#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 8637
#define LARGE_STATE_COUNT 2322
#define SYMBOL_COUNT 538
#define ALIAS_COUNT 5
#define TOKEN_COUNT 219
#define EXTERNAL_TOKEN_COUNT 2
#define FIELD_COUNT 50
#define MAX_ALIAS_SEQUENCE_LENGTH 9
#define PRODUCTION_ID_COUNT 220

enum ts_symbol_identifiers {
  sym_identifier = 1,
  aux_sym_preproc_include_token1 = 2,
  aux_sym_preproc_include_token2 = 3,
  aux_sym_preproc_def_token1 = 4,
  anon_sym_LPAREN = 5,
  anon_sym_DOT_DOT_DOT = 6,
  anon_sym_COMMA = 7,
  anon_sym_RPAREN = 8,
  aux_sym_preproc_if_token1 = 9,
  anon_sym_LF = 10,
  aux_sym_preproc_if_token2 = 11,
  aux_sym_preproc_ifdef_token1 = 12,
  aux_sym_preproc_ifdef_token2 = 13,
  aux_sym_preproc_else_token1 = 14,
  aux_sym_preproc_elif_token1 = 15,
  aux_sym_preproc_elifdef_token1 = 16,
  aux_sym_preproc_elifdef_token2 = 17,
  sym_preproc_arg = 18,
  sym_preproc_directive = 19,
  anon_sym_LPAREN2 = 20,
  anon_sym_defined = 21,
  anon_sym_BANG = 22,
  anon_sym_TILDE = 23,
  anon_sym_DASH = 24,
  anon_sym_PLUS = 25,
  anon_sym_STAR = 26,
  anon_sym_SLASH = 27,
  anon_sym_PERCENT = 28,
  anon_sym_PIPE_PIPE = 29,
  anon_sym_AMP_AMP = 30,
  anon_sym_PIPE = 31,
  anon_sym_CARET = 32,
  anon_sym_AMP = 33,
  anon_sym_EQ_EQ = 34,
  anon_sym_BANG_EQ = 35,
  anon_sym_GT = 36,
  anon_sym_GT_EQ = 37,
  anon_sym_LT_EQ = 38,
  anon_sym_LT = 39,
  anon_sym_LT_LT = 40,
  anon_sym_GT_GT = 41,
  anon_sym_SEMI = 42,
  anon_sym___extension__ = 43,
  anon_sym_typedef = 44,
  anon_sym_virtual = 45,
  anon_sym_extern = 46,
  anon_sym___attribute__ = 47,
  anon_sym___attribute = 48,
  anon_sym_COLON_COLON = 49,
  anon_sym_LBRACK_LBRACK = 50,
  anon_sym_RBRACK_RBRACK = 51,
  anon_sym___declspec = 52,
  anon_sym___based = 53,
  anon_sym___cdecl = 54,
  anon_sym___clrcall = 55,
  anon_sym___stdcall = 56,
  anon_sym___fastcall = 57,
  anon_sym___thiscall = 58,
  anon_sym___vectorcall = 59,
  sym_ms_restrict_modifier = 60,
  sym_ms_unsigned_ptr_modifier = 61,
  sym_ms_signed_ptr_modifier = 62,
  anon_sym__unaligned = 63,
  anon_sym___unaligned = 64,
  anon_sym_LBRACE = 65,
  anon_sym_RBRACE = 66,
  anon_sym_signed = 67,
  anon_sym_unsigned = 68,
  anon_sym_long = 69,
  anon_sym_short = 70,
  anon_sym_LBRACK = 71,
  anon_sym_static = 72,
  anon_sym_RBRACK = 73,
  anon_sym_EQ = 74,
  anon_sym_register = 75,
  anon_sym_inline = 76,
  anon_sym___inline = 77,
  anon_sym___inline__ = 78,
  anon_sym___forceinline = 79,
  anon_sym_thread_local = 80,
  anon_sym___thread = 81,
  anon_sym_const = 82,
  anon_sym_constexpr = 83,
  anon_sym_volatile = 84,
  anon_sym_restrict = 85,
  anon_sym___restrict__ = 86,
  anon_sym__Atomic = 87,
  anon_sym__Noreturn = 88,
  anon_sym_noreturn = 89,
  anon_sym__Nonnull = 90,
  anon_sym_mutable = 91,
  anon_sym_constinit = 92,
  anon_sym_consteval = 93,
  anon_sym_alignas = 94,
  anon_sym__Alignas = 95,
  sym_primitive_type = 96,
  anon_sym_enum = 97,
  anon_sym_class = 98,
  anon_sym_struct = 99,
  anon_sym_union = 100,
  anon_sym_COLON = 101,
  anon_sym_if = 102,
  anon_sym_else = 103,
  anon_sym_switch = 104,
  anon_sym_case = 105,
  anon_sym_default = 106,
  anon_sym_while = 107,
  anon_sym_do = 108,
  anon_sym_for = 109,
  anon_sym_return = 110,
  anon_sym_break = 111,
  anon_sym_continue = 112,
  anon_sym_goto = 113,
  anon_sym___try = 114,
  anon_sym___except = 115,
  anon_sym___finally = 116,
  anon_sym___leave = 117,
  anon_sym_QMARK = 118,
  anon_sym_STAR_EQ = 119,
  anon_sym_SLASH_EQ = 120,
  anon_sym_PERCENT_EQ = 121,
  anon_sym_PLUS_EQ = 122,
  anon_sym_DASH_EQ = 123,
  anon_sym_LT_LT_EQ = 124,
  anon_sym_GT_GT_EQ = 125,
  anon_sym_AMP_EQ = 126,
  anon_sym_CARET_EQ = 127,
  anon_sym_PIPE_EQ = 128,
  anon_sym_and_eq = 129,
  anon_sym_or_eq = 130,
  anon_sym_xor_eq = 131,
  anon_sym_not = 132,
  anon_sym_compl = 133,
  anon_sym_LT_EQ_GT = 134,
  anon_sym_or = 135,
  anon_sym_and = 136,
  anon_sym_bitor = 137,
  anon_sym_xor = 138,
  anon_sym_bitand = 139,
  anon_sym_not_eq = 140,
  anon_sym_DASH_DASH = 141,
  anon_sym_PLUS_PLUS = 142,
  anon_sym_sizeof = 143,
  anon_sym___alignof__ = 144,
  anon_sym___alignof = 145,
  anon_sym__alignof = 146,
  anon_sym_alignof = 147,
  anon_sym__Alignof = 148,
  anon_sym_offsetof = 149,
  anon_sym__Generic = 150,
  anon_sym_asm = 151,
  anon_sym___asm__ = 152,
  anon_sym___asm = 153,
  anon_sym___volatile__ = 154,
  anon_sym_DOT = 155,
  anon_sym_DOT_STAR = 156,
  anon_sym_DASH_GT = 157,
  sym_number_literal = 158,
  anon_sym_L_SQUOTE = 159,
  anon_sym_u_SQUOTE = 160,
  anon_sym_U_SQUOTE = 161,
  anon_sym_u8_SQUOTE = 162,
  anon_sym_SQUOTE = 163,
  aux_sym_char_literal_token1 = 164,
  anon_sym_L_DQUOTE = 165,
  anon_sym_u_DQUOTE = 166,
  anon_sym_U_DQUOTE = 167,
  anon_sym_u8_DQUOTE = 168,
  anon_sym_DQUOTE = 169,
  aux_sym_string_literal_token1 = 170,
  sym_escape_sequence = 171,
  sym_system_lib_string = 172,
  sym_true = 173,
  sym_false = 174,
  anon_sym_NULL = 175,
  anon_sym_nullptr = 176,
  sym_comment = 177,
  sym_auto = 178,
  anon_sym_decltype = 179,
  anon_sym_final = 180,
  anon_sym_override = 181,
  anon_sym_explicit = 182,
  anon_sym_typename = 183,
  anon_sym_template = 184,
  anon_sym_GT2 = 185,
  anon_sym_operator = 186,
  anon_sym_try = 187,
  anon_sym_delete = 188,
  aux_sym_pure_virtual_clause_token1 = 189,
  anon_sym_friend = 190,
  anon_sym_public = 191,
  anon_sym_private = 192,
  anon_sym_protected = 193,
  anon_sym_noexcept = 194,
  anon_sym_throw = 195,
  anon_sym_namespace = 196,
  anon_sym_using = 197,
  anon_sym_static_assert = 198,
  anon_sym_concept = 199,
  anon_sym_co_return = 200,
  anon_sym_co_yield = 201,
  anon_sym_catch = 202,
  anon_sym_R_DQUOTE = 203,
  anon_sym_LR_DQUOTE = 204,
  anon_sym_uR_DQUOTE = 205,
  anon_sym_UR_DQUOTE = 206,
  anon_sym_u8R_DQUOTE = 207,
  anon_sym_co_await = 208,
  anon_sym_new = 209,
  anon_sym_requires = 210,
  anon_sym_DASH_GT_STAR = 211,
  anon_sym_LPAREN_RPAREN = 212,
  anon_sym_LBRACK_RBRACK = 213,
  anon_sym_DQUOTE_DQUOTE = 214,
  sym_this = 215,
  sym_literal_suffix = 216,
  sym_raw_string_delimiter = 217,
  sym_raw_string_content = 218,
  sym_translation_unit = 219,
  sym__top_level_item = 220,
  sym__block_item = 221,
  sym_preproc_include = 222,
  sym_preproc_def = 223,
  sym_preproc_function_def = 224,
  sym_preproc_params = 225,
  sym_preproc_call = 226,
  sym_preproc_if = 227,
  sym_preproc_ifdef = 228,
  sym_preproc_else = 229,
  sym_preproc_elif = 230,
  sym_preproc_elifdef = 231,
  sym_preproc_if_in_field_declaration_list = 232,
  sym_preproc_ifdef_in_field_declaration_list = 233,
  sym_preproc_else_in_field_declaration_list = 234,
  sym_preproc_elif_in_field_declaration_list = 235,
  sym_preproc_elifdef_in_field_declaration_list = 236,
  sym_preproc_if_in_enumerator_list = 237,
  sym_preproc_ifdef_in_enumerator_list = 238,
  sym_preproc_else_in_enumerator_list = 239,
  sym_preproc_elif_in_enumerator_list = 240,
  sym_preproc_elifdef_in_enumerator_list = 241,
  sym_preproc_if_in_enumerator_list_no_comma = 242,
  sym_preproc_ifdef_in_enumerator_list_no_comma = 243,
  sym_preproc_else_in_enumerator_list_no_comma = 244,
  sym_preproc_elif_in_enumerator_list_no_comma = 245,
  sym_preproc_elifdef_in_enumerator_list_no_comma = 246,
  sym__preproc_expression = 247,
  sym_preproc_parenthesized_expression = 248,
  sym_preproc_defined = 249,
  sym_preproc_unary_expression = 250,
  sym_preproc_call_expression = 251,
  sym_preproc_argument_list = 252,
  sym_preproc_binary_expression = 253,
  sym_function_definition = 254,
  sym_declaration = 255,
  sym_type_definition = 256,
  sym__type_definition_type = 257,
  sym__type_definition_declarators = 258,
  sym__declaration_modifiers = 259,
  sym__declaration_specifiers = 260,
  sym_linkage_specification = 261,
  sym_attribute_specifier = 262,
  sym_attribute = 263,
  sym_attribute_declaration = 264,
  sym_ms_declspec_modifier = 265,
  sym_ms_based_modifier = 266,
  sym_ms_call_modifier = 267,
  sym_ms_unaligned_ptr_modifier = 268,
  sym_ms_pointer_modifier = 269,
  sym_declaration_list = 270,
  sym__declarator = 271,
  sym__field_declarator = 272,
  sym__type_declarator = 273,
  sym__abstract_declarator = 274,
  sym_parenthesized_declarator = 275,
  sym_parenthesized_field_declarator = 276,
  sym_parenthesized_type_declarator = 277,
  sym_abstract_parenthesized_declarator = 278,
  sym_attributed_declarator = 279,
  sym_attributed_field_declarator = 280,
  sym_attributed_type_declarator = 281,
  sym_pointer_declarator = 282,
  sym_pointer_field_declarator = 283,
  sym_pointer_type_declarator = 284,
  sym_abstract_pointer_declarator = 285,
  sym_function_declarator = 286,
  sym_function_field_declarator = 287,
  sym_function_type_declarator = 288,
  sym_abstract_function_declarator = 289,
  sym_array_declarator = 290,
  sym_array_field_declarator = 291,
  sym_array_type_declarator = 292,
  sym_abstract_array_declarator = 293,
  sym_init_declarator = 294,
  sym_compound_statement = 295,
  sym_storage_class_specifier = 296,
  sym_type_qualifier = 297,
  sym_alignas_qualifier = 298,
  sym_type_specifier = 299,
  sym_sized_type_specifier = 300,
  sym_enum_specifier = 301,
  sym_enumerator_list = 302,
  sym_struct_specifier = 303,
  sym_union_specifier = 304,
  sym_field_declaration_list = 305,
  sym__field_declaration_list_item = 306,
  sym_field_declaration = 307,
  sym_bitfield_clause = 308,
  sym_enumerator = 309,
  sym_parameter_list = 310,
  sym_parameter_declaration = 311,
  sym_attributed_statement = 312,
  sym_statement = 313,
  sym__top_level_statement = 314,
  sym_labeled_statement = 315,
  sym__top_level_expression_statement = 316,
  sym_expression_statement = 317,
  sym_if_statement = 318,
  sym_else_clause = 319,
  sym_switch_statement = 320,
  sym_case_statement = 321,
  sym_while_statement = 322,
  sym_do_statement = 323,
  sym_for_statement = 324,
  sym__for_statement_body = 325,
  sym_return_statement = 326,
  sym_break_statement = 327,
  sym_continue_statement = 328,
  sym_goto_statement = 329,
  sym_seh_try_statement = 330,
  sym_seh_except_clause = 331,
  sym_seh_finally_clause = 332,
  sym_seh_leave_statement = 333,
  sym_expression = 334,
  sym__string = 335,
  sym_comma_expression = 336,
  sym_conditional_expression = 337,
  sym_assignment_expression = 338,
  sym_pointer_expression = 339,
  sym_unary_expression = 340,
  sym_binary_expression = 341,
  sym_update_expression = 342,
  sym_cast_expression = 343,
  sym_type_descriptor = 344,
  sym_sizeof_expression = 345,
  sym_alignof_expression = 346,
  sym_offsetof_expression = 347,
  sym_generic_expression = 348,
  sym_subscript_expression = 349,
  sym_call_expression = 350,
  sym_gnu_asm_expression = 351,
  sym_gnu_asm_qualifier = 352,
  sym_gnu_asm_output_operand_list = 353,
  sym_gnu_asm_output_operand = 354,
  sym_gnu_asm_input_operand_list = 355,
  sym_gnu_asm_input_operand = 356,
  sym_gnu_asm_clobber_list = 357,
  sym_gnu_asm_goto_list = 358,
  sym_extension_expression = 359,
  sym_argument_list = 360,
  sym_field_expression = 361,
  sym_compound_literal_expression = 362,
  sym_parenthesized_expression = 363,
  sym_initializer_list = 364,
  sym_initializer_pair = 365,
  sym_subscript_designator = 366,
  sym_subscript_range_designator = 367,
  sym_field_designator = 368,
  sym_char_literal = 369,
  sym_concatenated_string = 370,
  sym_string_literal = 371,
  sym_null = 372,
  sym__empty_declaration = 373,
  sym_placeholder_type_specifier = 374,
  sym_decltype_auto = 375,
  sym_decltype = 376,
  sym__class_declaration = 377,
  sym__class_declaration_item = 378,
  sym_class_specifier = 379,
  sym__class_name = 380,
  sym_virtual_specifier = 381,
  sym_explicit_function_specifier = 382,
  sym_base_class_clause = 383,
  sym__enum_base_clause = 384,
  sym_dependent_type = 385,
  sym_template_declaration = 386,
  sym_template_instantiation = 387,
  sym_template_parameter_list = 388,
  sym_type_parameter_declaration = 389,
  sym_variadic_type_parameter_declaration = 390,
  sym_optional_type_parameter_declaration = 391,
  sym_template_template_parameter_declaration = 392,
  sym_optional_parameter_declaration = 393,
  sym_variadic_parameter_declaration = 394,
  sym_variadic_declarator = 395,
  sym_variadic_reference_declarator = 396,
  sym_operator_cast = 397,
  sym_field_initializer_list = 398,
  sym_field_initializer = 399,
  sym_inline_method_definition = 400,
  sym__constructor_specifiers = 401,
  sym_operator_cast_definition = 402,
  sym_operator_cast_declaration = 403,
  sym_constructor_try_statement = 404,
  sym_constructor_or_destructor_definition = 405,
  sym_constructor_or_destructor_declaration = 406,
  sym_default_method_clause = 407,
  sym_delete_method_clause = 408,
  sym_pure_virtual_clause = 409,
  sym_friend_declaration = 410,
  sym_access_specifier = 411,
  sym_reference_declarator = 412,
  sym_reference_field_declarator = 413,
  sym_reference_type_declarator = 414,
  sym_abstract_reference_declarator = 415,
  sym_structured_binding_declarator = 416,
  sym_ref_qualifier = 417,
  sym__function_declarator_seq = 418,
  sym__function_attributes_start = 419,
  sym__function_exception_specification = 420,
  sym__function_attributes_end = 421,
  sym__function_postfix = 422,
  sym_trailing_return_type = 423,
  sym_noexcept = 424,
  sym_throw_specifier = 425,
  sym_template_type = 426,
  sym_template_method = 427,
  sym_template_function = 428,
  sym_template_argument_list = 429,
  sym_namespace_definition = 430,
  sym_namespace_alias_definition = 431,
  sym__namespace_specifier = 432,
  sym_nested_namespace_specifier = 433,
  sym_using_declaration = 434,
  sym_alias_declaration = 435,
  sym_static_assert_declaration = 436,
  sym_concept_definition = 437,
  sym_for_range_loop = 438,
  sym__for_range_loop_body = 439,
  sym_init_statement = 440,
  sym_condition_clause = 441,
  sym_condition_declaration = 442,
  sym_co_return_statement = 443,
  sym_co_yield_statement = 444,
  sym_throw_statement = 445,
  sym_try_statement = 446,
  sym_catch_clause = 447,
  sym_raw_string_literal = 448,
  sym_subscript_argument_list = 449,
  sym_co_await_expression = 450,
  sym_new_expression = 451,
  sym_new_declarator = 452,
  sym_delete_expression = 453,
  sym_type_requirement = 454,
  sym_compound_requirement = 455,
  sym__requirement = 456,
  sym_requirement_seq = 457,
  sym_constraint_conjunction = 458,
  sym_constraint_disjunction = 459,
  sym__requirement_clause_constraint = 460,
  sym_requires_clause = 461,
  sym_requires_parameter_list = 462,
  sym_requires_expression = 463,
  sym_lambda_expression = 464,
  sym_lambda_capture_specifier = 465,
  sym_lambda_default_capture = 466,
  sym__lambda_capture_identifier = 467,
  sym_lambda_capture_initializer = 468,
  sym__lambda_capture = 469,
  sym__fold_operator = 470,
  sym__binary_fold_operator = 471,
  sym__unary_left_fold = 472,
  sym__unary_right_fold = 473,
  sym__binary_fold = 474,
  sym_fold_expression = 475,
  sym_parameter_pack_expansion = 476,
  sym_type_parameter_pack_expansion = 477,
  sym_identifier_parameter_pack_expansion = 478,
  sym_destructor_name = 479,
  sym_dependent_identifier = 480,
  sym_dependent_field_identifier = 481,
  sym_dependent_type_identifier = 482,
  sym__scope_resolution = 483,
  sym_qualified_field_identifier = 484,
  sym_qualified_identifier = 485,
  sym_qualified_type_identifier = 486,
  sym_qualified_operator_cast_identifier = 487,
  sym__assignment_expression_lhs = 488,
  sym_operator_name = 489,
  sym_user_defined_literal = 490,
  aux_sym_translation_unit_repeat1 = 491,
  aux_sym_preproc_params_repeat1 = 492,
  aux_sym_preproc_if_repeat1 = 493,
  aux_sym_preproc_if_in_field_declaration_list_repeat1 = 494,
  aux_sym_preproc_if_in_enumerator_list_repeat1 = 495,
  aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1 = 496,
  aux_sym_preproc_argument_list_repeat1 = 497,
  aux_sym_declaration_repeat1 = 498,
  aux_sym_type_definition_repeat1 = 499,
  aux_sym__type_definition_type_repeat1 = 500,
  aux_sym__type_definition_declarators_repeat1 = 501,
  aux_sym__declaration_specifiers_repeat1 = 502,
  aux_sym_attribute_declaration_repeat1 = 503,
  aux_sym_attributed_declarator_repeat1 = 504,
  aux_sym_pointer_declarator_repeat1 = 505,
  aux_sym_array_declarator_repeat1 = 506,
  aux_sym_sized_type_specifier_repeat1 = 507,
  aux_sym_enumerator_list_repeat1 = 508,
  aux_sym_field_declaration_repeat1 = 509,
  aux_sym_parameter_list_repeat1 = 510,
  aux_sym_case_statement_repeat1 = 511,
  aux_sym_generic_expression_repeat1 = 512,
  aux_sym_gnu_asm_expression_repeat1 = 513,
  aux_sym_gnu_asm_output_operand_list_repeat1 = 514,
  aux_sym_gnu_asm_input_operand_list_repeat1 = 515,
  aux_sym_gnu_asm_clobber_list_repeat1 = 516,
  aux_sym_gnu_asm_goto_list_repeat1 = 517,
  aux_sym_argument_list_repeat1 = 518,
  aux_sym_initializer_list_repeat1 = 519,
  aux_sym_initializer_pair_repeat1 = 520,
  aux_sym_char_literal_repeat1 = 521,
  aux_sym_concatenated_string_repeat1 = 522,
  aux_sym_string_literal_repeat1 = 523,
  aux_sym__class_declaration_repeat1 = 524,
  aux_sym_base_class_clause_repeat1 = 525,
  aux_sym_template_parameter_list_repeat1 = 526,
  aux_sym_field_initializer_list_repeat1 = 527,
  aux_sym_operator_cast_definition_repeat1 = 528,
  aux_sym_constructor_try_statement_repeat1 = 529,
  aux_sym_structured_binding_declarator_repeat1 = 530,
  aux_sym__function_postfix_repeat1 = 531,
  aux_sym_throw_specifier_repeat1 = 532,
  aux_sym_template_argument_list_repeat1 = 533,
  aux_sym_subscript_argument_list_repeat1 = 534,
  aux_sym_requirement_seq_repeat1 = 535,
  aux_sym_requires_parameter_list_repeat1 = 536,
  aux_sym_lambda_capture_specifier_repeat1 = 537,
  alias_sym_field_identifier = 538,
  alias_sym_namespace_identifier = 539,
  alias_sym_simple_requirement = 540,
  alias_sym_statement_identifier = 541,
  alias_sym_type_identifier = 542,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [aux_sym_preproc_include_token1] = "#include",
  [aux_sym_preproc_include_token2] = "preproc_include_token2",
  [aux_sym_preproc_def_token1] = "#define",
  [anon_sym_LPAREN] = "(",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_COMMA] = ",",
  [anon_sym_RPAREN] = ")",
  [aux_sym_preproc_if_token1] = "#if",
  [anon_sym_LF] = "\n",
  [aux_sym_preproc_if_token2] = "#endif",
  [aux_sym_preproc_ifdef_token1] = "#ifdef",
  [aux_sym_preproc_ifdef_token2] = "#ifndef",
  [aux_sym_preproc_else_token1] = "#else",
  [aux_sym_preproc_elif_token1] = "#elif",
  [aux_sym_preproc_elifdef_token1] = "#elifdef",
  [aux_sym_preproc_elifdef_token2] = "#elifndef",
  [sym_preproc_arg] = "preproc_arg",
  [sym_preproc_directive] = "preproc_directive",
  [anon_sym_LPAREN2] = "(",
  [anon_sym_defined] = "defined",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [anon_sym_DASH] = "-",
  [anon_sym_PLUS] = "+",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE] = "|",
  [anon_sym_CARET] = "^",
  [anon_sym_AMP] = "&",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_GT] = ">",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_LT] = "<",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_SEMI] = ";",
  [anon_sym___extension__] = "__extension__",
  [anon_sym_typedef] = "typedef",
  [anon_sym_virtual] = "virtual",
  [anon_sym_extern] = "extern",
  [anon_sym___attribute__] = "__attribute__",
  [anon_sym___attribute] = "__attribute",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_LBRACK_LBRACK] = "[[",
  [anon_sym_RBRACK_RBRACK] = "]]",
  [anon_sym___declspec] = "__declspec",
  [anon_sym___based] = "__based",
  [anon_sym___cdecl] = "__cdecl",
  [anon_sym___clrcall] = "__clrcall",
  [anon_sym___stdcall] = "__stdcall",
  [anon_sym___fastcall] = "__fastcall",
  [anon_sym___thiscall] = "__thiscall",
  [anon_sym___vectorcall] = "__vectorcall",
  [sym_ms_restrict_modifier] = "ms_restrict_modifier",
  [sym_ms_unsigned_ptr_modifier] = "ms_unsigned_ptr_modifier",
  [sym_ms_signed_ptr_modifier] = "ms_signed_ptr_modifier",
  [anon_sym__unaligned] = "_unaligned",
  [anon_sym___unaligned] = "__unaligned",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_signed] = "signed",
  [anon_sym_unsigned] = "unsigned",
  [anon_sym_long] = "long",
  [anon_sym_short] = "short",
  [anon_sym_LBRACK] = "[",
  [anon_sym_static] = "static",
  [anon_sym_RBRACK] = "]",
  [anon_sym_EQ] = "=",
  [anon_sym_register] = "register",
  [anon_sym_inline] = "inline",
  [anon_sym___inline] = "__inline",
  [anon_sym___inline__] = "__inline__",
  [anon_sym___forceinline] = "__forceinline",
  [anon_sym_thread_local] = "thread_local",
  [anon_sym___thread] = "__thread",
  [anon_sym_const] = "const",
  [anon_sym_constexpr] = "constexpr",
  [anon_sym_volatile] = "volatile",
  [anon_sym_restrict] = "restrict",
  [anon_sym___restrict__] = "__restrict__",
  [anon_sym__Atomic] = "_Atomic",
  [anon_sym__Noreturn] = "_Noreturn",
  [anon_sym_noreturn] = "noreturn",
  [anon_sym__Nonnull] = "_Nonnull",
  [anon_sym_mutable] = "mutable",
  [anon_sym_constinit] = "constinit",
  [anon_sym_consteval] = "consteval",
  [anon_sym_alignas] = "alignas",
  [anon_sym__Alignas] = "_Alignas",
  [sym_primitive_type] = "primitive_type",
  [anon_sym_enum] = "enum",
  [anon_sym_class] = "class",
  [anon_sym_struct] = "struct",
  [anon_sym_union] = "union",
  [anon_sym_COLON] = ":",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_switch] = "switch",
  [anon_sym_case] = "case",
  [anon_sym_default] = "default",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_for] = "for",
  [anon_sym_return] = "return",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_goto] = "goto",
  [anon_sym___try] = "__try",
  [anon_sym___except] = "__except",
  [anon_sym___finally] = "__finally",
  [anon_sym___leave] = "__leave",
  [anon_sym_QMARK] = "\?",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_and_eq] = "and_eq",
  [anon_sym_or_eq] = "or_eq",
  [anon_sym_xor_eq] = "xor_eq",
  [anon_sym_not] = "not",
  [anon_sym_compl] = "compl",
  [anon_sym_LT_EQ_GT] = "<=>",
  [anon_sym_or] = "or",
  [anon_sym_and] = "and",
  [anon_sym_bitor] = "bitor",
  [anon_sym_xor] = "xor",
  [anon_sym_bitand] = "bitand",
  [anon_sym_not_eq] = "not_eq",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_sizeof] = "sizeof",
  [anon_sym___alignof__] = "__alignof__",
  [anon_sym___alignof] = "__alignof",
  [anon_sym__alignof] = "_alignof",
  [anon_sym_alignof] = "alignof",
  [anon_sym__Alignof] = "_Alignof",
  [anon_sym_offsetof] = "offsetof",
  [anon_sym__Generic] = "_Generic",
  [anon_sym_asm] = "asm",
  [anon_sym___asm__] = "__asm__",
  [anon_sym___asm] = "__asm",
  [anon_sym___volatile__] = "__volatile__",
  [anon_sym_DOT] = ".",
  [anon_sym_DOT_STAR] = ".*",
  [anon_sym_DASH_GT] = "->",
  [sym_number_literal] = "number_literal",
  [anon_sym_L_SQUOTE] = "L'",
  [anon_sym_u_SQUOTE] = "u'",
  [anon_sym_U_SQUOTE] = "U'",
  [anon_sym_u8_SQUOTE] = "u8'",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_char_literal_token1] = "character",
  [anon_sym_L_DQUOTE] = "L\"",
  [anon_sym_u_DQUOTE] = "u\"",
  [anon_sym_U_DQUOTE] = "U\"",
  [anon_sym_u8_DQUOTE] = "u8\"",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_string_literal_token1] = "string_content",
  [sym_escape_sequence] = "escape_sequence",
  [sym_system_lib_string] = "system_lib_string",
  [sym_true] = "true",
  [sym_false] = "false",
  [anon_sym_NULL] = "NULL",
  [anon_sym_nullptr] = "nullptr",
  [sym_comment] = "comment",
  [sym_auto] = "auto",
  [anon_sym_decltype] = "decltype",
  [anon_sym_final] = "final",
  [anon_sym_override] = "override",
  [anon_sym_explicit] = "explicit",
  [anon_sym_typename] = "typename",
  [anon_sym_template] = "template",
  [anon_sym_GT2] = ">",
  [anon_sym_operator] = "operator",
  [anon_sym_try] = "try",
  [anon_sym_delete] = "delete",
  [aux_sym_pure_virtual_clause_token1] = "pure_virtual_clause_token1",
  [anon_sym_friend] = "friend",
  [anon_sym_public] = "public",
  [anon_sym_private] = "private",
  [anon_sym_protected] = "protected",
  [anon_sym_noexcept] = "noexcept",
  [anon_sym_throw] = "throw",
  [anon_sym_namespace] = "namespace",
  [anon_sym_using] = "using",
  [anon_sym_static_assert] = "static_assert",
  [anon_sym_concept] = "concept",
  [anon_sym_co_return] = "co_return",
  [anon_sym_co_yield] = "co_yield",
  [anon_sym_catch] = "catch",
  [anon_sym_R_DQUOTE] = "R\"",
  [anon_sym_LR_DQUOTE] = "LR\"",
  [anon_sym_uR_DQUOTE] = "uR\"",
  [anon_sym_UR_DQUOTE] = "UR\"",
  [anon_sym_u8R_DQUOTE] = "u8R\"",
  [anon_sym_co_await] = "co_await",
  [anon_sym_new] = "new",
  [anon_sym_requires] = "requires",
  [anon_sym_DASH_GT_STAR] = "->*",
  [anon_sym_LPAREN_RPAREN] = "()",
  [anon_sym_LBRACK_RBRACK] = "[]",
  [anon_sym_DQUOTE_DQUOTE] = "\"\"",
  [sym_this] = "this",
  [sym_literal_suffix] = "literal_suffix",
  [sym_raw_string_delimiter] = "raw_string_delimiter",
  [sym_raw_string_content] = "raw_string_content",
  [sym_translation_unit] = "translation_unit",
  [sym__top_level_item] = "_top_level_item",
  [sym__block_item] = "_block_item",
  [sym_preproc_include] = "preproc_include",
  [sym_preproc_def] = "preproc_def",
  [sym_preproc_function_def] = "preproc_function_def",
  [sym_preproc_params] = "preproc_params",
  [sym_preproc_call] = "preproc_call",
  [sym_preproc_if] = "preproc_if",
  [sym_preproc_ifdef] = "preproc_ifdef",
  [sym_preproc_else] = "preproc_else",
  [sym_preproc_elif] = "preproc_elif",
  [sym_preproc_elifdef] = "preproc_elifdef",
  [sym_preproc_if_in_field_declaration_list] = "preproc_if",
  [sym_preproc_ifdef_in_field_declaration_list] = "preproc_ifdef",
  [sym_preproc_else_in_field_declaration_list] = "preproc_else",
  [sym_preproc_elif_in_field_declaration_list] = "preproc_elif",
  [sym_preproc_elifdef_in_field_declaration_list] = "preproc_elifdef",
  [sym_preproc_if_in_enumerator_list] = "preproc_if",
  [sym_preproc_ifdef_in_enumerator_list] = "preproc_ifdef",
  [sym_preproc_else_in_enumerator_list] = "preproc_else",
  [sym_preproc_elif_in_enumerator_list] = "preproc_elif",
  [sym_preproc_elifdef_in_enumerator_list] = "preproc_elifdef",
  [sym_preproc_if_in_enumerator_list_no_comma] = "preproc_if",
  [sym_preproc_ifdef_in_enumerator_list_no_comma] = "preproc_ifdef",
  [sym_preproc_else_in_enumerator_list_no_comma] = "preproc_else",
  [sym_preproc_elif_in_enumerator_list_no_comma] = "preproc_elif",
  [sym_preproc_elifdef_in_enumerator_list_no_comma] = "preproc_elifdef",
  [sym__preproc_expression] = "_preproc_expression",
  [sym_preproc_parenthesized_expression] = "parenthesized_expression",
  [sym_preproc_defined] = "preproc_defined",
  [sym_preproc_unary_expression] = "unary_expression",
  [sym_preproc_call_expression] = "call_expression",
  [sym_preproc_argument_list] = "argument_list",
  [sym_preproc_binary_expression] = "binary_expression",
  [sym_function_definition] = "function_definition",
  [sym_declaration] = "declaration",
  [sym_type_definition] = "type_definition",
  [sym__type_definition_type] = "_type_definition_type",
  [sym__type_definition_declarators] = "_type_definition_declarators",
  [sym__declaration_modifiers] = "_declaration_modifiers",
  [sym__declaration_specifiers] = "_declaration_specifiers",
  [sym_linkage_specification] = "linkage_specification",
  [sym_attribute_specifier] = "attribute_specifier",
  [sym_attribute] = "attribute",
  [sym_attribute_declaration] = "attribute_declaration",
  [sym_ms_declspec_modifier] = "ms_declspec_modifier",
  [sym_ms_based_modifier] = "ms_based_modifier",
  [sym_ms_call_modifier] = "ms_call_modifier",
  [sym_ms_unaligned_ptr_modifier] = "ms_unaligned_ptr_modifier",
  [sym_ms_pointer_modifier] = "ms_pointer_modifier",
  [sym_declaration_list] = "declaration_list",
  [sym__declarator] = "_declarator",
  [sym__field_declarator] = "_field_declarator",
  [sym__type_declarator] = "_type_declarator",
  [sym__abstract_declarator] = "_abstract_declarator",
  [sym_parenthesized_declarator] = "parenthesized_declarator",
  [sym_parenthesized_field_declarator] = "parenthesized_declarator",
  [sym_parenthesized_type_declarator] = "parenthesized_declarator",
  [sym_abstract_parenthesized_declarator] = "abstract_parenthesized_declarator",
  [sym_attributed_declarator] = "attributed_declarator",
  [sym_attributed_field_declarator] = "attributed_declarator",
  [sym_attributed_type_declarator] = "attributed_declarator",
  [sym_pointer_declarator] = "pointer_declarator",
  [sym_pointer_field_declarator] = "pointer_declarator",
  [sym_pointer_type_declarator] = "pointer_type_declarator",
  [sym_abstract_pointer_declarator] = "abstract_pointer_declarator",
  [sym_function_declarator] = "function_declarator",
  [sym_function_field_declarator] = "function_declarator",
  [sym_function_type_declarator] = "function_declarator",
  [sym_abstract_function_declarator] = "abstract_function_declarator",
  [sym_array_declarator] = "array_declarator",
  [sym_array_field_declarator] = "array_declarator",
  [sym_array_type_declarator] = "array_declarator",
  [sym_abstract_array_declarator] = "abstract_array_declarator",
  [sym_init_declarator] = "init_declarator",
  [sym_compound_statement] = "compound_statement",
  [sym_storage_class_specifier] = "storage_class_specifier",
  [sym_type_qualifier] = "type_qualifier",
  [sym_alignas_qualifier] = "alignas_qualifier",
  [sym_type_specifier] = "type_specifier",
  [sym_sized_type_specifier] = "sized_type_specifier",
  [sym_enum_specifier] = "enum_specifier",
  [sym_enumerator_list] = "enumerator_list",
  [sym_struct_specifier] = "struct_specifier",
  [sym_union_specifier] = "union_specifier",
  [sym_field_declaration_list] = "field_declaration_list",
  [sym__field_declaration_list_item] = "_field_declaration_list_item",
  [sym_field_declaration] = "field_declaration",
  [sym_bitfield_clause] = "bitfield_clause",
  [sym_enumerator] = "enumerator",
  [sym_parameter_list] = "parameter_list",
  [sym_parameter_declaration] = "parameter_declaration",
  [sym_attributed_statement] = "attributed_statement",
  [sym_statement] = "statement",
  [sym__top_level_statement] = "_top_level_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym__top_level_expression_statement] = "expression_statement",
  [sym_expression_statement] = "expression_statement",
  [sym_if_statement] = "if_statement",
  [sym_else_clause] = "else_clause",
  [sym_switch_statement] = "switch_statement",
  [sym_case_statement] = "case_statement",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_for_statement] = "for_statement",
  [sym__for_statement_body] = "_for_statement_body",
  [sym_return_statement] = "return_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_goto_statement] = "goto_statement",
  [sym_seh_try_statement] = "seh_try_statement",
  [sym_seh_except_clause] = "seh_except_clause",
  [sym_seh_finally_clause] = "seh_finally_clause",
  [sym_seh_leave_statement] = "seh_leave_statement",
  [sym_expression] = "expression",
  [sym__string] = "_string",
  [sym_comma_expression] = "comma_expression",
  [sym_conditional_expression] = "conditional_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_pointer_expression] = "pointer_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_update_expression] = "update_expression",
  [sym_cast_expression] = "cast_expression",
  [sym_type_descriptor] = "type_descriptor",
  [sym_sizeof_expression] = "sizeof_expression",
  [sym_alignof_expression] = "alignof_expression",
  [sym_offsetof_expression] = "offsetof_expression",
  [sym_generic_expression] = "generic_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_call_expression] = "call_expression",
  [sym_gnu_asm_expression] = "gnu_asm_expression",
  [sym_gnu_asm_qualifier] = "gnu_asm_qualifier",
  [sym_gnu_asm_output_operand_list] = "gnu_asm_output_operand_list",
  [sym_gnu_asm_output_operand] = "gnu_asm_output_operand",
  [sym_gnu_asm_input_operand_list] = "gnu_asm_input_operand_list",
  [sym_gnu_asm_input_operand] = "gnu_asm_input_operand",
  [sym_gnu_asm_clobber_list] = "gnu_asm_clobber_list",
  [sym_gnu_asm_goto_list] = "gnu_asm_goto_list",
  [sym_extension_expression] = "extension_expression",
  [sym_argument_list] = "argument_list",
  [sym_field_expression] = "field_expression",
  [sym_compound_literal_expression] = "compound_literal_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_initializer_list] = "initializer_list",
  [sym_initializer_pair] = "initializer_pair",
  [sym_subscript_designator] = "subscript_designator",
  [sym_subscript_range_designator] = "subscript_range_designator",
  [sym_field_designator] = "field_designator",
  [sym_char_literal] = "char_literal",
  [sym_concatenated_string] = "concatenated_string",
  [sym_string_literal] = "string_literal",
  [sym_null] = "null",
  [sym__empty_declaration] = "_empty_declaration",
  [sym_placeholder_type_specifier] = "placeholder_type_specifier",
  [sym_decltype_auto] = "decltype",
  [sym_decltype] = "decltype",
  [sym__class_declaration] = "_class_declaration",
  [sym__class_declaration_item] = "_class_declaration_item",
  [sym_class_specifier] = "class_specifier",
  [sym__class_name] = "_class_name",
  [sym_virtual_specifier] = "virtual_specifier",
  [sym_explicit_function_specifier] = "explicit_function_specifier",
  [sym_base_class_clause] = "base_class_clause",
  [sym__enum_base_clause] = "_enum_base_clause",
  [sym_dependent_type] = "dependent_type",
  [sym_template_declaration] = "template_declaration",
  [sym_template_instantiation] = "template_instantiation",
  [sym_template_parameter_list] = "template_parameter_list",
  [sym_type_parameter_declaration] = "type_parameter_declaration",
  [sym_variadic_type_parameter_declaration] = "variadic_type_parameter_declaration",
  [sym_optional_type_parameter_declaration] = "optional_type_parameter_declaration",
  [sym_template_template_parameter_declaration] = "template_template_parameter_declaration",
  [sym_optional_parameter_declaration] = "optional_parameter_declaration",
  [sym_variadic_parameter_declaration] = "variadic_parameter_declaration",
  [sym_variadic_declarator] = "variadic_declarator",
  [sym_variadic_reference_declarator] = "reference_declarator",
  [sym_operator_cast] = "operator_cast",
  [sym_field_initializer_list] = "field_initializer_list",
  [sym_field_initializer] = "field_initializer",
  [sym_inline_method_definition] = "function_definition",
  [sym__constructor_specifiers] = "_constructor_specifiers",
  [sym_operator_cast_definition] = "function_definition",
  [sym_operator_cast_declaration] = "declaration",
  [sym_constructor_try_statement] = "try_statement",
  [sym_constructor_or_destructor_definition] = "function_definition",
  [sym_constructor_or_destructor_declaration] = "declaration",
  [sym_default_method_clause] = "default_method_clause",
  [sym_delete_method_clause] = "delete_method_clause",
  [sym_pure_virtual_clause] = "pure_virtual_clause",
  [sym_friend_declaration] = "friend_declaration",
  [sym_access_specifier] = "access_specifier",
  [sym_reference_declarator] = "reference_declarator",
  [sym_reference_field_declarator] = "reference_declarator",
  [sym_reference_type_declarator] = "reference_declarator",
  [sym_abstract_reference_declarator] = "abstract_reference_declarator",
  [sym_structured_binding_declarator] = "structured_binding_declarator",
  [sym_ref_qualifier] = "ref_qualifier",
  [sym__function_declarator_seq] = "_function_declarator_seq",
  [sym__function_attributes_start] = "_function_attributes_start",
  [sym__function_exception_specification] = "_function_exception_specification",
  [sym__function_attributes_end] = "_function_attributes_end",
  [sym__function_postfix] = "_function_postfix",
  [sym_trailing_return_type] = "trailing_return_type",
  [sym_noexcept] = "noexcept",
  [sym_throw_specifier] = "throw_specifier",
  [sym_template_type] = "template_type",
  [sym_template_method] = "template_method",
  [sym_template_function] = "template_function",
  [sym_template_argument_list] = "template_argument_list",
  [sym_namespace_definition] = "namespace_definition",
  [sym_namespace_alias_definition] = "namespace_alias_definition",
  [sym__namespace_specifier] = "_namespace_specifier",
  [sym_nested_namespace_specifier] = "nested_namespace_specifier",
  [sym_using_declaration] = "using_declaration",
  [sym_alias_declaration] = "alias_declaration",
  [sym_static_assert_declaration] = "static_assert_declaration",
  [sym_concept_definition] = "concept_definition",
  [sym_for_range_loop] = "for_range_loop",
  [sym__for_range_loop_body] = "_for_range_loop_body",
  [sym_init_statement] = "init_statement",
  [sym_condition_clause] = "condition_clause",
  [sym_condition_declaration] = "declaration",
  [sym_co_return_statement] = "co_return_statement",
  [sym_co_yield_statement] = "co_yield_statement",
  [sym_throw_statement] = "throw_statement",
  [sym_try_statement] = "try_statement",
  [sym_catch_clause] = "catch_clause",
  [sym_raw_string_literal] = "raw_string_literal",
  [sym_subscript_argument_list] = "subscript_argument_list",
  [sym_co_await_expression] = "co_await_expression",
  [sym_new_expression] = "new_expression",
  [sym_new_declarator] = "new_declarator",
  [sym_delete_expression] = "delete_expression",
  [sym_type_requirement] = "type_requirement",
  [sym_compound_requirement] = "compound_requirement",
  [sym__requirement] = "_requirement",
  [sym_requirement_seq] = "requirement_seq",
  [sym_constraint_conjunction] = "constraint_conjunction",
  [sym_constraint_disjunction] = "constraint_disjunction",
  [sym__requirement_clause_constraint] = "_requirement_clause_constraint",
  [sym_requires_clause] = "requires_clause",
  [sym_requires_parameter_list] = "parameter_list",
  [sym_requires_expression] = "requires_expression",
  [sym_lambda_expression] = "lambda_expression",
  [sym_lambda_capture_specifier] = "lambda_capture_specifier",
  [sym_lambda_default_capture] = "lambda_default_capture",
  [sym__lambda_capture_identifier] = "_lambda_capture_identifier",
  [sym_lambda_capture_initializer] = "lambda_capture_initializer",
  [sym__lambda_capture] = "_lambda_capture",
  [sym__fold_operator] = "_fold_operator",
  [sym__binary_fold_operator] = "_binary_fold_operator",
  [sym__unary_left_fold] = "_unary_left_fold",
  [sym__unary_right_fold] = "_unary_right_fold",
  [sym__binary_fold] = "_binary_fold",
  [sym_fold_expression] = "fold_expression",
  [sym_parameter_pack_expansion] = "parameter_pack_expansion",
  [sym_type_parameter_pack_expansion] = "parameter_pack_expansion",
  [sym_identifier_parameter_pack_expansion] = "parameter_pack_expansion",
  [sym_destructor_name] = "destructor_name",
  [sym_dependent_identifier] = "dependent_name",
  [sym_dependent_field_identifier] = "dependent_name",
  [sym_dependent_type_identifier] = "dependent_name",
  [sym__scope_resolution] = "_scope_resolution",
  [sym_qualified_field_identifier] = "qualified_identifier",
  [sym_qualified_identifier] = "qualified_identifier",
  [sym_qualified_type_identifier] = "qualified_identifier",
  [sym_qualified_operator_cast_identifier] = "qualified_identifier",
  [sym__assignment_expression_lhs] = "assignment_expression",
  [sym_operator_name] = "operator_name",
  [sym_user_defined_literal] = "user_defined_literal",
  [aux_sym_translation_unit_repeat1] = "translation_unit_repeat1",
  [aux_sym_preproc_params_repeat1] = "preproc_params_repeat1",
  [aux_sym_preproc_if_repeat1] = "preproc_if_repeat1",
  [aux_sym_preproc_if_in_field_declaration_list_repeat1] = "preproc_if_in_field_declaration_list_repeat1",
  [aux_sym_preproc_if_in_enumerator_list_repeat1] = "preproc_if_in_enumerator_list_repeat1",
  [aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1] = "preproc_if_in_enumerator_list_no_comma_repeat1",
  [aux_sym_preproc_argument_list_repeat1] = "preproc_argument_list_repeat1",
  [aux_sym_declaration_repeat1] = "declaration_repeat1",
  [aux_sym_type_definition_repeat1] = "type_definition_repeat1",
  [aux_sym__type_definition_type_repeat1] = "_type_definition_type_repeat1",
  [aux_sym__type_definition_declarators_repeat1] = "_type_definition_declarators_repeat1",
  [aux_sym__declaration_specifiers_repeat1] = "_declaration_specifiers_repeat1",
  [aux_sym_attribute_declaration_repeat1] = "attribute_declaration_repeat1",
  [aux_sym_attributed_declarator_repeat1] = "attributed_declarator_repeat1",
  [aux_sym_pointer_declarator_repeat1] = "pointer_declarator_repeat1",
  [aux_sym_array_declarator_repeat1] = "array_declarator_repeat1",
  [aux_sym_sized_type_specifier_repeat1] = "sized_type_specifier_repeat1",
  [aux_sym_enumerator_list_repeat1] = "enumerator_list_repeat1",
  [aux_sym_field_declaration_repeat1] = "field_declaration_repeat1",
  [aux_sym_parameter_list_repeat1] = "parameter_list_repeat1",
  [aux_sym_case_statement_repeat1] = "case_statement_repeat1",
  [aux_sym_generic_expression_repeat1] = "generic_expression_repeat1",
  [aux_sym_gnu_asm_expression_repeat1] = "gnu_asm_expression_repeat1",
  [aux_sym_gnu_asm_output_operand_list_repeat1] = "gnu_asm_output_operand_list_repeat1",
  [aux_sym_gnu_asm_input_operand_list_repeat1] = "gnu_asm_input_operand_list_repeat1",
  [aux_sym_gnu_asm_clobber_list_repeat1] = "gnu_asm_clobber_list_repeat1",
  [aux_sym_gnu_asm_goto_list_repeat1] = "gnu_asm_goto_list_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym_initializer_list_repeat1] = "initializer_list_repeat1",
  [aux_sym_initializer_pair_repeat1] = "initializer_pair_repeat1",
  [aux_sym_char_literal_repeat1] = "char_literal_repeat1",
  [aux_sym_concatenated_string_repeat1] = "concatenated_string_repeat1",
  [aux_sym_string_literal_repeat1] = "string_literal_repeat1",
  [aux_sym__class_declaration_repeat1] = "_class_declaration_repeat1",
  [aux_sym_base_class_clause_repeat1] = "base_class_clause_repeat1",
  [aux_sym_template_parameter_list_repeat1] = "template_parameter_list_repeat1",
  [aux_sym_field_initializer_list_repeat1] = "field_initializer_list_repeat1",
  [aux_sym_operator_cast_definition_repeat1] = "operator_cast_definition_repeat1",
  [aux_sym_constructor_try_statement_repeat1] = "constructor_try_statement_repeat1",
  [aux_sym_structured_binding_declarator_repeat1] = "structured_binding_declarator_repeat1",
  [aux_sym__function_postfix_repeat1] = "_function_postfix_repeat1",
  [aux_sym_throw_specifier_repeat1] = "throw_specifier_repeat1",
  [aux_sym_template_argument_list_repeat1] = "template_argument_list_repeat1",
  [aux_sym_subscript_argument_list_repeat1] = "subscript_argument_list_repeat1",
  [aux_sym_requirement_seq_repeat1] = "requirement_seq_repeat1",
  [aux_sym_requires_parameter_list_repeat1] = "requires_parameter_list_repeat1",
  [aux_sym_lambda_capture_specifier_repeat1] = "lambda_capture_specifier_repeat1",
  [alias_sym_field_identifier] = "field_identifier",
  [alias_sym_namespace_identifier] = "namespace_identifier",
  [alias_sym_simple_requirement] = "simple_requirement",
  [alias_sym_statement_identifier] = "statement_identifier",
  [alias_sym_type_identifier] = "type_identifier",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [aux_sym_preproc_include_token1] = aux_sym_preproc_include_token1,
  [aux_sym_preproc_include_token2] = aux_sym_preproc_include_token2,
  [aux_sym_preproc_def_token1] = aux_sym_preproc_def_token1,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [aux_sym_preproc_if_token1] = aux_sym_preproc_if_token1,
  [anon_sym_LF] = anon_sym_LF,
  [aux_sym_preproc_if_token2] = aux_sym_preproc_if_token2,
  [aux_sym_preproc_ifdef_token1] = aux_sym_preproc_ifdef_token1,
  [aux_sym_preproc_ifdef_token2] = aux_sym_preproc_ifdef_token2,
  [aux_sym_preproc_else_token1] = aux_sym_preproc_else_token1,
  [aux_sym_preproc_elif_token1] = aux_sym_preproc_elif_token1,
  [aux_sym_preproc_elifdef_token1] = aux_sym_preproc_elifdef_token1,
  [aux_sym_preproc_elifdef_token2] = aux_sym_preproc_elifdef_token2,
  [sym_preproc_arg] = sym_preproc_arg,
  [sym_preproc_directive] = sym_preproc_directive,
  [anon_sym_LPAREN2] = anon_sym_LPAREN,
  [anon_sym_defined] = anon_sym_defined,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym___extension__] = anon_sym___extension__,
  [anon_sym_typedef] = anon_sym_typedef,
  [anon_sym_virtual] = anon_sym_virtual,
  [anon_sym_extern] = anon_sym_extern,
  [anon_sym___attribute__] = anon_sym___attribute__,
  [anon_sym___attribute] = anon_sym___attribute,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_LBRACK_LBRACK] = anon_sym_LBRACK_LBRACK,
  [anon_sym_RBRACK_RBRACK] = anon_sym_RBRACK_RBRACK,
  [anon_sym___declspec] = anon_sym___declspec,
  [anon_sym___based] = anon_sym___based,
  [anon_sym___cdecl] = anon_sym___cdecl,
  [anon_sym___clrcall] = anon_sym___clrcall,
  [anon_sym___stdcall] = anon_sym___stdcall,
  [anon_sym___fastcall] = anon_sym___fastcall,
  [anon_sym___thiscall] = anon_sym___thiscall,
  [anon_sym___vectorcall] = anon_sym___vectorcall,
  [sym_ms_restrict_modifier] = sym_ms_restrict_modifier,
  [sym_ms_unsigned_ptr_modifier] = sym_ms_unsigned_ptr_modifier,
  [sym_ms_signed_ptr_modifier] = sym_ms_signed_ptr_modifier,
  [anon_sym__unaligned] = anon_sym__unaligned,
  [anon_sym___unaligned] = anon_sym___unaligned,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_signed] = anon_sym_signed,
  [anon_sym_unsigned] = anon_sym_unsigned,
  [anon_sym_long] = anon_sym_long,
  [anon_sym_short] = anon_sym_short,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_register] = anon_sym_register,
  [anon_sym_inline] = anon_sym_inline,
  [anon_sym___inline] = anon_sym___inline,
  [anon_sym___inline__] = anon_sym___inline__,
  [anon_sym___forceinline] = anon_sym___forceinline,
  [anon_sym_thread_local] = anon_sym_thread_local,
  [anon_sym___thread] = anon_sym___thread,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_constexpr] = anon_sym_constexpr,
  [anon_sym_volatile] = anon_sym_volatile,
  [anon_sym_restrict] = anon_sym_restrict,
  [anon_sym___restrict__] = anon_sym___restrict__,
  [anon_sym__Atomic] = anon_sym__Atomic,
  [anon_sym__Noreturn] = anon_sym__Noreturn,
  [anon_sym_noreturn] = anon_sym_noreturn,
  [anon_sym__Nonnull] = anon_sym__Nonnull,
  [anon_sym_mutable] = anon_sym_mutable,
  [anon_sym_constinit] = anon_sym_constinit,
  [anon_sym_consteval] = anon_sym_consteval,
  [anon_sym_alignas] = anon_sym_alignas,
  [anon_sym__Alignas] = anon_sym__Alignas,
  [sym_primitive_type] = sym_primitive_type,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_struct] = anon_sym_struct,
  [anon_sym_union] = anon_sym_union,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_goto] = anon_sym_goto,
  [anon_sym___try] = anon_sym___try,
  [anon_sym___except] = anon_sym___except,
  [anon_sym___finally] = anon_sym___finally,
  [anon_sym___leave] = anon_sym___leave,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_and_eq] = anon_sym_and_eq,
  [anon_sym_or_eq] = anon_sym_or_eq,
  [anon_sym_xor_eq] = anon_sym_xor_eq,
  [anon_sym_not] = anon_sym_not,
  [anon_sym_compl] = anon_sym_compl,
  [anon_sym_LT_EQ_GT] = anon_sym_LT_EQ_GT,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_bitor] = anon_sym_bitor,
  [anon_sym_xor] = anon_sym_xor,
  [anon_sym_bitand] = anon_sym_bitand,
  [anon_sym_not_eq] = anon_sym_not_eq,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_sizeof] = anon_sym_sizeof,
  [anon_sym___alignof__] = anon_sym___alignof__,
  [anon_sym___alignof] = anon_sym___alignof,
  [anon_sym__alignof] = anon_sym__alignof,
  [anon_sym_alignof] = anon_sym_alignof,
  [anon_sym__Alignof] = anon_sym__Alignof,
  [anon_sym_offsetof] = anon_sym_offsetof,
  [anon_sym__Generic] = anon_sym__Generic,
  [anon_sym_asm] = anon_sym_asm,
  [anon_sym___asm__] = anon_sym___asm__,
  [anon_sym___asm] = anon_sym___asm,
  [anon_sym___volatile__] = anon_sym___volatile__,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_DOT_STAR] = anon_sym_DOT_STAR,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [sym_number_literal] = sym_number_literal,
  [anon_sym_L_SQUOTE] = anon_sym_L_SQUOTE,
  [anon_sym_u_SQUOTE] = anon_sym_u_SQUOTE,
  [anon_sym_U_SQUOTE] = anon_sym_U_SQUOTE,
  [anon_sym_u8_SQUOTE] = anon_sym_u8_SQUOTE,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_char_literal_token1] = aux_sym_char_literal_token1,
  [anon_sym_L_DQUOTE] = anon_sym_L_DQUOTE,
  [anon_sym_u_DQUOTE] = anon_sym_u_DQUOTE,
  [anon_sym_U_DQUOTE] = anon_sym_U_DQUOTE,
  [anon_sym_u8_DQUOTE] = anon_sym_u8_DQUOTE,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_string_literal_token1] = aux_sym_string_literal_token1,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_system_lib_string] = sym_system_lib_string,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [anon_sym_NULL] = anon_sym_NULL,
  [anon_sym_nullptr] = anon_sym_nullptr,
  [sym_comment] = sym_comment,
  [sym_auto] = sym_auto,
  [anon_sym_decltype] = anon_sym_decltype,
  [anon_sym_final] = anon_sym_final,
  [anon_sym_override] = anon_sym_override,
  [anon_sym_explicit] = anon_sym_explicit,
  [anon_sym_typename] = anon_sym_typename,
  [anon_sym_template] = anon_sym_template,
  [anon_sym_GT2] = anon_sym_GT,
  [anon_sym_operator] = anon_sym_operator,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_delete] = anon_sym_delete,
  [aux_sym_pure_virtual_clause_token1] = aux_sym_pure_virtual_clause_token1,
  [anon_sym_friend] = anon_sym_friend,
  [anon_sym_public] = anon_sym_public,
  [anon_sym_private] = anon_sym_private,
  [anon_sym_protected] = anon_sym_protected,
  [anon_sym_noexcept] = anon_sym_noexcept,
  [anon_sym_throw] = anon_sym_throw,
  [anon_sym_namespace] = anon_sym_namespace,
  [anon_sym_using] = anon_sym_using,
  [anon_sym_static_assert] = anon_sym_static_assert,
  [anon_sym_concept] = anon_sym_concept,
  [anon_sym_co_return] = anon_sym_co_return,
  [anon_sym_co_yield] = anon_sym_co_yield,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_R_DQUOTE] = anon_sym_R_DQUOTE,
  [anon_sym_LR_DQUOTE] = anon_sym_LR_DQUOTE,
  [anon_sym_uR_DQUOTE] = anon_sym_uR_DQUOTE,
  [anon_sym_UR_DQUOTE] = anon_sym_UR_DQUOTE,
  [anon_sym_u8R_DQUOTE] = anon_sym_u8R_DQUOTE,
  [anon_sym_co_await] = anon_sym_co_await,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_requires] = anon_sym_requires,
  [anon_sym_DASH_GT_STAR] = anon_sym_DASH_GT_STAR,
  [anon_sym_LPAREN_RPAREN] = anon_sym_LPAREN_RPAREN,
  [anon_sym_LBRACK_RBRACK] = anon_sym_LBRACK_RBRACK,
  [anon_sym_DQUOTE_DQUOTE] = anon_sym_DQUOTE_DQUOTE,
  [sym_this] = sym_this,
  [sym_literal_suffix] = sym_literal_suffix,
  [sym_raw_string_delimiter] = sym_raw_string_delimiter,
  [sym_raw_string_content] = sym_raw_string_content,
  [sym_translation_unit] = sym_translation_unit,
  [sym__top_level_item] = sym__top_level_item,
  [sym__block_item] = sym__block_item,
  [sym_preproc_include] = sym_preproc_include,
  [sym_preproc_def] = sym_preproc_def,
  [sym_preproc_function_def] = sym_preproc_function_def,
  [sym_preproc_params] = sym_preproc_params,
  [sym_preproc_call] = sym_preproc_call,
  [sym_preproc_if] = sym_preproc_if,
  [sym_preproc_ifdef] = sym_preproc_ifdef,
  [sym_preproc_else] = sym_preproc_else,
  [sym_preproc_elif] = sym_preproc_elif,
  [sym_preproc_elifdef] = sym_preproc_elifdef,
  [sym_preproc_if_in_field_declaration_list] = sym_preproc_if,
  [sym_preproc_ifdef_in_field_declaration_list] = sym_preproc_ifdef,
  [sym_preproc_else_in_field_declaration_list] = sym_preproc_else,
  [sym_preproc_elif_in_field_declaration_list] = sym_preproc_elif,
  [sym_preproc_elifdef_in_field_declaration_list] = sym_preproc_elifdef,
  [sym_preproc_if_in_enumerator_list] = sym_preproc_if,
  [sym_preproc_ifdef_in_enumerator_list] = sym_preproc_ifdef,
  [sym_preproc_else_in_enumerator_list] = sym_preproc_else,
  [sym_preproc_elif_in_enumerator_list] = sym_preproc_elif,
  [sym_preproc_elifdef_in_enumerator_list] = sym_preproc_elifdef,
  [sym_preproc_if_in_enumerator_list_no_comma] = sym_preproc_if,
  [sym_preproc_ifdef_in_enumerator_list_no_comma] = sym_preproc_ifdef,
  [sym_preproc_else_in_enumerator_list_no_comma] = sym_preproc_else,
  [sym_preproc_elif_in_enumerator_list_no_comma] = sym_preproc_elif,
  [sym_preproc_elifdef_in_enumerator_list_no_comma] = sym_preproc_elifdef,
  [sym__preproc_expression] = sym__preproc_expression,
  [sym_preproc_parenthesized_expression] = sym_parenthesized_expression,
  [sym_preproc_defined] = sym_preproc_defined,
  [sym_preproc_unary_expression] = sym_unary_expression,
  [sym_preproc_call_expression] = sym_call_expression,
  [sym_preproc_argument_list] = sym_argument_list,
  [sym_preproc_binary_expression] = sym_binary_expression,
  [sym_function_definition] = sym_function_definition,
  [sym_declaration] = sym_declaration,
  [sym_type_definition] = sym_type_definition,
  [sym__type_definition_type] = sym__type_definition_type,
  [sym__type_definition_declarators] = sym__type_definition_declarators,
  [sym__declaration_modifiers] = sym__declaration_modifiers,
  [sym__declaration_specifiers] = sym__declaration_specifiers,
  [sym_linkage_specification] = sym_linkage_specification,
  [sym_attribute_specifier] = sym_attribute_specifier,
  [sym_attribute] = sym_attribute,
  [sym_attribute_declaration] = sym_attribute_declaration,
  [sym_ms_declspec_modifier] = sym_ms_declspec_modifier,
  [sym_ms_based_modifier] = sym_ms_based_modifier,
  [sym_ms_call_modifier] = sym_ms_call_modifier,
  [sym_ms_unaligned_ptr_modifier] = sym_ms_unaligned_ptr_modifier,
  [sym_ms_pointer_modifier] = sym_ms_pointer_modifier,
  [sym_declaration_list] = sym_declaration_list,
  [sym__declarator] = sym__declarator,
  [sym__field_declarator] = sym__field_declarator,
  [sym__type_declarator] = sym__type_declarator,
  [sym__abstract_declarator] = sym__abstract_declarator,
  [sym_parenthesized_declarator] = sym_parenthesized_declarator,
  [sym_parenthesized_field_declarator] = sym_parenthesized_declarator,
  [sym_parenthesized_type_declarator] = sym_parenthesized_declarator,
  [sym_abstract_parenthesized_declarator] = sym_abstract_parenthesized_declarator,
  [sym_attributed_declarator] = sym_attributed_declarator,
  [sym_attributed_field_declarator] = sym_attributed_declarator,
  [sym_attributed_type_declarator] = sym_attributed_declarator,
  [sym_pointer_declarator] = sym_pointer_declarator,
  [sym_pointer_field_declarator] = sym_pointer_declarator,
  [sym_pointer_type_declarator] = sym_pointer_type_declarator,
  [sym_abstract_pointer_declarator] = sym_abstract_pointer_declarator,
  [sym_function_declarator] = sym_function_declarator,
  [sym_function_field_declarator] = sym_function_declarator,
  [sym_function_type_declarator] = sym_function_declarator,
  [sym_abstract_function_declarator] = sym_abstract_function_declarator,
  [sym_array_declarator] = sym_array_declarator,
  [sym_array_field_declarator] = sym_array_declarator,
  [sym_array_type_declarator] = sym_array_declarator,
  [sym_abstract_array_declarator] = sym_abstract_array_declarator,
  [sym_init_declarator] = sym_init_declarator,
  [sym_compound_statement] = sym_compound_statement,
  [sym_storage_class_specifier] = sym_storage_class_specifier,
  [sym_type_qualifier] = sym_type_qualifier,
  [sym_alignas_qualifier] = sym_alignas_qualifier,
  [sym_type_specifier] = sym_type_specifier,
  [sym_sized_type_specifier] = sym_sized_type_specifier,
  [sym_enum_specifier] = sym_enum_specifier,
  [sym_enumerator_list] = sym_enumerator_list,
  [sym_struct_specifier] = sym_struct_specifier,
  [sym_union_specifier] = sym_union_specifier,
  [sym_field_declaration_list] = sym_field_declaration_list,
  [sym__field_declaration_list_item] = sym__field_declaration_list_item,
  [sym_field_declaration] = sym_field_declaration,
  [sym_bitfield_clause] = sym_bitfield_clause,
  [sym_enumerator] = sym_enumerator,
  [sym_parameter_list] = sym_parameter_list,
  [sym_parameter_declaration] = sym_parameter_declaration,
  [sym_attributed_statement] = sym_attributed_statement,
  [sym_statement] = sym_statement,
  [sym__top_level_statement] = sym__top_level_statement,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym__top_level_expression_statement] = sym_expression_statement,
  [sym_expression_statement] = sym_expression_statement,
  [sym_if_statement] = sym_if_statement,
  [sym_else_clause] = sym_else_clause,
  [sym_switch_statement] = sym_switch_statement,
  [sym_case_statement] = sym_case_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_for_statement] = sym_for_statement,
  [sym__for_statement_body] = sym__for_statement_body,
  [sym_return_statement] = sym_return_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_goto_statement] = sym_goto_statement,
  [sym_seh_try_statement] = sym_seh_try_statement,
  [sym_seh_except_clause] = sym_seh_except_clause,
  [sym_seh_finally_clause] = sym_seh_finally_clause,
  [sym_seh_leave_statement] = sym_seh_leave_statement,
  [sym_expression] = sym_expression,
  [sym__string] = sym__string,
  [sym_comma_expression] = sym_comma_expression,
  [sym_conditional_expression] = sym_conditional_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym_pointer_expression] = sym_pointer_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_update_expression] = sym_update_expression,
  [sym_cast_expression] = sym_cast_expression,
  [sym_type_descriptor] = sym_type_descriptor,
  [sym_sizeof_expression] = sym_sizeof_expression,
  [sym_alignof_expression] = sym_alignof_expression,
  [sym_offsetof_expression] = sym_offsetof_expression,
  [sym_generic_expression] = sym_generic_expression,
  [sym_subscript_expression] = sym_subscript_expression,
  [sym_call_expression] = sym_call_expression,
  [sym_gnu_asm_expression] = sym_gnu_asm_expression,
  [sym_gnu_asm_qualifier] = sym_gnu_asm_qualifier,
  [sym_gnu_asm_output_operand_list] = sym_gnu_asm_output_operand_list,
  [sym_gnu_asm_output_operand] = sym_gnu_asm_output_operand,
  [sym_gnu_asm_input_operand_list] = sym_gnu_asm_input_operand_list,
  [sym_gnu_asm_input_operand] = sym_gnu_asm_input_operand,
  [sym_gnu_asm_clobber_list] = sym_gnu_asm_clobber_list,
  [sym_gnu_asm_goto_list] = sym_gnu_asm_goto_list,
  [sym_extension_expression] = sym_extension_expression,
  [sym_argument_list] = sym_argument_list,
  [sym_field_expression] = sym_field_expression,
  [sym_compound_literal_expression] = sym_compound_literal_expression,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_initializer_list] = sym_initializer_list,
  [sym_initializer_pair] = sym_initializer_pair,
  [sym_subscript_designator] = sym_subscript_designator,
  [sym_subscript_range_designator] = sym_subscript_range_designator,
  [sym_field_designator] = sym_field_designator,
  [sym_char_literal] = sym_char_literal,
  [sym_concatenated_string] = sym_concatenated_string,
  [sym_string_literal] = sym_string_literal,
  [sym_null] = sym_null,
  [sym__empty_declaration] = sym__empty_declaration,
  [sym_placeholder_type_specifier] = sym_placeholder_type_specifier,
  [sym_decltype_auto] = sym_decltype,
  [sym_decltype] = sym_decltype,
  [sym__class_declaration] = sym__class_declaration,
  [sym__class_declaration_item] = sym__class_declaration_item,
  [sym_class_specifier] = sym_class_specifier,
  [sym__class_name] = sym__class_name,
  [sym_virtual_specifier] = sym_virtual_specifier,
  [sym_explicit_function_specifier] = sym_explicit_function_specifier,
  [sym_base_class_clause] = sym_base_class_clause,
  [sym__enum_base_clause] = sym__enum_base_clause,
  [sym_dependent_type] = sym_dependent_type,
  [sym_template_declaration] = sym_template_declaration,
  [sym_template_instantiation] = sym_template_instantiation,
  [sym_template_parameter_list] = sym_template_parameter_list,
  [sym_type_parameter_declaration] = sym_type_parameter_declaration,
  [sym_variadic_type_parameter_declaration] = sym_variadic_type_parameter_declaration,
  [sym_optional_type_parameter_declaration] = sym_optional_type_parameter_declaration,
  [sym_template_template_parameter_declaration] = sym_template_template_parameter_declaration,
  [sym_optional_parameter_declaration] = sym_optional_parameter_declaration,
  [sym_variadic_parameter_declaration] = sym_variadic_parameter_declaration,
  [sym_variadic_declarator] = sym_variadic_declarator,
  [sym_variadic_reference_declarator] = sym_reference_declarator,
  [sym_operator_cast] = sym_operator_cast,
  [sym_field_initializer_list] = sym_field_initializer_list,
  [sym_field_initializer] = sym_field_initializer,
  [sym_inline_method_definition] = sym_function_definition,
  [sym__constructor_specifiers] = sym__constructor_specifiers,
  [sym_operator_cast_definition] = sym_function_definition,
  [sym_operator_cast_declaration] = sym_declaration,
  [sym_constructor_try_statement] = sym_try_statement,
  [sym_constructor_or_destructor_definition] = sym_function_definition,
  [sym_constructor_or_destructor_declaration] = sym_declaration,
  [sym_default_method_clause] = sym_default_method_clause,
  [sym_delete_method_clause] = sym_delete_method_clause,
  [sym_pure_virtual_clause] = sym_pure_virtual_clause,
  [sym_friend_declaration] = sym_friend_declaration,
  [sym_access_specifier] = sym_access_specifier,
  [sym_reference_declarator] = sym_reference_declarator,
  [sym_reference_field_declarator] = sym_reference_declarator,
  [sym_reference_type_declarator] = sym_reference_declarator,
  [sym_abstract_reference_declarator] = sym_abstract_reference_declarator,
  [sym_structured_binding_declarator] = sym_structured_binding_declarator,
  [sym_ref_qualifier] = sym_ref_qualifier,
  [sym__function_declarator_seq] = sym__function_declarator_seq,
  [sym__function_attributes_start] = sym__function_attributes_start,
  [sym__function_exception_specification] = sym__function_exception_specification,
  [sym__function_attributes_end] = sym__function_attributes_end,
  [sym__function_postfix] = sym__function_postfix,
  [sym_trailing_return_type] = sym_trailing_return_type,
  [sym_noexcept] = sym_noexcept,
  [sym_throw_specifier] = sym_throw_specifier,
  [sym_template_type] = sym_template_type,
  [sym_template_method] = sym_template_method,
  [sym_template_function] = sym_template_function,
  [sym_template_argument_list] = sym_template_argument_list,
  [sym_namespace_definition] = sym_namespace_definition,
  [sym_namespace_alias_definition] = sym_namespace_alias_definition,
  [sym__namespace_specifier] = sym__namespace_specifier,
  [sym_nested_namespace_specifier] = sym_nested_namespace_specifier,
  [sym_using_declaration] = sym_using_declaration,
  [sym_alias_declaration] = sym_alias_declaration,
  [sym_static_assert_declaration] = sym_static_assert_declaration,
  [sym_concept_definition] = sym_concept_definition,
  [sym_for_range_loop] = sym_for_range_loop,
  [sym__for_range_loop_body] = sym__for_range_loop_body,
  [sym_init_statement] = sym_init_statement,
  [sym_condition_clause] = sym_condition_clause,
  [sym_condition_declaration] = sym_declaration,
  [sym_co_return_statement] = sym_co_return_statement,
  [sym_co_yield_statement] = sym_co_yield_statement,
  [sym_throw_statement] = sym_throw_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_catch_clause] = sym_catch_clause,
  [sym_raw_string_literal] = sym_raw_string_literal,
  [sym_subscript_argument_list] = sym_subscript_argument_list,
  [sym_co_await_expression] = sym_co_await_expression,
  [sym_new_expression] = sym_new_expression,
  [sym_new_declarator] = sym_new_declarator,
  [sym_delete_expression] = sym_delete_expression,
  [sym_type_requirement] = sym_type_requirement,
  [sym_compound_requirement] = sym_compound_requirement,
  [sym__requirement] = sym__requirement,
  [sym_requirement_seq] = sym_requirement_seq,
  [sym_constraint_conjunction] = sym_constraint_conjunction,
  [sym_constraint_disjunction] = sym_constraint_disjunction,
  [sym__requirement_clause_constraint] = sym__requirement_clause_constraint,
  [sym_requires_clause] = sym_requires_clause,
  [sym_requires_parameter_list] = sym_parameter_list,
  [sym_requires_expression] = sym_requires_expression,
  [sym_lambda_expression] = sym_lambda_expression,
  [sym_lambda_capture_specifier] = sym_lambda_capture_specifier,
  [sym_lambda_default_capture] = sym_lambda_default_capture,
  [sym__lambda_capture_identifier] = sym__lambda_capture_identifier,
  [sym_lambda_capture_initializer] = sym_lambda_capture_initializer,
  [sym__lambda_capture] = sym__lambda_capture,
  [sym__fold_operator] = sym__fold_operator,
  [sym__binary_fold_operator] = sym__binary_fold_operator,
  [sym__unary_left_fold] = sym__unary_left_fold,
  [sym__unary_right_fold] = sym__unary_right_fold,
  [sym__binary_fold] = sym__binary_fold,
  [sym_fold_expression] = sym_fold_expression,
  [sym_parameter_pack_expansion] = sym_parameter_pack_expansion,
  [sym_type_parameter_pack_expansion] = sym_parameter_pack_expansion,
  [sym_identifier_parameter_pack_expansion] = sym_parameter_pack_expansion,
  [sym_destructor_name] = sym_destructor_name,
  [sym_dependent_identifier] = sym_dependent_identifier,
  [sym_dependent_field_identifier] = sym_dependent_identifier,
  [sym_dependent_type_identifier] = sym_dependent_identifier,
  [sym__scope_resolution] = sym__scope_resolution,
  [sym_qualified_field_identifier] = sym_qualified_identifier,
  [sym_qualified_identifier] = sym_qualified_identifier,
  [sym_qualified_type_identifier] = sym_qualified_identifier,
  [sym_qualified_operator_cast_identifier] = sym_qualified_identifier,
  [sym__assignment_expression_lhs] = sym_assignment_expression,
  [sym_operator_name] = sym_operator_name,
  [sym_user_defined_literal] = sym_user_defined_literal,
  [aux_sym_translation_unit_repeat1] = aux_sym_translation_unit_repeat1,
  [aux_sym_preproc_params_repeat1] = aux_sym_preproc_params_repeat1,
  [aux_sym_preproc_if_repeat1] = aux_sym_preproc_if_repeat1,
  [aux_sym_preproc_if_in_field_declaration_list_repeat1] = aux_sym_preproc_if_in_field_declaration_list_repeat1,
  [aux_sym_preproc_if_in_enumerator_list_repeat1] = aux_sym_preproc_if_in_enumerator_list_repeat1,
  [aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1] = aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
  [aux_sym_preproc_argument_list_repeat1] = aux_sym_preproc_argument_list_repeat1,
  [aux_sym_declaration_repeat1] = aux_sym_declaration_repeat1,
  [aux_sym_type_definition_repeat1] = aux_sym_type_definition_repeat1,
  [aux_sym__type_definition_type_repeat1] = aux_sym__type_definition_type_repeat1,
  [aux_sym__type_definition_declarators_repeat1] = aux_sym__type_definition_declarators_repeat1,
  [aux_sym__declaration_specifiers_repeat1] = aux_sym__declaration_specifiers_repeat1,
  [aux_sym_attribute_declaration_repeat1] = aux_sym_attribute_declaration_repeat1,
  [aux_sym_attributed_declarator_repeat1] = aux_sym_attributed_declarator_repeat1,
  [aux_sym_pointer_declarator_repeat1] = aux_sym_pointer_declarator_repeat1,
  [aux_sym_array_declarator_repeat1] = aux_sym_array_declarator_repeat1,
  [aux_sym_sized_type_specifier_repeat1] = aux_sym_sized_type_specifier_repeat1,
  [aux_sym_enumerator_list_repeat1] = aux_sym_enumerator_list_repeat1,
  [aux_sym_field_declaration_repeat1] = aux_sym_field_declaration_repeat1,
  [aux_sym_parameter_list_repeat1] = aux_sym_parameter_list_repeat1,
  [aux_sym_case_statement_repeat1] = aux_sym_case_statement_repeat1,
  [aux_sym_generic_expression_repeat1] = aux_sym_generic_expression_repeat1,
  [aux_sym_gnu_asm_expression_repeat1] = aux_sym_gnu_asm_expression_repeat1,
  [aux_sym_gnu_asm_output_operand_list_repeat1] = aux_sym_gnu_asm_output_operand_list_repeat1,
  [aux_sym_gnu_asm_input_operand_list_repeat1] = aux_sym_gnu_asm_input_operand_list_repeat1,
  [aux_sym_gnu_asm_clobber_list_repeat1] = aux_sym_gnu_asm_clobber_list_repeat1,
  [aux_sym_gnu_asm_goto_list_repeat1] = aux_sym_gnu_asm_goto_list_repeat1,
  [aux_sym_argument_list_repeat1] = aux_sym_argument_list_repeat1,
  [aux_sym_initializer_list_repeat1] = aux_sym_initializer_list_repeat1,
  [aux_sym_initializer_pair_repeat1] = aux_sym_initializer_pair_repeat1,
  [aux_sym_char_literal_repeat1] = aux_sym_char_literal_repeat1,
  [aux_sym_concatenated_string_repeat1] = aux_sym_concatenated_string_repeat1,
  [aux_sym_string_literal_repeat1] = aux_sym_string_literal_repeat1,
  [aux_sym__class_declaration_repeat1] = aux_sym__class_declaration_repeat1,
  [aux_sym_base_class_clause_repeat1] = aux_sym_base_class_clause_repeat1,
  [aux_sym_template_parameter_list_repeat1] = aux_sym_template_parameter_list_repeat1,
  [aux_sym_field_initializer_list_repeat1] = aux_sym_field_initializer_list_repeat1,
  [aux_sym_operator_cast_definition_repeat1] = aux_sym_operator_cast_definition_repeat1,
  [aux_sym_constructor_try_statement_repeat1] = aux_sym_constructor_try_statement_repeat1,
  [aux_sym_structured_binding_declarator_repeat1] = aux_sym_structured_binding_declarator_repeat1,
  [aux_sym__function_postfix_repeat1] = aux_sym__function_postfix_repeat1,
  [aux_sym_throw_specifier_repeat1] = aux_sym_throw_specifier_repeat1,
  [aux_sym_template_argument_list_repeat1] = aux_sym_template_argument_list_repeat1,
  [aux_sym_subscript_argument_list_repeat1] = aux_sym_subscript_argument_list_repeat1,
  [aux_sym_requirement_seq_repeat1] = aux_sym_requirement_seq_repeat1,
  [aux_sym_requires_parameter_list_repeat1] = aux_sym_requires_parameter_list_repeat1,
  [aux_sym_lambda_capture_specifier_repeat1] = aux_sym_lambda_capture_specifier_repeat1,
  [alias_sym_field_identifier] = alias_sym_field_identifier,
  [alias_sym_namespace_identifier] = alias_sym_namespace_identifier,
  [alias_sym_simple_requirement] = alias_sym_simple_requirement,
  [alias_sym_statement_identifier] = alias_sym_statement_identifier,
  [alias_sym_type_identifier] = alias_sym_type_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_preproc_include_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_include_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_def_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_if_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_if_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_ifdef_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_ifdef_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_else_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_elif_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_elifdef_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_preproc_elifdef_token2] = {
    .visible = true,
    .named = false,
  },
  [sym_preproc_arg] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_directive] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defined] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___extension__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typedef] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_virtual] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extern] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___attribute__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___attribute] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___declspec] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___based] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___cdecl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___clrcall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___stdcall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___fastcall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___thiscall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___vectorcall] = {
    .visible = true,
    .named = false,
  },
  [sym_ms_restrict_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_unsigned_ptr_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_signed_ptr_modifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym__unaligned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___unaligned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_signed] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsigned] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_long] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_short] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_register] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___inline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___inline__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___forceinline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_thread_local] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___thread] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_constexpr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_volatile] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_restrict] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___restrict__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Atomic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Noreturn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_noreturn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Nonnull] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mutable] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_constinit] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_consteval] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_alignas] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Alignas] = {
    .visible = true,
    .named = false,
  },
  [sym_primitive_type] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_union] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_goto] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___except] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___leave] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and_eq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or_eq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_xor_eq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_compl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bitor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_xor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bitand] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not_eq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sizeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___alignof__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___alignof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__alignof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_alignof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Alignof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_offsetof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__Generic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_asm] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___asm__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___asm] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___volatile__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [sym_number_literal] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_L_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_U_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u8_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_char_literal_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_L_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_U_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u8_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_literal_token1] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_system_lib_string] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_NULL] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nullptr] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_auto] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_decltype] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_final] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_override] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_explicit] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typename] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_template] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_operator] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delete] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_pure_virtual_clause_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_friend] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_noexcept] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_namespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_using] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static_assert] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_concept] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_co_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_co_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_R_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LR_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uR_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_UR_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u8R_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_co_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_requires] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym_this] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_suffix] = {
    .visible = true,
    .named = true,
  },
  [sym_raw_string_delimiter] = {
    .visible = true,
    .named = true,
  },
  [sym_raw_string_content] = {
    .visible = true,
    .named = true,
  },
  [sym_translation_unit] = {
    .visible = true,
    .named = true,
  },
  [sym__top_level_item] = {
    .visible = false,
    .named = true,
  },
  [sym__block_item] = {
    .visible = false,
    .named = true,
  },
  [sym_preproc_include] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_def] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_function_def] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_params] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_call] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elifdef] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elifdef_in_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elifdef_in_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_if_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_ifdef_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_else_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elif_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_elifdef_in_enumerator_list_no_comma] = {
    .visible = true,
    .named = true,
  },
  [sym__preproc_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_preproc_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_defined] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_type_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__type_definition_type] = {
    .visible = false,
    .named = true,
  },
  [sym__type_definition_declarators] = {
    .visible = false,
    .named = true,
  },
  [sym__declaration_modifiers] = {
    .visible = false,
    .named = true,
  },
  [sym__declaration_specifiers] = {
    .visible = false,
    .named = true,
  },
  [sym_linkage_specification] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_declspec_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_based_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_call_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_unaligned_ptr_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_ms_pointer_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym__declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__field_declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__type_declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__abstract_declarator] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_parenthesized_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_parenthesized_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_attributed_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_attributed_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_attributed_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_pointer_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_function_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_array_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_init_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_storage_class_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_type_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym_alignas_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym_type_specifier] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_sized_type_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_enumerator_list] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_union_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym__field_declaration_list_item] = {
    .visible = false,
    .named = true,
  },
  [sym_field_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_bitfield_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_enumerator] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_attributed_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_statement] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__top_level_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__top_level_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_case_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__for_statement_body] = {
    .visible = false,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_goto_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_seh_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_seh_except_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_seh_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_seh_leave_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__string] = {
    .visible = false,
    .named = true,
  },
  [sym_comma_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_descriptor] = {
    .visible = true,
    .named = true,
  },
  [sym_sizeof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_alignof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_offsetof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_output_operand_list] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_output_operand] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_input_operand_list] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_input_operand] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_clobber_list] = {
    .visible = true,
    .named = true,
  },
  [sym_gnu_asm_goto_list] = {
    .visible = true,
    .named = true,
  },
  [sym_extension_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_field_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_literal_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_initializer_list] = {
    .visible = true,
    .named = true,
  },
  [sym_initializer_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_designator] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_range_designator] = {
    .visible = true,
    .named = true,
  },
  [sym_field_designator] = {
    .visible = true,
    .named = true,
  },
  [sym_char_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenated_string] = {
    .visible = true,
    .named = true,
  },
  [sym_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym__empty_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_placeholder_type_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_decltype_auto] = {
    .visible = true,
    .named = true,
  },
  [sym_decltype] = {
    .visible = true,
    .named = true,
  },
  [sym__class_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym__class_declaration_item] = {
    .visible = false,
    .named = true,
  },
  [sym_class_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym__class_name] = {
    .visible = false,
    .named = true,
  },
  [sym_virtual_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_explicit_function_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_base_class_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__enum_base_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_dependent_type] = {
    .visible = true,
    .named = true,
  },
  [sym_template_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_template_instantiation] = {
    .visible = true,
    .named = true,
  },
  [sym_template_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_type_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_type_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_template_template_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_parameter_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_reference_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_operator_cast] = {
    .visible = true,
    .named = true,
  },
  [sym_field_initializer_list] = {
    .visible = true,
    .named = true,
  },
  [sym_field_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_inline_method_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__constructor_specifiers] = {
    .visible = false,
    .named = true,
  },
  [sym_operator_cast_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_operator_cast_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_or_destructor_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_or_destructor_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_default_method_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_delete_method_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_pure_virtual_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_friend_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_access_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_field_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_type_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_reference_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_structured_binding_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_ref_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym__function_declarator_seq] = {
    .visible = false,
    .named = true,
  },
  [sym__function_attributes_start] = {
    .visible = false,
    .named = true,
  },
  [sym__function_exception_specification] = {
    .visible = false,
    .named = true,
  },
  [sym__function_attributes_end] = {
    .visible = false,
    .named = true,
  },
  [sym__function_postfix] = {
    .visible = false,
    .named = true,
  },
  [sym_trailing_return_type] = {
    .visible = true,
    .named = true,
  },
  [sym_noexcept] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_template_type] = {
    .visible = true,
    .named = true,
  },
  [sym_template_method] = {
    .visible = true,
    .named = true,
  },
  [sym_template_function] = {
    .visible = true,
    .named = true,
  },
  [sym_template_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_alias_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__namespace_specifier] = {
    .visible = false,
    .named = true,
  },
  [sym_nested_namespace_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_using_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_alias_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_static_assert_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_concept_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_for_range_loop] = {
    .visible = true,
    .named = true,
  },
  [sym__for_range_loop_body] = {
    .visible = false,
    .named = true,
  },
  [sym_init_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_condition_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_condition_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_co_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_co_yield_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_raw_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_co_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_delete_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_requirement] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_requirement] = {
    .visible = true,
    .named = true,
  },
  [sym__requirement] = {
    .visible = false,
    .named = true,
  },
  [sym_requirement_seq] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint_conjunction] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint_disjunction] = {
    .visible = true,
    .named = true,
  },
  [sym__requirement_clause_constraint] = {
    .visible = false,
    .named = true,
  },
  [sym_requires_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_requires_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_requires_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_capture_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_default_capture] = {
    .visible = true,
    .named = true,
  },
  [sym__lambda_capture_identifier] = {
    .visible = false,
    .named = true,
  },
  [sym_lambda_capture_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym__lambda_capture] = {
    .visible = false,
    .named = true,
  },
  [sym__fold_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__binary_fold_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__unary_left_fold] = {
    .visible = false,
    .named = true,
  },
  [sym__unary_right_fold] = {
    .visible = false,
    .named = true,
  },
  [sym__binary_fold] = {
    .visible = false,
    .named = true,
  },
  [sym_fold_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_pack_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter_pack_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_identifier_parameter_pack_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_destructor_name] = {
    .visible = true,
    .named = true,
  },
  [sym_dependent_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_dependent_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_dependent_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__scope_resolution] = {
    .visible = false,
    .named = true,
  },
  [sym_qualified_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_operator_cast_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__assignment_expression_lhs] = {
    .visible = true,
    .named = true,
  },
  [sym_operator_name] = {
    .visible = true,
    .named = true,
  },
  [sym_user_defined_literal] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_translation_unit_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_params_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_field_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_enumerator_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_preproc_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__type_definition_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__type_definition_declarators_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__declaration_specifiers_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attribute_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attributed_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pointer_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_sized_type_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enumerator_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_generic_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_output_operand_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_input_operand_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_clobber_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_gnu_asm_goto_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_initializer_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_initializer_pair_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_char_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenated_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__class_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_base_class_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_initializer_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_operator_cast_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_constructor_try_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_structured_binding_declarator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__function_postfix_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_throw_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_subscript_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_requirement_seq_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_requires_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_lambda_capture_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_namespace_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_simple_requirement] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_statement_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_alternative = 1,
  field_argument = 2,
  field_arguments = 3,
  field_assembly_code = 4,
  field_base = 5,
  field_body = 6,
  field_captures = 7,
  field_clobbers = 8,
  field_condition = 9,
  field_consequence = 10,
  field_constraint = 11,
  field_declarator = 12,
  field_default_type = 13,
  field_default_value = 14,
  field_delimiter = 15,
  field_designator = 16,
  field_directive = 17,
  field_end = 18,
  field_field = 19,
  field_filter = 20,
  field_function = 21,
  field_goto_labels = 22,
  field_indices = 23,
  field_initializer = 24,
  field_input_operands = 25,
  field_label = 26,
  field_left = 27,
  field_length = 28,
  field_member = 29,
  field_message = 30,
  field_name = 31,
  field_operand = 32,
  field_operator = 33,
  field_output_operands = 34,
  field_parameters = 35,
  field_path = 36,
  field_pattern = 37,
  field_placement = 38,
  field_prefix = 39,
  field_register = 40,
  field_requirements = 41,
  field_right = 42,
  field_scope = 43,
  field_size = 44,
  field_start = 45,
  field_symbol = 46,
  field_template_parameters = 47,
  field_type = 48,
  field_update = 49,
  field_value = 50,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_assembly_code] = "assembly_code",
  [field_base] = "base",
  [field_body] = "body",
  [field_captures] = "captures",
  [field_clobbers] = "clobbers",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_constraint] = "constraint",
  [field_declarator] = "declarator",
  [field_default_type] = "default_type",
  [field_default_value] = "default_value",
  [field_delimiter] = "delimiter",
  [field_designator] = "designator",
  [field_directive] = "directive",
  [field_end] = "end",
  [field_field] = "field",
  [field_filter] = "filter",
  [field_function] = "function",
  [field_goto_labels] = "goto_labels",
  [field_indices] = "indices",
  [field_initializer] = "initializer",
  [field_input_operands] = "input_operands",
  [field_label] = "label",
  [field_left] = "left",
  [field_length] = "length",
  [field_member] = "member",
  [field_message] = "message",
  [field_name] = "name",
  [field_operand] = "operand",
  [field_operator] = "operator",
  [field_output_operands] = "output_operands",
  [field_parameters] = "parameters",
  [field_path] = "path",
  [field_pattern] = "pattern",
  [field_placement] = "placement",
  [field_prefix] = "prefix",
  [field_register] = "register",
  [field_requirements] = "requirements",
  [field_right] = "right",
  [field_scope] = "scope",
  [field_size] = "size",
  [field_start] = "start",
  [field_symbol] = "symbol",
  [field_template_parameters] = "template_parameters",
  [field_type] = "type",
  [field_update] = "update",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [2] = {.index = 0, .length = 1},
  [3] = {.index = 1, .length = 1},
  [4] = {.index = 2, .length = 2},
  [5] = {.index = 4, .length = 1},
  [6] = {.index = 5, .length = 1},
  [7] = {.index = 6, .length = 2},
  [8] = {.index = 8, .length = 2},
  [9] = {.index = 10, .length = 1},
  [10] = {.index = 11, .length = 1},
  [11] = {.index = 12, .length = 1},
  [12] = {.index = 13, .length = 2},
  [13] = {.index = 15, .length = 2},
  [14] = {.index = 17, .length = 1},
  [15] = {.index = 18, .length = 1},
  [16] = {.index = 19, .length = 2},
  [17] = {.index = 19, .length = 2},
  [18] = {.index = 0, .length = 1},
  [20] = {.index = 21, .length = 1},
  [21] = {.index = 22, .length = 1},
  [22] = {.index = 23, .length = 1},
  [23] = {.index = 24, .length = 1},
  [24] = {.index = 25, .length = 2},
  [25] = {.index = 27, .length = 2},
  [26] = {.index = 29, .length = 1},
  [27] = {.index = 30, .length = 1},
  [28] = {.index = 31, .length = 1},
  [29] = {.index = 32, .length = 2},
  [30] = {.index = 34, .length = 2},
  [31] = {.index = 18, .length = 1},
  [32] = {.index = 36, .length = 2},
  [33] = {.index = 38, .length = 1},
  [34] = {.index = 39, .length = 2},
  [35] = {.index = 39, .length = 2},
  [36] = {.index = 21, .length = 1},
  [37] = {.index = 41, .length = 1},
  [38] = {.index = 42, .length = 2},
  [39] = {.index = 44, .length = 2},
  [40] = {.index = 46, .length = 3},
  [41] = {.index = 49, .length = 1},
  [44] = {.index = 50, .length = 2},
  [45] = {.index = 52, .length = 1},
  [46] = {.index = 53, .length = 1},
  [47] = {.index = 54, .length = 1},
  [48] = {.index = 55, .length = 2},
  [49] = {.index = 57, .length = 2},
  [50] = {.index = 59, .length = 2},
  [51] = {.index = 61, .length = 2},
  [52] = {.index = 63, .length = 2},
  [53] = {.index = 65, .length = 1},
  [54] = {.index = 66, .length = 3},
  [55] = {.index = 69, .length = 1},
  [56] = {.index = 70, .length = 1},
  [57] = {.index = 71, .length = 1},
  [58] = {.index = 72, .length = 2},
  [60] = {.index = 55, .length = 2},
  [61] = {.index = 74, .length = 2},
  [62] = {.index = 76, .length = 2},
  [63] = {.index = 78, .length = 2},
  [65] = {.index = 80, .length = 2},
  [66] = {.index = 82, .length = 2},
  [67] = {.index = 84, .length = 3},
  [68] = {.index = 87, .length = 2},
  [69] = {.index = 89, .length = 2},
  [70] = {.index = 91, .length = 3},
  [71] = {.index = 91, .length = 3},
  [72] = {.index = 94, .length = 3},
  [73] = {.index = 97, .length = 3},
  [74] = {.index = 100, .length = 3},
  [75] = {.index = 52, .length = 1},
  [76] = {.index = 103, .length = 2},
  [77] = {.index = 105, .length = 2},
  [78] = {.index = 107, .length = 2},
  [79] = {.index = 109, .length = 1},
  [80] = {.index = 110, .length = 2},
  [81] = {.index = 112, .length = 2},
  [82] = {.index = 114, .length = 2},
  [83] = {.index = 116, .length = 3},
  [84] = {.index = 119, .length = 2},
  [85] = {.index = 121, .length = 1},
  [86] = {.index = 122, .length = 2},
  [87] = {.index = 124, .length = 2},
  [88] = {.index = 126, .length = 2},
  [89] = {.index = 128, .length = 2},
  [90] = {.index = 130, .length = 2},
  [91] = {.index = 132, .length = 2},
  [92] = {.index = 134, .length = 2},
  [93] = {.index = 136, .length = 2},
  [94] = {.index = 138, .length = 1},
  [95] = {.index = 136, .length = 2},
  [97] = {.index = 139, .length = 2},
  [98] = {.index = 141, .length = 1},
  [99] = {.index = 141, .length = 1},
  [100] = {.index = 142, .length = 3},
  [102] = {.index = 145, .length = 2},
  [103] = {.index = 147, .length = 2},
  [104] = {.index = 149, .length = 2},
  [105] = {.index = 151, .length = 3},
  [106] = {.index = 154, .length = 1},
  [107] = {.index = 155, .length = 1},
  [109] = {.index = 156, .length = 3},
  [110] = {.index = 159, .length = 3},
  [111] = {.index = 162, .length = 3},
  [112] = {.index = 165, .length = 3},
  [113] = {.index = 168, .length = 2},
  [114] = {.index = 170, .length = 3},
  [115] = {.index = 173, .length = 3},
  [116] = {.index = 176, .length = 2},
  [117] = {.index = 178, .length = 3},
  [118] = {.index = 181, .length = 2},
  [119] = {.index = 19, .length = 2},
  [120] = {.index = 39, .length = 2},
  [121] = {.index = 183, .length = 2},
  [122] = {.index = 185, .length = 2},
  [123] = {.index = 187, .length = 1},
  [124] = {.index = 188, .length = 4},
  [125] = {.index = 192, .length = 4},
  [126] = {.index = 196, .length = 2},
  [127] = {.index = 198, .length = 3},
  [128] = {.index = 201, .length = 2},
  [129] = {.index = 203, .length = 2},
  [130] = {.index = 205, .length = 1},
  [131] = {.index = 206, .length = 2},
  [132] = {.index = 208, .length = 2},
  [133] = {.index = 210, .length = 3},
  [134] = {.index = 213, .length = 3},
  [135] = {.index = 216, .length = 3},
  [136] = {.index = 219, .length = 2},
  [137] = {.index = 221, .length = 2},
  [138] = {.index = 221, .length = 2},
  [139] = {.index = 223, .length = 2},
  [140] = {.index = 223, .length = 2},
  [141] = {.index = 225, .length = 2},
  [142] = {.index = 227, .length = 3},
  [143] = {.index = 230, .length = 2},
  [144] = {.index = 232, .length = 2},
  [145] = {.index = 234, .length = 3},
  [146] = {.index = 237, .length = 2},
  [147] = {.index = 239, .length = 3},
  [148] = {.index = 242, .length = 2},
  [149] = {.index = 244, .length = 1},
  [150] = {.index = 245, .length = 2},
  [151] = {.index = 247, .length = 2},
  [152] = {.index = 249, .length = 4},
  [153] = {.index = 253, .length = 5},
  [154] = {.index = 258, .length = 1},
  [155] = {.index = 259, .length = 1},
  [156] = {.index = 260, .length = 2},
  [157] = {.index = 262, .length = 1},
  [159] = {.index = 263, .length = 1},
  [160] = {.index = 264, .length = 2},
  [161] = {.index = 266, .length = 2},
  [162] = {.index = 11, .length = 1},
  [163] = {.index = 11, .length = 1},
  [164] = {.index = 268, .length = 2},
  [165] = {.index = 270, .length = 1},
  [166] = {.index = 271, .length = 1},
  [167] = {.index = 272, .length = 4},
  [168] = {.index = 276, .length = 2},
  [169] = {.index = 278, .length = 4},
  [170] = {.index = 282, .length = 1},
  [171] = {.index = 283, .length = 3},
  [172] = {.index = 286, .length = 2},
  [173] = {.index = 288, .length = 3},
  [174] = {.index = 291, .length = 1},
  [175] = {.index = 292, .length = 5},
  [176] = {.index = 297, .length = 2},
  [177] = {.index = 299, .length = 2},
  [178] = {.index = 301, .length = 4},
  [179] = {.index = 305, .length = 2},
  [180] = {.index = 307, .length = 2},
  [181] = {.index = 309, .length = 3},
  [182] = {.index = 312, .length = 4},
  [183] = {.index = 316, .length = 4},
  [184] = {.index = 320, .length = 3},
  [185] = {.index = 323, .length = 2},
  [186] = {.index = 325, .length = 3},
  [187] = {.index = 328, .length = 3},
  [188] = {.index = 331, .length = 2},
  [189] = {.index = 333, .length = 2},
  [190] = {.index = 335, .length = 2},
  [191] = {.index = 337, .length = 2},
  [192] = {.index = 339, .length = 3},
  [193] = {.index = 342, .length = 2},
  [194] = {.index = 344, .length = 2},
  [195] = {.index = 346, .length = 3},
  [196] = {.index = 349, .length = 2},
  [197] = {.index = 351, .length = 2},
  [198] = {.index = 353, .length = 2},
  [199] = {.index = 355, .length = 4},
  [200] = {.index = 359, .length = 5},
  [201] = {.index = 364, .length = 3},
  [202] = {.index = 367, .length = 4},
  [203] = {.index = 371, .length = 2},
  [204] = {.index = 373, .length = 1},
  [205] = {.index = 374, .length = 4},
  [206] = {.index = 378, .length = 3},
  [207] = {.index = 381, .length = 2},
  [208] = {.index = 383, .length = 1},
  [209] = {.index = 384, .length = 5},
  [210] = {.index = 389, .length = 2},
  [211] = {.index = 391, .length = 2},
  [212] = {.index = 65, .length = 1},
  [213] = {.index = 393, .length = 5},
  [214] = {.index = 398, .length = 4},
  [215] = {.index = 402, .length = 2},
  [216] = {.index = 404, .length = 2},
  [217] = {.index = 406, .length = 5},
  [218] = {.index = 411, .length = 2},
  [219] = {.index = 413, .length = 3},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_type, 0},
  [1] =
    {field_directive, 0},
  [2] =
    {field_argument, 1},
    {field_operator, 0},
  [4] =
    {field_declarator, 1},
  [5] =
    {field_name, 0},
  [6] =
    {field_arguments, 1},
    {field_function, 0},
  [8] =
    {field_type, 0},
    {field_value, 1},
  [10] =
    {field_body, 1},
  [11] =
    {field_name, 1},
  [12] =
    {field_body, 0},
  [13] =
    {field_body, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [15] =
    {field_body, 0, .inherited = true},
    {field_name, 0, .inherited = true},
  [17] =
    {field_value, 1},
  [18] =
    {field_scope, 0},
  [19] =
    {field_arguments, 1},
    {field_name, 0},
  [21] =
    {field_type, 1},
  [22] =
    {field_requirements, 1},
  [23] =
    {field_constraint, 1},
  [24] =
    {field_parameters, 0},
  [25] =
    {field_declarator, 0},
    {field_parameters, 1, .inherited = true},
  [27] =
    {field_body, 1},
    {field_declarator, 0},
  [29] =
    {field_declarator, 0},
  [30] =
    {field_constraint, 0},
  [31] =
    {field_pattern, 0},
  [32] =
    {field_argument, 0},
    {field_operator, 1},
  [34] =
    {field_argument, 0},
    {field_indices, 1},
  [36] =
    {field_body, 1},
    {field_captures, 0},
  [38] =
    {field_parameters, 0, .inherited = true},
  [39] =
    {field_name, 1},
    {field_scope, 0, .inherited = true},
  [41] =
    {field_path, 1},
  [42] =
    {field_argument, 1},
    {field_directive, 0},
  [44] =
    {field_declarator, 1},
    {field_type, 0},
  [46] =
    {field_left, 1, .inherited = true},
    {field_operator, 1, .inherited = true},
    {field_right, 1, .inherited = true},
  [49] =
    {field_declarator, 2},
  [50] =
    {field_body, 2},
    {field_value, 1},
  [52] =
    {field_type, 2},
  [53] =
    {field_body, 2},
  [54] =
    {field_name, 2},
  [55] =
    {field_body, 2},
    {field_name, 1},
  [57] =
    {field_base, 2, .inherited = true},
    {field_name, 1},
  [59] =
    {field_body, 1},
    {field_name, 0},
  [61] =
    {field_condition, 1},
    {field_consequence, 2},
  [63] =
    {field_body, 2},
    {field_condition, 1},
  [65] =
    {field_label, 1},
  [66] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [69] =
    {field_label, 0},
  [70] =
    {field_type, 0, .inherited = true},
  [71] =
    {field_parameters, 1},
  [72] =
    {field_declarator, 2},
    {field_type, 1, .inherited = true},
  [74] =
    {field_arguments, 2},
    {field_type, 1},
  [76] =
    {field_declarator, 2},
    {field_type, 1},
  [78] =
    {field_placement, 1},
    {field_type, 2},
  [80] =
    {field_parameters, 1},
    {field_requirements, 2},
  [82] =
    {field_declarator, 1},
    {field_type, 0, .inherited = true},
  [84] =
    {field_body, 2},
    {field_declarator, 1},
    {field_type, 0, .inherited = true},
  [87] =
    {field_declarator, 0},
    {field_value, 1},
  [89] =
    {field_body, 2},
    {field_declarator, 0},
  [91] =
    {field_argument, 0},
    {field_field, 2},
    {field_operator, 1},
  [94] =
    {field_body, 2},
    {field_captures, 0},
    {field_declarator, 1},
  [97] =
    {field_body, 2},
    {field_captures, 0},
    {field_template_parameters, 1},
  [100] =
    {field_name, 1},
    {field_name, 2},
    {field_scope, 0, .inherited = true},
  [103] =
    {field_body, 2},
    {field_declarator, 1},
  [105] =
    {field_name, 1},
    {field_value, 2},
  [107] =
    {field_name, 1},
    {field_parameters, 2},
  [109] =
    {field_condition, 1},
  [110] =
    {field_alternative, 2},
    {field_name, 1},
  [112] =
    {field_declarator, 2},
    {field_type, 0},
  [114] =
    {field_left, 0},
    {field_right, 2},
  [116] =
    {field_left, 0},
    {field_operator, 1, .inherited = true},
    {field_right, 2},
  [119] =
    {field_type, 1},
    {field_value, 3},
  [121] =
    {field_declarator, 3},
  [122] =
    {field_declarator, 2, .inherited = true},
    {field_type, 1, .inherited = true},
  [124] =
    {field_declarator, 0},
    {field_parameters, 1},
  [126] =
    {field_declarator, 0},
    {field_declarator, 1, .inherited = true},
  [128] =
    {field_arguments, 3},
    {field_type, 2},
  [130] =
    {field_declarator, 3},
    {field_type, 2},
  [132] =
    {field_placement, 2},
    {field_type, 3},
  [134] =
    {field_name, 2},
    {field_prefix, 0},
  [136] =
    {field_body, 3},
    {field_name, 2},
  [138] =
    {field_body, 3},
  [139] =
    {field_base, 3, .inherited = true},
    {field_name, 2},
  [141] =
    {field_base, 1},
  [142] =
    {field_base, 2, .inherited = true},
    {field_body, 3},
    {field_name, 1},
  [145] =
    {field_body, 2, .inherited = true},
    {field_name, 2, .inherited = true},
  [147] =
    {field_body, 2},
    {field_name, 0},
  [149] =
    {field_condition, 2},
    {field_consequence, 3},
  [151] =
    {field_alternative, 3},
    {field_condition, 1},
    {field_consequence, 2},
  [154] =
    {field_initializer, 0},
  [155] =
    {field_assembly_code, 2},
  [156] =
    {field_arguments, 3},
    {field_declarator, 2},
    {field_type, 1},
  [159] =
    {field_arguments, 3},
    {field_placement, 1},
    {field_type, 2},
  [162] =
    {field_declarator, 3},
    {field_placement, 1},
    {field_type, 2},
  [165] =
    {field_body, 3},
    {field_declarator, 2},
    {field_type, 0, .inherited = true},
  [168] =
    {field_declarator, 0},
    {field_value, 2},
  [170] =
    {field_declarator, 1},
    {field_declarator, 2},
    {field_type, 0, .inherited = true},
  [173] =
    {field_declarator, 1},
    {field_declarator, 2, .inherited = true},
    {field_type, 0, .inherited = true},
  [176] =
    {field_declarator, 0, .inherited = true},
    {field_declarator, 1, .inherited = true},
  [178] =
    {field_body, 3},
    {field_declarator, 2},
    {field_type, 1, .inherited = true},
  [181] =
    {field_declarator, 0},
    {field_size, 2},
  [183] =
    {field_alternative, 3},
    {field_condition, 0},
  [185] =
    {field_declarator, 0},
    {field_default_value, 2},
  [187] =
    {field_size, 1},
  [188] =
    {field_body, 3},
    {field_captures, 0},
    {field_declarator, 2},
    {field_template_parameters, 1},
  [192] =
    {field_body, 3},
    {field_captures, 0},
    {field_constraint, 2},
    {field_template_parameters, 1},
  [196] =
    {field_body, 3},
    {field_declarator, 1},
  [198] =
    {field_name, 1},
    {field_parameters, 2},
    {field_value, 3},
  [201] =
    {field_alternative, 3},
    {field_condition, 1},
  [203] =
    {field_alternative, 3},
    {field_name, 1},
  [205] =
    {field_operator, 0},
  [206] =
    {field_declarator, 3},
    {field_type, 1},
  [208] =
    {field_declarator, 3, .inherited = true},
    {field_type, 2, .inherited = true},
  [210] =
    {field_arguments, 4},
    {field_declarator, 3},
    {field_type, 2},
  [213] =
    {field_arguments, 4},
    {field_placement, 2},
    {field_type, 3},
  [216] =
    {field_declarator, 4},
    {field_placement, 2},
    {field_type, 3},
  [219] =
    {field_left, 1},
    {field_right, 3},
  [221] =
    {field_body, 4},
    {field_name, 3},
  [223] =
    {field_designator, 0},
    {field_value, 2},
  [225] =
    {field_name, 0},
    {field_value, 2},
  [227] =
    {field_base, 3, .inherited = true},
    {field_body, 4},
    {field_name, 2},
  [230] =
    {field_body, 3},
    {field_name, 0},
  [232] =
    {field_body, 3, .inherited = true},
    {field_name, 3, .inherited = true},
  [234] =
    {field_declarator, 1},
    {field_type, 0, .inherited = true},
    {field_value, 2},
  [237] =
    {field_initializer, 1},
    {field_value, 2},
  [239] =
    {field_alternative, 4},
    {field_condition, 2},
    {field_consequence, 3},
  [242] =
    {field_body, 1},
    {field_condition, 3},
  [244] =
    {field_update, 2},
  [245] =
    {field_initializer, 0},
    {field_update, 2},
  [247] =
    {field_condition, 1},
    {field_initializer, 0},
  [249] =
    {field_body, 4},
    {field_condition, 2, .inherited = true},
    {field_initializer, 2, .inherited = true},
    {field_update, 2, .inherited = true},
  [253] =
    {field_body, 4},
    {field_declarator, 2, .inherited = true},
    {field_initializer, 2, .inherited = true},
    {field_right, 2, .inherited = true},
    {field_type, 2, .inherited = true},
  [258] =
    {field_value, 3},
  [259] =
    {field_operand, 1},
  [260] =
    {field_assembly_code, 2},
    {field_output_operands, 3},
  [262] =
    {field_assembly_code, 3},
  [263] =
    {field_default_type, 2},
  [264] =
    {field_default_value, 2},
    {field_type, 0, .inherited = true},
  [266] =
    {field_body, 2},
    {field_parameters, 1},
  [268] =
    {field_name, 1},
    {field_type, 3},
  [270] =
    {field_condition, 2},
  [271] =
    {field_length, 1},
  [272] =
    {field_arguments, 4},
    {field_declarator, 3},
    {field_placement, 1},
    {field_type, 2},
  [276] =
    {field_declarator, 1},
    {field_declarator, 2},
  [278] =
    {field_declarator, 1},
    {field_declarator, 2},
    {field_declarator, 3, .inherited = true},
    {field_type, 0, .inherited = true},
  [282] =
    {field_declarator, 4},
  [283] =
    {field_body, 4},
    {field_declarator, 3},
    {field_type, 1, .inherited = true},
  [286] =
    {field_declarator, 0},
    {field_size, 3},
  [288] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [291] =
    {field_size, 2},
  [292] =
    {field_body, 4},
    {field_captures, 0},
    {field_constraint, 2},
    {field_declarator, 3},
    {field_template_parameters, 1},
  [297] =
    {field_declarator, 1},
    {field_default_value, 3},
  [299] =
    {field_alternative, 4},
    {field_condition, 1},
  [301] =
    {field_arguments, 5},
    {field_declarator, 4},
    {field_placement, 2},
    {field_type, 3},
  [305] =
    {field_body, 2},
    {field_filter, 1},
  [307] =
    {field_left, 2},
    {field_right, 4},
  [309] =
    {field_declarator, 1},
    {field_default_value, 2},
    {field_type, 0, .inherited = true},
  [312] =
    {field_declarator, 1},
    {field_declarator, 2, .inherited = true},
    {field_default_value, 2, .inherited = true},
    {field_type, 0, .inherited = true},
  [316] =
    {field_declarator, 0, .inherited = true},
    {field_declarator, 1, .inherited = true},
    {field_default_value, 0, .inherited = true},
    {field_default_value, 1, .inherited = true},
  [320] =
    {field_declarator, 1},
    {field_type, 0, .inherited = true},
    {field_value, 3},
  [323] =
    {field_condition, 1},
    {field_update, 3},
  [325] =
    {field_condition, 1},
    {field_initializer, 0},
    {field_update, 3},
  [328] =
    {field_declarator, 1},
    {field_right, 3},
    {field_type, 0, .inherited = true},
  [331] =
    {field_initializer, 0},
    {field_update, 3},
  [333] =
    {field_condition, 2},
    {field_initializer, 0},
  [335] =
    {field_member, 4},
    {field_type, 2},
  [337] =
    {field_operand, 1},
    {field_operand, 2, .inherited = true},
  [339] =
    {field_assembly_code, 2},
    {field_input_operands, 4},
    {field_output_operands, 3},
  [342] =
    {field_assembly_code, 3},
    {field_output_operands, 4},
  [344] =
    {field_default_type, 3},
    {field_name, 1},
  [346] =
    {field_declarator, 1},
    {field_default_value, 3},
    {field_type, 0, .inherited = true},
  [349] =
    {field_name, 1},
    {field_type, 4},
  [351] =
    {field_end, 3},
    {field_start, 1},
  [353] =
    {field_declarator, 1},
    {field_default_value, 2},
  [355] =
    {field_declarator, 1},
    {field_declarator, 3, .inherited = true},
    {field_default_value, 3, .inherited = true},
    {field_type, 0, .inherited = true},
  [359] =
    {field_declarator, 1},
    {field_declarator, 3, .inherited = true},
    {field_default_value, 2},
    {field_default_value, 3, .inherited = true},
    {field_type, 0, .inherited = true},
  [364] =
    {field_condition, 2},
    {field_initializer, 0},
    {field_update, 4},
  [367] =
    {field_declarator, 2},
    {field_initializer, 0},
    {field_right, 4},
    {field_type, 1, .inherited = true},
  [371] =
    {field_operand, 0, .inherited = true},
    {field_operand, 1, .inherited = true},
  [373] =
    {field_register, 1},
  [374] =
    {field_assembly_code, 2},
    {field_clobbers, 5},
    {field_input_operands, 4},
    {field_output_operands, 3},
  [378] =
    {field_assembly_code, 3},
    {field_input_operands, 5},
    {field_output_operands, 4},
  [381] =
    {field_condition, 2},
    {field_message, 4},
  [383] =
    {field_delimiter, 1},
  [384] =
    {field_declarator, 1},
    {field_declarator, 4, .inherited = true},
    {field_default_value, 3},
    {field_default_value, 4, .inherited = true},
    {field_type, 0, .inherited = true},
  [389] =
    {field_constraint, 0},
    {field_value, 2},
  [391] =
    {field_register, 1},
    {field_register, 2, .inherited = true},
  [393] =
    {field_assembly_code, 2},
    {field_clobbers, 5},
    {field_goto_labels, 6},
    {field_input_operands, 4},
    {field_output_operands, 3},
  [398] =
    {field_assembly_code, 3},
    {field_clobbers, 6},
    {field_input_operands, 5},
    {field_output_operands, 4},
  [402] =
    {field_register, 0, .inherited = true},
    {field_register, 1, .inherited = true},
  [404] =
    {field_label, 1},
    {field_label, 2, .inherited = true},
  [406] =
    {field_assembly_code, 3},
    {field_clobbers, 6},
    {field_goto_labels, 7},
    {field_input_operands, 5},
    {field_output_operands, 4},
  [411] =
    {field_label, 0, .inherited = true},
    {field_label, 1, .inherited = true},
  [413] =
    {field_constraint, 3},
    {field_symbol, 1},
    {field_value, 5},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = alias_sym_type_identifier,
  },
  [15] = {
    [0] = alias_sym_namespace_identifier,
  },
  [16] = {
    [0] = alias_sym_type_identifier,
  },
  [18] = {
    [0] = alias_sym_type_identifier,
  },
  [19] = {
    [0] = alias_sym_namespace_identifier,
  },
  [35] = {
    [1] = alias_sym_type_identifier,
  },
  [36] = {
    [1] = alias_sym_type_identifier,
  },
  [42] = {
    [0] = sym_primitive_type,
  },
  [43] = {
    [0] = sym_pointer_declarator,
  },
  [53] = {
    [1] = alias_sym_statement_identifier,
  },
  [55] = {
    [0] = alias_sym_statement_identifier,
  },
  [59] = {
    [1] = alias_sym_namespace_identifier,
  },
  [60] = {
    [1] = alias_sym_namespace_identifier,
  },
  [64] = {
    [0] = alias_sym_simple_requirement,
  },
  [70] = {
    [2] = alias_sym_field_identifier,
  },
  [75] = {
    [2] = alias_sym_type_identifier,
  },
  [93] = {
    [2] = alias_sym_namespace_identifier,
  },
  [96] = {
    [1] = alias_sym_field_identifier,
  },
  [99] = {
    [1] = alias_sym_type_identifier,
  },
  [101] = {
    [0] = alias_sym_field_identifier,
  },
  [108] = {
    [1] = alias_sym_type_identifier,
  },
  [119] = {
    [0] = alias_sym_field_identifier,
  },
  [120] = {
    [1] = alias_sym_field_identifier,
  },
  [137] = {
    [3] = alias_sym_namespace_identifier,
  },
  [139] = {
    [0] = alias_sym_field_identifier,
  },
  [158] = {
    [2] = alias_sym_type_identifier,
  },
  [162] = {
    [1] = alias_sym_namespace_identifier,
    [3] = alias_sym_namespace_identifier,
  },
  [163] = {
    [1] = alias_sym_namespace_identifier,
  },
  [164] = {
    [1] = alias_sym_type_identifier,
  },
  [190] = {
    [4] = alias_sym_field_identifier,
  },
  [194] = {
    [1] = alias_sym_type_identifier,
  },
  [196] = {
    [1] = alias_sym_type_identifier,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym_pointer_type_declarator, 2,
    sym_pointer_type_declarator,
    sym_pointer_declarator,
  sym_expression_statement, 2,
    sym_expression_statement,
    alias_sym_simple_requirement,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 2,
  [4] = 2,
  [5] = 2,
  [6] = 2,
  [7] = 2,
  [8] = 2,
  [9] = 2,
  [10] = 2,
  [11] = 2,
  [12] = 2,
  [13] = 13,
  [14] = 14,
  [15] = 15,
  [16] = 16,
  [17] = 17,
  [18] = 18,
  [19] = 19,
  [20] = 19,
  [21] = 18,
  [22] = 22,
  [23] = 13,
  [24] = 18,
  [25] = 22,
  [26] = 22,
  [27] = 18,
  [28] = 13,
  [29] = 13,
  [30] = 22,
  [31] = 19,
  [32] = 19,
  [33] = 33,
  [34] = 34,
  [35] = 35,
  [36] = 36,
  [37] = 37,
  [38] = 35,
  [39] = 35,
  [40] = 34,
  [41] = 33,
  [42] = 42,
  [43] = 37,
  [44] = 42,
  [45] = 35,
  [46] = 37,
  [47] = 47,
  [48] = 42,
  [49] = 37,
  [50] = 35,
  [51] = 34,
  [52] = 34,
  [53] = 42,
  [54] = 33,
  [55] = 35,
  [56] = 37,
  [57] = 35,
  [58] = 37,
  [59] = 35,
  [60] = 37,
  [61] = 35,
  [62] = 37,
  [63] = 35,
  [64] = 37,
  [65] = 35,
  [66] = 37,
  [67] = 35,
  [68] = 37,
  [69] = 35,
  [70] = 37,
  [71] = 35,
  [72] = 37,
  [73] = 35,
  [74] = 37,
  [75] = 35,
  [76] = 37,
  [77] = 35,
  [78] = 37,
  [79] = 37,
  [80] = 80,
  [81] = 81,
  [82] = 82,
  [83] = 83,
  [84] = 84,
  [85] = 85,
  [86] = 86,
  [87] = 83,
  [88] = 82,
  [89] = 86,
  [90] = 85,
  [91] = 83,
  [92] = 83,
  [93] = 84,
  [94] = 85,
  [95] = 86,
  [96] = 85,
  [97] = 86,
  [98] = 84,
  [99] = 82,
  [100] = 82,
  [101] = 84,
  [102] = 102,
  [103] = 84,
  [104] = 104,
  [105] = 104,
  [106] = 104,
  [107] = 104,
  [108] = 104,
  [109] = 86,
  [110] = 83,
  [111] = 104,
  [112] = 85,
  [113] = 82,
  [114] = 114,
  [115] = 114,
  [116] = 114,
  [117] = 114,
  [118] = 114,
  [119] = 114,
  [120] = 120,
  [121] = 121,
  [122] = 120,
  [123] = 120,
  [124] = 124,
  [125] = 125,
  [126] = 124,
  [127] = 124,
  [128] = 124,
  [129] = 124,
  [130] = 124,
  [131] = 131,
  [132] = 132,
  [133] = 133,
  [134] = 134,
  [135] = 134,
  [136] = 134,
  [137] = 137,
  [138] = 138,
  [139] = 138,
  [140] = 138,
  [141] = 137,
  [142] = 138,
  [143] = 137,
  [144] = 137,
  [145] = 137,
  [146] = 137,
  [147] = 138,
  [148] = 138,
  [149] = 138,
  [150] = 137,
  [151] = 137,
  [152] = 138,
  [153] = 138,
  [154] = 137,
  [155] = 138,
  [156] = 138,
  [157] = 137,
  [158] = 137,
  [159] = 137,
  [160] = 138,
  [161] = 137,
  [162] = 138,
  [163] = 163,
  [164] = 164,
  [165] = 165,
  [166] = 163,
  [167] = 134,
  [168] = 168,
  [169] = 169,
  [170] = 170,
  [171] = 171,
  [172] = 164,
  [173] = 173,
  [174] = 174,
  [175] = 168,
  [176] = 165,
  [177] = 164,
  [178] = 165,
  [179] = 163,
  [180] = 170,
  [181] = 171,
  [182] = 173,
  [183] = 168,
  [184] = 164,
  [185] = 165,
  [186] = 163,
  [187] = 174,
  [188] = 170,
  [189] = 171,
  [190] = 173,
  [191] = 170,
  [192] = 173,
  [193] = 168,
  [194] = 164,
  [195] = 165,
  [196] = 163,
  [197] = 174,
  [198] = 170,
  [199] = 171,
  [200] = 173,
  [201] = 171,
  [202] = 168,
  [203] = 164,
  [204] = 165,
  [205] = 163,
  [206] = 174,
  [207] = 174,
  [208] = 170,
  [209] = 171,
  [210] = 169,
  [211] = 173,
  [212] = 168,
  [213] = 169,
  [214] = 169,
  [215] = 169,
  [216] = 174,
  [217] = 217,
  [218] = 134,
  [219] = 219,
  [220] = 134,
  [221] = 221,
  [222] = 222,
  [223] = 223,
  [224] = 222,
  [225] = 222,
  [226] = 222,
  [227] = 227,
  [228] = 132,
  [229] = 229,
  [230] = 230,
  [231] = 134,
  [232] = 133,
  [233] = 233,
  [234] = 234,
  [235] = 235,
  [236] = 236,
  [237] = 237,
  [238] = 238,
  [239] = 239,
  [240] = 240,
  [241] = 241,
  [242] = 242,
  [243] = 243,
  [244] = 244,
  [245] = 245,
  [246] = 246,
  [247] = 247,
  [248] = 248,
  [249] = 249,
  [250] = 250,
  [251] = 251,
  [252] = 252,
  [253] = 253,
  [254] = 254,
  [255] = 255,
  [256] = 256,
  [257] = 257,
  [258] = 258,
  [259] = 259,
  [260] = 260,
  [261] = 261,
  [262] = 262,
  [263] = 263,
  [264] = 264,
  [265] = 265,
  [266] = 266,
  [267] = 267,
  [268] = 268,
  [269] = 269,
  [270] = 270,
  [271] = 271,
  [272] = 272,
  [273] = 273,
  [274] = 274,
  [275] = 275,
  [276] = 276,
  [277] = 277,
  [278] = 278,
  [279] = 279,
  [280] = 280,
  [281] = 281,
  [282] = 282,
  [283] = 283,
  [284] = 284,
  [285] = 285,
  [286] = 219,
  [287] = 287,
  [288] = 288,
  [289] = 289,
  [290] = 219,
  [291] = 217,
  [292] = 292,
  [293] = 293,
  [294] = 294,
  [295] = 295,
  [296] = 296,
  [297] = 297,
  [298] = 298,
  [299] = 299,
  [300] = 300,
  [301] = 301,
  [302] = 302,
  [303] = 303,
  [304] = 304,
  [305] = 305,
  [306] = 306,
  [307] = 307,
  [308] = 308,
  [309] = 309,
  [310] = 310,
  [311] = 311,
  [312] = 312,
  [313] = 313,
  [314] = 217,
  [315] = 301,
  [316] = 316,
  [317] = 317,
  [318] = 318,
  [319] = 217,
  [320] = 320,
  [321] = 301,
  [322] = 322,
  [323] = 323,
  [324] = 324,
  [325] = 325,
  [326] = 326,
  [327] = 327,
  [328] = 328,
  [329] = 329,
  [330] = 330,
  [331] = 301,
  [332] = 332,
  [333] = 333,
  [334] = 334,
  [335] = 335,
  [336] = 336,
  [337] = 337,
  [338] = 301,
  [339] = 339,
  [340] = 340,
  [341] = 301,
  [342] = 342,
  [343] = 343,
  [344] = 301,
  [345] = 345,
  [346] = 301,
  [347] = 301,
  [348] = 301,
  [349] = 349,
  [350] = 301,
  [351] = 301,
  [352] = 301,
  [353] = 301,
  [354] = 301,
  [355] = 355,
  [356] = 301,
  [357] = 301,
  [358] = 219,
  [359] = 359,
  [360] = 360,
  [361] = 361,
  [362] = 362,
  [363] = 363,
  [364] = 364,
  [365] = 365,
  [366] = 366,
  [367] = 367,
  [368] = 223,
  [369] = 369,
  [370] = 370,
  [371] = 371,
  [372] = 372,
  [373] = 373,
  [374] = 222,
  [375] = 375,
  [376] = 221,
  [377] = 223,
  [378] = 370,
  [379] = 379,
  [380] = 370,
  [381] = 221,
  [382] = 382,
  [383] = 379,
  [384] = 384,
  [385] = 385,
  [386] = 384,
  [387] = 379,
  [388] = 222,
  [389] = 384,
  [390] = 385,
  [391] = 222,
  [392] = 222,
  [393] = 222,
  [394] = 382,
  [395] = 222,
  [396] = 385,
  [397] = 227,
  [398] = 230,
  [399] = 133,
  [400] = 400,
  [401] = 400,
  [402] = 133,
  [403] = 400,
  [404] = 400,
  [405] = 400,
  [406] = 400,
  [407] = 400,
  [408] = 400,
  [409] = 400,
  [410] = 400,
  [411] = 400,
  [412] = 412,
  [413] = 230,
  [414] = 229,
  [415] = 132,
  [416] = 132,
  [417] = 227,
  [418] = 400,
  [419] = 229,
  [420] = 227,
  [421] = 230,
  [422] = 412,
  [423] = 229,
  [424] = 253,
  [425] = 255,
  [426] = 256,
  [427] = 257,
  [428] = 233,
  [429] = 237,
  [430] = 239,
  [431] = 240,
  [432] = 238,
  [433] = 263,
  [434] = 269,
  [435] = 246,
  [436] = 247,
  [437] = 248,
  [438] = 262,
  [439] = 259,
  [440] = 242,
  [441] = 245,
  [442] = 249,
  [443] = 269,
  [444] = 241,
  [445] = 250,
  [446] = 251,
  [447] = 261,
  [448] = 239,
  [449] = 240,
  [450] = 264,
  [451] = 241,
  [452] = 244,
  [453] = 258,
  [454] = 242,
  [455] = 260,
  [456] = 244,
  [457] = 266,
  [458] = 246,
  [459] = 247,
  [460] = 248,
  [461] = 243,
  [462] = 235,
  [463] = 246,
  [464] = 247,
  [465] = 248,
  [466] = 221,
  [467] = 250,
  [468] = 251,
  [469] = 252,
  [470] = 250,
  [471] = 251,
  [472] = 245,
  [473] = 252,
  [474] = 253,
  [475] = 254,
  [476] = 255,
  [477] = 256,
  [478] = 257,
  [479] = 253,
  [480] = 254,
  [481] = 255,
  [482] = 235,
  [483] = 256,
  [484] = 270,
  [485] = 257,
  [486] = 258,
  [487] = 259,
  [488] = 260,
  [489] = 223,
  [490] = 263,
  [491] = 261,
  [492] = 233,
  [493] = 264,
  [494] = 266,
  [495] = 268,
  [496] = 243,
  [497] = 245,
  [498] = 265,
  [499] = 267,
  [500] = 235,
  [501] = 262,
  [502] = 265,
  [503] = 267,
  [504] = 234,
  [505] = 270,
  [506] = 258,
  [507] = 260,
  [508] = 263,
  [509] = 236,
  [510] = 264,
  [511] = 266,
  [512] = 237,
  [513] = 238,
  [514] = 268,
  [515] = 249,
  [516] = 268,
  [517] = 259,
  [518] = 242,
  [519] = 243,
  [520] = 249,
  [521] = 270,
  [522] = 262,
  [523] = 265,
  [524] = 267,
  [525] = 234,
  [526] = 236,
  [527] = 241,
  [528] = 244,
  [529] = 234,
  [530] = 269,
  [531] = 237,
  [532] = 238,
  [533] = 239,
  [534] = 240,
  [535] = 252,
  [536] = 261,
  [537] = 233,
  [538] = 254,
  [539] = 236,
  [540] = 275,
  [541] = 322,
  [542] = 336,
  [543] = 337,
  [544] = 288,
  [545] = 339,
  [546] = 289,
  [547] = 281,
  [548] = 329,
  [549] = 330,
  [550] = 332,
  [551] = 313,
  [552] = 333,
  [553] = 349,
  [554] = 334,
  [555] = 355,
  [556] = 335,
  [557] = 273,
  [558] = 282,
  [559] = 297,
  [560] = 294,
  [561] = 367,
  [562] = 295,
  [563] = 306,
  [564] = 365,
  [565] = 282,
  [566] = 310,
  [567] = 342,
  [568] = 343,
  [569] = 366,
  [570] = 361,
  [571] = 288,
  [572] = 289,
  [573] = 340,
  [574] = 292,
  [575] = 293,
  [576] = 294,
  [577] = 295,
  [578] = 311,
  [579] = 326,
  [580] = 312,
  [581] = 362,
  [582] = 345,
  [583] = 283,
  [584] = 280,
  [585] = 271,
  [586] = 309,
  [587] = 308,
  [588] = 272,
  [589] = 325,
  [590] = 273,
  [591] = 272,
  [592] = 313,
  [593] = 340,
  [594] = 281,
  [595] = 365,
  [596] = 360,
  [597] = 313,
  [598] = 598,
  [599] = 278,
  [600] = 308,
  [601] = 298,
  [602] = 299,
  [603] = 366,
  [604] = 359,
  [605] = 269,
  [606] = 274,
  [607] = 274,
  [608] = 326,
  [609] = 296,
  [610] = 297,
  [611] = 342,
  [612] = 343,
  [613] = 363,
  [614] = 345,
  [615] = 361,
  [616] = 362,
  [617] = 364,
  [618] = 298,
  [619] = 335,
  [620] = 318,
  [621] = 300,
  [622] = 283,
  [623] = 271,
  [624] = 308,
  [625] = 302,
  [626] = 309,
  [627] = 303,
  [628] = 285,
  [629] = 317,
  [630] = 287,
  [631] = 304,
  [632] = 299,
  [633] = 325,
  [634] = 305,
  [635] = 306,
  [636] = 318,
  [637] = 300,
  [638] = 304,
  [639] = 320,
  [640] = 310,
  [641] = 322,
  [642] = 323,
  [643] = 311,
  [644] = 324,
  [645] = 302,
  [646] = 303,
  [647] = 359,
  [648] = 360,
  [649] = 312,
  [650] = 276,
  [651] = 276,
  [652] = 363,
  [653] = 277,
  [654] = 327,
  [655] = 328,
  [656] = 329,
  [657] = 277,
  [658] = 317,
  [659] = 367,
  [660] = 320,
  [661] = 323,
  [662] = 364,
  [663] = 275,
  [664] = 278,
  [665] = 324,
  [666] = 327,
  [667] = 292,
  [668] = 293,
  [669] = 279,
  [670] = 328,
  [671] = 336,
  [672] = 285,
  [673] = 337,
  [674] = 287,
  [675] = 330,
  [676] = 339,
  [677] = 332,
  [678] = 296,
  [679] = 349,
  [680] = 355,
  [681] = 279,
  [682] = 305,
  [683] = 333,
  [684] = 334,
  [685] = 280,
  [686] = 686,
  [687] = 329,
  [688] = 332,
  [689] = 333,
  [690] = 334,
  [691] = 335,
  [692] = 336,
  [693] = 337,
  [694] = 339,
  [695] = 294,
  [696] = 295,
  [697] = 349,
  [698] = 355,
  [699] = 365,
  [700] = 366,
  [701] = 272,
  [702] = 273,
  [703] = 274,
  [704] = 134,
  [705] = 276,
  [706] = 277,
  [707] = 367,
  [708] = 279,
  [709] = 281,
  [710] = 282,
  [711] = 309,
  [712] = 712,
  [713] = 713,
  [714] = 325,
  [715] = 326,
  [716] = 342,
  [717] = 343,
  [718] = 345,
  [719] = 359,
  [720] = 360,
  [721] = 363,
  [722] = 361,
  [723] = 364,
  [724] = 275,
  [725] = 278,
  [726] = 362,
  [727] = 285,
  [728] = 287,
  [729] = 296,
  [730] = 297,
  [731] = 298,
  [732] = 299,
  [733] = 300,
  [734] = 302,
  [735] = 303,
  [736] = 304,
  [737] = 280,
  [738] = 283,
  [739] = 305,
  [740] = 306,
  [741] = 271,
  [742] = 310,
  [743] = 288,
  [744] = 289,
  [745] = 311,
  [746] = 312,
  [747] = 317,
  [748] = 318,
  [749] = 320,
  [750] = 322,
  [751] = 323,
  [752] = 324,
  [753] = 327,
  [754] = 292,
  [755] = 293,
  [756] = 328,
  [757] = 330,
  [758] = 134,
  [759] = 759,
  [760] = 760,
  [761] = 761,
  [762] = 761,
  [763] = 598,
  [764] = 761,
  [765] = 759,
  [766] = 759,
  [767] = 761,
  [768] = 759,
  [769] = 769,
  [770] = 759,
  [771] = 761,
  [772] = 759,
  [773] = 761,
  [774] = 761,
  [775] = 759,
  [776] = 761,
  [777] = 759,
  [778] = 761,
  [779] = 759,
  [780] = 761,
  [781] = 759,
  [782] = 598,
  [783] = 134,
  [784] = 134,
  [785] = 134,
  [786] = 134,
  [787] = 787,
  [788] = 788,
  [789] = 788,
  [790] = 412,
  [791] = 412,
  [792] = 412,
  [793] = 793,
  [794] = 794,
  [795] = 795,
  [796] = 795,
  [797] = 795,
  [798] = 795,
  [799] = 795,
  [800] = 795,
  [801] = 795,
  [802] = 802,
  [803] = 802,
  [804] = 804,
  [805] = 805,
  [806] = 804,
  [807] = 805,
  [808] = 808,
  [809] = 802,
  [810] = 810,
  [811] = 811,
  [812] = 812,
  [813] = 813,
  [814] = 802,
  [815] = 812,
  [816] = 802,
  [817] = 817,
  [818] = 804,
  [819] = 813,
  [820] = 820,
  [821] = 820,
  [822] = 822,
  [823] = 802,
  [824] = 802,
  [825] = 820,
  [826] = 804,
  [827] = 827,
  [828] = 820,
  [829] = 822,
  [830] = 830,
  [831] = 412,
  [832] = 217,
  [833] = 412,
  [834] = 834,
  [835] = 219,
  [836] = 836,
  [837] = 836,
  [838] = 412,
  [839] = 836,
  [840] = 840,
  [841] = 132,
  [842] = 230,
  [843] = 227,
  [844] = 229,
  [845] = 133,
  [846] = 239,
  [847] = 251,
  [848] = 244,
  [849] = 260,
  [850] = 252,
  [851] = 238,
  [852] = 253,
  [853] = 249,
  [854] = 254,
  [855] = 268,
  [856] = 255,
  [857] = 256,
  [858] = 257,
  [859] = 261,
  [860] = 233,
  [861] = 793,
  [862] = 862,
  [863] = 241,
  [864] = 242,
  [865] = 240,
  [866] = 263,
  [867] = 270,
  [868] = 262,
  [869] = 243,
  [870] = 266,
  [871] = 246,
  [872] = 247,
  [873] = 248,
  [874] = 235,
  [875] = 265,
  [876] = 267,
  [877] = 234,
  [878] = 264,
  [879] = 236,
  [880] = 258,
  [881] = 259,
  [882] = 250,
  [883] = 830,
  [884] = 237,
  [885] = 862,
  [886] = 794,
  [887] = 245,
  [888] = 888,
  [889] = 889,
  [890] = 890,
  [891] = 891,
  [892] = 892,
  [893] = 893,
  [894] = 893,
  [895] = 889,
  [896] = 892,
  [897] = 891,
  [898] = 891,
  [899] = 891,
  [900] = 900,
  [901] = 891,
  [902] = 892,
  [903] = 893,
  [904] = 889,
  [905] = 891,
  [906] = 891,
  [907] = 890,
  [908] = 889,
  [909] = 893,
  [910] = 893,
  [911] = 892,
  [912] = 892,
  [913] = 892,
  [914] = 914,
  [915] = 893,
  [916] = 891,
  [917] = 891,
  [918] = 892,
  [919] = 892,
  [920] = 892,
  [921] = 889,
  [922] = 889,
  [923] = 923,
  [924] = 924,
  [925] = 923,
  [926] = 923,
  [927] = 923,
  [928] = 924,
  [929] = 923,
  [930] = 924,
  [931] = 924,
  [932] = 924,
  [933] = 924,
  [934] = 890,
  [935] = 923,
  [936] = 936,
  [937] = 937,
  [938] = 938,
  [939] = 939,
  [940] = 939,
  [941] = 941,
  [942] = 942,
  [943] = 943,
  [944] = 941,
  [945] = 941,
  [946] = 939,
  [947] = 939,
  [948] = 941,
  [949] = 939,
  [950] = 941,
  [951] = 941,
  [952] = 941,
  [953] = 953,
  [954] = 943,
  [955] = 942,
  [956] = 943,
  [957] = 942,
  [958] = 958,
  [959] = 943,
  [960] = 943,
  [961] = 943,
  [962] = 943,
  [963] = 943,
  [964] = 943,
  [965] = 965,
  [966] = 966,
  [967] = 966,
  [968] = 968,
  [969] = 969,
  [970] = 970,
  [971] = 971,
  [972] = 972,
  [973] = 973,
  [974] = 974,
  [975] = 975,
  [976] = 970,
  [977] = 966,
  [978] = 966,
  [979] = 975,
  [980] = 980,
  [981] = 975,
  [982] = 982,
  [983] = 975,
  [984] = 966,
  [985] = 970,
  [986] = 966,
  [987] = 975,
  [988] = 975,
  [989] = 966,
  [990] = 975,
  [991] = 966,
  [992] = 975,
  [993] = 966,
  [994] = 975,
  [995] = 995,
  [996] = 966,
  [997] = 997,
  [998] = 998,
  [999] = 966,
  [1000] = 975,
  [1001] = 966,
  [1002] = 975,
  [1003] = 966,
  [1004] = 975,
  [1005] = 975,
  [1006] = 1006,
  [1007] = 1007,
  [1008] = 1008,
  [1009] = 1009,
  [1010] = 1010,
  [1011] = 1011,
  [1012] = 1007,
  [1013] = 1013,
  [1014] = 1007,
  [1015] = 1010,
  [1016] = 1007,
  [1017] = 1017,
  [1018] = 1009,
  [1019] = 1019,
  [1020] = 1010,
  [1021] = 1010,
  [1022] = 1007,
  [1023] = 1023,
  [1024] = 1007,
  [1025] = 1025,
  [1026] = 1007,
  [1027] = 1007,
  [1028] = 1028,
  [1029] = 1010,
  [1030] = 1010,
  [1031] = 1031,
  [1032] = 1009,
  [1033] = 1010,
  [1034] = 1007,
  [1035] = 1007,
  [1036] = 1010,
  [1037] = 1007,
  [1038] = 1038,
  [1039] = 1009,
  [1040] = 1040,
  [1041] = 1010,
  [1042] = 1042,
  [1043] = 1009,
  [1044] = 1044,
  [1045] = 1045,
  [1046] = 1046,
  [1047] = 1010,
  [1048] = 1007,
  [1049] = 1010,
  [1050] = 1007,
  [1051] = 1009,
  [1052] = 1010,
  [1053] = 1009,
  [1054] = 1010,
  [1055] = 1055,
  [1056] = 1056,
  [1057] = 1057,
  [1058] = 1058,
  [1059] = 1059,
  [1060] = 1060,
  [1061] = 1061,
  [1062] = 1062,
  [1063] = 1063,
  [1064] = 1064,
  [1065] = 1065,
  [1066] = 1066,
  [1067] = 1062,
  [1068] = 1068,
  [1069] = 1066,
  [1070] = 1064,
  [1071] = 1063,
  [1072] = 1059,
  [1073] = 1073,
  [1074] = 1074,
  [1075] = 1056,
  [1076] = 1064,
  [1077] = 1077,
  [1078] = 1061,
  [1079] = 1079,
  [1080] = 1080,
  [1081] = 1068,
  [1082] = 1082,
  [1083] = 1083,
  [1084] = 1082,
  [1085] = 1058,
  [1086] = 1086,
  [1087] = 1087,
  [1088] = 1080,
  [1089] = 1089,
  [1090] = 1064,
  [1091] = 1091,
  [1092] = 1092,
  [1093] = 1064,
  [1094] = 1074,
  [1095] = 1095,
  [1096] = 1079,
  [1097] = 1092,
  [1098] = 1082,
  [1099] = 1099,
  [1100] = 1100,
  [1101] = 1101,
  [1102] = 1095,
  [1103] = 1064,
  [1104] = 1061,
  [1105] = 1082,
  [1106] = 1064,
  [1107] = 1107,
  [1108] = 1082,
  [1109] = 1068,
  [1110] = 1110,
  [1111] = 1082,
  [1112] = 1112,
  [1113] = 1062,
  [1114] = 1082,
  [1115] = 1062,
  [1116] = 1064,
  [1117] = 1082,
  [1118] = 1099,
  [1119] = 1107,
  [1120] = 1082,
  [1121] = 1110,
  [1122] = 1082,
  [1123] = 1123,
  [1124] = 1083,
  [1125] = 1064,
  [1126] = 1126,
  [1127] = 1057,
  [1128] = 1123,
  [1129] = 1064,
  [1130] = 1126,
  [1131] = 1131,
  [1132] = 1064,
  [1133] = 1061,
  [1134] = 1086,
  [1135] = 1135,
  [1136] = 1135,
  [1137] = 1083,
  [1138] = 1138,
  [1139] = 1068,
  [1140] = 1064,
  [1141] = 1061,
  [1142] = 1086,
  [1143] = 1143,
  [1144] = 1100,
  [1145] = 1138,
  [1146] = 1146,
  [1147] = 1089,
  [1148] = 1065,
  [1149] = 1091,
  [1150] = 1086,
  [1151] = 1064,
  [1152] = 1060,
  [1153] = 1068,
  [1154] = 1154,
  [1155] = 1146,
  [1156] = 1154,
  [1157] = 1131,
  [1158] = 1101,
  [1159] = 1159,
  [1160] = 1160,
  [1161] = 1087,
  [1162] = 1143,
  [1163] = 1163,
  [1164] = 1164,
  [1165] = 1165,
  [1166] = 1166,
  [1167] = 1167,
  [1168] = 1168,
  [1169] = 1169,
  [1170] = 1170,
  [1171] = 1171,
  [1172] = 1172,
  [1173] = 1173,
  [1174] = 1174,
  [1175] = 1175,
  [1176] = 1176,
  [1177] = 1177,
  [1178] = 1178,
  [1179] = 1179,
  [1180] = 1180,
  [1181] = 1181,
  [1182] = 1169,
  [1183] = 1183,
  [1184] = 1165,
  [1185] = 1185,
  [1186] = 1166,
  [1187] = 1187,
  [1188] = 1188,
  [1189] = 1189,
  [1190] = 1190,
  [1191] = 1188,
  [1192] = 1192,
  [1193] = 1193,
  [1194] = 1165,
  [1195] = 1166,
  [1196] = 1168,
  [1197] = 1169,
  [1198] = 1171,
  [1199] = 1172,
  [1200] = 1173,
  [1201] = 1174,
  [1202] = 1175,
  [1203] = 1176,
  [1204] = 1177,
  [1205] = 1178,
  [1206] = 1179,
  [1207] = 1180,
  [1208] = 1181,
  [1209] = 1209,
  [1210] = 1210,
  [1211] = 1164,
  [1212] = 1212,
  [1213] = 1187,
  [1214] = 1188,
  [1215] = 1215,
  [1216] = 1216,
  [1217] = 1217,
  [1218] = 1165,
  [1219] = 1166,
  [1220] = 1169,
  [1221] = 1221,
  [1222] = 1163,
  [1223] = 1181,
  [1224] = 1224,
  [1225] = 1225,
  [1226] = 1226,
  [1227] = 1187,
  [1228] = 1165,
  [1229] = 1166,
  [1230] = 1230,
  [1231] = 1231,
  [1232] = 1168,
  [1233] = 1188,
  [1234] = 1169,
  [1235] = 1165,
  [1236] = 1166,
  [1237] = 1169,
  [1238] = 1181,
  [1239] = 1239,
  [1240] = 1187,
  [1241] = 1188,
  [1242] = 1169,
  [1243] = 1181,
  [1244] = 1187,
  [1245] = 1188,
  [1246] = 1246,
  [1247] = 1247,
  [1248] = 1171,
  [1249] = 1183,
  [1250] = 1239,
  [1251] = 1172,
  [1252] = 1173,
  [1253] = 1174,
  [1254] = 1175,
  [1255] = 1247,
  [1256] = 1176,
  [1257] = 1177,
  [1258] = 1165,
  [1259] = 1178,
  [1260] = 1179,
  [1261] = 1166,
  [1262] = 1180,
  [1263] = 1181,
  [1264] = 1231,
  [1265] = 1168,
  [1266] = 1169,
  [1267] = 1171,
  [1268] = 1172,
  [1269] = 1173,
  [1270] = 1174,
  [1271] = 1175,
  [1272] = 1176,
  [1273] = 1177,
  [1274] = 1178,
  [1275] = 1179,
  [1276] = 1180,
  [1277] = 1181,
  [1278] = 1278,
  [1279] = 1279,
  [1280] = 1280,
  [1281] = 1281,
  [1282] = 1188,
  [1283] = 1171,
  [1284] = 1172,
  [1285] = 1173,
  [1286] = 1174,
  [1287] = 1168,
  [1288] = 1171,
  [1289] = 1172,
  [1290] = 1173,
  [1291] = 1174,
  [1292] = 1175,
  [1293] = 1176,
  [1294] = 1177,
  [1295] = 1178,
  [1296] = 1179,
  [1297] = 1180,
  [1298] = 1165,
  [1299] = 1166,
  [1300] = 1169,
  [1301] = 1181,
  [1302] = 1187,
  [1303] = 1188,
  [1304] = 1183,
  [1305] = 1239,
  [1306] = 1247,
  [1307] = 1165,
  [1308] = 1166,
  [1309] = 1175,
  [1310] = 1231,
  [1311] = 1168,
  [1312] = 1169,
  [1313] = 1187,
  [1314] = 1171,
  [1315] = 1172,
  [1316] = 1173,
  [1317] = 1174,
  [1318] = 1175,
  [1319] = 1176,
  [1320] = 1177,
  [1321] = 1178,
  [1322] = 1179,
  [1323] = 1180,
  [1324] = 1181,
  [1325] = 1176,
  [1326] = 1177,
  [1327] = 1178,
  [1328] = 1187,
  [1329] = 1188,
  [1330] = 1179,
  [1331] = 1180,
  [1332] = 1168,
  [1333] = 1171,
  [1334] = 1172,
  [1335] = 1173,
  [1336] = 1174,
  [1337] = 1175,
  [1338] = 1176,
  [1339] = 1177,
  [1340] = 1178,
  [1341] = 1179,
  [1342] = 1180,
  [1343] = 1165,
  [1344] = 1166,
  [1345] = 1183,
  [1346] = 1346,
  [1347] = 1247,
  [1348] = 1181,
  [1349] = 1231,
  [1350] = 1187,
  [1351] = 1168,
  [1352] = 1171,
  [1353] = 1172,
  [1354] = 1173,
  [1355] = 1174,
  [1356] = 1175,
  [1357] = 1176,
  [1358] = 1177,
  [1359] = 1178,
  [1360] = 1179,
  [1361] = 1180,
  [1362] = 1183,
  [1363] = 1247,
  [1364] = 1364,
  [1365] = 1231,
  [1366] = 1168,
  [1367] = 1171,
  [1368] = 1172,
  [1369] = 1173,
  [1370] = 1174,
  [1371] = 1175,
  [1372] = 1176,
  [1373] = 1177,
  [1374] = 1178,
  [1375] = 1179,
  [1376] = 1180,
  [1377] = 1183,
  [1378] = 1247,
  [1379] = 1183,
  [1380] = 1247,
  [1381] = 1381,
  [1382] = 1183,
  [1383] = 1247,
  [1384] = 1183,
  [1385] = 1170,
  [1386] = 1247,
  [1387] = 1387,
  [1388] = 1183,
  [1389] = 1247,
  [1390] = 1168,
  [1391] = 1391,
  [1392] = 1281,
  [1393] = 1188,
  [1394] = 1163,
  [1395] = 1185,
  [1396] = 1168,
  [1397] = 1169,
  [1398] = 1171,
  [1399] = 1172,
  [1400] = 1173,
  [1401] = 1174,
  [1402] = 1175,
  [1403] = 1176,
  [1404] = 1177,
  [1405] = 1178,
  [1406] = 1179,
  [1407] = 1180,
  [1408] = 1181,
  [1409] = 1364,
  [1410] = 1278,
  [1411] = 1279,
  [1412] = 1187,
  [1413] = 1346,
  [1414] = 1188,
  [1415] = 1216,
  [1416] = 1163,
  [1417] = 1185,
  [1418] = 1364,
  [1419] = 1278,
  [1420] = 1279,
  [1421] = 1346,
  [1422] = 1216,
  [1423] = 1185,
  [1424] = 1364,
  [1425] = 1278,
  [1426] = 1279,
  [1427] = 1346,
  [1428] = 1216,
  [1429] = 1163,
  [1430] = 1185,
  [1431] = 1364,
  [1432] = 1278,
  [1433] = 1279,
  [1434] = 1346,
  [1435] = 1216,
  [1436] = 1364,
  [1437] = 1278,
  [1438] = 1279,
  [1439] = 1346,
  [1440] = 1216,
  [1441] = 1364,
  [1442] = 1278,
  [1443] = 1346,
  [1444] = 1183,
  [1445] = 1247,
  [1446] = 1165,
  [1447] = 1166,
  [1448] = 1246,
  [1449] = 1209,
  [1450] = 1210,
  [1451] = 1183,
  [1452] = 1247,
  [1453] = 1172,
  [1454] = 1246,
  [1455] = 1246,
  [1456] = 1246,
  [1457] = 1246,
  [1458] = 1246,
  [1459] = 1231,
  [1460] = 1168,
  [1461] = 1171,
  [1462] = 1172,
  [1463] = 1173,
  [1464] = 1174,
  [1465] = 1175,
  [1466] = 1176,
  [1467] = 1177,
  [1468] = 1178,
  [1469] = 1179,
  [1470] = 1180,
  [1471] = 1165,
  [1472] = 1166,
  [1473] = 1169,
  [1474] = 1181,
  [1475] = 1187,
  [1476] = 1188,
  [1477] = 1168,
  [1478] = 1169,
  [1479] = 1171,
  [1480] = 1173,
  [1481] = 1174,
  [1482] = 1175,
  [1483] = 1176,
  [1484] = 1177,
  [1485] = 1178,
  [1486] = 1179,
  [1487] = 1180,
  [1488] = 1181,
  [1489] = 1187,
  [1490] = 1188,
  [1491] = 1183,
  [1492] = 1247,
  [1493] = 1165,
  [1494] = 1166,
  [1495] = 1164,
  [1496] = 1164,
  [1497] = 1164,
  [1498] = 1164,
  [1499] = 1187,
  [1500] = 1500,
  [1501] = 1501,
  [1502] = 1502,
  [1503] = 1503,
  [1504] = 1504,
  [1505] = 1505,
  [1506] = 1506,
  [1507] = 1507,
  [1508] = 1508,
  [1509] = 1509,
  [1510] = 1509,
  [1511] = 281,
  [1512] = 272,
  [1513] = 1513,
  [1514] = 1514,
  [1515] = 1507,
  [1516] = 1514,
  [1517] = 1514,
  [1518] = 1514,
  [1519] = 1508,
  [1520] = 1507,
  [1521] = 1507,
  [1522] = 1506,
  [1523] = 1500,
  [1524] = 1508,
  [1525] = 1501,
  [1526] = 1505,
  [1527] = 1504,
  [1528] = 1500,
  [1529] = 1504,
  [1530] = 1502,
  [1531] = 1503,
  [1532] = 1502,
  [1533] = 1533,
  [1534] = 1501,
  [1535] = 1505,
  [1536] = 1506,
  [1537] = 1503,
  [1538] = 1508,
  [1539] = 890,
  [1540] = 1540,
  [1541] = 890,
  [1542] = 890,
  [1543] = 1508,
  [1544] = 1544,
  [1545] = 1506,
  [1546] = 1500,
  [1547] = 1504,
  [1548] = 1503,
  [1549] = 1502,
  [1550] = 1501,
  [1551] = 1505,
  [1552] = 1552,
  [1553] = 1553,
  [1554] = 1554,
  [1555] = 1555,
  [1556] = 1554,
  [1557] = 1555,
  [1558] = 1504,
  [1559] = 1500,
  [1560] = 1503,
  [1561] = 1502,
  [1562] = 1501,
  [1563] = 1506,
  [1564] = 1505,
  [1565] = 1508,
  [1566] = 1566,
  [1567] = 1566,
  [1568] = 1555,
  [1569] = 1554,
  [1570] = 1570,
  [1571] = 1540,
  [1572] = 1555,
  [1573] = 1554,
  [1574] = 1574,
  [1575] = 1540,
  [1576] = 1574,
  [1577] = 1574,
  [1578] = 1574,
  [1579] = 1566,
  [1580] = 1540,
  [1581] = 1581,
  [1582] = 1581,
  [1583] = 1583,
  [1584] = 1583,
  [1585] = 1581,
  [1586] = 1583,
  [1587] = 1581,
  [1588] = 1583,
  [1589] = 1581,
  [1590] = 1583,
  [1591] = 1591,
  [1592] = 1592,
  [1593] = 1593,
  [1594] = 1594,
  [1595] = 1595,
  [1596] = 1596,
  [1597] = 1597,
  [1598] = 1598,
  [1599] = 1599,
  [1600] = 1600,
  [1601] = 1601,
  [1602] = 1602,
  [1603] = 1581,
  [1604] = 1583,
  [1605] = 1605,
  [1606] = 1606,
  [1607] = 1607,
  [1608] = 1544,
  [1609] = 1581,
  [1610] = 1554,
  [1611] = 1555,
  [1612] = 1583,
  [1613] = 1553,
  [1614] = 1552,
  [1615] = 1566,
  [1616] = 1540,
  [1617] = 1540,
  [1618] = 1544,
  [1619] = 1552,
  [1620] = 1553,
  [1621] = 1621,
  [1622] = 1621,
  [1623] = 1508,
  [1624] = 1552,
  [1625] = 1553,
  [1626] = 1501,
  [1627] = 1505,
  [1628] = 1544,
  [1629] = 1500,
  [1630] = 1506,
  [1631] = 1508,
  [1632] = 1502,
  [1633] = 1566,
  [1634] = 1503,
  [1635] = 1504,
  [1636] = 1636,
  [1637] = 1637,
  [1638] = 1544,
  [1639] = 1500,
  [1640] = 217,
  [1641] = 1504,
  [1642] = 1502,
  [1643] = 223,
  [1644] = 1644,
  [1645] = 1553,
  [1646] = 1646,
  [1647] = 219,
  [1648] = 1648,
  [1649] = 1649,
  [1650] = 1552,
  [1651] = 1552,
  [1652] = 1503,
  [1653] = 1501,
  [1654] = 1553,
  [1655] = 1506,
  [1656] = 1656,
  [1657] = 221,
  [1658] = 1505,
  [1659] = 1659,
  [1660] = 1659,
  [1661] = 1659,
  [1662] = 1662,
  [1663] = 1659,
  [1664] = 1664,
  [1665] = 269,
  [1666] = 1666,
  [1667] = 227,
  [1668] = 1508,
  [1669] = 269,
  [1670] = 132,
  [1671] = 1507,
  [1672] = 133,
  [1673] = 1673,
  [1674] = 1674,
  [1675] = 342,
  [1676] = 343,
  [1677] = 345,
  [1678] = 1678,
  [1679] = 361,
  [1680] = 362,
  [1681] = 1681,
  [1682] = 283,
  [1683] = 308,
  [1684] = 1684,
  [1685] = 1685,
  [1686] = 1686,
  [1687] = 1687,
  [1688] = 1688,
  [1689] = 360,
  [1690] = 278,
  [1691] = 285,
  [1692] = 287,
  [1693] = 296,
  [1694] = 297,
  [1695] = 298,
  [1696] = 299,
  [1697] = 300,
  [1698] = 302,
  [1699] = 303,
  [1700] = 1700,
  [1701] = 1701,
  [1702] = 1702,
  [1703] = 1703,
  [1704] = 1704,
  [1705] = 318,
  [1706] = 1706,
  [1707] = 1500,
  [1708] = 1708,
  [1709] = 1709,
  [1710] = 1710,
  [1711] = 322,
  [1712] = 323,
  [1713] = 324,
  [1714] = 327,
  [1715] = 328,
  [1716] = 329,
  [1717] = 330,
  [1718] = 332,
  [1719] = 1501,
  [1720] = 333,
  [1721] = 1710,
  [1722] = 334,
  [1723] = 335,
  [1724] = 1724,
  [1725] = 1725,
  [1726] = 273,
  [1727] = 274,
  [1728] = 1728,
  [1729] = 276,
  [1730] = 277,
  [1731] = 367,
  [1732] = 1688,
  [1733] = 1733,
  [1734] = 282,
  [1735] = 1735,
  [1736] = 1505,
  [1737] = 1737,
  [1738] = 1710,
  [1739] = 1688,
  [1740] = 1506,
  [1741] = 1710,
  [1742] = 1742,
  [1743] = 1688,
  [1744] = 1744,
  [1745] = 1745,
  [1746] = 1746,
  [1747] = 1747,
  [1748] = 1688,
  [1749] = 239,
  [1750] = 240,
  [1751] = 1751,
  [1752] = 1752,
  [1753] = 1753,
  [1754] = 1688,
  [1755] = 1755,
  [1756] = 1756,
  [1757] = 246,
  [1758] = 247,
  [1759] = 248,
  [1760] = 288,
  [1761] = 289,
  [1762] = 1504,
  [1763] = 1763,
  [1764] = 1764,
  [1765] = 1502,
  [1766] = 1766,
  [1767] = 259,
  [1768] = 1503,
  [1769] = 1769,
  [1770] = 1507,
  [1771] = 292,
  [1772] = 1772,
  [1773] = 241,
  [1774] = 293,
  [1775] = 1775,
  [1776] = 250,
  [1777] = 251,
  [1778] = 272,
  [1779] = 261,
  [1780] = 281,
  [1781] = 1781,
  [1782] = 294,
  [1783] = 1688,
  [1784] = 295,
  [1785] = 1785,
  [1786] = 1786,
  [1787] = 1787,
  [1788] = 313,
  [1789] = 1789,
  [1790] = 1790,
  [1791] = 1791,
  [1792] = 1792,
  [1793] = 1793,
  [1794] = 1794,
  [1795] = 1795,
  [1796] = 1796,
  [1797] = 1797,
  [1798] = 1798,
  [1799] = 1799,
  [1800] = 1800,
  [1801] = 1554,
  [1802] = 1802,
  [1803] = 1803,
  [1804] = 1804,
  [1805] = 1805,
  [1806] = 1806,
  [1807] = 1807,
  [1808] = 1808,
  [1809] = 1809,
  [1810] = 1810,
  [1811] = 1636,
  [1812] = 1812,
  [1813] = 1553,
  [1814] = 1814,
  [1815] = 1815,
  [1816] = 1816,
  [1817] = 1817,
  [1818] = 221,
  [1819] = 1819,
  [1820] = 217,
  [1821] = 1555,
  [1822] = 1822,
  [1823] = 1823,
  [1824] = 1824,
  [1825] = 223,
  [1826] = 1826,
  [1827] = 1555,
  [1828] = 223,
  [1829] = 1570,
  [1830] = 219,
  [1831] = 1507,
  [1832] = 1552,
  [1833] = 217,
  [1834] = 1834,
  [1835] = 219,
  [1836] = 1836,
  [1837] = 1837,
  [1838] = 1838,
  [1839] = 1554,
  [1840] = 1840,
  [1841] = 1841,
  [1842] = 1842,
  [1843] = 221,
  [1844] = 1844,
  [1845] = 1845,
  [1846] = 1846,
  [1847] = 1847,
  [1848] = 1848,
  [1849] = 1849,
  [1850] = 1508,
  [1851] = 1851,
  [1852] = 1852,
  [1853] = 1853,
  [1854] = 1854,
  [1855] = 1855,
  [1856] = 1856,
  [1857] = 1857,
  [1858] = 1834,
  [1859] = 1859,
  [1860] = 1860,
  [1861] = 1507,
  [1862] = 1508,
  [1863] = 1863,
  [1864] = 1864,
  [1865] = 1865,
  [1866] = 269,
  [1867] = 1867,
  [1868] = 1865,
  [1869] = 1869,
  [1870] = 1870,
  [1871] = 227,
  [1872] = 1872,
  [1873] = 1873,
  [1874] = 1570,
  [1875] = 227,
  [1876] = 133,
  [1877] = 1865,
  [1878] = 133,
  [1879] = 1508,
  [1880] = 1880,
  [1881] = 1865,
  [1882] = 1540,
  [1883] = 1766,
  [1884] = 1884,
  [1885] = 1787,
  [1886] = 269,
  [1887] = 1887,
  [1888] = 1888,
  [1889] = 269,
  [1890] = 1890,
  [1891] = 1865,
  [1892] = 132,
  [1893] = 1893,
  [1894] = 1544,
  [1895] = 1706,
  [1896] = 1896,
  [1897] = 1897,
  [1898] = 269,
  [1899] = 1865,
  [1900] = 1900,
  [1901] = 1901,
  [1902] = 1865,
  [1903] = 132,
  [1904] = 1704,
  [1905] = 334,
  [1906] = 296,
  [1907] = 297,
  [1908] = 298,
  [1909] = 299,
  [1910] = 300,
  [1911] = 302,
  [1912] = 303,
  [1913] = 288,
  [1914] = 289,
  [1915] = 1863,
  [1916] = 318,
  [1917] = 322,
  [1918] = 323,
  [1919] = 324,
  [1920] = 327,
  [1921] = 328,
  [1922] = 329,
  [1923] = 330,
  [1924] = 332,
  [1925] = 333,
  [1926] = 335,
  [1927] = 292,
  [1928] = 293,
  [1929] = 273,
  [1930] = 274,
  [1931] = 342,
  [1932] = 276,
  [1933] = 277,
  [1934] = 343,
  [1935] = 367,
  [1936] = 294,
  [1937] = 295,
  [1938] = 282,
  [1939] = 239,
  [1940] = 240,
  [1941] = 361,
  [1942] = 362,
  [1943] = 246,
  [1944] = 247,
  [1945] = 248,
  [1946] = 1808,
  [1947] = 1947,
  [1948] = 259,
  [1949] = 1900,
  [1950] = 283,
  [1951] = 308,
  [1952] = 1656,
  [1953] = 1646,
  [1954] = 241,
  [1955] = 1854,
  [1956] = 1648,
  [1957] = 250,
  [1958] = 251,
  [1959] = 272,
  [1960] = 261,
  [1961] = 281,
  [1962] = 1962,
  [1963] = 360,
  [1964] = 1964,
  [1965] = 1965,
  [1966] = 278,
  [1967] = 1566,
  [1968] = 296,
  [1969] = 297,
  [1970] = 298,
  [1971] = 299,
  [1972] = 300,
  [1973] = 302,
  [1974] = 303,
  [1975] = 241,
  [1976] = 1976,
  [1977] = 1790,
  [1978] = 1978,
  [1979] = 1636,
  [1980] = 1791,
  [1981] = 1792,
  [1982] = 294,
  [1983] = 318,
  [1984] = 322,
  [1985] = 1763,
  [1986] = 1793,
  [1987] = 1703,
  [1988] = 1737,
  [1989] = 329,
  [1990] = 330,
  [1991] = 332,
  [1992] = 333,
  [1993] = 334,
  [1994] = 335,
  [1995] = 250,
  [1996] = 251,
  [1997] = 1863,
  [1998] = 1854,
  [1999] = 272,
  [2000] = 1636,
  [2001] = 273,
  [2002] = 1785,
  [2003] = 367,
  [2004] = 1794,
  [2005] = 261,
  [2006] = 793,
  [2007] = 295,
  [2008] = 1978,
  [2009] = 281,
  [2010] = 282,
  [2011] = 1764,
  [2012] = 1775,
  [2013] = 1781,
  [2014] = 1786,
  [2015] = 1789,
  [2016] = 1678,
  [2017] = 1795,
  [2018] = 345,
  [2019] = 1681,
  [2020] = 1566,
  [2021] = 1684,
  [2022] = 1685,
  [2023] = 1686,
  [2024] = 1701,
  [2025] = 1687,
  [2026] = 1700,
  [2027] = 1673,
  [2028] = 1702,
  [2029] = 1708,
  [2030] = 1725,
  [2031] = 285,
  [2032] = 287,
  [2033] = 1978,
  [2034] = 794,
  [2035] = 323,
  [2036] = 324,
  [2037] = 327,
  [2038] = 328,
  [2039] = 1947,
  [2040] = 2040,
  [2041] = 274,
  [2042] = 276,
  [2043] = 277,
  [2044] = 1724,
  [2045] = 1978,
  [2046] = 1742,
  [2047] = 1744,
  [2048] = 1745,
  [2049] = 1746,
  [2050] = 1751,
  [2051] = 1752,
  [2052] = 1753,
  [2053] = 1756,
  [2054] = 1742,
  [2055] = 1859,
  [2056] = 1636,
  [2057] = 292,
  [2058] = 288,
  [2059] = 1701,
  [2060] = 1744,
  [2061] = 239,
  [2062] = 1745,
  [2063] = 240,
  [2064] = 289,
  [2065] = 1746,
  [2066] = 1751,
  [2067] = 1752,
  [2068] = 1753,
  [2069] = 1756,
  [2070] = 293,
  [2071] = 1790,
  [2072] = 1791,
  [2073] = 1792,
  [2074] = 246,
  [2075] = 247,
  [2076] = 248,
  [2077] = 1763,
  [2078] = 1793,
  [2079] = 1703,
  [2080] = 1673,
  [2081] = 1737,
  [2082] = 1747,
  [2083] = 1785,
  [2084] = 1794,
  [2085] = 1764,
  [2086] = 1775,
  [2087] = 1781,
  [2088] = 1786,
  [2089] = 259,
  [2090] = 1789,
  [2091] = 1678,
  [2092] = 1795,
  [2093] = 1681,
  [2094] = 1684,
  [2095] = 313,
  [2096] = 1685,
  [2097] = 1686,
  [2098] = 313,
  [2099] = 1857,
  [2100] = 1687,
  [2101] = 1700,
  [2102] = 342,
  [2103] = 343,
  [2104] = 345,
  [2105] = 1702,
  [2106] = 361,
  [2107] = 362,
  [2108] = 283,
  [2109] = 308,
  [2110] = 1708,
  [2111] = 1725,
  [2112] = 1947,
  [2113] = 360,
  [2114] = 2040,
  [2115] = 278,
  [2116] = 285,
  [2117] = 287,
  [2118] = 1747,
  [2119] = 1706,
  [2120] = 2120,
  [2121] = 2121,
  [2122] = 2122,
  [2123] = 2123,
  [2124] = 2124,
  [2125] = 2125,
  [2126] = 2126,
  [2127] = 2127,
  [2128] = 2128,
  [2129] = 1646,
  [2130] = 2124,
  [2131] = 1965,
  [2132] = 2124,
  [2133] = 2124,
  [2134] = 1636,
  [2135] = 2135,
  [2136] = 2136,
  [2137] = 1704,
  [2138] = 2138,
  [2139] = 2139,
  [2140] = 1648,
  [2141] = 1636,
  [2142] = 2142,
  [2143] = 2143,
  [2144] = 2124,
  [2145] = 1787,
  [2146] = 1544,
  [2147] = 2147,
  [2148] = 2148,
  [2149] = 1656,
  [2150] = 2150,
  [2151] = 2151,
  [2152] = 2124,
  [2153] = 1709,
  [2154] = 1554,
  [2155] = 1555,
  [2156] = 1733,
  [2157] = 2157,
  [2158] = 1766,
  [2159] = 2159,
  [2160] = 1755,
  [2161] = 1808,
  [2162] = 1808,
  [2163] = 2163,
  [2164] = 2142,
  [2165] = 1636,
  [2166] = 1880,
  [2167] = 1704,
  [2168] = 1706,
  [2169] = 1896,
  [2170] = 1815,
  [2171] = 1901,
  [2172] = 1787,
  [2173] = 1869,
  [2174] = 1897,
  [2175] = 1887,
  [2176] = 1867,
  [2177] = 1873,
  [2178] = 1884,
  [2179] = 1849,
  [2180] = 1890,
  [2181] = 1772,
  [2182] = 2182,
  [2183] = 1837,
  [2184] = 1870,
  [2185] = 1872,
  [2186] = 2186,
  [2187] = 2187,
  [2188] = 1848,
  [2189] = 2189,
  [2190] = 2190,
  [2191] = 2191,
  [2192] = 133,
  [2193] = 132,
  [2194] = 1851,
  [2195] = 1816,
  [2196] = 1976,
  [2197] = 2197,
  [2198] = 1507,
  [2199] = 1822,
  [2200] = 2200,
  [2201] = 1797,
  [2202] = 1799,
  [2203] = 1844,
  [2204] = 2204,
  [2205] = 2205,
  [2206] = 1803,
  [2207] = 1766,
  [2208] = 1800,
  [2209] = 1552,
  [2210] = 1838,
  [2211] = 1860,
  [2212] = 1840,
  [2213] = 2213,
  [2214] = 1500,
  [2215] = 1504,
  [2216] = 1502,
  [2217] = 1503,
  [2218] = 2218,
  [2219] = 1505,
  [2220] = 1506,
  [2221] = 2221,
  [2222] = 1728,
  [2223] = 2223,
  [2224] = 2224,
  [2225] = 1834,
  [2226] = 1798,
  [2227] = 1802,
  [2228] = 1805,
  [2229] = 1806,
  [2230] = 1807,
  [2231] = 1809,
  [2232] = 1817,
  [2233] = 1836,
  [2234] = 1819,
  [2235] = 1796,
  [2236] = 1823,
  [2237] = 1636,
  [2238] = 2238,
  [2239] = 1852,
  [2240] = 1648,
  [2241] = 1962,
  [2242] = 1826,
  [2243] = 1900,
  [2244] = 1735,
  [2245] = 1842,
  [2246] = 1636,
  [2247] = 1824,
  [2248] = 1656,
  [2249] = 1544,
  [2250] = 1769,
  [2251] = 1812,
  [2252] = 2252,
  [2253] = 2253,
  [2254] = 1553,
  [2255] = 2255,
  [2256] = 1804,
  [2257] = 1646,
  [2258] = 2258,
  [2259] = 1636,
  [2260] = 1845,
  [2261] = 1810,
  [2262] = 1814,
  [2263] = 1841,
  [2264] = 1846,
  [2265] = 1847,
  [2266] = 1501,
  [2267] = 1896,
  [2268] = 2268,
  [2269] = 1554,
  [2270] = 1728,
  [2271] = 1769,
  [2272] = 1863,
  [2273] = 2139,
  [2274] = 1897,
  [2275] = 1887,
  [2276] = 1867,
  [2277] = 1873,
  [2278] = 1884,
  [2279] = 2279,
  [2280] = 2280,
  [2281] = 1772,
  [2282] = 1870,
  [2283] = 2122,
  [2284] = 1890,
  [2285] = 2143,
  [2286] = 1854,
  [2287] = 1867,
  [2288] = 2138,
  [2289] = 1872,
  [2290] = 2120,
  [2291] = 1870,
  [2292] = 1872,
  [2293] = 2293,
  [2294] = 2123,
  [2295] = 2147,
  [2296] = 1893,
  [2297] = 1873,
  [2298] = 1887,
  [2299] = 1890,
  [2300] = 1508,
  [2301] = 1884,
  [2302] = 2302,
  [2303] = 1880,
  [2304] = 1893,
  [2305] = 1896,
  [2306] = 1880,
  [2307] = 1724,
  [2308] = 1555,
  [2309] = 2148,
  [2310] = 1900,
  [2311] = 2126,
  [2312] = 1901,
  [2313] = 2127,
  [2314] = 1869,
  [2315] = 1897,
  [2316] = 1901,
  [2317] = 1869,
  [2318] = 2150,
  [2319] = 2151,
  [2320] = 2320,
  [2321] = 1735,
  [2322] = 1724,
  [2323] = 2323,
  [2324] = 2324,
  [2325] = 2325,
  [2326] = 1656,
  [2327] = 2327,
  [2328] = 2328,
  [2329] = 1965,
  [2330] = 2330,
  [2331] = 2331,
  [2332] = 2332,
  [2333] = 2333,
  [2334] = 1769,
  [2335] = 2335,
  [2336] = 1755,
  [2337] = 1893,
  [2338] = 1769,
  [2339] = 1566,
  [2340] = 1648,
  [2341] = 2341,
  [2342] = 2342,
  [2343] = 1735,
  [2344] = 2344,
  [2345] = 2345,
  [2346] = 1728,
  [2347] = 2347,
  [2348] = 2348,
  [2349] = 2349,
  [2350] = 794,
  [2351] = 2351,
  [2352] = 2352,
  [2353] = 1728,
  [2354] = 1735,
  [2355] = 1772,
  [2356] = 1733,
  [2357] = 2357,
  [2358] = 2358,
  [2359] = 2359,
  [2360] = 2360,
  [2361] = 2361,
  [2362] = 793,
  [2363] = 1900,
  [2364] = 2364,
  [2365] = 1709,
  [2366] = 1646,
  [2367] = 1772,
  [2368] = 2368,
  [2369] = 2369,
  [2370] = 2370,
  [2371] = 2371,
  [2372] = 2372,
  [2373] = 2373,
  [2374] = 1596,
  [2375] = 1836,
  [2376] = 1735,
  [2377] = 1597,
  [2378] = 1824,
  [2379] = 2268,
  [2380] = 2380,
  [2381] = 2381,
  [2382] = 2382,
  [2383] = 1810,
  [2384] = 1728,
  [2385] = 1735,
  [2386] = 2386,
  [2387] = 2387,
  [2388] = 2388,
  [2389] = 1769,
  [2390] = 1845,
  [2391] = 1592,
  [2392] = 2392,
  [2393] = 2393,
  [2394] = 1606,
  [2395] = 1600,
  [2396] = 2191,
  [2397] = 1607,
  [2398] = 2398,
  [2399] = 1848,
  [2400] = 1769,
  [2401] = 1851,
  [2402] = 1772,
  [2403] = 2403,
  [2404] = 2404,
  [2405] = 1601,
  [2406] = 1591,
  [2407] = 1602,
  [2408] = 2408,
  [2409] = 2409,
  [2410] = 2410,
  [2411] = 1841,
  [2412] = 1846,
  [2413] = 2413,
  [2414] = 2414,
  [2415] = 1847,
  [2416] = 1849,
  [2417] = 2417,
  [2418] = 1798,
  [2419] = 1802,
  [2420] = 1805,
  [2421] = 1844,
  [2422] = 1965,
  [2423] = 1804,
  [2424] = 2218,
  [2425] = 2425,
  [2426] = 133,
  [2427] = 1806,
  [2428] = 1807,
  [2429] = 1822,
  [2430] = 1809,
  [2431] = 2431,
  [2432] = 2320,
  [2433] = 2433,
  [2434] = 2434,
  [2435] = 2435,
  [2436] = 2436,
  [2437] = 132,
  [2438] = 2438,
  [2439] = 1598,
  [2440] = 1797,
  [2441] = 2441,
  [2442] = 1803,
  [2443] = 2443,
  [2444] = 1599,
  [2445] = 1605,
  [2446] = 2446,
  [2447] = 1799,
  [2448] = 1800,
  [2449] = 1812,
  [2450] = 2450,
  [2451] = 2451,
  [2452] = 1772,
  [2453] = 2453,
  [2454] = 1837,
  [2455] = 1816,
  [2456] = 1842,
  [2457] = 2457,
  [2458] = 2458,
  [2459] = 2459,
  [2460] = 1819,
  [2461] = 1796,
  [2462] = 1823,
  [2463] = 1817,
  [2464] = 1838,
  [2465] = 2465,
  [2466] = 1852,
  [2467] = 2467,
  [2468] = 1826,
  [2469] = 2469,
  [2470] = 2470,
  [2471] = 1728,
  [2472] = 1814,
  [2473] = 2473,
  [2474] = 1724,
  [2475] = 2475,
  [2476] = 2476,
  [2477] = 1815,
  [2478] = 2478,
  [2479] = 2479,
  [2480] = 2480,
  [2481] = 2481,
  [2482] = 2482,
  [2483] = 2483,
  [2484] = 1724,
  [2485] = 2485,
  [2486] = 2486,
  [2487] = 1593,
  [2488] = 2488,
  [2489] = 1594,
  [2490] = 1595,
  [2491] = 1965,
  [2492] = 1840,
  [2493] = 2493,
  [2494] = 1900,
  [2495] = 1570,
  [2496] = 1505,
  [2497] = 1962,
  [2498] = 1506,
  [2499] = 1859,
  [2500] = 1500,
  [2501] = 2501,
  [2502] = 1976,
  [2503] = 1769,
  [2504] = 1857,
  [2505] = 1772,
  [2506] = 1897,
  [2507] = 1887,
  [2508] = 1867,
  [2509] = 1873,
  [2510] = 1884,
  [2511] = 2511,
  [2512] = 2512,
  [2513] = 1890,
  [2514] = 1880,
  [2515] = 1501,
  [2516] = 1504,
  [2517] = 1704,
  [2518] = 2518,
  [2519] = 2519,
  [2520] = 1901,
  [2521] = 1706,
  [2522] = 1869,
  [2523] = 1502,
  [2524] = 1503,
  [2525] = 1787,
  [2526] = 1566,
  [2527] = 1896,
  [2528] = 1870,
  [2529] = 1728,
  [2530] = 1735,
  [2531] = 1872,
  [2532] = 1766,
  [2533] = 2142,
  [2534] = 2534,
  [2535] = 1502,
  [2536] = 2122,
  [2537] = 1506,
  [2538] = 1724,
  [2539] = 2147,
  [2540] = 2148,
  [2541] = 2150,
  [2542] = 2138,
  [2543] = 2151,
  [2544] = 1706,
  [2545] = 1880,
  [2546] = 2123,
  [2547] = 1648,
  [2548] = 1897,
  [2549] = 2320,
  [2550] = 1887,
  [2551] = 1896,
  [2552] = 1769,
  [2553] = 1787,
  [2554] = 1867,
  [2555] = 2139,
  [2556] = 1873,
  [2557] = 2143,
  [2558] = 2120,
  [2559] = 2268,
  [2560] = 1772,
  [2561] = 1884,
  [2562] = 1766,
  [2563] = 1755,
  [2564] = 1504,
  [2565] = 1503,
  [2566] = 1505,
  [2567] = 2142,
  [2568] = 1880,
  [2569] = 1857,
  [2570] = 1656,
  [2571] = 1857,
  [2572] = 2126,
  [2573] = 1901,
  [2574] = 1544,
  [2575] = 1901,
  [2576] = 1869,
  [2577] = 1869,
  [2578] = 2127,
  [2579] = 1897,
  [2580] = 1887,
  [2581] = 1867,
  [2582] = 1728,
  [2583] = 1890,
  [2584] = 1873,
  [2585] = 1884,
  [2586] = 1709,
  [2587] = 1890,
  [2588] = 1965,
  [2589] = 1870,
  [2590] = 1872,
  [2591] = 1500,
  [2592] = 1733,
  [2593] = 1808,
  [2594] = 1704,
  [2595] = 1870,
  [2596] = 1859,
  [2597] = 1859,
  [2598] = 1646,
  [2599] = 1872,
  [2600] = 1570,
  [2601] = 1735,
  [2602] = 1501,
  [2603] = 1896,
  [2604] = 1570,
  [2605] = 1809,
  [2606] = 1704,
  [2607] = 2320,
  [2608] = 1845,
  [2609] = 1842,
  [2610] = 1808,
  [2611] = 1769,
  [2612] = 2519,
  [2613] = 1819,
  [2614] = 1796,
  [2615] = 1799,
  [2616] = 1800,
  [2617] = 1823,
  [2618] = 1802,
  [2619] = 1841,
  [2620] = 1846,
  [2621] = 2621,
  [2622] = 1847,
  [2623] = 1840,
  [2624] = 2621,
  [2625] = 2518,
  [2626] = 1735,
  [2627] = 1772,
  [2628] = 1852,
  [2629] = 1805,
  [2630] = 1849,
  [2631] = 1812,
  [2632] = 1766,
  [2633] = 2268,
  [2634] = 1848,
  [2635] = 1816,
  [2636] = 1836,
  [2637] = 1804,
  [2638] = 1824,
  [2639] = 1817,
  [2640] = 2519,
  [2641] = 1838,
  [2642] = 1814,
  [2643] = 1851,
  [2644] = 1826,
  [2645] = 1728,
  [2646] = 2621,
  [2647] = 1815,
  [2648] = 1834,
  [2649] = 1860,
  [2650] = 1893,
  [2651] = 1810,
  [2652] = 1844,
  [2653] = 1837,
  [2654] = 1570,
  [2655] = 1834,
  [2656] = 1822,
  [2657] = 1706,
  [2658] = 1798,
  [2659] = 1555,
  [2660] = 1893,
  [2661] = 1803,
  [2662] = 1806,
  [2663] = 1807,
  [2664] = 2518,
  [2665] = 1797,
  [2666] = 2621,
  [2667] = 1554,
  [2668] = 1787,
  [2669] = 1893,
  [2670] = 2142,
  [2671] = 1503,
  [2672] = 1962,
  [2673] = 1869,
  [2674] = 2674,
  [2675] = 2675,
  [2676] = 1500,
  [2677] = 1897,
  [2678] = 1884,
  [2679] = 1570,
  [2680] = 1504,
  [2681] = 2681,
  [2682] = 2682,
  [2683] = 1901,
  [2684] = 1855,
  [2685] = 1704,
  [2686] = 1706,
  [2687] = 1864,
  [2688] = 2688,
  [2689] = 1502,
  [2690] = 1501,
  [2691] = 249,
  [2692] = 1570,
  [2693] = 1766,
  [2694] = 1887,
  [2695] = 1787,
  [2696] = 2696,
  [2697] = 1880,
  [2698] = 1505,
  [2699] = 1506,
  [2700] = 2700,
  [2701] = 2675,
  [2702] = 1859,
  [2703] = 1856,
  [2704] = 2675,
  [2705] = 1870,
  [2706] = 1872,
  [2707] = 1808,
  [2708] = 2675,
  [2709] = 1976,
  [2710] = 1867,
  [2711] = 2675,
  [2712] = 2675,
  [2713] = 1553,
  [2714] = 2675,
  [2715] = 245,
  [2716] = 1857,
  [2717] = 1890,
  [2718] = 1873,
  [2719] = 1853,
  [2720] = 1808,
  [2721] = 1896,
  [2722] = 2139,
  [2723] = 2475,
  [2724] = 2138,
  [2725] = 2123,
  [2726] = 2436,
  [2727] = 2126,
  [2728] = 2127,
  [2729] = 1500,
  [2730] = 1504,
  [2731] = 1502,
  [2732] = 1503,
  [2733] = 1501,
  [2734] = 1505,
  [2735] = 1506,
  [2736] = 1769,
  [2737] = 1856,
  [2738] = 1704,
  [2739] = 1706,
  [2740] = 2120,
  [2741] = 1787,
  [2742] = 1853,
  [2743] = 2743,
  [2744] = 2744,
  [2745] = 1962,
  [2746] = 1772,
  [2747] = 1864,
  [2748] = 2743,
  [2749] = 2749,
  [2750] = 2750,
  [2751] = 2751,
  [2752] = 2752,
  [2753] = 2753,
  [2754] = 2754,
  [2755] = 2755,
  [2756] = 2756,
  [2757] = 2757,
  [2758] = 2758,
  [2759] = 2759,
  [2760] = 2760,
  [2761] = 2761,
  [2762] = 1965,
  [2763] = 1855,
  [2764] = 2744,
  [2765] = 2446,
  [2766] = 2743,
  [2767] = 2744,
  [2768] = 2768,
  [2769] = 2769,
  [2770] = 2743,
  [2771] = 2744,
  [2772] = 2744,
  [2773] = 1766,
  [2774] = 2122,
  [2775] = 2143,
  [2776] = 2320,
  [2777] = 2403,
  [2778] = 2743,
  [2779] = 2744,
  [2780] = 2410,
  [2781] = 2425,
  [2782] = 2398,
  [2783] = 1728,
  [2784] = 2431,
  [2785] = 2743,
  [2786] = 2744,
  [2787] = 2438,
  [2788] = 1860,
  [2789] = 2268,
  [2790] = 2441,
  [2791] = 1962,
  [2792] = 1976,
  [2793] = 2147,
  [2794] = 1735,
  [2795] = 2148,
  [2796] = 2796,
  [2797] = 2797,
  [2798] = 2798,
  [2799] = 1976,
  [2800] = 2150,
  [2801] = 2151,
  [2802] = 2743,
  [2803] = 2803,
  [2804] = 2138,
  [2805] = 2143,
  [2806] = 2519,
  [2807] = 2123,
  [2808] = 2808,
  [2809] = 2126,
  [2810] = 2127,
  [2811] = 1566,
  [2812] = 1798,
  [2813] = 1845,
  [2814] = 1806,
  [2815] = 1808,
  [2816] = 2142,
  [2817] = 2817,
  [2818] = 1819,
  [2819] = 1808,
  [2820] = 2820,
  [2821] = 1822,
  [2822] = 2147,
  [2823] = 1841,
  [2824] = 2148,
  [2825] = 2150,
  [2826] = 2151,
  [2827] = 2518,
  [2828] = 2122,
  [2829] = 2139,
  [2830] = 2120,
  [2831] = 2831,
  [2832] = 1508,
  [2833] = 1893,
  [2834] = 2831,
  [2835] = 2122,
  [2836] = 2759,
  [2837] = 1709,
  [2838] = 2831,
  [2839] = 1859,
  [2840] = 1853,
  [2841] = 2841,
  [2842] = 2842,
  [2843] = 2768,
  [2844] = 2844,
  [2845] = 1733,
  [2846] = 2846,
  [2847] = 2761,
  [2848] = 2796,
  [2849] = 2760,
  [2850] = 2751,
  [2851] = 2752,
  [2852] = 1755,
  [2853] = 2404,
  [2854] = 2120,
  [2855] = 2753,
  [2856] = 2754,
  [2857] = 2755,
  [2858] = 2756,
  [2859] = 2757,
  [2860] = 2797,
  [2861] = 1507,
  [2862] = 2842,
  [2863] = 2844,
  [2864] = 2798,
  [2865] = 2846,
  [2866] = 2128,
  [2867] = 2842,
  [2868] = 2159,
  [2869] = 2844,
  [2870] = 2846,
  [2871] = 1864,
  [2872] = 2831,
  [2873] = 1857,
  [2874] = 2820,
  [2875] = 2139,
  [2876] = 1508,
  [2877] = 2143,
  [2878] = 2844,
  [2879] = 2126,
  [2880] = 2831,
  [2881] = 2846,
  [2882] = 1507,
  [2883] = 1976,
  [2884] = 2844,
  [2885] = 2138,
  [2886] = 2831,
  [2887] = 2842,
  [2888] = 2127,
  [2889] = 2846,
  [2890] = 2808,
  [2891] = 1845,
  [2892] = 1822,
  [2893] = 2841,
  [2894] = 2147,
  [2895] = 2842,
  [2896] = 2758,
  [2897] = 2125,
  [2898] = 2898,
  [2899] = 2842,
  [2900] = 2844,
  [2901] = 2750,
  [2902] = 2148,
  [2903] = 1798,
  [2904] = 2769,
  [2905] = 2844,
  [2906] = 2123,
  [2907] = 1806,
  [2908] = 2898,
  [2909] = 2842,
  [2910] = 1819,
  [2911] = 2831,
  [2912] = 2846,
  [2913] = 2898,
  [2914] = 1962,
  [2915] = 2898,
  [2916] = 2121,
  [2917] = 2898,
  [2918] = 2898,
  [2919] = 1841,
  [2920] = 2150,
  [2921] = 1856,
  [2922] = 2831,
  [2923] = 2841,
  [2924] = 2749,
  [2925] = 2151,
  [2926] = 1855,
  [2927] = 2136,
  [2928] = 2846,
  [2929] = 2898,
  [2930] = 2831,
  [2931] = 2831,
  [2932] = 2932,
  [2933] = 2320,
  [2934] = 2798,
  [2935] = 1733,
  [2936] = 2197,
  [2937] = 1840,
  [2938] = 1724,
  [2939] = 1837,
  [2940] = 2831,
  [2941] = 2120,
  [2942] = 1836,
  [2943] = 1901,
  [2944] = 1846,
  [2945] = 2945,
  [2946] = 1824,
  [2947] = 1847,
  [2948] = 1755,
  [2949] = 1804,
  [2950] = 2148,
  [2951] = 1797,
  [2952] = 2952,
  [2953] = 1869,
  [2954] = 2268,
  [2955] = 1799,
  [2956] = 1800,
  [2957] = 2127,
  [2958] = 2142,
  [2959] = 1842,
  [2960] = 1849,
  [2961] = 1844,
  [2962] = 2512,
  [2963] = 2136,
  [2964] = 2749,
  [2965] = 2150,
  [2966] = 2128,
  [2967] = 1897,
  [2968] = 1887,
  [2969] = 2138,
  [2970] = 2932,
  [2971] = 2190,
  [2972] = 1814,
  [2973] = 2973,
  [2974] = 1867,
  [2975] = 2975,
  [2976] = 1873,
  [2977] = 2750,
  [2978] = 1860,
  [2979] = 2975,
  [2980] = 1802,
  [2981] = 1805,
  [2982] = 2831,
  [2983] = 2121,
  [2984] = 1890,
  [2985] = 2253,
  [2986] = 2932,
  [2987] = 1884,
  [2988] = 1508,
  [2989] = 1807,
  [2990] = 2751,
  [2991] = 2752,
  [2992] = 2753,
  [2993] = 2754,
  [2994] = 2755,
  [2995] = 2756,
  [2996] = 2757,
  [2997] = 1809,
  [2998] = 2831,
  [2999] = 1810,
  [3000] = 1815,
  [3001] = 3001,
  [3002] = 2797,
  [3003] = 1507,
  [3004] = 1803,
  [3005] = 2831,
  [3006] = 2831,
  [3007] = 2125,
  [3008] = 2123,
  [3009] = 2932,
  [3010] = 2204,
  [3011] = 1812,
  [3012] = 2975,
  [3013] = 2151,
  [3014] = 1796,
  [3015] = 1870,
  [3016] = 1872,
  [3017] = 1848,
  [3018] = 2159,
  [3019] = 3001,
  [3020] = 1851,
  [3021] = 2932,
  [3022] = 2126,
  [3023] = 2975,
  [3024] = 1823,
  [3025] = 1880,
  [3026] = 2973,
  [3027] = 3001,
  [3028] = 2768,
  [3029] = 1852,
  [3030] = 2758,
  [3031] = 2122,
  [3032] = 2932,
  [3033] = 2143,
  [3034] = 2255,
  [3035] = 1826,
  [3036] = 3001,
  [3037] = 3037,
  [3038] = 1893,
  [3039] = 2759,
  [3040] = 2213,
  [3041] = 3001,
  [3042] = 2769,
  [3043] = 2760,
  [3044] = 1508,
  [3045] = 3001,
  [3046] = 1834,
  [3047] = 1816,
  [3048] = 1860,
  [3049] = 1552,
  [3050] = 2796,
  [3051] = 3001,
  [3052] = 2761,
  [3053] = 2831,
  [3054] = 3054,
  [3055] = 2831,
  [3056] = 1817,
  [3057] = 2973,
  [3058] = 1900,
  [3059] = 2139,
  [3060] = 1896,
  [3061] = 1838,
  [3062] = 1709,
  [3063] = 2147,
  [3064] = 2831,
  [3065] = 2328,
  [3066] = 1810,
  [3067] = 1859,
  [3068] = 2253,
  [3069] = 2344,
  [3070] = 1648,
  [3071] = 2808,
  [3072] = 1838,
  [3073] = 1840,
  [3074] = 1836,
  [3075] = 2696,
  [3076] = 1824,
  [3077] = 3077,
  [3078] = 1860,
  [3079] = 1841,
  [3080] = 1806,
  [3081] = 1837,
  [3082] = 2293,
  [3083] = 1819,
  [3084] = 1965,
  [3085] = 2351,
  [3086] = 2749,
  [3087] = 2769,
  [3088] = 1848,
  [3089] = 1851,
  [3090] = 2758,
  [3091] = 2803,
  [3092] = 1797,
  [3093] = 1799,
  [3094] = 1800,
  [3095] = 1814,
  [3096] = 1815,
  [3097] = 2213,
  [3098] = 2759,
  [3099] = 2352,
  [3100] = 2347,
  [3101] = 1857,
  [3102] = 2344,
  [3103] = 2750,
  [3104] = 793,
  [3105] = 2190,
  [3106] = 3054,
  [3107] = 1822,
  [3108] = 2760,
  [3109] = 2831,
  [3110] = 1900,
  [3111] = 1802,
  [3112] = 2358,
  [3113] = 2831,
  [3114] = 1845,
  [3115] = 1507,
  [3116] = 1805,
  [3117] = 2344,
  [3118] = 2255,
  [3119] = 1807,
  [3120] = 2344,
  [3121] = 1809,
  [3122] = 1796,
  [3123] = 1823,
  [3124] = 1852,
  [3125] = 2342,
  [3126] = 1826,
  [3127] = 2327,
  [3128] = 2204,
  [3129] = 2796,
  [3130] = 2325,
  [3131] = 1842,
  [3132] = 2751,
  [3133] = 2752,
  [3134] = 2753,
  [3135] = 2754,
  [3136] = 2755,
  [3137] = 1834,
  [3138] = 2756,
  [3139] = 2757,
  [3140] = 2797,
  [3141] = 2798,
  [3142] = 2302,
  [3143] = 2351,
  [3144] = 794,
  [3145] = 2344,
  [3146] = 1846,
  [3147] = 1847,
  [3148] = 1849,
  [3149] = 1812,
  [3150] = 2820,
  [3151] = 1816,
  [3152] = 1817,
  [3153] = 2768,
  [3154] = 3154,
  [3155] = 1844,
  [3156] = 1803,
  [3157] = 2197,
  [3158] = 2280,
  [3159] = 1798,
  [3160] = 1724,
  [3161] = 1656,
  [3162] = 1508,
  [3163] = 2761,
  [3164] = 1804,
  [3165] = 1646,
  [3166] = 2831,
  [3167] = 2465,
  [3168] = 2758,
  [3169] = 2768,
  [3170] = 1600,
  [3171] = 2368,
  [3172] = 1709,
  [3173] = 2808,
  [3174] = 132,
  [3175] = 1591,
  [3176] = 1755,
  [3177] = 1859,
  [3178] = 1606,
  [3179] = 2344,
  [3180] = 794,
  [3181] = 2182,
  [3182] = 3182,
  [3183] = 2189,
  [3184] = 2344,
  [3185] = 3185,
  [3186] = 2831,
  [3187] = 2769,
  [3188] = 1857,
  [3189] = 2796,
  [3190] = 2325,
  [3191] = 2831,
  [3192] = 2163,
  [3193] = 3193,
  [3194] = 2323,
  [3195] = 2751,
  [3196] = 2752,
  [3197] = 2759,
  [3198] = 3193,
  [3199] = 1595,
  [3200] = 2753,
  [3201] = 1593,
  [3202] = 2333,
  [3203] = 2754,
  [3204] = 3193,
  [3205] = 2755,
  [3206] = 2756,
  [3207] = 2344,
  [3208] = 2757,
  [3209] = 2293,
  [3210] = 1596,
  [3211] = 3211,
  [3212] = 2760,
  [3213] = 2797,
  [3214] = 2327,
  [3215] = 3215,
  [3216] = 2403,
  [3217] = 793,
  [3218] = 3218,
  [3219] = 3193,
  [3220] = 2404,
  [3221] = 2831,
  [3222] = 2798,
  [3223] = 2410,
  [3224] = 2252,
  [3225] = 2238,
  [3226] = 2342,
  [3227] = 2186,
  [3228] = 2425,
  [3229] = 3193,
  [3230] = 2431,
  [3231] = 1597,
  [3232] = 2328,
  [3233] = 2831,
  [3234] = 2258,
  [3235] = 2465,
  [3236] = 2749,
  [3237] = 2351,
  [3238] = 3193,
  [3239] = 3193,
  [3240] = 1733,
  [3241] = 2368,
  [3242] = 2511,
  [3243] = 1605,
  [3244] = 2142,
  [3245] = 3215,
  [3246] = 3215,
  [3247] = 2352,
  [3248] = 2347,
  [3249] = 2831,
  [3250] = 1965,
  [3251] = 2438,
  [3252] = 2279,
  [3253] = 1594,
  [3254] = 2820,
  [3255] = 1607,
  [3256] = 2302,
  [3257] = 2320,
  [3258] = 2358,
  [3259] = 2268,
  [3260] = 2280,
  [3261] = 2358,
  [3262] = 2768,
  [3263] = 2352,
  [3264] = 2347,
  [3265] = 2769,
  [3266] = 2327,
  [3267] = 2749,
  [3268] = 2750,
  [3269] = 2796,
  [3270] = 2325,
  [3271] = 2751,
  [3272] = 2752,
  [3273] = 2753,
  [3274] = 2754,
  [3275] = 2755,
  [3276] = 2756,
  [3277] = 2757,
  [3278] = 2797,
  [3279] = 2798,
  [3280] = 2328,
  [3281] = 2761,
  [3282] = 2758,
  [3283] = 2759,
  [3284] = 2760,
  [3285] = 2761,
  [3286] = 2404,
  [3287] = 2372,
  [3288] = 1592,
  [3289] = 133,
  [3290] = 2441,
  [3291] = 2345,
  [3292] = 3292,
  [3293] = 2342,
  [3294] = 2750,
  [3295] = 2187,
  [3296] = 1508,
  [3297] = 2348,
  [3298] = 3182,
  [3299] = 3299,
  [3300] = 1598,
  [3301] = 1599,
  [3302] = 3193,
  [3303] = 1601,
  [3304] = 2372,
  [3305] = 3193,
  [3306] = 1602,
  [3307] = 2221,
  [3308] = 2223,
  [3309] = 2224,
  [3310] = 2446,
  [3311] = 2369,
  [3312] = 1772,
  [3313] = 2820,
  [3314] = 1897,
  [3315] = 1887,
  [3316] = 1867,
  [3317] = 1873,
  [3318] = 1884,
  [3319] = 2368,
  [3320] = 1890,
  [3321] = 1870,
  [3322] = 1872,
  [3323] = 2344,
  [3324] = 2459,
  [3325] = 2483,
  [3326] = 2480,
  [3327] = 2481,
  [3328] = 2482,
  [3329] = 132,
  [3330] = 1646,
  [3331] = 2467,
  [3332] = 2469,
  [3333] = 2204,
  [3334] = 2373,
  [3335] = 1846,
  [3336] = 1847,
  [3337] = 1849,
  [3338] = 1812,
  [3339] = 2478,
  [3340] = 1816,
  [3341] = 1817,
  [3342] = 2253,
  [3343] = 2409,
  [3344] = 1507,
  [3345] = 1769,
  [3346] = 2323,
  [3347] = 3347,
  [3348] = 3348,
  [3349] = 1728,
  [3350] = 2435,
  [3351] = 1596,
  [3352] = 1597,
  [3353] = 2371,
  [3354] = 2436,
  [3355] = 2485,
  [3356] = 2831,
  [3357] = 2408,
  [3358] = 2476,
  [3359] = 1598,
  [3360] = 1599,
  [3361] = 1844,
  [3362] = 1803,
  [3363] = 2486,
  [3364] = 2344,
  [3365] = 2182,
  [3366] = 2333,
  [3367] = 2189,
  [3368] = 2473,
  [3369] = 2479,
  [3370] = 1900,
  [3371] = 2370,
  [3372] = 2446,
  [3373] = 2831,
  [3374] = 2808,
  [3375] = 2348,
  [3376] = 1848,
  [3377] = 2398,
  [3378] = 2470,
  [3379] = 2388,
  [3380] = 2345,
  [3381] = 2380,
  [3382] = 1851,
  [3383] = 2386,
  [3384] = 2387,
  [3385] = 794,
  [3386] = 2213,
  [3387] = 2142,
  [3388] = 2238,
  [3389] = 2381,
  [3390] = 1592,
  [3391] = 2392,
  [3392] = 2186,
  [3393] = 2393,
  [3394] = 2252,
  [3395] = 1606,
  [3396] = 1600,
  [3397] = 2191,
  [3398] = 1607,
  [3399] = 2488,
  [3400] = 1802,
  [3401] = 1805,
  [3402] = 1797,
  [3403] = 1799,
  [3404] = 2258,
  [3405] = 1800,
  [3406] = 2221,
  [3407] = 2458,
  [3408] = 2331,
  [3409] = 2359,
  [3410] = 2324,
  [3411] = 2223,
  [3412] = 2453,
  [3413] = 1807,
  [3414] = 2335,
  [3415] = 2224,
  [3416] = 1601,
  [3417] = 1602,
  [3418] = 2457,
  [3419] = 1809,
  [3420] = 2163,
  [3421] = 2279,
  [3422] = 1796,
  [3423] = 1804,
  [3424] = 1823,
  [3425] = 1810,
  [3426] = 2372,
  [3427] = 1852,
  [3428] = 2404,
  [3429] = 1834,
  [3430] = 2341,
  [3431] = 1826,
  [3432] = 1857,
  [3433] = 1859,
  [3434] = 2831,
  [3435] = 2413,
  [3436] = 2414,
  [3437] = 2187,
  [3438] = 2417,
  [3439] = 1860,
  [3440] = 1648,
  [3441] = 1842,
  [3442] = 1814,
  [3443] = 2404,
  [3444] = 133,
  [3445] = 1838,
  [3446] = 1840,
  [3447] = 1836,
  [3448] = 1824,
  [3449] = 1593,
  [3450] = 2465,
  [3451] = 1594,
  [3452] = 1595,
  [3453] = 1769,
  [3454] = 1656,
  [3455] = 1591,
  [3456] = 2361,
  [3457] = 2190,
  [3458] = 2493,
  [3459] = 2433,
  [3460] = 1544,
  [3461] = 2434,
  [3462] = 1772,
  [3463] = 2218,
  [3464] = 2831,
  [3465] = 3347,
  [3466] = 1962,
  [3467] = 1976,
  [3468] = 1735,
  [3469] = 1837,
  [3470] = 1815,
  [3471] = 3348,
  [3472] = 3347,
  [3473] = 3348,
  [3474] = 2443,
  [3475] = 2403,
  [3476] = 2344,
  [3477] = 2410,
  [3478] = 2425,
  [3479] = 2431,
  [3480] = 2142,
  [3481] = 2438,
  [3482] = 2382,
  [3483] = 1605,
  [3484] = 1880,
  [3485] = 1896,
  [3486] = 2441,
  [3487] = 2351,
  [3488] = 793,
  [3489] = 2475,
  [3490] = 1901,
  [3491] = 2450,
  [3492] = 1869,
  [3493] = 2451,
  [3494] = 2332,
  [3495] = 1500,
  [3496] = 2280,
  [3497] = 2473,
  [3498] = 2761,
  [3499] = 2372,
  [3500] = 3500,
  [3501] = 1502,
  [3502] = 2760,
  [3503] = 2796,
  [3504] = 2325,
  [3505] = 133,
  [3506] = 2479,
  [3507] = 2280,
  [3508] = 2443,
  [3509] = 2369,
  [3510] = 1605,
  [3511] = 2450,
  [3512] = 2451,
  [3513] = 1503,
  [3514] = 2457,
  [3515] = 2751,
  [3516] = 2409,
  [3517] = 2752,
  [3518] = 2480,
  [3519] = 2485,
  [3520] = 1500,
  [3521] = 1504,
  [3522] = 1502,
  [3523] = 2436,
  [3524] = 1503,
  [3525] = 2370,
  [3526] = 1501,
  [3527] = 1505,
  [3528] = 1506,
  [3529] = 1728,
  [3530] = 1735,
  [3531] = 2753,
  [3532] = 2754,
  [3533] = 2755,
  [3534] = 2408,
  [3535] = 2756,
  [3536] = 2470,
  [3537] = 1769,
  [3538] = 2757,
  [3539] = 1772,
  [3540] = 2797,
  [3541] = 2798,
  [3542] = 2749,
  [3543] = 1508,
  [3544] = 2404,
  [3545] = 1606,
  [3546] = 2386,
  [3547] = 2371,
  [3548] = 1607,
  [3549] = 2328,
  [3550] = 2465,
  [3551] = 1501,
  [3552] = 2341,
  [3553] = 132,
  [3554] = 2382,
  [3555] = 3555,
  [3556] = 1598,
  [3557] = 1591,
  [3558] = 1599,
  [3559] = 2191,
  [3560] = 1505,
  [3561] = 2380,
  [3562] = 2392,
  [3563] = 2393,
  [3564] = 2488,
  [3565] = 2388,
  [3566] = 1592,
  [3567] = 2403,
  [3568] = 2410,
  [3569] = 2425,
  [3570] = 2431,
  [3571] = 2438,
  [3572] = 1600,
  [3573] = 2404,
  [3574] = 2441,
  [3575] = 2373,
  [3576] = 2381,
  [3577] = 2361,
  [3578] = 2358,
  [3579] = 2493,
  [3580] = 2768,
  [3581] = 2404,
  [3582] = 2803,
  [3583] = 3583,
  [3584] = 1593,
  [3585] = 1594,
  [3586] = 1766,
  [3587] = 1595,
  [3588] = 2475,
  [3589] = 2332,
  [3590] = 2387,
  [3591] = 2331,
  [3592] = 2758,
  [3593] = 2398,
  [3594] = 2750,
  [3595] = 2483,
  [3596] = 1601,
  [3597] = 1602,
  [3598] = 2359,
  [3599] = 2352,
  [3600] = 2347,
  [3601] = 2320,
  [3602] = 3602,
  [3603] = 2769,
  [3604] = 2478,
  [3605] = 2476,
  [3606] = 2433,
  [3607] = 2434,
  [3608] = 2327,
  [3609] = 2122,
  [3610] = 2453,
  [3611] = 2143,
  [3612] = 1704,
  [3613] = 2138,
  [3614] = 2435,
  [3615] = 2123,
  [3616] = 2126,
  [3617] = 2127,
  [3618] = 2147,
  [3619] = 2148,
  [3620] = 2150,
  [3621] = 2151,
  [3622] = 2139,
  [3623] = 2120,
  [3624] = 1706,
  [3625] = 2268,
  [3626] = 2335,
  [3627] = 1596,
  [3628] = 1597,
  [3629] = 3629,
  [3630] = 1504,
  [3631] = 2759,
  [3632] = 2344,
  [3633] = 2458,
  [3634] = 2459,
  [3635] = 2467,
  [3636] = 2469,
  [3637] = 2481,
  [3638] = 2482,
  [3639] = 2486,
  [3640] = 1787,
  [3641] = 2413,
  [3642] = 1506,
  [3643] = 1508,
  [3644] = 2414,
  [3645] = 2218,
  [3646] = 2368,
  [3647] = 2417,
  [3648] = 2324,
  [3649] = 2404,
  [3650] = 2446,
  [3651] = 2945,
  [3652] = 3652,
  [3653] = 2327,
  [3654] = 2370,
  [3655] = 2328,
  [3656] = 1508,
  [3657] = 3657,
  [3658] = 2820,
  [3659] = 2333,
  [3660] = 3657,
  [3661] = 1772,
  [3662] = 1900,
  [3663] = 3663,
  [3664] = 2808,
  [3665] = 3665,
  [3666] = 3657,
  [3667] = 3665,
  [3668] = 3668,
  [3669] = 3669,
  [3670] = 2952,
  [3671] = 3657,
  [3672] = 3657,
  [3673] = 3657,
  [3674] = 2417,
  [3675] = 2325,
  [3676] = 3657,
  [3677] = 3657,
  [3678] = 3657,
  [3679] = 2483,
  [3680] = 3663,
  [3681] = 3665,
  [3682] = 3657,
  [3683] = 3668,
  [3684] = 3657,
  [3685] = 3663,
  [3686] = 3665,
  [3687] = 3657,
  [3688] = 3668,
  [3689] = 3657,
  [3690] = 3657,
  [3691] = 3663,
  [3692] = 3668,
  [3693] = 3665,
  [3694] = 3668,
  [3695] = 3663,
  [3696] = 1859,
  [3697] = 1808,
  [3698] = 3665,
  [3699] = 2352,
  [3700] = 3668,
  [3701] = 3665,
  [3702] = 2451,
  [3703] = 3668,
  [3704] = 3665,
  [3705] = 3668,
  [3706] = 2358,
  [3707] = 3707,
  [3708] = 3668,
  [3709] = 3709,
  [3710] = 3652,
  [3711] = 1728,
  [3712] = 3347,
  [3713] = 1769,
  [3714] = 1735,
  [3715] = 3348,
  [3716] = 2333,
  [3717] = 3717,
  [3718] = 3718,
  [3719] = 3657,
  [3720] = 3720,
  [3721] = 3721,
  [3722] = 3709,
  [3723] = 3652,
  [3724] = 3724,
  [3725] = 3709,
  [3726] = 3709,
  [3727] = 2347,
  [3728] = 3652,
  [3729] = 3709,
  [3730] = 3652,
  [3731] = 3709,
  [3732] = 3652,
  [3733] = 3709,
  [3734] = 3652,
  [3735] = 3709,
  [3736] = 3652,
  [3737] = 3709,
  [3738] = 3652,
  [3739] = 3669,
  [3740] = 3707,
  [3741] = 3707,
  [3742] = 1893,
  [3743] = 3743,
  [3744] = 1540,
  [3745] = 3663,
  [3746] = 1857,
  [3747] = 3657,
  [3748] = 3669,
  [3749] = 3707,
  [3750] = 3669,
  [3751] = 3707,
  [3752] = 3669,
  [3753] = 3707,
  [3754] = 3669,
  [3755] = 3665,
  [3756] = 2413,
  [3757] = 2387,
  [3758] = 3758,
  [3759] = 2457,
  [3760] = 2473,
  [3761] = 2436,
  [3762] = 2433,
  [3763] = 2467,
  [3764] = 2434,
  [3765] = 1864,
  [3766] = 3758,
  [3767] = 2486,
  [3768] = 3758,
  [3769] = 2370,
  [3770] = 3758,
  [3771] = 2469,
  [3772] = 2488,
  [3773] = 2457,
  [3774] = 1769,
  [3775] = 2371,
  [3776] = 2473,
  [3777] = 2451,
  [3778] = 2450,
  [3779] = 1593,
  [3780] = 2458,
  [3781] = 3758,
  [3782] = 2218,
  [3783] = 2459,
  [3784] = 2480,
  [3785] = 2443,
  [3786] = 1772,
  [3787] = 2481,
  [3788] = 2482,
  [3789] = 2485,
  [3790] = 2486,
  [3791] = 1596,
  [3792] = 1965,
  [3793] = 2371,
  [3794] = 1855,
  [3795] = 2392,
  [3796] = 2393,
  [3797] = 2479,
  [3798] = 3758,
  [3799] = 1976,
  [3800] = 132,
  [3801] = 2467,
  [3802] = 1606,
  [3803] = 3758,
  [3804] = 2458,
  [3805] = 1605,
  [3806] = 1853,
  [3807] = 1600,
  [3808] = 2387,
  [3809] = 3758,
  [3810] = 2469,
  [3811] = 3758,
  [3812] = 1591,
  [3813] = 1597,
  [3814] = 2459,
  [3815] = 2413,
  [3816] = 2483,
  [3817] = 1598,
  [3818] = 1599,
  [3819] = 1595,
  [3820] = 3348,
  [3821] = 2414,
  [3822] = 2408,
  [3823] = 2191,
  [3824] = 1607,
  [3825] = 2480,
  [3826] = 2485,
  [3827] = 2470,
  [3828] = 2488,
  [3829] = 2481,
  [3830] = 2388,
  [3831] = 3831,
  [3832] = 2450,
  [3833] = 2435,
  [3834] = 2443,
  [3835] = 2417,
  [3836] = 2434,
  [3837] = 2386,
  [3838] = 2479,
  [3839] = 2408,
  [3840] = 2470,
  [3841] = 2475,
  [3842] = 2478,
  [3843] = 1592,
  [3844] = 2803,
  [3845] = 3758,
  [3846] = 2320,
  [3847] = 2268,
  [3848] = 1594,
  [3849] = 1507,
  [3850] = 2482,
  [3851] = 3218,
  [3852] = 3758,
  [3853] = 1728,
  [3854] = 3758,
  [3855] = 3758,
  [3856] = 3758,
  [3857] = 133,
  [3858] = 1735,
  [3859] = 2414,
  [3860] = 3758,
  [3861] = 2388,
  [3862] = 3758,
  [3863] = 2493,
  [3864] = 2433,
  [3865] = 2393,
  [3866] = 3348,
  [3867] = 3758,
  [3868] = 1601,
  [3869] = 1602,
  [3870] = 2478,
  [3871] = 2493,
  [3872] = 1856,
  [3873] = 2435,
  [3874] = 2386,
  [3875] = 1962,
  [3876] = 3758,
  [3877] = 3347,
  [3878] = 2398,
  [3879] = 3347,
  [3880] = 2392,
  [3881] = 3347,
  [3882] = 2127,
  [3883] = 2268,
  [3884] = 3884,
  [3885] = 3884,
  [3886] = 3886,
  [3887] = 3887,
  [3888] = 3886,
  [3889] = 2148,
  [3890] = 3886,
  [3891] = 3886,
  [3892] = 3892,
  [3893] = 3886,
  [3894] = 1772,
  [3895] = 3892,
  [3896] = 1735,
  [3897] = 3884,
  [3898] = 3884,
  [3899] = 3887,
  [3900] = 3884,
  [3901] = 1855,
  [3902] = 1769,
  [3903] = 3348,
  [3904] = 1555,
  [3905] = 1853,
  [3906] = 2120,
  [3907] = 2122,
  [3908] = 2143,
  [3909] = 1554,
  [3910] = 3887,
  [3911] = 2139,
  [3912] = 3887,
  [3913] = 1508,
  [3914] = 3887,
  [3915] = 1728,
  [3916] = 3887,
  [3917] = 2147,
  [3918] = 1864,
  [3919] = 2151,
  [3920] = 2138,
  [3921] = 1724,
  [3922] = 1856,
  [3923] = 3884,
  [3924] = 2150,
  [3925] = 2123,
  [3926] = 3884,
  [3927] = 3886,
  [3928] = 2320,
  [3929] = 3887,
  [3930] = 2126,
  [3931] = 3886,
  [3932] = 3932,
  [3933] = 3348,
  [3934] = 1552,
  [3935] = 3347,
  [3936] = 3348,
  [3937] = 3348,
  [3938] = 1798,
  [3939] = 1859,
  [3940] = 3940,
  [3941] = 2142,
  [3942] = 1806,
  [3943] = 1845,
  [3944] = 2253,
  [3945] = 3932,
  [3946] = 1553,
  [3947] = 3947,
  [3948] = 3348,
  [3949] = 2142,
  [3950] = 1819,
  [3951] = 2204,
  [3952] = 1857,
  [3953] = 3932,
  [3954] = 2213,
  [3955] = 2190,
  [3956] = 1822,
  [3957] = 3940,
  [3958] = 3940,
  [3959] = 3347,
  [3960] = 1841,
  [3961] = 3347,
  [3962] = 3347,
  [3963] = 3963,
  [3964] = 3963,
  [3965] = 2357,
  [3966] = 3963,
  [3967] = 3967,
  [3968] = 3967,
  [3969] = 3347,
  [3970] = 1709,
  [3971] = 3963,
  [3972] = 2364,
  [3973] = 3348,
  [3974] = 3974,
  [3975] = 3963,
  [3976] = 3967,
  [3977] = 3974,
  [3978] = 3963,
  [3979] = 3967,
  [3980] = 1857,
  [3981] = 2320,
  [3982] = 2268,
  [3983] = 3974,
  [3984] = 3984,
  [3985] = 3984,
  [3986] = 3984,
  [3987] = 3347,
  [3988] = 1507,
  [3989] = 3348,
  [3990] = 1755,
  [3991] = 1733,
  [3992] = 3984,
  [3993] = 3984,
  [3994] = 3967,
  [3995] = 3974,
  [3996] = 1965,
  [3997] = 3984,
  [3998] = 3720,
  [3999] = 3974,
  [4000] = 3721,
  [4001] = 3974,
  [4002] = 3984,
  [4003] = 1859,
  [4004] = 4004,
  [4005] = 3967,
  [4006] = 2142,
  [4007] = 3967,
  [4008] = 3974,
  [4009] = 3963,
  [4010] = 1823,
  [4011] = 1810,
  [4012] = 1566,
  [4013] = 1856,
  [4014] = 1853,
  [4015] = 3347,
  [4016] = 1842,
  [4017] = 3348,
  [4018] = 1513,
  [4019] = 2268,
  [4020] = 1807,
  [4021] = 1796,
  [4022] = 1838,
  [4023] = 1840,
  [4024] = 1836,
  [4025] = 1824,
  [4026] = 1849,
  [4027] = 1554,
  [4028] = 1855,
  [4029] = 1805,
  [4030] = 1864,
  [4031] = 241,
  [4032] = 1809,
  [4033] = 2320,
  [4034] = 1804,
  [4035] = 251,
  [4036] = 1852,
  [4037] = 1846,
  [4038] = 272,
  [4039] = 1826,
  [4040] = 1816,
  [4041] = 1555,
  [4042] = 3932,
  [4043] = 1544,
  [4044] = 250,
  [4045] = 1848,
  [4046] = 1802,
  [4047] = 1815,
  [4048] = 3947,
  [4049] = 1851,
  [4050] = 1812,
  [4051] = 1844,
  [4052] = 3940,
  [4053] = 1817,
  [4054] = 1803,
  [4055] = 261,
  [4056] = 1797,
  [4057] = 1847,
  [4058] = 1799,
  [4059] = 1800,
  [4060] = 281,
  [4061] = 1814,
  [4062] = 1837,
  [4063] = 2752,
  [4064] = 2757,
  [4065] = 4065,
  [4066] = 4066,
  [4067] = 1855,
  [4068] = 3932,
  [4069] = 2190,
  [4070] = 1507,
  [4071] = 3348,
  [4072] = 1540,
  [4073] = 2398,
  [4074] = 4074,
  [4075] = 4075,
  [4076] = 2797,
  [4077] = 3932,
  [4078] = 4065,
  [4079] = 4079,
  [4080] = 4080,
  [4081] = 2436,
  [4082] = 2760,
  [4083] = 2798,
  [4084] = 4084,
  [4085] = 3940,
  [4086] = 2749,
  [4087] = 2768,
  [4088] = 1856,
  [4089] = 4066,
  [4090] = 2759,
  [4091] = 4091,
  [4092] = 4075,
  [4093] = 2253,
  [4094] = 1540,
  [4095] = 4095,
  [4096] = 2204,
  [4097] = 4074,
  [4098] = 4095,
  [4099] = 2761,
  [4100] = 4080,
  [4101] = 2751,
  [4102] = 2769,
  [4103] = 2213,
  [4104] = 3347,
  [4105] = 2758,
  [4106] = 2754,
  [4107] = 3348,
  [4108] = 4091,
  [4109] = 4075,
  [4110] = 4095,
  [4111] = 2753,
  [4112] = 4112,
  [4113] = 4079,
  [4114] = 3940,
  [4115] = 2755,
  [4116] = 2475,
  [4117] = 2750,
  [4118] = 3347,
  [4119] = 2796,
  [4120] = 2756,
  [4121] = 1864,
  [4122] = 1853,
  [4123] = 4091,
  [4124] = 4074,
  [4125] = 1872,
  [4126] = 2218,
  [4127] = 2808,
  [4128] = 4128,
  [4129] = 1880,
  [4130] = 1896,
  [4131] = 1901,
  [4132] = 1869,
  [4133] = 1897,
  [4134] = 1887,
  [4135] = 1867,
  [4136] = 1873,
  [4137] = 1884,
  [4138] = 1890,
  [4139] = 1870,
  [4140] = 2820,
  [4141] = 3347,
  [4142] = 1554,
  [4143] = 3348,
  [4144] = 2534,
  [4145] = 1555,
  [4146] = 4128,
  [4147] = 2142,
  [4148] = 1965,
  [4149] = 4149,
  [4150] = 2501,
  [4151] = 4128,
  [4152] = 4152,
  [4153] = 4153,
  [4154] = 2191,
  [4155] = 2511,
  [4156] = 4156,
  [4157] = 3940,
  [4158] = 3347,
  [4159] = 3348,
  [4160] = 2320,
  [4161] = 2268,
  [4162] = 4162,
  [4163] = 3932,
  [4164] = 1893,
  [4165] = 1599,
  [4166] = 1598,
  [4167] = 1554,
  [4168] = 2808,
  [4169] = 1606,
  [4170] = 1600,
  [4171] = 1607,
  [4172] = 1601,
  [4173] = 1602,
  [4174] = 1605,
  [4175] = 4084,
  [4176] = 1555,
  [4177] = 1724,
  [4178] = 133,
  [4179] = 1566,
  [4180] = 1591,
  [4181] = 3940,
  [4182] = 3932,
  [4183] = 132,
  [4184] = 4084,
  [4185] = 2345,
  [4186] = 4091,
  [4187] = 4074,
  [4188] = 4095,
  [4189] = 3932,
  [4190] = 1592,
  [4191] = 2191,
  [4192] = 1859,
  [4193] = 3940,
  [4194] = 1857,
  [4195] = 1593,
  [4196] = 3932,
  [4197] = 2323,
  [4198] = 3940,
  [4199] = 3932,
  [4200] = 3940,
  [4201] = 1594,
  [4202] = 1595,
  [4203] = 2348,
  [4204] = 1544,
  [4205] = 1597,
  [4206] = 2218,
  [4207] = 1508,
  [4208] = 4208,
  [4209] = 1596,
  [4210] = 2820,
  [4211] = 4075,
  [4212] = 2320,
  [4213] = 2798,
  [4214] = 4214,
  [4215] = 2761,
  [4216] = 4216,
  [4217] = 4149,
  [4218] = 4091,
  [4219] = 2268,
  [4220] = 2796,
  [4221] = 3347,
  [4222] = 4074,
  [4223] = 2142,
  [4224] = 2751,
  [4225] = 2752,
  [4226] = 2749,
  [4227] = 1553,
  [4228] = 1965,
  [4229] = 2750,
  [4230] = 2796,
  [4231] = 2751,
  [4232] = 2752,
  [4233] = 4233,
  [4234] = 2753,
  [4235] = 2758,
  [4236] = 4095,
  [4237] = 3932,
  [4238] = 2754,
  [4239] = 3940,
  [4240] = 3348,
  [4241] = 2756,
  [4242] = 2749,
  [4243] = 2757,
  [4244] = 2797,
  [4245] = 2798,
  [4246] = 4153,
  [4247] = 2768,
  [4248] = 2759,
  [4249] = 2768,
  [4250] = 2769,
  [4251] = 2758,
  [4252] = 2759,
  [4253] = 2760,
  [4254] = 1552,
  [4255] = 2760,
  [4256] = 2753,
  [4257] = 4075,
  [4258] = 4091,
  [4259] = 4074,
  [4260] = 4095,
  [4261] = 2769,
  [4262] = 1553,
  [4263] = 2754,
  [4264] = 2761,
  [4265] = 2755,
  [4266] = 1552,
  [4267] = 4075,
  [4268] = 3940,
  [4269] = 3932,
  [4270] = 2750,
  [4271] = 2756,
  [4272] = 2757,
  [4273] = 2797,
  [4274] = 1834,
  [4275] = 2755,
  [4276] = 4276,
  [4277] = 4277,
  [4278] = 4278,
  [4279] = 2820,
  [4280] = 4280,
  [4281] = 4277,
  [4282] = 4278,
  [4283] = 2204,
  [4284] = 1787,
  [4285] = 4285,
  [4286] = 4276,
  [4287] = 1500,
  [4288] = 1504,
  [4289] = 1502,
  [4290] = 1503,
  [4291] = 1501,
  [4292] = 1505,
  [4293] = 4280,
  [4294] = 4277,
  [4295] = 4278,
  [4296] = 4276,
  [4297] = 1506,
  [4298] = 1724,
  [4299] = 4299,
  [4300] = 4300,
  [4301] = 4280,
  [4302] = 4277,
  [4303] = 4303,
  [4304] = 4278,
  [4305] = 4276,
  [4306] = 1570,
  [4307] = 1566,
  [4308] = 1965,
  [4309] = 4280,
  [4310] = 4278,
  [4311] = 4208,
  [4312] = 4312,
  [4313] = 4095,
  [4314] = 4280,
  [4315] = 4278,
  [4316] = 4278,
  [4317] = 4276,
  [4318] = 4278,
  [4319] = 1962,
  [4320] = 4320,
  [4321] = 4278,
  [4322] = 4278,
  [4323] = 4278,
  [4324] = 4278,
  [4325] = 4278,
  [4326] = 4278,
  [4327] = 1766,
  [4328] = 2213,
  [4329] = 1893,
  [4330] = 4278,
  [4331] = 4277,
  [4332] = 1976,
  [4333] = 1880,
  [4334] = 1704,
  [4335] = 1896,
  [4336] = 1901,
  [4337] = 1869,
  [4338] = 1897,
  [4339] = 4299,
  [4340] = 1887,
  [4341] = 4280,
  [4342] = 4277,
  [4343] = 1867,
  [4344] = 4278,
  [4345] = 2808,
  [4346] = 2190,
  [4347] = 4075,
  [4348] = 4299,
  [4349] = 4349,
  [4350] = 1873,
  [4351] = 3940,
  [4352] = 3932,
  [4353] = 1884,
  [4354] = 1890,
  [4355] = 4276,
  [4356] = 1870,
  [4357] = 4091,
  [4358] = 1872,
  [4359] = 1706,
  [4360] = 4074,
  [4361] = 2253,
  [4362] = 4280,
  [4363] = 4278,
  [4364] = 2749,
  [4365] = 2769,
  [4366] = 2328,
  [4367] = 2327,
  [4368] = 4368,
  [4369] = 4369,
  [4370] = 1508,
  [4371] = 4371,
  [4372] = 2758,
  [4373] = 4373,
  [4374] = 4374,
  [4375] = 1859,
  [4376] = 4373,
  [4377] = 2759,
  [4378] = 4378,
  [4379] = 2760,
  [4380] = 4371,
  [4381] = 2280,
  [4382] = 2761,
  [4383] = 4383,
  [4384] = 3932,
  [4385] = 1859,
  [4386] = 4386,
  [4387] = 4373,
  [4388] = 4374,
  [4389] = 4075,
  [4390] = 4371,
  [4391] = 4091,
  [4392] = 4074,
  [4393] = 4095,
  [4394] = 1857,
  [4395] = 4395,
  [4396] = 2320,
  [4397] = 4397,
  [4398] = 4374,
  [4399] = 4373,
  [4400] = 4400,
  [4401] = 4401,
  [4402] = 4374,
  [4403] = 4075,
  [4404] = 4404,
  [4405] = 4371,
  [4406] = 4091,
  [4407] = 4074,
  [4408] = 2268,
  [4409] = 4095,
  [4410] = 1566,
  [4411] = 4373,
  [4412] = 4374,
  [4413] = 2749,
  [4414] = 4075,
  [4415] = 1808,
  [4416] = 4371,
  [4417] = 4091,
  [4418] = 4074,
  [4419] = 4095,
  [4420] = 4420,
  [4421] = 4373,
  [4422] = 4075,
  [4423] = 4423,
  [4424] = 4371,
  [4425] = 4091,
  [4426] = 4074,
  [4427] = 2122,
  [4428] = 4095,
  [4429] = 2143,
  [4430] = 2750,
  [4431] = 1733,
  [4432] = 4432,
  [4433] = 4371,
  [4434] = 4371,
  [4435] = 4435,
  [4436] = 3940,
  [4437] = 2138,
  [4438] = 2123,
  [4439] = 2126,
  [4440] = 2127,
  [4441] = 4383,
  [4442] = 4395,
  [4443] = 2358,
  [4444] = 2768,
  [4445] = 2749,
  [4446] = 2750,
  [4447] = 4404,
  [4448] = 2796,
  [4449] = 2751,
  [4450] = 2752,
  [4451] = 2753,
  [4452] = 2754,
  [4453] = 2755,
  [4454] = 2756,
  [4455] = 2757,
  [4456] = 2347,
  [4457] = 4371,
  [4458] = 2798,
  [4459] = 4303,
  [4460] = 2758,
  [4461] = 2759,
  [4462] = 2760,
  [4463] = 2761,
  [4464] = 2147,
  [4465] = 2148,
  [4466] = 4466,
  [4467] = 2150,
  [4468] = 2151,
  [4469] = 3182,
  [4470] = 4470,
  [4471] = 4471,
  [4472] = 2796,
  [4473] = 1857,
  [4474] = 4474,
  [4475] = 4475,
  [4476] = 4404,
  [4477] = 4477,
  [4478] = 4371,
  [4479] = 2139,
  [4480] = 2325,
  [4481] = 2751,
  [4482] = 2120,
  [4483] = 4112,
  [4484] = 2752,
  [4485] = 4404,
  [4486] = 4404,
  [4487] = 4404,
  [4488] = 2753,
  [4489] = 2142,
  [4490] = 4404,
  [4491] = 2754,
  [4492] = 2755,
  [4493] = 2756,
  [4494] = 2768,
  [4495] = 2769,
  [4496] = 2325,
  [4497] = 4371,
  [4498] = 2328,
  [4499] = 2757,
  [4500] = 2797,
  [4501] = 4501,
  [4502] = 2798,
  [4503] = 1724,
  [4504] = 4504,
  [4505] = 4505,
  [4506] = 4506,
  [4507] = 2750,
  [4508] = 2796,
  [4509] = 2751,
  [4510] = 2752,
  [4511] = 2753,
  [4512] = 2754,
  [4513] = 2755,
  [4514] = 2756,
  [4515] = 2757,
  [4516] = 2797,
  [4517] = 2798,
  [4518] = 2758,
  [4519] = 2759,
  [4520] = 2760,
  [4521] = 2761,
  [4522] = 2768,
  [4523] = 2769,
  [4524] = 4084,
  [4525] = 4525,
  [4526] = 4432,
  [4527] = 2358,
  [4528] = 2352,
  [4529] = 2347,
  [4530] = 2327,
  [4531] = 4531,
  [4532] = 4371,
  [4533] = 2352,
  [4534] = 4371,
  [4535] = 4535,
  [4536] = 2797,
  [4537] = 4537,
  [4538] = 4538,
  [4539] = 4539,
  [4540] = 4540,
  [4541] = 4541,
  [4542] = 4542,
  [4543] = 4543,
  [4544] = 4537,
  [4545] = 4545,
  [4546] = 4546,
  [4547] = 4547,
  [4548] = 4548,
  [4549] = 4541,
  [4550] = 4548,
  [4551] = 4551,
  [4552] = 4552,
  [4553] = 4553,
  [4554] = 4540,
  [4555] = 4539,
  [4556] = 4540,
  [4557] = 4557,
  [4558] = 4541,
  [4559] = 3940,
  [4560] = 4543,
  [4561] = 4537,
  [4562] = 3932,
  [4563] = 4545,
  [4564] = 4546,
  [4565] = 4547,
  [4566] = 4566,
  [4567] = 4542,
  [4568] = 4548,
  [4569] = 4551,
  [4570] = 4552,
  [4571] = 4553,
  [4572] = 4539,
  [4573] = 4573,
  [4574] = 4540,
  [4575] = 4543,
  [4576] = 4576,
  [4577] = 4541,
  [4578] = 4548,
  [4579] = 4537,
  [4580] = 4543,
  [4581] = 4537,
  [4582] = 4582,
  [4583] = 4545,
  [4584] = 1804,
  [4585] = 4585,
  [4586] = 1810,
  [4587] = 1859,
  [4588] = 4542,
  [4589] = 4589,
  [4590] = 4590,
  [4591] = 4551,
  [4592] = 4592,
  [4593] = 4539,
  [4594] = 4540,
  [4595] = 4552,
  [4596] = 4541,
  [4597] = 4553,
  [4598] = 4543,
  [4599] = 4545,
  [4600] = 1838,
  [4601] = 1840,
  [4602] = 1836,
  [4603] = 1824,
  [4604] = 4604,
  [4605] = 3940,
  [4606] = 4606,
  [4607] = 4539,
  [4608] = 4576,
  [4609] = 4540,
  [4610] = 1837,
  [4611] = 4576,
  [4612] = 4541,
  [4613] = 4543,
  [4614] = 4545,
  [4615] = 4539,
  [4616] = 4540,
  [4617] = 4617,
  [4618] = 4539,
  [4619] = 3932,
  [4620] = 4540,
  [4621] = 4621,
  [4622] = 1845,
  [4623] = 4539,
  [4624] = 1848,
  [4625] = 1851,
  [4626] = 4539,
  [4627] = 4539,
  [4628] = 1822,
  [4629] = 1797,
  [4630] = 1799,
  [4631] = 4539,
  [4632] = 1800,
  [4633] = 1814,
  [4634] = 1815,
  [4635] = 2820,
  [4636] = 4636,
  [4637] = 2808,
  [4638] = 4638,
  [4639] = 4639,
  [4640] = 4592,
  [4641] = 4641,
  [4642] = 4576,
  [4643] = 4643,
  [4644] = 4545,
  [4645] = 4547,
  [4646] = 4540,
  [4647] = 4647,
  [4648] = 4542,
  [4649] = 4546,
  [4650] = 4541,
  [4651] = 1798,
  [4652] = 4576,
  [4653] = 1802,
  [4654] = 4557,
  [4655] = 1805,
  [4656] = 4617,
  [4657] = 4657,
  [4658] = 1806,
  [4659] = 1807,
  [4660] = 1809,
  [4661] = 4542,
  [4662] = 1819,
  [4663] = 4576,
  [4664] = 1796,
  [4665] = 4617,
  [4666] = 1823,
  [4667] = 1852,
  [4668] = 1826,
  [4669] = 4617,
  [4670] = 1842,
  [4671] = 4075,
  [4672] = 4091,
  [4673] = 4074,
  [4674] = 4095,
  [4675] = 4543,
  [4676] = 4537,
  [4677] = 4592,
  [4678] = 4551,
  [4679] = 4639,
  [4680] = 4542,
  [4681] = 1841,
  [4682] = 1846,
  [4683] = 4576,
  [4684] = 1847,
  [4685] = 4641,
  [4686] = 4617,
  [4687] = 1849,
  [4688] = 1812,
  [4689] = 4545,
  [4690] = 4546,
  [4691] = 1816,
  [4692] = 1817,
  [4693] = 4592,
  [4694] = 4592,
  [4695] = 1844,
  [4696] = 1803,
  [4697] = 4617,
  [4698] = 4592,
  [4699] = 4636,
  [4700] = 4592,
  [4701] = 4701,
  [4702] = 4547,
  [4703] = 4552,
  [4704] = 4553,
  [4705] = 2333,
  [4706] = 4617,
  [4707] = 4075,
  [4708] = 4091,
  [4709] = 4074,
  [4710] = 4095,
  [4711] = 4711,
  [4712] = 1857,
  [4713] = 4713,
  [4714] = 4714,
  [4715] = 4715,
  [4716] = 4716,
  [4717] = 4717,
  [4718] = 4542,
  [4719] = 4548,
  [4720] = 4720,
  [4721] = 4721,
  [4722] = 4551,
  [4723] = 4552,
  [4724] = 4553,
  [4725] = 4701,
  [4726] = 4716,
  [4727] = 4716,
  [4728] = 4716,
  [4729] = 4716,
  [4730] = 4716,
  [4731] = 4539,
  [4732] = 1962,
  [4733] = 2408,
  [4734] = 2392,
  [4735] = 2470,
  [4736] = 2483,
  [4737] = 2393,
  [4738] = 2413,
  [4739] = 2218,
  [4740] = 4740,
  [4741] = 2370,
  [4742] = 2488,
  [4743] = 2414,
  [4744] = 2417,
  [4745] = 2435,
  [4746] = 2388,
  [4747] = 4747,
  [4748] = 2191,
  [4749] = 2371,
  [4750] = 2493,
  [4751] = 2433,
  [4752] = 4752,
  [4753] = 2434,
  [4754] = 4636,
  [4755] = 4636,
  [4756] = 4740,
  [4757] = 4740,
  [4758] = 2443,
  [4759] = 2479,
  [4760] = 2478,
  [4761] = 4761,
  [4762] = 1976,
  [4763] = 4740,
  [4764] = 4636,
  [4765] = 4740,
  [4766] = 2386,
  [4767] = 4636,
  [4768] = 4740,
  [4769] = 4740,
  [4770] = 2387,
  [4771] = 2450,
  [4772] = 2451,
  [4773] = 2457,
  [4774] = 2458,
  [4775] = 2459,
  [4776] = 4776,
  [4777] = 2475,
  [4778] = 2467,
  [4779] = 2469,
  [4780] = 2480,
  [4781] = 4075,
  [4782] = 4091,
  [4783] = 4074,
  [4784] = 4095,
  [4785] = 2481,
  [4786] = 2482,
  [4787] = 4636,
  [4788] = 2485,
  [4789] = 2486,
  [4790] = 4636,
  [4791] = 2398,
  [4792] = 2436,
  [4793] = 2473,
  [4794] = 4794,
  [4795] = 4795,
  [4796] = 1709,
  [4797] = 1733,
  [4798] = 2320,
  [4799] = 2123,
  [4800] = 4636,
  [4801] = 2139,
  [4802] = 4636,
  [4803] = 4636,
  [4804] = 4636,
  [4805] = 4636,
  [4806] = 4636,
  [4807] = 2320,
  [4808] = 4095,
  [4809] = 2122,
  [4810] = 2320,
  [4811] = 4811,
  [4812] = 2120,
  [4813] = 2147,
  [4814] = 2143,
  [4815] = 4795,
  [4816] = 2138,
  [4817] = 3940,
  [4818] = 1965,
  [4819] = 4819,
  [4820] = 4820,
  [4821] = 4819,
  [4822] = 2126,
  [4823] = 2127,
  [4824] = 2268,
  [4825] = 2148,
  [4826] = 4636,
  [4827] = 4827,
  [4828] = 4636,
  [4829] = 1755,
  [4830] = 4820,
  [4831] = 1554,
  [4832] = 4091,
  [4833] = 4075,
  [4834] = 4091,
  [4835] = 4074,
  [4836] = 4095,
  [4837] = 2268,
  [4838] = 2150,
  [4839] = 4636,
  [4840] = 2151,
  [4841] = 2142,
  [4842] = 2268,
  [4843] = 3932,
  [4844] = 4636,
  [4845] = 1555,
  [4846] = 1799,
  [4847] = 1805,
  [4848] = 1840,
  [4849] = 4091,
  [4850] = 1847,
  [4851] = 4074,
  [4852] = 4636,
  [4853] = 1846,
  [4854] = 1845,
  [4855] = 4855,
  [4856] = 1851,
  [4857] = 1834,
  [4858] = 1816,
  [4859] = 4859,
  [4860] = 1822,
  [4861] = 1826,
  [4862] = 1806,
  [4863] = 1842,
  [4864] = 1817,
  [4865] = 1837,
  [4866] = 1807,
  [4867] = 1797,
  [4868] = 1809,
  [4869] = 1800,
  [4870] = 4075,
  [4871] = 4636,
  [4872] = 1814,
  [4873] = 1815,
  [4874] = 4874,
  [4875] = 1803,
  [4876] = 1838,
  [4877] = 1844,
  [4878] = 4091,
  [4879] = 1810,
  [4880] = 4095,
  [4881] = 4855,
  [4882] = 1819,
  [4883] = 1798,
  [4884] = 4874,
  [4885] = 1802,
  [4886] = 4074,
  [4887] = 1796,
  [4888] = 1823,
  [4889] = 1852,
  [4890] = 4095,
  [4891] = 1836,
  [4892] = 4075,
  [4893] = 1824,
  [4894] = 1804,
  [4895] = 1860,
  [4896] = 1848,
  [4897] = 1812,
  [4898] = 1841,
  [4899] = 1849,
  [4900] = 4874,
  [4901] = 4874,
  [4902] = 4636,
  [4903] = 4874,
  [4904] = 1962,
  [4905] = 4855,
  [4906] = 1976,
  [4907] = 4874,
  [4908] = 4874,
  [4909] = 4855,
  [4910] = 4855,
  [4911] = 4636,
  [4912] = 2320,
  [4913] = 4855,
  [4914] = 4636,
  [4915] = 4855,
  [4916] = 2512,
  [4917] = 4855,
  [4918] = 4636,
  [4919] = 4636,
  [4920] = 2268,
  [4921] = 4636,
  [4922] = 4874,
  [4923] = 3218,
  [4924] = 4924,
  [4925] = 1872,
  [4926] = 4926,
  [4927] = 4874,
  [4928] = 4926,
  [4929] = 4855,
  [4930] = 4855,
  [4931] = 2142,
  [4932] = 4874,
  [4933] = 4636,
  [4934] = 4934,
  [4935] = 4095,
  [4936] = 4855,
  [4937] = 4934,
  [4938] = 4091,
  [4939] = 4874,
  [4940] = 4636,
  [4941] = 4874,
  [4942] = 4926,
  [4943] = 4934,
  [4944] = 4874,
  [4945] = 4874,
  [4946] = 4934,
  [4947] = 4075,
  [4948] = 4934,
  [4949] = 1555,
  [4950] = 4636,
  [4951] = 1901,
  [4952] = 1869,
  [4953] = 4855,
  [4954] = 4855,
  [4955] = 4074,
  [4956] = 4926,
  [4957] = 4957,
  [4958] = 4926,
  [4959] = 4934,
  [4960] = 1566,
  [4961] = 1896,
  [4962] = 4874,
  [4963] = 4926,
  [4964] = 1897,
  [4965] = 1887,
  [4966] = 1867,
  [4967] = 1873,
  [4968] = 1884,
  [4969] = 4874,
  [4970] = 4855,
  [4971] = 4934,
  [4972] = 4926,
  [4973] = 4636,
  [4974] = 4874,
  [4975] = 1554,
  [4976] = 4926,
  [4977] = 4855,
  [4978] = 1870,
  [4979] = 1890,
  [4980] = 4855,
  [4981] = 4934,
  [4982] = 4855,
  [4983] = 4926,
  [4984] = 1880,
  [4985] = 4874,
  [4986] = 4855,
  [4987] = 4934,
  [4988] = 2150,
  [4989] = 4989,
  [4990] = 4990,
  [4991] = 4991,
  [4992] = 2512,
  [4993] = 4993,
  [4994] = 4994,
  [4995] = 4995,
  [4996] = 4989,
  [4997] = 4990,
  [4998] = 4991,
  [4999] = 4989,
  [5000] = 4990,
  [5001] = 4991,
  [5002] = 4989,
  [5003] = 4990,
  [5004] = 4991,
  [5005] = 4991,
  [5006] = 4989,
  [5007] = 4990,
  [5008] = 4991,
  [5009] = 4989,
  [5010] = 4990,
  [5011] = 4991,
  [5012] = 4989,
  [5013] = 4990,
  [5014] = 4991,
  [5015] = 4989,
  [5016] = 4990,
  [5017] = 4991,
  [5018] = 4989,
  [5019] = 4990,
  [5020] = 4991,
  [5021] = 4989,
  [5022] = 4990,
  [5023] = 4991,
  [5024] = 4989,
  [5025] = 4990,
  [5026] = 4991,
  [5027] = 4989,
  [5028] = 4990,
  [5029] = 4991,
  [5030] = 4989,
  [5031] = 4990,
  [5032] = 4991,
  [5033] = 4989,
  [5034] = 4990,
  [5035] = 4991,
  [5036] = 4989,
  [5037] = 4990,
  [5038] = 4991,
  [5039] = 4989,
  [5040] = 4990,
  [5041] = 4991,
  [5042] = 4989,
  [5043] = 4990,
  [5044] = 4991,
  [5045] = 4993,
  [5046] = 4994,
  [5047] = 4995,
  [5048] = 4990,
  [5049] = 5049,
  [5050] = 5050,
  [5051] = 4855,
  [5052] = 4874,
  [5053] = 4855,
  [5054] = 4874,
  [5055] = 4993,
  [5056] = 4994,
  [5057] = 4995,
  [5058] = 5058,
  [5059] = 5049,
  [5060] = 5050,
  [5061] = 4993,
  [5062] = 4994,
  [5063] = 4995,
  [5064] = 5058,
  [5065] = 5049,
  [5066] = 5050,
  [5067] = 5058,
  [5068] = 5049,
  [5069] = 5050,
  [5070] = 4993,
  [5071] = 4994,
  [5072] = 4995,
  [5073] = 5058,
  [5074] = 5049,
  [5075] = 5050,
  [5076] = 4993,
  [5077] = 4994,
  [5078] = 4995,
  [5079] = 5058,
  [5080] = 5049,
  [5081] = 5050,
  [5082] = 4993,
  [5083] = 4994,
  [5084] = 4995,
  [5085] = 5058,
  [5086] = 5049,
  [5087] = 5050,
  [5088] = 2197,
  [5089] = 2122,
  [5090] = 2143,
  [5091] = 2138,
  [5092] = 2123,
  [5093] = 2126,
  [5094] = 2127,
  [5095] = 2147,
  [5096] = 2148,
  [5097] = 2151,
  [5098] = 2139,
  [5099] = 2120,
  [5100] = 4989,
  [5101] = 2512,
  [5102] = 5058,
  [5103] = 5103,
  [5104] = 5104,
  [5105] = 5105,
  [5106] = 5106,
  [5107] = 5105,
  [5108] = 5104,
  [5109] = 5106,
  [5110] = 5110,
  [5111] = 5104,
  [5112] = 5110,
  [5113] = 5103,
  [5114] = 5106,
  [5115] = 5110,
  [5116] = 5104,
  [5117] = 5105,
  [5118] = 5104,
  [5119] = 5105,
  [5120] = 5105,
  [5121] = 5105,
  [5122] = 5104,
  [5123] = 5104,
  [5124] = 5104,
  [5125] = 5105,
  [5126] = 5105,
  [5127] = 5106,
  [5128] = 5105,
  [5129] = 5104,
  [5130] = 5106,
  [5131] = 5110,
  [5132] = 5105,
  [5133] = 4855,
  [5134] = 5104,
  [5135] = 5106,
  [5136] = 5110,
  [5137] = 5105,
  [5138] = 5110,
  [5139] = 5103,
  [5140] = 4855,
  [5141] = 4874,
  [5142] = 5142,
  [5143] = 5105,
  [5144] = 4855,
  [5145] = 4874,
  [5146] = 4855,
  [5147] = 5104,
  [5148] = 5105,
  [5149] = 4874,
  [5150] = 5104,
  [5151] = 5105,
  [5152] = 5104,
  [5153] = 4874,
  [5154] = 5104,
  [5155] = 5106,
  [5156] = 4855,
  [5157] = 5110,
  [5158] = 4874,
  [5159] = 5103,
  [5160] = 5105,
  [5161] = 5161,
  [5162] = 5104,
  [5163] = 5105,
  [5164] = 5105,
  [5165] = 5105,
  [5166] = 5166,
  [5167] = 5104,
  [5168] = 5106,
  [5169] = 5110,
  [5170] = 5105,
  [5171] = 5106,
  [5172] = 5103,
  [5173] = 4855,
  [5174] = 5174,
  [5175] = 5175,
  [5176] = 5110,
  [5177] = 5105,
  [5178] = 5104,
  [5179] = 4874,
  [5180] = 5104,
  [5181] = 5181,
  [5182] = 5182,
  [5183] = 5183,
  [5184] = 5183,
  [5185] = 5185,
  [5186] = 4874,
  [5187] = 1893,
  [5188] = 5188,
  [5189] = 5189,
  [5190] = 4874,
  [5191] = 4855,
  [5192] = 5183,
  [5193] = 5185,
  [5194] = 4874,
  [5195] = 5188,
  [5196] = 4855,
  [5197] = 5182,
  [5198] = 5198,
  [5199] = 5189,
  [5200] = 5183,
  [5201] = 5188,
  [5202] = 5188,
  [5203] = 4874,
  [5204] = 5185,
  [5205] = 5205,
  [5206] = 1566,
  [5207] = 5185,
  [5208] = 5198,
  [5209] = 5209,
  [5210] = 5205,
  [5211] = 3720,
  [5212] = 5183,
  [5213] = 3721,
  [5214] = 5183,
  [5215] = 5215,
  [5216] = 5188,
  [5217] = 5205,
  [5218] = 5218,
  [5219] = 5188,
  [5220] = 5185,
  [5221] = 5188,
  [5222] = 4855,
  [5223] = 5223,
  [5224] = 5183,
  [5225] = 5185,
  [5226] = 5205,
  [5227] = 4855,
  [5228] = 5185,
  [5229] = 5182,
  [5230] = 5189,
  [5231] = 5198,
  [5232] = 5182,
  [5233] = 5198,
  [5234] = 5198,
  [5235] = 5189,
  [5236] = 5182,
  [5237] = 5189,
  [5238] = 2952,
  [5239] = 5189,
  [5240] = 5198,
  [5241] = 5182,
  [5242] = 5182,
  [5243] = 5182,
  [5244] = 5198,
  [5245] = 5189,
  [5246] = 5198,
  [5247] = 5189,
  [5248] = 5189,
  [5249] = 5182,
  [5250] = 5198,
  [5251] = 5198,
  [5252] = 5189,
  [5253] = 5198,
  [5254] = 5182,
  [5255] = 5182,
  [5256] = 5198,
  [5257] = 5189,
  [5258] = 2945,
  [5259] = 5189,
  [5260] = 5182,
  [5261] = 5189,
  [5262] = 5182,
  [5263] = 5198,
  [5264] = 5198,
  [5265] = 5189,
  [5266] = 5198,
  [5267] = 5189,
  [5268] = 5189,
  [5269] = 5182,
  [5270] = 5198,
  [5271] = 5182,
  [5272] = 5198,
  [5273] = 5182,
  [5274] = 5182,
  [5275] = 5189,
  [5276] = 5189,
  [5277] = 5198,
  [5278] = 5182,
  [5279] = 5189,
  [5280] = 5182,
  [5281] = 5281,
  [5282] = 5198,
  [5283] = 5198,
  [5284] = 5182,
  [5285] = 5281,
  [5286] = 5189,
  [5287] = 5281,
  [5288] = 5281,
  [5289] = 5198,
  [5290] = 5182,
  [5291] = 5198,
  [5292] = 5292,
  [5293] = 5198,
  [5294] = 5294,
  [5295] = 5182,
  [5296] = 5182,
  [5297] = 5198,
  [5298] = 5182,
  [5299] = 5292,
  [5300] = 5294,
  [5301] = 5292,
  [5302] = 5292,
  [5303] = 5189,
  [5304] = 5189,
  [5305] = 5292,
  [5306] = 5182,
  [5307] = 5292,
  [5308] = 5189,
  [5309] = 5189,
  [5310] = 5189,
  [5311] = 5294,
  [5312] = 5198,
  [5313] = 5292,
  [5314] = 5198,
  [5315] = 5189,
  [5316] = 5182,
  [5317] = 5189,
  [5318] = 5182,
  [5319] = 5182,
  [5320] = 5198,
  [5321] = 5189,
  [5322] = 5182,
  [5323] = 5198,
  [5324] = 5189,
  [5325] = 5198,
  [5326] = 5182,
  [5327] = 5198,
  [5328] = 5189,
  [5329] = 5329,
  [5330] = 5330,
  [5331] = 5329,
  [5332] = 5329,
  [5333] = 5333,
  [5334] = 5334,
  [5335] = 5294,
  [5336] = 5336,
  [5337] = 5337,
  [5338] = 5338,
  [5339] = 5339,
  [5340] = 5338,
  [5341] = 5339,
  [5342] = 5339,
  [5343] = 5343,
  [5344] = 5294,
  [5345] = 5339,
  [5346] = 5343,
  [5347] = 5339,
  [5348] = 5343,
  [5349] = 5339,
  [5350] = 5343,
  [5351] = 2191,
  [5352] = 5352,
  [5353] = 5338,
  [5354] = 5343,
  [5355] = 5343,
  [5356] = 5339,
  [5357] = 5343,
  [5358] = 5343,
  [5359] = 5338,
  [5360] = 5360,
  [5361] = 2218,
  [5362] = 5294,
  [5363] = 5360,
  [5364] = 5343,
  [5365] = 5338,
  [5366] = 5366,
  [5367] = 5367,
  [5368] = 5337,
  [5369] = 5369,
  [5370] = 5338,
  [5371] = 5339,
  [5372] = 5372,
  [5373] = 5338,
  [5374] = 5343,
  [5375] = 5339,
  [5376] = 5339,
  [5377] = 5339,
  [5378] = 5343,
  [5379] = 5379,
  [5380] = 5366,
  [5381] = 5333,
  [5382] = 5367,
  [5383] = 5360,
  [5384] = 5339,
  [5385] = 5334,
  [5386] = 5343,
  [5387] = 5387,
  [5388] = 5339,
  [5389] = 5343,
  [5390] = 5338,
  [5391] = 5339,
  [5392] = 5369,
  [5393] = 5339,
  [5394] = 5343,
  [5395] = 5395,
  [5396] = 5339,
  [5397] = 5343,
  [5398] = 5338,
  [5399] = 5343,
  [5400] = 5379,
  [5401] = 5337,
  [5402] = 5402,
  [5403] = 1597,
  [5404] = 1599,
  [5405] = 5405,
  [5406] = 5406,
  [5407] = 5402,
  [5408] = 5408,
  [5409] = 5409,
  [5410] = 5410,
  [5411] = 5366,
  [5412] = 1605,
  [5413] = 133,
  [5414] = 5410,
  [5415] = 5415,
  [5416] = 5416,
  [5417] = 5408,
  [5418] = 5408,
  [5419] = 5402,
  [5420] = 5420,
  [5421] = 5408,
  [5422] = 5422,
  [5423] = 5410,
  [5424] = 5402,
  [5425] = 5402,
  [5426] = 1593,
  [5427] = 5410,
  [5428] = 132,
  [5429] = 5429,
  [5430] = 1594,
  [5431] = 5410,
  [5432] = 5415,
  [5433] = 5416,
  [5434] = 5408,
  [5435] = 5402,
  [5436] = 5410,
  [5437] = 5437,
  [5438] = 5415,
  [5439] = 5439,
  [5440] = 1600,
  [5441] = 1596,
  [5442] = 5442,
  [5443] = 5410,
  [5444] = 5444,
  [5445] = 5439,
  [5446] = 5416,
  [5447] = 5416,
  [5448] = 5408,
  [5449] = 5415,
  [5450] = 5416,
  [5451] = 5402,
  [5452] = 5408,
  [5453] = 5410,
  [5454] = 5437,
  [5455] = 5402,
  [5456] = 5406,
  [5457] = 1591,
  [5458] = 1601,
  [5459] = 5410,
  [5460] = 1602,
  [5461] = 5415,
  [5462] = 5416,
  [5463] = 5408,
  [5464] = 5402,
  [5465] = 5415,
  [5466] = 5416,
  [5467] = 5415,
  [5468] = 5294,
  [5469] = 5416,
  [5470] = 5402,
  [5471] = 5410,
  [5472] = 5415,
  [5473] = 5415,
  [5474] = 5416,
  [5475] = 5408,
  [5476] = 5405,
  [5477] = 5415,
  [5478] = 5408,
  [5479] = 5402,
  [5480] = 5410,
  [5481] = 5408,
  [5482] = 5337,
  [5483] = 5379,
  [5484] = 5410,
  [5485] = 2218,
  [5486] = 5369,
  [5487] = 5415,
  [5488] = 5416,
  [5489] = 5367,
  [5490] = 5379,
  [5491] = 5406,
  [5492] = 5415,
  [5493] = 5408,
  [5494] = 5408,
  [5495] = 1592,
  [5496] = 5437,
  [5497] = 5366,
  [5498] = 5406,
  [5499] = 5402,
  [5500] = 5415,
  [5501] = 5395,
  [5502] = 5402,
  [5503] = 5410,
  [5504] = 5415,
  [5505] = 5416,
  [5506] = 5416,
  [5507] = 5416,
  [5508] = 5406,
  [5509] = 5405,
  [5510] = 5415,
  [5511] = 5416,
  [5512] = 5408,
  [5513] = 5513,
  [5514] = 5402,
  [5515] = 5408,
  [5516] = 5402,
  [5517] = 1595,
  [5518] = 5410,
  [5519] = 5415,
  [5520] = 5410,
  [5521] = 5402,
  [5522] = 5410,
  [5523] = 5439,
  [5524] = 5402,
  [5525] = 5416,
  [5526] = 5406,
  [5527] = 5369,
  [5528] = 5410,
  [5529] = 5416,
  [5530] = 1606,
  [5531] = 2191,
  [5532] = 1607,
  [5533] = 5533,
  [5534] = 5534,
  [5535] = 5367,
  [5536] = 5415,
  [5537] = 5402,
  [5538] = 5416,
  [5539] = 5406,
  [5540] = 5416,
  [5541] = 5410,
  [5542] = 1598,
  [5543] = 5408,
  [5544] = 5408,
  [5545] = 5415,
  [5546] = 5408,
  [5547] = 5547,
  [5548] = 5294,
  [5549] = 5549,
  [5550] = 5550,
  [5551] = 5551,
  [5552] = 5552,
  [5553] = 5553,
  [5554] = 5554,
  [5555] = 5555,
  [5556] = 5551,
  [5557] = 5557,
  [5558] = 5558,
  [5559] = 5559,
  [5560] = 5560,
  [5561] = 5561,
  [5562] = 5562,
  [5563] = 5563,
  [5564] = 5564,
  [5565] = 5565,
  [5566] = 5566,
  [5567] = 5567,
  [5568] = 5554,
  [5569] = 5569,
  [5570] = 5558,
  [5571] = 5555,
  [5572] = 5552,
  [5573] = 5573,
  [5574] = 5555,
  [5575] = 5352,
  [5576] = 5294,
  [5577] = 2820,
  [5578] = 5551,
  [5579] = 5555,
  [5580] = 5547,
  [5581] = 5581,
  [5582] = 5582,
  [5583] = 5559,
  [5584] = 5554,
  [5585] = 5558,
  [5586] = 5586,
  [5587] = 5558,
  [5588] = 5588,
  [5589] = 5554,
  [5590] = 5581,
  [5591] = 5554,
  [5592] = 5551,
  [5593] = 5593,
  [5594] = 5551,
  [5595] = 5554,
  [5596] = 5558,
  [5597] = 5597,
  [5598] = 5554,
  [5599] = 5599,
  [5600] = 5558,
  [5601] = 5551,
  [5602] = 5602,
  [5603] = 5603,
  [5604] = 5561,
  [5605] = 5605,
  [5606] = 5551,
  [5607] = 5547,
  [5608] = 5555,
  [5609] = 5609,
  [5610] = 5610,
  [5611] = 5611,
  [5612] = 5612,
  [5613] = 5547,
  [5614] = 5551,
  [5615] = 5562,
  [5616] = 5567,
  [5617] = 5617,
  [5618] = 5555,
  [5619] = 5547,
  [5620] = 5593,
  [5621] = 5547,
  [5622] = 5603,
  [5623] = 5372,
  [5624] = 5551,
  [5625] = 5552,
  [5626] = 5626,
  [5627] = 5555,
  [5628] = 5554,
  [5629] = 5569,
  [5630] = 5630,
  [5631] = 5610,
  [5632] = 5632,
  [5633] = 5559,
  [5634] = 5573,
  [5635] = 2197,
  [5636] = 5547,
  [5637] = 5611,
  [5638] = 5561,
  [5639] = 5558,
  [5640] = 5588,
  [5641] = 5547,
  [5642] = 5555,
  [5643] = 5562,
  [5644] = 5644,
  [5645] = 5552,
  [5646] = 5549,
  [5647] = 5550,
  [5648] = 5547,
  [5649] = 5551,
  [5650] = 5650,
  [5651] = 5612,
  [5652] = 5603,
  [5653] = 5653,
  [5654] = 5558,
  [5655] = 5559,
  [5656] = 5610,
  [5657] = 5603,
  [5658] = 5551,
  [5659] = 5294,
  [5660] = 5294,
  [5661] = 5630,
  [5662] = 5662,
  [5663] = 5561,
  [5664] = 5551,
  [5665] = 5555,
  [5666] = 5552,
  [5667] = 5562,
  [5668] = 5559,
  [5669] = 5669,
  [5670] = 5552,
  [5671] = 5671,
  [5672] = 5547,
  [5673] = 5555,
  [5674] = 5559,
  [5675] = 5561,
  [5676] = 5562,
  [5677] = 5561,
  [5678] = 5678,
  [5679] = 5562,
  [5680] = 5680,
  [5681] = 5555,
  [5682] = 5644,
  [5683] = 5387,
  [5684] = 5554,
  [5685] = 5547,
  [5686] = 5686,
  [5687] = 5547,
  [5688] = 5555,
  [5689] = 5689,
  [5690] = 5558,
  [5691] = 5691,
  [5692] = 5547,
  [5693] = 5551,
  [5694] = 5694,
  [5695] = 5555,
  [5696] = 5551,
  [5697] = 5697,
  [5698] = 5698,
  [5699] = 5699,
  [5700] = 5700,
  [5701] = 5701,
  [5702] = 5605,
  [5703] = 5680,
  [5704] = 5704,
  [5705] = 5705,
  [5706] = 5706,
  [5707] = 5653,
  [5708] = 5704,
  [5709] = 2351,
  [5710] = 5705,
  [5711] = 5711,
  [5712] = 5700,
  [5713] = 5662,
  [5714] = 5714,
  [5715] = 5686,
  [5716] = 5716,
  [5717] = 1859,
  [5718] = 5691,
  [5719] = 5694,
  [5720] = 5720,
  [5721] = 5557,
  [5722] = 5711,
  [5723] = 5560,
  [5724] = 5706,
  [5725] = 5563,
  [5726] = 5726,
  [5727] = 5727,
  [5728] = 5728,
  [5729] = 5729,
  [5730] = 2820,
  [5731] = 5597,
  [5732] = 5700,
  [5733] = 5564,
  [5734] = 5294,
  [5735] = 5735,
  [5736] = 5565,
  [5737] = 5566,
  [5738] = 5738,
  [5739] = 5739,
  [5740] = 5700,
  [5741] = 5741,
  [5742] = 5738,
  [5743] = 5704,
  [5744] = 5705,
  [5745] = 5711,
  [5746] = 5746,
  [5747] = 5738,
  [5748] = 5748,
  [5749] = 5738,
  [5750] = 5700,
  [5751] = 5751,
  [5752] = 5705,
  [5753] = 5602,
  [5754] = 5599,
  [5755] = 5755,
  [5756] = 5756,
  [5757] = 5757,
  [5758] = 5758,
  [5759] = 5759,
  [5760] = 5760,
  [5761] = 5678,
  [5762] = 5762,
  [5763] = 5617,
  [5764] = 5700,
  [5765] = 5700,
  [5766] = 5766,
  [5767] = 1857,
  [5768] = 5768,
  [5769] = 5294,
  [5770] = 5704,
  [5771] = 5704,
  [5772] = 5772,
  [5773] = 5773,
  [5774] = 5774,
  [5775] = 5775,
  [5776] = 5776,
  [5777] = 5777,
  [5778] = 5778,
  [5779] = 5704,
  [5780] = 5704,
  [5781] = 2128,
  [5782] = 2191,
  [5783] = 2197,
  [5784] = 2136,
  [5785] = 1591,
  [5786] = 2125,
  [5787] = 1606,
  [5788] = 5552,
  [5789] = 5559,
  [5790] = 5561,
  [5791] = 5562,
  [5792] = 5552,
  [5793] = 5559,
  [5794] = 5561,
  [5795] = 5562,
  [5796] = 1593,
  [5797] = 5797,
  [5798] = 1594,
  [5799] = 1595,
  [5800] = 1607,
  [5801] = 1600,
  [5802] = 5797,
  [5803] = 5367,
  [5804] = 1599,
  [5805] = 5409,
  [5806] = 5337,
  [5807] = 5366,
  [5808] = 5369,
  [5809] = 133,
  [5810] = 2218,
  [5811] = 132,
  [5812] = 5367,
  [5813] = 5813,
  [5814] = 2368,
  [5815] = 1592,
  [5816] = 2344,
  [5817] = 5369,
  [5818] = 1605,
  [5819] = 793,
  [5820] = 2372,
  [5821] = 5821,
  [5822] = 5337,
  [5823] = 794,
  [5824] = 5294,
  [5825] = 1601,
  [5826] = 5797,
  [5827] = 5827,
  [5828] = 5513,
  [5829] = 5797,
  [5830] = 2121,
  [5831] = 1598,
  [5832] = 5379,
  [5833] = 5833,
  [5834] = 1596,
  [5835] = 5797,
  [5836] = 5836,
  [5837] = 1602,
  [5838] = 5366,
  [5839] = 1597,
  [5840] = 2159,
  [5841] = 5379,
  [5842] = 5561,
  [5843] = 1508,
  [5844] = 2465,
  [5845] = 5845,
  [5846] = 5846,
  [5847] = 5847,
  [5848] = 5848,
  [5849] = 5552,
  [5850] = 5850,
  [5851] = 5562,
  [5852] = 5852,
  [5853] = 5559,
  [5854] = 5846,
  [5855] = 5846,
  [5856] = 5846,
  [5857] = 5846,
  [5858] = 5858,
  [5859] = 5848,
  [5860] = 5848,
  [5861] = 5861,
  [5862] = 5848,
  [5863] = 5552,
  [5864] = 5559,
  [5865] = 1646,
  [5866] = 5848,
  [5867] = 5552,
  [5868] = 5559,
  [5869] = 5561,
  [5870] = 5562,
  [5871] = 5871,
  [5872] = 5846,
  [5873] = 5846,
  [5874] = 5846,
  [5875] = 5847,
  [5876] = 5846,
  [5877] = 5848,
  [5878] = 5294,
  [5879] = 5848,
  [5880] = 5848,
  [5881] = 5552,
  [5882] = 5848,
  [5883] = 5883,
  [5884] = 1648,
  [5885] = 5848,
  [5886] = 5886,
  [5887] = 5294,
  [5888] = 5561,
  [5889] = 5562,
  [5890] = 5846,
  [5891] = 2255,
  [5892] = 5561,
  [5893] = 1656,
  [5894] = 5559,
  [5895] = 5562,
  [5896] = 5896,
  [5897] = 5714,
  [5898] = 2425,
  [5899] = 2431,
  [5900] = 2438,
  [5901] = 5901,
  [5902] = 5369,
  [5903] = 5903,
  [5904] = 5904,
  [5905] = 5905,
  [5906] = 5906,
  [5907] = 5904,
  [5908] = 5904,
  [5909] = 5909,
  [5910] = 5910,
  [5911] = 5911,
  [5912] = 2441,
  [5913] = 5913,
  [5914] = 5904,
  [5915] = 5773,
  [5916] = 5916,
  [5917] = 5917,
  [5918] = 5904,
  [5919] = 5735,
  [5920] = 2403,
  [5921] = 5778,
  [5922] = 2189,
  [5923] = 5562,
  [5924] = 5562,
  [5925] = 5904,
  [5926] = 5904,
  [5927] = 5698,
  [5928] = 5905,
  [5929] = 5904,
  [5930] = 5379,
  [5931] = 5366,
  [5932] = 5904,
  [5933] = 5906,
  [5934] = 5904,
  [5935] = 5777,
  [5936] = 5367,
  [5937] = 2191,
  [5938] = 2182,
  [5939] = 5903,
  [5940] = 2446,
  [5941] = 5559,
  [5942] = 5727,
  [5943] = 5726,
  [5944] = 5944,
  [5945] = 5904,
  [5946] = 5746,
  [5947] = 5947,
  [5948] = 5901,
  [5949] = 2238,
  [5950] = 2186,
  [5951] = 2252,
  [5952] = 2258,
  [5953] = 5953,
  [5954] = 5903,
  [5955] = 5905,
  [5956] = 5906,
  [5957] = 5904,
  [5958] = 5909,
  [5959] = 5910,
  [5960] = 5904,
  [5961] = 5911,
  [5962] = 5904,
  [5963] = 5909,
  [5964] = 5748,
  [5965] = 5366,
  [5966] = 2221,
  [5967] = 5337,
  [5968] = 5561,
  [5969] = 5294,
  [5970] = 5552,
  [5971] = 2223,
  [5972] = 2224,
  [5973] = 2163,
  [5974] = 5974,
  [5975] = 5755,
  [5976] = 5379,
  [5977] = 5720,
  [5978] = 5772,
  [5979] = 5552,
  [5980] = 5947,
  [5981] = 5904,
  [5982] = 5561,
  [5983] = 5910,
  [5984] = 2218,
  [5985] = 5911,
  [5986] = 5774,
  [5987] = 5987,
  [5988] = 5988,
  [5989] = 5904,
  [5990] = 5776,
  [5991] = 5701,
  [5992] = 5559,
  [5993] = 5337,
  [5994] = 5369,
  [5995] = 5947,
  [5996] = 5904,
  [5997] = 5997,
  [5998] = 2187,
  [5999] = 5294,
  [6000] = 2410,
  [6001] = 5775,
  [6002] = 5904,
  [6003] = 6003,
  [6004] = 5756,
  [6005] = 5757,
  [6006] = 5758,
  [6007] = 5759,
  [6008] = 5367,
  [6009] = 6009,
  [6010] = 5901,
  [6011] = 5904,
  [6012] = 5552,
  [6013] = 6013,
  [6014] = 6014,
  [6015] = 6015,
  [6016] = 6016,
  [6017] = 6017,
  [6018] = 6016,
  [6019] = 6019,
  [6020] = 5561,
  [6021] = 6016,
  [6022] = 5562,
  [6023] = 5561,
  [6024] = 6016,
  [6025] = 6025,
  [6026] = 6019,
  [6027] = 5559,
  [6028] = 6028,
  [6029] = 6029,
  [6030] = 6029,
  [6031] = 6016,
  [6032] = 6016,
  [6033] = 6013,
  [6034] = 6019,
  [6035] = 6035,
  [6036] = 6019,
  [6037] = 6037,
  [6038] = 6038,
  [6039] = 6037,
  [6040] = 6040,
  [6041] = 6041,
  [6042] = 6038,
  [6043] = 6013,
  [6044] = 6013,
  [6045] = 5561,
  [6046] = 6046,
  [6047] = 5552,
  [6048] = 6048,
  [6049] = 5552,
  [6050] = 5552,
  [6051] = 5559,
  [6052] = 6013,
  [6053] = 5561,
  [6054] = 5562,
  [6055] = 5559,
  [6056] = 6019,
  [6057] = 6035,
  [6058] = 6058,
  [6059] = 5561,
  [6060] = 5559,
  [6061] = 5561,
  [6062] = 5562,
  [6063] = 6013,
  [6064] = 5562,
  [6065] = 6065,
  [6066] = 6048,
  [6067] = 5552,
  [6068] = 6046,
  [6069] = 5552,
  [6070] = 5559,
  [6071] = 6046,
  [6072] = 6046,
  [6073] = 6046,
  [6074] = 6013,
  [6075] = 5561,
  [6076] = 6046,
  [6077] = 5562,
  [6078] = 6078,
  [6079] = 5562,
  [6080] = 6019,
  [6081] = 6013,
  [6082] = 1900,
  [6083] = 6038,
  [6084] = 5552,
  [6085] = 5559,
  [6086] = 5561,
  [6087] = 6041,
  [6088] = 5562,
  [6089] = 6089,
  [6090] = 5562,
  [6091] = 6016,
  [6092] = 5559,
  [6093] = 6013,
  [6094] = 6046,
  [6095] = 5559,
  [6096] = 6013,
  [6097] = 5552,
  [6098] = 6019,
  [6099] = 6038,
  [6100] = 6100,
  [6101] = 2128,
  [6102] = 5379,
  [6103] = 1772,
  [6104] = 6100,
  [6105] = 5379,
  [6106] = 5366,
  [6107] = 5367,
  [6108] = 5901,
  [6109] = 5337,
  [6110] = 5366,
  [6111] = 5911,
  [6112] = 2125,
  [6113] = 6113,
  [6114] = 5369,
  [6115] = 6100,
  [6116] = 5367,
  [6117] = 6100,
  [6118] = 5337,
  [6119] = 5379,
  [6120] = 6120,
  [6121] = 6100,
  [6122] = 6122,
  [6123] = 5337,
  [6124] = 6100,
  [6125] = 2218,
  [6126] = 2159,
  [6127] = 5369,
  [6128] = 5367,
  [6129] = 6100,
  [6130] = 6130,
  [6131] = 5552,
  [6132] = 6132,
  [6133] = 5367,
  [6134] = 6100,
  [6135] = 6100,
  [6136] = 5559,
  [6137] = 6130,
  [6138] = 5337,
  [6139] = 5903,
  [6140] = 5561,
  [6141] = 6122,
  [6142] = 1769,
  [6143] = 2191,
  [6144] = 6100,
  [6145] = 5562,
  [6146] = 1728,
  [6147] = 5552,
  [6148] = 6100,
  [6149] = 6130,
  [6150] = 5905,
  [6151] = 5562,
  [6152] = 6100,
  [6153] = 1735,
  [6154] = 5369,
  [6155] = 5906,
  [6156] = 5559,
  [6157] = 5294,
  [6158] = 2121,
  [6159] = 6100,
  [6160] = 2218,
  [6161] = 5561,
  [6162] = 5369,
  [6163] = 6100,
  [6164] = 5552,
  [6165] = 6130,
  [6166] = 6122,
  [6167] = 5559,
  [6168] = 5562,
  [6169] = 6122,
  [6170] = 6100,
  [6171] = 6122,
  [6172] = 6130,
  [6173] = 5561,
  [6174] = 2128,
  [6175] = 5909,
  [6176] = 6100,
  [6177] = 2136,
  [6178] = 6100,
  [6179] = 2125,
  [6180] = 6100,
  [6181] = 6130,
  [6182] = 5562,
  [6183] = 5366,
  [6184] = 5379,
  [6185] = 2191,
  [6186] = 6122,
  [6187] = 6100,
  [6188] = 6130,
  [6189] = 2121,
  [6190] = 5366,
  [6191] = 5947,
  [6192] = 2159,
  [6193] = 5552,
  [6194] = 6100,
  [6195] = 5559,
  [6196] = 6196,
  [6197] = 6196,
  [6198] = 6122,
  [6199] = 5561,
  [6200] = 5910,
  [6201] = 6201,
  [6202] = 2136,
  [6203] = 6203,
  [6204] = 6204,
  [6205] = 6203,
  [6206] = 6206,
  [6207] = 6207,
  [6208] = 5901,
  [6209] = 6041,
  [6210] = 6210,
  [6211] = 6206,
  [6212] = 5905,
  [6213] = 5901,
  [6214] = 5911,
  [6215] = 6035,
  [6216] = 5903,
  [6217] = 5947,
  [6218] = 5905,
  [6219] = 5911,
  [6220] = 6220,
  [6221] = 5559,
  [6222] = 6222,
  [6223] = 5947,
  [6224] = 6224,
  [6225] = 6204,
  [6226] = 6203,
  [6227] = 6204,
  [6228] = 5906,
  [6229] = 6206,
  [6230] = 6222,
  [6231] = 5910,
  [6232] = 5909,
  [6233] = 6222,
  [6234] = 5906,
  [6235] = 6206,
  [6236] = 6236,
  [6237] = 6206,
  [6238] = 5845,
  [6239] = 6206,
  [6240] = 5903,
  [6241] = 6241,
  [6242] = 6242,
  [6243] = 2255,
  [6244] = 6203,
  [6245] = 5552,
  [6246] = 5559,
  [6247] = 6203,
  [6248] = 6204,
  [6249] = 6207,
  [6250] = 6250,
  [6251] = 5561,
  [6252] = 6222,
  [6253] = 6203,
  [6254] = 6037,
  [6255] = 6236,
  [6256] = 5562,
  [6257] = 6222,
  [6258] = 5909,
  [6259] = 6206,
  [6260] = 6206,
  [6261] = 5910,
  [6262] = 6203,
  [6263] = 2255,
  [6264] = 6206,
  [6265] = 6203,
  [6266] = 6266,
  [6267] = 6206,
  [6268] = 6236,
  [6269] = 6029,
  [6270] = 6203,
  [6271] = 6236,
  [6272] = 5561,
  [6273] = 5552,
  [6274] = 5562,
  [6275] = 6048,
  [6276] = 6203,
  [6277] = 6277,
  [6278] = 5909,
  [6279] = 6279,
  [6280] = 6279,
  [6281] = 6279,
  [6282] = 5906,
  [6283] = 6279,
  [6284] = 6279,
  [6285] = 6285,
  [6286] = 6279,
  [6287] = 6279,
  [6288] = 6279,
  [6289] = 6279,
  [6290] = 6279,
  [6291] = 6279,
  [6292] = 6279,
  [6293] = 6279,
  [6294] = 6279,
  [6295] = 5911,
  [6296] = 6279,
  [6297] = 6297,
  [6298] = 6298,
  [6299] = 6299,
  [6300] = 6300,
  [6301] = 5905,
  [6302] = 5552,
  [6303] = 5559,
  [6304] = 5561,
  [6305] = 5562,
  [6306] = 6306,
  [6307] = 6279,
  [6308] = 3743,
  [6309] = 6309,
  [6310] = 5552,
  [6311] = 5559,
  [6312] = 6279,
  [6313] = 5561,
  [6314] = 5562,
  [6315] = 6279,
  [6316] = 2324,
  [6317] = 6317,
  [6318] = 5947,
  [6319] = 5910,
  [6320] = 6279,
  [6321] = 6279,
  [6322] = 5901,
  [6323] = 5903,
  [6324] = 6324,
  [6325] = 6325,
  [6326] = 5947,
  [6327] = 1504,
  [6328] = 5947,
  [6329] = 1500,
  [6330] = 6330,
  [6331] = 5947,
  [6332] = 6325,
  [6333] = 6333,
  [6334] = 6334,
  [6335] = 1502,
  [6336] = 1503,
  [6337] = 6048,
  [6338] = 6330,
  [6339] = 6339,
  [6340] = 6333,
  [6341] = 6029,
  [6342] = 6342,
  [6343] = 6343,
  [6344] = 5901,
  [6345] = 5903,
  [6346] = 5905,
  [6347] = 5906,
  [6348] = 5905,
  [6349] = 5906,
  [6350] = 6325,
  [6351] = 5909,
  [6352] = 5910,
  [6353] = 6325,
  [6354] = 5911,
  [6355] = 6355,
  [6356] = 6330,
  [6357] = 6339,
  [6358] = 6333,
  [6359] = 6359,
  [6360] = 6360,
  [6361] = 5901,
  [6362] = 5903,
  [6363] = 5379,
  [6364] = 6364,
  [6365] = 5905,
  [6366] = 5906,
  [6367] = 6037,
  [6368] = 6368,
  [6369] = 5366,
  [6370] = 5905,
  [6371] = 5906,
  [6372] = 5367,
  [6373] = 5337,
  [6374] = 5369,
  [6375] = 6375,
  [6376] = 6041,
  [6377] = 6377,
  [6378] = 6378,
  [6379] = 6339,
  [6380] = 5947,
  [6381] = 6381,
  [6382] = 6333,
  [6383] = 5910,
  [6384] = 6384,
  [6385] = 5911,
  [6386] = 6386,
  [6387] = 5379,
  [6388] = 5366,
  [6389] = 5901,
  [6390] = 5903,
  [6391] = 5367,
  [6392] = 6325,
  [6393] = 5337,
  [6394] = 5369,
  [6395] = 5909,
  [6396] = 2218,
  [6397] = 5911,
  [6398] = 6339,
  [6399] = 5910,
  [6400] = 5910,
  [6401] = 6330,
  [6402] = 6402,
  [6403] = 6333,
  [6404] = 6339,
  [6405] = 6405,
  [6406] = 6333,
  [6407] = 2191,
  [6408] = 6339,
  [6409] = 6333,
  [6410] = 6330,
  [6411] = 5901,
  [6412] = 5903,
  [6413] = 5909,
  [6414] = 6330,
  [6415] = 5911,
  [6416] = 6325,
  [6417] = 6035,
  [6418] = 6418,
  [6419] = 1501,
  [6420] = 1505,
  [6421] = 1506,
  [6422] = 6422,
  [6423] = 2320,
  [6424] = 2268,
  [6425] = 6339,
  [6426] = 6426,
  [6427] = 6325,
  [6428] = 6428,
  [6429] = 6330,
  [6430] = 6430,
  [6431] = 5909,
  [6432] = 6432,
  [6433] = 6433,
  [6434] = 6433,
  [6435] = 6435,
  [6436] = 6436,
  [6437] = 6437,
  [6438] = 5903,
  [6439] = 6439,
  [6440] = 6440,
  [6441] = 6441,
  [6442] = 6433,
  [6443] = 5905,
  [6444] = 5906,
  [6445] = 6433,
  [6446] = 5910,
  [6447] = 5901,
  [6448] = 5903,
  [6449] = 6432,
  [6450] = 6433,
  [6451] = 5947,
  [6452] = 6452,
  [6453] = 6433,
  [6454] = 6433,
  [6455] = 5909,
  [6456] = 6433,
  [6457] = 6433,
  [6458] = 6458,
  [6459] = 5911,
  [6460] = 5947,
  [6461] = 6433,
  [6462] = 5901,
  [6463] = 5903,
  [6464] = 5905,
  [6465] = 5906,
  [6466] = 5909,
  [6467] = 5910,
  [6468] = 5911,
  [6469] = 6433,
  [6470] = 6433,
  [6471] = 6471,
  [6472] = 5901,
  [6473] = 5909,
  [6474] = 5911,
  [6475] = 6433,
  [6476] = 6476,
  [6477] = 6476,
  [6478] = 5903,
  [6479] = 5905,
  [6480] = 6480,
  [6481] = 5906,
  [6482] = 5741,
  [6483] = 6476,
  [6484] = 6484,
  [6485] = 6485,
  [6486] = 6476,
  [6487] = 6476,
  [6488] = 6476,
  [6489] = 5909,
  [6490] = 6476,
  [6491] = 5910,
  [6492] = 6492,
  [6493] = 6476,
  [6494] = 6476,
  [6495] = 6029,
  [6496] = 6037,
  [6497] = 5911,
  [6498] = 6476,
  [6499] = 6485,
  [6500] = 6476,
  [6501] = 2191,
  [6502] = 6484,
  [6503] = 6035,
  [6504] = 6476,
  [6505] = 6480,
  [6506] = 6476,
  [6507] = 6476,
  [6508] = 6476,
  [6509] = 6476,
  [6510] = 6476,
  [6511] = 6476,
  [6512] = 5947,
  [6513] = 6476,
  [6514] = 6484,
  [6515] = 6480,
  [6516] = 6484,
  [6517] = 5760,
  [6518] = 6480,
  [6519] = 6485,
  [6520] = 6480,
  [6521] = 6041,
  [6522] = 6476,
  [6523] = 6480,
  [6524] = 6492,
  [6525] = 6480,
  [6526] = 2218,
  [6527] = 5901,
  [6528] = 6476,
  [6529] = 6485,
  [6530] = 6492,
  [6531] = 6492,
  [6532] = 6048,
  [6533] = 5903,
  [6534] = 5903,
  [6535] = 5909,
  [6536] = 6536,
  [6537] = 6537,
  [6538] = 6538,
  [6539] = 6029,
  [6540] = 6537,
  [6541] = 6037,
  [6542] = 6542,
  [6543] = 6538,
  [6544] = 6041,
  [6545] = 6545,
  [6546] = 6025,
  [6547] = 6547,
  [6548] = 5911,
  [6549] = 6028,
  [6550] = 6542,
  [6551] = 6551,
  [6552] = 6552,
  [6553] = 6553,
  [6554] = 5947,
  [6555] = 6555,
  [6556] = 6542,
  [6557] = 5911,
  [6558] = 6035,
  [6559] = 6538,
  [6560] = 6560,
  [6561] = 5911,
  [6562] = 5911,
  [6563] = 6563,
  [6564] = 6564,
  [6565] = 5905,
  [6566] = 5906,
  [6567] = 6542,
  [6568] = 5910,
  [6569] = 6569,
  [6570] = 5901,
  [6571] = 5901,
  [6572] = 5903,
  [6573] = 5760,
  [6574] = 6089,
  [6575] = 6542,
  [6576] = 6576,
  [6577] = 6065,
  [6578] = 5909,
  [6579] = 6015,
  [6580] = 6580,
  [6581] = 6537,
  [6582] = 6582,
  [6583] = 6538,
  [6584] = 6048,
  [6585] = 5901,
  [6586] = 5741,
  [6587] = 5909,
  [6588] = 2344,
  [6589] = 5901,
  [6590] = 6537,
  [6591] = 5903,
  [6592] = 6542,
  [6593] = 5909,
  [6594] = 6542,
  [6595] = 2344,
  [6596] = 6596,
  [6597] = 6597,
  [6598] = 6598,
  [6599] = 6599,
  [6600] = 6600,
  [6601] = 6601,
  [6602] = 6602,
  [6603] = 6603,
  [6604] = 6597,
  [6605] = 6605,
  [6606] = 6606,
  [6607] = 6607,
  [6608] = 6608,
  [6609] = 5901,
  [6610] = 6610,
  [6611] = 6600,
  [6612] = 2159,
  [6613] = 6603,
  [6614] = 6597,
  [6615] = 6600,
  [6616] = 5909,
  [6617] = 5905,
  [6618] = 5910,
  [6619] = 5903,
  [6620] = 6620,
  [6621] = 2349,
  [6622] = 6601,
  [6623] = 6623,
  [6624] = 2125,
  [6625] = 5906,
  [6626] = 6600,
  [6627] = 6610,
  [6628] = 6620,
  [6629] = 2330,
  [6630] = 6606,
  [6631] = 6610,
  [6632] = 6620,
  [6633] = 5910,
  [6634] = 6610,
  [6635] = 6635,
  [6636] = 6636,
  [6637] = 6610,
  [6638] = 6638,
  [6639] = 6620,
  [6640] = 6640,
  [6641] = 6610,
  [6642] = 6620,
  [6643] = 2136,
  [6644] = 6610,
  [6645] = 6636,
  [6646] = 6601,
  [6647] = 2121,
  [6648] = 6648,
  [6649] = 2360,
  [6650] = 5947,
  [6651] = 5947,
  [6652] = 6652,
  [6653] = 6653,
  [6654] = 6636,
  [6655] = 5901,
  [6656] = 6620,
  [6657] = 5903,
  [6658] = 5909,
  [6659] = 5911,
  [6660] = 6636,
  [6661] = 6661,
  [6662] = 5905,
  [6663] = 6663,
  [6664] = 2128,
  [6665] = 5911,
  [6666] = 6601,
  [6667] = 6597,
  [6668] = 5906,
  [6669] = 6620,
  [6670] = 6224,
  [6671] = 6671,
  [6672] = 6672,
  [6673] = 6673,
  [6674] = 6674,
  [6675] = 6671,
  [6676] = 6676,
  [6677] = 6210,
  [6678] = 6678,
  [6679] = 6673,
  [6680] = 6680,
  [6681] = 6680,
  [6682] = 6682,
  [6683] = 6682,
  [6684] = 6684,
  [6685] = 6685,
  [6686] = 6686,
  [6687] = 6672,
  [6688] = 6672,
  [6689] = 6671,
  [6690] = 6671,
  [6691] = 6674,
  [6692] = 6692,
  [6693] = 2344,
  [6694] = 6694,
  [6695] = 6695,
  [6696] = 6696,
  [6697] = 6697,
  [6698] = 6698,
  [6699] = 6678,
  [6700] = 6671,
  [6701] = 6266,
  [6702] = 6672,
  [6703] = 6703,
  [6704] = 6704,
  [6705] = 6673,
  [6706] = 2344,
  [6707] = 6672,
  [6708] = 6672,
  [6709] = 6709,
  [6710] = 6686,
  [6711] = 6695,
  [6712] = 6712,
  [6713] = 6678,
  [6714] = 6674,
  [6715] = 6715,
  [6716] = 6684,
  [6717] = 6672,
  [6718] = 6671,
  [6719] = 6682,
  [6720] = 6720,
  [6721] = 6671,
  [6722] = 6722,
  [6723] = 6695,
  [6724] = 6684,
  [6725] = 6686,
  [6726] = 6680,
  [6727] = 2255,
  [6728] = 6728,
  [6729] = 6728,
  [6730] = 6730,
  [6731] = 6731,
  [6732] = 6730,
  [6733] = 6733,
  [6734] = 6734,
  [6735] = 6735,
  [6736] = 6734,
  [6737] = 6734,
  [6738] = 6730,
  [6739] = 6739,
  [6740] = 6739,
  [6741] = 6728,
  [6742] = 5903,
  [6743] = 6730,
  [6744] = 6744,
  [6745] = 6734,
  [6746] = 6734,
  [6747] = 5905,
  [6748] = 6730,
  [6749] = 6749,
  [6750] = 5910,
  [6751] = 6751,
  [6752] = 6733,
  [6753] = 2344,
  [6754] = 6754,
  [6755] = 5906,
  [6756] = 2293,
  [6757] = 6751,
  [6758] = 5741,
  [6759] = 6728,
  [6760] = 5911,
  [6761] = 6761,
  [6762] = 6762,
  [6763] = 6734,
  [6764] = 6754,
  [6765] = 6754,
  [6766] = 6754,
  [6767] = 6728,
  [6768] = 6754,
  [6769] = 6769,
  [6770] = 6754,
  [6771] = 6771,
  [6772] = 2344,
  [6773] = 6734,
  [6774] = 6754,
  [6775] = 5947,
  [6776] = 6739,
  [6777] = 6730,
  [6778] = 6728,
  [6779] = 5909,
  [6780] = 5901,
  [6781] = 6781,
  [6782] = 6754,
  [6783] = 6730,
  [6784] = 6728,
  [6785] = 6751,
  [6786] = 6786,
  [6787] = 6787,
  [6788] = 6788,
  [6789] = 6789,
  [6790] = 6754,
  [6791] = 6751,
  [6792] = 6792,
  [6793] = 6734,
  [6794] = 6739,
  [6795] = 6730,
  [6796] = 6728,
  [6797] = 6730,
  [6798] = 6728,
  [6799] = 6739,
  [6800] = 6789,
  [6801] = 6734,
  [6802] = 6802,
  [6803] = 6803,
  [6804] = 6804,
  [6805] = 6803,
  [6806] = 6803,
  [6807] = 6807,
  [6808] = 6804,
  [6809] = 6809,
  [6810] = 6810,
  [6811] = 6811,
  [6812] = 6809,
  [6813] = 6813,
  [6814] = 6814,
  [6815] = 6815,
  [6816] = 6816,
  [6817] = 6817,
  [6818] = 6804,
  [6819] = 6819,
  [6820] = 6803,
  [6821] = 6821,
  [6822] = 6809,
  [6823] = 6810,
  [6824] = 6824,
  [6825] = 6809,
  [6826] = 6813,
  [6827] = 6814,
  [6828] = 6828,
  [6829] = 6829,
  [6830] = 6815,
  [6831] = 6802,
  [6832] = 6832,
  [6833] = 6816,
  [6834] = 6817,
  [6835] = 6804,
  [6836] = 6803,
  [6837] = 6837,
  [6838] = 6813,
  [6839] = 6814,
  [6840] = 6810,
  [6841] = 6809,
  [6842] = 6813,
  [6843] = 6814,
  [6844] = 6802,
  [6845] = 6816,
  [6846] = 6817,
  [6847] = 6804,
  [6848] = 6803,
  [6849] = 6849,
  [6850] = 6850,
  [6851] = 6810,
  [6852] = 6852,
  [6853] = 6813,
  [6854] = 6814,
  [6855] = 6817,
  [6856] = 6810,
  [6857] = 6810,
  [6858] = 6813,
  [6859] = 6814,
  [6860] = 6817,
  [6861] = 6861,
  [6862] = 6862,
  [6863] = 6810,
  [6864] = 6814,
  [6865] = 6817,
  [6866] = 6810,
  [6867] = 6815,
  [6868] = 6807,
  [6869] = 6814,
  [6870] = 6817,
  [6871] = 6810,
  [6872] = 6814,
  [6873] = 6817,
  [6874] = 6874,
  [6875] = 6807,
  [6876] = 6862,
  [6877] = 6810,
  [6878] = 6809,
  [6879] = 6814,
  [6880] = 6817,
  [6881] = 6810,
  [6882] = 6814,
  [6883] = 6817,
  [6884] = 6810,
  [6885] = 6813,
  [6886] = 6814,
  [6887] = 6810,
  [6888] = 6814,
  [6889] = 6814,
  [6890] = 6852,
  [6891] = 6815,
  [6892] = 6803,
  [6893] = 6802,
  [6894] = 6802,
  [6895] = 6874,
  [6896] = 6896,
  [6897] = 6896,
  [6898] = 6898,
  [6899] = 6816,
  [6900] = 6817,
  [6901] = 6832,
  [6902] = 6902,
  [6903] = 6903,
  [6904] = 6849,
  [6905] = 2344,
  [6906] = 6804,
  [6907] = 6896,
  [6908] = 6908,
  [6909] = 6803,
  [6910] = 6910,
  [6911] = 6898,
  [6912] = 6912,
  [6913] = 6913,
  [6914] = 6914,
  [6915] = 6915,
  [6916] = 6816,
  [6917] = 6813,
  [6918] = 6810,
  [6919] = 6817,
  [6920] = 6920,
  [6921] = 6810,
  [6922] = 6862,
  [6923] = 6862,
  [6924] = 6814,
  [6925] = 6807,
  [6926] = 6832,
  [6927] = 6809,
  [6928] = 6807,
  [6929] = 6813,
  [6930] = 6814,
  [6931] = 6810,
  [6932] = 6932,
  [6933] = 6933,
  [6934] = 6934,
  [6935] = 6815,
  [6936] = 6802,
  [6937] = 6809,
  [6938] = 6874,
  [6939] = 6896,
  [6940] = 6898,
  [6941] = 6816,
  [6942] = 6813,
  [6943] = 6814,
  [6944] = 6817,
  [6945] = 6832,
  [6946] = 6946,
  [6947] = 6852,
  [6948] = 6804,
  [6949] = 6815,
  [6950] = 6852,
  [6951] = 6874,
  [6952] = 6898,
  [6953] = 6898,
  [6954] = 6803,
  [6955] = 6802,
  [6956] = 6956,
  [6957] = 6957,
  [6958] = 6802,
  [6959] = 6874,
  [6960] = 6804,
  [6961] = 6898,
  [6962] = 6962,
  [6963] = 6810,
  [6964] = 6874,
  [6965] = 5741,
  [6966] = 6898,
  [6967] = 6862,
  [6968] = 6807,
  [6969] = 6896,
  [6970] = 6874,
  [6971] = 6809,
  [6972] = 6813,
  [6973] = 6814,
  [6974] = 6816,
  [6975] = 6810,
  [6976] = 6815,
  [6977] = 6802,
  [6978] = 6978,
  [6979] = 6816,
  [6980] = 6932,
  [6981] = 6817,
  [6982] = 6816,
  [6983] = 6849,
  [6984] = 6817,
  [6985] = 6832,
  [6986] = 6832,
  [6987] = 6987,
  [6988] = 6804,
  [6989] = 6989,
  [6990] = 6815,
  [6991] = 6803,
  [6992] = 6809,
  [6993] = 6816,
  [6994] = 6804,
  [6995] = 6932,
  [6996] = 6849,
  [6997] = 6810,
  [6998] = 6932,
  [6999] = 6849,
  [7000] = 6862,
  [7001] = 6932,
  [7002] = 6849,
  [7003] = 6862,
  [7004] = 6932,
  [7005] = 6849,
  [7006] = 6932,
  [7007] = 6849,
  [7008] = 6932,
  [7009] = 6849,
  [7010] = 6809,
  [7011] = 6932,
  [7012] = 6813,
  [7013] = 6814,
  [7014] = 6809,
  [7015] = 6816,
  [7016] = 7016,
  [7017] = 6815,
  [7018] = 7018,
  [7019] = 6802,
  [7020] = 6816,
  [7021] = 6817,
  [7022] = 7022,
  [7023] = 6832,
  [7024] = 6817,
  [7025] = 6896,
  [7026] = 7026,
  [7027] = 7027,
  [7028] = 7028,
  [7029] = 7029,
  [7030] = 7030,
  [7031] = 7031,
  [7032] = 7028,
  [7033] = 7033,
  [7034] = 7033,
  [7035] = 7035,
  [7036] = 7036,
  [7037] = 7037,
  [7038] = 7038,
  [7039] = 7039,
  [7040] = 7040,
  [7041] = 7041,
  [7042] = 7042,
  [7043] = 7043,
  [7044] = 7044,
  [7045] = 7045,
  [7046] = 7046,
  [7047] = 7047,
  [7048] = 7048,
  [7049] = 7049,
  [7050] = 7048,
  [7051] = 7051,
  [7052] = 7052,
  [7053] = 7040,
  [7054] = 7054,
  [7055] = 7038,
  [7056] = 7056,
  [7057] = 7057,
  [7058] = 7047,
  [7059] = 7059,
  [7060] = 7060,
  [7061] = 7045,
  [7062] = 7062,
  [7063] = 7063,
  [7064] = 7064,
  [7065] = 7065,
  [7066] = 7066,
  [7067] = 7029,
  [7068] = 7028,
  [7069] = 7069,
  [7070] = 7070,
  [7071] = 7071,
  [7072] = 7072,
  [7073] = 7037,
  [7074] = 7036,
  [7075] = 7059,
  [7076] = 7076,
  [7077] = 7077,
  [7078] = 7035,
  [7079] = 7041,
  [7080] = 7040,
  [7081] = 7047,
  [7082] = 7062,
  [7083] = 7083,
  [7084] = 7084,
  [7085] = 7085,
  [7086] = 7086,
  [7087] = 7038,
  [7088] = 7033,
  [7089] = 7057,
  [7090] = 7090,
  [7091] = 7091,
  [7092] = 7092,
  [7093] = 7062,
  [7094] = 7094,
  [7095] = 7045,
  [7096] = 7033,
  [7097] = 7097,
  [7098] = 7042,
  [7099] = 7056,
  [7100] = 7059,
  [7101] = 7040,
  [7102] = 7102,
  [7103] = 7047,
  [7104] = 7062,
  [7105] = 7105,
  [7106] = 7106,
  [7107] = 7107,
  [7108] = 7108,
  [7109] = 229,
  [7110] = 7054,
  [7111] = 7090,
  [7112] = 7112,
  [7113] = 7091,
  [7114] = 2387,
  [7115] = 2344,
  [7116] = 7043,
  [7117] = 7092,
  [7118] = 7045,
  [7119] = 7063,
  [7120] = 7120,
  [7121] = 7029,
  [7122] = 6569,
  [7123] = 7123,
  [7124] = 7124,
  [7125] = 7125,
  [7126] = 7083,
  [7127] = 7097,
  [7128] = 7069,
  [7129] = 7120,
  [7130] = 7045,
  [7131] = 7033,
  [7132] = 7132,
  [7133] = 7037,
  [7134] = 7063,
  [7135] = 7135,
  [7136] = 7042,
  [7137] = 7137,
  [7138] = 7045,
  [7139] = 7040,
  [7140] = 7047,
  [7141] = 7062,
  [7142] = 7063,
  [7143] = 7143,
  [7144] = 7048,
  [7145] = 7027,
  [7146] = 7048,
  [7147] = 7147,
  [7148] = 7051,
  [7149] = 7051,
  [7150] = 7090,
  [7151] = 7094,
  [7152] = 7107,
  [7153] = 7037,
  [7154] = 7052,
  [7155] = 7052,
  [7156] = 7033,
  [7157] = 7054,
  [7158] = 7158,
  [7159] = 7159,
  [7160] = 7160,
  [7161] = 7161,
  [7162] = 7033,
  [7163] = 7027,
  [7164] = 7086,
  [7165] = 7029,
  [7166] = 7028,
  [7167] = 7045,
  [7168] = 7040,
  [7169] = 7169,
  [7170] = 7038,
  [7171] = 7171,
  [7172] = 7057,
  [7173] = 7047,
  [7174] = 7062,
  [7175] = 7083,
  [7176] = 7043,
  [7177] = 7177,
  [7178] = 7125,
  [7179] = 7045,
  [7180] = 7070,
  [7181] = 7040,
  [7182] = 7182,
  [7183] = 7047,
  [7184] = 7048,
  [7185] = 7051,
  [7186] = 7052,
  [7187] = 7057,
  [7188] = 7063,
  [7189] = 7189,
  [7190] = 7190,
  [7191] = 7062,
  [7192] = 7192,
  [7193] = 7033,
  [7194] = 7194,
  [7195] = 7195,
  [7196] = 7196,
  [7197] = 7069,
  [7198] = 7072,
  [7199] = 7090,
  [7200] = 7107,
  [7201] = 2433,
  [7202] = 2434,
  [7203] = 7083,
  [7204] = 7035,
  [7205] = 7045,
  [7206] = 7041,
  [7207] = 7040,
  [7208] = 7047,
  [7209] = 7062,
  [7210] = 7027,
  [7211] = 7040,
  [7212] = 7047,
  [7213] = 7094,
  [7214] = 7062,
  [7215] = 7083,
  [7216] = 7086,
  [7217] = 7030,
  [7218] = 7196,
  [7219] = 7056,
  [7220] = 7220,
  [7221] = 7091,
  [7222] = 7092,
  [7223] = 7125,
  [7224] = 7097,
  [7225] = 7042,
  [7226] = 7072,
  [7227] = 7056,
  [7228] = 7059,
  [7229] = 7107,
  [7230] = 7230,
  [7231] = 7059,
  [7232] = 7033,
  [7233] = 7027,
  [7234] = 7033,
  [7235] = 7091,
  [7236] = 2458,
  [7237] = 7045,
  [7238] = 2459,
  [7239] = 7033,
  [7240] = 7240,
  [7241] = 7241,
  [7242] = 2467,
  [7243] = 2469,
  [7244] = 7107,
  [7245] = 7040,
  [7246] = 7246,
  [7247] = 2481,
  [7248] = 7047,
  [7249] = 7249,
  [7250] = 7250,
  [7251] = 7062,
  [7252] = 2482,
  [7253] = 7094,
  [7254] = 7037,
  [7255] = 2486,
  [7256] = 7090,
  [7257] = 7257,
  [7258] = 7258,
  [7259] = 7092,
  [7260] = 7107,
  [7261] = 7029,
  [7262] = 7037,
  [7263] = 7028,
  [7264] = 7033,
  [7265] = 7027,
  [7266] = 7030,
  [7267] = 7036,
  [7268] = 7045,
  [7269] = 7040,
  [7270] = 7047,
  [7271] = 7062,
  [7272] = 7272,
  [7273] = 7038,
  [7274] = 7063,
  [7275] = 7107,
  [7276] = 7069,
  [7277] = 7097,
  [7278] = 7107,
  [7279] = 7070,
  [7280] = 7094,
  [7281] = 7107,
  [7282] = 7107,
  [7283] = 7107,
  [7284] = 7042,
  [7285] = 7072,
  [7286] = 7033,
  [7287] = 7287,
  [7288] = 7288,
  [7289] = 7056,
  [7290] = 7056,
  [7291] = 7291,
  [7292] = 7029,
  [7293] = 7028,
  [7294] = 7294,
  [7295] = 7038,
  [7296] = 7043,
  [7297] = 7297,
  [7298] = 7085,
  [7299] = 7069,
  [7300] = 7045,
  [7301] = 7033,
  [7302] = 7043,
  [7303] = 7086,
  [7304] = 7045,
  [7305] = 7045,
  [7306] = 7083,
  [7307] = 7040,
  [7308] = 7308,
  [7309] = 7048,
  [7310] = 7051,
  [7311] = 7052,
  [7312] = 7057,
  [7313] = 7047,
  [7314] = 7062,
  [7315] = 7315,
  [7316] = 7044,
  [7317] = 230,
  [7318] = 7318,
  [7319] = 7048,
  [7320] = 7051,
  [7321] = 7052,
  [7322] = 7069,
  [7323] = 7072,
  [7324] = 7035,
  [7325] = 7041,
  [7326] = 7040,
  [7327] = 7047,
  [7328] = 7062,
  [7329] = 7054,
  [7330] = 7330,
  [7331] = 7091,
  [7332] = 7092,
  [7333] = 7083,
  [7334] = 7086,
  [7335] = 7335,
  [7336] = 7033,
  [7337] = 7033,
  [7338] = 7057,
  [7339] = 7091,
  [7340] = 7092,
  [7341] = 7091,
  [7342] = 7045,
  [7343] = 7035,
  [7344] = 7097,
  [7345] = 7042,
  [7346] = 7041,
  [7347] = 7347,
  [7348] = 7056,
  [7349] = 7059,
  [7350] = 7040,
  [7351] = 7047,
  [7352] = 7062,
  [7353] = 7196,
  [7354] = 7354,
  [7355] = 7123,
  [7356] = 7040,
  [7357] = 7357,
  [7358] = 7047,
  [7359] = 7062,
  [7360] = 7360,
  [7361] = 7086,
  [7362] = 7362,
  [7363] = 7085,
  [7364] = 7083,
  [7365] = 7092,
  [7366] = 7366,
  [7367] = 7367,
  [7368] = 7033,
  [7369] = 7125,
  [7370] = 7045,
  [7371] = 7097,
  [7372] = 7085,
  [7373] = 7042,
  [7374] = 7033,
  [7375] = 7033,
  [7376] = 7029,
  [7377] = 7037,
  [7378] = 7086,
  [7379] = 7044,
  [7380] = 7033,
  [7381] = 7063,
  [7382] = 7382,
  [7383] = 7069,
  [7384] = 7097,
  [7385] = 7037,
  [7386] = 7090,
  [7387] = 7107,
  [7388] = 7388,
  [7389] = 7051,
  [7390] = 7390,
  [7391] = 7094,
  [7392] = 7070,
  [7393] = 7063,
  [7394] = 7394,
  [7395] = 7072,
  [7396] = 7043,
  [7397] = 7397,
  [7398] = 7040,
  [7399] = 7047,
  [7400] = 7094,
  [7401] = 7033,
  [7402] = 7052,
  [7403] = 7033,
  [7404] = 7404,
  [7405] = 7029,
  [7406] = 7406,
  [7407] = 7028,
  [7408] = 7035,
  [7409] = 7041,
  [7410] = 7040,
  [7411] = 7035,
  [7412] = 7043,
  [7413] = 7047,
  [7414] = 7414,
  [7415] = 7415,
  [7416] = 7045,
  [7417] = 7041,
  [7418] = 7418,
  [7419] = 7062,
  [7420] = 7036,
  [7421] = 7094,
  [7422] = 7048,
  [7423] = 7051,
  [7424] = 7052,
  [7425] = 7062,
  [7426] = 7057,
  [7427] = 7027,
  [7428] = 7428,
  [7429] = 7429,
  [7430] = 7430,
  [7431] = 7431,
  [7432] = 7432,
  [7433] = 7429,
  [7434] = 7434,
  [7435] = 7435,
  [7436] = 7436,
  [7437] = 7437,
  [7438] = 7438,
  [7439] = 7439,
  [7440] = 7440,
  [7441] = 7441,
  [7442] = 7442,
  [7443] = 7443,
  [7444] = 7444,
  [7445] = 7445,
  [7446] = 7429,
  [7447] = 7445,
  [7448] = 7448,
  [7449] = 7449,
  [7450] = 7449,
  [7451] = 7451,
  [7452] = 7452,
  [7453] = 7453,
  [7454] = 7454,
  [7455] = 7434,
  [7456] = 7431,
  [7457] = 7454,
  [7458] = 7458,
  [7459] = 7459,
  [7460] = 7460,
  [7461] = 7428,
  [7462] = 7444,
  [7463] = 7463,
  [7464] = 7460,
  [7465] = 7429,
  [7466] = 7466,
  [7467] = 7467,
  [7468] = 7428,
  [7469] = 7469,
  [7470] = 7470,
  [7471] = 7471,
  [7472] = 7472,
  [7473] = 7466,
  [7474] = 7454,
  [7475] = 7466,
  [7476] = 7437,
  [7477] = 7477,
  [7478] = 7478,
  [7479] = 7479,
  [7480] = 7437,
  [7481] = 7454,
  [7482] = 7449,
  [7483] = 7460,
  [7484] = 7431,
  [7485] = 7477,
  [7486] = 7428,
  [7487] = 7437,
  [7488] = 7437,
  [7489] = 7449,
  [7490] = 7451,
  [7491] = 7491,
  [7492] = 7430,
  [7493] = 7493,
  [7494] = 7459,
  [7495] = 7452,
  [7496] = 7440,
  [7497] = 7445,
  [7498] = 7442,
  [7499] = 7499,
  [7500] = 7500,
  [7501] = 7466,
  [7502] = 7502,
  [7503] = 7435,
  [7504] = 7504,
  [7505] = 7451,
  [7506] = 7506,
  [7507] = 7459,
  [7508] = 7472,
  [7509] = 7509,
  [7510] = 7478,
  [7511] = 7449,
  [7512] = 7437,
  [7513] = 7477,
  [7514] = 7458,
  [7515] = 7449,
  [7516] = 7469,
  [7517] = 7471,
  [7518] = 7432,
  [7519] = 7519,
  [7520] = 7445,
  [7521] = 7521,
  [7522] = 7432,
  [7523] = 7523,
  [7524] = 7524,
  [7525] = 7442,
  [7526] = 7526,
  [7527] = 7527,
  [7528] = 7454,
  [7529] = 7463,
  [7530] = 7431,
  [7531] = 7437,
  [7532] = 7430,
  [7533] = 7460,
  [7534] = 7428,
  [7535] = 7535,
  [7536] = 7444,
  [7537] = 7449,
  [7538] = 7429,
  [7539] = 7459,
  [7540] = 7441,
  [7541] = 7541,
  [7542] = 7451,
  [7543] = 7493,
  [7544] = 7436,
  [7545] = 7437,
  [7546] = 7449,
  [7547] = 7435,
  [7548] = 7440,
  [7549] = 7504,
  [7550] = 7506,
  [7551] = 7472,
  [7552] = 7449,
  [7553] = 7509,
  [7554] = 7444,
  [7555] = 7437,
  [7556] = 7429,
  [7557] = 7435,
  [7558] = 7469,
  [7559] = 7471,
  [7560] = 7432,
  [7561] = 7451,
  [7562] = 7524,
  [7563] = 7526,
  [7564] = 7478,
  [7565] = 7463,
  [7566] = 7566,
  [7567] = 7430,
  [7568] = 7459,
  [7569] = 7472,
  [7570] = 7449,
  [7571] = 7504,
  [7572] = 7506,
  [7573] = 7466,
  [7574] = 7509,
  [7575] = 7469,
  [7576] = 7471,
  [7577] = 7437,
  [7578] = 7478,
  [7579] = 7445,
  [7580] = 7445,
  [7581] = 7524,
  [7582] = 7526,
  [7583] = 7583,
  [7584] = 7436,
  [7585] = 7463,
  [7586] = 7430,
  [7587] = 7458,
  [7588] = 7436,
  [7589] = 7437,
  [7590] = 7449,
  [7591] = 7466,
  [7592] = 7504,
  [7593] = 7509,
  [7594] = 7469,
  [7595] = 7442,
  [7596] = 7506,
  [7597] = 7477,
  [7598] = 7526,
  [7599] = 7432,
  [7600] = 7463,
  [7601] = 7437,
  [7602] = 7430,
  [7603] = 7472,
  [7604] = 7604,
  [7605] = 7504,
  [7606] = 7509,
  [7607] = 7493,
  [7608] = 7469,
  [7609] = 7609,
  [7610] = 7442,
  [7611] = 7445,
  [7612] = 7436,
  [7613] = 7526,
  [7614] = 7445,
  [7615] = 7526,
  [7616] = 7463,
  [7617] = 7437,
  [7618] = 7435,
  [7619] = 7504,
  [7620] = 7509,
  [7621] = 7454,
  [7622] = 7469,
  [7623] = 7526,
  [7624] = 7440,
  [7625] = 7435,
  [7626] = 7469,
  [7627] = 7627,
  [7628] = 7460,
  [7629] = 7449,
  [7630] = 7441,
  [7631] = 7428,
  [7632] = 7469,
  [7633] = 7478,
  [7634] = 7634,
  [7635] = 7635,
  [7636] = 7444,
  [7637] = 7504,
  [7638] = 7458,
  [7639] = 7449,
  [7640] = 7460,
  [7641] = 7428,
  [7642] = 7444,
  [7643] = 7471,
  [7644] = 7444,
  [7645] = 7493,
  [7646] = 7506,
  [7647] = 7454,
  [7648] = 7648,
  [7649] = 7472,
  [7650] = 7460,
  [7651] = 7428,
  [7652] = 7509,
  [7653] = 7653,
  [7654] = 7454,
  [7655] = 7435,
  [7656] = 7656,
  [7657] = 7437,
  [7658] = 7429,
  [7659] = 7436,
  [7660] = 7478,
  [7661] = 7440,
  [7662] = 7662,
  [7663] = 7460,
  [7664] = 7444,
  [7665] = 7665,
  [7666] = 7504,
  [7667] = 7429,
  [7668] = 7469,
  [7669] = 7471,
  [7670] = 7451,
  [7671] = 7509,
  [7672] = 7524,
  [7673] = 7477,
  [7674] = 7432,
  [7675] = 7675,
  [7676] = 7458,
  [7677] = 7431,
  [7678] = 7459,
  [7679] = 7434,
  [7680] = 7445,
  [7681] = 7449,
  [7682] = 7460,
  [7683] = 7428,
  [7684] = 7429,
  [7685] = 7685,
  [7686] = 7686,
  [7687] = 7477,
  [7688] = 7451,
  [7689] = 7689,
  [7690] = 7452,
  [7691] = 7466,
  [7692] = 7692,
  [7693] = 7436,
  [7694] = 7694,
  [7695] = 7695,
  [7696] = 7696,
  [7697] = 7448,
  [7698] = 7437,
  [7699] = 7444,
  [7700] = 7429,
  [7701] = 7448,
  [7702] = 7627,
  [7703] = 7703,
  [7704] = 7704,
  [7705] = 7705,
  [7706] = 7445,
  [7707] = 7440,
  [7708] = 7454,
  [7709] = 7445,
  [7710] = 7435,
  [7711] = 7634,
  [7712] = 7524,
  [7713] = 7445,
  [7714] = 7441,
  [7715] = 7460,
  [7716] = 7428,
  [7717] = 7429,
  [7718] = 7718,
  [7719] = 7444,
  [7720] = 7720,
  [7721] = 7526,
  [7722] = 7722,
  [7723] = 7435,
  [7724] = 7460,
  [7725] = 7434,
  [7726] = 7478,
  [7727] = 7428,
  [7728] = 7728,
  [7729] = 7458,
  [7730] = 7449,
  [7731] = 7437,
  [7732] = 7429,
  [7733] = 7454,
  [7734] = 7460,
  [7735] = 7428,
  [7736] = 7736,
  [7737] = 7463,
  [7738] = 7738,
  [7739] = 7634,
  [7740] = 7740,
  [7741] = 7741,
  [7742] = 7634,
  [7743] = 7458,
  [7744] = 7634,
  [7745] = 7451,
  [7746] = 7634,
  [7747] = 7452,
  [7748] = 7634,
  [7749] = 7634,
  [7750] = 7634,
  [7751] = 7634,
  [7752] = 7634,
  [7753] = 7634,
  [7754] = 7634,
  [7755] = 7634,
  [7756] = 7634,
  [7757] = 7634,
  [7758] = 7634,
  [7759] = 7449,
  [7760] = 7448,
  [7761] = 7761,
  [7762] = 7762,
  [7763] = 7763,
  [7764] = 7764,
  [7765] = 7765,
  [7766] = 7766,
  [7767] = 7767,
  [7768] = 7768,
  [7769] = 7769,
  [7770] = 7770,
  [7771] = 7771,
  [7772] = 7772,
  [7773] = 7773,
  [7774] = 7774,
  [7775] = 7775,
  [7776] = 7776,
  [7777] = 7777,
  [7778] = 7770,
  [7779] = 7779,
  [7780] = 7771,
  [7781] = 7781,
  [7782] = 7782,
  [7783] = 7783,
  [7784] = 7779,
  [7785] = 7785,
  [7786] = 7786,
  [7787] = 7787,
  [7788] = 7788,
  [7789] = 7764,
  [7790] = 7790,
  [7791] = 7791,
  [7792] = 7792,
  [7793] = 7793,
  [7794] = 7794,
  [7795] = 7795,
  [7796] = 7796,
  [7797] = 7775,
  [7798] = 7798,
  [7799] = 7799,
  [7800] = 7800,
  [7801] = 7779,
  [7802] = 7802,
  [7803] = 7803,
  [7804] = 7804,
  [7805] = 7772,
  [7806] = 7806,
  [7807] = 7769,
  [7808] = 7808,
  [7809] = 7809,
  [7810] = 7810,
  [7811] = 7811,
  [7812] = 7773,
  [7813] = 7813,
  [7814] = 7777,
  [7815] = 7793,
  [7816] = 7804,
  [7817] = 7787,
  [7818] = 7818,
  [7819] = 7785,
  [7820] = 7820,
  [7821] = 7821,
  [7822] = 7822,
  [7823] = 7823,
  [7824] = 7824,
  [7825] = 7825,
  [7826] = 7769,
  [7827] = 7827,
  [7828] = 7828,
  [7829] = 7829,
  [7830] = 7786,
  [7831] = 7831,
  [7832] = 7832,
  [7833] = 7833,
  [7834] = 7779,
  [7835] = 7835,
  [7836] = 7836,
  [7837] = 7837,
  [7838] = 7838,
  [7839] = 7839,
  [7840] = 7824,
  [7841] = 7841,
  [7842] = 7771,
  [7843] = 7779,
  [7844] = 7771,
  [7845] = 7845,
  [7846] = 7764,
  [7847] = 7777,
  [7848] = 7837,
  [7849] = 7849,
  [7850] = 7775,
  [7851] = 7770,
  [7852] = 7791,
  [7853] = 7853,
  [7854] = 7777,
  [7855] = 7855,
  [7856] = 7783,
  [7857] = 7857,
  [7858] = 7858,
  [7859] = 7859,
  [7860] = 7779,
  [7861] = 7813,
  [7862] = 7862,
  [7863] = 7863,
  [7864] = 7864,
  [7865] = 7865,
  [7866] = 7866,
  [7867] = 6786,
  [7868] = 7868,
  [7869] = 7869,
  [7870] = 7827,
  [7871] = 7857,
  [7872] = 7872,
  [7873] = 7873,
  [7874] = 7874,
  [7875] = 7875,
  [7876] = 7876,
  [7877] = 7877,
  [7878] = 7878,
  [7879] = 7879,
  [7880] = 7880,
  [7881] = 7880,
  [7882] = 7771,
  [7883] = 7883,
  [7884] = 7884,
  [7885] = 7772,
  [7886] = 7773,
  [7887] = 7798,
  [7888] = 7824,
  [7889] = 7791,
  [7890] = 7776,
  [7891] = 7891,
  [7892] = 7892,
  [7893] = 7893,
  [7894] = 7768,
  [7895] = 7766,
  [7896] = 7771,
  [7897] = 7897,
  [7898] = 7777,
  [7899] = 7779,
  [7900] = 7771,
  [7901] = 7798,
  [7902] = 7902,
  [7903] = 7858,
  [7904] = 7810,
  [7905] = 7905,
  [7906] = 7787,
  [7907] = 7762,
  [7908] = 7832,
  [7909] = 7820,
  [7910] = 7910,
  [7911] = 7763,
  [7912] = 7912,
  [7913] = 7913,
  [7914] = 7914,
  [7915] = 7827,
  [7916] = 7804,
  [7917] = 7917,
  [7918] = 7918,
  [7919] = 7919,
  [7920] = 7920,
  [7921] = 7921,
  [7922] = 7922,
  [7923] = 7833,
  [7924] = 7924,
  [7925] = 7925,
  [7926] = 7926,
  [7927] = 7863,
  [7928] = 7928,
  [7929] = 7929,
  [7930] = 7849,
  [7931] = 7931,
  [7932] = 7932,
  [7933] = 7933,
  [7934] = 7934,
  [7935] = 7880,
  [7936] = 7936,
  [7937] = 7859,
  [7938] = 7938,
  [7939] = 7768,
  [7940] = 7940,
  [7941] = 7941,
  [7942] = 7831,
  [7943] = 7866,
  [7944] = 7944,
  [7945] = 7798,
  [7946] = 7897,
  [7947] = 7947,
  [7948] = 7813,
  [7949] = 7869,
  [7950] = 7874,
  [7951] = 7868,
  [7952] = 7878,
  [7953] = 7880,
  [7954] = 7879,
  [7955] = 7800,
  [7956] = 7820,
  [7957] = 7934,
  [7958] = 7772,
  [7959] = 7773,
  [7960] = 7960,
  [7961] = 7810,
  [7962] = 7962,
  [7963] = 7766,
  [7964] = 7788,
  [7965] = 7965,
  [7966] = 7966,
  [7967] = 7967,
  [7968] = 7827,
  [7969] = 7790,
  [7970] = 7836,
  [7971] = 7792,
  [7972] = 7972,
  [7973] = 7803,
  [7974] = 7825,
  [7975] = 7975,
  [7976] = 7779,
  [7977] = 7977,
  [7978] = 7771,
  [7979] = 7979,
  [7980] = 7980,
  [7981] = 7769,
  [7982] = 7849,
  [7983] = 7774,
  [7984] = 7984,
  [7985] = 7985,
  [7986] = 7986,
  [7987] = 7987,
  [7988] = 7859,
  [7989] = 7813,
  [7990] = 7928,
  [7991] = 7991,
  [7992] = 7813,
  [7993] = 7993,
  [7994] = 7866,
  [7995] = 7864,
  [7996] = 7996,
  [7997] = 7997,
  [7998] = 7831,
  [7999] = 7764,
  [8000] = 8000,
  [8001] = 8001,
  [8002] = 7767,
  [8003] = 7878,
  [8004] = 7788,
  [8005] = 7790,
  [8006] = 7792,
  [8007] = 7919,
  [8008] = 7878,
  [8009] = 7772,
  [8010] = 7773,
  [8011] = 7874,
  [8012] = 7810,
  [8013] = 8013,
  [8014] = 7800,
  [8015] = 7879,
  [8016] = 7791,
  [8017] = 7793,
  [8018] = 7879,
  [8019] = 7827,
  [8020] = 8020,
  [8021] = 7876,
  [8022] = 8022,
  [8023] = 8023,
  [8024] = 8024,
  [8025] = 7762,
  [8026] = 7876,
  [8027] = 7996,
  [8028] = 7803,
  [8029] = 7767,
  [8030] = 7883,
  [8031] = 7837,
  [8032] = 7849,
  [8033] = 7779,
  [8034] = 8034,
  [8035] = 7996,
  [8036] = 7771,
  [8037] = 7932,
  [8038] = 7767,
  [8039] = 7788,
  [8040] = 7802,
  [8041] = 7866,
  [8042] = 7838,
  [8043] = 7790,
  [8044] = 7921,
  [8045] = 8045,
  [8046] = 7792,
  [8047] = 7779,
  [8048] = 7767,
  [8049] = 7788,
  [8050] = 7790,
  [8051] = 7783,
  [8052] = 7875,
  [8053] = 7772,
  [8054] = 7773,
  [8055] = 7839,
  [8056] = 7792,
  [8057] = 7874,
  [8058] = 7879,
  [8059] = 8059,
  [8060] = 7919,
  [8061] = 7802,
  [8062] = 7849,
  [8063] = 7796,
  [8064] = 7793,
  [8065] = 7770,
  [8066] = 7866,
  [8067] = 8001,
  [8068] = 8013,
  [8069] = 7773,
  [8070] = 7791,
  [8071] = 7838,
  [8072] = 7783,
  [8073] = 7767,
  [8074] = 7869,
  [8075] = 7849,
  [8076] = 7940,
  [8077] = 8077,
  [8078] = 7866,
  [8079] = 7788,
  [8080] = 7773,
  [8081] = 8081,
  [8082] = 7771,
  [8083] = 7790,
  [8084] = 8084,
  [8085] = 7849,
  [8086] = 7866,
  [8087] = 7773,
  [8088] = 7810,
  [8089] = 7869,
  [8090] = 7866,
  [8091] = 7773,
  [8092] = 7811,
  [8093] = 7777,
  [8094] = 7866,
  [8095] = 7773,
  [8096] = 7866,
  [8097] = 7773,
  [8098] = 7866,
  [8099] = 7773,
  [8100] = 7866,
  [8101] = 7773,
  [8102] = 7866,
  [8103] = 7773,
  [8104] = 7866,
  [8105] = 7773,
  [8106] = 7776,
  [8107] = 8107,
  [8108] = 7783,
  [8109] = 8107,
  [8110] = 7792,
  [8111] = 7965,
  [8112] = 7764,
  [8113] = 7905,
  [8114] = 8114,
  [8115] = 8115,
  [8116] = 8020,
  [8117] = 7947,
  [8118] = 8118,
  [8119] = 7876,
  [8120] = 8001,
  [8121] = 8001,
  [8122] = 7767,
  [8123] = 8123,
  [8124] = 7839,
  [8125] = 7774,
  [8126] = 8126,
  [8127] = 7790,
  [8128] = 8128,
  [8129] = 7769,
  [8130] = 7932,
  [8131] = 8001,
  [8132] = 7768,
  [8133] = 8133,
  [8134] = 8134,
  [8135] = 8135,
  [8136] = 8136,
  [8137] = 7857,
  [8138] = 7785,
  [8139] = 7858,
  [8140] = 7762,
  [8141] = 7838,
  [8142] = 8084,
  [8143] = 8143,
  [8144] = 7833,
  [8145] = 8045,
  [8146] = 7763,
  [8147] = 7940,
  [8148] = 8148,
  [8149] = 8149,
  [8150] = 7919,
  [8151] = 8126,
  [8152] = 5678,
  [8153] = 8153,
  [8154] = 7798,
  [8155] = 8155,
  [8156] = 8123,
  [8157] = 8153,
  [8158] = 7762,
  [8159] = 8159,
  [8160] = 7820,
  [8161] = 7838,
  [8162] = 7802,
  [8163] = 7849,
  [8164] = 7791,
  [8165] = 8165,
  [8166] = 7775,
  [8167] = 7769,
  [8168] = 7762,
  [8169] = 7763,
  [8170] = 7779,
  [8171] = 7864,
  [8172] = 7768,
  [8173] = 7863,
  [8174] = 8174,
  [8175] = 8175,
  [8176] = 7781,
  [8177] = 8136,
  [8178] = 7768,
  [8179] = 7761,
  [8180] = 8013,
  [8181] = 8181,
  [8182] = 7827,
  [8183] = 7774,
  [8184] = 7831,
  [8185] = 7919,
  [8186] = 8186,
  [8187] = 8187,
  [8188] = 8188,
  [8189] = 8189,
  [8190] = 8190,
  [8191] = 8191,
  [8192] = 7862,
  [8193] = 7771,
  [8194] = 8194,
  [8195] = 7785,
  [8196] = 7786,
  [8197] = 7787,
  [8198] = 8198,
  [8199] = 7764,
  [8200] = 8200,
  [8201] = 7791,
  [8202] = 7767,
  [8203] = 7774,
  [8204] = 7875,
  [8205] = 7775,
  [8206] = 8118,
  [8207] = 8207,
  [8208] = 7940,
  [8209] = 8209,
  [8210] = 1769,
  [8211] = 7800,
  [8212] = 7878,
  [8213] = 7837,
  [8214] = 7783,
  [8215] = 8215,
  [8216] = 8216,
  [8217] = 8217,
  [8218] = 8218,
  [8219] = 7793,
  [8220] = 7770,
  [8221] = 8221,
  [8222] = 7769,
  [8223] = 7802,
  [8224] = 7831,
  [8225] = 7802,
  [8226] = 5599,
  [8227] = 8143,
  [8228] = 8228,
  [8229] = 7839,
  [8230] = 7779,
  [8231] = 8231,
  [8232] = 8232,
  [8233] = 8233,
  [8234] = 7841,
  [8235] = 7810,
  [8236] = 7811,
  [8237] = 7775,
  [8238] = 7770,
  [8239] = 5617,
  [8240] = 7810,
  [8241] = 7883,
  [8242] = 8181,
  [8243] = 8243,
  [8244] = 7940,
  [8245] = 8245,
  [8246] = 8246,
  [8247] = 7779,
  [8248] = 8248,
  [8249] = 8249,
  [8250] = 7762,
  [8251] = 8251,
  [8252] = 8252,
  [8253] = 7878,
  [8254] = 7786,
  [8255] = 7947,
  [8256] = 7838,
  [8257] = 8045,
  [8258] = 7787,
  [8259] = 7798,
  [8260] = 8260,
  [8261] = 7934,
  [8262] = 8262,
  [8263] = 7868,
  [8264] = 7764,
  [8265] = 7825,
  [8266] = 7839,
  [8267] = 7880,
  [8268] = 7874,
  [8269] = 7883,
  [8270] = 7824,
  [8271] = 8271,
  [8272] = 7824,
  [8273] = 8273,
  [8274] = 7768,
  [8275] = 7838,
  [8276] = 7820,
  [8277] = 8277,
  [8278] = 7790,
  [8279] = 8279,
  [8280] = 8280,
  [8281] = 7764,
  [8282] = 7769,
  [8283] = 7766,
  [8284] = 7762,
  [8285] = 7771,
  [8286] = 7786,
  [8287] = 7777,
  [8288] = 8288,
  [8289] = 8289,
  [8290] = 8290,
  [8291] = 7798,
  [8292] = 8292,
  [8293] = 7764,
  [8294] = 8126,
  [8295] = 7832,
  [8296] = 8296,
  [8297] = 7849,
  [8298] = 7931,
  [8299] = 8001,
  [8300] = 7791,
  [8301] = 8301,
  [8302] = 8302,
  [8303] = 7827,
  [8304] = 7869,
  [8305] = 8305,
  [8306] = 8123,
  [8307] = 7775,
  [8308] = 8107,
  [8309] = 7761,
  [8310] = 7905,
  [8311] = 8020,
  [8312] = 7919,
  [8313] = 8118,
  [8314] = 7767,
  [8315] = 7767,
  [8316] = 8316,
  [8317] = 7770,
  [8318] = 8318,
  [8319] = 8134,
  [8320] = 7883,
  [8321] = 8136,
  [8322] = 7779,
  [8323] = 7800,
  [8324] = 7876,
  [8325] = 8084,
  [8326] = 8143,
  [8327] = 7940,
  [8328] = 7836,
  [8329] = 7762,
  [8330] = 8159,
  [8331] = 5680,
  [8332] = 7792,
  [8333] = 8333,
  [8334] = 7781,
  [8335] = 8181,
  [8336] = 7803,
  [8337] = 1772,
  [8338] = 8107,
  [8339] = 7761,
  [8340] = 8020,
  [8341] = 7838,
  [8342] = 8118,
  [8343] = 7766,
  [8344] = 7997,
  [8345] = 8134,
  [8346] = 7857,
  [8347] = 8136,
  [8348] = 7788,
  [8349] = 8349,
  [8350] = 8084,
  [8351] = 8143,
  [8352] = 8159,
  [8353] = 7766,
  [8354] = 7921,
  [8355] = 8355,
  [8356] = 7781,
  [8357] = 8181,
  [8358] = 7821,
  [8359] = 8107,
  [8360] = 7761,
  [8361] = 8020,
  [8362] = 7771,
  [8363] = 8118,
  [8364] = 8364,
  [8365] = 7996,
  [8366] = 8134,
  [8367] = 8136,
  [8368] = 7947,
  [8369] = 7966,
  [8370] = 8084,
  [8371] = 8143,
  [8372] = 8159,
  [8373] = 7769,
  [8374] = 8374,
  [8375] = 7767,
  [8376] = 7781,
  [8377] = 8181,
  [8378] = 7788,
  [8379] = 8107,
  [8380] = 7761,
  [8381] = 8020,
  [8382] = 7790,
  [8383] = 8118,
  [8384] = 7858,
  [8385] = 7792,
  [8386] = 8136,
  [8387] = 7838,
  [8388] = 7821,
  [8389] = 8084,
  [8390] = 8143,
  [8391] = 8159,
  [8392] = 7940,
  [8393] = 7947,
  [8394] = 8394,
  [8395] = 7781,
  [8396] = 8181,
  [8397] = 7800,
  [8398] = 8107,
  [8399] = 7761,
  [8400] = 7866,
  [8401] = 8118,
  [8402] = 8402,
  [8403] = 7919,
  [8404] = 7838,
  [8405] = 8045,
  [8406] = 8084,
  [8407] = 8143,
  [8408] = 8408,
  [8409] = 8045,
  [8410] = 8410,
  [8411] = 7781,
  [8412] = 7876,
  [8413] = 8107,
  [8414] = 7761,
  [8415] = 8118,
  [8416] = 7791,
  [8417] = 8143,
  [8418] = 8410,
  [8419] = 7766,
  [8420] = 7781,
  [8421] = 7831,
  [8422] = 8107,
  [8423] = 7761,
  [8424] = 8118,
  [8425] = 8374,
  [8426] = 8143,
  [8427] = 7919,
  [8428] = 7781,
  [8429] = 8107,
  [8430] = 7761,
  [8431] = 8118,
  [8432] = 8143,
  [8433] = 7781,
  [8434] = 7761,
  [8435] = 8143,
  [8436] = 7781,
  [8437] = 7761,
  [8438] = 8143,
  [8439] = 7781,
  [8440] = 8143,
  [8441] = 7781,
  [8442] = 8143,
  [8443] = 7781,
  [8444] = 8143,
  [8445] = 7781,
  [8446] = 8143,
  [8447] = 7781,
  [8448] = 8143,
  [8449] = 7781,
  [8450] = 7771,
  [8451] = 8451,
  [8452] = 7905,
  [8453] = 8408,
  [8454] = 7910,
  [8455] = 7771,
  [8456] = 8456,
  [8457] = 7775,
  [8458] = 7859,
  [8459] = 8459,
  [8460] = 8460,
  [8461] = 7857,
  [8462] = 7762,
  [8463] = 8001,
  [8464] = 7763,
  [8465] = 7858,
  [8466] = 7824,
  [8467] = 7859,
  [8468] = 7785,
  [8469] = 7779,
  [8470] = 8153,
  [8471] = 8296,
  [8472] = 7771,
  [8473] = 7772,
  [8474] = 8159,
  [8475] = 7996,
  [8476] = 7773,
  [8477] = 7762,
  [8478] = 8478,
  [8479] = 7802,
  [8480] = 7849,
  [8481] = 8481,
  [8482] = 7786,
  [8483] = 7796,
  [8484] = 7792,
  [8485] = 7824,
  [8486] = 7835,
  [8487] = 8487,
  [8488] = 7800,
  [8489] = 7769,
  [8490] = 7779,
  [8491] = 8491,
  [8492] = 7787,
  [8493] = 7997,
  [8494] = 8494,
  [8495] = 8410,
  [8496] = 7767,
  [8497] = 7831,
  [8498] = 8498,
  [8499] = 7862,
  [8500] = 7821,
  [8501] = 7947,
  [8502] = 8402,
  [8503] = 7791,
  [8504] = 8504,
  [8505] = 7880,
  [8506] = 8506,
  [8507] = 8059,
  [8508] = 7866,
  [8509] = 7857,
  [8510] = 8001,
  [8511] = 8059,
  [8512] = 8512,
  [8513] = 8513,
  [8514] = 7864,
  [8515] = 7837,
  [8516] = 8516,
  [8517] = 8517,
  [8518] = 8518,
  [8519] = 7838,
  [8520] = 7858,
  [8521] = 7919,
  [8522] = 7839,
  [8523] = 7762,
  [8524] = 7763,
  [8525] = 7928,
  [8526] = 8526,
  [8527] = 7859,
  [8528] = 7996,
  [8529] = 7762,
  [8530] = 7883,
  [8531] = 8402,
  [8532] = 7838,
  [8533] = 7791,
  [8534] = 7806,
  [8535] = 7824,
  [8536] = 7905,
  [8537] = 8408,
  [8538] = 7910,
  [8539] = 8045,
  [8540] = 8540,
  [8541] = 7768,
  [8542] = 8013,
  [8543] = 8153,
  [8544] = 8296,
  [8545] = 7768,
  [8546] = 7866,
  [8547] = 7947,
  [8548] = 7771,
  [8549] = 7905,
  [8550] = 8408,
  [8551] = 7910,
  [8552] = 7836,
  [8553] = 7793,
  [8554] = 8153,
  [8555] = 8296,
  [8556] = 7767,
  [8557] = 7880,
  [8558] = 7774,
  [8559] = 8408,
  [8560] = 7910,
  [8561] = 8001,
  [8562] = 7919,
  [8563] = 8153,
  [8564] = 8296,
  [8565] = 7774,
  [8566] = 7788,
  [8567] = 8408,
  [8568] = 7910,
  [8569] = 8134,
  [8570] = 7824,
  [8571] = 8153,
  [8572] = 8296,
  [8573] = 7806,
  [8574] = 8408,
  [8575] = 7910,
  [8576] = 8576,
  [8577] = 8153,
  [8578] = 8296,
  [8579] = 7791,
  [8580] = 8153,
  [8581] = 8296,
  [8582] = 7996,
  [8583] = 8296,
  [8584] = 7864,
  [8585] = 8296,
  [8586] = 8013,
  [8587] = 8296,
  [8588] = 7764,
  [8589] = 8296,
  [8590] = 8001,
  [8591] = 8296,
  [8592] = 7779,
  [8593] = 8296,
  [8594] = 7768,
  [8595] = 8296,
  [8596] = 7811,
  [8597] = 8296,
  [8598] = 7997,
  [8599] = 8296,
  [8600] = 8277,
  [8601] = 8189,
  [8602] = 8602,
  [8603] = 8277,
  [8604] = 8189,
  [8605] = 7868,
  [8606] = 8277,
  [8607] = 8189,
  [8608] = 8123,
  [8609] = 8277,
  [8610] = 8189,
  [8611] = 7775,
  [8612] = 8277,
  [8613] = 8189,
  [8614] = 7785,
  [8615] = 8189,
  [8616] = 8189,
  [8617] = 8189,
  [8618] = 8189,
  [8619] = 8189,
  [8620] = 8189,
  [8621] = 8189,
  [8622] = 8189,
  [8623] = 8189,
  [8624] = 8189,
  [8625] = 8189,
  [8626] = 7786,
  [8627] = 7787,
  [8628] = 7791,
  [8629] = 8629,
  [8630] = 7931,
  [8631] = 8491,
  [8632] = 8491,
  [8633] = 8491,
  [8634] = 8491,
  [8635] = 8491,
  [8636] = 7785,
};

static TSCharacterRange sym_identifier_character_set_1[] = {
  {'$', '$'}, {'A', 'Z'}, {'\\', '\\'}, {'_', '_'}, {'a', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5}, {0xba, 0xba},
  {0xc0, 0xd6}, {0xd8, 0xf6}, {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec}, {0x2ee, 0x2ee}, {0x370, 0x374},
  {0x376, 0x377}, {0x37b, 0x37d}, {0x37f, 0x37f}, {0x386, 0x386}, {0x388, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5},
  {0x3f7, 0x481}, {0x48a, 0x52f}, {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x620, 0x64a},
  {0x66e, 0x66f}, {0x671, 0x6d3}, {0x6d5, 0x6d5}, {0x6e5, 0x6e6}, {0x6ee, 0x6ef}, {0x6fa, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x710},
  {0x712, 0x72f}, {0x74d, 0x7a5}, {0x7b1, 0x7b1}, {0x7ca, 0x7ea}, {0x7f4, 0x7f5}, {0x7fa, 0x7fa}, {0x800, 0x815}, {0x81a, 0x81a},
  {0x824, 0x824}, {0x828, 0x828}, {0x840, 0x858}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x8a0, 0x8c9}, {0x904, 0x939},
  {0x93d, 0x93d}, {0x950, 0x950}, {0x958, 0x961}, {0x971, 0x980}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0},
  {0x9b2, 0x9b2}, {0x9b6, 0x9b9}, {0x9bd, 0x9bd}, {0x9ce, 0x9ce}, {0x9dc, 0x9dd}, {0x9df, 0x9e1}, {0x9f0, 0x9f1}, {0x9fc, 0x9fc},
  {0xa05, 0xa0a}, {0xa0f, 0xa10}, {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33}, {0xa35, 0xa36}, {0xa38, 0xa39}, {0xa59, 0xa5c},
  {0xa5e, 0xa5e}, {0xa72, 0xa74}, {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3}, {0xab5, 0xab9},
  {0xabd, 0xabd}, {0xad0, 0xad0}, {0xae0, 0xae1}, {0xaf9, 0xaf9}, {0xb05, 0xb0c}, {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30},
  {0xb32, 0xb33}, {0xb35, 0xb39}, {0xb3d, 0xb3d}, {0xb5c, 0xb5d}, {0xb5f, 0xb61}, {0xb71, 0xb71}, {0xb83, 0xb83}, {0xb85, 0xb8a},
  {0xb8e, 0xb90}, {0xb92, 0xb95}, {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa}, {0xbae, 0xbb9},
  {0xbd0, 0xbd0}, {0xc05, 0xc0c}, {0xc0e, 0xc10}, {0xc12, 0xc28}, {0xc2a, 0xc39}, {0xc3d, 0xc3d}, {0xc58, 0xc5a}, {0xc5d, 0xc5d},
  {0xc60, 0xc61}, {0xc80, 0xc80}, {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3}, {0xcb5, 0xcb9}, {0xcbd, 0xcbd},
  {0xcdd, 0xcde}, {0xce0, 0xce1}, {0xcf1, 0xcf2}, {0xd04, 0xd0c}, {0xd0e, 0xd10}, {0xd12, 0xd3a}, {0xd3d, 0xd3d}, {0xd4e, 0xd4e},
  {0xd54, 0xd56}, {0xd5f, 0xd61}, {0xd7a, 0xd7f}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6},
  {0xe01, 0xe30}, {0xe32, 0xe32}, {0xe40, 0xe46}, {0xe81, 0xe82}, {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5},
  {0xea7, 0xeb0}, {0xeb2, 0xeb2}, {0xebd, 0xebd}, {0xec0, 0xec4}, {0xec6, 0xec6}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf40, 0xf47},
  {0xf49, 0xf6c}, {0xf88, 0xf8c}, {0x1000, 0x102a}, {0x103f, 0x103f}, {0x1050, 0x1055}, {0x105a, 0x105d}, {0x1061, 0x1061}, {0x1065, 0x1066},
  {0x106e, 0x1070}, {0x1075, 0x1081}, {0x108e, 0x108e}, {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248},
  {0x124a, 0x124d}, {0x1250, 0x1256}, {0x1258, 0x1258}, {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5},
  {0x12b8, 0x12be}, {0x12c0, 0x12c0}, {0x12c2, 0x12c5}, {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x1380, 0x138f},
  {0x13a0, 0x13f5}, {0x13f8, 0x13fd}, {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8}, {0x1700, 0x1711},
  {0x171f, 0x1731}, {0x1740, 0x1751}, {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1780, 0x17b3}, {0x17d7, 0x17d7}, {0x17dc, 0x17dc}, {0x1820, 0x1878},
  {0x1880, 0x18a8}, {0x18aa, 0x18aa}, {0x18b0, 0x18f5}, {0x1900, 0x191e}, {0x1950, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9},
  {0x1a00, 0x1a16}, {0x1a20, 0x1a54}, {0x1aa7, 0x1aa7}, {0x1b05, 0x1b33}, {0x1b45, 0x1b4c}, {0x1b83, 0x1ba0}, {0x1bae, 0x1baf}, {0x1bba, 0x1be5},
  {0x1c00, 0x1c23}, {0x1c4d, 0x1c4f}, {0x1c5a, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf}, {0x1ce9, 0x1cec}, {0x1cee, 0x1cf3},
  {0x1cf5, 0x1cf6}, {0x1cfa, 0x1cfa}, {0x1d00, 0x1dbf}, {0x1e00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57},
  {0x1f59, 0x1f59}, {0x1f5b, 0x1f5b}, {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4},
  {0x1fc6, 0x1fcc}, {0x1fd0, 0x1fd3}, {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x2071, 0x2071}, {0x207f, 0x207f},
  {0x2090, 0x209c}, {0x2102, 0x2102}, {0x2107, 0x2107}, {0x210a, 0x2113}, {0x2115, 0x2115}, {0x2118, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126},
  {0x2128, 0x2128}, {0x212a, 0x2139}, {0x213c, 0x213f}, {0x2145, 0x2149}, {0x214e, 0x214e}, {0x2160, 0x2188}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cee},
  {0x2cf2, 0x2cf3}, {0x2d00, 0x2d25}, {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d}, {0x2d30, 0x2d67}, {0x2d6f, 0x2d6f}, {0x2d80, 0x2d96}, {0x2da0, 0x2da6},
  {0x2da8, 0x2dae}, {0x2db0, 0x2db6}, {0x2db8, 0x2dbe}, {0x2dc0, 0x2dc6}, {0x2dc8, 0x2dce}, {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x3005, 0x3007},
  {0x3021, 0x3029}, {0x3031, 0x3035}, {0x3038, 0x303c}, {0x3041, 0x3096}, {0x309d, 0x309f}, {0x30a1, 0x30fa}, {0x30fc, 0x30ff}, {0x3105, 0x312f},
  {0x3131, 0x318e}, {0x31a0, 0x31bf}, {0x31f0, 0x31ff}, {0x3400, 0x4dbf}, {0x4e00, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa61f},
  {0xa62a, 0xa62b}, {0xa640, 0xa66e}, {0xa67f, 0xa69d}, {0xa6a0, 0xa6ef}, {0xa717, 0xa71f}, {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1},
  {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9}, {0xa7f2, 0xa801}, {0xa803, 0xa805}, {0xa807, 0xa80a}, {0xa80c, 0xa822}, {0xa840, 0xa873}, {0xa882, 0xa8b3},
  {0xa8f2, 0xa8f7}, {0xa8fb, 0xa8fb}, {0xa8fd, 0xa8fe}, {0xa90a, 0xa925}, {0xa930, 0xa946}, {0xa960, 0xa97c}, {0xa984, 0xa9b2}, {0xa9cf, 0xa9cf},
  {0xa9e0, 0xa9e4}, {0xa9e6, 0xa9ef}, {0xa9fa, 0xa9fe}, {0xaa00, 0xaa28}, {0xaa40, 0xaa42}, {0xaa44, 0xaa4b}, {0xaa60, 0xaa76}, {0xaa7a, 0xaa7a},
  {0xaa7e, 0xaaaf}, {0xaab1, 0xaab1}, {0xaab5, 0xaab6}, {0xaab9, 0xaabd}, {0xaac0, 0xaac0}, {0xaac2, 0xaac2}, {0xaadb, 0xaadd}, {0xaae0, 0xaaea},
  {0xaaf2, 0xaaf4}, {0xab01, 0xab06}, {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26}, {0xab28, 0xab2e}, {0xab30, 0xab5a}, {0xab5c, 0xab69},
  {0xab70, 0xabe2}, {0xac00, 0xd7a3}, {0xd7b0, 0xd7c6}, {0xd7cb, 0xd7fb}, {0xf900, 0xfa6d}, {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17},
  {0xfb1d, 0xfb1d}, {0xfb1f, 0xfb28}, {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c}, {0xfb3e, 0xfb3e}, {0xfb40, 0xfb41}, {0xfb43, 0xfb44}, {0xfb46, 0xfbb1},
  {0xfbd3, 0xfc5d}, {0xfc64, 0xfd3d}, {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7}, {0xfdf0, 0xfdf9}, {0xfe71, 0xfe71}, {0xfe73, 0xfe73}, {0xfe77, 0xfe77},
  {0xfe79, 0xfe79}, {0xfe7b, 0xfe7b}, {0xfe7d, 0xfe7d}, {0xfe7f, 0xfefc}, {0xff21, 0xff3a}, {0xff41, 0xff5a}, {0xff66, 0xff9d}, {0xffa0, 0xffbe},
  {0xffc2, 0xffc7}, {0xffca, 0xffcf}, {0xffd2, 0xffd7}, {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a}, {0x1003c, 0x1003d},
  {0x1003f, 0x1004d}, {0x10050, 0x1005d}, {0x10080, 0x100fa}, {0x10140, 0x10174}, {0x10280, 0x1029c}, {0x102a0, 0x102d0}, {0x10300, 0x1031f}, {0x1032d, 0x1034a},
  {0x10350, 0x10375}, {0x10380, 0x1039d}, {0x103a0, 0x103c3}, {0x103c8, 0x103cf}, {0x103d1, 0x103d5}, {0x10400, 0x1049d}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb},
  {0x10500, 0x10527}, {0x10530, 0x10563}, {0x10570, 0x1057a}, {0x1057c, 0x1058a}, {0x1058c, 0x10592}, {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1},
  {0x105b3, 0x105b9}, {0x105bb, 0x105bc}, {0x10600, 0x10736}, {0x10740, 0x10755}, {0x10760, 0x10767}, {0x10780, 0x10785}, {0x10787, 0x107b0}, {0x107b2, 0x107ba},
  {0x10800, 0x10805}, {0x10808, 0x10808}, {0x1080a, 0x10835}, {0x10837, 0x10838}, {0x1083c, 0x1083c}, {0x1083f, 0x10855}, {0x10860, 0x10876}, {0x10880, 0x1089e},
  {0x108e0, 0x108f2}, {0x108f4, 0x108f5}, {0x10900, 0x10915}, {0x10920, 0x10939}, {0x10980, 0x109b7}, {0x109be, 0x109bf}, {0x10a00, 0x10a00}, {0x10a10, 0x10a13},
  {0x10a15, 0x10a17}, {0x10a19, 0x10a35}, {0x10a60, 0x10a7c}, {0x10a80, 0x10a9c}, {0x10ac0, 0x10ac7}, {0x10ac9, 0x10ae4}, {0x10b00, 0x10b35}, {0x10b40, 0x10b55},
  {0x10b60, 0x10b72}, {0x10b80, 0x10b91}, {0x10c00, 0x10c48}, {0x10c80, 0x10cb2}, {0x10cc0, 0x10cf2}, {0x10d00, 0x10d23}, {0x10e80, 0x10ea9}, {0x10eb0, 0x10eb1},
  {0x10f00, 0x10f1c}, {0x10f27, 0x10f27}, {0x10f30, 0x10f45}, {0x10f70, 0x10f81}, {0x10fb0, 0x10fc4}, {0x10fe0, 0x10ff6}, {0x11003, 0x11037}, {0x11071, 0x11072},
  {0x11075, 0x11075}, {0x11083, 0x110af}, {0x110d0, 0x110e8}, {0x11103, 0x11126}, {0x11144, 0x11144}, {0x11147, 0x11147}, {0x11150, 0x11172}, {0x11176, 0x11176},
  {0x11183, 0x111b2}, {0x111c1, 0x111c4}, {0x111da, 0x111da}, {0x111dc, 0x111dc}, {0x11200, 0x11211}, {0x11213, 0x1122b}, {0x1123f, 0x11240}, {0x11280, 0x11286},
  {0x11288, 0x11288}, {0x1128a, 0x1128d}, {0x1128f, 0x1129d}, {0x1129f, 0x112a8}, {0x112b0, 0x112de}, {0x11305, 0x1130c}, {0x1130f, 0x11310}, {0x11313, 0x11328},
  {0x1132a, 0x11330}, {0x11332, 0x11333}, {0x11335, 0x11339}, {0x1133d, 0x1133d}, {0x11350, 0x11350}, {0x1135d, 0x11361}, {0x11400, 0x11434}, {0x11447, 0x1144a},
  {0x1145f, 0x11461}, {0x11480, 0x114af}, {0x114c4, 0x114c5}, {0x114c7, 0x114c7}, {0x11580, 0x115ae}, {0x115d8, 0x115db}, {0x11600, 0x1162f}, {0x11644, 0x11644},
  {0x11680, 0x116aa}, {0x116b8, 0x116b8}, {0x11700, 0x1171a}, {0x11740, 0x11746}, {0x11800, 0x1182b}, {0x118a0, 0x118df}, {0x118ff, 0x11906}, {0x11909, 0x11909},
  {0x1190c, 0x11913}, {0x11915, 0x11916}, {0x11918, 0x1192f}, {0x1193f, 0x1193f}, {0x11941, 0x11941}, {0x119a0, 0x119a7}, {0x119aa, 0x119d0}, {0x119e1, 0x119e1},
  {0x119e3, 0x119e3}, {0x11a00, 0x11a00}, {0x11a0b, 0x11a32}, {0x11a3a, 0x11a3a}, {0x11a50, 0x11a50}, {0x11a5c, 0x11a89}, {0x11a9d, 0x11a9d}, {0x11ab0, 0x11af8},
  {0x11c00, 0x11c08}, {0x11c0a, 0x11c2e}, {0x11c40, 0x11c40}, {0x11c72, 0x11c8f}, {0x11d00, 0x11d06}, {0x11d08, 0x11d09}, {0x11d0b, 0x11d30}, {0x11d46, 0x11d46},
  {0x11d60, 0x11d65}, {0x11d67, 0x11d68}, {0x11d6a, 0x11d89}, {0x11d98, 0x11d98}, {0x11ee0, 0x11ef2}, {0x11f02, 0x11f02}, {0x11f04, 0x11f10}, {0x11f12, 0x11f33},
  {0x11fb0, 0x11fb0}, {0x12000, 0x12399}, {0x12400, 0x1246e}, {0x12480, 0x12543}, {0x12f90, 0x12ff0}, {0x13000, 0x1342f}, {0x13441, 0x13446}, {0x14400, 0x14646},
  {0x16800, 0x16a38}, {0x16a40, 0x16a5e}, {0x16a70, 0x16abe}, {0x16ad0, 0x16aed}, {0x16b00, 0x16b2f}, {0x16b40, 0x16b43}, {0x16b63, 0x16b77}, {0x16b7d, 0x16b8f},
  {0x16e40, 0x16e7f}, {0x16f00, 0x16f4a}, {0x16f50, 0x16f50}, {0x16f93, 0x16f9f}, {0x16fe0, 0x16fe1}, {0x16fe3, 0x16fe3}, {0x17000, 0x187f7}, {0x18800, 0x18cd5},
  {0x18d00, 0x18d08}, {0x1aff0, 0x1aff3}, {0x1aff5, 0x1affb}, {0x1affd, 0x1affe}, {0x1b000, 0x1b122}, {0x1b132, 0x1b132}, {0x1b150, 0x1b152}, {0x1b155, 0x1b155},
  {0x1b164, 0x1b167}, {0x1b170, 0x1b2fb}, {0x1bc00, 0x1bc6a}, {0x1bc70, 0x1bc7c}, {0x1bc80, 0x1bc88}, {0x1bc90, 0x1bc99}, {0x1d400, 0x1d454}, {0x1d456, 0x1d49c},
  {0x1d49e, 0x1d49f}, {0x1d4a2, 0x1d4a2}, {0x1d4a5, 0x1d4a6}, {0x1d4a9, 0x1d4ac}, {0x1d4ae, 0x1d4b9}, {0x1d4bb, 0x1d4bb}, {0x1d4bd, 0x1d4c3}, {0x1d4c5, 0x1d505},
  {0x1d507, 0x1d50a}, {0x1d50d, 0x1d514}, {0x1d516, 0x1d51c}, {0x1d51e, 0x1d539}, {0x1d53b, 0x1d53e}, {0x1d540, 0x1d544}, {0x1d546, 0x1d546}, {0x1d54a, 0x1d550},
  {0x1d552, 0x1d6a5}, {0x1d6a8, 0x1d6c0}, {0x1d6c2, 0x1d6da}, {0x1d6dc, 0x1d6fa}, {0x1d6fc, 0x1d714}, {0x1d716, 0x1d734}, {0x1d736, 0x1d74e}, {0x1d750, 0x1d76e},
  {0x1d770, 0x1d788}, {0x1d78a, 0x1d7a8}, {0x1d7aa, 0x1d7c2}, {0x1d7c4, 0x1d7cb}, {0x1df00, 0x1df1e}, {0x1df25, 0x1df2a}, {0x1e030, 0x1e06d}, {0x1e100, 0x1e12c},
  {0x1e137, 0x1e13d}, {0x1e14e, 0x1e14e}, {0x1e290, 0x1e2ad}, {0x1e2c0, 0x1e2eb}, {0x1e4d0, 0x1e4eb}, {0x1e7e0, 0x1e7e6}, {0x1e7e8, 0x1e7eb}, {0x1e7ed, 0x1e7ee},
  {0x1e7f0, 0x1e7fe}, {0x1e800, 0x1e8c4}, {0x1e900, 0x1e943}, {0x1e94b, 0x1e94b}, {0x1ee00, 0x1ee03}, {0x1ee05, 0x1ee1f}, {0x1ee21, 0x1ee22}, {0x1ee24, 0x1ee24},
  {0x1ee27, 0x1ee27}, {0x1ee29, 0x1ee32}, {0x1ee34, 0x1ee37}, {0x1ee39, 0x1ee39}, {0x1ee3b, 0x1ee3b}, {0x1ee42, 0x1ee42}, {0x1ee47, 0x1ee47}, {0x1ee49, 0x1ee49},
  {0x1ee4b, 0x1ee4b}, {0x1ee4d, 0x1ee4f}, {0x1ee51, 0x1ee52}, {0x1ee54, 0x1ee54}, {0x1ee57, 0x1ee57}, {0x1ee59, 0x1ee59}, {0x1ee5b, 0x1ee5b}, {0x1ee5d, 0x1ee5d},
  {0x1ee5f, 0x1ee5f}, {0x1ee61, 0x1ee62}, {0x1ee64, 0x1ee64}, {0x1ee67, 0x1ee6a}, {0x1ee6c, 0x1ee72}, {0x1ee74, 0x1ee77}, {0x1ee79, 0x1ee7c}, {0x1ee7e, 0x1ee7e},
  {0x1ee80, 0x1ee89}, {0x1ee8b, 0x1ee9b}, {0x1eea1, 0x1eea3}, {0x1eea5, 0x1eea9}, {0x1eeab, 0x1eebb}, {0x20000, 0x2a6df}, {0x2a700, 0x2b739}, {0x2b740, 0x2b81d},
  {0x2b820, 0x2cea1}, {0x2ceb0, 0x2ebe0}, {0x2ebf0, 0x2ee5d}, {0x2f800, 0x2fa1d}, {0x30000, 0x3134a}, {0x31350, 0x323af},
};

static TSCharacterRange sym_identifier_character_set_2[] = {
  {'$', '$'}, {'0', '9'}, {'A', 'Z'}, {'\\', '\\'}, {'_', '_'}, {'a', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5},
  {0xb7, 0xb7}, {0xba, 0xba}, {0xc0, 0xd6}, {0xd8, 0xf6}, {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec},
  {0x2ee, 0x2ee}, {0x300, 0x374}, {0x376, 0x377}, {0x37b, 0x37d}, {0x37f, 0x37f}, {0x386, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1},
  {0x3a3, 0x3f5}, {0x3f7, 0x481}, {0x483, 0x487}, {0x48a, 0x52f}, {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x591, 0x5bd},
  {0x5bf, 0x5bf}, {0x5c1, 0x5c2}, {0x5c4, 0x5c5}, {0x5c7, 0x5c7}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x610, 0x61a}, {0x620, 0x669},
  {0x66e, 0x6d3}, {0x6d5, 0x6dc}, {0x6df, 0x6e8}, {0x6ea, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x74a}, {0x74d, 0x7b1}, {0x7c0, 0x7f5},
  {0x7fa, 0x7fa}, {0x7fd, 0x7fd}, {0x800, 0x82d}, {0x840, 0x85b}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x898, 0x8e1},
  {0x8e3, 0x963}, {0x966, 0x96f}, {0x971, 0x983}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0}, {0x9b2, 0x9b2},
  {0x9b6, 0x9b9}, {0x9bc, 0x9c4}, {0x9c7, 0x9c8}, {0x9cb, 0x9ce}, {0x9d7, 0x9d7}, {0x9dc, 0x9dd}, {0x9df, 0x9e3}, {0x9e6, 0x9f1},
  {0x9fc, 0x9fc}, {0x9fe, 0x9fe}, {0xa01, 0xa03}, {0xa05, 0xa0a}, {0xa0f, 0xa10}, {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33},
  {0xa35, 0xa36}, {0xa38, 0xa39}, {0xa3c, 0xa3c}, {0xa3e, 0xa42}, {0xa47, 0xa48}, {0xa4b, 0xa4d}, {0xa51, 0xa51}, {0xa59, 0xa5c},
  {0xa5e, 0xa5e}, {0xa66, 0xa75}, {0xa81, 0xa83}, {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3},
  {0xab5, 0xab9}, {0xabc, 0xac5}, {0xac7, 0xac9}, {0xacb, 0xacd}, {0xad0, 0xad0}, {0xae0, 0xae3}, {0xae6, 0xaef}, {0xaf9, 0xaff},
  {0xb01, 0xb03}, {0xb05, 0xb0c}, {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30}, {0xb32, 0xb33}, {0xb35, 0xb39}, {0xb3c, 0xb44},
  {0xb47, 0xb48}, {0xb4b, 0xb4d}, {0xb55, 0xb57}, {0xb5c, 0xb5d}, {0xb5f, 0xb63}, {0xb66, 0xb6f}, {0xb71, 0xb71}, {0xb82, 0xb83},
  {0xb85, 0xb8a}, {0xb8e, 0xb90}, {0xb92, 0xb95}, {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa},
  {0xbae, 0xbb9}, {0xbbe, 0xbc2}, {0xbc6, 0xbc8}, {0xbca, 0xbcd}, {0xbd0, 0xbd0}, {0xbd7, 0xbd7}, {0xbe6, 0xbef}, {0xc00, 0xc0c},
  {0xc0e, 0xc10}, {0xc12, 0xc28}, {0xc2a, 0xc39}, {0xc3c, 0xc44}, {0xc46, 0xc48}, {0xc4a, 0xc4d}, {0xc55, 0xc56}, {0xc58, 0xc5a},
  {0xc5d, 0xc5d}, {0xc60, 0xc63}, {0xc66, 0xc6f}, {0xc80, 0xc83}, {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3},
  {0xcb5, 0xcb9}, {0xcbc, 0xcc4}, {0xcc6, 0xcc8}, {0xcca, 0xccd}, {0xcd5, 0xcd6}, {0xcdd, 0xcde}, {0xce0, 0xce3}, {0xce6, 0xcef},
  {0xcf1, 0xcf3}, {0xd00, 0xd0c}, {0xd0e, 0xd10}, {0xd12, 0xd44}, {0xd46, 0xd48}, {0xd4a, 0xd4e}, {0xd54, 0xd57}, {0xd5f, 0xd63},
  {0xd66, 0xd6f}, {0xd7a, 0xd7f}, {0xd81, 0xd83}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6},
  {0xdca, 0xdca}, {0xdcf, 0xdd4}, {0xdd6, 0xdd6}, {0xdd8, 0xddf}, {0xde6, 0xdef}, {0xdf2, 0xdf3}, {0xe01, 0xe3a}, {0xe40, 0xe4e},
  {0xe50, 0xe59}, {0xe81, 0xe82}, {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5}, {0xea7, 0xebd}, {0xec0, 0xec4},
  {0xec6, 0xec6}, {0xec8, 0xece}, {0xed0, 0xed9}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf18, 0xf19}, {0xf20, 0xf29}, {0xf35, 0xf35},
  {0xf37, 0xf37}, {0xf39, 0xf39}, {0xf3e, 0xf47}, {0xf49, 0xf6c}, {0xf71, 0xf84}, {0xf86, 0xf97}, {0xf99, 0xfbc}, {0xfc6, 0xfc6},
  {0x1000, 0x1049}, {0x1050, 0x109d}, {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248}, {0x124a, 0x124d},
  {0x1250, 0x1256}, {0x1258, 0x1258}, {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5}, {0x12b8, 0x12be},
  {0x12c0, 0x12c0}, {0x12c2, 0x12c5}, {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x135d, 0x135f}, {0x1369, 0x1371},
  {0x1380, 0x138f}, {0x13a0, 0x13f5}, {0x13f8, 0x13fd}, {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8},
  {0x1700, 0x1715}, {0x171f, 0x1734}, {0x1740, 0x1753}, {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1772, 0x1773}, {0x1780, 0x17d3}, {0x17d7, 0x17d7},
  {0x17dc, 0x17dd}, {0x17e0, 0x17e9}, {0x180b, 0x180d}, {0x180f, 0x1819}, {0x1820, 0x1878}, {0x1880, 0x18aa}, {0x18b0, 0x18f5}, {0x1900, 0x191e},
  {0x1920, 0x192b}, {0x1930, 0x193b}, {0x1946, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9}, {0x19d0, 0x19da}, {0x1a00, 0x1a1b},
  {0x1a20, 0x1a5e}, {0x1a60, 0x1a7c}, {0x1a7f, 0x1a89}, {0x1a90, 0x1a99}, {0x1aa7, 0x1aa7}, {0x1ab0, 0x1abd}, {0x1abf, 0x1ace}, {0x1b00, 0x1b4c},
  {0x1b50, 0x1b59}, {0x1b6b, 0x1b73}, {0x1b80, 0x1bf3}, {0x1c00, 0x1c37}, {0x1c40, 0x1c49}, {0x1c4d, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba},
  {0x1cbd, 0x1cbf}, {0x1cd0, 0x1cd2}, {0x1cd4, 0x1cfa}, {0x1d00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57},
  {0x1f59, 0x1f59}, {0x1f5b, 0x1f5b}, {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4},
  {0x1fc6, 0x1fcc}, {0x1fd0, 0x1fd3}, {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x200c, 0x200d}, {0x203f, 0x2040},
  {0x2054, 0x2054}, {0x2071, 0x2071}, {0x207f, 0x207f}, {0x2090, 0x209c}, {0x20d0, 0x20dc}, {0x20e1, 0x20e1}, {0x20e5, 0x20f0}, {0x2102, 0x2102},
  {0x2107, 0x2107}, {0x210a, 0x2113}, {0x2115, 0x2115}, {0x2118, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128}, {0x212a, 0x2139},
  {0x213c, 0x213f}, {0x2145, 0x2149}, {0x214e, 0x214e}, {0x2160, 0x2188}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cf3}, {0x2d00, 0x2d25}, {0x2d27, 0x2d27},
  {0x2d2d, 0x2d2d}, {0x2d30, 0x2d67}, {0x2d6f, 0x2d6f}, {0x2d7f, 0x2d96}, {0x2da0, 0x2da6}, {0x2da8, 0x2dae}, {0x2db0, 0x2db6}, {0x2db8, 0x2dbe},
  {0x2dc0, 0x2dc6}, {0x2dc8, 0x2dce}, {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x2de0, 0x2dff}, {0x3005, 0x3007}, {0x3021, 0x302f}, {0x3031, 0x3035},
  {0x3038, 0x303c}, {0x3041, 0x3096}, {0x3099, 0x309a}, {0x309d, 0x309f}, {0x30a1, 0x30ff}, {0x3105, 0x312f}, {0x3131, 0x318e}, {0x31a0, 0x31bf},
  {0x31f0, 0x31ff}, {0x3400, 0x4dbf}, {0x4e00, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa62b}, {0xa640, 0xa66f}, {0xa674, 0xa67d},
  {0xa67f, 0xa6f1}, {0xa717, 0xa71f}, {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9}, {0xa7f2, 0xa827},
  {0xa82c, 0xa82c}, {0xa840, 0xa873}, {0xa880, 0xa8c5}, {0xa8d0, 0xa8d9}, {0xa8e0, 0xa8f7}, {0xa8fb, 0xa8fb}, {0xa8fd, 0xa92d}, {0xa930, 0xa953},
  {0xa960, 0xa97c}, {0xa980, 0xa9c0}, {0xa9cf, 0xa9d9}, {0xa9e0, 0xa9fe}, {0xaa00, 0xaa36}, {0xaa40, 0xaa4d}, {0xaa50, 0xaa59}, {0xaa60, 0xaa76},
  {0xaa7a, 0xaac2}, {0xaadb, 0xaadd}, {0xaae0, 0xaaef}, {0xaaf2, 0xaaf6}, {0xab01, 0xab06}, {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26},
  {0xab28, 0xab2e}, {0xab30, 0xab5a}, {0xab5c, 0xab69}, {0xab70, 0xabea}, {0xabec, 0xabed}, {0xabf0, 0xabf9}, {0xac00, 0xd7a3}, {0xd7b0, 0xd7c6},
  {0xd7cb, 0xd7fb}, {0xf900, 0xfa6d}, {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17}, {0xfb1d, 0xfb28}, {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c},
  {0xfb3e, 0xfb3e}, {0xfb40, 0xfb41}, {0xfb43, 0xfb44}, {0xfb46, 0xfbb1}, {0xfbd3, 0xfc5d}, {0xfc64, 0xfd3d}, {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7},
  {0xfdf0, 0xfdf9}, {0xfe00, 0xfe0f}, {0xfe20, 0xfe2f}, {0xfe33, 0xfe34}, {0xfe4d, 0xfe4f}, {0xfe71, 0xfe71}, {0xfe73, 0xfe73}, {0xfe77, 0xfe77},
  {0xfe79, 0xfe79}, {0xfe7b, 0xfe7b}, {0xfe7d, 0xfe7d}, {0xfe7f, 0xfefc}, {0xff10, 0xff19}, {0xff21, 0xff3a}, {0xff3f, 0xff3f}, {0xff41, 0xff5a},
  {0xff65, 0xffbe}, {0xffc2, 0xffc7}, {0xffca, 0xffcf}, {0xffd2, 0xffd7}, {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a},
  {0x1003c, 0x1003d}, {0x1003f, 0x1004d}, {0x10050, 0x1005d}, {0x10080, 0x100fa}, {0x10140, 0x10174}, {0x101fd, 0x101fd}, {0x10280, 0x1029c}, {0x102a0, 0x102d0},
  {0x102e0, 0x102e0}, {0x10300, 0x1031f}, {0x1032d, 0x1034a}, {0x10350, 0x1037a}, {0x10380, 0x1039d}, {0x103a0, 0x103c3}, {0x103c8, 0x103cf}, {0x103d1, 0x103d5},
  {0x10400, 0x1049d}, {0x104a0, 0x104a9}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb}, {0x10500, 0x10527}, {0x10530, 0x10563}, {0x10570, 0x1057a}, {0x1057c, 0x1058a},
  {0x1058c, 0x10592}, {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1}, {0x105b3, 0x105b9}, {0x105bb, 0x105bc}, {0x10600, 0x10736}, {0x10740, 0x10755},
  {0x10760, 0x10767}, {0x10780, 0x10785}, {0x10787, 0x107b0}, {0x107b2, 0x107ba}, {0x10800, 0x10805}, {0x10808, 0x10808}, {0x1080a, 0x10835}, {0x10837, 0x10838},
  {0x1083c, 0x1083c}, {0x1083f, 0x10855}, {0x10860, 0x10876}, {0x10880, 0x1089e}, {0x108e0, 0x108f2}, {0x108f4, 0x108f5}, {0x10900, 0x10915}, {0x10920, 0x10939},
  {0x10980, 0x109b7}, {0x109be, 0x109bf}, {0x10a00, 0x10a03}, {0x10a05, 0x10a06}, {0x10a0c, 0x10a13}, {0x10a15, 0x10a17}, {0x10a19, 0x10a35}, {0x10a38, 0x10a3a},
  {0x10a3f, 0x10a3f}, {0x10a60, 0x10a7c}, {0x10a80, 0x10a9c}, {0x10ac0, 0x10ac7}, {0x10ac9, 0x10ae6}, {0x10b00, 0x10b35}, {0x10b40, 0x10b55}, {0x10b60, 0x10b72},
  {0x10b80, 0x10b91}, {0x10c00, 0x10c48}, {0x10c80, 0x10cb2}, {0x10cc0, 0x10cf2}, {0x10d00, 0x10d27}, {0x10d30, 0x10d39}, {0x10e80, 0x10ea9}, {0x10eab, 0x10eac},
  {0x10eb0, 0x10eb1}, {0x10efd, 0x10f1c}, {0x10f27, 0x10f27}, {0x10f30, 0x10f50}, {0x10f70, 0x10f85}, {0x10fb0, 0x10fc4}, {0x10fe0, 0x10ff6}, {0x11000, 0x11046},
  {0x11066, 0x11075}, {0x1107f, 0x110ba}, {0x110c2, 0x110c2}, {0x110d0, 0x110e8}, {0x110f0, 0x110f9}, {0x11100, 0x11134}, {0x11136, 0x1113f}, {0x11144, 0x11147},
  {0x11150, 0x11173}, {0x11176, 0x11176}, {0x11180, 0x111c4}, {0x111c9, 0x111cc}, {0x111ce, 0x111da}, {0x111dc, 0x111dc}, {0x11200, 0x11211}, {0x11213, 0x11237},
  {0x1123e, 0x11241}, {0x11280, 0x11286}, {0x11288, 0x11288}, {0x1128a, 0x1128d}, {0x1128f, 0x1129d}, {0x1129f, 0x112a8}, {0x112b0, 0x112ea}, {0x112f0, 0x112f9},
  {0x11300, 0x11303}, {0x11305, 0x1130c}, {0x1130f, 0x11310}, {0x11313, 0x11328}, {0x1132a, 0x11330}, {0x11332, 0x11333}, {0x11335, 0x11339}, {0x1133b, 0x11344},
  {0x11347, 0x11348}, {0x1134b, 0x1134d}, {0x11350, 0x11350}, {0x11357, 0x11357}, {0x1135d, 0x11363}, {0x11366, 0x1136c}, {0x11370, 0x11374}, {0x11400, 0x1144a},
  {0x11450, 0x11459}, {0x1145e, 0x11461}, {0x11480, 0x114c5}, {0x114c7, 0x114c7}, {0x114d0, 0x114d9}, {0x11580, 0x115b5}, {0x115b8, 0x115c0}, {0x115d8, 0x115dd},
  {0x11600, 0x11640}, {0x11644, 0x11644}, {0x11650, 0x11659}, {0x11680, 0x116b8}, {0x116c0, 0x116c9}, {0x11700, 0x1171a}, {0x1171d, 0x1172b}, {0x11730, 0x11739},
  {0x11740, 0x11746}, {0x11800, 0x1183a}, {0x118a0, 0x118e9}, {0x118ff, 0x11906}, {0x11909, 0x11909}, {0x1190c, 0x11913}, {0x11915, 0x11916}, {0x11918, 0x11935},
  {0x11937, 0x11938}, {0x1193b, 0x11943}, {0x11950, 0x11959}, {0x119a0, 0x119a7}, {0x119aa, 0x119d7}, {0x119da, 0x119e1}, {0x119e3, 0x119e4}, {0x11a00, 0x11a3e},
  {0x11a47, 0x11a47}, {0x11a50, 0x11a99}, {0x11a9d, 0x11a9d}, {0x11ab0, 0x11af8}, {0x11c00, 0x11c08}, {0x11c0a, 0x11c36}, {0x11c38, 0x11c40}, {0x11c50, 0x11c59},
  {0x11c72, 0x11c8f}, {0x11c92, 0x11ca7}, {0x11ca9, 0x11cb6}, {0x11d00, 0x11d06}, {0x11d08, 0x11d09}, {0x11d0b, 0x11d36}, {0x11d3a, 0x11d3a}, {0x11d3c, 0x11d3d},
  {0x11d3f, 0x11d47}, {0x11d50, 0x11d59}, {0x11d60, 0x11d65}, {0x11d67, 0x11d68}, {0x11d6a, 0x11d8e}, {0x11d90, 0x11d91}, {0x11d93, 0x11d98}, {0x11da0, 0x11da9},
  {0x11ee0, 0x11ef6}, {0x11f00, 0x11f10}, {0x11f12, 0x11f3a}, {0x11f3e, 0x11f42}, {0x11f50, 0x11f59}, {0x11fb0, 0x11fb0}, {0x12000, 0x12399}, {0x12400, 0x1246e},
  {0x12480, 0x12543}, {0x12f90, 0x12ff0}, {0x13000, 0x1342f}, {0x13440, 0x13455}, {0x14400, 0x14646}, {0x16800, 0x16a38}, {0x16a40, 0x16a5e}, {0x16a60, 0x16a69},
  {0x16a70, 0x16abe}, {0x16ac0, 0x16ac9}, {0x16ad0, 0x16aed}, {0x16af0, 0x16af4}, {0x16b00, 0x16b36}, {0x16b40, 0x16b43}, {0x16b50, 0x16b59}, {0x16b63, 0x16b77},
  {0x16b7d, 0x16b8f}, {0x16e40, 0x16e7f}, {0x16f00, 0x16f4a}, {0x16f4f, 0x16f87}, {0x16f8f, 0x16f9f}, {0x16fe0, 0x16fe1}, {0x16fe3, 0x16fe4}, {0x16ff0, 0x16ff1},
  {0x17000, 0x187f7}, {0x18800, 0x18cd5}, {0x18d00, 0x18d08}, {0x1aff0, 0x1aff3}, {0x1aff5, 0x1affb}, {0x1affd, 0x1affe}, {0x1b000, 0x1b122}, {0x1b132, 0x1b132},
  {0x1b150, 0x1b152}, {0x1b155, 0x1b155}, {0x1b164, 0x1b167}, {0x1b170, 0x1b2fb}, {0x1bc00, 0x1bc6a}, {0x1bc70, 0x1bc7c}, {0x1bc80, 0x1bc88}, {0x1bc90, 0x1bc99},
  {0x1bc9d, 0x1bc9e}, {0x1cf00, 0x1cf2d}, {0x1cf30, 0x1cf46}, {0x1d165, 0x1d169}, {0x1d16d, 0x1d172}, {0x1d17b, 0x1d182}, {0x1d185, 0x1d18b}, {0x1d1aa, 0x1d1ad},
  {0x1d242, 0x1d244}, {0x1d400, 0x1d454}, {0x1d456, 0x1d49c}, {0x1d49e, 0x1d49f}, {0x1d4a2, 0x1d4a2}, {0x1d4a5, 0x1d4a6}, {0x1d4a9, 0x1d4ac}, {0x1d4ae, 0x1d4b9},
  {0x1d4bb, 0x1d4bb}, {0x1d4bd, 0x1d4c3}, {0x1d4c5, 0x1d505}, {0x1d507, 0x1d50a}, {0x1d50d, 0x1d514}, {0x1d516, 0x1d51c}, {0x1d51e, 0x1d539}, {0x1d53b, 0x1d53e},
  {0x1d540, 0x1d544}, {0x1d546, 0x1d546}, {0x1d54a, 0x1d550}, {0x1d552, 0x1d6a5}, {0x1d6a8, 0x1d6c0}, {0x1d6c2, 0x1d6da}, {0x1d6dc, 0x1d6fa}, {0x1d6fc, 0x1d714},
  {0x1d716, 0x1d734}, {0x1d736, 0x1d74e}, {0x1d750, 0x1d76e}, {0x1d770, 0x1d788}, {0x1d78a, 0x1d7a8}, {0x1d7aa, 0x1d7c2}, {0x1d7c4, 0x1d7cb}, {0x1d7ce, 0x1d7ff},
  {0x1da00, 0x1da36}, {0x1da3b, 0x1da6c}, {0x1da75, 0x1da75}, {0x1da84, 0x1da84}, {0x1da9b, 0x1da9f}, {0x1daa1, 0x1daaf}, {0x1df00, 0x1df1e}, {0x1df25, 0x1df2a},
  {0x1e000, 0x1e006}, {0x1e008, 0x1e018}, {0x1e01b, 0x1e021}, {0x1e023, 0x1e024}, {0x1e026, 0x1e02a}, {0x1e030, 0x1e06d}, {0x1e08f, 0x1e08f}, {0x1e100, 0x1e12c},
  {0x1e130, 0x1e13d}, {0x1e140, 0x1e149}, {0x1e14e, 0x1e14e}, {0x1e290, 0x1e2ae}, {0x1e2c0, 0x1e2f9}, {0x1e4d0, 0x1e4f9}, {0x1e7e0, 0x1e7e6}, {0x1e7e8, 0x1e7eb},
  {0x1e7ed, 0x1e7ee}, {0x1e7f0, 0x1e7fe}, {0x1e800, 0x1e8c4}, {0x1e8d0, 0x1e8d6}, {0x1e900, 0x1e94b}, {0x1e950, 0x1e959}, {0x1ee00, 0x1ee03}, {0x1ee05, 0x1ee1f},
  {0x1ee21, 0x1ee22}, {0x1ee24, 0x1ee24}, {0x1ee27, 0x1ee27}, {0x1ee29, 0x1ee32}, {0x1ee34, 0x1ee37}, {0x1ee39, 0x1ee39}, {0x1ee3b, 0x1ee3b}, {0x1ee42, 0x1ee42},
  {0x1ee47, 0x1ee47}, {0x1ee49, 0x1ee49}, {0x1ee4b, 0x1ee4b}, {0x1ee4d, 0x1ee4f}, {0x1ee51, 0x1ee52}, {0x1ee54, 0x1ee54}, {0x1ee57, 0x1ee57}, {0x1ee59, 0x1ee59},
  {0x1ee5b, 0x1ee5b}, {0x1ee5d, 0x1ee5d}, {0x1ee5f, 0x1ee5f}, {0x1ee61, 0x1ee62}, {0x1ee64, 0x1ee64}, {0x1ee67, 0x1ee6a}, {0x1ee6c, 0x1ee72}, {0x1ee74, 0x1ee77},
  {0x1ee79, 0x1ee7c}, {0x1ee7e, 0x1ee7e}, {0x1ee80, 0x1ee89}, {0x1ee8b, 0x1ee9b}, {0x1eea1, 0x1eea3}, {0x1eea5, 0x1eea9}, {0x1eeab, 0x1eebb}, {0x1fbf0, 0x1fbf9},
  {0x20000, 0x2a6df}, {0x2a700, 0x2b739}, {0x2b740, 0x2b81d}, {0x2b820, 0x2cea1}, {0x2ceb0, 0x2ebe0}, {0x2ebf0, 0x2ee5d}, {0x2f800, 0x2fa1d}, {0x30000, 0x3134a},
  {0x31350, 0x323af}, {0xe0100, 0xe01ef},
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(337);
      ADVANCE_MAP(
        '!', 404,
        '"', 522,
        '#', 283,
        '%', 428,
        '&', 438,
        '\'', 513,
        '(', 341,
        ')', 344,
        '*', 424,
        '+', 418,
        ',', 343,
        '-', 407,
        '.', 488,
        '/', 426,
        '0', 495,
        ':', 472,
        ';', 456,
        '<', 448,
        '=', 468,
        '>', 638,
        '?', 473,
        'F', 565,
        'L', 539,
        'R', 542,
        'T', 569,
        'U', 543,
        '[', 464,
        '\\', 2,
        ']', 466,
        '^', 435,
        'b', 611,
        'c', 590,
        'd', 607,
        'f', 574,
        'i', 604,
        'm', 576,
        'n', 624,
        'p', 621,
        's', 591,
        't', 616,
        'u', 546,
        'v', 608,
        '{', 460,
        '|', 432,
        '}', 461,
        '~', 405,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(335);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(161);
      END_STATE();
    case 2:
      if (lookahead == '\n') SKIP(161);
      if (lookahead == '\r') SKIP(1);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 3:
      if (lookahead == '\n') SKIP(170);
      END_STATE();
    case 4:
      if (lookahead == '\n') SKIP(170);
      if (lookahead == '\r') SKIP(3);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 5:
      if (lookahead == '\n') SKIP(169);
      END_STATE();
    case 6:
      if (lookahead == '\n') SKIP(169);
      if (lookahead == '\r') SKIP(5);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 7:
      if (lookahead == '\n') SKIP(172);
      END_STATE();
    case 8:
      if (lookahead == '\n') SKIP(172);
      if (lookahead == '\r') SKIP(7);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 9:
      if (lookahead == '\n') SKIP(171);
      END_STATE();
    case 10:
      if (lookahead == '\n') SKIP(171);
      if (lookahead == '\r') SKIP(9);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 11:
      if (lookahead == '\n') SKIP(173);
      END_STATE();
    case 12:
      if (lookahead == '\n') SKIP(173);
      if (lookahead == '\r') SKIP(11);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 13:
      if (lookahead == '\n') SKIP(174);
      END_STATE();
    case 14:
      if (lookahead == '\n') SKIP(174);
      if (lookahead == '\r') SKIP(13);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 15:
      if (lookahead == '\n') SKIP(164);
      END_STATE();
    case 16:
      if (lookahead == '\n') SKIP(164);
      if (lookahead == '\r') SKIP(15);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 17:
      if (lookahead == '\n') SKIP(165);
      END_STATE();
    case 18:
      if (lookahead == '\n') SKIP(165);
      if (lookahead == '\r') SKIP(17);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 19:
      if (lookahead == '\n') SKIP(236);
      END_STATE();
    case 20:
      if (lookahead == '\n') SKIP(236);
      if (lookahead == '\r') SKIP(19);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 21:
      if (lookahead == '\n') SKIP(192);
      END_STATE();
    case 22:
      if (lookahead == '\n') SKIP(192);
      if (lookahead == '\r') SKIP(21);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 23:
      if (lookahead == '\n') SKIP(237);
      END_STATE();
    case 24:
      if (lookahead == '\n') SKIP(237);
      if (lookahead == '\r') SKIP(23);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 25:
      if (lookahead == '\n') SKIP(167);
      END_STATE();
    case 26:
      if (lookahead == '\n') SKIP(167);
      if (lookahead == '\r') SKIP(25);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 27:
      if (lookahead == '\n') SKIP(185);
      END_STATE();
    case 28:
      if (lookahead == '\n') SKIP(185);
      if (lookahead == '\r') SKIP(27);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 29:
      if (lookahead == '\n') SKIP(181);
      END_STATE();
    case 30:
      if (lookahead == '\n') SKIP(181);
      if (lookahead == '\r') SKIP(29);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 31:
      if (lookahead == '\n') SKIP(193);
      END_STATE();
    case 32:
      if (lookahead == '\n') SKIP(193);
      if (lookahead == '\r') SKIP(31);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 33:
      if (lookahead == '\n') SKIP(191);
      END_STATE();
    case 34:
      if (lookahead == '\n') SKIP(191);
      if (lookahead == '\r') SKIP(33);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 35:
      if (lookahead == '\n') SKIP(222);
      END_STATE();
    case 36:
      if (lookahead == '\n') SKIP(222);
      if (lookahead == '\r') SKIP(35);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 37:
      if (lookahead == '\n') SKIP(182);
      END_STATE();
    case 38:
      if (lookahead == '\n') SKIP(182);
      if (lookahead == '\r') SKIP(37);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 39:
      if (lookahead == '\n') SKIP(196);
      END_STATE();
    case 40:
      if (lookahead == '\n') SKIP(196);
      if (lookahead == '\r') SKIP(39);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 41:
      if (lookahead == '\n') SKIP(186);
      END_STATE();
    case 42:
      if (lookahead == '\n') SKIP(186);
      if (lookahead == '\r') SKIP(41);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 43:
      if (lookahead == '\n') SKIP(176);
      END_STATE();
    case 44:
      if (lookahead == '\n') SKIP(176);
      if (lookahead == '\r') SKIP(43);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 45:
      if (lookahead == '\n') SKIP(194);
      END_STATE();
    case 46:
      if (lookahead == '\n') SKIP(194);
      if (lookahead == '\r') SKIP(45);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 47:
      if (lookahead == '\n') SKIP(209);
      END_STATE();
    case 48:
      if (lookahead == '\n') SKIP(209);
      if (lookahead == '\r') SKIP(47);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 49:
      if (lookahead == '\n') SKIP(217);
      END_STATE();
    case 50:
      if (lookahead == '\n') SKIP(217);
      if (lookahead == '\r') SKIP(49);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 51:
      if (lookahead == '\n') SKIP(206);
      END_STATE();
    case 52:
      if (lookahead == '\n') SKIP(206);
      if (lookahead == '\r') SKIP(51);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 53:
      if (lookahead == '\n') SKIP(213);
      END_STATE();
    case 54:
      if (lookahead == '\n') SKIP(213);
      if (lookahead == '\r') SKIP(53);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 55:
      if (lookahead == '\n') SKIP(177);
      END_STATE();
    case 56:
      if (lookahead == '\n') SKIP(177);
      if (lookahead == '\r') SKIP(55);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 57:
      if (lookahead == '\n') SKIP(223);
      END_STATE();
    case 58:
      if (lookahead == '\n') SKIP(223);
      if (lookahead == '\r') SKIP(57);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 59:
      if (lookahead == '\n') SKIP(201);
      END_STATE();
    case 60:
      if (lookahead == '\n') SKIP(201);
      if (lookahead == '\r') SKIP(59);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 61:
      if (lookahead == '\n') SKIP(235);
      END_STATE();
    case 62:
      if (lookahead == '\n') SKIP(235);
      if (lookahead == '\r') SKIP(61);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 63:
      if (lookahead == '\n') SKIP(238);
      END_STATE();
    case 64:
      if (lookahead == '\n') SKIP(238);
      if (lookahead == '\r') SKIP(63);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 65:
      if (lookahead == '\n') SKIP(183);
      END_STATE();
    case 66:
      if (lookahead == '\n') SKIP(183);
      if (lookahead == '\r') SKIP(65);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 67:
      if (lookahead == '\n') SKIP(187);
      END_STATE();
    case 68:
      if (lookahead == '\n') SKIP(187);
      if (lookahead == '\r') SKIP(67);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 69:
      if (lookahead == '\n') SKIP(226);
      END_STATE();
    case 70:
      if (lookahead == '\n') SKIP(226);
      if (lookahead == '\r') SKIP(69);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 71:
      if (lookahead == '\n') SKIP(200);
      END_STATE();
    case 72:
      if (lookahead == '\n') SKIP(200);
      if (lookahead == '\r') SKIP(71);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 73:
      if (lookahead == '\n') SKIP(230);
      END_STATE();
    case 74:
      if (lookahead == '\n') SKIP(230);
      if (lookahead == '\r') SKIP(73);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 75:
      if (lookahead == '\n') SKIP(240);
      END_STATE();
    case 76:
      if (lookahead == '\n') SKIP(240);
      if (lookahead == '\r') SKIP(75);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 77:
      if (lookahead == '\n') SKIP(239);
      END_STATE();
    case 78:
      if (lookahead == '\n') SKIP(239);
      if (lookahead == '\r') SKIP(77);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 79:
      if (lookahead == '\n') SKIP(168);
      END_STATE();
    case 80:
      if (lookahead == '\n') SKIP(168);
      if (lookahead == '\r') SKIP(79);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 81:
      if (lookahead == '\n') SKIP(216);
      END_STATE();
    case 82:
      if (lookahead == '\n') SKIP(216);
      if (lookahead == '\r') SKIP(81);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 83:
      if (lookahead == '\n') SKIP(208);
      END_STATE();
    case 84:
      if (lookahead == '\n') SKIP(208);
      if (lookahead == '\r') SKIP(83);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 85:
      if (lookahead == '\n') SKIP(215);
      END_STATE();
    case 86:
      if (lookahead == '\n') SKIP(215);
      if (lookahead == '\r') SKIP(85);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 87:
      if (lookahead == '\n') SKIP(242);
      END_STATE();
    case 88:
      if (lookahead == '\n') SKIP(242);
      if (lookahead == '\r') SKIP(87);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 89:
      if (lookahead == '\n') SKIP(221);
      END_STATE();
    case 90:
      if (lookahead == '\n') SKIP(221);
      if (lookahead == '\r') SKIP(89);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 91:
      if (lookahead == '\n') SKIP(241);
      END_STATE();
    case 92:
      if (lookahead == '\n') SKIP(241);
      if (lookahead == '\r') SKIP(91);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 93:
      if (lookahead == '\n') SKIP(248);
      END_STATE();
    case 94:
      if (lookahead == '\n') SKIP(248);
      if (lookahead == '\r') SKIP(93);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 95:
      if (lookahead == '\n') SKIP(175);
      END_STATE();
    case 96:
      if (lookahead == '\n') SKIP(175);
      if (lookahead == '\r') SKIP(95);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 97:
      if (lookahead == '\n') SKIP(99);
      END_STATE();
    case 98:
      if (lookahead == '\n') SKIP(99);
      if (lookahead == '\r') SKIP(97);
      END_STATE();
    case 99:
      ADVANCE_MAP(
        '\n', 346,
        '!', 270,
        '%', 427,
        '&', 437,
        '(', 402,
        '*', 423,
        '+', 416,
        '-', 406,
        '/', 425,
        '<', 451,
        '=', 271,
        '>', 442,
      );
      if (lookahead == '\\') SKIP(98);
      if (lookahead == '^') ADVANCE(434);
      if (lookahead == '|') ADVANCE(433);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(99);
      END_STATE();
    case 100:
      if (lookahead == '\n') SKIP(243);
      END_STATE();
    case 101:
      if (lookahead == '\n') SKIP(243);
      if (lookahead == '\r') SKIP(100);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 102:
      if (lookahead == '\n') SKIP(247);
      END_STATE();
    case 103:
      if (lookahead == '\n') SKIP(247);
      if (lookahead == '\r') SKIP(102);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 104:
      if (lookahead == '\n') SKIP(231);
      END_STATE();
    case 105:
      if (lookahead == '\n') SKIP(231);
      if (lookahead == '\r') SKIP(104);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 106:
      if (lookahead == '\n') SKIP(232);
      END_STATE();
    case 107:
      if (lookahead == '\n') SKIP(232);
      if (lookahead == '\r') SKIP(106);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 108:
      if (lookahead == '\n') SKIP(233);
      if (lookahead == '"') ADVANCE(522);
      if (lookahead == '/') ADVANCE(523);
      if (lookahead == '\\') ADVANCE(109);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(526);
      if (lookahead != 0) ADVANCE(527);
      END_STATE();
    case 109:
      if (lookahead == '\n') ADVANCE(529);
      if (lookahead == '\r') ADVANCE(528);
      if (lookahead == 'U') ADVANCE(333);
      if (lookahead == 'u') ADVANCE(325);
      if (lookahead == 'x') ADVANCE(319);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(531);
      if (lookahead != 0) ADVANCE(528);
      END_STATE();
    case 110:
      if (lookahead == '\n') SKIP(244);
      if (lookahead == '\'') ADVANCE(513);
      if (lookahead == '/') ADVANCE(516);
      if (lookahead == '\\') ADVANCE(515);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(517);
      if (lookahead != 0) ADVANCE(514);
      END_STATE();
    case 111:
      if (lookahead == '\n') ADVANCE(339);
      if (lookahead == '\r') ADVANCE(115);
      if (lookahead == '(') ADVANCE(341);
      if (lookahead == '/') ADVANCE(367);
      if (lookahead == '\\') ADVANCE(362);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(261);
      if (lookahead != 0) ADVANCE(369);
      END_STATE();
    case 112:
      if (lookahead == '\n') ADVANCE(339);
      if (lookahead == '\r') ADVANCE(115);
      if (lookahead == '/') ADVANCE(367);
      if (lookahead == '\\') ADVANCE(362);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(261);
      if (lookahead != 0) ADVANCE(369);
      END_STATE();
    case 113:
      if (lookahead == '\n') ADVANCE(339);
      if (lookahead == '\r') ADVANCE(114);
      if (lookahead == '(') ADVANCE(402);
      if (lookahead == '/') ADVANCE(252);
      if (lookahead == '\\') SKIP(117);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(249);
      END_STATE();
    case 114:
      if (lookahead == '\n') ADVANCE(339);
      if (lookahead == '(') ADVANCE(402);
      if (lookahead == '/') ADVANCE(252);
      if (lookahead == '\\') SKIP(117);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(249);
      END_STATE();
    case 115:
      if (lookahead == '\n') ADVANCE(339);
      if (lookahead == '/') ADVANCE(367);
      if (lookahead == '\\') ADVANCE(362);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(261);
      if (lookahead != 0) ADVANCE(369);
      END_STATE();
    case 116:
      if (lookahead == '\n') SKIP(249);
      END_STATE();
    case 117:
      if (lookahead == '\n') SKIP(249);
      if (lookahead == '\r') SKIP(116);
      END_STATE();
    case 118:
      if (lookahead == '\n') SKIP(162);
      END_STATE();
    case 119:
      if (lookahead == '\n') SKIP(162);
      if (lookahead == '\r') SKIP(118);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 120:
      if (lookahead == '\n') SKIP(166);
      END_STATE();
    case 121:
      if (lookahead == '\n') SKIP(166);
      if (lookahead == '\r') SKIP(120);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 122:
      if (lookahead == '\n') SKIP(202);
      END_STATE();
    case 123:
      if (lookahead == '\n') SKIP(202);
      if (lookahead == '\r') SKIP(122);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 124:
      if (lookahead == '\n') SKIP(197);
      END_STATE();
    case 125:
      if (lookahead == '\n') SKIP(197);
      if (lookahead == '\r') SKIP(124);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 126:
      if (lookahead == '\n') SKIP(227);
      END_STATE();
    case 127:
      if (lookahead == '\n') SKIP(227);
      if (lookahead == '\r') SKIP(126);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 128:
      if (lookahead == '\n') SKIP(207);
      END_STATE();
    case 129:
      if (lookahead == '\n') SKIP(207);
      if (lookahead == '\r') SKIP(128);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 130:
      if (lookahead == '\n') SKIP(179);
      END_STATE();
    case 131:
      if (lookahead == '\n') SKIP(179);
      if (lookahead == '\r') SKIP(130);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 132:
      if (lookahead == '\n') SKIP(224);
      END_STATE();
    case 133:
      if (lookahead == '\n') SKIP(224);
      if (lookahead == '\r') SKIP(132);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 134:
      if (lookahead == '\n') SKIP(189);
      END_STATE();
    case 135:
      if (lookahead == '\n') SKIP(189);
      if (lookahead == '\r') SKIP(134);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 136:
      if (lookahead == '\n') SKIP(214);
      END_STATE();
    case 137:
      if (lookahead == '\n') SKIP(214);
      if (lookahead == '\r') SKIP(136);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 138:
      if (lookahead == '\n') SKIP(199);
      END_STATE();
    case 139:
      if (lookahead == '\n') SKIP(199);
      if (lookahead == '\r') SKIP(138);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 140:
      if (lookahead == '\n') SKIP(219);
      END_STATE();
    case 141:
      if (lookahead == '\n') SKIP(219);
      if (lookahead == '\r') SKIP(140);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 142:
      if (lookahead == '\n') SKIP(211);
      END_STATE();
    case 143:
      if (lookahead == '\n') SKIP(211);
      if (lookahead == '\r') SKIP(142);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 144:
      if (lookahead == '\n') SKIP(163);
      END_STATE();
    case 145:
      if (lookahead == '\n') SKIP(163);
      if (lookahead == '\r') SKIP(144);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 146:
      if (lookahead == '\n') SKIP(203);
      END_STATE();
    case 147:
      if (lookahead == '\n') SKIP(203);
      if (lookahead == '\r') SKIP(146);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 148:
      if (lookahead == '\n') SKIP(225);
      END_STATE();
    case 149:
      if (lookahead == '\n') SKIP(225);
      if (lookahead == '\r') SKIP(148);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 150:
      if (lookahead == '\n') SKIP(205);
      END_STATE();
    case 151:
      if (lookahead == '\n') SKIP(205);
      if (lookahead == '\r') SKIP(150);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 152:
      if (lookahead == '\n') SKIP(220);
      END_STATE();
    case 153:
      if (lookahead == '\n') SKIP(220);
      if (lookahead == '\r') SKIP(152);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 154:
      if (lookahead == '\n') SKIP(212);
      END_STATE();
    case 155:
      if (lookahead == '\n') SKIP(212);
      if (lookahead == '\r') SKIP(154);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 156:
      if (lookahead == '\n') SKIP(195);
      END_STATE();
    case 157:
      if (lookahead == '\n') SKIP(195);
      if (lookahead == '\r') SKIP(156);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 158:
      if (lookahead == '\n') SKIP(229);
      END_STATE();
    case 159:
      if (lookahead == '\n') SKIP(229);
      if (lookahead == '\r') SKIP(158);
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 160:
      if (lookahead == '\r') ADVANCE(637);
      if (lookahead == '\\') ADVANCE(631);
      if (lookahead != 0) ADVANCE(636);
      END_STATE();
    case 161:
      ADVANCE_MAP(
        '!', 404,
        '"', 522,
        '#', 283,
        '%', 428,
        '&', 438,
        '\'', 513,
        '(', 402,
        ')', 344,
        '*', 424,
        '+', 418,
        ',', 343,
        '-', 407,
        '.', 488,
        '/', 426,
        '0', 495,
        ':', 472,
        ';', 456,
        '<', 448,
        '=', 468,
        '>', 638,
        '?', 473,
        'F', 565,
        'L', 539,
        'R', 542,
        'T', 569,
        'U', 543,
        '[', 464,
        '\\', 2,
        ']', 466,
        '^', 435,
        'b', 611,
        'c', 590,
        'd', 607,
        'f', 574,
        'i', 604,
        'm', 576,
        'n', 624,
        'p', 621,
        's', 591,
        't', 616,
        'u', 546,
        'v', 608,
        '{', 460,
        '|', 432,
        '}', 461,
        '~', 405,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(161);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 162:
      ADVANCE_MAP(
        '!', 404,
        '"', 522,
        '#', 292,
        '%', 428,
        '&', 438,
        '\'', 513,
        '(', 402,
        ')', 344,
        '*', 424,
        '+', 418,
        ',', 343,
        '-', 408,
        '.', 488,
        '/', 426,
        '0', 495,
        ':', 472,
        ';', 456,
        '<', 448,
        '=', 468,
        '>', 443,
        '?', 473,
        'F', 565,
        'L', 539,
        'R', 542,
        'T', 569,
        'U', 543,
        '[', 462,
        '\\', 119,
        ']', 466,
        '^', 435,
        'b', 611,
        'c', 590,
        'd', 607,
        'f', 574,
        'i', 604,
        'm', 576,
        'n', 624,
        'p', 621,
        's', 591,
        't', 616,
        'u', 546,
        'v', 608,
        '{', 460,
        '|', 432,
        '}', 461,
        '~', 405,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(162);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 163:
      ADVANCE_MAP(
        '!', 404,
        '"', 522,
        '#', 292,
        '%', 427,
        '&', 437,
        '\'', 513,
        '(', 402,
        ')', 344,
        '*', 423,
        '+', 419,
        ',', 343,
        '-', 409,
        '.', 488,
        '/', 425,
        '0', 495,
        ':', 472,
        ';', 456,
        '<', 450,
        '=', 271,
        '>', 442,
        '?', 473,
        'F', 565,
        'L', 539,
        'R', 542,
        'T', 569,
        'U', 543,
        '[', 462,
        '\\', 145,
        ']', 466,
        '^', 434,
        'b', 611,
        'c', 590,
        'd', 607,
        'f', 574,
        'i', 604,
        'm', 576,
        'n', 624,
        'p', 621,
        's', 591,
        't', 616,
        'u', 546,
        'v', 608,
        '{', 460,
        '|', 433,
        '}', 461,
        '~', 405,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(163);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 164:
      ADVANCE_MAP(
        '!', 404,
        '"', 522,
        '%', 428,
        '&', 438,
        '\'', 513,
        '(', 402,
        ')', 344,
        '*', 424,
        '+', 418,
        ',', 343,
        '-', 407,
        '.', 488,
        '/', 426,
        '0', 495,
        ':', 268,
        '<', 448,
        '=', 468,
        '>', 443,
        '?', 473,
        'F', 565,
        'L', 539,
        'R', 542,
        'T', 569,
        'U', 543,
        '[', 462,
        '\\', 16,
        '^', 435,
        'b', 611,
        'c', 590,
        'd', 607,
        'f', 574,
        'i', 604,
        'm', 576,
        'n', 624,
        'p', 621,
        's', 591,
        't', 616,
        'u', 546,
        'v', 608,
        '{', 460,
        '|', 432,
        '~', 405,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(164);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 165:
      ADVANCE_MAP(
        '!', 404,
        '"', 522,
        '%', 428,
        '&', 438,
        '\'', 513,
        '(', 402,
        '*', 424,
        '+', 418,
        ',', 343,
        '-', 408,
        '.', 488,
        '/', 426,
        '0', 495,
        ':', 268,
        '<', 448,
        '=', 468,
        '>', 638,
        '?', 473,
        'F', 565,
        'L', 539,
        'R', 542,
        'T', 569,
        'U', 543,
        '[', 462,
        '\\', 18,
        '^', 435,
        'b', 611,
        'c', 590,
        'd', 607,
        'f', 574,
        'i', 604,
        'm', 576,
        'n', 624,
        'p', 621,
        's', 591,
        't', 616,
        'u', 546,
        'v', 608,
        '{', 460,
        '|', 432,
        '~', 405,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(165);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 166:
      ADVANCE_MAP(
        '!', 404,
        '"', 522,
        '%', 427,
        '&', 437,
        '\'', 513,
        '(', 402,
        '*', 423,
        '+', 419,
        ',', 343,
        '-', 409,
        '.', 488,
        '/', 425,
        '0', 495,
        ':', 268,
        '<', 450,
        '=', 271,
        '>', 638,
        '?', 473,
        'F', 565,
        'L', 539,
        'R', 542,
        'T', 569,
        'U', 543,
        '[', 462,
        '\\', 121,
        '^', 434,
        'b', 611,
        'c', 590,
        'd', 607,
        'f', 574,
        'i', 604,
        'm', 576,
        'n', 624,
        'p', 621,
        's', 591,
        't', 616,
        'u', 546,
        'v', 608,
        '{', 460,
        '|', 433,
        '~', 405,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(166);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 167:
      ADVANCE_MAP(
        '!', 404,
        '"', 234,
        '%', 428,
        '&', 438,
        '(', 250,
        '*', 424,
        '+', 420,
        ',', 343,
        '-', 411,
        '/', 426,
        ':', 268,
        '<', 448,
        '=', 468,
        '>', 443,
        '[', 280,
        '\\', 26,
        '^', 435,
        'b', 611,
        'c', 590,
        'd', 607,
        'f', 603,
        'i', 604,
        'm', 576,
        'n', 624,
        'p', 621,
        's', 591,
        'u', 596,
        'v', 608,
        '|', 432,
        '~', 405,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(167);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 168:
      ADVANCE_MAP(
        '!', 404,
        '"', 234,
        '%', 428,
        '&', 438,
        '(', 250,
        '*', 424,
        '+', 420,
        ',', 343,
        '-', 411,
        '/', 426,
        '<', 448,
        '=', 468,
        '>', 443,
        '[', 281,
        '\\', 80,
        '^', 435,
        '|', 432,
        '~', 405,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(168);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 169:
      ADVANCE_MAP(
        '!', 403,
        '"', 522,
        '#', 283,
        '&', 437,
        '\'', 513,
        '(', 402,
        '*', 423,
        '+', 419,
        ',', 343,
        '-', 410,
        '.', 312,
        '/', 252,
        '0', 495,
        ':', 268,
        ';', 456,
        '<', 269,
        '>', 441,
        'F', 565,
        'L', 539,
        'R', 542,
        'T', 569,
        'U', 543,
        '[', 463,
        '\\', 6,
        ']', 282,
        'b', 611,
        'c', 590,
        'd', 607,
        'f', 574,
        'i', 604,
        'm', 576,
        'n', 624,
        'p', 621,
        's', 591,
        't', 616,
        'u', 546,
        'v', 608,
        '{', 460,
        '|', 431,
        '~', 405,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(169);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 170:
      ADVANCE_MAP(
        '!', 403,
        '"', 522,
        '#', 287,
        '%', 427,
        '&', 437,
        '\'', 513,
        '(', 402,
        ')', 344,
        '*', 423,
        '+', 419,
        ',', 343,
        '-', 410,
        '.', 489,
        '/', 425,
        '0', 495,
        ':', 472,
        ';', 456,
        '<', 447,
        '=', 467,
        '>', 638,
        'F', 565,
        'L', 539,
        'R', 542,
        'T', 569,
        'U', 543,
        '[', 463,
        '\\', 4,
        ']', 466,
        '^', 434,
        'b', 611,
        'c', 590,
        'd', 607,
        'f', 574,
        'i', 604,
        'm', 576,
        'n', 624,
        'p', 621,
        's', 591,
        't', 616,
        'u', 546,
        'v', 608,
        '{', 460,
        '|', 306,
        '}', 461,
        '~', 405,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(170);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 171:
      ADVANCE_MAP(
        '!', 403,
        '"', 522,
        '#', 291,
        '&', 436,
        '\'', 513,
        '(', 402,
        ')', 344,
        '*', 423,
        '+', 419,
        '-', 410,
        '.', 258,
        '/', 252,
        '0', 495,
        ':', 268,
        ';', 456,
        '>', 274,
        'F', 565,
        'L', 539,
        'R', 542,
        'T', 569,
        'U', 543,
        '[', 463,
        '\\', 10,
        'b', 611,
        'c', 590,
        'd', 607,
        'f', 574,
        'i', 604,
        'm', 576,
        'n', 624,
        'p', 621,
        's', 591,
        't', 616,
        'u', 546,
        'v', 608,
        '{', 460,
        '~', 405,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(171);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 172:
      ADVANCE_MAP(
        '!', 403,
        '"', 522,
        '#', 285,
        '&', 437,
        '\'', 513,
        '(', 402,
        '*', 423,
        '+', 419,
        ',', 343,
        '-', 410,
        '.', 312,
        '/', 252,
        '0', 495,
        ':', 268,
        ';', 456,
        '>', 272,
        'F', 565,
        'L', 539,
        'R', 542,
        'T', 569,
        'U', 543,
        '[', 463,
        '\\', 8,
        'b', 611,
        'c', 590,
        'd', 607,
        'f', 574,
        'i', 604,
        'm', 576,
        'n', 624,
        'p', 621,
        's', 591,
        't', 616,
        'u', 546,
        'v', 608,
        '{', 460,
        '~', 405,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(172);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 173:
      ADVANCE_MAP(
        '!', 403,
        '"', 522,
        '&', 437,
        '\'', 513,
        '(', 402,
        ')', 344,
        '*', 423,
        '+', 419,
        ',', 343,
        '-', 410,
        '.', 489,
        '/', 252,
        '0', 495,
        ':', 268,
        ';', 456,
        '<', 447,
        '=', 467,
        '>', 638,
        'F', 565,
        'L', 539,
        'R', 542,
        'T', 569,
        'U', 543,
        '[', 462,
        '\\', 12,
        'b', 611,
        'c', 590,
        'd', 607,
        'f', 574,
        'i', 604,
        'm', 576,
        'n', 624,
        'p', 621,
        's', 591,
        't', 616,
        'u', 546,
        'v', 608,
        '{', 460,
        '~', 405,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(173);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 174:
      ADVANCE_MAP(
        '!', 403,
        '"', 522,
        '&', 436,
        '\'', 513,
        '(', 402,
        ')', 344,
        '*', 423,
        '+', 419,
        ',', 343,
        '-', 410,
        '.', 489,
        '/', 252,
        '0', 495,
        ':', 472,
        ';', 456,
        '<', 447,
        '=', 467,
        '>', 638,
        'F', 565,
        'L', 539,
        'R', 542,
        'T', 569,
        'U', 543,
        '[', 462,
        '\\', 14,
        ']', 466,
        'b', 611,
        'c', 590,
        'd', 607,
        'f', 574,
        'i', 604,
        'm', 576,
        'n', 624,
        'p', 621,
        's', 591,
        't', 616,
        'u', 546,
        'v', 608,
        '{', 460,
        '}', 461,
        '~', 405,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(174);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 175:
      ADVANCE_MAP(
        '!', 403,
        '\'', 513,
        '(', 402,
        ')', 344,
        '+', 421,
        '-', 414,
        '.', 312,
        '/', 252,
        '0', 495,
        'L', 557,
        'U', 558,
        '\\', 96,
        'u', 559,
        '~', 405,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(175);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 176:
      ADVANCE_MAP(
        '!', 270,
        '"', 522,
        '#', 292,
        '%', 428,
        '&', 438,
        '(', 402,
        ')', 344,
        '*', 424,
        '+', 420,
        ',', 343,
        '-', 412,
        '.', 487,
        '/', 426,
        ':', 472,
        ';', 456,
        '<', 448,
        '=', 468,
        '>', 443,
        '?', 473,
        'L', 540,
        'R', 542,
        'U', 544,
        '[', 462,
        '\\', 44,
        ']', 466,
        '^', 435,
        'u', 547,
        '{', 460,
        '|', 432,
        '}', 461,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(176);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 177:
      ADVANCE_MAP(
        '!', 270,
        '"', 522,
        '#', 292,
        '%', 428,
        '&', 438,
        '(', 402,
        ')', 344,
        '*', 424,
        '+', 420,
        ',', 343,
        '-', 412,
        '.', 487,
        '/', 426,
        ':', 471,
        ';', 456,
        '<', 448,
        '=', 468,
        '>', 443,
        '?', 473,
        'L', 540,
        'R', 542,
        'U', 544,
        '[', 462,
        '\\', 56,
        ']', 466,
        '^', 435,
        'u', 547,
        '|', 432,
        '}', 461,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(177);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 178:
      ADVANCE_MAP(
        '!', 270,
        '"', 522,
        '#', 292,
        '%', 428,
        '&', 438,
        '(', 402,
        ')', 344,
        '*', 424,
        '+', 420,
        ',', 343,
        '-', 412,
        '.', 487,
        '/', 426,
        ':', 471,
        ';', 456,
        '<', 448,
        '=', 468,
        '>', 443,
        '?', 473,
        'L', 649,
        'R', 650,
        'U', 651,
        '[', 462,
        '\\', 56,
        ']', 466,
        '^', 435,
        'u', 652,
        '|', 432,
        '}', 461,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(177);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 179:
      ADVANCE_MAP(
        '!', 270,
        '"', 522,
        '#', 292,
        '%', 427,
        '&', 437,
        '(', 402,
        ')', 344,
        '*', 423,
        '+', 417,
        ',', 343,
        '-', 413,
        '.', 487,
        '/', 425,
        ':', 471,
        ';', 456,
        '<', 450,
        '=', 271,
        '>', 442,
        '?', 473,
        'L', 540,
        'R', 542,
        'U', 544,
        '[', 462,
        '\\', 131,
        ']', 466,
        '^', 434,
        'u', 547,
        '|', 433,
        '}', 461,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(179);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 180:
      ADVANCE_MAP(
        '!', 270,
        '"', 522,
        '#', 292,
        '%', 427,
        '&', 437,
        '(', 402,
        ')', 344,
        '*', 423,
        '+', 417,
        ',', 343,
        '-', 413,
        '.', 487,
        '/', 425,
        ':', 471,
        ';', 456,
        '<', 450,
        '=', 271,
        '>', 442,
        '?', 473,
        'L', 649,
        'R', 650,
        'U', 651,
        '[', 462,
        '\\', 131,
        ']', 466,
        '^', 434,
        'u', 652,
        '|', 433,
        '}', 461,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(179);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 181:
      ADVANCE_MAP(
        '!', 270,
        '"', 522,
        '%', 428,
        '&', 438,
        '(', 402,
        ')', 344,
        '*', 424,
        '+', 420,
        ',', 343,
        '-', 411,
        '.', 487,
        '/', 426,
        ':', 268,
        '<', 448,
        '=', 468,
        '>', 443,
        '?', 473,
        'L', 540,
        'R', 542,
        'U', 544,
        '[', 463,
        '\\', 30,
        '^', 435,
        'u', 547,
        '{', 460,
        '|', 432,
        '~', 405,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(181);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 182:
      ADVANCE_MAP(
        '!', 270,
        '"', 522,
        '%', 428,
        '&', 438,
        '(', 402,
        ')', 344,
        '*', 424,
        '+', 420,
        ',', 343,
        '-', 411,
        '.', 487,
        '/', 426,
        ':', 268,
        '<', 448,
        '=', 468,
        '>', 443,
        '?', 473,
        'L', 540,
        'R', 542,
        'U', 544,
        '[', 462,
        '\\', 38,
        '^', 435,
        'u', 547,
        '{', 460,
        '|', 432,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(182);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 183:
      ADVANCE_MAP(
        '!', 270,
        '"', 522,
        '%', 428,
        '&', 438,
        '(', 402,
        ')', 344,
        '*', 424,
        '+', 420,
        ',', 343,
        '-', 411,
        '.', 487,
        '/', 426,
        '<', 448,
        '=', 468,
        '>', 443,
        '?', 473,
        'L', 540,
        'R', 542,
        'U', 544,
        '[', 462,
        '\\', 66,
        '^', 435,
        'u', 547,
        '|', 432,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(183);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 184:
      ADVANCE_MAP(
        '!', 270,
        '"', 522,
        '%', 428,
        '&', 438,
        '(', 402,
        ')', 344,
        '*', 424,
        '+', 420,
        ',', 343,
        '-', 411,
        '.', 487,
        '/', 426,
        '<', 448,
        '=', 468,
        '>', 443,
        '?', 473,
        'L', 649,
        'R', 650,
        'U', 651,
        '[', 462,
        '\\', 66,
        '^', 435,
        'u', 652,
        '|', 432,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(183);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 185:
      ADVANCE_MAP(
        '!', 270,
        '"', 522,
        '%', 428,
        '&', 438,
        '(', 402,
        ')', 344,
        '*', 424,
        '+', 420,
        ',', 343,
        '-', 412,
        '.', 487,
        '/', 426,
        ':', 472,
        ';', 456,
        '<', 448,
        '=', 468,
        '>', 443,
        '?', 473,
        'L', 540,
        'R', 542,
        'U', 544,
        '[', 463,
        '\\', 28,
        '^', 435,
        'u', 547,
        '{', 460,
        '|', 432,
        '}', 461,
        '~', 405,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(185);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 186:
      ADVANCE_MAP(
        '!', 270,
        '"', 522,
        '%', 428,
        '&', 438,
        '(', 402,
        '*', 424,
        '+', 420,
        ',', 343,
        '-', 412,
        '.', 487,
        '/', 426,
        ':', 268,
        '<', 448,
        '=', 468,
        '>', 638,
        '?', 473,
        'L', 540,
        'R', 542,
        'U', 544,
        '[', 462,
        '\\', 42,
        '^', 435,
        'u', 547,
        '{', 460,
        '|', 432,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(186);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 187:
      ADVANCE_MAP(
        '!', 270,
        '"', 522,
        '%', 428,
        '&', 438,
        '(', 402,
        '*', 424,
        '+', 420,
        ',', 343,
        '-', 412,
        '.', 487,
        '/', 426,
        '<', 448,
        '=', 468,
        '>', 638,
        '?', 473,
        'L', 540,
        'R', 542,
        'U', 544,
        '[', 462,
        '\\', 68,
        '^', 435,
        'u', 547,
        '|', 432,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(187);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 188:
      ADVANCE_MAP(
        '!', 270,
        '"', 522,
        '%', 428,
        '&', 438,
        '(', 402,
        '*', 424,
        '+', 420,
        ',', 343,
        '-', 412,
        '.', 487,
        '/', 426,
        '<', 448,
        '=', 468,
        '>', 638,
        '?', 473,
        'L', 649,
        'R', 650,
        'U', 651,
        '[', 462,
        '\\', 68,
        '^', 435,
        'u', 652,
        '|', 432,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(187);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 189:
      ADVANCE_MAP(
        '!', 270,
        '"', 522,
        '%', 427,
        '&', 437,
        '(', 402,
        '*', 423,
        '+', 417,
        ',', 343,
        '-', 413,
        '.', 487,
        '/', 425,
        '<', 450,
        '=', 271,
        '>', 638,
        '?', 473,
        'L', 540,
        'R', 542,
        'U', 544,
        '[', 462,
        '\\', 135,
        '^', 434,
        'u', 547,
        '|', 433,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(189);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 190:
      ADVANCE_MAP(
        '!', 270,
        '"', 522,
        '%', 427,
        '&', 437,
        '(', 402,
        '*', 423,
        '+', 417,
        ',', 343,
        '-', 413,
        '.', 487,
        '/', 425,
        '<', 450,
        '=', 271,
        '>', 638,
        '?', 473,
        'L', 649,
        'R', 650,
        'U', 651,
        '[', 462,
        '\\', 135,
        '^', 434,
        'u', 652,
        '|', 433,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(189);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 191:
      ADVANCE_MAP(
        '!', 270,
        '#', 303,
        '%', 428,
        '&', 438,
        '(', 402,
        ')', 344,
        '*', 424,
        '+', 420,
        ',', 343,
        '-', 411,
        '.', 487,
        '/', 426,
        ':', 268,
        ';', 456,
        '<', 448,
        '=', 468,
        '>', 443,
        '?', 473,
        '[', 463,
        '\\', 34,
        '^', 435,
        '{', 460,
        '|', 432,
        '}', 461,
        '~', 405,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(191);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 192:
      ADVANCE_MAP(
        '!', 270,
        '#', 288,
        '%', 427,
        '&', 437,
        '(', 402,
        ')', 344,
        '*', 423,
        '+', 416,
        ',', 343,
        '-', 406,
        '/', 425,
        ':', 268,
        ';', 456,
        '<', 451,
        '=', 271,
        '>', 442,
        '[', 463,
        '\\', 22,
        '^', 434,
        'b', 611,
        'c', 590,
        'd', 607,
        'f', 603,
        'i', 604,
        'm', 576,
        'n', 624,
        'p', 621,
        's', 591,
        'u', 596,
        'v', 608,
        '|', 433,
        '}', 461,
        '~', 405,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(192);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 193:
      ADVANCE_MAP(
        '!', 270,
        '#', 292,
        '%', 428,
        '&', 438,
        '(', 402,
        ')', 344,
        '*', 424,
        '+', 420,
        ',', 343,
        '-', 412,
        '.', 487,
        '/', 426,
        '0', 639,
        ':', 472,
        ';', 456,
        '<', 448,
        '=', 468,
        '>', 443,
        '?', 473,
        '[', 463,
        '\\', 32,
        ']', 466,
        '^', 435,
        '{', 460,
        '|', 432,
        '}', 461,
        '~', 405,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(193);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 194:
      ADVANCE_MAP(
        '!', 270,
        '#', 292,
        '%', 428,
        '&', 438,
        '(', 402,
        ')', 344,
        '*', 424,
        '+', 420,
        ',', 343,
        '-', 412,
        '.', 487,
        '/', 426,
        ':', 472,
        ';', 456,
        '<', 448,
        '=', 468,
        '>', 443,
        '?', 473,
        '[', 462,
        '\\', 46,
        ']', 466,
        '^', 435,
        '{', 460,
        '|', 432,
        '}', 461,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(194);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 195:
      ADVANCE_MAP(
        '!', 270,
        '#', 292,
        '%', 428,
        '&', 438,
        '(', 402,
        ')', 344,
        '*', 424,
        '+', 420,
        ',', 343,
        '-', 412,
        '.', 487,
        '/', 426,
        ':', 471,
        ';', 456,
        '<', 448,
        '=', 468,
        '>', 443,
        '?', 473,
        '[', 463,
        '\\', 157,
        ']', 466,
        '^', 435,
        '{', 460,
        '|', 432,
        '}', 461,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(195);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 196:
      ADVANCE_MAP(
        '!', 270,
        '#', 292,
        '%', 428,
        '&', 438,
        '(', 402,
        ')', 344,
        '*', 424,
        '+', 420,
        ',', 343,
        '-', 412,
        '.', 487,
        '/', 426,
        ':', 471,
        ';', 456,
        '<', 448,
        '=', 468,
        '>', 443,
        '?', 473,
        '[', 462,
        '\\', 40,
        ']', 466,
        '^', 435,
        'b', 611,
        'c', 590,
        'd', 607,
        'f', 603,
        'i', 604,
        'm', 576,
        'n', 624,
        'p', 621,
        's', 591,
        'u', 596,
        'v', 608,
        '{', 460,
        '|', 432,
        '}', 461,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(196);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 197:
      ADVANCE_MAP(
        '!', 270,
        '#', 292,
        '%', 428,
        '&', 438,
        '(', 402,
        ')', 344,
        '*', 424,
        '+', 420,
        ',', 343,
        '-', 412,
        '.', 487,
        '/', 426,
        ':', 471,
        ';', 456,
        '<', 448,
        '=', 468,
        '>', 443,
        '?', 473,
        '[', 462,
        '\\', 125,
        ']', 466,
        '^', 435,
        '{', 460,
        '|', 432,
        '}', 461,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(197);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 198:
      ADVANCE_MAP(
        '!', 270,
        '#', 292,
        '%', 428,
        '&', 438,
        '(', 402,
        ')', 344,
        '*', 424,
        '+', 420,
        ',', 343,
        '-', 412,
        '.', 487,
        '/', 426,
        ':', 471,
        ';', 456,
        '<', 448,
        '=', 468,
        '>', 443,
        '?', 473,
        '[', 462,
        '\\', 139,
        ']', 466,
        '^', 435,
        '|', 432,
        '}', 461,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(199);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 199:
      ADVANCE_MAP(
        '!', 270,
        '#', 292,
        '%', 428,
        '&', 438,
        '(', 402,
        ')', 344,
        '*', 424,
        '+', 420,
        ',', 343,
        '-', 412,
        '.', 487,
        '/', 426,
        ':', 471,
        ';', 456,
        '<', 448,
        '=', 468,
        '>', 443,
        '?', 473,
        '[', 462,
        '\\', 139,
        ']', 466,
        '^', 435,
        '|', 432,
        '}', 461,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(199);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 200:
      ADVANCE_MAP(
        '!', 270,
        '#', 292,
        '%', 428,
        '&', 438,
        '(', 402,
        ')', 344,
        '*', 424,
        '+', 420,
        ',', 343,
        '-', 412,
        '.', 487,
        '/', 426,
        ':', 471,
        ';', 456,
        '<', 448,
        '=', 468,
        '>', 443,
        '?', 473,
        '[', 465,
        '\\', 72,
        ']', 466,
        '^', 435,
        '|', 432,
        '}', 461,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(200);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 201:
      ADVANCE_MAP(
        '!', 270,
        '#', 292,
        '%', 427,
        '&', 437,
        '(', 402,
        ')', 344,
        '*', 423,
        '+', 417,
        ',', 343,
        '-', 413,
        '.', 487,
        '/', 425,
        ':', 472,
        ';', 456,
        '<', 450,
        '=', 271,
        '>', 442,
        '?', 473,
        '[', 462,
        '\\', 60,
        ']', 466,
        '^', 434,
        '{', 460,
        '|', 433,
        '}', 461,
        '~', 405,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(201);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 202:
      ADVANCE_MAP(
        '!', 270,
        '#', 292,
        '%', 427,
        '&', 437,
        '(', 402,
        ')', 344,
        '*', 423,
        '+', 417,
        ',', 343,
        '-', 413,
        '.', 487,
        '/', 425,
        ':', 471,
        ';', 456,
        '<', 450,
        '=', 271,
        '>', 442,
        '?', 473,
        '[', 462,
        '\\', 123,
        ']', 466,
        '^', 434,
        'b', 611,
        'c', 590,
        'd', 607,
        'f', 603,
        'i', 604,
        'm', 576,
        'n', 624,
        'p', 621,
        's', 591,
        'u', 596,
        'v', 608,
        '{', 460,
        '|', 433,
        '}', 461,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(202);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 203:
      ADVANCE_MAP(
        '!', 270,
        '#', 292,
        '%', 427,
        '&', 437,
        '(', 402,
        ')', 344,
        '*', 423,
        '+', 417,
        ',', 343,
        '-', 413,
        '.', 487,
        '/', 425,
        ':', 471,
        ';', 456,
        '<', 450,
        '=', 271,
        '>', 442,
        '?', 473,
        '[', 462,
        '\\', 147,
        ']', 466,
        '^', 434,
        '{', 460,
        '|', 433,
        '}', 461,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(203);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 204:
      ADVANCE_MAP(
        '!', 270,
        '#', 292,
        '%', 427,
        '&', 437,
        '(', 402,
        ')', 344,
        '*', 423,
        '+', 417,
        ',', 343,
        '-', 413,
        '.', 487,
        '/', 425,
        ':', 471,
        ';', 456,
        '<', 450,
        '=', 271,
        '>', 442,
        '?', 473,
        '[', 462,
        '\\', 151,
        ']', 466,
        '^', 434,
        '|', 433,
        '}', 461,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(205);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 205:
      ADVANCE_MAP(
        '!', 270,
        '#', 292,
        '%', 427,
        '&', 437,
        '(', 402,
        ')', 344,
        '*', 423,
        '+', 417,
        ',', 343,
        '-', 413,
        '.', 487,
        '/', 425,
        ':', 471,
        ';', 456,
        '<', 450,
        '=', 271,
        '>', 442,
        '?', 473,
        '[', 462,
        '\\', 151,
        ']', 466,
        '^', 434,
        '|', 433,
        '}', 461,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(205);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 206:
      ADVANCE_MAP(
        '!', 270,
        '%', 428,
        '&', 438,
        '(', 402,
        ')', 344,
        '*', 424,
        '+', 420,
        ',', 343,
        '-', 411,
        '.', 487,
        '/', 426,
        ':', 472,
        ';', 456,
        '<', 448,
        '=', 468,
        '>', 443,
        '?', 473,
        '[', 462,
        '\\', 52,
        '^', 435,
        '{', 460,
        '|', 432,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(206);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 207:
      ADVANCE_MAP(
        '!', 270,
        '%', 428,
        '&', 438,
        '(', 402,
        ')', 344,
        '*', 424,
        '+', 420,
        ',', 343,
        '-', 411,
        '.', 487,
        '/', 426,
        ':', 471,
        '<', 448,
        '=', 468,
        '>', 443,
        '?', 473,
        '[', 462,
        '\\', 129,
        '^', 435,
        '{', 460,
        '|', 432,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(207);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 208:
      ADVANCE_MAP(
        '!', 270,
        '%', 428,
        '&', 438,
        '(', 402,
        ')', 344,
        '*', 424,
        '+', 420,
        ',', 343,
        '-', 411,
        '.', 487,
        '/', 426,
        '<', 448,
        '=', 468,
        '>', 443,
        '?', 473,
        '[', 464,
        '\\', 84,
        '^', 435,
        '|', 432,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(208);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 209:
      ADVANCE_MAP(
        '!', 270,
        '%', 428,
        '&', 438,
        '(', 402,
        ')', 344,
        '*', 424,
        '+', 420,
        ',', 343,
        '-', 411,
        '.', 487,
        '/', 426,
        '<', 448,
        '=', 468,
        '>', 443,
        '?', 473,
        '[', 462,
        '\\', 48,
        '^', 435,
        'b', 611,
        'c', 590,
        'd', 607,
        'f', 603,
        'i', 604,
        'm', 576,
        'n', 624,
        'p', 621,
        's', 591,
        'u', 596,
        'v', 608,
        '{', 460,
        '|', 432,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(209);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 210:
      ADVANCE_MAP(
        '!', 270,
        '%', 428,
        '&', 438,
        '(', 402,
        ')', 344,
        '*', 424,
        '+', 420,
        ',', 343,
        '-', 411,
        '.', 487,
        '/', 426,
        '<', 448,
        '=', 468,
        '>', 443,
        '?', 473,
        '[', 462,
        '\\', 143,
        '^', 435,
        '|', 432,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(211);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 211:
      ADVANCE_MAP(
        '!', 270,
        '%', 428,
        '&', 438,
        '(', 402,
        ')', 344,
        '*', 424,
        '+', 420,
        ',', 343,
        '-', 411,
        '.', 487,
        '/', 426,
        '<', 448,
        '=', 468,
        '>', 443,
        '?', 473,
        '[', 462,
        '\\', 143,
        '^', 435,
        '|', 432,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(211);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 212:
      ADVANCE_MAP(
        '!', 270,
        '%', 428,
        '&', 438,
        '(', 402,
        ')', 344,
        '*', 424,
        '+', 420,
        ',', 343,
        '-', 411,
        '.', 487,
        '/', 426,
        '<', 448,
        '=', 468,
        '>', 443,
        '?', 473,
        '[', 465,
        '\\', 155,
        '^', 435,
        '|', 432,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(212);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 213:
      ADVANCE_MAP(
        '!', 270,
        '%', 428,
        '&', 438,
        '(', 402,
        ')', 344,
        '*', 424,
        '+', 420,
        ',', 343,
        '-', 412,
        '.', 487,
        '/', 426,
        ':', 472,
        '<', 448,
        '=', 468,
        '>', 638,
        '?', 473,
        '[', 462,
        '\\', 54,
        '^', 435,
        '{', 460,
        '|', 432,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(213);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 214:
      ADVANCE_MAP(
        '!', 270,
        '%', 428,
        '&', 438,
        '(', 402,
        '*', 424,
        '+', 420,
        ',', 343,
        '-', 412,
        '.', 487,
        '/', 426,
        ':', 471,
        '<', 448,
        '=', 468,
        '>', 638,
        '?', 473,
        '[', 462,
        '\\', 137,
        '^', 435,
        '{', 460,
        '|', 432,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(214);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 215:
      ADVANCE_MAP(
        '!', 270,
        '%', 428,
        '&', 438,
        '(', 402,
        '*', 424,
        '+', 420,
        ',', 343,
        '-', 412,
        '.', 487,
        '/', 426,
        ';', 456,
        '<', 448,
        '=', 468,
        '>', 443,
        '?', 473,
        '[', 464,
        '\\', 86,
        '^', 435,
        '|', 432,
        '}', 461,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(215);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 216:
      ADVANCE_MAP(
        '!', 270,
        '%', 428,
        '&', 438,
        '(', 402,
        '*', 424,
        '+', 420,
        ',', 343,
        '-', 412,
        '.', 487,
        '/', 426,
        '<', 448,
        '=', 468,
        '>', 638,
        '?', 473,
        '[', 463,
        '\\', 82,
        '^', 435,
        '|', 432,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(216);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 217:
      ADVANCE_MAP(
        '!', 270,
        '%', 428,
        '&', 438,
        '(', 402,
        '*', 424,
        '+', 420,
        ',', 343,
        '-', 412,
        '.', 487,
        '/', 426,
        '<', 448,
        '=', 468,
        '>', 638,
        '?', 473,
        '[', 462,
        '\\', 50,
        '^', 435,
        'b', 611,
        'c', 590,
        'd', 607,
        'f', 603,
        'i', 604,
        'm', 576,
        'n', 624,
        'p', 621,
        's', 591,
        'u', 596,
        'v', 608,
        '{', 460,
        '|', 432,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(217);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 218:
      ADVANCE_MAP(
        '!', 270,
        '%', 428,
        '&', 438,
        '(', 402,
        '*', 424,
        '+', 420,
        ',', 343,
        '-', 412,
        '.', 487,
        '/', 426,
        '<', 448,
        '=', 468,
        '>', 638,
        '?', 473,
        '[', 462,
        '\\', 141,
        '^', 435,
        '|', 432,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(219);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 219:
      ADVANCE_MAP(
        '!', 270,
        '%', 428,
        '&', 438,
        '(', 402,
        '*', 424,
        '+', 420,
        ',', 343,
        '-', 412,
        '.', 487,
        '/', 426,
        '<', 448,
        '=', 468,
        '>', 638,
        '?', 473,
        '[', 462,
        '\\', 141,
        '^', 435,
        '|', 432,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(219);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 220:
      ADVANCE_MAP(
        '!', 270,
        '%', 428,
        '&', 438,
        '(', 402,
        '*', 424,
        '+', 420,
        ',', 343,
        '-', 412,
        '.', 487,
        '/', 426,
        '<', 448,
        '=', 468,
        '>', 638,
        '?', 473,
        '[', 465,
        '\\', 153,
        '^', 435,
        '|', 432,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(220);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 221:
      ADVANCE_MAP(
        '!', 270,
        '%', 428,
        '&', 438,
        '*', 424,
        '+', 422,
        ',', 343,
        '-', 415,
        '.', 251,
        '/', 426,
        '<', 449,
        '=', 468,
        '>', 443,
        '\\', 90,
        '^', 435,
        '|', 432,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(221);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 222:
      ADVANCE_MAP(
        '!', 270,
        '%', 427,
        '&', 437,
        '(', 402,
        ')', 344,
        '*', 423,
        '+', 417,
        ',', 343,
        '-', 413,
        '.', 487,
        '/', 425,
        ':', 472,
        ';', 456,
        '<', 450,
        '=', 468,
        '>', 442,
        '?', 473,
        '[', 463,
        '\\', 36,
        ']', 466,
        '^', 434,
        '{', 460,
        '|', 433,
        '}', 461,
        '~', 405,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(222);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 223:
      ADVANCE_MAP(
        '!', 270,
        '%', 427,
        '&', 437,
        '(', 402,
        ')', 344,
        '*', 423,
        '+', 417,
        ',', 343,
        '-', 413,
        '.', 487,
        '/', 425,
        ':', 472,
        ';', 456,
        '<', 450,
        '=', 271,
        '>', 442,
        '?', 473,
        '[', 462,
        '\\', 58,
        ']', 466,
        '^', 434,
        'b', 611,
        'c', 590,
        'd', 607,
        'f', 603,
        'i', 604,
        'm', 576,
        'n', 624,
        'p', 621,
        's', 591,
        'u', 596,
        'v', 608,
        '{', 460,
        '|', 433,
        '}', 461,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(223);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 224:
      ADVANCE_MAP(
        '!', 270,
        '%', 427,
        '&', 437,
        '(', 402,
        ')', 344,
        '*', 423,
        '+', 417,
        ',', 343,
        '-', 413,
        '.', 487,
        '/', 425,
        ':', 268,
        ';', 456,
        '<', 450,
        '=', 271,
        '>', 442,
        '?', 473,
        '[', 462,
        '\\', 133,
        ']', 282,
        '^', 434,
        'b', 611,
        'c', 590,
        'd', 607,
        'f', 603,
        'i', 604,
        'm', 576,
        'n', 624,
        'p', 621,
        's', 591,
        'u', 596,
        'v', 608,
        '{', 460,
        '|', 433,
        '}', 461,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(224);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 225:
      ADVANCE_MAP(
        '!', 270,
        '%', 427,
        '&', 437,
        '(', 402,
        '*', 423,
        '+', 417,
        ',', 343,
        '-', 413,
        '.', 487,
        '/', 425,
        ':', 472,
        '<', 450,
        '=', 271,
        '>', 638,
        '?', 473,
        '[', 462,
        '\\', 149,
        '^', 434,
        '{', 460,
        '|', 433,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(225);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 226:
      ADVANCE_MAP(
        '!', 270,
        '%', 427,
        '&', 437,
        '(', 402,
        '*', 423,
        '+', 417,
        ',', 343,
        '-', 413,
        '.', 487,
        '/', 425,
        ':', 471,
        '<', 450,
        '=', 271,
        '>', 638,
        '?', 473,
        '[', 462,
        '\\', 70,
        '^', 434,
        '{', 460,
        '|', 433,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(226);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 227:
      ADVANCE_MAP(
        '!', 270,
        '%', 427,
        '&', 437,
        '(', 402,
        '*', 423,
        '+', 417,
        ',', 343,
        '-', 413,
        '.', 487,
        '/', 425,
        '<', 450,
        '=', 271,
        '>', 638,
        '?', 473,
        '[', 462,
        '\\', 127,
        '^', 434,
        'b', 611,
        'c', 590,
        'd', 607,
        'f', 603,
        'i', 604,
        'm', 576,
        'n', 624,
        'p', 621,
        's', 591,
        'u', 596,
        'v', 608,
        '{', 460,
        '|', 433,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(227);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 228:
      ADVANCE_MAP(
        '!', 270,
        '%', 427,
        '&', 437,
        '(', 402,
        '*', 423,
        '+', 417,
        ',', 343,
        '-', 413,
        '.', 487,
        '/', 425,
        '<', 450,
        '=', 271,
        '>', 638,
        '?', 473,
        '[', 462,
        '\\', 159,
        '^', 434,
        '|', 433,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(229);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 229:
      ADVANCE_MAP(
        '!', 270,
        '%', 427,
        '&', 437,
        '(', 402,
        '*', 423,
        '+', 417,
        ',', 343,
        '-', 413,
        '.', 487,
        '/', 425,
        '<', 450,
        '=', 271,
        '>', 638,
        '?', 473,
        '[', 462,
        '\\', 159,
        '^', 434,
        '|', 433,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(229);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 230:
      ADVANCE_MAP(
        '"', 522,
        '&', 437,
        '(', 402,
        '*', 423,
        '/', 252,
        ':', 268,
        'L', 541,
        'U', 545,
        '[', 463,
        '\\', 74,
        'b', 611,
        'c', 590,
        'd', 607,
        'f', 603,
        'i', 604,
        'm', 576,
        'n', 624,
        'p', 621,
        's', 591,
        'u', 548,
        'v', 608,
        '~', 405,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(230);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 231:
      ADVANCE_MAP(
        '"', 522,
        ')', 344,
        ',', 343,
        '/', 252,
        ':', 471,
        'L', 540,
        'R', 542,
        'U', 544,
        '\\', 105,
        'u', 547,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(231);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 232:
      if (lookahead == '"') ADVANCE(522);
      if (lookahead == '/') ADVANCE(252);
      if (lookahead == '<') ADVANCE(276);
      if (lookahead == 'L') ADVANCE(541);
      if (lookahead == 'U') ADVANCE(545);
      if (lookahead == '\\') ADVANCE(107);
      if (lookahead == 'u') ADVANCE(549);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(232);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 233:
      if (lookahead == '"') ADVANCE(522);
      if (lookahead == '/') ADVANCE(252);
      if (lookahead == '\\') ADVANCE(109);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(233);
      END_STATE();
    case 234:
      if (lookahead == '"') ADVANCE(648);
      END_STATE();
    case 235:
      ADVANCE_MAP(
        '#', 292,
        '&', 437,
        '(', 402,
        ')', 344,
        '*', 423,
        ',', 343,
        '-', 275,
        '.', 257,
        '/', 252,
        ':', 472,
        ';', 456,
        '<', 447,
        '=', 467,
        '>', 638,
        '[', 462,
        '\\', 62,
        '{', 460,
        '|', 306,
        '~', 405,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(235);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 236:
      ADVANCE_MAP(
        '#', 284,
        '&', 437,
        '(', 402,
        ')', 344,
        '*', 423,
        '+', 416,
        ',', 343,
        '-', 275,
        '.', 257,
        '/', 252,
        ':', 472,
        ';', 456,
        '<', 447,
        '=', 467,
        '>', 638,
        '[', 463,
        '\\', 20,
        'b', 611,
        'c', 590,
        'd', 607,
        'f', 603,
        'i', 604,
        'm', 576,
        'n', 624,
        'p', 621,
        's', 591,
        'u', 596,
        'v', 608,
        '{', 460,
        '|', 306,
        '~', 405,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(236);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 237:
      ADVANCE_MAP(
        '#', 286,
        '&', 437,
        '(', 402,
        '*', 423,
        ',', 343,
        '/', 252,
        ':', 268,
        ';', 456,
        '[', 463,
        '\\', 24,
        'b', 611,
        'c', 590,
        'd', 607,
        'f', 603,
        'i', 604,
        'm', 576,
        'n', 624,
        'p', 621,
        's', 591,
        'u', 596,
        'v', 608,
        '~', 405,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(237);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 238:
      ADVANCE_MAP(
        '&', 437,
        '(', 402,
        ')', 344,
        '*', 423,
        ',', 343,
        '-', 275,
        '.', 257,
        '/', 252,
        ':', 472,
        ';', 456,
        '<', 447,
        '=', 467,
        '>', 638,
        '[', 463,
        '\\', 64,
        ']', 466,
        '{', 460,
        '|', 306,
        '~', 405,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(238);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 239:
      ADVANCE_MAP(
        '&', 437,
        '(', 402,
        ')', 344,
        '*', 423,
        ',', 343,
        '-', 275,
        '.', 257,
        '/', 252,
        ':', 471,
        ';', 456,
        '<', 447,
        '=', 467,
        '>', 638,
        '[', 463,
        '\\', 78,
        ']', 466,
        '{', 460,
        '|', 306,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(239);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 240:
      ADVANCE_MAP(
        '&', 437,
        '(', 402,
        ')', 344,
        '*', 423,
        ',', 343,
        '-', 275,
        '/', 252,
        ':', 471,
        ';', 456,
        '<', 447,
        '=', 467,
        '>', 638,
        '[', 463,
        '\\', 76,
        'b', 611,
        'c', 590,
        'd', 607,
        'f', 603,
        'i', 604,
        'm', 576,
        'n', 624,
        'p', 621,
        's', 591,
        'u', 596,
        'v', 608,
        '{', 460,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(240);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 241:
      ADVANCE_MAP(
        '&', 437,
        '(', 402,
        ')', 344,
        '*', 423,
        ',', 343,
        '.', 257,
        '/', 252,
        ':', 471,
        ';', 456,
        '=', 467,
        '>', 638,
        '[', 462,
        '\\', 92,
        '{', 460,
        '|', 306,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(241);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 242:
      ADVANCE_MAP(
        '&', 437,
        '(', 402,
        ')', 344,
        '*', 423,
        ',', 343,
        '/', 252,
        ';', 456,
        '=', 467,
        '>', 638,
        '[', 462,
        '\\', 88,
        'b', 611,
        'c', 590,
        'd', 607,
        'f', 603,
        'i', 604,
        'm', 576,
        'n', 624,
        'p', 621,
        's', 591,
        'u', 596,
        'v', 608,
        '{', 460,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(242);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 243:
      ADVANCE_MAP(
        '&', 436,
        '*', 423,
        '.', 257,
        '/', 252,
        ':', 268,
        '=', 467,
        '\\', 101,
        ']', 466,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(243);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 244:
      if (lookahead == '\'') ADVANCE(513);
      if (lookahead == '/') ADVANCE(252);
      if (lookahead == '\\') ADVANCE(109);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(244);
      END_STATE();
    case 245:
      if (lookahead == '\'') ADVANCE(317);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(307);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(245);
      END_STATE();
    case 246:
      if (lookahead == '\'') ADVANCE(313);
      if (lookahead == '.') ADVANCE(502);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(307);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(246);
      END_STATE();
    case 247:
      ADVANCE_MAP(
        '(', 402,
        ')', 344,
        ',', 343,
        '/', 252,
        ':', 471,
        ';', 456,
        '<', 447,
        '=', 467,
        '>', 638,
        '[', 464,
        '\\', 103,
        ']', 466,
        '{', 460,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(247);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 248:
      ADVANCE_MAP(
        '(', 402,
        '/', 252,
        ':', 268,
        'F', 565,
        'T', 569,
        '[', 462,
        '\\', 94,
        'f', 575,
        't', 616,
        '{', 460,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(248);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 249:
      if (lookahead == '(') ADVANCE(402);
      if (lookahead == '/') ADVANCE(252);
      if (lookahead == '\\') SKIP(117);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(249);
      END_STATE();
    case 250:
      if (lookahead == ')') ADVANCE(646);
      END_STATE();
    case 251:
      if (lookahead == '*') ADVANCE(490);
      END_STATE();
    case 252:
      if (lookahead == '*') ADVANCE(255);
      if (lookahead == '/') ADVANCE(636);
      END_STATE();
    case 253:
      if (lookahead == '*') ADVANCE(645);
      END_STATE();
    case 254:
      if (lookahead == '*') ADVANCE(254);
      if (lookahead == '/') ADVANCE(629);
      if (lookahead != 0) ADVANCE(255);
      END_STATE();
    case 255:
      if (lookahead == '*') ADVANCE(254);
      if (lookahead != 0) ADVANCE(255);
      END_STATE();
    case 256:
      if (lookahead == '*') ADVANCE(254);
      if (lookahead != 0) ADVANCE(360);
      END_STATE();
    case 257:
      if (lookahead == '.') ADVANCE(259);
      END_STATE();
    case 258:
      if (lookahead == '.') ADVANCE(259);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(494);
      END_STATE();
    case 259:
      if (lookahead == '.') ADVANCE(342);
      END_STATE();
    case 260:
      if (lookahead == '.') ADVANCE(317);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(500);
      END_STATE();
    case 261:
      if (lookahead == '/') ADVANCE(367);
      if (lookahead == '\\') ADVANCE(362);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(261);
      if (lookahead != 0) ADVANCE(369);
      END_STATE();
    case 262:
      if (lookahead == '1') ADVANCE(266);
      END_STATE();
    case 263:
      if (lookahead == '2') ADVANCE(493);
      END_STATE();
    case 264:
      if (lookahead == '2') ADVANCE(267);
      if (lookahead == '6') ADVANCE(493);
      END_STATE();
    case 265:
      if (lookahead == '4') ADVANCE(493);
      END_STATE();
    case 266:
      if (lookahead == '6') ADVANCE(493);
      END_STATE();
    case 267:
      if (lookahead == '8') ADVANCE(493);
      END_STATE();
    case 268:
      if (lookahead == ':') ADVANCE(457);
      END_STATE();
    case 269:
      if (lookahead == '<') ADVANCE(452);
      if (lookahead == '=') ADVANCE(445);
      END_STATE();
    case 270:
      if (lookahead == '=') ADVANCE(440);
      END_STATE();
    case 271:
      if (lookahead == '=') ADVANCE(439);
      END_STATE();
    case 272:
      if (lookahead == '=') ADVANCE(444);
      if (lookahead == '>') ADVANCE(454);
      END_STATE();
    case 273:
      if (lookahead == '=') ADVANCE(480);
      END_STATE();
    case 274:
      if (lookahead == '>') ADVANCE(273);
      END_STATE();
    case 275:
      if (lookahead == '>') ADVANCE(491);
      END_STATE();
    case 276:
      if (lookahead == '>') ADVANCE(535);
      if (lookahead == '\\') ADVANCE(277);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(276);
      END_STATE();
    case 277:
      if (lookahead == '>') ADVANCE(536);
      if (lookahead == '\\') ADVANCE(277);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(276);
      END_STATE();
    case 278:
      if (lookahead == 'F') ADVANCE(262);
      END_STATE();
    case 279:
      if (lookahead == 'U') ADVANCE(332);
      if (lookahead == 'u') ADVANCE(324);
      END_STATE();
    case 280:
      if (lookahead == '[') ADVANCE(458);
      if (lookahead == ']') ADVANCE(647);
      END_STATE();
    case 281:
      if (lookahead == ']') ADVANCE(647);
      END_STATE();
    case 282:
      if (lookahead == ']') ADVANCE(459);
      END_STATE();
    case 283:
      if (lookahead == 'd') ADVANCE(376);
      if (lookahead == 'e') ADVANCE(396);
      if (lookahead == 'i') ADVANCE(384);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(283);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(401);
      END_STATE();
    case 284:
      if (lookahead == 'd') ADVANCE(376);
      if (lookahead == 'e') ADVANCE(396);
      if (lookahead == 'i') ADVANCE(385);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(284);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(401);
      END_STATE();
    case 285:
      if (lookahead == 'd') ADVANCE(376);
      if (lookahead == 'e') ADVANCE(398);
      if (lookahead == 'i') ADVANCE(384);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(285);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(401);
      END_STATE();
    case 286:
      if (lookahead == 'd') ADVANCE(376);
      if (lookahead == 'e') ADVANCE(398);
      if (lookahead == 'i') ADVANCE(385);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(286);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(401);
      END_STATE();
    case 287:
      if (lookahead == 'd') ADVANCE(376);
      if (lookahead == 'i') ADVANCE(384);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(287);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(401);
      END_STATE();
    case 288:
      if (lookahead == 'd') ADVANCE(376);
      if (lookahead == 'i') ADVANCE(385);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(288);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(401);
      END_STATE();
    case 289:
      if (lookahead == 'd') ADVANCE(301);
      END_STATE();
    case 290:
      if (lookahead == 'd') ADVANCE(295);
      END_STATE();
    case 291:
      if (lookahead == 'e') ADVANCE(305);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(291);
      END_STATE();
    case 292:
      if (lookahead == 'e') ADVANCE(304);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(292);
      END_STATE();
    case 293:
      if (lookahead == 'e') ADVANCE(351);
      END_STATE();
    case 294:
      if (lookahead == 'e') ADVANCE(299);
      END_STATE();
    case 295:
      if (lookahead == 'e') ADVANCE(300);
      END_STATE();
    case 296:
      if (lookahead == 'f') ADVANCE(262);
      END_STATE();
    case 297:
      if (lookahead == 'f') ADVANCE(347);
      END_STATE();
    case 298:
      if (lookahead == 'f') ADVANCE(353);
      END_STATE();
    case 299:
      if (lookahead == 'f') ADVANCE(355);
      END_STATE();
    case 300:
      if (lookahead == 'f') ADVANCE(357);
      END_STATE();
    case 301:
      if (lookahead == 'i') ADVANCE(297);
      END_STATE();
    case 302:
      if (lookahead == 'i') ADVANCE(298);
      if (lookahead == 's') ADVANCE(293);
      END_STATE();
    case 303:
      if (lookahead == 'i') ADVANCE(385);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(303);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(401);
      END_STATE();
    case 304:
      if (lookahead == 'l') ADVANCE(302);
      if (lookahead == 'n') ADVANCE(289);
      END_STATE();
    case 305:
      if (lookahead == 'n') ADVANCE(289);
      END_STATE();
    case 306:
      if (lookahead == '|') ADVANCE(429);
      END_STATE();
    case 307:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(314);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(499);
      END_STATE();
    case 308:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(307);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(245);
      END_STATE();
    case 309:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(497);
      END_STATE();
    case 310:
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(246);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(496);
      END_STATE();
    case 311:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(498);
      END_STATE();
    case 312:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(494);
      END_STATE();
    case 313:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(246);
      END_STATE();
    case 314:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(499);
      END_STATE();
    case 315:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(628);
      END_STATE();
    case 316:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(500);
      END_STATE();
    case 317:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(245);
      END_STATE();
    case 318:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(528);
      END_STATE();
    case 319:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(534);
      END_STATE();
    case 320:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(315);
      END_STATE();
    case 321:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(318);
      END_STATE();
    case 322:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(320);
      END_STATE();
    case 323:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(321);
      END_STATE();
    case 324:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(322);
      END_STATE();
    case 325:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(323);
      END_STATE();
    case 326:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(324);
      END_STATE();
    case 327:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(325);
      END_STATE();
    case 328:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(326);
      END_STATE();
    case 329:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(327);
      END_STATE();
    case 330:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(328);
      END_STATE();
    case 331:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(329);
      END_STATE();
    case 332:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(330);
      END_STATE();
    case 333:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(331);
      END_STATE();
    case 334:
      if (lookahead != 0 &&
          lookahead != '*') ADVANCE(369);
      END_STATE();
    case 335:
      if (eof) ADVANCE(337);
      ADVANCE_MAP(
        '!', 404,
        '"', 522,
        '#', 283,
        '%', 428,
        '&', 438,
        '\'', 513,
        '(', 402,
        ')', 344,
        '*', 424,
        '+', 418,
        ',', 343,
        '-', 407,
        '.', 488,
        '/', 426,
        '0', 495,
        ':', 472,
        ';', 456,
        '<', 448,
        '=', 468,
        '>', 638,
        '?', 473,
        'F', 565,
        'L', 539,
        'R', 542,
        'T', 569,
        'U', 543,
        '[', 464,
        '\\', 2,
        ']', 466,
        '^', 435,
        'b', 611,
        'c', 590,
        'd', 607,
        'f', 574,
        'i', 604,
        'm', 576,
        'n', 624,
        'p', 621,
        's', 591,
        't', 616,
        'u', 546,
        'v', 608,
        '{', 460,
        '|', 432,
        '}', 461,
        '~', 405,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(335);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 336:
      if (eof) ADVANCE(337);
      ADVANCE_MAP(
        '!', 403,
        '"', 522,
        '#', 287,
        '%', 427,
        '&', 437,
        '\'', 513,
        '(', 402,
        ')', 344,
        '*', 423,
        '+', 419,
        ',', 343,
        '-', 410,
        '.', 489,
        '/', 425,
        '0', 495,
        ':', 472,
        ';', 456,
        '<', 447,
        '=', 467,
        '>', 638,
        'F', 565,
        'L', 539,
        'R', 542,
        'T', 569,
        'U', 543,
        '[', 463,
        '\\', 4,
        ']', 466,
        '^', 434,
        'b', 611,
        'c', 590,
        'd', 607,
        'f', 574,
        'i', 604,
        'm', 576,
        'n', 624,
        'p', 621,
        's', 591,
        't', 616,
        'u', 546,
        'v', 608,
        '{', 460,
        '|', 306,
        '}', 461,
        '~', 405,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(336);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      if (set_contains(sym_identifier_character_set_1, 670, lookahead)) ADVANCE(628);
      END_STATE();
    case 337:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 338:
      ACCEPT_TOKEN(aux_sym_preproc_include_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(401);
      END_STATE();
    case 339:
      ACCEPT_TOKEN(aux_sym_preproc_include_token2);
      END_STATE();
    case 340:
      ACCEPT_TOKEN(aux_sym_preproc_def_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(401);
      END_STATE();
    case 341:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 342:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 343:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 344:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 345:
      ACCEPT_TOKEN(aux_sym_preproc_if_token1);
      if (lookahead == 'd') ADVANCE(380);
      if (lookahead == 'n') ADVANCE(374);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(401);
      END_STATE();
    case 346:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(346);
      END_STATE();
    case 347:
      ACCEPT_TOKEN(aux_sym_preproc_if_token2);
      END_STATE();
    case 348:
      ACCEPT_TOKEN(aux_sym_preproc_if_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(401);
      END_STATE();
    case 349:
      ACCEPT_TOKEN(aux_sym_preproc_ifdef_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(401);
      END_STATE();
    case 350:
      ACCEPT_TOKEN(aux_sym_preproc_ifdef_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(401);
      END_STATE();
    case 351:
      ACCEPT_TOKEN(aux_sym_preproc_else_token1);
      END_STATE();
    case 352:
      ACCEPT_TOKEN(aux_sym_preproc_else_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(401);
      END_STATE();
    case 353:
      ACCEPT_TOKEN(aux_sym_preproc_elif_token1);
      if (lookahead == 'd') ADVANCE(294);
      if (lookahead == 'n') ADVANCE(290);
      END_STATE();
    case 354:
      ACCEPT_TOKEN(aux_sym_preproc_elif_token1);
      if (lookahead == 'd') ADVANCE(382);
      if (lookahead == 'n') ADVANCE(375);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(401);
      END_STATE();
    case 355:
      ACCEPT_TOKEN(aux_sym_preproc_elifdef_token1);
      END_STATE();
    case 356:
      ACCEPT_TOKEN(aux_sym_preproc_elifdef_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(401);
      END_STATE();
    case 357:
      ACCEPT_TOKEN(aux_sym_preproc_elifdef_token2);
      END_STATE();
    case 358:
      ACCEPT_TOKEN(aux_sym_preproc_elifdef_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(401);
      END_STATE();
    case 359:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(255);
      if (lookahead == '*') ADVANCE(359);
      if (lookahead == '/') ADVANCE(629);
      if (lookahead == '\\') ADVANCE(365);
      if (lookahead != 0) ADVANCE(360);
      END_STATE();
    case 360:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(255);
      if (lookahead == '*') ADVANCE(359);
      if (lookahead == '/') ADVANCE(256);
      if (lookahead == '\\') ADVANCE(365);
      if (lookahead != 0) ADVANCE(360);
      END_STATE();
    case 361:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') ADVANCE(636);
      if (lookahead == '\r') ADVANCE(630);
      if (lookahead == '/') ADVANCE(633);
      if (lookahead == '\\') ADVANCE(632);
      if (lookahead != 0) ADVANCE(634);
      END_STATE();
    case 362:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') SKIP(261);
      if (lookahead == '\r') ADVANCE(363);
      if (lookahead == '/') ADVANCE(334);
      if (lookahead == '\\') ADVANCE(364);
      if (lookahead != 0) ADVANCE(369);
      END_STATE();
    case 363:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\n') SKIP(261);
      if (lookahead == '/') ADVANCE(334);
      if (lookahead == '\\') ADVANCE(364);
      if (lookahead != 0) ADVANCE(369);
      END_STATE();
    case 364:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\r') ADVANCE(370);
      if (lookahead == '/') ADVANCE(334);
      if (lookahead == '\\') ADVANCE(364);
      if (lookahead != 0) ADVANCE(369);
      END_STATE();
    case 365:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\r') ADVANCE(368);
      if (lookahead == '*') ADVANCE(359);
      if (lookahead == '/') ADVANCE(256);
      if (lookahead == '\\') ADVANCE(365);
      if (lookahead != 0) ADVANCE(360);
      END_STATE();
    case 366:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '\r') ADVANCE(635);
      if (lookahead == '/') ADVANCE(633);
      if (lookahead == '\\') ADVANCE(632);
      if (lookahead != 0) ADVANCE(634);
      END_STATE();
    case 367:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '*') ADVANCE(360);
      if (lookahead == '/') ADVANCE(633);
      if (lookahead == '\\') ADVANCE(364);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(369);
      END_STATE();
    case 368:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '*') ADVANCE(359);
      if (lookahead == '/') ADVANCE(256);
      if (lookahead == '\\') ADVANCE(365);
      if (lookahead != 0) ADVANCE(360);
      END_STATE();
    case 369:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(334);
      if (lookahead == '\\') ADVANCE(364);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(369);
      END_STATE();
    case 370:
      ACCEPT_TOKEN(sym_preproc_arg);
      if (lookahead == '/') ADVANCE(334);
      if (lookahead == '\\') ADVANCE(364);
      if (lookahead != 0) ADVANCE(369);
      END_STATE();
    case 371:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'c') ADVANCE(397);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(401);
      END_STATE();
    case 372:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(395);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(401);
      END_STATE();
    case 373:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(379);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(401);
      END_STATE();
    case 374:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(381);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(401);
      END_STATE();
    case 375:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'd') ADVANCE(383);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(401);
      END_STATE();
    case 376:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(386);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(401);
      END_STATE();
    case 377:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(352);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(401);
      END_STATE();
    case 378:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(340);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(401);
      END_STATE();
    case 379:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(338);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(401);
      END_STATE();
    case 380:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(389);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(401);
      END_STATE();
    case 381:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(390);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(401);
      END_STATE();
    case 382:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(391);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(401);
      END_STATE();
    case 383:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'e') ADVANCE(392);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(401);
      END_STATE();
    case 384:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(345);
      if (lookahead == 'n') ADVANCE(371);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(401);
      END_STATE();
    case 385:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(345);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(401);
      END_STATE();
    case 386:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(393);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(401);
      END_STATE();
    case 387:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(354);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(401);
      END_STATE();
    case 388:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(348);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(401);
      END_STATE();
    case 389:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(349);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(401);
      END_STATE();
    case 390:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(350);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(401);
      END_STATE();
    case 391:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(356);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(401);
      END_STATE();
    case 392:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'f') ADVANCE(358);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(401);
      END_STATE();
    case 393:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i') ADVANCE(399);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(401);
      END_STATE();
    case 394:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i') ADVANCE(387);
      if (lookahead == 's') ADVANCE(377);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(401);
      END_STATE();
    case 395:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'i') ADVANCE(388);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(401);
      END_STATE();
    case 396:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'l') ADVANCE(394);
      if (lookahead == 'n') ADVANCE(372);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(401);
      END_STATE();
    case 397:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'l') ADVANCE(400);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(401);
      END_STATE();
    case 398:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'n') ADVANCE(372);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(401);
      END_STATE();
    case 399:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'n') ADVANCE(378);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(401);
      END_STATE();
    case 400:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (lookahead == 'u') ADVANCE(373);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(401);
      END_STATE();
    case 401:
      ACCEPT_TOKEN(sym_preproc_directive);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(401);
      END_STATE();
    case 402:
      ACCEPT_TOKEN(anon_sym_LPAREN2);
      END_STATE();
    case 403:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 404:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(440);
      END_STATE();
    case 405:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 406:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 407:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(485);
      if (lookahead == '.') ADVANCE(312);
      if (lookahead == '0') ADVANCE(495);
      if (lookahead == '=') ADVANCE(478);
      if (lookahead == '>') ADVANCE(492);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      END_STATE();
    case 408:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(485);
      if (lookahead == '.') ADVANCE(312);
      if (lookahead == '0') ADVANCE(495);
      if (lookahead == '=') ADVANCE(478);
      if (lookahead == '>') ADVANCE(491);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      END_STATE();
    case 409:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(485);
      if (lookahead == '.') ADVANCE(312);
      if (lookahead == '0') ADVANCE(495);
      if (lookahead == '>') ADVANCE(491);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      END_STATE();
    case 410:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(485);
      if (lookahead == '.') ADVANCE(312);
      if (lookahead == '0') ADVANCE(495);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      END_STATE();
    case 411:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(485);
      if (lookahead == '=') ADVANCE(478);
      if (lookahead == '>') ADVANCE(492);
      END_STATE();
    case 412:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(485);
      if (lookahead == '=') ADVANCE(478);
      if (lookahead == '>') ADVANCE(491);
      END_STATE();
    case 413:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(485);
      if (lookahead == '>') ADVANCE(491);
      END_STATE();
    case 414:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '.') ADVANCE(312);
      if (lookahead == '0') ADVANCE(495);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      END_STATE();
    case 415:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(478);
      if (lookahead == '>') ADVANCE(253);
      END_STATE();
    case 416:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 417:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(486);
      END_STATE();
    case 418:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(486);
      if (lookahead == '.') ADVANCE(312);
      if (lookahead == '0') ADVANCE(495);
      if (lookahead == '=') ADVANCE(477);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      END_STATE();
    case 419:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(486);
      if (lookahead == '.') ADVANCE(312);
      if (lookahead == '0') ADVANCE(495);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      END_STATE();
    case 420:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(486);
      if (lookahead == '=') ADVANCE(477);
      END_STATE();
    case 421:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '.') ADVANCE(312);
      if (lookahead == '0') ADVANCE(495);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(498);
      END_STATE();
    case 422:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(477);
      END_STATE();
    case 423:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 424:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=') ADVANCE(474);
      END_STATE();
    case 425:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(255);
      if (lookahead == '/') ADVANCE(636);
      END_STATE();
    case 426:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(255);
      if (lookahead == '/') ADVANCE(636);
      if (lookahead == '=') ADVANCE(475);
      END_STATE();
    case 427:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 428:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(476);
      END_STATE();
    case 429:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 430:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 431:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 432:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(483);
      if (lookahead == '|') ADVANCE(429);
      END_STATE();
    case 433:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(429);
      END_STATE();
    case 434:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 435:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(482);
      END_STATE();
    case 436:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 437:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(430);
      END_STATE();
    case 438:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(430);
      if (lookahead == '=') ADVANCE(481);
      END_STATE();
    case 439:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 440:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 441:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 442:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(444);
      if (lookahead == '>') ADVANCE(454);
      END_STATE();
    case 443:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(444);
      if (lookahead == '>') ADVANCE(455);
      END_STATE();
    case 444:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 445:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 446:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      if (lookahead == '>') ADVANCE(484);
      END_STATE();
    case 447:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 448:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(453);
      if (lookahead == '=') ADVANCE(446);
      END_STATE();
    case 449:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(453);
      if (lookahead == '=') ADVANCE(445);
      END_STATE();
    case 450:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(452);
      if (lookahead == '=') ADVANCE(446);
      END_STATE();
    case 451:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(452);
      if (lookahead == '=') ADVANCE(445);
      END_STATE();
    case 452:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 453:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(479);
      END_STATE();
    case 454:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 455:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(480);
      END_STATE();
    case 456:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 457:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 458:
      ACCEPT_TOKEN(anon_sym_LBRACK_LBRACK);
      END_STATE();
    case 459:
      ACCEPT_TOKEN(anon_sym_RBRACK_RBRACK);
      END_STATE();
    case 460:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 461:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 462:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 463:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '[') ADVANCE(458);
      END_STATE();
    case 464:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '[') ADVANCE(458);
      if (lookahead == ']') ADVANCE(647);
      END_STATE();
    case 465:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == ']') ADVANCE(647);
      END_STATE();
    case 466:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 467:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 468:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(439);
      END_STATE();
    case 469:
      ACCEPT_TOKEN(sym_primitive_type);
      if (lookahead == '1') ADVANCE(564);
      if (lookahead == '3') ADVANCE(562);
      if (lookahead == '6') ADVANCE(563);
      if (lookahead == '8') ADVANCE(573);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'p') ADVANCE(622);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 470:
      ACCEPT_TOKEN(sym_primitive_type);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 471:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 472:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(457);
      END_STATE();
    case 473:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 474:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 475:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 476:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 477:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 478:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 479:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 480:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 481:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 482:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 483:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 484:
      ACCEPT_TOKEN(anon_sym_LT_EQ_GT);
      END_STATE();
    case 485:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 486:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 487:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '*') ADVANCE(490);
      if (lookahead == '.') ADVANCE(259);
      END_STATE();
    case 488:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '*') ADVANCE(490);
      if (lookahead == '.') ADVANCE(259);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(494);
      END_STATE();
    case 489:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(259);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(494);
      END_STATE();
    case 490:
      ACCEPT_TOKEN(anon_sym_DOT_STAR);
      END_STATE();
    case 491:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 492:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      if (lookahead == '*') ADVANCE(645);
      END_STATE();
    case 493:
      ACCEPT_TOKEN(sym_number_literal);
      END_STATE();
    case 494:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 312,
        'B', 278,
        'b', 296,
        'E', 307,
        'e', 307,
        'F', 501,
        'f', 501,
        'L', 493,
        'l', 493,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(494);
      END_STATE();
    case 495:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 310,
        '.', 502,
        'L', 503,
        'l', 506,
        'B', 309,
        'b', 309,
        'E', 307,
        'e', 307,
        'U', 505,
        'u', 505,
        'X', 260,
        'x', 260,
        'Z', 508,
        'z', 508,
        '8', 246,
        '9', 246,
      );
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(496);
      END_STATE();
    case 496:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 310,
        '.', 502,
        'L', 503,
        'l', 506,
        'E', 307,
        'e', 307,
        'U', 505,
        'u', 505,
        'Z', 508,
        'z', 508,
        '8', 246,
        '9', 246,
      );
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(496);
      END_STATE();
    case 497:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 309,
        'L', 503,
        'l', 506,
        'U', 505,
        'u', 505,
        'Z', 508,
        'z', 508,
        '0', 497,
        '1', 497,
      );
      END_STATE();
    case 498:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 311,
        '.', 502,
        'L', 503,
        'l', 506,
        'E', 307,
        'e', 307,
        'U', 505,
        'u', 505,
        'Z', 508,
        'z', 508,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(498);
      END_STATE();
    case 499:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '\'') ADVANCE(314);
      if (lookahead == 'B') ADVANCE(278);
      if (lookahead == 'b') ADVANCE(296);
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(501);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(493);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(499);
      END_STATE();
    case 500:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        '\'', 316,
        '.', 308,
        'L', 503,
        'l', 506,
        'P', 307,
        'p', 307,
        'U', 505,
        'u', 505,
        'Z', 508,
        'z', 508,
      );
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(500);
      END_STATE();
    case 501:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == '1') ADVANCE(264);
      if (lookahead == '3') ADVANCE(263);
      if (lookahead == '6') ADVANCE(265);
      END_STATE();
    case 502:
      ACCEPT_TOKEN(sym_number_literal);
      ADVANCE_MAP(
        'B', 278,
        'b', 296,
        'E', 307,
        'e', 307,
        'F', 501,
        'f', 501,
        'L', 493,
        'l', 493,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(494);
      END_STATE();
    case 503:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'L') ADVANCE(508);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(493);
      END_STATE();
    case 504:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'L') ADVANCE(493);
      END_STATE();
    case 505:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'L') ADVANCE(504);
      if (lookahead == 'l') ADVANCE(507);
      if (lookahead == 'Z' ||
          lookahead == 'z') ADVANCE(493);
      END_STATE();
    case 506:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'l') ADVANCE(508);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(493);
      END_STATE();
    case 507:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'l') ADVANCE(493);
      END_STATE();
    case 508:
      ACCEPT_TOKEN(sym_number_literal);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(493);
      END_STATE();
    case 509:
      ACCEPT_TOKEN(anon_sym_L_SQUOTE);
      END_STATE();
    case 510:
      ACCEPT_TOKEN(anon_sym_u_SQUOTE);
      END_STATE();
    case 511:
      ACCEPT_TOKEN(anon_sym_U_SQUOTE);
      END_STATE();
    case 512:
      ACCEPT_TOKEN(anon_sym_u8_SQUOTE);
      END_STATE();
    case 513:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 514:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      END_STATE();
    case 515:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      if (lookahead == '\n') ADVANCE(529);
      if (lookahead == '\r') ADVANCE(528);
      if (lookahead == 'U') ADVANCE(333);
      if (lookahead == 'u') ADVANCE(325);
      if (lookahead == 'x') ADVANCE(319);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(531);
      if (lookahead != 0) ADVANCE(528);
      END_STATE();
    case 516:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      if (lookahead == '*') ADVANCE(255);
      if (lookahead == '/') ADVANCE(636);
      END_STATE();
    case 517:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      if (lookahead == '\\') ADVANCE(109);
      END_STATE();
    case 518:
      ACCEPT_TOKEN(anon_sym_L_DQUOTE);
      END_STATE();
    case 519:
      ACCEPT_TOKEN(anon_sym_u_DQUOTE);
      END_STATE();
    case 520:
      ACCEPT_TOKEN(anon_sym_U_DQUOTE);
      END_STATE();
    case 521:
      ACCEPT_TOKEN(anon_sym_u8_DQUOTE);
      END_STATE();
    case 522:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 523:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '*') ADVANCE(525);
      if (lookahead == '/') ADVANCE(527);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(527);
      END_STATE();
    case 524:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '*') ADVANCE(524);
      if (lookahead == '/') ADVANCE(527);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(525);
      END_STATE();
    case 525:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '*') ADVANCE(524);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(525);
      END_STATE();
    case 526:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '/') ADVANCE(523);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(526);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(527);
      END_STATE();
    case 527:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(527);
      END_STATE();
    case 528:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 529:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(109);
      END_STATE();
    case 530:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(528);
      END_STATE();
    case 531:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(530);
      END_STATE();
    case 532:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(528);
      END_STATE();
    case 533:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(532);
      END_STATE();
    case 534:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(533);
      END_STATE();
    case 535:
      ACCEPT_TOKEN(sym_system_lib_string);
      END_STATE();
    case 536:
      ACCEPT_TOKEN(sym_system_lib_string);
      if (lookahead == '>') ADVANCE(535);
      if (lookahead == '\\') ADVANCE(277);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(276);
      END_STATE();
    case 537:
      ACCEPT_TOKEN(sym_true);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 538:
      ACCEPT_TOKEN(sym_false);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 539:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(518);
      if (lookahead == '\'') ADVANCE(509);
      if (lookahead == 'R') ADVANCE(550);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 540:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(518);
      if (lookahead == 'R') ADVANCE(550);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 541:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(518);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 542:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(640);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 543:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(520);
      if (lookahead == '\'') ADVANCE(511);
      if (lookahead == 'R') ADVANCE(551);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 544:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(520);
      if (lookahead == 'R') ADVANCE(551);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 545:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(520);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 546:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(519);
      if (lookahead == '\'') ADVANCE(510);
      if (lookahead == '8') ADVANCE(552);
      if (lookahead == 'R') ADVANCE(555);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'i') ADVANCE(606);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 547:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(519);
      if (lookahead == '8') ADVANCE(553);
      if (lookahead == 'R') ADVANCE(555);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 548:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(519);
      if (lookahead == '8') ADVANCE(554);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'i') ADVANCE(606);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 549:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(519);
      if (lookahead == '8') ADVANCE(554);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 550:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(641);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 551:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(643);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 552:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(521);
      if (lookahead == '\'') ADVANCE(512);
      if (lookahead == 'R') ADVANCE(556);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 553:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(521);
      if (lookahead == 'R') ADVANCE(556);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 554:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(521);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 555:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(642);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 556:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(644);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 557:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\'') ADVANCE(509);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 558:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\'') ADVANCE(511);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 559:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\'') ADVANCE(510);
      if (lookahead == '8') ADVANCE(560);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 560:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\'') ADVANCE(512);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 561:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '1') ADVANCE(564);
      if (lookahead == '3') ADVANCE(562);
      if (lookahead == '6') ADVANCE(563);
      if (lookahead == '8') ADVANCE(573);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'p') ADVANCE(622);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 562:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '2') ADVANCE(573);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 563:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '4') ADVANCE(573);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 564:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '6') ADVANCE(573);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 565:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'A') ADVANCE(568);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 566:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'E') ADVANCE(537);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 567:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'E') ADVANCE(538);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 568:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'L') ADVANCE(570);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 569:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'R') ADVANCE(571);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 570:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'S') ADVANCE(567);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 571:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'U') ADVANCE(566);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 572:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == '_') ADVANCE(579);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 573:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == '_') ADVANCE(619);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 574:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'a') ADVANCE(597);
      if (lookahead == 'l') ADVANCE(609);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 575:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'a') ADVANCE(597);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 576:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'a') ADVANCE(626);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 577:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'a') ADVANCE(613);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 578:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'a') ADVANCE(619);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 579:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'a') ADVANCE(601);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 580:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'b') ADVANCE(602);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 581:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'd') ADVANCE(470);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 582:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'd') ADVANCE(593);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 583:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'e') ADVANCE(537);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 584:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'e') ADVANCE(470);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 585:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'e') ADVANCE(538);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 586:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'e') ADVANCE(573);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 587:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'f') ADVANCE(573);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 588:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'f') ADVANCE(587);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 589:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'g') ADVANCE(605);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 590:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'h') ADVANCE(577);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 591:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'i') ADVANCE(627);
      if (lookahead == 's') ADVANCE(592);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 592:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'i') ADVANCE(627);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 593:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'i') ADVANCE(588);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 594:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'i') ADVANCE(589);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 595:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'i') ADVANCE(581);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 596:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'i') ADVANCE(606);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 597:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'l') ADVANCE(617);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 598:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'l') ADVANCE(470);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 599:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'l') ADVANCE(612);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 600:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'l') ADVANCE(599);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 601:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'l') ADVANCE(594);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 602:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'l') ADVANCE(584);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 603:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'l') ADVANCE(609);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 604:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'n') ADVANCE(618);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 605:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'n') ADVANCE(573);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 606:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'n') ADVANCE(620);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 607:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'o') ADVANCE(623);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 608:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'o') ADVANCE(595);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 609:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'o') ADVANCE(578);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 610:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'o') ADVANCE(598);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 611:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'o') ADVANCE(610);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 612:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'p') ADVANCE(622);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 613:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'r') ADVANCE(469);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 614:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'r') ADVANCE(582);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 615:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'r') ADVANCE(573);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 616:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'r') ADVANCE(625);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 617:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 's') ADVANCE(585);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 618:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 't') ADVANCE(469);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 619:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 't') ADVANCE(470);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 620:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 't') ADVANCE(561);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 621:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 't') ADVANCE(614);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 622:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 't') ADVANCE(615);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 623:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'u') ADVANCE(580);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 624:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'u') ADVANCE(600);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 625:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'u') ADVANCE(583);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 626:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'x') ADVANCE(572);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 627:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (lookahead == 'z') ADVANCE(586);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 628:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(279);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 629:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 630:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\n') ADVANCE(636);
      if (lookahead == '/') ADVANCE(633);
      if (lookahead == '\\') ADVANCE(366);
      if (lookahead != 0) ADVANCE(634);
      END_STATE();
    case 631:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\r') ADVANCE(637);
      if (lookahead == '\\') ADVANCE(631);
      if (lookahead != 0) ADVANCE(636);
      END_STATE();
    case 632:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\r') ADVANCE(635);
      if (lookahead == '/') ADVANCE(633);
      if (lookahead == '\\') ADVANCE(632);
      if (lookahead != 0) ADVANCE(634);
      END_STATE();
    case 633:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '*') ADVANCE(636);
      if (lookahead == '\\') ADVANCE(361);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(634);
      END_STATE();
    case 634:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '/') ADVANCE(633);
      if (lookahead == '\\') ADVANCE(366);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(634);
      END_STATE();
    case 635:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '/') ADVANCE(633);
      if (lookahead == '\\') ADVANCE(366);
      if (lookahead != 0) ADVANCE(634);
      END_STATE();
    case 636:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\\') ADVANCE(160);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(636);
      END_STATE();
    case 637:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\\') ADVANCE(160);
      if (lookahead != 0) ADVANCE(636);
      END_STATE();
    case 638:
      ACCEPT_TOKEN(anon_sym_GT2);
      END_STATE();
    case 639:
      ACCEPT_TOKEN(aux_sym_pure_virtual_clause_token1);
      END_STATE();
    case 640:
      ACCEPT_TOKEN(anon_sym_R_DQUOTE);
      END_STATE();
    case 641:
      ACCEPT_TOKEN(anon_sym_LR_DQUOTE);
      END_STATE();
    case 642:
      ACCEPT_TOKEN(anon_sym_uR_DQUOTE);
      END_STATE();
    case 643:
      ACCEPT_TOKEN(anon_sym_UR_DQUOTE);
      END_STATE();
    case 644:
      ACCEPT_TOKEN(anon_sym_u8R_DQUOTE);
      END_STATE();
    case 645:
      ACCEPT_TOKEN(anon_sym_DASH_GT_STAR);
      END_STATE();
    case 646:
      ACCEPT_TOKEN(anon_sym_LPAREN_RPAREN);
      END_STATE();
    case 647:
      ACCEPT_TOKEN(anon_sym_LBRACK_RBRACK);
      END_STATE();
    case 648:
      ACCEPT_TOKEN(anon_sym_DQUOTE_DQUOTE);
      END_STATE();
    case 649:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(518);
      if (lookahead == 'R') ADVANCE(653);
      if (lookahead == '\\') ADVANCE(279);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 650:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(640);
      if (lookahead == '\\') ADVANCE(279);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 651:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(520);
      if (lookahead == 'R') ADVANCE(654);
      if (lookahead == '\\') ADVANCE(279);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 652:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(519);
      if (lookahead == '8') ADVANCE(655);
      if (lookahead == 'R') ADVANCE(656);
      if (lookahead == '\\') ADVANCE(279);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 653:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(641);
      if (lookahead == '\\') ADVANCE(279);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 654:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(643);
      if (lookahead == '\\') ADVANCE(279);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 655:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(521);
      if (lookahead == 'R') ADVANCE(657);
      if (lookahead == '\\') ADVANCE(279);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 656:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(642);
      if (lookahead == '\\') ADVANCE(279);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 657:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '"') ADVANCE(644);
      if (lookahead == '\\') ADVANCE(279);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    case 658:
      ACCEPT_TOKEN(sym_literal_suffix);
      if (lookahead == '\\') ADVANCE(279);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(658);
      if (set_contains(sym_identifier_character_set_2, 778, lookahead)) ADVANCE(628);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'N') ADVANCE(1);
      if (lookahead == '\\') SKIP(2);
      if (lookahead == '_') ADVANCE(3);
      if (lookahead == 'a') ADVANCE(4);
      if (lookahead == 'b') ADVANCE(5);
      if (lookahead == 'c') ADVANCE(6);
      if (lookahead == 'd') ADVANCE(7);
      if (lookahead == 'e') ADVANCE(8);
      if (lookahead == 'f') ADVANCE(9);
      if (lookahead == 'g') ADVANCE(10);
      if (lookahead == 'i') ADVANCE(11);
      if (lookahead == 'l') ADVANCE(12);
      if (lookahead == 'm') ADVANCE(13);
      if (lookahead == 'n') ADVANCE(14);
      if (lookahead == 'o') ADVANCE(15);
      if (lookahead == 'p') ADVANCE(16);
      if (lookahead == 'r') ADVANCE(17);
      if (lookahead == 's') ADVANCE(18);
      if (lookahead == 't') ADVANCE(19);
      if (lookahead == 'u') ADVANCE(20);
      if (lookahead == 'v') ADVANCE(21);
      if (lookahead == 'w') ADVANCE(22);
      if (lookahead == 'x') ADVANCE(23);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(0);
      END_STATE();
    case 1:
      if (lookahead == 'U') ADVANCE(24);
      END_STATE();
    case 2:
      if (lookahead == '\n') SKIP(0);
      if (lookahead == '\r') SKIP(25);
      END_STATE();
    case 3:
      if (lookahead == 'A') ADVANCE(26);
      if (lookahead == 'G') ADVANCE(27);
      if (lookahead == 'N') ADVANCE(28);
      if (lookahead == '_') ADVANCE(29);
      if (lookahead == 'a') ADVANCE(30);
      if (lookahead == 'u') ADVANCE(31);
      END_STATE();
    case 4:
      if (lookahead == 'l') ADVANCE(32);
      if (lookahead == 'n') ADVANCE(33);
      if (lookahead == 's') ADVANCE(34);
      if (lookahead == 'u') ADVANCE(35);
      END_STATE();
    case 5:
      if (lookahead == 'i') ADVANCE(36);
      if (lookahead == 'r') ADVANCE(37);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(38);
      if (lookahead == 'l') ADVANCE(39);
      if (lookahead == 'o') ADVANCE(40);
      END_STATE();
    case 7:
      if (lookahead == 'e') ADVANCE(41);
      if (lookahead == 'o') ADVANCE(42);
      END_STATE();
    case 8:
      if (lookahead == 'l') ADVANCE(43);
      if (lookahead == 'n') ADVANCE(44);
      if (lookahead == 'x') ADVANCE(45);
      END_STATE();
    case 9:
      if (lookahead == 'i') ADVANCE(46);
      if (lookahead == 'o') ADVANCE(47);
      if (lookahead == 'r') ADVANCE(48);
      END_STATE();
    case 10:
      if (lookahead == 'o') ADVANCE(49);
      END_STATE();
    case 11:
      if (lookahead == 'f') ADVANCE(50);
      if (lookahead == 'n') ADVANCE(51);
      END_STATE();
    case 12:
      if (lookahead == 'o') ADVANCE(52);
      END_STATE();
    case 13:
      if (lookahead == 'u') ADVANCE(53);
      END_STATE();
    case 14:
      if (lookahead == 'a') ADVANCE(54);
      if (lookahead == 'e') ADVANCE(55);
      if (lookahead == 'o') ADVANCE(56);
      if (lookahead == 'u') ADVANCE(57);
      END_STATE();
    case 15:
      if (lookahead == 'f') ADVANCE(58);
      if (lookahead == 'p') ADVANCE(59);
      if (lookahead == 'r') ADVANCE(60);
      if (lookahead == 'v') ADVANCE(61);
      END_STATE();
    case 16:
      if (lookahead == 'r') ADVANCE(62);
      if (lookahead == 'u') ADVANCE(63);
      END_STATE();
    case 17:
      if (lookahead == 'e') ADVANCE(64);
      END_STATE();
    case 18:
      if (lookahead == 'h') ADVANCE(65);
      if (lookahead == 'i') ADVANCE(66);
      if (lookahead == 't') ADVANCE(67);
      if (lookahead == 'w') ADVANCE(68);
      END_STATE();
    case 19:
      if (lookahead == 'e') ADVANCE(69);
      if (lookahead == 'h') ADVANCE(70);
      if (lookahead == 'r') ADVANCE(71);
      if (lookahead == 'y') ADVANCE(72);
      END_STATE();
    case 20:
      if (lookahead == 'n') ADVANCE(73);
      if (lookahead == 's') ADVANCE(74);
      END_STATE();
    case 21:
      if (lookahead == 'i') ADVANCE(75);
      if (lookahead == 'o') ADVANCE(76);
      END_STATE();
    case 22:
      if (lookahead == 'h') ADVANCE(77);
      END_STATE();
    case 23:
      if (lookahead == 'o') ADVANCE(78);
      END_STATE();
    case 24:
      if (lookahead == 'L') ADVANCE(79);
      END_STATE();
    case 25:
      if (lookahead == '\n') SKIP(0);
      END_STATE();
    case 26:
      if (lookahead == 'l') ADVANCE(80);
      if (lookahead == 't') ADVANCE(81);
      END_STATE();
    case 27:
      if (lookahead == 'e') ADVANCE(82);
      END_STATE();
    case 28:
      if (lookahead == 'o') ADVANCE(83);
      END_STATE();
    case 29:
      ADVANCE_MAP(
        'a', 84,
        'b', 85,
        'c', 86,
        'd', 87,
        'e', 88,
        'f', 89,
        'i', 90,
        'l', 91,
        'r', 92,
        's', 93,
        't', 94,
        'u', 95,
        'v', 96,
      );
      END_STATE();
    case 30:
      if (lookahead == 'l') ADVANCE(97);
      END_STATE();
    case 31:
      if (lookahead == 'n') ADVANCE(98);
      END_STATE();
    case 32:
      if (lookahead == 'i') ADVANCE(99);
      END_STATE();
    case 33:
      if (lookahead == 'd') ADVANCE(100);
      END_STATE();
    case 34:
      if (lookahead == 'm') ADVANCE(101);
      END_STATE();
    case 35:
      if (lookahead == 't') ADVANCE(102);
      END_STATE();
    case 36:
      if (lookahead == 't') ADVANCE(103);
      END_STATE();
    case 37:
      if (lookahead == 'e') ADVANCE(104);
      END_STATE();
    case 38:
      if (lookahead == 's') ADVANCE(105);
      if (lookahead == 't') ADVANCE(106);
      END_STATE();
    case 39:
      if (lookahead == 'a') ADVANCE(107);
      END_STATE();
    case 40:
      if (lookahead == '_') ADVANCE(108);
      if (lookahead == 'm') ADVANCE(109);
      if (lookahead == 'n') ADVANCE(110);
      END_STATE();
    case 41:
      if (lookahead == 'c') ADVANCE(111);
      if (lookahead == 'f') ADVANCE(112);
      if (lookahead == 'l') ADVANCE(113);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 43:
      if (lookahead == 's') ADVANCE(114);
      END_STATE();
    case 44:
      if (lookahead == 'u') ADVANCE(115);
      END_STATE();
    case 45:
      if (lookahead == 'p') ADVANCE(116);
      if (lookahead == 't') ADVANCE(117);
      END_STATE();
    case 46:
      if (lookahead == 'n') ADVANCE(118);
      END_STATE();
    case 47:
      if (lookahead == 'r') ADVANCE(119);
      END_STATE();
    case 48:
      if (lookahead == 'i') ADVANCE(120);
      END_STATE();
    case 49:
      if (lookahead == 't') ADVANCE(121);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 51:
      if (lookahead == 'l') ADVANCE(122);
      END_STATE();
    case 52:
      if (lookahead == 'n') ADVANCE(123);
      END_STATE();
    case 53:
      if (lookahead == 't') ADVANCE(124);
      END_STATE();
    case 54:
      if (lookahead == 'm') ADVANCE(125);
      END_STATE();
    case 55:
      if (lookahead == 'w') ADVANCE(126);
      END_STATE();
    case 56:
      if (lookahead == 'e') ADVANCE(127);
      if (lookahead == 'r') ADVANCE(128);
      if (lookahead == 't') ADVANCE(129);
      END_STATE();
    case 57:
      if (lookahead == 'l') ADVANCE(130);
      END_STATE();
    case 58:
      if (lookahead == 'f') ADVANCE(131);
      END_STATE();
    case 59:
      if (lookahead == 'e') ADVANCE(132);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_or);
      if (lookahead == '_') ADVANCE(133);
      END_STATE();
    case 61:
      if (lookahead == 'e') ADVANCE(134);
      END_STATE();
    case 62:
      if (lookahead == 'i') ADVANCE(135);
      if (lookahead == 'o') ADVANCE(136);
      END_STATE();
    case 63:
      if (lookahead == 'b') ADVANCE(137);
      END_STATE();
    case 64:
      if (lookahead == 'g') ADVANCE(138);
      if (lookahead == 'q') ADVANCE(139);
      if (lookahead == 's') ADVANCE(140);
      if (lookahead == 't') ADVANCE(141);
      END_STATE();
    case 65:
      if (lookahead == 'o') ADVANCE(142);
      END_STATE();
    case 66:
      if (lookahead == 'g') ADVANCE(143);
      if (lookahead == 'z') ADVANCE(144);
      END_STATE();
    case 67:
      if (lookahead == 'a') ADVANCE(145);
      if (lookahead == 'r') ADVANCE(146);
      END_STATE();
    case 68:
      if (lookahead == 'i') ADVANCE(147);
      END_STATE();
    case 69:
      if (lookahead == 'm') ADVANCE(148);
      END_STATE();
    case 70:
      if (lookahead == 'i') ADVANCE(149);
      if (lookahead == 'r') ADVANCE(150);
      END_STATE();
    case 71:
      if (lookahead == 'y') ADVANCE(151);
      END_STATE();
    case 72:
      if (lookahead == 'p') ADVANCE(152);
      END_STATE();
    case 73:
      if (lookahead == 'i') ADVANCE(153);
      if (lookahead == 's') ADVANCE(154);
      END_STATE();
    case 74:
      if (lookahead == 'i') ADVANCE(155);
      END_STATE();
    case 75:
      if (lookahead == 'r') ADVANCE(156);
      END_STATE();
    case 76:
      if (lookahead == 'l') ADVANCE(157);
      END_STATE();
    case 77:
      if (lookahead == 'i') ADVANCE(158);
      END_STATE();
    case 78:
      if (lookahead == 'r') ADVANCE(159);
      END_STATE();
    case 79:
      if (lookahead == 'L') ADVANCE(160);
      END_STATE();
    case 80:
      if (lookahead == 'i') ADVANCE(161);
      END_STATE();
    case 81:
      if (lookahead == 'o') ADVANCE(162);
      END_STATE();
    case 82:
      if (lookahead == 'n') ADVANCE(163);
      END_STATE();
    case 83:
      if (lookahead == 'n') ADVANCE(164);
      if (lookahead == 'r') ADVANCE(165);
      END_STATE();
    case 84:
      if (lookahead == 'l') ADVANCE(166);
      if (lookahead == 's') ADVANCE(167);
      if (lookahead == 't') ADVANCE(168);
      END_STATE();
    case 85:
      if (lookahead == 'a') ADVANCE(169);
      END_STATE();
    case 86:
      if (lookahead == 'd') ADVANCE(170);
      if (lookahead == 'l') ADVANCE(171);
      END_STATE();
    case 87:
      if (lookahead == 'e') ADVANCE(172);
      END_STATE();
    case 88:
      if (lookahead == 'x') ADVANCE(173);
      END_STATE();
    case 89:
      if (lookahead == 'a') ADVANCE(174);
      if (lookahead == 'i') ADVANCE(175);
      if (lookahead == 'o') ADVANCE(176);
      END_STATE();
    case 90:
      if (lookahead == 'n') ADVANCE(177);
      END_STATE();
    case 91:
      if (lookahead == 'e') ADVANCE(178);
      END_STATE();
    case 92:
      if (lookahead == 'e') ADVANCE(179);
      END_STATE();
    case 93:
      if (lookahead == 'p') ADVANCE(180);
      if (lookahead == 't') ADVANCE(181);
      END_STATE();
    case 94:
      if (lookahead == 'h') ADVANCE(182);
      if (lookahead == 'r') ADVANCE(183);
      END_STATE();
    case 95:
      if (lookahead == 'n') ADVANCE(184);
      if (lookahead == 'p') ADVANCE(185);
      END_STATE();
    case 96:
      if (lookahead == 'e') ADVANCE(186);
      if (lookahead == 'o') ADVANCE(187);
      END_STATE();
    case 97:
      if (lookahead == 'i') ADVANCE(188);
      END_STATE();
    case 98:
      if (lookahead == 'a') ADVANCE(189);
      END_STATE();
    case 99:
      if (lookahead == 'g') ADVANCE(190);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_and);
      if (lookahead == '_') ADVANCE(191);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_asm);
      END_STATE();
    case 102:
      if (lookahead == 'o') ADVANCE(192);
      END_STATE();
    case 103:
      if (lookahead == 'a') ADVANCE(193);
      if (lookahead == 'o') ADVANCE(194);
      END_STATE();
    case 104:
      if (lookahead == 'a') ADVANCE(195);
      END_STATE();
    case 105:
      if (lookahead == 'e') ADVANCE(196);
      END_STATE();
    case 106:
      if (lookahead == 'c') ADVANCE(197);
      END_STATE();
    case 107:
      if (lookahead == 's') ADVANCE(198);
      END_STATE();
    case 108:
      if (lookahead == 'a') ADVANCE(199);
      if (lookahead == 'r') ADVANCE(200);
      if (lookahead == 'y') ADVANCE(201);
      END_STATE();
    case 109:
      if (lookahead == 'p') ADVANCE(202);
      END_STATE();
    case 110:
      if (lookahead == 'c') ADVANCE(203);
      if (lookahead == 's') ADVANCE(204);
      if (lookahead == 't') ADVANCE(205);
      END_STATE();
    case 111:
      if (lookahead == 'l') ADVANCE(206);
      END_STATE();
    case 112:
      if (lookahead == 'a') ADVANCE(207);
      if (lookahead == 'i') ADVANCE(208);
      END_STATE();
    case 113:
      if (lookahead == 'e') ADVANCE(209);
      END_STATE();
    case 114:
      if (lookahead == 'e') ADVANCE(210);
      END_STATE();
    case 115:
      if (lookahead == 'm') ADVANCE(211);
      END_STATE();
    case 116:
      if (lookahead == 'l') ADVANCE(212);
      END_STATE();
    case 117:
      if (lookahead == 'e') ADVANCE(213);
      END_STATE();
    case 118:
      if (lookahead == 'a') ADVANCE(214);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 120:
      if (lookahead == 'e') ADVANCE(215);
      END_STATE();
    case 121:
      if (lookahead == 'o') ADVANCE(216);
      END_STATE();
    case 122:
      if (lookahead == 'i') ADVANCE(217);
      END_STATE();
    case 123:
      if (lookahead == 'g') ADVANCE(218);
      END_STATE();
    case 124:
      if (lookahead == 'a') ADVANCE(219);
      END_STATE();
    case 125:
      if (lookahead == 'e') ADVANCE(220);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 127:
      if (lookahead == 'x') ADVANCE(221);
      END_STATE();
    case 128:
      if (lookahead == 'e') ADVANCE(222);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_not);
      if (lookahead == '_') ADVANCE(223);
      END_STATE();
    case 130:
      if (lookahead == 'l') ADVANCE(224);
      END_STATE();
    case 131:
      if (lookahead == 's') ADVANCE(225);
      END_STATE();
    case 132:
      if (lookahead == 'r') ADVANCE(226);
      END_STATE();
    case 133:
      if (lookahead == 'e') ADVANCE(227);
      END_STATE();
    case 134:
      if (lookahead == 'r') ADVANCE(228);
      END_STATE();
    case 135:
      if (lookahead == 'v') ADVANCE(229);
      END_STATE();
    case 136:
      if (lookahead == 't') ADVANCE(230);
      END_STATE();
    case 137:
      if (lookahead == 'l') ADVANCE(231);
      END_STATE();
    case 138:
      if (lookahead == 'i') ADVANCE(232);
      END_STATE();
    case 139:
      if (lookahead == 'u') ADVANCE(233);
      END_STATE();
    case 140:
      if (lookahead == 't') ADVANCE(234);
      END_STATE();
    case 141:
      if (lookahead == 'u') ADVANCE(235);
      END_STATE();
    case 142:
      if (lookahead == 'r') ADVANCE(236);
      END_STATE();
    case 143:
      if (lookahead == 'n') ADVANCE(237);
      END_STATE();
    case 144:
      if (lookahead == 'e') ADVANCE(238);
      END_STATE();
    case 145:
      if (lookahead == 't') ADVANCE(239);
      END_STATE();
    case 146:
      if (lookahead == 'u') ADVANCE(240);
      END_STATE();
    case 147:
      if (lookahead == 't') ADVANCE(241);
      END_STATE();
    case 148:
      if (lookahead == 'p') ADVANCE(242);
      END_STATE();
    case 149:
      if (lookahead == 's') ADVANCE(243);
      END_STATE();
    case 150:
      if (lookahead == 'e') ADVANCE(244);
      if (lookahead == 'o') ADVANCE(245);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 152:
      if (lookahead == 'e') ADVANCE(246);
      END_STATE();
    case 153:
      if (lookahead == 'o') ADVANCE(247);
      END_STATE();
    case 154:
      if (lookahead == 'i') ADVANCE(248);
      END_STATE();
    case 155:
      if (lookahead == 'n') ADVANCE(249);
      END_STATE();
    case 156:
      if (lookahead == 't') ADVANCE(250);
      END_STATE();
    case 157:
      if (lookahead == 'a') ADVANCE(251);
      END_STATE();
    case 158:
      if (lookahead == 'l') ADVANCE(252);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_xor);
      if (lookahead == '_') ADVANCE(253);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_NULL);
      END_STATE();
    case 161:
      if (lookahead == 'g') ADVANCE(254);
      END_STATE();
    case 162:
      if (lookahead == 'm') ADVANCE(255);
      END_STATE();
    case 163:
      if (lookahead == 'e') ADVANCE(256);
      END_STATE();
    case 164:
      if (lookahead == 'n') ADVANCE(257);
      END_STATE();
    case 165:
      if (lookahead == 'e') ADVANCE(258);
      END_STATE();
    case 166:
      if (lookahead == 'i') ADVANCE(259);
      END_STATE();
    case 167:
      if (lookahead == 'm') ADVANCE(260);
      END_STATE();
    case 168:
      if (lookahead == 't') ADVANCE(261);
      END_STATE();
    case 169:
      if (lookahead == 's') ADVANCE(262);
      END_STATE();
    case 170:
      if (lookahead == 'e') ADVANCE(263);
      END_STATE();
    case 171:
      if (lookahead == 'r') ADVANCE(264);
      END_STATE();
    case 172:
      if (lookahead == 'c') ADVANCE(265);
      END_STATE();
    case 173:
      if (lookahead == 'c') ADVANCE(266);
      if (lookahead == 't') ADVANCE(267);
      END_STATE();
    case 174:
      if (lookahead == 's') ADVANCE(268);
      END_STATE();
    case 175:
      if (lookahead == 'n') ADVANCE(269);
      END_STATE();
    case 176:
      if (lookahead == 'r') ADVANCE(270);
      END_STATE();
    case 177:
      if (lookahead == 'l') ADVANCE(271);
      END_STATE();
    case 178:
      if (lookahead == 'a') ADVANCE(272);
      END_STATE();
    case 179:
      if (lookahead == 's') ADVANCE(273);
      END_STATE();
    case 180:
      if (lookahead == 't') ADVANCE(274);
      END_STATE();
    case 181:
      if (lookahead == 'd') ADVANCE(275);
      END_STATE();
    case 182:
      if (lookahead == 'i') ADVANCE(276);
      if (lookahead == 'r') ADVANCE(277);
      END_STATE();
    case 183:
      if (lookahead == 'y') ADVANCE(278);
      END_STATE();
    case 184:
      if (lookahead == 'a') ADVANCE(279);
      END_STATE();
    case 185:
      if (lookahead == 't') ADVANCE(280);
      END_STATE();
    case 186:
      if (lookahead == 'c') ADVANCE(281);
      END_STATE();
    case 187:
      if (lookahead == 'l') ADVANCE(282);
      END_STATE();
    case 188:
      if (lookahead == 'g') ADVANCE(283);
      END_STATE();
    case 189:
      if (lookahead == 'l') ADVANCE(284);
      END_STATE();
    case 190:
      if (lookahead == 'n') ADVANCE(285);
      END_STATE();
    case 191:
      if (lookahead == 'e') ADVANCE(286);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(sym_auto);
      END_STATE();
    case 193:
      if (lookahead == 'n') ADVANCE(287);
      END_STATE();
    case 194:
      if (lookahead == 'r') ADVANCE(288);
      END_STATE();
    case 195:
      if (lookahead == 'k') ADVANCE(289);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 197:
      if (lookahead == 'h') ADVANCE(290);
      END_STATE();
    case 198:
      if (lookahead == 's') ADVANCE(291);
      END_STATE();
    case 199:
      if (lookahead == 'w') ADVANCE(292);
      END_STATE();
    case 200:
      if (lookahead == 'e') ADVANCE(293);
      END_STATE();
    case 201:
      if (lookahead == 'i') ADVANCE(294);
      END_STATE();
    case 202:
      if (lookahead == 'l') ADVANCE(295);
      END_STATE();
    case 203:
      if (lookahead == 'e') ADVANCE(296);
      END_STATE();
    case 204:
      if (lookahead == 't') ADVANCE(297);
      END_STATE();
    case 205:
      if (lookahead == 'i') ADVANCE(298);
      END_STATE();
    case 206:
      if (lookahead == 't') ADVANCE(299);
      END_STATE();
    case 207:
      if (lookahead == 'u') ADVANCE(300);
      END_STATE();
    case 208:
      if (lookahead == 'n') ADVANCE(301);
      END_STATE();
    case 209:
      if (lookahead == 't') ADVANCE(302);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 212:
      if (lookahead == 'i') ADVANCE(303);
      END_STATE();
    case 213:
      if (lookahead == 'r') ADVANCE(304);
      END_STATE();
    case 214:
      if (lookahead == 'l') ADVANCE(305);
      END_STATE();
    case 215:
      if (lookahead == 'n') ADVANCE(306);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(anon_sym_goto);
      END_STATE();
    case 217:
      if (lookahead == 'n') ADVANCE(307);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(anon_sym_long);
      END_STATE();
    case 219:
      if (lookahead == 'b') ADVANCE(308);
      END_STATE();
    case 220:
      if (lookahead == 's') ADVANCE(309);
      END_STATE();
    case 221:
      if (lookahead == 'c') ADVANCE(310);
      END_STATE();
    case 222:
      if (lookahead == 't') ADVANCE(311);
      END_STATE();
    case 223:
      if (lookahead == 'e') ADVANCE(312);
      END_STATE();
    case 224:
      if (lookahead == 'p') ADVANCE(313);
      END_STATE();
    case 225:
      if (lookahead == 'e') ADVANCE(314);
      END_STATE();
    case 226:
      if (lookahead == 'a') ADVANCE(315);
      END_STATE();
    case 227:
      if (lookahead == 'q') ADVANCE(316);
      END_STATE();
    case 228:
      if (lookahead == 'r') ADVANCE(317);
      END_STATE();
    case 229:
      if (lookahead == 'a') ADVANCE(318);
      END_STATE();
    case 230:
      if (lookahead == 'e') ADVANCE(319);
      END_STATE();
    case 231:
      if (lookahead == 'i') ADVANCE(320);
      END_STATE();
    case 232:
      if (lookahead == 's') ADVANCE(321);
      END_STATE();
    case 233:
      if (lookahead == 'i') ADVANCE(322);
      END_STATE();
    case 234:
      if (lookahead == 'r') ADVANCE(323);
      END_STATE();
    case 235:
      if (lookahead == 'r') ADVANCE(324);
      END_STATE();
    case 236:
      if (lookahead == 't') ADVANCE(325);
      END_STATE();
    case 237:
      if (lookahead == 'e') ADVANCE(326);
      END_STATE();
    case 238:
      if (lookahead == 'o') ADVANCE(327);
      END_STATE();
    case 239:
      if (lookahead == 'i') ADVANCE(328);
      END_STATE();
    case 240:
      if (lookahead == 'c') ADVANCE(329);
      END_STATE();
    case 241:
      if (lookahead == 'c') ADVANCE(330);
      END_STATE();
    case 242:
      if (lookahead == 'l') ADVANCE(331);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(sym_this);
      END_STATE();
    case 244:
      if (lookahead == 'a') ADVANCE(332);
      END_STATE();
    case 245:
      if (lookahead == 'w') ADVANCE(333);
      END_STATE();
    case 246:
      if (lookahead == 'd') ADVANCE(334);
      if (lookahead == 'n') ADVANCE(335);
      END_STATE();
    case 247:
      if (lookahead == 'n') ADVANCE(336);
      END_STATE();
    case 248:
      if (lookahead == 'g') ADVANCE(337);
      END_STATE();
    case 249:
      if (lookahead == 'g') ADVANCE(338);
      END_STATE();
    case 250:
      if (lookahead == 'u') ADVANCE(339);
      END_STATE();
    case 251:
      if (lookahead == 't') ADVANCE(340);
      END_STATE();
    case 252:
      if (lookahead == 'e') ADVANCE(341);
      END_STATE();
    case 253:
      if (lookahead == 'e') ADVANCE(342);
      END_STATE();
    case 254:
      if (lookahead == 'n') ADVANCE(343);
      END_STATE();
    case 255:
      if (lookahead == 'i') ADVANCE(344);
      END_STATE();
    case 256:
      if (lookahead == 'r') ADVANCE(345);
      END_STATE();
    case 257:
      if (lookahead == 'u') ADVANCE(346);
      END_STATE();
    case 258:
      if (lookahead == 't') ADVANCE(347);
      END_STATE();
    case 259:
      if (lookahead == 'g') ADVANCE(348);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(anon_sym___asm);
      if (lookahead == '_') ADVANCE(349);
      END_STATE();
    case 261:
      if (lookahead == 'r') ADVANCE(350);
      END_STATE();
    case 262:
      if (lookahead == 'e') ADVANCE(351);
      END_STATE();
    case 263:
      if (lookahead == 'c') ADVANCE(352);
      END_STATE();
    case 264:
      if (lookahead == 'c') ADVANCE(353);
      END_STATE();
    case 265:
      if (lookahead == 'l') ADVANCE(354);
      END_STATE();
    case 266:
      if (lookahead == 'e') ADVANCE(355);
      END_STATE();
    case 267:
      if (lookahead == 'e') ADVANCE(356);
      END_STATE();
    case 268:
      if (lookahead == 't') ADVANCE(357);
      END_STATE();
    case 269:
      if (lookahead == 'a') ADVANCE(358);
      END_STATE();
    case 270:
      if (lookahead == 'c') ADVANCE(359);
      END_STATE();
    case 271:
      if (lookahead == 'i') ADVANCE(360);
      END_STATE();
    case 272:
      if (lookahead == 'v') ADVANCE(361);
      END_STATE();
    case 273:
      if (lookahead == 't') ADVANCE(362);
      END_STATE();
    case 274:
      if (lookahead == 'r') ADVANCE(363);
      END_STATE();
    case 275:
      if (lookahead == 'c') ADVANCE(364);
      END_STATE();
    case 276:
      if (lookahead == 's') ADVANCE(365);
      END_STATE();
    case 277:
      if (lookahead == 'e') ADVANCE(366);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(anon_sym___try);
      END_STATE();
    case 279:
      if (lookahead == 'l') ADVANCE(367);
      END_STATE();
    case 280:
      if (lookahead == 'r') ADVANCE(368);
      END_STATE();
    case 281:
      if (lookahead == 't') ADVANCE(369);
      END_STATE();
    case 282:
      if (lookahead == 'a') ADVANCE(370);
      END_STATE();
    case 283:
      if (lookahead == 'n') ADVANCE(371);
      END_STATE();
    case 284:
      if (lookahead == 'i') ADVANCE(372);
      END_STATE();
    case 285:
      if (lookahead == 'a') ADVANCE(373);
      if (lookahead == 'o') ADVANCE(374);
      END_STATE();
    case 286:
      if (lookahead == 'q') ADVANCE(375);
      END_STATE();
    case 287:
      if (lookahead == 'd') ADVANCE(376);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(anon_sym_bitor);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 292:
      if (lookahead == 'a') ADVANCE(377);
      END_STATE();
    case 293:
      if (lookahead == 't') ADVANCE(378);
      END_STATE();
    case 294:
      if (lookahead == 'e') ADVANCE(379);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(anon_sym_compl);
      END_STATE();
    case 296:
      if (lookahead == 'p') ADVANCE(380);
      END_STATE();
    case 297:
      ACCEPT_TOKEN(anon_sym_const);
      if (lookahead == 'e') ADVANCE(381);
      if (lookahead == 'i') ADVANCE(382);
      END_STATE();
    case 298:
      if (lookahead == 'n') ADVANCE(383);
      END_STATE();
    case 299:
      if (lookahead == 'y') ADVANCE(384);
      END_STATE();
    case 300:
      if (lookahead == 'l') ADVANCE(385);
      END_STATE();
    case 301:
      if (lookahead == 'e') ADVANCE(386);
      END_STATE();
    case 302:
      if (lookahead == 'e') ADVANCE(387);
      END_STATE();
    case 303:
      if (lookahead == 'c') ADVANCE(388);
      END_STATE();
    case 304:
      if (lookahead == 'n') ADVANCE(389);
      END_STATE();
    case 305:
      ACCEPT_TOKEN(anon_sym_final);
      END_STATE();
    case 306:
      if (lookahead == 'd') ADVANCE(390);
      END_STATE();
    case 307:
      if (lookahead == 'e') ADVANCE(391);
      END_STATE();
    case 308:
      if (lookahead == 'l') ADVANCE(392);
      END_STATE();
    case 309:
      if (lookahead == 'p') ADVANCE(393);
      END_STATE();
    case 310:
      if (lookahead == 'e') ADVANCE(394);
      END_STATE();
    case 311:
      if (lookahead == 'u') ADVANCE(395);
      END_STATE();
    case 312:
      if (lookahead == 'q') ADVANCE(396);
      END_STATE();
    case 313:
      if (lookahead == 't') ADVANCE(397);
      END_STATE();
    case 314:
      if (lookahead == 't') ADVANCE(398);
      END_STATE();
    case 315:
      if (lookahead == 't') ADVANCE(399);
      END_STATE();
    case 316:
      ACCEPT_TOKEN(anon_sym_or_eq);
      END_STATE();
    case 317:
      if (lookahead == 'i') ADVANCE(400);
      END_STATE();
    case 318:
      if (lookahead == 't') ADVANCE(401);
      END_STATE();
    case 319:
      if (lookahead == 'c') ADVANCE(402);
      END_STATE();
    case 320:
      if (lookahead == 'c') ADVANCE(403);
      END_STATE();
    case 321:
      if (lookahead == 't') ADVANCE(404);
      END_STATE();
    case 322:
      if (lookahead == 'r') ADVANCE(405);
      END_STATE();
    case 323:
      if (lookahead == 'i') ADVANCE(406);
      END_STATE();
    case 324:
      if (lookahead == 'n') ADVANCE(407);
      END_STATE();
    case 325:
      ACCEPT_TOKEN(anon_sym_short);
      END_STATE();
    case 326:
      if (lookahead == 'd') ADVANCE(408);
      END_STATE();
    case 327:
      if (lookahead == 'f') ADVANCE(409);
      END_STATE();
    case 328:
      if (lookahead == 'c') ADVANCE(410);
      END_STATE();
    case 329:
      if (lookahead == 't') ADVANCE(411);
      END_STATE();
    case 330:
      if (lookahead == 'h') ADVANCE(412);
      END_STATE();
    case 331:
      if (lookahead == 'a') ADVANCE(413);
      END_STATE();
    case 332:
      if (lookahead == 'd') ADVANCE(414);
      END_STATE();
    case 333:
      ACCEPT_TOKEN(anon_sym_throw);
      END_STATE();
    case 334:
      if (lookahead == 'e') ADVANCE(415);
      END_STATE();
    case 335:
      if (lookahead == 'a') ADVANCE(416);
      END_STATE();
    case 336:
      ACCEPT_TOKEN(anon_sym_union);
      END_STATE();
    case 337:
      if (lookahead == 'n') ADVANCE(417);
      END_STATE();
    case 338:
      ACCEPT_TOKEN(anon_sym_using);
      END_STATE();
    case 339:
      if (lookahead == 'a') ADVANCE(418);
      END_STATE();
    case 340:
      if (lookahead == 'i') ADVANCE(419);
      END_STATE();
    case 341:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 342:
      if (lookahead == 'q') ADVANCE(420);
      END_STATE();
    case 343:
      if (lookahead == 'a') ADVANCE(421);
      if (lookahead == 'o') ADVANCE(422);
      END_STATE();
    case 344:
      if (lookahead == 'c') ADVANCE(423);
      END_STATE();
    case 345:
      if (lookahead == 'i') ADVANCE(424);
      END_STATE();
    case 346:
      if (lookahead == 'l') ADVANCE(425);
      END_STATE();
    case 347:
      if (lookahead == 'u') ADVANCE(426);
      END_STATE();
    case 348:
      if (lookahead == 'n') ADVANCE(427);
      END_STATE();
    case 349:
      if (lookahead == '_') ADVANCE(428);
      END_STATE();
    case 350:
      if (lookahead == 'i') ADVANCE(429);
      END_STATE();
    case 351:
      if (lookahead == 'd') ADVANCE(430);
      END_STATE();
    case 352:
      if (lookahead == 'l') ADVANCE(431);
      END_STATE();
    case 353:
      if (lookahead == 'a') ADVANCE(432);
      END_STATE();
    case 354:
      if (lookahead == 's') ADVANCE(433);
      END_STATE();
    case 355:
      if (lookahead == 'p') ADVANCE(434);
      END_STATE();
    case 356:
      if (lookahead == 'n') ADVANCE(435);
      END_STATE();
    case 357:
      if (lookahead == 'c') ADVANCE(436);
      END_STATE();
    case 358:
      if (lookahead == 'l') ADVANCE(437);
      END_STATE();
    case 359:
      if (lookahead == 'e') ADVANCE(438);
      END_STATE();
    case 360:
      if (lookahead == 'n') ADVANCE(439);
      END_STATE();
    case 361:
      if (lookahead == 'e') ADVANCE(440);
      END_STATE();
    case 362:
      if (lookahead == 'r') ADVANCE(441);
      END_STATE();
    case 363:
      ACCEPT_TOKEN(sym_ms_signed_ptr_modifier);
      END_STATE();
    case 364:
      if (lookahead == 'a') ADVANCE(442);
      END_STATE();
    case 365:
      if (lookahead == 'c') ADVANCE(443);
      END_STATE();
    case 366:
      if (lookahead == 'a') ADVANCE(444);
      END_STATE();
    case 367:
      if (lookahead == 'i') ADVANCE(445);
      END_STATE();
    case 368:
      ACCEPT_TOKEN(sym_ms_unsigned_ptr_modifier);
      END_STATE();
    case 369:
      if (lookahead == 'o') ADVANCE(446);
      END_STATE();
    case 370:
      if (lookahead == 't') ADVANCE(447);
      END_STATE();
    case 371:
      if (lookahead == 'o') ADVANCE(448);
      END_STATE();
    case 372:
      if (lookahead == 'g') ADVANCE(449);
      END_STATE();
    case 373:
      if (lookahead == 's') ADVANCE(450);
      END_STATE();
    case 374:
      if (lookahead == 'f') ADVANCE(451);
      END_STATE();
    case 375:
      ACCEPT_TOKEN(anon_sym_and_eq);
      END_STATE();
    case 376:
      ACCEPT_TOKEN(anon_sym_bitand);
      END_STATE();
    case 377:
      if (lookahead == 'i') ADVANCE(452);
      END_STATE();
    case 378:
      if (lookahead == 'u') ADVANCE(453);
      END_STATE();
    case 379:
      if (lookahead == 'l') ADVANCE(454);
      END_STATE();
    case 380:
      if (lookahead == 't') ADVANCE(455);
      END_STATE();
    case 381:
      if (lookahead == 'v') ADVANCE(456);
      if (lookahead == 'x') ADVANCE(457);
      END_STATE();
    case 382:
      if (lookahead == 'n') ADVANCE(458);
      END_STATE();
    case 383:
      if (lookahead == 'u') ADVANCE(459);
      END_STATE();
    case 384:
      if (lookahead == 'p') ADVANCE(460);
      END_STATE();
    case 385:
      if (lookahead == 't') ADVANCE(461);
      END_STATE();
    case 386:
      if (lookahead == 'd') ADVANCE(462);
      END_STATE();
    case 387:
      ACCEPT_TOKEN(anon_sym_delete);
      END_STATE();
    case 388:
      if (lookahead == 'i') ADVANCE(463);
      END_STATE();
    case 389:
      ACCEPT_TOKEN(anon_sym_extern);
      END_STATE();
    case 390:
      ACCEPT_TOKEN(anon_sym_friend);
      END_STATE();
    case 391:
      ACCEPT_TOKEN(anon_sym_inline);
      END_STATE();
    case 392:
      if (lookahead == 'e') ADVANCE(464);
      END_STATE();
    case 393:
      if (lookahead == 'a') ADVANCE(465);
      END_STATE();
    case 394:
      if (lookahead == 'p') ADVANCE(466);
      END_STATE();
    case 395:
      if (lookahead == 'r') ADVANCE(467);
      END_STATE();
    case 396:
      ACCEPT_TOKEN(anon_sym_not_eq);
      END_STATE();
    case 397:
      if (lookahead == 'r') ADVANCE(468);
      END_STATE();
    case 398:
      if (lookahead == 'o') ADVANCE(469);
      END_STATE();
    case 399:
      if (lookahead == 'o') ADVANCE(470);
      END_STATE();
    case 400:
      if (lookahead == 'd') ADVANCE(471);
      END_STATE();
    case 401:
      if (lookahead == 'e') ADVANCE(472);
      END_STATE();
    case 402:
      if (lookahead == 't') ADVANCE(473);
      END_STATE();
    case 403:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 404:
      if (lookahead == 'e') ADVANCE(474);
      END_STATE();
    case 405:
      if (lookahead == 'e') ADVANCE(475);
      END_STATE();
    case 406:
      if (lookahead == 'c') ADVANCE(476);
      END_STATE();
    case 407:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 408:
      ACCEPT_TOKEN(anon_sym_signed);
      END_STATE();
    case 409:
      ACCEPT_TOKEN(anon_sym_sizeof);
      END_STATE();
    case 410:
      ACCEPT_TOKEN(anon_sym_static);
      if (lookahead == '_') ADVANCE(477);
      END_STATE();
    case 411:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 412:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 413:
      if (lookahead == 't') ADVANCE(478);
      END_STATE();
    case 414:
      if (lookahead == '_') ADVANCE(479);
      END_STATE();
    case 415:
      if (lookahead == 'f') ADVANCE(480);
      END_STATE();
    case 416:
      if (lookahead == 'm') ADVANCE(481);
      END_STATE();
    case 417:
      if (lookahead == 'e') ADVANCE(482);
      END_STATE();
    case 418:
      if (lookahead == 'l') ADVANCE(483);
      END_STATE();
    case 419:
      if (lookahead == 'l') ADVANCE(484);
      END_STATE();
    case 420:
      ACCEPT_TOKEN(anon_sym_xor_eq);
      END_STATE();
    case 421:
      if (lookahead == 's') ADVANCE(485);
      END_STATE();
    case 422:
      if (lookahead == 'f') ADVANCE(486);
      END_STATE();
    case 423:
      ACCEPT_TOKEN(anon_sym__Atomic);
      END_STATE();
    case 424:
      if (lookahead == 'c') ADVANCE(487);
      END_STATE();
    case 425:
      if (lookahead == 'l') ADVANCE(488);
      END_STATE();
    case 426:
      if (lookahead == 'r') ADVANCE(489);
      END_STATE();
    case 427:
      if (lookahead == 'o') ADVANCE(490);
      END_STATE();
    case 428:
      ACCEPT_TOKEN(anon_sym___asm__);
      END_STATE();
    case 429:
      if (lookahead == 'b') ADVANCE(491);
      END_STATE();
    case 430:
      ACCEPT_TOKEN(anon_sym___based);
      END_STATE();
    case 431:
      ACCEPT_TOKEN(anon_sym___cdecl);
      END_STATE();
    case 432:
      if (lookahead == 'l') ADVANCE(492);
      END_STATE();
    case 433:
      if (lookahead == 'p') ADVANCE(493);
      END_STATE();
    case 434:
      if (lookahead == 't') ADVANCE(494);
      END_STATE();
    case 435:
      if (lookahead == 's') ADVANCE(495);
      END_STATE();
    case 436:
      if (lookahead == 'a') ADVANCE(496);
      END_STATE();
    case 437:
      if (lookahead == 'l') ADVANCE(497);
      END_STATE();
    case 438:
      if (lookahead == 'i') ADVANCE(498);
      END_STATE();
    case 439:
      if (lookahead == 'e') ADVANCE(499);
      END_STATE();
    case 440:
      ACCEPT_TOKEN(anon_sym___leave);
      END_STATE();
    case 441:
      if (lookahead == 'i') ADVANCE(500);
      END_STATE();
    case 442:
      if (lookahead == 'l') ADVANCE(501);
      END_STATE();
    case 443:
      if (lookahead == 'a') ADVANCE(502);
      END_STATE();
    case 444:
      if (lookahead == 'd') ADVANCE(503);
      END_STATE();
    case 445:
      if (lookahead == 'g') ADVANCE(504);
      END_STATE();
    case 446:
      if (lookahead == 'r') ADVANCE(505);
      END_STATE();
    case 447:
      if (lookahead == 'i') ADVANCE(506);
      END_STATE();
    case 448:
      if (lookahead == 'f') ADVANCE(507);
      END_STATE();
    case 449:
      if (lookahead == 'n') ADVANCE(508);
      END_STATE();
    case 450:
      ACCEPT_TOKEN(anon_sym_alignas);
      END_STATE();
    case 451:
      ACCEPT_TOKEN(anon_sym_alignof);
      END_STATE();
    case 452:
      if (lookahead == 't') ADVANCE(509);
      END_STATE();
    case 453:
      if (lookahead == 'r') ADVANCE(510);
      END_STATE();
    case 454:
      if (lookahead == 'd') ADVANCE(511);
      END_STATE();
    case 455:
      ACCEPT_TOKEN(anon_sym_concept);
      END_STATE();
    case 456:
      if (lookahead == 'a') ADVANCE(512);
      END_STATE();
    case 457:
      if (lookahead == 'p') ADVANCE(513);
      END_STATE();
    case 458:
      if (lookahead == 'i') ADVANCE(514);
      END_STATE();
    case 459:
      if (lookahead == 'e') ADVANCE(515);
      END_STATE();
    case 460:
      if (lookahead == 'e') ADVANCE(516);
      END_STATE();
    case 461:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 462:
      ACCEPT_TOKEN(anon_sym_defined);
      END_STATE();
    case 463:
      if (lookahead == 't') ADVANCE(517);
      END_STATE();
    case 464:
      ACCEPT_TOKEN(anon_sym_mutable);
      END_STATE();
    case 465:
      if (lookahead == 'c') ADVANCE(518);
      END_STATE();
    case 466:
      if (lookahead == 't') ADVANCE(519);
      END_STATE();
    case 467:
      if (lookahead == 'n') ADVANCE(520);
      END_STATE();
    case 468:
      ACCEPT_TOKEN(anon_sym_nullptr);
      END_STATE();
    case 469:
      if (lookahead == 'f') ADVANCE(521);
      END_STATE();
    case 470:
      if (lookahead == 'r') ADVANCE(522);
      END_STATE();
    case 471:
      if (lookahead == 'e') ADVANCE(523);
      END_STATE();
    case 472:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 473:
      if (lookahead == 'e') ADVANCE(524);
      END_STATE();
    case 474:
      if (lookahead == 'r') ADVANCE(525);
      END_STATE();
    case 475:
      if (lookahead == 's') ADVANCE(526);
      END_STATE();
    case 476:
      if (lookahead == 't') ADVANCE(527);
      END_STATE();
    case 477:
      if (lookahead == 'a') ADVANCE(528);
      END_STATE();
    case 478:
      if (lookahead == 'e') ADVANCE(529);
      END_STATE();
    case 479:
      if (lookahead == 'l') ADVANCE(530);
      END_STATE();
    case 480:
      ACCEPT_TOKEN(anon_sym_typedef);
      END_STATE();
    case 481:
      if (lookahead == 'e') ADVANCE(531);
      END_STATE();
    case 482:
      if (lookahead == 'd') ADVANCE(532);
      END_STATE();
    case 483:
      ACCEPT_TOKEN(anon_sym_virtual);
      END_STATE();
    case 484:
      if (lookahead == 'e') ADVANCE(533);
      END_STATE();
    case 485:
      ACCEPT_TOKEN(anon_sym__Alignas);
      END_STATE();
    case 486:
      ACCEPT_TOKEN(anon_sym__Alignof);
      END_STATE();
    case 487:
      ACCEPT_TOKEN(anon_sym__Generic);
      END_STATE();
    case 488:
      ACCEPT_TOKEN(anon_sym__Nonnull);
      END_STATE();
    case 489:
      if (lookahead == 'n') ADVANCE(534);
      END_STATE();
    case 490:
      if (lookahead == 'f') ADVANCE(535);
      END_STATE();
    case 491:
      if (lookahead == 'u') ADVANCE(536);
      END_STATE();
    case 492:
      if (lookahead == 'l') ADVANCE(537);
      END_STATE();
    case 493:
      if (lookahead == 'e') ADVANCE(538);
      END_STATE();
    case 494:
      ACCEPT_TOKEN(anon_sym___except);
      END_STATE();
    case 495:
      if (lookahead == 'i') ADVANCE(539);
      END_STATE();
    case 496:
      if (lookahead == 'l') ADVANCE(540);
      END_STATE();
    case 497:
      if (lookahead == 'y') ADVANCE(541);
      END_STATE();
    case 498:
      if (lookahead == 'n') ADVANCE(542);
      END_STATE();
    case 499:
      ACCEPT_TOKEN(anon_sym___inline);
      if (lookahead == '_') ADVANCE(543);
      END_STATE();
    case 500:
      if (lookahead == 'c') ADVANCE(544);
      END_STATE();
    case 501:
      if (lookahead == 'l') ADVANCE(545);
      END_STATE();
    case 502:
      if (lookahead == 'l') ADVANCE(546);
      END_STATE();
    case 503:
      ACCEPT_TOKEN(anon_sym___thread);
      END_STATE();
    case 504:
      if (lookahead == 'n') ADVANCE(547);
      END_STATE();
    case 505:
      if (lookahead == 'c') ADVANCE(548);
      END_STATE();
    case 506:
      if (lookahead == 'l') ADVANCE(549);
      END_STATE();
    case 507:
      ACCEPT_TOKEN(anon_sym__alignof);
      END_STATE();
    case 508:
      if (lookahead == 'e') ADVANCE(550);
      END_STATE();
    case 509:
      ACCEPT_TOKEN(anon_sym_co_await);
      END_STATE();
    case 510:
      if (lookahead == 'n') ADVANCE(551);
      END_STATE();
    case 511:
      ACCEPT_TOKEN(anon_sym_co_yield);
      END_STATE();
    case 512:
      if (lookahead == 'l') ADVANCE(552);
      END_STATE();
    case 513:
      if (lookahead == 'r') ADVANCE(553);
      END_STATE();
    case 514:
      if (lookahead == 't') ADVANCE(554);
      END_STATE();
    case 515:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 516:
      ACCEPT_TOKEN(anon_sym_decltype);
      END_STATE();
    case 517:
      ACCEPT_TOKEN(anon_sym_explicit);
      END_STATE();
    case 518:
      if (lookahead == 'e') ADVANCE(555);
      END_STATE();
    case 519:
      ACCEPT_TOKEN(anon_sym_noexcept);
      END_STATE();
    case 520:
      ACCEPT_TOKEN(anon_sym_noreturn);
      END_STATE();
    case 521:
      ACCEPT_TOKEN(anon_sym_offsetof);
      END_STATE();
    case 522:
      ACCEPT_TOKEN(anon_sym_operator);
      END_STATE();
    case 523:
      ACCEPT_TOKEN(anon_sym_override);
      END_STATE();
    case 524:
      if (lookahead == 'd') ADVANCE(556);
      END_STATE();
    case 525:
      ACCEPT_TOKEN(anon_sym_register);
      END_STATE();
    case 526:
      ACCEPT_TOKEN(anon_sym_requires);
      END_STATE();
    case 527:
      ACCEPT_TOKEN(anon_sym_restrict);
      END_STATE();
    case 528:
      if (lookahead == 's') ADVANCE(557);
      END_STATE();
    case 529:
      ACCEPT_TOKEN(anon_sym_template);
      END_STATE();
    case 530:
      if (lookahead == 'o') ADVANCE(558);
      END_STATE();
    case 531:
      ACCEPT_TOKEN(anon_sym_typename);
      END_STATE();
    case 532:
      ACCEPT_TOKEN(anon_sym_unsigned);
      END_STATE();
    case 533:
      ACCEPT_TOKEN(anon_sym_volatile);
      END_STATE();
    case 534:
      ACCEPT_TOKEN(anon_sym__Noreturn);
      END_STATE();
    case 535:
      ACCEPT_TOKEN(anon_sym___alignof);
      if (lookahead == '_') ADVANCE(559);
      END_STATE();
    case 536:
      if (lookahead == 't') ADVANCE(560);
      END_STATE();
    case 537:
      ACCEPT_TOKEN(anon_sym___clrcall);
      END_STATE();
    case 538:
      if (lookahead == 'c') ADVANCE(561);
      END_STATE();
    case 539:
      if (lookahead == 'o') ADVANCE(562);
      END_STATE();
    case 540:
      if (lookahead == 'l') ADVANCE(563);
      END_STATE();
    case 541:
      ACCEPT_TOKEN(anon_sym___finally);
      END_STATE();
    case 542:
      if (lookahead == 'l') ADVANCE(564);
      END_STATE();
    case 543:
      if (lookahead == '_') ADVANCE(565);
      END_STATE();
    case 544:
      if (lookahead == 't') ADVANCE(566);
      END_STATE();
    case 545:
      ACCEPT_TOKEN(anon_sym___stdcall);
      END_STATE();
    case 546:
      if (lookahead == 'l') ADVANCE(567);
      END_STATE();
    case 547:
      if (lookahead == 'e') ADVANCE(568);
      END_STATE();
    case 548:
      if (lookahead == 'a') ADVANCE(569);
      END_STATE();
    case 549:
      if (lookahead == 'e') ADVANCE(570);
      END_STATE();
    case 550:
      if (lookahead == 'd') ADVANCE(571);
      END_STATE();
    case 551:
      ACCEPT_TOKEN(anon_sym_co_return);
      END_STATE();
    case 552:
      ACCEPT_TOKEN(anon_sym_consteval);
      END_STATE();
    case 553:
      ACCEPT_TOKEN(anon_sym_constexpr);
      END_STATE();
    case 554:
      ACCEPT_TOKEN(anon_sym_constinit);
      END_STATE();
    case 555:
      ACCEPT_TOKEN(anon_sym_namespace);
      END_STATE();
    case 556:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 557:
      if (lookahead == 's') ADVANCE(572);
      END_STATE();
    case 558:
      if (lookahead == 'c') ADVANCE(573);
      END_STATE();
    case 559:
      if (lookahead == '_') ADVANCE(574);
      END_STATE();
    case 560:
      if (lookahead == 'e') ADVANCE(575);
      END_STATE();
    case 561:
      ACCEPT_TOKEN(anon_sym___declspec);
      END_STATE();
    case 562:
      if (lookahead == 'n') ADVANCE(576);
      END_STATE();
    case 563:
      ACCEPT_TOKEN(anon_sym___fastcall);
      END_STATE();
    case 564:
      if (lookahead == 'i') ADVANCE(577);
      END_STATE();
    case 565:
      ACCEPT_TOKEN(anon_sym___inline__);
      END_STATE();
    case 566:
      ACCEPT_TOKEN(sym_ms_restrict_modifier);
      if (lookahead == '_') ADVANCE(578);
      END_STATE();
    case 567:
      ACCEPT_TOKEN(anon_sym___thiscall);
      END_STATE();
    case 568:
      if (lookahead == 'd') ADVANCE(579);
      END_STATE();
    case 569:
      if (lookahead == 'l') ADVANCE(580);
      END_STATE();
    case 570:
      if (lookahead == '_') ADVANCE(581);
      END_STATE();
    case 571:
      ACCEPT_TOKEN(anon_sym__unaligned);
      END_STATE();
    case 572:
      if (lookahead == 'e') ADVANCE(582);
      END_STATE();
    case 573:
      if (lookahead == 'a') ADVANCE(583);
      END_STATE();
    case 574:
      ACCEPT_TOKEN(anon_sym___alignof__);
      END_STATE();
    case 575:
      ACCEPT_TOKEN(anon_sym___attribute);
      if (lookahead == '_') ADVANCE(584);
      END_STATE();
    case 576:
      if (lookahead == '_') ADVANCE(585);
      END_STATE();
    case 577:
      if (lookahead == 'n') ADVANCE(586);
      END_STATE();
    case 578:
      if (lookahead == '_') ADVANCE(587);
      END_STATE();
    case 579:
      ACCEPT_TOKEN(anon_sym___unaligned);
      END_STATE();
    case 580:
      if (lookahead == 'l') ADVANCE(588);
      END_STATE();
    case 581:
      if (lookahead == '_') ADVANCE(589);
      END_STATE();
    case 582:
      if (lookahead == 'r') ADVANCE(590);
      END_STATE();
    case 583:
      if (lookahead == 'l') ADVANCE(591);
      END_STATE();
    case 584:
      if (lookahead == '_') ADVANCE(592);
      END_STATE();
    case 585:
      if (lookahead == '_') ADVANCE(593);
      END_STATE();
    case 586:
      if (lookahead == 'e') ADVANCE(594);
      END_STATE();
    case 587:
      ACCEPT_TOKEN(anon_sym___restrict__);
      END_STATE();
    case 588:
      ACCEPT_TOKEN(anon_sym___vectorcall);
      END_STATE();
    case 589:
      ACCEPT_TOKEN(anon_sym___volatile__);
      END_STATE();
    case 590:
      if (lookahead == 't') ADVANCE(595);
      END_STATE();
    case 591:
      ACCEPT_TOKEN(anon_sym_thread_local);
      END_STATE();
    case 592:
      ACCEPT_TOKEN(anon_sym___attribute__);
      END_STATE();
    case 593:
      ACCEPT_TOKEN(anon_sym___extension__);
      END_STATE();
    case 594:
      ACCEPT_TOKEN(anon_sym___forceinline);
      END_STATE();
    case 595:
      ACCEPT_TOKEN(anon_sym_static_assert);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 336},
  [2] = {.lex_state = 336},
  [3] = {.lex_state = 336},
  [4] = {.lex_state = 336},
  [5] = {.lex_state = 336},
  [6] = {.lex_state = 336},
  [7] = {.lex_state = 336},
  [8] = {.lex_state = 336},
  [9] = {.lex_state = 336},
  [10] = {.lex_state = 336},
  [11] = {.lex_state = 336},
  [12] = {.lex_state = 336},
  [13] = {.lex_state = 169},
  [14] = {.lex_state = 169},
  [15] = {.lex_state = 169},
  [16] = {.lex_state = 169},
  [17] = {.lex_state = 169},
  [18] = {.lex_state = 169},
  [19] = {.lex_state = 169},
  [20] = {.lex_state = 169},
  [21] = {.lex_state = 169},
  [22] = {.lex_state = 169},
  [23] = {.lex_state = 169},
  [24] = {.lex_state = 169},
  [25] = {.lex_state = 169},
  [26] = {.lex_state = 169},
  [27] = {.lex_state = 169},
  [28] = {.lex_state = 169},
  [29] = {.lex_state = 169},
  [30] = {.lex_state = 169},
  [31] = {.lex_state = 169},
  [32] = {.lex_state = 169},
  [33] = {.lex_state = 169},
  [34] = {.lex_state = 336},
  [35] = {.lex_state = 336},
  [36] = {.lex_state = 172},
  [37] = {.lex_state = 336},
  [38] = {.lex_state = 336},
  [39] = {.lex_state = 336},
  [40] = {.lex_state = 336},
  [41] = {.lex_state = 336},
  [42] = {.lex_state = 336},
  [43] = {.lex_state = 336},
  [44] = {.lex_state = 336},
  [45] = {.lex_state = 336},
  [46] = {.lex_state = 336},
  [47] = {.lex_state = 172},
  [48] = {.lex_state = 336},
  [49] = {.lex_state = 336},
  [50] = {.lex_state = 336},
  [51] = {.lex_state = 336},
  [52] = {.lex_state = 336},
  [53] = {.lex_state = 336},
  [54] = {.lex_state = 172},
  [55] = {.lex_state = 336},
  [56] = {.lex_state = 336},
  [57] = {.lex_state = 336},
  [58] = {.lex_state = 336},
  [59] = {.lex_state = 336},
  [60] = {.lex_state = 336},
  [61] = {.lex_state = 336},
  [62] = {.lex_state = 336},
  [63] = {.lex_state = 336},
  [64] = {.lex_state = 336},
  [65] = {.lex_state = 336},
  [66] = {.lex_state = 336},
  [67] = {.lex_state = 336},
  [68] = {.lex_state = 336},
  [69] = {.lex_state = 336},
  [70] = {.lex_state = 336},
  [71] = {.lex_state = 336},
  [72] = {.lex_state = 336},
  [73] = {.lex_state = 336},
  [74] = {.lex_state = 336},
  [75] = {.lex_state = 336},
  [76] = {.lex_state = 336},
  [77] = {.lex_state = 336},
  [78] = {.lex_state = 336},
  [79] = {.lex_state = 336},
  [80] = {.lex_state = 336},
  [81] = {.lex_state = 336},
  [82] = {.lex_state = 169},
  [83] = {.lex_state = 169},
  [84] = {.lex_state = 169},
  [85] = {.lex_state = 169},
  [86] = {.lex_state = 169},
  [87] = {.lex_state = 336},
  [88] = {.lex_state = 172},
  [89] = {.lex_state = 336},
  [90] = {.lex_state = 336},
  [91] = {.lex_state = 172},
  [92] = {.lex_state = 336},
  [93] = {.lex_state = 336},
  [94] = {.lex_state = 172},
  [95] = {.lex_state = 336},
  [96] = {.lex_state = 336},
  [97] = {.lex_state = 172},
  [98] = {.lex_state = 172},
  [99] = {.lex_state = 336},
  [100] = {.lex_state = 336},
  [101] = {.lex_state = 336},
  [102] = {.lex_state = 171},
  [103] = {.lex_state = 171},
  [104] = {.lex_state = 171},
  [105] = {.lex_state = 171},
  [106] = {.lex_state = 171},
  [107] = {.lex_state = 171},
  [108] = {.lex_state = 171},
  [109] = {.lex_state = 171},
  [110] = {.lex_state = 171},
  [111] = {.lex_state = 171},
  [112] = {.lex_state = 171},
  [113] = {.lex_state = 171},
  [114] = {.lex_state = 171},
  [115] = {.lex_state = 171},
  [116] = {.lex_state = 171},
  [117] = {.lex_state = 171},
  [118] = {.lex_state = 171},
  [119] = {.lex_state = 171},
  [120] = {.lex_state = 173},
  [121] = {.lex_state = 171},
  [122] = {.lex_state = 173},
  [123] = {.lex_state = 173},
  [124] = {.lex_state = 171},
  [125] = {.lex_state = 171},
  [126] = {.lex_state = 171},
  [127] = {.lex_state = 171},
  [128] = {.lex_state = 171},
  [129] = {.lex_state = 171},
  [130] = {.lex_state = 171},
  [131] = {.lex_state = 171},
  [132] = {.lex_state = 336},
  [133] = {.lex_state = 336},
  [134] = {.lex_state = 162},
  [135] = {.lex_state = 162},
  [136] = {.lex_state = 162},
  [137] = {.lex_state = 174},
  [138] = {.lex_state = 174},
  [139] = {.lex_state = 174},
  [140] = {.lex_state = 174},
  [141] = {.lex_state = 174},
  [142] = {.lex_state = 174},
  [143] = {.lex_state = 174},
  [144] = {.lex_state = 174},
  [145] = {.lex_state = 174},
  [146] = {.lex_state = 174},
  [147] = {.lex_state = 174},
  [148] = {.lex_state = 174},
  [149] = {.lex_state = 174},
  [150] = {.lex_state = 174},
  [151] = {.lex_state = 174},
  [152] = {.lex_state = 174},
  [153] = {.lex_state = 174},
  [154] = {.lex_state = 174},
  [155] = {.lex_state = 174},
  [156] = {.lex_state = 174},
  [157] = {.lex_state = 174},
  [158] = {.lex_state = 174},
  [159] = {.lex_state = 174},
  [160] = {.lex_state = 174},
  [161] = {.lex_state = 174},
  [162] = {.lex_state = 174},
  [163] = {.lex_state = 171},
  [164] = {.lex_state = 171},
  [165] = {.lex_state = 171},
  [166] = {.lex_state = 171},
  [167] = {.lex_state = 164},
  [168] = {.lex_state = 171},
  [169] = {.lex_state = 171},
  [170] = {.lex_state = 171},
  [171] = {.lex_state = 171},
  [172] = {.lex_state = 171},
  [173] = {.lex_state = 171},
  [174] = {.lex_state = 171},
  [175] = {.lex_state = 171},
  [176] = {.lex_state = 171},
  [177] = {.lex_state = 171},
  [178] = {.lex_state = 171},
  [179] = {.lex_state = 171},
  [180] = {.lex_state = 171},
  [181] = {.lex_state = 171},
  [182] = {.lex_state = 171},
  [183] = {.lex_state = 171},
  [184] = {.lex_state = 171},
  [185] = {.lex_state = 171},
  [186] = {.lex_state = 171},
  [187] = {.lex_state = 171},
  [188] = {.lex_state = 171},
  [189] = {.lex_state = 171},
  [190] = {.lex_state = 171},
  [191] = {.lex_state = 171},
  [192] = {.lex_state = 171},
  [193] = {.lex_state = 171},
  [194] = {.lex_state = 171},
  [195] = {.lex_state = 171},
  [196] = {.lex_state = 171},
  [197] = {.lex_state = 171},
  [198] = {.lex_state = 171},
  [199] = {.lex_state = 171},
  [200] = {.lex_state = 171},
  [201] = {.lex_state = 171},
  [202] = {.lex_state = 171},
  [203] = {.lex_state = 171},
  [204] = {.lex_state = 171},
  [205] = {.lex_state = 171},
  [206] = {.lex_state = 171},
  [207] = {.lex_state = 171},
  [208] = {.lex_state = 171},
  [209] = {.lex_state = 171},
  [210] = {.lex_state = 171},
  [211] = {.lex_state = 171},
  [212] = {.lex_state = 171},
  [213] = {.lex_state = 171},
  [214] = {.lex_state = 171},
  [215] = {.lex_state = 171},
  [216] = {.lex_state = 171},
  [217] = {.lex_state = 169},
  [218] = {.lex_state = 165},
  [219] = {.lex_state = 169},
  [220] = {.lex_state = 162},
  [221] = {.lex_state = 169},
  [222] = {.lex_state = 336},
  [223] = {.lex_state = 169},
  [224] = {.lex_state = 336},
  [225] = {.lex_state = 336},
  [226] = {.lex_state = 336},
  [227] = {.lex_state = 169},
  [228] = {.lex_state = 169},
  [229] = {.lex_state = 169},
  [230] = {.lex_state = 169},
  [231] = {.lex_state = 164},
  [232] = {.lex_state = 169},
  [233] = {.lex_state = 169},
  [234] = {.lex_state = 169},
  [235] = {.lex_state = 169},
  [236] = {.lex_state = 169},
  [237] = {.lex_state = 169},
  [238] = {.lex_state = 169},
  [239] = {.lex_state = 169},
  [240] = {.lex_state = 169},
  [241] = {.lex_state = 169},
  [242] = {.lex_state = 169},
  [243] = {.lex_state = 169},
  [244] = {.lex_state = 169},
  [245] = {.lex_state = 169},
  [246] = {.lex_state = 169},
  [247] = {.lex_state = 169},
  [248] = {.lex_state = 169},
  [249] = {.lex_state = 169},
  [250] = {.lex_state = 169},
  [251] = {.lex_state = 169},
  [252] = {.lex_state = 169},
  [253] = {.lex_state = 169},
  [254] = {.lex_state = 169},
  [255] = {.lex_state = 169},
  [256] = {.lex_state = 169},
  [257] = {.lex_state = 169},
  [258] = {.lex_state = 169},
  [259] = {.lex_state = 169},
  [260] = {.lex_state = 169},
  [261] = {.lex_state = 169},
  [262] = {.lex_state = 169},
  [263] = {.lex_state = 169},
  [264] = {.lex_state = 169},
  [265] = {.lex_state = 169},
  [266] = {.lex_state = 169},
  [267] = {.lex_state = 169},
  [268] = {.lex_state = 169},
  [269] = {.lex_state = 169},
  [270] = {.lex_state = 169},
  [271] = {.lex_state = 169},
  [272] = {.lex_state = 169},
  [273] = {.lex_state = 169},
  [274] = {.lex_state = 169},
  [275] = {.lex_state = 169},
  [276] = {.lex_state = 169},
  [277] = {.lex_state = 169},
  [278] = {.lex_state = 169},
  [279] = {.lex_state = 169},
  [280] = {.lex_state = 169},
  [281] = {.lex_state = 169},
  [282] = {.lex_state = 169},
  [283] = {.lex_state = 169},
  [284] = {.lex_state = 171},
  [285] = {.lex_state = 169},
  [286] = {.lex_state = 172},
  [287] = {.lex_state = 169},
  [288] = {.lex_state = 169},
  [289] = {.lex_state = 169},
  [290] = {.lex_state = 336},
  [291] = {.lex_state = 172},
  [292] = {.lex_state = 169},
  [293] = {.lex_state = 169},
  [294] = {.lex_state = 169},
  [295] = {.lex_state = 169},
  [296] = {.lex_state = 169},
  [297] = {.lex_state = 169},
  [298] = {.lex_state = 169},
  [299] = {.lex_state = 169},
  [300] = {.lex_state = 169},
  [301] = {.lex_state = 174},
  [302] = {.lex_state = 169},
  [303] = {.lex_state = 169},
  [304] = {.lex_state = 169},
  [305] = {.lex_state = 169},
  [306] = {.lex_state = 169},
  [307] = {.lex_state = 171},
  [308] = {.lex_state = 169},
  [309] = {.lex_state = 169},
  [310] = {.lex_state = 169},
  [311] = {.lex_state = 169},
  [312] = {.lex_state = 169},
  [313] = {.lex_state = 169},
  [314] = {.lex_state = 336},
  [315] = {.lex_state = 174},
  [316] = {.lex_state = 171},
  [317] = {.lex_state = 169},
  [318] = {.lex_state = 169},
  [319] = {.lex_state = 336},
  [320] = {.lex_state = 169},
  [321] = {.lex_state = 174},
  [322] = {.lex_state = 169},
  [323] = {.lex_state = 169},
  [324] = {.lex_state = 169},
  [325] = {.lex_state = 169},
  [326] = {.lex_state = 169},
  [327] = {.lex_state = 169},
  [328] = {.lex_state = 169},
  [329] = {.lex_state = 169},
  [330] = {.lex_state = 169},
  [331] = {.lex_state = 174},
  [332] = {.lex_state = 169},
  [333] = {.lex_state = 169},
  [334] = {.lex_state = 169},
  [335] = {.lex_state = 169},
  [336] = {.lex_state = 169},
  [337] = {.lex_state = 169},
  [338] = {.lex_state = 174},
  [339] = {.lex_state = 169},
  [340] = {.lex_state = 169},
  [341] = {.lex_state = 174},
  [342] = {.lex_state = 169},
  [343] = {.lex_state = 169},
  [344] = {.lex_state = 174},
  [345] = {.lex_state = 169},
  [346] = {.lex_state = 174},
  [347] = {.lex_state = 174},
  [348] = {.lex_state = 174},
  [349] = {.lex_state = 169},
  [350] = {.lex_state = 174},
  [351] = {.lex_state = 174},
  [352] = {.lex_state = 174},
  [353] = {.lex_state = 174},
  [354] = {.lex_state = 174},
  [355] = {.lex_state = 169},
  [356] = {.lex_state = 174},
  [357] = {.lex_state = 174},
  [358] = {.lex_state = 336},
  [359] = {.lex_state = 169},
  [360] = {.lex_state = 169},
  [361] = {.lex_state = 169},
  [362] = {.lex_state = 169},
  [363] = {.lex_state = 169},
  [364] = {.lex_state = 169},
  [365] = {.lex_state = 169},
  [366] = {.lex_state = 169},
  [367] = {.lex_state = 169},
  [368] = {.lex_state = 336},
  [369] = {.lex_state = 236},
  [370] = {.lex_state = 236},
  [371] = {.lex_state = 236},
  [372] = {.lex_state = 236},
  [373] = {.lex_state = 236},
  [374] = {.lex_state = 171},
  [375] = {.lex_state = 174},
  [376] = {.lex_state = 172},
  [377] = {.lex_state = 172},
  [378] = {.lex_state = 236},
  [379] = {.lex_state = 236},
  [380] = {.lex_state = 236},
  [381] = {.lex_state = 336},
  [382] = {.lex_state = 173},
  [383] = {.lex_state = 236},
  [384] = {.lex_state = 236},
  [385] = {.lex_state = 236},
  [386] = {.lex_state = 236},
  [387] = {.lex_state = 236},
  [388] = {.lex_state = 171},
  [389] = {.lex_state = 236},
  [390] = {.lex_state = 236},
  [391] = {.lex_state = 171},
  [392] = {.lex_state = 171},
  [393] = {.lex_state = 171},
  [394] = {.lex_state = 173},
  [395] = {.lex_state = 171},
  [396] = {.lex_state = 236},
  [397] = {.lex_state = 336},
  [398] = {.lex_state = 172},
  [399] = {.lex_state = 336},
  [400] = {.lex_state = 174},
  [401] = {.lex_state = 174},
  [402] = {.lex_state = 172},
  [403] = {.lex_state = 174},
  [404] = {.lex_state = 174},
  [405] = {.lex_state = 174},
  [406] = {.lex_state = 174},
  [407] = {.lex_state = 174},
  [408] = {.lex_state = 174},
  [409] = {.lex_state = 174},
  [410] = {.lex_state = 174},
  [411] = {.lex_state = 174},
  [412] = {.lex_state = 171},
  [413] = {.lex_state = 336},
  [414] = {.lex_state = 336},
  [415] = {.lex_state = 172},
  [416] = {.lex_state = 336},
  [417] = {.lex_state = 172},
  [418] = {.lex_state = 174},
  [419] = {.lex_state = 172},
  [420] = {.lex_state = 336},
  [421] = {.lex_state = 336},
  [422] = {.lex_state = 171},
  [423] = {.lex_state = 336},
  [424] = {.lex_state = 172},
  [425] = {.lex_state = 172},
  [426] = {.lex_state = 172},
  [427] = {.lex_state = 172},
  [428] = {.lex_state = 172},
  [429] = {.lex_state = 336},
  [430] = {.lex_state = 172},
  [431] = {.lex_state = 172},
  [432] = {.lex_state = 336},
  [433] = {.lex_state = 336},
  [434] = {.lex_state = 336},
  [435] = {.lex_state = 172},
  [436] = {.lex_state = 172},
  [437] = {.lex_state = 172},
  [438] = {.lex_state = 336},
  [439] = {.lex_state = 172},
  [440] = {.lex_state = 336},
  [441] = {.lex_state = 172},
  [442] = {.lex_state = 172},
  [443] = {.lex_state = 172},
  [444] = {.lex_state = 172},
  [445] = {.lex_state = 172},
  [446] = {.lex_state = 172},
  [447] = {.lex_state = 172},
  [448] = {.lex_state = 336},
  [449] = {.lex_state = 336},
  [450] = {.lex_state = 336},
  [451] = {.lex_state = 336},
  [452] = {.lex_state = 336},
  [453] = {.lex_state = 336},
  [454] = {.lex_state = 336},
  [455] = {.lex_state = 336},
  [456] = {.lex_state = 336},
  [457] = {.lex_state = 336},
  [458] = {.lex_state = 336},
  [459] = {.lex_state = 336},
  [460] = {.lex_state = 336},
  [461] = {.lex_state = 336},
  [462] = {.lex_state = 336},
  [463] = {.lex_state = 336},
  [464] = {.lex_state = 336},
  [465] = {.lex_state = 336},
  [466] = {.lex_state = 336},
  [467] = {.lex_state = 336},
  [468] = {.lex_state = 336},
  [469] = {.lex_state = 336},
  [470] = {.lex_state = 336},
  [471] = {.lex_state = 336},
  [472] = {.lex_state = 336},
  [473] = {.lex_state = 336},
  [474] = {.lex_state = 336},
  [475] = {.lex_state = 336},
  [476] = {.lex_state = 336},
  [477] = {.lex_state = 336},
  [478] = {.lex_state = 336},
  [479] = {.lex_state = 336},
  [480] = {.lex_state = 336},
  [481] = {.lex_state = 336},
  [482] = {.lex_state = 172},
  [483] = {.lex_state = 336},
  [484] = {.lex_state = 172},
  [485] = {.lex_state = 336},
  [486] = {.lex_state = 172},
  [487] = {.lex_state = 336},
  [488] = {.lex_state = 172},
  [489] = {.lex_state = 336},
  [490] = {.lex_state = 172},
  [491] = {.lex_state = 336},
  [492] = {.lex_state = 336},
  [493] = {.lex_state = 172},
  [494] = {.lex_state = 172},
  [495] = {.lex_state = 172},
  [496] = {.lex_state = 172},
  [497] = {.lex_state = 336},
  [498] = {.lex_state = 336},
  [499] = {.lex_state = 336},
  [500] = {.lex_state = 336},
  [501] = {.lex_state = 172},
  [502] = {.lex_state = 172},
  [503] = {.lex_state = 172},
  [504] = {.lex_state = 172},
  [505] = {.lex_state = 336},
  [506] = {.lex_state = 336},
  [507] = {.lex_state = 336},
  [508] = {.lex_state = 336},
  [509] = {.lex_state = 172},
  [510] = {.lex_state = 336},
  [511] = {.lex_state = 336},
  [512] = {.lex_state = 172},
  [513] = {.lex_state = 172},
  [514] = {.lex_state = 336},
  [515] = {.lex_state = 336},
  [516] = {.lex_state = 336},
  [517] = {.lex_state = 336},
  [518] = {.lex_state = 172},
  [519] = {.lex_state = 336},
  [520] = {.lex_state = 336},
  [521] = {.lex_state = 336},
  [522] = {.lex_state = 336},
  [523] = {.lex_state = 336},
  [524] = {.lex_state = 336},
  [525] = {.lex_state = 336},
  [526] = {.lex_state = 336},
  [527] = {.lex_state = 336},
  [528] = {.lex_state = 172},
  [529] = {.lex_state = 336},
  [530] = {.lex_state = 336},
  [531] = {.lex_state = 336},
  [532] = {.lex_state = 336},
  [533] = {.lex_state = 336},
  [534] = {.lex_state = 336},
  [535] = {.lex_state = 172},
  [536] = {.lex_state = 336},
  [537] = {.lex_state = 336},
  [538] = {.lex_state = 172},
  [539] = {.lex_state = 336},
  [540] = {.lex_state = 172},
  [541] = {.lex_state = 172},
  [542] = {.lex_state = 336},
  [543] = {.lex_state = 336},
  [544] = {.lex_state = 336},
  [545] = {.lex_state = 336},
  [546] = {.lex_state = 336},
  [547] = {.lex_state = 336},
  [548] = {.lex_state = 172},
  [549] = {.lex_state = 172},
  [550] = {.lex_state = 172},
  [551] = {.lex_state = 172},
  [552] = {.lex_state = 172},
  [553] = {.lex_state = 336},
  [554] = {.lex_state = 172},
  [555] = {.lex_state = 336},
  [556] = {.lex_state = 172},
  [557] = {.lex_state = 172},
  [558] = {.lex_state = 336},
  [559] = {.lex_state = 336},
  [560] = {.lex_state = 336},
  [561] = {.lex_state = 172},
  [562] = {.lex_state = 336},
  [563] = {.lex_state = 336},
  [564] = {.lex_state = 336},
  [565] = {.lex_state = 172},
  [566] = {.lex_state = 336},
  [567] = {.lex_state = 172},
  [568] = {.lex_state = 172},
  [569] = {.lex_state = 336},
  [570] = {.lex_state = 172},
  [571] = {.lex_state = 172},
  [572] = {.lex_state = 172},
  [573] = {.lex_state = 172},
  [574] = {.lex_state = 172},
  [575] = {.lex_state = 172},
  [576] = {.lex_state = 172},
  [577] = {.lex_state = 172},
  [578] = {.lex_state = 336},
  [579] = {.lex_state = 172},
  [580] = {.lex_state = 336},
  [581] = {.lex_state = 172},
  [582] = {.lex_state = 172},
  [583] = {.lex_state = 172},
  [584] = {.lex_state = 172},
  [585] = {.lex_state = 172},
  [586] = {.lex_state = 172},
  [587] = {.lex_state = 172},
  [588] = {.lex_state = 336},
  [589] = {.lex_state = 172},
  [590] = {.lex_state = 336},
  [591] = {.lex_state = 172},
  [592] = {.lex_state = 336},
  [593] = {.lex_state = 336},
  [594] = {.lex_state = 172},
  [595] = {.lex_state = 172},
  [596] = {.lex_state = 172},
  [597] = {.lex_state = 336},
  [598] = {.lex_state = 236},
  [599] = {.lex_state = 172},
  [600] = {.lex_state = 336},
  [601] = {.lex_state = 336},
  [602] = {.lex_state = 336},
  [603] = {.lex_state = 172},
  [604] = {.lex_state = 172},
  [605] = {.lex_state = 336},
  [606] = {.lex_state = 336},
  [607] = {.lex_state = 172},
  [608] = {.lex_state = 336},
  [609] = {.lex_state = 172},
  [610] = {.lex_state = 172},
  [611] = {.lex_state = 336},
  [612] = {.lex_state = 336},
  [613] = {.lex_state = 172},
  [614] = {.lex_state = 336},
  [615] = {.lex_state = 336},
  [616] = {.lex_state = 336},
  [617] = {.lex_state = 172},
  [618] = {.lex_state = 172},
  [619] = {.lex_state = 336},
  [620] = {.lex_state = 172},
  [621] = {.lex_state = 336},
  [622] = {.lex_state = 336},
  [623] = {.lex_state = 336},
  [624] = {.lex_state = 336},
  [625] = {.lex_state = 336},
  [626] = {.lex_state = 336},
  [627] = {.lex_state = 336},
  [628] = {.lex_state = 172},
  [629] = {.lex_state = 336},
  [630] = {.lex_state = 172},
  [631] = {.lex_state = 172},
  [632] = {.lex_state = 172},
  [633] = {.lex_state = 336},
  [634] = {.lex_state = 172},
  [635] = {.lex_state = 172},
  [636] = {.lex_state = 336},
  [637] = {.lex_state = 172},
  [638] = {.lex_state = 336},
  [639] = {.lex_state = 336},
  [640] = {.lex_state = 172},
  [641] = {.lex_state = 336},
  [642] = {.lex_state = 336},
  [643] = {.lex_state = 172},
  [644] = {.lex_state = 336},
  [645] = {.lex_state = 172},
  [646] = {.lex_state = 172},
  [647] = {.lex_state = 336},
  [648] = {.lex_state = 336},
  [649] = {.lex_state = 172},
  [650] = {.lex_state = 336},
  [651] = {.lex_state = 172},
  [652] = {.lex_state = 336},
  [653] = {.lex_state = 336},
  [654] = {.lex_state = 336},
  [655] = {.lex_state = 336},
  [656] = {.lex_state = 336},
  [657] = {.lex_state = 172},
  [658] = {.lex_state = 172},
  [659] = {.lex_state = 336},
  [660] = {.lex_state = 172},
  [661] = {.lex_state = 172},
  [662] = {.lex_state = 336},
  [663] = {.lex_state = 336},
  [664] = {.lex_state = 336},
  [665] = {.lex_state = 172},
  [666] = {.lex_state = 172},
  [667] = {.lex_state = 336},
  [668] = {.lex_state = 336},
  [669] = {.lex_state = 172},
  [670] = {.lex_state = 172},
  [671] = {.lex_state = 172},
  [672] = {.lex_state = 336},
  [673] = {.lex_state = 172},
  [674] = {.lex_state = 336},
  [675] = {.lex_state = 336},
  [676] = {.lex_state = 172},
  [677] = {.lex_state = 336},
  [678] = {.lex_state = 336},
  [679] = {.lex_state = 172},
  [680] = {.lex_state = 172},
  [681] = {.lex_state = 336},
  [682] = {.lex_state = 336},
  [683] = {.lex_state = 336},
  [684] = {.lex_state = 336},
  [685] = {.lex_state = 336},
  [686] = {.lex_state = 336},
  [687] = {.lex_state = 336},
  [688] = {.lex_state = 336},
  [689] = {.lex_state = 336},
  [690] = {.lex_state = 336},
  [691] = {.lex_state = 336},
  [692] = {.lex_state = 336},
  [693] = {.lex_state = 336},
  [694] = {.lex_state = 336},
  [695] = {.lex_state = 336},
  [696] = {.lex_state = 336},
  [697] = {.lex_state = 336},
  [698] = {.lex_state = 336},
  [699] = {.lex_state = 336},
  [700] = {.lex_state = 336},
  [701] = {.lex_state = 336},
  [702] = {.lex_state = 336},
  [703] = {.lex_state = 336},
  [704] = {.lex_state = 163},
  [705] = {.lex_state = 336},
  [706] = {.lex_state = 336},
  [707] = {.lex_state = 336},
  [708] = {.lex_state = 336},
  [709] = {.lex_state = 336},
  [710] = {.lex_state = 336},
  [711] = {.lex_state = 336},
  [712] = {.lex_state = 336},
  [713] = {.lex_state = 336},
  [714] = {.lex_state = 336},
  [715] = {.lex_state = 336},
  [716] = {.lex_state = 336},
  [717] = {.lex_state = 336},
  [718] = {.lex_state = 336},
  [719] = {.lex_state = 336},
  [720] = {.lex_state = 336},
  [721] = {.lex_state = 336},
  [722] = {.lex_state = 336},
  [723] = {.lex_state = 336},
  [724] = {.lex_state = 336},
  [725] = {.lex_state = 336},
  [726] = {.lex_state = 336},
  [727] = {.lex_state = 336},
  [728] = {.lex_state = 336},
  [729] = {.lex_state = 336},
  [730] = {.lex_state = 336},
  [731] = {.lex_state = 336},
  [732] = {.lex_state = 336},
  [733] = {.lex_state = 336},
  [734] = {.lex_state = 336},
  [735] = {.lex_state = 336},
  [736] = {.lex_state = 336},
  [737] = {.lex_state = 336},
  [738] = {.lex_state = 336},
  [739] = {.lex_state = 336},
  [740] = {.lex_state = 336},
  [741] = {.lex_state = 336},
  [742] = {.lex_state = 336},
  [743] = {.lex_state = 336},
  [744] = {.lex_state = 336},
  [745] = {.lex_state = 336},
  [746] = {.lex_state = 336},
  [747] = {.lex_state = 336},
  [748] = {.lex_state = 336},
  [749] = {.lex_state = 336},
  [750] = {.lex_state = 336},
  [751] = {.lex_state = 336},
  [752] = {.lex_state = 336},
  [753] = {.lex_state = 336},
  [754] = {.lex_state = 336},
  [755] = {.lex_state = 336},
  [756] = {.lex_state = 336},
  [757] = {.lex_state = 336},
  [758] = {.lex_state = 163},
  [759] = {.lex_state = 192},
  [760] = {.lex_state = 237},
  [761] = {.lex_state = 192},
  [762] = {.lex_state = 192},
  [763] = {.lex_state = 237},
  [764] = {.lex_state = 192},
  [765] = {.lex_state = 192},
  [766] = {.lex_state = 192},
  [767] = {.lex_state = 192},
  [768] = {.lex_state = 192},
  [769] = {.lex_state = 237},
  [770] = {.lex_state = 192},
  [771] = {.lex_state = 192},
  [772] = {.lex_state = 192},
  [773] = {.lex_state = 192},
  [774] = {.lex_state = 192},
  [775] = {.lex_state = 192},
  [776] = {.lex_state = 192},
  [777] = {.lex_state = 192},
  [778] = {.lex_state = 192},
  [779] = {.lex_state = 192},
  [780] = {.lex_state = 192},
  [781] = {.lex_state = 192},
  [782] = {.lex_state = 192},
  [783] = {.lex_state = 163},
  [784] = {.lex_state = 163},
  [785] = {.lex_state = 166},
  [786] = {.lex_state = 163},
  [787] = {.lex_state = 163},
  [788] = {.lex_state = 167},
  [789] = {.lex_state = 167},
  [790] = {.lex_state = 174},
  [791] = {.lex_state = 174},
  [792] = {.lex_state = 174},
  [793] = {.lex_state = 336},
  [794] = {.lex_state = 336},
  [795] = {.lex_state = 236},
  [796] = {.lex_state = 236},
  [797] = {.lex_state = 236},
  [798] = {.lex_state = 236},
  [799] = {.lex_state = 236},
  [800] = {.lex_state = 236},
  [801] = {.lex_state = 236},
  [802] = {.lex_state = 236},
  [803] = {.lex_state = 236},
  [804] = {.lex_state = 174},
  [805] = {.lex_state = 174},
  [806] = {.lex_state = 174},
  [807] = {.lex_state = 174},
  [808] = {.lex_state = 174},
  [809] = {.lex_state = 236},
  [810] = {.lex_state = 174},
  [811] = {.lex_state = 174},
  [812] = {.lex_state = 174},
  [813] = {.lex_state = 174},
  [814] = {.lex_state = 236},
  [815] = {.lex_state = 174},
  [816] = {.lex_state = 236},
  [817] = {.lex_state = 174},
  [818] = {.lex_state = 174},
  [819] = {.lex_state = 174},
  [820] = {.lex_state = 174},
  [821] = {.lex_state = 174},
  [822] = {.lex_state = 174},
  [823] = {.lex_state = 236},
  [824] = {.lex_state = 236},
  [825] = {.lex_state = 174},
  [826] = {.lex_state = 174},
  [827] = {.lex_state = 174},
  [828] = {.lex_state = 174},
  [829] = {.lex_state = 174},
  [830] = {.lex_state = 336},
  [831] = {.lex_state = 173},
  [832] = {.lex_state = 171},
  [833] = {.lex_state = 173},
  [834] = {.lex_state = 185},
  [835] = {.lex_state = 171},
  [836] = {.lex_state = 185},
  [837] = {.lex_state = 185},
  [838] = {.lex_state = 174},
  [839] = {.lex_state = 185},
  [840] = {.lex_state = 185},
  [841] = {.lex_state = 171},
  [842] = {.lex_state = 171},
  [843] = {.lex_state = 171},
  [844] = {.lex_state = 171},
  [845] = {.lex_state = 171},
  [846] = {.lex_state = 171},
  [847] = {.lex_state = 171},
  [848] = {.lex_state = 171},
  [849] = {.lex_state = 171},
  [850] = {.lex_state = 171},
  [851] = {.lex_state = 171},
  [852] = {.lex_state = 171},
  [853] = {.lex_state = 171},
  [854] = {.lex_state = 171},
  [855] = {.lex_state = 171},
  [856] = {.lex_state = 171},
  [857] = {.lex_state = 171},
  [858] = {.lex_state = 171},
  [859] = {.lex_state = 171},
  [860] = {.lex_state = 171},
  [861] = {.lex_state = 171},
  [862] = {.lex_state = 173},
  [863] = {.lex_state = 171},
  [864] = {.lex_state = 171},
  [865] = {.lex_state = 171},
  [866] = {.lex_state = 171},
  [867] = {.lex_state = 171},
  [868] = {.lex_state = 171},
  [869] = {.lex_state = 171},
  [870] = {.lex_state = 171},
  [871] = {.lex_state = 171},
  [872] = {.lex_state = 171},
  [873] = {.lex_state = 171},
  [874] = {.lex_state = 171},
  [875] = {.lex_state = 171},
  [876] = {.lex_state = 171},
  [877] = {.lex_state = 171},
  [878] = {.lex_state = 171},
  [879] = {.lex_state = 171},
  [880] = {.lex_state = 171},
  [881] = {.lex_state = 171},
  [882] = {.lex_state = 171},
  [883] = {.lex_state = 171},
  [884] = {.lex_state = 171},
  [885] = {.lex_state = 173},
  [886] = {.lex_state = 171},
  [887] = {.lex_state = 171},
  [888] = {.lex_state = 236},
  [889] = {.lex_state = 185},
  [890] = {.lex_state = 185},
  [891] = {.lex_state = 174},
  [892] = {.lex_state = 174},
  [893] = {.lex_state = 174},
  [894] = {.lex_state = 174},
  [895] = {.lex_state = 185},
  [896] = {.lex_state = 174},
  [897] = {.lex_state = 174},
  [898] = {.lex_state = 174},
  [899] = {.lex_state = 174},
  [900] = {.lex_state = 174},
  [901] = {.lex_state = 174},
  [902] = {.lex_state = 174},
  [903] = {.lex_state = 174},
  [904] = {.lex_state = 185},
  [905] = {.lex_state = 174},
  [906] = {.lex_state = 174},
  [907] = {.lex_state = 181},
  [908] = {.lex_state = 185},
  [909] = {.lex_state = 174},
  [910] = {.lex_state = 174},
  [911] = {.lex_state = 174},
  [912] = {.lex_state = 174},
  [913] = {.lex_state = 174},
  [914] = {.lex_state = 174},
  [915] = {.lex_state = 174},
  [916] = {.lex_state = 174},
  [917] = {.lex_state = 174},
  [918] = {.lex_state = 174},
  [919] = {.lex_state = 174},
  [920] = {.lex_state = 174},
  [921] = {.lex_state = 185},
  [922] = {.lex_state = 185},
  [923] = {.lex_state = 174},
  [924] = {.lex_state = 174},
  [925] = {.lex_state = 174},
  [926] = {.lex_state = 174},
  [927] = {.lex_state = 174},
  [928] = {.lex_state = 174},
  [929] = {.lex_state = 174},
  [930] = {.lex_state = 174},
  [931] = {.lex_state = 174},
  [932] = {.lex_state = 174},
  [933] = {.lex_state = 174},
  [934] = {.lex_state = 185},
  [935] = {.lex_state = 174},
  [936] = {.lex_state = 174},
  [937] = {.lex_state = 174},
  [938] = {.lex_state = 174},
  [939] = {.lex_state = 174},
  [940] = {.lex_state = 174},
  [941] = {.lex_state = 174},
  [942] = {.lex_state = 174},
  [943] = {.lex_state = 174},
  [944] = {.lex_state = 174},
  [945] = {.lex_state = 174},
  [946] = {.lex_state = 174},
  [947] = {.lex_state = 174},
  [948] = {.lex_state = 174},
  [949] = {.lex_state = 174},
  [950] = {.lex_state = 174},
  [951] = {.lex_state = 174},
  [952] = {.lex_state = 174},
  [953] = {.lex_state = 174},
  [954] = {.lex_state = 174},
  [955] = {.lex_state = 174},
  [956] = {.lex_state = 174},
  [957] = {.lex_state = 174},
  [958] = {.lex_state = 174},
  [959] = {.lex_state = 174},
  [960] = {.lex_state = 174},
  [961] = {.lex_state = 174},
  [962] = {.lex_state = 174},
  [963] = {.lex_state = 174},
  [964] = {.lex_state = 174},
  [965] = {.lex_state = 174},
  [966] = {.lex_state = 173},
  [967] = {.lex_state = 173},
  [968] = {.lex_state = 174},
  [969] = {.lex_state = 174},
  [970] = {.lex_state = 174},
  [971] = {.lex_state = 174},
  [972] = {.lex_state = 174},
  [973] = {.lex_state = 174},
  [974] = {.lex_state = 174},
  [975] = {.lex_state = 173},
  [976] = {.lex_state = 174},
  [977] = {.lex_state = 173},
  [978] = {.lex_state = 173},
  [979] = {.lex_state = 173},
  [980] = {.lex_state = 174},
  [981] = {.lex_state = 173},
  [982] = {.lex_state = 174},
  [983] = {.lex_state = 173},
  [984] = {.lex_state = 173},
  [985] = {.lex_state = 174},
  [986] = {.lex_state = 173},
  [987] = {.lex_state = 173},
  [988] = {.lex_state = 173},
  [989] = {.lex_state = 173},
  [990] = {.lex_state = 173},
  [991] = {.lex_state = 173},
  [992] = {.lex_state = 173},
  [993] = {.lex_state = 173},
  [994] = {.lex_state = 173},
  [995] = {.lex_state = 174},
  [996] = {.lex_state = 173},
  [997] = {.lex_state = 174},
  [998] = {.lex_state = 174},
  [999] = {.lex_state = 173},
  [1000] = {.lex_state = 173},
  [1001] = {.lex_state = 173},
  [1002] = {.lex_state = 173},
  [1003] = {.lex_state = 173},
  [1004] = {.lex_state = 173},
  [1005] = {.lex_state = 173},
  [1006] = {.lex_state = 174},
  [1007] = {.lex_state = 174},
  [1008] = {.lex_state = 174},
  [1009] = {.lex_state = 174},
  [1010] = {.lex_state = 174},
  [1011] = {.lex_state = 174},
  [1012] = {.lex_state = 174},
  [1013] = {.lex_state = 174},
  [1014] = {.lex_state = 174},
  [1015] = {.lex_state = 174},
  [1016] = {.lex_state = 174},
  [1017] = {.lex_state = 174},
  [1018] = {.lex_state = 174},
  [1019] = {.lex_state = 174},
  [1020] = {.lex_state = 174},
  [1021] = {.lex_state = 174},
  [1022] = {.lex_state = 174},
  [1023] = {.lex_state = 174},
  [1024] = {.lex_state = 174},
  [1025] = {.lex_state = 174},
  [1026] = {.lex_state = 174},
  [1027] = {.lex_state = 174},
  [1028] = {.lex_state = 174},
  [1029] = {.lex_state = 174},
  [1030] = {.lex_state = 174},
  [1031] = {.lex_state = 174},
  [1032] = {.lex_state = 174},
  [1033] = {.lex_state = 174},
  [1034] = {.lex_state = 174},
  [1035] = {.lex_state = 174},
  [1036] = {.lex_state = 174},
  [1037] = {.lex_state = 174},
  [1038] = {.lex_state = 174},
  [1039] = {.lex_state = 174},
  [1040] = {.lex_state = 174},
  [1041] = {.lex_state = 174},
  [1042] = {.lex_state = 174},
  [1043] = {.lex_state = 174},
  [1044] = {.lex_state = 174},
  [1045] = {.lex_state = 174},
  [1046] = {.lex_state = 174},
  [1047] = {.lex_state = 174},
  [1048] = {.lex_state = 174},
  [1049] = {.lex_state = 174},
  [1050] = {.lex_state = 174},
  [1051] = {.lex_state = 174},
  [1052] = {.lex_state = 174},
  [1053] = {.lex_state = 174},
  [1054] = {.lex_state = 174},
  [1055] = {.lex_state = 174},
  [1056] = {.lex_state = 174},
  [1057] = {.lex_state = 174},
  [1058] = {.lex_state = 174},
  [1059] = {.lex_state = 174},
  [1060] = {.lex_state = 174},
  [1061] = {.lex_state = 174},
  [1062] = {.lex_state = 174},
  [1063] = {.lex_state = 174},
  [1064] = {.lex_state = 174},
  [1065] = {.lex_state = 174},
  [1066] = {.lex_state = 174},
  [1067] = {.lex_state = 174},
  [1068] = {.lex_state = 174},
  [1069] = {.lex_state = 174},
  [1070] = {.lex_state = 174},
  [1071] = {.lex_state = 174},
  [1072] = {.lex_state = 174},
  [1073] = {.lex_state = 174},
  [1074] = {.lex_state = 174},
  [1075] = {.lex_state = 174},
  [1076] = {.lex_state = 174},
  [1077] = {.lex_state = 174},
  [1078] = {.lex_state = 174},
  [1079] = {.lex_state = 174},
  [1080] = {.lex_state = 174},
  [1081] = {.lex_state = 174},
  [1082] = {.lex_state = 174},
  [1083] = {.lex_state = 174},
  [1084] = {.lex_state = 174},
  [1085] = {.lex_state = 174},
  [1086] = {.lex_state = 174},
  [1087] = {.lex_state = 174},
  [1088] = {.lex_state = 174},
  [1089] = {.lex_state = 174},
  [1090] = {.lex_state = 174},
  [1091] = {.lex_state = 174},
  [1092] = {.lex_state = 174},
  [1093] = {.lex_state = 174},
  [1094] = {.lex_state = 174},
  [1095] = {.lex_state = 174},
  [1096] = {.lex_state = 174},
  [1097] = {.lex_state = 174},
  [1098] = {.lex_state = 174},
  [1099] = {.lex_state = 174},
  [1100] = {.lex_state = 174},
  [1101] = {.lex_state = 174},
  [1102] = {.lex_state = 174},
  [1103] = {.lex_state = 174},
  [1104] = {.lex_state = 174},
  [1105] = {.lex_state = 174},
  [1106] = {.lex_state = 174},
  [1107] = {.lex_state = 174},
  [1108] = {.lex_state = 174},
  [1109] = {.lex_state = 174},
  [1110] = {.lex_state = 174},
  [1111] = {.lex_state = 174},
  [1112] = {.lex_state = 174},
  [1113] = {.lex_state = 174},
  [1114] = {.lex_state = 174},
  [1115] = {.lex_state = 174},
  [1116] = {.lex_state = 174},
  [1117] = {.lex_state = 174},
  [1118] = {.lex_state = 174},
  [1119] = {.lex_state = 174},
  [1120] = {.lex_state = 174},
  [1121] = {.lex_state = 174},
  [1122] = {.lex_state = 174},
  [1123] = {.lex_state = 174},
  [1124] = {.lex_state = 174},
  [1125] = {.lex_state = 174},
  [1126] = {.lex_state = 174},
  [1127] = {.lex_state = 174},
  [1128] = {.lex_state = 174},
  [1129] = {.lex_state = 174},
  [1130] = {.lex_state = 174},
  [1131] = {.lex_state = 174},
  [1132] = {.lex_state = 174},
  [1133] = {.lex_state = 174},
  [1134] = {.lex_state = 174},
  [1135] = {.lex_state = 174},
  [1136] = {.lex_state = 174},
  [1137] = {.lex_state = 174},
  [1138] = {.lex_state = 174},
  [1139] = {.lex_state = 174},
  [1140] = {.lex_state = 174},
  [1141] = {.lex_state = 174},
  [1142] = {.lex_state = 174},
  [1143] = {.lex_state = 174},
  [1144] = {.lex_state = 174},
  [1145] = {.lex_state = 174},
  [1146] = {.lex_state = 174},
  [1147] = {.lex_state = 174},
  [1148] = {.lex_state = 174},
  [1149] = {.lex_state = 174},
  [1150] = {.lex_state = 174},
  [1151] = {.lex_state = 174},
  [1152] = {.lex_state = 174},
  [1153] = {.lex_state = 174},
  [1154] = {.lex_state = 174},
  [1155] = {.lex_state = 174},
  [1156] = {.lex_state = 174},
  [1157] = {.lex_state = 174},
  [1158] = {.lex_state = 174},
  [1159] = {.lex_state = 174},
  [1160] = {.lex_state = 174},
  [1161] = {.lex_state = 174},
  [1162] = {.lex_state = 174},
  [1163] = {.lex_state = 174},
  [1164] = {.lex_state = 174},
  [1165] = {.lex_state = 174},
  [1166] = {.lex_state = 174},
  [1167] = {.lex_state = 174},
  [1168] = {.lex_state = 174},
  [1169] = {.lex_state = 174},
  [1170] = {.lex_state = 174},
  [1171] = {.lex_state = 174},
  [1172] = {.lex_state = 174},
  [1173] = {.lex_state = 174},
  [1174] = {.lex_state = 174},
  [1175] = {.lex_state = 174},
  [1176] = {.lex_state = 174},
  [1177] = {.lex_state = 174},
  [1178] = {.lex_state = 174},
  [1179] = {.lex_state = 174},
  [1180] = {.lex_state = 174},
  [1181] = {.lex_state = 174},
  [1182] = {.lex_state = 174},
  [1183] = {.lex_state = 174},
  [1184] = {.lex_state = 174},
  [1185] = {.lex_state = 174},
  [1186] = {.lex_state = 174},
  [1187] = {.lex_state = 174},
  [1188] = {.lex_state = 174},
  [1189] = {.lex_state = 174},
  [1190] = {.lex_state = 174},
  [1191] = {.lex_state = 174},
  [1192] = {.lex_state = 174},
  [1193] = {.lex_state = 174},
  [1194] = {.lex_state = 174},
  [1195] = {.lex_state = 174},
  [1196] = {.lex_state = 174},
  [1197] = {.lex_state = 174},
  [1198] = {.lex_state = 174},
  [1199] = {.lex_state = 174},
  [1200] = {.lex_state = 174},
  [1201] = {.lex_state = 174},
  [1202] = {.lex_state = 174},
  [1203] = {.lex_state = 174},
  [1204] = {.lex_state = 174},
  [1205] = {.lex_state = 174},
  [1206] = {.lex_state = 174},
  [1207] = {.lex_state = 174},
  [1208] = {.lex_state = 174},
  [1209] = {.lex_state = 174},
  [1210] = {.lex_state = 174},
  [1211] = {.lex_state = 174},
  [1212] = {.lex_state = 174},
  [1213] = {.lex_state = 174},
  [1214] = {.lex_state = 174},
  [1215] = {.lex_state = 174},
  [1216] = {.lex_state = 174},
  [1217] = {.lex_state = 174},
  [1218] = {.lex_state = 174},
  [1219] = {.lex_state = 174},
  [1220] = {.lex_state = 174},
  [1221] = {.lex_state = 174},
  [1222] = {.lex_state = 174},
  [1223] = {.lex_state = 174},
  [1224] = {.lex_state = 174},
  [1225] = {.lex_state = 174},
  [1226] = {.lex_state = 174},
  [1227] = {.lex_state = 174},
  [1228] = {.lex_state = 174},
  [1229] = {.lex_state = 174},
  [1230] = {.lex_state = 174},
  [1231] = {.lex_state = 174},
  [1232] = {.lex_state = 174},
  [1233] = {.lex_state = 174},
  [1234] = {.lex_state = 174},
  [1235] = {.lex_state = 174},
  [1236] = {.lex_state = 174},
  [1237] = {.lex_state = 174},
  [1238] = {.lex_state = 174},
  [1239] = {.lex_state = 174},
  [1240] = {.lex_state = 174},
  [1241] = {.lex_state = 174},
  [1242] = {.lex_state = 174},
  [1243] = {.lex_state = 174},
  [1244] = {.lex_state = 174},
  [1245] = {.lex_state = 174},
  [1246] = {.lex_state = 174},
  [1247] = {.lex_state = 174},
  [1248] = {.lex_state = 174},
  [1249] = {.lex_state = 174},
  [1250] = {.lex_state = 174},
  [1251] = {.lex_state = 174},
  [1252] = {.lex_state = 174},
  [1253] = {.lex_state = 174},
  [1254] = {.lex_state = 174},
  [1255] = {.lex_state = 174},
  [1256] = {.lex_state = 174},
  [1257] = {.lex_state = 174},
  [1258] = {.lex_state = 174},
  [1259] = {.lex_state = 174},
  [1260] = {.lex_state = 174},
  [1261] = {.lex_state = 174},
  [1262] = {.lex_state = 174},
  [1263] = {.lex_state = 174},
  [1264] = {.lex_state = 174},
  [1265] = {.lex_state = 174},
  [1266] = {.lex_state = 174},
  [1267] = {.lex_state = 174},
  [1268] = {.lex_state = 174},
  [1269] = {.lex_state = 174},
  [1270] = {.lex_state = 174},
  [1271] = {.lex_state = 174},
  [1272] = {.lex_state = 174},
  [1273] = {.lex_state = 174},
  [1274] = {.lex_state = 174},
  [1275] = {.lex_state = 174},
  [1276] = {.lex_state = 174},
  [1277] = {.lex_state = 174},
  [1278] = {.lex_state = 174},
  [1279] = {.lex_state = 174},
  [1280] = {.lex_state = 174},
  [1281] = {.lex_state = 174},
  [1282] = {.lex_state = 174},
  [1283] = {.lex_state = 174},
  [1284] = {.lex_state = 174},
  [1285] = {.lex_state = 174},
  [1286] = {.lex_state = 174},
  [1287] = {.lex_state = 174},
  [1288] = {.lex_state = 174},
  [1289] = {.lex_state = 174},
  [1290] = {.lex_state = 174},
  [1291] = {.lex_state = 174},
  [1292] = {.lex_state = 174},
  [1293] = {.lex_state = 174},
  [1294] = {.lex_state = 174},
  [1295] = {.lex_state = 174},
  [1296] = {.lex_state = 174},
  [1297] = {.lex_state = 174},
  [1298] = {.lex_state = 174},
  [1299] = {.lex_state = 174},
  [1300] = {.lex_state = 174},
  [1301] = {.lex_state = 174},
  [1302] = {.lex_state = 174},
  [1303] = {.lex_state = 174},
  [1304] = {.lex_state = 174},
  [1305] = {.lex_state = 174},
  [1306] = {.lex_state = 174},
  [1307] = {.lex_state = 174},
  [1308] = {.lex_state = 174},
  [1309] = {.lex_state = 174},
  [1310] = {.lex_state = 174},
  [1311] = {.lex_state = 174},
  [1312] = {.lex_state = 174},
  [1313] = {.lex_state = 174},
  [1314] = {.lex_state = 174},
  [1315] = {.lex_state = 174},
  [1316] = {.lex_state = 174},
  [1317] = {.lex_state = 174},
  [1318] = {.lex_state = 174},
  [1319] = {.lex_state = 174},
  [1320] = {.lex_state = 174},
  [1321] = {.lex_state = 174},
  [1322] = {.lex_state = 174},
  [1323] = {.lex_state = 174},
  [1324] = {.lex_state = 174},
  [1325] = {.lex_state = 174},
  [1326] = {.lex_state = 174},
  [1327] = {.lex_state = 174},
  [1328] = {.lex_state = 174},
  [1329] = {.lex_state = 174},
  [1330] = {.lex_state = 174},
  [1331] = {.lex_state = 174},
  [1332] = {.lex_state = 174},
  [1333] = {.lex_state = 174},
  [1334] = {.lex_state = 174},
  [1335] = {.lex_state = 174},
  [1336] = {.lex_state = 174},
  [1337] = {.lex_state = 174},
  [1338] = {.lex_state = 174},
  [1339] = {.lex_state = 174},
  [1340] = {.lex_state = 174},
  [1341] = {.lex_state = 174},
  [1342] = {.lex_state = 174},
  [1343] = {.lex_state = 174},
  [1344] = {.lex_state = 174},
  [1345] = {.lex_state = 174},
  [1346] = {.lex_state = 174},
  [1347] = {.lex_state = 174},
  [1348] = {.lex_state = 174},
  [1349] = {.lex_state = 174},
  [1350] = {.lex_state = 174},
  [1351] = {.lex_state = 174},
  [1352] = {.lex_state = 174},
  [1353] = {.lex_state = 174},
  [1354] = {.lex_state = 174},
  [1355] = {.lex_state = 174},
  [1356] = {.lex_state = 174},
  [1357] = {.lex_state = 174},
  [1358] = {.lex_state = 174},
  [1359] = {.lex_state = 174},
  [1360] = {.lex_state = 174},
  [1361] = {.lex_state = 174},
  [1362] = {.lex_state = 174},
  [1363] = {.lex_state = 174},
  [1364] = {.lex_state = 174},
  [1365] = {.lex_state = 174},
  [1366] = {.lex_state = 174},
  [1367] = {.lex_state = 174},
  [1368] = {.lex_state = 174},
  [1369] = {.lex_state = 174},
  [1370] = {.lex_state = 174},
  [1371] = {.lex_state = 174},
  [1372] = {.lex_state = 174},
  [1373] = {.lex_state = 174},
  [1374] = {.lex_state = 174},
  [1375] = {.lex_state = 174},
  [1376] = {.lex_state = 174},
  [1377] = {.lex_state = 174},
  [1378] = {.lex_state = 174},
  [1379] = {.lex_state = 174},
  [1380] = {.lex_state = 174},
  [1381] = {.lex_state = 174},
  [1382] = {.lex_state = 174},
  [1383] = {.lex_state = 174},
  [1384] = {.lex_state = 174},
  [1385] = {.lex_state = 174},
  [1386] = {.lex_state = 174},
  [1387] = {.lex_state = 174},
  [1388] = {.lex_state = 174},
  [1389] = {.lex_state = 174},
  [1390] = {.lex_state = 174},
  [1391] = {.lex_state = 174},
  [1392] = {.lex_state = 174},
  [1393] = {.lex_state = 174},
  [1394] = {.lex_state = 174},
  [1395] = {.lex_state = 174},
  [1396] = {.lex_state = 174},
  [1397] = {.lex_state = 174},
  [1398] = {.lex_state = 174},
  [1399] = {.lex_state = 174},
  [1400] = {.lex_state = 174},
  [1401] = {.lex_state = 174},
  [1402] = {.lex_state = 174},
  [1403] = {.lex_state = 174},
  [1404] = {.lex_state = 174},
  [1405] = {.lex_state = 174},
  [1406] = {.lex_state = 174},
  [1407] = {.lex_state = 174},
  [1408] = {.lex_state = 174},
  [1409] = {.lex_state = 174},
  [1410] = {.lex_state = 174},
  [1411] = {.lex_state = 174},
  [1412] = {.lex_state = 174},
  [1413] = {.lex_state = 174},
  [1414] = {.lex_state = 174},
  [1415] = {.lex_state = 174},
  [1416] = {.lex_state = 174},
  [1417] = {.lex_state = 174},
  [1418] = {.lex_state = 174},
  [1419] = {.lex_state = 174},
  [1420] = {.lex_state = 174},
  [1421] = {.lex_state = 174},
  [1422] = {.lex_state = 174},
  [1423] = {.lex_state = 174},
  [1424] = {.lex_state = 174},
  [1425] = {.lex_state = 174},
  [1426] = {.lex_state = 174},
  [1427] = {.lex_state = 174},
  [1428] = {.lex_state = 174},
  [1429] = {.lex_state = 174},
  [1430] = {.lex_state = 174},
  [1431] = {.lex_state = 174},
  [1432] = {.lex_state = 174},
  [1433] = {.lex_state = 174},
  [1434] = {.lex_state = 174},
  [1435] = {.lex_state = 174},
  [1436] = {.lex_state = 174},
  [1437] = {.lex_state = 174},
  [1438] = {.lex_state = 174},
  [1439] = {.lex_state = 174},
  [1440] = {.lex_state = 174},
  [1441] = {.lex_state = 174},
  [1442] = {.lex_state = 174},
  [1443] = {.lex_state = 174},
  [1444] = {.lex_state = 174},
  [1445] = {.lex_state = 174},
  [1446] = {.lex_state = 174},
  [1447] = {.lex_state = 174},
  [1448] = {.lex_state = 174},
  [1449] = {.lex_state = 174},
  [1450] = {.lex_state = 174},
  [1451] = {.lex_state = 174},
  [1452] = {.lex_state = 174},
  [1453] = {.lex_state = 174},
  [1454] = {.lex_state = 174},
  [1455] = {.lex_state = 174},
  [1456] = {.lex_state = 174},
  [1457] = {.lex_state = 174},
  [1458] = {.lex_state = 174},
  [1459] = {.lex_state = 174},
  [1460] = {.lex_state = 174},
  [1461] = {.lex_state = 174},
  [1462] = {.lex_state = 174},
  [1463] = {.lex_state = 174},
  [1464] = {.lex_state = 174},
  [1465] = {.lex_state = 174},
  [1466] = {.lex_state = 174},
  [1467] = {.lex_state = 174},
  [1468] = {.lex_state = 174},
  [1469] = {.lex_state = 174},
  [1470] = {.lex_state = 174},
  [1471] = {.lex_state = 174},
  [1472] = {.lex_state = 174},
  [1473] = {.lex_state = 174},
  [1474] = {.lex_state = 174},
  [1475] = {.lex_state = 174},
  [1476] = {.lex_state = 174},
  [1477] = {.lex_state = 174},
  [1478] = {.lex_state = 174},
  [1479] = {.lex_state = 174},
  [1480] = {.lex_state = 174},
  [1481] = {.lex_state = 174},
  [1482] = {.lex_state = 174},
  [1483] = {.lex_state = 174},
  [1484] = {.lex_state = 174},
  [1485] = {.lex_state = 174},
  [1486] = {.lex_state = 174},
  [1487] = {.lex_state = 174},
  [1488] = {.lex_state = 174},
  [1489] = {.lex_state = 174},
  [1490] = {.lex_state = 174},
  [1491] = {.lex_state = 174},
  [1492] = {.lex_state = 174},
  [1493] = {.lex_state = 174},
  [1494] = {.lex_state = 174},
  [1495] = {.lex_state = 174},
  [1496] = {.lex_state = 174},
  [1497] = {.lex_state = 174},
  [1498] = {.lex_state = 174},
  [1499] = {.lex_state = 174},
  [1500] = {.lex_state = 193},
  [1501] = {.lex_state = 193},
  [1502] = {.lex_state = 193},
  [1503] = {.lex_state = 193},
  [1504] = {.lex_state = 193},
  [1505] = {.lex_state = 193},
  [1506] = {.lex_state = 193},
  [1507] = {.lex_state = 193},
  [1508] = {.lex_state = 193},
  [1509] = {.lex_state = 236},
  [1510] = {.lex_state = 236},
  [1511] = {.lex_state = 171},
  [1512] = {.lex_state = 171},
  [1513] = {.lex_state = 171},
  [1514] = {.lex_state = 236},
  [1515] = {.lex_state = 193},
  [1516] = {.lex_state = 236},
  [1517] = {.lex_state = 236},
  [1518] = {.lex_state = 236},
  [1519] = {.lex_state = 193},
  [1520] = {.lex_state = 191},
  [1521] = {.lex_state = 193},
  [1522] = {.lex_state = 222},
  [1523] = {.lex_state = 191},
  [1524] = {.lex_state = 191},
  [1525] = {.lex_state = 222},
  [1526] = {.lex_state = 222},
  [1527] = {.lex_state = 222},
  [1528] = {.lex_state = 222},
  [1529] = {.lex_state = 191},
  [1530] = {.lex_state = 191},
  [1531] = {.lex_state = 191},
  [1532] = {.lex_state = 222},
  [1533] = {.lex_state = 181},
  [1534] = {.lex_state = 191},
  [1535] = {.lex_state = 191},
  [1536] = {.lex_state = 191},
  [1537] = {.lex_state = 222},
  [1538] = {.lex_state = 193},
  [1539] = {.lex_state = 182},
  [1540] = {.lex_state = 196},
  [1541] = {.lex_state = 186},
  [1542] = {.lex_state = 176},
  [1543] = {.lex_state = 191},
  [1544] = {.lex_state = 196},
  [1545] = {.lex_state = 191},
  [1546] = {.lex_state = 191},
  [1547] = {.lex_state = 191},
  [1548] = {.lex_state = 191},
  [1549] = {.lex_state = 191},
  [1550] = {.lex_state = 191},
  [1551] = {.lex_state = 191},
  [1552] = {.lex_state = 196},
  [1553] = {.lex_state = 196},
  [1554] = {.lex_state = 196},
  [1555] = {.lex_state = 196},
  [1556] = {.lex_state = 196},
  [1557] = {.lex_state = 196},
  [1558] = {.lex_state = 194},
  [1559] = {.lex_state = 194},
  [1560] = {.lex_state = 194},
  [1561] = {.lex_state = 194},
  [1562] = {.lex_state = 194},
  [1563] = {.lex_state = 194},
  [1564] = {.lex_state = 194},
  [1565] = {.lex_state = 222},
  [1566] = {.lex_state = 196},
  [1567] = {.lex_state = 196},
  [1568] = {.lex_state = 209},
  [1569] = {.lex_state = 209},
  [1570] = {.lex_state = 236},
  [1571] = {.lex_state = 209},
  [1572] = {.lex_state = 217},
  [1573] = {.lex_state = 217},
  [1574] = {.lex_state = 236},
  [1575] = {.lex_state = 217},
  [1576] = {.lex_state = 236},
  [1577] = {.lex_state = 236},
  [1578] = {.lex_state = 236},
  [1579] = {.lex_state = 209},
  [1580] = {.lex_state = 236},
  [1581] = {.lex_state = 236},
  [1582] = {.lex_state = 236},
  [1583] = {.lex_state = 236},
  [1584] = {.lex_state = 236},
  [1585] = {.lex_state = 236},
  [1586] = {.lex_state = 236},
  [1587] = {.lex_state = 236},
  [1588] = {.lex_state = 236},
  [1589] = {.lex_state = 236},
  [1590] = {.lex_state = 236},
  [1591] = {.lex_state = 236},
  [1592] = {.lex_state = 236},
  [1593] = {.lex_state = 236},
  [1594] = {.lex_state = 236},
  [1595] = {.lex_state = 236},
  [1596] = {.lex_state = 236},
  [1597] = {.lex_state = 236},
  [1598] = {.lex_state = 236},
  [1599] = {.lex_state = 236},
  [1600] = {.lex_state = 236},
  [1601] = {.lex_state = 236},
  [1602] = {.lex_state = 236},
  [1603] = {.lex_state = 236},
  [1604] = {.lex_state = 236},
  [1605] = {.lex_state = 236},
  [1606] = {.lex_state = 236},
  [1607] = {.lex_state = 236},
  [1608] = {.lex_state = 209},
  [1609] = {.lex_state = 236},
  [1610] = {.lex_state = 209},
  [1611] = {.lex_state = 209},
  [1612] = {.lex_state = 236},
  [1613] = {.lex_state = 209},
  [1614] = {.lex_state = 209},
  [1615] = {.lex_state = 217},
  [1616] = {.lex_state = 209},
  [1617] = {.lex_state = 202},
  [1618] = {.lex_state = 217},
  [1619] = {.lex_state = 236},
  [1620] = {.lex_state = 217},
  [1621] = {.lex_state = 236},
  [1622] = {.lex_state = 236},
  [1623] = {.lex_state = 222},
  [1624] = {.lex_state = 217},
  [1625] = {.lex_state = 236},
  [1626] = {.lex_state = 206},
  [1627] = {.lex_state = 206},
  [1628] = {.lex_state = 202},
  [1629] = {.lex_state = 206},
  [1630] = {.lex_state = 206},
  [1631] = {.lex_state = 222},
  [1632] = {.lex_state = 206},
  [1633] = {.lex_state = 209},
  [1634] = {.lex_state = 206},
  [1635] = {.lex_state = 206},
  [1636] = {.lex_state = 176},
  [1637] = {.lex_state = 236},
  [1638] = {.lex_state = 209},
  [1639] = {.lex_state = 213},
  [1640] = {.lex_state = 236},
  [1641] = {.lex_state = 213},
  [1642] = {.lex_state = 213},
  [1643] = {.lex_state = 236},
  [1644] = {.lex_state = 171},
  [1645] = {.lex_state = 202},
  [1646] = {.lex_state = 178},
  [1647] = {.lex_state = 236},
  [1648] = {.lex_state = 178},
  [1649] = {.lex_state = 171},
  [1650] = {.lex_state = 209},
  [1651] = {.lex_state = 202},
  [1652] = {.lex_state = 213},
  [1653] = {.lex_state = 213},
  [1654] = {.lex_state = 209},
  [1655] = {.lex_state = 213},
  [1656] = {.lex_state = 178},
  [1657] = {.lex_state = 236},
  [1658] = {.lex_state = 213},
  [1659] = {.lex_state = 236},
  [1660] = {.lex_state = 236},
  [1661] = {.lex_state = 236},
  [1662] = {.lex_state = 174},
  [1663] = {.lex_state = 236},
  [1664] = {.lex_state = 236},
  [1665] = {.lex_state = 236},
  [1666] = {.lex_state = 236},
  [1667] = {.lex_state = 236},
  [1668] = {.lex_state = 191},
  [1669] = {.lex_state = 236},
  [1670] = {.lex_state = 236},
  [1671] = {.lex_state = 191},
  [1672] = {.lex_state = 236},
  [1673] = {.lex_state = 236},
  [1674] = {.lex_state = 236},
  [1675] = {.lex_state = 236},
  [1676] = {.lex_state = 236},
  [1677] = {.lex_state = 236},
  [1678] = {.lex_state = 236},
  [1679] = {.lex_state = 236},
  [1680] = {.lex_state = 236},
  [1681] = {.lex_state = 236},
  [1682] = {.lex_state = 236},
  [1683] = {.lex_state = 236},
  [1684] = {.lex_state = 236},
  [1685] = {.lex_state = 236},
  [1686] = {.lex_state = 236},
  [1687] = {.lex_state = 236},
  [1688] = {.lex_state = 222},
  [1689] = {.lex_state = 236},
  [1690] = {.lex_state = 236},
  [1691] = {.lex_state = 236},
  [1692] = {.lex_state = 236},
  [1693] = {.lex_state = 236},
  [1694] = {.lex_state = 236},
  [1695] = {.lex_state = 236},
  [1696] = {.lex_state = 236},
  [1697] = {.lex_state = 236},
  [1698] = {.lex_state = 236},
  [1699] = {.lex_state = 236},
  [1700] = {.lex_state = 236},
  [1701] = {.lex_state = 236},
  [1702] = {.lex_state = 236},
  [1703] = {.lex_state = 236},
  [1704] = {.lex_state = 223},
  [1705] = {.lex_state = 236},
  [1706] = {.lex_state = 223},
  [1707] = {.lex_state = 223},
  [1708] = {.lex_state = 236},
  [1709] = {.lex_state = 223},
  [1710] = {.lex_state = 222},
  [1711] = {.lex_state = 236},
  [1712] = {.lex_state = 236},
  [1713] = {.lex_state = 236},
  [1714] = {.lex_state = 236},
  [1715] = {.lex_state = 236},
  [1716] = {.lex_state = 236},
  [1717] = {.lex_state = 236},
  [1718] = {.lex_state = 236},
  [1719] = {.lex_state = 223},
  [1720] = {.lex_state = 236},
  [1721] = {.lex_state = 222},
  [1722] = {.lex_state = 236},
  [1723] = {.lex_state = 236},
  [1724] = {.lex_state = 197},
  [1725] = {.lex_state = 236},
  [1726] = {.lex_state = 236},
  [1727] = {.lex_state = 236},
  [1728] = {.lex_state = 178},
  [1729] = {.lex_state = 236},
  [1730] = {.lex_state = 236},
  [1731] = {.lex_state = 236},
  [1732] = {.lex_state = 222},
  [1733] = {.lex_state = 202},
  [1734] = {.lex_state = 236},
  [1735] = {.lex_state = 178},
  [1736] = {.lex_state = 223},
  [1737] = {.lex_state = 236},
  [1738] = {.lex_state = 222},
  [1739] = {.lex_state = 222},
  [1740] = {.lex_state = 223},
  [1741] = {.lex_state = 222},
  [1742] = {.lex_state = 236},
  [1743] = {.lex_state = 222},
  [1744] = {.lex_state = 236},
  [1745] = {.lex_state = 236},
  [1746] = {.lex_state = 236},
  [1747] = {.lex_state = 236},
  [1748] = {.lex_state = 222},
  [1749] = {.lex_state = 236},
  [1750] = {.lex_state = 236},
  [1751] = {.lex_state = 236},
  [1752] = {.lex_state = 236},
  [1753] = {.lex_state = 236},
  [1754] = {.lex_state = 222},
  [1755] = {.lex_state = 223},
  [1756] = {.lex_state = 236},
  [1757] = {.lex_state = 236},
  [1758] = {.lex_state = 236},
  [1759] = {.lex_state = 236},
  [1760] = {.lex_state = 236},
  [1761] = {.lex_state = 236},
  [1762] = {.lex_state = 223},
  [1763] = {.lex_state = 236},
  [1764] = {.lex_state = 236},
  [1765] = {.lex_state = 223},
  [1766] = {.lex_state = 223},
  [1767] = {.lex_state = 236},
  [1768] = {.lex_state = 223},
  [1769] = {.lex_state = 178},
  [1770] = {.lex_state = 206},
  [1771] = {.lex_state = 236},
  [1772] = {.lex_state = 178},
  [1773] = {.lex_state = 236},
  [1774] = {.lex_state = 236},
  [1775] = {.lex_state = 236},
  [1776] = {.lex_state = 236},
  [1777] = {.lex_state = 236},
  [1778] = {.lex_state = 236},
  [1779] = {.lex_state = 236},
  [1780] = {.lex_state = 236},
  [1781] = {.lex_state = 236},
  [1782] = {.lex_state = 236},
  [1783] = {.lex_state = 222},
  [1784] = {.lex_state = 236},
  [1785] = {.lex_state = 236},
  [1786] = {.lex_state = 236},
  [1787] = {.lex_state = 223},
  [1788] = {.lex_state = 236},
  [1789] = {.lex_state = 236},
  [1790] = {.lex_state = 236},
  [1791] = {.lex_state = 236},
  [1792] = {.lex_state = 236},
  [1793] = {.lex_state = 236},
  [1794] = {.lex_state = 236},
  [1795] = {.lex_state = 236},
  [1796] = {.lex_state = 202},
  [1797] = {.lex_state = 202},
  [1798] = {.lex_state = 202},
  [1799] = {.lex_state = 202},
  [1800] = {.lex_state = 202},
  [1801] = {.lex_state = 202},
  [1802] = {.lex_state = 202},
  [1803] = {.lex_state = 202},
  [1804] = {.lex_state = 202},
  [1805] = {.lex_state = 202},
  [1806] = {.lex_state = 202},
  [1807] = {.lex_state = 202},
  [1808] = {.lex_state = 202},
  [1809] = {.lex_state = 202},
  [1810] = {.lex_state = 202},
  [1811] = {.lex_state = 176},
  [1812] = {.lex_state = 202},
  [1813] = {.lex_state = 174},
  [1814] = {.lex_state = 202},
  [1815] = {.lex_state = 202},
  [1816] = {.lex_state = 202},
  [1817] = {.lex_state = 202},
  [1818] = {.lex_state = 237},
  [1819] = {.lex_state = 202},
  [1820] = {.lex_state = 192},
  [1821] = {.lex_state = 202},
  [1822] = {.lex_state = 202},
  [1823] = {.lex_state = 202},
  [1824] = {.lex_state = 202},
  [1825] = {.lex_state = 237},
  [1826] = {.lex_state = 202},
  [1827] = {.lex_state = 202},
  [1828] = {.lex_state = 192},
  [1829] = {.lex_state = 201},
  [1830] = {.lex_state = 237},
  [1831] = {.lex_state = 213},
  [1832] = {.lex_state = 174},
  [1833] = {.lex_state = 237},
  [1834] = {.lex_state = 236},
  [1835] = {.lex_state = 192},
  [1836] = {.lex_state = 202},
  [1837] = {.lex_state = 202},
  [1838] = {.lex_state = 202},
  [1839] = {.lex_state = 202},
  [1840] = {.lex_state = 202},
  [1841] = {.lex_state = 202},
  [1842] = {.lex_state = 202},
  [1843] = {.lex_state = 192},
  [1844] = {.lex_state = 202},
  [1845] = {.lex_state = 202},
  [1846] = {.lex_state = 202},
  [1847] = {.lex_state = 202},
  [1848] = {.lex_state = 202},
  [1849] = {.lex_state = 202},
  [1850] = {.lex_state = 206},
  [1851] = {.lex_state = 202},
  [1852] = {.lex_state = 202},
  [1853] = {.lex_state = 197},
  [1854] = {.lex_state = 235},
  [1855] = {.lex_state = 197},
  [1856] = {.lex_state = 197},
  [1857] = {.lex_state = 194},
  [1858] = {.lex_state = 203},
  [1859] = {.lex_state = 194},
  [1860] = {.lex_state = 203},
  [1861] = {.lex_state = 194},
  [1862] = {.lex_state = 213},
  [1863] = {.lex_state = 235},
  [1864] = {.lex_state = 197},
  [1865] = {.lex_state = 236},
  [1866] = {.lex_state = 237},
  [1867] = {.lex_state = 203},
  [1868] = {.lex_state = 236},
  [1869] = {.lex_state = 203},
  [1870] = {.lex_state = 203},
  [1871] = {.lex_state = 192},
  [1872] = {.lex_state = 203},
  [1873] = {.lex_state = 203},
  [1874] = {.lex_state = 194},
  [1875] = {.lex_state = 237},
  [1876] = {.lex_state = 237},
  [1877] = {.lex_state = 236},
  [1878] = {.lex_state = 192},
  [1879] = {.lex_state = 194},
  [1880] = {.lex_state = 203},
  [1881] = {.lex_state = 236},
  [1882] = {.lex_state = 227},
  [1883] = {.lex_state = 194},
  [1884] = {.lex_state = 203},
  [1885] = {.lex_state = 194},
  [1886] = {.lex_state = 237},
  [1887] = {.lex_state = 203},
  [1888] = {.lex_state = 236},
  [1889] = {.lex_state = 192},
  [1890] = {.lex_state = 203},
  [1891] = {.lex_state = 236},
  [1892] = {.lex_state = 192},
  [1893] = {.lex_state = 203},
  [1894] = {.lex_state = 236},
  [1895] = {.lex_state = 194},
  [1896] = {.lex_state = 203},
  [1897] = {.lex_state = 203},
  [1898] = {.lex_state = 192},
  [1899] = {.lex_state = 236},
  [1900] = {.lex_state = 178},
  [1901] = {.lex_state = 203},
  [1902] = {.lex_state = 236},
  [1903] = {.lex_state = 237},
  [1904] = {.lex_state = 194},
  [1905] = {.lex_state = 237},
  [1906] = {.lex_state = 237},
  [1907] = {.lex_state = 237},
  [1908] = {.lex_state = 237},
  [1909] = {.lex_state = 237},
  [1910] = {.lex_state = 237},
  [1911] = {.lex_state = 237},
  [1912] = {.lex_state = 237},
  [1913] = {.lex_state = 237},
  [1914] = {.lex_state = 237},
  [1915] = {.lex_state = 235},
  [1916] = {.lex_state = 237},
  [1917] = {.lex_state = 237},
  [1918] = {.lex_state = 237},
  [1919] = {.lex_state = 237},
  [1920] = {.lex_state = 237},
  [1921] = {.lex_state = 237},
  [1922] = {.lex_state = 237},
  [1923] = {.lex_state = 237},
  [1924] = {.lex_state = 237},
  [1925] = {.lex_state = 237},
  [1926] = {.lex_state = 237},
  [1927] = {.lex_state = 237},
  [1928] = {.lex_state = 237},
  [1929] = {.lex_state = 237},
  [1930] = {.lex_state = 237},
  [1931] = {.lex_state = 192},
  [1932] = {.lex_state = 237},
  [1933] = {.lex_state = 237},
  [1934] = {.lex_state = 192},
  [1935] = {.lex_state = 237},
  [1936] = {.lex_state = 237},
  [1937] = {.lex_state = 237},
  [1938] = {.lex_state = 237},
  [1939] = {.lex_state = 237},
  [1940] = {.lex_state = 237},
  [1941] = {.lex_state = 192},
  [1942] = {.lex_state = 192},
  [1943] = {.lex_state = 237},
  [1944] = {.lex_state = 237},
  [1945] = {.lex_state = 237},
  [1946] = {.lex_state = 197},
  [1947] = {.lex_state = 185},
  [1948] = {.lex_state = 237},
  [1949] = {.lex_state = 178},
  [1950] = {.lex_state = 192},
  [1951] = {.lex_state = 192},
  [1952] = {.lex_state = 178},
  [1953] = {.lex_state = 178},
  [1954] = {.lex_state = 237},
  [1955] = {.lex_state = 235},
  [1956] = {.lex_state = 178},
  [1957] = {.lex_state = 237},
  [1958] = {.lex_state = 237},
  [1959] = {.lex_state = 237},
  [1960] = {.lex_state = 237},
  [1961] = {.lex_state = 237},
  [1962] = {.lex_state = 197},
  [1963] = {.lex_state = 192},
  [1964] = {.lex_state = 176},
  [1965] = {.lex_state = 194},
  [1966] = {.lex_state = 192},
  [1967] = {.lex_state = 202},
  [1968] = {.lex_state = 192},
  [1969] = {.lex_state = 192},
  [1970] = {.lex_state = 192},
  [1971] = {.lex_state = 192},
  [1972] = {.lex_state = 192},
  [1973] = {.lex_state = 192},
  [1974] = {.lex_state = 192},
  [1975] = {.lex_state = 192},
  [1976] = {.lex_state = 197},
  [1977] = {.lex_state = 192},
  [1978] = {.lex_state = 236},
  [1979] = {.lex_state = 176},
  [1980] = {.lex_state = 192},
  [1981] = {.lex_state = 192},
  [1982] = {.lex_state = 192},
  [1983] = {.lex_state = 192},
  [1984] = {.lex_state = 192},
  [1985] = {.lex_state = 192},
  [1986] = {.lex_state = 192},
  [1987] = {.lex_state = 192},
  [1988] = {.lex_state = 192},
  [1989] = {.lex_state = 192},
  [1990] = {.lex_state = 192},
  [1991] = {.lex_state = 192},
  [1992] = {.lex_state = 192},
  [1993] = {.lex_state = 192},
  [1994] = {.lex_state = 192},
  [1995] = {.lex_state = 192},
  [1996] = {.lex_state = 192},
  [1997] = {.lex_state = 201},
  [1998] = {.lex_state = 201},
  [1999] = {.lex_state = 192},
  [2000] = {.lex_state = 176},
  [2001] = {.lex_state = 192},
  [2002] = {.lex_state = 192},
  [2003] = {.lex_state = 192},
  [2004] = {.lex_state = 192},
  [2005] = {.lex_state = 192},
  [2006] = {.lex_state = 238},
  [2007] = {.lex_state = 192},
  [2008] = {.lex_state = 236},
  [2009] = {.lex_state = 192},
  [2010] = {.lex_state = 192},
  [2011] = {.lex_state = 192},
  [2012] = {.lex_state = 192},
  [2013] = {.lex_state = 192},
  [2014] = {.lex_state = 192},
  [2015] = {.lex_state = 192},
  [2016] = {.lex_state = 192},
  [2017] = {.lex_state = 192},
  [2018] = {.lex_state = 192},
  [2019] = {.lex_state = 192},
  [2020] = {.lex_state = 202},
  [2021] = {.lex_state = 192},
  [2022] = {.lex_state = 192},
  [2023] = {.lex_state = 192},
  [2024] = {.lex_state = 237},
  [2025] = {.lex_state = 192},
  [2026] = {.lex_state = 192},
  [2027] = {.lex_state = 237},
  [2028] = {.lex_state = 192},
  [2029] = {.lex_state = 192},
  [2030] = {.lex_state = 192},
  [2031] = {.lex_state = 192},
  [2032] = {.lex_state = 192},
  [2033] = {.lex_state = 236},
  [2034] = {.lex_state = 238},
  [2035] = {.lex_state = 192},
  [2036] = {.lex_state = 192},
  [2037] = {.lex_state = 192},
  [2038] = {.lex_state = 192},
  [2039] = {.lex_state = 181},
  [2040] = {.lex_state = 181},
  [2041] = {.lex_state = 192},
  [2042] = {.lex_state = 192},
  [2043] = {.lex_state = 192},
  [2044] = {.lex_state = 203},
  [2045] = {.lex_state = 236},
  [2046] = {.lex_state = 237},
  [2047] = {.lex_state = 237},
  [2048] = {.lex_state = 237},
  [2049] = {.lex_state = 237},
  [2050] = {.lex_state = 237},
  [2051] = {.lex_state = 237},
  [2052] = {.lex_state = 237},
  [2053] = {.lex_state = 237},
  [2054] = {.lex_state = 192},
  [2055] = {.lex_state = 236},
  [2056] = {.lex_state = 176},
  [2057] = {.lex_state = 192},
  [2058] = {.lex_state = 192},
  [2059] = {.lex_state = 192},
  [2060] = {.lex_state = 192},
  [2061] = {.lex_state = 192},
  [2062] = {.lex_state = 192},
  [2063] = {.lex_state = 192},
  [2064] = {.lex_state = 192},
  [2065] = {.lex_state = 192},
  [2066] = {.lex_state = 192},
  [2067] = {.lex_state = 192},
  [2068] = {.lex_state = 192},
  [2069] = {.lex_state = 192},
  [2070] = {.lex_state = 192},
  [2071] = {.lex_state = 237},
  [2072] = {.lex_state = 237},
  [2073] = {.lex_state = 237},
  [2074] = {.lex_state = 192},
  [2075] = {.lex_state = 192},
  [2076] = {.lex_state = 192},
  [2077] = {.lex_state = 237},
  [2078] = {.lex_state = 237},
  [2079] = {.lex_state = 237},
  [2080] = {.lex_state = 192},
  [2081] = {.lex_state = 237},
  [2082] = {.lex_state = 237},
  [2083] = {.lex_state = 237},
  [2084] = {.lex_state = 237},
  [2085] = {.lex_state = 237},
  [2086] = {.lex_state = 237},
  [2087] = {.lex_state = 237},
  [2088] = {.lex_state = 237},
  [2089] = {.lex_state = 192},
  [2090] = {.lex_state = 237},
  [2091] = {.lex_state = 237},
  [2092] = {.lex_state = 237},
  [2093] = {.lex_state = 237},
  [2094] = {.lex_state = 237},
  [2095] = {.lex_state = 237},
  [2096] = {.lex_state = 237},
  [2097] = {.lex_state = 237},
  [2098] = {.lex_state = 192},
  [2099] = {.lex_state = 236},
  [2100] = {.lex_state = 237},
  [2101] = {.lex_state = 237},
  [2102] = {.lex_state = 237},
  [2103] = {.lex_state = 237},
  [2104] = {.lex_state = 237},
  [2105] = {.lex_state = 237},
  [2106] = {.lex_state = 237},
  [2107] = {.lex_state = 237},
  [2108] = {.lex_state = 237},
  [2109] = {.lex_state = 237},
  [2110] = {.lex_state = 237},
  [2111] = {.lex_state = 237},
  [2112] = {.lex_state = 185},
  [2113] = {.lex_state = 237},
  [2114] = {.lex_state = 185},
  [2115] = {.lex_state = 237},
  [2116] = {.lex_state = 237},
  [2117] = {.lex_state = 237},
  [2118] = {.lex_state = 192},
  [2119] = {.lex_state = 238},
  [2120] = {.lex_state = 197},
  [2121] = {.lex_state = 195},
  [2122] = {.lex_state = 197},
  [2123] = {.lex_state = 197},
  [2124] = {.lex_state = 176},
  [2125] = {.lex_state = 195},
  [2126] = {.lex_state = 197},
  [2127] = {.lex_state = 197},
  [2128] = {.lex_state = 195},
  [2129] = {.lex_state = 184},
  [2130] = {.lex_state = 176},
  [2131] = {.lex_state = 194},
  [2132] = {.lex_state = 176},
  [2133] = {.lex_state = 176},
  [2134] = {.lex_state = 182},
  [2135] = {.lex_state = 176},
  [2136] = {.lex_state = 195},
  [2137] = {.lex_state = 238},
  [2138] = {.lex_state = 197},
  [2139] = {.lex_state = 197},
  [2140] = {.lex_state = 184},
  [2141] = {.lex_state = 182},
  [2142] = {.lex_state = 194},
  [2143] = {.lex_state = 197},
  [2144] = {.lex_state = 176},
  [2145] = {.lex_state = 238},
  [2146] = {.lex_state = 227},
  [2147] = {.lex_state = 197},
  [2148] = {.lex_state = 197},
  [2149] = {.lex_state = 184},
  [2150] = {.lex_state = 197},
  [2151] = {.lex_state = 197},
  [2152] = {.lex_state = 176},
  [2153] = {.lex_state = 194},
  [2154] = {.lex_state = 227},
  [2155] = {.lex_state = 227},
  [2156] = {.lex_state = 197},
  [2157] = {.lex_state = 176},
  [2158] = {.lex_state = 238},
  [2159] = {.lex_state = 195},
  [2160] = {.lex_state = 194},
  [2161] = {.lex_state = 238},
  [2162] = {.lex_state = 236},
  [2163] = {.lex_state = 195},
  [2164] = {.lex_state = 194},
  [2165] = {.lex_state = 186},
  [2166] = {.lex_state = 194},
  [2167] = {.lex_state = 236},
  [2168] = {.lex_state = 236},
  [2169] = {.lex_state = 194},
  [2170] = {.lex_state = 197},
  [2171] = {.lex_state = 194},
  [2172] = {.lex_state = 236},
  [2173] = {.lex_state = 194},
  [2174] = {.lex_state = 194},
  [2175] = {.lex_state = 194},
  [2176] = {.lex_state = 194},
  [2177] = {.lex_state = 194},
  [2178] = {.lex_state = 194},
  [2179] = {.lex_state = 197},
  [2180] = {.lex_state = 194},
  [2181] = {.lex_state = 178},
  [2182] = {.lex_state = 195},
  [2183] = {.lex_state = 197},
  [2184] = {.lex_state = 194},
  [2185] = {.lex_state = 194},
  [2186] = {.lex_state = 195},
  [2187] = {.lex_state = 195},
  [2188] = {.lex_state = 197},
  [2189] = {.lex_state = 195},
  [2190] = {.lex_state = 197},
  [2191] = {.lex_state = 236},
  [2192] = {.lex_state = 236},
  [2193] = {.lex_state = 236},
  [2194] = {.lex_state = 197},
  [2195] = {.lex_state = 197},
  [2196] = {.lex_state = 203},
  [2197] = {.lex_state = 195},
  [2198] = {.lex_state = 194},
  [2199] = {.lex_state = 197},
  [2200] = {.lex_state = 176},
  [2201] = {.lex_state = 197},
  [2202] = {.lex_state = 197},
  [2203] = {.lex_state = 197},
  [2204] = {.lex_state = 197},
  [2205] = {.lex_state = 176},
  [2206] = {.lex_state = 197},
  [2207] = {.lex_state = 236},
  [2208] = {.lex_state = 197},
  [2209] = {.lex_state = 227},
  [2210] = {.lex_state = 197},
  [2211] = {.lex_state = 197},
  [2212] = {.lex_state = 197},
  [2213] = {.lex_state = 197},
  [2214] = {.lex_state = 236},
  [2215] = {.lex_state = 236},
  [2216] = {.lex_state = 236},
  [2217] = {.lex_state = 236},
  [2218] = {.lex_state = 236},
  [2219] = {.lex_state = 236},
  [2220] = {.lex_state = 236},
  [2221] = {.lex_state = 195},
  [2222] = {.lex_state = 178},
  [2223] = {.lex_state = 195},
  [2224] = {.lex_state = 195},
  [2225] = {.lex_state = 197},
  [2226] = {.lex_state = 197},
  [2227] = {.lex_state = 197},
  [2228] = {.lex_state = 197},
  [2229] = {.lex_state = 197},
  [2230] = {.lex_state = 197},
  [2231] = {.lex_state = 197},
  [2232] = {.lex_state = 197},
  [2233] = {.lex_state = 197},
  [2234] = {.lex_state = 197},
  [2235] = {.lex_state = 197},
  [2236] = {.lex_state = 197},
  [2237] = {.lex_state = 176},
  [2238] = {.lex_state = 195},
  [2239] = {.lex_state = 197},
  [2240] = {.lex_state = 188},
  [2241] = {.lex_state = 203},
  [2242] = {.lex_state = 197},
  [2243] = {.lex_state = 178},
  [2244] = {.lex_state = 178},
  [2245] = {.lex_state = 197},
  [2246] = {.lex_state = 186},
  [2247] = {.lex_state = 197},
  [2248] = {.lex_state = 188},
  [2249] = {.lex_state = 194},
  [2250] = {.lex_state = 178},
  [2251] = {.lex_state = 197},
  [2252] = {.lex_state = 195},
  [2253] = {.lex_state = 197},
  [2254] = {.lex_state = 227},
  [2255] = {.lex_state = 195},
  [2256] = {.lex_state = 197},
  [2257] = {.lex_state = 188},
  [2258] = {.lex_state = 195},
  [2259] = {.lex_state = 176},
  [2260] = {.lex_state = 197},
  [2261] = {.lex_state = 197},
  [2262] = {.lex_state = 197},
  [2263] = {.lex_state = 197},
  [2264] = {.lex_state = 197},
  [2265] = {.lex_state = 197},
  [2266] = {.lex_state = 236},
  [2267] = {.lex_state = 226},
  [2268] = {.lex_state = 197},
  [2269] = {.lex_state = 236},
  [2270] = {.lex_state = 178},
  [2271] = {.lex_state = 178},
  [2272] = {.lex_state = 201},
  [2273] = {.lex_state = 203},
  [2274] = {.lex_state = 197},
  [2275] = {.lex_state = 197},
  [2276] = {.lex_state = 197},
  [2277] = {.lex_state = 197},
  [2278] = {.lex_state = 197},
  [2279] = {.lex_state = 194},
  [2280] = {.lex_state = 197},
  [2281] = {.lex_state = 178},
  [2282] = {.lex_state = 226},
  [2283] = {.lex_state = 203},
  [2284] = {.lex_state = 197},
  [2285] = {.lex_state = 203},
  [2286] = {.lex_state = 201},
  [2287] = {.lex_state = 226},
  [2288] = {.lex_state = 203},
  [2289] = {.lex_state = 226},
  [2290] = {.lex_state = 203},
  [2291] = {.lex_state = 197},
  [2292] = {.lex_state = 197},
  [2293] = {.lex_state = 194},
  [2294] = {.lex_state = 203},
  [2295] = {.lex_state = 203},
  [2296] = {.lex_state = 197},
  [2297] = {.lex_state = 226},
  [2298] = {.lex_state = 226},
  [2299] = {.lex_state = 226},
  [2300] = {.lex_state = 194},
  [2301] = {.lex_state = 226},
  [2302] = {.lex_state = 194},
  [2303] = {.lex_state = 197},
  [2304] = {.lex_state = 226},
  [2305] = {.lex_state = 197},
  [2306] = {.lex_state = 226},
  [2307] = {.lex_state = 226},
  [2308] = {.lex_state = 236},
  [2309] = {.lex_state = 203},
  [2310] = {.lex_state = 184},
  [2311] = {.lex_state = 203},
  [2312] = {.lex_state = 226},
  [2313] = {.lex_state = 203},
  [2314] = {.lex_state = 226},
  [2315] = {.lex_state = 226},
  [2316] = {.lex_state = 197},
  [2317] = {.lex_state = 197},
  [2318] = {.lex_state = 203},
  [2319] = {.lex_state = 203},
  [2320] = {.lex_state = 197},
  [2321] = {.lex_state = 178},
  [2322] = {.lex_state = 207},
  [2323] = {.lex_state = 195},
  [2324] = {.lex_state = 197},
  [2325] = {.lex_state = 194},
  [2326] = {.lex_state = 184},
  [2327] = {.lex_state = 194},
  [2328] = {.lex_state = 194},
  [2329] = {.lex_state = 206},
  [2330] = {.lex_state = 236},
  [2331] = {.lex_state = 197},
  [2332] = {.lex_state = 197},
  [2333] = {.lex_state = 197},
  [2334] = {.lex_state = 184},
  [2335] = {.lex_state = 197},
  [2336] = {.lex_state = 238},
  [2337] = {.lex_state = 194},
  [2338] = {.lex_state = 178},
  [2339] = {.lex_state = 227},
  [2340] = {.lex_state = 184},
  [2341] = {.lex_state = 197},
  [2342] = {.lex_state = 194},
  [2343] = {.lex_state = 178},
  [2344] = {.lex_state = 197},
  [2345] = {.lex_state = 195},
  [2346] = {.lex_state = 178},
  [2347] = {.lex_state = 194},
  [2348] = {.lex_state = 195},
  [2349] = {.lex_state = 236},
  [2350] = {.lex_state = 195},
  [2351] = {.lex_state = 200},
  [2352] = {.lex_state = 194},
  [2353] = {.lex_state = 184},
  [2354] = {.lex_state = 184},
  [2355] = {.lex_state = 184},
  [2356] = {.lex_state = 238},
  [2357] = {.lex_state = 238},
  [2358] = {.lex_state = 194},
  [2359] = {.lex_state = 197},
  [2360] = {.lex_state = 236},
  [2361] = {.lex_state = 197},
  [2362] = {.lex_state = 195},
  [2363] = {.lex_state = 188},
  [2364] = {.lex_state = 238},
  [2365] = {.lex_state = 238},
  [2366] = {.lex_state = 184},
  [2367] = {.lex_state = 178},
  [2368] = {.lex_state = 197},
  [2369] = {.lex_state = 197},
  [2370] = {.lex_state = 197},
  [2371] = {.lex_state = 197},
  [2372] = {.lex_state = 197},
  [2373] = {.lex_state = 197},
  [2374] = {.lex_state = 197},
  [2375] = {.lex_state = 238},
  [2376] = {.lex_state = 184},
  [2377] = {.lex_state = 197},
  [2378] = {.lex_state = 238},
  [2379] = {.lex_state = 197},
  [2380] = {.lex_state = 197},
  [2381] = {.lex_state = 197},
  [2382] = {.lex_state = 197},
  [2383] = {.lex_state = 238},
  [2384] = {.lex_state = 188},
  [2385] = {.lex_state = 188},
  [2386] = {.lex_state = 197},
  [2387] = {.lex_state = 197},
  [2388] = {.lex_state = 197},
  [2389] = {.lex_state = 184},
  [2390] = {.lex_state = 238},
  [2391] = {.lex_state = 197},
  [2392] = {.lex_state = 197},
  [2393] = {.lex_state = 197},
  [2394] = {.lex_state = 197},
  [2395] = {.lex_state = 197},
  [2396] = {.lex_state = 197},
  [2397] = {.lex_state = 197},
  [2398] = {.lex_state = 197},
  [2399] = {.lex_state = 238},
  [2400] = {.lex_state = 188},
  [2401] = {.lex_state = 238},
  [2402] = {.lex_state = 188},
  [2403] = {.lex_state = 197},
  [2404] = {.lex_state = 197},
  [2405] = {.lex_state = 197},
  [2406] = {.lex_state = 197},
  [2407] = {.lex_state = 197},
  [2408] = {.lex_state = 197},
  [2409] = {.lex_state = 197},
  [2410] = {.lex_state = 197},
  [2411] = {.lex_state = 238},
  [2412] = {.lex_state = 238},
  [2413] = {.lex_state = 197},
  [2414] = {.lex_state = 197},
  [2415] = {.lex_state = 238},
  [2416] = {.lex_state = 238},
  [2417] = {.lex_state = 197},
  [2418] = {.lex_state = 238},
  [2419] = {.lex_state = 238},
  [2420] = {.lex_state = 238},
  [2421] = {.lex_state = 238},
  [2422] = {.lex_state = 238},
  [2423] = {.lex_state = 238},
  [2424] = {.lex_state = 197},
  [2425] = {.lex_state = 197},
  [2426] = {.lex_state = 197},
  [2427] = {.lex_state = 238},
  [2428] = {.lex_state = 238},
  [2429] = {.lex_state = 238},
  [2430] = {.lex_state = 238},
  [2431] = {.lex_state = 197},
  [2432] = {.lex_state = 197},
  [2433] = {.lex_state = 197},
  [2434] = {.lex_state = 197},
  [2435] = {.lex_state = 197},
  [2436] = {.lex_state = 197},
  [2437] = {.lex_state = 197},
  [2438] = {.lex_state = 197},
  [2439] = {.lex_state = 197},
  [2440] = {.lex_state = 238},
  [2441] = {.lex_state = 197},
  [2442] = {.lex_state = 238},
  [2443] = {.lex_state = 197},
  [2444] = {.lex_state = 197},
  [2445] = {.lex_state = 197},
  [2446] = {.lex_state = 197},
  [2447] = {.lex_state = 238},
  [2448] = {.lex_state = 238},
  [2449] = {.lex_state = 238},
  [2450] = {.lex_state = 197},
  [2451] = {.lex_state = 197},
  [2452] = {.lex_state = 184},
  [2453] = {.lex_state = 197},
  [2454] = {.lex_state = 238},
  [2455] = {.lex_state = 238},
  [2456] = {.lex_state = 238},
  [2457] = {.lex_state = 197},
  [2458] = {.lex_state = 197},
  [2459] = {.lex_state = 197},
  [2460] = {.lex_state = 238},
  [2461] = {.lex_state = 238},
  [2462] = {.lex_state = 238},
  [2463] = {.lex_state = 238},
  [2464] = {.lex_state = 238},
  [2465] = {.lex_state = 197},
  [2466] = {.lex_state = 238},
  [2467] = {.lex_state = 197},
  [2468] = {.lex_state = 238},
  [2469] = {.lex_state = 197},
  [2470] = {.lex_state = 197},
  [2471] = {.lex_state = 184},
  [2472] = {.lex_state = 238},
  [2473] = {.lex_state = 197},
  [2474] = {.lex_state = 214},
  [2475] = {.lex_state = 197},
  [2476] = {.lex_state = 197},
  [2477] = {.lex_state = 238},
  [2478] = {.lex_state = 197},
  [2479] = {.lex_state = 197},
  [2480] = {.lex_state = 197},
  [2481] = {.lex_state = 197},
  [2482] = {.lex_state = 197},
  [2483] = {.lex_state = 197},
  [2484] = {.lex_state = 238},
  [2485] = {.lex_state = 197},
  [2486] = {.lex_state = 197},
  [2487] = {.lex_state = 197},
  [2488] = {.lex_state = 197},
  [2489] = {.lex_state = 197},
  [2490] = {.lex_state = 197},
  [2491] = {.lex_state = 213},
  [2492] = {.lex_state = 238},
  [2493] = {.lex_state = 197},
  [2494] = {.lex_state = 184},
  [2495] = {.lex_state = 225},
  [2496] = {.lex_state = 225},
  [2497] = {.lex_state = 226},
  [2498] = {.lex_state = 225},
  [2499] = {.lex_state = 206},
  [2500] = {.lex_state = 225},
  [2501] = {.lex_state = 238},
  [2502] = {.lex_state = 226},
  [2503] = {.lex_state = 188},
  [2504] = {.lex_state = 206},
  [2505] = {.lex_state = 188},
  [2506] = {.lex_state = 206},
  [2507] = {.lex_state = 206},
  [2508] = {.lex_state = 206},
  [2509] = {.lex_state = 206},
  [2510] = {.lex_state = 206},
  [2511] = {.lex_state = 238},
  [2512] = {.lex_state = 238},
  [2513] = {.lex_state = 206},
  [2514] = {.lex_state = 206},
  [2515] = {.lex_state = 225},
  [2516] = {.lex_state = 225},
  [2517] = {.lex_state = 225},
  [2518] = {.lex_state = 235},
  [2519] = {.lex_state = 235},
  [2520] = {.lex_state = 206},
  [2521] = {.lex_state = 225},
  [2522] = {.lex_state = 206},
  [2523] = {.lex_state = 225},
  [2524] = {.lex_state = 225},
  [2525] = {.lex_state = 225},
  [2526] = {.lex_state = 236},
  [2527] = {.lex_state = 206},
  [2528] = {.lex_state = 206},
  [2529] = {.lex_state = 188},
  [2530] = {.lex_state = 188},
  [2531] = {.lex_state = 206},
  [2532] = {.lex_state = 225},
  [2533] = {.lex_state = 206},
  [2534] = {.lex_state = 238},
  [2535] = {.lex_state = 238},
  [2536] = {.lex_state = 226},
  [2537] = {.lex_state = 238},
  [2538] = {.lex_state = 207},
  [2539] = {.lex_state = 226},
  [2540] = {.lex_state = 226},
  [2541] = {.lex_state = 226},
  [2542] = {.lex_state = 226},
  [2543] = {.lex_state = 226},
  [2544] = {.lex_state = 206},
  [2545] = {.lex_state = 238},
  [2546] = {.lex_state = 226},
  [2547] = {.lex_state = 180},
  [2548] = {.lex_state = 238},
  [2549] = {.lex_state = 207},
  [2550] = {.lex_state = 238},
  [2551] = {.lex_state = 238},
  [2552] = {.lex_state = 184},
  [2553] = {.lex_state = 206},
  [2554] = {.lex_state = 238},
  [2555] = {.lex_state = 226},
  [2556] = {.lex_state = 238},
  [2557] = {.lex_state = 226},
  [2558] = {.lex_state = 226},
  [2559] = {.lex_state = 207},
  [2560] = {.lex_state = 184},
  [2561] = {.lex_state = 238},
  [2562] = {.lex_state = 206},
  [2563] = {.lex_state = 225},
  [2564] = {.lex_state = 238},
  [2565] = {.lex_state = 238},
  [2566] = {.lex_state = 238},
  [2567] = {.lex_state = 213},
  [2568] = {.lex_state = 213},
  [2569] = {.lex_state = 213},
  [2570] = {.lex_state = 180},
  [2571] = {.lex_state = 174},
  [2572] = {.lex_state = 226},
  [2573] = {.lex_state = 213},
  [2574] = {.lex_state = 238},
  [2575] = {.lex_state = 238},
  [2576] = {.lex_state = 238},
  [2577] = {.lex_state = 213},
  [2578] = {.lex_state = 226},
  [2579] = {.lex_state = 213},
  [2580] = {.lex_state = 213},
  [2581] = {.lex_state = 213},
  [2582] = {.lex_state = 184},
  [2583] = {.lex_state = 238},
  [2584] = {.lex_state = 213},
  [2585] = {.lex_state = 213},
  [2586] = {.lex_state = 225},
  [2587] = {.lex_state = 213},
  [2588] = {.lex_state = 206},
  [2589] = {.lex_state = 213},
  [2590] = {.lex_state = 213},
  [2591] = {.lex_state = 238},
  [2592] = {.lex_state = 226},
  [2593] = {.lex_state = 226},
  [2594] = {.lex_state = 206},
  [2595] = {.lex_state = 238},
  [2596] = {.lex_state = 213},
  [2597] = {.lex_state = 174},
  [2598] = {.lex_state = 180},
  [2599] = {.lex_state = 238},
  [2600] = {.lex_state = 206},
  [2601] = {.lex_state = 184},
  [2602] = {.lex_state = 238},
  [2603] = {.lex_state = 213},
  [2604] = {.lex_state = 213},
  [2605] = {.lex_state = 226},
  [2606] = {.lex_state = 213},
  [2607] = {.lex_state = 214},
  [2608] = {.lex_state = 226},
  [2609] = {.lex_state = 226},
  [2610] = {.lex_state = 207},
  [2611] = {.lex_state = 184},
  [2612] = {.lex_state = 235},
  [2613] = {.lex_state = 226},
  [2614] = {.lex_state = 226},
  [2615] = {.lex_state = 226},
  [2616] = {.lex_state = 226},
  [2617] = {.lex_state = 226},
  [2618] = {.lex_state = 226},
  [2619] = {.lex_state = 226},
  [2620] = {.lex_state = 226},
  [2621] = {.lex_state = 230},
  [2622] = {.lex_state = 226},
  [2623] = {.lex_state = 226},
  [2624] = {.lex_state = 230},
  [2625] = {.lex_state = 235},
  [2626] = {.lex_state = 184},
  [2627] = {.lex_state = 184},
  [2628] = {.lex_state = 226},
  [2629] = {.lex_state = 226},
  [2630] = {.lex_state = 226},
  [2631] = {.lex_state = 226},
  [2632] = {.lex_state = 213},
  [2633] = {.lex_state = 214},
  [2634] = {.lex_state = 226},
  [2635] = {.lex_state = 226},
  [2636] = {.lex_state = 226},
  [2637] = {.lex_state = 226},
  [2638] = {.lex_state = 226},
  [2639] = {.lex_state = 226},
  [2640] = {.lex_state = 201},
  [2641] = {.lex_state = 226},
  [2642] = {.lex_state = 226},
  [2643] = {.lex_state = 226},
  [2644] = {.lex_state = 226},
  [2645] = {.lex_state = 184},
  [2646] = {.lex_state = 230},
  [2647] = {.lex_state = 226},
  [2648] = {.lex_state = 238},
  [2649] = {.lex_state = 226},
  [2650] = {.lex_state = 238},
  [2651] = {.lex_state = 226},
  [2652] = {.lex_state = 226},
  [2653] = {.lex_state = 226},
  [2654] = {.lex_state = 206},
  [2655] = {.lex_state = 226},
  [2656] = {.lex_state = 226},
  [2657] = {.lex_state = 213},
  [2658] = {.lex_state = 226},
  [2659] = {.lex_state = 236},
  [2660] = {.lex_state = 206},
  [2661] = {.lex_state = 226},
  [2662] = {.lex_state = 226},
  [2663] = {.lex_state = 226},
  [2664] = {.lex_state = 201},
  [2665] = {.lex_state = 226},
  [2666] = {.lex_state = 230},
  [2667] = {.lex_state = 236},
  [2668] = {.lex_state = 213},
  [2669] = {.lex_state = 213},
  [2670] = {.lex_state = 206},
  [2671] = {.lex_state = 174},
  [2672] = {.lex_state = 206},
  [2673] = {.lex_state = 206},
  [2674] = {.lex_state = 174},
  [2675] = {.lex_state = 222},
  [2676] = {.lex_state = 174},
  [2677] = {.lex_state = 206},
  [2678] = {.lex_state = 206},
  [2679] = {.lex_state = 174},
  [2680] = {.lex_state = 174},
  [2681] = {.lex_state = 174},
  [2682] = {.lex_state = 174},
  [2683] = {.lex_state = 206},
  [2684] = {.lex_state = 206},
  [2685] = {.lex_state = 174},
  [2686] = {.lex_state = 174},
  [2687] = {.lex_state = 206},
  [2688] = {.lex_state = 174},
  [2689] = {.lex_state = 174},
  [2690] = {.lex_state = 174},
  [2691] = {.lex_state = 174},
  [2692] = {.lex_state = 238},
  [2693] = {.lex_state = 174},
  [2694] = {.lex_state = 206},
  [2695] = {.lex_state = 174},
  [2696] = {.lex_state = 238},
  [2697] = {.lex_state = 206},
  [2698] = {.lex_state = 174},
  [2699] = {.lex_state = 174},
  [2700] = {.lex_state = 174},
  [2701] = {.lex_state = 222},
  [2702] = {.lex_state = 206},
  [2703] = {.lex_state = 206},
  [2704] = {.lex_state = 222},
  [2705] = {.lex_state = 206},
  [2706] = {.lex_state = 206},
  [2707] = {.lex_state = 214},
  [2708] = {.lex_state = 222},
  [2709] = {.lex_state = 206},
  [2710] = {.lex_state = 206},
  [2711] = {.lex_state = 222},
  [2712] = {.lex_state = 222},
  [2713] = {.lex_state = 238},
  [2714] = {.lex_state = 222},
  [2715] = {.lex_state = 174},
  [2716] = {.lex_state = 206},
  [2717] = {.lex_state = 206},
  [2718] = {.lex_state = 206},
  [2719] = {.lex_state = 206},
  [2720] = {.lex_state = 174},
  [2721] = {.lex_state = 206},
  [2722] = {.lex_state = 206},
  [2723] = {.lex_state = 224},
  [2724] = {.lex_state = 206},
  [2725] = {.lex_state = 206},
  [2726] = {.lex_state = 224},
  [2727] = {.lex_state = 206},
  [2728] = {.lex_state = 206},
  [2729] = {.lex_state = 206},
  [2730] = {.lex_state = 206},
  [2731] = {.lex_state = 206},
  [2732] = {.lex_state = 206},
  [2733] = {.lex_state = 206},
  [2734] = {.lex_state = 206},
  [2735] = {.lex_state = 206},
  [2736] = {.lex_state = 180},
  [2737] = {.lex_state = 213},
  [2738] = {.lex_state = 206},
  [2739] = {.lex_state = 206},
  [2740] = {.lex_state = 206},
  [2741] = {.lex_state = 206},
  [2742] = {.lex_state = 213},
  [2743] = {.lex_state = 222},
  [2744] = {.lex_state = 222},
  [2745] = {.lex_state = 238},
  [2746] = {.lex_state = 180},
  [2747] = {.lex_state = 213},
  [2748] = {.lex_state = 222},
  [2749] = {.lex_state = 194},
  [2750] = {.lex_state = 194},
  [2751] = {.lex_state = 194},
  [2752] = {.lex_state = 194},
  [2753] = {.lex_state = 194},
  [2754] = {.lex_state = 194},
  [2755] = {.lex_state = 194},
  [2756] = {.lex_state = 194},
  [2757] = {.lex_state = 194},
  [2758] = {.lex_state = 194},
  [2759] = {.lex_state = 194},
  [2760] = {.lex_state = 194},
  [2761] = {.lex_state = 194},
  [2762] = {.lex_state = 238},
  [2763] = {.lex_state = 213},
  [2764] = {.lex_state = 222},
  [2765] = {.lex_state = 195},
  [2766] = {.lex_state = 222},
  [2767] = {.lex_state = 222},
  [2768] = {.lex_state = 194},
  [2769] = {.lex_state = 194},
  [2770] = {.lex_state = 222},
  [2771] = {.lex_state = 222},
  [2772] = {.lex_state = 222},
  [2773] = {.lex_state = 206},
  [2774] = {.lex_state = 206},
  [2775] = {.lex_state = 206},
  [2776] = {.lex_state = 207},
  [2777] = {.lex_state = 195},
  [2778] = {.lex_state = 222},
  [2779] = {.lex_state = 222},
  [2780] = {.lex_state = 195},
  [2781] = {.lex_state = 195},
  [2782] = {.lex_state = 224},
  [2783] = {.lex_state = 180},
  [2784] = {.lex_state = 195},
  [2785] = {.lex_state = 222},
  [2786] = {.lex_state = 222},
  [2787] = {.lex_state = 195},
  [2788] = {.lex_state = 240},
  [2789] = {.lex_state = 207},
  [2790] = {.lex_state = 195},
  [2791] = {.lex_state = 213},
  [2792] = {.lex_state = 238},
  [2793] = {.lex_state = 206},
  [2794] = {.lex_state = 180},
  [2795] = {.lex_state = 206},
  [2796] = {.lex_state = 194},
  [2797] = {.lex_state = 194},
  [2798] = {.lex_state = 194},
  [2799] = {.lex_state = 213},
  [2800] = {.lex_state = 206},
  [2801] = {.lex_state = 206},
  [2802] = {.lex_state = 222},
  [2803] = {.lex_state = 238},
  [2804] = {.lex_state = 213},
  [2805] = {.lex_state = 213},
  [2806] = {.lex_state = 201},
  [2807] = {.lex_state = 213},
  [2808] = {.lex_state = 198},
  [2809] = {.lex_state = 213},
  [2810] = {.lex_state = 213},
  [2811] = {.lex_state = 236},
  [2812] = {.lex_state = 206},
  [2813] = {.lex_state = 206},
  [2814] = {.lex_state = 206},
  [2815] = {.lex_state = 207},
  [2816] = {.lex_state = 238},
  [2817] = {.lex_state = 238},
  [2818] = {.lex_state = 206},
  [2819] = {.lex_state = 239},
  [2820] = {.lex_state = 198},
  [2821] = {.lex_state = 206},
  [2822] = {.lex_state = 213},
  [2823] = {.lex_state = 206},
  [2824] = {.lex_state = 213},
  [2825] = {.lex_state = 213},
  [2826] = {.lex_state = 213},
  [2827] = {.lex_state = 201},
  [2828] = {.lex_state = 213},
  [2829] = {.lex_state = 213},
  [2830] = {.lex_state = 213},
  [2831] = {.lex_state = 239},
  [2832] = {.lex_state = 193},
  [2833] = {.lex_state = 206},
  [2834] = {.lex_state = 239},
  [2835] = {.lex_state = 238},
  [2836] = {.lex_state = 194},
  [2837] = {.lex_state = 206},
  [2838] = {.lex_state = 239},
  [2839] = {.lex_state = 238},
  [2840] = {.lex_state = 206},
  [2841] = {.lex_state = 206},
  [2842] = {.lex_state = 201},
  [2843] = {.lex_state = 194},
  [2844] = {.lex_state = 201},
  [2845] = {.lex_state = 206},
  [2846] = {.lex_state = 201},
  [2847] = {.lex_state = 194},
  [2848] = {.lex_state = 194},
  [2849] = {.lex_state = 194},
  [2850] = {.lex_state = 194},
  [2851] = {.lex_state = 194},
  [2852] = {.lex_state = 206},
  [2853] = {.lex_state = 194},
  [2854] = {.lex_state = 238},
  [2855] = {.lex_state = 194},
  [2856] = {.lex_state = 194},
  [2857] = {.lex_state = 194},
  [2858] = {.lex_state = 194},
  [2859] = {.lex_state = 194},
  [2860] = {.lex_state = 194},
  [2861] = {.lex_state = 193},
  [2862] = {.lex_state = 201},
  [2863] = {.lex_state = 201},
  [2864] = {.lex_state = 194},
  [2865] = {.lex_state = 201},
  [2866] = {.lex_state = 191},
  [2867] = {.lex_state = 201},
  [2868] = {.lex_state = 191},
  [2869] = {.lex_state = 201},
  [2870] = {.lex_state = 201},
  [2871] = {.lex_state = 206},
  [2872] = {.lex_state = 239},
  [2873] = {.lex_state = 238},
  [2874] = {.lex_state = 198},
  [2875] = {.lex_state = 238},
  [2876] = {.lex_state = 225},
  [2877] = {.lex_state = 238},
  [2878] = {.lex_state = 201},
  [2879] = {.lex_state = 238},
  [2880] = {.lex_state = 238},
  [2881] = {.lex_state = 201},
  [2882] = {.lex_state = 191},
  [2883] = {.lex_state = 206},
  [2884] = {.lex_state = 201},
  [2885] = {.lex_state = 238},
  [2886] = {.lex_state = 239},
  [2887] = {.lex_state = 201},
  [2888] = {.lex_state = 238},
  [2889] = {.lex_state = 201},
  [2890] = {.lex_state = 198},
  [2891] = {.lex_state = 213},
  [2892] = {.lex_state = 213},
  [2893] = {.lex_state = 206},
  [2894] = {.lex_state = 238},
  [2895] = {.lex_state = 201},
  [2896] = {.lex_state = 194},
  [2897] = {.lex_state = 191},
  [2898] = {.lex_state = 201},
  [2899] = {.lex_state = 201},
  [2900] = {.lex_state = 201},
  [2901] = {.lex_state = 194},
  [2902] = {.lex_state = 238},
  [2903] = {.lex_state = 213},
  [2904] = {.lex_state = 194},
  [2905] = {.lex_state = 201},
  [2906] = {.lex_state = 238},
  [2907] = {.lex_state = 213},
  [2908] = {.lex_state = 201},
  [2909] = {.lex_state = 201},
  [2910] = {.lex_state = 213},
  [2911] = {.lex_state = 239},
  [2912] = {.lex_state = 201},
  [2913] = {.lex_state = 201},
  [2914] = {.lex_state = 206},
  [2915] = {.lex_state = 201},
  [2916] = {.lex_state = 191},
  [2917] = {.lex_state = 201},
  [2918] = {.lex_state = 201},
  [2919] = {.lex_state = 213},
  [2920] = {.lex_state = 238},
  [2921] = {.lex_state = 206},
  [2922] = {.lex_state = 238},
  [2923] = {.lex_state = 206},
  [2924] = {.lex_state = 194},
  [2925] = {.lex_state = 238},
  [2926] = {.lex_state = 206},
  [2927] = {.lex_state = 191},
  [2928] = {.lex_state = 201},
  [2929] = {.lex_state = 201},
  [2930] = {.lex_state = 238},
  [2931] = {.lex_state = 238},
  [2932] = {.lex_state = 168},
  [2933] = {.lex_state = 222},
  [2934] = {.lex_state = 194},
  [2935] = {.lex_state = 213},
  [2936] = {.lex_state = 191},
  [2937] = {.lex_state = 206},
  [2938] = {.lex_state = 239},
  [2939] = {.lex_state = 206},
  [2940] = {.lex_state = 238},
  [2941] = {.lex_state = 206},
  [2942] = {.lex_state = 206},
  [2943] = {.lex_state = 238},
  [2944] = {.lex_state = 206},
  [2945] = {.lex_state = 238},
  [2946] = {.lex_state = 206},
  [2947] = {.lex_state = 206},
  [2948] = {.lex_state = 213},
  [2949] = {.lex_state = 206},
  [2950] = {.lex_state = 206},
  [2951] = {.lex_state = 206},
  [2952] = {.lex_state = 238},
  [2953] = {.lex_state = 238},
  [2954] = {.lex_state = 222},
  [2955] = {.lex_state = 206},
  [2956] = {.lex_state = 206},
  [2957] = {.lex_state = 206},
  [2958] = {.lex_state = 238},
  [2959] = {.lex_state = 206},
  [2960] = {.lex_state = 206},
  [2961] = {.lex_state = 206},
  [2962] = {.lex_state = 238},
  [2963] = {.lex_state = 216},
  [2964] = {.lex_state = 194},
  [2965] = {.lex_state = 206},
  [2966] = {.lex_state = 216},
  [2967] = {.lex_state = 238},
  [2968] = {.lex_state = 238},
  [2969] = {.lex_state = 206},
  [2970] = {.lex_state = 168},
  [2971] = {.lex_state = 206},
  [2972] = {.lex_state = 206},
  [2973] = {.lex_state = 236},
  [2974] = {.lex_state = 238},
  [2975] = {.lex_state = 236},
  [2976] = {.lex_state = 238},
  [2977] = {.lex_state = 194},
  [2978] = {.lex_state = 238},
  [2979] = {.lex_state = 236},
  [2980] = {.lex_state = 206},
  [2981] = {.lex_state = 206},
  [2982] = {.lex_state = 222},
  [2983] = {.lex_state = 216},
  [2984] = {.lex_state = 238},
  [2985] = {.lex_state = 206},
  [2986] = {.lex_state = 168},
  [2987] = {.lex_state = 238},
  [2988] = {.lex_state = 201},
  [2989] = {.lex_state = 206},
  [2990] = {.lex_state = 194},
  [2991] = {.lex_state = 194},
  [2992] = {.lex_state = 194},
  [2993] = {.lex_state = 194},
  [2994] = {.lex_state = 194},
  [2995] = {.lex_state = 194},
  [2996] = {.lex_state = 194},
  [2997] = {.lex_state = 206},
  [2998] = {.lex_state = 222},
  [2999] = {.lex_state = 206},
  [3000] = {.lex_state = 206},
  [3001] = {.lex_state = 236},
  [3002] = {.lex_state = 194},
  [3003] = {.lex_state = 206},
  [3004] = {.lex_state = 206},
  [3005] = {.lex_state = 238},
  [3006] = {.lex_state = 238},
  [3007] = {.lex_state = 216},
  [3008] = {.lex_state = 206},
  [3009] = {.lex_state = 168},
  [3010] = {.lex_state = 206},
  [3011] = {.lex_state = 206},
  [3012] = {.lex_state = 236},
  [3013] = {.lex_state = 206},
  [3014] = {.lex_state = 206},
  [3015] = {.lex_state = 238},
  [3016] = {.lex_state = 238},
  [3017] = {.lex_state = 206},
  [3018] = {.lex_state = 216},
  [3019] = {.lex_state = 236},
  [3020] = {.lex_state = 206},
  [3021] = {.lex_state = 168},
  [3022] = {.lex_state = 206},
  [3023] = {.lex_state = 236},
  [3024] = {.lex_state = 206},
  [3025] = {.lex_state = 238},
  [3026] = {.lex_state = 236},
  [3027] = {.lex_state = 236},
  [3028] = {.lex_state = 194},
  [3029] = {.lex_state = 206},
  [3030] = {.lex_state = 194},
  [3031] = {.lex_state = 206},
  [3032] = {.lex_state = 168},
  [3033] = {.lex_state = 206},
  [3034] = {.lex_state = 191},
  [3035] = {.lex_state = 206},
  [3036] = {.lex_state = 236},
  [3037] = {.lex_state = 174},
  [3038] = {.lex_state = 238},
  [3039] = {.lex_state = 194},
  [3040] = {.lex_state = 206},
  [3041] = {.lex_state = 236},
  [3042] = {.lex_state = 194},
  [3043] = {.lex_state = 194},
  [3044] = {.lex_state = 191},
  [3045] = {.lex_state = 236},
  [3046] = {.lex_state = 206},
  [3047] = {.lex_state = 206},
  [3048] = {.lex_state = 206},
  [3049] = {.lex_state = 238},
  [3050] = {.lex_state = 194},
  [3051] = {.lex_state = 236},
  [3052] = {.lex_state = 194},
  [3053] = {.lex_state = 238},
  [3054] = {.lex_state = 238},
  [3055] = {.lex_state = 222},
  [3056] = {.lex_state = 206},
  [3057] = {.lex_state = 236},
  [3058] = {.lex_state = 180},
  [3059] = {.lex_state = 206},
  [3060] = {.lex_state = 238},
  [3061] = {.lex_state = 206},
  [3062] = {.lex_state = 213},
  [3063] = {.lex_state = 206},
  [3064] = {.lex_state = 222},
  [3065] = {.lex_state = 206},
  [3066] = {.lex_state = 213},
  [3067] = {.lex_state = 238},
  [3068] = {.lex_state = 213},
  [3069] = {.lex_state = 191},
  [3070] = {.lex_state = 180},
  [3071] = {.lex_state = 198},
  [3072] = {.lex_state = 213},
  [3073] = {.lex_state = 213},
  [3074] = {.lex_state = 213},
  [3075] = {.lex_state = 236},
  [3076] = {.lex_state = 213},
  [3077] = {.lex_state = 236},
  [3078] = {.lex_state = 213},
  [3079] = {.lex_state = 206},
  [3080] = {.lex_state = 206},
  [3081] = {.lex_state = 213},
  [3082] = {.lex_state = 206},
  [3083] = {.lex_state = 206},
  [3084] = {.lex_state = 201},
  [3085] = {.lex_state = 208},
  [3086] = {.lex_state = 206},
  [3087] = {.lex_state = 206},
  [3088] = {.lex_state = 213},
  [3089] = {.lex_state = 213},
  [3090] = {.lex_state = 206},
  [3091] = {.lex_state = 238},
  [3092] = {.lex_state = 213},
  [3093] = {.lex_state = 213},
  [3094] = {.lex_state = 213},
  [3095] = {.lex_state = 213},
  [3096] = {.lex_state = 213},
  [3097] = {.lex_state = 213},
  [3098] = {.lex_state = 206},
  [3099] = {.lex_state = 206},
  [3100] = {.lex_state = 206},
  [3101] = {.lex_state = 238},
  [3102] = {.lex_state = 193},
  [3103] = {.lex_state = 206},
  [3104] = {.lex_state = 236},
  [3105] = {.lex_state = 213},
  [3106] = {.lex_state = 236},
  [3107] = {.lex_state = 206},
  [3108] = {.lex_state = 206},
  [3109] = {.lex_state = 238},
  [3110] = {.lex_state = 180},
  [3111] = {.lex_state = 213},
  [3112] = {.lex_state = 206},
  [3113] = {.lex_state = 238},
  [3114] = {.lex_state = 206},
  [3115] = {.lex_state = 213},
  [3116] = {.lex_state = 213},
  [3117] = {.lex_state = 193},
  [3118] = {.lex_state = 216},
  [3119] = {.lex_state = 213},
  [3120] = {.lex_state = 194},
  [3121] = {.lex_state = 213},
  [3122] = {.lex_state = 213},
  [3123] = {.lex_state = 213},
  [3124] = {.lex_state = 213},
  [3125] = {.lex_state = 206},
  [3126] = {.lex_state = 213},
  [3127] = {.lex_state = 206},
  [3128] = {.lex_state = 213},
  [3129] = {.lex_state = 206},
  [3130] = {.lex_state = 206},
  [3131] = {.lex_state = 213},
  [3132] = {.lex_state = 206},
  [3133] = {.lex_state = 206},
  [3134] = {.lex_state = 206},
  [3135] = {.lex_state = 206},
  [3136] = {.lex_state = 206},
  [3137] = {.lex_state = 213},
  [3138] = {.lex_state = 206},
  [3139] = {.lex_state = 206},
  [3140] = {.lex_state = 206},
  [3141] = {.lex_state = 206},
  [3142] = {.lex_state = 206},
  [3143] = {.lex_state = 215},
  [3144] = {.lex_state = 236},
  [3145] = {.lex_state = 191},
  [3146] = {.lex_state = 213},
  [3147] = {.lex_state = 213},
  [3148] = {.lex_state = 213},
  [3149] = {.lex_state = 213},
  [3150] = {.lex_state = 198},
  [3151] = {.lex_state = 213},
  [3152] = {.lex_state = 213},
  [3153] = {.lex_state = 206},
  [3154] = {.lex_state = 238},
  [3155] = {.lex_state = 213},
  [3156] = {.lex_state = 213},
  [3157] = {.lex_state = 216},
  [3158] = {.lex_state = 206},
  [3159] = {.lex_state = 206},
  [3160] = {.lex_state = 203},
  [3161] = {.lex_state = 180},
  [3162] = {.lex_state = 206},
  [3163] = {.lex_state = 206},
  [3164] = {.lex_state = 213},
  [3165] = {.lex_state = 180},
  [3166] = {.lex_state = 238},
  [3167] = {.lex_state = 193},
  [3168] = {.lex_state = 213},
  [3169] = {.lex_state = 213},
  [3170] = {.lex_state = 203},
  [3171] = {.lex_state = 191},
  [3172] = {.lex_state = 206},
  [3173] = {.lex_state = 210},
  [3174] = {.lex_state = 203},
  [3175] = {.lex_state = 203},
  [3176] = {.lex_state = 206},
  [3177] = {.lex_state = 238},
  [3178] = {.lex_state = 203},
  [3179] = {.lex_state = 206},
  [3180] = {.lex_state = 191},
  [3181] = {.lex_state = 191},
  [3182] = {.lex_state = 191},
  [3183] = {.lex_state = 191},
  [3184] = {.lex_state = 206},
  [3185] = {.lex_state = 194},
  [3186] = {.lex_state = 238},
  [3187] = {.lex_state = 213},
  [3188] = {.lex_state = 238},
  [3189] = {.lex_state = 213},
  [3190] = {.lex_state = 213},
  [3191] = {.lex_state = 238},
  [3192] = {.lex_state = 191},
  [3193] = {.lex_state = 206},
  [3194] = {.lex_state = 191},
  [3195] = {.lex_state = 213},
  [3196] = {.lex_state = 213},
  [3197] = {.lex_state = 213},
  [3198] = {.lex_state = 206},
  [3199] = {.lex_state = 203},
  [3200] = {.lex_state = 213},
  [3201] = {.lex_state = 203},
  [3202] = {.lex_state = 206},
  [3203] = {.lex_state = 213},
  [3204] = {.lex_state = 206},
  [3205] = {.lex_state = 213},
  [3206] = {.lex_state = 213},
  [3207] = {.lex_state = 206},
  [3208] = {.lex_state = 213},
  [3209] = {.lex_state = 213},
  [3210] = {.lex_state = 203},
  [3211] = {.lex_state = 194},
  [3212] = {.lex_state = 213},
  [3213] = {.lex_state = 213},
  [3214] = {.lex_state = 213},
  [3215] = {.lex_state = 191},
  [3216] = {.lex_state = 191},
  [3217] = {.lex_state = 191},
  [3218] = {.lex_state = 240},
  [3219] = {.lex_state = 206},
  [3220] = {.lex_state = 194},
  [3221] = {.lex_state = 238},
  [3222] = {.lex_state = 213},
  [3223] = {.lex_state = 191},
  [3224] = {.lex_state = 191},
  [3225] = {.lex_state = 191},
  [3226] = {.lex_state = 213},
  [3227] = {.lex_state = 191},
  [3228] = {.lex_state = 191},
  [3229] = {.lex_state = 206},
  [3230] = {.lex_state = 191},
  [3231] = {.lex_state = 203},
  [3232] = {.lex_state = 213},
  [3233] = {.lex_state = 222},
  [3234] = {.lex_state = 191},
  [3235] = {.lex_state = 191},
  [3236] = {.lex_state = 213},
  [3237] = {.lex_state = 212},
  [3238] = {.lex_state = 206},
  [3239] = {.lex_state = 206},
  [3240] = {.lex_state = 206},
  [3241] = {.lex_state = 193},
  [3242] = {.lex_state = 236},
  [3243] = {.lex_state = 203},
  [3244] = {.lex_state = 201},
  [3245] = {.lex_state = 193},
  [3246] = {.lex_state = 193},
  [3247] = {.lex_state = 213},
  [3248] = {.lex_state = 213},
  [3249] = {.lex_state = 222},
  [3250] = {.lex_state = 201},
  [3251] = {.lex_state = 191},
  [3252] = {.lex_state = 206},
  [3253] = {.lex_state = 203},
  [3254] = {.lex_state = 210},
  [3255] = {.lex_state = 203},
  [3256] = {.lex_state = 213},
  [3257] = {.lex_state = 238},
  [3258] = {.lex_state = 213},
  [3259] = {.lex_state = 238},
  [3260] = {.lex_state = 213},
  [3261] = {.lex_state = 197},
  [3262] = {.lex_state = 197},
  [3263] = {.lex_state = 197},
  [3264] = {.lex_state = 197},
  [3265] = {.lex_state = 197},
  [3266] = {.lex_state = 197},
  [3267] = {.lex_state = 197},
  [3268] = {.lex_state = 197},
  [3269] = {.lex_state = 197},
  [3270] = {.lex_state = 197},
  [3271] = {.lex_state = 197},
  [3272] = {.lex_state = 197},
  [3273] = {.lex_state = 197},
  [3274] = {.lex_state = 197},
  [3275] = {.lex_state = 197},
  [3276] = {.lex_state = 197},
  [3277] = {.lex_state = 197},
  [3278] = {.lex_state = 197},
  [3279] = {.lex_state = 197},
  [3280] = {.lex_state = 197},
  [3281] = {.lex_state = 213},
  [3282] = {.lex_state = 197},
  [3283] = {.lex_state = 197},
  [3284] = {.lex_state = 197},
  [3285] = {.lex_state = 197},
  [3286] = {.lex_state = 194},
  [3287] = {.lex_state = 193},
  [3288] = {.lex_state = 203},
  [3289] = {.lex_state = 203},
  [3290] = {.lex_state = 191},
  [3291] = {.lex_state = 191},
  [3292] = {.lex_state = 238},
  [3293] = {.lex_state = 197},
  [3294] = {.lex_state = 213},
  [3295] = {.lex_state = 191},
  [3296] = {.lex_state = 213},
  [3297] = {.lex_state = 191},
  [3298] = {.lex_state = 193},
  [3299] = {.lex_state = 222},
  [3300] = {.lex_state = 203},
  [3301] = {.lex_state = 203},
  [3302] = {.lex_state = 206},
  [3303] = {.lex_state = 203},
  [3304] = {.lex_state = 191},
  [3305] = {.lex_state = 206},
  [3306] = {.lex_state = 203},
  [3307] = {.lex_state = 191},
  [3308] = {.lex_state = 191},
  [3309] = {.lex_state = 191},
  [3310] = {.lex_state = 191},
  [3311] = {.lex_state = 206},
  [3312] = {.lex_state = 236},
  [3313] = {.lex_state = 218},
  [3314] = {.lex_state = 201},
  [3315] = {.lex_state = 201},
  [3316] = {.lex_state = 201},
  [3317] = {.lex_state = 201},
  [3318] = {.lex_state = 201},
  [3319] = {.lex_state = 206},
  [3320] = {.lex_state = 201},
  [3321] = {.lex_state = 201},
  [3322] = {.lex_state = 201},
  [3323] = {.lex_state = 213},
  [3324] = {.lex_state = 206},
  [3325] = {.lex_state = 206},
  [3326] = {.lex_state = 206},
  [3327] = {.lex_state = 206},
  [3328] = {.lex_state = 206},
  [3329] = {.lex_state = 206},
  [3330] = {.lex_state = 190},
  [3331] = {.lex_state = 206},
  [3332] = {.lex_state = 206},
  [3333] = {.lex_state = 206},
  [3334] = {.lex_state = 206},
  [3335] = {.lex_state = 206},
  [3336] = {.lex_state = 206},
  [3337] = {.lex_state = 206},
  [3338] = {.lex_state = 206},
  [3339] = {.lex_state = 206},
  [3340] = {.lex_state = 206},
  [3341] = {.lex_state = 206},
  [3342] = {.lex_state = 206},
  [3343] = {.lex_state = 206},
  [3344] = {.lex_state = 238},
  [3345] = {.lex_state = 180},
  [3346] = {.lex_state = 216},
  [3347] = {.lex_state = 239},
  [3348] = {.lex_state = 239},
  [3349] = {.lex_state = 180},
  [3350] = {.lex_state = 206},
  [3351] = {.lex_state = 206},
  [3352] = {.lex_state = 206},
  [3353] = {.lex_state = 206},
  [3354] = {.lex_state = 206},
  [3355] = {.lex_state = 206},
  [3356] = {.lex_state = 239},
  [3357] = {.lex_state = 206},
  [3358] = {.lex_state = 206},
  [3359] = {.lex_state = 206},
  [3360] = {.lex_state = 206},
  [3361] = {.lex_state = 206},
  [3362] = {.lex_state = 206},
  [3363] = {.lex_state = 206},
  [3364] = {.lex_state = 194},
  [3365] = {.lex_state = 216},
  [3366] = {.lex_state = 213},
  [3367] = {.lex_state = 216},
  [3368] = {.lex_state = 206},
  [3369] = {.lex_state = 206},
  [3370] = {.lex_state = 180},
  [3371] = {.lex_state = 206},
  [3372] = {.lex_state = 206},
  [3373] = {.lex_state = 239},
  [3374] = {.lex_state = 218},
  [3375] = {.lex_state = 216},
  [3376] = {.lex_state = 206},
  [3377] = {.lex_state = 206},
  [3378] = {.lex_state = 206},
  [3379] = {.lex_state = 206},
  [3380] = {.lex_state = 216},
  [3381] = {.lex_state = 206},
  [3382] = {.lex_state = 206},
  [3383] = {.lex_state = 206},
  [3384] = {.lex_state = 206},
  [3385] = {.lex_state = 216},
  [3386] = {.lex_state = 206},
  [3387] = {.lex_state = 238},
  [3388] = {.lex_state = 216},
  [3389] = {.lex_state = 206},
  [3390] = {.lex_state = 206},
  [3391] = {.lex_state = 206},
  [3392] = {.lex_state = 216},
  [3393] = {.lex_state = 206},
  [3394] = {.lex_state = 216},
  [3395] = {.lex_state = 206},
  [3396] = {.lex_state = 206},
  [3397] = {.lex_state = 206},
  [3398] = {.lex_state = 206},
  [3399] = {.lex_state = 206},
  [3400] = {.lex_state = 206},
  [3401] = {.lex_state = 206},
  [3402] = {.lex_state = 206},
  [3403] = {.lex_state = 206},
  [3404] = {.lex_state = 216},
  [3405] = {.lex_state = 206},
  [3406] = {.lex_state = 216},
  [3407] = {.lex_state = 206},
  [3408] = {.lex_state = 206},
  [3409] = {.lex_state = 206},
  [3410] = {.lex_state = 206},
  [3411] = {.lex_state = 216},
  [3412] = {.lex_state = 206},
  [3413] = {.lex_state = 206},
  [3414] = {.lex_state = 206},
  [3415] = {.lex_state = 216},
  [3416] = {.lex_state = 206},
  [3417] = {.lex_state = 206},
  [3418] = {.lex_state = 206},
  [3419] = {.lex_state = 206},
  [3420] = {.lex_state = 216},
  [3421] = {.lex_state = 213},
  [3422] = {.lex_state = 206},
  [3423] = {.lex_state = 206},
  [3424] = {.lex_state = 206},
  [3425] = {.lex_state = 206},
  [3426] = {.lex_state = 206},
  [3427] = {.lex_state = 206},
  [3428] = {.lex_state = 206},
  [3429] = {.lex_state = 206},
  [3430] = {.lex_state = 206},
  [3431] = {.lex_state = 206},
  [3432] = {.lex_state = 201},
  [3433] = {.lex_state = 201},
  [3434] = {.lex_state = 239},
  [3435] = {.lex_state = 206},
  [3436] = {.lex_state = 206},
  [3437] = {.lex_state = 216},
  [3438] = {.lex_state = 206},
  [3439] = {.lex_state = 206},
  [3440] = {.lex_state = 190},
  [3441] = {.lex_state = 206},
  [3442] = {.lex_state = 206},
  [3443] = {.lex_state = 206},
  [3444] = {.lex_state = 206},
  [3445] = {.lex_state = 206},
  [3446] = {.lex_state = 206},
  [3447] = {.lex_state = 206},
  [3448] = {.lex_state = 206},
  [3449] = {.lex_state = 206},
  [3450] = {.lex_state = 206},
  [3451] = {.lex_state = 206},
  [3452] = {.lex_state = 206},
  [3453] = {.lex_state = 236},
  [3454] = {.lex_state = 190},
  [3455] = {.lex_state = 206},
  [3456] = {.lex_state = 206},
  [3457] = {.lex_state = 206},
  [3458] = {.lex_state = 206},
  [3459] = {.lex_state = 206},
  [3460] = {.lex_state = 201},
  [3461] = {.lex_state = 206},
  [3462] = {.lex_state = 180},
  [3463] = {.lex_state = 206},
  [3464] = {.lex_state = 239},
  [3465] = {.lex_state = 239},
  [3466] = {.lex_state = 238},
  [3467] = {.lex_state = 238},
  [3468] = {.lex_state = 180},
  [3469] = {.lex_state = 206},
  [3470] = {.lex_state = 206},
  [3471] = {.lex_state = 239},
  [3472] = {.lex_state = 238},
  [3473] = {.lex_state = 238},
  [3474] = {.lex_state = 206},
  [3475] = {.lex_state = 206},
  [3476] = {.lex_state = 213},
  [3477] = {.lex_state = 206},
  [3478] = {.lex_state = 206},
  [3479] = {.lex_state = 206},
  [3480] = {.lex_state = 201},
  [3481] = {.lex_state = 206},
  [3482] = {.lex_state = 206},
  [3483] = {.lex_state = 206},
  [3484] = {.lex_state = 201},
  [3485] = {.lex_state = 201},
  [3486] = {.lex_state = 206},
  [3487] = {.lex_state = 220},
  [3488] = {.lex_state = 216},
  [3489] = {.lex_state = 206},
  [3490] = {.lex_state = 201},
  [3491] = {.lex_state = 206},
  [3492] = {.lex_state = 201},
  [3493] = {.lex_state = 206},
  [3494] = {.lex_state = 206},
  [3495] = {.lex_state = 197},
  [3496] = {.lex_state = 203},
  [3497] = {.lex_state = 213},
  [3498] = {.lex_state = 206},
  [3499] = {.lex_state = 213},
  [3500] = {.lex_state = 193},
  [3501] = {.lex_state = 197},
  [3502] = {.lex_state = 206},
  [3503] = {.lex_state = 206},
  [3504] = {.lex_state = 206},
  [3505] = {.lex_state = 213},
  [3506] = {.lex_state = 213},
  [3507] = {.lex_state = 206},
  [3508] = {.lex_state = 213},
  [3509] = {.lex_state = 213},
  [3510] = {.lex_state = 213},
  [3511] = {.lex_state = 213},
  [3512] = {.lex_state = 213},
  [3513] = {.lex_state = 197},
  [3514] = {.lex_state = 213},
  [3515] = {.lex_state = 206},
  [3516] = {.lex_state = 213},
  [3517] = {.lex_state = 206},
  [3518] = {.lex_state = 213},
  [3519] = {.lex_state = 213},
  [3520] = {.lex_state = 201},
  [3521] = {.lex_state = 201},
  [3522] = {.lex_state = 201},
  [3523] = {.lex_state = 213},
  [3524] = {.lex_state = 201},
  [3525] = {.lex_state = 213},
  [3526] = {.lex_state = 201},
  [3527] = {.lex_state = 201},
  [3528] = {.lex_state = 201},
  [3529] = {.lex_state = 180},
  [3530] = {.lex_state = 180},
  [3531] = {.lex_state = 206},
  [3532] = {.lex_state = 206},
  [3533] = {.lex_state = 206},
  [3534] = {.lex_state = 213},
  [3535] = {.lex_state = 206},
  [3536] = {.lex_state = 213},
  [3537] = {.lex_state = 180},
  [3538] = {.lex_state = 206},
  [3539] = {.lex_state = 180},
  [3540] = {.lex_state = 206},
  [3541] = {.lex_state = 206},
  [3542] = {.lex_state = 206},
  [3543] = {.lex_state = 206},
  [3544] = {.lex_state = 213},
  [3545] = {.lex_state = 213},
  [3546] = {.lex_state = 213},
  [3547] = {.lex_state = 213},
  [3548] = {.lex_state = 213},
  [3549] = {.lex_state = 206},
  [3550] = {.lex_state = 213},
  [3551] = {.lex_state = 197},
  [3552] = {.lex_state = 213},
  [3553] = {.lex_state = 213},
  [3554] = {.lex_state = 213},
  [3555] = {.lex_state = 194},
  [3556] = {.lex_state = 213},
  [3557] = {.lex_state = 213},
  [3558] = {.lex_state = 213},
  [3559] = {.lex_state = 213},
  [3560] = {.lex_state = 197},
  [3561] = {.lex_state = 213},
  [3562] = {.lex_state = 213},
  [3563] = {.lex_state = 213},
  [3564] = {.lex_state = 213},
  [3565] = {.lex_state = 213},
  [3566] = {.lex_state = 213},
  [3567] = {.lex_state = 213},
  [3568] = {.lex_state = 213},
  [3569] = {.lex_state = 213},
  [3570] = {.lex_state = 213},
  [3571] = {.lex_state = 213},
  [3572] = {.lex_state = 213},
  [3573] = {.lex_state = 213},
  [3574] = {.lex_state = 213},
  [3575] = {.lex_state = 213},
  [3576] = {.lex_state = 213},
  [3577] = {.lex_state = 213},
  [3578] = {.lex_state = 206},
  [3579] = {.lex_state = 213},
  [3580] = {.lex_state = 206},
  [3581] = {.lex_state = 197},
  [3582] = {.lex_state = 238},
  [3583] = {.lex_state = 236},
  [3584] = {.lex_state = 213},
  [3585] = {.lex_state = 213},
  [3586] = {.lex_state = 201},
  [3587] = {.lex_state = 213},
  [3588] = {.lex_state = 213},
  [3589] = {.lex_state = 213},
  [3590] = {.lex_state = 213},
  [3591] = {.lex_state = 213},
  [3592] = {.lex_state = 206},
  [3593] = {.lex_state = 213},
  [3594] = {.lex_state = 206},
  [3595] = {.lex_state = 213},
  [3596] = {.lex_state = 213},
  [3597] = {.lex_state = 213},
  [3598] = {.lex_state = 213},
  [3599] = {.lex_state = 206},
  [3600] = {.lex_state = 206},
  [3601] = {.lex_state = 203},
  [3602] = {.lex_state = 194},
  [3603] = {.lex_state = 206},
  [3604] = {.lex_state = 213},
  [3605] = {.lex_state = 213},
  [3606] = {.lex_state = 213},
  [3607] = {.lex_state = 213},
  [3608] = {.lex_state = 206},
  [3609] = {.lex_state = 238},
  [3610] = {.lex_state = 213},
  [3611] = {.lex_state = 238},
  [3612] = {.lex_state = 201},
  [3613] = {.lex_state = 238},
  [3614] = {.lex_state = 213},
  [3615] = {.lex_state = 238},
  [3616] = {.lex_state = 238},
  [3617] = {.lex_state = 238},
  [3618] = {.lex_state = 238},
  [3619] = {.lex_state = 238},
  [3620] = {.lex_state = 238},
  [3621] = {.lex_state = 238},
  [3622] = {.lex_state = 238},
  [3623] = {.lex_state = 238},
  [3624] = {.lex_state = 201},
  [3625] = {.lex_state = 203},
  [3626] = {.lex_state = 213},
  [3627] = {.lex_state = 213},
  [3628] = {.lex_state = 213},
  [3629] = {.lex_state = 194},
  [3630] = {.lex_state = 197},
  [3631] = {.lex_state = 206},
  [3632] = {.lex_state = 194},
  [3633] = {.lex_state = 213},
  [3634] = {.lex_state = 213},
  [3635] = {.lex_state = 213},
  [3636] = {.lex_state = 213},
  [3637] = {.lex_state = 213},
  [3638] = {.lex_state = 213},
  [3639] = {.lex_state = 213},
  [3640] = {.lex_state = 201},
  [3641] = {.lex_state = 213},
  [3642] = {.lex_state = 197},
  [3643] = {.lex_state = 201},
  [3644] = {.lex_state = 213},
  [3645] = {.lex_state = 213},
  [3646] = {.lex_state = 213},
  [3647] = {.lex_state = 213},
  [3648] = {.lex_state = 213},
  [3649] = {.lex_state = 194},
  [3650] = {.lex_state = 213},
  [3651] = {.lex_state = 222},
  [3652] = {.lex_state = 236},
  [3653] = {.lex_state = 201},
  [3654] = {.lex_state = 203},
  [3655] = {.lex_state = 201},
  [3656] = {.lex_state = 222},
  [3657] = {.lex_state = 236},
  [3658] = {.lex_state = 210},
  [3659] = {.lex_state = 206},
  [3660] = {.lex_state = 236},
  [3661] = {.lex_state = 180},
  [3662] = {.lex_state = 190},
  [3663] = {.lex_state = 236},
  [3664] = {.lex_state = 210},
  [3665] = {.lex_state = 236},
  [3666] = {.lex_state = 236},
  [3667] = {.lex_state = 236},
  [3668] = {.lex_state = 236},
  [3669] = {.lex_state = 236},
  [3670] = {.lex_state = 222},
  [3671] = {.lex_state = 236},
  [3672] = {.lex_state = 236},
  [3673] = {.lex_state = 236},
  [3674] = {.lex_state = 203},
  [3675] = {.lex_state = 201},
  [3676] = {.lex_state = 236},
  [3677] = {.lex_state = 236},
  [3678] = {.lex_state = 236},
  [3679] = {.lex_state = 203},
  [3680] = {.lex_state = 236},
  [3681] = {.lex_state = 236},
  [3682] = {.lex_state = 236},
  [3683] = {.lex_state = 236},
  [3684] = {.lex_state = 236},
  [3685] = {.lex_state = 236},
  [3686] = {.lex_state = 236},
  [3687] = {.lex_state = 236},
  [3688] = {.lex_state = 236},
  [3689] = {.lex_state = 236},
  [3690] = {.lex_state = 236},
  [3691] = {.lex_state = 236},
  [3692] = {.lex_state = 236},
  [3693] = {.lex_state = 236},
  [3694] = {.lex_state = 236},
  [3695] = {.lex_state = 236},
  [3696] = {.lex_state = 201},
  [3697] = {.lex_state = 203},
  [3698] = {.lex_state = 236},
  [3699] = {.lex_state = 201},
  [3700] = {.lex_state = 236},
  [3701] = {.lex_state = 236},
  [3702] = {.lex_state = 203},
  [3703] = {.lex_state = 236},
  [3704] = {.lex_state = 236},
  [3705] = {.lex_state = 236},
  [3706] = {.lex_state = 201},
  [3707] = {.lex_state = 236},
  [3708] = {.lex_state = 236},
  [3709] = {.lex_state = 236},
  [3710] = {.lex_state = 236},
  [3711] = {.lex_state = 180},
  [3712] = {.lex_state = 238},
  [3713] = {.lex_state = 180},
  [3714] = {.lex_state = 180},
  [3715] = {.lex_state = 238},
  [3716] = {.lex_state = 203},
  [3717] = {.lex_state = 194},
  [3718] = {.lex_state = 236},
  [3719] = {.lex_state = 236},
  [3720] = {.lex_state = 240},
  [3721] = {.lex_state = 240},
  [3722] = {.lex_state = 236},
  [3723] = {.lex_state = 236},
  [3724] = {.lex_state = 236},
  [3725] = {.lex_state = 236},
  [3726] = {.lex_state = 236},
  [3727] = {.lex_state = 201},
  [3728] = {.lex_state = 236},
  [3729] = {.lex_state = 236},
  [3730] = {.lex_state = 236},
  [3731] = {.lex_state = 236},
  [3732] = {.lex_state = 236},
  [3733] = {.lex_state = 236},
  [3734] = {.lex_state = 236},
  [3735] = {.lex_state = 236},
  [3736] = {.lex_state = 236},
  [3737] = {.lex_state = 236},
  [3738] = {.lex_state = 236},
  [3739] = {.lex_state = 236},
  [3740] = {.lex_state = 236},
  [3741] = {.lex_state = 236},
  [3742] = {.lex_state = 201},
  [3743] = {.lex_state = 236},
  [3744] = {.lex_state = 240},
  [3745] = {.lex_state = 236},
  [3746] = {.lex_state = 201},
  [3747] = {.lex_state = 236},
  [3748] = {.lex_state = 236},
  [3749] = {.lex_state = 236},
  [3750] = {.lex_state = 236},
  [3751] = {.lex_state = 236},
  [3752] = {.lex_state = 236},
  [3753] = {.lex_state = 236},
  [3754] = {.lex_state = 236},
  [3755] = {.lex_state = 236},
  [3756] = {.lex_state = 203},
  [3757] = {.lex_state = 206},
  [3758] = {.lex_state = 236},
  [3759] = {.lex_state = 203},
  [3760] = {.lex_state = 206},
  [3761] = {.lex_state = 206},
  [3762] = {.lex_state = 206},
  [3763] = {.lex_state = 206},
  [3764] = {.lex_state = 206},
  [3765] = {.lex_state = 201},
  [3766] = {.lex_state = 236},
  [3767] = {.lex_state = 203},
  [3768] = {.lex_state = 236},
  [3769] = {.lex_state = 206},
  [3770] = {.lex_state = 236},
  [3771] = {.lex_state = 206},
  [3772] = {.lex_state = 203},
  [3773] = {.lex_state = 206},
  [3774] = {.lex_state = 190},
  [3775] = {.lex_state = 206},
  [3776] = {.lex_state = 203},
  [3777] = {.lex_state = 206},
  [3778] = {.lex_state = 203},
  [3779] = {.lex_state = 206},
  [3780] = {.lex_state = 206},
  [3781] = {.lex_state = 236},
  [3782] = {.lex_state = 206},
  [3783] = {.lex_state = 206},
  [3784] = {.lex_state = 206},
  [3785] = {.lex_state = 203},
  [3786] = {.lex_state = 190},
  [3787] = {.lex_state = 206},
  [3788] = {.lex_state = 206},
  [3789] = {.lex_state = 206},
  [3790] = {.lex_state = 206},
  [3791] = {.lex_state = 206},
  [3792] = {.lex_state = 225},
  [3793] = {.lex_state = 203},
  [3794] = {.lex_state = 201},
  [3795] = {.lex_state = 206},
  [3796] = {.lex_state = 206},
  [3797] = {.lex_state = 203},
  [3798] = {.lex_state = 236},
  [3799] = {.lex_state = 201},
  [3800] = {.lex_state = 206},
  [3801] = {.lex_state = 203},
  [3802] = {.lex_state = 206},
  [3803] = {.lex_state = 236},
  [3804] = {.lex_state = 203},
  [3805] = {.lex_state = 206},
  [3806] = {.lex_state = 201},
  [3807] = {.lex_state = 206},
  [3808] = {.lex_state = 203},
  [3809] = {.lex_state = 236},
  [3810] = {.lex_state = 203},
  [3811] = {.lex_state = 236},
  [3812] = {.lex_state = 206},
  [3813] = {.lex_state = 206},
  [3814] = {.lex_state = 203},
  [3815] = {.lex_state = 206},
  [3816] = {.lex_state = 206},
  [3817] = {.lex_state = 206},
  [3818] = {.lex_state = 206},
  [3819] = {.lex_state = 206},
  [3820] = {.lex_state = 235},
  [3821] = {.lex_state = 203},
  [3822] = {.lex_state = 206},
  [3823] = {.lex_state = 206},
  [3824] = {.lex_state = 206},
  [3825] = {.lex_state = 203},
  [3826] = {.lex_state = 203},
  [3827] = {.lex_state = 206},
  [3828] = {.lex_state = 206},
  [3829] = {.lex_state = 203},
  [3830] = {.lex_state = 206},
  [3831] = {.lex_state = 236},
  [3832] = {.lex_state = 206},
  [3833] = {.lex_state = 206},
  [3834] = {.lex_state = 206},
  [3835] = {.lex_state = 206},
  [3836] = {.lex_state = 203},
  [3837] = {.lex_state = 203},
  [3838] = {.lex_state = 206},
  [3839] = {.lex_state = 203},
  [3840] = {.lex_state = 203},
  [3841] = {.lex_state = 206},
  [3842] = {.lex_state = 203},
  [3843] = {.lex_state = 206},
  [3844] = {.lex_state = 238},
  [3845] = {.lex_state = 236},
  [3846] = {.lex_state = 203},
  [3847] = {.lex_state = 203},
  [3848] = {.lex_state = 206},
  [3849] = {.lex_state = 238},
  [3850] = {.lex_state = 203},
  [3851] = {.lex_state = 235},
  [3852] = {.lex_state = 236},
  [3853] = {.lex_state = 190},
  [3854] = {.lex_state = 236},
  [3855] = {.lex_state = 236},
  [3856] = {.lex_state = 236},
  [3857] = {.lex_state = 206},
  [3858] = {.lex_state = 190},
  [3859] = {.lex_state = 206},
  [3860] = {.lex_state = 236},
  [3861] = {.lex_state = 203},
  [3862] = {.lex_state = 236},
  [3863] = {.lex_state = 203},
  [3864] = {.lex_state = 203},
  [3865] = {.lex_state = 203},
  [3866] = {.lex_state = 239},
  [3867] = {.lex_state = 236},
  [3868] = {.lex_state = 206},
  [3869] = {.lex_state = 206},
  [3870] = {.lex_state = 206},
  [3871] = {.lex_state = 206},
  [3872] = {.lex_state = 201},
  [3873] = {.lex_state = 203},
  [3874] = {.lex_state = 206},
  [3875] = {.lex_state = 201},
  [3876] = {.lex_state = 236},
  [3877] = {.lex_state = 239},
  [3878] = {.lex_state = 206},
  [3879] = {.lex_state = 235},
  [3880] = {.lex_state = 203},
  [3881] = {.lex_state = 222},
  [3882] = {.lex_state = 201},
  [3883] = {.lex_state = 239},
  [3884] = {.lex_state = 201},
  [3885] = {.lex_state = 201},
  [3886] = {.lex_state = 201},
  [3887] = {.lex_state = 201},
  [3888] = {.lex_state = 201},
  [3889] = {.lex_state = 201},
  [3890] = {.lex_state = 201},
  [3891] = {.lex_state = 201},
  [3892] = {.lex_state = 235},
  [3893] = {.lex_state = 201},
  [3894] = {.lex_state = 190},
  [3895] = {.lex_state = 235},
  [3896] = {.lex_state = 190},
  [3897] = {.lex_state = 201},
  [3898] = {.lex_state = 201},
  [3899] = {.lex_state = 201},
  [3900] = {.lex_state = 201},
  [3901] = {.lex_state = 201},
  [3902] = {.lex_state = 190},
  [3903] = {.lex_state = 222},
  [3904] = {.lex_state = 240},
  [3905] = {.lex_state = 201},
  [3906] = {.lex_state = 201},
  [3907] = {.lex_state = 201},
  [3908] = {.lex_state = 201},
  [3909] = {.lex_state = 240},
  [3910] = {.lex_state = 201},
  [3911] = {.lex_state = 201},
  [3912] = {.lex_state = 201},
  [3913] = {.lex_state = 238},
  [3914] = {.lex_state = 201},
  [3915] = {.lex_state = 190},
  [3916] = {.lex_state = 201},
  [3917] = {.lex_state = 201},
  [3918] = {.lex_state = 201},
  [3919] = {.lex_state = 201},
  [3920] = {.lex_state = 201},
  [3921] = {.lex_state = 239},
  [3922] = {.lex_state = 201},
  [3923] = {.lex_state = 201},
  [3924] = {.lex_state = 201},
  [3925] = {.lex_state = 201},
  [3926] = {.lex_state = 201},
  [3927] = {.lex_state = 201},
  [3928] = {.lex_state = 239},
  [3929] = {.lex_state = 201},
  [3930] = {.lex_state = 201},
  [3931] = {.lex_state = 201},
  [3932] = {.lex_state = 238},
  [3933] = {.lex_state = 235},
  [3934] = {.lex_state = 240},
  [3935] = {.lex_state = 201},
  [3936] = {.lex_state = 235},
  [3937] = {.lex_state = 201},
  [3938] = {.lex_state = 201},
  [3939] = {.lex_state = 225},
  [3940] = {.lex_state = 239},
  [3941] = {.lex_state = 225},
  [3942] = {.lex_state = 201},
  [3943] = {.lex_state = 201},
  [3944] = {.lex_state = 203},
  [3945] = {.lex_state = 239},
  [3946] = {.lex_state = 240},
  [3947] = {.lex_state = 238},
  [3948] = {.lex_state = 201},
  [3949] = {.lex_state = 238},
  [3950] = {.lex_state = 201},
  [3951] = {.lex_state = 203},
  [3952] = {.lex_state = 225},
  [3953] = {.lex_state = 239},
  [3954] = {.lex_state = 203},
  [3955] = {.lex_state = 203},
  [3956] = {.lex_state = 201},
  [3957] = {.lex_state = 238},
  [3958] = {.lex_state = 239},
  [3959] = {.lex_state = 235},
  [3960] = {.lex_state = 201},
  [3961] = {.lex_state = 235},
  [3962] = {.lex_state = 201},
  [3963] = {.lex_state = 236},
  [3964] = {.lex_state = 236},
  [3965] = {.lex_state = 222},
  [3966] = {.lex_state = 236},
  [3967] = {.lex_state = 236},
  [3968] = {.lex_state = 236},
  [3969] = {.lex_state = 238},
  [3970] = {.lex_state = 201},
  [3971] = {.lex_state = 236},
  [3972] = {.lex_state = 222},
  [3973] = {.lex_state = 238},
  [3974] = {.lex_state = 236},
  [3975] = {.lex_state = 236},
  [3976] = {.lex_state = 236},
  [3977] = {.lex_state = 236},
  [3978] = {.lex_state = 236},
  [3979] = {.lex_state = 236},
  [3980] = {.lex_state = 238},
  [3981] = {.lex_state = 226},
  [3982] = {.lex_state = 226},
  [3983] = {.lex_state = 236},
  [3984] = {.lex_state = 236},
  [3985] = {.lex_state = 236},
  [3986] = {.lex_state = 236},
  [3987] = {.lex_state = 235},
  [3988] = {.lex_state = 238},
  [3989] = {.lex_state = 235},
  [3990] = {.lex_state = 201},
  [3991] = {.lex_state = 201},
  [3992] = {.lex_state = 236},
  [3993] = {.lex_state = 236},
  [3994] = {.lex_state = 236},
  [3995] = {.lex_state = 236},
  [3996] = {.lex_state = 238},
  [3997] = {.lex_state = 236},
  [3998] = {.lex_state = 235},
  [3999] = {.lex_state = 236},
  [4000] = {.lex_state = 235},
  [4001] = {.lex_state = 236},
  [4002] = {.lex_state = 236},
  [4003] = {.lex_state = 238},
  [4004] = {.lex_state = 235},
  [4005] = {.lex_state = 236},
  [4006] = {.lex_state = 238},
  [4007] = {.lex_state = 236},
  [4008] = {.lex_state = 236},
  [4009] = {.lex_state = 236},
  [4010] = {.lex_state = 201},
  [4011] = {.lex_state = 201},
  [4012] = {.lex_state = 240},
  [4013] = {.lex_state = 203},
  [4014] = {.lex_state = 203},
  [4015] = {.lex_state = 239},
  [4016] = {.lex_state = 201},
  [4017] = {.lex_state = 239},
  [4018] = {.lex_state = 236},
  [4019] = {.lex_state = 239},
  [4020] = {.lex_state = 201},
  [4021] = {.lex_state = 201},
  [4022] = {.lex_state = 201},
  [4023] = {.lex_state = 201},
  [4024] = {.lex_state = 201},
  [4025] = {.lex_state = 201},
  [4026] = {.lex_state = 201},
  [4027] = {.lex_state = 242},
  [4028] = {.lex_state = 203},
  [4029] = {.lex_state = 201},
  [4030] = {.lex_state = 203},
  [4031] = {.lex_state = 236},
  [4032] = {.lex_state = 201},
  [4033] = {.lex_state = 239},
  [4034] = {.lex_state = 201},
  [4035] = {.lex_state = 236},
  [4036] = {.lex_state = 201},
  [4037] = {.lex_state = 201},
  [4038] = {.lex_state = 236},
  [4039] = {.lex_state = 201},
  [4040] = {.lex_state = 201},
  [4041] = {.lex_state = 242},
  [4042] = {.lex_state = 238},
  [4043] = {.lex_state = 240},
  [4044] = {.lex_state = 236},
  [4045] = {.lex_state = 201},
  [4046] = {.lex_state = 201},
  [4047] = {.lex_state = 201},
  [4048] = {.lex_state = 239},
  [4049] = {.lex_state = 201},
  [4050] = {.lex_state = 201},
  [4051] = {.lex_state = 201},
  [4052] = {.lex_state = 238},
  [4053] = {.lex_state = 201},
  [4054] = {.lex_state = 201},
  [4055] = {.lex_state = 236},
  [4056] = {.lex_state = 201},
  [4057] = {.lex_state = 201},
  [4058] = {.lex_state = 201},
  [4059] = {.lex_state = 201},
  [4060] = {.lex_state = 236},
  [4061] = {.lex_state = 201},
  [4062] = {.lex_state = 201},
  [4063] = {.lex_state = 201},
  [4064] = {.lex_state = 201},
  [4065] = {.lex_state = 222},
  [4066] = {.lex_state = 222},
  [4067] = {.lex_state = 226},
  [4068] = {.lex_state = 239},
  [4069] = {.lex_state = 201},
  [4070] = {.lex_state = 238},
  [4071] = {.lex_state = 235},
  [4072] = {.lex_state = 235},
  [4073] = {.lex_state = 203},
  [4074] = {.lex_state = 238},
  [4075] = {.lex_state = 238},
  [4076] = {.lex_state = 201},
  [4077] = {.lex_state = 235},
  [4078] = {.lex_state = 222},
  [4079] = {.lex_state = 222},
  [4080] = {.lex_state = 222},
  [4081] = {.lex_state = 203},
  [4082] = {.lex_state = 201},
  [4083] = {.lex_state = 201},
  [4084] = {.lex_state = 235},
  [4085] = {.lex_state = 235},
  [4086] = {.lex_state = 201},
  [4087] = {.lex_state = 201},
  [4088] = {.lex_state = 226},
  [4089] = {.lex_state = 222},
  [4090] = {.lex_state = 201},
  [4091] = {.lex_state = 239},
  [4092] = {.lex_state = 239},
  [4093] = {.lex_state = 201},
  [4094] = {.lex_state = 242},
  [4095] = {.lex_state = 238},
  [4096] = {.lex_state = 201},
  [4097] = {.lex_state = 239},
  [4098] = {.lex_state = 239},
  [4099] = {.lex_state = 201},
  [4100] = {.lex_state = 222},
  [4101] = {.lex_state = 201},
  [4102] = {.lex_state = 201},
  [4103] = {.lex_state = 201},
  [4104] = {.lex_state = 203},
  [4105] = {.lex_state = 201},
  [4106] = {.lex_state = 201},
  [4107] = {.lex_state = 203},
  [4108] = {.lex_state = 238},
  [4109] = {.lex_state = 239},
  [4110] = {.lex_state = 239},
  [4111] = {.lex_state = 201},
  [4112] = {.lex_state = 201},
  [4113] = {.lex_state = 222},
  [4114] = {.lex_state = 239},
  [4115] = {.lex_state = 201},
  [4116] = {.lex_state = 203},
  [4117] = {.lex_state = 201},
  [4118] = {.lex_state = 235},
  [4119] = {.lex_state = 201},
  [4120] = {.lex_state = 201},
  [4121] = {.lex_state = 226},
  [4122] = {.lex_state = 226},
  [4123] = {.lex_state = 239},
  [4124] = {.lex_state = 239},
  [4125] = {.lex_state = 239},
  [4126] = {.lex_state = 203},
  [4127] = {.lex_state = 204},
  [4128] = {.lex_state = 201},
  [4129] = {.lex_state = 239},
  [4130] = {.lex_state = 239},
  [4131] = {.lex_state = 239},
  [4132] = {.lex_state = 239},
  [4133] = {.lex_state = 239},
  [4134] = {.lex_state = 239},
  [4135] = {.lex_state = 239},
  [4136] = {.lex_state = 239},
  [4137] = {.lex_state = 239},
  [4138] = {.lex_state = 239},
  [4139] = {.lex_state = 239},
  [4140] = {.lex_state = 204},
  [4141] = {.lex_state = 201},
  [4142] = {.lex_state = 202},
  [4143] = {.lex_state = 201},
  [4144] = {.lex_state = 222},
  [4145] = {.lex_state = 202},
  [4146] = {.lex_state = 201},
  [4147] = {.lex_state = 235},
  [4148] = {.lex_state = 235},
  [4149] = {.lex_state = 238},
  [4150] = {.lex_state = 222},
  [4151] = {.lex_state = 201},
  [4152] = {.lex_state = 222},
  [4153] = {.lex_state = 238},
  [4154] = {.lex_state = 203},
  [4155] = {.lex_state = 222},
  [4156] = {.lex_state = 222},
  [4157] = {.lex_state = 222},
  [4158] = {.lex_state = 235},
  [4159] = {.lex_state = 235},
  [4160] = {.lex_state = 239},
  [4161] = {.lex_state = 239},
  [4162] = {.lex_state = 222},
  [4163] = {.lex_state = 222},
  [4164] = {.lex_state = 239},
  [4165] = {.lex_state = 226},
  [4166] = {.lex_state = 226},
  [4167] = {.lex_state = 227},
  [4168] = {.lex_state = 204},
  [4169] = {.lex_state = 226},
  [4170] = {.lex_state = 226},
  [4171] = {.lex_state = 226},
  [4172] = {.lex_state = 226},
  [4173] = {.lex_state = 226},
  [4174] = {.lex_state = 226},
  [4175] = {.lex_state = 235},
  [4176] = {.lex_state = 227},
  [4177] = {.lex_state = 239},
  [4178] = {.lex_state = 226},
  [4179] = {.lex_state = 242},
  [4180] = {.lex_state = 226},
  [4181] = {.lex_state = 201},
  [4182] = {.lex_state = 201},
  [4183] = {.lex_state = 226},
  [4184] = {.lex_state = 201},
  [4185] = {.lex_state = 239},
  [4186] = {.lex_state = 238},
  [4187] = {.lex_state = 238},
  [4188] = {.lex_state = 238},
  [4189] = {.lex_state = 235},
  [4190] = {.lex_state = 226},
  [4191] = {.lex_state = 201},
  [4192] = {.lex_state = 235},
  [4193] = {.lex_state = 235},
  [4194] = {.lex_state = 235},
  [4195] = {.lex_state = 226},
  [4196] = {.lex_state = 235},
  [4197] = {.lex_state = 239},
  [4198] = {.lex_state = 235},
  [4199] = {.lex_state = 201},
  [4200] = {.lex_state = 201},
  [4201] = {.lex_state = 226},
  [4202] = {.lex_state = 226},
  [4203] = {.lex_state = 239},
  [4204] = {.lex_state = 242},
  [4205] = {.lex_state = 226},
  [4206] = {.lex_state = 201},
  [4207] = {.lex_state = 222},
  [4208] = {.lex_state = 238},
  [4209] = {.lex_state = 226},
  [4210] = {.lex_state = 204},
  [4211] = {.lex_state = 238},
  [4212] = {.lex_state = 239},
  [4213] = {.lex_state = 201},
  [4214] = {.lex_state = 201},
  [4215] = {.lex_state = 201},
  [4216] = {.lex_state = 201},
  [4217] = {.lex_state = 239},
  [4218] = {.lex_state = 239},
  [4219] = {.lex_state = 239},
  [4220] = {.lex_state = 201},
  [4221] = {.lex_state = 203},
  [4222] = {.lex_state = 239},
  [4223] = {.lex_state = 235},
  [4224] = {.lex_state = 201},
  [4225] = {.lex_state = 201},
  [4226] = {.lex_state = 201},
  [4227] = {.lex_state = 235},
  [4228] = {.lex_state = 235},
  [4229] = {.lex_state = 201},
  [4230] = {.lex_state = 201},
  [4231] = {.lex_state = 201},
  [4232] = {.lex_state = 201},
  [4233] = {.lex_state = 201},
  [4234] = {.lex_state = 201},
  [4235] = {.lex_state = 201},
  [4236] = {.lex_state = 239},
  [4237] = {.lex_state = 235},
  [4238] = {.lex_state = 201},
  [4239] = {.lex_state = 235},
  [4240] = {.lex_state = 203},
  [4241] = {.lex_state = 201},
  [4242] = {.lex_state = 201},
  [4243] = {.lex_state = 201},
  [4244] = {.lex_state = 201},
  [4245] = {.lex_state = 201},
  [4246] = {.lex_state = 239},
  [4247] = {.lex_state = 201},
  [4248] = {.lex_state = 201},
  [4249] = {.lex_state = 201},
  [4250] = {.lex_state = 201},
  [4251] = {.lex_state = 201},
  [4252] = {.lex_state = 201},
  [4253] = {.lex_state = 201},
  [4254] = {.lex_state = 242},
  [4255] = {.lex_state = 201},
  [4256] = {.lex_state = 201},
  [4257] = {.lex_state = 235},
  [4258] = {.lex_state = 235},
  [4259] = {.lex_state = 235},
  [4260] = {.lex_state = 235},
  [4261] = {.lex_state = 201},
  [4262] = {.lex_state = 242},
  [4263] = {.lex_state = 201},
  [4264] = {.lex_state = 201},
  [4265] = {.lex_state = 201},
  [4266] = {.lex_state = 235},
  [4267] = {.lex_state = 239},
  [4268] = {.lex_state = 238},
  [4269] = {.lex_state = 238},
  [4270] = {.lex_state = 201},
  [4271] = {.lex_state = 201},
  [4272] = {.lex_state = 201},
  [4273] = {.lex_state = 201},
  [4274] = {.lex_state = 239},
  [4275] = {.lex_state = 201},
  [4276] = {.lex_state = 201},
  [4277] = {.lex_state = 201},
  [4278] = {.lex_state = 226},
  [4279] = {.lex_state = 204},
  [4280] = {.lex_state = 201},
  [4281] = {.lex_state = 201},
  [4282] = {.lex_state = 226},
  [4283] = {.lex_state = 226},
  [4284] = {.lex_state = 235},
  [4285] = {.lex_state = 221},
  [4286] = {.lex_state = 201},
  [4287] = {.lex_state = 235},
  [4288] = {.lex_state = 235},
  [4289] = {.lex_state = 235},
  [4290] = {.lex_state = 235},
  [4291] = {.lex_state = 235},
  [4292] = {.lex_state = 235},
  [4293] = {.lex_state = 201},
  [4294] = {.lex_state = 201},
  [4295] = {.lex_state = 226},
  [4296] = {.lex_state = 201},
  [4297] = {.lex_state = 235},
  [4298] = {.lex_state = 241},
  [4299] = {.lex_state = 201},
  [4300] = {.lex_state = 201},
  [4301] = {.lex_state = 201},
  [4302] = {.lex_state = 201},
  [4303] = {.lex_state = 201},
  [4304] = {.lex_state = 226},
  [4305] = {.lex_state = 201},
  [4306] = {.lex_state = 235},
  [4307] = {.lex_state = 202},
  [4308] = {.lex_state = 235},
  [4309] = {.lex_state = 201},
  [4310] = {.lex_state = 226},
  [4311] = {.lex_state = 239},
  [4312] = {.lex_state = 201},
  [4313] = {.lex_state = 222},
  [4314] = {.lex_state = 201},
  [4315] = {.lex_state = 226},
  [4316] = {.lex_state = 226},
  [4317] = {.lex_state = 201},
  [4318] = {.lex_state = 226},
  [4319] = {.lex_state = 239},
  [4320] = {.lex_state = 201},
  [4321] = {.lex_state = 226},
  [4322] = {.lex_state = 226},
  [4323] = {.lex_state = 226},
  [4324] = {.lex_state = 226},
  [4325] = {.lex_state = 226},
  [4326] = {.lex_state = 226},
  [4327] = {.lex_state = 235},
  [4328] = {.lex_state = 226},
  [4329] = {.lex_state = 235},
  [4330] = {.lex_state = 226},
  [4331] = {.lex_state = 201},
  [4332] = {.lex_state = 239},
  [4333] = {.lex_state = 235},
  [4334] = {.lex_state = 235},
  [4335] = {.lex_state = 235},
  [4336] = {.lex_state = 235},
  [4337] = {.lex_state = 235},
  [4338] = {.lex_state = 235},
  [4339] = {.lex_state = 201},
  [4340] = {.lex_state = 235},
  [4341] = {.lex_state = 201},
  [4342] = {.lex_state = 201},
  [4343] = {.lex_state = 235},
  [4344] = {.lex_state = 226},
  [4345] = {.lex_state = 204},
  [4346] = {.lex_state = 226},
  [4347] = {.lex_state = 222},
  [4348] = {.lex_state = 201},
  [4349] = {.lex_state = 201},
  [4350] = {.lex_state = 235},
  [4351] = {.lex_state = 239},
  [4352] = {.lex_state = 239},
  [4353] = {.lex_state = 235},
  [4354] = {.lex_state = 235},
  [4355] = {.lex_state = 201},
  [4356] = {.lex_state = 235},
  [4357] = {.lex_state = 222},
  [4358] = {.lex_state = 235},
  [4359] = {.lex_state = 235},
  [4360] = {.lex_state = 222},
  [4361] = {.lex_state = 226},
  [4362] = {.lex_state = 201},
  [4363] = {.lex_state = 226},
  [4364] = {.lex_state = 201},
  [4365] = {.lex_state = 226},
  [4366] = {.lex_state = 226},
  [4367] = {.lex_state = 226},
  [4368] = {.lex_state = 201},
  [4369] = {.lex_state = 201},
  [4370] = {.lex_state = 225},
  [4371] = {.lex_state = 203},
  [4372] = {.lex_state = 226},
  [4373] = {.lex_state = 201},
  [4374] = {.lex_state = 201},
  [4375] = {.lex_state = 235},
  [4376] = {.lex_state = 201},
  [4377] = {.lex_state = 226},
  [4378] = {.lex_state = 201},
  [4379] = {.lex_state = 226},
  [4380] = {.lex_state = 203},
  [4381] = {.lex_state = 226},
  [4382] = {.lex_state = 226},
  [4383] = {.lex_state = 226},
  [4384] = {.lex_state = 203},
  [4385] = {.lex_state = 235},
  [4386] = {.lex_state = 201},
  [4387] = {.lex_state = 201},
  [4388] = {.lex_state = 201},
  [4389] = {.lex_state = 201},
  [4390] = {.lex_state = 203},
  [4391] = {.lex_state = 201},
  [4392] = {.lex_state = 201},
  [4393] = {.lex_state = 201},
  [4394] = {.lex_state = 235},
  [4395] = {.lex_state = 226},
  [4396] = {.lex_state = 241},
  [4397] = {.lex_state = 201},
  [4398] = {.lex_state = 201},
  [4399] = {.lex_state = 201},
  [4400] = {.lex_state = 201},
  [4401] = {.lex_state = 201},
  [4402] = {.lex_state = 201},
  [4403] = {.lex_state = 235},
  [4404] = {.lex_state = 201},
  [4405] = {.lex_state = 203},
  [4406] = {.lex_state = 235},
  [4407] = {.lex_state = 235},
  [4408] = {.lex_state = 241},
  [4409] = {.lex_state = 235},
  [4410] = {.lex_state = 227},
  [4411] = {.lex_state = 201},
  [4412] = {.lex_state = 201},
  [4413] = {.lex_state = 226},
  [4414] = {.lex_state = 235},
  [4415] = {.lex_state = 241},
  [4416] = {.lex_state = 203},
  [4417] = {.lex_state = 235},
  [4418] = {.lex_state = 235},
  [4419] = {.lex_state = 235},
  [4420] = {.lex_state = 201},
  [4421] = {.lex_state = 201},
  [4422] = {.lex_state = 201},
  [4423] = {.lex_state = 201},
  [4424] = {.lex_state = 203},
  [4425] = {.lex_state = 201},
  [4426] = {.lex_state = 201},
  [4427] = {.lex_state = 239},
  [4428] = {.lex_state = 201},
  [4429] = {.lex_state = 239},
  [4430] = {.lex_state = 226},
  [4431] = {.lex_state = 239},
  [4432] = {.lex_state = 201},
  [4433] = {.lex_state = 203},
  [4434] = {.lex_state = 203},
  [4435] = {.lex_state = 201},
  [4436] = {.lex_state = 203},
  [4437] = {.lex_state = 239},
  [4438] = {.lex_state = 239},
  [4439] = {.lex_state = 239},
  [4440] = {.lex_state = 239},
  [4441] = {.lex_state = 201},
  [4442] = {.lex_state = 201},
  [4443] = {.lex_state = 226},
  [4444] = {.lex_state = 226},
  [4445] = {.lex_state = 203},
  [4446] = {.lex_state = 203},
  [4447] = {.lex_state = 201},
  [4448] = {.lex_state = 203},
  [4449] = {.lex_state = 203},
  [4450] = {.lex_state = 203},
  [4451] = {.lex_state = 203},
  [4452] = {.lex_state = 203},
  [4453] = {.lex_state = 203},
  [4454] = {.lex_state = 203},
  [4455] = {.lex_state = 203},
  [4456] = {.lex_state = 226},
  [4457] = {.lex_state = 203},
  [4458] = {.lex_state = 203},
  [4459] = {.lex_state = 203},
  [4460] = {.lex_state = 203},
  [4461] = {.lex_state = 203},
  [4462] = {.lex_state = 203},
  [4463] = {.lex_state = 203},
  [4464] = {.lex_state = 239},
  [4465] = {.lex_state = 239},
  [4466] = {.lex_state = 201},
  [4467] = {.lex_state = 239},
  [4468] = {.lex_state = 239},
  [4469] = {.lex_state = 222},
  [4470] = {.lex_state = 201},
  [4471] = {.lex_state = 201},
  [4472] = {.lex_state = 226},
  [4473] = {.lex_state = 235},
  [4474] = {.lex_state = 201},
  [4475] = {.lex_state = 201},
  [4476] = {.lex_state = 201},
  [4477] = {.lex_state = 201},
  [4478] = {.lex_state = 203},
  [4479] = {.lex_state = 239},
  [4480] = {.lex_state = 226},
  [4481] = {.lex_state = 226},
  [4482] = {.lex_state = 239},
  [4483] = {.lex_state = 201},
  [4484] = {.lex_state = 226},
  [4485] = {.lex_state = 201},
  [4486] = {.lex_state = 201},
  [4487] = {.lex_state = 201},
  [4488] = {.lex_state = 226},
  [4489] = {.lex_state = 235},
  [4490] = {.lex_state = 201},
  [4491] = {.lex_state = 226},
  [4492] = {.lex_state = 226},
  [4493] = {.lex_state = 226},
  [4494] = {.lex_state = 203},
  [4495] = {.lex_state = 203},
  [4496] = {.lex_state = 203},
  [4497] = {.lex_state = 203},
  [4498] = {.lex_state = 203},
  [4499] = {.lex_state = 226},
  [4500] = {.lex_state = 226},
  [4501] = {.lex_state = 201},
  [4502] = {.lex_state = 226},
  [4503] = {.lex_state = 202},
  [4504] = {.lex_state = 201},
  [4505] = {.lex_state = 201},
  [4506] = {.lex_state = 226},
  [4507] = {.lex_state = 201},
  [4508] = {.lex_state = 201},
  [4509] = {.lex_state = 201},
  [4510] = {.lex_state = 201},
  [4511] = {.lex_state = 201},
  [4512] = {.lex_state = 201},
  [4513] = {.lex_state = 201},
  [4514] = {.lex_state = 201},
  [4515] = {.lex_state = 201},
  [4516] = {.lex_state = 201},
  [4517] = {.lex_state = 201},
  [4518] = {.lex_state = 201},
  [4519] = {.lex_state = 201},
  [4520] = {.lex_state = 201},
  [4521] = {.lex_state = 201},
  [4522] = {.lex_state = 201},
  [4523] = {.lex_state = 201},
  [4524] = {.lex_state = 201},
  [4525] = {.lex_state = 201},
  [4526] = {.lex_state = 226},
  [4527] = {.lex_state = 203},
  [4528] = {.lex_state = 203},
  [4529] = {.lex_state = 203},
  [4530] = {.lex_state = 203},
  [4531] = {.lex_state = 201},
  [4532] = {.lex_state = 203},
  [4533] = {.lex_state = 226},
  [4534] = {.lex_state = 203},
  [4535] = {.lex_state = 201},
  [4536] = {.lex_state = 203},
  [4537] = {.lex_state = 201},
  [4538] = {.lex_state = 201},
  [4539] = {.lex_state = 201},
  [4540] = {.lex_state = 201},
  [4541] = {.lex_state = 201},
  [4542] = {.lex_state = 236},
  [4543] = {.lex_state = 201},
  [4544] = {.lex_state = 201},
  [4545] = {.lex_state = 201},
  [4546] = {.lex_state = 201},
  [4547] = {.lex_state = 201},
  [4548] = {.lex_state = 203},
  [4549] = {.lex_state = 201},
  [4550] = {.lex_state = 203},
  [4551] = {.lex_state = 201},
  [4552] = {.lex_state = 201},
  [4553] = {.lex_state = 201},
  [4554] = {.lex_state = 201},
  [4555] = {.lex_state = 201},
  [4556] = {.lex_state = 201},
  [4557] = {.lex_state = 201},
  [4558] = {.lex_state = 201},
  [4559] = {.lex_state = 235},
  [4560] = {.lex_state = 201},
  [4561] = {.lex_state = 201},
  [4562] = {.lex_state = 201},
  [4563] = {.lex_state = 201},
  [4564] = {.lex_state = 201},
  [4565] = {.lex_state = 201},
  [4566] = {.lex_state = 201},
  [4567] = {.lex_state = 236},
  [4568] = {.lex_state = 203},
  [4569] = {.lex_state = 201},
  [4570] = {.lex_state = 201},
  [4571] = {.lex_state = 201},
  [4572] = {.lex_state = 201},
  [4573] = {.lex_state = 201},
  [4574] = {.lex_state = 201},
  [4575] = {.lex_state = 201},
  [4576] = {.lex_state = 236},
  [4577] = {.lex_state = 201},
  [4578] = {.lex_state = 203},
  [4579] = {.lex_state = 201},
  [4580] = {.lex_state = 201},
  [4581] = {.lex_state = 201},
  [4582] = {.lex_state = 201},
  [4583] = {.lex_state = 201},
  [4584] = {.lex_state = 239},
  [4585] = {.lex_state = 201},
  [4586] = {.lex_state = 239},
  [4587] = {.lex_state = 236},
  [4588] = {.lex_state = 236},
  [4589] = {.lex_state = 201},
  [4590] = {.lex_state = 239},
  [4591] = {.lex_state = 201},
  [4592] = {.lex_state = 201},
  [4593] = {.lex_state = 201},
  [4594] = {.lex_state = 201},
  [4595] = {.lex_state = 201},
  [4596] = {.lex_state = 201},
  [4597] = {.lex_state = 201},
  [4598] = {.lex_state = 201},
  [4599] = {.lex_state = 201},
  [4600] = {.lex_state = 239},
  [4601] = {.lex_state = 239},
  [4602] = {.lex_state = 239},
  [4603] = {.lex_state = 239},
  [4604] = {.lex_state = 201},
  [4605] = {.lex_state = 201},
  [4606] = {.lex_state = 201},
  [4607] = {.lex_state = 201},
  [4608] = {.lex_state = 236},
  [4609] = {.lex_state = 201},
  [4610] = {.lex_state = 239},
  [4611] = {.lex_state = 236},
  [4612] = {.lex_state = 201},
  [4613] = {.lex_state = 201},
  [4614] = {.lex_state = 201},
  [4615] = {.lex_state = 201},
  [4616] = {.lex_state = 201},
  [4617] = {.lex_state = 236},
  [4618] = {.lex_state = 201},
  [4619] = {.lex_state = 235},
  [4620] = {.lex_state = 201},
  [4621] = {.lex_state = 201},
  [4622] = {.lex_state = 239},
  [4623] = {.lex_state = 201},
  [4624] = {.lex_state = 239},
  [4625] = {.lex_state = 239},
  [4626] = {.lex_state = 201},
  [4627] = {.lex_state = 201},
  [4628] = {.lex_state = 239},
  [4629] = {.lex_state = 239},
  [4630] = {.lex_state = 239},
  [4631] = {.lex_state = 201},
  [4632] = {.lex_state = 239},
  [4633] = {.lex_state = 239},
  [4634] = {.lex_state = 239},
  [4635] = {.lex_state = 228},
  [4636] = {.lex_state = 239},
  [4637] = {.lex_state = 228},
  [4638] = {.lex_state = 201},
  [4639] = {.lex_state = 201},
  [4640] = {.lex_state = 201},
  [4641] = {.lex_state = 201},
  [4642] = {.lex_state = 236},
  [4643] = {.lex_state = 201},
  [4644] = {.lex_state = 201},
  [4645] = {.lex_state = 201},
  [4646] = {.lex_state = 201},
  [4647] = {.lex_state = 201},
  [4648] = {.lex_state = 236},
  [4649] = {.lex_state = 201},
  [4650] = {.lex_state = 201},
  [4651] = {.lex_state = 239},
  [4652] = {.lex_state = 236},
  [4653] = {.lex_state = 239},
  [4654] = {.lex_state = 201},
  [4655] = {.lex_state = 239},
  [4656] = {.lex_state = 236},
  [4657] = {.lex_state = 201},
  [4658] = {.lex_state = 239},
  [4659] = {.lex_state = 239},
  [4660] = {.lex_state = 239},
  [4661] = {.lex_state = 236},
  [4662] = {.lex_state = 239},
  [4663] = {.lex_state = 236},
  [4664] = {.lex_state = 239},
  [4665] = {.lex_state = 236},
  [4666] = {.lex_state = 239},
  [4667] = {.lex_state = 239},
  [4668] = {.lex_state = 239},
  [4669] = {.lex_state = 236},
  [4670] = {.lex_state = 239},
  [4671] = {.lex_state = 235},
  [4672] = {.lex_state = 235},
  [4673] = {.lex_state = 235},
  [4674] = {.lex_state = 235},
  [4675] = {.lex_state = 201},
  [4676] = {.lex_state = 201},
  [4677] = {.lex_state = 201},
  [4678] = {.lex_state = 201},
  [4679] = {.lex_state = 201},
  [4680] = {.lex_state = 236},
  [4681] = {.lex_state = 239},
  [4682] = {.lex_state = 239},
  [4683] = {.lex_state = 236},
  [4684] = {.lex_state = 239},
  [4685] = {.lex_state = 201},
  [4686] = {.lex_state = 236},
  [4687] = {.lex_state = 239},
  [4688] = {.lex_state = 239},
  [4689] = {.lex_state = 201},
  [4690] = {.lex_state = 201},
  [4691] = {.lex_state = 239},
  [4692] = {.lex_state = 239},
  [4693] = {.lex_state = 201},
  [4694] = {.lex_state = 201},
  [4695] = {.lex_state = 239},
  [4696] = {.lex_state = 239},
  [4697] = {.lex_state = 236},
  [4698] = {.lex_state = 201},
  [4699] = {.lex_state = 239},
  [4700] = {.lex_state = 201},
  [4701] = {.lex_state = 201},
  [4702] = {.lex_state = 201},
  [4703] = {.lex_state = 201},
  [4704] = {.lex_state = 201},
  [4705] = {.lex_state = 226},
  [4706] = {.lex_state = 236},
  [4707] = {.lex_state = 238},
  [4708] = {.lex_state = 238},
  [4709] = {.lex_state = 238},
  [4710] = {.lex_state = 238},
  [4711] = {.lex_state = 201},
  [4712] = {.lex_state = 236},
  [4713] = {.lex_state = 201},
  [4714] = {.lex_state = 201},
  [4715] = {.lex_state = 201},
  [4716] = {.lex_state = 201},
  [4717] = {.lex_state = 201},
  [4718] = {.lex_state = 236},
  [4719] = {.lex_state = 203},
  [4720] = {.lex_state = 201},
  [4721] = {.lex_state = 201},
  [4722] = {.lex_state = 201},
  [4723] = {.lex_state = 201},
  [4724] = {.lex_state = 201},
  [4725] = {.lex_state = 201},
  [4726] = {.lex_state = 201},
  [4727] = {.lex_state = 201},
  [4728] = {.lex_state = 201},
  [4729] = {.lex_state = 201},
  [4730] = {.lex_state = 201},
  [4731] = {.lex_state = 201},
  [4732] = {.lex_state = 235},
  [4733] = {.lex_state = 226},
  [4734] = {.lex_state = 226},
  [4735] = {.lex_state = 226},
  [4736] = {.lex_state = 226},
  [4737] = {.lex_state = 226},
  [4738] = {.lex_state = 226},
  [4739] = {.lex_state = 226},
  [4740] = {.lex_state = 201},
  [4741] = {.lex_state = 226},
  [4742] = {.lex_state = 226},
  [4743] = {.lex_state = 226},
  [4744] = {.lex_state = 226},
  [4745] = {.lex_state = 226},
  [4746] = {.lex_state = 226},
  [4747] = {.lex_state = 201},
  [4748] = {.lex_state = 226},
  [4749] = {.lex_state = 226},
  [4750] = {.lex_state = 226},
  [4751] = {.lex_state = 226},
  [4752] = {.lex_state = 222},
  [4753] = {.lex_state = 226},
  [4754] = {.lex_state = 239},
  [4755] = {.lex_state = 239},
  [4756] = {.lex_state = 201},
  [4757] = {.lex_state = 201},
  [4758] = {.lex_state = 226},
  [4759] = {.lex_state = 226},
  [4760] = {.lex_state = 226},
  [4761] = {.lex_state = 204},
  [4762] = {.lex_state = 235},
  [4763] = {.lex_state = 201},
  [4764] = {.lex_state = 239},
  [4765] = {.lex_state = 201},
  [4766] = {.lex_state = 226},
  [4767] = {.lex_state = 238},
  [4768] = {.lex_state = 201},
  [4769] = {.lex_state = 201},
  [4770] = {.lex_state = 226},
  [4771] = {.lex_state = 226},
  [4772] = {.lex_state = 226},
  [4773] = {.lex_state = 226},
  [4774] = {.lex_state = 226},
  [4775] = {.lex_state = 226},
  [4776] = {.lex_state = 201},
  [4777] = {.lex_state = 226},
  [4778] = {.lex_state = 226},
  [4779] = {.lex_state = 226},
  [4780] = {.lex_state = 226},
  [4781] = {.lex_state = 239},
  [4782] = {.lex_state = 239},
  [4783] = {.lex_state = 239},
  [4784] = {.lex_state = 239},
  [4785] = {.lex_state = 226},
  [4786] = {.lex_state = 226},
  [4787] = {.lex_state = 238},
  [4788] = {.lex_state = 226},
  [4789] = {.lex_state = 226},
  [4790] = {.lex_state = 239},
  [4791] = {.lex_state = 226},
  [4792] = {.lex_state = 226},
  [4793] = {.lex_state = 226},
  [4794] = {.lex_state = 201},
  [4795] = {.lex_state = 222},
  [4796] = {.lex_state = 235},
  [4797] = {.lex_state = 235},
  [4798] = {.lex_state = 203},
  [4799] = {.lex_state = 235},
  [4800] = {.lex_state = 222},
  [4801] = {.lex_state = 235},
  [4802] = {.lex_state = 238},
  [4803] = {.lex_state = 238},
  [4804] = {.lex_state = 222},
  [4805] = {.lex_state = 238},
  [4806] = {.lex_state = 238},
  [4807] = {.lex_state = 202},
  [4808] = {.lex_state = 235},
  [4809] = {.lex_state = 235},
  [4810] = {.lex_state = 226},
  [4811] = {.lex_state = 238},
  [4812] = {.lex_state = 235},
  [4813] = {.lex_state = 235},
  [4814] = {.lex_state = 235},
  [4815] = {.lex_state = 222},
  [4816] = {.lex_state = 235},
  [4817] = {.lex_state = 203},
  [4818] = {.lex_state = 236},
  [4819] = {.lex_state = 222},
  [4820] = {.lex_state = 222},
  [4821] = {.lex_state = 222},
  [4822] = {.lex_state = 235},
  [4823] = {.lex_state = 235},
  [4824] = {.lex_state = 202},
  [4825] = {.lex_state = 235},
  [4826] = {.lex_state = 238},
  [4827] = {.lex_state = 201},
  [4828] = {.lex_state = 238},
  [4829] = {.lex_state = 235},
  [4830] = {.lex_state = 222},
  [4831] = {.lex_state = 236},
  [4832] = {.lex_state = 235},
  [4833] = {.lex_state = 203},
  [4834] = {.lex_state = 203},
  [4835] = {.lex_state = 203},
  [4836] = {.lex_state = 203},
  [4837] = {.lex_state = 203},
  [4838] = {.lex_state = 235},
  [4839] = {.lex_state = 222},
  [4840] = {.lex_state = 235},
  [4841] = {.lex_state = 238},
  [4842] = {.lex_state = 226},
  [4843] = {.lex_state = 203},
  [4844] = {.lex_state = 222},
  [4845] = {.lex_state = 236},
  [4846] = {.lex_state = 235},
  [4847] = {.lex_state = 235},
  [4848] = {.lex_state = 235},
  [4849] = {.lex_state = 201},
  [4850] = {.lex_state = 235},
  [4851] = {.lex_state = 235},
  [4852] = {.lex_state = 238},
  [4853] = {.lex_state = 235},
  [4854] = {.lex_state = 235},
  [4855] = {.lex_state = 239},
  [4856] = {.lex_state = 235},
  [4857] = {.lex_state = 235},
  [4858] = {.lex_state = 235},
  [4859] = {.lex_state = 236},
  [4860] = {.lex_state = 235},
  [4861] = {.lex_state = 235},
  [4862] = {.lex_state = 235},
  [4863] = {.lex_state = 235},
  [4864] = {.lex_state = 235},
  [4865] = {.lex_state = 235},
  [4866] = {.lex_state = 235},
  [4867] = {.lex_state = 235},
  [4868] = {.lex_state = 235},
  [4869] = {.lex_state = 235},
  [4870] = {.lex_state = 201},
  [4871] = {.lex_state = 238},
  [4872] = {.lex_state = 235},
  [4873] = {.lex_state = 235},
  [4874] = {.lex_state = 239},
  [4875] = {.lex_state = 235},
  [4876] = {.lex_state = 235},
  [4877] = {.lex_state = 235},
  [4878] = {.lex_state = 235},
  [4879] = {.lex_state = 235},
  [4880] = {.lex_state = 235},
  [4881] = {.lex_state = 239},
  [4882] = {.lex_state = 235},
  [4883] = {.lex_state = 235},
  [4884] = {.lex_state = 239},
  [4885] = {.lex_state = 235},
  [4886] = {.lex_state = 201},
  [4887] = {.lex_state = 235},
  [4888] = {.lex_state = 235},
  [4889] = {.lex_state = 235},
  [4890] = {.lex_state = 201},
  [4891] = {.lex_state = 235},
  [4892] = {.lex_state = 235},
  [4893] = {.lex_state = 235},
  [4894] = {.lex_state = 235},
  [4895] = {.lex_state = 235},
  [4896] = {.lex_state = 235},
  [4897] = {.lex_state = 235},
  [4898] = {.lex_state = 235},
  [4899] = {.lex_state = 235},
  [4900] = {.lex_state = 238},
  [4901] = {.lex_state = 239},
  [4902] = {.lex_state = 238},
  [4903] = {.lex_state = 239},
  [4904] = {.lex_state = 236},
  [4905] = {.lex_state = 239},
  [4906] = {.lex_state = 236},
  [4907] = {.lex_state = 239},
  [4908] = {.lex_state = 239},
  [4909] = {.lex_state = 238},
  [4910] = {.lex_state = 238},
  [4911] = {.lex_state = 222},
  [4912] = {.lex_state = 239},
  [4913] = {.lex_state = 239},
  [4914] = {.lex_state = 238},
  [4915] = {.lex_state = 239},
  [4916] = {.lex_state = 235},
  [4917] = {.lex_state = 239},
  [4918] = {.lex_state = 238},
  [4919] = {.lex_state = 238},
  [4920] = {.lex_state = 239},
  [4921] = {.lex_state = 222},
  [4922] = {.lex_state = 238},
  [4923] = {.lex_state = 203},
  [4924] = {.lex_state = 236},
  [4925] = {.lex_state = 236},
  [4926] = {.lex_state = 236},
  [4927] = {.lex_state = 193},
  [4928] = {.lex_state = 236},
  [4929] = {.lex_state = 238},
  [4930] = {.lex_state = 238},
  [4931] = {.lex_state = 236},
  [4932] = {.lex_state = 238},
  [4933] = {.lex_state = 239},
  [4934] = {.lex_state = 236},
  [4935] = {.lex_state = 203},
  [4936] = {.lex_state = 238},
  [4937] = {.lex_state = 236},
  [4938] = {.lex_state = 203},
  [4939] = {.lex_state = 193},
  [4940] = {.lex_state = 239},
  [4941] = {.lex_state = 193},
  [4942] = {.lex_state = 236},
  [4943] = {.lex_state = 236},
  [4944] = {.lex_state = 238},
  [4945] = {.lex_state = 238},
  [4946] = {.lex_state = 236},
  [4947] = {.lex_state = 203},
  [4948] = {.lex_state = 236},
  [4949] = {.lex_state = 236},
  [4950] = {.lex_state = 239},
  [4951] = {.lex_state = 236},
  [4952] = {.lex_state = 236},
  [4953] = {.lex_state = 193},
  [4954] = {.lex_state = 238},
  [4955] = {.lex_state = 203},
  [4956] = {.lex_state = 236},
  [4957] = {.lex_state = 236},
  [4958] = {.lex_state = 236},
  [4959] = {.lex_state = 236},
  [4960] = {.lex_state = 236},
  [4961] = {.lex_state = 236},
  [4962] = {.lex_state = 238},
  [4963] = {.lex_state = 236},
  [4964] = {.lex_state = 236},
  [4965] = {.lex_state = 236},
  [4966] = {.lex_state = 236},
  [4967] = {.lex_state = 236},
  [4968] = {.lex_state = 236},
  [4969] = {.lex_state = 193},
  [4970] = {.lex_state = 238},
  [4971] = {.lex_state = 236},
  [4972] = {.lex_state = 236},
  [4973] = {.lex_state = 239},
  [4974] = {.lex_state = 238},
  [4975] = {.lex_state = 236},
  [4976] = {.lex_state = 236},
  [4977] = {.lex_state = 238},
  [4978] = {.lex_state = 236},
  [4979] = {.lex_state = 236},
  [4980] = {.lex_state = 193},
  [4981] = {.lex_state = 236},
  [4982] = {.lex_state = 193},
  [4983] = {.lex_state = 236},
  [4984] = {.lex_state = 236},
  [4985] = {.lex_state = 238},
  [4986] = {.lex_state = 193},
  [4987] = {.lex_state = 236},
  [4988] = {.lex_state = 236},
  [4989] = {.lex_state = 193},
  [4990] = {.lex_state = 193},
  [4991] = {.lex_state = 193},
  [4992] = {.lex_state = 201},
  [4993] = {.lex_state = 193},
  [4994] = {.lex_state = 193},
  [4995] = {.lex_state = 193},
  [4996] = {.lex_state = 193},
  [4997] = {.lex_state = 193},
  [4998] = {.lex_state = 193},
  [4999] = {.lex_state = 193},
  [5000] = {.lex_state = 193},
  [5001] = {.lex_state = 193},
  [5002] = {.lex_state = 193},
  [5003] = {.lex_state = 193},
  [5004] = {.lex_state = 193},
  [5005] = {.lex_state = 193},
  [5006] = {.lex_state = 193},
  [5007] = {.lex_state = 193},
  [5008] = {.lex_state = 193},
  [5009] = {.lex_state = 193},
  [5010] = {.lex_state = 193},
  [5011] = {.lex_state = 193},
  [5012] = {.lex_state = 193},
  [5013] = {.lex_state = 193},
  [5014] = {.lex_state = 193},
  [5015] = {.lex_state = 193},
  [5016] = {.lex_state = 193},
  [5017] = {.lex_state = 193},
  [5018] = {.lex_state = 193},
  [5019] = {.lex_state = 193},
  [5020] = {.lex_state = 193},
  [5021] = {.lex_state = 193},
  [5022] = {.lex_state = 193},
  [5023] = {.lex_state = 193},
  [5024] = {.lex_state = 193},
  [5025] = {.lex_state = 193},
  [5026] = {.lex_state = 193},
  [5027] = {.lex_state = 193},
  [5028] = {.lex_state = 193},
  [5029] = {.lex_state = 193},
  [5030] = {.lex_state = 193},
  [5031] = {.lex_state = 193},
  [5032] = {.lex_state = 193},
  [5033] = {.lex_state = 193},
  [5034] = {.lex_state = 193},
  [5035] = {.lex_state = 193},
  [5036] = {.lex_state = 193},
  [5037] = {.lex_state = 193},
  [5038] = {.lex_state = 193},
  [5039] = {.lex_state = 193},
  [5040] = {.lex_state = 193},
  [5041] = {.lex_state = 193},
  [5042] = {.lex_state = 193},
  [5043] = {.lex_state = 193},
  [5044] = {.lex_state = 193},
  [5045] = {.lex_state = 193},
  [5046] = {.lex_state = 193},
  [5047] = {.lex_state = 193},
  [5048] = {.lex_state = 193},
  [5049] = {.lex_state = 193},
  [5050] = {.lex_state = 193},
  [5051] = {.lex_state = 238},
  [5052] = {.lex_state = 238},
  [5053] = {.lex_state = 238},
  [5054] = {.lex_state = 238},
  [5055] = {.lex_state = 193},
  [5056] = {.lex_state = 193},
  [5057] = {.lex_state = 193},
  [5058] = {.lex_state = 193},
  [5059] = {.lex_state = 193},
  [5060] = {.lex_state = 193},
  [5061] = {.lex_state = 193},
  [5062] = {.lex_state = 193},
  [5063] = {.lex_state = 193},
  [5064] = {.lex_state = 193},
  [5065] = {.lex_state = 193},
  [5066] = {.lex_state = 193},
  [5067] = {.lex_state = 193},
  [5068] = {.lex_state = 193},
  [5069] = {.lex_state = 193},
  [5070] = {.lex_state = 193},
  [5071] = {.lex_state = 193},
  [5072] = {.lex_state = 193},
  [5073] = {.lex_state = 193},
  [5074] = {.lex_state = 193},
  [5075] = {.lex_state = 193},
  [5076] = {.lex_state = 193},
  [5077] = {.lex_state = 193},
  [5078] = {.lex_state = 193},
  [5079] = {.lex_state = 193},
  [5080] = {.lex_state = 193},
  [5081] = {.lex_state = 193},
  [5082] = {.lex_state = 193},
  [5083] = {.lex_state = 193},
  [5084] = {.lex_state = 193},
  [5085] = {.lex_state = 193},
  [5086] = {.lex_state = 193},
  [5087] = {.lex_state = 193},
  [5088] = {.lex_state = 238},
  [5089] = {.lex_state = 236},
  [5090] = {.lex_state = 236},
  [5091] = {.lex_state = 236},
  [5092] = {.lex_state = 236},
  [5093] = {.lex_state = 236},
  [5094] = {.lex_state = 236},
  [5095] = {.lex_state = 236},
  [5096] = {.lex_state = 236},
  [5097] = {.lex_state = 236},
  [5098] = {.lex_state = 236},
  [5099] = {.lex_state = 236},
  [5100] = {.lex_state = 193},
  [5101] = {.lex_state = 201},
  [5102] = {.lex_state = 193},
  [5103] = {.lex_state = 201},
  [5104] = {.lex_state = 193},
  [5105] = {.lex_state = 236},
  [5106] = {.lex_state = 236},
  [5107] = {.lex_state = 236},
  [5108] = {.lex_state = 193},
  [5109] = {.lex_state = 236},
  [5110] = {.lex_state = 236},
  [5111] = {.lex_state = 193},
  [5112] = {.lex_state = 236},
  [5113] = {.lex_state = 201},
  [5114] = {.lex_state = 236},
  [5115] = {.lex_state = 236},
  [5116] = {.lex_state = 193},
  [5117] = {.lex_state = 236},
  [5118] = {.lex_state = 193},
  [5119] = {.lex_state = 236},
  [5120] = {.lex_state = 236},
  [5121] = {.lex_state = 236},
  [5122] = {.lex_state = 193},
  [5123] = {.lex_state = 193},
  [5124] = {.lex_state = 193},
  [5125] = {.lex_state = 236},
  [5126] = {.lex_state = 236},
  [5127] = {.lex_state = 236},
  [5128] = {.lex_state = 236},
  [5129] = {.lex_state = 193},
  [5130] = {.lex_state = 236},
  [5131] = {.lex_state = 236},
  [5132] = {.lex_state = 236},
  [5133] = {.lex_state = 238},
  [5134] = {.lex_state = 193},
  [5135] = {.lex_state = 236},
  [5136] = {.lex_state = 236},
  [5137] = {.lex_state = 236},
  [5138] = {.lex_state = 236},
  [5139] = {.lex_state = 201},
  [5140] = {.lex_state = 238},
  [5141] = {.lex_state = 238},
  [5142] = {.lex_state = 236},
  [5143] = {.lex_state = 236},
  [5144] = {.lex_state = 238},
  [5145] = {.lex_state = 238},
  [5146] = {.lex_state = 238},
  [5147] = {.lex_state = 193},
  [5148] = {.lex_state = 236},
  [5149] = {.lex_state = 238},
  [5150] = {.lex_state = 193},
  [5151] = {.lex_state = 236},
  [5152] = {.lex_state = 193},
  [5153] = {.lex_state = 238},
  [5154] = {.lex_state = 193},
  [5155] = {.lex_state = 236},
  [5156] = {.lex_state = 193},
  [5157] = {.lex_state = 236},
  [5158] = {.lex_state = 193},
  [5159] = {.lex_state = 201},
  [5160] = {.lex_state = 236},
  [5161] = {.lex_state = 201},
  [5162] = {.lex_state = 193},
  [5163] = {.lex_state = 236},
  [5164] = {.lex_state = 236},
  [5165] = {.lex_state = 236},
  [5166] = {.lex_state = 201},
  [5167] = {.lex_state = 193},
  [5168] = {.lex_state = 236},
  [5169] = {.lex_state = 236},
  [5170] = {.lex_state = 236},
  [5171] = {.lex_state = 236},
  [5172] = {.lex_state = 201},
  [5173] = {.lex_state = 193},
  [5174] = {.lex_state = 201},
  [5175] = {.lex_state = 236},
  [5176] = {.lex_state = 236},
  [5177] = {.lex_state = 236},
  [5178] = {.lex_state = 193},
  [5179] = {.lex_state = 193},
  [5180] = {.lex_state = 193},
  [5181] = {.lex_state = 201},
  [5182] = {.lex_state = 239},
  [5183] = {.lex_state = 201},
  [5184] = {.lex_state = 201},
  [5185] = {.lex_state = 201},
  [5186] = {.lex_state = 195},
  [5187] = {.lex_state = 236},
  [5188] = {.lex_state = 201},
  [5189] = {.lex_state = 239},
  [5190] = {.lex_state = 195},
  [5191] = {.lex_state = 195},
  [5192] = {.lex_state = 201},
  [5193] = {.lex_state = 201},
  [5194] = {.lex_state = 195},
  [5195] = {.lex_state = 201},
  [5196] = {.lex_state = 195},
  [5197] = {.lex_state = 239},
  [5198] = {.lex_state = 239},
  [5199] = {.lex_state = 239},
  [5200] = {.lex_state = 201},
  [5201] = {.lex_state = 201},
  [5202] = {.lex_state = 201},
  [5203] = {.lex_state = 195},
  [5204] = {.lex_state = 201},
  [5205] = {.lex_state = 201},
  [5206] = {.lex_state = 236},
  [5207] = {.lex_state = 201},
  [5208] = {.lex_state = 239},
  [5209] = {.lex_state = 236},
  [5210] = {.lex_state = 201},
  [5211] = {.lex_state = 203},
  [5212] = {.lex_state = 201},
  [5213] = {.lex_state = 203},
  [5214] = {.lex_state = 201},
  [5215] = {.lex_state = 236},
  [5216] = {.lex_state = 201},
  [5217] = {.lex_state = 201},
  [5218] = {.lex_state = 201},
  [5219] = {.lex_state = 201},
  [5220] = {.lex_state = 201},
  [5221] = {.lex_state = 201},
  [5222] = {.lex_state = 195},
  [5223] = {.lex_state = 201},
  [5224] = {.lex_state = 201},
  [5225] = {.lex_state = 201},
  [5226] = {.lex_state = 201},
  [5227] = {.lex_state = 195},
  [5228] = {.lex_state = 201},
  [5229] = {.lex_state = 239},
  [5230] = {.lex_state = 239},
  [5231] = {.lex_state = 239},
  [5232] = {.lex_state = 238},
  [5233] = {.lex_state = 238},
  [5234] = {.lex_state = 238},
  [5235] = {.lex_state = 238},
  [5236] = {.lex_state = 239},
  [5237] = {.lex_state = 238},
  [5238] = {.lex_state = 235},
  [5239] = {.lex_state = 239},
  [5240] = {.lex_state = 239},
  [5241] = {.lex_state = 238},
  [5242] = {.lex_state = 239},
  [5243] = {.lex_state = 239},
  [5244] = {.lex_state = 239},
  [5245] = {.lex_state = 239},
  [5246] = {.lex_state = 239},
  [5247] = {.lex_state = 239},
  [5248] = {.lex_state = 193},
  [5249] = {.lex_state = 238},
  [5250] = {.lex_state = 238},
  [5251] = {.lex_state = 193},
  [5252] = {.lex_state = 238},
  [5253] = {.lex_state = 238},
  [5254] = {.lex_state = 193},
  [5255] = {.lex_state = 193},
  [5256] = {.lex_state = 238},
  [5257] = {.lex_state = 238},
  [5258] = {.lex_state = 235},
  [5259] = {.lex_state = 238},
  [5260] = {.lex_state = 238},
  [5261] = {.lex_state = 193},
  [5262] = {.lex_state = 238},
  [5263] = {.lex_state = 193},
  [5264] = {.lex_state = 238},
  [5265] = {.lex_state = 238},
  [5266] = {.lex_state = 238},
  [5267] = {.lex_state = 238},
  [5268] = {.lex_state = 238},
  [5269] = {.lex_state = 238},
  [5270] = {.lex_state = 193},
  [5271] = {.lex_state = 238},
  [5272] = {.lex_state = 238},
  [5273] = {.lex_state = 193},
  [5274] = {.lex_state = 193},
  [5275] = {.lex_state = 193},
  [5276] = {.lex_state = 193},
  [5277] = {.lex_state = 193},
  [5278] = {.lex_state = 238},
  [5279] = {.lex_state = 238},
  [5280] = {.lex_state = 238},
  [5281] = {.lex_state = 236},
  [5282] = {.lex_state = 238},
  [5283] = {.lex_state = 238},
  [5284] = {.lex_state = 238},
  [5285] = {.lex_state = 236},
  [5286] = {.lex_state = 238},
  [5287] = {.lex_state = 236},
  [5288] = {.lex_state = 236},
  [5289] = {.lex_state = 238},
  [5290] = {.lex_state = 193},
  [5291] = {.lex_state = 238},
  [5292] = {.lex_state = 248},
  [5293] = {.lex_state = 193},
  [5294] = {.lex_state = 238},
  [5295] = {.lex_state = 238},
  [5296] = {.lex_state = 238},
  [5297] = {.lex_state = 238},
  [5298] = {.lex_state = 193},
  [5299] = {.lex_state = 248},
  [5300] = {.lex_state = 239},
  [5301] = {.lex_state = 248},
  [5302] = {.lex_state = 248},
  [5303] = {.lex_state = 238},
  [5304] = {.lex_state = 238},
  [5305] = {.lex_state = 248},
  [5306] = {.lex_state = 238},
  [5307] = {.lex_state = 248},
  [5308] = {.lex_state = 238},
  [5309] = {.lex_state = 193},
  [5310] = {.lex_state = 193},
  [5311] = {.lex_state = 239},
  [5312] = {.lex_state = 193},
  [5313] = {.lex_state = 248},
  [5314] = {.lex_state = 238},
  [5315] = {.lex_state = 238},
  [5316] = {.lex_state = 238},
  [5317] = {.lex_state = 195},
  [5318] = {.lex_state = 195},
  [5319] = {.lex_state = 195},
  [5320] = {.lex_state = 195},
  [5321] = {.lex_state = 195},
  [5322] = {.lex_state = 195},
  [5323] = {.lex_state = 195},
  [5324] = {.lex_state = 195},
  [5325] = {.lex_state = 195},
  [5326] = {.lex_state = 195},
  [5327] = {.lex_state = 195},
  [5328] = {.lex_state = 195},
  [5329] = {.lex_state = 239},
  [5330] = {.lex_state = 222},
  [5331] = {.lex_state = 239},
  [5332] = {.lex_state = 239},
  [5333] = {.lex_state = 238},
  [5334] = {.lex_state = 238},
  [5335] = {.lex_state = 238},
  [5336] = {.lex_state = 239},
  [5337] = {.lex_state = 238},
  [5338] = {.lex_state = 248},
  [5339] = {.lex_state = 248},
  [5340] = {.lex_state = 248},
  [5341] = {.lex_state = 248},
  [5342] = {.lex_state = 248},
  [5343] = {.lex_state = 248},
  [5344] = {.lex_state = 239},
  [5345] = {.lex_state = 248},
  [5346] = {.lex_state = 248},
  [5347] = {.lex_state = 248},
  [5348] = {.lex_state = 248},
  [5349] = {.lex_state = 248},
  [5350] = {.lex_state = 248},
  [5351] = {.lex_state = 238},
  [5352] = {.lex_state = 238},
  [5353] = {.lex_state = 248},
  [5354] = {.lex_state = 248},
  [5355] = {.lex_state = 248},
  [5356] = {.lex_state = 248},
  [5357] = {.lex_state = 248},
  [5358] = {.lex_state = 248},
  [5359] = {.lex_state = 248},
  [5360] = {.lex_state = 222},
  [5361] = {.lex_state = 238},
  [5362] = {.lex_state = 235},
  [5363] = {.lex_state = 222},
  [5364] = {.lex_state = 248},
  [5365] = {.lex_state = 248},
  [5366] = {.lex_state = 238},
  [5367] = {.lex_state = 238},
  [5368] = {.lex_state = 238},
  [5369] = {.lex_state = 238},
  [5370] = {.lex_state = 248},
  [5371] = {.lex_state = 248},
  [5372] = {.lex_state = 238},
  [5373] = {.lex_state = 248},
  [5374] = {.lex_state = 248},
  [5375] = {.lex_state = 248},
  [5376] = {.lex_state = 248},
  [5377] = {.lex_state = 248},
  [5378] = {.lex_state = 248},
  [5379] = {.lex_state = 238},
  [5380] = {.lex_state = 238},
  [5381] = {.lex_state = 239},
  [5382] = {.lex_state = 238},
  [5383] = {.lex_state = 222},
  [5384] = {.lex_state = 248},
  [5385] = {.lex_state = 239},
  [5386] = {.lex_state = 248},
  [5387] = {.lex_state = 238},
  [5388] = {.lex_state = 248},
  [5389] = {.lex_state = 248},
  [5390] = {.lex_state = 248},
  [5391] = {.lex_state = 248},
  [5392] = {.lex_state = 238},
  [5393] = {.lex_state = 248},
  [5394] = {.lex_state = 248},
  [5395] = {.lex_state = 192},
  [5396] = {.lex_state = 248},
  [5397] = {.lex_state = 248},
  [5398] = {.lex_state = 248},
  [5399] = {.lex_state = 248},
  [5400] = {.lex_state = 238},
  [5401] = {.lex_state = 239},
  [5402] = {.lex_state = 193},
  [5403] = {.lex_state = 239},
  [5404] = {.lex_state = 239},
  [5405] = {.lex_state = 175},
  [5406] = {.lex_state = 238},
  [5407] = {.lex_state = 193},
  [5408] = {.lex_state = 193},
  [5409] = {.lex_state = 239},
  [5410] = {.lex_state = 193},
  [5411] = {.lex_state = 239},
  [5412] = {.lex_state = 239},
  [5413] = {.lex_state = 239},
  [5414] = {.lex_state = 193},
  [5415] = {.lex_state = 193},
  [5416] = {.lex_state = 193},
  [5417] = {.lex_state = 193},
  [5418] = {.lex_state = 193},
  [5419] = {.lex_state = 193},
  [5420] = {.lex_state = 239},
  [5421] = {.lex_state = 193},
  [5422] = {.lex_state = 239},
  [5423] = {.lex_state = 193},
  [5424] = {.lex_state = 193},
  [5425] = {.lex_state = 193},
  [5426] = {.lex_state = 239},
  [5427] = {.lex_state = 193},
  [5428] = {.lex_state = 239},
  [5429] = {.lex_state = 239},
  [5430] = {.lex_state = 239},
  [5431] = {.lex_state = 193},
  [5432] = {.lex_state = 193},
  [5433] = {.lex_state = 193},
  [5434] = {.lex_state = 193},
  [5435] = {.lex_state = 193},
  [5436] = {.lex_state = 193},
  [5437] = {.lex_state = 222},
  [5438] = {.lex_state = 193},
  [5439] = {.lex_state = 192},
  [5440] = {.lex_state = 239},
  [5441] = {.lex_state = 239},
  [5442] = {.lex_state = 239},
  [5443] = {.lex_state = 193},
  [5444] = {.lex_state = 222},
  [5445] = {.lex_state = 192},
  [5446] = {.lex_state = 193},
  [5447] = {.lex_state = 193},
  [5448] = {.lex_state = 193},
  [5449] = {.lex_state = 193},
  [5450] = {.lex_state = 193},
  [5451] = {.lex_state = 193},
  [5452] = {.lex_state = 193},
  [5453] = {.lex_state = 193},
  [5454] = {.lex_state = 222},
  [5455] = {.lex_state = 193},
  [5456] = {.lex_state = 238},
  [5457] = {.lex_state = 239},
  [5458] = {.lex_state = 239},
  [5459] = {.lex_state = 193},
  [5460] = {.lex_state = 239},
  [5461] = {.lex_state = 193},
  [5462] = {.lex_state = 193},
  [5463] = {.lex_state = 193},
  [5464] = {.lex_state = 193},
  [5465] = {.lex_state = 193},
  [5466] = {.lex_state = 193},
  [5467] = {.lex_state = 193},
  [5468] = {.lex_state = 222},
  [5469] = {.lex_state = 193},
  [5470] = {.lex_state = 193},
  [5471] = {.lex_state = 193},
  [5472] = {.lex_state = 193},
  [5473] = {.lex_state = 193},
  [5474] = {.lex_state = 193},
  [5475] = {.lex_state = 193},
  [5476] = {.lex_state = 175},
  [5477] = {.lex_state = 193},
  [5478] = {.lex_state = 193},
  [5479] = {.lex_state = 193},
  [5480] = {.lex_state = 193},
  [5481] = {.lex_state = 193},
  [5482] = {.lex_state = 239},
  [5483] = {.lex_state = 239},
  [5484] = {.lex_state = 193},
  [5485] = {.lex_state = 239},
  [5486] = {.lex_state = 239},
  [5487] = {.lex_state = 193},
  [5488] = {.lex_state = 193},
  [5489] = {.lex_state = 239},
  [5490] = {.lex_state = 239},
  [5491] = {.lex_state = 238},
  [5492] = {.lex_state = 193},
  [5493] = {.lex_state = 193},
  [5494] = {.lex_state = 193},
  [5495] = {.lex_state = 239},
  [5496] = {.lex_state = 222},
  [5497] = {.lex_state = 239},
  [5498] = {.lex_state = 238},
  [5499] = {.lex_state = 193},
  [5500] = {.lex_state = 193},
  [5501] = {.lex_state = 99},
  [5502] = {.lex_state = 193},
  [5503] = {.lex_state = 193},
  [5504] = {.lex_state = 193},
  [5505] = {.lex_state = 193},
  [5506] = {.lex_state = 193},
  [5507] = {.lex_state = 193},
  [5508] = {.lex_state = 238},
  [5509] = {.lex_state = 175},
  [5510] = {.lex_state = 193},
  [5511] = {.lex_state = 193},
  [5512] = {.lex_state = 193},
  [5513] = {.lex_state = 239},
  [5514] = {.lex_state = 193},
  [5515] = {.lex_state = 193},
  [5516] = {.lex_state = 193},
  [5517] = {.lex_state = 239},
  [5518] = {.lex_state = 193},
  [5519] = {.lex_state = 193},
  [5520] = {.lex_state = 193},
  [5521] = {.lex_state = 193},
  [5522] = {.lex_state = 193},
  [5523] = {.lex_state = 192},
  [5524] = {.lex_state = 193},
  [5525] = {.lex_state = 193},
  [5526] = {.lex_state = 238},
  [5527] = {.lex_state = 239},
  [5528] = {.lex_state = 193},
  [5529] = {.lex_state = 193},
  [5530] = {.lex_state = 239},
  [5531] = {.lex_state = 239},
  [5532] = {.lex_state = 239},
  [5533] = {.lex_state = 239},
  [5534] = {.lex_state = 239},
  [5535] = {.lex_state = 239},
  [5536] = {.lex_state = 193},
  [5537] = {.lex_state = 193},
  [5538] = {.lex_state = 193},
  [5539] = {.lex_state = 238},
  [5540] = {.lex_state = 193},
  [5541] = {.lex_state = 193},
  [5542] = {.lex_state = 239},
  [5543] = {.lex_state = 193},
  [5544] = {.lex_state = 193},
  [5545] = {.lex_state = 193},
  [5546] = {.lex_state = 193},
  [5547] = {.lex_state = 243},
  [5548] = {.lex_state = 201},
  [5549] = {.lex_state = 175},
  [5550] = {.lex_state = 175},
  [5551] = {.lex_state = 222},
  [5552] = {.lex_state = 238},
  [5553] = {.lex_state = 175},
  [5554] = {.lex_state = 236},
  [5555] = {.lex_state = 243},
  [5556] = {.lex_state = 222},
  [5557] = {.lex_state = 192},
  [5558] = {.lex_state = 236},
  [5559] = {.lex_state = 238},
  [5560] = {.lex_state = 192},
  [5561] = {.lex_state = 238},
  [5562] = {.lex_state = 238},
  [5563] = {.lex_state = 192},
  [5564] = {.lex_state = 192},
  [5565] = {.lex_state = 192},
  [5566] = {.lex_state = 192},
  [5567] = {.lex_state = 175},
  [5568] = {.lex_state = 236},
  [5569] = {.lex_state = 175},
  [5570] = {.lex_state = 236},
  [5571] = {.lex_state = 243},
  [5572] = {.lex_state = 239},
  [5573] = {.lex_state = 175},
  [5574] = {.lex_state = 243},
  [5575] = {.lex_state = 239},
  [5576] = {.lex_state = 235},
  [5577] = {.lex_state = 192},
  [5578] = {.lex_state = 222},
  [5579] = {.lex_state = 243},
  [5580] = {.lex_state = 243},
  [5581] = {.lex_state = 175},
  [5582] = {.lex_state = 175},
  [5583] = {.lex_state = 239},
  [5584] = {.lex_state = 236},
  [5585] = {.lex_state = 236},
  [5586] = {.lex_state = 175},
  [5587] = {.lex_state = 236},
  [5588] = {.lex_state = 175},
  [5589] = {.lex_state = 236},
  [5590] = {.lex_state = 175},
  [5591] = {.lex_state = 236},
  [5592] = {.lex_state = 222},
  [5593] = {.lex_state = 175},
  [5594] = {.lex_state = 222},
  [5595] = {.lex_state = 236},
  [5596] = {.lex_state = 236},
  [5597] = {.lex_state = 192},
  [5598] = {.lex_state = 236},
  [5599] = {.lex_state = 192},
  [5600] = {.lex_state = 236},
  [5601] = {.lex_state = 222},
  [5602] = {.lex_state = 192},
  [5603] = {.lex_state = 175},
  [5604] = {.lex_state = 239},
  [5605] = {.lex_state = 192},
  [5606] = {.lex_state = 222},
  [5607] = {.lex_state = 243},
  [5608] = {.lex_state = 243},
  [5609] = {.lex_state = 175},
  [5610] = {.lex_state = 175},
  [5611] = {.lex_state = 175},
  [5612] = {.lex_state = 175},
  [5613] = {.lex_state = 243},
  [5614] = {.lex_state = 222},
  [5615] = {.lex_state = 239},
  [5616] = {.lex_state = 175},
  [5617] = {.lex_state = 192},
  [5618] = {.lex_state = 243},
  [5619] = {.lex_state = 243},
  [5620] = {.lex_state = 175},
  [5621] = {.lex_state = 243},
  [5622] = {.lex_state = 175},
  [5623] = {.lex_state = 239},
  [5624] = {.lex_state = 222},
  [5625] = {.lex_state = 238},
  [5626] = {.lex_state = 243},
  [5627] = {.lex_state = 243},
  [5628] = {.lex_state = 236},
  [5629] = {.lex_state = 175},
  [5630] = {.lex_state = 175},
  [5631] = {.lex_state = 175},
  [5632] = {.lex_state = 175},
  [5633] = {.lex_state = 238},
  [5634] = {.lex_state = 175},
  [5635] = {.lex_state = 239},
  [5636] = {.lex_state = 243},
  [5637] = {.lex_state = 175},
  [5638] = {.lex_state = 238},
  [5639] = {.lex_state = 236},
  [5640] = {.lex_state = 175},
  [5641] = {.lex_state = 243},
  [5642] = {.lex_state = 243},
  [5643] = {.lex_state = 238},
  [5644] = {.lex_state = 175},
  [5645] = {.lex_state = 239},
  [5646] = {.lex_state = 175},
  [5647] = {.lex_state = 175},
  [5648] = {.lex_state = 243},
  [5649] = {.lex_state = 222},
  [5650] = {.lex_state = 243},
  [5651] = {.lex_state = 175},
  [5652] = {.lex_state = 175},
  [5653] = {.lex_state = 192},
  [5654] = {.lex_state = 236},
  [5655] = {.lex_state = 239},
  [5656] = {.lex_state = 175},
  [5657] = {.lex_state = 175},
  [5658] = {.lex_state = 222},
  [5659] = {.lex_state = 201},
  [5660] = {.lex_state = 235},
  [5661] = {.lex_state = 175},
  [5662] = {.lex_state = 192},
  [5663] = {.lex_state = 239},
  [5664] = {.lex_state = 222},
  [5665] = {.lex_state = 243},
  [5666] = {.lex_state = 239},
  [5667] = {.lex_state = 239},
  [5668] = {.lex_state = 239},
  [5669] = {.lex_state = 175},
  [5670] = {.lex_state = 239},
  [5671] = {.lex_state = 192},
  [5672] = {.lex_state = 243},
  [5673] = {.lex_state = 243},
  [5674] = {.lex_state = 239},
  [5675] = {.lex_state = 239},
  [5676] = {.lex_state = 239},
  [5677] = {.lex_state = 239},
  [5678] = {.lex_state = 192},
  [5679] = {.lex_state = 239},
  [5680] = {.lex_state = 192},
  [5681] = {.lex_state = 243},
  [5682] = {.lex_state = 175},
  [5683] = {.lex_state = 239},
  [5684] = {.lex_state = 236},
  [5685] = {.lex_state = 243},
  [5686] = {.lex_state = 192},
  [5687] = {.lex_state = 243},
  [5688] = {.lex_state = 243},
  [5689] = {.lex_state = 175},
  [5690] = {.lex_state = 236},
  [5691] = {.lex_state = 192},
  [5692] = {.lex_state = 243},
  [5693] = {.lex_state = 222},
  [5694] = {.lex_state = 192},
  [5695] = {.lex_state = 243},
  [5696] = {.lex_state = 222},
  [5697] = {.lex_state = 175},
  [5698] = {.lex_state = 239},
  [5699] = {.lex_state = 99},
  [5700] = {.lex_state = 222},
  [5701] = {.lex_state = 239},
  [5702] = {.lex_state = 99},
  [5703] = {.lex_state = 99},
  [5704] = {.lex_state = 236},
  [5705] = {.lex_state = 236},
  [5706] = {.lex_state = 192},
  [5707] = {.lex_state = 99},
  [5708] = {.lex_state = 236},
  [5709] = {.lex_state = 247},
  [5710] = {.lex_state = 236},
  [5711] = {.lex_state = 99},
  [5712] = {.lex_state = 222},
  [5713] = {.lex_state = 99},
  [5714] = {.lex_state = 239},
  [5715] = {.lex_state = 99},
  [5716] = {.lex_state = 236},
  [5717] = {.lex_state = 235},
  [5718] = {.lex_state = 99},
  [5719] = {.lex_state = 99},
  [5720] = {.lex_state = 239},
  [5721] = {.lex_state = 99},
  [5722] = {.lex_state = 99},
  [5723] = {.lex_state = 99},
  [5724] = {.lex_state = 192},
  [5725] = {.lex_state = 99},
  [5726] = {.lex_state = 239},
  [5727] = {.lex_state = 239},
  [5728] = {.lex_state = 99},
  [5729] = {.lex_state = 239},
  [5730] = {.lex_state = 99},
  [5731] = {.lex_state = 99},
  [5732] = {.lex_state = 222},
  [5733] = {.lex_state = 99},
  [5734] = {.lex_state = 235},
  [5735] = {.lex_state = 239},
  [5736] = {.lex_state = 99},
  [5737] = {.lex_state = 99},
  [5738] = {.lex_state = 99},
  [5739] = {.lex_state = 99},
  [5740] = {.lex_state = 222},
  [5741] = {.lex_state = 238},
  [5742] = {.lex_state = 99},
  [5743] = {.lex_state = 236},
  [5744] = {.lex_state = 236},
  [5745] = {.lex_state = 99},
  [5746] = {.lex_state = 239},
  [5747] = {.lex_state = 99},
  [5748] = {.lex_state = 239},
  [5749] = {.lex_state = 99},
  [5750] = {.lex_state = 222},
  [5751] = {.lex_state = 99},
  [5752] = {.lex_state = 236},
  [5753] = {.lex_state = 99},
  [5754] = {.lex_state = 99},
  [5755] = {.lex_state = 239},
  [5756] = {.lex_state = 239},
  [5757] = {.lex_state = 239},
  [5758] = {.lex_state = 239},
  [5759] = {.lex_state = 239},
  [5760] = {.lex_state = 238},
  [5761] = {.lex_state = 99},
  [5762] = {.lex_state = 99},
  [5763] = {.lex_state = 99},
  [5764] = {.lex_state = 222},
  [5765] = {.lex_state = 222},
  [5766] = {.lex_state = 99},
  [5767] = {.lex_state = 235},
  [5768] = {.lex_state = 99},
  [5769] = {.lex_state = 238},
  [5770] = {.lex_state = 236},
  [5771] = {.lex_state = 236},
  [5772] = {.lex_state = 239},
  [5773] = {.lex_state = 239},
  [5774] = {.lex_state = 239},
  [5775] = {.lex_state = 239},
  [5776] = {.lex_state = 239},
  [5777] = {.lex_state = 239},
  [5778] = {.lex_state = 239},
  [5779] = {.lex_state = 236},
  [5780] = {.lex_state = 236},
  [5781] = {.lex_state = 238},
  [5782] = {.lex_state = 235},
  [5783] = {.lex_state = 238},
  [5784] = {.lex_state = 238},
  [5785] = {.lex_state = 235},
  [5786] = {.lex_state = 238},
  [5787] = {.lex_state = 235},
  [5788] = {.lex_state = 238},
  [5789] = {.lex_state = 238},
  [5790] = {.lex_state = 238},
  [5791] = {.lex_state = 238},
  [5792] = {.lex_state = 238},
  [5793] = {.lex_state = 238},
  [5794] = {.lex_state = 238},
  [5795] = {.lex_state = 238},
  [5796] = {.lex_state = 235},
  [5797] = {.lex_state = 238},
  [5798] = {.lex_state = 235},
  [5799] = {.lex_state = 235},
  [5800] = {.lex_state = 235},
  [5801] = {.lex_state = 235},
  [5802] = {.lex_state = 238},
  [5803] = {.lex_state = 235},
  [5804] = {.lex_state = 235},
  [5805] = {.lex_state = 241},
  [5806] = {.lex_state = 235},
  [5807] = {.lex_state = 235},
  [5808] = {.lex_state = 235},
  [5809] = {.lex_state = 235},
  [5810] = {.lex_state = 235},
  [5811] = {.lex_state = 235},
  [5812] = {.lex_state = 235},
  [5813] = {.lex_state = 193},
  [5814] = {.lex_state = 239},
  [5815] = {.lex_state = 235},
  [5816] = {.lex_state = 239},
  [5817] = {.lex_state = 235},
  [5818] = {.lex_state = 235},
  [5819] = {.lex_state = 239},
  [5820] = {.lex_state = 239},
  [5821] = {.lex_state = 193},
  [5822] = {.lex_state = 235},
  [5823] = {.lex_state = 239},
  [5824] = {.lex_state = 239},
  [5825] = {.lex_state = 235},
  [5826] = {.lex_state = 238},
  [5827] = {.lex_state = 238},
  [5828] = {.lex_state = 241},
  [5829] = {.lex_state = 238},
  [5830] = {.lex_state = 238},
  [5831] = {.lex_state = 235},
  [5832] = {.lex_state = 235},
  [5833] = {.lex_state = 193},
  [5834] = {.lex_state = 235},
  [5835] = {.lex_state = 238},
  [5836] = {.lex_state = 193},
  [5837] = {.lex_state = 235},
  [5838] = {.lex_state = 235},
  [5839] = {.lex_state = 235},
  [5840] = {.lex_state = 238},
  [5841] = {.lex_state = 235},
  [5842] = {.lex_state = 235},
  [5843] = {.lex_state = 238},
  [5844] = {.lex_state = 239},
  [5845] = {.lex_state = 238},
  [5846] = {.lex_state = 173},
  [5847] = {.lex_state = 222},
  [5848] = {.lex_state = 201},
  [5849] = {.lex_state = 239},
  [5850] = {.lex_state = 243},
  [5851] = {.lex_state = 239},
  [5852] = {.lex_state = 193},
  [5853] = {.lex_state = 239},
  [5854] = {.lex_state = 173},
  [5855] = {.lex_state = 173},
  [5856] = {.lex_state = 173},
  [5857] = {.lex_state = 173},
  [5858] = {.lex_state = 231},
  [5859] = {.lex_state = 201},
  [5860] = {.lex_state = 201},
  [5861] = {.lex_state = 222},
  [5862] = {.lex_state = 201},
  [5863] = {.lex_state = 235},
  [5864] = {.lex_state = 235},
  [5865] = {.lex_state = 231},
  [5866] = {.lex_state = 201},
  [5867] = {.lex_state = 235},
  [5868] = {.lex_state = 235},
  [5869] = {.lex_state = 235},
  [5870] = {.lex_state = 235},
  [5871] = {.lex_state = 238},
  [5872] = {.lex_state = 173},
  [5873] = {.lex_state = 173},
  [5874] = {.lex_state = 173},
  [5875] = {.lex_state = 222},
  [5876] = {.lex_state = 173},
  [5877] = {.lex_state = 201},
  [5878] = {.lex_state = 203},
  [5879] = {.lex_state = 201},
  [5880] = {.lex_state = 201},
  [5881] = {.lex_state = 239},
  [5882] = {.lex_state = 201},
  [5883] = {.lex_state = 243},
  [5884] = {.lex_state = 231},
  [5885] = {.lex_state = 201},
  [5886] = {.lex_state = 222},
  [5887] = {.lex_state = 235},
  [5888] = {.lex_state = 239},
  [5889] = {.lex_state = 239},
  [5890] = {.lex_state = 173},
  [5891] = {.lex_state = 238},
  [5892] = {.lex_state = 239},
  [5893] = {.lex_state = 231},
  [5894] = {.lex_state = 239},
  [5895] = {.lex_state = 235},
  [5896] = {.lex_state = 239},
  [5897] = {.lex_state = 241},
  [5898] = {.lex_state = 239},
  [5899] = {.lex_state = 239},
  [5900] = {.lex_state = 239},
  [5901] = {.lex_state = 239},
  [5902] = {.lex_state = 197},
  [5903] = {.lex_state = 239},
  [5904] = {.lex_state = 236},
  [5905] = {.lex_state = 239},
  [5906] = {.lex_state = 239},
  [5907] = {.lex_state = 236},
  [5908] = {.lex_state = 236},
  [5909] = {.lex_state = 239},
  [5910] = {.lex_state = 239},
  [5911] = {.lex_state = 239},
  [5912] = {.lex_state = 239},
  [5913] = {.lex_state = 239},
  [5914] = {.lex_state = 236},
  [5915] = {.lex_state = 241},
  [5916] = {.lex_state = 239},
  [5917] = {.lex_state = 239},
  [5918] = {.lex_state = 236},
  [5919] = {.lex_state = 241},
  [5920] = {.lex_state = 239},
  [5921] = {.lex_state = 241},
  [5922] = {.lex_state = 239},
  [5923] = {.lex_state = 193},
  [5924] = {.lex_state = 193},
  [5925] = {.lex_state = 236},
  [5926] = {.lex_state = 236},
  [5927] = {.lex_state = 241},
  [5928] = {.lex_state = 238},
  [5929] = {.lex_state = 236},
  [5930] = {.lex_state = 197},
  [5931] = {.lex_state = 197},
  [5932] = {.lex_state = 236},
  [5933] = {.lex_state = 238},
  [5934] = {.lex_state = 236},
  [5935] = {.lex_state = 241},
  [5936] = {.lex_state = 197},
  [5937] = {.lex_state = 197},
  [5938] = {.lex_state = 239},
  [5939] = {.lex_state = 238},
  [5940] = {.lex_state = 239},
  [5941] = {.lex_state = 193},
  [5942] = {.lex_state = 241},
  [5943] = {.lex_state = 241},
  [5944] = {.lex_state = 239},
  [5945] = {.lex_state = 236},
  [5946] = {.lex_state = 241},
  [5947] = {.lex_state = 239},
  [5948] = {.lex_state = 239},
  [5949] = {.lex_state = 239},
  [5950] = {.lex_state = 239},
  [5951] = {.lex_state = 239},
  [5952] = {.lex_state = 239},
  [5953] = {.lex_state = 239},
  [5954] = {.lex_state = 239},
  [5955] = {.lex_state = 239},
  [5956] = {.lex_state = 239},
  [5957] = {.lex_state = 236},
  [5958] = {.lex_state = 239},
  [5959] = {.lex_state = 239},
  [5960] = {.lex_state = 236},
  [5961] = {.lex_state = 239},
  [5962] = {.lex_state = 236},
  [5963] = {.lex_state = 238},
  [5964] = {.lex_state = 241},
  [5965] = {.lex_state = 197},
  [5966] = {.lex_state = 239},
  [5967] = {.lex_state = 197},
  [5968] = {.lex_state = 193},
  [5969] = {.lex_state = 173},
  [5970] = {.lex_state = 193},
  [5971] = {.lex_state = 239},
  [5972] = {.lex_state = 239},
  [5973] = {.lex_state = 239},
  [5974] = {.lex_state = 239},
  [5975] = {.lex_state = 241},
  [5976] = {.lex_state = 197},
  [5977] = {.lex_state = 241},
  [5978] = {.lex_state = 241},
  [5979] = {.lex_state = 193},
  [5980] = {.lex_state = 238},
  [5981] = {.lex_state = 236},
  [5982] = {.lex_state = 193},
  [5983] = {.lex_state = 238},
  [5984] = {.lex_state = 197},
  [5985] = {.lex_state = 238},
  [5986] = {.lex_state = 241},
  [5987] = {.lex_state = 239},
  [5988] = {.lex_state = 239},
  [5989] = {.lex_state = 236},
  [5990] = {.lex_state = 241},
  [5991] = {.lex_state = 241},
  [5992] = {.lex_state = 193},
  [5993] = {.lex_state = 197},
  [5994] = {.lex_state = 197},
  [5995] = {.lex_state = 239},
  [5996] = {.lex_state = 236},
  [5997] = {.lex_state = 193},
  [5998] = {.lex_state = 239},
  [5999] = {.lex_state = 173},
  [6000] = {.lex_state = 239},
  [6001] = {.lex_state = 241},
  [6002] = {.lex_state = 236},
  [6003] = {.lex_state = 239},
  [6004] = {.lex_state = 241},
  [6005] = {.lex_state = 241},
  [6006] = {.lex_state = 241},
  [6007] = {.lex_state = 241},
  [6008] = {.lex_state = 197},
  [6009] = {.lex_state = 239},
  [6010] = {.lex_state = 238},
  [6011] = {.lex_state = 236},
  [6012] = {.lex_state = 194},
  [6013] = {.lex_state = 173},
  [6014] = {.lex_state = 193},
  [6015] = {.lex_state = 239},
  [6016] = {.lex_state = 185},
  [6017] = {.lex_state = 193},
  [6018] = {.lex_state = 185},
  [6019] = {.lex_state = 185},
  [6020] = {.lex_state = 194},
  [6021] = {.lex_state = 185},
  [6022] = {.lex_state = 194},
  [6023] = {.lex_state = 235},
  [6024] = {.lex_state = 185},
  [6025] = {.lex_state = 239},
  [6026] = {.lex_state = 185},
  [6027] = {.lex_state = 235},
  [6028] = {.lex_state = 239},
  [6029] = {.lex_state = 239},
  [6030] = {.lex_state = 238},
  [6031] = {.lex_state = 185},
  [6032] = {.lex_state = 185},
  [6033] = {.lex_state = 173},
  [6034] = {.lex_state = 185},
  [6035] = {.lex_state = 239},
  [6036] = {.lex_state = 185},
  [6037] = {.lex_state = 238},
  [6038] = {.lex_state = 193},
  [6039] = {.lex_state = 239},
  [6040] = {.lex_state = 193},
  [6041] = {.lex_state = 238},
  [6042] = {.lex_state = 193},
  [6043] = {.lex_state = 173},
  [6044] = {.lex_state = 173},
  [6045] = {.lex_state = 235},
  [6046] = {.lex_state = 185},
  [6047] = {.lex_state = 235},
  [6048] = {.lex_state = 238},
  [6049] = {.lex_state = 194},
  [6050] = {.lex_state = 194},
  [6051] = {.lex_state = 194},
  [6052] = {.lex_state = 173},
  [6053] = {.lex_state = 194},
  [6054] = {.lex_state = 194},
  [6055] = {.lex_state = 194},
  [6056] = {.lex_state = 185},
  [6057] = {.lex_state = 238},
  [6058] = {.lex_state = 193},
  [6059] = {.lex_state = 194},
  [6060] = {.lex_state = 194},
  [6061] = {.lex_state = 194},
  [6062] = {.lex_state = 194},
  [6063] = {.lex_state = 173},
  [6064] = {.lex_state = 235},
  [6065] = {.lex_state = 239},
  [6066] = {.lex_state = 239},
  [6067] = {.lex_state = 194},
  [6068] = {.lex_state = 185},
  [6069] = {.lex_state = 213},
  [6070] = {.lex_state = 213},
  [6071] = {.lex_state = 185},
  [6072] = {.lex_state = 185},
  [6073] = {.lex_state = 185},
  [6074] = {.lex_state = 173},
  [6075] = {.lex_state = 213},
  [6076] = {.lex_state = 185},
  [6077] = {.lex_state = 213},
  [6078] = {.lex_state = 185},
  [6079] = {.lex_state = 235},
  [6080] = {.lex_state = 185},
  [6081] = {.lex_state = 173},
  [6082] = {.lex_state = 178},
  [6083] = {.lex_state = 193},
  [6084] = {.lex_state = 213},
  [6085] = {.lex_state = 213},
  [6086] = {.lex_state = 213},
  [6087] = {.lex_state = 239},
  [6088] = {.lex_state = 213},
  [6089] = {.lex_state = 239},
  [6090] = {.lex_state = 194},
  [6091] = {.lex_state = 185},
  [6092] = {.lex_state = 194},
  [6093] = {.lex_state = 173},
  [6094] = {.lex_state = 185},
  [6095] = {.lex_state = 235},
  [6096] = {.lex_state = 173},
  [6097] = {.lex_state = 235},
  [6098] = {.lex_state = 185},
  [6099] = {.lex_state = 193},
  [6100] = {.lex_state = 193},
  [6101] = {.lex_state = 239},
  [6102] = {.lex_state = 213},
  [6103] = {.lex_state = 231},
  [6104] = {.lex_state = 193},
  [6105] = {.lex_state = 193},
  [6106] = {.lex_state = 213},
  [6107] = {.lex_state = 213},
  [6108] = {.lex_state = 238},
  [6109] = {.lex_state = 213},
  [6110] = {.lex_state = 193},
  [6111] = {.lex_state = 238},
  [6112] = {.lex_state = 193},
  [6113] = {.lex_state = 193},
  [6114] = {.lex_state = 213},
  [6115] = {.lex_state = 193},
  [6116] = {.lex_state = 193},
  [6117] = {.lex_state = 193},
  [6118] = {.lex_state = 213},
  [6119] = {.lex_state = 193},
  [6120] = {.lex_state = 193},
  [6121] = {.lex_state = 193},
  [6122] = {.lex_state = 239},
  [6123] = {.lex_state = 193},
  [6124] = {.lex_state = 193},
  [6125] = {.lex_state = 213},
  [6126] = {.lex_state = 193},
  [6127] = {.lex_state = 193},
  [6128] = {.lex_state = 193},
  [6129] = {.lex_state = 193},
  [6130] = {.lex_state = 239},
  [6131] = {.lex_state = 213},
  [6132] = {.lex_state = 193},
  [6133] = {.lex_state = 213},
  [6134] = {.lex_state = 193},
  [6135] = {.lex_state = 193},
  [6136] = {.lex_state = 213},
  [6137] = {.lex_state = 239},
  [6138] = {.lex_state = 193},
  [6139] = {.lex_state = 238},
  [6140] = {.lex_state = 213},
  [6141] = {.lex_state = 239},
  [6142] = {.lex_state = 231},
  [6143] = {.lex_state = 213},
  [6144] = {.lex_state = 193},
  [6145] = {.lex_state = 213},
  [6146] = {.lex_state = 231},
  [6147] = {.lex_state = 213},
  [6148] = {.lex_state = 193},
  [6149] = {.lex_state = 239},
  [6150] = {.lex_state = 238},
  [6151] = {.lex_state = 238},
  [6152] = {.lex_state = 193},
  [6153] = {.lex_state = 231},
  [6154] = {.lex_state = 193},
  [6155] = {.lex_state = 238},
  [6156] = {.lex_state = 213},
  [6157] = {.lex_state = 202},
  [6158] = {.lex_state = 193},
  [6159] = {.lex_state = 193},
  [6160] = {.lex_state = 193},
  [6161] = {.lex_state = 213},
  [6162] = {.lex_state = 213},
  [6163] = {.lex_state = 193},
  [6164] = {.lex_state = 238},
  [6165] = {.lex_state = 239},
  [6166] = {.lex_state = 239},
  [6167] = {.lex_state = 238},
  [6168] = {.lex_state = 213},
  [6169] = {.lex_state = 239},
  [6170] = {.lex_state = 193},
  [6171] = {.lex_state = 239},
  [6172] = {.lex_state = 239},
  [6173] = {.lex_state = 238},
  [6174] = {.lex_state = 193},
  [6175] = {.lex_state = 238},
  [6176] = {.lex_state = 193},
  [6177] = {.lex_state = 239},
  [6178] = {.lex_state = 193},
  [6179] = {.lex_state = 239},
  [6180] = {.lex_state = 193},
  [6181] = {.lex_state = 239},
  [6182] = {.lex_state = 238},
  [6183] = {.lex_state = 193},
  [6184] = {.lex_state = 213},
  [6185] = {.lex_state = 193},
  [6186] = {.lex_state = 239},
  [6187] = {.lex_state = 193},
  [6188] = {.lex_state = 239},
  [6189] = {.lex_state = 239},
  [6190] = {.lex_state = 213},
  [6191] = {.lex_state = 238},
  [6192] = {.lex_state = 239},
  [6193] = {.lex_state = 238},
  [6194] = {.lex_state = 193},
  [6195] = {.lex_state = 238},
  [6196] = {.lex_state = 238},
  [6197] = {.lex_state = 238},
  [6198] = {.lex_state = 239},
  [6199] = {.lex_state = 238},
  [6200] = {.lex_state = 238},
  [6201] = {.lex_state = 193},
  [6202] = {.lex_state = 193},
  [6203] = {.lex_state = 191},
  [6204] = {.lex_state = 239},
  [6205] = {.lex_state = 191},
  [6206] = {.lex_state = 191},
  [6207] = {.lex_state = 173},
  [6208] = {.lex_state = 239},
  [6209] = {.lex_state = 238},
  [6210] = {.lex_state = 239},
  [6211] = {.lex_state = 191},
  [6212] = {.lex_state = 239},
  [6213] = {.lex_state = 235},
  [6214] = {.lex_state = 239},
  [6215] = {.lex_state = 238},
  [6216] = {.lex_state = 235},
  [6217] = {.lex_state = 235},
  [6218] = {.lex_state = 235},
  [6219] = {.lex_state = 235},
  [6220] = {.lex_state = 193},
  [6221] = {.lex_state = 195},
  [6222] = {.lex_state = 193},
  [6223] = {.lex_state = 239},
  [6224] = {.lex_state = 239},
  [6225] = {.lex_state = 239},
  [6226] = {.lex_state = 191},
  [6227] = {.lex_state = 239},
  [6228] = {.lex_state = 235},
  [6229] = {.lex_state = 191},
  [6230] = {.lex_state = 193},
  [6231] = {.lex_state = 239},
  [6232] = {.lex_state = 239},
  [6233] = {.lex_state = 193},
  [6234] = {.lex_state = 239},
  [6235] = {.lex_state = 191},
  [6236] = {.lex_state = 239},
  [6237] = {.lex_state = 191},
  [6238] = {.lex_state = 239},
  [6239] = {.lex_state = 191},
  [6240] = {.lex_state = 239},
  [6241] = {.lex_state = 173},
  [6242] = {.lex_state = 193},
  [6243] = {.lex_state = 193},
  [6244] = {.lex_state = 191},
  [6245] = {.lex_state = 195},
  [6246] = {.lex_state = 195},
  [6247] = {.lex_state = 191},
  [6248] = {.lex_state = 239},
  [6249] = {.lex_state = 173},
  [6250] = {.lex_state = 193},
  [6251] = {.lex_state = 195},
  [6252] = {.lex_state = 193},
  [6253] = {.lex_state = 191},
  [6254] = {.lex_state = 238},
  [6255] = {.lex_state = 239},
  [6256] = {.lex_state = 195},
  [6257] = {.lex_state = 193},
  [6258] = {.lex_state = 235},
  [6259] = {.lex_state = 191},
  [6260] = {.lex_state = 191},
  [6261] = {.lex_state = 235},
  [6262] = {.lex_state = 191},
  [6263] = {.lex_state = 239},
  [6264] = {.lex_state = 191},
  [6265] = {.lex_state = 191},
  [6266] = {.lex_state = 239},
  [6267] = {.lex_state = 191},
  [6268] = {.lex_state = 239},
  [6269] = {.lex_state = 238},
  [6270] = {.lex_state = 191},
  [6271] = {.lex_state = 239},
  [6272] = {.lex_state = 195},
  [6273] = {.lex_state = 195},
  [6274] = {.lex_state = 195},
  [6275] = {.lex_state = 238},
  [6276] = {.lex_state = 191},
  [6277] = {.lex_state = 239},
  [6278] = {.lex_state = 193},
  [6279] = {.lex_state = 193},
  [6280] = {.lex_state = 193},
  [6281] = {.lex_state = 193},
  [6282] = {.lex_state = 193},
  [6283] = {.lex_state = 193},
  [6284] = {.lex_state = 193},
  [6285] = {.lex_state = 239},
  [6286] = {.lex_state = 193},
  [6287] = {.lex_state = 193},
  [6288] = {.lex_state = 193},
  [6289] = {.lex_state = 193},
  [6290] = {.lex_state = 193},
  [6291] = {.lex_state = 193},
  [6292] = {.lex_state = 193},
  [6293] = {.lex_state = 193},
  [6294] = {.lex_state = 193},
  [6295] = {.lex_state = 193},
  [6296] = {.lex_state = 193},
  [6297] = {.lex_state = 239},
  [6298] = {.lex_state = 239},
  [6299] = {.lex_state = 239},
  [6300] = {.lex_state = 239},
  [6301] = {.lex_state = 193},
  [6302] = {.lex_state = 197},
  [6303] = {.lex_state = 197},
  [6304] = {.lex_state = 197},
  [6305] = {.lex_state = 197},
  [6306] = {.lex_state = 239},
  [6307] = {.lex_state = 193},
  [6308] = {.lex_state = 201},
  [6309] = {.lex_state = 239},
  [6310] = {.lex_state = 197},
  [6311] = {.lex_state = 197},
  [6312] = {.lex_state = 193},
  [6313] = {.lex_state = 197},
  [6314] = {.lex_state = 197},
  [6315] = {.lex_state = 193},
  [6316] = {.lex_state = 239},
  [6317] = {.lex_state = 0},
  [6318] = {.lex_state = 193},
  [6319] = {.lex_state = 193},
  [6320] = {.lex_state = 193},
  [6321] = {.lex_state = 193},
  [6322] = {.lex_state = 193},
  [6323] = {.lex_state = 193},
  [6324] = {.lex_state = 239},
  [6325] = {.lex_state = 193},
  [6326] = {.lex_state = 194},
  [6327] = {.lex_state = 239},
  [6328] = {.lex_state = 194},
  [6329] = {.lex_state = 239},
  [6330] = {.lex_state = 193},
  [6331] = {.lex_state = 235},
  [6332] = {.lex_state = 193},
  [6333] = {.lex_state = 193},
  [6334] = {.lex_state = 193},
  [6335] = {.lex_state = 239},
  [6336] = {.lex_state = 239},
  [6337] = {.lex_state = 193},
  [6338] = {.lex_state = 193},
  [6339] = {.lex_state = 193},
  [6340] = {.lex_state = 193},
  [6341] = {.lex_state = 193},
  [6342] = {.lex_state = 193},
  [6343] = {.lex_state = 193},
  [6344] = {.lex_state = 235},
  [6345] = {.lex_state = 235},
  [6346] = {.lex_state = 194},
  [6347] = {.lex_state = 194},
  [6348] = {.lex_state = 194},
  [6349] = {.lex_state = 194},
  [6350] = {.lex_state = 193},
  [6351] = {.lex_state = 235},
  [6352] = {.lex_state = 194},
  [6353] = {.lex_state = 193},
  [6354] = {.lex_state = 235},
  [6355] = {.lex_state = 193},
  [6356] = {.lex_state = 193},
  [6357] = {.lex_state = 193},
  [6358] = {.lex_state = 193},
  [6359] = {.lex_state = 193},
  [6360] = {.lex_state = 193},
  [6361] = {.lex_state = 194},
  [6362] = {.lex_state = 194},
  [6363] = {.lex_state = 195},
  [6364] = {.lex_state = 193},
  [6365] = {.lex_state = 213},
  [6366] = {.lex_state = 213},
  [6367] = {.lex_state = 193},
  [6368] = {.lex_state = 193},
  [6369] = {.lex_state = 195},
  [6370] = {.lex_state = 235},
  [6371] = {.lex_state = 235},
  [6372] = {.lex_state = 195},
  [6373] = {.lex_state = 195},
  [6374] = {.lex_state = 195},
  [6375] = {.lex_state = 193},
  [6376] = {.lex_state = 193},
  [6377] = {.lex_state = 191},
  [6378] = {.lex_state = 193},
  [6379] = {.lex_state = 193},
  [6380] = {.lex_state = 213},
  [6381] = {.lex_state = 193},
  [6382] = {.lex_state = 193},
  [6383] = {.lex_state = 235},
  [6384] = {.lex_state = 193},
  [6385] = {.lex_state = 194},
  [6386] = {.lex_state = 193},
  [6387] = {.lex_state = 195},
  [6388] = {.lex_state = 195},
  [6389] = {.lex_state = 213},
  [6390] = {.lex_state = 213},
  [6391] = {.lex_state = 195},
  [6392] = {.lex_state = 193},
  [6393] = {.lex_state = 195},
  [6394] = {.lex_state = 195},
  [6395] = {.lex_state = 213},
  [6396] = {.lex_state = 195},
  [6397] = {.lex_state = 213},
  [6398] = {.lex_state = 193},
  [6399] = {.lex_state = 194},
  [6400] = {.lex_state = 213},
  [6401] = {.lex_state = 193},
  [6402] = {.lex_state = 193},
  [6403] = {.lex_state = 193},
  [6404] = {.lex_state = 193},
  [6405] = {.lex_state = 193},
  [6406] = {.lex_state = 193},
  [6407] = {.lex_state = 195},
  [6408] = {.lex_state = 193},
  [6409] = {.lex_state = 193},
  [6410] = {.lex_state = 193},
  [6411] = {.lex_state = 194},
  [6412] = {.lex_state = 194},
  [6413] = {.lex_state = 194},
  [6414] = {.lex_state = 193},
  [6415] = {.lex_state = 194},
  [6416] = {.lex_state = 193},
  [6417] = {.lex_state = 193},
  [6418] = {.lex_state = 193},
  [6419] = {.lex_state = 239},
  [6420] = {.lex_state = 239},
  [6421] = {.lex_state = 239},
  [6422] = {.lex_state = 193},
  [6423] = {.lex_state = 226},
  [6424] = {.lex_state = 226},
  [6425] = {.lex_state = 193},
  [6426] = {.lex_state = 193},
  [6427] = {.lex_state = 193},
  [6428] = {.lex_state = 193},
  [6429] = {.lex_state = 193},
  [6430] = {.lex_state = 193},
  [6431] = {.lex_state = 194},
  [6432] = {.lex_state = 213},
  [6433] = {.lex_state = 222},
  [6434] = {.lex_state = 222},
  [6435] = {.lex_state = 193},
  [6436] = {.lex_state = 193},
  [6437] = {.lex_state = 193},
  [6438] = {.lex_state = 235},
  [6439] = {.lex_state = 178},
  [6440] = {.lex_state = 193},
  [6441] = {.lex_state = 193},
  [6442] = {.lex_state = 222},
  [6443] = {.lex_state = 213},
  [6444] = {.lex_state = 213},
  [6445] = {.lex_state = 222},
  [6446] = {.lex_state = 213},
  [6447] = {.lex_state = 213},
  [6448] = {.lex_state = 213},
  [6449] = {.lex_state = 194},
  [6450] = {.lex_state = 222},
  [6451] = {.lex_state = 213},
  [6452] = {.lex_state = 178},
  [6453] = {.lex_state = 222},
  [6454] = {.lex_state = 222},
  [6455] = {.lex_state = 213},
  [6456] = {.lex_state = 222},
  [6457] = {.lex_state = 222},
  [6458] = {.lex_state = 193},
  [6459] = {.lex_state = 213},
  [6460] = {.lex_state = 238},
  [6461] = {.lex_state = 222},
  [6462] = {.lex_state = 238},
  [6463] = {.lex_state = 238},
  [6464] = {.lex_state = 238},
  [6465] = {.lex_state = 238},
  [6466] = {.lex_state = 238},
  [6467] = {.lex_state = 238},
  [6468] = {.lex_state = 238},
  [6469] = {.lex_state = 222},
  [6470] = {.lex_state = 222},
  [6471] = {.lex_state = 336},
  [6472] = {.lex_state = 235},
  [6473] = {.lex_state = 235},
  [6474] = {.lex_state = 235},
  [6475] = {.lex_state = 222},
  [6476] = {.lex_state = 193},
  [6477] = {.lex_state = 193},
  [6478] = {.lex_state = 195},
  [6479] = {.lex_state = 195},
  [6480] = {.lex_state = 193},
  [6481] = {.lex_state = 195},
  [6482] = {.lex_state = 336},
  [6483] = {.lex_state = 193},
  [6484] = {.lex_state = 232},
  [6485] = {.lex_state = 193},
  [6486] = {.lex_state = 193},
  [6487] = {.lex_state = 193},
  [6488] = {.lex_state = 193},
  [6489] = {.lex_state = 195},
  [6490] = {.lex_state = 193},
  [6491] = {.lex_state = 195},
  [6492] = {.lex_state = 193},
  [6493] = {.lex_state = 193},
  [6494] = {.lex_state = 193},
  [6495] = {.lex_state = 336},
  [6496] = {.lex_state = 336},
  [6497] = {.lex_state = 195},
  [6498] = {.lex_state = 193},
  [6499] = {.lex_state = 193},
  [6500] = {.lex_state = 193},
  [6501] = {.lex_state = 201},
  [6502] = {.lex_state = 232},
  [6503] = {.lex_state = 336},
  [6504] = {.lex_state = 193},
  [6505] = {.lex_state = 193},
  [6506] = {.lex_state = 193},
  [6507] = {.lex_state = 193},
  [6508] = {.lex_state = 193},
  [6509] = {.lex_state = 193},
  [6510] = {.lex_state = 193},
  [6511] = {.lex_state = 193},
  [6512] = {.lex_state = 195},
  [6513] = {.lex_state = 193},
  [6514] = {.lex_state = 232},
  [6515] = {.lex_state = 193},
  [6516] = {.lex_state = 232},
  [6517] = {.lex_state = 336},
  [6518] = {.lex_state = 193},
  [6519] = {.lex_state = 193},
  [6520] = {.lex_state = 193},
  [6521] = {.lex_state = 336},
  [6522] = {.lex_state = 193},
  [6523] = {.lex_state = 193},
  [6524] = {.lex_state = 193},
  [6525] = {.lex_state = 193},
  [6526] = {.lex_state = 201},
  [6527] = {.lex_state = 195},
  [6528] = {.lex_state = 193},
  [6529] = {.lex_state = 193},
  [6530] = {.lex_state = 193},
  [6531] = {.lex_state = 193},
  [6532] = {.lex_state = 336},
  [6533] = {.lex_state = 197},
  [6534] = {.lex_state = 235},
  [6535] = {.lex_state = 197},
  [6536] = {.lex_state = 336},
  [6537] = {.lex_state = 336},
  [6538] = {.lex_state = 336},
  [6539] = {.lex_state = 195},
  [6540] = {.lex_state = 336},
  [6541] = {.lex_state = 195},
  [6542] = {.lex_state = 336},
  [6543] = {.lex_state = 336},
  [6544] = {.lex_state = 195},
  [6545] = {.lex_state = 222},
  [6546] = {.lex_state = 336},
  [6547] = {.lex_state = 235},
  [6548] = {.lex_state = 213},
  [6549] = {.lex_state = 336},
  [6550] = {.lex_state = 336},
  [6551] = {.lex_state = 193},
  [6552] = {.lex_state = 336},
  [6553] = {.lex_state = 222},
  [6554] = {.lex_state = 197},
  [6555] = {.lex_state = 173},
  [6556] = {.lex_state = 336},
  [6557] = {.lex_state = 197},
  [6558] = {.lex_state = 195},
  [6559] = {.lex_state = 336},
  [6560] = {.lex_state = 195},
  [6561] = {.lex_state = 194},
  [6562] = {.lex_state = 235},
  [6563] = {.lex_state = 193},
  [6564] = {.lex_state = 336},
  [6565] = {.lex_state = 197},
  [6566] = {.lex_state = 197},
  [6567] = {.lex_state = 336},
  [6568] = {.lex_state = 197},
  [6569] = {.lex_state = 235},
  [6570] = {.lex_state = 194},
  [6571] = {.lex_state = 235},
  [6572] = {.lex_state = 194},
  [6573] = {.lex_state = 238},
  [6574] = {.lex_state = 336},
  [6575] = {.lex_state = 336},
  [6576] = {.lex_state = 336},
  [6577] = {.lex_state = 336},
  [6578] = {.lex_state = 213},
  [6579] = {.lex_state = 336},
  [6580] = {.lex_state = 336},
  [6581] = {.lex_state = 336},
  [6582] = {.lex_state = 173},
  [6583] = {.lex_state = 336},
  [6584] = {.lex_state = 195},
  [6585] = {.lex_state = 213},
  [6586] = {.lex_state = 238},
  [6587] = {.lex_state = 194},
  [6588] = {.lex_state = 240},
  [6589] = {.lex_state = 197},
  [6590] = {.lex_state = 336},
  [6591] = {.lex_state = 213},
  [6592] = {.lex_state = 336},
  [6593] = {.lex_state = 235},
  [6594] = {.lex_state = 336},
  [6595] = {.lex_state = 238},
  [6596] = {.lex_state = 173},
  [6597] = {.lex_state = 193},
  [6598] = {.lex_state = 173},
  [6599] = {.lex_state = 193},
  [6600] = {.lex_state = 336},
  [6601] = {.lex_state = 193},
  [6602] = {.lex_state = 173},
  [6603] = {.lex_state = 235},
  [6604] = {.lex_state = 193},
  [6605] = {.lex_state = 336},
  [6606] = {.lex_state = 193},
  [6607] = {.lex_state = 173},
  [6608] = {.lex_state = 213},
  [6609] = {.lex_state = 173},
  [6610] = {.lex_state = 193},
  [6611] = {.lex_state = 336},
  [6612] = {.lex_state = 195},
  [6613] = {.lex_state = 235},
  [6614] = {.lex_state = 193},
  [6615] = {.lex_state = 336},
  [6616] = {.lex_state = 173},
  [6617] = {.lex_state = 173},
  [6618] = {.lex_state = 173},
  [6619] = {.lex_state = 173},
  [6620] = {.lex_state = 193},
  [6621] = {.lex_state = 201},
  [6622] = {.lex_state = 193},
  [6623] = {.lex_state = 336},
  [6624] = {.lex_state = 195},
  [6625] = {.lex_state = 173},
  [6626] = {.lex_state = 336},
  [6627] = {.lex_state = 193},
  [6628] = {.lex_state = 193},
  [6629] = {.lex_state = 201},
  [6630] = {.lex_state = 193},
  [6631] = {.lex_state = 193},
  [6632] = {.lex_state = 193},
  [6633] = {.lex_state = 173},
  [6634] = {.lex_state = 193},
  [6635] = {.lex_state = 173},
  [6636] = {.lex_state = 336},
  [6637] = {.lex_state = 193},
  [6638] = {.lex_state = 213},
  [6639] = {.lex_state = 193},
  [6640] = {.lex_state = 213},
  [6641] = {.lex_state = 193},
  [6642] = {.lex_state = 193},
  [6643] = {.lex_state = 195},
  [6644] = {.lex_state = 193},
  [6645] = {.lex_state = 336},
  [6646] = {.lex_state = 193},
  [6647] = {.lex_state = 195},
  [6648] = {.lex_state = 193},
  [6649] = {.lex_state = 201},
  [6650] = {.lex_state = 173},
  [6651] = {.lex_state = 173},
  [6652] = {.lex_state = 173},
  [6653] = {.lex_state = 336},
  [6654] = {.lex_state = 336},
  [6655] = {.lex_state = 173},
  [6656] = {.lex_state = 193},
  [6657] = {.lex_state = 173},
  [6658] = {.lex_state = 173},
  [6659] = {.lex_state = 173},
  [6660] = {.lex_state = 336},
  [6661] = {.lex_state = 173},
  [6662] = {.lex_state = 173},
  [6663] = {.lex_state = 336},
  [6664] = {.lex_state = 195},
  [6665] = {.lex_state = 173},
  [6666] = {.lex_state = 193},
  [6667] = {.lex_state = 193},
  [6668] = {.lex_state = 173},
  [6669] = {.lex_state = 193},
  [6670] = {.lex_state = 336},
  [6671] = {.lex_state = 235},
  [6672] = {.lex_state = 235},
  [6673] = {.lex_state = 193},
  [6674] = {.lex_state = 193},
  [6675] = {.lex_state = 235},
  [6676] = {.lex_state = 191},
  [6677] = {.lex_state = 336},
  [6678] = {.lex_state = 193},
  [6679] = {.lex_state = 193},
  [6680] = {.lex_state = 193},
  [6681] = {.lex_state = 193},
  [6682] = {.lex_state = 193},
  [6683] = {.lex_state = 193},
  [6684] = {.lex_state = 193},
  [6685] = {.lex_state = 191},
  [6686] = {.lex_state = 193},
  [6687] = {.lex_state = 235},
  [6688] = {.lex_state = 235},
  [6689] = {.lex_state = 235},
  [6690] = {.lex_state = 235},
  [6691] = {.lex_state = 193},
  [6692] = {.lex_state = 193},
  [6693] = {.lex_state = 336},
  [6694] = {.lex_state = 0},
  [6695] = {.lex_state = 193},
  [6696] = {.lex_state = 191},
  [6697] = {.lex_state = 191},
  [6698] = {.lex_state = 191},
  [6699] = {.lex_state = 193},
  [6700] = {.lex_state = 235},
  [6701] = {.lex_state = 336},
  [6702] = {.lex_state = 235},
  [6703] = {.lex_state = 191},
  [6704] = {.lex_state = 0},
  [6705] = {.lex_state = 193},
  [6706] = {.lex_state = 336},
  [6707] = {.lex_state = 235},
  [6708] = {.lex_state = 235},
  [6709] = {.lex_state = 191},
  [6710] = {.lex_state = 193},
  [6711] = {.lex_state = 193},
  [6712] = {.lex_state = 191},
  [6713] = {.lex_state = 193},
  [6714] = {.lex_state = 193},
  [6715] = {.lex_state = 191},
  [6716] = {.lex_state = 193},
  [6717] = {.lex_state = 235},
  [6718] = {.lex_state = 235},
  [6719] = {.lex_state = 193},
  [6720] = {.lex_state = 191},
  [6721] = {.lex_state = 235},
  [6722] = {.lex_state = 191},
  [6723] = {.lex_state = 193},
  [6724] = {.lex_state = 193},
  [6725] = {.lex_state = 193},
  [6726] = {.lex_state = 193},
  [6727] = {.lex_state = 195},
  [6728] = {.lex_state = 193},
  [6729] = {.lex_state = 193},
  [6730] = {.lex_state = 193},
  [6731] = {.lex_state = 193},
  [6732] = {.lex_state = 193},
  [6733] = {.lex_state = 173},
  [6734] = {.lex_state = 193},
  [6735] = {.lex_state = 213},
  [6736] = {.lex_state = 193},
  [6737] = {.lex_state = 193},
  [6738] = {.lex_state = 193},
  [6739] = {.lex_state = 193},
  [6740] = {.lex_state = 193},
  [6741] = {.lex_state = 193},
  [6742] = {.lex_state = 196},
  [6743] = {.lex_state = 193},
  [6744] = {.lex_state = 235},
  [6745] = {.lex_state = 193},
  [6746] = {.lex_state = 193},
  [6747] = {.lex_state = 196},
  [6748] = {.lex_state = 193},
  [6749] = {.lex_state = 193},
  [6750] = {.lex_state = 196},
  [6751] = {.lex_state = 193},
  [6752] = {.lex_state = 173},
  [6753] = {.lex_state = 336},
  [6754] = {.lex_state = 193},
  [6755] = {.lex_state = 196},
  [6756] = {.lex_state = 336},
  [6757] = {.lex_state = 193},
  [6758] = {.lex_state = 336},
  [6759] = {.lex_state = 193},
  [6760] = {.lex_state = 196},
  [6761] = {.lex_state = 193},
  [6762] = {.lex_state = 193},
  [6763] = {.lex_state = 193},
  [6764] = {.lex_state = 193},
  [6765] = {.lex_state = 193},
  [6766] = {.lex_state = 193},
  [6767] = {.lex_state = 193},
  [6768] = {.lex_state = 193},
  [6769] = {.lex_state = 193},
  [6770] = {.lex_state = 193},
  [6771] = {.lex_state = 193},
  [6772] = {.lex_state = 336},
  [6773] = {.lex_state = 193},
  [6774] = {.lex_state = 193},
  [6775] = {.lex_state = 196},
  [6776] = {.lex_state = 193},
  [6777] = {.lex_state = 193},
  [6778] = {.lex_state = 193},
  [6779] = {.lex_state = 196},
  [6780] = {.lex_state = 196},
  [6781] = {.lex_state = 169},
  [6782] = {.lex_state = 193},
  [6783] = {.lex_state = 193},
  [6784] = {.lex_state = 193},
  [6785] = {.lex_state = 193},
  [6786] = {.lex_state = 193},
  [6787] = {.lex_state = 213},
  [6788] = {.lex_state = 193},
  [6789] = {.lex_state = 173},
  [6790] = {.lex_state = 193},
  [6791] = {.lex_state = 193},
  [6792] = {.lex_state = 193},
  [6793] = {.lex_state = 193},
  [6794] = {.lex_state = 193},
  [6795] = {.lex_state = 193},
  [6796] = {.lex_state = 193},
  [6797] = {.lex_state = 193},
  [6798] = {.lex_state = 193},
  [6799] = {.lex_state = 193},
  [6800] = {.lex_state = 173},
  [6801] = {.lex_state = 193},
  [6802] = {.lex_state = 173},
  [6803] = {.lex_state = 173},
  [6804] = {.lex_state = 173},
  [6805] = {.lex_state = 173},
  [6806] = {.lex_state = 173},
  [6807] = {.lex_state = 336},
  [6808] = {.lex_state = 173},
  [6809] = {.lex_state = 196},
  [6810] = {.lex_state = 108},
  [6811] = {.lex_state = 196},
  [6812] = {.lex_state = 196},
  [6813] = {.lex_state = 110},
  [6814] = {.lex_state = 108},
  [6815] = {.lex_state = 336},
  [6816] = {.lex_state = 196},
  [6817] = {.lex_state = 0},
  [6818] = {.lex_state = 173},
  [6819] = {.lex_state = 235},
  [6820] = {.lex_state = 173},
  [6821] = {.lex_state = 196},
  [6822] = {.lex_state = 196},
  [6823] = {.lex_state = 108},
  [6824] = {.lex_state = 196},
  [6825] = {.lex_state = 196},
  [6826] = {.lex_state = 110},
  [6827] = {.lex_state = 108},
  [6828] = {.lex_state = 0},
  [6829] = {.lex_state = 196},
  [6830] = {.lex_state = 336},
  [6831] = {.lex_state = 173},
  [6832] = {.lex_state = 336},
  [6833] = {.lex_state = 196},
  [6834] = {.lex_state = 0},
  [6835] = {.lex_state = 173},
  [6836] = {.lex_state = 173},
  [6837] = {.lex_state = 196},
  [6838] = {.lex_state = 110},
  [6839] = {.lex_state = 108},
  [6840] = {.lex_state = 108},
  [6841] = {.lex_state = 196},
  [6842] = {.lex_state = 110},
  [6843] = {.lex_state = 108},
  [6844] = {.lex_state = 173},
  [6845] = {.lex_state = 196},
  [6846] = {.lex_state = 0},
  [6847] = {.lex_state = 173},
  [6848] = {.lex_state = 173},
  [6849] = {.lex_state = 336},
  [6850] = {.lex_state = 193},
  [6851] = {.lex_state = 108},
  [6852] = {.lex_state = 336},
  [6853] = {.lex_state = 110},
  [6854] = {.lex_state = 108},
  [6855] = {.lex_state = 0},
  [6856] = {.lex_state = 108},
  [6857] = {.lex_state = 108},
  [6858] = {.lex_state = 110},
  [6859] = {.lex_state = 108},
  [6860] = {.lex_state = 0},
  [6861] = {.lex_state = 235},
  [6862] = {.lex_state = 111},
  [6863] = {.lex_state = 108},
  [6864] = {.lex_state = 108},
  [6865] = {.lex_state = 0},
  [6866] = {.lex_state = 108},
  [6867] = {.lex_state = 336},
  [6868] = {.lex_state = 336},
  [6869] = {.lex_state = 108},
  [6870] = {.lex_state = 0},
  [6871] = {.lex_state = 108},
  [6872] = {.lex_state = 108},
  [6873] = {.lex_state = 0},
  [6874] = {.lex_state = 196},
  [6875] = {.lex_state = 336},
  [6876] = {.lex_state = 111},
  [6877] = {.lex_state = 108},
  [6878] = {.lex_state = 196},
  [6879] = {.lex_state = 108},
  [6880] = {.lex_state = 0},
  [6881] = {.lex_state = 108},
  [6882] = {.lex_state = 108},
  [6883] = {.lex_state = 0},
  [6884] = {.lex_state = 108},
  [6885] = {.lex_state = 110},
  [6886] = {.lex_state = 108},
  [6887] = {.lex_state = 108},
  [6888] = {.lex_state = 108},
  [6889] = {.lex_state = 108},
  [6890] = {.lex_state = 336},
  [6891] = {.lex_state = 336},
  [6892] = {.lex_state = 173},
  [6893] = {.lex_state = 173},
  [6894] = {.lex_state = 173},
  [6895] = {.lex_state = 196},
  [6896] = {.lex_state = 193},
  [6897] = {.lex_state = 193},
  [6898] = {.lex_state = 235},
  [6899] = {.lex_state = 196},
  [6900] = {.lex_state = 0},
  [6901] = {.lex_state = 336},
  [6902] = {.lex_state = 193},
  [6903] = {.lex_state = 193},
  [6904] = {.lex_state = 336},
  [6905] = {.lex_state = 336},
  [6906] = {.lex_state = 173},
  [6907] = {.lex_state = 193},
  [6908] = {.lex_state = 336},
  [6909] = {.lex_state = 173},
  [6910] = {.lex_state = 213},
  [6911] = {.lex_state = 235},
  [6912] = {.lex_state = 169},
  [6913] = {.lex_state = 196},
  [6914] = {.lex_state = 193},
  [6915] = {.lex_state = 196},
  [6916] = {.lex_state = 196},
  [6917] = {.lex_state = 110},
  [6918] = {.lex_state = 108},
  [6919] = {.lex_state = 0},
  [6920] = {.lex_state = 173},
  [6921] = {.lex_state = 108},
  [6922] = {.lex_state = 111},
  [6923] = {.lex_state = 111},
  [6924] = {.lex_state = 108},
  [6925] = {.lex_state = 336},
  [6926] = {.lex_state = 336},
  [6927] = {.lex_state = 196},
  [6928] = {.lex_state = 336},
  [6929] = {.lex_state = 110},
  [6930] = {.lex_state = 108},
  [6931] = {.lex_state = 108},
  [6932] = {.lex_state = 336},
  [6933] = {.lex_state = 193},
  [6934] = {.lex_state = 193},
  [6935] = {.lex_state = 336},
  [6936] = {.lex_state = 173},
  [6937] = {.lex_state = 196},
  [6938] = {.lex_state = 196},
  [6939] = {.lex_state = 193},
  [6940] = {.lex_state = 235},
  [6941] = {.lex_state = 196},
  [6942] = {.lex_state = 110},
  [6943] = {.lex_state = 108},
  [6944] = {.lex_state = 0},
  [6945] = {.lex_state = 336},
  [6946] = {.lex_state = 196},
  [6947] = {.lex_state = 336},
  [6948] = {.lex_state = 173},
  [6949] = {.lex_state = 336},
  [6950] = {.lex_state = 336},
  [6951] = {.lex_state = 196},
  [6952] = {.lex_state = 235},
  [6953] = {.lex_state = 235},
  [6954] = {.lex_state = 173},
  [6955] = {.lex_state = 173},
  [6956] = {.lex_state = 235},
  [6957] = {.lex_state = 0},
  [6958] = {.lex_state = 173},
  [6959] = {.lex_state = 196},
  [6960] = {.lex_state = 173},
  [6961] = {.lex_state = 235},
  [6962] = {.lex_state = 0},
  [6963] = {.lex_state = 108},
  [6964] = {.lex_state = 196},
  [6965] = {.lex_state = 336},
  [6966] = {.lex_state = 235},
  [6967] = {.lex_state = 111},
  [6968] = {.lex_state = 336},
  [6969] = {.lex_state = 193},
  [6970] = {.lex_state = 196},
  [6971] = {.lex_state = 196},
  [6972] = {.lex_state = 110},
  [6973] = {.lex_state = 108},
  [6974] = {.lex_state = 196},
  [6975] = {.lex_state = 108},
  [6976] = {.lex_state = 336},
  [6977] = {.lex_state = 173},
  [6978] = {.lex_state = 0},
  [6979] = {.lex_state = 196},
  [6980] = {.lex_state = 336},
  [6981] = {.lex_state = 0},
  [6982] = {.lex_state = 196},
  [6983] = {.lex_state = 336},
  [6984] = {.lex_state = 0},
  [6985] = {.lex_state = 336},
  [6986] = {.lex_state = 336},
  [6987] = {.lex_state = 193},
  [6988] = {.lex_state = 173},
  [6989] = {.lex_state = 196},
  [6990] = {.lex_state = 336},
  [6991] = {.lex_state = 173},
  [6992] = {.lex_state = 196},
  [6993] = {.lex_state = 196},
  [6994] = {.lex_state = 173},
  [6995] = {.lex_state = 336},
  [6996] = {.lex_state = 336},
  [6997] = {.lex_state = 108},
  [6998] = {.lex_state = 336},
  [6999] = {.lex_state = 336},
  [7000] = {.lex_state = 111},
  [7001] = {.lex_state = 336},
  [7002] = {.lex_state = 336},
  [7003] = {.lex_state = 111},
  [7004] = {.lex_state = 336},
  [7005] = {.lex_state = 336},
  [7006] = {.lex_state = 336},
  [7007] = {.lex_state = 336},
  [7008] = {.lex_state = 336},
  [7009] = {.lex_state = 336},
  [7010] = {.lex_state = 196},
  [7011] = {.lex_state = 336},
  [7012] = {.lex_state = 110},
  [7013] = {.lex_state = 108},
  [7014] = {.lex_state = 196},
  [7015] = {.lex_state = 196},
  [7016] = {.lex_state = 193},
  [7017] = {.lex_state = 336},
  [7018] = {.lex_state = 110},
  [7019] = {.lex_state = 173},
  [7020] = {.lex_state = 196},
  [7021] = {.lex_state = 0},
  [7022] = {.lex_state = 108},
  [7023] = {.lex_state = 336},
  [7024] = {.lex_state = 0},
  [7025] = {.lex_state = 193},
  [7026] = {.lex_state = 0},
  [7027] = {.lex_state = 193},
  [7028] = {.lex_state = 0},
  [7029] = {.lex_state = 169},
  [7030] = {.lex_state = 0},
  [7031] = {.lex_state = 0},
  [7032] = {.lex_state = 0},
  [7033] = {.lex_state = 193},
  [7034] = {.lex_state = 193},
  [7035] = {.lex_state = 196},
  [7036] = {.lex_state = 0},
  [7037] = {.lex_state = 169},
  [7038] = {.lex_state = 0},
  [7039] = {.lex_state = 0},
  [7040] = {.lex_state = 0},
  [7041] = {.lex_state = 196},
  [7042] = {.lex_state = 196},
  [7043] = {.lex_state = 196},
  [7044] = {.lex_state = 0},
  [7045] = {.lex_state = 0},
  [7046] = {.lex_state = 0},
  [7047] = {.lex_state = 0},
  [7048] = {.lex_state = 0},
  [7049] = {.lex_state = 0},
  [7050] = {.lex_state = 0},
  [7051] = {.lex_state = 0},
  [7052] = {.lex_state = 0},
  [7053] = {.lex_state = 0},
  [7054] = {.lex_state = 0},
  [7055] = {.lex_state = 0},
  [7056] = {.lex_state = 196},
  [7057] = {.lex_state = 193},
  [7058] = {.lex_state = 0},
  [7059] = {.lex_state = 0},
  [7060] = {.lex_state = 336},
  [7061] = {.lex_state = 0},
  [7062] = {.lex_state = 0},
  [7063] = {.lex_state = 193},
  [7064] = {.lex_state = 196},
  [7065] = {.lex_state = 0},
  [7066] = {.lex_state = 0},
  [7067] = {.lex_state = 169},
  [7068] = {.lex_state = 0},
  [7069] = {.lex_state = 0},
  [7070] = {.lex_state = 0},
  [7071] = {.lex_state = 0},
  [7072] = {.lex_state = 0},
  [7073] = {.lex_state = 169},
  [7074] = {.lex_state = 0},
  [7075] = {.lex_state = 0},
  [7076] = {.lex_state = 213},
  [7077] = {.lex_state = 196},
  [7078] = {.lex_state = 196},
  [7079] = {.lex_state = 196},
  [7080] = {.lex_state = 0},
  [7081] = {.lex_state = 0},
  [7082] = {.lex_state = 0},
  [7083] = {.lex_state = 0},
  [7084] = {.lex_state = 193},
  [7085] = {.lex_state = 0},
  [7086] = {.lex_state = 193},
  [7087] = {.lex_state = 0},
  [7088] = {.lex_state = 193},
  [7089] = {.lex_state = 193},
  [7090] = {.lex_state = 193},
  [7091] = {.lex_state = 196},
  [7092] = {.lex_state = 196},
  [7093] = {.lex_state = 0},
  [7094] = {.lex_state = 0},
  [7095] = {.lex_state = 0},
  [7096] = {.lex_state = 193},
  [7097] = {.lex_state = 196},
  [7098] = {.lex_state = 196},
  [7099] = {.lex_state = 196},
  [7100] = {.lex_state = 0},
  [7101] = {.lex_state = 0},
  [7102] = {.lex_state = 0},
  [7103] = {.lex_state = 0},
  [7104] = {.lex_state = 0},
  [7105] = {.lex_state = 0},
  [7106] = {.lex_state = 0},
  [7107] = {.lex_state = 110},
  [7108] = {.lex_state = 169},
  [7109] = {.lex_state = 193},
  [7110] = {.lex_state = 0},
  [7111] = {.lex_state = 193},
  [7112] = {.lex_state = 0},
  [7113] = {.lex_state = 196},
  [7114] = {.lex_state = 193},
  [7115] = {.lex_state = 336},
  [7116] = {.lex_state = 196},
  [7117] = {.lex_state = 196},
  [7118] = {.lex_state = 0},
  [7119] = {.lex_state = 193},
  [7120] = {.lex_state = 0},
  [7121] = {.lex_state = 169},
  [7122] = {.lex_state = 336},
  [7123] = {.lex_state = 0},
  [7124] = {.lex_state = 0},
  [7125] = {.lex_state = 113},
  [7126] = {.lex_state = 0},
  [7127] = {.lex_state = 196},
  [7128] = {.lex_state = 0},
  [7129] = {.lex_state = 0},
  [7130] = {.lex_state = 0},
  [7131] = {.lex_state = 193},
  [7132] = {.lex_state = 0},
  [7133] = {.lex_state = 169},
  [7134] = {.lex_state = 193},
  [7135] = {.lex_state = 0},
  [7136] = {.lex_state = 196},
  [7137] = {.lex_state = 0},
  [7138] = {.lex_state = 0},
  [7139] = {.lex_state = 0},
  [7140] = {.lex_state = 0},
  [7141] = {.lex_state = 0},
  [7142] = {.lex_state = 193},
  [7143] = {.lex_state = 0},
  [7144] = {.lex_state = 0},
  [7145] = {.lex_state = 193},
  [7146] = {.lex_state = 0},
  [7147] = {.lex_state = 0},
  [7148] = {.lex_state = 0},
  [7149] = {.lex_state = 0},
  [7150] = {.lex_state = 193},
  [7151] = {.lex_state = 0},
  [7152] = {.lex_state = 110},
  [7153] = {.lex_state = 169},
  [7154] = {.lex_state = 0},
  [7155] = {.lex_state = 0},
  [7156] = {.lex_state = 193},
  [7157] = {.lex_state = 0},
  [7158] = {.lex_state = 0},
  [7159] = {.lex_state = 0},
  [7160] = {.lex_state = 0},
  [7161] = {.lex_state = 173},
  [7162] = {.lex_state = 193},
  [7163] = {.lex_state = 193},
  [7164] = {.lex_state = 193},
  [7165] = {.lex_state = 169},
  [7166] = {.lex_state = 0},
  [7167] = {.lex_state = 0},
  [7168] = {.lex_state = 0},
  [7169] = {.lex_state = 0},
  [7170] = {.lex_state = 0},
  [7171] = {.lex_state = 0},
  [7172] = {.lex_state = 193},
  [7173] = {.lex_state = 0},
  [7174] = {.lex_state = 0},
  [7175] = {.lex_state = 0},
  [7176] = {.lex_state = 196},
  [7177] = {.lex_state = 196},
  [7178] = {.lex_state = 113},
  [7179] = {.lex_state = 0},
  [7180] = {.lex_state = 0},
  [7181] = {.lex_state = 0},
  [7182] = {.lex_state = 196},
  [7183] = {.lex_state = 0},
  [7184] = {.lex_state = 0},
  [7185] = {.lex_state = 0},
  [7186] = {.lex_state = 0},
  [7187] = {.lex_state = 193},
  [7188] = {.lex_state = 193},
  [7189] = {.lex_state = 0},
  [7190] = {.lex_state = 0},
  [7191] = {.lex_state = 0},
  [7192] = {.lex_state = 0},
  [7193] = {.lex_state = 193},
  [7194] = {.lex_state = 0},
  [7195] = {.lex_state = 162},
  [7196] = {.lex_state = 0},
  [7197] = {.lex_state = 0},
  [7198] = {.lex_state = 0},
  [7199] = {.lex_state = 193},
  [7200] = {.lex_state = 110},
  [7201] = {.lex_state = 193},
  [7202] = {.lex_state = 193},
  [7203] = {.lex_state = 0},
  [7204] = {.lex_state = 196},
  [7205] = {.lex_state = 0},
  [7206] = {.lex_state = 196},
  [7207] = {.lex_state = 0},
  [7208] = {.lex_state = 0},
  [7209] = {.lex_state = 0},
  [7210] = {.lex_state = 193},
  [7211] = {.lex_state = 0},
  [7212] = {.lex_state = 0},
  [7213] = {.lex_state = 0},
  [7214] = {.lex_state = 0},
  [7215] = {.lex_state = 0},
  [7216] = {.lex_state = 193},
  [7217] = {.lex_state = 0},
  [7218] = {.lex_state = 0},
  [7219] = {.lex_state = 196},
  [7220] = {.lex_state = 173},
  [7221] = {.lex_state = 196},
  [7222] = {.lex_state = 196},
  [7223] = {.lex_state = 113},
  [7224] = {.lex_state = 196},
  [7225] = {.lex_state = 196},
  [7226] = {.lex_state = 0},
  [7227] = {.lex_state = 196},
  [7228] = {.lex_state = 0},
  [7229] = {.lex_state = 110},
  [7230] = {.lex_state = 0},
  [7231] = {.lex_state = 0},
  [7232] = {.lex_state = 193},
  [7233] = {.lex_state = 193},
  [7234] = {.lex_state = 193},
  [7235] = {.lex_state = 196},
  [7236] = {.lex_state = 193},
  [7237] = {.lex_state = 0},
  [7238] = {.lex_state = 193},
  [7239] = {.lex_state = 193},
  [7240] = {.lex_state = 0},
  [7241] = {.lex_state = 0},
  [7242] = {.lex_state = 193},
  [7243] = {.lex_state = 193},
  [7244] = {.lex_state = 110},
  [7245] = {.lex_state = 0},
  [7246] = {.lex_state = 0},
  [7247] = {.lex_state = 193},
  [7248] = {.lex_state = 0},
  [7249] = {.lex_state = 0},
  [7250] = {.lex_state = 0},
  [7251] = {.lex_state = 0},
  [7252] = {.lex_state = 193},
  [7253] = {.lex_state = 0},
  [7254] = {.lex_state = 169},
  [7255] = {.lex_state = 193},
  [7256] = {.lex_state = 193},
  [7257] = {.lex_state = 0},
  [7258] = {.lex_state = 196},
  [7259] = {.lex_state = 196},
  [7260] = {.lex_state = 110},
  [7261] = {.lex_state = 169},
  [7262] = {.lex_state = 169},
  [7263] = {.lex_state = 0},
  [7264] = {.lex_state = 193},
  [7265] = {.lex_state = 193},
  [7266] = {.lex_state = 0},
  [7267] = {.lex_state = 0},
  [7268] = {.lex_state = 0},
  [7269] = {.lex_state = 0},
  [7270] = {.lex_state = 0},
  [7271] = {.lex_state = 0},
  [7272] = {.lex_state = 0},
  [7273] = {.lex_state = 0},
  [7274] = {.lex_state = 193},
  [7275] = {.lex_state = 110},
  [7276] = {.lex_state = 0},
  [7277] = {.lex_state = 196},
  [7278] = {.lex_state = 110},
  [7279] = {.lex_state = 0},
  [7280] = {.lex_state = 0},
  [7281] = {.lex_state = 110},
  [7282] = {.lex_state = 110},
  [7283] = {.lex_state = 110},
  [7284] = {.lex_state = 196},
  [7285] = {.lex_state = 0},
  [7286] = {.lex_state = 193},
  [7287] = {.lex_state = 0},
  [7288] = {.lex_state = 0},
  [7289] = {.lex_state = 196},
  [7290] = {.lex_state = 196},
  [7291] = {.lex_state = 0},
  [7292] = {.lex_state = 169},
  [7293] = {.lex_state = 0},
  [7294] = {.lex_state = 0},
  [7295] = {.lex_state = 0},
  [7296] = {.lex_state = 196},
  [7297] = {.lex_state = 0},
  [7298] = {.lex_state = 0},
  [7299] = {.lex_state = 0},
  [7300] = {.lex_state = 0},
  [7301] = {.lex_state = 193},
  [7302] = {.lex_state = 196},
  [7303] = {.lex_state = 193},
  [7304] = {.lex_state = 0},
  [7305] = {.lex_state = 0},
  [7306] = {.lex_state = 0},
  [7307] = {.lex_state = 0},
  [7308] = {.lex_state = 0},
  [7309] = {.lex_state = 0},
  [7310] = {.lex_state = 0},
  [7311] = {.lex_state = 0},
  [7312] = {.lex_state = 193},
  [7313] = {.lex_state = 0},
  [7314] = {.lex_state = 0},
  [7315] = {.lex_state = 196},
  [7316] = {.lex_state = 0},
  [7317] = {.lex_state = 193},
  [7318] = {.lex_state = 196},
  [7319] = {.lex_state = 0},
  [7320] = {.lex_state = 0},
  [7321] = {.lex_state = 0},
  [7322] = {.lex_state = 0},
  [7323] = {.lex_state = 0},
  [7324] = {.lex_state = 196},
  [7325] = {.lex_state = 196},
  [7326] = {.lex_state = 0},
  [7327] = {.lex_state = 0},
  [7328] = {.lex_state = 0},
  [7329] = {.lex_state = 0},
  [7330] = {.lex_state = 0},
  [7331] = {.lex_state = 196},
  [7332] = {.lex_state = 196},
  [7333] = {.lex_state = 0},
  [7334] = {.lex_state = 193},
  [7335] = {.lex_state = 0},
  [7336] = {.lex_state = 193},
  [7337] = {.lex_state = 193},
  [7338] = {.lex_state = 193},
  [7339] = {.lex_state = 196},
  [7340] = {.lex_state = 196},
  [7341] = {.lex_state = 196},
  [7342] = {.lex_state = 0},
  [7343] = {.lex_state = 196},
  [7344] = {.lex_state = 196},
  [7345] = {.lex_state = 196},
  [7346] = {.lex_state = 196},
  [7347] = {.lex_state = 0},
  [7348] = {.lex_state = 196},
  [7349] = {.lex_state = 0},
  [7350] = {.lex_state = 0},
  [7351] = {.lex_state = 0},
  [7352] = {.lex_state = 0},
  [7353] = {.lex_state = 0},
  [7354] = {.lex_state = 0},
  [7355] = {.lex_state = 0},
  [7356] = {.lex_state = 0},
  [7357] = {.lex_state = 0},
  [7358] = {.lex_state = 0},
  [7359] = {.lex_state = 0},
  [7360] = {.lex_state = 0},
  [7361] = {.lex_state = 193},
  [7362] = {.lex_state = 0},
  [7363] = {.lex_state = 0},
  [7364] = {.lex_state = 0},
  [7365] = {.lex_state = 196},
  [7366] = {.lex_state = 196},
  [7367] = {.lex_state = 0},
  [7368] = {.lex_state = 193},
  [7369] = {.lex_state = 113},
  [7370] = {.lex_state = 0},
  [7371] = {.lex_state = 196},
  [7372] = {.lex_state = 0},
  [7373] = {.lex_state = 196},
  [7374] = {.lex_state = 193},
  [7375] = {.lex_state = 193},
  [7376] = {.lex_state = 169},
  [7377] = {.lex_state = 169},
  [7378] = {.lex_state = 193},
  [7379] = {.lex_state = 0},
  [7380] = {.lex_state = 193},
  [7381] = {.lex_state = 193},
  [7382] = {.lex_state = 173},
  [7383] = {.lex_state = 0},
  [7384] = {.lex_state = 196},
  [7385] = {.lex_state = 169},
  [7386] = {.lex_state = 193},
  [7387] = {.lex_state = 110},
  [7388] = {.lex_state = 0},
  [7389] = {.lex_state = 0},
  [7390] = {.lex_state = 0},
  [7391] = {.lex_state = 0},
  [7392] = {.lex_state = 0},
  [7393] = {.lex_state = 193},
  [7394] = {.lex_state = 0},
  [7395] = {.lex_state = 0},
  [7396] = {.lex_state = 196},
  [7397] = {.lex_state = 0},
  [7398] = {.lex_state = 0},
  [7399] = {.lex_state = 0},
  [7400] = {.lex_state = 0},
  [7401] = {.lex_state = 193},
  [7402] = {.lex_state = 0},
  [7403] = {.lex_state = 193},
  [7404] = {.lex_state = 0},
  [7405] = {.lex_state = 169},
  [7406] = {.lex_state = 0},
  [7407] = {.lex_state = 0},
  [7408] = {.lex_state = 196},
  [7409] = {.lex_state = 196},
  [7410] = {.lex_state = 0},
  [7411] = {.lex_state = 196},
  [7412] = {.lex_state = 196},
  [7413] = {.lex_state = 0},
  [7414] = {.lex_state = 0},
  [7415] = {.lex_state = 0},
  [7416] = {.lex_state = 0},
  [7417] = {.lex_state = 196},
  [7418] = {.lex_state = 0},
  [7419] = {.lex_state = 0},
  [7420] = {.lex_state = 0},
  [7421] = {.lex_state = 0},
  [7422] = {.lex_state = 0},
  [7423] = {.lex_state = 0},
  [7424] = {.lex_state = 0},
  [7425] = {.lex_state = 0},
  [7426] = {.lex_state = 193},
  [7427] = {.lex_state = 193},
  [7428] = {.lex_state = 0},
  [7429] = {.lex_state = 0},
  [7430] = {.lex_state = 336},
  [7431] = {.lex_state = 336},
  [7432] = {.lex_state = 336},
  [7433] = {.lex_state = 0},
  [7434] = {.lex_state = 336},
  [7435] = {.lex_state = 0},
  [7436] = {.lex_state = 0},
  [7437] = {.lex_state = 193},
  [7438] = {.lex_state = 336},
  [7439] = {.lex_state = 0},
  [7440] = {.lex_state = 0},
  [7441] = {.lex_state = 0},
  [7442] = {.lex_state = 0},
  [7443] = {.lex_state = 0},
  [7444] = {.lex_state = 0},
  [7445] = {.lex_state = 0},
  [7446] = {.lex_state = 0},
  [7447] = {.lex_state = 0},
  [7448] = {.lex_state = 0},
  [7449] = {.lex_state = 336},
  [7450] = {.lex_state = 336},
  [7451] = {.lex_state = 0},
  [7452] = {.lex_state = 0},
  [7453] = {.lex_state = 0},
  [7454] = {.lex_state = 0},
  [7455] = {.lex_state = 336},
  [7456] = {.lex_state = 336},
  [7457] = {.lex_state = 0},
  [7458] = {.lex_state = 112},
  [7459] = {.lex_state = 0},
  [7460] = {.lex_state = 0},
  [7461] = {.lex_state = 0},
  [7462] = {.lex_state = 0},
  [7463] = {.lex_state = 0},
  [7464] = {.lex_state = 0},
  [7465] = {.lex_state = 0},
  [7466] = {.lex_state = 112},
  [7467] = {.lex_state = 169},
  [7468] = {.lex_state = 0},
  [7469] = {.lex_state = 336},
  [7470] = {.lex_state = 0},
  [7471] = {.lex_state = 0},
  [7472] = {.lex_state = 336},
  [7473] = {.lex_state = 112},
  [7474] = {.lex_state = 0},
  [7475] = {.lex_state = 112},
  [7476] = {.lex_state = 193},
  [7477] = {.lex_state = 0},
  [7478] = {.lex_state = 0},
  [7479] = {.lex_state = 169},
  [7480] = {.lex_state = 193},
  [7481] = {.lex_state = 0},
  [7482] = {.lex_state = 336},
  [7483] = {.lex_state = 0},
  [7484] = {.lex_state = 336},
  [7485] = {.lex_state = 0},
  [7486] = {.lex_state = 0},
  [7487] = {.lex_state = 193},
  [7488] = {.lex_state = 193},
  [7489] = {.lex_state = 336},
  [7490] = {.lex_state = 0},
  [7491] = {.lex_state = 0},
  [7492] = {.lex_state = 336},
  [7493] = {.lex_state = 0},
  [7494] = {.lex_state = 0},
  [7495] = {.lex_state = 0},
  [7496] = {.lex_state = 0},
  [7497] = {.lex_state = 0},
  [7498] = {.lex_state = 0},
  [7499] = {.lex_state = 0},
  [7500] = {.lex_state = 0},
  [7501] = {.lex_state = 112},
  [7502] = {.lex_state = 0},
  [7503] = {.lex_state = 0},
  [7504] = {.lex_state = 193},
  [7505] = {.lex_state = 0},
  [7506] = {.lex_state = 336},
  [7507] = {.lex_state = 0},
  [7508] = {.lex_state = 336},
  [7509] = {.lex_state = 0},
  [7510] = {.lex_state = 0},
  [7511] = {.lex_state = 336},
  [7512] = {.lex_state = 193},
  [7513] = {.lex_state = 0},
  [7514] = {.lex_state = 112},
  [7515] = {.lex_state = 336},
  [7516] = {.lex_state = 336},
  [7517] = {.lex_state = 0},
  [7518] = {.lex_state = 336},
  [7519] = {.lex_state = 0},
  [7520] = {.lex_state = 0},
  [7521] = {.lex_state = 0},
  [7522] = {.lex_state = 336},
  [7523] = {.lex_state = 0},
  [7524] = {.lex_state = 336},
  [7525] = {.lex_state = 0},
  [7526] = {.lex_state = 336},
  [7527] = {.lex_state = 0},
  [7528] = {.lex_state = 0},
  [7529] = {.lex_state = 0},
  [7530] = {.lex_state = 336},
  [7531] = {.lex_state = 193},
  [7532] = {.lex_state = 336},
  [7533] = {.lex_state = 0},
  [7534] = {.lex_state = 0},
  [7535] = {.lex_state = 0},
  [7536] = {.lex_state = 0},
  [7537] = {.lex_state = 336},
  [7538] = {.lex_state = 0},
  [7539] = {.lex_state = 0},
  [7540] = {.lex_state = 0},
  [7541] = {.lex_state = 193},
  [7542] = {.lex_state = 0},
  [7543] = {.lex_state = 0},
  [7544] = {.lex_state = 0},
  [7545] = {.lex_state = 193},
  [7546] = {.lex_state = 336},
  [7547] = {.lex_state = 0},
  [7548] = {.lex_state = 0},
  [7549] = {.lex_state = 193},
  [7550] = {.lex_state = 336},
  [7551] = {.lex_state = 336},
  [7552] = {.lex_state = 336},
  [7553] = {.lex_state = 0},
  [7554] = {.lex_state = 0},
  [7555] = {.lex_state = 193},
  [7556] = {.lex_state = 0},
  [7557] = {.lex_state = 0},
  [7558] = {.lex_state = 336},
  [7559] = {.lex_state = 0},
  [7560] = {.lex_state = 336},
  [7561] = {.lex_state = 0},
  [7562] = {.lex_state = 336},
  [7563] = {.lex_state = 336},
  [7564] = {.lex_state = 0},
  [7565] = {.lex_state = 0},
  [7566] = {.lex_state = 0},
  [7567] = {.lex_state = 336},
  [7568] = {.lex_state = 0},
  [7569] = {.lex_state = 336},
  [7570] = {.lex_state = 336},
  [7571] = {.lex_state = 193},
  [7572] = {.lex_state = 336},
  [7573] = {.lex_state = 112},
  [7574] = {.lex_state = 0},
  [7575] = {.lex_state = 336},
  [7576] = {.lex_state = 0},
  [7577] = {.lex_state = 193},
  [7578] = {.lex_state = 0},
  [7579] = {.lex_state = 0},
  [7580] = {.lex_state = 0},
  [7581] = {.lex_state = 336},
  [7582] = {.lex_state = 336},
  [7583] = {.lex_state = 0},
  [7584] = {.lex_state = 0},
  [7585] = {.lex_state = 0},
  [7586] = {.lex_state = 336},
  [7587] = {.lex_state = 112},
  [7588] = {.lex_state = 0},
  [7589] = {.lex_state = 193},
  [7590] = {.lex_state = 336},
  [7591] = {.lex_state = 112},
  [7592] = {.lex_state = 193},
  [7593] = {.lex_state = 0},
  [7594] = {.lex_state = 336},
  [7595] = {.lex_state = 0},
  [7596] = {.lex_state = 336},
  [7597] = {.lex_state = 0},
  [7598] = {.lex_state = 336},
  [7599] = {.lex_state = 336},
  [7600] = {.lex_state = 0},
  [7601] = {.lex_state = 193},
  [7602] = {.lex_state = 336},
  [7603] = {.lex_state = 336},
  [7604] = {.lex_state = 112},
  [7605] = {.lex_state = 193},
  [7606] = {.lex_state = 0},
  [7607] = {.lex_state = 0},
  [7608] = {.lex_state = 336},
  [7609] = {.lex_state = 0},
  [7610] = {.lex_state = 0},
  [7611] = {.lex_state = 0},
  [7612] = {.lex_state = 0},
  [7613] = {.lex_state = 336},
  [7614] = {.lex_state = 0},
  [7615] = {.lex_state = 336},
  [7616] = {.lex_state = 0},
  [7617] = {.lex_state = 193},
  [7618] = {.lex_state = 0},
  [7619] = {.lex_state = 193},
  [7620] = {.lex_state = 0},
  [7621] = {.lex_state = 0},
  [7622] = {.lex_state = 336},
  [7623] = {.lex_state = 336},
  [7624] = {.lex_state = 0},
  [7625] = {.lex_state = 0},
  [7626] = {.lex_state = 336},
  [7627] = {.lex_state = 193},
  [7628] = {.lex_state = 0},
  [7629] = {.lex_state = 336},
  [7630] = {.lex_state = 0},
  [7631] = {.lex_state = 0},
  [7632] = {.lex_state = 336},
  [7633] = {.lex_state = 0},
  [7634] = {.lex_state = 336, .external_lex_state = 2},
  [7635] = {.lex_state = 0},
  [7636] = {.lex_state = 0},
  [7637] = {.lex_state = 193},
  [7638] = {.lex_state = 112},
  [7639] = {.lex_state = 336},
  [7640] = {.lex_state = 0},
  [7641] = {.lex_state = 0},
  [7642] = {.lex_state = 0},
  [7643] = {.lex_state = 0},
  [7644] = {.lex_state = 0},
  [7645] = {.lex_state = 0},
  [7646] = {.lex_state = 336},
  [7647] = {.lex_state = 0},
  [7648] = {.lex_state = 0},
  [7649] = {.lex_state = 336},
  [7650] = {.lex_state = 0},
  [7651] = {.lex_state = 0},
  [7652] = {.lex_state = 0},
  [7653] = {.lex_state = 0},
  [7654] = {.lex_state = 0},
  [7655] = {.lex_state = 0},
  [7656] = {.lex_state = 0},
  [7657] = {.lex_state = 193},
  [7658] = {.lex_state = 0},
  [7659] = {.lex_state = 0},
  [7660] = {.lex_state = 0},
  [7661] = {.lex_state = 0},
  [7662] = {.lex_state = 169},
  [7663] = {.lex_state = 0},
  [7664] = {.lex_state = 0},
  [7665] = {.lex_state = 193},
  [7666] = {.lex_state = 193},
  [7667] = {.lex_state = 0},
  [7668] = {.lex_state = 336},
  [7669] = {.lex_state = 0},
  [7670] = {.lex_state = 0},
  [7671] = {.lex_state = 0},
  [7672] = {.lex_state = 336},
  [7673] = {.lex_state = 0},
  [7674] = {.lex_state = 336},
  [7675] = {.lex_state = 0},
  [7676] = {.lex_state = 112},
  [7677] = {.lex_state = 336},
  [7678] = {.lex_state = 0},
  [7679] = {.lex_state = 336},
  [7680] = {.lex_state = 0},
  [7681] = {.lex_state = 336},
  [7682] = {.lex_state = 0},
  [7683] = {.lex_state = 0},
  [7684] = {.lex_state = 0},
  [7685] = {.lex_state = 0},
  [7686] = {.lex_state = 0},
  [7687] = {.lex_state = 0},
  [7688] = {.lex_state = 0},
  [7689] = {.lex_state = 0},
  [7690] = {.lex_state = 0},
  [7691] = {.lex_state = 112},
  [7692] = {.lex_state = 0},
  [7693] = {.lex_state = 0},
  [7694] = {.lex_state = 0},
  [7695] = {.lex_state = 193},
  [7696] = {.lex_state = 112},
  [7697] = {.lex_state = 0},
  [7698] = {.lex_state = 193},
  [7699] = {.lex_state = 0},
  [7700] = {.lex_state = 0},
  [7701] = {.lex_state = 0},
  [7702] = {.lex_state = 193},
  [7703] = {.lex_state = 0},
  [7704] = {.lex_state = 112},
  [7705] = {.lex_state = 0},
  [7706] = {.lex_state = 0},
  [7707] = {.lex_state = 0},
  [7708] = {.lex_state = 0},
  [7709] = {.lex_state = 0},
  [7710] = {.lex_state = 0},
  [7711] = {.lex_state = 336, .external_lex_state = 2},
  [7712] = {.lex_state = 336},
  [7713] = {.lex_state = 0},
  [7714] = {.lex_state = 0},
  [7715] = {.lex_state = 0},
  [7716] = {.lex_state = 0},
  [7717] = {.lex_state = 0},
  [7718] = {.lex_state = 0},
  [7719] = {.lex_state = 0},
  [7720] = {.lex_state = 0},
  [7721] = {.lex_state = 336},
  [7722] = {.lex_state = 0},
  [7723] = {.lex_state = 0},
  [7724] = {.lex_state = 0},
  [7725] = {.lex_state = 336},
  [7726] = {.lex_state = 0},
  [7727] = {.lex_state = 0},
  [7728] = {.lex_state = 0},
  [7729] = {.lex_state = 112},
  [7730] = {.lex_state = 336},
  [7731] = {.lex_state = 193},
  [7732] = {.lex_state = 0},
  [7733] = {.lex_state = 0},
  [7734] = {.lex_state = 0},
  [7735] = {.lex_state = 0},
  [7736] = {.lex_state = 0},
  [7737] = {.lex_state = 0},
  [7738] = {.lex_state = 0},
  [7739] = {.lex_state = 336, .external_lex_state = 2},
  [7740] = {.lex_state = 0},
  [7741] = {.lex_state = 0},
  [7742] = {.lex_state = 336, .external_lex_state = 2},
  [7743] = {.lex_state = 112},
  [7744] = {.lex_state = 336, .external_lex_state = 2},
  [7745] = {.lex_state = 0},
  [7746] = {.lex_state = 336, .external_lex_state = 2},
  [7747] = {.lex_state = 0},
  [7748] = {.lex_state = 336, .external_lex_state = 2},
  [7749] = {.lex_state = 336, .external_lex_state = 2},
  [7750] = {.lex_state = 336, .external_lex_state = 2},
  [7751] = {.lex_state = 336, .external_lex_state = 2},
  [7752] = {.lex_state = 336, .external_lex_state = 2},
  [7753] = {.lex_state = 336, .external_lex_state = 2},
  [7754] = {.lex_state = 336, .external_lex_state = 2},
  [7755] = {.lex_state = 336, .external_lex_state = 2},
  [7756] = {.lex_state = 336, .external_lex_state = 2},
  [7757] = {.lex_state = 336, .external_lex_state = 2},
  [7758] = {.lex_state = 336, .external_lex_state = 2},
  [7759] = {.lex_state = 336},
  [7760] = {.lex_state = 0},
  [7761] = {.lex_state = 336},
  [7762] = {.lex_state = 0},
  [7763] = {.lex_state = 0},
  [7764] = {.lex_state = 193},
  [7765] = {.lex_state = 169},
  [7766] = {.lex_state = 0},
  [7767] = {.lex_state = 0},
  [7768] = {.lex_state = 0},
  [7769] = {.lex_state = 0},
  [7770] = {.lex_state = 0},
  [7771] = {.lex_state = 0},
  [7772] = {.lex_state = 0},
  [7773] = {.lex_state = 0, .external_lex_state = 2},
  [7774] = {.lex_state = 0},
  [7775] = {.lex_state = 0},
  [7776] = {.lex_state = 196},
  [7777] = {.lex_state = 0},
  [7778] = {.lex_state = 0},
  [7779] = {.lex_state = 0},
  [7780] = {.lex_state = 0},
  [7781] = {.lex_state = 0},
  [7782] = {.lex_state = 193},
  [7783] = {.lex_state = 193},
  [7784] = {.lex_state = 0},
  [7785] = {.lex_state = 0},
  [7786] = {.lex_state = 0},
  [7787] = {.lex_state = 0},
  [7788] = {.lex_state = 0},
  [7789] = {.lex_state = 193},
  [7790] = {.lex_state = 0},
  [7791] = {.lex_state = 196},
  [7792] = {.lex_state = 0},
  [7793] = {.lex_state = 193},
  [7794] = {.lex_state = 193},
  [7795] = {.lex_state = 171},
  [7796] = {.lex_state = 0},
  [7797] = {.lex_state = 0},
  [7798] = {.lex_state = 0},
  [7799] = {.lex_state = 0},
  [7800] = {.lex_state = 113},
  [7801] = {.lex_state = 0},
  [7802] = {.lex_state = 0},
  [7803] = {.lex_state = 171},
  [7804] = {.lex_state = 171},
  [7805] = {.lex_state = 0},
  [7806] = {.lex_state = 0},
  [7807] = {.lex_state = 0},
  [7808] = {.lex_state = 0},
  [7809] = {.lex_state = 0},
  [7810] = {.lex_state = 193},
  [7811] = {.lex_state = 193},
  [7812] = {.lex_state = 0, .external_lex_state = 2},
  [7813] = {.lex_state = 196},
  [7814] = {.lex_state = 0},
  [7815] = {.lex_state = 193},
  [7816] = {.lex_state = 171},
  [7817] = {.lex_state = 0},
  [7818] = {.lex_state = 171},
  [7819] = {.lex_state = 0},
  [7820] = {.lex_state = 193},
  [7821] = {.lex_state = 171},
  [7822] = {.lex_state = 169},
  [7823] = {.lex_state = 0},
  [7824] = {.lex_state = 0},
  [7825] = {.lex_state = 0},
  [7826] = {.lex_state = 0},
  [7827] = {.lex_state = 336},
  [7828] = {.lex_state = 171},
  [7829] = {.lex_state = 171},
  [7830] = {.lex_state = 0},
  [7831] = {.lex_state = 0},
  [7832] = {.lex_state = 0},
  [7833] = {.lex_state = 0},
  [7834] = {.lex_state = 0},
  [7835] = {.lex_state = 0},
  [7836] = {.lex_state = 171},
  [7837] = {.lex_state = 0},
  [7838] = {.lex_state = 0},
  [7839] = {.lex_state = 0},
  [7840] = {.lex_state = 0},
  [7841] = {.lex_state = 193},
  [7842] = {.lex_state = 0},
  [7843] = {.lex_state = 0},
  [7844] = {.lex_state = 0},
  [7845] = {.lex_state = 171},
  [7846] = {.lex_state = 193},
  [7847] = {.lex_state = 0},
  [7848] = {.lex_state = 0},
  [7849] = {.lex_state = 336},
  [7850] = {.lex_state = 0},
  [7851] = {.lex_state = 0},
  [7852] = {.lex_state = 196},
  [7853] = {.lex_state = 193},
  [7854] = {.lex_state = 0},
  [7855] = {.lex_state = 0},
  [7856] = {.lex_state = 193},
  [7857] = {.lex_state = 0},
  [7858] = {.lex_state = 0},
  [7859] = {.lex_state = 193},
  [7860] = {.lex_state = 0},
  [7861] = {.lex_state = 196},
  [7862] = {.lex_state = 0},
  [7863] = {.lex_state = 0},
  [7864] = {.lex_state = 0},
  [7865] = {.lex_state = 193},
  [7866] = {.lex_state = 0},
  [7867] = {.lex_state = 196},
  [7868] = {.lex_state = 171},
  [7869] = {.lex_state = 0},
  [7870] = {.lex_state = 336},
  [7871] = {.lex_state = 0},
  [7872] = {.lex_state = 193},
  [7873] = {.lex_state = 172},
  [7874] = {.lex_state = 0},
  [7875] = {.lex_state = 0},
  [7876] = {.lex_state = 0},
  [7877] = {.lex_state = 171},
  [7878] = {.lex_state = 193},
  [7879] = {.lex_state = 0},
  [7880] = {.lex_state = 0},
  [7881] = {.lex_state = 0},
  [7882] = {.lex_state = 0},
  [7883] = {.lex_state = 0},
  [7884] = {.lex_state = 169},
  [7885] = {.lex_state = 0},
  [7886] = {.lex_state = 0, .external_lex_state = 2},
  [7887] = {.lex_state = 0},
  [7888] = {.lex_state = 0},
  [7889] = {.lex_state = 196},
  [7890] = {.lex_state = 196},
  [7891] = {.lex_state = 0},
  [7892] = {.lex_state = 171},
  [7893] = {.lex_state = 171},
  [7894] = {.lex_state = 0},
  [7895] = {.lex_state = 0},
  [7896] = {.lex_state = 0},
  [7897] = {.lex_state = 336},
  [7898] = {.lex_state = 0},
  [7899] = {.lex_state = 0},
  [7900] = {.lex_state = 0},
  [7901] = {.lex_state = 0},
  [7902] = {.lex_state = 0},
  [7903] = {.lex_state = 0},
  [7904] = {.lex_state = 193},
  [7905] = {.lex_state = 336},
  [7906] = {.lex_state = 0},
  [7907] = {.lex_state = 0},
  [7908] = {.lex_state = 0},
  [7909] = {.lex_state = 193},
  [7910] = {.lex_state = 193},
  [7911] = {.lex_state = 0},
  [7912] = {.lex_state = 0},
  [7913] = {.lex_state = 193},
  [7914] = {.lex_state = 0},
  [7915] = {.lex_state = 336},
  [7916] = {.lex_state = 171},
  [7917] = {.lex_state = 0},
  [7918] = {.lex_state = 336},
  [7919] = {.lex_state = 0},
  [7920] = {.lex_state = 336},
  [7921] = {.lex_state = 0},
  [7922] = {.lex_state = 0},
  [7923] = {.lex_state = 0},
  [7924] = {.lex_state = 0},
  [7925] = {.lex_state = 0},
  [7926] = {.lex_state = 0},
  [7927] = {.lex_state = 0},
  [7928] = {.lex_state = 171},
  [7929] = {.lex_state = 171},
  [7930] = {.lex_state = 336},
  [7931] = {.lex_state = 0},
  [7932] = {.lex_state = 171},
  [7933] = {.lex_state = 171},
  [7934] = {.lex_state = 0},
  [7935] = {.lex_state = 0},
  [7936] = {.lex_state = 171},
  [7937] = {.lex_state = 193},
  [7938] = {.lex_state = 0},
  [7939] = {.lex_state = 0},
  [7940] = {.lex_state = 336},
  [7941] = {.lex_state = 171},
  [7942] = {.lex_state = 0},
  [7943] = {.lex_state = 0},
  [7944] = {.lex_state = 336},
  [7945] = {.lex_state = 0},
  [7946] = {.lex_state = 336},
  [7947] = {.lex_state = 113},
  [7948] = {.lex_state = 196},
  [7949] = {.lex_state = 0},
  [7950] = {.lex_state = 0},
  [7951] = {.lex_state = 171},
  [7952] = {.lex_state = 193},
  [7953] = {.lex_state = 0},
  [7954] = {.lex_state = 0},
  [7955] = {.lex_state = 113},
  [7956] = {.lex_state = 193},
  [7957] = {.lex_state = 0},
  [7958] = {.lex_state = 0},
  [7959] = {.lex_state = 0, .external_lex_state = 2},
  [7960] = {.lex_state = 0},
  [7961] = {.lex_state = 193},
  [7962] = {.lex_state = 0},
  [7963] = {.lex_state = 0},
  [7964] = {.lex_state = 0},
  [7965] = {.lex_state = 336},
  [7966] = {.lex_state = 0},
  [7967] = {.lex_state = 0},
  [7968] = {.lex_state = 336},
  [7969] = {.lex_state = 0},
  [7970] = {.lex_state = 171},
  [7971] = {.lex_state = 0},
  [7972] = {.lex_state = 171},
  [7973] = {.lex_state = 171},
  [7974] = {.lex_state = 0},
  [7975] = {.lex_state = 0},
  [7976] = {.lex_state = 0},
  [7977] = {.lex_state = 0},
  [7978] = {.lex_state = 0},
  [7979] = {.lex_state = 193},
  [7980] = {.lex_state = 336},
  [7981] = {.lex_state = 0},
  [7982] = {.lex_state = 336},
  [7983] = {.lex_state = 0},
  [7984] = {.lex_state = 0},
  [7985] = {.lex_state = 0},
  [7986] = {.lex_state = 0},
  [7987] = {.lex_state = 169},
  [7988] = {.lex_state = 193},
  [7989] = {.lex_state = 196},
  [7990] = {.lex_state = 171},
  [7991] = {.lex_state = 193},
  [7992] = {.lex_state = 196},
  [7993] = {.lex_state = 0},
  [7994] = {.lex_state = 0},
  [7995] = {.lex_state = 0},
  [7996] = {.lex_state = 113},
  [7997] = {.lex_state = 113},
  [7998] = {.lex_state = 0},
  [7999] = {.lex_state = 193},
  [8000] = {.lex_state = 0},
  [8001] = {.lex_state = 0},
  [8002] = {.lex_state = 0},
  [8003] = {.lex_state = 193},
  [8004] = {.lex_state = 0},
  [8005] = {.lex_state = 0},
  [8006] = {.lex_state = 0},
  [8007] = {.lex_state = 0},
  [8008] = {.lex_state = 193},
  [8009] = {.lex_state = 0},
  [8010] = {.lex_state = 0, .external_lex_state = 2},
  [8011] = {.lex_state = 0},
  [8012] = {.lex_state = 193},
  [8013] = {.lex_state = 0},
  [8014] = {.lex_state = 113},
  [8015] = {.lex_state = 0},
  [8016] = {.lex_state = 196},
  [8017] = {.lex_state = 193},
  [8018] = {.lex_state = 0},
  [8019] = {.lex_state = 336},
  [8020] = {.lex_state = 336},
  [8021] = {.lex_state = 0},
  [8022] = {.lex_state = 336},
  [8023] = {.lex_state = 171},
  [8024] = {.lex_state = 0},
  [8025] = {.lex_state = 0},
  [8026] = {.lex_state = 0},
  [8027] = {.lex_state = 113},
  [8028] = {.lex_state = 171},
  [8029] = {.lex_state = 0},
  [8030] = {.lex_state = 0},
  [8031] = {.lex_state = 0},
  [8032] = {.lex_state = 336},
  [8033] = {.lex_state = 0},
  [8034] = {.lex_state = 0},
  [8035] = {.lex_state = 113},
  [8036] = {.lex_state = 0},
  [8037] = {.lex_state = 171},
  [8038] = {.lex_state = 0},
  [8039] = {.lex_state = 0},
  [8040] = {.lex_state = 0},
  [8041] = {.lex_state = 0},
  [8042] = {.lex_state = 0},
  [8043] = {.lex_state = 0},
  [8044] = {.lex_state = 0},
  [8045] = {.lex_state = 0},
  [8046] = {.lex_state = 0},
  [8047] = {.lex_state = 0},
  [8048] = {.lex_state = 0},
  [8049] = {.lex_state = 0},
  [8050] = {.lex_state = 0},
  [8051] = {.lex_state = 193},
  [8052] = {.lex_state = 0},
  [8053] = {.lex_state = 0},
  [8054] = {.lex_state = 0, .external_lex_state = 2},
  [8055] = {.lex_state = 0},
  [8056] = {.lex_state = 0},
  [8057] = {.lex_state = 0},
  [8058] = {.lex_state = 0},
  [8059] = {.lex_state = 0},
  [8060] = {.lex_state = 0},
  [8061] = {.lex_state = 0},
  [8062] = {.lex_state = 336},
  [8063] = {.lex_state = 0},
  [8064] = {.lex_state = 193},
  [8065] = {.lex_state = 0},
  [8066] = {.lex_state = 0},
  [8067] = {.lex_state = 0},
  [8068] = {.lex_state = 0},
  [8069] = {.lex_state = 0, .external_lex_state = 2},
  [8070] = {.lex_state = 196},
  [8071] = {.lex_state = 0},
  [8072] = {.lex_state = 193},
  [8073] = {.lex_state = 0},
  [8074] = {.lex_state = 0},
  [8075] = {.lex_state = 336},
  [8076] = {.lex_state = 336},
  [8077] = {.lex_state = 336},
  [8078] = {.lex_state = 0},
  [8079] = {.lex_state = 0},
  [8080] = {.lex_state = 0, .external_lex_state = 2},
  [8081] = {.lex_state = 172},
  [8082] = {.lex_state = 0},
  [8083] = {.lex_state = 0},
  [8084] = {.lex_state = 336},
  [8085] = {.lex_state = 336},
  [8086] = {.lex_state = 0},
  [8087] = {.lex_state = 0, .external_lex_state = 2},
  [8088] = {.lex_state = 193},
  [8089] = {.lex_state = 0},
  [8090] = {.lex_state = 0},
  [8091] = {.lex_state = 0, .external_lex_state = 2},
  [8092] = {.lex_state = 193},
  [8093] = {.lex_state = 0},
  [8094] = {.lex_state = 0},
  [8095] = {.lex_state = 0, .external_lex_state = 2},
  [8096] = {.lex_state = 0},
  [8097] = {.lex_state = 0, .external_lex_state = 2},
  [8098] = {.lex_state = 0},
  [8099] = {.lex_state = 0, .external_lex_state = 2},
  [8100] = {.lex_state = 0},
  [8101] = {.lex_state = 0, .external_lex_state = 2},
  [8102] = {.lex_state = 0},
  [8103] = {.lex_state = 0, .external_lex_state = 2},
  [8104] = {.lex_state = 0},
  [8105] = {.lex_state = 0, .external_lex_state = 2},
  [8106] = {.lex_state = 196},
  [8107] = {.lex_state = 336},
  [8108] = {.lex_state = 193},
  [8109] = {.lex_state = 336},
  [8110] = {.lex_state = 0},
  [8111] = {.lex_state = 336},
  [8112] = {.lex_state = 193},
  [8113] = {.lex_state = 336},
  [8114] = {.lex_state = 171},
  [8115] = {.lex_state = 336},
  [8116] = {.lex_state = 336},
  [8117] = {.lex_state = 113},
  [8118] = {.lex_state = 336},
  [8119] = {.lex_state = 0},
  [8120] = {.lex_state = 0},
  [8121] = {.lex_state = 0},
  [8122] = {.lex_state = 0},
  [8123] = {.lex_state = 0},
  [8124] = {.lex_state = 0},
  [8125] = {.lex_state = 0},
  [8126] = {.lex_state = 0},
  [8127] = {.lex_state = 0},
  [8128] = {.lex_state = 336},
  [8129] = {.lex_state = 0},
  [8130] = {.lex_state = 171},
  [8131] = {.lex_state = 0},
  [8132] = {.lex_state = 0},
  [8133] = {.lex_state = 0},
  [8134] = {.lex_state = 193},
  [8135] = {.lex_state = 0},
  [8136] = {.lex_state = 336},
  [8137] = {.lex_state = 0},
  [8138] = {.lex_state = 0},
  [8139] = {.lex_state = 0},
  [8140] = {.lex_state = 0},
  [8141] = {.lex_state = 0},
  [8142] = {.lex_state = 336},
  [8143] = {.lex_state = 0, .external_lex_state = 3},
  [8144] = {.lex_state = 0},
  [8145] = {.lex_state = 0},
  [8146] = {.lex_state = 0},
  [8147] = {.lex_state = 336},
  [8148] = {.lex_state = 171},
  [8149] = {.lex_state = 171},
  [8150] = {.lex_state = 0},
  [8151] = {.lex_state = 0},
  [8152] = {.lex_state = 113},
  [8153] = {.lex_state = 193},
  [8154] = {.lex_state = 0},
  [8155] = {.lex_state = 0},
  [8156] = {.lex_state = 0},
  [8157] = {.lex_state = 193},
  [8158] = {.lex_state = 0},
  [8159] = {.lex_state = 0},
  [8160] = {.lex_state = 193},
  [8161] = {.lex_state = 0},
  [8162] = {.lex_state = 0},
  [8163] = {.lex_state = 336},
  [8164] = {.lex_state = 196},
  [8165] = {.lex_state = 336},
  [8166] = {.lex_state = 0},
  [8167] = {.lex_state = 0},
  [8168] = {.lex_state = 0},
  [8169] = {.lex_state = 0},
  [8170] = {.lex_state = 0},
  [8171] = {.lex_state = 0},
  [8172] = {.lex_state = 0},
  [8173] = {.lex_state = 0},
  [8174] = {.lex_state = 0},
  [8175] = {.lex_state = 0},
  [8176] = {.lex_state = 0},
  [8177] = {.lex_state = 336},
  [8178] = {.lex_state = 0},
  [8179] = {.lex_state = 336},
  [8180] = {.lex_state = 0},
  [8181] = {.lex_state = 196},
  [8182] = {.lex_state = 336},
  [8183] = {.lex_state = 0},
  [8184] = {.lex_state = 0},
  [8185] = {.lex_state = 0},
  [8186] = {.lex_state = 0},
  [8187] = {.lex_state = 0},
  [8188] = {.lex_state = 193},
  [8189] = {.lex_state = 336},
  [8190] = {.lex_state = 0},
  [8191] = {.lex_state = 171},
  [8192] = {.lex_state = 0},
  [8193] = {.lex_state = 0},
  [8194] = {.lex_state = 193},
  [8195] = {.lex_state = 0},
  [8196] = {.lex_state = 0},
  [8197] = {.lex_state = 0},
  [8198] = {.lex_state = 336},
  [8199] = {.lex_state = 193},
  [8200] = {.lex_state = 0},
  [8201] = {.lex_state = 196},
  [8202] = {.lex_state = 0},
  [8203] = {.lex_state = 0},
  [8204] = {.lex_state = 0},
  [8205] = {.lex_state = 0},
  [8206] = {.lex_state = 336},
  [8207] = {.lex_state = 0},
  [8208] = {.lex_state = 336},
  [8209] = {.lex_state = 171},
  [8210] = {.lex_state = 113},
  [8211] = {.lex_state = 113},
  [8212] = {.lex_state = 193},
  [8213] = {.lex_state = 0},
  [8214] = {.lex_state = 193},
  [8215] = {.lex_state = 0},
  [8216] = {.lex_state = 0},
  [8217] = {.lex_state = 0},
  [8218] = {.lex_state = 171},
  [8219] = {.lex_state = 193},
  [8220] = {.lex_state = 0},
  [8221] = {.lex_state = 171},
  [8222] = {.lex_state = 0},
  [8223] = {.lex_state = 0},
  [8224] = {.lex_state = 0},
  [8225] = {.lex_state = 0},
  [8226] = {.lex_state = 113},
  [8227] = {.lex_state = 0, .external_lex_state = 3},
  [8228] = {.lex_state = 192},
  [8229] = {.lex_state = 0},
  [8230] = {.lex_state = 0},
  [8231] = {.lex_state = 0},
  [8232] = {.lex_state = 0},
  [8233] = {.lex_state = 0},
  [8234] = {.lex_state = 193},
  [8235] = {.lex_state = 193},
  [8236] = {.lex_state = 193},
  [8237] = {.lex_state = 0},
  [8238] = {.lex_state = 0},
  [8239] = {.lex_state = 113},
  [8240] = {.lex_state = 193},
  [8241] = {.lex_state = 0},
  [8242] = {.lex_state = 196},
  [8243] = {.lex_state = 193},
  [8244] = {.lex_state = 336},
  [8245] = {.lex_state = 336},
  [8246] = {.lex_state = 0},
  [8247] = {.lex_state = 0},
  [8248] = {.lex_state = 0},
  [8249] = {.lex_state = 0},
  [8250] = {.lex_state = 0},
  [8251] = {.lex_state = 0},
  [8252] = {.lex_state = 171},
  [8253] = {.lex_state = 193},
  [8254] = {.lex_state = 0},
  [8255] = {.lex_state = 113},
  [8256] = {.lex_state = 0},
  [8257] = {.lex_state = 0},
  [8258] = {.lex_state = 0},
  [8259] = {.lex_state = 0},
  [8260] = {.lex_state = 236},
  [8261] = {.lex_state = 0},
  [8262] = {.lex_state = 171},
  [8263] = {.lex_state = 171},
  [8264] = {.lex_state = 193},
  [8265] = {.lex_state = 0},
  [8266] = {.lex_state = 0},
  [8267] = {.lex_state = 0},
  [8268] = {.lex_state = 0},
  [8269] = {.lex_state = 0},
  [8270] = {.lex_state = 0},
  [8271] = {.lex_state = 336},
  [8272] = {.lex_state = 0},
  [8273] = {.lex_state = 171},
  [8274] = {.lex_state = 0},
  [8275] = {.lex_state = 0},
  [8276] = {.lex_state = 193},
  [8277] = {.lex_state = 336},
  [8278] = {.lex_state = 0},
  [8279] = {.lex_state = 0},
  [8280] = {.lex_state = 171},
  [8281] = {.lex_state = 193},
  [8282] = {.lex_state = 0},
  [8283] = {.lex_state = 0},
  [8284] = {.lex_state = 0},
  [8285] = {.lex_state = 0},
  [8286] = {.lex_state = 0},
  [8287] = {.lex_state = 0},
  [8288] = {.lex_state = 0},
  [8289] = {.lex_state = 0},
  [8290] = {.lex_state = 0},
  [8291] = {.lex_state = 0},
  [8292] = {.lex_state = 193},
  [8293] = {.lex_state = 193},
  [8294] = {.lex_state = 0},
  [8295] = {.lex_state = 0},
  [8296] = {.lex_state = 0, .external_lex_state = 3},
  [8297] = {.lex_state = 336},
  [8298] = {.lex_state = 0},
  [8299] = {.lex_state = 0},
  [8300] = {.lex_state = 196},
  [8301] = {.lex_state = 0},
  [8302] = {.lex_state = 336},
  [8303] = {.lex_state = 336},
  [8304] = {.lex_state = 0},
  [8305] = {.lex_state = 196},
  [8306] = {.lex_state = 0},
  [8307] = {.lex_state = 0},
  [8308] = {.lex_state = 336},
  [8309] = {.lex_state = 336},
  [8310] = {.lex_state = 336},
  [8311] = {.lex_state = 336},
  [8312] = {.lex_state = 0},
  [8313] = {.lex_state = 336},
  [8314] = {.lex_state = 0},
  [8315] = {.lex_state = 0},
  [8316] = {.lex_state = 193},
  [8317] = {.lex_state = 0},
  [8318] = {.lex_state = 193},
  [8319] = {.lex_state = 193},
  [8320] = {.lex_state = 0},
  [8321] = {.lex_state = 336},
  [8322] = {.lex_state = 0},
  [8323] = {.lex_state = 113},
  [8324] = {.lex_state = 0},
  [8325] = {.lex_state = 336},
  [8326] = {.lex_state = 0, .external_lex_state = 3},
  [8327] = {.lex_state = 336},
  [8328] = {.lex_state = 171},
  [8329] = {.lex_state = 0},
  [8330] = {.lex_state = 0},
  [8331] = {.lex_state = 113},
  [8332] = {.lex_state = 0},
  [8333] = {.lex_state = 193},
  [8334] = {.lex_state = 0},
  [8335] = {.lex_state = 196},
  [8336] = {.lex_state = 171},
  [8337] = {.lex_state = 113},
  [8338] = {.lex_state = 336},
  [8339] = {.lex_state = 336},
  [8340] = {.lex_state = 336},
  [8341] = {.lex_state = 0},
  [8342] = {.lex_state = 336},
  [8343] = {.lex_state = 0},
  [8344] = {.lex_state = 113},
  [8345] = {.lex_state = 193},
  [8346] = {.lex_state = 0},
  [8347] = {.lex_state = 336},
  [8348] = {.lex_state = 0},
  [8349] = {.lex_state = 193},
  [8350] = {.lex_state = 336},
  [8351] = {.lex_state = 0, .external_lex_state = 3},
  [8352] = {.lex_state = 0},
  [8353] = {.lex_state = 0},
  [8354] = {.lex_state = 0},
  [8355] = {.lex_state = 336},
  [8356] = {.lex_state = 0},
  [8357] = {.lex_state = 196},
  [8358] = {.lex_state = 171},
  [8359] = {.lex_state = 336},
  [8360] = {.lex_state = 336},
  [8361] = {.lex_state = 336},
  [8362] = {.lex_state = 0},
  [8363] = {.lex_state = 336},
  [8364] = {.lex_state = 0},
  [8365] = {.lex_state = 113},
  [8366] = {.lex_state = 193},
  [8367] = {.lex_state = 336},
  [8368] = {.lex_state = 113},
  [8369] = {.lex_state = 0},
  [8370] = {.lex_state = 336},
  [8371] = {.lex_state = 0, .external_lex_state = 3},
  [8372] = {.lex_state = 0},
  [8373] = {.lex_state = 0},
  [8374] = {.lex_state = 193},
  [8375] = {.lex_state = 0},
  [8376] = {.lex_state = 0},
  [8377] = {.lex_state = 196},
  [8378] = {.lex_state = 0},
  [8379] = {.lex_state = 336},
  [8380] = {.lex_state = 336},
  [8381] = {.lex_state = 336},
  [8382] = {.lex_state = 0},
  [8383] = {.lex_state = 336},
  [8384] = {.lex_state = 0},
  [8385] = {.lex_state = 0},
  [8386] = {.lex_state = 336},
  [8387] = {.lex_state = 0},
  [8388] = {.lex_state = 171},
  [8389] = {.lex_state = 336},
  [8390] = {.lex_state = 0, .external_lex_state = 3},
  [8391] = {.lex_state = 0},
  [8392] = {.lex_state = 336},
  [8393] = {.lex_state = 113},
  [8394] = {.lex_state = 171},
  [8395] = {.lex_state = 0},
  [8396] = {.lex_state = 196},
  [8397] = {.lex_state = 113},
  [8398] = {.lex_state = 336},
  [8399] = {.lex_state = 336},
  [8400] = {.lex_state = 0},
  [8401] = {.lex_state = 336},
  [8402] = {.lex_state = 171},
  [8403] = {.lex_state = 0},
  [8404] = {.lex_state = 0},
  [8405] = {.lex_state = 0},
  [8406] = {.lex_state = 336},
  [8407] = {.lex_state = 0, .external_lex_state = 3},
  [8408] = {.lex_state = 336},
  [8409] = {.lex_state = 0},
  [8410] = {.lex_state = 193},
  [8411] = {.lex_state = 0},
  [8412] = {.lex_state = 0},
  [8413] = {.lex_state = 336},
  [8414] = {.lex_state = 336},
  [8415] = {.lex_state = 336},
  [8416] = {.lex_state = 196},
  [8417] = {.lex_state = 0, .external_lex_state = 3},
  [8418] = {.lex_state = 193},
  [8419] = {.lex_state = 0},
  [8420] = {.lex_state = 0},
  [8421] = {.lex_state = 0},
  [8422] = {.lex_state = 336},
  [8423] = {.lex_state = 336},
  [8424] = {.lex_state = 336},
  [8425] = {.lex_state = 193},
  [8426] = {.lex_state = 0, .external_lex_state = 3},
  [8427] = {.lex_state = 0},
  [8428] = {.lex_state = 0},
  [8429] = {.lex_state = 336},
  [8430] = {.lex_state = 336},
  [8431] = {.lex_state = 336},
  [8432] = {.lex_state = 0, .external_lex_state = 3},
  [8433] = {.lex_state = 0},
  [8434] = {.lex_state = 336},
  [8435] = {.lex_state = 0, .external_lex_state = 3},
  [8436] = {.lex_state = 0},
  [8437] = {.lex_state = 336},
  [8438] = {.lex_state = 0, .external_lex_state = 3},
  [8439] = {.lex_state = 0},
  [8440] = {.lex_state = 0, .external_lex_state = 3},
  [8441] = {.lex_state = 0},
  [8442] = {.lex_state = 0, .external_lex_state = 3},
  [8443] = {.lex_state = 0},
  [8444] = {.lex_state = 0, .external_lex_state = 3},
  [8445] = {.lex_state = 0},
  [8446] = {.lex_state = 0, .external_lex_state = 3},
  [8447] = {.lex_state = 0},
  [8448] = {.lex_state = 0, .external_lex_state = 3},
  [8449] = {.lex_state = 0},
  [8450] = {.lex_state = 0},
  [8451] = {.lex_state = 193},
  [8452] = {.lex_state = 336},
  [8453] = {.lex_state = 336},
  [8454] = {.lex_state = 193},
  [8455] = {.lex_state = 0},
  [8456] = {.lex_state = 193},
  [8457] = {.lex_state = 0},
  [8458] = {.lex_state = 193},
  [8459] = {.lex_state = 0},
  [8460] = {.lex_state = 0},
  [8461] = {.lex_state = 0},
  [8462] = {.lex_state = 0},
  [8463] = {.lex_state = 0},
  [8464] = {.lex_state = 0},
  [8465] = {.lex_state = 0},
  [8466] = {.lex_state = 0},
  [8467] = {.lex_state = 193},
  [8468] = {.lex_state = 0},
  [8469] = {.lex_state = 0},
  [8470] = {.lex_state = 193},
  [8471] = {.lex_state = 0, .external_lex_state = 3},
  [8472] = {.lex_state = 0},
  [8473] = {.lex_state = 0},
  [8474] = {.lex_state = 0},
  [8475] = {.lex_state = 113},
  [8476] = {.lex_state = 0, .external_lex_state = 2},
  [8477] = {.lex_state = 0},
  [8478] = {.lex_state = 193},
  [8479] = {.lex_state = 0},
  [8480] = {.lex_state = 336},
  [8481] = {.lex_state = 0},
  [8482] = {.lex_state = 0},
  [8483] = {.lex_state = 0},
  [8484] = {.lex_state = 0},
  [8485] = {.lex_state = 0},
  [8486] = {.lex_state = 0},
  [8487] = {.lex_state = 193},
  [8488] = {.lex_state = 113},
  [8489] = {.lex_state = 0},
  [8490] = {.lex_state = 0},
  [8491] = {.lex_state = 336},
  [8492] = {.lex_state = 0},
  [8493] = {.lex_state = 113},
  [8494] = {.lex_state = 0},
  [8495] = {.lex_state = 193},
  [8496] = {.lex_state = 0},
  [8497] = {.lex_state = 0},
  [8498] = {.lex_state = 193},
  [8499] = {.lex_state = 0},
  [8500] = {.lex_state = 171},
  [8501] = {.lex_state = 113},
  [8502] = {.lex_state = 171},
  [8503] = {.lex_state = 196},
  [8504] = {.lex_state = 193},
  [8505] = {.lex_state = 0},
  [8506] = {.lex_state = 0},
  [8507] = {.lex_state = 0},
  [8508] = {.lex_state = 0},
  [8509] = {.lex_state = 0},
  [8510] = {.lex_state = 0},
  [8511] = {.lex_state = 0},
  [8512] = {.lex_state = 0},
  [8513] = {.lex_state = 0},
  [8514] = {.lex_state = 0},
  [8515] = {.lex_state = 0},
  [8516] = {.lex_state = 0},
  [8517] = {.lex_state = 0},
  [8518] = {.lex_state = 0},
  [8519] = {.lex_state = 0},
  [8520] = {.lex_state = 0},
  [8521] = {.lex_state = 0},
  [8522] = {.lex_state = 0},
  [8523] = {.lex_state = 0},
  [8524] = {.lex_state = 0},
  [8525] = {.lex_state = 171},
  [8526] = {.lex_state = 0},
  [8527] = {.lex_state = 193},
  [8528] = {.lex_state = 113},
  [8529] = {.lex_state = 0},
  [8530] = {.lex_state = 0},
  [8531] = {.lex_state = 171},
  [8532] = {.lex_state = 0},
  [8533] = {.lex_state = 196},
  [8534] = {.lex_state = 0},
  [8535] = {.lex_state = 0},
  [8536] = {.lex_state = 336},
  [8537] = {.lex_state = 336},
  [8538] = {.lex_state = 193},
  [8539] = {.lex_state = 0},
  [8540] = {.lex_state = 336},
  [8541] = {.lex_state = 0},
  [8542] = {.lex_state = 0},
  [8543] = {.lex_state = 193},
  [8544] = {.lex_state = 0, .external_lex_state = 3},
  [8545] = {.lex_state = 0},
  [8546] = {.lex_state = 0},
  [8547] = {.lex_state = 113},
  [8548] = {.lex_state = 0},
  [8549] = {.lex_state = 336},
  [8550] = {.lex_state = 336},
  [8551] = {.lex_state = 193},
  [8552] = {.lex_state = 171},
  [8553] = {.lex_state = 193},
  [8554] = {.lex_state = 193},
  [8555] = {.lex_state = 0, .external_lex_state = 3},
  [8556] = {.lex_state = 0},
  [8557] = {.lex_state = 0},
  [8558] = {.lex_state = 0},
  [8559] = {.lex_state = 336},
  [8560] = {.lex_state = 193},
  [8561] = {.lex_state = 0},
  [8562] = {.lex_state = 0},
  [8563] = {.lex_state = 193},
  [8564] = {.lex_state = 0, .external_lex_state = 3},
  [8565] = {.lex_state = 0},
  [8566] = {.lex_state = 0},
  [8567] = {.lex_state = 336},
  [8568] = {.lex_state = 193},
  [8569] = {.lex_state = 193},
  [8570] = {.lex_state = 0},
  [8571] = {.lex_state = 193},
  [8572] = {.lex_state = 0, .external_lex_state = 3},
  [8573] = {.lex_state = 0},
  [8574] = {.lex_state = 336},
  [8575] = {.lex_state = 193},
  [8576] = {.lex_state = 0},
  [8577] = {.lex_state = 193},
  [8578] = {.lex_state = 0, .external_lex_state = 3},
  [8579] = {.lex_state = 196},
  [8580] = {.lex_state = 193},
  [8581] = {.lex_state = 0, .external_lex_state = 3},
  [8582] = {.lex_state = 113},
  [8583] = {.lex_state = 0, .external_lex_state = 3},
  [8584] = {.lex_state = 0},
  [8585] = {.lex_state = 0, .external_lex_state = 3},
  [8586] = {.lex_state = 0},
  [8587] = {.lex_state = 0, .external_lex_state = 3},
  [8588] = {.lex_state = 193},
  [8589] = {.lex_state = 0, .external_lex_state = 3},
  [8590] = {.lex_state = 0},
  [8591] = {.lex_state = 0, .external_lex_state = 3},
  [8592] = {.lex_state = 0},
  [8593] = {.lex_state = 0, .external_lex_state = 3},
  [8594] = {.lex_state = 0},
  [8595] = {.lex_state = 0, .external_lex_state = 3},
  [8596] = {.lex_state = 193},
  [8597] = {.lex_state = 0, .external_lex_state = 3},
  [8598] = {.lex_state = 113},
  [8599] = {.lex_state = 0, .external_lex_state = 3},
  [8600] = {.lex_state = 336},
  [8601] = {.lex_state = 336},
  [8602] = {.lex_state = 193},
  [8603] = {.lex_state = 336},
  [8604] = {.lex_state = 336},
  [8605] = {.lex_state = 171},
  [8606] = {.lex_state = 336},
  [8607] = {.lex_state = 336},
  [8608] = {.lex_state = 0},
  [8609] = {.lex_state = 336},
  [8610] = {.lex_state = 336},
  [8611] = {.lex_state = 0},
  [8612] = {.lex_state = 336},
  [8613] = {.lex_state = 336},
  [8614] = {.lex_state = 0},
  [8615] = {.lex_state = 336},
  [8616] = {.lex_state = 336},
  [8617] = {.lex_state = 336},
  [8618] = {.lex_state = 336},
  [8619] = {.lex_state = 336},
  [8620] = {.lex_state = 336},
  [8621] = {.lex_state = 336},
  [8622] = {.lex_state = 336},
  [8623] = {.lex_state = 336},
  [8624] = {.lex_state = 336},
  [8625] = {.lex_state = 336},
  [8626] = {.lex_state = 0},
  [8627] = {.lex_state = 0},
  [8628] = {.lex_state = 196},
  [8629] = {.lex_state = 193},
  [8630] = {.lex_state = 0},
  [8631] = {.lex_state = 336},
  [8632] = {.lex_state = 336},
  [8633] = {.lex_state = 336},
  [8634] = {.lex_state = 336},
  [8635] = {.lex_state = 336},
  [8636] = {.lex_state = 0},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [aux_sym_preproc_include_token1] = ACTIONS(1),
    [aux_sym_preproc_def_token1] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [aux_sym_preproc_if_token1] = ACTIONS(1),
    [aux_sym_preproc_if_token2] = ACTIONS(1),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1),
    [aux_sym_preproc_else_token1] = ACTIONS(1),
    [aux_sym_preproc_elif_token1] = ACTIONS(1),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1),
    [sym_preproc_directive] = ACTIONS(1),
    [anon_sym_LPAREN2] = ACTIONS(1),
    [anon_sym_defined] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym___extension__] = ACTIONS(1),
    [anon_sym_typedef] = ACTIONS(1),
    [anon_sym_virtual] = ACTIONS(1),
    [anon_sym_extern] = ACTIONS(1),
    [anon_sym___attribute__] = ACTIONS(1),
    [anon_sym___attribute] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1),
    [anon_sym___declspec] = ACTIONS(1),
    [anon_sym___based] = ACTIONS(1),
    [anon_sym___cdecl] = ACTIONS(1),
    [anon_sym___clrcall] = ACTIONS(1),
    [anon_sym___stdcall] = ACTIONS(1),
    [anon_sym___fastcall] = ACTIONS(1),
    [anon_sym___thiscall] = ACTIONS(1),
    [anon_sym___vectorcall] = ACTIONS(1),
    [sym_ms_restrict_modifier] = ACTIONS(1),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(1),
    [sym_ms_signed_ptr_modifier] = ACTIONS(1),
    [anon_sym__unaligned] = ACTIONS(1),
    [anon_sym___unaligned] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_signed] = ACTIONS(1),
    [anon_sym_unsigned] = ACTIONS(1),
    [anon_sym_long] = ACTIONS(1),
    [anon_sym_short] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_register] = ACTIONS(1),
    [anon_sym_inline] = ACTIONS(1),
    [anon_sym___inline] = ACTIONS(1),
    [anon_sym___inline__] = ACTIONS(1),
    [anon_sym___forceinline] = ACTIONS(1),
    [anon_sym_thread_local] = ACTIONS(1),
    [anon_sym___thread] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_constexpr] = ACTIONS(1),
    [anon_sym_volatile] = ACTIONS(1),
    [anon_sym_restrict] = ACTIONS(1),
    [anon_sym___restrict__] = ACTIONS(1),
    [anon_sym__Atomic] = ACTIONS(1),
    [anon_sym__Noreturn] = ACTIONS(1),
    [anon_sym_noreturn] = ACTIONS(1),
    [anon_sym__Nonnull] = ACTIONS(1),
    [anon_sym_mutable] = ACTIONS(1),
    [anon_sym_constinit] = ACTIONS(1),
    [anon_sym_consteval] = ACTIONS(1),
    [anon_sym_alignas] = ACTIONS(1),
    [anon_sym__Alignas] = ACTIONS(1),
    [sym_primitive_type] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_struct] = ACTIONS(1),
    [anon_sym_union] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_goto] = ACTIONS(1),
    [anon_sym___try] = ACTIONS(1),
    [anon_sym___except] = ACTIONS(1),
    [anon_sym___finally] = ACTIONS(1),
    [anon_sym___leave] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_and_eq] = ACTIONS(1),
    [anon_sym_or_eq] = ACTIONS(1),
    [anon_sym_xor_eq] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [anon_sym_compl] = ACTIONS(1),
    [anon_sym_LT_EQ_GT] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_bitor] = ACTIONS(1),
    [anon_sym_xor] = ACTIONS(1),
    [anon_sym_bitand] = ACTIONS(1),
    [anon_sym_not_eq] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_sizeof] = ACTIONS(1),
    [anon_sym___alignof__] = ACTIONS(1),
    [anon_sym___alignof] = ACTIONS(1),
    [anon_sym__alignof] = ACTIONS(1),
    [anon_sym_alignof] = ACTIONS(1),
    [anon_sym__Alignof] = ACTIONS(1),
    [anon_sym_offsetof] = ACTIONS(1),
    [anon_sym__Generic] = ACTIONS(1),
    [anon_sym_asm] = ACTIONS(1),
    [anon_sym___asm__] = ACTIONS(1),
    [anon_sym___asm] = ACTIONS(1),
    [anon_sym___volatile__] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_DOT_STAR] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [sym_number_literal] = ACTIONS(1),
    [anon_sym_L_SQUOTE] = ACTIONS(1),
    [anon_sym_u_SQUOTE] = ACTIONS(1),
    [anon_sym_U_SQUOTE] = ACTIONS(1),
    [anon_sym_u8_SQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_L_DQUOTE] = ACTIONS(1),
    [anon_sym_u_DQUOTE] = ACTIONS(1),
    [anon_sym_U_DQUOTE] = ACTIONS(1),
    [anon_sym_u8_DQUOTE] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [anon_sym_NULL] = ACTIONS(1),
    [anon_sym_nullptr] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1),
    [anon_sym_decltype] = ACTIONS(1),
    [anon_sym_final] = ACTIONS(1),
    [anon_sym_override] = ACTIONS(1),
    [anon_sym_explicit] = ACTIONS(1),
    [anon_sym_typename] = ACTIONS(1),
    [anon_sym_template] = ACTIONS(1),
    [anon_sym_GT2] = ACTIONS(1),
    [anon_sym_operator] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_delete] = ACTIONS(1),
    [aux_sym_pure_virtual_clause_token1] = ACTIONS(1),
    [anon_sym_friend] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_protected] = ACTIONS(1),
    [anon_sym_noexcept] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_namespace] = ACTIONS(1),
    [anon_sym_using] = ACTIONS(1),
    [anon_sym_static_assert] = ACTIONS(1),
    [anon_sym_concept] = ACTIONS(1),
    [anon_sym_co_return] = ACTIONS(1),
    [anon_sym_co_yield] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_R_DQUOTE] = ACTIONS(1),
    [anon_sym_LR_DQUOTE] = ACTIONS(1),
    [anon_sym_uR_DQUOTE] = ACTIONS(1),
    [anon_sym_UR_DQUOTE] = ACTIONS(1),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1),
    [anon_sym_co_await] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_requires] = ACTIONS(1),
    [anon_sym_DASH_GT_STAR] = ACTIONS(1),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(1),
    [sym_this] = ACTIONS(1),
    [sym_raw_string_delimiter] = ACTIONS(1),
    [sym_raw_string_content] = ACTIONS(1),
  },
  [1] = {
    [sym_translation_unit] = STATE(8279),
    [sym__top_level_item] = STATE(81),
    [sym_preproc_include] = STATE(81),
    [sym_preproc_def] = STATE(81),
    [sym_preproc_function_def] = STATE(81),
    [sym_preproc_call] = STATE(81),
    [sym_preproc_if] = STATE(81),
    [sym_preproc_ifdef] = STATE(81),
    [sym_function_definition] = STATE(81),
    [sym_declaration] = STATE(81),
    [sym_type_definition] = STATE(81),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4592),
    [sym_linkage_specification] = STATE(81),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1881),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6204),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(81),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2704),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(686),
    [sym__top_level_statement] = STATE(81),
    [sym_labeled_statement] = STATE(81),
    [sym__top_level_expression_statement] = STATE(81),
    [sym_if_statement] = STATE(81),
    [sym_switch_statement] = STATE(81),
    [sym_case_statement] = STATE(81),
    [sym_while_statement] = STATE(81),
    [sym_do_statement] = STATE(81),
    [sym_for_statement] = STATE(81),
    [sym_return_statement] = STATE(81),
    [sym_break_statement] = STATE(81),
    [sym_continue_statement] = STATE(81),
    [sym_goto_statement] = STATE(81),
    [sym_expression] = STATE(4776),
    [sym__string] = STATE(4761),
    [sym_conditional_expression] = STATE(4827),
    [sym_assignment_expression] = STATE(4827),
    [sym_pointer_expression] = STATE(3717),
    [sym_unary_expression] = STATE(4827),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(4827),
    [sym_cast_expression] = STATE(4827),
    [sym_sizeof_expression] = STATE(4827),
    [sym_alignof_expression] = STATE(4827),
    [sym_offsetof_expression] = STATE(4827),
    [sym_generic_expression] = STATE(4827),
    [sym_subscript_expression] = STATE(3717),
    [sym_call_expression] = STATE(3717),
    [sym_gnu_asm_expression] = STATE(4827),
    [sym_extension_expression] = STATE(4827),
    [sym_field_expression] = STATE(3717),
    [sym_compound_literal_expression] = STATE(4827),
    [sym_parenthesized_expression] = STATE(3717),
    [sym_char_literal] = STATE(4761),
    [sym_concatenated_string] = STATE(4761),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(4827),
    [sym__empty_declaration] = STATE(81),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1710),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(81),
    [sym_template_instantiation] = STATE(81),
    [sym_operator_cast] = STATE(6688),
    [sym__constructor_specifiers] = STATE(1710),
    [sym_operator_cast_definition] = STATE(81),
    [sym_operator_cast_declaration] = STATE(81),
    [sym_constructor_or_destructor_definition] = STATE(81),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4752),
    [sym_namespace_definition] = STATE(81),
    [sym_namespace_alias_definition] = STATE(81),
    [sym_using_declaration] = STATE(81),
    [sym_alias_declaration] = STATE(81),
    [sym_static_assert_declaration] = STATE(81),
    [sym_concept_definition] = STATE(81),
    [sym_for_range_loop] = STATE(81),
    [sym_co_return_statement] = STATE(81),
    [sym_co_yield_statement] = STATE(81),
    [sym_throw_statement] = STATE(81),
    [sym_try_statement] = STATE(81),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(4827),
    [sym_new_expression] = STATE(4827),
    [sym_delete_expression] = STATE(4827),
    [sym_requires_clause] = STATE(4827),
    [sym_requires_expression] = STATE(4827),
    [sym_lambda_expression] = STATE(4827),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(4827),
    [sym_parameter_pack_expansion] = STATE(4827),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3500),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6688),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3717),
    [aux_sym_translation_unit_repeat1] = STATE(81),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(174),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1710),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [aux_sym_preproc_include_token1] = ACTIONS(9),
    [aux_sym_preproc_def_token1] = ACTIONS(11),
    [aux_sym_preproc_if_token1] = ACTIONS(13),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(15),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(15),
    [sym_preproc_directive] = ACTIONS(17),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(33),
    [anon_sym___extension__] = ACTIONS(35),
    [anon_sym_typedef] = ACTIONS(37),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_default] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(93),
    [anon_sym_break] = ACTIONS(95),
    [anon_sym_continue] = ACTIONS(97),
    [anon_sym_goto] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(113),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(119),
    [sym_false] = ACTIONS(119),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(131),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(141),
    [anon_sym_using] = ACTIONS(143),
    [anon_sym_static_assert] = ACTIONS(145),
    [anon_sym_concept] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(119),
  },
  [2] = {
    [sym__block_item] = STATE(59),
    [sym_preproc_include] = STATE(59),
    [sym_preproc_def] = STATE(59),
    [sym_preproc_function_def] = STATE(59),
    [sym_preproc_call] = STATE(59),
    [sym_preproc_if] = STATE(59),
    [sym_preproc_ifdef] = STATE(59),
    [sym_function_definition] = STATE(59),
    [sym_declaration] = STATE(59),
    [sym_type_definition] = STATE(59),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(59),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(59),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4214),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(7055),
    [sym_initializer_pair] = STATE(7055),
    [sym_subscript_designator] = STATE(6635),
    [sym_subscript_range_designator] = STATE(6635),
    [sym_field_designator] = STATE(6635),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(59),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(59),
    [sym_template_instantiation] = STATE(59),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(59),
    [sym_operator_cast_declaration] = STATE(59),
    [sym_constructor_or_destructor_definition] = STATE(59),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(59),
    [sym_namespace_alias_definition] = STATE(59),
    [sym_using_declaration] = STATE(59),
    [sym_alias_declaration] = STATE(59),
    [sym_static_assert_declaration] = STATE(59),
    [sym_concept_definition] = STATE(59),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(59),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_initializer_pair_repeat1] = STATE(6635),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(161),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(167),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(185),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [3] = {
    [sym__block_item] = STATE(39),
    [sym_preproc_include] = STATE(39),
    [sym_preproc_def] = STATE(39),
    [sym_preproc_function_def] = STATE(39),
    [sym_preproc_call] = STATE(39),
    [sym_preproc_if] = STATE(39),
    [sym_preproc_ifdef] = STATE(39),
    [sym_function_definition] = STATE(39),
    [sym_declaration] = STATE(39),
    [sym_type_definition] = STATE(39),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(39),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(39),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4214),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(7055),
    [sym_initializer_pair] = STATE(7055),
    [sym_subscript_designator] = STATE(6635),
    [sym_subscript_range_designator] = STATE(6635),
    [sym_field_designator] = STATE(6635),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(39),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(39),
    [sym_template_instantiation] = STATE(39),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(39),
    [sym_operator_cast_declaration] = STATE(39),
    [sym_constructor_or_destructor_definition] = STATE(39),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(39),
    [sym_namespace_alias_definition] = STATE(39),
    [sym_using_declaration] = STATE(39),
    [sym_alias_declaration] = STATE(39),
    [sym_static_assert_declaration] = STATE(39),
    [sym_concept_definition] = STATE(39),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(39),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_initializer_pair_repeat1] = STATE(6635),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(161),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(167),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(241),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [4] = {
    [sym__block_item] = STATE(38),
    [sym_preproc_include] = STATE(38),
    [sym_preproc_def] = STATE(38),
    [sym_preproc_function_def] = STATE(38),
    [sym_preproc_call] = STATE(38),
    [sym_preproc_if] = STATE(38),
    [sym_preproc_ifdef] = STATE(38),
    [sym_function_definition] = STATE(38),
    [sym_declaration] = STATE(38),
    [sym_type_definition] = STATE(38),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(38),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(38),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4214),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(7055),
    [sym_initializer_pair] = STATE(7055),
    [sym_subscript_designator] = STATE(6635),
    [sym_subscript_range_designator] = STATE(6635),
    [sym_field_designator] = STATE(6635),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(38),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(38),
    [sym_template_instantiation] = STATE(38),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(38),
    [sym_operator_cast_declaration] = STATE(38),
    [sym_constructor_or_destructor_definition] = STATE(38),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(38),
    [sym_namespace_alias_definition] = STATE(38),
    [sym_using_declaration] = STATE(38),
    [sym_alias_declaration] = STATE(38),
    [sym_static_assert_declaration] = STATE(38),
    [sym_concept_definition] = STATE(38),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(38),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_initializer_pair_repeat1] = STATE(6635),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(161),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(167),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(243),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [5] = {
    [sym__block_item] = STATE(75),
    [sym_preproc_include] = STATE(75),
    [sym_preproc_def] = STATE(75),
    [sym_preproc_function_def] = STATE(75),
    [sym_preproc_call] = STATE(75),
    [sym_preproc_if] = STATE(75),
    [sym_preproc_ifdef] = STATE(75),
    [sym_function_definition] = STATE(75),
    [sym_declaration] = STATE(75),
    [sym_type_definition] = STATE(75),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(75),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(75),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4214),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(7055),
    [sym_initializer_pair] = STATE(7055),
    [sym_subscript_designator] = STATE(6635),
    [sym_subscript_range_designator] = STATE(6635),
    [sym_field_designator] = STATE(6635),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(75),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(75),
    [sym_template_instantiation] = STATE(75),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(75),
    [sym_operator_cast_declaration] = STATE(75),
    [sym_constructor_or_destructor_definition] = STATE(75),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(75),
    [sym_namespace_alias_definition] = STATE(75),
    [sym_using_declaration] = STATE(75),
    [sym_alias_declaration] = STATE(75),
    [sym_static_assert_declaration] = STATE(75),
    [sym_concept_definition] = STATE(75),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(75),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_initializer_pair_repeat1] = STATE(6635),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(161),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(167),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(245),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [6] = {
    [sym__block_item] = STATE(39),
    [sym_preproc_include] = STATE(39),
    [sym_preproc_def] = STATE(39),
    [sym_preproc_function_def] = STATE(39),
    [sym_preproc_call] = STATE(39),
    [sym_preproc_if] = STATE(39),
    [sym_preproc_ifdef] = STATE(39),
    [sym_function_definition] = STATE(39),
    [sym_declaration] = STATE(39),
    [sym_type_definition] = STATE(39),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(39),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(39),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4214),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(7055),
    [sym_initializer_pair] = STATE(7055),
    [sym_subscript_designator] = STATE(6635),
    [sym_subscript_range_designator] = STATE(6635),
    [sym_field_designator] = STATE(6635),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(39),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(39),
    [sym_template_instantiation] = STATE(39),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(39),
    [sym_operator_cast_declaration] = STATE(39),
    [sym_constructor_or_destructor_definition] = STATE(39),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(39),
    [sym_namespace_alias_definition] = STATE(39),
    [sym_using_declaration] = STATE(39),
    [sym_alias_declaration] = STATE(39),
    [sym_static_assert_declaration] = STATE(39),
    [sym_concept_definition] = STATE(39),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(39),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_initializer_pair_repeat1] = STATE(6635),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(161),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(167),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(247),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [7] = {
    [sym__block_item] = STATE(61),
    [sym_preproc_include] = STATE(61),
    [sym_preproc_def] = STATE(61),
    [sym_preproc_function_def] = STATE(61),
    [sym_preproc_call] = STATE(61),
    [sym_preproc_if] = STATE(61),
    [sym_preproc_ifdef] = STATE(61),
    [sym_function_definition] = STATE(61),
    [sym_declaration] = STATE(61),
    [sym_type_definition] = STATE(61),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(61),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(61),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4214),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(7055),
    [sym_initializer_pair] = STATE(7055),
    [sym_subscript_designator] = STATE(6635),
    [sym_subscript_range_designator] = STATE(6635),
    [sym_field_designator] = STATE(6635),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(61),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(61),
    [sym_template_instantiation] = STATE(61),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(61),
    [sym_operator_cast_declaration] = STATE(61),
    [sym_constructor_or_destructor_definition] = STATE(61),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(61),
    [sym_namespace_alias_definition] = STATE(61),
    [sym_using_declaration] = STATE(61),
    [sym_alias_declaration] = STATE(61),
    [sym_static_assert_declaration] = STATE(61),
    [sym_concept_definition] = STATE(61),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(61),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_initializer_pair_repeat1] = STATE(6635),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(161),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(167),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(249),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [8] = {
    [sym__block_item] = STATE(50),
    [sym_preproc_include] = STATE(50),
    [sym_preproc_def] = STATE(50),
    [sym_preproc_function_def] = STATE(50),
    [sym_preproc_call] = STATE(50),
    [sym_preproc_if] = STATE(50),
    [sym_preproc_ifdef] = STATE(50),
    [sym_function_definition] = STATE(50),
    [sym_declaration] = STATE(50),
    [sym_type_definition] = STATE(50),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(50),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(50),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4214),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(7055),
    [sym_initializer_pair] = STATE(7055),
    [sym_subscript_designator] = STATE(6635),
    [sym_subscript_range_designator] = STATE(6635),
    [sym_field_designator] = STATE(6635),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(50),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(50),
    [sym_template_instantiation] = STATE(50),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(50),
    [sym_operator_cast_declaration] = STATE(50),
    [sym_constructor_or_destructor_definition] = STATE(50),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(50),
    [sym_namespace_alias_definition] = STATE(50),
    [sym_using_declaration] = STATE(50),
    [sym_alias_declaration] = STATE(50),
    [sym_static_assert_declaration] = STATE(50),
    [sym_concept_definition] = STATE(50),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(50),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_initializer_pair_repeat1] = STATE(6635),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(161),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(167),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(251),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [9] = {
    [sym__block_item] = STATE(61),
    [sym_preproc_include] = STATE(61),
    [sym_preproc_def] = STATE(61),
    [sym_preproc_function_def] = STATE(61),
    [sym_preproc_call] = STATE(61),
    [sym_preproc_if] = STATE(61),
    [sym_preproc_ifdef] = STATE(61),
    [sym_function_definition] = STATE(61),
    [sym_declaration] = STATE(61),
    [sym_type_definition] = STATE(61),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(61),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(61),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4214),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(7055),
    [sym_initializer_pair] = STATE(7055),
    [sym_subscript_designator] = STATE(6635),
    [sym_subscript_range_designator] = STATE(6635),
    [sym_field_designator] = STATE(6635),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(61),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(61),
    [sym_template_instantiation] = STATE(61),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(61),
    [sym_operator_cast_declaration] = STATE(61),
    [sym_constructor_or_destructor_definition] = STATE(61),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(61),
    [sym_namespace_alias_definition] = STATE(61),
    [sym_using_declaration] = STATE(61),
    [sym_alias_declaration] = STATE(61),
    [sym_static_assert_declaration] = STATE(61),
    [sym_concept_definition] = STATE(61),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(61),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_initializer_pair_repeat1] = STATE(6635),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(161),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(167),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(253),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [10] = {
    [sym__block_item] = STATE(35),
    [sym_preproc_include] = STATE(35),
    [sym_preproc_def] = STATE(35),
    [sym_preproc_function_def] = STATE(35),
    [sym_preproc_call] = STATE(35),
    [sym_preproc_if] = STATE(35),
    [sym_preproc_ifdef] = STATE(35),
    [sym_function_definition] = STATE(35),
    [sym_declaration] = STATE(35),
    [sym_type_definition] = STATE(35),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(35),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(35),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4214),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(7055),
    [sym_initializer_pair] = STATE(7055),
    [sym_subscript_designator] = STATE(6635),
    [sym_subscript_range_designator] = STATE(6635),
    [sym_field_designator] = STATE(6635),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(35),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(35),
    [sym_template_instantiation] = STATE(35),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(35),
    [sym_operator_cast_declaration] = STATE(35),
    [sym_constructor_or_destructor_definition] = STATE(35),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(35),
    [sym_namespace_alias_definition] = STATE(35),
    [sym_using_declaration] = STATE(35),
    [sym_alias_declaration] = STATE(35),
    [sym_static_assert_declaration] = STATE(35),
    [sym_concept_definition] = STATE(35),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(35),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_initializer_pair_repeat1] = STATE(6635),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(161),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(167),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(255),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [11] = {
    [sym__block_item] = STATE(75),
    [sym_preproc_include] = STATE(75),
    [sym_preproc_def] = STATE(75),
    [sym_preproc_function_def] = STATE(75),
    [sym_preproc_call] = STATE(75),
    [sym_preproc_if] = STATE(75),
    [sym_preproc_ifdef] = STATE(75),
    [sym_function_definition] = STATE(75),
    [sym_declaration] = STATE(75),
    [sym_type_definition] = STATE(75),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(75),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(75),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4214),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(7055),
    [sym_initializer_pair] = STATE(7055),
    [sym_subscript_designator] = STATE(6635),
    [sym_subscript_range_designator] = STATE(6635),
    [sym_field_designator] = STATE(6635),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(75),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(75),
    [sym_template_instantiation] = STATE(75),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(75),
    [sym_operator_cast_declaration] = STATE(75),
    [sym_constructor_or_destructor_definition] = STATE(75),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(75),
    [sym_namespace_alias_definition] = STATE(75),
    [sym_using_declaration] = STATE(75),
    [sym_alias_declaration] = STATE(75),
    [sym_static_assert_declaration] = STATE(75),
    [sym_concept_definition] = STATE(75),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(75),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_initializer_pair_repeat1] = STATE(6635),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(161),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(167),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(257),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [12] = {
    [sym__block_item] = STATE(35),
    [sym_preproc_include] = STATE(35),
    [sym_preproc_def] = STATE(35),
    [sym_preproc_function_def] = STATE(35),
    [sym_preproc_call] = STATE(35),
    [sym_preproc_if] = STATE(35),
    [sym_preproc_ifdef] = STATE(35),
    [sym_function_definition] = STATE(35),
    [sym_declaration] = STATE(35),
    [sym_type_definition] = STATE(35),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(35),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(35),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4214),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(7055),
    [sym_initializer_pair] = STATE(7055),
    [sym_subscript_designator] = STATE(6635),
    [sym_subscript_range_designator] = STATE(6635),
    [sym_field_designator] = STATE(6635),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(35),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(35),
    [sym_template_instantiation] = STATE(35),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(35),
    [sym_operator_cast_declaration] = STATE(35),
    [sym_constructor_or_destructor_definition] = STATE(35),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(35),
    [sym_namespace_alias_definition] = STATE(35),
    [sym_using_declaration] = STATE(35),
    [sym_alias_declaration] = STATE(35),
    [sym_static_assert_declaration] = STATE(35),
    [sym_concept_definition] = STATE(35),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(35),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_initializer_pair_repeat1] = STATE(6635),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(161),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [anon_sym_COMMA] = ACTIONS(167),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_RBRACE] = ACTIONS(259),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [13] = {
    [sym__block_item] = STATE(33),
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_preproc_else] = STATE(8358),
    [sym_preproc_elif] = STATE(8358),
    [sym_preproc_elifdef] = STATE(8358),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4677),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1899),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6225),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(235),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2675),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(340),
    [sym_statement] = STATE(33),
    [sym_labeled_statement] = STATE(235),
    [sym_expression_statement] = STATE(235),
    [sym_if_statement] = STATE(235),
    [sym_switch_statement] = STATE(235),
    [sym_case_statement] = STATE(235),
    [sym_while_statement] = STATE(235),
    [sym_do_statement] = STATE(235),
    [sym_for_statement] = STATE(235),
    [sym_return_statement] = STATE(235),
    [sym_break_statement] = STATE(235),
    [sym_continue_statement] = STATE(235),
    [sym_goto_statement] = STATE(235),
    [sym_seh_try_statement] = STATE(235),
    [sym_seh_leave_statement] = STATE(235),
    [sym_expression] = STATE(4387),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8324),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1738),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(6707),
    [sym__constructor_specifiers] = STATE(1738),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(235),
    [sym_co_return_statement] = STATE(235),
    [sym_co_yield_statement] = STATE(235),
    [sym_throw_statement] = STATE(235),
    [sym_try_statement] = STATE(235),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6707),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(197),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1738),
    [sym_identifier] = ACTIONS(261),
    [aux_sym_preproc_include_token1] = ACTIONS(263),
    [aux_sym_preproc_def_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token1] = ACTIONS(267),
    [aux_sym_preproc_if_token2] = ACTIONS(269),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(271),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(271),
    [aux_sym_preproc_else_token1] = ACTIONS(273),
    [aux_sym_preproc_elif_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(277),
    [sym_preproc_directive] = ACTIONS(279),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(283),
    [anon_sym_typedef] = ACTIONS(285),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(287),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(291),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(319),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_namespace] = ACTIONS(325),
    [anon_sym_using] = ACTIONS(327),
    [anon_sym_static_assert] = ACTIONS(329),
    [anon_sym_concept] = ACTIONS(331),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [14] = {
    [sym__block_item] = STATE(16),
    [sym_preproc_include] = STATE(16),
    [sym_preproc_def] = STATE(16),
    [sym_preproc_function_def] = STATE(16),
    [sym_preproc_call] = STATE(16),
    [sym_preproc_if] = STATE(16),
    [sym_preproc_ifdef] = STATE(16),
    [sym_preproc_else] = STATE(8394),
    [sym_preproc_elif] = STATE(8394),
    [sym_preproc_elifdef] = STATE(8394),
    [sym_function_definition] = STATE(16),
    [sym_declaration] = STATE(16),
    [sym_type_definition] = STATE(16),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4677),
    [sym_linkage_specification] = STATE(16),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1899),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6225),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(235),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2675),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(340),
    [sym_statement] = STATE(16),
    [sym_labeled_statement] = STATE(235),
    [sym_expression_statement] = STATE(235),
    [sym_if_statement] = STATE(235),
    [sym_switch_statement] = STATE(235),
    [sym_case_statement] = STATE(235),
    [sym_while_statement] = STATE(235),
    [sym_do_statement] = STATE(235),
    [sym_for_statement] = STATE(235),
    [sym_return_statement] = STATE(235),
    [sym_break_statement] = STATE(235),
    [sym_continue_statement] = STATE(235),
    [sym_goto_statement] = STATE(235),
    [sym_seh_try_statement] = STATE(235),
    [sym_seh_leave_statement] = STATE(235),
    [sym_expression] = STATE(4387),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8324),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(16),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1738),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(16),
    [sym_template_instantiation] = STATE(16),
    [sym_operator_cast] = STATE(6707),
    [sym__constructor_specifiers] = STATE(1738),
    [sym_operator_cast_definition] = STATE(16),
    [sym_operator_cast_declaration] = STATE(16),
    [sym_constructor_or_destructor_definition] = STATE(16),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(16),
    [sym_namespace_alias_definition] = STATE(16),
    [sym_using_declaration] = STATE(16),
    [sym_alias_declaration] = STATE(16),
    [sym_static_assert_declaration] = STATE(16),
    [sym_concept_definition] = STATE(16),
    [sym_for_range_loop] = STATE(235),
    [sym_co_return_statement] = STATE(235),
    [sym_co_yield_statement] = STATE(235),
    [sym_throw_statement] = STATE(235),
    [sym_try_statement] = STATE(235),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6707),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(16),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(197),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1738),
    [sym_identifier] = ACTIONS(261),
    [aux_sym_preproc_include_token1] = ACTIONS(263),
    [aux_sym_preproc_def_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token1] = ACTIONS(267),
    [aux_sym_preproc_if_token2] = ACTIONS(337),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(271),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(271),
    [aux_sym_preproc_else_token1] = ACTIONS(273),
    [aux_sym_preproc_elif_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(277),
    [sym_preproc_directive] = ACTIONS(279),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(283),
    [anon_sym_typedef] = ACTIONS(285),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(287),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(291),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(319),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_namespace] = ACTIONS(325),
    [anon_sym_using] = ACTIONS(327),
    [anon_sym_static_assert] = ACTIONS(329),
    [anon_sym_concept] = ACTIONS(331),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [15] = {
    [sym__block_item] = STATE(17),
    [sym_preproc_include] = STATE(17),
    [sym_preproc_def] = STATE(17),
    [sym_preproc_function_def] = STATE(17),
    [sym_preproc_call] = STATE(17),
    [sym_preproc_if] = STATE(17),
    [sym_preproc_ifdef] = STATE(17),
    [sym_preproc_else] = STATE(8221),
    [sym_preproc_elif] = STATE(8221),
    [sym_preproc_elifdef] = STATE(8221),
    [sym_function_definition] = STATE(17),
    [sym_declaration] = STATE(17),
    [sym_type_definition] = STATE(17),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4677),
    [sym_linkage_specification] = STATE(17),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1899),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6225),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(235),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2675),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(340),
    [sym_statement] = STATE(17),
    [sym_labeled_statement] = STATE(235),
    [sym_expression_statement] = STATE(235),
    [sym_if_statement] = STATE(235),
    [sym_switch_statement] = STATE(235),
    [sym_case_statement] = STATE(235),
    [sym_while_statement] = STATE(235),
    [sym_do_statement] = STATE(235),
    [sym_for_statement] = STATE(235),
    [sym_return_statement] = STATE(235),
    [sym_break_statement] = STATE(235),
    [sym_continue_statement] = STATE(235),
    [sym_goto_statement] = STATE(235),
    [sym_seh_try_statement] = STATE(235),
    [sym_seh_leave_statement] = STATE(235),
    [sym_expression] = STATE(4387),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8324),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(17),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1738),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(17),
    [sym_template_instantiation] = STATE(17),
    [sym_operator_cast] = STATE(6707),
    [sym__constructor_specifiers] = STATE(1738),
    [sym_operator_cast_definition] = STATE(17),
    [sym_operator_cast_declaration] = STATE(17),
    [sym_constructor_or_destructor_definition] = STATE(17),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(17),
    [sym_namespace_alias_definition] = STATE(17),
    [sym_using_declaration] = STATE(17),
    [sym_alias_declaration] = STATE(17),
    [sym_static_assert_declaration] = STATE(17),
    [sym_concept_definition] = STATE(17),
    [sym_for_range_loop] = STATE(235),
    [sym_co_return_statement] = STATE(235),
    [sym_co_yield_statement] = STATE(235),
    [sym_throw_statement] = STATE(235),
    [sym_try_statement] = STATE(235),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6707),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(17),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(197),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1738),
    [sym_identifier] = ACTIONS(261),
    [aux_sym_preproc_include_token1] = ACTIONS(263),
    [aux_sym_preproc_def_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token1] = ACTIONS(267),
    [aux_sym_preproc_if_token2] = ACTIONS(339),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(271),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(271),
    [aux_sym_preproc_else_token1] = ACTIONS(273),
    [aux_sym_preproc_elif_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(277),
    [sym_preproc_directive] = ACTIONS(279),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(283),
    [anon_sym_typedef] = ACTIONS(285),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(287),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(291),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(319),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_namespace] = ACTIONS(325),
    [anon_sym_using] = ACTIONS(327),
    [anon_sym_static_assert] = ACTIONS(329),
    [anon_sym_concept] = ACTIONS(331),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [16] = {
    [sym__block_item] = STATE(33),
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_preproc_else] = STATE(7941),
    [sym_preproc_elif] = STATE(7941),
    [sym_preproc_elifdef] = STATE(7941),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4677),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1899),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6225),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(235),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2675),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(340),
    [sym_statement] = STATE(33),
    [sym_labeled_statement] = STATE(235),
    [sym_expression_statement] = STATE(235),
    [sym_if_statement] = STATE(235),
    [sym_switch_statement] = STATE(235),
    [sym_case_statement] = STATE(235),
    [sym_while_statement] = STATE(235),
    [sym_do_statement] = STATE(235),
    [sym_for_statement] = STATE(235),
    [sym_return_statement] = STATE(235),
    [sym_break_statement] = STATE(235),
    [sym_continue_statement] = STATE(235),
    [sym_goto_statement] = STATE(235),
    [sym_seh_try_statement] = STATE(235),
    [sym_seh_leave_statement] = STATE(235),
    [sym_expression] = STATE(4387),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8324),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1738),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(6707),
    [sym__constructor_specifiers] = STATE(1738),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(235),
    [sym_co_return_statement] = STATE(235),
    [sym_co_yield_statement] = STATE(235),
    [sym_throw_statement] = STATE(235),
    [sym_try_statement] = STATE(235),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6707),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(197),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1738),
    [sym_identifier] = ACTIONS(261),
    [aux_sym_preproc_include_token1] = ACTIONS(263),
    [aux_sym_preproc_def_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token1] = ACTIONS(267),
    [aux_sym_preproc_if_token2] = ACTIONS(341),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(271),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(271),
    [aux_sym_preproc_else_token1] = ACTIONS(273),
    [aux_sym_preproc_elif_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(277),
    [sym_preproc_directive] = ACTIONS(279),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(283),
    [anon_sym_typedef] = ACTIONS(285),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(287),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(291),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(319),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_namespace] = ACTIONS(325),
    [anon_sym_using] = ACTIONS(327),
    [anon_sym_static_assert] = ACTIONS(329),
    [anon_sym_concept] = ACTIONS(331),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [17] = {
    [sym__block_item] = STATE(33),
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_preproc_else] = STATE(8114),
    [sym_preproc_elif] = STATE(8114),
    [sym_preproc_elifdef] = STATE(8114),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4677),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1899),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6225),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(235),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2675),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(340),
    [sym_statement] = STATE(33),
    [sym_labeled_statement] = STATE(235),
    [sym_expression_statement] = STATE(235),
    [sym_if_statement] = STATE(235),
    [sym_switch_statement] = STATE(235),
    [sym_case_statement] = STATE(235),
    [sym_while_statement] = STATE(235),
    [sym_do_statement] = STATE(235),
    [sym_for_statement] = STATE(235),
    [sym_return_statement] = STATE(235),
    [sym_break_statement] = STATE(235),
    [sym_continue_statement] = STATE(235),
    [sym_goto_statement] = STATE(235),
    [sym_seh_try_statement] = STATE(235),
    [sym_seh_leave_statement] = STATE(235),
    [sym_expression] = STATE(4387),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8324),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1738),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(6707),
    [sym__constructor_specifiers] = STATE(1738),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(235),
    [sym_co_return_statement] = STATE(235),
    [sym_co_yield_statement] = STATE(235),
    [sym_throw_statement] = STATE(235),
    [sym_try_statement] = STATE(235),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6707),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(197),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1738),
    [sym_identifier] = ACTIONS(261),
    [aux_sym_preproc_include_token1] = ACTIONS(263),
    [aux_sym_preproc_def_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token1] = ACTIONS(267),
    [aux_sym_preproc_if_token2] = ACTIONS(343),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(271),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(271),
    [aux_sym_preproc_else_token1] = ACTIONS(273),
    [aux_sym_preproc_elif_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(277),
    [sym_preproc_directive] = ACTIONS(279),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(283),
    [anon_sym_typedef] = ACTIONS(285),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(287),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(291),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(319),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_namespace] = ACTIONS(325),
    [anon_sym_using] = ACTIONS(327),
    [anon_sym_static_assert] = ACTIONS(329),
    [anon_sym_concept] = ACTIONS(331),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [18] = {
    [sym__block_item] = STATE(22),
    [sym_preproc_include] = STATE(22),
    [sym_preproc_def] = STATE(22),
    [sym_preproc_function_def] = STATE(22),
    [sym_preproc_call] = STATE(22),
    [sym_preproc_if] = STATE(22),
    [sym_preproc_ifdef] = STATE(22),
    [sym_preproc_else] = STATE(8605),
    [sym_preproc_elif] = STATE(8605),
    [sym_preproc_elifdef] = STATE(8605),
    [sym_function_definition] = STATE(22),
    [sym_declaration] = STATE(22),
    [sym_type_definition] = STATE(22),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4677),
    [sym_linkage_specification] = STATE(22),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1899),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6225),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(235),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2675),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(340),
    [sym_statement] = STATE(22),
    [sym_labeled_statement] = STATE(235),
    [sym_expression_statement] = STATE(235),
    [sym_if_statement] = STATE(235),
    [sym_switch_statement] = STATE(235),
    [sym_case_statement] = STATE(235),
    [sym_while_statement] = STATE(235),
    [sym_do_statement] = STATE(235),
    [sym_for_statement] = STATE(235),
    [sym_return_statement] = STATE(235),
    [sym_break_statement] = STATE(235),
    [sym_continue_statement] = STATE(235),
    [sym_goto_statement] = STATE(235),
    [sym_seh_try_statement] = STATE(235),
    [sym_seh_leave_statement] = STATE(235),
    [sym_expression] = STATE(4387),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8324),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(22),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1738),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(22),
    [sym_template_instantiation] = STATE(22),
    [sym_operator_cast] = STATE(6707),
    [sym__constructor_specifiers] = STATE(1738),
    [sym_operator_cast_definition] = STATE(22),
    [sym_operator_cast_declaration] = STATE(22),
    [sym_constructor_or_destructor_definition] = STATE(22),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(22),
    [sym_namespace_alias_definition] = STATE(22),
    [sym_using_declaration] = STATE(22),
    [sym_alias_declaration] = STATE(22),
    [sym_static_assert_declaration] = STATE(22),
    [sym_concept_definition] = STATE(22),
    [sym_for_range_loop] = STATE(235),
    [sym_co_return_statement] = STATE(235),
    [sym_co_yield_statement] = STATE(235),
    [sym_throw_statement] = STATE(235),
    [sym_try_statement] = STATE(235),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6707),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(22),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(197),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1738),
    [sym_identifier] = ACTIONS(261),
    [aux_sym_preproc_include_token1] = ACTIONS(263),
    [aux_sym_preproc_def_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token1] = ACTIONS(267),
    [aux_sym_preproc_if_token2] = ACTIONS(345),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(271),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(271),
    [aux_sym_preproc_else_token1] = ACTIONS(273),
    [aux_sym_preproc_elif_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(277),
    [sym_preproc_directive] = ACTIONS(279),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(283),
    [anon_sym_typedef] = ACTIONS(285),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(287),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(291),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(319),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_namespace] = ACTIONS(325),
    [anon_sym_using] = ACTIONS(327),
    [anon_sym_static_assert] = ACTIONS(329),
    [anon_sym_concept] = ACTIONS(331),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [19] = {
    [sym__block_item] = STATE(13),
    [sym_preproc_include] = STATE(13),
    [sym_preproc_def] = STATE(13),
    [sym_preproc_function_def] = STATE(13),
    [sym_preproc_call] = STATE(13),
    [sym_preproc_if] = STATE(13),
    [sym_preproc_ifdef] = STATE(13),
    [sym_preproc_else] = STATE(7836),
    [sym_preproc_elif] = STATE(7836),
    [sym_preproc_elifdef] = STATE(7836),
    [sym_function_definition] = STATE(13),
    [sym_declaration] = STATE(13),
    [sym_type_definition] = STATE(13),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4677),
    [sym_linkage_specification] = STATE(13),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1899),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6225),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(235),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2675),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(340),
    [sym_statement] = STATE(13),
    [sym_labeled_statement] = STATE(235),
    [sym_expression_statement] = STATE(235),
    [sym_if_statement] = STATE(235),
    [sym_switch_statement] = STATE(235),
    [sym_case_statement] = STATE(235),
    [sym_while_statement] = STATE(235),
    [sym_do_statement] = STATE(235),
    [sym_for_statement] = STATE(235),
    [sym_return_statement] = STATE(235),
    [sym_break_statement] = STATE(235),
    [sym_continue_statement] = STATE(235),
    [sym_goto_statement] = STATE(235),
    [sym_seh_try_statement] = STATE(235),
    [sym_seh_leave_statement] = STATE(235),
    [sym_expression] = STATE(4387),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8324),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(13),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1738),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(13),
    [sym_template_instantiation] = STATE(13),
    [sym_operator_cast] = STATE(6707),
    [sym__constructor_specifiers] = STATE(1738),
    [sym_operator_cast_definition] = STATE(13),
    [sym_operator_cast_declaration] = STATE(13),
    [sym_constructor_or_destructor_definition] = STATE(13),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(13),
    [sym_namespace_alias_definition] = STATE(13),
    [sym_using_declaration] = STATE(13),
    [sym_alias_declaration] = STATE(13),
    [sym_static_assert_declaration] = STATE(13),
    [sym_concept_definition] = STATE(13),
    [sym_for_range_loop] = STATE(235),
    [sym_co_return_statement] = STATE(235),
    [sym_co_yield_statement] = STATE(235),
    [sym_throw_statement] = STATE(235),
    [sym_try_statement] = STATE(235),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6707),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(13),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(197),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1738),
    [sym_identifier] = ACTIONS(261),
    [aux_sym_preproc_include_token1] = ACTIONS(263),
    [aux_sym_preproc_def_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token1] = ACTIONS(267),
    [aux_sym_preproc_if_token2] = ACTIONS(347),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(271),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(271),
    [aux_sym_preproc_else_token1] = ACTIONS(273),
    [aux_sym_preproc_elif_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(277),
    [sym_preproc_directive] = ACTIONS(279),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(283),
    [anon_sym_typedef] = ACTIONS(285),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(287),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(291),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(319),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_namespace] = ACTIONS(325),
    [anon_sym_using] = ACTIONS(327),
    [anon_sym_static_assert] = ACTIONS(329),
    [anon_sym_concept] = ACTIONS(331),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [20] = {
    [sym__block_item] = STATE(23),
    [sym_preproc_include] = STATE(23),
    [sym_preproc_def] = STATE(23),
    [sym_preproc_function_def] = STATE(23),
    [sym_preproc_call] = STATE(23),
    [sym_preproc_if] = STATE(23),
    [sym_preproc_ifdef] = STATE(23),
    [sym_preproc_else] = STATE(7970),
    [sym_preproc_elif] = STATE(7970),
    [sym_preproc_elifdef] = STATE(7970),
    [sym_function_definition] = STATE(23),
    [sym_declaration] = STATE(23),
    [sym_type_definition] = STATE(23),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4677),
    [sym_linkage_specification] = STATE(23),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1899),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6225),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(235),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2675),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(340),
    [sym_statement] = STATE(23),
    [sym_labeled_statement] = STATE(235),
    [sym_expression_statement] = STATE(235),
    [sym_if_statement] = STATE(235),
    [sym_switch_statement] = STATE(235),
    [sym_case_statement] = STATE(235),
    [sym_while_statement] = STATE(235),
    [sym_do_statement] = STATE(235),
    [sym_for_statement] = STATE(235),
    [sym_return_statement] = STATE(235),
    [sym_break_statement] = STATE(235),
    [sym_continue_statement] = STATE(235),
    [sym_goto_statement] = STATE(235),
    [sym_seh_try_statement] = STATE(235),
    [sym_seh_leave_statement] = STATE(235),
    [sym_expression] = STATE(4387),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8324),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(23),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1738),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(23),
    [sym_template_instantiation] = STATE(23),
    [sym_operator_cast] = STATE(6707),
    [sym__constructor_specifiers] = STATE(1738),
    [sym_operator_cast_definition] = STATE(23),
    [sym_operator_cast_declaration] = STATE(23),
    [sym_constructor_or_destructor_definition] = STATE(23),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(23),
    [sym_namespace_alias_definition] = STATE(23),
    [sym_using_declaration] = STATE(23),
    [sym_alias_declaration] = STATE(23),
    [sym_static_assert_declaration] = STATE(23),
    [sym_concept_definition] = STATE(23),
    [sym_for_range_loop] = STATE(235),
    [sym_co_return_statement] = STATE(235),
    [sym_co_yield_statement] = STATE(235),
    [sym_throw_statement] = STATE(235),
    [sym_try_statement] = STATE(235),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6707),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(23),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(197),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1738),
    [sym_identifier] = ACTIONS(261),
    [aux_sym_preproc_include_token1] = ACTIONS(263),
    [aux_sym_preproc_def_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token1] = ACTIONS(267),
    [aux_sym_preproc_if_token2] = ACTIONS(349),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(271),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(271),
    [aux_sym_preproc_else_token1] = ACTIONS(273),
    [aux_sym_preproc_elif_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(277),
    [sym_preproc_directive] = ACTIONS(279),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(283),
    [anon_sym_typedef] = ACTIONS(285),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(287),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(291),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(319),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_namespace] = ACTIONS(325),
    [anon_sym_using] = ACTIONS(327),
    [anon_sym_static_assert] = ACTIONS(329),
    [anon_sym_concept] = ACTIONS(331),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [21] = {
    [sym__block_item] = STATE(30),
    [sym_preproc_include] = STATE(30),
    [sym_preproc_def] = STATE(30),
    [sym_preproc_function_def] = STATE(30),
    [sym_preproc_call] = STATE(30),
    [sym_preproc_if] = STATE(30),
    [sym_preproc_ifdef] = STATE(30),
    [sym_preproc_else] = STATE(7868),
    [sym_preproc_elif] = STATE(7868),
    [sym_preproc_elifdef] = STATE(7868),
    [sym_function_definition] = STATE(30),
    [sym_declaration] = STATE(30),
    [sym_type_definition] = STATE(30),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4677),
    [sym_linkage_specification] = STATE(30),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1899),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6225),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(235),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2675),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(340),
    [sym_statement] = STATE(30),
    [sym_labeled_statement] = STATE(235),
    [sym_expression_statement] = STATE(235),
    [sym_if_statement] = STATE(235),
    [sym_switch_statement] = STATE(235),
    [sym_case_statement] = STATE(235),
    [sym_while_statement] = STATE(235),
    [sym_do_statement] = STATE(235),
    [sym_for_statement] = STATE(235),
    [sym_return_statement] = STATE(235),
    [sym_break_statement] = STATE(235),
    [sym_continue_statement] = STATE(235),
    [sym_goto_statement] = STATE(235),
    [sym_seh_try_statement] = STATE(235),
    [sym_seh_leave_statement] = STATE(235),
    [sym_expression] = STATE(4387),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8324),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(30),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1738),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(30),
    [sym_template_instantiation] = STATE(30),
    [sym_operator_cast] = STATE(6707),
    [sym__constructor_specifiers] = STATE(1738),
    [sym_operator_cast_definition] = STATE(30),
    [sym_operator_cast_declaration] = STATE(30),
    [sym_constructor_or_destructor_definition] = STATE(30),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(30),
    [sym_namespace_alias_definition] = STATE(30),
    [sym_using_declaration] = STATE(30),
    [sym_alias_declaration] = STATE(30),
    [sym_static_assert_declaration] = STATE(30),
    [sym_concept_definition] = STATE(30),
    [sym_for_range_loop] = STATE(235),
    [sym_co_return_statement] = STATE(235),
    [sym_co_yield_statement] = STATE(235),
    [sym_throw_statement] = STATE(235),
    [sym_try_statement] = STATE(235),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6707),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(30),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(197),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1738),
    [sym_identifier] = ACTIONS(261),
    [aux_sym_preproc_include_token1] = ACTIONS(263),
    [aux_sym_preproc_def_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token1] = ACTIONS(267),
    [aux_sym_preproc_if_token2] = ACTIONS(351),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(271),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(271),
    [aux_sym_preproc_else_token1] = ACTIONS(273),
    [aux_sym_preproc_elif_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(277),
    [sym_preproc_directive] = ACTIONS(279),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(283),
    [anon_sym_typedef] = ACTIONS(285),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(287),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(291),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(319),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_namespace] = ACTIONS(325),
    [anon_sym_using] = ACTIONS(327),
    [anon_sym_static_assert] = ACTIONS(329),
    [anon_sym_concept] = ACTIONS(331),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [22] = {
    [sym__block_item] = STATE(33),
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_preproc_else] = STATE(7973),
    [sym_preproc_elif] = STATE(7973),
    [sym_preproc_elifdef] = STATE(7973),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4677),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1899),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6225),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(235),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2675),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(340),
    [sym_statement] = STATE(33),
    [sym_labeled_statement] = STATE(235),
    [sym_expression_statement] = STATE(235),
    [sym_if_statement] = STATE(235),
    [sym_switch_statement] = STATE(235),
    [sym_case_statement] = STATE(235),
    [sym_while_statement] = STATE(235),
    [sym_do_statement] = STATE(235),
    [sym_for_statement] = STATE(235),
    [sym_return_statement] = STATE(235),
    [sym_break_statement] = STATE(235),
    [sym_continue_statement] = STATE(235),
    [sym_goto_statement] = STATE(235),
    [sym_seh_try_statement] = STATE(235),
    [sym_seh_leave_statement] = STATE(235),
    [sym_expression] = STATE(4387),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8324),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1738),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(6707),
    [sym__constructor_specifiers] = STATE(1738),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(235),
    [sym_co_return_statement] = STATE(235),
    [sym_co_yield_statement] = STATE(235),
    [sym_throw_statement] = STATE(235),
    [sym_try_statement] = STATE(235),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6707),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(197),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1738),
    [sym_identifier] = ACTIONS(261),
    [aux_sym_preproc_include_token1] = ACTIONS(263),
    [aux_sym_preproc_def_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token1] = ACTIONS(267),
    [aux_sym_preproc_if_token2] = ACTIONS(353),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(271),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(271),
    [aux_sym_preproc_else_token1] = ACTIONS(273),
    [aux_sym_preproc_elif_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(277),
    [sym_preproc_directive] = ACTIONS(279),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(283),
    [anon_sym_typedef] = ACTIONS(285),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(287),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(291),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(319),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_namespace] = ACTIONS(325),
    [anon_sym_using] = ACTIONS(327),
    [anon_sym_static_assert] = ACTIONS(329),
    [anon_sym_concept] = ACTIONS(331),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [23] = {
    [sym__block_item] = STATE(33),
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_preproc_else] = STATE(7821),
    [sym_preproc_elif] = STATE(7821),
    [sym_preproc_elifdef] = STATE(7821),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4677),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1899),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6225),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(235),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2675),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(340),
    [sym_statement] = STATE(33),
    [sym_labeled_statement] = STATE(235),
    [sym_expression_statement] = STATE(235),
    [sym_if_statement] = STATE(235),
    [sym_switch_statement] = STATE(235),
    [sym_case_statement] = STATE(235),
    [sym_while_statement] = STATE(235),
    [sym_do_statement] = STATE(235),
    [sym_for_statement] = STATE(235),
    [sym_return_statement] = STATE(235),
    [sym_break_statement] = STATE(235),
    [sym_continue_statement] = STATE(235),
    [sym_goto_statement] = STATE(235),
    [sym_seh_try_statement] = STATE(235),
    [sym_seh_leave_statement] = STATE(235),
    [sym_expression] = STATE(4387),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8324),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1738),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(6707),
    [sym__constructor_specifiers] = STATE(1738),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(235),
    [sym_co_return_statement] = STATE(235),
    [sym_co_yield_statement] = STATE(235),
    [sym_throw_statement] = STATE(235),
    [sym_try_statement] = STATE(235),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6707),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(197),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1738),
    [sym_identifier] = ACTIONS(261),
    [aux_sym_preproc_include_token1] = ACTIONS(263),
    [aux_sym_preproc_def_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token1] = ACTIONS(267),
    [aux_sym_preproc_if_token2] = ACTIONS(355),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(271),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(271),
    [aux_sym_preproc_else_token1] = ACTIONS(273),
    [aux_sym_preproc_elif_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(277),
    [sym_preproc_directive] = ACTIONS(279),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(283),
    [anon_sym_typedef] = ACTIONS(285),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(287),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(291),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(319),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_namespace] = ACTIONS(325),
    [anon_sym_using] = ACTIONS(327),
    [anon_sym_static_assert] = ACTIONS(329),
    [anon_sym_concept] = ACTIONS(331),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [24] = {
    [sym__block_item] = STATE(25),
    [sym_preproc_include] = STATE(25),
    [sym_preproc_def] = STATE(25),
    [sym_preproc_function_def] = STATE(25),
    [sym_preproc_call] = STATE(25),
    [sym_preproc_if] = STATE(25),
    [sym_preproc_ifdef] = STATE(25),
    [sym_preproc_else] = STATE(7951),
    [sym_preproc_elif] = STATE(7951),
    [sym_preproc_elifdef] = STATE(7951),
    [sym_function_definition] = STATE(25),
    [sym_declaration] = STATE(25),
    [sym_type_definition] = STATE(25),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4677),
    [sym_linkage_specification] = STATE(25),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1899),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6225),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(235),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2675),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(340),
    [sym_statement] = STATE(25),
    [sym_labeled_statement] = STATE(235),
    [sym_expression_statement] = STATE(235),
    [sym_if_statement] = STATE(235),
    [sym_switch_statement] = STATE(235),
    [sym_case_statement] = STATE(235),
    [sym_while_statement] = STATE(235),
    [sym_do_statement] = STATE(235),
    [sym_for_statement] = STATE(235),
    [sym_return_statement] = STATE(235),
    [sym_break_statement] = STATE(235),
    [sym_continue_statement] = STATE(235),
    [sym_goto_statement] = STATE(235),
    [sym_seh_try_statement] = STATE(235),
    [sym_seh_leave_statement] = STATE(235),
    [sym_expression] = STATE(4387),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8324),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(25),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1738),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(25),
    [sym_template_instantiation] = STATE(25),
    [sym_operator_cast] = STATE(6707),
    [sym__constructor_specifiers] = STATE(1738),
    [sym_operator_cast_definition] = STATE(25),
    [sym_operator_cast_declaration] = STATE(25),
    [sym_constructor_or_destructor_definition] = STATE(25),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(25),
    [sym_namespace_alias_definition] = STATE(25),
    [sym_using_declaration] = STATE(25),
    [sym_alias_declaration] = STATE(25),
    [sym_static_assert_declaration] = STATE(25),
    [sym_concept_definition] = STATE(25),
    [sym_for_range_loop] = STATE(235),
    [sym_co_return_statement] = STATE(235),
    [sym_co_yield_statement] = STATE(235),
    [sym_throw_statement] = STATE(235),
    [sym_try_statement] = STATE(235),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6707),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(25),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(197),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1738),
    [sym_identifier] = ACTIONS(261),
    [aux_sym_preproc_include_token1] = ACTIONS(263),
    [aux_sym_preproc_def_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token1] = ACTIONS(267),
    [aux_sym_preproc_if_token2] = ACTIONS(357),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(271),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(271),
    [aux_sym_preproc_else_token1] = ACTIONS(273),
    [aux_sym_preproc_elif_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(277),
    [sym_preproc_directive] = ACTIONS(279),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(283),
    [anon_sym_typedef] = ACTIONS(285),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(287),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(291),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(319),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_namespace] = ACTIONS(325),
    [anon_sym_using] = ACTIONS(327),
    [anon_sym_static_assert] = ACTIONS(329),
    [anon_sym_concept] = ACTIONS(331),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [25] = {
    [sym__block_item] = STATE(33),
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_preproc_else] = STATE(8336),
    [sym_preproc_elif] = STATE(8336),
    [sym_preproc_elifdef] = STATE(8336),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4677),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1899),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6225),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(235),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2675),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(340),
    [sym_statement] = STATE(33),
    [sym_labeled_statement] = STATE(235),
    [sym_expression_statement] = STATE(235),
    [sym_if_statement] = STATE(235),
    [sym_switch_statement] = STATE(235),
    [sym_case_statement] = STATE(235),
    [sym_while_statement] = STATE(235),
    [sym_do_statement] = STATE(235),
    [sym_for_statement] = STATE(235),
    [sym_return_statement] = STATE(235),
    [sym_break_statement] = STATE(235),
    [sym_continue_statement] = STATE(235),
    [sym_goto_statement] = STATE(235),
    [sym_seh_try_statement] = STATE(235),
    [sym_seh_leave_statement] = STATE(235),
    [sym_expression] = STATE(4387),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8324),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1738),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(6707),
    [sym__constructor_specifiers] = STATE(1738),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(235),
    [sym_co_return_statement] = STATE(235),
    [sym_co_yield_statement] = STATE(235),
    [sym_throw_statement] = STATE(235),
    [sym_try_statement] = STATE(235),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6707),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(197),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1738),
    [sym_identifier] = ACTIONS(261),
    [aux_sym_preproc_include_token1] = ACTIONS(263),
    [aux_sym_preproc_def_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token1] = ACTIONS(267),
    [aux_sym_preproc_if_token2] = ACTIONS(359),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(271),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(271),
    [aux_sym_preproc_else_token1] = ACTIONS(273),
    [aux_sym_preproc_elif_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(277),
    [sym_preproc_directive] = ACTIONS(279),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(283),
    [anon_sym_typedef] = ACTIONS(285),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(287),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(291),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(319),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_namespace] = ACTIONS(325),
    [anon_sym_using] = ACTIONS(327),
    [anon_sym_static_assert] = ACTIONS(329),
    [anon_sym_concept] = ACTIONS(331),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [26] = {
    [sym__block_item] = STATE(33),
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_preproc_else] = STATE(7803),
    [sym_preproc_elif] = STATE(7803),
    [sym_preproc_elifdef] = STATE(7803),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4677),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1899),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6225),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(235),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2675),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(340),
    [sym_statement] = STATE(33),
    [sym_labeled_statement] = STATE(235),
    [sym_expression_statement] = STATE(235),
    [sym_if_statement] = STATE(235),
    [sym_switch_statement] = STATE(235),
    [sym_case_statement] = STATE(235),
    [sym_while_statement] = STATE(235),
    [sym_do_statement] = STATE(235),
    [sym_for_statement] = STATE(235),
    [sym_return_statement] = STATE(235),
    [sym_break_statement] = STATE(235),
    [sym_continue_statement] = STATE(235),
    [sym_goto_statement] = STATE(235),
    [sym_seh_try_statement] = STATE(235),
    [sym_seh_leave_statement] = STATE(235),
    [sym_expression] = STATE(4387),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8324),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1738),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(6707),
    [sym__constructor_specifiers] = STATE(1738),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(235),
    [sym_co_return_statement] = STATE(235),
    [sym_co_yield_statement] = STATE(235),
    [sym_throw_statement] = STATE(235),
    [sym_try_statement] = STATE(235),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6707),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(197),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1738),
    [sym_identifier] = ACTIONS(261),
    [aux_sym_preproc_include_token1] = ACTIONS(263),
    [aux_sym_preproc_def_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token1] = ACTIONS(267),
    [aux_sym_preproc_if_token2] = ACTIONS(361),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(271),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(271),
    [aux_sym_preproc_else_token1] = ACTIONS(273),
    [aux_sym_preproc_elif_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(277),
    [sym_preproc_directive] = ACTIONS(279),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(283),
    [anon_sym_typedef] = ACTIONS(285),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(287),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(291),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(319),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_namespace] = ACTIONS(325),
    [anon_sym_using] = ACTIONS(327),
    [anon_sym_static_assert] = ACTIONS(329),
    [anon_sym_concept] = ACTIONS(331),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [27] = {
    [sym__block_item] = STATE(26),
    [sym_preproc_include] = STATE(26),
    [sym_preproc_def] = STATE(26),
    [sym_preproc_function_def] = STATE(26),
    [sym_preproc_call] = STATE(26),
    [sym_preproc_if] = STATE(26),
    [sym_preproc_ifdef] = STATE(26),
    [sym_preproc_else] = STATE(8263),
    [sym_preproc_elif] = STATE(8263),
    [sym_preproc_elifdef] = STATE(8263),
    [sym_function_definition] = STATE(26),
    [sym_declaration] = STATE(26),
    [sym_type_definition] = STATE(26),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4677),
    [sym_linkage_specification] = STATE(26),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1899),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6225),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(235),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2675),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(340),
    [sym_statement] = STATE(26),
    [sym_labeled_statement] = STATE(235),
    [sym_expression_statement] = STATE(235),
    [sym_if_statement] = STATE(235),
    [sym_switch_statement] = STATE(235),
    [sym_case_statement] = STATE(235),
    [sym_while_statement] = STATE(235),
    [sym_do_statement] = STATE(235),
    [sym_for_statement] = STATE(235),
    [sym_return_statement] = STATE(235),
    [sym_break_statement] = STATE(235),
    [sym_continue_statement] = STATE(235),
    [sym_goto_statement] = STATE(235),
    [sym_seh_try_statement] = STATE(235),
    [sym_seh_leave_statement] = STATE(235),
    [sym_expression] = STATE(4387),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8324),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(26),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1738),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(26),
    [sym_template_instantiation] = STATE(26),
    [sym_operator_cast] = STATE(6707),
    [sym__constructor_specifiers] = STATE(1738),
    [sym_operator_cast_definition] = STATE(26),
    [sym_operator_cast_declaration] = STATE(26),
    [sym_constructor_or_destructor_definition] = STATE(26),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(26),
    [sym_namespace_alias_definition] = STATE(26),
    [sym_using_declaration] = STATE(26),
    [sym_alias_declaration] = STATE(26),
    [sym_static_assert_declaration] = STATE(26),
    [sym_concept_definition] = STATE(26),
    [sym_for_range_loop] = STATE(235),
    [sym_co_return_statement] = STATE(235),
    [sym_co_yield_statement] = STATE(235),
    [sym_throw_statement] = STATE(235),
    [sym_try_statement] = STATE(235),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6707),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(26),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(197),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1738),
    [sym_identifier] = ACTIONS(261),
    [aux_sym_preproc_include_token1] = ACTIONS(263),
    [aux_sym_preproc_def_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token1] = ACTIONS(267),
    [aux_sym_preproc_if_token2] = ACTIONS(363),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(271),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(271),
    [aux_sym_preproc_else_token1] = ACTIONS(273),
    [aux_sym_preproc_elif_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(277),
    [sym_preproc_directive] = ACTIONS(279),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(283),
    [anon_sym_typedef] = ACTIONS(285),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(287),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(291),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(319),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_namespace] = ACTIONS(325),
    [anon_sym_using] = ACTIONS(327),
    [anon_sym_static_assert] = ACTIONS(329),
    [anon_sym_concept] = ACTIONS(331),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [28] = {
    [sym__block_item] = STATE(33),
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_preproc_else] = STATE(8388),
    [sym_preproc_elif] = STATE(8388),
    [sym_preproc_elifdef] = STATE(8388),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4677),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1899),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6225),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(235),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2675),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(340),
    [sym_statement] = STATE(33),
    [sym_labeled_statement] = STATE(235),
    [sym_expression_statement] = STATE(235),
    [sym_if_statement] = STATE(235),
    [sym_switch_statement] = STATE(235),
    [sym_case_statement] = STATE(235),
    [sym_while_statement] = STATE(235),
    [sym_do_statement] = STATE(235),
    [sym_for_statement] = STATE(235),
    [sym_return_statement] = STATE(235),
    [sym_break_statement] = STATE(235),
    [sym_continue_statement] = STATE(235),
    [sym_goto_statement] = STATE(235),
    [sym_seh_try_statement] = STATE(235),
    [sym_seh_leave_statement] = STATE(235),
    [sym_expression] = STATE(4387),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8324),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1738),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(6707),
    [sym__constructor_specifiers] = STATE(1738),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(235),
    [sym_co_return_statement] = STATE(235),
    [sym_co_yield_statement] = STATE(235),
    [sym_throw_statement] = STATE(235),
    [sym_try_statement] = STATE(235),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6707),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(197),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1738),
    [sym_identifier] = ACTIONS(261),
    [aux_sym_preproc_include_token1] = ACTIONS(263),
    [aux_sym_preproc_def_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token1] = ACTIONS(267),
    [aux_sym_preproc_if_token2] = ACTIONS(365),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(271),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(271),
    [aux_sym_preproc_else_token1] = ACTIONS(273),
    [aux_sym_preproc_elif_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(277),
    [sym_preproc_directive] = ACTIONS(279),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(283),
    [anon_sym_typedef] = ACTIONS(285),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(287),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(291),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(319),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_namespace] = ACTIONS(325),
    [anon_sym_using] = ACTIONS(327),
    [anon_sym_static_assert] = ACTIONS(329),
    [anon_sym_concept] = ACTIONS(331),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [29] = {
    [sym__block_item] = STATE(33),
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_preproc_else] = STATE(8500),
    [sym_preproc_elif] = STATE(8500),
    [sym_preproc_elifdef] = STATE(8500),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4677),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1899),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6225),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(235),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2675),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(340),
    [sym_statement] = STATE(33),
    [sym_labeled_statement] = STATE(235),
    [sym_expression_statement] = STATE(235),
    [sym_if_statement] = STATE(235),
    [sym_switch_statement] = STATE(235),
    [sym_case_statement] = STATE(235),
    [sym_while_statement] = STATE(235),
    [sym_do_statement] = STATE(235),
    [sym_for_statement] = STATE(235),
    [sym_return_statement] = STATE(235),
    [sym_break_statement] = STATE(235),
    [sym_continue_statement] = STATE(235),
    [sym_goto_statement] = STATE(235),
    [sym_seh_try_statement] = STATE(235),
    [sym_seh_leave_statement] = STATE(235),
    [sym_expression] = STATE(4387),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8324),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1738),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(6707),
    [sym__constructor_specifiers] = STATE(1738),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(235),
    [sym_co_return_statement] = STATE(235),
    [sym_co_yield_statement] = STATE(235),
    [sym_throw_statement] = STATE(235),
    [sym_try_statement] = STATE(235),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6707),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(197),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1738),
    [sym_identifier] = ACTIONS(261),
    [aux_sym_preproc_include_token1] = ACTIONS(263),
    [aux_sym_preproc_def_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token1] = ACTIONS(267),
    [aux_sym_preproc_if_token2] = ACTIONS(367),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(271),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(271),
    [aux_sym_preproc_else_token1] = ACTIONS(273),
    [aux_sym_preproc_elif_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(277),
    [sym_preproc_directive] = ACTIONS(279),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(283),
    [anon_sym_typedef] = ACTIONS(285),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(287),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(291),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(319),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_namespace] = ACTIONS(325),
    [anon_sym_using] = ACTIONS(327),
    [anon_sym_static_assert] = ACTIONS(329),
    [anon_sym_concept] = ACTIONS(331),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [30] = {
    [sym__block_item] = STATE(33),
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_preproc_else] = STATE(8028),
    [sym_preproc_elif] = STATE(8028),
    [sym_preproc_elifdef] = STATE(8028),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4677),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1899),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6225),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(235),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2675),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(340),
    [sym_statement] = STATE(33),
    [sym_labeled_statement] = STATE(235),
    [sym_expression_statement] = STATE(235),
    [sym_if_statement] = STATE(235),
    [sym_switch_statement] = STATE(235),
    [sym_case_statement] = STATE(235),
    [sym_while_statement] = STATE(235),
    [sym_do_statement] = STATE(235),
    [sym_for_statement] = STATE(235),
    [sym_return_statement] = STATE(235),
    [sym_break_statement] = STATE(235),
    [sym_continue_statement] = STATE(235),
    [sym_goto_statement] = STATE(235),
    [sym_seh_try_statement] = STATE(235),
    [sym_seh_leave_statement] = STATE(235),
    [sym_expression] = STATE(4387),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8324),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1738),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(6707),
    [sym__constructor_specifiers] = STATE(1738),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(235),
    [sym_co_return_statement] = STATE(235),
    [sym_co_yield_statement] = STATE(235),
    [sym_throw_statement] = STATE(235),
    [sym_try_statement] = STATE(235),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6707),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(197),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1738),
    [sym_identifier] = ACTIONS(261),
    [aux_sym_preproc_include_token1] = ACTIONS(263),
    [aux_sym_preproc_def_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token1] = ACTIONS(267),
    [aux_sym_preproc_if_token2] = ACTIONS(369),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(271),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(271),
    [aux_sym_preproc_else_token1] = ACTIONS(273),
    [aux_sym_preproc_elif_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(277),
    [sym_preproc_directive] = ACTIONS(279),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(283),
    [anon_sym_typedef] = ACTIONS(285),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(287),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(291),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(319),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_namespace] = ACTIONS(325),
    [anon_sym_using] = ACTIONS(327),
    [anon_sym_static_assert] = ACTIONS(329),
    [anon_sym_concept] = ACTIONS(331),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [31] = {
    [sym__block_item] = STATE(28),
    [sym_preproc_include] = STATE(28),
    [sym_preproc_def] = STATE(28),
    [sym_preproc_function_def] = STATE(28),
    [sym_preproc_call] = STATE(28),
    [sym_preproc_if] = STATE(28),
    [sym_preproc_ifdef] = STATE(28),
    [sym_preproc_else] = STATE(8552),
    [sym_preproc_elif] = STATE(8552),
    [sym_preproc_elifdef] = STATE(8552),
    [sym_function_definition] = STATE(28),
    [sym_declaration] = STATE(28),
    [sym_type_definition] = STATE(28),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4677),
    [sym_linkage_specification] = STATE(28),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1899),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6225),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(235),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2675),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(340),
    [sym_statement] = STATE(28),
    [sym_labeled_statement] = STATE(235),
    [sym_expression_statement] = STATE(235),
    [sym_if_statement] = STATE(235),
    [sym_switch_statement] = STATE(235),
    [sym_case_statement] = STATE(235),
    [sym_while_statement] = STATE(235),
    [sym_do_statement] = STATE(235),
    [sym_for_statement] = STATE(235),
    [sym_return_statement] = STATE(235),
    [sym_break_statement] = STATE(235),
    [sym_continue_statement] = STATE(235),
    [sym_goto_statement] = STATE(235),
    [sym_seh_try_statement] = STATE(235),
    [sym_seh_leave_statement] = STATE(235),
    [sym_expression] = STATE(4387),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8324),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(28),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1738),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(28),
    [sym_template_instantiation] = STATE(28),
    [sym_operator_cast] = STATE(6707),
    [sym__constructor_specifiers] = STATE(1738),
    [sym_operator_cast_definition] = STATE(28),
    [sym_operator_cast_declaration] = STATE(28),
    [sym_constructor_or_destructor_definition] = STATE(28),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(28),
    [sym_namespace_alias_definition] = STATE(28),
    [sym_using_declaration] = STATE(28),
    [sym_alias_declaration] = STATE(28),
    [sym_static_assert_declaration] = STATE(28),
    [sym_concept_definition] = STATE(28),
    [sym_for_range_loop] = STATE(235),
    [sym_co_return_statement] = STATE(235),
    [sym_co_yield_statement] = STATE(235),
    [sym_throw_statement] = STATE(235),
    [sym_try_statement] = STATE(235),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6707),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(28),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(197),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1738),
    [sym_identifier] = ACTIONS(261),
    [aux_sym_preproc_include_token1] = ACTIONS(263),
    [aux_sym_preproc_def_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token1] = ACTIONS(267),
    [aux_sym_preproc_if_token2] = ACTIONS(371),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(271),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(271),
    [aux_sym_preproc_else_token1] = ACTIONS(273),
    [aux_sym_preproc_elif_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(277),
    [sym_preproc_directive] = ACTIONS(279),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(283),
    [anon_sym_typedef] = ACTIONS(285),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(287),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(291),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(319),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_namespace] = ACTIONS(325),
    [anon_sym_using] = ACTIONS(327),
    [anon_sym_static_assert] = ACTIONS(329),
    [anon_sym_concept] = ACTIONS(331),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [32] = {
    [sym__block_item] = STATE(29),
    [sym_preproc_include] = STATE(29),
    [sym_preproc_def] = STATE(29),
    [sym_preproc_function_def] = STATE(29),
    [sym_preproc_call] = STATE(29),
    [sym_preproc_if] = STATE(29),
    [sym_preproc_ifdef] = STATE(29),
    [sym_preproc_else] = STATE(8328),
    [sym_preproc_elif] = STATE(8328),
    [sym_preproc_elifdef] = STATE(8328),
    [sym_function_definition] = STATE(29),
    [sym_declaration] = STATE(29),
    [sym_type_definition] = STATE(29),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4677),
    [sym_linkage_specification] = STATE(29),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1899),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6225),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(235),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2675),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(340),
    [sym_statement] = STATE(29),
    [sym_labeled_statement] = STATE(235),
    [sym_expression_statement] = STATE(235),
    [sym_if_statement] = STATE(235),
    [sym_switch_statement] = STATE(235),
    [sym_case_statement] = STATE(235),
    [sym_while_statement] = STATE(235),
    [sym_do_statement] = STATE(235),
    [sym_for_statement] = STATE(235),
    [sym_return_statement] = STATE(235),
    [sym_break_statement] = STATE(235),
    [sym_continue_statement] = STATE(235),
    [sym_goto_statement] = STATE(235),
    [sym_seh_try_statement] = STATE(235),
    [sym_seh_leave_statement] = STATE(235),
    [sym_expression] = STATE(4387),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8324),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(29),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1738),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(29),
    [sym_template_instantiation] = STATE(29),
    [sym_operator_cast] = STATE(6707),
    [sym__constructor_specifiers] = STATE(1738),
    [sym_operator_cast_definition] = STATE(29),
    [sym_operator_cast_declaration] = STATE(29),
    [sym_constructor_or_destructor_definition] = STATE(29),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(29),
    [sym_namespace_alias_definition] = STATE(29),
    [sym_using_declaration] = STATE(29),
    [sym_alias_declaration] = STATE(29),
    [sym_static_assert_declaration] = STATE(29),
    [sym_concept_definition] = STATE(29),
    [sym_for_range_loop] = STATE(235),
    [sym_co_return_statement] = STATE(235),
    [sym_co_yield_statement] = STATE(235),
    [sym_throw_statement] = STATE(235),
    [sym_try_statement] = STATE(235),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6707),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(29),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(197),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1738),
    [sym_identifier] = ACTIONS(261),
    [aux_sym_preproc_include_token1] = ACTIONS(263),
    [aux_sym_preproc_def_token1] = ACTIONS(265),
    [aux_sym_preproc_if_token1] = ACTIONS(267),
    [aux_sym_preproc_if_token2] = ACTIONS(373),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(271),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(271),
    [aux_sym_preproc_else_token1] = ACTIONS(273),
    [aux_sym_preproc_elif_token1] = ACTIONS(275),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(277),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(277),
    [sym_preproc_directive] = ACTIONS(279),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(283),
    [anon_sym_typedef] = ACTIONS(285),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(287),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(291),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(319),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_namespace] = ACTIONS(325),
    [anon_sym_using] = ACTIONS(327),
    [anon_sym_static_assert] = ACTIONS(329),
    [anon_sym_concept] = ACTIONS(331),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [33] = {
    [sym__block_item] = STATE(33),
    [sym_preproc_include] = STATE(33),
    [sym_preproc_def] = STATE(33),
    [sym_preproc_function_def] = STATE(33),
    [sym_preproc_call] = STATE(33),
    [sym_preproc_if] = STATE(33),
    [sym_preproc_ifdef] = STATE(33),
    [sym_function_definition] = STATE(33),
    [sym_declaration] = STATE(33),
    [sym_type_definition] = STATE(33),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4677),
    [sym_linkage_specification] = STATE(33),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1899),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6225),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(235),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2675),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(340),
    [sym_statement] = STATE(33),
    [sym_labeled_statement] = STATE(235),
    [sym_expression_statement] = STATE(235),
    [sym_if_statement] = STATE(235),
    [sym_switch_statement] = STATE(235),
    [sym_case_statement] = STATE(235),
    [sym_while_statement] = STATE(235),
    [sym_do_statement] = STATE(235),
    [sym_for_statement] = STATE(235),
    [sym_return_statement] = STATE(235),
    [sym_break_statement] = STATE(235),
    [sym_continue_statement] = STATE(235),
    [sym_goto_statement] = STATE(235),
    [sym_seh_try_statement] = STATE(235),
    [sym_seh_leave_statement] = STATE(235),
    [sym_expression] = STATE(4387),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8324),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(33),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1738),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(33),
    [sym_template_instantiation] = STATE(33),
    [sym_operator_cast] = STATE(6707),
    [sym__constructor_specifiers] = STATE(1738),
    [sym_operator_cast_definition] = STATE(33),
    [sym_operator_cast_declaration] = STATE(33),
    [sym_constructor_or_destructor_definition] = STATE(33),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(33),
    [sym_namespace_alias_definition] = STATE(33),
    [sym_using_declaration] = STATE(33),
    [sym_alias_declaration] = STATE(33),
    [sym_static_assert_declaration] = STATE(33),
    [sym_concept_definition] = STATE(33),
    [sym_for_range_loop] = STATE(235),
    [sym_co_return_statement] = STATE(235),
    [sym_co_yield_statement] = STATE(235),
    [sym_throw_statement] = STATE(235),
    [sym_try_statement] = STATE(235),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6707),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(33),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(197),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1738),
    [sym_identifier] = ACTIONS(375),
    [aux_sym_preproc_include_token1] = ACTIONS(378),
    [aux_sym_preproc_def_token1] = ACTIONS(381),
    [aux_sym_preproc_if_token1] = ACTIONS(384),
    [aux_sym_preproc_if_token2] = ACTIONS(387),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(389),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(389),
    [aux_sym_preproc_else_token1] = ACTIONS(387),
    [aux_sym_preproc_elif_token1] = ACTIONS(387),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(387),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(387),
    [sym_preproc_directive] = ACTIONS(392),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(398),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_DASH] = ACTIONS(404),
    [anon_sym_PLUS] = ACTIONS(404),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_AMP_AMP] = ACTIONS(410),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(416),
    [anon_sym___extension__] = ACTIONS(419),
    [anon_sym_typedef] = ACTIONS(422),
    [anon_sym_virtual] = ACTIONS(425),
    [anon_sym_extern] = ACTIONS(428),
    [anon_sym___attribute__] = ACTIONS(431),
    [anon_sym___attribute] = ACTIONS(431),
    [anon_sym_COLON_COLON] = ACTIONS(434),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(437),
    [anon_sym___declspec] = ACTIONS(440),
    [anon_sym___based] = ACTIONS(443),
    [anon_sym___cdecl] = ACTIONS(446),
    [anon_sym___clrcall] = ACTIONS(446),
    [anon_sym___stdcall] = ACTIONS(446),
    [anon_sym___fastcall] = ACTIONS(446),
    [anon_sym___thiscall] = ACTIONS(446),
    [anon_sym___vectorcall] = ACTIONS(446),
    [anon_sym_LBRACE] = ACTIONS(449),
    [anon_sym_signed] = ACTIONS(452),
    [anon_sym_unsigned] = ACTIONS(452),
    [anon_sym_long] = ACTIONS(452),
    [anon_sym_short] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(455),
    [anon_sym_static] = ACTIONS(458),
    [anon_sym_register] = ACTIONS(458),
    [anon_sym_inline] = ACTIONS(461),
    [anon_sym___inline] = ACTIONS(458),
    [anon_sym___inline__] = ACTIONS(458),
    [anon_sym___forceinline] = ACTIONS(458),
    [anon_sym_thread_local] = ACTIONS(458),
    [anon_sym___thread] = ACTIONS(458),
    [anon_sym_const] = ACTIONS(464),
    [anon_sym_constexpr] = ACTIONS(464),
    [anon_sym_volatile] = ACTIONS(464),
    [anon_sym_restrict] = ACTIONS(464),
    [anon_sym___restrict__] = ACTIONS(464),
    [anon_sym__Atomic] = ACTIONS(464),
    [anon_sym__Noreturn] = ACTIONS(464),
    [anon_sym_noreturn] = ACTIONS(464),
    [anon_sym__Nonnull] = ACTIONS(464),
    [anon_sym_mutable] = ACTIONS(464),
    [anon_sym_constinit] = ACTIONS(464),
    [anon_sym_consteval] = ACTIONS(464),
    [anon_sym_alignas] = ACTIONS(467),
    [anon_sym__Alignas] = ACTIONS(467),
    [sym_primitive_type] = ACTIONS(470),
    [anon_sym_enum] = ACTIONS(473),
    [anon_sym_class] = ACTIONS(476),
    [anon_sym_struct] = ACTIONS(479),
    [anon_sym_union] = ACTIONS(482),
    [anon_sym_if] = ACTIONS(485),
    [anon_sym_switch] = ACTIONS(488),
    [anon_sym_case] = ACTIONS(491),
    [anon_sym_default] = ACTIONS(494),
    [anon_sym_while] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(500),
    [anon_sym_for] = ACTIONS(503),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_break] = ACTIONS(509),
    [anon_sym_continue] = ACTIONS(512),
    [anon_sym_goto] = ACTIONS(515),
    [anon_sym___try] = ACTIONS(518),
    [anon_sym___leave] = ACTIONS(521),
    [anon_sym_not] = ACTIONS(404),
    [anon_sym_compl] = ACTIONS(404),
    [anon_sym_DASH_DASH] = ACTIONS(524),
    [anon_sym_PLUS_PLUS] = ACTIONS(524),
    [anon_sym_sizeof] = ACTIONS(527),
    [anon_sym___alignof__] = ACTIONS(530),
    [anon_sym___alignof] = ACTIONS(530),
    [anon_sym__alignof] = ACTIONS(530),
    [anon_sym_alignof] = ACTIONS(530),
    [anon_sym__Alignof] = ACTIONS(530),
    [anon_sym_offsetof] = ACTIONS(533),
    [anon_sym__Generic] = ACTIONS(536),
    [anon_sym_asm] = ACTIONS(539),
    [anon_sym___asm__] = ACTIONS(539),
    [anon_sym___asm] = ACTIONS(539),
    [sym_number_literal] = ACTIONS(542),
    [anon_sym_L_SQUOTE] = ACTIONS(545),
    [anon_sym_u_SQUOTE] = ACTIONS(545),
    [anon_sym_U_SQUOTE] = ACTIONS(545),
    [anon_sym_u8_SQUOTE] = ACTIONS(545),
    [anon_sym_SQUOTE] = ACTIONS(545),
    [anon_sym_L_DQUOTE] = ACTIONS(548),
    [anon_sym_u_DQUOTE] = ACTIONS(548),
    [anon_sym_U_DQUOTE] = ACTIONS(548),
    [anon_sym_u8_DQUOTE] = ACTIONS(548),
    [anon_sym_DQUOTE] = ACTIONS(548),
    [sym_true] = ACTIONS(551),
    [sym_false] = ACTIONS(551),
    [anon_sym_NULL] = ACTIONS(554),
    [anon_sym_nullptr] = ACTIONS(554),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(557),
    [anon_sym_decltype] = ACTIONS(560),
    [anon_sym_explicit] = ACTIONS(563),
    [anon_sym_typename] = ACTIONS(566),
    [anon_sym_template] = ACTIONS(569),
    [anon_sym_operator] = ACTIONS(572),
    [anon_sym_try] = ACTIONS(575),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_throw] = ACTIONS(581),
    [anon_sym_namespace] = ACTIONS(584),
    [anon_sym_using] = ACTIONS(587),
    [anon_sym_static_assert] = ACTIONS(590),
    [anon_sym_concept] = ACTIONS(593),
    [anon_sym_co_return] = ACTIONS(596),
    [anon_sym_co_yield] = ACTIONS(599),
    [anon_sym_R_DQUOTE] = ACTIONS(602),
    [anon_sym_LR_DQUOTE] = ACTIONS(602),
    [anon_sym_uR_DQUOTE] = ACTIONS(602),
    [anon_sym_UR_DQUOTE] = ACTIONS(602),
    [anon_sym_u8R_DQUOTE] = ACTIONS(602),
    [anon_sym_co_await] = ACTIONS(605),
    [anon_sym_new] = ACTIONS(608),
    [anon_sym_requires] = ACTIONS(611),
    [sym_this] = ACTIONS(551),
  },
  [34] = {
    [sym__block_item] = STATE(48),
    [sym_preproc_include] = STATE(48),
    [sym_preproc_def] = STATE(48),
    [sym_preproc_function_def] = STATE(48),
    [sym_preproc_call] = STATE(48),
    [sym_preproc_if] = STATE(48),
    [sym_preproc_ifdef] = STATE(48),
    [sym_function_definition] = STATE(48),
    [sym_declaration] = STATE(48),
    [sym_type_definition] = STATE(48),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(48),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(48),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(48),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(48),
    [sym_template_instantiation] = STATE(48),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(48),
    [sym_operator_cast_declaration] = STATE(48),
    [sym_constructor_or_destructor_definition] = STATE(48),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(48),
    [sym_namespace_alias_definition] = STATE(48),
    [sym_using_declaration] = STATE(48),
    [sym_alias_declaration] = STATE(48),
    [sym_static_assert_declaration] = STATE(48),
    [sym_concept_definition] = STATE(48),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(48),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(614),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_RBRACE] = ACTIONS(618),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [35] = {
    [sym__block_item] = STATE(41),
    [sym_preproc_include] = STATE(41),
    [sym_preproc_def] = STATE(41),
    [sym_preproc_function_def] = STATE(41),
    [sym_preproc_call] = STATE(41),
    [sym_preproc_if] = STATE(41),
    [sym_preproc_ifdef] = STATE(41),
    [sym_function_definition] = STATE(41),
    [sym_declaration] = STATE(41),
    [sym_type_definition] = STATE(41),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(41),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(41),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(41),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(41),
    [sym_template_instantiation] = STATE(41),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(41),
    [sym_operator_cast_declaration] = STATE(41),
    [sym_constructor_or_destructor_definition] = STATE(41),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(41),
    [sym_namespace_alias_definition] = STATE(41),
    [sym_using_declaration] = STATE(41),
    [sym_alias_declaration] = STATE(41),
    [sym_static_assert_declaration] = STATE(41),
    [sym_concept_definition] = STATE(41),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(41),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(614),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_RBRACE] = ACTIONS(620),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [36] = {
    [sym__block_item] = STATE(47),
    [sym_preproc_include] = STATE(47),
    [sym_preproc_def] = STATE(47),
    [sym_preproc_function_def] = STATE(47),
    [sym_preproc_call] = STATE(47),
    [sym_preproc_if] = STATE(47),
    [sym_preproc_ifdef] = STATE(47),
    [sym_function_definition] = STATE(47),
    [sym_declaration] = STATE(47),
    [sym_type_definition] = STATE(47),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4693),
    [sym_linkage_specification] = STATE(47),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1902),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6227),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(482),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2712),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(573),
    [sym_statement] = STATE(47),
    [sym_labeled_statement] = STATE(482),
    [sym_expression_statement] = STATE(482),
    [sym_if_statement] = STATE(482),
    [sym_switch_statement] = STATE(482),
    [sym_case_statement] = STATE(482),
    [sym_while_statement] = STATE(482),
    [sym_do_statement] = STATE(482),
    [sym_for_statement] = STATE(482),
    [sym_return_statement] = STATE(482),
    [sym_break_statement] = STATE(482),
    [sym_continue_statement] = STATE(482),
    [sym_goto_statement] = STATE(482),
    [sym_seh_try_statement] = STATE(482),
    [sym_seh_leave_statement] = STATE(482),
    [sym_expression] = STATE(4411),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8119),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(47),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1741),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(47),
    [sym_template_instantiation] = STATE(47),
    [sym_operator_cast] = STATE(6672),
    [sym__constructor_specifiers] = STATE(1741),
    [sym_operator_cast_definition] = STATE(47),
    [sym_operator_cast_declaration] = STATE(47),
    [sym_constructor_or_destructor_definition] = STATE(47),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(47),
    [sym_namespace_alias_definition] = STATE(47),
    [sym_using_declaration] = STATE(47),
    [sym_alias_declaration] = STATE(47),
    [sym_static_assert_declaration] = STATE(47),
    [sym_concept_definition] = STATE(47),
    [sym_for_range_loop] = STATE(482),
    [sym_co_return_statement] = STATE(482),
    [sym_co_yield_statement] = STATE(482),
    [sym_throw_statement] = STATE(482),
    [sym_try_statement] = STATE(482),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6672),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(47),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(206),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1741),
    [sym_identifier] = ACTIONS(622),
    [aux_sym_preproc_include_token1] = ACTIONS(624),
    [aux_sym_preproc_def_token1] = ACTIONS(626),
    [aux_sym_preproc_if_token1] = ACTIONS(628),
    [aux_sym_preproc_if_token2] = ACTIONS(630),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(632),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(632),
    [sym_preproc_directive] = ACTIONS(634),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym___extension__] = ACTIONS(638),
    [anon_sym_typedef] = ACTIONS(640),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(642),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(644),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(646),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(648),
    [anon_sym_switch] = ACTIONS(650),
    [anon_sym_case] = ACTIONS(652),
    [anon_sym_default] = ACTIONS(654),
    [anon_sym_while] = ACTIONS(656),
    [anon_sym_do] = ACTIONS(658),
    [anon_sym_for] = ACTIONS(660),
    [anon_sym_return] = ACTIONS(662),
    [anon_sym_break] = ACTIONS(664),
    [anon_sym_continue] = ACTIONS(666),
    [anon_sym_goto] = ACTIONS(668),
    [anon_sym___try] = ACTIONS(670),
    [anon_sym___leave] = ACTIONS(672),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(674),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(676),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(678),
    [anon_sym_namespace] = ACTIONS(680),
    [anon_sym_using] = ACTIONS(682),
    [anon_sym_static_assert] = ACTIONS(684),
    [anon_sym_concept] = ACTIONS(686),
    [anon_sym_co_return] = ACTIONS(688),
    [anon_sym_co_yield] = ACTIONS(690),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [37] = {
    [sym__block_item] = STATE(39),
    [sym_preproc_include] = STATE(39),
    [sym_preproc_def] = STATE(39),
    [sym_preproc_function_def] = STATE(39),
    [sym_preproc_call] = STATE(39),
    [sym_preproc_if] = STATE(39),
    [sym_preproc_ifdef] = STATE(39),
    [sym_function_definition] = STATE(39),
    [sym_declaration] = STATE(39),
    [sym_type_definition] = STATE(39),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(39),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(39),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(39),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(39),
    [sym_template_instantiation] = STATE(39),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(39),
    [sym_operator_cast_declaration] = STATE(39),
    [sym_constructor_or_destructor_definition] = STATE(39),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(39),
    [sym_namespace_alias_definition] = STATE(39),
    [sym_using_declaration] = STATE(39),
    [sym_alias_declaration] = STATE(39),
    [sym_static_assert_declaration] = STATE(39),
    [sym_concept_definition] = STATE(39),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(39),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(614),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_RBRACE] = ACTIONS(692),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [38] = {
    [sym__block_item] = STATE(41),
    [sym_preproc_include] = STATE(41),
    [sym_preproc_def] = STATE(41),
    [sym_preproc_function_def] = STATE(41),
    [sym_preproc_call] = STATE(41),
    [sym_preproc_if] = STATE(41),
    [sym_preproc_ifdef] = STATE(41),
    [sym_function_definition] = STATE(41),
    [sym_declaration] = STATE(41),
    [sym_type_definition] = STATE(41),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(41),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(41),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(41),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(41),
    [sym_template_instantiation] = STATE(41),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(41),
    [sym_operator_cast_declaration] = STATE(41),
    [sym_constructor_or_destructor_definition] = STATE(41),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(41),
    [sym_namespace_alias_definition] = STATE(41),
    [sym_using_declaration] = STATE(41),
    [sym_alias_declaration] = STATE(41),
    [sym_static_assert_declaration] = STATE(41),
    [sym_concept_definition] = STATE(41),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(41),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(614),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_RBRACE] = ACTIONS(694),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [39] = {
    [sym__block_item] = STATE(41),
    [sym_preproc_include] = STATE(41),
    [sym_preproc_def] = STATE(41),
    [sym_preproc_function_def] = STATE(41),
    [sym_preproc_call] = STATE(41),
    [sym_preproc_if] = STATE(41),
    [sym_preproc_ifdef] = STATE(41),
    [sym_function_definition] = STATE(41),
    [sym_declaration] = STATE(41),
    [sym_type_definition] = STATE(41),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(41),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(41),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(41),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(41),
    [sym_template_instantiation] = STATE(41),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(41),
    [sym_operator_cast_declaration] = STATE(41),
    [sym_constructor_or_destructor_definition] = STATE(41),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(41),
    [sym_namespace_alias_definition] = STATE(41),
    [sym_using_declaration] = STATE(41),
    [sym_alias_declaration] = STATE(41),
    [sym_static_assert_declaration] = STATE(41),
    [sym_concept_definition] = STATE(41),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(41),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(614),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_RBRACE] = ACTIONS(696),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [40] = {
    [sym__block_item] = STATE(42),
    [sym_preproc_include] = STATE(42),
    [sym_preproc_def] = STATE(42),
    [sym_preproc_function_def] = STATE(42),
    [sym_preproc_call] = STATE(42),
    [sym_preproc_if] = STATE(42),
    [sym_preproc_ifdef] = STATE(42),
    [sym_function_definition] = STATE(42),
    [sym_declaration] = STATE(42),
    [sym_type_definition] = STATE(42),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(42),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(42),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(42),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(42),
    [sym_template_instantiation] = STATE(42),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(42),
    [sym_operator_cast_declaration] = STATE(42),
    [sym_constructor_or_destructor_definition] = STATE(42),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(42),
    [sym_namespace_alias_definition] = STATE(42),
    [sym_using_declaration] = STATE(42),
    [sym_alias_declaration] = STATE(42),
    [sym_static_assert_declaration] = STATE(42),
    [sym_concept_definition] = STATE(42),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(42),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(614),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_RBRACE] = ACTIONS(698),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [41] = {
    [sym__block_item] = STATE(41),
    [sym_preproc_include] = STATE(41),
    [sym_preproc_def] = STATE(41),
    [sym_preproc_function_def] = STATE(41),
    [sym_preproc_call] = STATE(41),
    [sym_preproc_if] = STATE(41),
    [sym_preproc_ifdef] = STATE(41),
    [sym_function_definition] = STATE(41),
    [sym_declaration] = STATE(41),
    [sym_type_definition] = STATE(41),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(41),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(41),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(41),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(41),
    [sym_template_instantiation] = STATE(41),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(41),
    [sym_operator_cast_declaration] = STATE(41),
    [sym_constructor_or_destructor_definition] = STATE(41),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(41),
    [sym_namespace_alias_definition] = STATE(41),
    [sym_using_declaration] = STATE(41),
    [sym_alias_declaration] = STATE(41),
    [sym_static_assert_declaration] = STATE(41),
    [sym_concept_definition] = STATE(41),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(41),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(700),
    [aux_sym_preproc_include_token1] = ACTIONS(703),
    [aux_sym_preproc_def_token1] = ACTIONS(706),
    [aux_sym_preproc_if_token1] = ACTIONS(709),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(712),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(712),
    [sym_preproc_directive] = ACTIONS(715),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(398),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_DASH] = ACTIONS(404),
    [anon_sym_PLUS] = ACTIONS(404),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_AMP_AMP] = ACTIONS(410),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(718),
    [anon_sym___extension__] = ACTIONS(721),
    [anon_sym_typedef] = ACTIONS(724),
    [anon_sym_virtual] = ACTIONS(425),
    [anon_sym_extern] = ACTIONS(727),
    [anon_sym___attribute__] = ACTIONS(431),
    [anon_sym___attribute] = ACTIONS(431),
    [anon_sym_COLON_COLON] = ACTIONS(434),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(437),
    [anon_sym___declspec] = ACTIONS(440),
    [anon_sym___based] = ACTIONS(443),
    [anon_sym___cdecl] = ACTIONS(446),
    [anon_sym___clrcall] = ACTIONS(446),
    [anon_sym___stdcall] = ACTIONS(446),
    [anon_sym___fastcall] = ACTIONS(446),
    [anon_sym___thiscall] = ACTIONS(446),
    [anon_sym___vectorcall] = ACTIONS(446),
    [anon_sym_LBRACE] = ACTIONS(730),
    [anon_sym_RBRACE] = ACTIONS(733),
    [anon_sym_signed] = ACTIONS(452),
    [anon_sym_unsigned] = ACTIONS(452),
    [anon_sym_long] = ACTIONS(452),
    [anon_sym_short] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(455),
    [anon_sym_static] = ACTIONS(458),
    [anon_sym_register] = ACTIONS(458),
    [anon_sym_inline] = ACTIONS(735),
    [anon_sym___inline] = ACTIONS(458),
    [anon_sym___inline__] = ACTIONS(458),
    [anon_sym___forceinline] = ACTIONS(458),
    [anon_sym_thread_local] = ACTIONS(458),
    [anon_sym___thread] = ACTIONS(458),
    [anon_sym_const] = ACTIONS(464),
    [anon_sym_constexpr] = ACTIONS(464),
    [anon_sym_volatile] = ACTIONS(464),
    [anon_sym_restrict] = ACTIONS(464),
    [anon_sym___restrict__] = ACTIONS(464),
    [anon_sym__Atomic] = ACTIONS(464),
    [anon_sym__Noreturn] = ACTIONS(464),
    [anon_sym_noreturn] = ACTIONS(464),
    [anon_sym__Nonnull] = ACTIONS(464),
    [anon_sym_mutable] = ACTIONS(464),
    [anon_sym_constinit] = ACTIONS(464),
    [anon_sym_consteval] = ACTIONS(464),
    [anon_sym_alignas] = ACTIONS(467),
    [anon_sym__Alignas] = ACTIONS(467),
    [sym_primitive_type] = ACTIONS(470),
    [anon_sym_enum] = ACTIONS(473),
    [anon_sym_class] = ACTIONS(476),
    [anon_sym_struct] = ACTIONS(479),
    [anon_sym_union] = ACTIONS(482),
    [anon_sym_if] = ACTIONS(738),
    [anon_sym_switch] = ACTIONS(741),
    [anon_sym_case] = ACTIONS(744),
    [anon_sym_default] = ACTIONS(747),
    [anon_sym_while] = ACTIONS(750),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_for] = ACTIONS(756),
    [anon_sym_return] = ACTIONS(759),
    [anon_sym_break] = ACTIONS(762),
    [anon_sym_continue] = ACTIONS(765),
    [anon_sym_goto] = ACTIONS(768),
    [anon_sym___try] = ACTIONS(771),
    [anon_sym___leave] = ACTIONS(774),
    [anon_sym_not] = ACTIONS(404),
    [anon_sym_compl] = ACTIONS(404),
    [anon_sym_DASH_DASH] = ACTIONS(524),
    [anon_sym_PLUS_PLUS] = ACTIONS(524),
    [anon_sym_sizeof] = ACTIONS(527),
    [anon_sym___alignof__] = ACTIONS(530),
    [anon_sym___alignof] = ACTIONS(530),
    [anon_sym__alignof] = ACTIONS(530),
    [anon_sym_alignof] = ACTIONS(530),
    [anon_sym__Alignof] = ACTIONS(530),
    [anon_sym_offsetof] = ACTIONS(533),
    [anon_sym__Generic] = ACTIONS(536),
    [anon_sym_asm] = ACTIONS(539),
    [anon_sym___asm__] = ACTIONS(539),
    [anon_sym___asm] = ACTIONS(539),
    [sym_number_literal] = ACTIONS(542),
    [anon_sym_L_SQUOTE] = ACTIONS(545),
    [anon_sym_u_SQUOTE] = ACTIONS(545),
    [anon_sym_U_SQUOTE] = ACTIONS(545),
    [anon_sym_u8_SQUOTE] = ACTIONS(545),
    [anon_sym_SQUOTE] = ACTIONS(545),
    [anon_sym_L_DQUOTE] = ACTIONS(548),
    [anon_sym_u_DQUOTE] = ACTIONS(548),
    [anon_sym_U_DQUOTE] = ACTIONS(548),
    [anon_sym_u8_DQUOTE] = ACTIONS(548),
    [anon_sym_DQUOTE] = ACTIONS(548),
    [sym_true] = ACTIONS(551),
    [sym_false] = ACTIONS(551),
    [anon_sym_NULL] = ACTIONS(554),
    [anon_sym_nullptr] = ACTIONS(554),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(557),
    [anon_sym_decltype] = ACTIONS(560),
    [anon_sym_explicit] = ACTIONS(563),
    [anon_sym_typename] = ACTIONS(566),
    [anon_sym_template] = ACTIONS(777),
    [anon_sym_operator] = ACTIONS(572),
    [anon_sym_try] = ACTIONS(780),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_throw] = ACTIONS(783),
    [anon_sym_namespace] = ACTIONS(786),
    [anon_sym_using] = ACTIONS(789),
    [anon_sym_static_assert] = ACTIONS(792),
    [anon_sym_concept] = ACTIONS(795),
    [anon_sym_co_return] = ACTIONS(798),
    [anon_sym_co_yield] = ACTIONS(801),
    [anon_sym_R_DQUOTE] = ACTIONS(602),
    [anon_sym_LR_DQUOTE] = ACTIONS(602),
    [anon_sym_uR_DQUOTE] = ACTIONS(602),
    [anon_sym_UR_DQUOTE] = ACTIONS(602),
    [anon_sym_u8R_DQUOTE] = ACTIONS(602),
    [anon_sym_co_await] = ACTIONS(605),
    [anon_sym_new] = ACTIONS(608),
    [anon_sym_requires] = ACTIONS(611),
    [sym_this] = ACTIONS(551),
  },
  [42] = {
    [sym__block_item] = STATE(41),
    [sym_preproc_include] = STATE(41),
    [sym_preproc_def] = STATE(41),
    [sym_preproc_function_def] = STATE(41),
    [sym_preproc_call] = STATE(41),
    [sym_preproc_if] = STATE(41),
    [sym_preproc_ifdef] = STATE(41),
    [sym_function_definition] = STATE(41),
    [sym_declaration] = STATE(41),
    [sym_type_definition] = STATE(41),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(41),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(41),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(41),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(41),
    [sym_template_instantiation] = STATE(41),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(41),
    [sym_operator_cast_declaration] = STATE(41),
    [sym_constructor_or_destructor_definition] = STATE(41),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(41),
    [sym_namespace_alias_definition] = STATE(41),
    [sym_using_declaration] = STATE(41),
    [sym_alias_declaration] = STATE(41),
    [sym_static_assert_declaration] = STATE(41),
    [sym_concept_definition] = STATE(41),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(41),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(614),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_RBRACE] = ACTIONS(804),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [43] = {
    [sym__block_item] = STATE(45),
    [sym_preproc_include] = STATE(45),
    [sym_preproc_def] = STATE(45),
    [sym_preproc_function_def] = STATE(45),
    [sym_preproc_call] = STATE(45),
    [sym_preproc_if] = STATE(45),
    [sym_preproc_ifdef] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_declaration] = STATE(45),
    [sym_type_definition] = STATE(45),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(45),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(45),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(45),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(45),
    [sym_template_instantiation] = STATE(45),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(45),
    [sym_operator_cast_declaration] = STATE(45),
    [sym_constructor_or_destructor_definition] = STATE(45),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(45),
    [sym_namespace_alias_definition] = STATE(45),
    [sym_using_declaration] = STATE(45),
    [sym_alias_declaration] = STATE(45),
    [sym_static_assert_declaration] = STATE(45),
    [sym_concept_definition] = STATE(45),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(45),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(614),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_RBRACE] = ACTIONS(806),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [44] = {
    [sym__block_item] = STATE(41),
    [sym_preproc_include] = STATE(41),
    [sym_preproc_def] = STATE(41),
    [sym_preproc_function_def] = STATE(41),
    [sym_preproc_call] = STATE(41),
    [sym_preproc_if] = STATE(41),
    [sym_preproc_ifdef] = STATE(41),
    [sym_function_definition] = STATE(41),
    [sym_declaration] = STATE(41),
    [sym_type_definition] = STATE(41),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(41),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(41),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(41),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(41),
    [sym_template_instantiation] = STATE(41),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(41),
    [sym_operator_cast_declaration] = STATE(41),
    [sym_constructor_or_destructor_definition] = STATE(41),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(41),
    [sym_namespace_alias_definition] = STATE(41),
    [sym_using_declaration] = STATE(41),
    [sym_alias_declaration] = STATE(41),
    [sym_static_assert_declaration] = STATE(41),
    [sym_concept_definition] = STATE(41),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(41),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(614),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_RBRACE] = ACTIONS(808),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [45] = {
    [sym__block_item] = STATE(41),
    [sym_preproc_include] = STATE(41),
    [sym_preproc_def] = STATE(41),
    [sym_preproc_function_def] = STATE(41),
    [sym_preproc_call] = STATE(41),
    [sym_preproc_if] = STATE(41),
    [sym_preproc_ifdef] = STATE(41),
    [sym_function_definition] = STATE(41),
    [sym_declaration] = STATE(41),
    [sym_type_definition] = STATE(41),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(41),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(41),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(41),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(41),
    [sym_template_instantiation] = STATE(41),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(41),
    [sym_operator_cast_declaration] = STATE(41),
    [sym_constructor_or_destructor_definition] = STATE(41),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(41),
    [sym_namespace_alias_definition] = STATE(41),
    [sym_using_declaration] = STATE(41),
    [sym_alias_declaration] = STATE(41),
    [sym_static_assert_declaration] = STATE(41),
    [sym_concept_definition] = STATE(41),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(41),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(614),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_RBRACE] = ACTIONS(810),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [46] = {
    [sym__block_item] = STATE(38),
    [sym_preproc_include] = STATE(38),
    [sym_preproc_def] = STATE(38),
    [sym_preproc_function_def] = STATE(38),
    [sym_preproc_call] = STATE(38),
    [sym_preproc_if] = STATE(38),
    [sym_preproc_ifdef] = STATE(38),
    [sym_function_definition] = STATE(38),
    [sym_declaration] = STATE(38),
    [sym_type_definition] = STATE(38),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(38),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(38),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(38),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(38),
    [sym_template_instantiation] = STATE(38),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(38),
    [sym_operator_cast_declaration] = STATE(38),
    [sym_constructor_or_destructor_definition] = STATE(38),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(38),
    [sym_namespace_alias_definition] = STATE(38),
    [sym_using_declaration] = STATE(38),
    [sym_alias_declaration] = STATE(38),
    [sym_static_assert_declaration] = STATE(38),
    [sym_concept_definition] = STATE(38),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(38),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(614),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_RBRACE] = ACTIONS(812),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [47] = {
    [sym__block_item] = STATE(54),
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4693),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1902),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6227),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(482),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2712),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(573),
    [sym_statement] = STATE(54),
    [sym_labeled_statement] = STATE(482),
    [sym_expression_statement] = STATE(482),
    [sym_if_statement] = STATE(482),
    [sym_switch_statement] = STATE(482),
    [sym_case_statement] = STATE(482),
    [sym_while_statement] = STATE(482),
    [sym_do_statement] = STATE(482),
    [sym_for_statement] = STATE(482),
    [sym_return_statement] = STATE(482),
    [sym_break_statement] = STATE(482),
    [sym_continue_statement] = STATE(482),
    [sym_goto_statement] = STATE(482),
    [sym_seh_try_statement] = STATE(482),
    [sym_seh_leave_statement] = STATE(482),
    [sym_expression] = STATE(4411),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8119),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1741),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(6672),
    [sym__constructor_specifiers] = STATE(1741),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(482),
    [sym_co_return_statement] = STATE(482),
    [sym_co_yield_statement] = STATE(482),
    [sym_throw_statement] = STATE(482),
    [sym_try_statement] = STATE(482),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6672),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(206),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1741),
    [sym_identifier] = ACTIONS(622),
    [aux_sym_preproc_include_token1] = ACTIONS(624),
    [aux_sym_preproc_def_token1] = ACTIONS(626),
    [aux_sym_preproc_if_token1] = ACTIONS(628),
    [aux_sym_preproc_if_token2] = ACTIONS(814),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(632),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(632),
    [sym_preproc_directive] = ACTIONS(634),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym___extension__] = ACTIONS(638),
    [anon_sym_typedef] = ACTIONS(640),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(642),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(644),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(646),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(648),
    [anon_sym_switch] = ACTIONS(650),
    [anon_sym_case] = ACTIONS(652),
    [anon_sym_default] = ACTIONS(654),
    [anon_sym_while] = ACTIONS(656),
    [anon_sym_do] = ACTIONS(658),
    [anon_sym_for] = ACTIONS(660),
    [anon_sym_return] = ACTIONS(662),
    [anon_sym_break] = ACTIONS(664),
    [anon_sym_continue] = ACTIONS(666),
    [anon_sym_goto] = ACTIONS(668),
    [anon_sym___try] = ACTIONS(670),
    [anon_sym___leave] = ACTIONS(672),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(674),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(676),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(678),
    [anon_sym_namespace] = ACTIONS(680),
    [anon_sym_using] = ACTIONS(682),
    [anon_sym_static_assert] = ACTIONS(684),
    [anon_sym_concept] = ACTIONS(686),
    [anon_sym_co_return] = ACTIONS(688),
    [anon_sym_co_yield] = ACTIONS(690),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [48] = {
    [sym__block_item] = STATE(41),
    [sym_preproc_include] = STATE(41),
    [sym_preproc_def] = STATE(41),
    [sym_preproc_function_def] = STATE(41),
    [sym_preproc_call] = STATE(41),
    [sym_preproc_if] = STATE(41),
    [sym_preproc_ifdef] = STATE(41),
    [sym_function_definition] = STATE(41),
    [sym_declaration] = STATE(41),
    [sym_type_definition] = STATE(41),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(41),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(41),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(41),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(41),
    [sym_template_instantiation] = STATE(41),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(41),
    [sym_operator_cast_declaration] = STATE(41),
    [sym_constructor_or_destructor_definition] = STATE(41),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(41),
    [sym_namespace_alias_definition] = STATE(41),
    [sym_using_declaration] = STATE(41),
    [sym_alias_declaration] = STATE(41),
    [sym_static_assert_declaration] = STATE(41),
    [sym_concept_definition] = STATE(41),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(41),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(614),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_RBRACE] = ACTIONS(816),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [49] = {
    [sym__block_item] = STATE(50),
    [sym_preproc_include] = STATE(50),
    [sym_preproc_def] = STATE(50),
    [sym_preproc_function_def] = STATE(50),
    [sym_preproc_call] = STATE(50),
    [sym_preproc_if] = STATE(50),
    [sym_preproc_ifdef] = STATE(50),
    [sym_function_definition] = STATE(50),
    [sym_declaration] = STATE(50),
    [sym_type_definition] = STATE(50),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(50),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(50),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(50),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(50),
    [sym_template_instantiation] = STATE(50),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(50),
    [sym_operator_cast_declaration] = STATE(50),
    [sym_constructor_or_destructor_definition] = STATE(50),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(50),
    [sym_namespace_alias_definition] = STATE(50),
    [sym_using_declaration] = STATE(50),
    [sym_alias_declaration] = STATE(50),
    [sym_static_assert_declaration] = STATE(50),
    [sym_concept_definition] = STATE(50),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(50),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(614),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_RBRACE] = ACTIONS(818),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [50] = {
    [sym__block_item] = STATE(41),
    [sym_preproc_include] = STATE(41),
    [sym_preproc_def] = STATE(41),
    [sym_preproc_function_def] = STATE(41),
    [sym_preproc_call] = STATE(41),
    [sym_preproc_if] = STATE(41),
    [sym_preproc_ifdef] = STATE(41),
    [sym_function_definition] = STATE(41),
    [sym_declaration] = STATE(41),
    [sym_type_definition] = STATE(41),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(41),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(41),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(41),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(41),
    [sym_template_instantiation] = STATE(41),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(41),
    [sym_operator_cast_declaration] = STATE(41),
    [sym_constructor_or_destructor_definition] = STATE(41),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(41),
    [sym_namespace_alias_definition] = STATE(41),
    [sym_using_declaration] = STATE(41),
    [sym_alias_declaration] = STATE(41),
    [sym_static_assert_declaration] = STATE(41),
    [sym_concept_definition] = STATE(41),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(41),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(614),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_RBRACE] = ACTIONS(820),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [51] = {
    [sym__block_item] = STATE(53),
    [sym_preproc_include] = STATE(53),
    [sym_preproc_def] = STATE(53),
    [sym_preproc_function_def] = STATE(53),
    [sym_preproc_call] = STATE(53),
    [sym_preproc_if] = STATE(53),
    [sym_preproc_ifdef] = STATE(53),
    [sym_function_definition] = STATE(53),
    [sym_declaration] = STATE(53),
    [sym_type_definition] = STATE(53),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(53),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(53),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(53),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(53),
    [sym_template_instantiation] = STATE(53),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(53),
    [sym_operator_cast_declaration] = STATE(53),
    [sym_constructor_or_destructor_definition] = STATE(53),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(53),
    [sym_namespace_alias_definition] = STATE(53),
    [sym_using_declaration] = STATE(53),
    [sym_alias_declaration] = STATE(53),
    [sym_static_assert_declaration] = STATE(53),
    [sym_concept_definition] = STATE(53),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(53),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(614),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_RBRACE] = ACTIONS(822),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [52] = {
    [sym__block_item] = STATE(44),
    [sym_preproc_include] = STATE(44),
    [sym_preproc_def] = STATE(44),
    [sym_preproc_function_def] = STATE(44),
    [sym_preproc_call] = STATE(44),
    [sym_preproc_if] = STATE(44),
    [sym_preproc_ifdef] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_declaration] = STATE(44),
    [sym_type_definition] = STATE(44),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(44),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(44),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(44),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(44),
    [sym_template_instantiation] = STATE(44),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(44),
    [sym_operator_cast_declaration] = STATE(44),
    [sym_constructor_or_destructor_definition] = STATE(44),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(44),
    [sym_namespace_alias_definition] = STATE(44),
    [sym_using_declaration] = STATE(44),
    [sym_alias_declaration] = STATE(44),
    [sym_static_assert_declaration] = STATE(44),
    [sym_concept_definition] = STATE(44),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(44),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(614),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_RBRACE] = ACTIONS(824),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [53] = {
    [sym__block_item] = STATE(41),
    [sym_preproc_include] = STATE(41),
    [sym_preproc_def] = STATE(41),
    [sym_preproc_function_def] = STATE(41),
    [sym_preproc_call] = STATE(41),
    [sym_preproc_if] = STATE(41),
    [sym_preproc_ifdef] = STATE(41),
    [sym_function_definition] = STATE(41),
    [sym_declaration] = STATE(41),
    [sym_type_definition] = STATE(41),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(41),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(41),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(41),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(41),
    [sym_template_instantiation] = STATE(41),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(41),
    [sym_operator_cast_declaration] = STATE(41),
    [sym_constructor_or_destructor_definition] = STATE(41),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(41),
    [sym_namespace_alias_definition] = STATE(41),
    [sym_using_declaration] = STATE(41),
    [sym_alias_declaration] = STATE(41),
    [sym_static_assert_declaration] = STATE(41),
    [sym_concept_definition] = STATE(41),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(41),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(614),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_RBRACE] = ACTIONS(826),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [54] = {
    [sym__block_item] = STATE(54),
    [sym_preproc_include] = STATE(54),
    [sym_preproc_def] = STATE(54),
    [sym_preproc_function_def] = STATE(54),
    [sym_preproc_call] = STATE(54),
    [sym_preproc_if] = STATE(54),
    [sym_preproc_ifdef] = STATE(54),
    [sym_function_definition] = STATE(54),
    [sym_declaration] = STATE(54),
    [sym_type_definition] = STATE(54),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4693),
    [sym_linkage_specification] = STATE(54),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1902),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6227),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(482),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2712),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(573),
    [sym_statement] = STATE(54),
    [sym_labeled_statement] = STATE(482),
    [sym_expression_statement] = STATE(482),
    [sym_if_statement] = STATE(482),
    [sym_switch_statement] = STATE(482),
    [sym_case_statement] = STATE(482),
    [sym_while_statement] = STATE(482),
    [sym_do_statement] = STATE(482),
    [sym_for_statement] = STATE(482),
    [sym_return_statement] = STATE(482),
    [sym_break_statement] = STATE(482),
    [sym_continue_statement] = STATE(482),
    [sym_goto_statement] = STATE(482),
    [sym_seh_try_statement] = STATE(482),
    [sym_seh_leave_statement] = STATE(482),
    [sym_expression] = STATE(4411),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8119),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(54),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1741),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(54),
    [sym_template_instantiation] = STATE(54),
    [sym_operator_cast] = STATE(6672),
    [sym__constructor_specifiers] = STATE(1741),
    [sym_operator_cast_definition] = STATE(54),
    [sym_operator_cast_declaration] = STATE(54),
    [sym_constructor_or_destructor_definition] = STATE(54),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(54),
    [sym_namespace_alias_definition] = STATE(54),
    [sym_using_declaration] = STATE(54),
    [sym_alias_declaration] = STATE(54),
    [sym_static_assert_declaration] = STATE(54),
    [sym_concept_definition] = STATE(54),
    [sym_for_range_loop] = STATE(482),
    [sym_co_return_statement] = STATE(482),
    [sym_co_yield_statement] = STATE(482),
    [sym_throw_statement] = STATE(482),
    [sym_try_statement] = STATE(482),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6672),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(54),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(206),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1741),
    [sym_identifier] = ACTIONS(828),
    [aux_sym_preproc_include_token1] = ACTIONS(831),
    [aux_sym_preproc_def_token1] = ACTIONS(834),
    [aux_sym_preproc_if_token1] = ACTIONS(837),
    [aux_sym_preproc_if_token2] = ACTIONS(387),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(840),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(840),
    [sym_preproc_directive] = ACTIONS(843),
    [anon_sym_LPAREN2] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(398),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_DASH] = ACTIONS(404),
    [anon_sym_PLUS] = ACTIONS(404),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_AMP_AMP] = ACTIONS(410),
    [anon_sym_AMP] = ACTIONS(413),
    [anon_sym_SEMI] = ACTIONS(846),
    [anon_sym___extension__] = ACTIONS(849),
    [anon_sym_typedef] = ACTIONS(852),
    [anon_sym_virtual] = ACTIONS(425),
    [anon_sym_extern] = ACTIONS(855),
    [anon_sym___attribute__] = ACTIONS(431),
    [anon_sym___attribute] = ACTIONS(431),
    [anon_sym_COLON_COLON] = ACTIONS(434),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(437),
    [anon_sym___declspec] = ACTIONS(440),
    [anon_sym___based] = ACTIONS(443),
    [anon_sym___cdecl] = ACTIONS(446),
    [anon_sym___clrcall] = ACTIONS(446),
    [anon_sym___stdcall] = ACTIONS(446),
    [anon_sym___fastcall] = ACTIONS(446),
    [anon_sym___thiscall] = ACTIONS(446),
    [anon_sym___vectorcall] = ACTIONS(446),
    [anon_sym_LBRACE] = ACTIONS(858),
    [anon_sym_signed] = ACTIONS(452),
    [anon_sym_unsigned] = ACTIONS(452),
    [anon_sym_long] = ACTIONS(452),
    [anon_sym_short] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(455),
    [anon_sym_static] = ACTIONS(458),
    [anon_sym_register] = ACTIONS(458),
    [anon_sym_inline] = ACTIONS(861),
    [anon_sym___inline] = ACTIONS(458),
    [anon_sym___inline__] = ACTIONS(458),
    [anon_sym___forceinline] = ACTIONS(458),
    [anon_sym_thread_local] = ACTIONS(458),
    [anon_sym___thread] = ACTIONS(458),
    [anon_sym_const] = ACTIONS(464),
    [anon_sym_constexpr] = ACTIONS(464),
    [anon_sym_volatile] = ACTIONS(464),
    [anon_sym_restrict] = ACTIONS(464),
    [anon_sym___restrict__] = ACTIONS(464),
    [anon_sym__Atomic] = ACTIONS(464),
    [anon_sym__Noreturn] = ACTIONS(464),
    [anon_sym_noreturn] = ACTIONS(464),
    [anon_sym__Nonnull] = ACTIONS(464),
    [anon_sym_mutable] = ACTIONS(464),
    [anon_sym_constinit] = ACTIONS(464),
    [anon_sym_consteval] = ACTIONS(464),
    [anon_sym_alignas] = ACTIONS(467),
    [anon_sym__Alignas] = ACTIONS(467),
    [sym_primitive_type] = ACTIONS(470),
    [anon_sym_enum] = ACTIONS(473),
    [anon_sym_class] = ACTIONS(476),
    [anon_sym_struct] = ACTIONS(479),
    [anon_sym_union] = ACTIONS(482),
    [anon_sym_if] = ACTIONS(864),
    [anon_sym_switch] = ACTIONS(867),
    [anon_sym_case] = ACTIONS(870),
    [anon_sym_default] = ACTIONS(873),
    [anon_sym_while] = ACTIONS(876),
    [anon_sym_do] = ACTIONS(879),
    [anon_sym_for] = ACTIONS(882),
    [anon_sym_return] = ACTIONS(885),
    [anon_sym_break] = ACTIONS(888),
    [anon_sym_continue] = ACTIONS(891),
    [anon_sym_goto] = ACTIONS(894),
    [anon_sym___try] = ACTIONS(897),
    [anon_sym___leave] = ACTIONS(900),
    [anon_sym_not] = ACTIONS(404),
    [anon_sym_compl] = ACTIONS(404),
    [anon_sym_DASH_DASH] = ACTIONS(524),
    [anon_sym_PLUS_PLUS] = ACTIONS(524),
    [anon_sym_sizeof] = ACTIONS(527),
    [anon_sym___alignof__] = ACTIONS(530),
    [anon_sym___alignof] = ACTIONS(530),
    [anon_sym__alignof] = ACTIONS(530),
    [anon_sym_alignof] = ACTIONS(530),
    [anon_sym__Alignof] = ACTIONS(530),
    [anon_sym_offsetof] = ACTIONS(533),
    [anon_sym__Generic] = ACTIONS(536),
    [anon_sym_asm] = ACTIONS(539),
    [anon_sym___asm__] = ACTIONS(539),
    [anon_sym___asm] = ACTIONS(539),
    [sym_number_literal] = ACTIONS(542),
    [anon_sym_L_SQUOTE] = ACTIONS(545),
    [anon_sym_u_SQUOTE] = ACTIONS(545),
    [anon_sym_U_SQUOTE] = ACTIONS(545),
    [anon_sym_u8_SQUOTE] = ACTIONS(545),
    [anon_sym_SQUOTE] = ACTIONS(545),
    [anon_sym_L_DQUOTE] = ACTIONS(548),
    [anon_sym_u_DQUOTE] = ACTIONS(548),
    [anon_sym_U_DQUOTE] = ACTIONS(548),
    [anon_sym_u8_DQUOTE] = ACTIONS(548),
    [anon_sym_DQUOTE] = ACTIONS(548),
    [sym_true] = ACTIONS(551),
    [sym_false] = ACTIONS(551),
    [anon_sym_NULL] = ACTIONS(554),
    [anon_sym_nullptr] = ACTIONS(554),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(557),
    [anon_sym_decltype] = ACTIONS(560),
    [anon_sym_explicit] = ACTIONS(563),
    [anon_sym_typename] = ACTIONS(566),
    [anon_sym_template] = ACTIONS(903),
    [anon_sym_operator] = ACTIONS(572),
    [anon_sym_try] = ACTIONS(906),
    [anon_sym_delete] = ACTIONS(578),
    [anon_sym_throw] = ACTIONS(909),
    [anon_sym_namespace] = ACTIONS(912),
    [anon_sym_using] = ACTIONS(915),
    [anon_sym_static_assert] = ACTIONS(918),
    [anon_sym_concept] = ACTIONS(921),
    [anon_sym_co_return] = ACTIONS(924),
    [anon_sym_co_yield] = ACTIONS(927),
    [anon_sym_R_DQUOTE] = ACTIONS(602),
    [anon_sym_LR_DQUOTE] = ACTIONS(602),
    [anon_sym_uR_DQUOTE] = ACTIONS(602),
    [anon_sym_UR_DQUOTE] = ACTIONS(602),
    [anon_sym_u8R_DQUOTE] = ACTIONS(602),
    [anon_sym_co_await] = ACTIONS(605),
    [anon_sym_new] = ACTIONS(608),
    [anon_sym_requires] = ACTIONS(611),
    [sym_this] = ACTIONS(551),
  },
  [55] = {
    [sym__block_item] = STATE(41),
    [sym_preproc_include] = STATE(41),
    [sym_preproc_def] = STATE(41),
    [sym_preproc_function_def] = STATE(41),
    [sym_preproc_call] = STATE(41),
    [sym_preproc_if] = STATE(41),
    [sym_preproc_ifdef] = STATE(41),
    [sym_function_definition] = STATE(41),
    [sym_declaration] = STATE(41),
    [sym_type_definition] = STATE(41),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(41),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(41),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(41),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(41),
    [sym_template_instantiation] = STATE(41),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(41),
    [sym_operator_cast_declaration] = STATE(41),
    [sym_constructor_or_destructor_definition] = STATE(41),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(41),
    [sym_namespace_alias_definition] = STATE(41),
    [sym_using_declaration] = STATE(41),
    [sym_alias_declaration] = STATE(41),
    [sym_static_assert_declaration] = STATE(41),
    [sym_concept_definition] = STATE(41),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(41),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(614),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_RBRACE] = ACTIONS(930),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [56] = {
    [sym__block_item] = STATE(57),
    [sym_preproc_include] = STATE(57),
    [sym_preproc_def] = STATE(57),
    [sym_preproc_function_def] = STATE(57),
    [sym_preproc_call] = STATE(57),
    [sym_preproc_if] = STATE(57),
    [sym_preproc_ifdef] = STATE(57),
    [sym_function_definition] = STATE(57),
    [sym_declaration] = STATE(57),
    [sym_type_definition] = STATE(57),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(57),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(57),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(57),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(57),
    [sym_template_instantiation] = STATE(57),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(57),
    [sym_operator_cast_declaration] = STATE(57),
    [sym_constructor_or_destructor_definition] = STATE(57),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(57),
    [sym_namespace_alias_definition] = STATE(57),
    [sym_using_declaration] = STATE(57),
    [sym_alias_declaration] = STATE(57),
    [sym_static_assert_declaration] = STATE(57),
    [sym_concept_definition] = STATE(57),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(57),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(614),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_RBRACE] = ACTIONS(932),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [57] = {
    [sym__block_item] = STATE(41),
    [sym_preproc_include] = STATE(41),
    [sym_preproc_def] = STATE(41),
    [sym_preproc_function_def] = STATE(41),
    [sym_preproc_call] = STATE(41),
    [sym_preproc_if] = STATE(41),
    [sym_preproc_ifdef] = STATE(41),
    [sym_function_definition] = STATE(41),
    [sym_declaration] = STATE(41),
    [sym_type_definition] = STATE(41),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(41),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(41),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(41),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(41),
    [sym_template_instantiation] = STATE(41),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(41),
    [sym_operator_cast_declaration] = STATE(41),
    [sym_constructor_or_destructor_definition] = STATE(41),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(41),
    [sym_namespace_alias_definition] = STATE(41),
    [sym_using_declaration] = STATE(41),
    [sym_alias_declaration] = STATE(41),
    [sym_static_assert_declaration] = STATE(41),
    [sym_concept_definition] = STATE(41),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(41),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(614),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_RBRACE] = ACTIONS(934),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [58] = {
    [sym__block_item] = STATE(59),
    [sym_preproc_include] = STATE(59),
    [sym_preproc_def] = STATE(59),
    [sym_preproc_function_def] = STATE(59),
    [sym_preproc_call] = STATE(59),
    [sym_preproc_if] = STATE(59),
    [sym_preproc_ifdef] = STATE(59),
    [sym_function_definition] = STATE(59),
    [sym_declaration] = STATE(59),
    [sym_type_definition] = STATE(59),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(59),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(59),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(59),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(59),
    [sym_template_instantiation] = STATE(59),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(59),
    [sym_operator_cast_declaration] = STATE(59),
    [sym_constructor_or_destructor_definition] = STATE(59),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(59),
    [sym_namespace_alias_definition] = STATE(59),
    [sym_using_declaration] = STATE(59),
    [sym_alias_declaration] = STATE(59),
    [sym_static_assert_declaration] = STATE(59),
    [sym_concept_definition] = STATE(59),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(59),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(614),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_RBRACE] = ACTIONS(936),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [59] = {
    [sym__block_item] = STATE(41),
    [sym_preproc_include] = STATE(41),
    [sym_preproc_def] = STATE(41),
    [sym_preproc_function_def] = STATE(41),
    [sym_preproc_call] = STATE(41),
    [sym_preproc_if] = STATE(41),
    [sym_preproc_ifdef] = STATE(41),
    [sym_function_definition] = STATE(41),
    [sym_declaration] = STATE(41),
    [sym_type_definition] = STATE(41),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(41),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(41),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(41),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(41),
    [sym_template_instantiation] = STATE(41),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(41),
    [sym_operator_cast_declaration] = STATE(41),
    [sym_constructor_or_destructor_definition] = STATE(41),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(41),
    [sym_namespace_alias_definition] = STATE(41),
    [sym_using_declaration] = STATE(41),
    [sym_alias_declaration] = STATE(41),
    [sym_static_assert_declaration] = STATE(41),
    [sym_concept_definition] = STATE(41),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(41),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(614),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_RBRACE] = ACTIONS(938),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [60] = {
    [sym__block_item] = STATE(61),
    [sym_preproc_include] = STATE(61),
    [sym_preproc_def] = STATE(61),
    [sym_preproc_function_def] = STATE(61),
    [sym_preproc_call] = STATE(61),
    [sym_preproc_if] = STATE(61),
    [sym_preproc_ifdef] = STATE(61),
    [sym_function_definition] = STATE(61),
    [sym_declaration] = STATE(61),
    [sym_type_definition] = STATE(61),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(61),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(61),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(61),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(61),
    [sym_template_instantiation] = STATE(61),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(61),
    [sym_operator_cast_declaration] = STATE(61),
    [sym_constructor_or_destructor_definition] = STATE(61),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(61),
    [sym_namespace_alias_definition] = STATE(61),
    [sym_using_declaration] = STATE(61),
    [sym_alias_declaration] = STATE(61),
    [sym_static_assert_declaration] = STATE(61),
    [sym_concept_definition] = STATE(61),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(61),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(614),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_RBRACE] = ACTIONS(940),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [61] = {
    [sym__block_item] = STATE(41),
    [sym_preproc_include] = STATE(41),
    [sym_preproc_def] = STATE(41),
    [sym_preproc_function_def] = STATE(41),
    [sym_preproc_call] = STATE(41),
    [sym_preproc_if] = STATE(41),
    [sym_preproc_ifdef] = STATE(41),
    [sym_function_definition] = STATE(41),
    [sym_declaration] = STATE(41),
    [sym_type_definition] = STATE(41),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(41),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(41),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(41),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(41),
    [sym_template_instantiation] = STATE(41),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(41),
    [sym_operator_cast_declaration] = STATE(41),
    [sym_constructor_or_destructor_definition] = STATE(41),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(41),
    [sym_namespace_alias_definition] = STATE(41),
    [sym_using_declaration] = STATE(41),
    [sym_alias_declaration] = STATE(41),
    [sym_static_assert_declaration] = STATE(41),
    [sym_concept_definition] = STATE(41),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(41),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(614),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_RBRACE] = ACTIONS(942),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [62] = {
    [sym__block_item] = STATE(63),
    [sym_preproc_include] = STATE(63),
    [sym_preproc_def] = STATE(63),
    [sym_preproc_function_def] = STATE(63),
    [sym_preproc_call] = STATE(63),
    [sym_preproc_if] = STATE(63),
    [sym_preproc_ifdef] = STATE(63),
    [sym_function_definition] = STATE(63),
    [sym_declaration] = STATE(63),
    [sym_type_definition] = STATE(63),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(63),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(63),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(63),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(63),
    [sym_template_instantiation] = STATE(63),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(63),
    [sym_operator_cast_declaration] = STATE(63),
    [sym_constructor_or_destructor_definition] = STATE(63),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(63),
    [sym_namespace_alias_definition] = STATE(63),
    [sym_using_declaration] = STATE(63),
    [sym_alias_declaration] = STATE(63),
    [sym_static_assert_declaration] = STATE(63),
    [sym_concept_definition] = STATE(63),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(63),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(614),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_RBRACE] = ACTIONS(944),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [63] = {
    [sym__block_item] = STATE(41),
    [sym_preproc_include] = STATE(41),
    [sym_preproc_def] = STATE(41),
    [sym_preproc_function_def] = STATE(41),
    [sym_preproc_call] = STATE(41),
    [sym_preproc_if] = STATE(41),
    [sym_preproc_ifdef] = STATE(41),
    [sym_function_definition] = STATE(41),
    [sym_declaration] = STATE(41),
    [sym_type_definition] = STATE(41),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(41),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(41),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(41),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(41),
    [sym_template_instantiation] = STATE(41),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(41),
    [sym_operator_cast_declaration] = STATE(41),
    [sym_constructor_or_destructor_definition] = STATE(41),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(41),
    [sym_namespace_alias_definition] = STATE(41),
    [sym_using_declaration] = STATE(41),
    [sym_alias_declaration] = STATE(41),
    [sym_static_assert_declaration] = STATE(41),
    [sym_concept_definition] = STATE(41),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(41),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(614),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_RBRACE] = ACTIONS(946),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [64] = {
    [sym__block_item] = STATE(65),
    [sym_preproc_include] = STATE(65),
    [sym_preproc_def] = STATE(65),
    [sym_preproc_function_def] = STATE(65),
    [sym_preproc_call] = STATE(65),
    [sym_preproc_if] = STATE(65),
    [sym_preproc_ifdef] = STATE(65),
    [sym_function_definition] = STATE(65),
    [sym_declaration] = STATE(65),
    [sym_type_definition] = STATE(65),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(65),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(65),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(65),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(65),
    [sym_template_instantiation] = STATE(65),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(65),
    [sym_operator_cast_declaration] = STATE(65),
    [sym_constructor_or_destructor_definition] = STATE(65),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(65),
    [sym_namespace_alias_definition] = STATE(65),
    [sym_using_declaration] = STATE(65),
    [sym_alias_declaration] = STATE(65),
    [sym_static_assert_declaration] = STATE(65),
    [sym_concept_definition] = STATE(65),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(65),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(614),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_RBRACE] = ACTIONS(948),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [65] = {
    [sym__block_item] = STATE(41),
    [sym_preproc_include] = STATE(41),
    [sym_preproc_def] = STATE(41),
    [sym_preproc_function_def] = STATE(41),
    [sym_preproc_call] = STATE(41),
    [sym_preproc_if] = STATE(41),
    [sym_preproc_ifdef] = STATE(41),
    [sym_function_definition] = STATE(41),
    [sym_declaration] = STATE(41),
    [sym_type_definition] = STATE(41),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(41),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(41),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(41),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(41),
    [sym_template_instantiation] = STATE(41),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(41),
    [sym_operator_cast_declaration] = STATE(41),
    [sym_constructor_or_destructor_definition] = STATE(41),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(41),
    [sym_namespace_alias_definition] = STATE(41),
    [sym_using_declaration] = STATE(41),
    [sym_alias_declaration] = STATE(41),
    [sym_static_assert_declaration] = STATE(41),
    [sym_concept_definition] = STATE(41),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(41),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(614),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_RBRACE] = ACTIONS(950),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [66] = {
    [sym__block_item] = STATE(67),
    [sym_preproc_include] = STATE(67),
    [sym_preproc_def] = STATE(67),
    [sym_preproc_function_def] = STATE(67),
    [sym_preproc_call] = STATE(67),
    [sym_preproc_if] = STATE(67),
    [sym_preproc_ifdef] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_declaration] = STATE(67),
    [sym_type_definition] = STATE(67),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(67),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(67),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(67),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(67),
    [sym_template_instantiation] = STATE(67),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(67),
    [sym_operator_cast_declaration] = STATE(67),
    [sym_constructor_or_destructor_definition] = STATE(67),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(67),
    [sym_namespace_alias_definition] = STATE(67),
    [sym_using_declaration] = STATE(67),
    [sym_alias_declaration] = STATE(67),
    [sym_static_assert_declaration] = STATE(67),
    [sym_concept_definition] = STATE(67),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(67),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(614),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_RBRACE] = ACTIONS(952),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [67] = {
    [sym__block_item] = STATE(41),
    [sym_preproc_include] = STATE(41),
    [sym_preproc_def] = STATE(41),
    [sym_preproc_function_def] = STATE(41),
    [sym_preproc_call] = STATE(41),
    [sym_preproc_if] = STATE(41),
    [sym_preproc_ifdef] = STATE(41),
    [sym_function_definition] = STATE(41),
    [sym_declaration] = STATE(41),
    [sym_type_definition] = STATE(41),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(41),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(41),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(41),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(41),
    [sym_template_instantiation] = STATE(41),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(41),
    [sym_operator_cast_declaration] = STATE(41),
    [sym_constructor_or_destructor_definition] = STATE(41),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(41),
    [sym_namespace_alias_definition] = STATE(41),
    [sym_using_declaration] = STATE(41),
    [sym_alias_declaration] = STATE(41),
    [sym_static_assert_declaration] = STATE(41),
    [sym_concept_definition] = STATE(41),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(41),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(614),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_RBRACE] = ACTIONS(954),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [68] = {
    [sym__block_item] = STATE(69),
    [sym_preproc_include] = STATE(69),
    [sym_preproc_def] = STATE(69),
    [sym_preproc_function_def] = STATE(69),
    [sym_preproc_call] = STATE(69),
    [sym_preproc_if] = STATE(69),
    [sym_preproc_ifdef] = STATE(69),
    [sym_function_definition] = STATE(69),
    [sym_declaration] = STATE(69),
    [sym_type_definition] = STATE(69),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(69),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(69),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(69),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(69),
    [sym_template_instantiation] = STATE(69),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(69),
    [sym_operator_cast_declaration] = STATE(69),
    [sym_constructor_or_destructor_definition] = STATE(69),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(69),
    [sym_namespace_alias_definition] = STATE(69),
    [sym_using_declaration] = STATE(69),
    [sym_alias_declaration] = STATE(69),
    [sym_static_assert_declaration] = STATE(69),
    [sym_concept_definition] = STATE(69),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(69),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(614),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_RBRACE] = ACTIONS(956),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [69] = {
    [sym__block_item] = STATE(41),
    [sym_preproc_include] = STATE(41),
    [sym_preproc_def] = STATE(41),
    [sym_preproc_function_def] = STATE(41),
    [sym_preproc_call] = STATE(41),
    [sym_preproc_if] = STATE(41),
    [sym_preproc_ifdef] = STATE(41),
    [sym_function_definition] = STATE(41),
    [sym_declaration] = STATE(41),
    [sym_type_definition] = STATE(41),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(41),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(41),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(41),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(41),
    [sym_template_instantiation] = STATE(41),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(41),
    [sym_operator_cast_declaration] = STATE(41),
    [sym_constructor_or_destructor_definition] = STATE(41),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(41),
    [sym_namespace_alias_definition] = STATE(41),
    [sym_using_declaration] = STATE(41),
    [sym_alias_declaration] = STATE(41),
    [sym_static_assert_declaration] = STATE(41),
    [sym_concept_definition] = STATE(41),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(41),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(614),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_RBRACE] = ACTIONS(958),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [70] = {
    [sym__block_item] = STATE(71),
    [sym_preproc_include] = STATE(71),
    [sym_preproc_def] = STATE(71),
    [sym_preproc_function_def] = STATE(71),
    [sym_preproc_call] = STATE(71),
    [sym_preproc_if] = STATE(71),
    [sym_preproc_ifdef] = STATE(71),
    [sym_function_definition] = STATE(71),
    [sym_declaration] = STATE(71),
    [sym_type_definition] = STATE(71),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(71),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(71),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(71),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(71),
    [sym_template_instantiation] = STATE(71),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(71),
    [sym_operator_cast_declaration] = STATE(71),
    [sym_constructor_or_destructor_definition] = STATE(71),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(71),
    [sym_namespace_alias_definition] = STATE(71),
    [sym_using_declaration] = STATE(71),
    [sym_alias_declaration] = STATE(71),
    [sym_static_assert_declaration] = STATE(71),
    [sym_concept_definition] = STATE(71),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(71),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(614),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_RBRACE] = ACTIONS(960),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [71] = {
    [sym__block_item] = STATE(41),
    [sym_preproc_include] = STATE(41),
    [sym_preproc_def] = STATE(41),
    [sym_preproc_function_def] = STATE(41),
    [sym_preproc_call] = STATE(41),
    [sym_preproc_if] = STATE(41),
    [sym_preproc_ifdef] = STATE(41),
    [sym_function_definition] = STATE(41),
    [sym_declaration] = STATE(41),
    [sym_type_definition] = STATE(41),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(41),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(41),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(41),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(41),
    [sym_template_instantiation] = STATE(41),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(41),
    [sym_operator_cast_declaration] = STATE(41),
    [sym_constructor_or_destructor_definition] = STATE(41),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(41),
    [sym_namespace_alias_definition] = STATE(41),
    [sym_using_declaration] = STATE(41),
    [sym_alias_declaration] = STATE(41),
    [sym_static_assert_declaration] = STATE(41),
    [sym_concept_definition] = STATE(41),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(41),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(614),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_RBRACE] = ACTIONS(962),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [72] = {
    [sym__block_item] = STATE(73),
    [sym_preproc_include] = STATE(73),
    [sym_preproc_def] = STATE(73),
    [sym_preproc_function_def] = STATE(73),
    [sym_preproc_call] = STATE(73),
    [sym_preproc_if] = STATE(73),
    [sym_preproc_ifdef] = STATE(73),
    [sym_function_definition] = STATE(73),
    [sym_declaration] = STATE(73),
    [sym_type_definition] = STATE(73),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(73),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(73),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(73),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(73),
    [sym_template_instantiation] = STATE(73),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(73),
    [sym_operator_cast_declaration] = STATE(73),
    [sym_constructor_or_destructor_definition] = STATE(73),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(73),
    [sym_namespace_alias_definition] = STATE(73),
    [sym_using_declaration] = STATE(73),
    [sym_alias_declaration] = STATE(73),
    [sym_static_assert_declaration] = STATE(73),
    [sym_concept_definition] = STATE(73),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(73),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(614),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_RBRACE] = ACTIONS(964),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [73] = {
    [sym__block_item] = STATE(41),
    [sym_preproc_include] = STATE(41),
    [sym_preproc_def] = STATE(41),
    [sym_preproc_function_def] = STATE(41),
    [sym_preproc_call] = STATE(41),
    [sym_preproc_if] = STATE(41),
    [sym_preproc_ifdef] = STATE(41),
    [sym_function_definition] = STATE(41),
    [sym_declaration] = STATE(41),
    [sym_type_definition] = STATE(41),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(41),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(41),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(41),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(41),
    [sym_template_instantiation] = STATE(41),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(41),
    [sym_operator_cast_declaration] = STATE(41),
    [sym_constructor_or_destructor_definition] = STATE(41),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(41),
    [sym_namespace_alias_definition] = STATE(41),
    [sym_using_declaration] = STATE(41),
    [sym_alias_declaration] = STATE(41),
    [sym_static_assert_declaration] = STATE(41),
    [sym_concept_definition] = STATE(41),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(41),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(614),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_RBRACE] = ACTIONS(966),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [74] = {
    [sym__block_item] = STATE(75),
    [sym_preproc_include] = STATE(75),
    [sym_preproc_def] = STATE(75),
    [sym_preproc_function_def] = STATE(75),
    [sym_preproc_call] = STATE(75),
    [sym_preproc_if] = STATE(75),
    [sym_preproc_ifdef] = STATE(75),
    [sym_function_definition] = STATE(75),
    [sym_declaration] = STATE(75),
    [sym_type_definition] = STATE(75),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(75),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(75),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(75),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(75),
    [sym_template_instantiation] = STATE(75),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(75),
    [sym_operator_cast_declaration] = STATE(75),
    [sym_constructor_or_destructor_definition] = STATE(75),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(75),
    [sym_namespace_alias_definition] = STATE(75),
    [sym_using_declaration] = STATE(75),
    [sym_alias_declaration] = STATE(75),
    [sym_static_assert_declaration] = STATE(75),
    [sym_concept_definition] = STATE(75),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(75),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(614),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_RBRACE] = ACTIONS(968),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [75] = {
    [sym__block_item] = STATE(41),
    [sym_preproc_include] = STATE(41),
    [sym_preproc_def] = STATE(41),
    [sym_preproc_function_def] = STATE(41),
    [sym_preproc_call] = STATE(41),
    [sym_preproc_if] = STATE(41),
    [sym_preproc_ifdef] = STATE(41),
    [sym_function_definition] = STATE(41),
    [sym_declaration] = STATE(41),
    [sym_type_definition] = STATE(41),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(41),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(41),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(41),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(41),
    [sym_template_instantiation] = STATE(41),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(41),
    [sym_operator_cast_declaration] = STATE(41),
    [sym_constructor_or_destructor_definition] = STATE(41),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(41),
    [sym_namespace_alias_definition] = STATE(41),
    [sym_using_declaration] = STATE(41),
    [sym_alias_declaration] = STATE(41),
    [sym_static_assert_declaration] = STATE(41),
    [sym_concept_definition] = STATE(41),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(41),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(614),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_RBRACE] = ACTIONS(970),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [76] = {
    [sym__block_item] = STATE(77),
    [sym_preproc_include] = STATE(77),
    [sym_preproc_def] = STATE(77),
    [sym_preproc_function_def] = STATE(77),
    [sym_preproc_call] = STATE(77),
    [sym_preproc_if] = STATE(77),
    [sym_preproc_ifdef] = STATE(77),
    [sym_function_definition] = STATE(77),
    [sym_declaration] = STATE(77),
    [sym_type_definition] = STATE(77),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(77),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(77),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(77),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(77),
    [sym_template_instantiation] = STATE(77),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(77),
    [sym_operator_cast_declaration] = STATE(77),
    [sym_constructor_or_destructor_definition] = STATE(77),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(77),
    [sym_namespace_alias_definition] = STATE(77),
    [sym_using_declaration] = STATE(77),
    [sym_alias_declaration] = STATE(77),
    [sym_static_assert_declaration] = STATE(77),
    [sym_concept_definition] = STATE(77),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(77),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(614),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_RBRACE] = ACTIONS(972),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [77] = {
    [sym__block_item] = STATE(41),
    [sym_preproc_include] = STATE(41),
    [sym_preproc_def] = STATE(41),
    [sym_preproc_function_def] = STATE(41),
    [sym_preproc_call] = STATE(41),
    [sym_preproc_if] = STATE(41),
    [sym_preproc_ifdef] = STATE(41),
    [sym_function_definition] = STATE(41),
    [sym_declaration] = STATE(41),
    [sym_type_definition] = STATE(41),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(41),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(41),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(41),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(41),
    [sym_template_instantiation] = STATE(41),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(41),
    [sym_operator_cast_declaration] = STATE(41),
    [sym_constructor_or_destructor_definition] = STATE(41),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(41),
    [sym_namespace_alias_definition] = STATE(41),
    [sym_using_declaration] = STATE(41),
    [sym_alias_declaration] = STATE(41),
    [sym_static_assert_declaration] = STATE(41),
    [sym_concept_definition] = STATE(41),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(41),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(614),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_RBRACE] = ACTIONS(974),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [78] = {
    [sym__block_item] = STATE(35),
    [sym_preproc_include] = STATE(35),
    [sym_preproc_def] = STATE(35),
    [sym_preproc_function_def] = STATE(35),
    [sym_preproc_call] = STATE(35),
    [sym_preproc_if] = STATE(35),
    [sym_preproc_ifdef] = STATE(35),
    [sym_function_definition] = STATE(35),
    [sym_declaration] = STATE(35),
    [sym_type_definition] = STATE(35),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(35),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(35),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(35),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(35),
    [sym_template_instantiation] = STATE(35),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(35),
    [sym_operator_cast_declaration] = STATE(35),
    [sym_constructor_or_destructor_definition] = STATE(35),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(35),
    [sym_namespace_alias_definition] = STATE(35),
    [sym_using_declaration] = STATE(35),
    [sym_alias_declaration] = STATE(35),
    [sym_static_assert_declaration] = STATE(35),
    [sym_concept_definition] = STATE(35),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(35),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(614),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_RBRACE] = ACTIONS(976),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [79] = {
    [sym__block_item] = STATE(55),
    [sym_preproc_include] = STATE(55),
    [sym_preproc_def] = STATE(55),
    [sym_preproc_function_def] = STATE(55),
    [sym_preproc_call] = STATE(55),
    [sym_preproc_if] = STATE(55),
    [sym_preproc_ifdef] = STATE(55),
    [sym_function_definition] = STATE(55),
    [sym_declaration] = STATE(55),
    [sym_type_definition] = STATE(55),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_linkage_specification] = STATE(55),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6248),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(593),
    [sym_statement] = STATE(55),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym__empty_declaration] = STATE(55),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1721),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(55),
    [sym_template_instantiation] = STATE(55),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1721),
    [sym_operator_cast_definition] = STATE(55),
    [sym_operator_cast_declaration] = STATE(55),
    [sym_constructor_or_destructor_definition] = STATE(55),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4469),
    [sym_namespace_definition] = STATE(55),
    [sym_namespace_alias_definition] = STATE(55),
    [sym_using_declaration] = STATE(55),
    [sym_alias_declaration] = STATE(55),
    [sym_static_assert_declaration] = STATE(55),
    [sym_concept_definition] = STATE(55),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3245),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_preproc_if_repeat1] = STATE(55),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1721),
    [sym_identifier] = ACTIONS(614),
    [aux_sym_preproc_include_token1] = ACTIONS(163),
    [aux_sym_preproc_def_token1] = ACTIONS(165),
    [aux_sym_preproc_if_token1] = ACTIONS(169),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(171),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(171),
    [sym_preproc_directive] = ACTIONS(173),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(177),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(181),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_RBRACE] = ACTIONS(978),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(189),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(223),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(229),
    [anon_sym_using] = ACTIONS(231),
    [anon_sym_static_assert] = ACTIONS(233),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [80] = {
    [sym__top_level_item] = STATE(80),
    [sym_preproc_include] = STATE(80),
    [sym_preproc_def] = STATE(80),
    [sym_preproc_function_def] = STATE(80),
    [sym_preproc_call] = STATE(80),
    [sym_preproc_if] = STATE(80),
    [sym_preproc_ifdef] = STATE(80),
    [sym_function_definition] = STATE(80),
    [sym_declaration] = STATE(80),
    [sym_type_definition] = STATE(80),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4592),
    [sym_linkage_specification] = STATE(80),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1881),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6204),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(80),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2704),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(686),
    [sym__top_level_statement] = STATE(80),
    [sym_labeled_statement] = STATE(80),
    [sym__top_level_expression_statement] = STATE(80),
    [sym_if_statement] = STATE(80),
    [sym_switch_statement] = STATE(80),
    [sym_case_statement] = STATE(80),
    [sym_while_statement] = STATE(80),
    [sym_do_statement] = STATE(80),
    [sym_for_statement] = STATE(80),
    [sym_return_statement] = STATE(80),
    [sym_break_statement] = STATE(80),
    [sym_continue_statement] = STATE(80),
    [sym_goto_statement] = STATE(80),
    [sym_expression] = STATE(4776),
    [sym__string] = STATE(4761),
    [sym_conditional_expression] = STATE(4827),
    [sym_assignment_expression] = STATE(4827),
    [sym_pointer_expression] = STATE(3717),
    [sym_unary_expression] = STATE(4827),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(4827),
    [sym_cast_expression] = STATE(4827),
    [sym_sizeof_expression] = STATE(4827),
    [sym_alignof_expression] = STATE(4827),
    [sym_offsetof_expression] = STATE(4827),
    [sym_generic_expression] = STATE(4827),
    [sym_subscript_expression] = STATE(3717),
    [sym_call_expression] = STATE(3717),
    [sym_gnu_asm_expression] = STATE(4827),
    [sym_extension_expression] = STATE(4827),
    [sym_field_expression] = STATE(3717),
    [sym_compound_literal_expression] = STATE(4827),
    [sym_parenthesized_expression] = STATE(3717),
    [sym_char_literal] = STATE(4761),
    [sym_concatenated_string] = STATE(4761),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(4827),
    [sym__empty_declaration] = STATE(80),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1710),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(80),
    [sym_template_instantiation] = STATE(80),
    [sym_operator_cast] = STATE(6688),
    [sym__constructor_specifiers] = STATE(1710),
    [sym_operator_cast_definition] = STATE(80),
    [sym_operator_cast_declaration] = STATE(80),
    [sym_constructor_or_destructor_definition] = STATE(80),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4752),
    [sym_namespace_definition] = STATE(80),
    [sym_namespace_alias_definition] = STATE(80),
    [sym_using_declaration] = STATE(80),
    [sym_alias_declaration] = STATE(80),
    [sym_static_assert_declaration] = STATE(80),
    [sym_concept_definition] = STATE(80),
    [sym_for_range_loop] = STATE(80),
    [sym_co_return_statement] = STATE(80),
    [sym_co_yield_statement] = STATE(80),
    [sym_throw_statement] = STATE(80),
    [sym_try_statement] = STATE(80),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(4827),
    [sym_new_expression] = STATE(4827),
    [sym_delete_expression] = STATE(4827),
    [sym_requires_clause] = STATE(4827),
    [sym_requires_expression] = STATE(4827),
    [sym_lambda_expression] = STATE(4827),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(4827),
    [sym_parameter_pack_expansion] = STATE(4827),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3500),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6688),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3717),
    [aux_sym_translation_unit_repeat1] = STATE(80),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(174),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1710),
    [ts_builtin_sym_end] = ACTIONS(980),
    [sym_identifier] = ACTIONS(982),
    [aux_sym_preproc_include_token1] = ACTIONS(985),
    [aux_sym_preproc_def_token1] = ACTIONS(988),
    [aux_sym_preproc_if_token1] = ACTIONS(991),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(994),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(994),
    [sym_preproc_directive] = ACTIONS(997),
    [anon_sym_LPAREN2] = ACTIONS(1000),
    [anon_sym_BANG] = ACTIONS(1003),
    [anon_sym_TILDE] = ACTIONS(1006),
    [anon_sym_DASH] = ACTIONS(1009),
    [anon_sym_PLUS] = ACTIONS(1009),
    [anon_sym_STAR] = ACTIONS(1012),
    [anon_sym_AMP_AMP] = ACTIONS(1015),
    [anon_sym_AMP] = ACTIONS(1018),
    [anon_sym_SEMI] = ACTIONS(1021),
    [anon_sym___extension__] = ACTIONS(1024),
    [anon_sym_typedef] = ACTIONS(1027),
    [anon_sym_virtual] = ACTIONS(1030),
    [anon_sym_extern] = ACTIONS(1033),
    [anon_sym___attribute__] = ACTIONS(1036),
    [anon_sym___attribute] = ACTIONS(1036),
    [anon_sym_COLON_COLON] = ACTIONS(1039),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1042),
    [anon_sym___declspec] = ACTIONS(1045),
    [anon_sym___based] = ACTIONS(1048),
    [anon_sym___cdecl] = ACTIONS(1051),
    [anon_sym___clrcall] = ACTIONS(1051),
    [anon_sym___stdcall] = ACTIONS(1051),
    [anon_sym___fastcall] = ACTIONS(1051),
    [anon_sym___thiscall] = ACTIONS(1051),
    [anon_sym___vectorcall] = ACTIONS(1051),
    [anon_sym_LBRACE] = ACTIONS(1054),
    [anon_sym_signed] = ACTIONS(1057),
    [anon_sym_unsigned] = ACTIONS(1057),
    [anon_sym_long] = ACTIONS(1057),
    [anon_sym_short] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1060),
    [anon_sym_static] = ACTIONS(1063),
    [anon_sym_register] = ACTIONS(1063),
    [anon_sym_inline] = ACTIONS(1066),
    [anon_sym___inline] = ACTIONS(1063),
    [anon_sym___inline__] = ACTIONS(1063),
    [anon_sym___forceinline] = ACTIONS(1063),
    [anon_sym_thread_local] = ACTIONS(1063),
    [anon_sym___thread] = ACTIONS(1063),
    [anon_sym_const] = ACTIONS(1069),
    [anon_sym_constexpr] = ACTIONS(1069),
    [anon_sym_volatile] = ACTIONS(1069),
    [anon_sym_restrict] = ACTIONS(1069),
    [anon_sym___restrict__] = ACTIONS(1069),
    [anon_sym__Atomic] = ACTIONS(1069),
    [anon_sym__Noreturn] = ACTIONS(1069),
    [anon_sym_noreturn] = ACTIONS(1069),
    [anon_sym__Nonnull] = ACTIONS(1069),
    [anon_sym_mutable] = ACTIONS(1069),
    [anon_sym_constinit] = ACTIONS(1069),
    [anon_sym_consteval] = ACTIONS(1069),
    [anon_sym_alignas] = ACTIONS(1072),
    [anon_sym__Alignas] = ACTIONS(1072),
    [sym_primitive_type] = ACTIONS(1075),
    [anon_sym_enum] = ACTIONS(1078),
    [anon_sym_class] = ACTIONS(1081),
    [anon_sym_struct] = ACTIONS(1084),
    [anon_sym_union] = ACTIONS(1087),
    [anon_sym_if] = ACTIONS(1090),
    [anon_sym_switch] = ACTIONS(1093),
    [anon_sym_case] = ACTIONS(1096),
    [anon_sym_default] = ACTIONS(1099),
    [anon_sym_while] = ACTIONS(1102),
    [anon_sym_do] = ACTIONS(1105),
    [anon_sym_for] = ACTIONS(1108),
    [anon_sym_return] = ACTIONS(1111),
    [anon_sym_break] = ACTIONS(1114),
    [anon_sym_continue] = ACTIONS(1117),
    [anon_sym_goto] = ACTIONS(1120),
    [anon_sym_not] = ACTIONS(1009),
    [anon_sym_compl] = ACTIONS(1009),
    [anon_sym_DASH_DASH] = ACTIONS(1123),
    [anon_sym_PLUS_PLUS] = ACTIONS(1123),
    [anon_sym_sizeof] = ACTIONS(1126),
    [anon_sym___alignof__] = ACTIONS(1129),
    [anon_sym___alignof] = ACTIONS(1129),
    [anon_sym__alignof] = ACTIONS(1129),
    [anon_sym_alignof] = ACTIONS(1129),
    [anon_sym__Alignof] = ACTIONS(1129),
    [anon_sym_offsetof] = ACTIONS(1132),
    [anon_sym__Generic] = ACTIONS(1135),
    [anon_sym_asm] = ACTIONS(1138),
    [anon_sym___asm__] = ACTIONS(1138),
    [anon_sym___asm] = ACTIONS(1138),
    [sym_number_literal] = ACTIONS(1141),
    [anon_sym_L_SQUOTE] = ACTIONS(1144),
    [anon_sym_u_SQUOTE] = ACTIONS(1144),
    [anon_sym_U_SQUOTE] = ACTIONS(1144),
    [anon_sym_u8_SQUOTE] = ACTIONS(1144),
    [anon_sym_SQUOTE] = ACTIONS(1144),
    [anon_sym_L_DQUOTE] = ACTIONS(1147),
    [anon_sym_u_DQUOTE] = ACTIONS(1147),
    [anon_sym_U_DQUOTE] = ACTIONS(1147),
    [anon_sym_u8_DQUOTE] = ACTIONS(1147),
    [anon_sym_DQUOTE] = ACTIONS(1147),
    [sym_true] = ACTIONS(1150),
    [sym_false] = ACTIONS(1150),
    [anon_sym_NULL] = ACTIONS(1153),
    [anon_sym_nullptr] = ACTIONS(1153),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1156),
    [anon_sym_decltype] = ACTIONS(1159),
    [anon_sym_explicit] = ACTIONS(1162),
    [anon_sym_typename] = ACTIONS(1165),
    [anon_sym_template] = ACTIONS(1168),
    [anon_sym_operator] = ACTIONS(1171),
    [anon_sym_try] = ACTIONS(1174),
    [anon_sym_delete] = ACTIONS(1177),
    [anon_sym_throw] = ACTIONS(1180),
    [anon_sym_namespace] = ACTIONS(1183),
    [anon_sym_using] = ACTIONS(1186),
    [anon_sym_static_assert] = ACTIONS(1189),
    [anon_sym_concept] = ACTIONS(1192),
    [anon_sym_co_return] = ACTIONS(1195),
    [anon_sym_co_yield] = ACTIONS(1198),
    [anon_sym_R_DQUOTE] = ACTIONS(1201),
    [anon_sym_LR_DQUOTE] = ACTIONS(1201),
    [anon_sym_uR_DQUOTE] = ACTIONS(1201),
    [anon_sym_UR_DQUOTE] = ACTIONS(1201),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1201),
    [anon_sym_co_await] = ACTIONS(1204),
    [anon_sym_new] = ACTIONS(1207),
    [anon_sym_requires] = ACTIONS(1210),
    [sym_this] = ACTIONS(1150),
  },
  [81] = {
    [sym__top_level_item] = STATE(80),
    [sym_preproc_include] = STATE(80),
    [sym_preproc_def] = STATE(80),
    [sym_preproc_function_def] = STATE(80),
    [sym_preproc_call] = STATE(80),
    [sym_preproc_if] = STATE(80),
    [sym_preproc_ifdef] = STATE(80),
    [sym_function_definition] = STATE(80),
    [sym_declaration] = STATE(80),
    [sym_type_definition] = STATE(80),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4592),
    [sym_linkage_specification] = STATE(80),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(830),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1881),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6204),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(80),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2704),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(686),
    [sym__top_level_statement] = STATE(80),
    [sym_labeled_statement] = STATE(80),
    [sym__top_level_expression_statement] = STATE(80),
    [sym_if_statement] = STATE(80),
    [sym_switch_statement] = STATE(80),
    [sym_case_statement] = STATE(80),
    [sym_while_statement] = STATE(80),
    [sym_do_statement] = STATE(80),
    [sym_for_statement] = STATE(80),
    [sym_return_statement] = STATE(80),
    [sym_break_statement] = STATE(80),
    [sym_continue_statement] = STATE(80),
    [sym_goto_statement] = STATE(80),
    [sym_expression] = STATE(4776),
    [sym__string] = STATE(4761),
    [sym_conditional_expression] = STATE(4827),
    [sym_assignment_expression] = STATE(4827),
    [sym_pointer_expression] = STATE(3717),
    [sym_unary_expression] = STATE(4827),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(4827),
    [sym_cast_expression] = STATE(4827),
    [sym_sizeof_expression] = STATE(4827),
    [sym_alignof_expression] = STATE(4827),
    [sym_offsetof_expression] = STATE(4827),
    [sym_generic_expression] = STATE(4827),
    [sym_subscript_expression] = STATE(3717),
    [sym_call_expression] = STATE(3717),
    [sym_gnu_asm_expression] = STATE(4827),
    [sym_extension_expression] = STATE(4827),
    [sym_field_expression] = STATE(3717),
    [sym_compound_literal_expression] = STATE(4827),
    [sym_parenthesized_expression] = STATE(3717),
    [sym_char_literal] = STATE(4761),
    [sym_concatenated_string] = STATE(4761),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(4827),
    [sym__empty_declaration] = STATE(80),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_explicit_function_specifier] = STATE(1710),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(80),
    [sym_template_instantiation] = STATE(80),
    [sym_operator_cast] = STATE(6688),
    [sym__constructor_specifiers] = STATE(1710),
    [sym_operator_cast_definition] = STATE(80),
    [sym_operator_cast_declaration] = STATE(80),
    [sym_constructor_or_destructor_definition] = STATE(80),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(4752),
    [sym_namespace_definition] = STATE(80),
    [sym_namespace_alias_definition] = STATE(80),
    [sym_using_declaration] = STATE(80),
    [sym_alias_declaration] = STATE(80),
    [sym_static_assert_declaration] = STATE(80),
    [sym_concept_definition] = STATE(80),
    [sym_for_range_loop] = STATE(80),
    [sym_co_return_statement] = STATE(80),
    [sym_co_yield_statement] = STATE(80),
    [sym_throw_statement] = STATE(80),
    [sym_try_statement] = STATE(80),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(4827),
    [sym_new_expression] = STATE(4827),
    [sym_delete_expression] = STATE(4827),
    [sym_requires_clause] = STATE(4827),
    [sym_requires_expression] = STATE(4827),
    [sym_lambda_expression] = STATE(4827),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(4827),
    [sym_parameter_pack_expansion] = STATE(4827),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5363),
    [sym_qualified_identifier] = STATE(3500),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_qualified_operator_cast_identifier] = STATE(6688),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3717),
    [aux_sym_translation_unit_repeat1] = STATE(80),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(174),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1710),
    [ts_builtin_sym_end] = ACTIONS(1213),
    [sym_identifier] = ACTIONS(7),
    [aux_sym_preproc_include_token1] = ACTIONS(9),
    [aux_sym_preproc_def_token1] = ACTIONS(11),
    [aux_sym_preproc_if_token1] = ACTIONS(13),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(15),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(15),
    [sym_preproc_directive] = ACTIONS(17),
    [anon_sym_LPAREN2] = ACTIONS(19),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(23),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym_SEMI] = ACTIONS(33),
    [anon_sym___extension__] = ACTIONS(35),
    [anon_sym_typedef] = ACTIONS(37),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(41),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(47),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(63),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_default] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(93),
    [anon_sym_break] = ACTIONS(95),
    [anon_sym_continue] = ACTIONS(97),
    [anon_sym_goto] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(113),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(119),
    [sym_false] = ACTIONS(119),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(131),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(141),
    [anon_sym_using] = ACTIONS(143),
    [anon_sym_static_assert] = ACTIONS(145),
    [anon_sym_concept] = ACTIONS(147),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(119),
  },
  [82] = {
    [sym_declaration] = STATE(85),
    [sym_type_definition] = STATE(85),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(5139),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(883),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_compound_statement] = STATE(85),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(85),
    [sym_labeled_statement] = STATE(85),
    [sym_expression_statement] = STATE(85),
    [sym_if_statement] = STATE(85),
    [sym_switch_statement] = STATE(85),
    [sym_while_statement] = STATE(85),
    [sym_do_statement] = STATE(85),
    [sym_for_statement] = STATE(85),
    [sym_return_statement] = STATE(85),
    [sym_break_statement] = STATE(85),
    [sym_continue_statement] = STATE(85),
    [sym_goto_statement] = STATE(85),
    [sym_seh_try_statement] = STATE(85),
    [sym_seh_leave_statement] = STATE(85),
    [sym_expression] = STATE(4387),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8324),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(85),
    [sym_co_return_statement] = STATE(85),
    [sym_co_yield_statement] = STATE(85),
    [sym_throw_statement] = STATE(85),
    [sym_try_statement] = STATE(85),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5601),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(197),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_case_statement_repeat1] = STATE(85),
    [sym_identifier] = ACTIONS(1215),
    [aux_sym_preproc_include_token1] = ACTIONS(1217),
    [aux_sym_preproc_def_token1] = ACTIONS(1217),
    [aux_sym_preproc_if_token1] = ACTIONS(1217),
    [aux_sym_preproc_if_token2] = ACTIONS(1217),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1217),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1217),
    [aux_sym_preproc_else_token1] = ACTIONS(1217),
    [aux_sym_preproc_elif_token1] = ACTIONS(1217),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1217),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1217),
    [sym_preproc_directive] = ACTIONS(1217),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1225),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(1227),
    [anon_sym_typedef] = ACTIONS(285),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(1217),
    [anon_sym___cdecl] = ACTIONS(1217),
    [anon_sym___clrcall] = ACTIONS(1217),
    [anon_sym___stdcall] = ACTIONS(1217),
    [anon_sym___fastcall] = ACTIONS(1217),
    [anon_sym___thiscall] = ACTIONS(1217),
    [anon_sym___vectorcall] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_else] = ACTIONS(1217),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(1217),
    [anon_sym_default] = ACTIONS(1217),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(1217),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_operator] = ACTIONS(1217),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_namespace] = ACTIONS(1217),
    [anon_sym_using] = ACTIONS(1217),
    [anon_sym_static_assert] = ACTIONS(1217),
    [anon_sym_concept] = ACTIONS(1217),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [83] = {
    [sym_declaration] = STATE(84),
    [sym_type_definition] = STATE(84),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(5139),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(883),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_compound_statement] = STATE(84),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(84),
    [sym_labeled_statement] = STATE(84),
    [sym_expression_statement] = STATE(84),
    [sym_if_statement] = STATE(84),
    [sym_switch_statement] = STATE(84),
    [sym_while_statement] = STATE(84),
    [sym_do_statement] = STATE(84),
    [sym_for_statement] = STATE(84),
    [sym_return_statement] = STATE(84),
    [sym_break_statement] = STATE(84),
    [sym_continue_statement] = STATE(84),
    [sym_goto_statement] = STATE(84),
    [sym_seh_try_statement] = STATE(84),
    [sym_seh_leave_statement] = STATE(84),
    [sym_expression] = STATE(4387),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8324),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(84),
    [sym_co_return_statement] = STATE(84),
    [sym_co_yield_statement] = STATE(84),
    [sym_throw_statement] = STATE(84),
    [sym_try_statement] = STATE(84),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5601),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(197),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_case_statement_repeat1] = STATE(84),
    [sym_identifier] = ACTIONS(1215),
    [aux_sym_preproc_include_token1] = ACTIONS(1237),
    [aux_sym_preproc_def_token1] = ACTIONS(1237),
    [aux_sym_preproc_if_token1] = ACTIONS(1237),
    [aux_sym_preproc_if_token2] = ACTIONS(1237),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1237),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1237),
    [aux_sym_preproc_else_token1] = ACTIONS(1237),
    [aux_sym_preproc_elif_token1] = ACTIONS(1237),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1237),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1237),
    [sym_preproc_directive] = ACTIONS(1237),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1239),
    [anon_sym_AMP] = ACTIONS(1225),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(1227),
    [anon_sym_typedef] = ACTIONS(285),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(1237),
    [anon_sym___cdecl] = ACTIONS(1237),
    [anon_sym___clrcall] = ACTIONS(1237),
    [anon_sym___stdcall] = ACTIONS(1237),
    [anon_sym___fastcall] = ACTIONS(1237),
    [anon_sym___thiscall] = ACTIONS(1237),
    [anon_sym___vectorcall] = ACTIONS(1237),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_else] = ACTIONS(1237),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(1237),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(1237),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_operator] = ACTIONS(1237),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_namespace] = ACTIONS(1237),
    [anon_sym_using] = ACTIONS(1237),
    [anon_sym_static_assert] = ACTIONS(1237),
    [anon_sym_concept] = ACTIONS(1237),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [84] = {
    [sym_declaration] = STATE(86),
    [sym_type_definition] = STATE(86),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(5139),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(883),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_compound_statement] = STATE(86),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(86),
    [sym_labeled_statement] = STATE(86),
    [sym_expression_statement] = STATE(86),
    [sym_if_statement] = STATE(86),
    [sym_switch_statement] = STATE(86),
    [sym_while_statement] = STATE(86),
    [sym_do_statement] = STATE(86),
    [sym_for_statement] = STATE(86),
    [sym_return_statement] = STATE(86),
    [sym_break_statement] = STATE(86),
    [sym_continue_statement] = STATE(86),
    [sym_goto_statement] = STATE(86),
    [sym_seh_try_statement] = STATE(86),
    [sym_seh_leave_statement] = STATE(86),
    [sym_expression] = STATE(4387),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8324),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(86),
    [sym_co_return_statement] = STATE(86),
    [sym_co_yield_statement] = STATE(86),
    [sym_throw_statement] = STATE(86),
    [sym_try_statement] = STATE(86),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5601),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(197),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_case_statement_repeat1] = STATE(86),
    [sym_identifier] = ACTIONS(1215),
    [aux_sym_preproc_include_token1] = ACTIONS(1241),
    [aux_sym_preproc_def_token1] = ACTIONS(1241),
    [aux_sym_preproc_if_token1] = ACTIONS(1241),
    [aux_sym_preproc_if_token2] = ACTIONS(1241),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1241),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1241),
    [aux_sym_preproc_else_token1] = ACTIONS(1241),
    [aux_sym_preproc_elif_token1] = ACTIONS(1241),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1241),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1241),
    [sym_preproc_directive] = ACTIONS(1241),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1243),
    [anon_sym_AMP] = ACTIONS(1225),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(1227),
    [anon_sym_typedef] = ACTIONS(285),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(1241),
    [anon_sym___cdecl] = ACTIONS(1241),
    [anon_sym___clrcall] = ACTIONS(1241),
    [anon_sym___stdcall] = ACTIONS(1241),
    [anon_sym___fastcall] = ACTIONS(1241),
    [anon_sym___thiscall] = ACTIONS(1241),
    [anon_sym___vectorcall] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_else] = ACTIONS(1241),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(1241),
    [anon_sym_default] = ACTIONS(1241),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(1241),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_operator] = ACTIONS(1241),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_namespace] = ACTIONS(1241),
    [anon_sym_using] = ACTIONS(1241),
    [anon_sym_static_assert] = ACTIONS(1241),
    [anon_sym_concept] = ACTIONS(1241),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [85] = {
    [sym_declaration] = STATE(86),
    [sym_type_definition] = STATE(86),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(5139),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(883),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_compound_statement] = STATE(86),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(86),
    [sym_labeled_statement] = STATE(86),
    [sym_expression_statement] = STATE(86),
    [sym_if_statement] = STATE(86),
    [sym_switch_statement] = STATE(86),
    [sym_while_statement] = STATE(86),
    [sym_do_statement] = STATE(86),
    [sym_for_statement] = STATE(86),
    [sym_return_statement] = STATE(86),
    [sym_break_statement] = STATE(86),
    [sym_continue_statement] = STATE(86),
    [sym_goto_statement] = STATE(86),
    [sym_seh_try_statement] = STATE(86),
    [sym_seh_leave_statement] = STATE(86),
    [sym_expression] = STATE(4387),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8324),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(86),
    [sym_co_return_statement] = STATE(86),
    [sym_co_yield_statement] = STATE(86),
    [sym_throw_statement] = STATE(86),
    [sym_try_statement] = STATE(86),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5601),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(197),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_case_statement_repeat1] = STATE(86),
    [sym_identifier] = ACTIONS(1215),
    [aux_sym_preproc_include_token1] = ACTIONS(1245),
    [aux_sym_preproc_def_token1] = ACTIONS(1245),
    [aux_sym_preproc_if_token1] = ACTIONS(1245),
    [aux_sym_preproc_if_token2] = ACTIONS(1245),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1245),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1245),
    [aux_sym_preproc_else_token1] = ACTIONS(1245),
    [aux_sym_preproc_elif_token1] = ACTIONS(1245),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1245),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1245),
    [sym_preproc_directive] = ACTIONS(1245),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1247),
    [anon_sym_AMP] = ACTIONS(1225),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(1227),
    [anon_sym_typedef] = ACTIONS(285),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(1245),
    [anon_sym___cdecl] = ACTIONS(1245),
    [anon_sym___clrcall] = ACTIONS(1245),
    [anon_sym___stdcall] = ACTIONS(1245),
    [anon_sym___fastcall] = ACTIONS(1245),
    [anon_sym___thiscall] = ACTIONS(1245),
    [anon_sym___vectorcall] = ACTIONS(1245),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_else] = ACTIONS(1245),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(1245),
    [anon_sym_default] = ACTIONS(1245),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(1245),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_operator] = ACTIONS(1245),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_namespace] = ACTIONS(1245),
    [anon_sym_using] = ACTIONS(1245),
    [anon_sym_static_assert] = ACTIONS(1245),
    [anon_sym_concept] = ACTIONS(1245),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [86] = {
    [sym_declaration] = STATE(86),
    [sym_type_definition] = STATE(86),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(5139),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(883),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_compound_statement] = STATE(86),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(86),
    [sym_labeled_statement] = STATE(86),
    [sym_expression_statement] = STATE(86),
    [sym_if_statement] = STATE(86),
    [sym_switch_statement] = STATE(86),
    [sym_while_statement] = STATE(86),
    [sym_do_statement] = STATE(86),
    [sym_for_statement] = STATE(86),
    [sym_return_statement] = STATE(86),
    [sym_break_statement] = STATE(86),
    [sym_continue_statement] = STATE(86),
    [sym_goto_statement] = STATE(86),
    [sym_seh_try_statement] = STATE(86),
    [sym_seh_leave_statement] = STATE(86),
    [sym_expression] = STATE(4387),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8324),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(86),
    [sym_co_return_statement] = STATE(86),
    [sym_co_yield_statement] = STATE(86),
    [sym_throw_statement] = STATE(86),
    [sym_try_statement] = STATE(86),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5601),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(197),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_case_statement_repeat1] = STATE(86),
    [sym_identifier] = ACTIONS(1249),
    [aux_sym_preproc_include_token1] = ACTIONS(1252),
    [aux_sym_preproc_def_token1] = ACTIONS(1252),
    [aux_sym_preproc_if_token1] = ACTIONS(1252),
    [aux_sym_preproc_if_token2] = ACTIONS(1252),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1252),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1252),
    [aux_sym_preproc_else_token1] = ACTIONS(1252),
    [aux_sym_preproc_elif_token1] = ACTIONS(1252),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1252),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1252),
    [sym_preproc_directive] = ACTIONS(1252),
    [anon_sym_LPAREN2] = ACTIONS(1254),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [anon_sym_DASH] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(1260),
    [anon_sym_STAR] = ACTIONS(1263),
    [anon_sym_AMP_AMP] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(1268),
    [anon_sym_SEMI] = ACTIONS(1271),
    [anon_sym___extension__] = ACTIONS(1274),
    [anon_sym_typedef] = ACTIONS(1277),
    [anon_sym_virtual] = ACTIONS(1280),
    [anon_sym_extern] = ACTIONS(1283),
    [anon_sym___attribute__] = ACTIONS(1286),
    [anon_sym___attribute] = ACTIONS(1286),
    [anon_sym_COLON_COLON] = ACTIONS(1289),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1292),
    [anon_sym___declspec] = ACTIONS(1295),
    [anon_sym___based] = ACTIONS(1252),
    [anon_sym___cdecl] = ACTIONS(1252),
    [anon_sym___clrcall] = ACTIONS(1252),
    [anon_sym___stdcall] = ACTIONS(1252),
    [anon_sym___fastcall] = ACTIONS(1252),
    [anon_sym___thiscall] = ACTIONS(1252),
    [anon_sym___vectorcall] = ACTIONS(1252),
    [anon_sym_LBRACE] = ACTIONS(1298),
    [anon_sym_signed] = ACTIONS(1301),
    [anon_sym_unsigned] = ACTIONS(1301),
    [anon_sym_long] = ACTIONS(1301),
    [anon_sym_short] = ACTIONS(1301),
    [anon_sym_LBRACK] = ACTIONS(1304),
    [anon_sym_static] = ACTIONS(1283),
    [anon_sym_register] = ACTIONS(1283),
    [anon_sym_inline] = ACTIONS(1283),
    [anon_sym___inline] = ACTIONS(1283),
    [anon_sym___inline__] = ACTIONS(1283),
    [anon_sym___forceinline] = ACTIONS(1283),
    [anon_sym_thread_local] = ACTIONS(1283),
    [anon_sym___thread] = ACTIONS(1283),
    [anon_sym_const] = ACTIONS(1307),
    [anon_sym_constexpr] = ACTIONS(1307),
    [anon_sym_volatile] = ACTIONS(1307),
    [anon_sym_restrict] = ACTIONS(1307),
    [anon_sym___restrict__] = ACTIONS(1307),
    [anon_sym__Atomic] = ACTIONS(1307),
    [anon_sym__Noreturn] = ACTIONS(1307),
    [anon_sym_noreturn] = ACTIONS(1307),
    [anon_sym__Nonnull] = ACTIONS(1307),
    [anon_sym_mutable] = ACTIONS(1307),
    [anon_sym_constinit] = ACTIONS(1307),
    [anon_sym_consteval] = ACTIONS(1307),
    [anon_sym_alignas] = ACTIONS(1310),
    [anon_sym__Alignas] = ACTIONS(1310),
    [sym_primitive_type] = ACTIONS(1313),
    [anon_sym_enum] = ACTIONS(1316),
    [anon_sym_class] = ACTIONS(1319),
    [anon_sym_struct] = ACTIONS(1322),
    [anon_sym_union] = ACTIONS(1325),
    [anon_sym_if] = ACTIONS(1328),
    [anon_sym_else] = ACTIONS(1252),
    [anon_sym_switch] = ACTIONS(1331),
    [anon_sym_case] = ACTIONS(1252),
    [anon_sym_default] = ACTIONS(1252),
    [anon_sym_while] = ACTIONS(1334),
    [anon_sym_do] = ACTIONS(1337),
    [anon_sym_for] = ACTIONS(1340),
    [anon_sym_return] = ACTIONS(1343),
    [anon_sym_break] = ACTIONS(1346),
    [anon_sym_continue] = ACTIONS(1349),
    [anon_sym_goto] = ACTIONS(1352),
    [anon_sym___try] = ACTIONS(1355),
    [anon_sym___leave] = ACTIONS(1358),
    [anon_sym_not] = ACTIONS(1260),
    [anon_sym_compl] = ACTIONS(1260),
    [anon_sym_DASH_DASH] = ACTIONS(1361),
    [anon_sym_PLUS_PLUS] = ACTIONS(1361),
    [anon_sym_sizeof] = ACTIONS(1364),
    [anon_sym___alignof__] = ACTIONS(1367),
    [anon_sym___alignof] = ACTIONS(1367),
    [anon_sym__alignof] = ACTIONS(1367),
    [anon_sym_alignof] = ACTIONS(1367),
    [anon_sym__Alignof] = ACTIONS(1367),
    [anon_sym_offsetof] = ACTIONS(1370),
    [anon_sym__Generic] = ACTIONS(1373),
    [anon_sym_asm] = ACTIONS(1376),
    [anon_sym___asm__] = ACTIONS(1376),
    [anon_sym___asm] = ACTIONS(1376),
    [sym_number_literal] = ACTIONS(1379),
    [anon_sym_L_SQUOTE] = ACTIONS(1382),
    [anon_sym_u_SQUOTE] = ACTIONS(1382),
    [anon_sym_U_SQUOTE] = ACTIONS(1382),
    [anon_sym_u8_SQUOTE] = ACTIONS(1382),
    [anon_sym_SQUOTE] = ACTIONS(1382),
    [anon_sym_L_DQUOTE] = ACTIONS(1385),
    [anon_sym_u_DQUOTE] = ACTIONS(1385),
    [anon_sym_U_DQUOTE] = ACTIONS(1385),
    [anon_sym_u8_DQUOTE] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [sym_true] = ACTIONS(1388),
    [sym_false] = ACTIONS(1388),
    [anon_sym_NULL] = ACTIONS(1391),
    [anon_sym_nullptr] = ACTIONS(1391),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1394),
    [anon_sym_decltype] = ACTIONS(1397),
    [anon_sym_explicit] = ACTIONS(1252),
    [anon_sym_typename] = ACTIONS(1400),
    [anon_sym_template] = ACTIONS(1403),
    [anon_sym_operator] = ACTIONS(1252),
    [anon_sym_try] = ACTIONS(1406),
    [anon_sym_delete] = ACTIONS(1409),
    [anon_sym_throw] = ACTIONS(1412),
    [anon_sym_namespace] = ACTIONS(1252),
    [anon_sym_using] = ACTIONS(1252),
    [anon_sym_static_assert] = ACTIONS(1252),
    [anon_sym_concept] = ACTIONS(1252),
    [anon_sym_co_return] = ACTIONS(1415),
    [anon_sym_co_yield] = ACTIONS(1418),
    [anon_sym_R_DQUOTE] = ACTIONS(1421),
    [anon_sym_LR_DQUOTE] = ACTIONS(1421),
    [anon_sym_uR_DQUOTE] = ACTIONS(1421),
    [anon_sym_UR_DQUOTE] = ACTIONS(1421),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1421),
    [anon_sym_co_await] = ACTIONS(1424),
    [anon_sym_new] = ACTIONS(1427),
    [anon_sym_requires] = ACTIONS(1430),
    [sym_this] = ACTIONS(1388),
  },
  [87] = {
    [sym_declaration] = STATE(93),
    [sym_type_definition] = STATE(93),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(5103),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(883),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_compound_statement] = STATE(93),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(93),
    [sym_labeled_statement] = STATE(93),
    [sym_expression_statement] = STATE(93),
    [sym_if_statement] = STATE(93),
    [sym_switch_statement] = STATE(93),
    [sym_while_statement] = STATE(93),
    [sym_do_statement] = STATE(93),
    [sym_for_statement] = STATE(93),
    [sym_return_statement] = STATE(93),
    [sym_break_statement] = STATE(93),
    [sym_continue_statement] = STATE(93),
    [sym_goto_statement] = STATE(93),
    [sym_seh_try_statement] = STATE(93),
    [sym_seh_leave_statement] = STATE(93),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(93),
    [sym_co_return_statement] = STATE(93),
    [sym_co_yield_statement] = STATE(93),
    [sym_throw_statement] = STATE(93),
    [sym_try_statement] = STATE(93),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5601),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_case_statement_repeat1] = STATE(93),
    [sym_identifier] = ACTIONS(1433),
    [aux_sym_preproc_include_token1] = ACTIONS(1237),
    [aux_sym_preproc_def_token1] = ACTIONS(1237),
    [aux_sym_preproc_if_token1] = ACTIONS(1237),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1237),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1237),
    [sym_preproc_directive] = ACTIONS(1237),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1239),
    [anon_sym_AMP] = ACTIONS(1225),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(1435),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(1237),
    [anon_sym___cdecl] = ACTIONS(1237),
    [anon_sym___clrcall] = ACTIONS(1237),
    [anon_sym___stdcall] = ACTIONS(1237),
    [anon_sym___fastcall] = ACTIONS(1237),
    [anon_sym___thiscall] = ACTIONS(1237),
    [anon_sym___vectorcall] = ACTIONS(1237),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_RBRACE] = ACTIONS(1239),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_else] = ACTIONS(1237),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(1237),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(1237),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_operator] = ACTIONS(1237),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(1237),
    [anon_sym_using] = ACTIONS(1237),
    [anon_sym_static_assert] = ACTIONS(1237),
    [anon_sym_concept] = ACTIONS(1237),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [88] = {
    [sym_declaration] = STATE(94),
    [sym_type_definition] = STATE(94),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(5159),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(883),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_compound_statement] = STATE(94),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(94),
    [sym_labeled_statement] = STATE(94),
    [sym_expression_statement] = STATE(94),
    [sym_if_statement] = STATE(94),
    [sym_switch_statement] = STATE(94),
    [sym_while_statement] = STATE(94),
    [sym_do_statement] = STATE(94),
    [sym_for_statement] = STATE(94),
    [sym_return_statement] = STATE(94),
    [sym_break_statement] = STATE(94),
    [sym_continue_statement] = STATE(94),
    [sym_goto_statement] = STATE(94),
    [sym_seh_try_statement] = STATE(94),
    [sym_seh_leave_statement] = STATE(94),
    [sym_expression] = STATE(4411),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8119),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(94),
    [sym_co_return_statement] = STATE(94),
    [sym_co_yield_statement] = STATE(94),
    [sym_throw_statement] = STATE(94),
    [sym_try_statement] = STATE(94),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5601),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(206),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_case_statement_repeat1] = STATE(94),
    [sym_identifier] = ACTIONS(1437),
    [aux_sym_preproc_include_token1] = ACTIONS(1217),
    [aux_sym_preproc_def_token1] = ACTIONS(1217),
    [aux_sym_preproc_if_token1] = ACTIONS(1217),
    [aux_sym_preproc_if_token2] = ACTIONS(1217),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1217),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1217),
    [sym_preproc_directive] = ACTIONS(1217),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1225),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym___extension__] = ACTIONS(1439),
    [anon_sym_typedef] = ACTIONS(640),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(1217),
    [anon_sym___cdecl] = ACTIONS(1217),
    [anon_sym___clrcall] = ACTIONS(1217),
    [anon_sym___stdcall] = ACTIONS(1217),
    [anon_sym___fastcall] = ACTIONS(1217),
    [anon_sym___thiscall] = ACTIONS(1217),
    [anon_sym___vectorcall] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(644),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(648),
    [anon_sym_else] = ACTIONS(1217),
    [anon_sym_switch] = ACTIONS(650),
    [anon_sym_case] = ACTIONS(1217),
    [anon_sym_default] = ACTIONS(1217),
    [anon_sym_while] = ACTIONS(656),
    [anon_sym_do] = ACTIONS(658),
    [anon_sym_for] = ACTIONS(660),
    [anon_sym_return] = ACTIONS(662),
    [anon_sym_break] = ACTIONS(664),
    [anon_sym_continue] = ACTIONS(666),
    [anon_sym_goto] = ACTIONS(668),
    [anon_sym___try] = ACTIONS(670),
    [anon_sym___leave] = ACTIONS(672),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(1217),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_operator] = ACTIONS(1217),
    [anon_sym_try] = ACTIONS(676),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(678),
    [anon_sym_namespace] = ACTIONS(1217),
    [anon_sym_using] = ACTIONS(1217),
    [anon_sym_static_assert] = ACTIONS(1217),
    [anon_sym_concept] = ACTIONS(1217),
    [anon_sym_co_return] = ACTIONS(688),
    [anon_sym_co_yield] = ACTIONS(690),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [89] = {
    [sym_declaration] = STATE(89),
    [sym_type_definition] = STATE(89),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(5172),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(883),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_compound_statement] = STATE(89),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(89),
    [sym_labeled_statement] = STATE(89),
    [sym_expression_statement] = STATE(89),
    [sym_if_statement] = STATE(89),
    [sym_switch_statement] = STATE(89),
    [sym_while_statement] = STATE(89),
    [sym_do_statement] = STATE(89),
    [sym_for_statement] = STATE(89),
    [sym_return_statement] = STATE(89),
    [sym_break_statement] = STATE(89),
    [sym_continue_statement] = STATE(89),
    [sym_goto_statement] = STATE(89),
    [sym_seh_try_statement] = STATE(89),
    [sym_seh_leave_statement] = STATE(89),
    [sym_expression] = STATE(4373),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8412),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(89),
    [sym_co_return_statement] = STATE(89),
    [sym_co_yield_statement] = STATE(89),
    [sym_throw_statement] = STATE(89),
    [sym_try_statement] = STATE(89),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5601),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(174),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_case_statement_repeat1] = STATE(89),
    [ts_builtin_sym_end] = ACTIONS(1266),
    [sym_identifier] = ACTIONS(1441),
    [aux_sym_preproc_include_token1] = ACTIONS(1252),
    [aux_sym_preproc_def_token1] = ACTIONS(1252),
    [aux_sym_preproc_if_token1] = ACTIONS(1252),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1252),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1252),
    [sym_preproc_directive] = ACTIONS(1252),
    [anon_sym_LPAREN2] = ACTIONS(1254),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [anon_sym_DASH] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(1260),
    [anon_sym_STAR] = ACTIONS(1263),
    [anon_sym_AMP_AMP] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(1268),
    [anon_sym_SEMI] = ACTIONS(1444),
    [anon_sym___extension__] = ACTIONS(1447),
    [anon_sym_typedef] = ACTIONS(1450),
    [anon_sym_virtual] = ACTIONS(1280),
    [anon_sym_extern] = ACTIONS(1283),
    [anon_sym___attribute__] = ACTIONS(1286),
    [anon_sym___attribute] = ACTIONS(1286),
    [anon_sym_COLON_COLON] = ACTIONS(1289),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1292),
    [anon_sym___declspec] = ACTIONS(1295),
    [anon_sym___based] = ACTIONS(1252),
    [anon_sym___cdecl] = ACTIONS(1252),
    [anon_sym___clrcall] = ACTIONS(1252),
    [anon_sym___stdcall] = ACTIONS(1252),
    [anon_sym___fastcall] = ACTIONS(1252),
    [anon_sym___thiscall] = ACTIONS(1252),
    [anon_sym___vectorcall] = ACTIONS(1252),
    [anon_sym_LBRACE] = ACTIONS(1453),
    [anon_sym_signed] = ACTIONS(1301),
    [anon_sym_unsigned] = ACTIONS(1301),
    [anon_sym_long] = ACTIONS(1301),
    [anon_sym_short] = ACTIONS(1301),
    [anon_sym_LBRACK] = ACTIONS(1304),
    [anon_sym_static] = ACTIONS(1283),
    [anon_sym_register] = ACTIONS(1283),
    [anon_sym_inline] = ACTIONS(1283),
    [anon_sym___inline] = ACTIONS(1283),
    [anon_sym___inline__] = ACTIONS(1283),
    [anon_sym___forceinline] = ACTIONS(1283),
    [anon_sym_thread_local] = ACTIONS(1283),
    [anon_sym___thread] = ACTIONS(1283),
    [anon_sym_const] = ACTIONS(1307),
    [anon_sym_constexpr] = ACTIONS(1307),
    [anon_sym_volatile] = ACTIONS(1307),
    [anon_sym_restrict] = ACTIONS(1307),
    [anon_sym___restrict__] = ACTIONS(1307),
    [anon_sym__Atomic] = ACTIONS(1307),
    [anon_sym__Noreturn] = ACTIONS(1307),
    [anon_sym_noreturn] = ACTIONS(1307),
    [anon_sym__Nonnull] = ACTIONS(1307),
    [anon_sym_mutable] = ACTIONS(1307),
    [anon_sym_constinit] = ACTIONS(1307),
    [anon_sym_consteval] = ACTIONS(1307),
    [anon_sym_alignas] = ACTIONS(1310),
    [anon_sym__Alignas] = ACTIONS(1310),
    [sym_primitive_type] = ACTIONS(1313),
    [anon_sym_enum] = ACTIONS(1316),
    [anon_sym_class] = ACTIONS(1319),
    [anon_sym_struct] = ACTIONS(1322),
    [anon_sym_union] = ACTIONS(1325),
    [anon_sym_if] = ACTIONS(1456),
    [anon_sym_else] = ACTIONS(1252),
    [anon_sym_switch] = ACTIONS(1459),
    [anon_sym_case] = ACTIONS(1252),
    [anon_sym_default] = ACTIONS(1252),
    [anon_sym_while] = ACTIONS(1462),
    [anon_sym_do] = ACTIONS(1465),
    [anon_sym_for] = ACTIONS(1468),
    [anon_sym_return] = ACTIONS(1471),
    [anon_sym_break] = ACTIONS(1474),
    [anon_sym_continue] = ACTIONS(1477),
    [anon_sym_goto] = ACTIONS(1480),
    [anon_sym___try] = ACTIONS(1483),
    [anon_sym___leave] = ACTIONS(1486),
    [anon_sym_not] = ACTIONS(1260),
    [anon_sym_compl] = ACTIONS(1260),
    [anon_sym_DASH_DASH] = ACTIONS(1361),
    [anon_sym_PLUS_PLUS] = ACTIONS(1361),
    [anon_sym_sizeof] = ACTIONS(1364),
    [anon_sym___alignof__] = ACTIONS(1367),
    [anon_sym___alignof] = ACTIONS(1367),
    [anon_sym__alignof] = ACTIONS(1367),
    [anon_sym_alignof] = ACTIONS(1367),
    [anon_sym__Alignof] = ACTIONS(1367),
    [anon_sym_offsetof] = ACTIONS(1370),
    [anon_sym__Generic] = ACTIONS(1373),
    [anon_sym_asm] = ACTIONS(1376),
    [anon_sym___asm__] = ACTIONS(1376),
    [anon_sym___asm] = ACTIONS(1376),
    [sym_number_literal] = ACTIONS(1379),
    [anon_sym_L_SQUOTE] = ACTIONS(1382),
    [anon_sym_u_SQUOTE] = ACTIONS(1382),
    [anon_sym_U_SQUOTE] = ACTIONS(1382),
    [anon_sym_u8_SQUOTE] = ACTIONS(1382),
    [anon_sym_SQUOTE] = ACTIONS(1382),
    [anon_sym_L_DQUOTE] = ACTIONS(1385),
    [anon_sym_u_DQUOTE] = ACTIONS(1385),
    [anon_sym_U_DQUOTE] = ACTIONS(1385),
    [anon_sym_u8_DQUOTE] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [sym_true] = ACTIONS(1388),
    [sym_false] = ACTIONS(1388),
    [anon_sym_NULL] = ACTIONS(1391),
    [anon_sym_nullptr] = ACTIONS(1391),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1394),
    [anon_sym_decltype] = ACTIONS(1397),
    [anon_sym_explicit] = ACTIONS(1252),
    [anon_sym_typename] = ACTIONS(1400),
    [anon_sym_template] = ACTIONS(1403),
    [anon_sym_operator] = ACTIONS(1252),
    [anon_sym_try] = ACTIONS(1489),
    [anon_sym_delete] = ACTIONS(1409),
    [anon_sym_throw] = ACTIONS(1492),
    [anon_sym_namespace] = ACTIONS(1252),
    [anon_sym_using] = ACTIONS(1252),
    [anon_sym_static_assert] = ACTIONS(1252),
    [anon_sym_concept] = ACTIONS(1252),
    [anon_sym_co_return] = ACTIONS(1495),
    [anon_sym_co_yield] = ACTIONS(1498),
    [anon_sym_R_DQUOTE] = ACTIONS(1421),
    [anon_sym_LR_DQUOTE] = ACTIONS(1421),
    [anon_sym_uR_DQUOTE] = ACTIONS(1421),
    [anon_sym_UR_DQUOTE] = ACTIONS(1421),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1421),
    [anon_sym_co_await] = ACTIONS(1424),
    [anon_sym_new] = ACTIONS(1427),
    [anon_sym_requires] = ACTIONS(1430),
    [sym_this] = ACTIONS(1388),
  },
  [90] = {
    [sym_declaration] = STATE(95),
    [sym_type_definition] = STATE(95),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(5103),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(883),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_compound_statement] = STATE(95),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(95),
    [sym_labeled_statement] = STATE(95),
    [sym_expression_statement] = STATE(95),
    [sym_if_statement] = STATE(95),
    [sym_switch_statement] = STATE(95),
    [sym_while_statement] = STATE(95),
    [sym_do_statement] = STATE(95),
    [sym_for_statement] = STATE(95),
    [sym_return_statement] = STATE(95),
    [sym_break_statement] = STATE(95),
    [sym_continue_statement] = STATE(95),
    [sym_goto_statement] = STATE(95),
    [sym_seh_try_statement] = STATE(95),
    [sym_seh_leave_statement] = STATE(95),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(95),
    [sym_co_return_statement] = STATE(95),
    [sym_co_yield_statement] = STATE(95),
    [sym_throw_statement] = STATE(95),
    [sym_try_statement] = STATE(95),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5601),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_case_statement_repeat1] = STATE(95),
    [sym_identifier] = ACTIONS(1433),
    [aux_sym_preproc_include_token1] = ACTIONS(1245),
    [aux_sym_preproc_def_token1] = ACTIONS(1245),
    [aux_sym_preproc_if_token1] = ACTIONS(1245),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1245),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1245),
    [sym_preproc_directive] = ACTIONS(1245),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1247),
    [anon_sym_AMP] = ACTIONS(1225),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(1435),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(1245),
    [anon_sym___cdecl] = ACTIONS(1245),
    [anon_sym___clrcall] = ACTIONS(1245),
    [anon_sym___stdcall] = ACTIONS(1245),
    [anon_sym___fastcall] = ACTIONS(1245),
    [anon_sym___thiscall] = ACTIONS(1245),
    [anon_sym___vectorcall] = ACTIONS(1245),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_RBRACE] = ACTIONS(1247),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_else] = ACTIONS(1245),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(1245),
    [anon_sym_default] = ACTIONS(1245),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(1245),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_operator] = ACTIONS(1245),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(1245),
    [anon_sym_using] = ACTIONS(1245),
    [anon_sym_static_assert] = ACTIONS(1245),
    [anon_sym_concept] = ACTIONS(1245),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [91] = {
    [sym_declaration] = STATE(98),
    [sym_type_definition] = STATE(98),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(5159),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(883),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_compound_statement] = STATE(98),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(98),
    [sym_labeled_statement] = STATE(98),
    [sym_expression_statement] = STATE(98),
    [sym_if_statement] = STATE(98),
    [sym_switch_statement] = STATE(98),
    [sym_while_statement] = STATE(98),
    [sym_do_statement] = STATE(98),
    [sym_for_statement] = STATE(98),
    [sym_return_statement] = STATE(98),
    [sym_break_statement] = STATE(98),
    [sym_continue_statement] = STATE(98),
    [sym_goto_statement] = STATE(98),
    [sym_seh_try_statement] = STATE(98),
    [sym_seh_leave_statement] = STATE(98),
    [sym_expression] = STATE(4411),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8119),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(98),
    [sym_co_return_statement] = STATE(98),
    [sym_co_yield_statement] = STATE(98),
    [sym_throw_statement] = STATE(98),
    [sym_try_statement] = STATE(98),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5601),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(206),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_case_statement_repeat1] = STATE(98),
    [sym_identifier] = ACTIONS(1437),
    [aux_sym_preproc_include_token1] = ACTIONS(1237),
    [aux_sym_preproc_def_token1] = ACTIONS(1237),
    [aux_sym_preproc_if_token1] = ACTIONS(1237),
    [aux_sym_preproc_if_token2] = ACTIONS(1237),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1237),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1237),
    [sym_preproc_directive] = ACTIONS(1237),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1239),
    [anon_sym_AMP] = ACTIONS(1225),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym___extension__] = ACTIONS(1439),
    [anon_sym_typedef] = ACTIONS(640),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(1237),
    [anon_sym___cdecl] = ACTIONS(1237),
    [anon_sym___clrcall] = ACTIONS(1237),
    [anon_sym___stdcall] = ACTIONS(1237),
    [anon_sym___fastcall] = ACTIONS(1237),
    [anon_sym___thiscall] = ACTIONS(1237),
    [anon_sym___vectorcall] = ACTIONS(1237),
    [anon_sym_LBRACE] = ACTIONS(644),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(648),
    [anon_sym_else] = ACTIONS(1237),
    [anon_sym_switch] = ACTIONS(650),
    [anon_sym_case] = ACTIONS(1237),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_while] = ACTIONS(656),
    [anon_sym_do] = ACTIONS(658),
    [anon_sym_for] = ACTIONS(660),
    [anon_sym_return] = ACTIONS(662),
    [anon_sym_break] = ACTIONS(664),
    [anon_sym_continue] = ACTIONS(666),
    [anon_sym_goto] = ACTIONS(668),
    [anon_sym___try] = ACTIONS(670),
    [anon_sym___leave] = ACTIONS(672),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(1237),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_operator] = ACTIONS(1237),
    [anon_sym_try] = ACTIONS(676),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(678),
    [anon_sym_namespace] = ACTIONS(1237),
    [anon_sym_using] = ACTIONS(1237),
    [anon_sym_static_assert] = ACTIONS(1237),
    [anon_sym_concept] = ACTIONS(1237),
    [anon_sym_co_return] = ACTIONS(688),
    [anon_sym_co_yield] = ACTIONS(690),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [92] = {
    [sym_declaration] = STATE(101),
    [sym_type_definition] = STATE(101),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(5172),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(883),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_compound_statement] = STATE(101),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(101),
    [sym_labeled_statement] = STATE(101),
    [sym_expression_statement] = STATE(101),
    [sym_if_statement] = STATE(101),
    [sym_switch_statement] = STATE(101),
    [sym_while_statement] = STATE(101),
    [sym_do_statement] = STATE(101),
    [sym_for_statement] = STATE(101),
    [sym_return_statement] = STATE(101),
    [sym_break_statement] = STATE(101),
    [sym_continue_statement] = STATE(101),
    [sym_goto_statement] = STATE(101),
    [sym_seh_try_statement] = STATE(101),
    [sym_seh_leave_statement] = STATE(101),
    [sym_expression] = STATE(4373),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8412),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(101),
    [sym_co_return_statement] = STATE(101),
    [sym_co_yield_statement] = STATE(101),
    [sym_throw_statement] = STATE(101),
    [sym_try_statement] = STATE(101),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5601),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(174),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_case_statement_repeat1] = STATE(101),
    [ts_builtin_sym_end] = ACTIONS(1239),
    [sym_identifier] = ACTIONS(1501),
    [aux_sym_preproc_include_token1] = ACTIONS(1237),
    [aux_sym_preproc_def_token1] = ACTIONS(1237),
    [aux_sym_preproc_if_token1] = ACTIONS(1237),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1237),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1237),
    [sym_preproc_directive] = ACTIONS(1237),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1239),
    [anon_sym_AMP] = ACTIONS(1225),
    [anon_sym_SEMI] = ACTIONS(1503),
    [anon_sym___extension__] = ACTIONS(1505),
    [anon_sym_typedef] = ACTIONS(37),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(1237),
    [anon_sym___cdecl] = ACTIONS(1237),
    [anon_sym___clrcall] = ACTIONS(1237),
    [anon_sym___stdcall] = ACTIONS(1237),
    [anon_sym___fastcall] = ACTIONS(1237),
    [anon_sym___thiscall] = ACTIONS(1237),
    [anon_sym___vectorcall] = ACTIONS(1237),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(79),
    [anon_sym_else] = ACTIONS(1237),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(1237),
    [anon_sym_default] = ACTIONS(1237),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(93),
    [anon_sym_break] = ACTIONS(95),
    [anon_sym_continue] = ACTIONS(97),
    [anon_sym_goto] = ACTIONS(99),
    [anon_sym___try] = ACTIONS(1507),
    [anon_sym___leave] = ACTIONS(1509),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(1237),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_operator] = ACTIONS(1237),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(1237),
    [anon_sym_using] = ACTIONS(1237),
    [anon_sym_static_assert] = ACTIONS(1237),
    [anon_sym_concept] = ACTIONS(1237),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [93] = {
    [sym_declaration] = STATE(95),
    [sym_type_definition] = STATE(95),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(5103),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(883),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_compound_statement] = STATE(95),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(95),
    [sym_labeled_statement] = STATE(95),
    [sym_expression_statement] = STATE(95),
    [sym_if_statement] = STATE(95),
    [sym_switch_statement] = STATE(95),
    [sym_while_statement] = STATE(95),
    [sym_do_statement] = STATE(95),
    [sym_for_statement] = STATE(95),
    [sym_return_statement] = STATE(95),
    [sym_break_statement] = STATE(95),
    [sym_continue_statement] = STATE(95),
    [sym_goto_statement] = STATE(95),
    [sym_seh_try_statement] = STATE(95),
    [sym_seh_leave_statement] = STATE(95),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(95),
    [sym_co_return_statement] = STATE(95),
    [sym_co_yield_statement] = STATE(95),
    [sym_throw_statement] = STATE(95),
    [sym_try_statement] = STATE(95),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5601),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_case_statement_repeat1] = STATE(95),
    [sym_identifier] = ACTIONS(1433),
    [aux_sym_preproc_include_token1] = ACTIONS(1241),
    [aux_sym_preproc_def_token1] = ACTIONS(1241),
    [aux_sym_preproc_if_token1] = ACTIONS(1241),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1241),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1241),
    [sym_preproc_directive] = ACTIONS(1241),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1243),
    [anon_sym_AMP] = ACTIONS(1225),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(1435),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(1241),
    [anon_sym___cdecl] = ACTIONS(1241),
    [anon_sym___clrcall] = ACTIONS(1241),
    [anon_sym___stdcall] = ACTIONS(1241),
    [anon_sym___fastcall] = ACTIONS(1241),
    [anon_sym___thiscall] = ACTIONS(1241),
    [anon_sym___vectorcall] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_RBRACE] = ACTIONS(1243),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_else] = ACTIONS(1241),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(1241),
    [anon_sym_default] = ACTIONS(1241),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(1241),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_operator] = ACTIONS(1241),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(1241),
    [anon_sym_using] = ACTIONS(1241),
    [anon_sym_static_assert] = ACTIONS(1241),
    [anon_sym_concept] = ACTIONS(1241),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [94] = {
    [sym_declaration] = STATE(97),
    [sym_type_definition] = STATE(97),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(5159),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(883),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_compound_statement] = STATE(97),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(97),
    [sym_labeled_statement] = STATE(97),
    [sym_expression_statement] = STATE(97),
    [sym_if_statement] = STATE(97),
    [sym_switch_statement] = STATE(97),
    [sym_while_statement] = STATE(97),
    [sym_do_statement] = STATE(97),
    [sym_for_statement] = STATE(97),
    [sym_return_statement] = STATE(97),
    [sym_break_statement] = STATE(97),
    [sym_continue_statement] = STATE(97),
    [sym_goto_statement] = STATE(97),
    [sym_seh_try_statement] = STATE(97),
    [sym_seh_leave_statement] = STATE(97),
    [sym_expression] = STATE(4411),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8119),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(97),
    [sym_co_return_statement] = STATE(97),
    [sym_co_yield_statement] = STATE(97),
    [sym_throw_statement] = STATE(97),
    [sym_try_statement] = STATE(97),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5601),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(206),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_case_statement_repeat1] = STATE(97),
    [sym_identifier] = ACTIONS(1437),
    [aux_sym_preproc_include_token1] = ACTIONS(1245),
    [aux_sym_preproc_def_token1] = ACTIONS(1245),
    [aux_sym_preproc_if_token1] = ACTIONS(1245),
    [aux_sym_preproc_if_token2] = ACTIONS(1245),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1245),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1245),
    [sym_preproc_directive] = ACTIONS(1245),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1247),
    [anon_sym_AMP] = ACTIONS(1225),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym___extension__] = ACTIONS(1439),
    [anon_sym_typedef] = ACTIONS(640),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(1245),
    [anon_sym___cdecl] = ACTIONS(1245),
    [anon_sym___clrcall] = ACTIONS(1245),
    [anon_sym___stdcall] = ACTIONS(1245),
    [anon_sym___fastcall] = ACTIONS(1245),
    [anon_sym___thiscall] = ACTIONS(1245),
    [anon_sym___vectorcall] = ACTIONS(1245),
    [anon_sym_LBRACE] = ACTIONS(644),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(648),
    [anon_sym_else] = ACTIONS(1245),
    [anon_sym_switch] = ACTIONS(650),
    [anon_sym_case] = ACTIONS(1245),
    [anon_sym_default] = ACTIONS(1245),
    [anon_sym_while] = ACTIONS(656),
    [anon_sym_do] = ACTIONS(658),
    [anon_sym_for] = ACTIONS(660),
    [anon_sym_return] = ACTIONS(662),
    [anon_sym_break] = ACTIONS(664),
    [anon_sym_continue] = ACTIONS(666),
    [anon_sym_goto] = ACTIONS(668),
    [anon_sym___try] = ACTIONS(670),
    [anon_sym___leave] = ACTIONS(672),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(1245),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_operator] = ACTIONS(1245),
    [anon_sym_try] = ACTIONS(676),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(678),
    [anon_sym_namespace] = ACTIONS(1245),
    [anon_sym_using] = ACTIONS(1245),
    [anon_sym_static_assert] = ACTIONS(1245),
    [anon_sym_concept] = ACTIONS(1245),
    [anon_sym_co_return] = ACTIONS(688),
    [anon_sym_co_yield] = ACTIONS(690),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [95] = {
    [sym_declaration] = STATE(95),
    [sym_type_definition] = STATE(95),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(5103),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(883),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_compound_statement] = STATE(95),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(95),
    [sym_labeled_statement] = STATE(95),
    [sym_expression_statement] = STATE(95),
    [sym_if_statement] = STATE(95),
    [sym_switch_statement] = STATE(95),
    [sym_while_statement] = STATE(95),
    [sym_do_statement] = STATE(95),
    [sym_for_statement] = STATE(95),
    [sym_return_statement] = STATE(95),
    [sym_break_statement] = STATE(95),
    [sym_continue_statement] = STATE(95),
    [sym_goto_statement] = STATE(95),
    [sym_seh_try_statement] = STATE(95),
    [sym_seh_leave_statement] = STATE(95),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(95),
    [sym_co_return_statement] = STATE(95),
    [sym_co_yield_statement] = STATE(95),
    [sym_throw_statement] = STATE(95),
    [sym_try_statement] = STATE(95),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5601),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_case_statement_repeat1] = STATE(95),
    [sym_identifier] = ACTIONS(1511),
    [aux_sym_preproc_include_token1] = ACTIONS(1252),
    [aux_sym_preproc_def_token1] = ACTIONS(1252),
    [aux_sym_preproc_if_token1] = ACTIONS(1252),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1252),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1252),
    [sym_preproc_directive] = ACTIONS(1252),
    [anon_sym_LPAREN2] = ACTIONS(1254),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [anon_sym_DASH] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(1260),
    [anon_sym_STAR] = ACTIONS(1263),
    [anon_sym_AMP_AMP] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(1268),
    [anon_sym_SEMI] = ACTIONS(1514),
    [anon_sym___extension__] = ACTIONS(1517),
    [anon_sym_typedef] = ACTIONS(1520),
    [anon_sym_virtual] = ACTIONS(1280),
    [anon_sym_extern] = ACTIONS(1283),
    [anon_sym___attribute__] = ACTIONS(1286),
    [anon_sym___attribute] = ACTIONS(1286),
    [anon_sym_COLON_COLON] = ACTIONS(1289),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1292),
    [anon_sym___declspec] = ACTIONS(1295),
    [anon_sym___based] = ACTIONS(1252),
    [anon_sym___cdecl] = ACTIONS(1252),
    [anon_sym___clrcall] = ACTIONS(1252),
    [anon_sym___stdcall] = ACTIONS(1252),
    [anon_sym___fastcall] = ACTIONS(1252),
    [anon_sym___thiscall] = ACTIONS(1252),
    [anon_sym___vectorcall] = ACTIONS(1252),
    [anon_sym_LBRACE] = ACTIONS(1523),
    [anon_sym_RBRACE] = ACTIONS(1266),
    [anon_sym_signed] = ACTIONS(1301),
    [anon_sym_unsigned] = ACTIONS(1301),
    [anon_sym_long] = ACTIONS(1301),
    [anon_sym_short] = ACTIONS(1301),
    [anon_sym_LBRACK] = ACTIONS(1304),
    [anon_sym_static] = ACTIONS(1283),
    [anon_sym_register] = ACTIONS(1283),
    [anon_sym_inline] = ACTIONS(1283),
    [anon_sym___inline] = ACTIONS(1283),
    [anon_sym___inline__] = ACTIONS(1283),
    [anon_sym___forceinline] = ACTIONS(1283),
    [anon_sym_thread_local] = ACTIONS(1283),
    [anon_sym___thread] = ACTIONS(1283),
    [anon_sym_const] = ACTIONS(1307),
    [anon_sym_constexpr] = ACTIONS(1307),
    [anon_sym_volatile] = ACTIONS(1307),
    [anon_sym_restrict] = ACTIONS(1307),
    [anon_sym___restrict__] = ACTIONS(1307),
    [anon_sym__Atomic] = ACTIONS(1307),
    [anon_sym__Noreturn] = ACTIONS(1307),
    [anon_sym_noreturn] = ACTIONS(1307),
    [anon_sym__Nonnull] = ACTIONS(1307),
    [anon_sym_mutable] = ACTIONS(1307),
    [anon_sym_constinit] = ACTIONS(1307),
    [anon_sym_consteval] = ACTIONS(1307),
    [anon_sym_alignas] = ACTIONS(1310),
    [anon_sym__Alignas] = ACTIONS(1310),
    [sym_primitive_type] = ACTIONS(1313),
    [anon_sym_enum] = ACTIONS(1316),
    [anon_sym_class] = ACTIONS(1319),
    [anon_sym_struct] = ACTIONS(1322),
    [anon_sym_union] = ACTIONS(1325),
    [anon_sym_if] = ACTIONS(1526),
    [anon_sym_else] = ACTIONS(1252),
    [anon_sym_switch] = ACTIONS(1529),
    [anon_sym_case] = ACTIONS(1252),
    [anon_sym_default] = ACTIONS(1252),
    [anon_sym_while] = ACTIONS(1532),
    [anon_sym_do] = ACTIONS(1535),
    [anon_sym_for] = ACTIONS(1538),
    [anon_sym_return] = ACTIONS(1541),
    [anon_sym_break] = ACTIONS(1544),
    [anon_sym_continue] = ACTIONS(1547),
    [anon_sym_goto] = ACTIONS(1550),
    [anon_sym___try] = ACTIONS(1553),
    [anon_sym___leave] = ACTIONS(1556),
    [anon_sym_not] = ACTIONS(1260),
    [anon_sym_compl] = ACTIONS(1260),
    [anon_sym_DASH_DASH] = ACTIONS(1361),
    [anon_sym_PLUS_PLUS] = ACTIONS(1361),
    [anon_sym_sizeof] = ACTIONS(1364),
    [anon_sym___alignof__] = ACTIONS(1367),
    [anon_sym___alignof] = ACTIONS(1367),
    [anon_sym__alignof] = ACTIONS(1367),
    [anon_sym_alignof] = ACTIONS(1367),
    [anon_sym__Alignof] = ACTIONS(1367),
    [anon_sym_offsetof] = ACTIONS(1370),
    [anon_sym__Generic] = ACTIONS(1373),
    [anon_sym_asm] = ACTIONS(1376),
    [anon_sym___asm__] = ACTIONS(1376),
    [anon_sym___asm] = ACTIONS(1376),
    [sym_number_literal] = ACTIONS(1379),
    [anon_sym_L_SQUOTE] = ACTIONS(1382),
    [anon_sym_u_SQUOTE] = ACTIONS(1382),
    [anon_sym_U_SQUOTE] = ACTIONS(1382),
    [anon_sym_u8_SQUOTE] = ACTIONS(1382),
    [anon_sym_SQUOTE] = ACTIONS(1382),
    [anon_sym_L_DQUOTE] = ACTIONS(1385),
    [anon_sym_u_DQUOTE] = ACTIONS(1385),
    [anon_sym_U_DQUOTE] = ACTIONS(1385),
    [anon_sym_u8_DQUOTE] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [sym_true] = ACTIONS(1388),
    [sym_false] = ACTIONS(1388),
    [anon_sym_NULL] = ACTIONS(1391),
    [anon_sym_nullptr] = ACTIONS(1391),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1394),
    [anon_sym_decltype] = ACTIONS(1397),
    [anon_sym_explicit] = ACTIONS(1252),
    [anon_sym_typename] = ACTIONS(1400),
    [anon_sym_template] = ACTIONS(1403),
    [anon_sym_operator] = ACTIONS(1252),
    [anon_sym_try] = ACTIONS(1559),
    [anon_sym_delete] = ACTIONS(1409),
    [anon_sym_throw] = ACTIONS(1562),
    [anon_sym_namespace] = ACTIONS(1252),
    [anon_sym_using] = ACTIONS(1252),
    [anon_sym_static_assert] = ACTIONS(1252),
    [anon_sym_concept] = ACTIONS(1252),
    [anon_sym_co_return] = ACTIONS(1565),
    [anon_sym_co_yield] = ACTIONS(1568),
    [anon_sym_R_DQUOTE] = ACTIONS(1421),
    [anon_sym_LR_DQUOTE] = ACTIONS(1421),
    [anon_sym_uR_DQUOTE] = ACTIONS(1421),
    [anon_sym_UR_DQUOTE] = ACTIONS(1421),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1421),
    [anon_sym_co_await] = ACTIONS(1424),
    [anon_sym_new] = ACTIONS(1427),
    [anon_sym_requires] = ACTIONS(1430),
    [sym_this] = ACTIONS(1388),
  },
  [96] = {
    [sym_declaration] = STATE(89),
    [sym_type_definition] = STATE(89),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(5172),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(883),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_compound_statement] = STATE(89),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(89),
    [sym_labeled_statement] = STATE(89),
    [sym_expression_statement] = STATE(89),
    [sym_if_statement] = STATE(89),
    [sym_switch_statement] = STATE(89),
    [sym_while_statement] = STATE(89),
    [sym_do_statement] = STATE(89),
    [sym_for_statement] = STATE(89),
    [sym_return_statement] = STATE(89),
    [sym_break_statement] = STATE(89),
    [sym_continue_statement] = STATE(89),
    [sym_goto_statement] = STATE(89),
    [sym_seh_try_statement] = STATE(89),
    [sym_seh_leave_statement] = STATE(89),
    [sym_expression] = STATE(4373),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8412),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(89),
    [sym_co_return_statement] = STATE(89),
    [sym_co_yield_statement] = STATE(89),
    [sym_throw_statement] = STATE(89),
    [sym_try_statement] = STATE(89),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5601),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(174),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_case_statement_repeat1] = STATE(89),
    [ts_builtin_sym_end] = ACTIONS(1247),
    [sym_identifier] = ACTIONS(1501),
    [aux_sym_preproc_include_token1] = ACTIONS(1245),
    [aux_sym_preproc_def_token1] = ACTIONS(1245),
    [aux_sym_preproc_if_token1] = ACTIONS(1245),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1245),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1245),
    [sym_preproc_directive] = ACTIONS(1245),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1247),
    [anon_sym_AMP] = ACTIONS(1225),
    [anon_sym_SEMI] = ACTIONS(1503),
    [anon_sym___extension__] = ACTIONS(1505),
    [anon_sym_typedef] = ACTIONS(37),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(1245),
    [anon_sym___cdecl] = ACTIONS(1245),
    [anon_sym___clrcall] = ACTIONS(1245),
    [anon_sym___stdcall] = ACTIONS(1245),
    [anon_sym___fastcall] = ACTIONS(1245),
    [anon_sym___thiscall] = ACTIONS(1245),
    [anon_sym___vectorcall] = ACTIONS(1245),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(79),
    [anon_sym_else] = ACTIONS(1245),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(1245),
    [anon_sym_default] = ACTIONS(1245),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(93),
    [anon_sym_break] = ACTIONS(95),
    [anon_sym_continue] = ACTIONS(97),
    [anon_sym_goto] = ACTIONS(99),
    [anon_sym___try] = ACTIONS(1507),
    [anon_sym___leave] = ACTIONS(1509),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(1245),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_operator] = ACTIONS(1245),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(1245),
    [anon_sym_using] = ACTIONS(1245),
    [anon_sym_static_assert] = ACTIONS(1245),
    [anon_sym_concept] = ACTIONS(1245),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [97] = {
    [sym_declaration] = STATE(97),
    [sym_type_definition] = STATE(97),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(5159),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(883),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_compound_statement] = STATE(97),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(97),
    [sym_labeled_statement] = STATE(97),
    [sym_expression_statement] = STATE(97),
    [sym_if_statement] = STATE(97),
    [sym_switch_statement] = STATE(97),
    [sym_while_statement] = STATE(97),
    [sym_do_statement] = STATE(97),
    [sym_for_statement] = STATE(97),
    [sym_return_statement] = STATE(97),
    [sym_break_statement] = STATE(97),
    [sym_continue_statement] = STATE(97),
    [sym_goto_statement] = STATE(97),
    [sym_seh_try_statement] = STATE(97),
    [sym_seh_leave_statement] = STATE(97),
    [sym_expression] = STATE(4411),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8119),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(97),
    [sym_co_return_statement] = STATE(97),
    [sym_co_yield_statement] = STATE(97),
    [sym_throw_statement] = STATE(97),
    [sym_try_statement] = STATE(97),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5601),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(206),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_case_statement_repeat1] = STATE(97),
    [sym_identifier] = ACTIONS(1571),
    [aux_sym_preproc_include_token1] = ACTIONS(1252),
    [aux_sym_preproc_def_token1] = ACTIONS(1252),
    [aux_sym_preproc_if_token1] = ACTIONS(1252),
    [aux_sym_preproc_if_token2] = ACTIONS(1252),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1252),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1252),
    [sym_preproc_directive] = ACTIONS(1252),
    [anon_sym_LPAREN2] = ACTIONS(1254),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [anon_sym_DASH] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(1260),
    [anon_sym_STAR] = ACTIONS(1263),
    [anon_sym_AMP_AMP] = ACTIONS(1266),
    [anon_sym_AMP] = ACTIONS(1268),
    [anon_sym_SEMI] = ACTIONS(1574),
    [anon_sym___extension__] = ACTIONS(1577),
    [anon_sym_typedef] = ACTIONS(1580),
    [anon_sym_virtual] = ACTIONS(1280),
    [anon_sym_extern] = ACTIONS(1283),
    [anon_sym___attribute__] = ACTIONS(1286),
    [anon_sym___attribute] = ACTIONS(1286),
    [anon_sym_COLON_COLON] = ACTIONS(1289),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1292),
    [anon_sym___declspec] = ACTIONS(1295),
    [anon_sym___based] = ACTIONS(1252),
    [anon_sym___cdecl] = ACTIONS(1252),
    [anon_sym___clrcall] = ACTIONS(1252),
    [anon_sym___stdcall] = ACTIONS(1252),
    [anon_sym___fastcall] = ACTIONS(1252),
    [anon_sym___thiscall] = ACTIONS(1252),
    [anon_sym___vectorcall] = ACTIONS(1252),
    [anon_sym_LBRACE] = ACTIONS(1583),
    [anon_sym_signed] = ACTIONS(1301),
    [anon_sym_unsigned] = ACTIONS(1301),
    [anon_sym_long] = ACTIONS(1301),
    [anon_sym_short] = ACTIONS(1301),
    [anon_sym_LBRACK] = ACTIONS(1304),
    [anon_sym_static] = ACTIONS(1283),
    [anon_sym_register] = ACTIONS(1283),
    [anon_sym_inline] = ACTIONS(1283),
    [anon_sym___inline] = ACTIONS(1283),
    [anon_sym___inline__] = ACTIONS(1283),
    [anon_sym___forceinline] = ACTIONS(1283),
    [anon_sym_thread_local] = ACTIONS(1283),
    [anon_sym___thread] = ACTIONS(1283),
    [anon_sym_const] = ACTIONS(1307),
    [anon_sym_constexpr] = ACTIONS(1307),
    [anon_sym_volatile] = ACTIONS(1307),
    [anon_sym_restrict] = ACTIONS(1307),
    [anon_sym___restrict__] = ACTIONS(1307),
    [anon_sym__Atomic] = ACTIONS(1307),
    [anon_sym__Noreturn] = ACTIONS(1307),
    [anon_sym_noreturn] = ACTIONS(1307),
    [anon_sym__Nonnull] = ACTIONS(1307),
    [anon_sym_mutable] = ACTIONS(1307),
    [anon_sym_constinit] = ACTIONS(1307),
    [anon_sym_consteval] = ACTIONS(1307),
    [anon_sym_alignas] = ACTIONS(1310),
    [anon_sym__Alignas] = ACTIONS(1310),
    [sym_primitive_type] = ACTIONS(1313),
    [anon_sym_enum] = ACTIONS(1316),
    [anon_sym_class] = ACTIONS(1319),
    [anon_sym_struct] = ACTIONS(1322),
    [anon_sym_union] = ACTIONS(1325),
    [anon_sym_if] = ACTIONS(1586),
    [anon_sym_else] = ACTIONS(1252),
    [anon_sym_switch] = ACTIONS(1589),
    [anon_sym_case] = ACTIONS(1252),
    [anon_sym_default] = ACTIONS(1252),
    [anon_sym_while] = ACTIONS(1592),
    [anon_sym_do] = ACTIONS(1595),
    [anon_sym_for] = ACTIONS(1598),
    [anon_sym_return] = ACTIONS(1601),
    [anon_sym_break] = ACTIONS(1604),
    [anon_sym_continue] = ACTIONS(1607),
    [anon_sym_goto] = ACTIONS(1610),
    [anon_sym___try] = ACTIONS(1613),
    [anon_sym___leave] = ACTIONS(1616),
    [anon_sym_not] = ACTIONS(1260),
    [anon_sym_compl] = ACTIONS(1260),
    [anon_sym_DASH_DASH] = ACTIONS(1361),
    [anon_sym_PLUS_PLUS] = ACTIONS(1361),
    [anon_sym_sizeof] = ACTIONS(1364),
    [anon_sym___alignof__] = ACTIONS(1367),
    [anon_sym___alignof] = ACTIONS(1367),
    [anon_sym__alignof] = ACTIONS(1367),
    [anon_sym_alignof] = ACTIONS(1367),
    [anon_sym__Alignof] = ACTIONS(1367),
    [anon_sym_offsetof] = ACTIONS(1370),
    [anon_sym__Generic] = ACTIONS(1373),
    [anon_sym_asm] = ACTIONS(1376),
    [anon_sym___asm__] = ACTIONS(1376),
    [anon_sym___asm] = ACTIONS(1376),
    [sym_number_literal] = ACTIONS(1379),
    [anon_sym_L_SQUOTE] = ACTIONS(1382),
    [anon_sym_u_SQUOTE] = ACTIONS(1382),
    [anon_sym_U_SQUOTE] = ACTIONS(1382),
    [anon_sym_u8_SQUOTE] = ACTIONS(1382),
    [anon_sym_SQUOTE] = ACTIONS(1382),
    [anon_sym_L_DQUOTE] = ACTIONS(1385),
    [anon_sym_u_DQUOTE] = ACTIONS(1385),
    [anon_sym_U_DQUOTE] = ACTIONS(1385),
    [anon_sym_u8_DQUOTE] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [sym_true] = ACTIONS(1388),
    [sym_false] = ACTIONS(1388),
    [anon_sym_NULL] = ACTIONS(1391),
    [anon_sym_nullptr] = ACTIONS(1391),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1394),
    [anon_sym_decltype] = ACTIONS(1397),
    [anon_sym_explicit] = ACTIONS(1252),
    [anon_sym_typename] = ACTIONS(1400),
    [anon_sym_template] = ACTIONS(1403),
    [anon_sym_operator] = ACTIONS(1252),
    [anon_sym_try] = ACTIONS(1619),
    [anon_sym_delete] = ACTIONS(1409),
    [anon_sym_throw] = ACTIONS(1622),
    [anon_sym_namespace] = ACTIONS(1252),
    [anon_sym_using] = ACTIONS(1252),
    [anon_sym_static_assert] = ACTIONS(1252),
    [anon_sym_concept] = ACTIONS(1252),
    [anon_sym_co_return] = ACTIONS(1625),
    [anon_sym_co_yield] = ACTIONS(1628),
    [anon_sym_R_DQUOTE] = ACTIONS(1421),
    [anon_sym_LR_DQUOTE] = ACTIONS(1421),
    [anon_sym_uR_DQUOTE] = ACTIONS(1421),
    [anon_sym_UR_DQUOTE] = ACTIONS(1421),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1421),
    [anon_sym_co_await] = ACTIONS(1424),
    [anon_sym_new] = ACTIONS(1427),
    [anon_sym_requires] = ACTIONS(1430),
    [sym_this] = ACTIONS(1388),
  },
  [98] = {
    [sym_declaration] = STATE(97),
    [sym_type_definition] = STATE(97),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(5159),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(883),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_compound_statement] = STATE(97),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(97),
    [sym_labeled_statement] = STATE(97),
    [sym_expression_statement] = STATE(97),
    [sym_if_statement] = STATE(97),
    [sym_switch_statement] = STATE(97),
    [sym_while_statement] = STATE(97),
    [sym_do_statement] = STATE(97),
    [sym_for_statement] = STATE(97),
    [sym_return_statement] = STATE(97),
    [sym_break_statement] = STATE(97),
    [sym_continue_statement] = STATE(97),
    [sym_goto_statement] = STATE(97),
    [sym_seh_try_statement] = STATE(97),
    [sym_seh_leave_statement] = STATE(97),
    [sym_expression] = STATE(4411),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8119),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(97),
    [sym_co_return_statement] = STATE(97),
    [sym_co_yield_statement] = STATE(97),
    [sym_throw_statement] = STATE(97),
    [sym_try_statement] = STATE(97),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5601),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(206),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_case_statement_repeat1] = STATE(97),
    [sym_identifier] = ACTIONS(1437),
    [aux_sym_preproc_include_token1] = ACTIONS(1241),
    [aux_sym_preproc_def_token1] = ACTIONS(1241),
    [aux_sym_preproc_if_token1] = ACTIONS(1241),
    [aux_sym_preproc_if_token2] = ACTIONS(1241),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1241),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1241),
    [sym_preproc_directive] = ACTIONS(1241),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1243),
    [anon_sym_AMP] = ACTIONS(1225),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym___extension__] = ACTIONS(1439),
    [anon_sym_typedef] = ACTIONS(640),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(1241),
    [anon_sym___cdecl] = ACTIONS(1241),
    [anon_sym___clrcall] = ACTIONS(1241),
    [anon_sym___stdcall] = ACTIONS(1241),
    [anon_sym___fastcall] = ACTIONS(1241),
    [anon_sym___thiscall] = ACTIONS(1241),
    [anon_sym___vectorcall] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(644),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(648),
    [anon_sym_else] = ACTIONS(1241),
    [anon_sym_switch] = ACTIONS(650),
    [anon_sym_case] = ACTIONS(1241),
    [anon_sym_default] = ACTIONS(1241),
    [anon_sym_while] = ACTIONS(656),
    [anon_sym_do] = ACTIONS(658),
    [anon_sym_for] = ACTIONS(660),
    [anon_sym_return] = ACTIONS(662),
    [anon_sym_break] = ACTIONS(664),
    [anon_sym_continue] = ACTIONS(666),
    [anon_sym_goto] = ACTIONS(668),
    [anon_sym___try] = ACTIONS(670),
    [anon_sym___leave] = ACTIONS(672),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(1241),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_operator] = ACTIONS(1241),
    [anon_sym_try] = ACTIONS(676),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(678),
    [anon_sym_namespace] = ACTIONS(1241),
    [anon_sym_using] = ACTIONS(1241),
    [anon_sym_static_assert] = ACTIONS(1241),
    [anon_sym_concept] = ACTIONS(1241),
    [anon_sym_co_return] = ACTIONS(688),
    [anon_sym_co_yield] = ACTIONS(690),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [99] = {
    [sym_declaration] = STATE(96),
    [sym_type_definition] = STATE(96),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(5172),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(883),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_compound_statement] = STATE(96),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(96),
    [sym_labeled_statement] = STATE(96),
    [sym_expression_statement] = STATE(96),
    [sym_if_statement] = STATE(96),
    [sym_switch_statement] = STATE(96),
    [sym_while_statement] = STATE(96),
    [sym_do_statement] = STATE(96),
    [sym_for_statement] = STATE(96),
    [sym_return_statement] = STATE(96),
    [sym_break_statement] = STATE(96),
    [sym_continue_statement] = STATE(96),
    [sym_goto_statement] = STATE(96),
    [sym_seh_try_statement] = STATE(96),
    [sym_seh_leave_statement] = STATE(96),
    [sym_expression] = STATE(4373),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8412),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(96),
    [sym_co_return_statement] = STATE(96),
    [sym_co_yield_statement] = STATE(96),
    [sym_throw_statement] = STATE(96),
    [sym_try_statement] = STATE(96),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5601),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(174),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_case_statement_repeat1] = STATE(96),
    [ts_builtin_sym_end] = ACTIONS(1223),
    [sym_identifier] = ACTIONS(1501),
    [aux_sym_preproc_include_token1] = ACTIONS(1217),
    [aux_sym_preproc_def_token1] = ACTIONS(1217),
    [aux_sym_preproc_if_token1] = ACTIONS(1217),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1217),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1217),
    [sym_preproc_directive] = ACTIONS(1217),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1225),
    [anon_sym_SEMI] = ACTIONS(1503),
    [anon_sym___extension__] = ACTIONS(1505),
    [anon_sym_typedef] = ACTIONS(37),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(1217),
    [anon_sym___cdecl] = ACTIONS(1217),
    [anon_sym___clrcall] = ACTIONS(1217),
    [anon_sym___stdcall] = ACTIONS(1217),
    [anon_sym___fastcall] = ACTIONS(1217),
    [anon_sym___thiscall] = ACTIONS(1217),
    [anon_sym___vectorcall] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(79),
    [anon_sym_else] = ACTIONS(1217),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(1217),
    [anon_sym_default] = ACTIONS(1217),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(93),
    [anon_sym_break] = ACTIONS(95),
    [anon_sym_continue] = ACTIONS(97),
    [anon_sym_goto] = ACTIONS(99),
    [anon_sym___try] = ACTIONS(1507),
    [anon_sym___leave] = ACTIONS(1509),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(1217),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_operator] = ACTIONS(1217),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(1217),
    [anon_sym_using] = ACTIONS(1217),
    [anon_sym_static_assert] = ACTIONS(1217),
    [anon_sym_concept] = ACTIONS(1217),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [100] = {
    [sym_declaration] = STATE(90),
    [sym_type_definition] = STATE(90),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(5103),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(883),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_compound_statement] = STATE(90),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(90),
    [sym_labeled_statement] = STATE(90),
    [sym_expression_statement] = STATE(90),
    [sym_if_statement] = STATE(90),
    [sym_switch_statement] = STATE(90),
    [sym_while_statement] = STATE(90),
    [sym_do_statement] = STATE(90),
    [sym_for_statement] = STATE(90),
    [sym_return_statement] = STATE(90),
    [sym_break_statement] = STATE(90),
    [sym_continue_statement] = STATE(90),
    [sym_goto_statement] = STATE(90),
    [sym_seh_try_statement] = STATE(90),
    [sym_seh_leave_statement] = STATE(90),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(90),
    [sym_co_return_statement] = STATE(90),
    [sym_co_yield_statement] = STATE(90),
    [sym_throw_statement] = STATE(90),
    [sym_try_statement] = STATE(90),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5601),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_case_statement_repeat1] = STATE(90),
    [sym_identifier] = ACTIONS(1433),
    [aux_sym_preproc_include_token1] = ACTIONS(1217),
    [aux_sym_preproc_def_token1] = ACTIONS(1217),
    [aux_sym_preproc_if_token1] = ACTIONS(1217),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1217),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1217),
    [sym_preproc_directive] = ACTIONS(1217),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1223),
    [anon_sym_AMP] = ACTIONS(1225),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(1435),
    [anon_sym_typedef] = ACTIONS(179),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(1217),
    [anon_sym___cdecl] = ACTIONS(1217),
    [anon_sym___clrcall] = ACTIONS(1217),
    [anon_sym___stdcall] = ACTIONS(1217),
    [anon_sym___fastcall] = ACTIONS(1217),
    [anon_sym___thiscall] = ACTIONS(1217),
    [anon_sym___vectorcall] = ACTIONS(1217),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_RBRACE] = ACTIONS(1223),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_else] = ACTIONS(1217),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(1217),
    [anon_sym_default] = ACTIONS(1217),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(1217),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_operator] = ACTIONS(1217),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_namespace] = ACTIONS(1217),
    [anon_sym_using] = ACTIONS(1217),
    [anon_sym_static_assert] = ACTIONS(1217),
    [anon_sym_concept] = ACTIONS(1217),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [101] = {
    [sym_declaration] = STATE(89),
    [sym_type_definition] = STATE(89),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(5172),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(883),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_compound_statement] = STATE(89),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(89),
    [sym_labeled_statement] = STATE(89),
    [sym_expression_statement] = STATE(89),
    [sym_if_statement] = STATE(89),
    [sym_switch_statement] = STATE(89),
    [sym_while_statement] = STATE(89),
    [sym_do_statement] = STATE(89),
    [sym_for_statement] = STATE(89),
    [sym_return_statement] = STATE(89),
    [sym_break_statement] = STATE(89),
    [sym_continue_statement] = STATE(89),
    [sym_goto_statement] = STATE(89),
    [sym_seh_try_statement] = STATE(89),
    [sym_seh_leave_statement] = STATE(89),
    [sym_expression] = STATE(4373),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8412),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(89),
    [sym_co_return_statement] = STATE(89),
    [sym_co_yield_statement] = STATE(89),
    [sym_throw_statement] = STATE(89),
    [sym_try_statement] = STATE(89),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5601),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(174),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_case_statement_repeat1] = STATE(89),
    [ts_builtin_sym_end] = ACTIONS(1243),
    [sym_identifier] = ACTIONS(1501),
    [aux_sym_preproc_include_token1] = ACTIONS(1241),
    [aux_sym_preproc_def_token1] = ACTIONS(1241),
    [aux_sym_preproc_if_token1] = ACTIONS(1241),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1241),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1241),
    [sym_preproc_directive] = ACTIONS(1241),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP_AMP] = ACTIONS(1243),
    [anon_sym_AMP] = ACTIONS(1225),
    [anon_sym_SEMI] = ACTIONS(1503),
    [anon_sym___extension__] = ACTIONS(1505),
    [anon_sym_typedef] = ACTIONS(37),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(1241),
    [anon_sym___cdecl] = ACTIONS(1241),
    [anon_sym___clrcall] = ACTIONS(1241),
    [anon_sym___stdcall] = ACTIONS(1241),
    [anon_sym___fastcall] = ACTIONS(1241),
    [anon_sym___thiscall] = ACTIONS(1241),
    [anon_sym___vectorcall] = ACTIONS(1241),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(79),
    [anon_sym_else] = ACTIONS(1241),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(1241),
    [anon_sym_default] = ACTIONS(1241),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(93),
    [anon_sym_break] = ACTIONS(95),
    [anon_sym_continue] = ACTIONS(97),
    [anon_sym_goto] = ACTIONS(99),
    [anon_sym___try] = ACTIONS(1507),
    [anon_sym___leave] = ACTIONS(1509),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(1241),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_operator] = ACTIONS(1241),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(1241),
    [anon_sym_using] = ACTIONS(1241),
    [anon_sym_static_assert] = ACTIONS(1241),
    [anon_sym_concept] = ACTIONS(1241),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [102] = {
    [sym_declaration] = STATE(525),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(5103),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(883),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(462),
    [sym_statement] = STATE(525),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4320),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(7521),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5601),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(1433),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(1631),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(183),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [103] = {
    [sym_declaration] = STATE(109),
    [sym_type_definition] = STATE(109),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(5113),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(883),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_compound_statement] = STATE(109),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(109),
    [sym_labeled_statement] = STATE(109),
    [sym_expression_statement] = STATE(109),
    [sym_if_statement] = STATE(109),
    [sym_switch_statement] = STATE(109),
    [sym_while_statement] = STATE(109),
    [sym_do_statement] = STATE(109),
    [sym_for_statement] = STATE(109),
    [sym_return_statement] = STATE(109),
    [sym_break_statement] = STATE(109),
    [sym_continue_statement] = STATE(109),
    [sym_goto_statement] = STATE(109),
    [sym_seh_try_statement] = STATE(109),
    [sym_seh_leave_statement] = STATE(109),
    [sym_expression] = STATE(4421),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8026),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(109),
    [sym_co_return_statement] = STATE(109),
    [sym_co_yield_statement] = STATE(109),
    [sym_throw_statement] = STATE(109),
    [sym_try_statement] = STATE(109),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5601),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(207),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_case_statement_repeat1] = STATE(109),
    [sym_identifier] = ACTIONS(1633),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1635),
    [anon_sym___extension__] = ACTIONS(1637),
    [anon_sym_typedef] = ACTIONS(1639),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(1643),
    [anon_sym_else] = ACTIONS(1241),
    [anon_sym_switch] = ACTIONS(1645),
    [anon_sym_while] = ACTIONS(1647),
    [anon_sym_do] = ACTIONS(1649),
    [anon_sym_for] = ACTIONS(1651),
    [anon_sym_return] = ACTIONS(1653),
    [anon_sym_break] = ACTIONS(1655),
    [anon_sym_continue] = ACTIONS(1657),
    [anon_sym_goto] = ACTIONS(1659),
    [anon_sym___try] = ACTIONS(1661),
    [anon_sym___leave] = ACTIONS(1663),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(1665),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(1667),
    [anon_sym_co_return] = ACTIONS(1669),
    [anon_sym_co_yield] = ACTIONS(1671),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [104] = {
    [sym_declaration] = STATE(234),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(5139),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(883),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_compound_statement] = STATE(235),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(235),
    [sym_statement] = STATE(234),
    [sym_labeled_statement] = STATE(235),
    [sym_expression_statement] = STATE(235),
    [sym_if_statement] = STATE(235),
    [sym_switch_statement] = STATE(235),
    [sym_case_statement] = STATE(235),
    [sym_while_statement] = STATE(235),
    [sym_do_statement] = STATE(235),
    [sym_for_statement] = STATE(235),
    [sym_return_statement] = STATE(235),
    [sym_break_statement] = STATE(235),
    [sym_continue_statement] = STATE(235),
    [sym_goto_statement] = STATE(235),
    [sym_seh_try_statement] = STATE(235),
    [sym_seh_leave_statement] = STATE(235),
    [sym_expression] = STATE(4387),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8324),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(235),
    [sym_co_return_statement] = STATE(235),
    [sym_co_yield_statement] = STATE(235),
    [sym_throw_statement] = STATE(235),
    [sym_try_statement] = STATE(235),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5601),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(197),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(1215),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(1631),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [105] = {
    [sym_declaration] = STATE(877),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(5113),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(883),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_compound_statement] = STATE(874),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(874),
    [sym_statement] = STATE(877),
    [sym_labeled_statement] = STATE(874),
    [sym_expression_statement] = STATE(874),
    [sym_if_statement] = STATE(874),
    [sym_switch_statement] = STATE(874),
    [sym_case_statement] = STATE(874),
    [sym_while_statement] = STATE(874),
    [sym_do_statement] = STATE(874),
    [sym_for_statement] = STATE(874),
    [sym_return_statement] = STATE(874),
    [sym_break_statement] = STATE(874),
    [sym_continue_statement] = STATE(874),
    [sym_goto_statement] = STATE(874),
    [sym_seh_try_statement] = STATE(874),
    [sym_seh_leave_statement] = STATE(874),
    [sym_expression] = STATE(4421),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8026),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(874),
    [sym_co_return_statement] = STATE(874),
    [sym_co_yield_statement] = STATE(874),
    [sym_throw_statement] = STATE(874),
    [sym_try_statement] = STATE(874),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5601),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(207),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(1633),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1635),
    [anon_sym___extension__] = ACTIONS(1631),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(1643),
    [anon_sym_switch] = ACTIONS(1645),
    [anon_sym_case] = ACTIONS(1673),
    [anon_sym_default] = ACTIONS(1675),
    [anon_sym_while] = ACTIONS(1647),
    [anon_sym_do] = ACTIONS(1649),
    [anon_sym_for] = ACTIONS(1651),
    [anon_sym_return] = ACTIONS(1653),
    [anon_sym_break] = ACTIONS(1655),
    [anon_sym_continue] = ACTIONS(1657),
    [anon_sym_goto] = ACTIONS(1659),
    [anon_sym___try] = ACTIONS(1661),
    [anon_sym___leave] = ACTIONS(1663),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(1665),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(1667),
    [anon_sym_co_return] = ACTIONS(1669),
    [anon_sym_co_yield] = ACTIONS(1671),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [106] = {
    [sym_declaration] = STATE(529),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(5172),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(883),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(462),
    [sym_statement] = STATE(529),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5601),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(187),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(1677),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(1631),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(1679),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(1673),
    [anon_sym_default] = ACTIONS(1675),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_for] = ACTIONS(1683),
    [anon_sym_return] = ACTIONS(93),
    [anon_sym_break] = ACTIONS(95),
    [anon_sym_continue] = ACTIONS(97),
    [anon_sym_goto] = ACTIONS(99),
    [anon_sym___try] = ACTIONS(1685),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [107] = {
    [sym_declaration] = STATE(504),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(5159),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(883),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_compound_statement] = STATE(482),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(482),
    [sym_statement] = STATE(504),
    [sym_labeled_statement] = STATE(482),
    [sym_expression_statement] = STATE(482),
    [sym_if_statement] = STATE(482),
    [sym_switch_statement] = STATE(482),
    [sym_case_statement] = STATE(482),
    [sym_while_statement] = STATE(482),
    [sym_do_statement] = STATE(482),
    [sym_for_statement] = STATE(482),
    [sym_return_statement] = STATE(482),
    [sym_break_statement] = STATE(482),
    [sym_continue_statement] = STATE(482),
    [sym_goto_statement] = STATE(482),
    [sym_seh_try_statement] = STATE(482),
    [sym_seh_leave_statement] = STATE(482),
    [sym_expression] = STATE(4411),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8119),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(482),
    [sym_co_return_statement] = STATE(482),
    [sym_co_yield_statement] = STATE(482),
    [sym_throw_statement] = STATE(482),
    [sym_try_statement] = STATE(482),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5601),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(206),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(1437),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym___extension__] = ACTIONS(1631),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(644),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(648),
    [anon_sym_switch] = ACTIONS(650),
    [anon_sym_case] = ACTIONS(652),
    [anon_sym_default] = ACTIONS(654),
    [anon_sym_while] = ACTIONS(656),
    [anon_sym_do] = ACTIONS(658),
    [anon_sym_for] = ACTIONS(660),
    [anon_sym_return] = ACTIONS(662),
    [anon_sym_break] = ACTIONS(664),
    [anon_sym_continue] = ACTIONS(666),
    [anon_sym_goto] = ACTIONS(668),
    [anon_sym___try] = ACTIONS(670),
    [anon_sym___leave] = ACTIONS(672),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(676),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(678),
    [anon_sym_co_return] = ACTIONS(688),
    [anon_sym_co_yield] = ACTIONS(690),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [108] = {
    [sym_declaration] = STATE(525),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(5103),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(883),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_compound_statement] = STATE(462),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(462),
    [sym_statement] = STATE(525),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5601),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(1433),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(1631),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [109] = {
    [sym_declaration] = STATE(109),
    [sym_type_definition] = STATE(109),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(5113),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(883),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_compound_statement] = STATE(109),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(109),
    [sym_labeled_statement] = STATE(109),
    [sym_expression_statement] = STATE(109),
    [sym_if_statement] = STATE(109),
    [sym_switch_statement] = STATE(109),
    [sym_while_statement] = STATE(109),
    [sym_do_statement] = STATE(109),
    [sym_for_statement] = STATE(109),
    [sym_return_statement] = STATE(109),
    [sym_break_statement] = STATE(109),
    [sym_continue_statement] = STATE(109),
    [sym_goto_statement] = STATE(109),
    [sym_seh_try_statement] = STATE(109),
    [sym_seh_leave_statement] = STATE(109),
    [sym_expression] = STATE(4421),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8026),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(109),
    [sym_co_return_statement] = STATE(109),
    [sym_co_yield_statement] = STATE(109),
    [sym_throw_statement] = STATE(109),
    [sym_try_statement] = STATE(109),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5601),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(207),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_case_statement_repeat1] = STATE(109),
    [sym_identifier] = ACTIONS(1687),
    [anon_sym_LPAREN2] = ACTIONS(1254),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_TILDE] = ACTIONS(1257),
    [anon_sym_DASH] = ACTIONS(1260),
    [anon_sym_PLUS] = ACTIONS(1260),
    [anon_sym_STAR] = ACTIONS(1263),
    [anon_sym_AMP] = ACTIONS(1263),
    [anon_sym_SEMI] = ACTIONS(1690),
    [anon_sym___extension__] = ACTIONS(1693),
    [anon_sym_typedef] = ACTIONS(1696),
    [anon_sym_virtual] = ACTIONS(1280),
    [anon_sym_extern] = ACTIONS(1283),
    [anon_sym___attribute__] = ACTIONS(1286),
    [anon_sym___attribute] = ACTIONS(1286),
    [anon_sym_COLON_COLON] = ACTIONS(1289),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1292),
    [anon_sym___declspec] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(1699),
    [anon_sym_signed] = ACTIONS(1301),
    [anon_sym_unsigned] = ACTIONS(1301),
    [anon_sym_long] = ACTIONS(1301),
    [anon_sym_short] = ACTIONS(1301),
    [anon_sym_LBRACK] = ACTIONS(1304),
    [anon_sym_static] = ACTIONS(1283),
    [anon_sym_register] = ACTIONS(1283),
    [anon_sym_inline] = ACTIONS(1283),
    [anon_sym___inline] = ACTIONS(1283),
    [anon_sym___inline__] = ACTIONS(1283),
    [anon_sym___forceinline] = ACTIONS(1283),
    [anon_sym_thread_local] = ACTIONS(1283),
    [anon_sym___thread] = ACTIONS(1283),
    [anon_sym_const] = ACTIONS(1307),
    [anon_sym_constexpr] = ACTIONS(1307),
    [anon_sym_volatile] = ACTIONS(1307),
    [anon_sym_restrict] = ACTIONS(1307),
    [anon_sym___restrict__] = ACTIONS(1307),
    [anon_sym__Atomic] = ACTIONS(1307),
    [anon_sym__Noreturn] = ACTIONS(1307),
    [anon_sym_noreturn] = ACTIONS(1307),
    [anon_sym__Nonnull] = ACTIONS(1307),
    [anon_sym_mutable] = ACTIONS(1307),
    [anon_sym_constinit] = ACTIONS(1307),
    [anon_sym_consteval] = ACTIONS(1307),
    [anon_sym_alignas] = ACTIONS(1310),
    [anon_sym__Alignas] = ACTIONS(1310),
    [sym_primitive_type] = ACTIONS(1313),
    [anon_sym_enum] = ACTIONS(1316),
    [anon_sym_class] = ACTIONS(1319),
    [anon_sym_struct] = ACTIONS(1322),
    [anon_sym_union] = ACTIONS(1325),
    [anon_sym_if] = ACTIONS(1702),
    [anon_sym_else] = ACTIONS(1252),
    [anon_sym_switch] = ACTIONS(1705),
    [anon_sym_while] = ACTIONS(1708),
    [anon_sym_do] = ACTIONS(1711),
    [anon_sym_for] = ACTIONS(1714),
    [anon_sym_return] = ACTIONS(1717),
    [anon_sym_break] = ACTIONS(1720),
    [anon_sym_continue] = ACTIONS(1723),
    [anon_sym_goto] = ACTIONS(1726),
    [anon_sym___try] = ACTIONS(1729),
    [anon_sym___leave] = ACTIONS(1732),
    [anon_sym_not] = ACTIONS(1260),
    [anon_sym_compl] = ACTIONS(1260),
    [anon_sym_DASH_DASH] = ACTIONS(1361),
    [anon_sym_PLUS_PLUS] = ACTIONS(1361),
    [anon_sym_sizeof] = ACTIONS(1364),
    [anon_sym___alignof__] = ACTIONS(1367),
    [anon_sym___alignof] = ACTIONS(1367),
    [anon_sym__alignof] = ACTIONS(1367),
    [anon_sym_alignof] = ACTIONS(1367),
    [anon_sym__Alignof] = ACTIONS(1367),
    [anon_sym_offsetof] = ACTIONS(1370),
    [anon_sym__Generic] = ACTIONS(1373),
    [anon_sym_asm] = ACTIONS(1376),
    [anon_sym___asm__] = ACTIONS(1376),
    [anon_sym___asm] = ACTIONS(1376),
    [sym_number_literal] = ACTIONS(1379),
    [anon_sym_L_SQUOTE] = ACTIONS(1382),
    [anon_sym_u_SQUOTE] = ACTIONS(1382),
    [anon_sym_U_SQUOTE] = ACTIONS(1382),
    [anon_sym_u8_SQUOTE] = ACTIONS(1382),
    [anon_sym_SQUOTE] = ACTIONS(1382),
    [anon_sym_L_DQUOTE] = ACTIONS(1385),
    [anon_sym_u_DQUOTE] = ACTIONS(1385),
    [anon_sym_U_DQUOTE] = ACTIONS(1385),
    [anon_sym_u8_DQUOTE] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(1385),
    [sym_true] = ACTIONS(1388),
    [sym_false] = ACTIONS(1388),
    [anon_sym_NULL] = ACTIONS(1391),
    [anon_sym_nullptr] = ACTIONS(1391),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1394),
    [anon_sym_decltype] = ACTIONS(1397),
    [anon_sym_typename] = ACTIONS(1400),
    [anon_sym_template] = ACTIONS(1403),
    [anon_sym_try] = ACTIONS(1735),
    [anon_sym_delete] = ACTIONS(1409),
    [anon_sym_throw] = ACTIONS(1738),
    [anon_sym_co_return] = ACTIONS(1741),
    [anon_sym_co_yield] = ACTIONS(1744),
    [anon_sym_R_DQUOTE] = ACTIONS(1421),
    [anon_sym_LR_DQUOTE] = ACTIONS(1421),
    [anon_sym_uR_DQUOTE] = ACTIONS(1421),
    [anon_sym_UR_DQUOTE] = ACTIONS(1421),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1421),
    [anon_sym_co_await] = ACTIONS(1424),
    [anon_sym_new] = ACTIONS(1427),
    [anon_sym_requires] = ACTIONS(1430),
    [sym_this] = ACTIONS(1388),
  },
  [110] = {
    [sym_declaration] = STATE(103),
    [sym_type_definition] = STATE(103),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(5113),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(883),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_compound_statement] = STATE(103),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(103),
    [sym_labeled_statement] = STATE(103),
    [sym_expression_statement] = STATE(103),
    [sym_if_statement] = STATE(103),
    [sym_switch_statement] = STATE(103),
    [sym_while_statement] = STATE(103),
    [sym_do_statement] = STATE(103),
    [sym_for_statement] = STATE(103),
    [sym_return_statement] = STATE(103),
    [sym_break_statement] = STATE(103),
    [sym_continue_statement] = STATE(103),
    [sym_goto_statement] = STATE(103),
    [sym_seh_try_statement] = STATE(103),
    [sym_seh_leave_statement] = STATE(103),
    [sym_expression] = STATE(4421),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8026),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(103),
    [sym_co_return_statement] = STATE(103),
    [sym_co_yield_statement] = STATE(103),
    [sym_throw_statement] = STATE(103),
    [sym_try_statement] = STATE(103),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5601),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(207),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_case_statement_repeat1] = STATE(103),
    [sym_identifier] = ACTIONS(1633),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1635),
    [anon_sym___extension__] = ACTIONS(1637),
    [anon_sym_typedef] = ACTIONS(1639),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(1643),
    [anon_sym_else] = ACTIONS(1237),
    [anon_sym_switch] = ACTIONS(1645),
    [anon_sym_while] = ACTIONS(1647),
    [anon_sym_do] = ACTIONS(1649),
    [anon_sym_for] = ACTIONS(1651),
    [anon_sym_return] = ACTIONS(1653),
    [anon_sym_break] = ACTIONS(1655),
    [anon_sym_continue] = ACTIONS(1657),
    [anon_sym_goto] = ACTIONS(1659),
    [anon_sym___try] = ACTIONS(1661),
    [anon_sym___leave] = ACTIONS(1663),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(1665),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(1667),
    [anon_sym_co_return] = ACTIONS(1669),
    [anon_sym_co_yield] = ACTIONS(1671),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [111] = {
    [sym_declaration] = STATE(529),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(5172),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(883),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_compound_statement] = STATE(500),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(500),
    [sym_statement] = STATE(529),
    [sym_labeled_statement] = STATE(500),
    [sym_expression_statement] = STATE(500),
    [sym_if_statement] = STATE(500),
    [sym_switch_statement] = STATE(500),
    [sym_case_statement] = STATE(500),
    [sym_while_statement] = STATE(500),
    [sym_do_statement] = STATE(500),
    [sym_for_statement] = STATE(500),
    [sym_return_statement] = STATE(500),
    [sym_break_statement] = STATE(500),
    [sym_continue_statement] = STATE(500),
    [sym_goto_statement] = STATE(500),
    [sym_seh_try_statement] = STATE(500),
    [sym_seh_leave_statement] = STATE(500),
    [sym_expression] = STATE(4373),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8412),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(500),
    [sym_co_return_statement] = STATE(500),
    [sym_co_yield_statement] = STATE(500),
    [sym_throw_statement] = STATE(500),
    [sym_try_statement] = STATE(500),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5601),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(174),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(1501),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1503),
    [anon_sym___extension__] = ACTIONS(1631),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_default] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(93),
    [anon_sym_break] = ACTIONS(95),
    [anon_sym_continue] = ACTIONS(97),
    [anon_sym_goto] = ACTIONS(99),
    [anon_sym___try] = ACTIONS(1507),
    [anon_sym___leave] = ACTIONS(1509),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [112] = {
    [sym_declaration] = STATE(109),
    [sym_type_definition] = STATE(109),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(5113),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(883),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_compound_statement] = STATE(109),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(109),
    [sym_labeled_statement] = STATE(109),
    [sym_expression_statement] = STATE(109),
    [sym_if_statement] = STATE(109),
    [sym_switch_statement] = STATE(109),
    [sym_while_statement] = STATE(109),
    [sym_do_statement] = STATE(109),
    [sym_for_statement] = STATE(109),
    [sym_return_statement] = STATE(109),
    [sym_break_statement] = STATE(109),
    [sym_continue_statement] = STATE(109),
    [sym_goto_statement] = STATE(109),
    [sym_seh_try_statement] = STATE(109),
    [sym_seh_leave_statement] = STATE(109),
    [sym_expression] = STATE(4421),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8026),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(109),
    [sym_co_return_statement] = STATE(109),
    [sym_co_yield_statement] = STATE(109),
    [sym_throw_statement] = STATE(109),
    [sym_try_statement] = STATE(109),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5601),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(207),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_case_statement_repeat1] = STATE(109),
    [sym_identifier] = ACTIONS(1633),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1635),
    [anon_sym___extension__] = ACTIONS(1637),
    [anon_sym_typedef] = ACTIONS(1639),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(1643),
    [anon_sym_else] = ACTIONS(1245),
    [anon_sym_switch] = ACTIONS(1645),
    [anon_sym_while] = ACTIONS(1647),
    [anon_sym_do] = ACTIONS(1649),
    [anon_sym_for] = ACTIONS(1651),
    [anon_sym_return] = ACTIONS(1653),
    [anon_sym_break] = ACTIONS(1655),
    [anon_sym_continue] = ACTIONS(1657),
    [anon_sym_goto] = ACTIONS(1659),
    [anon_sym___try] = ACTIONS(1661),
    [anon_sym___leave] = ACTIONS(1663),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(1665),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(1667),
    [anon_sym_co_return] = ACTIONS(1669),
    [anon_sym_co_yield] = ACTIONS(1671),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [113] = {
    [sym_declaration] = STATE(112),
    [sym_type_definition] = STATE(112),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(5113),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(883),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_compound_statement] = STATE(112),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_attributed_statement] = STATE(112),
    [sym_labeled_statement] = STATE(112),
    [sym_expression_statement] = STATE(112),
    [sym_if_statement] = STATE(112),
    [sym_switch_statement] = STATE(112),
    [sym_while_statement] = STATE(112),
    [sym_do_statement] = STATE(112),
    [sym_for_statement] = STATE(112),
    [sym_return_statement] = STATE(112),
    [sym_break_statement] = STATE(112),
    [sym_continue_statement] = STATE(112),
    [sym_goto_statement] = STATE(112),
    [sym_seh_try_statement] = STATE(112),
    [sym_seh_leave_statement] = STATE(112),
    [sym_expression] = STATE(4421),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8026),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(112),
    [sym_co_return_statement] = STATE(112),
    [sym_co_yield_statement] = STATE(112),
    [sym_throw_statement] = STATE(112),
    [sym_try_statement] = STATE(112),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5601),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_attributed_declarator_repeat1] = STATE(207),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_case_statement_repeat1] = STATE(112),
    [sym_identifier] = ACTIONS(1633),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1635),
    [anon_sym___extension__] = ACTIONS(1637),
    [anon_sym_typedef] = ACTIONS(1639),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_if] = ACTIONS(1643),
    [anon_sym_else] = ACTIONS(1217),
    [anon_sym_switch] = ACTIONS(1645),
    [anon_sym_while] = ACTIONS(1647),
    [anon_sym_do] = ACTIONS(1649),
    [anon_sym_for] = ACTIONS(1651),
    [anon_sym_return] = ACTIONS(1653),
    [anon_sym_break] = ACTIONS(1655),
    [anon_sym_continue] = ACTIONS(1657),
    [anon_sym_goto] = ACTIONS(1659),
    [anon_sym___try] = ACTIONS(1661),
    [anon_sym___leave] = ACTIONS(1663),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(1665),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(1667),
    [anon_sym_co_return] = ACTIONS(1669),
    [anon_sym_co_yield] = ACTIONS(1671),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [114] = {
    [sym_declaration] = STATE(284),
    [sym_type_definition] = STATE(4018),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(5174),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(2033),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_expression_statement] = STATE(4018),
    [sym__for_statement_body] = STATE(8346),
    [sym_expression] = STATE(4525),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8364),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(3840),
    [sym_alias_declaration] = STATE(4018),
    [sym__for_range_loop_body] = STATE(8384),
    [sym_init_statement] = STATE(1888),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5601),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(1747),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1749),
    [anon_sym___extension__] = ACTIONS(1751),
    [anon_sym_typedef] = ACTIONS(1753),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(1757),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [115] = {
    [sym_declaration] = STATE(284),
    [sym_type_definition] = STATE(4018),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(5174),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(2033),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_expression_statement] = STATE(4018),
    [sym__for_statement_body] = STATE(7871),
    [sym_expression] = STATE(4525),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8364),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(3840),
    [sym_alias_declaration] = STATE(4018),
    [sym__for_range_loop_body] = STATE(7903),
    [sym_init_statement] = STATE(1888),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5601),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(1747),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1749),
    [anon_sym___extension__] = ACTIONS(1751),
    [anon_sym_typedef] = ACTIONS(1753),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(1757),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [116] = {
    [sym_declaration] = STATE(284),
    [sym_type_definition] = STATE(4018),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(5174),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(2033),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_expression_statement] = STATE(4018),
    [sym__for_statement_body] = STATE(8137),
    [sym_expression] = STATE(4525),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8364),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(3840),
    [sym_alias_declaration] = STATE(4018),
    [sym__for_range_loop_body] = STATE(8139),
    [sym_init_statement] = STATE(1888),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5601),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(1747),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1749),
    [anon_sym___extension__] = ACTIONS(1751),
    [anon_sym_typedef] = ACTIONS(1753),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(1757),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [117] = {
    [sym_declaration] = STATE(284),
    [sym_type_definition] = STATE(4018),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(5174),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(2033),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_expression_statement] = STATE(4018),
    [sym__for_statement_body] = STATE(8509),
    [sym_expression] = STATE(4525),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8364),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(3840),
    [sym_alias_declaration] = STATE(4018),
    [sym__for_range_loop_body] = STATE(8520),
    [sym_init_statement] = STATE(1888),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5601),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(1747),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1749),
    [anon_sym___extension__] = ACTIONS(1751),
    [anon_sym_typedef] = ACTIONS(1753),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(1757),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [118] = {
    [sym_declaration] = STATE(284),
    [sym_type_definition] = STATE(4018),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(5174),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(2033),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_expression_statement] = STATE(4018),
    [sym__for_statement_body] = STATE(8461),
    [sym_expression] = STATE(4525),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8364),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(3840),
    [sym_alias_declaration] = STATE(4018),
    [sym__for_range_loop_body] = STATE(8465),
    [sym_init_statement] = STATE(1888),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5601),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(1747),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1749),
    [anon_sym___extension__] = ACTIONS(1751),
    [anon_sym_typedef] = ACTIONS(1753),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(1757),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [119] = {
    [sym_declaration] = STATE(284),
    [sym_type_definition] = STATE(4018),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(5174),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(2033),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_expression_statement] = STATE(4018),
    [sym__for_statement_body] = STATE(7857),
    [sym_expression] = STATE(4525),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8364),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(3840),
    [sym_alias_declaration] = STATE(4018),
    [sym__for_range_loop_body] = STATE(7858),
    [sym_init_statement] = STATE(1888),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5601),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(1747),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1749),
    [anon_sym___extension__] = ACTIONS(1751),
    [anon_sym_typedef] = ACTIONS(1753),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(1757),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [120] = {
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(5218),
    [sym__declarator] = STATE(6536),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(5896),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(8507),
    [sym_type_qualifier] = STATE(3854),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4605),
    [sym_sized_type_specifier] = STATE(1810),
    [sym_enum_specifier] = STATE(1810),
    [sym_struct_specifier] = STATE(1810),
    [sym_union_specifier] = STATE(1810),
    [sym_expression] = STATE(2923),
    [sym__string] = STATE(3173),
    [sym_comma_expression] = STATE(8507),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_type_descriptor] = STATE(8029),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_placeholder_type_specifier] = STATE(1810),
    [sym_decltype_auto] = STATE(1804),
    [sym_decltype] = STATE(1755),
    [sym_class_specifier] = STATE(1810),
    [sym__class_name] = STATE(7687),
    [sym_dependent_type] = STATE(1810),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(3182),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym__unary_left_fold] = STATE(8348),
    [sym__unary_right_fold] = STATE(8278),
    [sym__binary_fold] = STATE(8484),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5551),
    [sym_qualified_identifier] = STATE(3215),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym__assignment_expression_lhs] = STATE(8151),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3443),
    [aux_sym__type_definition_type_repeat1] = STATE(3854),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(1759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(1763),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1767),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1771),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(1773),
    [anon_sym___extension__] = ACTIONS(1775),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(1779),
    [anon_sym___clrcall] = ACTIONS(1779),
    [anon_sym___stdcall] = ACTIONS(1779),
    [anon_sym___fastcall] = ACTIONS(1779),
    [anon_sym___thiscall] = ACTIONS(1779),
    [anon_sym___vectorcall] = ACTIONS(1779),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(1781),
    [anon_sym_unsigned] = ACTIONS(1781),
    [anon_sym_long] = ACTIONS(1781),
    [anon_sym_short] = ACTIONS(1781),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(1785),
    [anon_sym_enum] = ACTIONS(1787),
    [anon_sym_class] = ACTIONS(1789),
    [anon_sym_struct] = ACTIONS(1791),
    [anon_sym_union] = ACTIONS(1793),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1817),
    [anon_sym_decltype] = ACTIONS(1819),
    [anon_sym_typename] = ACTIONS(1821),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_operator] = ACTIONS(1823),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [121] = {
    [sym_declaration] = STATE(1513),
    [sym_type_definition] = STATE(1513),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(5166),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(2033),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_expression_statement] = STATE(1513),
    [sym_expression] = STATE(4349),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(7653),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(3840),
    [sym_alias_declaration] = STATE(1513),
    [sym_init_statement] = STATE(131),
    [sym_condition_declaration] = STATE(8174),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5601),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(1747),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1635),
    [anon_sym___extension__] = ACTIONS(1637),
    [anon_sym_typedef] = ACTIONS(1639),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(1835),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [122] = {
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(5218),
    [sym__declarator] = STATE(6536),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(5896),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(8511),
    [sym_type_qualifier] = STATE(3854),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4605),
    [sym_sized_type_specifier] = STATE(1810),
    [sym_enum_specifier] = STATE(1810),
    [sym_struct_specifier] = STATE(1810),
    [sym_union_specifier] = STATE(1810),
    [sym_expression] = STATE(2893),
    [sym__string] = STATE(3173),
    [sym_comma_expression] = STATE(8511),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_type_descriptor] = STATE(8556),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_placeholder_type_specifier] = STATE(1810),
    [sym_decltype_auto] = STATE(1804),
    [sym_decltype] = STATE(1755),
    [sym_class_specifier] = STATE(1810),
    [sym__class_name] = STATE(7687),
    [sym_dependent_type] = STATE(1810),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(3182),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym__unary_left_fold] = STATE(8566),
    [sym__unary_right_fold] = STATE(8127),
    [sym__binary_fold] = STATE(8332),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5551),
    [sym_qualified_identifier] = STATE(3215),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym__assignment_expression_lhs] = STATE(8294),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3443),
    [aux_sym__type_definition_type_repeat1] = STATE(3854),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(1759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(1763),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1767),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1771),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(1773),
    [anon_sym___extension__] = ACTIONS(1775),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(1779),
    [anon_sym___clrcall] = ACTIONS(1779),
    [anon_sym___stdcall] = ACTIONS(1779),
    [anon_sym___fastcall] = ACTIONS(1779),
    [anon_sym___thiscall] = ACTIONS(1779),
    [anon_sym___vectorcall] = ACTIONS(1779),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(1781),
    [anon_sym_unsigned] = ACTIONS(1781),
    [anon_sym_long] = ACTIONS(1781),
    [anon_sym_short] = ACTIONS(1781),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(1785),
    [anon_sym_enum] = ACTIONS(1787),
    [anon_sym_class] = ACTIONS(1789),
    [anon_sym_struct] = ACTIONS(1791),
    [anon_sym_union] = ACTIONS(1793),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1817),
    [anon_sym_decltype] = ACTIONS(1819),
    [anon_sym_typename] = ACTIONS(1821),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_operator] = ACTIONS(1823),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [123] = {
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(5218),
    [sym__declarator] = STATE(6536),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(5896),
    [sym_array_declarator] = STATE(5896),
    [sym_compound_statement] = STATE(8507),
    [sym_type_qualifier] = STATE(3854),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4605),
    [sym_sized_type_specifier] = STATE(1810),
    [sym_enum_specifier] = STATE(1810),
    [sym_struct_specifier] = STATE(1810),
    [sym_union_specifier] = STATE(1810),
    [sym_expression] = STATE(2923),
    [sym__string] = STATE(3173),
    [sym_comma_expression] = STATE(8507),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_type_descriptor] = STATE(8073),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_placeholder_type_specifier] = STATE(1810),
    [sym_decltype_auto] = STATE(1804),
    [sym_decltype] = STATE(1755),
    [sym_class_specifier] = STATE(1810),
    [sym__class_name] = STATE(7687),
    [sym_dependent_type] = STATE(1810),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(3182),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym__unary_left_fold] = STATE(8079),
    [sym__unary_right_fold] = STATE(8083),
    [sym__binary_fold] = STATE(8110),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5551),
    [sym_qualified_identifier] = STATE(3215),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym__assignment_expression_lhs] = STATE(8151),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3443),
    [aux_sym__type_definition_type_repeat1] = STATE(3854),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(1759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(1763),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1767),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1771),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(1773),
    [anon_sym___extension__] = ACTIONS(1775),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(1779),
    [anon_sym___clrcall] = ACTIONS(1779),
    [anon_sym___stdcall] = ACTIONS(1779),
    [anon_sym___fastcall] = ACTIONS(1779),
    [anon_sym___thiscall] = ACTIONS(1779),
    [anon_sym___vectorcall] = ACTIONS(1779),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(1781),
    [anon_sym_unsigned] = ACTIONS(1781),
    [anon_sym_long] = ACTIONS(1781),
    [anon_sym_short] = ACTIONS(1781),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(1785),
    [anon_sym_enum] = ACTIONS(1787),
    [anon_sym_class] = ACTIONS(1789),
    [anon_sym_struct] = ACTIONS(1791),
    [anon_sym_union] = ACTIONS(1793),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1817),
    [anon_sym_decltype] = ACTIONS(1819),
    [anon_sym_typename] = ACTIONS(1821),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_operator] = ACTIONS(1823),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [124] = {
    [sym__declaration_modifiers] = STATE(2045),
    [sym__declaration_specifiers] = STATE(3895),
    [sym_attribute_specifier] = STATE(2045),
    [sym_attribute_declaration] = STATE(2045),
    [sym_ms_declspec_modifier] = STATE(2045),
    [sym_storage_class_specifier] = STATE(2045),
    [sym_type_qualifier] = STATE(2045),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_parameter_declaration] = STATE(7330),
    [sym_expression] = STATE(3204),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7485),
    [sym_dependent_type] = STATE(2383),
    [sym_optional_parameter_declaration] = STATE(7330),
    [sym_variadic_parameter_declaration] = STATE(7330),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym__unary_left_fold] = STATE(8348),
    [sym__unary_right_fold] = STATE(8278),
    [sym__binary_fold] = STATE(8484),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5614),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_user_defined_literal] = STATE(3428),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2045),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(1837),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1761),
    [anon_sym_RPAREN] = ACTIONS(1839),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(1849),
    [anon_sym_virtual] = ACTIONS(1851),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(1855),
    [anon_sym_enum] = ACTIONS(1857),
    [anon_sym_class] = ACTIONS(1859),
    [anon_sym_struct] = ACTIONS(1861),
    [anon_sym_union] = ACTIONS(1863),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(1887),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [125] = {
    [sym__declaration_modifiers] = STATE(2045),
    [sym__declaration_specifiers] = STATE(3895),
    [sym_attribute_specifier] = STATE(2045),
    [sym_attribute_declaration] = STATE(2045),
    [sym_ms_declspec_modifier] = STATE(2045),
    [sym_compound_statement] = STATE(7028),
    [sym_storage_class_specifier] = STATE(2045),
    [sym_type_qualifier] = STATE(2045),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_parameter_declaration] = STATE(7110),
    [sym_expression] = STATE(4314),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(7028),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(2383),
    [sym_optional_parameter_declaration] = STATE(7110),
    [sym_variadic_parameter_declaration] = STATE(7110),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5578),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2045),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(1899),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1901),
    [anon_sym_RPAREN] = ACTIONS(1903),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(1631),
    [anon_sym_virtual] = ACTIONS(1851),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(1905),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(1857),
    [anon_sym_class] = ACTIONS(1859),
    [anon_sym_struct] = ACTIONS(1861),
    [anon_sym_union] = ACTIONS(1863),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(1887),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [126] = {
    [sym__declaration_modifiers] = STATE(2045),
    [sym__declaration_specifiers] = STATE(3895),
    [sym_attribute_specifier] = STATE(2045),
    [sym_attribute_declaration] = STATE(2045),
    [sym_ms_declspec_modifier] = STATE(2045),
    [sym_storage_class_specifier] = STATE(2045),
    [sym_type_qualifier] = STATE(2045),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_parameter_declaration] = STATE(7330),
    [sym_expression] = STATE(3219),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7485),
    [sym_dependent_type] = STATE(2383),
    [sym_optional_parameter_declaration] = STATE(7330),
    [sym_variadic_parameter_declaration] = STATE(7330),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym__unary_left_fold] = STATE(8004),
    [sym__unary_right_fold] = STATE(8005),
    [sym__binary_fold] = STATE(8006),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5614),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_user_defined_literal] = STATE(3428),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2045),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(1837),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1761),
    [anon_sym_RPAREN] = ACTIONS(1839),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(1849),
    [anon_sym_virtual] = ACTIONS(1851),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(1855),
    [anon_sym_enum] = ACTIONS(1857),
    [anon_sym_class] = ACTIONS(1859),
    [anon_sym_struct] = ACTIONS(1861),
    [anon_sym_union] = ACTIONS(1863),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(1887),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [127] = {
    [sym__declaration_modifiers] = STATE(2045),
    [sym__declaration_specifiers] = STATE(3895),
    [sym_attribute_specifier] = STATE(2045),
    [sym_attribute_declaration] = STATE(2045),
    [sym_ms_declspec_modifier] = STATE(2045),
    [sym_storage_class_specifier] = STATE(2045),
    [sym_type_qualifier] = STATE(2045),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_parameter_declaration] = STATE(7330),
    [sym_expression] = STATE(3302),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7485),
    [sym_dependent_type] = STATE(2383),
    [sym_optional_parameter_declaration] = STATE(7330),
    [sym_variadic_parameter_declaration] = STATE(7330),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym__unary_left_fold] = STATE(8079),
    [sym__unary_right_fold] = STATE(8083),
    [sym__binary_fold] = STATE(8110),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5614),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_user_defined_literal] = STATE(3428),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2045),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(1837),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1761),
    [anon_sym_RPAREN] = ACTIONS(1839),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(1849),
    [anon_sym_virtual] = ACTIONS(1851),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(1855),
    [anon_sym_enum] = ACTIONS(1857),
    [anon_sym_class] = ACTIONS(1859),
    [anon_sym_struct] = ACTIONS(1861),
    [anon_sym_union] = ACTIONS(1863),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(1887),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [128] = {
    [sym__declaration_modifiers] = STATE(2045),
    [sym__declaration_specifiers] = STATE(3895),
    [sym_attribute_specifier] = STATE(2045),
    [sym_attribute_declaration] = STATE(2045),
    [sym_ms_declspec_modifier] = STATE(2045),
    [sym_storage_class_specifier] = STATE(2045),
    [sym_type_qualifier] = STATE(2045),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_parameter_declaration] = STATE(7330),
    [sym_expression] = STATE(3193),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7485),
    [sym_dependent_type] = STATE(2383),
    [sym_optional_parameter_declaration] = STATE(7330),
    [sym_variadic_parameter_declaration] = STATE(7330),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym__unary_left_fold] = STATE(8566),
    [sym__unary_right_fold] = STATE(8127),
    [sym__binary_fold] = STATE(8332),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5614),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_user_defined_literal] = STATE(3428),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2045),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(1837),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1761),
    [anon_sym_RPAREN] = ACTIONS(1839),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(1849),
    [anon_sym_virtual] = ACTIONS(1851),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(1855),
    [anon_sym_enum] = ACTIONS(1857),
    [anon_sym_class] = ACTIONS(1859),
    [anon_sym_struct] = ACTIONS(1861),
    [anon_sym_union] = ACTIONS(1863),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(1887),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [129] = {
    [sym__declaration_modifiers] = STATE(2045),
    [sym__declaration_specifiers] = STATE(3895),
    [sym_attribute_specifier] = STATE(2045),
    [sym_attribute_declaration] = STATE(2045),
    [sym_ms_declspec_modifier] = STATE(2045),
    [sym_storage_class_specifier] = STATE(2045),
    [sym_type_qualifier] = STATE(2045),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_parameter_declaration] = STATE(7330),
    [sym_expression] = STATE(3238),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7485),
    [sym_dependent_type] = STATE(2383),
    [sym_optional_parameter_declaration] = STATE(7330),
    [sym_variadic_parameter_declaration] = STATE(7330),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym__unary_left_fold] = STATE(8039),
    [sym__unary_right_fold] = STATE(8043),
    [sym__binary_fold] = STATE(8046),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5614),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_user_defined_literal] = STATE(3428),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2045),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(1837),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1761),
    [anon_sym_RPAREN] = ACTIONS(1839),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(1849),
    [anon_sym_virtual] = ACTIONS(1851),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(1855),
    [anon_sym_enum] = ACTIONS(1857),
    [anon_sym_class] = ACTIONS(1859),
    [anon_sym_struct] = ACTIONS(1861),
    [anon_sym_union] = ACTIONS(1863),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(1887),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [130] = {
    [sym__declaration_modifiers] = STATE(2045),
    [sym__declaration_specifiers] = STATE(3895),
    [sym_attribute_specifier] = STATE(2045),
    [sym_attribute_declaration] = STATE(2045),
    [sym_ms_declspec_modifier] = STATE(2045),
    [sym_storage_class_specifier] = STATE(2045),
    [sym_type_qualifier] = STATE(2045),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_parameter_declaration] = STATE(7330),
    [sym_expression] = STATE(3239),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7485),
    [sym_dependent_type] = STATE(2383),
    [sym_optional_parameter_declaration] = STATE(7330),
    [sym_variadic_parameter_declaration] = STATE(7330),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym__unary_left_fold] = STATE(7788),
    [sym__unary_right_fold] = STATE(7790),
    [sym__binary_fold] = STATE(7792),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5614),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_user_defined_literal] = STATE(3428),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2045),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(1837),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1761),
    [anon_sym_RPAREN] = ACTIONS(1839),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(1849),
    [anon_sym_virtual] = ACTIONS(1851),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(1855),
    [anon_sym_enum] = ACTIONS(1857),
    [anon_sym_class] = ACTIONS(1859),
    [anon_sym_struct] = ACTIONS(1861),
    [anon_sym_union] = ACTIONS(1863),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(1887),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [131] = {
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(5181),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(2033),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_expression] = STATE(4397),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8246),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2952),
    [sym_template_function] = STATE(3840),
    [sym_condition_declaration] = STATE(8246),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5601),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(2945),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(1747),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(1631),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(69),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [132] = {
    [ts_builtin_sym_end] = ACTIONS(1907),
    [sym_identifier] = ACTIONS(1909),
    [aux_sym_preproc_include_token1] = ACTIONS(1909),
    [aux_sym_preproc_def_token1] = ACTIONS(1909),
    [anon_sym_COMMA] = ACTIONS(1907),
    [anon_sym_RPAREN] = ACTIONS(1907),
    [aux_sym_preproc_if_token1] = ACTIONS(1909),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1909),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1909),
    [sym_preproc_directive] = ACTIONS(1909),
    [anon_sym_LPAREN2] = ACTIONS(1907),
    [anon_sym_BANG] = ACTIONS(1907),
    [anon_sym_TILDE] = ACTIONS(1907),
    [anon_sym_DASH] = ACTIONS(1909),
    [anon_sym_PLUS] = ACTIONS(1909),
    [anon_sym_STAR] = ACTIONS(1907),
    [anon_sym_PIPE_PIPE] = ACTIONS(1907),
    [anon_sym_AMP_AMP] = ACTIONS(1907),
    [anon_sym_AMP] = ACTIONS(1909),
    [anon_sym_SEMI] = ACTIONS(1907),
    [anon_sym___extension__] = ACTIONS(1909),
    [anon_sym_typedef] = ACTIONS(1909),
    [anon_sym_virtual] = ACTIONS(1909),
    [anon_sym_extern] = ACTIONS(1909),
    [anon_sym___attribute__] = ACTIONS(1909),
    [anon_sym___attribute] = ACTIONS(1909),
    [anon_sym_COLON_COLON] = ACTIONS(1907),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1907),
    [anon_sym___declspec] = ACTIONS(1909),
    [anon_sym___based] = ACTIONS(1909),
    [anon_sym___cdecl] = ACTIONS(1909),
    [anon_sym___clrcall] = ACTIONS(1909),
    [anon_sym___stdcall] = ACTIONS(1909),
    [anon_sym___fastcall] = ACTIONS(1909),
    [anon_sym___thiscall] = ACTIONS(1909),
    [anon_sym___vectorcall] = ACTIONS(1909),
    [anon_sym_LBRACE] = ACTIONS(1907),
    [anon_sym_signed] = ACTIONS(1909),
    [anon_sym_unsigned] = ACTIONS(1909),
    [anon_sym_long] = ACTIONS(1909),
    [anon_sym_short] = ACTIONS(1909),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_static] = ACTIONS(1909),
    [anon_sym_EQ] = ACTIONS(1907),
    [anon_sym_register] = ACTIONS(1909),
    [anon_sym_inline] = ACTIONS(1909),
    [anon_sym___inline] = ACTIONS(1909),
    [anon_sym___inline__] = ACTIONS(1909),
    [anon_sym___forceinline] = ACTIONS(1909),
    [anon_sym_thread_local] = ACTIONS(1909),
    [anon_sym___thread] = ACTIONS(1909),
    [anon_sym_const] = ACTIONS(1909),
    [anon_sym_constexpr] = ACTIONS(1909),
    [anon_sym_volatile] = ACTIONS(1909),
    [anon_sym_restrict] = ACTIONS(1909),
    [anon_sym___restrict__] = ACTIONS(1909),
    [anon_sym__Atomic] = ACTIONS(1909),
    [anon_sym__Noreturn] = ACTIONS(1909),
    [anon_sym_noreturn] = ACTIONS(1909),
    [anon_sym__Nonnull] = ACTIONS(1909),
    [anon_sym_mutable] = ACTIONS(1909),
    [anon_sym_constinit] = ACTIONS(1909),
    [anon_sym_consteval] = ACTIONS(1909),
    [anon_sym_alignas] = ACTIONS(1909),
    [anon_sym__Alignas] = ACTIONS(1909),
    [sym_primitive_type] = ACTIONS(1909),
    [anon_sym_enum] = ACTIONS(1909),
    [anon_sym_class] = ACTIONS(1909),
    [anon_sym_struct] = ACTIONS(1909),
    [anon_sym_union] = ACTIONS(1909),
    [anon_sym_if] = ACTIONS(1909),
    [anon_sym_else] = ACTIONS(1909),
    [anon_sym_switch] = ACTIONS(1909),
    [anon_sym_case] = ACTIONS(1909),
    [anon_sym_default] = ACTIONS(1909),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_do] = ACTIONS(1909),
    [anon_sym_for] = ACTIONS(1909),
    [anon_sym_return] = ACTIONS(1909),
    [anon_sym_break] = ACTIONS(1909),
    [anon_sym_continue] = ACTIONS(1909),
    [anon_sym_goto] = ACTIONS(1909),
    [anon_sym___try] = ACTIONS(1909),
    [anon_sym___except] = ACTIONS(1909),
    [anon_sym___finally] = ACTIONS(1909),
    [anon_sym___leave] = ACTIONS(1909),
    [anon_sym_not] = ACTIONS(1909),
    [anon_sym_compl] = ACTIONS(1909),
    [anon_sym_or] = ACTIONS(1909),
    [anon_sym_and] = ACTIONS(1909),
    [anon_sym_DASH_DASH] = ACTIONS(1907),
    [anon_sym_PLUS_PLUS] = ACTIONS(1907),
    [anon_sym_sizeof] = ACTIONS(1909),
    [anon_sym___alignof__] = ACTIONS(1909),
    [anon_sym___alignof] = ACTIONS(1909),
    [anon_sym__alignof] = ACTIONS(1909),
    [anon_sym_alignof] = ACTIONS(1909),
    [anon_sym__Alignof] = ACTIONS(1909),
    [anon_sym_offsetof] = ACTIONS(1909),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1909),
    [anon_sym___asm__] = ACTIONS(1909),
    [anon_sym___asm] = ACTIONS(1909),
    [sym_number_literal] = ACTIONS(1907),
    [anon_sym_L_SQUOTE] = ACTIONS(1907),
    [anon_sym_u_SQUOTE] = ACTIONS(1907),
    [anon_sym_U_SQUOTE] = ACTIONS(1907),
    [anon_sym_u8_SQUOTE] = ACTIONS(1907),
    [anon_sym_SQUOTE] = ACTIONS(1907),
    [anon_sym_L_DQUOTE] = ACTIONS(1907),
    [anon_sym_u_DQUOTE] = ACTIONS(1907),
    [anon_sym_U_DQUOTE] = ACTIONS(1907),
    [anon_sym_u8_DQUOTE] = ACTIONS(1907),
    [anon_sym_DQUOTE] = ACTIONS(1907),
    [sym_true] = ACTIONS(1909),
    [sym_false] = ACTIONS(1909),
    [anon_sym_NULL] = ACTIONS(1909),
    [anon_sym_nullptr] = ACTIONS(1909),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1909),
    [anon_sym_decltype] = ACTIONS(1909),
    [anon_sym_final] = ACTIONS(1909),
    [anon_sym_override] = ACTIONS(1909),
    [anon_sym_explicit] = ACTIONS(1909),
    [anon_sym_typename] = ACTIONS(1909),
    [anon_sym_template] = ACTIONS(1909),
    [anon_sym_GT2] = ACTIONS(1907),
    [anon_sym_operator] = ACTIONS(1909),
    [anon_sym_try] = ACTIONS(1909),
    [anon_sym_delete] = ACTIONS(1909),
    [anon_sym_throw] = ACTIONS(1909),
    [anon_sym_namespace] = ACTIONS(1909),
    [anon_sym_using] = ACTIONS(1909),
    [anon_sym_static_assert] = ACTIONS(1909),
    [anon_sym_concept] = ACTIONS(1909),
    [anon_sym_co_return] = ACTIONS(1909),
    [anon_sym_co_yield] = ACTIONS(1909),
    [anon_sym_catch] = ACTIONS(1909),
    [anon_sym_R_DQUOTE] = ACTIONS(1907),
    [anon_sym_LR_DQUOTE] = ACTIONS(1907),
    [anon_sym_uR_DQUOTE] = ACTIONS(1907),
    [anon_sym_UR_DQUOTE] = ACTIONS(1907),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1907),
    [anon_sym_co_await] = ACTIONS(1909),
    [anon_sym_new] = ACTIONS(1909),
    [anon_sym_requires] = ACTIONS(1909),
    [sym_this] = ACTIONS(1909),
  },
  [133] = {
    [ts_builtin_sym_end] = ACTIONS(1911),
    [sym_identifier] = ACTIONS(1913),
    [aux_sym_preproc_include_token1] = ACTIONS(1913),
    [aux_sym_preproc_def_token1] = ACTIONS(1913),
    [anon_sym_COMMA] = ACTIONS(1911),
    [anon_sym_RPAREN] = ACTIONS(1911),
    [aux_sym_preproc_if_token1] = ACTIONS(1913),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1913),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1913),
    [sym_preproc_directive] = ACTIONS(1913),
    [anon_sym_LPAREN2] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_DASH] = ACTIONS(1913),
    [anon_sym_PLUS] = ACTIONS(1913),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_PIPE_PIPE] = ACTIONS(1911),
    [anon_sym_AMP_AMP] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1913),
    [anon_sym_SEMI] = ACTIONS(1911),
    [anon_sym___extension__] = ACTIONS(1913),
    [anon_sym_typedef] = ACTIONS(1913),
    [anon_sym_virtual] = ACTIONS(1913),
    [anon_sym_extern] = ACTIONS(1913),
    [anon_sym___attribute__] = ACTIONS(1913),
    [anon_sym___attribute] = ACTIONS(1913),
    [anon_sym_COLON_COLON] = ACTIONS(1911),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1911),
    [anon_sym___declspec] = ACTIONS(1913),
    [anon_sym___based] = ACTIONS(1913),
    [anon_sym___cdecl] = ACTIONS(1913),
    [anon_sym___clrcall] = ACTIONS(1913),
    [anon_sym___stdcall] = ACTIONS(1913),
    [anon_sym___fastcall] = ACTIONS(1913),
    [anon_sym___thiscall] = ACTIONS(1913),
    [anon_sym___vectorcall] = ACTIONS(1913),
    [anon_sym_LBRACE] = ACTIONS(1911),
    [anon_sym_signed] = ACTIONS(1913),
    [anon_sym_unsigned] = ACTIONS(1913),
    [anon_sym_long] = ACTIONS(1913),
    [anon_sym_short] = ACTIONS(1913),
    [anon_sym_LBRACK] = ACTIONS(1913),
    [anon_sym_static] = ACTIONS(1913),
    [anon_sym_EQ] = ACTIONS(1911),
    [anon_sym_register] = ACTIONS(1913),
    [anon_sym_inline] = ACTIONS(1913),
    [anon_sym___inline] = ACTIONS(1913),
    [anon_sym___inline__] = ACTIONS(1913),
    [anon_sym___forceinline] = ACTIONS(1913),
    [anon_sym_thread_local] = ACTIONS(1913),
    [anon_sym___thread] = ACTIONS(1913),
    [anon_sym_const] = ACTIONS(1913),
    [anon_sym_constexpr] = ACTIONS(1913),
    [anon_sym_volatile] = ACTIONS(1913),
    [anon_sym_restrict] = ACTIONS(1913),
    [anon_sym___restrict__] = ACTIONS(1913),
    [anon_sym__Atomic] = ACTIONS(1913),
    [anon_sym__Noreturn] = ACTIONS(1913),
    [anon_sym_noreturn] = ACTIONS(1913),
    [anon_sym__Nonnull] = ACTIONS(1913),
    [anon_sym_mutable] = ACTIONS(1913),
    [anon_sym_constinit] = ACTIONS(1913),
    [anon_sym_consteval] = ACTIONS(1913),
    [anon_sym_alignas] = ACTIONS(1913),
    [anon_sym__Alignas] = ACTIONS(1913),
    [sym_primitive_type] = ACTIONS(1913),
    [anon_sym_enum] = ACTIONS(1913),
    [anon_sym_class] = ACTIONS(1913),
    [anon_sym_struct] = ACTIONS(1913),
    [anon_sym_union] = ACTIONS(1913),
    [anon_sym_if] = ACTIONS(1913),
    [anon_sym_else] = ACTIONS(1913),
    [anon_sym_switch] = ACTIONS(1913),
    [anon_sym_case] = ACTIONS(1913),
    [anon_sym_default] = ACTIONS(1913),
    [anon_sym_while] = ACTIONS(1913),
    [anon_sym_do] = ACTIONS(1913),
    [anon_sym_for] = ACTIONS(1913),
    [anon_sym_return] = ACTIONS(1913),
    [anon_sym_break] = ACTIONS(1913),
    [anon_sym_continue] = ACTIONS(1913),
    [anon_sym_goto] = ACTIONS(1913),
    [anon_sym___try] = ACTIONS(1913),
    [anon_sym___except] = ACTIONS(1913),
    [anon_sym___finally] = ACTIONS(1913),
    [anon_sym___leave] = ACTIONS(1913),
    [anon_sym_not] = ACTIONS(1913),
    [anon_sym_compl] = ACTIONS(1913),
    [anon_sym_or] = ACTIONS(1913),
    [anon_sym_and] = ACTIONS(1913),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_sizeof] = ACTIONS(1913),
    [anon_sym___alignof__] = ACTIONS(1913),
    [anon_sym___alignof] = ACTIONS(1913),
    [anon_sym__alignof] = ACTIONS(1913),
    [anon_sym_alignof] = ACTIONS(1913),
    [anon_sym__Alignof] = ACTIONS(1913),
    [anon_sym_offsetof] = ACTIONS(1913),
    [anon_sym__Generic] = ACTIONS(1913),
    [anon_sym_asm] = ACTIONS(1913),
    [anon_sym___asm__] = ACTIONS(1913),
    [anon_sym___asm] = ACTIONS(1913),
    [sym_number_literal] = ACTIONS(1911),
    [anon_sym_L_SQUOTE] = ACTIONS(1911),
    [anon_sym_u_SQUOTE] = ACTIONS(1911),
    [anon_sym_U_SQUOTE] = ACTIONS(1911),
    [anon_sym_u8_SQUOTE] = ACTIONS(1911),
    [anon_sym_SQUOTE] = ACTIONS(1911),
    [anon_sym_L_DQUOTE] = ACTIONS(1911),
    [anon_sym_u_DQUOTE] = ACTIONS(1911),
    [anon_sym_U_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8_DQUOTE] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(1911),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1913),
    [anon_sym_nullptr] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1913),
    [anon_sym_decltype] = ACTIONS(1913),
    [anon_sym_final] = ACTIONS(1913),
    [anon_sym_override] = ACTIONS(1913),
    [anon_sym_explicit] = ACTIONS(1913),
    [anon_sym_typename] = ACTIONS(1913),
    [anon_sym_template] = ACTIONS(1913),
    [anon_sym_GT2] = ACTIONS(1911),
    [anon_sym_operator] = ACTIONS(1913),
    [anon_sym_try] = ACTIONS(1913),
    [anon_sym_delete] = ACTIONS(1913),
    [anon_sym_throw] = ACTIONS(1913),
    [anon_sym_namespace] = ACTIONS(1913),
    [anon_sym_using] = ACTIONS(1913),
    [anon_sym_static_assert] = ACTIONS(1913),
    [anon_sym_concept] = ACTIONS(1913),
    [anon_sym_co_return] = ACTIONS(1913),
    [anon_sym_co_yield] = ACTIONS(1913),
    [anon_sym_catch] = ACTIONS(1913),
    [anon_sym_R_DQUOTE] = ACTIONS(1911),
    [anon_sym_LR_DQUOTE] = ACTIONS(1911),
    [anon_sym_uR_DQUOTE] = ACTIONS(1911),
    [anon_sym_UR_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1911),
    [anon_sym_co_await] = ACTIONS(1913),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_requires] = ACTIONS(1913),
    [sym_this] = ACTIONS(1913),
  },
  [134] = {
    [sym_expression] = STATE(2328),
    [sym__string] = STATE(2808),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_initializer_list] = STATE(2473),
    [sym_char_literal] = STATE(2808),
    [sym_concatenated_string] = STATE(2808),
    [sym_string_literal] = STATE(1900),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1900),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1915),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1917),
    [anon_sym_COMMA] = ACTIONS(1917),
    [aux_sym_preproc_if_token2] = ACTIONS(1917),
    [aux_sym_preproc_else_token1] = ACTIONS(1917),
    [aux_sym_preproc_elif_token1] = ACTIONS(1915),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1917),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1917),
    [anon_sym_LPAREN2] = ACTIONS(1917),
    [anon_sym_BANG] = ACTIONS(1919),
    [anon_sym_TILDE] = ACTIONS(1921),
    [anon_sym_DASH] = ACTIONS(1915),
    [anon_sym_PLUS] = ACTIONS(1915),
    [anon_sym_STAR] = ACTIONS(1915),
    [anon_sym_SLASH] = ACTIONS(1915),
    [anon_sym_PERCENT] = ACTIONS(1915),
    [anon_sym_PIPE_PIPE] = ACTIONS(1917),
    [anon_sym_AMP_AMP] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(1915),
    [anon_sym_CARET] = ACTIONS(1915),
    [anon_sym_AMP] = ACTIONS(1915),
    [anon_sym_EQ_EQ] = ACTIONS(1917),
    [anon_sym_BANG_EQ] = ACTIONS(1917),
    [anon_sym_GT] = ACTIONS(1915),
    [anon_sym_GT_EQ] = ACTIONS(1917),
    [anon_sym_LT_EQ] = ACTIONS(1915),
    [anon_sym_LT] = ACTIONS(1915),
    [anon_sym_LT_LT] = ACTIONS(1915),
    [anon_sym_GT_GT] = ACTIONS(1915),
    [anon_sym___extension__] = ACTIONS(1923),
    [anon_sym_COLON_COLON] = ACTIONS(1925),
    [anon_sym_LBRACE] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(1917),
    [anon_sym_EQ] = ACTIONS(1915),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_QMARK] = ACTIONS(1917),
    [anon_sym_STAR_EQ] = ACTIONS(1917),
    [anon_sym_SLASH_EQ] = ACTIONS(1917),
    [anon_sym_PERCENT_EQ] = ACTIONS(1917),
    [anon_sym_PLUS_EQ] = ACTIONS(1917),
    [anon_sym_DASH_EQ] = ACTIONS(1917),
    [anon_sym_LT_LT_EQ] = ACTIONS(1917),
    [anon_sym_GT_GT_EQ] = ACTIONS(1917),
    [anon_sym_AMP_EQ] = ACTIONS(1917),
    [anon_sym_CARET_EQ] = ACTIONS(1917),
    [anon_sym_PIPE_EQ] = ACTIONS(1917),
    [anon_sym_and_eq] = ACTIONS(1915),
    [anon_sym_or_eq] = ACTIONS(1915),
    [anon_sym_xor_eq] = ACTIONS(1915),
    [anon_sym_not] = ACTIONS(1919),
    [anon_sym_compl] = ACTIONS(1919),
    [anon_sym_LT_EQ_GT] = ACTIONS(1917),
    [anon_sym_or] = ACTIONS(1915),
    [anon_sym_and] = ACTIONS(1915),
    [anon_sym_bitor] = ACTIONS(1915),
    [anon_sym_xor] = ACTIONS(1915),
    [anon_sym_bitand] = ACTIONS(1915),
    [anon_sym_not_eq] = ACTIONS(1915),
    [anon_sym_DASH_DASH] = ACTIONS(1917),
    [anon_sym_PLUS_PLUS] = ACTIONS(1917),
    [anon_sym_sizeof] = ACTIONS(1931),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [anon_sym_DOT] = ACTIONS(1915),
    [anon_sym_DOT_STAR] = ACTIONS(1917),
    [anon_sym_DASH_GT] = ACTIONS(1917),
    [sym_number_literal] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1953),
    [anon_sym_R_DQUOTE] = ACTIONS(1955),
    [anon_sym_LR_DQUOTE] = ACTIONS(1955),
    [anon_sym_uR_DQUOTE] = ACTIONS(1955),
    [anon_sym_UR_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1955),
    [anon_sym_co_await] = ACTIONS(1957),
    [anon_sym_new] = ACTIONS(1959),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [135] = {
    [sym_expression] = STATE(2328),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_initializer_list] = STATE(2473),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1917),
    [anon_sym_COMMA] = ACTIONS(1917),
    [anon_sym_RPAREN] = ACTIONS(1917),
    [anon_sym_LPAREN2] = ACTIONS(1917),
    [anon_sym_BANG] = ACTIONS(1965),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1915),
    [anon_sym_PLUS] = ACTIONS(1915),
    [anon_sym_STAR] = ACTIONS(1915),
    [anon_sym_SLASH] = ACTIONS(1915),
    [anon_sym_PERCENT] = ACTIONS(1915),
    [anon_sym_PIPE_PIPE] = ACTIONS(1917),
    [anon_sym_AMP_AMP] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(1915),
    [anon_sym_CARET] = ACTIONS(1915),
    [anon_sym_AMP] = ACTIONS(1915),
    [anon_sym_EQ_EQ] = ACTIONS(1917),
    [anon_sym_BANG_EQ] = ACTIONS(1917),
    [anon_sym_GT] = ACTIONS(1915),
    [anon_sym_GT_EQ] = ACTIONS(1917),
    [anon_sym_LT_EQ] = ACTIONS(1915),
    [anon_sym_LT] = ACTIONS(1915),
    [anon_sym_LT_LT] = ACTIONS(1915),
    [anon_sym_GT_GT] = ACTIONS(1915),
    [anon_sym_SEMI] = ACTIONS(1917),
    [anon_sym___extension__] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1971),
    [anon_sym_LBRACE] = ACTIONS(1927),
    [anon_sym_RBRACE] = ACTIONS(1917),
    [anon_sym_LBRACK] = ACTIONS(1917),
    [anon_sym_RBRACK] = ACTIONS(1917),
    [anon_sym_EQ] = ACTIONS(1915),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_QMARK] = ACTIONS(1917),
    [anon_sym_STAR_EQ] = ACTIONS(1917),
    [anon_sym_SLASH_EQ] = ACTIONS(1917),
    [anon_sym_PERCENT_EQ] = ACTIONS(1917),
    [anon_sym_PLUS_EQ] = ACTIONS(1917),
    [anon_sym_DASH_EQ] = ACTIONS(1917),
    [anon_sym_LT_LT_EQ] = ACTIONS(1917),
    [anon_sym_GT_GT_EQ] = ACTIONS(1917),
    [anon_sym_AMP_EQ] = ACTIONS(1917),
    [anon_sym_CARET_EQ] = ACTIONS(1917),
    [anon_sym_PIPE_EQ] = ACTIONS(1917),
    [anon_sym_and_eq] = ACTIONS(1915),
    [anon_sym_or_eq] = ACTIONS(1915),
    [anon_sym_xor_eq] = ACTIONS(1915),
    [anon_sym_not] = ACTIONS(1965),
    [anon_sym_compl] = ACTIONS(1965),
    [anon_sym_LT_EQ_GT] = ACTIONS(1917),
    [anon_sym_or] = ACTIONS(1915),
    [anon_sym_and] = ACTIONS(1915),
    [anon_sym_bitor] = ACTIONS(1915),
    [anon_sym_xor] = ACTIONS(1915),
    [anon_sym_bitand] = ACTIONS(1915),
    [anon_sym_not_eq] = ACTIONS(1915),
    [anon_sym_DASH_DASH] = ACTIONS(1917),
    [anon_sym_PLUS_PLUS] = ACTIONS(1917),
    [anon_sym_sizeof] = ACTIONS(1973),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [anon_sym_DOT] = ACTIONS(1915),
    [anon_sym_DOT_STAR] = ACTIONS(1917),
    [anon_sym_DASH_GT] = ACTIONS(1917),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [136] = {
    [sym_expression] = STATE(2328),
    [sym__string] = STATE(3071),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_initializer_list] = STATE(2473),
    [sym_char_literal] = STATE(3071),
    [sym_concatenated_string] = STATE(3071),
    [sym_string_literal] = STATE(2243),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(2243),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1989),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1917),
    [anon_sym_COMMA] = ACTIONS(1917),
    [anon_sym_LPAREN2] = ACTIONS(1917),
    [anon_sym_BANG] = ACTIONS(1991),
    [anon_sym_TILDE] = ACTIONS(1993),
    [anon_sym_DASH] = ACTIONS(1915),
    [anon_sym_PLUS] = ACTIONS(1915),
    [anon_sym_STAR] = ACTIONS(1915),
    [anon_sym_SLASH] = ACTIONS(1915),
    [anon_sym_PERCENT] = ACTIONS(1915),
    [anon_sym_PIPE_PIPE] = ACTIONS(1917),
    [anon_sym_AMP_AMP] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(1915),
    [anon_sym_CARET] = ACTIONS(1915),
    [anon_sym_AMP] = ACTIONS(1915),
    [anon_sym_EQ_EQ] = ACTIONS(1917),
    [anon_sym_BANG_EQ] = ACTIONS(1917),
    [anon_sym_GT] = ACTIONS(1915),
    [anon_sym_GT_EQ] = ACTIONS(1917),
    [anon_sym_LT_EQ] = ACTIONS(1915),
    [anon_sym_LT] = ACTIONS(1915),
    [anon_sym_LT_LT] = ACTIONS(1915),
    [anon_sym_GT_GT] = ACTIONS(1915),
    [anon_sym_SEMI] = ACTIONS(1917),
    [anon_sym___extension__] = ACTIONS(1995),
    [anon_sym___attribute__] = ACTIONS(1915),
    [anon_sym___attribute] = ACTIONS(1915),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_LBRACE] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(1917),
    [anon_sym_EQ] = ACTIONS(1915),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_QMARK] = ACTIONS(1917),
    [anon_sym_STAR_EQ] = ACTIONS(1917),
    [anon_sym_SLASH_EQ] = ACTIONS(1917),
    [anon_sym_PERCENT_EQ] = ACTIONS(1917),
    [anon_sym_PLUS_EQ] = ACTIONS(1917),
    [anon_sym_DASH_EQ] = ACTIONS(1917),
    [anon_sym_LT_LT_EQ] = ACTIONS(1917),
    [anon_sym_GT_GT_EQ] = ACTIONS(1917),
    [anon_sym_AMP_EQ] = ACTIONS(1917),
    [anon_sym_CARET_EQ] = ACTIONS(1917),
    [anon_sym_PIPE_EQ] = ACTIONS(1917),
    [anon_sym_and_eq] = ACTIONS(1915),
    [anon_sym_or_eq] = ACTIONS(1915),
    [anon_sym_xor_eq] = ACTIONS(1915),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_compl] = ACTIONS(1991),
    [anon_sym_LT_EQ_GT] = ACTIONS(1917),
    [anon_sym_or] = ACTIONS(1915),
    [anon_sym_and] = ACTIONS(1915),
    [anon_sym_bitor] = ACTIONS(1915),
    [anon_sym_xor] = ACTIONS(1915),
    [anon_sym_bitand] = ACTIONS(1915),
    [anon_sym_not_eq] = ACTIONS(1915),
    [anon_sym_DASH_DASH] = ACTIONS(1917),
    [anon_sym_PLUS_PLUS] = ACTIONS(1917),
    [anon_sym_sizeof] = ACTIONS(1999),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [anon_sym_DOT] = ACTIONS(1915),
    [anon_sym_DOT_STAR] = ACTIONS(1917),
    [anon_sym_DASH_GT] = ACTIONS(1917),
    [sym_number_literal] = ACTIONS(2001),
    [anon_sym_L_SQUOTE] = ACTIONS(2003),
    [anon_sym_u_SQUOTE] = ACTIONS(2003),
    [anon_sym_U_SQUOTE] = ACTIONS(2003),
    [anon_sym_u8_SQUOTE] = ACTIONS(2003),
    [anon_sym_SQUOTE] = ACTIONS(2003),
    [anon_sym_L_DQUOTE] = ACTIONS(2005),
    [anon_sym_u_DQUOTE] = ACTIONS(2005),
    [anon_sym_U_DQUOTE] = ACTIONS(2005),
    [anon_sym_u8_DQUOTE] = ACTIONS(2005),
    [anon_sym_DQUOTE] = ACTIONS(2005),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2007),
    [anon_sym_R_DQUOTE] = ACTIONS(2009),
    [anon_sym_LR_DQUOTE] = ACTIONS(2009),
    [anon_sym_uR_DQUOTE] = ACTIONS(2009),
    [anon_sym_UR_DQUOTE] = ACTIONS(2009),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2009),
    [anon_sym_co_await] = ACTIONS(2011),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [137] = {
    [sym_compound_statement] = STATE(8059),
    [sym_type_qualifier] = STATE(3854),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4605),
    [sym_sized_type_specifier] = STATE(1810),
    [sym_enum_specifier] = STATE(1810),
    [sym_struct_specifier] = STATE(1810),
    [sym_union_specifier] = STATE(1810),
    [sym_expression] = STATE(2841),
    [sym__string] = STATE(3173),
    [sym_comma_expression] = STATE(8059),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_type_descriptor] = STATE(8002),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_placeholder_type_specifier] = STATE(1810),
    [sym_decltype_auto] = STATE(1804),
    [sym_decltype] = STATE(1755),
    [sym_class_specifier] = STATE(1810),
    [sym__class_name] = STATE(7687),
    [sym_dependent_type] = STATE(1810),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym__unary_left_fold] = STATE(8004),
    [sym__unary_right_fold] = STATE(8005),
    [sym__binary_fold] = STATE(8006),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5594),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym__assignment_expression_lhs] = STATE(8126),
    [sym_user_defined_literal] = STATE(3443),
    [aux_sym__type_definition_type_repeat1] = STATE(3854),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(2013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(1775),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(1781),
    [anon_sym_unsigned] = ACTIONS(1781),
    [anon_sym_long] = ACTIONS(1781),
    [anon_sym_short] = ACTIONS(1781),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(1785),
    [anon_sym_enum] = ACTIONS(1787),
    [anon_sym_class] = ACTIONS(1789),
    [anon_sym_struct] = ACTIONS(1791),
    [anon_sym_union] = ACTIONS(1793),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1817),
    [anon_sym_decltype] = ACTIONS(1819),
    [anon_sym_typename] = ACTIONS(1821),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [138] = {
    [sym_compound_statement] = STATE(8507),
    [sym_type_qualifier] = STATE(3854),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4605),
    [sym_sized_type_specifier] = STATE(1810),
    [sym_enum_specifier] = STATE(1810),
    [sym_struct_specifier] = STATE(1810),
    [sym_union_specifier] = STATE(1810),
    [sym_expression] = STATE(2923),
    [sym__string] = STATE(3173),
    [sym_comma_expression] = STATE(8507),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_type_descriptor] = STATE(8140),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_placeholder_type_specifier] = STATE(1810),
    [sym_decltype_auto] = STATE(1804),
    [sym_decltype] = STATE(1755),
    [sym_class_specifier] = STATE(1810),
    [sym__class_name] = STATE(7687),
    [sym_dependent_type] = STATE(1810),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym__unary_left_fold] = STATE(8079),
    [sym__unary_right_fold] = STATE(8083),
    [sym__binary_fold] = STATE(8110),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5594),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym__assignment_expression_lhs] = STATE(8151),
    [sym_user_defined_literal] = STATE(3443),
    [aux_sym__type_definition_type_repeat1] = STATE(3854),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(2013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(1775),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(1781),
    [anon_sym_unsigned] = ACTIONS(1781),
    [anon_sym_long] = ACTIONS(1781),
    [anon_sym_short] = ACTIONS(1781),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(1785),
    [anon_sym_enum] = ACTIONS(1787),
    [anon_sym_class] = ACTIONS(1789),
    [anon_sym_struct] = ACTIONS(1791),
    [anon_sym_union] = ACTIONS(1793),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1817),
    [anon_sym_decltype] = ACTIONS(1819),
    [anon_sym_typename] = ACTIONS(1821),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [139] = {
    [sym_compound_statement] = STATE(8059),
    [sym_type_qualifier] = STATE(3854),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4605),
    [sym_sized_type_specifier] = STATE(1810),
    [sym_enum_specifier] = STATE(1810),
    [sym_struct_specifier] = STATE(1810),
    [sym_union_specifier] = STATE(1810),
    [sym_expression] = STATE(2841),
    [sym__string] = STATE(3173),
    [sym_comma_expression] = STATE(8059),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_type_descriptor] = STATE(8168),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_placeholder_type_specifier] = STATE(1810),
    [sym_decltype_auto] = STATE(1804),
    [sym_decltype] = STATE(1755),
    [sym_class_specifier] = STATE(1810),
    [sym__class_name] = STATE(7687),
    [sym_dependent_type] = STATE(1810),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym__unary_left_fold] = STATE(8004),
    [sym__unary_right_fold] = STATE(8005),
    [sym__binary_fold] = STATE(8006),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5594),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym__assignment_expression_lhs] = STATE(8126),
    [sym_user_defined_literal] = STATE(3443),
    [aux_sym__type_definition_type_repeat1] = STATE(3854),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(2013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(1775),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(1781),
    [anon_sym_unsigned] = ACTIONS(1781),
    [anon_sym_long] = ACTIONS(1781),
    [anon_sym_short] = ACTIONS(1781),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(1785),
    [anon_sym_enum] = ACTIONS(1787),
    [anon_sym_class] = ACTIONS(1789),
    [anon_sym_struct] = ACTIONS(1791),
    [anon_sym_union] = ACTIONS(1793),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1817),
    [anon_sym_decltype] = ACTIONS(1819),
    [anon_sym_typename] = ACTIONS(1821),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [140] = {
    [sym_compound_statement] = STATE(8511),
    [sym_type_qualifier] = STATE(3854),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4605),
    [sym_sized_type_specifier] = STATE(1810),
    [sym_enum_specifier] = STATE(1810),
    [sym_struct_specifier] = STATE(1810),
    [sym_union_specifier] = STATE(1810),
    [sym_expression] = STATE(2893),
    [sym__string] = STATE(3173),
    [sym_comma_expression] = STATE(8511),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_type_descriptor] = STATE(7762),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_placeholder_type_specifier] = STATE(1810),
    [sym_decltype_auto] = STATE(1804),
    [sym_decltype] = STATE(1755),
    [sym_class_specifier] = STATE(1810),
    [sym__class_name] = STATE(7687),
    [sym_dependent_type] = STATE(1810),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym__unary_left_fold] = STATE(8039),
    [sym__unary_right_fold] = STATE(8043),
    [sym__binary_fold] = STATE(8046),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5594),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym__assignment_expression_lhs] = STATE(8294),
    [sym_user_defined_literal] = STATE(3443),
    [aux_sym__type_definition_type_repeat1] = STATE(3854),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(2013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(1775),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(1781),
    [anon_sym_unsigned] = ACTIONS(1781),
    [anon_sym_long] = ACTIONS(1781),
    [anon_sym_short] = ACTIONS(1781),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(1785),
    [anon_sym_enum] = ACTIONS(1787),
    [anon_sym_class] = ACTIONS(1789),
    [anon_sym_struct] = ACTIONS(1791),
    [anon_sym_union] = ACTIONS(1793),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1817),
    [anon_sym_decltype] = ACTIONS(1819),
    [anon_sym_typename] = ACTIONS(1821),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [141] = {
    [sym_compound_statement] = STATE(8507),
    [sym_type_qualifier] = STATE(3854),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4605),
    [sym_sized_type_specifier] = STATE(1810),
    [sym_enum_specifier] = STATE(1810),
    [sym_struct_specifier] = STATE(1810),
    [sym_union_specifier] = STATE(1810),
    [sym_expression] = STATE(2923),
    [sym__string] = STATE(3173),
    [sym_comma_expression] = STATE(8507),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_type_descriptor] = STATE(8073),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_placeholder_type_specifier] = STATE(1810),
    [sym_decltype_auto] = STATE(1804),
    [sym_decltype] = STATE(1755),
    [sym_class_specifier] = STATE(1810),
    [sym__class_name] = STATE(7687),
    [sym_dependent_type] = STATE(1810),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym__unary_left_fold] = STATE(8079),
    [sym__unary_right_fold] = STATE(8083),
    [sym__binary_fold] = STATE(8110),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5594),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym__assignment_expression_lhs] = STATE(8151),
    [sym_user_defined_literal] = STATE(3443),
    [aux_sym__type_definition_type_repeat1] = STATE(3854),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(2013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(1775),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(1781),
    [anon_sym_unsigned] = ACTIONS(1781),
    [anon_sym_long] = ACTIONS(1781),
    [anon_sym_short] = ACTIONS(1781),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(1785),
    [anon_sym_enum] = ACTIONS(1787),
    [anon_sym_class] = ACTIONS(1789),
    [anon_sym_struct] = ACTIONS(1791),
    [anon_sym_union] = ACTIONS(1793),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1817),
    [anon_sym_decltype] = ACTIONS(1819),
    [anon_sym_typename] = ACTIONS(1821),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [142] = {
    [sym_compound_statement] = STATE(8511),
    [sym_type_qualifier] = STATE(3854),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4605),
    [sym_sized_type_specifier] = STATE(1810),
    [sym_enum_specifier] = STATE(1810),
    [sym_struct_specifier] = STATE(1810),
    [sym_union_specifier] = STATE(1810),
    [sym_expression] = STATE(2893),
    [sym__string] = STATE(3173),
    [sym_comma_expression] = STATE(8511),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_type_descriptor] = STATE(7907),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_placeholder_type_specifier] = STATE(1810),
    [sym_decltype_auto] = STATE(1804),
    [sym_decltype] = STATE(1755),
    [sym_class_specifier] = STATE(1810),
    [sym__class_name] = STATE(7687),
    [sym_dependent_type] = STATE(1810),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym__unary_left_fold] = STATE(8566),
    [sym__unary_right_fold] = STATE(8127),
    [sym__binary_fold] = STATE(8332),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5594),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym__assignment_expression_lhs] = STATE(8294),
    [sym_user_defined_literal] = STATE(3443),
    [aux_sym__type_definition_type_repeat1] = STATE(3854),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(2013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(1775),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(1781),
    [anon_sym_unsigned] = ACTIONS(1781),
    [anon_sym_long] = ACTIONS(1781),
    [anon_sym_short] = ACTIONS(1781),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(1785),
    [anon_sym_enum] = ACTIONS(1787),
    [anon_sym_class] = ACTIONS(1789),
    [anon_sym_struct] = ACTIONS(1791),
    [anon_sym_union] = ACTIONS(1793),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1817),
    [anon_sym_decltype] = ACTIONS(1819),
    [anon_sym_typename] = ACTIONS(1821),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [143] = {
    [sym_compound_statement] = STATE(8507),
    [sym_type_qualifier] = STATE(3854),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4605),
    [sym_sized_type_specifier] = STATE(1810),
    [sym_enum_specifier] = STATE(1810),
    [sym_struct_specifier] = STATE(1810),
    [sym_union_specifier] = STATE(1810),
    [sym_expression] = STATE(2923),
    [sym__string] = STATE(3173),
    [sym_comma_expression] = STATE(8507),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_type_descriptor] = STATE(8375),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_placeholder_type_specifier] = STATE(1810),
    [sym_decltype_auto] = STATE(1804),
    [sym_decltype] = STATE(1755),
    [sym_class_specifier] = STATE(1810),
    [sym__class_name] = STATE(7687),
    [sym_dependent_type] = STATE(1810),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym__unary_left_fold] = STATE(8079),
    [sym__unary_right_fold] = STATE(8083),
    [sym__binary_fold] = STATE(8110),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5594),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym__assignment_expression_lhs] = STATE(8151),
    [sym_user_defined_literal] = STATE(3443),
    [aux_sym__type_definition_type_repeat1] = STATE(3854),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(2013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(1775),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(1781),
    [anon_sym_unsigned] = ACTIONS(1781),
    [anon_sym_long] = ACTIONS(1781),
    [anon_sym_short] = ACTIONS(1781),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(1785),
    [anon_sym_enum] = ACTIONS(1787),
    [anon_sym_class] = ACTIONS(1789),
    [anon_sym_struct] = ACTIONS(1791),
    [anon_sym_union] = ACTIONS(1793),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1817),
    [anon_sym_decltype] = ACTIONS(1819),
    [anon_sym_typename] = ACTIONS(1821),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [144] = {
    [sym_compound_statement] = STATE(8511),
    [sym_type_qualifier] = STATE(3854),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4605),
    [sym_sized_type_specifier] = STATE(1810),
    [sym_enum_specifier] = STATE(1810),
    [sym_struct_specifier] = STATE(1810),
    [sym_union_specifier] = STATE(1810),
    [sym_expression] = STATE(2893),
    [sym__string] = STATE(3173),
    [sym_comma_expression] = STATE(8511),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_type_descriptor] = STATE(8038),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_placeholder_type_specifier] = STATE(1810),
    [sym_decltype_auto] = STATE(1804),
    [sym_decltype] = STATE(1755),
    [sym_class_specifier] = STATE(1810),
    [sym__class_name] = STATE(7687),
    [sym_dependent_type] = STATE(1810),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym__unary_left_fold] = STATE(8039),
    [sym__unary_right_fold] = STATE(8043),
    [sym__binary_fold] = STATE(8046),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5594),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym__assignment_expression_lhs] = STATE(8294),
    [sym_user_defined_literal] = STATE(3443),
    [aux_sym__type_definition_type_repeat1] = STATE(3854),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(2013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(1775),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(1781),
    [anon_sym_unsigned] = ACTIONS(1781),
    [anon_sym_long] = ACTIONS(1781),
    [anon_sym_short] = ACTIONS(1781),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(1785),
    [anon_sym_enum] = ACTIONS(1787),
    [anon_sym_class] = ACTIONS(1789),
    [anon_sym_struct] = ACTIONS(1791),
    [anon_sym_union] = ACTIONS(1793),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1817),
    [anon_sym_decltype] = ACTIONS(1819),
    [anon_sym_typename] = ACTIONS(1821),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [145] = {
    [sym_compound_statement] = STATE(8507),
    [sym_type_qualifier] = STATE(3854),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4605),
    [sym_sized_type_specifier] = STATE(1810),
    [sym_enum_specifier] = STATE(1810),
    [sym_struct_specifier] = STATE(1810),
    [sym_union_specifier] = STATE(1810),
    [sym_expression] = STATE(2923),
    [sym__string] = STATE(3173),
    [sym_comma_expression] = STATE(8507),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_type_descriptor] = STATE(8202),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_placeholder_type_specifier] = STATE(1810),
    [sym_decltype_auto] = STATE(1804),
    [sym_decltype] = STATE(1755),
    [sym_class_specifier] = STATE(1810),
    [sym__class_name] = STATE(7687),
    [sym_dependent_type] = STATE(1810),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym__unary_left_fold] = STATE(8348),
    [sym__unary_right_fold] = STATE(8278),
    [sym__binary_fold] = STATE(8484),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5594),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym__assignment_expression_lhs] = STATE(8151),
    [sym_user_defined_literal] = STATE(3443),
    [aux_sym__type_definition_type_repeat1] = STATE(3854),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(2013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(1775),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(1781),
    [anon_sym_unsigned] = ACTIONS(1781),
    [anon_sym_long] = ACTIONS(1781),
    [anon_sym_short] = ACTIONS(1781),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(1785),
    [anon_sym_enum] = ACTIONS(1787),
    [anon_sym_class] = ACTIONS(1789),
    [anon_sym_struct] = ACTIONS(1791),
    [anon_sym_union] = ACTIONS(1793),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1817),
    [anon_sym_decltype] = ACTIONS(1819),
    [anon_sym_typename] = ACTIONS(1821),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [146] = {
    [sym_compound_statement] = STATE(8059),
    [sym_type_qualifier] = STATE(3854),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4605),
    [sym_sized_type_specifier] = STATE(1810),
    [sym_enum_specifier] = STATE(1810),
    [sym_struct_specifier] = STATE(1810),
    [sym_union_specifier] = STATE(1810),
    [sym_expression] = STATE(2841),
    [sym__string] = STATE(3173),
    [sym_comma_expression] = STATE(8059),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_type_descriptor] = STATE(7767),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_placeholder_type_specifier] = STATE(1810),
    [sym_decltype_auto] = STATE(1804),
    [sym_decltype] = STATE(1755),
    [sym_class_specifier] = STATE(1810),
    [sym__class_name] = STATE(7687),
    [sym_dependent_type] = STATE(1810),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym__unary_left_fold] = STATE(7788),
    [sym__unary_right_fold] = STATE(7790),
    [sym__binary_fold] = STATE(7792),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5594),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym__assignment_expression_lhs] = STATE(8126),
    [sym_user_defined_literal] = STATE(3443),
    [aux_sym__type_definition_type_repeat1] = STATE(3854),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(2013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(1775),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(1781),
    [anon_sym_unsigned] = ACTIONS(1781),
    [anon_sym_long] = ACTIONS(1781),
    [anon_sym_short] = ACTIONS(1781),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(1785),
    [anon_sym_enum] = ACTIONS(1787),
    [anon_sym_class] = ACTIONS(1789),
    [anon_sym_struct] = ACTIONS(1791),
    [anon_sym_union] = ACTIONS(1793),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1817),
    [anon_sym_decltype] = ACTIONS(1819),
    [anon_sym_typename] = ACTIONS(1821),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [147] = {
    [sym_compound_statement] = STATE(8507),
    [sym_type_qualifier] = STATE(3854),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4605),
    [sym_sized_type_specifier] = STATE(1810),
    [sym_enum_specifier] = STATE(1810),
    [sym_struct_specifier] = STATE(1810),
    [sym_union_specifier] = STATE(1810),
    [sym_expression] = STATE(2923),
    [sym__string] = STATE(3173),
    [sym_comma_expression] = STATE(8507),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_type_descriptor] = STATE(8529),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_placeholder_type_specifier] = STATE(1810),
    [sym_decltype_auto] = STATE(1804),
    [sym_decltype] = STATE(1755),
    [sym_class_specifier] = STATE(1810),
    [sym__class_name] = STATE(7687),
    [sym_dependent_type] = STATE(1810),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym__unary_left_fold] = STATE(8348),
    [sym__unary_right_fold] = STATE(8278),
    [sym__binary_fold] = STATE(8484),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5594),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym__assignment_expression_lhs] = STATE(8151),
    [sym_user_defined_literal] = STATE(3443),
    [aux_sym__type_definition_type_repeat1] = STATE(3854),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(2013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(1775),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(1781),
    [anon_sym_unsigned] = ACTIONS(1781),
    [anon_sym_long] = ACTIONS(1781),
    [anon_sym_short] = ACTIONS(1781),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(1785),
    [anon_sym_enum] = ACTIONS(1787),
    [anon_sym_class] = ACTIONS(1789),
    [anon_sym_struct] = ACTIONS(1791),
    [anon_sym_union] = ACTIONS(1793),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1817),
    [anon_sym_decltype] = ACTIONS(1819),
    [anon_sym_typename] = ACTIONS(1821),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [148] = {
    [sym_compound_statement] = STATE(8507),
    [sym_type_qualifier] = STATE(3854),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4605),
    [sym_sized_type_specifier] = STATE(1810),
    [sym_enum_specifier] = STATE(1810),
    [sym_struct_specifier] = STATE(1810),
    [sym_union_specifier] = STATE(1810),
    [sym_expression] = STATE(2923),
    [sym__string] = STATE(3173),
    [sym_comma_expression] = STATE(8507),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_type_descriptor] = STATE(8025),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_placeholder_type_specifier] = STATE(1810),
    [sym_decltype_auto] = STATE(1804),
    [sym_decltype] = STATE(1755),
    [sym_class_specifier] = STATE(1810),
    [sym__class_name] = STATE(7687),
    [sym_dependent_type] = STATE(1810),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym__unary_left_fold] = STATE(8079),
    [sym__unary_right_fold] = STATE(8083),
    [sym__binary_fold] = STATE(8110),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5594),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym__assignment_expression_lhs] = STATE(8151),
    [sym_user_defined_literal] = STATE(3443),
    [aux_sym__type_definition_type_repeat1] = STATE(3854),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(2013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(1775),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(1781),
    [anon_sym_unsigned] = ACTIONS(1781),
    [anon_sym_long] = ACTIONS(1781),
    [anon_sym_short] = ACTIONS(1781),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(1785),
    [anon_sym_enum] = ACTIONS(1787),
    [anon_sym_class] = ACTIONS(1789),
    [anon_sym_struct] = ACTIONS(1791),
    [anon_sym_union] = ACTIONS(1793),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1817),
    [anon_sym_decltype] = ACTIONS(1819),
    [anon_sym_typename] = ACTIONS(1821),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [149] = {
    [sym_compound_statement] = STATE(8507),
    [sym_type_qualifier] = STATE(3854),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4605),
    [sym_sized_type_specifier] = STATE(1810),
    [sym_enum_specifier] = STATE(1810),
    [sym_struct_specifier] = STATE(1810),
    [sym_union_specifier] = STATE(1810),
    [sym_expression] = STATE(2923),
    [sym__string] = STATE(3173),
    [sym_comma_expression] = STATE(8507),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_type_descriptor] = STATE(8329),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_placeholder_type_specifier] = STATE(1810),
    [sym_decltype_auto] = STATE(1804),
    [sym_decltype] = STATE(1755),
    [sym_class_specifier] = STATE(1810),
    [sym__class_name] = STATE(7687),
    [sym_dependent_type] = STATE(1810),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym__unary_left_fold] = STATE(8348),
    [sym__unary_right_fold] = STATE(8278),
    [sym__binary_fold] = STATE(8484),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5594),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym__assignment_expression_lhs] = STATE(8151),
    [sym_user_defined_literal] = STATE(3443),
    [aux_sym__type_definition_type_repeat1] = STATE(3854),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(2013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(1775),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(1781),
    [anon_sym_unsigned] = ACTIONS(1781),
    [anon_sym_long] = ACTIONS(1781),
    [anon_sym_short] = ACTIONS(1781),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(1785),
    [anon_sym_enum] = ACTIONS(1787),
    [anon_sym_class] = ACTIONS(1789),
    [anon_sym_struct] = ACTIONS(1791),
    [anon_sym_union] = ACTIONS(1793),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1817),
    [anon_sym_decltype] = ACTIONS(1819),
    [anon_sym_typename] = ACTIONS(1821),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [150] = {
    [sym_compound_statement] = STATE(8507),
    [sym_type_qualifier] = STATE(3854),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4605),
    [sym_sized_type_specifier] = STATE(1810),
    [sym_enum_specifier] = STATE(1810),
    [sym_struct_specifier] = STATE(1810),
    [sym_union_specifier] = STATE(1810),
    [sym_expression] = STATE(2923),
    [sym__string] = STATE(3173),
    [sym_comma_expression] = STATE(8507),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_type_descriptor] = STATE(8314),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_placeholder_type_specifier] = STATE(1810),
    [sym_decltype_auto] = STATE(1804),
    [sym_decltype] = STATE(1755),
    [sym_class_specifier] = STATE(1810),
    [sym__class_name] = STATE(7687),
    [sym_dependent_type] = STATE(1810),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym__unary_left_fold] = STATE(8348),
    [sym__unary_right_fold] = STATE(8278),
    [sym__binary_fold] = STATE(8484),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5594),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym__assignment_expression_lhs] = STATE(8151),
    [sym_user_defined_literal] = STATE(3443),
    [aux_sym__type_definition_type_repeat1] = STATE(3854),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(2013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(1775),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(1781),
    [anon_sym_unsigned] = ACTIONS(1781),
    [anon_sym_long] = ACTIONS(1781),
    [anon_sym_short] = ACTIONS(1781),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(1785),
    [anon_sym_enum] = ACTIONS(1787),
    [anon_sym_class] = ACTIONS(1789),
    [anon_sym_struct] = ACTIONS(1791),
    [anon_sym_union] = ACTIONS(1793),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1817),
    [anon_sym_decltype] = ACTIONS(1819),
    [anon_sym_typename] = ACTIONS(1821),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [151] = {
    [sym_compound_statement] = STATE(8507),
    [sym_type_qualifier] = STATE(3854),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4605),
    [sym_sized_type_specifier] = STATE(1810),
    [sym_enum_specifier] = STATE(1810),
    [sym_struct_specifier] = STATE(1810),
    [sym_union_specifier] = STATE(1810),
    [sym_expression] = STATE(2923),
    [sym__string] = STATE(3173),
    [sym_comma_expression] = STATE(8507),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_type_descriptor] = STATE(8048),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_placeholder_type_specifier] = STATE(1810),
    [sym_decltype_auto] = STATE(1804),
    [sym_decltype] = STATE(1755),
    [sym_class_specifier] = STATE(1810),
    [sym__class_name] = STATE(7687),
    [sym_dependent_type] = STATE(1810),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym__unary_left_fold] = STATE(8079),
    [sym__unary_right_fold] = STATE(8083),
    [sym__binary_fold] = STATE(8110),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5594),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym__assignment_expression_lhs] = STATE(8151),
    [sym_user_defined_literal] = STATE(3443),
    [aux_sym__type_definition_type_repeat1] = STATE(3854),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(2013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(1775),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(1781),
    [anon_sym_unsigned] = ACTIONS(1781),
    [anon_sym_long] = ACTIONS(1781),
    [anon_sym_short] = ACTIONS(1781),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(1785),
    [anon_sym_enum] = ACTIONS(1787),
    [anon_sym_class] = ACTIONS(1789),
    [anon_sym_struct] = ACTIONS(1791),
    [anon_sym_union] = ACTIONS(1793),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1817),
    [anon_sym_decltype] = ACTIONS(1819),
    [anon_sym_typename] = ACTIONS(1821),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [152] = {
    [sym_compound_statement] = STATE(8507),
    [sym_type_qualifier] = STATE(3854),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4605),
    [sym_sized_type_specifier] = STATE(1810),
    [sym_enum_specifier] = STATE(1810),
    [sym_struct_specifier] = STATE(1810),
    [sym_union_specifier] = STATE(1810),
    [sym_expression] = STATE(2923),
    [sym__string] = STATE(3173),
    [sym_comma_expression] = STATE(8507),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_type_descriptor] = STATE(8250),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_placeholder_type_specifier] = STATE(1810),
    [sym_decltype_auto] = STATE(1804),
    [sym_decltype] = STATE(1755),
    [sym_class_specifier] = STATE(1810),
    [sym__class_name] = STATE(7687),
    [sym_dependent_type] = STATE(1810),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym__unary_left_fold] = STATE(8079),
    [sym__unary_right_fold] = STATE(8083),
    [sym__binary_fold] = STATE(8110),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5594),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym__assignment_expression_lhs] = STATE(8151),
    [sym_user_defined_literal] = STATE(3443),
    [aux_sym__type_definition_type_repeat1] = STATE(3854),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(2013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(1775),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(1781),
    [anon_sym_unsigned] = ACTIONS(1781),
    [anon_sym_long] = ACTIONS(1781),
    [anon_sym_short] = ACTIONS(1781),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(1785),
    [anon_sym_enum] = ACTIONS(1787),
    [anon_sym_class] = ACTIONS(1789),
    [anon_sym_struct] = ACTIONS(1791),
    [anon_sym_union] = ACTIONS(1793),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1817),
    [anon_sym_decltype] = ACTIONS(1819),
    [anon_sym_typename] = ACTIONS(1821),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [153] = {
    [sym_compound_statement] = STATE(8059),
    [sym_type_qualifier] = STATE(3854),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4605),
    [sym_sized_type_specifier] = STATE(1810),
    [sym_enum_specifier] = STATE(1810),
    [sym_struct_specifier] = STATE(1810),
    [sym_union_specifier] = STATE(1810),
    [sym_expression] = STATE(2841),
    [sym__string] = STATE(3173),
    [sym_comma_expression] = STATE(8059),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_type_descriptor] = STATE(8523),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_placeholder_type_specifier] = STATE(1810),
    [sym_decltype_auto] = STATE(1804),
    [sym_decltype] = STATE(1755),
    [sym_class_specifier] = STATE(1810),
    [sym__class_name] = STATE(7687),
    [sym_dependent_type] = STATE(1810),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym__unary_left_fold] = STATE(7788),
    [sym__unary_right_fold] = STATE(7790),
    [sym__binary_fold] = STATE(7792),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5594),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym__assignment_expression_lhs] = STATE(8126),
    [sym_user_defined_literal] = STATE(3443),
    [aux_sym__type_definition_type_repeat1] = STATE(3854),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(2013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(1775),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(1781),
    [anon_sym_unsigned] = ACTIONS(1781),
    [anon_sym_long] = ACTIONS(1781),
    [anon_sym_short] = ACTIONS(1781),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(1785),
    [anon_sym_enum] = ACTIONS(1787),
    [anon_sym_class] = ACTIONS(1789),
    [anon_sym_struct] = ACTIONS(1791),
    [anon_sym_union] = ACTIONS(1793),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1817),
    [anon_sym_decltype] = ACTIONS(1819),
    [anon_sym_typename] = ACTIONS(1821),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [154] = {
    [sym_compound_statement] = STATE(8507),
    [sym_type_qualifier] = STATE(3854),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4605),
    [sym_sized_type_specifier] = STATE(1810),
    [sym_enum_specifier] = STATE(1810),
    [sym_struct_specifier] = STATE(1810),
    [sym_union_specifier] = STATE(1810),
    [sym_expression] = STATE(2923),
    [sym__string] = STATE(3173),
    [sym_comma_expression] = STATE(8507),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_type_descriptor] = STATE(8122),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_placeholder_type_specifier] = STATE(1810),
    [sym_decltype_auto] = STATE(1804),
    [sym_decltype] = STATE(1755),
    [sym_class_specifier] = STATE(1810),
    [sym__class_name] = STATE(7687),
    [sym_dependent_type] = STATE(1810),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym__unary_left_fold] = STATE(8348),
    [sym__unary_right_fold] = STATE(8278),
    [sym__binary_fold] = STATE(8484),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5594),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym__assignment_expression_lhs] = STATE(8151),
    [sym_user_defined_literal] = STATE(3443),
    [aux_sym__type_definition_type_repeat1] = STATE(3854),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(2013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(1775),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(1781),
    [anon_sym_unsigned] = ACTIONS(1781),
    [anon_sym_long] = ACTIONS(1781),
    [anon_sym_short] = ACTIONS(1781),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(1785),
    [anon_sym_enum] = ACTIONS(1787),
    [anon_sym_class] = ACTIONS(1789),
    [anon_sym_struct] = ACTIONS(1791),
    [anon_sym_union] = ACTIONS(1793),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1817),
    [anon_sym_decltype] = ACTIONS(1819),
    [anon_sym_typename] = ACTIONS(1821),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [155] = {
    [sym_compound_statement] = STATE(8507),
    [sym_type_qualifier] = STATE(3854),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4605),
    [sym_sized_type_specifier] = STATE(1810),
    [sym_enum_specifier] = STATE(1810),
    [sym_struct_specifier] = STATE(1810),
    [sym_union_specifier] = STATE(1810),
    [sym_expression] = STATE(2923),
    [sym__string] = STATE(3173),
    [sym_comma_expression] = STATE(8507),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_type_descriptor] = STATE(8462),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_placeholder_type_specifier] = STATE(1810),
    [sym_decltype_auto] = STATE(1804),
    [sym_decltype] = STATE(1755),
    [sym_class_specifier] = STATE(1810),
    [sym__class_name] = STATE(7687),
    [sym_dependent_type] = STATE(1810),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym__unary_left_fold] = STATE(8348),
    [sym__unary_right_fold] = STATE(8278),
    [sym__binary_fold] = STATE(8484),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5594),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym__assignment_expression_lhs] = STATE(8151),
    [sym_user_defined_literal] = STATE(3443),
    [aux_sym__type_definition_type_repeat1] = STATE(3854),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(2013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(1775),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(1781),
    [anon_sym_unsigned] = ACTIONS(1781),
    [anon_sym_long] = ACTIONS(1781),
    [anon_sym_short] = ACTIONS(1781),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(1785),
    [anon_sym_enum] = ACTIONS(1787),
    [anon_sym_class] = ACTIONS(1789),
    [anon_sym_struct] = ACTIONS(1791),
    [anon_sym_union] = ACTIONS(1793),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1817),
    [anon_sym_decltype] = ACTIONS(1819),
    [anon_sym_typename] = ACTIONS(1821),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [156] = {
    [sym_compound_statement] = STATE(8507),
    [sym_type_qualifier] = STATE(3854),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4605),
    [sym_sized_type_specifier] = STATE(1810),
    [sym_enum_specifier] = STATE(1810),
    [sym_struct_specifier] = STATE(1810),
    [sym_union_specifier] = STATE(1810),
    [sym_expression] = STATE(2923),
    [sym__string] = STATE(3173),
    [sym_comma_expression] = STATE(8507),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_type_descriptor] = STATE(8477),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_placeholder_type_specifier] = STATE(1810),
    [sym_decltype_auto] = STATE(1804),
    [sym_decltype] = STATE(1755),
    [sym_class_specifier] = STATE(1810),
    [sym__class_name] = STATE(7687),
    [sym_dependent_type] = STATE(1810),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym__unary_left_fold] = STATE(8348),
    [sym__unary_right_fold] = STATE(8278),
    [sym__binary_fold] = STATE(8484),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5594),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym__assignment_expression_lhs] = STATE(8151),
    [sym_user_defined_literal] = STATE(3443),
    [aux_sym__type_definition_type_repeat1] = STATE(3854),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(2013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(1775),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(1781),
    [anon_sym_unsigned] = ACTIONS(1781),
    [anon_sym_long] = ACTIONS(1781),
    [anon_sym_short] = ACTIONS(1781),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(1785),
    [anon_sym_enum] = ACTIONS(1787),
    [anon_sym_class] = ACTIONS(1789),
    [anon_sym_struct] = ACTIONS(1791),
    [anon_sym_union] = ACTIONS(1793),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1817),
    [anon_sym_decltype] = ACTIONS(1819),
    [anon_sym_typename] = ACTIONS(1821),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [157] = {
    [sym_compound_statement] = STATE(8507),
    [sym_type_qualifier] = STATE(3854),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4605),
    [sym_sized_type_specifier] = STATE(1810),
    [sym_enum_specifier] = STATE(1810),
    [sym_struct_specifier] = STATE(1810),
    [sym_union_specifier] = STATE(1810),
    [sym_expression] = STATE(2923),
    [sym__string] = STATE(3173),
    [sym_comma_expression] = STATE(8507),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_type_descriptor] = STATE(8315),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_placeholder_type_specifier] = STATE(1810),
    [sym_decltype_auto] = STATE(1804),
    [sym_decltype] = STATE(1755),
    [sym_class_specifier] = STATE(1810),
    [sym__class_name] = STATE(7687),
    [sym_dependent_type] = STATE(1810),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym__unary_left_fold] = STATE(8348),
    [sym__unary_right_fold] = STATE(8278),
    [sym__binary_fold] = STATE(8484),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5594),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym__assignment_expression_lhs] = STATE(8151),
    [sym_user_defined_literal] = STATE(3443),
    [aux_sym__type_definition_type_repeat1] = STATE(3854),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(2013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(1775),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(1781),
    [anon_sym_unsigned] = ACTIONS(1781),
    [anon_sym_long] = ACTIONS(1781),
    [anon_sym_short] = ACTIONS(1781),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(1785),
    [anon_sym_enum] = ACTIONS(1787),
    [anon_sym_class] = ACTIONS(1789),
    [anon_sym_struct] = ACTIONS(1791),
    [anon_sym_union] = ACTIONS(1793),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1817),
    [anon_sym_decltype] = ACTIONS(1819),
    [anon_sym_typename] = ACTIONS(1821),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [158] = {
    [sym_compound_statement] = STATE(8511),
    [sym_type_qualifier] = STATE(3854),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4605),
    [sym_sized_type_specifier] = STATE(1810),
    [sym_enum_specifier] = STATE(1810),
    [sym_struct_specifier] = STATE(1810),
    [sym_union_specifier] = STATE(1810),
    [sym_expression] = STATE(2893),
    [sym__string] = STATE(3173),
    [sym_comma_expression] = STATE(8511),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_type_descriptor] = STATE(8556),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_placeholder_type_specifier] = STATE(1810),
    [sym_decltype_auto] = STATE(1804),
    [sym_decltype] = STATE(1755),
    [sym_class_specifier] = STATE(1810),
    [sym__class_name] = STATE(7687),
    [sym_dependent_type] = STATE(1810),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym__unary_left_fold] = STATE(8566),
    [sym__unary_right_fold] = STATE(8127),
    [sym__binary_fold] = STATE(8332),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5594),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym__assignment_expression_lhs] = STATE(8294),
    [sym_user_defined_literal] = STATE(3443),
    [aux_sym__type_definition_type_repeat1] = STATE(3854),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(2013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(1775),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(1781),
    [anon_sym_unsigned] = ACTIONS(1781),
    [anon_sym_long] = ACTIONS(1781),
    [anon_sym_short] = ACTIONS(1781),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(1785),
    [anon_sym_enum] = ACTIONS(1787),
    [anon_sym_class] = ACTIONS(1789),
    [anon_sym_struct] = ACTIONS(1791),
    [anon_sym_union] = ACTIONS(1793),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1817),
    [anon_sym_decltype] = ACTIONS(1819),
    [anon_sym_typename] = ACTIONS(1821),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [159] = {
    [sym_compound_statement] = STATE(8507),
    [sym_type_qualifier] = STATE(3854),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4605),
    [sym_sized_type_specifier] = STATE(1810),
    [sym_enum_specifier] = STATE(1810),
    [sym_struct_specifier] = STATE(1810),
    [sym_union_specifier] = STATE(1810),
    [sym_expression] = STATE(2923),
    [sym__string] = STATE(3173),
    [sym_comma_expression] = STATE(8507),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_type_descriptor] = STATE(8029),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_placeholder_type_specifier] = STATE(1810),
    [sym_decltype_auto] = STATE(1804),
    [sym_decltype] = STATE(1755),
    [sym_class_specifier] = STATE(1810),
    [sym__class_name] = STATE(7687),
    [sym_dependent_type] = STATE(1810),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym__unary_left_fold] = STATE(8348),
    [sym__unary_right_fold] = STATE(8278),
    [sym__binary_fold] = STATE(8484),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5594),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym__assignment_expression_lhs] = STATE(8151),
    [sym_user_defined_literal] = STATE(3443),
    [aux_sym__type_definition_type_repeat1] = STATE(3854),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(2013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(1775),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(1781),
    [anon_sym_unsigned] = ACTIONS(1781),
    [anon_sym_long] = ACTIONS(1781),
    [anon_sym_short] = ACTIONS(1781),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(1785),
    [anon_sym_enum] = ACTIONS(1787),
    [anon_sym_class] = ACTIONS(1789),
    [anon_sym_struct] = ACTIONS(1791),
    [anon_sym_union] = ACTIONS(1793),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1817),
    [anon_sym_decltype] = ACTIONS(1819),
    [anon_sym_typename] = ACTIONS(1821),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [160] = {
    [sym_compound_statement] = STATE(8507),
    [sym_type_qualifier] = STATE(3854),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4605),
    [sym_sized_type_specifier] = STATE(1810),
    [sym_enum_specifier] = STATE(1810),
    [sym_struct_specifier] = STATE(1810),
    [sym_union_specifier] = STATE(1810),
    [sym_expression] = STATE(2923),
    [sym__string] = STATE(3173),
    [sym_comma_expression] = STATE(8507),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_type_descriptor] = STATE(8158),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_placeholder_type_specifier] = STATE(1810),
    [sym_decltype_auto] = STATE(1804),
    [sym_decltype] = STATE(1755),
    [sym_class_specifier] = STATE(1810),
    [sym__class_name] = STATE(7687),
    [sym_dependent_type] = STATE(1810),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym__unary_left_fold] = STATE(8348),
    [sym__unary_right_fold] = STATE(8278),
    [sym__binary_fold] = STATE(8484),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5594),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym__assignment_expression_lhs] = STATE(8151),
    [sym_user_defined_literal] = STATE(3443),
    [aux_sym__type_definition_type_repeat1] = STATE(3854),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(2013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(1775),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(1781),
    [anon_sym_unsigned] = ACTIONS(1781),
    [anon_sym_long] = ACTIONS(1781),
    [anon_sym_short] = ACTIONS(1781),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(1785),
    [anon_sym_enum] = ACTIONS(1787),
    [anon_sym_class] = ACTIONS(1789),
    [anon_sym_struct] = ACTIONS(1791),
    [anon_sym_union] = ACTIONS(1793),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1817),
    [anon_sym_decltype] = ACTIONS(1819),
    [anon_sym_typename] = ACTIONS(1821),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [161] = {
    [sym_compound_statement] = STATE(8507),
    [sym_type_qualifier] = STATE(3854),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4605),
    [sym_sized_type_specifier] = STATE(1810),
    [sym_enum_specifier] = STATE(1810),
    [sym_struct_specifier] = STATE(1810),
    [sym_union_specifier] = STATE(1810),
    [sym_expression] = STATE(2923),
    [sym__string] = STATE(3173),
    [sym_comma_expression] = STATE(8507),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_type_descriptor] = STATE(8496),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_placeholder_type_specifier] = STATE(1810),
    [sym_decltype_auto] = STATE(1804),
    [sym_decltype] = STATE(1755),
    [sym_class_specifier] = STATE(1810),
    [sym__class_name] = STATE(7687),
    [sym_dependent_type] = STATE(1810),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym__unary_left_fold] = STATE(8079),
    [sym__unary_right_fold] = STATE(8083),
    [sym__binary_fold] = STATE(8110),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5594),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym__assignment_expression_lhs] = STATE(8151),
    [sym_user_defined_literal] = STATE(3443),
    [aux_sym__type_definition_type_repeat1] = STATE(3854),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(2013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(1775),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(1781),
    [anon_sym_unsigned] = ACTIONS(1781),
    [anon_sym_long] = ACTIONS(1781),
    [anon_sym_short] = ACTIONS(1781),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(1785),
    [anon_sym_enum] = ACTIONS(1787),
    [anon_sym_class] = ACTIONS(1789),
    [anon_sym_struct] = ACTIONS(1791),
    [anon_sym_union] = ACTIONS(1793),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1817),
    [anon_sym_decltype] = ACTIONS(1819),
    [anon_sym_typename] = ACTIONS(1821),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [162] = {
    [sym_compound_statement] = STATE(8507),
    [sym_type_qualifier] = STATE(3854),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4605),
    [sym_sized_type_specifier] = STATE(1810),
    [sym_enum_specifier] = STATE(1810),
    [sym_struct_specifier] = STATE(1810),
    [sym_union_specifier] = STATE(1810),
    [sym_expression] = STATE(2923),
    [sym__string] = STATE(3173),
    [sym_comma_expression] = STATE(8507),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_type_descriptor] = STATE(8284),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_placeholder_type_specifier] = STATE(1810),
    [sym_decltype_auto] = STATE(1804),
    [sym_decltype] = STATE(1755),
    [sym_class_specifier] = STATE(1810),
    [sym__class_name] = STATE(7687),
    [sym_dependent_type] = STATE(1810),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym__unary_left_fold] = STATE(8079),
    [sym__unary_right_fold] = STATE(8083),
    [sym__binary_fold] = STATE(8110),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5594),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym__assignment_expression_lhs] = STATE(8151),
    [sym_user_defined_literal] = STATE(3443),
    [aux_sym__type_definition_type_repeat1] = STATE(3854),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(2013),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(1775),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_signed] = ACTIONS(1781),
    [anon_sym_unsigned] = ACTIONS(1781),
    [anon_sym_long] = ACTIONS(1781),
    [anon_sym_short] = ACTIONS(1781),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(1785),
    [anon_sym_enum] = ACTIONS(1787),
    [anon_sym_class] = ACTIONS(1789),
    [anon_sym_struct] = ACTIONS(1791),
    [anon_sym_union] = ACTIONS(1793),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1817),
    [anon_sym_decltype] = ACTIONS(1819),
    [anon_sym_typename] = ACTIONS(1821),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [163] = {
    [sym_attribute_declaration] = STATE(174),
    [sym_compound_statement] = STATE(500),
    [sym_attributed_statement] = STATE(500),
    [sym_statement] = STATE(485),
    [sym_labeled_statement] = STATE(500),
    [sym_expression_statement] = STATE(500),
    [sym_if_statement] = STATE(500),
    [sym_switch_statement] = STATE(500),
    [sym_case_statement] = STATE(500),
    [sym_while_statement] = STATE(500),
    [sym_do_statement] = STATE(500),
    [sym_for_statement] = STATE(500),
    [sym_return_statement] = STATE(500),
    [sym_break_statement] = STATE(500),
    [sym_continue_statement] = STATE(500),
    [sym_goto_statement] = STATE(500),
    [sym_seh_try_statement] = STATE(500),
    [sym_seh_leave_statement] = STATE(500),
    [sym_expression] = STATE(4373),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8412),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(500),
    [sym_co_return_statement] = STATE(500),
    [sym_co_yield_statement] = STATE(500),
    [sym_throw_statement] = STATE(500),
    [sym_try_statement] = STATE(500),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(174),
    [sym_identifier] = ACTIONS(2019),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1503),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_if] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_default] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(93),
    [anon_sym_break] = ACTIONS(95),
    [anon_sym_continue] = ACTIONS(97),
    [anon_sym_goto] = ACTIONS(99),
    [anon_sym___try] = ACTIONS(1507),
    [anon_sym___leave] = ACTIONS(1509),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [164] = {
    [sym_attribute_declaration] = STATE(216),
    [sym_compound_statement] = STATE(462),
    [sym_attributed_statement] = STATE(462),
    [sym_statement] = STATE(475),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [sym_identifier] = ACTIONS(2025),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [165] = {
    [sym_attribute_declaration] = STATE(216),
    [sym_compound_statement] = STATE(462),
    [sym_attributed_statement] = STATE(462),
    [sym_statement] = STATE(477),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [sym_identifier] = ACTIONS(2025),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [166] = {
    [sym_attribute_declaration] = STATE(216),
    [sym_compound_statement] = STATE(462),
    [sym_attributed_statement] = STATE(462),
    [sym_statement] = STATE(478),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [sym_identifier] = ACTIONS(2025),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [167] = {
    [sym_expression] = STATE(3065),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_initializer_list] = STATE(3368),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1917),
    [anon_sym_COMMA] = ACTIONS(1917),
    [anon_sym_RPAREN] = ACTIONS(1917),
    [anon_sym_LPAREN2] = ACTIONS(1917),
    [anon_sym_BANG] = ACTIONS(1769),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1915),
    [anon_sym_PLUS] = ACTIONS(1915),
    [anon_sym_STAR] = ACTIONS(1915),
    [anon_sym_SLASH] = ACTIONS(1915),
    [anon_sym_PERCENT] = ACTIONS(1915),
    [anon_sym_PIPE_PIPE] = ACTIONS(1917),
    [anon_sym_AMP_AMP] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(1915),
    [anon_sym_CARET] = ACTIONS(1915),
    [anon_sym_AMP] = ACTIONS(1915),
    [anon_sym_EQ_EQ] = ACTIONS(1917),
    [anon_sym_BANG_EQ] = ACTIONS(1917),
    [anon_sym_GT] = ACTIONS(1915),
    [anon_sym_GT_EQ] = ACTIONS(1917),
    [anon_sym_LT_EQ] = ACTIONS(1915),
    [anon_sym_LT] = ACTIONS(1915),
    [anon_sym_LT_LT] = ACTIONS(1915),
    [anon_sym_GT_GT] = ACTIONS(1915),
    [anon_sym___extension__] = ACTIONS(2029),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(1917),
    [anon_sym_EQ] = ACTIONS(1915),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_QMARK] = ACTIONS(1917),
    [anon_sym_STAR_EQ] = ACTIONS(1917),
    [anon_sym_SLASH_EQ] = ACTIONS(1917),
    [anon_sym_PERCENT_EQ] = ACTIONS(1917),
    [anon_sym_PLUS_EQ] = ACTIONS(1917),
    [anon_sym_DASH_EQ] = ACTIONS(1917),
    [anon_sym_LT_LT_EQ] = ACTIONS(1917),
    [anon_sym_GT_GT_EQ] = ACTIONS(1917),
    [anon_sym_AMP_EQ] = ACTIONS(1917),
    [anon_sym_CARET_EQ] = ACTIONS(1917),
    [anon_sym_PIPE_EQ] = ACTIONS(1917),
    [anon_sym_and_eq] = ACTIONS(1915),
    [anon_sym_or_eq] = ACTIONS(1915),
    [anon_sym_xor_eq] = ACTIONS(1915),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_LT_EQ_GT] = ACTIONS(1917),
    [anon_sym_or] = ACTIONS(1915),
    [anon_sym_and] = ACTIONS(1915),
    [anon_sym_bitor] = ACTIONS(1915),
    [anon_sym_xor] = ACTIONS(1915),
    [anon_sym_bitand] = ACTIONS(1915),
    [anon_sym_not_eq] = ACTIONS(1915),
    [anon_sym_DASH_DASH] = ACTIONS(1917),
    [anon_sym_PLUS_PLUS] = ACTIONS(1917),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [anon_sym_DOT] = ACTIONS(1915),
    [anon_sym_DOT_STAR] = ACTIONS(1917),
    [anon_sym_DASH_GT] = ACTIONS(1915),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [anon_sym_DASH_GT_STAR] = ACTIONS(1917),
    [sym_this] = ACTIONS(1813),
  },
  [168] = {
    [sym_attribute_declaration] = STATE(174),
    [sym_compound_statement] = STATE(500),
    [sym_attributed_statement] = STATE(500),
    [sym_statement] = STATE(421),
    [sym_labeled_statement] = STATE(500),
    [sym_expression_statement] = STATE(500),
    [sym_if_statement] = STATE(500),
    [sym_switch_statement] = STATE(500),
    [sym_case_statement] = STATE(500),
    [sym_while_statement] = STATE(500),
    [sym_do_statement] = STATE(500),
    [sym_for_statement] = STATE(500),
    [sym_return_statement] = STATE(500),
    [sym_break_statement] = STATE(500),
    [sym_continue_statement] = STATE(500),
    [sym_goto_statement] = STATE(500),
    [sym_seh_try_statement] = STATE(500),
    [sym_seh_leave_statement] = STATE(500),
    [sym_expression] = STATE(4373),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8412),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(500),
    [sym_co_return_statement] = STATE(500),
    [sym_co_yield_statement] = STATE(500),
    [sym_throw_statement] = STATE(500),
    [sym_try_statement] = STATE(500),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(174),
    [sym_identifier] = ACTIONS(2019),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1503),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_if] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_default] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(93),
    [anon_sym_break] = ACTIONS(95),
    [anon_sym_continue] = ACTIONS(97),
    [anon_sym_goto] = ACTIONS(99),
    [anon_sym___try] = ACTIONS(1507),
    [anon_sym___leave] = ACTIONS(1509),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [169] = {
    [sym_attribute_declaration] = STATE(187),
    [sym_compound_statement] = STATE(462),
    [sym_attributed_statement] = STATE(462),
    [sym_statement] = STATE(8366),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(187),
    [sym_identifier] = ACTIONS(2035),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_if] = ACTIONS(1679),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(1673),
    [anon_sym_default] = ACTIONS(1675),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_for] = ACTIONS(1683),
    [anon_sym_return] = ACTIONS(93),
    [anon_sym_break] = ACTIONS(95),
    [anon_sym_continue] = ACTIONS(97),
    [anon_sym_goto] = ACTIONS(99),
    [anon_sym___try] = ACTIONS(1685),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [170] = {
    [sym_attribute_declaration] = STATE(197),
    [sym_compound_statement] = STATE(235),
    [sym_attributed_statement] = STATE(235),
    [sym_statement] = STATE(229),
    [sym_labeled_statement] = STATE(235),
    [sym_expression_statement] = STATE(235),
    [sym_if_statement] = STATE(235),
    [sym_switch_statement] = STATE(235),
    [sym_case_statement] = STATE(235),
    [sym_while_statement] = STATE(235),
    [sym_do_statement] = STATE(235),
    [sym_for_statement] = STATE(235),
    [sym_return_statement] = STATE(235),
    [sym_break_statement] = STATE(235),
    [sym_continue_statement] = STATE(235),
    [sym_goto_statement] = STATE(235),
    [sym_seh_try_statement] = STATE(235),
    [sym_seh_leave_statement] = STATE(235),
    [sym_expression] = STATE(4387),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8324),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(235),
    [sym_co_return_statement] = STATE(235),
    [sym_co_yield_statement] = STATE(235),
    [sym_throw_statement] = STATE(235),
    [sym_try_statement] = STATE(235),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(197),
    [sym_identifier] = ACTIONS(2037),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [171] = {
    [sym_attribute_declaration] = STATE(197),
    [sym_compound_statement] = STATE(235),
    [sym_attributed_statement] = STATE(235),
    [sym_statement] = STATE(262),
    [sym_labeled_statement] = STATE(235),
    [sym_expression_statement] = STATE(235),
    [sym_if_statement] = STATE(235),
    [sym_switch_statement] = STATE(235),
    [sym_case_statement] = STATE(235),
    [sym_while_statement] = STATE(235),
    [sym_do_statement] = STATE(235),
    [sym_for_statement] = STATE(235),
    [sym_return_statement] = STATE(235),
    [sym_break_statement] = STATE(235),
    [sym_continue_statement] = STATE(235),
    [sym_goto_statement] = STATE(235),
    [sym_seh_try_statement] = STATE(235),
    [sym_seh_leave_statement] = STATE(235),
    [sym_expression] = STATE(4387),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8324),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(235),
    [sym_co_return_statement] = STATE(235),
    [sym_co_yield_statement] = STATE(235),
    [sym_throw_statement] = STATE(235),
    [sym_try_statement] = STATE(235),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(197),
    [sym_identifier] = ACTIONS(2037),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [172] = {
    [sym_attribute_declaration] = STATE(174),
    [sym_compound_statement] = STATE(500),
    [sym_attributed_statement] = STATE(500),
    [sym_statement] = STATE(480),
    [sym_labeled_statement] = STATE(500),
    [sym_expression_statement] = STATE(500),
    [sym_if_statement] = STATE(500),
    [sym_switch_statement] = STATE(500),
    [sym_case_statement] = STATE(500),
    [sym_while_statement] = STATE(500),
    [sym_do_statement] = STATE(500),
    [sym_for_statement] = STATE(500),
    [sym_return_statement] = STATE(500),
    [sym_break_statement] = STATE(500),
    [sym_continue_statement] = STATE(500),
    [sym_goto_statement] = STATE(500),
    [sym_seh_try_statement] = STATE(500),
    [sym_seh_leave_statement] = STATE(500),
    [sym_expression] = STATE(4373),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8412),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(500),
    [sym_co_return_statement] = STATE(500),
    [sym_co_yield_statement] = STATE(500),
    [sym_throw_statement] = STATE(500),
    [sym_try_statement] = STATE(500),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(174),
    [sym_identifier] = ACTIONS(2019),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1503),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_if] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_default] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(93),
    [anon_sym_break] = ACTIONS(95),
    [anon_sym_continue] = ACTIONS(97),
    [anon_sym_goto] = ACTIONS(99),
    [anon_sym___try] = ACTIONS(1507),
    [anon_sym___leave] = ACTIONS(1509),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [173] = {
    [sym_attribute_declaration] = STATE(173),
    [sym_compound_statement] = STATE(235),
    [sym_attributed_statement] = STATE(235),
    [sym_statement] = STATE(266),
    [sym_labeled_statement] = STATE(235),
    [sym_expression_statement] = STATE(235),
    [sym_if_statement] = STATE(235),
    [sym_switch_statement] = STATE(235),
    [sym_case_statement] = STATE(235),
    [sym_while_statement] = STATE(235),
    [sym_do_statement] = STATE(235),
    [sym_for_statement] = STATE(235),
    [sym_return_statement] = STATE(235),
    [sym_break_statement] = STATE(235),
    [sym_continue_statement] = STATE(235),
    [sym_goto_statement] = STATE(235),
    [sym_seh_try_statement] = STATE(235),
    [sym_seh_leave_statement] = STATE(235),
    [sym_expression] = STATE(4387),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8324),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(235),
    [sym_co_return_statement] = STATE(235),
    [sym_co_yield_statement] = STATE(235),
    [sym_throw_statement] = STATE(235),
    [sym_try_statement] = STATE(235),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(173),
    [sym_identifier] = ACTIONS(2039),
    [anon_sym_LPAREN2] = ACTIONS(2042),
    [anon_sym_BANG] = ACTIONS(2045),
    [anon_sym_TILDE] = ACTIONS(2045),
    [anon_sym_DASH] = ACTIONS(2048),
    [anon_sym_PLUS] = ACTIONS(2048),
    [anon_sym_STAR] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_SEMI] = ACTIONS(2054),
    [anon_sym___extension__] = ACTIONS(2057),
    [anon_sym_COLON_COLON] = ACTIONS(2060),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2063),
    [anon_sym_LBRACE] = ACTIONS(2066),
    [anon_sym_LBRACK] = ACTIONS(2069),
    [sym_primitive_type] = ACTIONS(2072),
    [anon_sym_if] = ACTIONS(2075),
    [anon_sym_switch] = ACTIONS(2078),
    [anon_sym_case] = ACTIONS(2081),
    [anon_sym_default] = ACTIONS(2084),
    [anon_sym_while] = ACTIONS(2087),
    [anon_sym_do] = ACTIONS(2090),
    [anon_sym_for] = ACTIONS(2093),
    [anon_sym_return] = ACTIONS(2096),
    [anon_sym_break] = ACTIONS(2099),
    [anon_sym_continue] = ACTIONS(2102),
    [anon_sym_goto] = ACTIONS(2105),
    [anon_sym___try] = ACTIONS(2108),
    [anon_sym___leave] = ACTIONS(2111),
    [anon_sym_not] = ACTIONS(2048),
    [anon_sym_compl] = ACTIONS(2048),
    [anon_sym_DASH_DASH] = ACTIONS(2114),
    [anon_sym_PLUS_PLUS] = ACTIONS(2114),
    [anon_sym_sizeof] = ACTIONS(2117),
    [anon_sym___alignof__] = ACTIONS(2120),
    [anon_sym___alignof] = ACTIONS(2120),
    [anon_sym__alignof] = ACTIONS(2120),
    [anon_sym_alignof] = ACTIONS(2120),
    [anon_sym__Alignof] = ACTIONS(2120),
    [anon_sym_offsetof] = ACTIONS(2123),
    [anon_sym__Generic] = ACTIONS(2126),
    [anon_sym_asm] = ACTIONS(2129),
    [anon_sym___asm__] = ACTIONS(2129),
    [anon_sym___asm] = ACTIONS(2129),
    [sym_number_literal] = ACTIONS(2132),
    [anon_sym_L_SQUOTE] = ACTIONS(2135),
    [anon_sym_u_SQUOTE] = ACTIONS(2135),
    [anon_sym_U_SQUOTE] = ACTIONS(2135),
    [anon_sym_u8_SQUOTE] = ACTIONS(2135),
    [anon_sym_SQUOTE] = ACTIONS(2135),
    [anon_sym_L_DQUOTE] = ACTIONS(2138),
    [anon_sym_u_DQUOTE] = ACTIONS(2138),
    [anon_sym_U_DQUOTE] = ACTIONS(2138),
    [anon_sym_u8_DQUOTE] = ACTIONS(2138),
    [anon_sym_DQUOTE] = ACTIONS(2138),
    [sym_true] = ACTIONS(2141),
    [sym_false] = ACTIONS(2141),
    [anon_sym_NULL] = ACTIONS(2144),
    [anon_sym_nullptr] = ACTIONS(2144),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2147),
    [anon_sym_template] = ACTIONS(2150),
    [anon_sym_try] = ACTIONS(2153),
    [anon_sym_delete] = ACTIONS(2156),
    [anon_sym_throw] = ACTIONS(2159),
    [anon_sym_co_return] = ACTIONS(2162),
    [anon_sym_co_yield] = ACTIONS(2165),
    [anon_sym_R_DQUOTE] = ACTIONS(2168),
    [anon_sym_LR_DQUOTE] = ACTIONS(2168),
    [anon_sym_uR_DQUOTE] = ACTIONS(2168),
    [anon_sym_UR_DQUOTE] = ACTIONS(2168),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2168),
    [anon_sym_co_await] = ACTIONS(2171),
    [anon_sym_new] = ACTIONS(2174),
    [anon_sym_requires] = ACTIONS(2177),
    [sym_this] = ACTIONS(2141),
  },
  [174] = {
    [sym_attribute_declaration] = STATE(190),
    [sym_compound_statement] = STATE(500),
    [sym_attributed_statement] = STATE(500),
    [sym_statement] = STATE(457),
    [sym_labeled_statement] = STATE(500),
    [sym_expression_statement] = STATE(500),
    [sym_if_statement] = STATE(500),
    [sym_switch_statement] = STATE(500),
    [sym_case_statement] = STATE(500),
    [sym_while_statement] = STATE(500),
    [sym_do_statement] = STATE(500),
    [sym_for_statement] = STATE(500),
    [sym_return_statement] = STATE(500),
    [sym_break_statement] = STATE(500),
    [sym_continue_statement] = STATE(500),
    [sym_goto_statement] = STATE(500),
    [sym_seh_try_statement] = STATE(500),
    [sym_seh_leave_statement] = STATE(500),
    [sym_expression] = STATE(4373),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8412),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(500),
    [sym_co_return_statement] = STATE(500),
    [sym_co_yield_statement] = STATE(500),
    [sym_throw_statement] = STATE(500),
    [sym_try_statement] = STATE(500),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(190),
    [sym_identifier] = ACTIONS(2019),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1503),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_if] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_default] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(93),
    [anon_sym_break] = ACTIONS(95),
    [anon_sym_continue] = ACTIONS(97),
    [anon_sym_goto] = ACTIONS(99),
    [anon_sym___try] = ACTIONS(1507),
    [anon_sym___leave] = ACTIONS(1509),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [175] = {
    [sym_attribute_declaration] = STATE(197),
    [sym_compound_statement] = STATE(235),
    [sym_attributed_statement] = STATE(235),
    [sym_statement] = STATE(230),
    [sym_labeled_statement] = STATE(235),
    [sym_expression_statement] = STATE(235),
    [sym_if_statement] = STATE(235),
    [sym_switch_statement] = STATE(235),
    [sym_case_statement] = STATE(235),
    [sym_while_statement] = STATE(235),
    [sym_do_statement] = STATE(235),
    [sym_for_statement] = STATE(235),
    [sym_return_statement] = STATE(235),
    [sym_break_statement] = STATE(235),
    [sym_continue_statement] = STATE(235),
    [sym_goto_statement] = STATE(235),
    [sym_seh_try_statement] = STATE(235),
    [sym_seh_leave_statement] = STATE(235),
    [sym_expression] = STATE(4387),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8324),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(235),
    [sym_co_return_statement] = STATE(235),
    [sym_co_yield_statement] = STATE(235),
    [sym_throw_statement] = STATE(235),
    [sym_try_statement] = STATE(235),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(197),
    [sym_identifier] = ACTIONS(2037),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [176] = {
    [sym_attribute_declaration] = STATE(174),
    [sym_compound_statement] = STATE(500),
    [sym_attributed_statement] = STATE(500),
    [sym_statement] = STATE(483),
    [sym_labeled_statement] = STATE(500),
    [sym_expression_statement] = STATE(500),
    [sym_if_statement] = STATE(500),
    [sym_switch_statement] = STATE(500),
    [sym_case_statement] = STATE(500),
    [sym_while_statement] = STATE(500),
    [sym_do_statement] = STATE(500),
    [sym_for_statement] = STATE(500),
    [sym_return_statement] = STATE(500),
    [sym_break_statement] = STATE(500),
    [sym_continue_statement] = STATE(500),
    [sym_goto_statement] = STATE(500),
    [sym_seh_try_statement] = STATE(500),
    [sym_seh_leave_statement] = STATE(500),
    [sym_expression] = STATE(4373),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8412),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(500),
    [sym_co_return_statement] = STATE(500),
    [sym_co_yield_statement] = STATE(500),
    [sym_throw_statement] = STATE(500),
    [sym_try_statement] = STATE(500),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(174),
    [sym_identifier] = ACTIONS(2019),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1503),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_if] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_default] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(93),
    [anon_sym_break] = ACTIONS(95),
    [anon_sym_continue] = ACTIONS(97),
    [anon_sym_goto] = ACTIONS(99),
    [anon_sym___try] = ACTIONS(1507),
    [anon_sym___leave] = ACTIONS(1509),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [177] = {
    [sym_attribute_declaration] = STATE(197),
    [sym_compound_statement] = STATE(235),
    [sym_attributed_statement] = STATE(235),
    [sym_statement] = STATE(254),
    [sym_labeled_statement] = STATE(235),
    [sym_expression_statement] = STATE(235),
    [sym_if_statement] = STATE(235),
    [sym_switch_statement] = STATE(235),
    [sym_case_statement] = STATE(235),
    [sym_while_statement] = STATE(235),
    [sym_do_statement] = STATE(235),
    [sym_for_statement] = STATE(235),
    [sym_return_statement] = STATE(235),
    [sym_break_statement] = STATE(235),
    [sym_continue_statement] = STATE(235),
    [sym_goto_statement] = STATE(235),
    [sym_seh_try_statement] = STATE(235),
    [sym_seh_leave_statement] = STATE(235),
    [sym_expression] = STATE(4387),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8324),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(235),
    [sym_co_return_statement] = STATE(235),
    [sym_co_yield_statement] = STATE(235),
    [sym_throw_statement] = STATE(235),
    [sym_try_statement] = STATE(235),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(197),
    [sym_identifier] = ACTIONS(2037),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [178] = {
    [sym_attribute_declaration] = STATE(197),
    [sym_compound_statement] = STATE(235),
    [sym_attributed_statement] = STATE(235),
    [sym_statement] = STATE(256),
    [sym_labeled_statement] = STATE(235),
    [sym_expression_statement] = STATE(235),
    [sym_if_statement] = STATE(235),
    [sym_switch_statement] = STATE(235),
    [sym_case_statement] = STATE(235),
    [sym_while_statement] = STATE(235),
    [sym_do_statement] = STATE(235),
    [sym_for_statement] = STATE(235),
    [sym_return_statement] = STATE(235),
    [sym_break_statement] = STATE(235),
    [sym_continue_statement] = STATE(235),
    [sym_goto_statement] = STATE(235),
    [sym_seh_try_statement] = STATE(235),
    [sym_seh_leave_statement] = STATE(235),
    [sym_expression] = STATE(4387),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8324),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(235),
    [sym_co_return_statement] = STATE(235),
    [sym_co_yield_statement] = STATE(235),
    [sym_throw_statement] = STATE(235),
    [sym_try_statement] = STATE(235),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(197),
    [sym_identifier] = ACTIONS(2037),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [179] = {
    [sym_attribute_declaration] = STATE(197),
    [sym_compound_statement] = STATE(235),
    [sym_attributed_statement] = STATE(235),
    [sym_statement] = STATE(257),
    [sym_labeled_statement] = STATE(235),
    [sym_expression_statement] = STATE(235),
    [sym_if_statement] = STATE(235),
    [sym_switch_statement] = STATE(235),
    [sym_case_statement] = STATE(235),
    [sym_while_statement] = STATE(235),
    [sym_do_statement] = STATE(235),
    [sym_for_statement] = STATE(235),
    [sym_return_statement] = STATE(235),
    [sym_break_statement] = STATE(235),
    [sym_continue_statement] = STATE(235),
    [sym_goto_statement] = STATE(235),
    [sym_seh_try_statement] = STATE(235),
    [sym_seh_leave_statement] = STATE(235),
    [sym_expression] = STATE(4387),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8324),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(235),
    [sym_co_return_statement] = STATE(235),
    [sym_co_yield_statement] = STATE(235),
    [sym_throw_statement] = STATE(235),
    [sym_try_statement] = STATE(235),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(197),
    [sym_identifier] = ACTIONS(2037),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [180] = {
    [sym_attribute_declaration] = STATE(187),
    [sym_compound_statement] = STATE(462),
    [sym_attributed_statement] = STATE(462),
    [sym_statement] = STATE(7109),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(187),
    [sym_identifier] = ACTIONS(2035),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_if] = ACTIONS(1679),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(1673),
    [anon_sym_default] = ACTIONS(1675),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_for] = ACTIONS(1683),
    [anon_sym_return] = ACTIONS(93),
    [anon_sym_break] = ACTIONS(95),
    [anon_sym_continue] = ACTIONS(97),
    [anon_sym_goto] = ACTIONS(99),
    [anon_sym___try] = ACTIONS(1685),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [181] = {
    [sym_attribute_declaration] = STATE(187),
    [sym_compound_statement] = STATE(462),
    [sym_attributed_statement] = STATE(462),
    [sym_statement] = STATE(438),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(187),
    [sym_identifier] = ACTIONS(2035),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_if] = ACTIONS(1679),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(1673),
    [anon_sym_default] = ACTIONS(1675),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_for] = ACTIONS(1683),
    [anon_sym_return] = ACTIONS(93),
    [anon_sym_break] = ACTIONS(95),
    [anon_sym_continue] = ACTIONS(97),
    [anon_sym_goto] = ACTIONS(99),
    [anon_sym___try] = ACTIONS(1685),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [182] = {
    [sym_attribute_declaration] = STATE(182),
    [sym_compound_statement] = STATE(462),
    [sym_attributed_statement] = STATE(462),
    [sym_statement] = STATE(457),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(182),
    [sym_identifier] = ACTIONS(2180),
    [anon_sym_LPAREN2] = ACTIONS(2042),
    [anon_sym_BANG] = ACTIONS(2045),
    [anon_sym_TILDE] = ACTIONS(2045),
    [anon_sym_DASH] = ACTIONS(2048),
    [anon_sym_PLUS] = ACTIONS(2048),
    [anon_sym_STAR] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_SEMI] = ACTIONS(2183),
    [anon_sym___extension__] = ACTIONS(2057),
    [anon_sym_COLON_COLON] = ACTIONS(2060),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2063),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2069),
    [sym_primitive_type] = ACTIONS(2072),
    [anon_sym_if] = ACTIONS(2189),
    [anon_sym_switch] = ACTIONS(2192),
    [anon_sym_case] = ACTIONS(2195),
    [anon_sym_default] = ACTIONS(2198),
    [anon_sym_while] = ACTIONS(2201),
    [anon_sym_do] = ACTIONS(2204),
    [anon_sym_for] = ACTIONS(2207),
    [anon_sym_return] = ACTIONS(2210),
    [anon_sym_break] = ACTIONS(2213),
    [anon_sym_continue] = ACTIONS(2216),
    [anon_sym_goto] = ACTIONS(2219),
    [anon_sym___try] = ACTIONS(2222),
    [anon_sym___leave] = ACTIONS(2225),
    [anon_sym_not] = ACTIONS(2048),
    [anon_sym_compl] = ACTIONS(2048),
    [anon_sym_DASH_DASH] = ACTIONS(2114),
    [anon_sym_PLUS_PLUS] = ACTIONS(2114),
    [anon_sym_sizeof] = ACTIONS(2117),
    [anon_sym___alignof__] = ACTIONS(2120),
    [anon_sym___alignof] = ACTIONS(2120),
    [anon_sym__alignof] = ACTIONS(2120),
    [anon_sym_alignof] = ACTIONS(2120),
    [anon_sym__Alignof] = ACTIONS(2120),
    [anon_sym_offsetof] = ACTIONS(2123),
    [anon_sym__Generic] = ACTIONS(2126),
    [anon_sym_asm] = ACTIONS(2129),
    [anon_sym___asm__] = ACTIONS(2129),
    [anon_sym___asm] = ACTIONS(2129),
    [sym_number_literal] = ACTIONS(2132),
    [anon_sym_L_SQUOTE] = ACTIONS(2135),
    [anon_sym_u_SQUOTE] = ACTIONS(2135),
    [anon_sym_U_SQUOTE] = ACTIONS(2135),
    [anon_sym_u8_SQUOTE] = ACTIONS(2135),
    [anon_sym_SQUOTE] = ACTIONS(2135),
    [anon_sym_L_DQUOTE] = ACTIONS(2138),
    [anon_sym_u_DQUOTE] = ACTIONS(2138),
    [anon_sym_U_DQUOTE] = ACTIONS(2138),
    [anon_sym_u8_DQUOTE] = ACTIONS(2138),
    [anon_sym_DQUOTE] = ACTIONS(2138),
    [sym_true] = ACTIONS(2141),
    [sym_false] = ACTIONS(2141),
    [anon_sym_NULL] = ACTIONS(2144),
    [anon_sym_nullptr] = ACTIONS(2144),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2147),
    [anon_sym_template] = ACTIONS(2150),
    [anon_sym_try] = ACTIONS(2228),
    [anon_sym_delete] = ACTIONS(2156),
    [anon_sym_throw] = ACTIONS(2231),
    [anon_sym_co_return] = ACTIONS(2234),
    [anon_sym_co_yield] = ACTIONS(2237),
    [anon_sym_R_DQUOTE] = ACTIONS(2168),
    [anon_sym_LR_DQUOTE] = ACTIONS(2168),
    [anon_sym_uR_DQUOTE] = ACTIONS(2168),
    [anon_sym_UR_DQUOTE] = ACTIONS(2168),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2168),
    [anon_sym_co_await] = ACTIONS(2171),
    [anon_sym_new] = ACTIONS(2174),
    [anon_sym_requires] = ACTIONS(2177),
    [sym_this] = ACTIONS(2141),
  },
  [183] = {
    [sym_attribute_declaration] = STATE(187),
    [sym_compound_statement] = STATE(462),
    [sym_attributed_statement] = STATE(462),
    [sym_statement] = STATE(7317),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(187),
    [sym_identifier] = ACTIONS(2035),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_if] = ACTIONS(1679),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(1673),
    [anon_sym_default] = ACTIONS(1675),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_for] = ACTIONS(1683),
    [anon_sym_return] = ACTIONS(93),
    [anon_sym_break] = ACTIONS(95),
    [anon_sym_continue] = ACTIONS(97),
    [anon_sym_goto] = ACTIONS(99),
    [anon_sym___try] = ACTIONS(1685),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [184] = {
    [sym_attribute_declaration] = STATE(187),
    [sym_compound_statement] = STATE(462),
    [sym_attributed_statement] = STATE(462),
    [sym_statement] = STATE(480),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(187),
    [sym_identifier] = ACTIONS(2035),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_if] = ACTIONS(1679),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(1673),
    [anon_sym_default] = ACTIONS(1675),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_for] = ACTIONS(1683),
    [anon_sym_return] = ACTIONS(93),
    [anon_sym_break] = ACTIONS(95),
    [anon_sym_continue] = ACTIONS(97),
    [anon_sym_goto] = ACTIONS(99),
    [anon_sym___try] = ACTIONS(1685),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [185] = {
    [sym_attribute_declaration] = STATE(187),
    [sym_compound_statement] = STATE(462),
    [sym_attributed_statement] = STATE(462),
    [sym_statement] = STATE(483),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(187),
    [sym_identifier] = ACTIONS(2035),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_if] = ACTIONS(1679),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(1673),
    [anon_sym_default] = ACTIONS(1675),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_for] = ACTIONS(1683),
    [anon_sym_return] = ACTIONS(93),
    [anon_sym_break] = ACTIONS(95),
    [anon_sym_continue] = ACTIONS(97),
    [anon_sym_goto] = ACTIONS(99),
    [anon_sym___try] = ACTIONS(1685),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [186] = {
    [sym_attribute_declaration] = STATE(187),
    [sym_compound_statement] = STATE(462),
    [sym_attributed_statement] = STATE(462),
    [sym_statement] = STATE(485),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(187),
    [sym_identifier] = ACTIONS(2035),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_if] = ACTIONS(1679),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(1673),
    [anon_sym_default] = ACTIONS(1675),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_for] = ACTIONS(1683),
    [anon_sym_return] = ACTIONS(93),
    [anon_sym_break] = ACTIONS(95),
    [anon_sym_continue] = ACTIONS(97),
    [anon_sym_goto] = ACTIONS(99),
    [anon_sym___try] = ACTIONS(1685),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [187] = {
    [sym_attribute_declaration] = STATE(182),
    [sym_compound_statement] = STATE(462),
    [sym_attributed_statement] = STATE(462),
    [sym_statement] = STATE(457),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(182),
    [sym_identifier] = ACTIONS(2035),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_if] = ACTIONS(1679),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(1673),
    [anon_sym_default] = ACTIONS(1675),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_for] = ACTIONS(1683),
    [anon_sym_return] = ACTIONS(93),
    [anon_sym_break] = ACTIONS(95),
    [anon_sym_continue] = ACTIONS(97),
    [anon_sym_goto] = ACTIONS(99),
    [anon_sym___try] = ACTIONS(1685),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [188] = {
    [sym_attribute_declaration] = STATE(206),
    [sym_compound_statement] = STATE(482),
    [sym_attributed_statement] = STATE(482),
    [sym_statement] = STATE(419),
    [sym_labeled_statement] = STATE(482),
    [sym_expression_statement] = STATE(482),
    [sym_if_statement] = STATE(482),
    [sym_switch_statement] = STATE(482),
    [sym_case_statement] = STATE(482),
    [sym_while_statement] = STATE(482),
    [sym_do_statement] = STATE(482),
    [sym_for_statement] = STATE(482),
    [sym_return_statement] = STATE(482),
    [sym_break_statement] = STATE(482),
    [sym_continue_statement] = STATE(482),
    [sym_goto_statement] = STATE(482),
    [sym_seh_try_statement] = STATE(482),
    [sym_seh_leave_statement] = STATE(482),
    [sym_expression] = STATE(4411),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8119),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(482),
    [sym_co_return_statement] = STATE(482),
    [sym_co_yield_statement] = STATE(482),
    [sym_throw_statement] = STATE(482),
    [sym_try_statement] = STATE(482),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(206),
    [sym_identifier] = ACTIONS(2240),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_if] = ACTIONS(648),
    [anon_sym_switch] = ACTIONS(650),
    [anon_sym_case] = ACTIONS(652),
    [anon_sym_default] = ACTIONS(654),
    [anon_sym_while] = ACTIONS(656),
    [anon_sym_do] = ACTIONS(658),
    [anon_sym_for] = ACTIONS(660),
    [anon_sym_return] = ACTIONS(662),
    [anon_sym_break] = ACTIONS(664),
    [anon_sym_continue] = ACTIONS(666),
    [anon_sym_goto] = ACTIONS(668),
    [anon_sym___try] = ACTIONS(670),
    [anon_sym___leave] = ACTIONS(672),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(676),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(678),
    [anon_sym_co_return] = ACTIONS(688),
    [anon_sym_co_yield] = ACTIONS(690),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [189] = {
    [sym_attribute_declaration] = STATE(206),
    [sym_compound_statement] = STATE(482),
    [sym_attributed_statement] = STATE(482),
    [sym_statement] = STATE(501),
    [sym_labeled_statement] = STATE(482),
    [sym_expression_statement] = STATE(482),
    [sym_if_statement] = STATE(482),
    [sym_switch_statement] = STATE(482),
    [sym_case_statement] = STATE(482),
    [sym_while_statement] = STATE(482),
    [sym_do_statement] = STATE(482),
    [sym_for_statement] = STATE(482),
    [sym_return_statement] = STATE(482),
    [sym_break_statement] = STATE(482),
    [sym_continue_statement] = STATE(482),
    [sym_goto_statement] = STATE(482),
    [sym_seh_try_statement] = STATE(482),
    [sym_seh_leave_statement] = STATE(482),
    [sym_expression] = STATE(4411),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8119),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(482),
    [sym_co_return_statement] = STATE(482),
    [sym_co_yield_statement] = STATE(482),
    [sym_throw_statement] = STATE(482),
    [sym_try_statement] = STATE(482),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(206),
    [sym_identifier] = ACTIONS(2240),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_if] = ACTIONS(648),
    [anon_sym_switch] = ACTIONS(650),
    [anon_sym_case] = ACTIONS(652),
    [anon_sym_default] = ACTIONS(654),
    [anon_sym_while] = ACTIONS(656),
    [anon_sym_do] = ACTIONS(658),
    [anon_sym_for] = ACTIONS(660),
    [anon_sym_return] = ACTIONS(662),
    [anon_sym_break] = ACTIONS(664),
    [anon_sym_continue] = ACTIONS(666),
    [anon_sym_goto] = ACTIONS(668),
    [anon_sym___try] = ACTIONS(670),
    [anon_sym___leave] = ACTIONS(672),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(676),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(678),
    [anon_sym_co_return] = ACTIONS(688),
    [anon_sym_co_yield] = ACTIONS(690),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [190] = {
    [sym_attribute_declaration] = STATE(190),
    [sym_compound_statement] = STATE(500),
    [sym_attributed_statement] = STATE(500),
    [sym_statement] = STATE(457),
    [sym_labeled_statement] = STATE(500),
    [sym_expression_statement] = STATE(500),
    [sym_if_statement] = STATE(500),
    [sym_switch_statement] = STATE(500),
    [sym_case_statement] = STATE(500),
    [sym_while_statement] = STATE(500),
    [sym_do_statement] = STATE(500),
    [sym_for_statement] = STATE(500),
    [sym_return_statement] = STATE(500),
    [sym_break_statement] = STATE(500),
    [sym_continue_statement] = STATE(500),
    [sym_goto_statement] = STATE(500),
    [sym_seh_try_statement] = STATE(500),
    [sym_seh_leave_statement] = STATE(500),
    [sym_expression] = STATE(4373),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8412),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(500),
    [sym_co_return_statement] = STATE(500),
    [sym_co_yield_statement] = STATE(500),
    [sym_throw_statement] = STATE(500),
    [sym_try_statement] = STATE(500),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(190),
    [sym_identifier] = ACTIONS(2242),
    [anon_sym_LPAREN2] = ACTIONS(2042),
    [anon_sym_BANG] = ACTIONS(2045),
    [anon_sym_TILDE] = ACTIONS(2045),
    [anon_sym_DASH] = ACTIONS(2048),
    [anon_sym_PLUS] = ACTIONS(2048),
    [anon_sym_STAR] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_SEMI] = ACTIONS(2245),
    [anon_sym___extension__] = ACTIONS(2057),
    [anon_sym_COLON_COLON] = ACTIONS(2060),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2063),
    [anon_sym_LBRACE] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2069),
    [sym_primitive_type] = ACTIONS(2072),
    [anon_sym_if] = ACTIONS(2248),
    [anon_sym_switch] = ACTIONS(2192),
    [anon_sym_case] = ACTIONS(2251),
    [anon_sym_default] = ACTIONS(2254),
    [anon_sym_while] = ACTIONS(2257),
    [anon_sym_do] = ACTIONS(2204),
    [anon_sym_for] = ACTIONS(2260),
    [anon_sym_return] = ACTIONS(2210),
    [anon_sym_break] = ACTIONS(2213),
    [anon_sym_continue] = ACTIONS(2216),
    [anon_sym_goto] = ACTIONS(2219),
    [anon_sym___try] = ACTIONS(2263),
    [anon_sym___leave] = ACTIONS(2266),
    [anon_sym_not] = ACTIONS(2048),
    [anon_sym_compl] = ACTIONS(2048),
    [anon_sym_DASH_DASH] = ACTIONS(2114),
    [anon_sym_PLUS_PLUS] = ACTIONS(2114),
    [anon_sym_sizeof] = ACTIONS(2117),
    [anon_sym___alignof__] = ACTIONS(2120),
    [anon_sym___alignof] = ACTIONS(2120),
    [anon_sym__alignof] = ACTIONS(2120),
    [anon_sym_alignof] = ACTIONS(2120),
    [anon_sym__Alignof] = ACTIONS(2120),
    [anon_sym_offsetof] = ACTIONS(2123),
    [anon_sym__Generic] = ACTIONS(2126),
    [anon_sym_asm] = ACTIONS(2129),
    [anon_sym___asm__] = ACTIONS(2129),
    [anon_sym___asm] = ACTIONS(2129),
    [sym_number_literal] = ACTIONS(2132),
    [anon_sym_L_SQUOTE] = ACTIONS(2135),
    [anon_sym_u_SQUOTE] = ACTIONS(2135),
    [anon_sym_U_SQUOTE] = ACTIONS(2135),
    [anon_sym_u8_SQUOTE] = ACTIONS(2135),
    [anon_sym_SQUOTE] = ACTIONS(2135),
    [anon_sym_L_DQUOTE] = ACTIONS(2138),
    [anon_sym_u_DQUOTE] = ACTIONS(2138),
    [anon_sym_U_DQUOTE] = ACTIONS(2138),
    [anon_sym_u8_DQUOTE] = ACTIONS(2138),
    [anon_sym_DQUOTE] = ACTIONS(2138),
    [sym_true] = ACTIONS(2141),
    [sym_false] = ACTIONS(2141),
    [anon_sym_NULL] = ACTIONS(2144),
    [anon_sym_nullptr] = ACTIONS(2144),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2147),
    [anon_sym_template] = ACTIONS(2150),
    [anon_sym_try] = ACTIONS(2228),
    [anon_sym_delete] = ACTIONS(2156),
    [anon_sym_throw] = ACTIONS(2231),
    [anon_sym_co_return] = ACTIONS(2234),
    [anon_sym_co_yield] = ACTIONS(2237),
    [anon_sym_R_DQUOTE] = ACTIONS(2168),
    [anon_sym_LR_DQUOTE] = ACTIONS(2168),
    [anon_sym_uR_DQUOTE] = ACTIONS(2168),
    [anon_sym_UR_DQUOTE] = ACTIONS(2168),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2168),
    [anon_sym_co_await] = ACTIONS(2171),
    [anon_sym_new] = ACTIONS(2174),
    [anon_sym_requires] = ACTIONS(2177),
    [sym_this] = ACTIONS(2141),
  },
  [191] = {
    [sym_attribute_declaration] = STATE(174),
    [sym_compound_statement] = STATE(500),
    [sym_attributed_statement] = STATE(500),
    [sym_statement] = STATE(414),
    [sym_labeled_statement] = STATE(500),
    [sym_expression_statement] = STATE(500),
    [sym_if_statement] = STATE(500),
    [sym_switch_statement] = STATE(500),
    [sym_case_statement] = STATE(500),
    [sym_while_statement] = STATE(500),
    [sym_do_statement] = STATE(500),
    [sym_for_statement] = STATE(500),
    [sym_return_statement] = STATE(500),
    [sym_break_statement] = STATE(500),
    [sym_continue_statement] = STATE(500),
    [sym_goto_statement] = STATE(500),
    [sym_seh_try_statement] = STATE(500),
    [sym_seh_leave_statement] = STATE(500),
    [sym_expression] = STATE(4373),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8412),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(500),
    [sym_co_return_statement] = STATE(500),
    [sym_co_yield_statement] = STATE(500),
    [sym_throw_statement] = STATE(500),
    [sym_try_statement] = STATE(500),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(174),
    [sym_identifier] = ACTIONS(2019),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1503),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_if] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_default] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(93),
    [anon_sym_break] = ACTIONS(95),
    [anon_sym_continue] = ACTIONS(97),
    [anon_sym_goto] = ACTIONS(99),
    [anon_sym___try] = ACTIONS(1507),
    [anon_sym___leave] = ACTIONS(1509),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [192] = {
    [sym_attribute_declaration] = STATE(192),
    [sym_compound_statement] = STATE(482),
    [sym_attributed_statement] = STATE(482),
    [sym_statement] = STATE(494),
    [sym_labeled_statement] = STATE(482),
    [sym_expression_statement] = STATE(482),
    [sym_if_statement] = STATE(482),
    [sym_switch_statement] = STATE(482),
    [sym_case_statement] = STATE(482),
    [sym_while_statement] = STATE(482),
    [sym_do_statement] = STATE(482),
    [sym_for_statement] = STATE(482),
    [sym_return_statement] = STATE(482),
    [sym_break_statement] = STATE(482),
    [sym_continue_statement] = STATE(482),
    [sym_goto_statement] = STATE(482),
    [sym_seh_try_statement] = STATE(482),
    [sym_seh_leave_statement] = STATE(482),
    [sym_expression] = STATE(4411),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8119),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(482),
    [sym_co_return_statement] = STATE(482),
    [sym_co_yield_statement] = STATE(482),
    [sym_throw_statement] = STATE(482),
    [sym_try_statement] = STATE(482),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(192),
    [sym_identifier] = ACTIONS(2269),
    [anon_sym_LPAREN2] = ACTIONS(2042),
    [anon_sym_BANG] = ACTIONS(2045),
    [anon_sym_TILDE] = ACTIONS(2045),
    [anon_sym_DASH] = ACTIONS(2048),
    [anon_sym_PLUS] = ACTIONS(2048),
    [anon_sym_STAR] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_SEMI] = ACTIONS(2272),
    [anon_sym___extension__] = ACTIONS(2057),
    [anon_sym_COLON_COLON] = ACTIONS(2060),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2063),
    [anon_sym_LBRACE] = ACTIONS(2275),
    [anon_sym_LBRACK] = ACTIONS(2069),
    [sym_primitive_type] = ACTIONS(2072),
    [anon_sym_if] = ACTIONS(2278),
    [anon_sym_switch] = ACTIONS(2281),
    [anon_sym_case] = ACTIONS(2284),
    [anon_sym_default] = ACTIONS(2287),
    [anon_sym_while] = ACTIONS(2290),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_for] = ACTIONS(2296),
    [anon_sym_return] = ACTIONS(2299),
    [anon_sym_break] = ACTIONS(2302),
    [anon_sym_continue] = ACTIONS(2305),
    [anon_sym_goto] = ACTIONS(2308),
    [anon_sym___try] = ACTIONS(2311),
    [anon_sym___leave] = ACTIONS(2314),
    [anon_sym_not] = ACTIONS(2048),
    [anon_sym_compl] = ACTIONS(2048),
    [anon_sym_DASH_DASH] = ACTIONS(2114),
    [anon_sym_PLUS_PLUS] = ACTIONS(2114),
    [anon_sym_sizeof] = ACTIONS(2117),
    [anon_sym___alignof__] = ACTIONS(2120),
    [anon_sym___alignof] = ACTIONS(2120),
    [anon_sym__alignof] = ACTIONS(2120),
    [anon_sym_alignof] = ACTIONS(2120),
    [anon_sym__Alignof] = ACTIONS(2120),
    [anon_sym_offsetof] = ACTIONS(2123),
    [anon_sym__Generic] = ACTIONS(2126),
    [anon_sym_asm] = ACTIONS(2129),
    [anon_sym___asm__] = ACTIONS(2129),
    [anon_sym___asm] = ACTIONS(2129),
    [sym_number_literal] = ACTIONS(2132),
    [anon_sym_L_SQUOTE] = ACTIONS(2135),
    [anon_sym_u_SQUOTE] = ACTIONS(2135),
    [anon_sym_U_SQUOTE] = ACTIONS(2135),
    [anon_sym_u8_SQUOTE] = ACTIONS(2135),
    [anon_sym_SQUOTE] = ACTIONS(2135),
    [anon_sym_L_DQUOTE] = ACTIONS(2138),
    [anon_sym_u_DQUOTE] = ACTIONS(2138),
    [anon_sym_U_DQUOTE] = ACTIONS(2138),
    [anon_sym_u8_DQUOTE] = ACTIONS(2138),
    [anon_sym_DQUOTE] = ACTIONS(2138),
    [sym_true] = ACTIONS(2141),
    [sym_false] = ACTIONS(2141),
    [anon_sym_NULL] = ACTIONS(2144),
    [anon_sym_nullptr] = ACTIONS(2144),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2147),
    [anon_sym_template] = ACTIONS(2150),
    [anon_sym_try] = ACTIONS(2317),
    [anon_sym_delete] = ACTIONS(2156),
    [anon_sym_throw] = ACTIONS(2320),
    [anon_sym_co_return] = ACTIONS(2323),
    [anon_sym_co_yield] = ACTIONS(2326),
    [anon_sym_R_DQUOTE] = ACTIONS(2168),
    [anon_sym_LR_DQUOTE] = ACTIONS(2168),
    [anon_sym_uR_DQUOTE] = ACTIONS(2168),
    [anon_sym_UR_DQUOTE] = ACTIONS(2168),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2168),
    [anon_sym_co_await] = ACTIONS(2171),
    [anon_sym_new] = ACTIONS(2174),
    [anon_sym_requires] = ACTIONS(2177),
    [sym_this] = ACTIONS(2141),
  },
  [193] = {
    [sym_attribute_declaration] = STATE(206),
    [sym_compound_statement] = STATE(482),
    [sym_attributed_statement] = STATE(482),
    [sym_statement] = STATE(398),
    [sym_labeled_statement] = STATE(482),
    [sym_expression_statement] = STATE(482),
    [sym_if_statement] = STATE(482),
    [sym_switch_statement] = STATE(482),
    [sym_case_statement] = STATE(482),
    [sym_while_statement] = STATE(482),
    [sym_do_statement] = STATE(482),
    [sym_for_statement] = STATE(482),
    [sym_return_statement] = STATE(482),
    [sym_break_statement] = STATE(482),
    [sym_continue_statement] = STATE(482),
    [sym_goto_statement] = STATE(482),
    [sym_seh_try_statement] = STATE(482),
    [sym_seh_leave_statement] = STATE(482),
    [sym_expression] = STATE(4411),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8119),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(482),
    [sym_co_return_statement] = STATE(482),
    [sym_co_yield_statement] = STATE(482),
    [sym_throw_statement] = STATE(482),
    [sym_try_statement] = STATE(482),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(206),
    [sym_identifier] = ACTIONS(2240),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_if] = ACTIONS(648),
    [anon_sym_switch] = ACTIONS(650),
    [anon_sym_case] = ACTIONS(652),
    [anon_sym_default] = ACTIONS(654),
    [anon_sym_while] = ACTIONS(656),
    [anon_sym_do] = ACTIONS(658),
    [anon_sym_for] = ACTIONS(660),
    [anon_sym_return] = ACTIONS(662),
    [anon_sym_break] = ACTIONS(664),
    [anon_sym_continue] = ACTIONS(666),
    [anon_sym_goto] = ACTIONS(668),
    [anon_sym___try] = ACTIONS(670),
    [anon_sym___leave] = ACTIONS(672),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(676),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(678),
    [anon_sym_co_return] = ACTIONS(688),
    [anon_sym_co_yield] = ACTIONS(690),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [194] = {
    [sym_attribute_declaration] = STATE(206),
    [sym_compound_statement] = STATE(482),
    [sym_attributed_statement] = STATE(482),
    [sym_statement] = STATE(538),
    [sym_labeled_statement] = STATE(482),
    [sym_expression_statement] = STATE(482),
    [sym_if_statement] = STATE(482),
    [sym_switch_statement] = STATE(482),
    [sym_case_statement] = STATE(482),
    [sym_while_statement] = STATE(482),
    [sym_do_statement] = STATE(482),
    [sym_for_statement] = STATE(482),
    [sym_return_statement] = STATE(482),
    [sym_break_statement] = STATE(482),
    [sym_continue_statement] = STATE(482),
    [sym_goto_statement] = STATE(482),
    [sym_seh_try_statement] = STATE(482),
    [sym_seh_leave_statement] = STATE(482),
    [sym_expression] = STATE(4411),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8119),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(482),
    [sym_co_return_statement] = STATE(482),
    [sym_co_yield_statement] = STATE(482),
    [sym_throw_statement] = STATE(482),
    [sym_try_statement] = STATE(482),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(206),
    [sym_identifier] = ACTIONS(2240),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_if] = ACTIONS(648),
    [anon_sym_switch] = ACTIONS(650),
    [anon_sym_case] = ACTIONS(652),
    [anon_sym_default] = ACTIONS(654),
    [anon_sym_while] = ACTIONS(656),
    [anon_sym_do] = ACTIONS(658),
    [anon_sym_for] = ACTIONS(660),
    [anon_sym_return] = ACTIONS(662),
    [anon_sym_break] = ACTIONS(664),
    [anon_sym_continue] = ACTIONS(666),
    [anon_sym_goto] = ACTIONS(668),
    [anon_sym___try] = ACTIONS(670),
    [anon_sym___leave] = ACTIONS(672),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(676),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(678),
    [anon_sym_co_return] = ACTIONS(688),
    [anon_sym_co_yield] = ACTIONS(690),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [195] = {
    [sym_attribute_declaration] = STATE(206),
    [sym_compound_statement] = STATE(482),
    [sym_attributed_statement] = STATE(482),
    [sym_statement] = STATE(426),
    [sym_labeled_statement] = STATE(482),
    [sym_expression_statement] = STATE(482),
    [sym_if_statement] = STATE(482),
    [sym_switch_statement] = STATE(482),
    [sym_case_statement] = STATE(482),
    [sym_while_statement] = STATE(482),
    [sym_do_statement] = STATE(482),
    [sym_for_statement] = STATE(482),
    [sym_return_statement] = STATE(482),
    [sym_break_statement] = STATE(482),
    [sym_continue_statement] = STATE(482),
    [sym_goto_statement] = STATE(482),
    [sym_seh_try_statement] = STATE(482),
    [sym_seh_leave_statement] = STATE(482),
    [sym_expression] = STATE(4411),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8119),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(482),
    [sym_co_return_statement] = STATE(482),
    [sym_co_yield_statement] = STATE(482),
    [sym_throw_statement] = STATE(482),
    [sym_try_statement] = STATE(482),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(206),
    [sym_identifier] = ACTIONS(2240),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_if] = ACTIONS(648),
    [anon_sym_switch] = ACTIONS(650),
    [anon_sym_case] = ACTIONS(652),
    [anon_sym_default] = ACTIONS(654),
    [anon_sym_while] = ACTIONS(656),
    [anon_sym_do] = ACTIONS(658),
    [anon_sym_for] = ACTIONS(660),
    [anon_sym_return] = ACTIONS(662),
    [anon_sym_break] = ACTIONS(664),
    [anon_sym_continue] = ACTIONS(666),
    [anon_sym_goto] = ACTIONS(668),
    [anon_sym___try] = ACTIONS(670),
    [anon_sym___leave] = ACTIONS(672),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(676),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(678),
    [anon_sym_co_return] = ACTIONS(688),
    [anon_sym_co_yield] = ACTIONS(690),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [196] = {
    [sym_attribute_declaration] = STATE(206),
    [sym_compound_statement] = STATE(482),
    [sym_attributed_statement] = STATE(482),
    [sym_statement] = STATE(427),
    [sym_labeled_statement] = STATE(482),
    [sym_expression_statement] = STATE(482),
    [sym_if_statement] = STATE(482),
    [sym_switch_statement] = STATE(482),
    [sym_case_statement] = STATE(482),
    [sym_while_statement] = STATE(482),
    [sym_do_statement] = STATE(482),
    [sym_for_statement] = STATE(482),
    [sym_return_statement] = STATE(482),
    [sym_break_statement] = STATE(482),
    [sym_continue_statement] = STATE(482),
    [sym_goto_statement] = STATE(482),
    [sym_seh_try_statement] = STATE(482),
    [sym_seh_leave_statement] = STATE(482),
    [sym_expression] = STATE(4411),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8119),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(482),
    [sym_co_return_statement] = STATE(482),
    [sym_co_yield_statement] = STATE(482),
    [sym_throw_statement] = STATE(482),
    [sym_try_statement] = STATE(482),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(206),
    [sym_identifier] = ACTIONS(2240),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_if] = ACTIONS(648),
    [anon_sym_switch] = ACTIONS(650),
    [anon_sym_case] = ACTIONS(652),
    [anon_sym_default] = ACTIONS(654),
    [anon_sym_while] = ACTIONS(656),
    [anon_sym_do] = ACTIONS(658),
    [anon_sym_for] = ACTIONS(660),
    [anon_sym_return] = ACTIONS(662),
    [anon_sym_break] = ACTIONS(664),
    [anon_sym_continue] = ACTIONS(666),
    [anon_sym_goto] = ACTIONS(668),
    [anon_sym___try] = ACTIONS(670),
    [anon_sym___leave] = ACTIONS(672),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(676),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(678),
    [anon_sym_co_return] = ACTIONS(688),
    [anon_sym_co_yield] = ACTIONS(690),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [197] = {
    [sym_attribute_declaration] = STATE(173),
    [sym_compound_statement] = STATE(235),
    [sym_attributed_statement] = STATE(235),
    [sym_statement] = STATE(266),
    [sym_labeled_statement] = STATE(235),
    [sym_expression_statement] = STATE(235),
    [sym_if_statement] = STATE(235),
    [sym_switch_statement] = STATE(235),
    [sym_case_statement] = STATE(235),
    [sym_while_statement] = STATE(235),
    [sym_do_statement] = STATE(235),
    [sym_for_statement] = STATE(235),
    [sym_return_statement] = STATE(235),
    [sym_break_statement] = STATE(235),
    [sym_continue_statement] = STATE(235),
    [sym_goto_statement] = STATE(235),
    [sym_seh_try_statement] = STATE(235),
    [sym_seh_leave_statement] = STATE(235),
    [sym_expression] = STATE(4387),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8324),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(235),
    [sym_co_return_statement] = STATE(235),
    [sym_co_yield_statement] = STATE(235),
    [sym_throw_statement] = STATE(235),
    [sym_try_statement] = STATE(235),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(173),
    [sym_identifier] = ACTIONS(2037),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(281),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_switch] = ACTIONS(295),
    [anon_sym_case] = ACTIONS(297),
    [anon_sym_default] = ACTIONS(299),
    [anon_sym_while] = ACTIONS(301),
    [anon_sym_do] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_break] = ACTIONS(309),
    [anon_sym_continue] = ACTIONS(311),
    [anon_sym_goto] = ACTIONS(313),
    [anon_sym___try] = ACTIONS(315),
    [anon_sym___leave] = ACTIONS(317),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(321),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(323),
    [anon_sym_co_return] = ACTIONS(333),
    [anon_sym_co_yield] = ACTIONS(335),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [198] = {
    [sym_attribute_declaration] = STATE(207),
    [sym_compound_statement] = STATE(874),
    [sym_attributed_statement] = STATE(874),
    [sym_statement] = STATE(844),
    [sym_labeled_statement] = STATE(874),
    [sym_expression_statement] = STATE(874),
    [sym_if_statement] = STATE(874),
    [sym_switch_statement] = STATE(874),
    [sym_case_statement] = STATE(874),
    [sym_while_statement] = STATE(874),
    [sym_do_statement] = STATE(874),
    [sym_for_statement] = STATE(874),
    [sym_return_statement] = STATE(874),
    [sym_break_statement] = STATE(874),
    [sym_continue_statement] = STATE(874),
    [sym_goto_statement] = STATE(874),
    [sym_seh_try_statement] = STATE(874),
    [sym_seh_leave_statement] = STATE(874),
    [sym_expression] = STATE(4421),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8026),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(874),
    [sym_co_return_statement] = STATE(874),
    [sym_co_yield_statement] = STATE(874),
    [sym_throw_statement] = STATE(874),
    [sym_try_statement] = STATE(874),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(207),
    [sym_identifier] = ACTIONS(2329),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1635),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_if] = ACTIONS(1643),
    [anon_sym_switch] = ACTIONS(1645),
    [anon_sym_case] = ACTIONS(1673),
    [anon_sym_default] = ACTIONS(1675),
    [anon_sym_while] = ACTIONS(1647),
    [anon_sym_do] = ACTIONS(1649),
    [anon_sym_for] = ACTIONS(1651),
    [anon_sym_return] = ACTIONS(1653),
    [anon_sym_break] = ACTIONS(1655),
    [anon_sym_continue] = ACTIONS(1657),
    [anon_sym_goto] = ACTIONS(1659),
    [anon_sym___try] = ACTIONS(1661),
    [anon_sym___leave] = ACTIONS(1663),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(1665),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(1667),
    [anon_sym_co_return] = ACTIONS(1669),
    [anon_sym_co_yield] = ACTIONS(1671),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [199] = {
    [sym_attribute_declaration] = STATE(207),
    [sym_compound_statement] = STATE(874),
    [sym_attributed_statement] = STATE(874),
    [sym_statement] = STATE(868),
    [sym_labeled_statement] = STATE(874),
    [sym_expression_statement] = STATE(874),
    [sym_if_statement] = STATE(874),
    [sym_switch_statement] = STATE(874),
    [sym_case_statement] = STATE(874),
    [sym_while_statement] = STATE(874),
    [sym_do_statement] = STATE(874),
    [sym_for_statement] = STATE(874),
    [sym_return_statement] = STATE(874),
    [sym_break_statement] = STATE(874),
    [sym_continue_statement] = STATE(874),
    [sym_goto_statement] = STATE(874),
    [sym_seh_try_statement] = STATE(874),
    [sym_seh_leave_statement] = STATE(874),
    [sym_expression] = STATE(4421),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8026),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(874),
    [sym_co_return_statement] = STATE(874),
    [sym_co_yield_statement] = STATE(874),
    [sym_throw_statement] = STATE(874),
    [sym_try_statement] = STATE(874),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(207),
    [sym_identifier] = ACTIONS(2329),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1635),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_if] = ACTIONS(1643),
    [anon_sym_switch] = ACTIONS(1645),
    [anon_sym_case] = ACTIONS(1673),
    [anon_sym_default] = ACTIONS(1675),
    [anon_sym_while] = ACTIONS(1647),
    [anon_sym_do] = ACTIONS(1649),
    [anon_sym_for] = ACTIONS(1651),
    [anon_sym_return] = ACTIONS(1653),
    [anon_sym_break] = ACTIONS(1655),
    [anon_sym_continue] = ACTIONS(1657),
    [anon_sym_goto] = ACTIONS(1659),
    [anon_sym___try] = ACTIONS(1661),
    [anon_sym___leave] = ACTIONS(1663),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(1665),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(1667),
    [anon_sym_co_return] = ACTIONS(1669),
    [anon_sym_co_yield] = ACTIONS(1671),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [200] = {
    [sym_attribute_declaration] = STATE(200),
    [sym_compound_statement] = STATE(874),
    [sym_attributed_statement] = STATE(874),
    [sym_statement] = STATE(870),
    [sym_labeled_statement] = STATE(874),
    [sym_expression_statement] = STATE(874),
    [sym_if_statement] = STATE(874),
    [sym_switch_statement] = STATE(874),
    [sym_case_statement] = STATE(874),
    [sym_while_statement] = STATE(874),
    [sym_do_statement] = STATE(874),
    [sym_for_statement] = STATE(874),
    [sym_return_statement] = STATE(874),
    [sym_break_statement] = STATE(874),
    [sym_continue_statement] = STATE(874),
    [sym_goto_statement] = STATE(874),
    [sym_seh_try_statement] = STATE(874),
    [sym_seh_leave_statement] = STATE(874),
    [sym_expression] = STATE(4421),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8026),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(874),
    [sym_co_return_statement] = STATE(874),
    [sym_co_yield_statement] = STATE(874),
    [sym_throw_statement] = STATE(874),
    [sym_try_statement] = STATE(874),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(200),
    [sym_identifier] = ACTIONS(2331),
    [anon_sym_LPAREN2] = ACTIONS(2042),
    [anon_sym_BANG] = ACTIONS(2045),
    [anon_sym_TILDE] = ACTIONS(2045),
    [anon_sym_DASH] = ACTIONS(2048),
    [anon_sym_PLUS] = ACTIONS(2048),
    [anon_sym_STAR] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_SEMI] = ACTIONS(2334),
    [anon_sym___extension__] = ACTIONS(2057),
    [anon_sym_COLON_COLON] = ACTIONS(2060),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2063),
    [anon_sym_LBRACE] = ACTIONS(2337),
    [anon_sym_LBRACK] = ACTIONS(2069),
    [sym_primitive_type] = ACTIONS(2072),
    [anon_sym_if] = ACTIONS(2340),
    [anon_sym_switch] = ACTIONS(2343),
    [anon_sym_case] = ACTIONS(2195),
    [anon_sym_default] = ACTIONS(2198),
    [anon_sym_while] = ACTIONS(2346),
    [anon_sym_do] = ACTIONS(2349),
    [anon_sym_for] = ACTIONS(2352),
    [anon_sym_return] = ACTIONS(2355),
    [anon_sym_break] = ACTIONS(2358),
    [anon_sym_continue] = ACTIONS(2361),
    [anon_sym_goto] = ACTIONS(2364),
    [anon_sym___try] = ACTIONS(2367),
    [anon_sym___leave] = ACTIONS(2370),
    [anon_sym_not] = ACTIONS(2048),
    [anon_sym_compl] = ACTIONS(2048),
    [anon_sym_DASH_DASH] = ACTIONS(2114),
    [anon_sym_PLUS_PLUS] = ACTIONS(2114),
    [anon_sym_sizeof] = ACTIONS(2117),
    [anon_sym___alignof__] = ACTIONS(2120),
    [anon_sym___alignof] = ACTIONS(2120),
    [anon_sym__alignof] = ACTIONS(2120),
    [anon_sym_alignof] = ACTIONS(2120),
    [anon_sym__Alignof] = ACTIONS(2120),
    [anon_sym_offsetof] = ACTIONS(2123),
    [anon_sym__Generic] = ACTIONS(2126),
    [anon_sym_asm] = ACTIONS(2129),
    [anon_sym___asm__] = ACTIONS(2129),
    [anon_sym___asm] = ACTIONS(2129),
    [sym_number_literal] = ACTIONS(2132),
    [anon_sym_L_SQUOTE] = ACTIONS(2135),
    [anon_sym_u_SQUOTE] = ACTIONS(2135),
    [anon_sym_U_SQUOTE] = ACTIONS(2135),
    [anon_sym_u8_SQUOTE] = ACTIONS(2135),
    [anon_sym_SQUOTE] = ACTIONS(2135),
    [anon_sym_L_DQUOTE] = ACTIONS(2138),
    [anon_sym_u_DQUOTE] = ACTIONS(2138),
    [anon_sym_U_DQUOTE] = ACTIONS(2138),
    [anon_sym_u8_DQUOTE] = ACTIONS(2138),
    [anon_sym_DQUOTE] = ACTIONS(2138),
    [sym_true] = ACTIONS(2141),
    [sym_false] = ACTIONS(2141),
    [anon_sym_NULL] = ACTIONS(2144),
    [anon_sym_nullptr] = ACTIONS(2144),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2147),
    [anon_sym_template] = ACTIONS(2150),
    [anon_sym_try] = ACTIONS(2373),
    [anon_sym_delete] = ACTIONS(2156),
    [anon_sym_throw] = ACTIONS(2376),
    [anon_sym_co_return] = ACTIONS(2379),
    [anon_sym_co_yield] = ACTIONS(2382),
    [anon_sym_R_DQUOTE] = ACTIONS(2168),
    [anon_sym_LR_DQUOTE] = ACTIONS(2168),
    [anon_sym_uR_DQUOTE] = ACTIONS(2168),
    [anon_sym_UR_DQUOTE] = ACTIONS(2168),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2168),
    [anon_sym_co_await] = ACTIONS(2171),
    [anon_sym_new] = ACTIONS(2174),
    [anon_sym_requires] = ACTIONS(2177),
    [sym_this] = ACTIONS(2141),
  },
  [201] = {
    [sym_attribute_declaration] = STATE(174),
    [sym_compound_statement] = STATE(500),
    [sym_attributed_statement] = STATE(500),
    [sym_statement] = STATE(438),
    [sym_labeled_statement] = STATE(500),
    [sym_expression_statement] = STATE(500),
    [sym_if_statement] = STATE(500),
    [sym_switch_statement] = STATE(500),
    [sym_case_statement] = STATE(500),
    [sym_while_statement] = STATE(500),
    [sym_do_statement] = STATE(500),
    [sym_for_statement] = STATE(500),
    [sym_return_statement] = STATE(500),
    [sym_break_statement] = STATE(500),
    [sym_continue_statement] = STATE(500),
    [sym_goto_statement] = STATE(500),
    [sym_seh_try_statement] = STATE(500),
    [sym_seh_leave_statement] = STATE(500),
    [sym_expression] = STATE(4373),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8412),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(500),
    [sym_co_return_statement] = STATE(500),
    [sym_co_yield_statement] = STATE(500),
    [sym_throw_statement] = STATE(500),
    [sym_try_statement] = STATE(500),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(174),
    [sym_identifier] = ACTIONS(2019),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1503),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_if] = ACTIONS(79),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(83),
    [anon_sym_default] = ACTIONS(85),
    [anon_sym_while] = ACTIONS(87),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_for] = ACTIONS(91),
    [anon_sym_return] = ACTIONS(93),
    [anon_sym_break] = ACTIONS(95),
    [anon_sym_continue] = ACTIONS(97),
    [anon_sym_goto] = ACTIONS(99),
    [anon_sym___try] = ACTIONS(1507),
    [anon_sym___leave] = ACTIONS(1509),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [202] = {
    [sym_attribute_declaration] = STATE(207),
    [sym_compound_statement] = STATE(874),
    [sym_attributed_statement] = STATE(874),
    [sym_statement] = STATE(842),
    [sym_labeled_statement] = STATE(874),
    [sym_expression_statement] = STATE(874),
    [sym_if_statement] = STATE(874),
    [sym_switch_statement] = STATE(874),
    [sym_case_statement] = STATE(874),
    [sym_while_statement] = STATE(874),
    [sym_do_statement] = STATE(874),
    [sym_for_statement] = STATE(874),
    [sym_return_statement] = STATE(874),
    [sym_break_statement] = STATE(874),
    [sym_continue_statement] = STATE(874),
    [sym_goto_statement] = STATE(874),
    [sym_seh_try_statement] = STATE(874),
    [sym_seh_leave_statement] = STATE(874),
    [sym_expression] = STATE(4421),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8026),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(874),
    [sym_co_return_statement] = STATE(874),
    [sym_co_yield_statement] = STATE(874),
    [sym_throw_statement] = STATE(874),
    [sym_try_statement] = STATE(874),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(207),
    [sym_identifier] = ACTIONS(2329),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1635),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_if] = ACTIONS(1643),
    [anon_sym_switch] = ACTIONS(1645),
    [anon_sym_case] = ACTIONS(1673),
    [anon_sym_default] = ACTIONS(1675),
    [anon_sym_while] = ACTIONS(1647),
    [anon_sym_do] = ACTIONS(1649),
    [anon_sym_for] = ACTIONS(1651),
    [anon_sym_return] = ACTIONS(1653),
    [anon_sym_break] = ACTIONS(1655),
    [anon_sym_continue] = ACTIONS(1657),
    [anon_sym_goto] = ACTIONS(1659),
    [anon_sym___try] = ACTIONS(1661),
    [anon_sym___leave] = ACTIONS(1663),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(1665),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(1667),
    [anon_sym_co_return] = ACTIONS(1669),
    [anon_sym_co_yield] = ACTIONS(1671),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [203] = {
    [sym_attribute_declaration] = STATE(207),
    [sym_compound_statement] = STATE(874),
    [sym_attributed_statement] = STATE(874),
    [sym_statement] = STATE(854),
    [sym_labeled_statement] = STATE(874),
    [sym_expression_statement] = STATE(874),
    [sym_if_statement] = STATE(874),
    [sym_switch_statement] = STATE(874),
    [sym_case_statement] = STATE(874),
    [sym_while_statement] = STATE(874),
    [sym_do_statement] = STATE(874),
    [sym_for_statement] = STATE(874),
    [sym_return_statement] = STATE(874),
    [sym_break_statement] = STATE(874),
    [sym_continue_statement] = STATE(874),
    [sym_goto_statement] = STATE(874),
    [sym_seh_try_statement] = STATE(874),
    [sym_seh_leave_statement] = STATE(874),
    [sym_expression] = STATE(4421),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8026),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(874),
    [sym_co_return_statement] = STATE(874),
    [sym_co_yield_statement] = STATE(874),
    [sym_throw_statement] = STATE(874),
    [sym_try_statement] = STATE(874),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(207),
    [sym_identifier] = ACTIONS(2329),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1635),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_if] = ACTIONS(1643),
    [anon_sym_switch] = ACTIONS(1645),
    [anon_sym_case] = ACTIONS(1673),
    [anon_sym_default] = ACTIONS(1675),
    [anon_sym_while] = ACTIONS(1647),
    [anon_sym_do] = ACTIONS(1649),
    [anon_sym_for] = ACTIONS(1651),
    [anon_sym_return] = ACTIONS(1653),
    [anon_sym_break] = ACTIONS(1655),
    [anon_sym_continue] = ACTIONS(1657),
    [anon_sym_goto] = ACTIONS(1659),
    [anon_sym___try] = ACTIONS(1661),
    [anon_sym___leave] = ACTIONS(1663),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(1665),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(1667),
    [anon_sym_co_return] = ACTIONS(1669),
    [anon_sym_co_yield] = ACTIONS(1671),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [204] = {
    [sym_attribute_declaration] = STATE(207),
    [sym_compound_statement] = STATE(874),
    [sym_attributed_statement] = STATE(874),
    [sym_statement] = STATE(857),
    [sym_labeled_statement] = STATE(874),
    [sym_expression_statement] = STATE(874),
    [sym_if_statement] = STATE(874),
    [sym_switch_statement] = STATE(874),
    [sym_case_statement] = STATE(874),
    [sym_while_statement] = STATE(874),
    [sym_do_statement] = STATE(874),
    [sym_for_statement] = STATE(874),
    [sym_return_statement] = STATE(874),
    [sym_break_statement] = STATE(874),
    [sym_continue_statement] = STATE(874),
    [sym_goto_statement] = STATE(874),
    [sym_seh_try_statement] = STATE(874),
    [sym_seh_leave_statement] = STATE(874),
    [sym_expression] = STATE(4421),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8026),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(874),
    [sym_co_return_statement] = STATE(874),
    [sym_co_yield_statement] = STATE(874),
    [sym_throw_statement] = STATE(874),
    [sym_try_statement] = STATE(874),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(207),
    [sym_identifier] = ACTIONS(2329),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1635),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_if] = ACTIONS(1643),
    [anon_sym_switch] = ACTIONS(1645),
    [anon_sym_case] = ACTIONS(1673),
    [anon_sym_default] = ACTIONS(1675),
    [anon_sym_while] = ACTIONS(1647),
    [anon_sym_do] = ACTIONS(1649),
    [anon_sym_for] = ACTIONS(1651),
    [anon_sym_return] = ACTIONS(1653),
    [anon_sym_break] = ACTIONS(1655),
    [anon_sym_continue] = ACTIONS(1657),
    [anon_sym_goto] = ACTIONS(1659),
    [anon_sym___try] = ACTIONS(1661),
    [anon_sym___leave] = ACTIONS(1663),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(1665),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(1667),
    [anon_sym_co_return] = ACTIONS(1669),
    [anon_sym_co_yield] = ACTIONS(1671),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [205] = {
    [sym_attribute_declaration] = STATE(207),
    [sym_compound_statement] = STATE(874),
    [sym_attributed_statement] = STATE(874),
    [sym_statement] = STATE(858),
    [sym_labeled_statement] = STATE(874),
    [sym_expression_statement] = STATE(874),
    [sym_if_statement] = STATE(874),
    [sym_switch_statement] = STATE(874),
    [sym_case_statement] = STATE(874),
    [sym_while_statement] = STATE(874),
    [sym_do_statement] = STATE(874),
    [sym_for_statement] = STATE(874),
    [sym_return_statement] = STATE(874),
    [sym_break_statement] = STATE(874),
    [sym_continue_statement] = STATE(874),
    [sym_goto_statement] = STATE(874),
    [sym_seh_try_statement] = STATE(874),
    [sym_seh_leave_statement] = STATE(874),
    [sym_expression] = STATE(4421),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8026),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(874),
    [sym_co_return_statement] = STATE(874),
    [sym_co_yield_statement] = STATE(874),
    [sym_throw_statement] = STATE(874),
    [sym_try_statement] = STATE(874),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(207),
    [sym_identifier] = ACTIONS(2329),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1635),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_if] = ACTIONS(1643),
    [anon_sym_switch] = ACTIONS(1645),
    [anon_sym_case] = ACTIONS(1673),
    [anon_sym_default] = ACTIONS(1675),
    [anon_sym_while] = ACTIONS(1647),
    [anon_sym_do] = ACTIONS(1649),
    [anon_sym_for] = ACTIONS(1651),
    [anon_sym_return] = ACTIONS(1653),
    [anon_sym_break] = ACTIONS(1655),
    [anon_sym_continue] = ACTIONS(1657),
    [anon_sym_goto] = ACTIONS(1659),
    [anon_sym___try] = ACTIONS(1661),
    [anon_sym___leave] = ACTIONS(1663),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(1665),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(1667),
    [anon_sym_co_return] = ACTIONS(1669),
    [anon_sym_co_yield] = ACTIONS(1671),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [206] = {
    [sym_attribute_declaration] = STATE(192),
    [sym_compound_statement] = STATE(482),
    [sym_attributed_statement] = STATE(482),
    [sym_statement] = STATE(494),
    [sym_labeled_statement] = STATE(482),
    [sym_expression_statement] = STATE(482),
    [sym_if_statement] = STATE(482),
    [sym_switch_statement] = STATE(482),
    [sym_case_statement] = STATE(482),
    [sym_while_statement] = STATE(482),
    [sym_do_statement] = STATE(482),
    [sym_for_statement] = STATE(482),
    [sym_return_statement] = STATE(482),
    [sym_break_statement] = STATE(482),
    [sym_continue_statement] = STATE(482),
    [sym_goto_statement] = STATE(482),
    [sym_seh_try_statement] = STATE(482),
    [sym_seh_leave_statement] = STATE(482),
    [sym_expression] = STATE(4411),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8119),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(482),
    [sym_co_return_statement] = STATE(482),
    [sym_co_yield_statement] = STATE(482),
    [sym_throw_statement] = STATE(482),
    [sym_try_statement] = STATE(482),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(192),
    [sym_identifier] = ACTIONS(2240),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(636),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(644),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_if] = ACTIONS(648),
    [anon_sym_switch] = ACTIONS(650),
    [anon_sym_case] = ACTIONS(652),
    [anon_sym_default] = ACTIONS(654),
    [anon_sym_while] = ACTIONS(656),
    [anon_sym_do] = ACTIONS(658),
    [anon_sym_for] = ACTIONS(660),
    [anon_sym_return] = ACTIONS(662),
    [anon_sym_break] = ACTIONS(664),
    [anon_sym_continue] = ACTIONS(666),
    [anon_sym_goto] = ACTIONS(668),
    [anon_sym___try] = ACTIONS(670),
    [anon_sym___leave] = ACTIONS(672),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(676),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(678),
    [anon_sym_co_return] = ACTIONS(688),
    [anon_sym_co_yield] = ACTIONS(690),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [207] = {
    [sym_attribute_declaration] = STATE(200),
    [sym_compound_statement] = STATE(874),
    [sym_attributed_statement] = STATE(874),
    [sym_statement] = STATE(870),
    [sym_labeled_statement] = STATE(874),
    [sym_expression_statement] = STATE(874),
    [sym_if_statement] = STATE(874),
    [sym_switch_statement] = STATE(874),
    [sym_case_statement] = STATE(874),
    [sym_while_statement] = STATE(874),
    [sym_do_statement] = STATE(874),
    [sym_for_statement] = STATE(874),
    [sym_return_statement] = STATE(874),
    [sym_break_statement] = STATE(874),
    [sym_continue_statement] = STATE(874),
    [sym_goto_statement] = STATE(874),
    [sym_seh_try_statement] = STATE(874),
    [sym_seh_leave_statement] = STATE(874),
    [sym_expression] = STATE(4421),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8026),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(874),
    [sym_co_return_statement] = STATE(874),
    [sym_co_yield_statement] = STATE(874),
    [sym_throw_statement] = STATE(874),
    [sym_try_statement] = STATE(874),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(200),
    [sym_identifier] = ACTIONS(2329),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(1635),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_if] = ACTIONS(1643),
    [anon_sym_switch] = ACTIONS(1645),
    [anon_sym_case] = ACTIONS(1673),
    [anon_sym_default] = ACTIONS(1675),
    [anon_sym_while] = ACTIONS(1647),
    [anon_sym_do] = ACTIONS(1649),
    [anon_sym_for] = ACTIONS(1651),
    [anon_sym_return] = ACTIONS(1653),
    [anon_sym_break] = ACTIONS(1655),
    [anon_sym_continue] = ACTIONS(1657),
    [anon_sym_goto] = ACTIONS(1659),
    [anon_sym___try] = ACTIONS(1661),
    [anon_sym___leave] = ACTIONS(1663),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(1665),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(1667),
    [anon_sym_co_return] = ACTIONS(1669),
    [anon_sym_co_yield] = ACTIONS(1671),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [208] = {
    [sym_attribute_declaration] = STATE(216),
    [sym_compound_statement] = STATE(462),
    [sym_attributed_statement] = STATE(462),
    [sym_statement] = STATE(423),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [sym_identifier] = ACTIONS(2025),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [209] = {
    [sym_attribute_declaration] = STATE(216),
    [sym_compound_statement] = STATE(462),
    [sym_attributed_statement] = STATE(462),
    [sym_statement] = STATE(522),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [sym_identifier] = ACTIONS(2025),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [210] = {
    [sym_attribute_declaration] = STATE(187),
    [sym_compound_statement] = STATE(462),
    [sym_attributed_statement] = STATE(462),
    [sym_statement] = STATE(8569),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(187),
    [sym_identifier] = ACTIONS(2035),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_if] = ACTIONS(1679),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(1673),
    [anon_sym_default] = ACTIONS(1675),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_for] = ACTIONS(1683),
    [anon_sym_return] = ACTIONS(93),
    [anon_sym_break] = ACTIONS(95),
    [anon_sym_continue] = ACTIONS(97),
    [anon_sym_goto] = ACTIONS(99),
    [anon_sym___try] = ACTIONS(1685),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [211] = {
    [sym_attribute_declaration] = STATE(211),
    [sym_compound_statement] = STATE(462),
    [sym_attributed_statement] = STATE(462),
    [sym_statement] = STATE(511),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(211),
    [sym_identifier] = ACTIONS(2385),
    [anon_sym_LPAREN2] = ACTIONS(2042),
    [anon_sym_BANG] = ACTIONS(2045),
    [anon_sym_TILDE] = ACTIONS(2045),
    [anon_sym_DASH] = ACTIONS(2048),
    [anon_sym_PLUS] = ACTIONS(2048),
    [anon_sym_STAR] = ACTIONS(2051),
    [anon_sym_AMP] = ACTIONS(2051),
    [anon_sym_SEMI] = ACTIONS(2183),
    [anon_sym___extension__] = ACTIONS(2057),
    [anon_sym_COLON_COLON] = ACTIONS(2060),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2063),
    [anon_sym_LBRACE] = ACTIONS(2388),
    [anon_sym_LBRACK] = ACTIONS(2069),
    [sym_primitive_type] = ACTIONS(2072),
    [anon_sym_if] = ACTIONS(2391),
    [anon_sym_switch] = ACTIONS(2394),
    [anon_sym_case] = ACTIONS(2397),
    [anon_sym_default] = ACTIONS(2400),
    [anon_sym_while] = ACTIONS(2403),
    [anon_sym_do] = ACTIONS(2406),
    [anon_sym_for] = ACTIONS(2409),
    [anon_sym_return] = ACTIONS(2412),
    [anon_sym_break] = ACTIONS(2415),
    [anon_sym_continue] = ACTIONS(2418),
    [anon_sym_goto] = ACTIONS(2421),
    [anon_sym___try] = ACTIONS(2424),
    [anon_sym___leave] = ACTIONS(2225),
    [anon_sym_not] = ACTIONS(2048),
    [anon_sym_compl] = ACTIONS(2048),
    [anon_sym_DASH_DASH] = ACTIONS(2114),
    [anon_sym_PLUS_PLUS] = ACTIONS(2114),
    [anon_sym_sizeof] = ACTIONS(2117),
    [anon_sym___alignof__] = ACTIONS(2120),
    [anon_sym___alignof] = ACTIONS(2120),
    [anon_sym__alignof] = ACTIONS(2120),
    [anon_sym_alignof] = ACTIONS(2120),
    [anon_sym__Alignof] = ACTIONS(2120),
    [anon_sym_offsetof] = ACTIONS(2123),
    [anon_sym__Generic] = ACTIONS(2126),
    [anon_sym_asm] = ACTIONS(2129),
    [anon_sym___asm__] = ACTIONS(2129),
    [anon_sym___asm] = ACTIONS(2129),
    [sym_number_literal] = ACTIONS(2132),
    [anon_sym_L_SQUOTE] = ACTIONS(2135),
    [anon_sym_u_SQUOTE] = ACTIONS(2135),
    [anon_sym_U_SQUOTE] = ACTIONS(2135),
    [anon_sym_u8_SQUOTE] = ACTIONS(2135),
    [anon_sym_SQUOTE] = ACTIONS(2135),
    [anon_sym_L_DQUOTE] = ACTIONS(2138),
    [anon_sym_u_DQUOTE] = ACTIONS(2138),
    [anon_sym_U_DQUOTE] = ACTIONS(2138),
    [anon_sym_u8_DQUOTE] = ACTIONS(2138),
    [anon_sym_DQUOTE] = ACTIONS(2138),
    [sym_true] = ACTIONS(2141),
    [sym_false] = ACTIONS(2141),
    [anon_sym_NULL] = ACTIONS(2144),
    [anon_sym_nullptr] = ACTIONS(2144),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2147),
    [anon_sym_template] = ACTIONS(2150),
    [anon_sym_try] = ACTIONS(2427),
    [anon_sym_delete] = ACTIONS(2156),
    [anon_sym_throw] = ACTIONS(2430),
    [anon_sym_co_return] = ACTIONS(2433),
    [anon_sym_co_yield] = ACTIONS(2436),
    [anon_sym_R_DQUOTE] = ACTIONS(2168),
    [anon_sym_LR_DQUOTE] = ACTIONS(2168),
    [anon_sym_uR_DQUOTE] = ACTIONS(2168),
    [anon_sym_UR_DQUOTE] = ACTIONS(2168),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2168),
    [anon_sym_co_await] = ACTIONS(2171),
    [anon_sym_new] = ACTIONS(2174),
    [anon_sym_requires] = ACTIONS(2177),
    [sym_this] = ACTIONS(2141),
  },
  [212] = {
    [sym_attribute_declaration] = STATE(216),
    [sym_compound_statement] = STATE(462),
    [sym_attributed_statement] = STATE(462),
    [sym_statement] = STATE(413),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(216),
    [sym_identifier] = ACTIONS(2025),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [213] = {
    [sym_attribute_declaration] = STATE(187),
    [sym_compound_statement] = STATE(462),
    [sym_attributed_statement] = STATE(462),
    [sym_statement] = STATE(8134),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(187),
    [sym_identifier] = ACTIONS(2035),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_if] = ACTIONS(1679),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(1673),
    [anon_sym_default] = ACTIONS(1675),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_for] = ACTIONS(1683),
    [anon_sym_return] = ACTIONS(93),
    [anon_sym_break] = ACTIONS(95),
    [anon_sym_continue] = ACTIONS(97),
    [anon_sym_goto] = ACTIONS(99),
    [anon_sym___try] = ACTIONS(1685),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [214] = {
    [sym_attribute_declaration] = STATE(187),
    [sym_compound_statement] = STATE(462),
    [sym_attributed_statement] = STATE(462),
    [sym_statement] = STATE(8319),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(187),
    [sym_identifier] = ACTIONS(2035),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_if] = ACTIONS(1679),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(1673),
    [anon_sym_default] = ACTIONS(1675),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_for] = ACTIONS(1683),
    [anon_sym_return] = ACTIONS(93),
    [anon_sym_break] = ACTIONS(95),
    [anon_sym_continue] = ACTIONS(97),
    [anon_sym_goto] = ACTIONS(99),
    [anon_sym___try] = ACTIONS(1685),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [215] = {
    [sym_attribute_declaration] = STATE(187),
    [sym_compound_statement] = STATE(462),
    [sym_attributed_statement] = STATE(462),
    [sym_statement] = STATE(8345),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(187),
    [sym_identifier] = ACTIONS(2035),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_if] = ACTIONS(1679),
    [anon_sym_switch] = ACTIONS(81),
    [anon_sym_case] = ACTIONS(1673),
    [anon_sym_default] = ACTIONS(1675),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_do] = ACTIONS(89),
    [anon_sym_for] = ACTIONS(1683),
    [anon_sym_return] = ACTIONS(93),
    [anon_sym_break] = ACTIONS(95),
    [anon_sym_continue] = ACTIONS(97),
    [anon_sym_goto] = ACTIONS(99),
    [anon_sym___try] = ACTIONS(1685),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(135),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(139),
    [anon_sym_co_return] = ACTIONS(149),
    [anon_sym_co_yield] = ACTIONS(151),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [216] = {
    [sym_attribute_declaration] = STATE(211),
    [sym_compound_statement] = STATE(462),
    [sym_attributed_statement] = STATE(462),
    [sym_statement] = STATE(511),
    [sym_labeled_statement] = STATE(462),
    [sym_expression_statement] = STATE(462),
    [sym_if_statement] = STATE(462),
    [sym_switch_statement] = STATE(462),
    [sym_case_statement] = STATE(462),
    [sym_while_statement] = STATE(462),
    [sym_do_statement] = STATE(462),
    [sym_for_statement] = STATE(462),
    [sym_return_statement] = STATE(462),
    [sym_break_statement] = STATE(462),
    [sym_continue_statement] = STATE(462),
    [sym_goto_statement] = STATE(462),
    [sym_seh_try_statement] = STATE(462),
    [sym_seh_leave_statement] = STATE(462),
    [sym_expression] = STATE(4376),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8021),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_for_range_loop] = STATE(462),
    [sym_co_return_statement] = STATE(462),
    [sym_co_yield_statement] = STATE(462),
    [sym_throw_statement] = STATE(462),
    [sym_try_statement] = STATE(462),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_attributed_declarator_repeat1] = STATE(211),
    [sym_identifier] = ACTIONS(2025),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1231),
    [anon_sym_LBRACE] = ACTIONS(616),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_switch] = ACTIONS(193),
    [anon_sym_case] = ACTIONS(195),
    [anon_sym_default] = ACTIONS(197),
    [anon_sym_while] = ACTIONS(199),
    [anon_sym_do] = ACTIONS(201),
    [anon_sym_for] = ACTIONS(203),
    [anon_sym_return] = ACTIONS(205),
    [anon_sym_break] = ACTIONS(207),
    [anon_sym_continue] = ACTIONS(209),
    [anon_sym_goto] = ACTIONS(211),
    [anon_sym___try] = ACTIONS(213),
    [anon_sym___leave] = ACTIONS(215),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_try] = ACTIONS(225),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_throw] = ACTIONS(227),
    [anon_sym_co_return] = ACTIONS(237),
    [anon_sym_co_yield] = ACTIONS(239),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [217] = {
    [sym_catch_clause] = STATE(217),
    [aux_sym_constructor_try_statement_repeat1] = STATE(217),
    [sym_identifier] = ACTIONS(2439),
    [aux_sym_preproc_include_token1] = ACTIONS(2439),
    [aux_sym_preproc_def_token1] = ACTIONS(2439),
    [aux_sym_preproc_if_token1] = ACTIONS(2439),
    [aux_sym_preproc_if_token2] = ACTIONS(2439),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2439),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2439),
    [aux_sym_preproc_else_token1] = ACTIONS(2439),
    [aux_sym_preproc_elif_token1] = ACTIONS(2439),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2439),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2439),
    [sym_preproc_directive] = ACTIONS(2439),
    [anon_sym_LPAREN2] = ACTIONS(2441),
    [anon_sym_BANG] = ACTIONS(2441),
    [anon_sym_TILDE] = ACTIONS(2441),
    [anon_sym_DASH] = ACTIONS(2439),
    [anon_sym_PLUS] = ACTIONS(2439),
    [anon_sym_STAR] = ACTIONS(2441),
    [anon_sym_AMP_AMP] = ACTIONS(2441),
    [anon_sym_AMP] = ACTIONS(2439),
    [anon_sym_SEMI] = ACTIONS(2441),
    [anon_sym___extension__] = ACTIONS(2439),
    [anon_sym_typedef] = ACTIONS(2439),
    [anon_sym_virtual] = ACTIONS(2439),
    [anon_sym_extern] = ACTIONS(2439),
    [anon_sym___attribute__] = ACTIONS(2439),
    [anon_sym___attribute] = ACTIONS(2439),
    [anon_sym_COLON_COLON] = ACTIONS(2441),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2441),
    [anon_sym___declspec] = ACTIONS(2439),
    [anon_sym___based] = ACTIONS(2439),
    [anon_sym___cdecl] = ACTIONS(2439),
    [anon_sym___clrcall] = ACTIONS(2439),
    [anon_sym___stdcall] = ACTIONS(2439),
    [anon_sym___fastcall] = ACTIONS(2439),
    [anon_sym___thiscall] = ACTIONS(2439),
    [anon_sym___vectorcall] = ACTIONS(2439),
    [anon_sym_LBRACE] = ACTIONS(2441),
    [anon_sym_signed] = ACTIONS(2439),
    [anon_sym_unsigned] = ACTIONS(2439),
    [anon_sym_long] = ACTIONS(2439),
    [anon_sym_short] = ACTIONS(2439),
    [anon_sym_LBRACK] = ACTIONS(2439),
    [anon_sym_static] = ACTIONS(2439),
    [anon_sym_register] = ACTIONS(2439),
    [anon_sym_inline] = ACTIONS(2439),
    [anon_sym___inline] = ACTIONS(2439),
    [anon_sym___inline__] = ACTIONS(2439),
    [anon_sym___forceinline] = ACTIONS(2439),
    [anon_sym_thread_local] = ACTIONS(2439),
    [anon_sym___thread] = ACTIONS(2439),
    [anon_sym_const] = ACTIONS(2439),
    [anon_sym_constexpr] = ACTIONS(2439),
    [anon_sym_volatile] = ACTIONS(2439),
    [anon_sym_restrict] = ACTIONS(2439),
    [anon_sym___restrict__] = ACTIONS(2439),
    [anon_sym__Atomic] = ACTIONS(2439),
    [anon_sym__Noreturn] = ACTIONS(2439),
    [anon_sym_noreturn] = ACTIONS(2439),
    [anon_sym__Nonnull] = ACTIONS(2439),
    [anon_sym_mutable] = ACTIONS(2439),
    [anon_sym_constinit] = ACTIONS(2439),
    [anon_sym_consteval] = ACTIONS(2439),
    [anon_sym_alignas] = ACTIONS(2439),
    [anon_sym__Alignas] = ACTIONS(2439),
    [sym_primitive_type] = ACTIONS(2439),
    [anon_sym_enum] = ACTIONS(2439),
    [anon_sym_class] = ACTIONS(2439),
    [anon_sym_struct] = ACTIONS(2439),
    [anon_sym_union] = ACTIONS(2439),
    [anon_sym_if] = ACTIONS(2439),
    [anon_sym_else] = ACTIONS(2439),
    [anon_sym_switch] = ACTIONS(2439),
    [anon_sym_case] = ACTIONS(2439),
    [anon_sym_default] = ACTIONS(2439),
    [anon_sym_while] = ACTIONS(2439),
    [anon_sym_do] = ACTIONS(2439),
    [anon_sym_for] = ACTIONS(2439),
    [anon_sym_return] = ACTIONS(2439),
    [anon_sym_break] = ACTIONS(2439),
    [anon_sym_continue] = ACTIONS(2439),
    [anon_sym_goto] = ACTIONS(2439),
    [anon_sym___try] = ACTIONS(2439),
    [anon_sym___leave] = ACTIONS(2439),
    [anon_sym_not] = ACTIONS(2439),
    [anon_sym_compl] = ACTIONS(2439),
    [anon_sym_DASH_DASH] = ACTIONS(2441),
    [anon_sym_PLUS_PLUS] = ACTIONS(2441),
    [anon_sym_sizeof] = ACTIONS(2439),
    [anon_sym___alignof__] = ACTIONS(2439),
    [anon_sym___alignof] = ACTIONS(2439),
    [anon_sym__alignof] = ACTIONS(2439),
    [anon_sym_alignof] = ACTIONS(2439),
    [anon_sym__Alignof] = ACTIONS(2439),
    [anon_sym_offsetof] = ACTIONS(2439),
    [anon_sym__Generic] = ACTIONS(2439),
    [anon_sym_asm] = ACTIONS(2439),
    [anon_sym___asm__] = ACTIONS(2439),
    [anon_sym___asm] = ACTIONS(2439),
    [sym_number_literal] = ACTIONS(2441),
    [anon_sym_L_SQUOTE] = ACTIONS(2441),
    [anon_sym_u_SQUOTE] = ACTIONS(2441),
    [anon_sym_U_SQUOTE] = ACTIONS(2441),
    [anon_sym_u8_SQUOTE] = ACTIONS(2441),
    [anon_sym_SQUOTE] = ACTIONS(2441),
    [anon_sym_L_DQUOTE] = ACTIONS(2441),
    [anon_sym_u_DQUOTE] = ACTIONS(2441),
    [anon_sym_U_DQUOTE] = ACTIONS(2441),
    [anon_sym_u8_DQUOTE] = ACTIONS(2441),
    [anon_sym_DQUOTE] = ACTIONS(2441),
    [sym_true] = ACTIONS(2439),
    [sym_false] = ACTIONS(2439),
    [anon_sym_NULL] = ACTIONS(2439),
    [anon_sym_nullptr] = ACTIONS(2439),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2439),
    [anon_sym_decltype] = ACTIONS(2439),
    [anon_sym_explicit] = ACTIONS(2439),
    [anon_sym_typename] = ACTIONS(2439),
    [anon_sym_template] = ACTIONS(2439),
    [anon_sym_operator] = ACTIONS(2439),
    [anon_sym_try] = ACTIONS(2439),
    [anon_sym_delete] = ACTIONS(2439),
    [anon_sym_throw] = ACTIONS(2439),
    [anon_sym_namespace] = ACTIONS(2439),
    [anon_sym_using] = ACTIONS(2439),
    [anon_sym_static_assert] = ACTIONS(2439),
    [anon_sym_concept] = ACTIONS(2439),
    [anon_sym_co_return] = ACTIONS(2439),
    [anon_sym_co_yield] = ACTIONS(2439),
    [anon_sym_catch] = ACTIONS(2443),
    [anon_sym_R_DQUOTE] = ACTIONS(2441),
    [anon_sym_LR_DQUOTE] = ACTIONS(2441),
    [anon_sym_uR_DQUOTE] = ACTIONS(2441),
    [anon_sym_UR_DQUOTE] = ACTIONS(2441),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2441),
    [anon_sym_co_await] = ACTIONS(2439),
    [anon_sym_new] = ACTIONS(2439),
    [anon_sym_requires] = ACTIONS(2439),
    [sym_this] = ACTIONS(2439),
  },
  [218] = {
    [sym_expression] = STATE(3232),
    [sym__string] = STATE(3374),
    [sym_conditional_expression] = STATE(3536),
    [sym_assignment_expression] = STATE(3536),
    [sym_pointer_expression] = STATE(3544),
    [sym_unary_expression] = STATE(3536),
    [sym_binary_expression] = STATE(3536),
    [sym_update_expression] = STATE(3536),
    [sym_cast_expression] = STATE(3536),
    [sym_sizeof_expression] = STATE(3536),
    [sym_alignof_expression] = STATE(3536),
    [sym_offsetof_expression] = STATE(3536),
    [sym_generic_expression] = STATE(3536),
    [sym_subscript_expression] = STATE(3544),
    [sym_call_expression] = STATE(3544),
    [sym_gnu_asm_expression] = STATE(3536),
    [sym_extension_expression] = STATE(3536),
    [sym_field_expression] = STATE(3544),
    [sym_compound_literal_expression] = STATE(3536),
    [sym_parenthesized_expression] = STATE(3544),
    [sym_initializer_list] = STATE(3497),
    [sym_char_literal] = STATE(3374),
    [sym_concatenated_string] = STATE(3374),
    [sym_string_literal] = STATE(2363),
    [sym_null] = STATE(3536),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7597),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3536),
    [sym_raw_string_literal] = STATE(2363),
    [sym_co_await_expression] = STATE(3536),
    [sym_new_expression] = STATE(3536),
    [sym_delete_expression] = STATE(3536),
    [sym_requires_clause] = STATE(3536),
    [sym_requires_expression] = STATE(3536),
    [sym_lambda_expression] = STATE(3536),
    [sym_lambda_capture_specifier] = STATE(5874),
    [sym_fold_expression] = STATE(3536),
    [sym_parameter_pack_expansion] = STATE(3536),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3544),
    [sym_qualified_type_identifier] = STATE(7597),
    [sym_user_defined_literal] = STATE(3544),
    [sym_identifier] = ACTIONS(2446),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1917),
    [anon_sym_COMMA] = ACTIONS(1917),
    [anon_sym_LPAREN2] = ACTIONS(1917),
    [anon_sym_BANG] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(1915),
    [anon_sym_PLUS] = ACTIONS(1915),
    [anon_sym_STAR] = ACTIONS(1915),
    [anon_sym_SLASH] = ACTIONS(1915),
    [anon_sym_PERCENT] = ACTIONS(1915),
    [anon_sym_PIPE_PIPE] = ACTIONS(1917),
    [anon_sym_AMP_AMP] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(1915),
    [anon_sym_CARET] = ACTIONS(1915),
    [anon_sym_AMP] = ACTIONS(1915),
    [anon_sym_EQ_EQ] = ACTIONS(1917),
    [anon_sym_BANG_EQ] = ACTIONS(1917),
    [anon_sym_GT] = ACTIONS(1915),
    [anon_sym_GT_EQ] = ACTIONS(1915),
    [anon_sym_LT_EQ] = ACTIONS(1915),
    [anon_sym_LT] = ACTIONS(1915),
    [anon_sym_LT_LT] = ACTIONS(1915),
    [anon_sym_GT_GT] = ACTIONS(1915),
    [anon_sym___extension__] = ACTIONS(2452),
    [anon_sym_COLON_COLON] = ACTIONS(2454),
    [anon_sym_LBRACE] = ACTIONS(2456),
    [anon_sym_LBRACK] = ACTIONS(1917),
    [anon_sym_EQ] = ACTIONS(1915),
    [sym_primitive_type] = ACTIONS(2458),
    [anon_sym_QMARK] = ACTIONS(1917),
    [anon_sym_STAR_EQ] = ACTIONS(1917),
    [anon_sym_SLASH_EQ] = ACTIONS(1917),
    [anon_sym_PERCENT_EQ] = ACTIONS(1917),
    [anon_sym_PLUS_EQ] = ACTIONS(1917),
    [anon_sym_DASH_EQ] = ACTIONS(1917),
    [anon_sym_LT_LT_EQ] = ACTIONS(1917),
    [anon_sym_GT_GT_EQ] = ACTIONS(1915),
    [anon_sym_AMP_EQ] = ACTIONS(1917),
    [anon_sym_CARET_EQ] = ACTIONS(1917),
    [anon_sym_PIPE_EQ] = ACTIONS(1917),
    [anon_sym_and_eq] = ACTIONS(1915),
    [anon_sym_or_eq] = ACTIONS(1915),
    [anon_sym_xor_eq] = ACTIONS(1915),
    [anon_sym_not] = ACTIONS(2448),
    [anon_sym_compl] = ACTIONS(2448),
    [anon_sym_LT_EQ_GT] = ACTIONS(1917),
    [anon_sym_or] = ACTIONS(1915),
    [anon_sym_and] = ACTIONS(1915),
    [anon_sym_bitor] = ACTIONS(1915),
    [anon_sym_xor] = ACTIONS(1915),
    [anon_sym_bitand] = ACTIONS(1915),
    [anon_sym_not_eq] = ACTIONS(1915),
    [anon_sym_DASH_DASH] = ACTIONS(1917),
    [anon_sym_PLUS_PLUS] = ACTIONS(1917),
    [anon_sym_sizeof] = ACTIONS(2460),
    [anon_sym___alignof__] = ACTIONS(2462),
    [anon_sym___alignof] = ACTIONS(2462),
    [anon_sym__alignof] = ACTIONS(2462),
    [anon_sym_alignof] = ACTIONS(2462),
    [anon_sym__Alignof] = ACTIONS(2462),
    [anon_sym_offsetof] = ACTIONS(2464),
    [anon_sym__Generic] = ACTIONS(2466),
    [anon_sym_asm] = ACTIONS(2468),
    [anon_sym___asm__] = ACTIONS(2468),
    [anon_sym___asm] = ACTIONS(2468),
    [anon_sym_DOT] = ACTIONS(1915),
    [anon_sym_DOT_STAR] = ACTIONS(1917),
    [anon_sym_DASH_GT] = ACTIONS(1917),
    [sym_number_literal] = ACTIONS(2470),
    [anon_sym_L_SQUOTE] = ACTIONS(2472),
    [anon_sym_u_SQUOTE] = ACTIONS(2472),
    [anon_sym_U_SQUOTE] = ACTIONS(2472),
    [anon_sym_u8_SQUOTE] = ACTIONS(2472),
    [anon_sym_SQUOTE] = ACTIONS(2472),
    [anon_sym_L_DQUOTE] = ACTIONS(2474),
    [anon_sym_u_DQUOTE] = ACTIONS(2474),
    [anon_sym_U_DQUOTE] = ACTIONS(2474),
    [anon_sym_u8_DQUOTE] = ACTIONS(2474),
    [anon_sym_DQUOTE] = ACTIONS(2474),
    [sym_true] = ACTIONS(2476),
    [sym_false] = ACTIONS(2476),
    [anon_sym_NULL] = ACTIONS(2478),
    [anon_sym_nullptr] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_GT2] = ACTIONS(1917),
    [anon_sym_delete] = ACTIONS(2480),
    [anon_sym_R_DQUOTE] = ACTIONS(2482),
    [anon_sym_LR_DQUOTE] = ACTIONS(2482),
    [anon_sym_uR_DQUOTE] = ACTIONS(2482),
    [anon_sym_UR_DQUOTE] = ACTIONS(2482),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2482),
    [anon_sym_co_await] = ACTIONS(2484),
    [anon_sym_new] = ACTIONS(2486),
    [anon_sym_requires] = ACTIONS(2488),
    [sym_this] = ACTIONS(2476),
  },
  [219] = {
    [sym_catch_clause] = STATE(217),
    [aux_sym_constructor_try_statement_repeat1] = STATE(217),
    [sym_identifier] = ACTIONS(2490),
    [aux_sym_preproc_include_token1] = ACTIONS(2490),
    [aux_sym_preproc_def_token1] = ACTIONS(2490),
    [aux_sym_preproc_if_token1] = ACTIONS(2490),
    [aux_sym_preproc_if_token2] = ACTIONS(2490),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2490),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2490),
    [aux_sym_preproc_else_token1] = ACTIONS(2490),
    [aux_sym_preproc_elif_token1] = ACTIONS(2490),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2490),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2490),
    [sym_preproc_directive] = ACTIONS(2490),
    [anon_sym_LPAREN2] = ACTIONS(2492),
    [anon_sym_BANG] = ACTIONS(2492),
    [anon_sym_TILDE] = ACTIONS(2492),
    [anon_sym_DASH] = ACTIONS(2490),
    [anon_sym_PLUS] = ACTIONS(2490),
    [anon_sym_STAR] = ACTIONS(2492),
    [anon_sym_AMP_AMP] = ACTIONS(2492),
    [anon_sym_AMP] = ACTIONS(2490),
    [anon_sym_SEMI] = ACTIONS(2492),
    [anon_sym___extension__] = ACTIONS(2490),
    [anon_sym_typedef] = ACTIONS(2490),
    [anon_sym_virtual] = ACTIONS(2490),
    [anon_sym_extern] = ACTIONS(2490),
    [anon_sym___attribute__] = ACTIONS(2490),
    [anon_sym___attribute] = ACTIONS(2490),
    [anon_sym_COLON_COLON] = ACTIONS(2492),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2492),
    [anon_sym___declspec] = ACTIONS(2490),
    [anon_sym___based] = ACTIONS(2490),
    [anon_sym___cdecl] = ACTIONS(2490),
    [anon_sym___clrcall] = ACTIONS(2490),
    [anon_sym___stdcall] = ACTIONS(2490),
    [anon_sym___fastcall] = ACTIONS(2490),
    [anon_sym___thiscall] = ACTIONS(2490),
    [anon_sym___vectorcall] = ACTIONS(2490),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_signed] = ACTIONS(2490),
    [anon_sym_unsigned] = ACTIONS(2490),
    [anon_sym_long] = ACTIONS(2490),
    [anon_sym_short] = ACTIONS(2490),
    [anon_sym_LBRACK] = ACTIONS(2490),
    [anon_sym_static] = ACTIONS(2490),
    [anon_sym_register] = ACTIONS(2490),
    [anon_sym_inline] = ACTIONS(2490),
    [anon_sym___inline] = ACTIONS(2490),
    [anon_sym___inline__] = ACTIONS(2490),
    [anon_sym___forceinline] = ACTIONS(2490),
    [anon_sym_thread_local] = ACTIONS(2490),
    [anon_sym___thread] = ACTIONS(2490),
    [anon_sym_const] = ACTIONS(2490),
    [anon_sym_constexpr] = ACTIONS(2490),
    [anon_sym_volatile] = ACTIONS(2490),
    [anon_sym_restrict] = ACTIONS(2490),
    [anon_sym___restrict__] = ACTIONS(2490),
    [anon_sym__Atomic] = ACTIONS(2490),
    [anon_sym__Noreturn] = ACTIONS(2490),
    [anon_sym_noreturn] = ACTIONS(2490),
    [anon_sym__Nonnull] = ACTIONS(2490),
    [anon_sym_mutable] = ACTIONS(2490),
    [anon_sym_constinit] = ACTIONS(2490),
    [anon_sym_consteval] = ACTIONS(2490),
    [anon_sym_alignas] = ACTIONS(2490),
    [anon_sym__Alignas] = ACTIONS(2490),
    [sym_primitive_type] = ACTIONS(2490),
    [anon_sym_enum] = ACTIONS(2490),
    [anon_sym_class] = ACTIONS(2490),
    [anon_sym_struct] = ACTIONS(2490),
    [anon_sym_union] = ACTIONS(2490),
    [anon_sym_if] = ACTIONS(2490),
    [anon_sym_else] = ACTIONS(2490),
    [anon_sym_switch] = ACTIONS(2490),
    [anon_sym_case] = ACTIONS(2490),
    [anon_sym_default] = ACTIONS(2490),
    [anon_sym_while] = ACTIONS(2490),
    [anon_sym_do] = ACTIONS(2490),
    [anon_sym_for] = ACTIONS(2490),
    [anon_sym_return] = ACTIONS(2490),
    [anon_sym_break] = ACTIONS(2490),
    [anon_sym_continue] = ACTIONS(2490),
    [anon_sym_goto] = ACTIONS(2490),
    [anon_sym___try] = ACTIONS(2490),
    [anon_sym___leave] = ACTIONS(2490),
    [anon_sym_not] = ACTIONS(2490),
    [anon_sym_compl] = ACTIONS(2490),
    [anon_sym_DASH_DASH] = ACTIONS(2492),
    [anon_sym_PLUS_PLUS] = ACTIONS(2492),
    [anon_sym_sizeof] = ACTIONS(2490),
    [anon_sym___alignof__] = ACTIONS(2490),
    [anon_sym___alignof] = ACTIONS(2490),
    [anon_sym__alignof] = ACTIONS(2490),
    [anon_sym_alignof] = ACTIONS(2490),
    [anon_sym__Alignof] = ACTIONS(2490),
    [anon_sym_offsetof] = ACTIONS(2490),
    [anon_sym__Generic] = ACTIONS(2490),
    [anon_sym_asm] = ACTIONS(2490),
    [anon_sym___asm__] = ACTIONS(2490),
    [anon_sym___asm] = ACTIONS(2490),
    [sym_number_literal] = ACTIONS(2492),
    [anon_sym_L_SQUOTE] = ACTIONS(2492),
    [anon_sym_u_SQUOTE] = ACTIONS(2492),
    [anon_sym_U_SQUOTE] = ACTIONS(2492),
    [anon_sym_u8_SQUOTE] = ACTIONS(2492),
    [anon_sym_SQUOTE] = ACTIONS(2492),
    [anon_sym_L_DQUOTE] = ACTIONS(2492),
    [anon_sym_u_DQUOTE] = ACTIONS(2492),
    [anon_sym_U_DQUOTE] = ACTIONS(2492),
    [anon_sym_u8_DQUOTE] = ACTIONS(2492),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [sym_true] = ACTIONS(2490),
    [sym_false] = ACTIONS(2490),
    [anon_sym_NULL] = ACTIONS(2490),
    [anon_sym_nullptr] = ACTIONS(2490),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2490),
    [anon_sym_decltype] = ACTIONS(2490),
    [anon_sym_explicit] = ACTIONS(2490),
    [anon_sym_typename] = ACTIONS(2490),
    [anon_sym_template] = ACTIONS(2490),
    [anon_sym_operator] = ACTIONS(2490),
    [anon_sym_try] = ACTIONS(2490),
    [anon_sym_delete] = ACTIONS(2490),
    [anon_sym_throw] = ACTIONS(2490),
    [anon_sym_namespace] = ACTIONS(2490),
    [anon_sym_using] = ACTIONS(2490),
    [anon_sym_static_assert] = ACTIONS(2490),
    [anon_sym_concept] = ACTIONS(2490),
    [anon_sym_co_return] = ACTIONS(2490),
    [anon_sym_co_yield] = ACTIONS(2490),
    [anon_sym_catch] = ACTIONS(2494),
    [anon_sym_R_DQUOTE] = ACTIONS(2492),
    [anon_sym_LR_DQUOTE] = ACTIONS(2492),
    [anon_sym_uR_DQUOTE] = ACTIONS(2492),
    [anon_sym_UR_DQUOTE] = ACTIONS(2492),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2492),
    [anon_sym_co_await] = ACTIONS(2490),
    [anon_sym_new] = ACTIONS(2490),
    [anon_sym_requires] = ACTIONS(2490),
    [sym_this] = ACTIONS(2490),
  },
  [220] = {
    [sym_expression] = STATE(3280),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_initializer_list] = STATE(2473),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1917),
    [anon_sym_COMMA] = ACTIONS(1917),
    [anon_sym_LPAREN2] = ACTIONS(1917),
    [anon_sym_BANG] = ACTIONS(2496),
    [anon_sym_TILDE] = ACTIONS(2498),
    [anon_sym_DASH] = ACTIONS(1915),
    [anon_sym_PLUS] = ACTIONS(1915),
    [anon_sym_STAR] = ACTIONS(1915),
    [anon_sym_SLASH] = ACTIONS(1915),
    [anon_sym_PERCENT] = ACTIONS(1915),
    [anon_sym_PIPE_PIPE] = ACTIONS(1917),
    [anon_sym_AMP_AMP] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(1915),
    [anon_sym_CARET] = ACTIONS(1915),
    [anon_sym_AMP] = ACTIONS(1915),
    [anon_sym_EQ_EQ] = ACTIONS(1917),
    [anon_sym_BANG_EQ] = ACTIONS(1917),
    [anon_sym_GT] = ACTIONS(1915),
    [anon_sym_GT_EQ] = ACTIONS(1917),
    [anon_sym_LT_EQ] = ACTIONS(1915),
    [anon_sym_LT] = ACTIONS(1915),
    [anon_sym_LT_LT] = ACTIONS(1915),
    [anon_sym_GT_GT] = ACTIONS(1915),
    [anon_sym___extension__] = ACTIONS(2500),
    [anon_sym_COLON_COLON] = ACTIONS(2502),
    [anon_sym_LBRACE] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(1917),
    [anon_sym_EQ] = ACTIONS(1915),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_COLON] = ACTIONS(1915),
    [anon_sym_QMARK] = ACTIONS(1917),
    [anon_sym_STAR_EQ] = ACTIONS(1917),
    [anon_sym_SLASH_EQ] = ACTIONS(1917),
    [anon_sym_PERCENT_EQ] = ACTIONS(1917),
    [anon_sym_PLUS_EQ] = ACTIONS(1917),
    [anon_sym_DASH_EQ] = ACTIONS(1917),
    [anon_sym_LT_LT_EQ] = ACTIONS(1917),
    [anon_sym_GT_GT_EQ] = ACTIONS(1917),
    [anon_sym_AMP_EQ] = ACTIONS(1917),
    [anon_sym_CARET_EQ] = ACTIONS(1917),
    [anon_sym_PIPE_EQ] = ACTIONS(1917),
    [anon_sym_and_eq] = ACTIONS(1915),
    [anon_sym_or_eq] = ACTIONS(1915),
    [anon_sym_xor_eq] = ACTIONS(1915),
    [anon_sym_not] = ACTIONS(2496),
    [anon_sym_compl] = ACTIONS(2496),
    [anon_sym_LT_EQ_GT] = ACTIONS(1917),
    [anon_sym_or] = ACTIONS(1915),
    [anon_sym_and] = ACTIONS(1915),
    [anon_sym_bitor] = ACTIONS(1915),
    [anon_sym_xor] = ACTIONS(1915),
    [anon_sym_bitand] = ACTIONS(1915),
    [anon_sym_not_eq] = ACTIONS(1915),
    [anon_sym_DASH_DASH] = ACTIONS(1917),
    [anon_sym_PLUS_PLUS] = ACTIONS(1917),
    [anon_sym_sizeof] = ACTIONS(2504),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [anon_sym_DOT] = ACTIONS(1915),
    [anon_sym_DOT_STAR] = ACTIONS(1917),
    [anon_sym_DASH_GT] = ACTIONS(1917),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2506),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(2508),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [221] = {
    [sym_catch_clause] = STATE(217),
    [aux_sym_constructor_try_statement_repeat1] = STATE(217),
    [sym_identifier] = ACTIONS(2510),
    [aux_sym_preproc_include_token1] = ACTIONS(2510),
    [aux_sym_preproc_def_token1] = ACTIONS(2510),
    [aux_sym_preproc_if_token1] = ACTIONS(2510),
    [aux_sym_preproc_if_token2] = ACTIONS(2510),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2510),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2510),
    [aux_sym_preproc_else_token1] = ACTIONS(2510),
    [aux_sym_preproc_elif_token1] = ACTIONS(2510),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2510),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2510),
    [sym_preproc_directive] = ACTIONS(2510),
    [anon_sym_LPAREN2] = ACTIONS(2512),
    [anon_sym_BANG] = ACTIONS(2512),
    [anon_sym_TILDE] = ACTIONS(2512),
    [anon_sym_DASH] = ACTIONS(2510),
    [anon_sym_PLUS] = ACTIONS(2510),
    [anon_sym_STAR] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2510),
    [anon_sym_SEMI] = ACTIONS(2512),
    [anon_sym___extension__] = ACTIONS(2510),
    [anon_sym_typedef] = ACTIONS(2510),
    [anon_sym_virtual] = ACTIONS(2510),
    [anon_sym_extern] = ACTIONS(2510),
    [anon_sym___attribute__] = ACTIONS(2510),
    [anon_sym___attribute] = ACTIONS(2510),
    [anon_sym_COLON_COLON] = ACTIONS(2512),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2512),
    [anon_sym___declspec] = ACTIONS(2510),
    [anon_sym___based] = ACTIONS(2510),
    [anon_sym___cdecl] = ACTIONS(2510),
    [anon_sym___clrcall] = ACTIONS(2510),
    [anon_sym___stdcall] = ACTIONS(2510),
    [anon_sym___fastcall] = ACTIONS(2510),
    [anon_sym___thiscall] = ACTIONS(2510),
    [anon_sym___vectorcall] = ACTIONS(2510),
    [anon_sym_LBRACE] = ACTIONS(2512),
    [anon_sym_signed] = ACTIONS(2510),
    [anon_sym_unsigned] = ACTIONS(2510),
    [anon_sym_long] = ACTIONS(2510),
    [anon_sym_short] = ACTIONS(2510),
    [anon_sym_LBRACK] = ACTIONS(2510),
    [anon_sym_static] = ACTIONS(2510),
    [anon_sym_register] = ACTIONS(2510),
    [anon_sym_inline] = ACTIONS(2510),
    [anon_sym___inline] = ACTIONS(2510),
    [anon_sym___inline__] = ACTIONS(2510),
    [anon_sym___forceinline] = ACTIONS(2510),
    [anon_sym_thread_local] = ACTIONS(2510),
    [anon_sym___thread] = ACTIONS(2510),
    [anon_sym_const] = ACTIONS(2510),
    [anon_sym_constexpr] = ACTIONS(2510),
    [anon_sym_volatile] = ACTIONS(2510),
    [anon_sym_restrict] = ACTIONS(2510),
    [anon_sym___restrict__] = ACTIONS(2510),
    [anon_sym__Atomic] = ACTIONS(2510),
    [anon_sym__Noreturn] = ACTIONS(2510),
    [anon_sym_noreturn] = ACTIONS(2510),
    [anon_sym__Nonnull] = ACTIONS(2510),
    [anon_sym_mutable] = ACTIONS(2510),
    [anon_sym_constinit] = ACTIONS(2510),
    [anon_sym_consteval] = ACTIONS(2510),
    [anon_sym_alignas] = ACTIONS(2510),
    [anon_sym__Alignas] = ACTIONS(2510),
    [sym_primitive_type] = ACTIONS(2510),
    [anon_sym_enum] = ACTIONS(2510),
    [anon_sym_class] = ACTIONS(2510),
    [anon_sym_struct] = ACTIONS(2510),
    [anon_sym_union] = ACTIONS(2510),
    [anon_sym_if] = ACTIONS(2510),
    [anon_sym_switch] = ACTIONS(2510),
    [anon_sym_case] = ACTIONS(2510),
    [anon_sym_default] = ACTIONS(2510),
    [anon_sym_while] = ACTIONS(2510),
    [anon_sym_do] = ACTIONS(2510),
    [anon_sym_for] = ACTIONS(2510),
    [anon_sym_return] = ACTIONS(2510),
    [anon_sym_break] = ACTIONS(2510),
    [anon_sym_continue] = ACTIONS(2510),
    [anon_sym_goto] = ACTIONS(2510),
    [anon_sym___try] = ACTIONS(2510),
    [anon_sym___leave] = ACTIONS(2510),
    [anon_sym_not] = ACTIONS(2510),
    [anon_sym_compl] = ACTIONS(2510),
    [anon_sym_DASH_DASH] = ACTIONS(2512),
    [anon_sym_PLUS_PLUS] = ACTIONS(2512),
    [anon_sym_sizeof] = ACTIONS(2510),
    [anon_sym___alignof__] = ACTIONS(2510),
    [anon_sym___alignof] = ACTIONS(2510),
    [anon_sym__alignof] = ACTIONS(2510),
    [anon_sym_alignof] = ACTIONS(2510),
    [anon_sym__Alignof] = ACTIONS(2510),
    [anon_sym_offsetof] = ACTIONS(2510),
    [anon_sym__Generic] = ACTIONS(2510),
    [anon_sym_asm] = ACTIONS(2510),
    [anon_sym___asm__] = ACTIONS(2510),
    [anon_sym___asm] = ACTIONS(2510),
    [sym_number_literal] = ACTIONS(2512),
    [anon_sym_L_SQUOTE] = ACTIONS(2512),
    [anon_sym_u_SQUOTE] = ACTIONS(2512),
    [anon_sym_U_SQUOTE] = ACTIONS(2512),
    [anon_sym_u8_SQUOTE] = ACTIONS(2512),
    [anon_sym_SQUOTE] = ACTIONS(2512),
    [anon_sym_L_DQUOTE] = ACTIONS(2512),
    [anon_sym_u_DQUOTE] = ACTIONS(2512),
    [anon_sym_U_DQUOTE] = ACTIONS(2512),
    [anon_sym_u8_DQUOTE] = ACTIONS(2512),
    [anon_sym_DQUOTE] = ACTIONS(2512),
    [sym_true] = ACTIONS(2510),
    [sym_false] = ACTIONS(2510),
    [anon_sym_NULL] = ACTIONS(2510),
    [anon_sym_nullptr] = ACTIONS(2510),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2510),
    [anon_sym_decltype] = ACTIONS(2510),
    [anon_sym_explicit] = ACTIONS(2510),
    [anon_sym_typename] = ACTIONS(2510),
    [anon_sym_template] = ACTIONS(2510),
    [anon_sym_operator] = ACTIONS(2510),
    [anon_sym_try] = ACTIONS(2510),
    [anon_sym_delete] = ACTIONS(2510),
    [anon_sym_throw] = ACTIONS(2510),
    [anon_sym_namespace] = ACTIONS(2510),
    [anon_sym_using] = ACTIONS(2510),
    [anon_sym_static_assert] = ACTIONS(2510),
    [anon_sym_concept] = ACTIONS(2510),
    [anon_sym_co_return] = ACTIONS(2510),
    [anon_sym_co_yield] = ACTIONS(2510),
    [anon_sym_catch] = ACTIONS(2494),
    [anon_sym_R_DQUOTE] = ACTIONS(2512),
    [anon_sym_LR_DQUOTE] = ACTIONS(2512),
    [anon_sym_uR_DQUOTE] = ACTIONS(2512),
    [anon_sym_UR_DQUOTE] = ACTIONS(2512),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2512),
    [anon_sym_co_await] = ACTIONS(2510),
    [anon_sym_new] = ACTIONS(2510),
    [anon_sym_requires] = ACTIONS(2510),
    [sym_this] = ACTIONS(2510),
  },
  [222] = {
    [sym_expression] = STATE(4247),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(2514),
    [anon_sym_LPAREN2] = ACTIONS(2517),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(2520),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(2523),
    [anon_sym_AMP_AMP] = ACTIONS(2526),
    [anon_sym_AMP] = ACTIONS(2528),
    [anon_sym___extension__] = ACTIONS(2531),
    [anon_sym_typedef] = ACTIONS(2534),
    [anon_sym_virtual] = ACTIONS(2536),
    [anon_sym_extern] = ACTIONS(2536),
    [anon_sym___attribute__] = ACTIONS(2536),
    [anon_sym___attribute] = ACTIONS(2536),
    [anon_sym_COLON_COLON] = ACTIONS(2538),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2526),
    [anon_sym___declspec] = ACTIONS(2536),
    [anon_sym___based] = ACTIONS(2536),
    [anon_sym_signed] = ACTIONS(2536),
    [anon_sym_unsigned] = ACTIONS(2536),
    [anon_sym_long] = ACTIONS(2536),
    [anon_sym_short] = ACTIONS(2536),
    [anon_sym_LBRACK] = ACTIONS(2541),
    [anon_sym_static] = ACTIONS(2536),
    [anon_sym_register] = ACTIONS(2536),
    [anon_sym_inline] = ACTIONS(2536),
    [anon_sym___inline] = ACTIONS(2536),
    [anon_sym___inline__] = ACTIONS(2536),
    [anon_sym___forceinline] = ACTIONS(2536),
    [anon_sym_thread_local] = ACTIONS(2536),
    [anon_sym___thread] = ACTIONS(2536),
    [anon_sym_const] = ACTIONS(2536),
    [anon_sym_constexpr] = ACTIONS(2536),
    [anon_sym_volatile] = ACTIONS(2536),
    [anon_sym_restrict] = ACTIONS(2536),
    [anon_sym___restrict__] = ACTIONS(2536),
    [anon_sym__Atomic] = ACTIONS(2536),
    [anon_sym__Noreturn] = ACTIONS(2536),
    [anon_sym_noreturn] = ACTIONS(2536),
    [anon_sym__Nonnull] = ACTIONS(2536),
    [anon_sym_mutable] = ACTIONS(2536),
    [anon_sym_constinit] = ACTIONS(2536),
    [anon_sym_consteval] = ACTIONS(2536),
    [anon_sym_alignas] = ACTIONS(2536),
    [anon_sym__Alignas] = ACTIONS(2536),
    [sym_primitive_type] = ACTIONS(2544),
    [anon_sym_enum] = ACTIONS(2536),
    [anon_sym_class] = ACTIONS(2536),
    [anon_sym_struct] = ACTIONS(2536),
    [anon_sym_union] = ACTIONS(2536),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2536),
    [anon_sym_decltype] = ACTIONS(2547),
    [anon_sym_explicit] = ACTIONS(2536),
    [anon_sym_typename] = ACTIONS(2536),
    [anon_sym_template] = ACTIONS(2550),
    [anon_sym_operator] = ACTIONS(2536),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [223] = {
    [sym_catch_clause] = STATE(217),
    [aux_sym_constructor_try_statement_repeat1] = STATE(217),
    [sym_identifier] = ACTIONS(2553),
    [aux_sym_preproc_include_token1] = ACTIONS(2553),
    [aux_sym_preproc_def_token1] = ACTIONS(2553),
    [aux_sym_preproc_if_token1] = ACTIONS(2553),
    [aux_sym_preproc_if_token2] = ACTIONS(2553),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2553),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2553),
    [aux_sym_preproc_else_token1] = ACTIONS(2553),
    [aux_sym_preproc_elif_token1] = ACTIONS(2553),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2553),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2553),
    [sym_preproc_directive] = ACTIONS(2553),
    [anon_sym_LPAREN2] = ACTIONS(2555),
    [anon_sym_BANG] = ACTIONS(2555),
    [anon_sym_TILDE] = ACTIONS(2555),
    [anon_sym_DASH] = ACTIONS(2553),
    [anon_sym_PLUS] = ACTIONS(2553),
    [anon_sym_STAR] = ACTIONS(2555),
    [anon_sym_AMP_AMP] = ACTIONS(2555),
    [anon_sym_AMP] = ACTIONS(2553),
    [anon_sym_SEMI] = ACTIONS(2555),
    [anon_sym___extension__] = ACTIONS(2553),
    [anon_sym_typedef] = ACTIONS(2553),
    [anon_sym_virtual] = ACTIONS(2553),
    [anon_sym_extern] = ACTIONS(2553),
    [anon_sym___attribute__] = ACTIONS(2553),
    [anon_sym___attribute] = ACTIONS(2553),
    [anon_sym_COLON_COLON] = ACTIONS(2555),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2555),
    [anon_sym___declspec] = ACTIONS(2553),
    [anon_sym___based] = ACTIONS(2553),
    [anon_sym___cdecl] = ACTIONS(2553),
    [anon_sym___clrcall] = ACTIONS(2553),
    [anon_sym___stdcall] = ACTIONS(2553),
    [anon_sym___fastcall] = ACTIONS(2553),
    [anon_sym___thiscall] = ACTIONS(2553),
    [anon_sym___vectorcall] = ACTIONS(2553),
    [anon_sym_LBRACE] = ACTIONS(2555),
    [anon_sym_signed] = ACTIONS(2553),
    [anon_sym_unsigned] = ACTIONS(2553),
    [anon_sym_long] = ACTIONS(2553),
    [anon_sym_short] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(2553),
    [anon_sym_static] = ACTIONS(2553),
    [anon_sym_register] = ACTIONS(2553),
    [anon_sym_inline] = ACTIONS(2553),
    [anon_sym___inline] = ACTIONS(2553),
    [anon_sym___inline__] = ACTIONS(2553),
    [anon_sym___forceinline] = ACTIONS(2553),
    [anon_sym_thread_local] = ACTIONS(2553),
    [anon_sym___thread] = ACTIONS(2553),
    [anon_sym_const] = ACTIONS(2553),
    [anon_sym_constexpr] = ACTIONS(2553),
    [anon_sym_volatile] = ACTIONS(2553),
    [anon_sym_restrict] = ACTIONS(2553),
    [anon_sym___restrict__] = ACTIONS(2553),
    [anon_sym__Atomic] = ACTIONS(2553),
    [anon_sym__Noreturn] = ACTIONS(2553),
    [anon_sym_noreturn] = ACTIONS(2553),
    [anon_sym__Nonnull] = ACTIONS(2553),
    [anon_sym_mutable] = ACTIONS(2553),
    [anon_sym_constinit] = ACTIONS(2553),
    [anon_sym_consteval] = ACTIONS(2553),
    [anon_sym_alignas] = ACTIONS(2553),
    [anon_sym__Alignas] = ACTIONS(2553),
    [sym_primitive_type] = ACTIONS(2553),
    [anon_sym_enum] = ACTIONS(2553),
    [anon_sym_class] = ACTIONS(2553),
    [anon_sym_struct] = ACTIONS(2553),
    [anon_sym_union] = ACTIONS(2553),
    [anon_sym_if] = ACTIONS(2553),
    [anon_sym_switch] = ACTIONS(2553),
    [anon_sym_case] = ACTIONS(2553),
    [anon_sym_default] = ACTIONS(2553),
    [anon_sym_while] = ACTIONS(2553),
    [anon_sym_do] = ACTIONS(2553),
    [anon_sym_for] = ACTIONS(2553),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_break] = ACTIONS(2553),
    [anon_sym_continue] = ACTIONS(2553),
    [anon_sym_goto] = ACTIONS(2553),
    [anon_sym___try] = ACTIONS(2553),
    [anon_sym___leave] = ACTIONS(2553),
    [anon_sym_not] = ACTIONS(2553),
    [anon_sym_compl] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(2555),
    [anon_sym_PLUS_PLUS] = ACTIONS(2555),
    [anon_sym_sizeof] = ACTIONS(2553),
    [anon_sym___alignof__] = ACTIONS(2553),
    [anon_sym___alignof] = ACTIONS(2553),
    [anon_sym__alignof] = ACTIONS(2553),
    [anon_sym_alignof] = ACTIONS(2553),
    [anon_sym__Alignof] = ACTIONS(2553),
    [anon_sym_offsetof] = ACTIONS(2553),
    [anon_sym__Generic] = ACTIONS(2553),
    [anon_sym_asm] = ACTIONS(2553),
    [anon_sym___asm__] = ACTIONS(2553),
    [anon_sym___asm] = ACTIONS(2553),
    [sym_number_literal] = ACTIONS(2555),
    [anon_sym_L_SQUOTE] = ACTIONS(2555),
    [anon_sym_u_SQUOTE] = ACTIONS(2555),
    [anon_sym_U_SQUOTE] = ACTIONS(2555),
    [anon_sym_u8_SQUOTE] = ACTIONS(2555),
    [anon_sym_SQUOTE] = ACTIONS(2555),
    [anon_sym_L_DQUOTE] = ACTIONS(2555),
    [anon_sym_u_DQUOTE] = ACTIONS(2555),
    [anon_sym_U_DQUOTE] = ACTIONS(2555),
    [anon_sym_u8_DQUOTE] = ACTIONS(2555),
    [anon_sym_DQUOTE] = ACTIONS(2555),
    [sym_true] = ACTIONS(2553),
    [sym_false] = ACTIONS(2553),
    [anon_sym_NULL] = ACTIONS(2553),
    [anon_sym_nullptr] = ACTIONS(2553),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2553),
    [anon_sym_decltype] = ACTIONS(2553),
    [anon_sym_explicit] = ACTIONS(2553),
    [anon_sym_typename] = ACTIONS(2553),
    [anon_sym_template] = ACTIONS(2553),
    [anon_sym_operator] = ACTIONS(2553),
    [anon_sym_try] = ACTIONS(2553),
    [anon_sym_delete] = ACTIONS(2553),
    [anon_sym_throw] = ACTIONS(2553),
    [anon_sym_namespace] = ACTIONS(2553),
    [anon_sym_using] = ACTIONS(2553),
    [anon_sym_static_assert] = ACTIONS(2553),
    [anon_sym_concept] = ACTIONS(2553),
    [anon_sym_co_return] = ACTIONS(2553),
    [anon_sym_co_yield] = ACTIONS(2553),
    [anon_sym_catch] = ACTIONS(2494),
    [anon_sym_R_DQUOTE] = ACTIONS(2555),
    [anon_sym_LR_DQUOTE] = ACTIONS(2555),
    [anon_sym_uR_DQUOTE] = ACTIONS(2555),
    [anon_sym_UR_DQUOTE] = ACTIONS(2555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2555),
    [anon_sym_co_await] = ACTIONS(2553),
    [anon_sym_new] = ACTIONS(2553),
    [anon_sym_requires] = ACTIONS(2553),
    [sym_this] = ACTIONS(2553),
  },
  [224] = {
    [sym_expression] = STATE(4247),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(2514),
    [anon_sym_LPAREN2] = ACTIONS(2517),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(2520),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(2523),
    [anon_sym_AMP_AMP] = ACTIONS(2526),
    [anon_sym_AMP] = ACTIONS(2528),
    [anon_sym___extension__] = ACTIONS(2531),
    [anon_sym_typedef] = ACTIONS(2557),
    [anon_sym_virtual] = ACTIONS(2536),
    [anon_sym_extern] = ACTIONS(2536),
    [anon_sym___attribute__] = ACTIONS(2536),
    [anon_sym___attribute] = ACTIONS(2536),
    [anon_sym_COLON_COLON] = ACTIONS(2538),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2526),
    [anon_sym___declspec] = ACTIONS(2536),
    [anon_sym___based] = ACTIONS(2536),
    [anon_sym_signed] = ACTIONS(2536),
    [anon_sym_unsigned] = ACTIONS(2536),
    [anon_sym_long] = ACTIONS(2536),
    [anon_sym_short] = ACTIONS(2536),
    [anon_sym_LBRACK] = ACTIONS(2541),
    [anon_sym_static] = ACTIONS(2536),
    [anon_sym_register] = ACTIONS(2536),
    [anon_sym_inline] = ACTIONS(2536),
    [anon_sym___inline] = ACTIONS(2536),
    [anon_sym___inline__] = ACTIONS(2536),
    [anon_sym___forceinline] = ACTIONS(2536),
    [anon_sym_thread_local] = ACTIONS(2536),
    [anon_sym___thread] = ACTIONS(2536),
    [anon_sym_const] = ACTIONS(2536),
    [anon_sym_constexpr] = ACTIONS(2536),
    [anon_sym_volatile] = ACTIONS(2536),
    [anon_sym_restrict] = ACTIONS(2536),
    [anon_sym___restrict__] = ACTIONS(2536),
    [anon_sym__Atomic] = ACTIONS(2536),
    [anon_sym__Noreturn] = ACTIONS(2536),
    [anon_sym_noreturn] = ACTIONS(2536),
    [anon_sym__Nonnull] = ACTIONS(2536),
    [anon_sym_mutable] = ACTIONS(2536),
    [anon_sym_constinit] = ACTIONS(2536),
    [anon_sym_consteval] = ACTIONS(2536),
    [anon_sym_alignas] = ACTIONS(2536),
    [anon_sym__Alignas] = ACTIONS(2536),
    [sym_primitive_type] = ACTIONS(2544),
    [anon_sym_enum] = ACTIONS(2536),
    [anon_sym_class] = ACTIONS(2536),
    [anon_sym_struct] = ACTIONS(2536),
    [anon_sym_union] = ACTIONS(2536),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2536),
    [anon_sym_decltype] = ACTIONS(2547),
    [anon_sym_explicit] = ACTIONS(2536),
    [anon_sym_typename] = ACTIONS(2536),
    [anon_sym_template] = ACTIONS(2550),
    [anon_sym_operator] = ACTIONS(2536),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [225] = {
    [sym_expression] = STATE(4247),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(2514),
    [anon_sym_LPAREN2] = ACTIONS(2517),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(2520),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(2523),
    [anon_sym_AMP_AMP] = ACTIONS(2526),
    [anon_sym_AMP] = ACTIONS(2528),
    [anon_sym___extension__] = ACTIONS(2531),
    [anon_sym_typedef] = ACTIONS(2559),
    [anon_sym_virtual] = ACTIONS(2536),
    [anon_sym_extern] = ACTIONS(2536),
    [anon_sym___attribute__] = ACTIONS(2536),
    [anon_sym___attribute] = ACTIONS(2536),
    [anon_sym_COLON_COLON] = ACTIONS(2538),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2526),
    [anon_sym___declspec] = ACTIONS(2536),
    [anon_sym___based] = ACTIONS(2536),
    [anon_sym_signed] = ACTIONS(2536),
    [anon_sym_unsigned] = ACTIONS(2536),
    [anon_sym_long] = ACTIONS(2536),
    [anon_sym_short] = ACTIONS(2536),
    [anon_sym_LBRACK] = ACTIONS(2541),
    [anon_sym_static] = ACTIONS(2536),
    [anon_sym_register] = ACTIONS(2536),
    [anon_sym_inline] = ACTIONS(2536),
    [anon_sym___inline] = ACTIONS(2536),
    [anon_sym___inline__] = ACTIONS(2536),
    [anon_sym___forceinline] = ACTIONS(2536),
    [anon_sym_thread_local] = ACTIONS(2536),
    [anon_sym___thread] = ACTIONS(2536),
    [anon_sym_const] = ACTIONS(2536),
    [anon_sym_constexpr] = ACTIONS(2536),
    [anon_sym_volatile] = ACTIONS(2536),
    [anon_sym_restrict] = ACTIONS(2536),
    [anon_sym___restrict__] = ACTIONS(2536),
    [anon_sym__Atomic] = ACTIONS(2536),
    [anon_sym__Noreturn] = ACTIONS(2536),
    [anon_sym_noreturn] = ACTIONS(2536),
    [anon_sym__Nonnull] = ACTIONS(2536),
    [anon_sym_mutable] = ACTIONS(2536),
    [anon_sym_constinit] = ACTIONS(2536),
    [anon_sym_consteval] = ACTIONS(2536),
    [anon_sym_alignas] = ACTIONS(2536),
    [anon_sym__Alignas] = ACTIONS(2536),
    [sym_primitive_type] = ACTIONS(2544),
    [anon_sym_enum] = ACTIONS(2536),
    [anon_sym_class] = ACTIONS(2536),
    [anon_sym_struct] = ACTIONS(2536),
    [anon_sym_union] = ACTIONS(2536),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2536),
    [anon_sym_decltype] = ACTIONS(2547),
    [anon_sym_explicit] = ACTIONS(2536),
    [anon_sym_typename] = ACTIONS(2536),
    [anon_sym_template] = ACTIONS(2550),
    [anon_sym_operator] = ACTIONS(2536),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [226] = {
    [sym_expression] = STATE(4247),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(2514),
    [anon_sym_LPAREN2] = ACTIONS(2517),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(2520),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(2523),
    [anon_sym_AMP_AMP] = ACTIONS(2526),
    [anon_sym_AMP] = ACTIONS(2528),
    [anon_sym___extension__] = ACTIONS(2531),
    [anon_sym_typedef] = ACTIONS(2561),
    [anon_sym_virtual] = ACTIONS(2536),
    [anon_sym_extern] = ACTIONS(2536),
    [anon_sym___attribute__] = ACTIONS(2536),
    [anon_sym___attribute] = ACTIONS(2536),
    [anon_sym_COLON_COLON] = ACTIONS(2538),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2526),
    [anon_sym___declspec] = ACTIONS(2536),
    [anon_sym___based] = ACTIONS(2536),
    [anon_sym_signed] = ACTIONS(2536),
    [anon_sym_unsigned] = ACTIONS(2536),
    [anon_sym_long] = ACTIONS(2536),
    [anon_sym_short] = ACTIONS(2536),
    [anon_sym_LBRACK] = ACTIONS(2541),
    [anon_sym_static] = ACTIONS(2536),
    [anon_sym_register] = ACTIONS(2536),
    [anon_sym_inline] = ACTIONS(2536),
    [anon_sym___inline] = ACTIONS(2536),
    [anon_sym___inline__] = ACTIONS(2536),
    [anon_sym___forceinline] = ACTIONS(2536),
    [anon_sym_thread_local] = ACTIONS(2536),
    [anon_sym___thread] = ACTIONS(2536),
    [anon_sym_const] = ACTIONS(2536),
    [anon_sym_constexpr] = ACTIONS(2536),
    [anon_sym_volatile] = ACTIONS(2536),
    [anon_sym_restrict] = ACTIONS(2536),
    [anon_sym___restrict__] = ACTIONS(2536),
    [anon_sym__Atomic] = ACTIONS(2536),
    [anon_sym__Noreturn] = ACTIONS(2536),
    [anon_sym_noreturn] = ACTIONS(2536),
    [anon_sym__Nonnull] = ACTIONS(2536),
    [anon_sym_mutable] = ACTIONS(2536),
    [anon_sym_constinit] = ACTIONS(2536),
    [anon_sym_consteval] = ACTIONS(2536),
    [anon_sym_alignas] = ACTIONS(2536),
    [anon_sym__Alignas] = ACTIONS(2536),
    [sym_primitive_type] = ACTIONS(2544),
    [anon_sym_enum] = ACTIONS(2536),
    [anon_sym_class] = ACTIONS(2536),
    [anon_sym_struct] = ACTIONS(2536),
    [anon_sym_union] = ACTIONS(2536),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2536),
    [anon_sym_decltype] = ACTIONS(2547),
    [anon_sym_explicit] = ACTIONS(2536),
    [anon_sym_typename] = ACTIONS(2536),
    [anon_sym_template] = ACTIONS(2550),
    [anon_sym_operator] = ACTIONS(2536),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [227] = {
    [sym_identifier] = ACTIONS(2563),
    [aux_sym_preproc_include_token1] = ACTIONS(2563),
    [aux_sym_preproc_def_token1] = ACTIONS(2563),
    [aux_sym_preproc_if_token1] = ACTIONS(2563),
    [aux_sym_preproc_if_token2] = ACTIONS(2563),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2563),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2563),
    [aux_sym_preproc_else_token1] = ACTIONS(2563),
    [aux_sym_preproc_elif_token1] = ACTIONS(2563),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2563),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2563),
    [sym_preproc_directive] = ACTIONS(2563),
    [anon_sym_LPAREN2] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2565),
    [anon_sym_TILDE] = ACTIONS(2565),
    [anon_sym_DASH] = ACTIONS(2563),
    [anon_sym_PLUS] = ACTIONS(2563),
    [anon_sym_STAR] = ACTIONS(2565),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_AMP] = ACTIONS(2563),
    [anon_sym_SEMI] = ACTIONS(2565),
    [anon_sym___extension__] = ACTIONS(2563),
    [anon_sym_typedef] = ACTIONS(2563),
    [anon_sym_virtual] = ACTIONS(2563),
    [anon_sym_extern] = ACTIONS(2563),
    [anon_sym___attribute__] = ACTIONS(2563),
    [anon_sym___attribute] = ACTIONS(2563),
    [anon_sym_COLON_COLON] = ACTIONS(2565),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2565),
    [anon_sym___declspec] = ACTIONS(2563),
    [anon_sym___based] = ACTIONS(2563),
    [anon_sym___cdecl] = ACTIONS(2563),
    [anon_sym___clrcall] = ACTIONS(2563),
    [anon_sym___stdcall] = ACTIONS(2563),
    [anon_sym___fastcall] = ACTIONS(2563),
    [anon_sym___thiscall] = ACTIONS(2563),
    [anon_sym___vectorcall] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(2565),
    [anon_sym_signed] = ACTIONS(2563),
    [anon_sym_unsigned] = ACTIONS(2563),
    [anon_sym_long] = ACTIONS(2563),
    [anon_sym_short] = ACTIONS(2563),
    [anon_sym_LBRACK] = ACTIONS(2563),
    [anon_sym_static] = ACTIONS(2563),
    [anon_sym_register] = ACTIONS(2563),
    [anon_sym_inline] = ACTIONS(2563),
    [anon_sym___inline] = ACTIONS(2563),
    [anon_sym___inline__] = ACTIONS(2563),
    [anon_sym___forceinline] = ACTIONS(2563),
    [anon_sym_thread_local] = ACTIONS(2563),
    [anon_sym___thread] = ACTIONS(2563),
    [anon_sym_const] = ACTIONS(2563),
    [anon_sym_constexpr] = ACTIONS(2563),
    [anon_sym_volatile] = ACTIONS(2563),
    [anon_sym_restrict] = ACTIONS(2563),
    [anon_sym___restrict__] = ACTIONS(2563),
    [anon_sym__Atomic] = ACTIONS(2563),
    [anon_sym__Noreturn] = ACTIONS(2563),
    [anon_sym_noreturn] = ACTIONS(2563),
    [anon_sym__Nonnull] = ACTIONS(2563),
    [anon_sym_mutable] = ACTIONS(2563),
    [anon_sym_constinit] = ACTIONS(2563),
    [anon_sym_consteval] = ACTIONS(2563),
    [anon_sym_alignas] = ACTIONS(2563),
    [anon_sym__Alignas] = ACTIONS(2563),
    [sym_primitive_type] = ACTIONS(2563),
    [anon_sym_enum] = ACTIONS(2563),
    [anon_sym_class] = ACTIONS(2563),
    [anon_sym_struct] = ACTIONS(2563),
    [anon_sym_union] = ACTIONS(2563),
    [anon_sym_if] = ACTIONS(2563),
    [anon_sym_else] = ACTIONS(2563),
    [anon_sym_switch] = ACTIONS(2563),
    [anon_sym_case] = ACTIONS(2563),
    [anon_sym_default] = ACTIONS(2563),
    [anon_sym_while] = ACTIONS(2563),
    [anon_sym_do] = ACTIONS(2563),
    [anon_sym_for] = ACTIONS(2563),
    [anon_sym_return] = ACTIONS(2563),
    [anon_sym_break] = ACTIONS(2563),
    [anon_sym_continue] = ACTIONS(2563),
    [anon_sym_goto] = ACTIONS(2563),
    [anon_sym___try] = ACTIONS(2563),
    [anon_sym___leave] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2563),
    [anon_sym_compl] = ACTIONS(2563),
    [anon_sym_DASH_DASH] = ACTIONS(2565),
    [anon_sym_PLUS_PLUS] = ACTIONS(2565),
    [anon_sym_sizeof] = ACTIONS(2563),
    [anon_sym___alignof__] = ACTIONS(2563),
    [anon_sym___alignof] = ACTIONS(2563),
    [anon_sym__alignof] = ACTIONS(2563),
    [anon_sym_alignof] = ACTIONS(2563),
    [anon_sym__Alignof] = ACTIONS(2563),
    [anon_sym_offsetof] = ACTIONS(2563),
    [anon_sym__Generic] = ACTIONS(2563),
    [anon_sym_asm] = ACTIONS(2563),
    [anon_sym___asm__] = ACTIONS(2563),
    [anon_sym___asm] = ACTIONS(2563),
    [sym_number_literal] = ACTIONS(2565),
    [anon_sym_L_SQUOTE] = ACTIONS(2565),
    [anon_sym_u_SQUOTE] = ACTIONS(2565),
    [anon_sym_U_SQUOTE] = ACTIONS(2565),
    [anon_sym_u8_SQUOTE] = ACTIONS(2565),
    [anon_sym_SQUOTE] = ACTIONS(2565),
    [anon_sym_L_DQUOTE] = ACTIONS(2565),
    [anon_sym_u_DQUOTE] = ACTIONS(2565),
    [anon_sym_U_DQUOTE] = ACTIONS(2565),
    [anon_sym_u8_DQUOTE] = ACTIONS(2565),
    [anon_sym_DQUOTE] = ACTIONS(2565),
    [sym_true] = ACTIONS(2563),
    [sym_false] = ACTIONS(2563),
    [anon_sym_NULL] = ACTIONS(2563),
    [anon_sym_nullptr] = ACTIONS(2563),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2563),
    [anon_sym_decltype] = ACTIONS(2563),
    [anon_sym_explicit] = ACTIONS(2563),
    [anon_sym_typename] = ACTIONS(2563),
    [anon_sym_template] = ACTIONS(2563),
    [anon_sym_operator] = ACTIONS(2563),
    [anon_sym_try] = ACTIONS(2563),
    [anon_sym_delete] = ACTIONS(2563),
    [anon_sym_throw] = ACTIONS(2563),
    [anon_sym_namespace] = ACTIONS(2563),
    [anon_sym_using] = ACTIONS(2563),
    [anon_sym_static_assert] = ACTIONS(2563),
    [anon_sym_concept] = ACTIONS(2563),
    [anon_sym_co_return] = ACTIONS(2563),
    [anon_sym_co_yield] = ACTIONS(2563),
    [anon_sym_catch] = ACTIONS(2563),
    [anon_sym_R_DQUOTE] = ACTIONS(2565),
    [anon_sym_LR_DQUOTE] = ACTIONS(2565),
    [anon_sym_uR_DQUOTE] = ACTIONS(2565),
    [anon_sym_UR_DQUOTE] = ACTIONS(2565),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2565),
    [anon_sym_co_await] = ACTIONS(2563),
    [anon_sym_new] = ACTIONS(2563),
    [anon_sym_requires] = ACTIONS(2563),
    [sym_this] = ACTIONS(2563),
  },
  [228] = {
    [sym_identifier] = ACTIONS(1909),
    [aux_sym_preproc_include_token1] = ACTIONS(1909),
    [aux_sym_preproc_def_token1] = ACTIONS(1909),
    [aux_sym_preproc_if_token1] = ACTIONS(1909),
    [aux_sym_preproc_if_token2] = ACTIONS(1909),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1909),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1909),
    [aux_sym_preproc_else_token1] = ACTIONS(1909),
    [aux_sym_preproc_elif_token1] = ACTIONS(1909),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1909),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1909),
    [sym_preproc_directive] = ACTIONS(1909),
    [anon_sym_LPAREN2] = ACTIONS(1907),
    [anon_sym_BANG] = ACTIONS(1907),
    [anon_sym_TILDE] = ACTIONS(1907),
    [anon_sym_DASH] = ACTIONS(1909),
    [anon_sym_PLUS] = ACTIONS(1909),
    [anon_sym_STAR] = ACTIONS(1907),
    [anon_sym_AMP_AMP] = ACTIONS(1907),
    [anon_sym_AMP] = ACTIONS(1909),
    [anon_sym_SEMI] = ACTIONS(1907),
    [anon_sym___extension__] = ACTIONS(1909),
    [anon_sym_typedef] = ACTIONS(1909),
    [anon_sym_virtual] = ACTIONS(1909),
    [anon_sym_extern] = ACTIONS(1909),
    [anon_sym___attribute__] = ACTIONS(1909),
    [anon_sym___attribute] = ACTIONS(1909),
    [anon_sym_COLON_COLON] = ACTIONS(1907),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1907),
    [anon_sym___declspec] = ACTIONS(1909),
    [anon_sym___based] = ACTIONS(1909),
    [anon_sym___cdecl] = ACTIONS(1909),
    [anon_sym___clrcall] = ACTIONS(1909),
    [anon_sym___stdcall] = ACTIONS(1909),
    [anon_sym___fastcall] = ACTIONS(1909),
    [anon_sym___thiscall] = ACTIONS(1909),
    [anon_sym___vectorcall] = ACTIONS(1909),
    [anon_sym_LBRACE] = ACTIONS(1907),
    [anon_sym_signed] = ACTIONS(1909),
    [anon_sym_unsigned] = ACTIONS(1909),
    [anon_sym_long] = ACTIONS(1909),
    [anon_sym_short] = ACTIONS(1909),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_static] = ACTIONS(1909),
    [anon_sym_register] = ACTIONS(1909),
    [anon_sym_inline] = ACTIONS(1909),
    [anon_sym___inline] = ACTIONS(1909),
    [anon_sym___inline__] = ACTIONS(1909),
    [anon_sym___forceinline] = ACTIONS(1909),
    [anon_sym_thread_local] = ACTIONS(1909),
    [anon_sym___thread] = ACTIONS(1909),
    [anon_sym_const] = ACTIONS(1909),
    [anon_sym_constexpr] = ACTIONS(1909),
    [anon_sym_volatile] = ACTIONS(1909),
    [anon_sym_restrict] = ACTIONS(1909),
    [anon_sym___restrict__] = ACTIONS(1909),
    [anon_sym__Atomic] = ACTIONS(1909),
    [anon_sym__Noreturn] = ACTIONS(1909),
    [anon_sym_noreturn] = ACTIONS(1909),
    [anon_sym__Nonnull] = ACTIONS(1909),
    [anon_sym_mutable] = ACTIONS(1909),
    [anon_sym_constinit] = ACTIONS(1909),
    [anon_sym_consteval] = ACTIONS(1909),
    [anon_sym_alignas] = ACTIONS(1909),
    [anon_sym__Alignas] = ACTIONS(1909),
    [sym_primitive_type] = ACTIONS(1909),
    [anon_sym_enum] = ACTIONS(1909),
    [anon_sym_class] = ACTIONS(1909),
    [anon_sym_struct] = ACTIONS(1909),
    [anon_sym_union] = ACTIONS(1909),
    [anon_sym_if] = ACTIONS(1909),
    [anon_sym_else] = ACTIONS(1909),
    [anon_sym_switch] = ACTIONS(1909),
    [anon_sym_case] = ACTIONS(1909),
    [anon_sym_default] = ACTIONS(1909),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_do] = ACTIONS(1909),
    [anon_sym_for] = ACTIONS(1909),
    [anon_sym_return] = ACTIONS(1909),
    [anon_sym_break] = ACTIONS(1909),
    [anon_sym_continue] = ACTIONS(1909),
    [anon_sym_goto] = ACTIONS(1909),
    [anon_sym___try] = ACTIONS(1909),
    [anon_sym___leave] = ACTIONS(1909),
    [anon_sym_not] = ACTIONS(1909),
    [anon_sym_compl] = ACTIONS(1909),
    [anon_sym_DASH_DASH] = ACTIONS(1907),
    [anon_sym_PLUS_PLUS] = ACTIONS(1907),
    [anon_sym_sizeof] = ACTIONS(1909),
    [anon_sym___alignof__] = ACTIONS(1909),
    [anon_sym___alignof] = ACTIONS(1909),
    [anon_sym__alignof] = ACTIONS(1909),
    [anon_sym_alignof] = ACTIONS(1909),
    [anon_sym__Alignof] = ACTIONS(1909),
    [anon_sym_offsetof] = ACTIONS(1909),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1909),
    [anon_sym___asm__] = ACTIONS(1909),
    [anon_sym___asm] = ACTIONS(1909),
    [sym_number_literal] = ACTIONS(1907),
    [anon_sym_L_SQUOTE] = ACTIONS(1907),
    [anon_sym_u_SQUOTE] = ACTIONS(1907),
    [anon_sym_U_SQUOTE] = ACTIONS(1907),
    [anon_sym_u8_SQUOTE] = ACTIONS(1907),
    [anon_sym_SQUOTE] = ACTIONS(1907),
    [anon_sym_L_DQUOTE] = ACTIONS(1907),
    [anon_sym_u_DQUOTE] = ACTIONS(1907),
    [anon_sym_U_DQUOTE] = ACTIONS(1907),
    [anon_sym_u8_DQUOTE] = ACTIONS(1907),
    [anon_sym_DQUOTE] = ACTIONS(1907),
    [sym_true] = ACTIONS(1909),
    [sym_false] = ACTIONS(1909),
    [anon_sym_NULL] = ACTIONS(1909),
    [anon_sym_nullptr] = ACTIONS(1909),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1909),
    [anon_sym_decltype] = ACTIONS(1909),
    [anon_sym_explicit] = ACTIONS(1909),
    [anon_sym_typename] = ACTIONS(1909),
    [anon_sym_template] = ACTIONS(1909),
    [anon_sym_operator] = ACTIONS(1909),
    [anon_sym_try] = ACTIONS(1909),
    [anon_sym_delete] = ACTIONS(1909),
    [anon_sym_throw] = ACTIONS(1909),
    [anon_sym_namespace] = ACTIONS(1909),
    [anon_sym_using] = ACTIONS(1909),
    [anon_sym_static_assert] = ACTIONS(1909),
    [anon_sym_concept] = ACTIONS(1909),
    [anon_sym_co_return] = ACTIONS(1909),
    [anon_sym_co_yield] = ACTIONS(1909),
    [anon_sym_catch] = ACTIONS(1909),
    [anon_sym_R_DQUOTE] = ACTIONS(1907),
    [anon_sym_LR_DQUOTE] = ACTIONS(1907),
    [anon_sym_uR_DQUOTE] = ACTIONS(1907),
    [anon_sym_UR_DQUOTE] = ACTIONS(1907),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1907),
    [anon_sym_co_await] = ACTIONS(1909),
    [anon_sym_new] = ACTIONS(1909),
    [anon_sym_requires] = ACTIONS(1909),
    [sym_this] = ACTIONS(1909),
  },
  [229] = {
    [sym_else_clause] = STATE(244),
    [sym_identifier] = ACTIONS(2567),
    [aux_sym_preproc_include_token1] = ACTIONS(2567),
    [aux_sym_preproc_def_token1] = ACTIONS(2567),
    [aux_sym_preproc_if_token1] = ACTIONS(2567),
    [aux_sym_preproc_if_token2] = ACTIONS(2567),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2567),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2567),
    [aux_sym_preproc_else_token1] = ACTIONS(2567),
    [aux_sym_preproc_elif_token1] = ACTIONS(2567),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2567),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2567),
    [sym_preproc_directive] = ACTIONS(2567),
    [anon_sym_LPAREN2] = ACTIONS(2569),
    [anon_sym_BANG] = ACTIONS(2569),
    [anon_sym_TILDE] = ACTIONS(2569),
    [anon_sym_DASH] = ACTIONS(2567),
    [anon_sym_PLUS] = ACTIONS(2567),
    [anon_sym_STAR] = ACTIONS(2569),
    [anon_sym_AMP_AMP] = ACTIONS(2569),
    [anon_sym_AMP] = ACTIONS(2567),
    [anon_sym_SEMI] = ACTIONS(2569),
    [anon_sym___extension__] = ACTIONS(2567),
    [anon_sym_typedef] = ACTIONS(2567),
    [anon_sym_virtual] = ACTIONS(2567),
    [anon_sym_extern] = ACTIONS(2567),
    [anon_sym___attribute__] = ACTIONS(2567),
    [anon_sym___attribute] = ACTIONS(2567),
    [anon_sym_COLON_COLON] = ACTIONS(2569),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2569),
    [anon_sym___declspec] = ACTIONS(2567),
    [anon_sym___based] = ACTIONS(2567),
    [anon_sym___cdecl] = ACTIONS(2567),
    [anon_sym___clrcall] = ACTIONS(2567),
    [anon_sym___stdcall] = ACTIONS(2567),
    [anon_sym___fastcall] = ACTIONS(2567),
    [anon_sym___thiscall] = ACTIONS(2567),
    [anon_sym___vectorcall] = ACTIONS(2567),
    [anon_sym_LBRACE] = ACTIONS(2569),
    [anon_sym_signed] = ACTIONS(2567),
    [anon_sym_unsigned] = ACTIONS(2567),
    [anon_sym_long] = ACTIONS(2567),
    [anon_sym_short] = ACTIONS(2567),
    [anon_sym_LBRACK] = ACTIONS(2567),
    [anon_sym_static] = ACTIONS(2567),
    [anon_sym_register] = ACTIONS(2567),
    [anon_sym_inline] = ACTIONS(2567),
    [anon_sym___inline] = ACTIONS(2567),
    [anon_sym___inline__] = ACTIONS(2567),
    [anon_sym___forceinline] = ACTIONS(2567),
    [anon_sym_thread_local] = ACTIONS(2567),
    [anon_sym___thread] = ACTIONS(2567),
    [anon_sym_const] = ACTIONS(2567),
    [anon_sym_constexpr] = ACTIONS(2567),
    [anon_sym_volatile] = ACTIONS(2567),
    [anon_sym_restrict] = ACTIONS(2567),
    [anon_sym___restrict__] = ACTIONS(2567),
    [anon_sym__Atomic] = ACTIONS(2567),
    [anon_sym__Noreturn] = ACTIONS(2567),
    [anon_sym_noreturn] = ACTIONS(2567),
    [anon_sym__Nonnull] = ACTIONS(2567),
    [anon_sym_mutable] = ACTIONS(2567),
    [anon_sym_constinit] = ACTIONS(2567),
    [anon_sym_consteval] = ACTIONS(2567),
    [anon_sym_alignas] = ACTIONS(2567),
    [anon_sym__Alignas] = ACTIONS(2567),
    [sym_primitive_type] = ACTIONS(2567),
    [anon_sym_enum] = ACTIONS(2567),
    [anon_sym_class] = ACTIONS(2567),
    [anon_sym_struct] = ACTIONS(2567),
    [anon_sym_union] = ACTIONS(2567),
    [anon_sym_if] = ACTIONS(2567),
    [anon_sym_else] = ACTIONS(2571),
    [anon_sym_switch] = ACTIONS(2567),
    [anon_sym_case] = ACTIONS(2567),
    [anon_sym_default] = ACTIONS(2567),
    [anon_sym_while] = ACTIONS(2567),
    [anon_sym_do] = ACTIONS(2567),
    [anon_sym_for] = ACTIONS(2567),
    [anon_sym_return] = ACTIONS(2567),
    [anon_sym_break] = ACTIONS(2567),
    [anon_sym_continue] = ACTIONS(2567),
    [anon_sym_goto] = ACTIONS(2567),
    [anon_sym___try] = ACTIONS(2567),
    [anon_sym___leave] = ACTIONS(2567),
    [anon_sym_not] = ACTIONS(2567),
    [anon_sym_compl] = ACTIONS(2567),
    [anon_sym_DASH_DASH] = ACTIONS(2569),
    [anon_sym_PLUS_PLUS] = ACTIONS(2569),
    [anon_sym_sizeof] = ACTIONS(2567),
    [anon_sym___alignof__] = ACTIONS(2567),
    [anon_sym___alignof] = ACTIONS(2567),
    [anon_sym__alignof] = ACTIONS(2567),
    [anon_sym_alignof] = ACTIONS(2567),
    [anon_sym__Alignof] = ACTIONS(2567),
    [anon_sym_offsetof] = ACTIONS(2567),
    [anon_sym__Generic] = ACTIONS(2567),
    [anon_sym_asm] = ACTIONS(2567),
    [anon_sym___asm__] = ACTIONS(2567),
    [anon_sym___asm] = ACTIONS(2567),
    [sym_number_literal] = ACTIONS(2569),
    [anon_sym_L_SQUOTE] = ACTIONS(2569),
    [anon_sym_u_SQUOTE] = ACTIONS(2569),
    [anon_sym_U_SQUOTE] = ACTIONS(2569),
    [anon_sym_u8_SQUOTE] = ACTIONS(2569),
    [anon_sym_SQUOTE] = ACTIONS(2569),
    [anon_sym_L_DQUOTE] = ACTIONS(2569),
    [anon_sym_u_DQUOTE] = ACTIONS(2569),
    [anon_sym_U_DQUOTE] = ACTIONS(2569),
    [anon_sym_u8_DQUOTE] = ACTIONS(2569),
    [anon_sym_DQUOTE] = ACTIONS(2569),
    [sym_true] = ACTIONS(2567),
    [sym_false] = ACTIONS(2567),
    [anon_sym_NULL] = ACTIONS(2567),
    [anon_sym_nullptr] = ACTIONS(2567),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2567),
    [anon_sym_decltype] = ACTIONS(2567),
    [anon_sym_explicit] = ACTIONS(2567),
    [anon_sym_typename] = ACTIONS(2567),
    [anon_sym_template] = ACTIONS(2567),
    [anon_sym_operator] = ACTIONS(2567),
    [anon_sym_try] = ACTIONS(2567),
    [anon_sym_delete] = ACTIONS(2567),
    [anon_sym_throw] = ACTIONS(2567),
    [anon_sym_namespace] = ACTIONS(2567),
    [anon_sym_using] = ACTIONS(2567),
    [anon_sym_static_assert] = ACTIONS(2567),
    [anon_sym_concept] = ACTIONS(2567),
    [anon_sym_co_return] = ACTIONS(2567),
    [anon_sym_co_yield] = ACTIONS(2567),
    [anon_sym_R_DQUOTE] = ACTIONS(2569),
    [anon_sym_LR_DQUOTE] = ACTIONS(2569),
    [anon_sym_uR_DQUOTE] = ACTIONS(2569),
    [anon_sym_UR_DQUOTE] = ACTIONS(2569),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2569),
    [anon_sym_co_await] = ACTIONS(2567),
    [anon_sym_new] = ACTIONS(2567),
    [anon_sym_requires] = ACTIONS(2567),
    [sym_this] = ACTIONS(2567),
  },
  [230] = {
    [sym_else_clause] = STATE(253),
    [sym_identifier] = ACTIONS(2573),
    [aux_sym_preproc_include_token1] = ACTIONS(2573),
    [aux_sym_preproc_def_token1] = ACTIONS(2573),
    [aux_sym_preproc_if_token1] = ACTIONS(2573),
    [aux_sym_preproc_if_token2] = ACTIONS(2573),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2573),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2573),
    [aux_sym_preproc_else_token1] = ACTIONS(2573),
    [aux_sym_preproc_elif_token1] = ACTIONS(2573),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2573),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2573),
    [sym_preproc_directive] = ACTIONS(2573),
    [anon_sym_LPAREN2] = ACTIONS(2575),
    [anon_sym_BANG] = ACTIONS(2575),
    [anon_sym_TILDE] = ACTIONS(2575),
    [anon_sym_DASH] = ACTIONS(2573),
    [anon_sym_PLUS] = ACTIONS(2573),
    [anon_sym_STAR] = ACTIONS(2575),
    [anon_sym_AMP_AMP] = ACTIONS(2575),
    [anon_sym_AMP] = ACTIONS(2573),
    [anon_sym_SEMI] = ACTIONS(2575),
    [anon_sym___extension__] = ACTIONS(2573),
    [anon_sym_typedef] = ACTIONS(2573),
    [anon_sym_virtual] = ACTIONS(2573),
    [anon_sym_extern] = ACTIONS(2573),
    [anon_sym___attribute__] = ACTIONS(2573),
    [anon_sym___attribute] = ACTIONS(2573),
    [anon_sym_COLON_COLON] = ACTIONS(2575),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2575),
    [anon_sym___declspec] = ACTIONS(2573),
    [anon_sym___based] = ACTIONS(2573),
    [anon_sym___cdecl] = ACTIONS(2573),
    [anon_sym___clrcall] = ACTIONS(2573),
    [anon_sym___stdcall] = ACTIONS(2573),
    [anon_sym___fastcall] = ACTIONS(2573),
    [anon_sym___thiscall] = ACTIONS(2573),
    [anon_sym___vectorcall] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_signed] = ACTIONS(2573),
    [anon_sym_unsigned] = ACTIONS(2573),
    [anon_sym_long] = ACTIONS(2573),
    [anon_sym_short] = ACTIONS(2573),
    [anon_sym_LBRACK] = ACTIONS(2573),
    [anon_sym_static] = ACTIONS(2573),
    [anon_sym_register] = ACTIONS(2573),
    [anon_sym_inline] = ACTIONS(2573),
    [anon_sym___inline] = ACTIONS(2573),
    [anon_sym___inline__] = ACTIONS(2573),
    [anon_sym___forceinline] = ACTIONS(2573),
    [anon_sym_thread_local] = ACTIONS(2573),
    [anon_sym___thread] = ACTIONS(2573),
    [anon_sym_const] = ACTIONS(2573),
    [anon_sym_constexpr] = ACTIONS(2573),
    [anon_sym_volatile] = ACTIONS(2573),
    [anon_sym_restrict] = ACTIONS(2573),
    [anon_sym___restrict__] = ACTIONS(2573),
    [anon_sym__Atomic] = ACTIONS(2573),
    [anon_sym__Noreturn] = ACTIONS(2573),
    [anon_sym_noreturn] = ACTIONS(2573),
    [anon_sym__Nonnull] = ACTIONS(2573),
    [anon_sym_mutable] = ACTIONS(2573),
    [anon_sym_constinit] = ACTIONS(2573),
    [anon_sym_consteval] = ACTIONS(2573),
    [anon_sym_alignas] = ACTIONS(2573),
    [anon_sym__Alignas] = ACTIONS(2573),
    [sym_primitive_type] = ACTIONS(2573),
    [anon_sym_enum] = ACTIONS(2573),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_struct] = ACTIONS(2573),
    [anon_sym_union] = ACTIONS(2573),
    [anon_sym_if] = ACTIONS(2573),
    [anon_sym_else] = ACTIONS(2571),
    [anon_sym_switch] = ACTIONS(2573),
    [anon_sym_case] = ACTIONS(2573),
    [anon_sym_default] = ACTIONS(2573),
    [anon_sym_while] = ACTIONS(2573),
    [anon_sym_do] = ACTIONS(2573),
    [anon_sym_for] = ACTIONS(2573),
    [anon_sym_return] = ACTIONS(2573),
    [anon_sym_break] = ACTIONS(2573),
    [anon_sym_continue] = ACTIONS(2573),
    [anon_sym_goto] = ACTIONS(2573),
    [anon_sym___try] = ACTIONS(2573),
    [anon_sym___leave] = ACTIONS(2573),
    [anon_sym_not] = ACTIONS(2573),
    [anon_sym_compl] = ACTIONS(2573),
    [anon_sym_DASH_DASH] = ACTIONS(2575),
    [anon_sym_PLUS_PLUS] = ACTIONS(2575),
    [anon_sym_sizeof] = ACTIONS(2573),
    [anon_sym___alignof__] = ACTIONS(2573),
    [anon_sym___alignof] = ACTIONS(2573),
    [anon_sym__alignof] = ACTIONS(2573),
    [anon_sym_alignof] = ACTIONS(2573),
    [anon_sym__Alignof] = ACTIONS(2573),
    [anon_sym_offsetof] = ACTIONS(2573),
    [anon_sym__Generic] = ACTIONS(2573),
    [anon_sym_asm] = ACTIONS(2573),
    [anon_sym___asm__] = ACTIONS(2573),
    [anon_sym___asm] = ACTIONS(2573),
    [sym_number_literal] = ACTIONS(2575),
    [anon_sym_L_SQUOTE] = ACTIONS(2575),
    [anon_sym_u_SQUOTE] = ACTIONS(2575),
    [anon_sym_U_SQUOTE] = ACTIONS(2575),
    [anon_sym_u8_SQUOTE] = ACTIONS(2575),
    [anon_sym_SQUOTE] = ACTIONS(2575),
    [anon_sym_L_DQUOTE] = ACTIONS(2575),
    [anon_sym_u_DQUOTE] = ACTIONS(2575),
    [anon_sym_U_DQUOTE] = ACTIONS(2575),
    [anon_sym_u8_DQUOTE] = ACTIONS(2575),
    [anon_sym_DQUOTE] = ACTIONS(2575),
    [sym_true] = ACTIONS(2573),
    [sym_false] = ACTIONS(2573),
    [anon_sym_NULL] = ACTIONS(2573),
    [anon_sym_nullptr] = ACTIONS(2573),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2573),
    [anon_sym_decltype] = ACTIONS(2573),
    [anon_sym_explicit] = ACTIONS(2573),
    [anon_sym_typename] = ACTIONS(2573),
    [anon_sym_template] = ACTIONS(2573),
    [anon_sym_operator] = ACTIONS(2573),
    [anon_sym_try] = ACTIONS(2573),
    [anon_sym_delete] = ACTIONS(2573),
    [anon_sym_throw] = ACTIONS(2573),
    [anon_sym_namespace] = ACTIONS(2573),
    [anon_sym_using] = ACTIONS(2573),
    [anon_sym_static_assert] = ACTIONS(2573),
    [anon_sym_concept] = ACTIONS(2573),
    [anon_sym_co_return] = ACTIONS(2573),
    [anon_sym_co_yield] = ACTIONS(2573),
    [anon_sym_R_DQUOTE] = ACTIONS(2575),
    [anon_sym_LR_DQUOTE] = ACTIONS(2575),
    [anon_sym_uR_DQUOTE] = ACTIONS(2575),
    [anon_sym_UR_DQUOTE] = ACTIONS(2575),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2575),
    [anon_sym_co_await] = ACTIONS(2573),
    [anon_sym_new] = ACTIONS(2573),
    [anon_sym_requires] = ACTIONS(2573),
    [sym_this] = ACTIONS(2573),
  },
  [231] = {
    [sym_expression] = STATE(3549),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_initializer_list] = STATE(3760),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1917),
    [anon_sym_COMMA] = ACTIONS(1917),
    [anon_sym_RPAREN] = ACTIONS(1917),
    [anon_sym_LPAREN2] = ACTIONS(1917),
    [anon_sym_BANG] = ACTIONS(1845),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1915),
    [anon_sym_PLUS] = ACTIONS(1915),
    [anon_sym_STAR] = ACTIONS(1915),
    [anon_sym_SLASH] = ACTIONS(1915),
    [anon_sym_PERCENT] = ACTIONS(1915),
    [anon_sym_PIPE_PIPE] = ACTIONS(1917),
    [anon_sym_AMP_AMP] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(1915),
    [anon_sym_CARET] = ACTIONS(1915),
    [anon_sym_AMP] = ACTIONS(1915),
    [anon_sym_EQ_EQ] = ACTIONS(1917),
    [anon_sym_BANG_EQ] = ACTIONS(1917),
    [anon_sym_GT] = ACTIONS(1915),
    [anon_sym_GT_EQ] = ACTIONS(1917),
    [anon_sym_LT_EQ] = ACTIONS(1915),
    [anon_sym_LT] = ACTIONS(1915),
    [anon_sym_LT_LT] = ACTIONS(1915),
    [anon_sym_GT_GT] = ACTIONS(1915),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACE] = ACTIONS(2581),
    [anon_sym_LBRACK] = ACTIONS(1917),
    [anon_sym_EQ] = ACTIONS(1915),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_QMARK] = ACTIONS(1917),
    [anon_sym_STAR_EQ] = ACTIONS(1917),
    [anon_sym_SLASH_EQ] = ACTIONS(1917),
    [anon_sym_PERCENT_EQ] = ACTIONS(1917),
    [anon_sym_PLUS_EQ] = ACTIONS(1917),
    [anon_sym_DASH_EQ] = ACTIONS(1917),
    [anon_sym_LT_LT_EQ] = ACTIONS(1917),
    [anon_sym_GT_GT_EQ] = ACTIONS(1917),
    [anon_sym_AMP_EQ] = ACTIONS(1917),
    [anon_sym_CARET_EQ] = ACTIONS(1917),
    [anon_sym_PIPE_EQ] = ACTIONS(1917),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_LT_EQ_GT] = ACTIONS(1917),
    [anon_sym_or] = ACTIONS(1915),
    [anon_sym_and] = ACTIONS(1915),
    [anon_sym_bitor] = ACTIONS(1915),
    [anon_sym_xor] = ACTIONS(1915),
    [anon_sym_bitand] = ACTIONS(1915),
    [anon_sym_not_eq] = ACTIONS(1915),
    [anon_sym_DASH_DASH] = ACTIONS(1917),
    [anon_sym_PLUS_PLUS] = ACTIONS(1917),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [anon_sym_DOT] = ACTIONS(1915),
    [anon_sym_DOT_STAR] = ACTIONS(1917),
    [anon_sym_DASH_GT] = ACTIONS(1915),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [anon_sym_DASH_GT_STAR] = ACTIONS(1917),
    [sym_this] = ACTIONS(1883),
  },
  [232] = {
    [sym_identifier] = ACTIONS(1913),
    [aux_sym_preproc_include_token1] = ACTIONS(1913),
    [aux_sym_preproc_def_token1] = ACTIONS(1913),
    [aux_sym_preproc_if_token1] = ACTIONS(1913),
    [aux_sym_preproc_if_token2] = ACTIONS(1913),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1913),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1913),
    [aux_sym_preproc_else_token1] = ACTIONS(1913),
    [aux_sym_preproc_elif_token1] = ACTIONS(1913),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1913),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1913),
    [sym_preproc_directive] = ACTIONS(1913),
    [anon_sym_LPAREN2] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_DASH] = ACTIONS(1913),
    [anon_sym_PLUS] = ACTIONS(1913),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_AMP_AMP] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1913),
    [anon_sym_SEMI] = ACTIONS(1911),
    [anon_sym___extension__] = ACTIONS(1913),
    [anon_sym_typedef] = ACTIONS(1913),
    [anon_sym_virtual] = ACTIONS(1913),
    [anon_sym_extern] = ACTIONS(1913),
    [anon_sym___attribute__] = ACTIONS(1913),
    [anon_sym___attribute] = ACTIONS(1913),
    [anon_sym_COLON_COLON] = ACTIONS(1911),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1911),
    [anon_sym___declspec] = ACTIONS(1913),
    [anon_sym___based] = ACTIONS(1913),
    [anon_sym___cdecl] = ACTIONS(1913),
    [anon_sym___clrcall] = ACTIONS(1913),
    [anon_sym___stdcall] = ACTIONS(1913),
    [anon_sym___fastcall] = ACTIONS(1913),
    [anon_sym___thiscall] = ACTIONS(1913),
    [anon_sym___vectorcall] = ACTIONS(1913),
    [anon_sym_LBRACE] = ACTIONS(1911),
    [anon_sym_signed] = ACTIONS(1913),
    [anon_sym_unsigned] = ACTIONS(1913),
    [anon_sym_long] = ACTIONS(1913),
    [anon_sym_short] = ACTIONS(1913),
    [anon_sym_LBRACK] = ACTIONS(1913),
    [anon_sym_static] = ACTIONS(1913),
    [anon_sym_register] = ACTIONS(1913),
    [anon_sym_inline] = ACTIONS(1913),
    [anon_sym___inline] = ACTIONS(1913),
    [anon_sym___inline__] = ACTIONS(1913),
    [anon_sym___forceinline] = ACTIONS(1913),
    [anon_sym_thread_local] = ACTIONS(1913),
    [anon_sym___thread] = ACTIONS(1913),
    [anon_sym_const] = ACTIONS(1913),
    [anon_sym_constexpr] = ACTIONS(1913),
    [anon_sym_volatile] = ACTIONS(1913),
    [anon_sym_restrict] = ACTIONS(1913),
    [anon_sym___restrict__] = ACTIONS(1913),
    [anon_sym__Atomic] = ACTIONS(1913),
    [anon_sym__Noreturn] = ACTIONS(1913),
    [anon_sym_noreturn] = ACTIONS(1913),
    [anon_sym__Nonnull] = ACTIONS(1913),
    [anon_sym_mutable] = ACTIONS(1913),
    [anon_sym_constinit] = ACTIONS(1913),
    [anon_sym_consteval] = ACTIONS(1913),
    [anon_sym_alignas] = ACTIONS(1913),
    [anon_sym__Alignas] = ACTIONS(1913),
    [sym_primitive_type] = ACTIONS(1913),
    [anon_sym_enum] = ACTIONS(1913),
    [anon_sym_class] = ACTIONS(1913),
    [anon_sym_struct] = ACTIONS(1913),
    [anon_sym_union] = ACTIONS(1913),
    [anon_sym_if] = ACTIONS(1913),
    [anon_sym_else] = ACTIONS(1913),
    [anon_sym_switch] = ACTIONS(1913),
    [anon_sym_case] = ACTIONS(1913),
    [anon_sym_default] = ACTIONS(1913),
    [anon_sym_while] = ACTIONS(1913),
    [anon_sym_do] = ACTIONS(1913),
    [anon_sym_for] = ACTIONS(1913),
    [anon_sym_return] = ACTIONS(1913),
    [anon_sym_break] = ACTIONS(1913),
    [anon_sym_continue] = ACTIONS(1913),
    [anon_sym_goto] = ACTIONS(1913),
    [anon_sym___try] = ACTIONS(1913),
    [anon_sym___leave] = ACTIONS(1913),
    [anon_sym_not] = ACTIONS(1913),
    [anon_sym_compl] = ACTIONS(1913),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_sizeof] = ACTIONS(1913),
    [anon_sym___alignof__] = ACTIONS(1913),
    [anon_sym___alignof] = ACTIONS(1913),
    [anon_sym__alignof] = ACTIONS(1913),
    [anon_sym_alignof] = ACTIONS(1913),
    [anon_sym__Alignof] = ACTIONS(1913),
    [anon_sym_offsetof] = ACTIONS(1913),
    [anon_sym__Generic] = ACTIONS(1913),
    [anon_sym_asm] = ACTIONS(1913),
    [anon_sym___asm__] = ACTIONS(1913),
    [anon_sym___asm] = ACTIONS(1913),
    [sym_number_literal] = ACTIONS(1911),
    [anon_sym_L_SQUOTE] = ACTIONS(1911),
    [anon_sym_u_SQUOTE] = ACTIONS(1911),
    [anon_sym_U_SQUOTE] = ACTIONS(1911),
    [anon_sym_u8_SQUOTE] = ACTIONS(1911),
    [anon_sym_SQUOTE] = ACTIONS(1911),
    [anon_sym_L_DQUOTE] = ACTIONS(1911),
    [anon_sym_u_DQUOTE] = ACTIONS(1911),
    [anon_sym_U_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8_DQUOTE] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(1911),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1913),
    [anon_sym_nullptr] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1913),
    [anon_sym_decltype] = ACTIONS(1913),
    [anon_sym_explicit] = ACTIONS(1913),
    [anon_sym_typename] = ACTIONS(1913),
    [anon_sym_template] = ACTIONS(1913),
    [anon_sym_operator] = ACTIONS(1913),
    [anon_sym_try] = ACTIONS(1913),
    [anon_sym_delete] = ACTIONS(1913),
    [anon_sym_throw] = ACTIONS(1913),
    [anon_sym_namespace] = ACTIONS(1913),
    [anon_sym_using] = ACTIONS(1913),
    [anon_sym_static_assert] = ACTIONS(1913),
    [anon_sym_concept] = ACTIONS(1913),
    [anon_sym_co_return] = ACTIONS(1913),
    [anon_sym_co_yield] = ACTIONS(1913),
    [anon_sym_catch] = ACTIONS(1913),
    [anon_sym_R_DQUOTE] = ACTIONS(1911),
    [anon_sym_LR_DQUOTE] = ACTIONS(1911),
    [anon_sym_uR_DQUOTE] = ACTIONS(1911),
    [anon_sym_UR_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1911),
    [anon_sym_co_await] = ACTIONS(1913),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_requires] = ACTIONS(1913),
    [sym_this] = ACTIONS(1913),
  },
  [233] = {
    [sym_identifier] = ACTIONS(2585),
    [aux_sym_preproc_include_token1] = ACTIONS(2585),
    [aux_sym_preproc_def_token1] = ACTIONS(2585),
    [aux_sym_preproc_if_token1] = ACTIONS(2585),
    [aux_sym_preproc_if_token2] = ACTIONS(2585),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2585),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2585),
    [aux_sym_preproc_else_token1] = ACTIONS(2585),
    [aux_sym_preproc_elif_token1] = ACTIONS(2585),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2585),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2585),
    [sym_preproc_directive] = ACTIONS(2585),
    [anon_sym_LPAREN2] = ACTIONS(2587),
    [anon_sym_BANG] = ACTIONS(2587),
    [anon_sym_TILDE] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2585),
    [anon_sym_PLUS] = ACTIONS(2585),
    [anon_sym_STAR] = ACTIONS(2587),
    [anon_sym_AMP_AMP] = ACTIONS(2587),
    [anon_sym_AMP] = ACTIONS(2585),
    [anon_sym_SEMI] = ACTIONS(2587),
    [anon_sym___extension__] = ACTIONS(2585),
    [anon_sym_typedef] = ACTIONS(2585),
    [anon_sym_virtual] = ACTIONS(2585),
    [anon_sym_extern] = ACTIONS(2585),
    [anon_sym___attribute__] = ACTIONS(2585),
    [anon_sym___attribute] = ACTIONS(2585),
    [anon_sym_COLON_COLON] = ACTIONS(2587),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2587),
    [anon_sym___declspec] = ACTIONS(2585),
    [anon_sym___based] = ACTIONS(2585),
    [anon_sym___cdecl] = ACTIONS(2585),
    [anon_sym___clrcall] = ACTIONS(2585),
    [anon_sym___stdcall] = ACTIONS(2585),
    [anon_sym___fastcall] = ACTIONS(2585),
    [anon_sym___thiscall] = ACTIONS(2585),
    [anon_sym___vectorcall] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2587),
    [anon_sym_signed] = ACTIONS(2585),
    [anon_sym_unsigned] = ACTIONS(2585),
    [anon_sym_long] = ACTIONS(2585),
    [anon_sym_short] = ACTIONS(2585),
    [anon_sym_LBRACK] = ACTIONS(2585),
    [anon_sym_static] = ACTIONS(2585),
    [anon_sym_register] = ACTIONS(2585),
    [anon_sym_inline] = ACTIONS(2585),
    [anon_sym___inline] = ACTIONS(2585),
    [anon_sym___inline__] = ACTIONS(2585),
    [anon_sym___forceinline] = ACTIONS(2585),
    [anon_sym_thread_local] = ACTIONS(2585),
    [anon_sym___thread] = ACTIONS(2585),
    [anon_sym_const] = ACTIONS(2585),
    [anon_sym_constexpr] = ACTIONS(2585),
    [anon_sym_volatile] = ACTIONS(2585),
    [anon_sym_restrict] = ACTIONS(2585),
    [anon_sym___restrict__] = ACTIONS(2585),
    [anon_sym__Atomic] = ACTIONS(2585),
    [anon_sym__Noreturn] = ACTIONS(2585),
    [anon_sym_noreturn] = ACTIONS(2585),
    [anon_sym__Nonnull] = ACTIONS(2585),
    [anon_sym_mutable] = ACTIONS(2585),
    [anon_sym_constinit] = ACTIONS(2585),
    [anon_sym_consteval] = ACTIONS(2585),
    [anon_sym_alignas] = ACTIONS(2585),
    [anon_sym__Alignas] = ACTIONS(2585),
    [sym_primitive_type] = ACTIONS(2585),
    [anon_sym_enum] = ACTIONS(2585),
    [anon_sym_class] = ACTIONS(2585),
    [anon_sym_struct] = ACTIONS(2585),
    [anon_sym_union] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2585),
    [anon_sym_else] = ACTIONS(2585),
    [anon_sym_switch] = ACTIONS(2585),
    [anon_sym_case] = ACTIONS(2585),
    [anon_sym_default] = ACTIONS(2585),
    [anon_sym_while] = ACTIONS(2585),
    [anon_sym_do] = ACTIONS(2585),
    [anon_sym_for] = ACTIONS(2585),
    [anon_sym_return] = ACTIONS(2585),
    [anon_sym_break] = ACTIONS(2585),
    [anon_sym_continue] = ACTIONS(2585),
    [anon_sym_goto] = ACTIONS(2585),
    [anon_sym___try] = ACTIONS(2585),
    [anon_sym___leave] = ACTIONS(2585),
    [anon_sym_not] = ACTIONS(2585),
    [anon_sym_compl] = ACTIONS(2585),
    [anon_sym_DASH_DASH] = ACTIONS(2587),
    [anon_sym_PLUS_PLUS] = ACTIONS(2587),
    [anon_sym_sizeof] = ACTIONS(2585),
    [anon_sym___alignof__] = ACTIONS(2585),
    [anon_sym___alignof] = ACTIONS(2585),
    [anon_sym__alignof] = ACTIONS(2585),
    [anon_sym_alignof] = ACTIONS(2585),
    [anon_sym__Alignof] = ACTIONS(2585),
    [anon_sym_offsetof] = ACTIONS(2585),
    [anon_sym__Generic] = ACTIONS(2585),
    [anon_sym_asm] = ACTIONS(2585),
    [anon_sym___asm__] = ACTIONS(2585),
    [anon_sym___asm] = ACTIONS(2585),
    [sym_number_literal] = ACTIONS(2587),
    [anon_sym_L_SQUOTE] = ACTIONS(2587),
    [anon_sym_u_SQUOTE] = ACTIONS(2587),
    [anon_sym_U_SQUOTE] = ACTIONS(2587),
    [anon_sym_u8_SQUOTE] = ACTIONS(2587),
    [anon_sym_SQUOTE] = ACTIONS(2587),
    [anon_sym_L_DQUOTE] = ACTIONS(2587),
    [anon_sym_u_DQUOTE] = ACTIONS(2587),
    [anon_sym_U_DQUOTE] = ACTIONS(2587),
    [anon_sym_u8_DQUOTE] = ACTIONS(2587),
    [anon_sym_DQUOTE] = ACTIONS(2587),
    [sym_true] = ACTIONS(2585),
    [sym_false] = ACTIONS(2585),
    [anon_sym_NULL] = ACTIONS(2585),
    [anon_sym_nullptr] = ACTIONS(2585),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2585),
    [anon_sym_decltype] = ACTIONS(2585),
    [anon_sym_explicit] = ACTIONS(2585),
    [anon_sym_typename] = ACTIONS(2585),
    [anon_sym_template] = ACTIONS(2585),
    [anon_sym_operator] = ACTIONS(2585),
    [anon_sym_try] = ACTIONS(2585),
    [anon_sym_delete] = ACTIONS(2585),
    [anon_sym_throw] = ACTIONS(2585),
    [anon_sym_namespace] = ACTIONS(2585),
    [anon_sym_using] = ACTIONS(2585),
    [anon_sym_static_assert] = ACTIONS(2585),
    [anon_sym_concept] = ACTIONS(2585),
    [anon_sym_co_return] = ACTIONS(2585),
    [anon_sym_co_yield] = ACTIONS(2585),
    [anon_sym_R_DQUOTE] = ACTIONS(2587),
    [anon_sym_LR_DQUOTE] = ACTIONS(2587),
    [anon_sym_uR_DQUOTE] = ACTIONS(2587),
    [anon_sym_UR_DQUOTE] = ACTIONS(2587),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2587),
    [anon_sym_co_await] = ACTIONS(2585),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_requires] = ACTIONS(2585),
    [sym_this] = ACTIONS(2585),
  },
  [234] = {
    [sym_identifier] = ACTIONS(2589),
    [aux_sym_preproc_include_token1] = ACTIONS(2589),
    [aux_sym_preproc_def_token1] = ACTIONS(2589),
    [aux_sym_preproc_if_token1] = ACTIONS(2589),
    [aux_sym_preproc_if_token2] = ACTIONS(2589),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2589),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2589),
    [aux_sym_preproc_else_token1] = ACTIONS(2589),
    [aux_sym_preproc_elif_token1] = ACTIONS(2589),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2589),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2589),
    [sym_preproc_directive] = ACTIONS(2589),
    [anon_sym_LPAREN2] = ACTIONS(2591),
    [anon_sym_BANG] = ACTIONS(2591),
    [anon_sym_TILDE] = ACTIONS(2591),
    [anon_sym_DASH] = ACTIONS(2589),
    [anon_sym_PLUS] = ACTIONS(2589),
    [anon_sym_STAR] = ACTIONS(2591),
    [anon_sym_AMP_AMP] = ACTIONS(2591),
    [anon_sym_AMP] = ACTIONS(2589),
    [anon_sym_SEMI] = ACTIONS(2591),
    [anon_sym___extension__] = ACTIONS(2589),
    [anon_sym_typedef] = ACTIONS(2589),
    [anon_sym_virtual] = ACTIONS(2589),
    [anon_sym_extern] = ACTIONS(2589),
    [anon_sym___attribute__] = ACTIONS(2589),
    [anon_sym___attribute] = ACTIONS(2589),
    [anon_sym_COLON_COLON] = ACTIONS(2591),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2591),
    [anon_sym___declspec] = ACTIONS(2589),
    [anon_sym___based] = ACTIONS(2589),
    [anon_sym___cdecl] = ACTIONS(2589),
    [anon_sym___clrcall] = ACTIONS(2589),
    [anon_sym___stdcall] = ACTIONS(2589),
    [anon_sym___fastcall] = ACTIONS(2589),
    [anon_sym___thiscall] = ACTIONS(2589),
    [anon_sym___vectorcall] = ACTIONS(2589),
    [anon_sym_LBRACE] = ACTIONS(2591),
    [anon_sym_signed] = ACTIONS(2589),
    [anon_sym_unsigned] = ACTIONS(2589),
    [anon_sym_long] = ACTIONS(2589),
    [anon_sym_short] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(2589),
    [anon_sym_static] = ACTIONS(2589),
    [anon_sym_register] = ACTIONS(2589),
    [anon_sym_inline] = ACTIONS(2589),
    [anon_sym___inline] = ACTIONS(2589),
    [anon_sym___inline__] = ACTIONS(2589),
    [anon_sym___forceinline] = ACTIONS(2589),
    [anon_sym_thread_local] = ACTIONS(2589),
    [anon_sym___thread] = ACTIONS(2589),
    [anon_sym_const] = ACTIONS(2589),
    [anon_sym_constexpr] = ACTIONS(2589),
    [anon_sym_volatile] = ACTIONS(2589),
    [anon_sym_restrict] = ACTIONS(2589),
    [anon_sym___restrict__] = ACTIONS(2589),
    [anon_sym__Atomic] = ACTIONS(2589),
    [anon_sym__Noreturn] = ACTIONS(2589),
    [anon_sym_noreturn] = ACTIONS(2589),
    [anon_sym__Nonnull] = ACTIONS(2589),
    [anon_sym_mutable] = ACTIONS(2589),
    [anon_sym_constinit] = ACTIONS(2589),
    [anon_sym_consteval] = ACTIONS(2589),
    [anon_sym_alignas] = ACTIONS(2589),
    [anon_sym__Alignas] = ACTIONS(2589),
    [sym_primitive_type] = ACTIONS(2589),
    [anon_sym_enum] = ACTIONS(2589),
    [anon_sym_class] = ACTIONS(2589),
    [anon_sym_struct] = ACTIONS(2589),
    [anon_sym_union] = ACTIONS(2589),
    [anon_sym_if] = ACTIONS(2589),
    [anon_sym_else] = ACTIONS(2589),
    [anon_sym_switch] = ACTIONS(2589),
    [anon_sym_case] = ACTIONS(2589),
    [anon_sym_default] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2589),
    [anon_sym_do] = ACTIONS(2589),
    [anon_sym_for] = ACTIONS(2589),
    [anon_sym_return] = ACTIONS(2589),
    [anon_sym_break] = ACTIONS(2589),
    [anon_sym_continue] = ACTIONS(2589),
    [anon_sym_goto] = ACTIONS(2589),
    [anon_sym___try] = ACTIONS(2589),
    [anon_sym___leave] = ACTIONS(2589),
    [anon_sym_not] = ACTIONS(2589),
    [anon_sym_compl] = ACTIONS(2589),
    [anon_sym_DASH_DASH] = ACTIONS(2591),
    [anon_sym_PLUS_PLUS] = ACTIONS(2591),
    [anon_sym_sizeof] = ACTIONS(2589),
    [anon_sym___alignof__] = ACTIONS(2589),
    [anon_sym___alignof] = ACTIONS(2589),
    [anon_sym__alignof] = ACTIONS(2589),
    [anon_sym_alignof] = ACTIONS(2589),
    [anon_sym__Alignof] = ACTIONS(2589),
    [anon_sym_offsetof] = ACTIONS(2589),
    [anon_sym__Generic] = ACTIONS(2589),
    [anon_sym_asm] = ACTIONS(2589),
    [anon_sym___asm__] = ACTIONS(2589),
    [anon_sym___asm] = ACTIONS(2589),
    [sym_number_literal] = ACTIONS(2591),
    [anon_sym_L_SQUOTE] = ACTIONS(2591),
    [anon_sym_u_SQUOTE] = ACTIONS(2591),
    [anon_sym_U_SQUOTE] = ACTIONS(2591),
    [anon_sym_u8_SQUOTE] = ACTIONS(2591),
    [anon_sym_SQUOTE] = ACTIONS(2591),
    [anon_sym_L_DQUOTE] = ACTIONS(2591),
    [anon_sym_u_DQUOTE] = ACTIONS(2591),
    [anon_sym_U_DQUOTE] = ACTIONS(2591),
    [anon_sym_u8_DQUOTE] = ACTIONS(2591),
    [anon_sym_DQUOTE] = ACTIONS(2591),
    [sym_true] = ACTIONS(2589),
    [sym_false] = ACTIONS(2589),
    [anon_sym_NULL] = ACTIONS(2589),
    [anon_sym_nullptr] = ACTIONS(2589),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2589),
    [anon_sym_decltype] = ACTIONS(2589),
    [anon_sym_explicit] = ACTIONS(2589),
    [anon_sym_typename] = ACTIONS(2589),
    [anon_sym_template] = ACTIONS(2589),
    [anon_sym_operator] = ACTIONS(2589),
    [anon_sym_try] = ACTIONS(2589),
    [anon_sym_delete] = ACTIONS(2589),
    [anon_sym_throw] = ACTIONS(2589),
    [anon_sym_namespace] = ACTIONS(2589),
    [anon_sym_using] = ACTIONS(2589),
    [anon_sym_static_assert] = ACTIONS(2589),
    [anon_sym_concept] = ACTIONS(2589),
    [anon_sym_co_return] = ACTIONS(2589),
    [anon_sym_co_yield] = ACTIONS(2589),
    [anon_sym_R_DQUOTE] = ACTIONS(2591),
    [anon_sym_LR_DQUOTE] = ACTIONS(2591),
    [anon_sym_uR_DQUOTE] = ACTIONS(2591),
    [anon_sym_UR_DQUOTE] = ACTIONS(2591),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2591),
    [anon_sym_co_await] = ACTIONS(2589),
    [anon_sym_new] = ACTIONS(2589),
    [anon_sym_requires] = ACTIONS(2589),
    [sym_this] = ACTIONS(2589),
  },
  [235] = {
    [sym_identifier] = ACTIONS(2593),
    [aux_sym_preproc_include_token1] = ACTIONS(2593),
    [aux_sym_preproc_def_token1] = ACTIONS(2593),
    [aux_sym_preproc_if_token1] = ACTIONS(2593),
    [aux_sym_preproc_if_token2] = ACTIONS(2593),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2593),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2593),
    [aux_sym_preproc_else_token1] = ACTIONS(2593),
    [aux_sym_preproc_elif_token1] = ACTIONS(2593),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2593),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2593),
    [sym_preproc_directive] = ACTIONS(2593),
    [anon_sym_LPAREN2] = ACTIONS(2595),
    [anon_sym_BANG] = ACTIONS(2595),
    [anon_sym_TILDE] = ACTIONS(2595),
    [anon_sym_DASH] = ACTIONS(2593),
    [anon_sym_PLUS] = ACTIONS(2593),
    [anon_sym_STAR] = ACTIONS(2595),
    [anon_sym_AMP_AMP] = ACTIONS(2595),
    [anon_sym_AMP] = ACTIONS(2593),
    [anon_sym_SEMI] = ACTIONS(2595),
    [anon_sym___extension__] = ACTIONS(2593),
    [anon_sym_typedef] = ACTIONS(2593),
    [anon_sym_virtual] = ACTIONS(2593),
    [anon_sym_extern] = ACTIONS(2593),
    [anon_sym___attribute__] = ACTIONS(2593),
    [anon_sym___attribute] = ACTIONS(2593),
    [anon_sym_COLON_COLON] = ACTIONS(2595),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2595),
    [anon_sym___declspec] = ACTIONS(2593),
    [anon_sym___based] = ACTIONS(2593),
    [anon_sym___cdecl] = ACTIONS(2593),
    [anon_sym___clrcall] = ACTIONS(2593),
    [anon_sym___stdcall] = ACTIONS(2593),
    [anon_sym___fastcall] = ACTIONS(2593),
    [anon_sym___thiscall] = ACTIONS(2593),
    [anon_sym___vectorcall] = ACTIONS(2593),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_signed] = ACTIONS(2593),
    [anon_sym_unsigned] = ACTIONS(2593),
    [anon_sym_long] = ACTIONS(2593),
    [anon_sym_short] = ACTIONS(2593),
    [anon_sym_LBRACK] = ACTIONS(2593),
    [anon_sym_static] = ACTIONS(2593),
    [anon_sym_register] = ACTIONS(2593),
    [anon_sym_inline] = ACTIONS(2593),
    [anon_sym___inline] = ACTIONS(2593),
    [anon_sym___inline__] = ACTIONS(2593),
    [anon_sym___forceinline] = ACTIONS(2593),
    [anon_sym_thread_local] = ACTIONS(2593),
    [anon_sym___thread] = ACTIONS(2593),
    [anon_sym_const] = ACTIONS(2593),
    [anon_sym_constexpr] = ACTIONS(2593),
    [anon_sym_volatile] = ACTIONS(2593),
    [anon_sym_restrict] = ACTIONS(2593),
    [anon_sym___restrict__] = ACTIONS(2593),
    [anon_sym__Atomic] = ACTIONS(2593),
    [anon_sym__Noreturn] = ACTIONS(2593),
    [anon_sym_noreturn] = ACTIONS(2593),
    [anon_sym__Nonnull] = ACTIONS(2593),
    [anon_sym_mutable] = ACTIONS(2593),
    [anon_sym_constinit] = ACTIONS(2593),
    [anon_sym_consteval] = ACTIONS(2593),
    [anon_sym_alignas] = ACTIONS(2593),
    [anon_sym__Alignas] = ACTIONS(2593),
    [sym_primitive_type] = ACTIONS(2593),
    [anon_sym_enum] = ACTIONS(2593),
    [anon_sym_class] = ACTIONS(2593),
    [anon_sym_struct] = ACTIONS(2593),
    [anon_sym_union] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2593),
    [anon_sym_else] = ACTIONS(2593),
    [anon_sym_switch] = ACTIONS(2593),
    [anon_sym_case] = ACTIONS(2593),
    [anon_sym_default] = ACTIONS(2593),
    [anon_sym_while] = ACTIONS(2593),
    [anon_sym_do] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2593),
    [anon_sym_return] = ACTIONS(2593),
    [anon_sym_break] = ACTIONS(2593),
    [anon_sym_continue] = ACTIONS(2593),
    [anon_sym_goto] = ACTIONS(2593),
    [anon_sym___try] = ACTIONS(2593),
    [anon_sym___leave] = ACTIONS(2593),
    [anon_sym_not] = ACTIONS(2593),
    [anon_sym_compl] = ACTIONS(2593),
    [anon_sym_DASH_DASH] = ACTIONS(2595),
    [anon_sym_PLUS_PLUS] = ACTIONS(2595),
    [anon_sym_sizeof] = ACTIONS(2593),
    [anon_sym___alignof__] = ACTIONS(2593),
    [anon_sym___alignof] = ACTIONS(2593),
    [anon_sym__alignof] = ACTIONS(2593),
    [anon_sym_alignof] = ACTIONS(2593),
    [anon_sym__Alignof] = ACTIONS(2593),
    [anon_sym_offsetof] = ACTIONS(2593),
    [anon_sym__Generic] = ACTIONS(2593),
    [anon_sym_asm] = ACTIONS(2593),
    [anon_sym___asm__] = ACTIONS(2593),
    [anon_sym___asm] = ACTIONS(2593),
    [sym_number_literal] = ACTIONS(2595),
    [anon_sym_L_SQUOTE] = ACTIONS(2595),
    [anon_sym_u_SQUOTE] = ACTIONS(2595),
    [anon_sym_U_SQUOTE] = ACTIONS(2595),
    [anon_sym_u8_SQUOTE] = ACTIONS(2595),
    [anon_sym_SQUOTE] = ACTIONS(2595),
    [anon_sym_L_DQUOTE] = ACTIONS(2595),
    [anon_sym_u_DQUOTE] = ACTIONS(2595),
    [anon_sym_U_DQUOTE] = ACTIONS(2595),
    [anon_sym_u8_DQUOTE] = ACTIONS(2595),
    [anon_sym_DQUOTE] = ACTIONS(2595),
    [sym_true] = ACTIONS(2593),
    [sym_false] = ACTIONS(2593),
    [anon_sym_NULL] = ACTIONS(2593),
    [anon_sym_nullptr] = ACTIONS(2593),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2593),
    [anon_sym_decltype] = ACTIONS(2593),
    [anon_sym_explicit] = ACTIONS(2593),
    [anon_sym_typename] = ACTIONS(2593),
    [anon_sym_template] = ACTIONS(2593),
    [anon_sym_operator] = ACTIONS(2593),
    [anon_sym_try] = ACTIONS(2593),
    [anon_sym_delete] = ACTIONS(2593),
    [anon_sym_throw] = ACTIONS(2593),
    [anon_sym_namespace] = ACTIONS(2593),
    [anon_sym_using] = ACTIONS(2593),
    [anon_sym_static_assert] = ACTIONS(2593),
    [anon_sym_concept] = ACTIONS(2593),
    [anon_sym_co_return] = ACTIONS(2593),
    [anon_sym_co_yield] = ACTIONS(2593),
    [anon_sym_R_DQUOTE] = ACTIONS(2595),
    [anon_sym_LR_DQUOTE] = ACTIONS(2595),
    [anon_sym_uR_DQUOTE] = ACTIONS(2595),
    [anon_sym_UR_DQUOTE] = ACTIONS(2595),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2595),
    [anon_sym_co_await] = ACTIONS(2593),
    [anon_sym_new] = ACTIONS(2593),
    [anon_sym_requires] = ACTIONS(2593),
    [sym_this] = ACTIONS(2593),
  },
  [236] = {
    [sym_identifier] = ACTIONS(2597),
    [aux_sym_preproc_include_token1] = ACTIONS(2597),
    [aux_sym_preproc_def_token1] = ACTIONS(2597),
    [aux_sym_preproc_if_token1] = ACTIONS(2597),
    [aux_sym_preproc_if_token2] = ACTIONS(2597),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2597),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2597),
    [aux_sym_preproc_else_token1] = ACTIONS(2597),
    [aux_sym_preproc_elif_token1] = ACTIONS(2597),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2597),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2597),
    [sym_preproc_directive] = ACTIONS(2597),
    [anon_sym_LPAREN2] = ACTIONS(2599),
    [anon_sym_BANG] = ACTIONS(2599),
    [anon_sym_TILDE] = ACTIONS(2599),
    [anon_sym_DASH] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(2597),
    [anon_sym_STAR] = ACTIONS(2599),
    [anon_sym_AMP_AMP] = ACTIONS(2599),
    [anon_sym_AMP] = ACTIONS(2597),
    [anon_sym_SEMI] = ACTIONS(2599),
    [anon_sym___extension__] = ACTIONS(2597),
    [anon_sym_typedef] = ACTIONS(2597),
    [anon_sym_virtual] = ACTIONS(2597),
    [anon_sym_extern] = ACTIONS(2597),
    [anon_sym___attribute__] = ACTIONS(2597),
    [anon_sym___attribute] = ACTIONS(2597),
    [anon_sym_COLON_COLON] = ACTIONS(2599),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2599),
    [anon_sym___declspec] = ACTIONS(2597),
    [anon_sym___based] = ACTIONS(2597),
    [anon_sym___cdecl] = ACTIONS(2597),
    [anon_sym___clrcall] = ACTIONS(2597),
    [anon_sym___stdcall] = ACTIONS(2597),
    [anon_sym___fastcall] = ACTIONS(2597),
    [anon_sym___thiscall] = ACTIONS(2597),
    [anon_sym___vectorcall] = ACTIONS(2597),
    [anon_sym_LBRACE] = ACTIONS(2599),
    [anon_sym_signed] = ACTIONS(2597),
    [anon_sym_unsigned] = ACTIONS(2597),
    [anon_sym_long] = ACTIONS(2597),
    [anon_sym_short] = ACTIONS(2597),
    [anon_sym_LBRACK] = ACTIONS(2597),
    [anon_sym_static] = ACTIONS(2597),
    [anon_sym_register] = ACTIONS(2597),
    [anon_sym_inline] = ACTIONS(2597),
    [anon_sym___inline] = ACTIONS(2597),
    [anon_sym___inline__] = ACTIONS(2597),
    [anon_sym___forceinline] = ACTIONS(2597),
    [anon_sym_thread_local] = ACTIONS(2597),
    [anon_sym___thread] = ACTIONS(2597),
    [anon_sym_const] = ACTIONS(2597),
    [anon_sym_constexpr] = ACTIONS(2597),
    [anon_sym_volatile] = ACTIONS(2597),
    [anon_sym_restrict] = ACTIONS(2597),
    [anon_sym___restrict__] = ACTIONS(2597),
    [anon_sym__Atomic] = ACTIONS(2597),
    [anon_sym__Noreturn] = ACTIONS(2597),
    [anon_sym_noreturn] = ACTIONS(2597),
    [anon_sym__Nonnull] = ACTIONS(2597),
    [anon_sym_mutable] = ACTIONS(2597),
    [anon_sym_constinit] = ACTIONS(2597),
    [anon_sym_consteval] = ACTIONS(2597),
    [anon_sym_alignas] = ACTIONS(2597),
    [anon_sym__Alignas] = ACTIONS(2597),
    [sym_primitive_type] = ACTIONS(2597),
    [anon_sym_enum] = ACTIONS(2597),
    [anon_sym_class] = ACTIONS(2597),
    [anon_sym_struct] = ACTIONS(2597),
    [anon_sym_union] = ACTIONS(2597),
    [anon_sym_if] = ACTIONS(2597),
    [anon_sym_else] = ACTIONS(2597),
    [anon_sym_switch] = ACTIONS(2597),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_default] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2597),
    [anon_sym_do] = ACTIONS(2597),
    [anon_sym_for] = ACTIONS(2597),
    [anon_sym_return] = ACTIONS(2597),
    [anon_sym_break] = ACTIONS(2597),
    [anon_sym_continue] = ACTIONS(2597),
    [anon_sym_goto] = ACTIONS(2597),
    [anon_sym___try] = ACTIONS(2597),
    [anon_sym___leave] = ACTIONS(2597),
    [anon_sym_not] = ACTIONS(2597),
    [anon_sym_compl] = ACTIONS(2597),
    [anon_sym_DASH_DASH] = ACTIONS(2599),
    [anon_sym_PLUS_PLUS] = ACTIONS(2599),
    [anon_sym_sizeof] = ACTIONS(2597),
    [anon_sym___alignof__] = ACTIONS(2597),
    [anon_sym___alignof] = ACTIONS(2597),
    [anon_sym__alignof] = ACTIONS(2597),
    [anon_sym_alignof] = ACTIONS(2597),
    [anon_sym__Alignof] = ACTIONS(2597),
    [anon_sym_offsetof] = ACTIONS(2597),
    [anon_sym__Generic] = ACTIONS(2597),
    [anon_sym_asm] = ACTIONS(2597),
    [anon_sym___asm__] = ACTIONS(2597),
    [anon_sym___asm] = ACTIONS(2597),
    [sym_number_literal] = ACTIONS(2599),
    [anon_sym_L_SQUOTE] = ACTIONS(2599),
    [anon_sym_u_SQUOTE] = ACTIONS(2599),
    [anon_sym_U_SQUOTE] = ACTIONS(2599),
    [anon_sym_u8_SQUOTE] = ACTIONS(2599),
    [anon_sym_SQUOTE] = ACTIONS(2599),
    [anon_sym_L_DQUOTE] = ACTIONS(2599),
    [anon_sym_u_DQUOTE] = ACTIONS(2599),
    [anon_sym_U_DQUOTE] = ACTIONS(2599),
    [anon_sym_u8_DQUOTE] = ACTIONS(2599),
    [anon_sym_DQUOTE] = ACTIONS(2599),
    [sym_true] = ACTIONS(2597),
    [sym_false] = ACTIONS(2597),
    [anon_sym_NULL] = ACTIONS(2597),
    [anon_sym_nullptr] = ACTIONS(2597),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2597),
    [anon_sym_decltype] = ACTIONS(2597),
    [anon_sym_explicit] = ACTIONS(2597),
    [anon_sym_typename] = ACTIONS(2597),
    [anon_sym_template] = ACTIONS(2597),
    [anon_sym_operator] = ACTIONS(2597),
    [anon_sym_try] = ACTIONS(2597),
    [anon_sym_delete] = ACTIONS(2597),
    [anon_sym_throw] = ACTIONS(2597),
    [anon_sym_namespace] = ACTIONS(2597),
    [anon_sym_using] = ACTIONS(2597),
    [anon_sym_static_assert] = ACTIONS(2597),
    [anon_sym_concept] = ACTIONS(2597),
    [anon_sym_co_return] = ACTIONS(2597),
    [anon_sym_co_yield] = ACTIONS(2597),
    [anon_sym_R_DQUOTE] = ACTIONS(2599),
    [anon_sym_LR_DQUOTE] = ACTIONS(2599),
    [anon_sym_uR_DQUOTE] = ACTIONS(2599),
    [anon_sym_UR_DQUOTE] = ACTIONS(2599),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2599),
    [anon_sym_co_await] = ACTIONS(2597),
    [anon_sym_new] = ACTIONS(2597),
    [anon_sym_requires] = ACTIONS(2597),
    [sym_this] = ACTIONS(2597),
  },
  [237] = {
    [sym_identifier] = ACTIONS(2601),
    [aux_sym_preproc_include_token1] = ACTIONS(2601),
    [aux_sym_preproc_def_token1] = ACTIONS(2601),
    [aux_sym_preproc_if_token1] = ACTIONS(2601),
    [aux_sym_preproc_if_token2] = ACTIONS(2601),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2601),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2601),
    [aux_sym_preproc_else_token1] = ACTIONS(2601),
    [aux_sym_preproc_elif_token1] = ACTIONS(2601),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2601),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2601),
    [sym_preproc_directive] = ACTIONS(2601),
    [anon_sym_LPAREN2] = ACTIONS(2603),
    [anon_sym_BANG] = ACTIONS(2603),
    [anon_sym_TILDE] = ACTIONS(2603),
    [anon_sym_DASH] = ACTIONS(2601),
    [anon_sym_PLUS] = ACTIONS(2601),
    [anon_sym_STAR] = ACTIONS(2603),
    [anon_sym_AMP_AMP] = ACTIONS(2603),
    [anon_sym_AMP] = ACTIONS(2601),
    [anon_sym_SEMI] = ACTIONS(2603),
    [anon_sym___extension__] = ACTIONS(2601),
    [anon_sym_typedef] = ACTIONS(2601),
    [anon_sym_virtual] = ACTIONS(2601),
    [anon_sym_extern] = ACTIONS(2601),
    [anon_sym___attribute__] = ACTIONS(2601),
    [anon_sym___attribute] = ACTIONS(2601),
    [anon_sym_COLON_COLON] = ACTIONS(2603),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2603),
    [anon_sym___declspec] = ACTIONS(2601),
    [anon_sym___based] = ACTIONS(2601),
    [anon_sym___cdecl] = ACTIONS(2601),
    [anon_sym___clrcall] = ACTIONS(2601),
    [anon_sym___stdcall] = ACTIONS(2601),
    [anon_sym___fastcall] = ACTIONS(2601),
    [anon_sym___thiscall] = ACTIONS(2601),
    [anon_sym___vectorcall] = ACTIONS(2601),
    [anon_sym_LBRACE] = ACTIONS(2603),
    [anon_sym_signed] = ACTIONS(2601),
    [anon_sym_unsigned] = ACTIONS(2601),
    [anon_sym_long] = ACTIONS(2601),
    [anon_sym_short] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2601),
    [anon_sym_static] = ACTIONS(2601),
    [anon_sym_register] = ACTIONS(2601),
    [anon_sym_inline] = ACTIONS(2601),
    [anon_sym___inline] = ACTIONS(2601),
    [anon_sym___inline__] = ACTIONS(2601),
    [anon_sym___forceinline] = ACTIONS(2601),
    [anon_sym_thread_local] = ACTIONS(2601),
    [anon_sym___thread] = ACTIONS(2601),
    [anon_sym_const] = ACTIONS(2601),
    [anon_sym_constexpr] = ACTIONS(2601),
    [anon_sym_volatile] = ACTIONS(2601),
    [anon_sym_restrict] = ACTIONS(2601),
    [anon_sym___restrict__] = ACTIONS(2601),
    [anon_sym__Atomic] = ACTIONS(2601),
    [anon_sym__Noreturn] = ACTIONS(2601),
    [anon_sym_noreturn] = ACTIONS(2601),
    [anon_sym__Nonnull] = ACTIONS(2601),
    [anon_sym_mutable] = ACTIONS(2601),
    [anon_sym_constinit] = ACTIONS(2601),
    [anon_sym_consteval] = ACTIONS(2601),
    [anon_sym_alignas] = ACTIONS(2601),
    [anon_sym__Alignas] = ACTIONS(2601),
    [sym_primitive_type] = ACTIONS(2601),
    [anon_sym_enum] = ACTIONS(2601),
    [anon_sym_class] = ACTIONS(2601),
    [anon_sym_struct] = ACTIONS(2601),
    [anon_sym_union] = ACTIONS(2601),
    [anon_sym_if] = ACTIONS(2601),
    [anon_sym_else] = ACTIONS(2601),
    [anon_sym_switch] = ACTIONS(2601),
    [anon_sym_case] = ACTIONS(2601),
    [anon_sym_default] = ACTIONS(2601),
    [anon_sym_while] = ACTIONS(2601),
    [anon_sym_do] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2601),
    [anon_sym_return] = ACTIONS(2601),
    [anon_sym_break] = ACTIONS(2601),
    [anon_sym_continue] = ACTIONS(2601),
    [anon_sym_goto] = ACTIONS(2601),
    [anon_sym___try] = ACTIONS(2601),
    [anon_sym___leave] = ACTIONS(2601),
    [anon_sym_not] = ACTIONS(2601),
    [anon_sym_compl] = ACTIONS(2601),
    [anon_sym_DASH_DASH] = ACTIONS(2603),
    [anon_sym_PLUS_PLUS] = ACTIONS(2603),
    [anon_sym_sizeof] = ACTIONS(2601),
    [anon_sym___alignof__] = ACTIONS(2601),
    [anon_sym___alignof] = ACTIONS(2601),
    [anon_sym__alignof] = ACTIONS(2601),
    [anon_sym_alignof] = ACTIONS(2601),
    [anon_sym__Alignof] = ACTIONS(2601),
    [anon_sym_offsetof] = ACTIONS(2601),
    [anon_sym__Generic] = ACTIONS(2601),
    [anon_sym_asm] = ACTIONS(2601),
    [anon_sym___asm__] = ACTIONS(2601),
    [anon_sym___asm] = ACTIONS(2601),
    [sym_number_literal] = ACTIONS(2603),
    [anon_sym_L_SQUOTE] = ACTIONS(2603),
    [anon_sym_u_SQUOTE] = ACTIONS(2603),
    [anon_sym_U_SQUOTE] = ACTIONS(2603),
    [anon_sym_u8_SQUOTE] = ACTIONS(2603),
    [anon_sym_SQUOTE] = ACTIONS(2603),
    [anon_sym_L_DQUOTE] = ACTIONS(2603),
    [anon_sym_u_DQUOTE] = ACTIONS(2603),
    [anon_sym_U_DQUOTE] = ACTIONS(2603),
    [anon_sym_u8_DQUOTE] = ACTIONS(2603),
    [anon_sym_DQUOTE] = ACTIONS(2603),
    [sym_true] = ACTIONS(2601),
    [sym_false] = ACTIONS(2601),
    [anon_sym_NULL] = ACTIONS(2601),
    [anon_sym_nullptr] = ACTIONS(2601),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2601),
    [anon_sym_decltype] = ACTIONS(2601),
    [anon_sym_explicit] = ACTIONS(2601),
    [anon_sym_typename] = ACTIONS(2601),
    [anon_sym_template] = ACTIONS(2601),
    [anon_sym_operator] = ACTIONS(2601),
    [anon_sym_try] = ACTIONS(2601),
    [anon_sym_delete] = ACTIONS(2601),
    [anon_sym_throw] = ACTIONS(2601),
    [anon_sym_namespace] = ACTIONS(2601),
    [anon_sym_using] = ACTIONS(2601),
    [anon_sym_static_assert] = ACTIONS(2601),
    [anon_sym_concept] = ACTIONS(2601),
    [anon_sym_co_return] = ACTIONS(2601),
    [anon_sym_co_yield] = ACTIONS(2601),
    [anon_sym_R_DQUOTE] = ACTIONS(2603),
    [anon_sym_LR_DQUOTE] = ACTIONS(2603),
    [anon_sym_uR_DQUOTE] = ACTIONS(2603),
    [anon_sym_UR_DQUOTE] = ACTIONS(2603),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2603),
    [anon_sym_co_await] = ACTIONS(2601),
    [anon_sym_new] = ACTIONS(2601),
    [anon_sym_requires] = ACTIONS(2601),
    [sym_this] = ACTIONS(2601),
  },
  [238] = {
    [sym_identifier] = ACTIONS(2605),
    [aux_sym_preproc_include_token1] = ACTIONS(2605),
    [aux_sym_preproc_def_token1] = ACTIONS(2605),
    [aux_sym_preproc_if_token1] = ACTIONS(2605),
    [aux_sym_preproc_if_token2] = ACTIONS(2605),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2605),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2605),
    [aux_sym_preproc_else_token1] = ACTIONS(2605),
    [aux_sym_preproc_elif_token1] = ACTIONS(2605),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2605),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2605),
    [sym_preproc_directive] = ACTIONS(2605),
    [anon_sym_LPAREN2] = ACTIONS(2607),
    [anon_sym_BANG] = ACTIONS(2607),
    [anon_sym_TILDE] = ACTIONS(2607),
    [anon_sym_DASH] = ACTIONS(2605),
    [anon_sym_PLUS] = ACTIONS(2605),
    [anon_sym_STAR] = ACTIONS(2607),
    [anon_sym_AMP_AMP] = ACTIONS(2607),
    [anon_sym_AMP] = ACTIONS(2605),
    [anon_sym_SEMI] = ACTIONS(2607),
    [anon_sym___extension__] = ACTIONS(2605),
    [anon_sym_typedef] = ACTIONS(2605),
    [anon_sym_virtual] = ACTIONS(2605),
    [anon_sym_extern] = ACTIONS(2605),
    [anon_sym___attribute__] = ACTIONS(2605),
    [anon_sym___attribute] = ACTIONS(2605),
    [anon_sym_COLON_COLON] = ACTIONS(2607),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2607),
    [anon_sym___declspec] = ACTIONS(2605),
    [anon_sym___based] = ACTIONS(2605),
    [anon_sym___cdecl] = ACTIONS(2605),
    [anon_sym___clrcall] = ACTIONS(2605),
    [anon_sym___stdcall] = ACTIONS(2605),
    [anon_sym___fastcall] = ACTIONS(2605),
    [anon_sym___thiscall] = ACTIONS(2605),
    [anon_sym___vectorcall] = ACTIONS(2605),
    [anon_sym_LBRACE] = ACTIONS(2607),
    [anon_sym_signed] = ACTIONS(2605),
    [anon_sym_unsigned] = ACTIONS(2605),
    [anon_sym_long] = ACTIONS(2605),
    [anon_sym_short] = ACTIONS(2605),
    [anon_sym_LBRACK] = ACTIONS(2605),
    [anon_sym_static] = ACTIONS(2605),
    [anon_sym_register] = ACTIONS(2605),
    [anon_sym_inline] = ACTIONS(2605),
    [anon_sym___inline] = ACTIONS(2605),
    [anon_sym___inline__] = ACTIONS(2605),
    [anon_sym___forceinline] = ACTIONS(2605),
    [anon_sym_thread_local] = ACTIONS(2605),
    [anon_sym___thread] = ACTIONS(2605),
    [anon_sym_const] = ACTIONS(2605),
    [anon_sym_constexpr] = ACTIONS(2605),
    [anon_sym_volatile] = ACTIONS(2605),
    [anon_sym_restrict] = ACTIONS(2605),
    [anon_sym___restrict__] = ACTIONS(2605),
    [anon_sym__Atomic] = ACTIONS(2605),
    [anon_sym__Noreturn] = ACTIONS(2605),
    [anon_sym_noreturn] = ACTIONS(2605),
    [anon_sym__Nonnull] = ACTIONS(2605),
    [anon_sym_mutable] = ACTIONS(2605),
    [anon_sym_constinit] = ACTIONS(2605),
    [anon_sym_consteval] = ACTIONS(2605),
    [anon_sym_alignas] = ACTIONS(2605),
    [anon_sym__Alignas] = ACTIONS(2605),
    [sym_primitive_type] = ACTIONS(2605),
    [anon_sym_enum] = ACTIONS(2605),
    [anon_sym_class] = ACTIONS(2605),
    [anon_sym_struct] = ACTIONS(2605),
    [anon_sym_union] = ACTIONS(2605),
    [anon_sym_if] = ACTIONS(2605),
    [anon_sym_else] = ACTIONS(2605),
    [anon_sym_switch] = ACTIONS(2605),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_default] = ACTIONS(2605),
    [anon_sym_while] = ACTIONS(2605),
    [anon_sym_do] = ACTIONS(2605),
    [anon_sym_for] = ACTIONS(2605),
    [anon_sym_return] = ACTIONS(2605),
    [anon_sym_break] = ACTIONS(2605),
    [anon_sym_continue] = ACTIONS(2605),
    [anon_sym_goto] = ACTIONS(2605),
    [anon_sym___try] = ACTIONS(2605),
    [anon_sym___leave] = ACTIONS(2605),
    [anon_sym_not] = ACTIONS(2605),
    [anon_sym_compl] = ACTIONS(2605),
    [anon_sym_DASH_DASH] = ACTIONS(2607),
    [anon_sym_PLUS_PLUS] = ACTIONS(2607),
    [anon_sym_sizeof] = ACTIONS(2605),
    [anon_sym___alignof__] = ACTIONS(2605),
    [anon_sym___alignof] = ACTIONS(2605),
    [anon_sym__alignof] = ACTIONS(2605),
    [anon_sym_alignof] = ACTIONS(2605),
    [anon_sym__Alignof] = ACTIONS(2605),
    [anon_sym_offsetof] = ACTIONS(2605),
    [anon_sym__Generic] = ACTIONS(2605),
    [anon_sym_asm] = ACTIONS(2605),
    [anon_sym___asm__] = ACTIONS(2605),
    [anon_sym___asm] = ACTIONS(2605),
    [sym_number_literal] = ACTIONS(2607),
    [anon_sym_L_SQUOTE] = ACTIONS(2607),
    [anon_sym_u_SQUOTE] = ACTIONS(2607),
    [anon_sym_U_SQUOTE] = ACTIONS(2607),
    [anon_sym_u8_SQUOTE] = ACTIONS(2607),
    [anon_sym_SQUOTE] = ACTIONS(2607),
    [anon_sym_L_DQUOTE] = ACTIONS(2607),
    [anon_sym_u_DQUOTE] = ACTIONS(2607),
    [anon_sym_U_DQUOTE] = ACTIONS(2607),
    [anon_sym_u8_DQUOTE] = ACTIONS(2607),
    [anon_sym_DQUOTE] = ACTIONS(2607),
    [sym_true] = ACTIONS(2605),
    [sym_false] = ACTIONS(2605),
    [anon_sym_NULL] = ACTIONS(2605),
    [anon_sym_nullptr] = ACTIONS(2605),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2605),
    [anon_sym_decltype] = ACTIONS(2605),
    [anon_sym_explicit] = ACTIONS(2605),
    [anon_sym_typename] = ACTIONS(2605),
    [anon_sym_template] = ACTIONS(2605),
    [anon_sym_operator] = ACTIONS(2605),
    [anon_sym_try] = ACTIONS(2605),
    [anon_sym_delete] = ACTIONS(2605),
    [anon_sym_throw] = ACTIONS(2605),
    [anon_sym_namespace] = ACTIONS(2605),
    [anon_sym_using] = ACTIONS(2605),
    [anon_sym_static_assert] = ACTIONS(2605),
    [anon_sym_concept] = ACTIONS(2605),
    [anon_sym_co_return] = ACTIONS(2605),
    [anon_sym_co_yield] = ACTIONS(2605),
    [anon_sym_R_DQUOTE] = ACTIONS(2607),
    [anon_sym_LR_DQUOTE] = ACTIONS(2607),
    [anon_sym_uR_DQUOTE] = ACTIONS(2607),
    [anon_sym_UR_DQUOTE] = ACTIONS(2607),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2607),
    [anon_sym_co_await] = ACTIONS(2605),
    [anon_sym_new] = ACTIONS(2605),
    [anon_sym_requires] = ACTIONS(2605),
    [sym_this] = ACTIONS(2605),
  },
  [239] = {
    [sym_identifier] = ACTIONS(2609),
    [aux_sym_preproc_include_token1] = ACTIONS(2609),
    [aux_sym_preproc_def_token1] = ACTIONS(2609),
    [aux_sym_preproc_if_token1] = ACTIONS(2609),
    [aux_sym_preproc_if_token2] = ACTIONS(2609),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2609),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2609),
    [aux_sym_preproc_else_token1] = ACTIONS(2609),
    [aux_sym_preproc_elif_token1] = ACTIONS(2609),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2609),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2609),
    [sym_preproc_directive] = ACTIONS(2609),
    [anon_sym_LPAREN2] = ACTIONS(2611),
    [anon_sym_BANG] = ACTIONS(2611),
    [anon_sym_TILDE] = ACTIONS(2611),
    [anon_sym_DASH] = ACTIONS(2609),
    [anon_sym_PLUS] = ACTIONS(2609),
    [anon_sym_STAR] = ACTIONS(2611),
    [anon_sym_AMP_AMP] = ACTIONS(2611),
    [anon_sym_AMP] = ACTIONS(2609),
    [anon_sym_SEMI] = ACTIONS(2611),
    [anon_sym___extension__] = ACTIONS(2609),
    [anon_sym_typedef] = ACTIONS(2609),
    [anon_sym_virtual] = ACTIONS(2609),
    [anon_sym_extern] = ACTIONS(2609),
    [anon_sym___attribute__] = ACTIONS(2609),
    [anon_sym___attribute] = ACTIONS(2609),
    [anon_sym_COLON_COLON] = ACTIONS(2611),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2611),
    [anon_sym___declspec] = ACTIONS(2609),
    [anon_sym___based] = ACTIONS(2609),
    [anon_sym___cdecl] = ACTIONS(2609),
    [anon_sym___clrcall] = ACTIONS(2609),
    [anon_sym___stdcall] = ACTIONS(2609),
    [anon_sym___fastcall] = ACTIONS(2609),
    [anon_sym___thiscall] = ACTIONS(2609),
    [anon_sym___vectorcall] = ACTIONS(2609),
    [anon_sym_LBRACE] = ACTIONS(2611),
    [anon_sym_signed] = ACTIONS(2609),
    [anon_sym_unsigned] = ACTIONS(2609),
    [anon_sym_long] = ACTIONS(2609),
    [anon_sym_short] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(2609),
    [anon_sym_static] = ACTIONS(2609),
    [anon_sym_register] = ACTIONS(2609),
    [anon_sym_inline] = ACTIONS(2609),
    [anon_sym___inline] = ACTIONS(2609),
    [anon_sym___inline__] = ACTIONS(2609),
    [anon_sym___forceinline] = ACTIONS(2609),
    [anon_sym_thread_local] = ACTIONS(2609),
    [anon_sym___thread] = ACTIONS(2609),
    [anon_sym_const] = ACTIONS(2609),
    [anon_sym_constexpr] = ACTIONS(2609),
    [anon_sym_volatile] = ACTIONS(2609),
    [anon_sym_restrict] = ACTIONS(2609),
    [anon_sym___restrict__] = ACTIONS(2609),
    [anon_sym__Atomic] = ACTIONS(2609),
    [anon_sym__Noreturn] = ACTIONS(2609),
    [anon_sym_noreturn] = ACTIONS(2609),
    [anon_sym__Nonnull] = ACTIONS(2609),
    [anon_sym_mutable] = ACTIONS(2609),
    [anon_sym_constinit] = ACTIONS(2609),
    [anon_sym_consteval] = ACTIONS(2609),
    [anon_sym_alignas] = ACTIONS(2609),
    [anon_sym__Alignas] = ACTIONS(2609),
    [sym_primitive_type] = ACTIONS(2609),
    [anon_sym_enum] = ACTIONS(2609),
    [anon_sym_class] = ACTIONS(2609),
    [anon_sym_struct] = ACTIONS(2609),
    [anon_sym_union] = ACTIONS(2609),
    [anon_sym_if] = ACTIONS(2609),
    [anon_sym_else] = ACTIONS(2609),
    [anon_sym_switch] = ACTIONS(2609),
    [anon_sym_case] = ACTIONS(2609),
    [anon_sym_default] = ACTIONS(2609),
    [anon_sym_while] = ACTIONS(2609),
    [anon_sym_do] = ACTIONS(2609),
    [anon_sym_for] = ACTIONS(2609),
    [anon_sym_return] = ACTIONS(2609),
    [anon_sym_break] = ACTIONS(2609),
    [anon_sym_continue] = ACTIONS(2609),
    [anon_sym_goto] = ACTIONS(2609),
    [anon_sym___try] = ACTIONS(2609),
    [anon_sym___leave] = ACTIONS(2609),
    [anon_sym_not] = ACTIONS(2609),
    [anon_sym_compl] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(2611),
    [anon_sym_PLUS_PLUS] = ACTIONS(2611),
    [anon_sym_sizeof] = ACTIONS(2609),
    [anon_sym___alignof__] = ACTIONS(2609),
    [anon_sym___alignof] = ACTIONS(2609),
    [anon_sym__alignof] = ACTIONS(2609),
    [anon_sym_alignof] = ACTIONS(2609),
    [anon_sym__Alignof] = ACTIONS(2609),
    [anon_sym_offsetof] = ACTIONS(2609),
    [anon_sym__Generic] = ACTIONS(2609),
    [anon_sym_asm] = ACTIONS(2609),
    [anon_sym___asm__] = ACTIONS(2609),
    [anon_sym___asm] = ACTIONS(2609),
    [sym_number_literal] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2611),
    [anon_sym_u_SQUOTE] = ACTIONS(2611),
    [anon_sym_U_SQUOTE] = ACTIONS(2611),
    [anon_sym_u8_SQUOTE] = ACTIONS(2611),
    [anon_sym_SQUOTE] = ACTIONS(2611),
    [anon_sym_L_DQUOTE] = ACTIONS(2611),
    [anon_sym_u_DQUOTE] = ACTIONS(2611),
    [anon_sym_U_DQUOTE] = ACTIONS(2611),
    [anon_sym_u8_DQUOTE] = ACTIONS(2611),
    [anon_sym_DQUOTE] = ACTIONS(2611),
    [sym_true] = ACTIONS(2609),
    [sym_false] = ACTIONS(2609),
    [anon_sym_NULL] = ACTIONS(2609),
    [anon_sym_nullptr] = ACTIONS(2609),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2609),
    [anon_sym_decltype] = ACTIONS(2609),
    [anon_sym_explicit] = ACTIONS(2609),
    [anon_sym_typename] = ACTIONS(2609),
    [anon_sym_template] = ACTIONS(2609),
    [anon_sym_operator] = ACTIONS(2609),
    [anon_sym_try] = ACTIONS(2609),
    [anon_sym_delete] = ACTIONS(2609),
    [anon_sym_throw] = ACTIONS(2609),
    [anon_sym_namespace] = ACTIONS(2609),
    [anon_sym_using] = ACTIONS(2609),
    [anon_sym_static_assert] = ACTIONS(2609),
    [anon_sym_concept] = ACTIONS(2609),
    [anon_sym_co_return] = ACTIONS(2609),
    [anon_sym_co_yield] = ACTIONS(2609),
    [anon_sym_R_DQUOTE] = ACTIONS(2611),
    [anon_sym_LR_DQUOTE] = ACTIONS(2611),
    [anon_sym_uR_DQUOTE] = ACTIONS(2611),
    [anon_sym_UR_DQUOTE] = ACTIONS(2611),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2611),
    [anon_sym_co_await] = ACTIONS(2609),
    [anon_sym_new] = ACTIONS(2609),
    [anon_sym_requires] = ACTIONS(2609),
    [sym_this] = ACTIONS(2609),
  },
  [240] = {
    [sym_identifier] = ACTIONS(2609),
    [aux_sym_preproc_include_token1] = ACTIONS(2609),
    [aux_sym_preproc_def_token1] = ACTIONS(2609),
    [aux_sym_preproc_if_token1] = ACTIONS(2609),
    [aux_sym_preproc_if_token2] = ACTIONS(2609),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2609),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2609),
    [aux_sym_preproc_else_token1] = ACTIONS(2609),
    [aux_sym_preproc_elif_token1] = ACTIONS(2609),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2609),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2609),
    [sym_preproc_directive] = ACTIONS(2609),
    [anon_sym_LPAREN2] = ACTIONS(2611),
    [anon_sym_BANG] = ACTIONS(2611),
    [anon_sym_TILDE] = ACTIONS(2611),
    [anon_sym_DASH] = ACTIONS(2609),
    [anon_sym_PLUS] = ACTIONS(2609),
    [anon_sym_STAR] = ACTIONS(2611),
    [anon_sym_AMP_AMP] = ACTIONS(2611),
    [anon_sym_AMP] = ACTIONS(2609),
    [anon_sym_SEMI] = ACTIONS(2611),
    [anon_sym___extension__] = ACTIONS(2609),
    [anon_sym_typedef] = ACTIONS(2609),
    [anon_sym_virtual] = ACTIONS(2609),
    [anon_sym_extern] = ACTIONS(2609),
    [anon_sym___attribute__] = ACTIONS(2609),
    [anon_sym___attribute] = ACTIONS(2609),
    [anon_sym_COLON_COLON] = ACTIONS(2611),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2611),
    [anon_sym___declspec] = ACTIONS(2609),
    [anon_sym___based] = ACTIONS(2609),
    [anon_sym___cdecl] = ACTIONS(2609),
    [anon_sym___clrcall] = ACTIONS(2609),
    [anon_sym___stdcall] = ACTIONS(2609),
    [anon_sym___fastcall] = ACTIONS(2609),
    [anon_sym___thiscall] = ACTIONS(2609),
    [anon_sym___vectorcall] = ACTIONS(2609),
    [anon_sym_LBRACE] = ACTIONS(2611),
    [anon_sym_signed] = ACTIONS(2609),
    [anon_sym_unsigned] = ACTIONS(2609),
    [anon_sym_long] = ACTIONS(2609),
    [anon_sym_short] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(2609),
    [anon_sym_static] = ACTIONS(2609),
    [anon_sym_register] = ACTIONS(2609),
    [anon_sym_inline] = ACTIONS(2609),
    [anon_sym___inline] = ACTIONS(2609),
    [anon_sym___inline__] = ACTIONS(2609),
    [anon_sym___forceinline] = ACTIONS(2609),
    [anon_sym_thread_local] = ACTIONS(2609),
    [anon_sym___thread] = ACTIONS(2609),
    [anon_sym_const] = ACTIONS(2609),
    [anon_sym_constexpr] = ACTIONS(2609),
    [anon_sym_volatile] = ACTIONS(2609),
    [anon_sym_restrict] = ACTIONS(2609),
    [anon_sym___restrict__] = ACTIONS(2609),
    [anon_sym__Atomic] = ACTIONS(2609),
    [anon_sym__Noreturn] = ACTIONS(2609),
    [anon_sym_noreturn] = ACTIONS(2609),
    [anon_sym__Nonnull] = ACTIONS(2609),
    [anon_sym_mutable] = ACTIONS(2609),
    [anon_sym_constinit] = ACTIONS(2609),
    [anon_sym_consteval] = ACTIONS(2609),
    [anon_sym_alignas] = ACTIONS(2609),
    [anon_sym__Alignas] = ACTIONS(2609),
    [sym_primitive_type] = ACTIONS(2609),
    [anon_sym_enum] = ACTIONS(2609),
    [anon_sym_class] = ACTIONS(2609),
    [anon_sym_struct] = ACTIONS(2609),
    [anon_sym_union] = ACTIONS(2609),
    [anon_sym_if] = ACTIONS(2609),
    [anon_sym_else] = ACTIONS(2609),
    [anon_sym_switch] = ACTIONS(2609),
    [anon_sym_case] = ACTIONS(2609),
    [anon_sym_default] = ACTIONS(2609),
    [anon_sym_while] = ACTIONS(2609),
    [anon_sym_do] = ACTIONS(2609),
    [anon_sym_for] = ACTIONS(2609),
    [anon_sym_return] = ACTIONS(2609),
    [anon_sym_break] = ACTIONS(2609),
    [anon_sym_continue] = ACTIONS(2609),
    [anon_sym_goto] = ACTIONS(2609),
    [anon_sym___try] = ACTIONS(2609),
    [anon_sym___leave] = ACTIONS(2609),
    [anon_sym_not] = ACTIONS(2609),
    [anon_sym_compl] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(2611),
    [anon_sym_PLUS_PLUS] = ACTIONS(2611),
    [anon_sym_sizeof] = ACTIONS(2609),
    [anon_sym___alignof__] = ACTIONS(2609),
    [anon_sym___alignof] = ACTIONS(2609),
    [anon_sym__alignof] = ACTIONS(2609),
    [anon_sym_alignof] = ACTIONS(2609),
    [anon_sym__Alignof] = ACTIONS(2609),
    [anon_sym_offsetof] = ACTIONS(2609),
    [anon_sym__Generic] = ACTIONS(2609),
    [anon_sym_asm] = ACTIONS(2609),
    [anon_sym___asm__] = ACTIONS(2609),
    [anon_sym___asm] = ACTIONS(2609),
    [sym_number_literal] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2611),
    [anon_sym_u_SQUOTE] = ACTIONS(2611),
    [anon_sym_U_SQUOTE] = ACTIONS(2611),
    [anon_sym_u8_SQUOTE] = ACTIONS(2611),
    [anon_sym_SQUOTE] = ACTIONS(2611),
    [anon_sym_L_DQUOTE] = ACTIONS(2611),
    [anon_sym_u_DQUOTE] = ACTIONS(2611),
    [anon_sym_U_DQUOTE] = ACTIONS(2611),
    [anon_sym_u8_DQUOTE] = ACTIONS(2611),
    [anon_sym_DQUOTE] = ACTIONS(2611),
    [sym_true] = ACTIONS(2609),
    [sym_false] = ACTIONS(2609),
    [anon_sym_NULL] = ACTIONS(2609),
    [anon_sym_nullptr] = ACTIONS(2609),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2609),
    [anon_sym_decltype] = ACTIONS(2609),
    [anon_sym_explicit] = ACTIONS(2609),
    [anon_sym_typename] = ACTIONS(2609),
    [anon_sym_template] = ACTIONS(2609),
    [anon_sym_operator] = ACTIONS(2609),
    [anon_sym_try] = ACTIONS(2609),
    [anon_sym_delete] = ACTIONS(2609),
    [anon_sym_throw] = ACTIONS(2609),
    [anon_sym_namespace] = ACTIONS(2609),
    [anon_sym_using] = ACTIONS(2609),
    [anon_sym_static_assert] = ACTIONS(2609),
    [anon_sym_concept] = ACTIONS(2609),
    [anon_sym_co_return] = ACTIONS(2609),
    [anon_sym_co_yield] = ACTIONS(2609),
    [anon_sym_R_DQUOTE] = ACTIONS(2611),
    [anon_sym_LR_DQUOTE] = ACTIONS(2611),
    [anon_sym_uR_DQUOTE] = ACTIONS(2611),
    [anon_sym_UR_DQUOTE] = ACTIONS(2611),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2611),
    [anon_sym_co_await] = ACTIONS(2609),
    [anon_sym_new] = ACTIONS(2609),
    [anon_sym_requires] = ACTIONS(2609),
    [sym_this] = ACTIONS(2609),
  },
  [241] = {
    [sym_identifier] = ACTIONS(2613),
    [aux_sym_preproc_include_token1] = ACTIONS(2613),
    [aux_sym_preproc_def_token1] = ACTIONS(2613),
    [aux_sym_preproc_if_token1] = ACTIONS(2613),
    [aux_sym_preproc_if_token2] = ACTIONS(2613),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2613),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2613),
    [aux_sym_preproc_else_token1] = ACTIONS(2613),
    [aux_sym_preproc_elif_token1] = ACTIONS(2613),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2613),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2613),
    [sym_preproc_directive] = ACTIONS(2613),
    [anon_sym_LPAREN2] = ACTIONS(2615),
    [anon_sym_BANG] = ACTIONS(2615),
    [anon_sym_TILDE] = ACTIONS(2615),
    [anon_sym_DASH] = ACTIONS(2613),
    [anon_sym_PLUS] = ACTIONS(2613),
    [anon_sym_STAR] = ACTIONS(2615),
    [anon_sym_AMP_AMP] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2613),
    [anon_sym_SEMI] = ACTIONS(2615),
    [anon_sym___extension__] = ACTIONS(2613),
    [anon_sym_typedef] = ACTIONS(2613),
    [anon_sym_virtual] = ACTIONS(2613),
    [anon_sym_extern] = ACTIONS(2613),
    [anon_sym___attribute__] = ACTIONS(2613),
    [anon_sym___attribute] = ACTIONS(2613),
    [anon_sym_COLON_COLON] = ACTIONS(2615),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2615),
    [anon_sym___declspec] = ACTIONS(2613),
    [anon_sym___based] = ACTIONS(2613),
    [anon_sym___cdecl] = ACTIONS(2613),
    [anon_sym___clrcall] = ACTIONS(2613),
    [anon_sym___stdcall] = ACTIONS(2613),
    [anon_sym___fastcall] = ACTIONS(2613),
    [anon_sym___thiscall] = ACTIONS(2613),
    [anon_sym___vectorcall] = ACTIONS(2613),
    [anon_sym_LBRACE] = ACTIONS(2615),
    [anon_sym_signed] = ACTIONS(2613),
    [anon_sym_unsigned] = ACTIONS(2613),
    [anon_sym_long] = ACTIONS(2613),
    [anon_sym_short] = ACTIONS(2613),
    [anon_sym_LBRACK] = ACTIONS(2613),
    [anon_sym_static] = ACTIONS(2613),
    [anon_sym_register] = ACTIONS(2613),
    [anon_sym_inline] = ACTIONS(2613),
    [anon_sym___inline] = ACTIONS(2613),
    [anon_sym___inline__] = ACTIONS(2613),
    [anon_sym___forceinline] = ACTIONS(2613),
    [anon_sym_thread_local] = ACTIONS(2613),
    [anon_sym___thread] = ACTIONS(2613),
    [anon_sym_const] = ACTIONS(2613),
    [anon_sym_constexpr] = ACTIONS(2613),
    [anon_sym_volatile] = ACTIONS(2613),
    [anon_sym_restrict] = ACTIONS(2613),
    [anon_sym___restrict__] = ACTIONS(2613),
    [anon_sym__Atomic] = ACTIONS(2613),
    [anon_sym__Noreturn] = ACTIONS(2613),
    [anon_sym_noreturn] = ACTIONS(2613),
    [anon_sym__Nonnull] = ACTIONS(2613),
    [anon_sym_mutable] = ACTIONS(2613),
    [anon_sym_constinit] = ACTIONS(2613),
    [anon_sym_consteval] = ACTIONS(2613),
    [anon_sym_alignas] = ACTIONS(2613),
    [anon_sym__Alignas] = ACTIONS(2613),
    [sym_primitive_type] = ACTIONS(2613),
    [anon_sym_enum] = ACTIONS(2613),
    [anon_sym_class] = ACTIONS(2613),
    [anon_sym_struct] = ACTIONS(2613),
    [anon_sym_union] = ACTIONS(2613),
    [anon_sym_if] = ACTIONS(2613),
    [anon_sym_else] = ACTIONS(2613),
    [anon_sym_switch] = ACTIONS(2613),
    [anon_sym_case] = ACTIONS(2613),
    [anon_sym_default] = ACTIONS(2613),
    [anon_sym_while] = ACTIONS(2613),
    [anon_sym_do] = ACTIONS(2613),
    [anon_sym_for] = ACTIONS(2613),
    [anon_sym_return] = ACTIONS(2613),
    [anon_sym_break] = ACTIONS(2613),
    [anon_sym_continue] = ACTIONS(2613),
    [anon_sym_goto] = ACTIONS(2613),
    [anon_sym___try] = ACTIONS(2613),
    [anon_sym___leave] = ACTIONS(2613),
    [anon_sym_not] = ACTIONS(2613),
    [anon_sym_compl] = ACTIONS(2613),
    [anon_sym_DASH_DASH] = ACTIONS(2615),
    [anon_sym_PLUS_PLUS] = ACTIONS(2615),
    [anon_sym_sizeof] = ACTIONS(2613),
    [anon_sym___alignof__] = ACTIONS(2613),
    [anon_sym___alignof] = ACTIONS(2613),
    [anon_sym__alignof] = ACTIONS(2613),
    [anon_sym_alignof] = ACTIONS(2613),
    [anon_sym__Alignof] = ACTIONS(2613),
    [anon_sym_offsetof] = ACTIONS(2613),
    [anon_sym__Generic] = ACTIONS(2613),
    [anon_sym_asm] = ACTIONS(2613),
    [anon_sym___asm__] = ACTIONS(2613),
    [anon_sym___asm] = ACTIONS(2613),
    [sym_number_literal] = ACTIONS(2615),
    [anon_sym_L_SQUOTE] = ACTIONS(2615),
    [anon_sym_u_SQUOTE] = ACTIONS(2615),
    [anon_sym_U_SQUOTE] = ACTIONS(2615),
    [anon_sym_u8_SQUOTE] = ACTIONS(2615),
    [anon_sym_SQUOTE] = ACTIONS(2615),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2613),
    [sym_false] = ACTIONS(2613),
    [anon_sym_NULL] = ACTIONS(2613),
    [anon_sym_nullptr] = ACTIONS(2613),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2613),
    [anon_sym_decltype] = ACTIONS(2613),
    [anon_sym_explicit] = ACTIONS(2613),
    [anon_sym_typename] = ACTIONS(2613),
    [anon_sym_template] = ACTIONS(2613),
    [anon_sym_operator] = ACTIONS(2613),
    [anon_sym_try] = ACTIONS(2613),
    [anon_sym_delete] = ACTIONS(2613),
    [anon_sym_throw] = ACTIONS(2613),
    [anon_sym_namespace] = ACTIONS(2613),
    [anon_sym_using] = ACTIONS(2613),
    [anon_sym_static_assert] = ACTIONS(2613),
    [anon_sym_concept] = ACTIONS(2613),
    [anon_sym_co_return] = ACTIONS(2613),
    [anon_sym_co_yield] = ACTIONS(2613),
    [anon_sym_R_DQUOTE] = ACTIONS(2615),
    [anon_sym_LR_DQUOTE] = ACTIONS(2615),
    [anon_sym_uR_DQUOTE] = ACTIONS(2615),
    [anon_sym_UR_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2615),
    [anon_sym_co_await] = ACTIONS(2613),
    [anon_sym_new] = ACTIONS(2613),
    [anon_sym_requires] = ACTIONS(2613),
    [sym_this] = ACTIONS(2613),
  },
  [242] = {
    [sym_identifier] = ACTIONS(2617),
    [aux_sym_preproc_include_token1] = ACTIONS(2617),
    [aux_sym_preproc_def_token1] = ACTIONS(2617),
    [aux_sym_preproc_if_token1] = ACTIONS(2617),
    [aux_sym_preproc_if_token2] = ACTIONS(2617),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2617),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2617),
    [aux_sym_preproc_else_token1] = ACTIONS(2617),
    [aux_sym_preproc_elif_token1] = ACTIONS(2617),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2617),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2617),
    [sym_preproc_directive] = ACTIONS(2617),
    [anon_sym_LPAREN2] = ACTIONS(2619),
    [anon_sym_BANG] = ACTIONS(2619),
    [anon_sym_TILDE] = ACTIONS(2619),
    [anon_sym_DASH] = ACTIONS(2617),
    [anon_sym_PLUS] = ACTIONS(2617),
    [anon_sym_STAR] = ACTIONS(2619),
    [anon_sym_AMP_AMP] = ACTIONS(2619),
    [anon_sym_AMP] = ACTIONS(2617),
    [anon_sym_SEMI] = ACTIONS(2619),
    [anon_sym___extension__] = ACTIONS(2617),
    [anon_sym_typedef] = ACTIONS(2617),
    [anon_sym_virtual] = ACTIONS(2617),
    [anon_sym_extern] = ACTIONS(2617),
    [anon_sym___attribute__] = ACTIONS(2617),
    [anon_sym___attribute] = ACTIONS(2617),
    [anon_sym_COLON_COLON] = ACTIONS(2619),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2619),
    [anon_sym___declspec] = ACTIONS(2617),
    [anon_sym___based] = ACTIONS(2617),
    [anon_sym___cdecl] = ACTIONS(2617),
    [anon_sym___clrcall] = ACTIONS(2617),
    [anon_sym___stdcall] = ACTIONS(2617),
    [anon_sym___fastcall] = ACTIONS(2617),
    [anon_sym___thiscall] = ACTIONS(2617),
    [anon_sym___vectorcall] = ACTIONS(2617),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_signed] = ACTIONS(2617),
    [anon_sym_unsigned] = ACTIONS(2617),
    [anon_sym_long] = ACTIONS(2617),
    [anon_sym_short] = ACTIONS(2617),
    [anon_sym_LBRACK] = ACTIONS(2617),
    [anon_sym_static] = ACTIONS(2617),
    [anon_sym_register] = ACTIONS(2617),
    [anon_sym_inline] = ACTIONS(2617),
    [anon_sym___inline] = ACTIONS(2617),
    [anon_sym___inline__] = ACTIONS(2617),
    [anon_sym___forceinline] = ACTIONS(2617),
    [anon_sym_thread_local] = ACTIONS(2617),
    [anon_sym___thread] = ACTIONS(2617),
    [anon_sym_const] = ACTIONS(2617),
    [anon_sym_constexpr] = ACTIONS(2617),
    [anon_sym_volatile] = ACTIONS(2617),
    [anon_sym_restrict] = ACTIONS(2617),
    [anon_sym___restrict__] = ACTIONS(2617),
    [anon_sym__Atomic] = ACTIONS(2617),
    [anon_sym__Noreturn] = ACTIONS(2617),
    [anon_sym_noreturn] = ACTIONS(2617),
    [anon_sym__Nonnull] = ACTIONS(2617),
    [anon_sym_mutable] = ACTIONS(2617),
    [anon_sym_constinit] = ACTIONS(2617),
    [anon_sym_consteval] = ACTIONS(2617),
    [anon_sym_alignas] = ACTIONS(2617),
    [anon_sym__Alignas] = ACTIONS(2617),
    [sym_primitive_type] = ACTIONS(2617),
    [anon_sym_enum] = ACTIONS(2617),
    [anon_sym_class] = ACTIONS(2617),
    [anon_sym_struct] = ACTIONS(2617),
    [anon_sym_union] = ACTIONS(2617),
    [anon_sym_if] = ACTIONS(2617),
    [anon_sym_else] = ACTIONS(2617),
    [anon_sym_switch] = ACTIONS(2617),
    [anon_sym_case] = ACTIONS(2617),
    [anon_sym_default] = ACTIONS(2617),
    [anon_sym_while] = ACTIONS(2617),
    [anon_sym_do] = ACTIONS(2617),
    [anon_sym_for] = ACTIONS(2617),
    [anon_sym_return] = ACTIONS(2617),
    [anon_sym_break] = ACTIONS(2617),
    [anon_sym_continue] = ACTIONS(2617),
    [anon_sym_goto] = ACTIONS(2617),
    [anon_sym___try] = ACTIONS(2617),
    [anon_sym___leave] = ACTIONS(2617),
    [anon_sym_not] = ACTIONS(2617),
    [anon_sym_compl] = ACTIONS(2617),
    [anon_sym_DASH_DASH] = ACTIONS(2619),
    [anon_sym_PLUS_PLUS] = ACTIONS(2619),
    [anon_sym_sizeof] = ACTIONS(2617),
    [anon_sym___alignof__] = ACTIONS(2617),
    [anon_sym___alignof] = ACTIONS(2617),
    [anon_sym__alignof] = ACTIONS(2617),
    [anon_sym_alignof] = ACTIONS(2617),
    [anon_sym__Alignof] = ACTIONS(2617),
    [anon_sym_offsetof] = ACTIONS(2617),
    [anon_sym__Generic] = ACTIONS(2617),
    [anon_sym_asm] = ACTIONS(2617),
    [anon_sym___asm__] = ACTIONS(2617),
    [anon_sym___asm] = ACTIONS(2617),
    [sym_number_literal] = ACTIONS(2619),
    [anon_sym_L_SQUOTE] = ACTIONS(2619),
    [anon_sym_u_SQUOTE] = ACTIONS(2619),
    [anon_sym_U_SQUOTE] = ACTIONS(2619),
    [anon_sym_u8_SQUOTE] = ACTIONS(2619),
    [anon_sym_SQUOTE] = ACTIONS(2619),
    [anon_sym_L_DQUOTE] = ACTIONS(2619),
    [anon_sym_u_DQUOTE] = ACTIONS(2619),
    [anon_sym_U_DQUOTE] = ACTIONS(2619),
    [anon_sym_u8_DQUOTE] = ACTIONS(2619),
    [anon_sym_DQUOTE] = ACTIONS(2619),
    [sym_true] = ACTIONS(2617),
    [sym_false] = ACTIONS(2617),
    [anon_sym_NULL] = ACTIONS(2617),
    [anon_sym_nullptr] = ACTIONS(2617),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2617),
    [anon_sym_decltype] = ACTIONS(2617),
    [anon_sym_explicit] = ACTIONS(2617),
    [anon_sym_typename] = ACTIONS(2617),
    [anon_sym_template] = ACTIONS(2617),
    [anon_sym_operator] = ACTIONS(2617),
    [anon_sym_try] = ACTIONS(2617),
    [anon_sym_delete] = ACTIONS(2617),
    [anon_sym_throw] = ACTIONS(2617),
    [anon_sym_namespace] = ACTIONS(2617),
    [anon_sym_using] = ACTIONS(2617),
    [anon_sym_static_assert] = ACTIONS(2617),
    [anon_sym_concept] = ACTIONS(2617),
    [anon_sym_co_return] = ACTIONS(2617),
    [anon_sym_co_yield] = ACTIONS(2617),
    [anon_sym_R_DQUOTE] = ACTIONS(2619),
    [anon_sym_LR_DQUOTE] = ACTIONS(2619),
    [anon_sym_uR_DQUOTE] = ACTIONS(2619),
    [anon_sym_UR_DQUOTE] = ACTIONS(2619),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2619),
    [anon_sym_co_await] = ACTIONS(2617),
    [anon_sym_new] = ACTIONS(2617),
    [anon_sym_requires] = ACTIONS(2617),
    [sym_this] = ACTIONS(2617),
  },
  [243] = {
    [sym_identifier] = ACTIONS(2621),
    [aux_sym_preproc_include_token1] = ACTIONS(2621),
    [aux_sym_preproc_def_token1] = ACTIONS(2621),
    [aux_sym_preproc_if_token1] = ACTIONS(2621),
    [aux_sym_preproc_if_token2] = ACTIONS(2621),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2621),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2621),
    [aux_sym_preproc_else_token1] = ACTIONS(2621),
    [aux_sym_preproc_elif_token1] = ACTIONS(2621),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2621),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2621),
    [sym_preproc_directive] = ACTIONS(2621),
    [anon_sym_LPAREN2] = ACTIONS(2623),
    [anon_sym_BANG] = ACTIONS(2623),
    [anon_sym_TILDE] = ACTIONS(2623),
    [anon_sym_DASH] = ACTIONS(2621),
    [anon_sym_PLUS] = ACTIONS(2621),
    [anon_sym_STAR] = ACTIONS(2623),
    [anon_sym_AMP_AMP] = ACTIONS(2623),
    [anon_sym_AMP] = ACTIONS(2621),
    [anon_sym_SEMI] = ACTIONS(2623),
    [anon_sym___extension__] = ACTIONS(2621),
    [anon_sym_typedef] = ACTIONS(2621),
    [anon_sym_virtual] = ACTIONS(2621),
    [anon_sym_extern] = ACTIONS(2621),
    [anon_sym___attribute__] = ACTIONS(2621),
    [anon_sym___attribute] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(2623),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2623),
    [anon_sym___declspec] = ACTIONS(2621),
    [anon_sym___based] = ACTIONS(2621),
    [anon_sym___cdecl] = ACTIONS(2621),
    [anon_sym___clrcall] = ACTIONS(2621),
    [anon_sym___stdcall] = ACTIONS(2621),
    [anon_sym___fastcall] = ACTIONS(2621),
    [anon_sym___thiscall] = ACTIONS(2621),
    [anon_sym___vectorcall] = ACTIONS(2621),
    [anon_sym_LBRACE] = ACTIONS(2623),
    [anon_sym_signed] = ACTIONS(2621),
    [anon_sym_unsigned] = ACTIONS(2621),
    [anon_sym_long] = ACTIONS(2621),
    [anon_sym_short] = ACTIONS(2621),
    [anon_sym_LBRACK] = ACTIONS(2621),
    [anon_sym_static] = ACTIONS(2621),
    [anon_sym_register] = ACTIONS(2621),
    [anon_sym_inline] = ACTIONS(2621),
    [anon_sym___inline] = ACTIONS(2621),
    [anon_sym___inline__] = ACTIONS(2621),
    [anon_sym___forceinline] = ACTIONS(2621),
    [anon_sym_thread_local] = ACTIONS(2621),
    [anon_sym___thread] = ACTIONS(2621),
    [anon_sym_const] = ACTIONS(2621),
    [anon_sym_constexpr] = ACTIONS(2621),
    [anon_sym_volatile] = ACTIONS(2621),
    [anon_sym_restrict] = ACTIONS(2621),
    [anon_sym___restrict__] = ACTIONS(2621),
    [anon_sym__Atomic] = ACTIONS(2621),
    [anon_sym__Noreturn] = ACTIONS(2621),
    [anon_sym_noreturn] = ACTIONS(2621),
    [anon_sym__Nonnull] = ACTIONS(2621),
    [anon_sym_mutable] = ACTIONS(2621),
    [anon_sym_constinit] = ACTIONS(2621),
    [anon_sym_consteval] = ACTIONS(2621),
    [anon_sym_alignas] = ACTIONS(2621),
    [anon_sym__Alignas] = ACTIONS(2621),
    [sym_primitive_type] = ACTIONS(2621),
    [anon_sym_enum] = ACTIONS(2621),
    [anon_sym_class] = ACTIONS(2621),
    [anon_sym_struct] = ACTIONS(2621),
    [anon_sym_union] = ACTIONS(2621),
    [anon_sym_if] = ACTIONS(2621),
    [anon_sym_else] = ACTIONS(2621),
    [anon_sym_switch] = ACTIONS(2621),
    [anon_sym_case] = ACTIONS(2621),
    [anon_sym_default] = ACTIONS(2621),
    [anon_sym_while] = ACTIONS(2621),
    [anon_sym_do] = ACTIONS(2621),
    [anon_sym_for] = ACTIONS(2621),
    [anon_sym_return] = ACTIONS(2621),
    [anon_sym_break] = ACTIONS(2621),
    [anon_sym_continue] = ACTIONS(2621),
    [anon_sym_goto] = ACTIONS(2621),
    [anon_sym___try] = ACTIONS(2621),
    [anon_sym___leave] = ACTIONS(2621),
    [anon_sym_not] = ACTIONS(2621),
    [anon_sym_compl] = ACTIONS(2621),
    [anon_sym_DASH_DASH] = ACTIONS(2623),
    [anon_sym_PLUS_PLUS] = ACTIONS(2623),
    [anon_sym_sizeof] = ACTIONS(2621),
    [anon_sym___alignof__] = ACTIONS(2621),
    [anon_sym___alignof] = ACTIONS(2621),
    [anon_sym__alignof] = ACTIONS(2621),
    [anon_sym_alignof] = ACTIONS(2621),
    [anon_sym__Alignof] = ACTIONS(2621),
    [anon_sym_offsetof] = ACTIONS(2621),
    [anon_sym__Generic] = ACTIONS(2621),
    [anon_sym_asm] = ACTIONS(2621),
    [anon_sym___asm__] = ACTIONS(2621),
    [anon_sym___asm] = ACTIONS(2621),
    [sym_number_literal] = ACTIONS(2623),
    [anon_sym_L_SQUOTE] = ACTIONS(2623),
    [anon_sym_u_SQUOTE] = ACTIONS(2623),
    [anon_sym_U_SQUOTE] = ACTIONS(2623),
    [anon_sym_u8_SQUOTE] = ACTIONS(2623),
    [anon_sym_SQUOTE] = ACTIONS(2623),
    [anon_sym_L_DQUOTE] = ACTIONS(2623),
    [anon_sym_u_DQUOTE] = ACTIONS(2623),
    [anon_sym_U_DQUOTE] = ACTIONS(2623),
    [anon_sym_u8_DQUOTE] = ACTIONS(2623),
    [anon_sym_DQUOTE] = ACTIONS(2623),
    [sym_true] = ACTIONS(2621),
    [sym_false] = ACTIONS(2621),
    [anon_sym_NULL] = ACTIONS(2621),
    [anon_sym_nullptr] = ACTIONS(2621),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2621),
    [anon_sym_decltype] = ACTIONS(2621),
    [anon_sym_explicit] = ACTIONS(2621),
    [anon_sym_typename] = ACTIONS(2621),
    [anon_sym_template] = ACTIONS(2621),
    [anon_sym_operator] = ACTIONS(2621),
    [anon_sym_try] = ACTIONS(2621),
    [anon_sym_delete] = ACTIONS(2621),
    [anon_sym_throw] = ACTIONS(2621),
    [anon_sym_namespace] = ACTIONS(2621),
    [anon_sym_using] = ACTIONS(2621),
    [anon_sym_static_assert] = ACTIONS(2621),
    [anon_sym_concept] = ACTIONS(2621),
    [anon_sym_co_return] = ACTIONS(2621),
    [anon_sym_co_yield] = ACTIONS(2621),
    [anon_sym_R_DQUOTE] = ACTIONS(2623),
    [anon_sym_LR_DQUOTE] = ACTIONS(2623),
    [anon_sym_uR_DQUOTE] = ACTIONS(2623),
    [anon_sym_UR_DQUOTE] = ACTIONS(2623),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2623),
    [anon_sym_co_await] = ACTIONS(2621),
    [anon_sym_new] = ACTIONS(2621),
    [anon_sym_requires] = ACTIONS(2621),
    [sym_this] = ACTIONS(2621),
  },
  [244] = {
    [sym_identifier] = ACTIONS(2625),
    [aux_sym_preproc_include_token1] = ACTIONS(2625),
    [aux_sym_preproc_def_token1] = ACTIONS(2625),
    [aux_sym_preproc_if_token1] = ACTIONS(2625),
    [aux_sym_preproc_if_token2] = ACTIONS(2625),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2625),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2625),
    [aux_sym_preproc_else_token1] = ACTIONS(2625),
    [aux_sym_preproc_elif_token1] = ACTIONS(2625),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2625),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2625),
    [sym_preproc_directive] = ACTIONS(2625),
    [anon_sym_LPAREN2] = ACTIONS(2627),
    [anon_sym_BANG] = ACTIONS(2627),
    [anon_sym_TILDE] = ACTIONS(2627),
    [anon_sym_DASH] = ACTIONS(2625),
    [anon_sym_PLUS] = ACTIONS(2625),
    [anon_sym_STAR] = ACTIONS(2627),
    [anon_sym_AMP_AMP] = ACTIONS(2627),
    [anon_sym_AMP] = ACTIONS(2625),
    [anon_sym_SEMI] = ACTIONS(2627),
    [anon_sym___extension__] = ACTIONS(2625),
    [anon_sym_typedef] = ACTIONS(2625),
    [anon_sym_virtual] = ACTIONS(2625),
    [anon_sym_extern] = ACTIONS(2625),
    [anon_sym___attribute__] = ACTIONS(2625),
    [anon_sym___attribute] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(2627),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2627),
    [anon_sym___declspec] = ACTIONS(2625),
    [anon_sym___based] = ACTIONS(2625),
    [anon_sym___cdecl] = ACTIONS(2625),
    [anon_sym___clrcall] = ACTIONS(2625),
    [anon_sym___stdcall] = ACTIONS(2625),
    [anon_sym___fastcall] = ACTIONS(2625),
    [anon_sym___thiscall] = ACTIONS(2625),
    [anon_sym___vectorcall] = ACTIONS(2625),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_signed] = ACTIONS(2625),
    [anon_sym_unsigned] = ACTIONS(2625),
    [anon_sym_long] = ACTIONS(2625),
    [anon_sym_short] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(2625),
    [anon_sym_static] = ACTIONS(2625),
    [anon_sym_register] = ACTIONS(2625),
    [anon_sym_inline] = ACTIONS(2625),
    [anon_sym___inline] = ACTIONS(2625),
    [anon_sym___inline__] = ACTIONS(2625),
    [anon_sym___forceinline] = ACTIONS(2625),
    [anon_sym_thread_local] = ACTIONS(2625),
    [anon_sym___thread] = ACTIONS(2625),
    [anon_sym_const] = ACTIONS(2625),
    [anon_sym_constexpr] = ACTIONS(2625),
    [anon_sym_volatile] = ACTIONS(2625),
    [anon_sym_restrict] = ACTIONS(2625),
    [anon_sym___restrict__] = ACTIONS(2625),
    [anon_sym__Atomic] = ACTIONS(2625),
    [anon_sym__Noreturn] = ACTIONS(2625),
    [anon_sym_noreturn] = ACTIONS(2625),
    [anon_sym__Nonnull] = ACTIONS(2625),
    [anon_sym_mutable] = ACTIONS(2625),
    [anon_sym_constinit] = ACTIONS(2625),
    [anon_sym_consteval] = ACTIONS(2625),
    [anon_sym_alignas] = ACTIONS(2625),
    [anon_sym__Alignas] = ACTIONS(2625),
    [sym_primitive_type] = ACTIONS(2625),
    [anon_sym_enum] = ACTIONS(2625),
    [anon_sym_class] = ACTIONS(2625),
    [anon_sym_struct] = ACTIONS(2625),
    [anon_sym_union] = ACTIONS(2625),
    [anon_sym_if] = ACTIONS(2625),
    [anon_sym_else] = ACTIONS(2625),
    [anon_sym_switch] = ACTIONS(2625),
    [anon_sym_case] = ACTIONS(2625),
    [anon_sym_default] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(2625),
    [anon_sym_do] = ACTIONS(2625),
    [anon_sym_for] = ACTIONS(2625),
    [anon_sym_return] = ACTIONS(2625),
    [anon_sym_break] = ACTIONS(2625),
    [anon_sym_continue] = ACTIONS(2625),
    [anon_sym_goto] = ACTIONS(2625),
    [anon_sym___try] = ACTIONS(2625),
    [anon_sym___leave] = ACTIONS(2625),
    [anon_sym_not] = ACTIONS(2625),
    [anon_sym_compl] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(2627),
    [anon_sym_PLUS_PLUS] = ACTIONS(2627),
    [anon_sym_sizeof] = ACTIONS(2625),
    [anon_sym___alignof__] = ACTIONS(2625),
    [anon_sym___alignof] = ACTIONS(2625),
    [anon_sym__alignof] = ACTIONS(2625),
    [anon_sym_alignof] = ACTIONS(2625),
    [anon_sym__Alignof] = ACTIONS(2625),
    [anon_sym_offsetof] = ACTIONS(2625),
    [anon_sym__Generic] = ACTIONS(2625),
    [anon_sym_asm] = ACTIONS(2625),
    [anon_sym___asm__] = ACTIONS(2625),
    [anon_sym___asm] = ACTIONS(2625),
    [sym_number_literal] = ACTIONS(2627),
    [anon_sym_L_SQUOTE] = ACTIONS(2627),
    [anon_sym_u_SQUOTE] = ACTIONS(2627),
    [anon_sym_U_SQUOTE] = ACTIONS(2627),
    [anon_sym_u8_SQUOTE] = ACTIONS(2627),
    [anon_sym_SQUOTE] = ACTIONS(2627),
    [anon_sym_L_DQUOTE] = ACTIONS(2627),
    [anon_sym_u_DQUOTE] = ACTIONS(2627),
    [anon_sym_U_DQUOTE] = ACTIONS(2627),
    [anon_sym_u8_DQUOTE] = ACTIONS(2627),
    [anon_sym_DQUOTE] = ACTIONS(2627),
    [sym_true] = ACTIONS(2625),
    [sym_false] = ACTIONS(2625),
    [anon_sym_NULL] = ACTIONS(2625),
    [anon_sym_nullptr] = ACTIONS(2625),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2625),
    [anon_sym_decltype] = ACTIONS(2625),
    [anon_sym_explicit] = ACTIONS(2625),
    [anon_sym_typename] = ACTIONS(2625),
    [anon_sym_template] = ACTIONS(2625),
    [anon_sym_operator] = ACTIONS(2625),
    [anon_sym_try] = ACTIONS(2625),
    [anon_sym_delete] = ACTIONS(2625),
    [anon_sym_throw] = ACTIONS(2625),
    [anon_sym_namespace] = ACTIONS(2625),
    [anon_sym_using] = ACTIONS(2625),
    [anon_sym_static_assert] = ACTIONS(2625),
    [anon_sym_concept] = ACTIONS(2625),
    [anon_sym_co_return] = ACTIONS(2625),
    [anon_sym_co_yield] = ACTIONS(2625),
    [anon_sym_R_DQUOTE] = ACTIONS(2627),
    [anon_sym_LR_DQUOTE] = ACTIONS(2627),
    [anon_sym_uR_DQUOTE] = ACTIONS(2627),
    [anon_sym_UR_DQUOTE] = ACTIONS(2627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2627),
    [anon_sym_co_await] = ACTIONS(2625),
    [anon_sym_new] = ACTIONS(2625),
    [anon_sym_requires] = ACTIONS(2625),
    [sym_this] = ACTIONS(2625),
  },
  [245] = {
    [sym_identifier] = ACTIONS(2629),
    [aux_sym_preproc_include_token1] = ACTIONS(2629),
    [aux_sym_preproc_def_token1] = ACTIONS(2629),
    [aux_sym_preproc_if_token1] = ACTIONS(2629),
    [aux_sym_preproc_if_token2] = ACTIONS(2629),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2629),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2629),
    [aux_sym_preproc_else_token1] = ACTIONS(2629),
    [aux_sym_preproc_elif_token1] = ACTIONS(2629),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2629),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2629),
    [sym_preproc_directive] = ACTIONS(2629),
    [anon_sym_LPAREN2] = ACTIONS(2631),
    [anon_sym_BANG] = ACTIONS(2631),
    [anon_sym_TILDE] = ACTIONS(2631),
    [anon_sym_DASH] = ACTIONS(2629),
    [anon_sym_PLUS] = ACTIONS(2629),
    [anon_sym_STAR] = ACTIONS(2631),
    [anon_sym_AMP_AMP] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2629),
    [anon_sym_SEMI] = ACTIONS(2631),
    [anon_sym___extension__] = ACTIONS(2629),
    [anon_sym_typedef] = ACTIONS(2629),
    [anon_sym_virtual] = ACTIONS(2629),
    [anon_sym_extern] = ACTIONS(2629),
    [anon_sym___attribute__] = ACTIONS(2629),
    [anon_sym___attribute] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(2631),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2631),
    [anon_sym___declspec] = ACTIONS(2629),
    [anon_sym___based] = ACTIONS(2629),
    [anon_sym___cdecl] = ACTIONS(2629),
    [anon_sym___clrcall] = ACTIONS(2629),
    [anon_sym___stdcall] = ACTIONS(2629),
    [anon_sym___fastcall] = ACTIONS(2629),
    [anon_sym___thiscall] = ACTIONS(2629),
    [anon_sym___vectorcall] = ACTIONS(2629),
    [anon_sym_LBRACE] = ACTIONS(2631),
    [anon_sym_signed] = ACTIONS(2629),
    [anon_sym_unsigned] = ACTIONS(2629),
    [anon_sym_long] = ACTIONS(2629),
    [anon_sym_short] = ACTIONS(2629),
    [anon_sym_LBRACK] = ACTIONS(2629),
    [anon_sym_static] = ACTIONS(2629),
    [anon_sym_register] = ACTIONS(2629),
    [anon_sym_inline] = ACTIONS(2629),
    [anon_sym___inline] = ACTIONS(2629),
    [anon_sym___inline__] = ACTIONS(2629),
    [anon_sym___forceinline] = ACTIONS(2629),
    [anon_sym_thread_local] = ACTIONS(2629),
    [anon_sym___thread] = ACTIONS(2629),
    [anon_sym_const] = ACTIONS(2629),
    [anon_sym_constexpr] = ACTIONS(2629),
    [anon_sym_volatile] = ACTIONS(2629),
    [anon_sym_restrict] = ACTIONS(2629),
    [anon_sym___restrict__] = ACTIONS(2629),
    [anon_sym__Atomic] = ACTIONS(2629),
    [anon_sym__Noreturn] = ACTIONS(2629),
    [anon_sym_noreturn] = ACTIONS(2629),
    [anon_sym__Nonnull] = ACTIONS(2629),
    [anon_sym_mutable] = ACTIONS(2629),
    [anon_sym_constinit] = ACTIONS(2629),
    [anon_sym_consteval] = ACTIONS(2629),
    [anon_sym_alignas] = ACTIONS(2629),
    [anon_sym__Alignas] = ACTIONS(2629),
    [sym_primitive_type] = ACTIONS(2629),
    [anon_sym_enum] = ACTIONS(2629),
    [anon_sym_class] = ACTIONS(2629),
    [anon_sym_struct] = ACTIONS(2629),
    [anon_sym_union] = ACTIONS(2629),
    [anon_sym_if] = ACTIONS(2629),
    [anon_sym_else] = ACTIONS(2629),
    [anon_sym_switch] = ACTIONS(2629),
    [anon_sym_case] = ACTIONS(2629),
    [anon_sym_default] = ACTIONS(2629),
    [anon_sym_while] = ACTIONS(2629),
    [anon_sym_do] = ACTIONS(2629),
    [anon_sym_for] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(2629),
    [anon_sym_break] = ACTIONS(2629),
    [anon_sym_continue] = ACTIONS(2629),
    [anon_sym_goto] = ACTIONS(2629),
    [anon_sym___try] = ACTIONS(2629),
    [anon_sym___leave] = ACTIONS(2629),
    [anon_sym_not] = ACTIONS(2629),
    [anon_sym_compl] = ACTIONS(2629),
    [anon_sym_DASH_DASH] = ACTIONS(2631),
    [anon_sym_PLUS_PLUS] = ACTIONS(2631),
    [anon_sym_sizeof] = ACTIONS(2629),
    [anon_sym___alignof__] = ACTIONS(2629),
    [anon_sym___alignof] = ACTIONS(2629),
    [anon_sym__alignof] = ACTIONS(2629),
    [anon_sym_alignof] = ACTIONS(2629),
    [anon_sym__Alignof] = ACTIONS(2629),
    [anon_sym_offsetof] = ACTIONS(2629),
    [anon_sym__Generic] = ACTIONS(2629),
    [anon_sym_asm] = ACTIONS(2629),
    [anon_sym___asm__] = ACTIONS(2629),
    [anon_sym___asm] = ACTIONS(2629),
    [sym_number_literal] = ACTIONS(2631),
    [anon_sym_L_SQUOTE] = ACTIONS(2631),
    [anon_sym_u_SQUOTE] = ACTIONS(2631),
    [anon_sym_U_SQUOTE] = ACTIONS(2631),
    [anon_sym_u8_SQUOTE] = ACTIONS(2631),
    [anon_sym_SQUOTE] = ACTIONS(2631),
    [anon_sym_L_DQUOTE] = ACTIONS(2631),
    [anon_sym_u_DQUOTE] = ACTIONS(2631),
    [anon_sym_U_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8_DQUOTE] = ACTIONS(2631),
    [anon_sym_DQUOTE] = ACTIONS(2631),
    [sym_true] = ACTIONS(2629),
    [sym_false] = ACTIONS(2629),
    [anon_sym_NULL] = ACTIONS(2629),
    [anon_sym_nullptr] = ACTIONS(2629),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2629),
    [anon_sym_decltype] = ACTIONS(2629),
    [anon_sym_explicit] = ACTIONS(2629),
    [anon_sym_typename] = ACTIONS(2629),
    [anon_sym_template] = ACTIONS(2629),
    [anon_sym_operator] = ACTIONS(2629),
    [anon_sym_try] = ACTIONS(2629),
    [anon_sym_delete] = ACTIONS(2629),
    [anon_sym_throw] = ACTIONS(2629),
    [anon_sym_namespace] = ACTIONS(2629),
    [anon_sym_using] = ACTIONS(2629),
    [anon_sym_static_assert] = ACTIONS(2629),
    [anon_sym_concept] = ACTIONS(2629),
    [anon_sym_co_return] = ACTIONS(2629),
    [anon_sym_co_yield] = ACTIONS(2629),
    [anon_sym_R_DQUOTE] = ACTIONS(2631),
    [anon_sym_LR_DQUOTE] = ACTIONS(2631),
    [anon_sym_uR_DQUOTE] = ACTIONS(2631),
    [anon_sym_UR_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2631),
    [anon_sym_co_await] = ACTIONS(2629),
    [anon_sym_new] = ACTIONS(2629),
    [anon_sym_requires] = ACTIONS(2629),
    [sym_this] = ACTIONS(2629),
  },
  [246] = {
    [sym_identifier] = ACTIONS(2633),
    [aux_sym_preproc_include_token1] = ACTIONS(2633),
    [aux_sym_preproc_def_token1] = ACTIONS(2633),
    [aux_sym_preproc_if_token1] = ACTIONS(2633),
    [aux_sym_preproc_if_token2] = ACTIONS(2633),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2633),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2633),
    [aux_sym_preproc_else_token1] = ACTIONS(2633),
    [aux_sym_preproc_elif_token1] = ACTIONS(2633),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2633),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2633),
    [sym_preproc_directive] = ACTIONS(2633),
    [anon_sym_LPAREN2] = ACTIONS(2635),
    [anon_sym_BANG] = ACTIONS(2635),
    [anon_sym_TILDE] = ACTIONS(2635),
    [anon_sym_DASH] = ACTIONS(2633),
    [anon_sym_PLUS] = ACTIONS(2633),
    [anon_sym_STAR] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2635),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_SEMI] = ACTIONS(2635),
    [anon_sym___extension__] = ACTIONS(2633),
    [anon_sym_typedef] = ACTIONS(2633),
    [anon_sym_virtual] = ACTIONS(2633),
    [anon_sym_extern] = ACTIONS(2633),
    [anon_sym___attribute__] = ACTIONS(2633),
    [anon_sym___attribute] = ACTIONS(2633),
    [anon_sym_COLON_COLON] = ACTIONS(2635),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2635),
    [anon_sym___declspec] = ACTIONS(2633),
    [anon_sym___based] = ACTIONS(2633),
    [anon_sym___cdecl] = ACTIONS(2633),
    [anon_sym___clrcall] = ACTIONS(2633),
    [anon_sym___stdcall] = ACTIONS(2633),
    [anon_sym___fastcall] = ACTIONS(2633),
    [anon_sym___thiscall] = ACTIONS(2633),
    [anon_sym___vectorcall] = ACTIONS(2633),
    [anon_sym_LBRACE] = ACTIONS(2635),
    [anon_sym_signed] = ACTIONS(2633),
    [anon_sym_unsigned] = ACTIONS(2633),
    [anon_sym_long] = ACTIONS(2633),
    [anon_sym_short] = ACTIONS(2633),
    [anon_sym_LBRACK] = ACTIONS(2633),
    [anon_sym_static] = ACTIONS(2633),
    [anon_sym_register] = ACTIONS(2633),
    [anon_sym_inline] = ACTIONS(2633),
    [anon_sym___inline] = ACTIONS(2633),
    [anon_sym___inline__] = ACTIONS(2633),
    [anon_sym___forceinline] = ACTIONS(2633),
    [anon_sym_thread_local] = ACTIONS(2633),
    [anon_sym___thread] = ACTIONS(2633),
    [anon_sym_const] = ACTIONS(2633),
    [anon_sym_constexpr] = ACTIONS(2633),
    [anon_sym_volatile] = ACTIONS(2633),
    [anon_sym_restrict] = ACTIONS(2633),
    [anon_sym___restrict__] = ACTIONS(2633),
    [anon_sym__Atomic] = ACTIONS(2633),
    [anon_sym__Noreturn] = ACTIONS(2633),
    [anon_sym_noreturn] = ACTIONS(2633),
    [anon_sym__Nonnull] = ACTIONS(2633),
    [anon_sym_mutable] = ACTIONS(2633),
    [anon_sym_constinit] = ACTIONS(2633),
    [anon_sym_consteval] = ACTIONS(2633),
    [anon_sym_alignas] = ACTIONS(2633),
    [anon_sym__Alignas] = ACTIONS(2633),
    [sym_primitive_type] = ACTIONS(2633),
    [anon_sym_enum] = ACTIONS(2633),
    [anon_sym_class] = ACTIONS(2633),
    [anon_sym_struct] = ACTIONS(2633),
    [anon_sym_union] = ACTIONS(2633),
    [anon_sym_if] = ACTIONS(2633),
    [anon_sym_else] = ACTIONS(2633),
    [anon_sym_switch] = ACTIONS(2633),
    [anon_sym_case] = ACTIONS(2633),
    [anon_sym_default] = ACTIONS(2633),
    [anon_sym_while] = ACTIONS(2633),
    [anon_sym_do] = ACTIONS(2633),
    [anon_sym_for] = ACTIONS(2633),
    [anon_sym_return] = ACTIONS(2633),
    [anon_sym_break] = ACTIONS(2633),
    [anon_sym_continue] = ACTIONS(2633),
    [anon_sym_goto] = ACTIONS(2633),
    [anon_sym___try] = ACTIONS(2633),
    [anon_sym___leave] = ACTIONS(2633),
    [anon_sym_not] = ACTIONS(2633),
    [anon_sym_compl] = ACTIONS(2633),
    [anon_sym_DASH_DASH] = ACTIONS(2635),
    [anon_sym_PLUS_PLUS] = ACTIONS(2635),
    [anon_sym_sizeof] = ACTIONS(2633),
    [anon_sym___alignof__] = ACTIONS(2633),
    [anon_sym___alignof] = ACTIONS(2633),
    [anon_sym__alignof] = ACTIONS(2633),
    [anon_sym_alignof] = ACTIONS(2633),
    [anon_sym__Alignof] = ACTIONS(2633),
    [anon_sym_offsetof] = ACTIONS(2633),
    [anon_sym__Generic] = ACTIONS(2633),
    [anon_sym_asm] = ACTIONS(2633),
    [anon_sym___asm__] = ACTIONS(2633),
    [anon_sym___asm] = ACTIONS(2633),
    [sym_number_literal] = ACTIONS(2635),
    [anon_sym_L_SQUOTE] = ACTIONS(2635),
    [anon_sym_u_SQUOTE] = ACTIONS(2635),
    [anon_sym_U_SQUOTE] = ACTIONS(2635),
    [anon_sym_u8_SQUOTE] = ACTIONS(2635),
    [anon_sym_SQUOTE] = ACTIONS(2635),
    [anon_sym_L_DQUOTE] = ACTIONS(2635),
    [anon_sym_u_DQUOTE] = ACTIONS(2635),
    [anon_sym_U_DQUOTE] = ACTIONS(2635),
    [anon_sym_u8_DQUOTE] = ACTIONS(2635),
    [anon_sym_DQUOTE] = ACTIONS(2635),
    [sym_true] = ACTIONS(2633),
    [sym_false] = ACTIONS(2633),
    [anon_sym_NULL] = ACTIONS(2633),
    [anon_sym_nullptr] = ACTIONS(2633),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2633),
    [anon_sym_decltype] = ACTIONS(2633),
    [anon_sym_explicit] = ACTIONS(2633),
    [anon_sym_typename] = ACTIONS(2633),
    [anon_sym_template] = ACTIONS(2633),
    [anon_sym_operator] = ACTIONS(2633),
    [anon_sym_try] = ACTIONS(2633),
    [anon_sym_delete] = ACTIONS(2633),
    [anon_sym_throw] = ACTIONS(2633),
    [anon_sym_namespace] = ACTIONS(2633),
    [anon_sym_using] = ACTIONS(2633),
    [anon_sym_static_assert] = ACTIONS(2633),
    [anon_sym_concept] = ACTIONS(2633),
    [anon_sym_co_return] = ACTIONS(2633),
    [anon_sym_co_yield] = ACTIONS(2633),
    [anon_sym_R_DQUOTE] = ACTIONS(2635),
    [anon_sym_LR_DQUOTE] = ACTIONS(2635),
    [anon_sym_uR_DQUOTE] = ACTIONS(2635),
    [anon_sym_UR_DQUOTE] = ACTIONS(2635),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2635),
    [anon_sym_co_await] = ACTIONS(2633),
    [anon_sym_new] = ACTIONS(2633),
    [anon_sym_requires] = ACTIONS(2633),
    [sym_this] = ACTIONS(2633),
  },
  [247] = {
    [sym_identifier] = ACTIONS(2637),
    [aux_sym_preproc_include_token1] = ACTIONS(2637),
    [aux_sym_preproc_def_token1] = ACTIONS(2637),
    [aux_sym_preproc_if_token1] = ACTIONS(2637),
    [aux_sym_preproc_if_token2] = ACTIONS(2637),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2637),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2637),
    [aux_sym_preproc_else_token1] = ACTIONS(2637),
    [aux_sym_preproc_elif_token1] = ACTIONS(2637),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2637),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2637),
    [sym_preproc_directive] = ACTIONS(2637),
    [anon_sym_LPAREN2] = ACTIONS(2639),
    [anon_sym_BANG] = ACTIONS(2639),
    [anon_sym_TILDE] = ACTIONS(2639),
    [anon_sym_DASH] = ACTIONS(2637),
    [anon_sym_PLUS] = ACTIONS(2637),
    [anon_sym_STAR] = ACTIONS(2639),
    [anon_sym_AMP_AMP] = ACTIONS(2639),
    [anon_sym_AMP] = ACTIONS(2637),
    [anon_sym_SEMI] = ACTIONS(2639),
    [anon_sym___extension__] = ACTIONS(2637),
    [anon_sym_typedef] = ACTIONS(2637),
    [anon_sym_virtual] = ACTIONS(2637),
    [anon_sym_extern] = ACTIONS(2637),
    [anon_sym___attribute__] = ACTIONS(2637),
    [anon_sym___attribute] = ACTIONS(2637),
    [anon_sym_COLON_COLON] = ACTIONS(2639),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2639),
    [anon_sym___declspec] = ACTIONS(2637),
    [anon_sym___based] = ACTIONS(2637),
    [anon_sym___cdecl] = ACTIONS(2637),
    [anon_sym___clrcall] = ACTIONS(2637),
    [anon_sym___stdcall] = ACTIONS(2637),
    [anon_sym___fastcall] = ACTIONS(2637),
    [anon_sym___thiscall] = ACTIONS(2637),
    [anon_sym___vectorcall] = ACTIONS(2637),
    [anon_sym_LBRACE] = ACTIONS(2639),
    [anon_sym_signed] = ACTIONS(2637),
    [anon_sym_unsigned] = ACTIONS(2637),
    [anon_sym_long] = ACTIONS(2637),
    [anon_sym_short] = ACTIONS(2637),
    [anon_sym_LBRACK] = ACTIONS(2637),
    [anon_sym_static] = ACTIONS(2637),
    [anon_sym_register] = ACTIONS(2637),
    [anon_sym_inline] = ACTIONS(2637),
    [anon_sym___inline] = ACTIONS(2637),
    [anon_sym___inline__] = ACTIONS(2637),
    [anon_sym___forceinline] = ACTIONS(2637),
    [anon_sym_thread_local] = ACTIONS(2637),
    [anon_sym___thread] = ACTIONS(2637),
    [anon_sym_const] = ACTIONS(2637),
    [anon_sym_constexpr] = ACTIONS(2637),
    [anon_sym_volatile] = ACTIONS(2637),
    [anon_sym_restrict] = ACTIONS(2637),
    [anon_sym___restrict__] = ACTIONS(2637),
    [anon_sym__Atomic] = ACTIONS(2637),
    [anon_sym__Noreturn] = ACTIONS(2637),
    [anon_sym_noreturn] = ACTIONS(2637),
    [anon_sym__Nonnull] = ACTIONS(2637),
    [anon_sym_mutable] = ACTIONS(2637),
    [anon_sym_constinit] = ACTIONS(2637),
    [anon_sym_consteval] = ACTIONS(2637),
    [anon_sym_alignas] = ACTIONS(2637),
    [anon_sym__Alignas] = ACTIONS(2637),
    [sym_primitive_type] = ACTIONS(2637),
    [anon_sym_enum] = ACTIONS(2637),
    [anon_sym_class] = ACTIONS(2637),
    [anon_sym_struct] = ACTIONS(2637),
    [anon_sym_union] = ACTIONS(2637),
    [anon_sym_if] = ACTIONS(2637),
    [anon_sym_else] = ACTIONS(2637),
    [anon_sym_switch] = ACTIONS(2637),
    [anon_sym_case] = ACTIONS(2637),
    [anon_sym_default] = ACTIONS(2637),
    [anon_sym_while] = ACTIONS(2637),
    [anon_sym_do] = ACTIONS(2637),
    [anon_sym_for] = ACTIONS(2637),
    [anon_sym_return] = ACTIONS(2637),
    [anon_sym_break] = ACTIONS(2637),
    [anon_sym_continue] = ACTIONS(2637),
    [anon_sym_goto] = ACTIONS(2637),
    [anon_sym___try] = ACTIONS(2637),
    [anon_sym___leave] = ACTIONS(2637),
    [anon_sym_not] = ACTIONS(2637),
    [anon_sym_compl] = ACTIONS(2637),
    [anon_sym_DASH_DASH] = ACTIONS(2639),
    [anon_sym_PLUS_PLUS] = ACTIONS(2639),
    [anon_sym_sizeof] = ACTIONS(2637),
    [anon_sym___alignof__] = ACTIONS(2637),
    [anon_sym___alignof] = ACTIONS(2637),
    [anon_sym__alignof] = ACTIONS(2637),
    [anon_sym_alignof] = ACTIONS(2637),
    [anon_sym__Alignof] = ACTIONS(2637),
    [anon_sym_offsetof] = ACTIONS(2637),
    [anon_sym__Generic] = ACTIONS(2637),
    [anon_sym_asm] = ACTIONS(2637),
    [anon_sym___asm__] = ACTIONS(2637),
    [anon_sym___asm] = ACTIONS(2637),
    [sym_number_literal] = ACTIONS(2639),
    [anon_sym_L_SQUOTE] = ACTIONS(2639),
    [anon_sym_u_SQUOTE] = ACTIONS(2639),
    [anon_sym_U_SQUOTE] = ACTIONS(2639),
    [anon_sym_u8_SQUOTE] = ACTIONS(2639),
    [anon_sym_SQUOTE] = ACTIONS(2639),
    [anon_sym_L_DQUOTE] = ACTIONS(2639),
    [anon_sym_u_DQUOTE] = ACTIONS(2639),
    [anon_sym_U_DQUOTE] = ACTIONS(2639),
    [anon_sym_u8_DQUOTE] = ACTIONS(2639),
    [anon_sym_DQUOTE] = ACTIONS(2639),
    [sym_true] = ACTIONS(2637),
    [sym_false] = ACTIONS(2637),
    [anon_sym_NULL] = ACTIONS(2637),
    [anon_sym_nullptr] = ACTIONS(2637),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2637),
    [anon_sym_decltype] = ACTIONS(2637),
    [anon_sym_explicit] = ACTIONS(2637),
    [anon_sym_typename] = ACTIONS(2637),
    [anon_sym_template] = ACTIONS(2637),
    [anon_sym_operator] = ACTIONS(2637),
    [anon_sym_try] = ACTIONS(2637),
    [anon_sym_delete] = ACTIONS(2637),
    [anon_sym_throw] = ACTIONS(2637),
    [anon_sym_namespace] = ACTIONS(2637),
    [anon_sym_using] = ACTIONS(2637),
    [anon_sym_static_assert] = ACTIONS(2637),
    [anon_sym_concept] = ACTIONS(2637),
    [anon_sym_co_return] = ACTIONS(2637),
    [anon_sym_co_yield] = ACTIONS(2637),
    [anon_sym_R_DQUOTE] = ACTIONS(2639),
    [anon_sym_LR_DQUOTE] = ACTIONS(2639),
    [anon_sym_uR_DQUOTE] = ACTIONS(2639),
    [anon_sym_UR_DQUOTE] = ACTIONS(2639),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2639),
    [anon_sym_co_await] = ACTIONS(2637),
    [anon_sym_new] = ACTIONS(2637),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2637),
  },
  [248] = {
    [sym_identifier] = ACTIONS(2637),
    [aux_sym_preproc_include_token1] = ACTIONS(2637),
    [aux_sym_preproc_def_token1] = ACTIONS(2637),
    [aux_sym_preproc_if_token1] = ACTIONS(2637),
    [aux_sym_preproc_if_token2] = ACTIONS(2637),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2637),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2637),
    [aux_sym_preproc_else_token1] = ACTIONS(2637),
    [aux_sym_preproc_elif_token1] = ACTIONS(2637),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2637),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2637),
    [sym_preproc_directive] = ACTIONS(2637),
    [anon_sym_LPAREN2] = ACTIONS(2639),
    [anon_sym_BANG] = ACTIONS(2639),
    [anon_sym_TILDE] = ACTIONS(2639),
    [anon_sym_DASH] = ACTIONS(2637),
    [anon_sym_PLUS] = ACTIONS(2637),
    [anon_sym_STAR] = ACTIONS(2639),
    [anon_sym_AMP_AMP] = ACTIONS(2639),
    [anon_sym_AMP] = ACTIONS(2637),
    [anon_sym_SEMI] = ACTIONS(2639),
    [anon_sym___extension__] = ACTIONS(2637),
    [anon_sym_typedef] = ACTIONS(2637),
    [anon_sym_virtual] = ACTIONS(2637),
    [anon_sym_extern] = ACTIONS(2637),
    [anon_sym___attribute__] = ACTIONS(2637),
    [anon_sym___attribute] = ACTIONS(2637),
    [anon_sym_COLON_COLON] = ACTIONS(2639),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2639),
    [anon_sym___declspec] = ACTIONS(2637),
    [anon_sym___based] = ACTIONS(2637),
    [anon_sym___cdecl] = ACTIONS(2637),
    [anon_sym___clrcall] = ACTIONS(2637),
    [anon_sym___stdcall] = ACTIONS(2637),
    [anon_sym___fastcall] = ACTIONS(2637),
    [anon_sym___thiscall] = ACTIONS(2637),
    [anon_sym___vectorcall] = ACTIONS(2637),
    [anon_sym_LBRACE] = ACTIONS(2639),
    [anon_sym_signed] = ACTIONS(2637),
    [anon_sym_unsigned] = ACTIONS(2637),
    [anon_sym_long] = ACTIONS(2637),
    [anon_sym_short] = ACTIONS(2637),
    [anon_sym_LBRACK] = ACTIONS(2637),
    [anon_sym_static] = ACTIONS(2637),
    [anon_sym_register] = ACTIONS(2637),
    [anon_sym_inline] = ACTIONS(2637),
    [anon_sym___inline] = ACTIONS(2637),
    [anon_sym___inline__] = ACTIONS(2637),
    [anon_sym___forceinline] = ACTIONS(2637),
    [anon_sym_thread_local] = ACTIONS(2637),
    [anon_sym___thread] = ACTIONS(2637),
    [anon_sym_const] = ACTIONS(2637),
    [anon_sym_constexpr] = ACTIONS(2637),
    [anon_sym_volatile] = ACTIONS(2637),
    [anon_sym_restrict] = ACTIONS(2637),
    [anon_sym___restrict__] = ACTIONS(2637),
    [anon_sym__Atomic] = ACTIONS(2637),
    [anon_sym__Noreturn] = ACTIONS(2637),
    [anon_sym_noreturn] = ACTIONS(2637),
    [anon_sym__Nonnull] = ACTIONS(2637),
    [anon_sym_mutable] = ACTIONS(2637),
    [anon_sym_constinit] = ACTIONS(2637),
    [anon_sym_consteval] = ACTIONS(2637),
    [anon_sym_alignas] = ACTIONS(2637),
    [anon_sym__Alignas] = ACTIONS(2637),
    [sym_primitive_type] = ACTIONS(2637),
    [anon_sym_enum] = ACTIONS(2637),
    [anon_sym_class] = ACTIONS(2637),
    [anon_sym_struct] = ACTIONS(2637),
    [anon_sym_union] = ACTIONS(2637),
    [anon_sym_if] = ACTIONS(2637),
    [anon_sym_else] = ACTIONS(2637),
    [anon_sym_switch] = ACTIONS(2637),
    [anon_sym_case] = ACTIONS(2637),
    [anon_sym_default] = ACTIONS(2637),
    [anon_sym_while] = ACTIONS(2637),
    [anon_sym_do] = ACTIONS(2637),
    [anon_sym_for] = ACTIONS(2637),
    [anon_sym_return] = ACTIONS(2637),
    [anon_sym_break] = ACTIONS(2637),
    [anon_sym_continue] = ACTIONS(2637),
    [anon_sym_goto] = ACTIONS(2637),
    [anon_sym___try] = ACTIONS(2637),
    [anon_sym___leave] = ACTIONS(2637),
    [anon_sym_not] = ACTIONS(2637),
    [anon_sym_compl] = ACTIONS(2637),
    [anon_sym_DASH_DASH] = ACTIONS(2639),
    [anon_sym_PLUS_PLUS] = ACTIONS(2639),
    [anon_sym_sizeof] = ACTIONS(2637),
    [anon_sym___alignof__] = ACTIONS(2637),
    [anon_sym___alignof] = ACTIONS(2637),
    [anon_sym__alignof] = ACTIONS(2637),
    [anon_sym_alignof] = ACTIONS(2637),
    [anon_sym__Alignof] = ACTIONS(2637),
    [anon_sym_offsetof] = ACTIONS(2637),
    [anon_sym__Generic] = ACTIONS(2637),
    [anon_sym_asm] = ACTIONS(2637),
    [anon_sym___asm__] = ACTIONS(2637),
    [anon_sym___asm] = ACTIONS(2637),
    [sym_number_literal] = ACTIONS(2639),
    [anon_sym_L_SQUOTE] = ACTIONS(2639),
    [anon_sym_u_SQUOTE] = ACTIONS(2639),
    [anon_sym_U_SQUOTE] = ACTIONS(2639),
    [anon_sym_u8_SQUOTE] = ACTIONS(2639),
    [anon_sym_SQUOTE] = ACTIONS(2639),
    [anon_sym_L_DQUOTE] = ACTIONS(2639),
    [anon_sym_u_DQUOTE] = ACTIONS(2639),
    [anon_sym_U_DQUOTE] = ACTIONS(2639),
    [anon_sym_u8_DQUOTE] = ACTIONS(2639),
    [anon_sym_DQUOTE] = ACTIONS(2639),
    [sym_true] = ACTIONS(2637),
    [sym_false] = ACTIONS(2637),
    [anon_sym_NULL] = ACTIONS(2637),
    [anon_sym_nullptr] = ACTIONS(2637),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2637),
    [anon_sym_decltype] = ACTIONS(2637),
    [anon_sym_explicit] = ACTIONS(2637),
    [anon_sym_typename] = ACTIONS(2637),
    [anon_sym_template] = ACTIONS(2637),
    [anon_sym_operator] = ACTIONS(2637),
    [anon_sym_try] = ACTIONS(2637),
    [anon_sym_delete] = ACTIONS(2637),
    [anon_sym_throw] = ACTIONS(2637),
    [anon_sym_namespace] = ACTIONS(2637),
    [anon_sym_using] = ACTIONS(2637),
    [anon_sym_static_assert] = ACTIONS(2637),
    [anon_sym_concept] = ACTIONS(2637),
    [anon_sym_co_return] = ACTIONS(2637),
    [anon_sym_co_yield] = ACTIONS(2637),
    [anon_sym_R_DQUOTE] = ACTIONS(2639),
    [anon_sym_LR_DQUOTE] = ACTIONS(2639),
    [anon_sym_uR_DQUOTE] = ACTIONS(2639),
    [anon_sym_UR_DQUOTE] = ACTIONS(2639),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2639),
    [anon_sym_co_await] = ACTIONS(2637),
    [anon_sym_new] = ACTIONS(2637),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2637),
  },
  [249] = {
    [sym_identifier] = ACTIONS(2641),
    [aux_sym_preproc_include_token1] = ACTIONS(2641),
    [aux_sym_preproc_def_token1] = ACTIONS(2641),
    [aux_sym_preproc_if_token1] = ACTIONS(2641),
    [aux_sym_preproc_if_token2] = ACTIONS(2641),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2641),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2641),
    [aux_sym_preproc_else_token1] = ACTIONS(2641),
    [aux_sym_preproc_elif_token1] = ACTIONS(2641),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2641),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2641),
    [sym_preproc_directive] = ACTIONS(2641),
    [anon_sym_LPAREN2] = ACTIONS(2643),
    [anon_sym_BANG] = ACTIONS(2643),
    [anon_sym_TILDE] = ACTIONS(2643),
    [anon_sym_DASH] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(2641),
    [anon_sym_STAR] = ACTIONS(2643),
    [anon_sym_AMP_AMP] = ACTIONS(2643),
    [anon_sym_AMP] = ACTIONS(2641),
    [anon_sym_SEMI] = ACTIONS(2643),
    [anon_sym___extension__] = ACTIONS(2641),
    [anon_sym_typedef] = ACTIONS(2641),
    [anon_sym_virtual] = ACTIONS(2641),
    [anon_sym_extern] = ACTIONS(2641),
    [anon_sym___attribute__] = ACTIONS(2641),
    [anon_sym___attribute] = ACTIONS(2641),
    [anon_sym_COLON_COLON] = ACTIONS(2643),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2643),
    [anon_sym___declspec] = ACTIONS(2641),
    [anon_sym___based] = ACTIONS(2641),
    [anon_sym___cdecl] = ACTIONS(2641),
    [anon_sym___clrcall] = ACTIONS(2641),
    [anon_sym___stdcall] = ACTIONS(2641),
    [anon_sym___fastcall] = ACTIONS(2641),
    [anon_sym___thiscall] = ACTIONS(2641),
    [anon_sym___vectorcall] = ACTIONS(2641),
    [anon_sym_LBRACE] = ACTIONS(2643),
    [anon_sym_signed] = ACTIONS(2641),
    [anon_sym_unsigned] = ACTIONS(2641),
    [anon_sym_long] = ACTIONS(2641),
    [anon_sym_short] = ACTIONS(2641),
    [anon_sym_LBRACK] = ACTIONS(2641),
    [anon_sym_static] = ACTIONS(2641),
    [anon_sym_register] = ACTIONS(2641),
    [anon_sym_inline] = ACTIONS(2641),
    [anon_sym___inline] = ACTIONS(2641),
    [anon_sym___inline__] = ACTIONS(2641),
    [anon_sym___forceinline] = ACTIONS(2641),
    [anon_sym_thread_local] = ACTIONS(2641),
    [anon_sym___thread] = ACTIONS(2641),
    [anon_sym_const] = ACTIONS(2641),
    [anon_sym_constexpr] = ACTIONS(2641),
    [anon_sym_volatile] = ACTIONS(2641),
    [anon_sym_restrict] = ACTIONS(2641),
    [anon_sym___restrict__] = ACTIONS(2641),
    [anon_sym__Atomic] = ACTIONS(2641),
    [anon_sym__Noreturn] = ACTIONS(2641),
    [anon_sym_noreturn] = ACTIONS(2641),
    [anon_sym__Nonnull] = ACTIONS(2641),
    [anon_sym_mutable] = ACTIONS(2641),
    [anon_sym_constinit] = ACTIONS(2641),
    [anon_sym_consteval] = ACTIONS(2641),
    [anon_sym_alignas] = ACTIONS(2641),
    [anon_sym__Alignas] = ACTIONS(2641),
    [sym_primitive_type] = ACTIONS(2641),
    [anon_sym_enum] = ACTIONS(2641),
    [anon_sym_class] = ACTIONS(2641),
    [anon_sym_struct] = ACTIONS(2641),
    [anon_sym_union] = ACTIONS(2641),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_else] = ACTIONS(2641),
    [anon_sym_switch] = ACTIONS(2641),
    [anon_sym_case] = ACTIONS(2641),
    [anon_sym_default] = ACTIONS(2641),
    [anon_sym_while] = ACTIONS(2641),
    [anon_sym_do] = ACTIONS(2641),
    [anon_sym_for] = ACTIONS(2641),
    [anon_sym_return] = ACTIONS(2641),
    [anon_sym_break] = ACTIONS(2641),
    [anon_sym_continue] = ACTIONS(2641),
    [anon_sym_goto] = ACTIONS(2641),
    [anon_sym___try] = ACTIONS(2641),
    [anon_sym___leave] = ACTIONS(2641),
    [anon_sym_not] = ACTIONS(2641),
    [anon_sym_compl] = ACTIONS(2641),
    [anon_sym_DASH_DASH] = ACTIONS(2643),
    [anon_sym_PLUS_PLUS] = ACTIONS(2643),
    [anon_sym_sizeof] = ACTIONS(2641),
    [anon_sym___alignof__] = ACTIONS(2641),
    [anon_sym___alignof] = ACTIONS(2641),
    [anon_sym__alignof] = ACTIONS(2641),
    [anon_sym_alignof] = ACTIONS(2641),
    [anon_sym__Alignof] = ACTIONS(2641),
    [anon_sym_offsetof] = ACTIONS(2641),
    [anon_sym__Generic] = ACTIONS(2641),
    [anon_sym_asm] = ACTIONS(2641),
    [anon_sym___asm__] = ACTIONS(2641),
    [anon_sym___asm] = ACTIONS(2641),
    [sym_number_literal] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2643),
    [anon_sym_u_SQUOTE] = ACTIONS(2643),
    [anon_sym_U_SQUOTE] = ACTIONS(2643),
    [anon_sym_u8_SQUOTE] = ACTIONS(2643),
    [anon_sym_SQUOTE] = ACTIONS(2643),
    [anon_sym_L_DQUOTE] = ACTIONS(2643),
    [anon_sym_u_DQUOTE] = ACTIONS(2643),
    [anon_sym_U_DQUOTE] = ACTIONS(2643),
    [anon_sym_u8_DQUOTE] = ACTIONS(2643),
    [anon_sym_DQUOTE] = ACTIONS(2643),
    [sym_true] = ACTIONS(2641),
    [sym_false] = ACTIONS(2641),
    [anon_sym_NULL] = ACTIONS(2641),
    [anon_sym_nullptr] = ACTIONS(2641),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2641),
    [anon_sym_decltype] = ACTIONS(2641),
    [anon_sym_explicit] = ACTIONS(2641),
    [anon_sym_typename] = ACTIONS(2641),
    [anon_sym_template] = ACTIONS(2641),
    [anon_sym_operator] = ACTIONS(2641),
    [anon_sym_try] = ACTIONS(2641),
    [anon_sym_delete] = ACTIONS(2641),
    [anon_sym_throw] = ACTIONS(2641),
    [anon_sym_namespace] = ACTIONS(2641),
    [anon_sym_using] = ACTIONS(2641),
    [anon_sym_static_assert] = ACTIONS(2641),
    [anon_sym_concept] = ACTIONS(2641),
    [anon_sym_co_return] = ACTIONS(2641),
    [anon_sym_co_yield] = ACTIONS(2641),
    [anon_sym_R_DQUOTE] = ACTIONS(2643),
    [anon_sym_LR_DQUOTE] = ACTIONS(2643),
    [anon_sym_uR_DQUOTE] = ACTIONS(2643),
    [anon_sym_UR_DQUOTE] = ACTIONS(2643),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2643),
    [anon_sym_co_await] = ACTIONS(2641),
    [anon_sym_new] = ACTIONS(2641),
    [anon_sym_requires] = ACTIONS(2641),
    [sym_this] = ACTIONS(2641),
  },
  [250] = {
    [sym_identifier] = ACTIONS(2645),
    [aux_sym_preproc_include_token1] = ACTIONS(2645),
    [aux_sym_preproc_def_token1] = ACTIONS(2645),
    [aux_sym_preproc_if_token1] = ACTIONS(2645),
    [aux_sym_preproc_if_token2] = ACTIONS(2645),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2645),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2645),
    [aux_sym_preproc_else_token1] = ACTIONS(2645),
    [aux_sym_preproc_elif_token1] = ACTIONS(2645),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2645),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2645),
    [sym_preproc_directive] = ACTIONS(2645),
    [anon_sym_LPAREN2] = ACTIONS(2647),
    [anon_sym_BANG] = ACTIONS(2647),
    [anon_sym_TILDE] = ACTIONS(2647),
    [anon_sym_DASH] = ACTIONS(2645),
    [anon_sym_PLUS] = ACTIONS(2645),
    [anon_sym_STAR] = ACTIONS(2647),
    [anon_sym_AMP_AMP] = ACTIONS(2647),
    [anon_sym_AMP] = ACTIONS(2645),
    [anon_sym_SEMI] = ACTIONS(2647),
    [anon_sym___extension__] = ACTIONS(2645),
    [anon_sym_typedef] = ACTIONS(2645),
    [anon_sym_virtual] = ACTIONS(2645),
    [anon_sym_extern] = ACTIONS(2645),
    [anon_sym___attribute__] = ACTIONS(2645),
    [anon_sym___attribute] = ACTIONS(2645),
    [anon_sym_COLON_COLON] = ACTIONS(2647),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2647),
    [anon_sym___declspec] = ACTIONS(2645),
    [anon_sym___based] = ACTIONS(2645),
    [anon_sym___cdecl] = ACTIONS(2645),
    [anon_sym___clrcall] = ACTIONS(2645),
    [anon_sym___stdcall] = ACTIONS(2645),
    [anon_sym___fastcall] = ACTIONS(2645),
    [anon_sym___thiscall] = ACTIONS(2645),
    [anon_sym___vectorcall] = ACTIONS(2645),
    [anon_sym_LBRACE] = ACTIONS(2647),
    [anon_sym_signed] = ACTIONS(2645),
    [anon_sym_unsigned] = ACTIONS(2645),
    [anon_sym_long] = ACTIONS(2645),
    [anon_sym_short] = ACTIONS(2645),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_static] = ACTIONS(2645),
    [anon_sym_register] = ACTIONS(2645),
    [anon_sym_inline] = ACTIONS(2645),
    [anon_sym___inline] = ACTIONS(2645),
    [anon_sym___inline__] = ACTIONS(2645),
    [anon_sym___forceinline] = ACTIONS(2645),
    [anon_sym_thread_local] = ACTIONS(2645),
    [anon_sym___thread] = ACTIONS(2645),
    [anon_sym_const] = ACTIONS(2645),
    [anon_sym_constexpr] = ACTIONS(2645),
    [anon_sym_volatile] = ACTIONS(2645),
    [anon_sym_restrict] = ACTIONS(2645),
    [anon_sym___restrict__] = ACTIONS(2645),
    [anon_sym__Atomic] = ACTIONS(2645),
    [anon_sym__Noreturn] = ACTIONS(2645),
    [anon_sym_noreturn] = ACTIONS(2645),
    [anon_sym__Nonnull] = ACTIONS(2645),
    [anon_sym_mutable] = ACTIONS(2645),
    [anon_sym_constinit] = ACTIONS(2645),
    [anon_sym_consteval] = ACTIONS(2645),
    [anon_sym_alignas] = ACTIONS(2645),
    [anon_sym__Alignas] = ACTIONS(2645),
    [sym_primitive_type] = ACTIONS(2645),
    [anon_sym_enum] = ACTIONS(2645),
    [anon_sym_class] = ACTIONS(2645),
    [anon_sym_struct] = ACTIONS(2645),
    [anon_sym_union] = ACTIONS(2645),
    [anon_sym_if] = ACTIONS(2645),
    [anon_sym_else] = ACTIONS(2645),
    [anon_sym_switch] = ACTIONS(2645),
    [anon_sym_case] = ACTIONS(2645),
    [anon_sym_default] = ACTIONS(2645),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_do] = ACTIONS(2645),
    [anon_sym_for] = ACTIONS(2645),
    [anon_sym_return] = ACTIONS(2645),
    [anon_sym_break] = ACTIONS(2645),
    [anon_sym_continue] = ACTIONS(2645),
    [anon_sym_goto] = ACTIONS(2645),
    [anon_sym___try] = ACTIONS(2645),
    [anon_sym___leave] = ACTIONS(2645),
    [anon_sym_not] = ACTIONS(2645),
    [anon_sym_compl] = ACTIONS(2645),
    [anon_sym_DASH_DASH] = ACTIONS(2647),
    [anon_sym_PLUS_PLUS] = ACTIONS(2647),
    [anon_sym_sizeof] = ACTIONS(2645),
    [anon_sym___alignof__] = ACTIONS(2645),
    [anon_sym___alignof] = ACTIONS(2645),
    [anon_sym__alignof] = ACTIONS(2645),
    [anon_sym_alignof] = ACTIONS(2645),
    [anon_sym__Alignof] = ACTIONS(2645),
    [anon_sym_offsetof] = ACTIONS(2645),
    [anon_sym__Generic] = ACTIONS(2645),
    [anon_sym_asm] = ACTIONS(2645),
    [anon_sym___asm__] = ACTIONS(2645),
    [anon_sym___asm] = ACTIONS(2645),
    [sym_number_literal] = ACTIONS(2647),
    [anon_sym_L_SQUOTE] = ACTIONS(2647),
    [anon_sym_u_SQUOTE] = ACTIONS(2647),
    [anon_sym_U_SQUOTE] = ACTIONS(2647),
    [anon_sym_u8_SQUOTE] = ACTIONS(2647),
    [anon_sym_SQUOTE] = ACTIONS(2647),
    [anon_sym_L_DQUOTE] = ACTIONS(2647),
    [anon_sym_u_DQUOTE] = ACTIONS(2647),
    [anon_sym_U_DQUOTE] = ACTIONS(2647),
    [anon_sym_u8_DQUOTE] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(2647),
    [sym_true] = ACTIONS(2645),
    [sym_false] = ACTIONS(2645),
    [anon_sym_NULL] = ACTIONS(2645),
    [anon_sym_nullptr] = ACTIONS(2645),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2645),
    [anon_sym_decltype] = ACTIONS(2645),
    [anon_sym_explicit] = ACTIONS(2645),
    [anon_sym_typename] = ACTIONS(2645),
    [anon_sym_template] = ACTIONS(2645),
    [anon_sym_operator] = ACTIONS(2645),
    [anon_sym_try] = ACTIONS(2645),
    [anon_sym_delete] = ACTIONS(2645),
    [anon_sym_throw] = ACTIONS(2645),
    [anon_sym_namespace] = ACTIONS(2645),
    [anon_sym_using] = ACTIONS(2645),
    [anon_sym_static_assert] = ACTIONS(2645),
    [anon_sym_concept] = ACTIONS(2645),
    [anon_sym_co_return] = ACTIONS(2645),
    [anon_sym_co_yield] = ACTIONS(2645),
    [anon_sym_R_DQUOTE] = ACTIONS(2647),
    [anon_sym_LR_DQUOTE] = ACTIONS(2647),
    [anon_sym_uR_DQUOTE] = ACTIONS(2647),
    [anon_sym_UR_DQUOTE] = ACTIONS(2647),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2647),
    [anon_sym_co_await] = ACTIONS(2645),
    [anon_sym_new] = ACTIONS(2645),
    [anon_sym_requires] = ACTIONS(2645),
    [sym_this] = ACTIONS(2645),
  },
  [251] = {
    [sym_identifier] = ACTIONS(2649),
    [aux_sym_preproc_include_token1] = ACTIONS(2649),
    [aux_sym_preproc_def_token1] = ACTIONS(2649),
    [aux_sym_preproc_if_token1] = ACTIONS(2649),
    [aux_sym_preproc_if_token2] = ACTIONS(2649),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2649),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2649),
    [aux_sym_preproc_else_token1] = ACTIONS(2649),
    [aux_sym_preproc_elif_token1] = ACTIONS(2649),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2649),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2649),
    [sym_preproc_directive] = ACTIONS(2649),
    [anon_sym_LPAREN2] = ACTIONS(2651),
    [anon_sym_BANG] = ACTIONS(2651),
    [anon_sym_TILDE] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2651),
    [anon_sym_AMP_AMP] = ACTIONS(2651),
    [anon_sym_AMP] = ACTIONS(2649),
    [anon_sym_SEMI] = ACTIONS(2651),
    [anon_sym___extension__] = ACTIONS(2649),
    [anon_sym_typedef] = ACTIONS(2649),
    [anon_sym_virtual] = ACTIONS(2649),
    [anon_sym_extern] = ACTIONS(2649),
    [anon_sym___attribute__] = ACTIONS(2649),
    [anon_sym___attribute] = ACTIONS(2649),
    [anon_sym_COLON_COLON] = ACTIONS(2651),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2651),
    [anon_sym___declspec] = ACTIONS(2649),
    [anon_sym___based] = ACTIONS(2649),
    [anon_sym___cdecl] = ACTIONS(2649),
    [anon_sym___clrcall] = ACTIONS(2649),
    [anon_sym___stdcall] = ACTIONS(2649),
    [anon_sym___fastcall] = ACTIONS(2649),
    [anon_sym___thiscall] = ACTIONS(2649),
    [anon_sym___vectorcall] = ACTIONS(2649),
    [anon_sym_LBRACE] = ACTIONS(2651),
    [anon_sym_signed] = ACTIONS(2649),
    [anon_sym_unsigned] = ACTIONS(2649),
    [anon_sym_long] = ACTIONS(2649),
    [anon_sym_short] = ACTIONS(2649),
    [anon_sym_LBRACK] = ACTIONS(2649),
    [anon_sym_static] = ACTIONS(2649),
    [anon_sym_register] = ACTIONS(2649),
    [anon_sym_inline] = ACTIONS(2649),
    [anon_sym___inline] = ACTIONS(2649),
    [anon_sym___inline__] = ACTIONS(2649),
    [anon_sym___forceinline] = ACTIONS(2649),
    [anon_sym_thread_local] = ACTIONS(2649),
    [anon_sym___thread] = ACTIONS(2649),
    [anon_sym_const] = ACTIONS(2649),
    [anon_sym_constexpr] = ACTIONS(2649),
    [anon_sym_volatile] = ACTIONS(2649),
    [anon_sym_restrict] = ACTIONS(2649),
    [anon_sym___restrict__] = ACTIONS(2649),
    [anon_sym__Atomic] = ACTIONS(2649),
    [anon_sym__Noreturn] = ACTIONS(2649),
    [anon_sym_noreturn] = ACTIONS(2649),
    [anon_sym__Nonnull] = ACTIONS(2649),
    [anon_sym_mutable] = ACTIONS(2649),
    [anon_sym_constinit] = ACTIONS(2649),
    [anon_sym_consteval] = ACTIONS(2649),
    [anon_sym_alignas] = ACTIONS(2649),
    [anon_sym__Alignas] = ACTIONS(2649),
    [sym_primitive_type] = ACTIONS(2649),
    [anon_sym_enum] = ACTIONS(2649),
    [anon_sym_class] = ACTIONS(2649),
    [anon_sym_struct] = ACTIONS(2649),
    [anon_sym_union] = ACTIONS(2649),
    [anon_sym_if] = ACTIONS(2649),
    [anon_sym_else] = ACTIONS(2649),
    [anon_sym_switch] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2649),
    [anon_sym_default] = ACTIONS(2649),
    [anon_sym_while] = ACTIONS(2649),
    [anon_sym_do] = ACTIONS(2649),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_return] = ACTIONS(2649),
    [anon_sym_break] = ACTIONS(2649),
    [anon_sym_continue] = ACTIONS(2649),
    [anon_sym_goto] = ACTIONS(2649),
    [anon_sym___try] = ACTIONS(2649),
    [anon_sym___leave] = ACTIONS(2649),
    [anon_sym_not] = ACTIONS(2649),
    [anon_sym_compl] = ACTIONS(2649),
    [anon_sym_DASH_DASH] = ACTIONS(2651),
    [anon_sym_PLUS_PLUS] = ACTIONS(2651),
    [anon_sym_sizeof] = ACTIONS(2649),
    [anon_sym___alignof__] = ACTIONS(2649),
    [anon_sym___alignof] = ACTIONS(2649),
    [anon_sym__alignof] = ACTIONS(2649),
    [anon_sym_alignof] = ACTIONS(2649),
    [anon_sym__Alignof] = ACTIONS(2649),
    [anon_sym_offsetof] = ACTIONS(2649),
    [anon_sym__Generic] = ACTIONS(2649),
    [anon_sym_asm] = ACTIONS(2649),
    [anon_sym___asm__] = ACTIONS(2649),
    [anon_sym___asm] = ACTIONS(2649),
    [sym_number_literal] = ACTIONS(2651),
    [anon_sym_L_SQUOTE] = ACTIONS(2651),
    [anon_sym_u_SQUOTE] = ACTIONS(2651),
    [anon_sym_U_SQUOTE] = ACTIONS(2651),
    [anon_sym_u8_SQUOTE] = ACTIONS(2651),
    [anon_sym_SQUOTE] = ACTIONS(2651),
    [anon_sym_L_DQUOTE] = ACTIONS(2651),
    [anon_sym_u_DQUOTE] = ACTIONS(2651),
    [anon_sym_U_DQUOTE] = ACTIONS(2651),
    [anon_sym_u8_DQUOTE] = ACTIONS(2651),
    [anon_sym_DQUOTE] = ACTIONS(2651),
    [sym_true] = ACTIONS(2649),
    [sym_false] = ACTIONS(2649),
    [anon_sym_NULL] = ACTIONS(2649),
    [anon_sym_nullptr] = ACTIONS(2649),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2649),
    [anon_sym_decltype] = ACTIONS(2649),
    [anon_sym_explicit] = ACTIONS(2649),
    [anon_sym_typename] = ACTIONS(2649),
    [anon_sym_template] = ACTIONS(2649),
    [anon_sym_operator] = ACTIONS(2649),
    [anon_sym_try] = ACTIONS(2649),
    [anon_sym_delete] = ACTIONS(2649),
    [anon_sym_throw] = ACTIONS(2649),
    [anon_sym_namespace] = ACTIONS(2649),
    [anon_sym_using] = ACTIONS(2649),
    [anon_sym_static_assert] = ACTIONS(2649),
    [anon_sym_concept] = ACTIONS(2649),
    [anon_sym_co_return] = ACTIONS(2649),
    [anon_sym_co_yield] = ACTIONS(2649),
    [anon_sym_R_DQUOTE] = ACTIONS(2651),
    [anon_sym_LR_DQUOTE] = ACTIONS(2651),
    [anon_sym_uR_DQUOTE] = ACTIONS(2651),
    [anon_sym_UR_DQUOTE] = ACTIONS(2651),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2651),
    [anon_sym_co_await] = ACTIONS(2649),
    [anon_sym_new] = ACTIONS(2649),
    [anon_sym_requires] = ACTIONS(2649),
    [sym_this] = ACTIONS(2649),
  },
  [252] = {
    [sym_identifier] = ACTIONS(2653),
    [aux_sym_preproc_include_token1] = ACTIONS(2653),
    [aux_sym_preproc_def_token1] = ACTIONS(2653),
    [aux_sym_preproc_if_token1] = ACTIONS(2653),
    [aux_sym_preproc_if_token2] = ACTIONS(2653),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2653),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2653),
    [aux_sym_preproc_else_token1] = ACTIONS(2653),
    [aux_sym_preproc_elif_token1] = ACTIONS(2653),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2653),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2653),
    [sym_preproc_directive] = ACTIONS(2653),
    [anon_sym_LPAREN2] = ACTIONS(2655),
    [anon_sym_BANG] = ACTIONS(2655),
    [anon_sym_TILDE] = ACTIONS(2655),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_AMP_AMP] = ACTIONS(2655),
    [anon_sym_AMP] = ACTIONS(2653),
    [anon_sym_SEMI] = ACTIONS(2655),
    [anon_sym___extension__] = ACTIONS(2653),
    [anon_sym_typedef] = ACTIONS(2653),
    [anon_sym_virtual] = ACTIONS(2653),
    [anon_sym_extern] = ACTIONS(2653),
    [anon_sym___attribute__] = ACTIONS(2653),
    [anon_sym___attribute] = ACTIONS(2653),
    [anon_sym_COLON_COLON] = ACTIONS(2655),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2655),
    [anon_sym___declspec] = ACTIONS(2653),
    [anon_sym___based] = ACTIONS(2653),
    [anon_sym___cdecl] = ACTIONS(2653),
    [anon_sym___clrcall] = ACTIONS(2653),
    [anon_sym___stdcall] = ACTIONS(2653),
    [anon_sym___fastcall] = ACTIONS(2653),
    [anon_sym___thiscall] = ACTIONS(2653),
    [anon_sym___vectorcall] = ACTIONS(2653),
    [anon_sym_LBRACE] = ACTIONS(2655),
    [anon_sym_signed] = ACTIONS(2653),
    [anon_sym_unsigned] = ACTIONS(2653),
    [anon_sym_long] = ACTIONS(2653),
    [anon_sym_short] = ACTIONS(2653),
    [anon_sym_LBRACK] = ACTIONS(2653),
    [anon_sym_static] = ACTIONS(2653),
    [anon_sym_register] = ACTIONS(2653),
    [anon_sym_inline] = ACTIONS(2653),
    [anon_sym___inline] = ACTIONS(2653),
    [anon_sym___inline__] = ACTIONS(2653),
    [anon_sym___forceinline] = ACTIONS(2653),
    [anon_sym_thread_local] = ACTIONS(2653),
    [anon_sym___thread] = ACTIONS(2653),
    [anon_sym_const] = ACTIONS(2653),
    [anon_sym_constexpr] = ACTIONS(2653),
    [anon_sym_volatile] = ACTIONS(2653),
    [anon_sym_restrict] = ACTIONS(2653),
    [anon_sym___restrict__] = ACTIONS(2653),
    [anon_sym__Atomic] = ACTIONS(2653),
    [anon_sym__Noreturn] = ACTIONS(2653),
    [anon_sym_noreturn] = ACTIONS(2653),
    [anon_sym__Nonnull] = ACTIONS(2653),
    [anon_sym_mutable] = ACTIONS(2653),
    [anon_sym_constinit] = ACTIONS(2653),
    [anon_sym_consteval] = ACTIONS(2653),
    [anon_sym_alignas] = ACTIONS(2653),
    [anon_sym__Alignas] = ACTIONS(2653),
    [sym_primitive_type] = ACTIONS(2653),
    [anon_sym_enum] = ACTIONS(2653),
    [anon_sym_class] = ACTIONS(2653),
    [anon_sym_struct] = ACTIONS(2653),
    [anon_sym_union] = ACTIONS(2653),
    [anon_sym_if] = ACTIONS(2653),
    [anon_sym_else] = ACTIONS(2653),
    [anon_sym_switch] = ACTIONS(2653),
    [anon_sym_case] = ACTIONS(2653),
    [anon_sym_default] = ACTIONS(2653),
    [anon_sym_while] = ACTIONS(2653),
    [anon_sym_do] = ACTIONS(2653),
    [anon_sym_for] = ACTIONS(2653),
    [anon_sym_return] = ACTIONS(2653),
    [anon_sym_break] = ACTIONS(2653),
    [anon_sym_continue] = ACTIONS(2653),
    [anon_sym_goto] = ACTIONS(2653),
    [anon_sym___try] = ACTIONS(2653),
    [anon_sym___leave] = ACTIONS(2653),
    [anon_sym_not] = ACTIONS(2653),
    [anon_sym_compl] = ACTIONS(2653),
    [anon_sym_DASH_DASH] = ACTIONS(2655),
    [anon_sym_PLUS_PLUS] = ACTIONS(2655),
    [anon_sym_sizeof] = ACTIONS(2653),
    [anon_sym___alignof__] = ACTIONS(2653),
    [anon_sym___alignof] = ACTIONS(2653),
    [anon_sym__alignof] = ACTIONS(2653),
    [anon_sym_alignof] = ACTIONS(2653),
    [anon_sym__Alignof] = ACTIONS(2653),
    [anon_sym_offsetof] = ACTIONS(2653),
    [anon_sym__Generic] = ACTIONS(2653),
    [anon_sym_asm] = ACTIONS(2653),
    [anon_sym___asm__] = ACTIONS(2653),
    [anon_sym___asm] = ACTIONS(2653),
    [sym_number_literal] = ACTIONS(2655),
    [anon_sym_L_SQUOTE] = ACTIONS(2655),
    [anon_sym_u_SQUOTE] = ACTIONS(2655),
    [anon_sym_U_SQUOTE] = ACTIONS(2655),
    [anon_sym_u8_SQUOTE] = ACTIONS(2655),
    [anon_sym_SQUOTE] = ACTIONS(2655),
    [anon_sym_L_DQUOTE] = ACTIONS(2655),
    [anon_sym_u_DQUOTE] = ACTIONS(2655),
    [anon_sym_U_DQUOTE] = ACTIONS(2655),
    [anon_sym_u8_DQUOTE] = ACTIONS(2655),
    [anon_sym_DQUOTE] = ACTIONS(2655),
    [sym_true] = ACTIONS(2653),
    [sym_false] = ACTIONS(2653),
    [anon_sym_NULL] = ACTIONS(2653),
    [anon_sym_nullptr] = ACTIONS(2653),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2653),
    [anon_sym_decltype] = ACTIONS(2653),
    [anon_sym_explicit] = ACTIONS(2653),
    [anon_sym_typename] = ACTIONS(2653),
    [anon_sym_template] = ACTIONS(2653),
    [anon_sym_operator] = ACTIONS(2653),
    [anon_sym_try] = ACTIONS(2653),
    [anon_sym_delete] = ACTIONS(2653),
    [anon_sym_throw] = ACTIONS(2653),
    [anon_sym_namespace] = ACTIONS(2653),
    [anon_sym_using] = ACTIONS(2653),
    [anon_sym_static_assert] = ACTIONS(2653),
    [anon_sym_concept] = ACTIONS(2653),
    [anon_sym_co_return] = ACTIONS(2653),
    [anon_sym_co_yield] = ACTIONS(2653),
    [anon_sym_R_DQUOTE] = ACTIONS(2655),
    [anon_sym_LR_DQUOTE] = ACTIONS(2655),
    [anon_sym_uR_DQUOTE] = ACTIONS(2655),
    [anon_sym_UR_DQUOTE] = ACTIONS(2655),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2655),
    [anon_sym_co_await] = ACTIONS(2653),
    [anon_sym_new] = ACTIONS(2653),
    [anon_sym_requires] = ACTIONS(2653),
    [sym_this] = ACTIONS(2653),
  },
  [253] = {
    [sym_identifier] = ACTIONS(2657),
    [aux_sym_preproc_include_token1] = ACTIONS(2657),
    [aux_sym_preproc_def_token1] = ACTIONS(2657),
    [aux_sym_preproc_if_token1] = ACTIONS(2657),
    [aux_sym_preproc_if_token2] = ACTIONS(2657),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2657),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2657),
    [aux_sym_preproc_else_token1] = ACTIONS(2657),
    [aux_sym_preproc_elif_token1] = ACTIONS(2657),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2657),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2657),
    [sym_preproc_directive] = ACTIONS(2657),
    [anon_sym_LPAREN2] = ACTIONS(2659),
    [anon_sym_BANG] = ACTIONS(2659),
    [anon_sym_TILDE] = ACTIONS(2659),
    [anon_sym_DASH] = ACTIONS(2657),
    [anon_sym_PLUS] = ACTIONS(2657),
    [anon_sym_STAR] = ACTIONS(2659),
    [anon_sym_AMP_AMP] = ACTIONS(2659),
    [anon_sym_AMP] = ACTIONS(2657),
    [anon_sym_SEMI] = ACTIONS(2659),
    [anon_sym___extension__] = ACTIONS(2657),
    [anon_sym_typedef] = ACTIONS(2657),
    [anon_sym_virtual] = ACTIONS(2657),
    [anon_sym_extern] = ACTIONS(2657),
    [anon_sym___attribute__] = ACTIONS(2657),
    [anon_sym___attribute] = ACTIONS(2657),
    [anon_sym_COLON_COLON] = ACTIONS(2659),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2659),
    [anon_sym___declspec] = ACTIONS(2657),
    [anon_sym___based] = ACTIONS(2657),
    [anon_sym___cdecl] = ACTIONS(2657),
    [anon_sym___clrcall] = ACTIONS(2657),
    [anon_sym___stdcall] = ACTIONS(2657),
    [anon_sym___fastcall] = ACTIONS(2657),
    [anon_sym___thiscall] = ACTIONS(2657),
    [anon_sym___vectorcall] = ACTIONS(2657),
    [anon_sym_LBRACE] = ACTIONS(2659),
    [anon_sym_signed] = ACTIONS(2657),
    [anon_sym_unsigned] = ACTIONS(2657),
    [anon_sym_long] = ACTIONS(2657),
    [anon_sym_short] = ACTIONS(2657),
    [anon_sym_LBRACK] = ACTIONS(2657),
    [anon_sym_static] = ACTIONS(2657),
    [anon_sym_register] = ACTIONS(2657),
    [anon_sym_inline] = ACTIONS(2657),
    [anon_sym___inline] = ACTIONS(2657),
    [anon_sym___inline__] = ACTIONS(2657),
    [anon_sym___forceinline] = ACTIONS(2657),
    [anon_sym_thread_local] = ACTIONS(2657),
    [anon_sym___thread] = ACTIONS(2657),
    [anon_sym_const] = ACTIONS(2657),
    [anon_sym_constexpr] = ACTIONS(2657),
    [anon_sym_volatile] = ACTIONS(2657),
    [anon_sym_restrict] = ACTIONS(2657),
    [anon_sym___restrict__] = ACTIONS(2657),
    [anon_sym__Atomic] = ACTIONS(2657),
    [anon_sym__Noreturn] = ACTIONS(2657),
    [anon_sym_noreturn] = ACTIONS(2657),
    [anon_sym__Nonnull] = ACTIONS(2657),
    [anon_sym_mutable] = ACTIONS(2657),
    [anon_sym_constinit] = ACTIONS(2657),
    [anon_sym_consteval] = ACTIONS(2657),
    [anon_sym_alignas] = ACTIONS(2657),
    [anon_sym__Alignas] = ACTIONS(2657),
    [sym_primitive_type] = ACTIONS(2657),
    [anon_sym_enum] = ACTIONS(2657),
    [anon_sym_class] = ACTIONS(2657),
    [anon_sym_struct] = ACTIONS(2657),
    [anon_sym_union] = ACTIONS(2657),
    [anon_sym_if] = ACTIONS(2657),
    [anon_sym_else] = ACTIONS(2657),
    [anon_sym_switch] = ACTIONS(2657),
    [anon_sym_case] = ACTIONS(2657),
    [anon_sym_default] = ACTIONS(2657),
    [anon_sym_while] = ACTIONS(2657),
    [anon_sym_do] = ACTIONS(2657),
    [anon_sym_for] = ACTIONS(2657),
    [anon_sym_return] = ACTIONS(2657),
    [anon_sym_break] = ACTIONS(2657),
    [anon_sym_continue] = ACTIONS(2657),
    [anon_sym_goto] = ACTIONS(2657),
    [anon_sym___try] = ACTIONS(2657),
    [anon_sym___leave] = ACTIONS(2657),
    [anon_sym_not] = ACTIONS(2657),
    [anon_sym_compl] = ACTIONS(2657),
    [anon_sym_DASH_DASH] = ACTIONS(2659),
    [anon_sym_PLUS_PLUS] = ACTIONS(2659),
    [anon_sym_sizeof] = ACTIONS(2657),
    [anon_sym___alignof__] = ACTIONS(2657),
    [anon_sym___alignof] = ACTIONS(2657),
    [anon_sym__alignof] = ACTIONS(2657),
    [anon_sym_alignof] = ACTIONS(2657),
    [anon_sym__Alignof] = ACTIONS(2657),
    [anon_sym_offsetof] = ACTIONS(2657),
    [anon_sym__Generic] = ACTIONS(2657),
    [anon_sym_asm] = ACTIONS(2657),
    [anon_sym___asm__] = ACTIONS(2657),
    [anon_sym___asm] = ACTIONS(2657),
    [sym_number_literal] = ACTIONS(2659),
    [anon_sym_L_SQUOTE] = ACTIONS(2659),
    [anon_sym_u_SQUOTE] = ACTIONS(2659),
    [anon_sym_U_SQUOTE] = ACTIONS(2659),
    [anon_sym_u8_SQUOTE] = ACTIONS(2659),
    [anon_sym_SQUOTE] = ACTIONS(2659),
    [anon_sym_L_DQUOTE] = ACTIONS(2659),
    [anon_sym_u_DQUOTE] = ACTIONS(2659),
    [anon_sym_U_DQUOTE] = ACTIONS(2659),
    [anon_sym_u8_DQUOTE] = ACTIONS(2659),
    [anon_sym_DQUOTE] = ACTIONS(2659),
    [sym_true] = ACTIONS(2657),
    [sym_false] = ACTIONS(2657),
    [anon_sym_NULL] = ACTIONS(2657),
    [anon_sym_nullptr] = ACTIONS(2657),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2657),
    [anon_sym_decltype] = ACTIONS(2657),
    [anon_sym_explicit] = ACTIONS(2657),
    [anon_sym_typename] = ACTIONS(2657),
    [anon_sym_template] = ACTIONS(2657),
    [anon_sym_operator] = ACTIONS(2657),
    [anon_sym_try] = ACTIONS(2657),
    [anon_sym_delete] = ACTIONS(2657),
    [anon_sym_throw] = ACTIONS(2657),
    [anon_sym_namespace] = ACTIONS(2657),
    [anon_sym_using] = ACTIONS(2657),
    [anon_sym_static_assert] = ACTIONS(2657),
    [anon_sym_concept] = ACTIONS(2657),
    [anon_sym_co_return] = ACTIONS(2657),
    [anon_sym_co_yield] = ACTIONS(2657),
    [anon_sym_R_DQUOTE] = ACTIONS(2659),
    [anon_sym_LR_DQUOTE] = ACTIONS(2659),
    [anon_sym_uR_DQUOTE] = ACTIONS(2659),
    [anon_sym_UR_DQUOTE] = ACTIONS(2659),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2659),
    [anon_sym_co_await] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(2657),
    [anon_sym_requires] = ACTIONS(2657),
    [sym_this] = ACTIONS(2657),
  },
  [254] = {
    [sym_identifier] = ACTIONS(2661),
    [aux_sym_preproc_include_token1] = ACTIONS(2661),
    [aux_sym_preproc_def_token1] = ACTIONS(2661),
    [aux_sym_preproc_if_token1] = ACTIONS(2661),
    [aux_sym_preproc_if_token2] = ACTIONS(2661),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2661),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2661),
    [aux_sym_preproc_else_token1] = ACTIONS(2661),
    [aux_sym_preproc_elif_token1] = ACTIONS(2661),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2661),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2661),
    [sym_preproc_directive] = ACTIONS(2661),
    [anon_sym_LPAREN2] = ACTIONS(2663),
    [anon_sym_BANG] = ACTIONS(2663),
    [anon_sym_TILDE] = ACTIONS(2663),
    [anon_sym_DASH] = ACTIONS(2661),
    [anon_sym_PLUS] = ACTIONS(2661),
    [anon_sym_STAR] = ACTIONS(2663),
    [anon_sym_AMP_AMP] = ACTIONS(2663),
    [anon_sym_AMP] = ACTIONS(2661),
    [anon_sym_SEMI] = ACTIONS(2663),
    [anon_sym___extension__] = ACTIONS(2661),
    [anon_sym_typedef] = ACTIONS(2661),
    [anon_sym_virtual] = ACTIONS(2661),
    [anon_sym_extern] = ACTIONS(2661),
    [anon_sym___attribute__] = ACTIONS(2661),
    [anon_sym___attribute] = ACTIONS(2661),
    [anon_sym_COLON_COLON] = ACTIONS(2663),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2663),
    [anon_sym___declspec] = ACTIONS(2661),
    [anon_sym___based] = ACTIONS(2661),
    [anon_sym___cdecl] = ACTIONS(2661),
    [anon_sym___clrcall] = ACTIONS(2661),
    [anon_sym___stdcall] = ACTIONS(2661),
    [anon_sym___fastcall] = ACTIONS(2661),
    [anon_sym___thiscall] = ACTIONS(2661),
    [anon_sym___vectorcall] = ACTIONS(2661),
    [anon_sym_LBRACE] = ACTIONS(2663),
    [anon_sym_signed] = ACTIONS(2661),
    [anon_sym_unsigned] = ACTIONS(2661),
    [anon_sym_long] = ACTIONS(2661),
    [anon_sym_short] = ACTIONS(2661),
    [anon_sym_LBRACK] = ACTIONS(2661),
    [anon_sym_static] = ACTIONS(2661),
    [anon_sym_register] = ACTIONS(2661),
    [anon_sym_inline] = ACTIONS(2661),
    [anon_sym___inline] = ACTIONS(2661),
    [anon_sym___inline__] = ACTIONS(2661),
    [anon_sym___forceinline] = ACTIONS(2661),
    [anon_sym_thread_local] = ACTIONS(2661),
    [anon_sym___thread] = ACTIONS(2661),
    [anon_sym_const] = ACTIONS(2661),
    [anon_sym_constexpr] = ACTIONS(2661),
    [anon_sym_volatile] = ACTIONS(2661),
    [anon_sym_restrict] = ACTIONS(2661),
    [anon_sym___restrict__] = ACTIONS(2661),
    [anon_sym__Atomic] = ACTIONS(2661),
    [anon_sym__Noreturn] = ACTIONS(2661),
    [anon_sym_noreturn] = ACTIONS(2661),
    [anon_sym__Nonnull] = ACTIONS(2661),
    [anon_sym_mutable] = ACTIONS(2661),
    [anon_sym_constinit] = ACTIONS(2661),
    [anon_sym_consteval] = ACTIONS(2661),
    [anon_sym_alignas] = ACTIONS(2661),
    [anon_sym__Alignas] = ACTIONS(2661),
    [sym_primitive_type] = ACTIONS(2661),
    [anon_sym_enum] = ACTIONS(2661),
    [anon_sym_class] = ACTIONS(2661),
    [anon_sym_struct] = ACTIONS(2661),
    [anon_sym_union] = ACTIONS(2661),
    [anon_sym_if] = ACTIONS(2661),
    [anon_sym_else] = ACTIONS(2661),
    [anon_sym_switch] = ACTIONS(2661),
    [anon_sym_case] = ACTIONS(2661),
    [anon_sym_default] = ACTIONS(2661),
    [anon_sym_while] = ACTIONS(2661),
    [anon_sym_do] = ACTIONS(2661),
    [anon_sym_for] = ACTIONS(2661),
    [anon_sym_return] = ACTIONS(2661),
    [anon_sym_break] = ACTIONS(2661),
    [anon_sym_continue] = ACTIONS(2661),
    [anon_sym_goto] = ACTIONS(2661),
    [anon_sym___try] = ACTIONS(2661),
    [anon_sym___leave] = ACTIONS(2661),
    [anon_sym_not] = ACTIONS(2661),
    [anon_sym_compl] = ACTIONS(2661),
    [anon_sym_DASH_DASH] = ACTIONS(2663),
    [anon_sym_PLUS_PLUS] = ACTIONS(2663),
    [anon_sym_sizeof] = ACTIONS(2661),
    [anon_sym___alignof__] = ACTIONS(2661),
    [anon_sym___alignof] = ACTIONS(2661),
    [anon_sym__alignof] = ACTIONS(2661),
    [anon_sym_alignof] = ACTIONS(2661),
    [anon_sym__Alignof] = ACTIONS(2661),
    [anon_sym_offsetof] = ACTIONS(2661),
    [anon_sym__Generic] = ACTIONS(2661),
    [anon_sym_asm] = ACTIONS(2661),
    [anon_sym___asm__] = ACTIONS(2661),
    [anon_sym___asm] = ACTIONS(2661),
    [sym_number_literal] = ACTIONS(2663),
    [anon_sym_L_SQUOTE] = ACTIONS(2663),
    [anon_sym_u_SQUOTE] = ACTIONS(2663),
    [anon_sym_U_SQUOTE] = ACTIONS(2663),
    [anon_sym_u8_SQUOTE] = ACTIONS(2663),
    [anon_sym_SQUOTE] = ACTIONS(2663),
    [anon_sym_L_DQUOTE] = ACTIONS(2663),
    [anon_sym_u_DQUOTE] = ACTIONS(2663),
    [anon_sym_U_DQUOTE] = ACTIONS(2663),
    [anon_sym_u8_DQUOTE] = ACTIONS(2663),
    [anon_sym_DQUOTE] = ACTIONS(2663),
    [sym_true] = ACTIONS(2661),
    [sym_false] = ACTIONS(2661),
    [anon_sym_NULL] = ACTIONS(2661),
    [anon_sym_nullptr] = ACTIONS(2661),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2661),
    [anon_sym_decltype] = ACTIONS(2661),
    [anon_sym_explicit] = ACTIONS(2661),
    [anon_sym_typename] = ACTIONS(2661),
    [anon_sym_template] = ACTIONS(2661),
    [anon_sym_operator] = ACTIONS(2661),
    [anon_sym_try] = ACTIONS(2661),
    [anon_sym_delete] = ACTIONS(2661),
    [anon_sym_throw] = ACTIONS(2661),
    [anon_sym_namespace] = ACTIONS(2661),
    [anon_sym_using] = ACTIONS(2661),
    [anon_sym_static_assert] = ACTIONS(2661),
    [anon_sym_concept] = ACTIONS(2661),
    [anon_sym_co_return] = ACTIONS(2661),
    [anon_sym_co_yield] = ACTIONS(2661),
    [anon_sym_R_DQUOTE] = ACTIONS(2663),
    [anon_sym_LR_DQUOTE] = ACTIONS(2663),
    [anon_sym_uR_DQUOTE] = ACTIONS(2663),
    [anon_sym_UR_DQUOTE] = ACTIONS(2663),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2663),
    [anon_sym_co_await] = ACTIONS(2661),
    [anon_sym_new] = ACTIONS(2661),
    [anon_sym_requires] = ACTIONS(2661),
    [sym_this] = ACTIONS(2661),
  },
  [255] = {
    [sym_identifier] = ACTIONS(2665),
    [aux_sym_preproc_include_token1] = ACTIONS(2665),
    [aux_sym_preproc_def_token1] = ACTIONS(2665),
    [aux_sym_preproc_if_token1] = ACTIONS(2665),
    [aux_sym_preproc_if_token2] = ACTIONS(2665),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2665),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2665),
    [aux_sym_preproc_else_token1] = ACTIONS(2665),
    [aux_sym_preproc_elif_token1] = ACTIONS(2665),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2665),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2665),
    [sym_preproc_directive] = ACTIONS(2665),
    [anon_sym_LPAREN2] = ACTIONS(2667),
    [anon_sym_BANG] = ACTIONS(2667),
    [anon_sym_TILDE] = ACTIONS(2667),
    [anon_sym_DASH] = ACTIONS(2665),
    [anon_sym_PLUS] = ACTIONS(2665),
    [anon_sym_STAR] = ACTIONS(2667),
    [anon_sym_AMP_AMP] = ACTIONS(2667),
    [anon_sym_AMP] = ACTIONS(2665),
    [anon_sym_SEMI] = ACTIONS(2667),
    [anon_sym___extension__] = ACTIONS(2665),
    [anon_sym_typedef] = ACTIONS(2665),
    [anon_sym_virtual] = ACTIONS(2665),
    [anon_sym_extern] = ACTIONS(2665),
    [anon_sym___attribute__] = ACTIONS(2665),
    [anon_sym___attribute] = ACTIONS(2665),
    [anon_sym_COLON_COLON] = ACTIONS(2667),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2667),
    [anon_sym___declspec] = ACTIONS(2665),
    [anon_sym___based] = ACTIONS(2665),
    [anon_sym___cdecl] = ACTIONS(2665),
    [anon_sym___clrcall] = ACTIONS(2665),
    [anon_sym___stdcall] = ACTIONS(2665),
    [anon_sym___fastcall] = ACTIONS(2665),
    [anon_sym___thiscall] = ACTIONS(2665),
    [anon_sym___vectorcall] = ACTIONS(2665),
    [anon_sym_LBRACE] = ACTIONS(2667),
    [anon_sym_signed] = ACTIONS(2665),
    [anon_sym_unsigned] = ACTIONS(2665),
    [anon_sym_long] = ACTIONS(2665),
    [anon_sym_short] = ACTIONS(2665),
    [anon_sym_LBRACK] = ACTIONS(2665),
    [anon_sym_static] = ACTIONS(2665),
    [anon_sym_register] = ACTIONS(2665),
    [anon_sym_inline] = ACTIONS(2665),
    [anon_sym___inline] = ACTIONS(2665),
    [anon_sym___inline__] = ACTIONS(2665),
    [anon_sym___forceinline] = ACTIONS(2665),
    [anon_sym_thread_local] = ACTIONS(2665),
    [anon_sym___thread] = ACTIONS(2665),
    [anon_sym_const] = ACTIONS(2665),
    [anon_sym_constexpr] = ACTIONS(2665),
    [anon_sym_volatile] = ACTIONS(2665),
    [anon_sym_restrict] = ACTIONS(2665),
    [anon_sym___restrict__] = ACTIONS(2665),
    [anon_sym__Atomic] = ACTIONS(2665),
    [anon_sym__Noreturn] = ACTIONS(2665),
    [anon_sym_noreturn] = ACTIONS(2665),
    [anon_sym__Nonnull] = ACTIONS(2665),
    [anon_sym_mutable] = ACTIONS(2665),
    [anon_sym_constinit] = ACTIONS(2665),
    [anon_sym_consteval] = ACTIONS(2665),
    [anon_sym_alignas] = ACTIONS(2665),
    [anon_sym__Alignas] = ACTIONS(2665),
    [sym_primitive_type] = ACTIONS(2665),
    [anon_sym_enum] = ACTIONS(2665),
    [anon_sym_class] = ACTIONS(2665),
    [anon_sym_struct] = ACTIONS(2665),
    [anon_sym_union] = ACTIONS(2665),
    [anon_sym_if] = ACTIONS(2665),
    [anon_sym_else] = ACTIONS(2665),
    [anon_sym_switch] = ACTIONS(2665),
    [anon_sym_case] = ACTIONS(2665),
    [anon_sym_default] = ACTIONS(2665),
    [anon_sym_while] = ACTIONS(2665),
    [anon_sym_do] = ACTIONS(2665),
    [anon_sym_for] = ACTIONS(2665),
    [anon_sym_return] = ACTIONS(2665),
    [anon_sym_break] = ACTIONS(2665),
    [anon_sym_continue] = ACTIONS(2665),
    [anon_sym_goto] = ACTIONS(2665),
    [anon_sym___try] = ACTIONS(2665),
    [anon_sym___leave] = ACTIONS(2665),
    [anon_sym_not] = ACTIONS(2665),
    [anon_sym_compl] = ACTIONS(2665),
    [anon_sym_DASH_DASH] = ACTIONS(2667),
    [anon_sym_PLUS_PLUS] = ACTIONS(2667),
    [anon_sym_sizeof] = ACTIONS(2665),
    [anon_sym___alignof__] = ACTIONS(2665),
    [anon_sym___alignof] = ACTIONS(2665),
    [anon_sym__alignof] = ACTIONS(2665),
    [anon_sym_alignof] = ACTIONS(2665),
    [anon_sym__Alignof] = ACTIONS(2665),
    [anon_sym_offsetof] = ACTIONS(2665),
    [anon_sym__Generic] = ACTIONS(2665),
    [anon_sym_asm] = ACTIONS(2665),
    [anon_sym___asm__] = ACTIONS(2665),
    [anon_sym___asm] = ACTIONS(2665),
    [sym_number_literal] = ACTIONS(2667),
    [anon_sym_L_SQUOTE] = ACTIONS(2667),
    [anon_sym_u_SQUOTE] = ACTIONS(2667),
    [anon_sym_U_SQUOTE] = ACTIONS(2667),
    [anon_sym_u8_SQUOTE] = ACTIONS(2667),
    [anon_sym_SQUOTE] = ACTIONS(2667),
    [anon_sym_L_DQUOTE] = ACTIONS(2667),
    [anon_sym_u_DQUOTE] = ACTIONS(2667),
    [anon_sym_U_DQUOTE] = ACTIONS(2667),
    [anon_sym_u8_DQUOTE] = ACTIONS(2667),
    [anon_sym_DQUOTE] = ACTIONS(2667),
    [sym_true] = ACTIONS(2665),
    [sym_false] = ACTIONS(2665),
    [anon_sym_NULL] = ACTIONS(2665),
    [anon_sym_nullptr] = ACTIONS(2665),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2665),
    [anon_sym_decltype] = ACTIONS(2665),
    [anon_sym_explicit] = ACTIONS(2665),
    [anon_sym_typename] = ACTIONS(2665),
    [anon_sym_template] = ACTIONS(2665),
    [anon_sym_operator] = ACTIONS(2665),
    [anon_sym_try] = ACTIONS(2665),
    [anon_sym_delete] = ACTIONS(2665),
    [anon_sym_throw] = ACTIONS(2665),
    [anon_sym_namespace] = ACTIONS(2665),
    [anon_sym_using] = ACTIONS(2665),
    [anon_sym_static_assert] = ACTIONS(2665),
    [anon_sym_concept] = ACTIONS(2665),
    [anon_sym_co_return] = ACTIONS(2665),
    [anon_sym_co_yield] = ACTIONS(2665),
    [anon_sym_R_DQUOTE] = ACTIONS(2667),
    [anon_sym_LR_DQUOTE] = ACTIONS(2667),
    [anon_sym_uR_DQUOTE] = ACTIONS(2667),
    [anon_sym_UR_DQUOTE] = ACTIONS(2667),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2667),
    [anon_sym_co_await] = ACTIONS(2665),
    [anon_sym_new] = ACTIONS(2665),
    [anon_sym_requires] = ACTIONS(2665),
    [sym_this] = ACTIONS(2665),
  },
  [256] = {
    [sym_identifier] = ACTIONS(2669),
    [aux_sym_preproc_include_token1] = ACTIONS(2669),
    [aux_sym_preproc_def_token1] = ACTIONS(2669),
    [aux_sym_preproc_if_token1] = ACTIONS(2669),
    [aux_sym_preproc_if_token2] = ACTIONS(2669),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2669),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2669),
    [aux_sym_preproc_else_token1] = ACTIONS(2669),
    [aux_sym_preproc_elif_token1] = ACTIONS(2669),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2669),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2669),
    [sym_preproc_directive] = ACTIONS(2669),
    [anon_sym_LPAREN2] = ACTIONS(2671),
    [anon_sym_BANG] = ACTIONS(2671),
    [anon_sym_TILDE] = ACTIONS(2671),
    [anon_sym_DASH] = ACTIONS(2669),
    [anon_sym_PLUS] = ACTIONS(2669),
    [anon_sym_STAR] = ACTIONS(2671),
    [anon_sym_AMP_AMP] = ACTIONS(2671),
    [anon_sym_AMP] = ACTIONS(2669),
    [anon_sym_SEMI] = ACTIONS(2671),
    [anon_sym___extension__] = ACTIONS(2669),
    [anon_sym_typedef] = ACTIONS(2669),
    [anon_sym_virtual] = ACTIONS(2669),
    [anon_sym_extern] = ACTIONS(2669),
    [anon_sym___attribute__] = ACTIONS(2669),
    [anon_sym___attribute] = ACTIONS(2669),
    [anon_sym_COLON_COLON] = ACTIONS(2671),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2671),
    [anon_sym___declspec] = ACTIONS(2669),
    [anon_sym___based] = ACTIONS(2669),
    [anon_sym___cdecl] = ACTIONS(2669),
    [anon_sym___clrcall] = ACTIONS(2669),
    [anon_sym___stdcall] = ACTIONS(2669),
    [anon_sym___fastcall] = ACTIONS(2669),
    [anon_sym___thiscall] = ACTIONS(2669),
    [anon_sym___vectorcall] = ACTIONS(2669),
    [anon_sym_LBRACE] = ACTIONS(2671),
    [anon_sym_signed] = ACTIONS(2669),
    [anon_sym_unsigned] = ACTIONS(2669),
    [anon_sym_long] = ACTIONS(2669),
    [anon_sym_short] = ACTIONS(2669),
    [anon_sym_LBRACK] = ACTIONS(2669),
    [anon_sym_static] = ACTIONS(2669),
    [anon_sym_register] = ACTIONS(2669),
    [anon_sym_inline] = ACTIONS(2669),
    [anon_sym___inline] = ACTIONS(2669),
    [anon_sym___inline__] = ACTIONS(2669),
    [anon_sym___forceinline] = ACTIONS(2669),
    [anon_sym_thread_local] = ACTIONS(2669),
    [anon_sym___thread] = ACTIONS(2669),
    [anon_sym_const] = ACTIONS(2669),
    [anon_sym_constexpr] = ACTIONS(2669),
    [anon_sym_volatile] = ACTIONS(2669),
    [anon_sym_restrict] = ACTIONS(2669),
    [anon_sym___restrict__] = ACTIONS(2669),
    [anon_sym__Atomic] = ACTIONS(2669),
    [anon_sym__Noreturn] = ACTIONS(2669),
    [anon_sym_noreturn] = ACTIONS(2669),
    [anon_sym__Nonnull] = ACTIONS(2669),
    [anon_sym_mutable] = ACTIONS(2669),
    [anon_sym_constinit] = ACTIONS(2669),
    [anon_sym_consteval] = ACTIONS(2669),
    [anon_sym_alignas] = ACTIONS(2669),
    [anon_sym__Alignas] = ACTIONS(2669),
    [sym_primitive_type] = ACTIONS(2669),
    [anon_sym_enum] = ACTIONS(2669),
    [anon_sym_class] = ACTIONS(2669),
    [anon_sym_struct] = ACTIONS(2669),
    [anon_sym_union] = ACTIONS(2669),
    [anon_sym_if] = ACTIONS(2669),
    [anon_sym_else] = ACTIONS(2669),
    [anon_sym_switch] = ACTIONS(2669),
    [anon_sym_case] = ACTIONS(2669),
    [anon_sym_default] = ACTIONS(2669),
    [anon_sym_while] = ACTIONS(2669),
    [anon_sym_do] = ACTIONS(2669),
    [anon_sym_for] = ACTIONS(2669),
    [anon_sym_return] = ACTIONS(2669),
    [anon_sym_break] = ACTIONS(2669),
    [anon_sym_continue] = ACTIONS(2669),
    [anon_sym_goto] = ACTIONS(2669),
    [anon_sym___try] = ACTIONS(2669),
    [anon_sym___leave] = ACTIONS(2669),
    [anon_sym_not] = ACTIONS(2669),
    [anon_sym_compl] = ACTIONS(2669),
    [anon_sym_DASH_DASH] = ACTIONS(2671),
    [anon_sym_PLUS_PLUS] = ACTIONS(2671),
    [anon_sym_sizeof] = ACTIONS(2669),
    [anon_sym___alignof__] = ACTIONS(2669),
    [anon_sym___alignof] = ACTIONS(2669),
    [anon_sym__alignof] = ACTIONS(2669),
    [anon_sym_alignof] = ACTIONS(2669),
    [anon_sym__Alignof] = ACTIONS(2669),
    [anon_sym_offsetof] = ACTIONS(2669),
    [anon_sym__Generic] = ACTIONS(2669),
    [anon_sym_asm] = ACTIONS(2669),
    [anon_sym___asm__] = ACTIONS(2669),
    [anon_sym___asm] = ACTIONS(2669),
    [sym_number_literal] = ACTIONS(2671),
    [anon_sym_L_SQUOTE] = ACTIONS(2671),
    [anon_sym_u_SQUOTE] = ACTIONS(2671),
    [anon_sym_U_SQUOTE] = ACTIONS(2671),
    [anon_sym_u8_SQUOTE] = ACTIONS(2671),
    [anon_sym_SQUOTE] = ACTIONS(2671),
    [anon_sym_L_DQUOTE] = ACTIONS(2671),
    [anon_sym_u_DQUOTE] = ACTIONS(2671),
    [anon_sym_U_DQUOTE] = ACTIONS(2671),
    [anon_sym_u8_DQUOTE] = ACTIONS(2671),
    [anon_sym_DQUOTE] = ACTIONS(2671),
    [sym_true] = ACTIONS(2669),
    [sym_false] = ACTIONS(2669),
    [anon_sym_NULL] = ACTIONS(2669),
    [anon_sym_nullptr] = ACTIONS(2669),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2669),
    [anon_sym_decltype] = ACTIONS(2669),
    [anon_sym_explicit] = ACTIONS(2669),
    [anon_sym_typename] = ACTIONS(2669),
    [anon_sym_template] = ACTIONS(2669),
    [anon_sym_operator] = ACTIONS(2669),
    [anon_sym_try] = ACTIONS(2669),
    [anon_sym_delete] = ACTIONS(2669),
    [anon_sym_throw] = ACTIONS(2669),
    [anon_sym_namespace] = ACTIONS(2669),
    [anon_sym_using] = ACTIONS(2669),
    [anon_sym_static_assert] = ACTIONS(2669),
    [anon_sym_concept] = ACTIONS(2669),
    [anon_sym_co_return] = ACTIONS(2669),
    [anon_sym_co_yield] = ACTIONS(2669),
    [anon_sym_R_DQUOTE] = ACTIONS(2671),
    [anon_sym_LR_DQUOTE] = ACTIONS(2671),
    [anon_sym_uR_DQUOTE] = ACTIONS(2671),
    [anon_sym_UR_DQUOTE] = ACTIONS(2671),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2671),
    [anon_sym_co_await] = ACTIONS(2669),
    [anon_sym_new] = ACTIONS(2669),
    [anon_sym_requires] = ACTIONS(2669),
    [sym_this] = ACTIONS(2669),
  },
  [257] = {
    [sym_identifier] = ACTIONS(2673),
    [aux_sym_preproc_include_token1] = ACTIONS(2673),
    [aux_sym_preproc_def_token1] = ACTIONS(2673),
    [aux_sym_preproc_if_token1] = ACTIONS(2673),
    [aux_sym_preproc_if_token2] = ACTIONS(2673),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2673),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2673),
    [aux_sym_preproc_else_token1] = ACTIONS(2673),
    [aux_sym_preproc_elif_token1] = ACTIONS(2673),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2673),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2673),
    [sym_preproc_directive] = ACTIONS(2673),
    [anon_sym_LPAREN2] = ACTIONS(2675),
    [anon_sym_BANG] = ACTIONS(2675),
    [anon_sym_TILDE] = ACTIONS(2675),
    [anon_sym_DASH] = ACTIONS(2673),
    [anon_sym_PLUS] = ACTIONS(2673),
    [anon_sym_STAR] = ACTIONS(2675),
    [anon_sym_AMP_AMP] = ACTIONS(2675),
    [anon_sym_AMP] = ACTIONS(2673),
    [anon_sym_SEMI] = ACTIONS(2675),
    [anon_sym___extension__] = ACTIONS(2673),
    [anon_sym_typedef] = ACTIONS(2673),
    [anon_sym_virtual] = ACTIONS(2673),
    [anon_sym_extern] = ACTIONS(2673),
    [anon_sym___attribute__] = ACTIONS(2673),
    [anon_sym___attribute] = ACTIONS(2673),
    [anon_sym_COLON_COLON] = ACTIONS(2675),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2675),
    [anon_sym___declspec] = ACTIONS(2673),
    [anon_sym___based] = ACTIONS(2673),
    [anon_sym___cdecl] = ACTIONS(2673),
    [anon_sym___clrcall] = ACTIONS(2673),
    [anon_sym___stdcall] = ACTIONS(2673),
    [anon_sym___fastcall] = ACTIONS(2673),
    [anon_sym___thiscall] = ACTIONS(2673),
    [anon_sym___vectorcall] = ACTIONS(2673),
    [anon_sym_LBRACE] = ACTIONS(2675),
    [anon_sym_signed] = ACTIONS(2673),
    [anon_sym_unsigned] = ACTIONS(2673),
    [anon_sym_long] = ACTIONS(2673),
    [anon_sym_short] = ACTIONS(2673),
    [anon_sym_LBRACK] = ACTIONS(2673),
    [anon_sym_static] = ACTIONS(2673),
    [anon_sym_register] = ACTIONS(2673),
    [anon_sym_inline] = ACTIONS(2673),
    [anon_sym___inline] = ACTIONS(2673),
    [anon_sym___inline__] = ACTIONS(2673),
    [anon_sym___forceinline] = ACTIONS(2673),
    [anon_sym_thread_local] = ACTIONS(2673),
    [anon_sym___thread] = ACTIONS(2673),
    [anon_sym_const] = ACTIONS(2673),
    [anon_sym_constexpr] = ACTIONS(2673),
    [anon_sym_volatile] = ACTIONS(2673),
    [anon_sym_restrict] = ACTIONS(2673),
    [anon_sym___restrict__] = ACTIONS(2673),
    [anon_sym__Atomic] = ACTIONS(2673),
    [anon_sym__Noreturn] = ACTIONS(2673),
    [anon_sym_noreturn] = ACTIONS(2673),
    [anon_sym__Nonnull] = ACTIONS(2673),
    [anon_sym_mutable] = ACTIONS(2673),
    [anon_sym_constinit] = ACTIONS(2673),
    [anon_sym_consteval] = ACTIONS(2673),
    [anon_sym_alignas] = ACTIONS(2673),
    [anon_sym__Alignas] = ACTIONS(2673),
    [sym_primitive_type] = ACTIONS(2673),
    [anon_sym_enum] = ACTIONS(2673),
    [anon_sym_class] = ACTIONS(2673),
    [anon_sym_struct] = ACTIONS(2673),
    [anon_sym_union] = ACTIONS(2673),
    [anon_sym_if] = ACTIONS(2673),
    [anon_sym_else] = ACTIONS(2673),
    [anon_sym_switch] = ACTIONS(2673),
    [anon_sym_case] = ACTIONS(2673),
    [anon_sym_default] = ACTIONS(2673),
    [anon_sym_while] = ACTIONS(2673),
    [anon_sym_do] = ACTIONS(2673),
    [anon_sym_for] = ACTIONS(2673),
    [anon_sym_return] = ACTIONS(2673),
    [anon_sym_break] = ACTIONS(2673),
    [anon_sym_continue] = ACTIONS(2673),
    [anon_sym_goto] = ACTIONS(2673),
    [anon_sym___try] = ACTIONS(2673),
    [anon_sym___leave] = ACTIONS(2673),
    [anon_sym_not] = ACTIONS(2673),
    [anon_sym_compl] = ACTIONS(2673),
    [anon_sym_DASH_DASH] = ACTIONS(2675),
    [anon_sym_PLUS_PLUS] = ACTIONS(2675),
    [anon_sym_sizeof] = ACTIONS(2673),
    [anon_sym___alignof__] = ACTIONS(2673),
    [anon_sym___alignof] = ACTIONS(2673),
    [anon_sym__alignof] = ACTIONS(2673),
    [anon_sym_alignof] = ACTIONS(2673),
    [anon_sym__Alignof] = ACTIONS(2673),
    [anon_sym_offsetof] = ACTIONS(2673),
    [anon_sym__Generic] = ACTIONS(2673),
    [anon_sym_asm] = ACTIONS(2673),
    [anon_sym___asm__] = ACTIONS(2673),
    [anon_sym___asm] = ACTIONS(2673),
    [sym_number_literal] = ACTIONS(2675),
    [anon_sym_L_SQUOTE] = ACTIONS(2675),
    [anon_sym_u_SQUOTE] = ACTIONS(2675),
    [anon_sym_U_SQUOTE] = ACTIONS(2675),
    [anon_sym_u8_SQUOTE] = ACTIONS(2675),
    [anon_sym_SQUOTE] = ACTIONS(2675),
    [anon_sym_L_DQUOTE] = ACTIONS(2675),
    [anon_sym_u_DQUOTE] = ACTIONS(2675),
    [anon_sym_U_DQUOTE] = ACTIONS(2675),
    [anon_sym_u8_DQUOTE] = ACTIONS(2675),
    [anon_sym_DQUOTE] = ACTIONS(2675),
    [sym_true] = ACTIONS(2673),
    [sym_false] = ACTIONS(2673),
    [anon_sym_NULL] = ACTIONS(2673),
    [anon_sym_nullptr] = ACTIONS(2673),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2673),
    [anon_sym_decltype] = ACTIONS(2673),
    [anon_sym_explicit] = ACTIONS(2673),
    [anon_sym_typename] = ACTIONS(2673),
    [anon_sym_template] = ACTIONS(2673),
    [anon_sym_operator] = ACTIONS(2673),
    [anon_sym_try] = ACTIONS(2673),
    [anon_sym_delete] = ACTIONS(2673),
    [anon_sym_throw] = ACTIONS(2673),
    [anon_sym_namespace] = ACTIONS(2673),
    [anon_sym_using] = ACTIONS(2673),
    [anon_sym_static_assert] = ACTIONS(2673),
    [anon_sym_concept] = ACTIONS(2673),
    [anon_sym_co_return] = ACTIONS(2673),
    [anon_sym_co_yield] = ACTIONS(2673),
    [anon_sym_R_DQUOTE] = ACTIONS(2675),
    [anon_sym_LR_DQUOTE] = ACTIONS(2675),
    [anon_sym_uR_DQUOTE] = ACTIONS(2675),
    [anon_sym_UR_DQUOTE] = ACTIONS(2675),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2675),
    [anon_sym_co_await] = ACTIONS(2673),
    [anon_sym_new] = ACTIONS(2673),
    [anon_sym_requires] = ACTIONS(2673),
    [sym_this] = ACTIONS(2673),
  },
  [258] = {
    [sym_identifier] = ACTIONS(2677),
    [aux_sym_preproc_include_token1] = ACTIONS(2677),
    [aux_sym_preproc_def_token1] = ACTIONS(2677),
    [aux_sym_preproc_if_token1] = ACTIONS(2677),
    [aux_sym_preproc_if_token2] = ACTIONS(2677),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2677),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2677),
    [aux_sym_preproc_else_token1] = ACTIONS(2677),
    [aux_sym_preproc_elif_token1] = ACTIONS(2677),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2677),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2677),
    [sym_preproc_directive] = ACTIONS(2677),
    [anon_sym_LPAREN2] = ACTIONS(2679),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_TILDE] = ACTIONS(2679),
    [anon_sym_DASH] = ACTIONS(2677),
    [anon_sym_PLUS] = ACTIONS(2677),
    [anon_sym_STAR] = ACTIONS(2679),
    [anon_sym_AMP_AMP] = ACTIONS(2679),
    [anon_sym_AMP] = ACTIONS(2677),
    [anon_sym_SEMI] = ACTIONS(2679),
    [anon_sym___extension__] = ACTIONS(2677),
    [anon_sym_typedef] = ACTIONS(2677),
    [anon_sym_virtual] = ACTIONS(2677),
    [anon_sym_extern] = ACTIONS(2677),
    [anon_sym___attribute__] = ACTIONS(2677),
    [anon_sym___attribute] = ACTIONS(2677),
    [anon_sym_COLON_COLON] = ACTIONS(2679),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2679),
    [anon_sym___declspec] = ACTIONS(2677),
    [anon_sym___based] = ACTIONS(2677),
    [anon_sym___cdecl] = ACTIONS(2677),
    [anon_sym___clrcall] = ACTIONS(2677),
    [anon_sym___stdcall] = ACTIONS(2677),
    [anon_sym___fastcall] = ACTIONS(2677),
    [anon_sym___thiscall] = ACTIONS(2677),
    [anon_sym___vectorcall] = ACTIONS(2677),
    [anon_sym_LBRACE] = ACTIONS(2679),
    [anon_sym_signed] = ACTIONS(2677),
    [anon_sym_unsigned] = ACTIONS(2677),
    [anon_sym_long] = ACTIONS(2677),
    [anon_sym_short] = ACTIONS(2677),
    [anon_sym_LBRACK] = ACTIONS(2677),
    [anon_sym_static] = ACTIONS(2677),
    [anon_sym_register] = ACTIONS(2677),
    [anon_sym_inline] = ACTIONS(2677),
    [anon_sym___inline] = ACTIONS(2677),
    [anon_sym___inline__] = ACTIONS(2677),
    [anon_sym___forceinline] = ACTIONS(2677),
    [anon_sym_thread_local] = ACTIONS(2677),
    [anon_sym___thread] = ACTIONS(2677),
    [anon_sym_const] = ACTIONS(2677),
    [anon_sym_constexpr] = ACTIONS(2677),
    [anon_sym_volatile] = ACTIONS(2677),
    [anon_sym_restrict] = ACTIONS(2677),
    [anon_sym___restrict__] = ACTIONS(2677),
    [anon_sym__Atomic] = ACTIONS(2677),
    [anon_sym__Noreturn] = ACTIONS(2677),
    [anon_sym_noreturn] = ACTIONS(2677),
    [anon_sym__Nonnull] = ACTIONS(2677),
    [anon_sym_mutable] = ACTIONS(2677),
    [anon_sym_constinit] = ACTIONS(2677),
    [anon_sym_consteval] = ACTIONS(2677),
    [anon_sym_alignas] = ACTIONS(2677),
    [anon_sym__Alignas] = ACTIONS(2677),
    [sym_primitive_type] = ACTIONS(2677),
    [anon_sym_enum] = ACTIONS(2677),
    [anon_sym_class] = ACTIONS(2677),
    [anon_sym_struct] = ACTIONS(2677),
    [anon_sym_union] = ACTIONS(2677),
    [anon_sym_if] = ACTIONS(2677),
    [anon_sym_else] = ACTIONS(2677),
    [anon_sym_switch] = ACTIONS(2677),
    [anon_sym_case] = ACTIONS(2677),
    [anon_sym_default] = ACTIONS(2677),
    [anon_sym_while] = ACTIONS(2677),
    [anon_sym_do] = ACTIONS(2677),
    [anon_sym_for] = ACTIONS(2677),
    [anon_sym_return] = ACTIONS(2677),
    [anon_sym_break] = ACTIONS(2677),
    [anon_sym_continue] = ACTIONS(2677),
    [anon_sym_goto] = ACTIONS(2677),
    [anon_sym___try] = ACTIONS(2677),
    [anon_sym___leave] = ACTIONS(2677),
    [anon_sym_not] = ACTIONS(2677),
    [anon_sym_compl] = ACTIONS(2677),
    [anon_sym_DASH_DASH] = ACTIONS(2679),
    [anon_sym_PLUS_PLUS] = ACTIONS(2679),
    [anon_sym_sizeof] = ACTIONS(2677),
    [anon_sym___alignof__] = ACTIONS(2677),
    [anon_sym___alignof] = ACTIONS(2677),
    [anon_sym__alignof] = ACTIONS(2677),
    [anon_sym_alignof] = ACTIONS(2677),
    [anon_sym__Alignof] = ACTIONS(2677),
    [anon_sym_offsetof] = ACTIONS(2677),
    [anon_sym__Generic] = ACTIONS(2677),
    [anon_sym_asm] = ACTIONS(2677),
    [anon_sym___asm__] = ACTIONS(2677),
    [anon_sym___asm] = ACTIONS(2677),
    [sym_number_literal] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2679),
    [anon_sym_u_SQUOTE] = ACTIONS(2679),
    [anon_sym_U_SQUOTE] = ACTIONS(2679),
    [anon_sym_u8_SQUOTE] = ACTIONS(2679),
    [anon_sym_SQUOTE] = ACTIONS(2679),
    [anon_sym_L_DQUOTE] = ACTIONS(2679),
    [anon_sym_u_DQUOTE] = ACTIONS(2679),
    [anon_sym_U_DQUOTE] = ACTIONS(2679),
    [anon_sym_u8_DQUOTE] = ACTIONS(2679),
    [anon_sym_DQUOTE] = ACTIONS(2679),
    [sym_true] = ACTIONS(2677),
    [sym_false] = ACTIONS(2677),
    [anon_sym_NULL] = ACTIONS(2677),
    [anon_sym_nullptr] = ACTIONS(2677),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2677),
    [anon_sym_decltype] = ACTIONS(2677),
    [anon_sym_explicit] = ACTIONS(2677),
    [anon_sym_typename] = ACTIONS(2677),
    [anon_sym_template] = ACTIONS(2677),
    [anon_sym_operator] = ACTIONS(2677),
    [anon_sym_try] = ACTIONS(2677),
    [anon_sym_delete] = ACTIONS(2677),
    [anon_sym_throw] = ACTIONS(2677),
    [anon_sym_namespace] = ACTIONS(2677),
    [anon_sym_using] = ACTIONS(2677),
    [anon_sym_static_assert] = ACTIONS(2677),
    [anon_sym_concept] = ACTIONS(2677),
    [anon_sym_co_return] = ACTIONS(2677),
    [anon_sym_co_yield] = ACTIONS(2677),
    [anon_sym_R_DQUOTE] = ACTIONS(2679),
    [anon_sym_LR_DQUOTE] = ACTIONS(2679),
    [anon_sym_uR_DQUOTE] = ACTIONS(2679),
    [anon_sym_UR_DQUOTE] = ACTIONS(2679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2679),
    [anon_sym_co_await] = ACTIONS(2677),
    [anon_sym_new] = ACTIONS(2677),
    [anon_sym_requires] = ACTIONS(2677),
    [sym_this] = ACTIONS(2677),
  },
  [259] = {
    [sym_identifier] = ACTIONS(2681),
    [aux_sym_preproc_include_token1] = ACTIONS(2681),
    [aux_sym_preproc_def_token1] = ACTIONS(2681),
    [aux_sym_preproc_if_token1] = ACTIONS(2681),
    [aux_sym_preproc_if_token2] = ACTIONS(2681),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2681),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2681),
    [aux_sym_preproc_else_token1] = ACTIONS(2681),
    [aux_sym_preproc_elif_token1] = ACTIONS(2681),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2681),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2681),
    [sym_preproc_directive] = ACTIONS(2681),
    [anon_sym_LPAREN2] = ACTIONS(2683),
    [anon_sym_BANG] = ACTIONS(2683),
    [anon_sym_TILDE] = ACTIONS(2683),
    [anon_sym_DASH] = ACTIONS(2681),
    [anon_sym_PLUS] = ACTIONS(2681),
    [anon_sym_STAR] = ACTIONS(2683),
    [anon_sym_AMP_AMP] = ACTIONS(2683),
    [anon_sym_AMP] = ACTIONS(2681),
    [anon_sym_SEMI] = ACTIONS(2683),
    [anon_sym___extension__] = ACTIONS(2681),
    [anon_sym_typedef] = ACTIONS(2681),
    [anon_sym_virtual] = ACTIONS(2681),
    [anon_sym_extern] = ACTIONS(2681),
    [anon_sym___attribute__] = ACTIONS(2681),
    [anon_sym___attribute] = ACTIONS(2681),
    [anon_sym_COLON_COLON] = ACTIONS(2683),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2683),
    [anon_sym___declspec] = ACTIONS(2681),
    [anon_sym___based] = ACTIONS(2681),
    [anon_sym___cdecl] = ACTIONS(2681),
    [anon_sym___clrcall] = ACTIONS(2681),
    [anon_sym___stdcall] = ACTIONS(2681),
    [anon_sym___fastcall] = ACTIONS(2681),
    [anon_sym___thiscall] = ACTIONS(2681),
    [anon_sym___vectorcall] = ACTIONS(2681),
    [anon_sym_LBRACE] = ACTIONS(2683),
    [anon_sym_signed] = ACTIONS(2681),
    [anon_sym_unsigned] = ACTIONS(2681),
    [anon_sym_long] = ACTIONS(2681),
    [anon_sym_short] = ACTIONS(2681),
    [anon_sym_LBRACK] = ACTIONS(2681),
    [anon_sym_static] = ACTIONS(2681),
    [anon_sym_register] = ACTIONS(2681),
    [anon_sym_inline] = ACTIONS(2681),
    [anon_sym___inline] = ACTIONS(2681),
    [anon_sym___inline__] = ACTIONS(2681),
    [anon_sym___forceinline] = ACTIONS(2681),
    [anon_sym_thread_local] = ACTIONS(2681),
    [anon_sym___thread] = ACTIONS(2681),
    [anon_sym_const] = ACTIONS(2681),
    [anon_sym_constexpr] = ACTIONS(2681),
    [anon_sym_volatile] = ACTIONS(2681),
    [anon_sym_restrict] = ACTIONS(2681),
    [anon_sym___restrict__] = ACTIONS(2681),
    [anon_sym__Atomic] = ACTIONS(2681),
    [anon_sym__Noreturn] = ACTIONS(2681),
    [anon_sym_noreturn] = ACTIONS(2681),
    [anon_sym__Nonnull] = ACTIONS(2681),
    [anon_sym_mutable] = ACTIONS(2681),
    [anon_sym_constinit] = ACTIONS(2681),
    [anon_sym_consteval] = ACTIONS(2681),
    [anon_sym_alignas] = ACTIONS(2681),
    [anon_sym__Alignas] = ACTIONS(2681),
    [sym_primitive_type] = ACTIONS(2681),
    [anon_sym_enum] = ACTIONS(2681),
    [anon_sym_class] = ACTIONS(2681),
    [anon_sym_struct] = ACTIONS(2681),
    [anon_sym_union] = ACTIONS(2681),
    [anon_sym_if] = ACTIONS(2681),
    [anon_sym_else] = ACTIONS(2681),
    [anon_sym_switch] = ACTIONS(2681),
    [anon_sym_case] = ACTIONS(2681),
    [anon_sym_default] = ACTIONS(2681),
    [anon_sym_while] = ACTIONS(2681),
    [anon_sym_do] = ACTIONS(2681),
    [anon_sym_for] = ACTIONS(2681),
    [anon_sym_return] = ACTIONS(2681),
    [anon_sym_break] = ACTIONS(2681),
    [anon_sym_continue] = ACTIONS(2681),
    [anon_sym_goto] = ACTIONS(2681),
    [anon_sym___try] = ACTIONS(2681),
    [anon_sym___leave] = ACTIONS(2681),
    [anon_sym_not] = ACTIONS(2681),
    [anon_sym_compl] = ACTIONS(2681),
    [anon_sym_DASH_DASH] = ACTIONS(2683),
    [anon_sym_PLUS_PLUS] = ACTIONS(2683),
    [anon_sym_sizeof] = ACTIONS(2681),
    [anon_sym___alignof__] = ACTIONS(2681),
    [anon_sym___alignof] = ACTIONS(2681),
    [anon_sym__alignof] = ACTIONS(2681),
    [anon_sym_alignof] = ACTIONS(2681),
    [anon_sym__Alignof] = ACTIONS(2681),
    [anon_sym_offsetof] = ACTIONS(2681),
    [anon_sym__Generic] = ACTIONS(2681),
    [anon_sym_asm] = ACTIONS(2681),
    [anon_sym___asm__] = ACTIONS(2681),
    [anon_sym___asm] = ACTIONS(2681),
    [sym_number_literal] = ACTIONS(2683),
    [anon_sym_L_SQUOTE] = ACTIONS(2683),
    [anon_sym_u_SQUOTE] = ACTIONS(2683),
    [anon_sym_U_SQUOTE] = ACTIONS(2683),
    [anon_sym_u8_SQUOTE] = ACTIONS(2683),
    [anon_sym_SQUOTE] = ACTIONS(2683),
    [anon_sym_L_DQUOTE] = ACTIONS(2683),
    [anon_sym_u_DQUOTE] = ACTIONS(2683),
    [anon_sym_U_DQUOTE] = ACTIONS(2683),
    [anon_sym_u8_DQUOTE] = ACTIONS(2683),
    [anon_sym_DQUOTE] = ACTIONS(2683),
    [sym_true] = ACTIONS(2681),
    [sym_false] = ACTIONS(2681),
    [anon_sym_NULL] = ACTIONS(2681),
    [anon_sym_nullptr] = ACTIONS(2681),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2681),
    [anon_sym_decltype] = ACTIONS(2681),
    [anon_sym_explicit] = ACTIONS(2681),
    [anon_sym_typename] = ACTIONS(2681),
    [anon_sym_template] = ACTIONS(2681),
    [anon_sym_operator] = ACTIONS(2681),
    [anon_sym_try] = ACTIONS(2681),
    [anon_sym_delete] = ACTIONS(2681),
    [anon_sym_throw] = ACTIONS(2681),
    [anon_sym_namespace] = ACTIONS(2681),
    [anon_sym_using] = ACTIONS(2681),
    [anon_sym_static_assert] = ACTIONS(2681),
    [anon_sym_concept] = ACTIONS(2681),
    [anon_sym_co_return] = ACTIONS(2681),
    [anon_sym_co_yield] = ACTIONS(2681),
    [anon_sym_R_DQUOTE] = ACTIONS(2683),
    [anon_sym_LR_DQUOTE] = ACTIONS(2683),
    [anon_sym_uR_DQUOTE] = ACTIONS(2683),
    [anon_sym_UR_DQUOTE] = ACTIONS(2683),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2683),
    [anon_sym_co_await] = ACTIONS(2681),
    [anon_sym_new] = ACTIONS(2681),
    [anon_sym_requires] = ACTIONS(2681),
    [sym_this] = ACTIONS(2681),
  },
  [260] = {
    [sym_identifier] = ACTIONS(2685),
    [aux_sym_preproc_include_token1] = ACTIONS(2685),
    [aux_sym_preproc_def_token1] = ACTIONS(2685),
    [aux_sym_preproc_if_token1] = ACTIONS(2685),
    [aux_sym_preproc_if_token2] = ACTIONS(2685),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2685),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2685),
    [aux_sym_preproc_else_token1] = ACTIONS(2685),
    [aux_sym_preproc_elif_token1] = ACTIONS(2685),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2685),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2685),
    [sym_preproc_directive] = ACTIONS(2685),
    [anon_sym_LPAREN2] = ACTIONS(2687),
    [anon_sym_BANG] = ACTIONS(2687),
    [anon_sym_TILDE] = ACTIONS(2687),
    [anon_sym_DASH] = ACTIONS(2685),
    [anon_sym_PLUS] = ACTIONS(2685),
    [anon_sym_STAR] = ACTIONS(2687),
    [anon_sym_AMP_AMP] = ACTIONS(2687),
    [anon_sym_AMP] = ACTIONS(2685),
    [anon_sym_SEMI] = ACTIONS(2687),
    [anon_sym___extension__] = ACTIONS(2685),
    [anon_sym_typedef] = ACTIONS(2685),
    [anon_sym_virtual] = ACTIONS(2685),
    [anon_sym_extern] = ACTIONS(2685),
    [anon_sym___attribute__] = ACTIONS(2685),
    [anon_sym___attribute] = ACTIONS(2685),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2687),
    [anon_sym___declspec] = ACTIONS(2685),
    [anon_sym___based] = ACTIONS(2685),
    [anon_sym___cdecl] = ACTIONS(2685),
    [anon_sym___clrcall] = ACTIONS(2685),
    [anon_sym___stdcall] = ACTIONS(2685),
    [anon_sym___fastcall] = ACTIONS(2685),
    [anon_sym___thiscall] = ACTIONS(2685),
    [anon_sym___vectorcall] = ACTIONS(2685),
    [anon_sym_LBRACE] = ACTIONS(2687),
    [anon_sym_signed] = ACTIONS(2685),
    [anon_sym_unsigned] = ACTIONS(2685),
    [anon_sym_long] = ACTIONS(2685),
    [anon_sym_short] = ACTIONS(2685),
    [anon_sym_LBRACK] = ACTIONS(2685),
    [anon_sym_static] = ACTIONS(2685),
    [anon_sym_register] = ACTIONS(2685),
    [anon_sym_inline] = ACTIONS(2685),
    [anon_sym___inline] = ACTIONS(2685),
    [anon_sym___inline__] = ACTIONS(2685),
    [anon_sym___forceinline] = ACTIONS(2685),
    [anon_sym_thread_local] = ACTIONS(2685),
    [anon_sym___thread] = ACTIONS(2685),
    [anon_sym_const] = ACTIONS(2685),
    [anon_sym_constexpr] = ACTIONS(2685),
    [anon_sym_volatile] = ACTIONS(2685),
    [anon_sym_restrict] = ACTIONS(2685),
    [anon_sym___restrict__] = ACTIONS(2685),
    [anon_sym__Atomic] = ACTIONS(2685),
    [anon_sym__Noreturn] = ACTIONS(2685),
    [anon_sym_noreturn] = ACTIONS(2685),
    [anon_sym__Nonnull] = ACTIONS(2685),
    [anon_sym_mutable] = ACTIONS(2685),
    [anon_sym_constinit] = ACTIONS(2685),
    [anon_sym_consteval] = ACTIONS(2685),
    [anon_sym_alignas] = ACTIONS(2685),
    [anon_sym__Alignas] = ACTIONS(2685),
    [sym_primitive_type] = ACTIONS(2685),
    [anon_sym_enum] = ACTIONS(2685),
    [anon_sym_class] = ACTIONS(2685),
    [anon_sym_struct] = ACTIONS(2685),
    [anon_sym_union] = ACTIONS(2685),
    [anon_sym_if] = ACTIONS(2685),
    [anon_sym_else] = ACTIONS(2685),
    [anon_sym_switch] = ACTIONS(2685),
    [anon_sym_case] = ACTIONS(2685),
    [anon_sym_default] = ACTIONS(2685),
    [anon_sym_while] = ACTIONS(2685),
    [anon_sym_do] = ACTIONS(2685),
    [anon_sym_for] = ACTIONS(2685),
    [anon_sym_return] = ACTIONS(2685),
    [anon_sym_break] = ACTIONS(2685),
    [anon_sym_continue] = ACTIONS(2685),
    [anon_sym_goto] = ACTIONS(2685),
    [anon_sym___try] = ACTIONS(2685),
    [anon_sym___leave] = ACTIONS(2685),
    [anon_sym_not] = ACTIONS(2685),
    [anon_sym_compl] = ACTIONS(2685),
    [anon_sym_DASH_DASH] = ACTIONS(2687),
    [anon_sym_PLUS_PLUS] = ACTIONS(2687),
    [anon_sym_sizeof] = ACTIONS(2685),
    [anon_sym___alignof__] = ACTIONS(2685),
    [anon_sym___alignof] = ACTIONS(2685),
    [anon_sym__alignof] = ACTIONS(2685),
    [anon_sym_alignof] = ACTIONS(2685),
    [anon_sym__Alignof] = ACTIONS(2685),
    [anon_sym_offsetof] = ACTIONS(2685),
    [anon_sym__Generic] = ACTIONS(2685),
    [anon_sym_asm] = ACTIONS(2685),
    [anon_sym___asm__] = ACTIONS(2685),
    [anon_sym___asm] = ACTIONS(2685),
    [sym_number_literal] = ACTIONS(2687),
    [anon_sym_L_SQUOTE] = ACTIONS(2687),
    [anon_sym_u_SQUOTE] = ACTIONS(2687),
    [anon_sym_U_SQUOTE] = ACTIONS(2687),
    [anon_sym_u8_SQUOTE] = ACTIONS(2687),
    [anon_sym_SQUOTE] = ACTIONS(2687),
    [anon_sym_L_DQUOTE] = ACTIONS(2687),
    [anon_sym_u_DQUOTE] = ACTIONS(2687),
    [anon_sym_U_DQUOTE] = ACTIONS(2687),
    [anon_sym_u8_DQUOTE] = ACTIONS(2687),
    [anon_sym_DQUOTE] = ACTIONS(2687),
    [sym_true] = ACTIONS(2685),
    [sym_false] = ACTIONS(2685),
    [anon_sym_NULL] = ACTIONS(2685),
    [anon_sym_nullptr] = ACTIONS(2685),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2685),
    [anon_sym_decltype] = ACTIONS(2685),
    [anon_sym_explicit] = ACTIONS(2685),
    [anon_sym_typename] = ACTIONS(2685),
    [anon_sym_template] = ACTIONS(2685),
    [anon_sym_operator] = ACTIONS(2685),
    [anon_sym_try] = ACTIONS(2685),
    [anon_sym_delete] = ACTIONS(2685),
    [anon_sym_throw] = ACTIONS(2685),
    [anon_sym_namespace] = ACTIONS(2685),
    [anon_sym_using] = ACTIONS(2685),
    [anon_sym_static_assert] = ACTIONS(2685),
    [anon_sym_concept] = ACTIONS(2685),
    [anon_sym_co_return] = ACTIONS(2685),
    [anon_sym_co_yield] = ACTIONS(2685),
    [anon_sym_R_DQUOTE] = ACTIONS(2687),
    [anon_sym_LR_DQUOTE] = ACTIONS(2687),
    [anon_sym_uR_DQUOTE] = ACTIONS(2687),
    [anon_sym_UR_DQUOTE] = ACTIONS(2687),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2687),
    [anon_sym_co_await] = ACTIONS(2685),
    [anon_sym_new] = ACTIONS(2685),
    [anon_sym_requires] = ACTIONS(2685),
    [sym_this] = ACTIONS(2685),
  },
  [261] = {
    [sym_identifier] = ACTIONS(2689),
    [aux_sym_preproc_include_token1] = ACTIONS(2689),
    [aux_sym_preproc_def_token1] = ACTIONS(2689),
    [aux_sym_preproc_if_token1] = ACTIONS(2689),
    [aux_sym_preproc_if_token2] = ACTIONS(2689),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2689),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2689),
    [aux_sym_preproc_else_token1] = ACTIONS(2689),
    [aux_sym_preproc_elif_token1] = ACTIONS(2689),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2689),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2689),
    [sym_preproc_directive] = ACTIONS(2689),
    [anon_sym_LPAREN2] = ACTIONS(2691),
    [anon_sym_BANG] = ACTIONS(2691),
    [anon_sym_TILDE] = ACTIONS(2691),
    [anon_sym_DASH] = ACTIONS(2689),
    [anon_sym_PLUS] = ACTIONS(2689),
    [anon_sym_STAR] = ACTIONS(2691),
    [anon_sym_AMP_AMP] = ACTIONS(2691),
    [anon_sym_AMP] = ACTIONS(2689),
    [anon_sym_SEMI] = ACTIONS(2691),
    [anon_sym___extension__] = ACTIONS(2689),
    [anon_sym_typedef] = ACTIONS(2689),
    [anon_sym_virtual] = ACTIONS(2689),
    [anon_sym_extern] = ACTIONS(2689),
    [anon_sym___attribute__] = ACTIONS(2689),
    [anon_sym___attribute] = ACTIONS(2689),
    [anon_sym_COLON_COLON] = ACTIONS(2691),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2691),
    [anon_sym___declspec] = ACTIONS(2689),
    [anon_sym___based] = ACTIONS(2689),
    [anon_sym___cdecl] = ACTIONS(2689),
    [anon_sym___clrcall] = ACTIONS(2689),
    [anon_sym___stdcall] = ACTIONS(2689),
    [anon_sym___fastcall] = ACTIONS(2689),
    [anon_sym___thiscall] = ACTIONS(2689),
    [anon_sym___vectorcall] = ACTIONS(2689),
    [anon_sym_LBRACE] = ACTIONS(2691),
    [anon_sym_signed] = ACTIONS(2689),
    [anon_sym_unsigned] = ACTIONS(2689),
    [anon_sym_long] = ACTIONS(2689),
    [anon_sym_short] = ACTIONS(2689),
    [anon_sym_LBRACK] = ACTIONS(2689),
    [anon_sym_static] = ACTIONS(2689),
    [anon_sym_register] = ACTIONS(2689),
    [anon_sym_inline] = ACTIONS(2689),
    [anon_sym___inline] = ACTIONS(2689),
    [anon_sym___inline__] = ACTIONS(2689),
    [anon_sym___forceinline] = ACTIONS(2689),
    [anon_sym_thread_local] = ACTIONS(2689),
    [anon_sym___thread] = ACTIONS(2689),
    [anon_sym_const] = ACTIONS(2689),
    [anon_sym_constexpr] = ACTIONS(2689),
    [anon_sym_volatile] = ACTIONS(2689),
    [anon_sym_restrict] = ACTIONS(2689),
    [anon_sym___restrict__] = ACTIONS(2689),
    [anon_sym__Atomic] = ACTIONS(2689),
    [anon_sym__Noreturn] = ACTIONS(2689),
    [anon_sym_noreturn] = ACTIONS(2689),
    [anon_sym__Nonnull] = ACTIONS(2689),
    [anon_sym_mutable] = ACTIONS(2689),
    [anon_sym_constinit] = ACTIONS(2689),
    [anon_sym_consteval] = ACTIONS(2689),
    [anon_sym_alignas] = ACTIONS(2689),
    [anon_sym__Alignas] = ACTIONS(2689),
    [sym_primitive_type] = ACTIONS(2689),
    [anon_sym_enum] = ACTIONS(2689),
    [anon_sym_class] = ACTIONS(2689),
    [anon_sym_struct] = ACTIONS(2689),
    [anon_sym_union] = ACTIONS(2689),
    [anon_sym_if] = ACTIONS(2689),
    [anon_sym_else] = ACTIONS(2689),
    [anon_sym_switch] = ACTIONS(2689),
    [anon_sym_case] = ACTIONS(2689),
    [anon_sym_default] = ACTIONS(2689),
    [anon_sym_while] = ACTIONS(2689),
    [anon_sym_do] = ACTIONS(2689),
    [anon_sym_for] = ACTIONS(2689),
    [anon_sym_return] = ACTIONS(2689),
    [anon_sym_break] = ACTIONS(2689),
    [anon_sym_continue] = ACTIONS(2689),
    [anon_sym_goto] = ACTIONS(2689),
    [anon_sym___try] = ACTIONS(2689),
    [anon_sym___leave] = ACTIONS(2689),
    [anon_sym_not] = ACTIONS(2689),
    [anon_sym_compl] = ACTIONS(2689),
    [anon_sym_DASH_DASH] = ACTIONS(2691),
    [anon_sym_PLUS_PLUS] = ACTIONS(2691),
    [anon_sym_sizeof] = ACTIONS(2689),
    [anon_sym___alignof__] = ACTIONS(2689),
    [anon_sym___alignof] = ACTIONS(2689),
    [anon_sym__alignof] = ACTIONS(2689),
    [anon_sym_alignof] = ACTIONS(2689),
    [anon_sym__Alignof] = ACTIONS(2689),
    [anon_sym_offsetof] = ACTIONS(2689),
    [anon_sym__Generic] = ACTIONS(2689),
    [anon_sym_asm] = ACTIONS(2689),
    [anon_sym___asm__] = ACTIONS(2689),
    [anon_sym___asm] = ACTIONS(2689),
    [sym_number_literal] = ACTIONS(2691),
    [anon_sym_L_SQUOTE] = ACTIONS(2691),
    [anon_sym_u_SQUOTE] = ACTIONS(2691),
    [anon_sym_U_SQUOTE] = ACTIONS(2691),
    [anon_sym_u8_SQUOTE] = ACTIONS(2691),
    [anon_sym_SQUOTE] = ACTIONS(2691),
    [anon_sym_L_DQUOTE] = ACTIONS(2691),
    [anon_sym_u_DQUOTE] = ACTIONS(2691),
    [anon_sym_U_DQUOTE] = ACTIONS(2691),
    [anon_sym_u8_DQUOTE] = ACTIONS(2691),
    [anon_sym_DQUOTE] = ACTIONS(2691),
    [sym_true] = ACTIONS(2689),
    [sym_false] = ACTIONS(2689),
    [anon_sym_NULL] = ACTIONS(2689),
    [anon_sym_nullptr] = ACTIONS(2689),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2689),
    [anon_sym_decltype] = ACTIONS(2689),
    [anon_sym_explicit] = ACTIONS(2689),
    [anon_sym_typename] = ACTIONS(2689),
    [anon_sym_template] = ACTIONS(2689),
    [anon_sym_operator] = ACTIONS(2689),
    [anon_sym_try] = ACTIONS(2689),
    [anon_sym_delete] = ACTIONS(2689),
    [anon_sym_throw] = ACTIONS(2689),
    [anon_sym_namespace] = ACTIONS(2689),
    [anon_sym_using] = ACTIONS(2689),
    [anon_sym_static_assert] = ACTIONS(2689),
    [anon_sym_concept] = ACTIONS(2689),
    [anon_sym_co_return] = ACTIONS(2689),
    [anon_sym_co_yield] = ACTIONS(2689),
    [anon_sym_R_DQUOTE] = ACTIONS(2691),
    [anon_sym_LR_DQUOTE] = ACTIONS(2691),
    [anon_sym_uR_DQUOTE] = ACTIONS(2691),
    [anon_sym_UR_DQUOTE] = ACTIONS(2691),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2691),
    [anon_sym_co_await] = ACTIONS(2689),
    [anon_sym_new] = ACTIONS(2689),
    [anon_sym_requires] = ACTIONS(2689),
    [sym_this] = ACTIONS(2689),
  },
  [262] = {
    [sym_identifier] = ACTIONS(2693),
    [aux_sym_preproc_include_token1] = ACTIONS(2693),
    [aux_sym_preproc_def_token1] = ACTIONS(2693),
    [aux_sym_preproc_if_token1] = ACTIONS(2693),
    [aux_sym_preproc_if_token2] = ACTIONS(2693),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2693),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2693),
    [aux_sym_preproc_else_token1] = ACTIONS(2693),
    [aux_sym_preproc_elif_token1] = ACTIONS(2693),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2693),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2693),
    [sym_preproc_directive] = ACTIONS(2693),
    [anon_sym_LPAREN2] = ACTIONS(2695),
    [anon_sym_BANG] = ACTIONS(2695),
    [anon_sym_TILDE] = ACTIONS(2695),
    [anon_sym_DASH] = ACTIONS(2693),
    [anon_sym_PLUS] = ACTIONS(2693),
    [anon_sym_STAR] = ACTIONS(2695),
    [anon_sym_AMP_AMP] = ACTIONS(2695),
    [anon_sym_AMP] = ACTIONS(2693),
    [anon_sym_SEMI] = ACTIONS(2695),
    [anon_sym___extension__] = ACTIONS(2693),
    [anon_sym_typedef] = ACTIONS(2693),
    [anon_sym_virtual] = ACTIONS(2693),
    [anon_sym_extern] = ACTIONS(2693),
    [anon_sym___attribute__] = ACTIONS(2693),
    [anon_sym___attribute] = ACTIONS(2693),
    [anon_sym_COLON_COLON] = ACTIONS(2695),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2695),
    [anon_sym___declspec] = ACTIONS(2693),
    [anon_sym___based] = ACTIONS(2693),
    [anon_sym___cdecl] = ACTIONS(2693),
    [anon_sym___clrcall] = ACTIONS(2693),
    [anon_sym___stdcall] = ACTIONS(2693),
    [anon_sym___fastcall] = ACTIONS(2693),
    [anon_sym___thiscall] = ACTIONS(2693),
    [anon_sym___vectorcall] = ACTIONS(2693),
    [anon_sym_LBRACE] = ACTIONS(2695),
    [anon_sym_signed] = ACTIONS(2693),
    [anon_sym_unsigned] = ACTIONS(2693),
    [anon_sym_long] = ACTIONS(2693),
    [anon_sym_short] = ACTIONS(2693),
    [anon_sym_LBRACK] = ACTIONS(2693),
    [anon_sym_static] = ACTIONS(2693),
    [anon_sym_register] = ACTIONS(2693),
    [anon_sym_inline] = ACTIONS(2693),
    [anon_sym___inline] = ACTIONS(2693),
    [anon_sym___inline__] = ACTIONS(2693),
    [anon_sym___forceinline] = ACTIONS(2693),
    [anon_sym_thread_local] = ACTIONS(2693),
    [anon_sym___thread] = ACTIONS(2693),
    [anon_sym_const] = ACTIONS(2693),
    [anon_sym_constexpr] = ACTIONS(2693),
    [anon_sym_volatile] = ACTIONS(2693),
    [anon_sym_restrict] = ACTIONS(2693),
    [anon_sym___restrict__] = ACTIONS(2693),
    [anon_sym__Atomic] = ACTIONS(2693),
    [anon_sym__Noreturn] = ACTIONS(2693),
    [anon_sym_noreturn] = ACTIONS(2693),
    [anon_sym__Nonnull] = ACTIONS(2693),
    [anon_sym_mutable] = ACTIONS(2693),
    [anon_sym_constinit] = ACTIONS(2693),
    [anon_sym_consteval] = ACTIONS(2693),
    [anon_sym_alignas] = ACTIONS(2693),
    [anon_sym__Alignas] = ACTIONS(2693),
    [sym_primitive_type] = ACTIONS(2693),
    [anon_sym_enum] = ACTIONS(2693),
    [anon_sym_class] = ACTIONS(2693),
    [anon_sym_struct] = ACTIONS(2693),
    [anon_sym_union] = ACTIONS(2693),
    [anon_sym_if] = ACTIONS(2693),
    [anon_sym_else] = ACTIONS(2693),
    [anon_sym_switch] = ACTIONS(2693),
    [anon_sym_case] = ACTIONS(2693),
    [anon_sym_default] = ACTIONS(2693),
    [anon_sym_while] = ACTIONS(2693),
    [anon_sym_do] = ACTIONS(2693),
    [anon_sym_for] = ACTIONS(2693),
    [anon_sym_return] = ACTIONS(2693),
    [anon_sym_break] = ACTIONS(2693),
    [anon_sym_continue] = ACTIONS(2693),
    [anon_sym_goto] = ACTIONS(2693),
    [anon_sym___try] = ACTIONS(2693),
    [anon_sym___leave] = ACTIONS(2693),
    [anon_sym_not] = ACTIONS(2693),
    [anon_sym_compl] = ACTIONS(2693),
    [anon_sym_DASH_DASH] = ACTIONS(2695),
    [anon_sym_PLUS_PLUS] = ACTIONS(2695),
    [anon_sym_sizeof] = ACTIONS(2693),
    [anon_sym___alignof__] = ACTIONS(2693),
    [anon_sym___alignof] = ACTIONS(2693),
    [anon_sym__alignof] = ACTIONS(2693),
    [anon_sym_alignof] = ACTIONS(2693),
    [anon_sym__Alignof] = ACTIONS(2693),
    [anon_sym_offsetof] = ACTIONS(2693),
    [anon_sym__Generic] = ACTIONS(2693),
    [anon_sym_asm] = ACTIONS(2693),
    [anon_sym___asm__] = ACTIONS(2693),
    [anon_sym___asm] = ACTIONS(2693),
    [sym_number_literal] = ACTIONS(2695),
    [anon_sym_L_SQUOTE] = ACTIONS(2695),
    [anon_sym_u_SQUOTE] = ACTIONS(2695),
    [anon_sym_U_SQUOTE] = ACTIONS(2695),
    [anon_sym_u8_SQUOTE] = ACTIONS(2695),
    [anon_sym_SQUOTE] = ACTIONS(2695),
    [anon_sym_L_DQUOTE] = ACTIONS(2695),
    [anon_sym_u_DQUOTE] = ACTIONS(2695),
    [anon_sym_U_DQUOTE] = ACTIONS(2695),
    [anon_sym_u8_DQUOTE] = ACTIONS(2695),
    [anon_sym_DQUOTE] = ACTIONS(2695),
    [sym_true] = ACTIONS(2693),
    [sym_false] = ACTIONS(2693),
    [anon_sym_NULL] = ACTIONS(2693),
    [anon_sym_nullptr] = ACTIONS(2693),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2693),
    [anon_sym_decltype] = ACTIONS(2693),
    [anon_sym_explicit] = ACTIONS(2693),
    [anon_sym_typename] = ACTIONS(2693),
    [anon_sym_template] = ACTIONS(2693),
    [anon_sym_operator] = ACTIONS(2693),
    [anon_sym_try] = ACTIONS(2693),
    [anon_sym_delete] = ACTIONS(2693),
    [anon_sym_throw] = ACTIONS(2693),
    [anon_sym_namespace] = ACTIONS(2693),
    [anon_sym_using] = ACTIONS(2693),
    [anon_sym_static_assert] = ACTIONS(2693),
    [anon_sym_concept] = ACTIONS(2693),
    [anon_sym_co_return] = ACTIONS(2693),
    [anon_sym_co_yield] = ACTIONS(2693),
    [anon_sym_R_DQUOTE] = ACTIONS(2695),
    [anon_sym_LR_DQUOTE] = ACTIONS(2695),
    [anon_sym_uR_DQUOTE] = ACTIONS(2695),
    [anon_sym_UR_DQUOTE] = ACTIONS(2695),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2695),
    [anon_sym_co_await] = ACTIONS(2693),
    [anon_sym_new] = ACTIONS(2693),
    [anon_sym_requires] = ACTIONS(2693),
    [sym_this] = ACTIONS(2693),
  },
  [263] = {
    [sym_identifier] = ACTIONS(2697),
    [aux_sym_preproc_include_token1] = ACTIONS(2697),
    [aux_sym_preproc_def_token1] = ACTIONS(2697),
    [aux_sym_preproc_if_token1] = ACTIONS(2697),
    [aux_sym_preproc_if_token2] = ACTIONS(2697),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2697),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2697),
    [aux_sym_preproc_else_token1] = ACTIONS(2697),
    [aux_sym_preproc_elif_token1] = ACTIONS(2697),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2697),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2697),
    [sym_preproc_directive] = ACTIONS(2697),
    [anon_sym_LPAREN2] = ACTIONS(2699),
    [anon_sym_BANG] = ACTIONS(2699),
    [anon_sym_TILDE] = ACTIONS(2699),
    [anon_sym_DASH] = ACTIONS(2697),
    [anon_sym_PLUS] = ACTIONS(2697),
    [anon_sym_STAR] = ACTIONS(2699),
    [anon_sym_AMP_AMP] = ACTIONS(2699),
    [anon_sym_AMP] = ACTIONS(2697),
    [anon_sym_SEMI] = ACTIONS(2699),
    [anon_sym___extension__] = ACTIONS(2697),
    [anon_sym_typedef] = ACTIONS(2697),
    [anon_sym_virtual] = ACTIONS(2697),
    [anon_sym_extern] = ACTIONS(2697),
    [anon_sym___attribute__] = ACTIONS(2697),
    [anon_sym___attribute] = ACTIONS(2697),
    [anon_sym_COLON_COLON] = ACTIONS(2699),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2699),
    [anon_sym___declspec] = ACTIONS(2697),
    [anon_sym___based] = ACTIONS(2697),
    [anon_sym___cdecl] = ACTIONS(2697),
    [anon_sym___clrcall] = ACTIONS(2697),
    [anon_sym___stdcall] = ACTIONS(2697),
    [anon_sym___fastcall] = ACTIONS(2697),
    [anon_sym___thiscall] = ACTIONS(2697),
    [anon_sym___vectorcall] = ACTIONS(2697),
    [anon_sym_LBRACE] = ACTIONS(2699),
    [anon_sym_signed] = ACTIONS(2697),
    [anon_sym_unsigned] = ACTIONS(2697),
    [anon_sym_long] = ACTIONS(2697),
    [anon_sym_short] = ACTIONS(2697),
    [anon_sym_LBRACK] = ACTIONS(2697),
    [anon_sym_static] = ACTIONS(2697),
    [anon_sym_register] = ACTIONS(2697),
    [anon_sym_inline] = ACTIONS(2697),
    [anon_sym___inline] = ACTIONS(2697),
    [anon_sym___inline__] = ACTIONS(2697),
    [anon_sym___forceinline] = ACTIONS(2697),
    [anon_sym_thread_local] = ACTIONS(2697),
    [anon_sym___thread] = ACTIONS(2697),
    [anon_sym_const] = ACTIONS(2697),
    [anon_sym_constexpr] = ACTIONS(2697),
    [anon_sym_volatile] = ACTIONS(2697),
    [anon_sym_restrict] = ACTIONS(2697),
    [anon_sym___restrict__] = ACTIONS(2697),
    [anon_sym__Atomic] = ACTIONS(2697),
    [anon_sym__Noreturn] = ACTIONS(2697),
    [anon_sym_noreturn] = ACTIONS(2697),
    [anon_sym__Nonnull] = ACTIONS(2697),
    [anon_sym_mutable] = ACTIONS(2697),
    [anon_sym_constinit] = ACTIONS(2697),
    [anon_sym_consteval] = ACTIONS(2697),
    [anon_sym_alignas] = ACTIONS(2697),
    [anon_sym__Alignas] = ACTIONS(2697),
    [sym_primitive_type] = ACTIONS(2697),
    [anon_sym_enum] = ACTIONS(2697),
    [anon_sym_class] = ACTIONS(2697),
    [anon_sym_struct] = ACTIONS(2697),
    [anon_sym_union] = ACTIONS(2697),
    [anon_sym_if] = ACTIONS(2697),
    [anon_sym_else] = ACTIONS(2697),
    [anon_sym_switch] = ACTIONS(2697),
    [anon_sym_case] = ACTIONS(2697),
    [anon_sym_default] = ACTIONS(2697),
    [anon_sym_while] = ACTIONS(2697),
    [anon_sym_do] = ACTIONS(2697),
    [anon_sym_for] = ACTIONS(2697),
    [anon_sym_return] = ACTIONS(2697),
    [anon_sym_break] = ACTIONS(2697),
    [anon_sym_continue] = ACTIONS(2697),
    [anon_sym_goto] = ACTIONS(2697),
    [anon_sym___try] = ACTIONS(2697),
    [anon_sym___leave] = ACTIONS(2697),
    [anon_sym_not] = ACTIONS(2697),
    [anon_sym_compl] = ACTIONS(2697),
    [anon_sym_DASH_DASH] = ACTIONS(2699),
    [anon_sym_PLUS_PLUS] = ACTIONS(2699),
    [anon_sym_sizeof] = ACTIONS(2697),
    [anon_sym___alignof__] = ACTIONS(2697),
    [anon_sym___alignof] = ACTIONS(2697),
    [anon_sym__alignof] = ACTIONS(2697),
    [anon_sym_alignof] = ACTIONS(2697),
    [anon_sym__Alignof] = ACTIONS(2697),
    [anon_sym_offsetof] = ACTIONS(2697),
    [anon_sym__Generic] = ACTIONS(2697),
    [anon_sym_asm] = ACTIONS(2697),
    [anon_sym___asm__] = ACTIONS(2697),
    [anon_sym___asm] = ACTIONS(2697),
    [sym_number_literal] = ACTIONS(2699),
    [anon_sym_L_SQUOTE] = ACTIONS(2699),
    [anon_sym_u_SQUOTE] = ACTIONS(2699),
    [anon_sym_U_SQUOTE] = ACTIONS(2699),
    [anon_sym_u8_SQUOTE] = ACTIONS(2699),
    [anon_sym_SQUOTE] = ACTIONS(2699),
    [anon_sym_L_DQUOTE] = ACTIONS(2699),
    [anon_sym_u_DQUOTE] = ACTIONS(2699),
    [anon_sym_U_DQUOTE] = ACTIONS(2699),
    [anon_sym_u8_DQUOTE] = ACTIONS(2699),
    [anon_sym_DQUOTE] = ACTIONS(2699),
    [sym_true] = ACTIONS(2697),
    [sym_false] = ACTIONS(2697),
    [anon_sym_NULL] = ACTIONS(2697),
    [anon_sym_nullptr] = ACTIONS(2697),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2697),
    [anon_sym_decltype] = ACTIONS(2697),
    [anon_sym_explicit] = ACTIONS(2697),
    [anon_sym_typename] = ACTIONS(2697),
    [anon_sym_template] = ACTIONS(2697),
    [anon_sym_operator] = ACTIONS(2697),
    [anon_sym_try] = ACTIONS(2697),
    [anon_sym_delete] = ACTIONS(2697),
    [anon_sym_throw] = ACTIONS(2697),
    [anon_sym_namespace] = ACTIONS(2697),
    [anon_sym_using] = ACTIONS(2697),
    [anon_sym_static_assert] = ACTIONS(2697),
    [anon_sym_concept] = ACTIONS(2697),
    [anon_sym_co_return] = ACTIONS(2697),
    [anon_sym_co_yield] = ACTIONS(2697),
    [anon_sym_R_DQUOTE] = ACTIONS(2699),
    [anon_sym_LR_DQUOTE] = ACTIONS(2699),
    [anon_sym_uR_DQUOTE] = ACTIONS(2699),
    [anon_sym_UR_DQUOTE] = ACTIONS(2699),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2699),
    [anon_sym_co_await] = ACTIONS(2697),
    [anon_sym_new] = ACTIONS(2697),
    [anon_sym_requires] = ACTIONS(2697),
    [sym_this] = ACTIONS(2697),
  },
  [264] = {
    [sym_identifier] = ACTIONS(2701),
    [aux_sym_preproc_include_token1] = ACTIONS(2701),
    [aux_sym_preproc_def_token1] = ACTIONS(2701),
    [aux_sym_preproc_if_token1] = ACTIONS(2701),
    [aux_sym_preproc_if_token2] = ACTIONS(2701),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2701),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2701),
    [aux_sym_preproc_else_token1] = ACTIONS(2701),
    [aux_sym_preproc_elif_token1] = ACTIONS(2701),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2701),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2701),
    [sym_preproc_directive] = ACTIONS(2701),
    [anon_sym_LPAREN2] = ACTIONS(2703),
    [anon_sym_BANG] = ACTIONS(2703),
    [anon_sym_TILDE] = ACTIONS(2703),
    [anon_sym_DASH] = ACTIONS(2701),
    [anon_sym_PLUS] = ACTIONS(2701),
    [anon_sym_STAR] = ACTIONS(2703),
    [anon_sym_AMP_AMP] = ACTIONS(2703),
    [anon_sym_AMP] = ACTIONS(2701),
    [anon_sym_SEMI] = ACTIONS(2703),
    [anon_sym___extension__] = ACTIONS(2701),
    [anon_sym_typedef] = ACTIONS(2701),
    [anon_sym_virtual] = ACTIONS(2701),
    [anon_sym_extern] = ACTIONS(2701),
    [anon_sym___attribute__] = ACTIONS(2701),
    [anon_sym___attribute] = ACTIONS(2701),
    [anon_sym_COLON_COLON] = ACTIONS(2703),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2703),
    [anon_sym___declspec] = ACTIONS(2701),
    [anon_sym___based] = ACTIONS(2701),
    [anon_sym___cdecl] = ACTIONS(2701),
    [anon_sym___clrcall] = ACTIONS(2701),
    [anon_sym___stdcall] = ACTIONS(2701),
    [anon_sym___fastcall] = ACTIONS(2701),
    [anon_sym___thiscall] = ACTIONS(2701),
    [anon_sym___vectorcall] = ACTIONS(2701),
    [anon_sym_LBRACE] = ACTIONS(2703),
    [anon_sym_signed] = ACTIONS(2701),
    [anon_sym_unsigned] = ACTIONS(2701),
    [anon_sym_long] = ACTIONS(2701),
    [anon_sym_short] = ACTIONS(2701),
    [anon_sym_LBRACK] = ACTIONS(2701),
    [anon_sym_static] = ACTIONS(2701),
    [anon_sym_register] = ACTIONS(2701),
    [anon_sym_inline] = ACTIONS(2701),
    [anon_sym___inline] = ACTIONS(2701),
    [anon_sym___inline__] = ACTIONS(2701),
    [anon_sym___forceinline] = ACTIONS(2701),
    [anon_sym_thread_local] = ACTIONS(2701),
    [anon_sym___thread] = ACTIONS(2701),
    [anon_sym_const] = ACTIONS(2701),
    [anon_sym_constexpr] = ACTIONS(2701),
    [anon_sym_volatile] = ACTIONS(2701),
    [anon_sym_restrict] = ACTIONS(2701),
    [anon_sym___restrict__] = ACTIONS(2701),
    [anon_sym__Atomic] = ACTIONS(2701),
    [anon_sym__Noreturn] = ACTIONS(2701),
    [anon_sym_noreturn] = ACTIONS(2701),
    [anon_sym__Nonnull] = ACTIONS(2701),
    [anon_sym_mutable] = ACTIONS(2701),
    [anon_sym_constinit] = ACTIONS(2701),
    [anon_sym_consteval] = ACTIONS(2701),
    [anon_sym_alignas] = ACTIONS(2701),
    [anon_sym__Alignas] = ACTIONS(2701),
    [sym_primitive_type] = ACTIONS(2701),
    [anon_sym_enum] = ACTIONS(2701),
    [anon_sym_class] = ACTIONS(2701),
    [anon_sym_struct] = ACTIONS(2701),
    [anon_sym_union] = ACTIONS(2701),
    [anon_sym_if] = ACTIONS(2701),
    [anon_sym_else] = ACTIONS(2701),
    [anon_sym_switch] = ACTIONS(2701),
    [anon_sym_case] = ACTIONS(2701),
    [anon_sym_default] = ACTIONS(2701),
    [anon_sym_while] = ACTIONS(2701),
    [anon_sym_do] = ACTIONS(2701),
    [anon_sym_for] = ACTIONS(2701),
    [anon_sym_return] = ACTIONS(2701),
    [anon_sym_break] = ACTIONS(2701),
    [anon_sym_continue] = ACTIONS(2701),
    [anon_sym_goto] = ACTIONS(2701),
    [anon_sym___try] = ACTIONS(2701),
    [anon_sym___leave] = ACTIONS(2701),
    [anon_sym_not] = ACTIONS(2701),
    [anon_sym_compl] = ACTIONS(2701),
    [anon_sym_DASH_DASH] = ACTIONS(2703),
    [anon_sym_PLUS_PLUS] = ACTIONS(2703),
    [anon_sym_sizeof] = ACTIONS(2701),
    [anon_sym___alignof__] = ACTIONS(2701),
    [anon_sym___alignof] = ACTIONS(2701),
    [anon_sym__alignof] = ACTIONS(2701),
    [anon_sym_alignof] = ACTIONS(2701),
    [anon_sym__Alignof] = ACTIONS(2701),
    [anon_sym_offsetof] = ACTIONS(2701),
    [anon_sym__Generic] = ACTIONS(2701),
    [anon_sym_asm] = ACTIONS(2701),
    [anon_sym___asm__] = ACTIONS(2701),
    [anon_sym___asm] = ACTIONS(2701),
    [sym_number_literal] = ACTIONS(2703),
    [anon_sym_L_SQUOTE] = ACTIONS(2703),
    [anon_sym_u_SQUOTE] = ACTIONS(2703),
    [anon_sym_U_SQUOTE] = ACTIONS(2703),
    [anon_sym_u8_SQUOTE] = ACTIONS(2703),
    [anon_sym_SQUOTE] = ACTIONS(2703),
    [anon_sym_L_DQUOTE] = ACTIONS(2703),
    [anon_sym_u_DQUOTE] = ACTIONS(2703),
    [anon_sym_U_DQUOTE] = ACTIONS(2703),
    [anon_sym_u8_DQUOTE] = ACTIONS(2703),
    [anon_sym_DQUOTE] = ACTIONS(2703),
    [sym_true] = ACTIONS(2701),
    [sym_false] = ACTIONS(2701),
    [anon_sym_NULL] = ACTIONS(2701),
    [anon_sym_nullptr] = ACTIONS(2701),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2701),
    [anon_sym_decltype] = ACTIONS(2701),
    [anon_sym_explicit] = ACTIONS(2701),
    [anon_sym_typename] = ACTIONS(2701),
    [anon_sym_template] = ACTIONS(2701),
    [anon_sym_operator] = ACTIONS(2701),
    [anon_sym_try] = ACTIONS(2701),
    [anon_sym_delete] = ACTIONS(2701),
    [anon_sym_throw] = ACTIONS(2701),
    [anon_sym_namespace] = ACTIONS(2701),
    [anon_sym_using] = ACTIONS(2701),
    [anon_sym_static_assert] = ACTIONS(2701),
    [anon_sym_concept] = ACTIONS(2701),
    [anon_sym_co_return] = ACTIONS(2701),
    [anon_sym_co_yield] = ACTIONS(2701),
    [anon_sym_R_DQUOTE] = ACTIONS(2703),
    [anon_sym_LR_DQUOTE] = ACTIONS(2703),
    [anon_sym_uR_DQUOTE] = ACTIONS(2703),
    [anon_sym_UR_DQUOTE] = ACTIONS(2703),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2703),
    [anon_sym_co_await] = ACTIONS(2701),
    [anon_sym_new] = ACTIONS(2701),
    [anon_sym_requires] = ACTIONS(2701),
    [sym_this] = ACTIONS(2701),
  },
  [265] = {
    [sym_identifier] = ACTIONS(2705),
    [aux_sym_preproc_include_token1] = ACTIONS(2705),
    [aux_sym_preproc_def_token1] = ACTIONS(2705),
    [aux_sym_preproc_if_token1] = ACTIONS(2705),
    [aux_sym_preproc_if_token2] = ACTIONS(2705),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2705),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2705),
    [aux_sym_preproc_else_token1] = ACTIONS(2705),
    [aux_sym_preproc_elif_token1] = ACTIONS(2705),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2705),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2705),
    [sym_preproc_directive] = ACTIONS(2705),
    [anon_sym_LPAREN2] = ACTIONS(2707),
    [anon_sym_BANG] = ACTIONS(2707),
    [anon_sym_TILDE] = ACTIONS(2707),
    [anon_sym_DASH] = ACTIONS(2705),
    [anon_sym_PLUS] = ACTIONS(2705),
    [anon_sym_STAR] = ACTIONS(2707),
    [anon_sym_AMP_AMP] = ACTIONS(2707),
    [anon_sym_AMP] = ACTIONS(2705),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym___extension__] = ACTIONS(2705),
    [anon_sym_typedef] = ACTIONS(2705),
    [anon_sym_virtual] = ACTIONS(2705),
    [anon_sym_extern] = ACTIONS(2705),
    [anon_sym___attribute__] = ACTIONS(2705),
    [anon_sym___attribute] = ACTIONS(2705),
    [anon_sym_COLON_COLON] = ACTIONS(2707),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2707),
    [anon_sym___declspec] = ACTIONS(2705),
    [anon_sym___based] = ACTIONS(2705),
    [anon_sym___cdecl] = ACTIONS(2705),
    [anon_sym___clrcall] = ACTIONS(2705),
    [anon_sym___stdcall] = ACTIONS(2705),
    [anon_sym___fastcall] = ACTIONS(2705),
    [anon_sym___thiscall] = ACTIONS(2705),
    [anon_sym___vectorcall] = ACTIONS(2705),
    [anon_sym_LBRACE] = ACTIONS(2707),
    [anon_sym_signed] = ACTIONS(2705),
    [anon_sym_unsigned] = ACTIONS(2705),
    [anon_sym_long] = ACTIONS(2705),
    [anon_sym_short] = ACTIONS(2705),
    [anon_sym_LBRACK] = ACTIONS(2705),
    [anon_sym_static] = ACTIONS(2705),
    [anon_sym_register] = ACTIONS(2705),
    [anon_sym_inline] = ACTIONS(2705),
    [anon_sym___inline] = ACTIONS(2705),
    [anon_sym___inline__] = ACTIONS(2705),
    [anon_sym___forceinline] = ACTIONS(2705),
    [anon_sym_thread_local] = ACTIONS(2705),
    [anon_sym___thread] = ACTIONS(2705),
    [anon_sym_const] = ACTIONS(2705),
    [anon_sym_constexpr] = ACTIONS(2705),
    [anon_sym_volatile] = ACTIONS(2705),
    [anon_sym_restrict] = ACTIONS(2705),
    [anon_sym___restrict__] = ACTIONS(2705),
    [anon_sym__Atomic] = ACTIONS(2705),
    [anon_sym__Noreturn] = ACTIONS(2705),
    [anon_sym_noreturn] = ACTIONS(2705),
    [anon_sym__Nonnull] = ACTIONS(2705),
    [anon_sym_mutable] = ACTIONS(2705),
    [anon_sym_constinit] = ACTIONS(2705),
    [anon_sym_consteval] = ACTIONS(2705),
    [anon_sym_alignas] = ACTIONS(2705),
    [anon_sym__Alignas] = ACTIONS(2705),
    [sym_primitive_type] = ACTIONS(2705),
    [anon_sym_enum] = ACTIONS(2705),
    [anon_sym_class] = ACTIONS(2705),
    [anon_sym_struct] = ACTIONS(2705),
    [anon_sym_union] = ACTIONS(2705),
    [anon_sym_if] = ACTIONS(2705),
    [anon_sym_else] = ACTIONS(2705),
    [anon_sym_switch] = ACTIONS(2705),
    [anon_sym_case] = ACTIONS(2705),
    [anon_sym_default] = ACTIONS(2705),
    [anon_sym_while] = ACTIONS(2705),
    [anon_sym_do] = ACTIONS(2705),
    [anon_sym_for] = ACTIONS(2705),
    [anon_sym_return] = ACTIONS(2705),
    [anon_sym_break] = ACTIONS(2705),
    [anon_sym_continue] = ACTIONS(2705),
    [anon_sym_goto] = ACTIONS(2705),
    [anon_sym___try] = ACTIONS(2705),
    [anon_sym___leave] = ACTIONS(2705),
    [anon_sym_not] = ACTIONS(2705),
    [anon_sym_compl] = ACTIONS(2705),
    [anon_sym_DASH_DASH] = ACTIONS(2707),
    [anon_sym_PLUS_PLUS] = ACTIONS(2707),
    [anon_sym_sizeof] = ACTIONS(2705),
    [anon_sym___alignof__] = ACTIONS(2705),
    [anon_sym___alignof] = ACTIONS(2705),
    [anon_sym__alignof] = ACTIONS(2705),
    [anon_sym_alignof] = ACTIONS(2705),
    [anon_sym__Alignof] = ACTIONS(2705),
    [anon_sym_offsetof] = ACTIONS(2705),
    [anon_sym__Generic] = ACTIONS(2705),
    [anon_sym_asm] = ACTIONS(2705),
    [anon_sym___asm__] = ACTIONS(2705),
    [anon_sym___asm] = ACTIONS(2705),
    [sym_number_literal] = ACTIONS(2707),
    [anon_sym_L_SQUOTE] = ACTIONS(2707),
    [anon_sym_u_SQUOTE] = ACTIONS(2707),
    [anon_sym_U_SQUOTE] = ACTIONS(2707),
    [anon_sym_u8_SQUOTE] = ACTIONS(2707),
    [anon_sym_SQUOTE] = ACTIONS(2707),
    [anon_sym_L_DQUOTE] = ACTIONS(2707),
    [anon_sym_u_DQUOTE] = ACTIONS(2707),
    [anon_sym_U_DQUOTE] = ACTIONS(2707),
    [anon_sym_u8_DQUOTE] = ACTIONS(2707),
    [anon_sym_DQUOTE] = ACTIONS(2707),
    [sym_true] = ACTIONS(2705),
    [sym_false] = ACTIONS(2705),
    [anon_sym_NULL] = ACTIONS(2705),
    [anon_sym_nullptr] = ACTIONS(2705),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2705),
    [anon_sym_decltype] = ACTIONS(2705),
    [anon_sym_explicit] = ACTIONS(2705),
    [anon_sym_typename] = ACTIONS(2705),
    [anon_sym_template] = ACTIONS(2705),
    [anon_sym_operator] = ACTIONS(2705),
    [anon_sym_try] = ACTIONS(2705),
    [anon_sym_delete] = ACTIONS(2705),
    [anon_sym_throw] = ACTIONS(2705),
    [anon_sym_namespace] = ACTIONS(2705),
    [anon_sym_using] = ACTIONS(2705),
    [anon_sym_static_assert] = ACTIONS(2705),
    [anon_sym_concept] = ACTIONS(2705),
    [anon_sym_co_return] = ACTIONS(2705),
    [anon_sym_co_yield] = ACTIONS(2705),
    [anon_sym_R_DQUOTE] = ACTIONS(2707),
    [anon_sym_LR_DQUOTE] = ACTIONS(2707),
    [anon_sym_uR_DQUOTE] = ACTIONS(2707),
    [anon_sym_UR_DQUOTE] = ACTIONS(2707),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2707),
    [anon_sym_co_await] = ACTIONS(2705),
    [anon_sym_new] = ACTIONS(2705),
    [anon_sym_requires] = ACTIONS(2705),
    [sym_this] = ACTIONS(2705),
  },
  [266] = {
    [sym_identifier] = ACTIONS(2709),
    [aux_sym_preproc_include_token1] = ACTIONS(2709),
    [aux_sym_preproc_def_token1] = ACTIONS(2709),
    [aux_sym_preproc_if_token1] = ACTIONS(2709),
    [aux_sym_preproc_if_token2] = ACTIONS(2709),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2709),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2709),
    [aux_sym_preproc_else_token1] = ACTIONS(2709),
    [aux_sym_preproc_elif_token1] = ACTIONS(2709),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2709),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2709),
    [sym_preproc_directive] = ACTIONS(2709),
    [anon_sym_LPAREN2] = ACTIONS(2711),
    [anon_sym_BANG] = ACTIONS(2711),
    [anon_sym_TILDE] = ACTIONS(2711),
    [anon_sym_DASH] = ACTIONS(2709),
    [anon_sym_PLUS] = ACTIONS(2709),
    [anon_sym_STAR] = ACTIONS(2711),
    [anon_sym_AMP_AMP] = ACTIONS(2711),
    [anon_sym_AMP] = ACTIONS(2709),
    [anon_sym_SEMI] = ACTIONS(2711),
    [anon_sym___extension__] = ACTIONS(2709),
    [anon_sym_typedef] = ACTIONS(2709),
    [anon_sym_virtual] = ACTIONS(2709),
    [anon_sym_extern] = ACTIONS(2709),
    [anon_sym___attribute__] = ACTIONS(2709),
    [anon_sym___attribute] = ACTIONS(2709),
    [anon_sym_COLON_COLON] = ACTIONS(2711),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2711),
    [anon_sym___declspec] = ACTIONS(2709),
    [anon_sym___based] = ACTIONS(2709),
    [anon_sym___cdecl] = ACTIONS(2709),
    [anon_sym___clrcall] = ACTIONS(2709),
    [anon_sym___stdcall] = ACTIONS(2709),
    [anon_sym___fastcall] = ACTIONS(2709),
    [anon_sym___thiscall] = ACTIONS(2709),
    [anon_sym___vectorcall] = ACTIONS(2709),
    [anon_sym_LBRACE] = ACTIONS(2711),
    [anon_sym_signed] = ACTIONS(2709),
    [anon_sym_unsigned] = ACTIONS(2709),
    [anon_sym_long] = ACTIONS(2709),
    [anon_sym_short] = ACTIONS(2709),
    [anon_sym_LBRACK] = ACTIONS(2709),
    [anon_sym_static] = ACTIONS(2709),
    [anon_sym_register] = ACTIONS(2709),
    [anon_sym_inline] = ACTIONS(2709),
    [anon_sym___inline] = ACTIONS(2709),
    [anon_sym___inline__] = ACTIONS(2709),
    [anon_sym___forceinline] = ACTIONS(2709),
    [anon_sym_thread_local] = ACTIONS(2709),
    [anon_sym___thread] = ACTIONS(2709),
    [anon_sym_const] = ACTIONS(2709),
    [anon_sym_constexpr] = ACTIONS(2709),
    [anon_sym_volatile] = ACTIONS(2709),
    [anon_sym_restrict] = ACTIONS(2709),
    [anon_sym___restrict__] = ACTIONS(2709),
    [anon_sym__Atomic] = ACTIONS(2709),
    [anon_sym__Noreturn] = ACTIONS(2709),
    [anon_sym_noreturn] = ACTIONS(2709),
    [anon_sym__Nonnull] = ACTIONS(2709),
    [anon_sym_mutable] = ACTIONS(2709),
    [anon_sym_constinit] = ACTIONS(2709),
    [anon_sym_consteval] = ACTIONS(2709),
    [anon_sym_alignas] = ACTIONS(2709),
    [anon_sym__Alignas] = ACTIONS(2709),
    [sym_primitive_type] = ACTIONS(2709),
    [anon_sym_enum] = ACTIONS(2709),
    [anon_sym_class] = ACTIONS(2709),
    [anon_sym_struct] = ACTIONS(2709),
    [anon_sym_union] = ACTIONS(2709),
    [anon_sym_if] = ACTIONS(2709),
    [anon_sym_else] = ACTIONS(2709),
    [anon_sym_switch] = ACTIONS(2709),
    [anon_sym_case] = ACTIONS(2709),
    [anon_sym_default] = ACTIONS(2709),
    [anon_sym_while] = ACTIONS(2709),
    [anon_sym_do] = ACTIONS(2709),
    [anon_sym_for] = ACTIONS(2709),
    [anon_sym_return] = ACTIONS(2709),
    [anon_sym_break] = ACTIONS(2709),
    [anon_sym_continue] = ACTIONS(2709),
    [anon_sym_goto] = ACTIONS(2709),
    [anon_sym___try] = ACTIONS(2709),
    [anon_sym___leave] = ACTIONS(2709),
    [anon_sym_not] = ACTIONS(2709),
    [anon_sym_compl] = ACTIONS(2709),
    [anon_sym_DASH_DASH] = ACTIONS(2711),
    [anon_sym_PLUS_PLUS] = ACTIONS(2711),
    [anon_sym_sizeof] = ACTIONS(2709),
    [anon_sym___alignof__] = ACTIONS(2709),
    [anon_sym___alignof] = ACTIONS(2709),
    [anon_sym__alignof] = ACTIONS(2709),
    [anon_sym_alignof] = ACTIONS(2709),
    [anon_sym__Alignof] = ACTIONS(2709),
    [anon_sym_offsetof] = ACTIONS(2709),
    [anon_sym__Generic] = ACTIONS(2709),
    [anon_sym_asm] = ACTIONS(2709),
    [anon_sym___asm__] = ACTIONS(2709),
    [anon_sym___asm] = ACTIONS(2709),
    [sym_number_literal] = ACTIONS(2711),
    [anon_sym_L_SQUOTE] = ACTIONS(2711),
    [anon_sym_u_SQUOTE] = ACTIONS(2711),
    [anon_sym_U_SQUOTE] = ACTIONS(2711),
    [anon_sym_u8_SQUOTE] = ACTIONS(2711),
    [anon_sym_SQUOTE] = ACTIONS(2711),
    [anon_sym_L_DQUOTE] = ACTIONS(2711),
    [anon_sym_u_DQUOTE] = ACTIONS(2711),
    [anon_sym_U_DQUOTE] = ACTIONS(2711),
    [anon_sym_u8_DQUOTE] = ACTIONS(2711),
    [anon_sym_DQUOTE] = ACTIONS(2711),
    [sym_true] = ACTIONS(2709),
    [sym_false] = ACTIONS(2709),
    [anon_sym_NULL] = ACTIONS(2709),
    [anon_sym_nullptr] = ACTIONS(2709),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2709),
    [anon_sym_decltype] = ACTIONS(2709),
    [anon_sym_explicit] = ACTIONS(2709),
    [anon_sym_typename] = ACTIONS(2709),
    [anon_sym_template] = ACTIONS(2709),
    [anon_sym_operator] = ACTIONS(2709),
    [anon_sym_try] = ACTIONS(2709),
    [anon_sym_delete] = ACTIONS(2709),
    [anon_sym_throw] = ACTIONS(2709),
    [anon_sym_namespace] = ACTIONS(2709),
    [anon_sym_using] = ACTIONS(2709),
    [anon_sym_static_assert] = ACTIONS(2709),
    [anon_sym_concept] = ACTIONS(2709),
    [anon_sym_co_return] = ACTIONS(2709),
    [anon_sym_co_yield] = ACTIONS(2709),
    [anon_sym_R_DQUOTE] = ACTIONS(2711),
    [anon_sym_LR_DQUOTE] = ACTIONS(2711),
    [anon_sym_uR_DQUOTE] = ACTIONS(2711),
    [anon_sym_UR_DQUOTE] = ACTIONS(2711),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2711),
    [anon_sym_co_await] = ACTIONS(2709),
    [anon_sym_new] = ACTIONS(2709),
    [anon_sym_requires] = ACTIONS(2709),
    [sym_this] = ACTIONS(2709),
  },
  [267] = {
    [sym_identifier] = ACTIONS(2713),
    [aux_sym_preproc_include_token1] = ACTIONS(2713),
    [aux_sym_preproc_def_token1] = ACTIONS(2713),
    [aux_sym_preproc_if_token1] = ACTIONS(2713),
    [aux_sym_preproc_if_token2] = ACTIONS(2713),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2713),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2713),
    [aux_sym_preproc_else_token1] = ACTIONS(2713),
    [aux_sym_preproc_elif_token1] = ACTIONS(2713),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2713),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2713),
    [sym_preproc_directive] = ACTIONS(2713),
    [anon_sym_LPAREN2] = ACTIONS(2715),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_STAR] = ACTIONS(2715),
    [anon_sym_AMP_AMP] = ACTIONS(2715),
    [anon_sym_AMP] = ACTIONS(2713),
    [anon_sym_SEMI] = ACTIONS(2715),
    [anon_sym___extension__] = ACTIONS(2713),
    [anon_sym_typedef] = ACTIONS(2713),
    [anon_sym_virtual] = ACTIONS(2713),
    [anon_sym_extern] = ACTIONS(2713),
    [anon_sym___attribute__] = ACTIONS(2713),
    [anon_sym___attribute] = ACTIONS(2713),
    [anon_sym_COLON_COLON] = ACTIONS(2715),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2715),
    [anon_sym___declspec] = ACTIONS(2713),
    [anon_sym___based] = ACTIONS(2713),
    [anon_sym___cdecl] = ACTIONS(2713),
    [anon_sym___clrcall] = ACTIONS(2713),
    [anon_sym___stdcall] = ACTIONS(2713),
    [anon_sym___fastcall] = ACTIONS(2713),
    [anon_sym___thiscall] = ACTIONS(2713),
    [anon_sym___vectorcall] = ACTIONS(2713),
    [anon_sym_LBRACE] = ACTIONS(2715),
    [anon_sym_signed] = ACTIONS(2713),
    [anon_sym_unsigned] = ACTIONS(2713),
    [anon_sym_long] = ACTIONS(2713),
    [anon_sym_short] = ACTIONS(2713),
    [anon_sym_LBRACK] = ACTIONS(2713),
    [anon_sym_static] = ACTIONS(2713),
    [anon_sym_register] = ACTIONS(2713),
    [anon_sym_inline] = ACTIONS(2713),
    [anon_sym___inline] = ACTIONS(2713),
    [anon_sym___inline__] = ACTIONS(2713),
    [anon_sym___forceinline] = ACTIONS(2713),
    [anon_sym_thread_local] = ACTIONS(2713),
    [anon_sym___thread] = ACTIONS(2713),
    [anon_sym_const] = ACTIONS(2713),
    [anon_sym_constexpr] = ACTIONS(2713),
    [anon_sym_volatile] = ACTIONS(2713),
    [anon_sym_restrict] = ACTIONS(2713),
    [anon_sym___restrict__] = ACTIONS(2713),
    [anon_sym__Atomic] = ACTIONS(2713),
    [anon_sym__Noreturn] = ACTIONS(2713),
    [anon_sym_noreturn] = ACTIONS(2713),
    [anon_sym__Nonnull] = ACTIONS(2713),
    [anon_sym_mutable] = ACTIONS(2713),
    [anon_sym_constinit] = ACTIONS(2713),
    [anon_sym_consteval] = ACTIONS(2713),
    [anon_sym_alignas] = ACTIONS(2713),
    [anon_sym__Alignas] = ACTIONS(2713),
    [sym_primitive_type] = ACTIONS(2713),
    [anon_sym_enum] = ACTIONS(2713),
    [anon_sym_class] = ACTIONS(2713),
    [anon_sym_struct] = ACTIONS(2713),
    [anon_sym_union] = ACTIONS(2713),
    [anon_sym_if] = ACTIONS(2713),
    [anon_sym_else] = ACTIONS(2713),
    [anon_sym_switch] = ACTIONS(2713),
    [anon_sym_case] = ACTIONS(2713),
    [anon_sym_default] = ACTIONS(2713),
    [anon_sym_while] = ACTIONS(2713),
    [anon_sym_do] = ACTIONS(2713),
    [anon_sym_for] = ACTIONS(2713),
    [anon_sym_return] = ACTIONS(2713),
    [anon_sym_break] = ACTIONS(2713),
    [anon_sym_continue] = ACTIONS(2713),
    [anon_sym_goto] = ACTIONS(2713),
    [anon_sym___try] = ACTIONS(2713),
    [anon_sym___leave] = ACTIONS(2713),
    [anon_sym_not] = ACTIONS(2713),
    [anon_sym_compl] = ACTIONS(2713),
    [anon_sym_DASH_DASH] = ACTIONS(2715),
    [anon_sym_PLUS_PLUS] = ACTIONS(2715),
    [anon_sym_sizeof] = ACTIONS(2713),
    [anon_sym___alignof__] = ACTIONS(2713),
    [anon_sym___alignof] = ACTIONS(2713),
    [anon_sym__alignof] = ACTIONS(2713),
    [anon_sym_alignof] = ACTIONS(2713),
    [anon_sym__Alignof] = ACTIONS(2713),
    [anon_sym_offsetof] = ACTIONS(2713),
    [anon_sym__Generic] = ACTIONS(2713),
    [anon_sym_asm] = ACTIONS(2713),
    [anon_sym___asm__] = ACTIONS(2713),
    [anon_sym___asm] = ACTIONS(2713),
    [sym_number_literal] = ACTIONS(2715),
    [anon_sym_L_SQUOTE] = ACTIONS(2715),
    [anon_sym_u_SQUOTE] = ACTIONS(2715),
    [anon_sym_U_SQUOTE] = ACTIONS(2715),
    [anon_sym_u8_SQUOTE] = ACTIONS(2715),
    [anon_sym_SQUOTE] = ACTIONS(2715),
    [anon_sym_L_DQUOTE] = ACTIONS(2715),
    [anon_sym_u_DQUOTE] = ACTIONS(2715),
    [anon_sym_U_DQUOTE] = ACTIONS(2715),
    [anon_sym_u8_DQUOTE] = ACTIONS(2715),
    [anon_sym_DQUOTE] = ACTIONS(2715),
    [sym_true] = ACTIONS(2713),
    [sym_false] = ACTIONS(2713),
    [anon_sym_NULL] = ACTIONS(2713),
    [anon_sym_nullptr] = ACTIONS(2713),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2713),
    [anon_sym_decltype] = ACTIONS(2713),
    [anon_sym_explicit] = ACTIONS(2713),
    [anon_sym_typename] = ACTIONS(2713),
    [anon_sym_template] = ACTIONS(2713),
    [anon_sym_operator] = ACTIONS(2713),
    [anon_sym_try] = ACTIONS(2713),
    [anon_sym_delete] = ACTIONS(2713),
    [anon_sym_throw] = ACTIONS(2713),
    [anon_sym_namespace] = ACTIONS(2713),
    [anon_sym_using] = ACTIONS(2713),
    [anon_sym_static_assert] = ACTIONS(2713),
    [anon_sym_concept] = ACTIONS(2713),
    [anon_sym_co_return] = ACTIONS(2713),
    [anon_sym_co_yield] = ACTIONS(2713),
    [anon_sym_R_DQUOTE] = ACTIONS(2715),
    [anon_sym_LR_DQUOTE] = ACTIONS(2715),
    [anon_sym_uR_DQUOTE] = ACTIONS(2715),
    [anon_sym_UR_DQUOTE] = ACTIONS(2715),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2715),
    [anon_sym_co_await] = ACTIONS(2713),
    [anon_sym_new] = ACTIONS(2713),
    [anon_sym_requires] = ACTIONS(2713),
    [sym_this] = ACTIONS(2713),
  },
  [268] = {
    [sym_identifier] = ACTIONS(2717),
    [aux_sym_preproc_include_token1] = ACTIONS(2717),
    [aux_sym_preproc_def_token1] = ACTIONS(2717),
    [aux_sym_preproc_if_token1] = ACTIONS(2717),
    [aux_sym_preproc_if_token2] = ACTIONS(2717),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2717),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2717),
    [aux_sym_preproc_else_token1] = ACTIONS(2717),
    [aux_sym_preproc_elif_token1] = ACTIONS(2717),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2717),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2717),
    [sym_preproc_directive] = ACTIONS(2717),
    [anon_sym_LPAREN2] = ACTIONS(2719),
    [anon_sym_BANG] = ACTIONS(2719),
    [anon_sym_TILDE] = ACTIONS(2719),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP_AMP] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2717),
    [anon_sym_SEMI] = ACTIONS(2719),
    [anon_sym___extension__] = ACTIONS(2717),
    [anon_sym_typedef] = ACTIONS(2717),
    [anon_sym_virtual] = ACTIONS(2717),
    [anon_sym_extern] = ACTIONS(2717),
    [anon_sym___attribute__] = ACTIONS(2717),
    [anon_sym___attribute] = ACTIONS(2717),
    [anon_sym_COLON_COLON] = ACTIONS(2719),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2719),
    [anon_sym___declspec] = ACTIONS(2717),
    [anon_sym___based] = ACTIONS(2717),
    [anon_sym___cdecl] = ACTIONS(2717),
    [anon_sym___clrcall] = ACTIONS(2717),
    [anon_sym___stdcall] = ACTIONS(2717),
    [anon_sym___fastcall] = ACTIONS(2717),
    [anon_sym___thiscall] = ACTIONS(2717),
    [anon_sym___vectorcall] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(2719),
    [anon_sym_signed] = ACTIONS(2717),
    [anon_sym_unsigned] = ACTIONS(2717),
    [anon_sym_long] = ACTIONS(2717),
    [anon_sym_short] = ACTIONS(2717),
    [anon_sym_LBRACK] = ACTIONS(2717),
    [anon_sym_static] = ACTIONS(2717),
    [anon_sym_register] = ACTIONS(2717),
    [anon_sym_inline] = ACTIONS(2717),
    [anon_sym___inline] = ACTIONS(2717),
    [anon_sym___inline__] = ACTIONS(2717),
    [anon_sym___forceinline] = ACTIONS(2717),
    [anon_sym_thread_local] = ACTIONS(2717),
    [anon_sym___thread] = ACTIONS(2717),
    [anon_sym_const] = ACTIONS(2717),
    [anon_sym_constexpr] = ACTIONS(2717),
    [anon_sym_volatile] = ACTIONS(2717),
    [anon_sym_restrict] = ACTIONS(2717),
    [anon_sym___restrict__] = ACTIONS(2717),
    [anon_sym__Atomic] = ACTIONS(2717),
    [anon_sym__Noreturn] = ACTIONS(2717),
    [anon_sym_noreturn] = ACTIONS(2717),
    [anon_sym__Nonnull] = ACTIONS(2717),
    [anon_sym_mutable] = ACTIONS(2717),
    [anon_sym_constinit] = ACTIONS(2717),
    [anon_sym_consteval] = ACTIONS(2717),
    [anon_sym_alignas] = ACTIONS(2717),
    [anon_sym__Alignas] = ACTIONS(2717),
    [sym_primitive_type] = ACTIONS(2717),
    [anon_sym_enum] = ACTIONS(2717),
    [anon_sym_class] = ACTIONS(2717),
    [anon_sym_struct] = ACTIONS(2717),
    [anon_sym_union] = ACTIONS(2717),
    [anon_sym_if] = ACTIONS(2717),
    [anon_sym_else] = ACTIONS(2717),
    [anon_sym_switch] = ACTIONS(2717),
    [anon_sym_case] = ACTIONS(2717),
    [anon_sym_default] = ACTIONS(2717),
    [anon_sym_while] = ACTIONS(2717),
    [anon_sym_do] = ACTIONS(2717),
    [anon_sym_for] = ACTIONS(2717),
    [anon_sym_return] = ACTIONS(2717),
    [anon_sym_break] = ACTIONS(2717),
    [anon_sym_continue] = ACTIONS(2717),
    [anon_sym_goto] = ACTIONS(2717),
    [anon_sym___try] = ACTIONS(2717),
    [anon_sym___leave] = ACTIONS(2717),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2719),
    [anon_sym_PLUS_PLUS] = ACTIONS(2719),
    [anon_sym_sizeof] = ACTIONS(2717),
    [anon_sym___alignof__] = ACTIONS(2717),
    [anon_sym___alignof] = ACTIONS(2717),
    [anon_sym__alignof] = ACTIONS(2717),
    [anon_sym_alignof] = ACTIONS(2717),
    [anon_sym__Alignof] = ACTIONS(2717),
    [anon_sym_offsetof] = ACTIONS(2717),
    [anon_sym__Generic] = ACTIONS(2717),
    [anon_sym_asm] = ACTIONS(2717),
    [anon_sym___asm__] = ACTIONS(2717),
    [anon_sym___asm] = ACTIONS(2717),
    [sym_number_literal] = ACTIONS(2719),
    [anon_sym_L_SQUOTE] = ACTIONS(2719),
    [anon_sym_u_SQUOTE] = ACTIONS(2719),
    [anon_sym_U_SQUOTE] = ACTIONS(2719),
    [anon_sym_u8_SQUOTE] = ACTIONS(2719),
    [anon_sym_SQUOTE] = ACTIONS(2719),
    [anon_sym_L_DQUOTE] = ACTIONS(2719),
    [anon_sym_u_DQUOTE] = ACTIONS(2719),
    [anon_sym_U_DQUOTE] = ACTIONS(2719),
    [anon_sym_u8_DQUOTE] = ACTIONS(2719),
    [anon_sym_DQUOTE] = ACTIONS(2719),
    [sym_true] = ACTIONS(2717),
    [sym_false] = ACTIONS(2717),
    [anon_sym_NULL] = ACTIONS(2717),
    [anon_sym_nullptr] = ACTIONS(2717),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2717),
    [anon_sym_decltype] = ACTIONS(2717),
    [anon_sym_explicit] = ACTIONS(2717),
    [anon_sym_typename] = ACTIONS(2717),
    [anon_sym_template] = ACTIONS(2717),
    [anon_sym_operator] = ACTIONS(2717),
    [anon_sym_try] = ACTIONS(2717),
    [anon_sym_delete] = ACTIONS(2717),
    [anon_sym_throw] = ACTIONS(2717),
    [anon_sym_namespace] = ACTIONS(2717),
    [anon_sym_using] = ACTIONS(2717),
    [anon_sym_static_assert] = ACTIONS(2717),
    [anon_sym_concept] = ACTIONS(2717),
    [anon_sym_co_return] = ACTIONS(2717),
    [anon_sym_co_yield] = ACTIONS(2717),
    [anon_sym_R_DQUOTE] = ACTIONS(2719),
    [anon_sym_LR_DQUOTE] = ACTIONS(2719),
    [anon_sym_uR_DQUOTE] = ACTIONS(2719),
    [anon_sym_UR_DQUOTE] = ACTIONS(2719),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2719),
    [anon_sym_co_await] = ACTIONS(2717),
    [anon_sym_new] = ACTIONS(2717),
    [anon_sym_requires] = ACTIONS(2717),
    [sym_this] = ACTIONS(2717),
  },
  [269] = {
    [sym_identifier] = ACTIONS(1913),
    [aux_sym_preproc_include_token1] = ACTIONS(1913),
    [aux_sym_preproc_def_token1] = ACTIONS(1913),
    [anon_sym_COMMA] = ACTIONS(2721),
    [aux_sym_preproc_if_token1] = ACTIONS(1913),
    [aux_sym_preproc_if_token2] = ACTIONS(1913),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1913),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1913),
    [aux_sym_preproc_else_token1] = ACTIONS(1913),
    [aux_sym_preproc_elif_token1] = ACTIONS(1913),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1913),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1913),
    [sym_preproc_directive] = ACTIONS(1913),
    [anon_sym_LPAREN2] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_DASH] = ACTIONS(1913),
    [anon_sym_PLUS] = ACTIONS(1913),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_AMP_AMP] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1913),
    [anon_sym_SEMI] = ACTIONS(2721),
    [anon_sym___extension__] = ACTIONS(1913),
    [anon_sym_typedef] = ACTIONS(1913),
    [anon_sym_virtual] = ACTIONS(1913),
    [anon_sym_extern] = ACTIONS(1913),
    [anon_sym___attribute__] = ACTIONS(1913),
    [anon_sym___attribute] = ACTIONS(1913),
    [anon_sym_COLON_COLON] = ACTIONS(1911),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1911),
    [anon_sym___declspec] = ACTIONS(1913),
    [anon_sym___based] = ACTIONS(1913),
    [anon_sym___cdecl] = ACTIONS(1913),
    [anon_sym___clrcall] = ACTIONS(1913),
    [anon_sym___stdcall] = ACTIONS(1913),
    [anon_sym___fastcall] = ACTIONS(1913),
    [anon_sym___thiscall] = ACTIONS(1913),
    [anon_sym___vectorcall] = ACTIONS(1913),
    [anon_sym_LBRACE] = ACTIONS(1911),
    [anon_sym_signed] = ACTIONS(1913),
    [anon_sym_unsigned] = ACTIONS(1913),
    [anon_sym_long] = ACTIONS(1913),
    [anon_sym_short] = ACTIONS(1913),
    [anon_sym_LBRACK] = ACTIONS(1913),
    [anon_sym_static] = ACTIONS(1913),
    [anon_sym_register] = ACTIONS(1913),
    [anon_sym_inline] = ACTIONS(1913),
    [anon_sym___inline] = ACTIONS(1913),
    [anon_sym___inline__] = ACTIONS(1913),
    [anon_sym___forceinline] = ACTIONS(1913),
    [anon_sym_thread_local] = ACTIONS(1913),
    [anon_sym___thread] = ACTIONS(1913),
    [anon_sym_const] = ACTIONS(1913),
    [anon_sym_constexpr] = ACTIONS(1913),
    [anon_sym_volatile] = ACTIONS(1913),
    [anon_sym_restrict] = ACTIONS(1913),
    [anon_sym___restrict__] = ACTIONS(1913),
    [anon_sym__Atomic] = ACTIONS(1913),
    [anon_sym__Noreturn] = ACTIONS(1913),
    [anon_sym_noreturn] = ACTIONS(1913),
    [anon_sym__Nonnull] = ACTIONS(1913),
    [anon_sym_mutable] = ACTIONS(1913),
    [anon_sym_constinit] = ACTIONS(1913),
    [anon_sym_consteval] = ACTIONS(1913),
    [anon_sym_alignas] = ACTIONS(1913),
    [anon_sym__Alignas] = ACTIONS(1913),
    [sym_primitive_type] = ACTIONS(1913),
    [anon_sym_enum] = ACTIONS(1913),
    [anon_sym_class] = ACTIONS(1913),
    [anon_sym_struct] = ACTIONS(1913),
    [anon_sym_union] = ACTIONS(1913),
    [anon_sym_if] = ACTIONS(1913),
    [anon_sym_switch] = ACTIONS(1913),
    [anon_sym_case] = ACTIONS(1913),
    [anon_sym_default] = ACTIONS(1913),
    [anon_sym_while] = ACTIONS(1913),
    [anon_sym_do] = ACTIONS(1913),
    [anon_sym_for] = ACTIONS(1913),
    [anon_sym_return] = ACTIONS(1913),
    [anon_sym_break] = ACTIONS(1913),
    [anon_sym_continue] = ACTIONS(1913),
    [anon_sym_goto] = ACTIONS(1913),
    [anon_sym___try] = ACTIONS(1913),
    [anon_sym___leave] = ACTIONS(1913),
    [anon_sym_not] = ACTIONS(1913),
    [anon_sym_compl] = ACTIONS(1913),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_sizeof] = ACTIONS(1913),
    [anon_sym___alignof__] = ACTIONS(1913),
    [anon_sym___alignof] = ACTIONS(1913),
    [anon_sym__alignof] = ACTIONS(1913),
    [anon_sym_alignof] = ACTIONS(1913),
    [anon_sym__Alignof] = ACTIONS(1913),
    [anon_sym_offsetof] = ACTIONS(1913),
    [anon_sym__Generic] = ACTIONS(1913),
    [anon_sym_asm] = ACTIONS(1913),
    [anon_sym___asm__] = ACTIONS(1913),
    [anon_sym___asm] = ACTIONS(1913),
    [sym_number_literal] = ACTIONS(1911),
    [anon_sym_L_SQUOTE] = ACTIONS(1911),
    [anon_sym_u_SQUOTE] = ACTIONS(1911),
    [anon_sym_U_SQUOTE] = ACTIONS(1911),
    [anon_sym_u8_SQUOTE] = ACTIONS(1911),
    [anon_sym_SQUOTE] = ACTIONS(1911),
    [anon_sym_L_DQUOTE] = ACTIONS(1911),
    [anon_sym_u_DQUOTE] = ACTIONS(1911),
    [anon_sym_U_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8_DQUOTE] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(1911),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1913),
    [anon_sym_nullptr] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1913),
    [anon_sym_decltype] = ACTIONS(1913),
    [anon_sym_explicit] = ACTIONS(1913),
    [anon_sym_typename] = ACTIONS(1913),
    [anon_sym_template] = ACTIONS(1913),
    [anon_sym_operator] = ACTIONS(1913),
    [anon_sym_try] = ACTIONS(1913),
    [anon_sym_delete] = ACTIONS(1913),
    [anon_sym_throw] = ACTIONS(1913),
    [anon_sym_namespace] = ACTIONS(1913),
    [anon_sym_using] = ACTIONS(1913),
    [anon_sym_static_assert] = ACTIONS(1913),
    [anon_sym_concept] = ACTIONS(1913),
    [anon_sym_co_return] = ACTIONS(1913),
    [anon_sym_co_yield] = ACTIONS(1913),
    [anon_sym_R_DQUOTE] = ACTIONS(1911),
    [anon_sym_LR_DQUOTE] = ACTIONS(1911),
    [anon_sym_uR_DQUOTE] = ACTIONS(1911),
    [anon_sym_UR_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1911),
    [anon_sym_co_await] = ACTIONS(1913),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_requires] = ACTIONS(1913),
    [sym_this] = ACTIONS(1913),
  },
  [270] = {
    [sym_identifier] = ACTIONS(2723),
    [aux_sym_preproc_include_token1] = ACTIONS(2723),
    [aux_sym_preproc_def_token1] = ACTIONS(2723),
    [aux_sym_preproc_if_token1] = ACTIONS(2723),
    [aux_sym_preproc_if_token2] = ACTIONS(2723),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2723),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2723),
    [aux_sym_preproc_else_token1] = ACTIONS(2723),
    [aux_sym_preproc_elif_token1] = ACTIONS(2723),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2723),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2723),
    [sym_preproc_directive] = ACTIONS(2723),
    [anon_sym_LPAREN2] = ACTIONS(2725),
    [anon_sym_BANG] = ACTIONS(2725),
    [anon_sym_TILDE] = ACTIONS(2725),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_STAR] = ACTIONS(2725),
    [anon_sym_AMP_AMP] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_SEMI] = ACTIONS(2725),
    [anon_sym___extension__] = ACTIONS(2723),
    [anon_sym_typedef] = ACTIONS(2723),
    [anon_sym_virtual] = ACTIONS(2723),
    [anon_sym_extern] = ACTIONS(2723),
    [anon_sym___attribute__] = ACTIONS(2723),
    [anon_sym___attribute] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2725),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2725),
    [anon_sym___declspec] = ACTIONS(2723),
    [anon_sym___based] = ACTIONS(2723),
    [anon_sym___cdecl] = ACTIONS(2723),
    [anon_sym___clrcall] = ACTIONS(2723),
    [anon_sym___stdcall] = ACTIONS(2723),
    [anon_sym___fastcall] = ACTIONS(2723),
    [anon_sym___thiscall] = ACTIONS(2723),
    [anon_sym___vectorcall] = ACTIONS(2723),
    [anon_sym_LBRACE] = ACTIONS(2725),
    [anon_sym_signed] = ACTIONS(2723),
    [anon_sym_unsigned] = ACTIONS(2723),
    [anon_sym_long] = ACTIONS(2723),
    [anon_sym_short] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_static] = ACTIONS(2723),
    [anon_sym_register] = ACTIONS(2723),
    [anon_sym_inline] = ACTIONS(2723),
    [anon_sym___inline] = ACTIONS(2723),
    [anon_sym___inline__] = ACTIONS(2723),
    [anon_sym___forceinline] = ACTIONS(2723),
    [anon_sym_thread_local] = ACTIONS(2723),
    [anon_sym___thread] = ACTIONS(2723),
    [anon_sym_const] = ACTIONS(2723),
    [anon_sym_constexpr] = ACTIONS(2723),
    [anon_sym_volatile] = ACTIONS(2723),
    [anon_sym_restrict] = ACTIONS(2723),
    [anon_sym___restrict__] = ACTIONS(2723),
    [anon_sym__Atomic] = ACTIONS(2723),
    [anon_sym__Noreturn] = ACTIONS(2723),
    [anon_sym_noreturn] = ACTIONS(2723),
    [anon_sym__Nonnull] = ACTIONS(2723),
    [anon_sym_mutable] = ACTIONS(2723),
    [anon_sym_constinit] = ACTIONS(2723),
    [anon_sym_consteval] = ACTIONS(2723),
    [anon_sym_alignas] = ACTIONS(2723),
    [anon_sym__Alignas] = ACTIONS(2723),
    [sym_primitive_type] = ACTIONS(2723),
    [anon_sym_enum] = ACTIONS(2723),
    [anon_sym_class] = ACTIONS(2723),
    [anon_sym_struct] = ACTIONS(2723),
    [anon_sym_union] = ACTIONS(2723),
    [anon_sym_if] = ACTIONS(2723),
    [anon_sym_else] = ACTIONS(2723),
    [anon_sym_switch] = ACTIONS(2723),
    [anon_sym_case] = ACTIONS(2723),
    [anon_sym_default] = ACTIONS(2723),
    [anon_sym_while] = ACTIONS(2723),
    [anon_sym_do] = ACTIONS(2723),
    [anon_sym_for] = ACTIONS(2723),
    [anon_sym_return] = ACTIONS(2723),
    [anon_sym_break] = ACTIONS(2723),
    [anon_sym_continue] = ACTIONS(2723),
    [anon_sym_goto] = ACTIONS(2723),
    [anon_sym___try] = ACTIONS(2723),
    [anon_sym___leave] = ACTIONS(2723),
    [anon_sym_not] = ACTIONS(2723),
    [anon_sym_compl] = ACTIONS(2723),
    [anon_sym_DASH_DASH] = ACTIONS(2725),
    [anon_sym_PLUS_PLUS] = ACTIONS(2725),
    [anon_sym_sizeof] = ACTIONS(2723),
    [anon_sym___alignof__] = ACTIONS(2723),
    [anon_sym___alignof] = ACTIONS(2723),
    [anon_sym__alignof] = ACTIONS(2723),
    [anon_sym_alignof] = ACTIONS(2723),
    [anon_sym__Alignof] = ACTIONS(2723),
    [anon_sym_offsetof] = ACTIONS(2723),
    [anon_sym__Generic] = ACTIONS(2723),
    [anon_sym_asm] = ACTIONS(2723),
    [anon_sym___asm__] = ACTIONS(2723),
    [anon_sym___asm] = ACTIONS(2723),
    [sym_number_literal] = ACTIONS(2725),
    [anon_sym_L_SQUOTE] = ACTIONS(2725),
    [anon_sym_u_SQUOTE] = ACTIONS(2725),
    [anon_sym_U_SQUOTE] = ACTIONS(2725),
    [anon_sym_u8_SQUOTE] = ACTIONS(2725),
    [anon_sym_SQUOTE] = ACTIONS(2725),
    [anon_sym_L_DQUOTE] = ACTIONS(2725),
    [anon_sym_u_DQUOTE] = ACTIONS(2725),
    [anon_sym_U_DQUOTE] = ACTIONS(2725),
    [anon_sym_u8_DQUOTE] = ACTIONS(2725),
    [anon_sym_DQUOTE] = ACTIONS(2725),
    [sym_true] = ACTIONS(2723),
    [sym_false] = ACTIONS(2723),
    [anon_sym_NULL] = ACTIONS(2723),
    [anon_sym_nullptr] = ACTIONS(2723),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2723),
    [anon_sym_decltype] = ACTIONS(2723),
    [anon_sym_explicit] = ACTIONS(2723),
    [anon_sym_typename] = ACTIONS(2723),
    [anon_sym_template] = ACTIONS(2723),
    [anon_sym_operator] = ACTIONS(2723),
    [anon_sym_try] = ACTIONS(2723),
    [anon_sym_delete] = ACTIONS(2723),
    [anon_sym_throw] = ACTIONS(2723),
    [anon_sym_namespace] = ACTIONS(2723),
    [anon_sym_using] = ACTIONS(2723),
    [anon_sym_static_assert] = ACTIONS(2723),
    [anon_sym_concept] = ACTIONS(2723),
    [anon_sym_co_return] = ACTIONS(2723),
    [anon_sym_co_yield] = ACTIONS(2723),
    [anon_sym_R_DQUOTE] = ACTIONS(2725),
    [anon_sym_LR_DQUOTE] = ACTIONS(2725),
    [anon_sym_uR_DQUOTE] = ACTIONS(2725),
    [anon_sym_UR_DQUOTE] = ACTIONS(2725),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2725),
    [anon_sym_co_await] = ACTIONS(2723),
    [anon_sym_new] = ACTIONS(2723),
    [anon_sym_requires] = ACTIONS(2723),
    [sym_this] = ACTIONS(2723),
  },
  [271] = {
    [sym_identifier] = ACTIONS(2727),
    [aux_sym_preproc_include_token1] = ACTIONS(2727),
    [aux_sym_preproc_def_token1] = ACTIONS(2727),
    [aux_sym_preproc_if_token1] = ACTIONS(2727),
    [aux_sym_preproc_if_token2] = ACTIONS(2727),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2727),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2727),
    [aux_sym_preproc_else_token1] = ACTIONS(2727),
    [aux_sym_preproc_elif_token1] = ACTIONS(2727),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2727),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2727),
    [sym_preproc_directive] = ACTIONS(2727),
    [anon_sym_LPAREN2] = ACTIONS(2729),
    [anon_sym_BANG] = ACTIONS(2729),
    [anon_sym_TILDE] = ACTIONS(2729),
    [anon_sym_DASH] = ACTIONS(2727),
    [anon_sym_PLUS] = ACTIONS(2727),
    [anon_sym_STAR] = ACTIONS(2729),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_AMP] = ACTIONS(2727),
    [anon_sym_SEMI] = ACTIONS(2729),
    [anon_sym___extension__] = ACTIONS(2727),
    [anon_sym_typedef] = ACTIONS(2727),
    [anon_sym_virtual] = ACTIONS(2727),
    [anon_sym_extern] = ACTIONS(2727),
    [anon_sym___attribute__] = ACTIONS(2727),
    [anon_sym___attribute] = ACTIONS(2727),
    [anon_sym_COLON_COLON] = ACTIONS(2729),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2729),
    [anon_sym___declspec] = ACTIONS(2727),
    [anon_sym___based] = ACTIONS(2727),
    [anon_sym___cdecl] = ACTIONS(2727),
    [anon_sym___clrcall] = ACTIONS(2727),
    [anon_sym___stdcall] = ACTIONS(2727),
    [anon_sym___fastcall] = ACTIONS(2727),
    [anon_sym___thiscall] = ACTIONS(2727),
    [anon_sym___vectorcall] = ACTIONS(2727),
    [anon_sym_LBRACE] = ACTIONS(2729),
    [anon_sym_signed] = ACTIONS(2727),
    [anon_sym_unsigned] = ACTIONS(2727),
    [anon_sym_long] = ACTIONS(2727),
    [anon_sym_short] = ACTIONS(2727),
    [anon_sym_LBRACK] = ACTIONS(2727),
    [anon_sym_static] = ACTIONS(2727),
    [anon_sym_register] = ACTIONS(2727),
    [anon_sym_inline] = ACTIONS(2727),
    [anon_sym___inline] = ACTIONS(2727),
    [anon_sym___inline__] = ACTIONS(2727),
    [anon_sym___forceinline] = ACTIONS(2727),
    [anon_sym_thread_local] = ACTIONS(2727),
    [anon_sym___thread] = ACTIONS(2727),
    [anon_sym_const] = ACTIONS(2727),
    [anon_sym_constexpr] = ACTIONS(2727),
    [anon_sym_volatile] = ACTIONS(2727),
    [anon_sym_restrict] = ACTIONS(2727),
    [anon_sym___restrict__] = ACTIONS(2727),
    [anon_sym__Atomic] = ACTIONS(2727),
    [anon_sym__Noreturn] = ACTIONS(2727),
    [anon_sym_noreturn] = ACTIONS(2727),
    [anon_sym__Nonnull] = ACTIONS(2727),
    [anon_sym_mutable] = ACTIONS(2727),
    [anon_sym_constinit] = ACTIONS(2727),
    [anon_sym_consteval] = ACTIONS(2727),
    [anon_sym_alignas] = ACTIONS(2727),
    [anon_sym__Alignas] = ACTIONS(2727),
    [sym_primitive_type] = ACTIONS(2727),
    [anon_sym_enum] = ACTIONS(2727),
    [anon_sym_class] = ACTIONS(2727),
    [anon_sym_struct] = ACTIONS(2727),
    [anon_sym_union] = ACTIONS(2727),
    [anon_sym_if] = ACTIONS(2727),
    [anon_sym_switch] = ACTIONS(2727),
    [anon_sym_case] = ACTIONS(2727),
    [anon_sym_default] = ACTIONS(2727),
    [anon_sym_while] = ACTIONS(2727),
    [anon_sym_do] = ACTIONS(2727),
    [anon_sym_for] = ACTIONS(2727),
    [anon_sym_return] = ACTIONS(2727),
    [anon_sym_break] = ACTIONS(2727),
    [anon_sym_continue] = ACTIONS(2727),
    [anon_sym_goto] = ACTIONS(2727),
    [anon_sym___try] = ACTIONS(2727),
    [anon_sym___leave] = ACTIONS(2727),
    [anon_sym_not] = ACTIONS(2727),
    [anon_sym_compl] = ACTIONS(2727),
    [anon_sym_DASH_DASH] = ACTIONS(2729),
    [anon_sym_PLUS_PLUS] = ACTIONS(2729),
    [anon_sym_sizeof] = ACTIONS(2727),
    [anon_sym___alignof__] = ACTIONS(2727),
    [anon_sym___alignof] = ACTIONS(2727),
    [anon_sym__alignof] = ACTIONS(2727),
    [anon_sym_alignof] = ACTIONS(2727),
    [anon_sym__Alignof] = ACTIONS(2727),
    [anon_sym_offsetof] = ACTIONS(2727),
    [anon_sym__Generic] = ACTIONS(2727),
    [anon_sym_asm] = ACTIONS(2727),
    [anon_sym___asm__] = ACTIONS(2727),
    [anon_sym___asm] = ACTIONS(2727),
    [sym_number_literal] = ACTIONS(2729),
    [anon_sym_L_SQUOTE] = ACTIONS(2729),
    [anon_sym_u_SQUOTE] = ACTIONS(2729),
    [anon_sym_U_SQUOTE] = ACTIONS(2729),
    [anon_sym_u8_SQUOTE] = ACTIONS(2729),
    [anon_sym_SQUOTE] = ACTIONS(2729),
    [anon_sym_L_DQUOTE] = ACTIONS(2729),
    [anon_sym_u_DQUOTE] = ACTIONS(2729),
    [anon_sym_U_DQUOTE] = ACTIONS(2729),
    [anon_sym_u8_DQUOTE] = ACTIONS(2729),
    [anon_sym_DQUOTE] = ACTIONS(2729),
    [sym_true] = ACTIONS(2727),
    [sym_false] = ACTIONS(2727),
    [anon_sym_NULL] = ACTIONS(2727),
    [anon_sym_nullptr] = ACTIONS(2727),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2727),
    [anon_sym_decltype] = ACTIONS(2727),
    [anon_sym_explicit] = ACTIONS(2727),
    [anon_sym_typename] = ACTIONS(2727),
    [anon_sym_template] = ACTIONS(2727),
    [anon_sym_operator] = ACTIONS(2727),
    [anon_sym_try] = ACTIONS(2727),
    [anon_sym_delete] = ACTIONS(2727),
    [anon_sym_throw] = ACTIONS(2727),
    [anon_sym_namespace] = ACTIONS(2727),
    [anon_sym_using] = ACTIONS(2727),
    [anon_sym_static_assert] = ACTIONS(2727),
    [anon_sym_concept] = ACTIONS(2727),
    [anon_sym_co_return] = ACTIONS(2727),
    [anon_sym_co_yield] = ACTIONS(2727),
    [anon_sym_R_DQUOTE] = ACTIONS(2729),
    [anon_sym_LR_DQUOTE] = ACTIONS(2729),
    [anon_sym_uR_DQUOTE] = ACTIONS(2729),
    [anon_sym_UR_DQUOTE] = ACTIONS(2729),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2729),
    [anon_sym_co_await] = ACTIONS(2727),
    [anon_sym_new] = ACTIONS(2727),
    [anon_sym_requires] = ACTIONS(2727),
    [sym_this] = ACTIONS(2727),
  },
  [272] = {
    [sym_identifier] = ACTIONS(2731),
    [aux_sym_preproc_include_token1] = ACTIONS(2731),
    [aux_sym_preproc_def_token1] = ACTIONS(2731),
    [aux_sym_preproc_if_token1] = ACTIONS(2731),
    [aux_sym_preproc_if_token2] = ACTIONS(2731),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2731),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2731),
    [aux_sym_preproc_else_token1] = ACTIONS(2731),
    [aux_sym_preproc_elif_token1] = ACTIONS(2731),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2731),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2731),
    [sym_preproc_directive] = ACTIONS(2731),
    [anon_sym_LPAREN2] = ACTIONS(2733),
    [anon_sym_BANG] = ACTIONS(2733),
    [anon_sym_TILDE] = ACTIONS(2733),
    [anon_sym_DASH] = ACTIONS(2731),
    [anon_sym_PLUS] = ACTIONS(2731),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_AMP_AMP] = ACTIONS(2733),
    [anon_sym_AMP] = ACTIONS(2731),
    [anon_sym_SEMI] = ACTIONS(2733),
    [anon_sym___extension__] = ACTIONS(2731),
    [anon_sym_typedef] = ACTIONS(2731),
    [anon_sym_virtual] = ACTIONS(2731),
    [anon_sym_extern] = ACTIONS(2731),
    [anon_sym___attribute__] = ACTIONS(2731),
    [anon_sym___attribute] = ACTIONS(2731),
    [anon_sym_COLON_COLON] = ACTIONS(2733),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2733),
    [anon_sym___declspec] = ACTIONS(2731),
    [anon_sym___based] = ACTIONS(2731),
    [anon_sym___cdecl] = ACTIONS(2731),
    [anon_sym___clrcall] = ACTIONS(2731),
    [anon_sym___stdcall] = ACTIONS(2731),
    [anon_sym___fastcall] = ACTIONS(2731),
    [anon_sym___thiscall] = ACTIONS(2731),
    [anon_sym___vectorcall] = ACTIONS(2731),
    [anon_sym_LBRACE] = ACTIONS(2733),
    [anon_sym_signed] = ACTIONS(2731),
    [anon_sym_unsigned] = ACTIONS(2731),
    [anon_sym_long] = ACTIONS(2731),
    [anon_sym_short] = ACTIONS(2731),
    [anon_sym_LBRACK] = ACTIONS(2731),
    [anon_sym_static] = ACTIONS(2731),
    [anon_sym_register] = ACTIONS(2731),
    [anon_sym_inline] = ACTIONS(2731),
    [anon_sym___inline] = ACTIONS(2731),
    [anon_sym___inline__] = ACTIONS(2731),
    [anon_sym___forceinline] = ACTIONS(2731),
    [anon_sym_thread_local] = ACTIONS(2731),
    [anon_sym___thread] = ACTIONS(2731),
    [anon_sym_const] = ACTIONS(2731),
    [anon_sym_constexpr] = ACTIONS(2731),
    [anon_sym_volatile] = ACTIONS(2731),
    [anon_sym_restrict] = ACTIONS(2731),
    [anon_sym___restrict__] = ACTIONS(2731),
    [anon_sym__Atomic] = ACTIONS(2731),
    [anon_sym__Noreturn] = ACTIONS(2731),
    [anon_sym_noreturn] = ACTIONS(2731),
    [anon_sym__Nonnull] = ACTIONS(2731),
    [anon_sym_mutable] = ACTIONS(2731),
    [anon_sym_constinit] = ACTIONS(2731),
    [anon_sym_consteval] = ACTIONS(2731),
    [anon_sym_alignas] = ACTIONS(2731),
    [anon_sym__Alignas] = ACTIONS(2731),
    [sym_primitive_type] = ACTIONS(2731),
    [anon_sym_enum] = ACTIONS(2731),
    [anon_sym_class] = ACTIONS(2731),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2731),
    [anon_sym_if] = ACTIONS(2731),
    [anon_sym_switch] = ACTIONS(2731),
    [anon_sym_case] = ACTIONS(2731),
    [anon_sym_default] = ACTIONS(2731),
    [anon_sym_while] = ACTIONS(2731),
    [anon_sym_do] = ACTIONS(2731),
    [anon_sym_for] = ACTIONS(2731),
    [anon_sym_return] = ACTIONS(2731),
    [anon_sym_break] = ACTIONS(2731),
    [anon_sym_continue] = ACTIONS(2731),
    [anon_sym_goto] = ACTIONS(2731),
    [anon_sym___try] = ACTIONS(2731),
    [anon_sym___leave] = ACTIONS(2731),
    [anon_sym_not] = ACTIONS(2731),
    [anon_sym_compl] = ACTIONS(2731),
    [anon_sym_DASH_DASH] = ACTIONS(2733),
    [anon_sym_PLUS_PLUS] = ACTIONS(2733),
    [anon_sym_sizeof] = ACTIONS(2731),
    [anon_sym___alignof__] = ACTIONS(2731),
    [anon_sym___alignof] = ACTIONS(2731),
    [anon_sym__alignof] = ACTIONS(2731),
    [anon_sym_alignof] = ACTIONS(2731),
    [anon_sym__Alignof] = ACTIONS(2731),
    [anon_sym_offsetof] = ACTIONS(2731),
    [anon_sym__Generic] = ACTIONS(2731),
    [anon_sym_asm] = ACTIONS(2731),
    [anon_sym___asm__] = ACTIONS(2731),
    [anon_sym___asm] = ACTIONS(2731),
    [sym_number_literal] = ACTIONS(2733),
    [anon_sym_L_SQUOTE] = ACTIONS(2733),
    [anon_sym_u_SQUOTE] = ACTIONS(2733),
    [anon_sym_U_SQUOTE] = ACTIONS(2733),
    [anon_sym_u8_SQUOTE] = ACTIONS(2733),
    [anon_sym_SQUOTE] = ACTIONS(2733),
    [anon_sym_L_DQUOTE] = ACTIONS(2733),
    [anon_sym_u_DQUOTE] = ACTIONS(2733),
    [anon_sym_U_DQUOTE] = ACTIONS(2733),
    [anon_sym_u8_DQUOTE] = ACTIONS(2733),
    [anon_sym_DQUOTE] = ACTIONS(2733),
    [sym_true] = ACTIONS(2731),
    [sym_false] = ACTIONS(2731),
    [anon_sym_NULL] = ACTIONS(2731),
    [anon_sym_nullptr] = ACTIONS(2731),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2731),
    [anon_sym_decltype] = ACTIONS(2731),
    [anon_sym_explicit] = ACTIONS(2731),
    [anon_sym_typename] = ACTIONS(2731),
    [anon_sym_template] = ACTIONS(2731),
    [anon_sym_operator] = ACTIONS(2731),
    [anon_sym_try] = ACTIONS(2731),
    [anon_sym_delete] = ACTIONS(2731),
    [anon_sym_throw] = ACTIONS(2731),
    [anon_sym_namespace] = ACTIONS(2731),
    [anon_sym_using] = ACTIONS(2731),
    [anon_sym_static_assert] = ACTIONS(2731),
    [anon_sym_concept] = ACTIONS(2731),
    [anon_sym_co_return] = ACTIONS(2731),
    [anon_sym_co_yield] = ACTIONS(2731),
    [anon_sym_R_DQUOTE] = ACTIONS(2733),
    [anon_sym_LR_DQUOTE] = ACTIONS(2733),
    [anon_sym_uR_DQUOTE] = ACTIONS(2733),
    [anon_sym_UR_DQUOTE] = ACTIONS(2733),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2733),
    [anon_sym_co_await] = ACTIONS(2731),
    [anon_sym_new] = ACTIONS(2731),
    [anon_sym_requires] = ACTIONS(2731),
    [sym_this] = ACTIONS(2731),
  },
  [273] = {
    [sym_identifier] = ACTIONS(2735),
    [aux_sym_preproc_include_token1] = ACTIONS(2735),
    [aux_sym_preproc_def_token1] = ACTIONS(2735),
    [aux_sym_preproc_if_token1] = ACTIONS(2735),
    [aux_sym_preproc_if_token2] = ACTIONS(2735),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2735),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2735),
    [aux_sym_preproc_else_token1] = ACTIONS(2735),
    [aux_sym_preproc_elif_token1] = ACTIONS(2735),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2735),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2735),
    [sym_preproc_directive] = ACTIONS(2735),
    [anon_sym_LPAREN2] = ACTIONS(2737),
    [anon_sym_BANG] = ACTIONS(2737),
    [anon_sym_TILDE] = ACTIONS(2737),
    [anon_sym_DASH] = ACTIONS(2735),
    [anon_sym_PLUS] = ACTIONS(2735),
    [anon_sym_STAR] = ACTIONS(2737),
    [anon_sym_AMP_AMP] = ACTIONS(2737),
    [anon_sym_AMP] = ACTIONS(2735),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym___extension__] = ACTIONS(2735),
    [anon_sym_typedef] = ACTIONS(2735),
    [anon_sym_virtual] = ACTIONS(2735),
    [anon_sym_extern] = ACTIONS(2735),
    [anon_sym___attribute__] = ACTIONS(2735),
    [anon_sym___attribute] = ACTIONS(2735),
    [anon_sym_COLON_COLON] = ACTIONS(2737),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2737),
    [anon_sym___declspec] = ACTIONS(2735),
    [anon_sym___based] = ACTIONS(2735),
    [anon_sym___cdecl] = ACTIONS(2735),
    [anon_sym___clrcall] = ACTIONS(2735),
    [anon_sym___stdcall] = ACTIONS(2735),
    [anon_sym___fastcall] = ACTIONS(2735),
    [anon_sym___thiscall] = ACTIONS(2735),
    [anon_sym___vectorcall] = ACTIONS(2735),
    [anon_sym_LBRACE] = ACTIONS(2737),
    [anon_sym_signed] = ACTIONS(2735),
    [anon_sym_unsigned] = ACTIONS(2735),
    [anon_sym_long] = ACTIONS(2735),
    [anon_sym_short] = ACTIONS(2735),
    [anon_sym_LBRACK] = ACTIONS(2735),
    [anon_sym_static] = ACTIONS(2735),
    [anon_sym_register] = ACTIONS(2735),
    [anon_sym_inline] = ACTIONS(2735),
    [anon_sym___inline] = ACTIONS(2735),
    [anon_sym___inline__] = ACTIONS(2735),
    [anon_sym___forceinline] = ACTIONS(2735),
    [anon_sym_thread_local] = ACTIONS(2735),
    [anon_sym___thread] = ACTIONS(2735),
    [anon_sym_const] = ACTIONS(2735),
    [anon_sym_constexpr] = ACTIONS(2735),
    [anon_sym_volatile] = ACTIONS(2735),
    [anon_sym_restrict] = ACTIONS(2735),
    [anon_sym___restrict__] = ACTIONS(2735),
    [anon_sym__Atomic] = ACTIONS(2735),
    [anon_sym__Noreturn] = ACTIONS(2735),
    [anon_sym_noreturn] = ACTIONS(2735),
    [anon_sym__Nonnull] = ACTIONS(2735),
    [anon_sym_mutable] = ACTIONS(2735),
    [anon_sym_constinit] = ACTIONS(2735),
    [anon_sym_consteval] = ACTIONS(2735),
    [anon_sym_alignas] = ACTIONS(2735),
    [anon_sym__Alignas] = ACTIONS(2735),
    [sym_primitive_type] = ACTIONS(2735),
    [anon_sym_enum] = ACTIONS(2735),
    [anon_sym_class] = ACTIONS(2735),
    [anon_sym_struct] = ACTIONS(2735),
    [anon_sym_union] = ACTIONS(2735),
    [anon_sym_if] = ACTIONS(2735),
    [anon_sym_switch] = ACTIONS(2735),
    [anon_sym_case] = ACTIONS(2735),
    [anon_sym_default] = ACTIONS(2735),
    [anon_sym_while] = ACTIONS(2735),
    [anon_sym_do] = ACTIONS(2735),
    [anon_sym_for] = ACTIONS(2735),
    [anon_sym_return] = ACTIONS(2735),
    [anon_sym_break] = ACTIONS(2735),
    [anon_sym_continue] = ACTIONS(2735),
    [anon_sym_goto] = ACTIONS(2735),
    [anon_sym___try] = ACTIONS(2735),
    [anon_sym___leave] = ACTIONS(2735),
    [anon_sym_not] = ACTIONS(2735),
    [anon_sym_compl] = ACTIONS(2735),
    [anon_sym_DASH_DASH] = ACTIONS(2737),
    [anon_sym_PLUS_PLUS] = ACTIONS(2737),
    [anon_sym_sizeof] = ACTIONS(2735),
    [anon_sym___alignof__] = ACTIONS(2735),
    [anon_sym___alignof] = ACTIONS(2735),
    [anon_sym__alignof] = ACTIONS(2735),
    [anon_sym_alignof] = ACTIONS(2735),
    [anon_sym__Alignof] = ACTIONS(2735),
    [anon_sym_offsetof] = ACTIONS(2735),
    [anon_sym__Generic] = ACTIONS(2735),
    [anon_sym_asm] = ACTIONS(2735),
    [anon_sym___asm__] = ACTIONS(2735),
    [anon_sym___asm] = ACTIONS(2735),
    [sym_number_literal] = ACTIONS(2737),
    [anon_sym_L_SQUOTE] = ACTIONS(2737),
    [anon_sym_u_SQUOTE] = ACTIONS(2737),
    [anon_sym_U_SQUOTE] = ACTIONS(2737),
    [anon_sym_u8_SQUOTE] = ACTIONS(2737),
    [anon_sym_SQUOTE] = ACTIONS(2737),
    [anon_sym_L_DQUOTE] = ACTIONS(2737),
    [anon_sym_u_DQUOTE] = ACTIONS(2737),
    [anon_sym_U_DQUOTE] = ACTIONS(2737),
    [anon_sym_u8_DQUOTE] = ACTIONS(2737),
    [anon_sym_DQUOTE] = ACTIONS(2737),
    [sym_true] = ACTIONS(2735),
    [sym_false] = ACTIONS(2735),
    [anon_sym_NULL] = ACTIONS(2735),
    [anon_sym_nullptr] = ACTIONS(2735),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2735),
    [anon_sym_decltype] = ACTIONS(2735),
    [anon_sym_explicit] = ACTIONS(2735),
    [anon_sym_typename] = ACTIONS(2735),
    [anon_sym_template] = ACTIONS(2735),
    [anon_sym_operator] = ACTIONS(2735),
    [anon_sym_try] = ACTIONS(2735),
    [anon_sym_delete] = ACTIONS(2735),
    [anon_sym_throw] = ACTIONS(2735),
    [anon_sym_namespace] = ACTIONS(2735),
    [anon_sym_using] = ACTIONS(2735),
    [anon_sym_static_assert] = ACTIONS(2735),
    [anon_sym_concept] = ACTIONS(2735),
    [anon_sym_co_return] = ACTIONS(2735),
    [anon_sym_co_yield] = ACTIONS(2735),
    [anon_sym_R_DQUOTE] = ACTIONS(2737),
    [anon_sym_LR_DQUOTE] = ACTIONS(2737),
    [anon_sym_uR_DQUOTE] = ACTIONS(2737),
    [anon_sym_UR_DQUOTE] = ACTIONS(2737),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2737),
    [anon_sym_co_await] = ACTIONS(2735),
    [anon_sym_new] = ACTIONS(2735),
    [anon_sym_requires] = ACTIONS(2735),
    [sym_this] = ACTIONS(2735),
  },
  [274] = {
    [sym_identifier] = ACTIONS(2739),
    [aux_sym_preproc_include_token1] = ACTIONS(2739),
    [aux_sym_preproc_def_token1] = ACTIONS(2739),
    [aux_sym_preproc_if_token1] = ACTIONS(2739),
    [aux_sym_preproc_if_token2] = ACTIONS(2739),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2739),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2739),
    [aux_sym_preproc_else_token1] = ACTIONS(2739),
    [aux_sym_preproc_elif_token1] = ACTIONS(2739),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2739),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2739),
    [sym_preproc_directive] = ACTIONS(2739),
    [anon_sym_LPAREN2] = ACTIONS(2741),
    [anon_sym_BANG] = ACTIONS(2741),
    [anon_sym_TILDE] = ACTIONS(2741),
    [anon_sym_DASH] = ACTIONS(2739),
    [anon_sym_PLUS] = ACTIONS(2739),
    [anon_sym_STAR] = ACTIONS(2741),
    [anon_sym_AMP_AMP] = ACTIONS(2741),
    [anon_sym_AMP] = ACTIONS(2739),
    [anon_sym_SEMI] = ACTIONS(2741),
    [anon_sym___extension__] = ACTIONS(2739),
    [anon_sym_typedef] = ACTIONS(2739),
    [anon_sym_virtual] = ACTIONS(2739),
    [anon_sym_extern] = ACTIONS(2739),
    [anon_sym___attribute__] = ACTIONS(2739),
    [anon_sym___attribute] = ACTIONS(2739),
    [anon_sym_COLON_COLON] = ACTIONS(2741),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2741),
    [anon_sym___declspec] = ACTIONS(2739),
    [anon_sym___based] = ACTIONS(2739),
    [anon_sym___cdecl] = ACTIONS(2739),
    [anon_sym___clrcall] = ACTIONS(2739),
    [anon_sym___stdcall] = ACTIONS(2739),
    [anon_sym___fastcall] = ACTIONS(2739),
    [anon_sym___thiscall] = ACTIONS(2739),
    [anon_sym___vectorcall] = ACTIONS(2739),
    [anon_sym_LBRACE] = ACTIONS(2741),
    [anon_sym_signed] = ACTIONS(2739),
    [anon_sym_unsigned] = ACTIONS(2739),
    [anon_sym_long] = ACTIONS(2739),
    [anon_sym_short] = ACTIONS(2739),
    [anon_sym_LBRACK] = ACTIONS(2739),
    [anon_sym_static] = ACTIONS(2739),
    [anon_sym_register] = ACTIONS(2739),
    [anon_sym_inline] = ACTIONS(2739),
    [anon_sym___inline] = ACTIONS(2739),
    [anon_sym___inline__] = ACTIONS(2739),
    [anon_sym___forceinline] = ACTIONS(2739),
    [anon_sym_thread_local] = ACTIONS(2739),
    [anon_sym___thread] = ACTIONS(2739),
    [anon_sym_const] = ACTIONS(2739),
    [anon_sym_constexpr] = ACTIONS(2739),
    [anon_sym_volatile] = ACTIONS(2739),
    [anon_sym_restrict] = ACTIONS(2739),
    [anon_sym___restrict__] = ACTIONS(2739),
    [anon_sym__Atomic] = ACTIONS(2739),
    [anon_sym__Noreturn] = ACTIONS(2739),
    [anon_sym_noreturn] = ACTIONS(2739),
    [anon_sym__Nonnull] = ACTIONS(2739),
    [anon_sym_mutable] = ACTIONS(2739),
    [anon_sym_constinit] = ACTIONS(2739),
    [anon_sym_consteval] = ACTIONS(2739),
    [anon_sym_alignas] = ACTIONS(2739),
    [anon_sym__Alignas] = ACTIONS(2739),
    [sym_primitive_type] = ACTIONS(2739),
    [anon_sym_enum] = ACTIONS(2739),
    [anon_sym_class] = ACTIONS(2739),
    [anon_sym_struct] = ACTIONS(2739),
    [anon_sym_union] = ACTIONS(2739),
    [anon_sym_if] = ACTIONS(2739),
    [anon_sym_switch] = ACTIONS(2739),
    [anon_sym_case] = ACTIONS(2739),
    [anon_sym_default] = ACTIONS(2739),
    [anon_sym_while] = ACTIONS(2739),
    [anon_sym_do] = ACTIONS(2739),
    [anon_sym_for] = ACTIONS(2739),
    [anon_sym_return] = ACTIONS(2739),
    [anon_sym_break] = ACTIONS(2739),
    [anon_sym_continue] = ACTIONS(2739),
    [anon_sym_goto] = ACTIONS(2739),
    [anon_sym___try] = ACTIONS(2739),
    [anon_sym___leave] = ACTIONS(2739),
    [anon_sym_not] = ACTIONS(2739),
    [anon_sym_compl] = ACTIONS(2739),
    [anon_sym_DASH_DASH] = ACTIONS(2741),
    [anon_sym_PLUS_PLUS] = ACTIONS(2741),
    [anon_sym_sizeof] = ACTIONS(2739),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2739),
    [anon_sym__Generic] = ACTIONS(2739),
    [anon_sym_asm] = ACTIONS(2739),
    [anon_sym___asm__] = ACTIONS(2739),
    [anon_sym___asm] = ACTIONS(2739),
    [sym_number_literal] = ACTIONS(2741),
    [anon_sym_L_SQUOTE] = ACTIONS(2741),
    [anon_sym_u_SQUOTE] = ACTIONS(2741),
    [anon_sym_U_SQUOTE] = ACTIONS(2741),
    [anon_sym_u8_SQUOTE] = ACTIONS(2741),
    [anon_sym_SQUOTE] = ACTIONS(2741),
    [anon_sym_L_DQUOTE] = ACTIONS(2741),
    [anon_sym_u_DQUOTE] = ACTIONS(2741),
    [anon_sym_U_DQUOTE] = ACTIONS(2741),
    [anon_sym_u8_DQUOTE] = ACTIONS(2741),
    [anon_sym_DQUOTE] = ACTIONS(2741),
    [sym_true] = ACTIONS(2739),
    [sym_false] = ACTIONS(2739),
    [anon_sym_NULL] = ACTIONS(2739),
    [anon_sym_nullptr] = ACTIONS(2739),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2739),
    [anon_sym_decltype] = ACTIONS(2739),
    [anon_sym_explicit] = ACTIONS(2739),
    [anon_sym_typename] = ACTIONS(2739),
    [anon_sym_template] = ACTIONS(2739),
    [anon_sym_operator] = ACTIONS(2739),
    [anon_sym_try] = ACTIONS(2739),
    [anon_sym_delete] = ACTIONS(2739),
    [anon_sym_throw] = ACTIONS(2739),
    [anon_sym_namespace] = ACTIONS(2739),
    [anon_sym_using] = ACTIONS(2739),
    [anon_sym_static_assert] = ACTIONS(2739),
    [anon_sym_concept] = ACTIONS(2739),
    [anon_sym_co_return] = ACTIONS(2739),
    [anon_sym_co_yield] = ACTIONS(2739),
    [anon_sym_R_DQUOTE] = ACTIONS(2741),
    [anon_sym_LR_DQUOTE] = ACTIONS(2741),
    [anon_sym_uR_DQUOTE] = ACTIONS(2741),
    [anon_sym_UR_DQUOTE] = ACTIONS(2741),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2741),
    [anon_sym_co_await] = ACTIONS(2739),
    [anon_sym_new] = ACTIONS(2739),
    [anon_sym_requires] = ACTIONS(2739),
    [sym_this] = ACTIONS(2739),
  },
  [275] = {
    [sym_identifier] = ACTIONS(2743),
    [aux_sym_preproc_include_token1] = ACTIONS(2743),
    [aux_sym_preproc_def_token1] = ACTIONS(2743),
    [aux_sym_preproc_if_token1] = ACTIONS(2743),
    [aux_sym_preproc_if_token2] = ACTIONS(2743),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2743),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2743),
    [aux_sym_preproc_else_token1] = ACTIONS(2743),
    [aux_sym_preproc_elif_token1] = ACTIONS(2743),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2743),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2743),
    [sym_preproc_directive] = ACTIONS(2743),
    [anon_sym_LPAREN2] = ACTIONS(2745),
    [anon_sym_BANG] = ACTIONS(2745),
    [anon_sym_TILDE] = ACTIONS(2745),
    [anon_sym_DASH] = ACTIONS(2743),
    [anon_sym_PLUS] = ACTIONS(2743),
    [anon_sym_STAR] = ACTIONS(2745),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_AMP] = ACTIONS(2743),
    [anon_sym_SEMI] = ACTIONS(2745),
    [anon_sym___extension__] = ACTIONS(2743),
    [anon_sym_typedef] = ACTIONS(2743),
    [anon_sym_virtual] = ACTIONS(2743),
    [anon_sym_extern] = ACTIONS(2743),
    [anon_sym___attribute__] = ACTIONS(2743),
    [anon_sym___attribute] = ACTIONS(2743),
    [anon_sym_COLON_COLON] = ACTIONS(2745),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2745),
    [anon_sym___declspec] = ACTIONS(2743),
    [anon_sym___based] = ACTIONS(2743),
    [anon_sym___cdecl] = ACTIONS(2743),
    [anon_sym___clrcall] = ACTIONS(2743),
    [anon_sym___stdcall] = ACTIONS(2743),
    [anon_sym___fastcall] = ACTIONS(2743),
    [anon_sym___thiscall] = ACTIONS(2743),
    [anon_sym___vectorcall] = ACTIONS(2743),
    [anon_sym_LBRACE] = ACTIONS(2745),
    [anon_sym_signed] = ACTIONS(2743),
    [anon_sym_unsigned] = ACTIONS(2743),
    [anon_sym_long] = ACTIONS(2743),
    [anon_sym_short] = ACTIONS(2743),
    [anon_sym_LBRACK] = ACTIONS(2743),
    [anon_sym_static] = ACTIONS(2743),
    [anon_sym_register] = ACTIONS(2743),
    [anon_sym_inline] = ACTIONS(2743),
    [anon_sym___inline] = ACTIONS(2743),
    [anon_sym___inline__] = ACTIONS(2743),
    [anon_sym___forceinline] = ACTIONS(2743),
    [anon_sym_thread_local] = ACTIONS(2743),
    [anon_sym___thread] = ACTIONS(2743),
    [anon_sym_const] = ACTIONS(2743),
    [anon_sym_constexpr] = ACTIONS(2743),
    [anon_sym_volatile] = ACTIONS(2743),
    [anon_sym_restrict] = ACTIONS(2743),
    [anon_sym___restrict__] = ACTIONS(2743),
    [anon_sym__Atomic] = ACTIONS(2743),
    [anon_sym__Noreturn] = ACTIONS(2743),
    [anon_sym_noreturn] = ACTIONS(2743),
    [anon_sym__Nonnull] = ACTIONS(2743),
    [anon_sym_mutable] = ACTIONS(2743),
    [anon_sym_constinit] = ACTIONS(2743),
    [anon_sym_consteval] = ACTIONS(2743),
    [anon_sym_alignas] = ACTIONS(2743),
    [anon_sym__Alignas] = ACTIONS(2743),
    [sym_primitive_type] = ACTIONS(2743),
    [anon_sym_enum] = ACTIONS(2743),
    [anon_sym_class] = ACTIONS(2743),
    [anon_sym_struct] = ACTIONS(2743),
    [anon_sym_union] = ACTIONS(2743),
    [anon_sym_if] = ACTIONS(2743),
    [anon_sym_switch] = ACTIONS(2743),
    [anon_sym_case] = ACTIONS(2743),
    [anon_sym_default] = ACTIONS(2743),
    [anon_sym_while] = ACTIONS(2743),
    [anon_sym_do] = ACTIONS(2743),
    [anon_sym_for] = ACTIONS(2743),
    [anon_sym_return] = ACTIONS(2743),
    [anon_sym_break] = ACTIONS(2743),
    [anon_sym_continue] = ACTIONS(2743),
    [anon_sym_goto] = ACTIONS(2743),
    [anon_sym___try] = ACTIONS(2743),
    [anon_sym___leave] = ACTIONS(2743),
    [anon_sym_not] = ACTIONS(2743),
    [anon_sym_compl] = ACTIONS(2743),
    [anon_sym_DASH_DASH] = ACTIONS(2745),
    [anon_sym_PLUS_PLUS] = ACTIONS(2745),
    [anon_sym_sizeof] = ACTIONS(2743),
    [anon_sym___alignof__] = ACTIONS(2743),
    [anon_sym___alignof] = ACTIONS(2743),
    [anon_sym__alignof] = ACTIONS(2743),
    [anon_sym_alignof] = ACTIONS(2743),
    [anon_sym__Alignof] = ACTIONS(2743),
    [anon_sym_offsetof] = ACTIONS(2743),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2743),
    [anon_sym___asm__] = ACTIONS(2743),
    [anon_sym___asm] = ACTIONS(2743),
    [sym_number_literal] = ACTIONS(2745),
    [anon_sym_L_SQUOTE] = ACTIONS(2745),
    [anon_sym_u_SQUOTE] = ACTIONS(2745),
    [anon_sym_U_SQUOTE] = ACTIONS(2745),
    [anon_sym_u8_SQUOTE] = ACTIONS(2745),
    [anon_sym_SQUOTE] = ACTIONS(2745),
    [anon_sym_L_DQUOTE] = ACTIONS(2745),
    [anon_sym_u_DQUOTE] = ACTIONS(2745),
    [anon_sym_U_DQUOTE] = ACTIONS(2745),
    [anon_sym_u8_DQUOTE] = ACTIONS(2745),
    [anon_sym_DQUOTE] = ACTIONS(2745),
    [sym_true] = ACTIONS(2743),
    [sym_false] = ACTIONS(2743),
    [anon_sym_NULL] = ACTIONS(2743),
    [anon_sym_nullptr] = ACTIONS(2743),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2743),
    [anon_sym_decltype] = ACTIONS(2743),
    [anon_sym_explicit] = ACTIONS(2743),
    [anon_sym_typename] = ACTIONS(2743),
    [anon_sym_template] = ACTIONS(2743),
    [anon_sym_operator] = ACTIONS(2743),
    [anon_sym_try] = ACTIONS(2743),
    [anon_sym_delete] = ACTIONS(2743),
    [anon_sym_throw] = ACTIONS(2743),
    [anon_sym_namespace] = ACTIONS(2743),
    [anon_sym_using] = ACTIONS(2743),
    [anon_sym_static_assert] = ACTIONS(2743),
    [anon_sym_concept] = ACTIONS(2743),
    [anon_sym_co_return] = ACTIONS(2743),
    [anon_sym_co_yield] = ACTIONS(2743),
    [anon_sym_R_DQUOTE] = ACTIONS(2745),
    [anon_sym_LR_DQUOTE] = ACTIONS(2745),
    [anon_sym_uR_DQUOTE] = ACTIONS(2745),
    [anon_sym_UR_DQUOTE] = ACTIONS(2745),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2745),
    [anon_sym_co_await] = ACTIONS(2743),
    [anon_sym_new] = ACTIONS(2743),
    [anon_sym_requires] = ACTIONS(2743),
    [sym_this] = ACTIONS(2743),
  },
  [276] = {
    [sym_identifier] = ACTIONS(2747),
    [aux_sym_preproc_include_token1] = ACTIONS(2747),
    [aux_sym_preproc_def_token1] = ACTIONS(2747),
    [aux_sym_preproc_if_token1] = ACTIONS(2747),
    [aux_sym_preproc_if_token2] = ACTIONS(2747),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2747),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2747),
    [aux_sym_preproc_else_token1] = ACTIONS(2747),
    [aux_sym_preproc_elif_token1] = ACTIONS(2747),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2747),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2747),
    [sym_preproc_directive] = ACTIONS(2747),
    [anon_sym_LPAREN2] = ACTIONS(2749),
    [anon_sym_BANG] = ACTIONS(2749),
    [anon_sym_TILDE] = ACTIONS(2749),
    [anon_sym_DASH] = ACTIONS(2747),
    [anon_sym_PLUS] = ACTIONS(2747),
    [anon_sym_STAR] = ACTIONS(2749),
    [anon_sym_AMP_AMP] = ACTIONS(2749),
    [anon_sym_AMP] = ACTIONS(2747),
    [anon_sym_SEMI] = ACTIONS(2749),
    [anon_sym___extension__] = ACTIONS(2747),
    [anon_sym_typedef] = ACTIONS(2747),
    [anon_sym_virtual] = ACTIONS(2747),
    [anon_sym_extern] = ACTIONS(2747),
    [anon_sym___attribute__] = ACTIONS(2747),
    [anon_sym___attribute] = ACTIONS(2747),
    [anon_sym_COLON_COLON] = ACTIONS(2749),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2749),
    [anon_sym___declspec] = ACTIONS(2747),
    [anon_sym___based] = ACTIONS(2747),
    [anon_sym___cdecl] = ACTIONS(2747),
    [anon_sym___clrcall] = ACTIONS(2747),
    [anon_sym___stdcall] = ACTIONS(2747),
    [anon_sym___fastcall] = ACTIONS(2747),
    [anon_sym___thiscall] = ACTIONS(2747),
    [anon_sym___vectorcall] = ACTIONS(2747),
    [anon_sym_LBRACE] = ACTIONS(2749),
    [anon_sym_signed] = ACTIONS(2747),
    [anon_sym_unsigned] = ACTIONS(2747),
    [anon_sym_long] = ACTIONS(2747),
    [anon_sym_short] = ACTIONS(2747),
    [anon_sym_LBRACK] = ACTIONS(2747),
    [anon_sym_static] = ACTIONS(2747),
    [anon_sym_register] = ACTIONS(2747),
    [anon_sym_inline] = ACTIONS(2747),
    [anon_sym___inline] = ACTIONS(2747),
    [anon_sym___inline__] = ACTIONS(2747),
    [anon_sym___forceinline] = ACTIONS(2747),
    [anon_sym_thread_local] = ACTIONS(2747),
    [anon_sym___thread] = ACTIONS(2747),
    [anon_sym_const] = ACTIONS(2747),
    [anon_sym_constexpr] = ACTIONS(2747),
    [anon_sym_volatile] = ACTIONS(2747),
    [anon_sym_restrict] = ACTIONS(2747),
    [anon_sym___restrict__] = ACTIONS(2747),
    [anon_sym__Atomic] = ACTIONS(2747),
    [anon_sym__Noreturn] = ACTIONS(2747),
    [anon_sym_noreturn] = ACTIONS(2747),
    [anon_sym__Nonnull] = ACTIONS(2747),
    [anon_sym_mutable] = ACTIONS(2747),
    [anon_sym_constinit] = ACTIONS(2747),
    [anon_sym_consteval] = ACTIONS(2747),
    [anon_sym_alignas] = ACTIONS(2747),
    [anon_sym__Alignas] = ACTIONS(2747),
    [sym_primitive_type] = ACTIONS(2747),
    [anon_sym_enum] = ACTIONS(2747),
    [anon_sym_class] = ACTIONS(2747),
    [anon_sym_struct] = ACTIONS(2747),
    [anon_sym_union] = ACTIONS(2747),
    [anon_sym_if] = ACTIONS(2747),
    [anon_sym_switch] = ACTIONS(2747),
    [anon_sym_case] = ACTIONS(2747),
    [anon_sym_default] = ACTIONS(2747),
    [anon_sym_while] = ACTIONS(2747),
    [anon_sym_do] = ACTIONS(2747),
    [anon_sym_for] = ACTIONS(2747),
    [anon_sym_return] = ACTIONS(2747),
    [anon_sym_break] = ACTIONS(2747),
    [anon_sym_continue] = ACTIONS(2747),
    [anon_sym_goto] = ACTIONS(2747),
    [anon_sym___try] = ACTIONS(2747),
    [anon_sym___leave] = ACTIONS(2747),
    [anon_sym_not] = ACTIONS(2747),
    [anon_sym_compl] = ACTIONS(2747),
    [anon_sym_DASH_DASH] = ACTIONS(2749),
    [anon_sym_PLUS_PLUS] = ACTIONS(2749),
    [anon_sym_sizeof] = ACTIONS(2747),
    [anon_sym___alignof__] = ACTIONS(2747),
    [anon_sym___alignof] = ACTIONS(2747),
    [anon_sym__alignof] = ACTIONS(2747),
    [anon_sym_alignof] = ACTIONS(2747),
    [anon_sym__Alignof] = ACTIONS(2747),
    [anon_sym_offsetof] = ACTIONS(2747),
    [anon_sym__Generic] = ACTIONS(2747),
    [anon_sym_asm] = ACTIONS(2747),
    [anon_sym___asm__] = ACTIONS(2747),
    [anon_sym___asm] = ACTIONS(2747),
    [sym_number_literal] = ACTIONS(2749),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2749),
    [anon_sym_u_DQUOTE] = ACTIONS(2749),
    [anon_sym_U_DQUOTE] = ACTIONS(2749),
    [anon_sym_u8_DQUOTE] = ACTIONS(2749),
    [anon_sym_DQUOTE] = ACTIONS(2749),
    [sym_true] = ACTIONS(2747),
    [sym_false] = ACTIONS(2747),
    [anon_sym_NULL] = ACTIONS(2747),
    [anon_sym_nullptr] = ACTIONS(2747),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2747),
    [anon_sym_decltype] = ACTIONS(2747),
    [anon_sym_explicit] = ACTIONS(2747),
    [anon_sym_typename] = ACTIONS(2747),
    [anon_sym_template] = ACTIONS(2747),
    [anon_sym_operator] = ACTIONS(2747),
    [anon_sym_try] = ACTIONS(2747),
    [anon_sym_delete] = ACTIONS(2747),
    [anon_sym_throw] = ACTIONS(2747),
    [anon_sym_namespace] = ACTIONS(2747),
    [anon_sym_using] = ACTIONS(2747),
    [anon_sym_static_assert] = ACTIONS(2747),
    [anon_sym_concept] = ACTIONS(2747),
    [anon_sym_co_return] = ACTIONS(2747),
    [anon_sym_co_yield] = ACTIONS(2747),
    [anon_sym_R_DQUOTE] = ACTIONS(2749),
    [anon_sym_LR_DQUOTE] = ACTIONS(2749),
    [anon_sym_uR_DQUOTE] = ACTIONS(2749),
    [anon_sym_UR_DQUOTE] = ACTIONS(2749),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2749),
    [anon_sym_co_await] = ACTIONS(2747),
    [anon_sym_new] = ACTIONS(2747),
    [anon_sym_requires] = ACTIONS(2747),
    [sym_this] = ACTIONS(2747),
  },
  [277] = {
    [sym_identifier] = ACTIONS(2747),
    [aux_sym_preproc_include_token1] = ACTIONS(2747),
    [aux_sym_preproc_def_token1] = ACTIONS(2747),
    [aux_sym_preproc_if_token1] = ACTIONS(2747),
    [aux_sym_preproc_if_token2] = ACTIONS(2747),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2747),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2747),
    [aux_sym_preproc_else_token1] = ACTIONS(2747),
    [aux_sym_preproc_elif_token1] = ACTIONS(2747),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2747),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2747),
    [sym_preproc_directive] = ACTIONS(2747),
    [anon_sym_LPAREN2] = ACTIONS(2749),
    [anon_sym_BANG] = ACTIONS(2749),
    [anon_sym_TILDE] = ACTIONS(2749),
    [anon_sym_DASH] = ACTIONS(2747),
    [anon_sym_PLUS] = ACTIONS(2747),
    [anon_sym_STAR] = ACTIONS(2749),
    [anon_sym_AMP_AMP] = ACTIONS(2749),
    [anon_sym_AMP] = ACTIONS(2747),
    [anon_sym_SEMI] = ACTIONS(2749),
    [anon_sym___extension__] = ACTIONS(2747),
    [anon_sym_typedef] = ACTIONS(2747),
    [anon_sym_virtual] = ACTIONS(2747),
    [anon_sym_extern] = ACTIONS(2747),
    [anon_sym___attribute__] = ACTIONS(2747),
    [anon_sym___attribute] = ACTIONS(2747),
    [anon_sym_COLON_COLON] = ACTIONS(2749),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2749),
    [anon_sym___declspec] = ACTIONS(2747),
    [anon_sym___based] = ACTIONS(2747),
    [anon_sym___cdecl] = ACTIONS(2747),
    [anon_sym___clrcall] = ACTIONS(2747),
    [anon_sym___stdcall] = ACTIONS(2747),
    [anon_sym___fastcall] = ACTIONS(2747),
    [anon_sym___thiscall] = ACTIONS(2747),
    [anon_sym___vectorcall] = ACTIONS(2747),
    [anon_sym_LBRACE] = ACTIONS(2749),
    [anon_sym_signed] = ACTIONS(2747),
    [anon_sym_unsigned] = ACTIONS(2747),
    [anon_sym_long] = ACTIONS(2747),
    [anon_sym_short] = ACTIONS(2747),
    [anon_sym_LBRACK] = ACTIONS(2747),
    [anon_sym_static] = ACTIONS(2747),
    [anon_sym_register] = ACTIONS(2747),
    [anon_sym_inline] = ACTIONS(2747),
    [anon_sym___inline] = ACTIONS(2747),
    [anon_sym___inline__] = ACTIONS(2747),
    [anon_sym___forceinline] = ACTIONS(2747),
    [anon_sym_thread_local] = ACTIONS(2747),
    [anon_sym___thread] = ACTIONS(2747),
    [anon_sym_const] = ACTIONS(2747),
    [anon_sym_constexpr] = ACTIONS(2747),
    [anon_sym_volatile] = ACTIONS(2747),
    [anon_sym_restrict] = ACTIONS(2747),
    [anon_sym___restrict__] = ACTIONS(2747),
    [anon_sym__Atomic] = ACTIONS(2747),
    [anon_sym__Noreturn] = ACTIONS(2747),
    [anon_sym_noreturn] = ACTIONS(2747),
    [anon_sym__Nonnull] = ACTIONS(2747),
    [anon_sym_mutable] = ACTIONS(2747),
    [anon_sym_constinit] = ACTIONS(2747),
    [anon_sym_consteval] = ACTIONS(2747),
    [anon_sym_alignas] = ACTIONS(2747),
    [anon_sym__Alignas] = ACTIONS(2747),
    [sym_primitive_type] = ACTIONS(2747),
    [anon_sym_enum] = ACTIONS(2747),
    [anon_sym_class] = ACTIONS(2747),
    [anon_sym_struct] = ACTIONS(2747),
    [anon_sym_union] = ACTIONS(2747),
    [anon_sym_if] = ACTIONS(2747),
    [anon_sym_switch] = ACTIONS(2747),
    [anon_sym_case] = ACTIONS(2747),
    [anon_sym_default] = ACTIONS(2747),
    [anon_sym_while] = ACTIONS(2747),
    [anon_sym_do] = ACTIONS(2747),
    [anon_sym_for] = ACTIONS(2747),
    [anon_sym_return] = ACTIONS(2747),
    [anon_sym_break] = ACTIONS(2747),
    [anon_sym_continue] = ACTIONS(2747),
    [anon_sym_goto] = ACTIONS(2747),
    [anon_sym___try] = ACTIONS(2747),
    [anon_sym___leave] = ACTIONS(2747),
    [anon_sym_not] = ACTIONS(2747),
    [anon_sym_compl] = ACTIONS(2747),
    [anon_sym_DASH_DASH] = ACTIONS(2749),
    [anon_sym_PLUS_PLUS] = ACTIONS(2749),
    [anon_sym_sizeof] = ACTIONS(2747),
    [anon_sym___alignof__] = ACTIONS(2747),
    [anon_sym___alignof] = ACTIONS(2747),
    [anon_sym__alignof] = ACTIONS(2747),
    [anon_sym_alignof] = ACTIONS(2747),
    [anon_sym__Alignof] = ACTIONS(2747),
    [anon_sym_offsetof] = ACTIONS(2747),
    [anon_sym__Generic] = ACTIONS(2747),
    [anon_sym_asm] = ACTIONS(2747),
    [anon_sym___asm__] = ACTIONS(2747),
    [anon_sym___asm] = ACTIONS(2747),
    [sym_number_literal] = ACTIONS(2749),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2749),
    [anon_sym_u_DQUOTE] = ACTIONS(2749),
    [anon_sym_U_DQUOTE] = ACTIONS(2749),
    [anon_sym_u8_DQUOTE] = ACTIONS(2749),
    [anon_sym_DQUOTE] = ACTIONS(2749),
    [sym_true] = ACTIONS(2747),
    [sym_false] = ACTIONS(2747),
    [anon_sym_NULL] = ACTIONS(2747),
    [anon_sym_nullptr] = ACTIONS(2747),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2747),
    [anon_sym_decltype] = ACTIONS(2747),
    [anon_sym_explicit] = ACTIONS(2747),
    [anon_sym_typename] = ACTIONS(2747),
    [anon_sym_template] = ACTIONS(2747),
    [anon_sym_operator] = ACTIONS(2747),
    [anon_sym_try] = ACTIONS(2747),
    [anon_sym_delete] = ACTIONS(2747),
    [anon_sym_throw] = ACTIONS(2747),
    [anon_sym_namespace] = ACTIONS(2747),
    [anon_sym_using] = ACTIONS(2747),
    [anon_sym_static_assert] = ACTIONS(2747),
    [anon_sym_concept] = ACTIONS(2747),
    [anon_sym_co_return] = ACTIONS(2747),
    [anon_sym_co_yield] = ACTIONS(2747),
    [anon_sym_R_DQUOTE] = ACTIONS(2749),
    [anon_sym_LR_DQUOTE] = ACTIONS(2749),
    [anon_sym_uR_DQUOTE] = ACTIONS(2749),
    [anon_sym_UR_DQUOTE] = ACTIONS(2749),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2749),
    [anon_sym_co_await] = ACTIONS(2747),
    [anon_sym_new] = ACTIONS(2747),
    [anon_sym_requires] = ACTIONS(2747),
    [sym_this] = ACTIONS(2747),
  },
  [278] = {
    [sym_identifier] = ACTIONS(2751),
    [aux_sym_preproc_include_token1] = ACTIONS(2751),
    [aux_sym_preproc_def_token1] = ACTIONS(2751),
    [aux_sym_preproc_if_token1] = ACTIONS(2751),
    [aux_sym_preproc_if_token2] = ACTIONS(2751),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2751),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2751),
    [aux_sym_preproc_else_token1] = ACTIONS(2751),
    [aux_sym_preproc_elif_token1] = ACTIONS(2751),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2751),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2751),
    [sym_preproc_directive] = ACTIONS(2751),
    [anon_sym_LPAREN2] = ACTIONS(2753),
    [anon_sym_BANG] = ACTIONS(2753),
    [anon_sym_TILDE] = ACTIONS(2753),
    [anon_sym_DASH] = ACTIONS(2751),
    [anon_sym_PLUS] = ACTIONS(2751),
    [anon_sym_STAR] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2751),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym___extension__] = ACTIONS(2751),
    [anon_sym_typedef] = ACTIONS(2751),
    [anon_sym_virtual] = ACTIONS(2751),
    [anon_sym_extern] = ACTIONS(2751),
    [anon_sym___attribute__] = ACTIONS(2751),
    [anon_sym___attribute] = ACTIONS(2751),
    [anon_sym_COLON_COLON] = ACTIONS(2753),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2753),
    [anon_sym___declspec] = ACTIONS(2751),
    [anon_sym___based] = ACTIONS(2751),
    [anon_sym___cdecl] = ACTIONS(2751),
    [anon_sym___clrcall] = ACTIONS(2751),
    [anon_sym___stdcall] = ACTIONS(2751),
    [anon_sym___fastcall] = ACTIONS(2751),
    [anon_sym___thiscall] = ACTIONS(2751),
    [anon_sym___vectorcall] = ACTIONS(2751),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_signed] = ACTIONS(2751),
    [anon_sym_unsigned] = ACTIONS(2751),
    [anon_sym_long] = ACTIONS(2751),
    [anon_sym_short] = ACTIONS(2751),
    [anon_sym_LBRACK] = ACTIONS(2751),
    [anon_sym_static] = ACTIONS(2751),
    [anon_sym_register] = ACTIONS(2751),
    [anon_sym_inline] = ACTIONS(2751),
    [anon_sym___inline] = ACTIONS(2751),
    [anon_sym___inline__] = ACTIONS(2751),
    [anon_sym___forceinline] = ACTIONS(2751),
    [anon_sym_thread_local] = ACTIONS(2751),
    [anon_sym___thread] = ACTIONS(2751),
    [anon_sym_const] = ACTIONS(2751),
    [anon_sym_constexpr] = ACTIONS(2751),
    [anon_sym_volatile] = ACTIONS(2751),
    [anon_sym_restrict] = ACTIONS(2751),
    [anon_sym___restrict__] = ACTIONS(2751),
    [anon_sym__Atomic] = ACTIONS(2751),
    [anon_sym__Noreturn] = ACTIONS(2751),
    [anon_sym_noreturn] = ACTIONS(2751),
    [anon_sym__Nonnull] = ACTIONS(2751),
    [anon_sym_mutable] = ACTIONS(2751),
    [anon_sym_constinit] = ACTIONS(2751),
    [anon_sym_consteval] = ACTIONS(2751),
    [anon_sym_alignas] = ACTIONS(2751),
    [anon_sym__Alignas] = ACTIONS(2751),
    [sym_primitive_type] = ACTIONS(2751),
    [anon_sym_enum] = ACTIONS(2751),
    [anon_sym_class] = ACTIONS(2751),
    [anon_sym_struct] = ACTIONS(2751),
    [anon_sym_union] = ACTIONS(2751),
    [anon_sym_if] = ACTIONS(2751),
    [anon_sym_switch] = ACTIONS(2751),
    [anon_sym_case] = ACTIONS(2751),
    [anon_sym_default] = ACTIONS(2751),
    [anon_sym_while] = ACTIONS(2751),
    [anon_sym_do] = ACTIONS(2751),
    [anon_sym_for] = ACTIONS(2751),
    [anon_sym_return] = ACTIONS(2751),
    [anon_sym_break] = ACTIONS(2751),
    [anon_sym_continue] = ACTIONS(2751),
    [anon_sym_goto] = ACTIONS(2751),
    [anon_sym___try] = ACTIONS(2751),
    [anon_sym___leave] = ACTIONS(2751),
    [anon_sym_not] = ACTIONS(2751),
    [anon_sym_compl] = ACTIONS(2751),
    [anon_sym_DASH_DASH] = ACTIONS(2753),
    [anon_sym_PLUS_PLUS] = ACTIONS(2753),
    [anon_sym_sizeof] = ACTIONS(2751),
    [anon_sym___alignof__] = ACTIONS(2751),
    [anon_sym___alignof] = ACTIONS(2751),
    [anon_sym__alignof] = ACTIONS(2751),
    [anon_sym_alignof] = ACTIONS(2751),
    [anon_sym__Alignof] = ACTIONS(2751),
    [anon_sym_offsetof] = ACTIONS(2751),
    [anon_sym__Generic] = ACTIONS(2751),
    [anon_sym_asm] = ACTIONS(2751),
    [anon_sym___asm__] = ACTIONS(2751),
    [anon_sym___asm] = ACTIONS(2751),
    [sym_number_literal] = ACTIONS(2753),
    [anon_sym_L_SQUOTE] = ACTIONS(2753),
    [anon_sym_u_SQUOTE] = ACTIONS(2753),
    [anon_sym_U_SQUOTE] = ACTIONS(2753),
    [anon_sym_u8_SQUOTE] = ACTIONS(2753),
    [anon_sym_SQUOTE] = ACTIONS(2753),
    [anon_sym_L_DQUOTE] = ACTIONS(2753),
    [anon_sym_u_DQUOTE] = ACTIONS(2753),
    [anon_sym_U_DQUOTE] = ACTIONS(2753),
    [anon_sym_u8_DQUOTE] = ACTIONS(2753),
    [anon_sym_DQUOTE] = ACTIONS(2753),
    [sym_true] = ACTIONS(2751),
    [sym_false] = ACTIONS(2751),
    [anon_sym_NULL] = ACTIONS(2751),
    [anon_sym_nullptr] = ACTIONS(2751),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2751),
    [anon_sym_decltype] = ACTIONS(2751),
    [anon_sym_explicit] = ACTIONS(2751),
    [anon_sym_typename] = ACTIONS(2751),
    [anon_sym_template] = ACTIONS(2751),
    [anon_sym_operator] = ACTIONS(2751),
    [anon_sym_try] = ACTIONS(2751),
    [anon_sym_delete] = ACTIONS(2751),
    [anon_sym_throw] = ACTIONS(2751),
    [anon_sym_namespace] = ACTIONS(2751),
    [anon_sym_using] = ACTIONS(2751),
    [anon_sym_static_assert] = ACTIONS(2751),
    [anon_sym_concept] = ACTIONS(2751),
    [anon_sym_co_return] = ACTIONS(2751),
    [anon_sym_co_yield] = ACTIONS(2751),
    [anon_sym_R_DQUOTE] = ACTIONS(2753),
    [anon_sym_LR_DQUOTE] = ACTIONS(2753),
    [anon_sym_uR_DQUOTE] = ACTIONS(2753),
    [anon_sym_UR_DQUOTE] = ACTIONS(2753),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2753),
    [anon_sym_co_await] = ACTIONS(2751),
    [anon_sym_new] = ACTIONS(2751),
    [anon_sym_requires] = ACTIONS(2751),
    [sym_this] = ACTIONS(2751),
  },
  [279] = {
    [sym_identifier] = ACTIONS(2755),
    [aux_sym_preproc_include_token1] = ACTIONS(2755),
    [aux_sym_preproc_def_token1] = ACTIONS(2755),
    [aux_sym_preproc_if_token1] = ACTIONS(2755),
    [aux_sym_preproc_if_token2] = ACTIONS(2755),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2755),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2755),
    [aux_sym_preproc_else_token1] = ACTIONS(2755),
    [aux_sym_preproc_elif_token1] = ACTIONS(2755),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2755),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2755),
    [sym_preproc_directive] = ACTIONS(2755),
    [anon_sym_LPAREN2] = ACTIONS(2757),
    [anon_sym_BANG] = ACTIONS(2757),
    [anon_sym_TILDE] = ACTIONS(2757),
    [anon_sym_DASH] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_STAR] = ACTIONS(2757),
    [anon_sym_AMP_AMP] = ACTIONS(2757),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2757),
    [anon_sym___extension__] = ACTIONS(2755),
    [anon_sym_typedef] = ACTIONS(2755),
    [anon_sym_virtual] = ACTIONS(2755),
    [anon_sym_extern] = ACTIONS(2755),
    [anon_sym___attribute__] = ACTIONS(2755),
    [anon_sym___attribute] = ACTIONS(2755),
    [anon_sym_COLON_COLON] = ACTIONS(2757),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2757),
    [anon_sym___declspec] = ACTIONS(2755),
    [anon_sym___based] = ACTIONS(2755),
    [anon_sym___cdecl] = ACTIONS(2755),
    [anon_sym___clrcall] = ACTIONS(2755),
    [anon_sym___stdcall] = ACTIONS(2755),
    [anon_sym___fastcall] = ACTIONS(2755),
    [anon_sym___thiscall] = ACTIONS(2755),
    [anon_sym___vectorcall] = ACTIONS(2755),
    [anon_sym_LBRACE] = ACTIONS(2757),
    [anon_sym_signed] = ACTIONS(2755),
    [anon_sym_unsigned] = ACTIONS(2755),
    [anon_sym_long] = ACTIONS(2755),
    [anon_sym_short] = ACTIONS(2755),
    [anon_sym_LBRACK] = ACTIONS(2755),
    [anon_sym_static] = ACTIONS(2755),
    [anon_sym_register] = ACTIONS(2755),
    [anon_sym_inline] = ACTIONS(2755),
    [anon_sym___inline] = ACTIONS(2755),
    [anon_sym___inline__] = ACTIONS(2755),
    [anon_sym___forceinline] = ACTIONS(2755),
    [anon_sym_thread_local] = ACTIONS(2755),
    [anon_sym___thread] = ACTIONS(2755),
    [anon_sym_const] = ACTIONS(2755),
    [anon_sym_constexpr] = ACTIONS(2755),
    [anon_sym_volatile] = ACTIONS(2755),
    [anon_sym_restrict] = ACTIONS(2755),
    [anon_sym___restrict__] = ACTIONS(2755),
    [anon_sym__Atomic] = ACTIONS(2755),
    [anon_sym__Noreturn] = ACTIONS(2755),
    [anon_sym_noreturn] = ACTIONS(2755),
    [anon_sym__Nonnull] = ACTIONS(2755),
    [anon_sym_mutable] = ACTIONS(2755),
    [anon_sym_constinit] = ACTIONS(2755),
    [anon_sym_consteval] = ACTIONS(2755),
    [anon_sym_alignas] = ACTIONS(2755),
    [anon_sym__Alignas] = ACTIONS(2755),
    [sym_primitive_type] = ACTIONS(2755),
    [anon_sym_enum] = ACTIONS(2755),
    [anon_sym_class] = ACTIONS(2755),
    [anon_sym_struct] = ACTIONS(2755),
    [anon_sym_union] = ACTIONS(2755),
    [anon_sym_if] = ACTIONS(2755),
    [anon_sym_switch] = ACTIONS(2755),
    [anon_sym_case] = ACTIONS(2755),
    [anon_sym_default] = ACTIONS(2755),
    [anon_sym_while] = ACTIONS(2755),
    [anon_sym_do] = ACTIONS(2755),
    [anon_sym_for] = ACTIONS(2755),
    [anon_sym_return] = ACTIONS(2755),
    [anon_sym_break] = ACTIONS(2755),
    [anon_sym_continue] = ACTIONS(2755),
    [anon_sym_goto] = ACTIONS(2755),
    [anon_sym___try] = ACTIONS(2755),
    [anon_sym___leave] = ACTIONS(2755),
    [anon_sym_not] = ACTIONS(2755),
    [anon_sym_compl] = ACTIONS(2755),
    [anon_sym_DASH_DASH] = ACTIONS(2757),
    [anon_sym_PLUS_PLUS] = ACTIONS(2757),
    [anon_sym_sizeof] = ACTIONS(2755),
    [anon_sym___alignof__] = ACTIONS(2755),
    [anon_sym___alignof] = ACTIONS(2755),
    [anon_sym__alignof] = ACTIONS(2755),
    [anon_sym_alignof] = ACTIONS(2755),
    [anon_sym__Alignof] = ACTIONS(2755),
    [anon_sym_offsetof] = ACTIONS(2755),
    [anon_sym__Generic] = ACTIONS(2755),
    [anon_sym_asm] = ACTIONS(2755),
    [anon_sym___asm__] = ACTIONS(2755),
    [anon_sym___asm] = ACTIONS(2755),
    [sym_number_literal] = ACTIONS(2757),
    [anon_sym_L_SQUOTE] = ACTIONS(2757),
    [anon_sym_u_SQUOTE] = ACTIONS(2757),
    [anon_sym_U_SQUOTE] = ACTIONS(2757),
    [anon_sym_u8_SQUOTE] = ACTIONS(2757),
    [anon_sym_SQUOTE] = ACTIONS(2757),
    [anon_sym_L_DQUOTE] = ACTIONS(2757),
    [anon_sym_u_DQUOTE] = ACTIONS(2757),
    [anon_sym_U_DQUOTE] = ACTIONS(2757),
    [anon_sym_u8_DQUOTE] = ACTIONS(2757),
    [anon_sym_DQUOTE] = ACTIONS(2757),
    [sym_true] = ACTIONS(2755),
    [sym_false] = ACTIONS(2755),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2755),
    [anon_sym_decltype] = ACTIONS(2755),
    [anon_sym_explicit] = ACTIONS(2755),
    [anon_sym_typename] = ACTIONS(2755),
    [anon_sym_template] = ACTIONS(2755),
    [anon_sym_operator] = ACTIONS(2755),
    [anon_sym_try] = ACTIONS(2755),
    [anon_sym_delete] = ACTIONS(2755),
    [anon_sym_throw] = ACTIONS(2755),
    [anon_sym_namespace] = ACTIONS(2755),
    [anon_sym_using] = ACTIONS(2755),
    [anon_sym_static_assert] = ACTIONS(2755),
    [anon_sym_concept] = ACTIONS(2755),
    [anon_sym_co_return] = ACTIONS(2755),
    [anon_sym_co_yield] = ACTIONS(2755),
    [anon_sym_R_DQUOTE] = ACTIONS(2757),
    [anon_sym_LR_DQUOTE] = ACTIONS(2757),
    [anon_sym_uR_DQUOTE] = ACTIONS(2757),
    [anon_sym_UR_DQUOTE] = ACTIONS(2757),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2757),
    [anon_sym_co_await] = ACTIONS(2755),
    [anon_sym_new] = ACTIONS(2755),
    [anon_sym_requires] = ACTIONS(2755),
    [sym_this] = ACTIONS(2755),
  },
  [280] = {
    [sym_identifier] = ACTIONS(2759),
    [aux_sym_preproc_include_token1] = ACTIONS(2759),
    [aux_sym_preproc_def_token1] = ACTIONS(2759),
    [aux_sym_preproc_if_token1] = ACTIONS(2759),
    [aux_sym_preproc_if_token2] = ACTIONS(2759),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2759),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2759),
    [aux_sym_preproc_else_token1] = ACTIONS(2759),
    [aux_sym_preproc_elif_token1] = ACTIONS(2759),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2759),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2759),
    [sym_preproc_directive] = ACTIONS(2759),
    [anon_sym_LPAREN2] = ACTIONS(2761),
    [anon_sym_BANG] = ACTIONS(2761),
    [anon_sym_TILDE] = ACTIONS(2761),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_STAR] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2759),
    [anon_sym_SEMI] = ACTIONS(2761),
    [anon_sym___extension__] = ACTIONS(2759),
    [anon_sym_typedef] = ACTIONS(2759),
    [anon_sym_virtual] = ACTIONS(2759),
    [anon_sym_extern] = ACTIONS(2759),
    [anon_sym___attribute__] = ACTIONS(2759),
    [anon_sym___attribute] = ACTIONS(2759),
    [anon_sym_COLON_COLON] = ACTIONS(2761),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2761),
    [anon_sym___declspec] = ACTIONS(2759),
    [anon_sym___based] = ACTIONS(2759),
    [anon_sym___cdecl] = ACTIONS(2759),
    [anon_sym___clrcall] = ACTIONS(2759),
    [anon_sym___stdcall] = ACTIONS(2759),
    [anon_sym___fastcall] = ACTIONS(2759),
    [anon_sym___thiscall] = ACTIONS(2759),
    [anon_sym___vectorcall] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_signed] = ACTIONS(2759),
    [anon_sym_unsigned] = ACTIONS(2759),
    [anon_sym_long] = ACTIONS(2759),
    [anon_sym_short] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_static] = ACTIONS(2759),
    [anon_sym_register] = ACTIONS(2759),
    [anon_sym_inline] = ACTIONS(2759),
    [anon_sym___inline] = ACTIONS(2759),
    [anon_sym___inline__] = ACTIONS(2759),
    [anon_sym___forceinline] = ACTIONS(2759),
    [anon_sym_thread_local] = ACTIONS(2759),
    [anon_sym___thread] = ACTIONS(2759),
    [anon_sym_const] = ACTIONS(2759),
    [anon_sym_constexpr] = ACTIONS(2759),
    [anon_sym_volatile] = ACTIONS(2759),
    [anon_sym_restrict] = ACTIONS(2759),
    [anon_sym___restrict__] = ACTIONS(2759),
    [anon_sym__Atomic] = ACTIONS(2759),
    [anon_sym__Noreturn] = ACTIONS(2759),
    [anon_sym_noreturn] = ACTIONS(2759),
    [anon_sym__Nonnull] = ACTIONS(2759),
    [anon_sym_mutable] = ACTIONS(2759),
    [anon_sym_constinit] = ACTIONS(2759),
    [anon_sym_consteval] = ACTIONS(2759),
    [anon_sym_alignas] = ACTIONS(2759),
    [anon_sym__Alignas] = ACTIONS(2759),
    [sym_primitive_type] = ACTIONS(2759),
    [anon_sym_enum] = ACTIONS(2759),
    [anon_sym_class] = ACTIONS(2759),
    [anon_sym_struct] = ACTIONS(2759),
    [anon_sym_union] = ACTIONS(2759),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_switch] = ACTIONS(2759),
    [anon_sym_case] = ACTIONS(2759),
    [anon_sym_default] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_for] = ACTIONS(2759),
    [anon_sym_return] = ACTIONS(2759),
    [anon_sym_break] = ACTIONS(2759),
    [anon_sym_continue] = ACTIONS(2759),
    [anon_sym_goto] = ACTIONS(2759),
    [anon_sym___try] = ACTIONS(2759),
    [anon_sym___leave] = ACTIONS(2759),
    [anon_sym_not] = ACTIONS(2759),
    [anon_sym_compl] = ACTIONS(2759),
    [anon_sym_DASH_DASH] = ACTIONS(2761),
    [anon_sym_PLUS_PLUS] = ACTIONS(2761),
    [anon_sym_sizeof] = ACTIONS(2759),
    [anon_sym___alignof__] = ACTIONS(2759),
    [anon_sym___alignof] = ACTIONS(2759),
    [anon_sym__alignof] = ACTIONS(2759),
    [anon_sym_alignof] = ACTIONS(2759),
    [anon_sym__Alignof] = ACTIONS(2759),
    [anon_sym_offsetof] = ACTIONS(2759),
    [anon_sym__Generic] = ACTIONS(2759),
    [anon_sym_asm] = ACTIONS(2759),
    [anon_sym___asm__] = ACTIONS(2759),
    [anon_sym___asm] = ACTIONS(2759),
    [sym_number_literal] = ACTIONS(2761),
    [anon_sym_L_SQUOTE] = ACTIONS(2761),
    [anon_sym_u_SQUOTE] = ACTIONS(2761),
    [anon_sym_U_SQUOTE] = ACTIONS(2761),
    [anon_sym_u8_SQUOTE] = ACTIONS(2761),
    [anon_sym_SQUOTE] = ACTIONS(2761),
    [anon_sym_L_DQUOTE] = ACTIONS(2761),
    [anon_sym_u_DQUOTE] = ACTIONS(2761),
    [anon_sym_U_DQUOTE] = ACTIONS(2761),
    [anon_sym_u8_DQUOTE] = ACTIONS(2761),
    [anon_sym_DQUOTE] = ACTIONS(2761),
    [sym_true] = ACTIONS(2759),
    [sym_false] = ACTIONS(2759),
    [anon_sym_NULL] = ACTIONS(2759),
    [anon_sym_nullptr] = ACTIONS(2759),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2759),
    [anon_sym_decltype] = ACTIONS(2759),
    [anon_sym_explicit] = ACTIONS(2759),
    [anon_sym_typename] = ACTIONS(2759),
    [anon_sym_template] = ACTIONS(2759),
    [anon_sym_operator] = ACTIONS(2759),
    [anon_sym_try] = ACTIONS(2759),
    [anon_sym_delete] = ACTIONS(2759),
    [anon_sym_throw] = ACTIONS(2759),
    [anon_sym_namespace] = ACTIONS(2759),
    [anon_sym_using] = ACTIONS(2759),
    [anon_sym_static_assert] = ACTIONS(2759),
    [anon_sym_concept] = ACTIONS(2759),
    [anon_sym_co_return] = ACTIONS(2759),
    [anon_sym_co_yield] = ACTIONS(2759),
    [anon_sym_R_DQUOTE] = ACTIONS(2761),
    [anon_sym_LR_DQUOTE] = ACTIONS(2761),
    [anon_sym_uR_DQUOTE] = ACTIONS(2761),
    [anon_sym_UR_DQUOTE] = ACTIONS(2761),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2761),
    [anon_sym_co_await] = ACTIONS(2759),
    [anon_sym_new] = ACTIONS(2759),
    [anon_sym_requires] = ACTIONS(2759),
    [sym_this] = ACTIONS(2759),
  },
  [281] = {
    [sym_identifier] = ACTIONS(2763),
    [aux_sym_preproc_include_token1] = ACTIONS(2763),
    [aux_sym_preproc_def_token1] = ACTIONS(2763),
    [aux_sym_preproc_if_token1] = ACTIONS(2763),
    [aux_sym_preproc_if_token2] = ACTIONS(2763),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2763),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2763),
    [aux_sym_preproc_else_token1] = ACTIONS(2763),
    [aux_sym_preproc_elif_token1] = ACTIONS(2763),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2763),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2763),
    [sym_preproc_directive] = ACTIONS(2763),
    [anon_sym_LPAREN2] = ACTIONS(2765),
    [anon_sym_BANG] = ACTIONS(2765),
    [anon_sym_TILDE] = ACTIONS(2765),
    [anon_sym_DASH] = ACTIONS(2763),
    [anon_sym_PLUS] = ACTIONS(2763),
    [anon_sym_STAR] = ACTIONS(2765),
    [anon_sym_AMP_AMP] = ACTIONS(2765),
    [anon_sym_AMP] = ACTIONS(2763),
    [anon_sym_SEMI] = ACTIONS(2765),
    [anon_sym___extension__] = ACTIONS(2763),
    [anon_sym_typedef] = ACTIONS(2763),
    [anon_sym_virtual] = ACTIONS(2763),
    [anon_sym_extern] = ACTIONS(2763),
    [anon_sym___attribute__] = ACTIONS(2763),
    [anon_sym___attribute] = ACTIONS(2763),
    [anon_sym_COLON_COLON] = ACTIONS(2765),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2765),
    [anon_sym___declspec] = ACTIONS(2763),
    [anon_sym___based] = ACTIONS(2763),
    [anon_sym___cdecl] = ACTIONS(2763),
    [anon_sym___clrcall] = ACTIONS(2763),
    [anon_sym___stdcall] = ACTIONS(2763),
    [anon_sym___fastcall] = ACTIONS(2763),
    [anon_sym___thiscall] = ACTIONS(2763),
    [anon_sym___vectorcall] = ACTIONS(2763),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_signed] = ACTIONS(2763),
    [anon_sym_unsigned] = ACTIONS(2763),
    [anon_sym_long] = ACTIONS(2763),
    [anon_sym_short] = ACTIONS(2763),
    [anon_sym_LBRACK] = ACTIONS(2763),
    [anon_sym_static] = ACTIONS(2763),
    [anon_sym_register] = ACTIONS(2763),
    [anon_sym_inline] = ACTIONS(2763),
    [anon_sym___inline] = ACTIONS(2763),
    [anon_sym___inline__] = ACTIONS(2763),
    [anon_sym___forceinline] = ACTIONS(2763),
    [anon_sym_thread_local] = ACTIONS(2763),
    [anon_sym___thread] = ACTIONS(2763),
    [anon_sym_const] = ACTIONS(2763),
    [anon_sym_constexpr] = ACTIONS(2763),
    [anon_sym_volatile] = ACTIONS(2763),
    [anon_sym_restrict] = ACTIONS(2763),
    [anon_sym___restrict__] = ACTIONS(2763),
    [anon_sym__Atomic] = ACTIONS(2763),
    [anon_sym__Noreturn] = ACTIONS(2763),
    [anon_sym_noreturn] = ACTIONS(2763),
    [anon_sym__Nonnull] = ACTIONS(2763),
    [anon_sym_mutable] = ACTIONS(2763),
    [anon_sym_constinit] = ACTIONS(2763),
    [anon_sym_consteval] = ACTIONS(2763),
    [anon_sym_alignas] = ACTIONS(2763),
    [anon_sym__Alignas] = ACTIONS(2763),
    [sym_primitive_type] = ACTIONS(2763),
    [anon_sym_enum] = ACTIONS(2763),
    [anon_sym_class] = ACTIONS(2763),
    [anon_sym_struct] = ACTIONS(2763),
    [anon_sym_union] = ACTIONS(2763),
    [anon_sym_if] = ACTIONS(2763),
    [anon_sym_switch] = ACTIONS(2763),
    [anon_sym_case] = ACTIONS(2763),
    [anon_sym_default] = ACTIONS(2763),
    [anon_sym_while] = ACTIONS(2763),
    [anon_sym_do] = ACTIONS(2763),
    [anon_sym_for] = ACTIONS(2763),
    [anon_sym_return] = ACTIONS(2763),
    [anon_sym_break] = ACTIONS(2763),
    [anon_sym_continue] = ACTIONS(2763),
    [anon_sym_goto] = ACTIONS(2763),
    [anon_sym___try] = ACTIONS(2763),
    [anon_sym___leave] = ACTIONS(2763),
    [anon_sym_not] = ACTIONS(2763),
    [anon_sym_compl] = ACTIONS(2763),
    [anon_sym_DASH_DASH] = ACTIONS(2765),
    [anon_sym_PLUS_PLUS] = ACTIONS(2765),
    [anon_sym_sizeof] = ACTIONS(2763),
    [anon_sym___alignof__] = ACTIONS(2763),
    [anon_sym___alignof] = ACTIONS(2763),
    [anon_sym__alignof] = ACTIONS(2763),
    [anon_sym_alignof] = ACTIONS(2763),
    [anon_sym__Alignof] = ACTIONS(2763),
    [anon_sym_offsetof] = ACTIONS(2763),
    [anon_sym__Generic] = ACTIONS(2763),
    [anon_sym_asm] = ACTIONS(2763),
    [anon_sym___asm__] = ACTIONS(2763),
    [anon_sym___asm] = ACTIONS(2763),
    [sym_number_literal] = ACTIONS(2765),
    [anon_sym_L_SQUOTE] = ACTIONS(2765),
    [anon_sym_u_SQUOTE] = ACTIONS(2765),
    [anon_sym_U_SQUOTE] = ACTIONS(2765),
    [anon_sym_u8_SQUOTE] = ACTIONS(2765),
    [anon_sym_SQUOTE] = ACTIONS(2765),
    [anon_sym_L_DQUOTE] = ACTIONS(2765),
    [anon_sym_u_DQUOTE] = ACTIONS(2765),
    [anon_sym_U_DQUOTE] = ACTIONS(2765),
    [anon_sym_u8_DQUOTE] = ACTIONS(2765),
    [anon_sym_DQUOTE] = ACTIONS(2765),
    [sym_true] = ACTIONS(2763),
    [sym_false] = ACTIONS(2763),
    [anon_sym_NULL] = ACTIONS(2763),
    [anon_sym_nullptr] = ACTIONS(2763),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2763),
    [anon_sym_decltype] = ACTIONS(2763),
    [anon_sym_explicit] = ACTIONS(2763),
    [anon_sym_typename] = ACTIONS(2763),
    [anon_sym_template] = ACTIONS(2763),
    [anon_sym_operator] = ACTIONS(2763),
    [anon_sym_try] = ACTIONS(2763),
    [anon_sym_delete] = ACTIONS(2763),
    [anon_sym_throw] = ACTIONS(2763),
    [anon_sym_namespace] = ACTIONS(2763),
    [anon_sym_using] = ACTIONS(2763),
    [anon_sym_static_assert] = ACTIONS(2763),
    [anon_sym_concept] = ACTIONS(2763),
    [anon_sym_co_return] = ACTIONS(2763),
    [anon_sym_co_yield] = ACTIONS(2763),
    [anon_sym_R_DQUOTE] = ACTIONS(2765),
    [anon_sym_LR_DQUOTE] = ACTIONS(2765),
    [anon_sym_uR_DQUOTE] = ACTIONS(2765),
    [anon_sym_UR_DQUOTE] = ACTIONS(2765),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2765),
    [anon_sym_co_await] = ACTIONS(2763),
    [anon_sym_new] = ACTIONS(2763),
    [anon_sym_requires] = ACTIONS(2763),
    [sym_this] = ACTIONS(2763),
  },
  [282] = {
    [sym_identifier] = ACTIONS(2767),
    [aux_sym_preproc_include_token1] = ACTIONS(2767),
    [aux_sym_preproc_def_token1] = ACTIONS(2767),
    [aux_sym_preproc_if_token1] = ACTIONS(2767),
    [aux_sym_preproc_if_token2] = ACTIONS(2767),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2767),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2767),
    [aux_sym_preproc_else_token1] = ACTIONS(2767),
    [aux_sym_preproc_elif_token1] = ACTIONS(2767),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2767),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2767),
    [sym_preproc_directive] = ACTIONS(2767),
    [anon_sym_LPAREN2] = ACTIONS(2769),
    [anon_sym_BANG] = ACTIONS(2769),
    [anon_sym_TILDE] = ACTIONS(2769),
    [anon_sym_DASH] = ACTIONS(2767),
    [anon_sym_PLUS] = ACTIONS(2767),
    [anon_sym_STAR] = ACTIONS(2769),
    [anon_sym_AMP_AMP] = ACTIONS(2769),
    [anon_sym_AMP] = ACTIONS(2767),
    [anon_sym_SEMI] = ACTIONS(2769),
    [anon_sym___extension__] = ACTIONS(2767),
    [anon_sym_typedef] = ACTIONS(2767),
    [anon_sym_virtual] = ACTIONS(2767),
    [anon_sym_extern] = ACTIONS(2767),
    [anon_sym___attribute__] = ACTIONS(2767),
    [anon_sym___attribute] = ACTIONS(2767),
    [anon_sym_COLON_COLON] = ACTIONS(2769),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2769),
    [anon_sym___declspec] = ACTIONS(2767),
    [anon_sym___based] = ACTIONS(2767),
    [anon_sym___cdecl] = ACTIONS(2767),
    [anon_sym___clrcall] = ACTIONS(2767),
    [anon_sym___stdcall] = ACTIONS(2767),
    [anon_sym___fastcall] = ACTIONS(2767),
    [anon_sym___thiscall] = ACTIONS(2767),
    [anon_sym___vectorcall] = ACTIONS(2767),
    [anon_sym_LBRACE] = ACTIONS(2769),
    [anon_sym_signed] = ACTIONS(2767),
    [anon_sym_unsigned] = ACTIONS(2767),
    [anon_sym_long] = ACTIONS(2767),
    [anon_sym_short] = ACTIONS(2767),
    [anon_sym_LBRACK] = ACTIONS(2767),
    [anon_sym_static] = ACTIONS(2767),
    [anon_sym_register] = ACTIONS(2767),
    [anon_sym_inline] = ACTIONS(2767),
    [anon_sym___inline] = ACTIONS(2767),
    [anon_sym___inline__] = ACTIONS(2767),
    [anon_sym___forceinline] = ACTIONS(2767),
    [anon_sym_thread_local] = ACTIONS(2767),
    [anon_sym___thread] = ACTIONS(2767),
    [anon_sym_const] = ACTIONS(2767),
    [anon_sym_constexpr] = ACTIONS(2767),
    [anon_sym_volatile] = ACTIONS(2767),
    [anon_sym_restrict] = ACTIONS(2767),
    [anon_sym___restrict__] = ACTIONS(2767),
    [anon_sym__Atomic] = ACTIONS(2767),
    [anon_sym__Noreturn] = ACTIONS(2767),
    [anon_sym_noreturn] = ACTIONS(2767),
    [anon_sym__Nonnull] = ACTIONS(2767),
    [anon_sym_mutable] = ACTIONS(2767),
    [anon_sym_constinit] = ACTIONS(2767),
    [anon_sym_consteval] = ACTIONS(2767),
    [anon_sym_alignas] = ACTIONS(2767),
    [anon_sym__Alignas] = ACTIONS(2767),
    [sym_primitive_type] = ACTIONS(2767),
    [anon_sym_enum] = ACTIONS(2767),
    [anon_sym_class] = ACTIONS(2767),
    [anon_sym_struct] = ACTIONS(2767),
    [anon_sym_union] = ACTIONS(2767),
    [anon_sym_if] = ACTIONS(2767),
    [anon_sym_switch] = ACTIONS(2767),
    [anon_sym_case] = ACTIONS(2767),
    [anon_sym_default] = ACTIONS(2767),
    [anon_sym_while] = ACTIONS(2767),
    [anon_sym_do] = ACTIONS(2767),
    [anon_sym_for] = ACTIONS(2767),
    [anon_sym_return] = ACTIONS(2767),
    [anon_sym_break] = ACTIONS(2767),
    [anon_sym_continue] = ACTIONS(2767),
    [anon_sym_goto] = ACTIONS(2767),
    [anon_sym___try] = ACTIONS(2767),
    [anon_sym___leave] = ACTIONS(2767),
    [anon_sym_not] = ACTIONS(2767),
    [anon_sym_compl] = ACTIONS(2767),
    [anon_sym_DASH_DASH] = ACTIONS(2769),
    [anon_sym_PLUS_PLUS] = ACTIONS(2769),
    [anon_sym_sizeof] = ACTIONS(2767),
    [anon_sym___alignof__] = ACTIONS(2767),
    [anon_sym___alignof] = ACTIONS(2767),
    [anon_sym__alignof] = ACTIONS(2767),
    [anon_sym_alignof] = ACTIONS(2767),
    [anon_sym__Alignof] = ACTIONS(2767),
    [anon_sym_offsetof] = ACTIONS(2767),
    [anon_sym__Generic] = ACTIONS(2767),
    [anon_sym_asm] = ACTIONS(2767),
    [anon_sym___asm__] = ACTIONS(2767),
    [anon_sym___asm] = ACTIONS(2767),
    [sym_number_literal] = ACTIONS(2769),
    [anon_sym_L_SQUOTE] = ACTIONS(2769),
    [anon_sym_u_SQUOTE] = ACTIONS(2769),
    [anon_sym_U_SQUOTE] = ACTIONS(2769),
    [anon_sym_u8_SQUOTE] = ACTIONS(2769),
    [anon_sym_SQUOTE] = ACTIONS(2769),
    [anon_sym_L_DQUOTE] = ACTIONS(2769),
    [anon_sym_u_DQUOTE] = ACTIONS(2769),
    [anon_sym_U_DQUOTE] = ACTIONS(2769),
    [anon_sym_u8_DQUOTE] = ACTIONS(2769),
    [anon_sym_DQUOTE] = ACTIONS(2769),
    [sym_true] = ACTIONS(2767),
    [sym_false] = ACTIONS(2767),
    [anon_sym_NULL] = ACTIONS(2767),
    [anon_sym_nullptr] = ACTIONS(2767),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2767),
    [anon_sym_decltype] = ACTIONS(2767),
    [anon_sym_explicit] = ACTIONS(2767),
    [anon_sym_typename] = ACTIONS(2767),
    [anon_sym_template] = ACTIONS(2767),
    [anon_sym_operator] = ACTIONS(2767),
    [anon_sym_try] = ACTIONS(2767),
    [anon_sym_delete] = ACTIONS(2767),
    [anon_sym_throw] = ACTIONS(2767),
    [anon_sym_namespace] = ACTIONS(2767),
    [anon_sym_using] = ACTIONS(2767),
    [anon_sym_static_assert] = ACTIONS(2767),
    [anon_sym_concept] = ACTIONS(2767),
    [anon_sym_co_return] = ACTIONS(2767),
    [anon_sym_co_yield] = ACTIONS(2767),
    [anon_sym_R_DQUOTE] = ACTIONS(2769),
    [anon_sym_LR_DQUOTE] = ACTIONS(2769),
    [anon_sym_uR_DQUOTE] = ACTIONS(2769),
    [anon_sym_UR_DQUOTE] = ACTIONS(2769),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2769),
    [anon_sym_co_await] = ACTIONS(2767),
    [anon_sym_new] = ACTIONS(2767),
    [anon_sym_requires] = ACTIONS(2767),
    [sym_this] = ACTIONS(2767),
  },
  [283] = {
    [sym_identifier] = ACTIONS(2771),
    [aux_sym_preproc_include_token1] = ACTIONS(2771),
    [aux_sym_preproc_def_token1] = ACTIONS(2771),
    [aux_sym_preproc_if_token1] = ACTIONS(2771),
    [aux_sym_preproc_if_token2] = ACTIONS(2771),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2771),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2771),
    [aux_sym_preproc_else_token1] = ACTIONS(2771),
    [aux_sym_preproc_elif_token1] = ACTIONS(2771),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2771),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2771),
    [sym_preproc_directive] = ACTIONS(2771),
    [anon_sym_LPAREN2] = ACTIONS(2773),
    [anon_sym_BANG] = ACTIONS(2773),
    [anon_sym_TILDE] = ACTIONS(2773),
    [anon_sym_DASH] = ACTIONS(2771),
    [anon_sym_PLUS] = ACTIONS(2771),
    [anon_sym_STAR] = ACTIONS(2773),
    [anon_sym_AMP_AMP] = ACTIONS(2773),
    [anon_sym_AMP] = ACTIONS(2771),
    [anon_sym_SEMI] = ACTIONS(2773),
    [anon_sym___extension__] = ACTIONS(2771),
    [anon_sym_typedef] = ACTIONS(2771),
    [anon_sym_virtual] = ACTIONS(2771),
    [anon_sym_extern] = ACTIONS(2771),
    [anon_sym___attribute__] = ACTIONS(2771),
    [anon_sym___attribute] = ACTIONS(2771),
    [anon_sym_COLON_COLON] = ACTIONS(2773),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2773),
    [anon_sym___declspec] = ACTIONS(2771),
    [anon_sym___based] = ACTIONS(2771),
    [anon_sym___cdecl] = ACTIONS(2771),
    [anon_sym___clrcall] = ACTIONS(2771),
    [anon_sym___stdcall] = ACTIONS(2771),
    [anon_sym___fastcall] = ACTIONS(2771),
    [anon_sym___thiscall] = ACTIONS(2771),
    [anon_sym___vectorcall] = ACTIONS(2771),
    [anon_sym_LBRACE] = ACTIONS(2773),
    [anon_sym_signed] = ACTIONS(2771),
    [anon_sym_unsigned] = ACTIONS(2771),
    [anon_sym_long] = ACTIONS(2771),
    [anon_sym_short] = ACTIONS(2771),
    [anon_sym_LBRACK] = ACTIONS(2771),
    [anon_sym_static] = ACTIONS(2771),
    [anon_sym_register] = ACTIONS(2771),
    [anon_sym_inline] = ACTIONS(2771),
    [anon_sym___inline] = ACTIONS(2771),
    [anon_sym___inline__] = ACTIONS(2771),
    [anon_sym___forceinline] = ACTIONS(2771),
    [anon_sym_thread_local] = ACTIONS(2771),
    [anon_sym___thread] = ACTIONS(2771),
    [anon_sym_const] = ACTIONS(2771),
    [anon_sym_constexpr] = ACTIONS(2771),
    [anon_sym_volatile] = ACTIONS(2771),
    [anon_sym_restrict] = ACTIONS(2771),
    [anon_sym___restrict__] = ACTIONS(2771),
    [anon_sym__Atomic] = ACTIONS(2771),
    [anon_sym__Noreturn] = ACTIONS(2771),
    [anon_sym_noreturn] = ACTIONS(2771),
    [anon_sym__Nonnull] = ACTIONS(2771),
    [anon_sym_mutable] = ACTIONS(2771),
    [anon_sym_constinit] = ACTIONS(2771),
    [anon_sym_consteval] = ACTIONS(2771),
    [anon_sym_alignas] = ACTIONS(2771),
    [anon_sym__Alignas] = ACTIONS(2771),
    [sym_primitive_type] = ACTIONS(2771),
    [anon_sym_enum] = ACTIONS(2771),
    [anon_sym_class] = ACTIONS(2771),
    [anon_sym_struct] = ACTIONS(2771),
    [anon_sym_union] = ACTIONS(2771),
    [anon_sym_if] = ACTIONS(2771),
    [anon_sym_switch] = ACTIONS(2771),
    [anon_sym_case] = ACTIONS(2771),
    [anon_sym_default] = ACTIONS(2771),
    [anon_sym_while] = ACTIONS(2771),
    [anon_sym_do] = ACTIONS(2771),
    [anon_sym_for] = ACTIONS(2771),
    [anon_sym_return] = ACTIONS(2771),
    [anon_sym_break] = ACTIONS(2771),
    [anon_sym_continue] = ACTIONS(2771),
    [anon_sym_goto] = ACTIONS(2771),
    [anon_sym___try] = ACTIONS(2771),
    [anon_sym___leave] = ACTIONS(2771),
    [anon_sym_not] = ACTIONS(2771),
    [anon_sym_compl] = ACTIONS(2771),
    [anon_sym_DASH_DASH] = ACTIONS(2773),
    [anon_sym_PLUS_PLUS] = ACTIONS(2773),
    [anon_sym_sizeof] = ACTIONS(2771),
    [anon_sym___alignof__] = ACTIONS(2771),
    [anon_sym___alignof] = ACTIONS(2771),
    [anon_sym__alignof] = ACTIONS(2771),
    [anon_sym_alignof] = ACTIONS(2771),
    [anon_sym__Alignof] = ACTIONS(2771),
    [anon_sym_offsetof] = ACTIONS(2771),
    [anon_sym__Generic] = ACTIONS(2771),
    [anon_sym_asm] = ACTIONS(2771),
    [anon_sym___asm__] = ACTIONS(2771),
    [anon_sym___asm] = ACTIONS(2771),
    [sym_number_literal] = ACTIONS(2773),
    [anon_sym_L_SQUOTE] = ACTIONS(2773),
    [anon_sym_u_SQUOTE] = ACTIONS(2773),
    [anon_sym_U_SQUOTE] = ACTIONS(2773),
    [anon_sym_u8_SQUOTE] = ACTIONS(2773),
    [anon_sym_SQUOTE] = ACTIONS(2773),
    [anon_sym_L_DQUOTE] = ACTIONS(2773),
    [anon_sym_u_DQUOTE] = ACTIONS(2773),
    [anon_sym_U_DQUOTE] = ACTIONS(2773),
    [anon_sym_u8_DQUOTE] = ACTIONS(2773),
    [anon_sym_DQUOTE] = ACTIONS(2773),
    [sym_true] = ACTIONS(2771),
    [sym_false] = ACTIONS(2771),
    [anon_sym_NULL] = ACTIONS(2771),
    [anon_sym_nullptr] = ACTIONS(2771),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2771),
    [anon_sym_decltype] = ACTIONS(2771),
    [anon_sym_explicit] = ACTIONS(2771),
    [anon_sym_typename] = ACTIONS(2771),
    [anon_sym_template] = ACTIONS(2771),
    [anon_sym_operator] = ACTIONS(2771),
    [anon_sym_try] = ACTIONS(2771),
    [anon_sym_delete] = ACTIONS(2771),
    [anon_sym_throw] = ACTIONS(2771),
    [anon_sym_namespace] = ACTIONS(2771),
    [anon_sym_using] = ACTIONS(2771),
    [anon_sym_static_assert] = ACTIONS(2771),
    [anon_sym_concept] = ACTIONS(2771),
    [anon_sym_co_return] = ACTIONS(2771),
    [anon_sym_co_yield] = ACTIONS(2771),
    [anon_sym_R_DQUOTE] = ACTIONS(2773),
    [anon_sym_LR_DQUOTE] = ACTIONS(2773),
    [anon_sym_uR_DQUOTE] = ACTIONS(2773),
    [anon_sym_UR_DQUOTE] = ACTIONS(2773),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2773),
    [anon_sym_co_await] = ACTIONS(2771),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2771),
    [sym_this] = ACTIONS(2771),
  },
  [284] = {
    [sym_expression] = STATE(4401),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(7984),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(2775),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(2778),
    [anon_sym___extension__] = ACTIONS(2780),
    [anon_sym_virtual] = ACTIONS(2783),
    [anon_sym_extern] = ACTIONS(2783),
    [anon_sym___attribute__] = ACTIONS(2783),
    [anon_sym___attribute] = ACTIONS(2783),
    [anon_sym_COLON_COLON] = ACTIONS(2785),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2788),
    [anon_sym___declspec] = ACTIONS(2783),
    [anon_sym_signed] = ACTIONS(2783),
    [anon_sym_unsigned] = ACTIONS(2783),
    [anon_sym_long] = ACTIONS(2783),
    [anon_sym_short] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(2783),
    [anon_sym_register] = ACTIONS(2783),
    [anon_sym_inline] = ACTIONS(2783),
    [anon_sym___inline] = ACTIONS(2783),
    [anon_sym___inline__] = ACTIONS(2783),
    [anon_sym___forceinline] = ACTIONS(2783),
    [anon_sym_thread_local] = ACTIONS(2783),
    [anon_sym___thread] = ACTIONS(2783),
    [anon_sym_const] = ACTIONS(2783),
    [anon_sym_constexpr] = ACTIONS(2783),
    [anon_sym_volatile] = ACTIONS(2783),
    [anon_sym_restrict] = ACTIONS(2783),
    [anon_sym___restrict__] = ACTIONS(2783),
    [anon_sym__Atomic] = ACTIONS(2783),
    [anon_sym__Noreturn] = ACTIONS(2783),
    [anon_sym_noreturn] = ACTIONS(2783),
    [anon_sym__Nonnull] = ACTIONS(2783),
    [anon_sym_mutable] = ACTIONS(2783),
    [anon_sym_constinit] = ACTIONS(2783),
    [anon_sym_consteval] = ACTIONS(2783),
    [anon_sym_alignas] = ACTIONS(2783),
    [anon_sym__Alignas] = ACTIONS(2783),
    [sym_primitive_type] = ACTIONS(2790),
    [anon_sym_enum] = ACTIONS(2783),
    [anon_sym_class] = ACTIONS(2783),
    [anon_sym_struct] = ACTIONS(2783),
    [anon_sym_union] = ACTIONS(2783),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2783),
    [anon_sym_decltype] = ACTIONS(2793),
    [anon_sym_typename] = ACTIONS(2783),
    [anon_sym_template] = ACTIONS(2796),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [285] = {
    [sym_identifier] = ACTIONS(2799),
    [aux_sym_preproc_include_token1] = ACTIONS(2799),
    [aux_sym_preproc_def_token1] = ACTIONS(2799),
    [aux_sym_preproc_if_token1] = ACTIONS(2799),
    [aux_sym_preproc_if_token2] = ACTIONS(2799),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2799),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2799),
    [aux_sym_preproc_else_token1] = ACTIONS(2799),
    [aux_sym_preproc_elif_token1] = ACTIONS(2799),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2799),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2799),
    [sym_preproc_directive] = ACTIONS(2799),
    [anon_sym_LPAREN2] = ACTIONS(2801),
    [anon_sym_BANG] = ACTIONS(2801),
    [anon_sym_TILDE] = ACTIONS(2801),
    [anon_sym_DASH] = ACTIONS(2799),
    [anon_sym_PLUS] = ACTIONS(2799),
    [anon_sym_STAR] = ACTIONS(2801),
    [anon_sym_AMP_AMP] = ACTIONS(2801),
    [anon_sym_AMP] = ACTIONS(2799),
    [anon_sym_SEMI] = ACTIONS(2801),
    [anon_sym___extension__] = ACTIONS(2799),
    [anon_sym_typedef] = ACTIONS(2799),
    [anon_sym_virtual] = ACTIONS(2799),
    [anon_sym_extern] = ACTIONS(2799),
    [anon_sym___attribute__] = ACTIONS(2799),
    [anon_sym___attribute] = ACTIONS(2799),
    [anon_sym_COLON_COLON] = ACTIONS(2801),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2801),
    [anon_sym___declspec] = ACTIONS(2799),
    [anon_sym___based] = ACTIONS(2799),
    [anon_sym___cdecl] = ACTIONS(2799),
    [anon_sym___clrcall] = ACTIONS(2799),
    [anon_sym___stdcall] = ACTIONS(2799),
    [anon_sym___fastcall] = ACTIONS(2799),
    [anon_sym___thiscall] = ACTIONS(2799),
    [anon_sym___vectorcall] = ACTIONS(2799),
    [anon_sym_LBRACE] = ACTIONS(2801),
    [anon_sym_signed] = ACTIONS(2799),
    [anon_sym_unsigned] = ACTIONS(2799),
    [anon_sym_long] = ACTIONS(2799),
    [anon_sym_short] = ACTIONS(2799),
    [anon_sym_LBRACK] = ACTIONS(2799),
    [anon_sym_static] = ACTIONS(2799),
    [anon_sym_register] = ACTIONS(2799),
    [anon_sym_inline] = ACTIONS(2799),
    [anon_sym___inline] = ACTIONS(2799),
    [anon_sym___inline__] = ACTIONS(2799),
    [anon_sym___forceinline] = ACTIONS(2799),
    [anon_sym_thread_local] = ACTIONS(2799),
    [anon_sym___thread] = ACTIONS(2799),
    [anon_sym_const] = ACTIONS(2799),
    [anon_sym_constexpr] = ACTIONS(2799),
    [anon_sym_volatile] = ACTIONS(2799),
    [anon_sym_restrict] = ACTIONS(2799),
    [anon_sym___restrict__] = ACTIONS(2799),
    [anon_sym__Atomic] = ACTIONS(2799),
    [anon_sym__Noreturn] = ACTIONS(2799),
    [anon_sym_noreturn] = ACTIONS(2799),
    [anon_sym__Nonnull] = ACTIONS(2799),
    [anon_sym_mutable] = ACTIONS(2799),
    [anon_sym_constinit] = ACTIONS(2799),
    [anon_sym_consteval] = ACTIONS(2799),
    [anon_sym_alignas] = ACTIONS(2799),
    [anon_sym__Alignas] = ACTIONS(2799),
    [sym_primitive_type] = ACTIONS(2799),
    [anon_sym_enum] = ACTIONS(2799),
    [anon_sym_class] = ACTIONS(2799),
    [anon_sym_struct] = ACTIONS(2799),
    [anon_sym_union] = ACTIONS(2799),
    [anon_sym_if] = ACTIONS(2799),
    [anon_sym_switch] = ACTIONS(2799),
    [anon_sym_case] = ACTIONS(2799),
    [anon_sym_default] = ACTIONS(2799),
    [anon_sym_while] = ACTIONS(2799),
    [anon_sym_do] = ACTIONS(2799),
    [anon_sym_for] = ACTIONS(2799),
    [anon_sym_return] = ACTIONS(2799),
    [anon_sym_break] = ACTIONS(2799),
    [anon_sym_continue] = ACTIONS(2799),
    [anon_sym_goto] = ACTIONS(2799),
    [anon_sym___try] = ACTIONS(2799),
    [anon_sym___leave] = ACTIONS(2799),
    [anon_sym_not] = ACTIONS(2799),
    [anon_sym_compl] = ACTIONS(2799),
    [anon_sym_DASH_DASH] = ACTIONS(2801),
    [anon_sym_PLUS_PLUS] = ACTIONS(2801),
    [anon_sym_sizeof] = ACTIONS(2799),
    [anon_sym___alignof__] = ACTIONS(2799),
    [anon_sym___alignof] = ACTIONS(2799),
    [anon_sym__alignof] = ACTIONS(2799),
    [anon_sym_alignof] = ACTIONS(2799),
    [anon_sym__Alignof] = ACTIONS(2799),
    [anon_sym_offsetof] = ACTIONS(2799),
    [anon_sym__Generic] = ACTIONS(2799),
    [anon_sym_asm] = ACTIONS(2799),
    [anon_sym___asm__] = ACTIONS(2799),
    [anon_sym___asm] = ACTIONS(2799),
    [sym_number_literal] = ACTIONS(2801),
    [anon_sym_L_SQUOTE] = ACTIONS(2801),
    [anon_sym_u_SQUOTE] = ACTIONS(2801),
    [anon_sym_U_SQUOTE] = ACTIONS(2801),
    [anon_sym_u8_SQUOTE] = ACTIONS(2801),
    [anon_sym_SQUOTE] = ACTIONS(2801),
    [anon_sym_L_DQUOTE] = ACTIONS(2801),
    [anon_sym_u_DQUOTE] = ACTIONS(2801),
    [anon_sym_U_DQUOTE] = ACTIONS(2801),
    [anon_sym_u8_DQUOTE] = ACTIONS(2801),
    [anon_sym_DQUOTE] = ACTIONS(2801),
    [sym_true] = ACTIONS(2799),
    [sym_false] = ACTIONS(2799),
    [anon_sym_NULL] = ACTIONS(2799),
    [anon_sym_nullptr] = ACTIONS(2799),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2799),
    [anon_sym_decltype] = ACTIONS(2799),
    [anon_sym_explicit] = ACTIONS(2799),
    [anon_sym_typename] = ACTIONS(2799),
    [anon_sym_template] = ACTIONS(2799),
    [anon_sym_operator] = ACTIONS(2799),
    [anon_sym_try] = ACTIONS(2799),
    [anon_sym_delete] = ACTIONS(2799),
    [anon_sym_throw] = ACTIONS(2799),
    [anon_sym_namespace] = ACTIONS(2799),
    [anon_sym_using] = ACTIONS(2799),
    [anon_sym_static_assert] = ACTIONS(2799),
    [anon_sym_concept] = ACTIONS(2799),
    [anon_sym_co_return] = ACTIONS(2799),
    [anon_sym_co_yield] = ACTIONS(2799),
    [anon_sym_R_DQUOTE] = ACTIONS(2801),
    [anon_sym_LR_DQUOTE] = ACTIONS(2801),
    [anon_sym_uR_DQUOTE] = ACTIONS(2801),
    [anon_sym_UR_DQUOTE] = ACTIONS(2801),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2801),
    [anon_sym_co_await] = ACTIONS(2799),
    [anon_sym_new] = ACTIONS(2799),
    [anon_sym_requires] = ACTIONS(2799),
    [sym_this] = ACTIONS(2799),
  },
  [286] = {
    [sym_catch_clause] = STATE(291),
    [aux_sym_constructor_try_statement_repeat1] = STATE(291),
    [sym_identifier] = ACTIONS(2490),
    [aux_sym_preproc_include_token1] = ACTIONS(2490),
    [aux_sym_preproc_def_token1] = ACTIONS(2490),
    [aux_sym_preproc_if_token1] = ACTIONS(2490),
    [aux_sym_preproc_if_token2] = ACTIONS(2490),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2490),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2490),
    [sym_preproc_directive] = ACTIONS(2490),
    [anon_sym_LPAREN2] = ACTIONS(2492),
    [anon_sym_BANG] = ACTIONS(2492),
    [anon_sym_TILDE] = ACTIONS(2492),
    [anon_sym_DASH] = ACTIONS(2490),
    [anon_sym_PLUS] = ACTIONS(2490),
    [anon_sym_STAR] = ACTIONS(2492),
    [anon_sym_AMP_AMP] = ACTIONS(2492),
    [anon_sym_AMP] = ACTIONS(2490),
    [anon_sym_SEMI] = ACTIONS(2492),
    [anon_sym___extension__] = ACTIONS(2490),
    [anon_sym_typedef] = ACTIONS(2490),
    [anon_sym_virtual] = ACTIONS(2490),
    [anon_sym_extern] = ACTIONS(2490),
    [anon_sym___attribute__] = ACTIONS(2490),
    [anon_sym___attribute] = ACTIONS(2490),
    [anon_sym_COLON_COLON] = ACTIONS(2492),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2492),
    [anon_sym___declspec] = ACTIONS(2490),
    [anon_sym___based] = ACTIONS(2490),
    [anon_sym___cdecl] = ACTIONS(2490),
    [anon_sym___clrcall] = ACTIONS(2490),
    [anon_sym___stdcall] = ACTIONS(2490),
    [anon_sym___fastcall] = ACTIONS(2490),
    [anon_sym___thiscall] = ACTIONS(2490),
    [anon_sym___vectorcall] = ACTIONS(2490),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_signed] = ACTIONS(2490),
    [anon_sym_unsigned] = ACTIONS(2490),
    [anon_sym_long] = ACTIONS(2490),
    [anon_sym_short] = ACTIONS(2490),
    [anon_sym_LBRACK] = ACTIONS(2490),
    [anon_sym_static] = ACTIONS(2490),
    [anon_sym_register] = ACTIONS(2490),
    [anon_sym_inline] = ACTIONS(2490),
    [anon_sym___inline] = ACTIONS(2490),
    [anon_sym___inline__] = ACTIONS(2490),
    [anon_sym___forceinline] = ACTIONS(2490),
    [anon_sym_thread_local] = ACTIONS(2490),
    [anon_sym___thread] = ACTIONS(2490),
    [anon_sym_const] = ACTIONS(2490),
    [anon_sym_constexpr] = ACTIONS(2490),
    [anon_sym_volatile] = ACTIONS(2490),
    [anon_sym_restrict] = ACTIONS(2490),
    [anon_sym___restrict__] = ACTIONS(2490),
    [anon_sym__Atomic] = ACTIONS(2490),
    [anon_sym__Noreturn] = ACTIONS(2490),
    [anon_sym_noreturn] = ACTIONS(2490),
    [anon_sym__Nonnull] = ACTIONS(2490),
    [anon_sym_mutable] = ACTIONS(2490),
    [anon_sym_constinit] = ACTIONS(2490),
    [anon_sym_consteval] = ACTIONS(2490),
    [anon_sym_alignas] = ACTIONS(2490),
    [anon_sym__Alignas] = ACTIONS(2490),
    [sym_primitive_type] = ACTIONS(2490),
    [anon_sym_enum] = ACTIONS(2490),
    [anon_sym_class] = ACTIONS(2490),
    [anon_sym_struct] = ACTIONS(2490),
    [anon_sym_union] = ACTIONS(2490),
    [anon_sym_if] = ACTIONS(2490),
    [anon_sym_else] = ACTIONS(2490),
    [anon_sym_switch] = ACTIONS(2490),
    [anon_sym_case] = ACTIONS(2490),
    [anon_sym_default] = ACTIONS(2490),
    [anon_sym_while] = ACTIONS(2490),
    [anon_sym_do] = ACTIONS(2490),
    [anon_sym_for] = ACTIONS(2490),
    [anon_sym_return] = ACTIONS(2490),
    [anon_sym_break] = ACTIONS(2490),
    [anon_sym_continue] = ACTIONS(2490),
    [anon_sym_goto] = ACTIONS(2490),
    [anon_sym___try] = ACTIONS(2490),
    [anon_sym___leave] = ACTIONS(2490),
    [anon_sym_not] = ACTIONS(2490),
    [anon_sym_compl] = ACTIONS(2490),
    [anon_sym_DASH_DASH] = ACTIONS(2492),
    [anon_sym_PLUS_PLUS] = ACTIONS(2492),
    [anon_sym_sizeof] = ACTIONS(2490),
    [anon_sym___alignof__] = ACTIONS(2490),
    [anon_sym___alignof] = ACTIONS(2490),
    [anon_sym__alignof] = ACTIONS(2490),
    [anon_sym_alignof] = ACTIONS(2490),
    [anon_sym__Alignof] = ACTIONS(2490),
    [anon_sym_offsetof] = ACTIONS(2490),
    [anon_sym__Generic] = ACTIONS(2490),
    [anon_sym_asm] = ACTIONS(2490),
    [anon_sym___asm__] = ACTIONS(2490),
    [anon_sym___asm] = ACTIONS(2490),
    [sym_number_literal] = ACTIONS(2492),
    [anon_sym_L_SQUOTE] = ACTIONS(2492),
    [anon_sym_u_SQUOTE] = ACTIONS(2492),
    [anon_sym_U_SQUOTE] = ACTIONS(2492),
    [anon_sym_u8_SQUOTE] = ACTIONS(2492),
    [anon_sym_SQUOTE] = ACTIONS(2492),
    [anon_sym_L_DQUOTE] = ACTIONS(2492),
    [anon_sym_u_DQUOTE] = ACTIONS(2492),
    [anon_sym_U_DQUOTE] = ACTIONS(2492),
    [anon_sym_u8_DQUOTE] = ACTIONS(2492),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [sym_true] = ACTIONS(2490),
    [sym_false] = ACTIONS(2490),
    [anon_sym_NULL] = ACTIONS(2490),
    [anon_sym_nullptr] = ACTIONS(2490),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2490),
    [anon_sym_decltype] = ACTIONS(2490),
    [anon_sym_explicit] = ACTIONS(2490),
    [anon_sym_typename] = ACTIONS(2490),
    [anon_sym_template] = ACTIONS(2490),
    [anon_sym_operator] = ACTIONS(2490),
    [anon_sym_try] = ACTIONS(2490),
    [anon_sym_delete] = ACTIONS(2490),
    [anon_sym_throw] = ACTIONS(2490),
    [anon_sym_namespace] = ACTIONS(2490),
    [anon_sym_using] = ACTIONS(2490),
    [anon_sym_static_assert] = ACTIONS(2490),
    [anon_sym_concept] = ACTIONS(2490),
    [anon_sym_co_return] = ACTIONS(2490),
    [anon_sym_co_yield] = ACTIONS(2490),
    [anon_sym_catch] = ACTIONS(2803),
    [anon_sym_R_DQUOTE] = ACTIONS(2492),
    [anon_sym_LR_DQUOTE] = ACTIONS(2492),
    [anon_sym_uR_DQUOTE] = ACTIONS(2492),
    [anon_sym_UR_DQUOTE] = ACTIONS(2492),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2492),
    [anon_sym_co_await] = ACTIONS(2490),
    [anon_sym_new] = ACTIONS(2490),
    [anon_sym_requires] = ACTIONS(2490),
    [sym_this] = ACTIONS(2490),
  },
  [287] = {
    [sym_identifier] = ACTIONS(2799),
    [aux_sym_preproc_include_token1] = ACTIONS(2799),
    [aux_sym_preproc_def_token1] = ACTIONS(2799),
    [aux_sym_preproc_if_token1] = ACTIONS(2799),
    [aux_sym_preproc_if_token2] = ACTIONS(2799),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2799),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2799),
    [aux_sym_preproc_else_token1] = ACTIONS(2799),
    [aux_sym_preproc_elif_token1] = ACTIONS(2799),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2799),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2799),
    [sym_preproc_directive] = ACTIONS(2799),
    [anon_sym_LPAREN2] = ACTIONS(2801),
    [anon_sym_BANG] = ACTIONS(2801),
    [anon_sym_TILDE] = ACTIONS(2801),
    [anon_sym_DASH] = ACTIONS(2799),
    [anon_sym_PLUS] = ACTIONS(2799),
    [anon_sym_STAR] = ACTIONS(2801),
    [anon_sym_AMP_AMP] = ACTIONS(2801),
    [anon_sym_AMP] = ACTIONS(2799),
    [anon_sym_SEMI] = ACTIONS(2801),
    [anon_sym___extension__] = ACTIONS(2799),
    [anon_sym_typedef] = ACTIONS(2799),
    [anon_sym_virtual] = ACTIONS(2799),
    [anon_sym_extern] = ACTIONS(2799),
    [anon_sym___attribute__] = ACTIONS(2799),
    [anon_sym___attribute] = ACTIONS(2799),
    [anon_sym_COLON_COLON] = ACTIONS(2801),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2801),
    [anon_sym___declspec] = ACTIONS(2799),
    [anon_sym___based] = ACTIONS(2799),
    [anon_sym___cdecl] = ACTIONS(2799),
    [anon_sym___clrcall] = ACTIONS(2799),
    [anon_sym___stdcall] = ACTIONS(2799),
    [anon_sym___fastcall] = ACTIONS(2799),
    [anon_sym___thiscall] = ACTIONS(2799),
    [anon_sym___vectorcall] = ACTIONS(2799),
    [anon_sym_LBRACE] = ACTIONS(2801),
    [anon_sym_signed] = ACTIONS(2799),
    [anon_sym_unsigned] = ACTIONS(2799),
    [anon_sym_long] = ACTIONS(2799),
    [anon_sym_short] = ACTIONS(2799),
    [anon_sym_LBRACK] = ACTIONS(2799),
    [anon_sym_static] = ACTIONS(2799),
    [anon_sym_register] = ACTIONS(2799),
    [anon_sym_inline] = ACTIONS(2799),
    [anon_sym___inline] = ACTIONS(2799),
    [anon_sym___inline__] = ACTIONS(2799),
    [anon_sym___forceinline] = ACTIONS(2799),
    [anon_sym_thread_local] = ACTIONS(2799),
    [anon_sym___thread] = ACTIONS(2799),
    [anon_sym_const] = ACTIONS(2799),
    [anon_sym_constexpr] = ACTIONS(2799),
    [anon_sym_volatile] = ACTIONS(2799),
    [anon_sym_restrict] = ACTIONS(2799),
    [anon_sym___restrict__] = ACTIONS(2799),
    [anon_sym__Atomic] = ACTIONS(2799),
    [anon_sym__Noreturn] = ACTIONS(2799),
    [anon_sym_noreturn] = ACTIONS(2799),
    [anon_sym__Nonnull] = ACTIONS(2799),
    [anon_sym_mutable] = ACTIONS(2799),
    [anon_sym_constinit] = ACTIONS(2799),
    [anon_sym_consteval] = ACTIONS(2799),
    [anon_sym_alignas] = ACTIONS(2799),
    [anon_sym__Alignas] = ACTIONS(2799),
    [sym_primitive_type] = ACTIONS(2799),
    [anon_sym_enum] = ACTIONS(2799),
    [anon_sym_class] = ACTIONS(2799),
    [anon_sym_struct] = ACTIONS(2799),
    [anon_sym_union] = ACTIONS(2799),
    [anon_sym_if] = ACTIONS(2799),
    [anon_sym_switch] = ACTIONS(2799),
    [anon_sym_case] = ACTIONS(2799),
    [anon_sym_default] = ACTIONS(2799),
    [anon_sym_while] = ACTIONS(2799),
    [anon_sym_do] = ACTIONS(2799),
    [anon_sym_for] = ACTIONS(2799),
    [anon_sym_return] = ACTIONS(2799),
    [anon_sym_break] = ACTIONS(2799),
    [anon_sym_continue] = ACTIONS(2799),
    [anon_sym_goto] = ACTIONS(2799),
    [anon_sym___try] = ACTIONS(2799),
    [anon_sym___leave] = ACTIONS(2799),
    [anon_sym_not] = ACTIONS(2799),
    [anon_sym_compl] = ACTIONS(2799),
    [anon_sym_DASH_DASH] = ACTIONS(2801),
    [anon_sym_PLUS_PLUS] = ACTIONS(2801),
    [anon_sym_sizeof] = ACTIONS(2799),
    [anon_sym___alignof__] = ACTIONS(2799),
    [anon_sym___alignof] = ACTIONS(2799),
    [anon_sym__alignof] = ACTIONS(2799),
    [anon_sym_alignof] = ACTIONS(2799),
    [anon_sym__Alignof] = ACTIONS(2799),
    [anon_sym_offsetof] = ACTIONS(2799),
    [anon_sym__Generic] = ACTIONS(2799),
    [anon_sym_asm] = ACTIONS(2799),
    [anon_sym___asm__] = ACTIONS(2799),
    [anon_sym___asm] = ACTIONS(2799),
    [sym_number_literal] = ACTIONS(2801),
    [anon_sym_L_SQUOTE] = ACTIONS(2801),
    [anon_sym_u_SQUOTE] = ACTIONS(2801),
    [anon_sym_U_SQUOTE] = ACTIONS(2801),
    [anon_sym_u8_SQUOTE] = ACTIONS(2801),
    [anon_sym_SQUOTE] = ACTIONS(2801),
    [anon_sym_L_DQUOTE] = ACTIONS(2801),
    [anon_sym_u_DQUOTE] = ACTIONS(2801),
    [anon_sym_U_DQUOTE] = ACTIONS(2801),
    [anon_sym_u8_DQUOTE] = ACTIONS(2801),
    [anon_sym_DQUOTE] = ACTIONS(2801),
    [sym_true] = ACTIONS(2799),
    [sym_false] = ACTIONS(2799),
    [anon_sym_NULL] = ACTIONS(2799),
    [anon_sym_nullptr] = ACTIONS(2799),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2799),
    [anon_sym_decltype] = ACTIONS(2799),
    [anon_sym_explicit] = ACTIONS(2799),
    [anon_sym_typename] = ACTIONS(2799),
    [anon_sym_template] = ACTIONS(2799),
    [anon_sym_operator] = ACTIONS(2799),
    [anon_sym_try] = ACTIONS(2799),
    [anon_sym_delete] = ACTIONS(2799),
    [anon_sym_throw] = ACTIONS(2799),
    [anon_sym_namespace] = ACTIONS(2799),
    [anon_sym_using] = ACTIONS(2799),
    [anon_sym_static_assert] = ACTIONS(2799),
    [anon_sym_concept] = ACTIONS(2799),
    [anon_sym_co_return] = ACTIONS(2799),
    [anon_sym_co_yield] = ACTIONS(2799),
    [anon_sym_R_DQUOTE] = ACTIONS(2801),
    [anon_sym_LR_DQUOTE] = ACTIONS(2801),
    [anon_sym_uR_DQUOTE] = ACTIONS(2801),
    [anon_sym_UR_DQUOTE] = ACTIONS(2801),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2801),
    [anon_sym_co_await] = ACTIONS(2799),
    [anon_sym_new] = ACTIONS(2799),
    [anon_sym_requires] = ACTIONS(2799),
    [sym_this] = ACTIONS(2799),
  },
  [288] = {
    [sym_identifier] = ACTIONS(2805),
    [aux_sym_preproc_include_token1] = ACTIONS(2805),
    [aux_sym_preproc_def_token1] = ACTIONS(2805),
    [aux_sym_preproc_if_token1] = ACTIONS(2805),
    [aux_sym_preproc_if_token2] = ACTIONS(2805),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2805),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2805),
    [aux_sym_preproc_else_token1] = ACTIONS(2805),
    [aux_sym_preproc_elif_token1] = ACTIONS(2805),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2805),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2805),
    [sym_preproc_directive] = ACTIONS(2805),
    [anon_sym_LPAREN2] = ACTIONS(2807),
    [anon_sym_BANG] = ACTIONS(2807),
    [anon_sym_TILDE] = ACTIONS(2807),
    [anon_sym_DASH] = ACTIONS(2805),
    [anon_sym_PLUS] = ACTIONS(2805),
    [anon_sym_STAR] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2805),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym___extension__] = ACTIONS(2805),
    [anon_sym_typedef] = ACTIONS(2805),
    [anon_sym_virtual] = ACTIONS(2805),
    [anon_sym_extern] = ACTIONS(2805),
    [anon_sym___attribute__] = ACTIONS(2805),
    [anon_sym___attribute] = ACTIONS(2805),
    [anon_sym_COLON_COLON] = ACTIONS(2807),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2807),
    [anon_sym___declspec] = ACTIONS(2805),
    [anon_sym___based] = ACTIONS(2805),
    [anon_sym___cdecl] = ACTIONS(2805),
    [anon_sym___clrcall] = ACTIONS(2805),
    [anon_sym___stdcall] = ACTIONS(2805),
    [anon_sym___fastcall] = ACTIONS(2805),
    [anon_sym___thiscall] = ACTIONS(2805),
    [anon_sym___vectorcall] = ACTIONS(2805),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_signed] = ACTIONS(2805),
    [anon_sym_unsigned] = ACTIONS(2805),
    [anon_sym_long] = ACTIONS(2805),
    [anon_sym_short] = ACTIONS(2805),
    [anon_sym_LBRACK] = ACTIONS(2805),
    [anon_sym_static] = ACTIONS(2805),
    [anon_sym_register] = ACTIONS(2805),
    [anon_sym_inline] = ACTIONS(2805),
    [anon_sym___inline] = ACTIONS(2805),
    [anon_sym___inline__] = ACTIONS(2805),
    [anon_sym___forceinline] = ACTIONS(2805),
    [anon_sym_thread_local] = ACTIONS(2805),
    [anon_sym___thread] = ACTIONS(2805),
    [anon_sym_const] = ACTIONS(2805),
    [anon_sym_constexpr] = ACTIONS(2805),
    [anon_sym_volatile] = ACTIONS(2805),
    [anon_sym_restrict] = ACTIONS(2805),
    [anon_sym___restrict__] = ACTIONS(2805),
    [anon_sym__Atomic] = ACTIONS(2805),
    [anon_sym__Noreturn] = ACTIONS(2805),
    [anon_sym_noreturn] = ACTIONS(2805),
    [anon_sym__Nonnull] = ACTIONS(2805),
    [anon_sym_mutable] = ACTIONS(2805),
    [anon_sym_constinit] = ACTIONS(2805),
    [anon_sym_consteval] = ACTIONS(2805),
    [anon_sym_alignas] = ACTIONS(2805),
    [anon_sym__Alignas] = ACTIONS(2805),
    [sym_primitive_type] = ACTIONS(2805),
    [anon_sym_enum] = ACTIONS(2805),
    [anon_sym_class] = ACTIONS(2805),
    [anon_sym_struct] = ACTIONS(2805),
    [anon_sym_union] = ACTIONS(2805),
    [anon_sym_if] = ACTIONS(2805),
    [anon_sym_switch] = ACTIONS(2805),
    [anon_sym_case] = ACTIONS(2805),
    [anon_sym_default] = ACTIONS(2805),
    [anon_sym_while] = ACTIONS(2805),
    [anon_sym_do] = ACTIONS(2805),
    [anon_sym_for] = ACTIONS(2805),
    [anon_sym_return] = ACTIONS(2805),
    [anon_sym_break] = ACTIONS(2805),
    [anon_sym_continue] = ACTIONS(2805),
    [anon_sym_goto] = ACTIONS(2805),
    [anon_sym___try] = ACTIONS(2805),
    [anon_sym___leave] = ACTIONS(2805),
    [anon_sym_not] = ACTIONS(2805),
    [anon_sym_compl] = ACTIONS(2805),
    [anon_sym_DASH_DASH] = ACTIONS(2807),
    [anon_sym_PLUS_PLUS] = ACTIONS(2807),
    [anon_sym_sizeof] = ACTIONS(2805),
    [anon_sym___alignof__] = ACTIONS(2805),
    [anon_sym___alignof] = ACTIONS(2805),
    [anon_sym__alignof] = ACTIONS(2805),
    [anon_sym_alignof] = ACTIONS(2805),
    [anon_sym__Alignof] = ACTIONS(2805),
    [anon_sym_offsetof] = ACTIONS(2805),
    [anon_sym__Generic] = ACTIONS(2805),
    [anon_sym_asm] = ACTIONS(2805),
    [anon_sym___asm__] = ACTIONS(2805),
    [anon_sym___asm] = ACTIONS(2805),
    [sym_number_literal] = ACTIONS(2807),
    [anon_sym_L_SQUOTE] = ACTIONS(2807),
    [anon_sym_u_SQUOTE] = ACTIONS(2807),
    [anon_sym_U_SQUOTE] = ACTIONS(2807),
    [anon_sym_u8_SQUOTE] = ACTIONS(2807),
    [anon_sym_SQUOTE] = ACTIONS(2807),
    [anon_sym_L_DQUOTE] = ACTIONS(2807),
    [anon_sym_u_DQUOTE] = ACTIONS(2807),
    [anon_sym_U_DQUOTE] = ACTIONS(2807),
    [anon_sym_u8_DQUOTE] = ACTIONS(2807),
    [anon_sym_DQUOTE] = ACTIONS(2807),
    [sym_true] = ACTIONS(2805),
    [sym_false] = ACTIONS(2805),
    [anon_sym_NULL] = ACTIONS(2805),
    [anon_sym_nullptr] = ACTIONS(2805),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2805),
    [anon_sym_decltype] = ACTIONS(2805),
    [anon_sym_explicit] = ACTIONS(2805),
    [anon_sym_typename] = ACTIONS(2805),
    [anon_sym_template] = ACTIONS(2805),
    [anon_sym_operator] = ACTIONS(2805),
    [anon_sym_try] = ACTIONS(2805),
    [anon_sym_delete] = ACTIONS(2805),
    [anon_sym_throw] = ACTIONS(2805),
    [anon_sym_namespace] = ACTIONS(2805),
    [anon_sym_using] = ACTIONS(2805),
    [anon_sym_static_assert] = ACTIONS(2805),
    [anon_sym_concept] = ACTIONS(2805),
    [anon_sym_co_return] = ACTIONS(2805),
    [anon_sym_co_yield] = ACTIONS(2805),
    [anon_sym_R_DQUOTE] = ACTIONS(2807),
    [anon_sym_LR_DQUOTE] = ACTIONS(2807),
    [anon_sym_uR_DQUOTE] = ACTIONS(2807),
    [anon_sym_UR_DQUOTE] = ACTIONS(2807),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2807),
    [anon_sym_co_await] = ACTIONS(2805),
    [anon_sym_new] = ACTIONS(2805),
    [anon_sym_requires] = ACTIONS(2805),
    [sym_this] = ACTIONS(2805),
  },
  [289] = {
    [sym_identifier] = ACTIONS(2809),
    [aux_sym_preproc_include_token1] = ACTIONS(2809),
    [aux_sym_preproc_def_token1] = ACTIONS(2809),
    [aux_sym_preproc_if_token1] = ACTIONS(2809),
    [aux_sym_preproc_if_token2] = ACTIONS(2809),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2809),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2809),
    [aux_sym_preproc_else_token1] = ACTIONS(2809),
    [aux_sym_preproc_elif_token1] = ACTIONS(2809),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2809),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2809),
    [sym_preproc_directive] = ACTIONS(2809),
    [anon_sym_LPAREN2] = ACTIONS(2811),
    [anon_sym_BANG] = ACTIONS(2811),
    [anon_sym_TILDE] = ACTIONS(2811),
    [anon_sym_DASH] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_STAR] = ACTIONS(2811),
    [anon_sym_AMP_AMP] = ACTIONS(2811),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2811),
    [anon_sym___extension__] = ACTIONS(2809),
    [anon_sym_typedef] = ACTIONS(2809),
    [anon_sym_virtual] = ACTIONS(2809),
    [anon_sym_extern] = ACTIONS(2809),
    [anon_sym___attribute__] = ACTIONS(2809),
    [anon_sym___attribute] = ACTIONS(2809),
    [anon_sym_COLON_COLON] = ACTIONS(2811),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2811),
    [anon_sym___declspec] = ACTIONS(2809),
    [anon_sym___based] = ACTIONS(2809),
    [anon_sym___cdecl] = ACTIONS(2809),
    [anon_sym___clrcall] = ACTIONS(2809),
    [anon_sym___stdcall] = ACTIONS(2809),
    [anon_sym___fastcall] = ACTIONS(2809),
    [anon_sym___thiscall] = ACTIONS(2809),
    [anon_sym___vectorcall] = ACTIONS(2809),
    [anon_sym_LBRACE] = ACTIONS(2811),
    [anon_sym_signed] = ACTIONS(2809),
    [anon_sym_unsigned] = ACTIONS(2809),
    [anon_sym_long] = ACTIONS(2809),
    [anon_sym_short] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2809),
    [anon_sym_static] = ACTIONS(2809),
    [anon_sym_register] = ACTIONS(2809),
    [anon_sym_inline] = ACTIONS(2809),
    [anon_sym___inline] = ACTIONS(2809),
    [anon_sym___inline__] = ACTIONS(2809),
    [anon_sym___forceinline] = ACTIONS(2809),
    [anon_sym_thread_local] = ACTIONS(2809),
    [anon_sym___thread] = ACTIONS(2809),
    [anon_sym_const] = ACTIONS(2809),
    [anon_sym_constexpr] = ACTIONS(2809),
    [anon_sym_volatile] = ACTIONS(2809),
    [anon_sym_restrict] = ACTIONS(2809),
    [anon_sym___restrict__] = ACTIONS(2809),
    [anon_sym__Atomic] = ACTIONS(2809),
    [anon_sym__Noreturn] = ACTIONS(2809),
    [anon_sym_noreturn] = ACTIONS(2809),
    [anon_sym__Nonnull] = ACTIONS(2809),
    [anon_sym_mutable] = ACTIONS(2809),
    [anon_sym_constinit] = ACTIONS(2809),
    [anon_sym_consteval] = ACTIONS(2809),
    [anon_sym_alignas] = ACTIONS(2809),
    [anon_sym__Alignas] = ACTIONS(2809),
    [sym_primitive_type] = ACTIONS(2809),
    [anon_sym_enum] = ACTIONS(2809),
    [anon_sym_class] = ACTIONS(2809),
    [anon_sym_struct] = ACTIONS(2809),
    [anon_sym_union] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(2809),
    [anon_sym_switch] = ACTIONS(2809),
    [anon_sym_case] = ACTIONS(2809),
    [anon_sym_default] = ACTIONS(2809),
    [anon_sym_while] = ACTIONS(2809),
    [anon_sym_do] = ACTIONS(2809),
    [anon_sym_for] = ACTIONS(2809),
    [anon_sym_return] = ACTIONS(2809),
    [anon_sym_break] = ACTIONS(2809),
    [anon_sym_continue] = ACTIONS(2809),
    [anon_sym_goto] = ACTIONS(2809),
    [anon_sym___try] = ACTIONS(2809),
    [anon_sym___leave] = ACTIONS(2809),
    [anon_sym_not] = ACTIONS(2809),
    [anon_sym_compl] = ACTIONS(2809),
    [anon_sym_DASH_DASH] = ACTIONS(2811),
    [anon_sym_PLUS_PLUS] = ACTIONS(2811),
    [anon_sym_sizeof] = ACTIONS(2809),
    [anon_sym___alignof__] = ACTIONS(2809),
    [anon_sym___alignof] = ACTIONS(2809),
    [anon_sym__alignof] = ACTIONS(2809),
    [anon_sym_alignof] = ACTIONS(2809),
    [anon_sym__Alignof] = ACTIONS(2809),
    [anon_sym_offsetof] = ACTIONS(2809),
    [anon_sym__Generic] = ACTIONS(2809),
    [anon_sym_asm] = ACTIONS(2809),
    [anon_sym___asm__] = ACTIONS(2809),
    [anon_sym___asm] = ACTIONS(2809),
    [sym_number_literal] = ACTIONS(2811),
    [anon_sym_L_SQUOTE] = ACTIONS(2811),
    [anon_sym_u_SQUOTE] = ACTIONS(2811),
    [anon_sym_U_SQUOTE] = ACTIONS(2811),
    [anon_sym_u8_SQUOTE] = ACTIONS(2811),
    [anon_sym_SQUOTE] = ACTIONS(2811),
    [anon_sym_L_DQUOTE] = ACTIONS(2811),
    [anon_sym_u_DQUOTE] = ACTIONS(2811),
    [anon_sym_U_DQUOTE] = ACTIONS(2811),
    [anon_sym_u8_DQUOTE] = ACTIONS(2811),
    [anon_sym_DQUOTE] = ACTIONS(2811),
    [sym_true] = ACTIONS(2809),
    [sym_false] = ACTIONS(2809),
    [anon_sym_NULL] = ACTIONS(2809),
    [anon_sym_nullptr] = ACTIONS(2809),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2809),
    [anon_sym_decltype] = ACTIONS(2809),
    [anon_sym_explicit] = ACTIONS(2809),
    [anon_sym_typename] = ACTIONS(2809),
    [anon_sym_template] = ACTIONS(2809),
    [anon_sym_operator] = ACTIONS(2809),
    [anon_sym_try] = ACTIONS(2809),
    [anon_sym_delete] = ACTIONS(2809),
    [anon_sym_throw] = ACTIONS(2809),
    [anon_sym_namespace] = ACTIONS(2809),
    [anon_sym_using] = ACTIONS(2809),
    [anon_sym_static_assert] = ACTIONS(2809),
    [anon_sym_concept] = ACTIONS(2809),
    [anon_sym_co_return] = ACTIONS(2809),
    [anon_sym_co_yield] = ACTIONS(2809),
    [anon_sym_R_DQUOTE] = ACTIONS(2811),
    [anon_sym_LR_DQUOTE] = ACTIONS(2811),
    [anon_sym_uR_DQUOTE] = ACTIONS(2811),
    [anon_sym_UR_DQUOTE] = ACTIONS(2811),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2811),
    [anon_sym_co_await] = ACTIONS(2809),
    [anon_sym_new] = ACTIONS(2809),
    [anon_sym_requires] = ACTIONS(2809),
    [sym_this] = ACTIONS(2809),
  },
  [290] = {
    [sym_catch_clause] = STATE(319),
    [aux_sym_constructor_try_statement_repeat1] = STATE(319),
    [ts_builtin_sym_end] = ACTIONS(2492),
    [sym_identifier] = ACTIONS(2490),
    [aux_sym_preproc_include_token1] = ACTIONS(2490),
    [aux_sym_preproc_def_token1] = ACTIONS(2490),
    [aux_sym_preproc_if_token1] = ACTIONS(2490),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2490),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2490),
    [sym_preproc_directive] = ACTIONS(2490),
    [anon_sym_LPAREN2] = ACTIONS(2492),
    [anon_sym_BANG] = ACTIONS(2492),
    [anon_sym_TILDE] = ACTIONS(2492),
    [anon_sym_DASH] = ACTIONS(2490),
    [anon_sym_PLUS] = ACTIONS(2490),
    [anon_sym_STAR] = ACTIONS(2492),
    [anon_sym_AMP_AMP] = ACTIONS(2492),
    [anon_sym_AMP] = ACTIONS(2490),
    [anon_sym_SEMI] = ACTIONS(2492),
    [anon_sym___extension__] = ACTIONS(2490),
    [anon_sym_typedef] = ACTIONS(2490),
    [anon_sym_virtual] = ACTIONS(2490),
    [anon_sym_extern] = ACTIONS(2490),
    [anon_sym___attribute__] = ACTIONS(2490),
    [anon_sym___attribute] = ACTIONS(2490),
    [anon_sym_COLON_COLON] = ACTIONS(2492),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2492),
    [anon_sym___declspec] = ACTIONS(2490),
    [anon_sym___based] = ACTIONS(2490),
    [anon_sym___cdecl] = ACTIONS(2490),
    [anon_sym___clrcall] = ACTIONS(2490),
    [anon_sym___stdcall] = ACTIONS(2490),
    [anon_sym___fastcall] = ACTIONS(2490),
    [anon_sym___thiscall] = ACTIONS(2490),
    [anon_sym___vectorcall] = ACTIONS(2490),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_signed] = ACTIONS(2490),
    [anon_sym_unsigned] = ACTIONS(2490),
    [anon_sym_long] = ACTIONS(2490),
    [anon_sym_short] = ACTIONS(2490),
    [anon_sym_LBRACK] = ACTIONS(2490),
    [anon_sym_static] = ACTIONS(2490),
    [anon_sym_register] = ACTIONS(2490),
    [anon_sym_inline] = ACTIONS(2490),
    [anon_sym___inline] = ACTIONS(2490),
    [anon_sym___inline__] = ACTIONS(2490),
    [anon_sym___forceinline] = ACTIONS(2490),
    [anon_sym_thread_local] = ACTIONS(2490),
    [anon_sym___thread] = ACTIONS(2490),
    [anon_sym_const] = ACTIONS(2490),
    [anon_sym_constexpr] = ACTIONS(2490),
    [anon_sym_volatile] = ACTIONS(2490),
    [anon_sym_restrict] = ACTIONS(2490),
    [anon_sym___restrict__] = ACTIONS(2490),
    [anon_sym__Atomic] = ACTIONS(2490),
    [anon_sym__Noreturn] = ACTIONS(2490),
    [anon_sym_noreturn] = ACTIONS(2490),
    [anon_sym__Nonnull] = ACTIONS(2490),
    [anon_sym_mutable] = ACTIONS(2490),
    [anon_sym_constinit] = ACTIONS(2490),
    [anon_sym_consteval] = ACTIONS(2490),
    [anon_sym_alignas] = ACTIONS(2490),
    [anon_sym__Alignas] = ACTIONS(2490),
    [sym_primitive_type] = ACTIONS(2490),
    [anon_sym_enum] = ACTIONS(2490),
    [anon_sym_class] = ACTIONS(2490),
    [anon_sym_struct] = ACTIONS(2490),
    [anon_sym_union] = ACTIONS(2490),
    [anon_sym_if] = ACTIONS(2490),
    [anon_sym_else] = ACTIONS(2490),
    [anon_sym_switch] = ACTIONS(2490),
    [anon_sym_case] = ACTIONS(2490),
    [anon_sym_default] = ACTIONS(2490),
    [anon_sym_while] = ACTIONS(2490),
    [anon_sym_do] = ACTIONS(2490),
    [anon_sym_for] = ACTIONS(2490),
    [anon_sym_return] = ACTIONS(2490),
    [anon_sym_break] = ACTIONS(2490),
    [anon_sym_continue] = ACTIONS(2490),
    [anon_sym_goto] = ACTIONS(2490),
    [anon_sym___try] = ACTIONS(2490),
    [anon_sym___leave] = ACTIONS(2490),
    [anon_sym_not] = ACTIONS(2490),
    [anon_sym_compl] = ACTIONS(2490),
    [anon_sym_DASH_DASH] = ACTIONS(2492),
    [anon_sym_PLUS_PLUS] = ACTIONS(2492),
    [anon_sym_sizeof] = ACTIONS(2490),
    [anon_sym___alignof__] = ACTIONS(2490),
    [anon_sym___alignof] = ACTIONS(2490),
    [anon_sym__alignof] = ACTIONS(2490),
    [anon_sym_alignof] = ACTIONS(2490),
    [anon_sym__Alignof] = ACTIONS(2490),
    [anon_sym_offsetof] = ACTIONS(2490),
    [anon_sym__Generic] = ACTIONS(2490),
    [anon_sym_asm] = ACTIONS(2490),
    [anon_sym___asm__] = ACTIONS(2490),
    [anon_sym___asm] = ACTIONS(2490),
    [sym_number_literal] = ACTIONS(2492),
    [anon_sym_L_SQUOTE] = ACTIONS(2492),
    [anon_sym_u_SQUOTE] = ACTIONS(2492),
    [anon_sym_U_SQUOTE] = ACTIONS(2492),
    [anon_sym_u8_SQUOTE] = ACTIONS(2492),
    [anon_sym_SQUOTE] = ACTIONS(2492),
    [anon_sym_L_DQUOTE] = ACTIONS(2492),
    [anon_sym_u_DQUOTE] = ACTIONS(2492),
    [anon_sym_U_DQUOTE] = ACTIONS(2492),
    [anon_sym_u8_DQUOTE] = ACTIONS(2492),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [sym_true] = ACTIONS(2490),
    [sym_false] = ACTIONS(2490),
    [anon_sym_NULL] = ACTIONS(2490),
    [anon_sym_nullptr] = ACTIONS(2490),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2490),
    [anon_sym_decltype] = ACTIONS(2490),
    [anon_sym_explicit] = ACTIONS(2490),
    [anon_sym_typename] = ACTIONS(2490),
    [anon_sym_template] = ACTIONS(2490),
    [anon_sym_operator] = ACTIONS(2490),
    [anon_sym_try] = ACTIONS(2490),
    [anon_sym_delete] = ACTIONS(2490),
    [anon_sym_throw] = ACTIONS(2490),
    [anon_sym_namespace] = ACTIONS(2490),
    [anon_sym_using] = ACTIONS(2490),
    [anon_sym_static_assert] = ACTIONS(2490),
    [anon_sym_concept] = ACTIONS(2490),
    [anon_sym_co_return] = ACTIONS(2490),
    [anon_sym_co_yield] = ACTIONS(2490),
    [anon_sym_catch] = ACTIONS(2813),
    [anon_sym_R_DQUOTE] = ACTIONS(2492),
    [anon_sym_LR_DQUOTE] = ACTIONS(2492),
    [anon_sym_uR_DQUOTE] = ACTIONS(2492),
    [anon_sym_UR_DQUOTE] = ACTIONS(2492),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2492),
    [anon_sym_co_await] = ACTIONS(2490),
    [anon_sym_new] = ACTIONS(2490),
    [anon_sym_requires] = ACTIONS(2490),
    [sym_this] = ACTIONS(2490),
  },
  [291] = {
    [sym_catch_clause] = STATE(291),
    [aux_sym_constructor_try_statement_repeat1] = STATE(291),
    [sym_identifier] = ACTIONS(2439),
    [aux_sym_preproc_include_token1] = ACTIONS(2439),
    [aux_sym_preproc_def_token1] = ACTIONS(2439),
    [aux_sym_preproc_if_token1] = ACTIONS(2439),
    [aux_sym_preproc_if_token2] = ACTIONS(2439),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2439),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2439),
    [sym_preproc_directive] = ACTIONS(2439),
    [anon_sym_LPAREN2] = ACTIONS(2441),
    [anon_sym_BANG] = ACTIONS(2441),
    [anon_sym_TILDE] = ACTIONS(2441),
    [anon_sym_DASH] = ACTIONS(2439),
    [anon_sym_PLUS] = ACTIONS(2439),
    [anon_sym_STAR] = ACTIONS(2441),
    [anon_sym_AMP_AMP] = ACTIONS(2441),
    [anon_sym_AMP] = ACTIONS(2439),
    [anon_sym_SEMI] = ACTIONS(2441),
    [anon_sym___extension__] = ACTIONS(2439),
    [anon_sym_typedef] = ACTIONS(2439),
    [anon_sym_virtual] = ACTIONS(2439),
    [anon_sym_extern] = ACTIONS(2439),
    [anon_sym___attribute__] = ACTIONS(2439),
    [anon_sym___attribute] = ACTIONS(2439),
    [anon_sym_COLON_COLON] = ACTIONS(2441),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2441),
    [anon_sym___declspec] = ACTIONS(2439),
    [anon_sym___based] = ACTIONS(2439),
    [anon_sym___cdecl] = ACTIONS(2439),
    [anon_sym___clrcall] = ACTIONS(2439),
    [anon_sym___stdcall] = ACTIONS(2439),
    [anon_sym___fastcall] = ACTIONS(2439),
    [anon_sym___thiscall] = ACTIONS(2439),
    [anon_sym___vectorcall] = ACTIONS(2439),
    [anon_sym_LBRACE] = ACTIONS(2441),
    [anon_sym_signed] = ACTIONS(2439),
    [anon_sym_unsigned] = ACTIONS(2439),
    [anon_sym_long] = ACTIONS(2439),
    [anon_sym_short] = ACTIONS(2439),
    [anon_sym_LBRACK] = ACTIONS(2439),
    [anon_sym_static] = ACTIONS(2439),
    [anon_sym_register] = ACTIONS(2439),
    [anon_sym_inline] = ACTIONS(2439),
    [anon_sym___inline] = ACTIONS(2439),
    [anon_sym___inline__] = ACTIONS(2439),
    [anon_sym___forceinline] = ACTIONS(2439),
    [anon_sym_thread_local] = ACTIONS(2439),
    [anon_sym___thread] = ACTIONS(2439),
    [anon_sym_const] = ACTIONS(2439),
    [anon_sym_constexpr] = ACTIONS(2439),
    [anon_sym_volatile] = ACTIONS(2439),
    [anon_sym_restrict] = ACTIONS(2439),
    [anon_sym___restrict__] = ACTIONS(2439),
    [anon_sym__Atomic] = ACTIONS(2439),
    [anon_sym__Noreturn] = ACTIONS(2439),
    [anon_sym_noreturn] = ACTIONS(2439),
    [anon_sym__Nonnull] = ACTIONS(2439),
    [anon_sym_mutable] = ACTIONS(2439),
    [anon_sym_constinit] = ACTIONS(2439),
    [anon_sym_consteval] = ACTIONS(2439),
    [anon_sym_alignas] = ACTIONS(2439),
    [anon_sym__Alignas] = ACTIONS(2439),
    [sym_primitive_type] = ACTIONS(2439),
    [anon_sym_enum] = ACTIONS(2439),
    [anon_sym_class] = ACTIONS(2439),
    [anon_sym_struct] = ACTIONS(2439),
    [anon_sym_union] = ACTIONS(2439),
    [anon_sym_if] = ACTIONS(2439),
    [anon_sym_else] = ACTIONS(2439),
    [anon_sym_switch] = ACTIONS(2439),
    [anon_sym_case] = ACTIONS(2439),
    [anon_sym_default] = ACTIONS(2439),
    [anon_sym_while] = ACTIONS(2439),
    [anon_sym_do] = ACTIONS(2439),
    [anon_sym_for] = ACTIONS(2439),
    [anon_sym_return] = ACTIONS(2439),
    [anon_sym_break] = ACTIONS(2439),
    [anon_sym_continue] = ACTIONS(2439),
    [anon_sym_goto] = ACTIONS(2439),
    [anon_sym___try] = ACTIONS(2439),
    [anon_sym___leave] = ACTIONS(2439),
    [anon_sym_not] = ACTIONS(2439),
    [anon_sym_compl] = ACTIONS(2439),
    [anon_sym_DASH_DASH] = ACTIONS(2441),
    [anon_sym_PLUS_PLUS] = ACTIONS(2441),
    [anon_sym_sizeof] = ACTIONS(2439),
    [anon_sym___alignof__] = ACTIONS(2439),
    [anon_sym___alignof] = ACTIONS(2439),
    [anon_sym__alignof] = ACTIONS(2439),
    [anon_sym_alignof] = ACTIONS(2439),
    [anon_sym__Alignof] = ACTIONS(2439),
    [anon_sym_offsetof] = ACTIONS(2439),
    [anon_sym__Generic] = ACTIONS(2439),
    [anon_sym_asm] = ACTIONS(2439),
    [anon_sym___asm__] = ACTIONS(2439),
    [anon_sym___asm] = ACTIONS(2439),
    [sym_number_literal] = ACTIONS(2441),
    [anon_sym_L_SQUOTE] = ACTIONS(2441),
    [anon_sym_u_SQUOTE] = ACTIONS(2441),
    [anon_sym_U_SQUOTE] = ACTIONS(2441),
    [anon_sym_u8_SQUOTE] = ACTIONS(2441),
    [anon_sym_SQUOTE] = ACTIONS(2441),
    [anon_sym_L_DQUOTE] = ACTIONS(2441),
    [anon_sym_u_DQUOTE] = ACTIONS(2441),
    [anon_sym_U_DQUOTE] = ACTIONS(2441),
    [anon_sym_u8_DQUOTE] = ACTIONS(2441),
    [anon_sym_DQUOTE] = ACTIONS(2441),
    [sym_true] = ACTIONS(2439),
    [sym_false] = ACTIONS(2439),
    [anon_sym_NULL] = ACTIONS(2439),
    [anon_sym_nullptr] = ACTIONS(2439),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2439),
    [anon_sym_decltype] = ACTIONS(2439),
    [anon_sym_explicit] = ACTIONS(2439),
    [anon_sym_typename] = ACTIONS(2439),
    [anon_sym_template] = ACTIONS(2439),
    [anon_sym_operator] = ACTIONS(2439),
    [anon_sym_try] = ACTIONS(2439),
    [anon_sym_delete] = ACTIONS(2439),
    [anon_sym_throw] = ACTIONS(2439),
    [anon_sym_namespace] = ACTIONS(2439),
    [anon_sym_using] = ACTIONS(2439),
    [anon_sym_static_assert] = ACTIONS(2439),
    [anon_sym_concept] = ACTIONS(2439),
    [anon_sym_co_return] = ACTIONS(2439),
    [anon_sym_co_yield] = ACTIONS(2439),
    [anon_sym_catch] = ACTIONS(2815),
    [anon_sym_R_DQUOTE] = ACTIONS(2441),
    [anon_sym_LR_DQUOTE] = ACTIONS(2441),
    [anon_sym_uR_DQUOTE] = ACTIONS(2441),
    [anon_sym_UR_DQUOTE] = ACTIONS(2441),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2441),
    [anon_sym_co_await] = ACTIONS(2439),
    [anon_sym_new] = ACTIONS(2439),
    [anon_sym_requires] = ACTIONS(2439),
    [sym_this] = ACTIONS(2439),
  },
  [292] = {
    [sym_identifier] = ACTIONS(2818),
    [aux_sym_preproc_include_token1] = ACTIONS(2818),
    [aux_sym_preproc_def_token1] = ACTIONS(2818),
    [aux_sym_preproc_if_token1] = ACTIONS(2818),
    [aux_sym_preproc_if_token2] = ACTIONS(2818),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2818),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2818),
    [aux_sym_preproc_else_token1] = ACTIONS(2818),
    [aux_sym_preproc_elif_token1] = ACTIONS(2818),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2818),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2818),
    [sym_preproc_directive] = ACTIONS(2818),
    [anon_sym_LPAREN2] = ACTIONS(2820),
    [anon_sym_BANG] = ACTIONS(2820),
    [anon_sym_TILDE] = ACTIONS(2820),
    [anon_sym_DASH] = ACTIONS(2818),
    [anon_sym_PLUS] = ACTIONS(2818),
    [anon_sym_STAR] = ACTIONS(2820),
    [anon_sym_AMP_AMP] = ACTIONS(2820),
    [anon_sym_AMP] = ACTIONS(2818),
    [anon_sym_SEMI] = ACTIONS(2820),
    [anon_sym___extension__] = ACTIONS(2818),
    [anon_sym_typedef] = ACTIONS(2818),
    [anon_sym_virtual] = ACTIONS(2818),
    [anon_sym_extern] = ACTIONS(2818),
    [anon_sym___attribute__] = ACTIONS(2818),
    [anon_sym___attribute] = ACTIONS(2818),
    [anon_sym_COLON_COLON] = ACTIONS(2820),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2820),
    [anon_sym___declspec] = ACTIONS(2818),
    [anon_sym___based] = ACTIONS(2818),
    [anon_sym___cdecl] = ACTIONS(2818),
    [anon_sym___clrcall] = ACTIONS(2818),
    [anon_sym___stdcall] = ACTIONS(2818),
    [anon_sym___fastcall] = ACTIONS(2818),
    [anon_sym___thiscall] = ACTIONS(2818),
    [anon_sym___vectorcall] = ACTIONS(2818),
    [anon_sym_LBRACE] = ACTIONS(2820),
    [anon_sym_signed] = ACTIONS(2818),
    [anon_sym_unsigned] = ACTIONS(2818),
    [anon_sym_long] = ACTIONS(2818),
    [anon_sym_short] = ACTIONS(2818),
    [anon_sym_LBRACK] = ACTIONS(2818),
    [anon_sym_static] = ACTIONS(2818),
    [anon_sym_register] = ACTIONS(2818),
    [anon_sym_inline] = ACTIONS(2818),
    [anon_sym___inline] = ACTIONS(2818),
    [anon_sym___inline__] = ACTIONS(2818),
    [anon_sym___forceinline] = ACTIONS(2818),
    [anon_sym_thread_local] = ACTIONS(2818),
    [anon_sym___thread] = ACTIONS(2818),
    [anon_sym_const] = ACTIONS(2818),
    [anon_sym_constexpr] = ACTIONS(2818),
    [anon_sym_volatile] = ACTIONS(2818),
    [anon_sym_restrict] = ACTIONS(2818),
    [anon_sym___restrict__] = ACTIONS(2818),
    [anon_sym__Atomic] = ACTIONS(2818),
    [anon_sym__Noreturn] = ACTIONS(2818),
    [anon_sym_noreturn] = ACTIONS(2818),
    [anon_sym__Nonnull] = ACTIONS(2818),
    [anon_sym_mutable] = ACTIONS(2818),
    [anon_sym_constinit] = ACTIONS(2818),
    [anon_sym_consteval] = ACTIONS(2818),
    [anon_sym_alignas] = ACTIONS(2818),
    [anon_sym__Alignas] = ACTIONS(2818),
    [sym_primitive_type] = ACTIONS(2818),
    [anon_sym_enum] = ACTIONS(2818),
    [anon_sym_class] = ACTIONS(2818),
    [anon_sym_struct] = ACTIONS(2818),
    [anon_sym_union] = ACTIONS(2818),
    [anon_sym_if] = ACTIONS(2818),
    [anon_sym_switch] = ACTIONS(2818),
    [anon_sym_case] = ACTIONS(2818),
    [anon_sym_default] = ACTIONS(2818),
    [anon_sym_while] = ACTIONS(2818),
    [anon_sym_do] = ACTIONS(2818),
    [anon_sym_for] = ACTIONS(2818),
    [anon_sym_return] = ACTIONS(2818),
    [anon_sym_break] = ACTIONS(2818),
    [anon_sym_continue] = ACTIONS(2818),
    [anon_sym_goto] = ACTIONS(2818),
    [anon_sym___try] = ACTIONS(2818),
    [anon_sym___leave] = ACTIONS(2818),
    [anon_sym_not] = ACTIONS(2818),
    [anon_sym_compl] = ACTIONS(2818),
    [anon_sym_DASH_DASH] = ACTIONS(2820),
    [anon_sym_PLUS_PLUS] = ACTIONS(2820),
    [anon_sym_sizeof] = ACTIONS(2818),
    [anon_sym___alignof__] = ACTIONS(2818),
    [anon_sym___alignof] = ACTIONS(2818),
    [anon_sym__alignof] = ACTIONS(2818),
    [anon_sym_alignof] = ACTIONS(2818),
    [anon_sym__Alignof] = ACTIONS(2818),
    [anon_sym_offsetof] = ACTIONS(2818),
    [anon_sym__Generic] = ACTIONS(2818),
    [anon_sym_asm] = ACTIONS(2818),
    [anon_sym___asm__] = ACTIONS(2818),
    [anon_sym___asm] = ACTIONS(2818),
    [sym_number_literal] = ACTIONS(2820),
    [anon_sym_L_SQUOTE] = ACTIONS(2820),
    [anon_sym_u_SQUOTE] = ACTIONS(2820),
    [anon_sym_U_SQUOTE] = ACTIONS(2820),
    [anon_sym_u8_SQUOTE] = ACTIONS(2820),
    [anon_sym_SQUOTE] = ACTIONS(2820),
    [anon_sym_L_DQUOTE] = ACTIONS(2820),
    [anon_sym_u_DQUOTE] = ACTIONS(2820),
    [anon_sym_U_DQUOTE] = ACTIONS(2820),
    [anon_sym_u8_DQUOTE] = ACTIONS(2820),
    [anon_sym_DQUOTE] = ACTIONS(2820),
    [sym_true] = ACTIONS(2818),
    [sym_false] = ACTIONS(2818),
    [anon_sym_NULL] = ACTIONS(2818),
    [anon_sym_nullptr] = ACTIONS(2818),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2818),
    [anon_sym_decltype] = ACTIONS(2818),
    [anon_sym_explicit] = ACTIONS(2818),
    [anon_sym_typename] = ACTIONS(2818),
    [anon_sym_template] = ACTIONS(2818),
    [anon_sym_operator] = ACTIONS(2818),
    [anon_sym_try] = ACTIONS(2818),
    [anon_sym_delete] = ACTIONS(2818),
    [anon_sym_throw] = ACTIONS(2818),
    [anon_sym_namespace] = ACTIONS(2818),
    [anon_sym_using] = ACTIONS(2818),
    [anon_sym_static_assert] = ACTIONS(2818),
    [anon_sym_concept] = ACTIONS(2818),
    [anon_sym_co_return] = ACTIONS(2818),
    [anon_sym_co_yield] = ACTIONS(2818),
    [anon_sym_R_DQUOTE] = ACTIONS(2820),
    [anon_sym_LR_DQUOTE] = ACTIONS(2820),
    [anon_sym_uR_DQUOTE] = ACTIONS(2820),
    [anon_sym_UR_DQUOTE] = ACTIONS(2820),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2820),
    [anon_sym_co_await] = ACTIONS(2818),
    [anon_sym_new] = ACTIONS(2818),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2818),
  },
  [293] = {
    [sym_identifier] = ACTIONS(2822),
    [aux_sym_preproc_include_token1] = ACTIONS(2822),
    [aux_sym_preproc_def_token1] = ACTIONS(2822),
    [aux_sym_preproc_if_token1] = ACTIONS(2822),
    [aux_sym_preproc_if_token2] = ACTIONS(2822),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2822),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2822),
    [aux_sym_preproc_else_token1] = ACTIONS(2822),
    [aux_sym_preproc_elif_token1] = ACTIONS(2822),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2822),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2822),
    [sym_preproc_directive] = ACTIONS(2822),
    [anon_sym_LPAREN2] = ACTIONS(2824),
    [anon_sym_BANG] = ACTIONS(2824),
    [anon_sym_TILDE] = ACTIONS(2824),
    [anon_sym_DASH] = ACTIONS(2822),
    [anon_sym_PLUS] = ACTIONS(2822),
    [anon_sym_STAR] = ACTIONS(2824),
    [anon_sym_AMP_AMP] = ACTIONS(2824),
    [anon_sym_AMP] = ACTIONS(2822),
    [anon_sym_SEMI] = ACTIONS(2824),
    [anon_sym___extension__] = ACTIONS(2822),
    [anon_sym_typedef] = ACTIONS(2822),
    [anon_sym_virtual] = ACTIONS(2822),
    [anon_sym_extern] = ACTIONS(2822),
    [anon_sym___attribute__] = ACTIONS(2822),
    [anon_sym___attribute] = ACTIONS(2822),
    [anon_sym_COLON_COLON] = ACTIONS(2824),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2824),
    [anon_sym___declspec] = ACTIONS(2822),
    [anon_sym___based] = ACTIONS(2822),
    [anon_sym___cdecl] = ACTIONS(2822),
    [anon_sym___clrcall] = ACTIONS(2822),
    [anon_sym___stdcall] = ACTIONS(2822),
    [anon_sym___fastcall] = ACTIONS(2822),
    [anon_sym___thiscall] = ACTIONS(2822),
    [anon_sym___vectorcall] = ACTIONS(2822),
    [anon_sym_LBRACE] = ACTIONS(2824),
    [anon_sym_signed] = ACTIONS(2822),
    [anon_sym_unsigned] = ACTIONS(2822),
    [anon_sym_long] = ACTIONS(2822),
    [anon_sym_short] = ACTIONS(2822),
    [anon_sym_LBRACK] = ACTIONS(2822),
    [anon_sym_static] = ACTIONS(2822),
    [anon_sym_register] = ACTIONS(2822),
    [anon_sym_inline] = ACTIONS(2822),
    [anon_sym___inline] = ACTIONS(2822),
    [anon_sym___inline__] = ACTIONS(2822),
    [anon_sym___forceinline] = ACTIONS(2822),
    [anon_sym_thread_local] = ACTIONS(2822),
    [anon_sym___thread] = ACTIONS(2822),
    [anon_sym_const] = ACTIONS(2822),
    [anon_sym_constexpr] = ACTIONS(2822),
    [anon_sym_volatile] = ACTIONS(2822),
    [anon_sym_restrict] = ACTIONS(2822),
    [anon_sym___restrict__] = ACTIONS(2822),
    [anon_sym__Atomic] = ACTIONS(2822),
    [anon_sym__Noreturn] = ACTIONS(2822),
    [anon_sym_noreturn] = ACTIONS(2822),
    [anon_sym__Nonnull] = ACTIONS(2822),
    [anon_sym_mutable] = ACTIONS(2822),
    [anon_sym_constinit] = ACTIONS(2822),
    [anon_sym_consteval] = ACTIONS(2822),
    [anon_sym_alignas] = ACTIONS(2822),
    [anon_sym__Alignas] = ACTIONS(2822),
    [sym_primitive_type] = ACTIONS(2822),
    [anon_sym_enum] = ACTIONS(2822),
    [anon_sym_class] = ACTIONS(2822),
    [anon_sym_struct] = ACTIONS(2822),
    [anon_sym_union] = ACTIONS(2822),
    [anon_sym_if] = ACTIONS(2822),
    [anon_sym_switch] = ACTIONS(2822),
    [anon_sym_case] = ACTIONS(2822),
    [anon_sym_default] = ACTIONS(2822),
    [anon_sym_while] = ACTIONS(2822),
    [anon_sym_do] = ACTIONS(2822),
    [anon_sym_for] = ACTIONS(2822),
    [anon_sym_return] = ACTIONS(2822),
    [anon_sym_break] = ACTIONS(2822),
    [anon_sym_continue] = ACTIONS(2822),
    [anon_sym_goto] = ACTIONS(2822),
    [anon_sym___try] = ACTIONS(2822),
    [anon_sym___leave] = ACTIONS(2822),
    [anon_sym_not] = ACTIONS(2822),
    [anon_sym_compl] = ACTIONS(2822),
    [anon_sym_DASH_DASH] = ACTIONS(2824),
    [anon_sym_PLUS_PLUS] = ACTIONS(2824),
    [anon_sym_sizeof] = ACTIONS(2822),
    [anon_sym___alignof__] = ACTIONS(2822),
    [anon_sym___alignof] = ACTIONS(2822),
    [anon_sym__alignof] = ACTIONS(2822),
    [anon_sym_alignof] = ACTIONS(2822),
    [anon_sym__Alignof] = ACTIONS(2822),
    [anon_sym_offsetof] = ACTIONS(2822),
    [anon_sym__Generic] = ACTIONS(2822),
    [anon_sym_asm] = ACTIONS(2822),
    [anon_sym___asm__] = ACTIONS(2822),
    [anon_sym___asm] = ACTIONS(2822),
    [sym_number_literal] = ACTIONS(2824),
    [anon_sym_L_SQUOTE] = ACTIONS(2824),
    [anon_sym_u_SQUOTE] = ACTIONS(2824),
    [anon_sym_U_SQUOTE] = ACTIONS(2824),
    [anon_sym_u8_SQUOTE] = ACTIONS(2824),
    [anon_sym_SQUOTE] = ACTIONS(2824),
    [anon_sym_L_DQUOTE] = ACTIONS(2824),
    [anon_sym_u_DQUOTE] = ACTIONS(2824),
    [anon_sym_U_DQUOTE] = ACTIONS(2824),
    [anon_sym_u8_DQUOTE] = ACTIONS(2824),
    [anon_sym_DQUOTE] = ACTIONS(2824),
    [sym_true] = ACTIONS(2822),
    [sym_false] = ACTIONS(2822),
    [anon_sym_NULL] = ACTIONS(2822),
    [anon_sym_nullptr] = ACTIONS(2822),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2822),
    [anon_sym_decltype] = ACTIONS(2822),
    [anon_sym_explicit] = ACTIONS(2822),
    [anon_sym_typename] = ACTIONS(2822),
    [anon_sym_template] = ACTIONS(2822),
    [anon_sym_operator] = ACTIONS(2822),
    [anon_sym_try] = ACTIONS(2822),
    [anon_sym_delete] = ACTIONS(2822),
    [anon_sym_throw] = ACTIONS(2822),
    [anon_sym_namespace] = ACTIONS(2822),
    [anon_sym_using] = ACTIONS(2822),
    [anon_sym_static_assert] = ACTIONS(2822),
    [anon_sym_concept] = ACTIONS(2822),
    [anon_sym_co_return] = ACTIONS(2822),
    [anon_sym_co_yield] = ACTIONS(2822),
    [anon_sym_R_DQUOTE] = ACTIONS(2824),
    [anon_sym_LR_DQUOTE] = ACTIONS(2824),
    [anon_sym_uR_DQUOTE] = ACTIONS(2824),
    [anon_sym_UR_DQUOTE] = ACTIONS(2824),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2824),
    [anon_sym_co_await] = ACTIONS(2822),
    [anon_sym_new] = ACTIONS(2822),
    [anon_sym_requires] = ACTIONS(2822),
    [sym_this] = ACTIONS(2822),
  },
  [294] = {
    [sym_identifier] = ACTIONS(2826),
    [aux_sym_preproc_include_token1] = ACTIONS(2826),
    [aux_sym_preproc_def_token1] = ACTIONS(2826),
    [aux_sym_preproc_if_token1] = ACTIONS(2826),
    [aux_sym_preproc_if_token2] = ACTIONS(2826),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2826),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2826),
    [aux_sym_preproc_else_token1] = ACTIONS(2826),
    [aux_sym_preproc_elif_token1] = ACTIONS(2826),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2826),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2826),
    [sym_preproc_directive] = ACTIONS(2826),
    [anon_sym_LPAREN2] = ACTIONS(2828),
    [anon_sym_BANG] = ACTIONS(2828),
    [anon_sym_TILDE] = ACTIONS(2828),
    [anon_sym_DASH] = ACTIONS(2826),
    [anon_sym_PLUS] = ACTIONS(2826),
    [anon_sym_STAR] = ACTIONS(2828),
    [anon_sym_AMP_AMP] = ACTIONS(2828),
    [anon_sym_AMP] = ACTIONS(2826),
    [anon_sym_SEMI] = ACTIONS(2828),
    [anon_sym___extension__] = ACTIONS(2826),
    [anon_sym_typedef] = ACTIONS(2826),
    [anon_sym_virtual] = ACTIONS(2826),
    [anon_sym_extern] = ACTIONS(2826),
    [anon_sym___attribute__] = ACTIONS(2826),
    [anon_sym___attribute] = ACTIONS(2826),
    [anon_sym_COLON_COLON] = ACTIONS(2828),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2828),
    [anon_sym___declspec] = ACTIONS(2826),
    [anon_sym___based] = ACTIONS(2826),
    [anon_sym___cdecl] = ACTIONS(2826),
    [anon_sym___clrcall] = ACTIONS(2826),
    [anon_sym___stdcall] = ACTIONS(2826),
    [anon_sym___fastcall] = ACTIONS(2826),
    [anon_sym___thiscall] = ACTIONS(2826),
    [anon_sym___vectorcall] = ACTIONS(2826),
    [anon_sym_LBRACE] = ACTIONS(2828),
    [anon_sym_signed] = ACTIONS(2826),
    [anon_sym_unsigned] = ACTIONS(2826),
    [anon_sym_long] = ACTIONS(2826),
    [anon_sym_short] = ACTIONS(2826),
    [anon_sym_LBRACK] = ACTIONS(2826),
    [anon_sym_static] = ACTIONS(2826),
    [anon_sym_register] = ACTIONS(2826),
    [anon_sym_inline] = ACTIONS(2826),
    [anon_sym___inline] = ACTIONS(2826),
    [anon_sym___inline__] = ACTIONS(2826),
    [anon_sym___forceinline] = ACTIONS(2826),
    [anon_sym_thread_local] = ACTIONS(2826),
    [anon_sym___thread] = ACTIONS(2826),
    [anon_sym_const] = ACTIONS(2826),
    [anon_sym_constexpr] = ACTIONS(2826),
    [anon_sym_volatile] = ACTIONS(2826),
    [anon_sym_restrict] = ACTIONS(2826),
    [anon_sym___restrict__] = ACTIONS(2826),
    [anon_sym__Atomic] = ACTIONS(2826),
    [anon_sym__Noreturn] = ACTIONS(2826),
    [anon_sym_noreturn] = ACTIONS(2826),
    [anon_sym__Nonnull] = ACTIONS(2826),
    [anon_sym_mutable] = ACTIONS(2826),
    [anon_sym_constinit] = ACTIONS(2826),
    [anon_sym_consteval] = ACTIONS(2826),
    [anon_sym_alignas] = ACTIONS(2826),
    [anon_sym__Alignas] = ACTIONS(2826),
    [sym_primitive_type] = ACTIONS(2826),
    [anon_sym_enum] = ACTIONS(2826),
    [anon_sym_class] = ACTIONS(2826),
    [anon_sym_struct] = ACTIONS(2826),
    [anon_sym_union] = ACTIONS(2826),
    [anon_sym_if] = ACTIONS(2826),
    [anon_sym_switch] = ACTIONS(2826),
    [anon_sym_case] = ACTIONS(2826),
    [anon_sym_default] = ACTIONS(2826),
    [anon_sym_while] = ACTIONS(2826),
    [anon_sym_do] = ACTIONS(2826),
    [anon_sym_for] = ACTIONS(2826),
    [anon_sym_return] = ACTIONS(2826),
    [anon_sym_break] = ACTIONS(2826),
    [anon_sym_continue] = ACTIONS(2826),
    [anon_sym_goto] = ACTIONS(2826),
    [anon_sym___try] = ACTIONS(2826),
    [anon_sym___leave] = ACTIONS(2826),
    [anon_sym_not] = ACTIONS(2826),
    [anon_sym_compl] = ACTIONS(2826),
    [anon_sym_DASH_DASH] = ACTIONS(2828),
    [anon_sym_PLUS_PLUS] = ACTIONS(2828),
    [anon_sym_sizeof] = ACTIONS(2826),
    [anon_sym___alignof__] = ACTIONS(2826),
    [anon_sym___alignof] = ACTIONS(2826),
    [anon_sym__alignof] = ACTIONS(2826),
    [anon_sym_alignof] = ACTIONS(2826),
    [anon_sym__Alignof] = ACTIONS(2826),
    [anon_sym_offsetof] = ACTIONS(2826),
    [anon_sym__Generic] = ACTIONS(2826),
    [anon_sym_asm] = ACTIONS(2826),
    [anon_sym___asm__] = ACTIONS(2826),
    [anon_sym___asm] = ACTIONS(2826),
    [sym_number_literal] = ACTIONS(2828),
    [anon_sym_L_SQUOTE] = ACTIONS(2828),
    [anon_sym_u_SQUOTE] = ACTIONS(2828),
    [anon_sym_U_SQUOTE] = ACTIONS(2828),
    [anon_sym_u8_SQUOTE] = ACTIONS(2828),
    [anon_sym_SQUOTE] = ACTIONS(2828),
    [anon_sym_L_DQUOTE] = ACTIONS(2828),
    [anon_sym_u_DQUOTE] = ACTIONS(2828),
    [anon_sym_U_DQUOTE] = ACTIONS(2828),
    [anon_sym_u8_DQUOTE] = ACTIONS(2828),
    [anon_sym_DQUOTE] = ACTIONS(2828),
    [sym_true] = ACTIONS(2826),
    [sym_false] = ACTIONS(2826),
    [anon_sym_NULL] = ACTIONS(2826),
    [anon_sym_nullptr] = ACTIONS(2826),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2826),
    [anon_sym_decltype] = ACTIONS(2826),
    [anon_sym_explicit] = ACTIONS(2826),
    [anon_sym_typename] = ACTIONS(2826),
    [anon_sym_template] = ACTIONS(2826),
    [anon_sym_operator] = ACTIONS(2826),
    [anon_sym_try] = ACTIONS(2826),
    [anon_sym_delete] = ACTIONS(2826),
    [anon_sym_throw] = ACTIONS(2826),
    [anon_sym_namespace] = ACTIONS(2826),
    [anon_sym_using] = ACTIONS(2826),
    [anon_sym_static_assert] = ACTIONS(2826),
    [anon_sym_concept] = ACTIONS(2826),
    [anon_sym_co_return] = ACTIONS(2826),
    [anon_sym_co_yield] = ACTIONS(2826),
    [anon_sym_R_DQUOTE] = ACTIONS(2828),
    [anon_sym_LR_DQUOTE] = ACTIONS(2828),
    [anon_sym_uR_DQUOTE] = ACTIONS(2828),
    [anon_sym_UR_DQUOTE] = ACTIONS(2828),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2828),
    [anon_sym_co_await] = ACTIONS(2826),
    [anon_sym_new] = ACTIONS(2826),
    [anon_sym_requires] = ACTIONS(2826),
    [sym_this] = ACTIONS(2826),
  },
  [295] = {
    [sym_identifier] = ACTIONS(2830),
    [aux_sym_preproc_include_token1] = ACTIONS(2830),
    [aux_sym_preproc_def_token1] = ACTIONS(2830),
    [aux_sym_preproc_if_token1] = ACTIONS(2830),
    [aux_sym_preproc_if_token2] = ACTIONS(2830),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2830),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2830),
    [aux_sym_preproc_else_token1] = ACTIONS(2830),
    [aux_sym_preproc_elif_token1] = ACTIONS(2830),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2830),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2830),
    [sym_preproc_directive] = ACTIONS(2830),
    [anon_sym_LPAREN2] = ACTIONS(2832),
    [anon_sym_BANG] = ACTIONS(2832),
    [anon_sym_TILDE] = ACTIONS(2832),
    [anon_sym_DASH] = ACTIONS(2830),
    [anon_sym_PLUS] = ACTIONS(2830),
    [anon_sym_STAR] = ACTIONS(2832),
    [anon_sym_AMP_AMP] = ACTIONS(2832),
    [anon_sym_AMP] = ACTIONS(2830),
    [anon_sym_SEMI] = ACTIONS(2832),
    [anon_sym___extension__] = ACTIONS(2830),
    [anon_sym_typedef] = ACTIONS(2830),
    [anon_sym_virtual] = ACTIONS(2830),
    [anon_sym_extern] = ACTIONS(2830),
    [anon_sym___attribute__] = ACTIONS(2830),
    [anon_sym___attribute] = ACTIONS(2830),
    [anon_sym_COLON_COLON] = ACTIONS(2832),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2832),
    [anon_sym___declspec] = ACTIONS(2830),
    [anon_sym___based] = ACTIONS(2830),
    [anon_sym___cdecl] = ACTIONS(2830),
    [anon_sym___clrcall] = ACTIONS(2830),
    [anon_sym___stdcall] = ACTIONS(2830),
    [anon_sym___fastcall] = ACTIONS(2830),
    [anon_sym___thiscall] = ACTIONS(2830),
    [anon_sym___vectorcall] = ACTIONS(2830),
    [anon_sym_LBRACE] = ACTIONS(2832),
    [anon_sym_signed] = ACTIONS(2830),
    [anon_sym_unsigned] = ACTIONS(2830),
    [anon_sym_long] = ACTIONS(2830),
    [anon_sym_short] = ACTIONS(2830),
    [anon_sym_LBRACK] = ACTIONS(2830),
    [anon_sym_static] = ACTIONS(2830),
    [anon_sym_register] = ACTIONS(2830),
    [anon_sym_inline] = ACTIONS(2830),
    [anon_sym___inline] = ACTIONS(2830),
    [anon_sym___inline__] = ACTIONS(2830),
    [anon_sym___forceinline] = ACTIONS(2830),
    [anon_sym_thread_local] = ACTIONS(2830),
    [anon_sym___thread] = ACTIONS(2830),
    [anon_sym_const] = ACTIONS(2830),
    [anon_sym_constexpr] = ACTIONS(2830),
    [anon_sym_volatile] = ACTIONS(2830),
    [anon_sym_restrict] = ACTIONS(2830),
    [anon_sym___restrict__] = ACTIONS(2830),
    [anon_sym__Atomic] = ACTIONS(2830),
    [anon_sym__Noreturn] = ACTIONS(2830),
    [anon_sym_noreturn] = ACTIONS(2830),
    [anon_sym__Nonnull] = ACTIONS(2830),
    [anon_sym_mutable] = ACTIONS(2830),
    [anon_sym_constinit] = ACTIONS(2830),
    [anon_sym_consteval] = ACTIONS(2830),
    [anon_sym_alignas] = ACTIONS(2830),
    [anon_sym__Alignas] = ACTIONS(2830),
    [sym_primitive_type] = ACTIONS(2830),
    [anon_sym_enum] = ACTIONS(2830),
    [anon_sym_class] = ACTIONS(2830),
    [anon_sym_struct] = ACTIONS(2830),
    [anon_sym_union] = ACTIONS(2830),
    [anon_sym_if] = ACTIONS(2830),
    [anon_sym_switch] = ACTIONS(2830),
    [anon_sym_case] = ACTIONS(2830),
    [anon_sym_default] = ACTIONS(2830),
    [anon_sym_while] = ACTIONS(2830),
    [anon_sym_do] = ACTIONS(2830),
    [anon_sym_for] = ACTIONS(2830),
    [anon_sym_return] = ACTIONS(2830),
    [anon_sym_break] = ACTIONS(2830),
    [anon_sym_continue] = ACTIONS(2830),
    [anon_sym_goto] = ACTIONS(2830),
    [anon_sym___try] = ACTIONS(2830),
    [anon_sym___leave] = ACTIONS(2830),
    [anon_sym_not] = ACTIONS(2830),
    [anon_sym_compl] = ACTIONS(2830),
    [anon_sym_DASH_DASH] = ACTIONS(2832),
    [anon_sym_PLUS_PLUS] = ACTIONS(2832),
    [anon_sym_sizeof] = ACTIONS(2830),
    [anon_sym___alignof__] = ACTIONS(2830),
    [anon_sym___alignof] = ACTIONS(2830),
    [anon_sym__alignof] = ACTIONS(2830),
    [anon_sym_alignof] = ACTIONS(2830),
    [anon_sym__Alignof] = ACTIONS(2830),
    [anon_sym_offsetof] = ACTIONS(2830),
    [anon_sym__Generic] = ACTIONS(2830),
    [anon_sym_asm] = ACTIONS(2830),
    [anon_sym___asm__] = ACTIONS(2830),
    [anon_sym___asm] = ACTIONS(2830),
    [sym_number_literal] = ACTIONS(2832),
    [anon_sym_L_SQUOTE] = ACTIONS(2832),
    [anon_sym_u_SQUOTE] = ACTIONS(2832),
    [anon_sym_U_SQUOTE] = ACTIONS(2832),
    [anon_sym_u8_SQUOTE] = ACTIONS(2832),
    [anon_sym_SQUOTE] = ACTIONS(2832),
    [anon_sym_L_DQUOTE] = ACTIONS(2832),
    [anon_sym_u_DQUOTE] = ACTIONS(2832),
    [anon_sym_U_DQUOTE] = ACTIONS(2832),
    [anon_sym_u8_DQUOTE] = ACTIONS(2832),
    [anon_sym_DQUOTE] = ACTIONS(2832),
    [sym_true] = ACTIONS(2830),
    [sym_false] = ACTIONS(2830),
    [anon_sym_NULL] = ACTIONS(2830),
    [anon_sym_nullptr] = ACTIONS(2830),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2830),
    [anon_sym_decltype] = ACTIONS(2830),
    [anon_sym_explicit] = ACTIONS(2830),
    [anon_sym_typename] = ACTIONS(2830),
    [anon_sym_template] = ACTIONS(2830),
    [anon_sym_operator] = ACTIONS(2830),
    [anon_sym_try] = ACTIONS(2830),
    [anon_sym_delete] = ACTIONS(2830),
    [anon_sym_throw] = ACTIONS(2830),
    [anon_sym_namespace] = ACTIONS(2830),
    [anon_sym_using] = ACTIONS(2830),
    [anon_sym_static_assert] = ACTIONS(2830),
    [anon_sym_concept] = ACTIONS(2830),
    [anon_sym_co_return] = ACTIONS(2830),
    [anon_sym_co_yield] = ACTIONS(2830),
    [anon_sym_R_DQUOTE] = ACTIONS(2832),
    [anon_sym_LR_DQUOTE] = ACTIONS(2832),
    [anon_sym_uR_DQUOTE] = ACTIONS(2832),
    [anon_sym_UR_DQUOTE] = ACTIONS(2832),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2832),
    [anon_sym_co_await] = ACTIONS(2830),
    [anon_sym_new] = ACTIONS(2830),
    [anon_sym_requires] = ACTIONS(2830),
    [sym_this] = ACTIONS(2830),
  },
  [296] = {
    [sym_identifier] = ACTIONS(2834),
    [aux_sym_preproc_include_token1] = ACTIONS(2834),
    [aux_sym_preproc_def_token1] = ACTIONS(2834),
    [aux_sym_preproc_if_token1] = ACTIONS(2834),
    [aux_sym_preproc_if_token2] = ACTIONS(2834),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2834),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2834),
    [aux_sym_preproc_else_token1] = ACTIONS(2834),
    [aux_sym_preproc_elif_token1] = ACTIONS(2834),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2834),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2834),
    [sym_preproc_directive] = ACTIONS(2834),
    [anon_sym_LPAREN2] = ACTIONS(2836),
    [anon_sym_BANG] = ACTIONS(2836),
    [anon_sym_TILDE] = ACTIONS(2836),
    [anon_sym_DASH] = ACTIONS(2834),
    [anon_sym_PLUS] = ACTIONS(2834),
    [anon_sym_STAR] = ACTIONS(2836),
    [anon_sym_AMP_AMP] = ACTIONS(2836),
    [anon_sym_AMP] = ACTIONS(2834),
    [anon_sym_SEMI] = ACTIONS(2836),
    [anon_sym___extension__] = ACTIONS(2834),
    [anon_sym_typedef] = ACTIONS(2834),
    [anon_sym_virtual] = ACTIONS(2834),
    [anon_sym_extern] = ACTIONS(2834),
    [anon_sym___attribute__] = ACTIONS(2834),
    [anon_sym___attribute] = ACTIONS(2834),
    [anon_sym_COLON_COLON] = ACTIONS(2836),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2836),
    [anon_sym___declspec] = ACTIONS(2834),
    [anon_sym___based] = ACTIONS(2834),
    [anon_sym___cdecl] = ACTIONS(2834),
    [anon_sym___clrcall] = ACTIONS(2834),
    [anon_sym___stdcall] = ACTIONS(2834),
    [anon_sym___fastcall] = ACTIONS(2834),
    [anon_sym___thiscall] = ACTIONS(2834),
    [anon_sym___vectorcall] = ACTIONS(2834),
    [anon_sym_LBRACE] = ACTIONS(2836),
    [anon_sym_signed] = ACTIONS(2834),
    [anon_sym_unsigned] = ACTIONS(2834),
    [anon_sym_long] = ACTIONS(2834),
    [anon_sym_short] = ACTIONS(2834),
    [anon_sym_LBRACK] = ACTIONS(2834),
    [anon_sym_static] = ACTIONS(2834),
    [anon_sym_register] = ACTIONS(2834),
    [anon_sym_inline] = ACTIONS(2834),
    [anon_sym___inline] = ACTIONS(2834),
    [anon_sym___inline__] = ACTIONS(2834),
    [anon_sym___forceinline] = ACTIONS(2834),
    [anon_sym_thread_local] = ACTIONS(2834),
    [anon_sym___thread] = ACTIONS(2834),
    [anon_sym_const] = ACTIONS(2834),
    [anon_sym_constexpr] = ACTIONS(2834),
    [anon_sym_volatile] = ACTIONS(2834),
    [anon_sym_restrict] = ACTIONS(2834),
    [anon_sym___restrict__] = ACTIONS(2834),
    [anon_sym__Atomic] = ACTIONS(2834),
    [anon_sym__Noreturn] = ACTIONS(2834),
    [anon_sym_noreturn] = ACTIONS(2834),
    [anon_sym__Nonnull] = ACTIONS(2834),
    [anon_sym_mutable] = ACTIONS(2834),
    [anon_sym_constinit] = ACTIONS(2834),
    [anon_sym_consteval] = ACTIONS(2834),
    [anon_sym_alignas] = ACTIONS(2834),
    [anon_sym__Alignas] = ACTIONS(2834),
    [sym_primitive_type] = ACTIONS(2834),
    [anon_sym_enum] = ACTIONS(2834),
    [anon_sym_class] = ACTIONS(2834),
    [anon_sym_struct] = ACTIONS(2834),
    [anon_sym_union] = ACTIONS(2834),
    [anon_sym_if] = ACTIONS(2834),
    [anon_sym_switch] = ACTIONS(2834),
    [anon_sym_case] = ACTIONS(2834),
    [anon_sym_default] = ACTIONS(2834),
    [anon_sym_while] = ACTIONS(2834),
    [anon_sym_do] = ACTIONS(2834),
    [anon_sym_for] = ACTIONS(2834),
    [anon_sym_return] = ACTIONS(2834),
    [anon_sym_break] = ACTIONS(2834),
    [anon_sym_continue] = ACTIONS(2834),
    [anon_sym_goto] = ACTIONS(2834),
    [anon_sym___try] = ACTIONS(2834),
    [anon_sym___leave] = ACTIONS(2834),
    [anon_sym_not] = ACTIONS(2834),
    [anon_sym_compl] = ACTIONS(2834),
    [anon_sym_DASH_DASH] = ACTIONS(2836),
    [anon_sym_PLUS_PLUS] = ACTIONS(2836),
    [anon_sym_sizeof] = ACTIONS(2834),
    [anon_sym___alignof__] = ACTIONS(2834),
    [anon_sym___alignof] = ACTIONS(2834),
    [anon_sym__alignof] = ACTIONS(2834),
    [anon_sym_alignof] = ACTIONS(2834),
    [anon_sym__Alignof] = ACTIONS(2834),
    [anon_sym_offsetof] = ACTIONS(2834),
    [anon_sym__Generic] = ACTIONS(2834),
    [anon_sym_asm] = ACTIONS(2834),
    [anon_sym___asm__] = ACTIONS(2834),
    [anon_sym___asm] = ACTIONS(2834),
    [sym_number_literal] = ACTIONS(2836),
    [anon_sym_L_SQUOTE] = ACTIONS(2836),
    [anon_sym_u_SQUOTE] = ACTIONS(2836),
    [anon_sym_U_SQUOTE] = ACTIONS(2836),
    [anon_sym_u8_SQUOTE] = ACTIONS(2836),
    [anon_sym_SQUOTE] = ACTIONS(2836),
    [anon_sym_L_DQUOTE] = ACTIONS(2836),
    [anon_sym_u_DQUOTE] = ACTIONS(2836),
    [anon_sym_U_DQUOTE] = ACTIONS(2836),
    [anon_sym_u8_DQUOTE] = ACTIONS(2836),
    [anon_sym_DQUOTE] = ACTIONS(2836),
    [sym_true] = ACTIONS(2834),
    [sym_false] = ACTIONS(2834),
    [anon_sym_NULL] = ACTIONS(2834),
    [anon_sym_nullptr] = ACTIONS(2834),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2834),
    [anon_sym_decltype] = ACTIONS(2834),
    [anon_sym_explicit] = ACTIONS(2834),
    [anon_sym_typename] = ACTIONS(2834),
    [anon_sym_template] = ACTIONS(2834),
    [anon_sym_operator] = ACTIONS(2834),
    [anon_sym_try] = ACTIONS(2834),
    [anon_sym_delete] = ACTIONS(2834),
    [anon_sym_throw] = ACTIONS(2834),
    [anon_sym_namespace] = ACTIONS(2834),
    [anon_sym_using] = ACTIONS(2834),
    [anon_sym_static_assert] = ACTIONS(2834),
    [anon_sym_concept] = ACTIONS(2834),
    [anon_sym_co_return] = ACTIONS(2834),
    [anon_sym_co_yield] = ACTIONS(2834),
    [anon_sym_R_DQUOTE] = ACTIONS(2836),
    [anon_sym_LR_DQUOTE] = ACTIONS(2836),
    [anon_sym_uR_DQUOTE] = ACTIONS(2836),
    [anon_sym_UR_DQUOTE] = ACTIONS(2836),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2836),
    [anon_sym_co_await] = ACTIONS(2834),
    [anon_sym_new] = ACTIONS(2834),
    [anon_sym_requires] = ACTIONS(2834),
    [sym_this] = ACTIONS(2834),
  },
  [297] = {
    [sym_identifier] = ACTIONS(2838),
    [aux_sym_preproc_include_token1] = ACTIONS(2838),
    [aux_sym_preproc_def_token1] = ACTIONS(2838),
    [aux_sym_preproc_if_token1] = ACTIONS(2838),
    [aux_sym_preproc_if_token2] = ACTIONS(2838),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2838),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2838),
    [aux_sym_preproc_else_token1] = ACTIONS(2838),
    [aux_sym_preproc_elif_token1] = ACTIONS(2838),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2838),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2838),
    [sym_preproc_directive] = ACTIONS(2838),
    [anon_sym_LPAREN2] = ACTIONS(2840),
    [anon_sym_BANG] = ACTIONS(2840),
    [anon_sym_TILDE] = ACTIONS(2840),
    [anon_sym_DASH] = ACTIONS(2838),
    [anon_sym_PLUS] = ACTIONS(2838),
    [anon_sym_STAR] = ACTIONS(2840),
    [anon_sym_AMP_AMP] = ACTIONS(2840),
    [anon_sym_AMP] = ACTIONS(2838),
    [anon_sym_SEMI] = ACTIONS(2840),
    [anon_sym___extension__] = ACTIONS(2838),
    [anon_sym_typedef] = ACTIONS(2838),
    [anon_sym_virtual] = ACTIONS(2838),
    [anon_sym_extern] = ACTIONS(2838),
    [anon_sym___attribute__] = ACTIONS(2838),
    [anon_sym___attribute] = ACTIONS(2838),
    [anon_sym_COLON_COLON] = ACTIONS(2840),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2840),
    [anon_sym___declspec] = ACTIONS(2838),
    [anon_sym___based] = ACTIONS(2838),
    [anon_sym___cdecl] = ACTIONS(2838),
    [anon_sym___clrcall] = ACTIONS(2838),
    [anon_sym___stdcall] = ACTIONS(2838),
    [anon_sym___fastcall] = ACTIONS(2838),
    [anon_sym___thiscall] = ACTIONS(2838),
    [anon_sym___vectorcall] = ACTIONS(2838),
    [anon_sym_LBRACE] = ACTIONS(2840),
    [anon_sym_signed] = ACTIONS(2838),
    [anon_sym_unsigned] = ACTIONS(2838),
    [anon_sym_long] = ACTIONS(2838),
    [anon_sym_short] = ACTIONS(2838),
    [anon_sym_LBRACK] = ACTIONS(2838),
    [anon_sym_static] = ACTIONS(2838),
    [anon_sym_register] = ACTIONS(2838),
    [anon_sym_inline] = ACTIONS(2838),
    [anon_sym___inline] = ACTIONS(2838),
    [anon_sym___inline__] = ACTIONS(2838),
    [anon_sym___forceinline] = ACTIONS(2838),
    [anon_sym_thread_local] = ACTIONS(2838),
    [anon_sym___thread] = ACTIONS(2838),
    [anon_sym_const] = ACTIONS(2838),
    [anon_sym_constexpr] = ACTIONS(2838),
    [anon_sym_volatile] = ACTIONS(2838),
    [anon_sym_restrict] = ACTIONS(2838),
    [anon_sym___restrict__] = ACTIONS(2838),
    [anon_sym__Atomic] = ACTIONS(2838),
    [anon_sym__Noreturn] = ACTIONS(2838),
    [anon_sym_noreturn] = ACTIONS(2838),
    [anon_sym__Nonnull] = ACTIONS(2838),
    [anon_sym_mutable] = ACTIONS(2838),
    [anon_sym_constinit] = ACTIONS(2838),
    [anon_sym_consteval] = ACTIONS(2838),
    [anon_sym_alignas] = ACTIONS(2838),
    [anon_sym__Alignas] = ACTIONS(2838),
    [sym_primitive_type] = ACTIONS(2838),
    [anon_sym_enum] = ACTIONS(2838),
    [anon_sym_class] = ACTIONS(2838),
    [anon_sym_struct] = ACTIONS(2838),
    [anon_sym_union] = ACTIONS(2838),
    [anon_sym_if] = ACTIONS(2838),
    [anon_sym_switch] = ACTIONS(2838),
    [anon_sym_case] = ACTIONS(2838),
    [anon_sym_default] = ACTIONS(2838),
    [anon_sym_while] = ACTIONS(2838),
    [anon_sym_do] = ACTIONS(2838),
    [anon_sym_for] = ACTIONS(2838),
    [anon_sym_return] = ACTIONS(2838),
    [anon_sym_break] = ACTIONS(2838),
    [anon_sym_continue] = ACTIONS(2838),
    [anon_sym_goto] = ACTIONS(2838),
    [anon_sym___try] = ACTIONS(2838),
    [anon_sym___leave] = ACTIONS(2838),
    [anon_sym_not] = ACTIONS(2838),
    [anon_sym_compl] = ACTIONS(2838),
    [anon_sym_DASH_DASH] = ACTIONS(2840),
    [anon_sym_PLUS_PLUS] = ACTIONS(2840),
    [anon_sym_sizeof] = ACTIONS(2838),
    [anon_sym___alignof__] = ACTIONS(2838),
    [anon_sym___alignof] = ACTIONS(2838),
    [anon_sym__alignof] = ACTIONS(2838),
    [anon_sym_alignof] = ACTIONS(2838),
    [anon_sym__Alignof] = ACTIONS(2838),
    [anon_sym_offsetof] = ACTIONS(2838),
    [anon_sym__Generic] = ACTIONS(2838),
    [anon_sym_asm] = ACTIONS(2838),
    [anon_sym___asm__] = ACTIONS(2838),
    [anon_sym___asm] = ACTIONS(2838),
    [sym_number_literal] = ACTIONS(2840),
    [anon_sym_L_SQUOTE] = ACTIONS(2840),
    [anon_sym_u_SQUOTE] = ACTIONS(2840),
    [anon_sym_U_SQUOTE] = ACTIONS(2840),
    [anon_sym_u8_SQUOTE] = ACTIONS(2840),
    [anon_sym_SQUOTE] = ACTIONS(2840),
    [anon_sym_L_DQUOTE] = ACTIONS(2840),
    [anon_sym_u_DQUOTE] = ACTIONS(2840),
    [anon_sym_U_DQUOTE] = ACTIONS(2840),
    [anon_sym_u8_DQUOTE] = ACTIONS(2840),
    [anon_sym_DQUOTE] = ACTIONS(2840),
    [sym_true] = ACTIONS(2838),
    [sym_false] = ACTIONS(2838),
    [anon_sym_NULL] = ACTIONS(2838),
    [anon_sym_nullptr] = ACTIONS(2838),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2838),
    [anon_sym_decltype] = ACTIONS(2838),
    [anon_sym_explicit] = ACTIONS(2838),
    [anon_sym_typename] = ACTIONS(2838),
    [anon_sym_template] = ACTIONS(2838),
    [anon_sym_operator] = ACTIONS(2838),
    [anon_sym_try] = ACTIONS(2838),
    [anon_sym_delete] = ACTIONS(2838),
    [anon_sym_throw] = ACTIONS(2838),
    [anon_sym_namespace] = ACTIONS(2838),
    [anon_sym_using] = ACTIONS(2838),
    [anon_sym_static_assert] = ACTIONS(2838),
    [anon_sym_concept] = ACTIONS(2838),
    [anon_sym_co_return] = ACTIONS(2838),
    [anon_sym_co_yield] = ACTIONS(2838),
    [anon_sym_R_DQUOTE] = ACTIONS(2840),
    [anon_sym_LR_DQUOTE] = ACTIONS(2840),
    [anon_sym_uR_DQUOTE] = ACTIONS(2840),
    [anon_sym_UR_DQUOTE] = ACTIONS(2840),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2840),
    [anon_sym_co_await] = ACTIONS(2838),
    [anon_sym_new] = ACTIONS(2838),
    [anon_sym_requires] = ACTIONS(2838),
    [sym_this] = ACTIONS(2838),
  },
  [298] = {
    [sym_identifier] = ACTIONS(2842),
    [aux_sym_preproc_include_token1] = ACTIONS(2842),
    [aux_sym_preproc_def_token1] = ACTIONS(2842),
    [aux_sym_preproc_if_token1] = ACTIONS(2842),
    [aux_sym_preproc_if_token2] = ACTIONS(2842),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2842),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2842),
    [aux_sym_preproc_else_token1] = ACTIONS(2842),
    [aux_sym_preproc_elif_token1] = ACTIONS(2842),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2842),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2842),
    [sym_preproc_directive] = ACTIONS(2842),
    [anon_sym_LPAREN2] = ACTIONS(2844),
    [anon_sym_BANG] = ACTIONS(2844),
    [anon_sym_TILDE] = ACTIONS(2844),
    [anon_sym_DASH] = ACTIONS(2842),
    [anon_sym_PLUS] = ACTIONS(2842),
    [anon_sym_STAR] = ACTIONS(2844),
    [anon_sym_AMP_AMP] = ACTIONS(2844),
    [anon_sym_AMP] = ACTIONS(2842),
    [anon_sym_SEMI] = ACTIONS(2844),
    [anon_sym___extension__] = ACTIONS(2842),
    [anon_sym_typedef] = ACTIONS(2842),
    [anon_sym_virtual] = ACTIONS(2842),
    [anon_sym_extern] = ACTIONS(2842),
    [anon_sym___attribute__] = ACTIONS(2842),
    [anon_sym___attribute] = ACTIONS(2842),
    [anon_sym_COLON_COLON] = ACTIONS(2844),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2844),
    [anon_sym___declspec] = ACTIONS(2842),
    [anon_sym___based] = ACTIONS(2842),
    [anon_sym___cdecl] = ACTIONS(2842),
    [anon_sym___clrcall] = ACTIONS(2842),
    [anon_sym___stdcall] = ACTIONS(2842),
    [anon_sym___fastcall] = ACTIONS(2842),
    [anon_sym___thiscall] = ACTIONS(2842),
    [anon_sym___vectorcall] = ACTIONS(2842),
    [anon_sym_LBRACE] = ACTIONS(2844),
    [anon_sym_signed] = ACTIONS(2842),
    [anon_sym_unsigned] = ACTIONS(2842),
    [anon_sym_long] = ACTIONS(2842),
    [anon_sym_short] = ACTIONS(2842),
    [anon_sym_LBRACK] = ACTIONS(2842),
    [anon_sym_static] = ACTIONS(2842),
    [anon_sym_register] = ACTIONS(2842),
    [anon_sym_inline] = ACTIONS(2842),
    [anon_sym___inline] = ACTIONS(2842),
    [anon_sym___inline__] = ACTIONS(2842),
    [anon_sym___forceinline] = ACTIONS(2842),
    [anon_sym_thread_local] = ACTIONS(2842),
    [anon_sym___thread] = ACTIONS(2842),
    [anon_sym_const] = ACTIONS(2842),
    [anon_sym_constexpr] = ACTIONS(2842),
    [anon_sym_volatile] = ACTIONS(2842),
    [anon_sym_restrict] = ACTIONS(2842),
    [anon_sym___restrict__] = ACTIONS(2842),
    [anon_sym__Atomic] = ACTIONS(2842),
    [anon_sym__Noreturn] = ACTIONS(2842),
    [anon_sym_noreturn] = ACTIONS(2842),
    [anon_sym__Nonnull] = ACTIONS(2842),
    [anon_sym_mutable] = ACTIONS(2842),
    [anon_sym_constinit] = ACTIONS(2842),
    [anon_sym_consteval] = ACTIONS(2842),
    [anon_sym_alignas] = ACTIONS(2842),
    [anon_sym__Alignas] = ACTIONS(2842),
    [sym_primitive_type] = ACTIONS(2842),
    [anon_sym_enum] = ACTIONS(2842),
    [anon_sym_class] = ACTIONS(2842),
    [anon_sym_struct] = ACTIONS(2842),
    [anon_sym_union] = ACTIONS(2842),
    [anon_sym_if] = ACTIONS(2842),
    [anon_sym_switch] = ACTIONS(2842),
    [anon_sym_case] = ACTIONS(2842),
    [anon_sym_default] = ACTIONS(2842),
    [anon_sym_while] = ACTIONS(2842),
    [anon_sym_do] = ACTIONS(2842),
    [anon_sym_for] = ACTIONS(2842),
    [anon_sym_return] = ACTIONS(2842),
    [anon_sym_break] = ACTIONS(2842),
    [anon_sym_continue] = ACTIONS(2842),
    [anon_sym_goto] = ACTIONS(2842),
    [anon_sym___try] = ACTIONS(2842),
    [anon_sym___leave] = ACTIONS(2842),
    [anon_sym_not] = ACTIONS(2842),
    [anon_sym_compl] = ACTIONS(2842),
    [anon_sym_DASH_DASH] = ACTIONS(2844),
    [anon_sym_PLUS_PLUS] = ACTIONS(2844),
    [anon_sym_sizeof] = ACTIONS(2842),
    [anon_sym___alignof__] = ACTIONS(2842),
    [anon_sym___alignof] = ACTIONS(2842),
    [anon_sym__alignof] = ACTIONS(2842),
    [anon_sym_alignof] = ACTIONS(2842),
    [anon_sym__Alignof] = ACTIONS(2842),
    [anon_sym_offsetof] = ACTIONS(2842),
    [anon_sym__Generic] = ACTIONS(2842),
    [anon_sym_asm] = ACTIONS(2842),
    [anon_sym___asm__] = ACTIONS(2842),
    [anon_sym___asm] = ACTIONS(2842),
    [sym_number_literal] = ACTIONS(2844),
    [anon_sym_L_SQUOTE] = ACTIONS(2844),
    [anon_sym_u_SQUOTE] = ACTIONS(2844),
    [anon_sym_U_SQUOTE] = ACTIONS(2844),
    [anon_sym_u8_SQUOTE] = ACTIONS(2844),
    [anon_sym_SQUOTE] = ACTIONS(2844),
    [anon_sym_L_DQUOTE] = ACTIONS(2844),
    [anon_sym_u_DQUOTE] = ACTIONS(2844),
    [anon_sym_U_DQUOTE] = ACTIONS(2844),
    [anon_sym_u8_DQUOTE] = ACTIONS(2844),
    [anon_sym_DQUOTE] = ACTIONS(2844),
    [sym_true] = ACTIONS(2842),
    [sym_false] = ACTIONS(2842),
    [anon_sym_NULL] = ACTIONS(2842),
    [anon_sym_nullptr] = ACTIONS(2842),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2842),
    [anon_sym_decltype] = ACTIONS(2842),
    [anon_sym_explicit] = ACTIONS(2842),
    [anon_sym_typename] = ACTIONS(2842),
    [anon_sym_template] = ACTIONS(2842),
    [anon_sym_operator] = ACTIONS(2842),
    [anon_sym_try] = ACTIONS(2842),
    [anon_sym_delete] = ACTIONS(2842),
    [anon_sym_throw] = ACTIONS(2842),
    [anon_sym_namespace] = ACTIONS(2842),
    [anon_sym_using] = ACTIONS(2842),
    [anon_sym_static_assert] = ACTIONS(2842),
    [anon_sym_concept] = ACTIONS(2842),
    [anon_sym_co_return] = ACTIONS(2842),
    [anon_sym_co_yield] = ACTIONS(2842),
    [anon_sym_R_DQUOTE] = ACTIONS(2844),
    [anon_sym_LR_DQUOTE] = ACTIONS(2844),
    [anon_sym_uR_DQUOTE] = ACTIONS(2844),
    [anon_sym_UR_DQUOTE] = ACTIONS(2844),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2844),
    [anon_sym_co_await] = ACTIONS(2842),
    [anon_sym_new] = ACTIONS(2842),
    [anon_sym_requires] = ACTIONS(2842),
    [sym_this] = ACTIONS(2842),
  },
  [299] = {
    [sym_identifier] = ACTIONS(2846),
    [aux_sym_preproc_include_token1] = ACTIONS(2846),
    [aux_sym_preproc_def_token1] = ACTIONS(2846),
    [aux_sym_preproc_if_token1] = ACTIONS(2846),
    [aux_sym_preproc_if_token2] = ACTIONS(2846),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2846),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2846),
    [aux_sym_preproc_else_token1] = ACTIONS(2846),
    [aux_sym_preproc_elif_token1] = ACTIONS(2846),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2846),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2846),
    [sym_preproc_directive] = ACTIONS(2846),
    [anon_sym_LPAREN2] = ACTIONS(2848),
    [anon_sym_BANG] = ACTIONS(2848),
    [anon_sym_TILDE] = ACTIONS(2848),
    [anon_sym_DASH] = ACTIONS(2846),
    [anon_sym_PLUS] = ACTIONS(2846),
    [anon_sym_STAR] = ACTIONS(2848),
    [anon_sym_AMP_AMP] = ACTIONS(2848),
    [anon_sym_AMP] = ACTIONS(2846),
    [anon_sym_SEMI] = ACTIONS(2848),
    [anon_sym___extension__] = ACTIONS(2846),
    [anon_sym_typedef] = ACTIONS(2846),
    [anon_sym_virtual] = ACTIONS(2846),
    [anon_sym_extern] = ACTIONS(2846),
    [anon_sym___attribute__] = ACTIONS(2846),
    [anon_sym___attribute] = ACTIONS(2846),
    [anon_sym_COLON_COLON] = ACTIONS(2848),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2848),
    [anon_sym___declspec] = ACTIONS(2846),
    [anon_sym___based] = ACTIONS(2846),
    [anon_sym___cdecl] = ACTIONS(2846),
    [anon_sym___clrcall] = ACTIONS(2846),
    [anon_sym___stdcall] = ACTIONS(2846),
    [anon_sym___fastcall] = ACTIONS(2846),
    [anon_sym___thiscall] = ACTIONS(2846),
    [anon_sym___vectorcall] = ACTIONS(2846),
    [anon_sym_LBRACE] = ACTIONS(2848),
    [anon_sym_signed] = ACTIONS(2846),
    [anon_sym_unsigned] = ACTIONS(2846),
    [anon_sym_long] = ACTIONS(2846),
    [anon_sym_short] = ACTIONS(2846),
    [anon_sym_LBRACK] = ACTIONS(2846),
    [anon_sym_static] = ACTIONS(2846),
    [anon_sym_register] = ACTIONS(2846),
    [anon_sym_inline] = ACTIONS(2846),
    [anon_sym___inline] = ACTIONS(2846),
    [anon_sym___inline__] = ACTIONS(2846),
    [anon_sym___forceinline] = ACTIONS(2846),
    [anon_sym_thread_local] = ACTIONS(2846),
    [anon_sym___thread] = ACTIONS(2846),
    [anon_sym_const] = ACTIONS(2846),
    [anon_sym_constexpr] = ACTIONS(2846),
    [anon_sym_volatile] = ACTIONS(2846),
    [anon_sym_restrict] = ACTIONS(2846),
    [anon_sym___restrict__] = ACTIONS(2846),
    [anon_sym__Atomic] = ACTIONS(2846),
    [anon_sym__Noreturn] = ACTIONS(2846),
    [anon_sym_noreturn] = ACTIONS(2846),
    [anon_sym__Nonnull] = ACTIONS(2846),
    [anon_sym_mutable] = ACTIONS(2846),
    [anon_sym_constinit] = ACTIONS(2846),
    [anon_sym_consteval] = ACTIONS(2846),
    [anon_sym_alignas] = ACTIONS(2846),
    [anon_sym__Alignas] = ACTIONS(2846),
    [sym_primitive_type] = ACTIONS(2846),
    [anon_sym_enum] = ACTIONS(2846),
    [anon_sym_class] = ACTIONS(2846),
    [anon_sym_struct] = ACTIONS(2846),
    [anon_sym_union] = ACTIONS(2846),
    [anon_sym_if] = ACTIONS(2846),
    [anon_sym_switch] = ACTIONS(2846),
    [anon_sym_case] = ACTIONS(2846),
    [anon_sym_default] = ACTIONS(2846),
    [anon_sym_while] = ACTIONS(2846),
    [anon_sym_do] = ACTIONS(2846),
    [anon_sym_for] = ACTIONS(2846),
    [anon_sym_return] = ACTIONS(2846),
    [anon_sym_break] = ACTIONS(2846),
    [anon_sym_continue] = ACTIONS(2846),
    [anon_sym_goto] = ACTIONS(2846),
    [anon_sym___try] = ACTIONS(2846),
    [anon_sym___leave] = ACTIONS(2846),
    [anon_sym_not] = ACTIONS(2846),
    [anon_sym_compl] = ACTIONS(2846),
    [anon_sym_DASH_DASH] = ACTIONS(2848),
    [anon_sym_PLUS_PLUS] = ACTIONS(2848),
    [anon_sym_sizeof] = ACTIONS(2846),
    [anon_sym___alignof__] = ACTIONS(2846),
    [anon_sym___alignof] = ACTIONS(2846),
    [anon_sym__alignof] = ACTIONS(2846),
    [anon_sym_alignof] = ACTIONS(2846),
    [anon_sym__Alignof] = ACTIONS(2846),
    [anon_sym_offsetof] = ACTIONS(2846),
    [anon_sym__Generic] = ACTIONS(2846),
    [anon_sym_asm] = ACTIONS(2846),
    [anon_sym___asm__] = ACTIONS(2846),
    [anon_sym___asm] = ACTIONS(2846),
    [sym_number_literal] = ACTIONS(2848),
    [anon_sym_L_SQUOTE] = ACTIONS(2848),
    [anon_sym_u_SQUOTE] = ACTIONS(2848),
    [anon_sym_U_SQUOTE] = ACTIONS(2848),
    [anon_sym_u8_SQUOTE] = ACTIONS(2848),
    [anon_sym_SQUOTE] = ACTIONS(2848),
    [anon_sym_L_DQUOTE] = ACTIONS(2848),
    [anon_sym_u_DQUOTE] = ACTIONS(2848),
    [anon_sym_U_DQUOTE] = ACTIONS(2848),
    [anon_sym_u8_DQUOTE] = ACTIONS(2848),
    [anon_sym_DQUOTE] = ACTIONS(2848),
    [sym_true] = ACTIONS(2846),
    [sym_false] = ACTIONS(2846),
    [anon_sym_NULL] = ACTIONS(2846),
    [anon_sym_nullptr] = ACTIONS(2846),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2846),
    [anon_sym_decltype] = ACTIONS(2846),
    [anon_sym_explicit] = ACTIONS(2846),
    [anon_sym_typename] = ACTIONS(2846),
    [anon_sym_template] = ACTIONS(2846),
    [anon_sym_operator] = ACTIONS(2846),
    [anon_sym_try] = ACTIONS(2846),
    [anon_sym_delete] = ACTIONS(2846),
    [anon_sym_throw] = ACTIONS(2846),
    [anon_sym_namespace] = ACTIONS(2846),
    [anon_sym_using] = ACTIONS(2846),
    [anon_sym_static_assert] = ACTIONS(2846),
    [anon_sym_concept] = ACTIONS(2846),
    [anon_sym_co_return] = ACTIONS(2846),
    [anon_sym_co_yield] = ACTIONS(2846),
    [anon_sym_R_DQUOTE] = ACTIONS(2848),
    [anon_sym_LR_DQUOTE] = ACTIONS(2848),
    [anon_sym_uR_DQUOTE] = ACTIONS(2848),
    [anon_sym_UR_DQUOTE] = ACTIONS(2848),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2848),
    [anon_sym_co_await] = ACTIONS(2846),
    [anon_sym_new] = ACTIONS(2846),
    [anon_sym_requires] = ACTIONS(2846),
    [sym_this] = ACTIONS(2846),
  },
  [300] = {
    [sym_identifier] = ACTIONS(2850),
    [aux_sym_preproc_include_token1] = ACTIONS(2850),
    [aux_sym_preproc_def_token1] = ACTIONS(2850),
    [aux_sym_preproc_if_token1] = ACTIONS(2850),
    [aux_sym_preproc_if_token2] = ACTIONS(2850),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2850),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2850),
    [aux_sym_preproc_else_token1] = ACTIONS(2850),
    [aux_sym_preproc_elif_token1] = ACTIONS(2850),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2850),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2850),
    [sym_preproc_directive] = ACTIONS(2850),
    [anon_sym_LPAREN2] = ACTIONS(2852),
    [anon_sym_BANG] = ACTIONS(2852),
    [anon_sym_TILDE] = ACTIONS(2852),
    [anon_sym_DASH] = ACTIONS(2850),
    [anon_sym_PLUS] = ACTIONS(2850),
    [anon_sym_STAR] = ACTIONS(2852),
    [anon_sym_AMP_AMP] = ACTIONS(2852),
    [anon_sym_AMP] = ACTIONS(2850),
    [anon_sym_SEMI] = ACTIONS(2852),
    [anon_sym___extension__] = ACTIONS(2850),
    [anon_sym_typedef] = ACTIONS(2850),
    [anon_sym_virtual] = ACTIONS(2850),
    [anon_sym_extern] = ACTIONS(2850),
    [anon_sym___attribute__] = ACTIONS(2850),
    [anon_sym___attribute] = ACTIONS(2850),
    [anon_sym_COLON_COLON] = ACTIONS(2852),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2852),
    [anon_sym___declspec] = ACTIONS(2850),
    [anon_sym___based] = ACTIONS(2850),
    [anon_sym___cdecl] = ACTIONS(2850),
    [anon_sym___clrcall] = ACTIONS(2850),
    [anon_sym___stdcall] = ACTIONS(2850),
    [anon_sym___fastcall] = ACTIONS(2850),
    [anon_sym___thiscall] = ACTIONS(2850),
    [anon_sym___vectorcall] = ACTIONS(2850),
    [anon_sym_LBRACE] = ACTIONS(2852),
    [anon_sym_signed] = ACTIONS(2850),
    [anon_sym_unsigned] = ACTIONS(2850),
    [anon_sym_long] = ACTIONS(2850),
    [anon_sym_short] = ACTIONS(2850),
    [anon_sym_LBRACK] = ACTIONS(2850),
    [anon_sym_static] = ACTIONS(2850),
    [anon_sym_register] = ACTIONS(2850),
    [anon_sym_inline] = ACTIONS(2850),
    [anon_sym___inline] = ACTIONS(2850),
    [anon_sym___inline__] = ACTIONS(2850),
    [anon_sym___forceinline] = ACTIONS(2850),
    [anon_sym_thread_local] = ACTIONS(2850),
    [anon_sym___thread] = ACTIONS(2850),
    [anon_sym_const] = ACTIONS(2850),
    [anon_sym_constexpr] = ACTIONS(2850),
    [anon_sym_volatile] = ACTIONS(2850),
    [anon_sym_restrict] = ACTIONS(2850),
    [anon_sym___restrict__] = ACTIONS(2850),
    [anon_sym__Atomic] = ACTIONS(2850),
    [anon_sym__Noreturn] = ACTIONS(2850),
    [anon_sym_noreturn] = ACTIONS(2850),
    [anon_sym__Nonnull] = ACTIONS(2850),
    [anon_sym_mutable] = ACTIONS(2850),
    [anon_sym_constinit] = ACTIONS(2850),
    [anon_sym_consteval] = ACTIONS(2850),
    [anon_sym_alignas] = ACTIONS(2850),
    [anon_sym__Alignas] = ACTIONS(2850),
    [sym_primitive_type] = ACTIONS(2850),
    [anon_sym_enum] = ACTIONS(2850),
    [anon_sym_class] = ACTIONS(2850),
    [anon_sym_struct] = ACTIONS(2850),
    [anon_sym_union] = ACTIONS(2850),
    [anon_sym_if] = ACTIONS(2850),
    [anon_sym_switch] = ACTIONS(2850),
    [anon_sym_case] = ACTIONS(2850),
    [anon_sym_default] = ACTIONS(2850),
    [anon_sym_while] = ACTIONS(2850),
    [anon_sym_do] = ACTIONS(2850),
    [anon_sym_for] = ACTIONS(2850),
    [anon_sym_return] = ACTIONS(2850),
    [anon_sym_break] = ACTIONS(2850),
    [anon_sym_continue] = ACTIONS(2850),
    [anon_sym_goto] = ACTIONS(2850),
    [anon_sym___try] = ACTIONS(2850),
    [anon_sym___leave] = ACTIONS(2850),
    [anon_sym_not] = ACTIONS(2850),
    [anon_sym_compl] = ACTIONS(2850),
    [anon_sym_DASH_DASH] = ACTIONS(2852),
    [anon_sym_PLUS_PLUS] = ACTIONS(2852),
    [anon_sym_sizeof] = ACTIONS(2850),
    [anon_sym___alignof__] = ACTIONS(2850),
    [anon_sym___alignof] = ACTIONS(2850),
    [anon_sym__alignof] = ACTIONS(2850),
    [anon_sym_alignof] = ACTIONS(2850),
    [anon_sym__Alignof] = ACTIONS(2850),
    [anon_sym_offsetof] = ACTIONS(2850),
    [anon_sym__Generic] = ACTIONS(2850),
    [anon_sym_asm] = ACTIONS(2850),
    [anon_sym___asm__] = ACTIONS(2850),
    [anon_sym___asm] = ACTIONS(2850),
    [sym_number_literal] = ACTIONS(2852),
    [anon_sym_L_SQUOTE] = ACTIONS(2852),
    [anon_sym_u_SQUOTE] = ACTIONS(2852),
    [anon_sym_U_SQUOTE] = ACTIONS(2852),
    [anon_sym_u8_SQUOTE] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2852),
    [anon_sym_L_DQUOTE] = ACTIONS(2852),
    [anon_sym_u_DQUOTE] = ACTIONS(2852),
    [anon_sym_U_DQUOTE] = ACTIONS(2852),
    [anon_sym_u8_DQUOTE] = ACTIONS(2852),
    [anon_sym_DQUOTE] = ACTIONS(2852),
    [sym_true] = ACTIONS(2850),
    [sym_false] = ACTIONS(2850),
    [anon_sym_NULL] = ACTIONS(2850),
    [anon_sym_nullptr] = ACTIONS(2850),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2850),
    [anon_sym_decltype] = ACTIONS(2850),
    [anon_sym_explicit] = ACTIONS(2850),
    [anon_sym_typename] = ACTIONS(2850),
    [anon_sym_template] = ACTIONS(2850),
    [anon_sym_operator] = ACTIONS(2850),
    [anon_sym_try] = ACTIONS(2850),
    [anon_sym_delete] = ACTIONS(2850),
    [anon_sym_throw] = ACTIONS(2850),
    [anon_sym_namespace] = ACTIONS(2850),
    [anon_sym_using] = ACTIONS(2850),
    [anon_sym_static_assert] = ACTIONS(2850),
    [anon_sym_concept] = ACTIONS(2850),
    [anon_sym_co_return] = ACTIONS(2850),
    [anon_sym_co_yield] = ACTIONS(2850),
    [anon_sym_R_DQUOTE] = ACTIONS(2852),
    [anon_sym_LR_DQUOTE] = ACTIONS(2852),
    [anon_sym_uR_DQUOTE] = ACTIONS(2852),
    [anon_sym_UR_DQUOTE] = ACTIONS(2852),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2852),
    [anon_sym_co_await] = ACTIONS(2850),
    [anon_sym_new] = ACTIONS(2850),
    [anon_sym_requires] = ACTIONS(2850),
    [sym_this] = ACTIONS(2850),
  },
  [301] = {
    [sym_type_qualifier] = STATE(3798),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4559),
    [sym_sized_type_specifier] = STATE(2651),
    [sym_enum_specifier] = STATE(2651),
    [sym_struct_specifier] = STATE(2651),
    [sym_union_specifier] = STATE(2651),
    [sym_expression] = STATE(4278),
    [sym__string] = STATE(4637),
    [sym_conditional_expression] = STATE(4735),
    [sym_assignment_expression] = STATE(4735),
    [sym_pointer_expression] = STATE(3573),
    [sym_unary_expression] = STATE(4735),
    [sym_binary_expression] = STATE(4735),
    [sym_update_expression] = STATE(4735),
    [sym_cast_expression] = STATE(4735),
    [sym_type_descriptor] = STATE(6919),
    [sym_sizeof_expression] = STATE(4735),
    [sym_alignof_expression] = STATE(4735),
    [sym_offsetof_expression] = STATE(4735),
    [sym_generic_expression] = STATE(4735),
    [sym_subscript_expression] = STATE(3573),
    [sym_call_expression] = STATE(3573),
    [sym_gnu_asm_expression] = STATE(4735),
    [sym_extension_expression] = STATE(4735),
    [sym_field_expression] = STATE(3573),
    [sym_compound_literal_expression] = STATE(4735),
    [sym_parenthesized_expression] = STATE(3573),
    [sym_char_literal] = STATE(4637),
    [sym_concatenated_string] = STATE(4637),
    [sym_string_literal] = STATE(3662),
    [sym_null] = STATE(4735),
    [sym_placeholder_type_specifier] = STATE(2651),
    [sym_decltype_auto] = STATE(2637),
    [sym_decltype] = STATE(2563),
    [sym_class_specifier] = STATE(2651),
    [sym__class_name] = STATE(7513),
    [sym_dependent_type] = STATE(2651),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(4735),
    [sym_raw_string_literal] = STATE(3662),
    [sym_co_await_expression] = STATE(4735),
    [sym_new_expression] = STATE(4735),
    [sym_delete_expression] = STATE(4735),
    [sym_requires_clause] = STATE(4735),
    [sym_requires_expression] = STATE(4735),
    [sym_lambda_expression] = STATE(4735),
    [sym_lambda_capture_specifier] = STATE(5854),
    [sym_fold_expression] = STATE(4735),
    [sym_parameter_pack_expansion] = STATE(4735),
    [sym_type_parameter_pack_expansion] = STATE(7118),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5693),
    [sym_qualified_identifier] = STATE(3573),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym_user_defined_literal] = STATE(3573),
    [aux_sym__type_definition_type_repeat1] = STATE(3798),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4167),
    [sym_identifier] = ACTIONS(2854),
    [anon_sym_LPAREN2] = ACTIONS(2856),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(2864),
    [anon_sym_COLON_COLON] = ACTIONS(2866),
    [anon_sym_signed] = ACTIONS(2868),
    [anon_sym_unsigned] = ACTIONS(2868),
    [anon_sym_long] = ACTIONS(2868),
    [anon_sym_short] = ACTIONS(2868),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(2870),
    [anon_sym_enum] = ACTIONS(2872),
    [anon_sym_class] = ACTIONS(2874),
    [anon_sym_struct] = ACTIONS(2876),
    [anon_sym_union] = ACTIONS(2878),
    [anon_sym_not] = ACTIONS(2860),
    [anon_sym_compl] = ACTIONS(2860),
    [anon_sym_DASH_DASH] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(2880),
    [anon_sym_sizeof] = ACTIONS(2882),
    [anon_sym___alignof__] = ACTIONS(2884),
    [anon_sym___alignof] = ACTIONS(2884),
    [anon_sym__alignof] = ACTIONS(2884),
    [anon_sym_alignof] = ACTIONS(2884),
    [anon_sym__Alignof] = ACTIONS(2884),
    [anon_sym_offsetof] = ACTIONS(2886),
    [anon_sym__Generic] = ACTIONS(2888),
    [anon_sym_asm] = ACTIONS(2890),
    [anon_sym___asm__] = ACTIONS(2890),
    [anon_sym___asm] = ACTIONS(2890),
    [sym_number_literal] = ACTIONS(2892),
    [anon_sym_L_SQUOTE] = ACTIONS(2894),
    [anon_sym_u_SQUOTE] = ACTIONS(2894),
    [anon_sym_U_SQUOTE] = ACTIONS(2894),
    [anon_sym_u8_SQUOTE] = ACTIONS(2894),
    [anon_sym_SQUOTE] = ACTIONS(2894),
    [anon_sym_L_DQUOTE] = ACTIONS(2896),
    [anon_sym_u_DQUOTE] = ACTIONS(2896),
    [anon_sym_U_DQUOTE] = ACTIONS(2896),
    [anon_sym_u8_DQUOTE] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [anon_sym_NULL] = ACTIONS(2900),
    [anon_sym_nullptr] = ACTIONS(2900),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2902),
    [anon_sym_decltype] = ACTIONS(2904),
    [anon_sym_typename] = ACTIONS(2906),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_GT2] = ACTIONS(2908),
    [anon_sym_delete] = ACTIONS(2910),
    [anon_sym_R_DQUOTE] = ACTIONS(2912),
    [anon_sym_LR_DQUOTE] = ACTIONS(2912),
    [anon_sym_uR_DQUOTE] = ACTIONS(2912),
    [anon_sym_UR_DQUOTE] = ACTIONS(2912),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2912),
    [anon_sym_co_await] = ACTIONS(2914),
    [anon_sym_new] = ACTIONS(2916),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2898),
  },
  [302] = {
    [sym_identifier] = ACTIONS(2920),
    [aux_sym_preproc_include_token1] = ACTIONS(2920),
    [aux_sym_preproc_def_token1] = ACTIONS(2920),
    [aux_sym_preproc_if_token1] = ACTIONS(2920),
    [aux_sym_preproc_if_token2] = ACTIONS(2920),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2920),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2920),
    [aux_sym_preproc_else_token1] = ACTIONS(2920),
    [aux_sym_preproc_elif_token1] = ACTIONS(2920),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2920),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2920),
    [sym_preproc_directive] = ACTIONS(2920),
    [anon_sym_LPAREN2] = ACTIONS(2922),
    [anon_sym_BANG] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2922),
    [anon_sym_DASH] = ACTIONS(2920),
    [anon_sym_PLUS] = ACTIONS(2920),
    [anon_sym_STAR] = ACTIONS(2922),
    [anon_sym_AMP_AMP] = ACTIONS(2922),
    [anon_sym_AMP] = ACTIONS(2920),
    [anon_sym_SEMI] = ACTIONS(2922),
    [anon_sym___extension__] = ACTIONS(2920),
    [anon_sym_typedef] = ACTIONS(2920),
    [anon_sym_virtual] = ACTIONS(2920),
    [anon_sym_extern] = ACTIONS(2920),
    [anon_sym___attribute__] = ACTIONS(2920),
    [anon_sym___attribute] = ACTIONS(2920),
    [anon_sym_COLON_COLON] = ACTIONS(2922),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2922),
    [anon_sym___declspec] = ACTIONS(2920),
    [anon_sym___based] = ACTIONS(2920),
    [anon_sym___cdecl] = ACTIONS(2920),
    [anon_sym___clrcall] = ACTIONS(2920),
    [anon_sym___stdcall] = ACTIONS(2920),
    [anon_sym___fastcall] = ACTIONS(2920),
    [anon_sym___thiscall] = ACTIONS(2920),
    [anon_sym___vectorcall] = ACTIONS(2920),
    [anon_sym_LBRACE] = ACTIONS(2922),
    [anon_sym_signed] = ACTIONS(2920),
    [anon_sym_unsigned] = ACTIONS(2920),
    [anon_sym_long] = ACTIONS(2920),
    [anon_sym_short] = ACTIONS(2920),
    [anon_sym_LBRACK] = ACTIONS(2920),
    [anon_sym_static] = ACTIONS(2920),
    [anon_sym_register] = ACTIONS(2920),
    [anon_sym_inline] = ACTIONS(2920),
    [anon_sym___inline] = ACTIONS(2920),
    [anon_sym___inline__] = ACTIONS(2920),
    [anon_sym___forceinline] = ACTIONS(2920),
    [anon_sym_thread_local] = ACTIONS(2920),
    [anon_sym___thread] = ACTIONS(2920),
    [anon_sym_const] = ACTIONS(2920),
    [anon_sym_constexpr] = ACTIONS(2920),
    [anon_sym_volatile] = ACTIONS(2920),
    [anon_sym_restrict] = ACTIONS(2920),
    [anon_sym___restrict__] = ACTIONS(2920),
    [anon_sym__Atomic] = ACTIONS(2920),
    [anon_sym__Noreturn] = ACTIONS(2920),
    [anon_sym_noreturn] = ACTIONS(2920),
    [anon_sym__Nonnull] = ACTIONS(2920),
    [anon_sym_mutable] = ACTIONS(2920),
    [anon_sym_constinit] = ACTIONS(2920),
    [anon_sym_consteval] = ACTIONS(2920),
    [anon_sym_alignas] = ACTIONS(2920),
    [anon_sym__Alignas] = ACTIONS(2920),
    [sym_primitive_type] = ACTIONS(2920),
    [anon_sym_enum] = ACTIONS(2920),
    [anon_sym_class] = ACTIONS(2920),
    [anon_sym_struct] = ACTIONS(2920),
    [anon_sym_union] = ACTIONS(2920),
    [anon_sym_if] = ACTIONS(2920),
    [anon_sym_switch] = ACTIONS(2920),
    [anon_sym_case] = ACTIONS(2920),
    [anon_sym_default] = ACTIONS(2920),
    [anon_sym_while] = ACTIONS(2920),
    [anon_sym_do] = ACTIONS(2920),
    [anon_sym_for] = ACTIONS(2920),
    [anon_sym_return] = ACTIONS(2920),
    [anon_sym_break] = ACTIONS(2920),
    [anon_sym_continue] = ACTIONS(2920),
    [anon_sym_goto] = ACTIONS(2920),
    [anon_sym___try] = ACTIONS(2920),
    [anon_sym___leave] = ACTIONS(2920),
    [anon_sym_not] = ACTIONS(2920),
    [anon_sym_compl] = ACTIONS(2920),
    [anon_sym_DASH_DASH] = ACTIONS(2922),
    [anon_sym_PLUS_PLUS] = ACTIONS(2922),
    [anon_sym_sizeof] = ACTIONS(2920),
    [anon_sym___alignof__] = ACTIONS(2920),
    [anon_sym___alignof] = ACTIONS(2920),
    [anon_sym__alignof] = ACTIONS(2920),
    [anon_sym_alignof] = ACTIONS(2920),
    [anon_sym__Alignof] = ACTIONS(2920),
    [anon_sym_offsetof] = ACTIONS(2920),
    [anon_sym__Generic] = ACTIONS(2920),
    [anon_sym_asm] = ACTIONS(2920),
    [anon_sym___asm__] = ACTIONS(2920),
    [anon_sym___asm] = ACTIONS(2920),
    [sym_number_literal] = ACTIONS(2922),
    [anon_sym_L_SQUOTE] = ACTIONS(2922),
    [anon_sym_u_SQUOTE] = ACTIONS(2922),
    [anon_sym_U_SQUOTE] = ACTIONS(2922),
    [anon_sym_u8_SQUOTE] = ACTIONS(2922),
    [anon_sym_SQUOTE] = ACTIONS(2922),
    [anon_sym_L_DQUOTE] = ACTIONS(2922),
    [anon_sym_u_DQUOTE] = ACTIONS(2922),
    [anon_sym_U_DQUOTE] = ACTIONS(2922),
    [anon_sym_u8_DQUOTE] = ACTIONS(2922),
    [anon_sym_DQUOTE] = ACTIONS(2922),
    [sym_true] = ACTIONS(2920),
    [sym_false] = ACTIONS(2920),
    [anon_sym_NULL] = ACTIONS(2920),
    [anon_sym_nullptr] = ACTIONS(2920),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2920),
    [anon_sym_decltype] = ACTIONS(2920),
    [anon_sym_explicit] = ACTIONS(2920),
    [anon_sym_typename] = ACTIONS(2920),
    [anon_sym_template] = ACTIONS(2920),
    [anon_sym_operator] = ACTIONS(2920),
    [anon_sym_try] = ACTIONS(2920),
    [anon_sym_delete] = ACTIONS(2920),
    [anon_sym_throw] = ACTIONS(2920),
    [anon_sym_namespace] = ACTIONS(2920),
    [anon_sym_using] = ACTIONS(2920),
    [anon_sym_static_assert] = ACTIONS(2920),
    [anon_sym_concept] = ACTIONS(2920),
    [anon_sym_co_return] = ACTIONS(2920),
    [anon_sym_co_yield] = ACTIONS(2920),
    [anon_sym_R_DQUOTE] = ACTIONS(2922),
    [anon_sym_LR_DQUOTE] = ACTIONS(2922),
    [anon_sym_uR_DQUOTE] = ACTIONS(2922),
    [anon_sym_UR_DQUOTE] = ACTIONS(2922),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2922),
    [anon_sym_co_await] = ACTIONS(2920),
    [anon_sym_new] = ACTIONS(2920),
    [anon_sym_requires] = ACTIONS(2920),
    [sym_this] = ACTIONS(2920),
  },
  [303] = {
    [sym_identifier] = ACTIONS(2924),
    [aux_sym_preproc_include_token1] = ACTIONS(2924),
    [aux_sym_preproc_def_token1] = ACTIONS(2924),
    [aux_sym_preproc_if_token1] = ACTIONS(2924),
    [aux_sym_preproc_if_token2] = ACTIONS(2924),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2924),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2924),
    [aux_sym_preproc_else_token1] = ACTIONS(2924),
    [aux_sym_preproc_elif_token1] = ACTIONS(2924),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2924),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2924),
    [sym_preproc_directive] = ACTIONS(2924),
    [anon_sym_LPAREN2] = ACTIONS(2926),
    [anon_sym_BANG] = ACTIONS(2926),
    [anon_sym_TILDE] = ACTIONS(2926),
    [anon_sym_DASH] = ACTIONS(2924),
    [anon_sym_PLUS] = ACTIONS(2924),
    [anon_sym_STAR] = ACTIONS(2926),
    [anon_sym_AMP_AMP] = ACTIONS(2926),
    [anon_sym_AMP] = ACTIONS(2924),
    [anon_sym_SEMI] = ACTIONS(2926),
    [anon_sym___extension__] = ACTIONS(2924),
    [anon_sym_typedef] = ACTIONS(2924),
    [anon_sym_virtual] = ACTIONS(2924),
    [anon_sym_extern] = ACTIONS(2924),
    [anon_sym___attribute__] = ACTIONS(2924),
    [anon_sym___attribute] = ACTIONS(2924),
    [anon_sym_COLON_COLON] = ACTIONS(2926),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2926),
    [anon_sym___declspec] = ACTIONS(2924),
    [anon_sym___based] = ACTIONS(2924),
    [anon_sym___cdecl] = ACTIONS(2924),
    [anon_sym___clrcall] = ACTIONS(2924),
    [anon_sym___stdcall] = ACTIONS(2924),
    [anon_sym___fastcall] = ACTIONS(2924),
    [anon_sym___thiscall] = ACTIONS(2924),
    [anon_sym___vectorcall] = ACTIONS(2924),
    [anon_sym_LBRACE] = ACTIONS(2926),
    [anon_sym_signed] = ACTIONS(2924),
    [anon_sym_unsigned] = ACTIONS(2924),
    [anon_sym_long] = ACTIONS(2924),
    [anon_sym_short] = ACTIONS(2924),
    [anon_sym_LBRACK] = ACTIONS(2924),
    [anon_sym_static] = ACTIONS(2924),
    [anon_sym_register] = ACTIONS(2924),
    [anon_sym_inline] = ACTIONS(2924),
    [anon_sym___inline] = ACTIONS(2924),
    [anon_sym___inline__] = ACTIONS(2924),
    [anon_sym___forceinline] = ACTIONS(2924),
    [anon_sym_thread_local] = ACTIONS(2924),
    [anon_sym___thread] = ACTIONS(2924),
    [anon_sym_const] = ACTIONS(2924),
    [anon_sym_constexpr] = ACTIONS(2924),
    [anon_sym_volatile] = ACTIONS(2924),
    [anon_sym_restrict] = ACTIONS(2924),
    [anon_sym___restrict__] = ACTIONS(2924),
    [anon_sym__Atomic] = ACTIONS(2924),
    [anon_sym__Noreturn] = ACTIONS(2924),
    [anon_sym_noreturn] = ACTIONS(2924),
    [anon_sym__Nonnull] = ACTIONS(2924),
    [anon_sym_mutable] = ACTIONS(2924),
    [anon_sym_constinit] = ACTIONS(2924),
    [anon_sym_consteval] = ACTIONS(2924),
    [anon_sym_alignas] = ACTIONS(2924),
    [anon_sym__Alignas] = ACTIONS(2924),
    [sym_primitive_type] = ACTIONS(2924),
    [anon_sym_enum] = ACTIONS(2924),
    [anon_sym_class] = ACTIONS(2924),
    [anon_sym_struct] = ACTIONS(2924),
    [anon_sym_union] = ACTIONS(2924),
    [anon_sym_if] = ACTIONS(2924),
    [anon_sym_switch] = ACTIONS(2924),
    [anon_sym_case] = ACTIONS(2924),
    [anon_sym_default] = ACTIONS(2924),
    [anon_sym_while] = ACTIONS(2924),
    [anon_sym_do] = ACTIONS(2924),
    [anon_sym_for] = ACTIONS(2924),
    [anon_sym_return] = ACTIONS(2924),
    [anon_sym_break] = ACTIONS(2924),
    [anon_sym_continue] = ACTIONS(2924),
    [anon_sym_goto] = ACTIONS(2924),
    [anon_sym___try] = ACTIONS(2924),
    [anon_sym___leave] = ACTIONS(2924),
    [anon_sym_not] = ACTIONS(2924),
    [anon_sym_compl] = ACTIONS(2924),
    [anon_sym_DASH_DASH] = ACTIONS(2926),
    [anon_sym_PLUS_PLUS] = ACTIONS(2926),
    [anon_sym_sizeof] = ACTIONS(2924),
    [anon_sym___alignof__] = ACTIONS(2924),
    [anon_sym___alignof] = ACTIONS(2924),
    [anon_sym__alignof] = ACTIONS(2924),
    [anon_sym_alignof] = ACTIONS(2924),
    [anon_sym__Alignof] = ACTIONS(2924),
    [anon_sym_offsetof] = ACTIONS(2924),
    [anon_sym__Generic] = ACTIONS(2924),
    [anon_sym_asm] = ACTIONS(2924),
    [anon_sym___asm__] = ACTIONS(2924),
    [anon_sym___asm] = ACTIONS(2924),
    [sym_number_literal] = ACTIONS(2926),
    [anon_sym_L_SQUOTE] = ACTIONS(2926),
    [anon_sym_u_SQUOTE] = ACTIONS(2926),
    [anon_sym_U_SQUOTE] = ACTIONS(2926),
    [anon_sym_u8_SQUOTE] = ACTIONS(2926),
    [anon_sym_SQUOTE] = ACTIONS(2926),
    [anon_sym_L_DQUOTE] = ACTIONS(2926),
    [anon_sym_u_DQUOTE] = ACTIONS(2926),
    [anon_sym_U_DQUOTE] = ACTIONS(2926),
    [anon_sym_u8_DQUOTE] = ACTIONS(2926),
    [anon_sym_DQUOTE] = ACTIONS(2926),
    [sym_true] = ACTIONS(2924),
    [sym_false] = ACTIONS(2924),
    [anon_sym_NULL] = ACTIONS(2924),
    [anon_sym_nullptr] = ACTIONS(2924),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2924),
    [anon_sym_decltype] = ACTIONS(2924),
    [anon_sym_explicit] = ACTIONS(2924),
    [anon_sym_typename] = ACTIONS(2924),
    [anon_sym_template] = ACTIONS(2924),
    [anon_sym_operator] = ACTIONS(2924),
    [anon_sym_try] = ACTIONS(2924),
    [anon_sym_delete] = ACTIONS(2924),
    [anon_sym_throw] = ACTIONS(2924),
    [anon_sym_namespace] = ACTIONS(2924),
    [anon_sym_using] = ACTIONS(2924),
    [anon_sym_static_assert] = ACTIONS(2924),
    [anon_sym_concept] = ACTIONS(2924),
    [anon_sym_co_return] = ACTIONS(2924),
    [anon_sym_co_yield] = ACTIONS(2924),
    [anon_sym_R_DQUOTE] = ACTIONS(2926),
    [anon_sym_LR_DQUOTE] = ACTIONS(2926),
    [anon_sym_uR_DQUOTE] = ACTIONS(2926),
    [anon_sym_UR_DQUOTE] = ACTIONS(2926),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2926),
    [anon_sym_co_await] = ACTIONS(2924),
    [anon_sym_new] = ACTIONS(2924),
    [anon_sym_requires] = ACTIONS(2924),
    [sym_this] = ACTIONS(2924),
  },
  [304] = {
    [sym_identifier] = ACTIONS(2928),
    [aux_sym_preproc_include_token1] = ACTIONS(2928),
    [aux_sym_preproc_def_token1] = ACTIONS(2928),
    [aux_sym_preproc_if_token1] = ACTIONS(2928),
    [aux_sym_preproc_if_token2] = ACTIONS(2928),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2928),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2928),
    [aux_sym_preproc_else_token1] = ACTIONS(2928),
    [aux_sym_preproc_elif_token1] = ACTIONS(2928),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2928),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2928),
    [sym_preproc_directive] = ACTIONS(2928),
    [anon_sym_LPAREN2] = ACTIONS(2930),
    [anon_sym_BANG] = ACTIONS(2930),
    [anon_sym_TILDE] = ACTIONS(2930),
    [anon_sym_DASH] = ACTIONS(2928),
    [anon_sym_PLUS] = ACTIONS(2928),
    [anon_sym_STAR] = ACTIONS(2930),
    [anon_sym_AMP_AMP] = ACTIONS(2930),
    [anon_sym_AMP] = ACTIONS(2928),
    [anon_sym_SEMI] = ACTIONS(2930),
    [anon_sym___extension__] = ACTIONS(2928),
    [anon_sym_typedef] = ACTIONS(2928),
    [anon_sym_virtual] = ACTIONS(2928),
    [anon_sym_extern] = ACTIONS(2928),
    [anon_sym___attribute__] = ACTIONS(2928),
    [anon_sym___attribute] = ACTIONS(2928),
    [anon_sym_COLON_COLON] = ACTIONS(2930),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2930),
    [anon_sym___declspec] = ACTIONS(2928),
    [anon_sym___based] = ACTIONS(2928),
    [anon_sym___cdecl] = ACTIONS(2928),
    [anon_sym___clrcall] = ACTIONS(2928),
    [anon_sym___stdcall] = ACTIONS(2928),
    [anon_sym___fastcall] = ACTIONS(2928),
    [anon_sym___thiscall] = ACTIONS(2928),
    [anon_sym___vectorcall] = ACTIONS(2928),
    [anon_sym_LBRACE] = ACTIONS(2930),
    [anon_sym_signed] = ACTIONS(2928),
    [anon_sym_unsigned] = ACTIONS(2928),
    [anon_sym_long] = ACTIONS(2928),
    [anon_sym_short] = ACTIONS(2928),
    [anon_sym_LBRACK] = ACTIONS(2928),
    [anon_sym_static] = ACTIONS(2928),
    [anon_sym_register] = ACTIONS(2928),
    [anon_sym_inline] = ACTIONS(2928),
    [anon_sym___inline] = ACTIONS(2928),
    [anon_sym___inline__] = ACTIONS(2928),
    [anon_sym___forceinline] = ACTIONS(2928),
    [anon_sym_thread_local] = ACTIONS(2928),
    [anon_sym___thread] = ACTIONS(2928),
    [anon_sym_const] = ACTIONS(2928),
    [anon_sym_constexpr] = ACTIONS(2928),
    [anon_sym_volatile] = ACTIONS(2928),
    [anon_sym_restrict] = ACTIONS(2928),
    [anon_sym___restrict__] = ACTIONS(2928),
    [anon_sym__Atomic] = ACTIONS(2928),
    [anon_sym__Noreturn] = ACTIONS(2928),
    [anon_sym_noreturn] = ACTIONS(2928),
    [anon_sym__Nonnull] = ACTIONS(2928),
    [anon_sym_mutable] = ACTIONS(2928),
    [anon_sym_constinit] = ACTIONS(2928),
    [anon_sym_consteval] = ACTIONS(2928),
    [anon_sym_alignas] = ACTIONS(2928),
    [anon_sym__Alignas] = ACTIONS(2928),
    [sym_primitive_type] = ACTIONS(2928),
    [anon_sym_enum] = ACTIONS(2928),
    [anon_sym_class] = ACTIONS(2928),
    [anon_sym_struct] = ACTIONS(2928),
    [anon_sym_union] = ACTIONS(2928),
    [anon_sym_if] = ACTIONS(2928),
    [anon_sym_switch] = ACTIONS(2928),
    [anon_sym_case] = ACTIONS(2928),
    [anon_sym_default] = ACTIONS(2928),
    [anon_sym_while] = ACTIONS(2928),
    [anon_sym_do] = ACTIONS(2928),
    [anon_sym_for] = ACTIONS(2928),
    [anon_sym_return] = ACTIONS(2928),
    [anon_sym_break] = ACTIONS(2928),
    [anon_sym_continue] = ACTIONS(2928),
    [anon_sym_goto] = ACTIONS(2928),
    [anon_sym___try] = ACTIONS(2928),
    [anon_sym___leave] = ACTIONS(2928),
    [anon_sym_not] = ACTIONS(2928),
    [anon_sym_compl] = ACTIONS(2928),
    [anon_sym_DASH_DASH] = ACTIONS(2930),
    [anon_sym_PLUS_PLUS] = ACTIONS(2930),
    [anon_sym_sizeof] = ACTIONS(2928),
    [anon_sym___alignof__] = ACTIONS(2928),
    [anon_sym___alignof] = ACTIONS(2928),
    [anon_sym__alignof] = ACTIONS(2928),
    [anon_sym_alignof] = ACTIONS(2928),
    [anon_sym__Alignof] = ACTIONS(2928),
    [anon_sym_offsetof] = ACTIONS(2928),
    [anon_sym__Generic] = ACTIONS(2928),
    [anon_sym_asm] = ACTIONS(2928),
    [anon_sym___asm__] = ACTIONS(2928),
    [anon_sym___asm] = ACTIONS(2928),
    [sym_number_literal] = ACTIONS(2930),
    [anon_sym_L_SQUOTE] = ACTIONS(2930),
    [anon_sym_u_SQUOTE] = ACTIONS(2930),
    [anon_sym_U_SQUOTE] = ACTIONS(2930),
    [anon_sym_u8_SQUOTE] = ACTIONS(2930),
    [anon_sym_SQUOTE] = ACTIONS(2930),
    [anon_sym_L_DQUOTE] = ACTIONS(2930),
    [anon_sym_u_DQUOTE] = ACTIONS(2930),
    [anon_sym_U_DQUOTE] = ACTIONS(2930),
    [anon_sym_u8_DQUOTE] = ACTIONS(2930),
    [anon_sym_DQUOTE] = ACTIONS(2930),
    [sym_true] = ACTIONS(2928),
    [sym_false] = ACTIONS(2928),
    [anon_sym_NULL] = ACTIONS(2928),
    [anon_sym_nullptr] = ACTIONS(2928),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2928),
    [anon_sym_decltype] = ACTIONS(2928),
    [anon_sym_explicit] = ACTIONS(2928),
    [anon_sym_typename] = ACTIONS(2928),
    [anon_sym_template] = ACTIONS(2928),
    [anon_sym_operator] = ACTIONS(2928),
    [anon_sym_try] = ACTIONS(2928),
    [anon_sym_delete] = ACTIONS(2928),
    [anon_sym_throw] = ACTIONS(2928),
    [anon_sym_namespace] = ACTIONS(2928),
    [anon_sym_using] = ACTIONS(2928),
    [anon_sym_static_assert] = ACTIONS(2928),
    [anon_sym_concept] = ACTIONS(2928),
    [anon_sym_co_return] = ACTIONS(2928),
    [anon_sym_co_yield] = ACTIONS(2928),
    [anon_sym_R_DQUOTE] = ACTIONS(2930),
    [anon_sym_LR_DQUOTE] = ACTIONS(2930),
    [anon_sym_uR_DQUOTE] = ACTIONS(2930),
    [anon_sym_UR_DQUOTE] = ACTIONS(2930),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2930),
    [anon_sym_co_await] = ACTIONS(2928),
    [anon_sym_new] = ACTIONS(2928),
    [anon_sym_requires] = ACTIONS(2928),
    [sym_this] = ACTIONS(2928),
  },
  [305] = {
    [sym_identifier] = ACTIONS(2932),
    [aux_sym_preproc_include_token1] = ACTIONS(2932),
    [aux_sym_preproc_def_token1] = ACTIONS(2932),
    [aux_sym_preproc_if_token1] = ACTIONS(2932),
    [aux_sym_preproc_if_token2] = ACTIONS(2932),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2932),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2932),
    [aux_sym_preproc_else_token1] = ACTIONS(2932),
    [aux_sym_preproc_elif_token1] = ACTIONS(2932),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2932),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2932),
    [sym_preproc_directive] = ACTIONS(2932),
    [anon_sym_LPAREN2] = ACTIONS(2934),
    [anon_sym_BANG] = ACTIONS(2934),
    [anon_sym_TILDE] = ACTIONS(2934),
    [anon_sym_DASH] = ACTIONS(2932),
    [anon_sym_PLUS] = ACTIONS(2932),
    [anon_sym_STAR] = ACTIONS(2934),
    [anon_sym_AMP_AMP] = ACTIONS(2934),
    [anon_sym_AMP] = ACTIONS(2932),
    [anon_sym_SEMI] = ACTIONS(2934),
    [anon_sym___extension__] = ACTIONS(2932),
    [anon_sym_typedef] = ACTIONS(2932),
    [anon_sym_virtual] = ACTIONS(2932),
    [anon_sym_extern] = ACTIONS(2932),
    [anon_sym___attribute__] = ACTIONS(2932),
    [anon_sym___attribute] = ACTIONS(2932),
    [anon_sym_COLON_COLON] = ACTIONS(2934),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2934),
    [anon_sym___declspec] = ACTIONS(2932),
    [anon_sym___based] = ACTIONS(2932),
    [anon_sym___cdecl] = ACTIONS(2932),
    [anon_sym___clrcall] = ACTIONS(2932),
    [anon_sym___stdcall] = ACTIONS(2932),
    [anon_sym___fastcall] = ACTIONS(2932),
    [anon_sym___thiscall] = ACTIONS(2932),
    [anon_sym___vectorcall] = ACTIONS(2932),
    [anon_sym_LBRACE] = ACTIONS(2934),
    [anon_sym_signed] = ACTIONS(2932),
    [anon_sym_unsigned] = ACTIONS(2932),
    [anon_sym_long] = ACTIONS(2932),
    [anon_sym_short] = ACTIONS(2932),
    [anon_sym_LBRACK] = ACTIONS(2932),
    [anon_sym_static] = ACTIONS(2932),
    [anon_sym_register] = ACTIONS(2932),
    [anon_sym_inline] = ACTIONS(2932),
    [anon_sym___inline] = ACTIONS(2932),
    [anon_sym___inline__] = ACTIONS(2932),
    [anon_sym___forceinline] = ACTIONS(2932),
    [anon_sym_thread_local] = ACTIONS(2932),
    [anon_sym___thread] = ACTIONS(2932),
    [anon_sym_const] = ACTIONS(2932),
    [anon_sym_constexpr] = ACTIONS(2932),
    [anon_sym_volatile] = ACTIONS(2932),
    [anon_sym_restrict] = ACTIONS(2932),
    [anon_sym___restrict__] = ACTIONS(2932),
    [anon_sym__Atomic] = ACTIONS(2932),
    [anon_sym__Noreturn] = ACTIONS(2932),
    [anon_sym_noreturn] = ACTIONS(2932),
    [anon_sym__Nonnull] = ACTIONS(2932),
    [anon_sym_mutable] = ACTIONS(2932),
    [anon_sym_constinit] = ACTIONS(2932),
    [anon_sym_consteval] = ACTIONS(2932),
    [anon_sym_alignas] = ACTIONS(2932),
    [anon_sym__Alignas] = ACTIONS(2932),
    [sym_primitive_type] = ACTIONS(2932),
    [anon_sym_enum] = ACTIONS(2932),
    [anon_sym_class] = ACTIONS(2932),
    [anon_sym_struct] = ACTIONS(2932),
    [anon_sym_union] = ACTIONS(2932),
    [anon_sym_if] = ACTIONS(2932),
    [anon_sym_switch] = ACTIONS(2932),
    [anon_sym_case] = ACTIONS(2932),
    [anon_sym_default] = ACTIONS(2932),
    [anon_sym_while] = ACTIONS(2932),
    [anon_sym_do] = ACTIONS(2932),
    [anon_sym_for] = ACTIONS(2932),
    [anon_sym_return] = ACTIONS(2932),
    [anon_sym_break] = ACTIONS(2932),
    [anon_sym_continue] = ACTIONS(2932),
    [anon_sym_goto] = ACTIONS(2932),
    [anon_sym___try] = ACTIONS(2932),
    [anon_sym___leave] = ACTIONS(2932),
    [anon_sym_not] = ACTIONS(2932),
    [anon_sym_compl] = ACTIONS(2932),
    [anon_sym_DASH_DASH] = ACTIONS(2934),
    [anon_sym_PLUS_PLUS] = ACTIONS(2934),
    [anon_sym_sizeof] = ACTIONS(2932),
    [anon_sym___alignof__] = ACTIONS(2932),
    [anon_sym___alignof] = ACTIONS(2932),
    [anon_sym__alignof] = ACTIONS(2932),
    [anon_sym_alignof] = ACTIONS(2932),
    [anon_sym__Alignof] = ACTIONS(2932),
    [anon_sym_offsetof] = ACTIONS(2932),
    [anon_sym__Generic] = ACTIONS(2932),
    [anon_sym_asm] = ACTIONS(2932),
    [anon_sym___asm__] = ACTIONS(2932),
    [anon_sym___asm] = ACTIONS(2932),
    [sym_number_literal] = ACTIONS(2934),
    [anon_sym_L_SQUOTE] = ACTIONS(2934),
    [anon_sym_u_SQUOTE] = ACTIONS(2934),
    [anon_sym_U_SQUOTE] = ACTIONS(2934),
    [anon_sym_u8_SQUOTE] = ACTIONS(2934),
    [anon_sym_SQUOTE] = ACTIONS(2934),
    [anon_sym_L_DQUOTE] = ACTIONS(2934),
    [anon_sym_u_DQUOTE] = ACTIONS(2934),
    [anon_sym_U_DQUOTE] = ACTIONS(2934),
    [anon_sym_u8_DQUOTE] = ACTIONS(2934),
    [anon_sym_DQUOTE] = ACTIONS(2934),
    [sym_true] = ACTIONS(2932),
    [sym_false] = ACTIONS(2932),
    [anon_sym_NULL] = ACTIONS(2932),
    [anon_sym_nullptr] = ACTIONS(2932),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2932),
    [anon_sym_decltype] = ACTIONS(2932),
    [anon_sym_explicit] = ACTIONS(2932),
    [anon_sym_typename] = ACTIONS(2932),
    [anon_sym_template] = ACTIONS(2932),
    [anon_sym_operator] = ACTIONS(2932),
    [anon_sym_try] = ACTIONS(2932),
    [anon_sym_delete] = ACTIONS(2932),
    [anon_sym_throw] = ACTIONS(2932),
    [anon_sym_namespace] = ACTIONS(2932),
    [anon_sym_using] = ACTIONS(2932),
    [anon_sym_static_assert] = ACTIONS(2932),
    [anon_sym_concept] = ACTIONS(2932),
    [anon_sym_co_return] = ACTIONS(2932),
    [anon_sym_co_yield] = ACTIONS(2932),
    [anon_sym_R_DQUOTE] = ACTIONS(2934),
    [anon_sym_LR_DQUOTE] = ACTIONS(2934),
    [anon_sym_uR_DQUOTE] = ACTIONS(2934),
    [anon_sym_UR_DQUOTE] = ACTIONS(2934),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2934),
    [anon_sym_co_await] = ACTIONS(2932),
    [anon_sym_new] = ACTIONS(2932),
    [anon_sym_requires] = ACTIONS(2932),
    [sym_this] = ACTIONS(2932),
  },
  [306] = {
    [sym_identifier] = ACTIONS(2936),
    [aux_sym_preproc_include_token1] = ACTIONS(2936),
    [aux_sym_preproc_def_token1] = ACTIONS(2936),
    [aux_sym_preproc_if_token1] = ACTIONS(2936),
    [aux_sym_preproc_if_token2] = ACTIONS(2936),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2936),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2936),
    [aux_sym_preproc_else_token1] = ACTIONS(2936),
    [aux_sym_preproc_elif_token1] = ACTIONS(2936),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2936),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2936),
    [sym_preproc_directive] = ACTIONS(2936),
    [anon_sym_LPAREN2] = ACTIONS(2938),
    [anon_sym_BANG] = ACTIONS(2938),
    [anon_sym_TILDE] = ACTIONS(2938),
    [anon_sym_DASH] = ACTIONS(2936),
    [anon_sym_PLUS] = ACTIONS(2936),
    [anon_sym_STAR] = ACTIONS(2938),
    [anon_sym_AMP_AMP] = ACTIONS(2938),
    [anon_sym_AMP] = ACTIONS(2936),
    [anon_sym_SEMI] = ACTIONS(2938),
    [anon_sym___extension__] = ACTIONS(2936),
    [anon_sym_typedef] = ACTIONS(2936),
    [anon_sym_virtual] = ACTIONS(2936),
    [anon_sym_extern] = ACTIONS(2936),
    [anon_sym___attribute__] = ACTIONS(2936),
    [anon_sym___attribute] = ACTIONS(2936),
    [anon_sym_COLON_COLON] = ACTIONS(2938),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2938),
    [anon_sym___declspec] = ACTIONS(2936),
    [anon_sym___based] = ACTIONS(2936),
    [anon_sym___cdecl] = ACTIONS(2936),
    [anon_sym___clrcall] = ACTIONS(2936),
    [anon_sym___stdcall] = ACTIONS(2936),
    [anon_sym___fastcall] = ACTIONS(2936),
    [anon_sym___thiscall] = ACTIONS(2936),
    [anon_sym___vectorcall] = ACTIONS(2936),
    [anon_sym_LBRACE] = ACTIONS(2938),
    [anon_sym_signed] = ACTIONS(2936),
    [anon_sym_unsigned] = ACTIONS(2936),
    [anon_sym_long] = ACTIONS(2936),
    [anon_sym_short] = ACTIONS(2936),
    [anon_sym_LBRACK] = ACTIONS(2936),
    [anon_sym_static] = ACTIONS(2936),
    [anon_sym_register] = ACTIONS(2936),
    [anon_sym_inline] = ACTIONS(2936),
    [anon_sym___inline] = ACTIONS(2936),
    [anon_sym___inline__] = ACTIONS(2936),
    [anon_sym___forceinline] = ACTIONS(2936),
    [anon_sym_thread_local] = ACTIONS(2936),
    [anon_sym___thread] = ACTIONS(2936),
    [anon_sym_const] = ACTIONS(2936),
    [anon_sym_constexpr] = ACTIONS(2936),
    [anon_sym_volatile] = ACTIONS(2936),
    [anon_sym_restrict] = ACTIONS(2936),
    [anon_sym___restrict__] = ACTIONS(2936),
    [anon_sym__Atomic] = ACTIONS(2936),
    [anon_sym__Noreturn] = ACTIONS(2936),
    [anon_sym_noreturn] = ACTIONS(2936),
    [anon_sym__Nonnull] = ACTIONS(2936),
    [anon_sym_mutable] = ACTIONS(2936),
    [anon_sym_constinit] = ACTIONS(2936),
    [anon_sym_consteval] = ACTIONS(2936),
    [anon_sym_alignas] = ACTIONS(2936),
    [anon_sym__Alignas] = ACTIONS(2936),
    [sym_primitive_type] = ACTIONS(2936),
    [anon_sym_enum] = ACTIONS(2936),
    [anon_sym_class] = ACTIONS(2936),
    [anon_sym_struct] = ACTIONS(2936),
    [anon_sym_union] = ACTIONS(2936),
    [anon_sym_if] = ACTIONS(2936),
    [anon_sym_switch] = ACTIONS(2936),
    [anon_sym_case] = ACTIONS(2936),
    [anon_sym_default] = ACTIONS(2936),
    [anon_sym_while] = ACTIONS(2936),
    [anon_sym_do] = ACTIONS(2936),
    [anon_sym_for] = ACTIONS(2936),
    [anon_sym_return] = ACTIONS(2936),
    [anon_sym_break] = ACTIONS(2936),
    [anon_sym_continue] = ACTIONS(2936),
    [anon_sym_goto] = ACTIONS(2936),
    [anon_sym___try] = ACTIONS(2936),
    [anon_sym___leave] = ACTIONS(2936),
    [anon_sym_not] = ACTIONS(2936),
    [anon_sym_compl] = ACTIONS(2936),
    [anon_sym_DASH_DASH] = ACTIONS(2938),
    [anon_sym_PLUS_PLUS] = ACTIONS(2938),
    [anon_sym_sizeof] = ACTIONS(2936),
    [anon_sym___alignof__] = ACTIONS(2936),
    [anon_sym___alignof] = ACTIONS(2936),
    [anon_sym__alignof] = ACTIONS(2936),
    [anon_sym_alignof] = ACTIONS(2936),
    [anon_sym__Alignof] = ACTIONS(2936),
    [anon_sym_offsetof] = ACTIONS(2936),
    [anon_sym__Generic] = ACTIONS(2936),
    [anon_sym_asm] = ACTIONS(2936),
    [anon_sym___asm__] = ACTIONS(2936),
    [anon_sym___asm] = ACTIONS(2936),
    [sym_number_literal] = ACTIONS(2938),
    [anon_sym_L_SQUOTE] = ACTIONS(2938),
    [anon_sym_u_SQUOTE] = ACTIONS(2938),
    [anon_sym_U_SQUOTE] = ACTIONS(2938),
    [anon_sym_u8_SQUOTE] = ACTIONS(2938),
    [anon_sym_SQUOTE] = ACTIONS(2938),
    [anon_sym_L_DQUOTE] = ACTIONS(2938),
    [anon_sym_u_DQUOTE] = ACTIONS(2938),
    [anon_sym_U_DQUOTE] = ACTIONS(2938),
    [anon_sym_u8_DQUOTE] = ACTIONS(2938),
    [anon_sym_DQUOTE] = ACTIONS(2938),
    [sym_true] = ACTIONS(2936),
    [sym_false] = ACTIONS(2936),
    [anon_sym_NULL] = ACTIONS(2936),
    [anon_sym_nullptr] = ACTIONS(2936),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2936),
    [anon_sym_decltype] = ACTIONS(2936),
    [anon_sym_explicit] = ACTIONS(2936),
    [anon_sym_typename] = ACTIONS(2936),
    [anon_sym_template] = ACTIONS(2936),
    [anon_sym_operator] = ACTIONS(2936),
    [anon_sym_try] = ACTIONS(2936),
    [anon_sym_delete] = ACTIONS(2936),
    [anon_sym_throw] = ACTIONS(2936),
    [anon_sym_namespace] = ACTIONS(2936),
    [anon_sym_using] = ACTIONS(2936),
    [anon_sym_static_assert] = ACTIONS(2936),
    [anon_sym_concept] = ACTIONS(2936),
    [anon_sym_co_return] = ACTIONS(2936),
    [anon_sym_co_yield] = ACTIONS(2936),
    [anon_sym_R_DQUOTE] = ACTIONS(2938),
    [anon_sym_LR_DQUOTE] = ACTIONS(2938),
    [anon_sym_uR_DQUOTE] = ACTIONS(2938),
    [anon_sym_UR_DQUOTE] = ACTIONS(2938),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2938),
    [anon_sym_co_await] = ACTIONS(2936),
    [anon_sym_new] = ACTIONS(2936),
    [anon_sym_requires] = ACTIONS(2936),
    [sym_this] = ACTIONS(2936),
  },
  [307] = {
    [sym_expression] = STATE(4505),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8233),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(2940),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(2943),
    [anon_sym___extension__] = ACTIONS(2945),
    [anon_sym_virtual] = ACTIONS(2641),
    [anon_sym_extern] = ACTIONS(2641),
    [anon_sym___attribute__] = ACTIONS(2641),
    [anon_sym___attribute] = ACTIONS(2641),
    [anon_sym_COLON_COLON] = ACTIONS(2948),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2643),
    [anon_sym___declspec] = ACTIONS(2641),
    [anon_sym_signed] = ACTIONS(2641),
    [anon_sym_unsigned] = ACTIONS(2641),
    [anon_sym_long] = ACTIONS(2641),
    [anon_sym_short] = ACTIONS(2641),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(2641),
    [anon_sym_register] = ACTIONS(2641),
    [anon_sym_inline] = ACTIONS(2641),
    [anon_sym___inline] = ACTIONS(2641),
    [anon_sym___inline__] = ACTIONS(2641),
    [anon_sym___forceinline] = ACTIONS(2641),
    [anon_sym_thread_local] = ACTIONS(2641),
    [anon_sym___thread] = ACTIONS(2641),
    [anon_sym_const] = ACTIONS(2641),
    [anon_sym_constexpr] = ACTIONS(2641),
    [anon_sym_volatile] = ACTIONS(2641),
    [anon_sym_restrict] = ACTIONS(2641),
    [anon_sym___restrict__] = ACTIONS(2641),
    [anon_sym__Atomic] = ACTIONS(2641),
    [anon_sym__Noreturn] = ACTIONS(2641),
    [anon_sym_noreturn] = ACTIONS(2641),
    [anon_sym__Nonnull] = ACTIONS(2641),
    [anon_sym_mutable] = ACTIONS(2641),
    [anon_sym_constinit] = ACTIONS(2641),
    [anon_sym_consteval] = ACTIONS(2641),
    [anon_sym_alignas] = ACTIONS(2641),
    [anon_sym__Alignas] = ACTIONS(2641),
    [sym_primitive_type] = ACTIONS(2951),
    [anon_sym_enum] = ACTIONS(2641),
    [anon_sym_class] = ACTIONS(2641),
    [anon_sym_struct] = ACTIONS(2641),
    [anon_sym_union] = ACTIONS(2641),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2641),
    [anon_sym_decltype] = ACTIONS(2954),
    [anon_sym_typename] = ACTIONS(2641),
    [anon_sym_template] = ACTIONS(2957),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [308] = {
    [sym_identifier] = ACTIONS(2960),
    [aux_sym_preproc_include_token1] = ACTIONS(2960),
    [aux_sym_preproc_def_token1] = ACTIONS(2960),
    [aux_sym_preproc_if_token1] = ACTIONS(2960),
    [aux_sym_preproc_if_token2] = ACTIONS(2960),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2960),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2960),
    [aux_sym_preproc_else_token1] = ACTIONS(2960),
    [aux_sym_preproc_elif_token1] = ACTIONS(2960),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2960),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2960),
    [sym_preproc_directive] = ACTIONS(2960),
    [anon_sym_LPAREN2] = ACTIONS(2962),
    [anon_sym_BANG] = ACTIONS(2962),
    [anon_sym_TILDE] = ACTIONS(2962),
    [anon_sym_DASH] = ACTIONS(2960),
    [anon_sym_PLUS] = ACTIONS(2960),
    [anon_sym_STAR] = ACTIONS(2962),
    [anon_sym_AMP_AMP] = ACTIONS(2962),
    [anon_sym_AMP] = ACTIONS(2960),
    [anon_sym_SEMI] = ACTIONS(2962),
    [anon_sym___extension__] = ACTIONS(2960),
    [anon_sym_typedef] = ACTIONS(2960),
    [anon_sym_virtual] = ACTIONS(2960),
    [anon_sym_extern] = ACTIONS(2960),
    [anon_sym___attribute__] = ACTIONS(2960),
    [anon_sym___attribute] = ACTIONS(2960),
    [anon_sym_COLON_COLON] = ACTIONS(2962),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2962),
    [anon_sym___declspec] = ACTIONS(2960),
    [anon_sym___based] = ACTIONS(2960),
    [anon_sym___cdecl] = ACTIONS(2960),
    [anon_sym___clrcall] = ACTIONS(2960),
    [anon_sym___stdcall] = ACTIONS(2960),
    [anon_sym___fastcall] = ACTIONS(2960),
    [anon_sym___thiscall] = ACTIONS(2960),
    [anon_sym___vectorcall] = ACTIONS(2960),
    [anon_sym_LBRACE] = ACTIONS(2962),
    [anon_sym_signed] = ACTIONS(2960),
    [anon_sym_unsigned] = ACTIONS(2960),
    [anon_sym_long] = ACTIONS(2960),
    [anon_sym_short] = ACTIONS(2960),
    [anon_sym_LBRACK] = ACTIONS(2960),
    [anon_sym_static] = ACTIONS(2960),
    [anon_sym_register] = ACTIONS(2960),
    [anon_sym_inline] = ACTIONS(2960),
    [anon_sym___inline] = ACTIONS(2960),
    [anon_sym___inline__] = ACTIONS(2960),
    [anon_sym___forceinline] = ACTIONS(2960),
    [anon_sym_thread_local] = ACTIONS(2960),
    [anon_sym___thread] = ACTIONS(2960),
    [anon_sym_const] = ACTIONS(2960),
    [anon_sym_constexpr] = ACTIONS(2960),
    [anon_sym_volatile] = ACTIONS(2960),
    [anon_sym_restrict] = ACTIONS(2960),
    [anon_sym___restrict__] = ACTIONS(2960),
    [anon_sym__Atomic] = ACTIONS(2960),
    [anon_sym__Noreturn] = ACTIONS(2960),
    [anon_sym_noreturn] = ACTIONS(2960),
    [anon_sym__Nonnull] = ACTIONS(2960),
    [anon_sym_mutable] = ACTIONS(2960),
    [anon_sym_constinit] = ACTIONS(2960),
    [anon_sym_consteval] = ACTIONS(2960),
    [anon_sym_alignas] = ACTIONS(2960),
    [anon_sym__Alignas] = ACTIONS(2960),
    [sym_primitive_type] = ACTIONS(2960),
    [anon_sym_enum] = ACTIONS(2960),
    [anon_sym_class] = ACTIONS(2960),
    [anon_sym_struct] = ACTIONS(2960),
    [anon_sym_union] = ACTIONS(2960),
    [anon_sym_if] = ACTIONS(2960),
    [anon_sym_switch] = ACTIONS(2960),
    [anon_sym_case] = ACTIONS(2960),
    [anon_sym_default] = ACTIONS(2960),
    [anon_sym_while] = ACTIONS(2960),
    [anon_sym_do] = ACTIONS(2960),
    [anon_sym_for] = ACTIONS(2960),
    [anon_sym_return] = ACTIONS(2960),
    [anon_sym_break] = ACTIONS(2960),
    [anon_sym_continue] = ACTIONS(2960),
    [anon_sym_goto] = ACTIONS(2960),
    [anon_sym___try] = ACTIONS(2960),
    [anon_sym___leave] = ACTIONS(2960),
    [anon_sym_not] = ACTIONS(2960),
    [anon_sym_compl] = ACTIONS(2960),
    [anon_sym_DASH_DASH] = ACTIONS(2962),
    [anon_sym_PLUS_PLUS] = ACTIONS(2962),
    [anon_sym_sizeof] = ACTIONS(2960),
    [anon_sym___alignof__] = ACTIONS(2960),
    [anon_sym___alignof] = ACTIONS(2960),
    [anon_sym__alignof] = ACTIONS(2960),
    [anon_sym_alignof] = ACTIONS(2960),
    [anon_sym__Alignof] = ACTIONS(2960),
    [anon_sym_offsetof] = ACTIONS(2960),
    [anon_sym__Generic] = ACTIONS(2960),
    [anon_sym_asm] = ACTIONS(2960),
    [anon_sym___asm__] = ACTIONS(2960),
    [anon_sym___asm] = ACTIONS(2960),
    [sym_number_literal] = ACTIONS(2962),
    [anon_sym_L_SQUOTE] = ACTIONS(2962),
    [anon_sym_u_SQUOTE] = ACTIONS(2962),
    [anon_sym_U_SQUOTE] = ACTIONS(2962),
    [anon_sym_u8_SQUOTE] = ACTIONS(2962),
    [anon_sym_SQUOTE] = ACTIONS(2962),
    [anon_sym_L_DQUOTE] = ACTIONS(2962),
    [anon_sym_u_DQUOTE] = ACTIONS(2962),
    [anon_sym_U_DQUOTE] = ACTIONS(2962),
    [anon_sym_u8_DQUOTE] = ACTIONS(2962),
    [anon_sym_DQUOTE] = ACTIONS(2962),
    [sym_true] = ACTIONS(2960),
    [sym_false] = ACTIONS(2960),
    [anon_sym_NULL] = ACTIONS(2960),
    [anon_sym_nullptr] = ACTIONS(2960),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2960),
    [anon_sym_decltype] = ACTIONS(2960),
    [anon_sym_explicit] = ACTIONS(2960),
    [anon_sym_typename] = ACTIONS(2960),
    [anon_sym_template] = ACTIONS(2960),
    [anon_sym_operator] = ACTIONS(2960),
    [anon_sym_try] = ACTIONS(2960),
    [anon_sym_delete] = ACTIONS(2960),
    [anon_sym_throw] = ACTIONS(2960),
    [anon_sym_namespace] = ACTIONS(2960),
    [anon_sym_using] = ACTIONS(2960),
    [anon_sym_static_assert] = ACTIONS(2960),
    [anon_sym_concept] = ACTIONS(2960),
    [anon_sym_co_return] = ACTIONS(2960),
    [anon_sym_co_yield] = ACTIONS(2960),
    [anon_sym_R_DQUOTE] = ACTIONS(2962),
    [anon_sym_LR_DQUOTE] = ACTIONS(2962),
    [anon_sym_uR_DQUOTE] = ACTIONS(2962),
    [anon_sym_UR_DQUOTE] = ACTIONS(2962),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2962),
    [anon_sym_co_await] = ACTIONS(2960),
    [anon_sym_new] = ACTIONS(2960),
    [anon_sym_requires] = ACTIONS(2960),
    [sym_this] = ACTIONS(2960),
  },
  [309] = {
    [sym_identifier] = ACTIONS(2964),
    [aux_sym_preproc_include_token1] = ACTIONS(2964),
    [aux_sym_preproc_def_token1] = ACTIONS(2964),
    [aux_sym_preproc_if_token1] = ACTIONS(2964),
    [aux_sym_preproc_if_token2] = ACTIONS(2964),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2964),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2964),
    [aux_sym_preproc_else_token1] = ACTIONS(2964),
    [aux_sym_preproc_elif_token1] = ACTIONS(2964),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2964),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2964),
    [sym_preproc_directive] = ACTIONS(2964),
    [anon_sym_LPAREN2] = ACTIONS(2966),
    [anon_sym_BANG] = ACTIONS(2966),
    [anon_sym_TILDE] = ACTIONS(2966),
    [anon_sym_DASH] = ACTIONS(2964),
    [anon_sym_PLUS] = ACTIONS(2964),
    [anon_sym_STAR] = ACTIONS(2966),
    [anon_sym_AMP_AMP] = ACTIONS(2966),
    [anon_sym_AMP] = ACTIONS(2964),
    [anon_sym_SEMI] = ACTIONS(2966),
    [anon_sym___extension__] = ACTIONS(2964),
    [anon_sym_typedef] = ACTIONS(2964),
    [anon_sym_virtual] = ACTIONS(2964),
    [anon_sym_extern] = ACTIONS(2964),
    [anon_sym___attribute__] = ACTIONS(2964),
    [anon_sym___attribute] = ACTIONS(2964),
    [anon_sym_COLON_COLON] = ACTIONS(2966),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2966),
    [anon_sym___declspec] = ACTIONS(2964),
    [anon_sym___based] = ACTIONS(2964),
    [anon_sym___cdecl] = ACTIONS(2964),
    [anon_sym___clrcall] = ACTIONS(2964),
    [anon_sym___stdcall] = ACTIONS(2964),
    [anon_sym___fastcall] = ACTIONS(2964),
    [anon_sym___thiscall] = ACTIONS(2964),
    [anon_sym___vectorcall] = ACTIONS(2964),
    [anon_sym_LBRACE] = ACTIONS(2966),
    [anon_sym_signed] = ACTIONS(2964),
    [anon_sym_unsigned] = ACTIONS(2964),
    [anon_sym_long] = ACTIONS(2964),
    [anon_sym_short] = ACTIONS(2964),
    [anon_sym_LBRACK] = ACTIONS(2964),
    [anon_sym_static] = ACTIONS(2964),
    [anon_sym_register] = ACTIONS(2964),
    [anon_sym_inline] = ACTIONS(2964),
    [anon_sym___inline] = ACTIONS(2964),
    [anon_sym___inline__] = ACTIONS(2964),
    [anon_sym___forceinline] = ACTIONS(2964),
    [anon_sym_thread_local] = ACTIONS(2964),
    [anon_sym___thread] = ACTIONS(2964),
    [anon_sym_const] = ACTIONS(2964),
    [anon_sym_constexpr] = ACTIONS(2964),
    [anon_sym_volatile] = ACTIONS(2964),
    [anon_sym_restrict] = ACTIONS(2964),
    [anon_sym___restrict__] = ACTIONS(2964),
    [anon_sym__Atomic] = ACTIONS(2964),
    [anon_sym__Noreturn] = ACTIONS(2964),
    [anon_sym_noreturn] = ACTIONS(2964),
    [anon_sym__Nonnull] = ACTIONS(2964),
    [anon_sym_mutable] = ACTIONS(2964),
    [anon_sym_constinit] = ACTIONS(2964),
    [anon_sym_consteval] = ACTIONS(2964),
    [anon_sym_alignas] = ACTIONS(2964),
    [anon_sym__Alignas] = ACTIONS(2964),
    [sym_primitive_type] = ACTIONS(2964),
    [anon_sym_enum] = ACTIONS(2964),
    [anon_sym_class] = ACTIONS(2964),
    [anon_sym_struct] = ACTIONS(2964),
    [anon_sym_union] = ACTIONS(2964),
    [anon_sym_if] = ACTIONS(2964),
    [anon_sym_switch] = ACTIONS(2964),
    [anon_sym_case] = ACTIONS(2964),
    [anon_sym_default] = ACTIONS(2964),
    [anon_sym_while] = ACTIONS(2964),
    [anon_sym_do] = ACTIONS(2964),
    [anon_sym_for] = ACTIONS(2964),
    [anon_sym_return] = ACTIONS(2964),
    [anon_sym_break] = ACTIONS(2964),
    [anon_sym_continue] = ACTIONS(2964),
    [anon_sym_goto] = ACTIONS(2964),
    [anon_sym___try] = ACTIONS(2964),
    [anon_sym___leave] = ACTIONS(2964),
    [anon_sym_not] = ACTIONS(2964),
    [anon_sym_compl] = ACTIONS(2964),
    [anon_sym_DASH_DASH] = ACTIONS(2966),
    [anon_sym_PLUS_PLUS] = ACTIONS(2966),
    [anon_sym_sizeof] = ACTIONS(2964),
    [anon_sym___alignof__] = ACTIONS(2964),
    [anon_sym___alignof] = ACTIONS(2964),
    [anon_sym__alignof] = ACTIONS(2964),
    [anon_sym_alignof] = ACTIONS(2964),
    [anon_sym__Alignof] = ACTIONS(2964),
    [anon_sym_offsetof] = ACTIONS(2964),
    [anon_sym__Generic] = ACTIONS(2964),
    [anon_sym_asm] = ACTIONS(2964),
    [anon_sym___asm__] = ACTIONS(2964),
    [anon_sym___asm] = ACTIONS(2964),
    [sym_number_literal] = ACTIONS(2966),
    [anon_sym_L_SQUOTE] = ACTIONS(2966),
    [anon_sym_u_SQUOTE] = ACTIONS(2966),
    [anon_sym_U_SQUOTE] = ACTIONS(2966),
    [anon_sym_u8_SQUOTE] = ACTIONS(2966),
    [anon_sym_SQUOTE] = ACTIONS(2966),
    [anon_sym_L_DQUOTE] = ACTIONS(2966),
    [anon_sym_u_DQUOTE] = ACTIONS(2966),
    [anon_sym_U_DQUOTE] = ACTIONS(2966),
    [anon_sym_u8_DQUOTE] = ACTIONS(2966),
    [anon_sym_DQUOTE] = ACTIONS(2966),
    [sym_true] = ACTIONS(2964),
    [sym_false] = ACTIONS(2964),
    [anon_sym_NULL] = ACTIONS(2964),
    [anon_sym_nullptr] = ACTIONS(2964),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2964),
    [anon_sym_decltype] = ACTIONS(2964),
    [anon_sym_explicit] = ACTIONS(2964),
    [anon_sym_typename] = ACTIONS(2964),
    [anon_sym_template] = ACTIONS(2964),
    [anon_sym_operator] = ACTIONS(2964),
    [anon_sym_try] = ACTIONS(2964),
    [anon_sym_delete] = ACTIONS(2964),
    [anon_sym_throw] = ACTIONS(2964),
    [anon_sym_namespace] = ACTIONS(2964),
    [anon_sym_using] = ACTIONS(2964),
    [anon_sym_static_assert] = ACTIONS(2964),
    [anon_sym_concept] = ACTIONS(2964),
    [anon_sym_co_return] = ACTIONS(2964),
    [anon_sym_co_yield] = ACTIONS(2964),
    [anon_sym_R_DQUOTE] = ACTIONS(2966),
    [anon_sym_LR_DQUOTE] = ACTIONS(2966),
    [anon_sym_uR_DQUOTE] = ACTIONS(2966),
    [anon_sym_UR_DQUOTE] = ACTIONS(2966),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2966),
    [anon_sym_co_await] = ACTIONS(2964),
    [anon_sym_new] = ACTIONS(2964),
    [anon_sym_requires] = ACTIONS(2964),
    [sym_this] = ACTIONS(2964),
  },
  [310] = {
    [sym_identifier] = ACTIONS(2968),
    [aux_sym_preproc_include_token1] = ACTIONS(2968),
    [aux_sym_preproc_def_token1] = ACTIONS(2968),
    [aux_sym_preproc_if_token1] = ACTIONS(2968),
    [aux_sym_preproc_if_token2] = ACTIONS(2968),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2968),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2968),
    [aux_sym_preproc_else_token1] = ACTIONS(2968),
    [aux_sym_preproc_elif_token1] = ACTIONS(2968),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2968),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2968),
    [sym_preproc_directive] = ACTIONS(2968),
    [anon_sym_LPAREN2] = ACTIONS(2970),
    [anon_sym_BANG] = ACTIONS(2970),
    [anon_sym_TILDE] = ACTIONS(2970),
    [anon_sym_DASH] = ACTIONS(2968),
    [anon_sym_PLUS] = ACTIONS(2968),
    [anon_sym_STAR] = ACTIONS(2970),
    [anon_sym_AMP_AMP] = ACTIONS(2970),
    [anon_sym_AMP] = ACTIONS(2968),
    [anon_sym_SEMI] = ACTIONS(2970),
    [anon_sym___extension__] = ACTIONS(2968),
    [anon_sym_typedef] = ACTIONS(2968),
    [anon_sym_virtual] = ACTIONS(2968),
    [anon_sym_extern] = ACTIONS(2968),
    [anon_sym___attribute__] = ACTIONS(2968),
    [anon_sym___attribute] = ACTIONS(2968),
    [anon_sym_COLON_COLON] = ACTIONS(2970),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2970),
    [anon_sym___declspec] = ACTIONS(2968),
    [anon_sym___based] = ACTIONS(2968),
    [anon_sym___cdecl] = ACTIONS(2968),
    [anon_sym___clrcall] = ACTIONS(2968),
    [anon_sym___stdcall] = ACTIONS(2968),
    [anon_sym___fastcall] = ACTIONS(2968),
    [anon_sym___thiscall] = ACTIONS(2968),
    [anon_sym___vectorcall] = ACTIONS(2968),
    [anon_sym_LBRACE] = ACTIONS(2970),
    [anon_sym_signed] = ACTIONS(2968),
    [anon_sym_unsigned] = ACTIONS(2968),
    [anon_sym_long] = ACTIONS(2968),
    [anon_sym_short] = ACTIONS(2968),
    [anon_sym_LBRACK] = ACTIONS(2968),
    [anon_sym_static] = ACTIONS(2968),
    [anon_sym_register] = ACTIONS(2968),
    [anon_sym_inline] = ACTIONS(2968),
    [anon_sym___inline] = ACTIONS(2968),
    [anon_sym___inline__] = ACTIONS(2968),
    [anon_sym___forceinline] = ACTIONS(2968),
    [anon_sym_thread_local] = ACTIONS(2968),
    [anon_sym___thread] = ACTIONS(2968),
    [anon_sym_const] = ACTIONS(2968),
    [anon_sym_constexpr] = ACTIONS(2968),
    [anon_sym_volatile] = ACTIONS(2968),
    [anon_sym_restrict] = ACTIONS(2968),
    [anon_sym___restrict__] = ACTIONS(2968),
    [anon_sym__Atomic] = ACTIONS(2968),
    [anon_sym__Noreturn] = ACTIONS(2968),
    [anon_sym_noreturn] = ACTIONS(2968),
    [anon_sym__Nonnull] = ACTIONS(2968),
    [anon_sym_mutable] = ACTIONS(2968),
    [anon_sym_constinit] = ACTIONS(2968),
    [anon_sym_consteval] = ACTIONS(2968),
    [anon_sym_alignas] = ACTIONS(2968),
    [anon_sym__Alignas] = ACTIONS(2968),
    [sym_primitive_type] = ACTIONS(2968),
    [anon_sym_enum] = ACTIONS(2968),
    [anon_sym_class] = ACTIONS(2968),
    [anon_sym_struct] = ACTIONS(2968),
    [anon_sym_union] = ACTIONS(2968),
    [anon_sym_if] = ACTIONS(2968),
    [anon_sym_switch] = ACTIONS(2968),
    [anon_sym_case] = ACTIONS(2968),
    [anon_sym_default] = ACTIONS(2968),
    [anon_sym_while] = ACTIONS(2968),
    [anon_sym_do] = ACTIONS(2968),
    [anon_sym_for] = ACTIONS(2968),
    [anon_sym_return] = ACTIONS(2968),
    [anon_sym_break] = ACTIONS(2968),
    [anon_sym_continue] = ACTIONS(2968),
    [anon_sym_goto] = ACTIONS(2968),
    [anon_sym___try] = ACTIONS(2968),
    [anon_sym___leave] = ACTIONS(2968),
    [anon_sym_not] = ACTIONS(2968),
    [anon_sym_compl] = ACTIONS(2968),
    [anon_sym_DASH_DASH] = ACTIONS(2970),
    [anon_sym_PLUS_PLUS] = ACTIONS(2970),
    [anon_sym_sizeof] = ACTIONS(2968),
    [anon_sym___alignof__] = ACTIONS(2968),
    [anon_sym___alignof] = ACTIONS(2968),
    [anon_sym__alignof] = ACTIONS(2968),
    [anon_sym_alignof] = ACTIONS(2968),
    [anon_sym__Alignof] = ACTIONS(2968),
    [anon_sym_offsetof] = ACTIONS(2968),
    [anon_sym__Generic] = ACTIONS(2968),
    [anon_sym_asm] = ACTIONS(2968),
    [anon_sym___asm__] = ACTIONS(2968),
    [anon_sym___asm] = ACTIONS(2968),
    [sym_number_literal] = ACTIONS(2970),
    [anon_sym_L_SQUOTE] = ACTIONS(2970),
    [anon_sym_u_SQUOTE] = ACTIONS(2970),
    [anon_sym_U_SQUOTE] = ACTIONS(2970),
    [anon_sym_u8_SQUOTE] = ACTIONS(2970),
    [anon_sym_SQUOTE] = ACTIONS(2970),
    [anon_sym_L_DQUOTE] = ACTIONS(2970),
    [anon_sym_u_DQUOTE] = ACTIONS(2970),
    [anon_sym_U_DQUOTE] = ACTIONS(2970),
    [anon_sym_u8_DQUOTE] = ACTIONS(2970),
    [anon_sym_DQUOTE] = ACTIONS(2970),
    [sym_true] = ACTIONS(2968),
    [sym_false] = ACTIONS(2968),
    [anon_sym_NULL] = ACTIONS(2968),
    [anon_sym_nullptr] = ACTIONS(2968),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2968),
    [anon_sym_decltype] = ACTIONS(2968),
    [anon_sym_explicit] = ACTIONS(2968),
    [anon_sym_typename] = ACTIONS(2968),
    [anon_sym_template] = ACTIONS(2968),
    [anon_sym_operator] = ACTIONS(2968),
    [anon_sym_try] = ACTIONS(2968),
    [anon_sym_delete] = ACTIONS(2968),
    [anon_sym_throw] = ACTIONS(2968),
    [anon_sym_namespace] = ACTIONS(2968),
    [anon_sym_using] = ACTIONS(2968),
    [anon_sym_static_assert] = ACTIONS(2968),
    [anon_sym_concept] = ACTIONS(2968),
    [anon_sym_co_return] = ACTIONS(2968),
    [anon_sym_co_yield] = ACTIONS(2968),
    [anon_sym_R_DQUOTE] = ACTIONS(2970),
    [anon_sym_LR_DQUOTE] = ACTIONS(2970),
    [anon_sym_uR_DQUOTE] = ACTIONS(2970),
    [anon_sym_UR_DQUOTE] = ACTIONS(2970),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2970),
    [anon_sym_co_await] = ACTIONS(2968),
    [anon_sym_new] = ACTIONS(2968),
    [anon_sym_requires] = ACTIONS(2968),
    [sym_this] = ACTIONS(2968),
  },
  [311] = {
    [sym_identifier] = ACTIONS(2972),
    [aux_sym_preproc_include_token1] = ACTIONS(2972),
    [aux_sym_preproc_def_token1] = ACTIONS(2972),
    [aux_sym_preproc_if_token1] = ACTIONS(2972),
    [aux_sym_preproc_if_token2] = ACTIONS(2972),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2972),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2972),
    [aux_sym_preproc_else_token1] = ACTIONS(2972),
    [aux_sym_preproc_elif_token1] = ACTIONS(2972),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2972),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2972),
    [sym_preproc_directive] = ACTIONS(2972),
    [anon_sym_LPAREN2] = ACTIONS(2974),
    [anon_sym_BANG] = ACTIONS(2974),
    [anon_sym_TILDE] = ACTIONS(2974),
    [anon_sym_DASH] = ACTIONS(2972),
    [anon_sym_PLUS] = ACTIONS(2972),
    [anon_sym_STAR] = ACTIONS(2974),
    [anon_sym_AMP_AMP] = ACTIONS(2974),
    [anon_sym_AMP] = ACTIONS(2972),
    [anon_sym_SEMI] = ACTIONS(2974),
    [anon_sym___extension__] = ACTIONS(2972),
    [anon_sym_typedef] = ACTIONS(2972),
    [anon_sym_virtual] = ACTIONS(2972),
    [anon_sym_extern] = ACTIONS(2972),
    [anon_sym___attribute__] = ACTIONS(2972),
    [anon_sym___attribute] = ACTIONS(2972),
    [anon_sym_COLON_COLON] = ACTIONS(2974),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2974),
    [anon_sym___declspec] = ACTIONS(2972),
    [anon_sym___based] = ACTIONS(2972),
    [anon_sym___cdecl] = ACTIONS(2972),
    [anon_sym___clrcall] = ACTIONS(2972),
    [anon_sym___stdcall] = ACTIONS(2972),
    [anon_sym___fastcall] = ACTIONS(2972),
    [anon_sym___thiscall] = ACTIONS(2972),
    [anon_sym___vectorcall] = ACTIONS(2972),
    [anon_sym_LBRACE] = ACTIONS(2974),
    [anon_sym_signed] = ACTIONS(2972),
    [anon_sym_unsigned] = ACTIONS(2972),
    [anon_sym_long] = ACTIONS(2972),
    [anon_sym_short] = ACTIONS(2972),
    [anon_sym_LBRACK] = ACTIONS(2972),
    [anon_sym_static] = ACTIONS(2972),
    [anon_sym_register] = ACTIONS(2972),
    [anon_sym_inline] = ACTIONS(2972),
    [anon_sym___inline] = ACTIONS(2972),
    [anon_sym___inline__] = ACTIONS(2972),
    [anon_sym___forceinline] = ACTIONS(2972),
    [anon_sym_thread_local] = ACTIONS(2972),
    [anon_sym___thread] = ACTIONS(2972),
    [anon_sym_const] = ACTIONS(2972),
    [anon_sym_constexpr] = ACTIONS(2972),
    [anon_sym_volatile] = ACTIONS(2972),
    [anon_sym_restrict] = ACTIONS(2972),
    [anon_sym___restrict__] = ACTIONS(2972),
    [anon_sym__Atomic] = ACTIONS(2972),
    [anon_sym__Noreturn] = ACTIONS(2972),
    [anon_sym_noreturn] = ACTIONS(2972),
    [anon_sym__Nonnull] = ACTIONS(2972),
    [anon_sym_mutable] = ACTIONS(2972),
    [anon_sym_constinit] = ACTIONS(2972),
    [anon_sym_consteval] = ACTIONS(2972),
    [anon_sym_alignas] = ACTIONS(2972),
    [anon_sym__Alignas] = ACTIONS(2972),
    [sym_primitive_type] = ACTIONS(2972),
    [anon_sym_enum] = ACTIONS(2972),
    [anon_sym_class] = ACTIONS(2972),
    [anon_sym_struct] = ACTIONS(2972),
    [anon_sym_union] = ACTIONS(2972),
    [anon_sym_if] = ACTIONS(2972),
    [anon_sym_switch] = ACTIONS(2972),
    [anon_sym_case] = ACTIONS(2972),
    [anon_sym_default] = ACTIONS(2972),
    [anon_sym_while] = ACTIONS(2972),
    [anon_sym_do] = ACTIONS(2972),
    [anon_sym_for] = ACTIONS(2972),
    [anon_sym_return] = ACTIONS(2972),
    [anon_sym_break] = ACTIONS(2972),
    [anon_sym_continue] = ACTIONS(2972),
    [anon_sym_goto] = ACTIONS(2972),
    [anon_sym___try] = ACTIONS(2972),
    [anon_sym___leave] = ACTIONS(2972),
    [anon_sym_not] = ACTIONS(2972),
    [anon_sym_compl] = ACTIONS(2972),
    [anon_sym_DASH_DASH] = ACTIONS(2974),
    [anon_sym_PLUS_PLUS] = ACTIONS(2974),
    [anon_sym_sizeof] = ACTIONS(2972),
    [anon_sym___alignof__] = ACTIONS(2972),
    [anon_sym___alignof] = ACTIONS(2972),
    [anon_sym__alignof] = ACTIONS(2972),
    [anon_sym_alignof] = ACTIONS(2972),
    [anon_sym__Alignof] = ACTIONS(2972),
    [anon_sym_offsetof] = ACTIONS(2972),
    [anon_sym__Generic] = ACTIONS(2972),
    [anon_sym_asm] = ACTIONS(2972),
    [anon_sym___asm__] = ACTIONS(2972),
    [anon_sym___asm] = ACTIONS(2972),
    [sym_number_literal] = ACTIONS(2974),
    [anon_sym_L_SQUOTE] = ACTIONS(2974),
    [anon_sym_u_SQUOTE] = ACTIONS(2974),
    [anon_sym_U_SQUOTE] = ACTIONS(2974),
    [anon_sym_u8_SQUOTE] = ACTIONS(2974),
    [anon_sym_SQUOTE] = ACTIONS(2974),
    [anon_sym_L_DQUOTE] = ACTIONS(2974),
    [anon_sym_u_DQUOTE] = ACTIONS(2974),
    [anon_sym_U_DQUOTE] = ACTIONS(2974),
    [anon_sym_u8_DQUOTE] = ACTIONS(2974),
    [anon_sym_DQUOTE] = ACTIONS(2974),
    [sym_true] = ACTIONS(2972),
    [sym_false] = ACTIONS(2972),
    [anon_sym_NULL] = ACTIONS(2972),
    [anon_sym_nullptr] = ACTIONS(2972),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2972),
    [anon_sym_decltype] = ACTIONS(2972),
    [anon_sym_explicit] = ACTIONS(2972),
    [anon_sym_typename] = ACTIONS(2972),
    [anon_sym_template] = ACTIONS(2972),
    [anon_sym_operator] = ACTIONS(2972),
    [anon_sym_try] = ACTIONS(2972),
    [anon_sym_delete] = ACTIONS(2972),
    [anon_sym_throw] = ACTIONS(2972),
    [anon_sym_namespace] = ACTIONS(2972),
    [anon_sym_using] = ACTIONS(2972),
    [anon_sym_static_assert] = ACTIONS(2972),
    [anon_sym_concept] = ACTIONS(2972),
    [anon_sym_co_return] = ACTIONS(2972),
    [anon_sym_co_yield] = ACTIONS(2972),
    [anon_sym_R_DQUOTE] = ACTIONS(2974),
    [anon_sym_LR_DQUOTE] = ACTIONS(2974),
    [anon_sym_uR_DQUOTE] = ACTIONS(2974),
    [anon_sym_UR_DQUOTE] = ACTIONS(2974),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2974),
    [anon_sym_co_await] = ACTIONS(2972),
    [anon_sym_new] = ACTIONS(2972),
    [anon_sym_requires] = ACTIONS(2972),
    [sym_this] = ACTIONS(2972),
  },
  [312] = {
    [sym_identifier] = ACTIONS(2976),
    [aux_sym_preproc_include_token1] = ACTIONS(2976),
    [aux_sym_preproc_def_token1] = ACTIONS(2976),
    [aux_sym_preproc_if_token1] = ACTIONS(2976),
    [aux_sym_preproc_if_token2] = ACTIONS(2976),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2976),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2976),
    [aux_sym_preproc_else_token1] = ACTIONS(2976),
    [aux_sym_preproc_elif_token1] = ACTIONS(2976),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2976),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2976),
    [sym_preproc_directive] = ACTIONS(2976),
    [anon_sym_LPAREN2] = ACTIONS(2978),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2976),
    [anon_sym_PLUS] = ACTIONS(2976),
    [anon_sym_STAR] = ACTIONS(2978),
    [anon_sym_AMP_AMP] = ACTIONS(2978),
    [anon_sym_AMP] = ACTIONS(2976),
    [anon_sym_SEMI] = ACTIONS(2978),
    [anon_sym___extension__] = ACTIONS(2976),
    [anon_sym_typedef] = ACTIONS(2976),
    [anon_sym_virtual] = ACTIONS(2976),
    [anon_sym_extern] = ACTIONS(2976),
    [anon_sym___attribute__] = ACTIONS(2976),
    [anon_sym___attribute] = ACTIONS(2976),
    [anon_sym_COLON_COLON] = ACTIONS(2978),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2978),
    [anon_sym___declspec] = ACTIONS(2976),
    [anon_sym___based] = ACTIONS(2976),
    [anon_sym___cdecl] = ACTIONS(2976),
    [anon_sym___clrcall] = ACTIONS(2976),
    [anon_sym___stdcall] = ACTIONS(2976),
    [anon_sym___fastcall] = ACTIONS(2976),
    [anon_sym___thiscall] = ACTIONS(2976),
    [anon_sym___vectorcall] = ACTIONS(2976),
    [anon_sym_LBRACE] = ACTIONS(2978),
    [anon_sym_signed] = ACTIONS(2976),
    [anon_sym_unsigned] = ACTIONS(2976),
    [anon_sym_long] = ACTIONS(2976),
    [anon_sym_short] = ACTIONS(2976),
    [anon_sym_LBRACK] = ACTIONS(2976),
    [anon_sym_static] = ACTIONS(2976),
    [anon_sym_register] = ACTIONS(2976),
    [anon_sym_inline] = ACTIONS(2976),
    [anon_sym___inline] = ACTIONS(2976),
    [anon_sym___inline__] = ACTIONS(2976),
    [anon_sym___forceinline] = ACTIONS(2976),
    [anon_sym_thread_local] = ACTIONS(2976),
    [anon_sym___thread] = ACTIONS(2976),
    [anon_sym_const] = ACTIONS(2976),
    [anon_sym_constexpr] = ACTIONS(2976),
    [anon_sym_volatile] = ACTIONS(2976),
    [anon_sym_restrict] = ACTIONS(2976),
    [anon_sym___restrict__] = ACTIONS(2976),
    [anon_sym__Atomic] = ACTIONS(2976),
    [anon_sym__Noreturn] = ACTIONS(2976),
    [anon_sym_noreturn] = ACTIONS(2976),
    [anon_sym__Nonnull] = ACTIONS(2976),
    [anon_sym_mutable] = ACTIONS(2976),
    [anon_sym_constinit] = ACTIONS(2976),
    [anon_sym_consteval] = ACTIONS(2976),
    [anon_sym_alignas] = ACTIONS(2976),
    [anon_sym__Alignas] = ACTIONS(2976),
    [sym_primitive_type] = ACTIONS(2976),
    [anon_sym_enum] = ACTIONS(2976),
    [anon_sym_class] = ACTIONS(2976),
    [anon_sym_struct] = ACTIONS(2976),
    [anon_sym_union] = ACTIONS(2976),
    [anon_sym_if] = ACTIONS(2976),
    [anon_sym_switch] = ACTIONS(2976),
    [anon_sym_case] = ACTIONS(2976),
    [anon_sym_default] = ACTIONS(2976),
    [anon_sym_while] = ACTIONS(2976),
    [anon_sym_do] = ACTIONS(2976),
    [anon_sym_for] = ACTIONS(2976),
    [anon_sym_return] = ACTIONS(2976),
    [anon_sym_break] = ACTIONS(2976),
    [anon_sym_continue] = ACTIONS(2976),
    [anon_sym_goto] = ACTIONS(2976),
    [anon_sym___try] = ACTIONS(2976),
    [anon_sym___leave] = ACTIONS(2976),
    [anon_sym_not] = ACTIONS(2976),
    [anon_sym_compl] = ACTIONS(2976),
    [anon_sym_DASH_DASH] = ACTIONS(2978),
    [anon_sym_PLUS_PLUS] = ACTIONS(2978),
    [anon_sym_sizeof] = ACTIONS(2976),
    [anon_sym___alignof__] = ACTIONS(2976),
    [anon_sym___alignof] = ACTIONS(2976),
    [anon_sym__alignof] = ACTIONS(2976),
    [anon_sym_alignof] = ACTIONS(2976),
    [anon_sym__Alignof] = ACTIONS(2976),
    [anon_sym_offsetof] = ACTIONS(2976),
    [anon_sym__Generic] = ACTIONS(2976),
    [anon_sym_asm] = ACTIONS(2976),
    [anon_sym___asm__] = ACTIONS(2976),
    [anon_sym___asm] = ACTIONS(2976),
    [sym_number_literal] = ACTIONS(2978),
    [anon_sym_L_SQUOTE] = ACTIONS(2978),
    [anon_sym_u_SQUOTE] = ACTIONS(2978),
    [anon_sym_U_SQUOTE] = ACTIONS(2978),
    [anon_sym_u8_SQUOTE] = ACTIONS(2978),
    [anon_sym_SQUOTE] = ACTIONS(2978),
    [anon_sym_L_DQUOTE] = ACTIONS(2978),
    [anon_sym_u_DQUOTE] = ACTIONS(2978),
    [anon_sym_U_DQUOTE] = ACTIONS(2978),
    [anon_sym_u8_DQUOTE] = ACTIONS(2978),
    [anon_sym_DQUOTE] = ACTIONS(2978),
    [sym_true] = ACTIONS(2976),
    [sym_false] = ACTIONS(2976),
    [anon_sym_NULL] = ACTIONS(2976),
    [anon_sym_nullptr] = ACTIONS(2976),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2976),
    [anon_sym_decltype] = ACTIONS(2976),
    [anon_sym_explicit] = ACTIONS(2976),
    [anon_sym_typename] = ACTIONS(2976),
    [anon_sym_template] = ACTIONS(2976),
    [anon_sym_operator] = ACTIONS(2976),
    [anon_sym_try] = ACTIONS(2976),
    [anon_sym_delete] = ACTIONS(2976),
    [anon_sym_throw] = ACTIONS(2976),
    [anon_sym_namespace] = ACTIONS(2976),
    [anon_sym_using] = ACTIONS(2976),
    [anon_sym_static_assert] = ACTIONS(2976),
    [anon_sym_concept] = ACTIONS(2976),
    [anon_sym_co_return] = ACTIONS(2976),
    [anon_sym_co_yield] = ACTIONS(2976),
    [anon_sym_R_DQUOTE] = ACTIONS(2978),
    [anon_sym_LR_DQUOTE] = ACTIONS(2978),
    [anon_sym_uR_DQUOTE] = ACTIONS(2978),
    [anon_sym_UR_DQUOTE] = ACTIONS(2978),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2978),
    [anon_sym_co_await] = ACTIONS(2976),
    [anon_sym_new] = ACTIONS(2976),
    [anon_sym_requires] = ACTIONS(2976),
    [sym_this] = ACTIONS(2976),
  },
  [313] = {
    [sym_identifier] = ACTIONS(2980),
    [aux_sym_preproc_include_token1] = ACTIONS(2980),
    [aux_sym_preproc_def_token1] = ACTIONS(2980),
    [aux_sym_preproc_if_token1] = ACTIONS(2980),
    [aux_sym_preproc_if_token2] = ACTIONS(2980),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2980),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2980),
    [aux_sym_preproc_else_token1] = ACTIONS(2980),
    [aux_sym_preproc_elif_token1] = ACTIONS(2980),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2980),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2980),
    [sym_preproc_directive] = ACTIONS(2980),
    [anon_sym_LPAREN2] = ACTIONS(2982),
    [anon_sym_BANG] = ACTIONS(2982),
    [anon_sym_TILDE] = ACTIONS(2982),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP_AMP] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2980),
    [anon_sym_SEMI] = ACTIONS(2982),
    [anon_sym___extension__] = ACTIONS(2980),
    [anon_sym_typedef] = ACTIONS(2980),
    [anon_sym_virtual] = ACTIONS(2980),
    [anon_sym_extern] = ACTIONS(2980),
    [anon_sym___attribute__] = ACTIONS(2980),
    [anon_sym___attribute] = ACTIONS(2980),
    [anon_sym_COLON_COLON] = ACTIONS(2982),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2982),
    [anon_sym___declspec] = ACTIONS(2980),
    [anon_sym___based] = ACTIONS(2980),
    [anon_sym___cdecl] = ACTIONS(2980),
    [anon_sym___clrcall] = ACTIONS(2980),
    [anon_sym___stdcall] = ACTIONS(2980),
    [anon_sym___fastcall] = ACTIONS(2980),
    [anon_sym___thiscall] = ACTIONS(2980),
    [anon_sym___vectorcall] = ACTIONS(2980),
    [anon_sym_LBRACE] = ACTIONS(2982),
    [anon_sym_signed] = ACTIONS(2980),
    [anon_sym_unsigned] = ACTIONS(2980),
    [anon_sym_long] = ACTIONS(2980),
    [anon_sym_short] = ACTIONS(2980),
    [anon_sym_LBRACK] = ACTIONS(2980),
    [anon_sym_static] = ACTIONS(2980),
    [anon_sym_register] = ACTIONS(2980),
    [anon_sym_inline] = ACTIONS(2980),
    [anon_sym___inline] = ACTIONS(2980),
    [anon_sym___inline__] = ACTIONS(2980),
    [anon_sym___forceinline] = ACTIONS(2980),
    [anon_sym_thread_local] = ACTIONS(2980),
    [anon_sym___thread] = ACTIONS(2980),
    [anon_sym_const] = ACTIONS(2980),
    [anon_sym_constexpr] = ACTIONS(2980),
    [anon_sym_volatile] = ACTIONS(2980),
    [anon_sym_restrict] = ACTIONS(2980),
    [anon_sym___restrict__] = ACTIONS(2980),
    [anon_sym__Atomic] = ACTIONS(2980),
    [anon_sym__Noreturn] = ACTIONS(2980),
    [anon_sym_noreturn] = ACTIONS(2980),
    [anon_sym__Nonnull] = ACTIONS(2980),
    [anon_sym_mutable] = ACTIONS(2980),
    [anon_sym_constinit] = ACTIONS(2980),
    [anon_sym_consteval] = ACTIONS(2980),
    [anon_sym_alignas] = ACTIONS(2980),
    [anon_sym__Alignas] = ACTIONS(2980),
    [sym_primitive_type] = ACTIONS(2980),
    [anon_sym_enum] = ACTIONS(2980),
    [anon_sym_class] = ACTIONS(2980),
    [anon_sym_struct] = ACTIONS(2980),
    [anon_sym_union] = ACTIONS(2980),
    [anon_sym_if] = ACTIONS(2980),
    [anon_sym_switch] = ACTIONS(2980),
    [anon_sym_case] = ACTIONS(2980),
    [anon_sym_default] = ACTIONS(2980),
    [anon_sym_while] = ACTIONS(2980),
    [anon_sym_do] = ACTIONS(2980),
    [anon_sym_for] = ACTIONS(2980),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_break] = ACTIONS(2980),
    [anon_sym_continue] = ACTIONS(2980),
    [anon_sym_goto] = ACTIONS(2980),
    [anon_sym___try] = ACTIONS(2980),
    [anon_sym___leave] = ACTIONS(2980),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_compl] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2982),
    [anon_sym_PLUS_PLUS] = ACTIONS(2982),
    [anon_sym_sizeof] = ACTIONS(2980),
    [anon_sym___alignof__] = ACTIONS(2980),
    [anon_sym___alignof] = ACTIONS(2980),
    [anon_sym__alignof] = ACTIONS(2980),
    [anon_sym_alignof] = ACTIONS(2980),
    [anon_sym__Alignof] = ACTIONS(2980),
    [anon_sym_offsetof] = ACTIONS(2980),
    [anon_sym__Generic] = ACTIONS(2980),
    [anon_sym_asm] = ACTIONS(2980),
    [anon_sym___asm__] = ACTIONS(2980),
    [anon_sym___asm] = ACTIONS(2980),
    [sym_number_literal] = ACTIONS(2982),
    [anon_sym_L_SQUOTE] = ACTIONS(2982),
    [anon_sym_u_SQUOTE] = ACTIONS(2982),
    [anon_sym_U_SQUOTE] = ACTIONS(2982),
    [anon_sym_u8_SQUOTE] = ACTIONS(2982),
    [anon_sym_SQUOTE] = ACTIONS(2982),
    [anon_sym_L_DQUOTE] = ACTIONS(2982),
    [anon_sym_u_DQUOTE] = ACTIONS(2982),
    [anon_sym_U_DQUOTE] = ACTIONS(2982),
    [anon_sym_u8_DQUOTE] = ACTIONS(2982),
    [anon_sym_DQUOTE] = ACTIONS(2982),
    [sym_true] = ACTIONS(2980),
    [sym_false] = ACTIONS(2980),
    [anon_sym_NULL] = ACTIONS(2980),
    [anon_sym_nullptr] = ACTIONS(2980),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2980),
    [anon_sym_decltype] = ACTIONS(2980),
    [anon_sym_explicit] = ACTIONS(2980),
    [anon_sym_typename] = ACTIONS(2980),
    [anon_sym_template] = ACTIONS(2980),
    [anon_sym_operator] = ACTIONS(2980),
    [anon_sym_try] = ACTIONS(2980),
    [anon_sym_delete] = ACTIONS(2980),
    [anon_sym_throw] = ACTIONS(2980),
    [anon_sym_namespace] = ACTIONS(2980),
    [anon_sym_using] = ACTIONS(2980),
    [anon_sym_static_assert] = ACTIONS(2980),
    [anon_sym_concept] = ACTIONS(2980),
    [anon_sym_co_return] = ACTIONS(2980),
    [anon_sym_co_yield] = ACTIONS(2980),
    [anon_sym_R_DQUOTE] = ACTIONS(2982),
    [anon_sym_LR_DQUOTE] = ACTIONS(2982),
    [anon_sym_uR_DQUOTE] = ACTIONS(2982),
    [anon_sym_UR_DQUOTE] = ACTIONS(2982),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2982),
    [anon_sym_co_await] = ACTIONS(2980),
    [anon_sym_new] = ACTIONS(2980),
    [anon_sym_requires] = ACTIONS(2980),
    [sym_this] = ACTIONS(2980),
  },
  [314] = {
    [sym_catch_clause] = STATE(314),
    [aux_sym_constructor_try_statement_repeat1] = STATE(314),
    [sym_identifier] = ACTIONS(2439),
    [aux_sym_preproc_include_token1] = ACTIONS(2439),
    [aux_sym_preproc_def_token1] = ACTIONS(2439),
    [aux_sym_preproc_if_token1] = ACTIONS(2439),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2439),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2439),
    [sym_preproc_directive] = ACTIONS(2439),
    [anon_sym_LPAREN2] = ACTIONS(2441),
    [anon_sym_BANG] = ACTIONS(2441),
    [anon_sym_TILDE] = ACTIONS(2441),
    [anon_sym_DASH] = ACTIONS(2439),
    [anon_sym_PLUS] = ACTIONS(2439),
    [anon_sym_STAR] = ACTIONS(2441),
    [anon_sym_AMP_AMP] = ACTIONS(2441),
    [anon_sym_AMP] = ACTIONS(2439),
    [anon_sym_SEMI] = ACTIONS(2441),
    [anon_sym___extension__] = ACTIONS(2439),
    [anon_sym_typedef] = ACTIONS(2439),
    [anon_sym_virtual] = ACTIONS(2439),
    [anon_sym_extern] = ACTIONS(2439),
    [anon_sym___attribute__] = ACTIONS(2439),
    [anon_sym___attribute] = ACTIONS(2439),
    [anon_sym_COLON_COLON] = ACTIONS(2441),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2441),
    [anon_sym___declspec] = ACTIONS(2439),
    [anon_sym___based] = ACTIONS(2439),
    [anon_sym___cdecl] = ACTIONS(2439),
    [anon_sym___clrcall] = ACTIONS(2439),
    [anon_sym___stdcall] = ACTIONS(2439),
    [anon_sym___fastcall] = ACTIONS(2439),
    [anon_sym___thiscall] = ACTIONS(2439),
    [anon_sym___vectorcall] = ACTIONS(2439),
    [anon_sym_LBRACE] = ACTIONS(2441),
    [anon_sym_RBRACE] = ACTIONS(2441),
    [anon_sym_signed] = ACTIONS(2439),
    [anon_sym_unsigned] = ACTIONS(2439),
    [anon_sym_long] = ACTIONS(2439),
    [anon_sym_short] = ACTIONS(2439),
    [anon_sym_LBRACK] = ACTIONS(2439),
    [anon_sym_static] = ACTIONS(2439),
    [anon_sym_register] = ACTIONS(2439),
    [anon_sym_inline] = ACTIONS(2439),
    [anon_sym___inline] = ACTIONS(2439),
    [anon_sym___inline__] = ACTIONS(2439),
    [anon_sym___forceinline] = ACTIONS(2439),
    [anon_sym_thread_local] = ACTIONS(2439),
    [anon_sym___thread] = ACTIONS(2439),
    [anon_sym_const] = ACTIONS(2439),
    [anon_sym_constexpr] = ACTIONS(2439),
    [anon_sym_volatile] = ACTIONS(2439),
    [anon_sym_restrict] = ACTIONS(2439),
    [anon_sym___restrict__] = ACTIONS(2439),
    [anon_sym__Atomic] = ACTIONS(2439),
    [anon_sym__Noreturn] = ACTIONS(2439),
    [anon_sym_noreturn] = ACTIONS(2439),
    [anon_sym__Nonnull] = ACTIONS(2439),
    [anon_sym_mutable] = ACTIONS(2439),
    [anon_sym_constinit] = ACTIONS(2439),
    [anon_sym_consteval] = ACTIONS(2439),
    [anon_sym_alignas] = ACTIONS(2439),
    [anon_sym__Alignas] = ACTIONS(2439),
    [sym_primitive_type] = ACTIONS(2439),
    [anon_sym_enum] = ACTIONS(2439),
    [anon_sym_class] = ACTIONS(2439),
    [anon_sym_struct] = ACTIONS(2439),
    [anon_sym_union] = ACTIONS(2439),
    [anon_sym_if] = ACTIONS(2439),
    [anon_sym_else] = ACTIONS(2439),
    [anon_sym_switch] = ACTIONS(2439),
    [anon_sym_case] = ACTIONS(2439),
    [anon_sym_default] = ACTIONS(2439),
    [anon_sym_while] = ACTIONS(2439),
    [anon_sym_do] = ACTIONS(2439),
    [anon_sym_for] = ACTIONS(2439),
    [anon_sym_return] = ACTIONS(2439),
    [anon_sym_break] = ACTIONS(2439),
    [anon_sym_continue] = ACTIONS(2439),
    [anon_sym_goto] = ACTIONS(2439),
    [anon_sym___try] = ACTIONS(2439),
    [anon_sym___leave] = ACTIONS(2439),
    [anon_sym_not] = ACTIONS(2439),
    [anon_sym_compl] = ACTIONS(2439),
    [anon_sym_DASH_DASH] = ACTIONS(2441),
    [anon_sym_PLUS_PLUS] = ACTIONS(2441),
    [anon_sym_sizeof] = ACTIONS(2439),
    [anon_sym___alignof__] = ACTIONS(2439),
    [anon_sym___alignof] = ACTIONS(2439),
    [anon_sym__alignof] = ACTIONS(2439),
    [anon_sym_alignof] = ACTIONS(2439),
    [anon_sym__Alignof] = ACTIONS(2439),
    [anon_sym_offsetof] = ACTIONS(2439),
    [anon_sym__Generic] = ACTIONS(2439),
    [anon_sym_asm] = ACTIONS(2439),
    [anon_sym___asm__] = ACTIONS(2439),
    [anon_sym___asm] = ACTIONS(2439),
    [sym_number_literal] = ACTIONS(2441),
    [anon_sym_L_SQUOTE] = ACTIONS(2441),
    [anon_sym_u_SQUOTE] = ACTIONS(2441),
    [anon_sym_U_SQUOTE] = ACTIONS(2441),
    [anon_sym_u8_SQUOTE] = ACTIONS(2441),
    [anon_sym_SQUOTE] = ACTIONS(2441),
    [anon_sym_L_DQUOTE] = ACTIONS(2441),
    [anon_sym_u_DQUOTE] = ACTIONS(2441),
    [anon_sym_U_DQUOTE] = ACTIONS(2441),
    [anon_sym_u8_DQUOTE] = ACTIONS(2441),
    [anon_sym_DQUOTE] = ACTIONS(2441),
    [sym_true] = ACTIONS(2439),
    [sym_false] = ACTIONS(2439),
    [anon_sym_NULL] = ACTIONS(2439),
    [anon_sym_nullptr] = ACTIONS(2439),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2439),
    [anon_sym_decltype] = ACTIONS(2439),
    [anon_sym_explicit] = ACTIONS(2439),
    [anon_sym_typename] = ACTIONS(2439),
    [anon_sym_template] = ACTIONS(2439),
    [anon_sym_operator] = ACTIONS(2439),
    [anon_sym_try] = ACTIONS(2439),
    [anon_sym_delete] = ACTIONS(2439),
    [anon_sym_throw] = ACTIONS(2439),
    [anon_sym_namespace] = ACTIONS(2439),
    [anon_sym_using] = ACTIONS(2439),
    [anon_sym_static_assert] = ACTIONS(2439),
    [anon_sym_concept] = ACTIONS(2439),
    [anon_sym_co_return] = ACTIONS(2439),
    [anon_sym_co_yield] = ACTIONS(2439),
    [anon_sym_catch] = ACTIONS(2984),
    [anon_sym_R_DQUOTE] = ACTIONS(2441),
    [anon_sym_LR_DQUOTE] = ACTIONS(2441),
    [anon_sym_uR_DQUOTE] = ACTIONS(2441),
    [anon_sym_UR_DQUOTE] = ACTIONS(2441),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2441),
    [anon_sym_co_await] = ACTIONS(2439),
    [anon_sym_new] = ACTIONS(2439),
    [anon_sym_requires] = ACTIONS(2439),
    [sym_this] = ACTIONS(2439),
  },
  [315] = {
    [sym_type_qualifier] = STATE(3798),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4559),
    [sym_sized_type_specifier] = STATE(2651),
    [sym_enum_specifier] = STATE(2651),
    [sym_struct_specifier] = STATE(2651),
    [sym_union_specifier] = STATE(2651),
    [sym_expression] = STATE(4330),
    [sym__string] = STATE(4637),
    [sym_conditional_expression] = STATE(4735),
    [sym_assignment_expression] = STATE(4735),
    [sym_pointer_expression] = STATE(3573),
    [sym_unary_expression] = STATE(4735),
    [sym_binary_expression] = STATE(4735),
    [sym_update_expression] = STATE(4735),
    [sym_cast_expression] = STATE(4735),
    [sym_type_descriptor] = STATE(7024),
    [sym_sizeof_expression] = STATE(4735),
    [sym_alignof_expression] = STATE(4735),
    [sym_offsetof_expression] = STATE(4735),
    [sym_generic_expression] = STATE(4735),
    [sym_subscript_expression] = STATE(3573),
    [sym_call_expression] = STATE(3573),
    [sym_gnu_asm_expression] = STATE(4735),
    [sym_extension_expression] = STATE(4735),
    [sym_field_expression] = STATE(3573),
    [sym_compound_literal_expression] = STATE(4735),
    [sym_parenthesized_expression] = STATE(3573),
    [sym_char_literal] = STATE(4637),
    [sym_concatenated_string] = STATE(4637),
    [sym_string_literal] = STATE(3662),
    [sym_null] = STATE(4735),
    [sym_placeholder_type_specifier] = STATE(2651),
    [sym_decltype_auto] = STATE(2637),
    [sym_decltype] = STATE(2563),
    [sym_class_specifier] = STATE(2651),
    [sym__class_name] = STATE(7513),
    [sym_dependent_type] = STATE(2651),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(4735),
    [sym_raw_string_literal] = STATE(3662),
    [sym_co_await_expression] = STATE(4735),
    [sym_new_expression] = STATE(4735),
    [sym_delete_expression] = STATE(4735),
    [sym_requires_clause] = STATE(4735),
    [sym_requires_expression] = STATE(4735),
    [sym_lambda_expression] = STATE(4735),
    [sym_lambda_capture_specifier] = STATE(5854),
    [sym_fold_expression] = STATE(4735),
    [sym_parameter_pack_expansion] = STATE(4735),
    [sym_type_parameter_pack_expansion] = STATE(7061),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5693),
    [sym_qualified_identifier] = STATE(3573),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym_user_defined_literal] = STATE(3573),
    [aux_sym__type_definition_type_repeat1] = STATE(3798),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4167),
    [sym_identifier] = ACTIONS(2854),
    [anon_sym_LPAREN2] = ACTIONS(2856),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(2864),
    [anon_sym_COLON_COLON] = ACTIONS(2866),
    [anon_sym_signed] = ACTIONS(2868),
    [anon_sym_unsigned] = ACTIONS(2868),
    [anon_sym_long] = ACTIONS(2868),
    [anon_sym_short] = ACTIONS(2868),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(2870),
    [anon_sym_enum] = ACTIONS(2872),
    [anon_sym_class] = ACTIONS(2874),
    [anon_sym_struct] = ACTIONS(2876),
    [anon_sym_union] = ACTIONS(2878),
    [anon_sym_not] = ACTIONS(2860),
    [anon_sym_compl] = ACTIONS(2860),
    [anon_sym_DASH_DASH] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(2880),
    [anon_sym_sizeof] = ACTIONS(2882),
    [anon_sym___alignof__] = ACTIONS(2884),
    [anon_sym___alignof] = ACTIONS(2884),
    [anon_sym__alignof] = ACTIONS(2884),
    [anon_sym_alignof] = ACTIONS(2884),
    [anon_sym__Alignof] = ACTIONS(2884),
    [anon_sym_offsetof] = ACTIONS(2886),
    [anon_sym__Generic] = ACTIONS(2888),
    [anon_sym_asm] = ACTIONS(2890),
    [anon_sym___asm__] = ACTIONS(2890),
    [anon_sym___asm] = ACTIONS(2890),
    [sym_number_literal] = ACTIONS(2892),
    [anon_sym_L_SQUOTE] = ACTIONS(2894),
    [anon_sym_u_SQUOTE] = ACTIONS(2894),
    [anon_sym_U_SQUOTE] = ACTIONS(2894),
    [anon_sym_u8_SQUOTE] = ACTIONS(2894),
    [anon_sym_SQUOTE] = ACTIONS(2894),
    [anon_sym_L_DQUOTE] = ACTIONS(2896),
    [anon_sym_u_DQUOTE] = ACTIONS(2896),
    [anon_sym_U_DQUOTE] = ACTIONS(2896),
    [anon_sym_u8_DQUOTE] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [anon_sym_NULL] = ACTIONS(2900),
    [anon_sym_nullptr] = ACTIONS(2900),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2902),
    [anon_sym_decltype] = ACTIONS(2904),
    [anon_sym_typename] = ACTIONS(2906),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_GT2] = ACTIONS(2987),
    [anon_sym_delete] = ACTIONS(2910),
    [anon_sym_R_DQUOTE] = ACTIONS(2912),
    [anon_sym_LR_DQUOTE] = ACTIONS(2912),
    [anon_sym_uR_DQUOTE] = ACTIONS(2912),
    [anon_sym_UR_DQUOTE] = ACTIONS(2912),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2912),
    [anon_sym_co_await] = ACTIONS(2914),
    [anon_sym_new] = ACTIONS(2916),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2898),
  },
  [316] = {
    [sym_expression] = STATE(4400),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(7914),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(2989),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(2992),
    [anon_sym___extension__] = ACTIONS(2994),
    [anon_sym_virtual] = ACTIONS(2629),
    [anon_sym_extern] = ACTIONS(2629),
    [anon_sym___attribute__] = ACTIONS(2629),
    [anon_sym___attribute] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(2997),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2631),
    [anon_sym___declspec] = ACTIONS(2629),
    [anon_sym_signed] = ACTIONS(2629),
    [anon_sym_unsigned] = ACTIONS(2629),
    [anon_sym_long] = ACTIONS(2629),
    [anon_sym_short] = ACTIONS(2629),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(2629),
    [anon_sym_register] = ACTIONS(2629),
    [anon_sym_inline] = ACTIONS(2629),
    [anon_sym___inline] = ACTIONS(2629),
    [anon_sym___inline__] = ACTIONS(2629),
    [anon_sym___forceinline] = ACTIONS(2629),
    [anon_sym_thread_local] = ACTIONS(2629),
    [anon_sym___thread] = ACTIONS(2629),
    [anon_sym_const] = ACTIONS(2629),
    [anon_sym_constexpr] = ACTIONS(2629),
    [anon_sym_volatile] = ACTIONS(2629),
    [anon_sym_restrict] = ACTIONS(2629),
    [anon_sym___restrict__] = ACTIONS(2629),
    [anon_sym__Atomic] = ACTIONS(2629),
    [anon_sym__Noreturn] = ACTIONS(2629),
    [anon_sym_noreturn] = ACTIONS(2629),
    [anon_sym__Nonnull] = ACTIONS(2629),
    [anon_sym_mutable] = ACTIONS(2629),
    [anon_sym_constinit] = ACTIONS(2629),
    [anon_sym_consteval] = ACTIONS(2629),
    [anon_sym_alignas] = ACTIONS(2629),
    [anon_sym__Alignas] = ACTIONS(2629),
    [sym_primitive_type] = ACTIONS(3000),
    [anon_sym_enum] = ACTIONS(2629),
    [anon_sym_class] = ACTIONS(2629),
    [anon_sym_struct] = ACTIONS(2629),
    [anon_sym_union] = ACTIONS(2629),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2629),
    [anon_sym_decltype] = ACTIONS(3003),
    [anon_sym_typename] = ACTIONS(2629),
    [anon_sym_template] = ACTIONS(3006),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [317] = {
    [sym_identifier] = ACTIONS(3009),
    [aux_sym_preproc_include_token1] = ACTIONS(3009),
    [aux_sym_preproc_def_token1] = ACTIONS(3009),
    [aux_sym_preproc_if_token1] = ACTIONS(3009),
    [aux_sym_preproc_if_token2] = ACTIONS(3009),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3009),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3009),
    [aux_sym_preproc_else_token1] = ACTIONS(3009),
    [aux_sym_preproc_elif_token1] = ACTIONS(3009),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3009),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3009),
    [sym_preproc_directive] = ACTIONS(3009),
    [anon_sym_LPAREN2] = ACTIONS(3011),
    [anon_sym_BANG] = ACTIONS(3011),
    [anon_sym_TILDE] = ACTIONS(3011),
    [anon_sym_DASH] = ACTIONS(3009),
    [anon_sym_PLUS] = ACTIONS(3009),
    [anon_sym_STAR] = ACTIONS(3011),
    [anon_sym_AMP_AMP] = ACTIONS(3011),
    [anon_sym_AMP] = ACTIONS(3009),
    [anon_sym_SEMI] = ACTIONS(3011),
    [anon_sym___extension__] = ACTIONS(3009),
    [anon_sym_typedef] = ACTIONS(3009),
    [anon_sym_virtual] = ACTIONS(3009),
    [anon_sym_extern] = ACTIONS(3009),
    [anon_sym___attribute__] = ACTIONS(3009),
    [anon_sym___attribute] = ACTIONS(3009),
    [anon_sym_COLON_COLON] = ACTIONS(3011),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3011),
    [anon_sym___declspec] = ACTIONS(3009),
    [anon_sym___based] = ACTIONS(3009),
    [anon_sym___cdecl] = ACTIONS(3009),
    [anon_sym___clrcall] = ACTIONS(3009),
    [anon_sym___stdcall] = ACTIONS(3009),
    [anon_sym___fastcall] = ACTIONS(3009),
    [anon_sym___thiscall] = ACTIONS(3009),
    [anon_sym___vectorcall] = ACTIONS(3009),
    [anon_sym_LBRACE] = ACTIONS(3011),
    [anon_sym_signed] = ACTIONS(3009),
    [anon_sym_unsigned] = ACTIONS(3009),
    [anon_sym_long] = ACTIONS(3009),
    [anon_sym_short] = ACTIONS(3009),
    [anon_sym_LBRACK] = ACTIONS(3009),
    [anon_sym_static] = ACTIONS(3009),
    [anon_sym_register] = ACTIONS(3009),
    [anon_sym_inline] = ACTIONS(3009),
    [anon_sym___inline] = ACTIONS(3009),
    [anon_sym___inline__] = ACTIONS(3009),
    [anon_sym___forceinline] = ACTIONS(3009),
    [anon_sym_thread_local] = ACTIONS(3009),
    [anon_sym___thread] = ACTIONS(3009),
    [anon_sym_const] = ACTIONS(3009),
    [anon_sym_constexpr] = ACTIONS(3009),
    [anon_sym_volatile] = ACTIONS(3009),
    [anon_sym_restrict] = ACTIONS(3009),
    [anon_sym___restrict__] = ACTIONS(3009),
    [anon_sym__Atomic] = ACTIONS(3009),
    [anon_sym__Noreturn] = ACTIONS(3009),
    [anon_sym_noreturn] = ACTIONS(3009),
    [anon_sym__Nonnull] = ACTIONS(3009),
    [anon_sym_mutable] = ACTIONS(3009),
    [anon_sym_constinit] = ACTIONS(3009),
    [anon_sym_consteval] = ACTIONS(3009),
    [anon_sym_alignas] = ACTIONS(3009),
    [anon_sym__Alignas] = ACTIONS(3009),
    [sym_primitive_type] = ACTIONS(3009),
    [anon_sym_enum] = ACTIONS(3009),
    [anon_sym_class] = ACTIONS(3009),
    [anon_sym_struct] = ACTIONS(3009),
    [anon_sym_union] = ACTIONS(3009),
    [anon_sym_if] = ACTIONS(3009),
    [anon_sym_switch] = ACTIONS(3009),
    [anon_sym_case] = ACTIONS(3009),
    [anon_sym_default] = ACTIONS(3009),
    [anon_sym_while] = ACTIONS(3009),
    [anon_sym_do] = ACTIONS(3009),
    [anon_sym_for] = ACTIONS(3009),
    [anon_sym_return] = ACTIONS(3009),
    [anon_sym_break] = ACTIONS(3009),
    [anon_sym_continue] = ACTIONS(3009),
    [anon_sym_goto] = ACTIONS(3009),
    [anon_sym___try] = ACTIONS(3009),
    [anon_sym___leave] = ACTIONS(3009),
    [anon_sym_not] = ACTIONS(3009),
    [anon_sym_compl] = ACTIONS(3009),
    [anon_sym_DASH_DASH] = ACTIONS(3011),
    [anon_sym_PLUS_PLUS] = ACTIONS(3011),
    [anon_sym_sizeof] = ACTIONS(3009),
    [anon_sym___alignof__] = ACTIONS(3009),
    [anon_sym___alignof] = ACTIONS(3009),
    [anon_sym__alignof] = ACTIONS(3009),
    [anon_sym_alignof] = ACTIONS(3009),
    [anon_sym__Alignof] = ACTIONS(3009),
    [anon_sym_offsetof] = ACTIONS(3009),
    [anon_sym__Generic] = ACTIONS(3009),
    [anon_sym_asm] = ACTIONS(3009),
    [anon_sym___asm__] = ACTIONS(3009),
    [anon_sym___asm] = ACTIONS(3009),
    [sym_number_literal] = ACTIONS(3011),
    [anon_sym_L_SQUOTE] = ACTIONS(3011),
    [anon_sym_u_SQUOTE] = ACTIONS(3011),
    [anon_sym_U_SQUOTE] = ACTIONS(3011),
    [anon_sym_u8_SQUOTE] = ACTIONS(3011),
    [anon_sym_SQUOTE] = ACTIONS(3011),
    [anon_sym_L_DQUOTE] = ACTIONS(3011),
    [anon_sym_u_DQUOTE] = ACTIONS(3011),
    [anon_sym_U_DQUOTE] = ACTIONS(3011),
    [anon_sym_u8_DQUOTE] = ACTIONS(3011),
    [anon_sym_DQUOTE] = ACTIONS(3011),
    [sym_true] = ACTIONS(3009),
    [sym_false] = ACTIONS(3009),
    [anon_sym_NULL] = ACTIONS(3009),
    [anon_sym_nullptr] = ACTIONS(3009),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3009),
    [anon_sym_decltype] = ACTIONS(3009),
    [anon_sym_explicit] = ACTIONS(3009),
    [anon_sym_typename] = ACTIONS(3009),
    [anon_sym_template] = ACTIONS(3009),
    [anon_sym_operator] = ACTIONS(3009),
    [anon_sym_try] = ACTIONS(3009),
    [anon_sym_delete] = ACTIONS(3009),
    [anon_sym_throw] = ACTIONS(3009),
    [anon_sym_namespace] = ACTIONS(3009),
    [anon_sym_using] = ACTIONS(3009),
    [anon_sym_static_assert] = ACTIONS(3009),
    [anon_sym_concept] = ACTIONS(3009),
    [anon_sym_co_return] = ACTIONS(3009),
    [anon_sym_co_yield] = ACTIONS(3009),
    [anon_sym_R_DQUOTE] = ACTIONS(3011),
    [anon_sym_LR_DQUOTE] = ACTIONS(3011),
    [anon_sym_uR_DQUOTE] = ACTIONS(3011),
    [anon_sym_UR_DQUOTE] = ACTIONS(3011),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3011),
    [anon_sym_co_await] = ACTIONS(3009),
    [anon_sym_new] = ACTIONS(3009),
    [anon_sym_requires] = ACTIONS(3009),
    [sym_this] = ACTIONS(3009),
  },
  [318] = {
    [sym_identifier] = ACTIONS(3013),
    [aux_sym_preproc_include_token1] = ACTIONS(3013),
    [aux_sym_preproc_def_token1] = ACTIONS(3013),
    [aux_sym_preproc_if_token1] = ACTIONS(3013),
    [aux_sym_preproc_if_token2] = ACTIONS(3013),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3013),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3013),
    [aux_sym_preproc_else_token1] = ACTIONS(3013),
    [aux_sym_preproc_elif_token1] = ACTIONS(3013),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3013),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3013),
    [sym_preproc_directive] = ACTIONS(3013),
    [anon_sym_LPAREN2] = ACTIONS(3015),
    [anon_sym_BANG] = ACTIONS(3015),
    [anon_sym_TILDE] = ACTIONS(3015),
    [anon_sym_DASH] = ACTIONS(3013),
    [anon_sym_PLUS] = ACTIONS(3013),
    [anon_sym_STAR] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3015),
    [anon_sym_AMP] = ACTIONS(3013),
    [anon_sym_SEMI] = ACTIONS(3015),
    [anon_sym___extension__] = ACTIONS(3013),
    [anon_sym_typedef] = ACTIONS(3013),
    [anon_sym_virtual] = ACTIONS(3013),
    [anon_sym_extern] = ACTIONS(3013),
    [anon_sym___attribute__] = ACTIONS(3013),
    [anon_sym___attribute] = ACTIONS(3013),
    [anon_sym_COLON_COLON] = ACTIONS(3015),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3015),
    [anon_sym___declspec] = ACTIONS(3013),
    [anon_sym___based] = ACTIONS(3013),
    [anon_sym___cdecl] = ACTIONS(3013),
    [anon_sym___clrcall] = ACTIONS(3013),
    [anon_sym___stdcall] = ACTIONS(3013),
    [anon_sym___fastcall] = ACTIONS(3013),
    [anon_sym___thiscall] = ACTIONS(3013),
    [anon_sym___vectorcall] = ACTIONS(3013),
    [anon_sym_LBRACE] = ACTIONS(3015),
    [anon_sym_signed] = ACTIONS(3013),
    [anon_sym_unsigned] = ACTIONS(3013),
    [anon_sym_long] = ACTIONS(3013),
    [anon_sym_short] = ACTIONS(3013),
    [anon_sym_LBRACK] = ACTIONS(3013),
    [anon_sym_static] = ACTIONS(3013),
    [anon_sym_register] = ACTIONS(3013),
    [anon_sym_inline] = ACTIONS(3013),
    [anon_sym___inline] = ACTIONS(3013),
    [anon_sym___inline__] = ACTIONS(3013),
    [anon_sym___forceinline] = ACTIONS(3013),
    [anon_sym_thread_local] = ACTIONS(3013),
    [anon_sym___thread] = ACTIONS(3013),
    [anon_sym_const] = ACTIONS(3013),
    [anon_sym_constexpr] = ACTIONS(3013),
    [anon_sym_volatile] = ACTIONS(3013),
    [anon_sym_restrict] = ACTIONS(3013),
    [anon_sym___restrict__] = ACTIONS(3013),
    [anon_sym__Atomic] = ACTIONS(3013),
    [anon_sym__Noreturn] = ACTIONS(3013),
    [anon_sym_noreturn] = ACTIONS(3013),
    [anon_sym__Nonnull] = ACTIONS(3013),
    [anon_sym_mutable] = ACTIONS(3013),
    [anon_sym_constinit] = ACTIONS(3013),
    [anon_sym_consteval] = ACTIONS(3013),
    [anon_sym_alignas] = ACTIONS(3013),
    [anon_sym__Alignas] = ACTIONS(3013),
    [sym_primitive_type] = ACTIONS(3013),
    [anon_sym_enum] = ACTIONS(3013),
    [anon_sym_class] = ACTIONS(3013),
    [anon_sym_struct] = ACTIONS(3013),
    [anon_sym_union] = ACTIONS(3013),
    [anon_sym_if] = ACTIONS(3013),
    [anon_sym_switch] = ACTIONS(3013),
    [anon_sym_case] = ACTIONS(3013),
    [anon_sym_default] = ACTIONS(3013),
    [anon_sym_while] = ACTIONS(3013),
    [anon_sym_do] = ACTIONS(3013),
    [anon_sym_for] = ACTIONS(3013),
    [anon_sym_return] = ACTIONS(3013),
    [anon_sym_break] = ACTIONS(3013),
    [anon_sym_continue] = ACTIONS(3013),
    [anon_sym_goto] = ACTIONS(3013),
    [anon_sym___try] = ACTIONS(3013),
    [anon_sym___leave] = ACTIONS(3013),
    [anon_sym_not] = ACTIONS(3013),
    [anon_sym_compl] = ACTIONS(3013),
    [anon_sym_DASH_DASH] = ACTIONS(3015),
    [anon_sym_PLUS_PLUS] = ACTIONS(3015),
    [anon_sym_sizeof] = ACTIONS(3013),
    [anon_sym___alignof__] = ACTIONS(3013),
    [anon_sym___alignof] = ACTIONS(3013),
    [anon_sym__alignof] = ACTIONS(3013),
    [anon_sym_alignof] = ACTIONS(3013),
    [anon_sym__Alignof] = ACTIONS(3013),
    [anon_sym_offsetof] = ACTIONS(3013),
    [anon_sym__Generic] = ACTIONS(3013),
    [anon_sym_asm] = ACTIONS(3013),
    [anon_sym___asm__] = ACTIONS(3013),
    [anon_sym___asm] = ACTIONS(3013),
    [sym_number_literal] = ACTIONS(3015),
    [anon_sym_L_SQUOTE] = ACTIONS(3015),
    [anon_sym_u_SQUOTE] = ACTIONS(3015),
    [anon_sym_U_SQUOTE] = ACTIONS(3015),
    [anon_sym_u8_SQUOTE] = ACTIONS(3015),
    [anon_sym_SQUOTE] = ACTIONS(3015),
    [anon_sym_L_DQUOTE] = ACTIONS(3015),
    [anon_sym_u_DQUOTE] = ACTIONS(3015),
    [anon_sym_U_DQUOTE] = ACTIONS(3015),
    [anon_sym_u8_DQUOTE] = ACTIONS(3015),
    [anon_sym_DQUOTE] = ACTIONS(3015),
    [sym_true] = ACTIONS(3013),
    [sym_false] = ACTIONS(3013),
    [anon_sym_NULL] = ACTIONS(3013),
    [anon_sym_nullptr] = ACTIONS(3013),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3013),
    [anon_sym_decltype] = ACTIONS(3013),
    [anon_sym_explicit] = ACTIONS(3013),
    [anon_sym_typename] = ACTIONS(3013),
    [anon_sym_template] = ACTIONS(3013),
    [anon_sym_operator] = ACTIONS(3013),
    [anon_sym_try] = ACTIONS(3013),
    [anon_sym_delete] = ACTIONS(3013),
    [anon_sym_throw] = ACTIONS(3013),
    [anon_sym_namespace] = ACTIONS(3013),
    [anon_sym_using] = ACTIONS(3013),
    [anon_sym_static_assert] = ACTIONS(3013),
    [anon_sym_concept] = ACTIONS(3013),
    [anon_sym_co_return] = ACTIONS(3013),
    [anon_sym_co_yield] = ACTIONS(3013),
    [anon_sym_R_DQUOTE] = ACTIONS(3015),
    [anon_sym_LR_DQUOTE] = ACTIONS(3015),
    [anon_sym_uR_DQUOTE] = ACTIONS(3015),
    [anon_sym_UR_DQUOTE] = ACTIONS(3015),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3015),
    [anon_sym_co_await] = ACTIONS(3013),
    [anon_sym_new] = ACTIONS(3013),
    [anon_sym_requires] = ACTIONS(3013),
    [sym_this] = ACTIONS(3013),
  },
  [319] = {
    [sym_catch_clause] = STATE(319),
    [aux_sym_constructor_try_statement_repeat1] = STATE(319),
    [ts_builtin_sym_end] = ACTIONS(2441),
    [sym_identifier] = ACTIONS(2439),
    [aux_sym_preproc_include_token1] = ACTIONS(2439),
    [aux_sym_preproc_def_token1] = ACTIONS(2439),
    [aux_sym_preproc_if_token1] = ACTIONS(2439),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2439),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2439),
    [sym_preproc_directive] = ACTIONS(2439),
    [anon_sym_LPAREN2] = ACTIONS(2441),
    [anon_sym_BANG] = ACTIONS(2441),
    [anon_sym_TILDE] = ACTIONS(2441),
    [anon_sym_DASH] = ACTIONS(2439),
    [anon_sym_PLUS] = ACTIONS(2439),
    [anon_sym_STAR] = ACTIONS(2441),
    [anon_sym_AMP_AMP] = ACTIONS(2441),
    [anon_sym_AMP] = ACTIONS(2439),
    [anon_sym_SEMI] = ACTIONS(2441),
    [anon_sym___extension__] = ACTIONS(2439),
    [anon_sym_typedef] = ACTIONS(2439),
    [anon_sym_virtual] = ACTIONS(2439),
    [anon_sym_extern] = ACTIONS(2439),
    [anon_sym___attribute__] = ACTIONS(2439),
    [anon_sym___attribute] = ACTIONS(2439),
    [anon_sym_COLON_COLON] = ACTIONS(2441),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2441),
    [anon_sym___declspec] = ACTIONS(2439),
    [anon_sym___based] = ACTIONS(2439),
    [anon_sym___cdecl] = ACTIONS(2439),
    [anon_sym___clrcall] = ACTIONS(2439),
    [anon_sym___stdcall] = ACTIONS(2439),
    [anon_sym___fastcall] = ACTIONS(2439),
    [anon_sym___thiscall] = ACTIONS(2439),
    [anon_sym___vectorcall] = ACTIONS(2439),
    [anon_sym_LBRACE] = ACTIONS(2441),
    [anon_sym_signed] = ACTIONS(2439),
    [anon_sym_unsigned] = ACTIONS(2439),
    [anon_sym_long] = ACTIONS(2439),
    [anon_sym_short] = ACTIONS(2439),
    [anon_sym_LBRACK] = ACTIONS(2439),
    [anon_sym_static] = ACTIONS(2439),
    [anon_sym_register] = ACTIONS(2439),
    [anon_sym_inline] = ACTIONS(2439),
    [anon_sym___inline] = ACTIONS(2439),
    [anon_sym___inline__] = ACTIONS(2439),
    [anon_sym___forceinline] = ACTIONS(2439),
    [anon_sym_thread_local] = ACTIONS(2439),
    [anon_sym___thread] = ACTIONS(2439),
    [anon_sym_const] = ACTIONS(2439),
    [anon_sym_constexpr] = ACTIONS(2439),
    [anon_sym_volatile] = ACTIONS(2439),
    [anon_sym_restrict] = ACTIONS(2439),
    [anon_sym___restrict__] = ACTIONS(2439),
    [anon_sym__Atomic] = ACTIONS(2439),
    [anon_sym__Noreturn] = ACTIONS(2439),
    [anon_sym_noreturn] = ACTIONS(2439),
    [anon_sym__Nonnull] = ACTIONS(2439),
    [anon_sym_mutable] = ACTIONS(2439),
    [anon_sym_constinit] = ACTIONS(2439),
    [anon_sym_consteval] = ACTIONS(2439),
    [anon_sym_alignas] = ACTIONS(2439),
    [anon_sym__Alignas] = ACTIONS(2439),
    [sym_primitive_type] = ACTIONS(2439),
    [anon_sym_enum] = ACTIONS(2439),
    [anon_sym_class] = ACTIONS(2439),
    [anon_sym_struct] = ACTIONS(2439),
    [anon_sym_union] = ACTIONS(2439),
    [anon_sym_if] = ACTIONS(2439),
    [anon_sym_else] = ACTIONS(2439),
    [anon_sym_switch] = ACTIONS(2439),
    [anon_sym_case] = ACTIONS(2439),
    [anon_sym_default] = ACTIONS(2439),
    [anon_sym_while] = ACTIONS(2439),
    [anon_sym_do] = ACTIONS(2439),
    [anon_sym_for] = ACTIONS(2439),
    [anon_sym_return] = ACTIONS(2439),
    [anon_sym_break] = ACTIONS(2439),
    [anon_sym_continue] = ACTIONS(2439),
    [anon_sym_goto] = ACTIONS(2439),
    [anon_sym___try] = ACTIONS(2439),
    [anon_sym___leave] = ACTIONS(2439),
    [anon_sym_not] = ACTIONS(2439),
    [anon_sym_compl] = ACTIONS(2439),
    [anon_sym_DASH_DASH] = ACTIONS(2441),
    [anon_sym_PLUS_PLUS] = ACTIONS(2441),
    [anon_sym_sizeof] = ACTIONS(2439),
    [anon_sym___alignof__] = ACTIONS(2439),
    [anon_sym___alignof] = ACTIONS(2439),
    [anon_sym__alignof] = ACTIONS(2439),
    [anon_sym_alignof] = ACTIONS(2439),
    [anon_sym__Alignof] = ACTIONS(2439),
    [anon_sym_offsetof] = ACTIONS(2439),
    [anon_sym__Generic] = ACTIONS(2439),
    [anon_sym_asm] = ACTIONS(2439),
    [anon_sym___asm__] = ACTIONS(2439),
    [anon_sym___asm] = ACTIONS(2439),
    [sym_number_literal] = ACTIONS(2441),
    [anon_sym_L_SQUOTE] = ACTIONS(2441),
    [anon_sym_u_SQUOTE] = ACTIONS(2441),
    [anon_sym_U_SQUOTE] = ACTIONS(2441),
    [anon_sym_u8_SQUOTE] = ACTIONS(2441),
    [anon_sym_SQUOTE] = ACTIONS(2441),
    [anon_sym_L_DQUOTE] = ACTIONS(2441),
    [anon_sym_u_DQUOTE] = ACTIONS(2441),
    [anon_sym_U_DQUOTE] = ACTIONS(2441),
    [anon_sym_u8_DQUOTE] = ACTIONS(2441),
    [anon_sym_DQUOTE] = ACTIONS(2441),
    [sym_true] = ACTIONS(2439),
    [sym_false] = ACTIONS(2439),
    [anon_sym_NULL] = ACTIONS(2439),
    [anon_sym_nullptr] = ACTIONS(2439),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2439),
    [anon_sym_decltype] = ACTIONS(2439),
    [anon_sym_explicit] = ACTIONS(2439),
    [anon_sym_typename] = ACTIONS(2439),
    [anon_sym_template] = ACTIONS(2439),
    [anon_sym_operator] = ACTIONS(2439),
    [anon_sym_try] = ACTIONS(2439),
    [anon_sym_delete] = ACTIONS(2439),
    [anon_sym_throw] = ACTIONS(2439),
    [anon_sym_namespace] = ACTIONS(2439),
    [anon_sym_using] = ACTIONS(2439),
    [anon_sym_static_assert] = ACTIONS(2439),
    [anon_sym_concept] = ACTIONS(2439),
    [anon_sym_co_return] = ACTIONS(2439),
    [anon_sym_co_yield] = ACTIONS(2439),
    [anon_sym_catch] = ACTIONS(3017),
    [anon_sym_R_DQUOTE] = ACTIONS(2441),
    [anon_sym_LR_DQUOTE] = ACTIONS(2441),
    [anon_sym_uR_DQUOTE] = ACTIONS(2441),
    [anon_sym_UR_DQUOTE] = ACTIONS(2441),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2441),
    [anon_sym_co_await] = ACTIONS(2439),
    [anon_sym_new] = ACTIONS(2439),
    [anon_sym_requires] = ACTIONS(2439),
    [sym_this] = ACTIONS(2439),
  },
  [320] = {
    [sym_identifier] = ACTIONS(3020),
    [aux_sym_preproc_include_token1] = ACTIONS(3020),
    [aux_sym_preproc_def_token1] = ACTIONS(3020),
    [aux_sym_preproc_if_token1] = ACTIONS(3020),
    [aux_sym_preproc_if_token2] = ACTIONS(3020),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3020),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3020),
    [aux_sym_preproc_else_token1] = ACTIONS(3020),
    [aux_sym_preproc_elif_token1] = ACTIONS(3020),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3020),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3020),
    [sym_preproc_directive] = ACTIONS(3020),
    [anon_sym_LPAREN2] = ACTIONS(3022),
    [anon_sym_BANG] = ACTIONS(3022),
    [anon_sym_TILDE] = ACTIONS(3022),
    [anon_sym_DASH] = ACTIONS(3020),
    [anon_sym_PLUS] = ACTIONS(3020),
    [anon_sym_STAR] = ACTIONS(3022),
    [anon_sym_AMP_AMP] = ACTIONS(3022),
    [anon_sym_AMP] = ACTIONS(3020),
    [anon_sym_SEMI] = ACTIONS(3022),
    [anon_sym___extension__] = ACTIONS(3020),
    [anon_sym_typedef] = ACTIONS(3020),
    [anon_sym_virtual] = ACTIONS(3020),
    [anon_sym_extern] = ACTIONS(3020),
    [anon_sym___attribute__] = ACTIONS(3020),
    [anon_sym___attribute] = ACTIONS(3020),
    [anon_sym_COLON_COLON] = ACTIONS(3022),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3022),
    [anon_sym___declspec] = ACTIONS(3020),
    [anon_sym___based] = ACTIONS(3020),
    [anon_sym___cdecl] = ACTIONS(3020),
    [anon_sym___clrcall] = ACTIONS(3020),
    [anon_sym___stdcall] = ACTIONS(3020),
    [anon_sym___fastcall] = ACTIONS(3020),
    [anon_sym___thiscall] = ACTIONS(3020),
    [anon_sym___vectorcall] = ACTIONS(3020),
    [anon_sym_LBRACE] = ACTIONS(3022),
    [anon_sym_signed] = ACTIONS(3020),
    [anon_sym_unsigned] = ACTIONS(3020),
    [anon_sym_long] = ACTIONS(3020),
    [anon_sym_short] = ACTIONS(3020),
    [anon_sym_LBRACK] = ACTIONS(3020),
    [anon_sym_static] = ACTIONS(3020),
    [anon_sym_register] = ACTIONS(3020),
    [anon_sym_inline] = ACTIONS(3020),
    [anon_sym___inline] = ACTIONS(3020),
    [anon_sym___inline__] = ACTIONS(3020),
    [anon_sym___forceinline] = ACTIONS(3020),
    [anon_sym_thread_local] = ACTIONS(3020),
    [anon_sym___thread] = ACTIONS(3020),
    [anon_sym_const] = ACTIONS(3020),
    [anon_sym_constexpr] = ACTIONS(3020),
    [anon_sym_volatile] = ACTIONS(3020),
    [anon_sym_restrict] = ACTIONS(3020),
    [anon_sym___restrict__] = ACTIONS(3020),
    [anon_sym__Atomic] = ACTIONS(3020),
    [anon_sym__Noreturn] = ACTIONS(3020),
    [anon_sym_noreturn] = ACTIONS(3020),
    [anon_sym__Nonnull] = ACTIONS(3020),
    [anon_sym_mutable] = ACTIONS(3020),
    [anon_sym_constinit] = ACTIONS(3020),
    [anon_sym_consteval] = ACTIONS(3020),
    [anon_sym_alignas] = ACTIONS(3020),
    [anon_sym__Alignas] = ACTIONS(3020),
    [sym_primitive_type] = ACTIONS(3020),
    [anon_sym_enum] = ACTIONS(3020),
    [anon_sym_class] = ACTIONS(3020),
    [anon_sym_struct] = ACTIONS(3020),
    [anon_sym_union] = ACTIONS(3020),
    [anon_sym_if] = ACTIONS(3020),
    [anon_sym_switch] = ACTIONS(3020),
    [anon_sym_case] = ACTIONS(3020),
    [anon_sym_default] = ACTIONS(3020),
    [anon_sym_while] = ACTIONS(3020),
    [anon_sym_do] = ACTIONS(3020),
    [anon_sym_for] = ACTIONS(3020),
    [anon_sym_return] = ACTIONS(3020),
    [anon_sym_break] = ACTIONS(3020),
    [anon_sym_continue] = ACTIONS(3020),
    [anon_sym_goto] = ACTIONS(3020),
    [anon_sym___try] = ACTIONS(3020),
    [anon_sym___leave] = ACTIONS(3020),
    [anon_sym_not] = ACTIONS(3020),
    [anon_sym_compl] = ACTIONS(3020),
    [anon_sym_DASH_DASH] = ACTIONS(3022),
    [anon_sym_PLUS_PLUS] = ACTIONS(3022),
    [anon_sym_sizeof] = ACTIONS(3020),
    [anon_sym___alignof__] = ACTIONS(3020),
    [anon_sym___alignof] = ACTIONS(3020),
    [anon_sym__alignof] = ACTIONS(3020),
    [anon_sym_alignof] = ACTIONS(3020),
    [anon_sym__Alignof] = ACTIONS(3020),
    [anon_sym_offsetof] = ACTIONS(3020),
    [anon_sym__Generic] = ACTIONS(3020),
    [anon_sym_asm] = ACTIONS(3020),
    [anon_sym___asm__] = ACTIONS(3020),
    [anon_sym___asm] = ACTIONS(3020),
    [sym_number_literal] = ACTIONS(3022),
    [anon_sym_L_SQUOTE] = ACTIONS(3022),
    [anon_sym_u_SQUOTE] = ACTIONS(3022),
    [anon_sym_U_SQUOTE] = ACTIONS(3022),
    [anon_sym_u8_SQUOTE] = ACTIONS(3022),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [anon_sym_L_DQUOTE] = ACTIONS(3022),
    [anon_sym_u_DQUOTE] = ACTIONS(3022),
    [anon_sym_U_DQUOTE] = ACTIONS(3022),
    [anon_sym_u8_DQUOTE] = ACTIONS(3022),
    [anon_sym_DQUOTE] = ACTIONS(3022),
    [sym_true] = ACTIONS(3020),
    [sym_false] = ACTIONS(3020),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3020),
    [anon_sym_decltype] = ACTIONS(3020),
    [anon_sym_explicit] = ACTIONS(3020),
    [anon_sym_typename] = ACTIONS(3020),
    [anon_sym_template] = ACTIONS(3020),
    [anon_sym_operator] = ACTIONS(3020),
    [anon_sym_try] = ACTIONS(3020),
    [anon_sym_delete] = ACTIONS(3020),
    [anon_sym_throw] = ACTIONS(3020),
    [anon_sym_namespace] = ACTIONS(3020),
    [anon_sym_using] = ACTIONS(3020),
    [anon_sym_static_assert] = ACTIONS(3020),
    [anon_sym_concept] = ACTIONS(3020),
    [anon_sym_co_return] = ACTIONS(3020),
    [anon_sym_co_yield] = ACTIONS(3020),
    [anon_sym_R_DQUOTE] = ACTIONS(3022),
    [anon_sym_LR_DQUOTE] = ACTIONS(3022),
    [anon_sym_uR_DQUOTE] = ACTIONS(3022),
    [anon_sym_UR_DQUOTE] = ACTIONS(3022),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3022),
    [anon_sym_co_await] = ACTIONS(3020),
    [anon_sym_new] = ACTIONS(3020),
    [anon_sym_requires] = ACTIONS(3020),
    [sym_this] = ACTIONS(3020),
  },
  [321] = {
    [sym_type_qualifier] = STATE(3798),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4559),
    [sym_sized_type_specifier] = STATE(2651),
    [sym_enum_specifier] = STATE(2651),
    [sym_struct_specifier] = STATE(2651),
    [sym_union_specifier] = STATE(2651),
    [sym_expression] = STATE(4344),
    [sym__string] = STATE(4637),
    [sym_conditional_expression] = STATE(4735),
    [sym_assignment_expression] = STATE(4735),
    [sym_pointer_expression] = STATE(3573),
    [sym_unary_expression] = STATE(4735),
    [sym_binary_expression] = STATE(4735),
    [sym_update_expression] = STATE(4735),
    [sym_cast_expression] = STATE(4735),
    [sym_type_descriptor] = STATE(6981),
    [sym_sizeof_expression] = STATE(4735),
    [sym_alignof_expression] = STATE(4735),
    [sym_offsetof_expression] = STATE(4735),
    [sym_generic_expression] = STATE(4735),
    [sym_subscript_expression] = STATE(3573),
    [sym_call_expression] = STATE(3573),
    [sym_gnu_asm_expression] = STATE(4735),
    [sym_extension_expression] = STATE(4735),
    [sym_field_expression] = STATE(3573),
    [sym_compound_literal_expression] = STATE(4735),
    [sym_parenthesized_expression] = STATE(3573),
    [sym_char_literal] = STATE(4637),
    [sym_concatenated_string] = STATE(4637),
    [sym_string_literal] = STATE(3662),
    [sym_null] = STATE(4735),
    [sym_placeholder_type_specifier] = STATE(2651),
    [sym_decltype_auto] = STATE(2637),
    [sym_decltype] = STATE(2563),
    [sym_class_specifier] = STATE(2651),
    [sym__class_name] = STATE(7513),
    [sym_dependent_type] = STATE(2651),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(4735),
    [sym_raw_string_literal] = STATE(3662),
    [sym_co_await_expression] = STATE(4735),
    [sym_new_expression] = STATE(4735),
    [sym_delete_expression] = STATE(4735),
    [sym_requires_clause] = STATE(4735),
    [sym_requires_expression] = STATE(4735),
    [sym_lambda_expression] = STATE(4735),
    [sym_lambda_capture_specifier] = STATE(5854),
    [sym_fold_expression] = STATE(4735),
    [sym_parameter_pack_expansion] = STATE(4735),
    [sym_type_parameter_pack_expansion] = STATE(7300),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5693),
    [sym_qualified_identifier] = STATE(3573),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym_user_defined_literal] = STATE(3573),
    [aux_sym__type_definition_type_repeat1] = STATE(3798),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4167),
    [sym_identifier] = ACTIONS(2854),
    [anon_sym_LPAREN2] = ACTIONS(2856),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(2864),
    [anon_sym_COLON_COLON] = ACTIONS(2866),
    [anon_sym_signed] = ACTIONS(2868),
    [anon_sym_unsigned] = ACTIONS(2868),
    [anon_sym_long] = ACTIONS(2868),
    [anon_sym_short] = ACTIONS(2868),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(2870),
    [anon_sym_enum] = ACTIONS(2872),
    [anon_sym_class] = ACTIONS(2874),
    [anon_sym_struct] = ACTIONS(2876),
    [anon_sym_union] = ACTIONS(2878),
    [anon_sym_not] = ACTIONS(2860),
    [anon_sym_compl] = ACTIONS(2860),
    [anon_sym_DASH_DASH] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(2880),
    [anon_sym_sizeof] = ACTIONS(2882),
    [anon_sym___alignof__] = ACTIONS(2884),
    [anon_sym___alignof] = ACTIONS(2884),
    [anon_sym__alignof] = ACTIONS(2884),
    [anon_sym_alignof] = ACTIONS(2884),
    [anon_sym__Alignof] = ACTIONS(2884),
    [anon_sym_offsetof] = ACTIONS(2886),
    [anon_sym__Generic] = ACTIONS(2888),
    [anon_sym_asm] = ACTIONS(2890),
    [anon_sym___asm__] = ACTIONS(2890),
    [anon_sym___asm] = ACTIONS(2890),
    [sym_number_literal] = ACTIONS(2892),
    [anon_sym_L_SQUOTE] = ACTIONS(2894),
    [anon_sym_u_SQUOTE] = ACTIONS(2894),
    [anon_sym_U_SQUOTE] = ACTIONS(2894),
    [anon_sym_u8_SQUOTE] = ACTIONS(2894),
    [anon_sym_SQUOTE] = ACTIONS(2894),
    [anon_sym_L_DQUOTE] = ACTIONS(2896),
    [anon_sym_u_DQUOTE] = ACTIONS(2896),
    [anon_sym_U_DQUOTE] = ACTIONS(2896),
    [anon_sym_u8_DQUOTE] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [anon_sym_NULL] = ACTIONS(2900),
    [anon_sym_nullptr] = ACTIONS(2900),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2902),
    [anon_sym_decltype] = ACTIONS(2904),
    [anon_sym_typename] = ACTIONS(2906),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_GT2] = ACTIONS(3024),
    [anon_sym_delete] = ACTIONS(2910),
    [anon_sym_R_DQUOTE] = ACTIONS(2912),
    [anon_sym_LR_DQUOTE] = ACTIONS(2912),
    [anon_sym_uR_DQUOTE] = ACTIONS(2912),
    [anon_sym_UR_DQUOTE] = ACTIONS(2912),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2912),
    [anon_sym_co_await] = ACTIONS(2914),
    [anon_sym_new] = ACTIONS(2916),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2898),
  },
  [322] = {
    [sym_identifier] = ACTIONS(3026),
    [aux_sym_preproc_include_token1] = ACTIONS(3026),
    [aux_sym_preproc_def_token1] = ACTIONS(3026),
    [aux_sym_preproc_if_token1] = ACTIONS(3026),
    [aux_sym_preproc_if_token2] = ACTIONS(3026),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3026),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3026),
    [aux_sym_preproc_else_token1] = ACTIONS(3026),
    [aux_sym_preproc_elif_token1] = ACTIONS(3026),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3026),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3026),
    [sym_preproc_directive] = ACTIONS(3026),
    [anon_sym_LPAREN2] = ACTIONS(3028),
    [anon_sym_BANG] = ACTIONS(3028),
    [anon_sym_TILDE] = ACTIONS(3028),
    [anon_sym_DASH] = ACTIONS(3026),
    [anon_sym_PLUS] = ACTIONS(3026),
    [anon_sym_STAR] = ACTIONS(3028),
    [anon_sym_AMP_AMP] = ACTIONS(3028),
    [anon_sym_AMP] = ACTIONS(3026),
    [anon_sym_SEMI] = ACTIONS(3028),
    [anon_sym___extension__] = ACTIONS(3026),
    [anon_sym_typedef] = ACTIONS(3026),
    [anon_sym_virtual] = ACTIONS(3026),
    [anon_sym_extern] = ACTIONS(3026),
    [anon_sym___attribute__] = ACTIONS(3026),
    [anon_sym___attribute] = ACTIONS(3026),
    [anon_sym_COLON_COLON] = ACTIONS(3028),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3028),
    [anon_sym___declspec] = ACTIONS(3026),
    [anon_sym___based] = ACTIONS(3026),
    [anon_sym___cdecl] = ACTIONS(3026),
    [anon_sym___clrcall] = ACTIONS(3026),
    [anon_sym___stdcall] = ACTIONS(3026),
    [anon_sym___fastcall] = ACTIONS(3026),
    [anon_sym___thiscall] = ACTIONS(3026),
    [anon_sym___vectorcall] = ACTIONS(3026),
    [anon_sym_LBRACE] = ACTIONS(3028),
    [anon_sym_signed] = ACTIONS(3026),
    [anon_sym_unsigned] = ACTIONS(3026),
    [anon_sym_long] = ACTIONS(3026),
    [anon_sym_short] = ACTIONS(3026),
    [anon_sym_LBRACK] = ACTIONS(3026),
    [anon_sym_static] = ACTIONS(3026),
    [anon_sym_register] = ACTIONS(3026),
    [anon_sym_inline] = ACTIONS(3026),
    [anon_sym___inline] = ACTIONS(3026),
    [anon_sym___inline__] = ACTIONS(3026),
    [anon_sym___forceinline] = ACTIONS(3026),
    [anon_sym_thread_local] = ACTIONS(3026),
    [anon_sym___thread] = ACTIONS(3026),
    [anon_sym_const] = ACTIONS(3026),
    [anon_sym_constexpr] = ACTIONS(3026),
    [anon_sym_volatile] = ACTIONS(3026),
    [anon_sym_restrict] = ACTIONS(3026),
    [anon_sym___restrict__] = ACTIONS(3026),
    [anon_sym__Atomic] = ACTIONS(3026),
    [anon_sym__Noreturn] = ACTIONS(3026),
    [anon_sym_noreturn] = ACTIONS(3026),
    [anon_sym__Nonnull] = ACTIONS(3026),
    [anon_sym_mutable] = ACTIONS(3026),
    [anon_sym_constinit] = ACTIONS(3026),
    [anon_sym_consteval] = ACTIONS(3026),
    [anon_sym_alignas] = ACTIONS(3026),
    [anon_sym__Alignas] = ACTIONS(3026),
    [sym_primitive_type] = ACTIONS(3026),
    [anon_sym_enum] = ACTIONS(3026),
    [anon_sym_class] = ACTIONS(3026),
    [anon_sym_struct] = ACTIONS(3026),
    [anon_sym_union] = ACTIONS(3026),
    [anon_sym_if] = ACTIONS(3026),
    [anon_sym_switch] = ACTIONS(3026),
    [anon_sym_case] = ACTIONS(3026),
    [anon_sym_default] = ACTIONS(3026),
    [anon_sym_while] = ACTIONS(3026),
    [anon_sym_do] = ACTIONS(3026),
    [anon_sym_for] = ACTIONS(3026),
    [anon_sym_return] = ACTIONS(3026),
    [anon_sym_break] = ACTIONS(3026),
    [anon_sym_continue] = ACTIONS(3026),
    [anon_sym_goto] = ACTIONS(3026),
    [anon_sym___try] = ACTIONS(3026),
    [anon_sym___leave] = ACTIONS(3026),
    [anon_sym_not] = ACTIONS(3026),
    [anon_sym_compl] = ACTIONS(3026),
    [anon_sym_DASH_DASH] = ACTIONS(3028),
    [anon_sym_PLUS_PLUS] = ACTIONS(3028),
    [anon_sym_sizeof] = ACTIONS(3026),
    [anon_sym___alignof__] = ACTIONS(3026),
    [anon_sym___alignof] = ACTIONS(3026),
    [anon_sym__alignof] = ACTIONS(3026),
    [anon_sym_alignof] = ACTIONS(3026),
    [anon_sym__Alignof] = ACTIONS(3026),
    [anon_sym_offsetof] = ACTIONS(3026),
    [anon_sym__Generic] = ACTIONS(3026),
    [anon_sym_asm] = ACTIONS(3026),
    [anon_sym___asm__] = ACTIONS(3026),
    [anon_sym___asm] = ACTIONS(3026),
    [sym_number_literal] = ACTIONS(3028),
    [anon_sym_L_SQUOTE] = ACTIONS(3028),
    [anon_sym_u_SQUOTE] = ACTIONS(3028),
    [anon_sym_U_SQUOTE] = ACTIONS(3028),
    [anon_sym_u8_SQUOTE] = ACTIONS(3028),
    [anon_sym_SQUOTE] = ACTIONS(3028),
    [anon_sym_L_DQUOTE] = ACTIONS(3028),
    [anon_sym_u_DQUOTE] = ACTIONS(3028),
    [anon_sym_U_DQUOTE] = ACTIONS(3028),
    [anon_sym_u8_DQUOTE] = ACTIONS(3028),
    [anon_sym_DQUOTE] = ACTIONS(3028),
    [sym_true] = ACTIONS(3026),
    [sym_false] = ACTIONS(3026),
    [anon_sym_NULL] = ACTIONS(3026),
    [anon_sym_nullptr] = ACTIONS(3026),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3026),
    [anon_sym_decltype] = ACTIONS(3026),
    [anon_sym_explicit] = ACTIONS(3026),
    [anon_sym_typename] = ACTIONS(3026),
    [anon_sym_template] = ACTIONS(3026),
    [anon_sym_operator] = ACTIONS(3026),
    [anon_sym_try] = ACTIONS(3026),
    [anon_sym_delete] = ACTIONS(3026),
    [anon_sym_throw] = ACTIONS(3026),
    [anon_sym_namespace] = ACTIONS(3026),
    [anon_sym_using] = ACTIONS(3026),
    [anon_sym_static_assert] = ACTIONS(3026),
    [anon_sym_concept] = ACTIONS(3026),
    [anon_sym_co_return] = ACTIONS(3026),
    [anon_sym_co_yield] = ACTIONS(3026),
    [anon_sym_R_DQUOTE] = ACTIONS(3028),
    [anon_sym_LR_DQUOTE] = ACTIONS(3028),
    [anon_sym_uR_DQUOTE] = ACTIONS(3028),
    [anon_sym_UR_DQUOTE] = ACTIONS(3028),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3028),
    [anon_sym_co_await] = ACTIONS(3026),
    [anon_sym_new] = ACTIONS(3026),
    [anon_sym_requires] = ACTIONS(3026),
    [sym_this] = ACTIONS(3026),
  },
  [323] = {
    [sym_identifier] = ACTIONS(3030),
    [aux_sym_preproc_include_token1] = ACTIONS(3030),
    [aux_sym_preproc_def_token1] = ACTIONS(3030),
    [aux_sym_preproc_if_token1] = ACTIONS(3030),
    [aux_sym_preproc_if_token2] = ACTIONS(3030),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3030),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3030),
    [aux_sym_preproc_else_token1] = ACTIONS(3030),
    [aux_sym_preproc_elif_token1] = ACTIONS(3030),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3030),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3030),
    [sym_preproc_directive] = ACTIONS(3030),
    [anon_sym_LPAREN2] = ACTIONS(3032),
    [anon_sym_BANG] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3030),
    [anon_sym_PLUS] = ACTIONS(3030),
    [anon_sym_STAR] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_AMP] = ACTIONS(3030),
    [anon_sym_SEMI] = ACTIONS(3032),
    [anon_sym___extension__] = ACTIONS(3030),
    [anon_sym_typedef] = ACTIONS(3030),
    [anon_sym_virtual] = ACTIONS(3030),
    [anon_sym_extern] = ACTIONS(3030),
    [anon_sym___attribute__] = ACTIONS(3030),
    [anon_sym___attribute] = ACTIONS(3030),
    [anon_sym_COLON_COLON] = ACTIONS(3032),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3032),
    [anon_sym___declspec] = ACTIONS(3030),
    [anon_sym___based] = ACTIONS(3030),
    [anon_sym___cdecl] = ACTIONS(3030),
    [anon_sym___clrcall] = ACTIONS(3030),
    [anon_sym___stdcall] = ACTIONS(3030),
    [anon_sym___fastcall] = ACTIONS(3030),
    [anon_sym___thiscall] = ACTIONS(3030),
    [anon_sym___vectorcall] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_signed] = ACTIONS(3030),
    [anon_sym_unsigned] = ACTIONS(3030),
    [anon_sym_long] = ACTIONS(3030),
    [anon_sym_short] = ACTIONS(3030),
    [anon_sym_LBRACK] = ACTIONS(3030),
    [anon_sym_static] = ACTIONS(3030),
    [anon_sym_register] = ACTIONS(3030),
    [anon_sym_inline] = ACTIONS(3030),
    [anon_sym___inline] = ACTIONS(3030),
    [anon_sym___inline__] = ACTIONS(3030),
    [anon_sym___forceinline] = ACTIONS(3030),
    [anon_sym_thread_local] = ACTIONS(3030),
    [anon_sym___thread] = ACTIONS(3030),
    [anon_sym_const] = ACTIONS(3030),
    [anon_sym_constexpr] = ACTIONS(3030),
    [anon_sym_volatile] = ACTIONS(3030),
    [anon_sym_restrict] = ACTIONS(3030),
    [anon_sym___restrict__] = ACTIONS(3030),
    [anon_sym__Atomic] = ACTIONS(3030),
    [anon_sym__Noreturn] = ACTIONS(3030),
    [anon_sym_noreturn] = ACTIONS(3030),
    [anon_sym__Nonnull] = ACTIONS(3030),
    [anon_sym_mutable] = ACTIONS(3030),
    [anon_sym_constinit] = ACTIONS(3030),
    [anon_sym_consteval] = ACTIONS(3030),
    [anon_sym_alignas] = ACTIONS(3030),
    [anon_sym__Alignas] = ACTIONS(3030),
    [sym_primitive_type] = ACTIONS(3030),
    [anon_sym_enum] = ACTIONS(3030),
    [anon_sym_class] = ACTIONS(3030),
    [anon_sym_struct] = ACTIONS(3030),
    [anon_sym_union] = ACTIONS(3030),
    [anon_sym_if] = ACTIONS(3030),
    [anon_sym_switch] = ACTIONS(3030),
    [anon_sym_case] = ACTIONS(3030),
    [anon_sym_default] = ACTIONS(3030),
    [anon_sym_while] = ACTIONS(3030),
    [anon_sym_do] = ACTIONS(3030),
    [anon_sym_for] = ACTIONS(3030),
    [anon_sym_return] = ACTIONS(3030),
    [anon_sym_break] = ACTIONS(3030),
    [anon_sym_continue] = ACTIONS(3030),
    [anon_sym_goto] = ACTIONS(3030),
    [anon_sym___try] = ACTIONS(3030),
    [anon_sym___leave] = ACTIONS(3030),
    [anon_sym_not] = ACTIONS(3030),
    [anon_sym_compl] = ACTIONS(3030),
    [anon_sym_DASH_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_PLUS] = ACTIONS(3032),
    [anon_sym_sizeof] = ACTIONS(3030),
    [anon_sym___alignof__] = ACTIONS(3030),
    [anon_sym___alignof] = ACTIONS(3030),
    [anon_sym__alignof] = ACTIONS(3030),
    [anon_sym_alignof] = ACTIONS(3030),
    [anon_sym__Alignof] = ACTIONS(3030),
    [anon_sym_offsetof] = ACTIONS(3030),
    [anon_sym__Generic] = ACTIONS(3030),
    [anon_sym_asm] = ACTIONS(3030),
    [anon_sym___asm__] = ACTIONS(3030),
    [anon_sym___asm] = ACTIONS(3030),
    [sym_number_literal] = ACTIONS(3032),
    [anon_sym_L_SQUOTE] = ACTIONS(3032),
    [anon_sym_u_SQUOTE] = ACTIONS(3032),
    [anon_sym_U_SQUOTE] = ACTIONS(3032),
    [anon_sym_u8_SQUOTE] = ACTIONS(3032),
    [anon_sym_SQUOTE] = ACTIONS(3032),
    [anon_sym_L_DQUOTE] = ACTIONS(3032),
    [anon_sym_u_DQUOTE] = ACTIONS(3032),
    [anon_sym_U_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8_DQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [sym_true] = ACTIONS(3030),
    [sym_false] = ACTIONS(3030),
    [anon_sym_NULL] = ACTIONS(3030),
    [anon_sym_nullptr] = ACTIONS(3030),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3030),
    [anon_sym_decltype] = ACTIONS(3030),
    [anon_sym_explicit] = ACTIONS(3030),
    [anon_sym_typename] = ACTIONS(3030),
    [anon_sym_template] = ACTIONS(3030),
    [anon_sym_operator] = ACTIONS(3030),
    [anon_sym_try] = ACTIONS(3030),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_throw] = ACTIONS(3030),
    [anon_sym_namespace] = ACTIONS(3030),
    [anon_sym_using] = ACTIONS(3030),
    [anon_sym_static_assert] = ACTIONS(3030),
    [anon_sym_concept] = ACTIONS(3030),
    [anon_sym_co_return] = ACTIONS(3030),
    [anon_sym_co_yield] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3030),
    [anon_sym_new] = ACTIONS(3030),
    [anon_sym_requires] = ACTIONS(3030),
    [sym_this] = ACTIONS(3030),
  },
  [324] = {
    [sym_identifier] = ACTIONS(3030),
    [aux_sym_preproc_include_token1] = ACTIONS(3030),
    [aux_sym_preproc_def_token1] = ACTIONS(3030),
    [aux_sym_preproc_if_token1] = ACTIONS(3030),
    [aux_sym_preproc_if_token2] = ACTIONS(3030),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3030),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3030),
    [aux_sym_preproc_else_token1] = ACTIONS(3030),
    [aux_sym_preproc_elif_token1] = ACTIONS(3030),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3030),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3030),
    [sym_preproc_directive] = ACTIONS(3030),
    [anon_sym_LPAREN2] = ACTIONS(3032),
    [anon_sym_BANG] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3030),
    [anon_sym_PLUS] = ACTIONS(3030),
    [anon_sym_STAR] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_AMP] = ACTIONS(3030),
    [anon_sym_SEMI] = ACTIONS(3032),
    [anon_sym___extension__] = ACTIONS(3030),
    [anon_sym_typedef] = ACTIONS(3030),
    [anon_sym_virtual] = ACTIONS(3030),
    [anon_sym_extern] = ACTIONS(3030),
    [anon_sym___attribute__] = ACTIONS(3030),
    [anon_sym___attribute] = ACTIONS(3030),
    [anon_sym_COLON_COLON] = ACTIONS(3032),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3032),
    [anon_sym___declspec] = ACTIONS(3030),
    [anon_sym___based] = ACTIONS(3030),
    [anon_sym___cdecl] = ACTIONS(3030),
    [anon_sym___clrcall] = ACTIONS(3030),
    [anon_sym___stdcall] = ACTIONS(3030),
    [anon_sym___fastcall] = ACTIONS(3030),
    [anon_sym___thiscall] = ACTIONS(3030),
    [anon_sym___vectorcall] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_signed] = ACTIONS(3030),
    [anon_sym_unsigned] = ACTIONS(3030),
    [anon_sym_long] = ACTIONS(3030),
    [anon_sym_short] = ACTIONS(3030),
    [anon_sym_LBRACK] = ACTIONS(3030),
    [anon_sym_static] = ACTIONS(3030),
    [anon_sym_register] = ACTIONS(3030),
    [anon_sym_inline] = ACTIONS(3030),
    [anon_sym___inline] = ACTIONS(3030),
    [anon_sym___inline__] = ACTIONS(3030),
    [anon_sym___forceinline] = ACTIONS(3030),
    [anon_sym_thread_local] = ACTIONS(3030),
    [anon_sym___thread] = ACTIONS(3030),
    [anon_sym_const] = ACTIONS(3030),
    [anon_sym_constexpr] = ACTIONS(3030),
    [anon_sym_volatile] = ACTIONS(3030),
    [anon_sym_restrict] = ACTIONS(3030),
    [anon_sym___restrict__] = ACTIONS(3030),
    [anon_sym__Atomic] = ACTIONS(3030),
    [anon_sym__Noreturn] = ACTIONS(3030),
    [anon_sym_noreturn] = ACTIONS(3030),
    [anon_sym__Nonnull] = ACTIONS(3030),
    [anon_sym_mutable] = ACTIONS(3030),
    [anon_sym_constinit] = ACTIONS(3030),
    [anon_sym_consteval] = ACTIONS(3030),
    [anon_sym_alignas] = ACTIONS(3030),
    [anon_sym__Alignas] = ACTIONS(3030),
    [sym_primitive_type] = ACTIONS(3030),
    [anon_sym_enum] = ACTIONS(3030),
    [anon_sym_class] = ACTIONS(3030),
    [anon_sym_struct] = ACTIONS(3030),
    [anon_sym_union] = ACTIONS(3030),
    [anon_sym_if] = ACTIONS(3030),
    [anon_sym_switch] = ACTIONS(3030),
    [anon_sym_case] = ACTIONS(3030),
    [anon_sym_default] = ACTIONS(3030),
    [anon_sym_while] = ACTIONS(3030),
    [anon_sym_do] = ACTIONS(3030),
    [anon_sym_for] = ACTIONS(3030),
    [anon_sym_return] = ACTIONS(3030),
    [anon_sym_break] = ACTIONS(3030),
    [anon_sym_continue] = ACTIONS(3030),
    [anon_sym_goto] = ACTIONS(3030),
    [anon_sym___try] = ACTIONS(3030),
    [anon_sym___leave] = ACTIONS(3030),
    [anon_sym_not] = ACTIONS(3030),
    [anon_sym_compl] = ACTIONS(3030),
    [anon_sym_DASH_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_PLUS] = ACTIONS(3032),
    [anon_sym_sizeof] = ACTIONS(3030),
    [anon_sym___alignof__] = ACTIONS(3030),
    [anon_sym___alignof] = ACTIONS(3030),
    [anon_sym__alignof] = ACTIONS(3030),
    [anon_sym_alignof] = ACTIONS(3030),
    [anon_sym__Alignof] = ACTIONS(3030),
    [anon_sym_offsetof] = ACTIONS(3030),
    [anon_sym__Generic] = ACTIONS(3030),
    [anon_sym_asm] = ACTIONS(3030),
    [anon_sym___asm__] = ACTIONS(3030),
    [anon_sym___asm] = ACTIONS(3030),
    [sym_number_literal] = ACTIONS(3032),
    [anon_sym_L_SQUOTE] = ACTIONS(3032),
    [anon_sym_u_SQUOTE] = ACTIONS(3032),
    [anon_sym_U_SQUOTE] = ACTIONS(3032),
    [anon_sym_u8_SQUOTE] = ACTIONS(3032),
    [anon_sym_SQUOTE] = ACTIONS(3032),
    [anon_sym_L_DQUOTE] = ACTIONS(3032),
    [anon_sym_u_DQUOTE] = ACTIONS(3032),
    [anon_sym_U_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8_DQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [sym_true] = ACTIONS(3030),
    [sym_false] = ACTIONS(3030),
    [anon_sym_NULL] = ACTIONS(3030),
    [anon_sym_nullptr] = ACTIONS(3030),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3030),
    [anon_sym_decltype] = ACTIONS(3030),
    [anon_sym_explicit] = ACTIONS(3030),
    [anon_sym_typename] = ACTIONS(3030),
    [anon_sym_template] = ACTIONS(3030),
    [anon_sym_operator] = ACTIONS(3030),
    [anon_sym_try] = ACTIONS(3030),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_throw] = ACTIONS(3030),
    [anon_sym_namespace] = ACTIONS(3030),
    [anon_sym_using] = ACTIONS(3030),
    [anon_sym_static_assert] = ACTIONS(3030),
    [anon_sym_concept] = ACTIONS(3030),
    [anon_sym_co_return] = ACTIONS(3030),
    [anon_sym_co_yield] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3030),
    [anon_sym_new] = ACTIONS(3030),
    [anon_sym_requires] = ACTIONS(3030),
    [sym_this] = ACTIONS(3030),
  },
  [325] = {
    [sym_identifier] = ACTIONS(3034),
    [aux_sym_preproc_include_token1] = ACTIONS(3034),
    [aux_sym_preproc_def_token1] = ACTIONS(3034),
    [aux_sym_preproc_if_token1] = ACTIONS(3034),
    [aux_sym_preproc_if_token2] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3034),
    [aux_sym_preproc_else_token1] = ACTIONS(3034),
    [aux_sym_preproc_elif_token1] = ACTIONS(3034),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3034),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3034),
    [sym_preproc_directive] = ACTIONS(3034),
    [anon_sym_LPAREN2] = ACTIONS(3036),
    [anon_sym_BANG] = ACTIONS(3036),
    [anon_sym_TILDE] = ACTIONS(3036),
    [anon_sym_DASH] = ACTIONS(3034),
    [anon_sym_PLUS] = ACTIONS(3034),
    [anon_sym_STAR] = ACTIONS(3036),
    [anon_sym_AMP_AMP] = ACTIONS(3036),
    [anon_sym_AMP] = ACTIONS(3034),
    [anon_sym_SEMI] = ACTIONS(3036),
    [anon_sym___extension__] = ACTIONS(3034),
    [anon_sym_typedef] = ACTIONS(3034),
    [anon_sym_virtual] = ACTIONS(3034),
    [anon_sym_extern] = ACTIONS(3034),
    [anon_sym___attribute__] = ACTIONS(3034),
    [anon_sym___attribute] = ACTIONS(3034),
    [anon_sym_COLON_COLON] = ACTIONS(3036),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3036),
    [anon_sym___declspec] = ACTIONS(3034),
    [anon_sym___based] = ACTIONS(3034),
    [anon_sym___cdecl] = ACTIONS(3034),
    [anon_sym___clrcall] = ACTIONS(3034),
    [anon_sym___stdcall] = ACTIONS(3034),
    [anon_sym___fastcall] = ACTIONS(3034),
    [anon_sym___thiscall] = ACTIONS(3034),
    [anon_sym___vectorcall] = ACTIONS(3034),
    [anon_sym_LBRACE] = ACTIONS(3036),
    [anon_sym_signed] = ACTIONS(3034),
    [anon_sym_unsigned] = ACTIONS(3034),
    [anon_sym_long] = ACTIONS(3034),
    [anon_sym_short] = ACTIONS(3034),
    [anon_sym_LBRACK] = ACTIONS(3034),
    [anon_sym_static] = ACTIONS(3034),
    [anon_sym_register] = ACTIONS(3034),
    [anon_sym_inline] = ACTIONS(3034),
    [anon_sym___inline] = ACTIONS(3034),
    [anon_sym___inline__] = ACTIONS(3034),
    [anon_sym___forceinline] = ACTIONS(3034),
    [anon_sym_thread_local] = ACTIONS(3034),
    [anon_sym___thread] = ACTIONS(3034),
    [anon_sym_const] = ACTIONS(3034),
    [anon_sym_constexpr] = ACTIONS(3034),
    [anon_sym_volatile] = ACTIONS(3034),
    [anon_sym_restrict] = ACTIONS(3034),
    [anon_sym___restrict__] = ACTIONS(3034),
    [anon_sym__Atomic] = ACTIONS(3034),
    [anon_sym__Noreturn] = ACTIONS(3034),
    [anon_sym_noreturn] = ACTIONS(3034),
    [anon_sym__Nonnull] = ACTIONS(3034),
    [anon_sym_mutable] = ACTIONS(3034),
    [anon_sym_constinit] = ACTIONS(3034),
    [anon_sym_consteval] = ACTIONS(3034),
    [anon_sym_alignas] = ACTIONS(3034),
    [anon_sym__Alignas] = ACTIONS(3034),
    [sym_primitive_type] = ACTIONS(3034),
    [anon_sym_enum] = ACTIONS(3034),
    [anon_sym_class] = ACTIONS(3034),
    [anon_sym_struct] = ACTIONS(3034),
    [anon_sym_union] = ACTIONS(3034),
    [anon_sym_if] = ACTIONS(3034),
    [anon_sym_switch] = ACTIONS(3034),
    [anon_sym_case] = ACTIONS(3034),
    [anon_sym_default] = ACTIONS(3034),
    [anon_sym_while] = ACTIONS(3034),
    [anon_sym_do] = ACTIONS(3034),
    [anon_sym_for] = ACTIONS(3034),
    [anon_sym_return] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3034),
    [anon_sym_continue] = ACTIONS(3034),
    [anon_sym_goto] = ACTIONS(3034),
    [anon_sym___try] = ACTIONS(3034),
    [anon_sym___leave] = ACTIONS(3034),
    [anon_sym_not] = ACTIONS(3034),
    [anon_sym_compl] = ACTIONS(3034),
    [anon_sym_DASH_DASH] = ACTIONS(3036),
    [anon_sym_PLUS_PLUS] = ACTIONS(3036),
    [anon_sym_sizeof] = ACTIONS(3034),
    [anon_sym___alignof__] = ACTIONS(3034),
    [anon_sym___alignof] = ACTIONS(3034),
    [anon_sym__alignof] = ACTIONS(3034),
    [anon_sym_alignof] = ACTIONS(3034),
    [anon_sym__Alignof] = ACTIONS(3034),
    [anon_sym_offsetof] = ACTIONS(3034),
    [anon_sym__Generic] = ACTIONS(3034),
    [anon_sym_asm] = ACTIONS(3034),
    [anon_sym___asm__] = ACTIONS(3034),
    [anon_sym___asm] = ACTIONS(3034),
    [sym_number_literal] = ACTIONS(3036),
    [anon_sym_L_SQUOTE] = ACTIONS(3036),
    [anon_sym_u_SQUOTE] = ACTIONS(3036),
    [anon_sym_U_SQUOTE] = ACTIONS(3036),
    [anon_sym_u8_SQUOTE] = ACTIONS(3036),
    [anon_sym_SQUOTE] = ACTIONS(3036),
    [anon_sym_L_DQUOTE] = ACTIONS(3036),
    [anon_sym_u_DQUOTE] = ACTIONS(3036),
    [anon_sym_U_DQUOTE] = ACTIONS(3036),
    [anon_sym_u8_DQUOTE] = ACTIONS(3036),
    [anon_sym_DQUOTE] = ACTIONS(3036),
    [sym_true] = ACTIONS(3034),
    [sym_false] = ACTIONS(3034),
    [anon_sym_NULL] = ACTIONS(3034),
    [anon_sym_nullptr] = ACTIONS(3034),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3034),
    [anon_sym_decltype] = ACTIONS(3034),
    [anon_sym_explicit] = ACTIONS(3034),
    [anon_sym_typename] = ACTIONS(3034),
    [anon_sym_template] = ACTIONS(3034),
    [anon_sym_operator] = ACTIONS(3034),
    [anon_sym_try] = ACTIONS(3034),
    [anon_sym_delete] = ACTIONS(3034),
    [anon_sym_throw] = ACTIONS(3034),
    [anon_sym_namespace] = ACTIONS(3034),
    [anon_sym_using] = ACTIONS(3034),
    [anon_sym_static_assert] = ACTIONS(3034),
    [anon_sym_concept] = ACTIONS(3034),
    [anon_sym_co_return] = ACTIONS(3034),
    [anon_sym_co_yield] = ACTIONS(3034),
    [anon_sym_R_DQUOTE] = ACTIONS(3036),
    [anon_sym_LR_DQUOTE] = ACTIONS(3036),
    [anon_sym_uR_DQUOTE] = ACTIONS(3036),
    [anon_sym_UR_DQUOTE] = ACTIONS(3036),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3036),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3034),
    [anon_sym_requires] = ACTIONS(3034),
    [sym_this] = ACTIONS(3034),
  },
  [326] = {
    [sym_identifier] = ACTIONS(3038),
    [aux_sym_preproc_include_token1] = ACTIONS(3038),
    [aux_sym_preproc_def_token1] = ACTIONS(3038),
    [aux_sym_preproc_if_token1] = ACTIONS(3038),
    [aux_sym_preproc_if_token2] = ACTIONS(3038),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3038),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3038),
    [aux_sym_preproc_else_token1] = ACTIONS(3038),
    [aux_sym_preproc_elif_token1] = ACTIONS(3038),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3038),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3038),
    [sym_preproc_directive] = ACTIONS(3038),
    [anon_sym_LPAREN2] = ACTIONS(3040),
    [anon_sym_BANG] = ACTIONS(3040),
    [anon_sym_TILDE] = ACTIONS(3040),
    [anon_sym_DASH] = ACTIONS(3038),
    [anon_sym_PLUS] = ACTIONS(3038),
    [anon_sym_STAR] = ACTIONS(3040),
    [anon_sym_AMP_AMP] = ACTIONS(3040),
    [anon_sym_AMP] = ACTIONS(3038),
    [anon_sym_SEMI] = ACTIONS(3040),
    [anon_sym___extension__] = ACTIONS(3038),
    [anon_sym_typedef] = ACTIONS(3038),
    [anon_sym_virtual] = ACTIONS(3038),
    [anon_sym_extern] = ACTIONS(3038),
    [anon_sym___attribute__] = ACTIONS(3038),
    [anon_sym___attribute] = ACTIONS(3038),
    [anon_sym_COLON_COLON] = ACTIONS(3040),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3040),
    [anon_sym___declspec] = ACTIONS(3038),
    [anon_sym___based] = ACTIONS(3038),
    [anon_sym___cdecl] = ACTIONS(3038),
    [anon_sym___clrcall] = ACTIONS(3038),
    [anon_sym___stdcall] = ACTIONS(3038),
    [anon_sym___fastcall] = ACTIONS(3038),
    [anon_sym___thiscall] = ACTIONS(3038),
    [anon_sym___vectorcall] = ACTIONS(3038),
    [anon_sym_LBRACE] = ACTIONS(3040),
    [anon_sym_signed] = ACTIONS(3038),
    [anon_sym_unsigned] = ACTIONS(3038),
    [anon_sym_long] = ACTIONS(3038),
    [anon_sym_short] = ACTIONS(3038),
    [anon_sym_LBRACK] = ACTIONS(3038),
    [anon_sym_static] = ACTIONS(3038),
    [anon_sym_register] = ACTIONS(3038),
    [anon_sym_inline] = ACTIONS(3038),
    [anon_sym___inline] = ACTIONS(3038),
    [anon_sym___inline__] = ACTIONS(3038),
    [anon_sym___forceinline] = ACTIONS(3038),
    [anon_sym_thread_local] = ACTIONS(3038),
    [anon_sym___thread] = ACTIONS(3038),
    [anon_sym_const] = ACTIONS(3038),
    [anon_sym_constexpr] = ACTIONS(3038),
    [anon_sym_volatile] = ACTIONS(3038),
    [anon_sym_restrict] = ACTIONS(3038),
    [anon_sym___restrict__] = ACTIONS(3038),
    [anon_sym__Atomic] = ACTIONS(3038),
    [anon_sym__Noreturn] = ACTIONS(3038),
    [anon_sym_noreturn] = ACTIONS(3038),
    [anon_sym__Nonnull] = ACTIONS(3038),
    [anon_sym_mutable] = ACTIONS(3038),
    [anon_sym_constinit] = ACTIONS(3038),
    [anon_sym_consteval] = ACTIONS(3038),
    [anon_sym_alignas] = ACTIONS(3038),
    [anon_sym__Alignas] = ACTIONS(3038),
    [sym_primitive_type] = ACTIONS(3038),
    [anon_sym_enum] = ACTIONS(3038),
    [anon_sym_class] = ACTIONS(3038),
    [anon_sym_struct] = ACTIONS(3038),
    [anon_sym_union] = ACTIONS(3038),
    [anon_sym_if] = ACTIONS(3038),
    [anon_sym_switch] = ACTIONS(3038),
    [anon_sym_case] = ACTIONS(3038),
    [anon_sym_default] = ACTIONS(3038),
    [anon_sym_while] = ACTIONS(3038),
    [anon_sym_do] = ACTIONS(3038),
    [anon_sym_for] = ACTIONS(3038),
    [anon_sym_return] = ACTIONS(3038),
    [anon_sym_break] = ACTIONS(3038),
    [anon_sym_continue] = ACTIONS(3038),
    [anon_sym_goto] = ACTIONS(3038),
    [anon_sym___try] = ACTIONS(3038),
    [anon_sym___leave] = ACTIONS(3038),
    [anon_sym_not] = ACTIONS(3038),
    [anon_sym_compl] = ACTIONS(3038),
    [anon_sym_DASH_DASH] = ACTIONS(3040),
    [anon_sym_PLUS_PLUS] = ACTIONS(3040),
    [anon_sym_sizeof] = ACTIONS(3038),
    [anon_sym___alignof__] = ACTIONS(3038),
    [anon_sym___alignof] = ACTIONS(3038),
    [anon_sym__alignof] = ACTIONS(3038),
    [anon_sym_alignof] = ACTIONS(3038),
    [anon_sym__Alignof] = ACTIONS(3038),
    [anon_sym_offsetof] = ACTIONS(3038),
    [anon_sym__Generic] = ACTIONS(3038),
    [anon_sym_asm] = ACTIONS(3038),
    [anon_sym___asm__] = ACTIONS(3038),
    [anon_sym___asm] = ACTIONS(3038),
    [sym_number_literal] = ACTIONS(3040),
    [anon_sym_L_SQUOTE] = ACTIONS(3040),
    [anon_sym_u_SQUOTE] = ACTIONS(3040),
    [anon_sym_U_SQUOTE] = ACTIONS(3040),
    [anon_sym_u8_SQUOTE] = ACTIONS(3040),
    [anon_sym_SQUOTE] = ACTIONS(3040),
    [anon_sym_L_DQUOTE] = ACTIONS(3040),
    [anon_sym_u_DQUOTE] = ACTIONS(3040),
    [anon_sym_U_DQUOTE] = ACTIONS(3040),
    [anon_sym_u8_DQUOTE] = ACTIONS(3040),
    [anon_sym_DQUOTE] = ACTIONS(3040),
    [sym_true] = ACTIONS(3038),
    [sym_false] = ACTIONS(3038),
    [anon_sym_NULL] = ACTIONS(3038),
    [anon_sym_nullptr] = ACTIONS(3038),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3038),
    [anon_sym_decltype] = ACTIONS(3038),
    [anon_sym_explicit] = ACTIONS(3038),
    [anon_sym_typename] = ACTIONS(3038),
    [anon_sym_template] = ACTIONS(3038),
    [anon_sym_operator] = ACTIONS(3038),
    [anon_sym_try] = ACTIONS(3038),
    [anon_sym_delete] = ACTIONS(3038),
    [anon_sym_throw] = ACTIONS(3038),
    [anon_sym_namespace] = ACTIONS(3038),
    [anon_sym_using] = ACTIONS(3038),
    [anon_sym_static_assert] = ACTIONS(3038),
    [anon_sym_concept] = ACTIONS(3038),
    [anon_sym_co_return] = ACTIONS(3038),
    [anon_sym_co_yield] = ACTIONS(3038),
    [anon_sym_R_DQUOTE] = ACTIONS(3040),
    [anon_sym_LR_DQUOTE] = ACTIONS(3040),
    [anon_sym_uR_DQUOTE] = ACTIONS(3040),
    [anon_sym_UR_DQUOTE] = ACTIONS(3040),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3040),
    [anon_sym_co_await] = ACTIONS(3038),
    [anon_sym_new] = ACTIONS(3038),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3038),
  },
  [327] = {
    [sym_identifier] = ACTIONS(3042),
    [aux_sym_preproc_include_token1] = ACTIONS(3042),
    [aux_sym_preproc_def_token1] = ACTIONS(3042),
    [aux_sym_preproc_if_token1] = ACTIONS(3042),
    [aux_sym_preproc_if_token2] = ACTIONS(3042),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3042),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3042),
    [aux_sym_preproc_else_token1] = ACTIONS(3042),
    [aux_sym_preproc_elif_token1] = ACTIONS(3042),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3042),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3042),
    [sym_preproc_directive] = ACTIONS(3042),
    [anon_sym_LPAREN2] = ACTIONS(3044),
    [anon_sym_BANG] = ACTIONS(3044),
    [anon_sym_TILDE] = ACTIONS(3044),
    [anon_sym_DASH] = ACTIONS(3042),
    [anon_sym_PLUS] = ACTIONS(3042),
    [anon_sym_STAR] = ACTIONS(3044),
    [anon_sym_AMP_AMP] = ACTIONS(3044),
    [anon_sym_AMP] = ACTIONS(3042),
    [anon_sym_SEMI] = ACTIONS(3044),
    [anon_sym___extension__] = ACTIONS(3042),
    [anon_sym_typedef] = ACTIONS(3042),
    [anon_sym_virtual] = ACTIONS(3042),
    [anon_sym_extern] = ACTIONS(3042),
    [anon_sym___attribute__] = ACTIONS(3042),
    [anon_sym___attribute] = ACTIONS(3042),
    [anon_sym_COLON_COLON] = ACTIONS(3044),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3044),
    [anon_sym___declspec] = ACTIONS(3042),
    [anon_sym___based] = ACTIONS(3042),
    [anon_sym___cdecl] = ACTIONS(3042),
    [anon_sym___clrcall] = ACTIONS(3042),
    [anon_sym___stdcall] = ACTIONS(3042),
    [anon_sym___fastcall] = ACTIONS(3042),
    [anon_sym___thiscall] = ACTIONS(3042),
    [anon_sym___vectorcall] = ACTIONS(3042),
    [anon_sym_LBRACE] = ACTIONS(3044),
    [anon_sym_signed] = ACTIONS(3042),
    [anon_sym_unsigned] = ACTIONS(3042),
    [anon_sym_long] = ACTIONS(3042),
    [anon_sym_short] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3042),
    [anon_sym_static] = ACTIONS(3042),
    [anon_sym_register] = ACTIONS(3042),
    [anon_sym_inline] = ACTIONS(3042),
    [anon_sym___inline] = ACTIONS(3042),
    [anon_sym___inline__] = ACTIONS(3042),
    [anon_sym___forceinline] = ACTIONS(3042),
    [anon_sym_thread_local] = ACTIONS(3042),
    [anon_sym___thread] = ACTIONS(3042),
    [anon_sym_const] = ACTIONS(3042),
    [anon_sym_constexpr] = ACTIONS(3042),
    [anon_sym_volatile] = ACTIONS(3042),
    [anon_sym_restrict] = ACTIONS(3042),
    [anon_sym___restrict__] = ACTIONS(3042),
    [anon_sym__Atomic] = ACTIONS(3042),
    [anon_sym__Noreturn] = ACTIONS(3042),
    [anon_sym_noreturn] = ACTIONS(3042),
    [anon_sym__Nonnull] = ACTIONS(3042),
    [anon_sym_mutable] = ACTIONS(3042),
    [anon_sym_constinit] = ACTIONS(3042),
    [anon_sym_consteval] = ACTIONS(3042),
    [anon_sym_alignas] = ACTIONS(3042),
    [anon_sym__Alignas] = ACTIONS(3042),
    [sym_primitive_type] = ACTIONS(3042),
    [anon_sym_enum] = ACTIONS(3042),
    [anon_sym_class] = ACTIONS(3042),
    [anon_sym_struct] = ACTIONS(3042),
    [anon_sym_union] = ACTIONS(3042),
    [anon_sym_if] = ACTIONS(3042),
    [anon_sym_switch] = ACTIONS(3042),
    [anon_sym_case] = ACTIONS(3042),
    [anon_sym_default] = ACTIONS(3042),
    [anon_sym_while] = ACTIONS(3042),
    [anon_sym_do] = ACTIONS(3042),
    [anon_sym_for] = ACTIONS(3042),
    [anon_sym_return] = ACTIONS(3042),
    [anon_sym_break] = ACTIONS(3042),
    [anon_sym_continue] = ACTIONS(3042),
    [anon_sym_goto] = ACTIONS(3042),
    [anon_sym___try] = ACTIONS(3042),
    [anon_sym___leave] = ACTIONS(3042),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_compl] = ACTIONS(3042),
    [anon_sym_DASH_DASH] = ACTIONS(3044),
    [anon_sym_PLUS_PLUS] = ACTIONS(3044),
    [anon_sym_sizeof] = ACTIONS(3042),
    [anon_sym___alignof__] = ACTIONS(3042),
    [anon_sym___alignof] = ACTIONS(3042),
    [anon_sym__alignof] = ACTIONS(3042),
    [anon_sym_alignof] = ACTIONS(3042),
    [anon_sym__Alignof] = ACTIONS(3042),
    [anon_sym_offsetof] = ACTIONS(3042),
    [anon_sym__Generic] = ACTIONS(3042),
    [anon_sym_asm] = ACTIONS(3042),
    [anon_sym___asm__] = ACTIONS(3042),
    [anon_sym___asm] = ACTIONS(3042),
    [sym_number_literal] = ACTIONS(3044),
    [anon_sym_L_SQUOTE] = ACTIONS(3044),
    [anon_sym_u_SQUOTE] = ACTIONS(3044),
    [anon_sym_U_SQUOTE] = ACTIONS(3044),
    [anon_sym_u8_SQUOTE] = ACTIONS(3044),
    [anon_sym_SQUOTE] = ACTIONS(3044),
    [anon_sym_L_DQUOTE] = ACTIONS(3044),
    [anon_sym_u_DQUOTE] = ACTIONS(3044),
    [anon_sym_U_DQUOTE] = ACTIONS(3044),
    [anon_sym_u8_DQUOTE] = ACTIONS(3044),
    [anon_sym_DQUOTE] = ACTIONS(3044),
    [sym_true] = ACTIONS(3042),
    [sym_false] = ACTIONS(3042),
    [anon_sym_NULL] = ACTIONS(3042),
    [anon_sym_nullptr] = ACTIONS(3042),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3042),
    [anon_sym_decltype] = ACTIONS(3042),
    [anon_sym_explicit] = ACTIONS(3042),
    [anon_sym_typename] = ACTIONS(3042),
    [anon_sym_template] = ACTIONS(3042),
    [anon_sym_operator] = ACTIONS(3042),
    [anon_sym_try] = ACTIONS(3042),
    [anon_sym_delete] = ACTIONS(3042),
    [anon_sym_throw] = ACTIONS(3042),
    [anon_sym_namespace] = ACTIONS(3042),
    [anon_sym_using] = ACTIONS(3042),
    [anon_sym_static_assert] = ACTIONS(3042),
    [anon_sym_concept] = ACTIONS(3042),
    [anon_sym_co_return] = ACTIONS(3042),
    [anon_sym_co_yield] = ACTIONS(3042),
    [anon_sym_R_DQUOTE] = ACTIONS(3044),
    [anon_sym_LR_DQUOTE] = ACTIONS(3044),
    [anon_sym_uR_DQUOTE] = ACTIONS(3044),
    [anon_sym_UR_DQUOTE] = ACTIONS(3044),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3044),
    [anon_sym_co_await] = ACTIONS(3042),
    [anon_sym_new] = ACTIONS(3042),
    [anon_sym_requires] = ACTIONS(3042),
    [sym_this] = ACTIONS(3042),
  },
  [328] = {
    [sym_identifier] = ACTIONS(3042),
    [aux_sym_preproc_include_token1] = ACTIONS(3042),
    [aux_sym_preproc_def_token1] = ACTIONS(3042),
    [aux_sym_preproc_if_token1] = ACTIONS(3042),
    [aux_sym_preproc_if_token2] = ACTIONS(3042),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3042),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3042),
    [aux_sym_preproc_else_token1] = ACTIONS(3042),
    [aux_sym_preproc_elif_token1] = ACTIONS(3042),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3042),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3042),
    [sym_preproc_directive] = ACTIONS(3042),
    [anon_sym_LPAREN2] = ACTIONS(3044),
    [anon_sym_BANG] = ACTIONS(3044),
    [anon_sym_TILDE] = ACTIONS(3044),
    [anon_sym_DASH] = ACTIONS(3042),
    [anon_sym_PLUS] = ACTIONS(3042),
    [anon_sym_STAR] = ACTIONS(3044),
    [anon_sym_AMP_AMP] = ACTIONS(3044),
    [anon_sym_AMP] = ACTIONS(3042),
    [anon_sym_SEMI] = ACTIONS(3044),
    [anon_sym___extension__] = ACTIONS(3042),
    [anon_sym_typedef] = ACTIONS(3042),
    [anon_sym_virtual] = ACTIONS(3042),
    [anon_sym_extern] = ACTIONS(3042),
    [anon_sym___attribute__] = ACTIONS(3042),
    [anon_sym___attribute] = ACTIONS(3042),
    [anon_sym_COLON_COLON] = ACTIONS(3044),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3044),
    [anon_sym___declspec] = ACTIONS(3042),
    [anon_sym___based] = ACTIONS(3042),
    [anon_sym___cdecl] = ACTIONS(3042),
    [anon_sym___clrcall] = ACTIONS(3042),
    [anon_sym___stdcall] = ACTIONS(3042),
    [anon_sym___fastcall] = ACTIONS(3042),
    [anon_sym___thiscall] = ACTIONS(3042),
    [anon_sym___vectorcall] = ACTIONS(3042),
    [anon_sym_LBRACE] = ACTIONS(3044),
    [anon_sym_signed] = ACTIONS(3042),
    [anon_sym_unsigned] = ACTIONS(3042),
    [anon_sym_long] = ACTIONS(3042),
    [anon_sym_short] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3042),
    [anon_sym_static] = ACTIONS(3042),
    [anon_sym_register] = ACTIONS(3042),
    [anon_sym_inline] = ACTIONS(3042),
    [anon_sym___inline] = ACTIONS(3042),
    [anon_sym___inline__] = ACTIONS(3042),
    [anon_sym___forceinline] = ACTIONS(3042),
    [anon_sym_thread_local] = ACTIONS(3042),
    [anon_sym___thread] = ACTIONS(3042),
    [anon_sym_const] = ACTIONS(3042),
    [anon_sym_constexpr] = ACTIONS(3042),
    [anon_sym_volatile] = ACTIONS(3042),
    [anon_sym_restrict] = ACTIONS(3042),
    [anon_sym___restrict__] = ACTIONS(3042),
    [anon_sym__Atomic] = ACTIONS(3042),
    [anon_sym__Noreturn] = ACTIONS(3042),
    [anon_sym_noreturn] = ACTIONS(3042),
    [anon_sym__Nonnull] = ACTIONS(3042),
    [anon_sym_mutable] = ACTIONS(3042),
    [anon_sym_constinit] = ACTIONS(3042),
    [anon_sym_consteval] = ACTIONS(3042),
    [anon_sym_alignas] = ACTIONS(3042),
    [anon_sym__Alignas] = ACTIONS(3042),
    [sym_primitive_type] = ACTIONS(3042),
    [anon_sym_enum] = ACTIONS(3042),
    [anon_sym_class] = ACTIONS(3042),
    [anon_sym_struct] = ACTIONS(3042),
    [anon_sym_union] = ACTIONS(3042),
    [anon_sym_if] = ACTIONS(3042),
    [anon_sym_switch] = ACTIONS(3042),
    [anon_sym_case] = ACTIONS(3042),
    [anon_sym_default] = ACTIONS(3042),
    [anon_sym_while] = ACTIONS(3042),
    [anon_sym_do] = ACTIONS(3042),
    [anon_sym_for] = ACTIONS(3042),
    [anon_sym_return] = ACTIONS(3042),
    [anon_sym_break] = ACTIONS(3042),
    [anon_sym_continue] = ACTIONS(3042),
    [anon_sym_goto] = ACTIONS(3042),
    [anon_sym___try] = ACTIONS(3042),
    [anon_sym___leave] = ACTIONS(3042),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_compl] = ACTIONS(3042),
    [anon_sym_DASH_DASH] = ACTIONS(3044),
    [anon_sym_PLUS_PLUS] = ACTIONS(3044),
    [anon_sym_sizeof] = ACTIONS(3042),
    [anon_sym___alignof__] = ACTIONS(3042),
    [anon_sym___alignof] = ACTIONS(3042),
    [anon_sym__alignof] = ACTIONS(3042),
    [anon_sym_alignof] = ACTIONS(3042),
    [anon_sym__Alignof] = ACTIONS(3042),
    [anon_sym_offsetof] = ACTIONS(3042),
    [anon_sym__Generic] = ACTIONS(3042),
    [anon_sym_asm] = ACTIONS(3042),
    [anon_sym___asm__] = ACTIONS(3042),
    [anon_sym___asm] = ACTIONS(3042),
    [sym_number_literal] = ACTIONS(3044),
    [anon_sym_L_SQUOTE] = ACTIONS(3044),
    [anon_sym_u_SQUOTE] = ACTIONS(3044),
    [anon_sym_U_SQUOTE] = ACTIONS(3044),
    [anon_sym_u8_SQUOTE] = ACTIONS(3044),
    [anon_sym_SQUOTE] = ACTIONS(3044),
    [anon_sym_L_DQUOTE] = ACTIONS(3044),
    [anon_sym_u_DQUOTE] = ACTIONS(3044),
    [anon_sym_U_DQUOTE] = ACTIONS(3044),
    [anon_sym_u8_DQUOTE] = ACTIONS(3044),
    [anon_sym_DQUOTE] = ACTIONS(3044),
    [sym_true] = ACTIONS(3042),
    [sym_false] = ACTIONS(3042),
    [anon_sym_NULL] = ACTIONS(3042),
    [anon_sym_nullptr] = ACTIONS(3042),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3042),
    [anon_sym_decltype] = ACTIONS(3042),
    [anon_sym_explicit] = ACTIONS(3042),
    [anon_sym_typename] = ACTIONS(3042),
    [anon_sym_template] = ACTIONS(3042),
    [anon_sym_operator] = ACTIONS(3042),
    [anon_sym_try] = ACTIONS(3042),
    [anon_sym_delete] = ACTIONS(3042),
    [anon_sym_throw] = ACTIONS(3042),
    [anon_sym_namespace] = ACTIONS(3042),
    [anon_sym_using] = ACTIONS(3042),
    [anon_sym_static_assert] = ACTIONS(3042),
    [anon_sym_concept] = ACTIONS(3042),
    [anon_sym_co_return] = ACTIONS(3042),
    [anon_sym_co_yield] = ACTIONS(3042),
    [anon_sym_R_DQUOTE] = ACTIONS(3044),
    [anon_sym_LR_DQUOTE] = ACTIONS(3044),
    [anon_sym_uR_DQUOTE] = ACTIONS(3044),
    [anon_sym_UR_DQUOTE] = ACTIONS(3044),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3044),
    [anon_sym_co_await] = ACTIONS(3042),
    [anon_sym_new] = ACTIONS(3042),
    [anon_sym_requires] = ACTIONS(3042),
    [sym_this] = ACTIONS(3042),
  },
  [329] = {
    [sym_identifier] = ACTIONS(3046),
    [aux_sym_preproc_include_token1] = ACTIONS(3046),
    [aux_sym_preproc_def_token1] = ACTIONS(3046),
    [aux_sym_preproc_if_token1] = ACTIONS(3046),
    [aux_sym_preproc_if_token2] = ACTIONS(3046),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3046),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3046),
    [aux_sym_preproc_else_token1] = ACTIONS(3046),
    [aux_sym_preproc_elif_token1] = ACTIONS(3046),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3046),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3046),
    [sym_preproc_directive] = ACTIONS(3046),
    [anon_sym_LPAREN2] = ACTIONS(3048),
    [anon_sym_BANG] = ACTIONS(3048),
    [anon_sym_TILDE] = ACTIONS(3048),
    [anon_sym_DASH] = ACTIONS(3046),
    [anon_sym_PLUS] = ACTIONS(3046),
    [anon_sym_STAR] = ACTIONS(3048),
    [anon_sym_AMP_AMP] = ACTIONS(3048),
    [anon_sym_AMP] = ACTIONS(3046),
    [anon_sym_SEMI] = ACTIONS(3048),
    [anon_sym___extension__] = ACTIONS(3046),
    [anon_sym_typedef] = ACTIONS(3046),
    [anon_sym_virtual] = ACTIONS(3046),
    [anon_sym_extern] = ACTIONS(3046),
    [anon_sym___attribute__] = ACTIONS(3046),
    [anon_sym___attribute] = ACTIONS(3046),
    [anon_sym_COLON_COLON] = ACTIONS(3048),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3048),
    [anon_sym___declspec] = ACTIONS(3046),
    [anon_sym___based] = ACTIONS(3046),
    [anon_sym___cdecl] = ACTIONS(3046),
    [anon_sym___clrcall] = ACTIONS(3046),
    [anon_sym___stdcall] = ACTIONS(3046),
    [anon_sym___fastcall] = ACTIONS(3046),
    [anon_sym___thiscall] = ACTIONS(3046),
    [anon_sym___vectorcall] = ACTIONS(3046),
    [anon_sym_LBRACE] = ACTIONS(3048),
    [anon_sym_signed] = ACTIONS(3046),
    [anon_sym_unsigned] = ACTIONS(3046),
    [anon_sym_long] = ACTIONS(3046),
    [anon_sym_short] = ACTIONS(3046),
    [anon_sym_LBRACK] = ACTIONS(3046),
    [anon_sym_static] = ACTIONS(3046),
    [anon_sym_register] = ACTIONS(3046),
    [anon_sym_inline] = ACTIONS(3046),
    [anon_sym___inline] = ACTIONS(3046),
    [anon_sym___inline__] = ACTIONS(3046),
    [anon_sym___forceinline] = ACTIONS(3046),
    [anon_sym_thread_local] = ACTIONS(3046),
    [anon_sym___thread] = ACTIONS(3046),
    [anon_sym_const] = ACTIONS(3046),
    [anon_sym_constexpr] = ACTIONS(3046),
    [anon_sym_volatile] = ACTIONS(3046),
    [anon_sym_restrict] = ACTIONS(3046),
    [anon_sym___restrict__] = ACTIONS(3046),
    [anon_sym__Atomic] = ACTIONS(3046),
    [anon_sym__Noreturn] = ACTIONS(3046),
    [anon_sym_noreturn] = ACTIONS(3046),
    [anon_sym__Nonnull] = ACTIONS(3046),
    [anon_sym_mutable] = ACTIONS(3046),
    [anon_sym_constinit] = ACTIONS(3046),
    [anon_sym_consteval] = ACTIONS(3046),
    [anon_sym_alignas] = ACTIONS(3046),
    [anon_sym__Alignas] = ACTIONS(3046),
    [sym_primitive_type] = ACTIONS(3046),
    [anon_sym_enum] = ACTIONS(3046),
    [anon_sym_class] = ACTIONS(3046),
    [anon_sym_struct] = ACTIONS(3046),
    [anon_sym_union] = ACTIONS(3046),
    [anon_sym_if] = ACTIONS(3046),
    [anon_sym_switch] = ACTIONS(3046),
    [anon_sym_case] = ACTIONS(3046),
    [anon_sym_default] = ACTIONS(3046),
    [anon_sym_while] = ACTIONS(3046),
    [anon_sym_do] = ACTIONS(3046),
    [anon_sym_for] = ACTIONS(3046),
    [anon_sym_return] = ACTIONS(3046),
    [anon_sym_break] = ACTIONS(3046),
    [anon_sym_continue] = ACTIONS(3046),
    [anon_sym_goto] = ACTIONS(3046),
    [anon_sym___try] = ACTIONS(3046),
    [anon_sym___leave] = ACTIONS(3046),
    [anon_sym_not] = ACTIONS(3046),
    [anon_sym_compl] = ACTIONS(3046),
    [anon_sym_DASH_DASH] = ACTIONS(3048),
    [anon_sym_PLUS_PLUS] = ACTIONS(3048),
    [anon_sym_sizeof] = ACTIONS(3046),
    [anon_sym___alignof__] = ACTIONS(3046),
    [anon_sym___alignof] = ACTIONS(3046),
    [anon_sym__alignof] = ACTIONS(3046),
    [anon_sym_alignof] = ACTIONS(3046),
    [anon_sym__Alignof] = ACTIONS(3046),
    [anon_sym_offsetof] = ACTIONS(3046),
    [anon_sym__Generic] = ACTIONS(3046),
    [anon_sym_asm] = ACTIONS(3046),
    [anon_sym___asm__] = ACTIONS(3046),
    [anon_sym___asm] = ACTIONS(3046),
    [sym_number_literal] = ACTIONS(3048),
    [anon_sym_L_SQUOTE] = ACTIONS(3048),
    [anon_sym_u_SQUOTE] = ACTIONS(3048),
    [anon_sym_U_SQUOTE] = ACTIONS(3048),
    [anon_sym_u8_SQUOTE] = ACTIONS(3048),
    [anon_sym_SQUOTE] = ACTIONS(3048),
    [anon_sym_L_DQUOTE] = ACTIONS(3048),
    [anon_sym_u_DQUOTE] = ACTIONS(3048),
    [anon_sym_U_DQUOTE] = ACTIONS(3048),
    [anon_sym_u8_DQUOTE] = ACTIONS(3048),
    [anon_sym_DQUOTE] = ACTIONS(3048),
    [sym_true] = ACTIONS(3046),
    [sym_false] = ACTIONS(3046),
    [anon_sym_NULL] = ACTIONS(3046),
    [anon_sym_nullptr] = ACTIONS(3046),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3046),
    [anon_sym_decltype] = ACTIONS(3046),
    [anon_sym_explicit] = ACTIONS(3046),
    [anon_sym_typename] = ACTIONS(3046),
    [anon_sym_template] = ACTIONS(3046),
    [anon_sym_operator] = ACTIONS(3046),
    [anon_sym_try] = ACTIONS(3046),
    [anon_sym_delete] = ACTIONS(3046),
    [anon_sym_throw] = ACTIONS(3046),
    [anon_sym_namespace] = ACTIONS(3046),
    [anon_sym_using] = ACTIONS(3046),
    [anon_sym_static_assert] = ACTIONS(3046),
    [anon_sym_concept] = ACTIONS(3046),
    [anon_sym_co_return] = ACTIONS(3046),
    [anon_sym_co_yield] = ACTIONS(3046),
    [anon_sym_R_DQUOTE] = ACTIONS(3048),
    [anon_sym_LR_DQUOTE] = ACTIONS(3048),
    [anon_sym_uR_DQUOTE] = ACTIONS(3048),
    [anon_sym_UR_DQUOTE] = ACTIONS(3048),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3048),
    [anon_sym_co_await] = ACTIONS(3046),
    [anon_sym_new] = ACTIONS(3046),
    [anon_sym_requires] = ACTIONS(3046),
    [sym_this] = ACTIONS(3046),
  },
  [330] = {
    [sym_identifier] = ACTIONS(3050),
    [aux_sym_preproc_include_token1] = ACTIONS(3050),
    [aux_sym_preproc_def_token1] = ACTIONS(3050),
    [aux_sym_preproc_if_token1] = ACTIONS(3050),
    [aux_sym_preproc_if_token2] = ACTIONS(3050),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3050),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3050),
    [aux_sym_preproc_else_token1] = ACTIONS(3050),
    [aux_sym_preproc_elif_token1] = ACTIONS(3050),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3050),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3050),
    [sym_preproc_directive] = ACTIONS(3050),
    [anon_sym_LPAREN2] = ACTIONS(3052),
    [anon_sym_BANG] = ACTIONS(3052),
    [anon_sym_TILDE] = ACTIONS(3052),
    [anon_sym_DASH] = ACTIONS(3050),
    [anon_sym_PLUS] = ACTIONS(3050),
    [anon_sym_STAR] = ACTIONS(3052),
    [anon_sym_AMP_AMP] = ACTIONS(3052),
    [anon_sym_AMP] = ACTIONS(3050),
    [anon_sym_SEMI] = ACTIONS(3052),
    [anon_sym___extension__] = ACTIONS(3050),
    [anon_sym_typedef] = ACTIONS(3050),
    [anon_sym_virtual] = ACTIONS(3050),
    [anon_sym_extern] = ACTIONS(3050),
    [anon_sym___attribute__] = ACTIONS(3050),
    [anon_sym___attribute] = ACTIONS(3050),
    [anon_sym_COLON_COLON] = ACTIONS(3052),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3052),
    [anon_sym___declspec] = ACTIONS(3050),
    [anon_sym___based] = ACTIONS(3050),
    [anon_sym___cdecl] = ACTIONS(3050),
    [anon_sym___clrcall] = ACTIONS(3050),
    [anon_sym___stdcall] = ACTIONS(3050),
    [anon_sym___fastcall] = ACTIONS(3050),
    [anon_sym___thiscall] = ACTIONS(3050),
    [anon_sym___vectorcall] = ACTIONS(3050),
    [anon_sym_LBRACE] = ACTIONS(3052),
    [anon_sym_signed] = ACTIONS(3050),
    [anon_sym_unsigned] = ACTIONS(3050),
    [anon_sym_long] = ACTIONS(3050),
    [anon_sym_short] = ACTIONS(3050),
    [anon_sym_LBRACK] = ACTIONS(3050),
    [anon_sym_static] = ACTIONS(3050),
    [anon_sym_register] = ACTIONS(3050),
    [anon_sym_inline] = ACTIONS(3050),
    [anon_sym___inline] = ACTIONS(3050),
    [anon_sym___inline__] = ACTIONS(3050),
    [anon_sym___forceinline] = ACTIONS(3050),
    [anon_sym_thread_local] = ACTIONS(3050),
    [anon_sym___thread] = ACTIONS(3050),
    [anon_sym_const] = ACTIONS(3050),
    [anon_sym_constexpr] = ACTIONS(3050),
    [anon_sym_volatile] = ACTIONS(3050),
    [anon_sym_restrict] = ACTIONS(3050),
    [anon_sym___restrict__] = ACTIONS(3050),
    [anon_sym__Atomic] = ACTIONS(3050),
    [anon_sym__Noreturn] = ACTIONS(3050),
    [anon_sym_noreturn] = ACTIONS(3050),
    [anon_sym__Nonnull] = ACTIONS(3050),
    [anon_sym_mutable] = ACTIONS(3050),
    [anon_sym_constinit] = ACTIONS(3050),
    [anon_sym_consteval] = ACTIONS(3050),
    [anon_sym_alignas] = ACTIONS(3050),
    [anon_sym__Alignas] = ACTIONS(3050),
    [sym_primitive_type] = ACTIONS(3050),
    [anon_sym_enum] = ACTIONS(3050),
    [anon_sym_class] = ACTIONS(3050),
    [anon_sym_struct] = ACTIONS(3050),
    [anon_sym_union] = ACTIONS(3050),
    [anon_sym_if] = ACTIONS(3050),
    [anon_sym_switch] = ACTIONS(3050),
    [anon_sym_case] = ACTIONS(3050),
    [anon_sym_default] = ACTIONS(3050),
    [anon_sym_while] = ACTIONS(3050),
    [anon_sym_do] = ACTIONS(3050),
    [anon_sym_for] = ACTIONS(3050),
    [anon_sym_return] = ACTIONS(3050),
    [anon_sym_break] = ACTIONS(3050),
    [anon_sym_continue] = ACTIONS(3050),
    [anon_sym_goto] = ACTIONS(3050),
    [anon_sym___try] = ACTIONS(3050),
    [anon_sym___leave] = ACTIONS(3050),
    [anon_sym_not] = ACTIONS(3050),
    [anon_sym_compl] = ACTIONS(3050),
    [anon_sym_DASH_DASH] = ACTIONS(3052),
    [anon_sym_PLUS_PLUS] = ACTIONS(3052),
    [anon_sym_sizeof] = ACTIONS(3050),
    [anon_sym___alignof__] = ACTIONS(3050),
    [anon_sym___alignof] = ACTIONS(3050),
    [anon_sym__alignof] = ACTIONS(3050),
    [anon_sym_alignof] = ACTIONS(3050),
    [anon_sym__Alignof] = ACTIONS(3050),
    [anon_sym_offsetof] = ACTIONS(3050),
    [anon_sym__Generic] = ACTIONS(3050),
    [anon_sym_asm] = ACTIONS(3050),
    [anon_sym___asm__] = ACTIONS(3050),
    [anon_sym___asm] = ACTIONS(3050),
    [sym_number_literal] = ACTIONS(3052),
    [anon_sym_L_SQUOTE] = ACTIONS(3052),
    [anon_sym_u_SQUOTE] = ACTIONS(3052),
    [anon_sym_U_SQUOTE] = ACTIONS(3052),
    [anon_sym_u8_SQUOTE] = ACTIONS(3052),
    [anon_sym_SQUOTE] = ACTIONS(3052),
    [anon_sym_L_DQUOTE] = ACTIONS(3052),
    [anon_sym_u_DQUOTE] = ACTIONS(3052),
    [anon_sym_U_DQUOTE] = ACTIONS(3052),
    [anon_sym_u8_DQUOTE] = ACTIONS(3052),
    [anon_sym_DQUOTE] = ACTIONS(3052),
    [sym_true] = ACTIONS(3050),
    [sym_false] = ACTIONS(3050),
    [anon_sym_NULL] = ACTIONS(3050),
    [anon_sym_nullptr] = ACTIONS(3050),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3050),
    [anon_sym_decltype] = ACTIONS(3050),
    [anon_sym_explicit] = ACTIONS(3050),
    [anon_sym_typename] = ACTIONS(3050),
    [anon_sym_template] = ACTIONS(3050),
    [anon_sym_operator] = ACTIONS(3050),
    [anon_sym_try] = ACTIONS(3050),
    [anon_sym_delete] = ACTIONS(3050),
    [anon_sym_throw] = ACTIONS(3050),
    [anon_sym_namespace] = ACTIONS(3050),
    [anon_sym_using] = ACTIONS(3050),
    [anon_sym_static_assert] = ACTIONS(3050),
    [anon_sym_concept] = ACTIONS(3050),
    [anon_sym_co_return] = ACTIONS(3050),
    [anon_sym_co_yield] = ACTIONS(3050),
    [anon_sym_R_DQUOTE] = ACTIONS(3052),
    [anon_sym_LR_DQUOTE] = ACTIONS(3052),
    [anon_sym_uR_DQUOTE] = ACTIONS(3052),
    [anon_sym_UR_DQUOTE] = ACTIONS(3052),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3052),
    [anon_sym_co_await] = ACTIONS(3050),
    [anon_sym_new] = ACTIONS(3050),
    [anon_sym_requires] = ACTIONS(3050),
    [sym_this] = ACTIONS(3050),
  },
  [331] = {
    [sym_type_qualifier] = STATE(3798),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4559),
    [sym_sized_type_specifier] = STATE(2651),
    [sym_enum_specifier] = STATE(2651),
    [sym_struct_specifier] = STATE(2651),
    [sym_union_specifier] = STATE(2651),
    [sym_expression] = STATE(4282),
    [sym__string] = STATE(4637),
    [sym_conditional_expression] = STATE(4735),
    [sym_assignment_expression] = STATE(4735),
    [sym_pointer_expression] = STATE(3573),
    [sym_unary_expression] = STATE(4735),
    [sym_binary_expression] = STATE(4735),
    [sym_update_expression] = STATE(4735),
    [sym_cast_expression] = STATE(4735),
    [sym_type_descriptor] = STATE(6900),
    [sym_sizeof_expression] = STATE(4735),
    [sym_alignof_expression] = STATE(4735),
    [sym_offsetof_expression] = STATE(4735),
    [sym_generic_expression] = STATE(4735),
    [sym_subscript_expression] = STATE(3573),
    [sym_call_expression] = STATE(3573),
    [sym_gnu_asm_expression] = STATE(4735),
    [sym_extension_expression] = STATE(4735),
    [sym_field_expression] = STATE(3573),
    [sym_compound_literal_expression] = STATE(4735),
    [sym_parenthesized_expression] = STATE(3573),
    [sym_char_literal] = STATE(4637),
    [sym_concatenated_string] = STATE(4637),
    [sym_string_literal] = STATE(3662),
    [sym_null] = STATE(4735),
    [sym_placeholder_type_specifier] = STATE(2651),
    [sym_decltype_auto] = STATE(2637),
    [sym_decltype] = STATE(2563),
    [sym_class_specifier] = STATE(2651),
    [sym__class_name] = STATE(7513),
    [sym_dependent_type] = STATE(2651),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(4735),
    [sym_raw_string_literal] = STATE(3662),
    [sym_co_await_expression] = STATE(4735),
    [sym_new_expression] = STATE(4735),
    [sym_delete_expression] = STATE(4735),
    [sym_requires_clause] = STATE(4735),
    [sym_requires_expression] = STATE(4735),
    [sym_lambda_expression] = STATE(4735),
    [sym_lambda_capture_specifier] = STATE(5854),
    [sym_fold_expression] = STATE(4735),
    [sym_parameter_pack_expansion] = STATE(4735),
    [sym_type_parameter_pack_expansion] = STATE(7045),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5693),
    [sym_qualified_identifier] = STATE(3573),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym_user_defined_literal] = STATE(3573),
    [aux_sym__type_definition_type_repeat1] = STATE(3798),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4167),
    [sym_identifier] = ACTIONS(2854),
    [anon_sym_LPAREN2] = ACTIONS(2856),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(2864),
    [anon_sym_COLON_COLON] = ACTIONS(2866),
    [anon_sym_signed] = ACTIONS(2868),
    [anon_sym_unsigned] = ACTIONS(2868),
    [anon_sym_long] = ACTIONS(2868),
    [anon_sym_short] = ACTIONS(2868),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(2870),
    [anon_sym_enum] = ACTIONS(2872),
    [anon_sym_class] = ACTIONS(2874),
    [anon_sym_struct] = ACTIONS(2876),
    [anon_sym_union] = ACTIONS(2878),
    [anon_sym_not] = ACTIONS(2860),
    [anon_sym_compl] = ACTIONS(2860),
    [anon_sym_DASH_DASH] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(2880),
    [anon_sym_sizeof] = ACTIONS(2882),
    [anon_sym___alignof__] = ACTIONS(2884),
    [anon_sym___alignof] = ACTIONS(2884),
    [anon_sym__alignof] = ACTIONS(2884),
    [anon_sym_alignof] = ACTIONS(2884),
    [anon_sym__Alignof] = ACTIONS(2884),
    [anon_sym_offsetof] = ACTIONS(2886),
    [anon_sym__Generic] = ACTIONS(2888),
    [anon_sym_asm] = ACTIONS(2890),
    [anon_sym___asm__] = ACTIONS(2890),
    [anon_sym___asm] = ACTIONS(2890),
    [sym_number_literal] = ACTIONS(2892),
    [anon_sym_L_SQUOTE] = ACTIONS(2894),
    [anon_sym_u_SQUOTE] = ACTIONS(2894),
    [anon_sym_U_SQUOTE] = ACTIONS(2894),
    [anon_sym_u8_SQUOTE] = ACTIONS(2894),
    [anon_sym_SQUOTE] = ACTIONS(2894),
    [anon_sym_L_DQUOTE] = ACTIONS(2896),
    [anon_sym_u_DQUOTE] = ACTIONS(2896),
    [anon_sym_U_DQUOTE] = ACTIONS(2896),
    [anon_sym_u8_DQUOTE] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [anon_sym_NULL] = ACTIONS(2900),
    [anon_sym_nullptr] = ACTIONS(2900),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2902),
    [anon_sym_decltype] = ACTIONS(2904),
    [anon_sym_typename] = ACTIONS(2906),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_GT2] = ACTIONS(3054),
    [anon_sym_delete] = ACTIONS(2910),
    [anon_sym_R_DQUOTE] = ACTIONS(2912),
    [anon_sym_LR_DQUOTE] = ACTIONS(2912),
    [anon_sym_uR_DQUOTE] = ACTIONS(2912),
    [anon_sym_UR_DQUOTE] = ACTIONS(2912),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2912),
    [anon_sym_co_await] = ACTIONS(2914),
    [anon_sym_new] = ACTIONS(2916),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2898),
  },
  [332] = {
    [sym_identifier] = ACTIONS(3056),
    [aux_sym_preproc_include_token1] = ACTIONS(3056),
    [aux_sym_preproc_def_token1] = ACTIONS(3056),
    [aux_sym_preproc_if_token1] = ACTIONS(3056),
    [aux_sym_preproc_if_token2] = ACTIONS(3056),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3056),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3056),
    [aux_sym_preproc_else_token1] = ACTIONS(3056),
    [aux_sym_preproc_elif_token1] = ACTIONS(3056),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3056),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3056),
    [sym_preproc_directive] = ACTIONS(3056),
    [anon_sym_LPAREN2] = ACTIONS(3058),
    [anon_sym_BANG] = ACTIONS(3058),
    [anon_sym_TILDE] = ACTIONS(3058),
    [anon_sym_DASH] = ACTIONS(3056),
    [anon_sym_PLUS] = ACTIONS(3056),
    [anon_sym_STAR] = ACTIONS(3058),
    [anon_sym_AMP_AMP] = ACTIONS(3058),
    [anon_sym_AMP] = ACTIONS(3056),
    [anon_sym_SEMI] = ACTIONS(3058),
    [anon_sym___extension__] = ACTIONS(3056),
    [anon_sym_typedef] = ACTIONS(3056),
    [anon_sym_virtual] = ACTIONS(3056),
    [anon_sym_extern] = ACTIONS(3056),
    [anon_sym___attribute__] = ACTIONS(3056),
    [anon_sym___attribute] = ACTIONS(3056),
    [anon_sym_COLON_COLON] = ACTIONS(3058),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3058),
    [anon_sym___declspec] = ACTIONS(3056),
    [anon_sym___based] = ACTIONS(3056),
    [anon_sym___cdecl] = ACTIONS(3056),
    [anon_sym___clrcall] = ACTIONS(3056),
    [anon_sym___stdcall] = ACTIONS(3056),
    [anon_sym___fastcall] = ACTIONS(3056),
    [anon_sym___thiscall] = ACTIONS(3056),
    [anon_sym___vectorcall] = ACTIONS(3056),
    [anon_sym_LBRACE] = ACTIONS(3058),
    [anon_sym_signed] = ACTIONS(3056),
    [anon_sym_unsigned] = ACTIONS(3056),
    [anon_sym_long] = ACTIONS(3056),
    [anon_sym_short] = ACTIONS(3056),
    [anon_sym_LBRACK] = ACTIONS(3056),
    [anon_sym_static] = ACTIONS(3056),
    [anon_sym_register] = ACTIONS(3056),
    [anon_sym_inline] = ACTIONS(3056),
    [anon_sym___inline] = ACTIONS(3056),
    [anon_sym___inline__] = ACTIONS(3056),
    [anon_sym___forceinline] = ACTIONS(3056),
    [anon_sym_thread_local] = ACTIONS(3056),
    [anon_sym___thread] = ACTIONS(3056),
    [anon_sym_const] = ACTIONS(3056),
    [anon_sym_constexpr] = ACTIONS(3056),
    [anon_sym_volatile] = ACTIONS(3056),
    [anon_sym_restrict] = ACTIONS(3056),
    [anon_sym___restrict__] = ACTIONS(3056),
    [anon_sym__Atomic] = ACTIONS(3056),
    [anon_sym__Noreturn] = ACTIONS(3056),
    [anon_sym_noreturn] = ACTIONS(3056),
    [anon_sym__Nonnull] = ACTIONS(3056),
    [anon_sym_mutable] = ACTIONS(3056),
    [anon_sym_constinit] = ACTIONS(3056),
    [anon_sym_consteval] = ACTIONS(3056),
    [anon_sym_alignas] = ACTIONS(3056),
    [anon_sym__Alignas] = ACTIONS(3056),
    [sym_primitive_type] = ACTIONS(3056),
    [anon_sym_enum] = ACTIONS(3056),
    [anon_sym_class] = ACTIONS(3056),
    [anon_sym_struct] = ACTIONS(3056),
    [anon_sym_union] = ACTIONS(3056),
    [anon_sym_if] = ACTIONS(3056),
    [anon_sym_switch] = ACTIONS(3056),
    [anon_sym_case] = ACTIONS(3056),
    [anon_sym_default] = ACTIONS(3056),
    [anon_sym_while] = ACTIONS(3056),
    [anon_sym_do] = ACTIONS(3056),
    [anon_sym_for] = ACTIONS(3056),
    [anon_sym_return] = ACTIONS(3056),
    [anon_sym_break] = ACTIONS(3056),
    [anon_sym_continue] = ACTIONS(3056),
    [anon_sym_goto] = ACTIONS(3056),
    [anon_sym___try] = ACTIONS(3056),
    [anon_sym___leave] = ACTIONS(3056),
    [anon_sym_not] = ACTIONS(3056),
    [anon_sym_compl] = ACTIONS(3056),
    [anon_sym_DASH_DASH] = ACTIONS(3058),
    [anon_sym_PLUS_PLUS] = ACTIONS(3058),
    [anon_sym_sizeof] = ACTIONS(3056),
    [anon_sym___alignof__] = ACTIONS(3056),
    [anon_sym___alignof] = ACTIONS(3056),
    [anon_sym__alignof] = ACTIONS(3056),
    [anon_sym_alignof] = ACTIONS(3056),
    [anon_sym__Alignof] = ACTIONS(3056),
    [anon_sym_offsetof] = ACTIONS(3056),
    [anon_sym__Generic] = ACTIONS(3056),
    [anon_sym_asm] = ACTIONS(3056),
    [anon_sym___asm__] = ACTIONS(3056),
    [anon_sym___asm] = ACTIONS(3056),
    [sym_number_literal] = ACTIONS(3058),
    [anon_sym_L_SQUOTE] = ACTIONS(3058),
    [anon_sym_u_SQUOTE] = ACTIONS(3058),
    [anon_sym_U_SQUOTE] = ACTIONS(3058),
    [anon_sym_u8_SQUOTE] = ACTIONS(3058),
    [anon_sym_SQUOTE] = ACTIONS(3058),
    [anon_sym_L_DQUOTE] = ACTIONS(3058),
    [anon_sym_u_DQUOTE] = ACTIONS(3058),
    [anon_sym_U_DQUOTE] = ACTIONS(3058),
    [anon_sym_u8_DQUOTE] = ACTIONS(3058),
    [anon_sym_DQUOTE] = ACTIONS(3058),
    [sym_true] = ACTIONS(3056),
    [sym_false] = ACTIONS(3056),
    [anon_sym_NULL] = ACTIONS(3056),
    [anon_sym_nullptr] = ACTIONS(3056),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3056),
    [anon_sym_decltype] = ACTIONS(3056),
    [anon_sym_explicit] = ACTIONS(3056),
    [anon_sym_typename] = ACTIONS(3056),
    [anon_sym_template] = ACTIONS(3056),
    [anon_sym_operator] = ACTIONS(3056),
    [anon_sym_try] = ACTIONS(3056),
    [anon_sym_delete] = ACTIONS(3056),
    [anon_sym_throw] = ACTIONS(3056),
    [anon_sym_namespace] = ACTIONS(3056),
    [anon_sym_using] = ACTIONS(3056),
    [anon_sym_static_assert] = ACTIONS(3056),
    [anon_sym_concept] = ACTIONS(3056),
    [anon_sym_co_return] = ACTIONS(3056),
    [anon_sym_co_yield] = ACTIONS(3056),
    [anon_sym_R_DQUOTE] = ACTIONS(3058),
    [anon_sym_LR_DQUOTE] = ACTIONS(3058),
    [anon_sym_uR_DQUOTE] = ACTIONS(3058),
    [anon_sym_UR_DQUOTE] = ACTIONS(3058),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3058),
    [anon_sym_co_await] = ACTIONS(3056),
    [anon_sym_new] = ACTIONS(3056),
    [anon_sym_requires] = ACTIONS(3056),
    [sym_this] = ACTIONS(3056),
  },
  [333] = {
    [sym_identifier] = ACTIONS(3060),
    [aux_sym_preproc_include_token1] = ACTIONS(3060),
    [aux_sym_preproc_def_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token2] = ACTIONS(3060),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3060),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3060),
    [aux_sym_preproc_else_token1] = ACTIONS(3060),
    [aux_sym_preproc_elif_token1] = ACTIONS(3060),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3060),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3060),
    [sym_preproc_directive] = ACTIONS(3060),
    [anon_sym_LPAREN2] = ACTIONS(3062),
    [anon_sym_BANG] = ACTIONS(3062),
    [anon_sym_TILDE] = ACTIONS(3062),
    [anon_sym_DASH] = ACTIONS(3060),
    [anon_sym_PLUS] = ACTIONS(3060),
    [anon_sym_STAR] = ACTIONS(3062),
    [anon_sym_AMP_AMP] = ACTIONS(3062),
    [anon_sym_AMP] = ACTIONS(3060),
    [anon_sym_SEMI] = ACTIONS(3062),
    [anon_sym___extension__] = ACTIONS(3060),
    [anon_sym_typedef] = ACTIONS(3060),
    [anon_sym_virtual] = ACTIONS(3060),
    [anon_sym_extern] = ACTIONS(3060),
    [anon_sym___attribute__] = ACTIONS(3060),
    [anon_sym___attribute] = ACTIONS(3060),
    [anon_sym_COLON_COLON] = ACTIONS(3062),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3062),
    [anon_sym___declspec] = ACTIONS(3060),
    [anon_sym___based] = ACTIONS(3060),
    [anon_sym___cdecl] = ACTIONS(3060),
    [anon_sym___clrcall] = ACTIONS(3060),
    [anon_sym___stdcall] = ACTIONS(3060),
    [anon_sym___fastcall] = ACTIONS(3060),
    [anon_sym___thiscall] = ACTIONS(3060),
    [anon_sym___vectorcall] = ACTIONS(3060),
    [anon_sym_LBRACE] = ACTIONS(3062),
    [anon_sym_signed] = ACTIONS(3060),
    [anon_sym_unsigned] = ACTIONS(3060),
    [anon_sym_long] = ACTIONS(3060),
    [anon_sym_short] = ACTIONS(3060),
    [anon_sym_LBRACK] = ACTIONS(3060),
    [anon_sym_static] = ACTIONS(3060),
    [anon_sym_register] = ACTIONS(3060),
    [anon_sym_inline] = ACTIONS(3060),
    [anon_sym___inline] = ACTIONS(3060),
    [anon_sym___inline__] = ACTIONS(3060),
    [anon_sym___forceinline] = ACTIONS(3060),
    [anon_sym_thread_local] = ACTIONS(3060),
    [anon_sym___thread] = ACTIONS(3060),
    [anon_sym_const] = ACTIONS(3060),
    [anon_sym_constexpr] = ACTIONS(3060),
    [anon_sym_volatile] = ACTIONS(3060),
    [anon_sym_restrict] = ACTIONS(3060),
    [anon_sym___restrict__] = ACTIONS(3060),
    [anon_sym__Atomic] = ACTIONS(3060),
    [anon_sym__Noreturn] = ACTIONS(3060),
    [anon_sym_noreturn] = ACTIONS(3060),
    [anon_sym__Nonnull] = ACTIONS(3060),
    [anon_sym_mutable] = ACTIONS(3060),
    [anon_sym_constinit] = ACTIONS(3060),
    [anon_sym_consteval] = ACTIONS(3060),
    [anon_sym_alignas] = ACTIONS(3060),
    [anon_sym__Alignas] = ACTIONS(3060),
    [sym_primitive_type] = ACTIONS(3060),
    [anon_sym_enum] = ACTIONS(3060),
    [anon_sym_class] = ACTIONS(3060),
    [anon_sym_struct] = ACTIONS(3060),
    [anon_sym_union] = ACTIONS(3060),
    [anon_sym_if] = ACTIONS(3060),
    [anon_sym_switch] = ACTIONS(3060),
    [anon_sym_case] = ACTIONS(3060),
    [anon_sym_default] = ACTIONS(3060),
    [anon_sym_while] = ACTIONS(3060),
    [anon_sym_do] = ACTIONS(3060),
    [anon_sym_for] = ACTIONS(3060),
    [anon_sym_return] = ACTIONS(3060),
    [anon_sym_break] = ACTIONS(3060),
    [anon_sym_continue] = ACTIONS(3060),
    [anon_sym_goto] = ACTIONS(3060),
    [anon_sym___try] = ACTIONS(3060),
    [anon_sym___leave] = ACTIONS(3060),
    [anon_sym_not] = ACTIONS(3060),
    [anon_sym_compl] = ACTIONS(3060),
    [anon_sym_DASH_DASH] = ACTIONS(3062),
    [anon_sym_PLUS_PLUS] = ACTIONS(3062),
    [anon_sym_sizeof] = ACTIONS(3060),
    [anon_sym___alignof__] = ACTIONS(3060),
    [anon_sym___alignof] = ACTIONS(3060),
    [anon_sym__alignof] = ACTIONS(3060),
    [anon_sym_alignof] = ACTIONS(3060),
    [anon_sym__Alignof] = ACTIONS(3060),
    [anon_sym_offsetof] = ACTIONS(3060),
    [anon_sym__Generic] = ACTIONS(3060),
    [anon_sym_asm] = ACTIONS(3060),
    [anon_sym___asm__] = ACTIONS(3060),
    [anon_sym___asm] = ACTIONS(3060),
    [sym_number_literal] = ACTIONS(3062),
    [anon_sym_L_SQUOTE] = ACTIONS(3062),
    [anon_sym_u_SQUOTE] = ACTIONS(3062),
    [anon_sym_U_SQUOTE] = ACTIONS(3062),
    [anon_sym_u8_SQUOTE] = ACTIONS(3062),
    [anon_sym_SQUOTE] = ACTIONS(3062),
    [anon_sym_L_DQUOTE] = ACTIONS(3062),
    [anon_sym_u_DQUOTE] = ACTIONS(3062),
    [anon_sym_U_DQUOTE] = ACTIONS(3062),
    [anon_sym_u8_DQUOTE] = ACTIONS(3062),
    [anon_sym_DQUOTE] = ACTIONS(3062),
    [sym_true] = ACTIONS(3060),
    [sym_false] = ACTIONS(3060),
    [anon_sym_NULL] = ACTIONS(3060),
    [anon_sym_nullptr] = ACTIONS(3060),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3060),
    [anon_sym_decltype] = ACTIONS(3060),
    [anon_sym_explicit] = ACTIONS(3060),
    [anon_sym_typename] = ACTIONS(3060),
    [anon_sym_template] = ACTIONS(3060),
    [anon_sym_operator] = ACTIONS(3060),
    [anon_sym_try] = ACTIONS(3060),
    [anon_sym_delete] = ACTIONS(3060),
    [anon_sym_throw] = ACTIONS(3060),
    [anon_sym_namespace] = ACTIONS(3060),
    [anon_sym_using] = ACTIONS(3060),
    [anon_sym_static_assert] = ACTIONS(3060),
    [anon_sym_concept] = ACTIONS(3060),
    [anon_sym_co_return] = ACTIONS(3060),
    [anon_sym_co_yield] = ACTIONS(3060),
    [anon_sym_R_DQUOTE] = ACTIONS(3062),
    [anon_sym_LR_DQUOTE] = ACTIONS(3062),
    [anon_sym_uR_DQUOTE] = ACTIONS(3062),
    [anon_sym_UR_DQUOTE] = ACTIONS(3062),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3062),
    [anon_sym_co_await] = ACTIONS(3060),
    [anon_sym_new] = ACTIONS(3060),
    [anon_sym_requires] = ACTIONS(3060),
    [sym_this] = ACTIONS(3060),
  },
  [334] = {
    [sym_identifier] = ACTIONS(3064),
    [aux_sym_preproc_include_token1] = ACTIONS(3064),
    [aux_sym_preproc_def_token1] = ACTIONS(3064),
    [aux_sym_preproc_if_token1] = ACTIONS(3064),
    [aux_sym_preproc_if_token2] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3064),
    [aux_sym_preproc_else_token1] = ACTIONS(3064),
    [aux_sym_preproc_elif_token1] = ACTIONS(3064),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3064),
    [sym_preproc_directive] = ACTIONS(3064),
    [anon_sym_LPAREN2] = ACTIONS(3066),
    [anon_sym_BANG] = ACTIONS(3066),
    [anon_sym_TILDE] = ACTIONS(3066),
    [anon_sym_DASH] = ACTIONS(3064),
    [anon_sym_PLUS] = ACTIONS(3064),
    [anon_sym_STAR] = ACTIONS(3066),
    [anon_sym_AMP_AMP] = ACTIONS(3066),
    [anon_sym_AMP] = ACTIONS(3064),
    [anon_sym_SEMI] = ACTIONS(3066),
    [anon_sym___extension__] = ACTIONS(3064),
    [anon_sym_typedef] = ACTIONS(3064),
    [anon_sym_virtual] = ACTIONS(3064),
    [anon_sym_extern] = ACTIONS(3064),
    [anon_sym___attribute__] = ACTIONS(3064),
    [anon_sym___attribute] = ACTIONS(3064),
    [anon_sym_COLON_COLON] = ACTIONS(3066),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3066),
    [anon_sym___declspec] = ACTIONS(3064),
    [anon_sym___based] = ACTIONS(3064),
    [anon_sym___cdecl] = ACTIONS(3064),
    [anon_sym___clrcall] = ACTIONS(3064),
    [anon_sym___stdcall] = ACTIONS(3064),
    [anon_sym___fastcall] = ACTIONS(3064),
    [anon_sym___thiscall] = ACTIONS(3064),
    [anon_sym___vectorcall] = ACTIONS(3064),
    [anon_sym_LBRACE] = ACTIONS(3066),
    [anon_sym_signed] = ACTIONS(3064),
    [anon_sym_unsigned] = ACTIONS(3064),
    [anon_sym_long] = ACTIONS(3064),
    [anon_sym_short] = ACTIONS(3064),
    [anon_sym_LBRACK] = ACTIONS(3064),
    [anon_sym_static] = ACTIONS(3064),
    [anon_sym_register] = ACTIONS(3064),
    [anon_sym_inline] = ACTIONS(3064),
    [anon_sym___inline] = ACTIONS(3064),
    [anon_sym___inline__] = ACTIONS(3064),
    [anon_sym___forceinline] = ACTIONS(3064),
    [anon_sym_thread_local] = ACTIONS(3064),
    [anon_sym___thread] = ACTIONS(3064),
    [anon_sym_const] = ACTIONS(3064),
    [anon_sym_constexpr] = ACTIONS(3064),
    [anon_sym_volatile] = ACTIONS(3064),
    [anon_sym_restrict] = ACTIONS(3064),
    [anon_sym___restrict__] = ACTIONS(3064),
    [anon_sym__Atomic] = ACTIONS(3064),
    [anon_sym__Noreturn] = ACTIONS(3064),
    [anon_sym_noreturn] = ACTIONS(3064),
    [anon_sym__Nonnull] = ACTIONS(3064),
    [anon_sym_mutable] = ACTIONS(3064),
    [anon_sym_constinit] = ACTIONS(3064),
    [anon_sym_consteval] = ACTIONS(3064),
    [anon_sym_alignas] = ACTIONS(3064),
    [anon_sym__Alignas] = ACTIONS(3064),
    [sym_primitive_type] = ACTIONS(3064),
    [anon_sym_enum] = ACTIONS(3064),
    [anon_sym_class] = ACTIONS(3064),
    [anon_sym_struct] = ACTIONS(3064),
    [anon_sym_union] = ACTIONS(3064),
    [anon_sym_if] = ACTIONS(3064),
    [anon_sym_switch] = ACTIONS(3064),
    [anon_sym_case] = ACTIONS(3064),
    [anon_sym_default] = ACTIONS(3064),
    [anon_sym_while] = ACTIONS(3064),
    [anon_sym_do] = ACTIONS(3064),
    [anon_sym_for] = ACTIONS(3064),
    [anon_sym_return] = ACTIONS(3064),
    [anon_sym_break] = ACTIONS(3064),
    [anon_sym_continue] = ACTIONS(3064),
    [anon_sym_goto] = ACTIONS(3064),
    [anon_sym___try] = ACTIONS(3064),
    [anon_sym___leave] = ACTIONS(3064),
    [anon_sym_not] = ACTIONS(3064),
    [anon_sym_compl] = ACTIONS(3064),
    [anon_sym_DASH_DASH] = ACTIONS(3066),
    [anon_sym_PLUS_PLUS] = ACTIONS(3066),
    [anon_sym_sizeof] = ACTIONS(3064),
    [anon_sym___alignof__] = ACTIONS(3064),
    [anon_sym___alignof] = ACTIONS(3064),
    [anon_sym__alignof] = ACTIONS(3064),
    [anon_sym_alignof] = ACTIONS(3064),
    [anon_sym__Alignof] = ACTIONS(3064),
    [anon_sym_offsetof] = ACTIONS(3064),
    [anon_sym__Generic] = ACTIONS(3064),
    [anon_sym_asm] = ACTIONS(3064),
    [anon_sym___asm__] = ACTIONS(3064),
    [anon_sym___asm] = ACTIONS(3064),
    [sym_number_literal] = ACTIONS(3066),
    [anon_sym_L_SQUOTE] = ACTIONS(3066),
    [anon_sym_u_SQUOTE] = ACTIONS(3066),
    [anon_sym_U_SQUOTE] = ACTIONS(3066),
    [anon_sym_u8_SQUOTE] = ACTIONS(3066),
    [anon_sym_SQUOTE] = ACTIONS(3066),
    [anon_sym_L_DQUOTE] = ACTIONS(3066),
    [anon_sym_u_DQUOTE] = ACTIONS(3066),
    [anon_sym_U_DQUOTE] = ACTIONS(3066),
    [anon_sym_u8_DQUOTE] = ACTIONS(3066),
    [anon_sym_DQUOTE] = ACTIONS(3066),
    [sym_true] = ACTIONS(3064),
    [sym_false] = ACTIONS(3064),
    [anon_sym_NULL] = ACTIONS(3064),
    [anon_sym_nullptr] = ACTIONS(3064),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3064),
    [anon_sym_decltype] = ACTIONS(3064),
    [anon_sym_explicit] = ACTIONS(3064),
    [anon_sym_typename] = ACTIONS(3064),
    [anon_sym_template] = ACTIONS(3064),
    [anon_sym_operator] = ACTIONS(3064),
    [anon_sym_try] = ACTIONS(3064),
    [anon_sym_delete] = ACTIONS(3064),
    [anon_sym_throw] = ACTIONS(3064),
    [anon_sym_namespace] = ACTIONS(3064),
    [anon_sym_using] = ACTIONS(3064),
    [anon_sym_static_assert] = ACTIONS(3064),
    [anon_sym_concept] = ACTIONS(3064),
    [anon_sym_co_return] = ACTIONS(3064),
    [anon_sym_co_yield] = ACTIONS(3064),
    [anon_sym_R_DQUOTE] = ACTIONS(3066),
    [anon_sym_LR_DQUOTE] = ACTIONS(3066),
    [anon_sym_uR_DQUOTE] = ACTIONS(3066),
    [anon_sym_UR_DQUOTE] = ACTIONS(3066),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3066),
    [anon_sym_co_await] = ACTIONS(3064),
    [anon_sym_new] = ACTIONS(3064),
    [anon_sym_requires] = ACTIONS(3064),
    [sym_this] = ACTIONS(3064),
  },
  [335] = {
    [sym_identifier] = ACTIONS(3068),
    [aux_sym_preproc_include_token1] = ACTIONS(3068),
    [aux_sym_preproc_def_token1] = ACTIONS(3068),
    [aux_sym_preproc_if_token1] = ACTIONS(3068),
    [aux_sym_preproc_if_token2] = ACTIONS(3068),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3068),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3068),
    [aux_sym_preproc_else_token1] = ACTIONS(3068),
    [aux_sym_preproc_elif_token1] = ACTIONS(3068),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3068),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3068),
    [sym_preproc_directive] = ACTIONS(3068),
    [anon_sym_LPAREN2] = ACTIONS(3070),
    [anon_sym_BANG] = ACTIONS(3070),
    [anon_sym_TILDE] = ACTIONS(3070),
    [anon_sym_DASH] = ACTIONS(3068),
    [anon_sym_PLUS] = ACTIONS(3068),
    [anon_sym_STAR] = ACTIONS(3070),
    [anon_sym_AMP_AMP] = ACTIONS(3070),
    [anon_sym_AMP] = ACTIONS(3068),
    [anon_sym_SEMI] = ACTIONS(3070),
    [anon_sym___extension__] = ACTIONS(3068),
    [anon_sym_typedef] = ACTIONS(3068),
    [anon_sym_virtual] = ACTIONS(3068),
    [anon_sym_extern] = ACTIONS(3068),
    [anon_sym___attribute__] = ACTIONS(3068),
    [anon_sym___attribute] = ACTIONS(3068),
    [anon_sym_COLON_COLON] = ACTIONS(3070),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3070),
    [anon_sym___declspec] = ACTIONS(3068),
    [anon_sym___based] = ACTIONS(3068),
    [anon_sym___cdecl] = ACTIONS(3068),
    [anon_sym___clrcall] = ACTIONS(3068),
    [anon_sym___stdcall] = ACTIONS(3068),
    [anon_sym___fastcall] = ACTIONS(3068),
    [anon_sym___thiscall] = ACTIONS(3068),
    [anon_sym___vectorcall] = ACTIONS(3068),
    [anon_sym_LBRACE] = ACTIONS(3070),
    [anon_sym_signed] = ACTIONS(3068),
    [anon_sym_unsigned] = ACTIONS(3068),
    [anon_sym_long] = ACTIONS(3068),
    [anon_sym_short] = ACTIONS(3068),
    [anon_sym_LBRACK] = ACTIONS(3068),
    [anon_sym_static] = ACTIONS(3068),
    [anon_sym_register] = ACTIONS(3068),
    [anon_sym_inline] = ACTIONS(3068),
    [anon_sym___inline] = ACTIONS(3068),
    [anon_sym___inline__] = ACTIONS(3068),
    [anon_sym___forceinline] = ACTIONS(3068),
    [anon_sym_thread_local] = ACTIONS(3068),
    [anon_sym___thread] = ACTIONS(3068),
    [anon_sym_const] = ACTIONS(3068),
    [anon_sym_constexpr] = ACTIONS(3068),
    [anon_sym_volatile] = ACTIONS(3068),
    [anon_sym_restrict] = ACTIONS(3068),
    [anon_sym___restrict__] = ACTIONS(3068),
    [anon_sym__Atomic] = ACTIONS(3068),
    [anon_sym__Noreturn] = ACTIONS(3068),
    [anon_sym_noreturn] = ACTIONS(3068),
    [anon_sym__Nonnull] = ACTIONS(3068),
    [anon_sym_mutable] = ACTIONS(3068),
    [anon_sym_constinit] = ACTIONS(3068),
    [anon_sym_consteval] = ACTIONS(3068),
    [anon_sym_alignas] = ACTIONS(3068),
    [anon_sym__Alignas] = ACTIONS(3068),
    [sym_primitive_type] = ACTIONS(3068),
    [anon_sym_enum] = ACTIONS(3068),
    [anon_sym_class] = ACTIONS(3068),
    [anon_sym_struct] = ACTIONS(3068),
    [anon_sym_union] = ACTIONS(3068),
    [anon_sym_if] = ACTIONS(3068),
    [anon_sym_switch] = ACTIONS(3068),
    [anon_sym_case] = ACTIONS(3068),
    [anon_sym_default] = ACTIONS(3068),
    [anon_sym_while] = ACTIONS(3068),
    [anon_sym_do] = ACTIONS(3068),
    [anon_sym_for] = ACTIONS(3068),
    [anon_sym_return] = ACTIONS(3068),
    [anon_sym_break] = ACTIONS(3068),
    [anon_sym_continue] = ACTIONS(3068),
    [anon_sym_goto] = ACTIONS(3068),
    [anon_sym___try] = ACTIONS(3068),
    [anon_sym___leave] = ACTIONS(3068),
    [anon_sym_not] = ACTIONS(3068),
    [anon_sym_compl] = ACTIONS(3068),
    [anon_sym_DASH_DASH] = ACTIONS(3070),
    [anon_sym_PLUS_PLUS] = ACTIONS(3070),
    [anon_sym_sizeof] = ACTIONS(3068),
    [anon_sym___alignof__] = ACTIONS(3068),
    [anon_sym___alignof] = ACTIONS(3068),
    [anon_sym__alignof] = ACTIONS(3068),
    [anon_sym_alignof] = ACTIONS(3068),
    [anon_sym__Alignof] = ACTIONS(3068),
    [anon_sym_offsetof] = ACTIONS(3068),
    [anon_sym__Generic] = ACTIONS(3068),
    [anon_sym_asm] = ACTIONS(3068),
    [anon_sym___asm__] = ACTIONS(3068),
    [anon_sym___asm] = ACTIONS(3068),
    [sym_number_literal] = ACTIONS(3070),
    [anon_sym_L_SQUOTE] = ACTIONS(3070),
    [anon_sym_u_SQUOTE] = ACTIONS(3070),
    [anon_sym_U_SQUOTE] = ACTIONS(3070),
    [anon_sym_u8_SQUOTE] = ACTIONS(3070),
    [anon_sym_SQUOTE] = ACTIONS(3070),
    [anon_sym_L_DQUOTE] = ACTIONS(3070),
    [anon_sym_u_DQUOTE] = ACTIONS(3070),
    [anon_sym_U_DQUOTE] = ACTIONS(3070),
    [anon_sym_u8_DQUOTE] = ACTIONS(3070),
    [anon_sym_DQUOTE] = ACTIONS(3070),
    [sym_true] = ACTIONS(3068),
    [sym_false] = ACTIONS(3068),
    [anon_sym_NULL] = ACTIONS(3068),
    [anon_sym_nullptr] = ACTIONS(3068),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3068),
    [anon_sym_decltype] = ACTIONS(3068),
    [anon_sym_explicit] = ACTIONS(3068),
    [anon_sym_typename] = ACTIONS(3068),
    [anon_sym_template] = ACTIONS(3068),
    [anon_sym_operator] = ACTIONS(3068),
    [anon_sym_try] = ACTIONS(3068),
    [anon_sym_delete] = ACTIONS(3068),
    [anon_sym_throw] = ACTIONS(3068),
    [anon_sym_namespace] = ACTIONS(3068),
    [anon_sym_using] = ACTIONS(3068),
    [anon_sym_static_assert] = ACTIONS(3068),
    [anon_sym_concept] = ACTIONS(3068),
    [anon_sym_co_return] = ACTIONS(3068),
    [anon_sym_co_yield] = ACTIONS(3068),
    [anon_sym_R_DQUOTE] = ACTIONS(3070),
    [anon_sym_LR_DQUOTE] = ACTIONS(3070),
    [anon_sym_uR_DQUOTE] = ACTIONS(3070),
    [anon_sym_UR_DQUOTE] = ACTIONS(3070),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3070),
    [anon_sym_co_await] = ACTIONS(3068),
    [anon_sym_new] = ACTIONS(3068),
    [anon_sym_requires] = ACTIONS(3068),
    [sym_this] = ACTIONS(3068),
  },
  [336] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [aux_sym_preproc_else_token1] = ACTIONS(3072),
    [aux_sym_preproc_elif_token1] = ACTIONS(3072),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym___attribute] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym__Nonnull] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym__Alignas] = ACTIONS(3072),
    [sym_primitive_type] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [anon_sym___asm] = ACTIONS(3072),
    [sym_number_literal] = ACTIONS(3074),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [337] = {
    [sym_identifier] = ACTIONS(3076),
    [aux_sym_preproc_include_token1] = ACTIONS(3076),
    [aux_sym_preproc_def_token1] = ACTIONS(3076),
    [aux_sym_preproc_if_token1] = ACTIONS(3076),
    [aux_sym_preproc_if_token2] = ACTIONS(3076),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3076),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3076),
    [aux_sym_preproc_else_token1] = ACTIONS(3076),
    [aux_sym_preproc_elif_token1] = ACTIONS(3076),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3076),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3076),
    [sym_preproc_directive] = ACTIONS(3076),
    [anon_sym_LPAREN2] = ACTIONS(3078),
    [anon_sym_BANG] = ACTIONS(3078),
    [anon_sym_TILDE] = ACTIONS(3078),
    [anon_sym_DASH] = ACTIONS(3076),
    [anon_sym_PLUS] = ACTIONS(3076),
    [anon_sym_STAR] = ACTIONS(3078),
    [anon_sym_AMP_AMP] = ACTIONS(3078),
    [anon_sym_AMP] = ACTIONS(3076),
    [anon_sym_SEMI] = ACTIONS(3078),
    [anon_sym___extension__] = ACTIONS(3076),
    [anon_sym_typedef] = ACTIONS(3076),
    [anon_sym_virtual] = ACTIONS(3076),
    [anon_sym_extern] = ACTIONS(3076),
    [anon_sym___attribute__] = ACTIONS(3076),
    [anon_sym___attribute] = ACTIONS(3076),
    [anon_sym_COLON_COLON] = ACTIONS(3078),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3078),
    [anon_sym___declspec] = ACTIONS(3076),
    [anon_sym___based] = ACTIONS(3076),
    [anon_sym___cdecl] = ACTIONS(3076),
    [anon_sym___clrcall] = ACTIONS(3076),
    [anon_sym___stdcall] = ACTIONS(3076),
    [anon_sym___fastcall] = ACTIONS(3076),
    [anon_sym___thiscall] = ACTIONS(3076),
    [anon_sym___vectorcall] = ACTIONS(3076),
    [anon_sym_LBRACE] = ACTIONS(3078),
    [anon_sym_signed] = ACTIONS(3076),
    [anon_sym_unsigned] = ACTIONS(3076),
    [anon_sym_long] = ACTIONS(3076),
    [anon_sym_short] = ACTIONS(3076),
    [anon_sym_LBRACK] = ACTIONS(3076),
    [anon_sym_static] = ACTIONS(3076),
    [anon_sym_register] = ACTIONS(3076),
    [anon_sym_inline] = ACTIONS(3076),
    [anon_sym___inline] = ACTIONS(3076),
    [anon_sym___inline__] = ACTIONS(3076),
    [anon_sym___forceinline] = ACTIONS(3076),
    [anon_sym_thread_local] = ACTIONS(3076),
    [anon_sym___thread] = ACTIONS(3076),
    [anon_sym_const] = ACTIONS(3076),
    [anon_sym_constexpr] = ACTIONS(3076),
    [anon_sym_volatile] = ACTIONS(3076),
    [anon_sym_restrict] = ACTIONS(3076),
    [anon_sym___restrict__] = ACTIONS(3076),
    [anon_sym__Atomic] = ACTIONS(3076),
    [anon_sym__Noreturn] = ACTIONS(3076),
    [anon_sym_noreturn] = ACTIONS(3076),
    [anon_sym__Nonnull] = ACTIONS(3076),
    [anon_sym_mutable] = ACTIONS(3076),
    [anon_sym_constinit] = ACTIONS(3076),
    [anon_sym_consteval] = ACTIONS(3076),
    [anon_sym_alignas] = ACTIONS(3076),
    [anon_sym__Alignas] = ACTIONS(3076),
    [sym_primitive_type] = ACTIONS(3076),
    [anon_sym_enum] = ACTIONS(3076),
    [anon_sym_class] = ACTIONS(3076),
    [anon_sym_struct] = ACTIONS(3076),
    [anon_sym_union] = ACTIONS(3076),
    [anon_sym_if] = ACTIONS(3076),
    [anon_sym_switch] = ACTIONS(3076),
    [anon_sym_case] = ACTIONS(3076),
    [anon_sym_default] = ACTIONS(3076),
    [anon_sym_while] = ACTIONS(3076),
    [anon_sym_do] = ACTIONS(3076),
    [anon_sym_for] = ACTIONS(3076),
    [anon_sym_return] = ACTIONS(3076),
    [anon_sym_break] = ACTIONS(3076),
    [anon_sym_continue] = ACTIONS(3076),
    [anon_sym_goto] = ACTIONS(3076),
    [anon_sym___try] = ACTIONS(3076),
    [anon_sym___leave] = ACTIONS(3076),
    [anon_sym_not] = ACTIONS(3076),
    [anon_sym_compl] = ACTIONS(3076),
    [anon_sym_DASH_DASH] = ACTIONS(3078),
    [anon_sym_PLUS_PLUS] = ACTIONS(3078),
    [anon_sym_sizeof] = ACTIONS(3076),
    [anon_sym___alignof__] = ACTIONS(3076),
    [anon_sym___alignof] = ACTIONS(3076),
    [anon_sym__alignof] = ACTIONS(3076),
    [anon_sym_alignof] = ACTIONS(3076),
    [anon_sym__Alignof] = ACTIONS(3076),
    [anon_sym_offsetof] = ACTIONS(3076),
    [anon_sym__Generic] = ACTIONS(3076),
    [anon_sym_asm] = ACTIONS(3076),
    [anon_sym___asm__] = ACTIONS(3076),
    [anon_sym___asm] = ACTIONS(3076),
    [sym_number_literal] = ACTIONS(3078),
    [anon_sym_L_SQUOTE] = ACTIONS(3078),
    [anon_sym_u_SQUOTE] = ACTIONS(3078),
    [anon_sym_U_SQUOTE] = ACTIONS(3078),
    [anon_sym_u8_SQUOTE] = ACTIONS(3078),
    [anon_sym_SQUOTE] = ACTIONS(3078),
    [anon_sym_L_DQUOTE] = ACTIONS(3078),
    [anon_sym_u_DQUOTE] = ACTIONS(3078),
    [anon_sym_U_DQUOTE] = ACTIONS(3078),
    [anon_sym_u8_DQUOTE] = ACTIONS(3078),
    [anon_sym_DQUOTE] = ACTIONS(3078),
    [sym_true] = ACTIONS(3076),
    [sym_false] = ACTIONS(3076),
    [anon_sym_NULL] = ACTIONS(3076),
    [anon_sym_nullptr] = ACTIONS(3076),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3076),
    [anon_sym_decltype] = ACTIONS(3076),
    [anon_sym_explicit] = ACTIONS(3076),
    [anon_sym_typename] = ACTIONS(3076),
    [anon_sym_template] = ACTIONS(3076),
    [anon_sym_operator] = ACTIONS(3076),
    [anon_sym_try] = ACTIONS(3076),
    [anon_sym_delete] = ACTIONS(3076),
    [anon_sym_throw] = ACTIONS(3076),
    [anon_sym_namespace] = ACTIONS(3076),
    [anon_sym_using] = ACTIONS(3076),
    [anon_sym_static_assert] = ACTIONS(3076),
    [anon_sym_concept] = ACTIONS(3076),
    [anon_sym_co_return] = ACTIONS(3076),
    [anon_sym_co_yield] = ACTIONS(3076),
    [anon_sym_R_DQUOTE] = ACTIONS(3078),
    [anon_sym_LR_DQUOTE] = ACTIONS(3078),
    [anon_sym_uR_DQUOTE] = ACTIONS(3078),
    [anon_sym_UR_DQUOTE] = ACTIONS(3078),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3078),
    [anon_sym_co_await] = ACTIONS(3076),
    [anon_sym_new] = ACTIONS(3076),
    [anon_sym_requires] = ACTIONS(3076),
    [sym_this] = ACTIONS(3076),
  },
  [338] = {
    [sym_type_qualifier] = STATE(3798),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4559),
    [sym_sized_type_specifier] = STATE(2651),
    [sym_enum_specifier] = STATE(2651),
    [sym_struct_specifier] = STATE(2651),
    [sym_union_specifier] = STATE(2651),
    [sym_expression] = STATE(4295),
    [sym__string] = STATE(4637),
    [sym_conditional_expression] = STATE(4735),
    [sym_assignment_expression] = STATE(4735),
    [sym_pointer_expression] = STATE(3573),
    [sym_unary_expression] = STATE(4735),
    [sym_binary_expression] = STATE(4735),
    [sym_update_expression] = STATE(4735),
    [sym_cast_expression] = STATE(4735),
    [sym_type_descriptor] = STATE(6944),
    [sym_sizeof_expression] = STATE(4735),
    [sym_alignof_expression] = STATE(4735),
    [sym_offsetof_expression] = STATE(4735),
    [sym_generic_expression] = STATE(4735),
    [sym_subscript_expression] = STATE(3573),
    [sym_call_expression] = STATE(3573),
    [sym_gnu_asm_expression] = STATE(4735),
    [sym_extension_expression] = STATE(4735),
    [sym_field_expression] = STATE(3573),
    [sym_compound_literal_expression] = STATE(4735),
    [sym_parenthesized_expression] = STATE(3573),
    [sym_char_literal] = STATE(4637),
    [sym_concatenated_string] = STATE(4637),
    [sym_string_literal] = STATE(3662),
    [sym_null] = STATE(4735),
    [sym_placeholder_type_specifier] = STATE(2651),
    [sym_decltype_auto] = STATE(2637),
    [sym_decltype] = STATE(2563),
    [sym_class_specifier] = STATE(2651),
    [sym__class_name] = STATE(7513),
    [sym_dependent_type] = STATE(2651),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(4735),
    [sym_raw_string_literal] = STATE(3662),
    [sym_co_await_expression] = STATE(4735),
    [sym_new_expression] = STATE(4735),
    [sym_delete_expression] = STATE(4735),
    [sym_requires_clause] = STATE(4735),
    [sym_requires_expression] = STATE(4735),
    [sym_lambda_expression] = STATE(4735),
    [sym_lambda_capture_specifier] = STATE(5854),
    [sym_fold_expression] = STATE(4735),
    [sym_parameter_pack_expansion] = STATE(4735),
    [sym_type_parameter_pack_expansion] = STATE(7179),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5693),
    [sym_qualified_identifier] = STATE(3573),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym_user_defined_literal] = STATE(3573),
    [aux_sym__type_definition_type_repeat1] = STATE(3798),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4167),
    [sym_identifier] = ACTIONS(2854),
    [anon_sym_LPAREN2] = ACTIONS(2856),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(2864),
    [anon_sym_COLON_COLON] = ACTIONS(2866),
    [anon_sym_signed] = ACTIONS(2868),
    [anon_sym_unsigned] = ACTIONS(2868),
    [anon_sym_long] = ACTIONS(2868),
    [anon_sym_short] = ACTIONS(2868),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(2870),
    [anon_sym_enum] = ACTIONS(2872),
    [anon_sym_class] = ACTIONS(2874),
    [anon_sym_struct] = ACTIONS(2876),
    [anon_sym_union] = ACTIONS(2878),
    [anon_sym_not] = ACTIONS(2860),
    [anon_sym_compl] = ACTIONS(2860),
    [anon_sym_DASH_DASH] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(2880),
    [anon_sym_sizeof] = ACTIONS(2882),
    [anon_sym___alignof__] = ACTIONS(2884),
    [anon_sym___alignof] = ACTIONS(2884),
    [anon_sym__alignof] = ACTIONS(2884),
    [anon_sym_alignof] = ACTIONS(2884),
    [anon_sym__Alignof] = ACTIONS(2884),
    [anon_sym_offsetof] = ACTIONS(2886),
    [anon_sym__Generic] = ACTIONS(2888),
    [anon_sym_asm] = ACTIONS(2890),
    [anon_sym___asm__] = ACTIONS(2890),
    [anon_sym___asm] = ACTIONS(2890),
    [sym_number_literal] = ACTIONS(2892),
    [anon_sym_L_SQUOTE] = ACTIONS(2894),
    [anon_sym_u_SQUOTE] = ACTIONS(2894),
    [anon_sym_U_SQUOTE] = ACTIONS(2894),
    [anon_sym_u8_SQUOTE] = ACTIONS(2894),
    [anon_sym_SQUOTE] = ACTIONS(2894),
    [anon_sym_L_DQUOTE] = ACTIONS(2896),
    [anon_sym_u_DQUOTE] = ACTIONS(2896),
    [anon_sym_U_DQUOTE] = ACTIONS(2896),
    [anon_sym_u8_DQUOTE] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [anon_sym_NULL] = ACTIONS(2900),
    [anon_sym_nullptr] = ACTIONS(2900),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2902),
    [anon_sym_decltype] = ACTIONS(2904),
    [anon_sym_typename] = ACTIONS(2906),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_GT2] = ACTIONS(3080),
    [anon_sym_delete] = ACTIONS(2910),
    [anon_sym_R_DQUOTE] = ACTIONS(2912),
    [anon_sym_LR_DQUOTE] = ACTIONS(2912),
    [anon_sym_uR_DQUOTE] = ACTIONS(2912),
    [anon_sym_UR_DQUOTE] = ACTIONS(2912),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2912),
    [anon_sym_co_await] = ACTIONS(2914),
    [anon_sym_new] = ACTIONS(2916),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2898),
  },
  [339] = {
    [sym_identifier] = ACTIONS(3082),
    [aux_sym_preproc_include_token1] = ACTIONS(3082),
    [aux_sym_preproc_def_token1] = ACTIONS(3082),
    [aux_sym_preproc_if_token1] = ACTIONS(3082),
    [aux_sym_preproc_if_token2] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3082),
    [aux_sym_preproc_else_token1] = ACTIONS(3082),
    [aux_sym_preproc_elif_token1] = ACTIONS(3082),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3082),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3082),
    [sym_preproc_directive] = ACTIONS(3082),
    [anon_sym_LPAREN2] = ACTIONS(3084),
    [anon_sym_BANG] = ACTIONS(3084),
    [anon_sym_TILDE] = ACTIONS(3084),
    [anon_sym_DASH] = ACTIONS(3082),
    [anon_sym_PLUS] = ACTIONS(3082),
    [anon_sym_STAR] = ACTIONS(3084),
    [anon_sym_AMP_AMP] = ACTIONS(3084),
    [anon_sym_AMP] = ACTIONS(3082),
    [anon_sym_SEMI] = ACTIONS(3084),
    [anon_sym___extension__] = ACTIONS(3082),
    [anon_sym_typedef] = ACTIONS(3082),
    [anon_sym_virtual] = ACTIONS(3082),
    [anon_sym_extern] = ACTIONS(3082),
    [anon_sym___attribute__] = ACTIONS(3082),
    [anon_sym___attribute] = ACTIONS(3082),
    [anon_sym_COLON_COLON] = ACTIONS(3084),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3084),
    [anon_sym___declspec] = ACTIONS(3082),
    [anon_sym___based] = ACTIONS(3082),
    [anon_sym___cdecl] = ACTIONS(3082),
    [anon_sym___clrcall] = ACTIONS(3082),
    [anon_sym___stdcall] = ACTIONS(3082),
    [anon_sym___fastcall] = ACTIONS(3082),
    [anon_sym___thiscall] = ACTIONS(3082),
    [anon_sym___vectorcall] = ACTIONS(3082),
    [anon_sym_LBRACE] = ACTIONS(3084),
    [anon_sym_signed] = ACTIONS(3082),
    [anon_sym_unsigned] = ACTIONS(3082),
    [anon_sym_long] = ACTIONS(3082),
    [anon_sym_short] = ACTIONS(3082),
    [anon_sym_LBRACK] = ACTIONS(3082),
    [anon_sym_static] = ACTIONS(3082),
    [anon_sym_register] = ACTIONS(3082),
    [anon_sym_inline] = ACTIONS(3082),
    [anon_sym___inline] = ACTIONS(3082),
    [anon_sym___inline__] = ACTIONS(3082),
    [anon_sym___forceinline] = ACTIONS(3082),
    [anon_sym_thread_local] = ACTIONS(3082),
    [anon_sym___thread] = ACTIONS(3082),
    [anon_sym_const] = ACTIONS(3082),
    [anon_sym_constexpr] = ACTIONS(3082),
    [anon_sym_volatile] = ACTIONS(3082),
    [anon_sym_restrict] = ACTIONS(3082),
    [anon_sym___restrict__] = ACTIONS(3082),
    [anon_sym__Atomic] = ACTIONS(3082),
    [anon_sym__Noreturn] = ACTIONS(3082),
    [anon_sym_noreturn] = ACTIONS(3082),
    [anon_sym__Nonnull] = ACTIONS(3082),
    [anon_sym_mutable] = ACTIONS(3082),
    [anon_sym_constinit] = ACTIONS(3082),
    [anon_sym_consteval] = ACTIONS(3082),
    [anon_sym_alignas] = ACTIONS(3082),
    [anon_sym__Alignas] = ACTIONS(3082),
    [sym_primitive_type] = ACTIONS(3082),
    [anon_sym_enum] = ACTIONS(3082),
    [anon_sym_class] = ACTIONS(3082),
    [anon_sym_struct] = ACTIONS(3082),
    [anon_sym_union] = ACTIONS(3082),
    [anon_sym_if] = ACTIONS(3082),
    [anon_sym_switch] = ACTIONS(3082),
    [anon_sym_case] = ACTIONS(3082),
    [anon_sym_default] = ACTIONS(3082),
    [anon_sym_while] = ACTIONS(3082),
    [anon_sym_do] = ACTIONS(3082),
    [anon_sym_for] = ACTIONS(3082),
    [anon_sym_return] = ACTIONS(3082),
    [anon_sym_break] = ACTIONS(3082),
    [anon_sym_continue] = ACTIONS(3082),
    [anon_sym_goto] = ACTIONS(3082),
    [anon_sym___try] = ACTIONS(3082),
    [anon_sym___leave] = ACTIONS(3082),
    [anon_sym_not] = ACTIONS(3082),
    [anon_sym_compl] = ACTIONS(3082),
    [anon_sym_DASH_DASH] = ACTIONS(3084),
    [anon_sym_PLUS_PLUS] = ACTIONS(3084),
    [anon_sym_sizeof] = ACTIONS(3082),
    [anon_sym___alignof__] = ACTIONS(3082),
    [anon_sym___alignof] = ACTIONS(3082),
    [anon_sym__alignof] = ACTIONS(3082),
    [anon_sym_alignof] = ACTIONS(3082),
    [anon_sym__Alignof] = ACTIONS(3082),
    [anon_sym_offsetof] = ACTIONS(3082),
    [anon_sym__Generic] = ACTIONS(3082),
    [anon_sym_asm] = ACTIONS(3082),
    [anon_sym___asm__] = ACTIONS(3082),
    [anon_sym___asm] = ACTIONS(3082),
    [sym_number_literal] = ACTIONS(3084),
    [anon_sym_L_SQUOTE] = ACTIONS(3084),
    [anon_sym_u_SQUOTE] = ACTIONS(3084),
    [anon_sym_U_SQUOTE] = ACTIONS(3084),
    [anon_sym_u8_SQUOTE] = ACTIONS(3084),
    [anon_sym_SQUOTE] = ACTIONS(3084),
    [anon_sym_L_DQUOTE] = ACTIONS(3084),
    [anon_sym_u_DQUOTE] = ACTIONS(3084),
    [anon_sym_U_DQUOTE] = ACTIONS(3084),
    [anon_sym_u8_DQUOTE] = ACTIONS(3084),
    [anon_sym_DQUOTE] = ACTIONS(3084),
    [sym_true] = ACTIONS(3082),
    [sym_false] = ACTIONS(3082),
    [anon_sym_NULL] = ACTIONS(3082),
    [anon_sym_nullptr] = ACTIONS(3082),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3082),
    [anon_sym_decltype] = ACTIONS(3082),
    [anon_sym_explicit] = ACTIONS(3082),
    [anon_sym_typename] = ACTIONS(3082),
    [anon_sym_template] = ACTIONS(3082),
    [anon_sym_operator] = ACTIONS(3082),
    [anon_sym_try] = ACTIONS(3082),
    [anon_sym_delete] = ACTIONS(3082),
    [anon_sym_throw] = ACTIONS(3082),
    [anon_sym_namespace] = ACTIONS(3082),
    [anon_sym_using] = ACTIONS(3082),
    [anon_sym_static_assert] = ACTIONS(3082),
    [anon_sym_concept] = ACTIONS(3082),
    [anon_sym_co_return] = ACTIONS(3082),
    [anon_sym_co_yield] = ACTIONS(3082),
    [anon_sym_R_DQUOTE] = ACTIONS(3084),
    [anon_sym_LR_DQUOTE] = ACTIONS(3084),
    [anon_sym_uR_DQUOTE] = ACTIONS(3084),
    [anon_sym_UR_DQUOTE] = ACTIONS(3084),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3084),
    [anon_sym_co_await] = ACTIONS(3082),
    [anon_sym_new] = ACTIONS(3082),
    [anon_sym_requires] = ACTIONS(3082),
    [sym_this] = ACTIONS(3082),
  },
  [340] = {
    [sym_identifier] = ACTIONS(3086),
    [aux_sym_preproc_include_token1] = ACTIONS(3086),
    [aux_sym_preproc_def_token1] = ACTIONS(3086),
    [aux_sym_preproc_if_token1] = ACTIONS(3086),
    [aux_sym_preproc_if_token2] = ACTIONS(3086),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3086),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3086),
    [aux_sym_preproc_else_token1] = ACTIONS(3086),
    [aux_sym_preproc_elif_token1] = ACTIONS(3086),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3086),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3086),
    [sym_preproc_directive] = ACTIONS(3086),
    [anon_sym_LPAREN2] = ACTIONS(3089),
    [anon_sym_BANG] = ACTIONS(3089),
    [anon_sym_TILDE] = ACTIONS(3089),
    [anon_sym_DASH] = ACTIONS(3086),
    [anon_sym_PLUS] = ACTIONS(3086),
    [anon_sym_STAR] = ACTIONS(3089),
    [anon_sym_AMP_AMP] = ACTIONS(3089),
    [anon_sym_AMP] = ACTIONS(3086),
    [anon_sym_SEMI] = ACTIONS(3089),
    [anon_sym___extension__] = ACTIONS(3086),
    [anon_sym_typedef] = ACTIONS(3086),
    [anon_sym_virtual] = ACTIONS(3086),
    [anon_sym_extern] = ACTIONS(3086),
    [anon_sym___attribute__] = ACTIONS(3086),
    [anon_sym___attribute] = ACTIONS(3086),
    [anon_sym_COLON_COLON] = ACTIONS(3089),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3089),
    [anon_sym___declspec] = ACTIONS(3086),
    [anon_sym___based] = ACTIONS(3086),
    [anon_sym___cdecl] = ACTIONS(3086),
    [anon_sym___clrcall] = ACTIONS(3086),
    [anon_sym___stdcall] = ACTIONS(3086),
    [anon_sym___fastcall] = ACTIONS(3086),
    [anon_sym___thiscall] = ACTIONS(3086),
    [anon_sym___vectorcall] = ACTIONS(3086),
    [anon_sym_LBRACE] = ACTIONS(3089),
    [anon_sym_signed] = ACTIONS(3086),
    [anon_sym_unsigned] = ACTIONS(3086),
    [anon_sym_long] = ACTIONS(3086),
    [anon_sym_short] = ACTIONS(3086),
    [anon_sym_LBRACK] = ACTIONS(3086),
    [anon_sym_static] = ACTIONS(3086),
    [anon_sym_register] = ACTIONS(3086),
    [anon_sym_inline] = ACTIONS(3086),
    [anon_sym___inline] = ACTIONS(3086),
    [anon_sym___inline__] = ACTIONS(3086),
    [anon_sym___forceinline] = ACTIONS(3086),
    [anon_sym_thread_local] = ACTIONS(3086),
    [anon_sym___thread] = ACTIONS(3086),
    [anon_sym_const] = ACTIONS(3086),
    [anon_sym_constexpr] = ACTIONS(3086),
    [anon_sym_volatile] = ACTIONS(3086),
    [anon_sym_restrict] = ACTIONS(3086),
    [anon_sym___restrict__] = ACTIONS(3086),
    [anon_sym__Atomic] = ACTIONS(3086),
    [anon_sym__Noreturn] = ACTIONS(3086),
    [anon_sym_noreturn] = ACTIONS(3086),
    [anon_sym__Nonnull] = ACTIONS(3086),
    [anon_sym_mutable] = ACTIONS(3086),
    [anon_sym_constinit] = ACTIONS(3086),
    [anon_sym_consteval] = ACTIONS(3086),
    [anon_sym_alignas] = ACTIONS(3086),
    [anon_sym__Alignas] = ACTIONS(3086),
    [sym_primitive_type] = ACTIONS(3086),
    [anon_sym_enum] = ACTIONS(3086),
    [anon_sym_class] = ACTIONS(3086),
    [anon_sym_struct] = ACTIONS(3086),
    [anon_sym_union] = ACTIONS(3086),
    [anon_sym_if] = ACTIONS(3086),
    [anon_sym_switch] = ACTIONS(3086),
    [anon_sym_case] = ACTIONS(3086),
    [anon_sym_default] = ACTIONS(3086),
    [anon_sym_while] = ACTIONS(3086),
    [anon_sym_do] = ACTIONS(3086),
    [anon_sym_for] = ACTIONS(3086),
    [anon_sym_return] = ACTIONS(3086),
    [anon_sym_break] = ACTIONS(3086),
    [anon_sym_continue] = ACTIONS(3086),
    [anon_sym_goto] = ACTIONS(3086),
    [anon_sym___try] = ACTIONS(3086),
    [anon_sym___leave] = ACTIONS(3086),
    [anon_sym_not] = ACTIONS(3086),
    [anon_sym_compl] = ACTIONS(3086),
    [anon_sym_DASH_DASH] = ACTIONS(3089),
    [anon_sym_PLUS_PLUS] = ACTIONS(3089),
    [anon_sym_sizeof] = ACTIONS(3086),
    [anon_sym___alignof__] = ACTIONS(3086),
    [anon_sym___alignof] = ACTIONS(3086),
    [anon_sym__alignof] = ACTIONS(3086),
    [anon_sym_alignof] = ACTIONS(3086),
    [anon_sym__Alignof] = ACTIONS(3086),
    [anon_sym_offsetof] = ACTIONS(3086),
    [anon_sym__Generic] = ACTIONS(3086),
    [anon_sym_asm] = ACTIONS(3086),
    [anon_sym___asm__] = ACTIONS(3086),
    [anon_sym___asm] = ACTIONS(3086),
    [sym_number_literal] = ACTIONS(3089),
    [anon_sym_L_SQUOTE] = ACTIONS(3089),
    [anon_sym_u_SQUOTE] = ACTIONS(3089),
    [anon_sym_U_SQUOTE] = ACTIONS(3089),
    [anon_sym_u8_SQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3089),
    [anon_sym_L_DQUOTE] = ACTIONS(3089),
    [anon_sym_u_DQUOTE] = ACTIONS(3089),
    [anon_sym_U_DQUOTE] = ACTIONS(3089),
    [anon_sym_u8_DQUOTE] = ACTIONS(3089),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [sym_true] = ACTIONS(3086),
    [sym_false] = ACTIONS(3086),
    [anon_sym_NULL] = ACTIONS(3086),
    [anon_sym_nullptr] = ACTIONS(3086),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3086),
    [anon_sym_decltype] = ACTIONS(3086),
    [anon_sym_explicit] = ACTIONS(3086),
    [anon_sym_typename] = ACTIONS(3086),
    [anon_sym_template] = ACTIONS(3086),
    [anon_sym_operator] = ACTIONS(3086),
    [anon_sym_try] = ACTIONS(3086),
    [anon_sym_delete] = ACTIONS(3086),
    [anon_sym_throw] = ACTIONS(3086),
    [anon_sym_namespace] = ACTIONS(3086),
    [anon_sym_using] = ACTIONS(3086),
    [anon_sym_static_assert] = ACTIONS(3086),
    [anon_sym_concept] = ACTIONS(3086),
    [anon_sym_co_return] = ACTIONS(3086),
    [anon_sym_co_yield] = ACTIONS(3086),
    [anon_sym_R_DQUOTE] = ACTIONS(3089),
    [anon_sym_LR_DQUOTE] = ACTIONS(3089),
    [anon_sym_uR_DQUOTE] = ACTIONS(3089),
    [anon_sym_UR_DQUOTE] = ACTIONS(3089),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3089),
    [anon_sym_co_await] = ACTIONS(3086),
    [anon_sym_new] = ACTIONS(3086),
    [anon_sym_requires] = ACTIONS(3086),
    [sym_this] = ACTIONS(3086),
  },
  [341] = {
    [sym_type_qualifier] = STATE(3798),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4559),
    [sym_sized_type_specifier] = STATE(2651),
    [sym_enum_specifier] = STATE(2651),
    [sym_struct_specifier] = STATE(2651),
    [sym_union_specifier] = STATE(2651),
    [sym_expression] = STATE(4304),
    [sym__string] = STATE(4637),
    [sym_conditional_expression] = STATE(4735),
    [sym_assignment_expression] = STATE(4735),
    [sym_pointer_expression] = STATE(3573),
    [sym_unary_expression] = STATE(4735),
    [sym_binary_expression] = STATE(4735),
    [sym_update_expression] = STATE(4735),
    [sym_cast_expression] = STATE(4735),
    [sym_type_descriptor] = STATE(6984),
    [sym_sizeof_expression] = STATE(4735),
    [sym_alignof_expression] = STATE(4735),
    [sym_offsetof_expression] = STATE(4735),
    [sym_generic_expression] = STATE(4735),
    [sym_subscript_expression] = STATE(3573),
    [sym_call_expression] = STATE(3573),
    [sym_gnu_asm_expression] = STATE(4735),
    [sym_extension_expression] = STATE(4735),
    [sym_field_expression] = STATE(3573),
    [sym_compound_literal_expression] = STATE(4735),
    [sym_parenthesized_expression] = STATE(3573),
    [sym_char_literal] = STATE(4637),
    [sym_concatenated_string] = STATE(4637),
    [sym_string_literal] = STATE(3662),
    [sym_null] = STATE(4735),
    [sym_placeholder_type_specifier] = STATE(2651),
    [sym_decltype_auto] = STATE(2637),
    [sym_decltype] = STATE(2563),
    [sym_class_specifier] = STATE(2651),
    [sym__class_name] = STATE(7513),
    [sym_dependent_type] = STATE(2651),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(4735),
    [sym_raw_string_literal] = STATE(3662),
    [sym_co_await_expression] = STATE(4735),
    [sym_new_expression] = STATE(4735),
    [sym_delete_expression] = STATE(4735),
    [sym_requires_clause] = STATE(4735),
    [sym_requires_expression] = STATE(4735),
    [sym_lambda_expression] = STATE(4735),
    [sym_lambda_capture_specifier] = STATE(5854),
    [sym_fold_expression] = STATE(4735),
    [sym_parameter_pack_expansion] = STATE(4735),
    [sym_type_parameter_pack_expansion] = STATE(7305),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5693),
    [sym_qualified_identifier] = STATE(3573),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym_user_defined_literal] = STATE(3573),
    [aux_sym__type_definition_type_repeat1] = STATE(3798),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4167),
    [sym_identifier] = ACTIONS(2854),
    [anon_sym_LPAREN2] = ACTIONS(2856),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(2864),
    [anon_sym_COLON_COLON] = ACTIONS(2866),
    [anon_sym_signed] = ACTIONS(2868),
    [anon_sym_unsigned] = ACTIONS(2868),
    [anon_sym_long] = ACTIONS(2868),
    [anon_sym_short] = ACTIONS(2868),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(2870),
    [anon_sym_enum] = ACTIONS(2872),
    [anon_sym_class] = ACTIONS(2874),
    [anon_sym_struct] = ACTIONS(2876),
    [anon_sym_union] = ACTIONS(2878),
    [anon_sym_not] = ACTIONS(2860),
    [anon_sym_compl] = ACTIONS(2860),
    [anon_sym_DASH_DASH] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(2880),
    [anon_sym_sizeof] = ACTIONS(2882),
    [anon_sym___alignof__] = ACTIONS(2884),
    [anon_sym___alignof] = ACTIONS(2884),
    [anon_sym__alignof] = ACTIONS(2884),
    [anon_sym_alignof] = ACTIONS(2884),
    [anon_sym__Alignof] = ACTIONS(2884),
    [anon_sym_offsetof] = ACTIONS(2886),
    [anon_sym__Generic] = ACTIONS(2888),
    [anon_sym_asm] = ACTIONS(2890),
    [anon_sym___asm__] = ACTIONS(2890),
    [anon_sym___asm] = ACTIONS(2890),
    [sym_number_literal] = ACTIONS(2892),
    [anon_sym_L_SQUOTE] = ACTIONS(2894),
    [anon_sym_u_SQUOTE] = ACTIONS(2894),
    [anon_sym_U_SQUOTE] = ACTIONS(2894),
    [anon_sym_u8_SQUOTE] = ACTIONS(2894),
    [anon_sym_SQUOTE] = ACTIONS(2894),
    [anon_sym_L_DQUOTE] = ACTIONS(2896),
    [anon_sym_u_DQUOTE] = ACTIONS(2896),
    [anon_sym_U_DQUOTE] = ACTIONS(2896),
    [anon_sym_u8_DQUOTE] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [anon_sym_NULL] = ACTIONS(2900),
    [anon_sym_nullptr] = ACTIONS(2900),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2902),
    [anon_sym_decltype] = ACTIONS(2904),
    [anon_sym_typename] = ACTIONS(2906),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_GT2] = ACTIONS(3092),
    [anon_sym_delete] = ACTIONS(2910),
    [anon_sym_R_DQUOTE] = ACTIONS(2912),
    [anon_sym_LR_DQUOTE] = ACTIONS(2912),
    [anon_sym_uR_DQUOTE] = ACTIONS(2912),
    [anon_sym_UR_DQUOTE] = ACTIONS(2912),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2912),
    [anon_sym_co_await] = ACTIONS(2914),
    [anon_sym_new] = ACTIONS(2916),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2898),
  },
  [342] = {
    [sym_identifier] = ACTIONS(3094),
    [aux_sym_preproc_include_token1] = ACTIONS(3094),
    [aux_sym_preproc_def_token1] = ACTIONS(3094),
    [aux_sym_preproc_if_token1] = ACTIONS(3094),
    [aux_sym_preproc_if_token2] = ACTIONS(3094),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3094),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3094),
    [aux_sym_preproc_else_token1] = ACTIONS(3094),
    [aux_sym_preproc_elif_token1] = ACTIONS(3094),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3094),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3094),
    [sym_preproc_directive] = ACTIONS(3094),
    [anon_sym_LPAREN2] = ACTIONS(3096),
    [anon_sym_BANG] = ACTIONS(3096),
    [anon_sym_TILDE] = ACTIONS(3096),
    [anon_sym_DASH] = ACTIONS(3094),
    [anon_sym_PLUS] = ACTIONS(3094),
    [anon_sym_STAR] = ACTIONS(3096),
    [anon_sym_AMP_AMP] = ACTIONS(3096),
    [anon_sym_AMP] = ACTIONS(3094),
    [anon_sym_SEMI] = ACTIONS(3096),
    [anon_sym___extension__] = ACTIONS(3094),
    [anon_sym_typedef] = ACTIONS(3094),
    [anon_sym_virtual] = ACTIONS(3094),
    [anon_sym_extern] = ACTIONS(3094),
    [anon_sym___attribute__] = ACTIONS(3094),
    [anon_sym___attribute] = ACTIONS(3094),
    [anon_sym_COLON_COLON] = ACTIONS(3096),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3096),
    [anon_sym___declspec] = ACTIONS(3094),
    [anon_sym___based] = ACTIONS(3094),
    [anon_sym___cdecl] = ACTIONS(3094),
    [anon_sym___clrcall] = ACTIONS(3094),
    [anon_sym___stdcall] = ACTIONS(3094),
    [anon_sym___fastcall] = ACTIONS(3094),
    [anon_sym___thiscall] = ACTIONS(3094),
    [anon_sym___vectorcall] = ACTIONS(3094),
    [anon_sym_LBRACE] = ACTIONS(3096),
    [anon_sym_signed] = ACTIONS(3094),
    [anon_sym_unsigned] = ACTIONS(3094),
    [anon_sym_long] = ACTIONS(3094),
    [anon_sym_short] = ACTIONS(3094),
    [anon_sym_LBRACK] = ACTIONS(3094),
    [anon_sym_static] = ACTIONS(3094),
    [anon_sym_register] = ACTIONS(3094),
    [anon_sym_inline] = ACTIONS(3094),
    [anon_sym___inline] = ACTIONS(3094),
    [anon_sym___inline__] = ACTIONS(3094),
    [anon_sym___forceinline] = ACTIONS(3094),
    [anon_sym_thread_local] = ACTIONS(3094),
    [anon_sym___thread] = ACTIONS(3094),
    [anon_sym_const] = ACTIONS(3094),
    [anon_sym_constexpr] = ACTIONS(3094),
    [anon_sym_volatile] = ACTIONS(3094),
    [anon_sym_restrict] = ACTIONS(3094),
    [anon_sym___restrict__] = ACTIONS(3094),
    [anon_sym__Atomic] = ACTIONS(3094),
    [anon_sym__Noreturn] = ACTIONS(3094),
    [anon_sym_noreturn] = ACTIONS(3094),
    [anon_sym__Nonnull] = ACTIONS(3094),
    [anon_sym_mutable] = ACTIONS(3094),
    [anon_sym_constinit] = ACTIONS(3094),
    [anon_sym_consteval] = ACTIONS(3094),
    [anon_sym_alignas] = ACTIONS(3094),
    [anon_sym__Alignas] = ACTIONS(3094),
    [sym_primitive_type] = ACTIONS(3094),
    [anon_sym_enum] = ACTIONS(3094),
    [anon_sym_class] = ACTIONS(3094),
    [anon_sym_struct] = ACTIONS(3094),
    [anon_sym_union] = ACTIONS(3094),
    [anon_sym_if] = ACTIONS(3094),
    [anon_sym_switch] = ACTIONS(3094),
    [anon_sym_case] = ACTIONS(3094),
    [anon_sym_default] = ACTIONS(3094),
    [anon_sym_while] = ACTIONS(3094),
    [anon_sym_do] = ACTIONS(3094),
    [anon_sym_for] = ACTIONS(3094),
    [anon_sym_return] = ACTIONS(3094),
    [anon_sym_break] = ACTIONS(3094),
    [anon_sym_continue] = ACTIONS(3094),
    [anon_sym_goto] = ACTIONS(3094),
    [anon_sym___try] = ACTIONS(3094),
    [anon_sym___leave] = ACTIONS(3094),
    [anon_sym_not] = ACTIONS(3094),
    [anon_sym_compl] = ACTIONS(3094),
    [anon_sym_DASH_DASH] = ACTIONS(3096),
    [anon_sym_PLUS_PLUS] = ACTIONS(3096),
    [anon_sym_sizeof] = ACTIONS(3094),
    [anon_sym___alignof__] = ACTIONS(3094),
    [anon_sym___alignof] = ACTIONS(3094),
    [anon_sym__alignof] = ACTIONS(3094),
    [anon_sym_alignof] = ACTIONS(3094),
    [anon_sym__Alignof] = ACTIONS(3094),
    [anon_sym_offsetof] = ACTIONS(3094),
    [anon_sym__Generic] = ACTIONS(3094),
    [anon_sym_asm] = ACTIONS(3094),
    [anon_sym___asm__] = ACTIONS(3094),
    [anon_sym___asm] = ACTIONS(3094),
    [sym_number_literal] = ACTIONS(3096),
    [anon_sym_L_SQUOTE] = ACTIONS(3096),
    [anon_sym_u_SQUOTE] = ACTIONS(3096),
    [anon_sym_U_SQUOTE] = ACTIONS(3096),
    [anon_sym_u8_SQUOTE] = ACTIONS(3096),
    [anon_sym_SQUOTE] = ACTIONS(3096),
    [anon_sym_L_DQUOTE] = ACTIONS(3096),
    [anon_sym_u_DQUOTE] = ACTIONS(3096),
    [anon_sym_U_DQUOTE] = ACTIONS(3096),
    [anon_sym_u8_DQUOTE] = ACTIONS(3096),
    [anon_sym_DQUOTE] = ACTIONS(3096),
    [sym_true] = ACTIONS(3094),
    [sym_false] = ACTIONS(3094),
    [anon_sym_NULL] = ACTIONS(3094),
    [anon_sym_nullptr] = ACTIONS(3094),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3094),
    [anon_sym_decltype] = ACTIONS(3094),
    [anon_sym_explicit] = ACTIONS(3094),
    [anon_sym_typename] = ACTIONS(3094),
    [anon_sym_template] = ACTIONS(3094),
    [anon_sym_operator] = ACTIONS(3094),
    [anon_sym_try] = ACTIONS(3094),
    [anon_sym_delete] = ACTIONS(3094),
    [anon_sym_throw] = ACTIONS(3094),
    [anon_sym_namespace] = ACTIONS(3094),
    [anon_sym_using] = ACTIONS(3094),
    [anon_sym_static_assert] = ACTIONS(3094),
    [anon_sym_concept] = ACTIONS(3094),
    [anon_sym_co_return] = ACTIONS(3094),
    [anon_sym_co_yield] = ACTIONS(3094),
    [anon_sym_R_DQUOTE] = ACTIONS(3096),
    [anon_sym_LR_DQUOTE] = ACTIONS(3096),
    [anon_sym_uR_DQUOTE] = ACTIONS(3096),
    [anon_sym_UR_DQUOTE] = ACTIONS(3096),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3096),
    [anon_sym_co_await] = ACTIONS(3094),
    [anon_sym_new] = ACTIONS(3094),
    [anon_sym_requires] = ACTIONS(3094),
    [sym_this] = ACTIONS(3094),
  },
  [343] = {
    [sym_identifier] = ACTIONS(3098),
    [aux_sym_preproc_include_token1] = ACTIONS(3098),
    [aux_sym_preproc_def_token1] = ACTIONS(3098),
    [aux_sym_preproc_if_token1] = ACTIONS(3098),
    [aux_sym_preproc_if_token2] = ACTIONS(3098),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3098),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3098),
    [aux_sym_preproc_else_token1] = ACTIONS(3098),
    [aux_sym_preproc_elif_token1] = ACTIONS(3098),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3098),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3098),
    [sym_preproc_directive] = ACTIONS(3098),
    [anon_sym_LPAREN2] = ACTIONS(3100),
    [anon_sym_BANG] = ACTIONS(3100),
    [anon_sym_TILDE] = ACTIONS(3100),
    [anon_sym_DASH] = ACTIONS(3098),
    [anon_sym_PLUS] = ACTIONS(3098),
    [anon_sym_STAR] = ACTIONS(3100),
    [anon_sym_AMP_AMP] = ACTIONS(3100),
    [anon_sym_AMP] = ACTIONS(3098),
    [anon_sym_SEMI] = ACTIONS(3100),
    [anon_sym___extension__] = ACTIONS(3098),
    [anon_sym_typedef] = ACTIONS(3098),
    [anon_sym_virtual] = ACTIONS(3098),
    [anon_sym_extern] = ACTIONS(3098),
    [anon_sym___attribute__] = ACTIONS(3098),
    [anon_sym___attribute] = ACTIONS(3098),
    [anon_sym_COLON_COLON] = ACTIONS(3100),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3100),
    [anon_sym___declspec] = ACTIONS(3098),
    [anon_sym___based] = ACTIONS(3098),
    [anon_sym___cdecl] = ACTIONS(3098),
    [anon_sym___clrcall] = ACTIONS(3098),
    [anon_sym___stdcall] = ACTIONS(3098),
    [anon_sym___fastcall] = ACTIONS(3098),
    [anon_sym___thiscall] = ACTIONS(3098),
    [anon_sym___vectorcall] = ACTIONS(3098),
    [anon_sym_LBRACE] = ACTIONS(3100),
    [anon_sym_signed] = ACTIONS(3098),
    [anon_sym_unsigned] = ACTIONS(3098),
    [anon_sym_long] = ACTIONS(3098),
    [anon_sym_short] = ACTIONS(3098),
    [anon_sym_LBRACK] = ACTIONS(3098),
    [anon_sym_static] = ACTIONS(3098),
    [anon_sym_register] = ACTIONS(3098),
    [anon_sym_inline] = ACTIONS(3098),
    [anon_sym___inline] = ACTIONS(3098),
    [anon_sym___inline__] = ACTIONS(3098),
    [anon_sym___forceinline] = ACTIONS(3098),
    [anon_sym_thread_local] = ACTIONS(3098),
    [anon_sym___thread] = ACTIONS(3098),
    [anon_sym_const] = ACTIONS(3098),
    [anon_sym_constexpr] = ACTIONS(3098),
    [anon_sym_volatile] = ACTIONS(3098),
    [anon_sym_restrict] = ACTIONS(3098),
    [anon_sym___restrict__] = ACTIONS(3098),
    [anon_sym__Atomic] = ACTIONS(3098),
    [anon_sym__Noreturn] = ACTIONS(3098),
    [anon_sym_noreturn] = ACTIONS(3098),
    [anon_sym__Nonnull] = ACTIONS(3098),
    [anon_sym_mutable] = ACTIONS(3098),
    [anon_sym_constinit] = ACTIONS(3098),
    [anon_sym_consteval] = ACTIONS(3098),
    [anon_sym_alignas] = ACTIONS(3098),
    [anon_sym__Alignas] = ACTIONS(3098),
    [sym_primitive_type] = ACTIONS(3098),
    [anon_sym_enum] = ACTIONS(3098),
    [anon_sym_class] = ACTIONS(3098),
    [anon_sym_struct] = ACTIONS(3098),
    [anon_sym_union] = ACTIONS(3098),
    [anon_sym_if] = ACTIONS(3098),
    [anon_sym_switch] = ACTIONS(3098),
    [anon_sym_case] = ACTIONS(3098),
    [anon_sym_default] = ACTIONS(3098),
    [anon_sym_while] = ACTIONS(3098),
    [anon_sym_do] = ACTIONS(3098),
    [anon_sym_for] = ACTIONS(3098),
    [anon_sym_return] = ACTIONS(3098),
    [anon_sym_break] = ACTIONS(3098),
    [anon_sym_continue] = ACTIONS(3098),
    [anon_sym_goto] = ACTIONS(3098),
    [anon_sym___try] = ACTIONS(3098),
    [anon_sym___leave] = ACTIONS(3098),
    [anon_sym_not] = ACTIONS(3098),
    [anon_sym_compl] = ACTIONS(3098),
    [anon_sym_DASH_DASH] = ACTIONS(3100),
    [anon_sym_PLUS_PLUS] = ACTIONS(3100),
    [anon_sym_sizeof] = ACTIONS(3098),
    [anon_sym___alignof__] = ACTIONS(3098),
    [anon_sym___alignof] = ACTIONS(3098),
    [anon_sym__alignof] = ACTIONS(3098),
    [anon_sym_alignof] = ACTIONS(3098),
    [anon_sym__Alignof] = ACTIONS(3098),
    [anon_sym_offsetof] = ACTIONS(3098),
    [anon_sym__Generic] = ACTIONS(3098),
    [anon_sym_asm] = ACTIONS(3098),
    [anon_sym___asm__] = ACTIONS(3098),
    [anon_sym___asm] = ACTIONS(3098),
    [sym_number_literal] = ACTIONS(3100),
    [anon_sym_L_SQUOTE] = ACTIONS(3100),
    [anon_sym_u_SQUOTE] = ACTIONS(3100),
    [anon_sym_U_SQUOTE] = ACTIONS(3100),
    [anon_sym_u8_SQUOTE] = ACTIONS(3100),
    [anon_sym_SQUOTE] = ACTIONS(3100),
    [anon_sym_L_DQUOTE] = ACTIONS(3100),
    [anon_sym_u_DQUOTE] = ACTIONS(3100),
    [anon_sym_U_DQUOTE] = ACTIONS(3100),
    [anon_sym_u8_DQUOTE] = ACTIONS(3100),
    [anon_sym_DQUOTE] = ACTIONS(3100),
    [sym_true] = ACTIONS(3098),
    [sym_false] = ACTIONS(3098),
    [anon_sym_NULL] = ACTIONS(3098),
    [anon_sym_nullptr] = ACTIONS(3098),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3098),
    [anon_sym_decltype] = ACTIONS(3098),
    [anon_sym_explicit] = ACTIONS(3098),
    [anon_sym_typename] = ACTIONS(3098),
    [anon_sym_template] = ACTIONS(3098),
    [anon_sym_operator] = ACTIONS(3098),
    [anon_sym_try] = ACTIONS(3098),
    [anon_sym_delete] = ACTIONS(3098),
    [anon_sym_throw] = ACTIONS(3098),
    [anon_sym_namespace] = ACTIONS(3098),
    [anon_sym_using] = ACTIONS(3098),
    [anon_sym_static_assert] = ACTIONS(3098),
    [anon_sym_concept] = ACTIONS(3098),
    [anon_sym_co_return] = ACTIONS(3098),
    [anon_sym_co_yield] = ACTIONS(3098),
    [anon_sym_R_DQUOTE] = ACTIONS(3100),
    [anon_sym_LR_DQUOTE] = ACTIONS(3100),
    [anon_sym_uR_DQUOTE] = ACTIONS(3100),
    [anon_sym_UR_DQUOTE] = ACTIONS(3100),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3100),
    [anon_sym_co_await] = ACTIONS(3098),
    [anon_sym_new] = ACTIONS(3098),
    [anon_sym_requires] = ACTIONS(3098),
    [sym_this] = ACTIONS(3098),
  },
  [344] = {
    [sym_type_qualifier] = STATE(3798),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4559),
    [sym_sized_type_specifier] = STATE(2651),
    [sym_enum_specifier] = STATE(2651),
    [sym_struct_specifier] = STATE(2651),
    [sym_union_specifier] = STATE(2651),
    [sym_expression] = STATE(4310),
    [sym__string] = STATE(4637),
    [sym_conditional_expression] = STATE(4735),
    [sym_assignment_expression] = STATE(4735),
    [sym_pointer_expression] = STATE(3573),
    [sym_unary_expression] = STATE(4735),
    [sym_binary_expression] = STATE(4735),
    [sym_update_expression] = STATE(4735),
    [sym_cast_expression] = STATE(4735),
    [sym_type_descriptor] = STATE(7021),
    [sym_sizeof_expression] = STATE(4735),
    [sym_alignof_expression] = STATE(4735),
    [sym_offsetof_expression] = STATE(4735),
    [sym_generic_expression] = STATE(4735),
    [sym_subscript_expression] = STATE(3573),
    [sym_call_expression] = STATE(3573),
    [sym_gnu_asm_expression] = STATE(4735),
    [sym_extension_expression] = STATE(4735),
    [sym_field_expression] = STATE(3573),
    [sym_compound_literal_expression] = STATE(4735),
    [sym_parenthesized_expression] = STATE(3573),
    [sym_char_literal] = STATE(4637),
    [sym_concatenated_string] = STATE(4637),
    [sym_string_literal] = STATE(3662),
    [sym_null] = STATE(4735),
    [sym_placeholder_type_specifier] = STATE(2651),
    [sym_decltype_auto] = STATE(2637),
    [sym_decltype] = STATE(2563),
    [sym_class_specifier] = STATE(2651),
    [sym__class_name] = STATE(7513),
    [sym_dependent_type] = STATE(2651),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(4735),
    [sym_raw_string_literal] = STATE(3662),
    [sym_co_await_expression] = STATE(4735),
    [sym_new_expression] = STATE(4735),
    [sym_delete_expression] = STATE(4735),
    [sym_requires_clause] = STATE(4735),
    [sym_requires_expression] = STATE(4735),
    [sym_lambda_expression] = STATE(4735),
    [sym_lambda_capture_specifier] = STATE(5854),
    [sym_fold_expression] = STATE(4735),
    [sym_parameter_pack_expansion] = STATE(4735),
    [sym_type_parameter_pack_expansion] = STATE(7416),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5693),
    [sym_qualified_identifier] = STATE(3573),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym_user_defined_literal] = STATE(3573),
    [aux_sym__type_definition_type_repeat1] = STATE(3798),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4167),
    [sym_identifier] = ACTIONS(2854),
    [anon_sym_LPAREN2] = ACTIONS(2856),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(2864),
    [anon_sym_COLON_COLON] = ACTIONS(2866),
    [anon_sym_signed] = ACTIONS(2868),
    [anon_sym_unsigned] = ACTIONS(2868),
    [anon_sym_long] = ACTIONS(2868),
    [anon_sym_short] = ACTIONS(2868),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(2870),
    [anon_sym_enum] = ACTIONS(2872),
    [anon_sym_class] = ACTIONS(2874),
    [anon_sym_struct] = ACTIONS(2876),
    [anon_sym_union] = ACTIONS(2878),
    [anon_sym_not] = ACTIONS(2860),
    [anon_sym_compl] = ACTIONS(2860),
    [anon_sym_DASH_DASH] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(2880),
    [anon_sym_sizeof] = ACTIONS(2882),
    [anon_sym___alignof__] = ACTIONS(2884),
    [anon_sym___alignof] = ACTIONS(2884),
    [anon_sym__alignof] = ACTIONS(2884),
    [anon_sym_alignof] = ACTIONS(2884),
    [anon_sym__Alignof] = ACTIONS(2884),
    [anon_sym_offsetof] = ACTIONS(2886),
    [anon_sym__Generic] = ACTIONS(2888),
    [anon_sym_asm] = ACTIONS(2890),
    [anon_sym___asm__] = ACTIONS(2890),
    [anon_sym___asm] = ACTIONS(2890),
    [sym_number_literal] = ACTIONS(2892),
    [anon_sym_L_SQUOTE] = ACTIONS(2894),
    [anon_sym_u_SQUOTE] = ACTIONS(2894),
    [anon_sym_U_SQUOTE] = ACTIONS(2894),
    [anon_sym_u8_SQUOTE] = ACTIONS(2894),
    [anon_sym_SQUOTE] = ACTIONS(2894),
    [anon_sym_L_DQUOTE] = ACTIONS(2896),
    [anon_sym_u_DQUOTE] = ACTIONS(2896),
    [anon_sym_U_DQUOTE] = ACTIONS(2896),
    [anon_sym_u8_DQUOTE] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [anon_sym_NULL] = ACTIONS(2900),
    [anon_sym_nullptr] = ACTIONS(2900),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2902),
    [anon_sym_decltype] = ACTIONS(2904),
    [anon_sym_typename] = ACTIONS(2906),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_GT2] = ACTIONS(3102),
    [anon_sym_delete] = ACTIONS(2910),
    [anon_sym_R_DQUOTE] = ACTIONS(2912),
    [anon_sym_LR_DQUOTE] = ACTIONS(2912),
    [anon_sym_uR_DQUOTE] = ACTIONS(2912),
    [anon_sym_UR_DQUOTE] = ACTIONS(2912),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2912),
    [anon_sym_co_await] = ACTIONS(2914),
    [anon_sym_new] = ACTIONS(2916),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2898),
  },
  [345] = {
    [sym_identifier] = ACTIONS(3104),
    [aux_sym_preproc_include_token1] = ACTIONS(3104),
    [aux_sym_preproc_def_token1] = ACTIONS(3104),
    [aux_sym_preproc_if_token1] = ACTIONS(3104),
    [aux_sym_preproc_if_token2] = ACTIONS(3104),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3104),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3104),
    [aux_sym_preproc_else_token1] = ACTIONS(3104),
    [aux_sym_preproc_elif_token1] = ACTIONS(3104),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3104),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3104),
    [sym_preproc_directive] = ACTIONS(3104),
    [anon_sym_LPAREN2] = ACTIONS(3106),
    [anon_sym_BANG] = ACTIONS(3106),
    [anon_sym_TILDE] = ACTIONS(3106),
    [anon_sym_DASH] = ACTIONS(3104),
    [anon_sym_PLUS] = ACTIONS(3104),
    [anon_sym_STAR] = ACTIONS(3106),
    [anon_sym_AMP_AMP] = ACTIONS(3106),
    [anon_sym_AMP] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(3106),
    [anon_sym___extension__] = ACTIONS(3104),
    [anon_sym_typedef] = ACTIONS(3104),
    [anon_sym_virtual] = ACTIONS(3104),
    [anon_sym_extern] = ACTIONS(3104),
    [anon_sym___attribute__] = ACTIONS(3104),
    [anon_sym___attribute] = ACTIONS(3104),
    [anon_sym_COLON_COLON] = ACTIONS(3106),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3106),
    [anon_sym___declspec] = ACTIONS(3104),
    [anon_sym___based] = ACTIONS(3104),
    [anon_sym___cdecl] = ACTIONS(3104),
    [anon_sym___clrcall] = ACTIONS(3104),
    [anon_sym___stdcall] = ACTIONS(3104),
    [anon_sym___fastcall] = ACTIONS(3104),
    [anon_sym___thiscall] = ACTIONS(3104),
    [anon_sym___vectorcall] = ACTIONS(3104),
    [anon_sym_LBRACE] = ACTIONS(3106),
    [anon_sym_signed] = ACTIONS(3104),
    [anon_sym_unsigned] = ACTIONS(3104),
    [anon_sym_long] = ACTIONS(3104),
    [anon_sym_short] = ACTIONS(3104),
    [anon_sym_LBRACK] = ACTIONS(3104),
    [anon_sym_static] = ACTIONS(3104),
    [anon_sym_register] = ACTIONS(3104),
    [anon_sym_inline] = ACTIONS(3104),
    [anon_sym___inline] = ACTIONS(3104),
    [anon_sym___inline__] = ACTIONS(3104),
    [anon_sym___forceinline] = ACTIONS(3104),
    [anon_sym_thread_local] = ACTIONS(3104),
    [anon_sym___thread] = ACTIONS(3104),
    [anon_sym_const] = ACTIONS(3104),
    [anon_sym_constexpr] = ACTIONS(3104),
    [anon_sym_volatile] = ACTIONS(3104),
    [anon_sym_restrict] = ACTIONS(3104),
    [anon_sym___restrict__] = ACTIONS(3104),
    [anon_sym__Atomic] = ACTIONS(3104),
    [anon_sym__Noreturn] = ACTIONS(3104),
    [anon_sym_noreturn] = ACTIONS(3104),
    [anon_sym__Nonnull] = ACTIONS(3104),
    [anon_sym_mutable] = ACTIONS(3104),
    [anon_sym_constinit] = ACTIONS(3104),
    [anon_sym_consteval] = ACTIONS(3104),
    [anon_sym_alignas] = ACTIONS(3104),
    [anon_sym__Alignas] = ACTIONS(3104),
    [sym_primitive_type] = ACTIONS(3104),
    [anon_sym_enum] = ACTIONS(3104),
    [anon_sym_class] = ACTIONS(3104),
    [anon_sym_struct] = ACTIONS(3104),
    [anon_sym_union] = ACTIONS(3104),
    [anon_sym_if] = ACTIONS(3104),
    [anon_sym_switch] = ACTIONS(3104),
    [anon_sym_case] = ACTIONS(3104),
    [anon_sym_default] = ACTIONS(3104),
    [anon_sym_while] = ACTIONS(3104),
    [anon_sym_do] = ACTIONS(3104),
    [anon_sym_for] = ACTIONS(3104),
    [anon_sym_return] = ACTIONS(3104),
    [anon_sym_break] = ACTIONS(3104),
    [anon_sym_continue] = ACTIONS(3104),
    [anon_sym_goto] = ACTIONS(3104),
    [anon_sym___try] = ACTIONS(3104),
    [anon_sym___leave] = ACTIONS(3104),
    [anon_sym_not] = ACTIONS(3104),
    [anon_sym_compl] = ACTIONS(3104),
    [anon_sym_DASH_DASH] = ACTIONS(3106),
    [anon_sym_PLUS_PLUS] = ACTIONS(3106),
    [anon_sym_sizeof] = ACTIONS(3104),
    [anon_sym___alignof__] = ACTIONS(3104),
    [anon_sym___alignof] = ACTIONS(3104),
    [anon_sym__alignof] = ACTIONS(3104),
    [anon_sym_alignof] = ACTIONS(3104),
    [anon_sym__Alignof] = ACTIONS(3104),
    [anon_sym_offsetof] = ACTIONS(3104),
    [anon_sym__Generic] = ACTIONS(3104),
    [anon_sym_asm] = ACTIONS(3104),
    [anon_sym___asm__] = ACTIONS(3104),
    [anon_sym___asm] = ACTIONS(3104),
    [sym_number_literal] = ACTIONS(3106),
    [anon_sym_L_SQUOTE] = ACTIONS(3106),
    [anon_sym_u_SQUOTE] = ACTIONS(3106),
    [anon_sym_U_SQUOTE] = ACTIONS(3106),
    [anon_sym_u8_SQUOTE] = ACTIONS(3106),
    [anon_sym_SQUOTE] = ACTIONS(3106),
    [anon_sym_L_DQUOTE] = ACTIONS(3106),
    [anon_sym_u_DQUOTE] = ACTIONS(3106),
    [anon_sym_U_DQUOTE] = ACTIONS(3106),
    [anon_sym_u8_DQUOTE] = ACTIONS(3106),
    [anon_sym_DQUOTE] = ACTIONS(3106),
    [sym_true] = ACTIONS(3104),
    [sym_false] = ACTIONS(3104),
    [anon_sym_NULL] = ACTIONS(3104),
    [anon_sym_nullptr] = ACTIONS(3104),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3104),
    [anon_sym_decltype] = ACTIONS(3104),
    [anon_sym_explicit] = ACTIONS(3104),
    [anon_sym_typename] = ACTIONS(3104),
    [anon_sym_template] = ACTIONS(3104),
    [anon_sym_operator] = ACTIONS(3104),
    [anon_sym_try] = ACTIONS(3104),
    [anon_sym_delete] = ACTIONS(3104),
    [anon_sym_throw] = ACTIONS(3104),
    [anon_sym_namespace] = ACTIONS(3104),
    [anon_sym_using] = ACTIONS(3104),
    [anon_sym_static_assert] = ACTIONS(3104),
    [anon_sym_concept] = ACTIONS(3104),
    [anon_sym_co_return] = ACTIONS(3104),
    [anon_sym_co_yield] = ACTIONS(3104),
    [anon_sym_R_DQUOTE] = ACTIONS(3106),
    [anon_sym_LR_DQUOTE] = ACTIONS(3106),
    [anon_sym_uR_DQUOTE] = ACTIONS(3106),
    [anon_sym_UR_DQUOTE] = ACTIONS(3106),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3106),
    [anon_sym_co_await] = ACTIONS(3104),
    [anon_sym_new] = ACTIONS(3104),
    [anon_sym_requires] = ACTIONS(3104),
    [sym_this] = ACTIONS(3104),
  },
  [346] = {
    [sym_type_qualifier] = STATE(3798),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4559),
    [sym_sized_type_specifier] = STATE(2651),
    [sym_enum_specifier] = STATE(2651),
    [sym_struct_specifier] = STATE(2651),
    [sym_union_specifier] = STATE(2651),
    [sym_expression] = STATE(4315),
    [sym__string] = STATE(4637),
    [sym_conditional_expression] = STATE(4735),
    [sym_assignment_expression] = STATE(4735),
    [sym_pointer_expression] = STATE(3573),
    [sym_unary_expression] = STATE(4735),
    [sym_binary_expression] = STATE(4735),
    [sym_update_expression] = STATE(4735),
    [sym_cast_expression] = STATE(4735),
    [sym_type_descriptor] = STATE(6817),
    [sym_sizeof_expression] = STATE(4735),
    [sym_alignof_expression] = STATE(4735),
    [sym_offsetof_expression] = STATE(4735),
    [sym_generic_expression] = STATE(4735),
    [sym_subscript_expression] = STATE(3573),
    [sym_call_expression] = STATE(3573),
    [sym_gnu_asm_expression] = STATE(4735),
    [sym_extension_expression] = STATE(4735),
    [sym_field_expression] = STATE(3573),
    [sym_compound_literal_expression] = STATE(4735),
    [sym_parenthesized_expression] = STATE(3573),
    [sym_char_literal] = STATE(4637),
    [sym_concatenated_string] = STATE(4637),
    [sym_string_literal] = STATE(3662),
    [sym_null] = STATE(4735),
    [sym_placeholder_type_specifier] = STATE(2651),
    [sym_decltype_auto] = STATE(2637),
    [sym_decltype] = STATE(2563),
    [sym_class_specifier] = STATE(2651),
    [sym__class_name] = STATE(7513),
    [sym_dependent_type] = STATE(2651),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(4735),
    [sym_raw_string_literal] = STATE(3662),
    [sym_co_await_expression] = STATE(4735),
    [sym_new_expression] = STATE(4735),
    [sym_delete_expression] = STATE(4735),
    [sym_requires_clause] = STATE(4735),
    [sym_requires_expression] = STATE(4735),
    [sym_lambda_expression] = STATE(4735),
    [sym_lambda_capture_specifier] = STATE(5854),
    [sym_fold_expression] = STATE(4735),
    [sym_parameter_pack_expansion] = STATE(4735),
    [sym_type_parameter_pack_expansion] = STATE(7130),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5693),
    [sym_qualified_identifier] = STATE(3573),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym_user_defined_literal] = STATE(3573),
    [aux_sym__type_definition_type_repeat1] = STATE(3798),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4167),
    [sym_identifier] = ACTIONS(2854),
    [anon_sym_LPAREN2] = ACTIONS(2856),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(2864),
    [anon_sym_COLON_COLON] = ACTIONS(2866),
    [anon_sym_signed] = ACTIONS(2868),
    [anon_sym_unsigned] = ACTIONS(2868),
    [anon_sym_long] = ACTIONS(2868),
    [anon_sym_short] = ACTIONS(2868),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(2870),
    [anon_sym_enum] = ACTIONS(2872),
    [anon_sym_class] = ACTIONS(2874),
    [anon_sym_struct] = ACTIONS(2876),
    [anon_sym_union] = ACTIONS(2878),
    [anon_sym_not] = ACTIONS(2860),
    [anon_sym_compl] = ACTIONS(2860),
    [anon_sym_DASH_DASH] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(2880),
    [anon_sym_sizeof] = ACTIONS(2882),
    [anon_sym___alignof__] = ACTIONS(2884),
    [anon_sym___alignof] = ACTIONS(2884),
    [anon_sym__alignof] = ACTIONS(2884),
    [anon_sym_alignof] = ACTIONS(2884),
    [anon_sym__Alignof] = ACTIONS(2884),
    [anon_sym_offsetof] = ACTIONS(2886),
    [anon_sym__Generic] = ACTIONS(2888),
    [anon_sym_asm] = ACTIONS(2890),
    [anon_sym___asm__] = ACTIONS(2890),
    [anon_sym___asm] = ACTIONS(2890),
    [sym_number_literal] = ACTIONS(2892),
    [anon_sym_L_SQUOTE] = ACTIONS(2894),
    [anon_sym_u_SQUOTE] = ACTIONS(2894),
    [anon_sym_U_SQUOTE] = ACTIONS(2894),
    [anon_sym_u8_SQUOTE] = ACTIONS(2894),
    [anon_sym_SQUOTE] = ACTIONS(2894),
    [anon_sym_L_DQUOTE] = ACTIONS(2896),
    [anon_sym_u_DQUOTE] = ACTIONS(2896),
    [anon_sym_U_DQUOTE] = ACTIONS(2896),
    [anon_sym_u8_DQUOTE] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [anon_sym_NULL] = ACTIONS(2900),
    [anon_sym_nullptr] = ACTIONS(2900),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2902),
    [anon_sym_decltype] = ACTIONS(2904),
    [anon_sym_typename] = ACTIONS(2906),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_GT2] = ACTIONS(3108),
    [anon_sym_delete] = ACTIONS(2910),
    [anon_sym_R_DQUOTE] = ACTIONS(2912),
    [anon_sym_LR_DQUOTE] = ACTIONS(2912),
    [anon_sym_uR_DQUOTE] = ACTIONS(2912),
    [anon_sym_UR_DQUOTE] = ACTIONS(2912),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2912),
    [anon_sym_co_await] = ACTIONS(2914),
    [anon_sym_new] = ACTIONS(2916),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2898),
  },
  [347] = {
    [sym_type_qualifier] = STATE(3798),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4559),
    [sym_sized_type_specifier] = STATE(2651),
    [sym_enum_specifier] = STATE(2651),
    [sym_struct_specifier] = STATE(2651),
    [sym_union_specifier] = STATE(2651),
    [sym_expression] = STATE(4316),
    [sym__string] = STATE(4637),
    [sym_conditional_expression] = STATE(4735),
    [sym_assignment_expression] = STATE(4735),
    [sym_pointer_expression] = STATE(3573),
    [sym_unary_expression] = STATE(4735),
    [sym_binary_expression] = STATE(4735),
    [sym_update_expression] = STATE(4735),
    [sym_cast_expression] = STATE(4735),
    [sym_type_descriptor] = STATE(6834),
    [sym_sizeof_expression] = STATE(4735),
    [sym_alignof_expression] = STATE(4735),
    [sym_offsetof_expression] = STATE(4735),
    [sym_generic_expression] = STATE(4735),
    [sym_subscript_expression] = STATE(3573),
    [sym_call_expression] = STATE(3573),
    [sym_gnu_asm_expression] = STATE(4735),
    [sym_extension_expression] = STATE(4735),
    [sym_field_expression] = STATE(3573),
    [sym_compound_literal_expression] = STATE(4735),
    [sym_parenthesized_expression] = STATE(3573),
    [sym_char_literal] = STATE(4637),
    [sym_concatenated_string] = STATE(4637),
    [sym_string_literal] = STATE(3662),
    [sym_null] = STATE(4735),
    [sym_placeholder_type_specifier] = STATE(2651),
    [sym_decltype_auto] = STATE(2637),
    [sym_decltype] = STATE(2563),
    [sym_class_specifier] = STATE(2651),
    [sym__class_name] = STATE(7513),
    [sym_dependent_type] = STATE(2651),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(4735),
    [sym_raw_string_literal] = STATE(3662),
    [sym_co_await_expression] = STATE(4735),
    [sym_new_expression] = STATE(4735),
    [sym_delete_expression] = STATE(4735),
    [sym_requires_clause] = STATE(4735),
    [sym_requires_expression] = STATE(4735),
    [sym_lambda_expression] = STATE(4735),
    [sym_lambda_capture_specifier] = STATE(5854),
    [sym_fold_expression] = STATE(4735),
    [sym_parameter_pack_expansion] = STATE(4735),
    [sym_type_parameter_pack_expansion] = STATE(7370),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5693),
    [sym_qualified_identifier] = STATE(3573),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym_user_defined_literal] = STATE(3573),
    [aux_sym__type_definition_type_repeat1] = STATE(3798),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4167),
    [sym_identifier] = ACTIONS(2854),
    [anon_sym_LPAREN2] = ACTIONS(2856),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(2864),
    [anon_sym_COLON_COLON] = ACTIONS(2866),
    [anon_sym_signed] = ACTIONS(2868),
    [anon_sym_unsigned] = ACTIONS(2868),
    [anon_sym_long] = ACTIONS(2868),
    [anon_sym_short] = ACTIONS(2868),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(2870),
    [anon_sym_enum] = ACTIONS(2872),
    [anon_sym_class] = ACTIONS(2874),
    [anon_sym_struct] = ACTIONS(2876),
    [anon_sym_union] = ACTIONS(2878),
    [anon_sym_not] = ACTIONS(2860),
    [anon_sym_compl] = ACTIONS(2860),
    [anon_sym_DASH_DASH] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(2880),
    [anon_sym_sizeof] = ACTIONS(2882),
    [anon_sym___alignof__] = ACTIONS(2884),
    [anon_sym___alignof] = ACTIONS(2884),
    [anon_sym__alignof] = ACTIONS(2884),
    [anon_sym_alignof] = ACTIONS(2884),
    [anon_sym__Alignof] = ACTIONS(2884),
    [anon_sym_offsetof] = ACTIONS(2886),
    [anon_sym__Generic] = ACTIONS(2888),
    [anon_sym_asm] = ACTIONS(2890),
    [anon_sym___asm__] = ACTIONS(2890),
    [anon_sym___asm] = ACTIONS(2890),
    [sym_number_literal] = ACTIONS(2892),
    [anon_sym_L_SQUOTE] = ACTIONS(2894),
    [anon_sym_u_SQUOTE] = ACTIONS(2894),
    [anon_sym_U_SQUOTE] = ACTIONS(2894),
    [anon_sym_u8_SQUOTE] = ACTIONS(2894),
    [anon_sym_SQUOTE] = ACTIONS(2894),
    [anon_sym_L_DQUOTE] = ACTIONS(2896),
    [anon_sym_u_DQUOTE] = ACTIONS(2896),
    [anon_sym_U_DQUOTE] = ACTIONS(2896),
    [anon_sym_u8_DQUOTE] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [anon_sym_NULL] = ACTIONS(2900),
    [anon_sym_nullptr] = ACTIONS(2900),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2902),
    [anon_sym_decltype] = ACTIONS(2904),
    [anon_sym_typename] = ACTIONS(2906),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_GT2] = ACTIONS(3110),
    [anon_sym_delete] = ACTIONS(2910),
    [anon_sym_R_DQUOTE] = ACTIONS(2912),
    [anon_sym_LR_DQUOTE] = ACTIONS(2912),
    [anon_sym_uR_DQUOTE] = ACTIONS(2912),
    [anon_sym_UR_DQUOTE] = ACTIONS(2912),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2912),
    [anon_sym_co_await] = ACTIONS(2914),
    [anon_sym_new] = ACTIONS(2916),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2898),
  },
  [348] = {
    [sym_type_qualifier] = STATE(3798),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4559),
    [sym_sized_type_specifier] = STATE(2651),
    [sym_enum_specifier] = STATE(2651),
    [sym_struct_specifier] = STATE(2651),
    [sym_union_specifier] = STATE(2651),
    [sym_expression] = STATE(4318),
    [sym__string] = STATE(4637),
    [sym_conditional_expression] = STATE(4735),
    [sym_assignment_expression] = STATE(4735),
    [sym_pointer_expression] = STATE(3573),
    [sym_unary_expression] = STATE(4735),
    [sym_binary_expression] = STATE(4735),
    [sym_update_expression] = STATE(4735),
    [sym_cast_expression] = STATE(4735),
    [sym_type_descriptor] = STATE(6846),
    [sym_sizeof_expression] = STATE(4735),
    [sym_alignof_expression] = STATE(4735),
    [sym_offsetof_expression] = STATE(4735),
    [sym_generic_expression] = STATE(4735),
    [sym_subscript_expression] = STATE(3573),
    [sym_call_expression] = STATE(3573),
    [sym_gnu_asm_expression] = STATE(4735),
    [sym_extension_expression] = STATE(4735),
    [sym_field_expression] = STATE(3573),
    [sym_compound_literal_expression] = STATE(4735),
    [sym_parenthesized_expression] = STATE(3573),
    [sym_char_literal] = STATE(4637),
    [sym_concatenated_string] = STATE(4637),
    [sym_string_literal] = STATE(3662),
    [sym_null] = STATE(4735),
    [sym_placeholder_type_specifier] = STATE(2651),
    [sym_decltype_auto] = STATE(2637),
    [sym_decltype] = STATE(2563),
    [sym_class_specifier] = STATE(2651),
    [sym__class_name] = STATE(7513),
    [sym_dependent_type] = STATE(2651),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(4735),
    [sym_raw_string_literal] = STATE(3662),
    [sym_co_await_expression] = STATE(4735),
    [sym_new_expression] = STATE(4735),
    [sym_delete_expression] = STATE(4735),
    [sym_requires_clause] = STATE(4735),
    [sym_requires_expression] = STATE(4735),
    [sym_lambda_expression] = STATE(4735),
    [sym_lambda_capture_specifier] = STATE(5854),
    [sym_fold_expression] = STATE(4735),
    [sym_parameter_pack_expansion] = STATE(4735),
    [sym_type_parameter_pack_expansion] = STATE(7095),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5693),
    [sym_qualified_identifier] = STATE(3573),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym_user_defined_literal] = STATE(3573),
    [aux_sym__type_definition_type_repeat1] = STATE(3798),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4167),
    [sym_identifier] = ACTIONS(2854),
    [anon_sym_LPAREN2] = ACTIONS(2856),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(2864),
    [anon_sym_COLON_COLON] = ACTIONS(2866),
    [anon_sym_signed] = ACTIONS(2868),
    [anon_sym_unsigned] = ACTIONS(2868),
    [anon_sym_long] = ACTIONS(2868),
    [anon_sym_short] = ACTIONS(2868),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(2870),
    [anon_sym_enum] = ACTIONS(2872),
    [anon_sym_class] = ACTIONS(2874),
    [anon_sym_struct] = ACTIONS(2876),
    [anon_sym_union] = ACTIONS(2878),
    [anon_sym_not] = ACTIONS(2860),
    [anon_sym_compl] = ACTIONS(2860),
    [anon_sym_DASH_DASH] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(2880),
    [anon_sym_sizeof] = ACTIONS(2882),
    [anon_sym___alignof__] = ACTIONS(2884),
    [anon_sym___alignof] = ACTIONS(2884),
    [anon_sym__alignof] = ACTIONS(2884),
    [anon_sym_alignof] = ACTIONS(2884),
    [anon_sym__Alignof] = ACTIONS(2884),
    [anon_sym_offsetof] = ACTIONS(2886),
    [anon_sym__Generic] = ACTIONS(2888),
    [anon_sym_asm] = ACTIONS(2890),
    [anon_sym___asm__] = ACTIONS(2890),
    [anon_sym___asm] = ACTIONS(2890),
    [sym_number_literal] = ACTIONS(2892),
    [anon_sym_L_SQUOTE] = ACTIONS(2894),
    [anon_sym_u_SQUOTE] = ACTIONS(2894),
    [anon_sym_U_SQUOTE] = ACTIONS(2894),
    [anon_sym_u8_SQUOTE] = ACTIONS(2894),
    [anon_sym_SQUOTE] = ACTIONS(2894),
    [anon_sym_L_DQUOTE] = ACTIONS(2896),
    [anon_sym_u_DQUOTE] = ACTIONS(2896),
    [anon_sym_U_DQUOTE] = ACTIONS(2896),
    [anon_sym_u8_DQUOTE] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [anon_sym_NULL] = ACTIONS(2900),
    [anon_sym_nullptr] = ACTIONS(2900),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2902),
    [anon_sym_decltype] = ACTIONS(2904),
    [anon_sym_typename] = ACTIONS(2906),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_GT2] = ACTIONS(3112),
    [anon_sym_delete] = ACTIONS(2910),
    [anon_sym_R_DQUOTE] = ACTIONS(2912),
    [anon_sym_LR_DQUOTE] = ACTIONS(2912),
    [anon_sym_uR_DQUOTE] = ACTIONS(2912),
    [anon_sym_UR_DQUOTE] = ACTIONS(2912),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2912),
    [anon_sym_co_await] = ACTIONS(2914),
    [anon_sym_new] = ACTIONS(2916),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2898),
  },
  [349] = {
    [sym_identifier] = ACTIONS(3114),
    [aux_sym_preproc_include_token1] = ACTIONS(3114),
    [aux_sym_preproc_def_token1] = ACTIONS(3114),
    [aux_sym_preproc_if_token1] = ACTIONS(3114),
    [aux_sym_preproc_if_token2] = ACTIONS(3114),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3114),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3114),
    [aux_sym_preproc_else_token1] = ACTIONS(3114),
    [aux_sym_preproc_elif_token1] = ACTIONS(3114),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3114),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3114),
    [sym_preproc_directive] = ACTIONS(3114),
    [anon_sym_LPAREN2] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3116),
    [anon_sym_TILDE] = ACTIONS(3116),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_PLUS] = ACTIONS(3114),
    [anon_sym_STAR] = ACTIONS(3116),
    [anon_sym_AMP_AMP] = ACTIONS(3116),
    [anon_sym_AMP] = ACTIONS(3114),
    [anon_sym_SEMI] = ACTIONS(3116),
    [anon_sym___extension__] = ACTIONS(3114),
    [anon_sym_typedef] = ACTIONS(3114),
    [anon_sym_virtual] = ACTIONS(3114),
    [anon_sym_extern] = ACTIONS(3114),
    [anon_sym___attribute__] = ACTIONS(3114),
    [anon_sym___attribute] = ACTIONS(3114),
    [anon_sym_COLON_COLON] = ACTIONS(3116),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3116),
    [anon_sym___declspec] = ACTIONS(3114),
    [anon_sym___based] = ACTIONS(3114),
    [anon_sym___cdecl] = ACTIONS(3114),
    [anon_sym___clrcall] = ACTIONS(3114),
    [anon_sym___stdcall] = ACTIONS(3114),
    [anon_sym___fastcall] = ACTIONS(3114),
    [anon_sym___thiscall] = ACTIONS(3114),
    [anon_sym___vectorcall] = ACTIONS(3114),
    [anon_sym_LBRACE] = ACTIONS(3116),
    [anon_sym_signed] = ACTIONS(3114),
    [anon_sym_unsigned] = ACTIONS(3114),
    [anon_sym_long] = ACTIONS(3114),
    [anon_sym_short] = ACTIONS(3114),
    [anon_sym_LBRACK] = ACTIONS(3114),
    [anon_sym_static] = ACTIONS(3114),
    [anon_sym_register] = ACTIONS(3114),
    [anon_sym_inline] = ACTIONS(3114),
    [anon_sym___inline] = ACTIONS(3114),
    [anon_sym___inline__] = ACTIONS(3114),
    [anon_sym___forceinline] = ACTIONS(3114),
    [anon_sym_thread_local] = ACTIONS(3114),
    [anon_sym___thread] = ACTIONS(3114),
    [anon_sym_const] = ACTIONS(3114),
    [anon_sym_constexpr] = ACTIONS(3114),
    [anon_sym_volatile] = ACTIONS(3114),
    [anon_sym_restrict] = ACTIONS(3114),
    [anon_sym___restrict__] = ACTIONS(3114),
    [anon_sym__Atomic] = ACTIONS(3114),
    [anon_sym__Noreturn] = ACTIONS(3114),
    [anon_sym_noreturn] = ACTIONS(3114),
    [anon_sym__Nonnull] = ACTIONS(3114),
    [anon_sym_mutable] = ACTIONS(3114),
    [anon_sym_constinit] = ACTIONS(3114),
    [anon_sym_consteval] = ACTIONS(3114),
    [anon_sym_alignas] = ACTIONS(3114),
    [anon_sym__Alignas] = ACTIONS(3114),
    [sym_primitive_type] = ACTIONS(3114),
    [anon_sym_enum] = ACTIONS(3114),
    [anon_sym_class] = ACTIONS(3114),
    [anon_sym_struct] = ACTIONS(3114),
    [anon_sym_union] = ACTIONS(3114),
    [anon_sym_if] = ACTIONS(3114),
    [anon_sym_switch] = ACTIONS(3114),
    [anon_sym_case] = ACTIONS(3114),
    [anon_sym_default] = ACTIONS(3114),
    [anon_sym_while] = ACTIONS(3114),
    [anon_sym_do] = ACTIONS(3114),
    [anon_sym_for] = ACTIONS(3114),
    [anon_sym_return] = ACTIONS(3114),
    [anon_sym_break] = ACTIONS(3114),
    [anon_sym_continue] = ACTIONS(3114),
    [anon_sym_goto] = ACTIONS(3114),
    [anon_sym___try] = ACTIONS(3114),
    [anon_sym___leave] = ACTIONS(3114),
    [anon_sym_not] = ACTIONS(3114),
    [anon_sym_compl] = ACTIONS(3114),
    [anon_sym_DASH_DASH] = ACTIONS(3116),
    [anon_sym_PLUS_PLUS] = ACTIONS(3116),
    [anon_sym_sizeof] = ACTIONS(3114),
    [anon_sym___alignof__] = ACTIONS(3114),
    [anon_sym___alignof] = ACTIONS(3114),
    [anon_sym__alignof] = ACTIONS(3114),
    [anon_sym_alignof] = ACTIONS(3114),
    [anon_sym__Alignof] = ACTIONS(3114),
    [anon_sym_offsetof] = ACTIONS(3114),
    [anon_sym__Generic] = ACTIONS(3114),
    [anon_sym_asm] = ACTIONS(3114),
    [anon_sym___asm__] = ACTIONS(3114),
    [anon_sym___asm] = ACTIONS(3114),
    [sym_number_literal] = ACTIONS(3116),
    [anon_sym_L_SQUOTE] = ACTIONS(3116),
    [anon_sym_u_SQUOTE] = ACTIONS(3116),
    [anon_sym_U_SQUOTE] = ACTIONS(3116),
    [anon_sym_u8_SQUOTE] = ACTIONS(3116),
    [anon_sym_SQUOTE] = ACTIONS(3116),
    [anon_sym_L_DQUOTE] = ACTIONS(3116),
    [anon_sym_u_DQUOTE] = ACTIONS(3116),
    [anon_sym_U_DQUOTE] = ACTIONS(3116),
    [anon_sym_u8_DQUOTE] = ACTIONS(3116),
    [anon_sym_DQUOTE] = ACTIONS(3116),
    [sym_true] = ACTIONS(3114),
    [sym_false] = ACTIONS(3114),
    [anon_sym_NULL] = ACTIONS(3114),
    [anon_sym_nullptr] = ACTIONS(3114),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3114),
    [anon_sym_decltype] = ACTIONS(3114),
    [anon_sym_explicit] = ACTIONS(3114),
    [anon_sym_typename] = ACTIONS(3114),
    [anon_sym_template] = ACTIONS(3114),
    [anon_sym_operator] = ACTIONS(3114),
    [anon_sym_try] = ACTIONS(3114),
    [anon_sym_delete] = ACTIONS(3114),
    [anon_sym_throw] = ACTIONS(3114),
    [anon_sym_namespace] = ACTIONS(3114),
    [anon_sym_using] = ACTIONS(3114),
    [anon_sym_static_assert] = ACTIONS(3114),
    [anon_sym_concept] = ACTIONS(3114),
    [anon_sym_co_return] = ACTIONS(3114),
    [anon_sym_co_yield] = ACTIONS(3114),
    [anon_sym_R_DQUOTE] = ACTIONS(3116),
    [anon_sym_LR_DQUOTE] = ACTIONS(3116),
    [anon_sym_uR_DQUOTE] = ACTIONS(3116),
    [anon_sym_UR_DQUOTE] = ACTIONS(3116),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3116),
    [anon_sym_co_await] = ACTIONS(3114),
    [anon_sym_new] = ACTIONS(3114),
    [anon_sym_requires] = ACTIONS(3114),
    [sym_this] = ACTIONS(3114),
  },
  [350] = {
    [sym_type_qualifier] = STATE(3798),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4559),
    [sym_sized_type_specifier] = STATE(2651),
    [sym_enum_specifier] = STATE(2651),
    [sym_struct_specifier] = STATE(2651),
    [sym_union_specifier] = STATE(2651),
    [sym_expression] = STATE(4363),
    [sym__string] = STATE(4637),
    [sym_conditional_expression] = STATE(4735),
    [sym_assignment_expression] = STATE(4735),
    [sym_pointer_expression] = STATE(3573),
    [sym_unary_expression] = STATE(4735),
    [sym_binary_expression] = STATE(4735),
    [sym_update_expression] = STATE(4735),
    [sym_cast_expression] = STATE(4735),
    [sym_type_descriptor] = STATE(6855),
    [sym_sizeof_expression] = STATE(4735),
    [sym_alignof_expression] = STATE(4735),
    [sym_offsetof_expression] = STATE(4735),
    [sym_generic_expression] = STATE(4735),
    [sym_subscript_expression] = STATE(3573),
    [sym_call_expression] = STATE(3573),
    [sym_gnu_asm_expression] = STATE(4735),
    [sym_extension_expression] = STATE(4735),
    [sym_field_expression] = STATE(3573),
    [sym_compound_literal_expression] = STATE(4735),
    [sym_parenthesized_expression] = STATE(3573),
    [sym_char_literal] = STATE(4637),
    [sym_concatenated_string] = STATE(4637),
    [sym_string_literal] = STATE(3662),
    [sym_null] = STATE(4735),
    [sym_placeholder_type_specifier] = STATE(2651),
    [sym_decltype_auto] = STATE(2637),
    [sym_decltype] = STATE(2563),
    [sym_class_specifier] = STATE(2651),
    [sym__class_name] = STATE(7513),
    [sym_dependent_type] = STATE(2651),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(4735),
    [sym_raw_string_literal] = STATE(3662),
    [sym_co_await_expression] = STATE(4735),
    [sym_new_expression] = STATE(4735),
    [sym_delete_expression] = STATE(4735),
    [sym_requires_clause] = STATE(4735),
    [sym_requires_expression] = STATE(4735),
    [sym_lambda_expression] = STATE(4735),
    [sym_lambda_capture_specifier] = STATE(5854),
    [sym_fold_expression] = STATE(4735),
    [sym_parameter_pack_expansion] = STATE(4735),
    [sym_type_parameter_pack_expansion] = STATE(7138),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5693),
    [sym_qualified_identifier] = STATE(3573),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym_user_defined_literal] = STATE(3573),
    [aux_sym__type_definition_type_repeat1] = STATE(3798),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4167),
    [sym_identifier] = ACTIONS(2854),
    [anon_sym_LPAREN2] = ACTIONS(2856),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(2864),
    [anon_sym_COLON_COLON] = ACTIONS(2866),
    [anon_sym_signed] = ACTIONS(2868),
    [anon_sym_unsigned] = ACTIONS(2868),
    [anon_sym_long] = ACTIONS(2868),
    [anon_sym_short] = ACTIONS(2868),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(2870),
    [anon_sym_enum] = ACTIONS(2872),
    [anon_sym_class] = ACTIONS(2874),
    [anon_sym_struct] = ACTIONS(2876),
    [anon_sym_union] = ACTIONS(2878),
    [anon_sym_not] = ACTIONS(2860),
    [anon_sym_compl] = ACTIONS(2860),
    [anon_sym_DASH_DASH] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(2880),
    [anon_sym_sizeof] = ACTIONS(2882),
    [anon_sym___alignof__] = ACTIONS(2884),
    [anon_sym___alignof] = ACTIONS(2884),
    [anon_sym__alignof] = ACTIONS(2884),
    [anon_sym_alignof] = ACTIONS(2884),
    [anon_sym__Alignof] = ACTIONS(2884),
    [anon_sym_offsetof] = ACTIONS(2886),
    [anon_sym__Generic] = ACTIONS(2888),
    [anon_sym_asm] = ACTIONS(2890),
    [anon_sym___asm__] = ACTIONS(2890),
    [anon_sym___asm] = ACTIONS(2890),
    [sym_number_literal] = ACTIONS(2892),
    [anon_sym_L_SQUOTE] = ACTIONS(2894),
    [anon_sym_u_SQUOTE] = ACTIONS(2894),
    [anon_sym_U_SQUOTE] = ACTIONS(2894),
    [anon_sym_u8_SQUOTE] = ACTIONS(2894),
    [anon_sym_SQUOTE] = ACTIONS(2894),
    [anon_sym_L_DQUOTE] = ACTIONS(2896),
    [anon_sym_u_DQUOTE] = ACTIONS(2896),
    [anon_sym_U_DQUOTE] = ACTIONS(2896),
    [anon_sym_u8_DQUOTE] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [anon_sym_NULL] = ACTIONS(2900),
    [anon_sym_nullptr] = ACTIONS(2900),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2902),
    [anon_sym_decltype] = ACTIONS(2904),
    [anon_sym_typename] = ACTIONS(2906),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_GT2] = ACTIONS(3118),
    [anon_sym_delete] = ACTIONS(2910),
    [anon_sym_R_DQUOTE] = ACTIONS(2912),
    [anon_sym_LR_DQUOTE] = ACTIONS(2912),
    [anon_sym_uR_DQUOTE] = ACTIONS(2912),
    [anon_sym_UR_DQUOTE] = ACTIONS(2912),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2912),
    [anon_sym_co_await] = ACTIONS(2914),
    [anon_sym_new] = ACTIONS(2916),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2898),
  },
  [351] = {
    [sym_type_qualifier] = STATE(3798),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4559),
    [sym_sized_type_specifier] = STATE(2651),
    [sym_enum_specifier] = STATE(2651),
    [sym_struct_specifier] = STATE(2651),
    [sym_union_specifier] = STATE(2651),
    [sym_expression] = STATE(4321),
    [sym__string] = STATE(4637),
    [sym_conditional_expression] = STATE(4735),
    [sym_assignment_expression] = STATE(4735),
    [sym_pointer_expression] = STATE(3573),
    [sym_unary_expression] = STATE(4735),
    [sym_binary_expression] = STATE(4735),
    [sym_update_expression] = STATE(4735),
    [sym_cast_expression] = STATE(4735),
    [sym_type_descriptor] = STATE(6860),
    [sym_sizeof_expression] = STATE(4735),
    [sym_alignof_expression] = STATE(4735),
    [sym_offsetof_expression] = STATE(4735),
    [sym_generic_expression] = STATE(4735),
    [sym_subscript_expression] = STATE(3573),
    [sym_call_expression] = STATE(3573),
    [sym_gnu_asm_expression] = STATE(4735),
    [sym_extension_expression] = STATE(4735),
    [sym_field_expression] = STATE(3573),
    [sym_compound_literal_expression] = STATE(4735),
    [sym_parenthesized_expression] = STATE(3573),
    [sym_char_literal] = STATE(4637),
    [sym_concatenated_string] = STATE(4637),
    [sym_string_literal] = STATE(3662),
    [sym_null] = STATE(4735),
    [sym_placeholder_type_specifier] = STATE(2651),
    [sym_decltype_auto] = STATE(2637),
    [sym_decltype] = STATE(2563),
    [sym_class_specifier] = STATE(2651),
    [sym__class_name] = STATE(7513),
    [sym_dependent_type] = STATE(2651),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(4735),
    [sym_raw_string_literal] = STATE(3662),
    [sym_co_await_expression] = STATE(4735),
    [sym_new_expression] = STATE(4735),
    [sym_delete_expression] = STATE(4735),
    [sym_requires_clause] = STATE(4735),
    [sym_requires_expression] = STATE(4735),
    [sym_lambda_expression] = STATE(4735),
    [sym_lambda_capture_specifier] = STATE(5854),
    [sym_fold_expression] = STATE(4735),
    [sym_parameter_pack_expansion] = STATE(4735),
    [sym_type_parameter_pack_expansion] = STATE(7167),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5693),
    [sym_qualified_identifier] = STATE(3573),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym_user_defined_literal] = STATE(3573),
    [aux_sym__type_definition_type_repeat1] = STATE(3798),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4167),
    [sym_identifier] = ACTIONS(2854),
    [anon_sym_LPAREN2] = ACTIONS(2856),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(2864),
    [anon_sym_COLON_COLON] = ACTIONS(2866),
    [anon_sym_signed] = ACTIONS(2868),
    [anon_sym_unsigned] = ACTIONS(2868),
    [anon_sym_long] = ACTIONS(2868),
    [anon_sym_short] = ACTIONS(2868),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(2870),
    [anon_sym_enum] = ACTIONS(2872),
    [anon_sym_class] = ACTIONS(2874),
    [anon_sym_struct] = ACTIONS(2876),
    [anon_sym_union] = ACTIONS(2878),
    [anon_sym_not] = ACTIONS(2860),
    [anon_sym_compl] = ACTIONS(2860),
    [anon_sym_DASH_DASH] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(2880),
    [anon_sym_sizeof] = ACTIONS(2882),
    [anon_sym___alignof__] = ACTIONS(2884),
    [anon_sym___alignof] = ACTIONS(2884),
    [anon_sym__alignof] = ACTIONS(2884),
    [anon_sym_alignof] = ACTIONS(2884),
    [anon_sym__Alignof] = ACTIONS(2884),
    [anon_sym_offsetof] = ACTIONS(2886),
    [anon_sym__Generic] = ACTIONS(2888),
    [anon_sym_asm] = ACTIONS(2890),
    [anon_sym___asm__] = ACTIONS(2890),
    [anon_sym___asm] = ACTIONS(2890),
    [sym_number_literal] = ACTIONS(2892),
    [anon_sym_L_SQUOTE] = ACTIONS(2894),
    [anon_sym_u_SQUOTE] = ACTIONS(2894),
    [anon_sym_U_SQUOTE] = ACTIONS(2894),
    [anon_sym_u8_SQUOTE] = ACTIONS(2894),
    [anon_sym_SQUOTE] = ACTIONS(2894),
    [anon_sym_L_DQUOTE] = ACTIONS(2896),
    [anon_sym_u_DQUOTE] = ACTIONS(2896),
    [anon_sym_U_DQUOTE] = ACTIONS(2896),
    [anon_sym_u8_DQUOTE] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [anon_sym_NULL] = ACTIONS(2900),
    [anon_sym_nullptr] = ACTIONS(2900),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2902),
    [anon_sym_decltype] = ACTIONS(2904),
    [anon_sym_typename] = ACTIONS(2906),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_GT2] = ACTIONS(3120),
    [anon_sym_delete] = ACTIONS(2910),
    [anon_sym_R_DQUOTE] = ACTIONS(2912),
    [anon_sym_LR_DQUOTE] = ACTIONS(2912),
    [anon_sym_uR_DQUOTE] = ACTIONS(2912),
    [anon_sym_UR_DQUOTE] = ACTIONS(2912),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2912),
    [anon_sym_co_await] = ACTIONS(2914),
    [anon_sym_new] = ACTIONS(2916),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2898),
  },
  [352] = {
    [sym_type_qualifier] = STATE(3798),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4559),
    [sym_sized_type_specifier] = STATE(2651),
    [sym_enum_specifier] = STATE(2651),
    [sym_struct_specifier] = STATE(2651),
    [sym_union_specifier] = STATE(2651),
    [sym_expression] = STATE(4322),
    [sym__string] = STATE(4637),
    [sym_conditional_expression] = STATE(4735),
    [sym_assignment_expression] = STATE(4735),
    [sym_pointer_expression] = STATE(3573),
    [sym_unary_expression] = STATE(4735),
    [sym_binary_expression] = STATE(4735),
    [sym_update_expression] = STATE(4735),
    [sym_cast_expression] = STATE(4735),
    [sym_type_descriptor] = STATE(6865),
    [sym_sizeof_expression] = STATE(4735),
    [sym_alignof_expression] = STATE(4735),
    [sym_offsetof_expression] = STATE(4735),
    [sym_generic_expression] = STATE(4735),
    [sym_subscript_expression] = STATE(3573),
    [sym_call_expression] = STATE(3573),
    [sym_gnu_asm_expression] = STATE(4735),
    [sym_extension_expression] = STATE(4735),
    [sym_field_expression] = STATE(3573),
    [sym_compound_literal_expression] = STATE(4735),
    [sym_parenthesized_expression] = STATE(3573),
    [sym_char_literal] = STATE(4637),
    [sym_concatenated_string] = STATE(4637),
    [sym_string_literal] = STATE(3662),
    [sym_null] = STATE(4735),
    [sym_placeholder_type_specifier] = STATE(2651),
    [sym_decltype_auto] = STATE(2637),
    [sym_decltype] = STATE(2563),
    [sym_class_specifier] = STATE(2651),
    [sym__class_name] = STATE(7513),
    [sym_dependent_type] = STATE(2651),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(4735),
    [sym_raw_string_literal] = STATE(3662),
    [sym_co_await_expression] = STATE(4735),
    [sym_new_expression] = STATE(4735),
    [sym_delete_expression] = STATE(4735),
    [sym_requires_clause] = STATE(4735),
    [sym_requires_expression] = STATE(4735),
    [sym_lambda_expression] = STATE(4735),
    [sym_lambda_capture_specifier] = STATE(5854),
    [sym_fold_expression] = STATE(4735),
    [sym_parameter_pack_expansion] = STATE(4735),
    [sym_type_parameter_pack_expansion] = STATE(7205),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5693),
    [sym_qualified_identifier] = STATE(3573),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym_user_defined_literal] = STATE(3573),
    [aux_sym__type_definition_type_repeat1] = STATE(3798),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4167),
    [sym_identifier] = ACTIONS(2854),
    [anon_sym_LPAREN2] = ACTIONS(2856),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(2864),
    [anon_sym_COLON_COLON] = ACTIONS(2866),
    [anon_sym_signed] = ACTIONS(2868),
    [anon_sym_unsigned] = ACTIONS(2868),
    [anon_sym_long] = ACTIONS(2868),
    [anon_sym_short] = ACTIONS(2868),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(2870),
    [anon_sym_enum] = ACTIONS(2872),
    [anon_sym_class] = ACTIONS(2874),
    [anon_sym_struct] = ACTIONS(2876),
    [anon_sym_union] = ACTIONS(2878),
    [anon_sym_not] = ACTIONS(2860),
    [anon_sym_compl] = ACTIONS(2860),
    [anon_sym_DASH_DASH] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(2880),
    [anon_sym_sizeof] = ACTIONS(2882),
    [anon_sym___alignof__] = ACTIONS(2884),
    [anon_sym___alignof] = ACTIONS(2884),
    [anon_sym__alignof] = ACTIONS(2884),
    [anon_sym_alignof] = ACTIONS(2884),
    [anon_sym__Alignof] = ACTIONS(2884),
    [anon_sym_offsetof] = ACTIONS(2886),
    [anon_sym__Generic] = ACTIONS(2888),
    [anon_sym_asm] = ACTIONS(2890),
    [anon_sym___asm__] = ACTIONS(2890),
    [anon_sym___asm] = ACTIONS(2890),
    [sym_number_literal] = ACTIONS(2892),
    [anon_sym_L_SQUOTE] = ACTIONS(2894),
    [anon_sym_u_SQUOTE] = ACTIONS(2894),
    [anon_sym_U_SQUOTE] = ACTIONS(2894),
    [anon_sym_u8_SQUOTE] = ACTIONS(2894),
    [anon_sym_SQUOTE] = ACTIONS(2894),
    [anon_sym_L_DQUOTE] = ACTIONS(2896),
    [anon_sym_u_DQUOTE] = ACTIONS(2896),
    [anon_sym_U_DQUOTE] = ACTIONS(2896),
    [anon_sym_u8_DQUOTE] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [anon_sym_NULL] = ACTIONS(2900),
    [anon_sym_nullptr] = ACTIONS(2900),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2902),
    [anon_sym_decltype] = ACTIONS(2904),
    [anon_sym_typename] = ACTIONS(2906),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_GT2] = ACTIONS(3122),
    [anon_sym_delete] = ACTIONS(2910),
    [anon_sym_R_DQUOTE] = ACTIONS(2912),
    [anon_sym_LR_DQUOTE] = ACTIONS(2912),
    [anon_sym_uR_DQUOTE] = ACTIONS(2912),
    [anon_sym_UR_DQUOTE] = ACTIONS(2912),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2912),
    [anon_sym_co_await] = ACTIONS(2914),
    [anon_sym_new] = ACTIONS(2916),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2898),
  },
  [353] = {
    [sym_type_qualifier] = STATE(3798),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4559),
    [sym_sized_type_specifier] = STATE(2651),
    [sym_enum_specifier] = STATE(2651),
    [sym_struct_specifier] = STATE(2651),
    [sym_union_specifier] = STATE(2651),
    [sym_expression] = STATE(4323),
    [sym__string] = STATE(4637),
    [sym_conditional_expression] = STATE(4735),
    [sym_assignment_expression] = STATE(4735),
    [sym_pointer_expression] = STATE(3573),
    [sym_unary_expression] = STATE(4735),
    [sym_binary_expression] = STATE(4735),
    [sym_update_expression] = STATE(4735),
    [sym_cast_expression] = STATE(4735),
    [sym_type_descriptor] = STATE(6870),
    [sym_sizeof_expression] = STATE(4735),
    [sym_alignof_expression] = STATE(4735),
    [sym_offsetof_expression] = STATE(4735),
    [sym_generic_expression] = STATE(4735),
    [sym_subscript_expression] = STATE(3573),
    [sym_call_expression] = STATE(3573),
    [sym_gnu_asm_expression] = STATE(4735),
    [sym_extension_expression] = STATE(4735),
    [sym_field_expression] = STATE(3573),
    [sym_compound_literal_expression] = STATE(4735),
    [sym_parenthesized_expression] = STATE(3573),
    [sym_char_literal] = STATE(4637),
    [sym_concatenated_string] = STATE(4637),
    [sym_string_literal] = STATE(3662),
    [sym_null] = STATE(4735),
    [sym_placeholder_type_specifier] = STATE(2651),
    [sym_decltype_auto] = STATE(2637),
    [sym_decltype] = STATE(2563),
    [sym_class_specifier] = STATE(2651),
    [sym__class_name] = STATE(7513),
    [sym_dependent_type] = STATE(2651),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(4735),
    [sym_raw_string_literal] = STATE(3662),
    [sym_co_await_expression] = STATE(4735),
    [sym_new_expression] = STATE(4735),
    [sym_delete_expression] = STATE(4735),
    [sym_requires_clause] = STATE(4735),
    [sym_requires_expression] = STATE(4735),
    [sym_lambda_expression] = STATE(4735),
    [sym_lambda_capture_specifier] = STATE(5854),
    [sym_fold_expression] = STATE(4735),
    [sym_parameter_pack_expansion] = STATE(4735),
    [sym_type_parameter_pack_expansion] = STATE(7237),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5693),
    [sym_qualified_identifier] = STATE(3573),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym_user_defined_literal] = STATE(3573),
    [aux_sym__type_definition_type_repeat1] = STATE(3798),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4167),
    [sym_identifier] = ACTIONS(2854),
    [anon_sym_LPAREN2] = ACTIONS(2856),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(2864),
    [anon_sym_COLON_COLON] = ACTIONS(2866),
    [anon_sym_signed] = ACTIONS(2868),
    [anon_sym_unsigned] = ACTIONS(2868),
    [anon_sym_long] = ACTIONS(2868),
    [anon_sym_short] = ACTIONS(2868),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(2870),
    [anon_sym_enum] = ACTIONS(2872),
    [anon_sym_class] = ACTIONS(2874),
    [anon_sym_struct] = ACTIONS(2876),
    [anon_sym_union] = ACTIONS(2878),
    [anon_sym_not] = ACTIONS(2860),
    [anon_sym_compl] = ACTIONS(2860),
    [anon_sym_DASH_DASH] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(2880),
    [anon_sym_sizeof] = ACTIONS(2882),
    [anon_sym___alignof__] = ACTIONS(2884),
    [anon_sym___alignof] = ACTIONS(2884),
    [anon_sym__alignof] = ACTIONS(2884),
    [anon_sym_alignof] = ACTIONS(2884),
    [anon_sym__Alignof] = ACTIONS(2884),
    [anon_sym_offsetof] = ACTIONS(2886),
    [anon_sym__Generic] = ACTIONS(2888),
    [anon_sym_asm] = ACTIONS(2890),
    [anon_sym___asm__] = ACTIONS(2890),
    [anon_sym___asm] = ACTIONS(2890),
    [sym_number_literal] = ACTIONS(2892),
    [anon_sym_L_SQUOTE] = ACTIONS(2894),
    [anon_sym_u_SQUOTE] = ACTIONS(2894),
    [anon_sym_U_SQUOTE] = ACTIONS(2894),
    [anon_sym_u8_SQUOTE] = ACTIONS(2894),
    [anon_sym_SQUOTE] = ACTIONS(2894),
    [anon_sym_L_DQUOTE] = ACTIONS(2896),
    [anon_sym_u_DQUOTE] = ACTIONS(2896),
    [anon_sym_U_DQUOTE] = ACTIONS(2896),
    [anon_sym_u8_DQUOTE] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [anon_sym_NULL] = ACTIONS(2900),
    [anon_sym_nullptr] = ACTIONS(2900),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2902),
    [anon_sym_decltype] = ACTIONS(2904),
    [anon_sym_typename] = ACTIONS(2906),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_GT2] = ACTIONS(3124),
    [anon_sym_delete] = ACTIONS(2910),
    [anon_sym_R_DQUOTE] = ACTIONS(2912),
    [anon_sym_LR_DQUOTE] = ACTIONS(2912),
    [anon_sym_uR_DQUOTE] = ACTIONS(2912),
    [anon_sym_UR_DQUOTE] = ACTIONS(2912),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2912),
    [anon_sym_co_await] = ACTIONS(2914),
    [anon_sym_new] = ACTIONS(2916),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2898),
  },
  [354] = {
    [sym_type_qualifier] = STATE(3798),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4559),
    [sym_sized_type_specifier] = STATE(2651),
    [sym_enum_specifier] = STATE(2651),
    [sym_struct_specifier] = STATE(2651),
    [sym_union_specifier] = STATE(2651),
    [sym_expression] = STATE(4324),
    [sym__string] = STATE(4637),
    [sym_conditional_expression] = STATE(4735),
    [sym_assignment_expression] = STATE(4735),
    [sym_pointer_expression] = STATE(3573),
    [sym_unary_expression] = STATE(4735),
    [sym_binary_expression] = STATE(4735),
    [sym_update_expression] = STATE(4735),
    [sym_cast_expression] = STATE(4735),
    [sym_type_descriptor] = STATE(6873),
    [sym_sizeof_expression] = STATE(4735),
    [sym_alignof_expression] = STATE(4735),
    [sym_offsetof_expression] = STATE(4735),
    [sym_generic_expression] = STATE(4735),
    [sym_subscript_expression] = STATE(3573),
    [sym_call_expression] = STATE(3573),
    [sym_gnu_asm_expression] = STATE(4735),
    [sym_extension_expression] = STATE(4735),
    [sym_field_expression] = STATE(3573),
    [sym_compound_literal_expression] = STATE(4735),
    [sym_parenthesized_expression] = STATE(3573),
    [sym_char_literal] = STATE(4637),
    [sym_concatenated_string] = STATE(4637),
    [sym_string_literal] = STATE(3662),
    [sym_null] = STATE(4735),
    [sym_placeholder_type_specifier] = STATE(2651),
    [sym_decltype_auto] = STATE(2637),
    [sym_decltype] = STATE(2563),
    [sym_class_specifier] = STATE(2651),
    [sym__class_name] = STATE(7513),
    [sym_dependent_type] = STATE(2651),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(4735),
    [sym_raw_string_literal] = STATE(3662),
    [sym_co_await_expression] = STATE(4735),
    [sym_new_expression] = STATE(4735),
    [sym_delete_expression] = STATE(4735),
    [sym_requires_clause] = STATE(4735),
    [sym_requires_expression] = STATE(4735),
    [sym_lambda_expression] = STATE(4735),
    [sym_lambda_capture_specifier] = STATE(5854),
    [sym_fold_expression] = STATE(4735),
    [sym_parameter_pack_expansion] = STATE(4735),
    [sym_type_parameter_pack_expansion] = STATE(7268),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5693),
    [sym_qualified_identifier] = STATE(3573),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym_user_defined_literal] = STATE(3573),
    [aux_sym__type_definition_type_repeat1] = STATE(3798),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4167),
    [sym_identifier] = ACTIONS(2854),
    [anon_sym_LPAREN2] = ACTIONS(2856),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(2864),
    [anon_sym_COLON_COLON] = ACTIONS(2866),
    [anon_sym_signed] = ACTIONS(2868),
    [anon_sym_unsigned] = ACTIONS(2868),
    [anon_sym_long] = ACTIONS(2868),
    [anon_sym_short] = ACTIONS(2868),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(2870),
    [anon_sym_enum] = ACTIONS(2872),
    [anon_sym_class] = ACTIONS(2874),
    [anon_sym_struct] = ACTIONS(2876),
    [anon_sym_union] = ACTIONS(2878),
    [anon_sym_not] = ACTIONS(2860),
    [anon_sym_compl] = ACTIONS(2860),
    [anon_sym_DASH_DASH] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(2880),
    [anon_sym_sizeof] = ACTIONS(2882),
    [anon_sym___alignof__] = ACTIONS(2884),
    [anon_sym___alignof] = ACTIONS(2884),
    [anon_sym__alignof] = ACTIONS(2884),
    [anon_sym_alignof] = ACTIONS(2884),
    [anon_sym__Alignof] = ACTIONS(2884),
    [anon_sym_offsetof] = ACTIONS(2886),
    [anon_sym__Generic] = ACTIONS(2888),
    [anon_sym_asm] = ACTIONS(2890),
    [anon_sym___asm__] = ACTIONS(2890),
    [anon_sym___asm] = ACTIONS(2890),
    [sym_number_literal] = ACTIONS(2892),
    [anon_sym_L_SQUOTE] = ACTIONS(2894),
    [anon_sym_u_SQUOTE] = ACTIONS(2894),
    [anon_sym_U_SQUOTE] = ACTIONS(2894),
    [anon_sym_u8_SQUOTE] = ACTIONS(2894),
    [anon_sym_SQUOTE] = ACTIONS(2894),
    [anon_sym_L_DQUOTE] = ACTIONS(2896),
    [anon_sym_u_DQUOTE] = ACTIONS(2896),
    [anon_sym_U_DQUOTE] = ACTIONS(2896),
    [anon_sym_u8_DQUOTE] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [anon_sym_NULL] = ACTIONS(2900),
    [anon_sym_nullptr] = ACTIONS(2900),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2902),
    [anon_sym_decltype] = ACTIONS(2904),
    [anon_sym_typename] = ACTIONS(2906),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_GT2] = ACTIONS(3126),
    [anon_sym_delete] = ACTIONS(2910),
    [anon_sym_R_DQUOTE] = ACTIONS(2912),
    [anon_sym_LR_DQUOTE] = ACTIONS(2912),
    [anon_sym_uR_DQUOTE] = ACTIONS(2912),
    [anon_sym_UR_DQUOTE] = ACTIONS(2912),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2912),
    [anon_sym_co_await] = ACTIONS(2914),
    [anon_sym_new] = ACTIONS(2916),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2898),
  },
  [355] = {
    [sym_identifier] = ACTIONS(3128),
    [aux_sym_preproc_include_token1] = ACTIONS(3128),
    [aux_sym_preproc_def_token1] = ACTIONS(3128),
    [aux_sym_preproc_if_token1] = ACTIONS(3128),
    [aux_sym_preproc_if_token2] = ACTIONS(3128),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3128),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3128),
    [aux_sym_preproc_else_token1] = ACTIONS(3128),
    [aux_sym_preproc_elif_token1] = ACTIONS(3128),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3128),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3128),
    [sym_preproc_directive] = ACTIONS(3128),
    [anon_sym_LPAREN2] = ACTIONS(3130),
    [anon_sym_BANG] = ACTIONS(3130),
    [anon_sym_TILDE] = ACTIONS(3130),
    [anon_sym_DASH] = ACTIONS(3128),
    [anon_sym_PLUS] = ACTIONS(3128),
    [anon_sym_STAR] = ACTIONS(3130),
    [anon_sym_AMP_AMP] = ACTIONS(3130),
    [anon_sym_AMP] = ACTIONS(3128),
    [anon_sym_SEMI] = ACTIONS(3130),
    [anon_sym___extension__] = ACTIONS(3128),
    [anon_sym_typedef] = ACTIONS(3128),
    [anon_sym_virtual] = ACTIONS(3128),
    [anon_sym_extern] = ACTIONS(3128),
    [anon_sym___attribute__] = ACTIONS(3128),
    [anon_sym___attribute] = ACTIONS(3128),
    [anon_sym_COLON_COLON] = ACTIONS(3130),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3130),
    [anon_sym___declspec] = ACTIONS(3128),
    [anon_sym___based] = ACTIONS(3128),
    [anon_sym___cdecl] = ACTIONS(3128),
    [anon_sym___clrcall] = ACTIONS(3128),
    [anon_sym___stdcall] = ACTIONS(3128),
    [anon_sym___fastcall] = ACTIONS(3128),
    [anon_sym___thiscall] = ACTIONS(3128),
    [anon_sym___vectorcall] = ACTIONS(3128),
    [anon_sym_LBRACE] = ACTIONS(3130),
    [anon_sym_signed] = ACTIONS(3128),
    [anon_sym_unsigned] = ACTIONS(3128),
    [anon_sym_long] = ACTIONS(3128),
    [anon_sym_short] = ACTIONS(3128),
    [anon_sym_LBRACK] = ACTIONS(3128),
    [anon_sym_static] = ACTIONS(3128),
    [anon_sym_register] = ACTIONS(3128),
    [anon_sym_inline] = ACTIONS(3128),
    [anon_sym___inline] = ACTIONS(3128),
    [anon_sym___inline__] = ACTIONS(3128),
    [anon_sym___forceinline] = ACTIONS(3128),
    [anon_sym_thread_local] = ACTIONS(3128),
    [anon_sym___thread] = ACTIONS(3128),
    [anon_sym_const] = ACTIONS(3128),
    [anon_sym_constexpr] = ACTIONS(3128),
    [anon_sym_volatile] = ACTIONS(3128),
    [anon_sym_restrict] = ACTIONS(3128),
    [anon_sym___restrict__] = ACTIONS(3128),
    [anon_sym__Atomic] = ACTIONS(3128),
    [anon_sym__Noreturn] = ACTIONS(3128),
    [anon_sym_noreturn] = ACTIONS(3128),
    [anon_sym__Nonnull] = ACTIONS(3128),
    [anon_sym_mutable] = ACTIONS(3128),
    [anon_sym_constinit] = ACTIONS(3128),
    [anon_sym_consteval] = ACTIONS(3128),
    [anon_sym_alignas] = ACTIONS(3128),
    [anon_sym__Alignas] = ACTIONS(3128),
    [sym_primitive_type] = ACTIONS(3128),
    [anon_sym_enum] = ACTIONS(3128),
    [anon_sym_class] = ACTIONS(3128),
    [anon_sym_struct] = ACTIONS(3128),
    [anon_sym_union] = ACTIONS(3128),
    [anon_sym_if] = ACTIONS(3128),
    [anon_sym_switch] = ACTIONS(3128),
    [anon_sym_case] = ACTIONS(3128),
    [anon_sym_default] = ACTIONS(3128),
    [anon_sym_while] = ACTIONS(3128),
    [anon_sym_do] = ACTIONS(3128),
    [anon_sym_for] = ACTIONS(3128),
    [anon_sym_return] = ACTIONS(3128),
    [anon_sym_break] = ACTIONS(3128),
    [anon_sym_continue] = ACTIONS(3128),
    [anon_sym_goto] = ACTIONS(3128),
    [anon_sym___try] = ACTIONS(3128),
    [anon_sym___leave] = ACTIONS(3128),
    [anon_sym_not] = ACTIONS(3128),
    [anon_sym_compl] = ACTIONS(3128),
    [anon_sym_DASH_DASH] = ACTIONS(3130),
    [anon_sym_PLUS_PLUS] = ACTIONS(3130),
    [anon_sym_sizeof] = ACTIONS(3128),
    [anon_sym___alignof__] = ACTIONS(3128),
    [anon_sym___alignof] = ACTIONS(3128),
    [anon_sym__alignof] = ACTIONS(3128),
    [anon_sym_alignof] = ACTIONS(3128),
    [anon_sym__Alignof] = ACTIONS(3128),
    [anon_sym_offsetof] = ACTIONS(3128),
    [anon_sym__Generic] = ACTIONS(3128),
    [anon_sym_asm] = ACTIONS(3128),
    [anon_sym___asm__] = ACTIONS(3128),
    [anon_sym___asm] = ACTIONS(3128),
    [sym_number_literal] = ACTIONS(3130),
    [anon_sym_L_SQUOTE] = ACTIONS(3130),
    [anon_sym_u_SQUOTE] = ACTIONS(3130),
    [anon_sym_U_SQUOTE] = ACTIONS(3130),
    [anon_sym_u8_SQUOTE] = ACTIONS(3130),
    [anon_sym_SQUOTE] = ACTIONS(3130),
    [anon_sym_L_DQUOTE] = ACTIONS(3130),
    [anon_sym_u_DQUOTE] = ACTIONS(3130),
    [anon_sym_U_DQUOTE] = ACTIONS(3130),
    [anon_sym_u8_DQUOTE] = ACTIONS(3130),
    [anon_sym_DQUOTE] = ACTIONS(3130),
    [sym_true] = ACTIONS(3128),
    [sym_false] = ACTIONS(3128),
    [anon_sym_NULL] = ACTIONS(3128),
    [anon_sym_nullptr] = ACTIONS(3128),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3128),
    [anon_sym_decltype] = ACTIONS(3128),
    [anon_sym_explicit] = ACTIONS(3128),
    [anon_sym_typename] = ACTIONS(3128),
    [anon_sym_template] = ACTIONS(3128),
    [anon_sym_operator] = ACTIONS(3128),
    [anon_sym_try] = ACTIONS(3128),
    [anon_sym_delete] = ACTIONS(3128),
    [anon_sym_throw] = ACTIONS(3128),
    [anon_sym_namespace] = ACTIONS(3128),
    [anon_sym_using] = ACTIONS(3128),
    [anon_sym_static_assert] = ACTIONS(3128),
    [anon_sym_concept] = ACTIONS(3128),
    [anon_sym_co_return] = ACTIONS(3128),
    [anon_sym_co_yield] = ACTIONS(3128),
    [anon_sym_R_DQUOTE] = ACTIONS(3130),
    [anon_sym_LR_DQUOTE] = ACTIONS(3130),
    [anon_sym_uR_DQUOTE] = ACTIONS(3130),
    [anon_sym_UR_DQUOTE] = ACTIONS(3130),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3130),
    [anon_sym_co_await] = ACTIONS(3128),
    [anon_sym_new] = ACTIONS(3128),
    [anon_sym_requires] = ACTIONS(3128),
    [sym_this] = ACTIONS(3128),
  },
  [356] = {
    [sym_type_qualifier] = STATE(3798),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4559),
    [sym_sized_type_specifier] = STATE(2651),
    [sym_enum_specifier] = STATE(2651),
    [sym_struct_specifier] = STATE(2651),
    [sym_union_specifier] = STATE(2651),
    [sym_expression] = STATE(4325),
    [sym__string] = STATE(4637),
    [sym_conditional_expression] = STATE(4735),
    [sym_assignment_expression] = STATE(4735),
    [sym_pointer_expression] = STATE(3573),
    [sym_unary_expression] = STATE(4735),
    [sym_binary_expression] = STATE(4735),
    [sym_update_expression] = STATE(4735),
    [sym_cast_expression] = STATE(4735),
    [sym_type_descriptor] = STATE(6880),
    [sym_sizeof_expression] = STATE(4735),
    [sym_alignof_expression] = STATE(4735),
    [sym_offsetof_expression] = STATE(4735),
    [sym_generic_expression] = STATE(4735),
    [sym_subscript_expression] = STATE(3573),
    [sym_call_expression] = STATE(3573),
    [sym_gnu_asm_expression] = STATE(4735),
    [sym_extension_expression] = STATE(4735),
    [sym_field_expression] = STATE(3573),
    [sym_compound_literal_expression] = STATE(4735),
    [sym_parenthesized_expression] = STATE(3573),
    [sym_char_literal] = STATE(4637),
    [sym_concatenated_string] = STATE(4637),
    [sym_string_literal] = STATE(3662),
    [sym_null] = STATE(4735),
    [sym_placeholder_type_specifier] = STATE(2651),
    [sym_decltype_auto] = STATE(2637),
    [sym_decltype] = STATE(2563),
    [sym_class_specifier] = STATE(2651),
    [sym__class_name] = STATE(7513),
    [sym_dependent_type] = STATE(2651),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(4735),
    [sym_raw_string_literal] = STATE(3662),
    [sym_co_await_expression] = STATE(4735),
    [sym_new_expression] = STATE(4735),
    [sym_delete_expression] = STATE(4735),
    [sym_requires_clause] = STATE(4735),
    [sym_requires_expression] = STATE(4735),
    [sym_lambda_expression] = STATE(4735),
    [sym_lambda_capture_specifier] = STATE(5854),
    [sym_fold_expression] = STATE(4735),
    [sym_parameter_pack_expansion] = STATE(4735),
    [sym_type_parameter_pack_expansion] = STATE(7304),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5693),
    [sym_qualified_identifier] = STATE(3573),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym_user_defined_literal] = STATE(3573),
    [aux_sym__type_definition_type_repeat1] = STATE(3798),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4167),
    [sym_identifier] = ACTIONS(2854),
    [anon_sym_LPAREN2] = ACTIONS(2856),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(2864),
    [anon_sym_COLON_COLON] = ACTIONS(2866),
    [anon_sym_signed] = ACTIONS(2868),
    [anon_sym_unsigned] = ACTIONS(2868),
    [anon_sym_long] = ACTIONS(2868),
    [anon_sym_short] = ACTIONS(2868),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(2870),
    [anon_sym_enum] = ACTIONS(2872),
    [anon_sym_class] = ACTIONS(2874),
    [anon_sym_struct] = ACTIONS(2876),
    [anon_sym_union] = ACTIONS(2878),
    [anon_sym_not] = ACTIONS(2860),
    [anon_sym_compl] = ACTIONS(2860),
    [anon_sym_DASH_DASH] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(2880),
    [anon_sym_sizeof] = ACTIONS(2882),
    [anon_sym___alignof__] = ACTIONS(2884),
    [anon_sym___alignof] = ACTIONS(2884),
    [anon_sym__alignof] = ACTIONS(2884),
    [anon_sym_alignof] = ACTIONS(2884),
    [anon_sym__Alignof] = ACTIONS(2884),
    [anon_sym_offsetof] = ACTIONS(2886),
    [anon_sym__Generic] = ACTIONS(2888),
    [anon_sym_asm] = ACTIONS(2890),
    [anon_sym___asm__] = ACTIONS(2890),
    [anon_sym___asm] = ACTIONS(2890),
    [sym_number_literal] = ACTIONS(2892),
    [anon_sym_L_SQUOTE] = ACTIONS(2894),
    [anon_sym_u_SQUOTE] = ACTIONS(2894),
    [anon_sym_U_SQUOTE] = ACTIONS(2894),
    [anon_sym_u8_SQUOTE] = ACTIONS(2894),
    [anon_sym_SQUOTE] = ACTIONS(2894),
    [anon_sym_L_DQUOTE] = ACTIONS(2896),
    [anon_sym_u_DQUOTE] = ACTIONS(2896),
    [anon_sym_U_DQUOTE] = ACTIONS(2896),
    [anon_sym_u8_DQUOTE] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [anon_sym_NULL] = ACTIONS(2900),
    [anon_sym_nullptr] = ACTIONS(2900),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2902),
    [anon_sym_decltype] = ACTIONS(2904),
    [anon_sym_typename] = ACTIONS(2906),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_GT2] = ACTIONS(3132),
    [anon_sym_delete] = ACTIONS(2910),
    [anon_sym_R_DQUOTE] = ACTIONS(2912),
    [anon_sym_LR_DQUOTE] = ACTIONS(2912),
    [anon_sym_uR_DQUOTE] = ACTIONS(2912),
    [anon_sym_UR_DQUOTE] = ACTIONS(2912),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2912),
    [anon_sym_co_await] = ACTIONS(2914),
    [anon_sym_new] = ACTIONS(2916),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2898),
  },
  [357] = {
    [sym_type_qualifier] = STATE(3798),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4559),
    [sym_sized_type_specifier] = STATE(2651),
    [sym_enum_specifier] = STATE(2651),
    [sym_struct_specifier] = STATE(2651),
    [sym_union_specifier] = STATE(2651),
    [sym_expression] = STATE(4326),
    [sym__string] = STATE(4637),
    [sym_conditional_expression] = STATE(4735),
    [sym_assignment_expression] = STATE(4735),
    [sym_pointer_expression] = STATE(3573),
    [sym_unary_expression] = STATE(4735),
    [sym_binary_expression] = STATE(4735),
    [sym_update_expression] = STATE(4735),
    [sym_cast_expression] = STATE(4735),
    [sym_type_descriptor] = STATE(6883),
    [sym_sizeof_expression] = STATE(4735),
    [sym_alignof_expression] = STATE(4735),
    [sym_offsetof_expression] = STATE(4735),
    [sym_generic_expression] = STATE(4735),
    [sym_subscript_expression] = STATE(3573),
    [sym_call_expression] = STATE(3573),
    [sym_gnu_asm_expression] = STATE(4735),
    [sym_extension_expression] = STATE(4735),
    [sym_field_expression] = STATE(3573),
    [sym_compound_literal_expression] = STATE(4735),
    [sym_parenthesized_expression] = STATE(3573),
    [sym_char_literal] = STATE(4637),
    [sym_concatenated_string] = STATE(4637),
    [sym_string_literal] = STATE(3662),
    [sym_null] = STATE(4735),
    [sym_placeholder_type_specifier] = STATE(2651),
    [sym_decltype_auto] = STATE(2637),
    [sym_decltype] = STATE(2563),
    [sym_class_specifier] = STATE(2651),
    [sym__class_name] = STATE(7513),
    [sym_dependent_type] = STATE(2651),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(4735),
    [sym_raw_string_literal] = STATE(3662),
    [sym_co_await_expression] = STATE(4735),
    [sym_new_expression] = STATE(4735),
    [sym_delete_expression] = STATE(4735),
    [sym_requires_clause] = STATE(4735),
    [sym_requires_expression] = STATE(4735),
    [sym_lambda_expression] = STATE(4735),
    [sym_lambda_capture_specifier] = STATE(5854),
    [sym_fold_expression] = STATE(4735),
    [sym_parameter_pack_expansion] = STATE(4735),
    [sym_type_parameter_pack_expansion] = STATE(7342),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5693),
    [sym_qualified_identifier] = STATE(3573),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym_user_defined_literal] = STATE(3573),
    [aux_sym__type_definition_type_repeat1] = STATE(3798),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4167),
    [sym_identifier] = ACTIONS(2854),
    [anon_sym_LPAREN2] = ACTIONS(2856),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(2864),
    [anon_sym_COLON_COLON] = ACTIONS(2866),
    [anon_sym_signed] = ACTIONS(2868),
    [anon_sym_unsigned] = ACTIONS(2868),
    [anon_sym_long] = ACTIONS(2868),
    [anon_sym_short] = ACTIONS(2868),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(2870),
    [anon_sym_enum] = ACTIONS(2872),
    [anon_sym_class] = ACTIONS(2874),
    [anon_sym_struct] = ACTIONS(2876),
    [anon_sym_union] = ACTIONS(2878),
    [anon_sym_not] = ACTIONS(2860),
    [anon_sym_compl] = ACTIONS(2860),
    [anon_sym_DASH_DASH] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(2880),
    [anon_sym_sizeof] = ACTIONS(2882),
    [anon_sym___alignof__] = ACTIONS(2884),
    [anon_sym___alignof] = ACTIONS(2884),
    [anon_sym__alignof] = ACTIONS(2884),
    [anon_sym_alignof] = ACTIONS(2884),
    [anon_sym__Alignof] = ACTIONS(2884),
    [anon_sym_offsetof] = ACTIONS(2886),
    [anon_sym__Generic] = ACTIONS(2888),
    [anon_sym_asm] = ACTIONS(2890),
    [anon_sym___asm__] = ACTIONS(2890),
    [anon_sym___asm] = ACTIONS(2890),
    [sym_number_literal] = ACTIONS(2892),
    [anon_sym_L_SQUOTE] = ACTIONS(2894),
    [anon_sym_u_SQUOTE] = ACTIONS(2894),
    [anon_sym_U_SQUOTE] = ACTIONS(2894),
    [anon_sym_u8_SQUOTE] = ACTIONS(2894),
    [anon_sym_SQUOTE] = ACTIONS(2894),
    [anon_sym_L_DQUOTE] = ACTIONS(2896),
    [anon_sym_u_DQUOTE] = ACTIONS(2896),
    [anon_sym_U_DQUOTE] = ACTIONS(2896),
    [anon_sym_u8_DQUOTE] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [anon_sym_NULL] = ACTIONS(2900),
    [anon_sym_nullptr] = ACTIONS(2900),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2902),
    [anon_sym_decltype] = ACTIONS(2904),
    [anon_sym_typename] = ACTIONS(2906),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_GT2] = ACTIONS(3134),
    [anon_sym_delete] = ACTIONS(2910),
    [anon_sym_R_DQUOTE] = ACTIONS(2912),
    [anon_sym_LR_DQUOTE] = ACTIONS(2912),
    [anon_sym_uR_DQUOTE] = ACTIONS(2912),
    [anon_sym_UR_DQUOTE] = ACTIONS(2912),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2912),
    [anon_sym_co_await] = ACTIONS(2914),
    [anon_sym_new] = ACTIONS(2916),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2898),
  },
  [358] = {
    [sym_catch_clause] = STATE(314),
    [aux_sym_constructor_try_statement_repeat1] = STATE(314),
    [sym_identifier] = ACTIONS(2490),
    [aux_sym_preproc_include_token1] = ACTIONS(2490),
    [aux_sym_preproc_def_token1] = ACTIONS(2490),
    [aux_sym_preproc_if_token1] = ACTIONS(2490),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2490),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2490),
    [sym_preproc_directive] = ACTIONS(2490),
    [anon_sym_LPAREN2] = ACTIONS(2492),
    [anon_sym_BANG] = ACTIONS(2492),
    [anon_sym_TILDE] = ACTIONS(2492),
    [anon_sym_DASH] = ACTIONS(2490),
    [anon_sym_PLUS] = ACTIONS(2490),
    [anon_sym_STAR] = ACTIONS(2492),
    [anon_sym_AMP_AMP] = ACTIONS(2492),
    [anon_sym_AMP] = ACTIONS(2490),
    [anon_sym_SEMI] = ACTIONS(2492),
    [anon_sym___extension__] = ACTIONS(2490),
    [anon_sym_typedef] = ACTIONS(2490),
    [anon_sym_virtual] = ACTIONS(2490),
    [anon_sym_extern] = ACTIONS(2490),
    [anon_sym___attribute__] = ACTIONS(2490),
    [anon_sym___attribute] = ACTIONS(2490),
    [anon_sym_COLON_COLON] = ACTIONS(2492),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2492),
    [anon_sym___declspec] = ACTIONS(2490),
    [anon_sym___based] = ACTIONS(2490),
    [anon_sym___cdecl] = ACTIONS(2490),
    [anon_sym___clrcall] = ACTIONS(2490),
    [anon_sym___stdcall] = ACTIONS(2490),
    [anon_sym___fastcall] = ACTIONS(2490),
    [anon_sym___thiscall] = ACTIONS(2490),
    [anon_sym___vectorcall] = ACTIONS(2490),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_RBRACE] = ACTIONS(2492),
    [anon_sym_signed] = ACTIONS(2490),
    [anon_sym_unsigned] = ACTIONS(2490),
    [anon_sym_long] = ACTIONS(2490),
    [anon_sym_short] = ACTIONS(2490),
    [anon_sym_LBRACK] = ACTIONS(2490),
    [anon_sym_static] = ACTIONS(2490),
    [anon_sym_register] = ACTIONS(2490),
    [anon_sym_inline] = ACTIONS(2490),
    [anon_sym___inline] = ACTIONS(2490),
    [anon_sym___inline__] = ACTIONS(2490),
    [anon_sym___forceinline] = ACTIONS(2490),
    [anon_sym_thread_local] = ACTIONS(2490),
    [anon_sym___thread] = ACTIONS(2490),
    [anon_sym_const] = ACTIONS(2490),
    [anon_sym_constexpr] = ACTIONS(2490),
    [anon_sym_volatile] = ACTIONS(2490),
    [anon_sym_restrict] = ACTIONS(2490),
    [anon_sym___restrict__] = ACTIONS(2490),
    [anon_sym__Atomic] = ACTIONS(2490),
    [anon_sym__Noreturn] = ACTIONS(2490),
    [anon_sym_noreturn] = ACTIONS(2490),
    [anon_sym__Nonnull] = ACTIONS(2490),
    [anon_sym_mutable] = ACTIONS(2490),
    [anon_sym_constinit] = ACTIONS(2490),
    [anon_sym_consteval] = ACTIONS(2490),
    [anon_sym_alignas] = ACTIONS(2490),
    [anon_sym__Alignas] = ACTIONS(2490),
    [sym_primitive_type] = ACTIONS(2490),
    [anon_sym_enum] = ACTIONS(2490),
    [anon_sym_class] = ACTIONS(2490),
    [anon_sym_struct] = ACTIONS(2490),
    [anon_sym_union] = ACTIONS(2490),
    [anon_sym_if] = ACTIONS(2490),
    [anon_sym_else] = ACTIONS(2490),
    [anon_sym_switch] = ACTIONS(2490),
    [anon_sym_case] = ACTIONS(2490),
    [anon_sym_default] = ACTIONS(2490),
    [anon_sym_while] = ACTIONS(2490),
    [anon_sym_do] = ACTIONS(2490),
    [anon_sym_for] = ACTIONS(2490),
    [anon_sym_return] = ACTIONS(2490),
    [anon_sym_break] = ACTIONS(2490),
    [anon_sym_continue] = ACTIONS(2490),
    [anon_sym_goto] = ACTIONS(2490),
    [anon_sym___try] = ACTIONS(2490),
    [anon_sym___leave] = ACTIONS(2490),
    [anon_sym_not] = ACTIONS(2490),
    [anon_sym_compl] = ACTIONS(2490),
    [anon_sym_DASH_DASH] = ACTIONS(2492),
    [anon_sym_PLUS_PLUS] = ACTIONS(2492),
    [anon_sym_sizeof] = ACTIONS(2490),
    [anon_sym___alignof__] = ACTIONS(2490),
    [anon_sym___alignof] = ACTIONS(2490),
    [anon_sym__alignof] = ACTIONS(2490),
    [anon_sym_alignof] = ACTIONS(2490),
    [anon_sym__Alignof] = ACTIONS(2490),
    [anon_sym_offsetof] = ACTIONS(2490),
    [anon_sym__Generic] = ACTIONS(2490),
    [anon_sym_asm] = ACTIONS(2490),
    [anon_sym___asm__] = ACTIONS(2490),
    [anon_sym___asm] = ACTIONS(2490),
    [sym_number_literal] = ACTIONS(2492),
    [anon_sym_L_SQUOTE] = ACTIONS(2492),
    [anon_sym_u_SQUOTE] = ACTIONS(2492),
    [anon_sym_U_SQUOTE] = ACTIONS(2492),
    [anon_sym_u8_SQUOTE] = ACTIONS(2492),
    [anon_sym_SQUOTE] = ACTIONS(2492),
    [anon_sym_L_DQUOTE] = ACTIONS(2492),
    [anon_sym_u_DQUOTE] = ACTIONS(2492),
    [anon_sym_U_DQUOTE] = ACTIONS(2492),
    [anon_sym_u8_DQUOTE] = ACTIONS(2492),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [sym_true] = ACTIONS(2490),
    [sym_false] = ACTIONS(2490),
    [anon_sym_NULL] = ACTIONS(2490),
    [anon_sym_nullptr] = ACTIONS(2490),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2490),
    [anon_sym_decltype] = ACTIONS(2490),
    [anon_sym_explicit] = ACTIONS(2490),
    [anon_sym_typename] = ACTIONS(2490),
    [anon_sym_template] = ACTIONS(2490),
    [anon_sym_operator] = ACTIONS(2490),
    [anon_sym_try] = ACTIONS(2490),
    [anon_sym_delete] = ACTIONS(2490),
    [anon_sym_throw] = ACTIONS(2490),
    [anon_sym_namespace] = ACTIONS(2490),
    [anon_sym_using] = ACTIONS(2490),
    [anon_sym_static_assert] = ACTIONS(2490),
    [anon_sym_concept] = ACTIONS(2490),
    [anon_sym_co_return] = ACTIONS(2490),
    [anon_sym_co_yield] = ACTIONS(2490),
    [anon_sym_catch] = ACTIONS(3136),
    [anon_sym_R_DQUOTE] = ACTIONS(2492),
    [anon_sym_LR_DQUOTE] = ACTIONS(2492),
    [anon_sym_uR_DQUOTE] = ACTIONS(2492),
    [anon_sym_UR_DQUOTE] = ACTIONS(2492),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2492),
    [anon_sym_co_await] = ACTIONS(2490),
    [anon_sym_new] = ACTIONS(2490),
    [anon_sym_requires] = ACTIONS(2490),
    [sym_this] = ACTIONS(2490),
  },
  [359] = {
    [sym_identifier] = ACTIONS(3138),
    [aux_sym_preproc_include_token1] = ACTIONS(3138),
    [aux_sym_preproc_def_token1] = ACTIONS(3138),
    [aux_sym_preproc_if_token1] = ACTIONS(3138),
    [aux_sym_preproc_if_token2] = ACTIONS(3138),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3138),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3138),
    [aux_sym_preproc_else_token1] = ACTIONS(3138),
    [aux_sym_preproc_elif_token1] = ACTIONS(3138),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3138),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3138),
    [sym_preproc_directive] = ACTIONS(3138),
    [anon_sym_LPAREN2] = ACTIONS(3140),
    [anon_sym_BANG] = ACTIONS(3140),
    [anon_sym_TILDE] = ACTIONS(3140),
    [anon_sym_DASH] = ACTIONS(3138),
    [anon_sym_PLUS] = ACTIONS(3138),
    [anon_sym_STAR] = ACTIONS(3140),
    [anon_sym_AMP_AMP] = ACTIONS(3140),
    [anon_sym_AMP] = ACTIONS(3138),
    [anon_sym_SEMI] = ACTIONS(3140),
    [anon_sym___extension__] = ACTIONS(3138),
    [anon_sym_typedef] = ACTIONS(3138),
    [anon_sym_virtual] = ACTIONS(3138),
    [anon_sym_extern] = ACTIONS(3138),
    [anon_sym___attribute__] = ACTIONS(3138),
    [anon_sym___attribute] = ACTIONS(3138),
    [anon_sym_COLON_COLON] = ACTIONS(3140),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3140),
    [anon_sym___declspec] = ACTIONS(3138),
    [anon_sym___based] = ACTIONS(3138),
    [anon_sym___cdecl] = ACTIONS(3138),
    [anon_sym___clrcall] = ACTIONS(3138),
    [anon_sym___stdcall] = ACTIONS(3138),
    [anon_sym___fastcall] = ACTIONS(3138),
    [anon_sym___thiscall] = ACTIONS(3138),
    [anon_sym___vectorcall] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [anon_sym_signed] = ACTIONS(3138),
    [anon_sym_unsigned] = ACTIONS(3138),
    [anon_sym_long] = ACTIONS(3138),
    [anon_sym_short] = ACTIONS(3138),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_static] = ACTIONS(3138),
    [anon_sym_register] = ACTIONS(3138),
    [anon_sym_inline] = ACTIONS(3138),
    [anon_sym___inline] = ACTIONS(3138),
    [anon_sym___inline__] = ACTIONS(3138),
    [anon_sym___forceinline] = ACTIONS(3138),
    [anon_sym_thread_local] = ACTIONS(3138),
    [anon_sym___thread] = ACTIONS(3138),
    [anon_sym_const] = ACTIONS(3138),
    [anon_sym_constexpr] = ACTIONS(3138),
    [anon_sym_volatile] = ACTIONS(3138),
    [anon_sym_restrict] = ACTIONS(3138),
    [anon_sym___restrict__] = ACTIONS(3138),
    [anon_sym__Atomic] = ACTIONS(3138),
    [anon_sym__Noreturn] = ACTIONS(3138),
    [anon_sym_noreturn] = ACTIONS(3138),
    [anon_sym__Nonnull] = ACTIONS(3138),
    [anon_sym_mutable] = ACTIONS(3138),
    [anon_sym_constinit] = ACTIONS(3138),
    [anon_sym_consteval] = ACTIONS(3138),
    [anon_sym_alignas] = ACTIONS(3138),
    [anon_sym__Alignas] = ACTIONS(3138),
    [sym_primitive_type] = ACTIONS(3138),
    [anon_sym_enum] = ACTIONS(3138),
    [anon_sym_class] = ACTIONS(3138),
    [anon_sym_struct] = ACTIONS(3138),
    [anon_sym_union] = ACTIONS(3138),
    [anon_sym_if] = ACTIONS(3138),
    [anon_sym_switch] = ACTIONS(3138),
    [anon_sym_case] = ACTIONS(3138),
    [anon_sym_default] = ACTIONS(3138),
    [anon_sym_while] = ACTIONS(3138),
    [anon_sym_do] = ACTIONS(3138),
    [anon_sym_for] = ACTIONS(3138),
    [anon_sym_return] = ACTIONS(3138),
    [anon_sym_break] = ACTIONS(3138),
    [anon_sym_continue] = ACTIONS(3138),
    [anon_sym_goto] = ACTIONS(3138),
    [anon_sym___try] = ACTIONS(3138),
    [anon_sym___leave] = ACTIONS(3138),
    [anon_sym_not] = ACTIONS(3138),
    [anon_sym_compl] = ACTIONS(3138),
    [anon_sym_DASH_DASH] = ACTIONS(3140),
    [anon_sym_PLUS_PLUS] = ACTIONS(3140),
    [anon_sym_sizeof] = ACTIONS(3138),
    [anon_sym___alignof__] = ACTIONS(3138),
    [anon_sym___alignof] = ACTIONS(3138),
    [anon_sym__alignof] = ACTIONS(3138),
    [anon_sym_alignof] = ACTIONS(3138),
    [anon_sym__Alignof] = ACTIONS(3138),
    [anon_sym_offsetof] = ACTIONS(3138),
    [anon_sym__Generic] = ACTIONS(3138),
    [anon_sym_asm] = ACTIONS(3138),
    [anon_sym___asm__] = ACTIONS(3138),
    [anon_sym___asm] = ACTIONS(3138),
    [sym_number_literal] = ACTIONS(3140),
    [anon_sym_L_SQUOTE] = ACTIONS(3140),
    [anon_sym_u_SQUOTE] = ACTIONS(3140),
    [anon_sym_U_SQUOTE] = ACTIONS(3140),
    [anon_sym_u8_SQUOTE] = ACTIONS(3140),
    [anon_sym_SQUOTE] = ACTIONS(3140),
    [anon_sym_L_DQUOTE] = ACTIONS(3140),
    [anon_sym_u_DQUOTE] = ACTIONS(3140),
    [anon_sym_U_DQUOTE] = ACTIONS(3140),
    [anon_sym_u8_DQUOTE] = ACTIONS(3140),
    [anon_sym_DQUOTE] = ACTIONS(3140),
    [sym_true] = ACTIONS(3138),
    [sym_false] = ACTIONS(3138),
    [anon_sym_NULL] = ACTIONS(3138),
    [anon_sym_nullptr] = ACTIONS(3138),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3138),
    [anon_sym_decltype] = ACTIONS(3138),
    [anon_sym_explicit] = ACTIONS(3138),
    [anon_sym_typename] = ACTIONS(3138),
    [anon_sym_template] = ACTIONS(3138),
    [anon_sym_operator] = ACTIONS(3138),
    [anon_sym_try] = ACTIONS(3138),
    [anon_sym_delete] = ACTIONS(3138),
    [anon_sym_throw] = ACTIONS(3138),
    [anon_sym_namespace] = ACTIONS(3138),
    [anon_sym_using] = ACTIONS(3138),
    [anon_sym_static_assert] = ACTIONS(3138),
    [anon_sym_concept] = ACTIONS(3138),
    [anon_sym_co_return] = ACTIONS(3138),
    [anon_sym_co_yield] = ACTIONS(3138),
    [anon_sym_R_DQUOTE] = ACTIONS(3140),
    [anon_sym_LR_DQUOTE] = ACTIONS(3140),
    [anon_sym_uR_DQUOTE] = ACTIONS(3140),
    [anon_sym_UR_DQUOTE] = ACTIONS(3140),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3140),
    [anon_sym_co_await] = ACTIONS(3138),
    [anon_sym_new] = ACTIONS(3138),
    [anon_sym_requires] = ACTIONS(3138),
    [sym_this] = ACTIONS(3138),
  },
  [360] = {
    [sym_identifier] = ACTIONS(3142),
    [aux_sym_preproc_include_token1] = ACTIONS(3142),
    [aux_sym_preproc_def_token1] = ACTIONS(3142),
    [aux_sym_preproc_if_token1] = ACTIONS(3142),
    [aux_sym_preproc_if_token2] = ACTIONS(3142),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3142),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3142),
    [aux_sym_preproc_else_token1] = ACTIONS(3142),
    [aux_sym_preproc_elif_token1] = ACTIONS(3142),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3142),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3142),
    [sym_preproc_directive] = ACTIONS(3142),
    [anon_sym_LPAREN2] = ACTIONS(3144),
    [anon_sym_BANG] = ACTIONS(3144),
    [anon_sym_TILDE] = ACTIONS(3144),
    [anon_sym_DASH] = ACTIONS(3142),
    [anon_sym_PLUS] = ACTIONS(3142),
    [anon_sym_STAR] = ACTIONS(3144),
    [anon_sym_AMP_AMP] = ACTIONS(3144),
    [anon_sym_AMP] = ACTIONS(3142),
    [anon_sym_SEMI] = ACTIONS(3144),
    [anon_sym___extension__] = ACTIONS(3142),
    [anon_sym_typedef] = ACTIONS(3142),
    [anon_sym_virtual] = ACTIONS(3142),
    [anon_sym_extern] = ACTIONS(3142),
    [anon_sym___attribute__] = ACTIONS(3142),
    [anon_sym___attribute] = ACTIONS(3142),
    [anon_sym_COLON_COLON] = ACTIONS(3144),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3144),
    [anon_sym___declspec] = ACTIONS(3142),
    [anon_sym___based] = ACTIONS(3142),
    [anon_sym___cdecl] = ACTIONS(3142),
    [anon_sym___clrcall] = ACTIONS(3142),
    [anon_sym___stdcall] = ACTIONS(3142),
    [anon_sym___fastcall] = ACTIONS(3142),
    [anon_sym___thiscall] = ACTIONS(3142),
    [anon_sym___vectorcall] = ACTIONS(3142),
    [anon_sym_LBRACE] = ACTIONS(3144),
    [anon_sym_signed] = ACTIONS(3142),
    [anon_sym_unsigned] = ACTIONS(3142),
    [anon_sym_long] = ACTIONS(3142),
    [anon_sym_short] = ACTIONS(3142),
    [anon_sym_LBRACK] = ACTIONS(3142),
    [anon_sym_static] = ACTIONS(3142),
    [anon_sym_register] = ACTIONS(3142),
    [anon_sym_inline] = ACTIONS(3142),
    [anon_sym___inline] = ACTIONS(3142),
    [anon_sym___inline__] = ACTIONS(3142),
    [anon_sym___forceinline] = ACTIONS(3142),
    [anon_sym_thread_local] = ACTIONS(3142),
    [anon_sym___thread] = ACTIONS(3142),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_constexpr] = ACTIONS(3142),
    [anon_sym_volatile] = ACTIONS(3142),
    [anon_sym_restrict] = ACTIONS(3142),
    [anon_sym___restrict__] = ACTIONS(3142),
    [anon_sym__Atomic] = ACTIONS(3142),
    [anon_sym__Noreturn] = ACTIONS(3142),
    [anon_sym_noreturn] = ACTIONS(3142),
    [anon_sym__Nonnull] = ACTIONS(3142),
    [anon_sym_mutable] = ACTIONS(3142),
    [anon_sym_constinit] = ACTIONS(3142),
    [anon_sym_consteval] = ACTIONS(3142),
    [anon_sym_alignas] = ACTIONS(3142),
    [anon_sym__Alignas] = ACTIONS(3142),
    [sym_primitive_type] = ACTIONS(3142),
    [anon_sym_enum] = ACTIONS(3142),
    [anon_sym_class] = ACTIONS(3142),
    [anon_sym_struct] = ACTIONS(3142),
    [anon_sym_union] = ACTIONS(3142),
    [anon_sym_if] = ACTIONS(3142),
    [anon_sym_switch] = ACTIONS(3142),
    [anon_sym_case] = ACTIONS(3142),
    [anon_sym_default] = ACTIONS(3142),
    [anon_sym_while] = ACTIONS(3142),
    [anon_sym_do] = ACTIONS(3142),
    [anon_sym_for] = ACTIONS(3142),
    [anon_sym_return] = ACTIONS(3142),
    [anon_sym_break] = ACTIONS(3142),
    [anon_sym_continue] = ACTIONS(3142),
    [anon_sym_goto] = ACTIONS(3142),
    [anon_sym___try] = ACTIONS(3142),
    [anon_sym___leave] = ACTIONS(3142),
    [anon_sym_not] = ACTIONS(3142),
    [anon_sym_compl] = ACTIONS(3142),
    [anon_sym_DASH_DASH] = ACTIONS(3144),
    [anon_sym_PLUS_PLUS] = ACTIONS(3144),
    [anon_sym_sizeof] = ACTIONS(3142),
    [anon_sym___alignof__] = ACTIONS(3142),
    [anon_sym___alignof] = ACTIONS(3142),
    [anon_sym__alignof] = ACTIONS(3142),
    [anon_sym_alignof] = ACTIONS(3142),
    [anon_sym__Alignof] = ACTIONS(3142),
    [anon_sym_offsetof] = ACTIONS(3142),
    [anon_sym__Generic] = ACTIONS(3142),
    [anon_sym_asm] = ACTIONS(3142),
    [anon_sym___asm__] = ACTIONS(3142),
    [anon_sym___asm] = ACTIONS(3142),
    [sym_number_literal] = ACTIONS(3144),
    [anon_sym_L_SQUOTE] = ACTIONS(3144),
    [anon_sym_u_SQUOTE] = ACTIONS(3144),
    [anon_sym_U_SQUOTE] = ACTIONS(3144),
    [anon_sym_u8_SQUOTE] = ACTIONS(3144),
    [anon_sym_SQUOTE] = ACTIONS(3144),
    [anon_sym_L_DQUOTE] = ACTIONS(3144),
    [anon_sym_u_DQUOTE] = ACTIONS(3144),
    [anon_sym_U_DQUOTE] = ACTIONS(3144),
    [anon_sym_u8_DQUOTE] = ACTIONS(3144),
    [anon_sym_DQUOTE] = ACTIONS(3144),
    [sym_true] = ACTIONS(3142),
    [sym_false] = ACTIONS(3142),
    [anon_sym_NULL] = ACTIONS(3142),
    [anon_sym_nullptr] = ACTIONS(3142),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3142),
    [anon_sym_decltype] = ACTIONS(3142),
    [anon_sym_explicit] = ACTIONS(3142),
    [anon_sym_typename] = ACTIONS(3142),
    [anon_sym_template] = ACTIONS(3142),
    [anon_sym_operator] = ACTIONS(3142),
    [anon_sym_try] = ACTIONS(3142),
    [anon_sym_delete] = ACTIONS(3142),
    [anon_sym_throw] = ACTIONS(3142),
    [anon_sym_namespace] = ACTIONS(3142),
    [anon_sym_using] = ACTIONS(3142),
    [anon_sym_static_assert] = ACTIONS(3142),
    [anon_sym_concept] = ACTIONS(3142),
    [anon_sym_co_return] = ACTIONS(3142),
    [anon_sym_co_yield] = ACTIONS(3142),
    [anon_sym_R_DQUOTE] = ACTIONS(3144),
    [anon_sym_LR_DQUOTE] = ACTIONS(3144),
    [anon_sym_uR_DQUOTE] = ACTIONS(3144),
    [anon_sym_UR_DQUOTE] = ACTIONS(3144),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3144),
    [anon_sym_co_await] = ACTIONS(3142),
    [anon_sym_new] = ACTIONS(3142),
    [anon_sym_requires] = ACTIONS(3142),
    [sym_this] = ACTIONS(3142),
  },
  [361] = {
    [sym_identifier] = ACTIONS(3146),
    [aux_sym_preproc_include_token1] = ACTIONS(3146),
    [aux_sym_preproc_def_token1] = ACTIONS(3146),
    [aux_sym_preproc_if_token1] = ACTIONS(3146),
    [aux_sym_preproc_if_token2] = ACTIONS(3146),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3146),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3146),
    [aux_sym_preproc_else_token1] = ACTIONS(3146),
    [aux_sym_preproc_elif_token1] = ACTIONS(3146),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3146),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3146),
    [sym_preproc_directive] = ACTIONS(3146),
    [anon_sym_LPAREN2] = ACTIONS(3148),
    [anon_sym_BANG] = ACTIONS(3148),
    [anon_sym_TILDE] = ACTIONS(3148),
    [anon_sym_DASH] = ACTIONS(3146),
    [anon_sym_PLUS] = ACTIONS(3146),
    [anon_sym_STAR] = ACTIONS(3148),
    [anon_sym_AMP_AMP] = ACTIONS(3148),
    [anon_sym_AMP] = ACTIONS(3146),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym___extension__] = ACTIONS(3146),
    [anon_sym_typedef] = ACTIONS(3146),
    [anon_sym_virtual] = ACTIONS(3146),
    [anon_sym_extern] = ACTIONS(3146),
    [anon_sym___attribute__] = ACTIONS(3146),
    [anon_sym___attribute] = ACTIONS(3146),
    [anon_sym_COLON_COLON] = ACTIONS(3148),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3148),
    [anon_sym___declspec] = ACTIONS(3146),
    [anon_sym___based] = ACTIONS(3146),
    [anon_sym___cdecl] = ACTIONS(3146),
    [anon_sym___clrcall] = ACTIONS(3146),
    [anon_sym___stdcall] = ACTIONS(3146),
    [anon_sym___fastcall] = ACTIONS(3146),
    [anon_sym___thiscall] = ACTIONS(3146),
    [anon_sym___vectorcall] = ACTIONS(3146),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_signed] = ACTIONS(3146),
    [anon_sym_unsigned] = ACTIONS(3146),
    [anon_sym_long] = ACTIONS(3146),
    [anon_sym_short] = ACTIONS(3146),
    [anon_sym_LBRACK] = ACTIONS(3146),
    [anon_sym_static] = ACTIONS(3146),
    [anon_sym_register] = ACTIONS(3146),
    [anon_sym_inline] = ACTIONS(3146),
    [anon_sym___inline] = ACTIONS(3146),
    [anon_sym___inline__] = ACTIONS(3146),
    [anon_sym___forceinline] = ACTIONS(3146),
    [anon_sym_thread_local] = ACTIONS(3146),
    [anon_sym___thread] = ACTIONS(3146),
    [anon_sym_const] = ACTIONS(3146),
    [anon_sym_constexpr] = ACTIONS(3146),
    [anon_sym_volatile] = ACTIONS(3146),
    [anon_sym_restrict] = ACTIONS(3146),
    [anon_sym___restrict__] = ACTIONS(3146),
    [anon_sym__Atomic] = ACTIONS(3146),
    [anon_sym__Noreturn] = ACTIONS(3146),
    [anon_sym_noreturn] = ACTIONS(3146),
    [anon_sym__Nonnull] = ACTIONS(3146),
    [anon_sym_mutable] = ACTIONS(3146),
    [anon_sym_constinit] = ACTIONS(3146),
    [anon_sym_consteval] = ACTIONS(3146),
    [anon_sym_alignas] = ACTIONS(3146),
    [anon_sym__Alignas] = ACTIONS(3146),
    [sym_primitive_type] = ACTIONS(3146),
    [anon_sym_enum] = ACTIONS(3146),
    [anon_sym_class] = ACTIONS(3146),
    [anon_sym_struct] = ACTIONS(3146),
    [anon_sym_union] = ACTIONS(3146),
    [anon_sym_if] = ACTIONS(3146),
    [anon_sym_switch] = ACTIONS(3146),
    [anon_sym_case] = ACTIONS(3146),
    [anon_sym_default] = ACTIONS(3146),
    [anon_sym_while] = ACTIONS(3146),
    [anon_sym_do] = ACTIONS(3146),
    [anon_sym_for] = ACTIONS(3146),
    [anon_sym_return] = ACTIONS(3146),
    [anon_sym_break] = ACTIONS(3146),
    [anon_sym_continue] = ACTIONS(3146),
    [anon_sym_goto] = ACTIONS(3146),
    [anon_sym___try] = ACTIONS(3146),
    [anon_sym___leave] = ACTIONS(3146),
    [anon_sym_not] = ACTIONS(3146),
    [anon_sym_compl] = ACTIONS(3146),
    [anon_sym_DASH_DASH] = ACTIONS(3148),
    [anon_sym_PLUS_PLUS] = ACTIONS(3148),
    [anon_sym_sizeof] = ACTIONS(3146),
    [anon_sym___alignof__] = ACTIONS(3146),
    [anon_sym___alignof] = ACTIONS(3146),
    [anon_sym__alignof] = ACTIONS(3146),
    [anon_sym_alignof] = ACTIONS(3146),
    [anon_sym__Alignof] = ACTIONS(3146),
    [anon_sym_offsetof] = ACTIONS(3146),
    [anon_sym__Generic] = ACTIONS(3146),
    [anon_sym_asm] = ACTIONS(3146),
    [anon_sym___asm__] = ACTIONS(3146),
    [anon_sym___asm] = ACTIONS(3146),
    [sym_number_literal] = ACTIONS(3148),
    [anon_sym_L_SQUOTE] = ACTIONS(3148),
    [anon_sym_u_SQUOTE] = ACTIONS(3148),
    [anon_sym_U_SQUOTE] = ACTIONS(3148),
    [anon_sym_u8_SQUOTE] = ACTIONS(3148),
    [anon_sym_SQUOTE] = ACTIONS(3148),
    [anon_sym_L_DQUOTE] = ACTIONS(3148),
    [anon_sym_u_DQUOTE] = ACTIONS(3148),
    [anon_sym_U_DQUOTE] = ACTIONS(3148),
    [anon_sym_u8_DQUOTE] = ACTIONS(3148),
    [anon_sym_DQUOTE] = ACTIONS(3148),
    [sym_true] = ACTIONS(3146),
    [sym_false] = ACTIONS(3146),
    [anon_sym_NULL] = ACTIONS(3146),
    [anon_sym_nullptr] = ACTIONS(3146),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3146),
    [anon_sym_decltype] = ACTIONS(3146),
    [anon_sym_explicit] = ACTIONS(3146),
    [anon_sym_typename] = ACTIONS(3146),
    [anon_sym_template] = ACTIONS(3146),
    [anon_sym_operator] = ACTIONS(3146),
    [anon_sym_try] = ACTIONS(3146),
    [anon_sym_delete] = ACTIONS(3146),
    [anon_sym_throw] = ACTIONS(3146),
    [anon_sym_namespace] = ACTIONS(3146),
    [anon_sym_using] = ACTIONS(3146),
    [anon_sym_static_assert] = ACTIONS(3146),
    [anon_sym_concept] = ACTIONS(3146),
    [anon_sym_co_return] = ACTIONS(3146),
    [anon_sym_co_yield] = ACTIONS(3146),
    [anon_sym_R_DQUOTE] = ACTIONS(3148),
    [anon_sym_LR_DQUOTE] = ACTIONS(3148),
    [anon_sym_uR_DQUOTE] = ACTIONS(3148),
    [anon_sym_UR_DQUOTE] = ACTIONS(3148),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3148),
    [anon_sym_co_await] = ACTIONS(3146),
    [anon_sym_new] = ACTIONS(3146),
    [anon_sym_requires] = ACTIONS(3146),
    [sym_this] = ACTIONS(3146),
  },
  [362] = {
    [sym_identifier] = ACTIONS(3150),
    [aux_sym_preproc_include_token1] = ACTIONS(3150),
    [aux_sym_preproc_def_token1] = ACTIONS(3150),
    [aux_sym_preproc_if_token1] = ACTIONS(3150),
    [aux_sym_preproc_if_token2] = ACTIONS(3150),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3150),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3150),
    [aux_sym_preproc_else_token1] = ACTIONS(3150),
    [aux_sym_preproc_elif_token1] = ACTIONS(3150),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3150),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3150),
    [sym_preproc_directive] = ACTIONS(3150),
    [anon_sym_LPAREN2] = ACTIONS(3152),
    [anon_sym_BANG] = ACTIONS(3152),
    [anon_sym_TILDE] = ACTIONS(3152),
    [anon_sym_DASH] = ACTIONS(3150),
    [anon_sym_PLUS] = ACTIONS(3150),
    [anon_sym_STAR] = ACTIONS(3152),
    [anon_sym_AMP_AMP] = ACTIONS(3152),
    [anon_sym_AMP] = ACTIONS(3150),
    [anon_sym_SEMI] = ACTIONS(3152),
    [anon_sym___extension__] = ACTIONS(3150),
    [anon_sym_typedef] = ACTIONS(3150),
    [anon_sym_virtual] = ACTIONS(3150),
    [anon_sym_extern] = ACTIONS(3150),
    [anon_sym___attribute__] = ACTIONS(3150),
    [anon_sym___attribute] = ACTIONS(3150),
    [anon_sym_COLON_COLON] = ACTIONS(3152),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3152),
    [anon_sym___declspec] = ACTIONS(3150),
    [anon_sym___based] = ACTIONS(3150),
    [anon_sym___cdecl] = ACTIONS(3150),
    [anon_sym___clrcall] = ACTIONS(3150),
    [anon_sym___stdcall] = ACTIONS(3150),
    [anon_sym___fastcall] = ACTIONS(3150),
    [anon_sym___thiscall] = ACTIONS(3150),
    [anon_sym___vectorcall] = ACTIONS(3150),
    [anon_sym_LBRACE] = ACTIONS(3152),
    [anon_sym_signed] = ACTIONS(3150),
    [anon_sym_unsigned] = ACTIONS(3150),
    [anon_sym_long] = ACTIONS(3150),
    [anon_sym_short] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(3150),
    [anon_sym_static] = ACTIONS(3150),
    [anon_sym_register] = ACTIONS(3150),
    [anon_sym_inline] = ACTIONS(3150),
    [anon_sym___inline] = ACTIONS(3150),
    [anon_sym___inline__] = ACTIONS(3150),
    [anon_sym___forceinline] = ACTIONS(3150),
    [anon_sym_thread_local] = ACTIONS(3150),
    [anon_sym___thread] = ACTIONS(3150),
    [anon_sym_const] = ACTIONS(3150),
    [anon_sym_constexpr] = ACTIONS(3150),
    [anon_sym_volatile] = ACTIONS(3150),
    [anon_sym_restrict] = ACTIONS(3150),
    [anon_sym___restrict__] = ACTIONS(3150),
    [anon_sym__Atomic] = ACTIONS(3150),
    [anon_sym__Noreturn] = ACTIONS(3150),
    [anon_sym_noreturn] = ACTIONS(3150),
    [anon_sym__Nonnull] = ACTIONS(3150),
    [anon_sym_mutable] = ACTIONS(3150),
    [anon_sym_constinit] = ACTIONS(3150),
    [anon_sym_consteval] = ACTIONS(3150),
    [anon_sym_alignas] = ACTIONS(3150),
    [anon_sym__Alignas] = ACTIONS(3150),
    [sym_primitive_type] = ACTIONS(3150),
    [anon_sym_enum] = ACTIONS(3150),
    [anon_sym_class] = ACTIONS(3150),
    [anon_sym_struct] = ACTIONS(3150),
    [anon_sym_union] = ACTIONS(3150),
    [anon_sym_if] = ACTIONS(3150),
    [anon_sym_switch] = ACTIONS(3150),
    [anon_sym_case] = ACTIONS(3150),
    [anon_sym_default] = ACTIONS(3150),
    [anon_sym_while] = ACTIONS(3150),
    [anon_sym_do] = ACTIONS(3150),
    [anon_sym_for] = ACTIONS(3150),
    [anon_sym_return] = ACTIONS(3150),
    [anon_sym_break] = ACTIONS(3150),
    [anon_sym_continue] = ACTIONS(3150),
    [anon_sym_goto] = ACTIONS(3150),
    [anon_sym___try] = ACTIONS(3150),
    [anon_sym___leave] = ACTIONS(3150),
    [anon_sym_not] = ACTIONS(3150),
    [anon_sym_compl] = ACTIONS(3150),
    [anon_sym_DASH_DASH] = ACTIONS(3152),
    [anon_sym_PLUS_PLUS] = ACTIONS(3152),
    [anon_sym_sizeof] = ACTIONS(3150),
    [anon_sym___alignof__] = ACTIONS(3150),
    [anon_sym___alignof] = ACTIONS(3150),
    [anon_sym__alignof] = ACTIONS(3150),
    [anon_sym_alignof] = ACTIONS(3150),
    [anon_sym__Alignof] = ACTIONS(3150),
    [anon_sym_offsetof] = ACTIONS(3150),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3150),
    [anon_sym___asm__] = ACTIONS(3150),
    [anon_sym___asm] = ACTIONS(3150),
    [sym_number_literal] = ACTIONS(3152),
    [anon_sym_L_SQUOTE] = ACTIONS(3152),
    [anon_sym_u_SQUOTE] = ACTIONS(3152),
    [anon_sym_U_SQUOTE] = ACTIONS(3152),
    [anon_sym_u8_SQUOTE] = ACTIONS(3152),
    [anon_sym_SQUOTE] = ACTIONS(3152),
    [anon_sym_L_DQUOTE] = ACTIONS(3152),
    [anon_sym_u_DQUOTE] = ACTIONS(3152),
    [anon_sym_U_DQUOTE] = ACTIONS(3152),
    [anon_sym_u8_DQUOTE] = ACTIONS(3152),
    [anon_sym_DQUOTE] = ACTIONS(3152),
    [sym_true] = ACTIONS(3150),
    [sym_false] = ACTIONS(3150),
    [anon_sym_NULL] = ACTIONS(3150),
    [anon_sym_nullptr] = ACTIONS(3150),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3150),
    [anon_sym_decltype] = ACTIONS(3150),
    [anon_sym_explicit] = ACTIONS(3150),
    [anon_sym_typename] = ACTIONS(3150),
    [anon_sym_template] = ACTIONS(3150),
    [anon_sym_operator] = ACTIONS(3150),
    [anon_sym_try] = ACTIONS(3150),
    [anon_sym_delete] = ACTIONS(3150),
    [anon_sym_throw] = ACTIONS(3150),
    [anon_sym_namespace] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_static_assert] = ACTIONS(3150),
    [anon_sym_concept] = ACTIONS(3150),
    [anon_sym_co_return] = ACTIONS(3150),
    [anon_sym_co_yield] = ACTIONS(3150),
    [anon_sym_R_DQUOTE] = ACTIONS(3152),
    [anon_sym_LR_DQUOTE] = ACTIONS(3152),
    [anon_sym_uR_DQUOTE] = ACTIONS(3152),
    [anon_sym_UR_DQUOTE] = ACTIONS(3152),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3152),
    [anon_sym_co_await] = ACTIONS(3150),
    [anon_sym_new] = ACTIONS(3150),
    [anon_sym_requires] = ACTIONS(3150),
    [sym_this] = ACTIONS(3150),
  },
  [363] = {
    [sym_identifier] = ACTIONS(3154),
    [aux_sym_preproc_include_token1] = ACTIONS(3154),
    [aux_sym_preproc_def_token1] = ACTIONS(3154),
    [aux_sym_preproc_if_token1] = ACTIONS(3154),
    [aux_sym_preproc_if_token2] = ACTIONS(3154),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3154),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3154),
    [aux_sym_preproc_else_token1] = ACTIONS(3154),
    [aux_sym_preproc_elif_token1] = ACTIONS(3154),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3154),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3154),
    [sym_preproc_directive] = ACTIONS(3154),
    [anon_sym_LPAREN2] = ACTIONS(3156),
    [anon_sym_BANG] = ACTIONS(3156),
    [anon_sym_TILDE] = ACTIONS(3156),
    [anon_sym_DASH] = ACTIONS(3154),
    [anon_sym_PLUS] = ACTIONS(3154),
    [anon_sym_STAR] = ACTIONS(3156),
    [anon_sym_AMP_AMP] = ACTIONS(3156),
    [anon_sym_AMP] = ACTIONS(3154),
    [anon_sym_SEMI] = ACTIONS(3156),
    [anon_sym___extension__] = ACTIONS(3154),
    [anon_sym_typedef] = ACTIONS(3154),
    [anon_sym_virtual] = ACTIONS(3154),
    [anon_sym_extern] = ACTIONS(3154),
    [anon_sym___attribute__] = ACTIONS(3154),
    [anon_sym___attribute] = ACTIONS(3154),
    [anon_sym_COLON_COLON] = ACTIONS(3156),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3156),
    [anon_sym___declspec] = ACTIONS(3154),
    [anon_sym___based] = ACTIONS(3154),
    [anon_sym___cdecl] = ACTIONS(3154),
    [anon_sym___clrcall] = ACTIONS(3154),
    [anon_sym___stdcall] = ACTIONS(3154),
    [anon_sym___fastcall] = ACTIONS(3154),
    [anon_sym___thiscall] = ACTIONS(3154),
    [anon_sym___vectorcall] = ACTIONS(3154),
    [anon_sym_LBRACE] = ACTIONS(3156),
    [anon_sym_signed] = ACTIONS(3154),
    [anon_sym_unsigned] = ACTIONS(3154),
    [anon_sym_long] = ACTIONS(3154),
    [anon_sym_short] = ACTIONS(3154),
    [anon_sym_LBRACK] = ACTIONS(3154),
    [anon_sym_static] = ACTIONS(3154),
    [anon_sym_register] = ACTIONS(3154),
    [anon_sym_inline] = ACTIONS(3154),
    [anon_sym___inline] = ACTIONS(3154),
    [anon_sym___inline__] = ACTIONS(3154),
    [anon_sym___forceinline] = ACTIONS(3154),
    [anon_sym_thread_local] = ACTIONS(3154),
    [anon_sym___thread] = ACTIONS(3154),
    [anon_sym_const] = ACTIONS(3154),
    [anon_sym_constexpr] = ACTIONS(3154),
    [anon_sym_volatile] = ACTIONS(3154),
    [anon_sym_restrict] = ACTIONS(3154),
    [anon_sym___restrict__] = ACTIONS(3154),
    [anon_sym__Atomic] = ACTIONS(3154),
    [anon_sym__Noreturn] = ACTIONS(3154),
    [anon_sym_noreturn] = ACTIONS(3154),
    [anon_sym__Nonnull] = ACTIONS(3154),
    [anon_sym_mutable] = ACTIONS(3154),
    [anon_sym_constinit] = ACTIONS(3154),
    [anon_sym_consteval] = ACTIONS(3154),
    [anon_sym_alignas] = ACTIONS(3154),
    [anon_sym__Alignas] = ACTIONS(3154),
    [sym_primitive_type] = ACTIONS(3154),
    [anon_sym_enum] = ACTIONS(3154),
    [anon_sym_class] = ACTIONS(3154),
    [anon_sym_struct] = ACTIONS(3154),
    [anon_sym_union] = ACTIONS(3154),
    [anon_sym_if] = ACTIONS(3154),
    [anon_sym_switch] = ACTIONS(3154),
    [anon_sym_case] = ACTIONS(3154),
    [anon_sym_default] = ACTIONS(3154),
    [anon_sym_while] = ACTIONS(3154),
    [anon_sym_do] = ACTIONS(3154),
    [anon_sym_for] = ACTIONS(3154),
    [anon_sym_return] = ACTIONS(3154),
    [anon_sym_break] = ACTIONS(3154),
    [anon_sym_continue] = ACTIONS(3154),
    [anon_sym_goto] = ACTIONS(3154),
    [anon_sym___try] = ACTIONS(3154),
    [anon_sym___leave] = ACTIONS(3154),
    [anon_sym_not] = ACTIONS(3154),
    [anon_sym_compl] = ACTIONS(3154),
    [anon_sym_DASH_DASH] = ACTIONS(3156),
    [anon_sym_PLUS_PLUS] = ACTIONS(3156),
    [anon_sym_sizeof] = ACTIONS(3154),
    [anon_sym___alignof__] = ACTIONS(3154),
    [anon_sym___alignof] = ACTIONS(3154),
    [anon_sym__alignof] = ACTIONS(3154),
    [anon_sym_alignof] = ACTIONS(3154),
    [anon_sym__Alignof] = ACTIONS(3154),
    [anon_sym_offsetof] = ACTIONS(3154),
    [anon_sym__Generic] = ACTIONS(3154),
    [anon_sym_asm] = ACTIONS(3154),
    [anon_sym___asm__] = ACTIONS(3154),
    [anon_sym___asm] = ACTIONS(3154),
    [sym_number_literal] = ACTIONS(3156),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3156),
    [anon_sym_u_DQUOTE] = ACTIONS(3156),
    [anon_sym_U_DQUOTE] = ACTIONS(3156),
    [anon_sym_u8_DQUOTE] = ACTIONS(3156),
    [anon_sym_DQUOTE] = ACTIONS(3156),
    [sym_true] = ACTIONS(3154),
    [sym_false] = ACTIONS(3154),
    [anon_sym_NULL] = ACTIONS(3154),
    [anon_sym_nullptr] = ACTIONS(3154),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3154),
    [anon_sym_decltype] = ACTIONS(3154),
    [anon_sym_explicit] = ACTIONS(3154),
    [anon_sym_typename] = ACTIONS(3154),
    [anon_sym_template] = ACTIONS(3154),
    [anon_sym_operator] = ACTIONS(3154),
    [anon_sym_try] = ACTIONS(3154),
    [anon_sym_delete] = ACTIONS(3154),
    [anon_sym_throw] = ACTIONS(3154),
    [anon_sym_namespace] = ACTIONS(3154),
    [anon_sym_using] = ACTIONS(3154),
    [anon_sym_static_assert] = ACTIONS(3154),
    [anon_sym_concept] = ACTIONS(3154),
    [anon_sym_co_return] = ACTIONS(3154),
    [anon_sym_co_yield] = ACTIONS(3154),
    [anon_sym_R_DQUOTE] = ACTIONS(3156),
    [anon_sym_LR_DQUOTE] = ACTIONS(3156),
    [anon_sym_uR_DQUOTE] = ACTIONS(3156),
    [anon_sym_UR_DQUOTE] = ACTIONS(3156),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3156),
    [anon_sym_co_await] = ACTIONS(3154),
    [anon_sym_new] = ACTIONS(3154),
    [anon_sym_requires] = ACTIONS(3154),
    [sym_this] = ACTIONS(3154),
  },
  [364] = {
    [sym_identifier] = ACTIONS(3158),
    [aux_sym_preproc_include_token1] = ACTIONS(3158),
    [aux_sym_preproc_def_token1] = ACTIONS(3158),
    [aux_sym_preproc_if_token1] = ACTIONS(3158),
    [aux_sym_preproc_if_token2] = ACTIONS(3158),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3158),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3158),
    [aux_sym_preproc_else_token1] = ACTIONS(3158),
    [aux_sym_preproc_elif_token1] = ACTIONS(3158),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3158),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3158),
    [sym_preproc_directive] = ACTIONS(3158),
    [anon_sym_LPAREN2] = ACTIONS(3160),
    [anon_sym_BANG] = ACTIONS(3160),
    [anon_sym_TILDE] = ACTIONS(3160),
    [anon_sym_DASH] = ACTIONS(3158),
    [anon_sym_PLUS] = ACTIONS(3158),
    [anon_sym_STAR] = ACTIONS(3160),
    [anon_sym_AMP_AMP] = ACTIONS(3160),
    [anon_sym_AMP] = ACTIONS(3158),
    [anon_sym_SEMI] = ACTIONS(3160),
    [anon_sym___extension__] = ACTIONS(3158),
    [anon_sym_typedef] = ACTIONS(3158),
    [anon_sym_virtual] = ACTIONS(3158),
    [anon_sym_extern] = ACTIONS(3158),
    [anon_sym___attribute__] = ACTIONS(3158),
    [anon_sym___attribute] = ACTIONS(3158),
    [anon_sym_COLON_COLON] = ACTIONS(3160),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3160),
    [anon_sym___declspec] = ACTIONS(3158),
    [anon_sym___based] = ACTIONS(3158),
    [anon_sym___cdecl] = ACTIONS(3158),
    [anon_sym___clrcall] = ACTIONS(3158),
    [anon_sym___stdcall] = ACTIONS(3158),
    [anon_sym___fastcall] = ACTIONS(3158),
    [anon_sym___thiscall] = ACTIONS(3158),
    [anon_sym___vectorcall] = ACTIONS(3158),
    [anon_sym_LBRACE] = ACTIONS(3160),
    [anon_sym_signed] = ACTIONS(3158),
    [anon_sym_unsigned] = ACTIONS(3158),
    [anon_sym_long] = ACTIONS(3158),
    [anon_sym_short] = ACTIONS(3158),
    [anon_sym_LBRACK] = ACTIONS(3158),
    [anon_sym_static] = ACTIONS(3158),
    [anon_sym_register] = ACTIONS(3158),
    [anon_sym_inline] = ACTIONS(3158),
    [anon_sym___inline] = ACTIONS(3158),
    [anon_sym___inline__] = ACTIONS(3158),
    [anon_sym___forceinline] = ACTIONS(3158),
    [anon_sym_thread_local] = ACTIONS(3158),
    [anon_sym___thread] = ACTIONS(3158),
    [anon_sym_const] = ACTIONS(3158),
    [anon_sym_constexpr] = ACTIONS(3158),
    [anon_sym_volatile] = ACTIONS(3158),
    [anon_sym_restrict] = ACTIONS(3158),
    [anon_sym___restrict__] = ACTIONS(3158),
    [anon_sym__Atomic] = ACTIONS(3158),
    [anon_sym__Noreturn] = ACTIONS(3158),
    [anon_sym_noreturn] = ACTIONS(3158),
    [anon_sym__Nonnull] = ACTIONS(3158),
    [anon_sym_mutable] = ACTIONS(3158),
    [anon_sym_constinit] = ACTIONS(3158),
    [anon_sym_consteval] = ACTIONS(3158),
    [anon_sym_alignas] = ACTIONS(3158),
    [anon_sym__Alignas] = ACTIONS(3158),
    [sym_primitive_type] = ACTIONS(3158),
    [anon_sym_enum] = ACTIONS(3158),
    [anon_sym_class] = ACTIONS(3158),
    [anon_sym_struct] = ACTIONS(3158),
    [anon_sym_union] = ACTIONS(3158),
    [anon_sym_if] = ACTIONS(3158),
    [anon_sym_switch] = ACTIONS(3158),
    [anon_sym_case] = ACTIONS(3158),
    [anon_sym_default] = ACTIONS(3158),
    [anon_sym_while] = ACTIONS(3158),
    [anon_sym_do] = ACTIONS(3158),
    [anon_sym_for] = ACTIONS(3158),
    [anon_sym_return] = ACTIONS(3158),
    [anon_sym_break] = ACTIONS(3158),
    [anon_sym_continue] = ACTIONS(3158),
    [anon_sym_goto] = ACTIONS(3158),
    [anon_sym___try] = ACTIONS(3158),
    [anon_sym___leave] = ACTIONS(3158),
    [anon_sym_not] = ACTIONS(3158),
    [anon_sym_compl] = ACTIONS(3158),
    [anon_sym_DASH_DASH] = ACTIONS(3160),
    [anon_sym_PLUS_PLUS] = ACTIONS(3160),
    [anon_sym_sizeof] = ACTIONS(3158),
    [anon_sym___alignof__] = ACTIONS(3158),
    [anon_sym___alignof] = ACTIONS(3158),
    [anon_sym__alignof] = ACTIONS(3158),
    [anon_sym_alignof] = ACTIONS(3158),
    [anon_sym__Alignof] = ACTIONS(3158),
    [anon_sym_offsetof] = ACTIONS(3158),
    [anon_sym__Generic] = ACTIONS(3158),
    [anon_sym_asm] = ACTIONS(3158),
    [anon_sym___asm__] = ACTIONS(3158),
    [anon_sym___asm] = ACTIONS(3158),
    [sym_number_literal] = ACTIONS(3160),
    [anon_sym_L_SQUOTE] = ACTIONS(3160),
    [anon_sym_u_SQUOTE] = ACTIONS(3160),
    [anon_sym_U_SQUOTE] = ACTIONS(3160),
    [anon_sym_u8_SQUOTE] = ACTIONS(3160),
    [anon_sym_SQUOTE] = ACTIONS(3160),
    [anon_sym_L_DQUOTE] = ACTIONS(3160),
    [anon_sym_u_DQUOTE] = ACTIONS(3160),
    [anon_sym_U_DQUOTE] = ACTIONS(3160),
    [anon_sym_u8_DQUOTE] = ACTIONS(3160),
    [anon_sym_DQUOTE] = ACTIONS(3160),
    [sym_true] = ACTIONS(3158),
    [sym_false] = ACTIONS(3158),
    [anon_sym_NULL] = ACTIONS(3158),
    [anon_sym_nullptr] = ACTIONS(3158),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3158),
    [anon_sym_decltype] = ACTIONS(3158),
    [anon_sym_explicit] = ACTIONS(3158),
    [anon_sym_typename] = ACTIONS(3158),
    [anon_sym_template] = ACTIONS(3158),
    [anon_sym_operator] = ACTIONS(3158),
    [anon_sym_try] = ACTIONS(3158),
    [anon_sym_delete] = ACTIONS(3158),
    [anon_sym_throw] = ACTIONS(3158),
    [anon_sym_namespace] = ACTIONS(3158),
    [anon_sym_using] = ACTIONS(3158),
    [anon_sym_static_assert] = ACTIONS(3158),
    [anon_sym_concept] = ACTIONS(3158),
    [anon_sym_co_return] = ACTIONS(3158),
    [anon_sym_co_yield] = ACTIONS(3158),
    [anon_sym_R_DQUOTE] = ACTIONS(3160),
    [anon_sym_LR_DQUOTE] = ACTIONS(3160),
    [anon_sym_uR_DQUOTE] = ACTIONS(3160),
    [anon_sym_UR_DQUOTE] = ACTIONS(3160),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3160),
    [anon_sym_co_await] = ACTIONS(3158),
    [anon_sym_new] = ACTIONS(3158),
    [anon_sym_requires] = ACTIONS(3158),
    [sym_this] = ACTIONS(3158),
  },
  [365] = {
    [sym_identifier] = ACTIONS(3162),
    [aux_sym_preproc_include_token1] = ACTIONS(3162),
    [aux_sym_preproc_def_token1] = ACTIONS(3162),
    [aux_sym_preproc_if_token1] = ACTIONS(3162),
    [aux_sym_preproc_if_token2] = ACTIONS(3162),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3162),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3162),
    [aux_sym_preproc_else_token1] = ACTIONS(3162),
    [aux_sym_preproc_elif_token1] = ACTIONS(3162),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3162),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3162),
    [sym_preproc_directive] = ACTIONS(3162),
    [anon_sym_LPAREN2] = ACTIONS(3164),
    [anon_sym_BANG] = ACTIONS(3164),
    [anon_sym_TILDE] = ACTIONS(3164),
    [anon_sym_DASH] = ACTIONS(3162),
    [anon_sym_PLUS] = ACTIONS(3162),
    [anon_sym_STAR] = ACTIONS(3164),
    [anon_sym_AMP_AMP] = ACTIONS(3164),
    [anon_sym_AMP] = ACTIONS(3162),
    [anon_sym_SEMI] = ACTIONS(3164),
    [anon_sym___extension__] = ACTIONS(3162),
    [anon_sym_typedef] = ACTIONS(3162),
    [anon_sym_virtual] = ACTIONS(3162),
    [anon_sym_extern] = ACTIONS(3162),
    [anon_sym___attribute__] = ACTIONS(3162),
    [anon_sym___attribute] = ACTIONS(3162),
    [anon_sym_COLON_COLON] = ACTIONS(3164),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3164),
    [anon_sym___declspec] = ACTIONS(3162),
    [anon_sym___based] = ACTIONS(3162),
    [anon_sym___cdecl] = ACTIONS(3162),
    [anon_sym___clrcall] = ACTIONS(3162),
    [anon_sym___stdcall] = ACTIONS(3162),
    [anon_sym___fastcall] = ACTIONS(3162),
    [anon_sym___thiscall] = ACTIONS(3162),
    [anon_sym___vectorcall] = ACTIONS(3162),
    [anon_sym_LBRACE] = ACTIONS(3164),
    [anon_sym_signed] = ACTIONS(3162),
    [anon_sym_unsigned] = ACTIONS(3162),
    [anon_sym_long] = ACTIONS(3162),
    [anon_sym_short] = ACTIONS(3162),
    [anon_sym_LBRACK] = ACTIONS(3162),
    [anon_sym_static] = ACTIONS(3162),
    [anon_sym_register] = ACTIONS(3162),
    [anon_sym_inline] = ACTIONS(3162),
    [anon_sym___inline] = ACTIONS(3162),
    [anon_sym___inline__] = ACTIONS(3162),
    [anon_sym___forceinline] = ACTIONS(3162),
    [anon_sym_thread_local] = ACTIONS(3162),
    [anon_sym___thread] = ACTIONS(3162),
    [anon_sym_const] = ACTIONS(3162),
    [anon_sym_constexpr] = ACTIONS(3162),
    [anon_sym_volatile] = ACTIONS(3162),
    [anon_sym_restrict] = ACTIONS(3162),
    [anon_sym___restrict__] = ACTIONS(3162),
    [anon_sym__Atomic] = ACTIONS(3162),
    [anon_sym__Noreturn] = ACTIONS(3162),
    [anon_sym_noreturn] = ACTIONS(3162),
    [anon_sym__Nonnull] = ACTIONS(3162),
    [anon_sym_mutable] = ACTIONS(3162),
    [anon_sym_constinit] = ACTIONS(3162),
    [anon_sym_consteval] = ACTIONS(3162),
    [anon_sym_alignas] = ACTIONS(3162),
    [anon_sym__Alignas] = ACTIONS(3162),
    [sym_primitive_type] = ACTIONS(3162),
    [anon_sym_enum] = ACTIONS(3162),
    [anon_sym_class] = ACTIONS(3162),
    [anon_sym_struct] = ACTIONS(3162),
    [anon_sym_union] = ACTIONS(3162),
    [anon_sym_if] = ACTIONS(3162),
    [anon_sym_switch] = ACTIONS(3162),
    [anon_sym_case] = ACTIONS(3162),
    [anon_sym_default] = ACTIONS(3162),
    [anon_sym_while] = ACTIONS(3162),
    [anon_sym_do] = ACTIONS(3162),
    [anon_sym_for] = ACTIONS(3162),
    [anon_sym_return] = ACTIONS(3162),
    [anon_sym_break] = ACTIONS(3162),
    [anon_sym_continue] = ACTIONS(3162),
    [anon_sym_goto] = ACTIONS(3162),
    [anon_sym___try] = ACTIONS(3162),
    [anon_sym___leave] = ACTIONS(3162),
    [anon_sym_not] = ACTIONS(3162),
    [anon_sym_compl] = ACTIONS(3162),
    [anon_sym_DASH_DASH] = ACTIONS(3164),
    [anon_sym_PLUS_PLUS] = ACTIONS(3164),
    [anon_sym_sizeof] = ACTIONS(3162),
    [anon_sym___alignof__] = ACTIONS(3162),
    [anon_sym___alignof] = ACTIONS(3162),
    [anon_sym__alignof] = ACTIONS(3162),
    [anon_sym_alignof] = ACTIONS(3162),
    [anon_sym__Alignof] = ACTIONS(3162),
    [anon_sym_offsetof] = ACTIONS(3162),
    [anon_sym__Generic] = ACTIONS(3162),
    [anon_sym_asm] = ACTIONS(3162),
    [anon_sym___asm__] = ACTIONS(3162),
    [anon_sym___asm] = ACTIONS(3162),
    [sym_number_literal] = ACTIONS(3164),
    [anon_sym_L_SQUOTE] = ACTIONS(3164),
    [anon_sym_u_SQUOTE] = ACTIONS(3164),
    [anon_sym_U_SQUOTE] = ACTIONS(3164),
    [anon_sym_u8_SQUOTE] = ACTIONS(3164),
    [anon_sym_SQUOTE] = ACTIONS(3164),
    [anon_sym_L_DQUOTE] = ACTIONS(3164),
    [anon_sym_u_DQUOTE] = ACTIONS(3164),
    [anon_sym_U_DQUOTE] = ACTIONS(3164),
    [anon_sym_u8_DQUOTE] = ACTIONS(3164),
    [anon_sym_DQUOTE] = ACTIONS(3164),
    [sym_true] = ACTIONS(3162),
    [sym_false] = ACTIONS(3162),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3162),
    [anon_sym_decltype] = ACTIONS(3162),
    [anon_sym_explicit] = ACTIONS(3162),
    [anon_sym_typename] = ACTIONS(3162),
    [anon_sym_template] = ACTIONS(3162),
    [anon_sym_operator] = ACTIONS(3162),
    [anon_sym_try] = ACTIONS(3162),
    [anon_sym_delete] = ACTIONS(3162),
    [anon_sym_throw] = ACTIONS(3162),
    [anon_sym_namespace] = ACTIONS(3162),
    [anon_sym_using] = ACTIONS(3162),
    [anon_sym_static_assert] = ACTIONS(3162),
    [anon_sym_concept] = ACTIONS(3162),
    [anon_sym_co_return] = ACTIONS(3162),
    [anon_sym_co_yield] = ACTIONS(3162),
    [anon_sym_R_DQUOTE] = ACTIONS(3164),
    [anon_sym_LR_DQUOTE] = ACTIONS(3164),
    [anon_sym_uR_DQUOTE] = ACTIONS(3164),
    [anon_sym_UR_DQUOTE] = ACTIONS(3164),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3164),
    [anon_sym_co_await] = ACTIONS(3162),
    [anon_sym_new] = ACTIONS(3162),
    [anon_sym_requires] = ACTIONS(3162),
    [sym_this] = ACTIONS(3162),
  },
  [366] = {
    [sym_identifier] = ACTIONS(3166),
    [aux_sym_preproc_include_token1] = ACTIONS(3166),
    [aux_sym_preproc_def_token1] = ACTIONS(3166),
    [aux_sym_preproc_if_token1] = ACTIONS(3166),
    [aux_sym_preproc_if_token2] = ACTIONS(3166),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3166),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3166),
    [aux_sym_preproc_else_token1] = ACTIONS(3166),
    [aux_sym_preproc_elif_token1] = ACTIONS(3166),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3166),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3166),
    [sym_preproc_directive] = ACTIONS(3166),
    [anon_sym_LPAREN2] = ACTIONS(3168),
    [anon_sym_BANG] = ACTIONS(3168),
    [anon_sym_TILDE] = ACTIONS(3168),
    [anon_sym_DASH] = ACTIONS(3166),
    [anon_sym_PLUS] = ACTIONS(3166),
    [anon_sym_STAR] = ACTIONS(3168),
    [anon_sym_AMP_AMP] = ACTIONS(3168),
    [anon_sym_AMP] = ACTIONS(3166),
    [anon_sym_SEMI] = ACTIONS(3168),
    [anon_sym___extension__] = ACTIONS(3166),
    [anon_sym_typedef] = ACTIONS(3166),
    [anon_sym_virtual] = ACTIONS(3166),
    [anon_sym_extern] = ACTIONS(3166),
    [anon_sym___attribute__] = ACTIONS(3166),
    [anon_sym___attribute] = ACTIONS(3166),
    [anon_sym_COLON_COLON] = ACTIONS(3168),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3168),
    [anon_sym___declspec] = ACTIONS(3166),
    [anon_sym___based] = ACTIONS(3166),
    [anon_sym___cdecl] = ACTIONS(3166),
    [anon_sym___clrcall] = ACTIONS(3166),
    [anon_sym___stdcall] = ACTIONS(3166),
    [anon_sym___fastcall] = ACTIONS(3166),
    [anon_sym___thiscall] = ACTIONS(3166),
    [anon_sym___vectorcall] = ACTIONS(3166),
    [anon_sym_LBRACE] = ACTIONS(3168),
    [anon_sym_signed] = ACTIONS(3166),
    [anon_sym_unsigned] = ACTIONS(3166),
    [anon_sym_long] = ACTIONS(3166),
    [anon_sym_short] = ACTIONS(3166),
    [anon_sym_LBRACK] = ACTIONS(3166),
    [anon_sym_static] = ACTIONS(3166),
    [anon_sym_register] = ACTIONS(3166),
    [anon_sym_inline] = ACTIONS(3166),
    [anon_sym___inline] = ACTIONS(3166),
    [anon_sym___inline__] = ACTIONS(3166),
    [anon_sym___forceinline] = ACTIONS(3166),
    [anon_sym_thread_local] = ACTIONS(3166),
    [anon_sym___thread] = ACTIONS(3166),
    [anon_sym_const] = ACTIONS(3166),
    [anon_sym_constexpr] = ACTIONS(3166),
    [anon_sym_volatile] = ACTIONS(3166),
    [anon_sym_restrict] = ACTIONS(3166),
    [anon_sym___restrict__] = ACTIONS(3166),
    [anon_sym__Atomic] = ACTIONS(3166),
    [anon_sym__Noreturn] = ACTIONS(3166),
    [anon_sym_noreturn] = ACTIONS(3166),
    [anon_sym__Nonnull] = ACTIONS(3166),
    [anon_sym_mutable] = ACTIONS(3166),
    [anon_sym_constinit] = ACTIONS(3166),
    [anon_sym_consteval] = ACTIONS(3166),
    [anon_sym_alignas] = ACTIONS(3166),
    [anon_sym__Alignas] = ACTIONS(3166),
    [sym_primitive_type] = ACTIONS(3166),
    [anon_sym_enum] = ACTIONS(3166),
    [anon_sym_class] = ACTIONS(3166),
    [anon_sym_struct] = ACTIONS(3166),
    [anon_sym_union] = ACTIONS(3166),
    [anon_sym_if] = ACTIONS(3166),
    [anon_sym_switch] = ACTIONS(3166),
    [anon_sym_case] = ACTIONS(3166),
    [anon_sym_default] = ACTIONS(3166),
    [anon_sym_while] = ACTIONS(3166),
    [anon_sym_do] = ACTIONS(3166),
    [anon_sym_for] = ACTIONS(3166),
    [anon_sym_return] = ACTIONS(3166),
    [anon_sym_break] = ACTIONS(3166),
    [anon_sym_continue] = ACTIONS(3166),
    [anon_sym_goto] = ACTIONS(3166),
    [anon_sym___try] = ACTIONS(3166),
    [anon_sym___leave] = ACTIONS(3166),
    [anon_sym_not] = ACTIONS(3166),
    [anon_sym_compl] = ACTIONS(3166),
    [anon_sym_DASH_DASH] = ACTIONS(3168),
    [anon_sym_PLUS_PLUS] = ACTIONS(3168),
    [anon_sym_sizeof] = ACTIONS(3166),
    [anon_sym___alignof__] = ACTIONS(3166),
    [anon_sym___alignof] = ACTIONS(3166),
    [anon_sym__alignof] = ACTIONS(3166),
    [anon_sym_alignof] = ACTIONS(3166),
    [anon_sym__Alignof] = ACTIONS(3166),
    [anon_sym_offsetof] = ACTIONS(3166),
    [anon_sym__Generic] = ACTIONS(3166),
    [anon_sym_asm] = ACTIONS(3166),
    [anon_sym___asm__] = ACTIONS(3166),
    [anon_sym___asm] = ACTIONS(3166),
    [sym_number_literal] = ACTIONS(3168),
    [anon_sym_L_SQUOTE] = ACTIONS(3168),
    [anon_sym_u_SQUOTE] = ACTIONS(3168),
    [anon_sym_U_SQUOTE] = ACTIONS(3168),
    [anon_sym_u8_SQUOTE] = ACTIONS(3168),
    [anon_sym_SQUOTE] = ACTIONS(3168),
    [anon_sym_L_DQUOTE] = ACTIONS(3168),
    [anon_sym_u_DQUOTE] = ACTIONS(3168),
    [anon_sym_U_DQUOTE] = ACTIONS(3168),
    [anon_sym_u8_DQUOTE] = ACTIONS(3168),
    [anon_sym_DQUOTE] = ACTIONS(3168),
    [sym_true] = ACTIONS(3166),
    [sym_false] = ACTIONS(3166),
    [anon_sym_NULL] = ACTIONS(3166),
    [anon_sym_nullptr] = ACTIONS(3166),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3166),
    [anon_sym_decltype] = ACTIONS(3166),
    [anon_sym_explicit] = ACTIONS(3166),
    [anon_sym_typename] = ACTIONS(3166),
    [anon_sym_template] = ACTIONS(3166),
    [anon_sym_operator] = ACTIONS(3166),
    [anon_sym_try] = ACTIONS(3166),
    [anon_sym_delete] = ACTIONS(3166),
    [anon_sym_throw] = ACTIONS(3166),
    [anon_sym_namespace] = ACTIONS(3166),
    [anon_sym_using] = ACTIONS(3166),
    [anon_sym_static_assert] = ACTIONS(3166),
    [anon_sym_concept] = ACTIONS(3166),
    [anon_sym_co_return] = ACTIONS(3166),
    [anon_sym_co_yield] = ACTIONS(3166),
    [anon_sym_R_DQUOTE] = ACTIONS(3168),
    [anon_sym_LR_DQUOTE] = ACTIONS(3168),
    [anon_sym_uR_DQUOTE] = ACTIONS(3168),
    [anon_sym_UR_DQUOTE] = ACTIONS(3168),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3168),
    [anon_sym_co_await] = ACTIONS(3166),
    [anon_sym_new] = ACTIONS(3166),
    [anon_sym_requires] = ACTIONS(3166),
    [sym_this] = ACTIONS(3166),
  },
  [367] = {
    [sym_identifier] = ACTIONS(3170),
    [aux_sym_preproc_include_token1] = ACTIONS(3170),
    [aux_sym_preproc_def_token1] = ACTIONS(3170),
    [aux_sym_preproc_if_token1] = ACTIONS(3170),
    [aux_sym_preproc_if_token2] = ACTIONS(3170),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3170),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3170),
    [aux_sym_preproc_else_token1] = ACTIONS(3170),
    [aux_sym_preproc_elif_token1] = ACTIONS(3170),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3170),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3170),
    [sym_preproc_directive] = ACTIONS(3170),
    [anon_sym_LPAREN2] = ACTIONS(3172),
    [anon_sym_BANG] = ACTIONS(3172),
    [anon_sym_TILDE] = ACTIONS(3172),
    [anon_sym_DASH] = ACTIONS(3170),
    [anon_sym_PLUS] = ACTIONS(3170),
    [anon_sym_STAR] = ACTIONS(3172),
    [anon_sym_AMP_AMP] = ACTIONS(3172),
    [anon_sym_AMP] = ACTIONS(3170),
    [anon_sym_SEMI] = ACTIONS(3172),
    [anon_sym___extension__] = ACTIONS(3170),
    [anon_sym_typedef] = ACTIONS(3170),
    [anon_sym_virtual] = ACTIONS(3170),
    [anon_sym_extern] = ACTIONS(3170),
    [anon_sym___attribute__] = ACTIONS(3170),
    [anon_sym___attribute] = ACTIONS(3170),
    [anon_sym_COLON_COLON] = ACTIONS(3172),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3172),
    [anon_sym___declspec] = ACTIONS(3170),
    [anon_sym___based] = ACTIONS(3170),
    [anon_sym___cdecl] = ACTIONS(3170),
    [anon_sym___clrcall] = ACTIONS(3170),
    [anon_sym___stdcall] = ACTIONS(3170),
    [anon_sym___fastcall] = ACTIONS(3170),
    [anon_sym___thiscall] = ACTIONS(3170),
    [anon_sym___vectorcall] = ACTIONS(3170),
    [anon_sym_LBRACE] = ACTIONS(3172),
    [anon_sym_signed] = ACTIONS(3170),
    [anon_sym_unsigned] = ACTIONS(3170),
    [anon_sym_long] = ACTIONS(3170),
    [anon_sym_short] = ACTIONS(3170),
    [anon_sym_LBRACK] = ACTIONS(3170),
    [anon_sym_static] = ACTIONS(3170),
    [anon_sym_register] = ACTIONS(3170),
    [anon_sym_inline] = ACTIONS(3170),
    [anon_sym___inline] = ACTIONS(3170),
    [anon_sym___inline__] = ACTIONS(3170),
    [anon_sym___forceinline] = ACTIONS(3170),
    [anon_sym_thread_local] = ACTIONS(3170),
    [anon_sym___thread] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3170),
    [anon_sym_constexpr] = ACTIONS(3170),
    [anon_sym_volatile] = ACTIONS(3170),
    [anon_sym_restrict] = ACTIONS(3170),
    [anon_sym___restrict__] = ACTIONS(3170),
    [anon_sym__Atomic] = ACTIONS(3170),
    [anon_sym__Noreturn] = ACTIONS(3170),
    [anon_sym_noreturn] = ACTIONS(3170),
    [anon_sym__Nonnull] = ACTIONS(3170),
    [anon_sym_mutable] = ACTIONS(3170),
    [anon_sym_constinit] = ACTIONS(3170),
    [anon_sym_consteval] = ACTIONS(3170),
    [anon_sym_alignas] = ACTIONS(3170),
    [anon_sym__Alignas] = ACTIONS(3170),
    [sym_primitive_type] = ACTIONS(3170),
    [anon_sym_enum] = ACTIONS(3170),
    [anon_sym_class] = ACTIONS(3170),
    [anon_sym_struct] = ACTIONS(3170),
    [anon_sym_union] = ACTIONS(3170),
    [anon_sym_if] = ACTIONS(3170),
    [anon_sym_switch] = ACTIONS(3170),
    [anon_sym_case] = ACTIONS(3170),
    [anon_sym_default] = ACTIONS(3170),
    [anon_sym_while] = ACTIONS(3170),
    [anon_sym_do] = ACTIONS(3170),
    [anon_sym_for] = ACTIONS(3170),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_break] = ACTIONS(3170),
    [anon_sym_continue] = ACTIONS(3170),
    [anon_sym_goto] = ACTIONS(3170),
    [anon_sym___try] = ACTIONS(3170),
    [anon_sym___leave] = ACTIONS(3170),
    [anon_sym_not] = ACTIONS(3170),
    [anon_sym_compl] = ACTIONS(3170),
    [anon_sym_DASH_DASH] = ACTIONS(3172),
    [anon_sym_PLUS_PLUS] = ACTIONS(3172),
    [anon_sym_sizeof] = ACTIONS(3170),
    [anon_sym___alignof__] = ACTIONS(3170),
    [anon_sym___alignof] = ACTIONS(3170),
    [anon_sym__alignof] = ACTIONS(3170),
    [anon_sym_alignof] = ACTIONS(3170),
    [anon_sym__Alignof] = ACTIONS(3170),
    [anon_sym_offsetof] = ACTIONS(3170),
    [anon_sym__Generic] = ACTIONS(3170),
    [anon_sym_asm] = ACTIONS(3170),
    [anon_sym___asm__] = ACTIONS(3170),
    [anon_sym___asm] = ACTIONS(3170),
    [sym_number_literal] = ACTIONS(3172),
    [anon_sym_L_SQUOTE] = ACTIONS(3172),
    [anon_sym_u_SQUOTE] = ACTIONS(3172),
    [anon_sym_U_SQUOTE] = ACTIONS(3172),
    [anon_sym_u8_SQUOTE] = ACTIONS(3172),
    [anon_sym_SQUOTE] = ACTIONS(3172),
    [anon_sym_L_DQUOTE] = ACTIONS(3172),
    [anon_sym_u_DQUOTE] = ACTIONS(3172),
    [anon_sym_U_DQUOTE] = ACTIONS(3172),
    [anon_sym_u8_DQUOTE] = ACTIONS(3172),
    [anon_sym_DQUOTE] = ACTIONS(3172),
    [sym_true] = ACTIONS(3170),
    [sym_false] = ACTIONS(3170),
    [anon_sym_NULL] = ACTIONS(3170),
    [anon_sym_nullptr] = ACTIONS(3170),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3170),
    [anon_sym_decltype] = ACTIONS(3170),
    [anon_sym_explicit] = ACTIONS(3170),
    [anon_sym_typename] = ACTIONS(3170),
    [anon_sym_template] = ACTIONS(3170),
    [anon_sym_operator] = ACTIONS(3170),
    [anon_sym_try] = ACTIONS(3170),
    [anon_sym_delete] = ACTIONS(3170),
    [anon_sym_throw] = ACTIONS(3170),
    [anon_sym_namespace] = ACTIONS(3170),
    [anon_sym_using] = ACTIONS(3170),
    [anon_sym_static_assert] = ACTIONS(3170),
    [anon_sym_concept] = ACTIONS(3170),
    [anon_sym_co_return] = ACTIONS(3170),
    [anon_sym_co_yield] = ACTIONS(3170),
    [anon_sym_R_DQUOTE] = ACTIONS(3172),
    [anon_sym_LR_DQUOTE] = ACTIONS(3172),
    [anon_sym_uR_DQUOTE] = ACTIONS(3172),
    [anon_sym_UR_DQUOTE] = ACTIONS(3172),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3172),
    [anon_sym_co_await] = ACTIONS(3170),
    [anon_sym_new] = ACTIONS(3170),
    [anon_sym_requires] = ACTIONS(3170),
    [sym_this] = ACTIONS(3170),
  },
  [368] = {
    [sym_catch_clause] = STATE(314),
    [aux_sym_constructor_try_statement_repeat1] = STATE(314),
    [sym_identifier] = ACTIONS(2553),
    [aux_sym_preproc_include_token1] = ACTIONS(2553),
    [aux_sym_preproc_def_token1] = ACTIONS(2553),
    [aux_sym_preproc_if_token1] = ACTIONS(2553),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2553),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2553),
    [sym_preproc_directive] = ACTIONS(2553),
    [anon_sym_LPAREN2] = ACTIONS(2555),
    [anon_sym_BANG] = ACTIONS(2555),
    [anon_sym_TILDE] = ACTIONS(2555),
    [anon_sym_DASH] = ACTIONS(2553),
    [anon_sym_PLUS] = ACTIONS(2553),
    [anon_sym_STAR] = ACTIONS(2555),
    [anon_sym_AMP_AMP] = ACTIONS(2555),
    [anon_sym_AMP] = ACTIONS(2553),
    [anon_sym_SEMI] = ACTIONS(2555),
    [anon_sym___extension__] = ACTIONS(2553),
    [anon_sym_typedef] = ACTIONS(2553),
    [anon_sym_virtual] = ACTIONS(2553),
    [anon_sym_extern] = ACTIONS(2553),
    [anon_sym___attribute__] = ACTIONS(2553),
    [anon_sym___attribute] = ACTIONS(2553),
    [anon_sym_COLON_COLON] = ACTIONS(2555),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2555),
    [anon_sym___declspec] = ACTIONS(2553),
    [anon_sym___based] = ACTIONS(2553),
    [anon_sym___cdecl] = ACTIONS(2553),
    [anon_sym___clrcall] = ACTIONS(2553),
    [anon_sym___stdcall] = ACTIONS(2553),
    [anon_sym___fastcall] = ACTIONS(2553),
    [anon_sym___thiscall] = ACTIONS(2553),
    [anon_sym___vectorcall] = ACTIONS(2553),
    [anon_sym_LBRACE] = ACTIONS(2555),
    [anon_sym_RBRACE] = ACTIONS(2555),
    [anon_sym_signed] = ACTIONS(2553),
    [anon_sym_unsigned] = ACTIONS(2553),
    [anon_sym_long] = ACTIONS(2553),
    [anon_sym_short] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(2553),
    [anon_sym_static] = ACTIONS(2553),
    [anon_sym_register] = ACTIONS(2553),
    [anon_sym_inline] = ACTIONS(2553),
    [anon_sym___inline] = ACTIONS(2553),
    [anon_sym___inline__] = ACTIONS(2553),
    [anon_sym___forceinline] = ACTIONS(2553),
    [anon_sym_thread_local] = ACTIONS(2553),
    [anon_sym___thread] = ACTIONS(2553),
    [anon_sym_const] = ACTIONS(2553),
    [anon_sym_constexpr] = ACTIONS(2553),
    [anon_sym_volatile] = ACTIONS(2553),
    [anon_sym_restrict] = ACTIONS(2553),
    [anon_sym___restrict__] = ACTIONS(2553),
    [anon_sym__Atomic] = ACTIONS(2553),
    [anon_sym__Noreturn] = ACTIONS(2553),
    [anon_sym_noreturn] = ACTIONS(2553),
    [anon_sym__Nonnull] = ACTIONS(2553),
    [anon_sym_mutable] = ACTIONS(2553),
    [anon_sym_constinit] = ACTIONS(2553),
    [anon_sym_consteval] = ACTIONS(2553),
    [anon_sym_alignas] = ACTIONS(2553),
    [anon_sym__Alignas] = ACTIONS(2553),
    [sym_primitive_type] = ACTIONS(2553),
    [anon_sym_enum] = ACTIONS(2553),
    [anon_sym_class] = ACTIONS(2553),
    [anon_sym_struct] = ACTIONS(2553),
    [anon_sym_union] = ACTIONS(2553),
    [anon_sym_if] = ACTIONS(2553),
    [anon_sym_switch] = ACTIONS(2553),
    [anon_sym_case] = ACTIONS(2553),
    [anon_sym_default] = ACTIONS(2553),
    [anon_sym_while] = ACTIONS(2553),
    [anon_sym_do] = ACTIONS(2553),
    [anon_sym_for] = ACTIONS(2553),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_break] = ACTIONS(2553),
    [anon_sym_continue] = ACTIONS(2553),
    [anon_sym_goto] = ACTIONS(2553),
    [anon_sym___try] = ACTIONS(2553),
    [anon_sym___leave] = ACTIONS(2553),
    [anon_sym_not] = ACTIONS(2553),
    [anon_sym_compl] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(2555),
    [anon_sym_PLUS_PLUS] = ACTIONS(2555),
    [anon_sym_sizeof] = ACTIONS(2553),
    [anon_sym___alignof__] = ACTIONS(2553),
    [anon_sym___alignof] = ACTIONS(2553),
    [anon_sym__alignof] = ACTIONS(2553),
    [anon_sym_alignof] = ACTIONS(2553),
    [anon_sym__Alignof] = ACTIONS(2553),
    [anon_sym_offsetof] = ACTIONS(2553),
    [anon_sym__Generic] = ACTIONS(2553),
    [anon_sym_asm] = ACTIONS(2553),
    [anon_sym___asm__] = ACTIONS(2553),
    [anon_sym___asm] = ACTIONS(2553),
    [sym_number_literal] = ACTIONS(2555),
    [anon_sym_L_SQUOTE] = ACTIONS(2555),
    [anon_sym_u_SQUOTE] = ACTIONS(2555),
    [anon_sym_U_SQUOTE] = ACTIONS(2555),
    [anon_sym_u8_SQUOTE] = ACTIONS(2555),
    [anon_sym_SQUOTE] = ACTIONS(2555),
    [anon_sym_L_DQUOTE] = ACTIONS(2555),
    [anon_sym_u_DQUOTE] = ACTIONS(2555),
    [anon_sym_U_DQUOTE] = ACTIONS(2555),
    [anon_sym_u8_DQUOTE] = ACTIONS(2555),
    [anon_sym_DQUOTE] = ACTIONS(2555),
    [sym_true] = ACTIONS(2553),
    [sym_false] = ACTIONS(2553),
    [anon_sym_NULL] = ACTIONS(2553),
    [anon_sym_nullptr] = ACTIONS(2553),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2553),
    [anon_sym_decltype] = ACTIONS(2553),
    [anon_sym_explicit] = ACTIONS(2553),
    [anon_sym_typename] = ACTIONS(2553),
    [anon_sym_template] = ACTIONS(2553),
    [anon_sym_operator] = ACTIONS(2553),
    [anon_sym_try] = ACTIONS(2553),
    [anon_sym_delete] = ACTIONS(2553),
    [anon_sym_throw] = ACTIONS(2553),
    [anon_sym_namespace] = ACTIONS(2553),
    [anon_sym_using] = ACTIONS(2553),
    [anon_sym_static_assert] = ACTIONS(2553),
    [anon_sym_concept] = ACTIONS(2553),
    [anon_sym_co_return] = ACTIONS(2553),
    [anon_sym_co_yield] = ACTIONS(2553),
    [anon_sym_catch] = ACTIONS(3136),
    [anon_sym_R_DQUOTE] = ACTIONS(2555),
    [anon_sym_LR_DQUOTE] = ACTIONS(2555),
    [anon_sym_uR_DQUOTE] = ACTIONS(2555),
    [anon_sym_UR_DQUOTE] = ACTIONS(2555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2555),
    [anon_sym_co_await] = ACTIONS(2553),
    [anon_sym_new] = ACTIONS(2553),
    [anon_sym_requires] = ACTIONS(2553),
    [sym_this] = ACTIONS(2553),
  },
  [369] = {
    [sym_preproc_def] = STATE(372),
    [sym_preproc_function_def] = STATE(372),
    [sym_preproc_call] = STATE(372),
    [sym_preproc_if_in_field_declaration_list] = STATE(372),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(372),
    [sym_preproc_else_in_field_declaration_list] = STATE(7845),
    [sym_preproc_elif_in_field_declaration_list] = STATE(7845),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(7845),
    [sym_type_definition] = STATE(372),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(5496),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6181),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__field_declaration_list_item] = STATE(372),
    [sym_field_declaration] = STATE(372),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1743),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(372),
    [sym_operator_cast] = STATE(6702),
    [sym_inline_method_definition] = STATE(372),
    [sym__constructor_specifiers] = STATE(1743),
    [sym_operator_cast_definition] = STATE(372),
    [sym_operator_cast_declaration] = STATE(372),
    [sym_constructor_or_destructor_definition] = STATE(372),
    [sym_constructor_or_destructor_declaration] = STATE(372),
    [sym_friend_declaration] = STATE(372),
    [sym_access_specifier] = STATE(7776),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_using_declaration] = STATE(372),
    [sym_alias_declaration] = STATE(372),
    [sym_static_assert_declaration] = STATE(372),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5383),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6702),
    [sym_operator_name] = STATE(5896),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(372),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2008),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1743),
    [sym_identifier] = ACTIONS(3174),
    [aux_sym_preproc_def_token1] = ACTIONS(3176),
    [aux_sym_preproc_if_token1] = ACTIONS(3178),
    [aux_sym_preproc_if_token2] = ACTIONS(3180),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3182),
    [aux_sym_preproc_else_token1] = ACTIONS(3184),
    [aux_sym_preproc_elif_token1] = ACTIONS(3186),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3188),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3188),
    [sym_preproc_directive] = ACTIONS(3190),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3200),
    [anon_sym___extension__] = ACTIONS(3202),
    [anon_sym_typedef] = ACTIONS(3204),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(3210),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3216),
    [anon_sym_struct] = ACTIONS(3218),
    [anon_sym_union] = ACTIONS(3220),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3222),
    [anon_sym_template] = ACTIONS(3224),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3226),
    [anon_sym_public] = ACTIONS(3228),
    [anon_sym_private] = ACTIONS(3228),
    [anon_sym_protected] = ACTIONS(3228),
    [anon_sym_using] = ACTIONS(3230),
    [anon_sym_static_assert] = ACTIONS(3232),
  },
  [370] = {
    [sym_preproc_def] = STATE(386),
    [sym_preproc_function_def] = STATE(386),
    [sym_preproc_call] = STATE(386),
    [sym_preproc_if_in_field_declaration_list] = STATE(386),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(386),
    [sym_preproc_else_in_field_declaration_list] = STATE(7916),
    [sym_preproc_elif_in_field_declaration_list] = STATE(7916),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(7916),
    [sym_type_definition] = STATE(386),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(5496),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6181),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__field_declaration_list_item] = STATE(386),
    [sym_field_declaration] = STATE(386),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1743),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(386),
    [sym_operator_cast] = STATE(6702),
    [sym_inline_method_definition] = STATE(386),
    [sym__constructor_specifiers] = STATE(1743),
    [sym_operator_cast_definition] = STATE(386),
    [sym_operator_cast_declaration] = STATE(386),
    [sym_constructor_or_destructor_definition] = STATE(386),
    [sym_constructor_or_destructor_declaration] = STATE(386),
    [sym_friend_declaration] = STATE(386),
    [sym_access_specifier] = STATE(7776),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_using_declaration] = STATE(386),
    [sym_alias_declaration] = STATE(386),
    [sym_static_assert_declaration] = STATE(386),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5383),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6702),
    [sym_operator_name] = STATE(5896),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(386),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2008),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1743),
    [sym_identifier] = ACTIONS(3174),
    [aux_sym_preproc_def_token1] = ACTIONS(3176),
    [aux_sym_preproc_if_token1] = ACTIONS(3178),
    [aux_sym_preproc_if_token2] = ACTIONS(3234),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3182),
    [aux_sym_preproc_else_token1] = ACTIONS(3184),
    [aux_sym_preproc_elif_token1] = ACTIONS(3186),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3188),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3188),
    [sym_preproc_directive] = ACTIONS(3190),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3236),
    [anon_sym___extension__] = ACTIONS(3202),
    [anon_sym_typedef] = ACTIONS(3204),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(3210),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3216),
    [anon_sym_struct] = ACTIONS(3218),
    [anon_sym_union] = ACTIONS(3220),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3222),
    [anon_sym_template] = ACTIONS(3224),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3226),
    [anon_sym_public] = ACTIONS(3228),
    [anon_sym_private] = ACTIONS(3228),
    [anon_sym_protected] = ACTIONS(3228),
    [anon_sym_using] = ACTIONS(3230),
    [anon_sym_static_assert] = ACTIONS(3232),
  },
  [371] = {
    [sym_preproc_def] = STATE(373),
    [sym_preproc_function_def] = STATE(373),
    [sym_preproc_call] = STATE(373),
    [sym_preproc_if_in_field_declaration_list] = STATE(373),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(373),
    [sym_preproc_else_in_field_declaration_list] = STATE(8191),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8191),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8191),
    [sym_type_definition] = STATE(373),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(5496),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6181),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__field_declaration_list_item] = STATE(373),
    [sym_field_declaration] = STATE(373),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1743),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(373),
    [sym_operator_cast] = STATE(6702),
    [sym_inline_method_definition] = STATE(373),
    [sym__constructor_specifiers] = STATE(1743),
    [sym_operator_cast_definition] = STATE(373),
    [sym_operator_cast_declaration] = STATE(373),
    [sym_constructor_or_destructor_definition] = STATE(373),
    [sym_constructor_or_destructor_declaration] = STATE(373),
    [sym_friend_declaration] = STATE(373),
    [sym_access_specifier] = STATE(7776),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_using_declaration] = STATE(373),
    [sym_alias_declaration] = STATE(373),
    [sym_static_assert_declaration] = STATE(373),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5383),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6702),
    [sym_operator_name] = STATE(5896),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(373),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2008),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1743),
    [sym_identifier] = ACTIONS(3174),
    [aux_sym_preproc_def_token1] = ACTIONS(3176),
    [aux_sym_preproc_if_token1] = ACTIONS(3178),
    [aux_sym_preproc_if_token2] = ACTIONS(3238),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3182),
    [aux_sym_preproc_else_token1] = ACTIONS(3184),
    [aux_sym_preproc_elif_token1] = ACTIONS(3186),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3188),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3188),
    [sym_preproc_directive] = ACTIONS(3190),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3240),
    [anon_sym___extension__] = ACTIONS(3202),
    [anon_sym_typedef] = ACTIONS(3204),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(3210),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3216),
    [anon_sym_struct] = ACTIONS(3218),
    [anon_sym_union] = ACTIONS(3220),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3222),
    [anon_sym_template] = ACTIONS(3224),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3226),
    [anon_sym_public] = ACTIONS(3228),
    [anon_sym_private] = ACTIONS(3228),
    [anon_sym_protected] = ACTIONS(3228),
    [anon_sym_using] = ACTIONS(3230),
    [anon_sym_static_assert] = ACTIONS(3232),
  },
  [372] = {
    [sym_preproc_def] = STATE(598),
    [sym_preproc_function_def] = STATE(598),
    [sym_preproc_call] = STATE(598),
    [sym_preproc_if_in_field_declaration_list] = STATE(598),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(598),
    [sym_preproc_else_in_field_declaration_list] = STATE(7795),
    [sym_preproc_elif_in_field_declaration_list] = STATE(7795),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(7795),
    [sym_type_definition] = STATE(598),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(5496),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6181),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__field_declaration_list_item] = STATE(598),
    [sym_field_declaration] = STATE(598),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1743),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(598),
    [sym_operator_cast] = STATE(6702),
    [sym_inline_method_definition] = STATE(598),
    [sym__constructor_specifiers] = STATE(1743),
    [sym_operator_cast_definition] = STATE(598),
    [sym_operator_cast_declaration] = STATE(598),
    [sym_constructor_or_destructor_definition] = STATE(598),
    [sym_constructor_or_destructor_declaration] = STATE(598),
    [sym_friend_declaration] = STATE(598),
    [sym_access_specifier] = STATE(7776),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_using_declaration] = STATE(598),
    [sym_alias_declaration] = STATE(598),
    [sym_static_assert_declaration] = STATE(598),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5383),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6702),
    [sym_operator_name] = STATE(5896),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(598),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2008),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1743),
    [sym_identifier] = ACTIONS(3174),
    [aux_sym_preproc_def_token1] = ACTIONS(3176),
    [aux_sym_preproc_if_token1] = ACTIONS(3178),
    [aux_sym_preproc_if_token2] = ACTIONS(3242),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3182),
    [aux_sym_preproc_else_token1] = ACTIONS(3184),
    [aux_sym_preproc_elif_token1] = ACTIONS(3186),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3188),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3188),
    [sym_preproc_directive] = ACTIONS(3190),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3244),
    [anon_sym___extension__] = ACTIONS(3202),
    [anon_sym_typedef] = ACTIONS(3204),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(3210),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3216),
    [anon_sym_struct] = ACTIONS(3218),
    [anon_sym_union] = ACTIONS(3220),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3222),
    [anon_sym_template] = ACTIONS(3224),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3226),
    [anon_sym_public] = ACTIONS(3228),
    [anon_sym_private] = ACTIONS(3228),
    [anon_sym_protected] = ACTIONS(3228),
    [anon_sym_using] = ACTIONS(3230),
    [anon_sym_static_assert] = ACTIONS(3232),
  },
  [373] = {
    [sym_preproc_def] = STATE(598),
    [sym_preproc_function_def] = STATE(598),
    [sym_preproc_call] = STATE(598),
    [sym_preproc_if_in_field_declaration_list] = STATE(598),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(598),
    [sym_preproc_else_in_field_declaration_list] = STATE(8148),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8148),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8148),
    [sym_type_definition] = STATE(598),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(5496),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6181),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__field_declaration_list_item] = STATE(598),
    [sym_field_declaration] = STATE(598),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1743),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(598),
    [sym_operator_cast] = STATE(6702),
    [sym_inline_method_definition] = STATE(598),
    [sym__constructor_specifiers] = STATE(1743),
    [sym_operator_cast_definition] = STATE(598),
    [sym_operator_cast_declaration] = STATE(598),
    [sym_constructor_or_destructor_definition] = STATE(598),
    [sym_constructor_or_destructor_declaration] = STATE(598),
    [sym_friend_declaration] = STATE(598),
    [sym_access_specifier] = STATE(7776),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_using_declaration] = STATE(598),
    [sym_alias_declaration] = STATE(598),
    [sym_static_assert_declaration] = STATE(598),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5383),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6702),
    [sym_operator_name] = STATE(5896),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(598),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2008),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1743),
    [sym_identifier] = ACTIONS(3174),
    [aux_sym_preproc_def_token1] = ACTIONS(3176),
    [aux_sym_preproc_if_token1] = ACTIONS(3178),
    [aux_sym_preproc_if_token2] = ACTIONS(3246),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3182),
    [aux_sym_preproc_else_token1] = ACTIONS(3184),
    [aux_sym_preproc_elif_token1] = ACTIONS(3186),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3188),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3188),
    [sym_preproc_directive] = ACTIONS(3190),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3244),
    [anon_sym___extension__] = ACTIONS(3202),
    [anon_sym_typedef] = ACTIONS(3204),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(3210),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3216),
    [anon_sym_struct] = ACTIONS(3218),
    [anon_sym_union] = ACTIONS(3220),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3222),
    [anon_sym_template] = ACTIONS(3224),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3226),
    [anon_sym_public] = ACTIONS(3228),
    [anon_sym_private] = ACTIONS(3228),
    [anon_sym_protected] = ACTIONS(3228),
    [anon_sym_using] = ACTIONS(3230),
    [anon_sym_static_assert] = ACTIONS(3232),
  },
  [374] = {
    [sym_expression] = STATE(4247),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(2514),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2531),
    [anon_sym_typedef] = ACTIONS(3248),
    [anon_sym_virtual] = ACTIONS(2536),
    [anon_sym_extern] = ACTIONS(2536),
    [anon_sym___attribute__] = ACTIONS(2536),
    [anon_sym___attribute] = ACTIONS(2536),
    [anon_sym_COLON_COLON] = ACTIONS(2538),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2526),
    [anon_sym___declspec] = ACTIONS(2536),
    [anon_sym_signed] = ACTIONS(2536),
    [anon_sym_unsigned] = ACTIONS(2536),
    [anon_sym_long] = ACTIONS(2536),
    [anon_sym_short] = ACTIONS(2536),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(2536),
    [anon_sym_register] = ACTIONS(2536),
    [anon_sym_inline] = ACTIONS(2536),
    [anon_sym___inline] = ACTIONS(2536),
    [anon_sym___inline__] = ACTIONS(2536),
    [anon_sym___forceinline] = ACTIONS(2536),
    [anon_sym_thread_local] = ACTIONS(2536),
    [anon_sym___thread] = ACTIONS(2536),
    [anon_sym_const] = ACTIONS(2536),
    [anon_sym_constexpr] = ACTIONS(2536),
    [anon_sym_volatile] = ACTIONS(2536),
    [anon_sym_restrict] = ACTIONS(2536),
    [anon_sym___restrict__] = ACTIONS(2536),
    [anon_sym__Atomic] = ACTIONS(2536),
    [anon_sym__Noreturn] = ACTIONS(2536),
    [anon_sym_noreturn] = ACTIONS(2536),
    [anon_sym__Nonnull] = ACTIONS(2536),
    [anon_sym_mutable] = ACTIONS(2536),
    [anon_sym_constinit] = ACTIONS(2536),
    [anon_sym_consteval] = ACTIONS(2536),
    [anon_sym_alignas] = ACTIONS(2536),
    [anon_sym__Alignas] = ACTIONS(2536),
    [sym_primitive_type] = ACTIONS(2544),
    [anon_sym_enum] = ACTIONS(2536),
    [anon_sym_class] = ACTIONS(2536),
    [anon_sym_struct] = ACTIONS(2536),
    [anon_sym_union] = ACTIONS(2536),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2536),
    [anon_sym_decltype] = ACTIONS(2547),
    [anon_sym_typename] = ACTIONS(2536),
    [anon_sym_template] = ACTIONS(2550),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [375] = {
    [sym_type_qualifier] = STATE(3798),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4559),
    [sym_sized_type_specifier] = STATE(2651),
    [sym_enum_specifier] = STATE(2651),
    [sym_struct_specifier] = STATE(2651),
    [sym_union_specifier] = STATE(2651),
    [sym_expression] = STATE(4506),
    [sym__string] = STATE(4637),
    [sym_conditional_expression] = STATE(4735),
    [sym_assignment_expression] = STATE(4735),
    [sym_pointer_expression] = STATE(3573),
    [sym_unary_expression] = STATE(4735),
    [sym_binary_expression] = STATE(4735),
    [sym_update_expression] = STATE(4735),
    [sym_cast_expression] = STATE(4735),
    [sym_type_descriptor] = STATE(7335),
    [sym_sizeof_expression] = STATE(4735),
    [sym_alignof_expression] = STATE(4735),
    [sym_offsetof_expression] = STATE(4735),
    [sym_generic_expression] = STATE(4735),
    [sym_subscript_expression] = STATE(3573),
    [sym_call_expression] = STATE(3573),
    [sym_gnu_asm_expression] = STATE(4735),
    [sym_extension_expression] = STATE(4735),
    [sym_field_expression] = STATE(3573),
    [sym_compound_literal_expression] = STATE(4735),
    [sym_parenthesized_expression] = STATE(3573),
    [sym_char_literal] = STATE(4637),
    [sym_concatenated_string] = STATE(4637),
    [sym_string_literal] = STATE(3662),
    [sym_null] = STATE(4735),
    [sym_placeholder_type_specifier] = STATE(2651),
    [sym_decltype_auto] = STATE(2637),
    [sym_decltype] = STATE(2563),
    [sym_class_specifier] = STATE(2651),
    [sym__class_name] = STATE(7513),
    [sym_dependent_type] = STATE(2651),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(4735),
    [sym_raw_string_literal] = STATE(3662),
    [sym_co_await_expression] = STATE(4735),
    [sym_new_expression] = STATE(4735),
    [sym_delete_expression] = STATE(4735),
    [sym_requires_clause] = STATE(4735),
    [sym_requires_expression] = STATE(4735),
    [sym_lambda_expression] = STATE(4735),
    [sym_lambda_capture_specifier] = STATE(5854),
    [sym_fold_expression] = STATE(4735),
    [sym_parameter_pack_expansion] = STATE(4735),
    [sym_type_parameter_pack_expansion] = STATE(7675),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5693),
    [sym_qualified_identifier] = STATE(3573),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym_user_defined_literal] = STATE(3573),
    [aux_sym__type_definition_type_repeat1] = STATE(3798),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4167),
    [sym_identifier] = ACTIONS(2854),
    [anon_sym_LPAREN2] = ACTIONS(2856),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(2864),
    [anon_sym_COLON_COLON] = ACTIONS(2866),
    [anon_sym_signed] = ACTIONS(2868),
    [anon_sym_unsigned] = ACTIONS(2868),
    [anon_sym_long] = ACTIONS(2868),
    [anon_sym_short] = ACTIONS(2868),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(2870),
    [anon_sym_enum] = ACTIONS(2872),
    [anon_sym_class] = ACTIONS(2874),
    [anon_sym_struct] = ACTIONS(2876),
    [anon_sym_union] = ACTIONS(2878),
    [anon_sym_not] = ACTIONS(2860),
    [anon_sym_compl] = ACTIONS(2860),
    [anon_sym_DASH_DASH] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(2880),
    [anon_sym_sizeof] = ACTIONS(2882),
    [anon_sym___alignof__] = ACTIONS(2884),
    [anon_sym___alignof] = ACTIONS(2884),
    [anon_sym__alignof] = ACTIONS(2884),
    [anon_sym_alignof] = ACTIONS(2884),
    [anon_sym__Alignof] = ACTIONS(2884),
    [anon_sym_offsetof] = ACTIONS(2886),
    [anon_sym__Generic] = ACTIONS(2888),
    [anon_sym_asm] = ACTIONS(2890),
    [anon_sym___asm__] = ACTIONS(2890),
    [anon_sym___asm] = ACTIONS(2890),
    [sym_number_literal] = ACTIONS(2892),
    [anon_sym_L_SQUOTE] = ACTIONS(2894),
    [anon_sym_u_SQUOTE] = ACTIONS(2894),
    [anon_sym_U_SQUOTE] = ACTIONS(2894),
    [anon_sym_u8_SQUOTE] = ACTIONS(2894),
    [anon_sym_SQUOTE] = ACTIONS(2894),
    [anon_sym_L_DQUOTE] = ACTIONS(2896),
    [anon_sym_u_DQUOTE] = ACTIONS(2896),
    [anon_sym_U_DQUOTE] = ACTIONS(2896),
    [anon_sym_u8_DQUOTE] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [anon_sym_NULL] = ACTIONS(2900),
    [anon_sym_nullptr] = ACTIONS(2900),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2902),
    [anon_sym_decltype] = ACTIONS(2904),
    [anon_sym_typename] = ACTIONS(2906),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2910),
    [anon_sym_R_DQUOTE] = ACTIONS(2912),
    [anon_sym_LR_DQUOTE] = ACTIONS(2912),
    [anon_sym_uR_DQUOTE] = ACTIONS(2912),
    [anon_sym_UR_DQUOTE] = ACTIONS(2912),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2912),
    [anon_sym_co_await] = ACTIONS(2914),
    [anon_sym_new] = ACTIONS(2916),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2898),
  },
  [376] = {
    [sym_catch_clause] = STATE(291),
    [aux_sym_constructor_try_statement_repeat1] = STATE(291),
    [sym_identifier] = ACTIONS(2510),
    [aux_sym_preproc_include_token1] = ACTIONS(2510),
    [aux_sym_preproc_def_token1] = ACTIONS(2510),
    [aux_sym_preproc_if_token1] = ACTIONS(2510),
    [aux_sym_preproc_if_token2] = ACTIONS(2510),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2510),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2510),
    [sym_preproc_directive] = ACTIONS(2510),
    [anon_sym_LPAREN2] = ACTIONS(2512),
    [anon_sym_BANG] = ACTIONS(2512),
    [anon_sym_TILDE] = ACTIONS(2512),
    [anon_sym_DASH] = ACTIONS(2510),
    [anon_sym_PLUS] = ACTIONS(2510),
    [anon_sym_STAR] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2510),
    [anon_sym_SEMI] = ACTIONS(2512),
    [anon_sym___extension__] = ACTIONS(2510),
    [anon_sym_typedef] = ACTIONS(2510),
    [anon_sym_virtual] = ACTIONS(2510),
    [anon_sym_extern] = ACTIONS(2510),
    [anon_sym___attribute__] = ACTIONS(2510),
    [anon_sym___attribute] = ACTIONS(2510),
    [anon_sym_COLON_COLON] = ACTIONS(2512),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2512),
    [anon_sym___declspec] = ACTIONS(2510),
    [anon_sym___based] = ACTIONS(2510),
    [anon_sym___cdecl] = ACTIONS(2510),
    [anon_sym___clrcall] = ACTIONS(2510),
    [anon_sym___stdcall] = ACTIONS(2510),
    [anon_sym___fastcall] = ACTIONS(2510),
    [anon_sym___thiscall] = ACTIONS(2510),
    [anon_sym___vectorcall] = ACTIONS(2510),
    [anon_sym_LBRACE] = ACTIONS(2512),
    [anon_sym_signed] = ACTIONS(2510),
    [anon_sym_unsigned] = ACTIONS(2510),
    [anon_sym_long] = ACTIONS(2510),
    [anon_sym_short] = ACTIONS(2510),
    [anon_sym_LBRACK] = ACTIONS(2510),
    [anon_sym_static] = ACTIONS(2510),
    [anon_sym_register] = ACTIONS(2510),
    [anon_sym_inline] = ACTIONS(2510),
    [anon_sym___inline] = ACTIONS(2510),
    [anon_sym___inline__] = ACTIONS(2510),
    [anon_sym___forceinline] = ACTIONS(2510),
    [anon_sym_thread_local] = ACTIONS(2510),
    [anon_sym___thread] = ACTIONS(2510),
    [anon_sym_const] = ACTIONS(2510),
    [anon_sym_constexpr] = ACTIONS(2510),
    [anon_sym_volatile] = ACTIONS(2510),
    [anon_sym_restrict] = ACTIONS(2510),
    [anon_sym___restrict__] = ACTIONS(2510),
    [anon_sym__Atomic] = ACTIONS(2510),
    [anon_sym__Noreturn] = ACTIONS(2510),
    [anon_sym_noreturn] = ACTIONS(2510),
    [anon_sym__Nonnull] = ACTIONS(2510),
    [anon_sym_mutable] = ACTIONS(2510),
    [anon_sym_constinit] = ACTIONS(2510),
    [anon_sym_consteval] = ACTIONS(2510),
    [anon_sym_alignas] = ACTIONS(2510),
    [anon_sym__Alignas] = ACTIONS(2510),
    [sym_primitive_type] = ACTIONS(2510),
    [anon_sym_enum] = ACTIONS(2510),
    [anon_sym_class] = ACTIONS(2510),
    [anon_sym_struct] = ACTIONS(2510),
    [anon_sym_union] = ACTIONS(2510),
    [anon_sym_if] = ACTIONS(2510),
    [anon_sym_switch] = ACTIONS(2510),
    [anon_sym_case] = ACTIONS(2510),
    [anon_sym_default] = ACTIONS(2510),
    [anon_sym_while] = ACTIONS(2510),
    [anon_sym_do] = ACTIONS(2510),
    [anon_sym_for] = ACTIONS(2510),
    [anon_sym_return] = ACTIONS(2510),
    [anon_sym_break] = ACTIONS(2510),
    [anon_sym_continue] = ACTIONS(2510),
    [anon_sym_goto] = ACTIONS(2510),
    [anon_sym___try] = ACTIONS(2510),
    [anon_sym___leave] = ACTIONS(2510),
    [anon_sym_not] = ACTIONS(2510),
    [anon_sym_compl] = ACTIONS(2510),
    [anon_sym_DASH_DASH] = ACTIONS(2512),
    [anon_sym_PLUS_PLUS] = ACTIONS(2512),
    [anon_sym_sizeof] = ACTIONS(2510),
    [anon_sym___alignof__] = ACTIONS(2510),
    [anon_sym___alignof] = ACTIONS(2510),
    [anon_sym__alignof] = ACTIONS(2510),
    [anon_sym_alignof] = ACTIONS(2510),
    [anon_sym__Alignof] = ACTIONS(2510),
    [anon_sym_offsetof] = ACTIONS(2510),
    [anon_sym__Generic] = ACTIONS(2510),
    [anon_sym_asm] = ACTIONS(2510),
    [anon_sym___asm__] = ACTIONS(2510),
    [anon_sym___asm] = ACTIONS(2510),
    [sym_number_literal] = ACTIONS(2512),
    [anon_sym_L_SQUOTE] = ACTIONS(2512),
    [anon_sym_u_SQUOTE] = ACTIONS(2512),
    [anon_sym_U_SQUOTE] = ACTIONS(2512),
    [anon_sym_u8_SQUOTE] = ACTIONS(2512),
    [anon_sym_SQUOTE] = ACTIONS(2512),
    [anon_sym_L_DQUOTE] = ACTIONS(2512),
    [anon_sym_u_DQUOTE] = ACTIONS(2512),
    [anon_sym_U_DQUOTE] = ACTIONS(2512),
    [anon_sym_u8_DQUOTE] = ACTIONS(2512),
    [anon_sym_DQUOTE] = ACTIONS(2512),
    [sym_true] = ACTIONS(2510),
    [sym_false] = ACTIONS(2510),
    [anon_sym_NULL] = ACTIONS(2510),
    [anon_sym_nullptr] = ACTIONS(2510),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2510),
    [anon_sym_decltype] = ACTIONS(2510),
    [anon_sym_explicit] = ACTIONS(2510),
    [anon_sym_typename] = ACTIONS(2510),
    [anon_sym_template] = ACTIONS(2510),
    [anon_sym_operator] = ACTIONS(2510),
    [anon_sym_try] = ACTIONS(2510),
    [anon_sym_delete] = ACTIONS(2510),
    [anon_sym_throw] = ACTIONS(2510),
    [anon_sym_namespace] = ACTIONS(2510),
    [anon_sym_using] = ACTIONS(2510),
    [anon_sym_static_assert] = ACTIONS(2510),
    [anon_sym_concept] = ACTIONS(2510),
    [anon_sym_co_return] = ACTIONS(2510),
    [anon_sym_co_yield] = ACTIONS(2510),
    [anon_sym_catch] = ACTIONS(2803),
    [anon_sym_R_DQUOTE] = ACTIONS(2512),
    [anon_sym_LR_DQUOTE] = ACTIONS(2512),
    [anon_sym_uR_DQUOTE] = ACTIONS(2512),
    [anon_sym_UR_DQUOTE] = ACTIONS(2512),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2512),
    [anon_sym_co_await] = ACTIONS(2510),
    [anon_sym_new] = ACTIONS(2510),
    [anon_sym_requires] = ACTIONS(2510),
    [sym_this] = ACTIONS(2510),
  },
  [377] = {
    [sym_catch_clause] = STATE(291),
    [aux_sym_constructor_try_statement_repeat1] = STATE(291),
    [sym_identifier] = ACTIONS(2553),
    [aux_sym_preproc_include_token1] = ACTIONS(2553),
    [aux_sym_preproc_def_token1] = ACTIONS(2553),
    [aux_sym_preproc_if_token1] = ACTIONS(2553),
    [aux_sym_preproc_if_token2] = ACTIONS(2553),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2553),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2553),
    [sym_preproc_directive] = ACTIONS(2553),
    [anon_sym_LPAREN2] = ACTIONS(2555),
    [anon_sym_BANG] = ACTIONS(2555),
    [anon_sym_TILDE] = ACTIONS(2555),
    [anon_sym_DASH] = ACTIONS(2553),
    [anon_sym_PLUS] = ACTIONS(2553),
    [anon_sym_STAR] = ACTIONS(2555),
    [anon_sym_AMP_AMP] = ACTIONS(2555),
    [anon_sym_AMP] = ACTIONS(2553),
    [anon_sym_SEMI] = ACTIONS(2555),
    [anon_sym___extension__] = ACTIONS(2553),
    [anon_sym_typedef] = ACTIONS(2553),
    [anon_sym_virtual] = ACTIONS(2553),
    [anon_sym_extern] = ACTIONS(2553),
    [anon_sym___attribute__] = ACTIONS(2553),
    [anon_sym___attribute] = ACTIONS(2553),
    [anon_sym_COLON_COLON] = ACTIONS(2555),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2555),
    [anon_sym___declspec] = ACTIONS(2553),
    [anon_sym___based] = ACTIONS(2553),
    [anon_sym___cdecl] = ACTIONS(2553),
    [anon_sym___clrcall] = ACTIONS(2553),
    [anon_sym___stdcall] = ACTIONS(2553),
    [anon_sym___fastcall] = ACTIONS(2553),
    [anon_sym___thiscall] = ACTIONS(2553),
    [anon_sym___vectorcall] = ACTIONS(2553),
    [anon_sym_LBRACE] = ACTIONS(2555),
    [anon_sym_signed] = ACTIONS(2553),
    [anon_sym_unsigned] = ACTIONS(2553),
    [anon_sym_long] = ACTIONS(2553),
    [anon_sym_short] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(2553),
    [anon_sym_static] = ACTIONS(2553),
    [anon_sym_register] = ACTIONS(2553),
    [anon_sym_inline] = ACTIONS(2553),
    [anon_sym___inline] = ACTIONS(2553),
    [anon_sym___inline__] = ACTIONS(2553),
    [anon_sym___forceinline] = ACTIONS(2553),
    [anon_sym_thread_local] = ACTIONS(2553),
    [anon_sym___thread] = ACTIONS(2553),
    [anon_sym_const] = ACTIONS(2553),
    [anon_sym_constexpr] = ACTIONS(2553),
    [anon_sym_volatile] = ACTIONS(2553),
    [anon_sym_restrict] = ACTIONS(2553),
    [anon_sym___restrict__] = ACTIONS(2553),
    [anon_sym__Atomic] = ACTIONS(2553),
    [anon_sym__Noreturn] = ACTIONS(2553),
    [anon_sym_noreturn] = ACTIONS(2553),
    [anon_sym__Nonnull] = ACTIONS(2553),
    [anon_sym_mutable] = ACTIONS(2553),
    [anon_sym_constinit] = ACTIONS(2553),
    [anon_sym_consteval] = ACTIONS(2553),
    [anon_sym_alignas] = ACTIONS(2553),
    [anon_sym__Alignas] = ACTIONS(2553),
    [sym_primitive_type] = ACTIONS(2553),
    [anon_sym_enum] = ACTIONS(2553),
    [anon_sym_class] = ACTIONS(2553),
    [anon_sym_struct] = ACTIONS(2553),
    [anon_sym_union] = ACTIONS(2553),
    [anon_sym_if] = ACTIONS(2553),
    [anon_sym_switch] = ACTIONS(2553),
    [anon_sym_case] = ACTIONS(2553),
    [anon_sym_default] = ACTIONS(2553),
    [anon_sym_while] = ACTIONS(2553),
    [anon_sym_do] = ACTIONS(2553),
    [anon_sym_for] = ACTIONS(2553),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_break] = ACTIONS(2553),
    [anon_sym_continue] = ACTIONS(2553),
    [anon_sym_goto] = ACTIONS(2553),
    [anon_sym___try] = ACTIONS(2553),
    [anon_sym___leave] = ACTIONS(2553),
    [anon_sym_not] = ACTIONS(2553),
    [anon_sym_compl] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(2555),
    [anon_sym_PLUS_PLUS] = ACTIONS(2555),
    [anon_sym_sizeof] = ACTIONS(2553),
    [anon_sym___alignof__] = ACTIONS(2553),
    [anon_sym___alignof] = ACTIONS(2553),
    [anon_sym__alignof] = ACTIONS(2553),
    [anon_sym_alignof] = ACTIONS(2553),
    [anon_sym__Alignof] = ACTIONS(2553),
    [anon_sym_offsetof] = ACTIONS(2553),
    [anon_sym__Generic] = ACTIONS(2553),
    [anon_sym_asm] = ACTIONS(2553),
    [anon_sym___asm__] = ACTIONS(2553),
    [anon_sym___asm] = ACTIONS(2553),
    [sym_number_literal] = ACTIONS(2555),
    [anon_sym_L_SQUOTE] = ACTIONS(2555),
    [anon_sym_u_SQUOTE] = ACTIONS(2555),
    [anon_sym_U_SQUOTE] = ACTIONS(2555),
    [anon_sym_u8_SQUOTE] = ACTIONS(2555),
    [anon_sym_SQUOTE] = ACTIONS(2555),
    [anon_sym_L_DQUOTE] = ACTIONS(2555),
    [anon_sym_u_DQUOTE] = ACTIONS(2555),
    [anon_sym_U_DQUOTE] = ACTIONS(2555),
    [anon_sym_u8_DQUOTE] = ACTIONS(2555),
    [anon_sym_DQUOTE] = ACTIONS(2555),
    [sym_true] = ACTIONS(2553),
    [sym_false] = ACTIONS(2553),
    [anon_sym_NULL] = ACTIONS(2553),
    [anon_sym_nullptr] = ACTIONS(2553),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2553),
    [anon_sym_decltype] = ACTIONS(2553),
    [anon_sym_explicit] = ACTIONS(2553),
    [anon_sym_typename] = ACTIONS(2553),
    [anon_sym_template] = ACTIONS(2553),
    [anon_sym_operator] = ACTIONS(2553),
    [anon_sym_try] = ACTIONS(2553),
    [anon_sym_delete] = ACTIONS(2553),
    [anon_sym_throw] = ACTIONS(2553),
    [anon_sym_namespace] = ACTIONS(2553),
    [anon_sym_using] = ACTIONS(2553),
    [anon_sym_static_assert] = ACTIONS(2553),
    [anon_sym_concept] = ACTIONS(2553),
    [anon_sym_co_return] = ACTIONS(2553),
    [anon_sym_co_yield] = ACTIONS(2553),
    [anon_sym_catch] = ACTIONS(2803),
    [anon_sym_R_DQUOTE] = ACTIONS(2555),
    [anon_sym_LR_DQUOTE] = ACTIONS(2555),
    [anon_sym_uR_DQUOTE] = ACTIONS(2555),
    [anon_sym_UR_DQUOTE] = ACTIONS(2555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2555),
    [anon_sym_co_await] = ACTIONS(2553),
    [anon_sym_new] = ACTIONS(2553),
    [anon_sym_requires] = ACTIONS(2553),
    [sym_this] = ACTIONS(2553),
  },
  [378] = {
    [sym_preproc_def] = STATE(389),
    [sym_preproc_function_def] = STATE(389),
    [sym_preproc_call] = STATE(389),
    [sym_preproc_if_in_field_declaration_list] = STATE(389),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(389),
    [sym_preproc_else_in_field_declaration_list] = STATE(7804),
    [sym_preproc_elif_in_field_declaration_list] = STATE(7804),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(7804),
    [sym_type_definition] = STATE(389),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(5496),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6181),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__field_declaration_list_item] = STATE(389),
    [sym_field_declaration] = STATE(389),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1743),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(389),
    [sym_operator_cast] = STATE(6702),
    [sym_inline_method_definition] = STATE(389),
    [sym__constructor_specifiers] = STATE(1743),
    [sym_operator_cast_definition] = STATE(389),
    [sym_operator_cast_declaration] = STATE(389),
    [sym_constructor_or_destructor_definition] = STATE(389),
    [sym_constructor_or_destructor_declaration] = STATE(389),
    [sym_friend_declaration] = STATE(389),
    [sym_access_specifier] = STATE(7776),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_using_declaration] = STATE(389),
    [sym_alias_declaration] = STATE(389),
    [sym_static_assert_declaration] = STATE(389),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5383),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6702),
    [sym_operator_name] = STATE(5896),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(389),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2008),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1743),
    [sym_identifier] = ACTIONS(3174),
    [aux_sym_preproc_def_token1] = ACTIONS(3176),
    [aux_sym_preproc_if_token1] = ACTIONS(3178),
    [aux_sym_preproc_if_token2] = ACTIONS(3250),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3182),
    [aux_sym_preproc_else_token1] = ACTIONS(3184),
    [aux_sym_preproc_elif_token1] = ACTIONS(3186),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3188),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3188),
    [sym_preproc_directive] = ACTIONS(3190),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3252),
    [anon_sym___extension__] = ACTIONS(3202),
    [anon_sym_typedef] = ACTIONS(3204),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(3210),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3216),
    [anon_sym_struct] = ACTIONS(3218),
    [anon_sym_union] = ACTIONS(3220),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3222),
    [anon_sym_template] = ACTIONS(3224),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3226),
    [anon_sym_public] = ACTIONS(3228),
    [anon_sym_private] = ACTIONS(3228),
    [anon_sym_protected] = ACTIONS(3228),
    [anon_sym_using] = ACTIONS(3230),
    [anon_sym_static_assert] = ACTIONS(3232),
  },
  [379] = {
    [sym_preproc_def] = STATE(396),
    [sym_preproc_function_def] = STATE(396),
    [sym_preproc_call] = STATE(396),
    [sym_preproc_if_in_field_declaration_list] = STATE(396),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(396),
    [sym_preproc_else_in_field_declaration_list] = STATE(8525),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8525),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8525),
    [sym_type_definition] = STATE(396),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(5496),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6181),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__field_declaration_list_item] = STATE(396),
    [sym_field_declaration] = STATE(396),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1743),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(396),
    [sym_operator_cast] = STATE(6702),
    [sym_inline_method_definition] = STATE(396),
    [sym__constructor_specifiers] = STATE(1743),
    [sym_operator_cast_definition] = STATE(396),
    [sym_operator_cast_declaration] = STATE(396),
    [sym_constructor_or_destructor_definition] = STATE(396),
    [sym_constructor_or_destructor_declaration] = STATE(396),
    [sym_friend_declaration] = STATE(396),
    [sym_access_specifier] = STATE(7776),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_using_declaration] = STATE(396),
    [sym_alias_declaration] = STATE(396),
    [sym_static_assert_declaration] = STATE(396),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5383),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6702),
    [sym_operator_name] = STATE(5896),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(396),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2008),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1743),
    [sym_identifier] = ACTIONS(3174),
    [aux_sym_preproc_def_token1] = ACTIONS(3176),
    [aux_sym_preproc_if_token1] = ACTIONS(3178),
    [aux_sym_preproc_if_token2] = ACTIONS(3254),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3182),
    [aux_sym_preproc_else_token1] = ACTIONS(3184),
    [aux_sym_preproc_elif_token1] = ACTIONS(3186),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3188),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3188),
    [sym_preproc_directive] = ACTIONS(3190),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3256),
    [anon_sym___extension__] = ACTIONS(3202),
    [anon_sym_typedef] = ACTIONS(3204),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(3210),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3216),
    [anon_sym_struct] = ACTIONS(3218),
    [anon_sym_union] = ACTIONS(3220),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3222),
    [anon_sym_template] = ACTIONS(3224),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3226),
    [anon_sym_public] = ACTIONS(3228),
    [anon_sym_private] = ACTIONS(3228),
    [anon_sym_protected] = ACTIONS(3228),
    [anon_sym_using] = ACTIONS(3230),
    [anon_sym_static_assert] = ACTIONS(3232),
  },
  [380] = {
    [sym_preproc_def] = STATE(384),
    [sym_preproc_function_def] = STATE(384),
    [sym_preproc_call] = STATE(384),
    [sym_preproc_if_in_field_declaration_list] = STATE(384),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(384),
    [sym_preproc_else_in_field_declaration_list] = STATE(7816),
    [sym_preproc_elif_in_field_declaration_list] = STATE(7816),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(7816),
    [sym_type_definition] = STATE(384),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(5496),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6181),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__field_declaration_list_item] = STATE(384),
    [sym_field_declaration] = STATE(384),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1743),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(384),
    [sym_operator_cast] = STATE(6702),
    [sym_inline_method_definition] = STATE(384),
    [sym__constructor_specifiers] = STATE(1743),
    [sym_operator_cast_definition] = STATE(384),
    [sym_operator_cast_declaration] = STATE(384),
    [sym_constructor_or_destructor_definition] = STATE(384),
    [sym_constructor_or_destructor_declaration] = STATE(384),
    [sym_friend_declaration] = STATE(384),
    [sym_access_specifier] = STATE(7776),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_using_declaration] = STATE(384),
    [sym_alias_declaration] = STATE(384),
    [sym_static_assert_declaration] = STATE(384),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5383),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6702),
    [sym_operator_name] = STATE(5896),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(384),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2008),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1743),
    [sym_identifier] = ACTIONS(3174),
    [aux_sym_preproc_def_token1] = ACTIONS(3176),
    [aux_sym_preproc_if_token1] = ACTIONS(3178),
    [aux_sym_preproc_if_token2] = ACTIONS(3258),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3182),
    [aux_sym_preproc_else_token1] = ACTIONS(3184),
    [aux_sym_preproc_elif_token1] = ACTIONS(3186),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3188),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3188),
    [sym_preproc_directive] = ACTIONS(3190),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3260),
    [anon_sym___extension__] = ACTIONS(3202),
    [anon_sym_typedef] = ACTIONS(3204),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(3210),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3216),
    [anon_sym_struct] = ACTIONS(3218),
    [anon_sym_union] = ACTIONS(3220),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3222),
    [anon_sym_template] = ACTIONS(3224),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3226),
    [anon_sym_public] = ACTIONS(3228),
    [anon_sym_private] = ACTIONS(3228),
    [anon_sym_protected] = ACTIONS(3228),
    [anon_sym_using] = ACTIONS(3230),
    [anon_sym_static_assert] = ACTIONS(3232),
  },
  [381] = {
    [sym_catch_clause] = STATE(314),
    [aux_sym_constructor_try_statement_repeat1] = STATE(314),
    [sym_identifier] = ACTIONS(2510),
    [aux_sym_preproc_include_token1] = ACTIONS(2510),
    [aux_sym_preproc_def_token1] = ACTIONS(2510),
    [aux_sym_preproc_if_token1] = ACTIONS(2510),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2510),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2510),
    [sym_preproc_directive] = ACTIONS(2510),
    [anon_sym_LPAREN2] = ACTIONS(2512),
    [anon_sym_BANG] = ACTIONS(2512),
    [anon_sym_TILDE] = ACTIONS(2512),
    [anon_sym_DASH] = ACTIONS(2510),
    [anon_sym_PLUS] = ACTIONS(2510),
    [anon_sym_STAR] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2510),
    [anon_sym_SEMI] = ACTIONS(2512),
    [anon_sym___extension__] = ACTIONS(2510),
    [anon_sym_typedef] = ACTIONS(2510),
    [anon_sym_virtual] = ACTIONS(2510),
    [anon_sym_extern] = ACTIONS(2510),
    [anon_sym___attribute__] = ACTIONS(2510),
    [anon_sym___attribute] = ACTIONS(2510),
    [anon_sym_COLON_COLON] = ACTIONS(2512),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2512),
    [anon_sym___declspec] = ACTIONS(2510),
    [anon_sym___based] = ACTIONS(2510),
    [anon_sym___cdecl] = ACTIONS(2510),
    [anon_sym___clrcall] = ACTIONS(2510),
    [anon_sym___stdcall] = ACTIONS(2510),
    [anon_sym___fastcall] = ACTIONS(2510),
    [anon_sym___thiscall] = ACTIONS(2510),
    [anon_sym___vectorcall] = ACTIONS(2510),
    [anon_sym_LBRACE] = ACTIONS(2512),
    [anon_sym_RBRACE] = ACTIONS(2512),
    [anon_sym_signed] = ACTIONS(2510),
    [anon_sym_unsigned] = ACTIONS(2510),
    [anon_sym_long] = ACTIONS(2510),
    [anon_sym_short] = ACTIONS(2510),
    [anon_sym_LBRACK] = ACTIONS(2510),
    [anon_sym_static] = ACTIONS(2510),
    [anon_sym_register] = ACTIONS(2510),
    [anon_sym_inline] = ACTIONS(2510),
    [anon_sym___inline] = ACTIONS(2510),
    [anon_sym___inline__] = ACTIONS(2510),
    [anon_sym___forceinline] = ACTIONS(2510),
    [anon_sym_thread_local] = ACTIONS(2510),
    [anon_sym___thread] = ACTIONS(2510),
    [anon_sym_const] = ACTIONS(2510),
    [anon_sym_constexpr] = ACTIONS(2510),
    [anon_sym_volatile] = ACTIONS(2510),
    [anon_sym_restrict] = ACTIONS(2510),
    [anon_sym___restrict__] = ACTIONS(2510),
    [anon_sym__Atomic] = ACTIONS(2510),
    [anon_sym__Noreturn] = ACTIONS(2510),
    [anon_sym_noreturn] = ACTIONS(2510),
    [anon_sym__Nonnull] = ACTIONS(2510),
    [anon_sym_mutable] = ACTIONS(2510),
    [anon_sym_constinit] = ACTIONS(2510),
    [anon_sym_consteval] = ACTIONS(2510),
    [anon_sym_alignas] = ACTIONS(2510),
    [anon_sym__Alignas] = ACTIONS(2510),
    [sym_primitive_type] = ACTIONS(2510),
    [anon_sym_enum] = ACTIONS(2510),
    [anon_sym_class] = ACTIONS(2510),
    [anon_sym_struct] = ACTIONS(2510),
    [anon_sym_union] = ACTIONS(2510),
    [anon_sym_if] = ACTIONS(2510),
    [anon_sym_switch] = ACTIONS(2510),
    [anon_sym_case] = ACTIONS(2510),
    [anon_sym_default] = ACTIONS(2510),
    [anon_sym_while] = ACTIONS(2510),
    [anon_sym_do] = ACTIONS(2510),
    [anon_sym_for] = ACTIONS(2510),
    [anon_sym_return] = ACTIONS(2510),
    [anon_sym_break] = ACTIONS(2510),
    [anon_sym_continue] = ACTIONS(2510),
    [anon_sym_goto] = ACTIONS(2510),
    [anon_sym___try] = ACTIONS(2510),
    [anon_sym___leave] = ACTIONS(2510),
    [anon_sym_not] = ACTIONS(2510),
    [anon_sym_compl] = ACTIONS(2510),
    [anon_sym_DASH_DASH] = ACTIONS(2512),
    [anon_sym_PLUS_PLUS] = ACTIONS(2512),
    [anon_sym_sizeof] = ACTIONS(2510),
    [anon_sym___alignof__] = ACTIONS(2510),
    [anon_sym___alignof] = ACTIONS(2510),
    [anon_sym__alignof] = ACTIONS(2510),
    [anon_sym_alignof] = ACTIONS(2510),
    [anon_sym__Alignof] = ACTIONS(2510),
    [anon_sym_offsetof] = ACTIONS(2510),
    [anon_sym__Generic] = ACTIONS(2510),
    [anon_sym_asm] = ACTIONS(2510),
    [anon_sym___asm__] = ACTIONS(2510),
    [anon_sym___asm] = ACTIONS(2510),
    [sym_number_literal] = ACTIONS(2512),
    [anon_sym_L_SQUOTE] = ACTIONS(2512),
    [anon_sym_u_SQUOTE] = ACTIONS(2512),
    [anon_sym_U_SQUOTE] = ACTIONS(2512),
    [anon_sym_u8_SQUOTE] = ACTIONS(2512),
    [anon_sym_SQUOTE] = ACTIONS(2512),
    [anon_sym_L_DQUOTE] = ACTIONS(2512),
    [anon_sym_u_DQUOTE] = ACTIONS(2512),
    [anon_sym_U_DQUOTE] = ACTIONS(2512),
    [anon_sym_u8_DQUOTE] = ACTIONS(2512),
    [anon_sym_DQUOTE] = ACTIONS(2512),
    [sym_true] = ACTIONS(2510),
    [sym_false] = ACTIONS(2510),
    [anon_sym_NULL] = ACTIONS(2510),
    [anon_sym_nullptr] = ACTIONS(2510),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2510),
    [anon_sym_decltype] = ACTIONS(2510),
    [anon_sym_explicit] = ACTIONS(2510),
    [anon_sym_typename] = ACTIONS(2510),
    [anon_sym_template] = ACTIONS(2510),
    [anon_sym_operator] = ACTIONS(2510),
    [anon_sym_try] = ACTIONS(2510),
    [anon_sym_delete] = ACTIONS(2510),
    [anon_sym_throw] = ACTIONS(2510),
    [anon_sym_namespace] = ACTIONS(2510),
    [anon_sym_using] = ACTIONS(2510),
    [anon_sym_static_assert] = ACTIONS(2510),
    [anon_sym_concept] = ACTIONS(2510),
    [anon_sym_co_return] = ACTIONS(2510),
    [anon_sym_co_yield] = ACTIONS(2510),
    [anon_sym_catch] = ACTIONS(3136),
    [anon_sym_R_DQUOTE] = ACTIONS(2512),
    [anon_sym_LR_DQUOTE] = ACTIONS(2512),
    [anon_sym_uR_DQUOTE] = ACTIONS(2512),
    [anon_sym_UR_DQUOTE] = ACTIONS(2512),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2512),
    [anon_sym_co_await] = ACTIONS(2510),
    [anon_sym_new] = ACTIONS(2510),
    [anon_sym_requires] = ACTIONS(2510),
    [sym_this] = ACTIONS(2510),
  },
  [382] = {
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_unaligned_ptr_modifier] = STATE(3998),
    [sym_ms_pointer_modifier] = STATE(2929),
    [sym__declarator] = STATE(6341),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(5896),
    [sym_array_declarator] = STATE(5896),
    [sym_type_qualifier] = STATE(3884),
    [sym_alignas_qualifier] = STATE(4266),
    [sym_expression] = STATE(3125),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3182),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5649),
    [sym_qualified_identifier] = STATE(3215),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3443),
    [aux_sym__type_definition_type_repeat1] = STATE(3884),
    [aux_sym_pointer_declarator_repeat1] = STATE(2929),
    [sym_identifier] = ACTIONS(3262),
    [anon_sym_LPAREN2] = ACTIONS(1763),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1767),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1771),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(1773),
    [anon_sym___extension__] = ACTIONS(3264),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym___based] = ACTIONS(51),
    [sym_ms_restrict_modifier] = ACTIONS(3266),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(3266),
    [sym_ms_signed_ptr_modifier] = ACTIONS(3266),
    [anon_sym__unaligned] = ACTIONS(3268),
    [anon_sym___unaligned] = ACTIONS(3268),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [anon_sym_const] = ACTIONS(3270),
    [anon_sym_constexpr] = ACTIONS(3270),
    [anon_sym_volatile] = ACTIONS(3270),
    [anon_sym_restrict] = ACTIONS(3270),
    [anon_sym___restrict__] = ACTIONS(3270),
    [anon_sym__Atomic] = ACTIONS(3270),
    [anon_sym__Noreturn] = ACTIONS(3270),
    [anon_sym_noreturn] = ACTIONS(3270),
    [anon_sym__Nonnull] = ACTIONS(3270),
    [anon_sym_mutable] = ACTIONS(3270),
    [anon_sym_constinit] = ACTIONS(3270),
    [anon_sym_consteval] = ACTIONS(3270),
    [anon_sym_alignas] = ACTIONS(3272),
    [anon_sym__Alignas] = ACTIONS(3272),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_operator] = ACTIONS(1823),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [383] = {
    [sym_preproc_def] = STATE(385),
    [sym_preproc_function_def] = STATE(385),
    [sym_preproc_call] = STATE(385),
    [sym_preproc_if_in_field_declaration_list] = STATE(385),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(385),
    [sym_preproc_else_in_field_declaration_list] = STATE(7990),
    [sym_preproc_elif_in_field_declaration_list] = STATE(7990),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(7990),
    [sym_type_definition] = STATE(385),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(5496),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6181),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__field_declaration_list_item] = STATE(385),
    [sym_field_declaration] = STATE(385),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1743),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(385),
    [sym_operator_cast] = STATE(6702),
    [sym_inline_method_definition] = STATE(385),
    [sym__constructor_specifiers] = STATE(1743),
    [sym_operator_cast_definition] = STATE(385),
    [sym_operator_cast_declaration] = STATE(385),
    [sym_constructor_or_destructor_definition] = STATE(385),
    [sym_constructor_or_destructor_declaration] = STATE(385),
    [sym_friend_declaration] = STATE(385),
    [sym_access_specifier] = STATE(7776),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_using_declaration] = STATE(385),
    [sym_alias_declaration] = STATE(385),
    [sym_static_assert_declaration] = STATE(385),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5383),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6702),
    [sym_operator_name] = STATE(5896),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(385),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2008),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1743),
    [sym_identifier] = ACTIONS(3174),
    [aux_sym_preproc_def_token1] = ACTIONS(3176),
    [aux_sym_preproc_if_token1] = ACTIONS(3178),
    [aux_sym_preproc_if_token2] = ACTIONS(3274),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3182),
    [aux_sym_preproc_else_token1] = ACTIONS(3184),
    [aux_sym_preproc_elif_token1] = ACTIONS(3186),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3188),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3188),
    [sym_preproc_directive] = ACTIONS(3190),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3276),
    [anon_sym___extension__] = ACTIONS(3202),
    [anon_sym_typedef] = ACTIONS(3204),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(3210),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3216),
    [anon_sym_struct] = ACTIONS(3218),
    [anon_sym_union] = ACTIONS(3220),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3222),
    [anon_sym_template] = ACTIONS(3224),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3226),
    [anon_sym_public] = ACTIONS(3228),
    [anon_sym_private] = ACTIONS(3228),
    [anon_sym_protected] = ACTIONS(3228),
    [anon_sym_using] = ACTIONS(3230),
    [anon_sym_static_assert] = ACTIONS(3232),
  },
  [384] = {
    [sym_preproc_def] = STATE(598),
    [sym_preproc_function_def] = STATE(598),
    [sym_preproc_call] = STATE(598),
    [sym_preproc_if_in_field_declaration_list] = STATE(598),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(598),
    [sym_preproc_else_in_field_declaration_list] = STATE(8037),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8037),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8037),
    [sym_type_definition] = STATE(598),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(5496),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6181),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__field_declaration_list_item] = STATE(598),
    [sym_field_declaration] = STATE(598),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1743),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(598),
    [sym_operator_cast] = STATE(6702),
    [sym_inline_method_definition] = STATE(598),
    [sym__constructor_specifiers] = STATE(1743),
    [sym_operator_cast_definition] = STATE(598),
    [sym_operator_cast_declaration] = STATE(598),
    [sym_constructor_or_destructor_definition] = STATE(598),
    [sym_constructor_or_destructor_declaration] = STATE(598),
    [sym_friend_declaration] = STATE(598),
    [sym_access_specifier] = STATE(7776),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_using_declaration] = STATE(598),
    [sym_alias_declaration] = STATE(598),
    [sym_static_assert_declaration] = STATE(598),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5383),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6702),
    [sym_operator_name] = STATE(5896),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(598),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2008),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1743),
    [sym_identifier] = ACTIONS(3174),
    [aux_sym_preproc_def_token1] = ACTIONS(3176),
    [aux_sym_preproc_if_token1] = ACTIONS(3178),
    [aux_sym_preproc_if_token2] = ACTIONS(3278),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3182),
    [aux_sym_preproc_else_token1] = ACTIONS(3184),
    [aux_sym_preproc_elif_token1] = ACTIONS(3186),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3188),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3188),
    [sym_preproc_directive] = ACTIONS(3190),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3244),
    [anon_sym___extension__] = ACTIONS(3202),
    [anon_sym_typedef] = ACTIONS(3204),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(3210),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3216),
    [anon_sym_struct] = ACTIONS(3218),
    [anon_sym_union] = ACTIONS(3220),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3222),
    [anon_sym_template] = ACTIONS(3224),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3226),
    [anon_sym_public] = ACTIONS(3228),
    [anon_sym_private] = ACTIONS(3228),
    [anon_sym_protected] = ACTIONS(3228),
    [anon_sym_using] = ACTIONS(3230),
    [anon_sym_static_assert] = ACTIONS(3232),
  },
  [385] = {
    [sym_preproc_def] = STATE(598),
    [sym_preproc_function_def] = STATE(598),
    [sym_preproc_call] = STATE(598),
    [sym_preproc_if_in_field_declaration_list] = STATE(598),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(598),
    [sym_preproc_else_in_field_declaration_list] = STATE(8502),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8502),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8502),
    [sym_type_definition] = STATE(598),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(5496),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6181),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__field_declaration_list_item] = STATE(598),
    [sym_field_declaration] = STATE(598),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1743),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(598),
    [sym_operator_cast] = STATE(6702),
    [sym_inline_method_definition] = STATE(598),
    [sym__constructor_specifiers] = STATE(1743),
    [sym_operator_cast_definition] = STATE(598),
    [sym_operator_cast_declaration] = STATE(598),
    [sym_constructor_or_destructor_definition] = STATE(598),
    [sym_constructor_or_destructor_declaration] = STATE(598),
    [sym_friend_declaration] = STATE(598),
    [sym_access_specifier] = STATE(7776),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_using_declaration] = STATE(598),
    [sym_alias_declaration] = STATE(598),
    [sym_static_assert_declaration] = STATE(598),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5383),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6702),
    [sym_operator_name] = STATE(5896),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(598),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2008),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1743),
    [sym_identifier] = ACTIONS(3174),
    [aux_sym_preproc_def_token1] = ACTIONS(3176),
    [aux_sym_preproc_if_token1] = ACTIONS(3178),
    [aux_sym_preproc_if_token2] = ACTIONS(3280),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3182),
    [aux_sym_preproc_else_token1] = ACTIONS(3184),
    [aux_sym_preproc_elif_token1] = ACTIONS(3186),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3188),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3188),
    [sym_preproc_directive] = ACTIONS(3190),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3244),
    [anon_sym___extension__] = ACTIONS(3202),
    [anon_sym_typedef] = ACTIONS(3204),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(3210),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3216),
    [anon_sym_struct] = ACTIONS(3218),
    [anon_sym_union] = ACTIONS(3220),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3222),
    [anon_sym_template] = ACTIONS(3224),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3226),
    [anon_sym_public] = ACTIONS(3228),
    [anon_sym_private] = ACTIONS(3228),
    [anon_sym_protected] = ACTIONS(3228),
    [anon_sym_using] = ACTIONS(3230),
    [anon_sym_static_assert] = ACTIONS(3232),
  },
  [386] = {
    [sym_preproc_def] = STATE(598),
    [sym_preproc_function_def] = STATE(598),
    [sym_preproc_call] = STATE(598),
    [sym_preproc_if_in_field_declaration_list] = STATE(598),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(598),
    [sym_preproc_else_in_field_declaration_list] = STATE(8130),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8130),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8130),
    [sym_type_definition] = STATE(598),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(5496),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6181),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__field_declaration_list_item] = STATE(598),
    [sym_field_declaration] = STATE(598),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1743),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(598),
    [sym_operator_cast] = STATE(6702),
    [sym_inline_method_definition] = STATE(598),
    [sym__constructor_specifiers] = STATE(1743),
    [sym_operator_cast_definition] = STATE(598),
    [sym_operator_cast_declaration] = STATE(598),
    [sym_constructor_or_destructor_definition] = STATE(598),
    [sym_constructor_or_destructor_declaration] = STATE(598),
    [sym_friend_declaration] = STATE(598),
    [sym_access_specifier] = STATE(7776),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_using_declaration] = STATE(598),
    [sym_alias_declaration] = STATE(598),
    [sym_static_assert_declaration] = STATE(598),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5383),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6702),
    [sym_operator_name] = STATE(5896),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(598),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2008),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1743),
    [sym_identifier] = ACTIONS(3174),
    [aux_sym_preproc_def_token1] = ACTIONS(3176),
    [aux_sym_preproc_if_token1] = ACTIONS(3178),
    [aux_sym_preproc_if_token2] = ACTIONS(3282),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3182),
    [aux_sym_preproc_else_token1] = ACTIONS(3184),
    [aux_sym_preproc_elif_token1] = ACTIONS(3186),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3188),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3188),
    [sym_preproc_directive] = ACTIONS(3190),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3244),
    [anon_sym___extension__] = ACTIONS(3202),
    [anon_sym_typedef] = ACTIONS(3204),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(3210),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3216),
    [anon_sym_struct] = ACTIONS(3218),
    [anon_sym_union] = ACTIONS(3220),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3222),
    [anon_sym_template] = ACTIONS(3224),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3226),
    [anon_sym_public] = ACTIONS(3228),
    [anon_sym_private] = ACTIONS(3228),
    [anon_sym_protected] = ACTIONS(3228),
    [anon_sym_using] = ACTIONS(3230),
    [anon_sym_static_assert] = ACTIONS(3232),
  },
  [387] = {
    [sym_preproc_def] = STATE(390),
    [sym_preproc_function_def] = STATE(390),
    [sym_preproc_call] = STATE(390),
    [sym_preproc_if_in_field_declaration_list] = STATE(390),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(390),
    [sym_preproc_else_in_field_declaration_list] = STATE(7928),
    [sym_preproc_elif_in_field_declaration_list] = STATE(7928),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(7928),
    [sym_type_definition] = STATE(390),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(5496),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6181),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__field_declaration_list_item] = STATE(390),
    [sym_field_declaration] = STATE(390),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1743),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(390),
    [sym_operator_cast] = STATE(6702),
    [sym_inline_method_definition] = STATE(390),
    [sym__constructor_specifiers] = STATE(1743),
    [sym_operator_cast_definition] = STATE(390),
    [sym_operator_cast_declaration] = STATE(390),
    [sym_constructor_or_destructor_definition] = STATE(390),
    [sym_constructor_or_destructor_declaration] = STATE(390),
    [sym_friend_declaration] = STATE(390),
    [sym_access_specifier] = STATE(7776),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_using_declaration] = STATE(390),
    [sym_alias_declaration] = STATE(390),
    [sym_static_assert_declaration] = STATE(390),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5383),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6702),
    [sym_operator_name] = STATE(5896),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(390),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2008),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1743),
    [sym_identifier] = ACTIONS(3174),
    [aux_sym_preproc_def_token1] = ACTIONS(3176),
    [aux_sym_preproc_if_token1] = ACTIONS(3178),
    [aux_sym_preproc_if_token2] = ACTIONS(3284),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3182),
    [aux_sym_preproc_else_token1] = ACTIONS(3184),
    [aux_sym_preproc_elif_token1] = ACTIONS(3186),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3188),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3188),
    [sym_preproc_directive] = ACTIONS(3190),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3286),
    [anon_sym___extension__] = ACTIONS(3202),
    [anon_sym_typedef] = ACTIONS(3204),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(3210),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3216),
    [anon_sym_struct] = ACTIONS(3218),
    [anon_sym_union] = ACTIONS(3220),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3222),
    [anon_sym_template] = ACTIONS(3224),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3226),
    [anon_sym_public] = ACTIONS(3228),
    [anon_sym_private] = ACTIONS(3228),
    [anon_sym_protected] = ACTIONS(3228),
    [anon_sym_using] = ACTIONS(3230),
    [anon_sym_static_assert] = ACTIONS(3232),
  },
  [388] = {
    [sym_expression] = STATE(4247),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(2514),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2531),
    [anon_sym_typedef] = ACTIONS(2557),
    [anon_sym_virtual] = ACTIONS(2536),
    [anon_sym_extern] = ACTIONS(2536),
    [anon_sym___attribute__] = ACTIONS(2536),
    [anon_sym___attribute] = ACTIONS(2536),
    [anon_sym_COLON_COLON] = ACTIONS(2538),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2526),
    [anon_sym___declspec] = ACTIONS(2536),
    [anon_sym_signed] = ACTIONS(2536),
    [anon_sym_unsigned] = ACTIONS(2536),
    [anon_sym_long] = ACTIONS(2536),
    [anon_sym_short] = ACTIONS(2536),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(2536),
    [anon_sym_register] = ACTIONS(2536),
    [anon_sym_inline] = ACTIONS(2536),
    [anon_sym___inline] = ACTIONS(2536),
    [anon_sym___inline__] = ACTIONS(2536),
    [anon_sym___forceinline] = ACTIONS(2536),
    [anon_sym_thread_local] = ACTIONS(2536),
    [anon_sym___thread] = ACTIONS(2536),
    [anon_sym_const] = ACTIONS(2536),
    [anon_sym_constexpr] = ACTIONS(2536),
    [anon_sym_volatile] = ACTIONS(2536),
    [anon_sym_restrict] = ACTIONS(2536),
    [anon_sym___restrict__] = ACTIONS(2536),
    [anon_sym__Atomic] = ACTIONS(2536),
    [anon_sym__Noreturn] = ACTIONS(2536),
    [anon_sym_noreturn] = ACTIONS(2536),
    [anon_sym__Nonnull] = ACTIONS(2536),
    [anon_sym_mutable] = ACTIONS(2536),
    [anon_sym_constinit] = ACTIONS(2536),
    [anon_sym_consteval] = ACTIONS(2536),
    [anon_sym_alignas] = ACTIONS(2536),
    [anon_sym__Alignas] = ACTIONS(2536),
    [sym_primitive_type] = ACTIONS(2544),
    [anon_sym_enum] = ACTIONS(2536),
    [anon_sym_class] = ACTIONS(2536),
    [anon_sym_struct] = ACTIONS(2536),
    [anon_sym_union] = ACTIONS(2536),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2536),
    [anon_sym_decltype] = ACTIONS(2547),
    [anon_sym_typename] = ACTIONS(2536),
    [anon_sym_template] = ACTIONS(2550),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [389] = {
    [sym_preproc_def] = STATE(598),
    [sym_preproc_function_def] = STATE(598),
    [sym_preproc_call] = STATE(598),
    [sym_preproc_if_in_field_declaration_list] = STATE(598),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(598),
    [sym_preproc_else_in_field_declaration_list] = STATE(7932),
    [sym_preproc_elif_in_field_declaration_list] = STATE(7932),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(7932),
    [sym_type_definition] = STATE(598),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(5496),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6181),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__field_declaration_list_item] = STATE(598),
    [sym_field_declaration] = STATE(598),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1743),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(598),
    [sym_operator_cast] = STATE(6702),
    [sym_inline_method_definition] = STATE(598),
    [sym__constructor_specifiers] = STATE(1743),
    [sym_operator_cast_definition] = STATE(598),
    [sym_operator_cast_declaration] = STATE(598),
    [sym_constructor_or_destructor_definition] = STATE(598),
    [sym_constructor_or_destructor_declaration] = STATE(598),
    [sym_friend_declaration] = STATE(598),
    [sym_access_specifier] = STATE(7776),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_using_declaration] = STATE(598),
    [sym_alias_declaration] = STATE(598),
    [sym_static_assert_declaration] = STATE(598),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5383),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6702),
    [sym_operator_name] = STATE(5896),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(598),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2008),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1743),
    [sym_identifier] = ACTIONS(3174),
    [aux_sym_preproc_def_token1] = ACTIONS(3176),
    [aux_sym_preproc_if_token1] = ACTIONS(3178),
    [aux_sym_preproc_if_token2] = ACTIONS(3288),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3182),
    [aux_sym_preproc_else_token1] = ACTIONS(3184),
    [aux_sym_preproc_elif_token1] = ACTIONS(3186),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3188),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3188),
    [sym_preproc_directive] = ACTIONS(3190),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3244),
    [anon_sym___extension__] = ACTIONS(3202),
    [anon_sym_typedef] = ACTIONS(3204),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(3210),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3216),
    [anon_sym_struct] = ACTIONS(3218),
    [anon_sym_union] = ACTIONS(3220),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3222),
    [anon_sym_template] = ACTIONS(3224),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3226),
    [anon_sym_public] = ACTIONS(3228),
    [anon_sym_private] = ACTIONS(3228),
    [anon_sym_protected] = ACTIONS(3228),
    [anon_sym_using] = ACTIONS(3230),
    [anon_sym_static_assert] = ACTIONS(3232),
  },
  [390] = {
    [sym_preproc_def] = STATE(598),
    [sym_preproc_function_def] = STATE(598),
    [sym_preproc_call] = STATE(598),
    [sym_preproc_if_in_field_declaration_list] = STATE(598),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(598),
    [sym_preproc_else_in_field_declaration_list] = STATE(8531),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8531),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8531),
    [sym_type_definition] = STATE(598),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(5496),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6181),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__field_declaration_list_item] = STATE(598),
    [sym_field_declaration] = STATE(598),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1743),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(598),
    [sym_operator_cast] = STATE(6702),
    [sym_inline_method_definition] = STATE(598),
    [sym__constructor_specifiers] = STATE(1743),
    [sym_operator_cast_definition] = STATE(598),
    [sym_operator_cast_declaration] = STATE(598),
    [sym_constructor_or_destructor_definition] = STATE(598),
    [sym_constructor_or_destructor_declaration] = STATE(598),
    [sym_friend_declaration] = STATE(598),
    [sym_access_specifier] = STATE(7776),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_using_declaration] = STATE(598),
    [sym_alias_declaration] = STATE(598),
    [sym_static_assert_declaration] = STATE(598),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5383),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6702),
    [sym_operator_name] = STATE(5896),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(598),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2008),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1743),
    [sym_identifier] = ACTIONS(3174),
    [aux_sym_preproc_def_token1] = ACTIONS(3176),
    [aux_sym_preproc_if_token1] = ACTIONS(3178),
    [aux_sym_preproc_if_token2] = ACTIONS(3290),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3182),
    [aux_sym_preproc_else_token1] = ACTIONS(3184),
    [aux_sym_preproc_elif_token1] = ACTIONS(3186),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3188),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3188),
    [sym_preproc_directive] = ACTIONS(3190),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3244),
    [anon_sym___extension__] = ACTIONS(3202),
    [anon_sym_typedef] = ACTIONS(3204),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(3210),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3216),
    [anon_sym_struct] = ACTIONS(3218),
    [anon_sym_union] = ACTIONS(3220),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3222),
    [anon_sym_template] = ACTIONS(3224),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3226),
    [anon_sym_public] = ACTIONS(3228),
    [anon_sym_private] = ACTIONS(3228),
    [anon_sym_protected] = ACTIONS(3228),
    [anon_sym_using] = ACTIONS(3230),
    [anon_sym_static_assert] = ACTIONS(3232),
  },
  [391] = {
    [sym_expression] = STATE(4247),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(2514),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2531),
    [anon_sym_typedef] = ACTIONS(2534),
    [anon_sym_virtual] = ACTIONS(2536),
    [anon_sym_extern] = ACTIONS(2536),
    [anon_sym___attribute__] = ACTIONS(2536),
    [anon_sym___attribute] = ACTIONS(2536),
    [anon_sym_COLON_COLON] = ACTIONS(2538),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2526),
    [anon_sym___declspec] = ACTIONS(2536),
    [anon_sym_signed] = ACTIONS(2536),
    [anon_sym_unsigned] = ACTIONS(2536),
    [anon_sym_long] = ACTIONS(2536),
    [anon_sym_short] = ACTIONS(2536),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(2536),
    [anon_sym_register] = ACTIONS(2536),
    [anon_sym_inline] = ACTIONS(2536),
    [anon_sym___inline] = ACTIONS(2536),
    [anon_sym___inline__] = ACTIONS(2536),
    [anon_sym___forceinline] = ACTIONS(2536),
    [anon_sym_thread_local] = ACTIONS(2536),
    [anon_sym___thread] = ACTIONS(2536),
    [anon_sym_const] = ACTIONS(2536),
    [anon_sym_constexpr] = ACTIONS(2536),
    [anon_sym_volatile] = ACTIONS(2536),
    [anon_sym_restrict] = ACTIONS(2536),
    [anon_sym___restrict__] = ACTIONS(2536),
    [anon_sym__Atomic] = ACTIONS(2536),
    [anon_sym__Noreturn] = ACTIONS(2536),
    [anon_sym_noreturn] = ACTIONS(2536),
    [anon_sym__Nonnull] = ACTIONS(2536),
    [anon_sym_mutable] = ACTIONS(2536),
    [anon_sym_constinit] = ACTIONS(2536),
    [anon_sym_consteval] = ACTIONS(2536),
    [anon_sym_alignas] = ACTIONS(2536),
    [anon_sym__Alignas] = ACTIONS(2536),
    [sym_primitive_type] = ACTIONS(2544),
    [anon_sym_enum] = ACTIONS(2536),
    [anon_sym_class] = ACTIONS(2536),
    [anon_sym_struct] = ACTIONS(2536),
    [anon_sym_union] = ACTIONS(2536),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2536),
    [anon_sym_decltype] = ACTIONS(2547),
    [anon_sym_typename] = ACTIONS(2536),
    [anon_sym_template] = ACTIONS(2550),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [392] = {
    [sym_expression] = STATE(4247),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(2514),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2531),
    [anon_sym_typedef] = ACTIONS(3292),
    [anon_sym_virtual] = ACTIONS(2536),
    [anon_sym_extern] = ACTIONS(2536),
    [anon_sym___attribute__] = ACTIONS(2536),
    [anon_sym___attribute] = ACTIONS(2536),
    [anon_sym_COLON_COLON] = ACTIONS(2538),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2526),
    [anon_sym___declspec] = ACTIONS(2536),
    [anon_sym_signed] = ACTIONS(2536),
    [anon_sym_unsigned] = ACTIONS(2536),
    [anon_sym_long] = ACTIONS(2536),
    [anon_sym_short] = ACTIONS(2536),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(2536),
    [anon_sym_register] = ACTIONS(2536),
    [anon_sym_inline] = ACTIONS(2536),
    [anon_sym___inline] = ACTIONS(2536),
    [anon_sym___inline__] = ACTIONS(2536),
    [anon_sym___forceinline] = ACTIONS(2536),
    [anon_sym_thread_local] = ACTIONS(2536),
    [anon_sym___thread] = ACTIONS(2536),
    [anon_sym_const] = ACTIONS(2536),
    [anon_sym_constexpr] = ACTIONS(2536),
    [anon_sym_volatile] = ACTIONS(2536),
    [anon_sym_restrict] = ACTIONS(2536),
    [anon_sym___restrict__] = ACTIONS(2536),
    [anon_sym__Atomic] = ACTIONS(2536),
    [anon_sym__Noreturn] = ACTIONS(2536),
    [anon_sym_noreturn] = ACTIONS(2536),
    [anon_sym__Nonnull] = ACTIONS(2536),
    [anon_sym_mutable] = ACTIONS(2536),
    [anon_sym_constinit] = ACTIONS(2536),
    [anon_sym_consteval] = ACTIONS(2536),
    [anon_sym_alignas] = ACTIONS(2536),
    [anon_sym__Alignas] = ACTIONS(2536),
    [sym_primitive_type] = ACTIONS(2544),
    [anon_sym_enum] = ACTIONS(2536),
    [anon_sym_class] = ACTIONS(2536),
    [anon_sym_struct] = ACTIONS(2536),
    [anon_sym_union] = ACTIONS(2536),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2536),
    [anon_sym_decltype] = ACTIONS(2547),
    [anon_sym_typename] = ACTIONS(2536),
    [anon_sym_template] = ACTIONS(2550),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [393] = {
    [sym_expression] = STATE(4247),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(2514),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2531),
    [anon_sym_typedef] = ACTIONS(2559),
    [anon_sym_virtual] = ACTIONS(2536),
    [anon_sym_extern] = ACTIONS(2536),
    [anon_sym___attribute__] = ACTIONS(2536),
    [anon_sym___attribute] = ACTIONS(2536),
    [anon_sym_COLON_COLON] = ACTIONS(2538),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2526),
    [anon_sym___declspec] = ACTIONS(2536),
    [anon_sym_signed] = ACTIONS(2536),
    [anon_sym_unsigned] = ACTIONS(2536),
    [anon_sym_long] = ACTIONS(2536),
    [anon_sym_short] = ACTIONS(2536),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(2536),
    [anon_sym_register] = ACTIONS(2536),
    [anon_sym_inline] = ACTIONS(2536),
    [anon_sym___inline] = ACTIONS(2536),
    [anon_sym___inline__] = ACTIONS(2536),
    [anon_sym___forceinline] = ACTIONS(2536),
    [anon_sym_thread_local] = ACTIONS(2536),
    [anon_sym___thread] = ACTIONS(2536),
    [anon_sym_const] = ACTIONS(2536),
    [anon_sym_constexpr] = ACTIONS(2536),
    [anon_sym_volatile] = ACTIONS(2536),
    [anon_sym_restrict] = ACTIONS(2536),
    [anon_sym___restrict__] = ACTIONS(2536),
    [anon_sym__Atomic] = ACTIONS(2536),
    [anon_sym__Noreturn] = ACTIONS(2536),
    [anon_sym_noreturn] = ACTIONS(2536),
    [anon_sym__Nonnull] = ACTIONS(2536),
    [anon_sym_mutable] = ACTIONS(2536),
    [anon_sym_constinit] = ACTIONS(2536),
    [anon_sym_consteval] = ACTIONS(2536),
    [anon_sym_alignas] = ACTIONS(2536),
    [anon_sym__Alignas] = ACTIONS(2536),
    [sym_primitive_type] = ACTIONS(2544),
    [anon_sym_enum] = ACTIONS(2536),
    [anon_sym_class] = ACTIONS(2536),
    [anon_sym_struct] = ACTIONS(2536),
    [anon_sym_union] = ACTIONS(2536),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2536),
    [anon_sym_decltype] = ACTIONS(2547),
    [anon_sym_typename] = ACTIONS(2536),
    [anon_sym_template] = ACTIONS(2550),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [394] = {
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_unaligned_ptr_modifier] = STATE(3998),
    [sym_ms_pointer_modifier] = STATE(2929),
    [sym__declarator] = STATE(6341),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(5896),
    [sym_array_declarator] = STATE(5896),
    [sym_type_qualifier] = STATE(3884),
    [sym_alignas_qualifier] = STATE(4266),
    [sym_expression] = STATE(2342),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3298),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5556),
    [sym_qualified_identifier] = STATE(3246),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(2404),
    [aux_sym__type_definition_type_repeat1] = STATE(3884),
    [aux_sym_pointer_declarator_repeat1] = STATE(2929),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_LPAREN2] = ACTIONS(3296),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(3298),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym___extension__] = ACTIONS(3300),
    [anon_sym_COLON_COLON] = ACTIONS(1971),
    [anon_sym___based] = ACTIONS(51),
    [sym_ms_restrict_modifier] = ACTIONS(3266),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(3266),
    [sym_ms_signed_ptr_modifier] = ACTIONS(3266),
    [anon_sym__unaligned] = ACTIONS(3268),
    [anon_sym___unaligned] = ACTIONS(3268),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [anon_sym_const] = ACTIONS(3270),
    [anon_sym_constexpr] = ACTIONS(3270),
    [anon_sym_volatile] = ACTIONS(3270),
    [anon_sym_restrict] = ACTIONS(3270),
    [anon_sym___restrict__] = ACTIONS(3270),
    [anon_sym__Atomic] = ACTIONS(3270),
    [anon_sym__Noreturn] = ACTIONS(3270),
    [anon_sym_noreturn] = ACTIONS(3270),
    [anon_sym__Nonnull] = ACTIONS(3270),
    [anon_sym_mutable] = ACTIONS(3270),
    [anon_sym_constinit] = ACTIONS(3270),
    [anon_sym_consteval] = ACTIONS(3270),
    [anon_sym_alignas] = ACTIONS(3272),
    [anon_sym__Alignas] = ACTIONS(3272),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1965),
    [anon_sym_compl] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_sizeof] = ACTIONS(1973),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_operator] = ACTIONS(1823),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [395] = {
    [sym_expression] = STATE(4247),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(2514),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2531),
    [anon_sym_typedef] = ACTIONS(2561),
    [anon_sym_virtual] = ACTIONS(2536),
    [anon_sym_extern] = ACTIONS(2536),
    [anon_sym___attribute__] = ACTIONS(2536),
    [anon_sym___attribute] = ACTIONS(2536),
    [anon_sym_COLON_COLON] = ACTIONS(2538),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2526),
    [anon_sym___declspec] = ACTIONS(2536),
    [anon_sym_signed] = ACTIONS(2536),
    [anon_sym_unsigned] = ACTIONS(2536),
    [anon_sym_long] = ACTIONS(2536),
    [anon_sym_short] = ACTIONS(2536),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(2536),
    [anon_sym_register] = ACTIONS(2536),
    [anon_sym_inline] = ACTIONS(2536),
    [anon_sym___inline] = ACTIONS(2536),
    [anon_sym___inline__] = ACTIONS(2536),
    [anon_sym___forceinline] = ACTIONS(2536),
    [anon_sym_thread_local] = ACTIONS(2536),
    [anon_sym___thread] = ACTIONS(2536),
    [anon_sym_const] = ACTIONS(2536),
    [anon_sym_constexpr] = ACTIONS(2536),
    [anon_sym_volatile] = ACTIONS(2536),
    [anon_sym_restrict] = ACTIONS(2536),
    [anon_sym___restrict__] = ACTIONS(2536),
    [anon_sym__Atomic] = ACTIONS(2536),
    [anon_sym__Noreturn] = ACTIONS(2536),
    [anon_sym_noreturn] = ACTIONS(2536),
    [anon_sym__Nonnull] = ACTIONS(2536),
    [anon_sym_mutable] = ACTIONS(2536),
    [anon_sym_constinit] = ACTIONS(2536),
    [anon_sym_consteval] = ACTIONS(2536),
    [anon_sym_alignas] = ACTIONS(2536),
    [anon_sym__Alignas] = ACTIONS(2536),
    [sym_primitive_type] = ACTIONS(2544),
    [anon_sym_enum] = ACTIONS(2536),
    [anon_sym_class] = ACTIONS(2536),
    [anon_sym_struct] = ACTIONS(2536),
    [anon_sym_union] = ACTIONS(2536),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2536),
    [anon_sym_decltype] = ACTIONS(2547),
    [anon_sym_typename] = ACTIONS(2536),
    [anon_sym_template] = ACTIONS(2550),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [396] = {
    [sym_preproc_def] = STATE(598),
    [sym_preproc_function_def] = STATE(598),
    [sym_preproc_call] = STATE(598),
    [sym_preproc_if_in_field_declaration_list] = STATE(598),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(598),
    [sym_preproc_else_in_field_declaration_list] = STATE(8402),
    [sym_preproc_elif_in_field_declaration_list] = STATE(8402),
    [sym_preproc_elifdef_in_field_declaration_list] = STATE(8402),
    [sym_type_definition] = STATE(598),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(5496),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6181),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__field_declaration_list_item] = STATE(598),
    [sym_field_declaration] = STATE(598),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1743),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(598),
    [sym_operator_cast] = STATE(6702),
    [sym_inline_method_definition] = STATE(598),
    [sym__constructor_specifiers] = STATE(1743),
    [sym_operator_cast_definition] = STATE(598),
    [sym_operator_cast_declaration] = STATE(598),
    [sym_constructor_or_destructor_definition] = STATE(598),
    [sym_constructor_or_destructor_declaration] = STATE(598),
    [sym_friend_declaration] = STATE(598),
    [sym_access_specifier] = STATE(7776),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_using_declaration] = STATE(598),
    [sym_alias_declaration] = STATE(598),
    [sym_static_assert_declaration] = STATE(598),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5383),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6702),
    [sym_operator_name] = STATE(5896),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(598),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2008),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1743),
    [sym_identifier] = ACTIONS(3174),
    [aux_sym_preproc_def_token1] = ACTIONS(3176),
    [aux_sym_preproc_if_token1] = ACTIONS(3178),
    [aux_sym_preproc_if_token2] = ACTIONS(3304),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3182),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3182),
    [aux_sym_preproc_else_token1] = ACTIONS(3184),
    [aux_sym_preproc_elif_token1] = ACTIONS(3186),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3188),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3188),
    [sym_preproc_directive] = ACTIONS(3190),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3244),
    [anon_sym___extension__] = ACTIONS(3202),
    [anon_sym_typedef] = ACTIONS(3204),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(3210),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3216),
    [anon_sym_struct] = ACTIONS(3218),
    [anon_sym_union] = ACTIONS(3220),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3222),
    [anon_sym_template] = ACTIONS(3224),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3226),
    [anon_sym_public] = ACTIONS(3228),
    [anon_sym_private] = ACTIONS(3228),
    [anon_sym_protected] = ACTIONS(3228),
    [anon_sym_using] = ACTIONS(3230),
    [anon_sym_static_assert] = ACTIONS(3232),
  },
  [397] = {
    [ts_builtin_sym_end] = ACTIONS(2565),
    [sym_identifier] = ACTIONS(2563),
    [aux_sym_preproc_include_token1] = ACTIONS(2563),
    [aux_sym_preproc_def_token1] = ACTIONS(2563),
    [aux_sym_preproc_if_token1] = ACTIONS(2563),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2563),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2563),
    [sym_preproc_directive] = ACTIONS(2563),
    [anon_sym_LPAREN2] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2565),
    [anon_sym_TILDE] = ACTIONS(2565),
    [anon_sym_DASH] = ACTIONS(2563),
    [anon_sym_PLUS] = ACTIONS(2563),
    [anon_sym_STAR] = ACTIONS(2565),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_AMP] = ACTIONS(2563),
    [anon_sym_SEMI] = ACTIONS(2565),
    [anon_sym___extension__] = ACTIONS(2563),
    [anon_sym_typedef] = ACTIONS(2563),
    [anon_sym_virtual] = ACTIONS(2563),
    [anon_sym_extern] = ACTIONS(2563),
    [anon_sym___attribute__] = ACTIONS(2563),
    [anon_sym___attribute] = ACTIONS(2563),
    [anon_sym_COLON_COLON] = ACTIONS(2565),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2565),
    [anon_sym___declspec] = ACTIONS(2563),
    [anon_sym___based] = ACTIONS(2563),
    [anon_sym___cdecl] = ACTIONS(2563),
    [anon_sym___clrcall] = ACTIONS(2563),
    [anon_sym___stdcall] = ACTIONS(2563),
    [anon_sym___fastcall] = ACTIONS(2563),
    [anon_sym___thiscall] = ACTIONS(2563),
    [anon_sym___vectorcall] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(2565),
    [anon_sym_signed] = ACTIONS(2563),
    [anon_sym_unsigned] = ACTIONS(2563),
    [anon_sym_long] = ACTIONS(2563),
    [anon_sym_short] = ACTIONS(2563),
    [anon_sym_LBRACK] = ACTIONS(2563),
    [anon_sym_static] = ACTIONS(2563),
    [anon_sym_register] = ACTIONS(2563),
    [anon_sym_inline] = ACTIONS(2563),
    [anon_sym___inline] = ACTIONS(2563),
    [anon_sym___inline__] = ACTIONS(2563),
    [anon_sym___forceinline] = ACTIONS(2563),
    [anon_sym_thread_local] = ACTIONS(2563),
    [anon_sym___thread] = ACTIONS(2563),
    [anon_sym_const] = ACTIONS(2563),
    [anon_sym_constexpr] = ACTIONS(2563),
    [anon_sym_volatile] = ACTIONS(2563),
    [anon_sym_restrict] = ACTIONS(2563),
    [anon_sym___restrict__] = ACTIONS(2563),
    [anon_sym__Atomic] = ACTIONS(2563),
    [anon_sym__Noreturn] = ACTIONS(2563),
    [anon_sym_noreturn] = ACTIONS(2563),
    [anon_sym__Nonnull] = ACTIONS(2563),
    [anon_sym_mutable] = ACTIONS(2563),
    [anon_sym_constinit] = ACTIONS(2563),
    [anon_sym_consteval] = ACTIONS(2563),
    [anon_sym_alignas] = ACTIONS(2563),
    [anon_sym__Alignas] = ACTIONS(2563),
    [sym_primitive_type] = ACTIONS(2563),
    [anon_sym_enum] = ACTIONS(2563),
    [anon_sym_class] = ACTIONS(2563),
    [anon_sym_struct] = ACTIONS(2563),
    [anon_sym_union] = ACTIONS(2563),
    [anon_sym_if] = ACTIONS(2563),
    [anon_sym_else] = ACTIONS(2563),
    [anon_sym_switch] = ACTIONS(2563),
    [anon_sym_case] = ACTIONS(2563),
    [anon_sym_default] = ACTIONS(2563),
    [anon_sym_while] = ACTIONS(2563),
    [anon_sym_do] = ACTIONS(2563),
    [anon_sym_for] = ACTIONS(2563),
    [anon_sym_return] = ACTIONS(2563),
    [anon_sym_break] = ACTIONS(2563),
    [anon_sym_continue] = ACTIONS(2563),
    [anon_sym_goto] = ACTIONS(2563),
    [anon_sym___try] = ACTIONS(2563),
    [anon_sym___leave] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2563),
    [anon_sym_compl] = ACTIONS(2563),
    [anon_sym_DASH_DASH] = ACTIONS(2565),
    [anon_sym_PLUS_PLUS] = ACTIONS(2565),
    [anon_sym_sizeof] = ACTIONS(2563),
    [anon_sym___alignof__] = ACTIONS(2563),
    [anon_sym___alignof] = ACTIONS(2563),
    [anon_sym__alignof] = ACTIONS(2563),
    [anon_sym_alignof] = ACTIONS(2563),
    [anon_sym__Alignof] = ACTIONS(2563),
    [anon_sym_offsetof] = ACTIONS(2563),
    [anon_sym__Generic] = ACTIONS(2563),
    [anon_sym_asm] = ACTIONS(2563),
    [anon_sym___asm__] = ACTIONS(2563),
    [anon_sym___asm] = ACTIONS(2563),
    [sym_number_literal] = ACTIONS(2565),
    [anon_sym_L_SQUOTE] = ACTIONS(2565),
    [anon_sym_u_SQUOTE] = ACTIONS(2565),
    [anon_sym_U_SQUOTE] = ACTIONS(2565),
    [anon_sym_u8_SQUOTE] = ACTIONS(2565),
    [anon_sym_SQUOTE] = ACTIONS(2565),
    [anon_sym_L_DQUOTE] = ACTIONS(2565),
    [anon_sym_u_DQUOTE] = ACTIONS(2565),
    [anon_sym_U_DQUOTE] = ACTIONS(2565),
    [anon_sym_u8_DQUOTE] = ACTIONS(2565),
    [anon_sym_DQUOTE] = ACTIONS(2565),
    [sym_true] = ACTIONS(2563),
    [sym_false] = ACTIONS(2563),
    [anon_sym_NULL] = ACTIONS(2563),
    [anon_sym_nullptr] = ACTIONS(2563),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2563),
    [anon_sym_decltype] = ACTIONS(2563),
    [anon_sym_explicit] = ACTIONS(2563),
    [anon_sym_typename] = ACTIONS(2563),
    [anon_sym_template] = ACTIONS(2563),
    [anon_sym_operator] = ACTIONS(2563),
    [anon_sym_try] = ACTIONS(2563),
    [anon_sym_delete] = ACTIONS(2563),
    [anon_sym_throw] = ACTIONS(2563),
    [anon_sym_namespace] = ACTIONS(2563),
    [anon_sym_using] = ACTIONS(2563),
    [anon_sym_static_assert] = ACTIONS(2563),
    [anon_sym_concept] = ACTIONS(2563),
    [anon_sym_co_return] = ACTIONS(2563),
    [anon_sym_co_yield] = ACTIONS(2563),
    [anon_sym_catch] = ACTIONS(2563),
    [anon_sym_R_DQUOTE] = ACTIONS(2565),
    [anon_sym_LR_DQUOTE] = ACTIONS(2565),
    [anon_sym_uR_DQUOTE] = ACTIONS(2565),
    [anon_sym_UR_DQUOTE] = ACTIONS(2565),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2565),
    [anon_sym_co_await] = ACTIONS(2563),
    [anon_sym_new] = ACTIONS(2563),
    [anon_sym_requires] = ACTIONS(2563),
    [sym_this] = ACTIONS(2563),
  },
  [398] = {
    [sym_else_clause] = STATE(424),
    [sym_identifier] = ACTIONS(2573),
    [aux_sym_preproc_include_token1] = ACTIONS(2573),
    [aux_sym_preproc_def_token1] = ACTIONS(2573),
    [aux_sym_preproc_if_token1] = ACTIONS(2573),
    [aux_sym_preproc_if_token2] = ACTIONS(2573),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2573),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2573),
    [sym_preproc_directive] = ACTIONS(2573),
    [anon_sym_LPAREN2] = ACTIONS(2575),
    [anon_sym_BANG] = ACTIONS(2575),
    [anon_sym_TILDE] = ACTIONS(2575),
    [anon_sym_DASH] = ACTIONS(2573),
    [anon_sym_PLUS] = ACTIONS(2573),
    [anon_sym_STAR] = ACTIONS(2575),
    [anon_sym_AMP_AMP] = ACTIONS(2575),
    [anon_sym_AMP] = ACTIONS(2573),
    [anon_sym_SEMI] = ACTIONS(2575),
    [anon_sym___extension__] = ACTIONS(2573),
    [anon_sym_typedef] = ACTIONS(2573),
    [anon_sym_virtual] = ACTIONS(2573),
    [anon_sym_extern] = ACTIONS(2573),
    [anon_sym___attribute__] = ACTIONS(2573),
    [anon_sym___attribute] = ACTIONS(2573),
    [anon_sym_COLON_COLON] = ACTIONS(2575),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2575),
    [anon_sym___declspec] = ACTIONS(2573),
    [anon_sym___based] = ACTIONS(2573),
    [anon_sym___cdecl] = ACTIONS(2573),
    [anon_sym___clrcall] = ACTIONS(2573),
    [anon_sym___stdcall] = ACTIONS(2573),
    [anon_sym___fastcall] = ACTIONS(2573),
    [anon_sym___thiscall] = ACTIONS(2573),
    [anon_sym___vectorcall] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_signed] = ACTIONS(2573),
    [anon_sym_unsigned] = ACTIONS(2573),
    [anon_sym_long] = ACTIONS(2573),
    [anon_sym_short] = ACTIONS(2573),
    [anon_sym_LBRACK] = ACTIONS(2573),
    [anon_sym_static] = ACTIONS(2573),
    [anon_sym_register] = ACTIONS(2573),
    [anon_sym_inline] = ACTIONS(2573),
    [anon_sym___inline] = ACTIONS(2573),
    [anon_sym___inline__] = ACTIONS(2573),
    [anon_sym___forceinline] = ACTIONS(2573),
    [anon_sym_thread_local] = ACTIONS(2573),
    [anon_sym___thread] = ACTIONS(2573),
    [anon_sym_const] = ACTIONS(2573),
    [anon_sym_constexpr] = ACTIONS(2573),
    [anon_sym_volatile] = ACTIONS(2573),
    [anon_sym_restrict] = ACTIONS(2573),
    [anon_sym___restrict__] = ACTIONS(2573),
    [anon_sym__Atomic] = ACTIONS(2573),
    [anon_sym__Noreturn] = ACTIONS(2573),
    [anon_sym_noreturn] = ACTIONS(2573),
    [anon_sym__Nonnull] = ACTIONS(2573),
    [anon_sym_mutable] = ACTIONS(2573),
    [anon_sym_constinit] = ACTIONS(2573),
    [anon_sym_consteval] = ACTIONS(2573),
    [anon_sym_alignas] = ACTIONS(2573),
    [anon_sym__Alignas] = ACTIONS(2573),
    [sym_primitive_type] = ACTIONS(2573),
    [anon_sym_enum] = ACTIONS(2573),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_struct] = ACTIONS(2573),
    [anon_sym_union] = ACTIONS(2573),
    [anon_sym_if] = ACTIONS(2573),
    [anon_sym_else] = ACTIONS(3306),
    [anon_sym_switch] = ACTIONS(2573),
    [anon_sym_case] = ACTIONS(2573),
    [anon_sym_default] = ACTIONS(2573),
    [anon_sym_while] = ACTIONS(2573),
    [anon_sym_do] = ACTIONS(2573),
    [anon_sym_for] = ACTIONS(2573),
    [anon_sym_return] = ACTIONS(2573),
    [anon_sym_break] = ACTIONS(2573),
    [anon_sym_continue] = ACTIONS(2573),
    [anon_sym_goto] = ACTIONS(2573),
    [anon_sym___try] = ACTIONS(2573),
    [anon_sym___leave] = ACTIONS(2573),
    [anon_sym_not] = ACTIONS(2573),
    [anon_sym_compl] = ACTIONS(2573),
    [anon_sym_DASH_DASH] = ACTIONS(2575),
    [anon_sym_PLUS_PLUS] = ACTIONS(2575),
    [anon_sym_sizeof] = ACTIONS(2573),
    [anon_sym___alignof__] = ACTIONS(2573),
    [anon_sym___alignof] = ACTIONS(2573),
    [anon_sym__alignof] = ACTIONS(2573),
    [anon_sym_alignof] = ACTIONS(2573),
    [anon_sym__Alignof] = ACTIONS(2573),
    [anon_sym_offsetof] = ACTIONS(2573),
    [anon_sym__Generic] = ACTIONS(2573),
    [anon_sym_asm] = ACTIONS(2573),
    [anon_sym___asm__] = ACTIONS(2573),
    [anon_sym___asm] = ACTIONS(2573),
    [sym_number_literal] = ACTIONS(2575),
    [anon_sym_L_SQUOTE] = ACTIONS(2575),
    [anon_sym_u_SQUOTE] = ACTIONS(2575),
    [anon_sym_U_SQUOTE] = ACTIONS(2575),
    [anon_sym_u8_SQUOTE] = ACTIONS(2575),
    [anon_sym_SQUOTE] = ACTIONS(2575),
    [anon_sym_L_DQUOTE] = ACTIONS(2575),
    [anon_sym_u_DQUOTE] = ACTIONS(2575),
    [anon_sym_U_DQUOTE] = ACTIONS(2575),
    [anon_sym_u8_DQUOTE] = ACTIONS(2575),
    [anon_sym_DQUOTE] = ACTIONS(2575),
    [sym_true] = ACTIONS(2573),
    [sym_false] = ACTIONS(2573),
    [anon_sym_NULL] = ACTIONS(2573),
    [anon_sym_nullptr] = ACTIONS(2573),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2573),
    [anon_sym_decltype] = ACTIONS(2573),
    [anon_sym_explicit] = ACTIONS(2573),
    [anon_sym_typename] = ACTIONS(2573),
    [anon_sym_template] = ACTIONS(2573),
    [anon_sym_operator] = ACTIONS(2573),
    [anon_sym_try] = ACTIONS(2573),
    [anon_sym_delete] = ACTIONS(2573),
    [anon_sym_throw] = ACTIONS(2573),
    [anon_sym_namespace] = ACTIONS(2573),
    [anon_sym_using] = ACTIONS(2573),
    [anon_sym_static_assert] = ACTIONS(2573),
    [anon_sym_concept] = ACTIONS(2573),
    [anon_sym_co_return] = ACTIONS(2573),
    [anon_sym_co_yield] = ACTIONS(2573),
    [anon_sym_R_DQUOTE] = ACTIONS(2575),
    [anon_sym_LR_DQUOTE] = ACTIONS(2575),
    [anon_sym_uR_DQUOTE] = ACTIONS(2575),
    [anon_sym_UR_DQUOTE] = ACTIONS(2575),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2575),
    [anon_sym_co_await] = ACTIONS(2573),
    [anon_sym_new] = ACTIONS(2573),
    [anon_sym_requires] = ACTIONS(2573),
    [sym_this] = ACTIONS(2573),
  },
  [399] = {
    [sym_identifier] = ACTIONS(1913),
    [aux_sym_preproc_include_token1] = ACTIONS(1913),
    [aux_sym_preproc_def_token1] = ACTIONS(1913),
    [aux_sym_preproc_if_token1] = ACTIONS(1913),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1913),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1913),
    [sym_preproc_directive] = ACTIONS(1913),
    [anon_sym_LPAREN2] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_DASH] = ACTIONS(1913),
    [anon_sym_PLUS] = ACTIONS(1913),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_AMP_AMP] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1913),
    [anon_sym_SEMI] = ACTIONS(1911),
    [anon_sym___extension__] = ACTIONS(1913),
    [anon_sym_typedef] = ACTIONS(1913),
    [anon_sym_virtual] = ACTIONS(1913),
    [anon_sym_extern] = ACTIONS(1913),
    [anon_sym___attribute__] = ACTIONS(1913),
    [anon_sym___attribute] = ACTIONS(1913),
    [anon_sym_COLON_COLON] = ACTIONS(1911),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1911),
    [anon_sym___declspec] = ACTIONS(1913),
    [anon_sym___based] = ACTIONS(1913),
    [anon_sym___cdecl] = ACTIONS(1913),
    [anon_sym___clrcall] = ACTIONS(1913),
    [anon_sym___stdcall] = ACTIONS(1913),
    [anon_sym___fastcall] = ACTIONS(1913),
    [anon_sym___thiscall] = ACTIONS(1913),
    [anon_sym___vectorcall] = ACTIONS(1913),
    [anon_sym_LBRACE] = ACTIONS(1911),
    [anon_sym_RBRACE] = ACTIONS(1911),
    [anon_sym_signed] = ACTIONS(1913),
    [anon_sym_unsigned] = ACTIONS(1913),
    [anon_sym_long] = ACTIONS(1913),
    [anon_sym_short] = ACTIONS(1913),
    [anon_sym_LBRACK] = ACTIONS(1913),
    [anon_sym_static] = ACTIONS(1913),
    [anon_sym_register] = ACTIONS(1913),
    [anon_sym_inline] = ACTIONS(1913),
    [anon_sym___inline] = ACTIONS(1913),
    [anon_sym___inline__] = ACTIONS(1913),
    [anon_sym___forceinline] = ACTIONS(1913),
    [anon_sym_thread_local] = ACTIONS(1913),
    [anon_sym___thread] = ACTIONS(1913),
    [anon_sym_const] = ACTIONS(1913),
    [anon_sym_constexpr] = ACTIONS(1913),
    [anon_sym_volatile] = ACTIONS(1913),
    [anon_sym_restrict] = ACTIONS(1913),
    [anon_sym___restrict__] = ACTIONS(1913),
    [anon_sym__Atomic] = ACTIONS(1913),
    [anon_sym__Noreturn] = ACTIONS(1913),
    [anon_sym_noreturn] = ACTIONS(1913),
    [anon_sym__Nonnull] = ACTIONS(1913),
    [anon_sym_mutable] = ACTIONS(1913),
    [anon_sym_constinit] = ACTIONS(1913),
    [anon_sym_consteval] = ACTIONS(1913),
    [anon_sym_alignas] = ACTIONS(1913),
    [anon_sym__Alignas] = ACTIONS(1913),
    [sym_primitive_type] = ACTIONS(1913),
    [anon_sym_enum] = ACTIONS(1913),
    [anon_sym_class] = ACTIONS(1913),
    [anon_sym_struct] = ACTIONS(1913),
    [anon_sym_union] = ACTIONS(1913),
    [anon_sym_if] = ACTIONS(1913),
    [anon_sym_else] = ACTIONS(1913),
    [anon_sym_switch] = ACTIONS(1913),
    [anon_sym_case] = ACTIONS(1913),
    [anon_sym_default] = ACTIONS(1913),
    [anon_sym_while] = ACTIONS(1913),
    [anon_sym_do] = ACTIONS(1913),
    [anon_sym_for] = ACTIONS(1913),
    [anon_sym_return] = ACTIONS(1913),
    [anon_sym_break] = ACTIONS(1913),
    [anon_sym_continue] = ACTIONS(1913),
    [anon_sym_goto] = ACTIONS(1913),
    [anon_sym___try] = ACTIONS(1913),
    [anon_sym___leave] = ACTIONS(1913),
    [anon_sym_not] = ACTIONS(1913),
    [anon_sym_compl] = ACTIONS(1913),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_sizeof] = ACTIONS(1913),
    [anon_sym___alignof__] = ACTIONS(1913),
    [anon_sym___alignof] = ACTIONS(1913),
    [anon_sym__alignof] = ACTIONS(1913),
    [anon_sym_alignof] = ACTIONS(1913),
    [anon_sym__Alignof] = ACTIONS(1913),
    [anon_sym_offsetof] = ACTIONS(1913),
    [anon_sym__Generic] = ACTIONS(1913),
    [anon_sym_asm] = ACTIONS(1913),
    [anon_sym___asm__] = ACTIONS(1913),
    [anon_sym___asm] = ACTIONS(1913),
    [sym_number_literal] = ACTIONS(1911),
    [anon_sym_L_SQUOTE] = ACTIONS(1911),
    [anon_sym_u_SQUOTE] = ACTIONS(1911),
    [anon_sym_U_SQUOTE] = ACTIONS(1911),
    [anon_sym_u8_SQUOTE] = ACTIONS(1911),
    [anon_sym_SQUOTE] = ACTIONS(1911),
    [anon_sym_L_DQUOTE] = ACTIONS(1911),
    [anon_sym_u_DQUOTE] = ACTIONS(1911),
    [anon_sym_U_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8_DQUOTE] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(1911),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1913),
    [anon_sym_nullptr] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1913),
    [anon_sym_decltype] = ACTIONS(1913),
    [anon_sym_explicit] = ACTIONS(1913),
    [anon_sym_typename] = ACTIONS(1913),
    [anon_sym_template] = ACTIONS(1913),
    [anon_sym_operator] = ACTIONS(1913),
    [anon_sym_try] = ACTIONS(1913),
    [anon_sym_delete] = ACTIONS(1913),
    [anon_sym_throw] = ACTIONS(1913),
    [anon_sym_namespace] = ACTIONS(1913),
    [anon_sym_using] = ACTIONS(1913),
    [anon_sym_static_assert] = ACTIONS(1913),
    [anon_sym_concept] = ACTIONS(1913),
    [anon_sym_co_return] = ACTIONS(1913),
    [anon_sym_co_yield] = ACTIONS(1913),
    [anon_sym_catch] = ACTIONS(1913),
    [anon_sym_R_DQUOTE] = ACTIONS(1911),
    [anon_sym_LR_DQUOTE] = ACTIONS(1911),
    [anon_sym_uR_DQUOTE] = ACTIONS(1911),
    [anon_sym_UR_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1911),
    [anon_sym_co_await] = ACTIONS(1913),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_requires] = ACTIONS(1913),
    [sym_this] = ACTIONS(1913),
  },
  [400] = {
    [sym_type_qualifier] = STATE(3854),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4605),
    [sym_sized_type_specifier] = STATE(1810),
    [sym_enum_specifier] = STATE(1810),
    [sym_struct_specifier] = STATE(1810),
    [sym_union_specifier] = STATE(1810),
    [sym_expression] = STATE(4626),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_type_descriptor] = STATE(8256),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(1810),
    [sym_decltype_auto] = STATE(1804),
    [sym_decltype] = STATE(1755),
    [sym_class_specifier] = STATE(1810),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(1810),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5658),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__type_definition_type_repeat1] = STATE(3854),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(3308),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3310),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(1781),
    [anon_sym_unsigned] = ACTIONS(1781),
    [anon_sym_long] = ACTIONS(1781),
    [anon_sym_short] = ACTIONS(1781),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3312),
    [anon_sym_enum] = ACTIONS(1787),
    [anon_sym_class] = ACTIONS(1789),
    [anon_sym_struct] = ACTIONS(1791),
    [anon_sym_union] = ACTIONS(1793),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1817),
    [anon_sym_decltype] = ACTIONS(1819),
    [anon_sym_typename] = ACTIONS(1821),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [401] = {
    [sym_type_qualifier] = STATE(3854),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4605),
    [sym_sized_type_specifier] = STATE(1810),
    [sym_enum_specifier] = STATE(1810),
    [sym_struct_specifier] = STATE(1810),
    [sym_union_specifier] = STATE(1810),
    [sym_expression] = STATE(4539),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_type_descriptor] = STATE(8042),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(1810),
    [sym_decltype_auto] = STATE(1804),
    [sym_decltype] = STATE(1755),
    [sym_class_specifier] = STATE(1810),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(1810),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5658),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__type_definition_type_repeat1] = STATE(3854),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(3308),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3310),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(1781),
    [anon_sym_unsigned] = ACTIONS(1781),
    [anon_sym_long] = ACTIONS(1781),
    [anon_sym_short] = ACTIONS(1781),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3312),
    [anon_sym_enum] = ACTIONS(1787),
    [anon_sym_class] = ACTIONS(1789),
    [anon_sym_struct] = ACTIONS(1791),
    [anon_sym_union] = ACTIONS(1793),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1817),
    [anon_sym_decltype] = ACTIONS(1819),
    [anon_sym_typename] = ACTIONS(1821),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [402] = {
    [sym_identifier] = ACTIONS(1913),
    [aux_sym_preproc_include_token1] = ACTIONS(1913),
    [aux_sym_preproc_def_token1] = ACTIONS(1913),
    [aux_sym_preproc_if_token1] = ACTIONS(1913),
    [aux_sym_preproc_if_token2] = ACTIONS(1913),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1913),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1913),
    [sym_preproc_directive] = ACTIONS(1913),
    [anon_sym_LPAREN2] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_DASH] = ACTIONS(1913),
    [anon_sym_PLUS] = ACTIONS(1913),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_AMP_AMP] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1913),
    [anon_sym_SEMI] = ACTIONS(1911),
    [anon_sym___extension__] = ACTIONS(1913),
    [anon_sym_typedef] = ACTIONS(1913),
    [anon_sym_virtual] = ACTIONS(1913),
    [anon_sym_extern] = ACTIONS(1913),
    [anon_sym___attribute__] = ACTIONS(1913),
    [anon_sym___attribute] = ACTIONS(1913),
    [anon_sym_COLON_COLON] = ACTIONS(1911),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1911),
    [anon_sym___declspec] = ACTIONS(1913),
    [anon_sym___based] = ACTIONS(1913),
    [anon_sym___cdecl] = ACTIONS(1913),
    [anon_sym___clrcall] = ACTIONS(1913),
    [anon_sym___stdcall] = ACTIONS(1913),
    [anon_sym___fastcall] = ACTIONS(1913),
    [anon_sym___thiscall] = ACTIONS(1913),
    [anon_sym___vectorcall] = ACTIONS(1913),
    [anon_sym_LBRACE] = ACTIONS(1911),
    [anon_sym_signed] = ACTIONS(1913),
    [anon_sym_unsigned] = ACTIONS(1913),
    [anon_sym_long] = ACTIONS(1913),
    [anon_sym_short] = ACTIONS(1913),
    [anon_sym_LBRACK] = ACTIONS(1913),
    [anon_sym_static] = ACTIONS(1913),
    [anon_sym_register] = ACTIONS(1913),
    [anon_sym_inline] = ACTIONS(1913),
    [anon_sym___inline] = ACTIONS(1913),
    [anon_sym___inline__] = ACTIONS(1913),
    [anon_sym___forceinline] = ACTIONS(1913),
    [anon_sym_thread_local] = ACTIONS(1913),
    [anon_sym___thread] = ACTIONS(1913),
    [anon_sym_const] = ACTIONS(1913),
    [anon_sym_constexpr] = ACTIONS(1913),
    [anon_sym_volatile] = ACTIONS(1913),
    [anon_sym_restrict] = ACTIONS(1913),
    [anon_sym___restrict__] = ACTIONS(1913),
    [anon_sym__Atomic] = ACTIONS(1913),
    [anon_sym__Noreturn] = ACTIONS(1913),
    [anon_sym_noreturn] = ACTIONS(1913),
    [anon_sym__Nonnull] = ACTIONS(1913),
    [anon_sym_mutable] = ACTIONS(1913),
    [anon_sym_constinit] = ACTIONS(1913),
    [anon_sym_consteval] = ACTIONS(1913),
    [anon_sym_alignas] = ACTIONS(1913),
    [anon_sym__Alignas] = ACTIONS(1913),
    [sym_primitive_type] = ACTIONS(1913),
    [anon_sym_enum] = ACTIONS(1913),
    [anon_sym_class] = ACTIONS(1913),
    [anon_sym_struct] = ACTIONS(1913),
    [anon_sym_union] = ACTIONS(1913),
    [anon_sym_if] = ACTIONS(1913),
    [anon_sym_else] = ACTIONS(1913),
    [anon_sym_switch] = ACTIONS(1913),
    [anon_sym_case] = ACTIONS(1913),
    [anon_sym_default] = ACTIONS(1913),
    [anon_sym_while] = ACTIONS(1913),
    [anon_sym_do] = ACTIONS(1913),
    [anon_sym_for] = ACTIONS(1913),
    [anon_sym_return] = ACTIONS(1913),
    [anon_sym_break] = ACTIONS(1913),
    [anon_sym_continue] = ACTIONS(1913),
    [anon_sym_goto] = ACTIONS(1913),
    [anon_sym___try] = ACTIONS(1913),
    [anon_sym___leave] = ACTIONS(1913),
    [anon_sym_not] = ACTIONS(1913),
    [anon_sym_compl] = ACTIONS(1913),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_sizeof] = ACTIONS(1913),
    [anon_sym___alignof__] = ACTIONS(1913),
    [anon_sym___alignof] = ACTIONS(1913),
    [anon_sym__alignof] = ACTIONS(1913),
    [anon_sym_alignof] = ACTIONS(1913),
    [anon_sym__Alignof] = ACTIONS(1913),
    [anon_sym_offsetof] = ACTIONS(1913),
    [anon_sym__Generic] = ACTIONS(1913),
    [anon_sym_asm] = ACTIONS(1913),
    [anon_sym___asm__] = ACTIONS(1913),
    [anon_sym___asm] = ACTIONS(1913),
    [sym_number_literal] = ACTIONS(1911),
    [anon_sym_L_SQUOTE] = ACTIONS(1911),
    [anon_sym_u_SQUOTE] = ACTIONS(1911),
    [anon_sym_U_SQUOTE] = ACTIONS(1911),
    [anon_sym_u8_SQUOTE] = ACTIONS(1911),
    [anon_sym_SQUOTE] = ACTIONS(1911),
    [anon_sym_L_DQUOTE] = ACTIONS(1911),
    [anon_sym_u_DQUOTE] = ACTIONS(1911),
    [anon_sym_U_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8_DQUOTE] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(1911),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1913),
    [anon_sym_nullptr] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1913),
    [anon_sym_decltype] = ACTIONS(1913),
    [anon_sym_explicit] = ACTIONS(1913),
    [anon_sym_typename] = ACTIONS(1913),
    [anon_sym_template] = ACTIONS(1913),
    [anon_sym_operator] = ACTIONS(1913),
    [anon_sym_try] = ACTIONS(1913),
    [anon_sym_delete] = ACTIONS(1913),
    [anon_sym_throw] = ACTIONS(1913),
    [anon_sym_namespace] = ACTIONS(1913),
    [anon_sym_using] = ACTIONS(1913),
    [anon_sym_static_assert] = ACTIONS(1913),
    [anon_sym_concept] = ACTIONS(1913),
    [anon_sym_co_return] = ACTIONS(1913),
    [anon_sym_co_yield] = ACTIONS(1913),
    [anon_sym_catch] = ACTIONS(1913),
    [anon_sym_R_DQUOTE] = ACTIONS(1911),
    [anon_sym_LR_DQUOTE] = ACTIONS(1911),
    [anon_sym_uR_DQUOTE] = ACTIONS(1911),
    [anon_sym_UR_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1911),
    [anon_sym_co_await] = ACTIONS(1913),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_requires] = ACTIONS(1913),
    [sym_this] = ACTIONS(1913),
  },
  [403] = {
    [sym_type_qualifier] = STATE(3854),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4605),
    [sym_sized_type_specifier] = STATE(1810),
    [sym_enum_specifier] = STATE(1810),
    [sym_struct_specifier] = STATE(1810),
    [sym_union_specifier] = STATE(1810),
    [sym_expression] = STATE(4555),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_type_descriptor] = STATE(8404),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(1810),
    [sym_decltype_auto] = STATE(1804),
    [sym_decltype] = STATE(1755),
    [sym_class_specifier] = STATE(1810),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(1810),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5658),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__type_definition_type_repeat1] = STATE(3854),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(3308),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3310),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(1781),
    [anon_sym_unsigned] = ACTIONS(1781),
    [anon_sym_long] = ACTIONS(1781),
    [anon_sym_short] = ACTIONS(1781),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3312),
    [anon_sym_enum] = ACTIONS(1787),
    [anon_sym_class] = ACTIONS(1789),
    [anon_sym_struct] = ACTIONS(1791),
    [anon_sym_union] = ACTIONS(1793),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1817),
    [anon_sym_decltype] = ACTIONS(1819),
    [anon_sym_typename] = ACTIONS(1821),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [404] = {
    [sym_type_qualifier] = STATE(3854),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4605),
    [sym_sized_type_specifier] = STATE(1810),
    [sym_enum_specifier] = STATE(1810),
    [sym_struct_specifier] = STATE(1810),
    [sym_union_specifier] = STATE(1810),
    [sym_expression] = STATE(4572),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_type_descriptor] = STATE(8532),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(1810),
    [sym_decltype_auto] = STATE(1804),
    [sym_decltype] = STATE(1755),
    [sym_class_specifier] = STATE(1810),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(1810),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5658),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__type_definition_type_repeat1] = STATE(3854),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(3308),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3310),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(1781),
    [anon_sym_unsigned] = ACTIONS(1781),
    [anon_sym_long] = ACTIONS(1781),
    [anon_sym_short] = ACTIONS(1781),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3312),
    [anon_sym_enum] = ACTIONS(1787),
    [anon_sym_class] = ACTIONS(1789),
    [anon_sym_struct] = ACTIONS(1791),
    [anon_sym_union] = ACTIONS(1793),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1817),
    [anon_sym_decltype] = ACTIONS(1819),
    [anon_sym_typename] = ACTIONS(1821),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [405] = {
    [sym_type_qualifier] = STATE(3854),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4605),
    [sym_sized_type_specifier] = STATE(1810),
    [sym_enum_specifier] = STATE(1810),
    [sym_struct_specifier] = STATE(1810),
    [sym_union_specifier] = STATE(1810),
    [sym_expression] = STATE(4593),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_type_descriptor] = STATE(8141),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(1810),
    [sym_decltype_auto] = STATE(1804),
    [sym_decltype] = STATE(1755),
    [sym_class_specifier] = STATE(1810),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(1810),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5658),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__type_definition_type_repeat1] = STATE(3854),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(3308),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3310),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(1781),
    [anon_sym_unsigned] = ACTIONS(1781),
    [anon_sym_long] = ACTIONS(1781),
    [anon_sym_short] = ACTIONS(1781),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3312),
    [anon_sym_enum] = ACTIONS(1787),
    [anon_sym_class] = ACTIONS(1789),
    [anon_sym_struct] = ACTIONS(1791),
    [anon_sym_union] = ACTIONS(1793),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1817),
    [anon_sym_decltype] = ACTIONS(1819),
    [anon_sym_typename] = ACTIONS(1821),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [406] = {
    [sym_type_qualifier] = STATE(3854),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4605),
    [sym_sized_type_specifier] = STATE(1810),
    [sym_enum_specifier] = STATE(1810),
    [sym_struct_specifier] = STATE(1810),
    [sym_union_specifier] = STATE(1810),
    [sym_expression] = STATE(4607),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_type_descriptor] = STATE(8519),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(1810),
    [sym_decltype_auto] = STATE(1804),
    [sym_decltype] = STATE(1755),
    [sym_class_specifier] = STATE(1810),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(1810),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5658),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__type_definition_type_repeat1] = STATE(3854),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(3308),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3310),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(1781),
    [anon_sym_unsigned] = ACTIONS(1781),
    [anon_sym_long] = ACTIONS(1781),
    [anon_sym_short] = ACTIONS(1781),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3312),
    [anon_sym_enum] = ACTIONS(1787),
    [anon_sym_class] = ACTIONS(1789),
    [anon_sym_struct] = ACTIONS(1791),
    [anon_sym_union] = ACTIONS(1793),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1817),
    [anon_sym_decltype] = ACTIONS(1819),
    [anon_sym_typename] = ACTIONS(1821),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [407] = {
    [sym_type_qualifier] = STATE(3854),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4605),
    [sym_sized_type_specifier] = STATE(1810),
    [sym_enum_specifier] = STATE(1810),
    [sym_struct_specifier] = STATE(1810),
    [sym_union_specifier] = STATE(1810),
    [sym_expression] = STATE(4615),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_type_descriptor] = STATE(7838),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(1810),
    [sym_decltype_auto] = STATE(1804),
    [sym_decltype] = STATE(1755),
    [sym_class_specifier] = STATE(1810),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(1810),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5658),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__type_definition_type_repeat1] = STATE(3854),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(3308),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3310),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(1781),
    [anon_sym_unsigned] = ACTIONS(1781),
    [anon_sym_long] = ACTIONS(1781),
    [anon_sym_short] = ACTIONS(1781),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3312),
    [anon_sym_enum] = ACTIONS(1787),
    [anon_sym_class] = ACTIONS(1789),
    [anon_sym_struct] = ACTIONS(1791),
    [anon_sym_union] = ACTIONS(1793),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1817),
    [anon_sym_decltype] = ACTIONS(1819),
    [anon_sym_typename] = ACTIONS(1821),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [408] = {
    [sym_type_qualifier] = STATE(3854),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4605),
    [sym_sized_type_specifier] = STATE(1810),
    [sym_enum_specifier] = STATE(1810),
    [sym_struct_specifier] = STATE(1810),
    [sym_union_specifier] = STATE(1810),
    [sym_expression] = STATE(4618),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_type_descriptor] = STATE(8161),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(1810),
    [sym_decltype_auto] = STATE(1804),
    [sym_decltype] = STATE(1755),
    [sym_class_specifier] = STATE(1810),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(1810),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5658),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__type_definition_type_repeat1] = STATE(3854),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(3308),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3310),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(1781),
    [anon_sym_unsigned] = ACTIONS(1781),
    [anon_sym_long] = ACTIONS(1781),
    [anon_sym_short] = ACTIONS(1781),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3312),
    [anon_sym_enum] = ACTIONS(1787),
    [anon_sym_class] = ACTIONS(1789),
    [anon_sym_struct] = ACTIONS(1791),
    [anon_sym_union] = ACTIONS(1793),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1817),
    [anon_sym_decltype] = ACTIONS(1819),
    [anon_sym_typename] = ACTIONS(1821),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [409] = {
    [sym_type_qualifier] = STATE(3854),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4605),
    [sym_sized_type_specifier] = STATE(1810),
    [sym_enum_specifier] = STATE(1810),
    [sym_struct_specifier] = STATE(1810),
    [sym_union_specifier] = STATE(1810),
    [sym_expression] = STATE(4623),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_type_descriptor] = STATE(8275),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(1810),
    [sym_decltype_auto] = STATE(1804),
    [sym_decltype] = STATE(1755),
    [sym_class_specifier] = STATE(1810),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(1810),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5658),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__type_definition_type_repeat1] = STATE(3854),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(3308),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3310),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(1781),
    [anon_sym_unsigned] = ACTIONS(1781),
    [anon_sym_long] = ACTIONS(1781),
    [anon_sym_short] = ACTIONS(1781),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3312),
    [anon_sym_enum] = ACTIONS(1787),
    [anon_sym_class] = ACTIONS(1789),
    [anon_sym_struct] = ACTIONS(1791),
    [anon_sym_union] = ACTIONS(1793),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1817),
    [anon_sym_decltype] = ACTIONS(1819),
    [anon_sym_typename] = ACTIONS(1821),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [410] = {
    [sym_type_qualifier] = STATE(3854),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4605),
    [sym_sized_type_specifier] = STATE(1810),
    [sym_enum_specifier] = STATE(1810),
    [sym_struct_specifier] = STATE(1810),
    [sym_union_specifier] = STATE(1810),
    [sym_expression] = STATE(4627),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_type_descriptor] = STATE(8071),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(1810),
    [sym_decltype_auto] = STATE(1804),
    [sym_decltype] = STATE(1755),
    [sym_class_specifier] = STATE(1810),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(1810),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5658),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__type_definition_type_repeat1] = STATE(3854),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(3308),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3310),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(1781),
    [anon_sym_unsigned] = ACTIONS(1781),
    [anon_sym_long] = ACTIONS(1781),
    [anon_sym_short] = ACTIONS(1781),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3312),
    [anon_sym_enum] = ACTIONS(1787),
    [anon_sym_class] = ACTIONS(1789),
    [anon_sym_struct] = ACTIONS(1791),
    [anon_sym_union] = ACTIONS(1793),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1817),
    [anon_sym_decltype] = ACTIONS(1819),
    [anon_sym_typename] = ACTIONS(1821),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [411] = {
    [sym_type_qualifier] = STATE(3854),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4605),
    [sym_sized_type_specifier] = STATE(1810),
    [sym_enum_specifier] = STATE(1810),
    [sym_struct_specifier] = STATE(1810),
    [sym_union_specifier] = STATE(1810),
    [sym_expression] = STATE(4631),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_type_descriptor] = STATE(8341),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(1810),
    [sym_decltype_auto] = STATE(1804),
    [sym_decltype] = STATE(1755),
    [sym_class_specifier] = STATE(1810),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(1810),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5658),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__type_definition_type_repeat1] = STATE(3854),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(3308),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3310),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(1781),
    [anon_sym_unsigned] = ACTIONS(1781),
    [anon_sym_long] = ACTIONS(1781),
    [anon_sym_short] = ACTIONS(1781),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3312),
    [anon_sym_enum] = ACTIONS(1787),
    [anon_sym_class] = ACTIONS(1789),
    [anon_sym_struct] = ACTIONS(1791),
    [anon_sym_union] = ACTIONS(1793),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1817),
    [anon_sym_decltype] = ACTIONS(1819),
    [anon_sym_typename] = ACTIONS(1821),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [412] = {
    [sym_expression] = STATE(4247),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(2514),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2531),
    [anon_sym_virtual] = ACTIONS(2536),
    [anon_sym_extern] = ACTIONS(2536),
    [anon_sym___attribute__] = ACTIONS(2536),
    [anon_sym___attribute] = ACTIONS(2536),
    [anon_sym_COLON_COLON] = ACTIONS(2538),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2526),
    [anon_sym___declspec] = ACTIONS(2536),
    [anon_sym_signed] = ACTIONS(2536),
    [anon_sym_unsigned] = ACTIONS(2536),
    [anon_sym_long] = ACTIONS(2536),
    [anon_sym_short] = ACTIONS(2536),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(2536),
    [anon_sym_register] = ACTIONS(2536),
    [anon_sym_inline] = ACTIONS(2536),
    [anon_sym___inline] = ACTIONS(2536),
    [anon_sym___inline__] = ACTIONS(2536),
    [anon_sym___forceinline] = ACTIONS(2536),
    [anon_sym_thread_local] = ACTIONS(2536),
    [anon_sym___thread] = ACTIONS(2536),
    [anon_sym_const] = ACTIONS(2536),
    [anon_sym_constexpr] = ACTIONS(2536),
    [anon_sym_volatile] = ACTIONS(2536),
    [anon_sym_restrict] = ACTIONS(2536),
    [anon_sym___restrict__] = ACTIONS(2536),
    [anon_sym__Atomic] = ACTIONS(2536),
    [anon_sym__Noreturn] = ACTIONS(2536),
    [anon_sym_noreturn] = ACTIONS(2536),
    [anon_sym__Nonnull] = ACTIONS(2536),
    [anon_sym_mutable] = ACTIONS(2536),
    [anon_sym_constinit] = ACTIONS(2536),
    [anon_sym_consteval] = ACTIONS(2536),
    [anon_sym_alignas] = ACTIONS(2536),
    [anon_sym__Alignas] = ACTIONS(2536),
    [sym_primitive_type] = ACTIONS(2544),
    [anon_sym_enum] = ACTIONS(2536),
    [anon_sym_class] = ACTIONS(2536),
    [anon_sym_struct] = ACTIONS(2536),
    [anon_sym_union] = ACTIONS(2536),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2536),
    [anon_sym_decltype] = ACTIONS(2547),
    [anon_sym_typename] = ACTIONS(2536),
    [anon_sym_template] = ACTIONS(2550),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [413] = {
    [sym_else_clause] = STATE(474),
    [sym_identifier] = ACTIONS(2573),
    [aux_sym_preproc_include_token1] = ACTIONS(2573),
    [aux_sym_preproc_def_token1] = ACTIONS(2573),
    [aux_sym_preproc_if_token1] = ACTIONS(2573),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2573),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2573),
    [sym_preproc_directive] = ACTIONS(2573),
    [anon_sym_LPAREN2] = ACTIONS(2575),
    [anon_sym_BANG] = ACTIONS(2575),
    [anon_sym_TILDE] = ACTIONS(2575),
    [anon_sym_DASH] = ACTIONS(2573),
    [anon_sym_PLUS] = ACTIONS(2573),
    [anon_sym_STAR] = ACTIONS(2575),
    [anon_sym_AMP_AMP] = ACTIONS(2575),
    [anon_sym_AMP] = ACTIONS(2573),
    [anon_sym_SEMI] = ACTIONS(2575),
    [anon_sym___extension__] = ACTIONS(2573),
    [anon_sym_typedef] = ACTIONS(2573),
    [anon_sym_virtual] = ACTIONS(2573),
    [anon_sym_extern] = ACTIONS(2573),
    [anon_sym___attribute__] = ACTIONS(2573),
    [anon_sym___attribute] = ACTIONS(2573),
    [anon_sym_COLON_COLON] = ACTIONS(2575),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2575),
    [anon_sym___declspec] = ACTIONS(2573),
    [anon_sym___based] = ACTIONS(2573),
    [anon_sym___cdecl] = ACTIONS(2573),
    [anon_sym___clrcall] = ACTIONS(2573),
    [anon_sym___stdcall] = ACTIONS(2573),
    [anon_sym___fastcall] = ACTIONS(2573),
    [anon_sym___thiscall] = ACTIONS(2573),
    [anon_sym___vectorcall] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_RBRACE] = ACTIONS(2575),
    [anon_sym_signed] = ACTIONS(2573),
    [anon_sym_unsigned] = ACTIONS(2573),
    [anon_sym_long] = ACTIONS(2573),
    [anon_sym_short] = ACTIONS(2573),
    [anon_sym_LBRACK] = ACTIONS(2573),
    [anon_sym_static] = ACTIONS(2573),
    [anon_sym_register] = ACTIONS(2573),
    [anon_sym_inline] = ACTIONS(2573),
    [anon_sym___inline] = ACTIONS(2573),
    [anon_sym___inline__] = ACTIONS(2573),
    [anon_sym___forceinline] = ACTIONS(2573),
    [anon_sym_thread_local] = ACTIONS(2573),
    [anon_sym___thread] = ACTIONS(2573),
    [anon_sym_const] = ACTIONS(2573),
    [anon_sym_constexpr] = ACTIONS(2573),
    [anon_sym_volatile] = ACTIONS(2573),
    [anon_sym_restrict] = ACTIONS(2573),
    [anon_sym___restrict__] = ACTIONS(2573),
    [anon_sym__Atomic] = ACTIONS(2573),
    [anon_sym__Noreturn] = ACTIONS(2573),
    [anon_sym_noreturn] = ACTIONS(2573),
    [anon_sym__Nonnull] = ACTIONS(2573),
    [anon_sym_mutable] = ACTIONS(2573),
    [anon_sym_constinit] = ACTIONS(2573),
    [anon_sym_consteval] = ACTIONS(2573),
    [anon_sym_alignas] = ACTIONS(2573),
    [anon_sym__Alignas] = ACTIONS(2573),
    [sym_primitive_type] = ACTIONS(2573),
    [anon_sym_enum] = ACTIONS(2573),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_struct] = ACTIONS(2573),
    [anon_sym_union] = ACTIONS(2573),
    [anon_sym_if] = ACTIONS(2573),
    [anon_sym_else] = ACTIONS(3314),
    [anon_sym_switch] = ACTIONS(2573),
    [anon_sym_case] = ACTIONS(2573),
    [anon_sym_default] = ACTIONS(2573),
    [anon_sym_while] = ACTIONS(2573),
    [anon_sym_do] = ACTIONS(2573),
    [anon_sym_for] = ACTIONS(2573),
    [anon_sym_return] = ACTIONS(2573),
    [anon_sym_break] = ACTIONS(2573),
    [anon_sym_continue] = ACTIONS(2573),
    [anon_sym_goto] = ACTIONS(2573),
    [anon_sym___try] = ACTIONS(2573),
    [anon_sym___leave] = ACTIONS(2573),
    [anon_sym_not] = ACTIONS(2573),
    [anon_sym_compl] = ACTIONS(2573),
    [anon_sym_DASH_DASH] = ACTIONS(2575),
    [anon_sym_PLUS_PLUS] = ACTIONS(2575),
    [anon_sym_sizeof] = ACTIONS(2573),
    [anon_sym___alignof__] = ACTIONS(2573),
    [anon_sym___alignof] = ACTIONS(2573),
    [anon_sym__alignof] = ACTIONS(2573),
    [anon_sym_alignof] = ACTIONS(2573),
    [anon_sym__Alignof] = ACTIONS(2573),
    [anon_sym_offsetof] = ACTIONS(2573),
    [anon_sym__Generic] = ACTIONS(2573),
    [anon_sym_asm] = ACTIONS(2573),
    [anon_sym___asm__] = ACTIONS(2573),
    [anon_sym___asm] = ACTIONS(2573),
    [sym_number_literal] = ACTIONS(2575),
    [anon_sym_L_SQUOTE] = ACTIONS(2575),
    [anon_sym_u_SQUOTE] = ACTIONS(2575),
    [anon_sym_U_SQUOTE] = ACTIONS(2575),
    [anon_sym_u8_SQUOTE] = ACTIONS(2575),
    [anon_sym_SQUOTE] = ACTIONS(2575),
    [anon_sym_L_DQUOTE] = ACTIONS(2575),
    [anon_sym_u_DQUOTE] = ACTIONS(2575),
    [anon_sym_U_DQUOTE] = ACTIONS(2575),
    [anon_sym_u8_DQUOTE] = ACTIONS(2575),
    [anon_sym_DQUOTE] = ACTIONS(2575),
    [sym_true] = ACTIONS(2573),
    [sym_false] = ACTIONS(2573),
    [anon_sym_NULL] = ACTIONS(2573),
    [anon_sym_nullptr] = ACTIONS(2573),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2573),
    [anon_sym_decltype] = ACTIONS(2573),
    [anon_sym_explicit] = ACTIONS(2573),
    [anon_sym_typename] = ACTIONS(2573),
    [anon_sym_template] = ACTIONS(2573),
    [anon_sym_operator] = ACTIONS(2573),
    [anon_sym_try] = ACTIONS(2573),
    [anon_sym_delete] = ACTIONS(2573),
    [anon_sym_throw] = ACTIONS(2573),
    [anon_sym_namespace] = ACTIONS(2573),
    [anon_sym_using] = ACTIONS(2573),
    [anon_sym_static_assert] = ACTIONS(2573),
    [anon_sym_concept] = ACTIONS(2573),
    [anon_sym_co_return] = ACTIONS(2573),
    [anon_sym_co_yield] = ACTIONS(2573),
    [anon_sym_R_DQUOTE] = ACTIONS(2575),
    [anon_sym_LR_DQUOTE] = ACTIONS(2575),
    [anon_sym_uR_DQUOTE] = ACTIONS(2575),
    [anon_sym_UR_DQUOTE] = ACTIONS(2575),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2575),
    [anon_sym_co_await] = ACTIONS(2573),
    [anon_sym_new] = ACTIONS(2573),
    [anon_sym_requires] = ACTIONS(2573),
    [sym_this] = ACTIONS(2573),
  },
  [414] = {
    [sym_else_clause] = STATE(456),
    [ts_builtin_sym_end] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2567),
    [aux_sym_preproc_include_token1] = ACTIONS(2567),
    [aux_sym_preproc_def_token1] = ACTIONS(2567),
    [aux_sym_preproc_if_token1] = ACTIONS(2567),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2567),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2567),
    [sym_preproc_directive] = ACTIONS(2567),
    [anon_sym_LPAREN2] = ACTIONS(2569),
    [anon_sym_BANG] = ACTIONS(2569),
    [anon_sym_TILDE] = ACTIONS(2569),
    [anon_sym_DASH] = ACTIONS(2567),
    [anon_sym_PLUS] = ACTIONS(2567),
    [anon_sym_STAR] = ACTIONS(2569),
    [anon_sym_AMP_AMP] = ACTIONS(2569),
    [anon_sym_AMP] = ACTIONS(2567),
    [anon_sym_SEMI] = ACTIONS(2569),
    [anon_sym___extension__] = ACTIONS(2567),
    [anon_sym_typedef] = ACTIONS(2567),
    [anon_sym_virtual] = ACTIONS(2567),
    [anon_sym_extern] = ACTIONS(2567),
    [anon_sym___attribute__] = ACTIONS(2567),
    [anon_sym___attribute] = ACTIONS(2567),
    [anon_sym_COLON_COLON] = ACTIONS(2569),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2569),
    [anon_sym___declspec] = ACTIONS(2567),
    [anon_sym___based] = ACTIONS(2567),
    [anon_sym___cdecl] = ACTIONS(2567),
    [anon_sym___clrcall] = ACTIONS(2567),
    [anon_sym___stdcall] = ACTIONS(2567),
    [anon_sym___fastcall] = ACTIONS(2567),
    [anon_sym___thiscall] = ACTIONS(2567),
    [anon_sym___vectorcall] = ACTIONS(2567),
    [anon_sym_LBRACE] = ACTIONS(2569),
    [anon_sym_signed] = ACTIONS(2567),
    [anon_sym_unsigned] = ACTIONS(2567),
    [anon_sym_long] = ACTIONS(2567),
    [anon_sym_short] = ACTIONS(2567),
    [anon_sym_LBRACK] = ACTIONS(2567),
    [anon_sym_static] = ACTIONS(2567),
    [anon_sym_register] = ACTIONS(2567),
    [anon_sym_inline] = ACTIONS(2567),
    [anon_sym___inline] = ACTIONS(2567),
    [anon_sym___inline__] = ACTIONS(2567),
    [anon_sym___forceinline] = ACTIONS(2567),
    [anon_sym_thread_local] = ACTIONS(2567),
    [anon_sym___thread] = ACTIONS(2567),
    [anon_sym_const] = ACTIONS(2567),
    [anon_sym_constexpr] = ACTIONS(2567),
    [anon_sym_volatile] = ACTIONS(2567),
    [anon_sym_restrict] = ACTIONS(2567),
    [anon_sym___restrict__] = ACTIONS(2567),
    [anon_sym__Atomic] = ACTIONS(2567),
    [anon_sym__Noreturn] = ACTIONS(2567),
    [anon_sym_noreturn] = ACTIONS(2567),
    [anon_sym__Nonnull] = ACTIONS(2567),
    [anon_sym_mutable] = ACTIONS(2567),
    [anon_sym_constinit] = ACTIONS(2567),
    [anon_sym_consteval] = ACTIONS(2567),
    [anon_sym_alignas] = ACTIONS(2567),
    [anon_sym__Alignas] = ACTIONS(2567),
    [sym_primitive_type] = ACTIONS(2567),
    [anon_sym_enum] = ACTIONS(2567),
    [anon_sym_class] = ACTIONS(2567),
    [anon_sym_struct] = ACTIONS(2567),
    [anon_sym_union] = ACTIONS(2567),
    [anon_sym_if] = ACTIONS(2567),
    [anon_sym_else] = ACTIONS(3316),
    [anon_sym_switch] = ACTIONS(2567),
    [anon_sym_case] = ACTIONS(2567),
    [anon_sym_default] = ACTIONS(2567),
    [anon_sym_while] = ACTIONS(2567),
    [anon_sym_do] = ACTIONS(2567),
    [anon_sym_for] = ACTIONS(2567),
    [anon_sym_return] = ACTIONS(2567),
    [anon_sym_break] = ACTIONS(2567),
    [anon_sym_continue] = ACTIONS(2567),
    [anon_sym_goto] = ACTIONS(2567),
    [anon_sym___try] = ACTIONS(2567),
    [anon_sym___leave] = ACTIONS(2567),
    [anon_sym_not] = ACTIONS(2567),
    [anon_sym_compl] = ACTIONS(2567),
    [anon_sym_DASH_DASH] = ACTIONS(2569),
    [anon_sym_PLUS_PLUS] = ACTIONS(2569),
    [anon_sym_sizeof] = ACTIONS(2567),
    [anon_sym___alignof__] = ACTIONS(2567),
    [anon_sym___alignof] = ACTIONS(2567),
    [anon_sym__alignof] = ACTIONS(2567),
    [anon_sym_alignof] = ACTIONS(2567),
    [anon_sym__Alignof] = ACTIONS(2567),
    [anon_sym_offsetof] = ACTIONS(2567),
    [anon_sym__Generic] = ACTIONS(2567),
    [anon_sym_asm] = ACTIONS(2567),
    [anon_sym___asm__] = ACTIONS(2567),
    [anon_sym___asm] = ACTIONS(2567),
    [sym_number_literal] = ACTIONS(2569),
    [anon_sym_L_SQUOTE] = ACTIONS(2569),
    [anon_sym_u_SQUOTE] = ACTIONS(2569),
    [anon_sym_U_SQUOTE] = ACTIONS(2569),
    [anon_sym_u8_SQUOTE] = ACTIONS(2569),
    [anon_sym_SQUOTE] = ACTIONS(2569),
    [anon_sym_L_DQUOTE] = ACTIONS(2569),
    [anon_sym_u_DQUOTE] = ACTIONS(2569),
    [anon_sym_U_DQUOTE] = ACTIONS(2569),
    [anon_sym_u8_DQUOTE] = ACTIONS(2569),
    [anon_sym_DQUOTE] = ACTIONS(2569),
    [sym_true] = ACTIONS(2567),
    [sym_false] = ACTIONS(2567),
    [anon_sym_NULL] = ACTIONS(2567),
    [anon_sym_nullptr] = ACTIONS(2567),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2567),
    [anon_sym_decltype] = ACTIONS(2567),
    [anon_sym_explicit] = ACTIONS(2567),
    [anon_sym_typename] = ACTIONS(2567),
    [anon_sym_template] = ACTIONS(2567),
    [anon_sym_operator] = ACTIONS(2567),
    [anon_sym_try] = ACTIONS(2567),
    [anon_sym_delete] = ACTIONS(2567),
    [anon_sym_throw] = ACTIONS(2567),
    [anon_sym_namespace] = ACTIONS(2567),
    [anon_sym_using] = ACTIONS(2567),
    [anon_sym_static_assert] = ACTIONS(2567),
    [anon_sym_concept] = ACTIONS(2567),
    [anon_sym_co_return] = ACTIONS(2567),
    [anon_sym_co_yield] = ACTIONS(2567),
    [anon_sym_R_DQUOTE] = ACTIONS(2569),
    [anon_sym_LR_DQUOTE] = ACTIONS(2569),
    [anon_sym_uR_DQUOTE] = ACTIONS(2569),
    [anon_sym_UR_DQUOTE] = ACTIONS(2569),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2569),
    [anon_sym_co_await] = ACTIONS(2567),
    [anon_sym_new] = ACTIONS(2567),
    [anon_sym_requires] = ACTIONS(2567),
    [sym_this] = ACTIONS(2567),
  },
  [415] = {
    [sym_identifier] = ACTIONS(1909),
    [aux_sym_preproc_include_token1] = ACTIONS(1909),
    [aux_sym_preproc_def_token1] = ACTIONS(1909),
    [aux_sym_preproc_if_token1] = ACTIONS(1909),
    [aux_sym_preproc_if_token2] = ACTIONS(1909),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1909),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1909),
    [sym_preproc_directive] = ACTIONS(1909),
    [anon_sym_LPAREN2] = ACTIONS(1907),
    [anon_sym_BANG] = ACTIONS(1907),
    [anon_sym_TILDE] = ACTIONS(1907),
    [anon_sym_DASH] = ACTIONS(1909),
    [anon_sym_PLUS] = ACTIONS(1909),
    [anon_sym_STAR] = ACTIONS(1907),
    [anon_sym_AMP_AMP] = ACTIONS(1907),
    [anon_sym_AMP] = ACTIONS(1909),
    [anon_sym_SEMI] = ACTIONS(1907),
    [anon_sym___extension__] = ACTIONS(1909),
    [anon_sym_typedef] = ACTIONS(1909),
    [anon_sym_virtual] = ACTIONS(1909),
    [anon_sym_extern] = ACTIONS(1909),
    [anon_sym___attribute__] = ACTIONS(1909),
    [anon_sym___attribute] = ACTIONS(1909),
    [anon_sym_COLON_COLON] = ACTIONS(1907),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1907),
    [anon_sym___declspec] = ACTIONS(1909),
    [anon_sym___based] = ACTIONS(1909),
    [anon_sym___cdecl] = ACTIONS(1909),
    [anon_sym___clrcall] = ACTIONS(1909),
    [anon_sym___stdcall] = ACTIONS(1909),
    [anon_sym___fastcall] = ACTIONS(1909),
    [anon_sym___thiscall] = ACTIONS(1909),
    [anon_sym___vectorcall] = ACTIONS(1909),
    [anon_sym_LBRACE] = ACTIONS(1907),
    [anon_sym_signed] = ACTIONS(1909),
    [anon_sym_unsigned] = ACTIONS(1909),
    [anon_sym_long] = ACTIONS(1909),
    [anon_sym_short] = ACTIONS(1909),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_static] = ACTIONS(1909),
    [anon_sym_register] = ACTIONS(1909),
    [anon_sym_inline] = ACTIONS(1909),
    [anon_sym___inline] = ACTIONS(1909),
    [anon_sym___inline__] = ACTIONS(1909),
    [anon_sym___forceinline] = ACTIONS(1909),
    [anon_sym_thread_local] = ACTIONS(1909),
    [anon_sym___thread] = ACTIONS(1909),
    [anon_sym_const] = ACTIONS(1909),
    [anon_sym_constexpr] = ACTIONS(1909),
    [anon_sym_volatile] = ACTIONS(1909),
    [anon_sym_restrict] = ACTIONS(1909),
    [anon_sym___restrict__] = ACTIONS(1909),
    [anon_sym__Atomic] = ACTIONS(1909),
    [anon_sym__Noreturn] = ACTIONS(1909),
    [anon_sym_noreturn] = ACTIONS(1909),
    [anon_sym__Nonnull] = ACTIONS(1909),
    [anon_sym_mutable] = ACTIONS(1909),
    [anon_sym_constinit] = ACTIONS(1909),
    [anon_sym_consteval] = ACTIONS(1909),
    [anon_sym_alignas] = ACTIONS(1909),
    [anon_sym__Alignas] = ACTIONS(1909),
    [sym_primitive_type] = ACTIONS(1909),
    [anon_sym_enum] = ACTIONS(1909),
    [anon_sym_class] = ACTIONS(1909),
    [anon_sym_struct] = ACTIONS(1909),
    [anon_sym_union] = ACTIONS(1909),
    [anon_sym_if] = ACTIONS(1909),
    [anon_sym_else] = ACTIONS(1909),
    [anon_sym_switch] = ACTIONS(1909),
    [anon_sym_case] = ACTIONS(1909),
    [anon_sym_default] = ACTIONS(1909),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_do] = ACTIONS(1909),
    [anon_sym_for] = ACTIONS(1909),
    [anon_sym_return] = ACTIONS(1909),
    [anon_sym_break] = ACTIONS(1909),
    [anon_sym_continue] = ACTIONS(1909),
    [anon_sym_goto] = ACTIONS(1909),
    [anon_sym___try] = ACTIONS(1909),
    [anon_sym___leave] = ACTIONS(1909),
    [anon_sym_not] = ACTIONS(1909),
    [anon_sym_compl] = ACTIONS(1909),
    [anon_sym_DASH_DASH] = ACTIONS(1907),
    [anon_sym_PLUS_PLUS] = ACTIONS(1907),
    [anon_sym_sizeof] = ACTIONS(1909),
    [anon_sym___alignof__] = ACTIONS(1909),
    [anon_sym___alignof] = ACTIONS(1909),
    [anon_sym__alignof] = ACTIONS(1909),
    [anon_sym_alignof] = ACTIONS(1909),
    [anon_sym__Alignof] = ACTIONS(1909),
    [anon_sym_offsetof] = ACTIONS(1909),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1909),
    [anon_sym___asm__] = ACTIONS(1909),
    [anon_sym___asm] = ACTIONS(1909),
    [sym_number_literal] = ACTIONS(1907),
    [anon_sym_L_SQUOTE] = ACTIONS(1907),
    [anon_sym_u_SQUOTE] = ACTIONS(1907),
    [anon_sym_U_SQUOTE] = ACTIONS(1907),
    [anon_sym_u8_SQUOTE] = ACTIONS(1907),
    [anon_sym_SQUOTE] = ACTIONS(1907),
    [anon_sym_L_DQUOTE] = ACTIONS(1907),
    [anon_sym_u_DQUOTE] = ACTIONS(1907),
    [anon_sym_U_DQUOTE] = ACTIONS(1907),
    [anon_sym_u8_DQUOTE] = ACTIONS(1907),
    [anon_sym_DQUOTE] = ACTIONS(1907),
    [sym_true] = ACTIONS(1909),
    [sym_false] = ACTIONS(1909),
    [anon_sym_NULL] = ACTIONS(1909),
    [anon_sym_nullptr] = ACTIONS(1909),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1909),
    [anon_sym_decltype] = ACTIONS(1909),
    [anon_sym_explicit] = ACTIONS(1909),
    [anon_sym_typename] = ACTIONS(1909),
    [anon_sym_template] = ACTIONS(1909),
    [anon_sym_operator] = ACTIONS(1909),
    [anon_sym_try] = ACTIONS(1909),
    [anon_sym_delete] = ACTIONS(1909),
    [anon_sym_throw] = ACTIONS(1909),
    [anon_sym_namespace] = ACTIONS(1909),
    [anon_sym_using] = ACTIONS(1909),
    [anon_sym_static_assert] = ACTIONS(1909),
    [anon_sym_concept] = ACTIONS(1909),
    [anon_sym_co_return] = ACTIONS(1909),
    [anon_sym_co_yield] = ACTIONS(1909),
    [anon_sym_catch] = ACTIONS(1909),
    [anon_sym_R_DQUOTE] = ACTIONS(1907),
    [anon_sym_LR_DQUOTE] = ACTIONS(1907),
    [anon_sym_uR_DQUOTE] = ACTIONS(1907),
    [anon_sym_UR_DQUOTE] = ACTIONS(1907),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1907),
    [anon_sym_co_await] = ACTIONS(1909),
    [anon_sym_new] = ACTIONS(1909),
    [anon_sym_requires] = ACTIONS(1909),
    [sym_this] = ACTIONS(1909),
  },
  [416] = {
    [sym_identifier] = ACTIONS(1909),
    [aux_sym_preproc_include_token1] = ACTIONS(1909),
    [aux_sym_preproc_def_token1] = ACTIONS(1909),
    [aux_sym_preproc_if_token1] = ACTIONS(1909),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1909),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1909),
    [sym_preproc_directive] = ACTIONS(1909),
    [anon_sym_LPAREN2] = ACTIONS(1907),
    [anon_sym_BANG] = ACTIONS(1907),
    [anon_sym_TILDE] = ACTIONS(1907),
    [anon_sym_DASH] = ACTIONS(1909),
    [anon_sym_PLUS] = ACTIONS(1909),
    [anon_sym_STAR] = ACTIONS(1907),
    [anon_sym_AMP_AMP] = ACTIONS(1907),
    [anon_sym_AMP] = ACTIONS(1909),
    [anon_sym_SEMI] = ACTIONS(1907),
    [anon_sym___extension__] = ACTIONS(1909),
    [anon_sym_typedef] = ACTIONS(1909),
    [anon_sym_virtual] = ACTIONS(1909),
    [anon_sym_extern] = ACTIONS(1909),
    [anon_sym___attribute__] = ACTIONS(1909),
    [anon_sym___attribute] = ACTIONS(1909),
    [anon_sym_COLON_COLON] = ACTIONS(1907),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1907),
    [anon_sym___declspec] = ACTIONS(1909),
    [anon_sym___based] = ACTIONS(1909),
    [anon_sym___cdecl] = ACTIONS(1909),
    [anon_sym___clrcall] = ACTIONS(1909),
    [anon_sym___stdcall] = ACTIONS(1909),
    [anon_sym___fastcall] = ACTIONS(1909),
    [anon_sym___thiscall] = ACTIONS(1909),
    [anon_sym___vectorcall] = ACTIONS(1909),
    [anon_sym_LBRACE] = ACTIONS(1907),
    [anon_sym_RBRACE] = ACTIONS(1907),
    [anon_sym_signed] = ACTIONS(1909),
    [anon_sym_unsigned] = ACTIONS(1909),
    [anon_sym_long] = ACTIONS(1909),
    [anon_sym_short] = ACTIONS(1909),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_static] = ACTIONS(1909),
    [anon_sym_register] = ACTIONS(1909),
    [anon_sym_inline] = ACTIONS(1909),
    [anon_sym___inline] = ACTIONS(1909),
    [anon_sym___inline__] = ACTIONS(1909),
    [anon_sym___forceinline] = ACTIONS(1909),
    [anon_sym_thread_local] = ACTIONS(1909),
    [anon_sym___thread] = ACTIONS(1909),
    [anon_sym_const] = ACTIONS(1909),
    [anon_sym_constexpr] = ACTIONS(1909),
    [anon_sym_volatile] = ACTIONS(1909),
    [anon_sym_restrict] = ACTIONS(1909),
    [anon_sym___restrict__] = ACTIONS(1909),
    [anon_sym__Atomic] = ACTIONS(1909),
    [anon_sym__Noreturn] = ACTIONS(1909),
    [anon_sym_noreturn] = ACTIONS(1909),
    [anon_sym__Nonnull] = ACTIONS(1909),
    [anon_sym_mutable] = ACTIONS(1909),
    [anon_sym_constinit] = ACTIONS(1909),
    [anon_sym_consteval] = ACTIONS(1909),
    [anon_sym_alignas] = ACTIONS(1909),
    [anon_sym__Alignas] = ACTIONS(1909),
    [sym_primitive_type] = ACTIONS(1909),
    [anon_sym_enum] = ACTIONS(1909),
    [anon_sym_class] = ACTIONS(1909),
    [anon_sym_struct] = ACTIONS(1909),
    [anon_sym_union] = ACTIONS(1909),
    [anon_sym_if] = ACTIONS(1909),
    [anon_sym_else] = ACTIONS(1909),
    [anon_sym_switch] = ACTIONS(1909),
    [anon_sym_case] = ACTIONS(1909),
    [anon_sym_default] = ACTIONS(1909),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_do] = ACTIONS(1909),
    [anon_sym_for] = ACTIONS(1909),
    [anon_sym_return] = ACTIONS(1909),
    [anon_sym_break] = ACTIONS(1909),
    [anon_sym_continue] = ACTIONS(1909),
    [anon_sym_goto] = ACTIONS(1909),
    [anon_sym___try] = ACTIONS(1909),
    [anon_sym___leave] = ACTIONS(1909),
    [anon_sym_not] = ACTIONS(1909),
    [anon_sym_compl] = ACTIONS(1909),
    [anon_sym_DASH_DASH] = ACTIONS(1907),
    [anon_sym_PLUS_PLUS] = ACTIONS(1907),
    [anon_sym_sizeof] = ACTIONS(1909),
    [anon_sym___alignof__] = ACTIONS(1909),
    [anon_sym___alignof] = ACTIONS(1909),
    [anon_sym__alignof] = ACTIONS(1909),
    [anon_sym_alignof] = ACTIONS(1909),
    [anon_sym__Alignof] = ACTIONS(1909),
    [anon_sym_offsetof] = ACTIONS(1909),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1909),
    [anon_sym___asm__] = ACTIONS(1909),
    [anon_sym___asm] = ACTIONS(1909),
    [sym_number_literal] = ACTIONS(1907),
    [anon_sym_L_SQUOTE] = ACTIONS(1907),
    [anon_sym_u_SQUOTE] = ACTIONS(1907),
    [anon_sym_U_SQUOTE] = ACTIONS(1907),
    [anon_sym_u8_SQUOTE] = ACTIONS(1907),
    [anon_sym_SQUOTE] = ACTIONS(1907),
    [anon_sym_L_DQUOTE] = ACTIONS(1907),
    [anon_sym_u_DQUOTE] = ACTIONS(1907),
    [anon_sym_U_DQUOTE] = ACTIONS(1907),
    [anon_sym_u8_DQUOTE] = ACTIONS(1907),
    [anon_sym_DQUOTE] = ACTIONS(1907),
    [sym_true] = ACTIONS(1909),
    [sym_false] = ACTIONS(1909),
    [anon_sym_NULL] = ACTIONS(1909),
    [anon_sym_nullptr] = ACTIONS(1909),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1909),
    [anon_sym_decltype] = ACTIONS(1909),
    [anon_sym_explicit] = ACTIONS(1909),
    [anon_sym_typename] = ACTIONS(1909),
    [anon_sym_template] = ACTIONS(1909),
    [anon_sym_operator] = ACTIONS(1909),
    [anon_sym_try] = ACTIONS(1909),
    [anon_sym_delete] = ACTIONS(1909),
    [anon_sym_throw] = ACTIONS(1909),
    [anon_sym_namespace] = ACTIONS(1909),
    [anon_sym_using] = ACTIONS(1909),
    [anon_sym_static_assert] = ACTIONS(1909),
    [anon_sym_concept] = ACTIONS(1909),
    [anon_sym_co_return] = ACTIONS(1909),
    [anon_sym_co_yield] = ACTIONS(1909),
    [anon_sym_catch] = ACTIONS(1909),
    [anon_sym_R_DQUOTE] = ACTIONS(1907),
    [anon_sym_LR_DQUOTE] = ACTIONS(1907),
    [anon_sym_uR_DQUOTE] = ACTIONS(1907),
    [anon_sym_UR_DQUOTE] = ACTIONS(1907),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1907),
    [anon_sym_co_await] = ACTIONS(1909),
    [anon_sym_new] = ACTIONS(1909),
    [anon_sym_requires] = ACTIONS(1909),
    [sym_this] = ACTIONS(1909),
  },
  [417] = {
    [sym_identifier] = ACTIONS(2563),
    [aux_sym_preproc_include_token1] = ACTIONS(2563),
    [aux_sym_preproc_def_token1] = ACTIONS(2563),
    [aux_sym_preproc_if_token1] = ACTIONS(2563),
    [aux_sym_preproc_if_token2] = ACTIONS(2563),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2563),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2563),
    [sym_preproc_directive] = ACTIONS(2563),
    [anon_sym_LPAREN2] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2565),
    [anon_sym_TILDE] = ACTIONS(2565),
    [anon_sym_DASH] = ACTIONS(2563),
    [anon_sym_PLUS] = ACTIONS(2563),
    [anon_sym_STAR] = ACTIONS(2565),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_AMP] = ACTIONS(2563),
    [anon_sym_SEMI] = ACTIONS(2565),
    [anon_sym___extension__] = ACTIONS(2563),
    [anon_sym_typedef] = ACTIONS(2563),
    [anon_sym_virtual] = ACTIONS(2563),
    [anon_sym_extern] = ACTIONS(2563),
    [anon_sym___attribute__] = ACTIONS(2563),
    [anon_sym___attribute] = ACTIONS(2563),
    [anon_sym_COLON_COLON] = ACTIONS(2565),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2565),
    [anon_sym___declspec] = ACTIONS(2563),
    [anon_sym___based] = ACTIONS(2563),
    [anon_sym___cdecl] = ACTIONS(2563),
    [anon_sym___clrcall] = ACTIONS(2563),
    [anon_sym___stdcall] = ACTIONS(2563),
    [anon_sym___fastcall] = ACTIONS(2563),
    [anon_sym___thiscall] = ACTIONS(2563),
    [anon_sym___vectorcall] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(2565),
    [anon_sym_signed] = ACTIONS(2563),
    [anon_sym_unsigned] = ACTIONS(2563),
    [anon_sym_long] = ACTIONS(2563),
    [anon_sym_short] = ACTIONS(2563),
    [anon_sym_LBRACK] = ACTIONS(2563),
    [anon_sym_static] = ACTIONS(2563),
    [anon_sym_register] = ACTIONS(2563),
    [anon_sym_inline] = ACTIONS(2563),
    [anon_sym___inline] = ACTIONS(2563),
    [anon_sym___inline__] = ACTIONS(2563),
    [anon_sym___forceinline] = ACTIONS(2563),
    [anon_sym_thread_local] = ACTIONS(2563),
    [anon_sym___thread] = ACTIONS(2563),
    [anon_sym_const] = ACTIONS(2563),
    [anon_sym_constexpr] = ACTIONS(2563),
    [anon_sym_volatile] = ACTIONS(2563),
    [anon_sym_restrict] = ACTIONS(2563),
    [anon_sym___restrict__] = ACTIONS(2563),
    [anon_sym__Atomic] = ACTIONS(2563),
    [anon_sym__Noreturn] = ACTIONS(2563),
    [anon_sym_noreturn] = ACTIONS(2563),
    [anon_sym__Nonnull] = ACTIONS(2563),
    [anon_sym_mutable] = ACTIONS(2563),
    [anon_sym_constinit] = ACTIONS(2563),
    [anon_sym_consteval] = ACTIONS(2563),
    [anon_sym_alignas] = ACTIONS(2563),
    [anon_sym__Alignas] = ACTIONS(2563),
    [sym_primitive_type] = ACTIONS(2563),
    [anon_sym_enum] = ACTIONS(2563),
    [anon_sym_class] = ACTIONS(2563),
    [anon_sym_struct] = ACTIONS(2563),
    [anon_sym_union] = ACTIONS(2563),
    [anon_sym_if] = ACTIONS(2563),
    [anon_sym_else] = ACTIONS(2563),
    [anon_sym_switch] = ACTIONS(2563),
    [anon_sym_case] = ACTIONS(2563),
    [anon_sym_default] = ACTIONS(2563),
    [anon_sym_while] = ACTIONS(2563),
    [anon_sym_do] = ACTIONS(2563),
    [anon_sym_for] = ACTIONS(2563),
    [anon_sym_return] = ACTIONS(2563),
    [anon_sym_break] = ACTIONS(2563),
    [anon_sym_continue] = ACTIONS(2563),
    [anon_sym_goto] = ACTIONS(2563),
    [anon_sym___try] = ACTIONS(2563),
    [anon_sym___leave] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2563),
    [anon_sym_compl] = ACTIONS(2563),
    [anon_sym_DASH_DASH] = ACTIONS(2565),
    [anon_sym_PLUS_PLUS] = ACTIONS(2565),
    [anon_sym_sizeof] = ACTIONS(2563),
    [anon_sym___alignof__] = ACTIONS(2563),
    [anon_sym___alignof] = ACTIONS(2563),
    [anon_sym__alignof] = ACTIONS(2563),
    [anon_sym_alignof] = ACTIONS(2563),
    [anon_sym__Alignof] = ACTIONS(2563),
    [anon_sym_offsetof] = ACTIONS(2563),
    [anon_sym__Generic] = ACTIONS(2563),
    [anon_sym_asm] = ACTIONS(2563),
    [anon_sym___asm__] = ACTIONS(2563),
    [anon_sym___asm] = ACTIONS(2563),
    [sym_number_literal] = ACTIONS(2565),
    [anon_sym_L_SQUOTE] = ACTIONS(2565),
    [anon_sym_u_SQUOTE] = ACTIONS(2565),
    [anon_sym_U_SQUOTE] = ACTIONS(2565),
    [anon_sym_u8_SQUOTE] = ACTIONS(2565),
    [anon_sym_SQUOTE] = ACTIONS(2565),
    [anon_sym_L_DQUOTE] = ACTIONS(2565),
    [anon_sym_u_DQUOTE] = ACTIONS(2565),
    [anon_sym_U_DQUOTE] = ACTIONS(2565),
    [anon_sym_u8_DQUOTE] = ACTIONS(2565),
    [anon_sym_DQUOTE] = ACTIONS(2565),
    [sym_true] = ACTIONS(2563),
    [sym_false] = ACTIONS(2563),
    [anon_sym_NULL] = ACTIONS(2563),
    [anon_sym_nullptr] = ACTIONS(2563),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2563),
    [anon_sym_decltype] = ACTIONS(2563),
    [anon_sym_explicit] = ACTIONS(2563),
    [anon_sym_typename] = ACTIONS(2563),
    [anon_sym_template] = ACTIONS(2563),
    [anon_sym_operator] = ACTIONS(2563),
    [anon_sym_try] = ACTIONS(2563),
    [anon_sym_delete] = ACTIONS(2563),
    [anon_sym_throw] = ACTIONS(2563),
    [anon_sym_namespace] = ACTIONS(2563),
    [anon_sym_using] = ACTIONS(2563),
    [anon_sym_static_assert] = ACTIONS(2563),
    [anon_sym_concept] = ACTIONS(2563),
    [anon_sym_co_return] = ACTIONS(2563),
    [anon_sym_co_yield] = ACTIONS(2563),
    [anon_sym_catch] = ACTIONS(2563),
    [anon_sym_R_DQUOTE] = ACTIONS(2565),
    [anon_sym_LR_DQUOTE] = ACTIONS(2565),
    [anon_sym_uR_DQUOTE] = ACTIONS(2565),
    [anon_sym_UR_DQUOTE] = ACTIONS(2565),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2565),
    [anon_sym_co_await] = ACTIONS(2563),
    [anon_sym_new] = ACTIONS(2563),
    [anon_sym_requires] = ACTIONS(2563),
    [sym_this] = ACTIONS(2563),
  },
  [418] = {
    [sym_type_qualifier] = STATE(3854),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(4605),
    [sym_sized_type_specifier] = STATE(1810),
    [sym_enum_specifier] = STATE(1810),
    [sym_struct_specifier] = STATE(1810),
    [sym_union_specifier] = STATE(1810),
    [sym_expression] = STATE(4731),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_type_descriptor] = STATE(8387),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_placeholder_type_specifier] = STATE(1810),
    [sym_decltype_auto] = STATE(1804),
    [sym_decltype] = STATE(1755),
    [sym_class_specifier] = STATE(1810),
    [sym__class_name] = STATE(7673),
    [sym_dependent_type] = STATE(1810),
    [sym_template_type] = STATE(5238),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5658),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(5258),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym__type_definition_type_repeat1] = STATE(3854),
    [aux_sym_sized_type_specifier_repeat1] = STATE(4142),
    [sym_identifier] = ACTIONS(3308),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3310),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_signed] = ACTIONS(1781),
    [anon_sym_unsigned] = ACTIONS(1781),
    [anon_sym_long] = ACTIONS(1781),
    [anon_sym_short] = ACTIONS(1781),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3312),
    [anon_sym_enum] = ACTIONS(1787),
    [anon_sym_class] = ACTIONS(1789),
    [anon_sym_struct] = ACTIONS(1791),
    [anon_sym_union] = ACTIONS(1793),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1817),
    [anon_sym_decltype] = ACTIONS(1819),
    [anon_sym_typename] = ACTIONS(1821),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [419] = {
    [sym_else_clause] = STATE(528),
    [sym_identifier] = ACTIONS(2567),
    [aux_sym_preproc_include_token1] = ACTIONS(2567),
    [aux_sym_preproc_def_token1] = ACTIONS(2567),
    [aux_sym_preproc_if_token1] = ACTIONS(2567),
    [aux_sym_preproc_if_token2] = ACTIONS(2567),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2567),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2567),
    [sym_preproc_directive] = ACTIONS(2567),
    [anon_sym_LPAREN2] = ACTIONS(2569),
    [anon_sym_BANG] = ACTIONS(2569),
    [anon_sym_TILDE] = ACTIONS(2569),
    [anon_sym_DASH] = ACTIONS(2567),
    [anon_sym_PLUS] = ACTIONS(2567),
    [anon_sym_STAR] = ACTIONS(2569),
    [anon_sym_AMP_AMP] = ACTIONS(2569),
    [anon_sym_AMP] = ACTIONS(2567),
    [anon_sym_SEMI] = ACTIONS(2569),
    [anon_sym___extension__] = ACTIONS(2567),
    [anon_sym_typedef] = ACTIONS(2567),
    [anon_sym_virtual] = ACTIONS(2567),
    [anon_sym_extern] = ACTIONS(2567),
    [anon_sym___attribute__] = ACTIONS(2567),
    [anon_sym___attribute] = ACTIONS(2567),
    [anon_sym_COLON_COLON] = ACTIONS(2569),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2569),
    [anon_sym___declspec] = ACTIONS(2567),
    [anon_sym___based] = ACTIONS(2567),
    [anon_sym___cdecl] = ACTIONS(2567),
    [anon_sym___clrcall] = ACTIONS(2567),
    [anon_sym___stdcall] = ACTIONS(2567),
    [anon_sym___fastcall] = ACTIONS(2567),
    [anon_sym___thiscall] = ACTIONS(2567),
    [anon_sym___vectorcall] = ACTIONS(2567),
    [anon_sym_LBRACE] = ACTIONS(2569),
    [anon_sym_signed] = ACTIONS(2567),
    [anon_sym_unsigned] = ACTIONS(2567),
    [anon_sym_long] = ACTIONS(2567),
    [anon_sym_short] = ACTIONS(2567),
    [anon_sym_LBRACK] = ACTIONS(2567),
    [anon_sym_static] = ACTIONS(2567),
    [anon_sym_register] = ACTIONS(2567),
    [anon_sym_inline] = ACTIONS(2567),
    [anon_sym___inline] = ACTIONS(2567),
    [anon_sym___inline__] = ACTIONS(2567),
    [anon_sym___forceinline] = ACTIONS(2567),
    [anon_sym_thread_local] = ACTIONS(2567),
    [anon_sym___thread] = ACTIONS(2567),
    [anon_sym_const] = ACTIONS(2567),
    [anon_sym_constexpr] = ACTIONS(2567),
    [anon_sym_volatile] = ACTIONS(2567),
    [anon_sym_restrict] = ACTIONS(2567),
    [anon_sym___restrict__] = ACTIONS(2567),
    [anon_sym__Atomic] = ACTIONS(2567),
    [anon_sym__Noreturn] = ACTIONS(2567),
    [anon_sym_noreturn] = ACTIONS(2567),
    [anon_sym__Nonnull] = ACTIONS(2567),
    [anon_sym_mutable] = ACTIONS(2567),
    [anon_sym_constinit] = ACTIONS(2567),
    [anon_sym_consteval] = ACTIONS(2567),
    [anon_sym_alignas] = ACTIONS(2567),
    [anon_sym__Alignas] = ACTIONS(2567),
    [sym_primitive_type] = ACTIONS(2567),
    [anon_sym_enum] = ACTIONS(2567),
    [anon_sym_class] = ACTIONS(2567),
    [anon_sym_struct] = ACTIONS(2567),
    [anon_sym_union] = ACTIONS(2567),
    [anon_sym_if] = ACTIONS(2567),
    [anon_sym_else] = ACTIONS(3306),
    [anon_sym_switch] = ACTIONS(2567),
    [anon_sym_case] = ACTIONS(2567),
    [anon_sym_default] = ACTIONS(2567),
    [anon_sym_while] = ACTIONS(2567),
    [anon_sym_do] = ACTIONS(2567),
    [anon_sym_for] = ACTIONS(2567),
    [anon_sym_return] = ACTIONS(2567),
    [anon_sym_break] = ACTIONS(2567),
    [anon_sym_continue] = ACTIONS(2567),
    [anon_sym_goto] = ACTIONS(2567),
    [anon_sym___try] = ACTIONS(2567),
    [anon_sym___leave] = ACTIONS(2567),
    [anon_sym_not] = ACTIONS(2567),
    [anon_sym_compl] = ACTIONS(2567),
    [anon_sym_DASH_DASH] = ACTIONS(2569),
    [anon_sym_PLUS_PLUS] = ACTIONS(2569),
    [anon_sym_sizeof] = ACTIONS(2567),
    [anon_sym___alignof__] = ACTIONS(2567),
    [anon_sym___alignof] = ACTIONS(2567),
    [anon_sym__alignof] = ACTIONS(2567),
    [anon_sym_alignof] = ACTIONS(2567),
    [anon_sym__Alignof] = ACTIONS(2567),
    [anon_sym_offsetof] = ACTIONS(2567),
    [anon_sym__Generic] = ACTIONS(2567),
    [anon_sym_asm] = ACTIONS(2567),
    [anon_sym___asm__] = ACTIONS(2567),
    [anon_sym___asm] = ACTIONS(2567),
    [sym_number_literal] = ACTIONS(2569),
    [anon_sym_L_SQUOTE] = ACTIONS(2569),
    [anon_sym_u_SQUOTE] = ACTIONS(2569),
    [anon_sym_U_SQUOTE] = ACTIONS(2569),
    [anon_sym_u8_SQUOTE] = ACTIONS(2569),
    [anon_sym_SQUOTE] = ACTIONS(2569),
    [anon_sym_L_DQUOTE] = ACTIONS(2569),
    [anon_sym_u_DQUOTE] = ACTIONS(2569),
    [anon_sym_U_DQUOTE] = ACTIONS(2569),
    [anon_sym_u8_DQUOTE] = ACTIONS(2569),
    [anon_sym_DQUOTE] = ACTIONS(2569),
    [sym_true] = ACTIONS(2567),
    [sym_false] = ACTIONS(2567),
    [anon_sym_NULL] = ACTIONS(2567),
    [anon_sym_nullptr] = ACTIONS(2567),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2567),
    [anon_sym_decltype] = ACTIONS(2567),
    [anon_sym_explicit] = ACTIONS(2567),
    [anon_sym_typename] = ACTIONS(2567),
    [anon_sym_template] = ACTIONS(2567),
    [anon_sym_operator] = ACTIONS(2567),
    [anon_sym_try] = ACTIONS(2567),
    [anon_sym_delete] = ACTIONS(2567),
    [anon_sym_throw] = ACTIONS(2567),
    [anon_sym_namespace] = ACTIONS(2567),
    [anon_sym_using] = ACTIONS(2567),
    [anon_sym_static_assert] = ACTIONS(2567),
    [anon_sym_concept] = ACTIONS(2567),
    [anon_sym_co_return] = ACTIONS(2567),
    [anon_sym_co_yield] = ACTIONS(2567),
    [anon_sym_R_DQUOTE] = ACTIONS(2569),
    [anon_sym_LR_DQUOTE] = ACTIONS(2569),
    [anon_sym_uR_DQUOTE] = ACTIONS(2569),
    [anon_sym_UR_DQUOTE] = ACTIONS(2569),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2569),
    [anon_sym_co_await] = ACTIONS(2567),
    [anon_sym_new] = ACTIONS(2567),
    [anon_sym_requires] = ACTIONS(2567),
    [sym_this] = ACTIONS(2567),
  },
  [420] = {
    [sym_identifier] = ACTIONS(2563),
    [aux_sym_preproc_include_token1] = ACTIONS(2563),
    [aux_sym_preproc_def_token1] = ACTIONS(2563),
    [aux_sym_preproc_if_token1] = ACTIONS(2563),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2563),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2563),
    [sym_preproc_directive] = ACTIONS(2563),
    [anon_sym_LPAREN2] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2565),
    [anon_sym_TILDE] = ACTIONS(2565),
    [anon_sym_DASH] = ACTIONS(2563),
    [anon_sym_PLUS] = ACTIONS(2563),
    [anon_sym_STAR] = ACTIONS(2565),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_AMP] = ACTIONS(2563),
    [anon_sym_SEMI] = ACTIONS(2565),
    [anon_sym___extension__] = ACTIONS(2563),
    [anon_sym_typedef] = ACTIONS(2563),
    [anon_sym_virtual] = ACTIONS(2563),
    [anon_sym_extern] = ACTIONS(2563),
    [anon_sym___attribute__] = ACTIONS(2563),
    [anon_sym___attribute] = ACTIONS(2563),
    [anon_sym_COLON_COLON] = ACTIONS(2565),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2565),
    [anon_sym___declspec] = ACTIONS(2563),
    [anon_sym___based] = ACTIONS(2563),
    [anon_sym___cdecl] = ACTIONS(2563),
    [anon_sym___clrcall] = ACTIONS(2563),
    [anon_sym___stdcall] = ACTIONS(2563),
    [anon_sym___fastcall] = ACTIONS(2563),
    [anon_sym___thiscall] = ACTIONS(2563),
    [anon_sym___vectorcall] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(2565),
    [anon_sym_RBRACE] = ACTIONS(2565),
    [anon_sym_signed] = ACTIONS(2563),
    [anon_sym_unsigned] = ACTIONS(2563),
    [anon_sym_long] = ACTIONS(2563),
    [anon_sym_short] = ACTIONS(2563),
    [anon_sym_LBRACK] = ACTIONS(2563),
    [anon_sym_static] = ACTIONS(2563),
    [anon_sym_register] = ACTIONS(2563),
    [anon_sym_inline] = ACTIONS(2563),
    [anon_sym___inline] = ACTIONS(2563),
    [anon_sym___inline__] = ACTIONS(2563),
    [anon_sym___forceinline] = ACTIONS(2563),
    [anon_sym_thread_local] = ACTIONS(2563),
    [anon_sym___thread] = ACTIONS(2563),
    [anon_sym_const] = ACTIONS(2563),
    [anon_sym_constexpr] = ACTIONS(2563),
    [anon_sym_volatile] = ACTIONS(2563),
    [anon_sym_restrict] = ACTIONS(2563),
    [anon_sym___restrict__] = ACTIONS(2563),
    [anon_sym__Atomic] = ACTIONS(2563),
    [anon_sym__Noreturn] = ACTIONS(2563),
    [anon_sym_noreturn] = ACTIONS(2563),
    [anon_sym__Nonnull] = ACTIONS(2563),
    [anon_sym_mutable] = ACTIONS(2563),
    [anon_sym_constinit] = ACTIONS(2563),
    [anon_sym_consteval] = ACTIONS(2563),
    [anon_sym_alignas] = ACTIONS(2563),
    [anon_sym__Alignas] = ACTIONS(2563),
    [sym_primitive_type] = ACTIONS(2563),
    [anon_sym_enum] = ACTIONS(2563),
    [anon_sym_class] = ACTIONS(2563),
    [anon_sym_struct] = ACTIONS(2563),
    [anon_sym_union] = ACTIONS(2563),
    [anon_sym_if] = ACTIONS(2563),
    [anon_sym_else] = ACTIONS(2563),
    [anon_sym_switch] = ACTIONS(2563),
    [anon_sym_case] = ACTIONS(2563),
    [anon_sym_default] = ACTIONS(2563),
    [anon_sym_while] = ACTIONS(2563),
    [anon_sym_do] = ACTIONS(2563),
    [anon_sym_for] = ACTIONS(2563),
    [anon_sym_return] = ACTIONS(2563),
    [anon_sym_break] = ACTIONS(2563),
    [anon_sym_continue] = ACTIONS(2563),
    [anon_sym_goto] = ACTIONS(2563),
    [anon_sym___try] = ACTIONS(2563),
    [anon_sym___leave] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2563),
    [anon_sym_compl] = ACTIONS(2563),
    [anon_sym_DASH_DASH] = ACTIONS(2565),
    [anon_sym_PLUS_PLUS] = ACTIONS(2565),
    [anon_sym_sizeof] = ACTIONS(2563),
    [anon_sym___alignof__] = ACTIONS(2563),
    [anon_sym___alignof] = ACTIONS(2563),
    [anon_sym__alignof] = ACTIONS(2563),
    [anon_sym_alignof] = ACTIONS(2563),
    [anon_sym__Alignof] = ACTIONS(2563),
    [anon_sym_offsetof] = ACTIONS(2563),
    [anon_sym__Generic] = ACTIONS(2563),
    [anon_sym_asm] = ACTIONS(2563),
    [anon_sym___asm__] = ACTIONS(2563),
    [anon_sym___asm] = ACTIONS(2563),
    [sym_number_literal] = ACTIONS(2565),
    [anon_sym_L_SQUOTE] = ACTIONS(2565),
    [anon_sym_u_SQUOTE] = ACTIONS(2565),
    [anon_sym_U_SQUOTE] = ACTIONS(2565),
    [anon_sym_u8_SQUOTE] = ACTIONS(2565),
    [anon_sym_SQUOTE] = ACTIONS(2565),
    [anon_sym_L_DQUOTE] = ACTIONS(2565),
    [anon_sym_u_DQUOTE] = ACTIONS(2565),
    [anon_sym_U_DQUOTE] = ACTIONS(2565),
    [anon_sym_u8_DQUOTE] = ACTIONS(2565),
    [anon_sym_DQUOTE] = ACTIONS(2565),
    [sym_true] = ACTIONS(2563),
    [sym_false] = ACTIONS(2563),
    [anon_sym_NULL] = ACTIONS(2563),
    [anon_sym_nullptr] = ACTIONS(2563),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2563),
    [anon_sym_decltype] = ACTIONS(2563),
    [anon_sym_explicit] = ACTIONS(2563),
    [anon_sym_typename] = ACTIONS(2563),
    [anon_sym_template] = ACTIONS(2563),
    [anon_sym_operator] = ACTIONS(2563),
    [anon_sym_try] = ACTIONS(2563),
    [anon_sym_delete] = ACTIONS(2563),
    [anon_sym_throw] = ACTIONS(2563),
    [anon_sym_namespace] = ACTIONS(2563),
    [anon_sym_using] = ACTIONS(2563),
    [anon_sym_static_assert] = ACTIONS(2563),
    [anon_sym_concept] = ACTIONS(2563),
    [anon_sym_co_return] = ACTIONS(2563),
    [anon_sym_co_yield] = ACTIONS(2563),
    [anon_sym_catch] = ACTIONS(2563),
    [anon_sym_R_DQUOTE] = ACTIONS(2565),
    [anon_sym_LR_DQUOTE] = ACTIONS(2565),
    [anon_sym_uR_DQUOTE] = ACTIONS(2565),
    [anon_sym_UR_DQUOTE] = ACTIONS(2565),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2565),
    [anon_sym_co_await] = ACTIONS(2563),
    [anon_sym_new] = ACTIONS(2563),
    [anon_sym_requires] = ACTIONS(2563),
    [sym_this] = ACTIONS(2563),
  },
  [421] = {
    [sym_else_clause] = STATE(479),
    [ts_builtin_sym_end] = ACTIONS(2575),
    [sym_identifier] = ACTIONS(2573),
    [aux_sym_preproc_include_token1] = ACTIONS(2573),
    [aux_sym_preproc_def_token1] = ACTIONS(2573),
    [aux_sym_preproc_if_token1] = ACTIONS(2573),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2573),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2573),
    [sym_preproc_directive] = ACTIONS(2573),
    [anon_sym_LPAREN2] = ACTIONS(2575),
    [anon_sym_BANG] = ACTIONS(2575),
    [anon_sym_TILDE] = ACTIONS(2575),
    [anon_sym_DASH] = ACTIONS(2573),
    [anon_sym_PLUS] = ACTIONS(2573),
    [anon_sym_STAR] = ACTIONS(2575),
    [anon_sym_AMP_AMP] = ACTIONS(2575),
    [anon_sym_AMP] = ACTIONS(2573),
    [anon_sym_SEMI] = ACTIONS(2575),
    [anon_sym___extension__] = ACTIONS(2573),
    [anon_sym_typedef] = ACTIONS(2573),
    [anon_sym_virtual] = ACTIONS(2573),
    [anon_sym_extern] = ACTIONS(2573),
    [anon_sym___attribute__] = ACTIONS(2573),
    [anon_sym___attribute] = ACTIONS(2573),
    [anon_sym_COLON_COLON] = ACTIONS(2575),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2575),
    [anon_sym___declspec] = ACTIONS(2573),
    [anon_sym___based] = ACTIONS(2573),
    [anon_sym___cdecl] = ACTIONS(2573),
    [anon_sym___clrcall] = ACTIONS(2573),
    [anon_sym___stdcall] = ACTIONS(2573),
    [anon_sym___fastcall] = ACTIONS(2573),
    [anon_sym___thiscall] = ACTIONS(2573),
    [anon_sym___vectorcall] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_signed] = ACTIONS(2573),
    [anon_sym_unsigned] = ACTIONS(2573),
    [anon_sym_long] = ACTIONS(2573),
    [anon_sym_short] = ACTIONS(2573),
    [anon_sym_LBRACK] = ACTIONS(2573),
    [anon_sym_static] = ACTIONS(2573),
    [anon_sym_register] = ACTIONS(2573),
    [anon_sym_inline] = ACTIONS(2573),
    [anon_sym___inline] = ACTIONS(2573),
    [anon_sym___inline__] = ACTIONS(2573),
    [anon_sym___forceinline] = ACTIONS(2573),
    [anon_sym_thread_local] = ACTIONS(2573),
    [anon_sym___thread] = ACTIONS(2573),
    [anon_sym_const] = ACTIONS(2573),
    [anon_sym_constexpr] = ACTIONS(2573),
    [anon_sym_volatile] = ACTIONS(2573),
    [anon_sym_restrict] = ACTIONS(2573),
    [anon_sym___restrict__] = ACTIONS(2573),
    [anon_sym__Atomic] = ACTIONS(2573),
    [anon_sym__Noreturn] = ACTIONS(2573),
    [anon_sym_noreturn] = ACTIONS(2573),
    [anon_sym__Nonnull] = ACTIONS(2573),
    [anon_sym_mutable] = ACTIONS(2573),
    [anon_sym_constinit] = ACTIONS(2573),
    [anon_sym_consteval] = ACTIONS(2573),
    [anon_sym_alignas] = ACTIONS(2573),
    [anon_sym__Alignas] = ACTIONS(2573),
    [sym_primitive_type] = ACTIONS(2573),
    [anon_sym_enum] = ACTIONS(2573),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_struct] = ACTIONS(2573),
    [anon_sym_union] = ACTIONS(2573),
    [anon_sym_if] = ACTIONS(2573),
    [anon_sym_else] = ACTIONS(3316),
    [anon_sym_switch] = ACTIONS(2573),
    [anon_sym_case] = ACTIONS(2573),
    [anon_sym_default] = ACTIONS(2573),
    [anon_sym_while] = ACTIONS(2573),
    [anon_sym_do] = ACTIONS(2573),
    [anon_sym_for] = ACTIONS(2573),
    [anon_sym_return] = ACTIONS(2573),
    [anon_sym_break] = ACTIONS(2573),
    [anon_sym_continue] = ACTIONS(2573),
    [anon_sym_goto] = ACTIONS(2573),
    [anon_sym___try] = ACTIONS(2573),
    [anon_sym___leave] = ACTIONS(2573),
    [anon_sym_not] = ACTIONS(2573),
    [anon_sym_compl] = ACTIONS(2573),
    [anon_sym_DASH_DASH] = ACTIONS(2575),
    [anon_sym_PLUS_PLUS] = ACTIONS(2575),
    [anon_sym_sizeof] = ACTIONS(2573),
    [anon_sym___alignof__] = ACTIONS(2573),
    [anon_sym___alignof] = ACTIONS(2573),
    [anon_sym__alignof] = ACTIONS(2573),
    [anon_sym_alignof] = ACTIONS(2573),
    [anon_sym__Alignof] = ACTIONS(2573),
    [anon_sym_offsetof] = ACTIONS(2573),
    [anon_sym__Generic] = ACTIONS(2573),
    [anon_sym_asm] = ACTIONS(2573),
    [anon_sym___asm__] = ACTIONS(2573),
    [anon_sym___asm] = ACTIONS(2573),
    [sym_number_literal] = ACTIONS(2575),
    [anon_sym_L_SQUOTE] = ACTIONS(2575),
    [anon_sym_u_SQUOTE] = ACTIONS(2575),
    [anon_sym_U_SQUOTE] = ACTIONS(2575),
    [anon_sym_u8_SQUOTE] = ACTIONS(2575),
    [anon_sym_SQUOTE] = ACTIONS(2575),
    [anon_sym_L_DQUOTE] = ACTIONS(2575),
    [anon_sym_u_DQUOTE] = ACTIONS(2575),
    [anon_sym_U_DQUOTE] = ACTIONS(2575),
    [anon_sym_u8_DQUOTE] = ACTIONS(2575),
    [anon_sym_DQUOTE] = ACTIONS(2575),
    [sym_true] = ACTIONS(2573),
    [sym_false] = ACTIONS(2573),
    [anon_sym_NULL] = ACTIONS(2573),
    [anon_sym_nullptr] = ACTIONS(2573),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2573),
    [anon_sym_decltype] = ACTIONS(2573),
    [anon_sym_explicit] = ACTIONS(2573),
    [anon_sym_typename] = ACTIONS(2573),
    [anon_sym_template] = ACTIONS(2573),
    [anon_sym_operator] = ACTIONS(2573),
    [anon_sym_try] = ACTIONS(2573),
    [anon_sym_delete] = ACTIONS(2573),
    [anon_sym_throw] = ACTIONS(2573),
    [anon_sym_namespace] = ACTIONS(2573),
    [anon_sym_using] = ACTIONS(2573),
    [anon_sym_static_assert] = ACTIONS(2573),
    [anon_sym_concept] = ACTIONS(2573),
    [anon_sym_co_return] = ACTIONS(2573),
    [anon_sym_co_yield] = ACTIONS(2573),
    [anon_sym_R_DQUOTE] = ACTIONS(2575),
    [anon_sym_LR_DQUOTE] = ACTIONS(2575),
    [anon_sym_uR_DQUOTE] = ACTIONS(2575),
    [anon_sym_UR_DQUOTE] = ACTIONS(2575),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2575),
    [anon_sym_co_await] = ACTIONS(2573),
    [anon_sym_new] = ACTIONS(2573),
    [anon_sym_requires] = ACTIONS(2573),
    [sym_this] = ACTIONS(2573),
  },
  [422] = {
    [sym_expression] = STATE(3580),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(3318),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(3321),
    [anon_sym_virtual] = ACTIONS(2536),
    [anon_sym_extern] = ACTIONS(2536),
    [anon_sym___attribute__] = ACTIONS(2536),
    [anon_sym___attribute] = ACTIONS(2536),
    [anon_sym_COLON_COLON] = ACTIONS(3324),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2526),
    [anon_sym___declspec] = ACTIONS(2536),
    [anon_sym_signed] = ACTIONS(2536),
    [anon_sym_unsigned] = ACTIONS(2536),
    [anon_sym_long] = ACTIONS(2536),
    [anon_sym_short] = ACTIONS(2536),
    [anon_sym_LBRACK] = ACTIONS(1233),
    [anon_sym_static] = ACTIONS(2536),
    [anon_sym_register] = ACTIONS(2536),
    [anon_sym_inline] = ACTIONS(2536),
    [anon_sym___inline] = ACTIONS(2536),
    [anon_sym___inline__] = ACTIONS(2536),
    [anon_sym___forceinline] = ACTIONS(2536),
    [anon_sym_thread_local] = ACTIONS(2536),
    [anon_sym___thread] = ACTIONS(2536),
    [anon_sym_const] = ACTIONS(2536),
    [anon_sym_constexpr] = ACTIONS(2536),
    [anon_sym_volatile] = ACTIONS(2536),
    [anon_sym_restrict] = ACTIONS(2536),
    [anon_sym___restrict__] = ACTIONS(2536),
    [anon_sym__Atomic] = ACTIONS(2536),
    [anon_sym__Noreturn] = ACTIONS(2536),
    [anon_sym_noreturn] = ACTIONS(2536),
    [anon_sym__Nonnull] = ACTIONS(2536),
    [anon_sym_mutable] = ACTIONS(2536),
    [anon_sym_constinit] = ACTIONS(2536),
    [anon_sym_consteval] = ACTIONS(2536),
    [anon_sym_alignas] = ACTIONS(2536),
    [anon_sym__Alignas] = ACTIONS(2536),
    [sym_primitive_type] = ACTIONS(3327),
    [anon_sym_enum] = ACTIONS(2536),
    [anon_sym_class] = ACTIONS(2536),
    [anon_sym_struct] = ACTIONS(2536),
    [anon_sym_union] = ACTIONS(2536),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2536),
    [anon_sym_decltype] = ACTIONS(2547),
    [anon_sym_typename] = ACTIONS(2536),
    [anon_sym_template] = ACTIONS(2550),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [423] = {
    [sym_else_clause] = STATE(452),
    [sym_identifier] = ACTIONS(2567),
    [aux_sym_preproc_include_token1] = ACTIONS(2567),
    [aux_sym_preproc_def_token1] = ACTIONS(2567),
    [aux_sym_preproc_if_token1] = ACTIONS(2567),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2567),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2567),
    [sym_preproc_directive] = ACTIONS(2567),
    [anon_sym_LPAREN2] = ACTIONS(2569),
    [anon_sym_BANG] = ACTIONS(2569),
    [anon_sym_TILDE] = ACTIONS(2569),
    [anon_sym_DASH] = ACTIONS(2567),
    [anon_sym_PLUS] = ACTIONS(2567),
    [anon_sym_STAR] = ACTIONS(2569),
    [anon_sym_AMP_AMP] = ACTIONS(2569),
    [anon_sym_AMP] = ACTIONS(2567),
    [anon_sym_SEMI] = ACTIONS(2569),
    [anon_sym___extension__] = ACTIONS(2567),
    [anon_sym_typedef] = ACTIONS(2567),
    [anon_sym_virtual] = ACTIONS(2567),
    [anon_sym_extern] = ACTIONS(2567),
    [anon_sym___attribute__] = ACTIONS(2567),
    [anon_sym___attribute] = ACTIONS(2567),
    [anon_sym_COLON_COLON] = ACTIONS(2569),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2569),
    [anon_sym___declspec] = ACTIONS(2567),
    [anon_sym___based] = ACTIONS(2567),
    [anon_sym___cdecl] = ACTIONS(2567),
    [anon_sym___clrcall] = ACTIONS(2567),
    [anon_sym___stdcall] = ACTIONS(2567),
    [anon_sym___fastcall] = ACTIONS(2567),
    [anon_sym___thiscall] = ACTIONS(2567),
    [anon_sym___vectorcall] = ACTIONS(2567),
    [anon_sym_LBRACE] = ACTIONS(2569),
    [anon_sym_RBRACE] = ACTIONS(2569),
    [anon_sym_signed] = ACTIONS(2567),
    [anon_sym_unsigned] = ACTIONS(2567),
    [anon_sym_long] = ACTIONS(2567),
    [anon_sym_short] = ACTIONS(2567),
    [anon_sym_LBRACK] = ACTIONS(2567),
    [anon_sym_static] = ACTIONS(2567),
    [anon_sym_register] = ACTIONS(2567),
    [anon_sym_inline] = ACTIONS(2567),
    [anon_sym___inline] = ACTIONS(2567),
    [anon_sym___inline__] = ACTIONS(2567),
    [anon_sym___forceinline] = ACTIONS(2567),
    [anon_sym_thread_local] = ACTIONS(2567),
    [anon_sym___thread] = ACTIONS(2567),
    [anon_sym_const] = ACTIONS(2567),
    [anon_sym_constexpr] = ACTIONS(2567),
    [anon_sym_volatile] = ACTIONS(2567),
    [anon_sym_restrict] = ACTIONS(2567),
    [anon_sym___restrict__] = ACTIONS(2567),
    [anon_sym__Atomic] = ACTIONS(2567),
    [anon_sym__Noreturn] = ACTIONS(2567),
    [anon_sym_noreturn] = ACTIONS(2567),
    [anon_sym__Nonnull] = ACTIONS(2567),
    [anon_sym_mutable] = ACTIONS(2567),
    [anon_sym_constinit] = ACTIONS(2567),
    [anon_sym_consteval] = ACTIONS(2567),
    [anon_sym_alignas] = ACTIONS(2567),
    [anon_sym__Alignas] = ACTIONS(2567),
    [sym_primitive_type] = ACTIONS(2567),
    [anon_sym_enum] = ACTIONS(2567),
    [anon_sym_class] = ACTIONS(2567),
    [anon_sym_struct] = ACTIONS(2567),
    [anon_sym_union] = ACTIONS(2567),
    [anon_sym_if] = ACTIONS(2567),
    [anon_sym_else] = ACTIONS(3314),
    [anon_sym_switch] = ACTIONS(2567),
    [anon_sym_case] = ACTIONS(2567),
    [anon_sym_default] = ACTIONS(2567),
    [anon_sym_while] = ACTIONS(2567),
    [anon_sym_do] = ACTIONS(2567),
    [anon_sym_for] = ACTIONS(2567),
    [anon_sym_return] = ACTIONS(2567),
    [anon_sym_break] = ACTIONS(2567),
    [anon_sym_continue] = ACTIONS(2567),
    [anon_sym_goto] = ACTIONS(2567),
    [anon_sym___try] = ACTIONS(2567),
    [anon_sym___leave] = ACTIONS(2567),
    [anon_sym_not] = ACTIONS(2567),
    [anon_sym_compl] = ACTIONS(2567),
    [anon_sym_DASH_DASH] = ACTIONS(2569),
    [anon_sym_PLUS_PLUS] = ACTIONS(2569),
    [anon_sym_sizeof] = ACTIONS(2567),
    [anon_sym___alignof__] = ACTIONS(2567),
    [anon_sym___alignof] = ACTIONS(2567),
    [anon_sym__alignof] = ACTIONS(2567),
    [anon_sym_alignof] = ACTIONS(2567),
    [anon_sym__Alignof] = ACTIONS(2567),
    [anon_sym_offsetof] = ACTIONS(2567),
    [anon_sym__Generic] = ACTIONS(2567),
    [anon_sym_asm] = ACTIONS(2567),
    [anon_sym___asm__] = ACTIONS(2567),
    [anon_sym___asm] = ACTIONS(2567),
    [sym_number_literal] = ACTIONS(2569),
    [anon_sym_L_SQUOTE] = ACTIONS(2569),
    [anon_sym_u_SQUOTE] = ACTIONS(2569),
    [anon_sym_U_SQUOTE] = ACTIONS(2569),
    [anon_sym_u8_SQUOTE] = ACTIONS(2569),
    [anon_sym_SQUOTE] = ACTIONS(2569),
    [anon_sym_L_DQUOTE] = ACTIONS(2569),
    [anon_sym_u_DQUOTE] = ACTIONS(2569),
    [anon_sym_U_DQUOTE] = ACTIONS(2569),
    [anon_sym_u8_DQUOTE] = ACTIONS(2569),
    [anon_sym_DQUOTE] = ACTIONS(2569),
    [sym_true] = ACTIONS(2567),
    [sym_false] = ACTIONS(2567),
    [anon_sym_NULL] = ACTIONS(2567),
    [anon_sym_nullptr] = ACTIONS(2567),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2567),
    [anon_sym_decltype] = ACTIONS(2567),
    [anon_sym_explicit] = ACTIONS(2567),
    [anon_sym_typename] = ACTIONS(2567),
    [anon_sym_template] = ACTIONS(2567),
    [anon_sym_operator] = ACTIONS(2567),
    [anon_sym_try] = ACTIONS(2567),
    [anon_sym_delete] = ACTIONS(2567),
    [anon_sym_throw] = ACTIONS(2567),
    [anon_sym_namespace] = ACTIONS(2567),
    [anon_sym_using] = ACTIONS(2567),
    [anon_sym_static_assert] = ACTIONS(2567),
    [anon_sym_concept] = ACTIONS(2567),
    [anon_sym_co_return] = ACTIONS(2567),
    [anon_sym_co_yield] = ACTIONS(2567),
    [anon_sym_R_DQUOTE] = ACTIONS(2569),
    [anon_sym_LR_DQUOTE] = ACTIONS(2569),
    [anon_sym_uR_DQUOTE] = ACTIONS(2569),
    [anon_sym_UR_DQUOTE] = ACTIONS(2569),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2569),
    [anon_sym_co_await] = ACTIONS(2567),
    [anon_sym_new] = ACTIONS(2567),
    [anon_sym_requires] = ACTIONS(2567),
    [sym_this] = ACTIONS(2567),
  },
  [424] = {
    [sym_identifier] = ACTIONS(2657),
    [aux_sym_preproc_include_token1] = ACTIONS(2657),
    [aux_sym_preproc_def_token1] = ACTIONS(2657),
    [aux_sym_preproc_if_token1] = ACTIONS(2657),
    [aux_sym_preproc_if_token2] = ACTIONS(2657),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2657),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2657),
    [sym_preproc_directive] = ACTIONS(2657),
    [anon_sym_LPAREN2] = ACTIONS(2659),
    [anon_sym_BANG] = ACTIONS(2659),
    [anon_sym_TILDE] = ACTIONS(2659),
    [anon_sym_DASH] = ACTIONS(2657),
    [anon_sym_PLUS] = ACTIONS(2657),
    [anon_sym_STAR] = ACTIONS(2659),
    [anon_sym_AMP_AMP] = ACTIONS(2659),
    [anon_sym_AMP] = ACTIONS(2657),
    [anon_sym_SEMI] = ACTIONS(2659),
    [anon_sym___extension__] = ACTIONS(2657),
    [anon_sym_typedef] = ACTIONS(2657),
    [anon_sym_virtual] = ACTIONS(2657),
    [anon_sym_extern] = ACTIONS(2657),
    [anon_sym___attribute__] = ACTIONS(2657),
    [anon_sym___attribute] = ACTIONS(2657),
    [anon_sym_COLON_COLON] = ACTIONS(2659),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2659),
    [anon_sym___declspec] = ACTIONS(2657),
    [anon_sym___based] = ACTIONS(2657),
    [anon_sym___cdecl] = ACTIONS(2657),
    [anon_sym___clrcall] = ACTIONS(2657),
    [anon_sym___stdcall] = ACTIONS(2657),
    [anon_sym___fastcall] = ACTIONS(2657),
    [anon_sym___thiscall] = ACTIONS(2657),
    [anon_sym___vectorcall] = ACTIONS(2657),
    [anon_sym_LBRACE] = ACTIONS(2659),
    [anon_sym_signed] = ACTIONS(2657),
    [anon_sym_unsigned] = ACTIONS(2657),
    [anon_sym_long] = ACTIONS(2657),
    [anon_sym_short] = ACTIONS(2657),
    [anon_sym_LBRACK] = ACTIONS(2657),
    [anon_sym_static] = ACTIONS(2657),
    [anon_sym_register] = ACTIONS(2657),
    [anon_sym_inline] = ACTIONS(2657),
    [anon_sym___inline] = ACTIONS(2657),
    [anon_sym___inline__] = ACTIONS(2657),
    [anon_sym___forceinline] = ACTIONS(2657),
    [anon_sym_thread_local] = ACTIONS(2657),
    [anon_sym___thread] = ACTIONS(2657),
    [anon_sym_const] = ACTIONS(2657),
    [anon_sym_constexpr] = ACTIONS(2657),
    [anon_sym_volatile] = ACTIONS(2657),
    [anon_sym_restrict] = ACTIONS(2657),
    [anon_sym___restrict__] = ACTIONS(2657),
    [anon_sym__Atomic] = ACTIONS(2657),
    [anon_sym__Noreturn] = ACTIONS(2657),
    [anon_sym_noreturn] = ACTIONS(2657),
    [anon_sym__Nonnull] = ACTIONS(2657),
    [anon_sym_mutable] = ACTIONS(2657),
    [anon_sym_constinit] = ACTIONS(2657),
    [anon_sym_consteval] = ACTIONS(2657),
    [anon_sym_alignas] = ACTIONS(2657),
    [anon_sym__Alignas] = ACTIONS(2657),
    [sym_primitive_type] = ACTIONS(2657),
    [anon_sym_enum] = ACTIONS(2657),
    [anon_sym_class] = ACTIONS(2657),
    [anon_sym_struct] = ACTIONS(2657),
    [anon_sym_union] = ACTIONS(2657),
    [anon_sym_if] = ACTIONS(2657),
    [anon_sym_else] = ACTIONS(2657),
    [anon_sym_switch] = ACTIONS(2657),
    [anon_sym_case] = ACTIONS(2657),
    [anon_sym_default] = ACTIONS(2657),
    [anon_sym_while] = ACTIONS(2657),
    [anon_sym_do] = ACTIONS(2657),
    [anon_sym_for] = ACTIONS(2657),
    [anon_sym_return] = ACTIONS(2657),
    [anon_sym_break] = ACTIONS(2657),
    [anon_sym_continue] = ACTIONS(2657),
    [anon_sym_goto] = ACTIONS(2657),
    [anon_sym___try] = ACTIONS(2657),
    [anon_sym___leave] = ACTIONS(2657),
    [anon_sym_not] = ACTIONS(2657),
    [anon_sym_compl] = ACTIONS(2657),
    [anon_sym_DASH_DASH] = ACTIONS(2659),
    [anon_sym_PLUS_PLUS] = ACTIONS(2659),
    [anon_sym_sizeof] = ACTIONS(2657),
    [anon_sym___alignof__] = ACTIONS(2657),
    [anon_sym___alignof] = ACTIONS(2657),
    [anon_sym__alignof] = ACTIONS(2657),
    [anon_sym_alignof] = ACTIONS(2657),
    [anon_sym__Alignof] = ACTIONS(2657),
    [anon_sym_offsetof] = ACTIONS(2657),
    [anon_sym__Generic] = ACTIONS(2657),
    [anon_sym_asm] = ACTIONS(2657),
    [anon_sym___asm__] = ACTIONS(2657),
    [anon_sym___asm] = ACTIONS(2657),
    [sym_number_literal] = ACTIONS(2659),
    [anon_sym_L_SQUOTE] = ACTIONS(2659),
    [anon_sym_u_SQUOTE] = ACTIONS(2659),
    [anon_sym_U_SQUOTE] = ACTIONS(2659),
    [anon_sym_u8_SQUOTE] = ACTIONS(2659),
    [anon_sym_SQUOTE] = ACTIONS(2659),
    [anon_sym_L_DQUOTE] = ACTIONS(2659),
    [anon_sym_u_DQUOTE] = ACTIONS(2659),
    [anon_sym_U_DQUOTE] = ACTIONS(2659),
    [anon_sym_u8_DQUOTE] = ACTIONS(2659),
    [anon_sym_DQUOTE] = ACTIONS(2659),
    [sym_true] = ACTIONS(2657),
    [sym_false] = ACTIONS(2657),
    [anon_sym_NULL] = ACTIONS(2657),
    [anon_sym_nullptr] = ACTIONS(2657),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2657),
    [anon_sym_decltype] = ACTIONS(2657),
    [anon_sym_explicit] = ACTIONS(2657),
    [anon_sym_typename] = ACTIONS(2657),
    [anon_sym_template] = ACTIONS(2657),
    [anon_sym_operator] = ACTIONS(2657),
    [anon_sym_try] = ACTIONS(2657),
    [anon_sym_delete] = ACTIONS(2657),
    [anon_sym_throw] = ACTIONS(2657),
    [anon_sym_namespace] = ACTIONS(2657),
    [anon_sym_using] = ACTIONS(2657),
    [anon_sym_static_assert] = ACTIONS(2657),
    [anon_sym_concept] = ACTIONS(2657),
    [anon_sym_co_return] = ACTIONS(2657),
    [anon_sym_co_yield] = ACTIONS(2657),
    [anon_sym_R_DQUOTE] = ACTIONS(2659),
    [anon_sym_LR_DQUOTE] = ACTIONS(2659),
    [anon_sym_uR_DQUOTE] = ACTIONS(2659),
    [anon_sym_UR_DQUOTE] = ACTIONS(2659),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2659),
    [anon_sym_co_await] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(2657),
    [anon_sym_requires] = ACTIONS(2657),
    [sym_this] = ACTIONS(2657),
  },
  [425] = {
    [sym_identifier] = ACTIONS(2665),
    [aux_sym_preproc_include_token1] = ACTIONS(2665),
    [aux_sym_preproc_def_token1] = ACTIONS(2665),
    [aux_sym_preproc_if_token1] = ACTIONS(2665),
    [aux_sym_preproc_if_token2] = ACTIONS(2665),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2665),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2665),
    [sym_preproc_directive] = ACTIONS(2665),
    [anon_sym_LPAREN2] = ACTIONS(2667),
    [anon_sym_BANG] = ACTIONS(2667),
    [anon_sym_TILDE] = ACTIONS(2667),
    [anon_sym_DASH] = ACTIONS(2665),
    [anon_sym_PLUS] = ACTIONS(2665),
    [anon_sym_STAR] = ACTIONS(2667),
    [anon_sym_AMP_AMP] = ACTIONS(2667),
    [anon_sym_AMP] = ACTIONS(2665),
    [anon_sym_SEMI] = ACTIONS(2667),
    [anon_sym___extension__] = ACTIONS(2665),
    [anon_sym_typedef] = ACTIONS(2665),
    [anon_sym_virtual] = ACTIONS(2665),
    [anon_sym_extern] = ACTIONS(2665),
    [anon_sym___attribute__] = ACTIONS(2665),
    [anon_sym___attribute] = ACTIONS(2665),
    [anon_sym_COLON_COLON] = ACTIONS(2667),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2667),
    [anon_sym___declspec] = ACTIONS(2665),
    [anon_sym___based] = ACTIONS(2665),
    [anon_sym___cdecl] = ACTIONS(2665),
    [anon_sym___clrcall] = ACTIONS(2665),
    [anon_sym___stdcall] = ACTIONS(2665),
    [anon_sym___fastcall] = ACTIONS(2665),
    [anon_sym___thiscall] = ACTIONS(2665),
    [anon_sym___vectorcall] = ACTIONS(2665),
    [anon_sym_LBRACE] = ACTIONS(2667),
    [anon_sym_signed] = ACTIONS(2665),
    [anon_sym_unsigned] = ACTIONS(2665),
    [anon_sym_long] = ACTIONS(2665),
    [anon_sym_short] = ACTIONS(2665),
    [anon_sym_LBRACK] = ACTIONS(2665),
    [anon_sym_static] = ACTIONS(2665),
    [anon_sym_register] = ACTIONS(2665),
    [anon_sym_inline] = ACTIONS(2665),
    [anon_sym___inline] = ACTIONS(2665),
    [anon_sym___inline__] = ACTIONS(2665),
    [anon_sym___forceinline] = ACTIONS(2665),
    [anon_sym_thread_local] = ACTIONS(2665),
    [anon_sym___thread] = ACTIONS(2665),
    [anon_sym_const] = ACTIONS(2665),
    [anon_sym_constexpr] = ACTIONS(2665),
    [anon_sym_volatile] = ACTIONS(2665),
    [anon_sym_restrict] = ACTIONS(2665),
    [anon_sym___restrict__] = ACTIONS(2665),
    [anon_sym__Atomic] = ACTIONS(2665),
    [anon_sym__Noreturn] = ACTIONS(2665),
    [anon_sym_noreturn] = ACTIONS(2665),
    [anon_sym__Nonnull] = ACTIONS(2665),
    [anon_sym_mutable] = ACTIONS(2665),
    [anon_sym_constinit] = ACTIONS(2665),
    [anon_sym_consteval] = ACTIONS(2665),
    [anon_sym_alignas] = ACTIONS(2665),
    [anon_sym__Alignas] = ACTIONS(2665),
    [sym_primitive_type] = ACTIONS(2665),
    [anon_sym_enum] = ACTIONS(2665),
    [anon_sym_class] = ACTIONS(2665),
    [anon_sym_struct] = ACTIONS(2665),
    [anon_sym_union] = ACTIONS(2665),
    [anon_sym_if] = ACTIONS(2665),
    [anon_sym_else] = ACTIONS(2665),
    [anon_sym_switch] = ACTIONS(2665),
    [anon_sym_case] = ACTIONS(2665),
    [anon_sym_default] = ACTIONS(2665),
    [anon_sym_while] = ACTIONS(2665),
    [anon_sym_do] = ACTIONS(2665),
    [anon_sym_for] = ACTIONS(2665),
    [anon_sym_return] = ACTIONS(2665),
    [anon_sym_break] = ACTIONS(2665),
    [anon_sym_continue] = ACTIONS(2665),
    [anon_sym_goto] = ACTIONS(2665),
    [anon_sym___try] = ACTIONS(2665),
    [anon_sym___leave] = ACTIONS(2665),
    [anon_sym_not] = ACTIONS(2665),
    [anon_sym_compl] = ACTIONS(2665),
    [anon_sym_DASH_DASH] = ACTIONS(2667),
    [anon_sym_PLUS_PLUS] = ACTIONS(2667),
    [anon_sym_sizeof] = ACTIONS(2665),
    [anon_sym___alignof__] = ACTIONS(2665),
    [anon_sym___alignof] = ACTIONS(2665),
    [anon_sym__alignof] = ACTIONS(2665),
    [anon_sym_alignof] = ACTIONS(2665),
    [anon_sym__Alignof] = ACTIONS(2665),
    [anon_sym_offsetof] = ACTIONS(2665),
    [anon_sym__Generic] = ACTIONS(2665),
    [anon_sym_asm] = ACTIONS(2665),
    [anon_sym___asm__] = ACTIONS(2665),
    [anon_sym___asm] = ACTIONS(2665),
    [sym_number_literal] = ACTIONS(2667),
    [anon_sym_L_SQUOTE] = ACTIONS(2667),
    [anon_sym_u_SQUOTE] = ACTIONS(2667),
    [anon_sym_U_SQUOTE] = ACTIONS(2667),
    [anon_sym_u8_SQUOTE] = ACTIONS(2667),
    [anon_sym_SQUOTE] = ACTIONS(2667),
    [anon_sym_L_DQUOTE] = ACTIONS(2667),
    [anon_sym_u_DQUOTE] = ACTIONS(2667),
    [anon_sym_U_DQUOTE] = ACTIONS(2667),
    [anon_sym_u8_DQUOTE] = ACTIONS(2667),
    [anon_sym_DQUOTE] = ACTIONS(2667),
    [sym_true] = ACTIONS(2665),
    [sym_false] = ACTIONS(2665),
    [anon_sym_NULL] = ACTIONS(2665),
    [anon_sym_nullptr] = ACTIONS(2665),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2665),
    [anon_sym_decltype] = ACTIONS(2665),
    [anon_sym_explicit] = ACTIONS(2665),
    [anon_sym_typename] = ACTIONS(2665),
    [anon_sym_template] = ACTIONS(2665),
    [anon_sym_operator] = ACTIONS(2665),
    [anon_sym_try] = ACTIONS(2665),
    [anon_sym_delete] = ACTIONS(2665),
    [anon_sym_throw] = ACTIONS(2665),
    [anon_sym_namespace] = ACTIONS(2665),
    [anon_sym_using] = ACTIONS(2665),
    [anon_sym_static_assert] = ACTIONS(2665),
    [anon_sym_concept] = ACTIONS(2665),
    [anon_sym_co_return] = ACTIONS(2665),
    [anon_sym_co_yield] = ACTIONS(2665),
    [anon_sym_R_DQUOTE] = ACTIONS(2667),
    [anon_sym_LR_DQUOTE] = ACTIONS(2667),
    [anon_sym_uR_DQUOTE] = ACTIONS(2667),
    [anon_sym_UR_DQUOTE] = ACTIONS(2667),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2667),
    [anon_sym_co_await] = ACTIONS(2665),
    [anon_sym_new] = ACTIONS(2665),
    [anon_sym_requires] = ACTIONS(2665),
    [sym_this] = ACTIONS(2665),
  },
  [426] = {
    [sym_identifier] = ACTIONS(2669),
    [aux_sym_preproc_include_token1] = ACTIONS(2669),
    [aux_sym_preproc_def_token1] = ACTIONS(2669),
    [aux_sym_preproc_if_token1] = ACTIONS(2669),
    [aux_sym_preproc_if_token2] = ACTIONS(2669),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2669),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2669),
    [sym_preproc_directive] = ACTIONS(2669),
    [anon_sym_LPAREN2] = ACTIONS(2671),
    [anon_sym_BANG] = ACTIONS(2671),
    [anon_sym_TILDE] = ACTIONS(2671),
    [anon_sym_DASH] = ACTIONS(2669),
    [anon_sym_PLUS] = ACTIONS(2669),
    [anon_sym_STAR] = ACTIONS(2671),
    [anon_sym_AMP_AMP] = ACTIONS(2671),
    [anon_sym_AMP] = ACTIONS(2669),
    [anon_sym_SEMI] = ACTIONS(2671),
    [anon_sym___extension__] = ACTIONS(2669),
    [anon_sym_typedef] = ACTIONS(2669),
    [anon_sym_virtual] = ACTIONS(2669),
    [anon_sym_extern] = ACTIONS(2669),
    [anon_sym___attribute__] = ACTIONS(2669),
    [anon_sym___attribute] = ACTIONS(2669),
    [anon_sym_COLON_COLON] = ACTIONS(2671),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2671),
    [anon_sym___declspec] = ACTIONS(2669),
    [anon_sym___based] = ACTIONS(2669),
    [anon_sym___cdecl] = ACTIONS(2669),
    [anon_sym___clrcall] = ACTIONS(2669),
    [anon_sym___stdcall] = ACTIONS(2669),
    [anon_sym___fastcall] = ACTIONS(2669),
    [anon_sym___thiscall] = ACTIONS(2669),
    [anon_sym___vectorcall] = ACTIONS(2669),
    [anon_sym_LBRACE] = ACTIONS(2671),
    [anon_sym_signed] = ACTIONS(2669),
    [anon_sym_unsigned] = ACTIONS(2669),
    [anon_sym_long] = ACTIONS(2669),
    [anon_sym_short] = ACTIONS(2669),
    [anon_sym_LBRACK] = ACTIONS(2669),
    [anon_sym_static] = ACTIONS(2669),
    [anon_sym_register] = ACTIONS(2669),
    [anon_sym_inline] = ACTIONS(2669),
    [anon_sym___inline] = ACTIONS(2669),
    [anon_sym___inline__] = ACTIONS(2669),
    [anon_sym___forceinline] = ACTIONS(2669),
    [anon_sym_thread_local] = ACTIONS(2669),
    [anon_sym___thread] = ACTIONS(2669),
    [anon_sym_const] = ACTIONS(2669),
    [anon_sym_constexpr] = ACTIONS(2669),
    [anon_sym_volatile] = ACTIONS(2669),
    [anon_sym_restrict] = ACTIONS(2669),
    [anon_sym___restrict__] = ACTIONS(2669),
    [anon_sym__Atomic] = ACTIONS(2669),
    [anon_sym__Noreturn] = ACTIONS(2669),
    [anon_sym_noreturn] = ACTIONS(2669),
    [anon_sym__Nonnull] = ACTIONS(2669),
    [anon_sym_mutable] = ACTIONS(2669),
    [anon_sym_constinit] = ACTIONS(2669),
    [anon_sym_consteval] = ACTIONS(2669),
    [anon_sym_alignas] = ACTIONS(2669),
    [anon_sym__Alignas] = ACTIONS(2669),
    [sym_primitive_type] = ACTIONS(2669),
    [anon_sym_enum] = ACTIONS(2669),
    [anon_sym_class] = ACTIONS(2669),
    [anon_sym_struct] = ACTIONS(2669),
    [anon_sym_union] = ACTIONS(2669),
    [anon_sym_if] = ACTIONS(2669),
    [anon_sym_else] = ACTIONS(2669),
    [anon_sym_switch] = ACTIONS(2669),
    [anon_sym_case] = ACTIONS(2669),
    [anon_sym_default] = ACTIONS(2669),
    [anon_sym_while] = ACTIONS(2669),
    [anon_sym_do] = ACTIONS(2669),
    [anon_sym_for] = ACTIONS(2669),
    [anon_sym_return] = ACTIONS(2669),
    [anon_sym_break] = ACTIONS(2669),
    [anon_sym_continue] = ACTIONS(2669),
    [anon_sym_goto] = ACTIONS(2669),
    [anon_sym___try] = ACTIONS(2669),
    [anon_sym___leave] = ACTIONS(2669),
    [anon_sym_not] = ACTIONS(2669),
    [anon_sym_compl] = ACTIONS(2669),
    [anon_sym_DASH_DASH] = ACTIONS(2671),
    [anon_sym_PLUS_PLUS] = ACTIONS(2671),
    [anon_sym_sizeof] = ACTIONS(2669),
    [anon_sym___alignof__] = ACTIONS(2669),
    [anon_sym___alignof] = ACTIONS(2669),
    [anon_sym__alignof] = ACTIONS(2669),
    [anon_sym_alignof] = ACTIONS(2669),
    [anon_sym__Alignof] = ACTIONS(2669),
    [anon_sym_offsetof] = ACTIONS(2669),
    [anon_sym__Generic] = ACTIONS(2669),
    [anon_sym_asm] = ACTIONS(2669),
    [anon_sym___asm__] = ACTIONS(2669),
    [anon_sym___asm] = ACTIONS(2669),
    [sym_number_literal] = ACTIONS(2671),
    [anon_sym_L_SQUOTE] = ACTIONS(2671),
    [anon_sym_u_SQUOTE] = ACTIONS(2671),
    [anon_sym_U_SQUOTE] = ACTIONS(2671),
    [anon_sym_u8_SQUOTE] = ACTIONS(2671),
    [anon_sym_SQUOTE] = ACTIONS(2671),
    [anon_sym_L_DQUOTE] = ACTIONS(2671),
    [anon_sym_u_DQUOTE] = ACTIONS(2671),
    [anon_sym_U_DQUOTE] = ACTIONS(2671),
    [anon_sym_u8_DQUOTE] = ACTIONS(2671),
    [anon_sym_DQUOTE] = ACTIONS(2671),
    [sym_true] = ACTIONS(2669),
    [sym_false] = ACTIONS(2669),
    [anon_sym_NULL] = ACTIONS(2669),
    [anon_sym_nullptr] = ACTIONS(2669),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2669),
    [anon_sym_decltype] = ACTIONS(2669),
    [anon_sym_explicit] = ACTIONS(2669),
    [anon_sym_typename] = ACTIONS(2669),
    [anon_sym_template] = ACTIONS(2669),
    [anon_sym_operator] = ACTIONS(2669),
    [anon_sym_try] = ACTIONS(2669),
    [anon_sym_delete] = ACTIONS(2669),
    [anon_sym_throw] = ACTIONS(2669),
    [anon_sym_namespace] = ACTIONS(2669),
    [anon_sym_using] = ACTIONS(2669),
    [anon_sym_static_assert] = ACTIONS(2669),
    [anon_sym_concept] = ACTIONS(2669),
    [anon_sym_co_return] = ACTIONS(2669),
    [anon_sym_co_yield] = ACTIONS(2669),
    [anon_sym_R_DQUOTE] = ACTIONS(2671),
    [anon_sym_LR_DQUOTE] = ACTIONS(2671),
    [anon_sym_uR_DQUOTE] = ACTIONS(2671),
    [anon_sym_UR_DQUOTE] = ACTIONS(2671),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2671),
    [anon_sym_co_await] = ACTIONS(2669),
    [anon_sym_new] = ACTIONS(2669),
    [anon_sym_requires] = ACTIONS(2669),
    [sym_this] = ACTIONS(2669),
  },
  [427] = {
    [sym_identifier] = ACTIONS(2673),
    [aux_sym_preproc_include_token1] = ACTIONS(2673),
    [aux_sym_preproc_def_token1] = ACTIONS(2673),
    [aux_sym_preproc_if_token1] = ACTIONS(2673),
    [aux_sym_preproc_if_token2] = ACTIONS(2673),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2673),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2673),
    [sym_preproc_directive] = ACTIONS(2673),
    [anon_sym_LPAREN2] = ACTIONS(2675),
    [anon_sym_BANG] = ACTIONS(2675),
    [anon_sym_TILDE] = ACTIONS(2675),
    [anon_sym_DASH] = ACTIONS(2673),
    [anon_sym_PLUS] = ACTIONS(2673),
    [anon_sym_STAR] = ACTIONS(2675),
    [anon_sym_AMP_AMP] = ACTIONS(2675),
    [anon_sym_AMP] = ACTIONS(2673),
    [anon_sym_SEMI] = ACTIONS(2675),
    [anon_sym___extension__] = ACTIONS(2673),
    [anon_sym_typedef] = ACTIONS(2673),
    [anon_sym_virtual] = ACTIONS(2673),
    [anon_sym_extern] = ACTIONS(2673),
    [anon_sym___attribute__] = ACTIONS(2673),
    [anon_sym___attribute] = ACTIONS(2673),
    [anon_sym_COLON_COLON] = ACTIONS(2675),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2675),
    [anon_sym___declspec] = ACTIONS(2673),
    [anon_sym___based] = ACTIONS(2673),
    [anon_sym___cdecl] = ACTIONS(2673),
    [anon_sym___clrcall] = ACTIONS(2673),
    [anon_sym___stdcall] = ACTIONS(2673),
    [anon_sym___fastcall] = ACTIONS(2673),
    [anon_sym___thiscall] = ACTIONS(2673),
    [anon_sym___vectorcall] = ACTIONS(2673),
    [anon_sym_LBRACE] = ACTIONS(2675),
    [anon_sym_signed] = ACTIONS(2673),
    [anon_sym_unsigned] = ACTIONS(2673),
    [anon_sym_long] = ACTIONS(2673),
    [anon_sym_short] = ACTIONS(2673),
    [anon_sym_LBRACK] = ACTIONS(2673),
    [anon_sym_static] = ACTIONS(2673),
    [anon_sym_register] = ACTIONS(2673),
    [anon_sym_inline] = ACTIONS(2673),
    [anon_sym___inline] = ACTIONS(2673),
    [anon_sym___inline__] = ACTIONS(2673),
    [anon_sym___forceinline] = ACTIONS(2673),
    [anon_sym_thread_local] = ACTIONS(2673),
    [anon_sym___thread] = ACTIONS(2673),
    [anon_sym_const] = ACTIONS(2673),
    [anon_sym_constexpr] = ACTIONS(2673),
    [anon_sym_volatile] = ACTIONS(2673),
    [anon_sym_restrict] = ACTIONS(2673),
    [anon_sym___restrict__] = ACTIONS(2673),
    [anon_sym__Atomic] = ACTIONS(2673),
    [anon_sym__Noreturn] = ACTIONS(2673),
    [anon_sym_noreturn] = ACTIONS(2673),
    [anon_sym__Nonnull] = ACTIONS(2673),
    [anon_sym_mutable] = ACTIONS(2673),
    [anon_sym_constinit] = ACTIONS(2673),
    [anon_sym_consteval] = ACTIONS(2673),
    [anon_sym_alignas] = ACTIONS(2673),
    [anon_sym__Alignas] = ACTIONS(2673),
    [sym_primitive_type] = ACTIONS(2673),
    [anon_sym_enum] = ACTIONS(2673),
    [anon_sym_class] = ACTIONS(2673),
    [anon_sym_struct] = ACTIONS(2673),
    [anon_sym_union] = ACTIONS(2673),
    [anon_sym_if] = ACTIONS(2673),
    [anon_sym_else] = ACTIONS(2673),
    [anon_sym_switch] = ACTIONS(2673),
    [anon_sym_case] = ACTIONS(2673),
    [anon_sym_default] = ACTIONS(2673),
    [anon_sym_while] = ACTIONS(2673),
    [anon_sym_do] = ACTIONS(2673),
    [anon_sym_for] = ACTIONS(2673),
    [anon_sym_return] = ACTIONS(2673),
    [anon_sym_break] = ACTIONS(2673),
    [anon_sym_continue] = ACTIONS(2673),
    [anon_sym_goto] = ACTIONS(2673),
    [anon_sym___try] = ACTIONS(2673),
    [anon_sym___leave] = ACTIONS(2673),
    [anon_sym_not] = ACTIONS(2673),
    [anon_sym_compl] = ACTIONS(2673),
    [anon_sym_DASH_DASH] = ACTIONS(2675),
    [anon_sym_PLUS_PLUS] = ACTIONS(2675),
    [anon_sym_sizeof] = ACTIONS(2673),
    [anon_sym___alignof__] = ACTIONS(2673),
    [anon_sym___alignof] = ACTIONS(2673),
    [anon_sym__alignof] = ACTIONS(2673),
    [anon_sym_alignof] = ACTIONS(2673),
    [anon_sym__Alignof] = ACTIONS(2673),
    [anon_sym_offsetof] = ACTIONS(2673),
    [anon_sym__Generic] = ACTIONS(2673),
    [anon_sym_asm] = ACTIONS(2673),
    [anon_sym___asm__] = ACTIONS(2673),
    [anon_sym___asm] = ACTIONS(2673),
    [sym_number_literal] = ACTIONS(2675),
    [anon_sym_L_SQUOTE] = ACTIONS(2675),
    [anon_sym_u_SQUOTE] = ACTIONS(2675),
    [anon_sym_U_SQUOTE] = ACTIONS(2675),
    [anon_sym_u8_SQUOTE] = ACTIONS(2675),
    [anon_sym_SQUOTE] = ACTIONS(2675),
    [anon_sym_L_DQUOTE] = ACTIONS(2675),
    [anon_sym_u_DQUOTE] = ACTIONS(2675),
    [anon_sym_U_DQUOTE] = ACTIONS(2675),
    [anon_sym_u8_DQUOTE] = ACTIONS(2675),
    [anon_sym_DQUOTE] = ACTIONS(2675),
    [sym_true] = ACTIONS(2673),
    [sym_false] = ACTIONS(2673),
    [anon_sym_NULL] = ACTIONS(2673),
    [anon_sym_nullptr] = ACTIONS(2673),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2673),
    [anon_sym_decltype] = ACTIONS(2673),
    [anon_sym_explicit] = ACTIONS(2673),
    [anon_sym_typename] = ACTIONS(2673),
    [anon_sym_template] = ACTIONS(2673),
    [anon_sym_operator] = ACTIONS(2673),
    [anon_sym_try] = ACTIONS(2673),
    [anon_sym_delete] = ACTIONS(2673),
    [anon_sym_throw] = ACTIONS(2673),
    [anon_sym_namespace] = ACTIONS(2673),
    [anon_sym_using] = ACTIONS(2673),
    [anon_sym_static_assert] = ACTIONS(2673),
    [anon_sym_concept] = ACTIONS(2673),
    [anon_sym_co_return] = ACTIONS(2673),
    [anon_sym_co_yield] = ACTIONS(2673),
    [anon_sym_R_DQUOTE] = ACTIONS(2675),
    [anon_sym_LR_DQUOTE] = ACTIONS(2675),
    [anon_sym_uR_DQUOTE] = ACTIONS(2675),
    [anon_sym_UR_DQUOTE] = ACTIONS(2675),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2675),
    [anon_sym_co_await] = ACTIONS(2673),
    [anon_sym_new] = ACTIONS(2673),
    [anon_sym_requires] = ACTIONS(2673),
    [sym_this] = ACTIONS(2673),
  },
  [428] = {
    [sym_identifier] = ACTIONS(2585),
    [aux_sym_preproc_include_token1] = ACTIONS(2585),
    [aux_sym_preproc_def_token1] = ACTIONS(2585),
    [aux_sym_preproc_if_token1] = ACTIONS(2585),
    [aux_sym_preproc_if_token2] = ACTIONS(2585),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2585),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2585),
    [sym_preproc_directive] = ACTIONS(2585),
    [anon_sym_LPAREN2] = ACTIONS(2587),
    [anon_sym_BANG] = ACTIONS(2587),
    [anon_sym_TILDE] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2585),
    [anon_sym_PLUS] = ACTIONS(2585),
    [anon_sym_STAR] = ACTIONS(2587),
    [anon_sym_AMP_AMP] = ACTIONS(2587),
    [anon_sym_AMP] = ACTIONS(2585),
    [anon_sym_SEMI] = ACTIONS(2587),
    [anon_sym___extension__] = ACTIONS(2585),
    [anon_sym_typedef] = ACTIONS(2585),
    [anon_sym_virtual] = ACTIONS(2585),
    [anon_sym_extern] = ACTIONS(2585),
    [anon_sym___attribute__] = ACTIONS(2585),
    [anon_sym___attribute] = ACTIONS(2585),
    [anon_sym_COLON_COLON] = ACTIONS(2587),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2587),
    [anon_sym___declspec] = ACTIONS(2585),
    [anon_sym___based] = ACTIONS(2585),
    [anon_sym___cdecl] = ACTIONS(2585),
    [anon_sym___clrcall] = ACTIONS(2585),
    [anon_sym___stdcall] = ACTIONS(2585),
    [anon_sym___fastcall] = ACTIONS(2585),
    [anon_sym___thiscall] = ACTIONS(2585),
    [anon_sym___vectorcall] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2587),
    [anon_sym_signed] = ACTIONS(2585),
    [anon_sym_unsigned] = ACTIONS(2585),
    [anon_sym_long] = ACTIONS(2585),
    [anon_sym_short] = ACTIONS(2585),
    [anon_sym_LBRACK] = ACTIONS(2585),
    [anon_sym_static] = ACTIONS(2585),
    [anon_sym_register] = ACTIONS(2585),
    [anon_sym_inline] = ACTIONS(2585),
    [anon_sym___inline] = ACTIONS(2585),
    [anon_sym___inline__] = ACTIONS(2585),
    [anon_sym___forceinline] = ACTIONS(2585),
    [anon_sym_thread_local] = ACTIONS(2585),
    [anon_sym___thread] = ACTIONS(2585),
    [anon_sym_const] = ACTIONS(2585),
    [anon_sym_constexpr] = ACTIONS(2585),
    [anon_sym_volatile] = ACTIONS(2585),
    [anon_sym_restrict] = ACTIONS(2585),
    [anon_sym___restrict__] = ACTIONS(2585),
    [anon_sym__Atomic] = ACTIONS(2585),
    [anon_sym__Noreturn] = ACTIONS(2585),
    [anon_sym_noreturn] = ACTIONS(2585),
    [anon_sym__Nonnull] = ACTIONS(2585),
    [anon_sym_mutable] = ACTIONS(2585),
    [anon_sym_constinit] = ACTIONS(2585),
    [anon_sym_consteval] = ACTIONS(2585),
    [anon_sym_alignas] = ACTIONS(2585),
    [anon_sym__Alignas] = ACTIONS(2585),
    [sym_primitive_type] = ACTIONS(2585),
    [anon_sym_enum] = ACTIONS(2585),
    [anon_sym_class] = ACTIONS(2585),
    [anon_sym_struct] = ACTIONS(2585),
    [anon_sym_union] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2585),
    [anon_sym_else] = ACTIONS(2585),
    [anon_sym_switch] = ACTIONS(2585),
    [anon_sym_case] = ACTIONS(2585),
    [anon_sym_default] = ACTIONS(2585),
    [anon_sym_while] = ACTIONS(2585),
    [anon_sym_do] = ACTIONS(2585),
    [anon_sym_for] = ACTIONS(2585),
    [anon_sym_return] = ACTIONS(2585),
    [anon_sym_break] = ACTIONS(2585),
    [anon_sym_continue] = ACTIONS(2585),
    [anon_sym_goto] = ACTIONS(2585),
    [anon_sym___try] = ACTIONS(2585),
    [anon_sym___leave] = ACTIONS(2585),
    [anon_sym_not] = ACTIONS(2585),
    [anon_sym_compl] = ACTIONS(2585),
    [anon_sym_DASH_DASH] = ACTIONS(2587),
    [anon_sym_PLUS_PLUS] = ACTIONS(2587),
    [anon_sym_sizeof] = ACTIONS(2585),
    [anon_sym___alignof__] = ACTIONS(2585),
    [anon_sym___alignof] = ACTIONS(2585),
    [anon_sym__alignof] = ACTIONS(2585),
    [anon_sym_alignof] = ACTIONS(2585),
    [anon_sym__Alignof] = ACTIONS(2585),
    [anon_sym_offsetof] = ACTIONS(2585),
    [anon_sym__Generic] = ACTIONS(2585),
    [anon_sym_asm] = ACTIONS(2585),
    [anon_sym___asm__] = ACTIONS(2585),
    [anon_sym___asm] = ACTIONS(2585),
    [sym_number_literal] = ACTIONS(2587),
    [anon_sym_L_SQUOTE] = ACTIONS(2587),
    [anon_sym_u_SQUOTE] = ACTIONS(2587),
    [anon_sym_U_SQUOTE] = ACTIONS(2587),
    [anon_sym_u8_SQUOTE] = ACTIONS(2587),
    [anon_sym_SQUOTE] = ACTIONS(2587),
    [anon_sym_L_DQUOTE] = ACTIONS(2587),
    [anon_sym_u_DQUOTE] = ACTIONS(2587),
    [anon_sym_U_DQUOTE] = ACTIONS(2587),
    [anon_sym_u8_DQUOTE] = ACTIONS(2587),
    [anon_sym_DQUOTE] = ACTIONS(2587),
    [sym_true] = ACTIONS(2585),
    [sym_false] = ACTIONS(2585),
    [anon_sym_NULL] = ACTIONS(2585),
    [anon_sym_nullptr] = ACTIONS(2585),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2585),
    [anon_sym_decltype] = ACTIONS(2585),
    [anon_sym_explicit] = ACTIONS(2585),
    [anon_sym_typename] = ACTIONS(2585),
    [anon_sym_template] = ACTIONS(2585),
    [anon_sym_operator] = ACTIONS(2585),
    [anon_sym_try] = ACTIONS(2585),
    [anon_sym_delete] = ACTIONS(2585),
    [anon_sym_throw] = ACTIONS(2585),
    [anon_sym_namespace] = ACTIONS(2585),
    [anon_sym_using] = ACTIONS(2585),
    [anon_sym_static_assert] = ACTIONS(2585),
    [anon_sym_concept] = ACTIONS(2585),
    [anon_sym_co_return] = ACTIONS(2585),
    [anon_sym_co_yield] = ACTIONS(2585),
    [anon_sym_R_DQUOTE] = ACTIONS(2587),
    [anon_sym_LR_DQUOTE] = ACTIONS(2587),
    [anon_sym_uR_DQUOTE] = ACTIONS(2587),
    [anon_sym_UR_DQUOTE] = ACTIONS(2587),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2587),
    [anon_sym_co_await] = ACTIONS(2585),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_requires] = ACTIONS(2585),
    [sym_this] = ACTIONS(2585),
  },
  [429] = {
    [ts_builtin_sym_end] = ACTIONS(2603),
    [sym_identifier] = ACTIONS(2601),
    [aux_sym_preproc_include_token1] = ACTIONS(2601),
    [aux_sym_preproc_def_token1] = ACTIONS(2601),
    [aux_sym_preproc_if_token1] = ACTIONS(2601),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2601),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2601),
    [sym_preproc_directive] = ACTIONS(2601),
    [anon_sym_LPAREN2] = ACTIONS(2603),
    [anon_sym_BANG] = ACTIONS(2603),
    [anon_sym_TILDE] = ACTIONS(2603),
    [anon_sym_DASH] = ACTIONS(2601),
    [anon_sym_PLUS] = ACTIONS(2601),
    [anon_sym_STAR] = ACTIONS(2603),
    [anon_sym_AMP_AMP] = ACTIONS(2603),
    [anon_sym_AMP] = ACTIONS(2601),
    [anon_sym_SEMI] = ACTIONS(2603),
    [anon_sym___extension__] = ACTIONS(2601),
    [anon_sym_typedef] = ACTIONS(2601),
    [anon_sym_virtual] = ACTIONS(2601),
    [anon_sym_extern] = ACTIONS(2601),
    [anon_sym___attribute__] = ACTIONS(2601),
    [anon_sym___attribute] = ACTIONS(2601),
    [anon_sym_COLON_COLON] = ACTIONS(2603),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2603),
    [anon_sym___declspec] = ACTIONS(2601),
    [anon_sym___based] = ACTIONS(2601),
    [anon_sym___cdecl] = ACTIONS(2601),
    [anon_sym___clrcall] = ACTIONS(2601),
    [anon_sym___stdcall] = ACTIONS(2601),
    [anon_sym___fastcall] = ACTIONS(2601),
    [anon_sym___thiscall] = ACTIONS(2601),
    [anon_sym___vectorcall] = ACTIONS(2601),
    [anon_sym_LBRACE] = ACTIONS(2603),
    [anon_sym_signed] = ACTIONS(2601),
    [anon_sym_unsigned] = ACTIONS(2601),
    [anon_sym_long] = ACTIONS(2601),
    [anon_sym_short] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2601),
    [anon_sym_static] = ACTIONS(2601),
    [anon_sym_register] = ACTIONS(2601),
    [anon_sym_inline] = ACTIONS(2601),
    [anon_sym___inline] = ACTIONS(2601),
    [anon_sym___inline__] = ACTIONS(2601),
    [anon_sym___forceinline] = ACTIONS(2601),
    [anon_sym_thread_local] = ACTIONS(2601),
    [anon_sym___thread] = ACTIONS(2601),
    [anon_sym_const] = ACTIONS(2601),
    [anon_sym_constexpr] = ACTIONS(2601),
    [anon_sym_volatile] = ACTIONS(2601),
    [anon_sym_restrict] = ACTIONS(2601),
    [anon_sym___restrict__] = ACTIONS(2601),
    [anon_sym__Atomic] = ACTIONS(2601),
    [anon_sym__Noreturn] = ACTIONS(2601),
    [anon_sym_noreturn] = ACTIONS(2601),
    [anon_sym__Nonnull] = ACTIONS(2601),
    [anon_sym_mutable] = ACTIONS(2601),
    [anon_sym_constinit] = ACTIONS(2601),
    [anon_sym_consteval] = ACTIONS(2601),
    [anon_sym_alignas] = ACTIONS(2601),
    [anon_sym__Alignas] = ACTIONS(2601),
    [sym_primitive_type] = ACTIONS(2601),
    [anon_sym_enum] = ACTIONS(2601),
    [anon_sym_class] = ACTIONS(2601),
    [anon_sym_struct] = ACTIONS(2601),
    [anon_sym_union] = ACTIONS(2601),
    [anon_sym_if] = ACTIONS(2601),
    [anon_sym_else] = ACTIONS(2601),
    [anon_sym_switch] = ACTIONS(2601),
    [anon_sym_case] = ACTIONS(2601),
    [anon_sym_default] = ACTIONS(2601),
    [anon_sym_while] = ACTIONS(2601),
    [anon_sym_do] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2601),
    [anon_sym_return] = ACTIONS(2601),
    [anon_sym_break] = ACTIONS(2601),
    [anon_sym_continue] = ACTIONS(2601),
    [anon_sym_goto] = ACTIONS(2601),
    [anon_sym___try] = ACTIONS(2601),
    [anon_sym___leave] = ACTIONS(2601),
    [anon_sym_not] = ACTIONS(2601),
    [anon_sym_compl] = ACTIONS(2601),
    [anon_sym_DASH_DASH] = ACTIONS(2603),
    [anon_sym_PLUS_PLUS] = ACTIONS(2603),
    [anon_sym_sizeof] = ACTIONS(2601),
    [anon_sym___alignof__] = ACTIONS(2601),
    [anon_sym___alignof] = ACTIONS(2601),
    [anon_sym__alignof] = ACTIONS(2601),
    [anon_sym_alignof] = ACTIONS(2601),
    [anon_sym__Alignof] = ACTIONS(2601),
    [anon_sym_offsetof] = ACTIONS(2601),
    [anon_sym__Generic] = ACTIONS(2601),
    [anon_sym_asm] = ACTIONS(2601),
    [anon_sym___asm__] = ACTIONS(2601),
    [anon_sym___asm] = ACTIONS(2601),
    [sym_number_literal] = ACTIONS(2603),
    [anon_sym_L_SQUOTE] = ACTIONS(2603),
    [anon_sym_u_SQUOTE] = ACTIONS(2603),
    [anon_sym_U_SQUOTE] = ACTIONS(2603),
    [anon_sym_u8_SQUOTE] = ACTIONS(2603),
    [anon_sym_SQUOTE] = ACTIONS(2603),
    [anon_sym_L_DQUOTE] = ACTIONS(2603),
    [anon_sym_u_DQUOTE] = ACTIONS(2603),
    [anon_sym_U_DQUOTE] = ACTIONS(2603),
    [anon_sym_u8_DQUOTE] = ACTIONS(2603),
    [anon_sym_DQUOTE] = ACTIONS(2603),
    [sym_true] = ACTIONS(2601),
    [sym_false] = ACTIONS(2601),
    [anon_sym_NULL] = ACTIONS(2601),
    [anon_sym_nullptr] = ACTIONS(2601),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2601),
    [anon_sym_decltype] = ACTIONS(2601),
    [anon_sym_explicit] = ACTIONS(2601),
    [anon_sym_typename] = ACTIONS(2601),
    [anon_sym_template] = ACTIONS(2601),
    [anon_sym_operator] = ACTIONS(2601),
    [anon_sym_try] = ACTIONS(2601),
    [anon_sym_delete] = ACTIONS(2601),
    [anon_sym_throw] = ACTIONS(2601),
    [anon_sym_namespace] = ACTIONS(2601),
    [anon_sym_using] = ACTIONS(2601),
    [anon_sym_static_assert] = ACTIONS(2601),
    [anon_sym_concept] = ACTIONS(2601),
    [anon_sym_co_return] = ACTIONS(2601),
    [anon_sym_co_yield] = ACTIONS(2601),
    [anon_sym_R_DQUOTE] = ACTIONS(2603),
    [anon_sym_LR_DQUOTE] = ACTIONS(2603),
    [anon_sym_uR_DQUOTE] = ACTIONS(2603),
    [anon_sym_UR_DQUOTE] = ACTIONS(2603),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2603),
    [anon_sym_co_await] = ACTIONS(2601),
    [anon_sym_new] = ACTIONS(2601),
    [anon_sym_requires] = ACTIONS(2601),
    [sym_this] = ACTIONS(2601),
  },
  [430] = {
    [sym_identifier] = ACTIONS(2609),
    [aux_sym_preproc_include_token1] = ACTIONS(2609),
    [aux_sym_preproc_def_token1] = ACTIONS(2609),
    [aux_sym_preproc_if_token1] = ACTIONS(2609),
    [aux_sym_preproc_if_token2] = ACTIONS(2609),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2609),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2609),
    [sym_preproc_directive] = ACTIONS(2609),
    [anon_sym_LPAREN2] = ACTIONS(2611),
    [anon_sym_BANG] = ACTIONS(2611),
    [anon_sym_TILDE] = ACTIONS(2611),
    [anon_sym_DASH] = ACTIONS(2609),
    [anon_sym_PLUS] = ACTIONS(2609),
    [anon_sym_STAR] = ACTIONS(2611),
    [anon_sym_AMP_AMP] = ACTIONS(2611),
    [anon_sym_AMP] = ACTIONS(2609),
    [anon_sym_SEMI] = ACTIONS(2611),
    [anon_sym___extension__] = ACTIONS(2609),
    [anon_sym_typedef] = ACTIONS(2609),
    [anon_sym_virtual] = ACTIONS(2609),
    [anon_sym_extern] = ACTIONS(2609),
    [anon_sym___attribute__] = ACTIONS(2609),
    [anon_sym___attribute] = ACTIONS(2609),
    [anon_sym_COLON_COLON] = ACTIONS(2611),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2611),
    [anon_sym___declspec] = ACTIONS(2609),
    [anon_sym___based] = ACTIONS(2609),
    [anon_sym___cdecl] = ACTIONS(2609),
    [anon_sym___clrcall] = ACTIONS(2609),
    [anon_sym___stdcall] = ACTIONS(2609),
    [anon_sym___fastcall] = ACTIONS(2609),
    [anon_sym___thiscall] = ACTIONS(2609),
    [anon_sym___vectorcall] = ACTIONS(2609),
    [anon_sym_LBRACE] = ACTIONS(2611),
    [anon_sym_signed] = ACTIONS(2609),
    [anon_sym_unsigned] = ACTIONS(2609),
    [anon_sym_long] = ACTIONS(2609),
    [anon_sym_short] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(2609),
    [anon_sym_static] = ACTIONS(2609),
    [anon_sym_register] = ACTIONS(2609),
    [anon_sym_inline] = ACTIONS(2609),
    [anon_sym___inline] = ACTIONS(2609),
    [anon_sym___inline__] = ACTIONS(2609),
    [anon_sym___forceinline] = ACTIONS(2609),
    [anon_sym_thread_local] = ACTIONS(2609),
    [anon_sym___thread] = ACTIONS(2609),
    [anon_sym_const] = ACTIONS(2609),
    [anon_sym_constexpr] = ACTIONS(2609),
    [anon_sym_volatile] = ACTIONS(2609),
    [anon_sym_restrict] = ACTIONS(2609),
    [anon_sym___restrict__] = ACTIONS(2609),
    [anon_sym__Atomic] = ACTIONS(2609),
    [anon_sym__Noreturn] = ACTIONS(2609),
    [anon_sym_noreturn] = ACTIONS(2609),
    [anon_sym__Nonnull] = ACTIONS(2609),
    [anon_sym_mutable] = ACTIONS(2609),
    [anon_sym_constinit] = ACTIONS(2609),
    [anon_sym_consteval] = ACTIONS(2609),
    [anon_sym_alignas] = ACTIONS(2609),
    [anon_sym__Alignas] = ACTIONS(2609),
    [sym_primitive_type] = ACTIONS(2609),
    [anon_sym_enum] = ACTIONS(2609),
    [anon_sym_class] = ACTIONS(2609),
    [anon_sym_struct] = ACTIONS(2609),
    [anon_sym_union] = ACTIONS(2609),
    [anon_sym_if] = ACTIONS(2609),
    [anon_sym_else] = ACTIONS(2609),
    [anon_sym_switch] = ACTIONS(2609),
    [anon_sym_case] = ACTIONS(2609),
    [anon_sym_default] = ACTIONS(2609),
    [anon_sym_while] = ACTIONS(2609),
    [anon_sym_do] = ACTIONS(2609),
    [anon_sym_for] = ACTIONS(2609),
    [anon_sym_return] = ACTIONS(2609),
    [anon_sym_break] = ACTIONS(2609),
    [anon_sym_continue] = ACTIONS(2609),
    [anon_sym_goto] = ACTIONS(2609),
    [anon_sym___try] = ACTIONS(2609),
    [anon_sym___leave] = ACTIONS(2609),
    [anon_sym_not] = ACTIONS(2609),
    [anon_sym_compl] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(2611),
    [anon_sym_PLUS_PLUS] = ACTIONS(2611),
    [anon_sym_sizeof] = ACTIONS(2609),
    [anon_sym___alignof__] = ACTIONS(2609),
    [anon_sym___alignof] = ACTIONS(2609),
    [anon_sym__alignof] = ACTIONS(2609),
    [anon_sym_alignof] = ACTIONS(2609),
    [anon_sym__Alignof] = ACTIONS(2609),
    [anon_sym_offsetof] = ACTIONS(2609),
    [anon_sym__Generic] = ACTIONS(2609),
    [anon_sym_asm] = ACTIONS(2609),
    [anon_sym___asm__] = ACTIONS(2609),
    [anon_sym___asm] = ACTIONS(2609),
    [sym_number_literal] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2611),
    [anon_sym_u_SQUOTE] = ACTIONS(2611),
    [anon_sym_U_SQUOTE] = ACTIONS(2611),
    [anon_sym_u8_SQUOTE] = ACTIONS(2611),
    [anon_sym_SQUOTE] = ACTIONS(2611),
    [anon_sym_L_DQUOTE] = ACTIONS(2611),
    [anon_sym_u_DQUOTE] = ACTIONS(2611),
    [anon_sym_U_DQUOTE] = ACTIONS(2611),
    [anon_sym_u8_DQUOTE] = ACTIONS(2611),
    [anon_sym_DQUOTE] = ACTIONS(2611),
    [sym_true] = ACTIONS(2609),
    [sym_false] = ACTIONS(2609),
    [anon_sym_NULL] = ACTIONS(2609),
    [anon_sym_nullptr] = ACTIONS(2609),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2609),
    [anon_sym_decltype] = ACTIONS(2609),
    [anon_sym_explicit] = ACTIONS(2609),
    [anon_sym_typename] = ACTIONS(2609),
    [anon_sym_template] = ACTIONS(2609),
    [anon_sym_operator] = ACTIONS(2609),
    [anon_sym_try] = ACTIONS(2609),
    [anon_sym_delete] = ACTIONS(2609),
    [anon_sym_throw] = ACTIONS(2609),
    [anon_sym_namespace] = ACTIONS(2609),
    [anon_sym_using] = ACTIONS(2609),
    [anon_sym_static_assert] = ACTIONS(2609),
    [anon_sym_concept] = ACTIONS(2609),
    [anon_sym_co_return] = ACTIONS(2609),
    [anon_sym_co_yield] = ACTIONS(2609),
    [anon_sym_R_DQUOTE] = ACTIONS(2611),
    [anon_sym_LR_DQUOTE] = ACTIONS(2611),
    [anon_sym_uR_DQUOTE] = ACTIONS(2611),
    [anon_sym_UR_DQUOTE] = ACTIONS(2611),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2611),
    [anon_sym_co_await] = ACTIONS(2609),
    [anon_sym_new] = ACTIONS(2609),
    [anon_sym_requires] = ACTIONS(2609),
    [sym_this] = ACTIONS(2609),
  },
  [431] = {
    [sym_identifier] = ACTIONS(2609),
    [aux_sym_preproc_include_token1] = ACTIONS(2609),
    [aux_sym_preproc_def_token1] = ACTIONS(2609),
    [aux_sym_preproc_if_token1] = ACTIONS(2609),
    [aux_sym_preproc_if_token2] = ACTIONS(2609),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2609),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2609),
    [sym_preproc_directive] = ACTIONS(2609),
    [anon_sym_LPAREN2] = ACTIONS(2611),
    [anon_sym_BANG] = ACTIONS(2611),
    [anon_sym_TILDE] = ACTIONS(2611),
    [anon_sym_DASH] = ACTIONS(2609),
    [anon_sym_PLUS] = ACTIONS(2609),
    [anon_sym_STAR] = ACTIONS(2611),
    [anon_sym_AMP_AMP] = ACTIONS(2611),
    [anon_sym_AMP] = ACTIONS(2609),
    [anon_sym_SEMI] = ACTIONS(2611),
    [anon_sym___extension__] = ACTIONS(2609),
    [anon_sym_typedef] = ACTIONS(2609),
    [anon_sym_virtual] = ACTIONS(2609),
    [anon_sym_extern] = ACTIONS(2609),
    [anon_sym___attribute__] = ACTIONS(2609),
    [anon_sym___attribute] = ACTIONS(2609),
    [anon_sym_COLON_COLON] = ACTIONS(2611),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2611),
    [anon_sym___declspec] = ACTIONS(2609),
    [anon_sym___based] = ACTIONS(2609),
    [anon_sym___cdecl] = ACTIONS(2609),
    [anon_sym___clrcall] = ACTIONS(2609),
    [anon_sym___stdcall] = ACTIONS(2609),
    [anon_sym___fastcall] = ACTIONS(2609),
    [anon_sym___thiscall] = ACTIONS(2609),
    [anon_sym___vectorcall] = ACTIONS(2609),
    [anon_sym_LBRACE] = ACTIONS(2611),
    [anon_sym_signed] = ACTIONS(2609),
    [anon_sym_unsigned] = ACTIONS(2609),
    [anon_sym_long] = ACTIONS(2609),
    [anon_sym_short] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(2609),
    [anon_sym_static] = ACTIONS(2609),
    [anon_sym_register] = ACTIONS(2609),
    [anon_sym_inline] = ACTIONS(2609),
    [anon_sym___inline] = ACTIONS(2609),
    [anon_sym___inline__] = ACTIONS(2609),
    [anon_sym___forceinline] = ACTIONS(2609),
    [anon_sym_thread_local] = ACTIONS(2609),
    [anon_sym___thread] = ACTIONS(2609),
    [anon_sym_const] = ACTIONS(2609),
    [anon_sym_constexpr] = ACTIONS(2609),
    [anon_sym_volatile] = ACTIONS(2609),
    [anon_sym_restrict] = ACTIONS(2609),
    [anon_sym___restrict__] = ACTIONS(2609),
    [anon_sym__Atomic] = ACTIONS(2609),
    [anon_sym__Noreturn] = ACTIONS(2609),
    [anon_sym_noreturn] = ACTIONS(2609),
    [anon_sym__Nonnull] = ACTIONS(2609),
    [anon_sym_mutable] = ACTIONS(2609),
    [anon_sym_constinit] = ACTIONS(2609),
    [anon_sym_consteval] = ACTIONS(2609),
    [anon_sym_alignas] = ACTIONS(2609),
    [anon_sym__Alignas] = ACTIONS(2609),
    [sym_primitive_type] = ACTIONS(2609),
    [anon_sym_enum] = ACTIONS(2609),
    [anon_sym_class] = ACTIONS(2609),
    [anon_sym_struct] = ACTIONS(2609),
    [anon_sym_union] = ACTIONS(2609),
    [anon_sym_if] = ACTIONS(2609),
    [anon_sym_else] = ACTIONS(2609),
    [anon_sym_switch] = ACTIONS(2609),
    [anon_sym_case] = ACTIONS(2609),
    [anon_sym_default] = ACTIONS(2609),
    [anon_sym_while] = ACTIONS(2609),
    [anon_sym_do] = ACTIONS(2609),
    [anon_sym_for] = ACTIONS(2609),
    [anon_sym_return] = ACTIONS(2609),
    [anon_sym_break] = ACTIONS(2609),
    [anon_sym_continue] = ACTIONS(2609),
    [anon_sym_goto] = ACTIONS(2609),
    [anon_sym___try] = ACTIONS(2609),
    [anon_sym___leave] = ACTIONS(2609),
    [anon_sym_not] = ACTIONS(2609),
    [anon_sym_compl] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(2611),
    [anon_sym_PLUS_PLUS] = ACTIONS(2611),
    [anon_sym_sizeof] = ACTIONS(2609),
    [anon_sym___alignof__] = ACTIONS(2609),
    [anon_sym___alignof] = ACTIONS(2609),
    [anon_sym__alignof] = ACTIONS(2609),
    [anon_sym_alignof] = ACTIONS(2609),
    [anon_sym__Alignof] = ACTIONS(2609),
    [anon_sym_offsetof] = ACTIONS(2609),
    [anon_sym__Generic] = ACTIONS(2609),
    [anon_sym_asm] = ACTIONS(2609),
    [anon_sym___asm__] = ACTIONS(2609),
    [anon_sym___asm] = ACTIONS(2609),
    [sym_number_literal] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2611),
    [anon_sym_u_SQUOTE] = ACTIONS(2611),
    [anon_sym_U_SQUOTE] = ACTIONS(2611),
    [anon_sym_u8_SQUOTE] = ACTIONS(2611),
    [anon_sym_SQUOTE] = ACTIONS(2611),
    [anon_sym_L_DQUOTE] = ACTIONS(2611),
    [anon_sym_u_DQUOTE] = ACTIONS(2611),
    [anon_sym_U_DQUOTE] = ACTIONS(2611),
    [anon_sym_u8_DQUOTE] = ACTIONS(2611),
    [anon_sym_DQUOTE] = ACTIONS(2611),
    [sym_true] = ACTIONS(2609),
    [sym_false] = ACTIONS(2609),
    [anon_sym_NULL] = ACTIONS(2609),
    [anon_sym_nullptr] = ACTIONS(2609),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2609),
    [anon_sym_decltype] = ACTIONS(2609),
    [anon_sym_explicit] = ACTIONS(2609),
    [anon_sym_typename] = ACTIONS(2609),
    [anon_sym_template] = ACTIONS(2609),
    [anon_sym_operator] = ACTIONS(2609),
    [anon_sym_try] = ACTIONS(2609),
    [anon_sym_delete] = ACTIONS(2609),
    [anon_sym_throw] = ACTIONS(2609),
    [anon_sym_namespace] = ACTIONS(2609),
    [anon_sym_using] = ACTIONS(2609),
    [anon_sym_static_assert] = ACTIONS(2609),
    [anon_sym_concept] = ACTIONS(2609),
    [anon_sym_co_return] = ACTIONS(2609),
    [anon_sym_co_yield] = ACTIONS(2609),
    [anon_sym_R_DQUOTE] = ACTIONS(2611),
    [anon_sym_LR_DQUOTE] = ACTIONS(2611),
    [anon_sym_uR_DQUOTE] = ACTIONS(2611),
    [anon_sym_UR_DQUOTE] = ACTIONS(2611),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2611),
    [anon_sym_co_await] = ACTIONS(2609),
    [anon_sym_new] = ACTIONS(2609),
    [anon_sym_requires] = ACTIONS(2609),
    [sym_this] = ACTIONS(2609),
  },
  [432] = {
    [ts_builtin_sym_end] = ACTIONS(2607),
    [sym_identifier] = ACTIONS(2605),
    [aux_sym_preproc_include_token1] = ACTIONS(2605),
    [aux_sym_preproc_def_token1] = ACTIONS(2605),
    [aux_sym_preproc_if_token1] = ACTIONS(2605),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2605),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2605),
    [sym_preproc_directive] = ACTIONS(2605),
    [anon_sym_LPAREN2] = ACTIONS(2607),
    [anon_sym_BANG] = ACTIONS(2607),
    [anon_sym_TILDE] = ACTIONS(2607),
    [anon_sym_DASH] = ACTIONS(2605),
    [anon_sym_PLUS] = ACTIONS(2605),
    [anon_sym_STAR] = ACTIONS(2607),
    [anon_sym_AMP_AMP] = ACTIONS(2607),
    [anon_sym_AMP] = ACTIONS(2605),
    [anon_sym_SEMI] = ACTIONS(2607),
    [anon_sym___extension__] = ACTIONS(2605),
    [anon_sym_typedef] = ACTIONS(2605),
    [anon_sym_virtual] = ACTIONS(2605),
    [anon_sym_extern] = ACTIONS(2605),
    [anon_sym___attribute__] = ACTIONS(2605),
    [anon_sym___attribute] = ACTIONS(2605),
    [anon_sym_COLON_COLON] = ACTIONS(2607),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2607),
    [anon_sym___declspec] = ACTIONS(2605),
    [anon_sym___based] = ACTIONS(2605),
    [anon_sym___cdecl] = ACTIONS(2605),
    [anon_sym___clrcall] = ACTIONS(2605),
    [anon_sym___stdcall] = ACTIONS(2605),
    [anon_sym___fastcall] = ACTIONS(2605),
    [anon_sym___thiscall] = ACTIONS(2605),
    [anon_sym___vectorcall] = ACTIONS(2605),
    [anon_sym_LBRACE] = ACTIONS(2607),
    [anon_sym_signed] = ACTIONS(2605),
    [anon_sym_unsigned] = ACTIONS(2605),
    [anon_sym_long] = ACTIONS(2605),
    [anon_sym_short] = ACTIONS(2605),
    [anon_sym_LBRACK] = ACTIONS(2605),
    [anon_sym_static] = ACTIONS(2605),
    [anon_sym_register] = ACTIONS(2605),
    [anon_sym_inline] = ACTIONS(2605),
    [anon_sym___inline] = ACTIONS(2605),
    [anon_sym___inline__] = ACTIONS(2605),
    [anon_sym___forceinline] = ACTIONS(2605),
    [anon_sym_thread_local] = ACTIONS(2605),
    [anon_sym___thread] = ACTIONS(2605),
    [anon_sym_const] = ACTIONS(2605),
    [anon_sym_constexpr] = ACTIONS(2605),
    [anon_sym_volatile] = ACTIONS(2605),
    [anon_sym_restrict] = ACTIONS(2605),
    [anon_sym___restrict__] = ACTIONS(2605),
    [anon_sym__Atomic] = ACTIONS(2605),
    [anon_sym__Noreturn] = ACTIONS(2605),
    [anon_sym_noreturn] = ACTIONS(2605),
    [anon_sym__Nonnull] = ACTIONS(2605),
    [anon_sym_mutable] = ACTIONS(2605),
    [anon_sym_constinit] = ACTIONS(2605),
    [anon_sym_consteval] = ACTIONS(2605),
    [anon_sym_alignas] = ACTIONS(2605),
    [anon_sym__Alignas] = ACTIONS(2605),
    [sym_primitive_type] = ACTIONS(2605),
    [anon_sym_enum] = ACTIONS(2605),
    [anon_sym_class] = ACTIONS(2605),
    [anon_sym_struct] = ACTIONS(2605),
    [anon_sym_union] = ACTIONS(2605),
    [anon_sym_if] = ACTIONS(2605),
    [anon_sym_else] = ACTIONS(2605),
    [anon_sym_switch] = ACTIONS(2605),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_default] = ACTIONS(2605),
    [anon_sym_while] = ACTIONS(2605),
    [anon_sym_do] = ACTIONS(2605),
    [anon_sym_for] = ACTIONS(2605),
    [anon_sym_return] = ACTIONS(2605),
    [anon_sym_break] = ACTIONS(2605),
    [anon_sym_continue] = ACTIONS(2605),
    [anon_sym_goto] = ACTIONS(2605),
    [anon_sym___try] = ACTIONS(2605),
    [anon_sym___leave] = ACTIONS(2605),
    [anon_sym_not] = ACTIONS(2605),
    [anon_sym_compl] = ACTIONS(2605),
    [anon_sym_DASH_DASH] = ACTIONS(2607),
    [anon_sym_PLUS_PLUS] = ACTIONS(2607),
    [anon_sym_sizeof] = ACTIONS(2605),
    [anon_sym___alignof__] = ACTIONS(2605),
    [anon_sym___alignof] = ACTIONS(2605),
    [anon_sym__alignof] = ACTIONS(2605),
    [anon_sym_alignof] = ACTIONS(2605),
    [anon_sym__Alignof] = ACTIONS(2605),
    [anon_sym_offsetof] = ACTIONS(2605),
    [anon_sym__Generic] = ACTIONS(2605),
    [anon_sym_asm] = ACTIONS(2605),
    [anon_sym___asm__] = ACTIONS(2605),
    [anon_sym___asm] = ACTIONS(2605),
    [sym_number_literal] = ACTIONS(2607),
    [anon_sym_L_SQUOTE] = ACTIONS(2607),
    [anon_sym_u_SQUOTE] = ACTIONS(2607),
    [anon_sym_U_SQUOTE] = ACTIONS(2607),
    [anon_sym_u8_SQUOTE] = ACTIONS(2607),
    [anon_sym_SQUOTE] = ACTIONS(2607),
    [anon_sym_L_DQUOTE] = ACTIONS(2607),
    [anon_sym_u_DQUOTE] = ACTIONS(2607),
    [anon_sym_U_DQUOTE] = ACTIONS(2607),
    [anon_sym_u8_DQUOTE] = ACTIONS(2607),
    [anon_sym_DQUOTE] = ACTIONS(2607),
    [sym_true] = ACTIONS(2605),
    [sym_false] = ACTIONS(2605),
    [anon_sym_NULL] = ACTIONS(2605),
    [anon_sym_nullptr] = ACTIONS(2605),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2605),
    [anon_sym_decltype] = ACTIONS(2605),
    [anon_sym_explicit] = ACTIONS(2605),
    [anon_sym_typename] = ACTIONS(2605),
    [anon_sym_template] = ACTIONS(2605),
    [anon_sym_operator] = ACTIONS(2605),
    [anon_sym_try] = ACTIONS(2605),
    [anon_sym_delete] = ACTIONS(2605),
    [anon_sym_throw] = ACTIONS(2605),
    [anon_sym_namespace] = ACTIONS(2605),
    [anon_sym_using] = ACTIONS(2605),
    [anon_sym_static_assert] = ACTIONS(2605),
    [anon_sym_concept] = ACTIONS(2605),
    [anon_sym_co_return] = ACTIONS(2605),
    [anon_sym_co_yield] = ACTIONS(2605),
    [anon_sym_R_DQUOTE] = ACTIONS(2607),
    [anon_sym_LR_DQUOTE] = ACTIONS(2607),
    [anon_sym_uR_DQUOTE] = ACTIONS(2607),
    [anon_sym_UR_DQUOTE] = ACTIONS(2607),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2607),
    [anon_sym_co_await] = ACTIONS(2605),
    [anon_sym_new] = ACTIONS(2605),
    [anon_sym_requires] = ACTIONS(2605),
    [sym_this] = ACTIONS(2605),
  },
  [433] = {
    [ts_builtin_sym_end] = ACTIONS(2699),
    [sym_identifier] = ACTIONS(2697),
    [aux_sym_preproc_include_token1] = ACTIONS(2697),
    [aux_sym_preproc_def_token1] = ACTIONS(2697),
    [aux_sym_preproc_if_token1] = ACTIONS(2697),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2697),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2697),
    [sym_preproc_directive] = ACTIONS(2697),
    [anon_sym_LPAREN2] = ACTIONS(2699),
    [anon_sym_BANG] = ACTIONS(2699),
    [anon_sym_TILDE] = ACTIONS(2699),
    [anon_sym_DASH] = ACTIONS(2697),
    [anon_sym_PLUS] = ACTIONS(2697),
    [anon_sym_STAR] = ACTIONS(2699),
    [anon_sym_AMP_AMP] = ACTIONS(2699),
    [anon_sym_AMP] = ACTIONS(2697),
    [anon_sym_SEMI] = ACTIONS(2699),
    [anon_sym___extension__] = ACTIONS(2697),
    [anon_sym_typedef] = ACTIONS(2697),
    [anon_sym_virtual] = ACTIONS(2697),
    [anon_sym_extern] = ACTIONS(2697),
    [anon_sym___attribute__] = ACTIONS(2697),
    [anon_sym___attribute] = ACTIONS(2697),
    [anon_sym_COLON_COLON] = ACTIONS(2699),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2699),
    [anon_sym___declspec] = ACTIONS(2697),
    [anon_sym___based] = ACTIONS(2697),
    [anon_sym___cdecl] = ACTIONS(2697),
    [anon_sym___clrcall] = ACTIONS(2697),
    [anon_sym___stdcall] = ACTIONS(2697),
    [anon_sym___fastcall] = ACTIONS(2697),
    [anon_sym___thiscall] = ACTIONS(2697),
    [anon_sym___vectorcall] = ACTIONS(2697),
    [anon_sym_LBRACE] = ACTIONS(2699),
    [anon_sym_signed] = ACTIONS(2697),
    [anon_sym_unsigned] = ACTIONS(2697),
    [anon_sym_long] = ACTIONS(2697),
    [anon_sym_short] = ACTIONS(2697),
    [anon_sym_LBRACK] = ACTIONS(2697),
    [anon_sym_static] = ACTIONS(2697),
    [anon_sym_register] = ACTIONS(2697),
    [anon_sym_inline] = ACTIONS(2697),
    [anon_sym___inline] = ACTIONS(2697),
    [anon_sym___inline__] = ACTIONS(2697),
    [anon_sym___forceinline] = ACTIONS(2697),
    [anon_sym_thread_local] = ACTIONS(2697),
    [anon_sym___thread] = ACTIONS(2697),
    [anon_sym_const] = ACTIONS(2697),
    [anon_sym_constexpr] = ACTIONS(2697),
    [anon_sym_volatile] = ACTIONS(2697),
    [anon_sym_restrict] = ACTIONS(2697),
    [anon_sym___restrict__] = ACTIONS(2697),
    [anon_sym__Atomic] = ACTIONS(2697),
    [anon_sym__Noreturn] = ACTIONS(2697),
    [anon_sym_noreturn] = ACTIONS(2697),
    [anon_sym__Nonnull] = ACTIONS(2697),
    [anon_sym_mutable] = ACTIONS(2697),
    [anon_sym_constinit] = ACTIONS(2697),
    [anon_sym_consteval] = ACTIONS(2697),
    [anon_sym_alignas] = ACTIONS(2697),
    [anon_sym__Alignas] = ACTIONS(2697),
    [sym_primitive_type] = ACTIONS(2697),
    [anon_sym_enum] = ACTIONS(2697),
    [anon_sym_class] = ACTIONS(2697),
    [anon_sym_struct] = ACTIONS(2697),
    [anon_sym_union] = ACTIONS(2697),
    [anon_sym_if] = ACTIONS(2697),
    [anon_sym_else] = ACTIONS(2697),
    [anon_sym_switch] = ACTIONS(2697),
    [anon_sym_case] = ACTIONS(2697),
    [anon_sym_default] = ACTIONS(2697),
    [anon_sym_while] = ACTIONS(2697),
    [anon_sym_do] = ACTIONS(2697),
    [anon_sym_for] = ACTIONS(2697),
    [anon_sym_return] = ACTIONS(2697),
    [anon_sym_break] = ACTIONS(2697),
    [anon_sym_continue] = ACTIONS(2697),
    [anon_sym_goto] = ACTIONS(2697),
    [anon_sym___try] = ACTIONS(2697),
    [anon_sym___leave] = ACTIONS(2697),
    [anon_sym_not] = ACTIONS(2697),
    [anon_sym_compl] = ACTIONS(2697),
    [anon_sym_DASH_DASH] = ACTIONS(2699),
    [anon_sym_PLUS_PLUS] = ACTIONS(2699),
    [anon_sym_sizeof] = ACTIONS(2697),
    [anon_sym___alignof__] = ACTIONS(2697),
    [anon_sym___alignof] = ACTIONS(2697),
    [anon_sym__alignof] = ACTIONS(2697),
    [anon_sym_alignof] = ACTIONS(2697),
    [anon_sym__Alignof] = ACTIONS(2697),
    [anon_sym_offsetof] = ACTIONS(2697),
    [anon_sym__Generic] = ACTIONS(2697),
    [anon_sym_asm] = ACTIONS(2697),
    [anon_sym___asm__] = ACTIONS(2697),
    [anon_sym___asm] = ACTIONS(2697),
    [sym_number_literal] = ACTIONS(2699),
    [anon_sym_L_SQUOTE] = ACTIONS(2699),
    [anon_sym_u_SQUOTE] = ACTIONS(2699),
    [anon_sym_U_SQUOTE] = ACTIONS(2699),
    [anon_sym_u8_SQUOTE] = ACTIONS(2699),
    [anon_sym_SQUOTE] = ACTIONS(2699),
    [anon_sym_L_DQUOTE] = ACTIONS(2699),
    [anon_sym_u_DQUOTE] = ACTIONS(2699),
    [anon_sym_U_DQUOTE] = ACTIONS(2699),
    [anon_sym_u8_DQUOTE] = ACTIONS(2699),
    [anon_sym_DQUOTE] = ACTIONS(2699),
    [sym_true] = ACTIONS(2697),
    [sym_false] = ACTIONS(2697),
    [anon_sym_NULL] = ACTIONS(2697),
    [anon_sym_nullptr] = ACTIONS(2697),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2697),
    [anon_sym_decltype] = ACTIONS(2697),
    [anon_sym_explicit] = ACTIONS(2697),
    [anon_sym_typename] = ACTIONS(2697),
    [anon_sym_template] = ACTIONS(2697),
    [anon_sym_operator] = ACTIONS(2697),
    [anon_sym_try] = ACTIONS(2697),
    [anon_sym_delete] = ACTIONS(2697),
    [anon_sym_throw] = ACTIONS(2697),
    [anon_sym_namespace] = ACTIONS(2697),
    [anon_sym_using] = ACTIONS(2697),
    [anon_sym_static_assert] = ACTIONS(2697),
    [anon_sym_concept] = ACTIONS(2697),
    [anon_sym_co_return] = ACTIONS(2697),
    [anon_sym_co_yield] = ACTIONS(2697),
    [anon_sym_R_DQUOTE] = ACTIONS(2699),
    [anon_sym_LR_DQUOTE] = ACTIONS(2699),
    [anon_sym_uR_DQUOTE] = ACTIONS(2699),
    [anon_sym_UR_DQUOTE] = ACTIONS(2699),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2699),
    [anon_sym_co_await] = ACTIONS(2697),
    [anon_sym_new] = ACTIONS(2697),
    [anon_sym_requires] = ACTIONS(2697),
    [sym_this] = ACTIONS(2697),
  },
  [434] = {
    [sym_identifier] = ACTIONS(1913),
    [aux_sym_preproc_include_token1] = ACTIONS(1913),
    [aux_sym_preproc_def_token1] = ACTIONS(1913),
    [anon_sym_COMMA] = ACTIONS(2721),
    [aux_sym_preproc_if_token1] = ACTIONS(1913),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1913),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1913),
    [sym_preproc_directive] = ACTIONS(1913),
    [anon_sym_LPAREN2] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_DASH] = ACTIONS(1913),
    [anon_sym_PLUS] = ACTIONS(1913),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_AMP_AMP] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1913),
    [anon_sym_SEMI] = ACTIONS(1911),
    [anon_sym___extension__] = ACTIONS(1913),
    [anon_sym_typedef] = ACTIONS(1913),
    [anon_sym_virtual] = ACTIONS(1913),
    [anon_sym_extern] = ACTIONS(1913),
    [anon_sym___attribute__] = ACTIONS(1913),
    [anon_sym___attribute] = ACTIONS(1913),
    [anon_sym_COLON_COLON] = ACTIONS(1911),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1911),
    [anon_sym___declspec] = ACTIONS(1913),
    [anon_sym___based] = ACTIONS(1913),
    [anon_sym___cdecl] = ACTIONS(1913),
    [anon_sym___clrcall] = ACTIONS(1913),
    [anon_sym___stdcall] = ACTIONS(1913),
    [anon_sym___fastcall] = ACTIONS(1913),
    [anon_sym___thiscall] = ACTIONS(1913),
    [anon_sym___vectorcall] = ACTIONS(1913),
    [anon_sym_LBRACE] = ACTIONS(1911),
    [anon_sym_RBRACE] = ACTIONS(2721),
    [anon_sym_signed] = ACTIONS(1913),
    [anon_sym_unsigned] = ACTIONS(1913),
    [anon_sym_long] = ACTIONS(1913),
    [anon_sym_short] = ACTIONS(1913),
    [anon_sym_LBRACK] = ACTIONS(1913),
    [anon_sym_static] = ACTIONS(1913),
    [anon_sym_register] = ACTIONS(1913),
    [anon_sym_inline] = ACTIONS(1913),
    [anon_sym___inline] = ACTIONS(1913),
    [anon_sym___inline__] = ACTIONS(1913),
    [anon_sym___forceinline] = ACTIONS(1913),
    [anon_sym_thread_local] = ACTIONS(1913),
    [anon_sym___thread] = ACTIONS(1913),
    [anon_sym_const] = ACTIONS(1913),
    [anon_sym_constexpr] = ACTIONS(1913),
    [anon_sym_volatile] = ACTIONS(1913),
    [anon_sym_restrict] = ACTIONS(1913),
    [anon_sym___restrict__] = ACTIONS(1913),
    [anon_sym__Atomic] = ACTIONS(1913),
    [anon_sym__Noreturn] = ACTIONS(1913),
    [anon_sym_noreturn] = ACTIONS(1913),
    [anon_sym__Nonnull] = ACTIONS(1913),
    [anon_sym_mutable] = ACTIONS(1913),
    [anon_sym_constinit] = ACTIONS(1913),
    [anon_sym_consteval] = ACTIONS(1913),
    [anon_sym_alignas] = ACTIONS(1913),
    [anon_sym__Alignas] = ACTIONS(1913),
    [sym_primitive_type] = ACTIONS(1913),
    [anon_sym_enum] = ACTIONS(1913),
    [anon_sym_class] = ACTIONS(1913),
    [anon_sym_struct] = ACTIONS(1913),
    [anon_sym_union] = ACTIONS(1913),
    [anon_sym_if] = ACTIONS(1913),
    [anon_sym_switch] = ACTIONS(1913),
    [anon_sym_case] = ACTIONS(1913),
    [anon_sym_default] = ACTIONS(1913),
    [anon_sym_while] = ACTIONS(1913),
    [anon_sym_do] = ACTIONS(1913),
    [anon_sym_for] = ACTIONS(1913),
    [anon_sym_return] = ACTIONS(1913),
    [anon_sym_break] = ACTIONS(1913),
    [anon_sym_continue] = ACTIONS(1913),
    [anon_sym_goto] = ACTIONS(1913),
    [anon_sym___try] = ACTIONS(1913),
    [anon_sym___leave] = ACTIONS(1913),
    [anon_sym_not] = ACTIONS(1913),
    [anon_sym_compl] = ACTIONS(1913),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_sizeof] = ACTIONS(1913),
    [anon_sym___alignof__] = ACTIONS(1913),
    [anon_sym___alignof] = ACTIONS(1913),
    [anon_sym__alignof] = ACTIONS(1913),
    [anon_sym_alignof] = ACTIONS(1913),
    [anon_sym__Alignof] = ACTIONS(1913),
    [anon_sym_offsetof] = ACTIONS(1913),
    [anon_sym__Generic] = ACTIONS(1913),
    [anon_sym_asm] = ACTIONS(1913),
    [anon_sym___asm__] = ACTIONS(1913),
    [anon_sym___asm] = ACTIONS(1913),
    [sym_number_literal] = ACTIONS(1911),
    [anon_sym_L_SQUOTE] = ACTIONS(1911),
    [anon_sym_u_SQUOTE] = ACTIONS(1911),
    [anon_sym_U_SQUOTE] = ACTIONS(1911),
    [anon_sym_u8_SQUOTE] = ACTIONS(1911),
    [anon_sym_SQUOTE] = ACTIONS(1911),
    [anon_sym_L_DQUOTE] = ACTIONS(1911),
    [anon_sym_u_DQUOTE] = ACTIONS(1911),
    [anon_sym_U_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8_DQUOTE] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(1911),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1913),
    [anon_sym_nullptr] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1913),
    [anon_sym_decltype] = ACTIONS(1913),
    [anon_sym_explicit] = ACTIONS(1913),
    [anon_sym_typename] = ACTIONS(1913),
    [anon_sym_template] = ACTIONS(1913),
    [anon_sym_operator] = ACTIONS(1913),
    [anon_sym_try] = ACTIONS(1913),
    [anon_sym_delete] = ACTIONS(1913),
    [anon_sym_throw] = ACTIONS(1913),
    [anon_sym_namespace] = ACTIONS(1913),
    [anon_sym_using] = ACTIONS(1913),
    [anon_sym_static_assert] = ACTIONS(1913),
    [anon_sym_concept] = ACTIONS(1913),
    [anon_sym_co_return] = ACTIONS(1913),
    [anon_sym_co_yield] = ACTIONS(1913),
    [anon_sym_R_DQUOTE] = ACTIONS(1911),
    [anon_sym_LR_DQUOTE] = ACTIONS(1911),
    [anon_sym_uR_DQUOTE] = ACTIONS(1911),
    [anon_sym_UR_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1911),
    [anon_sym_co_await] = ACTIONS(1913),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_requires] = ACTIONS(1913),
    [sym_this] = ACTIONS(1913),
  },
  [435] = {
    [sym_identifier] = ACTIONS(2633),
    [aux_sym_preproc_include_token1] = ACTIONS(2633),
    [aux_sym_preproc_def_token1] = ACTIONS(2633),
    [aux_sym_preproc_if_token1] = ACTIONS(2633),
    [aux_sym_preproc_if_token2] = ACTIONS(2633),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2633),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2633),
    [sym_preproc_directive] = ACTIONS(2633),
    [anon_sym_LPAREN2] = ACTIONS(2635),
    [anon_sym_BANG] = ACTIONS(2635),
    [anon_sym_TILDE] = ACTIONS(2635),
    [anon_sym_DASH] = ACTIONS(2633),
    [anon_sym_PLUS] = ACTIONS(2633),
    [anon_sym_STAR] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2635),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_SEMI] = ACTIONS(2635),
    [anon_sym___extension__] = ACTIONS(2633),
    [anon_sym_typedef] = ACTIONS(2633),
    [anon_sym_virtual] = ACTIONS(2633),
    [anon_sym_extern] = ACTIONS(2633),
    [anon_sym___attribute__] = ACTIONS(2633),
    [anon_sym___attribute] = ACTIONS(2633),
    [anon_sym_COLON_COLON] = ACTIONS(2635),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2635),
    [anon_sym___declspec] = ACTIONS(2633),
    [anon_sym___based] = ACTIONS(2633),
    [anon_sym___cdecl] = ACTIONS(2633),
    [anon_sym___clrcall] = ACTIONS(2633),
    [anon_sym___stdcall] = ACTIONS(2633),
    [anon_sym___fastcall] = ACTIONS(2633),
    [anon_sym___thiscall] = ACTIONS(2633),
    [anon_sym___vectorcall] = ACTIONS(2633),
    [anon_sym_LBRACE] = ACTIONS(2635),
    [anon_sym_signed] = ACTIONS(2633),
    [anon_sym_unsigned] = ACTIONS(2633),
    [anon_sym_long] = ACTIONS(2633),
    [anon_sym_short] = ACTIONS(2633),
    [anon_sym_LBRACK] = ACTIONS(2633),
    [anon_sym_static] = ACTIONS(2633),
    [anon_sym_register] = ACTIONS(2633),
    [anon_sym_inline] = ACTIONS(2633),
    [anon_sym___inline] = ACTIONS(2633),
    [anon_sym___inline__] = ACTIONS(2633),
    [anon_sym___forceinline] = ACTIONS(2633),
    [anon_sym_thread_local] = ACTIONS(2633),
    [anon_sym___thread] = ACTIONS(2633),
    [anon_sym_const] = ACTIONS(2633),
    [anon_sym_constexpr] = ACTIONS(2633),
    [anon_sym_volatile] = ACTIONS(2633),
    [anon_sym_restrict] = ACTIONS(2633),
    [anon_sym___restrict__] = ACTIONS(2633),
    [anon_sym__Atomic] = ACTIONS(2633),
    [anon_sym__Noreturn] = ACTIONS(2633),
    [anon_sym_noreturn] = ACTIONS(2633),
    [anon_sym__Nonnull] = ACTIONS(2633),
    [anon_sym_mutable] = ACTIONS(2633),
    [anon_sym_constinit] = ACTIONS(2633),
    [anon_sym_consteval] = ACTIONS(2633),
    [anon_sym_alignas] = ACTIONS(2633),
    [anon_sym__Alignas] = ACTIONS(2633),
    [sym_primitive_type] = ACTIONS(2633),
    [anon_sym_enum] = ACTIONS(2633),
    [anon_sym_class] = ACTIONS(2633),
    [anon_sym_struct] = ACTIONS(2633),
    [anon_sym_union] = ACTIONS(2633),
    [anon_sym_if] = ACTIONS(2633),
    [anon_sym_else] = ACTIONS(2633),
    [anon_sym_switch] = ACTIONS(2633),
    [anon_sym_case] = ACTIONS(2633),
    [anon_sym_default] = ACTIONS(2633),
    [anon_sym_while] = ACTIONS(2633),
    [anon_sym_do] = ACTIONS(2633),
    [anon_sym_for] = ACTIONS(2633),
    [anon_sym_return] = ACTIONS(2633),
    [anon_sym_break] = ACTIONS(2633),
    [anon_sym_continue] = ACTIONS(2633),
    [anon_sym_goto] = ACTIONS(2633),
    [anon_sym___try] = ACTIONS(2633),
    [anon_sym___leave] = ACTIONS(2633),
    [anon_sym_not] = ACTIONS(2633),
    [anon_sym_compl] = ACTIONS(2633),
    [anon_sym_DASH_DASH] = ACTIONS(2635),
    [anon_sym_PLUS_PLUS] = ACTIONS(2635),
    [anon_sym_sizeof] = ACTIONS(2633),
    [anon_sym___alignof__] = ACTIONS(2633),
    [anon_sym___alignof] = ACTIONS(2633),
    [anon_sym__alignof] = ACTIONS(2633),
    [anon_sym_alignof] = ACTIONS(2633),
    [anon_sym__Alignof] = ACTIONS(2633),
    [anon_sym_offsetof] = ACTIONS(2633),
    [anon_sym__Generic] = ACTIONS(2633),
    [anon_sym_asm] = ACTIONS(2633),
    [anon_sym___asm__] = ACTIONS(2633),
    [anon_sym___asm] = ACTIONS(2633),
    [sym_number_literal] = ACTIONS(2635),
    [anon_sym_L_SQUOTE] = ACTIONS(2635),
    [anon_sym_u_SQUOTE] = ACTIONS(2635),
    [anon_sym_U_SQUOTE] = ACTIONS(2635),
    [anon_sym_u8_SQUOTE] = ACTIONS(2635),
    [anon_sym_SQUOTE] = ACTIONS(2635),
    [anon_sym_L_DQUOTE] = ACTIONS(2635),
    [anon_sym_u_DQUOTE] = ACTIONS(2635),
    [anon_sym_U_DQUOTE] = ACTIONS(2635),
    [anon_sym_u8_DQUOTE] = ACTIONS(2635),
    [anon_sym_DQUOTE] = ACTIONS(2635),
    [sym_true] = ACTIONS(2633),
    [sym_false] = ACTIONS(2633),
    [anon_sym_NULL] = ACTIONS(2633),
    [anon_sym_nullptr] = ACTIONS(2633),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2633),
    [anon_sym_decltype] = ACTIONS(2633),
    [anon_sym_explicit] = ACTIONS(2633),
    [anon_sym_typename] = ACTIONS(2633),
    [anon_sym_template] = ACTIONS(2633),
    [anon_sym_operator] = ACTIONS(2633),
    [anon_sym_try] = ACTIONS(2633),
    [anon_sym_delete] = ACTIONS(2633),
    [anon_sym_throw] = ACTIONS(2633),
    [anon_sym_namespace] = ACTIONS(2633),
    [anon_sym_using] = ACTIONS(2633),
    [anon_sym_static_assert] = ACTIONS(2633),
    [anon_sym_concept] = ACTIONS(2633),
    [anon_sym_co_return] = ACTIONS(2633),
    [anon_sym_co_yield] = ACTIONS(2633),
    [anon_sym_R_DQUOTE] = ACTIONS(2635),
    [anon_sym_LR_DQUOTE] = ACTIONS(2635),
    [anon_sym_uR_DQUOTE] = ACTIONS(2635),
    [anon_sym_UR_DQUOTE] = ACTIONS(2635),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2635),
    [anon_sym_co_await] = ACTIONS(2633),
    [anon_sym_new] = ACTIONS(2633),
    [anon_sym_requires] = ACTIONS(2633),
    [sym_this] = ACTIONS(2633),
  },
  [436] = {
    [sym_identifier] = ACTIONS(2637),
    [aux_sym_preproc_include_token1] = ACTIONS(2637),
    [aux_sym_preproc_def_token1] = ACTIONS(2637),
    [aux_sym_preproc_if_token1] = ACTIONS(2637),
    [aux_sym_preproc_if_token2] = ACTIONS(2637),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2637),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2637),
    [sym_preproc_directive] = ACTIONS(2637),
    [anon_sym_LPAREN2] = ACTIONS(2639),
    [anon_sym_BANG] = ACTIONS(2639),
    [anon_sym_TILDE] = ACTIONS(2639),
    [anon_sym_DASH] = ACTIONS(2637),
    [anon_sym_PLUS] = ACTIONS(2637),
    [anon_sym_STAR] = ACTIONS(2639),
    [anon_sym_AMP_AMP] = ACTIONS(2639),
    [anon_sym_AMP] = ACTIONS(2637),
    [anon_sym_SEMI] = ACTIONS(2639),
    [anon_sym___extension__] = ACTIONS(2637),
    [anon_sym_typedef] = ACTIONS(2637),
    [anon_sym_virtual] = ACTIONS(2637),
    [anon_sym_extern] = ACTIONS(2637),
    [anon_sym___attribute__] = ACTIONS(2637),
    [anon_sym___attribute] = ACTIONS(2637),
    [anon_sym_COLON_COLON] = ACTIONS(2639),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2639),
    [anon_sym___declspec] = ACTIONS(2637),
    [anon_sym___based] = ACTIONS(2637),
    [anon_sym___cdecl] = ACTIONS(2637),
    [anon_sym___clrcall] = ACTIONS(2637),
    [anon_sym___stdcall] = ACTIONS(2637),
    [anon_sym___fastcall] = ACTIONS(2637),
    [anon_sym___thiscall] = ACTIONS(2637),
    [anon_sym___vectorcall] = ACTIONS(2637),
    [anon_sym_LBRACE] = ACTIONS(2639),
    [anon_sym_signed] = ACTIONS(2637),
    [anon_sym_unsigned] = ACTIONS(2637),
    [anon_sym_long] = ACTIONS(2637),
    [anon_sym_short] = ACTIONS(2637),
    [anon_sym_LBRACK] = ACTIONS(2637),
    [anon_sym_static] = ACTIONS(2637),
    [anon_sym_register] = ACTIONS(2637),
    [anon_sym_inline] = ACTIONS(2637),
    [anon_sym___inline] = ACTIONS(2637),
    [anon_sym___inline__] = ACTIONS(2637),
    [anon_sym___forceinline] = ACTIONS(2637),
    [anon_sym_thread_local] = ACTIONS(2637),
    [anon_sym___thread] = ACTIONS(2637),
    [anon_sym_const] = ACTIONS(2637),
    [anon_sym_constexpr] = ACTIONS(2637),
    [anon_sym_volatile] = ACTIONS(2637),
    [anon_sym_restrict] = ACTIONS(2637),
    [anon_sym___restrict__] = ACTIONS(2637),
    [anon_sym__Atomic] = ACTIONS(2637),
    [anon_sym__Noreturn] = ACTIONS(2637),
    [anon_sym_noreturn] = ACTIONS(2637),
    [anon_sym__Nonnull] = ACTIONS(2637),
    [anon_sym_mutable] = ACTIONS(2637),
    [anon_sym_constinit] = ACTIONS(2637),
    [anon_sym_consteval] = ACTIONS(2637),
    [anon_sym_alignas] = ACTIONS(2637),
    [anon_sym__Alignas] = ACTIONS(2637),
    [sym_primitive_type] = ACTIONS(2637),
    [anon_sym_enum] = ACTIONS(2637),
    [anon_sym_class] = ACTIONS(2637),
    [anon_sym_struct] = ACTIONS(2637),
    [anon_sym_union] = ACTIONS(2637),
    [anon_sym_if] = ACTIONS(2637),
    [anon_sym_else] = ACTIONS(2637),
    [anon_sym_switch] = ACTIONS(2637),
    [anon_sym_case] = ACTIONS(2637),
    [anon_sym_default] = ACTIONS(2637),
    [anon_sym_while] = ACTIONS(2637),
    [anon_sym_do] = ACTIONS(2637),
    [anon_sym_for] = ACTIONS(2637),
    [anon_sym_return] = ACTIONS(2637),
    [anon_sym_break] = ACTIONS(2637),
    [anon_sym_continue] = ACTIONS(2637),
    [anon_sym_goto] = ACTIONS(2637),
    [anon_sym___try] = ACTIONS(2637),
    [anon_sym___leave] = ACTIONS(2637),
    [anon_sym_not] = ACTIONS(2637),
    [anon_sym_compl] = ACTIONS(2637),
    [anon_sym_DASH_DASH] = ACTIONS(2639),
    [anon_sym_PLUS_PLUS] = ACTIONS(2639),
    [anon_sym_sizeof] = ACTIONS(2637),
    [anon_sym___alignof__] = ACTIONS(2637),
    [anon_sym___alignof] = ACTIONS(2637),
    [anon_sym__alignof] = ACTIONS(2637),
    [anon_sym_alignof] = ACTIONS(2637),
    [anon_sym__Alignof] = ACTIONS(2637),
    [anon_sym_offsetof] = ACTIONS(2637),
    [anon_sym__Generic] = ACTIONS(2637),
    [anon_sym_asm] = ACTIONS(2637),
    [anon_sym___asm__] = ACTIONS(2637),
    [anon_sym___asm] = ACTIONS(2637),
    [sym_number_literal] = ACTIONS(2639),
    [anon_sym_L_SQUOTE] = ACTIONS(2639),
    [anon_sym_u_SQUOTE] = ACTIONS(2639),
    [anon_sym_U_SQUOTE] = ACTIONS(2639),
    [anon_sym_u8_SQUOTE] = ACTIONS(2639),
    [anon_sym_SQUOTE] = ACTIONS(2639),
    [anon_sym_L_DQUOTE] = ACTIONS(2639),
    [anon_sym_u_DQUOTE] = ACTIONS(2639),
    [anon_sym_U_DQUOTE] = ACTIONS(2639),
    [anon_sym_u8_DQUOTE] = ACTIONS(2639),
    [anon_sym_DQUOTE] = ACTIONS(2639),
    [sym_true] = ACTIONS(2637),
    [sym_false] = ACTIONS(2637),
    [anon_sym_NULL] = ACTIONS(2637),
    [anon_sym_nullptr] = ACTIONS(2637),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2637),
    [anon_sym_decltype] = ACTIONS(2637),
    [anon_sym_explicit] = ACTIONS(2637),
    [anon_sym_typename] = ACTIONS(2637),
    [anon_sym_template] = ACTIONS(2637),
    [anon_sym_operator] = ACTIONS(2637),
    [anon_sym_try] = ACTIONS(2637),
    [anon_sym_delete] = ACTIONS(2637),
    [anon_sym_throw] = ACTIONS(2637),
    [anon_sym_namespace] = ACTIONS(2637),
    [anon_sym_using] = ACTIONS(2637),
    [anon_sym_static_assert] = ACTIONS(2637),
    [anon_sym_concept] = ACTIONS(2637),
    [anon_sym_co_return] = ACTIONS(2637),
    [anon_sym_co_yield] = ACTIONS(2637),
    [anon_sym_R_DQUOTE] = ACTIONS(2639),
    [anon_sym_LR_DQUOTE] = ACTIONS(2639),
    [anon_sym_uR_DQUOTE] = ACTIONS(2639),
    [anon_sym_UR_DQUOTE] = ACTIONS(2639),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2639),
    [anon_sym_co_await] = ACTIONS(2637),
    [anon_sym_new] = ACTIONS(2637),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2637),
  },
  [437] = {
    [sym_identifier] = ACTIONS(2637),
    [aux_sym_preproc_include_token1] = ACTIONS(2637),
    [aux_sym_preproc_def_token1] = ACTIONS(2637),
    [aux_sym_preproc_if_token1] = ACTIONS(2637),
    [aux_sym_preproc_if_token2] = ACTIONS(2637),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2637),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2637),
    [sym_preproc_directive] = ACTIONS(2637),
    [anon_sym_LPAREN2] = ACTIONS(2639),
    [anon_sym_BANG] = ACTIONS(2639),
    [anon_sym_TILDE] = ACTIONS(2639),
    [anon_sym_DASH] = ACTIONS(2637),
    [anon_sym_PLUS] = ACTIONS(2637),
    [anon_sym_STAR] = ACTIONS(2639),
    [anon_sym_AMP_AMP] = ACTIONS(2639),
    [anon_sym_AMP] = ACTIONS(2637),
    [anon_sym_SEMI] = ACTIONS(2639),
    [anon_sym___extension__] = ACTIONS(2637),
    [anon_sym_typedef] = ACTIONS(2637),
    [anon_sym_virtual] = ACTIONS(2637),
    [anon_sym_extern] = ACTIONS(2637),
    [anon_sym___attribute__] = ACTIONS(2637),
    [anon_sym___attribute] = ACTIONS(2637),
    [anon_sym_COLON_COLON] = ACTIONS(2639),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2639),
    [anon_sym___declspec] = ACTIONS(2637),
    [anon_sym___based] = ACTIONS(2637),
    [anon_sym___cdecl] = ACTIONS(2637),
    [anon_sym___clrcall] = ACTIONS(2637),
    [anon_sym___stdcall] = ACTIONS(2637),
    [anon_sym___fastcall] = ACTIONS(2637),
    [anon_sym___thiscall] = ACTIONS(2637),
    [anon_sym___vectorcall] = ACTIONS(2637),
    [anon_sym_LBRACE] = ACTIONS(2639),
    [anon_sym_signed] = ACTIONS(2637),
    [anon_sym_unsigned] = ACTIONS(2637),
    [anon_sym_long] = ACTIONS(2637),
    [anon_sym_short] = ACTIONS(2637),
    [anon_sym_LBRACK] = ACTIONS(2637),
    [anon_sym_static] = ACTIONS(2637),
    [anon_sym_register] = ACTIONS(2637),
    [anon_sym_inline] = ACTIONS(2637),
    [anon_sym___inline] = ACTIONS(2637),
    [anon_sym___inline__] = ACTIONS(2637),
    [anon_sym___forceinline] = ACTIONS(2637),
    [anon_sym_thread_local] = ACTIONS(2637),
    [anon_sym___thread] = ACTIONS(2637),
    [anon_sym_const] = ACTIONS(2637),
    [anon_sym_constexpr] = ACTIONS(2637),
    [anon_sym_volatile] = ACTIONS(2637),
    [anon_sym_restrict] = ACTIONS(2637),
    [anon_sym___restrict__] = ACTIONS(2637),
    [anon_sym__Atomic] = ACTIONS(2637),
    [anon_sym__Noreturn] = ACTIONS(2637),
    [anon_sym_noreturn] = ACTIONS(2637),
    [anon_sym__Nonnull] = ACTIONS(2637),
    [anon_sym_mutable] = ACTIONS(2637),
    [anon_sym_constinit] = ACTIONS(2637),
    [anon_sym_consteval] = ACTIONS(2637),
    [anon_sym_alignas] = ACTIONS(2637),
    [anon_sym__Alignas] = ACTIONS(2637),
    [sym_primitive_type] = ACTIONS(2637),
    [anon_sym_enum] = ACTIONS(2637),
    [anon_sym_class] = ACTIONS(2637),
    [anon_sym_struct] = ACTIONS(2637),
    [anon_sym_union] = ACTIONS(2637),
    [anon_sym_if] = ACTIONS(2637),
    [anon_sym_else] = ACTIONS(2637),
    [anon_sym_switch] = ACTIONS(2637),
    [anon_sym_case] = ACTIONS(2637),
    [anon_sym_default] = ACTIONS(2637),
    [anon_sym_while] = ACTIONS(2637),
    [anon_sym_do] = ACTIONS(2637),
    [anon_sym_for] = ACTIONS(2637),
    [anon_sym_return] = ACTIONS(2637),
    [anon_sym_break] = ACTIONS(2637),
    [anon_sym_continue] = ACTIONS(2637),
    [anon_sym_goto] = ACTIONS(2637),
    [anon_sym___try] = ACTIONS(2637),
    [anon_sym___leave] = ACTIONS(2637),
    [anon_sym_not] = ACTIONS(2637),
    [anon_sym_compl] = ACTIONS(2637),
    [anon_sym_DASH_DASH] = ACTIONS(2639),
    [anon_sym_PLUS_PLUS] = ACTIONS(2639),
    [anon_sym_sizeof] = ACTIONS(2637),
    [anon_sym___alignof__] = ACTIONS(2637),
    [anon_sym___alignof] = ACTIONS(2637),
    [anon_sym__alignof] = ACTIONS(2637),
    [anon_sym_alignof] = ACTIONS(2637),
    [anon_sym__Alignof] = ACTIONS(2637),
    [anon_sym_offsetof] = ACTIONS(2637),
    [anon_sym__Generic] = ACTIONS(2637),
    [anon_sym_asm] = ACTIONS(2637),
    [anon_sym___asm__] = ACTIONS(2637),
    [anon_sym___asm] = ACTIONS(2637),
    [sym_number_literal] = ACTIONS(2639),
    [anon_sym_L_SQUOTE] = ACTIONS(2639),
    [anon_sym_u_SQUOTE] = ACTIONS(2639),
    [anon_sym_U_SQUOTE] = ACTIONS(2639),
    [anon_sym_u8_SQUOTE] = ACTIONS(2639),
    [anon_sym_SQUOTE] = ACTIONS(2639),
    [anon_sym_L_DQUOTE] = ACTIONS(2639),
    [anon_sym_u_DQUOTE] = ACTIONS(2639),
    [anon_sym_U_DQUOTE] = ACTIONS(2639),
    [anon_sym_u8_DQUOTE] = ACTIONS(2639),
    [anon_sym_DQUOTE] = ACTIONS(2639),
    [sym_true] = ACTIONS(2637),
    [sym_false] = ACTIONS(2637),
    [anon_sym_NULL] = ACTIONS(2637),
    [anon_sym_nullptr] = ACTIONS(2637),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2637),
    [anon_sym_decltype] = ACTIONS(2637),
    [anon_sym_explicit] = ACTIONS(2637),
    [anon_sym_typename] = ACTIONS(2637),
    [anon_sym_template] = ACTIONS(2637),
    [anon_sym_operator] = ACTIONS(2637),
    [anon_sym_try] = ACTIONS(2637),
    [anon_sym_delete] = ACTIONS(2637),
    [anon_sym_throw] = ACTIONS(2637),
    [anon_sym_namespace] = ACTIONS(2637),
    [anon_sym_using] = ACTIONS(2637),
    [anon_sym_static_assert] = ACTIONS(2637),
    [anon_sym_concept] = ACTIONS(2637),
    [anon_sym_co_return] = ACTIONS(2637),
    [anon_sym_co_yield] = ACTIONS(2637),
    [anon_sym_R_DQUOTE] = ACTIONS(2639),
    [anon_sym_LR_DQUOTE] = ACTIONS(2639),
    [anon_sym_uR_DQUOTE] = ACTIONS(2639),
    [anon_sym_UR_DQUOTE] = ACTIONS(2639),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2639),
    [anon_sym_co_await] = ACTIONS(2637),
    [anon_sym_new] = ACTIONS(2637),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2637),
  },
  [438] = {
    [ts_builtin_sym_end] = ACTIONS(2695),
    [sym_identifier] = ACTIONS(2693),
    [aux_sym_preproc_include_token1] = ACTIONS(2693),
    [aux_sym_preproc_def_token1] = ACTIONS(2693),
    [aux_sym_preproc_if_token1] = ACTIONS(2693),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2693),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2693),
    [sym_preproc_directive] = ACTIONS(2693),
    [anon_sym_LPAREN2] = ACTIONS(2695),
    [anon_sym_BANG] = ACTIONS(2695),
    [anon_sym_TILDE] = ACTIONS(2695),
    [anon_sym_DASH] = ACTIONS(2693),
    [anon_sym_PLUS] = ACTIONS(2693),
    [anon_sym_STAR] = ACTIONS(2695),
    [anon_sym_AMP_AMP] = ACTIONS(2695),
    [anon_sym_AMP] = ACTIONS(2693),
    [anon_sym_SEMI] = ACTIONS(2695),
    [anon_sym___extension__] = ACTIONS(2693),
    [anon_sym_typedef] = ACTIONS(2693),
    [anon_sym_virtual] = ACTIONS(2693),
    [anon_sym_extern] = ACTIONS(2693),
    [anon_sym___attribute__] = ACTIONS(2693),
    [anon_sym___attribute] = ACTIONS(2693),
    [anon_sym_COLON_COLON] = ACTIONS(2695),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2695),
    [anon_sym___declspec] = ACTIONS(2693),
    [anon_sym___based] = ACTIONS(2693),
    [anon_sym___cdecl] = ACTIONS(2693),
    [anon_sym___clrcall] = ACTIONS(2693),
    [anon_sym___stdcall] = ACTIONS(2693),
    [anon_sym___fastcall] = ACTIONS(2693),
    [anon_sym___thiscall] = ACTIONS(2693),
    [anon_sym___vectorcall] = ACTIONS(2693),
    [anon_sym_LBRACE] = ACTIONS(2695),
    [anon_sym_signed] = ACTIONS(2693),
    [anon_sym_unsigned] = ACTIONS(2693),
    [anon_sym_long] = ACTIONS(2693),
    [anon_sym_short] = ACTIONS(2693),
    [anon_sym_LBRACK] = ACTIONS(2693),
    [anon_sym_static] = ACTIONS(2693),
    [anon_sym_register] = ACTIONS(2693),
    [anon_sym_inline] = ACTIONS(2693),
    [anon_sym___inline] = ACTIONS(2693),
    [anon_sym___inline__] = ACTIONS(2693),
    [anon_sym___forceinline] = ACTIONS(2693),
    [anon_sym_thread_local] = ACTIONS(2693),
    [anon_sym___thread] = ACTIONS(2693),
    [anon_sym_const] = ACTIONS(2693),
    [anon_sym_constexpr] = ACTIONS(2693),
    [anon_sym_volatile] = ACTIONS(2693),
    [anon_sym_restrict] = ACTIONS(2693),
    [anon_sym___restrict__] = ACTIONS(2693),
    [anon_sym__Atomic] = ACTIONS(2693),
    [anon_sym__Noreturn] = ACTIONS(2693),
    [anon_sym_noreturn] = ACTIONS(2693),
    [anon_sym__Nonnull] = ACTIONS(2693),
    [anon_sym_mutable] = ACTIONS(2693),
    [anon_sym_constinit] = ACTIONS(2693),
    [anon_sym_consteval] = ACTIONS(2693),
    [anon_sym_alignas] = ACTIONS(2693),
    [anon_sym__Alignas] = ACTIONS(2693),
    [sym_primitive_type] = ACTIONS(2693),
    [anon_sym_enum] = ACTIONS(2693),
    [anon_sym_class] = ACTIONS(2693),
    [anon_sym_struct] = ACTIONS(2693),
    [anon_sym_union] = ACTIONS(2693),
    [anon_sym_if] = ACTIONS(2693),
    [anon_sym_else] = ACTIONS(2693),
    [anon_sym_switch] = ACTIONS(2693),
    [anon_sym_case] = ACTIONS(2693),
    [anon_sym_default] = ACTIONS(2693),
    [anon_sym_while] = ACTIONS(2693),
    [anon_sym_do] = ACTIONS(2693),
    [anon_sym_for] = ACTIONS(2693),
    [anon_sym_return] = ACTIONS(2693),
    [anon_sym_break] = ACTIONS(2693),
    [anon_sym_continue] = ACTIONS(2693),
    [anon_sym_goto] = ACTIONS(2693),
    [anon_sym___try] = ACTIONS(2693),
    [anon_sym___leave] = ACTIONS(2693),
    [anon_sym_not] = ACTIONS(2693),
    [anon_sym_compl] = ACTIONS(2693),
    [anon_sym_DASH_DASH] = ACTIONS(2695),
    [anon_sym_PLUS_PLUS] = ACTIONS(2695),
    [anon_sym_sizeof] = ACTIONS(2693),
    [anon_sym___alignof__] = ACTIONS(2693),
    [anon_sym___alignof] = ACTIONS(2693),
    [anon_sym__alignof] = ACTIONS(2693),
    [anon_sym_alignof] = ACTIONS(2693),
    [anon_sym__Alignof] = ACTIONS(2693),
    [anon_sym_offsetof] = ACTIONS(2693),
    [anon_sym__Generic] = ACTIONS(2693),
    [anon_sym_asm] = ACTIONS(2693),
    [anon_sym___asm__] = ACTIONS(2693),
    [anon_sym___asm] = ACTIONS(2693),
    [sym_number_literal] = ACTIONS(2695),
    [anon_sym_L_SQUOTE] = ACTIONS(2695),
    [anon_sym_u_SQUOTE] = ACTIONS(2695),
    [anon_sym_U_SQUOTE] = ACTIONS(2695),
    [anon_sym_u8_SQUOTE] = ACTIONS(2695),
    [anon_sym_SQUOTE] = ACTIONS(2695),
    [anon_sym_L_DQUOTE] = ACTIONS(2695),
    [anon_sym_u_DQUOTE] = ACTIONS(2695),
    [anon_sym_U_DQUOTE] = ACTIONS(2695),
    [anon_sym_u8_DQUOTE] = ACTIONS(2695),
    [anon_sym_DQUOTE] = ACTIONS(2695),
    [sym_true] = ACTIONS(2693),
    [sym_false] = ACTIONS(2693),
    [anon_sym_NULL] = ACTIONS(2693),
    [anon_sym_nullptr] = ACTIONS(2693),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2693),
    [anon_sym_decltype] = ACTIONS(2693),
    [anon_sym_explicit] = ACTIONS(2693),
    [anon_sym_typename] = ACTIONS(2693),
    [anon_sym_template] = ACTIONS(2693),
    [anon_sym_operator] = ACTIONS(2693),
    [anon_sym_try] = ACTIONS(2693),
    [anon_sym_delete] = ACTIONS(2693),
    [anon_sym_throw] = ACTIONS(2693),
    [anon_sym_namespace] = ACTIONS(2693),
    [anon_sym_using] = ACTIONS(2693),
    [anon_sym_static_assert] = ACTIONS(2693),
    [anon_sym_concept] = ACTIONS(2693),
    [anon_sym_co_return] = ACTIONS(2693),
    [anon_sym_co_yield] = ACTIONS(2693),
    [anon_sym_R_DQUOTE] = ACTIONS(2695),
    [anon_sym_LR_DQUOTE] = ACTIONS(2695),
    [anon_sym_uR_DQUOTE] = ACTIONS(2695),
    [anon_sym_UR_DQUOTE] = ACTIONS(2695),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2695),
    [anon_sym_co_await] = ACTIONS(2693),
    [anon_sym_new] = ACTIONS(2693),
    [anon_sym_requires] = ACTIONS(2693),
    [sym_this] = ACTIONS(2693),
  },
  [439] = {
    [sym_identifier] = ACTIONS(2681),
    [aux_sym_preproc_include_token1] = ACTIONS(2681),
    [aux_sym_preproc_def_token1] = ACTIONS(2681),
    [aux_sym_preproc_if_token1] = ACTIONS(2681),
    [aux_sym_preproc_if_token2] = ACTIONS(2681),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2681),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2681),
    [sym_preproc_directive] = ACTIONS(2681),
    [anon_sym_LPAREN2] = ACTIONS(2683),
    [anon_sym_BANG] = ACTIONS(2683),
    [anon_sym_TILDE] = ACTIONS(2683),
    [anon_sym_DASH] = ACTIONS(2681),
    [anon_sym_PLUS] = ACTIONS(2681),
    [anon_sym_STAR] = ACTIONS(2683),
    [anon_sym_AMP_AMP] = ACTIONS(2683),
    [anon_sym_AMP] = ACTIONS(2681),
    [anon_sym_SEMI] = ACTIONS(2683),
    [anon_sym___extension__] = ACTIONS(2681),
    [anon_sym_typedef] = ACTIONS(2681),
    [anon_sym_virtual] = ACTIONS(2681),
    [anon_sym_extern] = ACTIONS(2681),
    [anon_sym___attribute__] = ACTIONS(2681),
    [anon_sym___attribute] = ACTIONS(2681),
    [anon_sym_COLON_COLON] = ACTIONS(2683),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2683),
    [anon_sym___declspec] = ACTIONS(2681),
    [anon_sym___based] = ACTIONS(2681),
    [anon_sym___cdecl] = ACTIONS(2681),
    [anon_sym___clrcall] = ACTIONS(2681),
    [anon_sym___stdcall] = ACTIONS(2681),
    [anon_sym___fastcall] = ACTIONS(2681),
    [anon_sym___thiscall] = ACTIONS(2681),
    [anon_sym___vectorcall] = ACTIONS(2681),
    [anon_sym_LBRACE] = ACTIONS(2683),
    [anon_sym_signed] = ACTIONS(2681),
    [anon_sym_unsigned] = ACTIONS(2681),
    [anon_sym_long] = ACTIONS(2681),
    [anon_sym_short] = ACTIONS(2681),
    [anon_sym_LBRACK] = ACTIONS(2681),
    [anon_sym_static] = ACTIONS(2681),
    [anon_sym_register] = ACTIONS(2681),
    [anon_sym_inline] = ACTIONS(2681),
    [anon_sym___inline] = ACTIONS(2681),
    [anon_sym___inline__] = ACTIONS(2681),
    [anon_sym___forceinline] = ACTIONS(2681),
    [anon_sym_thread_local] = ACTIONS(2681),
    [anon_sym___thread] = ACTIONS(2681),
    [anon_sym_const] = ACTIONS(2681),
    [anon_sym_constexpr] = ACTIONS(2681),
    [anon_sym_volatile] = ACTIONS(2681),
    [anon_sym_restrict] = ACTIONS(2681),
    [anon_sym___restrict__] = ACTIONS(2681),
    [anon_sym__Atomic] = ACTIONS(2681),
    [anon_sym__Noreturn] = ACTIONS(2681),
    [anon_sym_noreturn] = ACTIONS(2681),
    [anon_sym__Nonnull] = ACTIONS(2681),
    [anon_sym_mutable] = ACTIONS(2681),
    [anon_sym_constinit] = ACTIONS(2681),
    [anon_sym_consteval] = ACTIONS(2681),
    [anon_sym_alignas] = ACTIONS(2681),
    [anon_sym__Alignas] = ACTIONS(2681),
    [sym_primitive_type] = ACTIONS(2681),
    [anon_sym_enum] = ACTIONS(2681),
    [anon_sym_class] = ACTIONS(2681),
    [anon_sym_struct] = ACTIONS(2681),
    [anon_sym_union] = ACTIONS(2681),
    [anon_sym_if] = ACTIONS(2681),
    [anon_sym_else] = ACTIONS(2681),
    [anon_sym_switch] = ACTIONS(2681),
    [anon_sym_case] = ACTIONS(2681),
    [anon_sym_default] = ACTIONS(2681),
    [anon_sym_while] = ACTIONS(2681),
    [anon_sym_do] = ACTIONS(2681),
    [anon_sym_for] = ACTIONS(2681),
    [anon_sym_return] = ACTIONS(2681),
    [anon_sym_break] = ACTIONS(2681),
    [anon_sym_continue] = ACTIONS(2681),
    [anon_sym_goto] = ACTIONS(2681),
    [anon_sym___try] = ACTIONS(2681),
    [anon_sym___leave] = ACTIONS(2681),
    [anon_sym_not] = ACTIONS(2681),
    [anon_sym_compl] = ACTIONS(2681),
    [anon_sym_DASH_DASH] = ACTIONS(2683),
    [anon_sym_PLUS_PLUS] = ACTIONS(2683),
    [anon_sym_sizeof] = ACTIONS(2681),
    [anon_sym___alignof__] = ACTIONS(2681),
    [anon_sym___alignof] = ACTIONS(2681),
    [anon_sym__alignof] = ACTIONS(2681),
    [anon_sym_alignof] = ACTIONS(2681),
    [anon_sym__Alignof] = ACTIONS(2681),
    [anon_sym_offsetof] = ACTIONS(2681),
    [anon_sym__Generic] = ACTIONS(2681),
    [anon_sym_asm] = ACTIONS(2681),
    [anon_sym___asm__] = ACTIONS(2681),
    [anon_sym___asm] = ACTIONS(2681),
    [sym_number_literal] = ACTIONS(2683),
    [anon_sym_L_SQUOTE] = ACTIONS(2683),
    [anon_sym_u_SQUOTE] = ACTIONS(2683),
    [anon_sym_U_SQUOTE] = ACTIONS(2683),
    [anon_sym_u8_SQUOTE] = ACTIONS(2683),
    [anon_sym_SQUOTE] = ACTIONS(2683),
    [anon_sym_L_DQUOTE] = ACTIONS(2683),
    [anon_sym_u_DQUOTE] = ACTIONS(2683),
    [anon_sym_U_DQUOTE] = ACTIONS(2683),
    [anon_sym_u8_DQUOTE] = ACTIONS(2683),
    [anon_sym_DQUOTE] = ACTIONS(2683),
    [sym_true] = ACTIONS(2681),
    [sym_false] = ACTIONS(2681),
    [anon_sym_NULL] = ACTIONS(2681),
    [anon_sym_nullptr] = ACTIONS(2681),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2681),
    [anon_sym_decltype] = ACTIONS(2681),
    [anon_sym_explicit] = ACTIONS(2681),
    [anon_sym_typename] = ACTIONS(2681),
    [anon_sym_template] = ACTIONS(2681),
    [anon_sym_operator] = ACTIONS(2681),
    [anon_sym_try] = ACTIONS(2681),
    [anon_sym_delete] = ACTIONS(2681),
    [anon_sym_throw] = ACTIONS(2681),
    [anon_sym_namespace] = ACTIONS(2681),
    [anon_sym_using] = ACTIONS(2681),
    [anon_sym_static_assert] = ACTIONS(2681),
    [anon_sym_concept] = ACTIONS(2681),
    [anon_sym_co_return] = ACTIONS(2681),
    [anon_sym_co_yield] = ACTIONS(2681),
    [anon_sym_R_DQUOTE] = ACTIONS(2683),
    [anon_sym_LR_DQUOTE] = ACTIONS(2683),
    [anon_sym_uR_DQUOTE] = ACTIONS(2683),
    [anon_sym_UR_DQUOTE] = ACTIONS(2683),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2683),
    [anon_sym_co_await] = ACTIONS(2681),
    [anon_sym_new] = ACTIONS(2681),
    [anon_sym_requires] = ACTIONS(2681),
    [sym_this] = ACTIONS(2681),
  },
  [440] = {
    [ts_builtin_sym_end] = ACTIONS(2619),
    [sym_identifier] = ACTIONS(2617),
    [aux_sym_preproc_include_token1] = ACTIONS(2617),
    [aux_sym_preproc_def_token1] = ACTIONS(2617),
    [aux_sym_preproc_if_token1] = ACTIONS(2617),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2617),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2617),
    [sym_preproc_directive] = ACTIONS(2617),
    [anon_sym_LPAREN2] = ACTIONS(2619),
    [anon_sym_BANG] = ACTIONS(2619),
    [anon_sym_TILDE] = ACTIONS(2619),
    [anon_sym_DASH] = ACTIONS(2617),
    [anon_sym_PLUS] = ACTIONS(2617),
    [anon_sym_STAR] = ACTIONS(2619),
    [anon_sym_AMP_AMP] = ACTIONS(2619),
    [anon_sym_AMP] = ACTIONS(2617),
    [anon_sym_SEMI] = ACTIONS(2619),
    [anon_sym___extension__] = ACTIONS(2617),
    [anon_sym_typedef] = ACTIONS(2617),
    [anon_sym_virtual] = ACTIONS(2617),
    [anon_sym_extern] = ACTIONS(2617),
    [anon_sym___attribute__] = ACTIONS(2617),
    [anon_sym___attribute] = ACTIONS(2617),
    [anon_sym_COLON_COLON] = ACTIONS(2619),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2619),
    [anon_sym___declspec] = ACTIONS(2617),
    [anon_sym___based] = ACTIONS(2617),
    [anon_sym___cdecl] = ACTIONS(2617),
    [anon_sym___clrcall] = ACTIONS(2617),
    [anon_sym___stdcall] = ACTIONS(2617),
    [anon_sym___fastcall] = ACTIONS(2617),
    [anon_sym___thiscall] = ACTIONS(2617),
    [anon_sym___vectorcall] = ACTIONS(2617),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_signed] = ACTIONS(2617),
    [anon_sym_unsigned] = ACTIONS(2617),
    [anon_sym_long] = ACTIONS(2617),
    [anon_sym_short] = ACTIONS(2617),
    [anon_sym_LBRACK] = ACTIONS(2617),
    [anon_sym_static] = ACTIONS(2617),
    [anon_sym_register] = ACTIONS(2617),
    [anon_sym_inline] = ACTIONS(2617),
    [anon_sym___inline] = ACTIONS(2617),
    [anon_sym___inline__] = ACTIONS(2617),
    [anon_sym___forceinline] = ACTIONS(2617),
    [anon_sym_thread_local] = ACTIONS(2617),
    [anon_sym___thread] = ACTIONS(2617),
    [anon_sym_const] = ACTIONS(2617),
    [anon_sym_constexpr] = ACTIONS(2617),
    [anon_sym_volatile] = ACTIONS(2617),
    [anon_sym_restrict] = ACTIONS(2617),
    [anon_sym___restrict__] = ACTIONS(2617),
    [anon_sym__Atomic] = ACTIONS(2617),
    [anon_sym__Noreturn] = ACTIONS(2617),
    [anon_sym_noreturn] = ACTIONS(2617),
    [anon_sym__Nonnull] = ACTIONS(2617),
    [anon_sym_mutable] = ACTIONS(2617),
    [anon_sym_constinit] = ACTIONS(2617),
    [anon_sym_consteval] = ACTIONS(2617),
    [anon_sym_alignas] = ACTIONS(2617),
    [anon_sym__Alignas] = ACTIONS(2617),
    [sym_primitive_type] = ACTIONS(2617),
    [anon_sym_enum] = ACTIONS(2617),
    [anon_sym_class] = ACTIONS(2617),
    [anon_sym_struct] = ACTIONS(2617),
    [anon_sym_union] = ACTIONS(2617),
    [anon_sym_if] = ACTIONS(2617),
    [anon_sym_else] = ACTIONS(2617),
    [anon_sym_switch] = ACTIONS(2617),
    [anon_sym_case] = ACTIONS(2617),
    [anon_sym_default] = ACTIONS(2617),
    [anon_sym_while] = ACTIONS(2617),
    [anon_sym_do] = ACTIONS(2617),
    [anon_sym_for] = ACTIONS(2617),
    [anon_sym_return] = ACTIONS(2617),
    [anon_sym_break] = ACTIONS(2617),
    [anon_sym_continue] = ACTIONS(2617),
    [anon_sym_goto] = ACTIONS(2617),
    [anon_sym___try] = ACTIONS(2617),
    [anon_sym___leave] = ACTIONS(2617),
    [anon_sym_not] = ACTIONS(2617),
    [anon_sym_compl] = ACTIONS(2617),
    [anon_sym_DASH_DASH] = ACTIONS(2619),
    [anon_sym_PLUS_PLUS] = ACTIONS(2619),
    [anon_sym_sizeof] = ACTIONS(2617),
    [anon_sym___alignof__] = ACTIONS(2617),
    [anon_sym___alignof] = ACTIONS(2617),
    [anon_sym__alignof] = ACTIONS(2617),
    [anon_sym_alignof] = ACTIONS(2617),
    [anon_sym__Alignof] = ACTIONS(2617),
    [anon_sym_offsetof] = ACTIONS(2617),
    [anon_sym__Generic] = ACTIONS(2617),
    [anon_sym_asm] = ACTIONS(2617),
    [anon_sym___asm__] = ACTIONS(2617),
    [anon_sym___asm] = ACTIONS(2617),
    [sym_number_literal] = ACTIONS(2619),
    [anon_sym_L_SQUOTE] = ACTIONS(2619),
    [anon_sym_u_SQUOTE] = ACTIONS(2619),
    [anon_sym_U_SQUOTE] = ACTIONS(2619),
    [anon_sym_u8_SQUOTE] = ACTIONS(2619),
    [anon_sym_SQUOTE] = ACTIONS(2619),
    [anon_sym_L_DQUOTE] = ACTIONS(2619),
    [anon_sym_u_DQUOTE] = ACTIONS(2619),
    [anon_sym_U_DQUOTE] = ACTIONS(2619),
    [anon_sym_u8_DQUOTE] = ACTIONS(2619),
    [anon_sym_DQUOTE] = ACTIONS(2619),
    [sym_true] = ACTIONS(2617),
    [sym_false] = ACTIONS(2617),
    [anon_sym_NULL] = ACTIONS(2617),
    [anon_sym_nullptr] = ACTIONS(2617),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2617),
    [anon_sym_decltype] = ACTIONS(2617),
    [anon_sym_explicit] = ACTIONS(2617),
    [anon_sym_typename] = ACTIONS(2617),
    [anon_sym_template] = ACTIONS(2617),
    [anon_sym_operator] = ACTIONS(2617),
    [anon_sym_try] = ACTIONS(2617),
    [anon_sym_delete] = ACTIONS(2617),
    [anon_sym_throw] = ACTIONS(2617),
    [anon_sym_namespace] = ACTIONS(2617),
    [anon_sym_using] = ACTIONS(2617),
    [anon_sym_static_assert] = ACTIONS(2617),
    [anon_sym_concept] = ACTIONS(2617),
    [anon_sym_co_return] = ACTIONS(2617),
    [anon_sym_co_yield] = ACTIONS(2617),
    [anon_sym_R_DQUOTE] = ACTIONS(2619),
    [anon_sym_LR_DQUOTE] = ACTIONS(2619),
    [anon_sym_uR_DQUOTE] = ACTIONS(2619),
    [anon_sym_UR_DQUOTE] = ACTIONS(2619),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2619),
    [anon_sym_co_await] = ACTIONS(2617),
    [anon_sym_new] = ACTIONS(2617),
    [anon_sym_requires] = ACTIONS(2617),
    [sym_this] = ACTIONS(2617),
  },
  [441] = {
    [sym_identifier] = ACTIONS(2629),
    [aux_sym_preproc_include_token1] = ACTIONS(2629),
    [aux_sym_preproc_def_token1] = ACTIONS(2629),
    [aux_sym_preproc_if_token1] = ACTIONS(2629),
    [aux_sym_preproc_if_token2] = ACTIONS(2629),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2629),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2629),
    [sym_preproc_directive] = ACTIONS(2629),
    [anon_sym_LPAREN2] = ACTIONS(2631),
    [anon_sym_BANG] = ACTIONS(2631),
    [anon_sym_TILDE] = ACTIONS(2631),
    [anon_sym_DASH] = ACTIONS(2629),
    [anon_sym_PLUS] = ACTIONS(2629),
    [anon_sym_STAR] = ACTIONS(2631),
    [anon_sym_AMP_AMP] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2629),
    [anon_sym_SEMI] = ACTIONS(2631),
    [anon_sym___extension__] = ACTIONS(2629),
    [anon_sym_typedef] = ACTIONS(2629),
    [anon_sym_virtual] = ACTIONS(2629),
    [anon_sym_extern] = ACTIONS(2629),
    [anon_sym___attribute__] = ACTIONS(2629),
    [anon_sym___attribute] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(2631),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2631),
    [anon_sym___declspec] = ACTIONS(2629),
    [anon_sym___based] = ACTIONS(2629),
    [anon_sym___cdecl] = ACTIONS(2629),
    [anon_sym___clrcall] = ACTIONS(2629),
    [anon_sym___stdcall] = ACTIONS(2629),
    [anon_sym___fastcall] = ACTIONS(2629),
    [anon_sym___thiscall] = ACTIONS(2629),
    [anon_sym___vectorcall] = ACTIONS(2629),
    [anon_sym_LBRACE] = ACTIONS(2631),
    [anon_sym_signed] = ACTIONS(2629),
    [anon_sym_unsigned] = ACTIONS(2629),
    [anon_sym_long] = ACTIONS(2629),
    [anon_sym_short] = ACTIONS(2629),
    [anon_sym_LBRACK] = ACTIONS(2629),
    [anon_sym_static] = ACTIONS(2629),
    [anon_sym_register] = ACTIONS(2629),
    [anon_sym_inline] = ACTIONS(2629),
    [anon_sym___inline] = ACTIONS(2629),
    [anon_sym___inline__] = ACTIONS(2629),
    [anon_sym___forceinline] = ACTIONS(2629),
    [anon_sym_thread_local] = ACTIONS(2629),
    [anon_sym___thread] = ACTIONS(2629),
    [anon_sym_const] = ACTIONS(2629),
    [anon_sym_constexpr] = ACTIONS(2629),
    [anon_sym_volatile] = ACTIONS(2629),
    [anon_sym_restrict] = ACTIONS(2629),
    [anon_sym___restrict__] = ACTIONS(2629),
    [anon_sym__Atomic] = ACTIONS(2629),
    [anon_sym__Noreturn] = ACTIONS(2629),
    [anon_sym_noreturn] = ACTIONS(2629),
    [anon_sym__Nonnull] = ACTIONS(2629),
    [anon_sym_mutable] = ACTIONS(2629),
    [anon_sym_constinit] = ACTIONS(2629),
    [anon_sym_consteval] = ACTIONS(2629),
    [anon_sym_alignas] = ACTIONS(2629),
    [anon_sym__Alignas] = ACTIONS(2629),
    [sym_primitive_type] = ACTIONS(2629),
    [anon_sym_enum] = ACTIONS(2629),
    [anon_sym_class] = ACTIONS(2629),
    [anon_sym_struct] = ACTIONS(2629),
    [anon_sym_union] = ACTIONS(2629),
    [anon_sym_if] = ACTIONS(2629),
    [anon_sym_else] = ACTIONS(2629),
    [anon_sym_switch] = ACTIONS(2629),
    [anon_sym_case] = ACTIONS(2629),
    [anon_sym_default] = ACTIONS(2629),
    [anon_sym_while] = ACTIONS(2629),
    [anon_sym_do] = ACTIONS(2629),
    [anon_sym_for] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(2629),
    [anon_sym_break] = ACTIONS(2629),
    [anon_sym_continue] = ACTIONS(2629),
    [anon_sym_goto] = ACTIONS(2629),
    [anon_sym___try] = ACTIONS(2629),
    [anon_sym___leave] = ACTIONS(2629),
    [anon_sym_not] = ACTIONS(2629),
    [anon_sym_compl] = ACTIONS(2629),
    [anon_sym_DASH_DASH] = ACTIONS(2631),
    [anon_sym_PLUS_PLUS] = ACTIONS(2631),
    [anon_sym_sizeof] = ACTIONS(2629),
    [anon_sym___alignof__] = ACTIONS(2629),
    [anon_sym___alignof] = ACTIONS(2629),
    [anon_sym__alignof] = ACTIONS(2629),
    [anon_sym_alignof] = ACTIONS(2629),
    [anon_sym__Alignof] = ACTIONS(2629),
    [anon_sym_offsetof] = ACTIONS(2629),
    [anon_sym__Generic] = ACTIONS(2629),
    [anon_sym_asm] = ACTIONS(2629),
    [anon_sym___asm__] = ACTIONS(2629),
    [anon_sym___asm] = ACTIONS(2629),
    [sym_number_literal] = ACTIONS(2631),
    [anon_sym_L_SQUOTE] = ACTIONS(2631),
    [anon_sym_u_SQUOTE] = ACTIONS(2631),
    [anon_sym_U_SQUOTE] = ACTIONS(2631),
    [anon_sym_u8_SQUOTE] = ACTIONS(2631),
    [anon_sym_SQUOTE] = ACTIONS(2631),
    [anon_sym_L_DQUOTE] = ACTIONS(2631),
    [anon_sym_u_DQUOTE] = ACTIONS(2631),
    [anon_sym_U_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8_DQUOTE] = ACTIONS(2631),
    [anon_sym_DQUOTE] = ACTIONS(2631),
    [sym_true] = ACTIONS(2629),
    [sym_false] = ACTIONS(2629),
    [anon_sym_NULL] = ACTIONS(2629),
    [anon_sym_nullptr] = ACTIONS(2629),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2629),
    [anon_sym_decltype] = ACTIONS(2629),
    [anon_sym_explicit] = ACTIONS(2629),
    [anon_sym_typename] = ACTIONS(2629),
    [anon_sym_template] = ACTIONS(2629),
    [anon_sym_operator] = ACTIONS(2629),
    [anon_sym_try] = ACTIONS(2629),
    [anon_sym_delete] = ACTIONS(2629),
    [anon_sym_throw] = ACTIONS(2629),
    [anon_sym_namespace] = ACTIONS(2629),
    [anon_sym_using] = ACTIONS(2629),
    [anon_sym_static_assert] = ACTIONS(2629),
    [anon_sym_concept] = ACTIONS(2629),
    [anon_sym_co_return] = ACTIONS(2629),
    [anon_sym_co_yield] = ACTIONS(2629),
    [anon_sym_R_DQUOTE] = ACTIONS(2631),
    [anon_sym_LR_DQUOTE] = ACTIONS(2631),
    [anon_sym_uR_DQUOTE] = ACTIONS(2631),
    [anon_sym_UR_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2631),
    [anon_sym_co_await] = ACTIONS(2629),
    [anon_sym_new] = ACTIONS(2629),
    [anon_sym_requires] = ACTIONS(2629),
    [sym_this] = ACTIONS(2629),
  },
  [442] = {
    [sym_identifier] = ACTIONS(2641),
    [aux_sym_preproc_include_token1] = ACTIONS(2641),
    [aux_sym_preproc_def_token1] = ACTIONS(2641),
    [aux_sym_preproc_if_token1] = ACTIONS(2641),
    [aux_sym_preproc_if_token2] = ACTIONS(2641),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2641),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2641),
    [sym_preproc_directive] = ACTIONS(2641),
    [anon_sym_LPAREN2] = ACTIONS(2643),
    [anon_sym_BANG] = ACTIONS(2643),
    [anon_sym_TILDE] = ACTIONS(2643),
    [anon_sym_DASH] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(2641),
    [anon_sym_STAR] = ACTIONS(2643),
    [anon_sym_AMP_AMP] = ACTIONS(2643),
    [anon_sym_AMP] = ACTIONS(2641),
    [anon_sym_SEMI] = ACTIONS(2643),
    [anon_sym___extension__] = ACTIONS(2641),
    [anon_sym_typedef] = ACTIONS(2641),
    [anon_sym_virtual] = ACTIONS(2641),
    [anon_sym_extern] = ACTIONS(2641),
    [anon_sym___attribute__] = ACTIONS(2641),
    [anon_sym___attribute] = ACTIONS(2641),
    [anon_sym_COLON_COLON] = ACTIONS(2643),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2643),
    [anon_sym___declspec] = ACTIONS(2641),
    [anon_sym___based] = ACTIONS(2641),
    [anon_sym___cdecl] = ACTIONS(2641),
    [anon_sym___clrcall] = ACTIONS(2641),
    [anon_sym___stdcall] = ACTIONS(2641),
    [anon_sym___fastcall] = ACTIONS(2641),
    [anon_sym___thiscall] = ACTIONS(2641),
    [anon_sym___vectorcall] = ACTIONS(2641),
    [anon_sym_LBRACE] = ACTIONS(2643),
    [anon_sym_signed] = ACTIONS(2641),
    [anon_sym_unsigned] = ACTIONS(2641),
    [anon_sym_long] = ACTIONS(2641),
    [anon_sym_short] = ACTIONS(2641),
    [anon_sym_LBRACK] = ACTIONS(2641),
    [anon_sym_static] = ACTIONS(2641),
    [anon_sym_register] = ACTIONS(2641),
    [anon_sym_inline] = ACTIONS(2641),
    [anon_sym___inline] = ACTIONS(2641),
    [anon_sym___inline__] = ACTIONS(2641),
    [anon_sym___forceinline] = ACTIONS(2641),
    [anon_sym_thread_local] = ACTIONS(2641),
    [anon_sym___thread] = ACTIONS(2641),
    [anon_sym_const] = ACTIONS(2641),
    [anon_sym_constexpr] = ACTIONS(2641),
    [anon_sym_volatile] = ACTIONS(2641),
    [anon_sym_restrict] = ACTIONS(2641),
    [anon_sym___restrict__] = ACTIONS(2641),
    [anon_sym__Atomic] = ACTIONS(2641),
    [anon_sym__Noreturn] = ACTIONS(2641),
    [anon_sym_noreturn] = ACTIONS(2641),
    [anon_sym__Nonnull] = ACTIONS(2641),
    [anon_sym_mutable] = ACTIONS(2641),
    [anon_sym_constinit] = ACTIONS(2641),
    [anon_sym_consteval] = ACTIONS(2641),
    [anon_sym_alignas] = ACTIONS(2641),
    [anon_sym__Alignas] = ACTIONS(2641),
    [sym_primitive_type] = ACTIONS(2641),
    [anon_sym_enum] = ACTIONS(2641),
    [anon_sym_class] = ACTIONS(2641),
    [anon_sym_struct] = ACTIONS(2641),
    [anon_sym_union] = ACTIONS(2641),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_else] = ACTIONS(2641),
    [anon_sym_switch] = ACTIONS(2641),
    [anon_sym_case] = ACTIONS(2641),
    [anon_sym_default] = ACTIONS(2641),
    [anon_sym_while] = ACTIONS(2641),
    [anon_sym_do] = ACTIONS(2641),
    [anon_sym_for] = ACTIONS(2641),
    [anon_sym_return] = ACTIONS(2641),
    [anon_sym_break] = ACTIONS(2641),
    [anon_sym_continue] = ACTIONS(2641),
    [anon_sym_goto] = ACTIONS(2641),
    [anon_sym___try] = ACTIONS(2641),
    [anon_sym___leave] = ACTIONS(2641),
    [anon_sym_not] = ACTIONS(2641),
    [anon_sym_compl] = ACTIONS(2641),
    [anon_sym_DASH_DASH] = ACTIONS(2643),
    [anon_sym_PLUS_PLUS] = ACTIONS(2643),
    [anon_sym_sizeof] = ACTIONS(2641),
    [anon_sym___alignof__] = ACTIONS(2641),
    [anon_sym___alignof] = ACTIONS(2641),
    [anon_sym__alignof] = ACTIONS(2641),
    [anon_sym_alignof] = ACTIONS(2641),
    [anon_sym__Alignof] = ACTIONS(2641),
    [anon_sym_offsetof] = ACTIONS(2641),
    [anon_sym__Generic] = ACTIONS(2641),
    [anon_sym_asm] = ACTIONS(2641),
    [anon_sym___asm__] = ACTIONS(2641),
    [anon_sym___asm] = ACTIONS(2641),
    [sym_number_literal] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2643),
    [anon_sym_u_SQUOTE] = ACTIONS(2643),
    [anon_sym_U_SQUOTE] = ACTIONS(2643),
    [anon_sym_u8_SQUOTE] = ACTIONS(2643),
    [anon_sym_SQUOTE] = ACTIONS(2643),
    [anon_sym_L_DQUOTE] = ACTIONS(2643),
    [anon_sym_u_DQUOTE] = ACTIONS(2643),
    [anon_sym_U_DQUOTE] = ACTIONS(2643),
    [anon_sym_u8_DQUOTE] = ACTIONS(2643),
    [anon_sym_DQUOTE] = ACTIONS(2643),
    [sym_true] = ACTIONS(2641),
    [sym_false] = ACTIONS(2641),
    [anon_sym_NULL] = ACTIONS(2641),
    [anon_sym_nullptr] = ACTIONS(2641),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2641),
    [anon_sym_decltype] = ACTIONS(2641),
    [anon_sym_explicit] = ACTIONS(2641),
    [anon_sym_typename] = ACTIONS(2641),
    [anon_sym_template] = ACTIONS(2641),
    [anon_sym_operator] = ACTIONS(2641),
    [anon_sym_try] = ACTIONS(2641),
    [anon_sym_delete] = ACTIONS(2641),
    [anon_sym_throw] = ACTIONS(2641),
    [anon_sym_namespace] = ACTIONS(2641),
    [anon_sym_using] = ACTIONS(2641),
    [anon_sym_static_assert] = ACTIONS(2641),
    [anon_sym_concept] = ACTIONS(2641),
    [anon_sym_co_return] = ACTIONS(2641),
    [anon_sym_co_yield] = ACTIONS(2641),
    [anon_sym_R_DQUOTE] = ACTIONS(2643),
    [anon_sym_LR_DQUOTE] = ACTIONS(2643),
    [anon_sym_uR_DQUOTE] = ACTIONS(2643),
    [anon_sym_UR_DQUOTE] = ACTIONS(2643),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2643),
    [anon_sym_co_await] = ACTIONS(2641),
    [anon_sym_new] = ACTIONS(2641),
    [anon_sym_requires] = ACTIONS(2641),
    [sym_this] = ACTIONS(2641),
  },
  [443] = {
    [sym_identifier] = ACTIONS(1913),
    [aux_sym_preproc_include_token1] = ACTIONS(1913),
    [aux_sym_preproc_def_token1] = ACTIONS(1913),
    [anon_sym_COMMA] = ACTIONS(2721),
    [aux_sym_preproc_if_token1] = ACTIONS(1913),
    [aux_sym_preproc_if_token2] = ACTIONS(1913),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1913),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1913),
    [sym_preproc_directive] = ACTIONS(1913),
    [anon_sym_LPAREN2] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_DASH] = ACTIONS(1913),
    [anon_sym_PLUS] = ACTIONS(1913),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_AMP_AMP] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1913),
    [anon_sym_SEMI] = ACTIONS(2721),
    [anon_sym___extension__] = ACTIONS(1913),
    [anon_sym_typedef] = ACTIONS(1913),
    [anon_sym_virtual] = ACTIONS(1913),
    [anon_sym_extern] = ACTIONS(1913),
    [anon_sym___attribute__] = ACTIONS(1913),
    [anon_sym___attribute] = ACTIONS(1913),
    [anon_sym_COLON_COLON] = ACTIONS(1911),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1911),
    [anon_sym___declspec] = ACTIONS(1913),
    [anon_sym___based] = ACTIONS(1913),
    [anon_sym___cdecl] = ACTIONS(1913),
    [anon_sym___clrcall] = ACTIONS(1913),
    [anon_sym___stdcall] = ACTIONS(1913),
    [anon_sym___fastcall] = ACTIONS(1913),
    [anon_sym___thiscall] = ACTIONS(1913),
    [anon_sym___vectorcall] = ACTIONS(1913),
    [anon_sym_LBRACE] = ACTIONS(1911),
    [anon_sym_signed] = ACTIONS(1913),
    [anon_sym_unsigned] = ACTIONS(1913),
    [anon_sym_long] = ACTIONS(1913),
    [anon_sym_short] = ACTIONS(1913),
    [anon_sym_LBRACK] = ACTIONS(1913),
    [anon_sym_static] = ACTIONS(1913),
    [anon_sym_register] = ACTIONS(1913),
    [anon_sym_inline] = ACTIONS(1913),
    [anon_sym___inline] = ACTIONS(1913),
    [anon_sym___inline__] = ACTIONS(1913),
    [anon_sym___forceinline] = ACTIONS(1913),
    [anon_sym_thread_local] = ACTIONS(1913),
    [anon_sym___thread] = ACTIONS(1913),
    [anon_sym_const] = ACTIONS(1913),
    [anon_sym_constexpr] = ACTIONS(1913),
    [anon_sym_volatile] = ACTIONS(1913),
    [anon_sym_restrict] = ACTIONS(1913),
    [anon_sym___restrict__] = ACTIONS(1913),
    [anon_sym__Atomic] = ACTIONS(1913),
    [anon_sym__Noreturn] = ACTIONS(1913),
    [anon_sym_noreturn] = ACTIONS(1913),
    [anon_sym__Nonnull] = ACTIONS(1913),
    [anon_sym_mutable] = ACTIONS(1913),
    [anon_sym_constinit] = ACTIONS(1913),
    [anon_sym_consteval] = ACTIONS(1913),
    [anon_sym_alignas] = ACTIONS(1913),
    [anon_sym__Alignas] = ACTIONS(1913),
    [sym_primitive_type] = ACTIONS(1913),
    [anon_sym_enum] = ACTIONS(1913),
    [anon_sym_class] = ACTIONS(1913),
    [anon_sym_struct] = ACTIONS(1913),
    [anon_sym_union] = ACTIONS(1913),
    [anon_sym_if] = ACTIONS(1913),
    [anon_sym_switch] = ACTIONS(1913),
    [anon_sym_case] = ACTIONS(1913),
    [anon_sym_default] = ACTIONS(1913),
    [anon_sym_while] = ACTIONS(1913),
    [anon_sym_do] = ACTIONS(1913),
    [anon_sym_for] = ACTIONS(1913),
    [anon_sym_return] = ACTIONS(1913),
    [anon_sym_break] = ACTIONS(1913),
    [anon_sym_continue] = ACTIONS(1913),
    [anon_sym_goto] = ACTIONS(1913),
    [anon_sym___try] = ACTIONS(1913),
    [anon_sym___leave] = ACTIONS(1913),
    [anon_sym_not] = ACTIONS(1913),
    [anon_sym_compl] = ACTIONS(1913),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_sizeof] = ACTIONS(1913),
    [anon_sym___alignof__] = ACTIONS(1913),
    [anon_sym___alignof] = ACTIONS(1913),
    [anon_sym__alignof] = ACTIONS(1913),
    [anon_sym_alignof] = ACTIONS(1913),
    [anon_sym__Alignof] = ACTIONS(1913),
    [anon_sym_offsetof] = ACTIONS(1913),
    [anon_sym__Generic] = ACTIONS(1913),
    [anon_sym_asm] = ACTIONS(1913),
    [anon_sym___asm__] = ACTIONS(1913),
    [anon_sym___asm] = ACTIONS(1913),
    [sym_number_literal] = ACTIONS(1911),
    [anon_sym_L_SQUOTE] = ACTIONS(1911),
    [anon_sym_u_SQUOTE] = ACTIONS(1911),
    [anon_sym_U_SQUOTE] = ACTIONS(1911),
    [anon_sym_u8_SQUOTE] = ACTIONS(1911),
    [anon_sym_SQUOTE] = ACTIONS(1911),
    [anon_sym_L_DQUOTE] = ACTIONS(1911),
    [anon_sym_u_DQUOTE] = ACTIONS(1911),
    [anon_sym_U_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8_DQUOTE] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(1911),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1913),
    [anon_sym_nullptr] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1913),
    [anon_sym_decltype] = ACTIONS(1913),
    [anon_sym_explicit] = ACTIONS(1913),
    [anon_sym_typename] = ACTIONS(1913),
    [anon_sym_template] = ACTIONS(1913),
    [anon_sym_operator] = ACTIONS(1913),
    [anon_sym_try] = ACTIONS(1913),
    [anon_sym_delete] = ACTIONS(1913),
    [anon_sym_throw] = ACTIONS(1913),
    [anon_sym_namespace] = ACTIONS(1913),
    [anon_sym_using] = ACTIONS(1913),
    [anon_sym_static_assert] = ACTIONS(1913),
    [anon_sym_concept] = ACTIONS(1913),
    [anon_sym_co_return] = ACTIONS(1913),
    [anon_sym_co_yield] = ACTIONS(1913),
    [anon_sym_R_DQUOTE] = ACTIONS(1911),
    [anon_sym_LR_DQUOTE] = ACTIONS(1911),
    [anon_sym_uR_DQUOTE] = ACTIONS(1911),
    [anon_sym_UR_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1911),
    [anon_sym_co_await] = ACTIONS(1913),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_requires] = ACTIONS(1913),
    [sym_this] = ACTIONS(1913),
  },
  [444] = {
    [sym_identifier] = ACTIONS(2613),
    [aux_sym_preproc_include_token1] = ACTIONS(2613),
    [aux_sym_preproc_def_token1] = ACTIONS(2613),
    [aux_sym_preproc_if_token1] = ACTIONS(2613),
    [aux_sym_preproc_if_token2] = ACTIONS(2613),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2613),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2613),
    [sym_preproc_directive] = ACTIONS(2613),
    [anon_sym_LPAREN2] = ACTIONS(2615),
    [anon_sym_BANG] = ACTIONS(2615),
    [anon_sym_TILDE] = ACTIONS(2615),
    [anon_sym_DASH] = ACTIONS(2613),
    [anon_sym_PLUS] = ACTIONS(2613),
    [anon_sym_STAR] = ACTIONS(2615),
    [anon_sym_AMP_AMP] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2613),
    [anon_sym_SEMI] = ACTIONS(2615),
    [anon_sym___extension__] = ACTIONS(2613),
    [anon_sym_typedef] = ACTIONS(2613),
    [anon_sym_virtual] = ACTIONS(2613),
    [anon_sym_extern] = ACTIONS(2613),
    [anon_sym___attribute__] = ACTIONS(2613),
    [anon_sym___attribute] = ACTIONS(2613),
    [anon_sym_COLON_COLON] = ACTIONS(2615),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2615),
    [anon_sym___declspec] = ACTIONS(2613),
    [anon_sym___based] = ACTIONS(2613),
    [anon_sym___cdecl] = ACTIONS(2613),
    [anon_sym___clrcall] = ACTIONS(2613),
    [anon_sym___stdcall] = ACTIONS(2613),
    [anon_sym___fastcall] = ACTIONS(2613),
    [anon_sym___thiscall] = ACTIONS(2613),
    [anon_sym___vectorcall] = ACTIONS(2613),
    [anon_sym_LBRACE] = ACTIONS(2615),
    [anon_sym_signed] = ACTIONS(2613),
    [anon_sym_unsigned] = ACTIONS(2613),
    [anon_sym_long] = ACTIONS(2613),
    [anon_sym_short] = ACTIONS(2613),
    [anon_sym_LBRACK] = ACTIONS(2613),
    [anon_sym_static] = ACTIONS(2613),
    [anon_sym_register] = ACTIONS(2613),
    [anon_sym_inline] = ACTIONS(2613),
    [anon_sym___inline] = ACTIONS(2613),
    [anon_sym___inline__] = ACTIONS(2613),
    [anon_sym___forceinline] = ACTIONS(2613),
    [anon_sym_thread_local] = ACTIONS(2613),
    [anon_sym___thread] = ACTIONS(2613),
    [anon_sym_const] = ACTIONS(2613),
    [anon_sym_constexpr] = ACTIONS(2613),
    [anon_sym_volatile] = ACTIONS(2613),
    [anon_sym_restrict] = ACTIONS(2613),
    [anon_sym___restrict__] = ACTIONS(2613),
    [anon_sym__Atomic] = ACTIONS(2613),
    [anon_sym__Noreturn] = ACTIONS(2613),
    [anon_sym_noreturn] = ACTIONS(2613),
    [anon_sym__Nonnull] = ACTIONS(2613),
    [anon_sym_mutable] = ACTIONS(2613),
    [anon_sym_constinit] = ACTIONS(2613),
    [anon_sym_consteval] = ACTIONS(2613),
    [anon_sym_alignas] = ACTIONS(2613),
    [anon_sym__Alignas] = ACTIONS(2613),
    [sym_primitive_type] = ACTIONS(2613),
    [anon_sym_enum] = ACTIONS(2613),
    [anon_sym_class] = ACTIONS(2613),
    [anon_sym_struct] = ACTIONS(2613),
    [anon_sym_union] = ACTIONS(2613),
    [anon_sym_if] = ACTIONS(2613),
    [anon_sym_else] = ACTIONS(2613),
    [anon_sym_switch] = ACTIONS(2613),
    [anon_sym_case] = ACTIONS(2613),
    [anon_sym_default] = ACTIONS(2613),
    [anon_sym_while] = ACTIONS(2613),
    [anon_sym_do] = ACTIONS(2613),
    [anon_sym_for] = ACTIONS(2613),
    [anon_sym_return] = ACTIONS(2613),
    [anon_sym_break] = ACTIONS(2613),
    [anon_sym_continue] = ACTIONS(2613),
    [anon_sym_goto] = ACTIONS(2613),
    [anon_sym___try] = ACTIONS(2613),
    [anon_sym___leave] = ACTIONS(2613),
    [anon_sym_not] = ACTIONS(2613),
    [anon_sym_compl] = ACTIONS(2613),
    [anon_sym_DASH_DASH] = ACTIONS(2615),
    [anon_sym_PLUS_PLUS] = ACTIONS(2615),
    [anon_sym_sizeof] = ACTIONS(2613),
    [anon_sym___alignof__] = ACTIONS(2613),
    [anon_sym___alignof] = ACTIONS(2613),
    [anon_sym__alignof] = ACTIONS(2613),
    [anon_sym_alignof] = ACTIONS(2613),
    [anon_sym__Alignof] = ACTIONS(2613),
    [anon_sym_offsetof] = ACTIONS(2613),
    [anon_sym__Generic] = ACTIONS(2613),
    [anon_sym_asm] = ACTIONS(2613),
    [anon_sym___asm__] = ACTIONS(2613),
    [anon_sym___asm] = ACTIONS(2613),
    [sym_number_literal] = ACTIONS(2615),
    [anon_sym_L_SQUOTE] = ACTIONS(2615),
    [anon_sym_u_SQUOTE] = ACTIONS(2615),
    [anon_sym_U_SQUOTE] = ACTIONS(2615),
    [anon_sym_u8_SQUOTE] = ACTIONS(2615),
    [anon_sym_SQUOTE] = ACTIONS(2615),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2613),
    [sym_false] = ACTIONS(2613),
    [anon_sym_NULL] = ACTIONS(2613),
    [anon_sym_nullptr] = ACTIONS(2613),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2613),
    [anon_sym_decltype] = ACTIONS(2613),
    [anon_sym_explicit] = ACTIONS(2613),
    [anon_sym_typename] = ACTIONS(2613),
    [anon_sym_template] = ACTIONS(2613),
    [anon_sym_operator] = ACTIONS(2613),
    [anon_sym_try] = ACTIONS(2613),
    [anon_sym_delete] = ACTIONS(2613),
    [anon_sym_throw] = ACTIONS(2613),
    [anon_sym_namespace] = ACTIONS(2613),
    [anon_sym_using] = ACTIONS(2613),
    [anon_sym_static_assert] = ACTIONS(2613),
    [anon_sym_concept] = ACTIONS(2613),
    [anon_sym_co_return] = ACTIONS(2613),
    [anon_sym_co_yield] = ACTIONS(2613),
    [anon_sym_R_DQUOTE] = ACTIONS(2615),
    [anon_sym_LR_DQUOTE] = ACTIONS(2615),
    [anon_sym_uR_DQUOTE] = ACTIONS(2615),
    [anon_sym_UR_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2615),
    [anon_sym_co_await] = ACTIONS(2613),
    [anon_sym_new] = ACTIONS(2613),
    [anon_sym_requires] = ACTIONS(2613),
    [sym_this] = ACTIONS(2613),
  },
  [445] = {
    [sym_identifier] = ACTIONS(2645),
    [aux_sym_preproc_include_token1] = ACTIONS(2645),
    [aux_sym_preproc_def_token1] = ACTIONS(2645),
    [aux_sym_preproc_if_token1] = ACTIONS(2645),
    [aux_sym_preproc_if_token2] = ACTIONS(2645),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2645),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2645),
    [sym_preproc_directive] = ACTIONS(2645),
    [anon_sym_LPAREN2] = ACTIONS(2647),
    [anon_sym_BANG] = ACTIONS(2647),
    [anon_sym_TILDE] = ACTIONS(2647),
    [anon_sym_DASH] = ACTIONS(2645),
    [anon_sym_PLUS] = ACTIONS(2645),
    [anon_sym_STAR] = ACTIONS(2647),
    [anon_sym_AMP_AMP] = ACTIONS(2647),
    [anon_sym_AMP] = ACTIONS(2645),
    [anon_sym_SEMI] = ACTIONS(2647),
    [anon_sym___extension__] = ACTIONS(2645),
    [anon_sym_typedef] = ACTIONS(2645),
    [anon_sym_virtual] = ACTIONS(2645),
    [anon_sym_extern] = ACTIONS(2645),
    [anon_sym___attribute__] = ACTIONS(2645),
    [anon_sym___attribute] = ACTIONS(2645),
    [anon_sym_COLON_COLON] = ACTIONS(2647),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2647),
    [anon_sym___declspec] = ACTIONS(2645),
    [anon_sym___based] = ACTIONS(2645),
    [anon_sym___cdecl] = ACTIONS(2645),
    [anon_sym___clrcall] = ACTIONS(2645),
    [anon_sym___stdcall] = ACTIONS(2645),
    [anon_sym___fastcall] = ACTIONS(2645),
    [anon_sym___thiscall] = ACTIONS(2645),
    [anon_sym___vectorcall] = ACTIONS(2645),
    [anon_sym_LBRACE] = ACTIONS(2647),
    [anon_sym_signed] = ACTIONS(2645),
    [anon_sym_unsigned] = ACTIONS(2645),
    [anon_sym_long] = ACTIONS(2645),
    [anon_sym_short] = ACTIONS(2645),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_static] = ACTIONS(2645),
    [anon_sym_register] = ACTIONS(2645),
    [anon_sym_inline] = ACTIONS(2645),
    [anon_sym___inline] = ACTIONS(2645),
    [anon_sym___inline__] = ACTIONS(2645),
    [anon_sym___forceinline] = ACTIONS(2645),
    [anon_sym_thread_local] = ACTIONS(2645),
    [anon_sym___thread] = ACTIONS(2645),
    [anon_sym_const] = ACTIONS(2645),
    [anon_sym_constexpr] = ACTIONS(2645),
    [anon_sym_volatile] = ACTIONS(2645),
    [anon_sym_restrict] = ACTIONS(2645),
    [anon_sym___restrict__] = ACTIONS(2645),
    [anon_sym__Atomic] = ACTIONS(2645),
    [anon_sym__Noreturn] = ACTIONS(2645),
    [anon_sym_noreturn] = ACTIONS(2645),
    [anon_sym__Nonnull] = ACTIONS(2645),
    [anon_sym_mutable] = ACTIONS(2645),
    [anon_sym_constinit] = ACTIONS(2645),
    [anon_sym_consteval] = ACTIONS(2645),
    [anon_sym_alignas] = ACTIONS(2645),
    [anon_sym__Alignas] = ACTIONS(2645),
    [sym_primitive_type] = ACTIONS(2645),
    [anon_sym_enum] = ACTIONS(2645),
    [anon_sym_class] = ACTIONS(2645),
    [anon_sym_struct] = ACTIONS(2645),
    [anon_sym_union] = ACTIONS(2645),
    [anon_sym_if] = ACTIONS(2645),
    [anon_sym_else] = ACTIONS(2645),
    [anon_sym_switch] = ACTIONS(2645),
    [anon_sym_case] = ACTIONS(2645),
    [anon_sym_default] = ACTIONS(2645),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_do] = ACTIONS(2645),
    [anon_sym_for] = ACTIONS(2645),
    [anon_sym_return] = ACTIONS(2645),
    [anon_sym_break] = ACTIONS(2645),
    [anon_sym_continue] = ACTIONS(2645),
    [anon_sym_goto] = ACTIONS(2645),
    [anon_sym___try] = ACTIONS(2645),
    [anon_sym___leave] = ACTIONS(2645),
    [anon_sym_not] = ACTIONS(2645),
    [anon_sym_compl] = ACTIONS(2645),
    [anon_sym_DASH_DASH] = ACTIONS(2647),
    [anon_sym_PLUS_PLUS] = ACTIONS(2647),
    [anon_sym_sizeof] = ACTIONS(2645),
    [anon_sym___alignof__] = ACTIONS(2645),
    [anon_sym___alignof] = ACTIONS(2645),
    [anon_sym__alignof] = ACTIONS(2645),
    [anon_sym_alignof] = ACTIONS(2645),
    [anon_sym__Alignof] = ACTIONS(2645),
    [anon_sym_offsetof] = ACTIONS(2645),
    [anon_sym__Generic] = ACTIONS(2645),
    [anon_sym_asm] = ACTIONS(2645),
    [anon_sym___asm__] = ACTIONS(2645),
    [anon_sym___asm] = ACTIONS(2645),
    [sym_number_literal] = ACTIONS(2647),
    [anon_sym_L_SQUOTE] = ACTIONS(2647),
    [anon_sym_u_SQUOTE] = ACTIONS(2647),
    [anon_sym_U_SQUOTE] = ACTIONS(2647),
    [anon_sym_u8_SQUOTE] = ACTIONS(2647),
    [anon_sym_SQUOTE] = ACTIONS(2647),
    [anon_sym_L_DQUOTE] = ACTIONS(2647),
    [anon_sym_u_DQUOTE] = ACTIONS(2647),
    [anon_sym_U_DQUOTE] = ACTIONS(2647),
    [anon_sym_u8_DQUOTE] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(2647),
    [sym_true] = ACTIONS(2645),
    [sym_false] = ACTIONS(2645),
    [anon_sym_NULL] = ACTIONS(2645),
    [anon_sym_nullptr] = ACTIONS(2645),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2645),
    [anon_sym_decltype] = ACTIONS(2645),
    [anon_sym_explicit] = ACTIONS(2645),
    [anon_sym_typename] = ACTIONS(2645),
    [anon_sym_template] = ACTIONS(2645),
    [anon_sym_operator] = ACTIONS(2645),
    [anon_sym_try] = ACTIONS(2645),
    [anon_sym_delete] = ACTIONS(2645),
    [anon_sym_throw] = ACTIONS(2645),
    [anon_sym_namespace] = ACTIONS(2645),
    [anon_sym_using] = ACTIONS(2645),
    [anon_sym_static_assert] = ACTIONS(2645),
    [anon_sym_concept] = ACTIONS(2645),
    [anon_sym_co_return] = ACTIONS(2645),
    [anon_sym_co_yield] = ACTIONS(2645),
    [anon_sym_R_DQUOTE] = ACTIONS(2647),
    [anon_sym_LR_DQUOTE] = ACTIONS(2647),
    [anon_sym_uR_DQUOTE] = ACTIONS(2647),
    [anon_sym_UR_DQUOTE] = ACTIONS(2647),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2647),
    [anon_sym_co_await] = ACTIONS(2645),
    [anon_sym_new] = ACTIONS(2645),
    [anon_sym_requires] = ACTIONS(2645),
    [sym_this] = ACTIONS(2645),
  },
  [446] = {
    [sym_identifier] = ACTIONS(2649),
    [aux_sym_preproc_include_token1] = ACTIONS(2649),
    [aux_sym_preproc_def_token1] = ACTIONS(2649),
    [aux_sym_preproc_if_token1] = ACTIONS(2649),
    [aux_sym_preproc_if_token2] = ACTIONS(2649),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2649),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2649),
    [sym_preproc_directive] = ACTIONS(2649),
    [anon_sym_LPAREN2] = ACTIONS(2651),
    [anon_sym_BANG] = ACTIONS(2651),
    [anon_sym_TILDE] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2651),
    [anon_sym_AMP_AMP] = ACTIONS(2651),
    [anon_sym_AMP] = ACTIONS(2649),
    [anon_sym_SEMI] = ACTIONS(2651),
    [anon_sym___extension__] = ACTIONS(2649),
    [anon_sym_typedef] = ACTIONS(2649),
    [anon_sym_virtual] = ACTIONS(2649),
    [anon_sym_extern] = ACTIONS(2649),
    [anon_sym___attribute__] = ACTIONS(2649),
    [anon_sym___attribute] = ACTIONS(2649),
    [anon_sym_COLON_COLON] = ACTIONS(2651),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2651),
    [anon_sym___declspec] = ACTIONS(2649),
    [anon_sym___based] = ACTIONS(2649),
    [anon_sym___cdecl] = ACTIONS(2649),
    [anon_sym___clrcall] = ACTIONS(2649),
    [anon_sym___stdcall] = ACTIONS(2649),
    [anon_sym___fastcall] = ACTIONS(2649),
    [anon_sym___thiscall] = ACTIONS(2649),
    [anon_sym___vectorcall] = ACTIONS(2649),
    [anon_sym_LBRACE] = ACTIONS(2651),
    [anon_sym_signed] = ACTIONS(2649),
    [anon_sym_unsigned] = ACTIONS(2649),
    [anon_sym_long] = ACTIONS(2649),
    [anon_sym_short] = ACTIONS(2649),
    [anon_sym_LBRACK] = ACTIONS(2649),
    [anon_sym_static] = ACTIONS(2649),
    [anon_sym_register] = ACTIONS(2649),
    [anon_sym_inline] = ACTIONS(2649),
    [anon_sym___inline] = ACTIONS(2649),
    [anon_sym___inline__] = ACTIONS(2649),
    [anon_sym___forceinline] = ACTIONS(2649),
    [anon_sym_thread_local] = ACTIONS(2649),
    [anon_sym___thread] = ACTIONS(2649),
    [anon_sym_const] = ACTIONS(2649),
    [anon_sym_constexpr] = ACTIONS(2649),
    [anon_sym_volatile] = ACTIONS(2649),
    [anon_sym_restrict] = ACTIONS(2649),
    [anon_sym___restrict__] = ACTIONS(2649),
    [anon_sym__Atomic] = ACTIONS(2649),
    [anon_sym__Noreturn] = ACTIONS(2649),
    [anon_sym_noreturn] = ACTIONS(2649),
    [anon_sym__Nonnull] = ACTIONS(2649),
    [anon_sym_mutable] = ACTIONS(2649),
    [anon_sym_constinit] = ACTIONS(2649),
    [anon_sym_consteval] = ACTIONS(2649),
    [anon_sym_alignas] = ACTIONS(2649),
    [anon_sym__Alignas] = ACTIONS(2649),
    [sym_primitive_type] = ACTIONS(2649),
    [anon_sym_enum] = ACTIONS(2649),
    [anon_sym_class] = ACTIONS(2649),
    [anon_sym_struct] = ACTIONS(2649),
    [anon_sym_union] = ACTIONS(2649),
    [anon_sym_if] = ACTIONS(2649),
    [anon_sym_else] = ACTIONS(2649),
    [anon_sym_switch] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2649),
    [anon_sym_default] = ACTIONS(2649),
    [anon_sym_while] = ACTIONS(2649),
    [anon_sym_do] = ACTIONS(2649),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_return] = ACTIONS(2649),
    [anon_sym_break] = ACTIONS(2649),
    [anon_sym_continue] = ACTIONS(2649),
    [anon_sym_goto] = ACTIONS(2649),
    [anon_sym___try] = ACTIONS(2649),
    [anon_sym___leave] = ACTIONS(2649),
    [anon_sym_not] = ACTIONS(2649),
    [anon_sym_compl] = ACTIONS(2649),
    [anon_sym_DASH_DASH] = ACTIONS(2651),
    [anon_sym_PLUS_PLUS] = ACTIONS(2651),
    [anon_sym_sizeof] = ACTIONS(2649),
    [anon_sym___alignof__] = ACTIONS(2649),
    [anon_sym___alignof] = ACTIONS(2649),
    [anon_sym__alignof] = ACTIONS(2649),
    [anon_sym_alignof] = ACTIONS(2649),
    [anon_sym__Alignof] = ACTIONS(2649),
    [anon_sym_offsetof] = ACTIONS(2649),
    [anon_sym__Generic] = ACTIONS(2649),
    [anon_sym_asm] = ACTIONS(2649),
    [anon_sym___asm__] = ACTIONS(2649),
    [anon_sym___asm] = ACTIONS(2649),
    [sym_number_literal] = ACTIONS(2651),
    [anon_sym_L_SQUOTE] = ACTIONS(2651),
    [anon_sym_u_SQUOTE] = ACTIONS(2651),
    [anon_sym_U_SQUOTE] = ACTIONS(2651),
    [anon_sym_u8_SQUOTE] = ACTIONS(2651),
    [anon_sym_SQUOTE] = ACTIONS(2651),
    [anon_sym_L_DQUOTE] = ACTIONS(2651),
    [anon_sym_u_DQUOTE] = ACTIONS(2651),
    [anon_sym_U_DQUOTE] = ACTIONS(2651),
    [anon_sym_u8_DQUOTE] = ACTIONS(2651),
    [anon_sym_DQUOTE] = ACTIONS(2651),
    [sym_true] = ACTIONS(2649),
    [sym_false] = ACTIONS(2649),
    [anon_sym_NULL] = ACTIONS(2649),
    [anon_sym_nullptr] = ACTIONS(2649),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2649),
    [anon_sym_decltype] = ACTIONS(2649),
    [anon_sym_explicit] = ACTIONS(2649),
    [anon_sym_typename] = ACTIONS(2649),
    [anon_sym_template] = ACTIONS(2649),
    [anon_sym_operator] = ACTIONS(2649),
    [anon_sym_try] = ACTIONS(2649),
    [anon_sym_delete] = ACTIONS(2649),
    [anon_sym_throw] = ACTIONS(2649),
    [anon_sym_namespace] = ACTIONS(2649),
    [anon_sym_using] = ACTIONS(2649),
    [anon_sym_static_assert] = ACTIONS(2649),
    [anon_sym_concept] = ACTIONS(2649),
    [anon_sym_co_return] = ACTIONS(2649),
    [anon_sym_co_yield] = ACTIONS(2649),
    [anon_sym_R_DQUOTE] = ACTIONS(2651),
    [anon_sym_LR_DQUOTE] = ACTIONS(2651),
    [anon_sym_uR_DQUOTE] = ACTIONS(2651),
    [anon_sym_UR_DQUOTE] = ACTIONS(2651),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2651),
    [anon_sym_co_await] = ACTIONS(2649),
    [anon_sym_new] = ACTIONS(2649),
    [anon_sym_requires] = ACTIONS(2649),
    [sym_this] = ACTIONS(2649),
  },
  [447] = {
    [sym_identifier] = ACTIONS(2689),
    [aux_sym_preproc_include_token1] = ACTIONS(2689),
    [aux_sym_preproc_def_token1] = ACTIONS(2689),
    [aux_sym_preproc_if_token1] = ACTIONS(2689),
    [aux_sym_preproc_if_token2] = ACTIONS(2689),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2689),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2689),
    [sym_preproc_directive] = ACTIONS(2689),
    [anon_sym_LPAREN2] = ACTIONS(2691),
    [anon_sym_BANG] = ACTIONS(2691),
    [anon_sym_TILDE] = ACTIONS(2691),
    [anon_sym_DASH] = ACTIONS(2689),
    [anon_sym_PLUS] = ACTIONS(2689),
    [anon_sym_STAR] = ACTIONS(2691),
    [anon_sym_AMP_AMP] = ACTIONS(2691),
    [anon_sym_AMP] = ACTIONS(2689),
    [anon_sym_SEMI] = ACTIONS(2691),
    [anon_sym___extension__] = ACTIONS(2689),
    [anon_sym_typedef] = ACTIONS(2689),
    [anon_sym_virtual] = ACTIONS(2689),
    [anon_sym_extern] = ACTIONS(2689),
    [anon_sym___attribute__] = ACTIONS(2689),
    [anon_sym___attribute] = ACTIONS(2689),
    [anon_sym_COLON_COLON] = ACTIONS(2691),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2691),
    [anon_sym___declspec] = ACTIONS(2689),
    [anon_sym___based] = ACTIONS(2689),
    [anon_sym___cdecl] = ACTIONS(2689),
    [anon_sym___clrcall] = ACTIONS(2689),
    [anon_sym___stdcall] = ACTIONS(2689),
    [anon_sym___fastcall] = ACTIONS(2689),
    [anon_sym___thiscall] = ACTIONS(2689),
    [anon_sym___vectorcall] = ACTIONS(2689),
    [anon_sym_LBRACE] = ACTIONS(2691),
    [anon_sym_signed] = ACTIONS(2689),
    [anon_sym_unsigned] = ACTIONS(2689),
    [anon_sym_long] = ACTIONS(2689),
    [anon_sym_short] = ACTIONS(2689),
    [anon_sym_LBRACK] = ACTIONS(2689),
    [anon_sym_static] = ACTIONS(2689),
    [anon_sym_register] = ACTIONS(2689),
    [anon_sym_inline] = ACTIONS(2689),
    [anon_sym___inline] = ACTIONS(2689),
    [anon_sym___inline__] = ACTIONS(2689),
    [anon_sym___forceinline] = ACTIONS(2689),
    [anon_sym_thread_local] = ACTIONS(2689),
    [anon_sym___thread] = ACTIONS(2689),
    [anon_sym_const] = ACTIONS(2689),
    [anon_sym_constexpr] = ACTIONS(2689),
    [anon_sym_volatile] = ACTIONS(2689),
    [anon_sym_restrict] = ACTIONS(2689),
    [anon_sym___restrict__] = ACTIONS(2689),
    [anon_sym__Atomic] = ACTIONS(2689),
    [anon_sym__Noreturn] = ACTIONS(2689),
    [anon_sym_noreturn] = ACTIONS(2689),
    [anon_sym__Nonnull] = ACTIONS(2689),
    [anon_sym_mutable] = ACTIONS(2689),
    [anon_sym_constinit] = ACTIONS(2689),
    [anon_sym_consteval] = ACTIONS(2689),
    [anon_sym_alignas] = ACTIONS(2689),
    [anon_sym__Alignas] = ACTIONS(2689),
    [sym_primitive_type] = ACTIONS(2689),
    [anon_sym_enum] = ACTIONS(2689),
    [anon_sym_class] = ACTIONS(2689),
    [anon_sym_struct] = ACTIONS(2689),
    [anon_sym_union] = ACTIONS(2689),
    [anon_sym_if] = ACTIONS(2689),
    [anon_sym_else] = ACTIONS(2689),
    [anon_sym_switch] = ACTIONS(2689),
    [anon_sym_case] = ACTIONS(2689),
    [anon_sym_default] = ACTIONS(2689),
    [anon_sym_while] = ACTIONS(2689),
    [anon_sym_do] = ACTIONS(2689),
    [anon_sym_for] = ACTIONS(2689),
    [anon_sym_return] = ACTIONS(2689),
    [anon_sym_break] = ACTIONS(2689),
    [anon_sym_continue] = ACTIONS(2689),
    [anon_sym_goto] = ACTIONS(2689),
    [anon_sym___try] = ACTIONS(2689),
    [anon_sym___leave] = ACTIONS(2689),
    [anon_sym_not] = ACTIONS(2689),
    [anon_sym_compl] = ACTIONS(2689),
    [anon_sym_DASH_DASH] = ACTIONS(2691),
    [anon_sym_PLUS_PLUS] = ACTIONS(2691),
    [anon_sym_sizeof] = ACTIONS(2689),
    [anon_sym___alignof__] = ACTIONS(2689),
    [anon_sym___alignof] = ACTIONS(2689),
    [anon_sym__alignof] = ACTIONS(2689),
    [anon_sym_alignof] = ACTIONS(2689),
    [anon_sym__Alignof] = ACTIONS(2689),
    [anon_sym_offsetof] = ACTIONS(2689),
    [anon_sym__Generic] = ACTIONS(2689),
    [anon_sym_asm] = ACTIONS(2689),
    [anon_sym___asm__] = ACTIONS(2689),
    [anon_sym___asm] = ACTIONS(2689),
    [sym_number_literal] = ACTIONS(2691),
    [anon_sym_L_SQUOTE] = ACTIONS(2691),
    [anon_sym_u_SQUOTE] = ACTIONS(2691),
    [anon_sym_U_SQUOTE] = ACTIONS(2691),
    [anon_sym_u8_SQUOTE] = ACTIONS(2691),
    [anon_sym_SQUOTE] = ACTIONS(2691),
    [anon_sym_L_DQUOTE] = ACTIONS(2691),
    [anon_sym_u_DQUOTE] = ACTIONS(2691),
    [anon_sym_U_DQUOTE] = ACTIONS(2691),
    [anon_sym_u8_DQUOTE] = ACTIONS(2691),
    [anon_sym_DQUOTE] = ACTIONS(2691),
    [sym_true] = ACTIONS(2689),
    [sym_false] = ACTIONS(2689),
    [anon_sym_NULL] = ACTIONS(2689),
    [anon_sym_nullptr] = ACTIONS(2689),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2689),
    [anon_sym_decltype] = ACTIONS(2689),
    [anon_sym_explicit] = ACTIONS(2689),
    [anon_sym_typename] = ACTIONS(2689),
    [anon_sym_template] = ACTIONS(2689),
    [anon_sym_operator] = ACTIONS(2689),
    [anon_sym_try] = ACTIONS(2689),
    [anon_sym_delete] = ACTIONS(2689),
    [anon_sym_throw] = ACTIONS(2689),
    [anon_sym_namespace] = ACTIONS(2689),
    [anon_sym_using] = ACTIONS(2689),
    [anon_sym_static_assert] = ACTIONS(2689),
    [anon_sym_concept] = ACTIONS(2689),
    [anon_sym_co_return] = ACTIONS(2689),
    [anon_sym_co_yield] = ACTIONS(2689),
    [anon_sym_R_DQUOTE] = ACTIONS(2691),
    [anon_sym_LR_DQUOTE] = ACTIONS(2691),
    [anon_sym_uR_DQUOTE] = ACTIONS(2691),
    [anon_sym_UR_DQUOTE] = ACTIONS(2691),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2691),
    [anon_sym_co_await] = ACTIONS(2689),
    [anon_sym_new] = ACTIONS(2689),
    [anon_sym_requires] = ACTIONS(2689),
    [sym_this] = ACTIONS(2689),
  },
  [448] = {
    [ts_builtin_sym_end] = ACTIONS(2611),
    [sym_identifier] = ACTIONS(2609),
    [aux_sym_preproc_include_token1] = ACTIONS(2609),
    [aux_sym_preproc_def_token1] = ACTIONS(2609),
    [aux_sym_preproc_if_token1] = ACTIONS(2609),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2609),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2609),
    [sym_preproc_directive] = ACTIONS(2609),
    [anon_sym_LPAREN2] = ACTIONS(2611),
    [anon_sym_BANG] = ACTIONS(2611),
    [anon_sym_TILDE] = ACTIONS(2611),
    [anon_sym_DASH] = ACTIONS(2609),
    [anon_sym_PLUS] = ACTIONS(2609),
    [anon_sym_STAR] = ACTIONS(2611),
    [anon_sym_AMP_AMP] = ACTIONS(2611),
    [anon_sym_AMP] = ACTIONS(2609),
    [anon_sym_SEMI] = ACTIONS(2611),
    [anon_sym___extension__] = ACTIONS(2609),
    [anon_sym_typedef] = ACTIONS(2609),
    [anon_sym_virtual] = ACTIONS(2609),
    [anon_sym_extern] = ACTIONS(2609),
    [anon_sym___attribute__] = ACTIONS(2609),
    [anon_sym___attribute] = ACTIONS(2609),
    [anon_sym_COLON_COLON] = ACTIONS(2611),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2611),
    [anon_sym___declspec] = ACTIONS(2609),
    [anon_sym___based] = ACTIONS(2609),
    [anon_sym___cdecl] = ACTIONS(2609),
    [anon_sym___clrcall] = ACTIONS(2609),
    [anon_sym___stdcall] = ACTIONS(2609),
    [anon_sym___fastcall] = ACTIONS(2609),
    [anon_sym___thiscall] = ACTIONS(2609),
    [anon_sym___vectorcall] = ACTIONS(2609),
    [anon_sym_LBRACE] = ACTIONS(2611),
    [anon_sym_signed] = ACTIONS(2609),
    [anon_sym_unsigned] = ACTIONS(2609),
    [anon_sym_long] = ACTIONS(2609),
    [anon_sym_short] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(2609),
    [anon_sym_static] = ACTIONS(2609),
    [anon_sym_register] = ACTIONS(2609),
    [anon_sym_inline] = ACTIONS(2609),
    [anon_sym___inline] = ACTIONS(2609),
    [anon_sym___inline__] = ACTIONS(2609),
    [anon_sym___forceinline] = ACTIONS(2609),
    [anon_sym_thread_local] = ACTIONS(2609),
    [anon_sym___thread] = ACTIONS(2609),
    [anon_sym_const] = ACTIONS(2609),
    [anon_sym_constexpr] = ACTIONS(2609),
    [anon_sym_volatile] = ACTIONS(2609),
    [anon_sym_restrict] = ACTIONS(2609),
    [anon_sym___restrict__] = ACTIONS(2609),
    [anon_sym__Atomic] = ACTIONS(2609),
    [anon_sym__Noreturn] = ACTIONS(2609),
    [anon_sym_noreturn] = ACTIONS(2609),
    [anon_sym__Nonnull] = ACTIONS(2609),
    [anon_sym_mutable] = ACTIONS(2609),
    [anon_sym_constinit] = ACTIONS(2609),
    [anon_sym_consteval] = ACTIONS(2609),
    [anon_sym_alignas] = ACTIONS(2609),
    [anon_sym__Alignas] = ACTIONS(2609),
    [sym_primitive_type] = ACTIONS(2609),
    [anon_sym_enum] = ACTIONS(2609),
    [anon_sym_class] = ACTIONS(2609),
    [anon_sym_struct] = ACTIONS(2609),
    [anon_sym_union] = ACTIONS(2609),
    [anon_sym_if] = ACTIONS(2609),
    [anon_sym_else] = ACTIONS(2609),
    [anon_sym_switch] = ACTIONS(2609),
    [anon_sym_case] = ACTIONS(2609),
    [anon_sym_default] = ACTIONS(2609),
    [anon_sym_while] = ACTIONS(2609),
    [anon_sym_do] = ACTIONS(2609),
    [anon_sym_for] = ACTIONS(2609),
    [anon_sym_return] = ACTIONS(2609),
    [anon_sym_break] = ACTIONS(2609),
    [anon_sym_continue] = ACTIONS(2609),
    [anon_sym_goto] = ACTIONS(2609),
    [anon_sym___try] = ACTIONS(2609),
    [anon_sym___leave] = ACTIONS(2609),
    [anon_sym_not] = ACTIONS(2609),
    [anon_sym_compl] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(2611),
    [anon_sym_PLUS_PLUS] = ACTIONS(2611),
    [anon_sym_sizeof] = ACTIONS(2609),
    [anon_sym___alignof__] = ACTIONS(2609),
    [anon_sym___alignof] = ACTIONS(2609),
    [anon_sym__alignof] = ACTIONS(2609),
    [anon_sym_alignof] = ACTIONS(2609),
    [anon_sym__Alignof] = ACTIONS(2609),
    [anon_sym_offsetof] = ACTIONS(2609),
    [anon_sym__Generic] = ACTIONS(2609),
    [anon_sym_asm] = ACTIONS(2609),
    [anon_sym___asm__] = ACTIONS(2609),
    [anon_sym___asm] = ACTIONS(2609),
    [sym_number_literal] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2611),
    [anon_sym_u_SQUOTE] = ACTIONS(2611),
    [anon_sym_U_SQUOTE] = ACTIONS(2611),
    [anon_sym_u8_SQUOTE] = ACTIONS(2611),
    [anon_sym_SQUOTE] = ACTIONS(2611),
    [anon_sym_L_DQUOTE] = ACTIONS(2611),
    [anon_sym_u_DQUOTE] = ACTIONS(2611),
    [anon_sym_U_DQUOTE] = ACTIONS(2611),
    [anon_sym_u8_DQUOTE] = ACTIONS(2611),
    [anon_sym_DQUOTE] = ACTIONS(2611),
    [sym_true] = ACTIONS(2609),
    [sym_false] = ACTIONS(2609),
    [anon_sym_NULL] = ACTIONS(2609),
    [anon_sym_nullptr] = ACTIONS(2609),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2609),
    [anon_sym_decltype] = ACTIONS(2609),
    [anon_sym_explicit] = ACTIONS(2609),
    [anon_sym_typename] = ACTIONS(2609),
    [anon_sym_template] = ACTIONS(2609),
    [anon_sym_operator] = ACTIONS(2609),
    [anon_sym_try] = ACTIONS(2609),
    [anon_sym_delete] = ACTIONS(2609),
    [anon_sym_throw] = ACTIONS(2609),
    [anon_sym_namespace] = ACTIONS(2609),
    [anon_sym_using] = ACTIONS(2609),
    [anon_sym_static_assert] = ACTIONS(2609),
    [anon_sym_concept] = ACTIONS(2609),
    [anon_sym_co_return] = ACTIONS(2609),
    [anon_sym_co_yield] = ACTIONS(2609),
    [anon_sym_R_DQUOTE] = ACTIONS(2611),
    [anon_sym_LR_DQUOTE] = ACTIONS(2611),
    [anon_sym_uR_DQUOTE] = ACTIONS(2611),
    [anon_sym_UR_DQUOTE] = ACTIONS(2611),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2611),
    [anon_sym_co_await] = ACTIONS(2609),
    [anon_sym_new] = ACTIONS(2609),
    [anon_sym_requires] = ACTIONS(2609),
    [sym_this] = ACTIONS(2609),
  },
  [449] = {
    [ts_builtin_sym_end] = ACTIONS(2611),
    [sym_identifier] = ACTIONS(2609),
    [aux_sym_preproc_include_token1] = ACTIONS(2609),
    [aux_sym_preproc_def_token1] = ACTIONS(2609),
    [aux_sym_preproc_if_token1] = ACTIONS(2609),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2609),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2609),
    [sym_preproc_directive] = ACTIONS(2609),
    [anon_sym_LPAREN2] = ACTIONS(2611),
    [anon_sym_BANG] = ACTIONS(2611),
    [anon_sym_TILDE] = ACTIONS(2611),
    [anon_sym_DASH] = ACTIONS(2609),
    [anon_sym_PLUS] = ACTIONS(2609),
    [anon_sym_STAR] = ACTIONS(2611),
    [anon_sym_AMP_AMP] = ACTIONS(2611),
    [anon_sym_AMP] = ACTIONS(2609),
    [anon_sym_SEMI] = ACTIONS(2611),
    [anon_sym___extension__] = ACTIONS(2609),
    [anon_sym_typedef] = ACTIONS(2609),
    [anon_sym_virtual] = ACTIONS(2609),
    [anon_sym_extern] = ACTIONS(2609),
    [anon_sym___attribute__] = ACTIONS(2609),
    [anon_sym___attribute] = ACTIONS(2609),
    [anon_sym_COLON_COLON] = ACTIONS(2611),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2611),
    [anon_sym___declspec] = ACTIONS(2609),
    [anon_sym___based] = ACTIONS(2609),
    [anon_sym___cdecl] = ACTIONS(2609),
    [anon_sym___clrcall] = ACTIONS(2609),
    [anon_sym___stdcall] = ACTIONS(2609),
    [anon_sym___fastcall] = ACTIONS(2609),
    [anon_sym___thiscall] = ACTIONS(2609),
    [anon_sym___vectorcall] = ACTIONS(2609),
    [anon_sym_LBRACE] = ACTIONS(2611),
    [anon_sym_signed] = ACTIONS(2609),
    [anon_sym_unsigned] = ACTIONS(2609),
    [anon_sym_long] = ACTIONS(2609),
    [anon_sym_short] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(2609),
    [anon_sym_static] = ACTIONS(2609),
    [anon_sym_register] = ACTIONS(2609),
    [anon_sym_inline] = ACTIONS(2609),
    [anon_sym___inline] = ACTIONS(2609),
    [anon_sym___inline__] = ACTIONS(2609),
    [anon_sym___forceinline] = ACTIONS(2609),
    [anon_sym_thread_local] = ACTIONS(2609),
    [anon_sym___thread] = ACTIONS(2609),
    [anon_sym_const] = ACTIONS(2609),
    [anon_sym_constexpr] = ACTIONS(2609),
    [anon_sym_volatile] = ACTIONS(2609),
    [anon_sym_restrict] = ACTIONS(2609),
    [anon_sym___restrict__] = ACTIONS(2609),
    [anon_sym__Atomic] = ACTIONS(2609),
    [anon_sym__Noreturn] = ACTIONS(2609),
    [anon_sym_noreturn] = ACTIONS(2609),
    [anon_sym__Nonnull] = ACTIONS(2609),
    [anon_sym_mutable] = ACTIONS(2609),
    [anon_sym_constinit] = ACTIONS(2609),
    [anon_sym_consteval] = ACTIONS(2609),
    [anon_sym_alignas] = ACTIONS(2609),
    [anon_sym__Alignas] = ACTIONS(2609),
    [sym_primitive_type] = ACTIONS(2609),
    [anon_sym_enum] = ACTIONS(2609),
    [anon_sym_class] = ACTIONS(2609),
    [anon_sym_struct] = ACTIONS(2609),
    [anon_sym_union] = ACTIONS(2609),
    [anon_sym_if] = ACTIONS(2609),
    [anon_sym_else] = ACTIONS(2609),
    [anon_sym_switch] = ACTIONS(2609),
    [anon_sym_case] = ACTIONS(2609),
    [anon_sym_default] = ACTIONS(2609),
    [anon_sym_while] = ACTIONS(2609),
    [anon_sym_do] = ACTIONS(2609),
    [anon_sym_for] = ACTIONS(2609),
    [anon_sym_return] = ACTIONS(2609),
    [anon_sym_break] = ACTIONS(2609),
    [anon_sym_continue] = ACTIONS(2609),
    [anon_sym_goto] = ACTIONS(2609),
    [anon_sym___try] = ACTIONS(2609),
    [anon_sym___leave] = ACTIONS(2609),
    [anon_sym_not] = ACTIONS(2609),
    [anon_sym_compl] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(2611),
    [anon_sym_PLUS_PLUS] = ACTIONS(2611),
    [anon_sym_sizeof] = ACTIONS(2609),
    [anon_sym___alignof__] = ACTIONS(2609),
    [anon_sym___alignof] = ACTIONS(2609),
    [anon_sym__alignof] = ACTIONS(2609),
    [anon_sym_alignof] = ACTIONS(2609),
    [anon_sym__Alignof] = ACTIONS(2609),
    [anon_sym_offsetof] = ACTIONS(2609),
    [anon_sym__Generic] = ACTIONS(2609),
    [anon_sym_asm] = ACTIONS(2609),
    [anon_sym___asm__] = ACTIONS(2609),
    [anon_sym___asm] = ACTIONS(2609),
    [sym_number_literal] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2611),
    [anon_sym_u_SQUOTE] = ACTIONS(2611),
    [anon_sym_U_SQUOTE] = ACTIONS(2611),
    [anon_sym_u8_SQUOTE] = ACTIONS(2611),
    [anon_sym_SQUOTE] = ACTIONS(2611),
    [anon_sym_L_DQUOTE] = ACTIONS(2611),
    [anon_sym_u_DQUOTE] = ACTIONS(2611),
    [anon_sym_U_DQUOTE] = ACTIONS(2611),
    [anon_sym_u8_DQUOTE] = ACTIONS(2611),
    [anon_sym_DQUOTE] = ACTIONS(2611),
    [sym_true] = ACTIONS(2609),
    [sym_false] = ACTIONS(2609),
    [anon_sym_NULL] = ACTIONS(2609),
    [anon_sym_nullptr] = ACTIONS(2609),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2609),
    [anon_sym_decltype] = ACTIONS(2609),
    [anon_sym_explicit] = ACTIONS(2609),
    [anon_sym_typename] = ACTIONS(2609),
    [anon_sym_template] = ACTIONS(2609),
    [anon_sym_operator] = ACTIONS(2609),
    [anon_sym_try] = ACTIONS(2609),
    [anon_sym_delete] = ACTIONS(2609),
    [anon_sym_throw] = ACTIONS(2609),
    [anon_sym_namespace] = ACTIONS(2609),
    [anon_sym_using] = ACTIONS(2609),
    [anon_sym_static_assert] = ACTIONS(2609),
    [anon_sym_concept] = ACTIONS(2609),
    [anon_sym_co_return] = ACTIONS(2609),
    [anon_sym_co_yield] = ACTIONS(2609),
    [anon_sym_R_DQUOTE] = ACTIONS(2611),
    [anon_sym_LR_DQUOTE] = ACTIONS(2611),
    [anon_sym_uR_DQUOTE] = ACTIONS(2611),
    [anon_sym_UR_DQUOTE] = ACTIONS(2611),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2611),
    [anon_sym_co_await] = ACTIONS(2609),
    [anon_sym_new] = ACTIONS(2609),
    [anon_sym_requires] = ACTIONS(2609),
    [sym_this] = ACTIONS(2609),
  },
  [450] = {
    [ts_builtin_sym_end] = ACTIONS(2703),
    [sym_identifier] = ACTIONS(2701),
    [aux_sym_preproc_include_token1] = ACTIONS(2701),
    [aux_sym_preproc_def_token1] = ACTIONS(2701),
    [aux_sym_preproc_if_token1] = ACTIONS(2701),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2701),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2701),
    [sym_preproc_directive] = ACTIONS(2701),
    [anon_sym_LPAREN2] = ACTIONS(2703),
    [anon_sym_BANG] = ACTIONS(2703),
    [anon_sym_TILDE] = ACTIONS(2703),
    [anon_sym_DASH] = ACTIONS(2701),
    [anon_sym_PLUS] = ACTIONS(2701),
    [anon_sym_STAR] = ACTIONS(2703),
    [anon_sym_AMP_AMP] = ACTIONS(2703),
    [anon_sym_AMP] = ACTIONS(2701),
    [anon_sym_SEMI] = ACTIONS(2703),
    [anon_sym___extension__] = ACTIONS(2701),
    [anon_sym_typedef] = ACTIONS(2701),
    [anon_sym_virtual] = ACTIONS(2701),
    [anon_sym_extern] = ACTIONS(2701),
    [anon_sym___attribute__] = ACTIONS(2701),
    [anon_sym___attribute] = ACTIONS(2701),
    [anon_sym_COLON_COLON] = ACTIONS(2703),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2703),
    [anon_sym___declspec] = ACTIONS(2701),
    [anon_sym___based] = ACTIONS(2701),
    [anon_sym___cdecl] = ACTIONS(2701),
    [anon_sym___clrcall] = ACTIONS(2701),
    [anon_sym___stdcall] = ACTIONS(2701),
    [anon_sym___fastcall] = ACTIONS(2701),
    [anon_sym___thiscall] = ACTIONS(2701),
    [anon_sym___vectorcall] = ACTIONS(2701),
    [anon_sym_LBRACE] = ACTIONS(2703),
    [anon_sym_signed] = ACTIONS(2701),
    [anon_sym_unsigned] = ACTIONS(2701),
    [anon_sym_long] = ACTIONS(2701),
    [anon_sym_short] = ACTIONS(2701),
    [anon_sym_LBRACK] = ACTIONS(2701),
    [anon_sym_static] = ACTIONS(2701),
    [anon_sym_register] = ACTIONS(2701),
    [anon_sym_inline] = ACTIONS(2701),
    [anon_sym___inline] = ACTIONS(2701),
    [anon_sym___inline__] = ACTIONS(2701),
    [anon_sym___forceinline] = ACTIONS(2701),
    [anon_sym_thread_local] = ACTIONS(2701),
    [anon_sym___thread] = ACTIONS(2701),
    [anon_sym_const] = ACTIONS(2701),
    [anon_sym_constexpr] = ACTIONS(2701),
    [anon_sym_volatile] = ACTIONS(2701),
    [anon_sym_restrict] = ACTIONS(2701),
    [anon_sym___restrict__] = ACTIONS(2701),
    [anon_sym__Atomic] = ACTIONS(2701),
    [anon_sym__Noreturn] = ACTIONS(2701),
    [anon_sym_noreturn] = ACTIONS(2701),
    [anon_sym__Nonnull] = ACTIONS(2701),
    [anon_sym_mutable] = ACTIONS(2701),
    [anon_sym_constinit] = ACTIONS(2701),
    [anon_sym_consteval] = ACTIONS(2701),
    [anon_sym_alignas] = ACTIONS(2701),
    [anon_sym__Alignas] = ACTIONS(2701),
    [sym_primitive_type] = ACTIONS(2701),
    [anon_sym_enum] = ACTIONS(2701),
    [anon_sym_class] = ACTIONS(2701),
    [anon_sym_struct] = ACTIONS(2701),
    [anon_sym_union] = ACTIONS(2701),
    [anon_sym_if] = ACTIONS(2701),
    [anon_sym_else] = ACTIONS(2701),
    [anon_sym_switch] = ACTIONS(2701),
    [anon_sym_case] = ACTIONS(2701),
    [anon_sym_default] = ACTIONS(2701),
    [anon_sym_while] = ACTIONS(2701),
    [anon_sym_do] = ACTIONS(2701),
    [anon_sym_for] = ACTIONS(2701),
    [anon_sym_return] = ACTIONS(2701),
    [anon_sym_break] = ACTIONS(2701),
    [anon_sym_continue] = ACTIONS(2701),
    [anon_sym_goto] = ACTIONS(2701),
    [anon_sym___try] = ACTIONS(2701),
    [anon_sym___leave] = ACTIONS(2701),
    [anon_sym_not] = ACTIONS(2701),
    [anon_sym_compl] = ACTIONS(2701),
    [anon_sym_DASH_DASH] = ACTIONS(2703),
    [anon_sym_PLUS_PLUS] = ACTIONS(2703),
    [anon_sym_sizeof] = ACTIONS(2701),
    [anon_sym___alignof__] = ACTIONS(2701),
    [anon_sym___alignof] = ACTIONS(2701),
    [anon_sym__alignof] = ACTIONS(2701),
    [anon_sym_alignof] = ACTIONS(2701),
    [anon_sym__Alignof] = ACTIONS(2701),
    [anon_sym_offsetof] = ACTIONS(2701),
    [anon_sym__Generic] = ACTIONS(2701),
    [anon_sym_asm] = ACTIONS(2701),
    [anon_sym___asm__] = ACTIONS(2701),
    [anon_sym___asm] = ACTIONS(2701),
    [sym_number_literal] = ACTIONS(2703),
    [anon_sym_L_SQUOTE] = ACTIONS(2703),
    [anon_sym_u_SQUOTE] = ACTIONS(2703),
    [anon_sym_U_SQUOTE] = ACTIONS(2703),
    [anon_sym_u8_SQUOTE] = ACTIONS(2703),
    [anon_sym_SQUOTE] = ACTIONS(2703),
    [anon_sym_L_DQUOTE] = ACTIONS(2703),
    [anon_sym_u_DQUOTE] = ACTIONS(2703),
    [anon_sym_U_DQUOTE] = ACTIONS(2703),
    [anon_sym_u8_DQUOTE] = ACTIONS(2703),
    [anon_sym_DQUOTE] = ACTIONS(2703),
    [sym_true] = ACTIONS(2701),
    [sym_false] = ACTIONS(2701),
    [anon_sym_NULL] = ACTIONS(2701),
    [anon_sym_nullptr] = ACTIONS(2701),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2701),
    [anon_sym_decltype] = ACTIONS(2701),
    [anon_sym_explicit] = ACTIONS(2701),
    [anon_sym_typename] = ACTIONS(2701),
    [anon_sym_template] = ACTIONS(2701),
    [anon_sym_operator] = ACTIONS(2701),
    [anon_sym_try] = ACTIONS(2701),
    [anon_sym_delete] = ACTIONS(2701),
    [anon_sym_throw] = ACTIONS(2701),
    [anon_sym_namespace] = ACTIONS(2701),
    [anon_sym_using] = ACTIONS(2701),
    [anon_sym_static_assert] = ACTIONS(2701),
    [anon_sym_concept] = ACTIONS(2701),
    [anon_sym_co_return] = ACTIONS(2701),
    [anon_sym_co_yield] = ACTIONS(2701),
    [anon_sym_R_DQUOTE] = ACTIONS(2703),
    [anon_sym_LR_DQUOTE] = ACTIONS(2703),
    [anon_sym_uR_DQUOTE] = ACTIONS(2703),
    [anon_sym_UR_DQUOTE] = ACTIONS(2703),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2703),
    [anon_sym_co_await] = ACTIONS(2701),
    [anon_sym_new] = ACTIONS(2701),
    [anon_sym_requires] = ACTIONS(2701),
    [sym_this] = ACTIONS(2701),
  },
  [451] = {
    [ts_builtin_sym_end] = ACTIONS(2615),
    [sym_identifier] = ACTIONS(2613),
    [aux_sym_preproc_include_token1] = ACTIONS(2613),
    [aux_sym_preproc_def_token1] = ACTIONS(2613),
    [aux_sym_preproc_if_token1] = ACTIONS(2613),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2613),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2613),
    [sym_preproc_directive] = ACTIONS(2613),
    [anon_sym_LPAREN2] = ACTIONS(2615),
    [anon_sym_BANG] = ACTIONS(2615),
    [anon_sym_TILDE] = ACTIONS(2615),
    [anon_sym_DASH] = ACTIONS(2613),
    [anon_sym_PLUS] = ACTIONS(2613),
    [anon_sym_STAR] = ACTIONS(2615),
    [anon_sym_AMP_AMP] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2613),
    [anon_sym_SEMI] = ACTIONS(2615),
    [anon_sym___extension__] = ACTIONS(2613),
    [anon_sym_typedef] = ACTIONS(2613),
    [anon_sym_virtual] = ACTIONS(2613),
    [anon_sym_extern] = ACTIONS(2613),
    [anon_sym___attribute__] = ACTIONS(2613),
    [anon_sym___attribute] = ACTIONS(2613),
    [anon_sym_COLON_COLON] = ACTIONS(2615),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2615),
    [anon_sym___declspec] = ACTIONS(2613),
    [anon_sym___based] = ACTIONS(2613),
    [anon_sym___cdecl] = ACTIONS(2613),
    [anon_sym___clrcall] = ACTIONS(2613),
    [anon_sym___stdcall] = ACTIONS(2613),
    [anon_sym___fastcall] = ACTIONS(2613),
    [anon_sym___thiscall] = ACTIONS(2613),
    [anon_sym___vectorcall] = ACTIONS(2613),
    [anon_sym_LBRACE] = ACTIONS(2615),
    [anon_sym_signed] = ACTIONS(2613),
    [anon_sym_unsigned] = ACTIONS(2613),
    [anon_sym_long] = ACTIONS(2613),
    [anon_sym_short] = ACTIONS(2613),
    [anon_sym_LBRACK] = ACTIONS(2613),
    [anon_sym_static] = ACTIONS(2613),
    [anon_sym_register] = ACTIONS(2613),
    [anon_sym_inline] = ACTIONS(2613),
    [anon_sym___inline] = ACTIONS(2613),
    [anon_sym___inline__] = ACTIONS(2613),
    [anon_sym___forceinline] = ACTIONS(2613),
    [anon_sym_thread_local] = ACTIONS(2613),
    [anon_sym___thread] = ACTIONS(2613),
    [anon_sym_const] = ACTIONS(2613),
    [anon_sym_constexpr] = ACTIONS(2613),
    [anon_sym_volatile] = ACTIONS(2613),
    [anon_sym_restrict] = ACTIONS(2613),
    [anon_sym___restrict__] = ACTIONS(2613),
    [anon_sym__Atomic] = ACTIONS(2613),
    [anon_sym__Noreturn] = ACTIONS(2613),
    [anon_sym_noreturn] = ACTIONS(2613),
    [anon_sym__Nonnull] = ACTIONS(2613),
    [anon_sym_mutable] = ACTIONS(2613),
    [anon_sym_constinit] = ACTIONS(2613),
    [anon_sym_consteval] = ACTIONS(2613),
    [anon_sym_alignas] = ACTIONS(2613),
    [anon_sym__Alignas] = ACTIONS(2613),
    [sym_primitive_type] = ACTIONS(2613),
    [anon_sym_enum] = ACTIONS(2613),
    [anon_sym_class] = ACTIONS(2613),
    [anon_sym_struct] = ACTIONS(2613),
    [anon_sym_union] = ACTIONS(2613),
    [anon_sym_if] = ACTIONS(2613),
    [anon_sym_else] = ACTIONS(2613),
    [anon_sym_switch] = ACTIONS(2613),
    [anon_sym_case] = ACTIONS(2613),
    [anon_sym_default] = ACTIONS(2613),
    [anon_sym_while] = ACTIONS(2613),
    [anon_sym_do] = ACTIONS(2613),
    [anon_sym_for] = ACTIONS(2613),
    [anon_sym_return] = ACTIONS(2613),
    [anon_sym_break] = ACTIONS(2613),
    [anon_sym_continue] = ACTIONS(2613),
    [anon_sym_goto] = ACTIONS(2613),
    [anon_sym___try] = ACTIONS(2613),
    [anon_sym___leave] = ACTIONS(2613),
    [anon_sym_not] = ACTIONS(2613),
    [anon_sym_compl] = ACTIONS(2613),
    [anon_sym_DASH_DASH] = ACTIONS(2615),
    [anon_sym_PLUS_PLUS] = ACTIONS(2615),
    [anon_sym_sizeof] = ACTIONS(2613),
    [anon_sym___alignof__] = ACTIONS(2613),
    [anon_sym___alignof] = ACTIONS(2613),
    [anon_sym__alignof] = ACTIONS(2613),
    [anon_sym_alignof] = ACTIONS(2613),
    [anon_sym__Alignof] = ACTIONS(2613),
    [anon_sym_offsetof] = ACTIONS(2613),
    [anon_sym__Generic] = ACTIONS(2613),
    [anon_sym_asm] = ACTIONS(2613),
    [anon_sym___asm__] = ACTIONS(2613),
    [anon_sym___asm] = ACTIONS(2613),
    [sym_number_literal] = ACTIONS(2615),
    [anon_sym_L_SQUOTE] = ACTIONS(2615),
    [anon_sym_u_SQUOTE] = ACTIONS(2615),
    [anon_sym_U_SQUOTE] = ACTIONS(2615),
    [anon_sym_u8_SQUOTE] = ACTIONS(2615),
    [anon_sym_SQUOTE] = ACTIONS(2615),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2613),
    [sym_false] = ACTIONS(2613),
    [anon_sym_NULL] = ACTIONS(2613),
    [anon_sym_nullptr] = ACTIONS(2613),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2613),
    [anon_sym_decltype] = ACTIONS(2613),
    [anon_sym_explicit] = ACTIONS(2613),
    [anon_sym_typename] = ACTIONS(2613),
    [anon_sym_template] = ACTIONS(2613),
    [anon_sym_operator] = ACTIONS(2613),
    [anon_sym_try] = ACTIONS(2613),
    [anon_sym_delete] = ACTIONS(2613),
    [anon_sym_throw] = ACTIONS(2613),
    [anon_sym_namespace] = ACTIONS(2613),
    [anon_sym_using] = ACTIONS(2613),
    [anon_sym_static_assert] = ACTIONS(2613),
    [anon_sym_concept] = ACTIONS(2613),
    [anon_sym_co_return] = ACTIONS(2613),
    [anon_sym_co_yield] = ACTIONS(2613),
    [anon_sym_R_DQUOTE] = ACTIONS(2615),
    [anon_sym_LR_DQUOTE] = ACTIONS(2615),
    [anon_sym_uR_DQUOTE] = ACTIONS(2615),
    [anon_sym_UR_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2615),
    [anon_sym_co_await] = ACTIONS(2613),
    [anon_sym_new] = ACTIONS(2613),
    [anon_sym_requires] = ACTIONS(2613),
    [sym_this] = ACTIONS(2613),
  },
  [452] = {
    [sym_identifier] = ACTIONS(2625),
    [aux_sym_preproc_include_token1] = ACTIONS(2625),
    [aux_sym_preproc_def_token1] = ACTIONS(2625),
    [aux_sym_preproc_if_token1] = ACTIONS(2625),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2625),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2625),
    [sym_preproc_directive] = ACTIONS(2625),
    [anon_sym_LPAREN2] = ACTIONS(2627),
    [anon_sym_BANG] = ACTIONS(2627),
    [anon_sym_TILDE] = ACTIONS(2627),
    [anon_sym_DASH] = ACTIONS(2625),
    [anon_sym_PLUS] = ACTIONS(2625),
    [anon_sym_STAR] = ACTIONS(2627),
    [anon_sym_AMP_AMP] = ACTIONS(2627),
    [anon_sym_AMP] = ACTIONS(2625),
    [anon_sym_SEMI] = ACTIONS(2627),
    [anon_sym___extension__] = ACTIONS(2625),
    [anon_sym_typedef] = ACTIONS(2625),
    [anon_sym_virtual] = ACTIONS(2625),
    [anon_sym_extern] = ACTIONS(2625),
    [anon_sym___attribute__] = ACTIONS(2625),
    [anon_sym___attribute] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(2627),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2627),
    [anon_sym___declspec] = ACTIONS(2625),
    [anon_sym___based] = ACTIONS(2625),
    [anon_sym___cdecl] = ACTIONS(2625),
    [anon_sym___clrcall] = ACTIONS(2625),
    [anon_sym___stdcall] = ACTIONS(2625),
    [anon_sym___fastcall] = ACTIONS(2625),
    [anon_sym___thiscall] = ACTIONS(2625),
    [anon_sym___vectorcall] = ACTIONS(2625),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_RBRACE] = ACTIONS(2627),
    [anon_sym_signed] = ACTIONS(2625),
    [anon_sym_unsigned] = ACTIONS(2625),
    [anon_sym_long] = ACTIONS(2625),
    [anon_sym_short] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(2625),
    [anon_sym_static] = ACTIONS(2625),
    [anon_sym_register] = ACTIONS(2625),
    [anon_sym_inline] = ACTIONS(2625),
    [anon_sym___inline] = ACTIONS(2625),
    [anon_sym___inline__] = ACTIONS(2625),
    [anon_sym___forceinline] = ACTIONS(2625),
    [anon_sym_thread_local] = ACTIONS(2625),
    [anon_sym___thread] = ACTIONS(2625),
    [anon_sym_const] = ACTIONS(2625),
    [anon_sym_constexpr] = ACTIONS(2625),
    [anon_sym_volatile] = ACTIONS(2625),
    [anon_sym_restrict] = ACTIONS(2625),
    [anon_sym___restrict__] = ACTIONS(2625),
    [anon_sym__Atomic] = ACTIONS(2625),
    [anon_sym__Noreturn] = ACTIONS(2625),
    [anon_sym_noreturn] = ACTIONS(2625),
    [anon_sym__Nonnull] = ACTIONS(2625),
    [anon_sym_mutable] = ACTIONS(2625),
    [anon_sym_constinit] = ACTIONS(2625),
    [anon_sym_consteval] = ACTIONS(2625),
    [anon_sym_alignas] = ACTIONS(2625),
    [anon_sym__Alignas] = ACTIONS(2625),
    [sym_primitive_type] = ACTIONS(2625),
    [anon_sym_enum] = ACTIONS(2625),
    [anon_sym_class] = ACTIONS(2625),
    [anon_sym_struct] = ACTIONS(2625),
    [anon_sym_union] = ACTIONS(2625),
    [anon_sym_if] = ACTIONS(2625),
    [anon_sym_else] = ACTIONS(2625),
    [anon_sym_switch] = ACTIONS(2625),
    [anon_sym_case] = ACTIONS(2625),
    [anon_sym_default] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(2625),
    [anon_sym_do] = ACTIONS(2625),
    [anon_sym_for] = ACTIONS(2625),
    [anon_sym_return] = ACTIONS(2625),
    [anon_sym_break] = ACTIONS(2625),
    [anon_sym_continue] = ACTIONS(2625),
    [anon_sym_goto] = ACTIONS(2625),
    [anon_sym___try] = ACTIONS(2625),
    [anon_sym___leave] = ACTIONS(2625),
    [anon_sym_not] = ACTIONS(2625),
    [anon_sym_compl] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(2627),
    [anon_sym_PLUS_PLUS] = ACTIONS(2627),
    [anon_sym_sizeof] = ACTIONS(2625),
    [anon_sym___alignof__] = ACTIONS(2625),
    [anon_sym___alignof] = ACTIONS(2625),
    [anon_sym__alignof] = ACTIONS(2625),
    [anon_sym_alignof] = ACTIONS(2625),
    [anon_sym__Alignof] = ACTIONS(2625),
    [anon_sym_offsetof] = ACTIONS(2625),
    [anon_sym__Generic] = ACTIONS(2625),
    [anon_sym_asm] = ACTIONS(2625),
    [anon_sym___asm__] = ACTIONS(2625),
    [anon_sym___asm] = ACTIONS(2625),
    [sym_number_literal] = ACTIONS(2627),
    [anon_sym_L_SQUOTE] = ACTIONS(2627),
    [anon_sym_u_SQUOTE] = ACTIONS(2627),
    [anon_sym_U_SQUOTE] = ACTIONS(2627),
    [anon_sym_u8_SQUOTE] = ACTIONS(2627),
    [anon_sym_SQUOTE] = ACTIONS(2627),
    [anon_sym_L_DQUOTE] = ACTIONS(2627),
    [anon_sym_u_DQUOTE] = ACTIONS(2627),
    [anon_sym_U_DQUOTE] = ACTIONS(2627),
    [anon_sym_u8_DQUOTE] = ACTIONS(2627),
    [anon_sym_DQUOTE] = ACTIONS(2627),
    [sym_true] = ACTIONS(2625),
    [sym_false] = ACTIONS(2625),
    [anon_sym_NULL] = ACTIONS(2625),
    [anon_sym_nullptr] = ACTIONS(2625),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2625),
    [anon_sym_decltype] = ACTIONS(2625),
    [anon_sym_explicit] = ACTIONS(2625),
    [anon_sym_typename] = ACTIONS(2625),
    [anon_sym_template] = ACTIONS(2625),
    [anon_sym_operator] = ACTIONS(2625),
    [anon_sym_try] = ACTIONS(2625),
    [anon_sym_delete] = ACTIONS(2625),
    [anon_sym_throw] = ACTIONS(2625),
    [anon_sym_namespace] = ACTIONS(2625),
    [anon_sym_using] = ACTIONS(2625),
    [anon_sym_static_assert] = ACTIONS(2625),
    [anon_sym_concept] = ACTIONS(2625),
    [anon_sym_co_return] = ACTIONS(2625),
    [anon_sym_co_yield] = ACTIONS(2625),
    [anon_sym_R_DQUOTE] = ACTIONS(2627),
    [anon_sym_LR_DQUOTE] = ACTIONS(2627),
    [anon_sym_uR_DQUOTE] = ACTIONS(2627),
    [anon_sym_UR_DQUOTE] = ACTIONS(2627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2627),
    [anon_sym_co_await] = ACTIONS(2625),
    [anon_sym_new] = ACTIONS(2625),
    [anon_sym_requires] = ACTIONS(2625),
    [sym_this] = ACTIONS(2625),
  },
  [453] = {
    [ts_builtin_sym_end] = ACTIONS(2679),
    [sym_identifier] = ACTIONS(2677),
    [aux_sym_preproc_include_token1] = ACTIONS(2677),
    [aux_sym_preproc_def_token1] = ACTIONS(2677),
    [aux_sym_preproc_if_token1] = ACTIONS(2677),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2677),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2677),
    [sym_preproc_directive] = ACTIONS(2677),
    [anon_sym_LPAREN2] = ACTIONS(2679),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_TILDE] = ACTIONS(2679),
    [anon_sym_DASH] = ACTIONS(2677),
    [anon_sym_PLUS] = ACTIONS(2677),
    [anon_sym_STAR] = ACTIONS(2679),
    [anon_sym_AMP_AMP] = ACTIONS(2679),
    [anon_sym_AMP] = ACTIONS(2677),
    [anon_sym_SEMI] = ACTIONS(2679),
    [anon_sym___extension__] = ACTIONS(2677),
    [anon_sym_typedef] = ACTIONS(2677),
    [anon_sym_virtual] = ACTIONS(2677),
    [anon_sym_extern] = ACTIONS(2677),
    [anon_sym___attribute__] = ACTIONS(2677),
    [anon_sym___attribute] = ACTIONS(2677),
    [anon_sym_COLON_COLON] = ACTIONS(2679),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2679),
    [anon_sym___declspec] = ACTIONS(2677),
    [anon_sym___based] = ACTIONS(2677),
    [anon_sym___cdecl] = ACTIONS(2677),
    [anon_sym___clrcall] = ACTIONS(2677),
    [anon_sym___stdcall] = ACTIONS(2677),
    [anon_sym___fastcall] = ACTIONS(2677),
    [anon_sym___thiscall] = ACTIONS(2677),
    [anon_sym___vectorcall] = ACTIONS(2677),
    [anon_sym_LBRACE] = ACTIONS(2679),
    [anon_sym_signed] = ACTIONS(2677),
    [anon_sym_unsigned] = ACTIONS(2677),
    [anon_sym_long] = ACTIONS(2677),
    [anon_sym_short] = ACTIONS(2677),
    [anon_sym_LBRACK] = ACTIONS(2677),
    [anon_sym_static] = ACTIONS(2677),
    [anon_sym_register] = ACTIONS(2677),
    [anon_sym_inline] = ACTIONS(2677),
    [anon_sym___inline] = ACTIONS(2677),
    [anon_sym___inline__] = ACTIONS(2677),
    [anon_sym___forceinline] = ACTIONS(2677),
    [anon_sym_thread_local] = ACTIONS(2677),
    [anon_sym___thread] = ACTIONS(2677),
    [anon_sym_const] = ACTIONS(2677),
    [anon_sym_constexpr] = ACTIONS(2677),
    [anon_sym_volatile] = ACTIONS(2677),
    [anon_sym_restrict] = ACTIONS(2677),
    [anon_sym___restrict__] = ACTIONS(2677),
    [anon_sym__Atomic] = ACTIONS(2677),
    [anon_sym__Noreturn] = ACTIONS(2677),
    [anon_sym_noreturn] = ACTIONS(2677),
    [anon_sym__Nonnull] = ACTIONS(2677),
    [anon_sym_mutable] = ACTIONS(2677),
    [anon_sym_constinit] = ACTIONS(2677),
    [anon_sym_consteval] = ACTIONS(2677),
    [anon_sym_alignas] = ACTIONS(2677),
    [anon_sym__Alignas] = ACTIONS(2677),
    [sym_primitive_type] = ACTIONS(2677),
    [anon_sym_enum] = ACTIONS(2677),
    [anon_sym_class] = ACTIONS(2677),
    [anon_sym_struct] = ACTIONS(2677),
    [anon_sym_union] = ACTIONS(2677),
    [anon_sym_if] = ACTIONS(2677),
    [anon_sym_else] = ACTIONS(2677),
    [anon_sym_switch] = ACTIONS(2677),
    [anon_sym_case] = ACTIONS(2677),
    [anon_sym_default] = ACTIONS(2677),
    [anon_sym_while] = ACTIONS(2677),
    [anon_sym_do] = ACTIONS(2677),
    [anon_sym_for] = ACTIONS(2677),
    [anon_sym_return] = ACTIONS(2677),
    [anon_sym_break] = ACTIONS(2677),
    [anon_sym_continue] = ACTIONS(2677),
    [anon_sym_goto] = ACTIONS(2677),
    [anon_sym___try] = ACTIONS(2677),
    [anon_sym___leave] = ACTIONS(2677),
    [anon_sym_not] = ACTIONS(2677),
    [anon_sym_compl] = ACTIONS(2677),
    [anon_sym_DASH_DASH] = ACTIONS(2679),
    [anon_sym_PLUS_PLUS] = ACTIONS(2679),
    [anon_sym_sizeof] = ACTIONS(2677),
    [anon_sym___alignof__] = ACTIONS(2677),
    [anon_sym___alignof] = ACTIONS(2677),
    [anon_sym__alignof] = ACTIONS(2677),
    [anon_sym_alignof] = ACTIONS(2677),
    [anon_sym__Alignof] = ACTIONS(2677),
    [anon_sym_offsetof] = ACTIONS(2677),
    [anon_sym__Generic] = ACTIONS(2677),
    [anon_sym_asm] = ACTIONS(2677),
    [anon_sym___asm__] = ACTIONS(2677),
    [anon_sym___asm] = ACTIONS(2677),
    [sym_number_literal] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2679),
    [anon_sym_u_SQUOTE] = ACTIONS(2679),
    [anon_sym_U_SQUOTE] = ACTIONS(2679),
    [anon_sym_u8_SQUOTE] = ACTIONS(2679),
    [anon_sym_SQUOTE] = ACTIONS(2679),
    [anon_sym_L_DQUOTE] = ACTIONS(2679),
    [anon_sym_u_DQUOTE] = ACTIONS(2679),
    [anon_sym_U_DQUOTE] = ACTIONS(2679),
    [anon_sym_u8_DQUOTE] = ACTIONS(2679),
    [anon_sym_DQUOTE] = ACTIONS(2679),
    [sym_true] = ACTIONS(2677),
    [sym_false] = ACTIONS(2677),
    [anon_sym_NULL] = ACTIONS(2677),
    [anon_sym_nullptr] = ACTIONS(2677),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2677),
    [anon_sym_decltype] = ACTIONS(2677),
    [anon_sym_explicit] = ACTIONS(2677),
    [anon_sym_typename] = ACTIONS(2677),
    [anon_sym_template] = ACTIONS(2677),
    [anon_sym_operator] = ACTIONS(2677),
    [anon_sym_try] = ACTIONS(2677),
    [anon_sym_delete] = ACTIONS(2677),
    [anon_sym_throw] = ACTIONS(2677),
    [anon_sym_namespace] = ACTIONS(2677),
    [anon_sym_using] = ACTIONS(2677),
    [anon_sym_static_assert] = ACTIONS(2677),
    [anon_sym_concept] = ACTIONS(2677),
    [anon_sym_co_return] = ACTIONS(2677),
    [anon_sym_co_yield] = ACTIONS(2677),
    [anon_sym_R_DQUOTE] = ACTIONS(2679),
    [anon_sym_LR_DQUOTE] = ACTIONS(2679),
    [anon_sym_uR_DQUOTE] = ACTIONS(2679),
    [anon_sym_UR_DQUOTE] = ACTIONS(2679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2679),
    [anon_sym_co_await] = ACTIONS(2677),
    [anon_sym_new] = ACTIONS(2677),
    [anon_sym_requires] = ACTIONS(2677),
    [sym_this] = ACTIONS(2677),
  },
  [454] = {
    [sym_identifier] = ACTIONS(2617),
    [aux_sym_preproc_include_token1] = ACTIONS(2617),
    [aux_sym_preproc_def_token1] = ACTIONS(2617),
    [aux_sym_preproc_if_token1] = ACTIONS(2617),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2617),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2617),
    [sym_preproc_directive] = ACTIONS(2617),
    [anon_sym_LPAREN2] = ACTIONS(2619),
    [anon_sym_BANG] = ACTIONS(2619),
    [anon_sym_TILDE] = ACTIONS(2619),
    [anon_sym_DASH] = ACTIONS(2617),
    [anon_sym_PLUS] = ACTIONS(2617),
    [anon_sym_STAR] = ACTIONS(2619),
    [anon_sym_AMP_AMP] = ACTIONS(2619),
    [anon_sym_AMP] = ACTIONS(2617),
    [anon_sym_SEMI] = ACTIONS(2619),
    [anon_sym___extension__] = ACTIONS(2617),
    [anon_sym_typedef] = ACTIONS(2617),
    [anon_sym_virtual] = ACTIONS(2617),
    [anon_sym_extern] = ACTIONS(2617),
    [anon_sym___attribute__] = ACTIONS(2617),
    [anon_sym___attribute] = ACTIONS(2617),
    [anon_sym_COLON_COLON] = ACTIONS(2619),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2619),
    [anon_sym___declspec] = ACTIONS(2617),
    [anon_sym___based] = ACTIONS(2617),
    [anon_sym___cdecl] = ACTIONS(2617),
    [anon_sym___clrcall] = ACTIONS(2617),
    [anon_sym___stdcall] = ACTIONS(2617),
    [anon_sym___fastcall] = ACTIONS(2617),
    [anon_sym___thiscall] = ACTIONS(2617),
    [anon_sym___vectorcall] = ACTIONS(2617),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_RBRACE] = ACTIONS(2619),
    [anon_sym_signed] = ACTIONS(2617),
    [anon_sym_unsigned] = ACTIONS(2617),
    [anon_sym_long] = ACTIONS(2617),
    [anon_sym_short] = ACTIONS(2617),
    [anon_sym_LBRACK] = ACTIONS(2617),
    [anon_sym_static] = ACTIONS(2617),
    [anon_sym_register] = ACTIONS(2617),
    [anon_sym_inline] = ACTIONS(2617),
    [anon_sym___inline] = ACTIONS(2617),
    [anon_sym___inline__] = ACTIONS(2617),
    [anon_sym___forceinline] = ACTIONS(2617),
    [anon_sym_thread_local] = ACTIONS(2617),
    [anon_sym___thread] = ACTIONS(2617),
    [anon_sym_const] = ACTIONS(2617),
    [anon_sym_constexpr] = ACTIONS(2617),
    [anon_sym_volatile] = ACTIONS(2617),
    [anon_sym_restrict] = ACTIONS(2617),
    [anon_sym___restrict__] = ACTIONS(2617),
    [anon_sym__Atomic] = ACTIONS(2617),
    [anon_sym__Noreturn] = ACTIONS(2617),
    [anon_sym_noreturn] = ACTIONS(2617),
    [anon_sym__Nonnull] = ACTIONS(2617),
    [anon_sym_mutable] = ACTIONS(2617),
    [anon_sym_constinit] = ACTIONS(2617),
    [anon_sym_consteval] = ACTIONS(2617),
    [anon_sym_alignas] = ACTIONS(2617),
    [anon_sym__Alignas] = ACTIONS(2617),
    [sym_primitive_type] = ACTIONS(2617),
    [anon_sym_enum] = ACTIONS(2617),
    [anon_sym_class] = ACTIONS(2617),
    [anon_sym_struct] = ACTIONS(2617),
    [anon_sym_union] = ACTIONS(2617),
    [anon_sym_if] = ACTIONS(2617),
    [anon_sym_else] = ACTIONS(2617),
    [anon_sym_switch] = ACTIONS(2617),
    [anon_sym_case] = ACTIONS(2617),
    [anon_sym_default] = ACTIONS(2617),
    [anon_sym_while] = ACTIONS(2617),
    [anon_sym_do] = ACTIONS(2617),
    [anon_sym_for] = ACTIONS(2617),
    [anon_sym_return] = ACTIONS(2617),
    [anon_sym_break] = ACTIONS(2617),
    [anon_sym_continue] = ACTIONS(2617),
    [anon_sym_goto] = ACTIONS(2617),
    [anon_sym___try] = ACTIONS(2617),
    [anon_sym___leave] = ACTIONS(2617),
    [anon_sym_not] = ACTIONS(2617),
    [anon_sym_compl] = ACTIONS(2617),
    [anon_sym_DASH_DASH] = ACTIONS(2619),
    [anon_sym_PLUS_PLUS] = ACTIONS(2619),
    [anon_sym_sizeof] = ACTIONS(2617),
    [anon_sym___alignof__] = ACTIONS(2617),
    [anon_sym___alignof] = ACTIONS(2617),
    [anon_sym__alignof] = ACTIONS(2617),
    [anon_sym_alignof] = ACTIONS(2617),
    [anon_sym__Alignof] = ACTIONS(2617),
    [anon_sym_offsetof] = ACTIONS(2617),
    [anon_sym__Generic] = ACTIONS(2617),
    [anon_sym_asm] = ACTIONS(2617),
    [anon_sym___asm__] = ACTIONS(2617),
    [anon_sym___asm] = ACTIONS(2617),
    [sym_number_literal] = ACTIONS(2619),
    [anon_sym_L_SQUOTE] = ACTIONS(2619),
    [anon_sym_u_SQUOTE] = ACTIONS(2619),
    [anon_sym_U_SQUOTE] = ACTIONS(2619),
    [anon_sym_u8_SQUOTE] = ACTIONS(2619),
    [anon_sym_SQUOTE] = ACTIONS(2619),
    [anon_sym_L_DQUOTE] = ACTIONS(2619),
    [anon_sym_u_DQUOTE] = ACTIONS(2619),
    [anon_sym_U_DQUOTE] = ACTIONS(2619),
    [anon_sym_u8_DQUOTE] = ACTIONS(2619),
    [anon_sym_DQUOTE] = ACTIONS(2619),
    [sym_true] = ACTIONS(2617),
    [sym_false] = ACTIONS(2617),
    [anon_sym_NULL] = ACTIONS(2617),
    [anon_sym_nullptr] = ACTIONS(2617),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2617),
    [anon_sym_decltype] = ACTIONS(2617),
    [anon_sym_explicit] = ACTIONS(2617),
    [anon_sym_typename] = ACTIONS(2617),
    [anon_sym_template] = ACTIONS(2617),
    [anon_sym_operator] = ACTIONS(2617),
    [anon_sym_try] = ACTIONS(2617),
    [anon_sym_delete] = ACTIONS(2617),
    [anon_sym_throw] = ACTIONS(2617),
    [anon_sym_namespace] = ACTIONS(2617),
    [anon_sym_using] = ACTIONS(2617),
    [anon_sym_static_assert] = ACTIONS(2617),
    [anon_sym_concept] = ACTIONS(2617),
    [anon_sym_co_return] = ACTIONS(2617),
    [anon_sym_co_yield] = ACTIONS(2617),
    [anon_sym_R_DQUOTE] = ACTIONS(2619),
    [anon_sym_LR_DQUOTE] = ACTIONS(2619),
    [anon_sym_uR_DQUOTE] = ACTIONS(2619),
    [anon_sym_UR_DQUOTE] = ACTIONS(2619),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2619),
    [anon_sym_co_await] = ACTIONS(2617),
    [anon_sym_new] = ACTIONS(2617),
    [anon_sym_requires] = ACTIONS(2617),
    [sym_this] = ACTIONS(2617),
  },
  [455] = {
    [ts_builtin_sym_end] = ACTIONS(2687),
    [sym_identifier] = ACTIONS(2685),
    [aux_sym_preproc_include_token1] = ACTIONS(2685),
    [aux_sym_preproc_def_token1] = ACTIONS(2685),
    [aux_sym_preproc_if_token1] = ACTIONS(2685),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2685),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2685),
    [sym_preproc_directive] = ACTIONS(2685),
    [anon_sym_LPAREN2] = ACTIONS(2687),
    [anon_sym_BANG] = ACTIONS(2687),
    [anon_sym_TILDE] = ACTIONS(2687),
    [anon_sym_DASH] = ACTIONS(2685),
    [anon_sym_PLUS] = ACTIONS(2685),
    [anon_sym_STAR] = ACTIONS(2687),
    [anon_sym_AMP_AMP] = ACTIONS(2687),
    [anon_sym_AMP] = ACTIONS(2685),
    [anon_sym_SEMI] = ACTIONS(2687),
    [anon_sym___extension__] = ACTIONS(2685),
    [anon_sym_typedef] = ACTIONS(2685),
    [anon_sym_virtual] = ACTIONS(2685),
    [anon_sym_extern] = ACTIONS(2685),
    [anon_sym___attribute__] = ACTIONS(2685),
    [anon_sym___attribute] = ACTIONS(2685),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2687),
    [anon_sym___declspec] = ACTIONS(2685),
    [anon_sym___based] = ACTIONS(2685),
    [anon_sym___cdecl] = ACTIONS(2685),
    [anon_sym___clrcall] = ACTIONS(2685),
    [anon_sym___stdcall] = ACTIONS(2685),
    [anon_sym___fastcall] = ACTIONS(2685),
    [anon_sym___thiscall] = ACTIONS(2685),
    [anon_sym___vectorcall] = ACTIONS(2685),
    [anon_sym_LBRACE] = ACTIONS(2687),
    [anon_sym_signed] = ACTIONS(2685),
    [anon_sym_unsigned] = ACTIONS(2685),
    [anon_sym_long] = ACTIONS(2685),
    [anon_sym_short] = ACTIONS(2685),
    [anon_sym_LBRACK] = ACTIONS(2685),
    [anon_sym_static] = ACTIONS(2685),
    [anon_sym_register] = ACTIONS(2685),
    [anon_sym_inline] = ACTIONS(2685),
    [anon_sym___inline] = ACTIONS(2685),
    [anon_sym___inline__] = ACTIONS(2685),
    [anon_sym___forceinline] = ACTIONS(2685),
    [anon_sym_thread_local] = ACTIONS(2685),
    [anon_sym___thread] = ACTIONS(2685),
    [anon_sym_const] = ACTIONS(2685),
    [anon_sym_constexpr] = ACTIONS(2685),
    [anon_sym_volatile] = ACTIONS(2685),
    [anon_sym_restrict] = ACTIONS(2685),
    [anon_sym___restrict__] = ACTIONS(2685),
    [anon_sym__Atomic] = ACTIONS(2685),
    [anon_sym__Noreturn] = ACTIONS(2685),
    [anon_sym_noreturn] = ACTIONS(2685),
    [anon_sym__Nonnull] = ACTIONS(2685),
    [anon_sym_mutable] = ACTIONS(2685),
    [anon_sym_constinit] = ACTIONS(2685),
    [anon_sym_consteval] = ACTIONS(2685),
    [anon_sym_alignas] = ACTIONS(2685),
    [anon_sym__Alignas] = ACTIONS(2685),
    [sym_primitive_type] = ACTIONS(2685),
    [anon_sym_enum] = ACTIONS(2685),
    [anon_sym_class] = ACTIONS(2685),
    [anon_sym_struct] = ACTIONS(2685),
    [anon_sym_union] = ACTIONS(2685),
    [anon_sym_if] = ACTIONS(2685),
    [anon_sym_else] = ACTIONS(2685),
    [anon_sym_switch] = ACTIONS(2685),
    [anon_sym_case] = ACTIONS(2685),
    [anon_sym_default] = ACTIONS(2685),
    [anon_sym_while] = ACTIONS(2685),
    [anon_sym_do] = ACTIONS(2685),
    [anon_sym_for] = ACTIONS(2685),
    [anon_sym_return] = ACTIONS(2685),
    [anon_sym_break] = ACTIONS(2685),
    [anon_sym_continue] = ACTIONS(2685),
    [anon_sym_goto] = ACTIONS(2685),
    [anon_sym___try] = ACTIONS(2685),
    [anon_sym___leave] = ACTIONS(2685),
    [anon_sym_not] = ACTIONS(2685),
    [anon_sym_compl] = ACTIONS(2685),
    [anon_sym_DASH_DASH] = ACTIONS(2687),
    [anon_sym_PLUS_PLUS] = ACTIONS(2687),
    [anon_sym_sizeof] = ACTIONS(2685),
    [anon_sym___alignof__] = ACTIONS(2685),
    [anon_sym___alignof] = ACTIONS(2685),
    [anon_sym__alignof] = ACTIONS(2685),
    [anon_sym_alignof] = ACTIONS(2685),
    [anon_sym__Alignof] = ACTIONS(2685),
    [anon_sym_offsetof] = ACTIONS(2685),
    [anon_sym__Generic] = ACTIONS(2685),
    [anon_sym_asm] = ACTIONS(2685),
    [anon_sym___asm__] = ACTIONS(2685),
    [anon_sym___asm] = ACTIONS(2685),
    [sym_number_literal] = ACTIONS(2687),
    [anon_sym_L_SQUOTE] = ACTIONS(2687),
    [anon_sym_u_SQUOTE] = ACTIONS(2687),
    [anon_sym_U_SQUOTE] = ACTIONS(2687),
    [anon_sym_u8_SQUOTE] = ACTIONS(2687),
    [anon_sym_SQUOTE] = ACTIONS(2687),
    [anon_sym_L_DQUOTE] = ACTIONS(2687),
    [anon_sym_u_DQUOTE] = ACTIONS(2687),
    [anon_sym_U_DQUOTE] = ACTIONS(2687),
    [anon_sym_u8_DQUOTE] = ACTIONS(2687),
    [anon_sym_DQUOTE] = ACTIONS(2687),
    [sym_true] = ACTIONS(2685),
    [sym_false] = ACTIONS(2685),
    [anon_sym_NULL] = ACTIONS(2685),
    [anon_sym_nullptr] = ACTIONS(2685),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2685),
    [anon_sym_decltype] = ACTIONS(2685),
    [anon_sym_explicit] = ACTIONS(2685),
    [anon_sym_typename] = ACTIONS(2685),
    [anon_sym_template] = ACTIONS(2685),
    [anon_sym_operator] = ACTIONS(2685),
    [anon_sym_try] = ACTIONS(2685),
    [anon_sym_delete] = ACTIONS(2685),
    [anon_sym_throw] = ACTIONS(2685),
    [anon_sym_namespace] = ACTIONS(2685),
    [anon_sym_using] = ACTIONS(2685),
    [anon_sym_static_assert] = ACTIONS(2685),
    [anon_sym_concept] = ACTIONS(2685),
    [anon_sym_co_return] = ACTIONS(2685),
    [anon_sym_co_yield] = ACTIONS(2685),
    [anon_sym_R_DQUOTE] = ACTIONS(2687),
    [anon_sym_LR_DQUOTE] = ACTIONS(2687),
    [anon_sym_uR_DQUOTE] = ACTIONS(2687),
    [anon_sym_UR_DQUOTE] = ACTIONS(2687),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2687),
    [anon_sym_co_await] = ACTIONS(2685),
    [anon_sym_new] = ACTIONS(2685),
    [anon_sym_requires] = ACTIONS(2685),
    [sym_this] = ACTIONS(2685),
  },
  [456] = {
    [ts_builtin_sym_end] = ACTIONS(2627),
    [sym_identifier] = ACTIONS(2625),
    [aux_sym_preproc_include_token1] = ACTIONS(2625),
    [aux_sym_preproc_def_token1] = ACTIONS(2625),
    [aux_sym_preproc_if_token1] = ACTIONS(2625),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2625),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2625),
    [sym_preproc_directive] = ACTIONS(2625),
    [anon_sym_LPAREN2] = ACTIONS(2627),
    [anon_sym_BANG] = ACTIONS(2627),
    [anon_sym_TILDE] = ACTIONS(2627),
    [anon_sym_DASH] = ACTIONS(2625),
    [anon_sym_PLUS] = ACTIONS(2625),
    [anon_sym_STAR] = ACTIONS(2627),
    [anon_sym_AMP_AMP] = ACTIONS(2627),
    [anon_sym_AMP] = ACTIONS(2625),
    [anon_sym_SEMI] = ACTIONS(2627),
    [anon_sym___extension__] = ACTIONS(2625),
    [anon_sym_typedef] = ACTIONS(2625),
    [anon_sym_virtual] = ACTIONS(2625),
    [anon_sym_extern] = ACTIONS(2625),
    [anon_sym___attribute__] = ACTIONS(2625),
    [anon_sym___attribute] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(2627),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2627),
    [anon_sym___declspec] = ACTIONS(2625),
    [anon_sym___based] = ACTIONS(2625),
    [anon_sym___cdecl] = ACTIONS(2625),
    [anon_sym___clrcall] = ACTIONS(2625),
    [anon_sym___stdcall] = ACTIONS(2625),
    [anon_sym___fastcall] = ACTIONS(2625),
    [anon_sym___thiscall] = ACTIONS(2625),
    [anon_sym___vectorcall] = ACTIONS(2625),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_signed] = ACTIONS(2625),
    [anon_sym_unsigned] = ACTIONS(2625),
    [anon_sym_long] = ACTIONS(2625),
    [anon_sym_short] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(2625),
    [anon_sym_static] = ACTIONS(2625),
    [anon_sym_register] = ACTIONS(2625),
    [anon_sym_inline] = ACTIONS(2625),
    [anon_sym___inline] = ACTIONS(2625),
    [anon_sym___inline__] = ACTIONS(2625),
    [anon_sym___forceinline] = ACTIONS(2625),
    [anon_sym_thread_local] = ACTIONS(2625),
    [anon_sym___thread] = ACTIONS(2625),
    [anon_sym_const] = ACTIONS(2625),
    [anon_sym_constexpr] = ACTIONS(2625),
    [anon_sym_volatile] = ACTIONS(2625),
    [anon_sym_restrict] = ACTIONS(2625),
    [anon_sym___restrict__] = ACTIONS(2625),
    [anon_sym__Atomic] = ACTIONS(2625),
    [anon_sym__Noreturn] = ACTIONS(2625),
    [anon_sym_noreturn] = ACTIONS(2625),
    [anon_sym__Nonnull] = ACTIONS(2625),
    [anon_sym_mutable] = ACTIONS(2625),
    [anon_sym_constinit] = ACTIONS(2625),
    [anon_sym_consteval] = ACTIONS(2625),
    [anon_sym_alignas] = ACTIONS(2625),
    [anon_sym__Alignas] = ACTIONS(2625),
    [sym_primitive_type] = ACTIONS(2625),
    [anon_sym_enum] = ACTIONS(2625),
    [anon_sym_class] = ACTIONS(2625),
    [anon_sym_struct] = ACTIONS(2625),
    [anon_sym_union] = ACTIONS(2625),
    [anon_sym_if] = ACTIONS(2625),
    [anon_sym_else] = ACTIONS(2625),
    [anon_sym_switch] = ACTIONS(2625),
    [anon_sym_case] = ACTIONS(2625),
    [anon_sym_default] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(2625),
    [anon_sym_do] = ACTIONS(2625),
    [anon_sym_for] = ACTIONS(2625),
    [anon_sym_return] = ACTIONS(2625),
    [anon_sym_break] = ACTIONS(2625),
    [anon_sym_continue] = ACTIONS(2625),
    [anon_sym_goto] = ACTIONS(2625),
    [anon_sym___try] = ACTIONS(2625),
    [anon_sym___leave] = ACTIONS(2625),
    [anon_sym_not] = ACTIONS(2625),
    [anon_sym_compl] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(2627),
    [anon_sym_PLUS_PLUS] = ACTIONS(2627),
    [anon_sym_sizeof] = ACTIONS(2625),
    [anon_sym___alignof__] = ACTIONS(2625),
    [anon_sym___alignof] = ACTIONS(2625),
    [anon_sym__alignof] = ACTIONS(2625),
    [anon_sym_alignof] = ACTIONS(2625),
    [anon_sym__Alignof] = ACTIONS(2625),
    [anon_sym_offsetof] = ACTIONS(2625),
    [anon_sym__Generic] = ACTIONS(2625),
    [anon_sym_asm] = ACTIONS(2625),
    [anon_sym___asm__] = ACTIONS(2625),
    [anon_sym___asm] = ACTIONS(2625),
    [sym_number_literal] = ACTIONS(2627),
    [anon_sym_L_SQUOTE] = ACTIONS(2627),
    [anon_sym_u_SQUOTE] = ACTIONS(2627),
    [anon_sym_U_SQUOTE] = ACTIONS(2627),
    [anon_sym_u8_SQUOTE] = ACTIONS(2627),
    [anon_sym_SQUOTE] = ACTIONS(2627),
    [anon_sym_L_DQUOTE] = ACTIONS(2627),
    [anon_sym_u_DQUOTE] = ACTIONS(2627),
    [anon_sym_U_DQUOTE] = ACTIONS(2627),
    [anon_sym_u8_DQUOTE] = ACTIONS(2627),
    [anon_sym_DQUOTE] = ACTIONS(2627),
    [sym_true] = ACTIONS(2625),
    [sym_false] = ACTIONS(2625),
    [anon_sym_NULL] = ACTIONS(2625),
    [anon_sym_nullptr] = ACTIONS(2625),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2625),
    [anon_sym_decltype] = ACTIONS(2625),
    [anon_sym_explicit] = ACTIONS(2625),
    [anon_sym_typename] = ACTIONS(2625),
    [anon_sym_template] = ACTIONS(2625),
    [anon_sym_operator] = ACTIONS(2625),
    [anon_sym_try] = ACTIONS(2625),
    [anon_sym_delete] = ACTIONS(2625),
    [anon_sym_throw] = ACTIONS(2625),
    [anon_sym_namespace] = ACTIONS(2625),
    [anon_sym_using] = ACTIONS(2625),
    [anon_sym_static_assert] = ACTIONS(2625),
    [anon_sym_concept] = ACTIONS(2625),
    [anon_sym_co_return] = ACTIONS(2625),
    [anon_sym_co_yield] = ACTIONS(2625),
    [anon_sym_R_DQUOTE] = ACTIONS(2627),
    [anon_sym_LR_DQUOTE] = ACTIONS(2627),
    [anon_sym_uR_DQUOTE] = ACTIONS(2627),
    [anon_sym_UR_DQUOTE] = ACTIONS(2627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2627),
    [anon_sym_co_await] = ACTIONS(2625),
    [anon_sym_new] = ACTIONS(2625),
    [anon_sym_requires] = ACTIONS(2625),
    [sym_this] = ACTIONS(2625),
  },
  [457] = {
    [ts_builtin_sym_end] = ACTIONS(2711),
    [sym_identifier] = ACTIONS(2709),
    [aux_sym_preproc_include_token1] = ACTIONS(2709),
    [aux_sym_preproc_def_token1] = ACTIONS(2709),
    [aux_sym_preproc_if_token1] = ACTIONS(2709),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2709),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2709),
    [sym_preproc_directive] = ACTIONS(2709),
    [anon_sym_LPAREN2] = ACTIONS(2711),
    [anon_sym_BANG] = ACTIONS(2711),
    [anon_sym_TILDE] = ACTIONS(2711),
    [anon_sym_DASH] = ACTIONS(2709),
    [anon_sym_PLUS] = ACTIONS(2709),
    [anon_sym_STAR] = ACTIONS(2711),
    [anon_sym_AMP_AMP] = ACTIONS(2711),
    [anon_sym_AMP] = ACTIONS(2709),
    [anon_sym_SEMI] = ACTIONS(2711),
    [anon_sym___extension__] = ACTIONS(2709),
    [anon_sym_typedef] = ACTIONS(2709),
    [anon_sym_virtual] = ACTIONS(2709),
    [anon_sym_extern] = ACTIONS(2709),
    [anon_sym___attribute__] = ACTIONS(2709),
    [anon_sym___attribute] = ACTIONS(2709),
    [anon_sym_COLON_COLON] = ACTIONS(2711),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2711),
    [anon_sym___declspec] = ACTIONS(2709),
    [anon_sym___based] = ACTIONS(2709),
    [anon_sym___cdecl] = ACTIONS(2709),
    [anon_sym___clrcall] = ACTIONS(2709),
    [anon_sym___stdcall] = ACTIONS(2709),
    [anon_sym___fastcall] = ACTIONS(2709),
    [anon_sym___thiscall] = ACTIONS(2709),
    [anon_sym___vectorcall] = ACTIONS(2709),
    [anon_sym_LBRACE] = ACTIONS(2711),
    [anon_sym_signed] = ACTIONS(2709),
    [anon_sym_unsigned] = ACTIONS(2709),
    [anon_sym_long] = ACTIONS(2709),
    [anon_sym_short] = ACTIONS(2709),
    [anon_sym_LBRACK] = ACTIONS(2709),
    [anon_sym_static] = ACTIONS(2709),
    [anon_sym_register] = ACTIONS(2709),
    [anon_sym_inline] = ACTIONS(2709),
    [anon_sym___inline] = ACTIONS(2709),
    [anon_sym___inline__] = ACTIONS(2709),
    [anon_sym___forceinline] = ACTIONS(2709),
    [anon_sym_thread_local] = ACTIONS(2709),
    [anon_sym___thread] = ACTIONS(2709),
    [anon_sym_const] = ACTIONS(2709),
    [anon_sym_constexpr] = ACTIONS(2709),
    [anon_sym_volatile] = ACTIONS(2709),
    [anon_sym_restrict] = ACTIONS(2709),
    [anon_sym___restrict__] = ACTIONS(2709),
    [anon_sym__Atomic] = ACTIONS(2709),
    [anon_sym__Noreturn] = ACTIONS(2709),
    [anon_sym_noreturn] = ACTIONS(2709),
    [anon_sym__Nonnull] = ACTIONS(2709),
    [anon_sym_mutable] = ACTIONS(2709),
    [anon_sym_constinit] = ACTIONS(2709),
    [anon_sym_consteval] = ACTIONS(2709),
    [anon_sym_alignas] = ACTIONS(2709),
    [anon_sym__Alignas] = ACTIONS(2709),
    [sym_primitive_type] = ACTIONS(2709),
    [anon_sym_enum] = ACTIONS(2709),
    [anon_sym_class] = ACTIONS(2709),
    [anon_sym_struct] = ACTIONS(2709),
    [anon_sym_union] = ACTIONS(2709),
    [anon_sym_if] = ACTIONS(2709),
    [anon_sym_else] = ACTIONS(2709),
    [anon_sym_switch] = ACTIONS(2709),
    [anon_sym_case] = ACTIONS(2709),
    [anon_sym_default] = ACTIONS(2709),
    [anon_sym_while] = ACTIONS(2709),
    [anon_sym_do] = ACTIONS(2709),
    [anon_sym_for] = ACTIONS(2709),
    [anon_sym_return] = ACTIONS(2709),
    [anon_sym_break] = ACTIONS(2709),
    [anon_sym_continue] = ACTIONS(2709),
    [anon_sym_goto] = ACTIONS(2709),
    [anon_sym___try] = ACTIONS(2709),
    [anon_sym___leave] = ACTIONS(2709),
    [anon_sym_not] = ACTIONS(2709),
    [anon_sym_compl] = ACTIONS(2709),
    [anon_sym_DASH_DASH] = ACTIONS(2711),
    [anon_sym_PLUS_PLUS] = ACTIONS(2711),
    [anon_sym_sizeof] = ACTIONS(2709),
    [anon_sym___alignof__] = ACTIONS(2709),
    [anon_sym___alignof] = ACTIONS(2709),
    [anon_sym__alignof] = ACTIONS(2709),
    [anon_sym_alignof] = ACTIONS(2709),
    [anon_sym__Alignof] = ACTIONS(2709),
    [anon_sym_offsetof] = ACTIONS(2709),
    [anon_sym__Generic] = ACTIONS(2709),
    [anon_sym_asm] = ACTIONS(2709),
    [anon_sym___asm__] = ACTIONS(2709),
    [anon_sym___asm] = ACTIONS(2709),
    [sym_number_literal] = ACTIONS(2711),
    [anon_sym_L_SQUOTE] = ACTIONS(2711),
    [anon_sym_u_SQUOTE] = ACTIONS(2711),
    [anon_sym_U_SQUOTE] = ACTIONS(2711),
    [anon_sym_u8_SQUOTE] = ACTIONS(2711),
    [anon_sym_SQUOTE] = ACTIONS(2711),
    [anon_sym_L_DQUOTE] = ACTIONS(2711),
    [anon_sym_u_DQUOTE] = ACTIONS(2711),
    [anon_sym_U_DQUOTE] = ACTIONS(2711),
    [anon_sym_u8_DQUOTE] = ACTIONS(2711),
    [anon_sym_DQUOTE] = ACTIONS(2711),
    [sym_true] = ACTIONS(2709),
    [sym_false] = ACTIONS(2709),
    [anon_sym_NULL] = ACTIONS(2709),
    [anon_sym_nullptr] = ACTIONS(2709),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2709),
    [anon_sym_decltype] = ACTIONS(2709),
    [anon_sym_explicit] = ACTIONS(2709),
    [anon_sym_typename] = ACTIONS(2709),
    [anon_sym_template] = ACTIONS(2709),
    [anon_sym_operator] = ACTIONS(2709),
    [anon_sym_try] = ACTIONS(2709),
    [anon_sym_delete] = ACTIONS(2709),
    [anon_sym_throw] = ACTIONS(2709),
    [anon_sym_namespace] = ACTIONS(2709),
    [anon_sym_using] = ACTIONS(2709),
    [anon_sym_static_assert] = ACTIONS(2709),
    [anon_sym_concept] = ACTIONS(2709),
    [anon_sym_co_return] = ACTIONS(2709),
    [anon_sym_co_yield] = ACTIONS(2709),
    [anon_sym_R_DQUOTE] = ACTIONS(2711),
    [anon_sym_LR_DQUOTE] = ACTIONS(2711),
    [anon_sym_uR_DQUOTE] = ACTIONS(2711),
    [anon_sym_UR_DQUOTE] = ACTIONS(2711),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2711),
    [anon_sym_co_await] = ACTIONS(2709),
    [anon_sym_new] = ACTIONS(2709),
    [anon_sym_requires] = ACTIONS(2709),
    [sym_this] = ACTIONS(2709),
  },
  [458] = {
    [sym_identifier] = ACTIONS(2633),
    [aux_sym_preproc_include_token1] = ACTIONS(2633),
    [aux_sym_preproc_def_token1] = ACTIONS(2633),
    [aux_sym_preproc_if_token1] = ACTIONS(2633),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2633),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2633),
    [sym_preproc_directive] = ACTIONS(2633),
    [anon_sym_LPAREN2] = ACTIONS(2635),
    [anon_sym_BANG] = ACTIONS(2635),
    [anon_sym_TILDE] = ACTIONS(2635),
    [anon_sym_DASH] = ACTIONS(2633),
    [anon_sym_PLUS] = ACTIONS(2633),
    [anon_sym_STAR] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2635),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_SEMI] = ACTIONS(2635),
    [anon_sym___extension__] = ACTIONS(2633),
    [anon_sym_typedef] = ACTIONS(2633),
    [anon_sym_virtual] = ACTIONS(2633),
    [anon_sym_extern] = ACTIONS(2633),
    [anon_sym___attribute__] = ACTIONS(2633),
    [anon_sym___attribute] = ACTIONS(2633),
    [anon_sym_COLON_COLON] = ACTIONS(2635),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2635),
    [anon_sym___declspec] = ACTIONS(2633),
    [anon_sym___based] = ACTIONS(2633),
    [anon_sym___cdecl] = ACTIONS(2633),
    [anon_sym___clrcall] = ACTIONS(2633),
    [anon_sym___stdcall] = ACTIONS(2633),
    [anon_sym___fastcall] = ACTIONS(2633),
    [anon_sym___thiscall] = ACTIONS(2633),
    [anon_sym___vectorcall] = ACTIONS(2633),
    [anon_sym_LBRACE] = ACTIONS(2635),
    [anon_sym_RBRACE] = ACTIONS(2635),
    [anon_sym_signed] = ACTIONS(2633),
    [anon_sym_unsigned] = ACTIONS(2633),
    [anon_sym_long] = ACTIONS(2633),
    [anon_sym_short] = ACTIONS(2633),
    [anon_sym_LBRACK] = ACTIONS(2633),
    [anon_sym_static] = ACTIONS(2633),
    [anon_sym_register] = ACTIONS(2633),
    [anon_sym_inline] = ACTIONS(2633),
    [anon_sym___inline] = ACTIONS(2633),
    [anon_sym___inline__] = ACTIONS(2633),
    [anon_sym___forceinline] = ACTIONS(2633),
    [anon_sym_thread_local] = ACTIONS(2633),
    [anon_sym___thread] = ACTIONS(2633),
    [anon_sym_const] = ACTIONS(2633),
    [anon_sym_constexpr] = ACTIONS(2633),
    [anon_sym_volatile] = ACTIONS(2633),
    [anon_sym_restrict] = ACTIONS(2633),
    [anon_sym___restrict__] = ACTIONS(2633),
    [anon_sym__Atomic] = ACTIONS(2633),
    [anon_sym__Noreturn] = ACTIONS(2633),
    [anon_sym_noreturn] = ACTIONS(2633),
    [anon_sym__Nonnull] = ACTIONS(2633),
    [anon_sym_mutable] = ACTIONS(2633),
    [anon_sym_constinit] = ACTIONS(2633),
    [anon_sym_consteval] = ACTIONS(2633),
    [anon_sym_alignas] = ACTIONS(2633),
    [anon_sym__Alignas] = ACTIONS(2633),
    [sym_primitive_type] = ACTIONS(2633),
    [anon_sym_enum] = ACTIONS(2633),
    [anon_sym_class] = ACTIONS(2633),
    [anon_sym_struct] = ACTIONS(2633),
    [anon_sym_union] = ACTIONS(2633),
    [anon_sym_if] = ACTIONS(2633),
    [anon_sym_else] = ACTIONS(2633),
    [anon_sym_switch] = ACTIONS(2633),
    [anon_sym_case] = ACTIONS(2633),
    [anon_sym_default] = ACTIONS(2633),
    [anon_sym_while] = ACTIONS(2633),
    [anon_sym_do] = ACTIONS(2633),
    [anon_sym_for] = ACTIONS(2633),
    [anon_sym_return] = ACTIONS(2633),
    [anon_sym_break] = ACTIONS(2633),
    [anon_sym_continue] = ACTIONS(2633),
    [anon_sym_goto] = ACTIONS(2633),
    [anon_sym___try] = ACTIONS(2633),
    [anon_sym___leave] = ACTIONS(2633),
    [anon_sym_not] = ACTIONS(2633),
    [anon_sym_compl] = ACTIONS(2633),
    [anon_sym_DASH_DASH] = ACTIONS(2635),
    [anon_sym_PLUS_PLUS] = ACTIONS(2635),
    [anon_sym_sizeof] = ACTIONS(2633),
    [anon_sym___alignof__] = ACTIONS(2633),
    [anon_sym___alignof] = ACTIONS(2633),
    [anon_sym__alignof] = ACTIONS(2633),
    [anon_sym_alignof] = ACTIONS(2633),
    [anon_sym__Alignof] = ACTIONS(2633),
    [anon_sym_offsetof] = ACTIONS(2633),
    [anon_sym__Generic] = ACTIONS(2633),
    [anon_sym_asm] = ACTIONS(2633),
    [anon_sym___asm__] = ACTIONS(2633),
    [anon_sym___asm] = ACTIONS(2633),
    [sym_number_literal] = ACTIONS(2635),
    [anon_sym_L_SQUOTE] = ACTIONS(2635),
    [anon_sym_u_SQUOTE] = ACTIONS(2635),
    [anon_sym_U_SQUOTE] = ACTIONS(2635),
    [anon_sym_u8_SQUOTE] = ACTIONS(2635),
    [anon_sym_SQUOTE] = ACTIONS(2635),
    [anon_sym_L_DQUOTE] = ACTIONS(2635),
    [anon_sym_u_DQUOTE] = ACTIONS(2635),
    [anon_sym_U_DQUOTE] = ACTIONS(2635),
    [anon_sym_u8_DQUOTE] = ACTIONS(2635),
    [anon_sym_DQUOTE] = ACTIONS(2635),
    [sym_true] = ACTIONS(2633),
    [sym_false] = ACTIONS(2633),
    [anon_sym_NULL] = ACTIONS(2633),
    [anon_sym_nullptr] = ACTIONS(2633),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2633),
    [anon_sym_decltype] = ACTIONS(2633),
    [anon_sym_explicit] = ACTIONS(2633),
    [anon_sym_typename] = ACTIONS(2633),
    [anon_sym_template] = ACTIONS(2633),
    [anon_sym_operator] = ACTIONS(2633),
    [anon_sym_try] = ACTIONS(2633),
    [anon_sym_delete] = ACTIONS(2633),
    [anon_sym_throw] = ACTIONS(2633),
    [anon_sym_namespace] = ACTIONS(2633),
    [anon_sym_using] = ACTIONS(2633),
    [anon_sym_static_assert] = ACTIONS(2633),
    [anon_sym_concept] = ACTIONS(2633),
    [anon_sym_co_return] = ACTIONS(2633),
    [anon_sym_co_yield] = ACTIONS(2633),
    [anon_sym_R_DQUOTE] = ACTIONS(2635),
    [anon_sym_LR_DQUOTE] = ACTIONS(2635),
    [anon_sym_uR_DQUOTE] = ACTIONS(2635),
    [anon_sym_UR_DQUOTE] = ACTIONS(2635),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2635),
    [anon_sym_co_await] = ACTIONS(2633),
    [anon_sym_new] = ACTIONS(2633),
    [anon_sym_requires] = ACTIONS(2633),
    [sym_this] = ACTIONS(2633),
  },
  [459] = {
    [sym_identifier] = ACTIONS(2637),
    [aux_sym_preproc_include_token1] = ACTIONS(2637),
    [aux_sym_preproc_def_token1] = ACTIONS(2637),
    [aux_sym_preproc_if_token1] = ACTIONS(2637),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2637),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2637),
    [sym_preproc_directive] = ACTIONS(2637),
    [anon_sym_LPAREN2] = ACTIONS(2639),
    [anon_sym_BANG] = ACTIONS(2639),
    [anon_sym_TILDE] = ACTIONS(2639),
    [anon_sym_DASH] = ACTIONS(2637),
    [anon_sym_PLUS] = ACTIONS(2637),
    [anon_sym_STAR] = ACTIONS(2639),
    [anon_sym_AMP_AMP] = ACTIONS(2639),
    [anon_sym_AMP] = ACTIONS(2637),
    [anon_sym_SEMI] = ACTIONS(2639),
    [anon_sym___extension__] = ACTIONS(2637),
    [anon_sym_typedef] = ACTIONS(2637),
    [anon_sym_virtual] = ACTIONS(2637),
    [anon_sym_extern] = ACTIONS(2637),
    [anon_sym___attribute__] = ACTIONS(2637),
    [anon_sym___attribute] = ACTIONS(2637),
    [anon_sym_COLON_COLON] = ACTIONS(2639),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2639),
    [anon_sym___declspec] = ACTIONS(2637),
    [anon_sym___based] = ACTIONS(2637),
    [anon_sym___cdecl] = ACTIONS(2637),
    [anon_sym___clrcall] = ACTIONS(2637),
    [anon_sym___stdcall] = ACTIONS(2637),
    [anon_sym___fastcall] = ACTIONS(2637),
    [anon_sym___thiscall] = ACTIONS(2637),
    [anon_sym___vectorcall] = ACTIONS(2637),
    [anon_sym_LBRACE] = ACTIONS(2639),
    [anon_sym_RBRACE] = ACTIONS(2639),
    [anon_sym_signed] = ACTIONS(2637),
    [anon_sym_unsigned] = ACTIONS(2637),
    [anon_sym_long] = ACTIONS(2637),
    [anon_sym_short] = ACTIONS(2637),
    [anon_sym_LBRACK] = ACTIONS(2637),
    [anon_sym_static] = ACTIONS(2637),
    [anon_sym_register] = ACTIONS(2637),
    [anon_sym_inline] = ACTIONS(2637),
    [anon_sym___inline] = ACTIONS(2637),
    [anon_sym___inline__] = ACTIONS(2637),
    [anon_sym___forceinline] = ACTIONS(2637),
    [anon_sym_thread_local] = ACTIONS(2637),
    [anon_sym___thread] = ACTIONS(2637),
    [anon_sym_const] = ACTIONS(2637),
    [anon_sym_constexpr] = ACTIONS(2637),
    [anon_sym_volatile] = ACTIONS(2637),
    [anon_sym_restrict] = ACTIONS(2637),
    [anon_sym___restrict__] = ACTIONS(2637),
    [anon_sym__Atomic] = ACTIONS(2637),
    [anon_sym__Noreturn] = ACTIONS(2637),
    [anon_sym_noreturn] = ACTIONS(2637),
    [anon_sym__Nonnull] = ACTIONS(2637),
    [anon_sym_mutable] = ACTIONS(2637),
    [anon_sym_constinit] = ACTIONS(2637),
    [anon_sym_consteval] = ACTIONS(2637),
    [anon_sym_alignas] = ACTIONS(2637),
    [anon_sym__Alignas] = ACTIONS(2637),
    [sym_primitive_type] = ACTIONS(2637),
    [anon_sym_enum] = ACTIONS(2637),
    [anon_sym_class] = ACTIONS(2637),
    [anon_sym_struct] = ACTIONS(2637),
    [anon_sym_union] = ACTIONS(2637),
    [anon_sym_if] = ACTIONS(2637),
    [anon_sym_else] = ACTIONS(2637),
    [anon_sym_switch] = ACTIONS(2637),
    [anon_sym_case] = ACTIONS(2637),
    [anon_sym_default] = ACTIONS(2637),
    [anon_sym_while] = ACTIONS(2637),
    [anon_sym_do] = ACTIONS(2637),
    [anon_sym_for] = ACTIONS(2637),
    [anon_sym_return] = ACTIONS(2637),
    [anon_sym_break] = ACTIONS(2637),
    [anon_sym_continue] = ACTIONS(2637),
    [anon_sym_goto] = ACTIONS(2637),
    [anon_sym___try] = ACTIONS(2637),
    [anon_sym___leave] = ACTIONS(2637),
    [anon_sym_not] = ACTIONS(2637),
    [anon_sym_compl] = ACTIONS(2637),
    [anon_sym_DASH_DASH] = ACTIONS(2639),
    [anon_sym_PLUS_PLUS] = ACTIONS(2639),
    [anon_sym_sizeof] = ACTIONS(2637),
    [anon_sym___alignof__] = ACTIONS(2637),
    [anon_sym___alignof] = ACTIONS(2637),
    [anon_sym__alignof] = ACTIONS(2637),
    [anon_sym_alignof] = ACTIONS(2637),
    [anon_sym__Alignof] = ACTIONS(2637),
    [anon_sym_offsetof] = ACTIONS(2637),
    [anon_sym__Generic] = ACTIONS(2637),
    [anon_sym_asm] = ACTIONS(2637),
    [anon_sym___asm__] = ACTIONS(2637),
    [anon_sym___asm] = ACTIONS(2637),
    [sym_number_literal] = ACTIONS(2639),
    [anon_sym_L_SQUOTE] = ACTIONS(2639),
    [anon_sym_u_SQUOTE] = ACTIONS(2639),
    [anon_sym_U_SQUOTE] = ACTIONS(2639),
    [anon_sym_u8_SQUOTE] = ACTIONS(2639),
    [anon_sym_SQUOTE] = ACTIONS(2639),
    [anon_sym_L_DQUOTE] = ACTIONS(2639),
    [anon_sym_u_DQUOTE] = ACTIONS(2639),
    [anon_sym_U_DQUOTE] = ACTIONS(2639),
    [anon_sym_u8_DQUOTE] = ACTIONS(2639),
    [anon_sym_DQUOTE] = ACTIONS(2639),
    [sym_true] = ACTIONS(2637),
    [sym_false] = ACTIONS(2637),
    [anon_sym_NULL] = ACTIONS(2637),
    [anon_sym_nullptr] = ACTIONS(2637),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2637),
    [anon_sym_decltype] = ACTIONS(2637),
    [anon_sym_explicit] = ACTIONS(2637),
    [anon_sym_typename] = ACTIONS(2637),
    [anon_sym_template] = ACTIONS(2637),
    [anon_sym_operator] = ACTIONS(2637),
    [anon_sym_try] = ACTIONS(2637),
    [anon_sym_delete] = ACTIONS(2637),
    [anon_sym_throw] = ACTIONS(2637),
    [anon_sym_namespace] = ACTIONS(2637),
    [anon_sym_using] = ACTIONS(2637),
    [anon_sym_static_assert] = ACTIONS(2637),
    [anon_sym_concept] = ACTIONS(2637),
    [anon_sym_co_return] = ACTIONS(2637),
    [anon_sym_co_yield] = ACTIONS(2637),
    [anon_sym_R_DQUOTE] = ACTIONS(2639),
    [anon_sym_LR_DQUOTE] = ACTIONS(2639),
    [anon_sym_uR_DQUOTE] = ACTIONS(2639),
    [anon_sym_UR_DQUOTE] = ACTIONS(2639),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2639),
    [anon_sym_co_await] = ACTIONS(2637),
    [anon_sym_new] = ACTIONS(2637),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2637),
  },
  [460] = {
    [sym_identifier] = ACTIONS(2637),
    [aux_sym_preproc_include_token1] = ACTIONS(2637),
    [aux_sym_preproc_def_token1] = ACTIONS(2637),
    [aux_sym_preproc_if_token1] = ACTIONS(2637),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2637),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2637),
    [sym_preproc_directive] = ACTIONS(2637),
    [anon_sym_LPAREN2] = ACTIONS(2639),
    [anon_sym_BANG] = ACTIONS(2639),
    [anon_sym_TILDE] = ACTIONS(2639),
    [anon_sym_DASH] = ACTIONS(2637),
    [anon_sym_PLUS] = ACTIONS(2637),
    [anon_sym_STAR] = ACTIONS(2639),
    [anon_sym_AMP_AMP] = ACTIONS(2639),
    [anon_sym_AMP] = ACTIONS(2637),
    [anon_sym_SEMI] = ACTIONS(2639),
    [anon_sym___extension__] = ACTIONS(2637),
    [anon_sym_typedef] = ACTIONS(2637),
    [anon_sym_virtual] = ACTIONS(2637),
    [anon_sym_extern] = ACTIONS(2637),
    [anon_sym___attribute__] = ACTIONS(2637),
    [anon_sym___attribute] = ACTIONS(2637),
    [anon_sym_COLON_COLON] = ACTIONS(2639),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2639),
    [anon_sym___declspec] = ACTIONS(2637),
    [anon_sym___based] = ACTIONS(2637),
    [anon_sym___cdecl] = ACTIONS(2637),
    [anon_sym___clrcall] = ACTIONS(2637),
    [anon_sym___stdcall] = ACTIONS(2637),
    [anon_sym___fastcall] = ACTIONS(2637),
    [anon_sym___thiscall] = ACTIONS(2637),
    [anon_sym___vectorcall] = ACTIONS(2637),
    [anon_sym_LBRACE] = ACTIONS(2639),
    [anon_sym_RBRACE] = ACTIONS(2639),
    [anon_sym_signed] = ACTIONS(2637),
    [anon_sym_unsigned] = ACTIONS(2637),
    [anon_sym_long] = ACTIONS(2637),
    [anon_sym_short] = ACTIONS(2637),
    [anon_sym_LBRACK] = ACTIONS(2637),
    [anon_sym_static] = ACTIONS(2637),
    [anon_sym_register] = ACTIONS(2637),
    [anon_sym_inline] = ACTIONS(2637),
    [anon_sym___inline] = ACTIONS(2637),
    [anon_sym___inline__] = ACTIONS(2637),
    [anon_sym___forceinline] = ACTIONS(2637),
    [anon_sym_thread_local] = ACTIONS(2637),
    [anon_sym___thread] = ACTIONS(2637),
    [anon_sym_const] = ACTIONS(2637),
    [anon_sym_constexpr] = ACTIONS(2637),
    [anon_sym_volatile] = ACTIONS(2637),
    [anon_sym_restrict] = ACTIONS(2637),
    [anon_sym___restrict__] = ACTIONS(2637),
    [anon_sym__Atomic] = ACTIONS(2637),
    [anon_sym__Noreturn] = ACTIONS(2637),
    [anon_sym_noreturn] = ACTIONS(2637),
    [anon_sym__Nonnull] = ACTIONS(2637),
    [anon_sym_mutable] = ACTIONS(2637),
    [anon_sym_constinit] = ACTIONS(2637),
    [anon_sym_consteval] = ACTIONS(2637),
    [anon_sym_alignas] = ACTIONS(2637),
    [anon_sym__Alignas] = ACTIONS(2637),
    [sym_primitive_type] = ACTIONS(2637),
    [anon_sym_enum] = ACTIONS(2637),
    [anon_sym_class] = ACTIONS(2637),
    [anon_sym_struct] = ACTIONS(2637),
    [anon_sym_union] = ACTIONS(2637),
    [anon_sym_if] = ACTIONS(2637),
    [anon_sym_else] = ACTIONS(2637),
    [anon_sym_switch] = ACTIONS(2637),
    [anon_sym_case] = ACTIONS(2637),
    [anon_sym_default] = ACTIONS(2637),
    [anon_sym_while] = ACTIONS(2637),
    [anon_sym_do] = ACTIONS(2637),
    [anon_sym_for] = ACTIONS(2637),
    [anon_sym_return] = ACTIONS(2637),
    [anon_sym_break] = ACTIONS(2637),
    [anon_sym_continue] = ACTIONS(2637),
    [anon_sym_goto] = ACTIONS(2637),
    [anon_sym___try] = ACTIONS(2637),
    [anon_sym___leave] = ACTIONS(2637),
    [anon_sym_not] = ACTIONS(2637),
    [anon_sym_compl] = ACTIONS(2637),
    [anon_sym_DASH_DASH] = ACTIONS(2639),
    [anon_sym_PLUS_PLUS] = ACTIONS(2639),
    [anon_sym_sizeof] = ACTIONS(2637),
    [anon_sym___alignof__] = ACTIONS(2637),
    [anon_sym___alignof] = ACTIONS(2637),
    [anon_sym__alignof] = ACTIONS(2637),
    [anon_sym_alignof] = ACTIONS(2637),
    [anon_sym__Alignof] = ACTIONS(2637),
    [anon_sym_offsetof] = ACTIONS(2637),
    [anon_sym__Generic] = ACTIONS(2637),
    [anon_sym_asm] = ACTIONS(2637),
    [anon_sym___asm__] = ACTIONS(2637),
    [anon_sym___asm] = ACTIONS(2637),
    [sym_number_literal] = ACTIONS(2639),
    [anon_sym_L_SQUOTE] = ACTIONS(2639),
    [anon_sym_u_SQUOTE] = ACTIONS(2639),
    [anon_sym_U_SQUOTE] = ACTIONS(2639),
    [anon_sym_u8_SQUOTE] = ACTIONS(2639),
    [anon_sym_SQUOTE] = ACTIONS(2639),
    [anon_sym_L_DQUOTE] = ACTIONS(2639),
    [anon_sym_u_DQUOTE] = ACTIONS(2639),
    [anon_sym_U_DQUOTE] = ACTIONS(2639),
    [anon_sym_u8_DQUOTE] = ACTIONS(2639),
    [anon_sym_DQUOTE] = ACTIONS(2639),
    [sym_true] = ACTIONS(2637),
    [sym_false] = ACTIONS(2637),
    [anon_sym_NULL] = ACTIONS(2637),
    [anon_sym_nullptr] = ACTIONS(2637),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2637),
    [anon_sym_decltype] = ACTIONS(2637),
    [anon_sym_explicit] = ACTIONS(2637),
    [anon_sym_typename] = ACTIONS(2637),
    [anon_sym_template] = ACTIONS(2637),
    [anon_sym_operator] = ACTIONS(2637),
    [anon_sym_try] = ACTIONS(2637),
    [anon_sym_delete] = ACTIONS(2637),
    [anon_sym_throw] = ACTIONS(2637),
    [anon_sym_namespace] = ACTIONS(2637),
    [anon_sym_using] = ACTIONS(2637),
    [anon_sym_static_assert] = ACTIONS(2637),
    [anon_sym_concept] = ACTIONS(2637),
    [anon_sym_co_return] = ACTIONS(2637),
    [anon_sym_co_yield] = ACTIONS(2637),
    [anon_sym_R_DQUOTE] = ACTIONS(2639),
    [anon_sym_LR_DQUOTE] = ACTIONS(2639),
    [anon_sym_uR_DQUOTE] = ACTIONS(2639),
    [anon_sym_UR_DQUOTE] = ACTIONS(2639),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2639),
    [anon_sym_co_await] = ACTIONS(2637),
    [anon_sym_new] = ACTIONS(2637),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2637),
  },
  [461] = {
    [ts_builtin_sym_end] = ACTIONS(2623),
    [sym_identifier] = ACTIONS(2621),
    [aux_sym_preproc_include_token1] = ACTIONS(2621),
    [aux_sym_preproc_def_token1] = ACTIONS(2621),
    [aux_sym_preproc_if_token1] = ACTIONS(2621),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2621),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2621),
    [sym_preproc_directive] = ACTIONS(2621),
    [anon_sym_LPAREN2] = ACTIONS(2623),
    [anon_sym_BANG] = ACTIONS(2623),
    [anon_sym_TILDE] = ACTIONS(2623),
    [anon_sym_DASH] = ACTIONS(2621),
    [anon_sym_PLUS] = ACTIONS(2621),
    [anon_sym_STAR] = ACTIONS(2623),
    [anon_sym_AMP_AMP] = ACTIONS(2623),
    [anon_sym_AMP] = ACTIONS(2621),
    [anon_sym_SEMI] = ACTIONS(2623),
    [anon_sym___extension__] = ACTIONS(2621),
    [anon_sym_typedef] = ACTIONS(2621),
    [anon_sym_virtual] = ACTIONS(2621),
    [anon_sym_extern] = ACTIONS(2621),
    [anon_sym___attribute__] = ACTIONS(2621),
    [anon_sym___attribute] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(2623),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2623),
    [anon_sym___declspec] = ACTIONS(2621),
    [anon_sym___based] = ACTIONS(2621),
    [anon_sym___cdecl] = ACTIONS(2621),
    [anon_sym___clrcall] = ACTIONS(2621),
    [anon_sym___stdcall] = ACTIONS(2621),
    [anon_sym___fastcall] = ACTIONS(2621),
    [anon_sym___thiscall] = ACTIONS(2621),
    [anon_sym___vectorcall] = ACTIONS(2621),
    [anon_sym_LBRACE] = ACTIONS(2623),
    [anon_sym_signed] = ACTIONS(2621),
    [anon_sym_unsigned] = ACTIONS(2621),
    [anon_sym_long] = ACTIONS(2621),
    [anon_sym_short] = ACTIONS(2621),
    [anon_sym_LBRACK] = ACTIONS(2621),
    [anon_sym_static] = ACTIONS(2621),
    [anon_sym_register] = ACTIONS(2621),
    [anon_sym_inline] = ACTIONS(2621),
    [anon_sym___inline] = ACTIONS(2621),
    [anon_sym___inline__] = ACTIONS(2621),
    [anon_sym___forceinline] = ACTIONS(2621),
    [anon_sym_thread_local] = ACTIONS(2621),
    [anon_sym___thread] = ACTIONS(2621),
    [anon_sym_const] = ACTIONS(2621),
    [anon_sym_constexpr] = ACTIONS(2621),
    [anon_sym_volatile] = ACTIONS(2621),
    [anon_sym_restrict] = ACTIONS(2621),
    [anon_sym___restrict__] = ACTIONS(2621),
    [anon_sym__Atomic] = ACTIONS(2621),
    [anon_sym__Noreturn] = ACTIONS(2621),
    [anon_sym_noreturn] = ACTIONS(2621),
    [anon_sym__Nonnull] = ACTIONS(2621),
    [anon_sym_mutable] = ACTIONS(2621),
    [anon_sym_constinit] = ACTIONS(2621),
    [anon_sym_consteval] = ACTIONS(2621),
    [anon_sym_alignas] = ACTIONS(2621),
    [anon_sym__Alignas] = ACTIONS(2621),
    [sym_primitive_type] = ACTIONS(2621),
    [anon_sym_enum] = ACTIONS(2621),
    [anon_sym_class] = ACTIONS(2621),
    [anon_sym_struct] = ACTIONS(2621),
    [anon_sym_union] = ACTIONS(2621),
    [anon_sym_if] = ACTIONS(2621),
    [anon_sym_else] = ACTIONS(2621),
    [anon_sym_switch] = ACTIONS(2621),
    [anon_sym_case] = ACTIONS(2621),
    [anon_sym_default] = ACTIONS(2621),
    [anon_sym_while] = ACTIONS(2621),
    [anon_sym_do] = ACTIONS(2621),
    [anon_sym_for] = ACTIONS(2621),
    [anon_sym_return] = ACTIONS(2621),
    [anon_sym_break] = ACTIONS(2621),
    [anon_sym_continue] = ACTIONS(2621),
    [anon_sym_goto] = ACTIONS(2621),
    [anon_sym___try] = ACTIONS(2621),
    [anon_sym___leave] = ACTIONS(2621),
    [anon_sym_not] = ACTIONS(2621),
    [anon_sym_compl] = ACTIONS(2621),
    [anon_sym_DASH_DASH] = ACTIONS(2623),
    [anon_sym_PLUS_PLUS] = ACTIONS(2623),
    [anon_sym_sizeof] = ACTIONS(2621),
    [anon_sym___alignof__] = ACTIONS(2621),
    [anon_sym___alignof] = ACTIONS(2621),
    [anon_sym__alignof] = ACTIONS(2621),
    [anon_sym_alignof] = ACTIONS(2621),
    [anon_sym__Alignof] = ACTIONS(2621),
    [anon_sym_offsetof] = ACTIONS(2621),
    [anon_sym__Generic] = ACTIONS(2621),
    [anon_sym_asm] = ACTIONS(2621),
    [anon_sym___asm__] = ACTIONS(2621),
    [anon_sym___asm] = ACTIONS(2621),
    [sym_number_literal] = ACTIONS(2623),
    [anon_sym_L_SQUOTE] = ACTIONS(2623),
    [anon_sym_u_SQUOTE] = ACTIONS(2623),
    [anon_sym_U_SQUOTE] = ACTIONS(2623),
    [anon_sym_u8_SQUOTE] = ACTIONS(2623),
    [anon_sym_SQUOTE] = ACTIONS(2623),
    [anon_sym_L_DQUOTE] = ACTIONS(2623),
    [anon_sym_u_DQUOTE] = ACTIONS(2623),
    [anon_sym_U_DQUOTE] = ACTIONS(2623),
    [anon_sym_u8_DQUOTE] = ACTIONS(2623),
    [anon_sym_DQUOTE] = ACTIONS(2623),
    [sym_true] = ACTIONS(2621),
    [sym_false] = ACTIONS(2621),
    [anon_sym_NULL] = ACTIONS(2621),
    [anon_sym_nullptr] = ACTIONS(2621),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2621),
    [anon_sym_decltype] = ACTIONS(2621),
    [anon_sym_explicit] = ACTIONS(2621),
    [anon_sym_typename] = ACTIONS(2621),
    [anon_sym_template] = ACTIONS(2621),
    [anon_sym_operator] = ACTIONS(2621),
    [anon_sym_try] = ACTIONS(2621),
    [anon_sym_delete] = ACTIONS(2621),
    [anon_sym_throw] = ACTIONS(2621),
    [anon_sym_namespace] = ACTIONS(2621),
    [anon_sym_using] = ACTIONS(2621),
    [anon_sym_static_assert] = ACTIONS(2621),
    [anon_sym_concept] = ACTIONS(2621),
    [anon_sym_co_return] = ACTIONS(2621),
    [anon_sym_co_yield] = ACTIONS(2621),
    [anon_sym_R_DQUOTE] = ACTIONS(2623),
    [anon_sym_LR_DQUOTE] = ACTIONS(2623),
    [anon_sym_uR_DQUOTE] = ACTIONS(2623),
    [anon_sym_UR_DQUOTE] = ACTIONS(2623),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2623),
    [anon_sym_co_await] = ACTIONS(2621),
    [anon_sym_new] = ACTIONS(2621),
    [anon_sym_requires] = ACTIONS(2621),
    [sym_this] = ACTIONS(2621),
  },
  [462] = {
    [sym_identifier] = ACTIONS(2593),
    [aux_sym_preproc_include_token1] = ACTIONS(2593),
    [aux_sym_preproc_def_token1] = ACTIONS(2593),
    [aux_sym_preproc_if_token1] = ACTIONS(2593),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2593),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2593),
    [sym_preproc_directive] = ACTIONS(2593),
    [anon_sym_LPAREN2] = ACTIONS(2595),
    [anon_sym_BANG] = ACTIONS(2595),
    [anon_sym_TILDE] = ACTIONS(2595),
    [anon_sym_DASH] = ACTIONS(2593),
    [anon_sym_PLUS] = ACTIONS(2593),
    [anon_sym_STAR] = ACTIONS(2595),
    [anon_sym_AMP_AMP] = ACTIONS(2595),
    [anon_sym_AMP] = ACTIONS(2593),
    [anon_sym_SEMI] = ACTIONS(2595),
    [anon_sym___extension__] = ACTIONS(2593),
    [anon_sym_typedef] = ACTIONS(2593),
    [anon_sym_virtual] = ACTIONS(2593),
    [anon_sym_extern] = ACTIONS(2593),
    [anon_sym___attribute__] = ACTIONS(2593),
    [anon_sym___attribute] = ACTIONS(2593),
    [anon_sym_COLON_COLON] = ACTIONS(2595),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2595),
    [anon_sym___declspec] = ACTIONS(2593),
    [anon_sym___based] = ACTIONS(2593),
    [anon_sym___cdecl] = ACTIONS(2593),
    [anon_sym___clrcall] = ACTIONS(2593),
    [anon_sym___stdcall] = ACTIONS(2593),
    [anon_sym___fastcall] = ACTIONS(2593),
    [anon_sym___thiscall] = ACTIONS(2593),
    [anon_sym___vectorcall] = ACTIONS(2593),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_RBRACE] = ACTIONS(2595),
    [anon_sym_signed] = ACTIONS(2593),
    [anon_sym_unsigned] = ACTIONS(2593),
    [anon_sym_long] = ACTIONS(2593),
    [anon_sym_short] = ACTIONS(2593),
    [anon_sym_LBRACK] = ACTIONS(2593),
    [anon_sym_static] = ACTIONS(2593),
    [anon_sym_register] = ACTIONS(2593),
    [anon_sym_inline] = ACTIONS(2593),
    [anon_sym___inline] = ACTIONS(2593),
    [anon_sym___inline__] = ACTIONS(2593),
    [anon_sym___forceinline] = ACTIONS(2593),
    [anon_sym_thread_local] = ACTIONS(2593),
    [anon_sym___thread] = ACTIONS(2593),
    [anon_sym_const] = ACTIONS(2593),
    [anon_sym_constexpr] = ACTIONS(2593),
    [anon_sym_volatile] = ACTIONS(2593),
    [anon_sym_restrict] = ACTIONS(2593),
    [anon_sym___restrict__] = ACTIONS(2593),
    [anon_sym__Atomic] = ACTIONS(2593),
    [anon_sym__Noreturn] = ACTIONS(2593),
    [anon_sym_noreturn] = ACTIONS(2593),
    [anon_sym__Nonnull] = ACTIONS(2593),
    [anon_sym_mutable] = ACTIONS(2593),
    [anon_sym_constinit] = ACTIONS(2593),
    [anon_sym_consteval] = ACTIONS(2593),
    [anon_sym_alignas] = ACTIONS(2593),
    [anon_sym__Alignas] = ACTIONS(2593),
    [sym_primitive_type] = ACTIONS(2593),
    [anon_sym_enum] = ACTIONS(2593),
    [anon_sym_class] = ACTIONS(2593),
    [anon_sym_struct] = ACTIONS(2593),
    [anon_sym_union] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2593),
    [anon_sym_else] = ACTIONS(2593),
    [anon_sym_switch] = ACTIONS(2593),
    [anon_sym_case] = ACTIONS(2593),
    [anon_sym_default] = ACTIONS(2593),
    [anon_sym_while] = ACTIONS(2593),
    [anon_sym_do] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2593),
    [anon_sym_return] = ACTIONS(2593),
    [anon_sym_break] = ACTIONS(2593),
    [anon_sym_continue] = ACTIONS(2593),
    [anon_sym_goto] = ACTIONS(2593),
    [anon_sym___try] = ACTIONS(2593),
    [anon_sym___leave] = ACTIONS(2593),
    [anon_sym_not] = ACTIONS(2593),
    [anon_sym_compl] = ACTIONS(2593),
    [anon_sym_DASH_DASH] = ACTIONS(2595),
    [anon_sym_PLUS_PLUS] = ACTIONS(2595),
    [anon_sym_sizeof] = ACTIONS(2593),
    [anon_sym___alignof__] = ACTIONS(2593),
    [anon_sym___alignof] = ACTIONS(2593),
    [anon_sym__alignof] = ACTIONS(2593),
    [anon_sym_alignof] = ACTIONS(2593),
    [anon_sym__Alignof] = ACTIONS(2593),
    [anon_sym_offsetof] = ACTIONS(2593),
    [anon_sym__Generic] = ACTIONS(2593),
    [anon_sym_asm] = ACTIONS(2593),
    [anon_sym___asm__] = ACTIONS(2593),
    [anon_sym___asm] = ACTIONS(2593),
    [sym_number_literal] = ACTIONS(2595),
    [anon_sym_L_SQUOTE] = ACTIONS(2595),
    [anon_sym_u_SQUOTE] = ACTIONS(2595),
    [anon_sym_U_SQUOTE] = ACTIONS(2595),
    [anon_sym_u8_SQUOTE] = ACTIONS(2595),
    [anon_sym_SQUOTE] = ACTIONS(2595),
    [anon_sym_L_DQUOTE] = ACTIONS(2595),
    [anon_sym_u_DQUOTE] = ACTIONS(2595),
    [anon_sym_U_DQUOTE] = ACTIONS(2595),
    [anon_sym_u8_DQUOTE] = ACTIONS(2595),
    [anon_sym_DQUOTE] = ACTIONS(2595),
    [sym_true] = ACTIONS(2593),
    [sym_false] = ACTIONS(2593),
    [anon_sym_NULL] = ACTIONS(2593),
    [anon_sym_nullptr] = ACTIONS(2593),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2593),
    [anon_sym_decltype] = ACTIONS(2593),
    [anon_sym_explicit] = ACTIONS(2593),
    [anon_sym_typename] = ACTIONS(2593),
    [anon_sym_template] = ACTIONS(2593),
    [anon_sym_operator] = ACTIONS(2593),
    [anon_sym_try] = ACTIONS(2593),
    [anon_sym_delete] = ACTIONS(2593),
    [anon_sym_throw] = ACTIONS(2593),
    [anon_sym_namespace] = ACTIONS(2593),
    [anon_sym_using] = ACTIONS(2593),
    [anon_sym_static_assert] = ACTIONS(2593),
    [anon_sym_concept] = ACTIONS(2593),
    [anon_sym_co_return] = ACTIONS(2593),
    [anon_sym_co_yield] = ACTIONS(2593),
    [anon_sym_R_DQUOTE] = ACTIONS(2595),
    [anon_sym_LR_DQUOTE] = ACTIONS(2595),
    [anon_sym_uR_DQUOTE] = ACTIONS(2595),
    [anon_sym_UR_DQUOTE] = ACTIONS(2595),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2595),
    [anon_sym_co_await] = ACTIONS(2593),
    [anon_sym_new] = ACTIONS(2593),
    [anon_sym_requires] = ACTIONS(2593),
    [sym_this] = ACTIONS(2593),
  },
  [463] = {
    [ts_builtin_sym_end] = ACTIONS(2635),
    [sym_identifier] = ACTIONS(2633),
    [aux_sym_preproc_include_token1] = ACTIONS(2633),
    [aux_sym_preproc_def_token1] = ACTIONS(2633),
    [aux_sym_preproc_if_token1] = ACTIONS(2633),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2633),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2633),
    [sym_preproc_directive] = ACTIONS(2633),
    [anon_sym_LPAREN2] = ACTIONS(2635),
    [anon_sym_BANG] = ACTIONS(2635),
    [anon_sym_TILDE] = ACTIONS(2635),
    [anon_sym_DASH] = ACTIONS(2633),
    [anon_sym_PLUS] = ACTIONS(2633),
    [anon_sym_STAR] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2635),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_SEMI] = ACTIONS(2635),
    [anon_sym___extension__] = ACTIONS(2633),
    [anon_sym_typedef] = ACTIONS(2633),
    [anon_sym_virtual] = ACTIONS(2633),
    [anon_sym_extern] = ACTIONS(2633),
    [anon_sym___attribute__] = ACTIONS(2633),
    [anon_sym___attribute] = ACTIONS(2633),
    [anon_sym_COLON_COLON] = ACTIONS(2635),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2635),
    [anon_sym___declspec] = ACTIONS(2633),
    [anon_sym___based] = ACTIONS(2633),
    [anon_sym___cdecl] = ACTIONS(2633),
    [anon_sym___clrcall] = ACTIONS(2633),
    [anon_sym___stdcall] = ACTIONS(2633),
    [anon_sym___fastcall] = ACTIONS(2633),
    [anon_sym___thiscall] = ACTIONS(2633),
    [anon_sym___vectorcall] = ACTIONS(2633),
    [anon_sym_LBRACE] = ACTIONS(2635),
    [anon_sym_signed] = ACTIONS(2633),
    [anon_sym_unsigned] = ACTIONS(2633),
    [anon_sym_long] = ACTIONS(2633),
    [anon_sym_short] = ACTIONS(2633),
    [anon_sym_LBRACK] = ACTIONS(2633),
    [anon_sym_static] = ACTIONS(2633),
    [anon_sym_register] = ACTIONS(2633),
    [anon_sym_inline] = ACTIONS(2633),
    [anon_sym___inline] = ACTIONS(2633),
    [anon_sym___inline__] = ACTIONS(2633),
    [anon_sym___forceinline] = ACTIONS(2633),
    [anon_sym_thread_local] = ACTIONS(2633),
    [anon_sym___thread] = ACTIONS(2633),
    [anon_sym_const] = ACTIONS(2633),
    [anon_sym_constexpr] = ACTIONS(2633),
    [anon_sym_volatile] = ACTIONS(2633),
    [anon_sym_restrict] = ACTIONS(2633),
    [anon_sym___restrict__] = ACTIONS(2633),
    [anon_sym__Atomic] = ACTIONS(2633),
    [anon_sym__Noreturn] = ACTIONS(2633),
    [anon_sym_noreturn] = ACTIONS(2633),
    [anon_sym__Nonnull] = ACTIONS(2633),
    [anon_sym_mutable] = ACTIONS(2633),
    [anon_sym_constinit] = ACTIONS(2633),
    [anon_sym_consteval] = ACTIONS(2633),
    [anon_sym_alignas] = ACTIONS(2633),
    [anon_sym__Alignas] = ACTIONS(2633),
    [sym_primitive_type] = ACTIONS(2633),
    [anon_sym_enum] = ACTIONS(2633),
    [anon_sym_class] = ACTIONS(2633),
    [anon_sym_struct] = ACTIONS(2633),
    [anon_sym_union] = ACTIONS(2633),
    [anon_sym_if] = ACTIONS(2633),
    [anon_sym_else] = ACTIONS(2633),
    [anon_sym_switch] = ACTIONS(2633),
    [anon_sym_case] = ACTIONS(2633),
    [anon_sym_default] = ACTIONS(2633),
    [anon_sym_while] = ACTIONS(2633),
    [anon_sym_do] = ACTIONS(2633),
    [anon_sym_for] = ACTIONS(2633),
    [anon_sym_return] = ACTIONS(2633),
    [anon_sym_break] = ACTIONS(2633),
    [anon_sym_continue] = ACTIONS(2633),
    [anon_sym_goto] = ACTIONS(2633),
    [anon_sym___try] = ACTIONS(2633),
    [anon_sym___leave] = ACTIONS(2633),
    [anon_sym_not] = ACTIONS(2633),
    [anon_sym_compl] = ACTIONS(2633),
    [anon_sym_DASH_DASH] = ACTIONS(2635),
    [anon_sym_PLUS_PLUS] = ACTIONS(2635),
    [anon_sym_sizeof] = ACTIONS(2633),
    [anon_sym___alignof__] = ACTIONS(2633),
    [anon_sym___alignof] = ACTIONS(2633),
    [anon_sym__alignof] = ACTIONS(2633),
    [anon_sym_alignof] = ACTIONS(2633),
    [anon_sym__Alignof] = ACTIONS(2633),
    [anon_sym_offsetof] = ACTIONS(2633),
    [anon_sym__Generic] = ACTIONS(2633),
    [anon_sym_asm] = ACTIONS(2633),
    [anon_sym___asm__] = ACTIONS(2633),
    [anon_sym___asm] = ACTIONS(2633),
    [sym_number_literal] = ACTIONS(2635),
    [anon_sym_L_SQUOTE] = ACTIONS(2635),
    [anon_sym_u_SQUOTE] = ACTIONS(2635),
    [anon_sym_U_SQUOTE] = ACTIONS(2635),
    [anon_sym_u8_SQUOTE] = ACTIONS(2635),
    [anon_sym_SQUOTE] = ACTIONS(2635),
    [anon_sym_L_DQUOTE] = ACTIONS(2635),
    [anon_sym_u_DQUOTE] = ACTIONS(2635),
    [anon_sym_U_DQUOTE] = ACTIONS(2635),
    [anon_sym_u8_DQUOTE] = ACTIONS(2635),
    [anon_sym_DQUOTE] = ACTIONS(2635),
    [sym_true] = ACTIONS(2633),
    [sym_false] = ACTIONS(2633),
    [anon_sym_NULL] = ACTIONS(2633),
    [anon_sym_nullptr] = ACTIONS(2633),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2633),
    [anon_sym_decltype] = ACTIONS(2633),
    [anon_sym_explicit] = ACTIONS(2633),
    [anon_sym_typename] = ACTIONS(2633),
    [anon_sym_template] = ACTIONS(2633),
    [anon_sym_operator] = ACTIONS(2633),
    [anon_sym_try] = ACTIONS(2633),
    [anon_sym_delete] = ACTIONS(2633),
    [anon_sym_throw] = ACTIONS(2633),
    [anon_sym_namespace] = ACTIONS(2633),
    [anon_sym_using] = ACTIONS(2633),
    [anon_sym_static_assert] = ACTIONS(2633),
    [anon_sym_concept] = ACTIONS(2633),
    [anon_sym_co_return] = ACTIONS(2633),
    [anon_sym_co_yield] = ACTIONS(2633),
    [anon_sym_R_DQUOTE] = ACTIONS(2635),
    [anon_sym_LR_DQUOTE] = ACTIONS(2635),
    [anon_sym_uR_DQUOTE] = ACTIONS(2635),
    [anon_sym_UR_DQUOTE] = ACTIONS(2635),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2635),
    [anon_sym_co_await] = ACTIONS(2633),
    [anon_sym_new] = ACTIONS(2633),
    [anon_sym_requires] = ACTIONS(2633),
    [sym_this] = ACTIONS(2633),
  },
  [464] = {
    [ts_builtin_sym_end] = ACTIONS(2639),
    [sym_identifier] = ACTIONS(2637),
    [aux_sym_preproc_include_token1] = ACTIONS(2637),
    [aux_sym_preproc_def_token1] = ACTIONS(2637),
    [aux_sym_preproc_if_token1] = ACTIONS(2637),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2637),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2637),
    [sym_preproc_directive] = ACTIONS(2637),
    [anon_sym_LPAREN2] = ACTIONS(2639),
    [anon_sym_BANG] = ACTIONS(2639),
    [anon_sym_TILDE] = ACTIONS(2639),
    [anon_sym_DASH] = ACTIONS(2637),
    [anon_sym_PLUS] = ACTIONS(2637),
    [anon_sym_STAR] = ACTIONS(2639),
    [anon_sym_AMP_AMP] = ACTIONS(2639),
    [anon_sym_AMP] = ACTIONS(2637),
    [anon_sym_SEMI] = ACTIONS(2639),
    [anon_sym___extension__] = ACTIONS(2637),
    [anon_sym_typedef] = ACTIONS(2637),
    [anon_sym_virtual] = ACTIONS(2637),
    [anon_sym_extern] = ACTIONS(2637),
    [anon_sym___attribute__] = ACTIONS(2637),
    [anon_sym___attribute] = ACTIONS(2637),
    [anon_sym_COLON_COLON] = ACTIONS(2639),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2639),
    [anon_sym___declspec] = ACTIONS(2637),
    [anon_sym___based] = ACTIONS(2637),
    [anon_sym___cdecl] = ACTIONS(2637),
    [anon_sym___clrcall] = ACTIONS(2637),
    [anon_sym___stdcall] = ACTIONS(2637),
    [anon_sym___fastcall] = ACTIONS(2637),
    [anon_sym___thiscall] = ACTIONS(2637),
    [anon_sym___vectorcall] = ACTIONS(2637),
    [anon_sym_LBRACE] = ACTIONS(2639),
    [anon_sym_signed] = ACTIONS(2637),
    [anon_sym_unsigned] = ACTIONS(2637),
    [anon_sym_long] = ACTIONS(2637),
    [anon_sym_short] = ACTIONS(2637),
    [anon_sym_LBRACK] = ACTIONS(2637),
    [anon_sym_static] = ACTIONS(2637),
    [anon_sym_register] = ACTIONS(2637),
    [anon_sym_inline] = ACTIONS(2637),
    [anon_sym___inline] = ACTIONS(2637),
    [anon_sym___inline__] = ACTIONS(2637),
    [anon_sym___forceinline] = ACTIONS(2637),
    [anon_sym_thread_local] = ACTIONS(2637),
    [anon_sym___thread] = ACTIONS(2637),
    [anon_sym_const] = ACTIONS(2637),
    [anon_sym_constexpr] = ACTIONS(2637),
    [anon_sym_volatile] = ACTIONS(2637),
    [anon_sym_restrict] = ACTIONS(2637),
    [anon_sym___restrict__] = ACTIONS(2637),
    [anon_sym__Atomic] = ACTIONS(2637),
    [anon_sym__Noreturn] = ACTIONS(2637),
    [anon_sym_noreturn] = ACTIONS(2637),
    [anon_sym__Nonnull] = ACTIONS(2637),
    [anon_sym_mutable] = ACTIONS(2637),
    [anon_sym_constinit] = ACTIONS(2637),
    [anon_sym_consteval] = ACTIONS(2637),
    [anon_sym_alignas] = ACTIONS(2637),
    [anon_sym__Alignas] = ACTIONS(2637),
    [sym_primitive_type] = ACTIONS(2637),
    [anon_sym_enum] = ACTIONS(2637),
    [anon_sym_class] = ACTIONS(2637),
    [anon_sym_struct] = ACTIONS(2637),
    [anon_sym_union] = ACTIONS(2637),
    [anon_sym_if] = ACTIONS(2637),
    [anon_sym_else] = ACTIONS(2637),
    [anon_sym_switch] = ACTIONS(2637),
    [anon_sym_case] = ACTIONS(2637),
    [anon_sym_default] = ACTIONS(2637),
    [anon_sym_while] = ACTIONS(2637),
    [anon_sym_do] = ACTIONS(2637),
    [anon_sym_for] = ACTIONS(2637),
    [anon_sym_return] = ACTIONS(2637),
    [anon_sym_break] = ACTIONS(2637),
    [anon_sym_continue] = ACTIONS(2637),
    [anon_sym_goto] = ACTIONS(2637),
    [anon_sym___try] = ACTIONS(2637),
    [anon_sym___leave] = ACTIONS(2637),
    [anon_sym_not] = ACTIONS(2637),
    [anon_sym_compl] = ACTIONS(2637),
    [anon_sym_DASH_DASH] = ACTIONS(2639),
    [anon_sym_PLUS_PLUS] = ACTIONS(2639),
    [anon_sym_sizeof] = ACTIONS(2637),
    [anon_sym___alignof__] = ACTIONS(2637),
    [anon_sym___alignof] = ACTIONS(2637),
    [anon_sym__alignof] = ACTIONS(2637),
    [anon_sym_alignof] = ACTIONS(2637),
    [anon_sym__Alignof] = ACTIONS(2637),
    [anon_sym_offsetof] = ACTIONS(2637),
    [anon_sym__Generic] = ACTIONS(2637),
    [anon_sym_asm] = ACTIONS(2637),
    [anon_sym___asm__] = ACTIONS(2637),
    [anon_sym___asm] = ACTIONS(2637),
    [sym_number_literal] = ACTIONS(2639),
    [anon_sym_L_SQUOTE] = ACTIONS(2639),
    [anon_sym_u_SQUOTE] = ACTIONS(2639),
    [anon_sym_U_SQUOTE] = ACTIONS(2639),
    [anon_sym_u8_SQUOTE] = ACTIONS(2639),
    [anon_sym_SQUOTE] = ACTIONS(2639),
    [anon_sym_L_DQUOTE] = ACTIONS(2639),
    [anon_sym_u_DQUOTE] = ACTIONS(2639),
    [anon_sym_U_DQUOTE] = ACTIONS(2639),
    [anon_sym_u8_DQUOTE] = ACTIONS(2639),
    [anon_sym_DQUOTE] = ACTIONS(2639),
    [sym_true] = ACTIONS(2637),
    [sym_false] = ACTIONS(2637),
    [anon_sym_NULL] = ACTIONS(2637),
    [anon_sym_nullptr] = ACTIONS(2637),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2637),
    [anon_sym_decltype] = ACTIONS(2637),
    [anon_sym_explicit] = ACTIONS(2637),
    [anon_sym_typename] = ACTIONS(2637),
    [anon_sym_template] = ACTIONS(2637),
    [anon_sym_operator] = ACTIONS(2637),
    [anon_sym_try] = ACTIONS(2637),
    [anon_sym_delete] = ACTIONS(2637),
    [anon_sym_throw] = ACTIONS(2637),
    [anon_sym_namespace] = ACTIONS(2637),
    [anon_sym_using] = ACTIONS(2637),
    [anon_sym_static_assert] = ACTIONS(2637),
    [anon_sym_concept] = ACTIONS(2637),
    [anon_sym_co_return] = ACTIONS(2637),
    [anon_sym_co_yield] = ACTIONS(2637),
    [anon_sym_R_DQUOTE] = ACTIONS(2639),
    [anon_sym_LR_DQUOTE] = ACTIONS(2639),
    [anon_sym_uR_DQUOTE] = ACTIONS(2639),
    [anon_sym_UR_DQUOTE] = ACTIONS(2639),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2639),
    [anon_sym_co_await] = ACTIONS(2637),
    [anon_sym_new] = ACTIONS(2637),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2637),
  },
  [465] = {
    [ts_builtin_sym_end] = ACTIONS(2639),
    [sym_identifier] = ACTIONS(2637),
    [aux_sym_preproc_include_token1] = ACTIONS(2637),
    [aux_sym_preproc_def_token1] = ACTIONS(2637),
    [aux_sym_preproc_if_token1] = ACTIONS(2637),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2637),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2637),
    [sym_preproc_directive] = ACTIONS(2637),
    [anon_sym_LPAREN2] = ACTIONS(2639),
    [anon_sym_BANG] = ACTIONS(2639),
    [anon_sym_TILDE] = ACTIONS(2639),
    [anon_sym_DASH] = ACTIONS(2637),
    [anon_sym_PLUS] = ACTIONS(2637),
    [anon_sym_STAR] = ACTIONS(2639),
    [anon_sym_AMP_AMP] = ACTIONS(2639),
    [anon_sym_AMP] = ACTIONS(2637),
    [anon_sym_SEMI] = ACTIONS(2639),
    [anon_sym___extension__] = ACTIONS(2637),
    [anon_sym_typedef] = ACTIONS(2637),
    [anon_sym_virtual] = ACTIONS(2637),
    [anon_sym_extern] = ACTIONS(2637),
    [anon_sym___attribute__] = ACTIONS(2637),
    [anon_sym___attribute] = ACTIONS(2637),
    [anon_sym_COLON_COLON] = ACTIONS(2639),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2639),
    [anon_sym___declspec] = ACTIONS(2637),
    [anon_sym___based] = ACTIONS(2637),
    [anon_sym___cdecl] = ACTIONS(2637),
    [anon_sym___clrcall] = ACTIONS(2637),
    [anon_sym___stdcall] = ACTIONS(2637),
    [anon_sym___fastcall] = ACTIONS(2637),
    [anon_sym___thiscall] = ACTIONS(2637),
    [anon_sym___vectorcall] = ACTIONS(2637),
    [anon_sym_LBRACE] = ACTIONS(2639),
    [anon_sym_signed] = ACTIONS(2637),
    [anon_sym_unsigned] = ACTIONS(2637),
    [anon_sym_long] = ACTIONS(2637),
    [anon_sym_short] = ACTIONS(2637),
    [anon_sym_LBRACK] = ACTIONS(2637),
    [anon_sym_static] = ACTIONS(2637),
    [anon_sym_register] = ACTIONS(2637),
    [anon_sym_inline] = ACTIONS(2637),
    [anon_sym___inline] = ACTIONS(2637),
    [anon_sym___inline__] = ACTIONS(2637),
    [anon_sym___forceinline] = ACTIONS(2637),
    [anon_sym_thread_local] = ACTIONS(2637),
    [anon_sym___thread] = ACTIONS(2637),
    [anon_sym_const] = ACTIONS(2637),
    [anon_sym_constexpr] = ACTIONS(2637),
    [anon_sym_volatile] = ACTIONS(2637),
    [anon_sym_restrict] = ACTIONS(2637),
    [anon_sym___restrict__] = ACTIONS(2637),
    [anon_sym__Atomic] = ACTIONS(2637),
    [anon_sym__Noreturn] = ACTIONS(2637),
    [anon_sym_noreturn] = ACTIONS(2637),
    [anon_sym__Nonnull] = ACTIONS(2637),
    [anon_sym_mutable] = ACTIONS(2637),
    [anon_sym_constinit] = ACTIONS(2637),
    [anon_sym_consteval] = ACTIONS(2637),
    [anon_sym_alignas] = ACTIONS(2637),
    [anon_sym__Alignas] = ACTIONS(2637),
    [sym_primitive_type] = ACTIONS(2637),
    [anon_sym_enum] = ACTIONS(2637),
    [anon_sym_class] = ACTIONS(2637),
    [anon_sym_struct] = ACTIONS(2637),
    [anon_sym_union] = ACTIONS(2637),
    [anon_sym_if] = ACTIONS(2637),
    [anon_sym_else] = ACTIONS(2637),
    [anon_sym_switch] = ACTIONS(2637),
    [anon_sym_case] = ACTIONS(2637),
    [anon_sym_default] = ACTIONS(2637),
    [anon_sym_while] = ACTIONS(2637),
    [anon_sym_do] = ACTIONS(2637),
    [anon_sym_for] = ACTIONS(2637),
    [anon_sym_return] = ACTIONS(2637),
    [anon_sym_break] = ACTIONS(2637),
    [anon_sym_continue] = ACTIONS(2637),
    [anon_sym_goto] = ACTIONS(2637),
    [anon_sym___try] = ACTIONS(2637),
    [anon_sym___leave] = ACTIONS(2637),
    [anon_sym_not] = ACTIONS(2637),
    [anon_sym_compl] = ACTIONS(2637),
    [anon_sym_DASH_DASH] = ACTIONS(2639),
    [anon_sym_PLUS_PLUS] = ACTIONS(2639),
    [anon_sym_sizeof] = ACTIONS(2637),
    [anon_sym___alignof__] = ACTIONS(2637),
    [anon_sym___alignof] = ACTIONS(2637),
    [anon_sym__alignof] = ACTIONS(2637),
    [anon_sym_alignof] = ACTIONS(2637),
    [anon_sym__Alignof] = ACTIONS(2637),
    [anon_sym_offsetof] = ACTIONS(2637),
    [anon_sym__Generic] = ACTIONS(2637),
    [anon_sym_asm] = ACTIONS(2637),
    [anon_sym___asm__] = ACTIONS(2637),
    [anon_sym___asm] = ACTIONS(2637),
    [sym_number_literal] = ACTIONS(2639),
    [anon_sym_L_SQUOTE] = ACTIONS(2639),
    [anon_sym_u_SQUOTE] = ACTIONS(2639),
    [anon_sym_U_SQUOTE] = ACTIONS(2639),
    [anon_sym_u8_SQUOTE] = ACTIONS(2639),
    [anon_sym_SQUOTE] = ACTIONS(2639),
    [anon_sym_L_DQUOTE] = ACTIONS(2639),
    [anon_sym_u_DQUOTE] = ACTIONS(2639),
    [anon_sym_U_DQUOTE] = ACTIONS(2639),
    [anon_sym_u8_DQUOTE] = ACTIONS(2639),
    [anon_sym_DQUOTE] = ACTIONS(2639),
    [sym_true] = ACTIONS(2637),
    [sym_false] = ACTIONS(2637),
    [anon_sym_NULL] = ACTIONS(2637),
    [anon_sym_nullptr] = ACTIONS(2637),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2637),
    [anon_sym_decltype] = ACTIONS(2637),
    [anon_sym_explicit] = ACTIONS(2637),
    [anon_sym_typename] = ACTIONS(2637),
    [anon_sym_template] = ACTIONS(2637),
    [anon_sym_operator] = ACTIONS(2637),
    [anon_sym_try] = ACTIONS(2637),
    [anon_sym_delete] = ACTIONS(2637),
    [anon_sym_throw] = ACTIONS(2637),
    [anon_sym_namespace] = ACTIONS(2637),
    [anon_sym_using] = ACTIONS(2637),
    [anon_sym_static_assert] = ACTIONS(2637),
    [anon_sym_concept] = ACTIONS(2637),
    [anon_sym_co_return] = ACTIONS(2637),
    [anon_sym_co_yield] = ACTIONS(2637),
    [anon_sym_R_DQUOTE] = ACTIONS(2639),
    [anon_sym_LR_DQUOTE] = ACTIONS(2639),
    [anon_sym_uR_DQUOTE] = ACTIONS(2639),
    [anon_sym_UR_DQUOTE] = ACTIONS(2639),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2639),
    [anon_sym_co_await] = ACTIONS(2637),
    [anon_sym_new] = ACTIONS(2637),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2637),
  },
  [466] = {
    [sym_catch_clause] = STATE(319),
    [aux_sym_constructor_try_statement_repeat1] = STATE(319),
    [ts_builtin_sym_end] = ACTIONS(2512),
    [sym_identifier] = ACTIONS(2510),
    [aux_sym_preproc_include_token1] = ACTIONS(2510),
    [aux_sym_preproc_def_token1] = ACTIONS(2510),
    [aux_sym_preproc_if_token1] = ACTIONS(2510),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2510),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2510),
    [sym_preproc_directive] = ACTIONS(2510),
    [anon_sym_LPAREN2] = ACTIONS(2512),
    [anon_sym_BANG] = ACTIONS(2512),
    [anon_sym_TILDE] = ACTIONS(2512),
    [anon_sym_DASH] = ACTIONS(2510),
    [anon_sym_PLUS] = ACTIONS(2510),
    [anon_sym_STAR] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2510),
    [anon_sym_SEMI] = ACTIONS(2512),
    [anon_sym___extension__] = ACTIONS(2510),
    [anon_sym_typedef] = ACTIONS(2510),
    [anon_sym_virtual] = ACTIONS(2510),
    [anon_sym_extern] = ACTIONS(2510),
    [anon_sym___attribute__] = ACTIONS(2510),
    [anon_sym___attribute] = ACTIONS(2510),
    [anon_sym_COLON_COLON] = ACTIONS(2512),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2512),
    [anon_sym___declspec] = ACTIONS(2510),
    [anon_sym___based] = ACTIONS(2510),
    [anon_sym___cdecl] = ACTIONS(2510),
    [anon_sym___clrcall] = ACTIONS(2510),
    [anon_sym___stdcall] = ACTIONS(2510),
    [anon_sym___fastcall] = ACTIONS(2510),
    [anon_sym___thiscall] = ACTIONS(2510),
    [anon_sym___vectorcall] = ACTIONS(2510),
    [anon_sym_LBRACE] = ACTIONS(2512),
    [anon_sym_signed] = ACTIONS(2510),
    [anon_sym_unsigned] = ACTIONS(2510),
    [anon_sym_long] = ACTIONS(2510),
    [anon_sym_short] = ACTIONS(2510),
    [anon_sym_LBRACK] = ACTIONS(2510),
    [anon_sym_static] = ACTIONS(2510),
    [anon_sym_register] = ACTIONS(2510),
    [anon_sym_inline] = ACTIONS(2510),
    [anon_sym___inline] = ACTIONS(2510),
    [anon_sym___inline__] = ACTIONS(2510),
    [anon_sym___forceinline] = ACTIONS(2510),
    [anon_sym_thread_local] = ACTIONS(2510),
    [anon_sym___thread] = ACTIONS(2510),
    [anon_sym_const] = ACTIONS(2510),
    [anon_sym_constexpr] = ACTIONS(2510),
    [anon_sym_volatile] = ACTIONS(2510),
    [anon_sym_restrict] = ACTIONS(2510),
    [anon_sym___restrict__] = ACTIONS(2510),
    [anon_sym__Atomic] = ACTIONS(2510),
    [anon_sym__Noreturn] = ACTIONS(2510),
    [anon_sym_noreturn] = ACTIONS(2510),
    [anon_sym__Nonnull] = ACTIONS(2510),
    [anon_sym_mutable] = ACTIONS(2510),
    [anon_sym_constinit] = ACTIONS(2510),
    [anon_sym_consteval] = ACTIONS(2510),
    [anon_sym_alignas] = ACTIONS(2510),
    [anon_sym__Alignas] = ACTIONS(2510),
    [sym_primitive_type] = ACTIONS(2510),
    [anon_sym_enum] = ACTIONS(2510),
    [anon_sym_class] = ACTIONS(2510),
    [anon_sym_struct] = ACTIONS(2510),
    [anon_sym_union] = ACTIONS(2510),
    [anon_sym_if] = ACTIONS(2510),
    [anon_sym_switch] = ACTIONS(2510),
    [anon_sym_case] = ACTIONS(2510),
    [anon_sym_default] = ACTIONS(2510),
    [anon_sym_while] = ACTIONS(2510),
    [anon_sym_do] = ACTIONS(2510),
    [anon_sym_for] = ACTIONS(2510),
    [anon_sym_return] = ACTIONS(2510),
    [anon_sym_break] = ACTIONS(2510),
    [anon_sym_continue] = ACTIONS(2510),
    [anon_sym_goto] = ACTIONS(2510),
    [anon_sym_not] = ACTIONS(2510),
    [anon_sym_compl] = ACTIONS(2510),
    [anon_sym_DASH_DASH] = ACTIONS(2512),
    [anon_sym_PLUS_PLUS] = ACTIONS(2512),
    [anon_sym_sizeof] = ACTIONS(2510),
    [anon_sym___alignof__] = ACTIONS(2510),
    [anon_sym___alignof] = ACTIONS(2510),
    [anon_sym__alignof] = ACTIONS(2510),
    [anon_sym_alignof] = ACTIONS(2510),
    [anon_sym__Alignof] = ACTIONS(2510),
    [anon_sym_offsetof] = ACTIONS(2510),
    [anon_sym__Generic] = ACTIONS(2510),
    [anon_sym_asm] = ACTIONS(2510),
    [anon_sym___asm__] = ACTIONS(2510),
    [anon_sym___asm] = ACTIONS(2510),
    [sym_number_literal] = ACTIONS(2512),
    [anon_sym_L_SQUOTE] = ACTIONS(2512),
    [anon_sym_u_SQUOTE] = ACTIONS(2512),
    [anon_sym_U_SQUOTE] = ACTIONS(2512),
    [anon_sym_u8_SQUOTE] = ACTIONS(2512),
    [anon_sym_SQUOTE] = ACTIONS(2512),
    [anon_sym_L_DQUOTE] = ACTIONS(2512),
    [anon_sym_u_DQUOTE] = ACTIONS(2512),
    [anon_sym_U_DQUOTE] = ACTIONS(2512),
    [anon_sym_u8_DQUOTE] = ACTIONS(2512),
    [anon_sym_DQUOTE] = ACTIONS(2512),
    [sym_true] = ACTIONS(2510),
    [sym_false] = ACTIONS(2510),
    [anon_sym_NULL] = ACTIONS(2510),
    [anon_sym_nullptr] = ACTIONS(2510),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2510),
    [anon_sym_decltype] = ACTIONS(2510),
    [anon_sym_explicit] = ACTIONS(2510),
    [anon_sym_typename] = ACTIONS(2510),
    [anon_sym_template] = ACTIONS(2510),
    [anon_sym_operator] = ACTIONS(2510),
    [anon_sym_try] = ACTIONS(2510),
    [anon_sym_delete] = ACTIONS(2510),
    [anon_sym_throw] = ACTIONS(2510),
    [anon_sym_namespace] = ACTIONS(2510),
    [anon_sym_using] = ACTIONS(2510),
    [anon_sym_static_assert] = ACTIONS(2510),
    [anon_sym_concept] = ACTIONS(2510),
    [anon_sym_co_return] = ACTIONS(2510),
    [anon_sym_co_yield] = ACTIONS(2510),
    [anon_sym_catch] = ACTIONS(2813),
    [anon_sym_R_DQUOTE] = ACTIONS(2512),
    [anon_sym_LR_DQUOTE] = ACTIONS(2512),
    [anon_sym_uR_DQUOTE] = ACTIONS(2512),
    [anon_sym_UR_DQUOTE] = ACTIONS(2512),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2512),
    [anon_sym_co_await] = ACTIONS(2510),
    [anon_sym_new] = ACTIONS(2510),
    [anon_sym_requires] = ACTIONS(2510),
    [sym_this] = ACTIONS(2510),
  },
  [467] = {
    [sym_identifier] = ACTIONS(2645),
    [aux_sym_preproc_include_token1] = ACTIONS(2645),
    [aux_sym_preproc_def_token1] = ACTIONS(2645),
    [aux_sym_preproc_if_token1] = ACTIONS(2645),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2645),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2645),
    [sym_preproc_directive] = ACTIONS(2645),
    [anon_sym_LPAREN2] = ACTIONS(2647),
    [anon_sym_BANG] = ACTIONS(2647),
    [anon_sym_TILDE] = ACTIONS(2647),
    [anon_sym_DASH] = ACTIONS(2645),
    [anon_sym_PLUS] = ACTIONS(2645),
    [anon_sym_STAR] = ACTIONS(2647),
    [anon_sym_AMP_AMP] = ACTIONS(2647),
    [anon_sym_AMP] = ACTIONS(2645),
    [anon_sym_SEMI] = ACTIONS(2647),
    [anon_sym___extension__] = ACTIONS(2645),
    [anon_sym_typedef] = ACTIONS(2645),
    [anon_sym_virtual] = ACTIONS(2645),
    [anon_sym_extern] = ACTIONS(2645),
    [anon_sym___attribute__] = ACTIONS(2645),
    [anon_sym___attribute] = ACTIONS(2645),
    [anon_sym_COLON_COLON] = ACTIONS(2647),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2647),
    [anon_sym___declspec] = ACTIONS(2645),
    [anon_sym___based] = ACTIONS(2645),
    [anon_sym___cdecl] = ACTIONS(2645),
    [anon_sym___clrcall] = ACTIONS(2645),
    [anon_sym___stdcall] = ACTIONS(2645),
    [anon_sym___fastcall] = ACTIONS(2645),
    [anon_sym___thiscall] = ACTIONS(2645),
    [anon_sym___vectorcall] = ACTIONS(2645),
    [anon_sym_LBRACE] = ACTIONS(2647),
    [anon_sym_RBRACE] = ACTIONS(2647),
    [anon_sym_signed] = ACTIONS(2645),
    [anon_sym_unsigned] = ACTIONS(2645),
    [anon_sym_long] = ACTIONS(2645),
    [anon_sym_short] = ACTIONS(2645),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_static] = ACTIONS(2645),
    [anon_sym_register] = ACTIONS(2645),
    [anon_sym_inline] = ACTIONS(2645),
    [anon_sym___inline] = ACTIONS(2645),
    [anon_sym___inline__] = ACTIONS(2645),
    [anon_sym___forceinline] = ACTIONS(2645),
    [anon_sym_thread_local] = ACTIONS(2645),
    [anon_sym___thread] = ACTIONS(2645),
    [anon_sym_const] = ACTIONS(2645),
    [anon_sym_constexpr] = ACTIONS(2645),
    [anon_sym_volatile] = ACTIONS(2645),
    [anon_sym_restrict] = ACTIONS(2645),
    [anon_sym___restrict__] = ACTIONS(2645),
    [anon_sym__Atomic] = ACTIONS(2645),
    [anon_sym__Noreturn] = ACTIONS(2645),
    [anon_sym_noreturn] = ACTIONS(2645),
    [anon_sym__Nonnull] = ACTIONS(2645),
    [anon_sym_mutable] = ACTIONS(2645),
    [anon_sym_constinit] = ACTIONS(2645),
    [anon_sym_consteval] = ACTIONS(2645),
    [anon_sym_alignas] = ACTIONS(2645),
    [anon_sym__Alignas] = ACTIONS(2645),
    [sym_primitive_type] = ACTIONS(2645),
    [anon_sym_enum] = ACTIONS(2645),
    [anon_sym_class] = ACTIONS(2645),
    [anon_sym_struct] = ACTIONS(2645),
    [anon_sym_union] = ACTIONS(2645),
    [anon_sym_if] = ACTIONS(2645),
    [anon_sym_else] = ACTIONS(2645),
    [anon_sym_switch] = ACTIONS(2645),
    [anon_sym_case] = ACTIONS(2645),
    [anon_sym_default] = ACTIONS(2645),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_do] = ACTIONS(2645),
    [anon_sym_for] = ACTIONS(2645),
    [anon_sym_return] = ACTIONS(2645),
    [anon_sym_break] = ACTIONS(2645),
    [anon_sym_continue] = ACTIONS(2645),
    [anon_sym_goto] = ACTIONS(2645),
    [anon_sym___try] = ACTIONS(2645),
    [anon_sym___leave] = ACTIONS(2645),
    [anon_sym_not] = ACTIONS(2645),
    [anon_sym_compl] = ACTIONS(2645),
    [anon_sym_DASH_DASH] = ACTIONS(2647),
    [anon_sym_PLUS_PLUS] = ACTIONS(2647),
    [anon_sym_sizeof] = ACTIONS(2645),
    [anon_sym___alignof__] = ACTIONS(2645),
    [anon_sym___alignof] = ACTIONS(2645),
    [anon_sym__alignof] = ACTIONS(2645),
    [anon_sym_alignof] = ACTIONS(2645),
    [anon_sym__Alignof] = ACTIONS(2645),
    [anon_sym_offsetof] = ACTIONS(2645),
    [anon_sym__Generic] = ACTIONS(2645),
    [anon_sym_asm] = ACTIONS(2645),
    [anon_sym___asm__] = ACTIONS(2645),
    [anon_sym___asm] = ACTIONS(2645),
    [sym_number_literal] = ACTIONS(2647),
    [anon_sym_L_SQUOTE] = ACTIONS(2647),
    [anon_sym_u_SQUOTE] = ACTIONS(2647),
    [anon_sym_U_SQUOTE] = ACTIONS(2647),
    [anon_sym_u8_SQUOTE] = ACTIONS(2647),
    [anon_sym_SQUOTE] = ACTIONS(2647),
    [anon_sym_L_DQUOTE] = ACTIONS(2647),
    [anon_sym_u_DQUOTE] = ACTIONS(2647),
    [anon_sym_U_DQUOTE] = ACTIONS(2647),
    [anon_sym_u8_DQUOTE] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(2647),
    [sym_true] = ACTIONS(2645),
    [sym_false] = ACTIONS(2645),
    [anon_sym_NULL] = ACTIONS(2645),
    [anon_sym_nullptr] = ACTIONS(2645),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2645),
    [anon_sym_decltype] = ACTIONS(2645),
    [anon_sym_explicit] = ACTIONS(2645),
    [anon_sym_typename] = ACTIONS(2645),
    [anon_sym_template] = ACTIONS(2645),
    [anon_sym_operator] = ACTIONS(2645),
    [anon_sym_try] = ACTIONS(2645),
    [anon_sym_delete] = ACTIONS(2645),
    [anon_sym_throw] = ACTIONS(2645),
    [anon_sym_namespace] = ACTIONS(2645),
    [anon_sym_using] = ACTIONS(2645),
    [anon_sym_static_assert] = ACTIONS(2645),
    [anon_sym_concept] = ACTIONS(2645),
    [anon_sym_co_return] = ACTIONS(2645),
    [anon_sym_co_yield] = ACTIONS(2645),
    [anon_sym_R_DQUOTE] = ACTIONS(2647),
    [anon_sym_LR_DQUOTE] = ACTIONS(2647),
    [anon_sym_uR_DQUOTE] = ACTIONS(2647),
    [anon_sym_UR_DQUOTE] = ACTIONS(2647),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2647),
    [anon_sym_co_await] = ACTIONS(2645),
    [anon_sym_new] = ACTIONS(2645),
    [anon_sym_requires] = ACTIONS(2645),
    [sym_this] = ACTIONS(2645),
  },
  [468] = {
    [sym_identifier] = ACTIONS(2649),
    [aux_sym_preproc_include_token1] = ACTIONS(2649),
    [aux_sym_preproc_def_token1] = ACTIONS(2649),
    [aux_sym_preproc_if_token1] = ACTIONS(2649),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2649),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2649),
    [sym_preproc_directive] = ACTIONS(2649),
    [anon_sym_LPAREN2] = ACTIONS(2651),
    [anon_sym_BANG] = ACTIONS(2651),
    [anon_sym_TILDE] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2651),
    [anon_sym_AMP_AMP] = ACTIONS(2651),
    [anon_sym_AMP] = ACTIONS(2649),
    [anon_sym_SEMI] = ACTIONS(2651),
    [anon_sym___extension__] = ACTIONS(2649),
    [anon_sym_typedef] = ACTIONS(2649),
    [anon_sym_virtual] = ACTIONS(2649),
    [anon_sym_extern] = ACTIONS(2649),
    [anon_sym___attribute__] = ACTIONS(2649),
    [anon_sym___attribute] = ACTIONS(2649),
    [anon_sym_COLON_COLON] = ACTIONS(2651),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2651),
    [anon_sym___declspec] = ACTIONS(2649),
    [anon_sym___based] = ACTIONS(2649),
    [anon_sym___cdecl] = ACTIONS(2649),
    [anon_sym___clrcall] = ACTIONS(2649),
    [anon_sym___stdcall] = ACTIONS(2649),
    [anon_sym___fastcall] = ACTIONS(2649),
    [anon_sym___thiscall] = ACTIONS(2649),
    [anon_sym___vectorcall] = ACTIONS(2649),
    [anon_sym_LBRACE] = ACTIONS(2651),
    [anon_sym_RBRACE] = ACTIONS(2651),
    [anon_sym_signed] = ACTIONS(2649),
    [anon_sym_unsigned] = ACTIONS(2649),
    [anon_sym_long] = ACTIONS(2649),
    [anon_sym_short] = ACTIONS(2649),
    [anon_sym_LBRACK] = ACTIONS(2649),
    [anon_sym_static] = ACTIONS(2649),
    [anon_sym_register] = ACTIONS(2649),
    [anon_sym_inline] = ACTIONS(2649),
    [anon_sym___inline] = ACTIONS(2649),
    [anon_sym___inline__] = ACTIONS(2649),
    [anon_sym___forceinline] = ACTIONS(2649),
    [anon_sym_thread_local] = ACTIONS(2649),
    [anon_sym___thread] = ACTIONS(2649),
    [anon_sym_const] = ACTIONS(2649),
    [anon_sym_constexpr] = ACTIONS(2649),
    [anon_sym_volatile] = ACTIONS(2649),
    [anon_sym_restrict] = ACTIONS(2649),
    [anon_sym___restrict__] = ACTIONS(2649),
    [anon_sym__Atomic] = ACTIONS(2649),
    [anon_sym__Noreturn] = ACTIONS(2649),
    [anon_sym_noreturn] = ACTIONS(2649),
    [anon_sym__Nonnull] = ACTIONS(2649),
    [anon_sym_mutable] = ACTIONS(2649),
    [anon_sym_constinit] = ACTIONS(2649),
    [anon_sym_consteval] = ACTIONS(2649),
    [anon_sym_alignas] = ACTIONS(2649),
    [anon_sym__Alignas] = ACTIONS(2649),
    [sym_primitive_type] = ACTIONS(2649),
    [anon_sym_enum] = ACTIONS(2649),
    [anon_sym_class] = ACTIONS(2649),
    [anon_sym_struct] = ACTIONS(2649),
    [anon_sym_union] = ACTIONS(2649),
    [anon_sym_if] = ACTIONS(2649),
    [anon_sym_else] = ACTIONS(2649),
    [anon_sym_switch] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2649),
    [anon_sym_default] = ACTIONS(2649),
    [anon_sym_while] = ACTIONS(2649),
    [anon_sym_do] = ACTIONS(2649),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_return] = ACTIONS(2649),
    [anon_sym_break] = ACTIONS(2649),
    [anon_sym_continue] = ACTIONS(2649),
    [anon_sym_goto] = ACTIONS(2649),
    [anon_sym___try] = ACTIONS(2649),
    [anon_sym___leave] = ACTIONS(2649),
    [anon_sym_not] = ACTIONS(2649),
    [anon_sym_compl] = ACTIONS(2649),
    [anon_sym_DASH_DASH] = ACTIONS(2651),
    [anon_sym_PLUS_PLUS] = ACTIONS(2651),
    [anon_sym_sizeof] = ACTIONS(2649),
    [anon_sym___alignof__] = ACTIONS(2649),
    [anon_sym___alignof] = ACTIONS(2649),
    [anon_sym__alignof] = ACTIONS(2649),
    [anon_sym_alignof] = ACTIONS(2649),
    [anon_sym__Alignof] = ACTIONS(2649),
    [anon_sym_offsetof] = ACTIONS(2649),
    [anon_sym__Generic] = ACTIONS(2649),
    [anon_sym_asm] = ACTIONS(2649),
    [anon_sym___asm__] = ACTIONS(2649),
    [anon_sym___asm] = ACTIONS(2649),
    [sym_number_literal] = ACTIONS(2651),
    [anon_sym_L_SQUOTE] = ACTIONS(2651),
    [anon_sym_u_SQUOTE] = ACTIONS(2651),
    [anon_sym_U_SQUOTE] = ACTIONS(2651),
    [anon_sym_u8_SQUOTE] = ACTIONS(2651),
    [anon_sym_SQUOTE] = ACTIONS(2651),
    [anon_sym_L_DQUOTE] = ACTIONS(2651),
    [anon_sym_u_DQUOTE] = ACTIONS(2651),
    [anon_sym_U_DQUOTE] = ACTIONS(2651),
    [anon_sym_u8_DQUOTE] = ACTIONS(2651),
    [anon_sym_DQUOTE] = ACTIONS(2651),
    [sym_true] = ACTIONS(2649),
    [sym_false] = ACTIONS(2649),
    [anon_sym_NULL] = ACTIONS(2649),
    [anon_sym_nullptr] = ACTIONS(2649),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2649),
    [anon_sym_decltype] = ACTIONS(2649),
    [anon_sym_explicit] = ACTIONS(2649),
    [anon_sym_typename] = ACTIONS(2649),
    [anon_sym_template] = ACTIONS(2649),
    [anon_sym_operator] = ACTIONS(2649),
    [anon_sym_try] = ACTIONS(2649),
    [anon_sym_delete] = ACTIONS(2649),
    [anon_sym_throw] = ACTIONS(2649),
    [anon_sym_namespace] = ACTIONS(2649),
    [anon_sym_using] = ACTIONS(2649),
    [anon_sym_static_assert] = ACTIONS(2649),
    [anon_sym_concept] = ACTIONS(2649),
    [anon_sym_co_return] = ACTIONS(2649),
    [anon_sym_co_yield] = ACTIONS(2649),
    [anon_sym_R_DQUOTE] = ACTIONS(2651),
    [anon_sym_LR_DQUOTE] = ACTIONS(2651),
    [anon_sym_uR_DQUOTE] = ACTIONS(2651),
    [anon_sym_UR_DQUOTE] = ACTIONS(2651),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2651),
    [anon_sym_co_await] = ACTIONS(2649),
    [anon_sym_new] = ACTIONS(2649),
    [anon_sym_requires] = ACTIONS(2649),
    [sym_this] = ACTIONS(2649),
  },
  [469] = {
    [ts_builtin_sym_end] = ACTIONS(2655),
    [sym_identifier] = ACTIONS(2653),
    [aux_sym_preproc_include_token1] = ACTIONS(2653),
    [aux_sym_preproc_def_token1] = ACTIONS(2653),
    [aux_sym_preproc_if_token1] = ACTIONS(2653),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2653),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2653),
    [sym_preproc_directive] = ACTIONS(2653),
    [anon_sym_LPAREN2] = ACTIONS(2655),
    [anon_sym_BANG] = ACTIONS(2655),
    [anon_sym_TILDE] = ACTIONS(2655),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_AMP_AMP] = ACTIONS(2655),
    [anon_sym_AMP] = ACTIONS(2653),
    [anon_sym_SEMI] = ACTIONS(2655),
    [anon_sym___extension__] = ACTIONS(2653),
    [anon_sym_typedef] = ACTIONS(2653),
    [anon_sym_virtual] = ACTIONS(2653),
    [anon_sym_extern] = ACTIONS(2653),
    [anon_sym___attribute__] = ACTIONS(2653),
    [anon_sym___attribute] = ACTIONS(2653),
    [anon_sym_COLON_COLON] = ACTIONS(2655),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2655),
    [anon_sym___declspec] = ACTIONS(2653),
    [anon_sym___based] = ACTIONS(2653),
    [anon_sym___cdecl] = ACTIONS(2653),
    [anon_sym___clrcall] = ACTIONS(2653),
    [anon_sym___stdcall] = ACTIONS(2653),
    [anon_sym___fastcall] = ACTIONS(2653),
    [anon_sym___thiscall] = ACTIONS(2653),
    [anon_sym___vectorcall] = ACTIONS(2653),
    [anon_sym_LBRACE] = ACTIONS(2655),
    [anon_sym_signed] = ACTIONS(2653),
    [anon_sym_unsigned] = ACTIONS(2653),
    [anon_sym_long] = ACTIONS(2653),
    [anon_sym_short] = ACTIONS(2653),
    [anon_sym_LBRACK] = ACTIONS(2653),
    [anon_sym_static] = ACTIONS(2653),
    [anon_sym_register] = ACTIONS(2653),
    [anon_sym_inline] = ACTIONS(2653),
    [anon_sym___inline] = ACTIONS(2653),
    [anon_sym___inline__] = ACTIONS(2653),
    [anon_sym___forceinline] = ACTIONS(2653),
    [anon_sym_thread_local] = ACTIONS(2653),
    [anon_sym___thread] = ACTIONS(2653),
    [anon_sym_const] = ACTIONS(2653),
    [anon_sym_constexpr] = ACTIONS(2653),
    [anon_sym_volatile] = ACTIONS(2653),
    [anon_sym_restrict] = ACTIONS(2653),
    [anon_sym___restrict__] = ACTIONS(2653),
    [anon_sym__Atomic] = ACTIONS(2653),
    [anon_sym__Noreturn] = ACTIONS(2653),
    [anon_sym_noreturn] = ACTIONS(2653),
    [anon_sym__Nonnull] = ACTIONS(2653),
    [anon_sym_mutable] = ACTIONS(2653),
    [anon_sym_constinit] = ACTIONS(2653),
    [anon_sym_consteval] = ACTIONS(2653),
    [anon_sym_alignas] = ACTIONS(2653),
    [anon_sym__Alignas] = ACTIONS(2653),
    [sym_primitive_type] = ACTIONS(2653),
    [anon_sym_enum] = ACTIONS(2653),
    [anon_sym_class] = ACTIONS(2653),
    [anon_sym_struct] = ACTIONS(2653),
    [anon_sym_union] = ACTIONS(2653),
    [anon_sym_if] = ACTIONS(2653),
    [anon_sym_else] = ACTIONS(2653),
    [anon_sym_switch] = ACTIONS(2653),
    [anon_sym_case] = ACTIONS(2653),
    [anon_sym_default] = ACTIONS(2653),
    [anon_sym_while] = ACTIONS(2653),
    [anon_sym_do] = ACTIONS(2653),
    [anon_sym_for] = ACTIONS(2653),
    [anon_sym_return] = ACTIONS(2653),
    [anon_sym_break] = ACTIONS(2653),
    [anon_sym_continue] = ACTIONS(2653),
    [anon_sym_goto] = ACTIONS(2653),
    [anon_sym___try] = ACTIONS(2653),
    [anon_sym___leave] = ACTIONS(2653),
    [anon_sym_not] = ACTIONS(2653),
    [anon_sym_compl] = ACTIONS(2653),
    [anon_sym_DASH_DASH] = ACTIONS(2655),
    [anon_sym_PLUS_PLUS] = ACTIONS(2655),
    [anon_sym_sizeof] = ACTIONS(2653),
    [anon_sym___alignof__] = ACTIONS(2653),
    [anon_sym___alignof] = ACTIONS(2653),
    [anon_sym__alignof] = ACTIONS(2653),
    [anon_sym_alignof] = ACTIONS(2653),
    [anon_sym__Alignof] = ACTIONS(2653),
    [anon_sym_offsetof] = ACTIONS(2653),
    [anon_sym__Generic] = ACTIONS(2653),
    [anon_sym_asm] = ACTIONS(2653),
    [anon_sym___asm__] = ACTIONS(2653),
    [anon_sym___asm] = ACTIONS(2653),
    [sym_number_literal] = ACTIONS(2655),
    [anon_sym_L_SQUOTE] = ACTIONS(2655),
    [anon_sym_u_SQUOTE] = ACTIONS(2655),
    [anon_sym_U_SQUOTE] = ACTIONS(2655),
    [anon_sym_u8_SQUOTE] = ACTIONS(2655),
    [anon_sym_SQUOTE] = ACTIONS(2655),
    [anon_sym_L_DQUOTE] = ACTIONS(2655),
    [anon_sym_u_DQUOTE] = ACTIONS(2655),
    [anon_sym_U_DQUOTE] = ACTIONS(2655),
    [anon_sym_u8_DQUOTE] = ACTIONS(2655),
    [anon_sym_DQUOTE] = ACTIONS(2655),
    [sym_true] = ACTIONS(2653),
    [sym_false] = ACTIONS(2653),
    [anon_sym_NULL] = ACTIONS(2653),
    [anon_sym_nullptr] = ACTIONS(2653),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2653),
    [anon_sym_decltype] = ACTIONS(2653),
    [anon_sym_explicit] = ACTIONS(2653),
    [anon_sym_typename] = ACTIONS(2653),
    [anon_sym_template] = ACTIONS(2653),
    [anon_sym_operator] = ACTIONS(2653),
    [anon_sym_try] = ACTIONS(2653),
    [anon_sym_delete] = ACTIONS(2653),
    [anon_sym_throw] = ACTIONS(2653),
    [anon_sym_namespace] = ACTIONS(2653),
    [anon_sym_using] = ACTIONS(2653),
    [anon_sym_static_assert] = ACTIONS(2653),
    [anon_sym_concept] = ACTIONS(2653),
    [anon_sym_co_return] = ACTIONS(2653),
    [anon_sym_co_yield] = ACTIONS(2653),
    [anon_sym_R_DQUOTE] = ACTIONS(2655),
    [anon_sym_LR_DQUOTE] = ACTIONS(2655),
    [anon_sym_uR_DQUOTE] = ACTIONS(2655),
    [anon_sym_UR_DQUOTE] = ACTIONS(2655),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2655),
    [anon_sym_co_await] = ACTIONS(2653),
    [anon_sym_new] = ACTIONS(2653),
    [anon_sym_requires] = ACTIONS(2653),
    [sym_this] = ACTIONS(2653),
  },
  [470] = {
    [ts_builtin_sym_end] = ACTIONS(2647),
    [sym_identifier] = ACTIONS(2645),
    [aux_sym_preproc_include_token1] = ACTIONS(2645),
    [aux_sym_preproc_def_token1] = ACTIONS(2645),
    [aux_sym_preproc_if_token1] = ACTIONS(2645),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2645),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2645),
    [sym_preproc_directive] = ACTIONS(2645),
    [anon_sym_LPAREN2] = ACTIONS(2647),
    [anon_sym_BANG] = ACTIONS(2647),
    [anon_sym_TILDE] = ACTIONS(2647),
    [anon_sym_DASH] = ACTIONS(2645),
    [anon_sym_PLUS] = ACTIONS(2645),
    [anon_sym_STAR] = ACTIONS(2647),
    [anon_sym_AMP_AMP] = ACTIONS(2647),
    [anon_sym_AMP] = ACTIONS(2645),
    [anon_sym_SEMI] = ACTIONS(2647),
    [anon_sym___extension__] = ACTIONS(2645),
    [anon_sym_typedef] = ACTIONS(2645),
    [anon_sym_virtual] = ACTIONS(2645),
    [anon_sym_extern] = ACTIONS(2645),
    [anon_sym___attribute__] = ACTIONS(2645),
    [anon_sym___attribute] = ACTIONS(2645),
    [anon_sym_COLON_COLON] = ACTIONS(2647),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2647),
    [anon_sym___declspec] = ACTIONS(2645),
    [anon_sym___based] = ACTIONS(2645),
    [anon_sym___cdecl] = ACTIONS(2645),
    [anon_sym___clrcall] = ACTIONS(2645),
    [anon_sym___stdcall] = ACTIONS(2645),
    [anon_sym___fastcall] = ACTIONS(2645),
    [anon_sym___thiscall] = ACTIONS(2645),
    [anon_sym___vectorcall] = ACTIONS(2645),
    [anon_sym_LBRACE] = ACTIONS(2647),
    [anon_sym_signed] = ACTIONS(2645),
    [anon_sym_unsigned] = ACTIONS(2645),
    [anon_sym_long] = ACTIONS(2645),
    [anon_sym_short] = ACTIONS(2645),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_static] = ACTIONS(2645),
    [anon_sym_register] = ACTIONS(2645),
    [anon_sym_inline] = ACTIONS(2645),
    [anon_sym___inline] = ACTIONS(2645),
    [anon_sym___inline__] = ACTIONS(2645),
    [anon_sym___forceinline] = ACTIONS(2645),
    [anon_sym_thread_local] = ACTIONS(2645),
    [anon_sym___thread] = ACTIONS(2645),
    [anon_sym_const] = ACTIONS(2645),
    [anon_sym_constexpr] = ACTIONS(2645),
    [anon_sym_volatile] = ACTIONS(2645),
    [anon_sym_restrict] = ACTIONS(2645),
    [anon_sym___restrict__] = ACTIONS(2645),
    [anon_sym__Atomic] = ACTIONS(2645),
    [anon_sym__Noreturn] = ACTIONS(2645),
    [anon_sym_noreturn] = ACTIONS(2645),
    [anon_sym__Nonnull] = ACTIONS(2645),
    [anon_sym_mutable] = ACTIONS(2645),
    [anon_sym_constinit] = ACTIONS(2645),
    [anon_sym_consteval] = ACTIONS(2645),
    [anon_sym_alignas] = ACTIONS(2645),
    [anon_sym__Alignas] = ACTIONS(2645),
    [sym_primitive_type] = ACTIONS(2645),
    [anon_sym_enum] = ACTIONS(2645),
    [anon_sym_class] = ACTIONS(2645),
    [anon_sym_struct] = ACTIONS(2645),
    [anon_sym_union] = ACTIONS(2645),
    [anon_sym_if] = ACTIONS(2645),
    [anon_sym_else] = ACTIONS(2645),
    [anon_sym_switch] = ACTIONS(2645),
    [anon_sym_case] = ACTIONS(2645),
    [anon_sym_default] = ACTIONS(2645),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_do] = ACTIONS(2645),
    [anon_sym_for] = ACTIONS(2645),
    [anon_sym_return] = ACTIONS(2645),
    [anon_sym_break] = ACTIONS(2645),
    [anon_sym_continue] = ACTIONS(2645),
    [anon_sym_goto] = ACTIONS(2645),
    [anon_sym___try] = ACTIONS(2645),
    [anon_sym___leave] = ACTIONS(2645),
    [anon_sym_not] = ACTIONS(2645),
    [anon_sym_compl] = ACTIONS(2645),
    [anon_sym_DASH_DASH] = ACTIONS(2647),
    [anon_sym_PLUS_PLUS] = ACTIONS(2647),
    [anon_sym_sizeof] = ACTIONS(2645),
    [anon_sym___alignof__] = ACTIONS(2645),
    [anon_sym___alignof] = ACTIONS(2645),
    [anon_sym__alignof] = ACTIONS(2645),
    [anon_sym_alignof] = ACTIONS(2645),
    [anon_sym__Alignof] = ACTIONS(2645),
    [anon_sym_offsetof] = ACTIONS(2645),
    [anon_sym__Generic] = ACTIONS(2645),
    [anon_sym_asm] = ACTIONS(2645),
    [anon_sym___asm__] = ACTIONS(2645),
    [anon_sym___asm] = ACTIONS(2645),
    [sym_number_literal] = ACTIONS(2647),
    [anon_sym_L_SQUOTE] = ACTIONS(2647),
    [anon_sym_u_SQUOTE] = ACTIONS(2647),
    [anon_sym_U_SQUOTE] = ACTIONS(2647),
    [anon_sym_u8_SQUOTE] = ACTIONS(2647),
    [anon_sym_SQUOTE] = ACTIONS(2647),
    [anon_sym_L_DQUOTE] = ACTIONS(2647),
    [anon_sym_u_DQUOTE] = ACTIONS(2647),
    [anon_sym_U_DQUOTE] = ACTIONS(2647),
    [anon_sym_u8_DQUOTE] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(2647),
    [sym_true] = ACTIONS(2645),
    [sym_false] = ACTIONS(2645),
    [anon_sym_NULL] = ACTIONS(2645),
    [anon_sym_nullptr] = ACTIONS(2645),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2645),
    [anon_sym_decltype] = ACTIONS(2645),
    [anon_sym_explicit] = ACTIONS(2645),
    [anon_sym_typename] = ACTIONS(2645),
    [anon_sym_template] = ACTIONS(2645),
    [anon_sym_operator] = ACTIONS(2645),
    [anon_sym_try] = ACTIONS(2645),
    [anon_sym_delete] = ACTIONS(2645),
    [anon_sym_throw] = ACTIONS(2645),
    [anon_sym_namespace] = ACTIONS(2645),
    [anon_sym_using] = ACTIONS(2645),
    [anon_sym_static_assert] = ACTIONS(2645),
    [anon_sym_concept] = ACTIONS(2645),
    [anon_sym_co_return] = ACTIONS(2645),
    [anon_sym_co_yield] = ACTIONS(2645),
    [anon_sym_R_DQUOTE] = ACTIONS(2647),
    [anon_sym_LR_DQUOTE] = ACTIONS(2647),
    [anon_sym_uR_DQUOTE] = ACTIONS(2647),
    [anon_sym_UR_DQUOTE] = ACTIONS(2647),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2647),
    [anon_sym_co_await] = ACTIONS(2645),
    [anon_sym_new] = ACTIONS(2645),
    [anon_sym_requires] = ACTIONS(2645),
    [sym_this] = ACTIONS(2645),
  },
  [471] = {
    [ts_builtin_sym_end] = ACTIONS(2651),
    [sym_identifier] = ACTIONS(2649),
    [aux_sym_preproc_include_token1] = ACTIONS(2649),
    [aux_sym_preproc_def_token1] = ACTIONS(2649),
    [aux_sym_preproc_if_token1] = ACTIONS(2649),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2649),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2649),
    [sym_preproc_directive] = ACTIONS(2649),
    [anon_sym_LPAREN2] = ACTIONS(2651),
    [anon_sym_BANG] = ACTIONS(2651),
    [anon_sym_TILDE] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2651),
    [anon_sym_AMP_AMP] = ACTIONS(2651),
    [anon_sym_AMP] = ACTIONS(2649),
    [anon_sym_SEMI] = ACTIONS(2651),
    [anon_sym___extension__] = ACTIONS(2649),
    [anon_sym_typedef] = ACTIONS(2649),
    [anon_sym_virtual] = ACTIONS(2649),
    [anon_sym_extern] = ACTIONS(2649),
    [anon_sym___attribute__] = ACTIONS(2649),
    [anon_sym___attribute] = ACTIONS(2649),
    [anon_sym_COLON_COLON] = ACTIONS(2651),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2651),
    [anon_sym___declspec] = ACTIONS(2649),
    [anon_sym___based] = ACTIONS(2649),
    [anon_sym___cdecl] = ACTIONS(2649),
    [anon_sym___clrcall] = ACTIONS(2649),
    [anon_sym___stdcall] = ACTIONS(2649),
    [anon_sym___fastcall] = ACTIONS(2649),
    [anon_sym___thiscall] = ACTIONS(2649),
    [anon_sym___vectorcall] = ACTIONS(2649),
    [anon_sym_LBRACE] = ACTIONS(2651),
    [anon_sym_signed] = ACTIONS(2649),
    [anon_sym_unsigned] = ACTIONS(2649),
    [anon_sym_long] = ACTIONS(2649),
    [anon_sym_short] = ACTIONS(2649),
    [anon_sym_LBRACK] = ACTIONS(2649),
    [anon_sym_static] = ACTIONS(2649),
    [anon_sym_register] = ACTIONS(2649),
    [anon_sym_inline] = ACTIONS(2649),
    [anon_sym___inline] = ACTIONS(2649),
    [anon_sym___inline__] = ACTIONS(2649),
    [anon_sym___forceinline] = ACTIONS(2649),
    [anon_sym_thread_local] = ACTIONS(2649),
    [anon_sym___thread] = ACTIONS(2649),
    [anon_sym_const] = ACTIONS(2649),
    [anon_sym_constexpr] = ACTIONS(2649),
    [anon_sym_volatile] = ACTIONS(2649),
    [anon_sym_restrict] = ACTIONS(2649),
    [anon_sym___restrict__] = ACTIONS(2649),
    [anon_sym__Atomic] = ACTIONS(2649),
    [anon_sym__Noreturn] = ACTIONS(2649),
    [anon_sym_noreturn] = ACTIONS(2649),
    [anon_sym__Nonnull] = ACTIONS(2649),
    [anon_sym_mutable] = ACTIONS(2649),
    [anon_sym_constinit] = ACTIONS(2649),
    [anon_sym_consteval] = ACTIONS(2649),
    [anon_sym_alignas] = ACTIONS(2649),
    [anon_sym__Alignas] = ACTIONS(2649),
    [sym_primitive_type] = ACTIONS(2649),
    [anon_sym_enum] = ACTIONS(2649),
    [anon_sym_class] = ACTIONS(2649),
    [anon_sym_struct] = ACTIONS(2649),
    [anon_sym_union] = ACTIONS(2649),
    [anon_sym_if] = ACTIONS(2649),
    [anon_sym_else] = ACTIONS(2649),
    [anon_sym_switch] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2649),
    [anon_sym_default] = ACTIONS(2649),
    [anon_sym_while] = ACTIONS(2649),
    [anon_sym_do] = ACTIONS(2649),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_return] = ACTIONS(2649),
    [anon_sym_break] = ACTIONS(2649),
    [anon_sym_continue] = ACTIONS(2649),
    [anon_sym_goto] = ACTIONS(2649),
    [anon_sym___try] = ACTIONS(2649),
    [anon_sym___leave] = ACTIONS(2649),
    [anon_sym_not] = ACTIONS(2649),
    [anon_sym_compl] = ACTIONS(2649),
    [anon_sym_DASH_DASH] = ACTIONS(2651),
    [anon_sym_PLUS_PLUS] = ACTIONS(2651),
    [anon_sym_sizeof] = ACTIONS(2649),
    [anon_sym___alignof__] = ACTIONS(2649),
    [anon_sym___alignof] = ACTIONS(2649),
    [anon_sym__alignof] = ACTIONS(2649),
    [anon_sym_alignof] = ACTIONS(2649),
    [anon_sym__Alignof] = ACTIONS(2649),
    [anon_sym_offsetof] = ACTIONS(2649),
    [anon_sym__Generic] = ACTIONS(2649),
    [anon_sym_asm] = ACTIONS(2649),
    [anon_sym___asm__] = ACTIONS(2649),
    [anon_sym___asm] = ACTIONS(2649),
    [sym_number_literal] = ACTIONS(2651),
    [anon_sym_L_SQUOTE] = ACTIONS(2651),
    [anon_sym_u_SQUOTE] = ACTIONS(2651),
    [anon_sym_U_SQUOTE] = ACTIONS(2651),
    [anon_sym_u8_SQUOTE] = ACTIONS(2651),
    [anon_sym_SQUOTE] = ACTIONS(2651),
    [anon_sym_L_DQUOTE] = ACTIONS(2651),
    [anon_sym_u_DQUOTE] = ACTIONS(2651),
    [anon_sym_U_DQUOTE] = ACTIONS(2651),
    [anon_sym_u8_DQUOTE] = ACTIONS(2651),
    [anon_sym_DQUOTE] = ACTIONS(2651),
    [sym_true] = ACTIONS(2649),
    [sym_false] = ACTIONS(2649),
    [anon_sym_NULL] = ACTIONS(2649),
    [anon_sym_nullptr] = ACTIONS(2649),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2649),
    [anon_sym_decltype] = ACTIONS(2649),
    [anon_sym_explicit] = ACTIONS(2649),
    [anon_sym_typename] = ACTIONS(2649),
    [anon_sym_template] = ACTIONS(2649),
    [anon_sym_operator] = ACTIONS(2649),
    [anon_sym_try] = ACTIONS(2649),
    [anon_sym_delete] = ACTIONS(2649),
    [anon_sym_throw] = ACTIONS(2649),
    [anon_sym_namespace] = ACTIONS(2649),
    [anon_sym_using] = ACTIONS(2649),
    [anon_sym_static_assert] = ACTIONS(2649),
    [anon_sym_concept] = ACTIONS(2649),
    [anon_sym_co_return] = ACTIONS(2649),
    [anon_sym_co_yield] = ACTIONS(2649),
    [anon_sym_R_DQUOTE] = ACTIONS(2651),
    [anon_sym_LR_DQUOTE] = ACTIONS(2651),
    [anon_sym_uR_DQUOTE] = ACTIONS(2651),
    [anon_sym_UR_DQUOTE] = ACTIONS(2651),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2651),
    [anon_sym_co_await] = ACTIONS(2649),
    [anon_sym_new] = ACTIONS(2649),
    [anon_sym_requires] = ACTIONS(2649),
    [sym_this] = ACTIONS(2649),
  },
  [472] = {
    [sym_identifier] = ACTIONS(2629),
    [aux_sym_preproc_include_token1] = ACTIONS(2629),
    [aux_sym_preproc_def_token1] = ACTIONS(2629),
    [aux_sym_preproc_if_token1] = ACTIONS(2629),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2629),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2629),
    [sym_preproc_directive] = ACTIONS(2629),
    [anon_sym_LPAREN2] = ACTIONS(2631),
    [anon_sym_BANG] = ACTIONS(2631),
    [anon_sym_TILDE] = ACTIONS(2631),
    [anon_sym_DASH] = ACTIONS(2629),
    [anon_sym_PLUS] = ACTIONS(2629),
    [anon_sym_STAR] = ACTIONS(2631),
    [anon_sym_AMP_AMP] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2629),
    [anon_sym_SEMI] = ACTIONS(2631),
    [anon_sym___extension__] = ACTIONS(2629),
    [anon_sym_typedef] = ACTIONS(2629),
    [anon_sym_virtual] = ACTIONS(2629),
    [anon_sym_extern] = ACTIONS(2629),
    [anon_sym___attribute__] = ACTIONS(2629),
    [anon_sym___attribute] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(2631),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2631),
    [anon_sym___declspec] = ACTIONS(2629),
    [anon_sym___based] = ACTIONS(2629),
    [anon_sym___cdecl] = ACTIONS(2629),
    [anon_sym___clrcall] = ACTIONS(2629),
    [anon_sym___stdcall] = ACTIONS(2629),
    [anon_sym___fastcall] = ACTIONS(2629),
    [anon_sym___thiscall] = ACTIONS(2629),
    [anon_sym___vectorcall] = ACTIONS(2629),
    [anon_sym_LBRACE] = ACTIONS(2631),
    [anon_sym_RBRACE] = ACTIONS(2631),
    [anon_sym_signed] = ACTIONS(2629),
    [anon_sym_unsigned] = ACTIONS(2629),
    [anon_sym_long] = ACTIONS(2629),
    [anon_sym_short] = ACTIONS(2629),
    [anon_sym_LBRACK] = ACTIONS(2629),
    [anon_sym_static] = ACTIONS(2629),
    [anon_sym_register] = ACTIONS(2629),
    [anon_sym_inline] = ACTIONS(2629),
    [anon_sym___inline] = ACTIONS(2629),
    [anon_sym___inline__] = ACTIONS(2629),
    [anon_sym___forceinline] = ACTIONS(2629),
    [anon_sym_thread_local] = ACTIONS(2629),
    [anon_sym___thread] = ACTIONS(2629),
    [anon_sym_const] = ACTIONS(2629),
    [anon_sym_constexpr] = ACTIONS(2629),
    [anon_sym_volatile] = ACTIONS(2629),
    [anon_sym_restrict] = ACTIONS(2629),
    [anon_sym___restrict__] = ACTIONS(2629),
    [anon_sym__Atomic] = ACTIONS(2629),
    [anon_sym__Noreturn] = ACTIONS(2629),
    [anon_sym_noreturn] = ACTIONS(2629),
    [anon_sym__Nonnull] = ACTIONS(2629),
    [anon_sym_mutable] = ACTIONS(2629),
    [anon_sym_constinit] = ACTIONS(2629),
    [anon_sym_consteval] = ACTIONS(2629),
    [anon_sym_alignas] = ACTIONS(2629),
    [anon_sym__Alignas] = ACTIONS(2629),
    [sym_primitive_type] = ACTIONS(2629),
    [anon_sym_enum] = ACTIONS(2629),
    [anon_sym_class] = ACTIONS(2629),
    [anon_sym_struct] = ACTIONS(2629),
    [anon_sym_union] = ACTIONS(2629),
    [anon_sym_if] = ACTIONS(2629),
    [anon_sym_else] = ACTIONS(2629),
    [anon_sym_switch] = ACTIONS(2629),
    [anon_sym_case] = ACTIONS(2629),
    [anon_sym_default] = ACTIONS(2629),
    [anon_sym_while] = ACTIONS(2629),
    [anon_sym_do] = ACTIONS(2629),
    [anon_sym_for] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(2629),
    [anon_sym_break] = ACTIONS(2629),
    [anon_sym_continue] = ACTIONS(2629),
    [anon_sym_goto] = ACTIONS(2629),
    [anon_sym___try] = ACTIONS(2629),
    [anon_sym___leave] = ACTIONS(2629),
    [anon_sym_not] = ACTIONS(2629),
    [anon_sym_compl] = ACTIONS(2629),
    [anon_sym_DASH_DASH] = ACTIONS(2631),
    [anon_sym_PLUS_PLUS] = ACTIONS(2631),
    [anon_sym_sizeof] = ACTIONS(2629),
    [anon_sym___alignof__] = ACTIONS(2629),
    [anon_sym___alignof] = ACTIONS(2629),
    [anon_sym__alignof] = ACTIONS(2629),
    [anon_sym_alignof] = ACTIONS(2629),
    [anon_sym__Alignof] = ACTIONS(2629),
    [anon_sym_offsetof] = ACTIONS(2629),
    [anon_sym__Generic] = ACTIONS(2629),
    [anon_sym_asm] = ACTIONS(2629),
    [anon_sym___asm__] = ACTIONS(2629),
    [anon_sym___asm] = ACTIONS(2629),
    [sym_number_literal] = ACTIONS(2631),
    [anon_sym_L_SQUOTE] = ACTIONS(2631),
    [anon_sym_u_SQUOTE] = ACTIONS(2631),
    [anon_sym_U_SQUOTE] = ACTIONS(2631),
    [anon_sym_u8_SQUOTE] = ACTIONS(2631),
    [anon_sym_SQUOTE] = ACTIONS(2631),
    [anon_sym_L_DQUOTE] = ACTIONS(2631),
    [anon_sym_u_DQUOTE] = ACTIONS(2631),
    [anon_sym_U_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8_DQUOTE] = ACTIONS(2631),
    [anon_sym_DQUOTE] = ACTIONS(2631),
    [sym_true] = ACTIONS(2629),
    [sym_false] = ACTIONS(2629),
    [anon_sym_NULL] = ACTIONS(2629),
    [anon_sym_nullptr] = ACTIONS(2629),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2629),
    [anon_sym_decltype] = ACTIONS(2629),
    [anon_sym_explicit] = ACTIONS(2629),
    [anon_sym_typename] = ACTIONS(2629),
    [anon_sym_template] = ACTIONS(2629),
    [anon_sym_operator] = ACTIONS(2629),
    [anon_sym_try] = ACTIONS(2629),
    [anon_sym_delete] = ACTIONS(2629),
    [anon_sym_throw] = ACTIONS(2629),
    [anon_sym_namespace] = ACTIONS(2629),
    [anon_sym_using] = ACTIONS(2629),
    [anon_sym_static_assert] = ACTIONS(2629),
    [anon_sym_concept] = ACTIONS(2629),
    [anon_sym_co_return] = ACTIONS(2629),
    [anon_sym_co_yield] = ACTIONS(2629),
    [anon_sym_R_DQUOTE] = ACTIONS(2631),
    [anon_sym_LR_DQUOTE] = ACTIONS(2631),
    [anon_sym_uR_DQUOTE] = ACTIONS(2631),
    [anon_sym_UR_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2631),
    [anon_sym_co_await] = ACTIONS(2629),
    [anon_sym_new] = ACTIONS(2629),
    [anon_sym_requires] = ACTIONS(2629),
    [sym_this] = ACTIONS(2629),
  },
  [473] = {
    [sym_identifier] = ACTIONS(2653),
    [aux_sym_preproc_include_token1] = ACTIONS(2653),
    [aux_sym_preproc_def_token1] = ACTIONS(2653),
    [aux_sym_preproc_if_token1] = ACTIONS(2653),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2653),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2653),
    [sym_preproc_directive] = ACTIONS(2653),
    [anon_sym_LPAREN2] = ACTIONS(2655),
    [anon_sym_BANG] = ACTIONS(2655),
    [anon_sym_TILDE] = ACTIONS(2655),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_AMP_AMP] = ACTIONS(2655),
    [anon_sym_AMP] = ACTIONS(2653),
    [anon_sym_SEMI] = ACTIONS(2655),
    [anon_sym___extension__] = ACTIONS(2653),
    [anon_sym_typedef] = ACTIONS(2653),
    [anon_sym_virtual] = ACTIONS(2653),
    [anon_sym_extern] = ACTIONS(2653),
    [anon_sym___attribute__] = ACTIONS(2653),
    [anon_sym___attribute] = ACTIONS(2653),
    [anon_sym_COLON_COLON] = ACTIONS(2655),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2655),
    [anon_sym___declspec] = ACTIONS(2653),
    [anon_sym___based] = ACTIONS(2653),
    [anon_sym___cdecl] = ACTIONS(2653),
    [anon_sym___clrcall] = ACTIONS(2653),
    [anon_sym___stdcall] = ACTIONS(2653),
    [anon_sym___fastcall] = ACTIONS(2653),
    [anon_sym___thiscall] = ACTIONS(2653),
    [anon_sym___vectorcall] = ACTIONS(2653),
    [anon_sym_LBRACE] = ACTIONS(2655),
    [anon_sym_RBRACE] = ACTIONS(2655),
    [anon_sym_signed] = ACTIONS(2653),
    [anon_sym_unsigned] = ACTIONS(2653),
    [anon_sym_long] = ACTIONS(2653),
    [anon_sym_short] = ACTIONS(2653),
    [anon_sym_LBRACK] = ACTIONS(2653),
    [anon_sym_static] = ACTIONS(2653),
    [anon_sym_register] = ACTIONS(2653),
    [anon_sym_inline] = ACTIONS(2653),
    [anon_sym___inline] = ACTIONS(2653),
    [anon_sym___inline__] = ACTIONS(2653),
    [anon_sym___forceinline] = ACTIONS(2653),
    [anon_sym_thread_local] = ACTIONS(2653),
    [anon_sym___thread] = ACTIONS(2653),
    [anon_sym_const] = ACTIONS(2653),
    [anon_sym_constexpr] = ACTIONS(2653),
    [anon_sym_volatile] = ACTIONS(2653),
    [anon_sym_restrict] = ACTIONS(2653),
    [anon_sym___restrict__] = ACTIONS(2653),
    [anon_sym__Atomic] = ACTIONS(2653),
    [anon_sym__Noreturn] = ACTIONS(2653),
    [anon_sym_noreturn] = ACTIONS(2653),
    [anon_sym__Nonnull] = ACTIONS(2653),
    [anon_sym_mutable] = ACTIONS(2653),
    [anon_sym_constinit] = ACTIONS(2653),
    [anon_sym_consteval] = ACTIONS(2653),
    [anon_sym_alignas] = ACTIONS(2653),
    [anon_sym__Alignas] = ACTIONS(2653),
    [sym_primitive_type] = ACTIONS(2653),
    [anon_sym_enum] = ACTIONS(2653),
    [anon_sym_class] = ACTIONS(2653),
    [anon_sym_struct] = ACTIONS(2653),
    [anon_sym_union] = ACTIONS(2653),
    [anon_sym_if] = ACTIONS(2653),
    [anon_sym_else] = ACTIONS(2653),
    [anon_sym_switch] = ACTIONS(2653),
    [anon_sym_case] = ACTIONS(2653),
    [anon_sym_default] = ACTIONS(2653),
    [anon_sym_while] = ACTIONS(2653),
    [anon_sym_do] = ACTIONS(2653),
    [anon_sym_for] = ACTIONS(2653),
    [anon_sym_return] = ACTIONS(2653),
    [anon_sym_break] = ACTIONS(2653),
    [anon_sym_continue] = ACTIONS(2653),
    [anon_sym_goto] = ACTIONS(2653),
    [anon_sym___try] = ACTIONS(2653),
    [anon_sym___leave] = ACTIONS(2653),
    [anon_sym_not] = ACTIONS(2653),
    [anon_sym_compl] = ACTIONS(2653),
    [anon_sym_DASH_DASH] = ACTIONS(2655),
    [anon_sym_PLUS_PLUS] = ACTIONS(2655),
    [anon_sym_sizeof] = ACTIONS(2653),
    [anon_sym___alignof__] = ACTIONS(2653),
    [anon_sym___alignof] = ACTIONS(2653),
    [anon_sym__alignof] = ACTIONS(2653),
    [anon_sym_alignof] = ACTIONS(2653),
    [anon_sym__Alignof] = ACTIONS(2653),
    [anon_sym_offsetof] = ACTIONS(2653),
    [anon_sym__Generic] = ACTIONS(2653),
    [anon_sym_asm] = ACTIONS(2653),
    [anon_sym___asm__] = ACTIONS(2653),
    [anon_sym___asm] = ACTIONS(2653),
    [sym_number_literal] = ACTIONS(2655),
    [anon_sym_L_SQUOTE] = ACTIONS(2655),
    [anon_sym_u_SQUOTE] = ACTIONS(2655),
    [anon_sym_U_SQUOTE] = ACTIONS(2655),
    [anon_sym_u8_SQUOTE] = ACTIONS(2655),
    [anon_sym_SQUOTE] = ACTIONS(2655),
    [anon_sym_L_DQUOTE] = ACTIONS(2655),
    [anon_sym_u_DQUOTE] = ACTIONS(2655),
    [anon_sym_U_DQUOTE] = ACTIONS(2655),
    [anon_sym_u8_DQUOTE] = ACTIONS(2655),
    [anon_sym_DQUOTE] = ACTIONS(2655),
    [sym_true] = ACTIONS(2653),
    [sym_false] = ACTIONS(2653),
    [anon_sym_NULL] = ACTIONS(2653),
    [anon_sym_nullptr] = ACTIONS(2653),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2653),
    [anon_sym_decltype] = ACTIONS(2653),
    [anon_sym_explicit] = ACTIONS(2653),
    [anon_sym_typename] = ACTIONS(2653),
    [anon_sym_template] = ACTIONS(2653),
    [anon_sym_operator] = ACTIONS(2653),
    [anon_sym_try] = ACTIONS(2653),
    [anon_sym_delete] = ACTIONS(2653),
    [anon_sym_throw] = ACTIONS(2653),
    [anon_sym_namespace] = ACTIONS(2653),
    [anon_sym_using] = ACTIONS(2653),
    [anon_sym_static_assert] = ACTIONS(2653),
    [anon_sym_concept] = ACTIONS(2653),
    [anon_sym_co_return] = ACTIONS(2653),
    [anon_sym_co_yield] = ACTIONS(2653),
    [anon_sym_R_DQUOTE] = ACTIONS(2655),
    [anon_sym_LR_DQUOTE] = ACTIONS(2655),
    [anon_sym_uR_DQUOTE] = ACTIONS(2655),
    [anon_sym_UR_DQUOTE] = ACTIONS(2655),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2655),
    [anon_sym_co_await] = ACTIONS(2653),
    [anon_sym_new] = ACTIONS(2653),
    [anon_sym_requires] = ACTIONS(2653),
    [sym_this] = ACTIONS(2653),
  },
  [474] = {
    [sym_identifier] = ACTIONS(2657),
    [aux_sym_preproc_include_token1] = ACTIONS(2657),
    [aux_sym_preproc_def_token1] = ACTIONS(2657),
    [aux_sym_preproc_if_token1] = ACTIONS(2657),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2657),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2657),
    [sym_preproc_directive] = ACTIONS(2657),
    [anon_sym_LPAREN2] = ACTIONS(2659),
    [anon_sym_BANG] = ACTIONS(2659),
    [anon_sym_TILDE] = ACTIONS(2659),
    [anon_sym_DASH] = ACTIONS(2657),
    [anon_sym_PLUS] = ACTIONS(2657),
    [anon_sym_STAR] = ACTIONS(2659),
    [anon_sym_AMP_AMP] = ACTIONS(2659),
    [anon_sym_AMP] = ACTIONS(2657),
    [anon_sym_SEMI] = ACTIONS(2659),
    [anon_sym___extension__] = ACTIONS(2657),
    [anon_sym_typedef] = ACTIONS(2657),
    [anon_sym_virtual] = ACTIONS(2657),
    [anon_sym_extern] = ACTIONS(2657),
    [anon_sym___attribute__] = ACTIONS(2657),
    [anon_sym___attribute] = ACTIONS(2657),
    [anon_sym_COLON_COLON] = ACTIONS(2659),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2659),
    [anon_sym___declspec] = ACTIONS(2657),
    [anon_sym___based] = ACTIONS(2657),
    [anon_sym___cdecl] = ACTIONS(2657),
    [anon_sym___clrcall] = ACTIONS(2657),
    [anon_sym___stdcall] = ACTIONS(2657),
    [anon_sym___fastcall] = ACTIONS(2657),
    [anon_sym___thiscall] = ACTIONS(2657),
    [anon_sym___vectorcall] = ACTIONS(2657),
    [anon_sym_LBRACE] = ACTIONS(2659),
    [anon_sym_RBRACE] = ACTIONS(2659),
    [anon_sym_signed] = ACTIONS(2657),
    [anon_sym_unsigned] = ACTIONS(2657),
    [anon_sym_long] = ACTIONS(2657),
    [anon_sym_short] = ACTIONS(2657),
    [anon_sym_LBRACK] = ACTIONS(2657),
    [anon_sym_static] = ACTIONS(2657),
    [anon_sym_register] = ACTIONS(2657),
    [anon_sym_inline] = ACTIONS(2657),
    [anon_sym___inline] = ACTIONS(2657),
    [anon_sym___inline__] = ACTIONS(2657),
    [anon_sym___forceinline] = ACTIONS(2657),
    [anon_sym_thread_local] = ACTIONS(2657),
    [anon_sym___thread] = ACTIONS(2657),
    [anon_sym_const] = ACTIONS(2657),
    [anon_sym_constexpr] = ACTIONS(2657),
    [anon_sym_volatile] = ACTIONS(2657),
    [anon_sym_restrict] = ACTIONS(2657),
    [anon_sym___restrict__] = ACTIONS(2657),
    [anon_sym__Atomic] = ACTIONS(2657),
    [anon_sym__Noreturn] = ACTIONS(2657),
    [anon_sym_noreturn] = ACTIONS(2657),
    [anon_sym__Nonnull] = ACTIONS(2657),
    [anon_sym_mutable] = ACTIONS(2657),
    [anon_sym_constinit] = ACTIONS(2657),
    [anon_sym_consteval] = ACTIONS(2657),
    [anon_sym_alignas] = ACTIONS(2657),
    [anon_sym__Alignas] = ACTIONS(2657),
    [sym_primitive_type] = ACTIONS(2657),
    [anon_sym_enum] = ACTIONS(2657),
    [anon_sym_class] = ACTIONS(2657),
    [anon_sym_struct] = ACTIONS(2657),
    [anon_sym_union] = ACTIONS(2657),
    [anon_sym_if] = ACTIONS(2657),
    [anon_sym_else] = ACTIONS(2657),
    [anon_sym_switch] = ACTIONS(2657),
    [anon_sym_case] = ACTIONS(2657),
    [anon_sym_default] = ACTIONS(2657),
    [anon_sym_while] = ACTIONS(2657),
    [anon_sym_do] = ACTIONS(2657),
    [anon_sym_for] = ACTIONS(2657),
    [anon_sym_return] = ACTIONS(2657),
    [anon_sym_break] = ACTIONS(2657),
    [anon_sym_continue] = ACTIONS(2657),
    [anon_sym_goto] = ACTIONS(2657),
    [anon_sym___try] = ACTIONS(2657),
    [anon_sym___leave] = ACTIONS(2657),
    [anon_sym_not] = ACTIONS(2657),
    [anon_sym_compl] = ACTIONS(2657),
    [anon_sym_DASH_DASH] = ACTIONS(2659),
    [anon_sym_PLUS_PLUS] = ACTIONS(2659),
    [anon_sym_sizeof] = ACTIONS(2657),
    [anon_sym___alignof__] = ACTIONS(2657),
    [anon_sym___alignof] = ACTIONS(2657),
    [anon_sym__alignof] = ACTIONS(2657),
    [anon_sym_alignof] = ACTIONS(2657),
    [anon_sym__Alignof] = ACTIONS(2657),
    [anon_sym_offsetof] = ACTIONS(2657),
    [anon_sym__Generic] = ACTIONS(2657),
    [anon_sym_asm] = ACTIONS(2657),
    [anon_sym___asm__] = ACTIONS(2657),
    [anon_sym___asm] = ACTIONS(2657),
    [sym_number_literal] = ACTIONS(2659),
    [anon_sym_L_SQUOTE] = ACTIONS(2659),
    [anon_sym_u_SQUOTE] = ACTIONS(2659),
    [anon_sym_U_SQUOTE] = ACTIONS(2659),
    [anon_sym_u8_SQUOTE] = ACTIONS(2659),
    [anon_sym_SQUOTE] = ACTIONS(2659),
    [anon_sym_L_DQUOTE] = ACTIONS(2659),
    [anon_sym_u_DQUOTE] = ACTIONS(2659),
    [anon_sym_U_DQUOTE] = ACTIONS(2659),
    [anon_sym_u8_DQUOTE] = ACTIONS(2659),
    [anon_sym_DQUOTE] = ACTIONS(2659),
    [sym_true] = ACTIONS(2657),
    [sym_false] = ACTIONS(2657),
    [anon_sym_NULL] = ACTIONS(2657),
    [anon_sym_nullptr] = ACTIONS(2657),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2657),
    [anon_sym_decltype] = ACTIONS(2657),
    [anon_sym_explicit] = ACTIONS(2657),
    [anon_sym_typename] = ACTIONS(2657),
    [anon_sym_template] = ACTIONS(2657),
    [anon_sym_operator] = ACTIONS(2657),
    [anon_sym_try] = ACTIONS(2657),
    [anon_sym_delete] = ACTIONS(2657),
    [anon_sym_throw] = ACTIONS(2657),
    [anon_sym_namespace] = ACTIONS(2657),
    [anon_sym_using] = ACTIONS(2657),
    [anon_sym_static_assert] = ACTIONS(2657),
    [anon_sym_concept] = ACTIONS(2657),
    [anon_sym_co_return] = ACTIONS(2657),
    [anon_sym_co_yield] = ACTIONS(2657),
    [anon_sym_R_DQUOTE] = ACTIONS(2659),
    [anon_sym_LR_DQUOTE] = ACTIONS(2659),
    [anon_sym_uR_DQUOTE] = ACTIONS(2659),
    [anon_sym_UR_DQUOTE] = ACTIONS(2659),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2659),
    [anon_sym_co_await] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(2657),
    [anon_sym_requires] = ACTIONS(2657),
    [sym_this] = ACTIONS(2657),
  },
  [475] = {
    [sym_identifier] = ACTIONS(2661),
    [aux_sym_preproc_include_token1] = ACTIONS(2661),
    [aux_sym_preproc_def_token1] = ACTIONS(2661),
    [aux_sym_preproc_if_token1] = ACTIONS(2661),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2661),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2661),
    [sym_preproc_directive] = ACTIONS(2661),
    [anon_sym_LPAREN2] = ACTIONS(2663),
    [anon_sym_BANG] = ACTIONS(2663),
    [anon_sym_TILDE] = ACTIONS(2663),
    [anon_sym_DASH] = ACTIONS(2661),
    [anon_sym_PLUS] = ACTIONS(2661),
    [anon_sym_STAR] = ACTIONS(2663),
    [anon_sym_AMP_AMP] = ACTIONS(2663),
    [anon_sym_AMP] = ACTIONS(2661),
    [anon_sym_SEMI] = ACTIONS(2663),
    [anon_sym___extension__] = ACTIONS(2661),
    [anon_sym_typedef] = ACTIONS(2661),
    [anon_sym_virtual] = ACTIONS(2661),
    [anon_sym_extern] = ACTIONS(2661),
    [anon_sym___attribute__] = ACTIONS(2661),
    [anon_sym___attribute] = ACTIONS(2661),
    [anon_sym_COLON_COLON] = ACTIONS(2663),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2663),
    [anon_sym___declspec] = ACTIONS(2661),
    [anon_sym___based] = ACTIONS(2661),
    [anon_sym___cdecl] = ACTIONS(2661),
    [anon_sym___clrcall] = ACTIONS(2661),
    [anon_sym___stdcall] = ACTIONS(2661),
    [anon_sym___fastcall] = ACTIONS(2661),
    [anon_sym___thiscall] = ACTIONS(2661),
    [anon_sym___vectorcall] = ACTIONS(2661),
    [anon_sym_LBRACE] = ACTIONS(2663),
    [anon_sym_RBRACE] = ACTIONS(2663),
    [anon_sym_signed] = ACTIONS(2661),
    [anon_sym_unsigned] = ACTIONS(2661),
    [anon_sym_long] = ACTIONS(2661),
    [anon_sym_short] = ACTIONS(2661),
    [anon_sym_LBRACK] = ACTIONS(2661),
    [anon_sym_static] = ACTIONS(2661),
    [anon_sym_register] = ACTIONS(2661),
    [anon_sym_inline] = ACTIONS(2661),
    [anon_sym___inline] = ACTIONS(2661),
    [anon_sym___inline__] = ACTIONS(2661),
    [anon_sym___forceinline] = ACTIONS(2661),
    [anon_sym_thread_local] = ACTIONS(2661),
    [anon_sym___thread] = ACTIONS(2661),
    [anon_sym_const] = ACTIONS(2661),
    [anon_sym_constexpr] = ACTIONS(2661),
    [anon_sym_volatile] = ACTIONS(2661),
    [anon_sym_restrict] = ACTIONS(2661),
    [anon_sym___restrict__] = ACTIONS(2661),
    [anon_sym__Atomic] = ACTIONS(2661),
    [anon_sym__Noreturn] = ACTIONS(2661),
    [anon_sym_noreturn] = ACTIONS(2661),
    [anon_sym__Nonnull] = ACTIONS(2661),
    [anon_sym_mutable] = ACTIONS(2661),
    [anon_sym_constinit] = ACTIONS(2661),
    [anon_sym_consteval] = ACTIONS(2661),
    [anon_sym_alignas] = ACTIONS(2661),
    [anon_sym__Alignas] = ACTIONS(2661),
    [sym_primitive_type] = ACTIONS(2661),
    [anon_sym_enum] = ACTIONS(2661),
    [anon_sym_class] = ACTIONS(2661),
    [anon_sym_struct] = ACTIONS(2661),
    [anon_sym_union] = ACTIONS(2661),
    [anon_sym_if] = ACTIONS(2661),
    [anon_sym_else] = ACTIONS(2661),
    [anon_sym_switch] = ACTIONS(2661),
    [anon_sym_case] = ACTIONS(2661),
    [anon_sym_default] = ACTIONS(2661),
    [anon_sym_while] = ACTIONS(2661),
    [anon_sym_do] = ACTIONS(2661),
    [anon_sym_for] = ACTIONS(2661),
    [anon_sym_return] = ACTIONS(2661),
    [anon_sym_break] = ACTIONS(2661),
    [anon_sym_continue] = ACTIONS(2661),
    [anon_sym_goto] = ACTIONS(2661),
    [anon_sym___try] = ACTIONS(2661),
    [anon_sym___leave] = ACTIONS(2661),
    [anon_sym_not] = ACTIONS(2661),
    [anon_sym_compl] = ACTIONS(2661),
    [anon_sym_DASH_DASH] = ACTIONS(2663),
    [anon_sym_PLUS_PLUS] = ACTIONS(2663),
    [anon_sym_sizeof] = ACTIONS(2661),
    [anon_sym___alignof__] = ACTIONS(2661),
    [anon_sym___alignof] = ACTIONS(2661),
    [anon_sym__alignof] = ACTIONS(2661),
    [anon_sym_alignof] = ACTIONS(2661),
    [anon_sym__Alignof] = ACTIONS(2661),
    [anon_sym_offsetof] = ACTIONS(2661),
    [anon_sym__Generic] = ACTIONS(2661),
    [anon_sym_asm] = ACTIONS(2661),
    [anon_sym___asm__] = ACTIONS(2661),
    [anon_sym___asm] = ACTIONS(2661),
    [sym_number_literal] = ACTIONS(2663),
    [anon_sym_L_SQUOTE] = ACTIONS(2663),
    [anon_sym_u_SQUOTE] = ACTIONS(2663),
    [anon_sym_U_SQUOTE] = ACTIONS(2663),
    [anon_sym_u8_SQUOTE] = ACTIONS(2663),
    [anon_sym_SQUOTE] = ACTIONS(2663),
    [anon_sym_L_DQUOTE] = ACTIONS(2663),
    [anon_sym_u_DQUOTE] = ACTIONS(2663),
    [anon_sym_U_DQUOTE] = ACTIONS(2663),
    [anon_sym_u8_DQUOTE] = ACTIONS(2663),
    [anon_sym_DQUOTE] = ACTIONS(2663),
    [sym_true] = ACTIONS(2661),
    [sym_false] = ACTIONS(2661),
    [anon_sym_NULL] = ACTIONS(2661),
    [anon_sym_nullptr] = ACTIONS(2661),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2661),
    [anon_sym_decltype] = ACTIONS(2661),
    [anon_sym_explicit] = ACTIONS(2661),
    [anon_sym_typename] = ACTIONS(2661),
    [anon_sym_template] = ACTIONS(2661),
    [anon_sym_operator] = ACTIONS(2661),
    [anon_sym_try] = ACTIONS(2661),
    [anon_sym_delete] = ACTIONS(2661),
    [anon_sym_throw] = ACTIONS(2661),
    [anon_sym_namespace] = ACTIONS(2661),
    [anon_sym_using] = ACTIONS(2661),
    [anon_sym_static_assert] = ACTIONS(2661),
    [anon_sym_concept] = ACTIONS(2661),
    [anon_sym_co_return] = ACTIONS(2661),
    [anon_sym_co_yield] = ACTIONS(2661),
    [anon_sym_R_DQUOTE] = ACTIONS(2663),
    [anon_sym_LR_DQUOTE] = ACTIONS(2663),
    [anon_sym_uR_DQUOTE] = ACTIONS(2663),
    [anon_sym_UR_DQUOTE] = ACTIONS(2663),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2663),
    [anon_sym_co_await] = ACTIONS(2661),
    [anon_sym_new] = ACTIONS(2661),
    [anon_sym_requires] = ACTIONS(2661),
    [sym_this] = ACTIONS(2661),
  },
  [476] = {
    [sym_identifier] = ACTIONS(2665),
    [aux_sym_preproc_include_token1] = ACTIONS(2665),
    [aux_sym_preproc_def_token1] = ACTIONS(2665),
    [aux_sym_preproc_if_token1] = ACTIONS(2665),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2665),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2665),
    [sym_preproc_directive] = ACTIONS(2665),
    [anon_sym_LPAREN2] = ACTIONS(2667),
    [anon_sym_BANG] = ACTIONS(2667),
    [anon_sym_TILDE] = ACTIONS(2667),
    [anon_sym_DASH] = ACTIONS(2665),
    [anon_sym_PLUS] = ACTIONS(2665),
    [anon_sym_STAR] = ACTIONS(2667),
    [anon_sym_AMP_AMP] = ACTIONS(2667),
    [anon_sym_AMP] = ACTIONS(2665),
    [anon_sym_SEMI] = ACTIONS(2667),
    [anon_sym___extension__] = ACTIONS(2665),
    [anon_sym_typedef] = ACTIONS(2665),
    [anon_sym_virtual] = ACTIONS(2665),
    [anon_sym_extern] = ACTIONS(2665),
    [anon_sym___attribute__] = ACTIONS(2665),
    [anon_sym___attribute] = ACTIONS(2665),
    [anon_sym_COLON_COLON] = ACTIONS(2667),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2667),
    [anon_sym___declspec] = ACTIONS(2665),
    [anon_sym___based] = ACTIONS(2665),
    [anon_sym___cdecl] = ACTIONS(2665),
    [anon_sym___clrcall] = ACTIONS(2665),
    [anon_sym___stdcall] = ACTIONS(2665),
    [anon_sym___fastcall] = ACTIONS(2665),
    [anon_sym___thiscall] = ACTIONS(2665),
    [anon_sym___vectorcall] = ACTIONS(2665),
    [anon_sym_LBRACE] = ACTIONS(2667),
    [anon_sym_RBRACE] = ACTIONS(2667),
    [anon_sym_signed] = ACTIONS(2665),
    [anon_sym_unsigned] = ACTIONS(2665),
    [anon_sym_long] = ACTIONS(2665),
    [anon_sym_short] = ACTIONS(2665),
    [anon_sym_LBRACK] = ACTIONS(2665),
    [anon_sym_static] = ACTIONS(2665),
    [anon_sym_register] = ACTIONS(2665),
    [anon_sym_inline] = ACTIONS(2665),
    [anon_sym___inline] = ACTIONS(2665),
    [anon_sym___inline__] = ACTIONS(2665),
    [anon_sym___forceinline] = ACTIONS(2665),
    [anon_sym_thread_local] = ACTIONS(2665),
    [anon_sym___thread] = ACTIONS(2665),
    [anon_sym_const] = ACTIONS(2665),
    [anon_sym_constexpr] = ACTIONS(2665),
    [anon_sym_volatile] = ACTIONS(2665),
    [anon_sym_restrict] = ACTIONS(2665),
    [anon_sym___restrict__] = ACTIONS(2665),
    [anon_sym__Atomic] = ACTIONS(2665),
    [anon_sym__Noreturn] = ACTIONS(2665),
    [anon_sym_noreturn] = ACTIONS(2665),
    [anon_sym__Nonnull] = ACTIONS(2665),
    [anon_sym_mutable] = ACTIONS(2665),
    [anon_sym_constinit] = ACTIONS(2665),
    [anon_sym_consteval] = ACTIONS(2665),
    [anon_sym_alignas] = ACTIONS(2665),
    [anon_sym__Alignas] = ACTIONS(2665),
    [sym_primitive_type] = ACTIONS(2665),
    [anon_sym_enum] = ACTIONS(2665),
    [anon_sym_class] = ACTIONS(2665),
    [anon_sym_struct] = ACTIONS(2665),
    [anon_sym_union] = ACTIONS(2665),
    [anon_sym_if] = ACTIONS(2665),
    [anon_sym_else] = ACTIONS(2665),
    [anon_sym_switch] = ACTIONS(2665),
    [anon_sym_case] = ACTIONS(2665),
    [anon_sym_default] = ACTIONS(2665),
    [anon_sym_while] = ACTIONS(2665),
    [anon_sym_do] = ACTIONS(2665),
    [anon_sym_for] = ACTIONS(2665),
    [anon_sym_return] = ACTIONS(2665),
    [anon_sym_break] = ACTIONS(2665),
    [anon_sym_continue] = ACTIONS(2665),
    [anon_sym_goto] = ACTIONS(2665),
    [anon_sym___try] = ACTIONS(2665),
    [anon_sym___leave] = ACTIONS(2665),
    [anon_sym_not] = ACTIONS(2665),
    [anon_sym_compl] = ACTIONS(2665),
    [anon_sym_DASH_DASH] = ACTIONS(2667),
    [anon_sym_PLUS_PLUS] = ACTIONS(2667),
    [anon_sym_sizeof] = ACTIONS(2665),
    [anon_sym___alignof__] = ACTIONS(2665),
    [anon_sym___alignof] = ACTIONS(2665),
    [anon_sym__alignof] = ACTIONS(2665),
    [anon_sym_alignof] = ACTIONS(2665),
    [anon_sym__Alignof] = ACTIONS(2665),
    [anon_sym_offsetof] = ACTIONS(2665),
    [anon_sym__Generic] = ACTIONS(2665),
    [anon_sym_asm] = ACTIONS(2665),
    [anon_sym___asm__] = ACTIONS(2665),
    [anon_sym___asm] = ACTIONS(2665),
    [sym_number_literal] = ACTIONS(2667),
    [anon_sym_L_SQUOTE] = ACTIONS(2667),
    [anon_sym_u_SQUOTE] = ACTIONS(2667),
    [anon_sym_U_SQUOTE] = ACTIONS(2667),
    [anon_sym_u8_SQUOTE] = ACTIONS(2667),
    [anon_sym_SQUOTE] = ACTIONS(2667),
    [anon_sym_L_DQUOTE] = ACTIONS(2667),
    [anon_sym_u_DQUOTE] = ACTIONS(2667),
    [anon_sym_U_DQUOTE] = ACTIONS(2667),
    [anon_sym_u8_DQUOTE] = ACTIONS(2667),
    [anon_sym_DQUOTE] = ACTIONS(2667),
    [sym_true] = ACTIONS(2665),
    [sym_false] = ACTIONS(2665),
    [anon_sym_NULL] = ACTIONS(2665),
    [anon_sym_nullptr] = ACTIONS(2665),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2665),
    [anon_sym_decltype] = ACTIONS(2665),
    [anon_sym_explicit] = ACTIONS(2665),
    [anon_sym_typename] = ACTIONS(2665),
    [anon_sym_template] = ACTIONS(2665),
    [anon_sym_operator] = ACTIONS(2665),
    [anon_sym_try] = ACTIONS(2665),
    [anon_sym_delete] = ACTIONS(2665),
    [anon_sym_throw] = ACTIONS(2665),
    [anon_sym_namespace] = ACTIONS(2665),
    [anon_sym_using] = ACTIONS(2665),
    [anon_sym_static_assert] = ACTIONS(2665),
    [anon_sym_concept] = ACTIONS(2665),
    [anon_sym_co_return] = ACTIONS(2665),
    [anon_sym_co_yield] = ACTIONS(2665),
    [anon_sym_R_DQUOTE] = ACTIONS(2667),
    [anon_sym_LR_DQUOTE] = ACTIONS(2667),
    [anon_sym_uR_DQUOTE] = ACTIONS(2667),
    [anon_sym_UR_DQUOTE] = ACTIONS(2667),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2667),
    [anon_sym_co_await] = ACTIONS(2665),
    [anon_sym_new] = ACTIONS(2665),
    [anon_sym_requires] = ACTIONS(2665),
    [sym_this] = ACTIONS(2665),
  },
  [477] = {
    [sym_identifier] = ACTIONS(2669),
    [aux_sym_preproc_include_token1] = ACTIONS(2669),
    [aux_sym_preproc_def_token1] = ACTIONS(2669),
    [aux_sym_preproc_if_token1] = ACTIONS(2669),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2669),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2669),
    [sym_preproc_directive] = ACTIONS(2669),
    [anon_sym_LPAREN2] = ACTIONS(2671),
    [anon_sym_BANG] = ACTIONS(2671),
    [anon_sym_TILDE] = ACTIONS(2671),
    [anon_sym_DASH] = ACTIONS(2669),
    [anon_sym_PLUS] = ACTIONS(2669),
    [anon_sym_STAR] = ACTIONS(2671),
    [anon_sym_AMP_AMP] = ACTIONS(2671),
    [anon_sym_AMP] = ACTIONS(2669),
    [anon_sym_SEMI] = ACTIONS(2671),
    [anon_sym___extension__] = ACTIONS(2669),
    [anon_sym_typedef] = ACTIONS(2669),
    [anon_sym_virtual] = ACTIONS(2669),
    [anon_sym_extern] = ACTIONS(2669),
    [anon_sym___attribute__] = ACTIONS(2669),
    [anon_sym___attribute] = ACTIONS(2669),
    [anon_sym_COLON_COLON] = ACTIONS(2671),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2671),
    [anon_sym___declspec] = ACTIONS(2669),
    [anon_sym___based] = ACTIONS(2669),
    [anon_sym___cdecl] = ACTIONS(2669),
    [anon_sym___clrcall] = ACTIONS(2669),
    [anon_sym___stdcall] = ACTIONS(2669),
    [anon_sym___fastcall] = ACTIONS(2669),
    [anon_sym___thiscall] = ACTIONS(2669),
    [anon_sym___vectorcall] = ACTIONS(2669),
    [anon_sym_LBRACE] = ACTIONS(2671),
    [anon_sym_RBRACE] = ACTIONS(2671),
    [anon_sym_signed] = ACTIONS(2669),
    [anon_sym_unsigned] = ACTIONS(2669),
    [anon_sym_long] = ACTIONS(2669),
    [anon_sym_short] = ACTIONS(2669),
    [anon_sym_LBRACK] = ACTIONS(2669),
    [anon_sym_static] = ACTIONS(2669),
    [anon_sym_register] = ACTIONS(2669),
    [anon_sym_inline] = ACTIONS(2669),
    [anon_sym___inline] = ACTIONS(2669),
    [anon_sym___inline__] = ACTIONS(2669),
    [anon_sym___forceinline] = ACTIONS(2669),
    [anon_sym_thread_local] = ACTIONS(2669),
    [anon_sym___thread] = ACTIONS(2669),
    [anon_sym_const] = ACTIONS(2669),
    [anon_sym_constexpr] = ACTIONS(2669),
    [anon_sym_volatile] = ACTIONS(2669),
    [anon_sym_restrict] = ACTIONS(2669),
    [anon_sym___restrict__] = ACTIONS(2669),
    [anon_sym__Atomic] = ACTIONS(2669),
    [anon_sym__Noreturn] = ACTIONS(2669),
    [anon_sym_noreturn] = ACTIONS(2669),
    [anon_sym__Nonnull] = ACTIONS(2669),
    [anon_sym_mutable] = ACTIONS(2669),
    [anon_sym_constinit] = ACTIONS(2669),
    [anon_sym_consteval] = ACTIONS(2669),
    [anon_sym_alignas] = ACTIONS(2669),
    [anon_sym__Alignas] = ACTIONS(2669),
    [sym_primitive_type] = ACTIONS(2669),
    [anon_sym_enum] = ACTIONS(2669),
    [anon_sym_class] = ACTIONS(2669),
    [anon_sym_struct] = ACTIONS(2669),
    [anon_sym_union] = ACTIONS(2669),
    [anon_sym_if] = ACTIONS(2669),
    [anon_sym_else] = ACTIONS(2669),
    [anon_sym_switch] = ACTIONS(2669),
    [anon_sym_case] = ACTIONS(2669),
    [anon_sym_default] = ACTIONS(2669),
    [anon_sym_while] = ACTIONS(2669),
    [anon_sym_do] = ACTIONS(2669),
    [anon_sym_for] = ACTIONS(2669),
    [anon_sym_return] = ACTIONS(2669),
    [anon_sym_break] = ACTIONS(2669),
    [anon_sym_continue] = ACTIONS(2669),
    [anon_sym_goto] = ACTIONS(2669),
    [anon_sym___try] = ACTIONS(2669),
    [anon_sym___leave] = ACTIONS(2669),
    [anon_sym_not] = ACTIONS(2669),
    [anon_sym_compl] = ACTIONS(2669),
    [anon_sym_DASH_DASH] = ACTIONS(2671),
    [anon_sym_PLUS_PLUS] = ACTIONS(2671),
    [anon_sym_sizeof] = ACTIONS(2669),
    [anon_sym___alignof__] = ACTIONS(2669),
    [anon_sym___alignof] = ACTIONS(2669),
    [anon_sym__alignof] = ACTIONS(2669),
    [anon_sym_alignof] = ACTIONS(2669),
    [anon_sym__Alignof] = ACTIONS(2669),
    [anon_sym_offsetof] = ACTIONS(2669),
    [anon_sym__Generic] = ACTIONS(2669),
    [anon_sym_asm] = ACTIONS(2669),
    [anon_sym___asm__] = ACTIONS(2669),
    [anon_sym___asm] = ACTIONS(2669),
    [sym_number_literal] = ACTIONS(2671),
    [anon_sym_L_SQUOTE] = ACTIONS(2671),
    [anon_sym_u_SQUOTE] = ACTIONS(2671),
    [anon_sym_U_SQUOTE] = ACTIONS(2671),
    [anon_sym_u8_SQUOTE] = ACTIONS(2671),
    [anon_sym_SQUOTE] = ACTIONS(2671),
    [anon_sym_L_DQUOTE] = ACTIONS(2671),
    [anon_sym_u_DQUOTE] = ACTIONS(2671),
    [anon_sym_U_DQUOTE] = ACTIONS(2671),
    [anon_sym_u8_DQUOTE] = ACTIONS(2671),
    [anon_sym_DQUOTE] = ACTIONS(2671),
    [sym_true] = ACTIONS(2669),
    [sym_false] = ACTIONS(2669),
    [anon_sym_NULL] = ACTIONS(2669),
    [anon_sym_nullptr] = ACTIONS(2669),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2669),
    [anon_sym_decltype] = ACTIONS(2669),
    [anon_sym_explicit] = ACTIONS(2669),
    [anon_sym_typename] = ACTIONS(2669),
    [anon_sym_template] = ACTIONS(2669),
    [anon_sym_operator] = ACTIONS(2669),
    [anon_sym_try] = ACTIONS(2669),
    [anon_sym_delete] = ACTIONS(2669),
    [anon_sym_throw] = ACTIONS(2669),
    [anon_sym_namespace] = ACTIONS(2669),
    [anon_sym_using] = ACTIONS(2669),
    [anon_sym_static_assert] = ACTIONS(2669),
    [anon_sym_concept] = ACTIONS(2669),
    [anon_sym_co_return] = ACTIONS(2669),
    [anon_sym_co_yield] = ACTIONS(2669),
    [anon_sym_R_DQUOTE] = ACTIONS(2671),
    [anon_sym_LR_DQUOTE] = ACTIONS(2671),
    [anon_sym_uR_DQUOTE] = ACTIONS(2671),
    [anon_sym_UR_DQUOTE] = ACTIONS(2671),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2671),
    [anon_sym_co_await] = ACTIONS(2669),
    [anon_sym_new] = ACTIONS(2669),
    [anon_sym_requires] = ACTIONS(2669),
    [sym_this] = ACTIONS(2669),
  },
  [478] = {
    [sym_identifier] = ACTIONS(2673),
    [aux_sym_preproc_include_token1] = ACTIONS(2673),
    [aux_sym_preproc_def_token1] = ACTIONS(2673),
    [aux_sym_preproc_if_token1] = ACTIONS(2673),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2673),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2673),
    [sym_preproc_directive] = ACTIONS(2673),
    [anon_sym_LPAREN2] = ACTIONS(2675),
    [anon_sym_BANG] = ACTIONS(2675),
    [anon_sym_TILDE] = ACTIONS(2675),
    [anon_sym_DASH] = ACTIONS(2673),
    [anon_sym_PLUS] = ACTIONS(2673),
    [anon_sym_STAR] = ACTIONS(2675),
    [anon_sym_AMP_AMP] = ACTIONS(2675),
    [anon_sym_AMP] = ACTIONS(2673),
    [anon_sym_SEMI] = ACTIONS(2675),
    [anon_sym___extension__] = ACTIONS(2673),
    [anon_sym_typedef] = ACTIONS(2673),
    [anon_sym_virtual] = ACTIONS(2673),
    [anon_sym_extern] = ACTIONS(2673),
    [anon_sym___attribute__] = ACTIONS(2673),
    [anon_sym___attribute] = ACTIONS(2673),
    [anon_sym_COLON_COLON] = ACTIONS(2675),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2675),
    [anon_sym___declspec] = ACTIONS(2673),
    [anon_sym___based] = ACTIONS(2673),
    [anon_sym___cdecl] = ACTIONS(2673),
    [anon_sym___clrcall] = ACTIONS(2673),
    [anon_sym___stdcall] = ACTIONS(2673),
    [anon_sym___fastcall] = ACTIONS(2673),
    [anon_sym___thiscall] = ACTIONS(2673),
    [anon_sym___vectorcall] = ACTIONS(2673),
    [anon_sym_LBRACE] = ACTIONS(2675),
    [anon_sym_RBRACE] = ACTIONS(2675),
    [anon_sym_signed] = ACTIONS(2673),
    [anon_sym_unsigned] = ACTIONS(2673),
    [anon_sym_long] = ACTIONS(2673),
    [anon_sym_short] = ACTIONS(2673),
    [anon_sym_LBRACK] = ACTIONS(2673),
    [anon_sym_static] = ACTIONS(2673),
    [anon_sym_register] = ACTIONS(2673),
    [anon_sym_inline] = ACTIONS(2673),
    [anon_sym___inline] = ACTIONS(2673),
    [anon_sym___inline__] = ACTIONS(2673),
    [anon_sym___forceinline] = ACTIONS(2673),
    [anon_sym_thread_local] = ACTIONS(2673),
    [anon_sym___thread] = ACTIONS(2673),
    [anon_sym_const] = ACTIONS(2673),
    [anon_sym_constexpr] = ACTIONS(2673),
    [anon_sym_volatile] = ACTIONS(2673),
    [anon_sym_restrict] = ACTIONS(2673),
    [anon_sym___restrict__] = ACTIONS(2673),
    [anon_sym__Atomic] = ACTIONS(2673),
    [anon_sym__Noreturn] = ACTIONS(2673),
    [anon_sym_noreturn] = ACTIONS(2673),
    [anon_sym__Nonnull] = ACTIONS(2673),
    [anon_sym_mutable] = ACTIONS(2673),
    [anon_sym_constinit] = ACTIONS(2673),
    [anon_sym_consteval] = ACTIONS(2673),
    [anon_sym_alignas] = ACTIONS(2673),
    [anon_sym__Alignas] = ACTIONS(2673),
    [sym_primitive_type] = ACTIONS(2673),
    [anon_sym_enum] = ACTIONS(2673),
    [anon_sym_class] = ACTIONS(2673),
    [anon_sym_struct] = ACTIONS(2673),
    [anon_sym_union] = ACTIONS(2673),
    [anon_sym_if] = ACTIONS(2673),
    [anon_sym_else] = ACTIONS(2673),
    [anon_sym_switch] = ACTIONS(2673),
    [anon_sym_case] = ACTIONS(2673),
    [anon_sym_default] = ACTIONS(2673),
    [anon_sym_while] = ACTIONS(2673),
    [anon_sym_do] = ACTIONS(2673),
    [anon_sym_for] = ACTIONS(2673),
    [anon_sym_return] = ACTIONS(2673),
    [anon_sym_break] = ACTIONS(2673),
    [anon_sym_continue] = ACTIONS(2673),
    [anon_sym_goto] = ACTIONS(2673),
    [anon_sym___try] = ACTIONS(2673),
    [anon_sym___leave] = ACTIONS(2673),
    [anon_sym_not] = ACTIONS(2673),
    [anon_sym_compl] = ACTIONS(2673),
    [anon_sym_DASH_DASH] = ACTIONS(2675),
    [anon_sym_PLUS_PLUS] = ACTIONS(2675),
    [anon_sym_sizeof] = ACTIONS(2673),
    [anon_sym___alignof__] = ACTIONS(2673),
    [anon_sym___alignof] = ACTIONS(2673),
    [anon_sym__alignof] = ACTIONS(2673),
    [anon_sym_alignof] = ACTIONS(2673),
    [anon_sym__Alignof] = ACTIONS(2673),
    [anon_sym_offsetof] = ACTIONS(2673),
    [anon_sym__Generic] = ACTIONS(2673),
    [anon_sym_asm] = ACTIONS(2673),
    [anon_sym___asm__] = ACTIONS(2673),
    [anon_sym___asm] = ACTIONS(2673),
    [sym_number_literal] = ACTIONS(2675),
    [anon_sym_L_SQUOTE] = ACTIONS(2675),
    [anon_sym_u_SQUOTE] = ACTIONS(2675),
    [anon_sym_U_SQUOTE] = ACTIONS(2675),
    [anon_sym_u8_SQUOTE] = ACTIONS(2675),
    [anon_sym_SQUOTE] = ACTIONS(2675),
    [anon_sym_L_DQUOTE] = ACTIONS(2675),
    [anon_sym_u_DQUOTE] = ACTIONS(2675),
    [anon_sym_U_DQUOTE] = ACTIONS(2675),
    [anon_sym_u8_DQUOTE] = ACTIONS(2675),
    [anon_sym_DQUOTE] = ACTIONS(2675),
    [sym_true] = ACTIONS(2673),
    [sym_false] = ACTIONS(2673),
    [anon_sym_NULL] = ACTIONS(2673),
    [anon_sym_nullptr] = ACTIONS(2673),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2673),
    [anon_sym_decltype] = ACTIONS(2673),
    [anon_sym_explicit] = ACTIONS(2673),
    [anon_sym_typename] = ACTIONS(2673),
    [anon_sym_template] = ACTIONS(2673),
    [anon_sym_operator] = ACTIONS(2673),
    [anon_sym_try] = ACTIONS(2673),
    [anon_sym_delete] = ACTIONS(2673),
    [anon_sym_throw] = ACTIONS(2673),
    [anon_sym_namespace] = ACTIONS(2673),
    [anon_sym_using] = ACTIONS(2673),
    [anon_sym_static_assert] = ACTIONS(2673),
    [anon_sym_concept] = ACTIONS(2673),
    [anon_sym_co_return] = ACTIONS(2673),
    [anon_sym_co_yield] = ACTIONS(2673),
    [anon_sym_R_DQUOTE] = ACTIONS(2675),
    [anon_sym_LR_DQUOTE] = ACTIONS(2675),
    [anon_sym_uR_DQUOTE] = ACTIONS(2675),
    [anon_sym_UR_DQUOTE] = ACTIONS(2675),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2675),
    [anon_sym_co_await] = ACTIONS(2673),
    [anon_sym_new] = ACTIONS(2673),
    [anon_sym_requires] = ACTIONS(2673),
    [sym_this] = ACTIONS(2673),
  },
  [479] = {
    [ts_builtin_sym_end] = ACTIONS(2659),
    [sym_identifier] = ACTIONS(2657),
    [aux_sym_preproc_include_token1] = ACTIONS(2657),
    [aux_sym_preproc_def_token1] = ACTIONS(2657),
    [aux_sym_preproc_if_token1] = ACTIONS(2657),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2657),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2657),
    [sym_preproc_directive] = ACTIONS(2657),
    [anon_sym_LPAREN2] = ACTIONS(2659),
    [anon_sym_BANG] = ACTIONS(2659),
    [anon_sym_TILDE] = ACTIONS(2659),
    [anon_sym_DASH] = ACTIONS(2657),
    [anon_sym_PLUS] = ACTIONS(2657),
    [anon_sym_STAR] = ACTIONS(2659),
    [anon_sym_AMP_AMP] = ACTIONS(2659),
    [anon_sym_AMP] = ACTIONS(2657),
    [anon_sym_SEMI] = ACTIONS(2659),
    [anon_sym___extension__] = ACTIONS(2657),
    [anon_sym_typedef] = ACTIONS(2657),
    [anon_sym_virtual] = ACTIONS(2657),
    [anon_sym_extern] = ACTIONS(2657),
    [anon_sym___attribute__] = ACTIONS(2657),
    [anon_sym___attribute] = ACTIONS(2657),
    [anon_sym_COLON_COLON] = ACTIONS(2659),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2659),
    [anon_sym___declspec] = ACTIONS(2657),
    [anon_sym___based] = ACTIONS(2657),
    [anon_sym___cdecl] = ACTIONS(2657),
    [anon_sym___clrcall] = ACTIONS(2657),
    [anon_sym___stdcall] = ACTIONS(2657),
    [anon_sym___fastcall] = ACTIONS(2657),
    [anon_sym___thiscall] = ACTIONS(2657),
    [anon_sym___vectorcall] = ACTIONS(2657),
    [anon_sym_LBRACE] = ACTIONS(2659),
    [anon_sym_signed] = ACTIONS(2657),
    [anon_sym_unsigned] = ACTIONS(2657),
    [anon_sym_long] = ACTIONS(2657),
    [anon_sym_short] = ACTIONS(2657),
    [anon_sym_LBRACK] = ACTIONS(2657),
    [anon_sym_static] = ACTIONS(2657),
    [anon_sym_register] = ACTIONS(2657),
    [anon_sym_inline] = ACTIONS(2657),
    [anon_sym___inline] = ACTIONS(2657),
    [anon_sym___inline__] = ACTIONS(2657),
    [anon_sym___forceinline] = ACTIONS(2657),
    [anon_sym_thread_local] = ACTIONS(2657),
    [anon_sym___thread] = ACTIONS(2657),
    [anon_sym_const] = ACTIONS(2657),
    [anon_sym_constexpr] = ACTIONS(2657),
    [anon_sym_volatile] = ACTIONS(2657),
    [anon_sym_restrict] = ACTIONS(2657),
    [anon_sym___restrict__] = ACTIONS(2657),
    [anon_sym__Atomic] = ACTIONS(2657),
    [anon_sym__Noreturn] = ACTIONS(2657),
    [anon_sym_noreturn] = ACTIONS(2657),
    [anon_sym__Nonnull] = ACTIONS(2657),
    [anon_sym_mutable] = ACTIONS(2657),
    [anon_sym_constinit] = ACTIONS(2657),
    [anon_sym_consteval] = ACTIONS(2657),
    [anon_sym_alignas] = ACTIONS(2657),
    [anon_sym__Alignas] = ACTIONS(2657),
    [sym_primitive_type] = ACTIONS(2657),
    [anon_sym_enum] = ACTIONS(2657),
    [anon_sym_class] = ACTIONS(2657),
    [anon_sym_struct] = ACTIONS(2657),
    [anon_sym_union] = ACTIONS(2657),
    [anon_sym_if] = ACTIONS(2657),
    [anon_sym_else] = ACTIONS(2657),
    [anon_sym_switch] = ACTIONS(2657),
    [anon_sym_case] = ACTIONS(2657),
    [anon_sym_default] = ACTIONS(2657),
    [anon_sym_while] = ACTIONS(2657),
    [anon_sym_do] = ACTIONS(2657),
    [anon_sym_for] = ACTIONS(2657),
    [anon_sym_return] = ACTIONS(2657),
    [anon_sym_break] = ACTIONS(2657),
    [anon_sym_continue] = ACTIONS(2657),
    [anon_sym_goto] = ACTIONS(2657),
    [anon_sym___try] = ACTIONS(2657),
    [anon_sym___leave] = ACTIONS(2657),
    [anon_sym_not] = ACTIONS(2657),
    [anon_sym_compl] = ACTIONS(2657),
    [anon_sym_DASH_DASH] = ACTIONS(2659),
    [anon_sym_PLUS_PLUS] = ACTIONS(2659),
    [anon_sym_sizeof] = ACTIONS(2657),
    [anon_sym___alignof__] = ACTIONS(2657),
    [anon_sym___alignof] = ACTIONS(2657),
    [anon_sym__alignof] = ACTIONS(2657),
    [anon_sym_alignof] = ACTIONS(2657),
    [anon_sym__Alignof] = ACTIONS(2657),
    [anon_sym_offsetof] = ACTIONS(2657),
    [anon_sym__Generic] = ACTIONS(2657),
    [anon_sym_asm] = ACTIONS(2657),
    [anon_sym___asm__] = ACTIONS(2657),
    [anon_sym___asm] = ACTIONS(2657),
    [sym_number_literal] = ACTIONS(2659),
    [anon_sym_L_SQUOTE] = ACTIONS(2659),
    [anon_sym_u_SQUOTE] = ACTIONS(2659),
    [anon_sym_U_SQUOTE] = ACTIONS(2659),
    [anon_sym_u8_SQUOTE] = ACTIONS(2659),
    [anon_sym_SQUOTE] = ACTIONS(2659),
    [anon_sym_L_DQUOTE] = ACTIONS(2659),
    [anon_sym_u_DQUOTE] = ACTIONS(2659),
    [anon_sym_U_DQUOTE] = ACTIONS(2659),
    [anon_sym_u8_DQUOTE] = ACTIONS(2659),
    [anon_sym_DQUOTE] = ACTIONS(2659),
    [sym_true] = ACTIONS(2657),
    [sym_false] = ACTIONS(2657),
    [anon_sym_NULL] = ACTIONS(2657),
    [anon_sym_nullptr] = ACTIONS(2657),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2657),
    [anon_sym_decltype] = ACTIONS(2657),
    [anon_sym_explicit] = ACTIONS(2657),
    [anon_sym_typename] = ACTIONS(2657),
    [anon_sym_template] = ACTIONS(2657),
    [anon_sym_operator] = ACTIONS(2657),
    [anon_sym_try] = ACTIONS(2657),
    [anon_sym_delete] = ACTIONS(2657),
    [anon_sym_throw] = ACTIONS(2657),
    [anon_sym_namespace] = ACTIONS(2657),
    [anon_sym_using] = ACTIONS(2657),
    [anon_sym_static_assert] = ACTIONS(2657),
    [anon_sym_concept] = ACTIONS(2657),
    [anon_sym_co_return] = ACTIONS(2657),
    [anon_sym_co_yield] = ACTIONS(2657),
    [anon_sym_R_DQUOTE] = ACTIONS(2659),
    [anon_sym_LR_DQUOTE] = ACTIONS(2659),
    [anon_sym_uR_DQUOTE] = ACTIONS(2659),
    [anon_sym_UR_DQUOTE] = ACTIONS(2659),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2659),
    [anon_sym_co_await] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(2657),
    [anon_sym_requires] = ACTIONS(2657),
    [sym_this] = ACTIONS(2657),
  },
  [480] = {
    [ts_builtin_sym_end] = ACTIONS(2663),
    [sym_identifier] = ACTIONS(2661),
    [aux_sym_preproc_include_token1] = ACTIONS(2661),
    [aux_sym_preproc_def_token1] = ACTIONS(2661),
    [aux_sym_preproc_if_token1] = ACTIONS(2661),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2661),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2661),
    [sym_preproc_directive] = ACTIONS(2661),
    [anon_sym_LPAREN2] = ACTIONS(2663),
    [anon_sym_BANG] = ACTIONS(2663),
    [anon_sym_TILDE] = ACTIONS(2663),
    [anon_sym_DASH] = ACTIONS(2661),
    [anon_sym_PLUS] = ACTIONS(2661),
    [anon_sym_STAR] = ACTIONS(2663),
    [anon_sym_AMP_AMP] = ACTIONS(2663),
    [anon_sym_AMP] = ACTIONS(2661),
    [anon_sym_SEMI] = ACTIONS(2663),
    [anon_sym___extension__] = ACTIONS(2661),
    [anon_sym_typedef] = ACTIONS(2661),
    [anon_sym_virtual] = ACTIONS(2661),
    [anon_sym_extern] = ACTIONS(2661),
    [anon_sym___attribute__] = ACTIONS(2661),
    [anon_sym___attribute] = ACTIONS(2661),
    [anon_sym_COLON_COLON] = ACTIONS(2663),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2663),
    [anon_sym___declspec] = ACTIONS(2661),
    [anon_sym___based] = ACTIONS(2661),
    [anon_sym___cdecl] = ACTIONS(2661),
    [anon_sym___clrcall] = ACTIONS(2661),
    [anon_sym___stdcall] = ACTIONS(2661),
    [anon_sym___fastcall] = ACTIONS(2661),
    [anon_sym___thiscall] = ACTIONS(2661),
    [anon_sym___vectorcall] = ACTIONS(2661),
    [anon_sym_LBRACE] = ACTIONS(2663),
    [anon_sym_signed] = ACTIONS(2661),
    [anon_sym_unsigned] = ACTIONS(2661),
    [anon_sym_long] = ACTIONS(2661),
    [anon_sym_short] = ACTIONS(2661),
    [anon_sym_LBRACK] = ACTIONS(2661),
    [anon_sym_static] = ACTIONS(2661),
    [anon_sym_register] = ACTIONS(2661),
    [anon_sym_inline] = ACTIONS(2661),
    [anon_sym___inline] = ACTIONS(2661),
    [anon_sym___inline__] = ACTIONS(2661),
    [anon_sym___forceinline] = ACTIONS(2661),
    [anon_sym_thread_local] = ACTIONS(2661),
    [anon_sym___thread] = ACTIONS(2661),
    [anon_sym_const] = ACTIONS(2661),
    [anon_sym_constexpr] = ACTIONS(2661),
    [anon_sym_volatile] = ACTIONS(2661),
    [anon_sym_restrict] = ACTIONS(2661),
    [anon_sym___restrict__] = ACTIONS(2661),
    [anon_sym__Atomic] = ACTIONS(2661),
    [anon_sym__Noreturn] = ACTIONS(2661),
    [anon_sym_noreturn] = ACTIONS(2661),
    [anon_sym__Nonnull] = ACTIONS(2661),
    [anon_sym_mutable] = ACTIONS(2661),
    [anon_sym_constinit] = ACTIONS(2661),
    [anon_sym_consteval] = ACTIONS(2661),
    [anon_sym_alignas] = ACTIONS(2661),
    [anon_sym__Alignas] = ACTIONS(2661),
    [sym_primitive_type] = ACTIONS(2661),
    [anon_sym_enum] = ACTIONS(2661),
    [anon_sym_class] = ACTIONS(2661),
    [anon_sym_struct] = ACTIONS(2661),
    [anon_sym_union] = ACTIONS(2661),
    [anon_sym_if] = ACTIONS(2661),
    [anon_sym_else] = ACTIONS(2661),
    [anon_sym_switch] = ACTIONS(2661),
    [anon_sym_case] = ACTIONS(2661),
    [anon_sym_default] = ACTIONS(2661),
    [anon_sym_while] = ACTIONS(2661),
    [anon_sym_do] = ACTIONS(2661),
    [anon_sym_for] = ACTIONS(2661),
    [anon_sym_return] = ACTIONS(2661),
    [anon_sym_break] = ACTIONS(2661),
    [anon_sym_continue] = ACTIONS(2661),
    [anon_sym_goto] = ACTIONS(2661),
    [anon_sym___try] = ACTIONS(2661),
    [anon_sym___leave] = ACTIONS(2661),
    [anon_sym_not] = ACTIONS(2661),
    [anon_sym_compl] = ACTIONS(2661),
    [anon_sym_DASH_DASH] = ACTIONS(2663),
    [anon_sym_PLUS_PLUS] = ACTIONS(2663),
    [anon_sym_sizeof] = ACTIONS(2661),
    [anon_sym___alignof__] = ACTIONS(2661),
    [anon_sym___alignof] = ACTIONS(2661),
    [anon_sym__alignof] = ACTIONS(2661),
    [anon_sym_alignof] = ACTIONS(2661),
    [anon_sym__Alignof] = ACTIONS(2661),
    [anon_sym_offsetof] = ACTIONS(2661),
    [anon_sym__Generic] = ACTIONS(2661),
    [anon_sym_asm] = ACTIONS(2661),
    [anon_sym___asm__] = ACTIONS(2661),
    [anon_sym___asm] = ACTIONS(2661),
    [sym_number_literal] = ACTIONS(2663),
    [anon_sym_L_SQUOTE] = ACTIONS(2663),
    [anon_sym_u_SQUOTE] = ACTIONS(2663),
    [anon_sym_U_SQUOTE] = ACTIONS(2663),
    [anon_sym_u8_SQUOTE] = ACTIONS(2663),
    [anon_sym_SQUOTE] = ACTIONS(2663),
    [anon_sym_L_DQUOTE] = ACTIONS(2663),
    [anon_sym_u_DQUOTE] = ACTIONS(2663),
    [anon_sym_U_DQUOTE] = ACTIONS(2663),
    [anon_sym_u8_DQUOTE] = ACTIONS(2663),
    [anon_sym_DQUOTE] = ACTIONS(2663),
    [sym_true] = ACTIONS(2661),
    [sym_false] = ACTIONS(2661),
    [anon_sym_NULL] = ACTIONS(2661),
    [anon_sym_nullptr] = ACTIONS(2661),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2661),
    [anon_sym_decltype] = ACTIONS(2661),
    [anon_sym_explicit] = ACTIONS(2661),
    [anon_sym_typename] = ACTIONS(2661),
    [anon_sym_template] = ACTIONS(2661),
    [anon_sym_operator] = ACTIONS(2661),
    [anon_sym_try] = ACTIONS(2661),
    [anon_sym_delete] = ACTIONS(2661),
    [anon_sym_throw] = ACTIONS(2661),
    [anon_sym_namespace] = ACTIONS(2661),
    [anon_sym_using] = ACTIONS(2661),
    [anon_sym_static_assert] = ACTIONS(2661),
    [anon_sym_concept] = ACTIONS(2661),
    [anon_sym_co_return] = ACTIONS(2661),
    [anon_sym_co_yield] = ACTIONS(2661),
    [anon_sym_R_DQUOTE] = ACTIONS(2663),
    [anon_sym_LR_DQUOTE] = ACTIONS(2663),
    [anon_sym_uR_DQUOTE] = ACTIONS(2663),
    [anon_sym_UR_DQUOTE] = ACTIONS(2663),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2663),
    [anon_sym_co_await] = ACTIONS(2661),
    [anon_sym_new] = ACTIONS(2661),
    [anon_sym_requires] = ACTIONS(2661),
    [sym_this] = ACTIONS(2661),
  },
  [481] = {
    [ts_builtin_sym_end] = ACTIONS(2667),
    [sym_identifier] = ACTIONS(2665),
    [aux_sym_preproc_include_token1] = ACTIONS(2665),
    [aux_sym_preproc_def_token1] = ACTIONS(2665),
    [aux_sym_preproc_if_token1] = ACTIONS(2665),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2665),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2665),
    [sym_preproc_directive] = ACTIONS(2665),
    [anon_sym_LPAREN2] = ACTIONS(2667),
    [anon_sym_BANG] = ACTIONS(2667),
    [anon_sym_TILDE] = ACTIONS(2667),
    [anon_sym_DASH] = ACTIONS(2665),
    [anon_sym_PLUS] = ACTIONS(2665),
    [anon_sym_STAR] = ACTIONS(2667),
    [anon_sym_AMP_AMP] = ACTIONS(2667),
    [anon_sym_AMP] = ACTIONS(2665),
    [anon_sym_SEMI] = ACTIONS(2667),
    [anon_sym___extension__] = ACTIONS(2665),
    [anon_sym_typedef] = ACTIONS(2665),
    [anon_sym_virtual] = ACTIONS(2665),
    [anon_sym_extern] = ACTIONS(2665),
    [anon_sym___attribute__] = ACTIONS(2665),
    [anon_sym___attribute] = ACTIONS(2665),
    [anon_sym_COLON_COLON] = ACTIONS(2667),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2667),
    [anon_sym___declspec] = ACTIONS(2665),
    [anon_sym___based] = ACTIONS(2665),
    [anon_sym___cdecl] = ACTIONS(2665),
    [anon_sym___clrcall] = ACTIONS(2665),
    [anon_sym___stdcall] = ACTIONS(2665),
    [anon_sym___fastcall] = ACTIONS(2665),
    [anon_sym___thiscall] = ACTIONS(2665),
    [anon_sym___vectorcall] = ACTIONS(2665),
    [anon_sym_LBRACE] = ACTIONS(2667),
    [anon_sym_signed] = ACTIONS(2665),
    [anon_sym_unsigned] = ACTIONS(2665),
    [anon_sym_long] = ACTIONS(2665),
    [anon_sym_short] = ACTIONS(2665),
    [anon_sym_LBRACK] = ACTIONS(2665),
    [anon_sym_static] = ACTIONS(2665),
    [anon_sym_register] = ACTIONS(2665),
    [anon_sym_inline] = ACTIONS(2665),
    [anon_sym___inline] = ACTIONS(2665),
    [anon_sym___inline__] = ACTIONS(2665),
    [anon_sym___forceinline] = ACTIONS(2665),
    [anon_sym_thread_local] = ACTIONS(2665),
    [anon_sym___thread] = ACTIONS(2665),
    [anon_sym_const] = ACTIONS(2665),
    [anon_sym_constexpr] = ACTIONS(2665),
    [anon_sym_volatile] = ACTIONS(2665),
    [anon_sym_restrict] = ACTIONS(2665),
    [anon_sym___restrict__] = ACTIONS(2665),
    [anon_sym__Atomic] = ACTIONS(2665),
    [anon_sym__Noreturn] = ACTIONS(2665),
    [anon_sym_noreturn] = ACTIONS(2665),
    [anon_sym__Nonnull] = ACTIONS(2665),
    [anon_sym_mutable] = ACTIONS(2665),
    [anon_sym_constinit] = ACTIONS(2665),
    [anon_sym_consteval] = ACTIONS(2665),
    [anon_sym_alignas] = ACTIONS(2665),
    [anon_sym__Alignas] = ACTIONS(2665),
    [sym_primitive_type] = ACTIONS(2665),
    [anon_sym_enum] = ACTIONS(2665),
    [anon_sym_class] = ACTIONS(2665),
    [anon_sym_struct] = ACTIONS(2665),
    [anon_sym_union] = ACTIONS(2665),
    [anon_sym_if] = ACTIONS(2665),
    [anon_sym_else] = ACTIONS(2665),
    [anon_sym_switch] = ACTIONS(2665),
    [anon_sym_case] = ACTIONS(2665),
    [anon_sym_default] = ACTIONS(2665),
    [anon_sym_while] = ACTIONS(2665),
    [anon_sym_do] = ACTIONS(2665),
    [anon_sym_for] = ACTIONS(2665),
    [anon_sym_return] = ACTIONS(2665),
    [anon_sym_break] = ACTIONS(2665),
    [anon_sym_continue] = ACTIONS(2665),
    [anon_sym_goto] = ACTIONS(2665),
    [anon_sym___try] = ACTIONS(2665),
    [anon_sym___leave] = ACTIONS(2665),
    [anon_sym_not] = ACTIONS(2665),
    [anon_sym_compl] = ACTIONS(2665),
    [anon_sym_DASH_DASH] = ACTIONS(2667),
    [anon_sym_PLUS_PLUS] = ACTIONS(2667),
    [anon_sym_sizeof] = ACTIONS(2665),
    [anon_sym___alignof__] = ACTIONS(2665),
    [anon_sym___alignof] = ACTIONS(2665),
    [anon_sym__alignof] = ACTIONS(2665),
    [anon_sym_alignof] = ACTIONS(2665),
    [anon_sym__Alignof] = ACTIONS(2665),
    [anon_sym_offsetof] = ACTIONS(2665),
    [anon_sym__Generic] = ACTIONS(2665),
    [anon_sym_asm] = ACTIONS(2665),
    [anon_sym___asm__] = ACTIONS(2665),
    [anon_sym___asm] = ACTIONS(2665),
    [sym_number_literal] = ACTIONS(2667),
    [anon_sym_L_SQUOTE] = ACTIONS(2667),
    [anon_sym_u_SQUOTE] = ACTIONS(2667),
    [anon_sym_U_SQUOTE] = ACTIONS(2667),
    [anon_sym_u8_SQUOTE] = ACTIONS(2667),
    [anon_sym_SQUOTE] = ACTIONS(2667),
    [anon_sym_L_DQUOTE] = ACTIONS(2667),
    [anon_sym_u_DQUOTE] = ACTIONS(2667),
    [anon_sym_U_DQUOTE] = ACTIONS(2667),
    [anon_sym_u8_DQUOTE] = ACTIONS(2667),
    [anon_sym_DQUOTE] = ACTIONS(2667),
    [sym_true] = ACTIONS(2665),
    [sym_false] = ACTIONS(2665),
    [anon_sym_NULL] = ACTIONS(2665),
    [anon_sym_nullptr] = ACTIONS(2665),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2665),
    [anon_sym_decltype] = ACTIONS(2665),
    [anon_sym_explicit] = ACTIONS(2665),
    [anon_sym_typename] = ACTIONS(2665),
    [anon_sym_template] = ACTIONS(2665),
    [anon_sym_operator] = ACTIONS(2665),
    [anon_sym_try] = ACTIONS(2665),
    [anon_sym_delete] = ACTIONS(2665),
    [anon_sym_throw] = ACTIONS(2665),
    [anon_sym_namespace] = ACTIONS(2665),
    [anon_sym_using] = ACTIONS(2665),
    [anon_sym_static_assert] = ACTIONS(2665),
    [anon_sym_concept] = ACTIONS(2665),
    [anon_sym_co_return] = ACTIONS(2665),
    [anon_sym_co_yield] = ACTIONS(2665),
    [anon_sym_R_DQUOTE] = ACTIONS(2667),
    [anon_sym_LR_DQUOTE] = ACTIONS(2667),
    [anon_sym_uR_DQUOTE] = ACTIONS(2667),
    [anon_sym_UR_DQUOTE] = ACTIONS(2667),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2667),
    [anon_sym_co_await] = ACTIONS(2665),
    [anon_sym_new] = ACTIONS(2665),
    [anon_sym_requires] = ACTIONS(2665),
    [sym_this] = ACTIONS(2665),
  },
  [482] = {
    [sym_identifier] = ACTIONS(2593),
    [aux_sym_preproc_include_token1] = ACTIONS(2593),
    [aux_sym_preproc_def_token1] = ACTIONS(2593),
    [aux_sym_preproc_if_token1] = ACTIONS(2593),
    [aux_sym_preproc_if_token2] = ACTIONS(2593),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2593),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2593),
    [sym_preproc_directive] = ACTIONS(2593),
    [anon_sym_LPAREN2] = ACTIONS(2595),
    [anon_sym_BANG] = ACTIONS(2595),
    [anon_sym_TILDE] = ACTIONS(2595),
    [anon_sym_DASH] = ACTIONS(2593),
    [anon_sym_PLUS] = ACTIONS(2593),
    [anon_sym_STAR] = ACTIONS(2595),
    [anon_sym_AMP_AMP] = ACTIONS(2595),
    [anon_sym_AMP] = ACTIONS(2593),
    [anon_sym_SEMI] = ACTIONS(2595),
    [anon_sym___extension__] = ACTIONS(2593),
    [anon_sym_typedef] = ACTIONS(2593),
    [anon_sym_virtual] = ACTIONS(2593),
    [anon_sym_extern] = ACTIONS(2593),
    [anon_sym___attribute__] = ACTIONS(2593),
    [anon_sym___attribute] = ACTIONS(2593),
    [anon_sym_COLON_COLON] = ACTIONS(2595),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2595),
    [anon_sym___declspec] = ACTIONS(2593),
    [anon_sym___based] = ACTIONS(2593),
    [anon_sym___cdecl] = ACTIONS(2593),
    [anon_sym___clrcall] = ACTIONS(2593),
    [anon_sym___stdcall] = ACTIONS(2593),
    [anon_sym___fastcall] = ACTIONS(2593),
    [anon_sym___thiscall] = ACTIONS(2593),
    [anon_sym___vectorcall] = ACTIONS(2593),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_signed] = ACTIONS(2593),
    [anon_sym_unsigned] = ACTIONS(2593),
    [anon_sym_long] = ACTIONS(2593),
    [anon_sym_short] = ACTIONS(2593),
    [anon_sym_LBRACK] = ACTIONS(2593),
    [anon_sym_static] = ACTIONS(2593),
    [anon_sym_register] = ACTIONS(2593),
    [anon_sym_inline] = ACTIONS(2593),
    [anon_sym___inline] = ACTIONS(2593),
    [anon_sym___inline__] = ACTIONS(2593),
    [anon_sym___forceinline] = ACTIONS(2593),
    [anon_sym_thread_local] = ACTIONS(2593),
    [anon_sym___thread] = ACTIONS(2593),
    [anon_sym_const] = ACTIONS(2593),
    [anon_sym_constexpr] = ACTIONS(2593),
    [anon_sym_volatile] = ACTIONS(2593),
    [anon_sym_restrict] = ACTIONS(2593),
    [anon_sym___restrict__] = ACTIONS(2593),
    [anon_sym__Atomic] = ACTIONS(2593),
    [anon_sym__Noreturn] = ACTIONS(2593),
    [anon_sym_noreturn] = ACTIONS(2593),
    [anon_sym__Nonnull] = ACTIONS(2593),
    [anon_sym_mutable] = ACTIONS(2593),
    [anon_sym_constinit] = ACTIONS(2593),
    [anon_sym_consteval] = ACTIONS(2593),
    [anon_sym_alignas] = ACTIONS(2593),
    [anon_sym__Alignas] = ACTIONS(2593),
    [sym_primitive_type] = ACTIONS(2593),
    [anon_sym_enum] = ACTIONS(2593),
    [anon_sym_class] = ACTIONS(2593),
    [anon_sym_struct] = ACTIONS(2593),
    [anon_sym_union] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2593),
    [anon_sym_else] = ACTIONS(2593),
    [anon_sym_switch] = ACTIONS(2593),
    [anon_sym_case] = ACTIONS(2593),
    [anon_sym_default] = ACTIONS(2593),
    [anon_sym_while] = ACTIONS(2593),
    [anon_sym_do] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2593),
    [anon_sym_return] = ACTIONS(2593),
    [anon_sym_break] = ACTIONS(2593),
    [anon_sym_continue] = ACTIONS(2593),
    [anon_sym_goto] = ACTIONS(2593),
    [anon_sym___try] = ACTIONS(2593),
    [anon_sym___leave] = ACTIONS(2593),
    [anon_sym_not] = ACTIONS(2593),
    [anon_sym_compl] = ACTIONS(2593),
    [anon_sym_DASH_DASH] = ACTIONS(2595),
    [anon_sym_PLUS_PLUS] = ACTIONS(2595),
    [anon_sym_sizeof] = ACTIONS(2593),
    [anon_sym___alignof__] = ACTIONS(2593),
    [anon_sym___alignof] = ACTIONS(2593),
    [anon_sym__alignof] = ACTIONS(2593),
    [anon_sym_alignof] = ACTIONS(2593),
    [anon_sym__Alignof] = ACTIONS(2593),
    [anon_sym_offsetof] = ACTIONS(2593),
    [anon_sym__Generic] = ACTIONS(2593),
    [anon_sym_asm] = ACTIONS(2593),
    [anon_sym___asm__] = ACTIONS(2593),
    [anon_sym___asm] = ACTIONS(2593),
    [sym_number_literal] = ACTIONS(2595),
    [anon_sym_L_SQUOTE] = ACTIONS(2595),
    [anon_sym_u_SQUOTE] = ACTIONS(2595),
    [anon_sym_U_SQUOTE] = ACTIONS(2595),
    [anon_sym_u8_SQUOTE] = ACTIONS(2595),
    [anon_sym_SQUOTE] = ACTIONS(2595),
    [anon_sym_L_DQUOTE] = ACTIONS(2595),
    [anon_sym_u_DQUOTE] = ACTIONS(2595),
    [anon_sym_U_DQUOTE] = ACTIONS(2595),
    [anon_sym_u8_DQUOTE] = ACTIONS(2595),
    [anon_sym_DQUOTE] = ACTIONS(2595),
    [sym_true] = ACTIONS(2593),
    [sym_false] = ACTIONS(2593),
    [anon_sym_NULL] = ACTIONS(2593),
    [anon_sym_nullptr] = ACTIONS(2593),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2593),
    [anon_sym_decltype] = ACTIONS(2593),
    [anon_sym_explicit] = ACTIONS(2593),
    [anon_sym_typename] = ACTIONS(2593),
    [anon_sym_template] = ACTIONS(2593),
    [anon_sym_operator] = ACTIONS(2593),
    [anon_sym_try] = ACTIONS(2593),
    [anon_sym_delete] = ACTIONS(2593),
    [anon_sym_throw] = ACTIONS(2593),
    [anon_sym_namespace] = ACTIONS(2593),
    [anon_sym_using] = ACTIONS(2593),
    [anon_sym_static_assert] = ACTIONS(2593),
    [anon_sym_concept] = ACTIONS(2593),
    [anon_sym_co_return] = ACTIONS(2593),
    [anon_sym_co_yield] = ACTIONS(2593),
    [anon_sym_R_DQUOTE] = ACTIONS(2595),
    [anon_sym_LR_DQUOTE] = ACTIONS(2595),
    [anon_sym_uR_DQUOTE] = ACTIONS(2595),
    [anon_sym_UR_DQUOTE] = ACTIONS(2595),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2595),
    [anon_sym_co_await] = ACTIONS(2593),
    [anon_sym_new] = ACTIONS(2593),
    [anon_sym_requires] = ACTIONS(2593),
    [sym_this] = ACTIONS(2593),
  },
  [483] = {
    [ts_builtin_sym_end] = ACTIONS(2671),
    [sym_identifier] = ACTIONS(2669),
    [aux_sym_preproc_include_token1] = ACTIONS(2669),
    [aux_sym_preproc_def_token1] = ACTIONS(2669),
    [aux_sym_preproc_if_token1] = ACTIONS(2669),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2669),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2669),
    [sym_preproc_directive] = ACTIONS(2669),
    [anon_sym_LPAREN2] = ACTIONS(2671),
    [anon_sym_BANG] = ACTIONS(2671),
    [anon_sym_TILDE] = ACTIONS(2671),
    [anon_sym_DASH] = ACTIONS(2669),
    [anon_sym_PLUS] = ACTIONS(2669),
    [anon_sym_STAR] = ACTIONS(2671),
    [anon_sym_AMP_AMP] = ACTIONS(2671),
    [anon_sym_AMP] = ACTIONS(2669),
    [anon_sym_SEMI] = ACTIONS(2671),
    [anon_sym___extension__] = ACTIONS(2669),
    [anon_sym_typedef] = ACTIONS(2669),
    [anon_sym_virtual] = ACTIONS(2669),
    [anon_sym_extern] = ACTIONS(2669),
    [anon_sym___attribute__] = ACTIONS(2669),
    [anon_sym___attribute] = ACTIONS(2669),
    [anon_sym_COLON_COLON] = ACTIONS(2671),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2671),
    [anon_sym___declspec] = ACTIONS(2669),
    [anon_sym___based] = ACTIONS(2669),
    [anon_sym___cdecl] = ACTIONS(2669),
    [anon_sym___clrcall] = ACTIONS(2669),
    [anon_sym___stdcall] = ACTIONS(2669),
    [anon_sym___fastcall] = ACTIONS(2669),
    [anon_sym___thiscall] = ACTIONS(2669),
    [anon_sym___vectorcall] = ACTIONS(2669),
    [anon_sym_LBRACE] = ACTIONS(2671),
    [anon_sym_signed] = ACTIONS(2669),
    [anon_sym_unsigned] = ACTIONS(2669),
    [anon_sym_long] = ACTIONS(2669),
    [anon_sym_short] = ACTIONS(2669),
    [anon_sym_LBRACK] = ACTIONS(2669),
    [anon_sym_static] = ACTIONS(2669),
    [anon_sym_register] = ACTIONS(2669),
    [anon_sym_inline] = ACTIONS(2669),
    [anon_sym___inline] = ACTIONS(2669),
    [anon_sym___inline__] = ACTIONS(2669),
    [anon_sym___forceinline] = ACTIONS(2669),
    [anon_sym_thread_local] = ACTIONS(2669),
    [anon_sym___thread] = ACTIONS(2669),
    [anon_sym_const] = ACTIONS(2669),
    [anon_sym_constexpr] = ACTIONS(2669),
    [anon_sym_volatile] = ACTIONS(2669),
    [anon_sym_restrict] = ACTIONS(2669),
    [anon_sym___restrict__] = ACTIONS(2669),
    [anon_sym__Atomic] = ACTIONS(2669),
    [anon_sym__Noreturn] = ACTIONS(2669),
    [anon_sym_noreturn] = ACTIONS(2669),
    [anon_sym__Nonnull] = ACTIONS(2669),
    [anon_sym_mutable] = ACTIONS(2669),
    [anon_sym_constinit] = ACTIONS(2669),
    [anon_sym_consteval] = ACTIONS(2669),
    [anon_sym_alignas] = ACTIONS(2669),
    [anon_sym__Alignas] = ACTIONS(2669),
    [sym_primitive_type] = ACTIONS(2669),
    [anon_sym_enum] = ACTIONS(2669),
    [anon_sym_class] = ACTIONS(2669),
    [anon_sym_struct] = ACTIONS(2669),
    [anon_sym_union] = ACTIONS(2669),
    [anon_sym_if] = ACTIONS(2669),
    [anon_sym_else] = ACTIONS(2669),
    [anon_sym_switch] = ACTIONS(2669),
    [anon_sym_case] = ACTIONS(2669),
    [anon_sym_default] = ACTIONS(2669),
    [anon_sym_while] = ACTIONS(2669),
    [anon_sym_do] = ACTIONS(2669),
    [anon_sym_for] = ACTIONS(2669),
    [anon_sym_return] = ACTIONS(2669),
    [anon_sym_break] = ACTIONS(2669),
    [anon_sym_continue] = ACTIONS(2669),
    [anon_sym_goto] = ACTIONS(2669),
    [anon_sym___try] = ACTIONS(2669),
    [anon_sym___leave] = ACTIONS(2669),
    [anon_sym_not] = ACTIONS(2669),
    [anon_sym_compl] = ACTIONS(2669),
    [anon_sym_DASH_DASH] = ACTIONS(2671),
    [anon_sym_PLUS_PLUS] = ACTIONS(2671),
    [anon_sym_sizeof] = ACTIONS(2669),
    [anon_sym___alignof__] = ACTIONS(2669),
    [anon_sym___alignof] = ACTIONS(2669),
    [anon_sym__alignof] = ACTIONS(2669),
    [anon_sym_alignof] = ACTIONS(2669),
    [anon_sym__Alignof] = ACTIONS(2669),
    [anon_sym_offsetof] = ACTIONS(2669),
    [anon_sym__Generic] = ACTIONS(2669),
    [anon_sym_asm] = ACTIONS(2669),
    [anon_sym___asm__] = ACTIONS(2669),
    [anon_sym___asm] = ACTIONS(2669),
    [sym_number_literal] = ACTIONS(2671),
    [anon_sym_L_SQUOTE] = ACTIONS(2671),
    [anon_sym_u_SQUOTE] = ACTIONS(2671),
    [anon_sym_U_SQUOTE] = ACTIONS(2671),
    [anon_sym_u8_SQUOTE] = ACTIONS(2671),
    [anon_sym_SQUOTE] = ACTIONS(2671),
    [anon_sym_L_DQUOTE] = ACTIONS(2671),
    [anon_sym_u_DQUOTE] = ACTIONS(2671),
    [anon_sym_U_DQUOTE] = ACTIONS(2671),
    [anon_sym_u8_DQUOTE] = ACTIONS(2671),
    [anon_sym_DQUOTE] = ACTIONS(2671),
    [sym_true] = ACTIONS(2669),
    [sym_false] = ACTIONS(2669),
    [anon_sym_NULL] = ACTIONS(2669),
    [anon_sym_nullptr] = ACTIONS(2669),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2669),
    [anon_sym_decltype] = ACTIONS(2669),
    [anon_sym_explicit] = ACTIONS(2669),
    [anon_sym_typename] = ACTIONS(2669),
    [anon_sym_template] = ACTIONS(2669),
    [anon_sym_operator] = ACTIONS(2669),
    [anon_sym_try] = ACTIONS(2669),
    [anon_sym_delete] = ACTIONS(2669),
    [anon_sym_throw] = ACTIONS(2669),
    [anon_sym_namespace] = ACTIONS(2669),
    [anon_sym_using] = ACTIONS(2669),
    [anon_sym_static_assert] = ACTIONS(2669),
    [anon_sym_concept] = ACTIONS(2669),
    [anon_sym_co_return] = ACTIONS(2669),
    [anon_sym_co_yield] = ACTIONS(2669),
    [anon_sym_R_DQUOTE] = ACTIONS(2671),
    [anon_sym_LR_DQUOTE] = ACTIONS(2671),
    [anon_sym_uR_DQUOTE] = ACTIONS(2671),
    [anon_sym_UR_DQUOTE] = ACTIONS(2671),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2671),
    [anon_sym_co_await] = ACTIONS(2669),
    [anon_sym_new] = ACTIONS(2669),
    [anon_sym_requires] = ACTIONS(2669),
    [sym_this] = ACTIONS(2669),
  },
  [484] = {
    [sym_identifier] = ACTIONS(2723),
    [aux_sym_preproc_include_token1] = ACTIONS(2723),
    [aux_sym_preproc_def_token1] = ACTIONS(2723),
    [aux_sym_preproc_if_token1] = ACTIONS(2723),
    [aux_sym_preproc_if_token2] = ACTIONS(2723),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2723),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2723),
    [sym_preproc_directive] = ACTIONS(2723),
    [anon_sym_LPAREN2] = ACTIONS(2725),
    [anon_sym_BANG] = ACTIONS(2725),
    [anon_sym_TILDE] = ACTIONS(2725),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_STAR] = ACTIONS(2725),
    [anon_sym_AMP_AMP] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_SEMI] = ACTIONS(2725),
    [anon_sym___extension__] = ACTIONS(2723),
    [anon_sym_typedef] = ACTIONS(2723),
    [anon_sym_virtual] = ACTIONS(2723),
    [anon_sym_extern] = ACTIONS(2723),
    [anon_sym___attribute__] = ACTIONS(2723),
    [anon_sym___attribute] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2725),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2725),
    [anon_sym___declspec] = ACTIONS(2723),
    [anon_sym___based] = ACTIONS(2723),
    [anon_sym___cdecl] = ACTIONS(2723),
    [anon_sym___clrcall] = ACTIONS(2723),
    [anon_sym___stdcall] = ACTIONS(2723),
    [anon_sym___fastcall] = ACTIONS(2723),
    [anon_sym___thiscall] = ACTIONS(2723),
    [anon_sym___vectorcall] = ACTIONS(2723),
    [anon_sym_LBRACE] = ACTIONS(2725),
    [anon_sym_signed] = ACTIONS(2723),
    [anon_sym_unsigned] = ACTIONS(2723),
    [anon_sym_long] = ACTIONS(2723),
    [anon_sym_short] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_static] = ACTIONS(2723),
    [anon_sym_register] = ACTIONS(2723),
    [anon_sym_inline] = ACTIONS(2723),
    [anon_sym___inline] = ACTIONS(2723),
    [anon_sym___inline__] = ACTIONS(2723),
    [anon_sym___forceinline] = ACTIONS(2723),
    [anon_sym_thread_local] = ACTIONS(2723),
    [anon_sym___thread] = ACTIONS(2723),
    [anon_sym_const] = ACTIONS(2723),
    [anon_sym_constexpr] = ACTIONS(2723),
    [anon_sym_volatile] = ACTIONS(2723),
    [anon_sym_restrict] = ACTIONS(2723),
    [anon_sym___restrict__] = ACTIONS(2723),
    [anon_sym__Atomic] = ACTIONS(2723),
    [anon_sym__Noreturn] = ACTIONS(2723),
    [anon_sym_noreturn] = ACTIONS(2723),
    [anon_sym__Nonnull] = ACTIONS(2723),
    [anon_sym_mutable] = ACTIONS(2723),
    [anon_sym_constinit] = ACTIONS(2723),
    [anon_sym_consteval] = ACTIONS(2723),
    [anon_sym_alignas] = ACTIONS(2723),
    [anon_sym__Alignas] = ACTIONS(2723),
    [sym_primitive_type] = ACTIONS(2723),
    [anon_sym_enum] = ACTIONS(2723),
    [anon_sym_class] = ACTIONS(2723),
    [anon_sym_struct] = ACTIONS(2723),
    [anon_sym_union] = ACTIONS(2723),
    [anon_sym_if] = ACTIONS(2723),
    [anon_sym_else] = ACTIONS(2723),
    [anon_sym_switch] = ACTIONS(2723),
    [anon_sym_case] = ACTIONS(2723),
    [anon_sym_default] = ACTIONS(2723),
    [anon_sym_while] = ACTIONS(2723),
    [anon_sym_do] = ACTIONS(2723),
    [anon_sym_for] = ACTIONS(2723),
    [anon_sym_return] = ACTIONS(2723),
    [anon_sym_break] = ACTIONS(2723),
    [anon_sym_continue] = ACTIONS(2723),
    [anon_sym_goto] = ACTIONS(2723),
    [anon_sym___try] = ACTIONS(2723),
    [anon_sym___leave] = ACTIONS(2723),
    [anon_sym_not] = ACTIONS(2723),
    [anon_sym_compl] = ACTIONS(2723),
    [anon_sym_DASH_DASH] = ACTIONS(2725),
    [anon_sym_PLUS_PLUS] = ACTIONS(2725),
    [anon_sym_sizeof] = ACTIONS(2723),
    [anon_sym___alignof__] = ACTIONS(2723),
    [anon_sym___alignof] = ACTIONS(2723),
    [anon_sym__alignof] = ACTIONS(2723),
    [anon_sym_alignof] = ACTIONS(2723),
    [anon_sym__Alignof] = ACTIONS(2723),
    [anon_sym_offsetof] = ACTIONS(2723),
    [anon_sym__Generic] = ACTIONS(2723),
    [anon_sym_asm] = ACTIONS(2723),
    [anon_sym___asm__] = ACTIONS(2723),
    [anon_sym___asm] = ACTIONS(2723),
    [sym_number_literal] = ACTIONS(2725),
    [anon_sym_L_SQUOTE] = ACTIONS(2725),
    [anon_sym_u_SQUOTE] = ACTIONS(2725),
    [anon_sym_U_SQUOTE] = ACTIONS(2725),
    [anon_sym_u8_SQUOTE] = ACTIONS(2725),
    [anon_sym_SQUOTE] = ACTIONS(2725),
    [anon_sym_L_DQUOTE] = ACTIONS(2725),
    [anon_sym_u_DQUOTE] = ACTIONS(2725),
    [anon_sym_U_DQUOTE] = ACTIONS(2725),
    [anon_sym_u8_DQUOTE] = ACTIONS(2725),
    [anon_sym_DQUOTE] = ACTIONS(2725),
    [sym_true] = ACTIONS(2723),
    [sym_false] = ACTIONS(2723),
    [anon_sym_NULL] = ACTIONS(2723),
    [anon_sym_nullptr] = ACTIONS(2723),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2723),
    [anon_sym_decltype] = ACTIONS(2723),
    [anon_sym_explicit] = ACTIONS(2723),
    [anon_sym_typename] = ACTIONS(2723),
    [anon_sym_template] = ACTIONS(2723),
    [anon_sym_operator] = ACTIONS(2723),
    [anon_sym_try] = ACTIONS(2723),
    [anon_sym_delete] = ACTIONS(2723),
    [anon_sym_throw] = ACTIONS(2723),
    [anon_sym_namespace] = ACTIONS(2723),
    [anon_sym_using] = ACTIONS(2723),
    [anon_sym_static_assert] = ACTIONS(2723),
    [anon_sym_concept] = ACTIONS(2723),
    [anon_sym_co_return] = ACTIONS(2723),
    [anon_sym_co_yield] = ACTIONS(2723),
    [anon_sym_R_DQUOTE] = ACTIONS(2725),
    [anon_sym_LR_DQUOTE] = ACTIONS(2725),
    [anon_sym_uR_DQUOTE] = ACTIONS(2725),
    [anon_sym_UR_DQUOTE] = ACTIONS(2725),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2725),
    [anon_sym_co_await] = ACTIONS(2723),
    [anon_sym_new] = ACTIONS(2723),
    [anon_sym_requires] = ACTIONS(2723),
    [sym_this] = ACTIONS(2723),
  },
  [485] = {
    [ts_builtin_sym_end] = ACTIONS(2675),
    [sym_identifier] = ACTIONS(2673),
    [aux_sym_preproc_include_token1] = ACTIONS(2673),
    [aux_sym_preproc_def_token1] = ACTIONS(2673),
    [aux_sym_preproc_if_token1] = ACTIONS(2673),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2673),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2673),
    [sym_preproc_directive] = ACTIONS(2673),
    [anon_sym_LPAREN2] = ACTIONS(2675),
    [anon_sym_BANG] = ACTIONS(2675),
    [anon_sym_TILDE] = ACTIONS(2675),
    [anon_sym_DASH] = ACTIONS(2673),
    [anon_sym_PLUS] = ACTIONS(2673),
    [anon_sym_STAR] = ACTIONS(2675),
    [anon_sym_AMP_AMP] = ACTIONS(2675),
    [anon_sym_AMP] = ACTIONS(2673),
    [anon_sym_SEMI] = ACTIONS(2675),
    [anon_sym___extension__] = ACTIONS(2673),
    [anon_sym_typedef] = ACTIONS(2673),
    [anon_sym_virtual] = ACTIONS(2673),
    [anon_sym_extern] = ACTIONS(2673),
    [anon_sym___attribute__] = ACTIONS(2673),
    [anon_sym___attribute] = ACTIONS(2673),
    [anon_sym_COLON_COLON] = ACTIONS(2675),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2675),
    [anon_sym___declspec] = ACTIONS(2673),
    [anon_sym___based] = ACTIONS(2673),
    [anon_sym___cdecl] = ACTIONS(2673),
    [anon_sym___clrcall] = ACTIONS(2673),
    [anon_sym___stdcall] = ACTIONS(2673),
    [anon_sym___fastcall] = ACTIONS(2673),
    [anon_sym___thiscall] = ACTIONS(2673),
    [anon_sym___vectorcall] = ACTIONS(2673),
    [anon_sym_LBRACE] = ACTIONS(2675),
    [anon_sym_signed] = ACTIONS(2673),
    [anon_sym_unsigned] = ACTIONS(2673),
    [anon_sym_long] = ACTIONS(2673),
    [anon_sym_short] = ACTIONS(2673),
    [anon_sym_LBRACK] = ACTIONS(2673),
    [anon_sym_static] = ACTIONS(2673),
    [anon_sym_register] = ACTIONS(2673),
    [anon_sym_inline] = ACTIONS(2673),
    [anon_sym___inline] = ACTIONS(2673),
    [anon_sym___inline__] = ACTIONS(2673),
    [anon_sym___forceinline] = ACTIONS(2673),
    [anon_sym_thread_local] = ACTIONS(2673),
    [anon_sym___thread] = ACTIONS(2673),
    [anon_sym_const] = ACTIONS(2673),
    [anon_sym_constexpr] = ACTIONS(2673),
    [anon_sym_volatile] = ACTIONS(2673),
    [anon_sym_restrict] = ACTIONS(2673),
    [anon_sym___restrict__] = ACTIONS(2673),
    [anon_sym__Atomic] = ACTIONS(2673),
    [anon_sym__Noreturn] = ACTIONS(2673),
    [anon_sym_noreturn] = ACTIONS(2673),
    [anon_sym__Nonnull] = ACTIONS(2673),
    [anon_sym_mutable] = ACTIONS(2673),
    [anon_sym_constinit] = ACTIONS(2673),
    [anon_sym_consteval] = ACTIONS(2673),
    [anon_sym_alignas] = ACTIONS(2673),
    [anon_sym__Alignas] = ACTIONS(2673),
    [sym_primitive_type] = ACTIONS(2673),
    [anon_sym_enum] = ACTIONS(2673),
    [anon_sym_class] = ACTIONS(2673),
    [anon_sym_struct] = ACTIONS(2673),
    [anon_sym_union] = ACTIONS(2673),
    [anon_sym_if] = ACTIONS(2673),
    [anon_sym_else] = ACTIONS(2673),
    [anon_sym_switch] = ACTIONS(2673),
    [anon_sym_case] = ACTIONS(2673),
    [anon_sym_default] = ACTIONS(2673),
    [anon_sym_while] = ACTIONS(2673),
    [anon_sym_do] = ACTIONS(2673),
    [anon_sym_for] = ACTIONS(2673),
    [anon_sym_return] = ACTIONS(2673),
    [anon_sym_break] = ACTIONS(2673),
    [anon_sym_continue] = ACTIONS(2673),
    [anon_sym_goto] = ACTIONS(2673),
    [anon_sym___try] = ACTIONS(2673),
    [anon_sym___leave] = ACTIONS(2673),
    [anon_sym_not] = ACTIONS(2673),
    [anon_sym_compl] = ACTIONS(2673),
    [anon_sym_DASH_DASH] = ACTIONS(2675),
    [anon_sym_PLUS_PLUS] = ACTIONS(2675),
    [anon_sym_sizeof] = ACTIONS(2673),
    [anon_sym___alignof__] = ACTIONS(2673),
    [anon_sym___alignof] = ACTIONS(2673),
    [anon_sym__alignof] = ACTIONS(2673),
    [anon_sym_alignof] = ACTIONS(2673),
    [anon_sym__Alignof] = ACTIONS(2673),
    [anon_sym_offsetof] = ACTIONS(2673),
    [anon_sym__Generic] = ACTIONS(2673),
    [anon_sym_asm] = ACTIONS(2673),
    [anon_sym___asm__] = ACTIONS(2673),
    [anon_sym___asm] = ACTIONS(2673),
    [sym_number_literal] = ACTIONS(2675),
    [anon_sym_L_SQUOTE] = ACTIONS(2675),
    [anon_sym_u_SQUOTE] = ACTIONS(2675),
    [anon_sym_U_SQUOTE] = ACTIONS(2675),
    [anon_sym_u8_SQUOTE] = ACTIONS(2675),
    [anon_sym_SQUOTE] = ACTIONS(2675),
    [anon_sym_L_DQUOTE] = ACTIONS(2675),
    [anon_sym_u_DQUOTE] = ACTIONS(2675),
    [anon_sym_U_DQUOTE] = ACTIONS(2675),
    [anon_sym_u8_DQUOTE] = ACTIONS(2675),
    [anon_sym_DQUOTE] = ACTIONS(2675),
    [sym_true] = ACTIONS(2673),
    [sym_false] = ACTIONS(2673),
    [anon_sym_NULL] = ACTIONS(2673),
    [anon_sym_nullptr] = ACTIONS(2673),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2673),
    [anon_sym_decltype] = ACTIONS(2673),
    [anon_sym_explicit] = ACTIONS(2673),
    [anon_sym_typename] = ACTIONS(2673),
    [anon_sym_template] = ACTIONS(2673),
    [anon_sym_operator] = ACTIONS(2673),
    [anon_sym_try] = ACTIONS(2673),
    [anon_sym_delete] = ACTIONS(2673),
    [anon_sym_throw] = ACTIONS(2673),
    [anon_sym_namespace] = ACTIONS(2673),
    [anon_sym_using] = ACTIONS(2673),
    [anon_sym_static_assert] = ACTIONS(2673),
    [anon_sym_concept] = ACTIONS(2673),
    [anon_sym_co_return] = ACTIONS(2673),
    [anon_sym_co_yield] = ACTIONS(2673),
    [anon_sym_R_DQUOTE] = ACTIONS(2675),
    [anon_sym_LR_DQUOTE] = ACTIONS(2675),
    [anon_sym_uR_DQUOTE] = ACTIONS(2675),
    [anon_sym_UR_DQUOTE] = ACTIONS(2675),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2675),
    [anon_sym_co_await] = ACTIONS(2673),
    [anon_sym_new] = ACTIONS(2673),
    [anon_sym_requires] = ACTIONS(2673),
    [sym_this] = ACTIONS(2673),
  },
  [486] = {
    [sym_identifier] = ACTIONS(2677),
    [aux_sym_preproc_include_token1] = ACTIONS(2677),
    [aux_sym_preproc_def_token1] = ACTIONS(2677),
    [aux_sym_preproc_if_token1] = ACTIONS(2677),
    [aux_sym_preproc_if_token2] = ACTIONS(2677),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2677),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2677),
    [sym_preproc_directive] = ACTIONS(2677),
    [anon_sym_LPAREN2] = ACTIONS(2679),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_TILDE] = ACTIONS(2679),
    [anon_sym_DASH] = ACTIONS(2677),
    [anon_sym_PLUS] = ACTIONS(2677),
    [anon_sym_STAR] = ACTIONS(2679),
    [anon_sym_AMP_AMP] = ACTIONS(2679),
    [anon_sym_AMP] = ACTIONS(2677),
    [anon_sym_SEMI] = ACTIONS(2679),
    [anon_sym___extension__] = ACTIONS(2677),
    [anon_sym_typedef] = ACTIONS(2677),
    [anon_sym_virtual] = ACTIONS(2677),
    [anon_sym_extern] = ACTIONS(2677),
    [anon_sym___attribute__] = ACTIONS(2677),
    [anon_sym___attribute] = ACTIONS(2677),
    [anon_sym_COLON_COLON] = ACTIONS(2679),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2679),
    [anon_sym___declspec] = ACTIONS(2677),
    [anon_sym___based] = ACTIONS(2677),
    [anon_sym___cdecl] = ACTIONS(2677),
    [anon_sym___clrcall] = ACTIONS(2677),
    [anon_sym___stdcall] = ACTIONS(2677),
    [anon_sym___fastcall] = ACTIONS(2677),
    [anon_sym___thiscall] = ACTIONS(2677),
    [anon_sym___vectorcall] = ACTIONS(2677),
    [anon_sym_LBRACE] = ACTIONS(2679),
    [anon_sym_signed] = ACTIONS(2677),
    [anon_sym_unsigned] = ACTIONS(2677),
    [anon_sym_long] = ACTIONS(2677),
    [anon_sym_short] = ACTIONS(2677),
    [anon_sym_LBRACK] = ACTIONS(2677),
    [anon_sym_static] = ACTIONS(2677),
    [anon_sym_register] = ACTIONS(2677),
    [anon_sym_inline] = ACTIONS(2677),
    [anon_sym___inline] = ACTIONS(2677),
    [anon_sym___inline__] = ACTIONS(2677),
    [anon_sym___forceinline] = ACTIONS(2677),
    [anon_sym_thread_local] = ACTIONS(2677),
    [anon_sym___thread] = ACTIONS(2677),
    [anon_sym_const] = ACTIONS(2677),
    [anon_sym_constexpr] = ACTIONS(2677),
    [anon_sym_volatile] = ACTIONS(2677),
    [anon_sym_restrict] = ACTIONS(2677),
    [anon_sym___restrict__] = ACTIONS(2677),
    [anon_sym__Atomic] = ACTIONS(2677),
    [anon_sym__Noreturn] = ACTIONS(2677),
    [anon_sym_noreturn] = ACTIONS(2677),
    [anon_sym__Nonnull] = ACTIONS(2677),
    [anon_sym_mutable] = ACTIONS(2677),
    [anon_sym_constinit] = ACTIONS(2677),
    [anon_sym_consteval] = ACTIONS(2677),
    [anon_sym_alignas] = ACTIONS(2677),
    [anon_sym__Alignas] = ACTIONS(2677),
    [sym_primitive_type] = ACTIONS(2677),
    [anon_sym_enum] = ACTIONS(2677),
    [anon_sym_class] = ACTIONS(2677),
    [anon_sym_struct] = ACTIONS(2677),
    [anon_sym_union] = ACTIONS(2677),
    [anon_sym_if] = ACTIONS(2677),
    [anon_sym_else] = ACTIONS(2677),
    [anon_sym_switch] = ACTIONS(2677),
    [anon_sym_case] = ACTIONS(2677),
    [anon_sym_default] = ACTIONS(2677),
    [anon_sym_while] = ACTIONS(2677),
    [anon_sym_do] = ACTIONS(2677),
    [anon_sym_for] = ACTIONS(2677),
    [anon_sym_return] = ACTIONS(2677),
    [anon_sym_break] = ACTIONS(2677),
    [anon_sym_continue] = ACTIONS(2677),
    [anon_sym_goto] = ACTIONS(2677),
    [anon_sym___try] = ACTIONS(2677),
    [anon_sym___leave] = ACTIONS(2677),
    [anon_sym_not] = ACTIONS(2677),
    [anon_sym_compl] = ACTIONS(2677),
    [anon_sym_DASH_DASH] = ACTIONS(2679),
    [anon_sym_PLUS_PLUS] = ACTIONS(2679),
    [anon_sym_sizeof] = ACTIONS(2677),
    [anon_sym___alignof__] = ACTIONS(2677),
    [anon_sym___alignof] = ACTIONS(2677),
    [anon_sym__alignof] = ACTIONS(2677),
    [anon_sym_alignof] = ACTIONS(2677),
    [anon_sym__Alignof] = ACTIONS(2677),
    [anon_sym_offsetof] = ACTIONS(2677),
    [anon_sym__Generic] = ACTIONS(2677),
    [anon_sym_asm] = ACTIONS(2677),
    [anon_sym___asm__] = ACTIONS(2677),
    [anon_sym___asm] = ACTIONS(2677),
    [sym_number_literal] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2679),
    [anon_sym_u_SQUOTE] = ACTIONS(2679),
    [anon_sym_U_SQUOTE] = ACTIONS(2679),
    [anon_sym_u8_SQUOTE] = ACTIONS(2679),
    [anon_sym_SQUOTE] = ACTIONS(2679),
    [anon_sym_L_DQUOTE] = ACTIONS(2679),
    [anon_sym_u_DQUOTE] = ACTIONS(2679),
    [anon_sym_U_DQUOTE] = ACTIONS(2679),
    [anon_sym_u8_DQUOTE] = ACTIONS(2679),
    [anon_sym_DQUOTE] = ACTIONS(2679),
    [sym_true] = ACTIONS(2677),
    [sym_false] = ACTIONS(2677),
    [anon_sym_NULL] = ACTIONS(2677),
    [anon_sym_nullptr] = ACTIONS(2677),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2677),
    [anon_sym_decltype] = ACTIONS(2677),
    [anon_sym_explicit] = ACTIONS(2677),
    [anon_sym_typename] = ACTIONS(2677),
    [anon_sym_template] = ACTIONS(2677),
    [anon_sym_operator] = ACTIONS(2677),
    [anon_sym_try] = ACTIONS(2677),
    [anon_sym_delete] = ACTIONS(2677),
    [anon_sym_throw] = ACTIONS(2677),
    [anon_sym_namespace] = ACTIONS(2677),
    [anon_sym_using] = ACTIONS(2677),
    [anon_sym_static_assert] = ACTIONS(2677),
    [anon_sym_concept] = ACTIONS(2677),
    [anon_sym_co_return] = ACTIONS(2677),
    [anon_sym_co_yield] = ACTIONS(2677),
    [anon_sym_R_DQUOTE] = ACTIONS(2679),
    [anon_sym_LR_DQUOTE] = ACTIONS(2679),
    [anon_sym_uR_DQUOTE] = ACTIONS(2679),
    [anon_sym_UR_DQUOTE] = ACTIONS(2679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2679),
    [anon_sym_co_await] = ACTIONS(2677),
    [anon_sym_new] = ACTIONS(2677),
    [anon_sym_requires] = ACTIONS(2677),
    [sym_this] = ACTIONS(2677),
  },
  [487] = {
    [ts_builtin_sym_end] = ACTIONS(2683),
    [sym_identifier] = ACTIONS(2681),
    [aux_sym_preproc_include_token1] = ACTIONS(2681),
    [aux_sym_preproc_def_token1] = ACTIONS(2681),
    [aux_sym_preproc_if_token1] = ACTIONS(2681),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2681),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2681),
    [sym_preproc_directive] = ACTIONS(2681),
    [anon_sym_LPAREN2] = ACTIONS(2683),
    [anon_sym_BANG] = ACTIONS(2683),
    [anon_sym_TILDE] = ACTIONS(2683),
    [anon_sym_DASH] = ACTIONS(2681),
    [anon_sym_PLUS] = ACTIONS(2681),
    [anon_sym_STAR] = ACTIONS(2683),
    [anon_sym_AMP_AMP] = ACTIONS(2683),
    [anon_sym_AMP] = ACTIONS(2681),
    [anon_sym_SEMI] = ACTIONS(2683),
    [anon_sym___extension__] = ACTIONS(2681),
    [anon_sym_typedef] = ACTIONS(2681),
    [anon_sym_virtual] = ACTIONS(2681),
    [anon_sym_extern] = ACTIONS(2681),
    [anon_sym___attribute__] = ACTIONS(2681),
    [anon_sym___attribute] = ACTIONS(2681),
    [anon_sym_COLON_COLON] = ACTIONS(2683),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2683),
    [anon_sym___declspec] = ACTIONS(2681),
    [anon_sym___based] = ACTIONS(2681),
    [anon_sym___cdecl] = ACTIONS(2681),
    [anon_sym___clrcall] = ACTIONS(2681),
    [anon_sym___stdcall] = ACTIONS(2681),
    [anon_sym___fastcall] = ACTIONS(2681),
    [anon_sym___thiscall] = ACTIONS(2681),
    [anon_sym___vectorcall] = ACTIONS(2681),
    [anon_sym_LBRACE] = ACTIONS(2683),
    [anon_sym_signed] = ACTIONS(2681),
    [anon_sym_unsigned] = ACTIONS(2681),
    [anon_sym_long] = ACTIONS(2681),
    [anon_sym_short] = ACTIONS(2681),
    [anon_sym_LBRACK] = ACTIONS(2681),
    [anon_sym_static] = ACTIONS(2681),
    [anon_sym_register] = ACTIONS(2681),
    [anon_sym_inline] = ACTIONS(2681),
    [anon_sym___inline] = ACTIONS(2681),
    [anon_sym___inline__] = ACTIONS(2681),
    [anon_sym___forceinline] = ACTIONS(2681),
    [anon_sym_thread_local] = ACTIONS(2681),
    [anon_sym___thread] = ACTIONS(2681),
    [anon_sym_const] = ACTIONS(2681),
    [anon_sym_constexpr] = ACTIONS(2681),
    [anon_sym_volatile] = ACTIONS(2681),
    [anon_sym_restrict] = ACTIONS(2681),
    [anon_sym___restrict__] = ACTIONS(2681),
    [anon_sym__Atomic] = ACTIONS(2681),
    [anon_sym__Noreturn] = ACTIONS(2681),
    [anon_sym_noreturn] = ACTIONS(2681),
    [anon_sym__Nonnull] = ACTIONS(2681),
    [anon_sym_mutable] = ACTIONS(2681),
    [anon_sym_constinit] = ACTIONS(2681),
    [anon_sym_consteval] = ACTIONS(2681),
    [anon_sym_alignas] = ACTIONS(2681),
    [anon_sym__Alignas] = ACTIONS(2681),
    [sym_primitive_type] = ACTIONS(2681),
    [anon_sym_enum] = ACTIONS(2681),
    [anon_sym_class] = ACTIONS(2681),
    [anon_sym_struct] = ACTIONS(2681),
    [anon_sym_union] = ACTIONS(2681),
    [anon_sym_if] = ACTIONS(2681),
    [anon_sym_else] = ACTIONS(2681),
    [anon_sym_switch] = ACTIONS(2681),
    [anon_sym_case] = ACTIONS(2681),
    [anon_sym_default] = ACTIONS(2681),
    [anon_sym_while] = ACTIONS(2681),
    [anon_sym_do] = ACTIONS(2681),
    [anon_sym_for] = ACTIONS(2681),
    [anon_sym_return] = ACTIONS(2681),
    [anon_sym_break] = ACTIONS(2681),
    [anon_sym_continue] = ACTIONS(2681),
    [anon_sym_goto] = ACTIONS(2681),
    [anon_sym___try] = ACTIONS(2681),
    [anon_sym___leave] = ACTIONS(2681),
    [anon_sym_not] = ACTIONS(2681),
    [anon_sym_compl] = ACTIONS(2681),
    [anon_sym_DASH_DASH] = ACTIONS(2683),
    [anon_sym_PLUS_PLUS] = ACTIONS(2683),
    [anon_sym_sizeof] = ACTIONS(2681),
    [anon_sym___alignof__] = ACTIONS(2681),
    [anon_sym___alignof] = ACTIONS(2681),
    [anon_sym__alignof] = ACTIONS(2681),
    [anon_sym_alignof] = ACTIONS(2681),
    [anon_sym__Alignof] = ACTIONS(2681),
    [anon_sym_offsetof] = ACTIONS(2681),
    [anon_sym__Generic] = ACTIONS(2681),
    [anon_sym_asm] = ACTIONS(2681),
    [anon_sym___asm__] = ACTIONS(2681),
    [anon_sym___asm] = ACTIONS(2681),
    [sym_number_literal] = ACTIONS(2683),
    [anon_sym_L_SQUOTE] = ACTIONS(2683),
    [anon_sym_u_SQUOTE] = ACTIONS(2683),
    [anon_sym_U_SQUOTE] = ACTIONS(2683),
    [anon_sym_u8_SQUOTE] = ACTIONS(2683),
    [anon_sym_SQUOTE] = ACTIONS(2683),
    [anon_sym_L_DQUOTE] = ACTIONS(2683),
    [anon_sym_u_DQUOTE] = ACTIONS(2683),
    [anon_sym_U_DQUOTE] = ACTIONS(2683),
    [anon_sym_u8_DQUOTE] = ACTIONS(2683),
    [anon_sym_DQUOTE] = ACTIONS(2683),
    [sym_true] = ACTIONS(2681),
    [sym_false] = ACTIONS(2681),
    [anon_sym_NULL] = ACTIONS(2681),
    [anon_sym_nullptr] = ACTIONS(2681),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2681),
    [anon_sym_decltype] = ACTIONS(2681),
    [anon_sym_explicit] = ACTIONS(2681),
    [anon_sym_typename] = ACTIONS(2681),
    [anon_sym_template] = ACTIONS(2681),
    [anon_sym_operator] = ACTIONS(2681),
    [anon_sym_try] = ACTIONS(2681),
    [anon_sym_delete] = ACTIONS(2681),
    [anon_sym_throw] = ACTIONS(2681),
    [anon_sym_namespace] = ACTIONS(2681),
    [anon_sym_using] = ACTIONS(2681),
    [anon_sym_static_assert] = ACTIONS(2681),
    [anon_sym_concept] = ACTIONS(2681),
    [anon_sym_co_return] = ACTIONS(2681),
    [anon_sym_co_yield] = ACTIONS(2681),
    [anon_sym_R_DQUOTE] = ACTIONS(2683),
    [anon_sym_LR_DQUOTE] = ACTIONS(2683),
    [anon_sym_uR_DQUOTE] = ACTIONS(2683),
    [anon_sym_UR_DQUOTE] = ACTIONS(2683),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2683),
    [anon_sym_co_await] = ACTIONS(2681),
    [anon_sym_new] = ACTIONS(2681),
    [anon_sym_requires] = ACTIONS(2681),
    [sym_this] = ACTIONS(2681),
  },
  [488] = {
    [sym_identifier] = ACTIONS(2685),
    [aux_sym_preproc_include_token1] = ACTIONS(2685),
    [aux_sym_preproc_def_token1] = ACTIONS(2685),
    [aux_sym_preproc_if_token1] = ACTIONS(2685),
    [aux_sym_preproc_if_token2] = ACTIONS(2685),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2685),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2685),
    [sym_preproc_directive] = ACTIONS(2685),
    [anon_sym_LPAREN2] = ACTIONS(2687),
    [anon_sym_BANG] = ACTIONS(2687),
    [anon_sym_TILDE] = ACTIONS(2687),
    [anon_sym_DASH] = ACTIONS(2685),
    [anon_sym_PLUS] = ACTIONS(2685),
    [anon_sym_STAR] = ACTIONS(2687),
    [anon_sym_AMP_AMP] = ACTIONS(2687),
    [anon_sym_AMP] = ACTIONS(2685),
    [anon_sym_SEMI] = ACTIONS(2687),
    [anon_sym___extension__] = ACTIONS(2685),
    [anon_sym_typedef] = ACTIONS(2685),
    [anon_sym_virtual] = ACTIONS(2685),
    [anon_sym_extern] = ACTIONS(2685),
    [anon_sym___attribute__] = ACTIONS(2685),
    [anon_sym___attribute] = ACTIONS(2685),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2687),
    [anon_sym___declspec] = ACTIONS(2685),
    [anon_sym___based] = ACTIONS(2685),
    [anon_sym___cdecl] = ACTIONS(2685),
    [anon_sym___clrcall] = ACTIONS(2685),
    [anon_sym___stdcall] = ACTIONS(2685),
    [anon_sym___fastcall] = ACTIONS(2685),
    [anon_sym___thiscall] = ACTIONS(2685),
    [anon_sym___vectorcall] = ACTIONS(2685),
    [anon_sym_LBRACE] = ACTIONS(2687),
    [anon_sym_signed] = ACTIONS(2685),
    [anon_sym_unsigned] = ACTIONS(2685),
    [anon_sym_long] = ACTIONS(2685),
    [anon_sym_short] = ACTIONS(2685),
    [anon_sym_LBRACK] = ACTIONS(2685),
    [anon_sym_static] = ACTIONS(2685),
    [anon_sym_register] = ACTIONS(2685),
    [anon_sym_inline] = ACTIONS(2685),
    [anon_sym___inline] = ACTIONS(2685),
    [anon_sym___inline__] = ACTIONS(2685),
    [anon_sym___forceinline] = ACTIONS(2685),
    [anon_sym_thread_local] = ACTIONS(2685),
    [anon_sym___thread] = ACTIONS(2685),
    [anon_sym_const] = ACTIONS(2685),
    [anon_sym_constexpr] = ACTIONS(2685),
    [anon_sym_volatile] = ACTIONS(2685),
    [anon_sym_restrict] = ACTIONS(2685),
    [anon_sym___restrict__] = ACTIONS(2685),
    [anon_sym__Atomic] = ACTIONS(2685),
    [anon_sym__Noreturn] = ACTIONS(2685),
    [anon_sym_noreturn] = ACTIONS(2685),
    [anon_sym__Nonnull] = ACTIONS(2685),
    [anon_sym_mutable] = ACTIONS(2685),
    [anon_sym_constinit] = ACTIONS(2685),
    [anon_sym_consteval] = ACTIONS(2685),
    [anon_sym_alignas] = ACTIONS(2685),
    [anon_sym__Alignas] = ACTIONS(2685),
    [sym_primitive_type] = ACTIONS(2685),
    [anon_sym_enum] = ACTIONS(2685),
    [anon_sym_class] = ACTIONS(2685),
    [anon_sym_struct] = ACTIONS(2685),
    [anon_sym_union] = ACTIONS(2685),
    [anon_sym_if] = ACTIONS(2685),
    [anon_sym_else] = ACTIONS(2685),
    [anon_sym_switch] = ACTIONS(2685),
    [anon_sym_case] = ACTIONS(2685),
    [anon_sym_default] = ACTIONS(2685),
    [anon_sym_while] = ACTIONS(2685),
    [anon_sym_do] = ACTIONS(2685),
    [anon_sym_for] = ACTIONS(2685),
    [anon_sym_return] = ACTIONS(2685),
    [anon_sym_break] = ACTIONS(2685),
    [anon_sym_continue] = ACTIONS(2685),
    [anon_sym_goto] = ACTIONS(2685),
    [anon_sym___try] = ACTIONS(2685),
    [anon_sym___leave] = ACTIONS(2685),
    [anon_sym_not] = ACTIONS(2685),
    [anon_sym_compl] = ACTIONS(2685),
    [anon_sym_DASH_DASH] = ACTIONS(2687),
    [anon_sym_PLUS_PLUS] = ACTIONS(2687),
    [anon_sym_sizeof] = ACTIONS(2685),
    [anon_sym___alignof__] = ACTIONS(2685),
    [anon_sym___alignof] = ACTIONS(2685),
    [anon_sym__alignof] = ACTIONS(2685),
    [anon_sym_alignof] = ACTIONS(2685),
    [anon_sym__Alignof] = ACTIONS(2685),
    [anon_sym_offsetof] = ACTIONS(2685),
    [anon_sym__Generic] = ACTIONS(2685),
    [anon_sym_asm] = ACTIONS(2685),
    [anon_sym___asm__] = ACTIONS(2685),
    [anon_sym___asm] = ACTIONS(2685),
    [sym_number_literal] = ACTIONS(2687),
    [anon_sym_L_SQUOTE] = ACTIONS(2687),
    [anon_sym_u_SQUOTE] = ACTIONS(2687),
    [anon_sym_U_SQUOTE] = ACTIONS(2687),
    [anon_sym_u8_SQUOTE] = ACTIONS(2687),
    [anon_sym_SQUOTE] = ACTIONS(2687),
    [anon_sym_L_DQUOTE] = ACTIONS(2687),
    [anon_sym_u_DQUOTE] = ACTIONS(2687),
    [anon_sym_U_DQUOTE] = ACTIONS(2687),
    [anon_sym_u8_DQUOTE] = ACTIONS(2687),
    [anon_sym_DQUOTE] = ACTIONS(2687),
    [sym_true] = ACTIONS(2685),
    [sym_false] = ACTIONS(2685),
    [anon_sym_NULL] = ACTIONS(2685),
    [anon_sym_nullptr] = ACTIONS(2685),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2685),
    [anon_sym_decltype] = ACTIONS(2685),
    [anon_sym_explicit] = ACTIONS(2685),
    [anon_sym_typename] = ACTIONS(2685),
    [anon_sym_template] = ACTIONS(2685),
    [anon_sym_operator] = ACTIONS(2685),
    [anon_sym_try] = ACTIONS(2685),
    [anon_sym_delete] = ACTIONS(2685),
    [anon_sym_throw] = ACTIONS(2685),
    [anon_sym_namespace] = ACTIONS(2685),
    [anon_sym_using] = ACTIONS(2685),
    [anon_sym_static_assert] = ACTIONS(2685),
    [anon_sym_concept] = ACTIONS(2685),
    [anon_sym_co_return] = ACTIONS(2685),
    [anon_sym_co_yield] = ACTIONS(2685),
    [anon_sym_R_DQUOTE] = ACTIONS(2687),
    [anon_sym_LR_DQUOTE] = ACTIONS(2687),
    [anon_sym_uR_DQUOTE] = ACTIONS(2687),
    [anon_sym_UR_DQUOTE] = ACTIONS(2687),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2687),
    [anon_sym_co_await] = ACTIONS(2685),
    [anon_sym_new] = ACTIONS(2685),
    [anon_sym_requires] = ACTIONS(2685),
    [sym_this] = ACTIONS(2685),
  },
  [489] = {
    [sym_catch_clause] = STATE(319),
    [aux_sym_constructor_try_statement_repeat1] = STATE(319),
    [ts_builtin_sym_end] = ACTIONS(2555),
    [sym_identifier] = ACTIONS(2553),
    [aux_sym_preproc_include_token1] = ACTIONS(2553),
    [aux_sym_preproc_def_token1] = ACTIONS(2553),
    [aux_sym_preproc_if_token1] = ACTIONS(2553),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2553),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2553),
    [sym_preproc_directive] = ACTIONS(2553),
    [anon_sym_LPAREN2] = ACTIONS(2555),
    [anon_sym_BANG] = ACTIONS(2555),
    [anon_sym_TILDE] = ACTIONS(2555),
    [anon_sym_DASH] = ACTIONS(2553),
    [anon_sym_PLUS] = ACTIONS(2553),
    [anon_sym_STAR] = ACTIONS(2555),
    [anon_sym_AMP_AMP] = ACTIONS(2555),
    [anon_sym_AMP] = ACTIONS(2553),
    [anon_sym_SEMI] = ACTIONS(2555),
    [anon_sym___extension__] = ACTIONS(2553),
    [anon_sym_typedef] = ACTIONS(2553),
    [anon_sym_virtual] = ACTIONS(2553),
    [anon_sym_extern] = ACTIONS(2553),
    [anon_sym___attribute__] = ACTIONS(2553),
    [anon_sym___attribute] = ACTIONS(2553),
    [anon_sym_COLON_COLON] = ACTIONS(2555),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2555),
    [anon_sym___declspec] = ACTIONS(2553),
    [anon_sym___based] = ACTIONS(2553),
    [anon_sym___cdecl] = ACTIONS(2553),
    [anon_sym___clrcall] = ACTIONS(2553),
    [anon_sym___stdcall] = ACTIONS(2553),
    [anon_sym___fastcall] = ACTIONS(2553),
    [anon_sym___thiscall] = ACTIONS(2553),
    [anon_sym___vectorcall] = ACTIONS(2553),
    [anon_sym_LBRACE] = ACTIONS(2555),
    [anon_sym_signed] = ACTIONS(2553),
    [anon_sym_unsigned] = ACTIONS(2553),
    [anon_sym_long] = ACTIONS(2553),
    [anon_sym_short] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(2553),
    [anon_sym_static] = ACTIONS(2553),
    [anon_sym_register] = ACTIONS(2553),
    [anon_sym_inline] = ACTIONS(2553),
    [anon_sym___inline] = ACTIONS(2553),
    [anon_sym___inline__] = ACTIONS(2553),
    [anon_sym___forceinline] = ACTIONS(2553),
    [anon_sym_thread_local] = ACTIONS(2553),
    [anon_sym___thread] = ACTIONS(2553),
    [anon_sym_const] = ACTIONS(2553),
    [anon_sym_constexpr] = ACTIONS(2553),
    [anon_sym_volatile] = ACTIONS(2553),
    [anon_sym_restrict] = ACTIONS(2553),
    [anon_sym___restrict__] = ACTIONS(2553),
    [anon_sym__Atomic] = ACTIONS(2553),
    [anon_sym__Noreturn] = ACTIONS(2553),
    [anon_sym_noreturn] = ACTIONS(2553),
    [anon_sym__Nonnull] = ACTIONS(2553),
    [anon_sym_mutable] = ACTIONS(2553),
    [anon_sym_constinit] = ACTIONS(2553),
    [anon_sym_consteval] = ACTIONS(2553),
    [anon_sym_alignas] = ACTIONS(2553),
    [anon_sym__Alignas] = ACTIONS(2553),
    [sym_primitive_type] = ACTIONS(2553),
    [anon_sym_enum] = ACTIONS(2553),
    [anon_sym_class] = ACTIONS(2553),
    [anon_sym_struct] = ACTIONS(2553),
    [anon_sym_union] = ACTIONS(2553),
    [anon_sym_if] = ACTIONS(2553),
    [anon_sym_switch] = ACTIONS(2553),
    [anon_sym_case] = ACTIONS(2553),
    [anon_sym_default] = ACTIONS(2553),
    [anon_sym_while] = ACTIONS(2553),
    [anon_sym_do] = ACTIONS(2553),
    [anon_sym_for] = ACTIONS(2553),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_break] = ACTIONS(2553),
    [anon_sym_continue] = ACTIONS(2553),
    [anon_sym_goto] = ACTIONS(2553),
    [anon_sym_not] = ACTIONS(2553),
    [anon_sym_compl] = ACTIONS(2553),
    [anon_sym_DASH_DASH] = ACTIONS(2555),
    [anon_sym_PLUS_PLUS] = ACTIONS(2555),
    [anon_sym_sizeof] = ACTIONS(2553),
    [anon_sym___alignof__] = ACTIONS(2553),
    [anon_sym___alignof] = ACTIONS(2553),
    [anon_sym__alignof] = ACTIONS(2553),
    [anon_sym_alignof] = ACTIONS(2553),
    [anon_sym__Alignof] = ACTIONS(2553),
    [anon_sym_offsetof] = ACTIONS(2553),
    [anon_sym__Generic] = ACTIONS(2553),
    [anon_sym_asm] = ACTIONS(2553),
    [anon_sym___asm__] = ACTIONS(2553),
    [anon_sym___asm] = ACTIONS(2553),
    [sym_number_literal] = ACTIONS(2555),
    [anon_sym_L_SQUOTE] = ACTIONS(2555),
    [anon_sym_u_SQUOTE] = ACTIONS(2555),
    [anon_sym_U_SQUOTE] = ACTIONS(2555),
    [anon_sym_u8_SQUOTE] = ACTIONS(2555),
    [anon_sym_SQUOTE] = ACTIONS(2555),
    [anon_sym_L_DQUOTE] = ACTIONS(2555),
    [anon_sym_u_DQUOTE] = ACTIONS(2555),
    [anon_sym_U_DQUOTE] = ACTIONS(2555),
    [anon_sym_u8_DQUOTE] = ACTIONS(2555),
    [anon_sym_DQUOTE] = ACTIONS(2555),
    [sym_true] = ACTIONS(2553),
    [sym_false] = ACTIONS(2553),
    [anon_sym_NULL] = ACTIONS(2553),
    [anon_sym_nullptr] = ACTIONS(2553),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2553),
    [anon_sym_decltype] = ACTIONS(2553),
    [anon_sym_explicit] = ACTIONS(2553),
    [anon_sym_typename] = ACTIONS(2553),
    [anon_sym_template] = ACTIONS(2553),
    [anon_sym_operator] = ACTIONS(2553),
    [anon_sym_try] = ACTIONS(2553),
    [anon_sym_delete] = ACTIONS(2553),
    [anon_sym_throw] = ACTIONS(2553),
    [anon_sym_namespace] = ACTIONS(2553),
    [anon_sym_using] = ACTIONS(2553),
    [anon_sym_static_assert] = ACTIONS(2553),
    [anon_sym_concept] = ACTIONS(2553),
    [anon_sym_co_return] = ACTIONS(2553),
    [anon_sym_co_yield] = ACTIONS(2553),
    [anon_sym_catch] = ACTIONS(2813),
    [anon_sym_R_DQUOTE] = ACTIONS(2555),
    [anon_sym_LR_DQUOTE] = ACTIONS(2555),
    [anon_sym_uR_DQUOTE] = ACTIONS(2555),
    [anon_sym_UR_DQUOTE] = ACTIONS(2555),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2555),
    [anon_sym_co_await] = ACTIONS(2553),
    [anon_sym_new] = ACTIONS(2553),
    [anon_sym_requires] = ACTIONS(2553),
    [sym_this] = ACTIONS(2553),
  },
  [490] = {
    [sym_identifier] = ACTIONS(2697),
    [aux_sym_preproc_include_token1] = ACTIONS(2697),
    [aux_sym_preproc_def_token1] = ACTIONS(2697),
    [aux_sym_preproc_if_token1] = ACTIONS(2697),
    [aux_sym_preproc_if_token2] = ACTIONS(2697),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2697),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2697),
    [sym_preproc_directive] = ACTIONS(2697),
    [anon_sym_LPAREN2] = ACTIONS(2699),
    [anon_sym_BANG] = ACTIONS(2699),
    [anon_sym_TILDE] = ACTIONS(2699),
    [anon_sym_DASH] = ACTIONS(2697),
    [anon_sym_PLUS] = ACTIONS(2697),
    [anon_sym_STAR] = ACTIONS(2699),
    [anon_sym_AMP_AMP] = ACTIONS(2699),
    [anon_sym_AMP] = ACTIONS(2697),
    [anon_sym_SEMI] = ACTIONS(2699),
    [anon_sym___extension__] = ACTIONS(2697),
    [anon_sym_typedef] = ACTIONS(2697),
    [anon_sym_virtual] = ACTIONS(2697),
    [anon_sym_extern] = ACTIONS(2697),
    [anon_sym___attribute__] = ACTIONS(2697),
    [anon_sym___attribute] = ACTIONS(2697),
    [anon_sym_COLON_COLON] = ACTIONS(2699),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2699),
    [anon_sym___declspec] = ACTIONS(2697),
    [anon_sym___based] = ACTIONS(2697),
    [anon_sym___cdecl] = ACTIONS(2697),
    [anon_sym___clrcall] = ACTIONS(2697),
    [anon_sym___stdcall] = ACTIONS(2697),
    [anon_sym___fastcall] = ACTIONS(2697),
    [anon_sym___thiscall] = ACTIONS(2697),
    [anon_sym___vectorcall] = ACTIONS(2697),
    [anon_sym_LBRACE] = ACTIONS(2699),
    [anon_sym_signed] = ACTIONS(2697),
    [anon_sym_unsigned] = ACTIONS(2697),
    [anon_sym_long] = ACTIONS(2697),
    [anon_sym_short] = ACTIONS(2697),
    [anon_sym_LBRACK] = ACTIONS(2697),
    [anon_sym_static] = ACTIONS(2697),
    [anon_sym_register] = ACTIONS(2697),
    [anon_sym_inline] = ACTIONS(2697),
    [anon_sym___inline] = ACTIONS(2697),
    [anon_sym___inline__] = ACTIONS(2697),
    [anon_sym___forceinline] = ACTIONS(2697),
    [anon_sym_thread_local] = ACTIONS(2697),
    [anon_sym___thread] = ACTIONS(2697),
    [anon_sym_const] = ACTIONS(2697),
    [anon_sym_constexpr] = ACTIONS(2697),
    [anon_sym_volatile] = ACTIONS(2697),
    [anon_sym_restrict] = ACTIONS(2697),
    [anon_sym___restrict__] = ACTIONS(2697),
    [anon_sym__Atomic] = ACTIONS(2697),
    [anon_sym__Noreturn] = ACTIONS(2697),
    [anon_sym_noreturn] = ACTIONS(2697),
    [anon_sym__Nonnull] = ACTIONS(2697),
    [anon_sym_mutable] = ACTIONS(2697),
    [anon_sym_constinit] = ACTIONS(2697),
    [anon_sym_consteval] = ACTIONS(2697),
    [anon_sym_alignas] = ACTIONS(2697),
    [anon_sym__Alignas] = ACTIONS(2697),
    [sym_primitive_type] = ACTIONS(2697),
    [anon_sym_enum] = ACTIONS(2697),
    [anon_sym_class] = ACTIONS(2697),
    [anon_sym_struct] = ACTIONS(2697),
    [anon_sym_union] = ACTIONS(2697),
    [anon_sym_if] = ACTIONS(2697),
    [anon_sym_else] = ACTIONS(2697),
    [anon_sym_switch] = ACTIONS(2697),
    [anon_sym_case] = ACTIONS(2697),
    [anon_sym_default] = ACTIONS(2697),
    [anon_sym_while] = ACTIONS(2697),
    [anon_sym_do] = ACTIONS(2697),
    [anon_sym_for] = ACTIONS(2697),
    [anon_sym_return] = ACTIONS(2697),
    [anon_sym_break] = ACTIONS(2697),
    [anon_sym_continue] = ACTIONS(2697),
    [anon_sym_goto] = ACTIONS(2697),
    [anon_sym___try] = ACTIONS(2697),
    [anon_sym___leave] = ACTIONS(2697),
    [anon_sym_not] = ACTIONS(2697),
    [anon_sym_compl] = ACTIONS(2697),
    [anon_sym_DASH_DASH] = ACTIONS(2699),
    [anon_sym_PLUS_PLUS] = ACTIONS(2699),
    [anon_sym_sizeof] = ACTIONS(2697),
    [anon_sym___alignof__] = ACTIONS(2697),
    [anon_sym___alignof] = ACTIONS(2697),
    [anon_sym__alignof] = ACTIONS(2697),
    [anon_sym_alignof] = ACTIONS(2697),
    [anon_sym__Alignof] = ACTIONS(2697),
    [anon_sym_offsetof] = ACTIONS(2697),
    [anon_sym__Generic] = ACTIONS(2697),
    [anon_sym_asm] = ACTIONS(2697),
    [anon_sym___asm__] = ACTIONS(2697),
    [anon_sym___asm] = ACTIONS(2697),
    [sym_number_literal] = ACTIONS(2699),
    [anon_sym_L_SQUOTE] = ACTIONS(2699),
    [anon_sym_u_SQUOTE] = ACTIONS(2699),
    [anon_sym_U_SQUOTE] = ACTIONS(2699),
    [anon_sym_u8_SQUOTE] = ACTIONS(2699),
    [anon_sym_SQUOTE] = ACTIONS(2699),
    [anon_sym_L_DQUOTE] = ACTIONS(2699),
    [anon_sym_u_DQUOTE] = ACTIONS(2699),
    [anon_sym_U_DQUOTE] = ACTIONS(2699),
    [anon_sym_u8_DQUOTE] = ACTIONS(2699),
    [anon_sym_DQUOTE] = ACTIONS(2699),
    [sym_true] = ACTIONS(2697),
    [sym_false] = ACTIONS(2697),
    [anon_sym_NULL] = ACTIONS(2697),
    [anon_sym_nullptr] = ACTIONS(2697),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2697),
    [anon_sym_decltype] = ACTIONS(2697),
    [anon_sym_explicit] = ACTIONS(2697),
    [anon_sym_typename] = ACTIONS(2697),
    [anon_sym_template] = ACTIONS(2697),
    [anon_sym_operator] = ACTIONS(2697),
    [anon_sym_try] = ACTIONS(2697),
    [anon_sym_delete] = ACTIONS(2697),
    [anon_sym_throw] = ACTIONS(2697),
    [anon_sym_namespace] = ACTIONS(2697),
    [anon_sym_using] = ACTIONS(2697),
    [anon_sym_static_assert] = ACTIONS(2697),
    [anon_sym_concept] = ACTIONS(2697),
    [anon_sym_co_return] = ACTIONS(2697),
    [anon_sym_co_yield] = ACTIONS(2697),
    [anon_sym_R_DQUOTE] = ACTIONS(2699),
    [anon_sym_LR_DQUOTE] = ACTIONS(2699),
    [anon_sym_uR_DQUOTE] = ACTIONS(2699),
    [anon_sym_UR_DQUOTE] = ACTIONS(2699),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2699),
    [anon_sym_co_await] = ACTIONS(2697),
    [anon_sym_new] = ACTIONS(2697),
    [anon_sym_requires] = ACTIONS(2697),
    [sym_this] = ACTIONS(2697),
  },
  [491] = {
    [ts_builtin_sym_end] = ACTIONS(2691),
    [sym_identifier] = ACTIONS(2689),
    [aux_sym_preproc_include_token1] = ACTIONS(2689),
    [aux_sym_preproc_def_token1] = ACTIONS(2689),
    [aux_sym_preproc_if_token1] = ACTIONS(2689),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2689),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2689),
    [sym_preproc_directive] = ACTIONS(2689),
    [anon_sym_LPAREN2] = ACTIONS(2691),
    [anon_sym_BANG] = ACTIONS(2691),
    [anon_sym_TILDE] = ACTIONS(2691),
    [anon_sym_DASH] = ACTIONS(2689),
    [anon_sym_PLUS] = ACTIONS(2689),
    [anon_sym_STAR] = ACTIONS(2691),
    [anon_sym_AMP_AMP] = ACTIONS(2691),
    [anon_sym_AMP] = ACTIONS(2689),
    [anon_sym_SEMI] = ACTIONS(2691),
    [anon_sym___extension__] = ACTIONS(2689),
    [anon_sym_typedef] = ACTIONS(2689),
    [anon_sym_virtual] = ACTIONS(2689),
    [anon_sym_extern] = ACTIONS(2689),
    [anon_sym___attribute__] = ACTIONS(2689),
    [anon_sym___attribute] = ACTIONS(2689),
    [anon_sym_COLON_COLON] = ACTIONS(2691),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2691),
    [anon_sym___declspec] = ACTIONS(2689),
    [anon_sym___based] = ACTIONS(2689),
    [anon_sym___cdecl] = ACTIONS(2689),
    [anon_sym___clrcall] = ACTIONS(2689),
    [anon_sym___stdcall] = ACTIONS(2689),
    [anon_sym___fastcall] = ACTIONS(2689),
    [anon_sym___thiscall] = ACTIONS(2689),
    [anon_sym___vectorcall] = ACTIONS(2689),
    [anon_sym_LBRACE] = ACTIONS(2691),
    [anon_sym_signed] = ACTIONS(2689),
    [anon_sym_unsigned] = ACTIONS(2689),
    [anon_sym_long] = ACTIONS(2689),
    [anon_sym_short] = ACTIONS(2689),
    [anon_sym_LBRACK] = ACTIONS(2689),
    [anon_sym_static] = ACTIONS(2689),
    [anon_sym_register] = ACTIONS(2689),
    [anon_sym_inline] = ACTIONS(2689),
    [anon_sym___inline] = ACTIONS(2689),
    [anon_sym___inline__] = ACTIONS(2689),
    [anon_sym___forceinline] = ACTIONS(2689),
    [anon_sym_thread_local] = ACTIONS(2689),
    [anon_sym___thread] = ACTIONS(2689),
    [anon_sym_const] = ACTIONS(2689),
    [anon_sym_constexpr] = ACTIONS(2689),
    [anon_sym_volatile] = ACTIONS(2689),
    [anon_sym_restrict] = ACTIONS(2689),
    [anon_sym___restrict__] = ACTIONS(2689),
    [anon_sym__Atomic] = ACTIONS(2689),
    [anon_sym__Noreturn] = ACTIONS(2689),
    [anon_sym_noreturn] = ACTIONS(2689),
    [anon_sym__Nonnull] = ACTIONS(2689),
    [anon_sym_mutable] = ACTIONS(2689),
    [anon_sym_constinit] = ACTIONS(2689),
    [anon_sym_consteval] = ACTIONS(2689),
    [anon_sym_alignas] = ACTIONS(2689),
    [anon_sym__Alignas] = ACTIONS(2689),
    [sym_primitive_type] = ACTIONS(2689),
    [anon_sym_enum] = ACTIONS(2689),
    [anon_sym_class] = ACTIONS(2689),
    [anon_sym_struct] = ACTIONS(2689),
    [anon_sym_union] = ACTIONS(2689),
    [anon_sym_if] = ACTIONS(2689),
    [anon_sym_else] = ACTIONS(2689),
    [anon_sym_switch] = ACTIONS(2689),
    [anon_sym_case] = ACTIONS(2689),
    [anon_sym_default] = ACTIONS(2689),
    [anon_sym_while] = ACTIONS(2689),
    [anon_sym_do] = ACTIONS(2689),
    [anon_sym_for] = ACTIONS(2689),
    [anon_sym_return] = ACTIONS(2689),
    [anon_sym_break] = ACTIONS(2689),
    [anon_sym_continue] = ACTIONS(2689),
    [anon_sym_goto] = ACTIONS(2689),
    [anon_sym___try] = ACTIONS(2689),
    [anon_sym___leave] = ACTIONS(2689),
    [anon_sym_not] = ACTIONS(2689),
    [anon_sym_compl] = ACTIONS(2689),
    [anon_sym_DASH_DASH] = ACTIONS(2691),
    [anon_sym_PLUS_PLUS] = ACTIONS(2691),
    [anon_sym_sizeof] = ACTIONS(2689),
    [anon_sym___alignof__] = ACTIONS(2689),
    [anon_sym___alignof] = ACTIONS(2689),
    [anon_sym__alignof] = ACTIONS(2689),
    [anon_sym_alignof] = ACTIONS(2689),
    [anon_sym__Alignof] = ACTIONS(2689),
    [anon_sym_offsetof] = ACTIONS(2689),
    [anon_sym__Generic] = ACTIONS(2689),
    [anon_sym_asm] = ACTIONS(2689),
    [anon_sym___asm__] = ACTIONS(2689),
    [anon_sym___asm] = ACTIONS(2689),
    [sym_number_literal] = ACTIONS(2691),
    [anon_sym_L_SQUOTE] = ACTIONS(2691),
    [anon_sym_u_SQUOTE] = ACTIONS(2691),
    [anon_sym_U_SQUOTE] = ACTIONS(2691),
    [anon_sym_u8_SQUOTE] = ACTIONS(2691),
    [anon_sym_SQUOTE] = ACTIONS(2691),
    [anon_sym_L_DQUOTE] = ACTIONS(2691),
    [anon_sym_u_DQUOTE] = ACTIONS(2691),
    [anon_sym_U_DQUOTE] = ACTIONS(2691),
    [anon_sym_u8_DQUOTE] = ACTIONS(2691),
    [anon_sym_DQUOTE] = ACTIONS(2691),
    [sym_true] = ACTIONS(2689),
    [sym_false] = ACTIONS(2689),
    [anon_sym_NULL] = ACTIONS(2689),
    [anon_sym_nullptr] = ACTIONS(2689),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2689),
    [anon_sym_decltype] = ACTIONS(2689),
    [anon_sym_explicit] = ACTIONS(2689),
    [anon_sym_typename] = ACTIONS(2689),
    [anon_sym_template] = ACTIONS(2689),
    [anon_sym_operator] = ACTIONS(2689),
    [anon_sym_try] = ACTIONS(2689),
    [anon_sym_delete] = ACTIONS(2689),
    [anon_sym_throw] = ACTIONS(2689),
    [anon_sym_namespace] = ACTIONS(2689),
    [anon_sym_using] = ACTIONS(2689),
    [anon_sym_static_assert] = ACTIONS(2689),
    [anon_sym_concept] = ACTIONS(2689),
    [anon_sym_co_return] = ACTIONS(2689),
    [anon_sym_co_yield] = ACTIONS(2689),
    [anon_sym_R_DQUOTE] = ACTIONS(2691),
    [anon_sym_LR_DQUOTE] = ACTIONS(2691),
    [anon_sym_uR_DQUOTE] = ACTIONS(2691),
    [anon_sym_UR_DQUOTE] = ACTIONS(2691),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2691),
    [anon_sym_co_await] = ACTIONS(2689),
    [anon_sym_new] = ACTIONS(2689),
    [anon_sym_requires] = ACTIONS(2689),
    [sym_this] = ACTIONS(2689),
  },
  [492] = {
    [sym_identifier] = ACTIONS(2585),
    [aux_sym_preproc_include_token1] = ACTIONS(2585),
    [aux_sym_preproc_def_token1] = ACTIONS(2585),
    [aux_sym_preproc_if_token1] = ACTIONS(2585),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2585),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2585),
    [sym_preproc_directive] = ACTIONS(2585),
    [anon_sym_LPAREN2] = ACTIONS(2587),
    [anon_sym_BANG] = ACTIONS(2587),
    [anon_sym_TILDE] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2585),
    [anon_sym_PLUS] = ACTIONS(2585),
    [anon_sym_STAR] = ACTIONS(2587),
    [anon_sym_AMP_AMP] = ACTIONS(2587),
    [anon_sym_AMP] = ACTIONS(2585),
    [anon_sym_SEMI] = ACTIONS(2587),
    [anon_sym___extension__] = ACTIONS(2585),
    [anon_sym_typedef] = ACTIONS(2585),
    [anon_sym_virtual] = ACTIONS(2585),
    [anon_sym_extern] = ACTIONS(2585),
    [anon_sym___attribute__] = ACTIONS(2585),
    [anon_sym___attribute] = ACTIONS(2585),
    [anon_sym_COLON_COLON] = ACTIONS(2587),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2587),
    [anon_sym___declspec] = ACTIONS(2585),
    [anon_sym___based] = ACTIONS(2585),
    [anon_sym___cdecl] = ACTIONS(2585),
    [anon_sym___clrcall] = ACTIONS(2585),
    [anon_sym___stdcall] = ACTIONS(2585),
    [anon_sym___fastcall] = ACTIONS(2585),
    [anon_sym___thiscall] = ACTIONS(2585),
    [anon_sym___vectorcall] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2587),
    [anon_sym_RBRACE] = ACTIONS(2587),
    [anon_sym_signed] = ACTIONS(2585),
    [anon_sym_unsigned] = ACTIONS(2585),
    [anon_sym_long] = ACTIONS(2585),
    [anon_sym_short] = ACTIONS(2585),
    [anon_sym_LBRACK] = ACTIONS(2585),
    [anon_sym_static] = ACTIONS(2585),
    [anon_sym_register] = ACTIONS(2585),
    [anon_sym_inline] = ACTIONS(2585),
    [anon_sym___inline] = ACTIONS(2585),
    [anon_sym___inline__] = ACTIONS(2585),
    [anon_sym___forceinline] = ACTIONS(2585),
    [anon_sym_thread_local] = ACTIONS(2585),
    [anon_sym___thread] = ACTIONS(2585),
    [anon_sym_const] = ACTIONS(2585),
    [anon_sym_constexpr] = ACTIONS(2585),
    [anon_sym_volatile] = ACTIONS(2585),
    [anon_sym_restrict] = ACTIONS(2585),
    [anon_sym___restrict__] = ACTIONS(2585),
    [anon_sym__Atomic] = ACTIONS(2585),
    [anon_sym__Noreturn] = ACTIONS(2585),
    [anon_sym_noreturn] = ACTIONS(2585),
    [anon_sym__Nonnull] = ACTIONS(2585),
    [anon_sym_mutable] = ACTIONS(2585),
    [anon_sym_constinit] = ACTIONS(2585),
    [anon_sym_consteval] = ACTIONS(2585),
    [anon_sym_alignas] = ACTIONS(2585),
    [anon_sym__Alignas] = ACTIONS(2585),
    [sym_primitive_type] = ACTIONS(2585),
    [anon_sym_enum] = ACTIONS(2585),
    [anon_sym_class] = ACTIONS(2585),
    [anon_sym_struct] = ACTIONS(2585),
    [anon_sym_union] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2585),
    [anon_sym_else] = ACTIONS(2585),
    [anon_sym_switch] = ACTIONS(2585),
    [anon_sym_case] = ACTIONS(2585),
    [anon_sym_default] = ACTIONS(2585),
    [anon_sym_while] = ACTIONS(2585),
    [anon_sym_do] = ACTIONS(2585),
    [anon_sym_for] = ACTIONS(2585),
    [anon_sym_return] = ACTIONS(2585),
    [anon_sym_break] = ACTIONS(2585),
    [anon_sym_continue] = ACTIONS(2585),
    [anon_sym_goto] = ACTIONS(2585),
    [anon_sym___try] = ACTIONS(2585),
    [anon_sym___leave] = ACTIONS(2585),
    [anon_sym_not] = ACTIONS(2585),
    [anon_sym_compl] = ACTIONS(2585),
    [anon_sym_DASH_DASH] = ACTIONS(2587),
    [anon_sym_PLUS_PLUS] = ACTIONS(2587),
    [anon_sym_sizeof] = ACTIONS(2585),
    [anon_sym___alignof__] = ACTIONS(2585),
    [anon_sym___alignof] = ACTIONS(2585),
    [anon_sym__alignof] = ACTIONS(2585),
    [anon_sym_alignof] = ACTIONS(2585),
    [anon_sym__Alignof] = ACTIONS(2585),
    [anon_sym_offsetof] = ACTIONS(2585),
    [anon_sym__Generic] = ACTIONS(2585),
    [anon_sym_asm] = ACTIONS(2585),
    [anon_sym___asm__] = ACTIONS(2585),
    [anon_sym___asm] = ACTIONS(2585),
    [sym_number_literal] = ACTIONS(2587),
    [anon_sym_L_SQUOTE] = ACTIONS(2587),
    [anon_sym_u_SQUOTE] = ACTIONS(2587),
    [anon_sym_U_SQUOTE] = ACTIONS(2587),
    [anon_sym_u8_SQUOTE] = ACTIONS(2587),
    [anon_sym_SQUOTE] = ACTIONS(2587),
    [anon_sym_L_DQUOTE] = ACTIONS(2587),
    [anon_sym_u_DQUOTE] = ACTIONS(2587),
    [anon_sym_U_DQUOTE] = ACTIONS(2587),
    [anon_sym_u8_DQUOTE] = ACTIONS(2587),
    [anon_sym_DQUOTE] = ACTIONS(2587),
    [sym_true] = ACTIONS(2585),
    [sym_false] = ACTIONS(2585),
    [anon_sym_NULL] = ACTIONS(2585),
    [anon_sym_nullptr] = ACTIONS(2585),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2585),
    [anon_sym_decltype] = ACTIONS(2585),
    [anon_sym_explicit] = ACTIONS(2585),
    [anon_sym_typename] = ACTIONS(2585),
    [anon_sym_template] = ACTIONS(2585),
    [anon_sym_operator] = ACTIONS(2585),
    [anon_sym_try] = ACTIONS(2585),
    [anon_sym_delete] = ACTIONS(2585),
    [anon_sym_throw] = ACTIONS(2585),
    [anon_sym_namespace] = ACTIONS(2585),
    [anon_sym_using] = ACTIONS(2585),
    [anon_sym_static_assert] = ACTIONS(2585),
    [anon_sym_concept] = ACTIONS(2585),
    [anon_sym_co_return] = ACTIONS(2585),
    [anon_sym_co_yield] = ACTIONS(2585),
    [anon_sym_R_DQUOTE] = ACTIONS(2587),
    [anon_sym_LR_DQUOTE] = ACTIONS(2587),
    [anon_sym_uR_DQUOTE] = ACTIONS(2587),
    [anon_sym_UR_DQUOTE] = ACTIONS(2587),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2587),
    [anon_sym_co_await] = ACTIONS(2585),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_requires] = ACTIONS(2585),
    [sym_this] = ACTIONS(2585),
  },
  [493] = {
    [sym_identifier] = ACTIONS(2701),
    [aux_sym_preproc_include_token1] = ACTIONS(2701),
    [aux_sym_preproc_def_token1] = ACTIONS(2701),
    [aux_sym_preproc_if_token1] = ACTIONS(2701),
    [aux_sym_preproc_if_token2] = ACTIONS(2701),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2701),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2701),
    [sym_preproc_directive] = ACTIONS(2701),
    [anon_sym_LPAREN2] = ACTIONS(2703),
    [anon_sym_BANG] = ACTIONS(2703),
    [anon_sym_TILDE] = ACTIONS(2703),
    [anon_sym_DASH] = ACTIONS(2701),
    [anon_sym_PLUS] = ACTIONS(2701),
    [anon_sym_STAR] = ACTIONS(2703),
    [anon_sym_AMP_AMP] = ACTIONS(2703),
    [anon_sym_AMP] = ACTIONS(2701),
    [anon_sym_SEMI] = ACTIONS(2703),
    [anon_sym___extension__] = ACTIONS(2701),
    [anon_sym_typedef] = ACTIONS(2701),
    [anon_sym_virtual] = ACTIONS(2701),
    [anon_sym_extern] = ACTIONS(2701),
    [anon_sym___attribute__] = ACTIONS(2701),
    [anon_sym___attribute] = ACTIONS(2701),
    [anon_sym_COLON_COLON] = ACTIONS(2703),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2703),
    [anon_sym___declspec] = ACTIONS(2701),
    [anon_sym___based] = ACTIONS(2701),
    [anon_sym___cdecl] = ACTIONS(2701),
    [anon_sym___clrcall] = ACTIONS(2701),
    [anon_sym___stdcall] = ACTIONS(2701),
    [anon_sym___fastcall] = ACTIONS(2701),
    [anon_sym___thiscall] = ACTIONS(2701),
    [anon_sym___vectorcall] = ACTIONS(2701),
    [anon_sym_LBRACE] = ACTIONS(2703),
    [anon_sym_signed] = ACTIONS(2701),
    [anon_sym_unsigned] = ACTIONS(2701),
    [anon_sym_long] = ACTIONS(2701),
    [anon_sym_short] = ACTIONS(2701),
    [anon_sym_LBRACK] = ACTIONS(2701),
    [anon_sym_static] = ACTIONS(2701),
    [anon_sym_register] = ACTIONS(2701),
    [anon_sym_inline] = ACTIONS(2701),
    [anon_sym___inline] = ACTIONS(2701),
    [anon_sym___inline__] = ACTIONS(2701),
    [anon_sym___forceinline] = ACTIONS(2701),
    [anon_sym_thread_local] = ACTIONS(2701),
    [anon_sym___thread] = ACTIONS(2701),
    [anon_sym_const] = ACTIONS(2701),
    [anon_sym_constexpr] = ACTIONS(2701),
    [anon_sym_volatile] = ACTIONS(2701),
    [anon_sym_restrict] = ACTIONS(2701),
    [anon_sym___restrict__] = ACTIONS(2701),
    [anon_sym__Atomic] = ACTIONS(2701),
    [anon_sym__Noreturn] = ACTIONS(2701),
    [anon_sym_noreturn] = ACTIONS(2701),
    [anon_sym__Nonnull] = ACTIONS(2701),
    [anon_sym_mutable] = ACTIONS(2701),
    [anon_sym_constinit] = ACTIONS(2701),
    [anon_sym_consteval] = ACTIONS(2701),
    [anon_sym_alignas] = ACTIONS(2701),
    [anon_sym__Alignas] = ACTIONS(2701),
    [sym_primitive_type] = ACTIONS(2701),
    [anon_sym_enum] = ACTIONS(2701),
    [anon_sym_class] = ACTIONS(2701),
    [anon_sym_struct] = ACTIONS(2701),
    [anon_sym_union] = ACTIONS(2701),
    [anon_sym_if] = ACTIONS(2701),
    [anon_sym_else] = ACTIONS(2701),
    [anon_sym_switch] = ACTIONS(2701),
    [anon_sym_case] = ACTIONS(2701),
    [anon_sym_default] = ACTIONS(2701),
    [anon_sym_while] = ACTIONS(2701),
    [anon_sym_do] = ACTIONS(2701),
    [anon_sym_for] = ACTIONS(2701),
    [anon_sym_return] = ACTIONS(2701),
    [anon_sym_break] = ACTIONS(2701),
    [anon_sym_continue] = ACTIONS(2701),
    [anon_sym_goto] = ACTIONS(2701),
    [anon_sym___try] = ACTIONS(2701),
    [anon_sym___leave] = ACTIONS(2701),
    [anon_sym_not] = ACTIONS(2701),
    [anon_sym_compl] = ACTIONS(2701),
    [anon_sym_DASH_DASH] = ACTIONS(2703),
    [anon_sym_PLUS_PLUS] = ACTIONS(2703),
    [anon_sym_sizeof] = ACTIONS(2701),
    [anon_sym___alignof__] = ACTIONS(2701),
    [anon_sym___alignof] = ACTIONS(2701),
    [anon_sym__alignof] = ACTIONS(2701),
    [anon_sym_alignof] = ACTIONS(2701),
    [anon_sym__Alignof] = ACTIONS(2701),
    [anon_sym_offsetof] = ACTIONS(2701),
    [anon_sym__Generic] = ACTIONS(2701),
    [anon_sym_asm] = ACTIONS(2701),
    [anon_sym___asm__] = ACTIONS(2701),
    [anon_sym___asm] = ACTIONS(2701),
    [sym_number_literal] = ACTIONS(2703),
    [anon_sym_L_SQUOTE] = ACTIONS(2703),
    [anon_sym_u_SQUOTE] = ACTIONS(2703),
    [anon_sym_U_SQUOTE] = ACTIONS(2703),
    [anon_sym_u8_SQUOTE] = ACTIONS(2703),
    [anon_sym_SQUOTE] = ACTIONS(2703),
    [anon_sym_L_DQUOTE] = ACTIONS(2703),
    [anon_sym_u_DQUOTE] = ACTIONS(2703),
    [anon_sym_U_DQUOTE] = ACTIONS(2703),
    [anon_sym_u8_DQUOTE] = ACTIONS(2703),
    [anon_sym_DQUOTE] = ACTIONS(2703),
    [sym_true] = ACTIONS(2701),
    [sym_false] = ACTIONS(2701),
    [anon_sym_NULL] = ACTIONS(2701),
    [anon_sym_nullptr] = ACTIONS(2701),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2701),
    [anon_sym_decltype] = ACTIONS(2701),
    [anon_sym_explicit] = ACTIONS(2701),
    [anon_sym_typename] = ACTIONS(2701),
    [anon_sym_template] = ACTIONS(2701),
    [anon_sym_operator] = ACTIONS(2701),
    [anon_sym_try] = ACTIONS(2701),
    [anon_sym_delete] = ACTIONS(2701),
    [anon_sym_throw] = ACTIONS(2701),
    [anon_sym_namespace] = ACTIONS(2701),
    [anon_sym_using] = ACTIONS(2701),
    [anon_sym_static_assert] = ACTIONS(2701),
    [anon_sym_concept] = ACTIONS(2701),
    [anon_sym_co_return] = ACTIONS(2701),
    [anon_sym_co_yield] = ACTIONS(2701),
    [anon_sym_R_DQUOTE] = ACTIONS(2703),
    [anon_sym_LR_DQUOTE] = ACTIONS(2703),
    [anon_sym_uR_DQUOTE] = ACTIONS(2703),
    [anon_sym_UR_DQUOTE] = ACTIONS(2703),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2703),
    [anon_sym_co_await] = ACTIONS(2701),
    [anon_sym_new] = ACTIONS(2701),
    [anon_sym_requires] = ACTIONS(2701),
    [sym_this] = ACTIONS(2701),
  },
  [494] = {
    [sym_identifier] = ACTIONS(2709),
    [aux_sym_preproc_include_token1] = ACTIONS(2709),
    [aux_sym_preproc_def_token1] = ACTIONS(2709),
    [aux_sym_preproc_if_token1] = ACTIONS(2709),
    [aux_sym_preproc_if_token2] = ACTIONS(2709),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2709),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2709),
    [sym_preproc_directive] = ACTIONS(2709),
    [anon_sym_LPAREN2] = ACTIONS(2711),
    [anon_sym_BANG] = ACTIONS(2711),
    [anon_sym_TILDE] = ACTIONS(2711),
    [anon_sym_DASH] = ACTIONS(2709),
    [anon_sym_PLUS] = ACTIONS(2709),
    [anon_sym_STAR] = ACTIONS(2711),
    [anon_sym_AMP_AMP] = ACTIONS(2711),
    [anon_sym_AMP] = ACTIONS(2709),
    [anon_sym_SEMI] = ACTIONS(2711),
    [anon_sym___extension__] = ACTIONS(2709),
    [anon_sym_typedef] = ACTIONS(2709),
    [anon_sym_virtual] = ACTIONS(2709),
    [anon_sym_extern] = ACTIONS(2709),
    [anon_sym___attribute__] = ACTIONS(2709),
    [anon_sym___attribute] = ACTIONS(2709),
    [anon_sym_COLON_COLON] = ACTIONS(2711),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2711),
    [anon_sym___declspec] = ACTIONS(2709),
    [anon_sym___based] = ACTIONS(2709),
    [anon_sym___cdecl] = ACTIONS(2709),
    [anon_sym___clrcall] = ACTIONS(2709),
    [anon_sym___stdcall] = ACTIONS(2709),
    [anon_sym___fastcall] = ACTIONS(2709),
    [anon_sym___thiscall] = ACTIONS(2709),
    [anon_sym___vectorcall] = ACTIONS(2709),
    [anon_sym_LBRACE] = ACTIONS(2711),
    [anon_sym_signed] = ACTIONS(2709),
    [anon_sym_unsigned] = ACTIONS(2709),
    [anon_sym_long] = ACTIONS(2709),
    [anon_sym_short] = ACTIONS(2709),
    [anon_sym_LBRACK] = ACTIONS(2709),
    [anon_sym_static] = ACTIONS(2709),
    [anon_sym_register] = ACTIONS(2709),
    [anon_sym_inline] = ACTIONS(2709),
    [anon_sym___inline] = ACTIONS(2709),
    [anon_sym___inline__] = ACTIONS(2709),
    [anon_sym___forceinline] = ACTIONS(2709),
    [anon_sym_thread_local] = ACTIONS(2709),
    [anon_sym___thread] = ACTIONS(2709),
    [anon_sym_const] = ACTIONS(2709),
    [anon_sym_constexpr] = ACTIONS(2709),
    [anon_sym_volatile] = ACTIONS(2709),
    [anon_sym_restrict] = ACTIONS(2709),
    [anon_sym___restrict__] = ACTIONS(2709),
    [anon_sym__Atomic] = ACTIONS(2709),
    [anon_sym__Noreturn] = ACTIONS(2709),
    [anon_sym_noreturn] = ACTIONS(2709),
    [anon_sym__Nonnull] = ACTIONS(2709),
    [anon_sym_mutable] = ACTIONS(2709),
    [anon_sym_constinit] = ACTIONS(2709),
    [anon_sym_consteval] = ACTIONS(2709),
    [anon_sym_alignas] = ACTIONS(2709),
    [anon_sym__Alignas] = ACTIONS(2709),
    [sym_primitive_type] = ACTIONS(2709),
    [anon_sym_enum] = ACTIONS(2709),
    [anon_sym_class] = ACTIONS(2709),
    [anon_sym_struct] = ACTIONS(2709),
    [anon_sym_union] = ACTIONS(2709),
    [anon_sym_if] = ACTIONS(2709),
    [anon_sym_else] = ACTIONS(2709),
    [anon_sym_switch] = ACTIONS(2709),
    [anon_sym_case] = ACTIONS(2709),
    [anon_sym_default] = ACTIONS(2709),
    [anon_sym_while] = ACTIONS(2709),
    [anon_sym_do] = ACTIONS(2709),
    [anon_sym_for] = ACTIONS(2709),
    [anon_sym_return] = ACTIONS(2709),
    [anon_sym_break] = ACTIONS(2709),
    [anon_sym_continue] = ACTIONS(2709),
    [anon_sym_goto] = ACTIONS(2709),
    [anon_sym___try] = ACTIONS(2709),
    [anon_sym___leave] = ACTIONS(2709),
    [anon_sym_not] = ACTIONS(2709),
    [anon_sym_compl] = ACTIONS(2709),
    [anon_sym_DASH_DASH] = ACTIONS(2711),
    [anon_sym_PLUS_PLUS] = ACTIONS(2711),
    [anon_sym_sizeof] = ACTIONS(2709),
    [anon_sym___alignof__] = ACTIONS(2709),
    [anon_sym___alignof] = ACTIONS(2709),
    [anon_sym__alignof] = ACTIONS(2709),
    [anon_sym_alignof] = ACTIONS(2709),
    [anon_sym__Alignof] = ACTIONS(2709),
    [anon_sym_offsetof] = ACTIONS(2709),
    [anon_sym__Generic] = ACTIONS(2709),
    [anon_sym_asm] = ACTIONS(2709),
    [anon_sym___asm__] = ACTIONS(2709),
    [anon_sym___asm] = ACTIONS(2709),
    [sym_number_literal] = ACTIONS(2711),
    [anon_sym_L_SQUOTE] = ACTIONS(2711),
    [anon_sym_u_SQUOTE] = ACTIONS(2711),
    [anon_sym_U_SQUOTE] = ACTIONS(2711),
    [anon_sym_u8_SQUOTE] = ACTIONS(2711),
    [anon_sym_SQUOTE] = ACTIONS(2711),
    [anon_sym_L_DQUOTE] = ACTIONS(2711),
    [anon_sym_u_DQUOTE] = ACTIONS(2711),
    [anon_sym_U_DQUOTE] = ACTIONS(2711),
    [anon_sym_u8_DQUOTE] = ACTIONS(2711),
    [anon_sym_DQUOTE] = ACTIONS(2711),
    [sym_true] = ACTIONS(2709),
    [sym_false] = ACTIONS(2709),
    [anon_sym_NULL] = ACTIONS(2709),
    [anon_sym_nullptr] = ACTIONS(2709),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2709),
    [anon_sym_decltype] = ACTIONS(2709),
    [anon_sym_explicit] = ACTIONS(2709),
    [anon_sym_typename] = ACTIONS(2709),
    [anon_sym_template] = ACTIONS(2709),
    [anon_sym_operator] = ACTIONS(2709),
    [anon_sym_try] = ACTIONS(2709),
    [anon_sym_delete] = ACTIONS(2709),
    [anon_sym_throw] = ACTIONS(2709),
    [anon_sym_namespace] = ACTIONS(2709),
    [anon_sym_using] = ACTIONS(2709),
    [anon_sym_static_assert] = ACTIONS(2709),
    [anon_sym_concept] = ACTIONS(2709),
    [anon_sym_co_return] = ACTIONS(2709),
    [anon_sym_co_yield] = ACTIONS(2709),
    [anon_sym_R_DQUOTE] = ACTIONS(2711),
    [anon_sym_LR_DQUOTE] = ACTIONS(2711),
    [anon_sym_uR_DQUOTE] = ACTIONS(2711),
    [anon_sym_UR_DQUOTE] = ACTIONS(2711),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2711),
    [anon_sym_co_await] = ACTIONS(2709),
    [anon_sym_new] = ACTIONS(2709),
    [anon_sym_requires] = ACTIONS(2709),
    [sym_this] = ACTIONS(2709),
  },
  [495] = {
    [sym_identifier] = ACTIONS(2717),
    [aux_sym_preproc_include_token1] = ACTIONS(2717),
    [aux_sym_preproc_def_token1] = ACTIONS(2717),
    [aux_sym_preproc_if_token1] = ACTIONS(2717),
    [aux_sym_preproc_if_token2] = ACTIONS(2717),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2717),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2717),
    [sym_preproc_directive] = ACTIONS(2717),
    [anon_sym_LPAREN2] = ACTIONS(2719),
    [anon_sym_BANG] = ACTIONS(2719),
    [anon_sym_TILDE] = ACTIONS(2719),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP_AMP] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2717),
    [anon_sym_SEMI] = ACTIONS(2719),
    [anon_sym___extension__] = ACTIONS(2717),
    [anon_sym_typedef] = ACTIONS(2717),
    [anon_sym_virtual] = ACTIONS(2717),
    [anon_sym_extern] = ACTIONS(2717),
    [anon_sym___attribute__] = ACTIONS(2717),
    [anon_sym___attribute] = ACTIONS(2717),
    [anon_sym_COLON_COLON] = ACTIONS(2719),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2719),
    [anon_sym___declspec] = ACTIONS(2717),
    [anon_sym___based] = ACTIONS(2717),
    [anon_sym___cdecl] = ACTIONS(2717),
    [anon_sym___clrcall] = ACTIONS(2717),
    [anon_sym___stdcall] = ACTIONS(2717),
    [anon_sym___fastcall] = ACTIONS(2717),
    [anon_sym___thiscall] = ACTIONS(2717),
    [anon_sym___vectorcall] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(2719),
    [anon_sym_signed] = ACTIONS(2717),
    [anon_sym_unsigned] = ACTIONS(2717),
    [anon_sym_long] = ACTIONS(2717),
    [anon_sym_short] = ACTIONS(2717),
    [anon_sym_LBRACK] = ACTIONS(2717),
    [anon_sym_static] = ACTIONS(2717),
    [anon_sym_register] = ACTIONS(2717),
    [anon_sym_inline] = ACTIONS(2717),
    [anon_sym___inline] = ACTIONS(2717),
    [anon_sym___inline__] = ACTIONS(2717),
    [anon_sym___forceinline] = ACTIONS(2717),
    [anon_sym_thread_local] = ACTIONS(2717),
    [anon_sym___thread] = ACTIONS(2717),
    [anon_sym_const] = ACTIONS(2717),
    [anon_sym_constexpr] = ACTIONS(2717),
    [anon_sym_volatile] = ACTIONS(2717),
    [anon_sym_restrict] = ACTIONS(2717),
    [anon_sym___restrict__] = ACTIONS(2717),
    [anon_sym__Atomic] = ACTIONS(2717),
    [anon_sym__Noreturn] = ACTIONS(2717),
    [anon_sym_noreturn] = ACTIONS(2717),
    [anon_sym__Nonnull] = ACTIONS(2717),
    [anon_sym_mutable] = ACTIONS(2717),
    [anon_sym_constinit] = ACTIONS(2717),
    [anon_sym_consteval] = ACTIONS(2717),
    [anon_sym_alignas] = ACTIONS(2717),
    [anon_sym__Alignas] = ACTIONS(2717),
    [sym_primitive_type] = ACTIONS(2717),
    [anon_sym_enum] = ACTIONS(2717),
    [anon_sym_class] = ACTIONS(2717),
    [anon_sym_struct] = ACTIONS(2717),
    [anon_sym_union] = ACTIONS(2717),
    [anon_sym_if] = ACTIONS(2717),
    [anon_sym_else] = ACTIONS(2717),
    [anon_sym_switch] = ACTIONS(2717),
    [anon_sym_case] = ACTIONS(2717),
    [anon_sym_default] = ACTIONS(2717),
    [anon_sym_while] = ACTIONS(2717),
    [anon_sym_do] = ACTIONS(2717),
    [anon_sym_for] = ACTIONS(2717),
    [anon_sym_return] = ACTIONS(2717),
    [anon_sym_break] = ACTIONS(2717),
    [anon_sym_continue] = ACTIONS(2717),
    [anon_sym_goto] = ACTIONS(2717),
    [anon_sym___try] = ACTIONS(2717),
    [anon_sym___leave] = ACTIONS(2717),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2719),
    [anon_sym_PLUS_PLUS] = ACTIONS(2719),
    [anon_sym_sizeof] = ACTIONS(2717),
    [anon_sym___alignof__] = ACTIONS(2717),
    [anon_sym___alignof] = ACTIONS(2717),
    [anon_sym__alignof] = ACTIONS(2717),
    [anon_sym_alignof] = ACTIONS(2717),
    [anon_sym__Alignof] = ACTIONS(2717),
    [anon_sym_offsetof] = ACTIONS(2717),
    [anon_sym__Generic] = ACTIONS(2717),
    [anon_sym_asm] = ACTIONS(2717),
    [anon_sym___asm__] = ACTIONS(2717),
    [anon_sym___asm] = ACTIONS(2717),
    [sym_number_literal] = ACTIONS(2719),
    [anon_sym_L_SQUOTE] = ACTIONS(2719),
    [anon_sym_u_SQUOTE] = ACTIONS(2719),
    [anon_sym_U_SQUOTE] = ACTIONS(2719),
    [anon_sym_u8_SQUOTE] = ACTIONS(2719),
    [anon_sym_SQUOTE] = ACTIONS(2719),
    [anon_sym_L_DQUOTE] = ACTIONS(2719),
    [anon_sym_u_DQUOTE] = ACTIONS(2719),
    [anon_sym_U_DQUOTE] = ACTIONS(2719),
    [anon_sym_u8_DQUOTE] = ACTIONS(2719),
    [anon_sym_DQUOTE] = ACTIONS(2719),
    [sym_true] = ACTIONS(2717),
    [sym_false] = ACTIONS(2717),
    [anon_sym_NULL] = ACTIONS(2717),
    [anon_sym_nullptr] = ACTIONS(2717),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2717),
    [anon_sym_decltype] = ACTIONS(2717),
    [anon_sym_explicit] = ACTIONS(2717),
    [anon_sym_typename] = ACTIONS(2717),
    [anon_sym_template] = ACTIONS(2717),
    [anon_sym_operator] = ACTIONS(2717),
    [anon_sym_try] = ACTIONS(2717),
    [anon_sym_delete] = ACTIONS(2717),
    [anon_sym_throw] = ACTIONS(2717),
    [anon_sym_namespace] = ACTIONS(2717),
    [anon_sym_using] = ACTIONS(2717),
    [anon_sym_static_assert] = ACTIONS(2717),
    [anon_sym_concept] = ACTIONS(2717),
    [anon_sym_co_return] = ACTIONS(2717),
    [anon_sym_co_yield] = ACTIONS(2717),
    [anon_sym_R_DQUOTE] = ACTIONS(2719),
    [anon_sym_LR_DQUOTE] = ACTIONS(2719),
    [anon_sym_uR_DQUOTE] = ACTIONS(2719),
    [anon_sym_UR_DQUOTE] = ACTIONS(2719),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2719),
    [anon_sym_co_await] = ACTIONS(2717),
    [anon_sym_new] = ACTIONS(2717),
    [anon_sym_requires] = ACTIONS(2717),
    [sym_this] = ACTIONS(2717),
  },
  [496] = {
    [sym_identifier] = ACTIONS(2621),
    [aux_sym_preproc_include_token1] = ACTIONS(2621),
    [aux_sym_preproc_def_token1] = ACTIONS(2621),
    [aux_sym_preproc_if_token1] = ACTIONS(2621),
    [aux_sym_preproc_if_token2] = ACTIONS(2621),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2621),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2621),
    [sym_preproc_directive] = ACTIONS(2621),
    [anon_sym_LPAREN2] = ACTIONS(2623),
    [anon_sym_BANG] = ACTIONS(2623),
    [anon_sym_TILDE] = ACTIONS(2623),
    [anon_sym_DASH] = ACTIONS(2621),
    [anon_sym_PLUS] = ACTIONS(2621),
    [anon_sym_STAR] = ACTIONS(2623),
    [anon_sym_AMP_AMP] = ACTIONS(2623),
    [anon_sym_AMP] = ACTIONS(2621),
    [anon_sym_SEMI] = ACTIONS(2623),
    [anon_sym___extension__] = ACTIONS(2621),
    [anon_sym_typedef] = ACTIONS(2621),
    [anon_sym_virtual] = ACTIONS(2621),
    [anon_sym_extern] = ACTIONS(2621),
    [anon_sym___attribute__] = ACTIONS(2621),
    [anon_sym___attribute] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(2623),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2623),
    [anon_sym___declspec] = ACTIONS(2621),
    [anon_sym___based] = ACTIONS(2621),
    [anon_sym___cdecl] = ACTIONS(2621),
    [anon_sym___clrcall] = ACTIONS(2621),
    [anon_sym___stdcall] = ACTIONS(2621),
    [anon_sym___fastcall] = ACTIONS(2621),
    [anon_sym___thiscall] = ACTIONS(2621),
    [anon_sym___vectorcall] = ACTIONS(2621),
    [anon_sym_LBRACE] = ACTIONS(2623),
    [anon_sym_signed] = ACTIONS(2621),
    [anon_sym_unsigned] = ACTIONS(2621),
    [anon_sym_long] = ACTIONS(2621),
    [anon_sym_short] = ACTIONS(2621),
    [anon_sym_LBRACK] = ACTIONS(2621),
    [anon_sym_static] = ACTIONS(2621),
    [anon_sym_register] = ACTIONS(2621),
    [anon_sym_inline] = ACTIONS(2621),
    [anon_sym___inline] = ACTIONS(2621),
    [anon_sym___inline__] = ACTIONS(2621),
    [anon_sym___forceinline] = ACTIONS(2621),
    [anon_sym_thread_local] = ACTIONS(2621),
    [anon_sym___thread] = ACTIONS(2621),
    [anon_sym_const] = ACTIONS(2621),
    [anon_sym_constexpr] = ACTIONS(2621),
    [anon_sym_volatile] = ACTIONS(2621),
    [anon_sym_restrict] = ACTIONS(2621),
    [anon_sym___restrict__] = ACTIONS(2621),
    [anon_sym__Atomic] = ACTIONS(2621),
    [anon_sym__Noreturn] = ACTIONS(2621),
    [anon_sym_noreturn] = ACTIONS(2621),
    [anon_sym__Nonnull] = ACTIONS(2621),
    [anon_sym_mutable] = ACTIONS(2621),
    [anon_sym_constinit] = ACTIONS(2621),
    [anon_sym_consteval] = ACTIONS(2621),
    [anon_sym_alignas] = ACTIONS(2621),
    [anon_sym__Alignas] = ACTIONS(2621),
    [sym_primitive_type] = ACTIONS(2621),
    [anon_sym_enum] = ACTIONS(2621),
    [anon_sym_class] = ACTIONS(2621),
    [anon_sym_struct] = ACTIONS(2621),
    [anon_sym_union] = ACTIONS(2621),
    [anon_sym_if] = ACTIONS(2621),
    [anon_sym_else] = ACTIONS(2621),
    [anon_sym_switch] = ACTIONS(2621),
    [anon_sym_case] = ACTIONS(2621),
    [anon_sym_default] = ACTIONS(2621),
    [anon_sym_while] = ACTIONS(2621),
    [anon_sym_do] = ACTIONS(2621),
    [anon_sym_for] = ACTIONS(2621),
    [anon_sym_return] = ACTIONS(2621),
    [anon_sym_break] = ACTIONS(2621),
    [anon_sym_continue] = ACTIONS(2621),
    [anon_sym_goto] = ACTIONS(2621),
    [anon_sym___try] = ACTIONS(2621),
    [anon_sym___leave] = ACTIONS(2621),
    [anon_sym_not] = ACTIONS(2621),
    [anon_sym_compl] = ACTIONS(2621),
    [anon_sym_DASH_DASH] = ACTIONS(2623),
    [anon_sym_PLUS_PLUS] = ACTIONS(2623),
    [anon_sym_sizeof] = ACTIONS(2621),
    [anon_sym___alignof__] = ACTIONS(2621),
    [anon_sym___alignof] = ACTIONS(2621),
    [anon_sym__alignof] = ACTIONS(2621),
    [anon_sym_alignof] = ACTIONS(2621),
    [anon_sym__Alignof] = ACTIONS(2621),
    [anon_sym_offsetof] = ACTIONS(2621),
    [anon_sym__Generic] = ACTIONS(2621),
    [anon_sym_asm] = ACTIONS(2621),
    [anon_sym___asm__] = ACTIONS(2621),
    [anon_sym___asm] = ACTIONS(2621),
    [sym_number_literal] = ACTIONS(2623),
    [anon_sym_L_SQUOTE] = ACTIONS(2623),
    [anon_sym_u_SQUOTE] = ACTIONS(2623),
    [anon_sym_U_SQUOTE] = ACTIONS(2623),
    [anon_sym_u8_SQUOTE] = ACTIONS(2623),
    [anon_sym_SQUOTE] = ACTIONS(2623),
    [anon_sym_L_DQUOTE] = ACTIONS(2623),
    [anon_sym_u_DQUOTE] = ACTIONS(2623),
    [anon_sym_U_DQUOTE] = ACTIONS(2623),
    [anon_sym_u8_DQUOTE] = ACTIONS(2623),
    [anon_sym_DQUOTE] = ACTIONS(2623),
    [sym_true] = ACTIONS(2621),
    [sym_false] = ACTIONS(2621),
    [anon_sym_NULL] = ACTIONS(2621),
    [anon_sym_nullptr] = ACTIONS(2621),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2621),
    [anon_sym_decltype] = ACTIONS(2621),
    [anon_sym_explicit] = ACTIONS(2621),
    [anon_sym_typename] = ACTIONS(2621),
    [anon_sym_template] = ACTIONS(2621),
    [anon_sym_operator] = ACTIONS(2621),
    [anon_sym_try] = ACTIONS(2621),
    [anon_sym_delete] = ACTIONS(2621),
    [anon_sym_throw] = ACTIONS(2621),
    [anon_sym_namespace] = ACTIONS(2621),
    [anon_sym_using] = ACTIONS(2621),
    [anon_sym_static_assert] = ACTIONS(2621),
    [anon_sym_concept] = ACTIONS(2621),
    [anon_sym_co_return] = ACTIONS(2621),
    [anon_sym_co_yield] = ACTIONS(2621),
    [anon_sym_R_DQUOTE] = ACTIONS(2623),
    [anon_sym_LR_DQUOTE] = ACTIONS(2623),
    [anon_sym_uR_DQUOTE] = ACTIONS(2623),
    [anon_sym_UR_DQUOTE] = ACTIONS(2623),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2623),
    [anon_sym_co_await] = ACTIONS(2621),
    [anon_sym_new] = ACTIONS(2621),
    [anon_sym_requires] = ACTIONS(2621),
    [sym_this] = ACTIONS(2621),
  },
  [497] = {
    [ts_builtin_sym_end] = ACTIONS(2631),
    [sym_identifier] = ACTIONS(2629),
    [aux_sym_preproc_include_token1] = ACTIONS(2629),
    [aux_sym_preproc_def_token1] = ACTIONS(2629),
    [aux_sym_preproc_if_token1] = ACTIONS(2629),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2629),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2629),
    [sym_preproc_directive] = ACTIONS(2629),
    [anon_sym_LPAREN2] = ACTIONS(2631),
    [anon_sym_BANG] = ACTIONS(2631),
    [anon_sym_TILDE] = ACTIONS(2631),
    [anon_sym_DASH] = ACTIONS(2629),
    [anon_sym_PLUS] = ACTIONS(2629),
    [anon_sym_STAR] = ACTIONS(2631),
    [anon_sym_AMP_AMP] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2629),
    [anon_sym_SEMI] = ACTIONS(2631),
    [anon_sym___extension__] = ACTIONS(2629),
    [anon_sym_typedef] = ACTIONS(2629),
    [anon_sym_virtual] = ACTIONS(2629),
    [anon_sym_extern] = ACTIONS(2629),
    [anon_sym___attribute__] = ACTIONS(2629),
    [anon_sym___attribute] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(2631),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2631),
    [anon_sym___declspec] = ACTIONS(2629),
    [anon_sym___based] = ACTIONS(2629),
    [anon_sym___cdecl] = ACTIONS(2629),
    [anon_sym___clrcall] = ACTIONS(2629),
    [anon_sym___stdcall] = ACTIONS(2629),
    [anon_sym___fastcall] = ACTIONS(2629),
    [anon_sym___thiscall] = ACTIONS(2629),
    [anon_sym___vectorcall] = ACTIONS(2629),
    [anon_sym_LBRACE] = ACTIONS(2631),
    [anon_sym_signed] = ACTIONS(2629),
    [anon_sym_unsigned] = ACTIONS(2629),
    [anon_sym_long] = ACTIONS(2629),
    [anon_sym_short] = ACTIONS(2629),
    [anon_sym_LBRACK] = ACTIONS(2629),
    [anon_sym_static] = ACTIONS(2629),
    [anon_sym_register] = ACTIONS(2629),
    [anon_sym_inline] = ACTIONS(2629),
    [anon_sym___inline] = ACTIONS(2629),
    [anon_sym___inline__] = ACTIONS(2629),
    [anon_sym___forceinline] = ACTIONS(2629),
    [anon_sym_thread_local] = ACTIONS(2629),
    [anon_sym___thread] = ACTIONS(2629),
    [anon_sym_const] = ACTIONS(2629),
    [anon_sym_constexpr] = ACTIONS(2629),
    [anon_sym_volatile] = ACTIONS(2629),
    [anon_sym_restrict] = ACTIONS(2629),
    [anon_sym___restrict__] = ACTIONS(2629),
    [anon_sym__Atomic] = ACTIONS(2629),
    [anon_sym__Noreturn] = ACTIONS(2629),
    [anon_sym_noreturn] = ACTIONS(2629),
    [anon_sym__Nonnull] = ACTIONS(2629),
    [anon_sym_mutable] = ACTIONS(2629),
    [anon_sym_constinit] = ACTIONS(2629),
    [anon_sym_consteval] = ACTIONS(2629),
    [anon_sym_alignas] = ACTIONS(2629),
    [anon_sym__Alignas] = ACTIONS(2629),
    [sym_primitive_type] = ACTIONS(2629),
    [anon_sym_enum] = ACTIONS(2629),
    [anon_sym_class] = ACTIONS(2629),
    [anon_sym_struct] = ACTIONS(2629),
    [anon_sym_union] = ACTIONS(2629),
    [anon_sym_if] = ACTIONS(2629),
    [anon_sym_else] = ACTIONS(2629),
    [anon_sym_switch] = ACTIONS(2629),
    [anon_sym_case] = ACTIONS(2629),
    [anon_sym_default] = ACTIONS(2629),
    [anon_sym_while] = ACTIONS(2629),
    [anon_sym_do] = ACTIONS(2629),
    [anon_sym_for] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(2629),
    [anon_sym_break] = ACTIONS(2629),
    [anon_sym_continue] = ACTIONS(2629),
    [anon_sym_goto] = ACTIONS(2629),
    [anon_sym___try] = ACTIONS(2629),
    [anon_sym___leave] = ACTIONS(2629),
    [anon_sym_not] = ACTIONS(2629),
    [anon_sym_compl] = ACTIONS(2629),
    [anon_sym_DASH_DASH] = ACTIONS(2631),
    [anon_sym_PLUS_PLUS] = ACTIONS(2631),
    [anon_sym_sizeof] = ACTIONS(2629),
    [anon_sym___alignof__] = ACTIONS(2629),
    [anon_sym___alignof] = ACTIONS(2629),
    [anon_sym__alignof] = ACTIONS(2629),
    [anon_sym_alignof] = ACTIONS(2629),
    [anon_sym__Alignof] = ACTIONS(2629),
    [anon_sym_offsetof] = ACTIONS(2629),
    [anon_sym__Generic] = ACTIONS(2629),
    [anon_sym_asm] = ACTIONS(2629),
    [anon_sym___asm__] = ACTIONS(2629),
    [anon_sym___asm] = ACTIONS(2629),
    [sym_number_literal] = ACTIONS(2631),
    [anon_sym_L_SQUOTE] = ACTIONS(2631),
    [anon_sym_u_SQUOTE] = ACTIONS(2631),
    [anon_sym_U_SQUOTE] = ACTIONS(2631),
    [anon_sym_u8_SQUOTE] = ACTIONS(2631),
    [anon_sym_SQUOTE] = ACTIONS(2631),
    [anon_sym_L_DQUOTE] = ACTIONS(2631),
    [anon_sym_u_DQUOTE] = ACTIONS(2631),
    [anon_sym_U_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8_DQUOTE] = ACTIONS(2631),
    [anon_sym_DQUOTE] = ACTIONS(2631),
    [sym_true] = ACTIONS(2629),
    [sym_false] = ACTIONS(2629),
    [anon_sym_NULL] = ACTIONS(2629),
    [anon_sym_nullptr] = ACTIONS(2629),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2629),
    [anon_sym_decltype] = ACTIONS(2629),
    [anon_sym_explicit] = ACTIONS(2629),
    [anon_sym_typename] = ACTIONS(2629),
    [anon_sym_template] = ACTIONS(2629),
    [anon_sym_operator] = ACTIONS(2629),
    [anon_sym_try] = ACTIONS(2629),
    [anon_sym_delete] = ACTIONS(2629),
    [anon_sym_throw] = ACTIONS(2629),
    [anon_sym_namespace] = ACTIONS(2629),
    [anon_sym_using] = ACTIONS(2629),
    [anon_sym_static_assert] = ACTIONS(2629),
    [anon_sym_concept] = ACTIONS(2629),
    [anon_sym_co_return] = ACTIONS(2629),
    [anon_sym_co_yield] = ACTIONS(2629),
    [anon_sym_R_DQUOTE] = ACTIONS(2631),
    [anon_sym_LR_DQUOTE] = ACTIONS(2631),
    [anon_sym_uR_DQUOTE] = ACTIONS(2631),
    [anon_sym_UR_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2631),
    [anon_sym_co_await] = ACTIONS(2629),
    [anon_sym_new] = ACTIONS(2629),
    [anon_sym_requires] = ACTIONS(2629),
    [sym_this] = ACTIONS(2629),
  },
  [498] = {
    [ts_builtin_sym_end] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2705),
    [aux_sym_preproc_include_token1] = ACTIONS(2705),
    [aux_sym_preproc_def_token1] = ACTIONS(2705),
    [aux_sym_preproc_if_token1] = ACTIONS(2705),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2705),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2705),
    [sym_preproc_directive] = ACTIONS(2705),
    [anon_sym_LPAREN2] = ACTIONS(2707),
    [anon_sym_BANG] = ACTIONS(2707),
    [anon_sym_TILDE] = ACTIONS(2707),
    [anon_sym_DASH] = ACTIONS(2705),
    [anon_sym_PLUS] = ACTIONS(2705),
    [anon_sym_STAR] = ACTIONS(2707),
    [anon_sym_AMP_AMP] = ACTIONS(2707),
    [anon_sym_AMP] = ACTIONS(2705),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym___extension__] = ACTIONS(2705),
    [anon_sym_typedef] = ACTIONS(2705),
    [anon_sym_virtual] = ACTIONS(2705),
    [anon_sym_extern] = ACTIONS(2705),
    [anon_sym___attribute__] = ACTIONS(2705),
    [anon_sym___attribute] = ACTIONS(2705),
    [anon_sym_COLON_COLON] = ACTIONS(2707),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2707),
    [anon_sym___declspec] = ACTIONS(2705),
    [anon_sym___based] = ACTIONS(2705),
    [anon_sym___cdecl] = ACTIONS(2705),
    [anon_sym___clrcall] = ACTIONS(2705),
    [anon_sym___stdcall] = ACTIONS(2705),
    [anon_sym___fastcall] = ACTIONS(2705),
    [anon_sym___thiscall] = ACTIONS(2705),
    [anon_sym___vectorcall] = ACTIONS(2705),
    [anon_sym_LBRACE] = ACTIONS(2707),
    [anon_sym_signed] = ACTIONS(2705),
    [anon_sym_unsigned] = ACTIONS(2705),
    [anon_sym_long] = ACTIONS(2705),
    [anon_sym_short] = ACTIONS(2705),
    [anon_sym_LBRACK] = ACTIONS(2705),
    [anon_sym_static] = ACTIONS(2705),
    [anon_sym_register] = ACTIONS(2705),
    [anon_sym_inline] = ACTIONS(2705),
    [anon_sym___inline] = ACTIONS(2705),
    [anon_sym___inline__] = ACTIONS(2705),
    [anon_sym___forceinline] = ACTIONS(2705),
    [anon_sym_thread_local] = ACTIONS(2705),
    [anon_sym___thread] = ACTIONS(2705),
    [anon_sym_const] = ACTIONS(2705),
    [anon_sym_constexpr] = ACTIONS(2705),
    [anon_sym_volatile] = ACTIONS(2705),
    [anon_sym_restrict] = ACTIONS(2705),
    [anon_sym___restrict__] = ACTIONS(2705),
    [anon_sym__Atomic] = ACTIONS(2705),
    [anon_sym__Noreturn] = ACTIONS(2705),
    [anon_sym_noreturn] = ACTIONS(2705),
    [anon_sym__Nonnull] = ACTIONS(2705),
    [anon_sym_mutable] = ACTIONS(2705),
    [anon_sym_constinit] = ACTIONS(2705),
    [anon_sym_consteval] = ACTIONS(2705),
    [anon_sym_alignas] = ACTIONS(2705),
    [anon_sym__Alignas] = ACTIONS(2705),
    [sym_primitive_type] = ACTIONS(2705),
    [anon_sym_enum] = ACTIONS(2705),
    [anon_sym_class] = ACTIONS(2705),
    [anon_sym_struct] = ACTIONS(2705),
    [anon_sym_union] = ACTIONS(2705),
    [anon_sym_if] = ACTIONS(2705),
    [anon_sym_else] = ACTIONS(2705),
    [anon_sym_switch] = ACTIONS(2705),
    [anon_sym_case] = ACTIONS(2705),
    [anon_sym_default] = ACTIONS(2705),
    [anon_sym_while] = ACTIONS(2705),
    [anon_sym_do] = ACTIONS(2705),
    [anon_sym_for] = ACTIONS(2705),
    [anon_sym_return] = ACTIONS(2705),
    [anon_sym_break] = ACTIONS(2705),
    [anon_sym_continue] = ACTIONS(2705),
    [anon_sym_goto] = ACTIONS(2705),
    [anon_sym___try] = ACTIONS(2705),
    [anon_sym___leave] = ACTIONS(2705),
    [anon_sym_not] = ACTIONS(2705),
    [anon_sym_compl] = ACTIONS(2705),
    [anon_sym_DASH_DASH] = ACTIONS(2707),
    [anon_sym_PLUS_PLUS] = ACTIONS(2707),
    [anon_sym_sizeof] = ACTIONS(2705),
    [anon_sym___alignof__] = ACTIONS(2705),
    [anon_sym___alignof] = ACTIONS(2705),
    [anon_sym__alignof] = ACTIONS(2705),
    [anon_sym_alignof] = ACTIONS(2705),
    [anon_sym__Alignof] = ACTIONS(2705),
    [anon_sym_offsetof] = ACTIONS(2705),
    [anon_sym__Generic] = ACTIONS(2705),
    [anon_sym_asm] = ACTIONS(2705),
    [anon_sym___asm__] = ACTIONS(2705),
    [anon_sym___asm] = ACTIONS(2705),
    [sym_number_literal] = ACTIONS(2707),
    [anon_sym_L_SQUOTE] = ACTIONS(2707),
    [anon_sym_u_SQUOTE] = ACTIONS(2707),
    [anon_sym_U_SQUOTE] = ACTIONS(2707),
    [anon_sym_u8_SQUOTE] = ACTIONS(2707),
    [anon_sym_SQUOTE] = ACTIONS(2707),
    [anon_sym_L_DQUOTE] = ACTIONS(2707),
    [anon_sym_u_DQUOTE] = ACTIONS(2707),
    [anon_sym_U_DQUOTE] = ACTIONS(2707),
    [anon_sym_u8_DQUOTE] = ACTIONS(2707),
    [anon_sym_DQUOTE] = ACTIONS(2707),
    [sym_true] = ACTIONS(2705),
    [sym_false] = ACTIONS(2705),
    [anon_sym_NULL] = ACTIONS(2705),
    [anon_sym_nullptr] = ACTIONS(2705),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2705),
    [anon_sym_decltype] = ACTIONS(2705),
    [anon_sym_explicit] = ACTIONS(2705),
    [anon_sym_typename] = ACTIONS(2705),
    [anon_sym_template] = ACTIONS(2705),
    [anon_sym_operator] = ACTIONS(2705),
    [anon_sym_try] = ACTIONS(2705),
    [anon_sym_delete] = ACTIONS(2705),
    [anon_sym_throw] = ACTIONS(2705),
    [anon_sym_namespace] = ACTIONS(2705),
    [anon_sym_using] = ACTIONS(2705),
    [anon_sym_static_assert] = ACTIONS(2705),
    [anon_sym_concept] = ACTIONS(2705),
    [anon_sym_co_return] = ACTIONS(2705),
    [anon_sym_co_yield] = ACTIONS(2705),
    [anon_sym_R_DQUOTE] = ACTIONS(2707),
    [anon_sym_LR_DQUOTE] = ACTIONS(2707),
    [anon_sym_uR_DQUOTE] = ACTIONS(2707),
    [anon_sym_UR_DQUOTE] = ACTIONS(2707),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2707),
    [anon_sym_co_await] = ACTIONS(2705),
    [anon_sym_new] = ACTIONS(2705),
    [anon_sym_requires] = ACTIONS(2705),
    [sym_this] = ACTIONS(2705),
  },
  [499] = {
    [ts_builtin_sym_end] = ACTIONS(2715),
    [sym_identifier] = ACTIONS(2713),
    [aux_sym_preproc_include_token1] = ACTIONS(2713),
    [aux_sym_preproc_def_token1] = ACTIONS(2713),
    [aux_sym_preproc_if_token1] = ACTIONS(2713),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2713),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2713),
    [sym_preproc_directive] = ACTIONS(2713),
    [anon_sym_LPAREN2] = ACTIONS(2715),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_STAR] = ACTIONS(2715),
    [anon_sym_AMP_AMP] = ACTIONS(2715),
    [anon_sym_AMP] = ACTIONS(2713),
    [anon_sym_SEMI] = ACTIONS(2715),
    [anon_sym___extension__] = ACTIONS(2713),
    [anon_sym_typedef] = ACTIONS(2713),
    [anon_sym_virtual] = ACTIONS(2713),
    [anon_sym_extern] = ACTIONS(2713),
    [anon_sym___attribute__] = ACTIONS(2713),
    [anon_sym___attribute] = ACTIONS(2713),
    [anon_sym_COLON_COLON] = ACTIONS(2715),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2715),
    [anon_sym___declspec] = ACTIONS(2713),
    [anon_sym___based] = ACTIONS(2713),
    [anon_sym___cdecl] = ACTIONS(2713),
    [anon_sym___clrcall] = ACTIONS(2713),
    [anon_sym___stdcall] = ACTIONS(2713),
    [anon_sym___fastcall] = ACTIONS(2713),
    [anon_sym___thiscall] = ACTIONS(2713),
    [anon_sym___vectorcall] = ACTIONS(2713),
    [anon_sym_LBRACE] = ACTIONS(2715),
    [anon_sym_signed] = ACTIONS(2713),
    [anon_sym_unsigned] = ACTIONS(2713),
    [anon_sym_long] = ACTIONS(2713),
    [anon_sym_short] = ACTIONS(2713),
    [anon_sym_LBRACK] = ACTIONS(2713),
    [anon_sym_static] = ACTIONS(2713),
    [anon_sym_register] = ACTIONS(2713),
    [anon_sym_inline] = ACTIONS(2713),
    [anon_sym___inline] = ACTIONS(2713),
    [anon_sym___inline__] = ACTIONS(2713),
    [anon_sym___forceinline] = ACTIONS(2713),
    [anon_sym_thread_local] = ACTIONS(2713),
    [anon_sym___thread] = ACTIONS(2713),
    [anon_sym_const] = ACTIONS(2713),
    [anon_sym_constexpr] = ACTIONS(2713),
    [anon_sym_volatile] = ACTIONS(2713),
    [anon_sym_restrict] = ACTIONS(2713),
    [anon_sym___restrict__] = ACTIONS(2713),
    [anon_sym__Atomic] = ACTIONS(2713),
    [anon_sym__Noreturn] = ACTIONS(2713),
    [anon_sym_noreturn] = ACTIONS(2713),
    [anon_sym__Nonnull] = ACTIONS(2713),
    [anon_sym_mutable] = ACTIONS(2713),
    [anon_sym_constinit] = ACTIONS(2713),
    [anon_sym_consteval] = ACTIONS(2713),
    [anon_sym_alignas] = ACTIONS(2713),
    [anon_sym__Alignas] = ACTIONS(2713),
    [sym_primitive_type] = ACTIONS(2713),
    [anon_sym_enum] = ACTIONS(2713),
    [anon_sym_class] = ACTIONS(2713),
    [anon_sym_struct] = ACTIONS(2713),
    [anon_sym_union] = ACTIONS(2713),
    [anon_sym_if] = ACTIONS(2713),
    [anon_sym_else] = ACTIONS(2713),
    [anon_sym_switch] = ACTIONS(2713),
    [anon_sym_case] = ACTIONS(2713),
    [anon_sym_default] = ACTIONS(2713),
    [anon_sym_while] = ACTIONS(2713),
    [anon_sym_do] = ACTIONS(2713),
    [anon_sym_for] = ACTIONS(2713),
    [anon_sym_return] = ACTIONS(2713),
    [anon_sym_break] = ACTIONS(2713),
    [anon_sym_continue] = ACTIONS(2713),
    [anon_sym_goto] = ACTIONS(2713),
    [anon_sym___try] = ACTIONS(2713),
    [anon_sym___leave] = ACTIONS(2713),
    [anon_sym_not] = ACTIONS(2713),
    [anon_sym_compl] = ACTIONS(2713),
    [anon_sym_DASH_DASH] = ACTIONS(2715),
    [anon_sym_PLUS_PLUS] = ACTIONS(2715),
    [anon_sym_sizeof] = ACTIONS(2713),
    [anon_sym___alignof__] = ACTIONS(2713),
    [anon_sym___alignof] = ACTIONS(2713),
    [anon_sym__alignof] = ACTIONS(2713),
    [anon_sym_alignof] = ACTIONS(2713),
    [anon_sym__Alignof] = ACTIONS(2713),
    [anon_sym_offsetof] = ACTIONS(2713),
    [anon_sym__Generic] = ACTIONS(2713),
    [anon_sym_asm] = ACTIONS(2713),
    [anon_sym___asm__] = ACTIONS(2713),
    [anon_sym___asm] = ACTIONS(2713),
    [sym_number_literal] = ACTIONS(2715),
    [anon_sym_L_SQUOTE] = ACTIONS(2715),
    [anon_sym_u_SQUOTE] = ACTIONS(2715),
    [anon_sym_U_SQUOTE] = ACTIONS(2715),
    [anon_sym_u8_SQUOTE] = ACTIONS(2715),
    [anon_sym_SQUOTE] = ACTIONS(2715),
    [anon_sym_L_DQUOTE] = ACTIONS(2715),
    [anon_sym_u_DQUOTE] = ACTIONS(2715),
    [anon_sym_U_DQUOTE] = ACTIONS(2715),
    [anon_sym_u8_DQUOTE] = ACTIONS(2715),
    [anon_sym_DQUOTE] = ACTIONS(2715),
    [sym_true] = ACTIONS(2713),
    [sym_false] = ACTIONS(2713),
    [anon_sym_NULL] = ACTIONS(2713),
    [anon_sym_nullptr] = ACTIONS(2713),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2713),
    [anon_sym_decltype] = ACTIONS(2713),
    [anon_sym_explicit] = ACTIONS(2713),
    [anon_sym_typename] = ACTIONS(2713),
    [anon_sym_template] = ACTIONS(2713),
    [anon_sym_operator] = ACTIONS(2713),
    [anon_sym_try] = ACTIONS(2713),
    [anon_sym_delete] = ACTIONS(2713),
    [anon_sym_throw] = ACTIONS(2713),
    [anon_sym_namespace] = ACTIONS(2713),
    [anon_sym_using] = ACTIONS(2713),
    [anon_sym_static_assert] = ACTIONS(2713),
    [anon_sym_concept] = ACTIONS(2713),
    [anon_sym_co_return] = ACTIONS(2713),
    [anon_sym_co_yield] = ACTIONS(2713),
    [anon_sym_R_DQUOTE] = ACTIONS(2715),
    [anon_sym_LR_DQUOTE] = ACTIONS(2715),
    [anon_sym_uR_DQUOTE] = ACTIONS(2715),
    [anon_sym_UR_DQUOTE] = ACTIONS(2715),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2715),
    [anon_sym_co_await] = ACTIONS(2713),
    [anon_sym_new] = ACTIONS(2713),
    [anon_sym_requires] = ACTIONS(2713),
    [sym_this] = ACTIONS(2713),
  },
  [500] = {
    [ts_builtin_sym_end] = ACTIONS(2595),
    [sym_identifier] = ACTIONS(2593),
    [aux_sym_preproc_include_token1] = ACTIONS(2593),
    [aux_sym_preproc_def_token1] = ACTIONS(2593),
    [aux_sym_preproc_if_token1] = ACTIONS(2593),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2593),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2593),
    [sym_preproc_directive] = ACTIONS(2593),
    [anon_sym_LPAREN2] = ACTIONS(2595),
    [anon_sym_BANG] = ACTIONS(2595),
    [anon_sym_TILDE] = ACTIONS(2595),
    [anon_sym_DASH] = ACTIONS(2593),
    [anon_sym_PLUS] = ACTIONS(2593),
    [anon_sym_STAR] = ACTIONS(2595),
    [anon_sym_AMP_AMP] = ACTIONS(2595),
    [anon_sym_AMP] = ACTIONS(2593),
    [anon_sym_SEMI] = ACTIONS(2595),
    [anon_sym___extension__] = ACTIONS(2593),
    [anon_sym_typedef] = ACTIONS(2593),
    [anon_sym_virtual] = ACTIONS(2593),
    [anon_sym_extern] = ACTIONS(2593),
    [anon_sym___attribute__] = ACTIONS(2593),
    [anon_sym___attribute] = ACTIONS(2593),
    [anon_sym_COLON_COLON] = ACTIONS(2595),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2595),
    [anon_sym___declspec] = ACTIONS(2593),
    [anon_sym___based] = ACTIONS(2593),
    [anon_sym___cdecl] = ACTIONS(2593),
    [anon_sym___clrcall] = ACTIONS(2593),
    [anon_sym___stdcall] = ACTIONS(2593),
    [anon_sym___fastcall] = ACTIONS(2593),
    [anon_sym___thiscall] = ACTIONS(2593),
    [anon_sym___vectorcall] = ACTIONS(2593),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_signed] = ACTIONS(2593),
    [anon_sym_unsigned] = ACTIONS(2593),
    [anon_sym_long] = ACTIONS(2593),
    [anon_sym_short] = ACTIONS(2593),
    [anon_sym_LBRACK] = ACTIONS(2593),
    [anon_sym_static] = ACTIONS(2593),
    [anon_sym_register] = ACTIONS(2593),
    [anon_sym_inline] = ACTIONS(2593),
    [anon_sym___inline] = ACTIONS(2593),
    [anon_sym___inline__] = ACTIONS(2593),
    [anon_sym___forceinline] = ACTIONS(2593),
    [anon_sym_thread_local] = ACTIONS(2593),
    [anon_sym___thread] = ACTIONS(2593),
    [anon_sym_const] = ACTIONS(2593),
    [anon_sym_constexpr] = ACTIONS(2593),
    [anon_sym_volatile] = ACTIONS(2593),
    [anon_sym_restrict] = ACTIONS(2593),
    [anon_sym___restrict__] = ACTIONS(2593),
    [anon_sym__Atomic] = ACTIONS(2593),
    [anon_sym__Noreturn] = ACTIONS(2593),
    [anon_sym_noreturn] = ACTIONS(2593),
    [anon_sym__Nonnull] = ACTIONS(2593),
    [anon_sym_mutable] = ACTIONS(2593),
    [anon_sym_constinit] = ACTIONS(2593),
    [anon_sym_consteval] = ACTIONS(2593),
    [anon_sym_alignas] = ACTIONS(2593),
    [anon_sym__Alignas] = ACTIONS(2593),
    [sym_primitive_type] = ACTIONS(2593),
    [anon_sym_enum] = ACTIONS(2593),
    [anon_sym_class] = ACTIONS(2593),
    [anon_sym_struct] = ACTIONS(2593),
    [anon_sym_union] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2593),
    [anon_sym_else] = ACTIONS(2593),
    [anon_sym_switch] = ACTIONS(2593),
    [anon_sym_case] = ACTIONS(2593),
    [anon_sym_default] = ACTIONS(2593),
    [anon_sym_while] = ACTIONS(2593),
    [anon_sym_do] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2593),
    [anon_sym_return] = ACTIONS(2593),
    [anon_sym_break] = ACTIONS(2593),
    [anon_sym_continue] = ACTIONS(2593),
    [anon_sym_goto] = ACTIONS(2593),
    [anon_sym___try] = ACTIONS(2593),
    [anon_sym___leave] = ACTIONS(2593),
    [anon_sym_not] = ACTIONS(2593),
    [anon_sym_compl] = ACTIONS(2593),
    [anon_sym_DASH_DASH] = ACTIONS(2595),
    [anon_sym_PLUS_PLUS] = ACTIONS(2595),
    [anon_sym_sizeof] = ACTIONS(2593),
    [anon_sym___alignof__] = ACTIONS(2593),
    [anon_sym___alignof] = ACTIONS(2593),
    [anon_sym__alignof] = ACTIONS(2593),
    [anon_sym_alignof] = ACTIONS(2593),
    [anon_sym__Alignof] = ACTIONS(2593),
    [anon_sym_offsetof] = ACTIONS(2593),
    [anon_sym__Generic] = ACTIONS(2593),
    [anon_sym_asm] = ACTIONS(2593),
    [anon_sym___asm__] = ACTIONS(2593),
    [anon_sym___asm] = ACTIONS(2593),
    [sym_number_literal] = ACTIONS(2595),
    [anon_sym_L_SQUOTE] = ACTIONS(2595),
    [anon_sym_u_SQUOTE] = ACTIONS(2595),
    [anon_sym_U_SQUOTE] = ACTIONS(2595),
    [anon_sym_u8_SQUOTE] = ACTIONS(2595),
    [anon_sym_SQUOTE] = ACTIONS(2595),
    [anon_sym_L_DQUOTE] = ACTIONS(2595),
    [anon_sym_u_DQUOTE] = ACTIONS(2595),
    [anon_sym_U_DQUOTE] = ACTIONS(2595),
    [anon_sym_u8_DQUOTE] = ACTIONS(2595),
    [anon_sym_DQUOTE] = ACTIONS(2595),
    [sym_true] = ACTIONS(2593),
    [sym_false] = ACTIONS(2593),
    [anon_sym_NULL] = ACTIONS(2593),
    [anon_sym_nullptr] = ACTIONS(2593),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2593),
    [anon_sym_decltype] = ACTIONS(2593),
    [anon_sym_explicit] = ACTIONS(2593),
    [anon_sym_typename] = ACTIONS(2593),
    [anon_sym_template] = ACTIONS(2593),
    [anon_sym_operator] = ACTIONS(2593),
    [anon_sym_try] = ACTIONS(2593),
    [anon_sym_delete] = ACTIONS(2593),
    [anon_sym_throw] = ACTIONS(2593),
    [anon_sym_namespace] = ACTIONS(2593),
    [anon_sym_using] = ACTIONS(2593),
    [anon_sym_static_assert] = ACTIONS(2593),
    [anon_sym_concept] = ACTIONS(2593),
    [anon_sym_co_return] = ACTIONS(2593),
    [anon_sym_co_yield] = ACTIONS(2593),
    [anon_sym_R_DQUOTE] = ACTIONS(2595),
    [anon_sym_LR_DQUOTE] = ACTIONS(2595),
    [anon_sym_uR_DQUOTE] = ACTIONS(2595),
    [anon_sym_UR_DQUOTE] = ACTIONS(2595),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2595),
    [anon_sym_co_await] = ACTIONS(2593),
    [anon_sym_new] = ACTIONS(2593),
    [anon_sym_requires] = ACTIONS(2593),
    [sym_this] = ACTIONS(2593),
  },
  [501] = {
    [sym_identifier] = ACTIONS(2693),
    [aux_sym_preproc_include_token1] = ACTIONS(2693),
    [aux_sym_preproc_def_token1] = ACTIONS(2693),
    [aux_sym_preproc_if_token1] = ACTIONS(2693),
    [aux_sym_preproc_if_token2] = ACTIONS(2693),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2693),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2693),
    [sym_preproc_directive] = ACTIONS(2693),
    [anon_sym_LPAREN2] = ACTIONS(2695),
    [anon_sym_BANG] = ACTIONS(2695),
    [anon_sym_TILDE] = ACTIONS(2695),
    [anon_sym_DASH] = ACTIONS(2693),
    [anon_sym_PLUS] = ACTIONS(2693),
    [anon_sym_STAR] = ACTIONS(2695),
    [anon_sym_AMP_AMP] = ACTIONS(2695),
    [anon_sym_AMP] = ACTIONS(2693),
    [anon_sym_SEMI] = ACTIONS(2695),
    [anon_sym___extension__] = ACTIONS(2693),
    [anon_sym_typedef] = ACTIONS(2693),
    [anon_sym_virtual] = ACTIONS(2693),
    [anon_sym_extern] = ACTIONS(2693),
    [anon_sym___attribute__] = ACTIONS(2693),
    [anon_sym___attribute] = ACTIONS(2693),
    [anon_sym_COLON_COLON] = ACTIONS(2695),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2695),
    [anon_sym___declspec] = ACTIONS(2693),
    [anon_sym___based] = ACTIONS(2693),
    [anon_sym___cdecl] = ACTIONS(2693),
    [anon_sym___clrcall] = ACTIONS(2693),
    [anon_sym___stdcall] = ACTIONS(2693),
    [anon_sym___fastcall] = ACTIONS(2693),
    [anon_sym___thiscall] = ACTIONS(2693),
    [anon_sym___vectorcall] = ACTIONS(2693),
    [anon_sym_LBRACE] = ACTIONS(2695),
    [anon_sym_signed] = ACTIONS(2693),
    [anon_sym_unsigned] = ACTIONS(2693),
    [anon_sym_long] = ACTIONS(2693),
    [anon_sym_short] = ACTIONS(2693),
    [anon_sym_LBRACK] = ACTIONS(2693),
    [anon_sym_static] = ACTIONS(2693),
    [anon_sym_register] = ACTIONS(2693),
    [anon_sym_inline] = ACTIONS(2693),
    [anon_sym___inline] = ACTIONS(2693),
    [anon_sym___inline__] = ACTIONS(2693),
    [anon_sym___forceinline] = ACTIONS(2693),
    [anon_sym_thread_local] = ACTIONS(2693),
    [anon_sym___thread] = ACTIONS(2693),
    [anon_sym_const] = ACTIONS(2693),
    [anon_sym_constexpr] = ACTIONS(2693),
    [anon_sym_volatile] = ACTIONS(2693),
    [anon_sym_restrict] = ACTIONS(2693),
    [anon_sym___restrict__] = ACTIONS(2693),
    [anon_sym__Atomic] = ACTIONS(2693),
    [anon_sym__Noreturn] = ACTIONS(2693),
    [anon_sym_noreturn] = ACTIONS(2693),
    [anon_sym__Nonnull] = ACTIONS(2693),
    [anon_sym_mutable] = ACTIONS(2693),
    [anon_sym_constinit] = ACTIONS(2693),
    [anon_sym_consteval] = ACTIONS(2693),
    [anon_sym_alignas] = ACTIONS(2693),
    [anon_sym__Alignas] = ACTIONS(2693),
    [sym_primitive_type] = ACTIONS(2693),
    [anon_sym_enum] = ACTIONS(2693),
    [anon_sym_class] = ACTIONS(2693),
    [anon_sym_struct] = ACTIONS(2693),
    [anon_sym_union] = ACTIONS(2693),
    [anon_sym_if] = ACTIONS(2693),
    [anon_sym_else] = ACTIONS(2693),
    [anon_sym_switch] = ACTIONS(2693),
    [anon_sym_case] = ACTIONS(2693),
    [anon_sym_default] = ACTIONS(2693),
    [anon_sym_while] = ACTIONS(2693),
    [anon_sym_do] = ACTIONS(2693),
    [anon_sym_for] = ACTIONS(2693),
    [anon_sym_return] = ACTIONS(2693),
    [anon_sym_break] = ACTIONS(2693),
    [anon_sym_continue] = ACTIONS(2693),
    [anon_sym_goto] = ACTIONS(2693),
    [anon_sym___try] = ACTIONS(2693),
    [anon_sym___leave] = ACTIONS(2693),
    [anon_sym_not] = ACTIONS(2693),
    [anon_sym_compl] = ACTIONS(2693),
    [anon_sym_DASH_DASH] = ACTIONS(2695),
    [anon_sym_PLUS_PLUS] = ACTIONS(2695),
    [anon_sym_sizeof] = ACTIONS(2693),
    [anon_sym___alignof__] = ACTIONS(2693),
    [anon_sym___alignof] = ACTIONS(2693),
    [anon_sym__alignof] = ACTIONS(2693),
    [anon_sym_alignof] = ACTIONS(2693),
    [anon_sym__Alignof] = ACTIONS(2693),
    [anon_sym_offsetof] = ACTIONS(2693),
    [anon_sym__Generic] = ACTIONS(2693),
    [anon_sym_asm] = ACTIONS(2693),
    [anon_sym___asm__] = ACTIONS(2693),
    [anon_sym___asm] = ACTIONS(2693),
    [sym_number_literal] = ACTIONS(2695),
    [anon_sym_L_SQUOTE] = ACTIONS(2695),
    [anon_sym_u_SQUOTE] = ACTIONS(2695),
    [anon_sym_U_SQUOTE] = ACTIONS(2695),
    [anon_sym_u8_SQUOTE] = ACTIONS(2695),
    [anon_sym_SQUOTE] = ACTIONS(2695),
    [anon_sym_L_DQUOTE] = ACTIONS(2695),
    [anon_sym_u_DQUOTE] = ACTIONS(2695),
    [anon_sym_U_DQUOTE] = ACTIONS(2695),
    [anon_sym_u8_DQUOTE] = ACTIONS(2695),
    [anon_sym_DQUOTE] = ACTIONS(2695),
    [sym_true] = ACTIONS(2693),
    [sym_false] = ACTIONS(2693),
    [anon_sym_NULL] = ACTIONS(2693),
    [anon_sym_nullptr] = ACTIONS(2693),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2693),
    [anon_sym_decltype] = ACTIONS(2693),
    [anon_sym_explicit] = ACTIONS(2693),
    [anon_sym_typename] = ACTIONS(2693),
    [anon_sym_template] = ACTIONS(2693),
    [anon_sym_operator] = ACTIONS(2693),
    [anon_sym_try] = ACTIONS(2693),
    [anon_sym_delete] = ACTIONS(2693),
    [anon_sym_throw] = ACTIONS(2693),
    [anon_sym_namespace] = ACTIONS(2693),
    [anon_sym_using] = ACTIONS(2693),
    [anon_sym_static_assert] = ACTIONS(2693),
    [anon_sym_concept] = ACTIONS(2693),
    [anon_sym_co_return] = ACTIONS(2693),
    [anon_sym_co_yield] = ACTIONS(2693),
    [anon_sym_R_DQUOTE] = ACTIONS(2695),
    [anon_sym_LR_DQUOTE] = ACTIONS(2695),
    [anon_sym_uR_DQUOTE] = ACTIONS(2695),
    [anon_sym_UR_DQUOTE] = ACTIONS(2695),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2695),
    [anon_sym_co_await] = ACTIONS(2693),
    [anon_sym_new] = ACTIONS(2693),
    [anon_sym_requires] = ACTIONS(2693),
    [sym_this] = ACTIONS(2693),
  },
  [502] = {
    [sym_identifier] = ACTIONS(2705),
    [aux_sym_preproc_include_token1] = ACTIONS(2705),
    [aux_sym_preproc_def_token1] = ACTIONS(2705),
    [aux_sym_preproc_if_token1] = ACTIONS(2705),
    [aux_sym_preproc_if_token2] = ACTIONS(2705),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2705),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2705),
    [sym_preproc_directive] = ACTIONS(2705),
    [anon_sym_LPAREN2] = ACTIONS(2707),
    [anon_sym_BANG] = ACTIONS(2707),
    [anon_sym_TILDE] = ACTIONS(2707),
    [anon_sym_DASH] = ACTIONS(2705),
    [anon_sym_PLUS] = ACTIONS(2705),
    [anon_sym_STAR] = ACTIONS(2707),
    [anon_sym_AMP_AMP] = ACTIONS(2707),
    [anon_sym_AMP] = ACTIONS(2705),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym___extension__] = ACTIONS(2705),
    [anon_sym_typedef] = ACTIONS(2705),
    [anon_sym_virtual] = ACTIONS(2705),
    [anon_sym_extern] = ACTIONS(2705),
    [anon_sym___attribute__] = ACTIONS(2705),
    [anon_sym___attribute] = ACTIONS(2705),
    [anon_sym_COLON_COLON] = ACTIONS(2707),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2707),
    [anon_sym___declspec] = ACTIONS(2705),
    [anon_sym___based] = ACTIONS(2705),
    [anon_sym___cdecl] = ACTIONS(2705),
    [anon_sym___clrcall] = ACTIONS(2705),
    [anon_sym___stdcall] = ACTIONS(2705),
    [anon_sym___fastcall] = ACTIONS(2705),
    [anon_sym___thiscall] = ACTIONS(2705),
    [anon_sym___vectorcall] = ACTIONS(2705),
    [anon_sym_LBRACE] = ACTIONS(2707),
    [anon_sym_signed] = ACTIONS(2705),
    [anon_sym_unsigned] = ACTIONS(2705),
    [anon_sym_long] = ACTIONS(2705),
    [anon_sym_short] = ACTIONS(2705),
    [anon_sym_LBRACK] = ACTIONS(2705),
    [anon_sym_static] = ACTIONS(2705),
    [anon_sym_register] = ACTIONS(2705),
    [anon_sym_inline] = ACTIONS(2705),
    [anon_sym___inline] = ACTIONS(2705),
    [anon_sym___inline__] = ACTIONS(2705),
    [anon_sym___forceinline] = ACTIONS(2705),
    [anon_sym_thread_local] = ACTIONS(2705),
    [anon_sym___thread] = ACTIONS(2705),
    [anon_sym_const] = ACTIONS(2705),
    [anon_sym_constexpr] = ACTIONS(2705),
    [anon_sym_volatile] = ACTIONS(2705),
    [anon_sym_restrict] = ACTIONS(2705),
    [anon_sym___restrict__] = ACTIONS(2705),
    [anon_sym__Atomic] = ACTIONS(2705),
    [anon_sym__Noreturn] = ACTIONS(2705),
    [anon_sym_noreturn] = ACTIONS(2705),
    [anon_sym__Nonnull] = ACTIONS(2705),
    [anon_sym_mutable] = ACTIONS(2705),
    [anon_sym_constinit] = ACTIONS(2705),
    [anon_sym_consteval] = ACTIONS(2705),
    [anon_sym_alignas] = ACTIONS(2705),
    [anon_sym__Alignas] = ACTIONS(2705),
    [sym_primitive_type] = ACTIONS(2705),
    [anon_sym_enum] = ACTIONS(2705),
    [anon_sym_class] = ACTIONS(2705),
    [anon_sym_struct] = ACTIONS(2705),
    [anon_sym_union] = ACTIONS(2705),
    [anon_sym_if] = ACTIONS(2705),
    [anon_sym_else] = ACTIONS(2705),
    [anon_sym_switch] = ACTIONS(2705),
    [anon_sym_case] = ACTIONS(2705),
    [anon_sym_default] = ACTIONS(2705),
    [anon_sym_while] = ACTIONS(2705),
    [anon_sym_do] = ACTIONS(2705),
    [anon_sym_for] = ACTIONS(2705),
    [anon_sym_return] = ACTIONS(2705),
    [anon_sym_break] = ACTIONS(2705),
    [anon_sym_continue] = ACTIONS(2705),
    [anon_sym_goto] = ACTIONS(2705),
    [anon_sym___try] = ACTIONS(2705),
    [anon_sym___leave] = ACTIONS(2705),
    [anon_sym_not] = ACTIONS(2705),
    [anon_sym_compl] = ACTIONS(2705),
    [anon_sym_DASH_DASH] = ACTIONS(2707),
    [anon_sym_PLUS_PLUS] = ACTIONS(2707),
    [anon_sym_sizeof] = ACTIONS(2705),
    [anon_sym___alignof__] = ACTIONS(2705),
    [anon_sym___alignof] = ACTIONS(2705),
    [anon_sym__alignof] = ACTIONS(2705),
    [anon_sym_alignof] = ACTIONS(2705),
    [anon_sym__Alignof] = ACTIONS(2705),
    [anon_sym_offsetof] = ACTIONS(2705),
    [anon_sym__Generic] = ACTIONS(2705),
    [anon_sym_asm] = ACTIONS(2705),
    [anon_sym___asm__] = ACTIONS(2705),
    [anon_sym___asm] = ACTIONS(2705),
    [sym_number_literal] = ACTIONS(2707),
    [anon_sym_L_SQUOTE] = ACTIONS(2707),
    [anon_sym_u_SQUOTE] = ACTIONS(2707),
    [anon_sym_U_SQUOTE] = ACTIONS(2707),
    [anon_sym_u8_SQUOTE] = ACTIONS(2707),
    [anon_sym_SQUOTE] = ACTIONS(2707),
    [anon_sym_L_DQUOTE] = ACTIONS(2707),
    [anon_sym_u_DQUOTE] = ACTIONS(2707),
    [anon_sym_U_DQUOTE] = ACTIONS(2707),
    [anon_sym_u8_DQUOTE] = ACTIONS(2707),
    [anon_sym_DQUOTE] = ACTIONS(2707),
    [sym_true] = ACTIONS(2705),
    [sym_false] = ACTIONS(2705),
    [anon_sym_NULL] = ACTIONS(2705),
    [anon_sym_nullptr] = ACTIONS(2705),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2705),
    [anon_sym_decltype] = ACTIONS(2705),
    [anon_sym_explicit] = ACTIONS(2705),
    [anon_sym_typename] = ACTIONS(2705),
    [anon_sym_template] = ACTIONS(2705),
    [anon_sym_operator] = ACTIONS(2705),
    [anon_sym_try] = ACTIONS(2705),
    [anon_sym_delete] = ACTIONS(2705),
    [anon_sym_throw] = ACTIONS(2705),
    [anon_sym_namespace] = ACTIONS(2705),
    [anon_sym_using] = ACTIONS(2705),
    [anon_sym_static_assert] = ACTIONS(2705),
    [anon_sym_concept] = ACTIONS(2705),
    [anon_sym_co_return] = ACTIONS(2705),
    [anon_sym_co_yield] = ACTIONS(2705),
    [anon_sym_R_DQUOTE] = ACTIONS(2707),
    [anon_sym_LR_DQUOTE] = ACTIONS(2707),
    [anon_sym_uR_DQUOTE] = ACTIONS(2707),
    [anon_sym_UR_DQUOTE] = ACTIONS(2707),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2707),
    [anon_sym_co_await] = ACTIONS(2705),
    [anon_sym_new] = ACTIONS(2705),
    [anon_sym_requires] = ACTIONS(2705),
    [sym_this] = ACTIONS(2705),
  },
  [503] = {
    [sym_identifier] = ACTIONS(2713),
    [aux_sym_preproc_include_token1] = ACTIONS(2713),
    [aux_sym_preproc_def_token1] = ACTIONS(2713),
    [aux_sym_preproc_if_token1] = ACTIONS(2713),
    [aux_sym_preproc_if_token2] = ACTIONS(2713),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2713),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2713),
    [sym_preproc_directive] = ACTIONS(2713),
    [anon_sym_LPAREN2] = ACTIONS(2715),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_STAR] = ACTIONS(2715),
    [anon_sym_AMP_AMP] = ACTIONS(2715),
    [anon_sym_AMP] = ACTIONS(2713),
    [anon_sym_SEMI] = ACTIONS(2715),
    [anon_sym___extension__] = ACTIONS(2713),
    [anon_sym_typedef] = ACTIONS(2713),
    [anon_sym_virtual] = ACTIONS(2713),
    [anon_sym_extern] = ACTIONS(2713),
    [anon_sym___attribute__] = ACTIONS(2713),
    [anon_sym___attribute] = ACTIONS(2713),
    [anon_sym_COLON_COLON] = ACTIONS(2715),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2715),
    [anon_sym___declspec] = ACTIONS(2713),
    [anon_sym___based] = ACTIONS(2713),
    [anon_sym___cdecl] = ACTIONS(2713),
    [anon_sym___clrcall] = ACTIONS(2713),
    [anon_sym___stdcall] = ACTIONS(2713),
    [anon_sym___fastcall] = ACTIONS(2713),
    [anon_sym___thiscall] = ACTIONS(2713),
    [anon_sym___vectorcall] = ACTIONS(2713),
    [anon_sym_LBRACE] = ACTIONS(2715),
    [anon_sym_signed] = ACTIONS(2713),
    [anon_sym_unsigned] = ACTIONS(2713),
    [anon_sym_long] = ACTIONS(2713),
    [anon_sym_short] = ACTIONS(2713),
    [anon_sym_LBRACK] = ACTIONS(2713),
    [anon_sym_static] = ACTIONS(2713),
    [anon_sym_register] = ACTIONS(2713),
    [anon_sym_inline] = ACTIONS(2713),
    [anon_sym___inline] = ACTIONS(2713),
    [anon_sym___inline__] = ACTIONS(2713),
    [anon_sym___forceinline] = ACTIONS(2713),
    [anon_sym_thread_local] = ACTIONS(2713),
    [anon_sym___thread] = ACTIONS(2713),
    [anon_sym_const] = ACTIONS(2713),
    [anon_sym_constexpr] = ACTIONS(2713),
    [anon_sym_volatile] = ACTIONS(2713),
    [anon_sym_restrict] = ACTIONS(2713),
    [anon_sym___restrict__] = ACTIONS(2713),
    [anon_sym__Atomic] = ACTIONS(2713),
    [anon_sym__Noreturn] = ACTIONS(2713),
    [anon_sym_noreturn] = ACTIONS(2713),
    [anon_sym__Nonnull] = ACTIONS(2713),
    [anon_sym_mutable] = ACTIONS(2713),
    [anon_sym_constinit] = ACTIONS(2713),
    [anon_sym_consteval] = ACTIONS(2713),
    [anon_sym_alignas] = ACTIONS(2713),
    [anon_sym__Alignas] = ACTIONS(2713),
    [sym_primitive_type] = ACTIONS(2713),
    [anon_sym_enum] = ACTIONS(2713),
    [anon_sym_class] = ACTIONS(2713),
    [anon_sym_struct] = ACTIONS(2713),
    [anon_sym_union] = ACTIONS(2713),
    [anon_sym_if] = ACTIONS(2713),
    [anon_sym_else] = ACTIONS(2713),
    [anon_sym_switch] = ACTIONS(2713),
    [anon_sym_case] = ACTIONS(2713),
    [anon_sym_default] = ACTIONS(2713),
    [anon_sym_while] = ACTIONS(2713),
    [anon_sym_do] = ACTIONS(2713),
    [anon_sym_for] = ACTIONS(2713),
    [anon_sym_return] = ACTIONS(2713),
    [anon_sym_break] = ACTIONS(2713),
    [anon_sym_continue] = ACTIONS(2713),
    [anon_sym_goto] = ACTIONS(2713),
    [anon_sym___try] = ACTIONS(2713),
    [anon_sym___leave] = ACTIONS(2713),
    [anon_sym_not] = ACTIONS(2713),
    [anon_sym_compl] = ACTIONS(2713),
    [anon_sym_DASH_DASH] = ACTIONS(2715),
    [anon_sym_PLUS_PLUS] = ACTIONS(2715),
    [anon_sym_sizeof] = ACTIONS(2713),
    [anon_sym___alignof__] = ACTIONS(2713),
    [anon_sym___alignof] = ACTIONS(2713),
    [anon_sym__alignof] = ACTIONS(2713),
    [anon_sym_alignof] = ACTIONS(2713),
    [anon_sym__Alignof] = ACTIONS(2713),
    [anon_sym_offsetof] = ACTIONS(2713),
    [anon_sym__Generic] = ACTIONS(2713),
    [anon_sym_asm] = ACTIONS(2713),
    [anon_sym___asm__] = ACTIONS(2713),
    [anon_sym___asm] = ACTIONS(2713),
    [sym_number_literal] = ACTIONS(2715),
    [anon_sym_L_SQUOTE] = ACTIONS(2715),
    [anon_sym_u_SQUOTE] = ACTIONS(2715),
    [anon_sym_U_SQUOTE] = ACTIONS(2715),
    [anon_sym_u8_SQUOTE] = ACTIONS(2715),
    [anon_sym_SQUOTE] = ACTIONS(2715),
    [anon_sym_L_DQUOTE] = ACTIONS(2715),
    [anon_sym_u_DQUOTE] = ACTIONS(2715),
    [anon_sym_U_DQUOTE] = ACTIONS(2715),
    [anon_sym_u8_DQUOTE] = ACTIONS(2715),
    [anon_sym_DQUOTE] = ACTIONS(2715),
    [sym_true] = ACTIONS(2713),
    [sym_false] = ACTIONS(2713),
    [anon_sym_NULL] = ACTIONS(2713),
    [anon_sym_nullptr] = ACTIONS(2713),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2713),
    [anon_sym_decltype] = ACTIONS(2713),
    [anon_sym_explicit] = ACTIONS(2713),
    [anon_sym_typename] = ACTIONS(2713),
    [anon_sym_template] = ACTIONS(2713),
    [anon_sym_operator] = ACTIONS(2713),
    [anon_sym_try] = ACTIONS(2713),
    [anon_sym_delete] = ACTIONS(2713),
    [anon_sym_throw] = ACTIONS(2713),
    [anon_sym_namespace] = ACTIONS(2713),
    [anon_sym_using] = ACTIONS(2713),
    [anon_sym_static_assert] = ACTIONS(2713),
    [anon_sym_concept] = ACTIONS(2713),
    [anon_sym_co_return] = ACTIONS(2713),
    [anon_sym_co_yield] = ACTIONS(2713),
    [anon_sym_R_DQUOTE] = ACTIONS(2715),
    [anon_sym_LR_DQUOTE] = ACTIONS(2715),
    [anon_sym_uR_DQUOTE] = ACTIONS(2715),
    [anon_sym_UR_DQUOTE] = ACTIONS(2715),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2715),
    [anon_sym_co_await] = ACTIONS(2713),
    [anon_sym_new] = ACTIONS(2713),
    [anon_sym_requires] = ACTIONS(2713),
    [sym_this] = ACTIONS(2713),
  },
  [504] = {
    [sym_identifier] = ACTIONS(2589),
    [aux_sym_preproc_include_token1] = ACTIONS(2589),
    [aux_sym_preproc_def_token1] = ACTIONS(2589),
    [aux_sym_preproc_if_token1] = ACTIONS(2589),
    [aux_sym_preproc_if_token2] = ACTIONS(2589),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2589),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2589),
    [sym_preproc_directive] = ACTIONS(2589),
    [anon_sym_LPAREN2] = ACTIONS(2591),
    [anon_sym_BANG] = ACTIONS(2591),
    [anon_sym_TILDE] = ACTIONS(2591),
    [anon_sym_DASH] = ACTIONS(2589),
    [anon_sym_PLUS] = ACTIONS(2589),
    [anon_sym_STAR] = ACTIONS(2591),
    [anon_sym_AMP_AMP] = ACTIONS(2591),
    [anon_sym_AMP] = ACTIONS(2589),
    [anon_sym_SEMI] = ACTIONS(2591),
    [anon_sym___extension__] = ACTIONS(2589),
    [anon_sym_typedef] = ACTIONS(2589),
    [anon_sym_virtual] = ACTIONS(2589),
    [anon_sym_extern] = ACTIONS(2589),
    [anon_sym___attribute__] = ACTIONS(2589),
    [anon_sym___attribute] = ACTIONS(2589),
    [anon_sym_COLON_COLON] = ACTIONS(2591),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2591),
    [anon_sym___declspec] = ACTIONS(2589),
    [anon_sym___based] = ACTIONS(2589),
    [anon_sym___cdecl] = ACTIONS(2589),
    [anon_sym___clrcall] = ACTIONS(2589),
    [anon_sym___stdcall] = ACTIONS(2589),
    [anon_sym___fastcall] = ACTIONS(2589),
    [anon_sym___thiscall] = ACTIONS(2589),
    [anon_sym___vectorcall] = ACTIONS(2589),
    [anon_sym_LBRACE] = ACTIONS(2591),
    [anon_sym_signed] = ACTIONS(2589),
    [anon_sym_unsigned] = ACTIONS(2589),
    [anon_sym_long] = ACTIONS(2589),
    [anon_sym_short] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(2589),
    [anon_sym_static] = ACTIONS(2589),
    [anon_sym_register] = ACTIONS(2589),
    [anon_sym_inline] = ACTIONS(2589),
    [anon_sym___inline] = ACTIONS(2589),
    [anon_sym___inline__] = ACTIONS(2589),
    [anon_sym___forceinline] = ACTIONS(2589),
    [anon_sym_thread_local] = ACTIONS(2589),
    [anon_sym___thread] = ACTIONS(2589),
    [anon_sym_const] = ACTIONS(2589),
    [anon_sym_constexpr] = ACTIONS(2589),
    [anon_sym_volatile] = ACTIONS(2589),
    [anon_sym_restrict] = ACTIONS(2589),
    [anon_sym___restrict__] = ACTIONS(2589),
    [anon_sym__Atomic] = ACTIONS(2589),
    [anon_sym__Noreturn] = ACTIONS(2589),
    [anon_sym_noreturn] = ACTIONS(2589),
    [anon_sym__Nonnull] = ACTIONS(2589),
    [anon_sym_mutable] = ACTIONS(2589),
    [anon_sym_constinit] = ACTIONS(2589),
    [anon_sym_consteval] = ACTIONS(2589),
    [anon_sym_alignas] = ACTIONS(2589),
    [anon_sym__Alignas] = ACTIONS(2589),
    [sym_primitive_type] = ACTIONS(2589),
    [anon_sym_enum] = ACTIONS(2589),
    [anon_sym_class] = ACTIONS(2589),
    [anon_sym_struct] = ACTIONS(2589),
    [anon_sym_union] = ACTIONS(2589),
    [anon_sym_if] = ACTIONS(2589),
    [anon_sym_else] = ACTIONS(2589),
    [anon_sym_switch] = ACTIONS(2589),
    [anon_sym_case] = ACTIONS(2589),
    [anon_sym_default] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2589),
    [anon_sym_do] = ACTIONS(2589),
    [anon_sym_for] = ACTIONS(2589),
    [anon_sym_return] = ACTIONS(2589),
    [anon_sym_break] = ACTIONS(2589),
    [anon_sym_continue] = ACTIONS(2589),
    [anon_sym_goto] = ACTIONS(2589),
    [anon_sym___try] = ACTIONS(2589),
    [anon_sym___leave] = ACTIONS(2589),
    [anon_sym_not] = ACTIONS(2589),
    [anon_sym_compl] = ACTIONS(2589),
    [anon_sym_DASH_DASH] = ACTIONS(2591),
    [anon_sym_PLUS_PLUS] = ACTIONS(2591),
    [anon_sym_sizeof] = ACTIONS(2589),
    [anon_sym___alignof__] = ACTIONS(2589),
    [anon_sym___alignof] = ACTIONS(2589),
    [anon_sym__alignof] = ACTIONS(2589),
    [anon_sym_alignof] = ACTIONS(2589),
    [anon_sym__Alignof] = ACTIONS(2589),
    [anon_sym_offsetof] = ACTIONS(2589),
    [anon_sym__Generic] = ACTIONS(2589),
    [anon_sym_asm] = ACTIONS(2589),
    [anon_sym___asm__] = ACTIONS(2589),
    [anon_sym___asm] = ACTIONS(2589),
    [sym_number_literal] = ACTIONS(2591),
    [anon_sym_L_SQUOTE] = ACTIONS(2591),
    [anon_sym_u_SQUOTE] = ACTIONS(2591),
    [anon_sym_U_SQUOTE] = ACTIONS(2591),
    [anon_sym_u8_SQUOTE] = ACTIONS(2591),
    [anon_sym_SQUOTE] = ACTIONS(2591),
    [anon_sym_L_DQUOTE] = ACTIONS(2591),
    [anon_sym_u_DQUOTE] = ACTIONS(2591),
    [anon_sym_U_DQUOTE] = ACTIONS(2591),
    [anon_sym_u8_DQUOTE] = ACTIONS(2591),
    [anon_sym_DQUOTE] = ACTIONS(2591),
    [sym_true] = ACTIONS(2589),
    [sym_false] = ACTIONS(2589),
    [anon_sym_NULL] = ACTIONS(2589),
    [anon_sym_nullptr] = ACTIONS(2589),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2589),
    [anon_sym_decltype] = ACTIONS(2589),
    [anon_sym_explicit] = ACTIONS(2589),
    [anon_sym_typename] = ACTIONS(2589),
    [anon_sym_template] = ACTIONS(2589),
    [anon_sym_operator] = ACTIONS(2589),
    [anon_sym_try] = ACTIONS(2589),
    [anon_sym_delete] = ACTIONS(2589),
    [anon_sym_throw] = ACTIONS(2589),
    [anon_sym_namespace] = ACTIONS(2589),
    [anon_sym_using] = ACTIONS(2589),
    [anon_sym_static_assert] = ACTIONS(2589),
    [anon_sym_concept] = ACTIONS(2589),
    [anon_sym_co_return] = ACTIONS(2589),
    [anon_sym_co_yield] = ACTIONS(2589),
    [anon_sym_R_DQUOTE] = ACTIONS(2591),
    [anon_sym_LR_DQUOTE] = ACTIONS(2591),
    [anon_sym_uR_DQUOTE] = ACTIONS(2591),
    [anon_sym_UR_DQUOTE] = ACTIONS(2591),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2591),
    [anon_sym_co_await] = ACTIONS(2589),
    [anon_sym_new] = ACTIONS(2589),
    [anon_sym_requires] = ACTIONS(2589),
    [sym_this] = ACTIONS(2589),
  },
  [505] = {
    [sym_identifier] = ACTIONS(2723),
    [aux_sym_preproc_include_token1] = ACTIONS(2723),
    [aux_sym_preproc_def_token1] = ACTIONS(2723),
    [aux_sym_preproc_if_token1] = ACTIONS(2723),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2723),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2723),
    [sym_preproc_directive] = ACTIONS(2723),
    [anon_sym_LPAREN2] = ACTIONS(2725),
    [anon_sym_BANG] = ACTIONS(2725),
    [anon_sym_TILDE] = ACTIONS(2725),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_STAR] = ACTIONS(2725),
    [anon_sym_AMP_AMP] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_SEMI] = ACTIONS(2725),
    [anon_sym___extension__] = ACTIONS(2723),
    [anon_sym_typedef] = ACTIONS(2723),
    [anon_sym_virtual] = ACTIONS(2723),
    [anon_sym_extern] = ACTIONS(2723),
    [anon_sym___attribute__] = ACTIONS(2723),
    [anon_sym___attribute] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2725),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2725),
    [anon_sym___declspec] = ACTIONS(2723),
    [anon_sym___based] = ACTIONS(2723),
    [anon_sym___cdecl] = ACTIONS(2723),
    [anon_sym___clrcall] = ACTIONS(2723),
    [anon_sym___stdcall] = ACTIONS(2723),
    [anon_sym___fastcall] = ACTIONS(2723),
    [anon_sym___thiscall] = ACTIONS(2723),
    [anon_sym___vectorcall] = ACTIONS(2723),
    [anon_sym_LBRACE] = ACTIONS(2725),
    [anon_sym_RBRACE] = ACTIONS(2725),
    [anon_sym_signed] = ACTIONS(2723),
    [anon_sym_unsigned] = ACTIONS(2723),
    [anon_sym_long] = ACTIONS(2723),
    [anon_sym_short] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_static] = ACTIONS(2723),
    [anon_sym_register] = ACTIONS(2723),
    [anon_sym_inline] = ACTIONS(2723),
    [anon_sym___inline] = ACTIONS(2723),
    [anon_sym___inline__] = ACTIONS(2723),
    [anon_sym___forceinline] = ACTIONS(2723),
    [anon_sym_thread_local] = ACTIONS(2723),
    [anon_sym___thread] = ACTIONS(2723),
    [anon_sym_const] = ACTIONS(2723),
    [anon_sym_constexpr] = ACTIONS(2723),
    [anon_sym_volatile] = ACTIONS(2723),
    [anon_sym_restrict] = ACTIONS(2723),
    [anon_sym___restrict__] = ACTIONS(2723),
    [anon_sym__Atomic] = ACTIONS(2723),
    [anon_sym__Noreturn] = ACTIONS(2723),
    [anon_sym_noreturn] = ACTIONS(2723),
    [anon_sym__Nonnull] = ACTIONS(2723),
    [anon_sym_mutable] = ACTIONS(2723),
    [anon_sym_constinit] = ACTIONS(2723),
    [anon_sym_consteval] = ACTIONS(2723),
    [anon_sym_alignas] = ACTIONS(2723),
    [anon_sym__Alignas] = ACTIONS(2723),
    [sym_primitive_type] = ACTIONS(2723),
    [anon_sym_enum] = ACTIONS(2723),
    [anon_sym_class] = ACTIONS(2723),
    [anon_sym_struct] = ACTIONS(2723),
    [anon_sym_union] = ACTIONS(2723),
    [anon_sym_if] = ACTIONS(2723),
    [anon_sym_else] = ACTIONS(2723),
    [anon_sym_switch] = ACTIONS(2723),
    [anon_sym_case] = ACTIONS(2723),
    [anon_sym_default] = ACTIONS(2723),
    [anon_sym_while] = ACTIONS(2723),
    [anon_sym_do] = ACTIONS(2723),
    [anon_sym_for] = ACTIONS(2723),
    [anon_sym_return] = ACTIONS(2723),
    [anon_sym_break] = ACTIONS(2723),
    [anon_sym_continue] = ACTIONS(2723),
    [anon_sym_goto] = ACTIONS(2723),
    [anon_sym___try] = ACTIONS(2723),
    [anon_sym___leave] = ACTIONS(2723),
    [anon_sym_not] = ACTIONS(2723),
    [anon_sym_compl] = ACTIONS(2723),
    [anon_sym_DASH_DASH] = ACTIONS(2725),
    [anon_sym_PLUS_PLUS] = ACTIONS(2725),
    [anon_sym_sizeof] = ACTIONS(2723),
    [anon_sym___alignof__] = ACTIONS(2723),
    [anon_sym___alignof] = ACTIONS(2723),
    [anon_sym__alignof] = ACTIONS(2723),
    [anon_sym_alignof] = ACTIONS(2723),
    [anon_sym__Alignof] = ACTIONS(2723),
    [anon_sym_offsetof] = ACTIONS(2723),
    [anon_sym__Generic] = ACTIONS(2723),
    [anon_sym_asm] = ACTIONS(2723),
    [anon_sym___asm__] = ACTIONS(2723),
    [anon_sym___asm] = ACTIONS(2723),
    [sym_number_literal] = ACTIONS(2725),
    [anon_sym_L_SQUOTE] = ACTIONS(2725),
    [anon_sym_u_SQUOTE] = ACTIONS(2725),
    [anon_sym_U_SQUOTE] = ACTIONS(2725),
    [anon_sym_u8_SQUOTE] = ACTIONS(2725),
    [anon_sym_SQUOTE] = ACTIONS(2725),
    [anon_sym_L_DQUOTE] = ACTIONS(2725),
    [anon_sym_u_DQUOTE] = ACTIONS(2725),
    [anon_sym_U_DQUOTE] = ACTIONS(2725),
    [anon_sym_u8_DQUOTE] = ACTIONS(2725),
    [anon_sym_DQUOTE] = ACTIONS(2725),
    [sym_true] = ACTIONS(2723),
    [sym_false] = ACTIONS(2723),
    [anon_sym_NULL] = ACTIONS(2723),
    [anon_sym_nullptr] = ACTIONS(2723),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2723),
    [anon_sym_decltype] = ACTIONS(2723),
    [anon_sym_explicit] = ACTIONS(2723),
    [anon_sym_typename] = ACTIONS(2723),
    [anon_sym_template] = ACTIONS(2723),
    [anon_sym_operator] = ACTIONS(2723),
    [anon_sym_try] = ACTIONS(2723),
    [anon_sym_delete] = ACTIONS(2723),
    [anon_sym_throw] = ACTIONS(2723),
    [anon_sym_namespace] = ACTIONS(2723),
    [anon_sym_using] = ACTIONS(2723),
    [anon_sym_static_assert] = ACTIONS(2723),
    [anon_sym_concept] = ACTIONS(2723),
    [anon_sym_co_return] = ACTIONS(2723),
    [anon_sym_co_yield] = ACTIONS(2723),
    [anon_sym_R_DQUOTE] = ACTIONS(2725),
    [anon_sym_LR_DQUOTE] = ACTIONS(2725),
    [anon_sym_uR_DQUOTE] = ACTIONS(2725),
    [anon_sym_UR_DQUOTE] = ACTIONS(2725),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2725),
    [anon_sym_co_await] = ACTIONS(2723),
    [anon_sym_new] = ACTIONS(2723),
    [anon_sym_requires] = ACTIONS(2723),
    [sym_this] = ACTIONS(2723),
  },
  [506] = {
    [sym_identifier] = ACTIONS(2677),
    [aux_sym_preproc_include_token1] = ACTIONS(2677),
    [aux_sym_preproc_def_token1] = ACTIONS(2677),
    [aux_sym_preproc_if_token1] = ACTIONS(2677),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2677),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2677),
    [sym_preproc_directive] = ACTIONS(2677),
    [anon_sym_LPAREN2] = ACTIONS(2679),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_TILDE] = ACTIONS(2679),
    [anon_sym_DASH] = ACTIONS(2677),
    [anon_sym_PLUS] = ACTIONS(2677),
    [anon_sym_STAR] = ACTIONS(2679),
    [anon_sym_AMP_AMP] = ACTIONS(2679),
    [anon_sym_AMP] = ACTIONS(2677),
    [anon_sym_SEMI] = ACTIONS(2679),
    [anon_sym___extension__] = ACTIONS(2677),
    [anon_sym_typedef] = ACTIONS(2677),
    [anon_sym_virtual] = ACTIONS(2677),
    [anon_sym_extern] = ACTIONS(2677),
    [anon_sym___attribute__] = ACTIONS(2677),
    [anon_sym___attribute] = ACTIONS(2677),
    [anon_sym_COLON_COLON] = ACTIONS(2679),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2679),
    [anon_sym___declspec] = ACTIONS(2677),
    [anon_sym___based] = ACTIONS(2677),
    [anon_sym___cdecl] = ACTIONS(2677),
    [anon_sym___clrcall] = ACTIONS(2677),
    [anon_sym___stdcall] = ACTIONS(2677),
    [anon_sym___fastcall] = ACTIONS(2677),
    [anon_sym___thiscall] = ACTIONS(2677),
    [anon_sym___vectorcall] = ACTIONS(2677),
    [anon_sym_LBRACE] = ACTIONS(2679),
    [anon_sym_RBRACE] = ACTIONS(2679),
    [anon_sym_signed] = ACTIONS(2677),
    [anon_sym_unsigned] = ACTIONS(2677),
    [anon_sym_long] = ACTIONS(2677),
    [anon_sym_short] = ACTIONS(2677),
    [anon_sym_LBRACK] = ACTIONS(2677),
    [anon_sym_static] = ACTIONS(2677),
    [anon_sym_register] = ACTIONS(2677),
    [anon_sym_inline] = ACTIONS(2677),
    [anon_sym___inline] = ACTIONS(2677),
    [anon_sym___inline__] = ACTIONS(2677),
    [anon_sym___forceinline] = ACTIONS(2677),
    [anon_sym_thread_local] = ACTIONS(2677),
    [anon_sym___thread] = ACTIONS(2677),
    [anon_sym_const] = ACTIONS(2677),
    [anon_sym_constexpr] = ACTIONS(2677),
    [anon_sym_volatile] = ACTIONS(2677),
    [anon_sym_restrict] = ACTIONS(2677),
    [anon_sym___restrict__] = ACTIONS(2677),
    [anon_sym__Atomic] = ACTIONS(2677),
    [anon_sym__Noreturn] = ACTIONS(2677),
    [anon_sym_noreturn] = ACTIONS(2677),
    [anon_sym__Nonnull] = ACTIONS(2677),
    [anon_sym_mutable] = ACTIONS(2677),
    [anon_sym_constinit] = ACTIONS(2677),
    [anon_sym_consteval] = ACTIONS(2677),
    [anon_sym_alignas] = ACTIONS(2677),
    [anon_sym__Alignas] = ACTIONS(2677),
    [sym_primitive_type] = ACTIONS(2677),
    [anon_sym_enum] = ACTIONS(2677),
    [anon_sym_class] = ACTIONS(2677),
    [anon_sym_struct] = ACTIONS(2677),
    [anon_sym_union] = ACTIONS(2677),
    [anon_sym_if] = ACTIONS(2677),
    [anon_sym_else] = ACTIONS(2677),
    [anon_sym_switch] = ACTIONS(2677),
    [anon_sym_case] = ACTIONS(2677),
    [anon_sym_default] = ACTIONS(2677),
    [anon_sym_while] = ACTIONS(2677),
    [anon_sym_do] = ACTIONS(2677),
    [anon_sym_for] = ACTIONS(2677),
    [anon_sym_return] = ACTIONS(2677),
    [anon_sym_break] = ACTIONS(2677),
    [anon_sym_continue] = ACTIONS(2677),
    [anon_sym_goto] = ACTIONS(2677),
    [anon_sym___try] = ACTIONS(2677),
    [anon_sym___leave] = ACTIONS(2677),
    [anon_sym_not] = ACTIONS(2677),
    [anon_sym_compl] = ACTIONS(2677),
    [anon_sym_DASH_DASH] = ACTIONS(2679),
    [anon_sym_PLUS_PLUS] = ACTIONS(2679),
    [anon_sym_sizeof] = ACTIONS(2677),
    [anon_sym___alignof__] = ACTIONS(2677),
    [anon_sym___alignof] = ACTIONS(2677),
    [anon_sym__alignof] = ACTIONS(2677),
    [anon_sym_alignof] = ACTIONS(2677),
    [anon_sym__Alignof] = ACTIONS(2677),
    [anon_sym_offsetof] = ACTIONS(2677),
    [anon_sym__Generic] = ACTIONS(2677),
    [anon_sym_asm] = ACTIONS(2677),
    [anon_sym___asm__] = ACTIONS(2677),
    [anon_sym___asm] = ACTIONS(2677),
    [sym_number_literal] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2679),
    [anon_sym_u_SQUOTE] = ACTIONS(2679),
    [anon_sym_U_SQUOTE] = ACTIONS(2679),
    [anon_sym_u8_SQUOTE] = ACTIONS(2679),
    [anon_sym_SQUOTE] = ACTIONS(2679),
    [anon_sym_L_DQUOTE] = ACTIONS(2679),
    [anon_sym_u_DQUOTE] = ACTIONS(2679),
    [anon_sym_U_DQUOTE] = ACTIONS(2679),
    [anon_sym_u8_DQUOTE] = ACTIONS(2679),
    [anon_sym_DQUOTE] = ACTIONS(2679),
    [sym_true] = ACTIONS(2677),
    [sym_false] = ACTIONS(2677),
    [anon_sym_NULL] = ACTIONS(2677),
    [anon_sym_nullptr] = ACTIONS(2677),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2677),
    [anon_sym_decltype] = ACTIONS(2677),
    [anon_sym_explicit] = ACTIONS(2677),
    [anon_sym_typename] = ACTIONS(2677),
    [anon_sym_template] = ACTIONS(2677),
    [anon_sym_operator] = ACTIONS(2677),
    [anon_sym_try] = ACTIONS(2677),
    [anon_sym_delete] = ACTIONS(2677),
    [anon_sym_throw] = ACTIONS(2677),
    [anon_sym_namespace] = ACTIONS(2677),
    [anon_sym_using] = ACTIONS(2677),
    [anon_sym_static_assert] = ACTIONS(2677),
    [anon_sym_concept] = ACTIONS(2677),
    [anon_sym_co_return] = ACTIONS(2677),
    [anon_sym_co_yield] = ACTIONS(2677),
    [anon_sym_R_DQUOTE] = ACTIONS(2679),
    [anon_sym_LR_DQUOTE] = ACTIONS(2679),
    [anon_sym_uR_DQUOTE] = ACTIONS(2679),
    [anon_sym_UR_DQUOTE] = ACTIONS(2679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2679),
    [anon_sym_co_await] = ACTIONS(2677),
    [anon_sym_new] = ACTIONS(2677),
    [anon_sym_requires] = ACTIONS(2677),
    [sym_this] = ACTIONS(2677),
  },
  [507] = {
    [sym_identifier] = ACTIONS(2685),
    [aux_sym_preproc_include_token1] = ACTIONS(2685),
    [aux_sym_preproc_def_token1] = ACTIONS(2685),
    [aux_sym_preproc_if_token1] = ACTIONS(2685),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2685),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2685),
    [sym_preproc_directive] = ACTIONS(2685),
    [anon_sym_LPAREN2] = ACTIONS(2687),
    [anon_sym_BANG] = ACTIONS(2687),
    [anon_sym_TILDE] = ACTIONS(2687),
    [anon_sym_DASH] = ACTIONS(2685),
    [anon_sym_PLUS] = ACTIONS(2685),
    [anon_sym_STAR] = ACTIONS(2687),
    [anon_sym_AMP_AMP] = ACTIONS(2687),
    [anon_sym_AMP] = ACTIONS(2685),
    [anon_sym_SEMI] = ACTIONS(2687),
    [anon_sym___extension__] = ACTIONS(2685),
    [anon_sym_typedef] = ACTIONS(2685),
    [anon_sym_virtual] = ACTIONS(2685),
    [anon_sym_extern] = ACTIONS(2685),
    [anon_sym___attribute__] = ACTIONS(2685),
    [anon_sym___attribute] = ACTIONS(2685),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2687),
    [anon_sym___declspec] = ACTIONS(2685),
    [anon_sym___based] = ACTIONS(2685),
    [anon_sym___cdecl] = ACTIONS(2685),
    [anon_sym___clrcall] = ACTIONS(2685),
    [anon_sym___stdcall] = ACTIONS(2685),
    [anon_sym___fastcall] = ACTIONS(2685),
    [anon_sym___thiscall] = ACTIONS(2685),
    [anon_sym___vectorcall] = ACTIONS(2685),
    [anon_sym_LBRACE] = ACTIONS(2687),
    [anon_sym_RBRACE] = ACTIONS(2687),
    [anon_sym_signed] = ACTIONS(2685),
    [anon_sym_unsigned] = ACTIONS(2685),
    [anon_sym_long] = ACTIONS(2685),
    [anon_sym_short] = ACTIONS(2685),
    [anon_sym_LBRACK] = ACTIONS(2685),
    [anon_sym_static] = ACTIONS(2685),
    [anon_sym_register] = ACTIONS(2685),
    [anon_sym_inline] = ACTIONS(2685),
    [anon_sym___inline] = ACTIONS(2685),
    [anon_sym___inline__] = ACTIONS(2685),
    [anon_sym___forceinline] = ACTIONS(2685),
    [anon_sym_thread_local] = ACTIONS(2685),
    [anon_sym___thread] = ACTIONS(2685),
    [anon_sym_const] = ACTIONS(2685),
    [anon_sym_constexpr] = ACTIONS(2685),
    [anon_sym_volatile] = ACTIONS(2685),
    [anon_sym_restrict] = ACTIONS(2685),
    [anon_sym___restrict__] = ACTIONS(2685),
    [anon_sym__Atomic] = ACTIONS(2685),
    [anon_sym__Noreturn] = ACTIONS(2685),
    [anon_sym_noreturn] = ACTIONS(2685),
    [anon_sym__Nonnull] = ACTIONS(2685),
    [anon_sym_mutable] = ACTIONS(2685),
    [anon_sym_constinit] = ACTIONS(2685),
    [anon_sym_consteval] = ACTIONS(2685),
    [anon_sym_alignas] = ACTIONS(2685),
    [anon_sym__Alignas] = ACTIONS(2685),
    [sym_primitive_type] = ACTIONS(2685),
    [anon_sym_enum] = ACTIONS(2685),
    [anon_sym_class] = ACTIONS(2685),
    [anon_sym_struct] = ACTIONS(2685),
    [anon_sym_union] = ACTIONS(2685),
    [anon_sym_if] = ACTIONS(2685),
    [anon_sym_else] = ACTIONS(2685),
    [anon_sym_switch] = ACTIONS(2685),
    [anon_sym_case] = ACTIONS(2685),
    [anon_sym_default] = ACTIONS(2685),
    [anon_sym_while] = ACTIONS(2685),
    [anon_sym_do] = ACTIONS(2685),
    [anon_sym_for] = ACTIONS(2685),
    [anon_sym_return] = ACTIONS(2685),
    [anon_sym_break] = ACTIONS(2685),
    [anon_sym_continue] = ACTIONS(2685),
    [anon_sym_goto] = ACTIONS(2685),
    [anon_sym___try] = ACTIONS(2685),
    [anon_sym___leave] = ACTIONS(2685),
    [anon_sym_not] = ACTIONS(2685),
    [anon_sym_compl] = ACTIONS(2685),
    [anon_sym_DASH_DASH] = ACTIONS(2687),
    [anon_sym_PLUS_PLUS] = ACTIONS(2687),
    [anon_sym_sizeof] = ACTIONS(2685),
    [anon_sym___alignof__] = ACTIONS(2685),
    [anon_sym___alignof] = ACTIONS(2685),
    [anon_sym__alignof] = ACTIONS(2685),
    [anon_sym_alignof] = ACTIONS(2685),
    [anon_sym__Alignof] = ACTIONS(2685),
    [anon_sym_offsetof] = ACTIONS(2685),
    [anon_sym__Generic] = ACTIONS(2685),
    [anon_sym_asm] = ACTIONS(2685),
    [anon_sym___asm__] = ACTIONS(2685),
    [anon_sym___asm] = ACTIONS(2685),
    [sym_number_literal] = ACTIONS(2687),
    [anon_sym_L_SQUOTE] = ACTIONS(2687),
    [anon_sym_u_SQUOTE] = ACTIONS(2687),
    [anon_sym_U_SQUOTE] = ACTIONS(2687),
    [anon_sym_u8_SQUOTE] = ACTIONS(2687),
    [anon_sym_SQUOTE] = ACTIONS(2687),
    [anon_sym_L_DQUOTE] = ACTIONS(2687),
    [anon_sym_u_DQUOTE] = ACTIONS(2687),
    [anon_sym_U_DQUOTE] = ACTIONS(2687),
    [anon_sym_u8_DQUOTE] = ACTIONS(2687),
    [anon_sym_DQUOTE] = ACTIONS(2687),
    [sym_true] = ACTIONS(2685),
    [sym_false] = ACTIONS(2685),
    [anon_sym_NULL] = ACTIONS(2685),
    [anon_sym_nullptr] = ACTIONS(2685),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2685),
    [anon_sym_decltype] = ACTIONS(2685),
    [anon_sym_explicit] = ACTIONS(2685),
    [anon_sym_typename] = ACTIONS(2685),
    [anon_sym_template] = ACTIONS(2685),
    [anon_sym_operator] = ACTIONS(2685),
    [anon_sym_try] = ACTIONS(2685),
    [anon_sym_delete] = ACTIONS(2685),
    [anon_sym_throw] = ACTIONS(2685),
    [anon_sym_namespace] = ACTIONS(2685),
    [anon_sym_using] = ACTIONS(2685),
    [anon_sym_static_assert] = ACTIONS(2685),
    [anon_sym_concept] = ACTIONS(2685),
    [anon_sym_co_return] = ACTIONS(2685),
    [anon_sym_co_yield] = ACTIONS(2685),
    [anon_sym_R_DQUOTE] = ACTIONS(2687),
    [anon_sym_LR_DQUOTE] = ACTIONS(2687),
    [anon_sym_uR_DQUOTE] = ACTIONS(2687),
    [anon_sym_UR_DQUOTE] = ACTIONS(2687),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2687),
    [anon_sym_co_await] = ACTIONS(2685),
    [anon_sym_new] = ACTIONS(2685),
    [anon_sym_requires] = ACTIONS(2685),
    [sym_this] = ACTIONS(2685),
  },
  [508] = {
    [sym_identifier] = ACTIONS(2697),
    [aux_sym_preproc_include_token1] = ACTIONS(2697),
    [aux_sym_preproc_def_token1] = ACTIONS(2697),
    [aux_sym_preproc_if_token1] = ACTIONS(2697),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2697),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2697),
    [sym_preproc_directive] = ACTIONS(2697),
    [anon_sym_LPAREN2] = ACTIONS(2699),
    [anon_sym_BANG] = ACTIONS(2699),
    [anon_sym_TILDE] = ACTIONS(2699),
    [anon_sym_DASH] = ACTIONS(2697),
    [anon_sym_PLUS] = ACTIONS(2697),
    [anon_sym_STAR] = ACTIONS(2699),
    [anon_sym_AMP_AMP] = ACTIONS(2699),
    [anon_sym_AMP] = ACTIONS(2697),
    [anon_sym_SEMI] = ACTIONS(2699),
    [anon_sym___extension__] = ACTIONS(2697),
    [anon_sym_typedef] = ACTIONS(2697),
    [anon_sym_virtual] = ACTIONS(2697),
    [anon_sym_extern] = ACTIONS(2697),
    [anon_sym___attribute__] = ACTIONS(2697),
    [anon_sym___attribute] = ACTIONS(2697),
    [anon_sym_COLON_COLON] = ACTIONS(2699),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2699),
    [anon_sym___declspec] = ACTIONS(2697),
    [anon_sym___based] = ACTIONS(2697),
    [anon_sym___cdecl] = ACTIONS(2697),
    [anon_sym___clrcall] = ACTIONS(2697),
    [anon_sym___stdcall] = ACTIONS(2697),
    [anon_sym___fastcall] = ACTIONS(2697),
    [anon_sym___thiscall] = ACTIONS(2697),
    [anon_sym___vectorcall] = ACTIONS(2697),
    [anon_sym_LBRACE] = ACTIONS(2699),
    [anon_sym_RBRACE] = ACTIONS(2699),
    [anon_sym_signed] = ACTIONS(2697),
    [anon_sym_unsigned] = ACTIONS(2697),
    [anon_sym_long] = ACTIONS(2697),
    [anon_sym_short] = ACTIONS(2697),
    [anon_sym_LBRACK] = ACTIONS(2697),
    [anon_sym_static] = ACTIONS(2697),
    [anon_sym_register] = ACTIONS(2697),
    [anon_sym_inline] = ACTIONS(2697),
    [anon_sym___inline] = ACTIONS(2697),
    [anon_sym___inline__] = ACTIONS(2697),
    [anon_sym___forceinline] = ACTIONS(2697),
    [anon_sym_thread_local] = ACTIONS(2697),
    [anon_sym___thread] = ACTIONS(2697),
    [anon_sym_const] = ACTIONS(2697),
    [anon_sym_constexpr] = ACTIONS(2697),
    [anon_sym_volatile] = ACTIONS(2697),
    [anon_sym_restrict] = ACTIONS(2697),
    [anon_sym___restrict__] = ACTIONS(2697),
    [anon_sym__Atomic] = ACTIONS(2697),
    [anon_sym__Noreturn] = ACTIONS(2697),
    [anon_sym_noreturn] = ACTIONS(2697),
    [anon_sym__Nonnull] = ACTIONS(2697),
    [anon_sym_mutable] = ACTIONS(2697),
    [anon_sym_constinit] = ACTIONS(2697),
    [anon_sym_consteval] = ACTIONS(2697),
    [anon_sym_alignas] = ACTIONS(2697),
    [anon_sym__Alignas] = ACTIONS(2697),
    [sym_primitive_type] = ACTIONS(2697),
    [anon_sym_enum] = ACTIONS(2697),
    [anon_sym_class] = ACTIONS(2697),
    [anon_sym_struct] = ACTIONS(2697),
    [anon_sym_union] = ACTIONS(2697),
    [anon_sym_if] = ACTIONS(2697),
    [anon_sym_else] = ACTIONS(2697),
    [anon_sym_switch] = ACTIONS(2697),
    [anon_sym_case] = ACTIONS(2697),
    [anon_sym_default] = ACTIONS(2697),
    [anon_sym_while] = ACTIONS(2697),
    [anon_sym_do] = ACTIONS(2697),
    [anon_sym_for] = ACTIONS(2697),
    [anon_sym_return] = ACTIONS(2697),
    [anon_sym_break] = ACTIONS(2697),
    [anon_sym_continue] = ACTIONS(2697),
    [anon_sym_goto] = ACTIONS(2697),
    [anon_sym___try] = ACTIONS(2697),
    [anon_sym___leave] = ACTIONS(2697),
    [anon_sym_not] = ACTIONS(2697),
    [anon_sym_compl] = ACTIONS(2697),
    [anon_sym_DASH_DASH] = ACTIONS(2699),
    [anon_sym_PLUS_PLUS] = ACTIONS(2699),
    [anon_sym_sizeof] = ACTIONS(2697),
    [anon_sym___alignof__] = ACTIONS(2697),
    [anon_sym___alignof] = ACTIONS(2697),
    [anon_sym__alignof] = ACTIONS(2697),
    [anon_sym_alignof] = ACTIONS(2697),
    [anon_sym__Alignof] = ACTIONS(2697),
    [anon_sym_offsetof] = ACTIONS(2697),
    [anon_sym__Generic] = ACTIONS(2697),
    [anon_sym_asm] = ACTIONS(2697),
    [anon_sym___asm__] = ACTIONS(2697),
    [anon_sym___asm] = ACTIONS(2697),
    [sym_number_literal] = ACTIONS(2699),
    [anon_sym_L_SQUOTE] = ACTIONS(2699),
    [anon_sym_u_SQUOTE] = ACTIONS(2699),
    [anon_sym_U_SQUOTE] = ACTIONS(2699),
    [anon_sym_u8_SQUOTE] = ACTIONS(2699),
    [anon_sym_SQUOTE] = ACTIONS(2699),
    [anon_sym_L_DQUOTE] = ACTIONS(2699),
    [anon_sym_u_DQUOTE] = ACTIONS(2699),
    [anon_sym_U_DQUOTE] = ACTIONS(2699),
    [anon_sym_u8_DQUOTE] = ACTIONS(2699),
    [anon_sym_DQUOTE] = ACTIONS(2699),
    [sym_true] = ACTIONS(2697),
    [sym_false] = ACTIONS(2697),
    [anon_sym_NULL] = ACTIONS(2697),
    [anon_sym_nullptr] = ACTIONS(2697),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2697),
    [anon_sym_decltype] = ACTIONS(2697),
    [anon_sym_explicit] = ACTIONS(2697),
    [anon_sym_typename] = ACTIONS(2697),
    [anon_sym_template] = ACTIONS(2697),
    [anon_sym_operator] = ACTIONS(2697),
    [anon_sym_try] = ACTIONS(2697),
    [anon_sym_delete] = ACTIONS(2697),
    [anon_sym_throw] = ACTIONS(2697),
    [anon_sym_namespace] = ACTIONS(2697),
    [anon_sym_using] = ACTIONS(2697),
    [anon_sym_static_assert] = ACTIONS(2697),
    [anon_sym_concept] = ACTIONS(2697),
    [anon_sym_co_return] = ACTIONS(2697),
    [anon_sym_co_yield] = ACTIONS(2697),
    [anon_sym_R_DQUOTE] = ACTIONS(2699),
    [anon_sym_LR_DQUOTE] = ACTIONS(2699),
    [anon_sym_uR_DQUOTE] = ACTIONS(2699),
    [anon_sym_UR_DQUOTE] = ACTIONS(2699),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2699),
    [anon_sym_co_await] = ACTIONS(2697),
    [anon_sym_new] = ACTIONS(2697),
    [anon_sym_requires] = ACTIONS(2697),
    [sym_this] = ACTIONS(2697),
  },
  [509] = {
    [sym_identifier] = ACTIONS(2597),
    [aux_sym_preproc_include_token1] = ACTIONS(2597),
    [aux_sym_preproc_def_token1] = ACTIONS(2597),
    [aux_sym_preproc_if_token1] = ACTIONS(2597),
    [aux_sym_preproc_if_token2] = ACTIONS(2597),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2597),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2597),
    [sym_preproc_directive] = ACTIONS(2597),
    [anon_sym_LPAREN2] = ACTIONS(2599),
    [anon_sym_BANG] = ACTIONS(2599),
    [anon_sym_TILDE] = ACTIONS(2599),
    [anon_sym_DASH] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(2597),
    [anon_sym_STAR] = ACTIONS(2599),
    [anon_sym_AMP_AMP] = ACTIONS(2599),
    [anon_sym_AMP] = ACTIONS(2597),
    [anon_sym_SEMI] = ACTIONS(2599),
    [anon_sym___extension__] = ACTIONS(2597),
    [anon_sym_typedef] = ACTIONS(2597),
    [anon_sym_virtual] = ACTIONS(2597),
    [anon_sym_extern] = ACTIONS(2597),
    [anon_sym___attribute__] = ACTIONS(2597),
    [anon_sym___attribute] = ACTIONS(2597),
    [anon_sym_COLON_COLON] = ACTIONS(2599),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2599),
    [anon_sym___declspec] = ACTIONS(2597),
    [anon_sym___based] = ACTIONS(2597),
    [anon_sym___cdecl] = ACTIONS(2597),
    [anon_sym___clrcall] = ACTIONS(2597),
    [anon_sym___stdcall] = ACTIONS(2597),
    [anon_sym___fastcall] = ACTIONS(2597),
    [anon_sym___thiscall] = ACTIONS(2597),
    [anon_sym___vectorcall] = ACTIONS(2597),
    [anon_sym_LBRACE] = ACTIONS(2599),
    [anon_sym_signed] = ACTIONS(2597),
    [anon_sym_unsigned] = ACTIONS(2597),
    [anon_sym_long] = ACTIONS(2597),
    [anon_sym_short] = ACTIONS(2597),
    [anon_sym_LBRACK] = ACTIONS(2597),
    [anon_sym_static] = ACTIONS(2597),
    [anon_sym_register] = ACTIONS(2597),
    [anon_sym_inline] = ACTIONS(2597),
    [anon_sym___inline] = ACTIONS(2597),
    [anon_sym___inline__] = ACTIONS(2597),
    [anon_sym___forceinline] = ACTIONS(2597),
    [anon_sym_thread_local] = ACTIONS(2597),
    [anon_sym___thread] = ACTIONS(2597),
    [anon_sym_const] = ACTIONS(2597),
    [anon_sym_constexpr] = ACTIONS(2597),
    [anon_sym_volatile] = ACTIONS(2597),
    [anon_sym_restrict] = ACTIONS(2597),
    [anon_sym___restrict__] = ACTIONS(2597),
    [anon_sym__Atomic] = ACTIONS(2597),
    [anon_sym__Noreturn] = ACTIONS(2597),
    [anon_sym_noreturn] = ACTIONS(2597),
    [anon_sym__Nonnull] = ACTIONS(2597),
    [anon_sym_mutable] = ACTIONS(2597),
    [anon_sym_constinit] = ACTIONS(2597),
    [anon_sym_consteval] = ACTIONS(2597),
    [anon_sym_alignas] = ACTIONS(2597),
    [anon_sym__Alignas] = ACTIONS(2597),
    [sym_primitive_type] = ACTIONS(2597),
    [anon_sym_enum] = ACTIONS(2597),
    [anon_sym_class] = ACTIONS(2597),
    [anon_sym_struct] = ACTIONS(2597),
    [anon_sym_union] = ACTIONS(2597),
    [anon_sym_if] = ACTIONS(2597),
    [anon_sym_else] = ACTIONS(2597),
    [anon_sym_switch] = ACTIONS(2597),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_default] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2597),
    [anon_sym_do] = ACTIONS(2597),
    [anon_sym_for] = ACTIONS(2597),
    [anon_sym_return] = ACTIONS(2597),
    [anon_sym_break] = ACTIONS(2597),
    [anon_sym_continue] = ACTIONS(2597),
    [anon_sym_goto] = ACTIONS(2597),
    [anon_sym___try] = ACTIONS(2597),
    [anon_sym___leave] = ACTIONS(2597),
    [anon_sym_not] = ACTIONS(2597),
    [anon_sym_compl] = ACTIONS(2597),
    [anon_sym_DASH_DASH] = ACTIONS(2599),
    [anon_sym_PLUS_PLUS] = ACTIONS(2599),
    [anon_sym_sizeof] = ACTIONS(2597),
    [anon_sym___alignof__] = ACTIONS(2597),
    [anon_sym___alignof] = ACTIONS(2597),
    [anon_sym__alignof] = ACTIONS(2597),
    [anon_sym_alignof] = ACTIONS(2597),
    [anon_sym__Alignof] = ACTIONS(2597),
    [anon_sym_offsetof] = ACTIONS(2597),
    [anon_sym__Generic] = ACTIONS(2597),
    [anon_sym_asm] = ACTIONS(2597),
    [anon_sym___asm__] = ACTIONS(2597),
    [anon_sym___asm] = ACTIONS(2597),
    [sym_number_literal] = ACTIONS(2599),
    [anon_sym_L_SQUOTE] = ACTIONS(2599),
    [anon_sym_u_SQUOTE] = ACTIONS(2599),
    [anon_sym_U_SQUOTE] = ACTIONS(2599),
    [anon_sym_u8_SQUOTE] = ACTIONS(2599),
    [anon_sym_SQUOTE] = ACTIONS(2599),
    [anon_sym_L_DQUOTE] = ACTIONS(2599),
    [anon_sym_u_DQUOTE] = ACTIONS(2599),
    [anon_sym_U_DQUOTE] = ACTIONS(2599),
    [anon_sym_u8_DQUOTE] = ACTIONS(2599),
    [anon_sym_DQUOTE] = ACTIONS(2599),
    [sym_true] = ACTIONS(2597),
    [sym_false] = ACTIONS(2597),
    [anon_sym_NULL] = ACTIONS(2597),
    [anon_sym_nullptr] = ACTIONS(2597),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2597),
    [anon_sym_decltype] = ACTIONS(2597),
    [anon_sym_explicit] = ACTIONS(2597),
    [anon_sym_typename] = ACTIONS(2597),
    [anon_sym_template] = ACTIONS(2597),
    [anon_sym_operator] = ACTIONS(2597),
    [anon_sym_try] = ACTIONS(2597),
    [anon_sym_delete] = ACTIONS(2597),
    [anon_sym_throw] = ACTIONS(2597),
    [anon_sym_namespace] = ACTIONS(2597),
    [anon_sym_using] = ACTIONS(2597),
    [anon_sym_static_assert] = ACTIONS(2597),
    [anon_sym_concept] = ACTIONS(2597),
    [anon_sym_co_return] = ACTIONS(2597),
    [anon_sym_co_yield] = ACTIONS(2597),
    [anon_sym_R_DQUOTE] = ACTIONS(2599),
    [anon_sym_LR_DQUOTE] = ACTIONS(2599),
    [anon_sym_uR_DQUOTE] = ACTIONS(2599),
    [anon_sym_UR_DQUOTE] = ACTIONS(2599),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2599),
    [anon_sym_co_await] = ACTIONS(2597),
    [anon_sym_new] = ACTIONS(2597),
    [anon_sym_requires] = ACTIONS(2597),
    [sym_this] = ACTIONS(2597),
  },
  [510] = {
    [sym_identifier] = ACTIONS(2701),
    [aux_sym_preproc_include_token1] = ACTIONS(2701),
    [aux_sym_preproc_def_token1] = ACTIONS(2701),
    [aux_sym_preproc_if_token1] = ACTIONS(2701),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2701),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2701),
    [sym_preproc_directive] = ACTIONS(2701),
    [anon_sym_LPAREN2] = ACTIONS(2703),
    [anon_sym_BANG] = ACTIONS(2703),
    [anon_sym_TILDE] = ACTIONS(2703),
    [anon_sym_DASH] = ACTIONS(2701),
    [anon_sym_PLUS] = ACTIONS(2701),
    [anon_sym_STAR] = ACTIONS(2703),
    [anon_sym_AMP_AMP] = ACTIONS(2703),
    [anon_sym_AMP] = ACTIONS(2701),
    [anon_sym_SEMI] = ACTIONS(2703),
    [anon_sym___extension__] = ACTIONS(2701),
    [anon_sym_typedef] = ACTIONS(2701),
    [anon_sym_virtual] = ACTIONS(2701),
    [anon_sym_extern] = ACTIONS(2701),
    [anon_sym___attribute__] = ACTIONS(2701),
    [anon_sym___attribute] = ACTIONS(2701),
    [anon_sym_COLON_COLON] = ACTIONS(2703),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2703),
    [anon_sym___declspec] = ACTIONS(2701),
    [anon_sym___based] = ACTIONS(2701),
    [anon_sym___cdecl] = ACTIONS(2701),
    [anon_sym___clrcall] = ACTIONS(2701),
    [anon_sym___stdcall] = ACTIONS(2701),
    [anon_sym___fastcall] = ACTIONS(2701),
    [anon_sym___thiscall] = ACTIONS(2701),
    [anon_sym___vectorcall] = ACTIONS(2701),
    [anon_sym_LBRACE] = ACTIONS(2703),
    [anon_sym_RBRACE] = ACTIONS(2703),
    [anon_sym_signed] = ACTIONS(2701),
    [anon_sym_unsigned] = ACTIONS(2701),
    [anon_sym_long] = ACTIONS(2701),
    [anon_sym_short] = ACTIONS(2701),
    [anon_sym_LBRACK] = ACTIONS(2701),
    [anon_sym_static] = ACTIONS(2701),
    [anon_sym_register] = ACTIONS(2701),
    [anon_sym_inline] = ACTIONS(2701),
    [anon_sym___inline] = ACTIONS(2701),
    [anon_sym___inline__] = ACTIONS(2701),
    [anon_sym___forceinline] = ACTIONS(2701),
    [anon_sym_thread_local] = ACTIONS(2701),
    [anon_sym___thread] = ACTIONS(2701),
    [anon_sym_const] = ACTIONS(2701),
    [anon_sym_constexpr] = ACTIONS(2701),
    [anon_sym_volatile] = ACTIONS(2701),
    [anon_sym_restrict] = ACTIONS(2701),
    [anon_sym___restrict__] = ACTIONS(2701),
    [anon_sym__Atomic] = ACTIONS(2701),
    [anon_sym__Noreturn] = ACTIONS(2701),
    [anon_sym_noreturn] = ACTIONS(2701),
    [anon_sym__Nonnull] = ACTIONS(2701),
    [anon_sym_mutable] = ACTIONS(2701),
    [anon_sym_constinit] = ACTIONS(2701),
    [anon_sym_consteval] = ACTIONS(2701),
    [anon_sym_alignas] = ACTIONS(2701),
    [anon_sym__Alignas] = ACTIONS(2701),
    [sym_primitive_type] = ACTIONS(2701),
    [anon_sym_enum] = ACTIONS(2701),
    [anon_sym_class] = ACTIONS(2701),
    [anon_sym_struct] = ACTIONS(2701),
    [anon_sym_union] = ACTIONS(2701),
    [anon_sym_if] = ACTIONS(2701),
    [anon_sym_else] = ACTIONS(2701),
    [anon_sym_switch] = ACTIONS(2701),
    [anon_sym_case] = ACTIONS(2701),
    [anon_sym_default] = ACTIONS(2701),
    [anon_sym_while] = ACTIONS(2701),
    [anon_sym_do] = ACTIONS(2701),
    [anon_sym_for] = ACTIONS(2701),
    [anon_sym_return] = ACTIONS(2701),
    [anon_sym_break] = ACTIONS(2701),
    [anon_sym_continue] = ACTIONS(2701),
    [anon_sym_goto] = ACTIONS(2701),
    [anon_sym___try] = ACTIONS(2701),
    [anon_sym___leave] = ACTIONS(2701),
    [anon_sym_not] = ACTIONS(2701),
    [anon_sym_compl] = ACTIONS(2701),
    [anon_sym_DASH_DASH] = ACTIONS(2703),
    [anon_sym_PLUS_PLUS] = ACTIONS(2703),
    [anon_sym_sizeof] = ACTIONS(2701),
    [anon_sym___alignof__] = ACTIONS(2701),
    [anon_sym___alignof] = ACTIONS(2701),
    [anon_sym__alignof] = ACTIONS(2701),
    [anon_sym_alignof] = ACTIONS(2701),
    [anon_sym__Alignof] = ACTIONS(2701),
    [anon_sym_offsetof] = ACTIONS(2701),
    [anon_sym__Generic] = ACTIONS(2701),
    [anon_sym_asm] = ACTIONS(2701),
    [anon_sym___asm__] = ACTIONS(2701),
    [anon_sym___asm] = ACTIONS(2701),
    [sym_number_literal] = ACTIONS(2703),
    [anon_sym_L_SQUOTE] = ACTIONS(2703),
    [anon_sym_u_SQUOTE] = ACTIONS(2703),
    [anon_sym_U_SQUOTE] = ACTIONS(2703),
    [anon_sym_u8_SQUOTE] = ACTIONS(2703),
    [anon_sym_SQUOTE] = ACTIONS(2703),
    [anon_sym_L_DQUOTE] = ACTIONS(2703),
    [anon_sym_u_DQUOTE] = ACTIONS(2703),
    [anon_sym_U_DQUOTE] = ACTIONS(2703),
    [anon_sym_u8_DQUOTE] = ACTIONS(2703),
    [anon_sym_DQUOTE] = ACTIONS(2703),
    [sym_true] = ACTIONS(2701),
    [sym_false] = ACTIONS(2701),
    [anon_sym_NULL] = ACTIONS(2701),
    [anon_sym_nullptr] = ACTIONS(2701),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2701),
    [anon_sym_decltype] = ACTIONS(2701),
    [anon_sym_explicit] = ACTIONS(2701),
    [anon_sym_typename] = ACTIONS(2701),
    [anon_sym_template] = ACTIONS(2701),
    [anon_sym_operator] = ACTIONS(2701),
    [anon_sym_try] = ACTIONS(2701),
    [anon_sym_delete] = ACTIONS(2701),
    [anon_sym_throw] = ACTIONS(2701),
    [anon_sym_namespace] = ACTIONS(2701),
    [anon_sym_using] = ACTIONS(2701),
    [anon_sym_static_assert] = ACTIONS(2701),
    [anon_sym_concept] = ACTIONS(2701),
    [anon_sym_co_return] = ACTIONS(2701),
    [anon_sym_co_yield] = ACTIONS(2701),
    [anon_sym_R_DQUOTE] = ACTIONS(2703),
    [anon_sym_LR_DQUOTE] = ACTIONS(2703),
    [anon_sym_uR_DQUOTE] = ACTIONS(2703),
    [anon_sym_UR_DQUOTE] = ACTIONS(2703),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2703),
    [anon_sym_co_await] = ACTIONS(2701),
    [anon_sym_new] = ACTIONS(2701),
    [anon_sym_requires] = ACTIONS(2701),
    [sym_this] = ACTIONS(2701),
  },
  [511] = {
    [sym_identifier] = ACTIONS(2709),
    [aux_sym_preproc_include_token1] = ACTIONS(2709),
    [aux_sym_preproc_def_token1] = ACTIONS(2709),
    [aux_sym_preproc_if_token1] = ACTIONS(2709),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2709),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2709),
    [sym_preproc_directive] = ACTIONS(2709),
    [anon_sym_LPAREN2] = ACTIONS(2711),
    [anon_sym_BANG] = ACTIONS(2711),
    [anon_sym_TILDE] = ACTIONS(2711),
    [anon_sym_DASH] = ACTIONS(2709),
    [anon_sym_PLUS] = ACTIONS(2709),
    [anon_sym_STAR] = ACTIONS(2711),
    [anon_sym_AMP_AMP] = ACTIONS(2711),
    [anon_sym_AMP] = ACTIONS(2709),
    [anon_sym_SEMI] = ACTIONS(2711),
    [anon_sym___extension__] = ACTIONS(2709),
    [anon_sym_typedef] = ACTIONS(2709),
    [anon_sym_virtual] = ACTIONS(2709),
    [anon_sym_extern] = ACTIONS(2709),
    [anon_sym___attribute__] = ACTIONS(2709),
    [anon_sym___attribute] = ACTIONS(2709),
    [anon_sym_COLON_COLON] = ACTIONS(2711),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2711),
    [anon_sym___declspec] = ACTIONS(2709),
    [anon_sym___based] = ACTIONS(2709),
    [anon_sym___cdecl] = ACTIONS(2709),
    [anon_sym___clrcall] = ACTIONS(2709),
    [anon_sym___stdcall] = ACTIONS(2709),
    [anon_sym___fastcall] = ACTIONS(2709),
    [anon_sym___thiscall] = ACTIONS(2709),
    [anon_sym___vectorcall] = ACTIONS(2709),
    [anon_sym_LBRACE] = ACTIONS(2711),
    [anon_sym_RBRACE] = ACTIONS(2711),
    [anon_sym_signed] = ACTIONS(2709),
    [anon_sym_unsigned] = ACTIONS(2709),
    [anon_sym_long] = ACTIONS(2709),
    [anon_sym_short] = ACTIONS(2709),
    [anon_sym_LBRACK] = ACTIONS(2709),
    [anon_sym_static] = ACTIONS(2709),
    [anon_sym_register] = ACTIONS(2709),
    [anon_sym_inline] = ACTIONS(2709),
    [anon_sym___inline] = ACTIONS(2709),
    [anon_sym___inline__] = ACTIONS(2709),
    [anon_sym___forceinline] = ACTIONS(2709),
    [anon_sym_thread_local] = ACTIONS(2709),
    [anon_sym___thread] = ACTIONS(2709),
    [anon_sym_const] = ACTIONS(2709),
    [anon_sym_constexpr] = ACTIONS(2709),
    [anon_sym_volatile] = ACTIONS(2709),
    [anon_sym_restrict] = ACTIONS(2709),
    [anon_sym___restrict__] = ACTIONS(2709),
    [anon_sym__Atomic] = ACTIONS(2709),
    [anon_sym__Noreturn] = ACTIONS(2709),
    [anon_sym_noreturn] = ACTIONS(2709),
    [anon_sym__Nonnull] = ACTIONS(2709),
    [anon_sym_mutable] = ACTIONS(2709),
    [anon_sym_constinit] = ACTIONS(2709),
    [anon_sym_consteval] = ACTIONS(2709),
    [anon_sym_alignas] = ACTIONS(2709),
    [anon_sym__Alignas] = ACTIONS(2709),
    [sym_primitive_type] = ACTIONS(2709),
    [anon_sym_enum] = ACTIONS(2709),
    [anon_sym_class] = ACTIONS(2709),
    [anon_sym_struct] = ACTIONS(2709),
    [anon_sym_union] = ACTIONS(2709),
    [anon_sym_if] = ACTIONS(2709),
    [anon_sym_else] = ACTIONS(2709),
    [anon_sym_switch] = ACTIONS(2709),
    [anon_sym_case] = ACTIONS(2709),
    [anon_sym_default] = ACTIONS(2709),
    [anon_sym_while] = ACTIONS(2709),
    [anon_sym_do] = ACTIONS(2709),
    [anon_sym_for] = ACTIONS(2709),
    [anon_sym_return] = ACTIONS(2709),
    [anon_sym_break] = ACTIONS(2709),
    [anon_sym_continue] = ACTIONS(2709),
    [anon_sym_goto] = ACTIONS(2709),
    [anon_sym___try] = ACTIONS(2709),
    [anon_sym___leave] = ACTIONS(2709),
    [anon_sym_not] = ACTIONS(2709),
    [anon_sym_compl] = ACTIONS(2709),
    [anon_sym_DASH_DASH] = ACTIONS(2711),
    [anon_sym_PLUS_PLUS] = ACTIONS(2711),
    [anon_sym_sizeof] = ACTIONS(2709),
    [anon_sym___alignof__] = ACTIONS(2709),
    [anon_sym___alignof] = ACTIONS(2709),
    [anon_sym__alignof] = ACTIONS(2709),
    [anon_sym_alignof] = ACTIONS(2709),
    [anon_sym__Alignof] = ACTIONS(2709),
    [anon_sym_offsetof] = ACTIONS(2709),
    [anon_sym__Generic] = ACTIONS(2709),
    [anon_sym_asm] = ACTIONS(2709),
    [anon_sym___asm__] = ACTIONS(2709),
    [anon_sym___asm] = ACTIONS(2709),
    [sym_number_literal] = ACTIONS(2711),
    [anon_sym_L_SQUOTE] = ACTIONS(2711),
    [anon_sym_u_SQUOTE] = ACTIONS(2711),
    [anon_sym_U_SQUOTE] = ACTIONS(2711),
    [anon_sym_u8_SQUOTE] = ACTIONS(2711),
    [anon_sym_SQUOTE] = ACTIONS(2711),
    [anon_sym_L_DQUOTE] = ACTIONS(2711),
    [anon_sym_u_DQUOTE] = ACTIONS(2711),
    [anon_sym_U_DQUOTE] = ACTIONS(2711),
    [anon_sym_u8_DQUOTE] = ACTIONS(2711),
    [anon_sym_DQUOTE] = ACTIONS(2711),
    [sym_true] = ACTIONS(2709),
    [sym_false] = ACTIONS(2709),
    [anon_sym_NULL] = ACTIONS(2709),
    [anon_sym_nullptr] = ACTIONS(2709),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2709),
    [anon_sym_decltype] = ACTIONS(2709),
    [anon_sym_explicit] = ACTIONS(2709),
    [anon_sym_typename] = ACTIONS(2709),
    [anon_sym_template] = ACTIONS(2709),
    [anon_sym_operator] = ACTIONS(2709),
    [anon_sym_try] = ACTIONS(2709),
    [anon_sym_delete] = ACTIONS(2709),
    [anon_sym_throw] = ACTIONS(2709),
    [anon_sym_namespace] = ACTIONS(2709),
    [anon_sym_using] = ACTIONS(2709),
    [anon_sym_static_assert] = ACTIONS(2709),
    [anon_sym_concept] = ACTIONS(2709),
    [anon_sym_co_return] = ACTIONS(2709),
    [anon_sym_co_yield] = ACTIONS(2709),
    [anon_sym_R_DQUOTE] = ACTIONS(2711),
    [anon_sym_LR_DQUOTE] = ACTIONS(2711),
    [anon_sym_uR_DQUOTE] = ACTIONS(2711),
    [anon_sym_UR_DQUOTE] = ACTIONS(2711),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2711),
    [anon_sym_co_await] = ACTIONS(2709),
    [anon_sym_new] = ACTIONS(2709),
    [anon_sym_requires] = ACTIONS(2709),
    [sym_this] = ACTIONS(2709),
  },
  [512] = {
    [sym_identifier] = ACTIONS(2601),
    [aux_sym_preproc_include_token1] = ACTIONS(2601),
    [aux_sym_preproc_def_token1] = ACTIONS(2601),
    [aux_sym_preproc_if_token1] = ACTIONS(2601),
    [aux_sym_preproc_if_token2] = ACTIONS(2601),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2601),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2601),
    [sym_preproc_directive] = ACTIONS(2601),
    [anon_sym_LPAREN2] = ACTIONS(2603),
    [anon_sym_BANG] = ACTIONS(2603),
    [anon_sym_TILDE] = ACTIONS(2603),
    [anon_sym_DASH] = ACTIONS(2601),
    [anon_sym_PLUS] = ACTIONS(2601),
    [anon_sym_STAR] = ACTIONS(2603),
    [anon_sym_AMP_AMP] = ACTIONS(2603),
    [anon_sym_AMP] = ACTIONS(2601),
    [anon_sym_SEMI] = ACTIONS(2603),
    [anon_sym___extension__] = ACTIONS(2601),
    [anon_sym_typedef] = ACTIONS(2601),
    [anon_sym_virtual] = ACTIONS(2601),
    [anon_sym_extern] = ACTIONS(2601),
    [anon_sym___attribute__] = ACTIONS(2601),
    [anon_sym___attribute] = ACTIONS(2601),
    [anon_sym_COLON_COLON] = ACTIONS(2603),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2603),
    [anon_sym___declspec] = ACTIONS(2601),
    [anon_sym___based] = ACTIONS(2601),
    [anon_sym___cdecl] = ACTIONS(2601),
    [anon_sym___clrcall] = ACTIONS(2601),
    [anon_sym___stdcall] = ACTIONS(2601),
    [anon_sym___fastcall] = ACTIONS(2601),
    [anon_sym___thiscall] = ACTIONS(2601),
    [anon_sym___vectorcall] = ACTIONS(2601),
    [anon_sym_LBRACE] = ACTIONS(2603),
    [anon_sym_signed] = ACTIONS(2601),
    [anon_sym_unsigned] = ACTIONS(2601),
    [anon_sym_long] = ACTIONS(2601),
    [anon_sym_short] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2601),
    [anon_sym_static] = ACTIONS(2601),
    [anon_sym_register] = ACTIONS(2601),
    [anon_sym_inline] = ACTIONS(2601),
    [anon_sym___inline] = ACTIONS(2601),
    [anon_sym___inline__] = ACTIONS(2601),
    [anon_sym___forceinline] = ACTIONS(2601),
    [anon_sym_thread_local] = ACTIONS(2601),
    [anon_sym___thread] = ACTIONS(2601),
    [anon_sym_const] = ACTIONS(2601),
    [anon_sym_constexpr] = ACTIONS(2601),
    [anon_sym_volatile] = ACTIONS(2601),
    [anon_sym_restrict] = ACTIONS(2601),
    [anon_sym___restrict__] = ACTIONS(2601),
    [anon_sym__Atomic] = ACTIONS(2601),
    [anon_sym__Noreturn] = ACTIONS(2601),
    [anon_sym_noreturn] = ACTIONS(2601),
    [anon_sym__Nonnull] = ACTIONS(2601),
    [anon_sym_mutable] = ACTIONS(2601),
    [anon_sym_constinit] = ACTIONS(2601),
    [anon_sym_consteval] = ACTIONS(2601),
    [anon_sym_alignas] = ACTIONS(2601),
    [anon_sym__Alignas] = ACTIONS(2601),
    [sym_primitive_type] = ACTIONS(2601),
    [anon_sym_enum] = ACTIONS(2601),
    [anon_sym_class] = ACTIONS(2601),
    [anon_sym_struct] = ACTIONS(2601),
    [anon_sym_union] = ACTIONS(2601),
    [anon_sym_if] = ACTIONS(2601),
    [anon_sym_else] = ACTIONS(2601),
    [anon_sym_switch] = ACTIONS(2601),
    [anon_sym_case] = ACTIONS(2601),
    [anon_sym_default] = ACTIONS(2601),
    [anon_sym_while] = ACTIONS(2601),
    [anon_sym_do] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2601),
    [anon_sym_return] = ACTIONS(2601),
    [anon_sym_break] = ACTIONS(2601),
    [anon_sym_continue] = ACTIONS(2601),
    [anon_sym_goto] = ACTIONS(2601),
    [anon_sym___try] = ACTIONS(2601),
    [anon_sym___leave] = ACTIONS(2601),
    [anon_sym_not] = ACTIONS(2601),
    [anon_sym_compl] = ACTIONS(2601),
    [anon_sym_DASH_DASH] = ACTIONS(2603),
    [anon_sym_PLUS_PLUS] = ACTIONS(2603),
    [anon_sym_sizeof] = ACTIONS(2601),
    [anon_sym___alignof__] = ACTIONS(2601),
    [anon_sym___alignof] = ACTIONS(2601),
    [anon_sym__alignof] = ACTIONS(2601),
    [anon_sym_alignof] = ACTIONS(2601),
    [anon_sym__Alignof] = ACTIONS(2601),
    [anon_sym_offsetof] = ACTIONS(2601),
    [anon_sym__Generic] = ACTIONS(2601),
    [anon_sym_asm] = ACTIONS(2601),
    [anon_sym___asm__] = ACTIONS(2601),
    [anon_sym___asm] = ACTIONS(2601),
    [sym_number_literal] = ACTIONS(2603),
    [anon_sym_L_SQUOTE] = ACTIONS(2603),
    [anon_sym_u_SQUOTE] = ACTIONS(2603),
    [anon_sym_U_SQUOTE] = ACTIONS(2603),
    [anon_sym_u8_SQUOTE] = ACTIONS(2603),
    [anon_sym_SQUOTE] = ACTIONS(2603),
    [anon_sym_L_DQUOTE] = ACTIONS(2603),
    [anon_sym_u_DQUOTE] = ACTIONS(2603),
    [anon_sym_U_DQUOTE] = ACTIONS(2603),
    [anon_sym_u8_DQUOTE] = ACTIONS(2603),
    [anon_sym_DQUOTE] = ACTIONS(2603),
    [sym_true] = ACTIONS(2601),
    [sym_false] = ACTIONS(2601),
    [anon_sym_NULL] = ACTIONS(2601),
    [anon_sym_nullptr] = ACTIONS(2601),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2601),
    [anon_sym_decltype] = ACTIONS(2601),
    [anon_sym_explicit] = ACTIONS(2601),
    [anon_sym_typename] = ACTIONS(2601),
    [anon_sym_template] = ACTIONS(2601),
    [anon_sym_operator] = ACTIONS(2601),
    [anon_sym_try] = ACTIONS(2601),
    [anon_sym_delete] = ACTIONS(2601),
    [anon_sym_throw] = ACTIONS(2601),
    [anon_sym_namespace] = ACTIONS(2601),
    [anon_sym_using] = ACTIONS(2601),
    [anon_sym_static_assert] = ACTIONS(2601),
    [anon_sym_concept] = ACTIONS(2601),
    [anon_sym_co_return] = ACTIONS(2601),
    [anon_sym_co_yield] = ACTIONS(2601),
    [anon_sym_R_DQUOTE] = ACTIONS(2603),
    [anon_sym_LR_DQUOTE] = ACTIONS(2603),
    [anon_sym_uR_DQUOTE] = ACTIONS(2603),
    [anon_sym_UR_DQUOTE] = ACTIONS(2603),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2603),
    [anon_sym_co_await] = ACTIONS(2601),
    [anon_sym_new] = ACTIONS(2601),
    [anon_sym_requires] = ACTIONS(2601),
    [sym_this] = ACTIONS(2601),
  },
  [513] = {
    [sym_identifier] = ACTIONS(2605),
    [aux_sym_preproc_include_token1] = ACTIONS(2605),
    [aux_sym_preproc_def_token1] = ACTIONS(2605),
    [aux_sym_preproc_if_token1] = ACTIONS(2605),
    [aux_sym_preproc_if_token2] = ACTIONS(2605),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2605),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2605),
    [sym_preproc_directive] = ACTIONS(2605),
    [anon_sym_LPAREN2] = ACTIONS(2607),
    [anon_sym_BANG] = ACTIONS(2607),
    [anon_sym_TILDE] = ACTIONS(2607),
    [anon_sym_DASH] = ACTIONS(2605),
    [anon_sym_PLUS] = ACTIONS(2605),
    [anon_sym_STAR] = ACTIONS(2607),
    [anon_sym_AMP_AMP] = ACTIONS(2607),
    [anon_sym_AMP] = ACTIONS(2605),
    [anon_sym_SEMI] = ACTIONS(2607),
    [anon_sym___extension__] = ACTIONS(2605),
    [anon_sym_typedef] = ACTIONS(2605),
    [anon_sym_virtual] = ACTIONS(2605),
    [anon_sym_extern] = ACTIONS(2605),
    [anon_sym___attribute__] = ACTIONS(2605),
    [anon_sym___attribute] = ACTIONS(2605),
    [anon_sym_COLON_COLON] = ACTIONS(2607),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2607),
    [anon_sym___declspec] = ACTIONS(2605),
    [anon_sym___based] = ACTIONS(2605),
    [anon_sym___cdecl] = ACTIONS(2605),
    [anon_sym___clrcall] = ACTIONS(2605),
    [anon_sym___stdcall] = ACTIONS(2605),
    [anon_sym___fastcall] = ACTIONS(2605),
    [anon_sym___thiscall] = ACTIONS(2605),
    [anon_sym___vectorcall] = ACTIONS(2605),
    [anon_sym_LBRACE] = ACTIONS(2607),
    [anon_sym_signed] = ACTIONS(2605),
    [anon_sym_unsigned] = ACTIONS(2605),
    [anon_sym_long] = ACTIONS(2605),
    [anon_sym_short] = ACTIONS(2605),
    [anon_sym_LBRACK] = ACTIONS(2605),
    [anon_sym_static] = ACTIONS(2605),
    [anon_sym_register] = ACTIONS(2605),
    [anon_sym_inline] = ACTIONS(2605),
    [anon_sym___inline] = ACTIONS(2605),
    [anon_sym___inline__] = ACTIONS(2605),
    [anon_sym___forceinline] = ACTIONS(2605),
    [anon_sym_thread_local] = ACTIONS(2605),
    [anon_sym___thread] = ACTIONS(2605),
    [anon_sym_const] = ACTIONS(2605),
    [anon_sym_constexpr] = ACTIONS(2605),
    [anon_sym_volatile] = ACTIONS(2605),
    [anon_sym_restrict] = ACTIONS(2605),
    [anon_sym___restrict__] = ACTIONS(2605),
    [anon_sym__Atomic] = ACTIONS(2605),
    [anon_sym__Noreturn] = ACTIONS(2605),
    [anon_sym_noreturn] = ACTIONS(2605),
    [anon_sym__Nonnull] = ACTIONS(2605),
    [anon_sym_mutable] = ACTIONS(2605),
    [anon_sym_constinit] = ACTIONS(2605),
    [anon_sym_consteval] = ACTIONS(2605),
    [anon_sym_alignas] = ACTIONS(2605),
    [anon_sym__Alignas] = ACTIONS(2605),
    [sym_primitive_type] = ACTIONS(2605),
    [anon_sym_enum] = ACTIONS(2605),
    [anon_sym_class] = ACTIONS(2605),
    [anon_sym_struct] = ACTIONS(2605),
    [anon_sym_union] = ACTIONS(2605),
    [anon_sym_if] = ACTIONS(2605),
    [anon_sym_else] = ACTIONS(2605),
    [anon_sym_switch] = ACTIONS(2605),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_default] = ACTIONS(2605),
    [anon_sym_while] = ACTIONS(2605),
    [anon_sym_do] = ACTIONS(2605),
    [anon_sym_for] = ACTIONS(2605),
    [anon_sym_return] = ACTIONS(2605),
    [anon_sym_break] = ACTIONS(2605),
    [anon_sym_continue] = ACTIONS(2605),
    [anon_sym_goto] = ACTIONS(2605),
    [anon_sym___try] = ACTIONS(2605),
    [anon_sym___leave] = ACTIONS(2605),
    [anon_sym_not] = ACTIONS(2605),
    [anon_sym_compl] = ACTIONS(2605),
    [anon_sym_DASH_DASH] = ACTIONS(2607),
    [anon_sym_PLUS_PLUS] = ACTIONS(2607),
    [anon_sym_sizeof] = ACTIONS(2605),
    [anon_sym___alignof__] = ACTIONS(2605),
    [anon_sym___alignof] = ACTIONS(2605),
    [anon_sym__alignof] = ACTIONS(2605),
    [anon_sym_alignof] = ACTIONS(2605),
    [anon_sym__Alignof] = ACTIONS(2605),
    [anon_sym_offsetof] = ACTIONS(2605),
    [anon_sym__Generic] = ACTIONS(2605),
    [anon_sym_asm] = ACTIONS(2605),
    [anon_sym___asm__] = ACTIONS(2605),
    [anon_sym___asm] = ACTIONS(2605),
    [sym_number_literal] = ACTIONS(2607),
    [anon_sym_L_SQUOTE] = ACTIONS(2607),
    [anon_sym_u_SQUOTE] = ACTIONS(2607),
    [anon_sym_U_SQUOTE] = ACTIONS(2607),
    [anon_sym_u8_SQUOTE] = ACTIONS(2607),
    [anon_sym_SQUOTE] = ACTIONS(2607),
    [anon_sym_L_DQUOTE] = ACTIONS(2607),
    [anon_sym_u_DQUOTE] = ACTIONS(2607),
    [anon_sym_U_DQUOTE] = ACTIONS(2607),
    [anon_sym_u8_DQUOTE] = ACTIONS(2607),
    [anon_sym_DQUOTE] = ACTIONS(2607),
    [sym_true] = ACTIONS(2605),
    [sym_false] = ACTIONS(2605),
    [anon_sym_NULL] = ACTIONS(2605),
    [anon_sym_nullptr] = ACTIONS(2605),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2605),
    [anon_sym_decltype] = ACTIONS(2605),
    [anon_sym_explicit] = ACTIONS(2605),
    [anon_sym_typename] = ACTIONS(2605),
    [anon_sym_template] = ACTIONS(2605),
    [anon_sym_operator] = ACTIONS(2605),
    [anon_sym_try] = ACTIONS(2605),
    [anon_sym_delete] = ACTIONS(2605),
    [anon_sym_throw] = ACTIONS(2605),
    [anon_sym_namespace] = ACTIONS(2605),
    [anon_sym_using] = ACTIONS(2605),
    [anon_sym_static_assert] = ACTIONS(2605),
    [anon_sym_concept] = ACTIONS(2605),
    [anon_sym_co_return] = ACTIONS(2605),
    [anon_sym_co_yield] = ACTIONS(2605),
    [anon_sym_R_DQUOTE] = ACTIONS(2607),
    [anon_sym_LR_DQUOTE] = ACTIONS(2607),
    [anon_sym_uR_DQUOTE] = ACTIONS(2607),
    [anon_sym_UR_DQUOTE] = ACTIONS(2607),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2607),
    [anon_sym_co_await] = ACTIONS(2605),
    [anon_sym_new] = ACTIONS(2605),
    [anon_sym_requires] = ACTIONS(2605),
    [sym_this] = ACTIONS(2605),
  },
  [514] = {
    [ts_builtin_sym_end] = ACTIONS(2719),
    [sym_identifier] = ACTIONS(2717),
    [aux_sym_preproc_include_token1] = ACTIONS(2717),
    [aux_sym_preproc_def_token1] = ACTIONS(2717),
    [aux_sym_preproc_if_token1] = ACTIONS(2717),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2717),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2717),
    [sym_preproc_directive] = ACTIONS(2717),
    [anon_sym_LPAREN2] = ACTIONS(2719),
    [anon_sym_BANG] = ACTIONS(2719),
    [anon_sym_TILDE] = ACTIONS(2719),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP_AMP] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2717),
    [anon_sym_SEMI] = ACTIONS(2719),
    [anon_sym___extension__] = ACTIONS(2717),
    [anon_sym_typedef] = ACTIONS(2717),
    [anon_sym_virtual] = ACTIONS(2717),
    [anon_sym_extern] = ACTIONS(2717),
    [anon_sym___attribute__] = ACTIONS(2717),
    [anon_sym___attribute] = ACTIONS(2717),
    [anon_sym_COLON_COLON] = ACTIONS(2719),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2719),
    [anon_sym___declspec] = ACTIONS(2717),
    [anon_sym___based] = ACTIONS(2717),
    [anon_sym___cdecl] = ACTIONS(2717),
    [anon_sym___clrcall] = ACTIONS(2717),
    [anon_sym___stdcall] = ACTIONS(2717),
    [anon_sym___fastcall] = ACTIONS(2717),
    [anon_sym___thiscall] = ACTIONS(2717),
    [anon_sym___vectorcall] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(2719),
    [anon_sym_signed] = ACTIONS(2717),
    [anon_sym_unsigned] = ACTIONS(2717),
    [anon_sym_long] = ACTIONS(2717),
    [anon_sym_short] = ACTIONS(2717),
    [anon_sym_LBRACK] = ACTIONS(2717),
    [anon_sym_static] = ACTIONS(2717),
    [anon_sym_register] = ACTIONS(2717),
    [anon_sym_inline] = ACTIONS(2717),
    [anon_sym___inline] = ACTIONS(2717),
    [anon_sym___inline__] = ACTIONS(2717),
    [anon_sym___forceinline] = ACTIONS(2717),
    [anon_sym_thread_local] = ACTIONS(2717),
    [anon_sym___thread] = ACTIONS(2717),
    [anon_sym_const] = ACTIONS(2717),
    [anon_sym_constexpr] = ACTIONS(2717),
    [anon_sym_volatile] = ACTIONS(2717),
    [anon_sym_restrict] = ACTIONS(2717),
    [anon_sym___restrict__] = ACTIONS(2717),
    [anon_sym__Atomic] = ACTIONS(2717),
    [anon_sym__Noreturn] = ACTIONS(2717),
    [anon_sym_noreturn] = ACTIONS(2717),
    [anon_sym__Nonnull] = ACTIONS(2717),
    [anon_sym_mutable] = ACTIONS(2717),
    [anon_sym_constinit] = ACTIONS(2717),
    [anon_sym_consteval] = ACTIONS(2717),
    [anon_sym_alignas] = ACTIONS(2717),
    [anon_sym__Alignas] = ACTIONS(2717),
    [sym_primitive_type] = ACTIONS(2717),
    [anon_sym_enum] = ACTIONS(2717),
    [anon_sym_class] = ACTIONS(2717),
    [anon_sym_struct] = ACTIONS(2717),
    [anon_sym_union] = ACTIONS(2717),
    [anon_sym_if] = ACTIONS(2717),
    [anon_sym_else] = ACTIONS(2717),
    [anon_sym_switch] = ACTIONS(2717),
    [anon_sym_case] = ACTIONS(2717),
    [anon_sym_default] = ACTIONS(2717),
    [anon_sym_while] = ACTIONS(2717),
    [anon_sym_do] = ACTIONS(2717),
    [anon_sym_for] = ACTIONS(2717),
    [anon_sym_return] = ACTIONS(2717),
    [anon_sym_break] = ACTIONS(2717),
    [anon_sym_continue] = ACTIONS(2717),
    [anon_sym_goto] = ACTIONS(2717),
    [anon_sym___try] = ACTIONS(2717),
    [anon_sym___leave] = ACTIONS(2717),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2719),
    [anon_sym_PLUS_PLUS] = ACTIONS(2719),
    [anon_sym_sizeof] = ACTIONS(2717),
    [anon_sym___alignof__] = ACTIONS(2717),
    [anon_sym___alignof] = ACTIONS(2717),
    [anon_sym__alignof] = ACTIONS(2717),
    [anon_sym_alignof] = ACTIONS(2717),
    [anon_sym__Alignof] = ACTIONS(2717),
    [anon_sym_offsetof] = ACTIONS(2717),
    [anon_sym__Generic] = ACTIONS(2717),
    [anon_sym_asm] = ACTIONS(2717),
    [anon_sym___asm__] = ACTIONS(2717),
    [anon_sym___asm] = ACTIONS(2717),
    [sym_number_literal] = ACTIONS(2719),
    [anon_sym_L_SQUOTE] = ACTIONS(2719),
    [anon_sym_u_SQUOTE] = ACTIONS(2719),
    [anon_sym_U_SQUOTE] = ACTIONS(2719),
    [anon_sym_u8_SQUOTE] = ACTIONS(2719),
    [anon_sym_SQUOTE] = ACTIONS(2719),
    [anon_sym_L_DQUOTE] = ACTIONS(2719),
    [anon_sym_u_DQUOTE] = ACTIONS(2719),
    [anon_sym_U_DQUOTE] = ACTIONS(2719),
    [anon_sym_u8_DQUOTE] = ACTIONS(2719),
    [anon_sym_DQUOTE] = ACTIONS(2719),
    [sym_true] = ACTIONS(2717),
    [sym_false] = ACTIONS(2717),
    [anon_sym_NULL] = ACTIONS(2717),
    [anon_sym_nullptr] = ACTIONS(2717),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2717),
    [anon_sym_decltype] = ACTIONS(2717),
    [anon_sym_explicit] = ACTIONS(2717),
    [anon_sym_typename] = ACTIONS(2717),
    [anon_sym_template] = ACTIONS(2717),
    [anon_sym_operator] = ACTIONS(2717),
    [anon_sym_try] = ACTIONS(2717),
    [anon_sym_delete] = ACTIONS(2717),
    [anon_sym_throw] = ACTIONS(2717),
    [anon_sym_namespace] = ACTIONS(2717),
    [anon_sym_using] = ACTIONS(2717),
    [anon_sym_static_assert] = ACTIONS(2717),
    [anon_sym_concept] = ACTIONS(2717),
    [anon_sym_co_return] = ACTIONS(2717),
    [anon_sym_co_yield] = ACTIONS(2717),
    [anon_sym_R_DQUOTE] = ACTIONS(2719),
    [anon_sym_LR_DQUOTE] = ACTIONS(2719),
    [anon_sym_uR_DQUOTE] = ACTIONS(2719),
    [anon_sym_UR_DQUOTE] = ACTIONS(2719),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2719),
    [anon_sym_co_await] = ACTIONS(2717),
    [anon_sym_new] = ACTIONS(2717),
    [anon_sym_requires] = ACTIONS(2717),
    [sym_this] = ACTIONS(2717),
  },
  [515] = {
    [ts_builtin_sym_end] = ACTIONS(2643),
    [sym_identifier] = ACTIONS(2641),
    [aux_sym_preproc_include_token1] = ACTIONS(2641),
    [aux_sym_preproc_def_token1] = ACTIONS(2641),
    [aux_sym_preproc_if_token1] = ACTIONS(2641),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2641),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2641),
    [sym_preproc_directive] = ACTIONS(2641),
    [anon_sym_LPAREN2] = ACTIONS(2643),
    [anon_sym_BANG] = ACTIONS(2643),
    [anon_sym_TILDE] = ACTIONS(2643),
    [anon_sym_DASH] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(2641),
    [anon_sym_STAR] = ACTIONS(2643),
    [anon_sym_AMP_AMP] = ACTIONS(2643),
    [anon_sym_AMP] = ACTIONS(2641),
    [anon_sym_SEMI] = ACTIONS(2643),
    [anon_sym___extension__] = ACTIONS(2641),
    [anon_sym_typedef] = ACTIONS(2641),
    [anon_sym_virtual] = ACTIONS(2641),
    [anon_sym_extern] = ACTIONS(2641),
    [anon_sym___attribute__] = ACTIONS(2641),
    [anon_sym___attribute] = ACTIONS(2641),
    [anon_sym_COLON_COLON] = ACTIONS(2643),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2643),
    [anon_sym___declspec] = ACTIONS(2641),
    [anon_sym___based] = ACTIONS(2641),
    [anon_sym___cdecl] = ACTIONS(2641),
    [anon_sym___clrcall] = ACTIONS(2641),
    [anon_sym___stdcall] = ACTIONS(2641),
    [anon_sym___fastcall] = ACTIONS(2641),
    [anon_sym___thiscall] = ACTIONS(2641),
    [anon_sym___vectorcall] = ACTIONS(2641),
    [anon_sym_LBRACE] = ACTIONS(2643),
    [anon_sym_signed] = ACTIONS(2641),
    [anon_sym_unsigned] = ACTIONS(2641),
    [anon_sym_long] = ACTIONS(2641),
    [anon_sym_short] = ACTIONS(2641),
    [anon_sym_LBRACK] = ACTIONS(2641),
    [anon_sym_static] = ACTIONS(2641),
    [anon_sym_register] = ACTIONS(2641),
    [anon_sym_inline] = ACTIONS(2641),
    [anon_sym___inline] = ACTIONS(2641),
    [anon_sym___inline__] = ACTIONS(2641),
    [anon_sym___forceinline] = ACTIONS(2641),
    [anon_sym_thread_local] = ACTIONS(2641),
    [anon_sym___thread] = ACTIONS(2641),
    [anon_sym_const] = ACTIONS(2641),
    [anon_sym_constexpr] = ACTIONS(2641),
    [anon_sym_volatile] = ACTIONS(2641),
    [anon_sym_restrict] = ACTIONS(2641),
    [anon_sym___restrict__] = ACTIONS(2641),
    [anon_sym__Atomic] = ACTIONS(2641),
    [anon_sym__Noreturn] = ACTIONS(2641),
    [anon_sym_noreturn] = ACTIONS(2641),
    [anon_sym__Nonnull] = ACTIONS(2641),
    [anon_sym_mutable] = ACTIONS(2641),
    [anon_sym_constinit] = ACTIONS(2641),
    [anon_sym_consteval] = ACTIONS(2641),
    [anon_sym_alignas] = ACTIONS(2641),
    [anon_sym__Alignas] = ACTIONS(2641),
    [sym_primitive_type] = ACTIONS(2641),
    [anon_sym_enum] = ACTIONS(2641),
    [anon_sym_class] = ACTIONS(2641),
    [anon_sym_struct] = ACTIONS(2641),
    [anon_sym_union] = ACTIONS(2641),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_else] = ACTIONS(2641),
    [anon_sym_switch] = ACTIONS(2641),
    [anon_sym_case] = ACTIONS(2641),
    [anon_sym_default] = ACTIONS(2641),
    [anon_sym_while] = ACTIONS(2641),
    [anon_sym_do] = ACTIONS(2641),
    [anon_sym_for] = ACTIONS(2641),
    [anon_sym_return] = ACTIONS(2641),
    [anon_sym_break] = ACTIONS(2641),
    [anon_sym_continue] = ACTIONS(2641),
    [anon_sym_goto] = ACTIONS(2641),
    [anon_sym___try] = ACTIONS(2641),
    [anon_sym___leave] = ACTIONS(2641),
    [anon_sym_not] = ACTIONS(2641),
    [anon_sym_compl] = ACTIONS(2641),
    [anon_sym_DASH_DASH] = ACTIONS(2643),
    [anon_sym_PLUS_PLUS] = ACTIONS(2643),
    [anon_sym_sizeof] = ACTIONS(2641),
    [anon_sym___alignof__] = ACTIONS(2641),
    [anon_sym___alignof] = ACTIONS(2641),
    [anon_sym__alignof] = ACTIONS(2641),
    [anon_sym_alignof] = ACTIONS(2641),
    [anon_sym__Alignof] = ACTIONS(2641),
    [anon_sym_offsetof] = ACTIONS(2641),
    [anon_sym__Generic] = ACTIONS(2641),
    [anon_sym_asm] = ACTIONS(2641),
    [anon_sym___asm__] = ACTIONS(2641),
    [anon_sym___asm] = ACTIONS(2641),
    [sym_number_literal] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2643),
    [anon_sym_u_SQUOTE] = ACTIONS(2643),
    [anon_sym_U_SQUOTE] = ACTIONS(2643),
    [anon_sym_u8_SQUOTE] = ACTIONS(2643),
    [anon_sym_SQUOTE] = ACTIONS(2643),
    [anon_sym_L_DQUOTE] = ACTIONS(2643),
    [anon_sym_u_DQUOTE] = ACTIONS(2643),
    [anon_sym_U_DQUOTE] = ACTIONS(2643),
    [anon_sym_u8_DQUOTE] = ACTIONS(2643),
    [anon_sym_DQUOTE] = ACTIONS(2643),
    [sym_true] = ACTIONS(2641),
    [sym_false] = ACTIONS(2641),
    [anon_sym_NULL] = ACTIONS(2641),
    [anon_sym_nullptr] = ACTIONS(2641),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2641),
    [anon_sym_decltype] = ACTIONS(2641),
    [anon_sym_explicit] = ACTIONS(2641),
    [anon_sym_typename] = ACTIONS(2641),
    [anon_sym_template] = ACTIONS(2641),
    [anon_sym_operator] = ACTIONS(2641),
    [anon_sym_try] = ACTIONS(2641),
    [anon_sym_delete] = ACTIONS(2641),
    [anon_sym_throw] = ACTIONS(2641),
    [anon_sym_namespace] = ACTIONS(2641),
    [anon_sym_using] = ACTIONS(2641),
    [anon_sym_static_assert] = ACTIONS(2641),
    [anon_sym_concept] = ACTIONS(2641),
    [anon_sym_co_return] = ACTIONS(2641),
    [anon_sym_co_yield] = ACTIONS(2641),
    [anon_sym_R_DQUOTE] = ACTIONS(2643),
    [anon_sym_LR_DQUOTE] = ACTIONS(2643),
    [anon_sym_uR_DQUOTE] = ACTIONS(2643),
    [anon_sym_UR_DQUOTE] = ACTIONS(2643),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2643),
    [anon_sym_co_await] = ACTIONS(2641),
    [anon_sym_new] = ACTIONS(2641),
    [anon_sym_requires] = ACTIONS(2641),
    [sym_this] = ACTIONS(2641),
  },
  [516] = {
    [sym_identifier] = ACTIONS(2717),
    [aux_sym_preproc_include_token1] = ACTIONS(2717),
    [aux_sym_preproc_def_token1] = ACTIONS(2717),
    [aux_sym_preproc_if_token1] = ACTIONS(2717),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2717),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2717),
    [sym_preproc_directive] = ACTIONS(2717),
    [anon_sym_LPAREN2] = ACTIONS(2719),
    [anon_sym_BANG] = ACTIONS(2719),
    [anon_sym_TILDE] = ACTIONS(2719),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP_AMP] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2717),
    [anon_sym_SEMI] = ACTIONS(2719),
    [anon_sym___extension__] = ACTIONS(2717),
    [anon_sym_typedef] = ACTIONS(2717),
    [anon_sym_virtual] = ACTIONS(2717),
    [anon_sym_extern] = ACTIONS(2717),
    [anon_sym___attribute__] = ACTIONS(2717),
    [anon_sym___attribute] = ACTIONS(2717),
    [anon_sym_COLON_COLON] = ACTIONS(2719),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2719),
    [anon_sym___declspec] = ACTIONS(2717),
    [anon_sym___based] = ACTIONS(2717),
    [anon_sym___cdecl] = ACTIONS(2717),
    [anon_sym___clrcall] = ACTIONS(2717),
    [anon_sym___stdcall] = ACTIONS(2717),
    [anon_sym___fastcall] = ACTIONS(2717),
    [anon_sym___thiscall] = ACTIONS(2717),
    [anon_sym___vectorcall] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(2719),
    [anon_sym_RBRACE] = ACTIONS(2719),
    [anon_sym_signed] = ACTIONS(2717),
    [anon_sym_unsigned] = ACTIONS(2717),
    [anon_sym_long] = ACTIONS(2717),
    [anon_sym_short] = ACTIONS(2717),
    [anon_sym_LBRACK] = ACTIONS(2717),
    [anon_sym_static] = ACTIONS(2717),
    [anon_sym_register] = ACTIONS(2717),
    [anon_sym_inline] = ACTIONS(2717),
    [anon_sym___inline] = ACTIONS(2717),
    [anon_sym___inline__] = ACTIONS(2717),
    [anon_sym___forceinline] = ACTIONS(2717),
    [anon_sym_thread_local] = ACTIONS(2717),
    [anon_sym___thread] = ACTIONS(2717),
    [anon_sym_const] = ACTIONS(2717),
    [anon_sym_constexpr] = ACTIONS(2717),
    [anon_sym_volatile] = ACTIONS(2717),
    [anon_sym_restrict] = ACTIONS(2717),
    [anon_sym___restrict__] = ACTIONS(2717),
    [anon_sym__Atomic] = ACTIONS(2717),
    [anon_sym__Noreturn] = ACTIONS(2717),
    [anon_sym_noreturn] = ACTIONS(2717),
    [anon_sym__Nonnull] = ACTIONS(2717),
    [anon_sym_mutable] = ACTIONS(2717),
    [anon_sym_constinit] = ACTIONS(2717),
    [anon_sym_consteval] = ACTIONS(2717),
    [anon_sym_alignas] = ACTIONS(2717),
    [anon_sym__Alignas] = ACTIONS(2717),
    [sym_primitive_type] = ACTIONS(2717),
    [anon_sym_enum] = ACTIONS(2717),
    [anon_sym_class] = ACTIONS(2717),
    [anon_sym_struct] = ACTIONS(2717),
    [anon_sym_union] = ACTIONS(2717),
    [anon_sym_if] = ACTIONS(2717),
    [anon_sym_else] = ACTIONS(2717),
    [anon_sym_switch] = ACTIONS(2717),
    [anon_sym_case] = ACTIONS(2717),
    [anon_sym_default] = ACTIONS(2717),
    [anon_sym_while] = ACTIONS(2717),
    [anon_sym_do] = ACTIONS(2717),
    [anon_sym_for] = ACTIONS(2717),
    [anon_sym_return] = ACTIONS(2717),
    [anon_sym_break] = ACTIONS(2717),
    [anon_sym_continue] = ACTIONS(2717),
    [anon_sym_goto] = ACTIONS(2717),
    [anon_sym___try] = ACTIONS(2717),
    [anon_sym___leave] = ACTIONS(2717),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2719),
    [anon_sym_PLUS_PLUS] = ACTIONS(2719),
    [anon_sym_sizeof] = ACTIONS(2717),
    [anon_sym___alignof__] = ACTIONS(2717),
    [anon_sym___alignof] = ACTIONS(2717),
    [anon_sym__alignof] = ACTIONS(2717),
    [anon_sym_alignof] = ACTIONS(2717),
    [anon_sym__Alignof] = ACTIONS(2717),
    [anon_sym_offsetof] = ACTIONS(2717),
    [anon_sym__Generic] = ACTIONS(2717),
    [anon_sym_asm] = ACTIONS(2717),
    [anon_sym___asm__] = ACTIONS(2717),
    [anon_sym___asm] = ACTIONS(2717),
    [sym_number_literal] = ACTIONS(2719),
    [anon_sym_L_SQUOTE] = ACTIONS(2719),
    [anon_sym_u_SQUOTE] = ACTIONS(2719),
    [anon_sym_U_SQUOTE] = ACTIONS(2719),
    [anon_sym_u8_SQUOTE] = ACTIONS(2719),
    [anon_sym_SQUOTE] = ACTIONS(2719),
    [anon_sym_L_DQUOTE] = ACTIONS(2719),
    [anon_sym_u_DQUOTE] = ACTIONS(2719),
    [anon_sym_U_DQUOTE] = ACTIONS(2719),
    [anon_sym_u8_DQUOTE] = ACTIONS(2719),
    [anon_sym_DQUOTE] = ACTIONS(2719),
    [sym_true] = ACTIONS(2717),
    [sym_false] = ACTIONS(2717),
    [anon_sym_NULL] = ACTIONS(2717),
    [anon_sym_nullptr] = ACTIONS(2717),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2717),
    [anon_sym_decltype] = ACTIONS(2717),
    [anon_sym_explicit] = ACTIONS(2717),
    [anon_sym_typename] = ACTIONS(2717),
    [anon_sym_template] = ACTIONS(2717),
    [anon_sym_operator] = ACTIONS(2717),
    [anon_sym_try] = ACTIONS(2717),
    [anon_sym_delete] = ACTIONS(2717),
    [anon_sym_throw] = ACTIONS(2717),
    [anon_sym_namespace] = ACTIONS(2717),
    [anon_sym_using] = ACTIONS(2717),
    [anon_sym_static_assert] = ACTIONS(2717),
    [anon_sym_concept] = ACTIONS(2717),
    [anon_sym_co_return] = ACTIONS(2717),
    [anon_sym_co_yield] = ACTIONS(2717),
    [anon_sym_R_DQUOTE] = ACTIONS(2719),
    [anon_sym_LR_DQUOTE] = ACTIONS(2719),
    [anon_sym_uR_DQUOTE] = ACTIONS(2719),
    [anon_sym_UR_DQUOTE] = ACTIONS(2719),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2719),
    [anon_sym_co_await] = ACTIONS(2717),
    [anon_sym_new] = ACTIONS(2717),
    [anon_sym_requires] = ACTIONS(2717),
    [sym_this] = ACTIONS(2717),
  },
  [517] = {
    [sym_identifier] = ACTIONS(2681),
    [aux_sym_preproc_include_token1] = ACTIONS(2681),
    [aux_sym_preproc_def_token1] = ACTIONS(2681),
    [aux_sym_preproc_if_token1] = ACTIONS(2681),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2681),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2681),
    [sym_preproc_directive] = ACTIONS(2681),
    [anon_sym_LPAREN2] = ACTIONS(2683),
    [anon_sym_BANG] = ACTIONS(2683),
    [anon_sym_TILDE] = ACTIONS(2683),
    [anon_sym_DASH] = ACTIONS(2681),
    [anon_sym_PLUS] = ACTIONS(2681),
    [anon_sym_STAR] = ACTIONS(2683),
    [anon_sym_AMP_AMP] = ACTIONS(2683),
    [anon_sym_AMP] = ACTIONS(2681),
    [anon_sym_SEMI] = ACTIONS(2683),
    [anon_sym___extension__] = ACTIONS(2681),
    [anon_sym_typedef] = ACTIONS(2681),
    [anon_sym_virtual] = ACTIONS(2681),
    [anon_sym_extern] = ACTIONS(2681),
    [anon_sym___attribute__] = ACTIONS(2681),
    [anon_sym___attribute] = ACTIONS(2681),
    [anon_sym_COLON_COLON] = ACTIONS(2683),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2683),
    [anon_sym___declspec] = ACTIONS(2681),
    [anon_sym___based] = ACTIONS(2681),
    [anon_sym___cdecl] = ACTIONS(2681),
    [anon_sym___clrcall] = ACTIONS(2681),
    [anon_sym___stdcall] = ACTIONS(2681),
    [anon_sym___fastcall] = ACTIONS(2681),
    [anon_sym___thiscall] = ACTIONS(2681),
    [anon_sym___vectorcall] = ACTIONS(2681),
    [anon_sym_LBRACE] = ACTIONS(2683),
    [anon_sym_RBRACE] = ACTIONS(2683),
    [anon_sym_signed] = ACTIONS(2681),
    [anon_sym_unsigned] = ACTIONS(2681),
    [anon_sym_long] = ACTIONS(2681),
    [anon_sym_short] = ACTIONS(2681),
    [anon_sym_LBRACK] = ACTIONS(2681),
    [anon_sym_static] = ACTIONS(2681),
    [anon_sym_register] = ACTIONS(2681),
    [anon_sym_inline] = ACTIONS(2681),
    [anon_sym___inline] = ACTIONS(2681),
    [anon_sym___inline__] = ACTIONS(2681),
    [anon_sym___forceinline] = ACTIONS(2681),
    [anon_sym_thread_local] = ACTIONS(2681),
    [anon_sym___thread] = ACTIONS(2681),
    [anon_sym_const] = ACTIONS(2681),
    [anon_sym_constexpr] = ACTIONS(2681),
    [anon_sym_volatile] = ACTIONS(2681),
    [anon_sym_restrict] = ACTIONS(2681),
    [anon_sym___restrict__] = ACTIONS(2681),
    [anon_sym__Atomic] = ACTIONS(2681),
    [anon_sym__Noreturn] = ACTIONS(2681),
    [anon_sym_noreturn] = ACTIONS(2681),
    [anon_sym__Nonnull] = ACTIONS(2681),
    [anon_sym_mutable] = ACTIONS(2681),
    [anon_sym_constinit] = ACTIONS(2681),
    [anon_sym_consteval] = ACTIONS(2681),
    [anon_sym_alignas] = ACTIONS(2681),
    [anon_sym__Alignas] = ACTIONS(2681),
    [sym_primitive_type] = ACTIONS(2681),
    [anon_sym_enum] = ACTIONS(2681),
    [anon_sym_class] = ACTIONS(2681),
    [anon_sym_struct] = ACTIONS(2681),
    [anon_sym_union] = ACTIONS(2681),
    [anon_sym_if] = ACTIONS(2681),
    [anon_sym_else] = ACTIONS(2681),
    [anon_sym_switch] = ACTIONS(2681),
    [anon_sym_case] = ACTIONS(2681),
    [anon_sym_default] = ACTIONS(2681),
    [anon_sym_while] = ACTIONS(2681),
    [anon_sym_do] = ACTIONS(2681),
    [anon_sym_for] = ACTIONS(2681),
    [anon_sym_return] = ACTIONS(2681),
    [anon_sym_break] = ACTIONS(2681),
    [anon_sym_continue] = ACTIONS(2681),
    [anon_sym_goto] = ACTIONS(2681),
    [anon_sym___try] = ACTIONS(2681),
    [anon_sym___leave] = ACTIONS(2681),
    [anon_sym_not] = ACTIONS(2681),
    [anon_sym_compl] = ACTIONS(2681),
    [anon_sym_DASH_DASH] = ACTIONS(2683),
    [anon_sym_PLUS_PLUS] = ACTIONS(2683),
    [anon_sym_sizeof] = ACTIONS(2681),
    [anon_sym___alignof__] = ACTIONS(2681),
    [anon_sym___alignof] = ACTIONS(2681),
    [anon_sym__alignof] = ACTIONS(2681),
    [anon_sym_alignof] = ACTIONS(2681),
    [anon_sym__Alignof] = ACTIONS(2681),
    [anon_sym_offsetof] = ACTIONS(2681),
    [anon_sym__Generic] = ACTIONS(2681),
    [anon_sym_asm] = ACTIONS(2681),
    [anon_sym___asm__] = ACTIONS(2681),
    [anon_sym___asm] = ACTIONS(2681),
    [sym_number_literal] = ACTIONS(2683),
    [anon_sym_L_SQUOTE] = ACTIONS(2683),
    [anon_sym_u_SQUOTE] = ACTIONS(2683),
    [anon_sym_U_SQUOTE] = ACTIONS(2683),
    [anon_sym_u8_SQUOTE] = ACTIONS(2683),
    [anon_sym_SQUOTE] = ACTIONS(2683),
    [anon_sym_L_DQUOTE] = ACTIONS(2683),
    [anon_sym_u_DQUOTE] = ACTIONS(2683),
    [anon_sym_U_DQUOTE] = ACTIONS(2683),
    [anon_sym_u8_DQUOTE] = ACTIONS(2683),
    [anon_sym_DQUOTE] = ACTIONS(2683),
    [sym_true] = ACTIONS(2681),
    [sym_false] = ACTIONS(2681),
    [anon_sym_NULL] = ACTIONS(2681),
    [anon_sym_nullptr] = ACTIONS(2681),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2681),
    [anon_sym_decltype] = ACTIONS(2681),
    [anon_sym_explicit] = ACTIONS(2681),
    [anon_sym_typename] = ACTIONS(2681),
    [anon_sym_template] = ACTIONS(2681),
    [anon_sym_operator] = ACTIONS(2681),
    [anon_sym_try] = ACTIONS(2681),
    [anon_sym_delete] = ACTIONS(2681),
    [anon_sym_throw] = ACTIONS(2681),
    [anon_sym_namespace] = ACTIONS(2681),
    [anon_sym_using] = ACTIONS(2681),
    [anon_sym_static_assert] = ACTIONS(2681),
    [anon_sym_concept] = ACTIONS(2681),
    [anon_sym_co_return] = ACTIONS(2681),
    [anon_sym_co_yield] = ACTIONS(2681),
    [anon_sym_R_DQUOTE] = ACTIONS(2683),
    [anon_sym_LR_DQUOTE] = ACTIONS(2683),
    [anon_sym_uR_DQUOTE] = ACTIONS(2683),
    [anon_sym_UR_DQUOTE] = ACTIONS(2683),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2683),
    [anon_sym_co_await] = ACTIONS(2681),
    [anon_sym_new] = ACTIONS(2681),
    [anon_sym_requires] = ACTIONS(2681),
    [sym_this] = ACTIONS(2681),
  },
  [518] = {
    [sym_identifier] = ACTIONS(2617),
    [aux_sym_preproc_include_token1] = ACTIONS(2617),
    [aux_sym_preproc_def_token1] = ACTIONS(2617),
    [aux_sym_preproc_if_token1] = ACTIONS(2617),
    [aux_sym_preproc_if_token2] = ACTIONS(2617),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2617),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2617),
    [sym_preproc_directive] = ACTIONS(2617),
    [anon_sym_LPAREN2] = ACTIONS(2619),
    [anon_sym_BANG] = ACTIONS(2619),
    [anon_sym_TILDE] = ACTIONS(2619),
    [anon_sym_DASH] = ACTIONS(2617),
    [anon_sym_PLUS] = ACTIONS(2617),
    [anon_sym_STAR] = ACTIONS(2619),
    [anon_sym_AMP_AMP] = ACTIONS(2619),
    [anon_sym_AMP] = ACTIONS(2617),
    [anon_sym_SEMI] = ACTIONS(2619),
    [anon_sym___extension__] = ACTIONS(2617),
    [anon_sym_typedef] = ACTIONS(2617),
    [anon_sym_virtual] = ACTIONS(2617),
    [anon_sym_extern] = ACTIONS(2617),
    [anon_sym___attribute__] = ACTIONS(2617),
    [anon_sym___attribute] = ACTIONS(2617),
    [anon_sym_COLON_COLON] = ACTIONS(2619),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2619),
    [anon_sym___declspec] = ACTIONS(2617),
    [anon_sym___based] = ACTIONS(2617),
    [anon_sym___cdecl] = ACTIONS(2617),
    [anon_sym___clrcall] = ACTIONS(2617),
    [anon_sym___stdcall] = ACTIONS(2617),
    [anon_sym___fastcall] = ACTIONS(2617),
    [anon_sym___thiscall] = ACTIONS(2617),
    [anon_sym___vectorcall] = ACTIONS(2617),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_signed] = ACTIONS(2617),
    [anon_sym_unsigned] = ACTIONS(2617),
    [anon_sym_long] = ACTIONS(2617),
    [anon_sym_short] = ACTIONS(2617),
    [anon_sym_LBRACK] = ACTIONS(2617),
    [anon_sym_static] = ACTIONS(2617),
    [anon_sym_register] = ACTIONS(2617),
    [anon_sym_inline] = ACTIONS(2617),
    [anon_sym___inline] = ACTIONS(2617),
    [anon_sym___inline__] = ACTIONS(2617),
    [anon_sym___forceinline] = ACTIONS(2617),
    [anon_sym_thread_local] = ACTIONS(2617),
    [anon_sym___thread] = ACTIONS(2617),
    [anon_sym_const] = ACTIONS(2617),
    [anon_sym_constexpr] = ACTIONS(2617),
    [anon_sym_volatile] = ACTIONS(2617),
    [anon_sym_restrict] = ACTIONS(2617),
    [anon_sym___restrict__] = ACTIONS(2617),
    [anon_sym__Atomic] = ACTIONS(2617),
    [anon_sym__Noreturn] = ACTIONS(2617),
    [anon_sym_noreturn] = ACTIONS(2617),
    [anon_sym__Nonnull] = ACTIONS(2617),
    [anon_sym_mutable] = ACTIONS(2617),
    [anon_sym_constinit] = ACTIONS(2617),
    [anon_sym_consteval] = ACTIONS(2617),
    [anon_sym_alignas] = ACTIONS(2617),
    [anon_sym__Alignas] = ACTIONS(2617),
    [sym_primitive_type] = ACTIONS(2617),
    [anon_sym_enum] = ACTIONS(2617),
    [anon_sym_class] = ACTIONS(2617),
    [anon_sym_struct] = ACTIONS(2617),
    [anon_sym_union] = ACTIONS(2617),
    [anon_sym_if] = ACTIONS(2617),
    [anon_sym_else] = ACTIONS(2617),
    [anon_sym_switch] = ACTIONS(2617),
    [anon_sym_case] = ACTIONS(2617),
    [anon_sym_default] = ACTIONS(2617),
    [anon_sym_while] = ACTIONS(2617),
    [anon_sym_do] = ACTIONS(2617),
    [anon_sym_for] = ACTIONS(2617),
    [anon_sym_return] = ACTIONS(2617),
    [anon_sym_break] = ACTIONS(2617),
    [anon_sym_continue] = ACTIONS(2617),
    [anon_sym_goto] = ACTIONS(2617),
    [anon_sym___try] = ACTIONS(2617),
    [anon_sym___leave] = ACTIONS(2617),
    [anon_sym_not] = ACTIONS(2617),
    [anon_sym_compl] = ACTIONS(2617),
    [anon_sym_DASH_DASH] = ACTIONS(2619),
    [anon_sym_PLUS_PLUS] = ACTIONS(2619),
    [anon_sym_sizeof] = ACTIONS(2617),
    [anon_sym___alignof__] = ACTIONS(2617),
    [anon_sym___alignof] = ACTIONS(2617),
    [anon_sym__alignof] = ACTIONS(2617),
    [anon_sym_alignof] = ACTIONS(2617),
    [anon_sym__Alignof] = ACTIONS(2617),
    [anon_sym_offsetof] = ACTIONS(2617),
    [anon_sym__Generic] = ACTIONS(2617),
    [anon_sym_asm] = ACTIONS(2617),
    [anon_sym___asm__] = ACTIONS(2617),
    [anon_sym___asm] = ACTIONS(2617),
    [sym_number_literal] = ACTIONS(2619),
    [anon_sym_L_SQUOTE] = ACTIONS(2619),
    [anon_sym_u_SQUOTE] = ACTIONS(2619),
    [anon_sym_U_SQUOTE] = ACTIONS(2619),
    [anon_sym_u8_SQUOTE] = ACTIONS(2619),
    [anon_sym_SQUOTE] = ACTIONS(2619),
    [anon_sym_L_DQUOTE] = ACTIONS(2619),
    [anon_sym_u_DQUOTE] = ACTIONS(2619),
    [anon_sym_U_DQUOTE] = ACTIONS(2619),
    [anon_sym_u8_DQUOTE] = ACTIONS(2619),
    [anon_sym_DQUOTE] = ACTIONS(2619),
    [sym_true] = ACTIONS(2617),
    [sym_false] = ACTIONS(2617),
    [anon_sym_NULL] = ACTIONS(2617),
    [anon_sym_nullptr] = ACTIONS(2617),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2617),
    [anon_sym_decltype] = ACTIONS(2617),
    [anon_sym_explicit] = ACTIONS(2617),
    [anon_sym_typename] = ACTIONS(2617),
    [anon_sym_template] = ACTIONS(2617),
    [anon_sym_operator] = ACTIONS(2617),
    [anon_sym_try] = ACTIONS(2617),
    [anon_sym_delete] = ACTIONS(2617),
    [anon_sym_throw] = ACTIONS(2617),
    [anon_sym_namespace] = ACTIONS(2617),
    [anon_sym_using] = ACTIONS(2617),
    [anon_sym_static_assert] = ACTIONS(2617),
    [anon_sym_concept] = ACTIONS(2617),
    [anon_sym_co_return] = ACTIONS(2617),
    [anon_sym_co_yield] = ACTIONS(2617),
    [anon_sym_R_DQUOTE] = ACTIONS(2619),
    [anon_sym_LR_DQUOTE] = ACTIONS(2619),
    [anon_sym_uR_DQUOTE] = ACTIONS(2619),
    [anon_sym_UR_DQUOTE] = ACTIONS(2619),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2619),
    [anon_sym_co_await] = ACTIONS(2617),
    [anon_sym_new] = ACTIONS(2617),
    [anon_sym_requires] = ACTIONS(2617),
    [sym_this] = ACTIONS(2617),
  },
  [519] = {
    [sym_identifier] = ACTIONS(2621),
    [aux_sym_preproc_include_token1] = ACTIONS(2621),
    [aux_sym_preproc_def_token1] = ACTIONS(2621),
    [aux_sym_preproc_if_token1] = ACTIONS(2621),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2621),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2621),
    [sym_preproc_directive] = ACTIONS(2621),
    [anon_sym_LPAREN2] = ACTIONS(2623),
    [anon_sym_BANG] = ACTIONS(2623),
    [anon_sym_TILDE] = ACTIONS(2623),
    [anon_sym_DASH] = ACTIONS(2621),
    [anon_sym_PLUS] = ACTIONS(2621),
    [anon_sym_STAR] = ACTIONS(2623),
    [anon_sym_AMP_AMP] = ACTIONS(2623),
    [anon_sym_AMP] = ACTIONS(2621),
    [anon_sym_SEMI] = ACTIONS(2623),
    [anon_sym___extension__] = ACTIONS(2621),
    [anon_sym_typedef] = ACTIONS(2621),
    [anon_sym_virtual] = ACTIONS(2621),
    [anon_sym_extern] = ACTIONS(2621),
    [anon_sym___attribute__] = ACTIONS(2621),
    [anon_sym___attribute] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(2623),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2623),
    [anon_sym___declspec] = ACTIONS(2621),
    [anon_sym___based] = ACTIONS(2621),
    [anon_sym___cdecl] = ACTIONS(2621),
    [anon_sym___clrcall] = ACTIONS(2621),
    [anon_sym___stdcall] = ACTIONS(2621),
    [anon_sym___fastcall] = ACTIONS(2621),
    [anon_sym___thiscall] = ACTIONS(2621),
    [anon_sym___vectorcall] = ACTIONS(2621),
    [anon_sym_LBRACE] = ACTIONS(2623),
    [anon_sym_RBRACE] = ACTIONS(2623),
    [anon_sym_signed] = ACTIONS(2621),
    [anon_sym_unsigned] = ACTIONS(2621),
    [anon_sym_long] = ACTIONS(2621),
    [anon_sym_short] = ACTIONS(2621),
    [anon_sym_LBRACK] = ACTIONS(2621),
    [anon_sym_static] = ACTIONS(2621),
    [anon_sym_register] = ACTIONS(2621),
    [anon_sym_inline] = ACTIONS(2621),
    [anon_sym___inline] = ACTIONS(2621),
    [anon_sym___inline__] = ACTIONS(2621),
    [anon_sym___forceinline] = ACTIONS(2621),
    [anon_sym_thread_local] = ACTIONS(2621),
    [anon_sym___thread] = ACTIONS(2621),
    [anon_sym_const] = ACTIONS(2621),
    [anon_sym_constexpr] = ACTIONS(2621),
    [anon_sym_volatile] = ACTIONS(2621),
    [anon_sym_restrict] = ACTIONS(2621),
    [anon_sym___restrict__] = ACTIONS(2621),
    [anon_sym__Atomic] = ACTIONS(2621),
    [anon_sym__Noreturn] = ACTIONS(2621),
    [anon_sym_noreturn] = ACTIONS(2621),
    [anon_sym__Nonnull] = ACTIONS(2621),
    [anon_sym_mutable] = ACTIONS(2621),
    [anon_sym_constinit] = ACTIONS(2621),
    [anon_sym_consteval] = ACTIONS(2621),
    [anon_sym_alignas] = ACTIONS(2621),
    [anon_sym__Alignas] = ACTIONS(2621),
    [sym_primitive_type] = ACTIONS(2621),
    [anon_sym_enum] = ACTIONS(2621),
    [anon_sym_class] = ACTIONS(2621),
    [anon_sym_struct] = ACTIONS(2621),
    [anon_sym_union] = ACTIONS(2621),
    [anon_sym_if] = ACTIONS(2621),
    [anon_sym_else] = ACTIONS(2621),
    [anon_sym_switch] = ACTIONS(2621),
    [anon_sym_case] = ACTIONS(2621),
    [anon_sym_default] = ACTIONS(2621),
    [anon_sym_while] = ACTIONS(2621),
    [anon_sym_do] = ACTIONS(2621),
    [anon_sym_for] = ACTIONS(2621),
    [anon_sym_return] = ACTIONS(2621),
    [anon_sym_break] = ACTIONS(2621),
    [anon_sym_continue] = ACTIONS(2621),
    [anon_sym_goto] = ACTIONS(2621),
    [anon_sym___try] = ACTIONS(2621),
    [anon_sym___leave] = ACTIONS(2621),
    [anon_sym_not] = ACTIONS(2621),
    [anon_sym_compl] = ACTIONS(2621),
    [anon_sym_DASH_DASH] = ACTIONS(2623),
    [anon_sym_PLUS_PLUS] = ACTIONS(2623),
    [anon_sym_sizeof] = ACTIONS(2621),
    [anon_sym___alignof__] = ACTIONS(2621),
    [anon_sym___alignof] = ACTIONS(2621),
    [anon_sym__alignof] = ACTIONS(2621),
    [anon_sym_alignof] = ACTIONS(2621),
    [anon_sym__Alignof] = ACTIONS(2621),
    [anon_sym_offsetof] = ACTIONS(2621),
    [anon_sym__Generic] = ACTIONS(2621),
    [anon_sym_asm] = ACTIONS(2621),
    [anon_sym___asm__] = ACTIONS(2621),
    [anon_sym___asm] = ACTIONS(2621),
    [sym_number_literal] = ACTIONS(2623),
    [anon_sym_L_SQUOTE] = ACTIONS(2623),
    [anon_sym_u_SQUOTE] = ACTIONS(2623),
    [anon_sym_U_SQUOTE] = ACTIONS(2623),
    [anon_sym_u8_SQUOTE] = ACTIONS(2623),
    [anon_sym_SQUOTE] = ACTIONS(2623),
    [anon_sym_L_DQUOTE] = ACTIONS(2623),
    [anon_sym_u_DQUOTE] = ACTIONS(2623),
    [anon_sym_U_DQUOTE] = ACTIONS(2623),
    [anon_sym_u8_DQUOTE] = ACTIONS(2623),
    [anon_sym_DQUOTE] = ACTIONS(2623),
    [sym_true] = ACTIONS(2621),
    [sym_false] = ACTIONS(2621),
    [anon_sym_NULL] = ACTIONS(2621),
    [anon_sym_nullptr] = ACTIONS(2621),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2621),
    [anon_sym_decltype] = ACTIONS(2621),
    [anon_sym_explicit] = ACTIONS(2621),
    [anon_sym_typename] = ACTIONS(2621),
    [anon_sym_template] = ACTIONS(2621),
    [anon_sym_operator] = ACTIONS(2621),
    [anon_sym_try] = ACTIONS(2621),
    [anon_sym_delete] = ACTIONS(2621),
    [anon_sym_throw] = ACTIONS(2621),
    [anon_sym_namespace] = ACTIONS(2621),
    [anon_sym_using] = ACTIONS(2621),
    [anon_sym_static_assert] = ACTIONS(2621),
    [anon_sym_concept] = ACTIONS(2621),
    [anon_sym_co_return] = ACTIONS(2621),
    [anon_sym_co_yield] = ACTIONS(2621),
    [anon_sym_R_DQUOTE] = ACTIONS(2623),
    [anon_sym_LR_DQUOTE] = ACTIONS(2623),
    [anon_sym_uR_DQUOTE] = ACTIONS(2623),
    [anon_sym_UR_DQUOTE] = ACTIONS(2623),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2623),
    [anon_sym_co_await] = ACTIONS(2621),
    [anon_sym_new] = ACTIONS(2621),
    [anon_sym_requires] = ACTIONS(2621),
    [sym_this] = ACTIONS(2621),
  },
  [520] = {
    [sym_identifier] = ACTIONS(2641),
    [aux_sym_preproc_include_token1] = ACTIONS(2641),
    [aux_sym_preproc_def_token1] = ACTIONS(2641),
    [aux_sym_preproc_if_token1] = ACTIONS(2641),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2641),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2641),
    [sym_preproc_directive] = ACTIONS(2641),
    [anon_sym_LPAREN2] = ACTIONS(2643),
    [anon_sym_BANG] = ACTIONS(2643),
    [anon_sym_TILDE] = ACTIONS(2643),
    [anon_sym_DASH] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(2641),
    [anon_sym_STAR] = ACTIONS(2643),
    [anon_sym_AMP_AMP] = ACTIONS(2643),
    [anon_sym_AMP] = ACTIONS(2641),
    [anon_sym_SEMI] = ACTIONS(2643),
    [anon_sym___extension__] = ACTIONS(2641),
    [anon_sym_typedef] = ACTIONS(2641),
    [anon_sym_virtual] = ACTIONS(2641),
    [anon_sym_extern] = ACTIONS(2641),
    [anon_sym___attribute__] = ACTIONS(2641),
    [anon_sym___attribute] = ACTIONS(2641),
    [anon_sym_COLON_COLON] = ACTIONS(2643),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2643),
    [anon_sym___declspec] = ACTIONS(2641),
    [anon_sym___based] = ACTIONS(2641),
    [anon_sym___cdecl] = ACTIONS(2641),
    [anon_sym___clrcall] = ACTIONS(2641),
    [anon_sym___stdcall] = ACTIONS(2641),
    [anon_sym___fastcall] = ACTIONS(2641),
    [anon_sym___thiscall] = ACTIONS(2641),
    [anon_sym___vectorcall] = ACTIONS(2641),
    [anon_sym_LBRACE] = ACTIONS(2643),
    [anon_sym_RBRACE] = ACTIONS(2643),
    [anon_sym_signed] = ACTIONS(2641),
    [anon_sym_unsigned] = ACTIONS(2641),
    [anon_sym_long] = ACTIONS(2641),
    [anon_sym_short] = ACTIONS(2641),
    [anon_sym_LBRACK] = ACTIONS(2641),
    [anon_sym_static] = ACTIONS(2641),
    [anon_sym_register] = ACTIONS(2641),
    [anon_sym_inline] = ACTIONS(2641),
    [anon_sym___inline] = ACTIONS(2641),
    [anon_sym___inline__] = ACTIONS(2641),
    [anon_sym___forceinline] = ACTIONS(2641),
    [anon_sym_thread_local] = ACTIONS(2641),
    [anon_sym___thread] = ACTIONS(2641),
    [anon_sym_const] = ACTIONS(2641),
    [anon_sym_constexpr] = ACTIONS(2641),
    [anon_sym_volatile] = ACTIONS(2641),
    [anon_sym_restrict] = ACTIONS(2641),
    [anon_sym___restrict__] = ACTIONS(2641),
    [anon_sym__Atomic] = ACTIONS(2641),
    [anon_sym__Noreturn] = ACTIONS(2641),
    [anon_sym_noreturn] = ACTIONS(2641),
    [anon_sym__Nonnull] = ACTIONS(2641),
    [anon_sym_mutable] = ACTIONS(2641),
    [anon_sym_constinit] = ACTIONS(2641),
    [anon_sym_consteval] = ACTIONS(2641),
    [anon_sym_alignas] = ACTIONS(2641),
    [anon_sym__Alignas] = ACTIONS(2641),
    [sym_primitive_type] = ACTIONS(2641),
    [anon_sym_enum] = ACTIONS(2641),
    [anon_sym_class] = ACTIONS(2641),
    [anon_sym_struct] = ACTIONS(2641),
    [anon_sym_union] = ACTIONS(2641),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_else] = ACTIONS(2641),
    [anon_sym_switch] = ACTIONS(2641),
    [anon_sym_case] = ACTIONS(2641),
    [anon_sym_default] = ACTIONS(2641),
    [anon_sym_while] = ACTIONS(2641),
    [anon_sym_do] = ACTIONS(2641),
    [anon_sym_for] = ACTIONS(2641),
    [anon_sym_return] = ACTIONS(2641),
    [anon_sym_break] = ACTIONS(2641),
    [anon_sym_continue] = ACTIONS(2641),
    [anon_sym_goto] = ACTIONS(2641),
    [anon_sym___try] = ACTIONS(2641),
    [anon_sym___leave] = ACTIONS(2641),
    [anon_sym_not] = ACTIONS(2641),
    [anon_sym_compl] = ACTIONS(2641),
    [anon_sym_DASH_DASH] = ACTIONS(2643),
    [anon_sym_PLUS_PLUS] = ACTIONS(2643),
    [anon_sym_sizeof] = ACTIONS(2641),
    [anon_sym___alignof__] = ACTIONS(2641),
    [anon_sym___alignof] = ACTIONS(2641),
    [anon_sym__alignof] = ACTIONS(2641),
    [anon_sym_alignof] = ACTIONS(2641),
    [anon_sym__Alignof] = ACTIONS(2641),
    [anon_sym_offsetof] = ACTIONS(2641),
    [anon_sym__Generic] = ACTIONS(2641),
    [anon_sym_asm] = ACTIONS(2641),
    [anon_sym___asm__] = ACTIONS(2641),
    [anon_sym___asm] = ACTIONS(2641),
    [sym_number_literal] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2643),
    [anon_sym_u_SQUOTE] = ACTIONS(2643),
    [anon_sym_U_SQUOTE] = ACTIONS(2643),
    [anon_sym_u8_SQUOTE] = ACTIONS(2643),
    [anon_sym_SQUOTE] = ACTIONS(2643),
    [anon_sym_L_DQUOTE] = ACTIONS(2643),
    [anon_sym_u_DQUOTE] = ACTIONS(2643),
    [anon_sym_U_DQUOTE] = ACTIONS(2643),
    [anon_sym_u8_DQUOTE] = ACTIONS(2643),
    [anon_sym_DQUOTE] = ACTIONS(2643),
    [sym_true] = ACTIONS(2641),
    [sym_false] = ACTIONS(2641),
    [anon_sym_NULL] = ACTIONS(2641),
    [anon_sym_nullptr] = ACTIONS(2641),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2641),
    [anon_sym_decltype] = ACTIONS(2641),
    [anon_sym_explicit] = ACTIONS(2641),
    [anon_sym_typename] = ACTIONS(2641),
    [anon_sym_template] = ACTIONS(2641),
    [anon_sym_operator] = ACTIONS(2641),
    [anon_sym_try] = ACTIONS(2641),
    [anon_sym_delete] = ACTIONS(2641),
    [anon_sym_throw] = ACTIONS(2641),
    [anon_sym_namespace] = ACTIONS(2641),
    [anon_sym_using] = ACTIONS(2641),
    [anon_sym_static_assert] = ACTIONS(2641),
    [anon_sym_concept] = ACTIONS(2641),
    [anon_sym_co_return] = ACTIONS(2641),
    [anon_sym_co_yield] = ACTIONS(2641),
    [anon_sym_R_DQUOTE] = ACTIONS(2643),
    [anon_sym_LR_DQUOTE] = ACTIONS(2643),
    [anon_sym_uR_DQUOTE] = ACTIONS(2643),
    [anon_sym_UR_DQUOTE] = ACTIONS(2643),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2643),
    [anon_sym_co_await] = ACTIONS(2641),
    [anon_sym_new] = ACTIONS(2641),
    [anon_sym_requires] = ACTIONS(2641),
    [sym_this] = ACTIONS(2641),
  },
  [521] = {
    [ts_builtin_sym_end] = ACTIONS(2725),
    [sym_identifier] = ACTIONS(2723),
    [aux_sym_preproc_include_token1] = ACTIONS(2723),
    [aux_sym_preproc_def_token1] = ACTIONS(2723),
    [aux_sym_preproc_if_token1] = ACTIONS(2723),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2723),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2723),
    [sym_preproc_directive] = ACTIONS(2723),
    [anon_sym_LPAREN2] = ACTIONS(2725),
    [anon_sym_BANG] = ACTIONS(2725),
    [anon_sym_TILDE] = ACTIONS(2725),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_STAR] = ACTIONS(2725),
    [anon_sym_AMP_AMP] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2723),
    [anon_sym_SEMI] = ACTIONS(2725),
    [anon_sym___extension__] = ACTIONS(2723),
    [anon_sym_typedef] = ACTIONS(2723),
    [anon_sym_virtual] = ACTIONS(2723),
    [anon_sym_extern] = ACTIONS(2723),
    [anon_sym___attribute__] = ACTIONS(2723),
    [anon_sym___attribute] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2725),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2725),
    [anon_sym___declspec] = ACTIONS(2723),
    [anon_sym___based] = ACTIONS(2723),
    [anon_sym___cdecl] = ACTIONS(2723),
    [anon_sym___clrcall] = ACTIONS(2723),
    [anon_sym___stdcall] = ACTIONS(2723),
    [anon_sym___fastcall] = ACTIONS(2723),
    [anon_sym___thiscall] = ACTIONS(2723),
    [anon_sym___vectorcall] = ACTIONS(2723),
    [anon_sym_LBRACE] = ACTIONS(2725),
    [anon_sym_signed] = ACTIONS(2723),
    [anon_sym_unsigned] = ACTIONS(2723),
    [anon_sym_long] = ACTIONS(2723),
    [anon_sym_short] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_static] = ACTIONS(2723),
    [anon_sym_register] = ACTIONS(2723),
    [anon_sym_inline] = ACTIONS(2723),
    [anon_sym___inline] = ACTIONS(2723),
    [anon_sym___inline__] = ACTIONS(2723),
    [anon_sym___forceinline] = ACTIONS(2723),
    [anon_sym_thread_local] = ACTIONS(2723),
    [anon_sym___thread] = ACTIONS(2723),
    [anon_sym_const] = ACTIONS(2723),
    [anon_sym_constexpr] = ACTIONS(2723),
    [anon_sym_volatile] = ACTIONS(2723),
    [anon_sym_restrict] = ACTIONS(2723),
    [anon_sym___restrict__] = ACTIONS(2723),
    [anon_sym__Atomic] = ACTIONS(2723),
    [anon_sym__Noreturn] = ACTIONS(2723),
    [anon_sym_noreturn] = ACTIONS(2723),
    [anon_sym__Nonnull] = ACTIONS(2723),
    [anon_sym_mutable] = ACTIONS(2723),
    [anon_sym_constinit] = ACTIONS(2723),
    [anon_sym_consteval] = ACTIONS(2723),
    [anon_sym_alignas] = ACTIONS(2723),
    [anon_sym__Alignas] = ACTIONS(2723),
    [sym_primitive_type] = ACTIONS(2723),
    [anon_sym_enum] = ACTIONS(2723),
    [anon_sym_class] = ACTIONS(2723),
    [anon_sym_struct] = ACTIONS(2723),
    [anon_sym_union] = ACTIONS(2723),
    [anon_sym_if] = ACTIONS(2723),
    [anon_sym_else] = ACTIONS(2723),
    [anon_sym_switch] = ACTIONS(2723),
    [anon_sym_case] = ACTIONS(2723),
    [anon_sym_default] = ACTIONS(2723),
    [anon_sym_while] = ACTIONS(2723),
    [anon_sym_do] = ACTIONS(2723),
    [anon_sym_for] = ACTIONS(2723),
    [anon_sym_return] = ACTIONS(2723),
    [anon_sym_break] = ACTIONS(2723),
    [anon_sym_continue] = ACTIONS(2723),
    [anon_sym_goto] = ACTIONS(2723),
    [anon_sym___try] = ACTIONS(2723),
    [anon_sym___leave] = ACTIONS(2723),
    [anon_sym_not] = ACTIONS(2723),
    [anon_sym_compl] = ACTIONS(2723),
    [anon_sym_DASH_DASH] = ACTIONS(2725),
    [anon_sym_PLUS_PLUS] = ACTIONS(2725),
    [anon_sym_sizeof] = ACTIONS(2723),
    [anon_sym___alignof__] = ACTIONS(2723),
    [anon_sym___alignof] = ACTIONS(2723),
    [anon_sym__alignof] = ACTIONS(2723),
    [anon_sym_alignof] = ACTIONS(2723),
    [anon_sym__Alignof] = ACTIONS(2723),
    [anon_sym_offsetof] = ACTIONS(2723),
    [anon_sym__Generic] = ACTIONS(2723),
    [anon_sym_asm] = ACTIONS(2723),
    [anon_sym___asm__] = ACTIONS(2723),
    [anon_sym___asm] = ACTIONS(2723),
    [sym_number_literal] = ACTIONS(2725),
    [anon_sym_L_SQUOTE] = ACTIONS(2725),
    [anon_sym_u_SQUOTE] = ACTIONS(2725),
    [anon_sym_U_SQUOTE] = ACTIONS(2725),
    [anon_sym_u8_SQUOTE] = ACTIONS(2725),
    [anon_sym_SQUOTE] = ACTIONS(2725),
    [anon_sym_L_DQUOTE] = ACTIONS(2725),
    [anon_sym_u_DQUOTE] = ACTIONS(2725),
    [anon_sym_U_DQUOTE] = ACTIONS(2725),
    [anon_sym_u8_DQUOTE] = ACTIONS(2725),
    [anon_sym_DQUOTE] = ACTIONS(2725),
    [sym_true] = ACTIONS(2723),
    [sym_false] = ACTIONS(2723),
    [anon_sym_NULL] = ACTIONS(2723),
    [anon_sym_nullptr] = ACTIONS(2723),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2723),
    [anon_sym_decltype] = ACTIONS(2723),
    [anon_sym_explicit] = ACTIONS(2723),
    [anon_sym_typename] = ACTIONS(2723),
    [anon_sym_template] = ACTIONS(2723),
    [anon_sym_operator] = ACTIONS(2723),
    [anon_sym_try] = ACTIONS(2723),
    [anon_sym_delete] = ACTIONS(2723),
    [anon_sym_throw] = ACTIONS(2723),
    [anon_sym_namespace] = ACTIONS(2723),
    [anon_sym_using] = ACTIONS(2723),
    [anon_sym_static_assert] = ACTIONS(2723),
    [anon_sym_concept] = ACTIONS(2723),
    [anon_sym_co_return] = ACTIONS(2723),
    [anon_sym_co_yield] = ACTIONS(2723),
    [anon_sym_R_DQUOTE] = ACTIONS(2725),
    [anon_sym_LR_DQUOTE] = ACTIONS(2725),
    [anon_sym_uR_DQUOTE] = ACTIONS(2725),
    [anon_sym_UR_DQUOTE] = ACTIONS(2725),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2725),
    [anon_sym_co_await] = ACTIONS(2723),
    [anon_sym_new] = ACTIONS(2723),
    [anon_sym_requires] = ACTIONS(2723),
    [sym_this] = ACTIONS(2723),
  },
  [522] = {
    [sym_identifier] = ACTIONS(2693),
    [aux_sym_preproc_include_token1] = ACTIONS(2693),
    [aux_sym_preproc_def_token1] = ACTIONS(2693),
    [aux_sym_preproc_if_token1] = ACTIONS(2693),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2693),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2693),
    [sym_preproc_directive] = ACTIONS(2693),
    [anon_sym_LPAREN2] = ACTIONS(2695),
    [anon_sym_BANG] = ACTIONS(2695),
    [anon_sym_TILDE] = ACTIONS(2695),
    [anon_sym_DASH] = ACTIONS(2693),
    [anon_sym_PLUS] = ACTIONS(2693),
    [anon_sym_STAR] = ACTIONS(2695),
    [anon_sym_AMP_AMP] = ACTIONS(2695),
    [anon_sym_AMP] = ACTIONS(2693),
    [anon_sym_SEMI] = ACTIONS(2695),
    [anon_sym___extension__] = ACTIONS(2693),
    [anon_sym_typedef] = ACTIONS(2693),
    [anon_sym_virtual] = ACTIONS(2693),
    [anon_sym_extern] = ACTIONS(2693),
    [anon_sym___attribute__] = ACTIONS(2693),
    [anon_sym___attribute] = ACTIONS(2693),
    [anon_sym_COLON_COLON] = ACTIONS(2695),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2695),
    [anon_sym___declspec] = ACTIONS(2693),
    [anon_sym___based] = ACTIONS(2693),
    [anon_sym___cdecl] = ACTIONS(2693),
    [anon_sym___clrcall] = ACTIONS(2693),
    [anon_sym___stdcall] = ACTIONS(2693),
    [anon_sym___fastcall] = ACTIONS(2693),
    [anon_sym___thiscall] = ACTIONS(2693),
    [anon_sym___vectorcall] = ACTIONS(2693),
    [anon_sym_LBRACE] = ACTIONS(2695),
    [anon_sym_RBRACE] = ACTIONS(2695),
    [anon_sym_signed] = ACTIONS(2693),
    [anon_sym_unsigned] = ACTIONS(2693),
    [anon_sym_long] = ACTIONS(2693),
    [anon_sym_short] = ACTIONS(2693),
    [anon_sym_LBRACK] = ACTIONS(2693),
    [anon_sym_static] = ACTIONS(2693),
    [anon_sym_register] = ACTIONS(2693),
    [anon_sym_inline] = ACTIONS(2693),
    [anon_sym___inline] = ACTIONS(2693),
    [anon_sym___inline__] = ACTIONS(2693),
    [anon_sym___forceinline] = ACTIONS(2693),
    [anon_sym_thread_local] = ACTIONS(2693),
    [anon_sym___thread] = ACTIONS(2693),
    [anon_sym_const] = ACTIONS(2693),
    [anon_sym_constexpr] = ACTIONS(2693),
    [anon_sym_volatile] = ACTIONS(2693),
    [anon_sym_restrict] = ACTIONS(2693),
    [anon_sym___restrict__] = ACTIONS(2693),
    [anon_sym__Atomic] = ACTIONS(2693),
    [anon_sym__Noreturn] = ACTIONS(2693),
    [anon_sym_noreturn] = ACTIONS(2693),
    [anon_sym__Nonnull] = ACTIONS(2693),
    [anon_sym_mutable] = ACTIONS(2693),
    [anon_sym_constinit] = ACTIONS(2693),
    [anon_sym_consteval] = ACTIONS(2693),
    [anon_sym_alignas] = ACTIONS(2693),
    [anon_sym__Alignas] = ACTIONS(2693),
    [sym_primitive_type] = ACTIONS(2693),
    [anon_sym_enum] = ACTIONS(2693),
    [anon_sym_class] = ACTIONS(2693),
    [anon_sym_struct] = ACTIONS(2693),
    [anon_sym_union] = ACTIONS(2693),
    [anon_sym_if] = ACTIONS(2693),
    [anon_sym_else] = ACTIONS(2693),
    [anon_sym_switch] = ACTIONS(2693),
    [anon_sym_case] = ACTIONS(2693),
    [anon_sym_default] = ACTIONS(2693),
    [anon_sym_while] = ACTIONS(2693),
    [anon_sym_do] = ACTIONS(2693),
    [anon_sym_for] = ACTIONS(2693),
    [anon_sym_return] = ACTIONS(2693),
    [anon_sym_break] = ACTIONS(2693),
    [anon_sym_continue] = ACTIONS(2693),
    [anon_sym_goto] = ACTIONS(2693),
    [anon_sym___try] = ACTIONS(2693),
    [anon_sym___leave] = ACTIONS(2693),
    [anon_sym_not] = ACTIONS(2693),
    [anon_sym_compl] = ACTIONS(2693),
    [anon_sym_DASH_DASH] = ACTIONS(2695),
    [anon_sym_PLUS_PLUS] = ACTIONS(2695),
    [anon_sym_sizeof] = ACTIONS(2693),
    [anon_sym___alignof__] = ACTIONS(2693),
    [anon_sym___alignof] = ACTIONS(2693),
    [anon_sym__alignof] = ACTIONS(2693),
    [anon_sym_alignof] = ACTIONS(2693),
    [anon_sym__Alignof] = ACTIONS(2693),
    [anon_sym_offsetof] = ACTIONS(2693),
    [anon_sym__Generic] = ACTIONS(2693),
    [anon_sym_asm] = ACTIONS(2693),
    [anon_sym___asm__] = ACTIONS(2693),
    [anon_sym___asm] = ACTIONS(2693),
    [sym_number_literal] = ACTIONS(2695),
    [anon_sym_L_SQUOTE] = ACTIONS(2695),
    [anon_sym_u_SQUOTE] = ACTIONS(2695),
    [anon_sym_U_SQUOTE] = ACTIONS(2695),
    [anon_sym_u8_SQUOTE] = ACTIONS(2695),
    [anon_sym_SQUOTE] = ACTIONS(2695),
    [anon_sym_L_DQUOTE] = ACTIONS(2695),
    [anon_sym_u_DQUOTE] = ACTIONS(2695),
    [anon_sym_U_DQUOTE] = ACTIONS(2695),
    [anon_sym_u8_DQUOTE] = ACTIONS(2695),
    [anon_sym_DQUOTE] = ACTIONS(2695),
    [sym_true] = ACTIONS(2693),
    [sym_false] = ACTIONS(2693),
    [anon_sym_NULL] = ACTIONS(2693),
    [anon_sym_nullptr] = ACTIONS(2693),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2693),
    [anon_sym_decltype] = ACTIONS(2693),
    [anon_sym_explicit] = ACTIONS(2693),
    [anon_sym_typename] = ACTIONS(2693),
    [anon_sym_template] = ACTIONS(2693),
    [anon_sym_operator] = ACTIONS(2693),
    [anon_sym_try] = ACTIONS(2693),
    [anon_sym_delete] = ACTIONS(2693),
    [anon_sym_throw] = ACTIONS(2693),
    [anon_sym_namespace] = ACTIONS(2693),
    [anon_sym_using] = ACTIONS(2693),
    [anon_sym_static_assert] = ACTIONS(2693),
    [anon_sym_concept] = ACTIONS(2693),
    [anon_sym_co_return] = ACTIONS(2693),
    [anon_sym_co_yield] = ACTIONS(2693),
    [anon_sym_R_DQUOTE] = ACTIONS(2695),
    [anon_sym_LR_DQUOTE] = ACTIONS(2695),
    [anon_sym_uR_DQUOTE] = ACTIONS(2695),
    [anon_sym_UR_DQUOTE] = ACTIONS(2695),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2695),
    [anon_sym_co_await] = ACTIONS(2693),
    [anon_sym_new] = ACTIONS(2693),
    [anon_sym_requires] = ACTIONS(2693),
    [sym_this] = ACTIONS(2693),
  },
  [523] = {
    [sym_identifier] = ACTIONS(2705),
    [aux_sym_preproc_include_token1] = ACTIONS(2705),
    [aux_sym_preproc_def_token1] = ACTIONS(2705),
    [aux_sym_preproc_if_token1] = ACTIONS(2705),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2705),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2705),
    [sym_preproc_directive] = ACTIONS(2705),
    [anon_sym_LPAREN2] = ACTIONS(2707),
    [anon_sym_BANG] = ACTIONS(2707),
    [anon_sym_TILDE] = ACTIONS(2707),
    [anon_sym_DASH] = ACTIONS(2705),
    [anon_sym_PLUS] = ACTIONS(2705),
    [anon_sym_STAR] = ACTIONS(2707),
    [anon_sym_AMP_AMP] = ACTIONS(2707),
    [anon_sym_AMP] = ACTIONS(2705),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym___extension__] = ACTIONS(2705),
    [anon_sym_typedef] = ACTIONS(2705),
    [anon_sym_virtual] = ACTIONS(2705),
    [anon_sym_extern] = ACTIONS(2705),
    [anon_sym___attribute__] = ACTIONS(2705),
    [anon_sym___attribute] = ACTIONS(2705),
    [anon_sym_COLON_COLON] = ACTIONS(2707),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2707),
    [anon_sym___declspec] = ACTIONS(2705),
    [anon_sym___based] = ACTIONS(2705),
    [anon_sym___cdecl] = ACTIONS(2705),
    [anon_sym___clrcall] = ACTIONS(2705),
    [anon_sym___stdcall] = ACTIONS(2705),
    [anon_sym___fastcall] = ACTIONS(2705),
    [anon_sym___thiscall] = ACTIONS(2705),
    [anon_sym___vectorcall] = ACTIONS(2705),
    [anon_sym_LBRACE] = ACTIONS(2707),
    [anon_sym_RBRACE] = ACTIONS(2707),
    [anon_sym_signed] = ACTIONS(2705),
    [anon_sym_unsigned] = ACTIONS(2705),
    [anon_sym_long] = ACTIONS(2705),
    [anon_sym_short] = ACTIONS(2705),
    [anon_sym_LBRACK] = ACTIONS(2705),
    [anon_sym_static] = ACTIONS(2705),
    [anon_sym_register] = ACTIONS(2705),
    [anon_sym_inline] = ACTIONS(2705),
    [anon_sym___inline] = ACTIONS(2705),
    [anon_sym___inline__] = ACTIONS(2705),
    [anon_sym___forceinline] = ACTIONS(2705),
    [anon_sym_thread_local] = ACTIONS(2705),
    [anon_sym___thread] = ACTIONS(2705),
    [anon_sym_const] = ACTIONS(2705),
    [anon_sym_constexpr] = ACTIONS(2705),
    [anon_sym_volatile] = ACTIONS(2705),
    [anon_sym_restrict] = ACTIONS(2705),
    [anon_sym___restrict__] = ACTIONS(2705),
    [anon_sym__Atomic] = ACTIONS(2705),
    [anon_sym__Noreturn] = ACTIONS(2705),
    [anon_sym_noreturn] = ACTIONS(2705),
    [anon_sym__Nonnull] = ACTIONS(2705),
    [anon_sym_mutable] = ACTIONS(2705),
    [anon_sym_constinit] = ACTIONS(2705),
    [anon_sym_consteval] = ACTIONS(2705),
    [anon_sym_alignas] = ACTIONS(2705),
    [anon_sym__Alignas] = ACTIONS(2705),
    [sym_primitive_type] = ACTIONS(2705),
    [anon_sym_enum] = ACTIONS(2705),
    [anon_sym_class] = ACTIONS(2705),
    [anon_sym_struct] = ACTIONS(2705),
    [anon_sym_union] = ACTIONS(2705),
    [anon_sym_if] = ACTIONS(2705),
    [anon_sym_else] = ACTIONS(2705),
    [anon_sym_switch] = ACTIONS(2705),
    [anon_sym_case] = ACTIONS(2705),
    [anon_sym_default] = ACTIONS(2705),
    [anon_sym_while] = ACTIONS(2705),
    [anon_sym_do] = ACTIONS(2705),
    [anon_sym_for] = ACTIONS(2705),
    [anon_sym_return] = ACTIONS(2705),
    [anon_sym_break] = ACTIONS(2705),
    [anon_sym_continue] = ACTIONS(2705),
    [anon_sym_goto] = ACTIONS(2705),
    [anon_sym___try] = ACTIONS(2705),
    [anon_sym___leave] = ACTIONS(2705),
    [anon_sym_not] = ACTIONS(2705),
    [anon_sym_compl] = ACTIONS(2705),
    [anon_sym_DASH_DASH] = ACTIONS(2707),
    [anon_sym_PLUS_PLUS] = ACTIONS(2707),
    [anon_sym_sizeof] = ACTIONS(2705),
    [anon_sym___alignof__] = ACTIONS(2705),
    [anon_sym___alignof] = ACTIONS(2705),
    [anon_sym__alignof] = ACTIONS(2705),
    [anon_sym_alignof] = ACTIONS(2705),
    [anon_sym__Alignof] = ACTIONS(2705),
    [anon_sym_offsetof] = ACTIONS(2705),
    [anon_sym__Generic] = ACTIONS(2705),
    [anon_sym_asm] = ACTIONS(2705),
    [anon_sym___asm__] = ACTIONS(2705),
    [anon_sym___asm] = ACTIONS(2705),
    [sym_number_literal] = ACTIONS(2707),
    [anon_sym_L_SQUOTE] = ACTIONS(2707),
    [anon_sym_u_SQUOTE] = ACTIONS(2707),
    [anon_sym_U_SQUOTE] = ACTIONS(2707),
    [anon_sym_u8_SQUOTE] = ACTIONS(2707),
    [anon_sym_SQUOTE] = ACTIONS(2707),
    [anon_sym_L_DQUOTE] = ACTIONS(2707),
    [anon_sym_u_DQUOTE] = ACTIONS(2707),
    [anon_sym_U_DQUOTE] = ACTIONS(2707),
    [anon_sym_u8_DQUOTE] = ACTIONS(2707),
    [anon_sym_DQUOTE] = ACTIONS(2707),
    [sym_true] = ACTIONS(2705),
    [sym_false] = ACTIONS(2705),
    [anon_sym_NULL] = ACTIONS(2705),
    [anon_sym_nullptr] = ACTIONS(2705),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2705),
    [anon_sym_decltype] = ACTIONS(2705),
    [anon_sym_explicit] = ACTIONS(2705),
    [anon_sym_typename] = ACTIONS(2705),
    [anon_sym_template] = ACTIONS(2705),
    [anon_sym_operator] = ACTIONS(2705),
    [anon_sym_try] = ACTIONS(2705),
    [anon_sym_delete] = ACTIONS(2705),
    [anon_sym_throw] = ACTIONS(2705),
    [anon_sym_namespace] = ACTIONS(2705),
    [anon_sym_using] = ACTIONS(2705),
    [anon_sym_static_assert] = ACTIONS(2705),
    [anon_sym_concept] = ACTIONS(2705),
    [anon_sym_co_return] = ACTIONS(2705),
    [anon_sym_co_yield] = ACTIONS(2705),
    [anon_sym_R_DQUOTE] = ACTIONS(2707),
    [anon_sym_LR_DQUOTE] = ACTIONS(2707),
    [anon_sym_uR_DQUOTE] = ACTIONS(2707),
    [anon_sym_UR_DQUOTE] = ACTIONS(2707),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2707),
    [anon_sym_co_await] = ACTIONS(2705),
    [anon_sym_new] = ACTIONS(2705),
    [anon_sym_requires] = ACTIONS(2705),
    [sym_this] = ACTIONS(2705),
  },
  [524] = {
    [sym_identifier] = ACTIONS(2713),
    [aux_sym_preproc_include_token1] = ACTIONS(2713),
    [aux_sym_preproc_def_token1] = ACTIONS(2713),
    [aux_sym_preproc_if_token1] = ACTIONS(2713),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2713),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2713),
    [sym_preproc_directive] = ACTIONS(2713),
    [anon_sym_LPAREN2] = ACTIONS(2715),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_STAR] = ACTIONS(2715),
    [anon_sym_AMP_AMP] = ACTIONS(2715),
    [anon_sym_AMP] = ACTIONS(2713),
    [anon_sym_SEMI] = ACTIONS(2715),
    [anon_sym___extension__] = ACTIONS(2713),
    [anon_sym_typedef] = ACTIONS(2713),
    [anon_sym_virtual] = ACTIONS(2713),
    [anon_sym_extern] = ACTIONS(2713),
    [anon_sym___attribute__] = ACTIONS(2713),
    [anon_sym___attribute] = ACTIONS(2713),
    [anon_sym_COLON_COLON] = ACTIONS(2715),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2715),
    [anon_sym___declspec] = ACTIONS(2713),
    [anon_sym___based] = ACTIONS(2713),
    [anon_sym___cdecl] = ACTIONS(2713),
    [anon_sym___clrcall] = ACTIONS(2713),
    [anon_sym___stdcall] = ACTIONS(2713),
    [anon_sym___fastcall] = ACTIONS(2713),
    [anon_sym___thiscall] = ACTIONS(2713),
    [anon_sym___vectorcall] = ACTIONS(2713),
    [anon_sym_LBRACE] = ACTIONS(2715),
    [anon_sym_RBRACE] = ACTIONS(2715),
    [anon_sym_signed] = ACTIONS(2713),
    [anon_sym_unsigned] = ACTIONS(2713),
    [anon_sym_long] = ACTIONS(2713),
    [anon_sym_short] = ACTIONS(2713),
    [anon_sym_LBRACK] = ACTIONS(2713),
    [anon_sym_static] = ACTIONS(2713),
    [anon_sym_register] = ACTIONS(2713),
    [anon_sym_inline] = ACTIONS(2713),
    [anon_sym___inline] = ACTIONS(2713),
    [anon_sym___inline__] = ACTIONS(2713),
    [anon_sym___forceinline] = ACTIONS(2713),
    [anon_sym_thread_local] = ACTIONS(2713),
    [anon_sym___thread] = ACTIONS(2713),
    [anon_sym_const] = ACTIONS(2713),
    [anon_sym_constexpr] = ACTIONS(2713),
    [anon_sym_volatile] = ACTIONS(2713),
    [anon_sym_restrict] = ACTIONS(2713),
    [anon_sym___restrict__] = ACTIONS(2713),
    [anon_sym__Atomic] = ACTIONS(2713),
    [anon_sym__Noreturn] = ACTIONS(2713),
    [anon_sym_noreturn] = ACTIONS(2713),
    [anon_sym__Nonnull] = ACTIONS(2713),
    [anon_sym_mutable] = ACTIONS(2713),
    [anon_sym_constinit] = ACTIONS(2713),
    [anon_sym_consteval] = ACTIONS(2713),
    [anon_sym_alignas] = ACTIONS(2713),
    [anon_sym__Alignas] = ACTIONS(2713),
    [sym_primitive_type] = ACTIONS(2713),
    [anon_sym_enum] = ACTIONS(2713),
    [anon_sym_class] = ACTIONS(2713),
    [anon_sym_struct] = ACTIONS(2713),
    [anon_sym_union] = ACTIONS(2713),
    [anon_sym_if] = ACTIONS(2713),
    [anon_sym_else] = ACTIONS(2713),
    [anon_sym_switch] = ACTIONS(2713),
    [anon_sym_case] = ACTIONS(2713),
    [anon_sym_default] = ACTIONS(2713),
    [anon_sym_while] = ACTIONS(2713),
    [anon_sym_do] = ACTIONS(2713),
    [anon_sym_for] = ACTIONS(2713),
    [anon_sym_return] = ACTIONS(2713),
    [anon_sym_break] = ACTIONS(2713),
    [anon_sym_continue] = ACTIONS(2713),
    [anon_sym_goto] = ACTIONS(2713),
    [anon_sym___try] = ACTIONS(2713),
    [anon_sym___leave] = ACTIONS(2713),
    [anon_sym_not] = ACTIONS(2713),
    [anon_sym_compl] = ACTIONS(2713),
    [anon_sym_DASH_DASH] = ACTIONS(2715),
    [anon_sym_PLUS_PLUS] = ACTIONS(2715),
    [anon_sym_sizeof] = ACTIONS(2713),
    [anon_sym___alignof__] = ACTIONS(2713),
    [anon_sym___alignof] = ACTIONS(2713),
    [anon_sym__alignof] = ACTIONS(2713),
    [anon_sym_alignof] = ACTIONS(2713),
    [anon_sym__Alignof] = ACTIONS(2713),
    [anon_sym_offsetof] = ACTIONS(2713),
    [anon_sym__Generic] = ACTIONS(2713),
    [anon_sym_asm] = ACTIONS(2713),
    [anon_sym___asm__] = ACTIONS(2713),
    [anon_sym___asm] = ACTIONS(2713),
    [sym_number_literal] = ACTIONS(2715),
    [anon_sym_L_SQUOTE] = ACTIONS(2715),
    [anon_sym_u_SQUOTE] = ACTIONS(2715),
    [anon_sym_U_SQUOTE] = ACTIONS(2715),
    [anon_sym_u8_SQUOTE] = ACTIONS(2715),
    [anon_sym_SQUOTE] = ACTIONS(2715),
    [anon_sym_L_DQUOTE] = ACTIONS(2715),
    [anon_sym_u_DQUOTE] = ACTIONS(2715),
    [anon_sym_U_DQUOTE] = ACTIONS(2715),
    [anon_sym_u8_DQUOTE] = ACTIONS(2715),
    [anon_sym_DQUOTE] = ACTIONS(2715),
    [sym_true] = ACTIONS(2713),
    [sym_false] = ACTIONS(2713),
    [anon_sym_NULL] = ACTIONS(2713),
    [anon_sym_nullptr] = ACTIONS(2713),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2713),
    [anon_sym_decltype] = ACTIONS(2713),
    [anon_sym_explicit] = ACTIONS(2713),
    [anon_sym_typename] = ACTIONS(2713),
    [anon_sym_template] = ACTIONS(2713),
    [anon_sym_operator] = ACTIONS(2713),
    [anon_sym_try] = ACTIONS(2713),
    [anon_sym_delete] = ACTIONS(2713),
    [anon_sym_throw] = ACTIONS(2713),
    [anon_sym_namespace] = ACTIONS(2713),
    [anon_sym_using] = ACTIONS(2713),
    [anon_sym_static_assert] = ACTIONS(2713),
    [anon_sym_concept] = ACTIONS(2713),
    [anon_sym_co_return] = ACTIONS(2713),
    [anon_sym_co_yield] = ACTIONS(2713),
    [anon_sym_R_DQUOTE] = ACTIONS(2715),
    [anon_sym_LR_DQUOTE] = ACTIONS(2715),
    [anon_sym_uR_DQUOTE] = ACTIONS(2715),
    [anon_sym_UR_DQUOTE] = ACTIONS(2715),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2715),
    [anon_sym_co_await] = ACTIONS(2713),
    [anon_sym_new] = ACTIONS(2713),
    [anon_sym_requires] = ACTIONS(2713),
    [sym_this] = ACTIONS(2713),
  },
  [525] = {
    [sym_identifier] = ACTIONS(2589),
    [aux_sym_preproc_include_token1] = ACTIONS(2589),
    [aux_sym_preproc_def_token1] = ACTIONS(2589),
    [aux_sym_preproc_if_token1] = ACTIONS(2589),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2589),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2589),
    [sym_preproc_directive] = ACTIONS(2589),
    [anon_sym_LPAREN2] = ACTIONS(2591),
    [anon_sym_BANG] = ACTIONS(2591),
    [anon_sym_TILDE] = ACTIONS(2591),
    [anon_sym_DASH] = ACTIONS(2589),
    [anon_sym_PLUS] = ACTIONS(2589),
    [anon_sym_STAR] = ACTIONS(2591),
    [anon_sym_AMP_AMP] = ACTIONS(2591),
    [anon_sym_AMP] = ACTIONS(2589),
    [anon_sym_SEMI] = ACTIONS(2591),
    [anon_sym___extension__] = ACTIONS(2589),
    [anon_sym_typedef] = ACTIONS(2589),
    [anon_sym_virtual] = ACTIONS(2589),
    [anon_sym_extern] = ACTIONS(2589),
    [anon_sym___attribute__] = ACTIONS(2589),
    [anon_sym___attribute] = ACTIONS(2589),
    [anon_sym_COLON_COLON] = ACTIONS(2591),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2591),
    [anon_sym___declspec] = ACTIONS(2589),
    [anon_sym___based] = ACTIONS(2589),
    [anon_sym___cdecl] = ACTIONS(2589),
    [anon_sym___clrcall] = ACTIONS(2589),
    [anon_sym___stdcall] = ACTIONS(2589),
    [anon_sym___fastcall] = ACTIONS(2589),
    [anon_sym___thiscall] = ACTIONS(2589),
    [anon_sym___vectorcall] = ACTIONS(2589),
    [anon_sym_LBRACE] = ACTIONS(2591),
    [anon_sym_RBRACE] = ACTIONS(2591),
    [anon_sym_signed] = ACTIONS(2589),
    [anon_sym_unsigned] = ACTIONS(2589),
    [anon_sym_long] = ACTIONS(2589),
    [anon_sym_short] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(2589),
    [anon_sym_static] = ACTIONS(2589),
    [anon_sym_register] = ACTIONS(2589),
    [anon_sym_inline] = ACTIONS(2589),
    [anon_sym___inline] = ACTIONS(2589),
    [anon_sym___inline__] = ACTIONS(2589),
    [anon_sym___forceinline] = ACTIONS(2589),
    [anon_sym_thread_local] = ACTIONS(2589),
    [anon_sym___thread] = ACTIONS(2589),
    [anon_sym_const] = ACTIONS(2589),
    [anon_sym_constexpr] = ACTIONS(2589),
    [anon_sym_volatile] = ACTIONS(2589),
    [anon_sym_restrict] = ACTIONS(2589),
    [anon_sym___restrict__] = ACTIONS(2589),
    [anon_sym__Atomic] = ACTIONS(2589),
    [anon_sym__Noreturn] = ACTIONS(2589),
    [anon_sym_noreturn] = ACTIONS(2589),
    [anon_sym__Nonnull] = ACTIONS(2589),
    [anon_sym_mutable] = ACTIONS(2589),
    [anon_sym_constinit] = ACTIONS(2589),
    [anon_sym_consteval] = ACTIONS(2589),
    [anon_sym_alignas] = ACTIONS(2589),
    [anon_sym__Alignas] = ACTIONS(2589),
    [sym_primitive_type] = ACTIONS(2589),
    [anon_sym_enum] = ACTIONS(2589),
    [anon_sym_class] = ACTIONS(2589),
    [anon_sym_struct] = ACTIONS(2589),
    [anon_sym_union] = ACTIONS(2589),
    [anon_sym_if] = ACTIONS(2589),
    [anon_sym_else] = ACTIONS(2589),
    [anon_sym_switch] = ACTIONS(2589),
    [anon_sym_case] = ACTIONS(2589),
    [anon_sym_default] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2589),
    [anon_sym_do] = ACTIONS(2589),
    [anon_sym_for] = ACTIONS(2589),
    [anon_sym_return] = ACTIONS(2589),
    [anon_sym_break] = ACTIONS(2589),
    [anon_sym_continue] = ACTIONS(2589),
    [anon_sym_goto] = ACTIONS(2589),
    [anon_sym___try] = ACTIONS(2589),
    [anon_sym___leave] = ACTIONS(2589),
    [anon_sym_not] = ACTIONS(2589),
    [anon_sym_compl] = ACTIONS(2589),
    [anon_sym_DASH_DASH] = ACTIONS(2591),
    [anon_sym_PLUS_PLUS] = ACTIONS(2591),
    [anon_sym_sizeof] = ACTIONS(2589),
    [anon_sym___alignof__] = ACTIONS(2589),
    [anon_sym___alignof] = ACTIONS(2589),
    [anon_sym__alignof] = ACTIONS(2589),
    [anon_sym_alignof] = ACTIONS(2589),
    [anon_sym__Alignof] = ACTIONS(2589),
    [anon_sym_offsetof] = ACTIONS(2589),
    [anon_sym__Generic] = ACTIONS(2589),
    [anon_sym_asm] = ACTIONS(2589),
    [anon_sym___asm__] = ACTIONS(2589),
    [anon_sym___asm] = ACTIONS(2589),
    [sym_number_literal] = ACTIONS(2591),
    [anon_sym_L_SQUOTE] = ACTIONS(2591),
    [anon_sym_u_SQUOTE] = ACTIONS(2591),
    [anon_sym_U_SQUOTE] = ACTIONS(2591),
    [anon_sym_u8_SQUOTE] = ACTIONS(2591),
    [anon_sym_SQUOTE] = ACTIONS(2591),
    [anon_sym_L_DQUOTE] = ACTIONS(2591),
    [anon_sym_u_DQUOTE] = ACTIONS(2591),
    [anon_sym_U_DQUOTE] = ACTIONS(2591),
    [anon_sym_u8_DQUOTE] = ACTIONS(2591),
    [anon_sym_DQUOTE] = ACTIONS(2591),
    [sym_true] = ACTIONS(2589),
    [sym_false] = ACTIONS(2589),
    [anon_sym_NULL] = ACTIONS(2589),
    [anon_sym_nullptr] = ACTIONS(2589),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2589),
    [anon_sym_decltype] = ACTIONS(2589),
    [anon_sym_explicit] = ACTIONS(2589),
    [anon_sym_typename] = ACTIONS(2589),
    [anon_sym_template] = ACTIONS(2589),
    [anon_sym_operator] = ACTIONS(2589),
    [anon_sym_try] = ACTIONS(2589),
    [anon_sym_delete] = ACTIONS(2589),
    [anon_sym_throw] = ACTIONS(2589),
    [anon_sym_namespace] = ACTIONS(2589),
    [anon_sym_using] = ACTIONS(2589),
    [anon_sym_static_assert] = ACTIONS(2589),
    [anon_sym_concept] = ACTIONS(2589),
    [anon_sym_co_return] = ACTIONS(2589),
    [anon_sym_co_yield] = ACTIONS(2589),
    [anon_sym_R_DQUOTE] = ACTIONS(2591),
    [anon_sym_LR_DQUOTE] = ACTIONS(2591),
    [anon_sym_uR_DQUOTE] = ACTIONS(2591),
    [anon_sym_UR_DQUOTE] = ACTIONS(2591),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2591),
    [anon_sym_co_await] = ACTIONS(2589),
    [anon_sym_new] = ACTIONS(2589),
    [anon_sym_requires] = ACTIONS(2589),
    [sym_this] = ACTIONS(2589),
  },
  [526] = {
    [sym_identifier] = ACTIONS(2597),
    [aux_sym_preproc_include_token1] = ACTIONS(2597),
    [aux_sym_preproc_def_token1] = ACTIONS(2597),
    [aux_sym_preproc_if_token1] = ACTIONS(2597),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2597),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2597),
    [sym_preproc_directive] = ACTIONS(2597),
    [anon_sym_LPAREN2] = ACTIONS(2599),
    [anon_sym_BANG] = ACTIONS(2599),
    [anon_sym_TILDE] = ACTIONS(2599),
    [anon_sym_DASH] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(2597),
    [anon_sym_STAR] = ACTIONS(2599),
    [anon_sym_AMP_AMP] = ACTIONS(2599),
    [anon_sym_AMP] = ACTIONS(2597),
    [anon_sym_SEMI] = ACTIONS(2599),
    [anon_sym___extension__] = ACTIONS(2597),
    [anon_sym_typedef] = ACTIONS(2597),
    [anon_sym_virtual] = ACTIONS(2597),
    [anon_sym_extern] = ACTIONS(2597),
    [anon_sym___attribute__] = ACTIONS(2597),
    [anon_sym___attribute] = ACTIONS(2597),
    [anon_sym_COLON_COLON] = ACTIONS(2599),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2599),
    [anon_sym___declspec] = ACTIONS(2597),
    [anon_sym___based] = ACTIONS(2597),
    [anon_sym___cdecl] = ACTIONS(2597),
    [anon_sym___clrcall] = ACTIONS(2597),
    [anon_sym___stdcall] = ACTIONS(2597),
    [anon_sym___fastcall] = ACTIONS(2597),
    [anon_sym___thiscall] = ACTIONS(2597),
    [anon_sym___vectorcall] = ACTIONS(2597),
    [anon_sym_LBRACE] = ACTIONS(2599),
    [anon_sym_RBRACE] = ACTIONS(2599),
    [anon_sym_signed] = ACTIONS(2597),
    [anon_sym_unsigned] = ACTIONS(2597),
    [anon_sym_long] = ACTIONS(2597),
    [anon_sym_short] = ACTIONS(2597),
    [anon_sym_LBRACK] = ACTIONS(2597),
    [anon_sym_static] = ACTIONS(2597),
    [anon_sym_register] = ACTIONS(2597),
    [anon_sym_inline] = ACTIONS(2597),
    [anon_sym___inline] = ACTIONS(2597),
    [anon_sym___inline__] = ACTIONS(2597),
    [anon_sym___forceinline] = ACTIONS(2597),
    [anon_sym_thread_local] = ACTIONS(2597),
    [anon_sym___thread] = ACTIONS(2597),
    [anon_sym_const] = ACTIONS(2597),
    [anon_sym_constexpr] = ACTIONS(2597),
    [anon_sym_volatile] = ACTIONS(2597),
    [anon_sym_restrict] = ACTIONS(2597),
    [anon_sym___restrict__] = ACTIONS(2597),
    [anon_sym__Atomic] = ACTIONS(2597),
    [anon_sym__Noreturn] = ACTIONS(2597),
    [anon_sym_noreturn] = ACTIONS(2597),
    [anon_sym__Nonnull] = ACTIONS(2597),
    [anon_sym_mutable] = ACTIONS(2597),
    [anon_sym_constinit] = ACTIONS(2597),
    [anon_sym_consteval] = ACTIONS(2597),
    [anon_sym_alignas] = ACTIONS(2597),
    [anon_sym__Alignas] = ACTIONS(2597),
    [sym_primitive_type] = ACTIONS(2597),
    [anon_sym_enum] = ACTIONS(2597),
    [anon_sym_class] = ACTIONS(2597),
    [anon_sym_struct] = ACTIONS(2597),
    [anon_sym_union] = ACTIONS(2597),
    [anon_sym_if] = ACTIONS(2597),
    [anon_sym_else] = ACTIONS(2597),
    [anon_sym_switch] = ACTIONS(2597),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_default] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2597),
    [anon_sym_do] = ACTIONS(2597),
    [anon_sym_for] = ACTIONS(2597),
    [anon_sym_return] = ACTIONS(2597),
    [anon_sym_break] = ACTIONS(2597),
    [anon_sym_continue] = ACTIONS(2597),
    [anon_sym_goto] = ACTIONS(2597),
    [anon_sym___try] = ACTIONS(2597),
    [anon_sym___leave] = ACTIONS(2597),
    [anon_sym_not] = ACTIONS(2597),
    [anon_sym_compl] = ACTIONS(2597),
    [anon_sym_DASH_DASH] = ACTIONS(2599),
    [anon_sym_PLUS_PLUS] = ACTIONS(2599),
    [anon_sym_sizeof] = ACTIONS(2597),
    [anon_sym___alignof__] = ACTIONS(2597),
    [anon_sym___alignof] = ACTIONS(2597),
    [anon_sym__alignof] = ACTIONS(2597),
    [anon_sym_alignof] = ACTIONS(2597),
    [anon_sym__Alignof] = ACTIONS(2597),
    [anon_sym_offsetof] = ACTIONS(2597),
    [anon_sym__Generic] = ACTIONS(2597),
    [anon_sym_asm] = ACTIONS(2597),
    [anon_sym___asm__] = ACTIONS(2597),
    [anon_sym___asm] = ACTIONS(2597),
    [sym_number_literal] = ACTIONS(2599),
    [anon_sym_L_SQUOTE] = ACTIONS(2599),
    [anon_sym_u_SQUOTE] = ACTIONS(2599),
    [anon_sym_U_SQUOTE] = ACTIONS(2599),
    [anon_sym_u8_SQUOTE] = ACTIONS(2599),
    [anon_sym_SQUOTE] = ACTIONS(2599),
    [anon_sym_L_DQUOTE] = ACTIONS(2599),
    [anon_sym_u_DQUOTE] = ACTIONS(2599),
    [anon_sym_U_DQUOTE] = ACTIONS(2599),
    [anon_sym_u8_DQUOTE] = ACTIONS(2599),
    [anon_sym_DQUOTE] = ACTIONS(2599),
    [sym_true] = ACTIONS(2597),
    [sym_false] = ACTIONS(2597),
    [anon_sym_NULL] = ACTIONS(2597),
    [anon_sym_nullptr] = ACTIONS(2597),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2597),
    [anon_sym_decltype] = ACTIONS(2597),
    [anon_sym_explicit] = ACTIONS(2597),
    [anon_sym_typename] = ACTIONS(2597),
    [anon_sym_template] = ACTIONS(2597),
    [anon_sym_operator] = ACTIONS(2597),
    [anon_sym_try] = ACTIONS(2597),
    [anon_sym_delete] = ACTIONS(2597),
    [anon_sym_throw] = ACTIONS(2597),
    [anon_sym_namespace] = ACTIONS(2597),
    [anon_sym_using] = ACTIONS(2597),
    [anon_sym_static_assert] = ACTIONS(2597),
    [anon_sym_concept] = ACTIONS(2597),
    [anon_sym_co_return] = ACTIONS(2597),
    [anon_sym_co_yield] = ACTIONS(2597),
    [anon_sym_R_DQUOTE] = ACTIONS(2599),
    [anon_sym_LR_DQUOTE] = ACTIONS(2599),
    [anon_sym_uR_DQUOTE] = ACTIONS(2599),
    [anon_sym_UR_DQUOTE] = ACTIONS(2599),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2599),
    [anon_sym_co_await] = ACTIONS(2597),
    [anon_sym_new] = ACTIONS(2597),
    [anon_sym_requires] = ACTIONS(2597),
    [sym_this] = ACTIONS(2597),
  },
  [527] = {
    [sym_identifier] = ACTIONS(2613),
    [aux_sym_preproc_include_token1] = ACTIONS(2613),
    [aux_sym_preproc_def_token1] = ACTIONS(2613),
    [aux_sym_preproc_if_token1] = ACTIONS(2613),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2613),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2613),
    [sym_preproc_directive] = ACTIONS(2613),
    [anon_sym_LPAREN2] = ACTIONS(2615),
    [anon_sym_BANG] = ACTIONS(2615),
    [anon_sym_TILDE] = ACTIONS(2615),
    [anon_sym_DASH] = ACTIONS(2613),
    [anon_sym_PLUS] = ACTIONS(2613),
    [anon_sym_STAR] = ACTIONS(2615),
    [anon_sym_AMP_AMP] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2613),
    [anon_sym_SEMI] = ACTIONS(2615),
    [anon_sym___extension__] = ACTIONS(2613),
    [anon_sym_typedef] = ACTIONS(2613),
    [anon_sym_virtual] = ACTIONS(2613),
    [anon_sym_extern] = ACTIONS(2613),
    [anon_sym___attribute__] = ACTIONS(2613),
    [anon_sym___attribute] = ACTIONS(2613),
    [anon_sym_COLON_COLON] = ACTIONS(2615),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2615),
    [anon_sym___declspec] = ACTIONS(2613),
    [anon_sym___based] = ACTIONS(2613),
    [anon_sym___cdecl] = ACTIONS(2613),
    [anon_sym___clrcall] = ACTIONS(2613),
    [anon_sym___stdcall] = ACTIONS(2613),
    [anon_sym___fastcall] = ACTIONS(2613),
    [anon_sym___thiscall] = ACTIONS(2613),
    [anon_sym___vectorcall] = ACTIONS(2613),
    [anon_sym_LBRACE] = ACTIONS(2615),
    [anon_sym_RBRACE] = ACTIONS(2615),
    [anon_sym_signed] = ACTIONS(2613),
    [anon_sym_unsigned] = ACTIONS(2613),
    [anon_sym_long] = ACTIONS(2613),
    [anon_sym_short] = ACTIONS(2613),
    [anon_sym_LBRACK] = ACTIONS(2613),
    [anon_sym_static] = ACTIONS(2613),
    [anon_sym_register] = ACTIONS(2613),
    [anon_sym_inline] = ACTIONS(2613),
    [anon_sym___inline] = ACTIONS(2613),
    [anon_sym___inline__] = ACTIONS(2613),
    [anon_sym___forceinline] = ACTIONS(2613),
    [anon_sym_thread_local] = ACTIONS(2613),
    [anon_sym___thread] = ACTIONS(2613),
    [anon_sym_const] = ACTIONS(2613),
    [anon_sym_constexpr] = ACTIONS(2613),
    [anon_sym_volatile] = ACTIONS(2613),
    [anon_sym_restrict] = ACTIONS(2613),
    [anon_sym___restrict__] = ACTIONS(2613),
    [anon_sym__Atomic] = ACTIONS(2613),
    [anon_sym__Noreturn] = ACTIONS(2613),
    [anon_sym_noreturn] = ACTIONS(2613),
    [anon_sym__Nonnull] = ACTIONS(2613),
    [anon_sym_mutable] = ACTIONS(2613),
    [anon_sym_constinit] = ACTIONS(2613),
    [anon_sym_consteval] = ACTIONS(2613),
    [anon_sym_alignas] = ACTIONS(2613),
    [anon_sym__Alignas] = ACTIONS(2613),
    [sym_primitive_type] = ACTIONS(2613),
    [anon_sym_enum] = ACTIONS(2613),
    [anon_sym_class] = ACTIONS(2613),
    [anon_sym_struct] = ACTIONS(2613),
    [anon_sym_union] = ACTIONS(2613),
    [anon_sym_if] = ACTIONS(2613),
    [anon_sym_else] = ACTIONS(2613),
    [anon_sym_switch] = ACTIONS(2613),
    [anon_sym_case] = ACTIONS(2613),
    [anon_sym_default] = ACTIONS(2613),
    [anon_sym_while] = ACTIONS(2613),
    [anon_sym_do] = ACTIONS(2613),
    [anon_sym_for] = ACTIONS(2613),
    [anon_sym_return] = ACTIONS(2613),
    [anon_sym_break] = ACTIONS(2613),
    [anon_sym_continue] = ACTIONS(2613),
    [anon_sym_goto] = ACTIONS(2613),
    [anon_sym___try] = ACTIONS(2613),
    [anon_sym___leave] = ACTIONS(2613),
    [anon_sym_not] = ACTIONS(2613),
    [anon_sym_compl] = ACTIONS(2613),
    [anon_sym_DASH_DASH] = ACTIONS(2615),
    [anon_sym_PLUS_PLUS] = ACTIONS(2615),
    [anon_sym_sizeof] = ACTIONS(2613),
    [anon_sym___alignof__] = ACTIONS(2613),
    [anon_sym___alignof] = ACTIONS(2613),
    [anon_sym__alignof] = ACTIONS(2613),
    [anon_sym_alignof] = ACTIONS(2613),
    [anon_sym__Alignof] = ACTIONS(2613),
    [anon_sym_offsetof] = ACTIONS(2613),
    [anon_sym__Generic] = ACTIONS(2613),
    [anon_sym_asm] = ACTIONS(2613),
    [anon_sym___asm__] = ACTIONS(2613),
    [anon_sym___asm] = ACTIONS(2613),
    [sym_number_literal] = ACTIONS(2615),
    [anon_sym_L_SQUOTE] = ACTIONS(2615),
    [anon_sym_u_SQUOTE] = ACTIONS(2615),
    [anon_sym_U_SQUOTE] = ACTIONS(2615),
    [anon_sym_u8_SQUOTE] = ACTIONS(2615),
    [anon_sym_SQUOTE] = ACTIONS(2615),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2613),
    [sym_false] = ACTIONS(2613),
    [anon_sym_NULL] = ACTIONS(2613),
    [anon_sym_nullptr] = ACTIONS(2613),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2613),
    [anon_sym_decltype] = ACTIONS(2613),
    [anon_sym_explicit] = ACTIONS(2613),
    [anon_sym_typename] = ACTIONS(2613),
    [anon_sym_template] = ACTIONS(2613),
    [anon_sym_operator] = ACTIONS(2613),
    [anon_sym_try] = ACTIONS(2613),
    [anon_sym_delete] = ACTIONS(2613),
    [anon_sym_throw] = ACTIONS(2613),
    [anon_sym_namespace] = ACTIONS(2613),
    [anon_sym_using] = ACTIONS(2613),
    [anon_sym_static_assert] = ACTIONS(2613),
    [anon_sym_concept] = ACTIONS(2613),
    [anon_sym_co_return] = ACTIONS(2613),
    [anon_sym_co_yield] = ACTIONS(2613),
    [anon_sym_R_DQUOTE] = ACTIONS(2615),
    [anon_sym_LR_DQUOTE] = ACTIONS(2615),
    [anon_sym_uR_DQUOTE] = ACTIONS(2615),
    [anon_sym_UR_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2615),
    [anon_sym_co_await] = ACTIONS(2613),
    [anon_sym_new] = ACTIONS(2613),
    [anon_sym_requires] = ACTIONS(2613),
    [sym_this] = ACTIONS(2613),
  },
  [528] = {
    [sym_identifier] = ACTIONS(2625),
    [aux_sym_preproc_include_token1] = ACTIONS(2625),
    [aux_sym_preproc_def_token1] = ACTIONS(2625),
    [aux_sym_preproc_if_token1] = ACTIONS(2625),
    [aux_sym_preproc_if_token2] = ACTIONS(2625),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2625),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2625),
    [sym_preproc_directive] = ACTIONS(2625),
    [anon_sym_LPAREN2] = ACTIONS(2627),
    [anon_sym_BANG] = ACTIONS(2627),
    [anon_sym_TILDE] = ACTIONS(2627),
    [anon_sym_DASH] = ACTIONS(2625),
    [anon_sym_PLUS] = ACTIONS(2625),
    [anon_sym_STAR] = ACTIONS(2627),
    [anon_sym_AMP_AMP] = ACTIONS(2627),
    [anon_sym_AMP] = ACTIONS(2625),
    [anon_sym_SEMI] = ACTIONS(2627),
    [anon_sym___extension__] = ACTIONS(2625),
    [anon_sym_typedef] = ACTIONS(2625),
    [anon_sym_virtual] = ACTIONS(2625),
    [anon_sym_extern] = ACTIONS(2625),
    [anon_sym___attribute__] = ACTIONS(2625),
    [anon_sym___attribute] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(2627),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2627),
    [anon_sym___declspec] = ACTIONS(2625),
    [anon_sym___based] = ACTIONS(2625),
    [anon_sym___cdecl] = ACTIONS(2625),
    [anon_sym___clrcall] = ACTIONS(2625),
    [anon_sym___stdcall] = ACTIONS(2625),
    [anon_sym___fastcall] = ACTIONS(2625),
    [anon_sym___thiscall] = ACTIONS(2625),
    [anon_sym___vectorcall] = ACTIONS(2625),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_signed] = ACTIONS(2625),
    [anon_sym_unsigned] = ACTIONS(2625),
    [anon_sym_long] = ACTIONS(2625),
    [anon_sym_short] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(2625),
    [anon_sym_static] = ACTIONS(2625),
    [anon_sym_register] = ACTIONS(2625),
    [anon_sym_inline] = ACTIONS(2625),
    [anon_sym___inline] = ACTIONS(2625),
    [anon_sym___inline__] = ACTIONS(2625),
    [anon_sym___forceinline] = ACTIONS(2625),
    [anon_sym_thread_local] = ACTIONS(2625),
    [anon_sym___thread] = ACTIONS(2625),
    [anon_sym_const] = ACTIONS(2625),
    [anon_sym_constexpr] = ACTIONS(2625),
    [anon_sym_volatile] = ACTIONS(2625),
    [anon_sym_restrict] = ACTIONS(2625),
    [anon_sym___restrict__] = ACTIONS(2625),
    [anon_sym__Atomic] = ACTIONS(2625),
    [anon_sym__Noreturn] = ACTIONS(2625),
    [anon_sym_noreturn] = ACTIONS(2625),
    [anon_sym__Nonnull] = ACTIONS(2625),
    [anon_sym_mutable] = ACTIONS(2625),
    [anon_sym_constinit] = ACTIONS(2625),
    [anon_sym_consteval] = ACTIONS(2625),
    [anon_sym_alignas] = ACTIONS(2625),
    [anon_sym__Alignas] = ACTIONS(2625),
    [sym_primitive_type] = ACTIONS(2625),
    [anon_sym_enum] = ACTIONS(2625),
    [anon_sym_class] = ACTIONS(2625),
    [anon_sym_struct] = ACTIONS(2625),
    [anon_sym_union] = ACTIONS(2625),
    [anon_sym_if] = ACTIONS(2625),
    [anon_sym_else] = ACTIONS(2625),
    [anon_sym_switch] = ACTIONS(2625),
    [anon_sym_case] = ACTIONS(2625),
    [anon_sym_default] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(2625),
    [anon_sym_do] = ACTIONS(2625),
    [anon_sym_for] = ACTIONS(2625),
    [anon_sym_return] = ACTIONS(2625),
    [anon_sym_break] = ACTIONS(2625),
    [anon_sym_continue] = ACTIONS(2625),
    [anon_sym_goto] = ACTIONS(2625),
    [anon_sym___try] = ACTIONS(2625),
    [anon_sym___leave] = ACTIONS(2625),
    [anon_sym_not] = ACTIONS(2625),
    [anon_sym_compl] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(2627),
    [anon_sym_PLUS_PLUS] = ACTIONS(2627),
    [anon_sym_sizeof] = ACTIONS(2625),
    [anon_sym___alignof__] = ACTIONS(2625),
    [anon_sym___alignof] = ACTIONS(2625),
    [anon_sym__alignof] = ACTIONS(2625),
    [anon_sym_alignof] = ACTIONS(2625),
    [anon_sym__Alignof] = ACTIONS(2625),
    [anon_sym_offsetof] = ACTIONS(2625),
    [anon_sym__Generic] = ACTIONS(2625),
    [anon_sym_asm] = ACTIONS(2625),
    [anon_sym___asm__] = ACTIONS(2625),
    [anon_sym___asm] = ACTIONS(2625),
    [sym_number_literal] = ACTIONS(2627),
    [anon_sym_L_SQUOTE] = ACTIONS(2627),
    [anon_sym_u_SQUOTE] = ACTIONS(2627),
    [anon_sym_U_SQUOTE] = ACTIONS(2627),
    [anon_sym_u8_SQUOTE] = ACTIONS(2627),
    [anon_sym_SQUOTE] = ACTIONS(2627),
    [anon_sym_L_DQUOTE] = ACTIONS(2627),
    [anon_sym_u_DQUOTE] = ACTIONS(2627),
    [anon_sym_U_DQUOTE] = ACTIONS(2627),
    [anon_sym_u8_DQUOTE] = ACTIONS(2627),
    [anon_sym_DQUOTE] = ACTIONS(2627),
    [sym_true] = ACTIONS(2625),
    [sym_false] = ACTIONS(2625),
    [anon_sym_NULL] = ACTIONS(2625),
    [anon_sym_nullptr] = ACTIONS(2625),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2625),
    [anon_sym_decltype] = ACTIONS(2625),
    [anon_sym_explicit] = ACTIONS(2625),
    [anon_sym_typename] = ACTIONS(2625),
    [anon_sym_template] = ACTIONS(2625),
    [anon_sym_operator] = ACTIONS(2625),
    [anon_sym_try] = ACTIONS(2625),
    [anon_sym_delete] = ACTIONS(2625),
    [anon_sym_throw] = ACTIONS(2625),
    [anon_sym_namespace] = ACTIONS(2625),
    [anon_sym_using] = ACTIONS(2625),
    [anon_sym_static_assert] = ACTIONS(2625),
    [anon_sym_concept] = ACTIONS(2625),
    [anon_sym_co_return] = ACTIONS(2625),
    [anon_sym_co_yield] = ACTIONS(2625),
    [anon_sym_R_DQUOTE] = ACTIONS(2627),
    [anon_sym_LR_DQUOTE] = ACTIONS(2627),
    [anon_sym_uR_DQUOTE] = ACTIONS(2627),
    [anon_sym_UR_DQUOTE] = ACTIONS(2627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2627),
    [anon_sym_co_await] = ACTIONS(2625),
    [anon_sym_new] = ACTIONS(2625),
    [anon_sym_requires] = ACTIONS(2625),
    [sym_this] = ACTIONS(2625),
  },
  [529] = {
    [ts_builtin_sym_end] = ACTIONS(2591),
    [sym_identifier] = ACTIONS(2589),
    [aux_sym_preproc_include_token1] = ACTIONS(2589),
    [aux_sym_preproc_def_token1] = ACTIONS(2589),
    [aux_sym_preproc_if_token1] = ACTIONS(2589),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2589),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2589),
    [sym_preproc_directive] = ACTIONS(2589),
    [anon_sym_LPAREN2] = ACTIONS(2591),
    [anon_sym_BANG] = ACTIONS(2591),
    [anon_sym_TILDE] = ACTIONS(2591),
    [anon_sym_DASH] = ACTIONS(2589),
    [anon_sym_PLUS] = ACTIONS(2589),
    [anon_sym_STAR] = ACTIONS(2591),
    [anon_sym_AMP_AMP] = ACTIONS(2591),
    [anon_sym_AMP] = ACTIONS(2589),
    [anon_sym_SEMI] = ACTIONS(2591),
    [anon_sym___extension__] = ACTIONS(2589),
    [anon_sym_typedef] = ACTIONS(2589),
    [anon_sym_virtual] = ACTIONS(2589),
    [anon_sym_extern] = ACTIONS(2589),
    [anon_sym___attribute__] = ACTIONS(2589),
    [anon_sym___attribute] = ACTIONS(2589),
    [anon_sym_COLON_COLON] = ACTIONS(2591),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2591),
    [anon_sym___declspec] = ACTIONS(2589),
    [anon_sym___based] = ACTIONS(2589),
    [anon_sym___cdecl] = ACTIONS(2589),
    [anon_sym___clrcall] = ACTIONS(2589),
    [anon_sym___stdcall] = ACTIONS(2589),
    [anon_sym___fastcall] = ACTIONS(2589),
    [anon_sym___thiscall] = ACTIONS(2589),
    [anon_sym___vectorcall] = ACTIONS(2589),
    [anon_sym_LBRACE] = ACTIONS(2591),
    [anon_sym_signed] = ACTIONS(2589),
    [anon_sym_unsigned] = ACTIONS(2589),
    [anon_sym_long] = ACTIONS(2589),
    [anon_sym_short] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(2589),
    [anon_sym_static] = ACTIONS(2589),
    [anon_sym_register] = ACTIONS(2589),
    [anon_sym_inline] = ACTIONS(2589),
    [anon_sym___inline] = ACTIONS(2589),
    [anon_sym___inline__] = ACTIONS(2589),
    [anon_sym___forceinline] = ACTIONS(2589),
    [anon_sym_thread_local] = ACTIONS(2589),
    [anon_sym___thread] = ACTIONS(2589),
    [anon_sym_const] = ACTIONS(2589),
    [anon_sym_constexpr] = ACTIONS(2589),
    [anon_sym_volatile] = ACTIONS(2589),
    [anon_sym_restrict] = ACTIONS(2589),
    [anon_sym___restrict__] = ACTIONS(2589),
    [anon_sym__Atomic] = ACTIONS(2589),
    [anon_sym__Noreturn] = ACTIONS(2589),
    [anon_sym_noreturn] = ACTIONS(2589),
    [anon_sym__Nonnull] = ACTIONS(2589),
    [anon_sym_mutable] = ACTIONS(2589),
    [anon_sym_constinit] = ACTIONS(2589),
    [anon_sym_consteval] = ACTIONS(2589),
    [anon_sym_alignas] = ACTIONS(2589),
    [anon_sym__Alignas] = ACTIONS(2589),
    [sym_primitive_type] = ACTIONS(2589),
    [anon_sym_enum] = ACTIONS(2589),
    [anon_sym_class] = ACTIONS(2589),
    [anon_sym_struct] = ACTIONS(2589),
    [anon_sym_union] = ACTIONS(2589),
    [anon_sym_if] = ACTIONS(2589),
    [anon_sym_else] = ACTIONS(2589),
    [anon_sym_switch] = ACTIONS(2589),
    [anon_sym_case] = ACTIONS(2589),
    [anon_sym_default] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2589),
    [anon_sym_do] = ACTIONS(2589),
    [anon_sym_for] = ACTIONS(2589),
    [anon_sym_return] = ACTIONS(2589),
    [anon_sym_break] = ACTIONS(2589),
    [anon_sym_continue] = ACTIONS(2589),
    [anon_sym_goto] = ACTIONS(2589),
    [anon_sym___try] = ACTIONS(2589),
    [anon_sym___leave] = ACTIONS(2589),
    [anon_sym_not] = ACTIONS(2589),
    [anon_sym_compl] = ACTIONS(2589),
    [anon_sym_DASH_DASH] = ACTIONS(2591),
    [anon_sym_PLUS_PLUS] = ACTIONS(2591),
    [anon_sym_sizeof] = ACTIONS(2589),
    [anon_sym___alignof__] = ACTIONS(2589),
    [anon_sym___alignof] = ACTIONS(2589),
    [anon_sym__alignof] = ACTIONS(2589),
    [anon_sym_alignof] = ACTIONS(2589),
    [anon_sym__Alignof] = ACTIONS(2589),
    [anon_sym_offsetof] = ACTIONS(2589),
    [anon_sym__Generic] = ACTIONS(2589),
    [anon_sym_asm] = ACTIONS(2589),
    [anon_sym___asm__] = ACTIONS(2589),
    [anon_sym___asm] = ACTIONS(2589),
    [sym_number_literal] = ACTIONS(2591),
    [anon_sym_L_SQUOTE] = ACTIONS(2591),
    [anon_sym_u_SQUOTE] = ACTIONS(2591),
    [anon_sym_U_SQUOTE] = ACTIONS(2591),
    [anon_sym_u8_SQUOTE] = ACTIONS(2591),
    [anon_sym_SQUOTE] = ACTIONS(2591),
    [anon_sym_L_DQUOTE] = ACTIONS(2591),
    [anon_sym_u_DQUOTE] = ACTIONS(2591),
    [anon_sym_U_DQUOTE] = ACTIONS(2591),
    [anon_sym_u8_DQUOTE] = ACTIONS(2591),
    [anon_sym_DQUOTE] = ACTIONS(2591),
    [sym_true] = ACTIONS(2589),
    [sym_false] = ACTIONS(2589),
    [anon_sym_NULL] = ACTIONS(2589),
    [anon_sym_nullptr] = ACTIONS(2589),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2589),
    [anon_sym_decltype] = ACTIONS(2589),
    [anon_sym_explicit] = ACTIONS(2589),
    [anon_sym_typename] = ACTIONS(2589),
    [anon_sym_template] = ACTIONS(2589),
    [anon_sym_operator] = ACTIONS(2589),
    [anon_sym_try] = ACTIONS(2589),
    [anon_sym_delete] = ACTIONS(2589),
    [anon_sym_throw] = ACTIONS(2589),
    [anon_sym_namespace] = ACTIONS(2589),
    [anon_sym_using] = ACTIONS(2589),
    [anon_sym_static_assert] = ACTIONS(2589),
    [anon_sym_concept] = ACTIONS(2589),
    [anon_sym_co_return] = ACTIONS(2589),
    [anon_sym_co_yield] = ACTIONS(2589),
    [anon_sym_R_DQUOTE] = ACTIONS(2591),
    [anon_sym_LR_DQUOTE] = ACTIONS(2591),
    [anon_sym_uR_DQUOTE] = ACTIONS(2591),
    [anon_sym_UR_DQUOTE] = ACTIONS(2591),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2591),
    [anon_sym_co_await] = ACTIONS(2589),
    [anon_sym_new] = ACTIONS(2589),
    [anon_sym_requires] = ACTIONS(2589),
    [sym_this] = ACTIONS(2589),
  },
  [530] = {
    [sym_identifier] = ACTIONS(1913),
    [aux_sym_preproc_include_token1] = ACTIONS(1913),
    [aux_sym_preproc_def_token1] = ACTIONS(1913),
    [anon_sym_COMMA] = ACTIONS(2721),
    [aux_sym_preproc_if_token1] = ACTIONS(1913),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1913),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1913),
    [sym_preproc_directive] = ACTIONS(1913),
    [anon_sym_LPAREN2] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_DASH] = ACTIONS(1913),
    [anon_sym_PLUS] = ACTIONS(1913),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_AMP_AMP] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1913),
    [anon_sym_SEMI] = ACTIONS(2721),
    [anon_sym___extension__] = ACTIONS(1913),
    [anon_sym_typedef] = ACTIONS(1913),
    [anon_sym_virtual] = ACTIONS(1913),
    [anon_sym_extern] = ACTIONS(1913),
    [anon_sym___attribute__] = ACTIONS(1913),
    [anon_sym___attribute] = ACTIONS(1913),
    [anon_sym_COLON_COLON] = ACTIONS(1911),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1911),
    [anon_sym___declspec] = ACTIONS(1913),
    [anon_sym___based] = ACTIONS(1913),
    [anon_sym___cdecl] = ACTIONS(1913),
    [anon_sym___clrcall] = ACTIONS(1913),
    [anon_sym___stdcall] = ACTIONS(1913),
    [anon_sym___fastcall] = ACTIONS(1913),
    [anon_sym___thiscall] = ACTIONS(1913),
    [anon_sym___vectorcall] = ACTIONS(1913),
    [anon_sym_LBRACE] = ACTIONS(1911),
    [anon_sym_RBRACE] = ACTIONS(1911),
    [anon_sym_signed] = ACTIONS(1913),
    [anon_sym_unsigned] = ACTIONS(1913),
    [anon_sym_long] = ACTIONS(1913),
    [anon_sym_short] = ACTIONS(1913),
    [anon_sym_LBRACK] = ACTIONS(1913),
    [anon_sym_static] = ACTIONS(1913),
    [anon_sym_register] = ACTIONS(1913),
    [anon_sym_inline] = ACTIONS(1913),
    [anon_sym___inline] = ACTIONS(1913),
    [anon_sym___inline__] = ACTIONS(1913),
    [anon_sym___forceinline] = ACTIONS(1913),
    [anon_sym_thread_local] = ACTIONS(1913),
    [anon_sym___thread] = ACTIONS(1913),
    [anon_sym_const] = ACTIONS(1913),
    [anon_sym_constexpr] = ACTIONS(1913),
    [anon_sym_volatile] = ACTIONS(1913),
    [anon_sym_restrict] = ACTIONS(1913),
    [anon_sym___restrict__] = ACTIONS(1913),
    [anon_sym__Atomic] = ACTIONS(1913),
    [anon_sym__Noreturn] = ACTIONS(1913),
    [anon_sym_noreturn] = ACTIONS(1913),
    [anon_sym__Nonnull] = ACTIONS(1913),
    [anon_sym_mutable] = ACTIONS(1913),
    [anon_sym_constinit] = ACTIONS(1913),
    [anon_sym_consteval] = ACTIONS(1913),
    [anon_sym_alignas] = ACTIONS(1913),
    [anon_sym__Alignas] = ACTIONS(1913),
    [sym_primitive_type] = ACTIONS(1913),
    [anon_sym_enum] = ACTIONS(1913),
    [anon_sym_class] = ACTIONS(1913),
    [anon_sym_struct] = ACTIONS(1913),
    [anon_sym_union] = ACTIONS(1913),
    [anon_sym_if] = ACTIONS(1913),
    [anon_sym_switch] = ACTIONS(1913),
    [anon_sym_case] = ACTIONS(1913),
    [anon_sym_default] = ACTIONS(1913),
    [anon_sym_while] = ACTIONS(1913),
    [anon_sym_do] = ACTIONS(1913),
    [anon_sym_for] = ACTIONS(1913),
    [anon_sym_return] = ACTIONS(1913),
    [anon_sym_break] = ACTIONS(1913),
    [anon_sym_continue] = ACTIONS(1913),
    [anon_sym_goto] = ACTIONS(1913),
    [anon_sym___try] = ACTIONS(1913),
    [anon_sym___leave] = ACTIONS(1913),
    [anon_sym_not] = ACTIONS(1913),
    [anon_sym_compl] = ACTIONS(1913),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_sizeof] = ACTIONS(1913),
    [anon_sym___alignof__] = ACTIONS(1913),
    [anon_sym___alignof] = ACTIONS(1913),
    [anon_sym__alignof] = ACTIONS(1913),
    [anon_sym_alignof] = ACTIONS(1913),
    [anon_sym__Alignof] = ACTIONS(1913),
    [anon_sym_offsetof] = ACTIONS(1913),
    [anon_sym__Generic] = ACTIONS(1913),
    [anon_sym_asm] = ACTIONS(1913),
    [anon_sym___asm__] = ACTIONS(1913),
    [anon_sym___asm] = ACTIONS(1913),
    [sym_number_literal] = ACTIONS(1911),
    [anon_sym_L_SQUOTE] = ACTIONS(1911),
    [anon_sym_u_SQUOTE] = ACTIONS(1911),
    [anon_sym_U_SQUOTE] = ACTIONS(1911),
    [anon_sym_u8_SQUOTE] = ACTIONS(1911),
    [anon_sym_SQUOTE] = ACTIONS(1911),
    [anon_sym_L_DQUOTE] = ACTIONS(1911),
    [anon_sym_u_DQUOTE] = ACTIONS(1911),
    [anon_sym_U_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8_DQUOTE] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(1911),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1913),
    [anon_sym_nullptr] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1913),
    [anon_sym_decltype] = ACTIONS(1913),
    [anon_sym_explicit] = ACTIONS(1913),
    [anon_sym_typename] = ACTIONS(1913),
    [anon_sym_template] = ACTIONS(1913),
    [anon_sym_operator] = ACTIONS(1913),
    [anon_sym_try] = ACTIONS(1913),
    [anon_sym_delete] = ACTIONS(1913),
    [anon_sym_throw] = ACTIONS(1913),
    [anon_sym_namespace] = ACTIONS(1913),
    [anon_sym_using] = ACTIONS(1913),
    [anon_sym_static_assert] = ACTIONS(1913),
    [anon_sym_concept] = ACTIONS(1913),
    [anon_sym_co_return] = ACTIONS(1913),
    [anon_sym_co_yield] = ACTIONS(1913),
    [anon_sym_R_DQUOTE] = ACTIONS(1911),
    [anon_sym_LR_DQUOTE] = ACTIONS(1911),
    [anon_sym_uR_DQUOTE] = ACTIONS(1911),
    [anon_sym_UR_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1911),
    [anon_sym_co_await] = ACTIONS(1913),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_requires] = ACTIONS(1913),
    [sym_this] = ACTIONS(1913),
  },
  [531] = {
    [sym_identifier] = ACTIONS(2601),
    [aux_sym_preproc_include_token1] = ACTIONS(2601),
    [aux_sym_preproc_def_token1] = ACTIONS(2601),
    [aux_sym_preproc_if_token1] = ACTIONS(2601),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2601),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2601),
    [sym_preproc_directive] = ACTIONS(2601),
    [anon_sym_LPAREN2] = ACTIONS(2603),
    [anon_sym_BANG] = ACTIONS(2603),
    [anon_sym_TILDE] = ACTIONS(2603),
    [anon_sym_DASH] = ACTIONS(2601),
    [anon_sym_PLUS] = ACTIONS(2601),
    [anon_sym_STAR] = ACTIONS(2603),
    [anon_sym_AMP_AMP] = ACTIONS(2603),
    [anon_sym_AMP] = ACTIONS(2601),
    [anon_sym_SEMI] = ACTIONS(2603),
    [anon_sym___extension__] = ACTIONS(2601),
    [anon_sym_typedef] = ACTIONS(2601),
    [anon_sym_virtual] = ACTIONS(2601),
    [anon_sym_extern] = ACTIONS(2601),
    [anon_sym___attribute__] = ACTIONS(2601),
    [anon_sym___attribute] = ACTIONS(2601),
    [anon_sym_COLON_COLON] = ACTIONS(2603),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2603),
    [anon_sym___declspec] = ACTIONS(2601),
    [anon_sym___based] = ACTIONS(2601),
    [anon_sym___cdecl] = ACTIONS(2601),
    [anon_sym___clrcall] = ACTIONS(2601),
    [anon_sym___stdcall] = ACTIONS(2601),
    [anon_sym___fastcall] = ACTIONS(2601),
    [anon_sym___thiscall] = ACTIONS(2601),
    [anon_sym___vectorcall] = ACTIONS(2601),
    [anon_sym_LBRACE] = ACTIONS(2603),
    [anon_sym_RBRACE] = ACTIONS(2603),
    [anon_sym_signed] = ACTIONS(2601),
    [anon_sym_unsigned] = ACTIONS(2601),
    [anon_sym_long] = ACTIONS(2601),
    [anon_sym_short] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2601),
    [anon_sym_static] = ACTIONS(2601),
    [anon_sym_register] = ACTIONS(2601),
    [anon_sym_inline] = ACTIONS(2601),
    [anon_sym___inline] = ACTIONS(2601),
    [anon_sym___inline__] = ACTIONS(2601),
    [anon_sym___forceinline] = ACTIONS(2601),
    [anon_sym_thread_local] = ACTIONS(2601),
    [anon_sym___thread] = ACTIONS(2601),
    [anon_sym_const] = ACTIONS(2601),
    [anon_sym_constexpr] = ACTIONS(2601),
    [anon_sym_volatile] = ACTIONS(2601),
    [anon_sym_restrict] = ACTIONS(2601),
    [anon_sym___restrict__] = ACTIONS(2601),
    [anon_sym__Atomic] = ACTIONS(2601),
    [anon_sym__Noreturn] = ACTIONS(2601),
    [anon_sym_noreturn] = ACTIONS(2601),
    [anon_sym__Nonnull] = ACTIONS(2601),
    [anon_sym_mutable] = ACTIONS(2601),
    [anon_sym_constinit] = ACTIONS(2601),
    [anon_sym_consteval] = ACTIONS(2601),
    [anon_sym_alignas] = ACTIONS(2601),
    [anon_sym__Alignas] = ACTIONS(2601),
    [sym_primitive_type] = ACTIONS(2601),
    [anon_sym_enum] = ACTIONS(2601),
    [anon_sym_class] = ACTIONS(2601),
    [anon_sym_struct] = ACTIONS(2601),
    [anon_sym_union] = ACTIONS(2601),
    [anon_sym_if] = ACTIONS(2601),
    [anon_sym_else] = ACTIONS(2601),
    [anon_sym_switch] = ACTIONS(2601),
    [anon_sym_case] = ACTIONS(2601),
    [anon_sym_default] = ACTIONS(2601),
    [anon_sym_while] = ACTIONS(2601),
    [anon_sym_do] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2601),
    [anon_sym_return] = ACTIONS(2601),
    [anon_sym_break] = ACTIONS(2601),
    [anon_sym_continue] = ACTIONS(2601),
    [anon_sym_goto] = ACTIONS(2601),
    [anon_sym___try] = ACTIONS(2601),
    [anon_sym___leave] = ACTIONS(2601),
    [anon_sym_not] = ACTIONS(2601),
    [anon_sym_compl] = ACTIONS(2601),
    [anon_sym_DASH_DASH] = ACTIONS(2603),
    [anon_sym_PLUS_PLUS] = ACTIONS(2603),
    [anon_sym_sizeof] = ACTIONS(2601),
    [anon_sym___alignof__] = ACTIONS(2601),
    [anon_sym___alignof] = ACTIONS(2601),
    [anon_sym__alignof] = ACTIONS(2601),
    [anon_sym_alignof] = ACTIONS(2601),
    [anon_sym__Alignof] = ACTIONS(2601),
    [anon_sym_offsetof] = ACTIONS(2601),
    [anon_sym__Generic] = ACTIONS(2601),
    [anon_sym_asm] = ACTIONS(2601),
    [anon_sym___asm__] = ACTIONS(2601),
    [anon_sym___asm] = ACTIONS(2601),
    [sym_number_literal] = ACTIONS(2603),
    [anon_sym_L_SQUOTE] = ACTIONS(2603),
    [anon_sym_u_SQUOTE] = ACTIONS(2603),
    [anon_sym_U_SQUOTE] = ACTIONS(2603),
    [anon_sym_u8_SQUOTE] = ACTIONS(2603),
    [anon_sym_SQUOTE] = ACTIONS(2603),
    [anon_sym_L_DQUOTE] = ACTIONS(2603),
    [anon_sym_u_DQUOTE] = ACTIONS(2603),
    [anon_sym_U_DQUOTE] = ACTIONS(2603),
    [anon_sym_u8_DQUOTE] = ACTIONS(2603),
    [anon_sym_DQUOTE] = ACTIONS(2603),
    [sym_true] = ACTIONS(2601),
    [sym_false] = ACTIONS(2601),
    [anon_sym_NULL] = ACTIONS(2601),
    [anon_sym_nullptr] = ACTIONS(2601),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2601),
    [anon_sym_decltype] = ACTIONS(2601),
    [anon_sym_explicit] = ACTIONS(2601),
    [anon_sym_typename] = ACTIONS(2601),
    [anon_sym_template] = ACTIONS(2601),
    [anon_sym_operator] = ACTIONS(2601),
    [anon_sym_try] = ACTIONS(2601),
    [anon_sym_delete] = ACTIONS(2601),
    [anon_sym_throw] = ACTIONS(2601),
    [anon_sym_namespace] = ACTIONS(2601),
    [anon_sym_using] = ACTIONS(2601),
    [anon_sym_static_assert] = ACTIONS(2601),
    [anon_sym_concept] = ACTIONS(2601),
    [anon_sym_co_return] = ACTIONS(2601),
    [anon_sym_co_yield] = ACTIONS(2601),
    [anon_sym_R_DQUOTE] = ACTIONS(2603),
    [anon_sym_LR_DQUOTE] = ACTIONS(2603),
    [anon_sym_uR_DQUOTE] = ACTIONS(2603),
    [anon_sym_UR_DQUOTE] = ACTIONS(2603),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2603),
    [anon_sym_co_await] = ACTIONS(2601),
    [anon_sym_new] = ACTIONS(2601),
    [anon_sym_requires] = ACTIONS(2601),
    [sym_this] = ACTIONS(2601),
  },
  [532] = {
    [sym_identifier] = ACTIONS(2605),
    [aux_sym_preproc_include_token1] = ACTIONS(2605),
    [aux_sym_preproc_def_token1] = ACTIONS(2605),
    [aux_sym_preproc_if_token1] = ACTIONS(2605),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2605),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2605),
    [sym_preproc_directive] = ACTIONS(2605),
    [anon_sym_LPAREN2] = ACTIONS(2607),
    [anon_sym_BANG] = ACTIONS(2607),
    [anon_sym_TILDE] = ACTIONS(2607),
    [anon_sym_DASH] = ACTIONS(2605),
    [anon_sym_PLUS] = ACTIONS(2605),
    [anon_sym_STAR] = ACTIONS(2607),
    [anon_sym_AMP_AMP] = ACTIONS(2607),
    [anon_sym_AMP] = ACTIONS(2605),
    [anon_sym_SEMI] = ACTIONS(2607),
    [anon_sym___extension__] = ACTIONS(2605),
    [anon_sym_typedef] = ACTIONS(2605),
    [anon_sym_virtual] = ACTIONS(2605),
    [anon_sym_extern] = ACTIONS(2605),
    [anon_sym___attribute__] = ACTIONS(2605),
    [anon_sym___attribute] = ACTIONS(2605),
    [anon_sym_COLON_COLON] = ACTIONS(2607),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2607),
    [anon_sym___declspec] = ACTIONS(2605),
    [anon_sym___based] = ACTIONS(2605),
    [anon_sym___cdecl] = ACTIONS(2605),
    [anon_sym___clrcall] = ACTIONS(2605),
    [anon_sym___stdcall] = ACTIONS(2605),
    [anon_sym___fastcall] = ACTIONS(2605),
    [anon_sym___thiscall] = ACTIONS(2605),
    [anon_sym___vectorcall] = ACTIONS(2605),
    [anon_sym_LBRACE] = ACTIONS(2607),
    [anon_sym_RBRACE] = ACTIONS(2607),
    [anon_sym_signed] = ACTIONS(2605),
    [anon_sym_unsigned] = ACTIONS(2605),
    [anon_sym_long] = ACTIONS(2605),
    [anon_sym_short] = ACTIONS(2605),
    [anon_sym_LBRACK] = ACTIONS(2605),
    [anon_sym_static] = ACTIONS(2605),
    [anon_sym_register] = ACTIONS(2605),
    [anon_sym_inline] = ACTIONS(2605),
    [anon_sym___inline] = ACTIONS(2605),
    [anon_sym___inline__] = ACTIONS(2605),
    [anon_sym___forceinline] = ACTIONS(2605),
    [anon_sym_thread_local] = ACTIONS(2605),
    [anon_sym___thread] = ACTIONS(2605),
    [anon_sym_const] = ACTIONS(2605),
    [anon_sym_constexpr] = ACTIONS(2605),
    [anon_sym_volatile] = ACTIONS(2605),
    [anon_sym_restrict] = ACTIONS(2605),
    [anon_sym___restrict__] = ACTIONS(2605),
    [anon_sym__Atomic] = ACTIONS(2605),
    [anon_sym__Noreturn] = ACTIONS(2605),
    [anon_sym_noreturn] = ACTIONS(2605),
    [anon_sym__Nonnull] = ACTIONS(2605),
    [anon_sym_mutable] = ACTIONS(2605),
    [anon_sym_constinit] = ACTIONS(2605),
    [anon_sym_consteval] = ACTIONS(2605),
    [anon_sym_alignas] = ACTIONS(2605),
    [anon_sym__Alignas] = ACTIONS(2605),
    [sym_primitive_type] = ACTIONS(2605),
    [anon_sym_enum] = ACTIONS(2605),
    [anon_sym_class] = ACTIONS(2605),
    [anon_sym_struct] = ACTIONS(2605),
    [anon_sym_union] = ACTIONS(2605),
    [anon_sym_if] = ACTIONS(2605),
    [anon_sym_else] = ACTIONS(2605),
    [anon_sym_switch] = ACTIONS(2605),
    [anon_sym_case] = ACTIONS(2605),
    [anon_sym_default] = ACTIONS(2605),
    [anon_sym_while] = ACTIONS(2605),
    [anon_sym_do] = ACTIONS(2605),
    [anon_sym_for] = ACTIONS(2605),
    [anon_sym_return] = ACTIONS(2605),
    [anon_sym_break] = ACTIONS(2605),
    [anon_sym_continue] = ACTIONS(2605),
    [anon_sym_goto] = ACTIONS(2605),
    [anon_sym___try] = ACTIONS(2605),
    [anon_sym___leave] = ACTIONS(2605),
    [anon_sym_not] = ACTIONS(2605),
    [anon_sym_compl] = ACTIONS(2605),
    [anon_sym_DASH_DASH] = ACTIONS(2607),
    [anon_sym_PLUS_PLUS] = ACTIONS(2607),
    [anon_sym_sizeof] = ACTIONS(2605),
    [anon_sym___alignof__] = ACTIONS(2605),
    [anon_sym___alignof] = ACTIONS(2605),
    [anon_sym__alignof] = ACTIONS(2605),
    [anon_sym_alignof] = ACTIONS(2605),
    [anon_sym__Alignof] = ACTIONS(2605),
    [anon_sym_offsetof] = ACTIONS(2605),
    [anon_sym__Generic] = ACTIONS(2605),
    [anon_sym_asm] = ACTIONS(2605),
    [anon_sym___asm__] = ACTIONS(2605),
    [anon_sym___asm] = ACTIONS(2605),
    [sym_number_literal] = ACTIONS(2607),
    [anon_sym_L_SQUOTE] = ACTIONS(2607),
    [anon_sym_u_SQUOTE] = ACTIONS(2607),
    [anon_sym_U_SQUOTE] = ACTIONS(2607),
    [anon_sym_u8_SQUOTE] = ACTIONS(2607),
    [anon_sym_SQUOTE] = ACTIONS(2607),
    [anon_sym_L_DQUOTE] = ACTIONS(2607),
    [anon_sym_u_DQUOTE] = ACTIONS(2607),
    [anon_sym_U_DQUOTE] = ACTIONS(2607),
    [anon_sym_u8_DQUOTE] = ACTIONS(2607),
    [anon_sym_DQUOTE] = ACTIONS(2607),
    [sym_true] = ACTIONS(2605),
    [sym_false] = ACTIONS(2605),
    [anon_sym_NULL] = ACTIONS(2605),
    [anon_sym_nullptr] = ACTIONS(2605),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2605),
    [anon_sym_decltype] = ACTIONS(2605),
    [anon_sym_explicit] = ACTIONS(2605),
    [anon_sym_typename] = ACTIONS(2605),
    [anon_sym_template] = ACTIONS(2605),
    [anon_sym_operator] = ACTIONS(2605),
    [anon_sym_try] = ACTIONS(2605),
    [anon_sym_delete] = ACTIONS(2605),
    [anon_sym_throw] = ACTIONS(2605),
    [anon_sym_namespace] = ACTIONS(2605),
    [anon_sym_using] = ACTIONS(2605),
    [anon_sym_static_assert] = ACTIONS(2605),
    [anon_sym_concept] = ACTIONS(2605),
    [anon_sym_co_return] = ACTIONS(2605),
    [anon_sym_co_yield] = ACTIONS(2605),
    [anon_sym_R_DQUOTE] = ACTIONS(2607),
    [anon_sym_LR_DQUOTE] = ACTIONS(2607),
    [anon_sym_uR_DQUOTE] = ACTIONS(2607),
    [anon_sym_UR_DQUOTE] = ACTIONS(2607),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2607),
    [anon_sym_co_await] = ACTIONS(2605),
    [anon_sym_new] = ACTIONS(2605),
    [anon_sym_requires] = ACTIONS(2605),
    [sym_this] = ACTIONS(2605),
  },
  [533] = {
    [sym_identifier] = ACTIONS(2609),
    [aux_sym_preproc_include_token1] = ACTIONS(2609),
    [aux_sym_preproc_def_token1] = ACTIONS(2609),
    [aux_sym_preproc_if_token1] = ACTIONS(2609),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2609),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2609),
    [sym_preproc_directive] = ACTIONS(2609),
    [anon_sym_LPAREN2] = ACTIONS(2611),
    [anon_sym_BANG] = ACTIONS(2611),
    [anon_sym_TILDE] = ACTIONS(2611),
    [anon_sym_DASH] = ACTIONS(2609),
    [anon_sym_PLUS] = ACTIONS(2609),
    [anon_sym_STAR] = ACTIONS(2611),
    [anon_sym_AMP_AMP] = ACTIONS(2611),
    [anon_sym_AMP] = ACTIONS(2609),
    [anon_sym_SEMI] = ACTIONS(2611),
    [anon_sym___extension__] = ACTIONS(2609),
    [anon_sym_typedef] = ACTIONS(2609),
    [anon_sym_virtual] = ACTIONS(2609),
    [anon_sym_extern] = ACTIONS(2609),
    [anon_sym___attribute__] = ACTIONS(2609),
    [anon_sym___attribute] = ACTIONS(2609),
    [anon_sym_COLON_COLON] = ACTIONS(2611),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2611),
    [anon_sym___declspec] = ACTIONS(2609),
    [anon_sym___based] = ACTIONS(2609),
    [anon_sym___cdecl] = ACTIONS(2609),
    [anon_sym___clrcall] = ACTIONS(2609),
    [anon_sym___stdcall] = ACTIONS(2609),
    [anon_sym___fastcall] = ACTIONS(2609),
    [anon_sym___thiscall] = ACTIONS(2609),
    [anon_sym___vectorcall] = ACTIONS(2609),
    [anon_sym_LBRACE] = ACTIONS(2611),
    [anon_sym_RBRACE] = ACTIONS(2611),
    [anon_sym_signed] = ACTIONS(2609),
    [anon_sym_unsigned] = ACTIONS(2609),
    [anon_sym_long] = ACTIONS(2609),
    [anon_sym_short] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(2609),
    [anon_sym_static] = ACTIONS(2609),
    [anon_sym_register] = ACTIONS(2609),
    [anon_sym_inline] = ACTIONS(2609),
    [anon_sym___inline] = ACTIONS(2609),
    [anon_sym___inline__] = ACTIONS(2609),
    [anon_sym___forceinline] = ACTIONS(2609),
    [anon_sym_thread_local] = ACTIONS(2609),
    [anon_sym___thread] = ACTIONS(2609),
    [anon_sym_const] = ACTIONS(2609),
    [anon_sym_constexpr] = ACTIONS(2609),
    [anon_sym_volatile] = ACTIONS(2609),
    [anon_sym_restrict] = ACTIONS(2609),
    [anon_sym___restrict__] = ACTIONS(2609),
    [anon_sym__Atomic] = ACTIONS(2609),
    [anon_sym__Noreturn] = ACTIONS(2609),
    [anon_sym_noreturn] = ACTIONS(2609),
    [anon_sym__Nonnull] = ACTIONS(2609),
    [anon_sym_mutable] = ACTIONS(2609),
    [anon_sym_constinit] = ACTIONS(2609),
    [anon_sym_consteval] = ACTIONS(2609),
    [anon_sym_alignas] = ACTIONS(2609),
    [anon_sym__Alignas] = ACTIONS(2609),
    [sym_primitive_type] = ACTIONS(2609),
    [anon_sym_enum] = ACTIONS(2609),
    [anon_sym_class] = ACTIONS(2609),
    [anon_sym_struct] = ACTIONS(2609),
    [anon_sym_union] = ACTIONS(2609),
    [anon_sym_if] = ACTIONS(2609),
    [anon_sym_else] = ACTIONS(2609),
    [anon_sym_switch] = ACTIONS(2609),
    [anon_sym_case] = ACTIONS(2609),
    [anon_sym_default] = ACTIONS(2609),
    [anon_sym_while] = ACTIONS(2609),
    [anon_sym_do] = ACTIONS(2609),
    [anon_sym_for] = ACTIONS(2609),
    [anon_sym_return] = ACTIONS(2609),
    [anon_sym_break] = ACTIONS(2609),
    [anon_sym_continue] = ACTIONS(2609),
    [anon_sym_goto] = ACTIONS(2609),
    [anon_sym___try] = ACTIONS(2609),
    [anon_sym___leave] = ACTIONS(2609),
    [anon_sym_not] = ACTIONS(2609),
    [anon_sym_compl] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(2611),
    [anon_sym_PLUS_PLUS] = ACTIONS(2611),
    [anon_sym_sizeof] = ACTIONS(2609),
    [anon_sym___alignof__] = ACTIONS(2609),
    [anon_sym___alignof] = ACTIONS(2609),
    [anon_sym__alignof] = ACTIONS(2609),
    [anon_sym_alignof] = ACTIONS(2609),
    [anon_sym__Alignof] = ACTIONS(2609),
    [anon_sym_offsetof] = ACTIONS(2609),
    [anon_sym__Generic] = ACTIONS(2609),
    [anon_sym_asm] = ACTIONS(2609),
    [anon_sym___asm__] = ACTIONS(2609),
    [anon_sym___asm] = ACTIONS(2609),
    [sym_number_literal] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2611),
    [anon_sym_u_SQUOTE] = ACTIONS(2611),
    [anon_sym_U_SQUOTE] = ACTIONS(2611),
    [anon_sym_u8_SQUOTE] = ACTIONS(2611),
    [anon_sym_SQUOTE] = ACTIONS(2611),
    [anon_sym_L_DQUOTE] = ACTIONS(2611),
    [anon_sym_u_DQUOTE] = ACTIONS(2611),
    [anon_sym_U_DQUOTE] = ACTIONS(2611),
    [anon_sym_u8_DQUOTE] = ACTIONS(2611),
    [anon_sym_DQUOTE] = ACTIONS(2611),
    [sym_true] = ACTIONS(2609),
    [sym_false] = ACTIONS(2609),
    [anon_sym_NULL] = ACTIONS(2609),
    [anon_sym_nullptr] = ACTIONS(2609),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2609),
    [anon_sym_decltype] = ACTIONS(2609),
    [anon_sym_explicit] = ACTIONS(2609),
    [anon_sym_typename] = ACTIONS(2609),
    [anon_sym_template] = ACTIONS(2609),
    [anon_sym_operator] = ACTIONS(2609),
    [anon_sym_try] = ACTIONS(2609),
    [anon_sym_delete] = ACTIONS(2609),
    [anon_sym_throw] = ACTIONS(2609),
    [anon_sym_namespace] = ACTIONS(2609),
    [anon_sym_using] = ACTIONS(2609),
    [anon_sym_static_assert] = ACTIONS(2609),
    [anon_sym_concept] = ACTIONS(2609),
    [anon_sym_co_return] = ACTIONS(2609),
    [anon_sym_co_yield] = ACTIONS(2609),
    [anon_sym_R_DQUOTE] = ACTIONS(2611),
    [anon_sym_LR_DQUOTE] = ACTIONS(2611),
    [anon_sym_uR_DQUOTE] = ACTIONS(2611),
    [anon_sym_UR_DQUOTE] = ACTIONS(2611),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2611),
    [anon_sym_co_await] = ACTIONS(2609),
    [anon_sym_new] = ACTIONS(2609),
    [anon_sym_requires] = ACTIONS(2609),
    [sym_this] = ACTIONS(2609),
  },
  [534] = {
    [sym_identifier] = ACTIONS(2609),
    [aux_sym_preproc_include_token1] = ACTIONS(2609),
    [aux_sym_preproc_def_token1] = ACTIONS(2609),
    [aux_sym_preproc_if_token1] = ACTIONS(2609),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2609),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2609),
    [sym_preproc_directive] = ACTIONS(2609),
    [anon_sym_LPAREN2] = ACTIONS(2611),
    [anon_sym_BANG] = ACTIONS(2611),
    [anon_sym_TILDE] = ACTIONS(2611),
    [anon_sym_DASH] = ACTIONS(2609),
    [anon_sym_PLUS] = ACTIONS(2609),
    [anon_sym_STAR] = ACTIONS(2611),
    [anon_sym_AMP_AMP] = ACTIONS(2611),
    [anon_sym_AMP] = ACTIONS(2609),
    [anon_sym_SEMI] = ACTIONS(2611),
    [anon_sym___extension__] = ACTIONS(2609),
    [anon_sym_typedef] = ACTIONS(2609),
    [anon_sym_virtual] = ACTIONS(2609),
    [anon_sym_extern] = ACTIONS(2609),
    [anon_sym___attribute__] = ACTIONS(2609),
    [anon_sym___attribute] = ACTIONS(2609),
    [anon_sym_COLON_COLON] = ACTIONS(2611),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2611),
    [anon_sym___declspec] = ACTIONS(2609),
    [anon_sym___based] = ACTIONS(2609),
    [anon_sym___cdecl] = ACTIONS(2609),
    [anon_sym___clrcall] = ACTIONS(2609),
    [anon_sym___stdcall] = ACTIONS(2609),
    [anon_sym___fastcall] = ACTIONS(2609),
    [anon_sym___thiscall] = ACTIONS(2609),
    [anon_sym___vectorcall] = ACTIONS(2609),
    [anon_sym_LBRACE] = ACTIONS(2611),
    [anon_sym_RBRACE] = ACTIONS(2611),
    [anon_sym_signed] = ACTIONS(2609),
    [anon_sym_unsigned] = ACTIONS(2609),
    [anon_sym_long] = ACTIONS(2609),
    [anon_sym_short] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(2609),
    [anon_sym_static] = ACTIONS(2609),
    [anon_sym_register] = ACTIONS(2609),
    [anon_sym_inline] = ACTIONS(2609),
    [anon_sym___inline] = ACTIONS(2609),
    [anon_sym___inline__] = ACTIONS(2609),
    [anon_sym___forceinline] = ACTIONS(2609),
    [anon_sym_thread_local] = ACTIONS(2609),
    [anon_sym___thread] = ACTIONS(2609),
    [anon_sym_const] = ACTIONS(2609),
    [anon_sym_constexpr] = ACTIONS(2609),
    [anon_sym_volatile] = ACTIONS(2609),
    [anon_sym_restrict] = ACTIONS(2609),
    [anon_sym___restrict__] = ACTIONS(2609),
    [anon_sym__Atomic] = ACTIONS(2609),
    [anon_sym__Noreturn] = ACTIONS(2609),
    [anon_sym_noreturn] = ACTIONS(2609),
    [anon_sym__Nonnull] = ACTIONS(2609),
    [anon_sym_mutable] = ACTIONS(2609),
    [anon_sym_constinit] = ACTIONS(2609),
    [anon_sym_consteval] = ACTIONS(2609),
    [anon_sym_alignas] = ACTIONS(2609),
    [anon_sym__Alignas] = ACTIONS(2609),
    [sym_primitive_type] = ACTIONS(2609),
    [anon_sym_enum] = ACTIONS(2609),
    [anon_sym_class] = ACTIONS(2609),
    [anon_sym_struct] = ACTIONS(2609),
    [anon_sym_union] = ACTIONS(2609),
    [anon_sym_if] = ACTIONS(2609),
    [anon_sym_else] = ACTIONS(2609),
    [anon_sym_switch] = ACTIONS(2609),
    [anon_sym_case] = ACTIONS(2609),
    [anon_sym_default] = ACTIONS(2609),
    [anon_sym_while] = ACTIONS(2609),
    [anon_sym_do] = ACTIONS(2609),
    [anon_sym_for] = ACTIONS(2609),
    [anon_sym_return] = ACTIONS(2609),
    [anon_sym_break] = ACTIONS(2609),
    [anon_sym_continue] = ACTIONS(2609),
    [anon_sym_goto] = ACTIONS(2609),
    [anon_sym___try] = ACTIONS(2609),
    [anon_sym___leave] = ACTIONS(2609),
    [anon_sym_not] = ACTIONS(2609),
    [anon_sym_compl] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(2611),
    [anon_sym_PLUS_PLUS] = ACTIONS(2611),
    [anon_sym_sizeof] = ACTIONS(2609),
    [anon_sym___alignof__] = ACTIONS(2609),
    [anon_sym___alignof] = ACTIONS(2609),
    [anon_sym__alignof] = ACTIONS(2609),
    [anon_sym_alignof] = ACTIONS(2609),
    [anon_sym__Alignof] = ACTIONS(2609),
    [anon_sym_offsetof] = ACTIONS(2609),
    [anon_sym__Generic] = ACTIONS(2609),
    [anon_sym_asm] = ACTIONS(2609),
    [anon_sym___asm__] = ACTIONS(2609),
    [anon_sym___asm] = ACTIONS(2609),
    [sym_number_literal] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2611),
    [anon_sym_u_SQUOTE] = ACTIONS(2611),
    [anon_sym_U_SQUOTE] = ACTIONS(2611),
    [anon_sym_u8_SQUOTE] = ACTIONS(2611),
    [anon_sym_SQUOTE] = ACTIONS(2611),
    [anon_sym_L_DQUOTE] = ACTIONS(2611),
    [anon_sym_u_DQUOTE] = ACTIONS(2611),
    [anon_sym_U_DQUOTE] = ACTIONS(2611),
    [anon_sym_u8_DQUOTE] = ACTIONS(2611),
    [anon_sym_DQUOTE] = ACTIONS(2611),
    [sym_true] = ACTIONS(2609),
    [sym_false] = ACTIONS(2609),
    [anon_sym_NULL] = ACTIONS(2609),
    [anon_sym_nullptr] = ACTIONS(2609),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2609),
    [anon_sym_decltype] = ACTIONS(2609),
    [anon_sym_explicit] = ACTIONS(2609),
    [anon_sym_typename] = ACTIONS(2609),
    [anon_sym_template] = ACTIONS(2609),
    [anon_sym_operator] = ACTIONS(2609),
    [anon_sym_try] = ACTIONS(2609),
    [anon_sym_delete] = ACTIONS(2609),
    [anon_sym_throw] = ACTIONS(2609),
    [anon_sym_namespace] = ACTIONS(2609),
    [anon_sym_using] = ACTIONS(2609),
    [anon_sym_static_assert] = ACTIONS(2609),
    [anon_sym_concept] = ACTIONS(2609),
    [anon_sym_co_return] = ACTIONS(2609),
    [anon_sym_co_yield] = ACTIONS(2609),
    [anon_sym_R_DQUOTE] = ACTIONS(2611),
    [anon_sym_LR_DQUOTE] = ACTIONS(2611),
    [anon_sym_uR_DQUOTE] = ACTIONS(2611),
    [anon_sym_UR_DQUOTE] = ACTIONS(2611),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2611),
    [anon_sym_co_await] = ACTIONS(2609),
    [anon_sym_new] = ACTIONS(2609),
    [anon_sym_requires] = ACTIONS(2609),
    [sym_this] = ACTIONS(2609),
  },
  [535] = {
    [sym_identifier] = ACTIONS(2653),
    [aux_sym_preproc_include_token1] = ACTIONS(2653),
    [aux_sym_preproc_def_token1] = ACTIONS(2653),
    [aux_sym_preproc_if_token1] = ACTIONS(2653),
    [aux_sym_preproc_if_token2] = ACTIONS(2653),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2653),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2653),
    [sym_preproc_directive] = ACTIONS(2653),
    [anon_sym_LPAREN2] = ACTIONS(2655),
    [anon_sym_BANG] = ACTIONS(2655),
    [anon_sym_TILDE] = ACTIONS(2655),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_AMP_AMP] = ACTIONS(2655),
    [anon_sym_AMP] = ACTIONS(2653),
    [anon_sym_SEMI] = ACTIONS(2655),
    [anon_sym___extension__] = ACTIONS(2653),
    [anon_sym_typedef] = ACTIONS(2653),
    [anon_sym_virtual] = ACTIONS(2653),
    [anon_sym_extern] = ACTIONS(2653),
    [anon_sym___attribute__] = ACTIONS(2653),
    [anon_sym___attribute] = ACTIONS(2653),
    [anon_sym_COLON_COLON] = ACTIONS(2655),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2655),
    [anon_sym___declspec] = ACTIONS(2653),
    [anon_sym___based] = ACTIONS(2653),
    [anon_sym___cdecl] = ACTIONS(2653),
    [anon_sym___clrcall] = ACTIONS(2653),
    [anon_sym___stdcall] = ACTIONS(2653),
    [anon_sym___fastcall] = ACTIONS(2653),
    [anon_sym___thiscall] = ACTIONS(2653),
    [anon_sym___vectorcall] = ACTIONS(2653),
    [anon_sym_LBRACE] = ACTIONS(2655),
    [anon_sym_signed] = ACTIONS(2653),
    [anon_sym_unsigned] = ACTIONS(2653),
    [anon_sym_long] = ACTIONS(2653),
    [anon_sym_short] = ACTIONS(2653),
    [anon_sym_LBRACK] = ACTIONS(2653),
    [anon_sym_static] = ACTIONS(2653),
    [anon_sym_register] = ACTIONS(2653),
    [anon_sym_inline] = ACTIONS(2653),
    [anon_sym___inline] = ACTIONS(2653),
    [anon_sym___inline__] = ACTIONS(2653),
    [anon_sym___forceinline] = ACTIONS(2653),
    [anon_sym_thread_local] = ACTIONS(2653),
    [anon_sym___thread] = ACTIONS(2653),
    [anon_sym_const] = ACTIONS(2653),
    [anon_sym_constexpr] = ACTIONS(2653),
    [anon_sym_volatile] = ACTIONS(2653),
    [anon_sym_restrict] = ACTIONS(2653),
    [anon_sym___restrict__] = ACTIONS(2653),
    [anon_sym__Atomic] = ACTIONS(2653),
    [anon_sym__Noreturn] = ACTIONS(2653),
    [anon_sym_noreturn] = ACTIONS(2653),
    [anon_sym__Nonnull] = ACTIONS(2653),
    [anon_sym_mutable] = ACTIONS(2653),
    [anon_sym_constinit] = ACTIONS(2653),
    [anon_sym_consteval] = ACTIONS(2653),
    [anon_sym_alignas] = ACTIONS(2653),
    [anon_sym__Alignas] = ACTIONS(2653),
    [sym_primitive_type] = ACTIONS(2653),
    [anon_sym_enum] = ACTIONS(2653),
    [anon_sym_class] = ACTIONS(2653),
    [anon_sym_struct] = ACTIONS(2653),
    [anon_sym_union] = ACTIONS(2653),
    [anon_sym_if] = ACTIONS(2653),
    [anon_sym_else] = ACTIONS(2653),
    [anon_sym_switch] = ACTIONS(2653),
    [anon_sym_case] = ACTIONS(2653),
    [anon_sym_default] = ACTIONS(2653),
    [anon_sym_while] = ACTIONS(2653),
    [anon_sym_do] = ACTIONS(2653),
    [anon_sym_for] = ACTIONS(2653),
    [anon_sym_return] = ACTIONS(2653),
    [anon_sym_break] = ACTIONS(2653),
    [anon_sym_continue] = ACTIONS(2653),
    [anon_sym_goto] = ACTIONS(2653),
    [anon_sym___try] = ACTIONS(2653),
    [anon_sym___leave] = ACTIONS(2653),
    [anon_sym_not] = ACTIONS(2653),
    [anon_sym_compl] = ACTIONS(2653),
    [anon_sym_DASH_DASH] = ACTIONS(2655),
    [anon_sym_PLUS_PLUS] = ACTIONS(2655),
    [anon_sym_sizeof] = ACTIONS(2653),
    [anon_sym___alignof__] = ACTIONS(2653),
    [anon_sym___alignof] = ACTIONS(2653),
    [anon_sym__alignof] = ACTIONS(2653),
    [anon_sym_alignof] = ACTIONS(2653),
    [anon_sym__Alignof] = ACTIONS(2653),
    [anon_sym_offsetof] = ACTIONS(2653),
    [anon_sym__Generic] = ACTIONS(2653),
    [anon_sym_asm] = ACTIONS(2653),
    [anon_sym___asm__] = ACTIONS(2653),
    [anon_sym___asm] = ACTIONS(2653),
    [sym_number_literal] = ACTIONS(2655),
    [anon_sym_L_SQUOTE] = ACTIONS(2655),
    [anon_sym_u_SQUOTE] = ACTIONS(2655),
    [anon_sym_U_SQUOTE] = ACTIONS(2655),
    [anon_sym_u8_SQUOTE] = ACTIONS(2655),
    [anon_sym_SQUOTE] = ACTIONS(2655),
    [anon_sym_L_DQUOTE] = ACTIONS(2655),
    [anon_sym_u_DQUOTE] = ACTIONS(2655),
    [anon_sym_U_DQUOTE] = ACTIONS(2655),
    [anon_sym_u8_DQUOTE] = ACTIONS(2655),
    [anon_sym_DQUOTE] = ACTIONS(2655),
    [sym_true] = ACTIONS(2653),
    [sym_false] = ACTIONS(2653),
    [anon_sym_NULL] = ACTIONS(2653),
    [anon_sym_nullptr] = ACTIONS(2653),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2653),
    [anon_sym_decltype] = ACTIONS(2653),
    [anon_sym_explicit] = ACTIONS(2653),
    [anon_sym_typename] = ACTIONS(2653),
    [anon_sym_template] = ACTIONS(2653),
    [anon_sym_operator] = ACTIONS(2653),
    [anon_sym_try] = ACTIONS(2653),
    [anon_sym_delete] = ACTIONS(2653),
    [anon_sym_throw] = ACTIONS(2653),
    [anon_sym_namespace] = ACTIONS(2653),
    [anon_sym_using] = ACTIONS(2653),
    [anon_sym_static_assert] = ACTIONS(2653),
    [anon_sym_concept] = ACTIONS(2653),
    [anon_sym_co_return] = ACTIONS(2653),
    [anon_sym_co_yield] = ACTIONS(2653),
    [anon_sym_R_DQUOTE] = ACTIONS(2655),
    [anon_sym_LR_DQUOTE] = ACTIONS(2655),
    [anon_sym_uR_DQUOTE] = ACTIONS(2655),
    [anon_sym_UR_DQUOTE] = ACTIONS(2655),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2655),
    [anon_sym_co_await] = ACTIONS(2653),
    [anon_sym_new] = ACTIONS(2653),
    [anon_sym_requires] = ACTIONS(2653),
    [sym_this] = ACTIONS(2653),
  },
  [536] = {
    [sym_identifier] = ACTIONS(2689),
    [aux_sym_preproc_include_token1] = ACTIONS(2689),
    [aux_sym_preproc_def_token1] = ACTIONS(2689),
    [aux_sym_preproc_if_token1] = ACTIONS(2689),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2689),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2689),
    [sym_preproc_directive] = ACTIONS(2689),
    [anon_sym_LPAREN2] = ACTIONS(2691),
    [anon_sym_BANG] = ACTIONS(2691),
    [anon_sym_TILDE] = ACTIONS(2691),
    [anon_sym_DASH] = ACTIONS(2689),
    [anon_sym_PLUS] = ACTIONS(2689),
    [anon_sym_STAR] = ACTIONS(2691),
    [anon_sym_AMP_AMP] = ACTIONS(2691),
    [anon_sym_AMP] = ACTIONS(2689),
    [anon_sym_SEMI] = ACTIONS(2691),
    [anon_sym___extension__] = ACTIONS(2689),
    [anon_sym_typedef] = ACTIONS(2689),
    [anon_sym_virtual] = ACTIONS(2689),
    [anon_sym_extern] = ACTIONS(2689),
    [anon_sym___attribute__] = ACTIONS(2689),
    [anon_sym___attribute] = ACTIONS(2689),
    [anon_sym_COLON_COLON] = ACTIONS(2691),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2691),
    [anon_sym___declspec] = ACTIONS(2689),
    [anon_sym___based] = ACTIONS(2689),
    [anon_sym___cdecl] = ACTIONS(2689),
    [anon_sym___clrcall] = ACTIONS(2689),
    [anon_sym___stdcall] = ACTIONS(2689),
    [anon_sym___fastcall] = ACTIONS(2689),
    [anon_sym___thiscall] = ACTIONS(2689),
    [anon_sym___vectorcall] = ACTIONS(2689),
    [anon_sym_LBRACE] = ACTIONS(2691),
    [anon_sym_RBRACE] = ACTIONS(2691),
    [anon_sym_signed] = ACTIONS(2689),
    [anon_sym_unsigned] = ACTIONS(2689),
    [anon_sym_long] = ACTIONS(2689),
    [anon_sym_short] = ACTIONS(2689),
    [anon_sym_LBRACK] = ACTIONS(2689),
    [anon_sym_static] = ACTIONS(2689),
    [anon_sym_register] = ACTIONS(2689),
    [anon_sym_inline] = ACTIONS(2689),
    [anon_sym___inline] = ACTIONS(2689),
    [anon_sym___inline__] = ACTIONS(2689),
    [anon_sym___forceinline] = ACTIONS(2689),
    [anon_sym_thread_local] = ACTIONS(2689),
    [anon_sym___thread] = ACTIONS(2689),
    [anon_sym_const] = ACTIONS(2689),
    [anon_sym_constexpr] = ACTIONS(2689),
    [anon_sym_volatile] = ACTIONS(2689),
    [anon_sym_restrict] = ACTIONS(2689),
    [anon_sym___restrict__] = ACTIONS(2689),
    [anon_sym__Atomic] = ACTIONS(2689),
    [anon_sym__Noreturn] = ACTIONS(2689),
    [anon_sym_noreturn] = ACTIONS(2689),
    [anon_sym__Nonnull] = ACTIONS(2689),
    [anon_sym_mutable] = ACTIONS(2689),
    [anon_sym_constinit] = ACTIONS(2689),
    [anon_sym_consteval] = ACTIONS(2689),
    [anon_sym_alignas] = ACTIONS(2689),
    [anon_sym__Alignas] = ACTIONS(2689),
    [sym_primitive_type] = ACTIONS(2689),
    [anon_sym_enum] = ACTIONS(2689),
    [anon_sym_class] = ACTIONS(2689),
    [anon_sym_struct] = ACTIONS(2689),
    [anon_sym_union] = ACTIONS(2689),
    [anon_sym_if] = ACTIONS(2689),
    [anon_sym_else] = ACTIONS(2689),
    [anon_sym_switch] = ACTIONS(2689),
    [anon_sym_case] = ACTIONS(2689),
    [anon_sym_default] = ACTIONS(2689),
    [anon_sym_while] = ACTIONS(2689),
    [anon_sym_do] = ACTIONS(2689),
    [anon_sym_for] = ACTIONS(2689),
    [anon_sym_return] = ACTIONS(2689),
    [anon_sym_break] = ACTIONS(2689),
    [anon_sym_continue] = ACTIONS(2689),
    [anon_sym_goto] = ACTIONS(2689),
    [anon_sym___try] = ACTIONS(2689),
    [anon_sym___leave] = ACTIONS(2689),
    [anon_sym_not] = ACTIONS(2689),
    [anon_sym_compl] = ACTIONS(2689),
    [anon_sym_DASH_DASH] = ACTIONS(2691),
    [anon_sym_PLUS_PLUS] = ACTIONS(2691),
    [anon_sym_sizeof] = ACTIONS(2689),
    [anon_sym___alignof__] = ACTIONS(2689),
    [anon_sym___alignof] = ACTIONS(2689),
    [anon_sym__alignof] = ACTIONS(2689),
    [anon_sym_alignof] = ACTIONS(2689),
    [anon_sym__Alignof] = ACTIONS(2689),
    [anon_sym_offsetof] = ACTIONS(2689),
    [anon_sym__Generic] = ACTIONS(2689),
    [anon_sym_asm] = ACTIONS(2689),
    [anon_sym___asm__] = ACTIONS(2689),
    [anon_sym___asm] = ACTIONS(2689),
    [sym_number_literal] = ACTIONS(2691),
    [anon_sym_L_SQUOTE] = ACTIONS(2691),
    [anon_sym_u_SQUOTE] = ACTIONS(2691),
    [anon_sym_U_SQUOTE] = ACTIONS(2691),
    [anon_sym_u8_SQUOTE] = ACTIONS(2691),
    [anon_sym_SQUOTE] = ACTIONS(2691),
    [anon_sym_L_DQUOTE] = ACTIONS(2691),
    [anon_sym_u_DQUOTE] = ACTIONS(2691),
    [anon_sym_U_DQUOTE] = ACTIONS(2691),
    [anon_sym_u8_DQUOTE] = ACTIONS(2691),
    [anon_sym_DQUOTE] = ACTIONS(2691),
    [sym_true] = ACTIONS(2689),
    [sym_false] = ACTIONS(2689),
    [anon_sym_NULL] = ACTIONS(2689),
    [anon_sym_nullptr] = ACTIONS(2689),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2689),
    [anon_sym_decltype] = ACTIONS(2689),
    [anon_sym_explicit] = ACTIONS(2689),
    [anon_sym_typename] = ACTIONS(2689),
    [anon_sym_template] = ACTIONS(2689),
    [anon_sym_operator] = ACTIONS(2689),
    [anon_sym_try] = ACTIONS(2689),
    [anon_sym_delete] = ACTIONS(2689),
    [anon_sym_throw] = ACTIONS(2689),
    [anon_sym_namespace] = ACTIONS(2689),
    [anon_sym_using] = ACTIONS(2689),
    [anon_sym_static_assert] = ACTIONS(2689),
    [anon_sym_concept] = ACTIONS(2689),
    [anon_sym_co_return] = ACTIONS(2689),
    [anon_sym_co_yield] = ACTIONS(2689),
    [anon_sym_R_DQUOTE] = ACTIONS(2691),
    [anon_sym_LR_DQUOTE] = ACTIONS(2691),
    [anon_sym_uR_DQUOTE] = ACTIONS(2691),
    [anon_sym_UR_DQUOTE] = ACTIONS(2691),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2691),
    [anon_sym_co_await] = ACTIONS(2689),
    [anon_sym_new] = ACTIONS(2689),
    [anon_sym_requires] = ACTIONS(2689),
    [sym_this] = ACTIONS(2689),
  },
  [537] = {
    [ts_builtin_sym_end] = ACTIONS(2587),
    [sym_identifier] = ACTIONS(2585),
    [aux_sym_preproc_include_token1] = ACTIONS(2585),
    [aux_sym_preproc_def_token1] = ACTIONS(2585),
    [aux_sym_preproc_if_token1] = ACTIONS(2585),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2585),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2585),
    [sym_preproc_directive] = ACTIONS(2585),
    [anon_sym_LPAREN2] = ACTIONS(2587),
    [anon_sym_BANG] = ACTIONS(2587),
    [anon_sym_TILDE] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2585),
    [anon_sym_PLUS] = ACTIONS(2585),
    [anon_sym_STAR] = ACTIONS(2587),
    [anon_sym_AMP_AMP] = ACTIONS(2587),
    [anon_sym_AMP] = ACTIONS(2585),
    [anon_sym_SEMI] = ACTIONS(2587),
    [anon_sym___extension__] = ACTIONS(2585),
    [anon_sym_typedef] = ACTIONS(2585),
    [anon_sym_virtual] = ACTIONS(2585),
    [anon_sym_extern] = ACTIONS(2585),
    [anon_sym___attribute__] = ACTIONS(2585),
    [anon_sym___attribute] = ACTIONS(2585),
    [anon_sym_COLON_COLON] = ACTIONS(2587),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2587),
    [anon_sym___declspec] = ACTIONS(2585),
    [anon_sym___based] = ACTIONS(2585),
    [anon_sym___cdecl] = ACTIONS(2585),
    [anon_sym___clrcall] = ACTIONS(2585),
    [anon_sym___stdcall] = ACTIONS(2585),
    [anon_sym___fastcall] = ACTIONS(2585),
    [anon_sym___thiscall] = ACTIONS(2585),
    [anon_sym___vectorcall] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2587),
    [anon_sym_signed] = ACTIONS(2585),
    [anon_sym_unsigned] = ACTIONS(2585),
    [anon_sym_long] = ACTIONS(2585),
    [anon_sym_short] = ACTIONS(2585),
    [anon_sym_LBRACK] = ACTIONS(2585),
    [anon_sym_static] = ACTIONS(2585),
    [anon_sym_register] = ACTIONS(2585),
    [anon_sym_inline] = ACTIONS(2585),
    [anon_sym___inline] = ACTIONS(2585),
    [anon_sym___inline__] = ACTIONS(2585),
    [anon_sym___forceinline] = ACTIONS(2585),
    [anon_sym_thread_local] = ACTIONS(2585),
    [anon_sym___thread] = ACTIONS(2585),
    [anon_sym_const] = ACTIONS(2585),
    [anon_sym_constexpr] = ACTIONS(2585),
    [anon_sym_volatile] = ACTIONS(2585),
    [anon_sym_restrict] = ACTIONS(2585),
    [anon_sym___restrict__] = ACTIONS(2585),
    [anon_sym__Atomic] = ACTIONS(2585),
    [anon_sym__Noreturn] = ACTIONS(2585),
    [anon_sym_noreturn] = ACTIONS(2585),
    [anon_sym__Nonnull] = ACTIONS(2585),
    [anon_sym_mutable] = ACTIONS(2585),
    [anon_sym_constinit] = ACTIONS(2585),
    [anon_sym_consteval] = ACTIONS(2585),
    [anon_sym_alignas] = ACTIONS(2585),
    [anon_sym__Alignas] = ACTIONS(2585),
    [sym_primitive_type] = ACTIONS(2585),
    [anon_sym_enum] = ACTIONS(2585),
    [anon_sym_class] = ACTIONS(2585),
    [anon_sym_struct] = ACTIONS(2585),
    [anon_sym_union] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2585),
    [anon_sym_else] = ACTIONS(2585),
    [anon_sym_switch] = ACTIONS(2585),
    [anon_sym_case] = ACTIONS(2585),
    [anon_sym_default] = ACTIONS(2585),
    [anon_sym_while] = ACTIONS(2585),
    [anon_sym_do] = ACTIONS(2585),
    [anon_sym_for] = ACTIONS(2585),
    [anon_sym_return] = ACTIONS(2585),
    [anon_sym_break] = ACTIONS(2585),
    [anon_sym_continue] = ACTIONS(2585),
    [anon_sym_goto] = ACTIONS(2585),
    [anon_sym___try] = ACTIONS(2585),
    [anon_sym___leave] = ACTIONS(2585),
    [anon_sym_not] = ACTIONS(2585),
    [anon_sym_compl] = ACTIONS(2585),
    [anon_sym_DASH_DASH] = ACTIONS(2587),
    [anon_sym_PLUS_PLUS] = ACTIONS(2587),
    [anon_sym_sizeof] = ACTIONS(2585),
    [anon_sym___alignof__] = ACTIONS(2585),
    [anon_sym___alignof] = ACTIONS(2585),
    [anon_sym__alignof] = ACTIONS(2585),
    [anon_sym_alignof] = ACTIONS(2585),
    [anon_sym__Alignof] = ACTIONS(2585),
    [anon_sym_offsetof] = ACTIONS(2585),
    [anon_sym__Generic] = ACTIONS(2585),
    [anon_sym_asm] = ACTIONS(2585),
    [anon_sym___asm__] = ACTIONS(2585),
    [anon_sym___asm] = ACTIONS(2585),
    [sym_number_literal] = ACTIONS(2587),
    [anon_sym_L_SQUOTE] = ACTIONS(2587),
    [anon_sym_u_SQUOTE] = ACTIONS(2587),
    [anon_sym_U_SQUOTE] = ACTIONS(2587),
    [anon_sym_u8_SQUOTE] = ACTIONS(2587),
    [anon_sym_SQUOTE] = ACTIONS(2587),
    [anon_sym_L_DQUOTE] = ACTIONS(2587),
    [anon_sym_u_DQUOTE] = ACTIONS(2587),
    [anon_sym_U_DQUOTE] = ACTIONS(2587),
    [anon_sym_u8_DQUOTE] = ACTIONS(2587),
    [anon_sym_DQUOTE] = ACTIONS(2587),
    [sym_true] = ACTIONS(2585),
    [sym_false] = ACTIONS(2585),
    [anon_sym_NULL] = ACTIONS(2585),
    [anon_sym_nullptr] = ACTIONS(2585),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2585),
    [anon_sym_decltype] = ACTIONS(2585),
    [anon_sym_explicit] = ACTIONS(2585),
    [anon_sym_typename] = ACTIONS(2585),
    [anon_sym_template] = ACTIONS(2585),
    [anon_sym_operator] = ACTIONS(2585),
    [anon_sym_try] = ACTIONS(2585),
    [anon_sym_delete] = ACTIONS(2585),
    [anon_sym_throw] = ACTIONS(2585),
    [anon_sym_namespace] = ACTIONS(2585),
    [anon_sym_using] = ACTIONS(2585),
    [anon_sym_static_assert] = ACTIONS(2585),
    [anon_sym_concept] = ACTIONS(2585),
    [anon_sym_co_return] = ACTIONS(2585),
    [anon_sym_co_yield] = ACTIONS(2585),
    [anon_sym_R_DQUOTE] = ACTIONS(2587),
    [anon_sym_LR_DQUOTE] = ACTIONS(2587),
    [anon_sym_uR_DQUOTE] = ACTIONS(2587),
    [anon_sym_UR_DQUOTE] = ACTIONS(2587),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2587),
    [anon_sym_co_await] = ACTIONS(2585),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_requires] = ACTIONS(2585),
    [sym_this] = ACTIONS(2585),
  },
  [538] = {
    [sym_identifier] = ACTIONS(2661),
    [aux_sym_preproc_include_token1] = ACTIONS(2661),
    [aux_sym_preproc_def_token1] = ACTIONS(2661),
    [aux_sym_preproc_if_token1] = ACTIONS(2661),
    [aux_sym_preproc_if_token2] = ACTIONS(2661),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2661),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2661),
    [sym_preproc_directive] = ACTIONS(2661),
    [anon_sym_LPAREN2] = ACTIONS(2663),
    [anon_sym_BANG] = ACTIONS(2663),
    [anon_sym_TILDE] = ACTIONS(2663),
    [anon_sym_DASH] = ACTIONS(2661),
    [anon_sym_PLUS] = ACTIONS(2661),
    [anon_sym_STAR] = ACTIONS(2663),
    [anon_sym_AMP_AMP] = ACTIONS(2663),
    [anon_sym_AMP] = ACTIONS(2661),
    [anon_sym_SEMI] = ACTIONS(2663),
    [anon_sym___extension__] = ACTIONS(2661),
    [anon_sym_typedef] = ACTIONS(2661),
    [anon_sym_virtual] = ACTIONS(2661),
    [anon_sym_extern] = ACTIONS(2661),
    [anon_sym___attribute__] = ACTIONS(2661),
    [anon_sym___attribute] = ACTIONS(2661),
    [anon_sym_COLON_COLON] = ACTIONS(2663),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2663),
    [anon_sym___declspec] = ACTIONS(2661),
    [anon_sym___based] = ACTIONS(2661),
    [anon_sym___cdecl] = ACTIONS(2661),
    [anon_sym___clrcall] = ACTIONS(2661),
    [anon_sym___stdcall] = ACTIONS(2661),
    [anon_sym___fastcall] = ACTIONS(2661),
    [anon_sym___thiscall] = ACTIONS(2661),
    [anon_sym___vectorcall] = ACTIONS(2661),
    [anon_sym_LBRACE] = ACTIONS(2663),
    [anon_sym_signed] = ACTIONS(2661),
    [anon_sym_unsigned] = ACTIONS(2661),
    [anon_sym_long] = ACTIONS(2661),
    [anon_sym_short] = ACTIONS(2661),
    [anon_sym_LBRACK] = ACTIONS(2661),
    [anon_sym_static] = ACTIONS(2661),
    [anon_sym_register] = ACTIONS(2661),
    [anon_sym_inline] = ACTIONS(2661),
    [anon_sym___inline] = ACTIONS(2661),
    [anon_sym___inline__] = ACTIONS(2661),
    [anon_sym___forceinline] = ACTIONS(2661),
    [anon_sym_thread_local] = ACTIONS(2661),
    [anon_sym___thread] = ACTIONS(2661),
    [anon_sym_const] = ACTIONS(2661),
    [anon_sym_constexpr] = ACTIONS(2661),
    [anon_sym_volatile] = ACTIONS(2661),
    [anon_sym_restrict] = ACTIONS(2661),
    [anon_sym___restrict__] = ACTIONS(2661),
    [anon_sym__Atomic] = ACTIONS(2661),
    [anon_sym__Noreturn] = ACTIONS(2661),
    [anon_sym_noreturn] = ACTIONS(2661),
    [anon_sym__Nonnull] = ACTIONS(2661),
    [anon_sym_mutable] = ACTIONS(2661),
    [anon_sym_constinit] = ACTIONS(2661),
    [anon_sym_consteval] = ACTIONS(2661),
    [anon_sym_alignas] = ACTIONS(2661),
    [anon_sym__Alignas] = ACTIONS(2661),
    [sym_primitive_type] = ACTIONS(2661),
    [anon_sym_enum] = ACTIONS(2661),
    [anon_sym_class] = ACTIONS(2661),
    [anon_sym_struct] = ACTIONS(2661),
    [anon_sym_union] = ACTIONS(2661),
    [anon_sym_if] = ACTIONS(2661),
    [anon_sym_else] = ACTIONS(2661),
    [anon_sym_switch] = ACTIONS(2661),
    [anon_sym_case] = ACTIONS(2661),
    [anon_sym_default] = ACTIONS(2661),
    [anon_sym_while] = ACTIONS(2661),
    [anon_sym_do] = ACTIONS(2661),
    [anon_sym_for] = ACTIONS(2661),
    [anon_sym_return] = ACTIONS(2661),
    [anon_sym_break] = ACTIONS(2661),
    [anon_sym_continue] = ACTIONS(2661),
    [anon_sym_goto] = ACTIONS(2661),
    [anon_sym___try] = ACTIONS(2661),
    [anon_sym___leave] = ACTIONS(2661),
    [anon_sym_not] = ACTIONS(2661),
    [anon_sym_compl] = ACTIONS(2661),
    [anon_sym_DASH_DASH] = ACTIONS(2663),
    [anon_sym_PLUS_PLUS] = ACTIONS(2663),
    [anon_sym_sizeof] = ACTIONS(2661),
    [anon_sym___alignof__] = ACTIONS(2661),
    [anon_sym___alignof] = ACTIONS(2661),
    [anon_sym__alignof] = ACTIONS(2661),
    [anon_sym_alignof] = ACTIONS(2661),
    [anon_sym__Alignof] = ACTIONS(2661),
    [anon_sym_offsetof] = ACTIONS(2661),
    [anon_sym__Generic] = ACTIONS(2661),
    [anon_sym_asm] = ACTIONS(2661),
    [anon_sym___asm__] = ACTIONS(2661),
    [anon_sym___asm] = ACTIONS(2661),
    [sym_number_literal] = ACTIONS(2663),
    [anon_sym_L_SQUOTE] = ACTIONS(2663),
    [anon_sym_u_SQUOTE] = ACTIONS(2663),
    [anon_sym_U_SQUOTE] = ACTIONS(2663),
    [anon_sym_u8_SQUOTE] = ACTIONS(2663),
    [anon_sym_SQUOTE] = ACTIONS(2663),
    [anon_sym_L_DQUOTE] = ACTIONS(2663),
    [anon_sym_u_DQUOTE] = ACTIONS(2663),
    [anon_sym_U_DQUOTE] = ACTIONS(2663),
    [anon_sym_u8_DQUOTE] = ACTIONS(2663),
    [anon_sym_DQUOTE] = ACTIONS(2663),
    [sym_true] = ACTIONS(2661),
    [sym_false] = ACTIONS(2661),
    [anon_sym_NULL] = ACTIONS(2661),
    [anon_sym_nullptr] = ACTIONS(2661),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2661),
    [anon_sym_decltype] = ACTIONS(2661),
    [anon_sym_explicit] = ACTIONS(2661),
    [anon_sym_typename] = ACTIONS(2661),
    [anon_sym_template] = ACTIONS(2661),
    [anon_sym_operator] = ACTIONS(2661),
    [anon_sym_try] = ACTIONS(2661),
    [anon_sym_delete] = ACTIONS(2661),
    [anon_sym_throw] = ACTIONS(2661),
    [anon_sym_namespace] = ACTIONS(2661),
    [anon_sym_using] = ACTIONS(2661),
    [anon_sym_static_assert] = ACTIONS(2661),
    [anon_sym_concept] = ACTIONS(2661),
    [anon_sym_co_return] = ACTIONS(2661),
    [anon_sym_co_yield] = ACTIONS(2661),
    [anon_sym_R_DQUOTE] = ACTIONS(2663),
    [anon_sym_LR_DQUOTE] = ACTIONS(2663),
    [anon_sym_uR_DQUOTE] = ACTIONS(2663),
    [anon_sym_UR_DQUOTE] = ACTIONS(2663),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2663),
    [anon_sym_co_await] = ACTIONS(2661),
    [anon_sym_new] = ACTIONS(2661),
    [anon_sym_requires] = ACTIONS(2661),
    [sym_this] = ACTIONS(2661),
  },
  [539] = {
    [ts_builtin_sym_end] = ACTIONS(2599),
    [sym_identifier] = ACTIONS(2597),
    [aux_sym_preproc_include_token1] = ACTIONS(2597),
    [aux_sym_preproc_def_token1] = ACTIONS(2597),
    [aux_sym_preproc_if_token1] = ACTIONS(2597),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2597),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2597),
    [sym_preproc_directive] = ACTIONS(2597),
    [anon_sym_LPAREN2] = ACTIONS(2599),
    [anon_sym_BANG] = ACTIONS(2599),
    [anon_sym_TILDE] = ACTIONS(2599),
    [anon_sym_DASH] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(2597),
    [anon_sym_STAR] = ACTIONS(2599),
    [anon_sym_AMP_AMP] = ACTIONS(2599),
    [anon_sym_AMP] = ACTIONS(2597),
    [anon_sym_SEMI] = ACTIONS(2599),
    [anon_sym___extension__] = ACTIONS(2597),
    [anon_sym_typedef] = ACTIONS(2597),
    [anon_sym_virtual] = ACTIONS(2597),
    [anon_sym_extern] = ACTIONS(2597),
    [anon_sym___attribute__] = ACTIONS(2597),
    [anon_sym___attribute] = ACTIONS(2597),
    [anon_sym_COLON_COLON] = ACTIONS(2599),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2599),
    [anon_sym___declspec] = ACTIONS(2597),
    [anon_sym___based] = ACTIONS(2597),
    [anon_sym___cdecl] = ACTIONS(2597),
    [anon_sym___clrcall] = ACTIONS(2597),
    [anon_sym___stdcall] = ACTIONS(2597),
    [anon_sym___fastcall] = ACTIONS(2597),
    [anon_sym___thiscall] = ACTIONS(2597),
    [anon_sym___vectorcall] = ACTIONS(2597),
    [anon_sym_LBRACE] = ACTIONS(2599),
    [anon_sym_signed] = ACTIONS(2597),
    [anon_sym_unsigned] = ACTIONS(2597),
    [anon_sym_long] = ACTIONS(2597),
    [anon_sym_short] = ACTIONS(2597),
    [anon_sym_LBRACK] = ACTIONS(2597),
    [anon_sym_static] = ACTIONS(2597),
    [anon_sym_register] = ACTIONS(2597),
    [anon_sym_inline] = ACTIONS(2597),
    [anon_sym___inline] = ACTIONS(2597),
    [anon_sym___inline__] = ACTIONS(2597),
    [anon_sym___forceinline] = ACTIONS(2597),
    [anon_sym_thread_local] = ACTIONS(2597),
    [anon_sym___thread] = ACTIONS(2597),
    [anon_sym_const] = ACTIONS(2597),
    [anon_sym_constexpr] = ACTIONS(2597),
    [anon_sym_volatile] = ACTIONS(2597),
    [anon_sym_restrict] = ACTIONS(2597),
    [anon_sym___restrict__] = ACTIONS(2597),
    [anon_sym__Atomic] = ACTIONS(2597),
    [anon_sym__Noreturn] = ACTIONS(2597),
    [anon_sym_noreturn] = ACTIONS(2597),
    [anon_sym__Nonnull] = ACTIONS(2597),
    [anon_sym_mutable] = ACTIONS(2597),
    [anon_sym_constinit] = ACTIONS(2597),
    [anon_sym_consteval] = ACTIONS(2597),
    [anon_sym_alignas] = ACTIONS(2597),
    [anon_sym__Alignas] = ACTIONS(2597),
    [sym_primitive_type] = ACTIONS(2597),
    [anon_sym_enum] = ACTIONS(2597),
    [anon_sym_class] = ACTIONS(2597),
    [anon_sym_struct] = ACTIONS(2597),
    [anon_sym_union] = ACTIONS(2597),
    [anon_sym_if] = ACTIONS(2597),
    [anon_sym_else] = ACTIONS(2597),
    [anon_sym_switch] = ACTIONS(2597),
    [anon_sym_case] = ACTIONS(2597),
    [anon_sym_default] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2597),
    [anon_sym_do] = ACTIONS(2597),
    [anon_sym_for] = ACTIONS(2597),
    [anon_sym_return] = ACTIONS(2597),
    [anon_sym_break] = ACTIONS(2597),
    [anon_sym_continue] = ACTIONS(2597),
    [anon_sym_goto] = ACTIONS(2597),
    [anon_sym___try] = ACTIONS(2597),
    [anon_sym___leave] = ACTIONS(2597),
    [anon_sym_not] = ACTIONS(2597),
    [anon_sym_compl] = ACTIONS(2597),
    [anon_sym_DASH_DASH] = ACTIONS(2599),
    [anon_sym_PLUS_PLUS] = ACTIONS(2599),
    [anon_sym_sizeof] = ACTIONS(2597),
    [anon_sym___alignof__] = ACTIONS(2597),
    [anon_sym___alignof] = ACTIONS(2597),
    [anon_sym__alignof] = ACTIONS(2597),
    [anon_sym_alignof] = ACTIONS(2597),
    [anon_sym__Alignof] = ACTIONS(2597),
    [anon_sym_offsetof] = ACTIONS(2597),
    [anon_sym__Generic] = ACTIONS(2597),
    [anon_sym_asm] = ACTIONS(2597),
    [anon_sym___asm__] = ACTIONS(2597),
    [anon_sym___asm] = ACTIONS(2597),
    [sym_number_literal] = ACTIONS(2599),
    [anon_sym_L_SQUOTE] = ACTIONS(2599),
    [anon_sym_u_SQUOTE] = ACTIONS(2599),
    [anon_sym_U_SQUOTE] = ACTIONS(2599),
    [anon_sym_u8_SQUOTE] = ACTIONS(2599),
    [anon_sym_SQUOTE] = ACTIONS(2599),
    [anon_sym_L_DQUOTE] = ACTIONS(2599),
    [anon_sym_u_DQUOTE] = ACTIONS(2599),
    [anon_sym_U_DQUOTE] = ACTIONS(2599),
    [anon_sym_u8_DQUOTE] = ACTIONS(2599),
    [anon_sym_DQUOTE] = ACTIONS(2599),
    [sym_true] = ACTIONS(2597),
    [sym_false] = ACTIONS(2597),
    [anon_sym_NULL] = ACTIONS(2597),
    [anon_sym_nullptr] = ACTIONS(2597),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2597),
    [anon_sym_decltype] = ACTIONS(2597),
    [anon_sym_explicit] = ACTIONS(2597),
    [anon_sym_typename] = ACTIONS(2597),
    [anon_sym_template] = ACTIONS(2597),
    [anon_sym_operator] = ACTIONS(2597),
    [anon_sym_try] = ACTIONS(2597),
    [anon_sym_delete] = ACTIONS(2597),
    [anon_sym_throw] = ACTIONS(2597),
    [anon_sym_namespace] = ACTIONS(2597),
    [anon_sym_using] = ACTIONS(2597),
    [anon_sym_static_assert] = ACTIONS(2597),
    [anon_sym_concept] = ACTIONS(2597),
    [anon_sym_co_return] = ACTIONS(2597),
    [anon_sym_co_yield] = ACTIONS(2597),
    [anon_sym_R_DQUOTE] = ACTIONS(2599),
    [anon_sym_LR_DQUOTE] = ACTIONS(2599),
    [anon_sym_uR_DQUOTE] = ACTIONS(2599),
    [anon_sym_UR_DQUOTE] = ACTIONS(2599),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2599),
    [anon_sym_co_await] = ACTIONS(2597),
    [anon_sym_new] = ACTIONS(2597),
    [anon_sym_requires] = ACTIONS(2597),
    [sym_this] = ACTIONS(2597),
  },
  [540] = {
    [sym_identifier] = ACTIONS(2743),
    [aux_sym_preproc_include_token1] = ACTIONS(2743),
    [aux_sym_preproc_def_token1] = ACTIONS(2743),
    [aux_sym_preproc_if_token1] = ACTIONS(2743),
    [aux_sym_preproc_if_token2] = ACTIONS(2743),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2743),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2743),
    [sym_preproc_directive] = ACTIONS(2743),
    [anon_sym_LPAREN2] = ACTIONS(2745),
    [anon_sym_BANG] = ACTIONS(2745),
    [anon_sym_TILDE] = ACTIONS(2745),
    [anon_sym_DASH] = ACTIONS(2743),
    [anon_sym_PLUS] = ACTIONS(2743),
    [anon_sym_STAR] = ACTIONS(2745),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_AMP] = ACTIONS(2743),
    [anon_sym_SEMI] = ACTIONS(2745),
    [anon_sym___extension__] = ACTIONS(2743),
    [anon_sym_typedef] = ACTIONS(2743),
    [anon_sym_virtual] = ACTIONS(2743),
    [anon_sym_extern] = ACTIONS(2743),
    [anon_sym___attribute__] = ACTIONS(2743),
    [anon_sym___attribute] = ACTIONS(2743),
    [anon_sym_COLON_COLON] = ACTIONS(2745),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2745),
    [anon_sym___declspec] = ACTIONS(2743),
    [anon_sym___based] = ACTIONS(2743),
    [anon_sym___cdecl] = ACTIONS(2743),
    [anon_sym___clrcall] = ACTIONS(2743),
    [anon_sym___stdcall] = ACTIONS(2743),
    [anon_sym___fastcall] = ACTIONS(2743),
    [anon_sym___thiscall] = ACTIONS(2743),
    [anon_sym___vectorcall] = ACTIONS(2743),
    [anon_sym_LBRACE] = ACTIONS(2745),
    [anon_sym_signed] = ACTIONS(2743),
    [anon_sym_unsigned] = ACTIONS(2743),
    [anon_sym_long] = ACTIONS(2743),
    [anon_sym_short] = ACTIONS(2743),
    [anon_sym_LBRACK] = ACTIONS(2743),
    [anon_sym_static] = ACTIONS(2743),
    [anon_sym_register] = ACTIONS(2743),
    [anon_sym_inline] = ACTIONS(2743),
    [anon_sym___inline] = ACTIONS(2743),
    [anon_sym___inline__] = ACTIONS(2743),
    [anon_sym___forceinline] = ACTIONS(2743),
    [anon_sym_thread_local] = ACTIONS(2743),
    [anon_sym___thread] = ACTIONS(2743),
    [anon_sym_const] = ACTIONS(2743),
    [anon_sym_constexpr] = ACTIONS(2743),
    [anon_sym_volatile] = ACTIONS(2743),
    [anon_sym_restrict] = ACTIONS(2743),
    [anon_sym___restrict__] = ACTIONS(2743),
    [anon_sym__Atomic] = ACTIONS(2743),
    [anon_sym__Noreturn] = ACTIONS(2743),
    [anon_sym_noreturn] = ACTIONS(2743),
    [anon_sym__Nonnull] = ACTIONS(2743),
    [anon_sym_mutable] = ACTIONS(2743),
    [anon_sym_constinit] = ACTIONS(2743),
    [anon_sym_consteval] = ACTIONS(2743),
    [anon_sym_alignas] = ACTIONS(2743),
    [anon_sym__Alignas] = ACTIONS(2743),
    [sym_primitive_type] = ACTIONS(2743),
    [anon_sym_enum] = ACTIONS(2743),
    [anon_sym_class] = ACTIONS(2743),
    [anon_sym_struct] = ACTIONS(2743),
    [anon_sym_union] = ACTIONS(2743),
    [anon_sym_if] = ACTIONS(2743),
    [anon_sym_switch] = ACTIONS(2743),
    [anon_sym_case] = ACTIONS(2743),
    [anon_sym_default] = ACTIONS(2743),
    [anon_sym_while] = ACTIONS(2743),
    [anon_sym_do] = ACTIONS(2743),
    [anon_sym_for] = ACTIONS(2743),
    [anon_sym_return] = ACTIONS(2743),
    [anon_sym_break] = ACTIONS(2743),
    [anon_sym_continue] = ACTIONS(2743),
    [anon_sym_goto] = ACTIONS(2743),
    [anon_sym___try] = ACTIONS(2743),
    [anon_sym___leave] = ACTIONS(2743),
    [anon_sym_not] = ACTIONS(2743),
    [anon_sym_compl] = ACTIONS(2743),
    [anon_sym_DASH_DASH] = ACTIONS(2745),
    [anon_sym_PLUS_PLUS] = ACTIONS(2745),
    [anon_sym_sizeof] = ACTIONS(2743),
    [anon_sym___alignof__] = ACTIONS(2743),
    [anon_sym___alignof] = ACTIONS(2743),
    [anon_sym__alignof] = ACTIONS(2743),
    [anon_sym_alignof] = ACTIONS(2743),
    [anon_sym__Alignof] = ACTIONS(2743),
    [anon_sym_offsetof] = ACTIONS(2743),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2743),
    [anon_sym___asm__] = ACTIONS(2743),
    [anon_sym___asm] = ACTIONS(2743),
    [sym_number_literal] = ACTIONS(2745),
    [anon_sym_L_SQUOTE] = ACTIONS(2745),
    [anon_sym_u_SQUOTE] = ACTIONS(2745),
    [anon_sym_U_SQUOTE] = ACTIONS(2745),
    [anon_sym_u8_SQUOTE] = ACTIONS(2745),
    [anon_sym_SQUOTE] = ACTIONS(2745),
    [anon_sym_L_DQUOTE] = ACTIONS(2745),
    [anon_sym_u_DQUOTE] = ACTIONS(2745),
    [anon_sym_U_DQUOTE] = ACTIONS(2745),
    [anon_sym_u8_DQUOTE] = ACTIONS(2745),
    [anon_sym_DQUOTE] = ACTIONS(2745),
    [sym_true] = ACTIONS(2743),
    [sym_false] = ACTIONS(2743),
    [anon_sym_NULL] = ACTIONS(2743),
    [anon_sym_nullptr] = ACTIONS(2743),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2743),
    [anon_sym_decltype] = ACTIONS(2743),
    [anon_sym_explicit] = ACTIONS(2743),
    [anon_sym_typename] = ACTIONS(2743),
    [anon_sym_template] = ACTIONS(2743),
    [anon_sym_operator] = ACTIONS(2743),
    [anon_sym_try] = ACTIONS(2743),
    [anon_sym_delete] = ACTIONS(2743),
    [anon_sym_throw] = ACTIONS(2743),
    [anon_sym_namespace] = ACTIONS(2743),
    [anon_sym_using] = ACTIONS(2743),
    [anon_sym_static_assert] = ACTIONS(2743),
    [anon_sym_concept] = ACTIONS(2743),
    [anon_sym_co_return] = ACTIONS(2743),
    [anon_sym_co_yield] = ACTIONS(2743),
    [anon_sym_R_DQUOTE] = ACTIONS(2745),
    [anon_sym_LR_DQUOTE] = ACTIONS(2745),
    [anon_sym_uR_DQUOTE] = ACTIONS(2745),
    [anon_sym_UR_DQUOTE] = ACTIONS(2745),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2745),
    [anon_sym_co_await] = ACTIONS(2743),
    [anon_sym_new] = ACTIONS(2743),
    [anon_sym_requires] = ACTIONS(2743),
    [sym_this] = ACTIONS(2743),
  },
  [541] = {
    [sym_identifier] = ACTIONS(3026),
    [aux_sym_preproc_include_token1] = ACTIONS(3026),
    [aux_sym_preproc_def_token1] = ACTIONS(3026),
    [aux_sym_preproc_if_token1] = ACTIONS(3026),
    [aux_sym_preproc_if_token2] = ACTIONS(3026),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3026),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3026),
    [sym_preproc_directive] = ACTIONS(3026),
    [anon_sym_LPAREN2] = ACTIONS(3028),
    [anon_sym_BANG] = ACTIONS(3028),
    [anon_sym_TILDE] = ACTIONS(3028),
    [anon_sym_DASH] = ACTIONS(3026),
    [anon_sym_PLUS] = ACTIONS(3026),
    [anon_sym_STAR] = ACTIONS(3028),
    [anon_sym_AMP_AMP] = ACTIONS(3028),
    [anon_sym_AMP] = ACTIONS(3026),
    [anon_sym_SEMI] = ACTIONS(3028),
    [anon_sym___extension__] = ACTIONS(3026),
    [anon_sym_typedef] = ACTIONS(3026),
    [anon_sym_virtual] = ACTIONS(3026),
    [anon_sym_extern] = ACTIONS(3026),
    [anon_sym___attribute__] = ACTIONS(3026),
    [anon_sym___attribute] = ACTIONS(3026),
    [anon_sym_COLON_COLON] = ACTIONS(3028),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3028),
    [anon_sym___declspec] = ACTIONS(3026),
    [anon_sym___based] = ACTIONS(3026),
    [anon_sym___cdecl] = ACTIONS(3026),
    [anon_sym___clrcall] = ACTIONS(3026),
    [anon_sym___stdcall] = ACTIONS(3026),
    [anon_sym___fastcall] = ACTIONS(3026),
    [anon_sym___thiscall] = ACTIONS(3026),
    [anon_sym___vectorcall] = ACTIONS(3026),
    [anon_sym_LBRACE] = ACTIONS(3028),
    [anon_sym_signed] = ACTIONS(3026),
    [anon_sym_unsigned] = ACTIONS(3026),
    [anon_sym_long] = ACTIONS(3026),
    [anon_sym_short] = ACTIONS(3026),
    [anon_sym_LBRACK] = ACTIONS(3026),
    [anon_sym_static] = ACTIONS(3026),
    [anon_sym_register] = ACTIONS(3026),
    [anon_sym_inline] = ACTIONS(3026),
    [anon_sym___inline] = ACTIONS(3026),
    [anon_sym___inline__] = ACTIONS(3026),
    [anon_sym___forceinline] = ACTIONS(3026),
    [anon_sym_thread_local] = ACTIONS(3026),
    [anon_sym___thread] = ACTIONS(3026),
    [anon_sym_const] = ACTIONS(3026),
    [anon_sym_constexpr] = ACTIONS(3026),
    [anon_sym_volatile] = ACTIONS(3026),
    [anon_sym_restrict] = ACTIONS(3026),
    [anon_sym___restrict__] = ACTIONS(3026),
    [anon_sym__Atomic] = ACTIONS(3026),
    [anon_sym__Noreturn] = ACTIONS(3026),
    [anon_sym_noreturn] = ACTIONS(3026),
    [anon_sym__Nonnull] = ACTIONS(3026),
    [anon_sym_mutable] = ACTIONS(3026),
    [anon_sym_constinit] = ACTIONS(3026),
    [anon_sym_consteval] = ACTIONS(3026),
    [anon_sym_alignas] = ACTIONS(3026),
    [anon_sym__Alignas] = ACTIONS(3026),
    [sym_primitive_type] = ACTIONS(3026),
    [anon_sym_enum] = ACTIONS(3026),
    [anon_sym_class] = ACTIONS(3026),
    [anon_sym_struct] = ACTIONS(3026),
    [anon_sym_union] = ACTIONS(3026),
    [anon_sym_if] = ACTIONS(3026),
    [anon_sym_switch] = ACTIONS(3026),
    [anon_sym_case] = ACTIONS(3026),
    [anon_sym_default] = ACTIONS(3026),
    [anon_sym_while] = ACTIONS(3026),
    [anon_sym_do] = ACTIONS(3026),
    [anon_sym_for] = ACTIONS(3026),
    [anon_sym_return] = ACTIONS(3026),
    [anon_sym_break] = ACTIONS(3026),
    [anon_sym_continue] = ACTIONS(3026),
    [anon_sym_goto] = ACTIONS(3026),
    [anon_sym___try] = ACTIONS(3026),
    [anon_sym___leave] = ACTIONS(3026),
    [anon_sym_not] = ACTIONS(3026),
    [anon_sym_compl] = ACTIONS(3026),
    [anon_sym_DASH_DASH] = ACTIONS(3028),
    [anon_sym_PLUS_PLUS] = ACTIONS(3028),
    [anon_sym_sizeof] = ACTIONS(3026),
    [anon_sym___alignof__] = ACTIONS(3026),
    [anon_sym___alignof] = ACTIONS(3026),
    [anon_sym__alignof] = ACTIONS(3026),
    [anon_sym_alignof] = ACTIONS(3026),
    [anon_sym__Alignof] = ACTIONS(3026),
    [anon_sym_offsetof] = ACTIONS(3026),
    [anon_sym__Generic] = ACTIONS(3026),
    [anon_sym_asm] = ACTIONS(3026),
    [anon_sym___asm__] = ACTIONS(3026),
    [anon_sym___asm] = ACTIONS(3026),
    [sym_number_literal] = ACTIONS(3028),
    [anon_sym_L_SQUOTE] = ACTIONS(3028),
    [anon_sym_u_SQUOTE] = ACTIONS(3028),
    [anon_sym_U_SQUOTE] = ACTIONS(3028),
    [anon_sym_u8_SQUOTE] = ACTIONS(3028),
    [anon_sym_SQUOTE] = ACTIONS(3028),
    [anon_sym_L_DQUOTE] = ACTIONS(3028),
    [anon_sym_u_DQUOTE] = ACTIONS(3028),
    [anon_sym_U_DQUOTE] = ACTIONS(3028),
    [anon_sym_u8_DQUOTE] = ACTIONS(3028),
    [anon_sym_DQUOTE] = ACTIONS(3028),
    [sym_true] = ACTIONS(3026),
    [sym_false] = ACTIONS(3026),
    [anon_sym_NULL] = ACTIONS(3026),
    [anon_sym_nullptr] = ACTIONS(3026),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3026),
    [anon_sym_decltype] = ACTIONS(3026),
    [anon_sym_explicit] = ACTIONS(3026),
    [anon_sym_typename] = ACTIONS(3026),
    [anon_sym_template] = ACTIONS(3026),
    [anon_sym_operator] = ACTIONS(3026),
    [anon_sym_try] = ACTIONS(3026),
    [anon_sym_delete] = ACTIONS(3026),
    [anon_sym_throw] = ACTIONS(3026),
    [anon_sym_namespace] = ACTIONS(3026),
    [anon_sym_using] = ACTIONS(3026),
    [anon_sym_static_assert] = ACTIONS(3026),
    [anon_sym_concept] = ACTIONS(3026),
    [anon_sym_co_return] = ACTIONS(3026),
    [anon_sym_co_yield] = ACTIONS(3026),
    [anon_sym_R_DQUOTE] = ACTIONS(3028),
    [anon_sym_LR_DQUOTE] = ACTIONS(3028),
    [anon_sym_uR_DQUOTE] = ACTIONS(3028),
    [anon_sym_UR_DQUOTE] = ACTIONS(3028),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3028),
    [anon_sym_co_await] = ACTIONS(3026),
    [anon_sym_new] = ACTIONS(3026),
    [anon_sym_requires] = ACTIONS(3026),
    [sym_this] = ACTIONS(3026),
  },
  [542] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym___attribute] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_RBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym__Nonnull] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym__Alignas] = ACTIONS(3072),
    [sym_primitive_type] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [anon_sym___asm] = ACTIONS(3072),
    [sym_number_literal] = ACTIONS(3074),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [543] = {
    [sym_identifier] = ACTIONS(3076),
    [aux_sym_preproc_include_token1] = ACTIONS(3076),
    [aux_sym_preproc_def_token1] = ACTIONS(3076),
    [aux_sym_preproc_if_token1] = ACTIONS(3076),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3076),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3076),
    [sym_preproc_directive] = ACTIONS(3076),
    [anon_sym_LPAREN2] = ACTIONS(3078),
    [anon_sym_BANG] = ACTIONS(3078),
    [anon_sym_TILDE] = ACTIONS(3078),
    [anon_sym_DASH] = ACTIONS(3076),
    [anon_sym_PLUS] = ACTIONS(3076),
    [anon_sym_STAR] = ACTIONS(3078),
    [anon_sym_AMP_AMP] = ACTIONS(3078),
    [anon_sym_AMP] = ACTIONS(3076),
    [anon_sym_SEMI] = ACTIONS(3078),
    [anon_sym___extension__] = ACTIONS(3076),
    [anon_sym_typedef] = ACTIONS(3076),
    [anon_sym_virtual] = ACTIONS(3076),
    [anon_sym_extern] = ACTIONS(3076),
    [anon_sym___attribute__] = ACTIONS(3076),
    [anon_sym___attribute] = ACTIONS(3076),
    [anon_sym_COLON_COLON] = ACTIONS(3078),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3078),
    [anon_sym___declspec] = ACTIONS(3076),
    [anon_sym___based] = ACTIONS(3076),
    [anon_sym___cdecl] = ACTIONS(3076),
    [anon_sym___clrcall] = ACTIONS(3076),
    [anon_sym___stdcall] = ACTIONS(3076),
    [anon_sym___fastcall] = ACTIONS(3076),
    [anon_sym___thiscall] = ACTIONS(3076),
    [anon_sym___vectorcall] = ACTIONS(3076),
    [anon_sym_LBRACE] = ACTIONS(3078),
    [anon_sym_RBRACE] = ACTIONS(3078),
    [anon_sym_signed] = ACTIONS(3076),
    [anon_sym_unsigned] = ACTIONS(3076),
    [anon_sym_long] = ACTIONS(3076),
    [anon_sym_short] = ACTIONS(3076),
    [anon_sym_LBRACK] = ACTIONS(3076),
    [anon_sym_static] = ACTIONS(3076),
    [anon_sym_register] = ACTIONS(3076),
    [anon_sym_inline] = ACTIONS(3076),
    [anon_sym___inline] = ACTIONS(3076),
    [anon_sym___inline__] = ACTIONS(3076),
    [anon_sym___forceinline] = ACTIONS(3076),
    [anon_sym_thread_local] = ACTIONS(3076),
    [anon_sym___thread] = ACTIONS(3076),
    [anon_sym_const] = ACTIONS(3076),
    [anon_sym_constexpr] = ACTIONS(3076),
    [anon_sym_volatile] = ACTIONS(3076),
    [anon_sym_restrict] = ACTIONS(3076),
    [anon_sym___restrict__] = ACTIONS(3076),
    [anon_sym__Atomic] = ACTIONS(3076),
    [anon_sym__Noreturn] = ACTIONS(3076),
    [anon_sym_noreturn] = ACTIONS(3076),
    [anon_sym__Nonnull] = ACTIONS(3076),
    [anon_sym_mutable] = ACTIONS(3076),
    [anon_sym_constinit] = ACTIONS(3076),
    [anon_sym_consteval] = ACTIONS(3076),
    [anon_sym_alignas] = ACTIONS(3076),
    [anon_sym__Alignas] = ACTIONS(3076),
    [sym_primitive_type] = ACTIONS(3076),
    [anon_sym_enum] = ACTIONS(3076),
    [anon_sym_class] = ACTIONS(3076),
    [anon_sym_struct] = ACTIONS(3076),
    [anon_sym_union] = ACTIONS(3076),
    [anon_sym_if] = ACTIONS(3076),
    [anon_sym_switch] = ACTIONS(3076),
    [anon_sym_case] = ACTIONS(3076),
    [anon_sym_default] = ACTIONS(3076),
    [anon_sym_while] = ACTIONS(3076),
    [anon_sym_do] = ACTIONS(3076),
    [anon_sym_for] = ACTIONS(3076),
    [anon_sym_return] = ACTIONS(3076),
    [anon_sym_break] = ACTIONS(3076),
    [anon_sym_continue] = ACTIONS(3076),
    [anon_sym_goto] = ACTIONS(3076),
    [anon_sym___try] = ACTIONS(3076),
    [anon_sym___leave] = ACTIONS(3076),
    [anon_sym_not] = ACTIONS(3076),
    [anon_sym_compl] = ACTIONS(3076),
    [anon_sym_DASH_DASH] = ACTIONS(3078),
    [anon_sym_PLUS_PLUS] = ACTIONS(3078),
    [anon_sym_sizeof] = ACTIONS(3076),
    [anon_sym___alignof__] = ACTIONS(3076),
    [anon_sym___alignof] = ACTIONS(3076),
    [anon_sym__alignof] = ACTIONS(3076),
    [anon_sym_alignof] = ACTIONS(3076),
    [anon_sym__Alignof] = ACTIONS(3076),
    [anon_sym_offsetof] = ACTIONS(3076),
    [anon_sym__Generic] = ACTIONS(3076),
    [anon_sym_asm] = ACTIONS(3076),
    [anon_sym___asm__] = ACTIONS(3076),
    [anon_sym___asm] = ACTIONS(3076),
    [sym_number_literal] = ACTIONS(3078),
    [anon_sym_L_SQUOTE] = ACTIONS(3078),
    [anon_sym_u_SQUOTE] = ACTIONS(3078),
    [anon_sym_U_SQUOTE] = ACTIONS(3078),
    [anon_sym_u8_SQUOTE] = ACTIONS(3078),
    [anon_sym_SQUOTE] = ACTIONS(3078),
    [anon_sym_L_DQUOTE] = ACTIONS(3078),
    [anon_sym_u_DQUOTE] = ACTIONS(3078),
    [anon_sym_U_DQUOTE] = ACTIONS(3078),
    [anon_sym_u8_DQUOTE] = ACTIONS(3078),
    [anon_sym_DQUOTE] = ACTIONS(3078),
    [sym_true] = ACTIONS(3076),
    [sym_false] = ACTIONS(3076),
    [anon_sym_NULL] = ACTIONS(3076),
    [anon_sym_nullptr] = ACTIONS(3076),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3076),
    [anon_sym_decltype] = ACTIONS(3076),
    [anon_sym_explicit] = ACTIONS(3076),
    [anon_sym_typename] = ACTIONS(3076),
    [anon_sym_template] = ACTIONS(3076),
    [anon_sym_operator] = ACTIONS(3076),
    [anon_sym_try] = ACTIONS(3076),
    [anon_sym_delete] = ACTIONS(3076),
    [anon_sym_throw] = ACTIONS(3076),
    [anon_sym_namespace] = ACTIONS(3076),
    [anon_sym_using] = ACTIONS(3076),
    [anon_sym_static_assert] = ACTIONS(3076),
    [anon_sym_concept] = ACTIONS(3076),
    [anon_sym_co_return] = ACTIONS(3076),
    [anon_sym_co_yield] = ACTIONS(3076),
    [anon_sym_R_DQUOTE] = ACTIONS(3078),
    [anon_sym_LR_DQUOTE] = ACTIONS(3078),
    [anon_sym_uR_DQUOTE] = ACTIONS(3078),
    [anon_sym_UR_DQUOTE] = ACTIONS(3078),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3078),
    [anon_sym_co_await] = ACTIONS(3076),
    [anon_sym_new] = ACTIONS(3076),
    [anon_sym_requires] = ACTIONS(3076),
    [sym_this] = ACTIONS(3076),
  },
  [544] = {
    [sym_identifier] = ACTIONS(2805),
    [aux_sym_preproc_include_token1] = ACTIONS(2805),
    [aux_sym_preproc_def_token1] = ACTIONS(2805),
    [aux_sym_preproc_if_token1] = ACTIONS(2805),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2805),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2805),
    [sym_preproc_directive] = ACTIONS(2805),
    [anon_sym_LPAREN2] = ACTIONS(2807),
    [anon_sym_BANG] = ACTIONS(2807),
    [anon_sym_TILDE] = ACTIONS(2807),
    [anon_sym_DASH] = ACTIONS(2805),
    [anon_sym_PLUS] = ACTIONS(2805),
    [anon_sym_STAR] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2805),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym___extension__] = ACTIONS(2805),
    [anon_sym_typedef] = ACTIONS(2805),
    [anon_sym_virtual] = ACTIONS(2805),
    [anon_sym_extern] = ACTIONS(2805),
    [anon_sym___attribute__] = ACTIONS(2805),
    [anon_sym___attribute] = ACTIONS(2805),
    [anon_sym_COLON_COLON] = ACTIONS(2807),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2807),
    [anon_sym___declspec] = ACTIONS(2805),
    [anon_sym___based] = ACTIONS(2805),
    [anon_sym___cdecl] = ACTIONS(2805),
    [anon_sym___clrcall] = ACTIONS(2805),
    [anon_sym___stdcall] = ACTIONS(2805),
    [anon_sym___fastcall] = ACTIONS(2805),
    [anon_sym___thiscall] = ACTIONS(2805),
    [anon_sym___vectorcall] = ACTIONS(2805),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_RBRACE] = ACTIONS(2807),
    [anon_sym_signed] = ACTIONS(2805),
    [anon_sym_unsigned] = ACTIONS(2805),
    [anon_sym_long] = ACTIONS(2805),
    [anon_sym_short] = ACTIONS(2805),
    [anon_sym_LBRACK] = ACTIONS(2805),
    [anon_sym_static] = ACTIONS(2805),
    [anon_sym_register] = ACTIONS(2805),
    [anon_sym_inline] = ACTIONS(2805),
    [anon_sym___inline] = ACTIONS(2805),
    [anon_sym___inline__] = ACTIONS(2805),
    [anon_sym___forceinline] = ACTIONS(2805),
    [anon_sym_thread_local] = ACTIONS(2805),
    [anon_sym___thread] = ACTIONS(2805),
    [anon_sym_const] = ACTIONS(2805),
    [anon_sym_constexpr] = ACTIONS(2805),
    [anon_sym_volatile] = ACTIONS(2805),
    [anon_sym_restrict] = ACTIONS(2805),
    [anon_sym___restrict__] = ACTIONS(2805),
    [anon_sym__Atomic] = ACTIONS(2805),
    [anon_sym__Noreturn] = ACTIONS(2805),
    [anon_sym_noreturn] = ACTIONS(2805),
    [anon_sym__Nonnull] = ACTIONS(2805),
    [anon_sym_mutable] = ACTIONS(2805),
    [anon_sym_constinit] = ACTIONS(2805),
    [anon_sym_consteval] = ACTIONS(2805),
    [anon_sym_alignas] = ACTIONS(2805),
    [anon_sym__Alignas] = ACTIONS(2805),
    [sym_primitive_type] = ACTIONS(2805),
    [anon_sym_enum] = ACTIONS(2805),
    [anon_sym_class] = ACTIONS(2805),
    [anon_sym_struct] = ACTIONS(2805),
    [anon_sym_union] = ACTIONS(2805),
    [anon_sym_if] = ACTIONS(2805),
    [anon_sym_switch] = ACTIONS(2805),
    [anon_sym_case] = ACTIONS(2805),
    [anon_sym_default] = ACTIONS(2805),
    [anon_sym_while] = ACTIONS(2805),
    [anon_sym_do] = ACTIONS(2805),
    [anon_sym_for] = ACTIONS(2805),
    [anon_sym_return] = ACTIONS(2805),
    [anon_sym_break] = ACTIONS(2805),
    [anon_sym_continue] = ACTIONS(2805),
    [anon_sym_goto] = ACTIONS(2805),
    [anon_sym___try] = ACTIONS(2805),
    [anon_sym___leave] = ACTIONS(2805),
    [anon_sym_not] = ACTIONS(2805),
    [anon_sym_compl] = ACTIONS(2805),
    [anon_sym_DASH_DASH] = ACTIONS(2807),
    [anon_sym_PLUS_PLUS] = ACTIONS(2807),
    [anon_sym_sizeof] = ACTIONS(2805),
    [anon_sym___alignof__] = ACTIONS(2805),
    [anon_sym___alignof] = ACTIONS(2805),
    [anon_sym__alignof] = ACTIONS(2805),
    [anon_sym_alignof] = ACTIONS(2805),
    [anon_sym__Alignof] = ACTIONS(2805),
    [anon_sym_offsetof] = ACTIONS(2805),
    [anon_sym__Generic] = ACTIONS(2805),
    [anon_sym_asm] = ACTIONS(2805),
    [anon_sym___asm__] = ACTIONS(2805),
    [anon_sym___asm] = ACTIONS(2805),
    [sym_number_literal] = ACTIONS(2807),
    [anon_sym_L_SQUOTE] = ACTIONS(2807),
    [anon_sym_u_SQUOTE] = ACTIONS(2807),
    [anon_sym_U_SQUOTE] = ACTIONS(2807),
    [anon_sym_u8_SQUOTE] = ACTIONS(2807),
    [anon_sym_SQUOTE] = ACTIONS(2807),
    [anon_sym_L_DQUOTE] = ACTIONS(2807),
    [anon_sym_u_DQUOTE] = ACTIONS(2807),
    [anon_sym_U_DQUOTE] = ACTIONS(2807),
    [anon_sym_u8_DQUOTE] = ACTIONS(2807),
    [anon_sym_DQUOTE] = ACTIONS(2807),
    [sym_true] = ACTIONS(2805),
    [sym_false] = ACTIONS(2805),
    [anon_sym_NULL] = ACTIONS(2805),
    [anon_sym_nullptr] = ACTIONS(2805),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2805),
    [anon_sym_decltype] = ACTIONS(2805),
    [anon_sym_explicit] = ACTIONS(2805),
    [anon_sym_typename] = ACTIONS(2805),
    [anon_sym_template] = ACTIONS(2805),
    [anon_sym_operator] = ACTIONS(2805),
    [anon_sym_try] = ACTIONS(2805),
    [anon_sym_delete] = ACTIONS(2805),
    [anon_sym_throw] = ACTIONS(2805),
    [anon_sym_namespace] = ACTIONS(2805),
    [anon_sym_using] = ACTIONS(2805),
    [anon_sym_static_assert] = ACTIONS(2805),
    [anon_sym_concept] = ACTIONS(2805),
    [anon_sym_co_return] = ACTIONS(2805),
    [anon_sym_co_yield] = ACTIONS(2805),
    [anon_sym_R_DQUOTE] = ACTIONS(2807),
    [anon_sym_LR_DQUOTE] = ACTIONS(2807),
    [anon_sym_uR_DQUOTE] = ACTIONS(2807),
    [anon_sym_UR_DQUOTE] = ACTIONS(2807),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2807),
    [anon_sym_co_await] = ACTIONS(2805),
    [anon_sym_new] = ACTIONS(2805),
    [anon_sym_requires] = ACTIONS(2805),
    [sym_this] = ACTIONS(2805),
  },
  [545] = {
    [sym_identifier] = ACTIONS(3082),
    [aux_sym_preproc_include_token1] = ACTIONS(3082),
    [aux_sym_preproc_def_token1] = ACTIONS(3082),
    [aux_sym_preproc_if_token1] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3082),
    [sym_preproc_directive] = ACTIONS(3082),
    [anon_sym_LPAREN2] = ACTIONS(3084),
    [anon_sym_BANG] = ACTIONS(3084),
    [anon_sym_TILDE] = ACTIONS(3084),
    [anon_sym_DASH] = ACTIONS(3082),
    [anon_sym_PLUS] = ACTIONS(3082),
    [anon_sym_STAR] = ACTIONS(3084),
    [anon_sym_AMP_AMP] = ACTIONS(3084),
    [anon_sym_AMP] = ACTIONS(3082),
    [anon_sym_SEMI] = ACTIONS(3084),
    [anon_sym___extension__] = ACTIONS(3082),
    [anon_sym_typedef] = ACTIONS(3082),
    [anon_sym_virtual] = ACTIONS(3082),
    [anon_sym_extern] = ACTIONS(3082),
    [anon_sym___attribute__] = ACTIONS(3082),
    [anon_sym___attribute] = ACTIONS(3082),
    [anon_sym_COLON_COLON] = ACTIONS(3084),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3084),
    [anon_sym___declspec] = ACTIONS(3082),
    [anon_sym___based] = ACTIONS(3082),
    [anon_sym___cdecl] = ACTIONS(3082),
    [anon_sym___clrcall] = ACTIONS(3082),
    [anon_sym___stdcall] = ACTIONS(3082),
    [anon_sym___fastcall] = ACTIONS(3082),
    [anon_sym___thiscall] = ACTIONS(3082),
    [anon_sym___vectorcall] = ACTIONS(3082),
    [anon_sym_LBRACE] = ACTIONS(3084),
    [anon_sym_RBRACE] = ACTIONS(3084),
    [anon_sym_signed] = ACTIONS(3082),
    [anon_sym_unsigned] = ACTIONS(3082),
    [anon_sym_long] = ACTIONS(3082),
    [anon_sym_short] = ACTIONS(3082),
    [anon_sym_LBRACK] = ACTIONS(3082),
    [anon_sym_static] = ACTIONS(3082),
    [anon_sym_register] = ACTIONS(3082),
    [anon_sym_inline] = ACTIONS(3082),
    [anon_sym___inline] = ACTIONS(3082),
    [anon_sym___inline__] = ACTIONS(3082),
    [anon_sym___forceinline] = ACTIONS(3082),
    [anon_sym_thread_local] = ACTIONS(3082),
    [anon_sym___thread] = ACTIONS(3082),
    [anon_sym_const] = ACTIONS(3082),
    [anon_sym_constexpr] = ACTIONS(3082),
    [anon_sym_volatile] = ACTIONS(3082),
    [anon_sym_restrict] = ACTIONS(3082),
    [anon_sym___restrict__] = ACTIONS(3082),
    [anon_sym__Atomic] = ACTIONS(3082),
    [anon_sym__Noreturn] = ACTIONS(3082),
    [anon_sym_noreturn] = ACTIONS(3082),
    [anon_sym__Nonnull] = ACTIONS(3082),
    [anon_sym_mutable] = ACTIONS(3082),
    [anon_sym_constinit] = ACTIONS(3082),
    [anon_sym_consteval] = ACTIONS(3082),
    [anon_sym_alignas] = ACTIONS(3082),
    [anon_sym__Alignas] = ACTIONS(3082),
    [sym_primitive_type] = ACTIONS(3082),
    [anon_sym_enum] = ACTIONS(3082),
    [anon_sym_class] = ACTIONS(3082),
    [anon_sym_struct] = ACTIONS(3082),
    [anon_sym_union] = ACTIONS(3082),
    [anon_sym_if] = ACTIONS(3082),
    [anon_sym_switch] = ACTIONS(3082),
    [anon_sym_case] = ACTIONS(3082),
    [anon_sym_default] = ACTIONS(3082),
    [anon_sym_while] = ACTIONS(3082),
    [anon_sym_do] = ACTIONS(3082),
    [anon_sym_for] = ACTIONS(3082),
    [anon_sym_return] = ACTIONS(3082),
    [anon_sym_break] = ACTIONS(3082),
    [anon_sym_continue] = ACTIONS(3082),
    [anon_sym_goto] = ACTIONS(3082),
    [anon_sym___try] = ACTIONS(3082),
    [anon_sym___leave] = ACTIONS(3082),
    [anon_sym_not] = ACTIONS(3082),
    [anon_sym_compl] = ACTIONS(3082),
    [anon_sym_DASH_DASH] = ACTIONS(3084),
    [anon_sym_PLUS_PLUS] = ACTIONS(3084),
    [anon_sym_sizeof] = ACTIONS(3082),
    [anon_sym___alignof__] = ACTIONS(3082),
    [anon_sym___alignof] = ACTIONS(3082),
    [anon_sym__alignof] = ACTIONS(3082),
    [anon_sym_alignof] = ACTIONS(3082),
    [anon_sym__Alignof] = ACTIONS(3082),
    [anon_sym_offsetof] = ACTIONS(3082),
    [anon_sym__Generic] = ACTIONS(3082),
    [anon_sym_asm] = ACTIONS(3082),
    [anon_sym___asm__] = ACTIONS(3082),
    [anon_sym___asm] = ACTIONS(3082),
    [sym_number_literal] = ACTIONS(3084),
    [anon_sym_L_SQUOTE] = ACTIONS(3084),
    [anon_sym_u_SQUOTE] = ACTIONS(3084),
    [anon_sym_U_SQUOTE] = ACTIONS(3084),
    [anon_sym_u8_SQUOTE] = ACTIONS(3084),
    [anon_sym_SQUOTE] = ACTIONS(3084),
    [anon_sym_L_DQUOTE] = ACTIONS(3084),
    [anon_sym_u_DQUOTE] = ACTIONS(3084),
    [anon_sym_U_DQUOTE] = ACTIONS(3084),
    [anon_sym_u8_DQUOTE] = ACTIONS(3084),
    [anon_sym_DQUOTE] = ACTIONS(3084),
    [sym_true] = ACTIONS(3082),
    [sym_false] = ACTIONS(3082),
    [anon_sym_NULL] = ACTIONS(3082),
    [anon_sym_nullptr] = ACTIONS(3082),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3082),
    [anon_sym_decltype] = ACTIONS(3082),
    [anon_sym_explicit] = ACTIONS(3082),
    [anon_sym_typename] = ACTIONS(3082),
    [anon_sym_template] = ACTIONS(3082),
    [anon_sym_operator] = ACTIONS(3082),
    [anon_sym_try] = ACTIONS(3082),
    [anon_sym_delete] = ACTIONS(3082),
    [anon_sym_throw] = ACTIONS(3082),
    [anon_sym_namespace] = ACTIONS(3082),
    [anon_sym_using] = ACTIONS(3082),
    [anon_sym_static_assert] = ACTIONS(3082),
    [anon_sym_concept] = ACTIONS(3082),
    [anon_sym_co_return] = ACTIONS(3082),
    [anon_sym_co_yield] = ACTIONS(3082),
    [anon_sym_R_DQUOTE] = ACTIONS(3084),
    [anon_sym_LR_DQUOTE] = ACTIONS(3084),
    [anon_sym_uR_DQUOTE] = ACTIONS(3084),
    [anon_sym_UR_DQUOTE] = ACTIONS(3084),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3084),
    [anon_sym_co_await] = ACTIONS(3082),
    [anon_sym_new] = ACTIONS(3082),
    [anon_sym_requires] = ACTIONS(3082),
    [sym_this] = ACTIONS(3082),
  },
  [546] = {
    [sym_identifier] = ACTIONS(2809),
    [aux_sym_preproc_include_token1] = ACTIONS(2809),
    [aux_sym_preproc_def_token1] = ACTIONS(2809),
    [aux_sym_preproc_if_token1] = ACTIONS(2809),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2809),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2809),
    [sym_preproc_directive] = ACTIONS(2809),
    [anon_sym_LPAREN2] = ACTIONS(2811),
    [anon_sym_BANG] = ACTIONS(2811),
    [anon_sym_TILDE] = ACTIONS(2811),
    [anon_sym_DASH] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_STAR] = ACTIONS(2811),
    [anon_sym_AMP_AMP] = ACTIONS(2811),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2811),
    [anon_sym___extension__] = ACTIONS(2809),
    [anon_sym_typedef] = ACTIONS(2809),
    [anon_sym_virtual] = ACTIONS(2809),
    [anon_sym_extern] = ACTIONS(2809),
    [anon_sym___attribute__] = ACTIONS(2809),
    [anon_sym___attribute] = ACTIONS(2809),
    [anon_sym_COLON_COLON] = ACTIONS(2811),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2811),
    [anon_sym___declspec] = ACTIONS(2809),
    [anon_sym___based] = ACTIONS(2809),
    [anon_sym___cdecl] = ACTIONS(2809),
    [anon_sym___clrcall] = ACTIONS(2809),
    [anon_sym___stdcall] = ACTIONS(2809),
    [anon_sym___fastcall] = ACTIONS(2809),
    [anon_sym___thiscall] = ACTIONS(2809),
    [anon_sym___vectorcall] = ACTIONS(2809),
    [anon_sym_LBRACE] = ACTIONS(2811),
    [anon_sym_RBRACE] = ACTIONS(2811),
    [anon_sym_signed] = ACTIONS(2809),
    [anon_sym_unsigned] = ACTIONS(2809),
    [anon_sym_long] = ACTIONS(2809),
    [anon_sym_short] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2809),
    [anon_sym_static] = ACTIONS(2809),
    [anon_sym_register] = ACTIONS(2809),
    [anon_sym_inline] = ACTIONS(2809),
    [anon_sym___inline] = ACTIONS(2809),
    [anon_sym___inline__] = ACTIONS(2809),
    [anon_sym___forceinline] = ACTIONS(2809),
    [anon_sym_thread_local] = ACTIONS(2809),
    [anon_sym___thread] = ACTIONS(2809),
    [anon_sym_const] = ACTIONS(2809),
    [anon_sym_constexpr] = ACTIONS(2809),
    [anon_sym_volatile] = ACTIONS(2809),
    [anon_sym_restrict] = ACTIONS(2809),
    [anon_sym___restrict__] = ACTIONS(2809),
    [anon_sym__Atomic] = ACTIONS(2809),
    [anon_sym__Noreturn] = ACTIONS(2809),
    [anon_sym_noreturn] = ACTIONS(2809),
    [anon_sym__Nonnull] = ACTIONS(2809),
    [anon_sym_mutable] = ACTIONS(2809),
    [anon_sym_constinit] = ACTIONS(2809),
    [anon_sym_consteval] = ACTIONS(2809),
    [anon_sym_alignas] = ACTIONS(2809),
    [anon_sym__Alignas] = ACTIONS(2809),
    [sym_primitive_type] = ACTIONS(2809),
    [anon_sym_enum] = ACTIONS(2809),
    [anon_sym_class] = ACTIONS(2809),
    [anon_sym_struct] = ACTIONS(2809),
    [anon_sym_union] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(2809),
    [anon_sym_switch] = ACTIONS(2809),
    [anon_sym_case] = ACTIONS(2809),
    [anon_sym_default] = ACTIONS(2809),
    [anon_sym_while] = ACTIONS(2809),
    [anon_sym_do] = ACTIONS(2809),
    [anon_sym_for] = ACTIONS(2809),
    [anon_sym_return] = ACTIONS(2809),
    [anon_sym_break] = ACTIONS(2809),
    [anon_sym_continue] = ACTIONS(2809),
    [anon_sym_goto] = ACTIONS(2809),
    [anon_sym___try] = ACTIONS(2809),
    [anon_sym___leave] = ACTIONS(2809),
    [anon_sym_not] = ACTIONS(2809),
    [anon_sym_compl] = ACTIONS(2809),
    [anon_sym_DASH_DASH] = ACTIONS(2811),
    [anon_sym_PLUS_PLUS] = ACTIONS(2811),
    [anon_sym_sizeof] = ACTIONS(2809),
    [anon_sym___alignof__] = ACTIONS(2809),
    [anon_sym___alignof] = ACTIONS(2809),
    [anon_sym__alignof] = ACTIONS(2809),
    [anon_sym_alignof] = ACTIONS(2809),
    [anon_sym__Alignof] = ACTIONS(2809),
    [anon_sym_offsetof] = ACTIONS(2809),
    [anon_sym__Generic] = ACTIONS(2809),
    [anon_sym_asm] = ACTIONS(2809),
    [anon_sym___asm__] = ACTIONS(2809),
    [anon_sym___asm] = ACTIONS(2809),
    [sym_number_literal] = ACTIONS(2811),
    [anon_sym_L_SQUOTE] = ACTIONS(2811),
    [anon_sym_u_SQUOTE] = ACTIONS(2811),
    [anon_sym_U_SQUOTE] = ACTIONS(2811),
    [anon_sym_u8_SQUOTE] = ACTIONS(2811),
    [anon_sym_SQUOTE] = ACTIONS(2811),
    [anon_sym_L_DQUOTE] = ACTIONS(2811),
    [anon_sym_u_DQUOTE] = ACTIONS(2811),
    [anon_sym_U_DQUOTE] = ACTIONS(2811),
    [anon_sym_u8_DQUOTE] = ACTIONS(2811),
    [anon_sym_DQUOTE] = ACTIONS(2811),
    [sym_true] = ACTIONS(2809),
    [sym_false] = ACTIONS(2809),
    [anon_sym_NULL] = ACTIONS(2809),
    [anon_sym_nullptr] = ACTIONS(2809),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2809),
    [anon_sym_decltype] = ACTIONS(2809),
    [anon_sym_explicit] = ACTIONS(2809),
    [anon_sym_typename] = ACTIONS(2809),
    [anon_sym_template] = ACTIONS(2809),
    [anon_sym_operator] = ACTIONS(2809),
    [anon_sym_try] = ACTIONS(2809),
    [anon_sym_delete] = ACTIONS(2809),
    [anon_sym_throw] = ACTIONS(2809),
    [anon_sym_namespace] = ACTIONS(2809),
    [anon_sym_using] = ACTIONS(2809),
    [anon_sym_static_assert] = ACTIONS(2809),
    [anon_sym_concept] = ACTIONS(2809),
    [anon_sym_co_return] = ACTIONS(2809),
    [anon_sym_co_yield] = ACTIONS(2809),
    [anon_sym_R_DQUOTE] = ACTIONS(2811),
    [anon_sym_LR_DQUOTE] = ACTIONS(2811),
    [anon_sym_uR_DQUOTE] = ACTIONS(2811),
    [anon_sym_UR_DQUOTE] = ACTIONS(2811),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2811),
    [anon_sym_co_await] = ACTIONS(2809),
    [anon_sym_new] = ACTIONS(2809),
    [anon_sym_requires] = ACTIONS(2809),
    [sym_this] = ACTIONS(2809),
  },
  [547] = {
    [sym_identifier] = ACTIONS(2763),
    [aux_sym_preproc_include_token1] = ACTIONS(2763),
    [aux_sym_preproc_def_token1] = ACTIONS(2763),
    [aux_sym_preproc_if_token1] = ACTIONS(2763),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2763),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2763),
    [sym_preproc_directive] = ACTIONS(2763),
    [anon_sym_LPAREN2] = ACTIONS(2765),
    [anon_sym_BANG] = ACTIONS(2765),
    [anon_sym_TILDE] = ACTIONS(2765),
    [anon_sym_DASH] = ACTIONS(2763),
    [anon_sym_PLUS] = ACTIONS(2763),
    [anon_sym_STAR] = ACTIONS(2765),
    [anon_sym_AMP_AMP] = ACTIONS(2765),
    [anon_sym_AMP] = ACTIONS(2763),
    [anon_sym_SEMI] = ACTIONS(2765),
    [anon_sym___extension__] = ACTIONS(2763),
    [anon_sym_typedef] = ACTIONS(2763),
    [anon_sym_virtual] = ACTIONS(2763),
    [anon_sym_extern] = ACTIONS(2763),
    [anon_sym___attribute__] = ACTIONS(2763),
    [anon_sym___attribute] = ACTIONS(2763),
    [anon_sym_COLON_COLON] = ACTIONS(2765),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2765),
    [anon_sym___declspec] = ACTIONS(2763),
    [anon_sym___based] = ACTIONS(2763),
    [anon_sym___cdecl] = ACTIONS(2763),
    [anon_sym___clrcall] = ACTIONS(2763),
    [anon_sym___stdcall] = ACTIONS(2763),
    [anon_sym___fastcall] = ACTIONS(2763),
    [anon_sym___thiscall] = ACTIONS(2763),
    [anon_sym___vectorcall] = ACTIONS(2763),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_RBRACE] = ACTIONS(2765),
    [anon_sym_signed] = ACTIONS(2763),
    [anon_sym_unsigned] = ACTIONS(2763),
    [anon_sym_long] = ACTIONS(2763),
    [anon_sym_short] = ACTIONS(2763),
    [anon_sym_LBRACK] = ACTIONS(2763),
    [anon_sym_static] = ACTIONS(2763),
    [anon_sym_register] = ACTIONS(2763),
    [anon_sym_inline] = ACTIONS(2763),
    [anon_sym___inline] = ACTIONS(2763),
    [anon_sym___inline__] = ACTIONS(2763),
    [anon_sym___forceinline] = ACTIONS(2763),
    [anon_sym_thread_local] = ACTIONS(2763),
    [anon_sym___thread] = ACTIONS(2763),
    [anon_sym_const] = ACTIONS(2763),
    [anon_sym_constexpr] = ACTIONS(2763),
    [anon_sym_volatile] = ACTIONS(2763),
    [anon_sym_restrict] = ACTIONS(2763),
    [anon_sym___restrict__] = ACTIONS(2763),
    [anon_sym__Atomic] = ACTIONS(2763),
    [anon_sym__Noreturn] = ACTIONS(2763),
    [anon_sym_noreturn] = ACTIONS(2763),
    [anon_sym__Nonnull] = ACTIONS(2763),
    [anon_sym_mutable] = ACTIONS(2763),
    [anon_sym_constinit] = ACTIONS(2763),
    [anon_sym_consteval] = ACTIONS(2763),
    [anon_sym_alignas] = ACTIONS(2763),
    [anon_sym__Alignas] = ACTIONS(2763),
    [sym_primitive_type] = ACTIONS(2763),
    [anon_sym_enum] = ACTIONS(2763),
    [anon_sym_class] = ACTIONS(2763),
    [anon_sym_struct] = ACTIONS(2763),
    [anon_sym_union] = ACTIONS(2763),
    [anon_sym_if] = ACTIONS(2763),
    [anon_sym_switch] = ACTIONS(2763),
    [anon_sym_case] = ACTIONS(2763),
    [anon_sym_default] = ACTIONS(2763),
    [anon_sym_while] = ACTIONS(2763),
    [anon_sym_do] = ACTIONS(2763),
    [anon_sym_for] = ACTIONS(2763),
    [anon_sym_return] = ACTIONS(2763),
    [anon_sym_break] = ACTIONS(2763),
    [anon_sym_continue] = ACTIONS(2763),
    [anon_sym_goto] = ACTIONS(2763),
    [anon_sym___try] = ACTIONS(2763),
    [anon_sym___leave] = ACTIONS(2763),
    [anon_sym_not] = ACTIONS(2763),
    [anon_sym_compl] = ACTIONS(2763),
    [anon_sym_DASH_DASH] = ACTIONS(2765),
    [anon_sym_PLUS_PLUS] = ACTIONS(2765),
    [anon_sym_sizeof] = ACTIONS(2763),
    [anon_sym___alignof__] = ACTIONS(2763),
    [anon_sym___alignof] = ACTIONS(2763),
    [anon_sym__alignof] = ACTIONS(2763),
    [anon_sym_alignof] = ACTIONS(2763),
    [anon_sym__Alignof] = ACTIONS(2763),
    [anon_sym_offsetof] = ACTIONS(2763),
    [anon_sym__Generic] = ACTIONS(2763),
    [anon_sym_asm] = ACTIONS(2763),
    [anon_sym___asm__] = ACTIONS(2763),
    [anon_sym___asm] = ACTIONS(2763),
    [sym_number_literal] = ACTIONS(2765),
    [anon_sym_L_SQUOTE] = ACTIONS(2765),
    [anon_sym_u_SQUOTE] = ACTIONS(2765),
    [anon_sym_U_SQUOTE] = ACTIONS(2765),
    [anon_sym_u8_SQUOTE] = ACTIONS(2765),
    [anon_sym_SQUOTE] = ACTIONS(2765),
    [anon_sym_L_DQUOTE] = ACTIONS(2765),
    [anon_sym_u_DQUOTE] = ACTIONS(2765),
    [anon_sym_U_DQUOTE] = ACTIONS(2765),
    [anon_sym_u8_DQUOTE] = ACTIONS(2765),
    [anon_sym_DQUOTE] = ACTIONS(2765),
    [sym_true] = ACTIONS(2763),
    [sym_false] = ACTIONS(2763),
    [anon_sym_NULL] = ACTIONS(2763),
    [anon_sym_nullptr] = ACTIONS(2763),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2763),
    [anon_sym_decltype] = ACTIONS(2763),
    [anon_sym_explicit] = ACTIONS(2763),
    [anon_sym_typename] = ACTIONS(2763),
    [anon_sym_template] = ACTIONS(2763),
    [anon_sym_operator] = ACTIONS(2763),
    [anon_sym_try] = ACTIONS(2763),
    [anon_sym_delete] = ACTIONS(2763),
    [anon_sym_throw] = ACTIONS(2763),
    [anon_sym_namespace] = ACTIONS(2763),
    [anon_sym_using] = ACTIONS(2763),
    [anon_sym_static_assert] = ACTIONS(2763),
    [anon_sym_concept] = ACTIONS(2763),
    [anon_sym_co_return] = ACTIONS(2763),
    [anon_sym_co_yield] = ACTIONS(2763),
    [anon_sym_R_DQUOTE] = ACTIONS(2765),
    [anon_sym_LR_DQUOTE] = ACTIONS(2765),
    [anon_sym_uR_DQUOTE] = ACTIONS(2765),
    [anon_sym_UR_DQUOTE] = ACTIONS(2765),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2765),
    [anon_sym_co_await] = ACTIONS(2763),
    [anon_sym_new] = ACTIONS(2763),
    [anon_sym_requires] = ACTIONS(2763),
    [sym_this] = ACTIONS(2763),
  },
  [548] = {
    [sym_identifier] = ACTIONS(3046),
    [aux_sym_preproc_include_token1] = ACTIONS(3046),
    [aux_sym_preproc_def_token1] = ACTIONS(3046),
    [aux_sym_preproc_if_token1] = ACTIONS(3046),
    [aux_sym_preproc_if_token2] = ACTIONS(3046),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3046),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3046),
    [sym_preproc_directive] = ACTIONS(3046),
    [anon_sym_LPAREN2] = ACTIONS(3048),
    [anon_sym_BANG] = ACTIONS(3048),
    [anon_sym_TILDE] = ACTIONS(3048),
    [anon_sym_DASH] = ACTIONS(3046),
    [anon_sym_PLUS] = ACTIONS(3046),
    [anon_sym_STAR] = ACTIONS(3048),
    [anon_sym_AMP_AMP] = ACTIONS(3048),
    [anon_sym_AMP] = ACTIONS(3046),
    [anon_sym_SEMI] = ACTIONS(3048),
    [anon_sym___extension__] = ACTIONS(3046),
    [anon_sym_typedef] = ACTIONS(3046),
    [anon_sym_virtual] = ACTIONS(3046),
    [anon_sym_extern] = ACTIONS(3046),
    [anon_sym___attribute__] = ACTIONS(3046),
    [anon_sym___attribute] = ACTIONS(3046),
    [anon_sym_COLON_COLON] = ACTIONS(3048),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3048),
    [anon_sym___declspec] = ACTIONS(3046),
    [anon_sym___based] = ACTIONS(3046),
    [anon_sym___cdecl] = ACTIONS(3046),
    [anon_sym___clrcall] = ACTIONS(3046),
    [anon_sym___stdcall] = ACTIONS(3046),
    [anon_sym___fastcall] = ACTIONS(3046),
    [anon_sym___thiscall] = ACTIONS(3046),
    [anon_sym___vectorcall] = ACTIONS(3046),
    [anon_sym_LBRACE] = ACTIONS(3048),
    [anon_sym_signed] = ACTIONS(3046),
    [anon_sym_unsigned] = ACTIONS(3046),
    [anon_sym_long] = ACTIONS(3046),
    [anon_sym_short] = ACTIONS(3046),
    [anon_sym_LBRACK] = ACTIONS(3046),
    [anon_sym_static] = ACTIONS(3046),
    [anon_sym_register] = ACTIONS(3046),
    [anon_sym_inline] = ACTIONS(3046),
    [anon_sym___inline] = ACTIONS(3046),
    [anon_sym___inline__] = ACTIONS(3046),
    [anon_sym___forceinline] = ACTIONS(3046),
    [anon_sym_thread_local] = ACTIONS(3046),
    [anon_sym___thread] = ACTIONS(3046),
    [anon_sym_const] = ACTIONS(3046),
    [anon_sym_constexpr] = ACTIONS(3046),
    [anon_sym_volatile] = ACTIONS(3046),
    [anon_sym_restrict] = ACTIONS(3046),
    [anon_sym___restrict__] = ACTIONS(3046),
    [anon_sym__Atomic] = ACTIONS(3046),
    [anon_sym__Noreturn] = ACTIONS(3046),
    [anon_sym_noreturn] = ACTIONS(3046),
    [anon_sym__Nonnull] = ACTIONS(3046),
    [anon_sym_mutable] = ACTIONS(3046),
    [anon_sym_constinit] = ACTIONS(3046),
    [anon_sym_consteval] = ACTIONS(3046),
    [anon_sym_alignas] = ACTIONS(3046),
    [anon_sym__Alignas] = ACTIONS(3046),
    [sym_primitive_type] = ACTIONS(3046),
    [anon_sym_enum] = ACTIONS(3046),
    [anon_sym_class] = ACTIONS(3046),
    [anon_sym_struct] = ACTIONS(3046),
    [anon_sym_union] = ACTIONS(3046),
    [anon_sym_if] = ACTIONS(3046),
    [anon_sym_switch] = ACTIONS(3046),
    [anon_sym_case] = ACTIONS(3046),
    [anon_sym_default] = ACTIONS(3046),
    [anon_sym_while] = ACTIONS(3046),
    [anon_sym_do] = ACTIONS(3046),
    [anon_sym_for] = ACTIONS(3046),
    [anon_sym_return] = ACTIONS(3046),
    [anon_sym_break] = ACTIONS(3046),
    [anon_sym_continue] = ACTIONS(3046),
    [anon_sym_goto] = ACTIONS(3046),
    [anon_sym___try] = ACTIONS(3046),
    [anon_sym___leave] = ACTIONS(3046),
    [anon_sym_not] = ACTIONS(3046),
    [anon_sym_compl] = ACTIONS(3046),
    [anon_sym_DASH_DASH] = ACTIONS(3048),
    [anon_sym_PLUS_PLUS] = ACTIONS(3048),
    [anon_sym_sizeof] = ACTIONS(3046),
    [anon_sym___alignof__] = ACTIONS(3046),
    [anon_sym___alignof] = ACTIONS(3046),
    [anon_sym__alignof] = ACTIONS(3046),
    [anon_sym_alignof] = ACTIONS(3046),
    [anon_sym__Alignof] = ACTIONS(3046),
    [anon_sym_offsetof] = ACTIONS(3046),
    [anon_sym__Generic] = ACTIONS(3046),
    [anon_sym_asm] = ACTIONS(3046),
    [anon_sym___asm__] = ACTIONS(3046),
    [anon_sym___asm] = ACTIONS(3046),
    [sym_number_literal] = ACTIONS(3048),
    [anon_sym_L_SQUOTE] = ACTIONS(3048),
    [anon_sym_u_SQUOTE] = ACTIONS(3048),
    [anon_sym_U_SQUOTE] = ACTIONS(3048),
    [anon_sym_u8_SQUOTE] = ACTIONS(3048),
    [anon_sym_SQUOTE] = ACTIONS(3048),
    [anon_sym_L_DQUOTE] = ACTIONS(3048),
    [anon_sym_u_DQUOTE] = ACTIONS(3048),
    [anon_sym_U_DQUOTE] = ACTIONS(3048),
    [anon_sym_u8_DQUOTE] = ACTIONS(3048),
    [anon_sym_DQUOTE] = ACTIONS(3048),
    [sym_true] = ACTIONS(3046),
    [sym_false] = ACTIONS(3046),
    [anon_sym_NULL] = ACTIONS(3046),
    [anon_sym_nullptr] = ACTIONS(3046),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3046),
    [anon_sym_decltype] = ACTIONS(3046),
    [anon_sym_explicit] = ACTIONS(3046),
    [anon_sym_typename] = ACTIONS(3046),
    [anon_sym_template] = ACTIONS(3046),
    [anon_sym_operator] = ACTIONS(3046),
    [anon_sym_try] = ACTIONS(3046),
    [anon_sym_delete] = ACTIONS(3046),
    [anon_sym_throw] = ACTIONS(3046),
    [anon_sym_namespace] = ACTIONS(3046),
    [anon_sym_using] = ACTIONS(3046),
    [anon_sym_static_assert] = ACTIONS(3046),
    [anon_sym_concept] = ACTIONS(3046),
    [anon_sym_co_return] = ACTIONS(3046),
    [anon_sym_co_yield] = ACTIONS(3046),
    [anon_sym_R_DQUOTE] = ACTIONS(3048),
    [anon_sym_LR_DQUOTE] = ACTIONS(3048),
    [anon_sym_uR_DQUOTE] = ACTIONS(3048),
    [anon_sym_UR_DQUOTE] = ACTIONS(3048),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3048),
    [anon_sym_co_await] = ACTIONS(3046),
    [anon_sym_new] = ACTIONS(3046),
    [anon_sym_requires] = ACTIONS(3046),
    [sym_this] = ACTIONS(3046),
  },
  [549] = {
    [sym_identifier] = ACTIONS(3050),
    [aux_sym_preproc_include_token1] = ACTIONS(3050),
    [aux_sym_preproc_def_token1] = ACTIONS(3050),
    [aux_sym_preproc_if_token1] = ACTIONS(3050),
    [aux_sym_preproc_if_token2] = ACTIONS(3050),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3050),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3050),
    [sym_preproc_directive] = ACTIONS(3050),
    [anon_sym_LPAREN2] = ACTIONS(3052),
    [anon_sym_BANG] = ACTIONS(3052),
    [anon_sym_TILDE] = ACTIONS(3052),
    [anon_sym_DASH] = ACTIONS(3050),
    [anon_sym_PLUS] = ACTIONS(3050),
    [anon_sym_STAR] = ACTIONS(3052),
    [anon_sym_AMP_AMP] = ACTIONS(3052),
    [anon_sym_AMP] = ACTIONS(3050),
    [anon_sym_SEMI] = ACTIONS(3052),
    [anon_sym___extension__] = ACTIONS(3050),
    [anon_sym_typedef] = ACTIONS(3050),
    [anon_sym_virtual] = ACTIONS(3050),
    [anon_sym_extern] = ACTIONS(3050),
    [anon_sym___attribute__] = ACTIONS(3050),
    [anon_sym___attribute] = ACTIONS(3050),
    [anon_sym_COLON_COLON] = ACTIONS(3052),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3052),
    [anon_sym___declspec] = ACTIONS(3050),
    [anon_sym___based] = ACTIONS(3050),
    [anon_sym___cdecl] = ACTIONS(3050),
    [anon_sym___clrcall] = ACTIONS(3050),
    [anon_sym___stdcall] = ACTIONS(3050),
    [anon_sym___fastcall] = ACTIONS(3050),
    [anon_sym___thiscall] = ACTIONS(3050),
    [anon_sym___vectorcall] = ACTIONS(3050),
    [anon_sym_LBRACE] = ACTIONS(3052),
    [anon_sym_signed] = ACTIONS(3050),
    [anon_sym_unsigned] = ACTIONS(3050),
    [anon_sym_long] = ACTIONS(3050),
    [anon_sym_short] = ACTIONS(3050),
    [anon_sym_LBRACK] = ACTIONS(3050),
    [anon_sym_static] = ACTIONS(3050),
    [anon_sym_register] = ACTIONS(3050),
    [anon_sym_inline] = ACTIONS(3050),
    [anon_sym___inline] = ACTIONS(3050),
    [anon_sym___inline__] = ACTIONS(3050),
    [anon_sym___forceinline] = ACTIONS(3050),
    [anon_sym_thread_local] = ACTIONS(3050),
    [anon_sym___thread] = ACTIONS(3050),
    [anon_sym_const] = ACTIONS(3050),
    [anon_sym_constexpr] = ACTIONS(3050),
    [anon_sym_volatile] = ACTIONS(3050),
    [anon_sym_restrict] = ACTIONS(3050),
    [anon_sym___restrict__] = ACTIONS(3050),
    [anon_sym__Atomic] = ACTIONS(3050),
    [anon_sym__Noreturn] = ACTIONS(3050),
    [anon_sym_noreturn] = ACTIONS(3050),
    [anon_sym__Nonnull] = ACTIONS(3050),
    [anon_sym_mutable] = ACTIONS(3050),
    [anon_sym_constinit] = ACTIONS(3050),
    [anon_sym_consteval] = ACTIONS(3050),
    [anon_sym_alignas] = ACTIONS(3050),
    [anon_sym__Alignas] = ACTIONS(3050),
    [sym_primitive_type] = ACTIONS(3050),
    [anon_sym_enum] = ACTIONS(3050),
    [anon_sym_class] = ACTIONS(3050),
    [anon_sym_struct] = ACTIONS(3050),
    [anon_sym_union] = ACTIONS(3050),
    [anon_sym_if] = ACTIONS(3050),
    [anon_sym_switch] = ACTIONS(3050),
    [anon_sym_case] = ACTIONS(3050),
    [anon_sym_default] = ACTIONS(3050),
    [anon_sym_while] = ACTIONS(3050),
    [anon_sym_do] = ACTIONS(3050),
    [anon_sym_for] = ACTIONS(3050),
    [anon_sym_return] = ACTIONS(3050),
    [anon_sym_break] = ACTIONS(3050),
    [anon_sym_continue] = ACTIONS(3050),
    [anon_sym_goto] = ACTIONS(3050),
    [anon_sym___try] = ACTIONS(3050),
    [anon_sym___leave] = ACTIONS(3050),
    [anon_sym_not] = ACTIONS(3050),
    [anon_sym_compl] = ACTIONS(3050),
    [anon_sym_DASH_DASH] = ACTIONS(3052),
    [anon_sym_PLUS_PLUS] = ACTIONS(3052),
    [anon_sym_sizeof] = ACTIONS(3050),
    [anon_sym___alignof__] = ACTIONS(3050),
    [anon_sym___alignof] = ACTIONS(3050),
    [anon_sym__alignof] = ACTIONS(3050),
    [anon_sym_alignof] = ACTIONS(3050),
    [anon_sym__Alignof] = ACTIONS(3050),
    [anon_sym_offsetof] = ACTIONS(3050),
    [anon_sym__Generic] = ACTIONS(3050),
    [anon_sym_asm] = ACTIONS(3050),
    [anon_sym___asm__] = ACTIONS(3050),
    [anon_sym___asm] = ACTIONS(3050),
    [sym_number_literal] = ACTIONS(3052),
    [anon_sym_L_SQUOTE] = ACTIONS(3052),
    [anon_sym_u_SQUOTE] = ACTIONS(3052),
    [anon_sym_U_SQUOTE] = ACTIONS(3052),
    [anon_sym_u8_SQUOTE] = ACTIONS(3052),
    [anon_sym_SQUOTE] = ACTIONS(3052),
    [anon_sym_L_DQUOTE] = ACTIONS(3052),
    [anon_sym_u_DQUOTE] = ACTIONS(3052),
    [anon_sym_U_DQUOTE] = ACTIONS(3052),
    [anon_sym_u8_DQUOTE] = ACTIONS(3052),
    [anon_sym_DQUOTE] = ACTIONS(3052),
    [sym_true] = ACTIONS(3050),
    [sym_false] = ACTIONS(3050),
    [anon_sym_NULL] = ACTIONS(3050),
    [anon_sym_nullptr] = ACTIONS(3050),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3050),
    [anon_sym_decltype] = ACTIONS(3050),
    [anon_sym_explicit] = ACTIONS(3050),
    [anon_sym_typename] = ACTIONS(3050),
    [anon_sym_template] = ACTIONS(3050),
    [anon_sym_operator] = ACTIONS(3050),
    [anon_sym_try] = ACTIONS(3050),
    [anon_sym_delete] = ACTIONS(3050),
    [anon_sym_throw] = ACTIONS(3050),
    [anon_sym_namespace] = ACTIONS(3050),
    [anon_sym_using] = ACTIONS(3050),
    [anon_sym_static_assert] = ACTIONS(3050),
    [anon_sym_concept] = ACTIONS(3050),
    [anon_sym_co_return] = ACTIONS(3050),
    [anon_sym_co_yield] = ACTIONS(3050),
    [anon_sym_R_DQUOTE] = ACTIONS(3052),
    [anon_sym_LR_DQUOTE] = ACTIONS(3052),
    [anon_sym_uR_DQUOTE] = ACTIONS(3052),
    [anon_sym_UR_DQUOTE] = ACTIONS(3052),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3052),
    [anon_sym_co_await] = ACTIONS(3050),
    [anon_sym_new] = ACTIONS(3050),
    [anon_sym_requires] = ACTIONS(3050),
    [sym_this] = ACTIONS(3050),
  },
  [550] = {
    [sym_identifier] = ACTIONS(3056),
    [aux_sym_preproc_include_token1] = ACTIONS(3056),
    [aux_sym_preproc_def_token1] = ACTIONS(3056),
    [aux_sym_preproc_if_token1] = ACTIONS(3056),
    [aux_sym_preproc_if_token2] = ACTIONS(3056),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3056),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3056),
    [sym_preproc_directive] = ACTIONS(3056),
    [anon_sym_LPAREN2] = ACTIONS(3058),
    [anon_sym_BANG] = ACTIONS(3058),
    [anon_sym_TILDE] = ACTIONS(3058),
    [anon_sym_DASH] = ACTIONS(3056),
    [anon_sym_PLUS] = ACTIONS(3056),
    [anon_sym_STAR] = ACTIONS(3058),
    [anon_sym_AMP_AMP] = ACTIONS(3058),
    [anon_sym_AMP] = ACTIONS(3056),
    [anon_sym_SEMI] = ACTIONS(3058),
    [anon_sym___extension__] = ACTIONS(3056),
    [anon_sym_typedef] = ACTIONS(3056),
    [anon_sym_virtual] = ACTIONS(3056),
    [anon_sym_extern] = ACTIONS(3056),
    [anon_sym___attribute__] = ACTIONS(3056),
    [anon_sym___attribute] = ACTIONS(3056),
    [anon_sym_COLON_COLON] = ACTIONS(3058),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3058),
    [anon_sym___declspec] = ACTIONS(3056),
    [anon_sym___based] = ACTIONS(3056),
    [anon_sym___cdecl] = ACTIONS(3056),
    [anon_sym___clrcall] = ACTIONS(3056),
    [anon_sym___stdcall] = ACTIONS(3056),
    [anon_sym___fastcall] = ACTIONS(3056),
    [anon_sym___thiscall] = ACTIONS(3056),
    [anon_sym___vectorcall] = ACTIONS(3056),
    [anon_sym_LBRACE] = ACTIONS(3058),
    [anon_sym_signed] = ACTIONS(3056),
    [anon_sym_unsigned] = ACTIONS(3056),
    [anon_sym_long] = ACTIONS(3056),
    [anon_sym_short] = ACTIONS(3056),
    [anon_sym_LBRACK] = ACTIONS(3056),
    [anon_sym_static] = ACTIONS(3056),
    [anon_sym_register] = ACTIONS(3056),
    [anon_sym_inline] = ACTIONS(3056),
    [anon_sym___inline] = ACTIONS(3056),
    [anon_sym___inline__] = ACTIONS(3056),
    [anon_sym___forceinline] = ACTIONS(3056),
    [anon_sym_thread_local] = ACTIONS(3056),
    [anon_sym___thread] = ACTIONS(3056),
    [anon_sym_const] = ACTIONS(3056),
    [anon_sym_constexpr] = ACTIONS(3056),
    [anon_sym_volatile] = ACTIONS(3056),
    [anon_sym_restrict] = ACTIONS(3056),
    [anon_sym___restrict__] = ACTIONS(3056),
    [anon_sym__Atomic] = ACTIONS(3056),
    [anon_sym__Noreturn] = ACTIONS(3056),
    [anon_sym_noreturn] = ACTIONS(3056),
    [anon_sym__Nonnull] = ACTIONS(3056),
    [anon_sym_mutable] = ACTIONS(3056),
    [anon_sym_constinit] = ACTIONS(3056),
    [anon_sym_consteval] = ACTIONS(3056),
    [anon_sym_alignas] = ACTIONS(3056),
    [anon_sym__Alignas] = ACTIONS(3056),
    [sym_primitive_type] = ACTIONS(3056),
    [anon_sym_enum] = ACTIONS(3056),
    [anon_sym_class] = ACTIONS(3056),
    [anon_sym_struct] = ACTIONS(3056),
    [anon_sym_union] = ACTIONS(3056),
    [anon_sym_if] = ACTIONS(3056),
    [anon_sym_switch] = ACTIONS(3056),
    [anon_sym_case] = ACTIONS(3056),
    [anon_sym_default] = ACTIONS(3056),
    [anon_sym_while] = ACTIONS(3056),
    [anon_sym_do] = ACTIONS(3056),
    [anon_sym_for] = ACTIONS(3056),
    [anon_sym_return] = ACTIONS(3056),
    [anon_sym_break] = ACTIONS(3056),
    [anon_sym_continue] = ACTIONS(3056),
    [anon_sym_goto] = ACTIONS(3056),
    [anon_sym___try] = ACTIONS(3056),
    [anon_sym___leave] = ACTIONS(3056),
    [anon_sym_not] = ACTIONS(3056),
    [anon_sym_compl] = ACTIONS(3056),
    [anon_sym_DASH_DASH] = ACTIONS(3058),
    [anon_sym_PLUS_PLUS] = ACTIONS(3058),
    [anon_sym_sizeof] = ACTIONS(3056),
    [anon_sym___alignof__] = ACTIONS(3056),
    [anon_sym___alignof] = ACTIONS(3056),
    [anon_sym__alignof] = ACTIONS(3056),
    [anon_sym_alignof] = ACTIONS(3056),
    [anon_sym__Alignof] = ACTIONS(3056),
    [anon_sym_offsetof] = ACTIONS(3056),
    [anon_sym__Generic] = ACTIONS(3056),
    [anon_sym_asm] = ACTIONS(3056),
    [anon_sym___asm__] = ACTIONS(3056),
    [anon_sym___asm] = ACTIONS(3056),
    [sym_number_literal] = ACTIONS(3058),
    [anon_sym_L_SQUOTE] = ACTIONS(3058),
    [anon_sym_u_SQUOTE] = ACTIONS(3058),
    [anon_sym_U_SQUOTE] = ACTIONS(3058),
    [anon_sym_u8_SQUOTE] = ACTIONS(3058),
    [anon_sym_SQUOTE] = ACTIONS(3058),
    [anon_sym_L_DQUOTE] = ACTIONS(3058),
    [anon_sym_u_DQUOTE] = ACTIONS(3058),
    [anon_sym_U_DQUOTE] = ACTIONS(3058),
    [anon_sym_u8_DQUOTE] = ACTIONS(3058),
    [anon_sym_DQUOTE] = ACTIONS(3058),
    [sym_true] = ACTIONS(3056),
    [sym_false] = ACTIONS(3056),
    [anon_sym_NULL] = ACTIONS(3056),
    [anon_sym_nullptr] = ACTIONS(3056),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3056),
    [anon_sym_decltype] = ACTIONS(3056),
    [anon_sym_explicit] = ACTIONS(3056),
    [anon_sym_typename] = ACTIONS(3056),
    [anon_sym_template] = ACTIONS(3056),
    [anon_sym_operator] = ACTIONS(3056),
    [anon_sym_try] = ACTIONS(3056),
    [anon_sym_delete] = ACTIONS(3056),
    [anon_sym_throw] = ACTIONS(3056),
    [anon_sym_namespace] = ACTIONS(3056),
    [anon_sym_using] = ACTIONS(3056),
    [anon_sym_static_assert] = ACTIONS(3056),
    [anon_sym_concept] = ACTIONS(3056),
    [anon_sym_co_return] = ACTIONS(3056),
    [anon_sym_co_yield] = ACTIONS(3056),
    [anon_sym_R_DQUOTE] = ACTIONS(3058),
    [anon_sym_LR_DQUOTE] = ACTIONS(3058),
    [anon_sym_uR_DQUOTE] = ACTIONS(3058),
    [anon_sym_UR_DQUOTE] = ACTIONS(3058),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3058),
    [anon_sym_co_await] = ACTIONS(3056),
    [anon_sym_new] = ACTIONS(3056),
    [anon_sym_requires] = ACTIONS(3056),
    [sym_this] = ACTIONS(3056),
  },
  [551] = {
    [sym_identifier] = ACTIONS(2980),
    [aux_sym_preproc_include_token1] = ACTIONS(2980),
    [aux_sym_preproc_def_token1] = ACTIONS(2980),
    [aux_sym_preproc_if_token1] = ACTIONS(2980),
    [aux_sym_preproc_if_token2] = ACTIONS(2980),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2980),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2980),
    [sym_preproc_directive] = ACTIONS(2980),
    [anon_sym_LPAREN2] = ACTIONS(2982),
    [anon_sym_BANG] = ACTIONS(2982),
    [anon_sym_TILDE] = ACTIONS(2982),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP_AMP] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2980),
    [anon_sym_SEMI] = ACTIONS(2982),
    [anon_sym___extension__] = ACTIONS(2980),
    [anon_sym_typedef] = ACTIONS(2980),
    [anon_sym_virtual] = ACTIONS(2980),
    [anon_sym_extern] = ACTIONS(2980),
    [anon_sym___attribute__] = ACTIONS(2980),
    [anon_sym___attribute] = ACTIONS(2980),
    [anon_sym_COLON_COLON] = ACTIONS(2982),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2982),
    [anon_sym___declspec] = ACTIONS(2980),
    [anon_sym___based] = ACTIONS(2980),
    [anon_sym___cdecl] = ACTIONS(2980),
    [anon_sym___clrcall] = ACTIONS(2980),
    [anon_sym___stdcall] = ACTIONS(2980),
    [anon_sym___fastcall] = ACTIONS(2980),
    [anon_sym___thiscall] = ACTIONS(2980),
    [anon_sym___vectorcall] = ACTIONS(2980),
    [anon_sym_LBRACE] = ACTIONS(2982),
    [anon_sym_signed] = ACTIONS(2980),
    [anon_sym_unsigned] = ACTIONS(2980),
    [anon_sym_long] = ACTIONS(2980),
    [anon_sym_short] = ACTIONS(2980),
    [anon_sym_LBRACK] = ACTIONS(2980),
    [anon_sym_static] = ACTIONS(2980),
    [anon_sym_register] = ACTIONS(2980),
    [anon_sym_inline] = ACTIONS(2980),
    [anon_sym___inline] = ACTIONS(2980),
    [anon_sym___inline__] = ACTIONS(2980),
    [anon_sym___forceinline] = ACTIONS(2980),
    [anon_sym_thread_local] = ACTIONS(2980),
    [anon_sym___thread] = ACTIONS(2980),
    [anon_sym_const] = ACTIONS(2980),
    [anon_sym_constexpr] = ACTIONS(2980),
    [anon_sym_volatile] = ACTIONS(2980),
    [anon_sym_restrict] = ACTIONS(2980),
    [anon_sym___restrict__] = ACTIONS(2980),
    [anon_sym__Atomic] = ACTIONS(2980),
    [anon_sym__Noreturn] = ACTIONS(2980),
    [anon_sym_noreturn] = ACTIONS(2980),
    [anon_sym__Nonnull] = ACTIONS(2980),
    [anon_sym_mutable] = ACTIONS(2980),
    [anon_sym_constinit] = ACTIONS(2980),
    [anon_sym_consteval] = ACTIONS(2980),
    [anon_sym_alignas] = ACTIONS(2980),
    [anon_sym__Alignas] = ACTIONS(2980),
    [sym_primitive_type] = ACTIONS(2980),
    [anon_sym_enum] = ACTIONS(2980),
    [anon_sym_class] = ACTIONS(2980),
    [anon_sym_struct] = ACTIONS(2980),
    [anon_sym_union] = ACTIONS(2980),
    [anon_sym_if] = ACTIONS(2980),
    [anon_sym_switch] = ACTIONS(2980),
    [anon_sym_case] = ACTIONS(2980),
    [anon_sym_default] = ACTIONS(2980),
    [anon_sym_while] = ACTIONS(2980),
    [anon_sym_do] = ACTIONS(2980),
    [anon_sym_for] = ACTIONS(2980),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_break] = ACTIONS(2980),
    [anon_sym_continue] = ACTIONS(2980),
    [anon_sym_goto] = ACTIONS(2980),
    [anon_sym___try] = ACTIONS(2980),
    [anon_sym___leave] = ACTIONS(2980),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_compl] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2982),
    [anon_sym_PLUS_PLUS] = ACTIONS(2982),
    [anon_sym_sizeof] = ACTIONS(2980),
    [anon_sym___alignof__] = ACTIONS(2980),
    [anon_sym___alignof] = ACTIONS(2980),
    [anon_sym__alignof] = ACTIONS(2980),
    [anon_sym_alignof] = ACTIONS(2980),
    [anon_sym__Alignof] = ACTIONS(2980),
    [anon_sym_offsetof] = ACTIONS(2980),
    [anon_sym__Generic] = ACTIONS(2980),
    [anon_sym_asm] = ACTIONS(2980),
    [anon_sym___asm__] = ACTIONS(2980),
    [anon_sym___asm] = ACTIONS(2980),
    [sym_number_literal] = ACTIONS(2982),
    [anon_sym_L_SQUOTE] = ACTIONS(2982),
    [anon_sym_u_SQUOTE] = ACTIONS(2982),
    [anon_sym_U_SQUOTE] = ACTIONS(2982),
    [anon_sym_u8_SQUOTE] = ACTIONS(2982),
    [anon_sym_SQUOTE] = ACTIONS(2982),
    [anon_sym_L_DQUOTE] = ACTIONS(2982),
    [anon_sym_u_DQUOTE] = ACTIONS(2982),
    [anon_sym_U_DQUOTE] = ACTIONS(2982),
    [anon_sym_u8_DQUOTE] = ACTIONS(2982),
    [anon_sym_DQUOTE] = ACTIONS(2982),
    [sym_true] = ACTIONS(2980),
    [sym_false] = ACTIONS(2980),
    [anon_sym_NULL] = ACTIONS(2980),
    [anon_sym_nullptr] = ACTIONS(2980),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2980),
    [anon_sym_decltype] = ACTIONS(2980),
    [anon_sym_explicit] = ACTIONS(2980),
    [anon_sym_typename] = ACTIONS(2980),
    [anon_sym_template] = ACTIONS(2980),
    [anon_sym_operator] = ACTIONS(2980),
    [anon_sym_try] = ACTIONS(2980),
    [anon_sym_delete] = ACTIONS(2980),
    [anon_sym_throw] = ACTIONS(2980),
    [anon_sym_namespace] = ACTIONS(2980),
    [anon_sym_using] = ACTIONS(2980),
    [anon_sym_static_assert] = ACTIONS(2980),
    [anon_sym_concept] = ACTIONS(2980),
    [anon_sym_co_return] = ACTIONS(2980),
    [anon_sym_co_yield] = ACTIONS(2980),
    [anon_sym_R_DQUOTE] = ACTIONS(2982),
    [anon_sym_LR_DQUOTE] = ACTIONS(2982),
    [anon_sym_uR_DQUOTE] = ACTIONS(2982),
    [anon_sym_UR_DQUOTE] = ACTIONS(2982),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2982),
    [anon_sym_co_await] = ACTIONS(2980),
    [anon_sym_new] = ACTIONS(2980),
    [anon_sym_requires] = ACTIONS(2980),
    [sym_this] = ACTIONS(2980),
  },
  [552] = {
    [sym_identifier] = ACTIONS(3060),
    [aux_sym_preproc_include_token1] = ACTIONS(3060),
    [aux_sym_preproc_def_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token2] = ACTIONS(3060),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3060),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3060),
    [sym_preproc_directive] = ACTIONS(3060),
    [anon_sym_LPAREN2] = ACTIONS(3062),
    [anon_sym_BANG] = ACTIONS(3062),
    [anon_sym_TILDE] = ACTIONS(3062),
    [anon_sym_DASH] = ACTIONS(3060),
    [anon_sym_PLUS] = ACTIONS(3060),
    [anon_sym_STAR] = ACTIONS(3062),
    [anon_sym_AMP_AMP] = ACTIONS(3062),
    [anon_sym_AMP] = ACTIONS(3060),
    [anon_sym_SEMI] = ACTIONS(3062),
    [anon_sym___extension__] = ACTIONS(3060),
    [anon_sym_typedef] = ACTIONS(3060),
    [anon_sym_virtual] = ACTIONS(3060),
    [anon_sym_extern] = ACTIONS(3060),
    [anon_sym___attribute__] = ACTIONS(3060),
    [anon_sym___attribute] = ACTIONS(3060),
    [anon_sym_COLON_COLON] = ACTIONS(3062),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3062),
    [anon_sym___declspec] = ACTIONS(3060),
    [anon_sym___based] = ACTIONS(3060),
    [anon_sym___cdecl] = ACTIONS(3060),
    [anon_sym___clrcall] = ACTIONS(3060),
    [anon_sym___stdcall] = ACTIONS(3060),
    [anon_sym___fastcall] = ACTIONS(3060),
    [anon_sym___thiscall] = ACTIONS(3060),
    [anon_sym___vectorcall] = ACTIONS(3060),
    [anon_sym_LBRACE] = ACTIONS(3062),
    [anon_sym_signed] = ACTIONS(3060),
    [anon_sym_unsigned] = ACTIONS(3060),
    [anon_sym_long] = ACTIONS(3060),
    [anon_sym_short] = ACTIONS(3060),
    [anon_sym_LBRACK] = ACTIONS(3060),
    [anon_sym_static] = ACTIONS(3060),
    [anon_sym_register] = ACTIONS(3060),
    [anon_sym_inline] = ACTIONS(3060),
    [anon_sym___inline] = ACTIONS(3060),
    [anon_sym___inline__] = ACTIONS(3060),
    [anon_sym___forceinline] = ACTIONS(3060),
    [anon_sym_thread_local] = ACTIONS(3060),
    [anon_sym___thread] = ACTIONS(3060),
    [anon_sym_const] = ACTIONS(3060),
    [anon_sym_constexpr] = ACTIONS(3060),
    [anon_sym_volatile] = ACTIONS(3060),
    [anon_sym_restrict] = ACTIONS(3060),
    [anon_sym___restrict__] = ACTIONS(3060),
    [anon_sym__Atomic] = ACTIONS(3060),
    [anon_sym__Noreturn] = ACTIONS(3060),
    [anon_sym_noreturn] = ACTIONS(3060),
    [anon_sym__Nonnull] = ACTIONS(3060),
    [anon_sym_mutable] = ACTIONS(3060),
    [anon_sym_constinit] = ACTIONS(3060),
    [anon_sym_consteval] = ACTIONS(3060),
    [anon_sym_alignas] = ACTIONS(3060),
    [anon_sym__Alignas] = ACTIONS(3060),
    [sym_primitive_type] = ACTIONS(3060),
    [anon_sym_enum] = ACTIONS(3060),
    [anon_sym_class] = ACTIONS(3060),
    [anon_sym_struct] = ACTIONS(3060),
    [anon_sym_union] = ACTIONS(3060),
    [anon_sym_if] = ACTIONS(3060),
    [anon_sym_switch] = ACTIONS(3060),
    [anon_sym_case] = ACTIONS(3060),
    [anon_sym_default] = ACTIONS(3060),
    [anon_sym_while] = ACTIONS(3060),
    [anon_sym_do] = ACTIONS(3060),
    [anon_sym_for] = ACTIONS(3060),
    [anon_sym_return] = ACTIONS(3060),
    [anon_sym_break] = ACTIONS(3060),
    [anon_sym_continue] = ACTIONS(3060),
    [anon_sym_goto] = ACTIONS(3060),
    [anon_sym___try] = ACTIONS(3060),
    [anon_sym___leave] = ACTIONS(3060),
    [anon_sym_not] = ACTIONS(3060),
    [anon_sym_compl] = ACTIONS(3060),
    [anon_sym_DASH_DASH] = ACTIONS(3062),
    [anon_sym_PLUS_PLUS] = ACTIONS(3062),
    [anon_sym_sizeof] = ACTIONS(3060),
    [anon_sym___alignof__] = ACTIONS(3060),
    [anon_sym___alignof] = ACTIONS(3060),
    [anon_sym__alignof] = ACTIONS(3060),
    [anon_sym_alignof] = ACTIONS(3060),
    [anon_sym__Alignof] = ACTIONS(3060),
    [anon_sym_offsetof] = ACTIONS(3060),
    [anon_sym__Generic] = ACTIONS(3060),
    [anon_sym_asm] = ACTIONS(3060),
    [anon_sym___asm__] = ACTIONS(3060),
    [anon_sym___asm] = ACTIONS(3060),
    [sym_number_literal] = ACTIONS(3062),
    [anon_sym_L_SQUOTE] = ACTIONS(3062),
    [anon_sym_u_SQUOTE] = ACTIONS(3062),
    [anon_sym_U_SQUOTE] = ACTIONS(3062),
    [anon_sym_u8_SQUOTE] = ACTIONS(3062),
    [anon_sym_SQUOTE] = ACTIONS(3062),
    [anon_sym_L_DQUOTE] = ACTIONS(3062),
    [anon_sym_u_DQUOTE] = ACTIONS(3062),
    [anon_sym_U_DQUOTE] = ACTIONS(3062),
    [anon_sym_u8_DQUOTE] = ACTIONS(3062),
    [anon_sym_DQUOTE] = ACTIONS(3062),
    [sym_true] = ACTIONS(3060),
    [sym_false] = ACTIONS(3060),
    [anon_sym_NULL] = ACTIONS(3060),
    [anon_sym_nullptr] = ACTIONS(3060),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3060),
    [anon_sym_decltype] = ACTIONS(3060),
    [anon_sym_explicit] = ACTIONS(3060),
    [anon_sym_typename] = ACTIONS(3060),
    [anon_sym_template] = ACTIONS(3060),
    [anon_sym_operator] = ACTIONS(3060),
    [anon_sym_try] = ACTIONS(3060),
    [anon_sym_delete] = ACTIONS(3060),
    [anon_sym_throw] = ACTIONS(3060),
    [anon_sym_namespace] = ACTIONS(3060),
    [anon_sym_using] = ACTIONS(3060),
    [anon_sym_static_assert] = ACTIONS(3060),
    [anon_sym_concept] = ACTIONS(3060),
    [anon_sym_co_return] = ACTIONS(3060),
    [anon_sym_co_yield] = ACTIONS(3060),
    [anon_sym_R_DQUOTE] = ACTIONS(3062),
    [anon_sym_LR_DQUOTE] = ACTIONS(3062),
    [anon_sym_uR_DQUOTE] = ACTIONS(3062),
    [anon_sym_UR_DQUOTE] = ACTIONS(3062),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3062),
    [anon_sym_co_await] = ACTIONS(3060),
    [anon_sym_new] = ACTIONS(3060),
    [anon_sym_requires] = ACTIONS(3060),
    [sym_this] = ACTIONS(3060),
  },
  [553] = {
    [sym_identifier] = ACTIONS(3114),
    [aux_sym_preproc_include_token1] = ACTIONS(3114),
    [aux_sym_preproc_def_token1] = ACTIONS(3114),
    [aux_sym_preproc_if_token1] = ACTIONS(3114),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3114),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3114),
    [sym_preproc_directive] = ACTIONS(3114),
    [anon_sym_LPAREN2] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3116),
    [anon_sym_TILDE] = ACTIONS(3116),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_PLUS] = ACTIONS(3114),
    [anon_sym_STAR] = ACTIONS(3116),
    [anon_sym_AMP_AMP] = ACTIONS(3116),
    [anon_sym_AMP] = ACTIONS(3114),
    [anon_sym_SEMI] = ACTIONS(3116),
    [anon_sym___extension__] = ACTIONS(3114),
    [anon_sym_typedef] = ACTIONS(3114),
    [anon_sym_virtual] = ACTIONS(3114),
    [anon_sym_extern] = ACTIONS(3114),
    [anon_sym___attribute__] = ACTIONS(3114),
    [anon_sym___attribute] = ACTIONS(3114),
    [anon_sym_COLON_COLON] = ACTIONS(3116),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3116),
    [anon_sym___declspec] = ACTIONS(3114),
    [anon_sym___based] = ACTIONS(3114),
    [anon_sym___cdecl] = ACTIONS(3114),
    [anon_sym___clrcall] = ACTIONS(3114),
    [anon_sym___stdcall] = ACTIONS(3114),
    [anon_sym___fastcall] = ACTIONS(3114),
    [anon_sym___thiscall] = ACTIONS(3114),
    [anon_sym___vectorcall] = ACTIONS(3114),
    [anon_sym_LBRACE] = ACTIONS(3116),
    [anon_sym_RBRACE] = ACTIONS(3116),
    [anon_sym_signed] = ACTIONS(3114),
    [anon_sym_unsigned] = ACTIONS(3114),
    [anon_sym_long] = ACTIONS(3114),
    [anon_sym_short] = ACTIONS(3114),
    [anon_sym_LBRACK] = ACTIONS(3114),
    [anon_sym_static] = ACTIONS(3114),
    [anon_sym_register] = ACTIONS(3114),
    [anon_sym_inline] = ACTIONS(3114),
    [anon_sym___inline] = ACTIONS(3114),
    [anon_sym___inline__] = ACTIONS(3114),
    [anon_sym___forceinline] = ACTIONS(3114),
    [anon_sym_thread_local] = ACTIONS(3114),
    [anon_sym___thread] = ACTIONS(3114),
    [anon_sym_const] = ACTIONS(3114),
    [anon_sym_constexpr] = ACTIONS(3114),
    [anon_sym_volatile] = ACTIONS(3114),
    [anon_sym_restrict] = ACTIONS(3114),
    [anon_sym___restrict__] = ACTIONS(3114),
    [anon_sym__Atomic] = ACTIONS(3114),
    [anon_sym__Noreturn] = ACTIONS(3114),
    [anon_sym_noreturn] = ACTIONS(3114),
    [anon_sym__Nonnull] = ACTIONS(3114),
    [anon_sym_mutable] = ACTIONS(3114),
    [anon_sym_constinit] = ACTIONS(3114),
    [anon_sym_consteval] = ACTIONS(3114),
    [anon_sym_alignas] = ACTIONS(3114),
    [anon_sym__Alignas] = ACTIONS(3114),
    [sym_primitive_type] = ACTIONS(3114),
    [anon_sym_enum] = ACTIONS(3114),
    [anon_sym_class] = ACTIONS(3114),
    [anon_sym_struct] = ACTIONS(3114),
    [anon_sym_union] = ACTIONS(3114),
    [anon_sym_if] = ACTIONS(3114),
    [anon_sym_switch] = ACTIONS(3114),
    [anon_sym_case] = ACTIONS(3114),
    [anon_sym_default] = ACTIONS(3114),
    [anon_sym_while] = ACTIONS(3114),
    [anon_sym_do] = ACTIONS(3114),
    [anon_sym_for] = ACTIONS(3114),
    [anon_sym_return] = ACTIONS(3114),
    [anon_sym_break] = ACTIONS(3114),
    [anon_sym_continue] = ACTIONS(3114),
    [anon_sym_goto] = ACTIONS(3114),
    [anon_sym___try] = ACTIONS(3114),
    [anon_sym___leave] = ACTIONS(3114),
    [anon_sym_not] = ACTIONS(3114),
    [anon_sym_compl] = ACTIONS(3114),
    [anon_sym_DASH_DASH] = ACTIONS(3116),
    [anon_sym_PLUS_PLUS] = ACTIONS(3116),
    [anon_sym_sizeof] = ACTIONS(3114),
    [anon_sym___alignof__] = ACTIONS(3114),
    [anon_sym___alignof] = ACTIONS(3114),
    [anon_sym__alignof] = ACTIONS(3114),
    [anon_sym_alignof] = ACTIONS(3114),
    [anon_sym__Alignof] = ACTIONS(3114),
    [anon_sym_offsetof] = ACTIONS(3114),
    [anon_sym__Generic] = ACTIONS(3114),
    [anon_sym_asm] = ACTIONS(3114),
    [anon_sym___asm__] = ACTIONS(3114),
    [anon_sym___asm] = ACTIONS(3114),
    [sym_number_literal] = ACTIONS(3116),
    [anon_sym_L_SQUOTE] = ACTIONS(3116),
    [anon_sym_u_SQUOTE] = ACTIONS(3116),
    [anon_sym_U_SQUOTE] = ACTIONS(3116),
    [anon_sym_u8_SQUOTE] = ACTIONS(3116),
    [anon_sym_SQUOTE] = ACTIONS(3116),
    [anon_sym_L_DQUOTE] = ACTIONS(3116),
    [anon_sym_u_DQUOTE] = ACTIONS(3116),
    [anon_sym_U_DQUOTE] = ACTIONS(3116),
    [anon_sym_u8_DQUOTE] = ACTIONS(3116),
    [anon_sym_DQUOTE] = ACTIONS(3116),
    [sym_true] = ACTIONS(3114),
    [sym_false] = ACTIONS(3114),
    [anon_sym_NULL] = ACTIONS(3114),
    [anon_sym_nullptr] = ACTIONS(3114),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3114),
    [anon_sym_decltype] = ACTIONS(3114),
    [anon_sym_explicit] = ACTIONS(3114),
    [anon_sym_typename] = ACTIONS(3114),
    [anon_sym_template] = ACTIONS(3114),
    [anon_sym_operator] = ACTIONS(3114),
    [anon_sym_try] = ACTIONS(3114),
    [anon_sym_delete] = ACTIONS(3114),
    [anon_sym_throw] = ACTIONS(3114),
    [anon_sym_namespace] = ACTIONS(3114),
    [anon_sym_using] = ACTIONS(3114),
    [anon_sym_static_assert] = ACTIONS(3114),
    [anon_sym_concept] = ACTIONS(3114),
    [anon_sym_co_return] = ACTIONS(3114),
    [anon_sym_co_yield] = ACTIONS(3114),
    [anon_sym_R_DQUOTE] = ACTIONS(3116),
    [anon_sym_LR_DQUOTE] = ACTIONS(3116),
    [anon_sym_uR_DQUOTE] = ACTIONS(3116),
    [anon_sym_UR_DQUOTE] = ACTIONS(3116),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3116),
    [anon_sym_co_await] = ACTIONS(3114),
    [anon_sym_new] = ACTIONS(3114),
    [anon_sym_requires] = ACTIONS(3114),
    [sym_this] = ACTIONS(3114),
  },
  [554] = {
    [sym_identifier] = ACTIONS(3064),
    [aux_sym_preproc_include_token1] = ACTIONS(3064),
    [aux_sym_preproc_def_token1] = ACTIONS(3064),
    [aux_sym_preproc_if_token1] = ACTIONS(3064),
    [aux_sym_preproc_if_token2] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3064),
    [sym_preproc_directive] = ACTIONS(3064),
    [anon_sym_LPAREN2] = ACTIONS(3066),
    [anon_sym_BANG] = ACTIONS(3066),
    [anon_sym_TILDE] = ACTIONS(3066),
    [anon_sym_DASH] = ACTIONS(3064),
    [anon_sym_PLUS] = ACTIONS(3064),
    [anon_sym_STAR] = ACTIONS(3066),
    [anon_sym_AMP_AMP] = ACTIONS(3066),
    [anon_sym_AMP] = ACTIONS(3064),
    [anon_sym_SEMI] = ACTIONS(3066),
    [anon_sym___extension__] = ACTIONS(3064),
    [anon_sym_typedef] = ACTIONS(3064),
    [anon_sym_virtual] = ACTIONS(3064),
    [anon_sym_extern] = ACTIONS(3064),
    [anon_sym___attribute__] = ACTIONS(3064),
    [anon_sym___attribute] = ACTIONS(3064),
    [anon_sym_COLON_COLON] = ACTIONS(3066),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3066),
    [anon_sym___declspec] = ACTIONS(3064),
    [anon_sym___based] = ACTIONS(3064),
    [anon_sym___cdecl] = ACTIONS(3064),
    [anon_sym___clrcall] = ACTIONS(3064),
    [anon_sym___stdcall] = ACTIONS(3064),
    [anon_sym___fastcall] = ACTIONS(3064),
    [anon_sym___thiscall] = ACTIONS(3064),
    [anon_sym___vectorcall] = ACTIONS(3064),
    [anon_sym_LBRACE] = ACTIONS(3066),
    [anon_sym_signed] = ACTIONS(3064),
    [anon_sym_unsigned] = ACTIONS(3064),
    [anon_sym_long] = ACTIONS(3064),
    [anon_sym_short] = ACTIONS(3064),
    [anon_sym_LBRACK] = ACTIONS(3064),
    [anon_sym_static] = ACTIONS(3064),
    [anon_sym_register] = ACTIONS(3064),
    [anon_sym_inline] = ACTIONS(3064),
    [anon_sym___inline] = ACTIONS(3064),
    [anon_sym___inline__] = ACTIONS(3064),
    [anon_sym___forceinline] = ACTIONS(3064),
    [anon_sym_thread_local] = ACTIONS(3064),
    [anon_sym___thread] = ACTIONS(3064),
    [anon_sym_const] = ACTIONS(3064),
    [anon_sym_constexpr] = ACTIONS(3064),
    [anon_sym_volatile] = ACTIONS(3064),
    [anon_sym_restrict] = ACTIONS(3064),
    [anon_sym___restrict__] = ACTIONS(3064),
    [anon_sym__Atomic] = ACTIONS(3064),
    [anon_sym__Noreturn] = ACTIONS(3064),
    [anon_sym_noreturn] = ACTIONS(3064),
    [anon_sym__Nonnull] = ACTIONS(3064),
    [anon_sym_mutable] = ACTIONS(3064),
    [anon_sym_constinit] = ACTIONS(3064),
    [anon_sym_consteval] = ACTIONS(3064),
    [anon_sym_alignas] = ACTIONS(3064),
    [anon_sym__Alignas] = ACTIONS(3064),
    [sym_primitive_type] = ACTIONS(3064),
    [anon_sym_enum] = ACTIONS(3064),
    [anon_sym_class] = ACTIONS(3064),
    [anon_sym_struct] = ACTIONS(3064),
    [anon_sym_union] = ACTIONS(3064),
    [anon_sym_if] = ACTIONS(3064),
    [anon_sym_switch] = ACTIONS(3064),
    [anon_sym_case] = ACTIONS(3064),
    [anon_sym_default] = ACTIONS(3064),
    [anon_sym_while] = ACTIONS(3064),
    [anon_sym_do] = ACTIONS(3064),
    [anon_sym_for] = ACTIONS(3064),
    [anon_sym_return] = ACTIONS(3064),
    [anon_sym_break] = ACTIONS(3064),
    [anon_sym_continue] = ACTIONS(3064),
    [anon_sym_goto] = ACTIONS(3064),
    [anon_sym___try] = ACTIONS(3064),
    [anon_sym___leave] = ACTIONS(3064),
    [anon_sym_not] = ACTIONS(3064),
    [anon_sym_compl] = ACTIONS(3064),
    [anon_sym_DASH_DASH] = ACTIONS(3066),
    [anon_sym_PLUS_PLUS] = ACTIONS(3066),
    [anon_sym_sizeof] = ACTIONS(3064),
    [anon_sym___alignof__] = ACTIONS(3064),
    [anon_sym___alignof] = ACTIONS(3064),
    [anon_sym__alignof] = ACTIONS(3064),
    [anon_sym_alignof] = ACTIONS(3064),
    [anon_sym__Alignof] = ACTIONS(3064),
    [anon_sym_offsetof] = ACTIONS(3064),
    [anon_sym__Generic] = ACTIONS(3064),
    [anon_sym_asm] = ACTIONS(3064),
    [anon_sym___asm__] = ACTIONS(3064),
    [anon_sym___asm] = ACTIONS(3064),
    [sym_number_literal] = ACTIONS(3066),
    [anon_sym_L_SQUOTE] = ACTIONS(3066),
    [anon_sym_u_SQUOTE] = ACTIONS(3066),
    [anon_sym_U_SQUOTE] = ACTIONS(3066),
    [anon_sym_u8_SQUOTE] = ACTIONS(3066),
    [anon_sym_SQUOTE] = ACTIONS(3066),
    [anon_sym_L_DQUOTE] = ACTIONS(3066),
    [anon_sym_u_DQUOTE] = ACTIONS(3066),
    [anon_sym_U_DQUOTE] = ACTIONS(3066),
    [anon_sym_u8_DQUOTE] = ACTIONS(3066),
    [anon_sym_DQUOTE] = ACTIONS(3066),
    [sym_true] = ACTIONS(3064),
    [sym_false] = ACTIONS(3064),
    [anon_sym_NULL] = ACTIONS(3064),
    [anon_sym_nullptr] = ACTIONS(3064),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3064),
    [anon_sym_decltype] = ACTIONS(3064),
    [anon_sym_explicit] = ACTIONS(3064),
    [anon_sym_typename] = ACTIONS(3064),
    [anon_sym_template] = ACTIONS(3064),
    [anon_sym_operator] = ACTIONS(3064),
    [anon_sym_try] = ACTIONS(3064),
    [anon_sym_delete] = ACTIONS(3064),
    [anon_sym_throw] = ACTIONS(3064),
    [anon_sym_namespace] = ACTIONS(3064),
    [anon_sym_using] = ACTIONS(3064),
    [anon_sym_static_assert] = ACTIONS(3064),
    [anon_sym_concept] = ACTIONS(3064),
    [anon_sym_co_return] = ACTIONS(3064),
    [anon_sym_co_yield] = ACTIONS(3064),
    [anon_sym_R_DQUOTE] = ACTIONS(3066),
    [anon_sym_LR_DQUOTE] = ACTIONS(3066),
    [anon_sym_uR_DQUOTE] = ACTIONS(3066),
    [anon_sym_UR_DQUOTE] = ACTIONS(3066),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3066),
    [anon_sym_co_await] = ACTIONS(3064),
    [anon_sym_new] = ACTIONS(3064),
    [anon_sym_requires] = ACTIONS(3064),
    [sym_this] = ACTIONS(3064),
  },
  [555] = {
    [sym_identifier] = ACTIONS(3128),
    [aux_sym_preproc_include_token1] = ACTIONS(3128),
    [aux_sym_preproc_def_token1] = ACTIONS(3128),
    [aux_sym_preproc_if_token1] = ACTIONS(3128),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3128),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3128),
    [sym_preproc_directive] = ACTIONS(3128),
    [anon_sym_LPAREN2] = ACTIONS(3130),
    [anon_sym_BANG] = ACTIONS(3130),
    [anon_sym_TILDE] = ACTIONS(3130),
    [anon_sym_DASH] = ACTIONS(3128),
    [anon_sym_PLUS] = ACTIONS(3128),
    [anon_sym_STAR] = ACTIONS(3130),
    [anon_sym_AMP_AMP] = ACTIONS(3130),
    [anon_sym_AMP] = ACTIONS(3128),
    [anon_sym_SEMI] = ACTIONS(3130),
    [anon_sym___extension__] = ACTIONS(3128),
    [anon_sym_typedef] = ACTIONS(3128),
    [anon_sym_virtual] = ACTIONS(3128),
    [anon_sym_extern] = ACTIONS(3128),
    [anon_sym___attribute__] = ACTIONS(3128),
    [anon_sym___attribute] = ACTIONS(3128),
    [anon_sym_COLON_COLON] = ACTIONS(3130),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3130),
    [anon_sym___declspec] = ACTIONS(3128),
    [anon_sym___based] = ACTIONS(3128),
    [anon_sym___cdecl] = ACTIONS(3128),
    [anon_sym___clrcall] = ACTIONS(3128),
    [anon_sym___stdcall] = ACTIONS(3128),
    [anon_sym___fastcall] = ACTIONS(3128),
    [anon_sym___thiscall] = ACTIONS(3128),
    [anon_sym___vectorcall] = ACTIONS(3128),
    [anon_sym_LBRACE] = ACTIONS(3130),
    [anon_sym_RBRACE] = ACTIONS(3130),
    [anon_sym_signed] = ACTIONS(3128),
    [anon_sym_unsigned] = ACTIONS(3128),
    [anon_sym_long] = ACTIONS(3128),
    [anon_sym_short] = ACTIONS(3128),
    [anon_sym_LBRACK] = ACTIONS(3128),
    [anon_sym_static] = ACTIONS(3128),
    [anon_sym_register] = ACTIONS(3128),
    [anon_sym_inline] = ACTIONS(3128),
    [anon_sym___inline] = ACTIONS(3128),
    [anon_sym___inline__] = ACTIONS(3128),
    [anon_sym___forceinline] = ACTIONS(3128),
    [anon_sym_thread_local] = ACTIONS(3128),
    [anon_sym___thread] = ACTIONS(3128),
    [anon_sym_const] = ACTIONS(3128),
    [anon_sym_constexpr] = ACTIONS(3128),
    [anon_sym_volatile] = ACTIONS(3128),
    [anon_sym_restrict] = ACTIONS(3128),
    [anon_sym___restrict__] = ACTIONS(3128),
    [anon_sym__Atomic] = ACTIONS(3128),
    [anon_sym__Noreturn] = ACTIONS(3128),
    [anon_sym_noreturn] = ACTIONS(3128),
    [anon_sym__Nonnull] = ACTIONS(3128),
    [anon_sym_mutable] = ACTIONS(3128),
    [anon_sym_constinit] = ACTIONS(3128),
    [anon_sym_consteval] = ACTIONS(3128),
    [anon_sym_alignas] = ACTIONS(3128),
    [anon_sym__Alignas] = ACTIONS(3128),
    [sym_primitive_type] = ACTIONS(3128),
    [anon_sym_enum] = ACTIONS(3128),
    [anon_sym_class] = ACTIONS(3128),
    [anon_sym_struct] = ACTIONS(3128),
    [anon_sym_union] = ACTIONS(3128),
    [anon_sym_if] = ACTIONS(3128),
    [anon_sym_switch] = ACTIONS(3128),
    [anon_sym_case] = ACTIONS(3128),
    [anon_sym_default] = ACTIONS(3128),
    [anon_sym_while] = ACTIONS(3128),
    [anon_sym_do] = ACTIONS(3128),
    [anon_sym_for] = ACTIONS(3128),
    [anon_sym_return] = ACTIONS(3128),
    [anon_sym_break] = ACTIONS(3128),
    [anon_sym_continue] = ACTIONS(3128),
    [anon_sym_goto] = ACTIONS(3128),
    [anon_sym___try] = ACTIONS(3128),
    [anon_sym___leave] = ACTIONS(3128),
    [anon_sym_not] = ACTIONS(3128),
    [anon_sym_compl] = ACTIONS(3128),
    [anon_sym_DASH_DASH] = ACTIONS(3130),
    [anon_sym_PLUS_PLUS] = ACTIONS(3130),
    [anon_sym_sizeof] = ACTIONS(3128),
    [anon_sym___alignof__] = ACTIONS(3128),
    [anon_sym___alignof] = ACTIONS(3128),
    [anon_sym__alignof] = ACTIONS(3128),
    [anon_sym_alignof] = ACTIONS(3128),
    [anon_sym__Alignof] = ACTIONS(3128),
    [anon_sym_offsetof] = ACTIONS(3128),
    [anon_sym__Generic] = ACTIONS(3128),
    [anon_sym_asm] = ACTIONS(3128),
    [anon_sym___asm__] = ACTIONS(3128),
    [anon_sym___asm] = ACTIONS(3128),
    [sym_number_literal] = ACTIONS(3130),
    [anon_sym_L_SQUOTE] = ACTIONS(3130),
    [anon_sym_u_SQUOTE] = ACTIONS(3130),
    [anon_sym_U_SQUOTE] = ACTIONS(3130),
    [anon_sym_u8_SQUOTE] = ACTIONS(3130),
    [anon_sym_SQUOTE] = ACTIONS(3130),
    [anon_sym_L_DQUOTE] = ACTIONS(3130),
    [anon_sym_u_DQUOTE] = ACTIONS(3130),
    [anon_sym_U_DQUOTE] = ACTIONS(3130),
    [anon_sym_u8_DQUOTE] = ACTIONS(3130),
    [anon_sym_DQUOTE] = ACTIONS(3130),
    [sym_true] = ACTIONS(3128),
    [sym_false] = ACTIONS(3128),
    [anon_sym_NULL] = ACTIONS(3128),
    [anon_sym_nullptr] = ACTIONS(3128),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3128),
    [anon_sym_decltype] = ACTIONS(3128),
    [anon_sym_explicit] = ACTIONS(3128),
    [anon_sym_typename] = ACTIONS(3128),
    [anon_sym_template] = ACTIONS(3128),
    [anon_sym_operator] = ACTIONS(3128),
    [anon_sym_try] = ACTIONS(3128),
    [anon_sym_delete] = ACTIONS(3128),
    [anon_sym_throw] = ACTIONS(3128),
    [anon_sym_namespace] = ACTIONS(3128),
    [anon_sym_using] = ACTIONS(3128),
    [anon_sym_static_assert] = ACTIONS(3128),
    [anon_sym_concept] = ACTIONS(3128),
    [anon_sym_co_return] = ACTIONS(3128),
    [anon_sym_co_yield] = ACTIONS(3128),
    [anon_sym_R_DQUOTE] = ACTIONS(3130),
    [anon_sym_LR_DQUOTE] = ACTIONS(3130),
    [anon_sym_uR_DQUOTE] = ACTIONS(3130),
    [anon_sym_UR_DQUOTE] = ACTIONS(3130),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3130),
    [anon_sym_co_await] = ACTIONS(3128),
    [anon_sym_new] = ACTIONS(3128),
    [anon_sym_requires] = ACTIONS(3128),
    [sym_this] = ACTIONS(3128),
  },
  [556] = {
    [sym_identifier] = ACTIONS(3068),
    [aux_sym_preproc_include_token1] = ACTIONS(3068),
    [aux_sym_preproc_def_token1] = ACTIONS(3068),
    [aux_sym_preproc_if_token1] = ACTIONS(3068),
    [aux_sym_preproc_if_token2] = ACTIONS(3068),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3068),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3068),
    [sym_preproc_directive] = ACTIONS(3068),
    [anon_sym_LPAREN2] = ACTIONS(3070),
    [anon_sym_BANG] = ACTIONS(3070),
    [anon_sym_TILDE] = ACTIONS(3070),
    [anon_sym_DASH] = ACTIONS(3068),
    [anon_sym_PLUS] = ACTIONS(3068),
    [anon_sym_STAR] = ACTIONS(3070),
    [anon_sym_AMP_AMP] = ACTIONS(3070),
    [anon_sym_AMP] = ACTIONS(3068),
    [anon_sym_SEMI] = ACTIONS(3070),
    [anon_sym___extension__] = ACTIONS(3068),
    [anon_sym_typedef] = ACTIONS(3068),
    [anon_sym_virtual] = ACTIONS(3068),
    [anon_sym_extern] = ACTIONS(3068),
    [anon_sym___attribute__] = ACTIONS(3068),
    [anon_sym___attribute] = ACTIONS(3068),
    [anon_sym_COLON_COLON] = ACTIONS(3070),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3070),
    [anon_sym___declspec] = ACTIONS(3068),
    [anon_sym___based] = ACTIONS(3068),
    [anon_sym___cdecl] = ACTIONS(3068),
    [anon_sym___clrcall] = ACTIONS(3068),
    [anon_sym___stdcall] = ACTIONS(3068),
    [anon_sym___fastcall] = ACTIONS(3068),
    [anon_sym___thiscall] = ACTIONS(3068),
    [anon_sym___vectorcall] = ACTIONS(3068),
    [anon_sym_LBRACE] = ACTIONS(3070),
    [anon_sym_signed] = ACTIONS(3068),
    [anon_sym_unsigned] = ACTIONS(3068),
    [anon_sym_long] = ACTIONS(3068),
    [anon_sym_short] = ACTIONS(3068),
    [anon_sym_LBRACK] = ACTIONS(3068),
    [anon_sym_static] = ACTIONS(3068),
    [anon_sym_register] = ACTIONS(3068),
    [anon_sym_inline] = ACTIONS(3068),
    [anon_sym___inline] = ACTIONS(3068),
    [anon_sym___inline__] = ACTIONS(3068),
    [anon_sym___forceinline] = ACTIONS(3068),
    [anon_sym_thread_local] = ACTIONS(3068),
    [anon_sym___thread] = ACTIONS(3068),
    [anon_sym_const] = ACTIONS(3068),
    [anon_sym_constexpr] = ACTIONS(3068),
    [anon_sym_volatile] = ACTIONS(3068),
    [anon_sym_restrict] = ACTIONS(3068),
    [anon_sym___restrict__] = ACTIONS(3068),
    [anon_sym__Atomic] = ACTIONS(3068),
    [anon_sym__Noreturn] = ACTIONS(3068),
    [anon_sym_noreturn] = ACTIONS(3068),
    [anon_sym__Nonnull] = ACTIONS(3068),
    [anon_sym_mutable] = ACTIONS(3068),
    [anon_sym_constinit] = ACTIONS(3068),
    [anon_sym_consteval] = ACTIONS(3068),
    [anon_sym_alignas] = ACTIONS(3068),
    [anon_sym__Alignas] = ACTIONS(3068),
    [sym_primitive_type] = ACTIONS(3068),
    [anon_sym_enum] = ACTIONS(3068),
    [anon_sym_class] = ACTIONS(3068),
    [anon_sym_struct] = ACTIONS(3068),
    [anon_sym_union] = ACTIONS(3068),
    [anon_sym_if] = ACTIONS(3068),
    [anon_sym_switch] = ACTIONS(3068),
    [anon_sym_case] = ACTIONS(3068),
    [anon_sym_default] = ACTIONS(3068),
    [anon_sym_while] = ACTIONS(3068),
    [anon_sym_do] = ACTIONS(3068),
    [anon_sym_for] = ACTIONS(3068),
    [anon_sym_return] = ACTIONS(3068),
    [anon_sym_break] = ACTIONS(3068),
    [anon_sym_continue] = ACTIONS(3068),
    [anon_sym_goto] = ACTIONS(3068),
    [anon_sym___try] = ACTIONS(3068),
    [anon_sym___leave] = ACTIONS(3068),
    [anon_sym_not] = ACTIONS(3068),
    [anon_sym_compl] = ACTIONS(3068),
    [anon_sym_DASH_DASH] = ACTIONS(3070),
    [anon_sym_PLUS_PLUS] = ACTIONS(3070),
    [anon_sym_sizeof] = ACTIONS(3068),
    [anon_sym___alignof__] = ACTIONS(3068),
    [anon_sym___alignof] = ACTIONS(3068),
    [anon_sym__alignof] = ACTIONS(3068),
    [anon_sym_alignof] = ACTIONS(3068),
    [anon_sym__Alignof] = ACTIONS(3068),
    [anon_sym_offsetof] = ACTIONS(3068),
    [anon_sym__Generic] = ACTIONS(3068),
    [anon_sym_asm] = ACTIONS(3068),
    [anon_sym___asm__] = ACTIONS(3068),
    [anon_sym___asm] = ACTIONS(3068),
    [sym_number_literal] = ACTIONS(3070),
    [anon_sym_L_SQUOTE] = ACTIONS(3070),
    [anon_sym_u_SQUOTE] = ACTIONS(3070),
    [anon_sym_U_SQUOTE] = ACTIONS(3070),
    [anon_sym_u8_SQUOTE] = ACTIONS(3070),
    [anon_sym_SQUOTE] = ACTIONS(3070),
    [anon_sym_L_DQUOTE] = ACTIONS(3070),
    [anon_sym_u_DQUOTE] = ACTIONS(3070),
    [anon_sym_U_DQUOTE] = ACTIONS(3070),
    [anon_sym_u8_DQUOTE] = ACTIONS(3070),
    [anon_sym_DQUOTE] = ACTIONS(3070),
    [sym_true] = ACTIONS(3068),
    [sym_false] = ACTIONS(3068),
    [anon_sym_NULL] = ACTIONS(3068),
    [anon_sym_nullptr] = ACTIONS(3068),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3068),
    [anon_sym_decltype] = ACTIONS(3068),
    [anon_sym_explicit] = ACTIONS(3068),
    [anon_sym_typename] = ACTIONS(3068),
    [anon_sym_template] = ACTIONS(3068),
    [anon_sym_operator] = ACTIONS(3068),
    [anon_sym_try] = ACTIONS(3068),
    [anon_sym_delete] = ACTIONS(3068),
    [anon_sym_throw] = ACTIONS(3068),
    [anon_sym_namespace] = ACTIONS(3068),
    [anon_sym_using] = ACTIONS(3068),
    [anon_sym_static_assert] = ACTIONS(3068),
    [anon_sym_concept] = ACTIONS(3068),
    [anon_sym_co_return] = ACTIONS(3068),
    [anon_sym_co_yield] = ACTIONS(3068),
    [anon_sym_R_DQUOTE] = ACTIONS(3070),
    [anon_sym_LR_DQUOTE] = ACTIONS(3070),
    [anon_sym_uR_DQUOTE] = ACTIONS(3070),
    [anon_sym_UR_DQUOTE] = ACTIONS(3070),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3070),
    [anon_sym_co_await] = ACTIONS(3068),
    [anon_sym_new] = ACTIONS(3068),
    [anon_sym_requires] = ACTIONS(3068),
    [sym_this] = ACTIONS(3068),
  },
  [557] = {
    [sym_identifier] = ACTIONS(2735),
    [aux_sym_preproc_include_token1] = ACTIONS(2735),
    [aux_sym_preproc_def_token1] = ACTIONS(2735),
    [aux_sym_preproc_if_token1] = ACTIONS(2735),
    [aux_sym_preproc_if_token2] = ACTIONS(2735),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2735),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2735),
    [sym_preproc_directive] = ACTIONS(2735),
    [anon_sym_LPAREN2] = ACTIONS(2737),
    [anon_sym_BANG] = ACTIONS(2737),
    [anon_sym_TILDE] = ACTIONS(2737),
    [anon_sym_DASH] = ACTIONS(2735),
    [anon_sym_PLUS] = ACTIONS(2735),
    [anon_sym_STAR] = ACTIONS(2737),
    [anon_sym_AMP_AMP] = ACTIONS(2737),
    [anon_sym_AMP] = ACTIONS(2735),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym___extension__] = ACTIONS(2735),
    [anon_sym_typedef] = ACTIONS(2735),
    [anon_sym_virtual] = ACTIONS(2735),
    [anon_sym_extern] = ACTIONS(2735),
    [anon_sym___attribute__] = ACTIONS(2735),
    [anon_sym___attribute] = ACTIONS(2735),
    [anon_sym_COLON_COLON] = ACTIONS(2737),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2737),
    [anon_sym___declspec] = ACTIONS(2735),
    [anon_sym___based] = ACTIONS(2735),
    [anon_sym___cdecl] = ACTIONS(2735),
    [anon_sym___clrcall] = ACTIONS(2735),
    [anon_sym___stdcall] = ACTIONS(2735),
    [anon_sym___fastcall] = ACTIONS(2735),
    [anon_sym___thiscall] = ACTIONS(2735),
    [anon_sym___vectorcall] = ACTIONS(2735),
    [anon_sym_LBRACE] = ACTIONS(2737),
    [anon_sym_signed] = ACTIONS(2735),
    [anon_sym_unsigned] = ACTIONS(2735),
    [anon_sym_long] = ACTIONS(2735),
    [anon_sym_short] = ACTIONS(2735),
    [anon_sym_LBRACK] = ACTIONS(2735),
    [anon_sym_static] = ACTIONS(2735),
    [anon_sym_register] = ACTIONS(2735),
    [anon_sym_inline] = ACTIONS(2735),
    [anon_sym___inline] = ACTIONS(2735),
    [anon_sym___inline__] = ACTIONS(2735),
    [anon_sym___forceinline] = ACTIONS(2735),
    [anon_sym_thread_local] = ACTIONS(2735),
    [anon_sym___thread] = ACTIONS(2735),
    [anon_sym_const] = ACTIONS(2735),
    [anon_sym_constexpr] = ACTIONS(2735),
    [anon_sym_volatile] = ACTIONS(2735),
    [anon_sym_restrict] = ACTIONS(2735),
    [anon_sym___restrict__] = ACTIONS(2735),
    [anon_sym__Atomic] = ACTIONS(2735),
    [anon_sym__Noreturn] = ACTIONS(2735),
    [anon_sym_noreturn] = ACTIONS(2735),
    [anon_sym__Nonnull] = ACTIONS(2735),
    [anon_sym_mutable] = ACTIONS(2735),
    [anon_sym_constinit] = ACTIONS(2735),
    [anon_sym_consteval] = ACTIONS(2735),
    [anon_sym_alignas] = ACTIONS(2735),
    [anon_sym__Alignas] = ACTIONS(2735),
    [sym_primitive_type] = ACTIONS(2735),
    [anon_sym_enum] = ACTIONS(2735),
    [anon_sym_class] = ACTIONS(2735),
    [anon_sym_struct] = ACTIONS(2735),
    [anon_sym_union] = ACTIONS(2735),
    [anon_sym_if] = ACTIONS(2735),
    [anon_sym_switch] = ACTIONS(2735),
    [anon_sym_case] = ACTIONS(2735),
    [anon_sym_default] = ACTIONS(2735),
    [anon_sym_while] = ACTIONS(2735),
    [anon_sym_do] = ACTIONS(2735),
    [anon_sym_for] = ACTIONS(2735),
    [anon_sym_return] = ACTIONS(2735),
    [anon_sym_break] = ACTIONS(2735),
    [anon_sym_continue] = ACTIONS(2735),
    [anon_sym_goto] = ACTIONS(2735),
    [anon_sym___try] = ACTIONS(2735),
    [anon_sym___leave] = ACTIONS(2735),
    [anon_sym_not] = ACTIONS(2735),
    [anon_sym_compl] = ACTIONS(2735),
    [anon_sym_DASH_DASH] = ACTIONS(2737),
    [anon_sym_PLUS_PLUS] = ACTIONS(2737),
    [anon_sym_sizeof] = ACTIONS(2735),
    [anon_sym___alignof__] = ACTIONS(2735),
    [anon_sym___alignof] = ACTIONS(2735),
    [anon_sym__alignof] = ACTIONS(2735),
    [anon_sym_alignof] = ACTIONS(2735),
    [anon_sym__Alignof] = ACTIONS(2735),
    [anon_sym_offsetof] = ACTIONS(2735),
    [anon_sym__Generic] = ACTIONS(2735),
    [anon_sym_asm] = ACTIONS(2735),
    [anon_sym___asm__] = ACTIONS(2735),
    [anon_sym___asm] = ACTIONS(2735),
    [sym_number_literal] = ACTIONS(2737),
    [anon_sym_L_SQUOTE] = ACTIONS(2737),
    [anon_sym_u_SQUOTE] = ACTIONS(2737),
    [anon_sym_U_SQUOTE] = ACTIONS(2737),
    [anon_sym_u8_SQUOTE] = ACTIONS(2737),
    [anon_sym_SQUOTE] = ACTIONS(2737),
    [anon_sym_L_DQUOTE] = ACTIONS(2737),
    [anon_sym_u_DQUOTE] = ACTIONS(2737),
    [anon_sym_U_DQUOTE] = ACTIONS(2737),
    [anon_sym_u8_DQUOTE] = ACTIONS(2737),
    [anon_sym_DQUOTE] = ACTIONS(2737),
    [sym_true] = ACTIONS(2735),
    [sym_false] = ACTIONS(2735),
    [anon_sym_NULL] = ACTIONS(2735),
    [anon_sym_nullptr] = ACTIONS(2735),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2735),
    [anon_sym_decltype] = ACTIONS(2735),
    [anon_sym_explicit] = ACTIONS(2735),
    [anon_sym_typename] = ACTIONS(2735),
    [anon_sym_template] = ACTIONS(2735),
    [anon_sym_operator] = ACTIONS(2735),
    [anon_sym_try] = ACTIONS(2735),
    [anon_sym_delete] = ACTIONS(2735),
    [anon_sym_throw] = ACTIONS(2735),
    [anon_sym_namespace] = ACTIONS(2735),
    [anon_sym_using] = ACTIONS(2735),
    [anon_sym_static_assert] = ACTIONS(2735),
    [anon_sym_concept] = ACTIONS(2735),
    [anon_sym_co_return] = ACTIONS(2735),
    [anon_sym_co_yield] = ACTIONS(2735),
    [anon_sym_R_DQUOTE] = ACTIONS(2737),
    [anon_sym_LR_DQUOTE] = ACTIONS(2737),
    [anon_sym_uR_DQUOTE] = ACTIONS(2737),
    [anon_sym_UR_DQUOTE] = ACTIONS(2737),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2737),
    [anon_sym_co_await] = ACTIONS(2735),
    [anon_sym_new] = ACTIONS(2735),
    [anon_sym_requires] = ACTIONS(2735),
    [sym_this] = ACTIONS(2735),
  },
  [558] = {
    [sym_identifier] = ACTIONS(2767),
    [aux_sym_preproc_include_token1] = ACTIONS(2767),
    [aux_sym_preproc_def_token1] = ACTIONS(2767),
    [aux_sym_preproc_if_token1] = ACTIONS(2767),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2767),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2767),
    [sym_preproc_directive] = ACTIONS(2767),
    [anon_sym_LPAREN2] = ACTIONS(2769),
    [anon_sym_BANG] = ACTIONS(2769),
    [anon_sym_TILDE] = ACTIONS(2769),
    [anon_sym_DASH] = ACTIONS(2767),
    [anon_sym_PLUS] = ACTIONS(2767),
    [anon_sym_STAR] = ACTIONS(2769),
    [anon_sym_AMP_AMP] = ACTIONS(2769),
    [anon_sym_AMP] = ACTIONS(2767),
    [anon_sym_SEMI] = ACTIONS(2769),
    [anon_sym___extension__] = ACTIONS(2767),
    [anon_sym_typedef] = ACTIONS(2767),
    [anon_sym_virtual] = ACTIONS(2767),
    [anon_sym_extern] = ACTIONS(2767),
    [anon_sym___attribute__] = ACTIONS(2767),
    [anon_sym___attribute] = ACTIONS(2767),
    [anon_sym_COLON_COLON] = ACTIONS(2769),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2769),
    [anon_sym___declspec] = ACTIONS(2767),
    [anon_sym___based] = ACTIONS(2767),
    [anon_sym___cdecl] = ACTIONS(2767),
    [anon_sym___clrcall] = ACTIONS(2767),
    [anon_sym___stdcall] = ACTIONS(2767),
    [anon_sym___fastcall] = ACTIONS(2767),
    [anon_sym___thiscall] = ACTIONS(2767),
    [anon_sym___vectorcall] = ACTIONS(2767),
    [anon_sym_LBRACE] = ACTIONS(2769),
    [anon_sym_RBRACE] = ACTIONS(2769),
    [anon_sym_signed] = ACTIONS(2767),
    [anon_sym_unsigned] = ACTIONS(2767),
    [anon_sym_long] = ACTIONS(2767),
    [anon_sym_short] = ACTIONS(2767),
    [anon_sym_LBRACK] = ACTIONS(2767),
    [anon_sym_static] = ACTIONS(2767),
    [anon_sym_register] = ACTIONS(2767),
    [anon_sym_inline] = ACTIONS(2767),
    [anon_sym___inline] = ACTIONS(2767),
    [anon_sym___inline__] = ACTIONS(2767),
    [anon_sym___forceinline] = ACTIONS(2767),
    [anon_sym_thread_local] = ACTIONS(2767),
    [anon_sym___thread] = ACTIONS(2767),
    [anon_sym_const] = ACTIONS(2767),
    [anon_sym_constexpr] = ACTIONS(2767),
    [anon_sym_volatile] = ACTIONS(2767),
    [anon_sym_restrict] = ACTIONS(2767),
    [anon_sym___restrict__] = ACTIONS(2767),
    [anon_sym__Atomic] = ACTIONS(2767),
    [anon_sym__Noreturn] = ACTIONS(2767),
    [anon_sym_noreturn] = ACTIONS(2767),
    [anon_sym__Nonnull] = ACTIONS(2767),
    [anon_sym_mutable] = ACTIONS(2767),
    [anon_sym_constinit] = ACTIONS(2767),
    [anon_sym_consteval] = ACTIONS(2767),
    [anon_sym_alignas] = ACTIONS(2767),
    [anon_sym__Alignas] = ACTIONS(2767),
    [sym_primitive_type] = ACTIONS(2767),
    [anon_sym_enum] = ACTIONS(2767),
    [anon_sym_class] = ACTIONS(2767),
    [anon_sym_struct] = ACTIONS(2767),
    [anon_sym_union] = ACTIONS(2767),
    [anon_sym_if] = ACTIONS(2767),
    [anon_sym_switch] = ACTIONS(2767),
    [anon_sym_case] = ACTIONS(2767),
    [anon_sym_default] = ACTIONS(2767),
    [anon_sym_while] = ACTIONS(2767),
    [anon_sym_do] = ACTIONS(2767),
    [anon_sym_for] = ACTIONS(2767),
    [anon_sym_return] = ACTIONS(2767),
    [anon_sym_break] = ACTIONS(2767),
    [anon_sym_continue] = ACTIONS(2767),
    [anon_sym_goto] = ACTIONS(2767),
    [anon_sym___try] = ACTIONS(2767),
    [anon_sym___leave] = ACTIONS(2767),
    [anon_sym_not] = ACTIONS(2767),
    [anon_sym_compl] = ACTIONS(2767),
    [anon_sym_DASH_DASH] = ACTIONS(2769),
    [anon_sym_PLUS_PLUS] = ACTIONS(2769),
    [anon_sym_sizeof] = ACTIONS(2767),
    [anon_sym___alignof__] = ACTIONS(2767),
    [anon_sym___alignof] = ACTIONS(2767),
    [anon_sym__alignof] = ACTIONS(2767),
    [anon_sym_alignof] = ACTIONS(2767),
    [anon_sym__Alignof] = ACTIONS(2767),
    [anon_sym_offsetof] = ACTIONS(2767),
    [anon_sym__Generic] = ACTIONS(2767),
    [anon_sym_asm] = ACTIONS(2767),
    [anon_sym___asm__] = ACTIONS(2767),
    [anon_sym___asm] = ACTIONS(2767),
    [sym_number_literal] = ACTIONS(2769),
    [anon_sym_L_SQUOTE] = ACTIONS(2769),
    [anon_sym_u_SQUOTE] = ACTIONS(2769),
    [anon_sym_U_SQUOTE] = ACTIONS(2769),
    [anon_sym_u8_SQUOTE] = ACTIONS(2769),
    [anon_sym_SQUOTE] = ACTIONS(2769),
    [anon_sym_L_DQUOTE] = ACTIONS(2769),
    [anon_sym_u_DQUOTE] = ACTIONS(2769),
    [anon_sym_U_DQUOTE] = ACTIONS(2769),
    [anon_sym_u8_DQUOTE] = ACTIONS(2769),
    [anon_sym_DQUOTE] = ACTIONS(2769),
    [sym_true] = ACTIONS(2767),
    [sym_false] = ACTIONS(2767),
    [anon_sym_NULL] = ACTIONS(2767),
    [anon_sym_nullptr] = ACTIONS(2767),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2767),
    [anon_sym_decltype] = ACTIONS(2767),
    [anon_sym_explicit] = ACTIONS(2767),
    [anon_sym_typename] = ACTIONS(2767),
    [anon_sym_template] = ACTIONS(2767),
    [anon_sym_operator] = ACTIONS(2767),
    [anon_sym_try] = ACTIONS(2767),
    [anon_sym_delete] = ACTIONS(2767),
    [anon_sym_throw] = ACTIONS(2767),
    [anon_sym_namespace] = ACTIONS(2767),
    [anon_sym_using] = ACTIONS(2767),
    [anon_sym_static_assert] = ACTIONS(2767),
    [anon_sym_concept] = ACTIONS(2767),
    [anon_sym_co_return] = ACTIONS(2767),
    [anon_sym_co_yield] = ACTIONS(2767),
    [anon_sym_R_DQUOTE] = ACTIONS(2769),
    [anon_sym_LR_DQUOTE] = ACTIONS(2769),
    [anon_sym_uR_DQUOTE] = ACTIONS(2769),
    [anon_sym_UR_DQUOTE] = ACTIONS(2769),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2769),
    [anon_sym_co_await] = ACTIONS(2767),
    [anon_sym_new] = ACTIONS(2767),
    [anon_sym_requires] = ACTIONS(2767),
    [sym_this] = ACTIONS(2767),
  },
  [559] = {
    [sym_identifier] = ACTIONS(2838),
    [aux_sym_preproc_include_token1] = ACTIONS(2838),
    [aux_sym_preproc_def_token1] = ACTIONS(2838),
    [aux_sym_preproc_if_token1] = ACTIONS(2838),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2838),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2838),
    [sym_preproc_directive] = ACTIONS(2838),
    [anon_sym_LPAREN2] = ACTIONS(2840),
    [anon_sym_BANG] = ACTIONS(2840),
    [anon_sym_TILDE] = ACTIONS(2840),
    [anon_sym_DASH] = ACTIONS(2838),
    [anon_sym_PLUS] = ACTIONS(2838),
    [anon_sym_STAR] = ACTIONS(2840),
    [anon_sym_AMP_AMP] = ACTIONS(2840),
    [anon_sym_AMP] = ACTIONS(2838),
    [anon_sym_SEMI] = ACTIONS(2840),
    [anon_sym___extension__] = ACTIONS(2838),
    [anon_sym_typedef] = ACTIONS(2838),
    [anon_sym_virtual] = ACTIONS(2838),
    [anon_sym_extern] = ACTIONS(2838),
    [anon_sym___attribute__] = ACTIONS(2838),
    [anon_sym___attribute] = ACTIONS(2838),
    [anon_sym_COLON_COLON] = ACTIONS(2840),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2840),
    [anon_sym___declspec] = ACTIONS(2838),
    [anon_sym___based] = ACTIONS(2838),
    [anon_sym___cdecl] = ACTIONS(2838),
    [anon_sym___clrcall] = ACTIONS(2838),
    [anon_sym___stdcall] = ACTIONS(2838),
    [anon_sym___fastcall] = ACTIONS(2838),
    [anon_sym___thiscall] = ACTIONS(2838),
    [anon_sym___vectorcall] = ACTIONS(2838),
    [anon_sym_LBRACE] = ACTIONS(2840),
    [anon_sym_RBRACE] = ACTIONS(2840),
    [anon_sym_signed] = ACTIONS(2838),
    [anon_sym_unsigned] = ACTIONS(2838),
    [anon_sym_long] = ACTIONS(2838),
    [anon_sym_short] = ACTIONS(2838),
    [anon_sym_LBRACK] = ACTIONS(2838),
    [anon_sym_static] = ACTIONS(2838),
    [anon_sym_register] = ACTIONS(2838),
    [anon_sym_inline] = ACTIONS(2838),
    [anon_sym___inline] = ACTIONS(2838),
    [anon_sym___inline__] = ACTIONS(2838),
    [anon_sym___forceinline] = ACTIONS(2838),
    [anon_sym_thread_local] = ACTIONS(2838),
    [anon_sym___thread] = ACTIONS(2838),
    [anon_sym_const] = ACTIONS(2838),
    [anon_sym_constexpr] = ACTIONS(2838),
    [anon_sym_volatile] = ACTIONS(2838),
    [anon_sym_restrict] = ACTIONS(2838),
    [anon_sym___restrict__] = ACTIONS(2838),
    [anon_sym__Atomic] = ACTIONS(2838),
    [anon_sym__Noreturn] = ACTIONS(2838),
    [anon_sym_noreturn] = ACTIONS(2838),
    [anon_sym__Nonnull] = ACTIONS(2838),
    [anon_sym_mutable] = ACTIONS(2838),
    [anon_sym_constinit] = ACTIONS(2838),
    [anon_sym_consteval] = ACTIONS(2838),
    [anon_sym_alignas] = ACTIONS(2838),
    [anon_sym__Alignas] = ACTIONS(2838),
    [sym_primitive_type] = ACTIONS(2838),
    [anon_sym_enum] = ACTIONS(2838),
    [anon_sym_class] = ACTIONS(2838),
    [anon_sym_struct] = ACTIONS(2838),
    [anon_sym_union] = ACTIONS(2838),
    [anon_sym_if] = ACTIONS(2838),
    [anon_sym_switch] = ACTIONS(2838),
    [anon_sym_case] = ACTIONS(2838),
    [anon_sym_default] = ACTIONS(2838),
    [anon_sym_while] = ACTIONS(2838),
    [anon_sym_do] = ACTIONS(2838),
    [anon_sym_for] = ACTIONS(2838),
    [anon_sym_return] = ACTIONS(2838),
    [anon_sym_break] = ACTIONS(2838),
    [anon_sym_continue] = ACTIONS(2838),
    [anon_sym_goto] = ACTIONS(2838),
    [anon_sym___try] = ACTIONS(2838),
    [anon_sym___leave] = ACTIONS(2838),
    [anon_sym_not] = ACTIONS(2838),
    [anon_sym_compl] = ACTIONS(2838),
    [anon_sym_DASH_DASH] = ACTIONS(2840),
    [anon_sym_PLUS_PLUS] = ACTIONS(2840),
    [anon_sym_sizeof] = ACTIONS(2838),
    [anon_sym___alignof__] = ACTIONS(2838),
    [anon_sym___alignof] = ACTIONS(2838),
    [anon_sym__alignof] = ACTIONS(2838),
    [anon_sym_alignof] = ACTIONS(2838),
    [anon_sym__Alignof] = ACTIONS(2838),
    [anon_sym_offsetof] = ACTIONS(2838),
    [anon_sym__Generic] = ACTIONS(2838),
    [anon_sym_asm] = ACTIONS(2838),
    [anon_sym___asm__] = ACTIONS(2838),
    [anon_sym___asm] = ACTIONS(2838),
    [sym_number_literal] = ACTIONS(2840),
    [anon_sym_L_SQUOTE] = ACTIONS(2840),
    [anon_sym_u_SQUOTE] = ACTIONS(2840),
    [anon_sym_U_SQUOTE] = ACTIONS(2840),
    [anon_sym_u8_SQUOTE] = ACTIONS(2840),
    [anon_sym_SQUOTE] = ACTIONS(2840),
    [anon_sym_L_DQUOTE] = ACTIONS(2840),
    [anon_sym_u_DQUOTE] = ACTIONS(2840),
    [anon_sym_U_DQUOTE] = ACTIONS(2840),
    [anon_sym_u8_DQUOTE] = ACTIONS(2840),
    [anon_sym_DQUOTE] = ACTIONS(2840),
    [sym_true] = ACTIONS(2838),
    [sym_false] = ACTIONS(2838),
    [anon_sym_NULL] = ACTIONS(2838),
    [anon_sym_nullptr] = ACTIONS(2838),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2838),
    [anon_sym_decltype] = ACTIONS(2838),
    [anon_sym_explicit] = ACTIONS(2838),
    [anon_sym_typename] = ACTIONS(2838),
    [anon_sym_template] = ACTIONS(2838),
    [anon_sym_operator] = ACTIONS(2838),
    [anon_sym_try] = ACTIONS(2838),
    [anon_sym_delete] = ACTIONS(2838),
    [anon_sym_throw] = ACTIONS(2838),
    [anon_sym_namespace] = ACTIONS(2838),
    [anon_sym_using] = ACTIONS(2838),
    [anon_sym_static_assert] = ACTIONS(2838),
    [anon_sym_concept] = ACTIONS(2838),
    [anon_sym_co_return] = ACTIONS(2838),
    [anon_sym_co_yield] = ACTIONS(2838),
    [anon_sym_R_DQUOTE] = ACTIONS(2840),
    [anon_sym_LR_DQUOTE] = ACTIONS(2840),
    [anon_sym_uR_DQUOTE] = ACTIONS(2840),
    [anon_sym_UR_DQUOTE] = ACTIONS(2840),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2840),
    [anon_sym_co_await] = ACTIONS(2838),
    [anon_sym_new] = ACTIONS(2838),
    [anon_sym_requires] = ACTIONS(2838),
    [sym_this] = ACTIONS(2838),
  },
  [560] = {
    [sym_identifier] = ACTIONS(2826),
    [aux_sym_preproc_include_token1] = ACTIONS(2826),
    [aux_sym_preproc_def_token1] = ACTIONS(2826),
    [aux_sym_preproc_if_token1] = ACTIONS(2826),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2826),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2826),
    [sym_preproc_directive] = ACTIONS(2826),
    [anon_sym_LPAREN2] = ACTIONS(2828),
    [anon_sym_BANG] = ACTIONS(2828),
    [anon_sym_TILDE] = ACTIONS(2828),
    [anon_sym_DASH] = ACTIONS(2826),
    [anon_sym_PLUS] = ACTIONS(2826),
    [anon_sym_STAR] = ACTIONS(2828),
    [anon_sym_AMP_AMP] = ACTIONS(2828),
    [anon_sym_AMP] = ACTIONS(2826),
    [anon_sym_SEMI] = ACTIONS(2828),
    [anon_sym___extension__] = ACTIONS(2826),
    [anon_sym_typedef] = ACTIONS(2826),
    [anon_sym_virtual] = ACTIONS(2826),
    [anon_sym_extern] = ACTIONS(2826),
    [anon_sym___attribute__] = ACTIONS(2826),
    [anon_sym___attribute] = ACTIONS(2826),
    [anon_sym_COLON_COLON] = ACTIONS(2828),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2828),
    [anon_sym___declspec] = ACTIONS(2826),
    [anon_sym___based] = ACTIONS(2826),
    [anon_sym___cdecl] = ACTIONS(2826),
    [anon_sym___clrcall] = ACTIONS(2826),
    [anon_sym___stdcall] = ACTIONS(2826),
    [anon_sym___fastcall] = ACTIONS(2826),
    [anon_sym___thiscall] = ACTIONS(2826),
    [anon_sym___vectorcall] = ACTIONS(2826),
    [anon_sym_LBRACE] = ACTIONS(2828),
    [anon_sym_RBRACE] = ACTIONS(2828),
    [anon_sym_signed] = ACTIONS(2826),
    [anon_sym_unsigned] = ACTIONS(2826),
    [anon_sym_long] = ACTIONS(2826),
    [anon_sym_short] = ACTIONS(2826),
    [anon_sym_LBRACK] = ACTIONS(2826),
    [anon_sym_static] = ACTIONS(2826),
    [anon_sym_register] = ACTIONS(2826),
    [anon_sym_inline] = ACTIONS(2826),
    [anon_sym___inline] = ACTIONS(2826),
    [anon_sym___inline__] = ACTIONS(2826),
    [anon_sym___forceinline] = ACTIONS(2826),
    [anon_sym_thread_local] = ACTIONS(2826),
    [anon_sym___thread] = ACTIONS(2826),
    [anon_sym_const] = ACTIONS(2826),
    [anon_sym_constexpr] = ACTIONS(2826),
    [anon_sym_volatile] = ACTIONS(2826),
    [anon_sym_restrict] = ACTIONS(2826),
    [anon_sym___restrict__] = ACTIONS(2826),
    [anon_sym__Atomic] = ACTIONS(2826),
    [anon_sym__Noreturn] = ACTIONS(2826),
    [anon_sym_noreturn] = ACTIONS(2826),
    [anon_sym__Nonnull] = ACTIONS(2826),
    [anon_sym_mutable] = ACTIONS(2826),
    [anon_sym_constinit] = ACTIONS(2826),
    [anon_sym_consteval] = ACTIONS(2826),
    [anon_sym_alignas] = ACTIONS(2826),
    [anon_sym__Alignas] = ACTIONS(2826),
    [sym_primitive_type] = ACTIONS(2826),
    [anon_sym_enum] = ACTIONS(2826),
    [anon_sym_class] = ACTIONS(2826),
    [anon_sym_struct] = ACTIONS(2826),
    [anon_sym_union] = ACTIONS(2826),
    [anon_sym_if] = ACTIONS(2826),
    [anon_sym_switch] = ACTIONS(2826),
    [anon_sym_case] = ACTIONS(2826),
    [anon_sym_default] = ACTIONS(2826),
    [anon_sym_while] = ACTIONS(2826),
    [anon_sym_do] = ACTIONS(2826),
    [anon_sym_for] = ACTIONS(2826),
    [anon_sym_return] = ACTIONS(2826),
    [anon_sym_break] = ACTIONS(2826),
    [anon_sym_continue] = ACTIONS(2826),
    [anon_sym_goto] = ACTIONS(2826),
    [anon_sym___try] = ACTIONS(2826),
    [anon_sym___leave] = ACTIONS(2826),
    [anon_sym_not] = ACTIONS(2826),
    [anon_sym_compl] = ACTIONS(2826),
    [anon_sym_DASH_DASH] = ACTIONS(2828),
    [anon_sym_PLUS_PLUS] = ACTIONS(2828),
    [anon_sym_sizeof] = ACTIONS(2826),
    [anon_sym___alignof__] = ACTIONS(2826),
    [anon_sym___alignof] = ACTIONS(2826),
    [anon_sym__alignof] = ACTIONS(2826),
    [anon_sym_alignof] = ACTIONS(2826),
    [anon_sym__Alignof] = ACTIONS(2826),
    [anon_sym_offsetof] = ACTIONS(2826),
    [anon_sym__Generic] = ACTIONS(2826),
    [anon_sym_asm] = ACTIONS(2826),
    [anon_sym___asm__] = ACTIONS(2826),
    [anon_sym___asm] = ACTIONS(2826),
    [sym_number_literal] = ACTIONS(2828),
    [anon_sym_L_SQUOTE] = ACTIONS(2828),
    [anon_sym_u_SQUOTE] = ACTIONS(2828),
    [anon_sym_U_SQUOTE] = ACTIONS(2828),
    [anon_sym_u8_SQUOTE] = ACTIONS(2828),
    [anon_sym_SQUOTE] = ACTIONS(2828),
    [anon_sym_L_DQUOTE] = ACTIONS(2828),
    [anon_sym_u_DQUOTE] = ACTIONS(2828),
    [anon_sym_U_DQUOTE] = ACTIONS(2828),
    [anon_sym_u8_DQUOTE] = ACTIONS(2828),
    [anon_sym_DQUOTE] = ACTIONS(2828),
    [sym_true] = ACTIONS(2826),
    [sym_false] = ACTIONS(2826),
    [anon_sym_NULL] = ACTIONS(2826),
    [anon_sym_nullptr] = ACTIONS(2826),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2826),
    [anon_sym_decltype] = ACTIONS(2826),
    [anon_sym_explicit] = ACTIONS(2826),
    [anon_sym_typename] = ACTIONS(2826),
    [anon_sym_template] = ACTIONS(2826),
    [anon_sym_operator] = ACTIONS(2826),
    [anon_sym_try] = ACTIONS(2826),
    [anon_sym_delete] = ACTIONS(2826),
    [anon_sym_throw] = ACTIONS(2826),
    [anon_sym_namespace] = ACTIONS(2826),
    [anon_sym_using] = ACTIONS(2826),
    [anon_sym_static_assert] = ACTIONS(2826),
    [anon_sym_concept] = ACTIONS(2826),
    [anon_sym_co_return] = ACTIONS(2826),
    [anon_sym_co_yield] = ACTIONS(2826),
    [anon_sym_R_DQUOTE] = ACTIONS(2828),
    [anon_sym_LR_DQUOTE] = ACTIONS(2828),
    [anon_sym_uR_DQUOTE] = ACTIONS(2828),
    [anon_sym_UR_DQUOTE] = ACTIONS(2828),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2828),
    [anon_sym_co_await] = ACTIONS(2826),
    [anon_sym_new] = ACTIONS(2826),
    [anon_sym_requires] = ACTIONS(2826),
    [sym_this] = ACTIONS(2826),
  },
  [561] = {
    [sym_identifier] = ACTIONS(3170),
    [aux_sym_preproc_include_token1] = ACTIONS(3170),
    [aux_sym_preproc_def_token1] = ACTIONS(3170),
    [aux_sym_preproc_if_token1] = ACTIONS(3170),
    [aux_sym_preproc_if_token2] = ACTIONS(3170),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3170),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3170),
    [sym_preproc_directive] = ACTIONS(3170),
    [anon_sym_LPAREN2] = ACTIONS(3172),
    [anon_sym_BANG] = ACTIONS(3172),
    [anon_sym_TILDE] = ACTIONS(3172),
    [anon_sym_DASH] = ACTIONS(3170),
    [anon_sym_PLUS] = ACTIONS(3170),
    [anon_sym_STAR] = ACTIONS(3172),
    [anon_sym_AMP_AMP] = ACTIONS(3172),
    [anon_sym_AMP] = ACTIONS(3170),
    [anon_sym_SEMI] = ACTIONS(3172),
    [anon_sym___extension__] = ACTIONS(3170),
    [anon_sym_typedef] = ACTIONS(3170),
    [anon_sym_virtual] = ACTIONS(3170),
    [anon_sym_extern] = ACTIONS(3170),
    [anon_sym___attribute__] = ACTIONS(3170),
    [anon_sym___attribute] = ACTIONS(3170),
    [anon_sym_COLON_COLON] = ACTIONS(3172),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3172),
    [anon_sym___declspec] = ACTIONS(3170),
    [anon_sym___based] = ACTIONS(3170),
    [anon_sym___cdecl] = ACTIONS(3170),
    [anon_sym___clrcall] = ACTIONS(3170),
    [anon_sym___stdcall] = ACTIONS(3170),
    [anon_sym___fastcall] = ACTIONS(3170),
    [anon_sym___thiscall] = ACTIONS(3170),
    [anon_sym___vectorcall] = ACTIONS(3170),
    [anon_sym_LBRACE] = ACTIONS(3172),
    [anon_sym_signed] = ACTIONS(3170),
    [anon_sym_unsigned] = ACTIONS(3170),
    [anon_sym_long] = ACTIONS(3170),
    [anon_sym_short] = ACTIONS(3170),
    [anon_sym_LBRACK] = ACTIONS(3170),
    [anon_sym_static] = ACTIONS(3170),
    [anon_sym_register] = ACTIONS(3170),
    [anon_sym_inline] = ACTIONS(3170),
    [anon_sym___inline] = ACTIONS(3170),
    [anon_sym___inline__] = ACTIONS(3170),
    [anon_sym___forceinline] = ACTIONS(3170),
    [anon_sym_thread_local] = ACTIONS(3170),
    [anon_sym___thread] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3170),
    [anon_sym_constexpr] = ACTIONS(3170),
    [anon_sym_volatile] = ACTIONS(3170),
    [anon_sym_restrict] = ACTIONS(3170),
    [anon_sym___restrict__] = ACTIONS(3170),
    [anon_sym__Atomic] = ACTIONS(3170),
    [anon_sym__Noreturn] = ACTIONS(3170),
    [anon_sym_noreturn] = ACTIONS(3170),
    [anon_sym__Nonnull] = ACTIONS(3170),
    [anon_sym_mutable] = ACTIONS(3170),
    [anon_sym_constinit] = ACTIONS(3170),
    [anon_sym_consteval] = ACTIONS(3170),
    [anon_sym_alignas] = ACTIONS(3170),
    [anon_sym__Alignas] = ACTIONS(3170),
    [sym_primitive_type] = ACTIONS(3170),
    [anon_sym_enum] = ACTIONS(3170),
    [anon_sym_class] = ACTIONS(3170),
    [anon_sym_struct] = ACTIONS(3170),
    [anon_sym_union] = ACTIONS(3170),
    [anon_sym_if] = ACTIONS(3170),
    [anon_sym_switch] = ACTIONS(3170),
    [anon_sym_case] = ACTIONS(3170),
    [anon_sym_default] = ACTIONS(3170),
    [anon_sym_while] = ACTIONS(3170),
    [anon_sym_do] = ACTIONS(3170),
    [anon_sym_for] = ACTIONS(3170),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_break] = ACTIONS(3170),
    [anon_sym_continue] = ACTIONS(3170),
    [anon_sym_goto] = ACTIONS(3170),
    [anon_sym___try] = ACTIONS(3170),
    [anon_sym___leave] = ACTIONS(3170),
    [anon_sym_not] = ACTIONS(3170),
    [anon_sym_compl] = ACTIONS(3170),
    [anon_sym_DASH_DASH] = ACTIONS(3172),
    [anon_sym_PLUS_PLUS] = ACTIONS(3172),
    [anon_sym_sizeof] = ACTIONS(3170),
    [anon_sym___alignof__] = ACTIONS(3170),
    [anon_sym___alignof] = ACTIONS(3170),
    [anon_sym__alignof] = ACTIONS(3170),
    [anon_sym_alignof] = ACTIONS(3170),
    [anon_sym__Alignof] = ACTIONS(3170),
    [anon_sym_offsetof] = ACTIONS(3170),
    [anon_sym__Generic] = ACTIONS(3170),
    [anon_sym_asm] = ACTIONS(3170),
    [anon_sym___asm__] = ACTIONS(3170),
    [anon_sym___asm] = ACTIONS(3170),
    [sym_number_literal] = ACTIONS(3172),
    [anon_sym_L_SQUOTE] = ACTIONS(3172),
    [anon_sym_u_SQUOTE] = ACTIONS(3172),
    [anon_sym_U_SQUOTE] = ACTIONS(3172),
    [anon_sym_u8_SQUOTE] = ACTIONS(3172),
    [anon_sym_SQUOTE] = ACTIONS(3172),
    [anon_sym_L_DQUOTE] = ACTIONS(3172),
    [anon_sym_u_DQUOTE] = ACTIONS(3172),
    [anon_sym_U_DQUOTE] = ACTIONS(3172),
    [anon_sym_u8_DQUOTE] = ACTIONS(3172),
    [anon_sym_DQUOTE] = ACTIONS(3172),
    [sym_true] = ACTIONS(3170),
    [sym_false] = ACTIONS(3170),
    [anon_sym_NULL] = ACTIONS(3170),
    [anon_sym_nullptr] = ACTIONS(3170),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3170),
    [anon_sym_decltype] = ACTIONS(3170),
    [anon_sym_explicit] = ACTIONS(3170),
    [anon_sym_typename] = ACTIONS(3170),
    [anon_sym_template] = ACTIONS(3170),
    [anon_sym_operator] = ACTIONS(3170),
    [anon_sym_try] = ACTIONS(3170),
    [anon_sym_delete] = ACTIONS(3170),
    [anon_sym_throw] = ACTIONS(3170),
    [anon_sym_namespace] = ACTIONS(3170),
    [anon_sym_using] = ACTIONS(3170),
    [anon_sym_static_assert] = ACTIONS(3170),
    [anon_sym_concept] = ACTIONS(3170),
    [anon_sym_co_return] = ACTIONS(3170),
    [anon_sym_co_yield] = ACTIONS(3170),
    [anon_sym_R_DQUOTE] = ACTIONS(3172),
    [anon_sym_LR_DQUOTE] = ACTIONS(3172),
    [anon_sym_uR_DQUOTE] = ACTIONS(3172),
    [anon_sym_UR_DQUOTE] = ACTIONS(3172),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3172),
    [anon_sym_co_await] = ACTIONS(3170),
    [anon_sym_new] = ACTIONS(3170),
    [anon_sym_requires] = ACTIONS(3170),
    [sym_this] = ACTIONS(3170),
  },
  [562] = {
    [sym_identifier] = ACTIONS(2830),
    [aux_sym_preproc_include_token1] = ACTIONS(2830),
    [aux_sym_preproc_def_token1] = ACTIONS(2830),
    [aux_sym_preproc_if_token1] = ACTIONS(2830),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2830),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2830),
    [sym_preproc_directive] = ACTIONS(2830),
    [anon_sym_LPAREN2] = ACTIONS(2832),
    [anon_sym_BANG] = ACTIONS(2832),
    [anon_sym_TILDE] = ACTIONS(2832),
    [anon_sym_DASH] = ACTIONS(2830),
    [anon_sym_PLUS] = ACTIONS(2830),
    [anon_sym_STAR] = ACTIONS(2832),
    [anon_sym_AMP_AMP] = ACTIONS(2832),
    [anon_sym_AMP] = ACTIONS(2830),
    [anon_sym_SEMI] = ACTIONS(2832),
    [anon_sym___extension__] = ACTIONS(2830),
    [anon_sym_typedef] = ACTIONS(2830),
    [anon_sym_virtual] = ACTIONS(2830),
    [anon_sym_extern] = ACTIONS(2830),
    [anon_sym___attribute__] = ACTIONS(2830),
    [anon_sym___attribute] = ACTIONS(2830),
    [anon_sym_COLON_COLON] = ACTIONS(2832),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2832),
    [anon_sym___declspec] = ACTIONS(2830),
    [anon_sym___based] = ACTIONS(2830),
    [anon_sym___cdecl] = ACTIONS(2830),
    [anon_sym___clrcall] = ACTIONS(2830),
    [anon_sym___stdcall] = ACTIONS(2830),
    [anon_sym___fastcall] = ACTIONS(2830),
    [anon_sym___thiscall] = ACTIONS(2830),
    [anon_sym___vectorcall] = ACTIONS(2830),
    [anon_sym_LBRACE] = ACTIONS(2832),
    [anon_sym_RBRACE] = ACTIONS(2832),
    [anon_sym_signed] = ACTIONS(2830),
    [anon_sym_unsigned] = ACTIONS(2830),
    [anon_sym_long] = ACTIONS(2830),
    [anon_sym_short] = ACTIONS(2830),
    [anon_sym_LBRACK] = ACTIONS(2830),
    [anon_sym_static] = ACTIONS(2830),
    [anon_sym_register] = ACTIONS(2830),
    [anon_sym_inline] = ACTIONS(2830),
    [anon_sym___inline] = ACTIONS(2830),
    [anon_sym___inline__] = ACTIONS(2830),
    [anon_sym___forceinline] = ACTIONS(2830),
    [anon_sym_thread_local] = ACTIONS(2830),
    [anon_sym___thread] = ACTIONS(2830),
    [anon_sym_const] = ACTIONS(2830),
    [anon_sym_constexpr] = ACTIONS(2830),
    [anon_sym_volatile] = ACTIONS(2830),
    [anon_sym_restrict] = ACTIONS(2830),
    [anon_sym___restrict__] = ACTIONS(2830),
    [anon_sym__Atomic] = ACTIONS(2830),
    [anon_sym__Noreturn] = ACTIONS(2830),
    [anon_sym_noreturn] = ACTIONS(2830),
    [anon_sym__Nonnull] = ACTIONS(2830),
    [anon_sym_mutable] = ACTIONS(2830),
    [anon_sym_constinit] = ACTIONS(2830),
    [anon_sym_consteval] = ACTIONS(2830),
    [anon_sym_alignas] = ACTIONS(2830),
    [anon_sym__Alignas] = ACTIONS(2830),
    [sym_primitive_type] = ACTIONS(2830),
    [anon_sym_enum] = ACTIONS(2830),
    [anon_sym_class] = ACTIONS(2830),
    [anon_sym_struct] = ACTIONS(2830),
    [anon_sym_union] = ACTIONS(2830),
    [anon_sym_if] = ACTIONS(2830),
    [anon_sym_switch] = ACTIONS(2830),
    [anon_sym_case] = ACTIONS(2830),
    [anon_sym_default] = ACTIONS(2830),
    [anon_sym_while] = ACTIONS(2830),
    [anon_sym_do] = ACTIONS(2830),
    [anon_sym_for] = ACTIONS(2830),
    [anon_sym_return] = ACTIONS(2830),
    [anon_sym_break] = ACTIONS(2830),
    [anon_sym_continue] = ACTIONS(2830),
    [anon_sym_goto] = ACTIONS(2830),
    [anon_sym___try] = ACTIONS(2830),
    [anon_sym___leave] = ACTIONS(2830),
    [anon_sym_not] = ACTIONS(2830),
    [anon_sym_compl] = ACTIONS(2830),
    [anon_sym_DASH_DASH] = ACTIONS(2832),
    [anon_sym_PLUS_PLUS] = ACTIONS(2832),
    [anon_sym_sizeof] = ACTIONS(2830),
    [anon_sym___alignof__] = ACTIONS(2830),
    [anon_sym___alignof] = ACTIONS(2830),
    [anon_sym__alignof] = ACTIONS(2830),
    [anon_sym_alignof] = ACTIONS(2830),
    [anon_sym__Alignof] = ACTIONS(2830),
    [anon_sym_offsetof] = ACTIONS(2830),
    [anon_sym__Generic] = ACTIONS(2830),
    [anon_sym_asm] = ACTIONS(2830),
    [anon_sym___asm__] = ACTIONS(2830),
    [anon_sym___asm] = ACTIONS(2830),
    [sym_number_literal] = ACTIONS(2832),
    [anon_sym_L_SQUOTE] = ACTIONS(2832),
    [anon_sym_u_SQUOTE] = ACTIONS(2832),
    [anon_sym_U_SQUOTE] = ACTIONS(2832),
    [anon_sym_u8_SQUOTE] = ACTIONS(2832),
    [anon_sym_SQUOTE] = ACTIONS(2832),
    [anon_sym_L_DQUOTE] = ACTIONS(2832),
    [anon_sym_u_DQUOTE] = ACTIONS(2832),
    [anon_sym_U_DQUOTE] = ACTIONS(2832),
    [anon_sym_u8_DQUOTE] = ACTIONS(2832),
    [anon_sym_DQUOTE] = ACTIONS(2832),
    [sym_true] = ACTIONS(2830),
    [sym_false] = ACTIONS(2830),
    [anon_sym_NULL] = ACTIONS(2830),
    [anon_sym_nullptr] = ACTIONS(2830),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2830),
    [anon_sym_decltype] = ACTIONS(2830),
    [anon_sym_explicit] = ACTIONS(2830),
    [anon_sym_typename] = ACTIONS(2830),
    [anon_sym_template] = ACTIONS(2830),
    [anon_sym_operator] = ACTIONS(2830),
    [anon_sym_try] = ACTIONS(2830),
    [anon_sym_delete] = ACTIONS(2830),
    [anon_sym_throw] = ACTIONS(2830),
    [anon_sym_namespace] = ACTIONS(2830),
    [anon_sym_using] = ACTIONS(2830),
    [anon_sym_static_assert] = ACTIONS(2830),
    [anon_sym_concept] = ACTIONS(2830),
    [anon_sym_co_return] = ACTIONS(2830),
    [anon_sym_co_yield] = ACTIONS(2830),
    [anon_sym_R_DQUOTE] = ACTIONS(2832),
    [anon_sym_LR_DQUOTE] = ACTIONS(2832),
    [anon_sym_uR_DQUOTE] = ACTIONS(2832),
    [anon_sym_UR_DQUOTE] = ACTIONS(2832),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2832),
    [anon_sym_co_await] = ACTIONS(2830),
    [anon_sym_new] = ACTIONS(2830),
    [anon_sym_requires] = ACTIONS(2830),
    [sym_this] = ACTIONS(2830),
  },
  [563] = {
    [sym_identifier] = ACTIONS(2936),
    [aux_sym_preproc_include_token1] = ACTIONS(2936),
    [aux_sym_preproc_def_token1] = ACTIONS(2936),
    [aux_sym_preproc_if_token1] = ACTIONS(2936),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2936),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2936),
    [sym_preproc_directive] = ACTIONS(2936),
    [anon_sym_LPAREN2] = ACTIONS(2938),
    [anon_sym_BANG] = ACTIONS(2938),
    [anon_sym_TILDE] = ACTIONS(2938),
    [anon_sym_DASH] = ACTIONS(2936),
    [anon_sym_PLUS] = ACTIONS(2936),
    [anon_sym_STAR] = ACTIONS(2938),
    [anon_sym_AMP_AMP] = ACTIONS(2938),
    [anon_sym_AMP] = ACTIONS(2936),
    [anon_sym_SEMI] = ACTIONS(2938),
    [anon_sym___extension__] = ACTIONS(2936),
    [anon_sym_typedef] = ACTIONS(2936),
    [anon_sym_virtual] = ACTIONS(2936),
    [anon_sym_extern] = ACTIONS(2936),
    [anon_sym___attribute__] = ACTIONS(2936),
    [anon_sym___attribute] = ACTIONS(2936),
    [anon_sym_COLON_COLON] = ACTIONS(2938),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2938),
    [anon_sym___declspec] = ACTIONS(2936),
    [anon_sym___based] = ACTIONS(2936),
    [anon_sym___cdecl] = ACTIONS(2936),
    [anon_sym___clrcall] = ACTIONS(2936),
    [anon_sym___stdcall] = ACTIONS(2936),
    [anon_sym___fastcall] = ACTIONS(2936),
    [anon_sym___thiscall] = ACTIONS(2936),
    [anon_sym___vectorcall] = ACTIONS(2936),
    [anon_sym_LBRACE] = ACTIONS(2938),
    [anon_sym_RBRACE] = ACTIONS(2938),
    [anon_sym_signed] = ACTIONS(2936),
    [anon_sym_unsigned] = ACTIONS(2936),
    [anon_sym_long] = ACTIONS(2936),
    [anon_sym_short] = ACTIONS(2936),
    [anon_sym_LBRACK] = ACTIONS(2936),
    [anon_sym_static] = ACTIONS(2936),
    [anon_sym_register] = ACTIONS(2936),
    [anon_sym_inline] = ACTIONS(2936),
    [anon_sym___inline] = ACTIONS(2936),
    [anon_sym___inline__] = ACTIONS(2936),
    [anon_sym___forceinline] = ACTIONS(2936),
    [anon_sym_thread_local] = ACTIONS(2936),
    [anon_sym___thread] = ACTIONS(2936),
    [anon_sym_const] = ACTIONS(2936),
    [anon_sym_constexpr] = ACTIONS(2936),
    [anon_sym_volatile] = ACTIONS(2936),
    [anon_sym_restrict] = ACTIONS(2936),
    [anon_sym___restrict__] = ACTIONS(2936),
    [anon_sym__Atomic] = ACTIONS(2936),
    [anon_sym__Noreturn] = ACTIONS(2936),
    [anon_sym_noreturn] = ACTIONS(2936),
    [anon_sym__Nonnull] = ACTIONS(2936),
    [anon_sym_mutable] = ACTIONS(2936),
    [anon_sym_constinit] = ACTIONS(2936),
    [anon_sym_consteval] = ACTIONS(2936),
    [anon_sym_alignas] = ACTIONS(2936),
    [anon_sym__Alignas] = ACTIONS(2936),
    [sym_primitive_type] = ACTIONS(2936),
    [anon_sym_enum] = ACTIONS(2936),
    [anon_sym_class] = ACTIONS(2936),
    [anon_sym_struct] = ACTIONS(2936),
    [anon_sym_union] = ACTIONS(2936),
    [anon_sym_if] = ACTIONS(2936),
    [anon_sym_switch] = ACTIONS(2936),
    [anon_sym_case] = ACTIONS(2936),
    [anon_sym_default] = ACTIONS(2936),
    [anon_sym_while] = ACTIONS(2936),
    [anon_sym_do] = ACTIONS(2936),
    [anon_sym_for] = ACTIONS(2936),
    [anon_sym_return] = ACTIONS(2936),
    [anon_sym_break] = ACTIONS(2936),
    [anon_sym_continue] = ACTIONS(2936),
    [anon_sym_goto] = ACTIONS(2936),
    [anon_sym___try] = ACTIONS(2936),
    [anon_sym___leave] = ACTIONS(2936),
    [anon_sym_not] = ACTIONS(2936),
    [anon_sym_compl] = ACTIONS(2936),
    [anon_sym_DASH_DASH] = ACTIONS(2938),
    [anon_sym_PLUS_PLUS] = ACTIONS(2938),
    [anon_sym_sizeof] = ACTIONS(2936),
    [anon_sym___alignof__] = ACTIONS(2936),
    [anon_sym___alignof] = ACTIONS(2936),
    [anon_sym__alignof] = ACTIONS(2936),
    [anon_sym_alignof] = ACTIONS(2936),
    [anon_sym__Alignof] = ACTIONS(2936),
    [anon_sym_offsetof] = ACTIONS(2936),
    [anon_sym__Generic] = ACTIONS(2936),
    [anon_sym_asm] = ACTIONS(2936),
    [anon_sym___asm__] = ACTIONS(2936),
    [anon_sym___asm] = ACTIONS(2936),
    [sym_number_literal] = ACTIONS(2938),
    [anon_sym_L_SQUOTE] = ACTIONS(2938),
    [anon_sym_u_SQUOTE] = ACTIONS(2938),
    [anon_sym_U_SQUOTE] = ACTIONS(2938),
    [anon_sym_u8_SQUOTE] = ACTIONS(2938),
    [anon_sym_SQUOTE] = ACTIONS(2938),
    [anon_sym_L_DQUOTE] = ACTIONS(2938),
    [anon_sym_u_DQUOTE] = ACTIONS(2938),
    [anon_sym_U_DQUOTE] = ACTIONS(2938),
    [anon_sym_u8_DQUOTE] = ACTIONS(2938),
    [anon_sym_DQUOTE] = ACTIONS(2938),
    [sym_true] = ACTIONS(2936),
    [sym_false] = ACTIONS(2936),
    [anon_sym_NULL] = ACTIONS(2936),
    [anon_sym_nullptr] = ACTIONS(2936),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2936),
    [anon_sym_decltype] = ACTIONS(2936),
    [anon_sym_explicit] = ACTIONS(2936),
    [anon_sym_typename] = ACTIONS(2936),
    [anon_sym_template] = ACTIONS(2936),
    [anon_sym_operator] = ACTIONS(2936),
    [anon_sym_try] = ACTIONS(2936),
    [anon_sym_delete] = ACTIONS(2936),
    [anon_sym_throw] = ACTIONS(2936),
    [anon_sym_namespace] = ACTIONS(2936),
    [anon_sym_using] = ACTIONS(2936),
    [anon_sym_static_assert] = ACTIONS(2936),
    [anon_sym_concept] = ACTIONS(2936),
    [anon_sym_co_return] = ACTIONS(2936),
    [anon_sym_co_yield] = ACTIONS(2936),
    [anon_sym_R_DQUOTE] = ACTIONS(2938),
    [anon_sym_LR_DQUOTE] = ACTIONS(2938),
    [anon_sym_uR_DQUOTE] = ACTIONS(2938),
    [anon_sym_UR_DQUOTE] = ACTIONS(2938),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2938),
    [anon_sym_co_await] = ACTIONS(2936),
    [anon_sym_new] = ACTIONS(2936),
    [anon_sym_requires] = ACTIONS(2936),
    [sym_this] = ACTIONS(2936),
  },
  [564] = {
    [sym_identifier] = ACTIONS(3162),
    [aux_sym_preproc_include_token1] = ACTIONS(3162),
    [aux_sym_preproc_def_token1] = ACTIONS(3162),
    [aux_sym_preproc_if_token1] = ACTIONS(3162),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3162),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3162),
    [sym_preproc_directive] = ACTIONS(3162),
    [anon_sym_LPAREN2] = ACTIONS(3164),
    [anon_sym_BANG] = ACTIONS(3164),
    [anon_sym_TILDE] = ACTIONS(3164),
    [anon_sym_DASH] = ACTIONS(3162),
    [anon_sym_PLUS] = ACTIONS(3162),
    [anon_sym_STAR] = ACTIONS(3164),
    [anon_sym_AMP_AMP] = ACTIONS(3164),
    [anon_sym_AMP] = ACTIONS(3162),
    [anon_sym_SEMI] = ACTIONS(3164),
    [anon_sym___extension__] = ACTIONS(3162),
    [anon_sym_typedef] = ACTIONS(3162),
    [anon_sym_virtual] = ACTIONS(3162),
    [anon_sym_extern] = ACTIONS(3162),
    [anon_sym___attribute__] = ACTIONS(3162),
    [anon_sym___attribute] = ACTIONS(3162),
    [anon_sym_COLON_COLON] = ACTIONS(3164),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3164),
    [anon_sym___declspec] = ACTIONS(3162),
    [anon_sym___based] = ACTIONS(3162),
    [anon_sym___cdecl] = ACTIONS(3162),
    [anon_sym___clrcall] = ACTIONS(3162),
    [anon_sym___stdcall] = ACTIONS(3162),
    [anon_sym___fastcall] = ACTIONS(3162),
    [anon_sym___thiscall] = ACTIONS(3162),
    [anon_sym___vectorcall] = ACTIONS(3162),
    [anon_sym_LBRACE] = ACTIONS(3164),
    [anon_sym_RBRACE] = ACTIONS(3164),
    [anon_sym_signed] = ACTIONS(3162),
    [anon_sym_unsigned] = ACTIONS(3162),
    [anon_sym_long] = ACTIONS(3162),
    [anon_sym_short] = ACTIONS(3162),
    [anon_sym_LBRACK] = ACTIONS(3162),
    [anon_sym_static] = ACTIONS(3162),
    [anon_sym_register] = ACTIONS(3162),
    [anon_sym_inline] = ACTIONS(3162),
    [anon_sym___inline] = ACTIONS(3162),
    [anon_sym___inline__] = ACTIONS(3162),
    [anon_sym___forceinline] = ACTIONS(3162),
    [anon_sym_thread_local] = ACTIONS(3162),
    [anon_sym___thread] = ACTIONS(3162),
    [anon_sym_const] = ACTIONS(3162),
    [anon_sym_constexpr] = ACTIONS(3162),
    [anon_sym_volatile] = ACTIONS(3162),
    [anon_sym_restrict] = ACTIONS(3162),
    [anon_sym___restrict__] = ACTIONS(3162),
    [anon_sym__Atomic] = ACTIONS(3162),
    [anon_sym__Noreturn] = ACTIONS(3162),
    [anon_sym_noreturn] = ACTIONS(3162),
    [anon_sym__Nonnull] = ACTIONS(3162),
    [anon_sym_mutable] = ACTIONS(3162),
    [anon_sym_constinit] = ACTIONS(3162),
    [anon_sym_consteval] = ACTIONS(3162),
    [anon_sym_alignas] = ACTIONS(3162),
    [anon_sym__Alignas] = ACTIONS(3162),
    [sym_primitive_type] = ACTIONS(3162),
    [anon_sym_enum] = ACTIONS(3162),
    [anon_sym_class] = ACTIONS(3162),
    [anon_sym_struct] = ACTIONS(3162),
    [anon_sym_union] = ACTIONS(3162),
    [anon_sym_if] = ACTIONS(3162),
    [anon_sym_switch] = ACTIONS(3162),
    [anon_sym_case] = ACTIONS(3162),
    [anon_sym_default] = ACTIONS(3162),
    [anon_sym_while] = ACTIONS(3162),
    [anon_sym_do] = ACTIONS(3162),
    [anon_sym_for] = ACTIONS(3162),
    [anon_sym_return] = ACTIONS(3162),
    [anon_sym_break] = ACTIONS(3162),
    [anon_sym_continue] = ACTIONS(3162),
    [anon_sym_goto] = ACTIONS(3162),
    [anon_sym___try] = ACTIONS(3162),
    [anon_sym___leave] = ACTIONS(3162),
    [anon_sym_not] = ACTIONS(3162),
    [anon_sym_compl] = ACTIONS(3162),
    [anon_sym_DASH_DASH] = ACTIONS(3164),
    [anon_sym_PLUS_PLUS] = ACTIONS(3164),
    [anon_sym_sizeof] = ACTIONS(3162),
    [anon_sym___alignof__] = ACTIONS(3162),
    [anon_sym___alignof] = ACTIONS(3162),
    [anon_sym__alignof] = ACTIONS(3162),
    [anon_sym_alignof] = ACTIONS(3162),
    [anon_sym__Alignof] = ACTIONS(3162),
    [anon_sym_offsetof] = ACTIONS(3162),
    [anon_sym__Generic] = ACTIONS(3162),
    [anon_sym_asm] = ACTIONS(3162),
    [anon_sym___asm__] = ACTIONS(3162),
    [anon_sym___asm] = ACTIONS(3162),
    [sym_number_literal] = ACTIONS(3164),
    [anon_sym_L_SQUOTE] = ACTIONS(3164),
    [anon_sym_u_SQUOTE] = ACTIONS(3164),
    [anon_sym_U_SQUOTE] = ACTIONS(3164),
    [anon_sym_u8_SQUOTE] = ACTIONS(3164),
    [anon_sym_SQUOTE] = ACTIONS(3164),
    [anon_sym_L_DQUOTE] = ACTIONS(3164),
    [anon_sym_u_DQUOTE] = ACTIONS(3164),
    [anon_sym_U_DQUOTE] = ACTIONS(3164),
    [anon_sym_u8_DQUOTE] = ACTIONS(3164),
    [anon_sym_DQUOTE] = ACTIONS(3164),
    [sym_true] = ACTIONS(3162),
    [sym_false] = ACTIONS(3162),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3162),
    [anon_sym_decltype] = ACTIONS(3162),
    [anon_sym_explicit] = ACTIONS(3162),
    [anon_sym_typename] = ACTIONS(3162),
    [anon_sym_template] = ACTIONS(3162),
    [anon_sym_operator] = ACTIONS(3162),
    [anon_sym_try] = ACTIONS(3162),
    [anon_sym_delete] = ACTIONS(3162),
    [anon_sym_throw] = ACTIONS(3162),
    [anon_sym_namespace] = ACTIONS(3162),
    [anon_sym_using] = ACTIONS(3162),
    [anon_sym_static_assert] = ACTIONS(3162),
    [anon_sym_concept] = ACTIONS(3162),
    [anon_sym_co_return] = ACTIONS(3162),
    [anon_sym_co_yield] = ACTIONS(3162),
    [anon_sym_R_DQUOTE] = ACTIONS(3164),
    [anon_sym_LR_DQUOTE] = ACTIONS(3164),
    [anon_sym_uR_DQUOTE] = ACTIONS(3164),
    [anon_sym_UR_DQUOTE] = ACTIONS(3164),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3164),
    [anon_sym_co_await] = ACTIONS(3162),
    [anon_sym_new] = ACTIONS(3162),
    [anon_sym_requires] = ACTIONS(3162),
    [sym_this] = ACTIONS(3162),
  },
  [565] = {
    [sym_identifier] = ACTIONS(2767),
    [aux_sym_preproc_include_token1] = ACTIONS(2767),
    [aux_sym_preproc_def_token1] = ACTIONS(2767),
    [aux_sym_preproc_if_token1] = ACTIONS(2767),
    [aux_sym_preproc_if_token2] = ACTIONS(2767),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2767),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2767),
    [sym_preproc_directive] = ACTIONS(2767),
    [anon_sym_LPAREN2] = ACTIONS(2769),
    [anon_sym_BANG] = ACTIONS(2769),
    [anon_sym_TILDE] = ACTIONS(2769),
    [anon_sym_DASH] = ACTIONS(2767),
    [anon_sym_PLUS] = ACTIONS(2767),
    [anon_sym_STAR] = ACTIONS(2769),
    [anon_sym_AMP_AMP] = ACTIONS(2769),
    [anon_sym_AMP] = ACTIONS(2767),
    [anon_sym_SEMI] = ACTIONS(2769),
    [anon_sym___extension__] = ACTIONS(2767),
    [anon_sym_typedef] = ACTIONS(2767),
    [anon_sym_virtual] = ACTIONS(2767),
    [anon_sym_extern] = ACTIONS(2767),
    [anon_sym___attribute__] = ACTIONS(2767),
    [anon_sym___attribute] = ACTIONS(2767),
    [anon_sym_COLON_COLON] = ACTIONS(2769),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2769),
    [anon_sym___declspec] = ACTIONS(2767),
    [anon_sym___based] = ACTIONS(2767),
    [anon_sym___cdecl] = ACTIONS(2767),
    [anon_sym___clrcall] = ACTIONS(2767),
    [anon_sym___stdcall] = ACTIONS(2767),
    [anon_sym___fastcall] = ACTIONS(2767),
    [anon_sym___thiscall] = ACTIONS(2767),
    [anon_sym___vectorcall] = ACTIONS(2767),
    [anon_sym_LBRACE] = ACTIONS(2769),
    [anon_sym_signed] = ACTIONS(2767),
    [anon_sym_unsigned] = ACTIONS(2767),
    [anon_sym_long] = ACTIONS(2767),
    [anon_sym_short] = ACTIONS(2767),
    [anon_sym_LBRACK] = ACTIONS(2767),
    [anon_sym_static] = ACTIONS(2767),
    [anon_sym_register] = ACTIONS(2767),
    [anon_sym_inline] = ACTIONS(2767),
    [anon_sym___inline] = ACTIONS(2767),
    [anon_sym___inline__] = ACTIONS(2767),
    [anon_sym___forceinline] = ACTIONS(2767),
    [anon_sym_thread_local] = ACTIONS(2767),
    [anon_sym___thread] = ACTIONS(2767),
    [anon_sym_const] = ACTIONS(2767),
    [anon_sym_constexpr] = ACTIONS(2767),
    [anon_sym_volatile] = ACTIONS(2767),
    [anon_sym_restrict] = ACTIONS(2767),
    [anon_sym___restrict__] = ACTIONS(2767),
    [anon_sym__Atomic] = ACTIONS(2767),
    [anon_sym__Noreturn] = ACTIONS(2767),
    [anon_sym_noreturn] = ACTIONS(2767),
    [anon_sym__Nonnull] = ACTIONS(2767),
    [anon_sym_mutable] = ACTIONS(2767),
    [anon_sym_constinit] = ACTIONS(2767),
    [anon_sym_consteval] = ACTIONS(2767),
    [anon_sym_alignas] = ACTIONS(2767),
    [anon_sym__Alignas] = ACTIONS(2767),
    [sym_primitive_type] = ACTIONS(2767),
    [anon_sym_enum] = ACTIONS(2767),
    [anon_sym_class] = ACTIONS(2767),
    [anon_sym_struct] = ACTIONS(2767),
    [anon_sym_union] = ACTIONS(2767),
    [anon_sym_if] = ACTIONS(2767),
    [anon_sym_switch] = ACTIONS(2767),
    [anon_sym_case] = ACTIONS(2767),
    [anon_sym_default] = ACTIONS(2767),
    [anon_sym_while] = ACTIONS(2767),
    [anon_sym_do] = ACTIONS(2767),
    [anon_sym_for] = ACTIONS(2767),
    [anon_sym_return] = ACTIONS(2767),
    [anon_sym_break] = ACTIONS(2767),
    [anon_sym_continue] = ACTIONS(2767),
    [anon_sym_goto] = ACTIONS(2767),
    [anon_sym___try] = ACTIONS(2767),
    [anon_sym___leave] = ACTIONS(2767),
    [anon_sym_not] = ACTIONS(2767),
    [anon_sym_compl] = ACTIONS(2767),
    [anon_sym_DASH_DASH] = ACTIONS(2769),
    [anon_sym_PLUS_PLUS] = ACTIONS(2769),
    [anon_sym_sizeof] = ACTIONS(2767),
    [anon_sym___alignof__] = ACTIONS(2767),
    [anon_sym___alignof] = ACTIONS(2767),
    [anon_sym__alignof] = ACTIONS(2767),
    [anon_sym_alignof] = ACTIONS(2767),
    [anon_sym__Alignof] = ACTIONS(2767),
    [anon_sym_offsetof] = ACTIONS(2767),
    [anon_sym__Generic] = ACTIONS(2767),
    [anon_sym_asm] = ACTIONS(2767),
    [anon_sym___asm__] = ACTIONS(2767),
    [anon_sym___asm] = ACTIONS(2767),
    [sym_number_literal] = ACTIONS(2769),
    [anon_sym_L_SQUOTE] = ACTIONS(2769),
    [anon_sym_u_SQUOTE] = ACTIONS(2769),
    [anon_sym_U_SQUOTE] = ACTIONS(2769),
    [anon_sym_u8_SQUOTE] = ACTIONS(2769),
    [anon_sym_SQUOTE] = ACTIONS(2769),
    [anon_sym_L_DQUOTE] = ACTIONS(2769),
    [anon_sym_u_DQUOTE] = ACTIONS(2769),
    [anon_sym_U_DQUOTE] = ACTIONS(2769),
    [anon_sym_u8_DQUOTE] = ACTIONS(2769),
    [anon_sym_DQUOTE] = ACTIONS(2769),
    [sym_true] = ACTIONS(2767),
    [sym_false] = ACTIONS(2767),
    [anon_sym_NULL] = ACTIONS(2767),
    [anon_sym_nullptr] = ACTIONS(2767),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2767),
    [anon_sym_decltype] = ACTIONS(2767),
    [anon_sym_explicit] = ACTIONS(2767),
    [anon_sym_typename] = ACTIONS(2767),
    [anon_sym_template] = ACTIONS(2767),
    [anon_sym_operator] = ACTIONS(2767),
    [anon_sym_try] = ACTIONS(2767),
    [anon_sym_delete] = ACTIONS(2767),
    [anon_sym_throw] = ACTIONS(2767),
    [anon_sym_namespace] = ACTIONS(2767),
    [anon_sym_using] = ACTIONS(2767),
    [anon_sym_static_assert] = ACTIONS(2767),
    [anon_sym_concept] = ACTIONS(2767),
    [anon_sym_co_return] = ACTIONS(2767),
    [anon_sym_co_yield] = ACTIONS(2767),
    [anon_sym_R_DQUOTE] = ACTIONS(2769),
    [anon_sym_LR_DQUOTE] = ACTIONS(2769),
    [anon_sym_uR_DQUOTE] = ACTIONS(2769),
    [anon_sym_UR_DQUOTE] = ACTIONS(2769),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2769),
    [anon_sym_co_await] = ACTIONS(2767),
    [anon_sym_new] = ACTIONS(2767),
    [anon_sym_requires] = ACTIONS(2767),
    [sym_this] = ACTIONS(2767),
  },
  [566] = {
    [sym_identifier] = ACTIONS(2968),
    [aux_sym_preproc_include_token1] = ACTIONS(2968),
    [aux_sym_preproc_def_token1] = ACTIONS(2968),
    [aux_sym_preproc_if_token1] = ACTIONS(2968),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2968),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2968),
    [sym_preproc_directive] = ACTIONS(2968),
    [anon_sym_LPAREN2] = ACTIONS(2970),
    [anon_sym_BANG] = ACTIONS(2970),
    [anon_sym_TILDE] = ACTIONS(2970),
    [anon_sym_DASH] = ACTIONS(2968),
    [anon_sym_PLUS] = ACTIONS(2968),
    [anon_sym_STAR] = ACTIONS(2970),
    [anon_sym_AMP_AMP] = ACTIONS(2970),
    [anon_sym_AMP] = ACTIONS(2968),
    [anon_sym_SEMI] = ACTIONS(2970),
    [anon_sym___extension__] = ACTIONS(2968),
    [anon_sym_typedef] = ACTIONS(2968),
    [anon_sym_virtual] = ACTIONS(2968),
    [anon_sym_extern] = ACTIONS(2968),
    [anon_sym___attribute__] = ACTIONS(2968),
    [anon_sym___attribute] = ACTIONS(2968),
    [anon_sym_COLON_COLON] = ACTIONS(2970),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2970),
    [anon_sym___declspec] = ACTIONS(2968),
    [anon_sym___based] = ACTIONS(2968),
    [anon_sym___cdecl] = ACTIONS(2968),
    [anon_sym___clrcall] = ACTIONS(2968),
    [anon_sym___stdcall] = ACTIONS(2968),
    [anon_sym___fastcall] = ACTIONS(2968),
    [anon_sym___thiscall] = ACTIONS(2968),
    [anon_sym___vectorcall] = ACTIONS(2968),
    [anon_sym_LBRACE] = ACTIONS(2970),
    [anon_sym_RBRACE] = ACTIONS(2970),
    [anon_sym_signed] = ACTIONS(2968),
    [anon_sym_unsigned] = ACTIONS(2968),
    [anon_sym_long] = ACTIONS(2968),
    [anon_sym_short] = ACTIONS(2968),
    [anon_sym_LBRACK] = ACTIONS(2968),
    [anon_sym_static] = ACTIONS(2968),
    [anon_sym_register] = ACTIONS(2968),
    [anon_sym_inline] = ACTIONS(2968),
    [anon_sym___inline] = ACTIONS(2968),
    [anon_sym___inline__] = ACTIONS(2968),
    [anon_sym___forceinline] = ACTIONS(2968),
    [anon_sym_thread_local] = ACTIONS(2968),
    [anon_sym___thread] = ACTIONS(2968),
    [anon_sym_const] = ACTIONS(2968),
    [anon_sym_constexpr] = ACTIONS(2968),
    [anon_sym_volatile] = ACTIONS(2968),
    [anon_sym_restrict] = ACTIONS(2968),
    [anon_sym___restrict__] = ACTIONS(2968),
    [anon_sym__Atomic] = ACTIONS(2968),
    [anon_sym__Noreturn] = ACTIONS(2968),
    [anon_sym_noreturn] = ACTIONS(2968),
    [anon_sym__Nonnull] = ACTIONS(2968),
    [anon_sym_mutable] = ACTIONS(2968),
    [anon_sym_constinit] = ACTIONS(2968),
    [anon_sym_consteval] = ACTIONS(2968),
    [anon_sym_alignas] = ACTIONS(2968),
    [anon_sym__Alignas] = ACTIONS(2968),
    [sym_primitive_type] = ACTIONS(2968),
    [anon_sym_enum] = ACTIONS(2968),
    [anon_sym_class] = ACTIONS(2968),
    [anon_sym_struct] = ACTIONS(2968),
    [anon_sym_union] = ACTIONS(2968),
    [anon_sym_if] = ACTIONS(2968),
    [anon_sym_switch] = ACTIONS(2968),
    [anon_sym_case] = ACTIONS(2968),
    [anon_sym_default] = ACTIONS(2968),
    [anon_sym_while] = ACTIONS(2968),
    [anon_sym_do] = ACTIONS(2968),
    [anon_sym_for] = ACTIONS(2968),
    [anon_sym_return] = ACTIONS(2968),
    [anon_sym_break] = ACTIONS(2968),
    [anon_sym_continue] = ACTIONS(2968),
    [anon_sym_goto] = ACTIONS(2968),
    [anon_sym___try] = ACTIONS(2968),
    [anon_sym___leave] = ACTIONS(2968),
    [anon_sym_not] = ACTIONS(2968),
    [anon_sym_compl] = ACTIONS(2968),
    [anon_sym_DASH_DASH] = ACTIONS(2970),
    [anon_sym_PLUS_PLUS] = ACTIONS(2970),
    [anon_sym_sizeof] = ACTIONS(2968),
    [anon_sym___alignof__] = ACTIONS(2968),
    [anon_sym___alignof] = ACTIONS(2968),
    [anon_sym__alignof] = ACTIONS(2968),
    [anon_sym_alignof] = ACTIONS(2968),
    [anon_sym__Alignof] = ACTIONS(2968),
    [anon_sym_offsetof] = ACTIONS(2968),
    [anon_sym__Generic] = ACTIONS(2968),
    [anon_sym_asm] = ACTIONS(2968),
    [anon_sym___asm__] = ACTIONS(2968),
    [anon_sym___asm] = ACTIONS(2968),
    [sym_number_literal] = ACTIONS(2970),
    [anon_sym_L_SQUOTE] = ACTIONS(2970),
    [anon_sym_u_SQUOTE] = ACTIONS(2970),
    [anon_sym_U_SQUOTE] = ACTIONS(2970),
    [anon_sym_u8_SQUOTE] = ACTIONS(2970),
    [anon_sym_SQUOTE] = ACTIONS(2970),
    [anon_sym_L_DQUOTE] = ACTIONS(2970),
    [anon_sym_u_DQUOTE] = ACTIONS(2970),
    [anon_sym_U_DQUOTE] = ACTIONS(2970),
    [anon_sym_u8_DQUOTE] = ACTIONS(2970),
    [anon_sym_DQUOTE] = ACTIONS(2970),
    [sym_true] = ACTIONS(2968),
    [sym_false] = ACTIONS(2968),
    [anon_sym_NULL] = ACTIONS(2968),
    [anon_sym_nullptr] = ACTIONS(2968),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2968),
    [anon_sym_decltype] = ACTIONS(2968),
    [anon_sym_explicit] = ACTIONS(2968),
    [anon_sym_typename] = ACTIONS(2968),
    [anon_sym_template] = ACTIONS(2968),
    [anon_sym_operator] = ACTIONS(2968),
    [anon_sym_try] = ACTIONS(2968),
    [anon_sym_delete] = ACTIONS(2968),
    [anon_sym_throw] = ACTIONS(2968),
    [anon_sym_namespace] = ACTIONS(2968),
    [anon_sym_using] = ACTIONS(2968),
    [anon_sym_static_assert] = ACTIONS(2968),
    [anon_sym_concept] = ACTIONS(2968),
    [anon_sym_co_return] = ACTIONS(2968),
    [anon_sym_co_yield] = ACTIONS(2968),
    [anon_sym_R_DQUOTE] = ACTIONS(2970),
    [anon_sym_LR_DQUOTE] = ACTIONS(2970),
    [anon_sym_uR_DQUOTE] = ACTIONS(2970),
    [anon_sym_UR_DQUOTE] = ACTIONS(2970),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2970),
    [anon_sym_co_await] = ACTIONS(2968),
    [anon_sym_new] = ACTIONS(2968),
    [anon_sym_requires] = ACTIONS(2968),
    [sym_this] = ACTIONS(2968),
  },
  [567] = {
    [sym_identifier] = ACTIONS(3094),
    [aux_sym_preproc_include_token1] = ACTIONS(3094),
    [aux_sym_preproc_def_token1] = ACTIONS(3094),
    [aux_sym_preproc_if_token1] = ACTIONS(3094),
    [aux_sym_preproc_if_token2] = ACTIONS(3094),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3094),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3094),
    [sym_preproc_directive] = ACTIONS(3094),
    [anon_sym_LPAREN2] = ACTIONS(3096),
    [anon_sym_BANG] = ACTIONS(3096),
    [anon_sym_TILDE] = ACTIONS(3096),
    [anon_sym_DASH] = ACTIONS(3094),
    [anon_sym_PLUS] = ACTIONS(3094),
    [anon_sym_STAR] = ACTIONS(3096),
    [anon_sym_AMP_AMP] = ACTIONS(3096),
    [anon_sym_AMP] = ACTIONS(3094),
    [anon_sym_SEMI] = ACTIONS(3096),
    [anon_sym___extension__] = ACTIONS(3094),
    [anon_sym_typedef] = ACTIONS(3094),
    [anon_sym_virtual] = ACTIONS(3094),
    [anon_sym_extern] = ACTIONS(3094),
    [anon_sym___attribute__] = ACTIONS(3094),
    [anon_sym___attribute] = ACTIONS(3094),
    [anon_sym_COLON_COLON] = ACTIONS(3096),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3096),
    [anon_sym___declspec] = ACTIONS(3094),
    [anon_sym___based] = ACTIONS(3094),
    [anon_sym___cdecl] = ACTIONS(3094),
    [anon_sym___clrcall] = ACTIONS(3094),
    [anon_sym___stdcall] = ACTIONS(3094),
    [anon_sym___fastcall] = ACTIONS(3094),
    [anon_sym___thiscall] = ACTIONS(3094),
    [anon_sym___vectorcall] = ACTIONS(3094),
    [anon_sym_LBRACE] = ACTIONS(3096),
    [anon_sym_signed] = ACTIONS(3094),
    [anon_sym_unsigned] = ACTIONS(3094),
    [anon_sym_long] = ACTIONS(3094),
    [anon_sym_short] = ACTIONS(3094),
    [anon_sym_LBRACK] = ACTIONS(3094),
    [anon_sym_static] = ACTIONS(3094),
    [anon_sym_register] = ACTIONS(3094),
    [anon_sym_inline] = ACTIONS(3094),
    [anon_sym___inline] = ACTIONS(3094),
    [anon_sym___inline__] = ACTIONS(3094),
    [anon_sym___forceinline] = ACTIONS(3094),
    [anon_sym_thread_local] = ACTIONS(3094),
    [anon_sym___thread] = ACTIONS(3094),
    [anon_sym_const] = ACTIONS(3094),
    [anon_sym_constexpr] = ACTIONS(3094),
    [anon_sym_volatile] = ACTIONS(3094),
    [anon_sym_restrict] = ACTIONS(3094),
    [anon_sym___restrict__] = ACTIONS(3094),
    [anon_sym__Atomic] = ACTIONS(3094),
    [anon_sym__Noreturn] = ACTIONS(3094),
    [anon_sym_noreturn] = ACTIONS(3094),
    [anon_sym__Nonnull] = ACTIONS(3094),
    [anon_sym_mutable] = ACTIONS(3094),
    [anon_sym_constinit] = ACTIONS(3094),
    [anon_sym_consteval] = ACTIONS(3094),
    [anon_sym_alignas] = ACTIONS(3094),
    [anon_sym__Alignas] = ACTIONS(3094),
    [sym_primitive_type] = ACTIONS(3094),
    [anon_sym_enum] = ACTIONS(3094),
    [anon_sym_class] = ACTIONS(3094),
    [anon_sym_struct] = ACTIONS(3094),
    [anon_sym_union] = ACTIONS(3094),
    [anon_sym_if] = ACTIONS(3094),
    [anon_sym_switch] = ACTIONS(3094),
    [anon_sym_case] = ACTIONS(3094),
    [anon_sym_default] = ACTIONS(3094),
    [anon_sym_while] = ACTIONS(3094),
    [anon_sym_do] = ACTIONS(3094),
    [anon_sym_for] = ACTIONS(3094),
    [anon_sym_return] = ACTIONS(3094),
    [anon_sym_break] = ACTIONS(3094),
    [anon_sym_continue] = ACTIONS(3094),
    [anon_sym_goto] = ACTIONS(3094),
    [anon_sym___try] = ACTIONS(3094),
    [anon_sym___leave] = ACTIONS(3094),
    [anon_sym_not] = ACTIONS(3094),
    [anon_sym_compl] = ACTIONS(3094),
    [anon_sym_DASH_DASH] = ACTIONS(3096),
    [anon_sym_PLUS_PLUS] = ACTIONS(3096),
    [anon_sym_sizeof] = ACTIONS(3094),
    [anon_sym___alignof__] = ACTIONS(3094),
    [anon_sym___alignof] = ACTIONS(3094),
    [anon_sym__alignof] = ACTIONS(3094),
    [anon_sym_alignof] = ACTIONS(3094),
    [anon_sym__Alignof] = ACTIONS(3094),
    [anon_sym_offsetof] = ACTIONS(3094),
    [anon_sym__Generic] = ACTIONS(3094),
    [anon_sym_asm] = ACTIONS(3094),
    [anon_sym___asm__] = ACTIONS(3094),
    [anon_sym___asm] = ACTIONS(3094),
    [sym_number_literal] = ACTIONS(3096),
    [anon_sym_L_SQUOTE] = ACTIONS(3096),
    [anon_sym_u_SQUOTE] = ACTIONS(3096),
    [anon_sym_U_SQUOTE] = ACTIONS(3096),
    [anon_sym_u8_SQUOTE] = ACTIONS(3096),
    [anon_sym_SQUOTE] = ACTIONS(3096),
    [anon_sym_L_DQUOTE] = ACTIONS(3096),
    [anon_sym_u_DQUOTE] = ACTIONS(3096),
    [anon_sym_U_DQUOTE] = ACTIONS(3096),
    [anon_sym_u8_DQUOTE] = ACTIONS(3096),
    [anon_sym_DQUOTE] = ACTIONS(3096),
    [sym_true] = ACTIONS(3094),
    [sym_false] = ACTIONS(3094),
    [anon_sym_NULL] = ACTIONS(3094),
    [anon_sym_nullptr] = ACTIONS(3094),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3094),
    [anon_sym_decltype] = ACTIONS(3094),
    [anon_sym_explicit] = ACTIONS(3094),
    [anon_sym_typename] = ACTIONS(3094),
    [anon_sym_template] = ACTIONS(3094),
    [anon_sym_operator] = ACTIONS(3094),
    [anon_sym_try] = ACTIONS(3094),
    [anon_sym_delete] = ACTIONS(3094),
    [anon_sym_throw] = ACTIONS(3094),
    [anon_sym_namespace] = ACTIONS(3094),
    [anon_sym_using] = ACTIONS(3094),
    [anon_sym_static_assert] = ACTIONS(3094),
    [anon_sym_concept] = ACTIONS(3094),
    [anon_sym_co_return] = ACTIONS(3094),
    [anon_sym_co_yield] = ACTIONS(3094),
    [anon_sym_R_DQUOTE] = ACTIONS(3096),
    [anon_sym_LR_DQUOTE] = ACTIONS(3096),
    [anon_sym_uR_DQUOTE] = ACTIONS(3096),
    [anon_sym_UR_DQUOTE] = ACTIONS(3096),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3096),
    [anon_sym_co_await] = ACTIONS(3094),
    [anon_sym_new] = ACTIONS(3094),
    [anon_sym_requires] = ACTIONS(3094),
    [sym_this] = ACTIONS(3094),
  },
  [568] = {
    [sym_identifier] = ACTIONS(3098),
    [aux_sym_preproc_include_token1] = ACTIONS(3098),
    [aux_sym_preproc_def_token1] = ACTIONS(3098),
    [aux_sym_preproc_if_token1] = ACTIONS(3098),
    [aux_sym_preproc_if_token2] = ACTIONS(3098),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3098),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3098),
    [sym_preproc_directive] = ACTIONS(3098),
    [anon_sym_LPAREN2] = ACTIONS(3100),
    [anon_sym_BANG] = ACTIONS(3100),
    [anon_sym_TILDE] = ACTIONS(3100),
    [anon_sym_DASH] = ACTIONS(3098),
    [anon_sym_PLUS] = ACTIONS(3098),
    [anon_sym_STAR] = ACTIONS(3100),
    [anon_sym_AMP_AMP] = ACTIONS(3100),
    [anon_sym_AMP] = ACTIONS(3098),
    [anon_sym_SEMI] = ACTIONS(3100),
    [anon_sym___extension__] = ACTIONS(3098),
    [anon_sym_typedef] = ACTIONS(3098),
    [anon_sym_virtual] = ACTIONS(3098),
    [anon_sym_extern] = ACTIONS(3098),
    [anon_sym___attribute__] = ACTIONS(3098),
    [anon_sym___attribute] = ACTIONS(3098),
    [anon_sym_COLON_COLON] = ACTIONS(3100),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3100),
    [anon_sym___declspec] = ACTIONS(3098),
    [anon_sym___based] = ACTIONS(3098),
    [anon_sym___cdecl] = ACTIONS(3098),
    [anon_sym___clrcall] = ACTIONS(3098),
    [anon_sym___stdcall] = ACTIONS(3098),
    [anon_sym___fastcall] = ACTIONS(3098),
    [anon_sym___thiscall] = ACTIONS(3098),
    [anon_sym___vectorcall] = ACTIONS(3098),
    [anon_sym_LBRACE] = ACTIONS(3100),
    [anon_sym_signed] = ACTIONS(3098),
    [anon_sym_unsigned] = ACTIONS(3098),
    [anon_sym_long] = ACTIONS(3098),
    [anon_sym_short] = ACTIONS(3098),
    [anon_sym_LBRACK] = ACTIONS(3098),
    [anon_sym_static] = ACTIONS(3098),
    [anon_sym_register] = ACTIONS(3098),
    [anon_sym_inline] = ACTIONS(3098),
    [anon_sym___inline] = ACTIONS(3098),
    [anon_sym___inline__] = ACTIONS(3098),
    [anon_sym___forceinline] = ACTIONS(3098),
    [anon_sym_thread_local] = ACTIONS(3098),
    [anon_sym___thread] = ACTIONS(3098),
    [anon_sym_const] = ACTIONS(3098),
    [anon_sym_constexpr] = ACTIONS(3098),
    [anon_sym_volatile] = ACTIONS(3098),
    [anon_sym_restrict] = ACTIONS(3098),
    [anon_sym___restrict__] = ACTIONS(3098),
    [anon_sym__Atomic] = ACTIONS(3098),
    [anon_sym__Noreturn] = ACTIONS(3098),
    [anon_sym_noreturn] = ACTIONS(3098),
    [anon_sym__Nonnull] = ACTIONS(3098),
    [anon_sym_mutable] = ACTIONS(3098),
    [anon_sym_constinit] = ACTIONS(3098),
    [anon_sym_consteval] = ACTIONS(3098),
    [anon_sym_alignas] = ACTIONS(3098),
    [anon_sym__Alignas] = ACTIONS(3098),
    [sym_primitive_type] = ACTIONS(3098),
    [anon_sym_enum] = ACTIONS(3098),
    [anon_sym_class] = ACTIONS(3098),
    [anon_sym_struct] = ACTIONS(3098),
    [anon_sym_union] = ACTIONS(3098),
    [anon_sym_if] = ACTIONS(3098),
    [anon_sym_switch] = ACTIONS(3098),
    [anon_sym_case] = ACTIONS(3098),
    [anon_sym_default] = ACTIONS(3098),
    [anon_sym_while] = ACTIONS(3098),
    [anon_sym_do] = ACTIONS(3098),
    [anon_sym_for] = ACTIONS(3098),
    [anon_sym_return] = ACTIONS(3098),
    [anon_sym_break] = ACTIONS(3098),
    [anon_sym_continue] = ACTIONS(3098),
    [anon_sym_goto] = ACTIONS(3098),
    [anon_sym___try] = ACTIONS(3098),
    [anon_sym___leave] = ACTIONS(3098),
    [anon_sym_not] = ACTIONS(3098),
    [anon_sym_compl] = ACTIONS(3098),
    [anon_sym_DASH_DASH] = ACTIONS(3100),
    [anon_sym_PLUS_PLUS] = ACTIONS(3100),
    [anon_sym_sizeof] = ACTIONS(3098),
    [anon_sym___alignof__] = ACTIONS(3098),
    [anon_sym___alignof] = ACTIONS(3098),
    [anon_sym__alignof] = ACTIONS(3098),
    [anon_sym_alignof] = ACTIONS(3098),
    [anon_sym__Alignof] = ACTIONS(3098),
    [anon_sym_offsetof] = ACTIONS(3098),
    [anon_sym__Generic] = ACTIONS(3098),
    [anon_sym_asm] = ACTIONS(3098),
    [anon_sym___asm__] = ACTIONS(3098),
    [anon_sym___asm] = ACTIONS(3098),
    [sym_number_literal] = ACTIONS(3100),
    [anon_sym_L_SQUOTE] = ACTIONS(3100),
    [anon_sym_u_SQUOTE] = ACTIONS(3100),
    [anon_sym_U_SQUOTE] = ACTIONS(3100),
    [anon_sym_u8_SQUOTE] = ACTIONS(3100),
    [anon_sym_SQUOTE] = ACTIONS(3100),
    [anon_sym_L_DQUOTE] = ACTIONS(3100),
    [anon_sym_u_DQUOTE] = ACTIONS(3100),
    [anon_sym_U_DQUOTE] = ACTIONS(3100),
    [anon_sym_u8_DQUOTE] = ACTIONS(3100),
    [anon_sym_DQUOTE] = ACTIONS(3100),
    [sym_true] = ACTIONS(3098),
    [sym_false] = ACTIONS(3098),
    [anon_sym_NULL] = ACTIONS(3098),
    [anon_sym_nullptr] = ACTIONS(3098),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3098),
    [anon_sym_decltype] = ACTIONS(3098),
    [anon_sym_explicit] = ACTIONS(3098),
    [anon_sym_typename] = ACTIONS(3098),
    [anon_sym_template] = ACTIONS(3098),
    [anon_sym_operator] = ACTIONS(3098),
    [anon_sym_try] = ACTIONS(3098),
    [anon_sym_delete] = ACTIONS(3098),
    [anon_sym_throw] = ACTIONS(3098),
    [anon_sym_namespace] = ACTIONS(3098),
    [anon_sym_using] = ACTIONS(3098),
    [anon_sym_static_assert] = ACTIONS(3098),
    [anon_sym_concept] = ACTIONS(3098),
    [anon_sym_co_return] = ACTIONS(3098),
    [anon_sym_co_yield] = ACTIONS(3098),
    [anon_sym_R_DQUOTE] = ACTIONS(3100),
    [anon_sym_LR_DQUOTE] = ACTIONS(3100),
    [anon_sym_uR_DQUOTE] = ACTIONS(3100),
    [anon_sym_UR_DQUOTE] = ACTIONS(3100),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3100),
    [anon_sym_co_await] = ACTIONS(3098),
    [anon_sym_new] = ACTIONS(3098),
    [anon_sym_requires] = ACTIONS(3098),
    [sym_this] = ACTIONS(3098),
  },
  [569] = {
    [sym_identifier] = ACTIONS(3166),
    [aux_sym_preproc_include_token1] = ACTIONS(3166),
    [aux_sym_preproc_def_token1] = ACTIONS(3166),
    [aux_sym_preproc_if_token1] = ACTIONS(3166),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3166),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3166),
    [sym_preproc_directive] = ACTIONS(3166),
    [anon_sym_LPAREN2] = ACTIONS(3168),
    [anon_sym_BANG] = ACTIONS(3168),
    [anon_sym_TILDE] = ACTIONS(3168),
    [anon_sym_DASH] = ACTIONS(3166),
    [anon_sym_PLUS] = ACTIONS(3166),
    [anon_sym_STAR] = ACTIONS(3168),
    [anon_sym_AMP_AMP] = ACTIONS(3168),
    [anon_sym_AMP] = ACTIONS(3166),
    [anon_sym_SEMI] = ACTIONS(3168),
    [anon_sym___extension__] = ACTIONS(3166),
    [anon_sym_typedef] = ACTIONS(3166),
    [anon_sym_virtual] = ACTIONS(3166),
    [anon_sym_extern] = ACTIONS(3166),
    [anon_sym___attribute__] = ACTIONS(3166),
    [anon_sym___attribute] = ACTIONS(3166),
    [anon_sym_COLON_COLON] = ACTIONS(3168),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3168),
    [anon_sym___declspec] = ACTIONS(3166),
    [anon_sym___based] = ACTIONS(3166),
    [anon_sym___cdecl] = ACTIONS(3166),
    [anon_sym___clrcall] = ACTIONS(3166),
    [anon_sym___stdcall] = ACTIONS(3166),
    [anon_sym___fastcall] = ACTIONS(3166),
    [anon_sym___thiscall] = ACTIONS(3166),
    [anon_sym___vectorcall] = ACTIONS(3166),
    [anon_sym_LBRACE] = ACTIONS(3168),
    [anon_sym_RBRACE] = ACTIONS(3168),
    [anon_sym_signed] = ACTIONS(3166),
    [anon_sym_unsigned] = ACTIONS(3166),
    [anon_sym_long] = ACTIONS(3166),
    [anon_sym_short] = ACTIONS(3166),
    [anon_sym_LBRACK] = ACTIONS(3166),
    [anon_sym_static] = ACTIONS(3166),
    [anon_sym_register] = ACTIONS(3166),
    [anon_sym_inline] = ACTIONS(3166),
    [anon_sym___inline] = ACTIONS(3166),
    [anon_sym___inline__] = ACTIONS(3166),
    [anon_sym___forceinline] = ACTIONS(3166),
    [anon_sym_thread_local] = ACTIONS(3166),
    [anon_sym___thread] = ACTIONS(3166),
    [anon_sym_const] = ACTIONS(3166),
    [anon_sym_constexpr] = ACTIONS(3166),
    [anon_sym_volatile] = ACTIONS(3166),
    [anon_sym_restrict] = ACTIONS(3166),
    [anon_sym___restrict__] = ACTIONS(3166),
    [anon_sym__Atomic] = ACTIONS(3166),
    [anon_sym__Noreturn] = ACTIONS(3166),
    [anon_sym_noreturn] = ACTIONS(3166),
    [anon_sym__Nonnull] = ACTIONS(3166),
    [anon_sym_mutable] = ACTIONS(3166),
    [anon_sym_constinit] = ACTIONS(3166),
    [anon_sym_consteval] = ACTIONS(3166),
    [anon_sym_alignas] = ACTIONS(3166),
    [anon_sym__Alignas] = ACTIONS(3166),
    [sym_primitive_type] = ACTIONS(3166),
    [anon_sym_enum] = ACTIONS(3166),
    [anon_sym_class] = ACTIONS(3166),
    [anon_sym_struct] = ACTIONS(3166),
    [anon_sym_union] = ACTIONS(3166),
    [anon_sym_if] = ACTIONS(3166),
    [anon_sym_switch] = ACTIONS(3166),
    [anon_sym_case] = ACTIONS(3166),
    [anon_sym_default] = ACTIONS(3166),
    [anon_sym_while] = ACTIONS(3166),
    [anon_sym_do] = ACTIONS(3166),
    [anon_sym_for] = ACTIONS(3166),
    [anon_sym_return] = ACTIONS(3166),
    [anon_sym_break] = ACTIONS(3166),
    [anon_sym_continue] = ACTIONS(3166),
    [anon_sym_goto] = ACTIONS(3166),
    [anon_sym___try] = ACTIONS(3166),
    [anon_sym___leave] = ACTIONS(3166),
    [anon_sym_not] = ACTIONS(3166),
    [anon_sym_compl] = ACTIONS(3166),
    [anon_sym_DASH_DASH] = ACTIONS(3168),
    [anon_sym_PLUS_PLUS] = ACTIONS(3168),
    [anon_sym_sizeof] = ACTIONS(3166),
    [anon_sym___alignof__] = ACTIONS(3166),
    [anon_sym___alignof] = ACTIONS(3166),
    [anon_sym__alignof] = ACTIONS(3166),
    [anon_sym_alignof] = ACTIONS(3166),
    [anon_sym__Alignof] = ACTIONS(3166),
    [anon_sym_offsetof] = ACTIONS(3166),
    [anon_sym__Generic] = ACTIONS(3166),
    [anon_sym_asm] = ACTIONS(3166),
    [anon_sym___asm__] = ACTIONS(3166),
    [anon_sym___asm] = ACTIONS(3166),
    [sym_number_literal] = ACTIONS(3168),
    [anon_sym_L_SQUOTE] = ACTIONS(3168),
    [anon_sym_u_SQUOTE] = ACTIONS(3168),
    [anon_sym_U_SQUOTE] = ACTIONS(3168),
    [anon_sym_u8_SQUOTE] = ACTIONS(3168),
    [anon_sym_SQUOTE] = ACTIONS(3168),
    [anon_sym_L_DQUOTE] = ACTIONS(3168),
    [anon_sym_u_DQUOTE] = ACTIONS(3168),
    [anon_sym_U_DQUOTE] = ACTIONS(3168),
    [anon_sym_u8_DQUOTE] = ACTIONS(3168),
    [anon_sym_DQUOTE] = ACTIONS(3168),
    [sym_true] = ACTIONS(3166),
    [sym_false] = ACTIONS(3166),
    [anon_sym_NULL] = ACTIONS(3166),
    [anon_sym_nullptr] = ACTIONS(3166),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3166),
    [anon_sym_decltype] = ACTIONS(3166),
    [anon_sym_explicit] = ACTIONS(3166),
    [anon_sym_typename] = ACTIONS(3166),
    [anon_sym_template] = ACTIONS(3166),
    [anon_sym_operator] = ACTIONS(3166),
    [anon_sym_try] = ACTIONS(3166),
    [anon_sym_delete] = ACTIONS(3166),
    [anon_sym_throw] = ACTIONS(3166),
    [anon_sym_namespace] = ACTIONS(3166),
    [anon_sym_using] = ACTIONS(3166),
    [anon_sym_static_assert] = ACTIONS(3166),
    [anon_sym_concept] = ACTIONS(3166),
    [anon_sym_co_return] = ACTIONS(3166),
    [anon_sym_co_yield] = ACTIONS(3166),
    [anon_sym_R_DQUOTE] = ACTIONS(3168),
    [anon_sym_LR_DQUOTE] = ACTIONS(3168),
    [anon_sym_uR_DQUOTE] = ACTIONS(3168),
    [anon_sym_UR_DQUOTE] = ACTIONS(3168),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3168),
    [anon_sym_co_await] = ACTIONS(3166),
    [anon_sym_new] = ACTIONS(3166),
    [anon_sym_requires] = ACTIONS(3166),
    [sym_this] = ACTIONS(3166),
  },
  [570] = {
    [sym_identifier] = ACTIONS(3146),
    [aux_sym_preproc_include_token1] = ACTIONS(3146),
    [aux_sym_preproc_def_token1] = ACTIONS(3146),
    [aux_sym_preproc_if_token1] = ACTIONS(3146),
    [aux_sym_preproc_if_token2] = ACTIONS(3146),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3146),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3146),
    [sym_preproc_directive] = ACTIONS(3146),
    [anon_sym_LPAREN2] = ACTIONS(3148),
    [anon_sym_BANG] = ACTIONS(3148),
    [anon_sym_TILDE] = ACTIONS(3148),
    [anon_sym_DASH] = ACTIONS(3146),
    [anon_sym_PLUS] = ACTIONS(3146),
    [anon_sym_STAR] = ACTIONS(3148),
    [anon_sym_AMP_AMP] = ACTIONS(3148),
    [anon_sym_AMP] = ACTIONS(3146),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym___extension__] = ACTIONS(3146),
    [anon_sym_typedef] = ACTIONS(3146),
    [anon_sym_virtual] = ACTIONS(3146),
    [anon_sym_extern] = ACTIONS(3146),
    [anon_sym___attribute__] = ACTIONS(3146),
    [anon_sym___attribute] = ACTIONS(3146),
    [anon_sym_COLON_COLON] = ACTIONS(3148),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3148),
    [anon_sym___declspec] = ACTIONS(3146),
    [anon_sym___based] = ACTIONS(3146),
    [anon_sym___cdecl] = ACTIONS(3146),
    [anon_sym___clrcall] = ACTIONS(3146),
    [anon_sym___stdcall] = ACTIONS(3146),
    [anon_sym___fastcall] = ACTIONS(3146),
    [anon_sym___thiscall] = ACTIONS(3146),
    [anon_sym___vectorcall] = ACTIONS(3146),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_signed] = ACTIONS(3146),
    [anon_sym_unsigned] = ACTIONS(3146),
    [anon_sym_long] = ACTIONS(3146),
    [anon_sym_short] = ACTIONS(3146),
    [anon_sym_LBRACK] = ACTIONS(3146),
    [anon_sym_static] = ACTIONS(3146),
    [anon_sym_register] = ACTIONS(3146),
    [anon_sym_inline] = ACTIONS(3146),
    [anon_sym___inline] = ACTIONS(3146),
    [anon_sym___inline__] = ACTIONS(3146),
    [anon_sym___forceinline] = ACTIONS(3146),
    [anon_sym_thread_local] = ACTIONS(3146),
    [anon_sym___thread] = ACTIONS(3146),
    [anon_sym_const] = ACTIONS(3146),
    [anon_sym_constexpr] = ACTIONS(3146),
    [anon_sym_volatile] = ACTIONS(3146),
    [anon_sym_restrict] = ACTIONS(3146),
    [anon_sym___restrict__] = ACTIONS(3146),
    [anon_sym__Atomic] = ACTIONS(3146),
    [anon_sym__Noreturn] = ACTIONS(3146),
    [anon_sym_noreturn] = ACTIONS(3146),
    [anon_sym__Nonnull] = ACTIONS(3146),
    [anon_sym_mutable] = ACTIONS(3146),
    [anon_sym_constinit] = ACTIONS(3146),
    [anon_sym_consteval] = ACTIONS(3146),
    [anon_sym_alignas] = ACTIONS(3146),
    [anon_sym__Alignas] = ACTIONS(3146),
    [sym_primitive_type] = ACTIONS(3146),
    [anon_sym_enum] = ACTIONS(3146),
    [anon_sym_class] = ACTIONS(3146),
    [anon_sym_struct] = ACTIONS(3146),
    [anon_sym_union] = ACTIONS(3146),
    [anon_sym_if] = ACTIONS(3146),
    [anon_sym_switch] = ACTIONS(3146),
    [anon_sym_case] = ACTIONS(3146),
    [anon_sym_default] = ACTIONS(3146),
    [anon_sym_while] = ACTIONS(3146),
    [anon_sym_do] = ACTIONS(3146),
    [anon_sym_for] = ACTIONS(3146),
    [anon_sym_return] = ACTIONS(3146),
    [anon_sym_break] = ACTIONS(3146),
    [anon_sym_continue] = ACTIONS(3146),
    [anon_sym_goto] = ACTIONS(3146),
    [anon_sym___try] = ACTIONS(3146),
    [anon_sym___leave] = ACTIONS(3146),
    [anon_sym_not] = ACTIONS(3146),
    [anon_sym_compl] = ACTIONS(3146),
    [anon_sym_DASH_DASH] = ACTIONS(3148),
    [anon_sym_PLUS_PLUS] = ACTIONS(3148),
    [anon_sym_sizeof] = ACTIONS(3146),
    [anon_sym___alignof__] = ACTIONS(3146),
    [anon_sym___alignof] = ACTIONS(3146),
    [anon_sym__alignof] = ACTIONS(3146),
    [anon_sym_alignof] = ACTIONS(3146),
    [anon_sym__Alignof] = ACTIONS(3146),
    [anon_sym_offsetof] = ACTIONS(3146),
    [anon_sym__Generic] = ACTIONS(3146),
    [anon_sym_asm] = ACTIONS(3146),
    [anon_sym___asm__] = ACTIONS(3146),
    [anon_sym___asm] = ACTIONS(3146),
    [sym_number_literal] = ACTIONS(3148),
    [anon_sym_L_SQUOTE] = ACTIONS(3148),
    [anon_sym_u_SQUOTE] = ACTIONS(3148),
    [anon_sym_U_SQUOTE] = ACTIONS(3148),
    [anon_sym_u8_SQUOTE] = ACTIONS(3148),
    [anon_sym_SQUOTE] = ACTIONS(3148),
    [anon_sym_L_DQUOTE] = ACTIONS(3148),
    [anon_sym_u_DQUOTE] = ACTIONS(3148),
    [anon_sym_U_DQUOTE] = ACTIONS(3148),
    [anon_sym_u8_DQUOTE] = ACTIONS(3148),
    [anon_sym_DQUOTE] = ACTIONS(3148),
    [sym_true] = ACTIONS(3146),
    [sym_false] = ACTIONS(3146),
    [anon_sym_NULL] = ACTIONS(3146),
    [anon_sym_nullptr] = ACTIONS(3146),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3146),
    [anon_sym_decltype] = ACTIONS(3146),
    [anon_sym_explicit] = ACTIONS(3146),
    [anon_sym_typename] = ACTIONS(3146),
    [anon_sym_template] = ACTIONS(3146),
    [anon_sym_operator] = ACTIONS(3146),
    [anon_sym_try] = ACTIONS(3146),
    [anon_sym_delete] = ACTIONS(3146),
    [anon_sym_throw] = ACTIONS(3146),
    [anon_sym_namespace] = ACTIONS(3146),
    [anon_sym_using] = ACTIONS(3146),
    [anon_sym_static_assert] = ACTIONS(3146),
    [anon_sym_concept] = ACTIONS(3146),
    [anon_sym_co_return] = ACTIONS(3146),
    [anon_sym_co_yield] = ACTIONS(3146),
    [anon_sym_R_DQUOTE] = ACTIONS(3148),
    [anon_sym_LR_DQUOTE] = ACTIONS(3148),
    [anon_sym_uR_DQUOTE] = ACTIONS(3148),
    [anon_sym_UR_DQUOTE] = ACTIONS(3148),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3148),
    [anon_sym_co_await] = ACTIONS(3146),
    [anon_sym_new] = ACTIONS(3146),
    [anon_sym_requires] = ACTIONS(3146),
    [sym_this] = ACTIONS(3146),
  },
  [571] = {
    [sym_identifier] = ACTIONS(2805),
    [aux_sym_preproc_include_token1] = ACTIONS(2805),
    [aux_sym_preproc_def_token1] = ACTIONS(2805),
    [aux_sym_preproc_if_token1] = ACTIONS(2805),
    [aux_sym_preproc_if_token2] = ACTIONS(2805),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2805),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2805),
    [sym_preproc_directive] = ACTIONS(2805),
    [anon_sym_LPAREN2] = ACTIONS(2807),
    [anon_sym_BANG] = ACTIONS(2807),
    [anon_sym_TILDE] = ACTIONS(2807),
    [anon_sym_DASH] = ACTIONS(2805),
    [anon_sym_PLUS] = ACTIONS(2805),
    [anon_sym_STAR] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2805),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym___extension__] = ACTIONS(2805),
    [anon_sym_typedef] = ACTIONS(2805),
    [anon_sym_virtual] = ACTIONS(2805),
    [anon_sym_extern] = ACTIONS(2805),
    [anon_sym___attribute__] = ACTIONS(2805),
    [anon_sym___attribute] = ACTIONS(2805),
    [anon_sym_COLON_COLON] = ACTIONS(2807),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2807),
    [anon_sym___declspec] = ACTIONS(2805),
    [anon_sym___based] = ACTIONS(2805),
    [anon_sym___cdecl] = ACTIONS(2805),
    [anon_sym___clrcall] = ACTIONS(2805),
    [anon_sym___stdcall] = ACTIONS(2805),
    [anon_sym___fastcall] = ACTIONS(2805),
    [anon_sym___thiscall] = ACTIONS(2805),
    [anon_sym___vectorcall] = ACTIONS(2805),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_signed] = ACTIONS(2805),
    [anon_sym_unsigned] = ACTIONS(2805),
    [anon_sym_long] = ACTIONS(2805),
    [anon_sym_short] = ACTIONS(2805),
    [anon_sym_LBRACK] = ACTIONS(2805),
    [anon_sym_static] = ACTIONS(2805),
    [anon_sym_register] = ACTIONS(2805),
    [anon_sym_inline] = ACTIONS(2805),
    [anon_sym___inline] = ACTIONS(2805),
    [anon_sym___inline__] = ACTIONS(2805),
    [anon_sym___forceinline] = ACTIONS(2805),
    [anon_sym_thread_local] = ACTIONS(2805),
    [anon_sym___thread] = ACTIONS(2805),
    [anon_sym_const] = ACTIONS(2805),
    [anon_sym_constexpr] = ACTIONS(2805),
    [anon_sym_volatile] = ACTIONS(2805),
    [anon_sym_restrict] = ACTIONS(2805),
    [anon_sym___restrict__] = ACTIONS(2805),
    [anon_sym__Atomic] = ACTIONS(2805),
    [anon_sym__Noreturn] = ACTIONS(2805),
    [anon_sym_noreturn] = ACTIONS(2805),
    [anon_sym__Nonnull] = ACTIONS(2805),
    [anon_sym_mutable] = ACTIONS(2805),
    [anon_sym_constinit] = ACTIONS(2805),
    [anon_sym_consteval] = ACTIONS(2805),
    [anon_sym_alignas] = ACTIONS(2805),
    [anon_sym__Alignas] = ACTIONS(2805),
    [sym_primitive_type] = ACTIONS(2805),
    [anon_sym_enum] = ACTIONS(2805),
    [anon_sym_class] = ACTIONS(2805),
    [anon_sym_struct] = ACTIONS(2805),
    [anon_sym_union] = ACTIONS(2805),
    [anon_sym_if] = ACTIONS(2805),
    [anon_sym_switch] = ACTIONS(2805),
    [anon_sym_case] = ACTIONS(2805),
    [anon_sym_default] = ACTIONS(2805),
    [anon_sym_while] = ACTIONS(2805),
    [anon_sym_do] = ACTIONS(2805),
    [anon_sym_for] = ACTIONS(2805),
    [anon_sym_return] = ACTIONS(2805),
    [anon_sym_break] = ACTIONS(2805),
    [anon_sym_continue] = ACTIONS(2805),
    [anon_sym_goto] = ACTIONS(2805),
    [anon_sym___try] = ACTIONS(2805),
    [anon_sym___leave] = ACTIONS(2805),
    [anon_sym_not] = ACTIONS(2805),
    [anon_sym_compl] = ACTIONS(2805),
    [anon_sym_DASH_DASH] = ACTIONS(2807),
    [anon_sym_PLUS_PLUS] = ACTIONS(2807),
    [anon_sym_sizeof] = ACTIONS(2805),
    [anon_sym___alignof__] = ACTIONS(2805),
    [anon_sym___alignof] = ACTIONS(2805),
    [anon_sym__alignof] = ACTIONS(2805),
    [anon_sym_alignof] = ACTIONS(2805),
    [anon_sym__Alignof] = ACTIONS(2805),
    [anon_sym_offsetof] = ACTIONS(2805),
    [anon_sym__Generic] = ACTIONS(2805),
    [anon_sym_asm] = ACTIONS(2805),
    [anon_sym___asm__] = ACTIONS(2805),
    [anon_sym___asm] = ACTIONS(2805),
    [sym_number_literal] = ACTIONS(2807),
    [anon_sym_L_SQUOTE] = ACTIONS(2807),
    [anon_sym_u_SQUOTE] = ACTIONS(2807),
    [anon_sym_U_SQUOTE] = ACTIONS(2807),
    [anon_sym_u8_SQUOTE] = ACTIONS(2807),
    [anon_sym_SQUOTE] = ACTIONS(2807),
    [anon_sym_L_DQUOTE] = ACTIONS(2807),
    [anon_sym_u_DQUOTE] = ACTIONS(2807),
    [anon_sym_U_DQUOTE] = ACTIONS(2807),
    [anon_sym_u8_DQUOTE] = ACTIONS(2807),
    [anon_sym_DQUOTE] = ACTIONS(2807),
    [sym_true] = ACTIONS(2805),
    [sym_false] = ACTIONS(2805),
    [anon_sym_NULL] = ACTIONS(2805),
    [anon_sym_nullptr] = ACTIONS(2805),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2805),
    [anon_sym_decltype] = ACTIONS(2805),
    [anon_sym_explicit] = ACTIONS(2805),
    [anon_sym_typename] = ACTIONS(2805),
    [anon_sym_template] = ACTIONS(2805),
    [anon_sym_operator] = ACTIONS(2805),
    [anon_sym_try] = ACTIONS(2805),
    [anon_sym_delete] = ACTIONS(2805),
    [anon_sym_throw] = ACTIONS(2805),
    [anon_sym_namespace] = ACTIONS(2805),
    [anon_sym_using] = ACTIONS(2805),
    [anon_sym_static_assert] = ACTIONS(2805),
    [anon_sym_concept] = ACTIONS(2805),
    [anon_sym_co_return] = ACTIONS(2805),
    [anon_sym_co_yield] = ACTIONS(2805),
    [anon_sym_R_DQUOTE] = ACTIONS(2807),
    [anon_sym_LR_DQUOTE] = ACTIONS(2807),
    [anon_sym_uR_DQUOTE] = ACTIONS(2807),
    [anon_sym_UR_DQUOTE] = ACTIONS(2807),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2807),
    [anon_sym_co_await] = ACTIONS(2805),
    [anon_sym_new] = ACTIONS(2805),
    [anon_sym_requires] = ACTIONS(2805),
    [sym_this] = ACTIONS(2805),
  },
  [572] = {
    [sym_identifier] = ACTIONS(2809),
    [aux_sym_preproc_include_token1] = ACTIONS(2809),
    [aux_sym_preproc_def_token1] = ACTIONS(2809),
    [aux_sym_preproc_if_token1] = ACTIONS(2809),
    [aux_sym_preproc_if_token2] = ACTIONS(2809),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2809),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2809),
    [sym_preproc_directive] = ACTIONS(2809),
    [anon_sym_LPAREN2] = ACTIONS(2811),
    [anon_sym_BANG] = ACTIONS(2811),
    [anon_sym_TILDE] = ACTIONS(2811),
    [anon_sym_DASH] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_STAR] = ACTIONS(2811),
    [anon_sym_AMP_AMP] = ACTIONS(2811),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2811),
    [anon_sym___extension__] = ACTIONS(2809),
    [anon_sym_typedef] = ACTIONS(2809),
    [anon_sym_virtual] = ACTIONS(2809),
    [anon_sym_extern] = ACTIONS(2809),
    [anon_sym___attribute__] = ACTIONS(2809),
    [anon_sym___attribute] = ACTIONS(2809),
    [anon_sym_COLON_COLON] = ACTIONS(2811),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2811),
    [anon_sym___declspec] = ACTIONS(2809),
    [anon_sym___based] = ACTIONS(2809),
    [anon_sym___cdecl] = ACTIONS(2809),
    [anon_sym___clrcall] = ACTIONS(2809),
    [anon_sym___stdcall] = ACTIONS(2809),
    [anon_sym___fastcall] = ACTIONS(2809),
    [anon_sym___thiscall] = ACTIONS(2809),
    [anon_sym___vectorcall] = ACTIONS(2809),
    [anon_sym_LBRACE] = ACTIONS(2811),
    [anon_sym_signed] = ACTIONS(2809),
    [anon_sym_unsigned] = ACTIONS(2809),
    [anon_sym_long] = ACTIONS(2809),
    [anon_sym_short] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2809),
    [anon_sym_static] = ACTIONS(2809),
    [anon_sym_register] = ACTIONS(2809),
    [anon_sym_inline] = ACTIONS(2809),
    [anon_sym___inline] = ACTIONS(2809),
    [anon_sym___inline__] = ACTIONS(2809),
    [anon_sym___forceinline] = ACTIONS(2809),
    [anon_sym_thread_local] = ACTIONS(2809),
    [anon_sym___thread] = ACTIONS(2809),
    [anon_sym_const] = ACTIONS(2809),
    [anon_sym_constexpr] = ACTIONS(2809),
    [anon_sym_volatile] = ACTIONS(2809),
    [anon_sym_restrict] = ACTIONS(2809),
    [anon_sym___restrict__] = ACTIONS(2809),
    [anon_sym__Atomic] = ACTIONS(2809),
    [anon_sym__Noreturn] = ACTIONS(2809),
    [anon_sym_noreturn] = ACTIONS(2809),
    [anon_sym__Nonnull] = ACTIONS(2809),
    [anon_sym_mutable] = ACTIONS(2809),
    [anon_sym_constinit] = ACTIONS(2809),
    [anon_sym_consteval] = ACTIONS(2809),
    [anon_sym_alignas] = ACTIONS(2809),
    [anon_sym__Alignas] = ACTIONS(2809),
    [sym_primitive_type] = ACTIONS(2809),
    [anon_sym_enum] = ACTIONS(2809),
    [anon_sym_class] = ACTIONS(2809),
    [anon_sym_struct] = ACTIONS(2809),
    [anon_sym_union] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(2809),
    [anon_sym_switch] = ACTIONS(2809),
    [anon_sym_case] = ACTIONS(2809),
    [anon_sym_default] = ACTIONS(2809),
    [anon_sym_while] = ACTIONS(2809),
    [anon_sym_do] = ACTIONS(2809),
    [anon_sym_for] = ACTIONS(2809),
    [anon_sym_return] = ACTIONS(2809),
    [anon_sym_break] = ACTIONS(2809),
    [anon_sym_continue] = ACTIONS(2809),
    [anon_sym_goto] = ACTIONS(2809),
    [anon_sym___try] = ACTIONS(2809),
    [anon_sym___leave] = ACTIONS(2809),
    [anon_sym_not] = ACTIONS(2809),
    [anon_sym_compl] = ACTIONS(2809),
    [anon_sym_DASH_DASH] = ACTIONS(2811),
    [anon_sym_PLUS_PLUS] = ACTIONS(2811),
    [anon_sym_sizeof] = ACTIONS(2809),
    [anon_sym___alignof__] = ACTIONS(2809),
    [anon_sym___alignof] = ACTIONS(2809),
    [anon_sym__alignof] = ACTIONS(2809),
    [anon_sym_alignof] = ACTIONS(2809),
    [anon_sym__Alignof] = ACTIONS(2809),
    [anon_sym_offsetof] = ACTIONS(2809),
    [anon_sym__Generic] = ACTIONS(2809),
    [anon_sym_asm] = ACTIONS(2809),
    [anon_sym___asm__] = ACTIONS(2809),
    [anon_sym___asm] = ACTIONS(2809),
    [sym_number_literal] = ACTIONS(2811),
    [anon_sym_L_SQUOTE] = ACTIONS(2811),
    [anon_sym_u_SQUOTE] = ACTIONS(2811),
    [anon_sym_U_SQUOTE] = ACTIONS(2811),
    [anon_sym_u8_SQUOTE] = ACTIONS(2811),
    [anon_sym_SQUOTE] = ACTIONS(2811),
    [anon_sym_L_DQUOTE] = ACTIONS(2811),
    [anon_sym_u_DQUOTE] = ACTIONS(2811),
    [anon_sym_U_DQUOTE] = ACTIONS(2811),
    [anon_sym_u8_DQUOTE] = ACTIONS(2811),
    [anon_sym_DQUOTE] = ACTIONS(2811),
    [sym_true] = ACTIONS(2809),
    [sym_false] = ACTIONS(2809),
    [anon_sym_NULL] = ACTIONS(2809),
    [anon_sym_nullptr] = ACTIONS(2809),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2809),
    [anon_sym_decltype] = ACTIONS(2809),
    [anon_sym_explicit] = ACTIONS(2809),
    [anon_sym_typename] = ACTIONS(2809),
    [anon_sym_template] = ACTIONS(2809),
    [anon_sym_operator] = ACTIONS(2809),
    [anon_sym_try] = ACTIONS(2809),
    [anon_sym_delete] = ACTIONS(2809),
    [anon_sym_throw] = ACTIONS(2809),
    [anon_sym_namespace] = ACTIONS(2809),
    [anon_sym_using] = ACTIONS(2809),
    [anon_sym_static_assert] = ACTIONS(2809),
    [anon_sym_concept] = ACTIONS(2809),
    [anon_sym_co_return] = ACTIONS(2809),
    [anon_sym_co_yield] = ACTIONS(2809),
    [anon_sym_R_DQUOTE] = ACTIONS(2811),
    [anon_sym_LR_DQUOTE] = ACTIONS(2811),
    [anon_sym_uR_DQUOTE] = ACTIONS(2811),
    [anon_sym_UR_DQUOTE] = ACTIONS(2811),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2811),
    [anon_sym_co_await] = ACTIONS(2809),
    [anon_sym_new] = ACTIONS(2809),
    [anon_sym_requires] = ACTIONS(2809),
    [sym_this] = ACTIONS(2809),
  },
  [573] = {
    [sym_identifier] = ACTIONS(3086),
    [aux_sym_preproc_include_token1] = ACTIONS(3086),
    [aux_sym_preproc_def_token1] = ACTIONS(3086),
    [aux_sym_preproc_if_token1] = ACTIONS(3086),
    [aux_sym_preproc_if_token2] = ACTIONS(3086),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3086),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3086),
    [sym_preproc_directive] = ACTIONS(3086),
    [anon_sym_LPAREN2] = ACTIONS(3089),
    [anon_sym_BANG] = ACTIONS(3089),
    [anon_sym_TILDE] = ACTIONS(3089),
    [anon_sym_DASH] = ACTIONS(3086),
    [anon_sym_PLUS] = ACTIONS(3086),
    [anon_sym_STAR] = ACTIONS(3089),
    [anon_sym_AMP_AMP] = ACTIONS(3089),
    [anon_sym_AMP] = ACTIONS(3086),
    [anon_sym_SEMI] = ACTIONS(3089),
    [anon_sym___extension__] = ACTIONS(3086),
    [anon_sym_typedef] = ACTIONS(3086),
    [anon_sym_virtual] = ACTIONS(3086),
    [anon_sym_extern] = ACTIONS(3086),
    [anon_sym___attribute__] = ACTIONS(3086),
    [anon_sym___attribute] = ACTIONS(3086),
    [anon_sym_COLON_COLON] = ACTIONS(3089),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3089),
    [anon_sym___declspec] = ACTIONS(3086),
    [anon_sym___based] = ACTIONS(3086),
    [anon_sym___cdecl] = ACTIONS(3086),
    [anon_sym___clrcall] = ACTIONS(3086),
    [anon_sym___stdcall] = ACTIONS(3086),
    [anon_sym___fastcall] = ACTIONS(3086),
    [anon_sym___thiscall] = ACTIONS(3086),
    [anon_sym___vectorcall] = ACTIONS(3086),
    [anon_sym_LBRACE] = ACTIONS(3089),
    [anon_sym_signed] = ACTIONS(3086),
    [anon_sym_unsigned] = ACTIONS(3086),
    [anon_sym_long] = ACTIONS(3086),
    [anon_sym_short] = ACTIONS(3086),
    [anon_sym_LBRACK] = ACTIONS(3086),
    [anon_sym_static] = ACTIONS(3086),
    [anon_sym_register] = ACTIONS(3086),
    [anon_sym_inline] = ACTIONS(3086),
    [anon_sym___inline] = ACTIONS(3086),
    [anon_sym___inline__] = ACTIONS(3086),
    [anon_sym___forceinline] = ACTIONS(3086),
    [anon_sym_thread_local] = ACTIONS(3086),
    [anon_sym___thread] = ACTIONS(3086),
    [anon_sym_const] = ACTIONS(3086),
    [anon_sym_constexpr] = ACTIONS(3086),
    [anon_sym_volatile] = ACTIONS(3086),
    [anon_sym_restrict] = ACTIONS(3086),
    [anon_sym___restrict__] = ACTIONS(3086),
    [anon_sym__Atomic] = ACTIONS(3086),
    [anon_sym__Noreturn] = ACTIONS(3086),
    [anon_sym_noreturn] = ACTIONS(3086),
    [anon_sym__Nonnull] = ACTIONS(3086),
    [anon_sym_mutable] = ACTIONS(3086),
    [anon_sym_constinit] = ACTIONS(3086),
    [anon_sym_consteval] = ACTIONS(3086),
    [anon_sym_alignas] = ACTIONS(3086),
    [anon_sym__Alignas] = ACTIONS(3086),
    [sym_primitive_type] = ACTIONS(3086),
    [anon_sym_enum] = ACTIONS(3086),
    [anon_sym_class] = ACTIONS(3086),
    [anon_sym_struct] = ACTIONS(3086),
    [anon_sym_union] = ACTIONS(3086),
    [anon_sym_if] = ACTIONS(3086),
    [anon_sym_switch] = ACTIONS(3086),
    [anon_sym_case] = ACTIONS(3086),
    [anon_sym_default] = ACTIONS(3086),
    [anon_sym_while] = ACTIONS(3086),
    [anon_sym_do] = ACTIONS(3086),
    [anon_sym_for] = ACTIONS(3086),
    [anon_sym_return] = ACTIONS(3086),
    [anon_sym_break] = ACTIONS(3086),
    [anon_sym_continue] = ACTIONS(3086),
    [anon_sym_goto] = ACTIONS(3086),
    [anon_sym___try] = ACTIONS(3086),
    [anon_sym___leave] = ACTIONS(3086),
    [anon_sym_not] = ACTIONS(3086),
    [anon_sym_compl] = ACTIONS(3086),
    [anon_sym_DASH_DASH] = ACTIONS(3089),
    [anon_sym_PLUS_PLUS] = ACTIONS(3089),
    [anon_sym_sizeof] = ACTIONS(3086),
    [anon_sym___alignof__] = ACTIONS(3086),
    [anon_sym___alignof] = ACTIONS(3086),
    [anon_sym__alignof] = ACTIONS(3086),
    [anon_sym_alignof] = ACTIONS(3086),
    [anon_sym__Alignof] = ACTIONS(3086),
    [anon_sym_offsetof] = ACTIONS(3086),
    [anon_sym__Generic] = ACTIONS(3086),
    [anon_sym_asm] = ACTIONS(3086),
    [anon_sym___asm__] = ACTIONS(3086),
    [anon_sym___asm] = ACTIONS(3086),
    [sym_number_literal] = ACTIONS(3089),
    [anon_sym_L_SQUOTE] = ACTIONS(3089),
    [anon_sym_u_SQUOTE] = ACTIONS(3089),
    [anon_sym_U_SQUOTE] = ACTIONS(3089),
    [anon_sym_u8_SQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3089),
    [anon_sym_L_DQUOTE] = ACTIONS(3089),
    [anon_sym_u_DQUOTE] = ACTIONS(3089),
    [anon_sym_U_DQUOTE] = ACTIONS(3089),
    [anon_sym_u8_DQUOTE] = ACTIONS(3089),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [sym_true] = ACTIONS(3086),
    [sym_false] = ACTIONS(3086),
    [anon_sym_NULL] = ACTIONS(3086),
    [anon_sym_nullptr] = ACTIONS(3086),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3086),
    [anon_sym_decltype] = ACTIONS(3086),
    [anon_sym_explicit] = ACTIONS(3086),
    [anon_sym_typename] = ACTIONS(3086),
    [anon_sym_template] = ACTIONS(3086),
    [anon_sym_operator] = ACTIONS(3086),
    [anon_sym_try] = ACTIONS(3086),
    [anon_sym_delete] = ACTIONS(3086),
    [anon_sym_throw] = ACTIONS(3086),
    [anon_sym_namespace] = ACTIONS(3086),
    [anon_sym_using] = ACTIONS(3086),
    [anon_sym_static_assert] = ACTIONS(3086),
    [anon_sym_concept] = ACTIONS(3086),
    [anon_sym_co_return] = ACTIONS(3086),
    [anon_sym_co_yield] = ACTIONS(3086),
    [anon_sym_R_DQUOTE] = ACTIONS(3089),
    [anon_sym_LR_DQUOTE] = ACTIONS(3089),
    [anon_sym_uR_DQUOTE] = ACTIONS(3089),
    [anon_sym_UR_DQUOTE] = ACTIONS(3089),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3089),
    [anon_sym_co_await] = ACTIONS(3086),
    [anon_sym_new] = ACTIONS(3086),
    [anon_sym_requires] = ACTIONS(3086),
    [sym_this] = ACTIONS(3086),
  },
  [574] = {
    [sym_identifier] = ACTIONS(2818),
    [aux_sym_preproc_include_token1] = ACTIONS(2818),
    [aux_sym_preproc_def_token1] = ACTIONS(2818),
    [aux_sym_preproc_if_token1] = ACTIONS(2818),
    [aux_sym_preproc_if_token2] = ACTIONS(2818),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2818),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2818),
    [sym_preproc_directive] = ACTIONS(2818),
    [anon_sym_LPAREN2] = ACTIONS(2820),
    [anon_sym_BANG] = ACTIONS(2820),
    [anon_sym_TILDE] = ACTIONS(2820),
    [anon_sym_DASH] = ACTIONS(2818),
    [anon_sym_PLUS] = ACTIONS(2818),
    [anon_sym_STAR] = ACTIONS(2820),
    [anon_sym_AMP_AMP] = ACTIONS(2820),
    [anon_sym_AMP] = ACTIONS(2818),
    [anon_sym_SEMI] = ACTIONS(2820),
    [anon_sym___extension__] = ACTIONS(2818),
    [anon_sym_typedef] = ACTIONS(2818),
    [anon_sym_virtual] = ACTIONS(2818),
    [anon_sym_extern] = ACTIONS(2818),
    [anon_sym___attribute__] = ACTIONS(2818),
    [anon_sym___attribute] = ACTIONS(2818),
    [anon_sym_COLON_COLON] = ACTIONS(2820),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2820),
    [anon_sym___declspec] = ACTIONS(2818),
    [anon_sym___based] = ACTIONS(2818),
    [anon_sym___cdecl] = ACTIONS(2818),
    [anon_sym___clrcall] = ACTIONS(2818),
    [anon_sym___stdcall] = ACTIONS(2818),
    [anon_sym___fastcall] = ACTIONS(2818),
    [anon_sym___thiscall] = ACTIONS(2818),
    [anon_sym___vectorcall] = ACTIONS(2818),
    [anon_sym_LBRACE] = ACTIONS(2820),
    [anon_sym_signed] = ACTIONS(2818),
    [anon_sym_unsigned] = ACTIONS(2818),
    [anon_sym_long] = ACTIONS(2818),
    [anon_sym_short] = ACTIONS(2818),
    [anon_sym_LBRACK] = ACTIONS(2818),
    [anon_sym_static] = ACTIONS(2818),
    [anon_sym_register] = ACTIONS(2818),
    [anon_sym_inline] = ACTIONS(2818),
    [anon_sym___inline] = ACTIONS(2818),
    [anon_sym___inline__] = ACTIONS(2818),
    [anon_sym___forceinline] = ACTIONS(2818),
    [anon_sym_thread_local] = ACTIONS(2818),
    [anon_sym___thread] = ACTIONS(2818),
    [anon_sym_const] = ACTIONS(2818),
    [anon_sym_constexpr] = ACTIONS(2818),
    [anon_sym_volatile] = ACTIONS(2818),
    [anon_sym_restrict] = ACTIONS(2818),
    [anon_sym___restrict__] = ACTIONS(2818),
    [anon_sym__Atomic] = ACTIONS(2818),
    [anon_sym__Noreturn] = ACTIONS(2818),
    [anon_sym_noreturn] = ACTIONS(2818),
    [anon_sym__Nonnull] = ACTIONS(2818),
    [anon_sym_mutable] = ACTIONS(2818),
    [anon_sym_constinit] = ACTIONS(2818),
    [anon_sym_consteval] = ACTIONS(2818),
    [anon_sym_alignas] = ACTIONS(2818),
    [anon_sym__Alignas] = ACTIONS(2818),
    [sym_primitive_type] = ACTIONS(2818),
    [anon_sym_enum] = ACTIONS(2818),
    [anon_sym_class] = ACTIONS(2818),
    [anon_sym_struct] = ACTIONS(2818),
    [anon_sym_union] = ACTIONS(2818),
    [anon_sym_if] = ACTIONS(2818),
    [anon_sym_switch] = ACTIONS(2818),
    [anon_sym_case] = ACTIONS(2818),
    [anon_sym_default] = ACTIONS(2818),
    [anon_sym_while] = ACTIONS(2818),
    [anon_sym_do] = ACTIONS(2818),
    [anon_sym_for] = ACTIONS(2818),
    [anon_sym_return] = ACTIONS(2818),
    [anon_sym_break] = ACTIONS(2818),
    [anon_sym_continue] = ACTIONS(2818),
    [anon_sym_goto] = ACTIONS(2818),
    [anon_sym___try] = ACTIONS(2818),
    [anon_sym___leave] = ACTIONS(2818),
    [anon_sym_not] = ACTIONS(2818),
    [anon_sym_compl] = ACTIONS(2818),
    [anon_sym_DASH_DASH] = ACTIONS(2820),
    [anon_sym_PLUS_PLUS] = ACTIONS(2820),
    [anon_sym_sizeof] = ACTIONS(2818),
    [anon_sym___alignof__] = ACTIONS(2818),
    [anon_sym___alignof] = ACTIONS(2818),
    [anon_sym__alignof] = ACTIONS(2818),
    [anon_sym_alignof] = ACTIONS(2818),
    [anon_sym__Alignof] = ACTIONS(2818),
    [anon_sym_offsetof] = ACTIONS(2818),
    [anon_sym__Generic] = ACTIONS(2818),
    [anon_sym_asm] = ACTIONS(2818),
    [anon_sym___asm__] = ACTIONS(2818),
    [anon_sym___asm] = ACTIONS(2818),
    [sym_number_literal] = ACTIONS(2820),
    [anon_sym_L_SQUOTE] = ACTIONS(2820),
    [anon_sym_u_SQUOTE] = ACTIONS(2820),
    [anon_sym_U_SQUOTE] = ACTIONS(2820),
    [anon_sym_u8_SQUOTE] = ACTIONS(2820),
    [anon_sym_SQUOTE] = ACTIONS(2820),
    [anon_sym_L_DQUOTE] = ACTIONS(2820),
    [anon_sym_u_DQUOTE] = ACTIONS(2820),
    [anon_sym_U_DQUOTE] = ACTIONS(2820),
    [anon_sym_u8_DQUOTE] = ACTIONS(2820),
    [anon_sym_DQUOTE] = ACTIONS(2820),
    [sym_true] = ACTIONS(2818),
    [sym_false] = ACTIONS(2818),
    [anon_sym_NULL] = ACTIONS(2818),
    [anon_sym_nullptr] = ACTIONS(2818),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2818),
    [anon_sym_decltype] = ACTIONS(2818),
    [anon_sym_explicit] = ACTIONS(2818),
    [anon_sym_typename] = ACTIONS(2818),
    [anon_sym_template] = ACTIONS(2818),
    [anon_sym_operator] = ACTIONS(2818),
    [anon_sym_try] = ACTIONS(2818),
    [anon_sym_delete] = ACTIONS(2818),
    [anon_sym_throw] = ACTIONS(2818),
    [anon_sym_namespace] = ACTIONS(2818),
    [anon_sym_using] = ACTIONS(2818),
    [anon_sym_static_assert] = ACTIONS(2818),
    [anon_sym_concept] = ACTIONS(2818),
    [anon_sym_co_return] = ACTIONS(2818),
    [anon_sym_co_yield] = ACTIONS(2818),
    [anon_sym_R_DQUOTE] = ACTIONS(2820),
    [anon_sym_LR_DQUOTE] = ACTIONS(2820),
    [anon_sym_uR_DQUOTE] = ACTIONS(2820),
    [anon_sym_UR_DQUOTE] = ACTIONS(2820),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2820),
    [anon_sym_co_await] = ACTIONS(2818),
    [anon_sym_new] = ACTIONS(2818),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2818),
  },
  [575] = {
    [sym_identifier] = ACTIONS(2822),
    [aux_sym_preproc_include_token1] = ACTIONS(2822),
    [aux_sym_preproc_def_token1] = ACTIONS(2822),
    [aux_sym_preproc_if_token1] = ACTIONS(2822),
    [aux_sym_preproc_if_token2] = ACTIONS(2822),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2822),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2822),
    [sym_preproc_directive] = ACTIONS(2822),
    [anon_sym_LPAREN2] = ACTIONS(2824),
    [anon_sym_BANG] = ACTIONS(2824),
    [anon_sym_TILDE] = ACTIONS(2824),
    [anon_sym_DASH] = ACTIONS(2822),
    [anon_sym_PLUS] = ACTIONS(2822),
    [anon_sym_STAR] = ACTIONS(2824),
    [anon_sym_AMP_AMP] = ACTIONS(2824),
    [anon_sym_AMP] = ACTIONS(2822),
    [anon_sym_SEMI] = ACTIONS(2824),
    [anon_sym___extension__] = ACTIONS(2822),
    [anon_sym_typedef] = ACTIONS(2822),
    [anon_sym_virtual] = ACTIONS(2822),
    [anon_sym_extern] = ACTIONS(2822),
    [anon_sym___attribute__] = ACTIONS(2822),
    [anon_sym___attribute] = ACTIONS(2822),
    [anon_sym_COLON_COLON] = ACTIONS(2824),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2824),
    [anon_sym___declspec] = ACTIONS(2822),
    [anon_sym___based] = ACTIONS(2822),
    [anon_sym___cdecl] = ACTIONS(2822),
    [anon_sym___clrcall] = ACTIONS(2822),
    [anon_sym___stdcall] = ACTIONS(2822),
    [anon_sym___fastcall] = ACTIONS(2822),
    [anon_sym___thiscall] = ACTIONS(2822),
    [anon_sym___vectorcall] = ACTIONS(2822),
    [anon_sym_LBRACE] = ACTIONS(2824),
    [anon_sym_signed] = ACTIONS(2822),
    [anon_sym_unsigned] = ACTIONS(2822),
    [anon_sym_long] = ACTIONS(2822),
    [anon_sym_short] = ACTIONS(2822),
    [anon_sym_LBRACK] = ACTIONS(2822),
    [anon_sym_static] = ACTIONS(2822),
    [anon_sym_register] = ACTIONS(2822),
    [anon_sym_inline] = ACTIONS(2822),
    [anon_sym___inline] = ACTIONS(2822),
    [anon_sym___inline__] = ACTIONS(2822),
    [anon_sym___forceinline] = ACTIONS(2822),
    [anon_sym_thread_local] = ACTIONS(2822),
    [anon_sym___thread] = ACTIONS(2822),
    [anon_sym_const] = ACTIONS(2822),
    [anon_sym_constexpr] = ACTIONS(2822),
    [anon_sym_volatile] = ACTIONS(2822),
    [anon_sym_restrict] = ACTIONS(2822),
    [anon_sym___restrict__] = ACTIONS(2822),
    [anon_sym__Atomic] = ACTIONS(2822),
    [anon_sym__Noreturn] = ACTIONS(2822),
    [anon_sym_noreturn] = ACTIONS(2822),
    [anon_sym__Nonnull] = ACTIONS(2822),
    [anon_sym_mutable] = ACTIONS(2822),
    [anon_sym_constinit] = ACTIONS(2822),
    [anon_sym_consteval] = ACTIONS(2822),
    [anon_sym_alignas] = ACTIONS(2822),
    [anon_sym__Alignas] = ACTIONS(2822),
    [sym_primitive_type] = ACTIONS(2822),
    [anon_sym_enum] = ACTIONS(2822),
    [anon_sym_class] = ACTIONS(2822),
    [anon_sym_struct] = ACTIONS(2822),
    [anon_sym_union] = ACTIONS(2822),
    [anon_sym_if] = ACTIONS(2822),
    [anon_sym_switch] = ACTIONS(2822),
    [anon_sym_case] = ACTIONS(2822),
    [anon_sym_default] = ACTIONS(2822),
    [anon_sym_while] = ACTIONS(2822),
    [anon_sym_do] = ACTIONS(2822),
    [anon_sym_for] = ACTIONS(2822),
    [anon_sym_return] = ACTIONS(2822),
    [anon_sym_break] = ACTIONS(2822),
    [anon_sym_continue] = ACTIONS(2822),
    [anon_sym_goto] = ACTIONS(2822),
    [anon_sym___try] = ACTIONS(2822),
    [anon_sym___leave] = ACTIONS(2822),
    [anon_sym_not] = ACTIONS(2822),
    [anon_sym_compl] = ACTIONS(2822),
    [anon_sym_DASH_DASH] = ACTIONS(2824),
    [anon_sym_PLUS_PLUS] = ACTIONS(2824),
    [anon_sym_sizeof] = ACTIONS(2822),
    [anon_sym___alignof__] = ACTIONS(2822),
    [anon_sym___alignof] = ACTIONS(2822),
    [anon_sym__alignof] = ACTIONS(2822),
    [anon_sym_alignof] = ACTIONS(2822),
    [anon_sym__Alignof] = ACTIONS(2822),
    [anon_sym_offsetof] = ACTIONS(2822),
    [anon_sym__Generic] = ACTIONS(2822),
    [anon_sym_asm] = ACTIONS(2822),
    [anon_sym___asm__] = ACTIONS(2822),
    [anon_sym___asm] = ACTIONS(2822),
    [sym_number_literal] = ACTIONS(2824),
    [anon_sym_L_SQUOTE] = ACTIONS(2824),
    [anon_sym_u_SQUOTE] = ACTIONS(2824),
    [anon_sym_U_SQUOTE] = ACTIONS(2824),
    [anon_sym_u8_SQUOTE] = ACTIONS(2824),
    [anon_sym_SQUOTE] = ACTIONS(2824),
    [anon_sym_L_DQUOTE] = ACTIONS(2824),
    [anon_sym_u_DQUOTE] = ACTIONS(2824),
    [anon_sym_U_DQUOTE] = ACTIONS(2824),
    [anon_sym_u8_DQUOTE] = ACTIONS(2824),
    [anon_sym_DQUOTE] = ACTIONS(2824),
    [sym_true] = ACTIONS(2822),
    [sym_false] = ACTIONS(2822),
    [anon_sym_NULL] = ACTIONS(2822),
    [anon_sym_nullptr] = ACTIONS(2822),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2822),
    [anon_sym_decltype] = ACTIONS(2822),
    [anon_sym_explicit] = ACTIONS(2822),
    [anon_sym_typename] = ACTIONS(2822),
    [anon_sym_template] = ACTIONS(2822),
    [anon_sym_operator] = ACTIONS(2822),
    [anon_sym_try] = ACTIONS(2822),
    [anon_sym_delete] = ACTIONS(2822),
    [anon_sym_throw] = ACTIONS(2822),
    [anon_sym_namespace] = ACTIONS(2822),
    [anon_sym_using] = ACTIONS(2822),
    [anon_sym_static_assert] = ACTIONS(2822),
    [anon_sym_concept] = ACTIONS(2822),
    [anon_sym_co_return] = ACTIONS(2822),
    [anon_sym_co_yield] = ACTIONS(2822),
    [anon_sym_R_DQUOTE] = ACTIONS(2824),
    [anon_sym_LR_DQUOTE] = ACTIONS(2824),
    [anon_sym_uR_DQUOTE] = ACTIONS(2824),
    [anon_sym_UR_DQUOTE] = ACTIONS(2824),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2824),
    [anon_sym_co_await] = ACTIONS(2822),
    [anon_sym_new] = ACTIONS(2822),
    [anon_sym_requires] = ACTIONS(2822),
    [sym_this] = ACTIONS(2822),
  },
  [576] = {
    [sym_identifier] = ACTIONS(2826),
    [aux_sym_preproc_include_token1] = ACTIONS(2826),
    [aux_sym_preproc_def_token1] = ACTIONS(2826),
    [aux_sym_preproc_if_token1] = ACTIONS(2826),
    [aux_sym_preproc_if_token2] = ACTIONS(2826),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2826),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2826),
    [sym_preproc_directive] = ACTIONS(2826),
    [anon_sym_LPAREN2] = ACTIONS(2828),
    [anon_sym_BANG] = ACTIONS(2828),
    [anon_sym_TILDE] = ACTIONS(2828),
    [anon_sym_DASH] = ACTIONS(2826),
    [anon_sym_PLUS] = ACTIONS(2826),
    [anon_sym_STAR] = ACTIONS(2828),
    [anon_sym_AMP_AMP] = ACTIONS(2828),
    [anon_sym_AMP] = ACTIONS(2826),
    [anon_sym_SEMI] = ACTIONS(2828),
    [anon_sym___extension__] = ACTIONS(2826),
    [anon_sym_typedef] = ACTIONS(2826),
    [anon_sym_virtual] = ACTIONS(2826),
    [anon_sym_extern] = ACTIONS(2826),
    [anon_sym___attribute__] = ACTIONS(2826),
    [anon_sym___attribute] = ACTIONS(2826),
    [anon_sym_COLON_COLON] = ACTIONS(2828),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2828),
    [anon_sym___declspec] = ACTIONS(2826),
    [anon_sym___based] = ACTIONS(2826),
    [anon_sym___cdecl] = ACTIONS(2826),
    [anon_sym___clrcall] = ACTIONS(2826),
    [anon_sym___stdcall] = ACTIONS(2826),
    [anon_sym___fastcall] = ACTIONS(2826),
    [anon_sym___thiscall] = ACTIONS(2826),
    [anon_sym___vectorcall] = ACTIONS(2826),
    [anon_sym_LBRACE] = ACTIONS(2828),
    [anon_sym_signed] = ACTIONS(2826),
    [anon_sym_unsigned] = ACTIONS(2826),
    [anon_sym_long] = ACTIONS(2826),
    [anon_sym_short] = ACTIONS(2826),
    [anon_sym_LBRACK] = ACTIONS(2826),
    [anon_sym_static] = ACTIONS(2826),
    [anon_sym_register] = ACTIONS(2826),
    [anon_sym_inline] = ACTIONS(2826),
    [anon_sym___inline] = ACTIONS(2826),
    [anon_sym___inline__] = ACTIONS(2826),
    [anon_sym___forceinline] = ACTIONS(2826),
    [anon_sym_thread_local] = ACTIONS(2826),
    [anon_sym___thread] = ACTIONS(2826),
    [anon_sym_const] = ACTIONS(2826),
    [anon_sym_constexpr] = ACTIONS(2826),
    [anon_sym_volatile] = ACTIONS(2826),
    [anon_sym_restrict] = ACTIONS(2826),
    [anon_sym___restrict__] = ACTIONS(2826),
    [anon_sym__Atomic] = ACTIONS(2826),
    [anon_sym__Noreturn] = ACTIONS(2826),
    [anon_sym_noreturn] = ACTIONS(2826),
    [anon_sym__Nonnull] = ACTIONS(2826),
    [anon_sym_mutable] = ACTIONS(2826),
    [anon_sym_constinit] = ACTIONS(2826),
    [anon_sym_consteval] = ACTIONS(2826),
    [anon_sym_alignas] = ACTIONS(2826),
    [anon_sym__Alignas] = ACTIONS(2826),
    [sym_primitive_type] = ACTIONS(2826),
    [anon_sym_enum] = ACTIONS(2826),
    [anon_sym_class] = ACTIONS(2826),
    [anon_sym_struct] = ACTIONS(2826),
    [anon_sym_union] = ACTIONS(2826),
    [anon_sym_if] = ACTIONS(2826),
    [anon_sym_switch] = ACTIONS(2826),
    [anon_sym_case] = ACTIONS(2826),
    [anon_sym_default] = ACTIONS(2826),
    [anon_sym_while] = ACTIONS(2826),
    [anon_sym_do] = ACTIONS(2826),
    [anon_sym_for] = ACTIONS(2826),
    [anon_sym_return] = ACTIONS(2826),
    [anon_sym_break] = ACTIONS(2826),
    [anon_sym_continue] = ACTIONS(2826),
    [anon_sym_goto] = ACTIONS(2826),
    [anon_sym___try] = ACTIONS(2826),
    [anon_sym___leave] = ACTIONS(2826),
    [anon_sym_not] = ACTIONS(2826),
    [anon_sym_compl] = ACTIONS(2826),
    [anon_sym_DASH_DASH] = ACTIONS(2828),
    [anon_sym_PLUS_PLUS] = ACTIONS(2828),
    [anon_sym_sizeof] = ACTIONS(2826),
    [anon_sym___alignof__] = ACTIONS(2826),
    [anon_sym___alignof] = ACTIONS(2826),
    [anon_sym__alignof] = ACTIONS(2826),
    [anon_sym_alignof] = ACTIONS(2826),
    [anon_sym__Alignof] = ACTIONS(2826),
    [anon_sym_offsetof] = ACTIONS(2826),
    [anon_sym__Generic] = ACTIONS(2826),
    [anon_sym_asm] = ACTIONS(2826),
    [anon_sym___asm__] = ACTIONS(2826),
    [anon_sym___asm] = ACTIONS(2826),
    [sym_number_literal] = ACTIONS(2828),
    [anon_sym_L_SQUOTE] = ACTIONS(2828),
    [anon_sym_u_SQUOTE] = ACTIONS(2828),
    [anon_sym_U_SQUOTE] = ACTIONS(2828),
    [anon_sym_u8_SQUOTE] = ACTIONS(2828),
    [anon_sym_SQUOTE] = ACTIONS(2828),
    [anon_sym_L_DQUOTE] = ACTIONS(2828),
    [anon_sym_u_DQUOTE] = ACTIONS(2828),
    [anon_sym_U_DQUOTE] = ACTIONS(2828),
    [anon_sym_u8_DQUOTE] = ACTIONS(2828),
    [anon_sym_DQUOTE] = ACTIONS(2828),
    [sym_true] = ACTIONS(2826),
    [sym_false] = ACTIONS(2826),
    [anon_sym_NULL] = ACTIONS(2826),
    [anon_sym_nullptr] = ACTIONS(2826),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2826),
    [anon_sym_decltype] = ACTIONS(2826),
    [anon_sym_explicit] = ACTIONS(2826),
    [anon_sym_typename] = ACTIONS(2826),
    [anon_sym_template] = ACTIONS(2826),
    [anon_sym_operator] = ACTIONS(2826),
    [anon_sym_try] = ACTIONS(2826),
    [anon_sym_delete] = ACTIONS(2826),
    [anon_sym_throw] = ACTIONS(2826),
    [anon_sym_namespace] = ACTIONS(2826),
    [anon_sym_using] = ACTIONS(2826),
    [anon_sym_static_assert] = ACTIONS(2826),
    [anon_sym_concept] = ACTIONS(2826),
    [anon_sym_co_return] = ACTIONS(2826),
    [anon_sym_co_yield] = ACTIONS(2826),
    [anon_sym_R_DQUOTE] = ACTIONS(2828),
    [anon_sym_LR_DQUOTE] = ACTIONS(2828),
    [anon_sym_uR_DQUOTE] = ACTIONS(2828),
    [anon_sym_UR_DQUOTE] = ACTIONS(2828),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2828),
    [anon_sym_co_await] = ACTIONS(2826),
    [anon_sym_new] = ACTIONS(2826),
    [anon_sym_requires] = ACTIONS(2826),
    [sym_this] = ACTIONS(2826),
  },
  [577] = {
    [sym_identifier] = ACTIONS(2830),
    [aux_sym_preproc_include_token1] = ACTIONS(2830),
    [aux_sym_preproc_def_token1] = ACTIONS(2830),
    [aux_sym_preproc_if_token1] = ACTIONS(2830),
    [aux_sym_preproc_if_token2] = ACTIONS(2830),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2830),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2830),
    [sym_preproc_directive] = ACTIONS(2830),
    [anon_sym_LPAREN2] = ACTIONS(2832),
    [anon_sym_BANG] = ACTIONS(2832),
    [anon_sym_TILDE] = ACTIONS(2832),
    [anon_sym_DASH] = ACTIONS(2830),
    [anon_sym_PLUS] = ACTIONS(2830),
    [anon_sym_STAR] = ACTIONS(2832),
    [anon_sym_AMP_AMP] = ACTIONS(2832),
    [anon_sym_AMP] = ACTIONS(2830),
    [anon_sym_SEMI] = ACTIONS(2832),
    [anon_sym___extension__] = ACTIONS(2830),
    [anon_sym_typedef] = ACTIONS(2830),
    [anon_sym_virtual] = ACTIONS(2830),
    [anon_sym_extern] = ACTIONS(2830),
    [anon_sym___attribute__] = ACTIONS(2830),
    [anon_sym___attribute] = ACTIONS(2830),
    [anon_sym_COLON_COLON] = ACTIONS(2832),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2832),
    [anon_sym___declspec] = ACTIONS(2830),
    [anon_sym___based] = ACTIONS(2830),
    [anon_sym___cdecl] = ACTIONS(2830),
    [anon_sym___clrcall] = ACTIONS(2830),
    [anon_sym___stdcall] = ACTIONS(2830),
    [anon_sym___fastcall] = ACTIONS(2830),
    [anon_sym___thiscall] = ACTIONS(2830),
    [anon_sym___vectorcall] = ACTIONS(2830),
    [anon_sym_LBRACE] = ACTIONS(2832),
    [anon_sym_signed] = ACTIONS(2830),
    [anon_sym_unsigned] = ACTIONS(2830),
    [anon_sym_long] = ACTIONS(2830),
    [anon_sym_short] = ACTIONS(2830),
    [anon_sym_LBRACK] = ACTIONS(2830),
    [anon_sym_static] = ACTIONS(2830),
    [anon_sym_register] = ACTIONS(2830),
    [anon_sym_inline] = ACTIONS(2830),
    [anon_sym___inline] = ACTIONS(2830),
    [anon_sym___inline__] = ACTIONS(2830),
    [anon_sym___forceinline] = ACTIONS(2830),
    [anon_sym_thread_local] = ACTIONS(2830),
    [anon_sym___thread] = ACTIONS(2830),
    [anon_sym_const] = ACTIONS(2830),
    [anon_sym_constexpr] = ACTIONS(2830),
    [anon_sym_volatile] = ACTIONS(2830),
    [anon_sym_restrict] = ACTIONS(2830),
    [anon_sym___restrict__] = ACTIONS(2830),
    [anon_sym__Atomic] = ACTIONS(2830),
    [anon_sym__Noreturn] = ACTIONS(2830),
    [anon_sym_noreturn] = ACTIONS(2830),
    [anon_sym__Nonnull] = ACTIONS(2830),
    [anon_sym_mutable] = ACTIONS(2830),
    [anon_sym_constinit] = ACTIONS(2830),
    [anon_sym_consteval] = ACTIONS(2830),
    [anon_sym_alignas] = ACTIONS(2830),
    [anon_sym__Alignas] = ACTIONS(2830),
    [sym_primitive_type] = ACTIONS(2830),
    [anon_sym_enum] = ACTIONS(2830),
    [anon_sym_class] = ACTIONS(2830),
    [anon_sym_struct] = ACTIONS(2830),
    [anon_sym_union] = ACTIONS(2830),
    [anon_sym_if] = ACTIONS(2830),
    [anon_sym_switch] = ACTIONS(2830),
    [anon_sym_case] = ACTIONS(2830),
    [anon_sym_default] = ACTIONS(2830),
    [anon_sym_while] = ACTIONS(2830),
    [anon_sym_do] = ACTIONS(2830),
    [anon_sym_for] = ACTIONS(2830),
    [anon_sym_return] = ACTIONS(2830),
    [anon_sym_break] = ACTIONS(2830),
    [anon_sym_continue] = ACTIONS(2830),
    [anon_sym_goto] = ACTIONS(2830),
    [anon_sym___try] = ACTIONS(2830),
    [anon_sym___leave] = ACTIONS(2830),
    [anon_sym_not] = ACTIONS(2830),
    [anon_sym_compl] = ACTIONS(2830),
    [anon_sym_DASH_DASH] = ACTIONS(2832),
    [anon_sym_PLUS_PLUS] = ACTIONS(2832),
    [anon_sym_sizeof] = ACTIONS(2830),
    [anon_sym___alignof__] = ACTIONS(2830),
    [anon_sym___alignof] = ACTIONS(2830),
    [anon_sym__alignof] = ACTIONS(2830),
    [anon_sym_alignof] = ACTIONS(2830),
    [anon_sym__Alignof] = ACTIONS(2830),
    [anon_sym_offsetof] = ACTIONS(2830),
    [anon_sym__Generic] = ACTIONS(2830),
    [anon_sym_asm] = ACTIONS(2830),
    [anon_sym___asm__] = ACTIONS(2830),
    [anon_sym___asm] = ACTIONS(2830),
    [sym_number_literal] = ACTIONS(2832),
    [anon_sym_L_SQUOTE] = ACTIONS(2832),
    [anon_sym_u_SQUOTE] = ACTIONS(2832),
    [anon_sym_U_SQUOTE] = ACTIONS(2832),
    [anon_sym_u8_SQUOTE] = ACTIONS(2832),
    [anon_sym_SQUOTE] = ACTIONS(2832),
    [anon_sym_L_DQUOTE] = ACTIONS(2832),
    [anon_sym_u_DQUOTE] = ACTIONS(2832),
    [anon_sym_U_DQUOTE] = ACTIONS(2832),
    [anon_sym_u8_DQUOTE] = ACTIONS(2832),
    [anon_sym_DQUOTE] = ACTIONS(2832),
    [sym_true] = ACTIONS(2830),
    [sym_false] = ACTIONS(2830),
    [anon_sym_NULL] = ACTIONS(2830),
    [anon_sym_nullptr] = ACTIONS(2830),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2830),
    [anon_sym_decltype] = ACTIONS(2830),
    [anon_sym_explicit] = ACTIONS(2830),
    [anon_sym_typename] = ACTIONS(2830),
    [anon_sym_template] = ACTIONS(2830),
    [anon_sym_operator] = ACTIONS(2830),
    [anon_sym_try] = ACTIONS(2830),
    [anon_sym_delete] = ACTIONS(2830),
    [anon_sym_throw] = ACTIONS(2830),
    [anon_sym_namespace] = ACTIONS(2830),
    [anon_sym_using] = ACTIONS(2830),
    [anon_sym_static_assert] = ACTIONS(2830),
    [anon_sym_concept] = ACTIONS(2830),
    [anon_sym_co_return] = ACTIONS(2830),
    [anon_sym_co_yield] = ACTIONS(2830),
    [anon_sym_R_DQUOTE] = ACTIONS(2832),
    [anon_sym_LR_DQUOTE] = ACTIONS(2832),
    [anon_sym_uR_DQUOTE] = ACTIONS(2832),
    [anon_sym_UR_DQUOTE] = ACTIONS(2832),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2832),
    [anon_sym_co_await] = ACTIONS(2830),
    [anon_sym_new] = ACTIONS(2830),
    [anon_sym_requires] = ACTIONS(2830),
    [sym_this] = ACTIONS(2830),
  },
  [578] = {
    [sym_identifier] = ACTIONS(2972),
    [aux_sym_preproc_include_token1] = ACTIONS(2972),
    [aux_sym_preproc_def_token1] = ACTIONS(2972),
    [aux_sym_preproc_if_token1] = ACTIONS(2972),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2972),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2972),
    [sym_preproc_directive] = ACTIONS(2972),
    [anon_sym_LPAREN2] = ACTIONS(2974),
    [anon_sym_BANG] = ACTIONS(2974),
    [anon_sym_TILDE] = ACTIONS(2974),
    [anon_sym_DASH] = ACTIONS(2972),
    [anon_sym_PLUS] = ACTIONS(2972),
    [anon_sym_STAR] = ACTIONS(2974),
    [anon_sym_AMP_AMP] = ACTIONS(2974),
    [anon_sym_AMP] = ACTIONS(2972),
    [anon_sym_SEMI] = ACTIONS(2974),
    [anon_sym___extension__] = ACTIONS(2972),
    [anon_sym_typedef] = ACTIONS(2972),
    [anon_sym_virtual] = ACTIONS(2972),
    [anon_sym_extern] = ACTIONS(2972),
    [anon_sym___attribute__] = ACTIONS(2972),
    [anon_sym___attribute] = ACTIONS(2972),
    [anon_sym_COLON_COLON] = ACTIONS(2974),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2974),
    [anon_sym___declspec] = ACTIONS(2972),
    [anon_sym___based] = ACTIONS(2972),
    [anon_sym___cdecl] = ACTIONS(2972),
    [anon_sym___clrcall] = ACTIONS(2972),
    [anon_sym___stdcall] = ACTIONS(2972),
    [anon_sym___fastcall] = ACTIONS(2972),
    [anon_sym___thiscall] = ACTIONS(2972),
    [anon_sym___vectorcall] = ACTIONS(2972),
    [anon_sym_LBRACE] = ACTIONS(2974),
    [anon_sym_RBRACE] = ACTIONS(2974),
    [anon_sym_signed] = ACTIONS(2972),
    [anon_sym_unsigned] = ACTIONS(2972),
    [anon_sym_long] = ACTIONS(2972),
    [anon_sym_short] = ACTIONS(2972),
    [anon_sym_LBRACK] = ACTIONS(2972),
    [anon_sym_static] = ACTIONS(2972),
    [anon_sym_register] = ACTIONS(2972),
    [anon_sym_inline] = ACTIONS(2972),
    [anon_sym___inline] = ACTIONS(2972),
    [anon_sym___inline__] = ACTIONS(2972),
    [anon_sym___forceinline] = ACTIONS(2972),
    [anon_sym_thread_local] = ACTIONS(2972),
    [anon_sym___thread] = ACTIONS(2972),
    [anon_sym_const] = ACTIONS(2972),
    [anon_sym_constexpr] = ACTIONS(2972),
    [anon_sym_volatile] = ACTIONS(2972),
    [anon_sym_restrict] = ACTIONS(2972),
    [anon_sym___restrict__] = ACTIONS(2972),
    [anon_sym__Atomic] = ACTIONS(2972),
    [anon_sym__Noreturn] = ACTIONS(2972),
    [anon_sym_noreturn] = ACTIONS(2972),
    [anon_sym__Nonnull] = ACTIONS(2972),
    [anon_sym_mutable] = ACTIONS(2972),
    [anon_sym_constinit] = ACTIONS(2972),
    [anon_sym_consteval] = ACTIONS(2972),
    [anon_sym_alignas] = ACTIONS(2972),
    [anon_sym__Alignas] = ACTIONS(2972),
    [sym_primitive_type] = ACTIONS(2972),
    [anon_sym_enum] = ACTIONS(2972),
    [anon_sym_class] = ACTIONS(2972),
    [anon_sym_struct] = ACTIONS(2972),
    [anon_sym_union] = ACTIONS(2972),
    [anon_sym_if] = ACTIONS(2972),
    [anon_sym_switch] = ACTIONS(2972),
    [anon_sym_case] = ACTIONS(2972),
    [anon_sym_default] = ACTIONS(2972),
    [anon_sym_while] = ACTIONS(2972),
    [anon_sym_do] = ACTIONS(2972),
    [anon_sym_for] = ACTIONS(2972),
    [anon_sym_return] = ACTIONS(2972),
    [anon_sym_break] = ACTIONS(2972),
    [anon_sym_continue] = ACTIONS(2972),
    [anon_sym_goto] = ACTIONS(2972),
    [anon_sym___try] = ACTIONS(2972),
    [anon_sym___leave] = ACTIONS(2972),
    [anon_sym_not] = ACTIONS(2972),
    [anon_sym_compl] = ACTIONS(2972),
    [anon_sym_DASH_DASH] = ACTIONS(2974),
    [anon_sym_PLUS_PLUS] = ACTIONS(2974),
    [anon_sym_sizeof] = ACTIONS(2972),
    [anon_sym___alignof__] = ACTIONS(2972),
    [anon_sym___alignof] = ACTIONS(2972),
    [anon_sym__alignof] = ACTIONS(2972),
    [anon_sym_alignof] = ACTIONS(2972),
    [anon_sym__Alignof] = ACTIONS(2972),
    [anon_sym_offsetof] = ACTIONS(2972),
    [anon_sym__Generic] = ACTIONS(2972),
    [anon_sym_asm] = ACTIONS(2972),
    [anon_sym___asm__] = ACTIONS(2972),
    [anon_sym___asm] = ACTIONS(2972),
    [sym_number_literal] = ACTIONS(2974),
    [anon_sym_L_SQUOTE] = ACTIONS(2974),
    [anon_sym_u_SQUOTE] = ACTIONS(2974),
    [anon_sym_U_SQUOTE] = ACTIONS(2974),
    [anon_sym_u8_SQUOTE] = ACTIONS(2974),
    [anon_sym_SQUOTE] = ACTIONS(2974),
    [anon_sym_L_DQUOTE] = ACTIONS(2974),
    [anon_sym_u_DQUOTE] = ACTIONS(2974),
    [anon_sym_U_DQUOTE] = ACTIONS(2974),
    [anon_sym_u8_DQUOTE] = ACTIONS(2974),
    [anon_sym_DQUOTE] = ACTIONS(2974),
    [sym_true] = ACTIONS(2972),
    [sym_false] = ACTIONS(2972),
    [anon_sym_NULL] = ACTIONS(2972),
    [anon_sym_nullptr] = ACTIONS(2972),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2972),
    [anon_sym_decltype] = ACTIONS(2972),
    [anon_sym_explicit] = ACTIONS(2972),
    [anon_sym_typename] = ACTIONS(2972),
    [anon_sym_template] = ACTIONS(2972),
    [anon_sym_operator] = ACTIONS(2972),
    [anon_sym_try] = ACTIONS(2972),
    [anon_sym_delete] = ACTIONS(2972),
    [anon_sym_throw] = ACTIONS(2972),
    [anon_sym_namespace] = ACTIONS(2972),
    [anon_sym_using] = ACTIONS(2972),
    [anon_sym_static_assert] = ACTIONS(2972),
    [anon_sym_concept] = ACTIONS(2972),
    [anon_sym_co_return] = ACTIONS(2972),
    [anon_sym_co_yield] = ACTIONS(2972),
    [anon_sym_R_DQUOTE] = ACTIONS(2974),
    [anon_sym_LR_DQUOTE] = ACTIONS(2974),
    [anon_sym_uR_DQUOTE] = ACTIONS(2974),
    [anon_sym_UR_DQUOTE] = ACTIONS(2974),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2974),
    [anon_sym_co_await] = ACTIONS(2972),
    [anon_sym_new] = ACTIONS(2972),
    [anon_sym_requires] = ACTIONS(2972),
    [sym_this] = ACTIONS(2972),
  },
  [579] = {
    [sym_identifier] = ACTIONS(3038),
    [aux_sym_preproc_include_token1] = ACTIONS(3038),
    [aux_sym_preproc_def_token1] = ACTIONS(3038),
    [aux_sym_preproc_if_token1] = ACTIONS(3038),
    [aux_sym_preproc_if_token2] = ACTIONS(3038),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3038),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3038),
    [sym_preproc_directive] = ACTIONS(3038),
    [anon_sym_LPAREN2] = ACTIONS(3040),
    [anon_sym_BANG] = ACTIONS(3040),
    [anon_sym_TILDE] = ACTIONS(3040),
    [anon_sym_DASH] = ACTIONS(3038),
    [anon_sym_PLUS] = ACTIONS(3038),
    [anon_sym_STAR] = ACTIONS(3040),
    [anon_sym_AMP_AMP] = ACTIONS(3040),
    [anon_sym_AMP] = ACTIONS(3038),
    [anon_sym_SEMI] = ACTIONS(3040),
    [anon_sym___extension__] = ACTIONS(3038),
    [anon_sym_typedef] = ACTIONS(3038),
    [anon_sym_virtual] = ACTIONS(3038),
    [anon_sym_extern] = ACTIONS(3038),
    [anon_sym___attribute__] = ACTIONS(3038),
    [anon_sym___attribute] = ACTIONS(3038),
    [anon_sym_COLON_COLON] = ACTIONS(3040),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3040),
    [anon_sym___declspec] = ACTIONS(3038),
    [anon_sym___based] = ACTIONS(3038),
    [anon_sym___cdecl] = ACTIONS(3038),
    [anon_sym___clrcall] = ACTIONS(3038),
    [anon_sym___stdcall] = ACTIONS(3038),
    [anon_sym___fastcall] = ACTIONS(3038),
    [anon_sym___thiscall] = ACTIONS(3038),
    [anon_sym___vectorcall] = ACTIONS(3038),
    [anon_sym_LBRACE] = ACTIONS(3040),
    [anon_sym_signed] = ACTIONS(3038),
    [anon_sym_unsigned] = ACTIONS(3038),
    [anon_sym_long] = ACTIONS(3038),
    [anon_sym_short] = ACTIONS(3038),
    [anon_sym_LBRACK] = ACTIONS(3038),
    [anon_sym_static] = ACTIONS(3038),
    [anon_sym_register] = ACTIONS(3038),
    [anon_sym_inline] = ACTIONS(3038),
    [anon_sym___inline] = ACTIONS(3038),
    [anon_sym___inline__] = ACTIONS(3038),
    [anon_sym___forceinline] = ACTIONS(3038),
    [anon_sym_thread_local] = ACTIONS(3038),
    [anon_sym___thread] = ACTIONS(3038),
    [anon_sym_const] = ACTIONS(3038),
    [anon_sym_constexpr] = ACTIONS(3038),
    [anon_sym_volatile] = ACTIONS(3038),
    [anon_sym_restrict] = ACTIONS(3038),
    [anon_sym___restrict__] = ACTIONS(3038),
    [anon_sym__Atomic] = ACTIONS(3038),
    [anon_sym__Noreturn] = ACTIONS(3038),
    [anon_sym_noreturn] = ACTIONS(3038),
    [anon_sym__Nonnull] = ACTIONS(3038),
    [anon_sym_mutable] = ACTIONS(3038),
    [anon_sym_constinit] = ACTIONS(3038),
    [anon_sym_consteval] = ACTIONS(3038),
    [anon_sym_alignas] = ACTIONS(3038),
    [anon_sym__Alignas] = ACTIONS(3038),
    [sym_primitive_type] = ACTIONS(3038),
    [anon_sym_enum] = ACTIONS(3038),
    [anon_sym_class] = ACTIONS(3038),
    [anon_sym_struct] = ACTIONS(3038),
    [anon_sym_union] = ACTIONS(3038),
    [anon_sym_if] = ACTIONS(3038),
    [anon_sym_switch] = ACTIONS(3038),
    [anon_sym_case] = ACTIONS(3038),
    [anon_sym_default] = ACTIONS(3038),
    [anon_sym_while] = ACTIONS(3038),
    [anon_sym_do] = ACTIONS(3038),
    [anon_sym_for] = ACTIONS(3038),
    [anon_sym_return] = ACTIONS(3038),
    [anon_sym_break] = ACTIONS(3038),
    [anon_sym_continue] = ACTIONS(3038),
    [anon_sym_goto] = ACTIONS(3038),
    [anon_sym___try] = ACTIONS(3038),
    [anon_sym___leave] = ACTIONS(3038),
    [anon_sym_not] = ACTIONS(3038),
    [anon_sym_compl] = ACTIONS(3038),
    [anon_sym_DASH_DASH] = ACTIONS(3040),
    [anon_sym_PLUS_PLUS] = ACTIONS(3040),
    [anon_sym_sizeof] = ACTIONS(3038),
    [anon_sym___alignof__] = ACTIONS(3038),
    [anon_sym___alignof] = ACTIONS(3038),
    [anon_sym__alignof] = ACTIONS(3038),
    [anon_sym_alignof] = ACTIONS(3038),
    [anon_sym__Alignof] = ACTIONS(3038),
    [anon_sym_offsetof] = ACTIONS(3038),
    [anon_sym__Generic] = ACTIONS(3038),
    [anon_sym_asm] = ACTIONS(3038),
    [anon_sym___asm__] = ACTIONS(3038),
    [anon_sym___asm] = ACTIONS(3038),
    [sym_number_literal] = ACTIONS(3040),
    [anon_sym_L_SQUOTE] = ACTIONS(3040),
    [anon_sym_u_SQUOTE] = ACTIONS(3040),
    [anon_sym_U_SQUOTE] = ACTIONS(3040),
    [anon_sym_u8_SQUOTE] = ACTIONS(3040),
    [anon_sym_SQUOTE] = ACTIONS(3040),
    [anon_sym_L_DQUOTE] = ACTIONS(3040),
    [anon_sym_u_DQUOTE] = ACTIONS(3040),
    [anon_sym_U_DQUOTE] = ACTIONS(3040),
    [anon_sym_u8_DQUOTE] = ACTIONS(3040),
    [anon_sym_DQUOTE] = ACTIONS(3040),
    [sym_true] = ACTIONS(3038),
    [sym_false] = ACTIONS(3038),
    [anon_sym_NULL] = ACTIONS(3038),
    [anon_sym_nullptr] = ACTIONS(3038),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3038),
    [anon_sym_decltype] = ACTIONS(3038),
    [anon_sym_explicit] = ACTIONS(3038),
    [anon_sym_typename] = ACTIONS(3038),
    [anon_sym_template] = ACTIONS(3038),
    [anon_sym_operator] = ACTIONS(3038),
    [anon_sym_try] = ACTIONS(3038),
    [anon_sym_delete] = ACTIONS(3038),
    [anon_sym_throw] = ACTIONS(3038),
    [anon_sym_namespace] = ACTIONS(3038),
    [anon_sym_using] = ACTIONS(3038),
    [anon_sym_static_assert] = ACTIONS(3038),
    [anon_sym_concept] = ACTIONS(3038),
    [anon_sym_co_return] = ACTIONS(3038),
    [anon_sym_co_yield] = ACTIONS(3038),
    [anon_sym_R_DQUOTE] = ACTIONS(3040),
    [anon_sym_LR_DQUOTE] = ACTIONS(3040),
    [anon_sym_uR_DQUOTE] = ACTIONS(3040),
    [anon_sym_UR_DQUOTE] = ACTIONS(3040),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3040),
    [anon_sym_co_await] = ACTIONS(3038),
    [anon_sym_new] = ACTIONS(3038),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3038),
  },
  [580] = {
    [sym_identifier] = ACTIONS(2976),
    [aux_sym_preproc_include_token1] = ACTIONS(2976),
    [aux_sym_preproc_def_token1] = ACTIONS(2976),
    [aux_sym_preproc_if_token1] = ACTIONS(2976),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2976),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2976),
    [sym_preproc_directive] = ACTIONS(2976),
    [anon_sym_LPAREN2] = ACTIONS(2978),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2976),
    [anon_sym_PLUS] = ACTIONS(2976),
    [anon_sym_STAR] = ACTIONS(2978),
    [anon_sym_AMP_AMP] = ACTIONS(2978),
    [anon_sym_AMP] = ACTIONS(2976),
    [anon_sym_SEMI] = ACTIONS(2978),
    [anon_sym___extension__] = ACTIONS(2976),
    [anon_sym_typedef] = ACTIONS(2976),
    [anon_sym_virtual] = ACTIONS(2976),
    [anon_sym_extern] = ACTIONS(2976),
    [anon_sym___attribute__] = ACTIONS(2976),
    [anon_sym___attribute] = ACTIONS(2976),
    [anon_sym_COLON_COLON] = ACTIONS(2978),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2978),
    [anon_sym___declspec] = ACTIONS(2976),
    [anon_sym___based] = ACTIONS(2976),
    [anon_sym___cdecl] = ACTIONS(2976),
    [anon_sym___clrcall] = ACTIONS(2976),
    [anon_sym___stdcall] = ACTIONS(2976),
    [anon_sym___fastcall] = ACTIONS(2976),
    [anon_sym___thiscall] = ACTIONS(2976),
    [anon_sym___vectorcall] = ACTIONS(2976),
    [anon_sym_LBRACE] = ACTIONS(2978),
    [anon_sym_RBRACE] = ACTIONS(2978),
    [anon_sym_signed] = ACTIONS(2976),
    [anon_sym_unsigned] = ACTIONS(2976),
    [anon_sym_long] = ACTIONS(2976),
    [anon_sym_short] = ACTIONS(2976),
    [anon_sym_LBRACK] = ACTIONS(2976),
    [anon_sym_static] = ACTIONS(2976),
    [anon_sym_register] = ACTIONS(2976),
    [anon_sym_inline] = ACTIONS(2976),
    [anon_sym___inline] = ACTIONS(2976),
    [anon_sym___inline__] = ACTIONS(2976),
    [anon_sym___forceinline] = ACTIONS(2976),
    [anon_sym_thread_local] = ACTIONS(2976),
    [anon_sym___thread] = ACTIONS(2976),
    [anon_sym_const] = ACTIONS(2976),
    [anon_sym_constexpr] = ACTIONS(2976),
    [anon_sym_volatile] = ACTIONS(2976),
    [anon_sym_restrict] = ACTIONS(2976),
    [anon_sym___restrict__] = ACTIONS(2976),
    [anon_sym__Atomic] = ACTIONS(2976),
    [anon_sym__Noreturn] = ACTIONS(2976),
    [anon_sym_noreturn] = ACTIONS(2976),
    [anon_sym__Nonnull] = ACTIONS(2976),
    [anon_sym_mutable] = ACTIONS(2976),
    [anon_sym_constinit] = ACTIONS(2976),
    [anon_sym_consteval] = ACTIONS(2976),
    [anon_sym_alignas] = ACTIONS(2976),
    [anon_sym__Alignas] = ACTIONS(2976),
    [sym_primitive_type] = ACTIONS(2976),
    [anon_sym_enum] = ACTIONS(2976),
    [anon_sym_class] = ACTIONS(2976),
    [anon_sym_struct] = ACTIONS(2976),
    [anon_sym_union] = ACTIONS(2976),
    [anon_sym_if] = ACTIONS(2976),
    [anon_sym_switch] = ACTIONS(2976),
    [anon_sym_case] = ACTIONS(2976),
    [anon_sym_default] = ACTIONS(2976),
    [anon_sym_while] = ACTIONS(2976),
    [anon_sym_do] = ACTIONS(2976),
    [anon_sym_for] = ACTIONS(2976),
    [anon_sym_return] = ACTIONS(2976),
    [anon_sym_break] = ACTIONS(2976),
    [anon_sym_continue] = ACTIONS(2976),
    [anon_sym_goto] = ACTIONS(2976),
    [anon_sym___try] = ACTIONS(2976),
    [anon_sym___leave] = ACTIONS(2976),
    [anon_sym_not] = ACTIONS(2976),
    [anon_sym_compl] = ACTIONS(2976),
    [anon_sym_DASH_DASH] = ACTIONS(2978),
    [anon_sym_PLUS_PLUS] = ACTIONS(2978),
    [anon_sym_sizeof] = ACTIONS(2976),
    [anon_sym___alignof__] = ACTIONS(2976),
    [anon_sym___alignof] = ACTIONS(2976),
    [anon_sym__alignof] = ACTIONS(2976),
    [anon_sym_alignof] = ACTIONS(2976),
    [anon_sym__Alignof] = ACTIONS(2976),
    [anon_sym_offsetof] = ACTIONS(2976),
    [anon_sym__Generic] = ACTIONS(2976),
    [anon_sym_asm] = ACTIONS(2976),
    [anon_sym___asm__] = ACTIONS(2976),
    [anon_sym___asm] = ACTIONS(2976),
    [sym_number_literal] = ACTIONS(2978),
    [anon_sym_L_SQUOTE] = ACTIONS(2978),
    [anon_sym_u_SQUOTE] = ACTIONS(2978),
    [anon_sym_U_SQUOTE] = ACTIONS(2978),
    [anon_sym_u8_SQUOTE] = ACTIONS(2978),
    [anon_sym_SQUOTE] = ACTIONS(2978),
    [anon_sym_L_DQUOTE] = ACTIONS(2978),
    [anon_sym_u_DQUOTE] = ACTIONS(2978),
    [anon_sym_U_DQUOTE] = ACTIONS(2978),
    [anon_sym_u8_DQUOTE] = ACTIONS(2978),
    [anon_sym_DQUOTE] = ACTIONS(2978),
    [sym_true] = ACTIONS(2976),
    [sym_false] = ACTIONS(2976),
    [anon_sym_NULL] = ACTIONS(2976),
    [anon_sym_nullptr] = ACTIONS(2976),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2976),
    [anon_sym_decltype] = ACTIONS(2976),
    [anon_sym_explicit] = ACTIONS(2976),
    [anon_sym_typename] = ACTIONS(2976),
    [anon_sym_template] = ACTIONS(2976),
    [anon_sym_operator] = ACTIONS(2976),
    [anon_sym_try] = ACTIONS(2976),
    [anon_sym_delete] = ACTIONS(2976),
    [anon_sym_throw] = ACTIONS(2976),
    [anon_sym_namespace] = ACTIONS(2976),
    [anon_sym_using] = ACTIONS(2976),
    [anon_sym_static_assert] = ACTIONS(2976),
    [anon_sym_concept] = ACTIONS(2976),
    [anon_sym_co_return] = ACTIONS(2976),
    [anon_sym_co_yield] = ACTIONS(2976),
    [anon_sym_R_DQUOTE] = ACTIONS(2978),
    [anon_sym_LR_DQUOTE] = ACTIONS(2978),
    [anon_sym_uR_DQUOTE] = ACTIONS(2978),
    [anon_sym_UR_DQUOTE] = ACTIONS(2978),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2978),
    [anon_sym_co_await] = ACTIONS(2976),
    [anon_sym_new] = ACTIONS(2976),
    [anon_sym_requires] = ACTIONS(2976),
    [sym_this] = ACTIONS(2976),
  },
  [581] = {
    [sym_identifier] = ACTIONS(3150),
    [aux_sym_preproc_include_token1] = ACTIONS(3150),
    [aux_sym_preproc_def_token1] = ACTIONS(3150),
    [aux_sym_preproc_if_token1] = ACTIONS(3150),
    [aux_sym_preproc_if_token2] = ACTIONS(3150),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3150),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3150),
    [sym_preproc_directive] = ACTIONS(3150),
    [anon_sym_LPAREN2] = ACTIONS(3152),
    [anon_sym_BANG] = ACTIONS(3152),
    [anon_sym_TILDE] = ACTIONS(3152),
    [anon_sym_DASH] = ACTIONS(3150),
    [anon_sym_PLUS] = ACTIONS(3150),
    [anon_sym_STAR] = ACTIONS(3152),
    [anon_sym_AMP_AMP] = ACTIONS(3152),
    [anon_sym_AMP] = ACTIONS(3150),
    [anon_sym_SEMI] = ACTIONS(3152),
    [anon_sym___extension__] = ACTIONS(3150),
    [anon_sym_typedef] = ACTIONS(3150),
    [anon_sym_virtual] = ACTIONS(3150),
    [anon_sym_extern] = ACTIONS(3150),
    [anon_sym___attribute__] = ACTIONS(3150),
    [anon_sym___attribute] = ACTIONS(3150),
    [anon_sym_COLON_COLON] = ACTIONS(3152),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3152),
    [anon_sym___declspec] = ACTIONS(3150),
    [anon_sym___based] = ACTIONS(3150),
    [anon_sym___cdecl] = ACTIONS(3150),
    [anon_sym___clrcall] = ACTIONS(3150),
    [anon_sym___stdcall] = ACTIONS(3150),
    [anon_sym___fastcall] = ACTIONS(3150),
    [anon_sym___thiscall] = ACTIONS(3150),
    [anon_sym___vectorcall] = ACTIONS(3150),
    [anon_sym_LBRACE] = ACTIONS(3152),
    [anon_sym_signed] = ACTIONS(3150),
    [anon_sym_unsigned] = ACTIONS(3150),
    [anon_sym_long] = ACTIONS(3150),
    [anon_sym_short] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(3150),
    [anon_sym_static] = ACTIONS(3150),
    [anon_sym_register] = ACTIONS(3150),
    [anon_sym_inline] = ACTIONS(3150),
    [anon_sym___inline] = ACTIONS(3150),
    [anon_sym___inline__] = ACTIONS(3150),
    [anon_sym___forceinline] = ACTIONS(3150),
    [anon_sym_thread_local] = ACTIONS(3150),
    [anon_sym___thread] = ACTIONS(3150),
    [anon_sym_const] = ACTIONS(3150),
    [anon_sym_constexpr] = ACTIONS(3150),
    [anon_sym_volatile] = ACTIONS(3150),
    [anon_sym_restrict] = ACTIONS(3150),
    [anon_sym___restrict__] = ACTIONS(3150),
    [anon_sym__Atomic] = ACTIONS(3150),
    [anon_sym__Noreturn] = ACTIONS(3150),
    [anon_sym_noreturn] = ACTIONS(3150),
    [anon_sym__Nonnull] = ACTIONS(3150),
    [anon_sym_mutable] = ACTIONS(3150),
    [anon_sym_constinit] = ACTIONS(3150),
    [anon_sym_consteval] = ACTIONS(3150),
    [anon_sym_alignas] = ACTIONS(3150),
    [anon_sym__Alignas] = ACTIONS(3150),
    [sym_primitive_type] = ACTIONS(3150),
    [anon_sym_enum] = ACTIONS(3150),
    [anon_sym_class] = ACTIONS(3150),
    [anon_sym_struct] = ACTIONS(3150),
    [anon_sym_union] = ACTIONS(3150),
    [anon_sym_if] = ACTIONS(3150),
    [anon_sym_switch] = ACTIONS(3150),
    [anon_sym_case] = ACTIONS(3150),
    [anon_sym_default] = ACTIONS(3150),
    [anon_sym_while] = ACTIONS(3150),
    [anon_sym_do] = ACTIONS(3150),
    [anon_sym_for] = ACTIONS(3150),
    [anon_sym_return] = ACTIONS(3150),
    [anon_sym_break] = ACTIONS(3150),
    [anon_sym_continue] = ACTIONS(3150),
    [anon_sym_goto] = ACTIONS(3150),
    [anon_sym___try] = ACTIONS(3150),
    [anon_sym___leave] = ACTIONS(3150),
    [anon_sym_not] = ACTIONS(3150),
    [anon_sym_compl] = ACTIONS(3150),
    [anon_sym_DASH_DASH] = ACTIONS(3152),
    [anon_sym_PLUS_PLUS] = ACTIONS(3152),
    [anon_sym_sizeof] = ACTIONS(3150),
    [anon_sym___alignof__] = ACTIONS(3150),
    [anon_sym___alignof] = ACTIONS(3150),
    [anon_sym__alignof] = ACTIONS(3150),
    [anon_sym_alignof] = ACTIONS(3150),
    [anon_sym__Alignof] = ACTIONS(3150),
    [anon_sym_offsetof] = ACTIONS(3150),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3150),
    [anon_sym___asm__] = ACTIONS(3150),
    [anon_sym___asm] = ACTIONS(3150),
    [sym_number_literal] = ACTIONS(3152),
    [anon_sym_L_SQUOTE] = ACTIONS(3152),
    [anon_sym_u_SQUOTE] = ACTIONS(3152),
    [anon_sym_U_SQUOTE] = ACTIONS(3152),
    [anon_sym_u8_SQUOTE] = ACTIONS(3152),
    [anon_sym_SQUOTE] = ACTIONS(3152),
    [anon_sym_L_DQUOTE] = ACTIONS(3152),
    [anon_sym_u_DQUOTE] = ACTIONS(3152),
    [anon_sym_U_DQUOTE] = ACTIONS(3152),
    [anon_sym_u8_DQUOTE] = ACTIONS(3152),
    [anon_sym_DQUOTE] = ACTIONS(3152),
    [sym_true] = ACTIONS(3150),
    [sym_false] = ACTIONS(3150),
    [anon_sym_NULL] = ACTIONS(3150),
    [anon_sym_nullptr] = ACTIONS(3150),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3150),
    [anon_sym_decltype] = ACTIONS(3150),
    [anon_sym_explicit] = ACTIONS(3150),
    [anon_sym_typename] = ACTIONS(3150),
    [anon_sym_template] = ACTIONS(3150),
    [anon_sym_operator] = ACTIONS(3150),
    [anon_sym_try] = ACTIONS(3150),
    [anon_sym_delete] = ACTIONS(3150),
    [anon_sym_throw] = ACTIONS(3150),
    [anon_sym_namespace] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_static_assert] = ACTIONS(3150),
    [anon_sym_concept] = ACTIONS(3150),
    [anon_sym_co_return] = ACTIONS(3150),
    [anon_sym_co_yield] = ACTIONS(3150),
    [anon_sym_R_DQUOTE] = ACTIONS(3152),
    [anon_sym_LR_DQUOTE] = ACTIONS(3152),
    [anon_sym_uR_DQUOTE] = ACTIONS(3152),
    [anon_sym_UR_DQUOTE] = ACTIONS(3152),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3152),
    [anon_sym_co_await] = ACTIONS(3150),
    [anon_sym_new] = ACTIONS(3150),
    [anon_sym_requires] = ACTIONS(3150),
    [sym_this] = ACTIONS(3150),
  },
  [582] = {
    [sym_identifier] = ACTIONS(3104),
    [aux_sym_preproc_include_token1] = ACTIONS(3104),
    [aux_sym_preproc_def_token1] = ACTIONS(3104),
    [aux_sym_preproc_if_token1] = ACTIONS(3104),
    [aux_sym_preproc_if_token2] = ACTIONS(3104),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3104),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3104),
    [sym_preproc_directive] = ACTIONS(3104),
    [anon_sym_LPAREN2] = ACTIONS(3106),
    [anon_sym_BANG] = ACTIONS(3106),
    [anon_sym_TILDE] = ACTIONS(3106),
    [anon_sym_DASH] = ACTIONS(3104),
    [anon_sym_PLUS] = ACTIONS(3104),
    [anon_sym_STAR] = ACTIONS(3106),
    [anon_sym_AMP_AMP] = ACTIONS(3106),
    [anon_sym_AMP] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(3106),
    [anon_sym___extension__] = ACTIONS(3104),
    [anon_sym_typedef] = ACTIONS(3104),
    [anon_sym_virtual] = ACTIONS(3104),
    [anon_sym_extern] = ACTIONS(3104),
    [anon_sym___attribute__] = ACTIONS(3104),
    [anon_sym___attribute] = ACTIONS(3104),
    [anon_sym_COLON_COLON] = ACTIONS(3106),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3106),
    [anon_sym___declspec] = ACTIONS(3104),
    [anon_sym___based] = ACTIONS(3104),
    [anon_sym___cdecl] = ACTIONS(3104),
    [anon_sym___clrcall] = ACTIONS(3104),
    [anon_sym___stdcall] = ACTIONS(3104),
    [anon_sym___fastcall] = ACTIONS(3104),
    [anon_sym___thiscall] = ACTIONS(3104),
    [anon_sym___vectorcall] = ACTIONS(3104),
    [anon_sym_LBRACE] = ACTIONS(3106),
    [anon_sym_signed] = ACTIONS(3104),
    [anon_sym_unsigned] = ACTIONS(3104),
    [anon_sym_long] = ACTIONS(3104),
    [anon_sym_short] = ACTIONS(3104),
    [anon_sym_LBRACK] = ACTIONS(3104),
    [anon_sym_static] = ACTIONS(3104),
    [anon_sym_register] = ACTIONS(3104),
    [anon_sym_inline] = ACTIONS(3104),
    [anon_sym___inline] = ACTIONS(3104),
    [anon_sym___inline__] = ACTIONS(3104),
    [anon_sym___forceinline] = ACTIONS(3104),
    [anon_sym_thread_local] = ACTIONS(3104),
    [anon_sym___thread] = ACTIONS(3104),
    [anon_sym_const] = ACTIONS(3104),
    [anon_sym_constexpr] = ACTIONS(3104),
    [anon_sym_volatile] = ACTIONS(3104),
    [anon_sym_restrict] = ACTIONS(3104),
    [anon_sym___restrict__] = ACTIONS(3104),
    [anon_sym__Atomic] = ACTIONS(3104),
    [anon_sym__Noreturn] = ACTIONS(3104),
    [anon_sym_noreturn] = ACTIONS(3104),
    [anon_sym__Nonnull] = ACTIONS(3104),
    [anon_sym_mutable] = ACTIONS(3104),
    [anon_sym_constinit] = ACTIONS(3104),
    [anon_sym_consteval] = ACTIONS(3104),
    [anon_sym_alignas] = ACTIONS(3104),
    [anon_sym__Alignas] = ACTIONS(3104),
    [sym_primitive_type] = ACTIONS(3104),
    [anon_sym_enum] = ACTIONS(3104),
    [anon_sym_class] = ACTIONS(3104),
    [anon_sym_struct] = ACTIONS(3104),
    [anon_sym_union] = ACTIONS(3104),
    [anon_sym_if] = ACTIONS(3104),
    [anon_sym_switch] = ACTIONS(3104),
    [anon_sym_case] = ACTIONS(3104),
    [anon_sym_default] = ACTIONS(3104),
    [anon_sym_while] = ACTIONS(3104),
    [anon_sym_do] = ACTIONS(3104),
    [anon_sym_for] = ACTIONS(3104),
    [anon_sym_return] = ACTIONS(3104),
    [anon_sym_break] = ACTIONS(3104),
    [anon_sym_continue] = ACTIONS(3104),
    [anon_sym_goto] = ACTIONS(3104),
    [anon_sym___try] = ACTIONS(3104),
    [anon_sym___leave] = ACTIONS(3104),
    [anon_sym_not] = ACTIONS(3104),
    [anon_sym_compl] = ACTIONS(3104),
    [anon_sym_DASH_DASH] = ACTIONS(3106),
    [anon_sym_PLUS_PLUS] = ACTIONS(3106),
    [anon_sym_sizeof] = ACTIONS(3104),
    [anon_sym___alignof__] = ACTIONS(3104),
    [anon_sym___alignof] = ACTIONS(3104),
    [anon_sym__alignof] = ACTIONS(3104),
    [anon_sym_alignof] = ACTIONS(3104),
    [anon_sym__Alignof] = ACTIONS(3104),
    [anon_sym_offsetof] = ACTIONS(3104),
    [anon_sym__Generic] = ACTIONS(3104),
    [anon_sym_asm] = ACTIONS(3104),
    [anon_sym___asm__] = ACTIONS(3104),
    [anon_sym___asm] = ACTIONS(3104),
    [sym_number_literal] = ACTIONS(3106),
    [anon_sym_L_SQUOTE] = ACTIONS(3106),
    [anon_sym_u_SQUOTE] = ACTIONS(3106),
    [anon_sym_U_SQUOTE] = ACTIONS(3106),
    [anon_sym_u8_SQUOTE] = ACTIONS(3106),
    [anon_sym_SQUOTE] = ACTIONS(3106),
    [anon_sym_L_DQUOTE] = ACTIONS(3106),
    [anon_sym_u_DQUOTE] = ACTIONS(3106),
    [anon_sym_U_DQUOTE] = ACTIONS(3106),
    [anon_sym_u8_DQUOTE] = ACTIONS(3106),
    [anon_sym_DQUOTE] = ACTIONS(3106),
    [sym_true] = ACTIONS(3104),
    [sym_false] = ACTIONS(3104),
    [anon_sym_NULL] = ACTIONS(3104),
    [anon_sym_nullptr] = ACTIONS(3104),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3104),
    [anon_sym_decltype] = ACTIONS(3104),
    [anon_sym_explicit] = ACTIONS(3104),
    [anon_sym_typename] = ACTIONS(3104),
    [anon_sym_template] = ACTIONS(3104),
    [anon_sym_operator] = ACTIONS(3104),
    [anon_sym_try] = ACTIONS(3104),
    [anon_sym_delete] = ACTIONS(3104),
    [anon_sym_throw] = ACTIONS(3104),
    [anon_sym_namespace] = ACTIONS(3104),
    [anon_sym_using] = ACTIONS(3104),
    [anon_sym_static_assert] = ACTIONS(3104),
    [anon_sym_concept] = ACTIONS(3104),
    [anon_sym_co_return] = ACTIONS(3104),
    [anon_sym_co_yield] = ACTIONS(3104),
    [anon_sym_R_DQUOTE] = ACTIONS(3106),
    [anon_sym_LR_DQUOTE] = ACTIONS(3106),
    [anon_sym_uR_DQUOTE] = ACTIONS(3106),
    [anon_sym_UR_DQUOTE] = ACTIONS(3106),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3106),
    [anon_sym_co_await] = ACTIONS(3104),
    [anon_sym_new] = ACTIONS(3104),
    [anon_sym_requires] = ACTIONS(3104),
    [sym_this] = ACTIONS(3104),
  },
  [583] = {
    [sym_identifier] = ACTIONS(2771),
    [aux_sym_preproc_include_token1] = ACTIONS(2771),
    [aux_sym_preproc_def_token1] = ACTIONS(2771),
    [aux_sym_preproc_if_token1] = ACTIONS(2771),
    [aux_sym_preproc_if_token2] = ACTIONS(2771),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2771),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2771),
    [sym_preproc_directive] = ACTIONS(2771),
    [anon_sym_LPAREN2] = ACTIONS(2773),
    [anon_sym_BANG] = ACTIONS(2773),
    [anon_sym_TILDE] = ACTIONS(2773),
    [anon_sym_DASH] = ACTIONS(2771),
    [anon_sym_PLUS] = ACTIONS(2771),
    [anon_sym_STAR] = ACTIONS(2773),
    [anon_sym_AMP_AMP] = ACTIONS(2773),
    [anon_sym_AMP] = ACTIONS(2771),
    [anon_sym_SEMI] = ACTIONS(2773),
    [anon_sym___extension__] = ACTIONS(2771),
    [anon_sym_typedef] = ACTIONS(2771),
    [anon_sym_virtual] = ACTIONS(2771),
    [anon_sym_extern] = ACTIONS(2771),
    [anon_sym___attribute__] = ACTIONS(2771),
    [anon_sym___attribute] = ACTIONS(2771),
    [anon_sym_COLON_COLON] = ACTIONS(2773),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2773),
    [anon_sym___declspec] = ACTIONS(2771),
    [anon_sym___based] = ACTIONS(2771),
    [anon_sym___cdecl] = ACTIONS(2771),
    [anon_sym___clrcall] = ACTIONS(2771),
    [anon_sym___stdcall] = ACTIONS(2771),
    [anon_sym___fastcall] = ACTIONS(2771),
    [anon_sym___thiscall] = ACTIONS(2771),
    [anon_sym___vectorcall] = ACTIONS(2771),
    [anon_sym_LBRACE] = ACTIONS(2773),
    [anon_sym_signed] = ACTIONS(2771),
    [anon_sym_unsigned] = ACTIONS(2771),
    [anon_sym_long] = ACTIONS(2771),
    [anon_sym_short] = ACTIONS(2771),
    [anon_sym_LBRACK] = ACTIONS(2771),
    [anon_sym_static] = ACTIONS(2771),
    [anon_sym_register] = ACTIONS(2771),
    [anon_sym_inline] = ACTIONS(2771),
    [anon_sym___inline] = ACTIONS(2771),
    [anon_sym___inline__] = ACTIONS(2771),
    [anon_sym___forceinline] = ACTIONS(2771),
    [anon_sym_thread_local] = ACTIONS(2771),
    [anon_sym___thread] = ACTIONS(2771),
    [anon_sym_const] = ACTIONS(2771),
    [anon_sym_constexpr] = ACTIONS(2771),
    [anon_sym_volatile] = ACTIONS(2771),
    [anon_sym_restrict] = ACTIONS(2771),
    [anon_sym___restrict__] = ACTIONS(2771),
    [anon_sym__Atomic] = ACTIONS(2771),
    [anon_sym__Noreturn] = ACTIONS(2771),
    [anon_sym_noreturn] = ACTIONS(2771),
    [anon_sym__Nonnull] = ACTIONS(2771),
    [anon_sym_mutable] = ACTIONS(2771),
    [anon_sym_constinit] = ACTIONS(2771),
    [anon_sym_consteval] = ACTIONS(2771),
    [anon_sym_alignas] = ACTIONS(2771),
    [anon_sym__Alignas] = ACTIONS(2771),
    [sym_primitive_type] = ACTIONS(2771),
    [anon_sym_enum] = ACTIONS(2771),
    [anon_sym_class] = ACTIONS(2771),
    [anon_sym_struct] = ACTIONS(2771),
    [anon_sym_union] = ACTIONS(2771),
    [anon_sym_if] = ACTIONS(2771),
    [anon_sym_switch] = ACTIONS(2771),
    [anon_sym_case] = ACTIONS(2771),
    [anon_sym_default] = ACTIONS(2771),
    [anon_sym_while] = ACTIONS(2771),
    [anon_sym_do] = ACTIONS(2771),
    [anon_sym_for] = ACTIONS(2771),
    [anon_sym_return] = ACTIONS(2771),
    [anon_sym_break] = ACTIONS(2771),
    [anon_sym_continue] = ACTIONS(2771),
    [anon_sym_goto] = ACTIONS(2771),
    [anon_sym___try] = ACTIONS(2771),
    [anon_sym___leave] = ACTIONS(2771),
    [anon_sym_not] = ACTIONS(2771),
    [anon_sym_compl] = ACTIONS(2771),
    [anon_sym_DASH_DASH] = ACTIONS(2773),
    [anon_sym_PLUS_PLUS] = ACTIONS(2773),
    [anon_sym_sizeof] = ACTIONS(2771),
    [anon_sym___alignof__] = ACTIONS(2771),
    [anon_sym___alignof] = ACTIONS(2771),
    [anon_sym__alignof] = ACTIONS(2771),
    [anon_sym_alignof] = ACTIONS(2771),
    [anon_sym__Alignof] = ACTIONS(2771),
    [anon_sym_offsetof] = ACTIONS(2771),
    [anon_sym__Generic] = ACTIONS(2771),
    [anon_sym_asm] = ACTIONS(2771),
    [anon_sym___asm__] = ACTIONS(2771),
    [anon_sym___asm] = ACTIONS(2771),
    [sym_number_literal] = ACTIONS(2773),
    [anon_sym_L_SQUOTE] = ACTIONS(2773),
    [anon_sym_u_SQUOTE] = ACTIONS(2773),
    [anon_sym_U_SQUOTE] = ACTIONS(2773),
    [anon_sym_u8_SQUOTE] = ACTIONS(2773),
    [anon_sym_SQUOTE] = ACTIONS(2773),
    [anon_sym_L_DQUOTE] = ACTIONS(2773),
    [anon_sym_u_DQUOTE] = ACTIONS(2773),
    [anon_sym_U_DQUOTE] = ACTIONS(2773),
    [anon_sym_u8_DQUOTE] = ACTIONS(2773),
    [anon_sym_DQUOTE] = ACTIONS(2773),
    [sym_true] = ACTIONS(2771),
    [sym_false] = ACTIONS(2771),
    [anon_sym_NULL] = ACTIONS(2771),
    [anon_sym_nullptr] = ACTIONS(2771),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2771),
    [anon_sym_decltype] = ACTIONS(2771),
    [anon_sym_explicit] = ACTIONS(2771),
    [anon_sym_typename] = ACTIONS(2771),
    [anon_sym_template] = ACTIONS(2771),
    [anon_sym_operator] = ACTIONS(2771),
    [anon_sym_try] = ACTIONS(2771),
    [anon_sym_delete] = ACTIONS(2771),
    [anon_sym_throw] = ACTIONS(2771),
    [anon_sym_namespace] = ACTIONS(2771),
    [anon_sym_using] = ACTIONS(2771),
    [anon_sym_static_assert] = ACTIONS(2771),
    [anon_sym_concept] = ACTIONS(2771),
    [anon_sym_co_return] = ACTIONS(2771),
    [anon_sym_co_yield] = ACTIONS(2771),
    [anon_sym_R_DQUOTE] = ACTIONS(2773),
    [anon_sym_LR_DQUOTE] = ACTIONS(2773),
    [anon_sym_uR_DQUOTE] = ACTIONS(2773),
    [anon_sym_UR_DQUOTE] = ACTIONS(2773),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2773),
    [anon_sym_co_await] = ACTIONS(2771),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2771),
    [sym_this] = ACTIONS(2771),
  },
  [584] = {
    [sym_identifier] = ACTIONS(2759),
    [aux_sym_preproc_include_token1] = ACTIONS(2759),
    [aux_sym_preproc_def_token1] = ACTIONS(2759),
    [aux_sym_preproc_if_token1] = ACTIONS(2759),
    [aux_sym_preproc_if_token2] = ACTIONS(2759),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2759),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2759),
    [sym_preproc_directive] = ACTIONS(2759),
    [anon_sym_LPAREN2] = ACTIONS(2761),
    [anon_sym_BANG] = ACTIONS(2761),
    [anon_sym_TILDE] = ACTIONS(2761),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_STAR] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2759),
    [anon_sym_SEMI] = ACTIONS(2761),
    [anon_sym___extension__] = ACTIONS(2759),
    [anon_sym_typedef] = ACTIONS(2759),
    [anon_sym_virtual] = ACTIONS(2759),
    [anon_sym_extern] = ACTIONS(2759),
    [anon_sym___attribute__] = ACTIONS(2759),
    [anon_sym___attribute] = ACTIONS(2759),
    [anon_sym_COLON_COLON] = ACTIONS(2761),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2761),
    [anon_sym___declspec] = ACTIONS(2759),
    [anon_sym___based] = ACTIONS(2759),
    [anon_sym___cdecl] = ACTIONS(2759),
    [anon_sym___clrcall] = ACTIONS(2759),
    [anon_sym___stdcall] = ACTIONS(2759),
    [anon_sym___fastcall] = ACTIONS(2759),
    [anon_sym___thiscall] = ACTIONS(2759),
    [anon_sym___vectorcall] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_signed] = ACTIONS(2759),
    [anon_sym_unsigned] = ACTIONS(2759),
    [anon_sym_long] = ACTIONS(2759),
    [anon_sym_short] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_static] = ACTIONS(2759),
    [anon_sym_register] = ACTIONS(2759),
    [anon_sym_inline] = ACTIONS(2759),
    [anon_sym___inline] = ACTIONS(2759),
    [anon_sym___inline__] = ACTIONS(2759),
    [anon_sym___forceinline] = ACTIONS(2759),
    [anon_sym_thread_local] = ACTIONS(2759),
    [anon_sym___thread] = ACTIONS(2759),
    [anon_sym_const] = ACTIONS(2759),
    [anon_sym_constexpr] = ACTIONS(2759),
    [anon_sym_volatile] = ACTIONS(2759),
    [anon_sym_restrict] = ACTIONS(2759),
    [anon_sym___restrict__] = ACTIONS(2759),
    [anon_sym__Atomic] = ACTIONS(2759),
    [anon_sym__Noreturn] = ACTIONS(2759),
    [anon_sym_noreturn] = ACTIONS(2759),
    [anon_sym__Nonnull] = ACTIONS(2759),
    [anon_sym_mutable] = ACTIONS(2759),
    [anon_sym_constinit] = ACTIONS(2759),
    [anon_sym_consteval] = ACTIONS(2759),
    [anon_sym_alignas] = ACTIONS(2759),
    [anon_sym__Alignas] = ACTIONS(2759),
    [sym_primitive_type] = ACTIONS(2759),
    [anon_sym_enum] = ACTIONS(2759),
    [anon_sym_class] = ACTIONS(2759),
    [anon_sym_struct] = ACTIONS(2759),
    [anon_sym_union] = ACTIONS(2759),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_switch] = ACTIONS(2759),
    [anon_sym_case] = ACTIONS(2759),
    [anon_sym_default] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_for] = ACTIONS(2759),
    [anon_sym_return] = ACTIONS(2759),
    [anon_sym_break] = ACTIONS(2759),
    [anon_sym_continue] = ACTIONS(2759),
    [anon_sym_goto] = ACTIONS(2759),
    [anon_sym___try] = ACTIONS(2759),
    [anon_sym___leave] = ACTIONS(2759),
    [anon_sym_not] = ACTIONS(2759),
    [anon_sym_compl] = ACTIONS(2759),
    [anon_sym_DASH_DASH] = ACTIONS(2761),
    [anon_sym_PLUS_PLUS] = ACTIONS(2761),
    [anon_sym_sizeof] = ACTIONS(2759),
    [anon_sym___alignof__] = ACTIONS(2759),
    [anon_sym___alignof] = ACTIONS(2759),
    [anon_sym__alignof] = ACTIONS(2759),
    [anon_sym_alignof] = ACTIONS(2759),
    [anon_sym__Alignof] = ACTIONS(2759),
    [anon_sym_offsetof] = ACTIONS(2759),
    [anon_sym__Generic] = ACTIONS(2759),
    [anon_sym_asm] = ACTIONS(2759),
    [anon_sym___asm__] = ACTIONS(2759),
    [anon_sym___asm] = ACTIONS(2759),
    [sym_number_literal] = ACTIONS(2761),
    [anon_sym_L_SQUOTE] = ACTIONS(2761),
    [anon_sym_u_SQUOTE] = ACTIONS(2761),
    [anon_sym_U_SQUOTE] = ACTIONS(2761),
    [anon_sym_u8_SQUOTE] = ACTIONS(2761),
    [anon_sym_SQUOTE] = ACTIONS(2761),
    [anon_sym_L_DQUOTE] = ACTIONS(2761),
    [anon_sym_u_DQUOTE] = ACTIONS(2761),
    [anon_sym_U_DQUOTE] = ACTIONS(2761),
    [anon_sym_u8_DQUOTE] = ACTIONS(2761),
    [anon_sym_DQUOTE] = ACTIONS(2761),
    [sym_true] = ACTIONS(2759),
    [sym_false] = ACTIONS(2759),
    [anon_sym_NULL] = ACTIONS(2759),
    [anon_sym_nullptr] = ACTIONS(2759),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2759),
    [anon_sym_decltype] = ACTIONS(2759),
    [anon_sym_explicit] = ACTIONS(2759),
    [anon_sym_typename] = ACTIONS(2759),
    [anon_sym_template] = ACTIONS(2759),
    [anon_sym_operator] = ACTIONS(2759),
    [anon_sym_try] = ACTIONS(2759),
    [anon_sym_delete] = ACTIONS(2759),
    [anon_sym_throw] = ACTIONS(2759),
    [anon_sym_namespace] = ACTIONS(2759),
    [anon_sym_using] = ACTIONS(2759),
    [anon_sym_static_assert] = ACTIONS(2759),
    [anon_sym_concept] = ACTIONS(2759),
    [anon_sym_co_return] = ACTIONS(2759),
    [anon_sym_co_yield] = ACTIONS(2759),
    [anon_sym_R_DQUOTE] = ACTIONS(2761),
    [anon_sym_LR_DQUOTE] = ACTIONS(2761),
    [anon_sym_uR_DQUOTE] = ACTIONS(2761),
    [anon_sym_UR_DQUOTE] = ACTIONS(2761),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2761),
    [anon_sym_co_await] = ACTIONS(2759),
    [anon_sym_new] = ACTIONS(2759),
    [anon_sym_requires] = ACTIONS(2759),
    [sym_this] = ACTIONS(2759),
  },
  [585] = {
    [sym_identifier] = ACTIONS(2727),
    [aux_sym_preproc_include_token1] = ACTIONS(2727),
    [aux_sym_preproc_def_token1] = ACTIONS(2727),
    [aux_sym_preproc_if_token1] = ACTIONS(2727),
    [aux_sym_preproc_if_token2] = ACTIONS(2727),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2727),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2727),
    [sym_preproc_directive] = ACTIONS(2727),
    [anon_sym_LPAREN2] = ACTIONS(2729),
    [anon_sym_BANG] = ACTIONS(2729),
    [anon_sym_TILDE] = ACTIONS(2729),
    [anon_sym_DASH] = ACTIONS(2727),
    [anon_sym_PLUS] = ACTIONS(2727),
    [anon_sym_STAR] = ACTIONS(2729),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_AMP] = ACTIONS(2727),
    [anon_sym_SEMI] = ACTIONS(2729),
    [anon_sym___extension__] = ACTIONS(2727),
    [anon_sym_typedef] = ACTIONS(2727),
    [anon_sym_virtual] = ACTIONS(2727),
    [anon_sym_extern] = ACTIONS(2727),
    [anon_sym___attribute__] = ACTIONS(2727),
    [anon_sym___attribute] = ACTIONS(2727),
    [anon_sym_COLON_COLON] = ACTIONS(2729),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2729),
    [anon_sym___declspec] = ACTIONS(2727),
    [anon_sym___based] = ACTIONS(2727),
    [anon_sym___cdecl] = ACTIONS(2727),
    [anon_sym___clrcall] = ACTIONS(2727),
    [anon_sym___stdcall] = ACTIONS(2727),
    [anon_sym___fastcall] = ACTIONS(2727),
    [anon_sym___thiscall] = ACTIONS(2727),
    [anon_sym___vectorcall] = ACTIONS(2727),
    [anon_sym_LBRACE] = ACTIONS(2729),
    [anon_sym_signed] = ACTIONS(2727),
    [anon_sym_unsigned] = ACTIONS(2727),
    [anon_sym_long] = ACTIONS(2727),
    [anon_sym_short] = ACTIONS(2727),
    [anon_sym_LBRACK] = ACTIONS(2727),
    [anon_sym_static] = ACTIONS(2727),
    [anon_sym_register] = ACTIONS(2727),
    [anon_sym_inline] = ACTIONS(2727),
    [anon_sym___inline] = ACTIONS(2727),
    [anon_sym___inline__] = ACTIONS(2727),
    [anon_sym___forceinline] = ACTIONS(2727),
    [anon_sym_thread_local] = ACTIONS(2727),
    [anon_sym___thread] = ACTIONS(2727),
    [anon_sym_const] = ACTIONS(2727),
    [anon_sym_constexpr] = ACTIONS(2727),
    [anon_sym_volatile] = ACTIONS(2727),
    [anon_sym_restrict] = ACTIONS(2727),
    [anon_sym___restrict__] = ACTIONS(2727),
    [anon_sym__Atomic] = ACTIONS(2727),
    [anon_sym__Noreturn] = ACTIONS(2727),
    [anon_sym_noreturn] = ACTIONS(2727),
    [anon_sym__Nonnull] = ACTIONS(2727),
    [anon_sym_mutable] = ACTIONS(2727),
    [anon_sym_constinit] = ACTIONS(2727),
    [anon_sym_consteval] = ACTIONS(2727),
    [anon_sym_alignas] = ACTIONS(2727),
    [anon_sym__Alignas] = ACTIONS(2727),
    [sym_primitive_type] = ACTIONS(2727),
    [anon_sym_enum] = ACTIONS(2727),
    [anon_sym_class] = ACTIONS(2727),
    [anon_sym_struct] = ACTIONS(2727),
    [anon_sym_union] = ACTIONS(2727),
    [anon_sym_if] = ACTIONS(2727),
    [anon_sym_switch] = ACTIONS(2727),
    [anon_sym_case] = ACTIONS(2727),
    [anon_sym_default] = ACTIONS(2727),
    [anon_sym_while] = ACTIONS(2727),
    [anon_sym_do] = ACTIONS(2727),
    [anon_sym_for] = ACTIONS(2727),
    [anon_sym_return] = ACTIONS(2727),
    [anon_sym_break] = ACTIONS(2727),
    [anon_sym_continue] = ACTIONS(2727),
    [anon_sym_goto] = ACTIONS(2727),
    [anon_sym___try] = ACTIONS(2727),
    [anon_sym___leave] = ACTIONS(2727),
    [anon_sym_not] = ACTIONS(2727),
    [anon_sym_compl] = ACTIONS(2727),
    [anon_sym_DASH_DASH] = ACTIONS(2729),
    [anon_sym_PLUS_PLUS] = ACTIONS(2729),
    [anon_sym_sizeof] = ACTIONS(2727),
    [anon_sym___alignof__] = ACTIONS(2727),
    [anon_sym___alignof] = ACTIONS(2727),
    [anon_sym__alignof] = ACTIONS(2727),
    [anon_sym_alignof] = ACTIONS(2727),
    [anon_sym__Alignof] = ACTIONS(2727),
    [anon_sym_offsetof] = ACTIONS(2727),
    [anon_sym__Generic] = ACTIONS(2727),
    [anon_sym_asm] = ACTIONS(2727),
    [anon_sym___asm__] = ACTIONS(2727),
    [anon_sym___asm] = ACTIONS(2727),
    [sym_number_literal] = ACTIONS(2729),
    [anon_sym_L_SQUOTE] = ACTIONS(2729),
    [anon_sym_u_SQUOTE] = ACTIONS(2729),
    [anon_sym_U_SQUOTE] = ACTIONS(2729),
    [anon_sym_u8_SQUOTE] = ACTIONS(2729),
    [anon_sym_SQUOTE] = ACTIONS(2729),
    [anon_sym_L_DQUOTE] = ACTIONS(2729),
    [anon_sym_u_DQUOTE] = ACTIONS(2729),
    [anon_sym_U_DQUOTE] = ACTIONS(2729),
    [anon_sym_u8_DQUOTE] = ACTIONS(2729),
    [anon_sym_DQUOTE] = ACTIONS(2729),
    [sym_true] = ACTIONS(2727),
    [sym_false] = ACTIONS(2727),
    [anon_sym_NULL] = ACTIONS(2727),
    [anon_sym_nullptr] = ACTIONS(2727),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2727),
    [anon_sym_decltype] = ACTIONS(2727),
    [anon_sym_explicit] = ACTIONS(2727),
    [anon_sym_typename] = ACTIONS(2727),
    [anon_sym_template] = ACTIONS(2727),
    [anon_sym_operator] = ACTIONS(2727),
    [anon_sym_try] = ACTIONS(2727),
    [anon_sym_delete] = ACTIONS(2727),
    [anon_sym_throw] = ACTIONS(2727),
    [anon_sym_namespace] = ACTIONS(2727),
    [anon_sym_using] = ACTIONS(2727),
    [anon_sym_static_assert] = ACTIONS(2727),
    [anon_sym_concept] = ACTIONS(2727),
    [anon_sym_co_return] = ACTIONS(2727),
    [anon_sym_co_yield] = ACTIONS(2727),
    [anon_sym_R_DQUOTE] = ACTIONS(2729),
    [anon_sym_LR_DQUOTE] = ACTIONS(2729),
    [anon_sym_uR_DQUOTE] = ACTIONS(2729),
    [anon_sym_UR_DQUOTE] = ACTIONS(2729),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2729),
    [anon_sym_co_await] = ACTIONS(2727),
    [anon_sym_new] = ACTIONS(2727),
    [anon_sym_requires] = ACTIONS(2727),
    [sym_this] = ACTIONS(2727),
  },
  [586] = {
    [sym_identifier] = ACTIONS(2964),
    [aux_sym_preproc_include_token1] = ACTIONS(2964),
    [aux_sym_preproc_def_token1] = ACTIONS(2964),
    [aux_sym_preproc_if_token1] = ACTIONS(2964),
    [aux_sym_preproc_if_token2] = ACTIONS(2964),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2964),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2964),
    [sym_preproc_directive] = ACTIONS(2964),
    [anon_sym_LPAREN2] = ACTIONS(2966),
    [anon_sym_BANG] = ACTIONS(2966),
    [anon_sym_TILDE] = ACTIONS(2966),
    [anon_sym_DASH] = ACTIONS(2964),
    [anon_sym_PLUS] = ACTIONS(2964),
    [anon_sym_STAR] = ACTIONS(2966),
    [anon_sym_AMP_AMP] = ACTIONS(2966),
    [anon_sym_AMP] = ACTIONS(2964),
    [anon_sym_SEMI] = ACTIONS(2966),
    [anon_sym___extension__] = ACTIONS(2964),
    [anon_sym_typedef] = ACTIONS(2964),
    [anon_sym_virtual] = ACTIONS(2964),
    [anon_sym_extern] = ACTIONS(2964),
    [anon_sym___attribute__] = ACTIONS(2964),
    [anon_sym___attribute] = ACTIONS(2964),
    [anon_sym_COLON_COLON] = ACTIONS(2966),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2966),
    [anon_sym___declspec] = ACTIONS(2964),
    [anon_sym___based] = ACTIONS(2964),
    [anon_sym___cdecl] = ACTIONS(2964),
    [anon_sym___clrcall] = ACTIONS(2964),
    [anon_sym___stdcall] = ACTIONS(2964),
    [anon_sym___fastcall] = ACTIONS(2964),
    [anon_sym___thiscall] = ACTIONS(2964),
    [anon_sym___vectorcall] = ACTIONS(2964),
    [anon_sym_LBRACE] = ACTIONS(2966),
    [anon_sym_signed] = ACTIONS(2964),
    [anon_sym_unsigned] = ACTIONS(2964),
    [anon_sym_long] = ACTIONS(2964),
    [anon_sym_short] = ACTIONS(2964),
    [anon_sym_LBRACK] = ACTIONS(2964),
    [anon_sym_static] = ACTIONS(2964),
    [anon_sym_register] = ACTIONS(2964),
    [anon_sym_inline] = ACTIONS(2964),
    [anon_sym___inline] = ACTIONS(2964),
    [anon_sym___inline__] = ACTIONS(2964),
    [anon_sym___forceinline] = ACTIONS(2964),
    [anon_sym_thread_local] = ACTIONS(2964),
    [anon_sym___thread] = ACTIONS(2964),
    [anon_sym_const] = ACTIONS(2964),
    [anon_sym_constexpr] = ACTIONS(2964),
    [anon_sym_volatile] = ACTIONS(2964),
    [anon_sym_restrict] = ACTIONS(2964),
    [anon_sym___restrict__] = ACTIONS(2964),
    [anon_sym__Atomic] = ACTIONS(2964),
    [anon_sym__Noreturn] = ACTIONS(2964),
    [anon_sym_noreturn] = ACTIONS(2964),
    [anon_sym__Nonnull] = ACTIONS(2964),
    [anon_sym_mutable] = ACTIONS(2964),
    [anon_sym_constinit] = ACTIONS(2964),
    [anon_sym_consteval] = ACTIONS(2964),
    [anon_sym_alignas] = ACTIONS(2964),
    [anon_sym__Alignas] = ACTIONS(2964),
    [sym_primitive_type] = ACTIONS(2964),
    [anon_sym_enum] = ACTIONS(2964),
    [anon_sym_class] = ACTIONS(2964),
    [anon_sym_struct] = ACTIONS(2964),
    [anon_sym_union] = ACTIONS(2964),
    [anon_sym_if] = ACTIONS(2964),
    [anon_sym_switch] = ACTIONS(2964),
    [anon_sym_case] = ACTIONS(2964),
    [anon_sym_default] = ACTIONS(2964),
    [anon_sym_while] = ACTIONS(2964),
    [anon_sym_do] = ACTIONS(2964),
    [anon_sym_for] = ACTIONS(2964),
    [anon_sym_return] = ACTIONS(2964),
    [anon_sym_break] = ACTIONS(2964),
    [anon_sym_continue] = ACTIONS(2964),
    [anon_sym_goto] = ACTIONS(2964),
    [anon_sym___try] = ACTIONS(2964),
    [anon_sym___leave] = ACTIONS(2964),
    [anon_sym_not] = ACTIONS(2964),
    [anon_sym_compl] = ACTIONS(2964),
    [anon_sym_DASH_DASH] = ACTIONS(2966),
    [anon_sym_PLUS_PLUS] = ACTIONS(2966),
    [anon_sym_sizeof] = ACTIONS(2964),
    [anon_sym___alignof__] = ACTIONS(2964),
    [anon_sym___alignof] = ACTIONS(2964),
    [anon_sym__alignof] = ACTIONS(2964),
    [anon_sym_alignof] = ACTIONS(2964),
    [anon_sym__Alignof] = ACTIONS(2964),
    [anon_sym_offsetof] = ACTIONS(2964),
    [anon_sym__Generic] = ACTIONS(2964),
    [anon_sym_asm] = ACTIONS(2964),
    [anon_sym___asm__] = ACTIONS(2964),
    [anon_sym___asm] = ACTIONS(2964),
    [sym_number_literal] = ACTIONS(2966),
    [anon_sym_L_SQUOTE] = ACTIONS(2966),
    [anon_sym_u_SQUOTE] = ACTIONS(2966),
    [anon_sym_U_SQUOTE] = ACTIONS(2966),
    [anon_sym_u8_SQUOTE] = ACTIONS(2966),
    [anon_sym_SQUOTE] = ACTIONS(2966),
    [anon_sym_L_DQUOTE] = ACTIONS(2966),
    [anon_sym_u_DQUOTE] = ACTIONS(2966),
    [anon_sym_U_DQUOTE] = ACTIONS(2966),
    [anon_sym_u8_DQUOTE] = ACTIONS(2966),
    [anon_sym_DQUOTE] = ACTIONS(2966),
    [sym_true] = ACTIONS(2964),
    [sym_false] = ACTIONS(2964),
    [anon_sym_NULL] = ACTIONS(2964),
    [anon_sym_nullptr] = ACTIONS(2964),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2964),
    [anon_sym_decltype] = ACTIONS(2964),
    [anon_sym_explicit] = ACTIONS(2964),
    [anon_sym_typename] = ACTIONS(2964),
    [anon_sym_template] = ACTIONS(2964),
    [anon_sym_operator] = ACTIONS(2964),
    [anon_sym_try] = ACTIONS(2964),
    [anon_sym_delete] = ACTIONS(2964),
    [anon_sym_throw] = ACTIONS(2964),
    [anon_sym_namespace] = ACTIONS(2964),
    [anon_sym_using] = ACTIONS(2964),
    [anon_sym_static_assert] = ACTIONS(2964),
    [anon_sym_concept] = ACTIONS(2964),
    [anon_sym_co_return] = ACTIONS(2964),
    [anon_sym_co_yield] = ACTIONS(2964),
    [anon_sym_R_DQUOTE] = ACTIONS(2966),
    [anon_sym_LR_DQUOTE] = ACTIONS(2966),
    [anon_sym_uR_DQUOTE] = ACTIONS(2966),
    [anon_sym_UR_DQUOTE] = ACTIONS(2966),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2966),
    [anon_sym_co_await] = ACTIONS(2964),
    [anon_sym_new] = ACTIONS(2964),
    [anon_sym_requires] = ACTIONS(2964),
    [sym_this] = ACTIONS(2964),
  },
  [587] = {
    [sym_identifier] = ACTIONS(2960),
    [aux_sym_preproc_include_token1] = ACTIONS(2960),
    [aux_sym_preproc_def_token1] = ACTIONS(2960),
    [aux_sym_preproc_if_token1] = ACTIONS(2960),
    [aux_sym_preproc_if_token2] = ACTIONS(2960),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2960),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2960),
    [sym_preproc_directive] = ACTIONS(2960),
    [anon_sym_LPAREN2] = ACTIONS(2962),
    [anon_sym_BANG] = ACTIONS(2962),
    [anon_sym_TILDE] = ACTIONS(2962),
    [anon_sym_DASH] = ACTIONS(2960),
    [anon_sym_PLUS] = ACTIONS(2960),
    [anon_sym_STAR] = ACTIONS(2962),
    [anon_sym_AMP_AMP] = ACTIONS(2962),
    [anon_sym_AMP] = ACTIONS(2960),
    [anon_sym_SEMI] = ACTIONS(2962),
    [anon_sym___extension__] = ACTIONS(2960),
    [anon_sym_typedef] = ACTIONS(2960),
    [anon_sym_virtual] = ACTIONS(2960),
    [anon_sym_extern] = ACTIONS(2960),
    [anon_sym___attribute__] = ACTIONS(2960),
    [anon_sym___attribute] = ACTIONS(2960),
    [anon_sym_COLON_COLON] = ACTIONS(2962),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2962),
    [anon_sym___declspec] = ACTIONS(2960),
    [anon_sym___based] = ACTIONS(2960),
    [anon_sym___cdecl] = ACTIONS(2960),
    [anon_sym___clrcall] = ACTIONS(2960),
    [anon_sym___stdcall] = ACTIONS(2960),
    [anon_sym___fastcall] = ACTIONS(2960),
    [anon_sym___thiscall] = ACTIONS(2960),
    [anon_sym___vectorcall] = ACTIONS(2960),
    [anon_sym_LBRACE] = ACTIONS(2962),
    [anon_sym_signed] = ACTIONS(2960),
    [anon_sym_unsigned] = ACTIONS(2960),
    [anon_sym_long] = ACTIONS(2960),
    [anon_sym_short] = ACTIONS(2960),
    [anon_sym_LBRACK] = ACTIONS(2960),
    [anon_sym_static] = ACTIONS(2960),
    [anon_sym_register] = ACTIONS(2960),
    [anon_sym_inline] = ACTIONS(2960),
    [anon_sym___inline] = ACTIONS(2960),
    [anon_sym___inline__] = ACTIONS(2960),
    [anon_sym___forceinline] = ACTIONS(2960),
    [anon_sym_thread_local] = ACTIONS(2960),
    [anon_sym___thread] = ACTIONS(2960),
    [anon_sym_const] = ACTIONS(2960),
    [anon_sym_constexpr] = ACTIONS(2960),
    [anon_sym_volatile] = ACTIONS(2960),
    [anon_sym_restrict] = ACTIONS(2960),
    [anon_sym___restrict__] = ACTIONS(2960),
    [anon_sym__Atomic] = ACTIONS(2960),
    [anon_sym__Noreturn] = ACTIONS(2960),
    [anon_sym_noreturn] = ACTIONS(2960),
    [anon_sym__Nonnull] = ACTIONS(2960),
    [anon_sym_mutable] = ACTIONS(2960),
    [anon_sym_constinit] = ACTIONS(2960),
    [anon_sym_consteval] = ACTIONS(2960),
    [anon_sym_alignas] = ACTIONS(2960),
    [anon_sym__Alignas] = ACTIONS(2960),
    [sym_primitive_type] = ACTIONS(2960),
    [anon_sym_enum] = ACTIONS(2960),
    [anon_sym_class] = ACTIONS(2960),
    [anon_sym_struct] = ACTIONS(2960),
    [anon_sym_union] = ACTIONS(2960),
    [anon_sym_if] = ACTIONS(2960),
    [anon_sym_switch] = ACTIONS(2960),
    [anon_sym_case] = ACTIONS(2960),
    [anon_sym_default] = ACTIONS(2960),
    [anon_sym_while] = ACTIONS(2960),
    [anon_sym_do] = ACTIONS(2960),
    [anon_sym_for] = ACTIONS(2960),
    [anon_sym_return] = ACTIONS(2960),
    [anon_sym_break] = ACTIONS(2960),
    [anon_sym_continue] = ACTIONS(2960),
    [anon_sym_goto] = ACTIONS(2960),
    [anon_sym___try] = ACTIONS(2960),
    [anon_sym___leave] = ACTIONS(2960),
    [anon_sym_not] = ACTIONS(2960),
    [anon_sym_compl] = ACTIONS(2960),
    [anon_sym_DASH_DASH] = ACTIONS(2962),
    [anon_sym_PLUS_PLUS] = ACTIONS(2962),
    [anon_sym_sizeof] = ACTIONS(2960),
    [anon_sym___alignof__] = ACTIONS(2960),
    [anon_sym___alignof] = ACTIONS(2960),
    [anon_sym__alignof] = ACTIONS(2960),
    [anon_sym_alignof] = ACTIONS(2960),
    [anon_sym__Alignof] = ACTIONS(2960),
    [anon_sym_offsetof] = ACTIONS(2960),
    [anon_sym__Generic] = ACTIONS(2960),
    [anon_sym_asm] = ACTIONS(2960),
    [anon_sym___asm__] = ACTIONS(2960),
    [anon_sym___asm] = ACTIONS(2960),
    [sym_number_literal] = ACTIONS(2962),
    [anon_sym_L_SQUOTE] = ACTIONS(2962),
    [anon_sym_u_SQUOTE] = ACTIONS(2962),
    [anon_sym_U_SQUOTE] = ACTIONS(2962),
    [anon_sym_u8_SQUOTE] = ACTIONS(2962),
    [anon_sym_SQUOTE] = ACTIONS(2962),
    [anon_sym_L_DQUOTE] = ACTIONS(2962),
    [anon_sym_u_DQUOTE] = ACTIONS(2962),
    [anon_sym_U_DQUOTE] = ACTIONS(2962),
    [anon_sym_u8_DQUOTE] = ACTIONS(2962),
    [anon_sym_DQUOTE] = ACTIONS(2962),
    [sym_true] = ACTIONS(2960),
    [sym_false] = ACTIONS(2960),
    [anon_sym_NULL] = ACTIONS(2960),
    [anon_sym_nullptr] = ACTIONS(2960),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2960),
    [anon_sym_decltype] = ACTIONS(2960),
    [anon_sym_explicit] = ACTIONS(2960),
    [anon_sym_typename] = ACTIONS(2960),
    [anon_sym_template] = ACTIONS(2960),
    [anon_sym_operator] = ACTIONS(2960),
    [anon_sym_try] = ACTIONS(2960),
    [anon_sym_delete] = ACTIONS(2960),
    [anon_sym_throw] = ACTIONS(2960),
    [anon_sym_namespace] = ACTIONS(2960),
    [anon_sym_using] = ACTIONS(2960),
    [anon_sym_static_assert] = ACTIONS(2960),
    [anon_sym_concept] = ACTIONS(2960),
    [anon_sym_co_return] = ACTIONS(2960),
    [anon_sym_co_yield] = ACTIONS(2960),
    [anon_sym_R_DQUOTE] = ACTIONS(2962),
    [anon_sym_LR_DQUOTE] = ACTIONS(2962),
    [anon_sym_uR_DQUOTE] = ACTIONS(2962),
    [anon_sym_UR_DQUOTE] = ACTIONS(2962),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2962),
    [anon_sym_co_await] = ACTIONS(2960),
    [anon_sym_new] = ACTIONS(2960),
    [anon_sym_requires] = ACTIONS(2960),
    [sym_this] = ACTIONS(2960),
  },
  [588] = {
    [sym_identifier] = ACTIONS(2731),
    [aux_sym_preproc_include_token1] = ACTIONS(2731),
    [aux_sym_preproc_def_token1] = ACTIONS(2731),
    [aux_sym_preproc_if_token1] = ACTIONS(2731),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2731),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2731),
    [sym_preproc_directive] = ACTIONS(2731),
    [anon_sym_LPAREN2] = ACTIONS(2733),
    [anon_sym_BANG] = ACTIONS(2733),
    [anon_sym_TILDE] = ACTIONS(2733),
    [anon_sym_DASH] = ACTIONS(2731),
    [anon_sym_PLUS] = ACTIONS(2731),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_AMP_AMP] = ACTIONS(2733),
    [anon_sym_AMP] = ACTIONS(2731),
    [anon_sym_SEMI] = ACTIONS(2733),
    [anon_sym___extension__] = ACTIONS(2731),
    [anon_sym_typedef] = ACTIONS(2731),
    [anon_sym_virtual] = ACTIONS(2731),
    [anon_sym_extern] = ACTIONS(2731),
    [anon_sym___attribute__] = ACTIONS(2731),
    [anon_sym___attribute] = ACTIONS(2731),
    [anon_sym_COLON_COLON] = ACTIONS(2733),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2733),
    [anon_sym___declspec] = ACTIONS(2731),
    [anon_sym___based] = ACTIONS(2731),
    [anon_sym___cdecl] = ACTIONS(2731),
    [anon_sym___clrcall] = ACTIONS(2731),
    [anon_sym___stdcall] = ACTIONS(2731),
    [anon_sym___fastcall] = ACTIONS(2731),
    [anon_sym___thiscall] = ACTIONS(2731),
    [anon_sym___vectorcall] = ACTIONS(2731),
    [anon_sym_LBRACE] = ACTIONS(2733),
    [anon_sym_RBRACE] = ACTIONS(2733),
    [anon_sym_signed] = ACTIONS(2731),
    [anon_sym_unsigned] = ACTIONS(2731),
    [anon_sym_long] = ACTIONS(2731),
    [anon_sym_short] = ACTIONS(2731),
    [anon_sym_LBRACK] = ACTIONS(2731),
    [anon_sym_static] = ACTIONS(2731),
    [anon_sym_register] = ACTIONS(2731),
    [anon_sym_inline] = ACTIONS(2731),
    [anon_sym___inline] = ACTIONS(2731),
    [anon_sym___inline__] = ACTIONS(2731),
    [anon_sym___forceinline] = ACTIONS(2731),
    [anon_sym_thread_local] = ACTIONS(2731),
    [anon_sym___thread] = ACTIONS(2731),
    [anon_sym_const] = ACTIONS(2731),
    [anon_sym_constexpr] = ACTIONS(2731),
    [anon_sym_volatile] = ACTIONS(2731),
    [anon_sym_restrict] = ACTIONS(2731),
    [anon_sym___restrict__] = ACTIONS(2731),
    [anon_sym__Atomic] = ACTIONS(2731),
    [anon_sym__Noreturn] = ACTIONS(2731),
    [anon_sym_noreturn] = ACTIONS(2731),
    [anon_sym__Nonnull] = ACTIONS(2731),
    [anon_sym_mutable] = ACTIONS(2731),
    [anon_sym_constinit] = ACTIONS(2731),
    [anon_sym_consteval] = ACTIONS(2731),
    [anon_sym_alignas] = ACTIONS(2731),
    [anon_sym__Alignas] = ACTIONS(2731),
    [sym_primitive_type] = ACTIONS(2731),
    [anon_sym_enum] = ACTIONS(2731),
    [anon_sym_class] = ACTIONS(2731),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2731),
    [anon_sym_if] = ACTIONS(2731),
    [anon_sym_switch] = ACTIONS(2731),
    [anon_sym_case] = ACTIONS(2731),
    [anon_sym_default] = ACTIONS(2731),
    [anon_sym_while] = ACTIONS(2731),
    [anon_sym_do] = ACTIONS(2731),
    [anon_sym_for] = ACTIONS(2731),
    [anon_sym_return] = ACTIONS(2731),
    [anon_sym_break] = ACTIONS(2731),
    [anon_sym_continue] = ACTIONS(2731),
    [anon_sym_goto] = ACTIONS(2731),
    [anon_sym___try] = ACTIONS(2731),
    [anon_sym___leave] = ACTIONS(2731),
    [anon_sym_not] = ACTIONS(2731),
    [anon_sym_compl] = ACTIONS(2731),
    [anon_sym_DASH_DASH] = ACTIONS(2733),
    [anon_sym_PLUS_PLUS] = ACTIONS(2733),
    [anon_sym_sizeof] = ACTIONS(2731),
    [anon_sym___alignof__] = ACTIONS(2731),
    [anon_sym___alignof] = ACTIONS(2731),
    [anon_sym__alignof] = ACTIONS(2731),
    [anon_sym_alignof] = ACTIONS(2731),
    [anon_sym__Alignof] = ACTIONS(2731),
    [anon_sym_offsetof] = ACTIONS(2731),
    [anon_sym__Generic] = ACTIONS(2731),
    [anon_sym_asm] = ACTIONS(2731),
    [anon_sym___asm__] = ACTIONS(2731),
    [anon_sym___asm] = ACTIONS(2731),
    [sym_number_literal] = ACTIONS(2733),
    [anon_sym_L_SQUOTE] = ACTIONS(2733),
    [anon_sym_u_SQUOTE] = ACTIONS(2733),
    [anon_sym_U_SQUOTE] = ACTIONS(2733),
    [anon_sym_u8_SQUOTE] = ACTIONS(2733),
    [anon_sym_SQUOTE] = ACTIONS(2733),
    [anon_sym_L_DQUOTE] = ACTIONS(2733),
    [anon_sym_u_DQUOTE] = ACTIONS(2733),
    [anon_sym_U_DQUOTE] = ACTIONS(2733),
    [anon_sym_u8_DQUOTE] = ACTIONS(2733),
    [anon_sym_DQUOTE] = ACTIONS(2733),
    [sym_true] = ACTIONS(2731),
    [sym_false] = ACTIONS(2731),
    [anon_sym_NULL] = ACTIONS(2731),
    [anon_sym_nullptr] = ACTIONS(2731),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2731),
    [anon_sym_decltype] = ACTIONS(2731),
    [anon_sym_explicit] = ACTIONS(2731),
    [anon_sym_typename] = ACTIONS(2731),
    [anon_sym_template] = ACTIONS(2731),
    [anon_sym_operator] = ACTIONS(2731),
    [anon_sym_try] = ACTIONS(2731),
    [anon_sym_delete] = ACTIONS(2731),
    [anon_sym_throw] = ACTIONS(2731),
    [anon_sym_namespace] = ACTIONS(2731),
    [anon_sym_using] = ACTIONS(2731),
    [anon_sym_static_assert] = ACTIONS(2731),
    [anon_sym_concept] = ACTIONS(2731),
    [anon_sym_co_return] = ACTIONS(2731),
    [anon_sym_co_yield] = ACTIONS(2731),
    [anon_sym_R_DQUOTE] = ACTIONS(2733),
    [anon_sym_LR_DQUOTE] = ACTIONS(2733),
    [anon_sym_uR_DQUOTE] = ACTIONS(2733),
    [anon_sym_UR_DQUOTE] = ACTIONS(2733),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2733),
    [anon_sym_co_await] = ACTIONS(2731),
    [anon_sym_new] = ACTIONS(2731),
    [anon_sym_requires] = ACTIONS(2731),
    [sym_this] = ACTIONS(2731),
  },
  [589] = {
    [sym_identifier] = ACTIONS(3034),
    [aux_sym_preproc_include_token1] = ACTIONS(3034),
    [aux_sym_preproc_def_token1] = ACTIONS(3034),
    [aux_sym_preproc_if_token1] = ACTIONS(3034),
    [aux_sym_preproc_if_token2] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3034),
    [sym_preproc_directive] = ACTIONS(3034),
    [anon_sym_LPAREN2] = ACTIONS(3036),
    [anon_sym_BANG] = ACTIONS(3036),
    [anon_sym_TILDE] = ACTIONS(3036),
    [anon_sym_DASH] = ACTIONS(3034),
    [anon_sym_PLUS] = ACTIONS(3034),
    [anon_sym_STAR] = ACTIONS(3036),
    [anon_sym_AMP_AMP] = ACTIONS(3036),
    [anon_sym_AMP] = ACTIONS(3034),
    [anon_sym_SEMI] = ACTIONS(3036),
    [anon_sym___extension__] = ACTIONS(3034),
    [anon_sym_typedef] = ACTIONS(3034),
    [anon_sym_virtual] = ACTIONS(3034),
    [anon_sym_extern] = ACTIONS(3034),
    [anon_sym___attribute__] = ACTIONS(3034),
    [anon_sym___attribute] = ACTIONS(3034),
    [anon_sym_COLON_COLON] = ACTIONS(3036),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3036),
    [anon_sym___declspec] = ACTIONS(3034),
    [anon_sym___based] = ACTIONS(3034),
    [anon_sym___cdecl] = ACTIONS(3034),
    [anon_sym___clrcall] = ACTIONS(3034),
    [anon_sym___stdcall] = ACTIONS(3034),
    [anon_sym___fastcall] = ACTIONS(3034),
    [anon_sym___thiscall] = ACTIONS(3034),
    [anon_sym___vectorcall] = ACTIONS(3034),
    [anon_sym_LBRACE] = ACTIONS(3036),
    [anon_sym_signed] = ACTIONS(3034),
    [anon_sym_unsigned] = ACTIONS(3034),
    [anon_sym_long] = ACTIONS(3034),
    [anon_sym_short] = ACTIONS(3034),
    [anon_sym_LBRACK] = ACTIONS(3034),
    [anon_sym_static] = ACTIONS(3034),
    [anon_sym_register] = ACTIONS(3034),
    [anon_sym_inline] = ACTIONS(3034),
    [anon_sym___inline] = ACTIONS(3034),
    [anon_sym___inline__] = ACTIONS(3034),
    [anon_sym___forceinline] = ACTIONS(3034),
    [anon_sym_thread_local] = ACTIONS(3034),
    [anon_sym___thread] = ACTIONS(3034),
    [anon_sym_const] = ACTIONS(3034),
    [anon_sym_constexpr] = ACTIONS(3034),
    [anon_sym_volatile] = ACTIONS(3034),
    [anon_sym_restrict] = ACTIONS(3034),
    [anon_sym___restrict__] = ACTIONS(3034),
    [anon_sym__Atomic] = ACTIONS(3034),
    [anon_sym__Noreturn] = ACTIONS(3034),
    [anon_sym_noreturn] = ACTIONS(3034),
    [anon_sym__Nonnull] = ACTIONS(3034),
    [anon_sym_mutable] = ACTIONS(3034),
    [anon_sym_constinit] = ACTIONS(3034),
    [anon_sym_consteval] = ACTIONS(3034),
    [anon_sym_alignas] = ACTIONS(3034),
    [anon_sym__Alignas] = ACTIONS(3034),
    [sym_primitive_type] = ACTIONS(3034),
    [anon_sym_enum] = ACTIONS(3034),
    [anon_sym_class] = ACTIONS(3034),
    [anon_sym_struct] = ACTIONS(3034),
    [anon_sym_union] = ACTIONS(3034),
    [anon_sym_if] = ACTIONS(3034),
    [anon_sym_switch] = ACTIONS(3034),
    [anon_sym_case] = ACTIONS(3034),
    [anon_sym_default] = ACTIONS(3034),
    [anon_sym_while] = ACTIONS(3034),
    [anon_sym_do] = ACTIONS(3034),
    [anon_sym_for] = ACTIONS(3034),
    [anon_sym_return] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3034),
    [anon_sym_continue] = ACTIONS(3034),
    [anon_sym_goto] = ACTIONS(3034),
    [anon_sym___try] = ACTIONS(3034),
    [anon_sym___leave] = ACTIONS(3034),
    [anon_sym_not] = ACTIONS(3034),
    [anon_sym_compl] = ACTIONS(3034),
    [anon_sym_DASH_DASH] = ACTIONS(3036),
    [anon_sym_PLUS_PLUS] = ACTIONS(3036),
    [anon_sym_sizeof] = ACTIONS(3034),
    [anon_sym___alignof__] = ACTIONS(3034),
    [anon_sym___alignof] = ACTIONS(3034),
    [anon_sym__alignof] = ACTIONS(3034),
    [anon_sym_alignof] = ACTIONS(3034),
    [anon_sym__Alignof] = ACTIONS(3034),
    [anon_sym_offsetof] = ACTIONS(3034),
    [anon_sym__Generic] = ACTIONS(3034),
    [anon_sym_asm] = ACTIONS(3034),
    [anon_sym___asm__] = ACTIONS(3034),
    [anon_sym___asm] = ACTIONS(3034),
    [sym_number_literal] = ACTIONS(3036),
    [anon_sym_L_SQUOTE] = ACTIONS(3036),
    [anon_sym_u_SQUOTE] = ACTIONS(3036),
    [anon_sym_U_SQUOTE] = ACTIONS(3036),
    [anon_sym_u8_SQUOTE] = ACTIONS(3036),
    [anon_sym_SQUOTE] = ACTIONS(3036),
    [anon_sym_L_DQUOTE] = ACTIONS(3036),
    [anon_sym_u_DQUOTE] = ACTIONS(3036),
    [anon_sym_U_DQUOTE] = ACTIONS(3036),
    [anon_sym_u8_DQUOTE] = ACTIONS(3036),
    [anon_sym_DQUOTE] = ACTIONS(3036),
    [sym_true] = ACTIONS(3034),
    [sym_false] = ACTIONS(3034),
    [anon_sym_NULL] = ACTIONS(3034),
    [anon_sym_nullptr] = ACTIONS(3034),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3034),
    [anon_sym_decltype] = ACTIONS(3034),
    [anon_sym_explicit] = ACTIONS(3034),
    [anon_sym_typename] = ACTIONS(3034),
    [anon_sym_template] = ACTIONS(3034),
    [anon_sym_operator] = ACTIONS(3034),
    [anon_sym_try] = ACTIONS(3034),
    [anon_sym_delete] = ACTIONS(3034),
    [anon_sym_throw] = ACTIONS(3034),
    [anon_sym_namespace] = ACTIONS(3034),
    [anon_sym_using] = ACTIONS(3034),
    [anon_sym_static_assert] = ACTIONS(3034),
    [anon_sym_concept] = ACTIONS(3034),
    [anon_sym_co_return] = ACTIONS(3034),
    [anon_sym_co_yield] = ACTIONS(3034),
    [anon_sym_R_DQUOTE] = ACTIONS(3036),
    [anon_sym_LR_DQUOTE] = ACTIONS(3036),
    [anon_sym_uR_DQUOTE] = ACTIONS(3036),
    [anon_sym_UR_DQUOTE] = ACTIONS(3036),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3036),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3034),
    [anon_sym_requires] = ACTIONS(3034),
    [sym_this] = ACTIONS(3034),
  },
  [590] = {
    [sym_identifier] = ACTIONS(2735),
    [aux_sym_preproc_include_token1] = ACTIONS(2735),
    [aux_sym_preproc_def_token1] = ACTIONS(2735),
    [aux_sym_preproc_if_token1] = ACTIONS(2735),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2735),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2735),
    [sym_preproc_directive] = ACTIONS(2735),
    [anon_sym_LPAREN2] = ACTIONS(2737),
    [anon_sym_BANG] = ACTIONS(2737),
    [anon_sym_TILDE] = ACTIONS(2737),
    [anon_sym_DASH] = ACTIONS(2735),
    [anon_sym_PLUS] = ACTIONS(2735),
    [anon_sym_STAR] = ACTIONS(2737),
    [anon_sym_AMP_AMP] = ACTIONS(2737),
    [anon_sym_AMP] = ACTIONS(2735),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym___extension__] = ACTIONS(2735),
    [anon_sym_typedef] = ACTIONS(2735),
    [anon_sym_virtual] = ACTIONS(2735),
    [anon_sym_extern] = ACTIONS(2735),
    [anon_sym___attribute__] = ACTIONS(2735),
    [anon_sym___attribute] = ACTIONS(2735),
    [anon_sym_COLON_COLON] = ACTIONS(2737),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2737),
    [anon_sym___declspec] = ACTIONS(2735),
    [anon_sym___based] = ACTIONS(2735),
    [anon_sym___cdecl] = ACTIONS(2735),
    [anon_sym___clrcall] = ACTIONS(2735),
    [anon_sym___stdcall] = ACTIONS(2735),
    [anon_sym___fastcall] = ACTIONS(2735),
    [anon_sym___thiscall] = ACTIONS(2735),
    [anon_sym___vectorcall] = ACTIONS(2735),
    [anon_sym_LBRACE] = ACTIONS(2737),
    [anon_sym_RBRACE] = ACTIONS(2737),
    [anon_sym_signed] = ACTIONS(2735),
    [anon_sym_unsigned] = ACTIONS(2735),
    [anon_sym_long] = ACTIONS(2735),
    [anon_sym_short] = ACTIONS(2735),
    [anon_sym_LBRACK] = ACTIONS(2735),
    [anon_sym_static] = ACTIONS(2735),
    [anon_sym_register] = ACTIONS(2735),
    [anon_sym_inline] = ACTIONS(2735),
    [anon_sym___inline] = ACTIONS(2735),
    [anon_sym___inline__] = ACTIONS(2735),
    [anon_sym___forceinline] = ACTIONS(2735),
    [anon_sym_thread_local] = ACTIONS(2735),
    [anon_sym___thread] = ACTIONS(2735),
    [anon_sym_const] = ACTIONS(2735),
    [anon_sym_constexpr] = ACTIONS(2735),
    [anon_sym_volatile] = ACTIONS(2735),
    [anon_sym_restrict] = ACTIONS(2735),
    [anon_sym___restrict__] = ACTIONS(2735),
    [anon_sym__Atomic] = ACTIONS(2735),
    [anon_sym__Noreturn] = ACTIONS(2735),
    [anon_sym_noreturn] = ACTIONS(2735),
    [anon_sym__Nonnull] = ACTIONS(2735),
    [anon_sym_mutable] = ACTIONS(2735),
    [anon_sym_constinit] = ACTIONS(2735),
    [anon_sym_consteval] = ACTIONS(2735),
    [anon_sym_alignas] = ACTIONS(2735),
    [anon_sym__Alignas] = ACTIONS(2735),
    [sym_primitive_type] = ACTIONS(2735),
    [anon_sym_enum] = ACTIONS(2735),
    [anon_sym_class] = ACTIONS(2735),
    [anon_sym_struct] = ACTIONS(2735),
    [anon_sym_union] = ACTIONS(2735),
    [anon_sym_if] = ACTIONS(2735),
    [anon_sym_switch] = ACTIONS(2735),
    [anon_sym_case] = ACTIONS(2735),
    [anon_sym_default] = ACTIONS(2735),
    [anon_sym_while] = ACTIONS(2735),
    [anon_sym_do] = ACTIONS(2735),
    [anon_sym_for] = ACTIONS(2735),
    [anon_sym_return] = ACTIONS(2735),
    [anon_sym_break] = ACTIONS(2735),
    [anon_sym_continue] = ACTIONS(2735),
    [anon_sym_goto] = ACTIONS(2735),
    [anon_sym___try] = ACTIONS(2735),
    [anon_sym___leave] = ACTIONS(2735),
    [anon_sym_not] = ACTIONS(2735),
    [anon_sym_compl] = ACTIONS(2735),
    [anon_sym_DASH_DASH] = ACTIONS(2737),
    [anon_sym_PLUS_PLUS] = ACTIONS(2737),
    [anon_sym_sizeof] = ACTIONS(2735),
    [anon_sym___alignof__] = ACTIONS(2735),
    [anon_sym___alignof] = ACTIONS(2735),
    [anon_sym__alignof] = ACTIONS(2735),
    [anon_sym_alignof] = ACTIONS(2735),
    [anon_sym__Alignof] = ACTIONS(2735),
    [anon_sym_offsetof] = ACTIONS(2735),
    [anon_sym__Generic] = ACTIONS(2735),
    [anon_sym_asm] = ACTIONS(2735),
    [anon_sym___asm__] = ACTIONS(2735),
    [anon_sym___asm] = ACTIONS(2735),
    [sym_number_literal] = ACTIONS(2737),
    [anon_sym_L_SQUOTE] = ACTIONS(2737),
    [anon_sym_u_SQUOTE] = ACTIONS(2737),
    [anon_sym_U_SQUOTE] = ACTIONS(2737),
    [anon_sym_u8_SQUOTE] = ACTIONS(2737),
    [anon_sym_SQUOTE] = ACTIONS(2737),
    [anon_sym_L_DQUOTE] = ACTIONS(2737),
    [anon_sym_u_DQUOTE] = ACTIONS(2737),
    [anon_sym_U_DQUOTE] = ACTIONS(2737),
    [anon_sym_u8_DQUOTE] = ACTIONS(2737),
    [anon_sym_DQUOTE] = ACTIONS(2737),
    [sym_true] = ACTIONS(2735),
    [sym_false] = ACTIONS(2735),
    [anon_sym_NULL] = ACTIONS(2735),
    [anon_sym_nullptr] = ACTIONS(2735),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2735),
    [anon_sym_decltype] = ACTIONS(2735),
    [anon_sym_explicit] = ACTIONS(2735),
    [anon_sym_typename] = ACTIONS(2735),
    [anon_sym_template] = ACTIONS(2735),
    [anon_sym_operator] = ACTIONS(2735),
    [anon_sym_try] = ACTIONS(2735),
    [anon_sym_delete] = ACTIONS(2735),
    [anon_sym_throw] = ACTIONS(2735),
    [anon_sym_namespace] = ACTIONS(2735),
    [anon_sym_using] = ACTIONS(2735),
    [anon_sym_static_assert] = ACTIONS(2735),
    [anon_sym_concept] = ACTIONS(2735),
    [anon_sym_co_return] = ACTIONS(2735),
    [anon_sym_co_yield] = ACTIONS(2735),
    [anon_sym_R_DQUOTE] = ACTIONS(2737),
    [anon_sym_LR_DQUOTE] = ACTIONS(2737),
    [anon_sym_uR_DQUOTE] = ACTIONS(2737),
    [anon_sym_UR_DQUOTE] = ACTIONS(2737),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2737),
    [anon_sym_co_await] = ACTIONS(2735),
    [anon_sym_new] = ACTIONS(2735),
    [anon_sym_requires] = ACTIONS(2735),
    [sym_this] = ACTIONS(2735),
  },
  [591] = {
    [sym_identifier] = ACTIONS(2731),
    [aux_sym_preproc_include_token1] = ACTIONS(2731),
    [aux_sym_preproc_def_token1] = ACTIONS(2731),
    [aux_sym_preproc_if_token1] = ACTIONS(2731),
    [aux_sym_preproc_if_token2] = ACTIONS(2731),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2731),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2731),
    [sym_preproc_directive] = ACTIONS(2731),
    [anon_sym_LPAREN2] = ACTIONS(2733),
    [anon_sym_BANG] = ACTIONS(2733),
    [anon_sym_TILDE] = ACTIONS(2733),
    [anon_sym_DASH] = ACTIONS(2731),
    [anon_sym_PLUS] = ACTIONS(2731),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_AMP_AMP] = ACTIONS(2733),
    [anon_sym_AMP] = ACTIONS(2731),
    [anon_sym_SEMI] = ACTIONS(2733),
    [anon_sym___extension__] = ACTIONS(2731),
    [anon_sym_typedef] = ACTIONS(2731),
    [anon_sym_virtual] = ACTIONS(2731),
    [anon_sym_extern] = ACTIONS(2731),
    [anon_sym___attribute__] = ACTIONS(2731),
    [anon_sym___attribute] = ACTIONS(2731),
    [anon_sym_COLON_COLON] = ACTIONS(2733),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2733),
    [anon_sym___declspec] = ACTIONS(2731),
    [anon_sym___based] = ACTIONS(2731),
    [anon_sym___cdecl] = ACTIONS(2731),
    [anon_sym___clrcall] = ACTIONS(2731),
    [anon_sym___stdcall] = ACTIONS(2731),
    [anon_sym___fastcall] = ACTIONS(2731),
    [anon_sym___thiscall] = ACTIONS(2731),
    [anon_sym___vectorcall] = ACTIONS(2731),
    [anon_sym_LBRACE] = ACTIONS(2733),
    [anon_sym_signed] = ACTIONS(2731),
    [anon_sym_unsigned] = ACTIONS(2731),
    [anon_sym_long] = ACTIONS(2731),
    [anon_sym_short] = ACTIONS(2731),
    [anon_sym_LBRACK] = ACTIONS(2731),
    [anon_sym_static] = ACTIONS(2731),
    [anon_sym_register] = ACTIONS(2731),
    [anon_sym_inline] = ACTIONS(2731),
    [anon_sym___inline] = ACTIONS(2731),
    [anon_sym___inline__] = ACTIONS(2731),
    [anon_sym___forceinline] = ACTIONS(2731),
    [anon_sym_thread_local] = ACTIONS(2731),
    [anon_sym___thread] = ACTIONS(2731),
    [anon_sym_const] = ACTIONS(2731),
    [anon_sym_constexpr] = ACTIONS(2731),
    [anon_sym_volatile] = ACTIONS(2731),
    [anon_sym_restrict] = ACTIONS(2731),
    [anon_sym___restrict__] = ACTIONS(2731),
    [anon_sym__Atomic] = ACTIONS(2731),
    [anon_sym__Noreturn] = ACTIONS(2731),
    [anon_sym_noreturn] = ACTIONS(2731),
    [anon_sym__Nonnull] = ACTIONS(2731),
    [anon_sym_mutable] = ACTIONS(2731),
    [anon_sym_constinit] = ACTIONS(2731),
    [anon_sym_consteval] = ACTIONS(2731),
    [anon_sym_alignas] = ACTIONS(2731),
    [anon_sym__Alignas] = ACTIONS(2731),
    [sym_primitive_type] = ACTIONS(2731),
    [anon_sym_enum] = ACTIONS(2731),
    [anon_sym_class] = ACTIONS(2731),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2731),
    [anon_sym_if] = ACTIONS(2731),
    [anon_sym_switch] = ACTIONS(2731),
    [anon_sym_case] = ACTIONS(2731),
    [anon_sym_default] = ACTIONS(2731),
    [anon_sym_while] = ACTIONS(2731),
    [anon_sym_do] = ACTIONS(2731),
    [anon_sym_for] = ACTIONS(2731),
    [anon_sym_return] = ACTIONS(2731),
    [anon_sym_break] = ACTIONS(2731),
    [anon_sym_continue] = ACTIONS(2731),
    [anon_sym_goto] = ACTIONS(2731),
    [anon_sym___try] = ACTIONS(2731),
    [anon_sym___leave] = ACTIONS(2731),
    [anon_sym_not] = ACTIONS(2731),
    [anon_sym_compl] = ACTIONS(2731),
    [anon_sym_DASH_DASH] = ACTIONS(2733),
    [anon_sym_PLUS_PLUS] = ACTIONS(2733),
    [anon_sym_sizeof] = ACTIONS(2731),
    [anon_sym___alignof__] = ACTIONS(2731),
    [anon_sym___alignof] = ACTIONS(2731),
    [anon_sym__alignof] = ACTIONS(2731),
    [anon_sym_alignof] = ACTIONS(2731),
    [anon_sym__Alignof] = ACTIONS(2731),
    [anon_sym_offsetof] = ACTIONS(2731),
    [anon_sym__Generic] = ACTIONS(2731),
    [anon_sym_asm] = ACTIONS(2731),
    [anon_sym___asm__] = ACTIONS(2731),
    [anon_sym___asm] = ACTIONS(2731),
    [sym_number_literal] = ACTIONS(2733),
    [anon_sym_L_SQUOTE] = ACTIONS(2733),
    [anon_sym_u_SQUOTE] = ACTIONS(2733),
    [anon_sym_U_SQUOTE] = ACTIONS(2733),
    [anon_sym_u8_SQUOTE] = ACTIONS(2733),
    [anon_sym_SQUOTE] = ACTIONS(2733),
    [anon_sym_L_DQUOTE] = ACTIONS(2733),
    [anon_sym_u_DQUOTE] = ACTIONS(2733),
    [anon_sym_U_DQUOTE] = ACTIONS(2733),
    [anon_sym_u8_DQUOTE] = ACTIONS(2733),
    [anon_sym_DQUOTE] = ACTIONS(2733),
    [sym_true] = ACTIONS(2731),
    [sym_false] = ACTIONS(2731),
    [anon_sym_NULL] = ACTIONS(2731),
    [anon_sym_nullptr] = ACTIONS(2731),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2731),
    [anon_sym_decltype] = ACTIONS(2731),
    [anon_sym_explicit] = ACTIONS(2731),
    [anon_sym_typename] = ACTIONS(2731),
    [anon_sym_template] = ACTIONS(2731),
    [anon_sym_operator] = ACTIONS(2731),
    [anon_sym_try] = ACTIONS(2731),
    [anon_sym_delete] = ACTIONS(2731),
    [anon_sym_throw] = ACTIONS(2731),
    [anon_sym_namespace] = ACTIONS(2731),
    [anon_sym_using] = ACTIONS(2731),
    [anon_sym_static_assert] = ACTIONS(2731),
    [anon_sym_concept] = ACTIONS(2731),
    [anon_sym_co_return] = ACTIONS(2731),
    [anon_sym_co_yield] = ACTIONS(2731),
    [anon_sym_R_DQUOTE] = ACTIONS(2733),
    [anon_sym_LR_DQUOTE] = ACTIONS(2733),
    [anon_sym_uR_DQUOTE] = ACTIONS(2733),
    [anon_sym_UR_DQUOTE] = ACTIONS(2733),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2733),
    [anon_sym_co_await] = ACTIONS(2731),
    [anon_sym_new] = ACTIONS(2731),
    [anon_sym_requires] = ACTIONS(2731),
    [sym_this] = ACTIONS(2731),
  },
  [592] = {
    [sym_identifier] = ACTIONS(2980),
    [aux_sym_preproc_include_token1] = ACTIONS(2980),
    [aux_sym_preproc_def_token1] = ACTIONS(2980),
    [aux_sym_preproc_if_token1] = ACTIONS(2980),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2980),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2980),
    [sym_preproc_directive] = ACTIONS(2980),
    [anon_sym_LPAREN2] = ACTIONS(2982),
    [anon_sym_BANG] = ACTIONS(2982),
    [anon_sym_TILDE] = ACTIONS(2982),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP_AMP] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2980),
    [anon_sym_SEMI] = ACTIONS(2982),
    [anon_sym___extension__] = ACTIONS(2980),
    [anon_sym_typedef] = ACTIONS(2980),
    [anon_sym_virtual] = ACTIONS(2980),
    [anon_sym_extern] = ACTIONS(2980),
    [anon_sym___attribute__] = ACTIONS(2980),
    [anon_sym___attribute] = ACTIONS(2980),
    [anon_sym_COLON_COLON] = ACTIONS(2982),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2982),
    [anon_sym___declspec] = ACTIONS(2980),
    [anon_sym___based] = ACTIONS(2980),
    [anon_sym___cdecl] = ACTIONS(2980),
    [anon_sym___clrcall] = ACTIONS(2980),
    [anon_sym___stdcall] = ACTIONS(2980),
    [anon_sym___fastcall] = ACTIONS(2980),
    [anon_sym___thiscall] = ACTIONS(2980),
    [anon_sym___vectorcall] = ACTIONS(2980),
    [anon_sym_LBRACE] = ACTIONS(2982),
    [anon_sym_RBRACE] = ACTIONS(2982),
    [anon_sym_signed] = ACTIONS(2980),
    [anon_sym_unsigned] = ACTIONS(2980),
    [anon_sym_long] = ACTIONS(2980),
    [anon_sym_short] = ACTIONS(2980),
    [anon_sym_LBRACK] = ACTIONS(2980),
    [anon_sym_static] = ACTIONS(2980),
    [anon_sym_register] = ACTIONS(2980),
    [anon_sym_inline] = ACTIONS(2980),
    [anon_sym___inline] = ACTIONS(2980),
    [anon_sym___inline__] = ACTIONS(2980),
    [anon_sym___forceinline] = ACTIONS(2980),
    [anon_sym_thread_local] = ACTIONS(2980),
    [anon_sym___thread] = ACTIONS(2980),
    [anon_sym_const] = ACTIONS(2980),
    [anon_sym_constexpr] = ACTIONS(2980),
    [anon_sym_volatile] = ACTIONS(2980),
    [anon_sym_restrict] = ACTIONS(2980),
    [anon_sym___restrict__] = ACTIONS(2980),
    [anon_sym__Atomic] = ACTIONS(2980),
    [anon_sym__Noreturn] = ACTIONS(2980),
    [anon_sym_noreturn] = ACTIONS(2980),
    [anon_sym__Nonnull] = ACTIONS(2980),
    [anon_sym_mutable] = ACTIONS(2980),
    [anon_sym_constinit] = ACTIONS(2980),
    [anon_sym_consteval] = ACTIONS(2980),
    [anon_sym_alignas] = ACTIONS(2980),
    [anon_sym__Alignas] = ACTIONS(2980),
    [sym_primitive_type] = ACTIONS(2980),
    [anon_sym_enum] = ACTIONS(2980),
    [anon_sym_class] = ACTIONS(2980),
    [anon_sym_struct] = ACTIONS(2980),
    [anon_sym_union] = ACTIONS(2980),
    [anon_sym_if] = ACTIONS(2980),
    [anon_sym_switch] = ACTIONS(2980),
    [anon_sym_case] = ACTIONS(2980),
    [anon_sym_default] = ACTIONS(2980),
    [anon_sym_while] = ACTIONS(2980),
    [anon_sym_do] = ACTIONS(2980),
    [anon_sym_for] = ACTIONS(2980),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_break] = ACTIONS(2980),
    [anon_sym_continue] = ACTIONS(2980),
    [anon_sym_goto] = ACTIONS(2980),
    [anon_sym___try] = ACTIONS(2980),
    [anon_sym___leave] = ACTIONS(2980),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_compl] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2982),
    [anon_sym_PLUS_PLUS] = ACTIONS(2982),
    [anon_sym_sizeof] = ACTIONS(2980),
    [anon_sym___alignof__] = ACTIONS(2980),
    [anon_sym___alignof] = ACTIONS(2980),
    [anon_sym__alignof] = ACTIONS(2980),
    [anon_sym_alignof] = ACTIONS(2980),
    [anon_sym__Alignof] = ACTIONS(2980),
    [anon_sym_offsetof] = ACTIONS(2980),
    [anon_sym__Generic] = ACTIONS(2980),
    [anon_sym_asm] = ACTIONS(2980),
    [anon_sym___asm__] = ACTIONS(2980),
    [anon_sym___asm] = ACTIONS(2980),
    [sym_number_literal] = ACTIONS(2982),
    [anon_sym_L_SQUOTE] = ACTIONS(2982),
    [anon_sym_u_SQUOTE] = ACTIONS(2982),
    [anon_sym_U_SQUOTE] = ACTIONS(2982),
    [anon_sym_u8_SQUOTE] = ACTIONS(2982),
    [anon_sym_SQUOTE] = ACTIONS(2982),
    [anon_sym_L_DQUOTE] = ACTIONS(2982),
    [anon_sym_u_DQUOTE] = ACTIONS(2982),
    [anon_sym_U_DQUOTE] = ACTIONS(2982),
    [anon_sym_u8_DQUOTE] = ACTIONS(2982),
    [anon_sym_DQUOTE] = ACTIONS(2982),
    [sym_true] = ACTIONS(2980),
    [sym_false] = ACTIONS(2980),
    [anon_sym_NULL] = ACTIONS(2980),
    [anon_sym_nullptr] = ACTIONS(2980),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2980),
    [anon_sym_decltype] = ACTIONS(2980),
    [anon_sym_explicit] = ACTIONS(2980),
    [anon_sym_typename] = ACTIONS(2980),
    [anon_sym_template] = ACTIONS(2980),
    [anon_sym_operator] = ACTIONS(2980),
    [anon_sym_try] = ACTIONS(2980),
    [anon_sym_delete] = ACTIONS(2980),
    [anon_sym_throw] = ACTIONS(2980),
    [anon_sym_namespace] = ACTIONS(2980),
    [anon_sym_using] = ACTIONS(2980),
    [anon_sym_static_assert] = ACTIONS(2980),
    [anon_sym_concept] = ACTIONS(2980),
    [anon_sym_co_return] = ACTIONS(2980),
    [anon_sym_co_yield] = ACTIONS(2980),
    [anon_sym_R_DQUOTE] = ACTIONS(2982),
    [anon_sym_LR_DQUOTE] = ACTIONS(2982),
    [anon_sym_uR_DQUOTE] = ACTIONS(2982),
    [anon_sym_UR_DQUOTE] = ACTIONS(2982),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2982),
    [anon_sym_co_await] = ACTIONS(2980),
    [anon_sym_new] = ACTIONS(2980),
    [anon_sym_requires] = ACTIONS(2980),
    [sym_this] = ACTIONS(2980),
  },
  [593] = {
    [sym_identifier] = ACTIONS(3086),
    [aux_sym_preproc_include_token1] = ACTIONS(3086),
    [aux_sym_preproc_def_token1] = ACTIONS(3086),
    [aux_sym_preproc_if_token1] = ACTIONS(3086),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3086),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3086),
    [sym_preproc_directive] = ACTIONS(3086),
    [anon_sym_LPAREN2] = ACTIONS(3089),
    [anon_sym_BANG] = ACTIONS(3089),
    [anon_sym_TILDE] = ACTIONS(3089),
    [anon_sym_DASH] = ACTIONS(3086),
    [anon_sym_PLUS] = ACTIONS(3086),
    [anon_sym_STAR] = ACTIONS(3089),
    [anon_sym_AMP_AMP] = ACTIONS(3089),
    [anon_sym_AMP] = ACTIONS(3086),
    [anon_sym_SEMI] = ACTIONS(3089),
    [anon_sym___extension__] = ACTIONS(3086),
    [anon_sym_typedef] = ACTIONS(3086),
    [anon_sym_virtual] = ACTIONS(3086),
    [anon_sym_extern] = ACTIONS(3086),
    [anon_sym___attribute__] = ACTIONS(3086),
    [anon_sym___attribute] = ACTIONS(3086),
    [anon_sym_COLON_COLON] = ACTIONS(3089),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3089),
    [anon_sym___declspec] = ACTIONS(3086),
    [anon_sym___based] = ACTIONS(3086),
    [anon_sym___cdecl] = ACTIONS(3086),
    [anon_sym___clrcall] = ACTIONS(3086),
    [anon_sym___stdcall] = ACTIONS(3086),
    [anon_sym___fastcall] = ACTIONS(3086),
    [anon_sym___thiscall] = ACTIONS(3086),
    [anon_sym___vectorcall] = ACTIONS(3086),
    [anon_sym_LBRACE] = ACTIONS(3089),
    [anon_sym_RBRACE] = ACTIONS(3089),
    [anon_sym_signed] = ACTIONS(3086),
    [anon_sym_unsigned] = ACTIONS(3086),
    [anon_sym_long] = ACTIONS(3086),
    [anon_sym_short] = ACTIONS(3086),
    [anon_sym_LBRACK] = ACTIONS(3086),
    [anon_sym_static] = ACTIONS(3086),
    [anon_sym_register] = ACTIONS(3086),
    [anon_sym_inline] = ACTIONS(3086),
    [anon_sym___inline] = ACTIONS(3086),
    [anon_sym___inline__] = ACTIONS(3086),
    [anon_sym___forceinline] = ACTIONS(3086),
    [anon_sym_thread_local] = ACTIONS(3086),
    [anon_sym___thread] = ACTIONS(3086),
    [anon_sym_const] = ACTIONS(3086),
    [anon_sym_constexpr] = ACTIONS(3086),
    [anon_sym_volatile] = ACTIONS(3086),
    [anon_sym_restrict] = ACTIONS(3086),
    [anon_sym___restrict__] = ACTIONS(3086),
    [anon_sym__Atomic] = ACTIONS(3086),
    [anon_sym__Noreturn] = ACTIONS(3086),
    [anon_sym_noreturn] = ACTIONS(3086),
    [anon_sym__Nonnull] = ACTIONS(3086),
    [anon_sym_mutable] = ACTIONS(3086),
    [anon_sym_constinit] = ACTIONS(3086),
    [anon_sym_consteval] = ACTIONS(3086),
    [anon_sym_alignas] = ACTIONS(3086),
    [anon_sym__Alignas] = ACTIONS(3086),
    [sym_primitive_type] = ACTIONS(3086),
    [anon_sym_enum] = ACTIONS(3086),
    [anon_sym_class] = ACTIONS(3086),
    [anon_sym_struct] = ACTIONS(3086),
    [anon_sym_union] = ACTIONS(3086),
    [anon_sym_if] = ACTIONS(3086),
    [anon_sym_switch] = ACTIONS(3086),
    [anon_sym_case] = ACTIONS(3086),
    [anon_sym_default] = ACTIONS(3086),
    [anon_sym_while] = ACTIONS(3086),
    [anon_sym_do] = ACTIONS(3086),
    [anon_sym_for] = ACTIONS(3086),
    [anon_sym_return] = ACTIONS(3086),
    [anon_sym_break] = ACTIONS(3086),
    [anon_sym_continue] = ACTIONS(3086),
    [anon_sym_goto] = ACTIONS(3086),
    [anon_sym___try] = ACTIONS(3086),
    [anon_sym___leave] = ACTIONS(3086),
    [anon_sym_not] = ACTIONS(3086),
    [anon_sym_compl] = ACTIONS(3086),
    [anon_sym_DASH_DASH] = ACTIONS(3089),
    [anon_sym_PLUS_PLUS] = ACTIONS(3089),
    [anon_sym_sizeof] = ACTIONS(3086),
    [anon_sym___alignof__] = ACTIONS(3086),
    [anon_sym___alignof] = ACTIONS(3086),
    [anon_sym__alignof] = ACTIONS(3086),
    [anon_sym_alignof] = ACTIONS(3086),
    [anon_sym__Alignof] = ACTIONS(3086),
    [anon_sym_offsetof] = ACTIONS(3086),
    [anon_sym__Generic] = ACTIONS(3086),
    [anon_sym_asm] = ACTIONS(3086),
    [anon_sym___asm__] = ACTIONS(3086),
    [anon_sym___asm] = ACTIONS(3086),
    [sym_number_literal] = ACTIONS(3089),
    [anon_sym_L_SQUOTE] = ACTIONS(3089),
    [anon_sym_u_SQUOTE] = ACTIONS(3089),
    [anon_sym_U_SQUOTE] = ACTIONS(3089),
    [anon_sym_u8_SQUOTE] = ACTIONS(3089),
    [anon_sym_SQUOTE] = ACTIONS(3089),
    [anon_sym_L_DQUOTE] = ACTIONS(3089),
    [anon_sym_u_DQUOTE] = ACTIONS(3089),
    [anon_sym_U_DQUOTE] = ACTIONS(3089),
    [anon_sym_u8_DQUOTE] = ACTIONS(3089),
    [anon_sym_DQUOTE] = ACTIONS(3089),
    [sym_true] = ACTIONS(3086),
    [sym_false] = ACTIONS(3086),
    [anon_sym_NULL] = ACTIONS(3086),
    [anon_sym_nullptr] = ACTIONS(3086),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3086),
    [anon_sym_decltype] = ACTIONS(3086),
    [anon_sym_explicit] = ACTIONS(3086),
    [anon_sym_typename] = ACTIONS(3086),
    [anon_sym_template] = ACTIONS(3086),
    [anon_sym_operator] = ACTIONS(3086),
    [anon_sym_try] = ACTIONS(3086),
    [anon_sym_delete] = ACTIONS(3086),
    [anon_sym_throw] = ACTIONS(3086),
    [anon_sym_namespace] = ACTIONS(3086),
    [anon_sym_using] = ACTIONS(3086),
    [anon_sym_static_assert] = ACTIONS(3086),
    [anon_sym_concept] = ACTIONS(3086),
    [anon_sym_co_return] = ACTIONS(3086),
    [anon_sym_co_yield] = ACTIONS(3086),
    [anon_sym_R_DQUOTE] = ACTIONS(3089),
    [anon_sym_LR_DQUOTE] = ACTIONS(3089),
    [anon_sym_uR_DQUOTE] = ACTIONS(3089),
    [anon_sym_UR_DQUOTE] = ACTIONS(3089),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3089),
    [anon_sym_co_await] = ACTIONS(3086),
    [anon_sym_new] = ACTIONS(3086),
    [anon_sym_requires] = ACTIONS(3086),
    [sym_this] = ACTIONS(3086),
  },
  [594] = {
    [sym_identifier] = ACTIONS(2763),
    [aux_sym_preproc_include_token1] = ACTIONS(2763),
    [aux_sym_preproc_def_token1] = ACTIONS(2763),
    [aux_sym_preproc_if_token1] = ACTIONS(2763),
    [aux_sym_preproc_if_token2] = ACTIONS(2763),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2763),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2763),
    [sym_preproc_directive] = ACTIONS(2763),
    [anon_sym_LPAREN2] = ACTIONS(2765),
    [anon_sym_BANG] = ACTIONS(2765),
    [anon_sym_TILDE] = ACTIONS(2765),
    [anon_sym_DASH] = ACTIONS(2763),
    [anon_sym_PLUS] = ACTIONS(2763),
    [anon_sym_STAR] = ACTIONS(2765),
    [anon_sym_AMP_AMP] = ACTIONS(2765),
    [anon_sym_AMP] = ACTIONS(2763),
    [anon_sym_SEMI] = ACTIONS(2765),
    [anon_sym___extension__] = ACTIONS(2763),
    [anon_sym_typedef] = ACTIONS(2763),
    [anon_sym_virtual] = ACTIONS(2763),
    [anon_sym_extern] = ACTIONS(2763),
    [anon_sym___attribute__] = ACTIONS(2763),
    [anon_sym___attribute] = ACTIONS(2763),
    [anon_sym_COLON_COLON] = ACTIONS(2765),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2765),
    [anon_sym___declspec] = ACTIONS(2763),
    [anon_sym___based] = ACTIONS(2763),
    [anon_sym___cdecl] = ACTIONS(2763),
    [anon_sym___clrcall] = ACTIONS(2763),
    [anon_sym___stdcall] = ACTIONS(2763),
    [anon_sym___fastcall] = ACTIONS(2763),
    [anon_sym___thiscall] = ACTIONS(2763),
    [anon_sym___vectorcall] = ACTIONS(2763),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_signed] = ACTIONS(2763),
    [anon_sym_unsigned] = ACTIONS(2763),
    [anon_sym_long] = ACTIONS(2763),
    [anon_sym_short] = ACTIONS(2763),
    [anon_sym_LBRACK] = ACTIONS(2763),
    [anon_sym_static] = ACTIONS(2763),
    [anon_sym_register] = ACTIONS(2763),
    [anon_sym_inline] = ACTIONS(2763),
    [anon_sym___inline] = ACTIONS(2763),
    [anon_sym___inline__] = ACTIONS(2763),
    [anon_sym___forceinline] = ACTIONS(2763),
    [anon_sym_thread_local] = ACTIONS(2763),
    [anon_sym___thread] = ACTIONS(2763),
    [anon_sym_const] = ACTIONS(2763),
    [anon_sym_constexpr] = ACTIONS(2763),
    [anon_sym_volatile] = ACTIONS(2763),
    [anon_sym_restrict] = ACTIONS(2763),
    [anon_sym___restrict__] = ACTIONS(2763),
    [anon_sym__Atomic] = ACTIONS(2763),
    [anon_sym__Noreturn] = ACTIONS(2763),
    [anon_sym_noreturn] = ACTIONS(2763),
    [anon_sym__Nonnull] = ACTIONS(2763),
    [anon_sym_mutable] = ACTIONS(2763),
    [anon_sym_constinit] = ACTIONS(2763),
    [anon_sym_consteval] = ACTIONS(2763),
    [anon_sym_alignas] = ACTIONS(2763),
    [anon_sym__Alignas] = ACTIONS(2763),
    [sym_primitive_type] = ACTIONS(2763),
    [anon_sym_enum] = ACTIONS(2763),
    [anon_sym_class] = ACTIONS(2763),
    [anon_sym_struct] = ACTIONS(2763),
    [anon_sym_union] = ACTIONS(2763),
    [anon_sym_if] = ACTIONS(2763),
    [anon_sym_switch] = ACTIONS(2763),
    [anon_sym_case] = ACTIONS(2763),
    [anon_sym_default] = ACTIONS(2763),
    [anon_sym_while] = ACTIONS(2763),
    [anon_sym_do] = ACTIONS(2763),
    [anon_sym_for] = ACTIONS(2763),
    [anon_sym_return] = ACTIONS(2763),
    [anon_sym_break] = ACTIONS(2763),
    [anon_sym_continue] = ACTIONS(2763),
    [anon_sym_goto] = ACTIONS(2763),
    [anon_sym___try] = ACTIONS(2763),
    [anon_sym___leave] = ACTIONS(2763),
    [anon_sym_not] = ACTIONS(2763),
    [anon_sym_compl] = ACTIONS(2763),
    [anon_sym_DASH_DASH] = ACTIONS(2765),
    [anon_sym_PLUS_PLUS] = ACTIONS(2765),
    [anon_sym_sizeof] = ACTIONS(2763),
    [anon_sym___alignof__] = ACTIONS(2763),
    [anon_sym___alignof] = ACTIONS(2763),
    [anon_sym__alignof] = ACTIONS(2763),
    [anon_sym_alignof] = ACTIONS(2763),
    [anon_sym__Alignof] = ACTIONS(2763),
    [anon_sym_offsetof] = ACTIONS(2763),
    [anon_sym__Generic] = ACTIONS(2763),
    [anon_sym_asm] = ACTIONS(2763),
    [anon_sym___asm__] = ACTIONS(2763),
    [anon_sym___asm] = ACTIONS(2763),
    [sym_number_literal] = ACTIONS(2765),
    [anon_sym_L_SQUOTE] = ACTIONS(2765),
    [anon_sym_u_SQUOTE] = ACTIONS(2765),
    [anon_sym_U_SQUOTE] = ACTIONS(2765),
    [anon_sym_u8_SQUOTE] = ACTIONS(2765),
    [anon_sym_SQUOTE] = ACTIONS(2765),
    [anon_sym_L_DQUOTE] = ACTIONS(2765),
    [anon_sym_u_DQUOTE] = ACTIONS(2765),
    [anon_sym_U_DQUOTE] = ACTIONS(2765),
    [anon_sym_u8_DQUOTE] = ACTIONS(2765),
    [anon_sym_DQUOTE] = ACTIONS(2765),
    [sym_true] = ACTIONS(2763),
    [sym_false] = ACTIONS(2763),
    [anon_sym_NULL] = ACTIONS(2763),
    [anon_sym_nullptr] = ACTIONS(2763),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2763),
    [anon_sym_decltype] = ACTIONS(2763),
    [anon_sym_explicit] = ACTIONS(2763),
    [anon_sym_typename] = ACTIONS(2763),
    [anon_sym_template] = ACTIONS(2763),
    [anon_sym_operator] = ACTIONS(2763),
    [anon_sym_try] = ACTIONS(2763),
    [anon_sym_delete] = ACTIONS(2763),
    [anon_sym_throw] = ACTIONS(2763),
    [anon_sym_namespace] = ACTIONS(2763),
    [anon_sym_using] = ACTIONS(2763),
    [anon_sym_static_assert] = ACTIONS(2763),
    [anon_sym_concept] = ACTIONS(2763),
    [anon_sym_co_return] = ACTIONS(2763),
    [anon_sym_co_yield] = ACTIONS(2763),
    [anon_sym_R_DQUOTE] = ACTIONS(2765),
    [anon_sym_LR_DQUOTE] = ACTIONS(2765),
    [anon_sym_uR_DQUOTE] = ACTIONS(2765),
    [anon_sym_UR_DQUOTE] = ACTIONS(2765),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2765),
    [anon_sym_co_await] = ACTIONS(2763),
    [anon_sym_new] = ACTIONS(2763),
    [anon_sym_requires] = ACTIONS(2763),
    [sym_this] = ACTIONS(2763),
  },
  [595] = {
    [sym_identifier] = ACTIONS(3162),
    [aux_sym_preproc_include_token1] = ACTIONS(3162),
    [aux_sym_preproc_def_token1] = ACTIONS(3162),
    [aux_sym_preproc_if_token1] = ACTIONS(3162),
    [aux_sym_preproc_if_token2] = ACTIONS(3162),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3162),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3162),
    [sym_preproc_directive] = ACTIONS(3162),
    [anon_sym_LPAREN2] = ACTIONS(3164),
    [anon_sym_BANG] = ACTIONS(3164),
    [anon_sym_TILDE] = ACTIONS(3164),
    [anon_sym_DASH] = ACTIONS(3162),
    [anon_sym_PLUS] = ACTIONS(3162),
    [anon_sym_STAR] = ACTIONS(3164),
    [anon_sym_AMP_AMP] = ACTIONS(3164),
    [anon_sym_AMP] = ACTIONS(3162),
    [anon_sym_SEMI] = ACTIONS(3164),
    [anon_sym___extension__] = ACTIONS(3162),
    [anon_sym_typedef] = ACTIONS(3162),
    [anon_sym_virtual] = ACTIONS(3162),
    [anon_sym_extern] = ACTIONS(3162),
    [anon_sym___attribute__] = ACTIONS(3162),
    [anon_sym___attribute] = ACTIONS(3162),
    [anon_sym_COLON_COLON] = ACTIONS(3164),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3164),
    [anon_sym___declspec] = ACTIONS(3162),
    [anon_sym___based] = ACTIONS(3162),
    [anon_sym___cdecl] = ACTIONS(3162),
    [anon_sym___clrcall] = ACTIONS(3162),
    [anon_sym___stdcall] = ACTIONS(3162),
    [anon_sym___fastcall] = ACTIONS(3162),
    [anon_sym___thiscall] = ACTIONS(3162),
    [anon_sym___vectorcall] = ACTIONS(3162),
    [anon_sym_LBRACE] = ACTIONS(3164),
    [anon_sym_signed] = ACTIONS(3162),
    [anon_sym_unsigned] = ACTIONS(3162),
    [anon_sym_long] = ACTIONS(3162),
    [anon_sym_short] = ACTIONS(3162),
    [anon_sym_LBRACK] = ACTIONS(3162),
    [anon_sym_static] = ACTIONS(3162),
    [anon_sym_register] = ACTIONS(3162),
    [anon_sym_inline] = ACTIONS(3162),
    [anon_sym___inline] = ACTIONS(3162),
    [anon_sym___inline__] = ACTIONS(3162),
    [anon_sym___forceinline] = ACTIONS(3162),
    [anon_sym_thread_local] = ACTIONS(3162),
    [anon_sym___thread] = ACTIONS(3162),
    [anon_sym_const] = ACTIONS(3162),
    [anon_sym_constexpr] = ACTIONS(3162),
    [anon_sym_volatile] = ACTIONS(3162),
    [anon_sym_restrict] = ACTIONS(3162),
    [anon_sym___restrict__] = ACTIONS(3162),
    [anon_sym__Atomic] = ACTIONS(3162),
    [anon_sym__Noreturn] = ACTIONS(3162),
    [anon_sym_noreturn] = ACTIONS(3162),
    [anon_sym__Nonnull] = ACTIONS(3162),
    [anon_sym_mutable] = ACTIONS(3162),
    [anon_sym_constinit] = ACTIONS(3162),
    [anon_sym_consteval] = ACTIONS(3162),
    [anon_sym_alignas] = ACTIONS(3162),
    [anon_sym__Alignas] = ACTIONS(3162),
    [sym_primitive_type] = ACTIONS(3162),
    [anon_sym_enum] = ACTIONS(3162),
    [anon_sym_class] = ACTIONS(3162),
    [anon_sym_struct] = ACTIONS(3162),
    [anon_sym_union] = ACTIONS(3162),
    [anon_sym_if] = ACTIONS(3162),
    [anon_sym_switch] = ACTIONS(3162),
    [anon_sym_case] = ACTIONS(3162),
    [anon_sym_default] = ACTIONS(3162),
    [anon_sym_while] = ACTIONS(3162),
    [anon_sym_do] = ACTIONS(3162),
    [anon_sym_for] = ACTIONS(3162),
    [anon_sym_return] = ACTIONS(3162),
    [anon_sym_break] = ACTIONS(3162),
    [anon_sym_continue] = ACTIONS(3162),
    [anon_sym_goto] = ACTIONS(3162),
    [anon_sym___try] = ACTIONS(3162),
    [anon_sym___leave] = ACTIONS(3162),
    [anon_sym_not] = ACTIONS(3162),
    [anon_sym_compl] = ACTIONS(3162),
    [anon_sym_DASH_DASH] = ACTIONS(3164),
    [anon_sym_PLUS_PLUS] = ACTIONS(3164),
    [anon_sym_sizeof] = ACTIONS(3162),
    [anon_sym___alignof__] = ACTIONS(3162),
    [anon_sym___alignof] = ACTIONS(3162),
    [anon_sym__alignof] = ACTIONS(3162),
    [anon_sym_alignof] = ACTIONS(3162),
    [anon_sym__Alignof] = ACTIONS(3162),
    [anon_sym_offsetof] = ACTIONS(3162),
    [anon_sym__Generic] = ACTIONS(3162),
    [anon_sym_asm] = ACTIONS(3162),
    [anon_sym___asm__] = ACTIONS(3162),
    [anon_sym___asm] = ACTIONS(3162),
    [sym_number_literal] = ACTIONS(3164),
    [anon_sym_L_SQUOTE] = ACTIONS(3164),
    [anon_sym_u_SQUOTE] = ACTIONS(3164),
    [anon_sym_U_SQUOTE] = ACTIONS(3164),
    [anon_sym_u8_SQUOTE] = ACTIONS(3164),
    [anon_sym_SQUOTE] = ACTIONS(3164),
    [anon_sym_L_DQUOTE] = ACTIONS(3164),
    [anon_sym_u_DQUOTE] = ACTIONS(3164),
    [anon_sym_U_DQUOTE] = ACTIONS(3164),
    [anon_sym_u8_DQUOTE] = ACTIONS(3164),
    [anon_sym_DQUOTE] = ACTIONS(3164),
    [sym_true] = ACTIONS(3162),
    [sym_false] = ACTIONS(3162),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3162),
    [anon_sym_decltype] = ACTIONS(3162),
    [anon_sym_explicit] = ACTIONS(3162),
    [anon_sym_typename] = ACTIONS(3162),
    [anon_sym_template] = ACTIONS(3162),
    [anon_sym_operator] = ACTIONS(3162),
    [anon_sym_try] = ACTIONS(3162),
    [anon_sym_delete] = ACTIONS(3162),
    [anon_sym_throw] = ACTIONS(3162),
    [anon_sym_namespace] = ACTIONS(3162),
    [anon_sym_using] = ACTIONS(3162),
    [anon_sym_static_assert] = ACTIONS(3162),
    [anon_sym_concept] = ACTIONS(3162),
    [anon_sym_co_return] = ACTIONS(3162),
    [anon_sym_co_yield] = ACTIONS(3162),
    [anon_sym_R_DQUOTE] = ACTIONS(3164),
    [anon_sym_LR_DQUOTE] = ACTIONS(3164),
    [anon_sym_uR_DQUOTE] = ACTIONS(3164),
    [anon_sym_UR_DQUOTE] = ACTIONS(3164),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3164),
    [anon_sym_co_await] = ACTIONS(3162),
    [anon_sym_new] = ACTIONS(3162),
    [anon_sym_requires] = ACTIONS(3162),
    [sym_this] = ACTIONS(3162),
  },
  [596] = {
    [sym_identifier] = ACTIONS(3142),
    [aux_sym_preproc_include_token1] = ACTIONS(3142),
    [aux_sym_preproc_def_token1] = ACTIONS(3142),
    [aux_sym_preproc_if_token1] = ACTIONS(3142),
    [aux_sym_preproc_if_token2] = ACTIONS(3142),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3142),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3142),
    [sym_preproc_directive] = ACTIONS(3142),
    [anon_sym_LPAREN2] = ACTIONS(3144),
    [anon_sym_BANG] = ACTIONS(3144),
    [anon_sym_TILDE] = ACTIONS(3144),
    [anon_sym_DASH] = ACTIONS(3142),
    [anon_sym_PLUS] = ACTIONS(3142),
    [anon_sym_STAR] = ACTIONS(3144),
    [anon_sym_AMP_AMP] = ACTIONS(3144),
    [anon_sym_AMP] = ACTIONS(3142),
    [anon_sym_SEMI] = ACTIONS(3144),
    [anon_sym___extension__] = ACTIONS(3142),
    [anon_sym_typedef] = ACTIONS(3142),
    [anon_sym_virtual] = ACTIONS(3142),
    [anon_sym_extern] = ACTIONS(3142),
    [anon_sym___attribute__] = ACTIONS(3142),
    [anon_sym___attribute] = ACTIONS(3142),
    [anon_sym_COLON_COLON] = ACTIONS(3144),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3144),
    [anon_sym___declspec] = ACTIONS(3142),
    [anon_sym___based] = ACTIONS(3142),
    [anon_sym___cdecl] = ACTIONS(3142),
    [anon_sym___clrcall] = ACTIONS(3142),
    [anon_sym___stdcall] = ACTIONS(3142),
    [anon_sym___fastcall] = ACTIONS(3142),
    [anon_sym___thiscall] = ACTIONS(3142),
    [anon_sym___vectorcall] = ACTIONS(3142),
    [anon_sym_LBRACE] = ACTIONS(3144),
    [anon_sym_signed] = ACTIONS(3142),
    [anon_sym_unsigned] = ACTIONS(3142),
    [anon_sym_long] = ACTIONS(3142),
    [anon_sym_short] = ACTIONS(3142),
    [anon_sym_LBRACK] = ACTIONS(3142),
    [anon_sym_static] = ACTIONS(3142),
    [anon_sym_register] = ACTIONS(3142),
    [anon_sym_inline] = ACTIONS(3142),
    [anon_sym___inline] = ACTIONS(3142),
    [anon_sym___inline__] = ACTIONS(3142),
    [anon_sym___forceinline] = ACTIONS(3142),
    [anon_sym_thread_local] = ACTIONS(3142),
    [anon_sym___thread] = ACTIONS(3142),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_constexpr] = ACTIONS(3142),
    [anon_sym_volatile] = ACTIONS(3142),
    [anon_sym_restrict] = ACTIONS(3142),
    [anon_sym___restrict__] = ACTIONS(3142),
    [anon_sym__Atomic] = ACTIONS(3142),
    [anon_sym__Noreturn] = ACTIONS(3142),
    [anon_sym_noreturn] = ACTIONS(3142),
    [anon_sym__Nonnull] = ACTIONS(3142),
    [anon_sym_mutable] = ACTIONS(3142),
    [anon_sym_constinit] = ACTIONS(3142),
    [anon_sym_consteval] = ACTIONS(3142),
    [anon_sym_alignas] = ACTIONS(3142),
    [anon_sym__Alignas] = ACTIONS(3142),
    [sym_primitive_type] = ACTIONS(3142),
    [anon_sym_enum] = ACTIONS(3142),
    [anon_sym_class] = ACTIONS(3142),
    [anon_sym_struct] = ACTIONS(3142),
    [anon_sym_union] = ACTIONS(3142),
    [anon_sym_if] = ACTIONS(3142),
    [anon_sym_switch] = ACTIONS(3142),
    [anon_sym_case] = ACTIONS(3142),
    [anon_sym_default] = ACTIONS(3142),
    [anon_sym_while] = ACTIONS(3142),
    [anon_sym_do] = ACTIONS(3142),
    [anon_sym_for] = ACTIONS(3142),
    [anon_sym_return] = ACTIONS(3142),
    [anon_sym_break] = ACTIONS(3142),
    [anon_sym_continue] = ACTIONS(3142),
    [anon_sym_goto] = ACTIONS(3142),
    [anon_sym___try] = ACTIONS(3142),
    [anon_sym___leave] = ACTIONS(3142),
    [anon_sym_not] = ACTIONS(3142),
    [anon_sym_compl] = ACTIONS(3142),
    [anon_sym_DASH_DASH] = ACTIONS(3144),
    [anon_sym_PLUS_PLUS] = ACTIONS(3144),
    [anon_sym_sizeof] = ACTIONS(3142),
    [anon_sym___alignof__] = ACTIONS(3142),
    [anon_sym___alignof] = ACTIONS(3142),
    [anon_sym__alignof] = ACTIONS(3142),
    [anon_sym_alignof] = ACTIONS(3142),
    [anon_sym__Alignof] = ACTIONS(3142),
    [anon_sym_offsetof] = ACTIONS(3142),
    [anon_sym__Generic] = ACTIONS(3142),
    [anon_sym_asm] = ACTIONS(3142),
    [anon_sym___asm__] = ACTIONS(3142),
    [anon_sym___asm] = ACTIONS(3142),
    [sym_number_literal] = ACTIONS(3144),
    [anon_sym_L_SQUOTE] = ACTIONS(3144),
    [anon_sym_u_SQUOTE] = ACTIONS(3144),
    [anon_sym_U_SQUOTE] = ACTIONS(3144),
    [anon_sym_u8_SQUOTE] = ACTIONS(3144),
    [anon_sym_SQUOTE] = ACTIONS(3144),
    [anon_sym_L_DQUOTE] = ACTIONS(3144),
    [anon_sym_u_DQUOTE] = ACTIONS(3144),
    [anon_sym_U_DQUOTE] = ACTIONS(3144),
    [anon_sym_u8_DQUOTE] = ACTIONS(3144),
    [anon_sym_DQUOTE] = ACTIONS(3144),
    [sym_true] = ACTIONS(3142),
    [sym_false] = ACTIONS(3142),
    [anon_sym_NULL] = ACTIONS(3142),
    [anon_sym_nullptr] = ACTIONS(3142),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3142),
    [anon_sym_decltype] = ACTIONS(3142),
    [anon_sym_explicit] = ACTIONS(3142),
    [anon_sym_typename] = ACTIONS(3142),
    [anon_sym_template] = ACTIONS(3142),
    [anon_sym_operator] = ACTIONS(3142),
    [anon_sym_try] = ACTIONS(3142),
    [anon_sym_delete] = ACTIONS(3142),
    [anon_sym_throw] = ACTIONS(3142),
    [anon_sym_namespace] = ACTIONS(3142),
    [anon_sym_using] = ACTIONS(3142),
    [anon_sym_static_assert] = ACTIONS(3142),
    [anon_sym_concept] = ACTIONS(3142),
    [anon_sym_co_return] = ACTIONS(3142),
    [anon_sym_co_yield] = ACTIONS(3142),
    [anon_sym_R_DQUOTE] = ACTIONS(3144),
    [anon_sym_LR_DQUOTE] = ACTIONS(3144),
    [anon_sym_uR_DQUOTE] = ACTIONS(3144),
    [anon_sym_UR_DQUOTE] = ACTIONS(3144),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3144),
    [anon_sym_co_await] = ACTIONS(3142),
    [anon_sym_new] = ACTIONS(3142),
    [anon_sym_requires] = ACTIONS(3142),
    [sym_this] = ACTIONS(3142),
  },
  [597] = {
    [ts_builtin_sym_end] = ACTIONS(2982),
    [sym_identifier] = ACTIONS(2980),
    [aux_sym_preproc_include_token1] = ACTIONS(2980),
    [aux_sym_preproc_def_token1] = ACTIONS(2980),
    [anon_sym_COMMA] = ACTIONS(2982),
    [aux_sym_preproc_if_token1] = ACTIONS(2980),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2980),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2980),
    [sym_preproc_directive] = ACTIONS(2980),
    [anon_sym_LPAREN2] = ACTIONS(2982),
    [anon_sym_BANG] = ACTIONS(2982),
    [anon_sym_TILDE] = ACTIONS(2982),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP_AMP] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2980),
    [anon_sym_SEMI] = ACTIONS(2982),
    [anon_sym___extension__] = ACTIONS(2980),
    [anon_sym_typedef] = ACTIONS(2980),
    [anon_sym_virtual] = ACTIONS(2980),
    [anon_sym_extern] = ACTIONS(2980),
    [anon_sym___attribute__] = ACTIONS(2980),
    [anon_sym___attribute] = ACTIONS(2980),
    [anon_sym_COLON_COLON] = ACTIONS(2982),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2982),
    [anon_sym___declspec] = ACTIONS(2980),
    [anon_sym___based] = ACTIONS(2980),
    [anon_sym___cdecl] = ACTIONS(2980),
    [anon_sym___clrcall] = ACTIONS(2980),
    [anon_sym___stdcall] = ACTIONS(2980),
    [anon_sym___fastcall] = ACTIONS(2980),
    [anon_sym___thiscall] = ACTIONS(2980),
    [anon_sym___vectorcall] = ACTIONS(2980),
    [anon_sym_LBRACE] = ACTIONS(2982),
    [anon_sym_RBRACE] = ACTIONS(2982),
    [anon_sym_signed] = ACTIONS(2980),
    [anon_sym_unsigned] = ACTIONS(2980),
    [anon_sym_long] = ACTIONS(2980),
    [anon_sym_short] = ACTIONS(2980),
    [anon_sym_LBRACK] = ACTIONS(2980),
    [anon_sym_static] = ACTIONS(2980),
    [anon_sym_register] = ACTIONS(2980),
    [anon_sym_inline] = ACTIONS(2980),
    [anon_sym___inline] = ACTIONS(2980),
    [anon_sym___inline__] = ACTIONS(2980),
    [anon_sym___forceinline] = ACTIONS(2980),
    [anon_sym_thread_local] = ACTIONS(2980),
    [anon_sym___thread] = ACTIONS(2980),
    [anon_sym_const] = ACTIONS(2980),
    [anon_sym_constexpr] = ACTIONS(2980),
    [anon_sym_volatile] = ACTIONS(2980),
    [anon_sym_restrict] = ACTIONS(2980),
    [anon_sym___restrict__] = ACTIONS(2980),
    [anon_sym__Atomic] = ACTIONS(2980),
    [anon_sym__Noreturn] = ACTIONS(2980),
    [anon_sym_noreturn] = ACTIONS(2980),
    [anon_sym__Nonnull] = ACTIONS(2980),
    [anon_sym_mutable] = ACTIONS(2980),
    [anon_sym_constinit] = ACTIONS(2980),
    [anon_sym_consteval] = ACTIONS(2980),
    [anon_sym_alignas] = ACTIONS(2980),
    [anon_sym__Alignas] = ACTIONS(2980),
    [sym_primitive_type] = ACTIONS(2980),
    [anon_sym_enum] = ACTIONS(2980),
    [anon_sym_class] = ACTIONS(2980),
    [anon_sym_struct] = ACTIONS(2980),
    [anon_sym_union] = ACTIONS(2980),
    [anon_sym_if] = ACTIONS(2980),
    [anon_sym_switch] = ACTIONS(2980),
    [anon_sym_case] = ACTIONS(2980),
    [anon_sym_default] = ACTIONS(2980),
    [anon_sym_while] = ACTIONS(2980),
    [anon_sym_do] = ACTIONS(2980),
    [anon_sym_for] = ACTIONS(2980),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_break] = ACTIONS(2980),
    [anon_sym_continue] = ACTIONS(2980),
    [anon_sym_goto] = ACTIONS(2980),
    [anon_sym_not] = ACTIONS(2980),
    [anon_sym_compl] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2982),
    [anon_sym_PLUS_PLUS] = ACTIONS(2982),
    [anon_sym_sizeof] = ACTIONS(2980),
    [anon_sym___alignof__] = ACTIONS(2980),
    [anon_sym___alignof] = ACTIONS(2980),
    [anon_sym__alignof] = ACTIONS(2980),
    [anon_sym_alignof] = ACTIONS(2980),
    [anon_sym__Alignof] = ACTIONS(2980),
    [anon_sym_offsetof] = ACTIONS(2980),
    [anon_sym__Generic] = ACTIONS(2980),
    [anon_sym_asm] = ACTIONS(2980),
    [anon_sym___asm__] = ACTIONS(2980),
    [anon_sym___asm] = ACTIONS(2980),
    [sym_number_literal] = ACTIONS(2982),
    [anon_sym_L_SQUOTE] = ACTIONS(2982),
    [anon_sym_u_SQUOTE] = ACTIONS(2982),
    [anon_sym_U_SQUOTE] = ACTIONS(2982),
    [anon_sym_u8_SQUOTE] = ACTIONS(2982),
    [anon_sym_SQUOTE] = ACTIONS(2982),
    [anon_sym_L_DQUOTE] = ACTIONS(2982),
    [anon_sym_u_DQUOTE] = ACTIONS(2982),
    [anon_sym_U_DQUOTE] = ACTIONS(2982),
    [anon_sym_u8_DQUOTE] = ACTIONS(2982),
    [anon_sym_DQUOTE] = ACTIONS(2982),
    [sym_true] = ACTIONS(2980),
    [sym_false] = ACTIONS(2980),
    [anon_sym_NULL] = ACTIONS(2980),
    [anon_sym_nullptr] = ACTIONS(2980),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2980),
    [anon_sym_decltype] = ACTIONS(2980),
    [anon_sym_explicit] = ACTIONS(2980),
    [anon_sym_typename] = ACTIONS(2980),
    [anon_sym_template] = ACTIONS(2980),
    [anon_sym_operator] = ACTIONS(2980),
    [anon_sym_try] = ACTIONS(2980),
    [anon_sym_delete] = ACTIONS(2980),
    [anon_sym_throw] = ACTIONS(2980),
    [anon_sym_namespace] = ACTIONS(2980),
    [anon_sym_using] = ACTIONS(2980),
    [anon_sym_static_assert] = ACTIONS(2980),
    [anon_sym_concept] = ACTIONS(2980),
    [anon_sym_co_return] = ACTIONS(2980),
    [anon_sym_co_yield] = ACTIONS(2980),
    [anon_sym_R_DQUOTE] = ACTIONS(2982),
    [anon_sym_LR_DQUOTE] = ACTIONS(2982),
    [anon_sym_uR_DQUOTE] = ACTIONS(2982),
    [anon_sym_UR_DQUOTE] = ACTIONS(2982),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2982),
    [anon_sym_co_await] = ACTIONS(2980),
    [anon_sym_new] = ACTIONS(2980),
    [anon_sym_requires] = ACTIONS(2980),
    [sym_this] = ACTIONS(2980),
  },
  [598] = {
    [sym_preproc_def] = STATE(598),
    [sym_preproc_function_def] = STATE(598),
    [sym_preproc_call] = STATE(598),
    [sym_preproc_if_in_field_declaration_list] = STATE(598),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(598),
    [sym_type_definition] = STATE(598),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(5496),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6181),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__field_declaration_list_item] = STATE(598),
    [sym_field_declaration] = STATE(598),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1743),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(598),
    [sym_operator_cast] = STATE(6702),
    [sym_inline_method_definition] = STATE(598),
    [sym__constructor_specifiers] = STATE(1743),
    [sym_operator_cast_definition] = STATE(598),
    [sym_operator_cast_declaration] = STATE(598),
    [sym_constructor_or_destructor_definition] = STATE(598),
    [sym_constructor_or_destructor_declaration] = STATE(598),
    [sym_friend_declaration] = STATE(598),
    [sym_access_specifier] = STATE(7776),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_using_declaration] = STATE(598),
    [sym_alias_declaration] = STATE(598),
    [sym_static_assert_declaration] = STATE(598),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5383),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6702),
    [sym_operator_name] = STATE(5896),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(598),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2008),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1743),
    [sym_identifier] = ACTIONS(3330),
    [aux_sym_preproc_def_token1] = ACTIONS(3333),
    [aux_sym_preproc_if_token1] = ACTIONS(3336),
    [aux_sym_preproc_if_token2] = ACTIONS(3339),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3341),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3341),
    [aux_sym_preproc_else_token1] = ACTIONS(3339),
    [aux_sym_preproc_elif_token1] = ACTIONS(3339),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3339),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3339),
    [sym_preproc_directive] = ACTIONS(3344),
    [anon_sym_LPAREN2] = ACTIONS(3347),
    [anon_sym_TILDE] = ACTIONS(3350),
    [anon_sym_STAR] = ACTIONS(3353),
    [anon_sym_AMP_AMP] = ACTIONS(3356),
    [anon_sym_AMP] = ACTIONS(3359),
    [anon_sym_SEMI] = ACTIONS(3362),
    [anon_sym___extension__] = ACTIONS(3365),
    [anon_sym_typedef] = ACTIONS(3368),
    [anon_sym_virtual] = ACTIONS(3371),
    [anon_sym_extern] = ACTIONS(3374),
    [anon_sym___attribute__] = ACTIONS(3377),
    [anon_sym___attribute] = ACTIONS(3377),
    [anon_sym_COLON_COLON] = ACTIONS(3380),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3383),
    [anon_sym___declspec] = ACTIONS(3386),
    [anon_sym___based] = ACTIONS(3389),
    [anon_sym_signed] = ACTIONS(3392),
    [anon_sym_unsigned] = ACTIONS(3392),
    [anon_sym_long] = ACTIONS(3392),
    [anon_sym_short] = ACTIONS(3392),
    [anon_sym_LBRACK] = ACTIONS(3395),
    [anon_sym_static] = ACTIONS(3374),
    [anon_sym_register] = ACTIONS(3374),
    [anon_sym_inline] = ACTIONS(3374),
    [anon_sym___inline] = ACTIONS(3374),
    [anon_sym___inline__] = ACTIONS(3374),
    [anon_sym___forceinline] = ACTIONS(3374),
    [anon_sym_thread_local] = ACTIONS(3374),
    [anon_sym___thread] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3398),
    [anon_sym_constexpr] = ACTIONS(3401),
    [anon_sym_volatile] = ACTIONS(3398),
    [anon_sym_restrict] = ACTIONS(3398),
    [anon_sym___restrict__] = ACTIONS(3398),
    [anon_sym__Atomic] = ACTIONS(3398),
    [anon_sym__Noreturn] = ACTIONS(3398),
    [anon_sym_noreturn] = ACTIONS(3398),
    [anon_sym__Nonnull] = ACTIONS(3398),
    [anon_sym_mutable] = ACTIONS(3398),
    [anon_sym_constinit] = ACTIONS(3398),
    [anon_sym_consteval] = ACTIONS(3398),
    [anon_sym_alignas] = ACTIONS(3404),
    [anon_sym__Alignas] = ACTIONS(3404),
    [sym_primitive_type] = ACTIONS(3407),
    [anon_sym_enum] = ACTIONS(3410),
    [anon_sym_class] = ACTIONS(3413),
    [anon_sym_struct] = ACTIONS(3416),
    [anon_sym_union] = ACTIONS(3419),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3422),
    [anon_sym_decltype] = ACTIONS(3425),
    [anon_sym_explicit] = ACTIONS(3428),
    [anon_sym_typename] = ACTIONS(3431),
    [anon_sym_template] = ACTIONS(3434),
    [anon_sym_operator] = ACTIONS(3437),
    [anon_sym_friend] = ACTIONS(3440),
    [anon_sym_public] = ACTIONS(3443),
    [anon_sym_private] = ACTIONS(3443),
    [anon_sym_protected] = ACTIONS(3443),
    [anon_sym_using] = ACTIONS(3446),
    [anon_sym_static_assert] = ACTIONS(3449),
  },
  [599] = {
    [sym_identifier] = ACTIONS(2751),
    [aux_sym_preproc_include_token1] = ACTIONS(2751),
    [aux_sym_preproc_def_token1] = ACTIONS(2751),
    [aux_sym_preproc_if_token1] = ACTIONS(2751),
    [aux_sym_preproc_if_token2] = ACTIONS(2751),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2751),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2751),
    [sym_preproc_directive] = ACTIONS(2751),
    [anon_sym_LPAREN2] = ACTIONS(2753),
    [anon_sym_BANG] = ACTIONS(2753),
    [anon_sym_TILDE] = ACTIONS(2753),
    [anon_sym_DASH] = ACTIONS(2751),
    [anon_sym_PLUS] = ACTIONS(2751),
    [anon_sym_STAR] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2751),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym___extension__] = ACTIONS(2751),
    [anon_sym_typedef] = ACTIONS(2751),
    [anon_sym_virtual] = ACTIONS(2751),
    [anon_sym_extern] = ACTIONS(2751),
    [anon_sym___attribute__] = ACTIONS(2751),
    [anon_sym___attribute] = ACTIONS(2751),
    [anon_sym_COLON_COLON] = ACTIONS(2753),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2753),
    [anon_sym___declspec] = ACTIONS(2751),
    [anon_sym___based] = ACTIONS(2751),
    [anon_sym___cdecl] = ACTIONS(2751),
    [anon_sym___clrcall] = ACTIONS(2751),
    [anon_sym___stdcall] = ACTIONS(2751),
    [anon_sym___fastcall] = ACTIONS(2751),
    [anon_sym___thiscall] = ACTIONS(2751),
    [anon_sym___vectorcall] = ACTIONS(2751),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_signed] = ACTIONS(2751),
    [anon_sym_unsigned] = ACTIONS(2751),
    [anon_sym_long] = ACTIONS(2751),
    [anon_sym_short] = ACTIONS(2751),
    [anon_sym_LBRACK] = ACTIONS(2751),
    [anon_sym_static] = ACTIONS(2751),
    [anon_sym_register] = ACTIONS(2751),
    [anon_sym_inline] = ACTIONS(2751),
    [anon_sym___inline] = ACTIONS(2751),
    [anon_sym___inline__] = ACTIONS(2751),
    [anon_sym___forceinline] = ACTIONS(2751),
    [anon_sym_thread_local] = ACTIONS(2751),
    [anon_sym___thread] = ACTIONS(2751),
    [anon_sym_const] = ACTIONS(2751),
    [anon_sym_constexpr] = ACTIONS(2751),
    [anon_sym_volatile] = ACTIONS(2751),
    [anon_sym_restrict] = ACTIONS(2751),
    [anon_sym___restrict__] = ACTIONS(2751),
    [anon_sym__Atomic] = ACTIONS(2751),
    [anon_sym__Noreturn] = ACTIONS(2751),
    [anon_sym_noreturn] = ACTIONS(2751),
    [anon_sym__Nonnull] = ACTIONS(2751),
    [anon_sym_mutable] = ACTIONS(2751),
    [anon_sym_constinit] = ACTIONS(2751),
    [anon_sym_consteval] = ACTIONS(2751),
    [anon_sym_alignas] = ACTIONS(2751),
    [anon_sym__Alignas] = ACTIONS(2751),
    [sym_primitive_type] = ACTIONS(2751),
    [anon_sym_enum] = ACTIONS(2751),
    [anon_sym_class] = ACTIONS(2751),
    [anon_sym_struct] = ACTIONS(2751),
    [anon_sym_union] = ACTIONS(2751),
    [anon_sym_if] = ACTIONS(2751),
    [anon_sym_switch] = ACTIONS(2751),
    [anon_sym_case] = ACTIONS(2751),
    [anon_sym_default] = ACTIONS(2751),
    [anon_sym_while] = ACTIONS(2751),
    [anon_sym_do] = ACTIONS(2751),
    [anon_sym_for] = ACTIONS(2751),
    [anon_sym_return] = ACTIONS(2751),
    [anon_sym_break] = ACTIONS(2751),
    [anon_sym_continue] = ACTIONS(2751),
    [anon_sym_goto] = ACTIONS(2751),
    [anon_sym___try] = ACTIONS(2751),
    [anon_sym___leave] = ACTIONS(2751),
    [anon_sym_not] = ACTIONS(2751),
    [anon_sym_compl] = ACTIONS(2751),
    [anon_sym_DASH_DASH] = ACTIONS(2753),
    [anon_sym_PLUS_PLUS] = ACTIONS(2753),
    [anon_sym_sizeof] = ACTIONS(2751),
    [anon_sym___alignof__] = ACTIONS(2751),
    [anon_sym___alignof] = ACTIONS(2751),
    [anon_sym__alignof] = ACTIONS(2751),
    [anon_sym_alignof] = ACTIONS(2751),
    [anon_sym__Alignof] = ACTIONS(2751),
    [anon_sym_offsetof] = ACTIONS(2751),
    [anon_sym__Generic] = ACTIONS(2751),
    [anon_sym_asm] = ACTIONS(2751),
    [anon_sym___asm__] = ACTIONS(2751),
    [anon_sym___asm] = ACTIONS(2751),
    [sym_number_literal] = ACTIONS(2753),
    [anon_sym_L_SQUOTE] = ACTIONS(2753),
    [anon_sym_u_SQUOTE] = ACTIONS(2753),
    [anon_sym_U_SQUOTE] = ACTIONS(2753),
    [anon_sym_u8_SQUOTE] = ACTIONS(2753),
    [anon_sym_SQUOTE] = ACTIONS(2753),
    [anon_sym_L_DQUOTE] = ACTIONS(2753),
    [anon_sym_u_DQUOTE] = ACTIONS(2753),
    [anon_sym_U_DQUOTE] = ACTIONS(2753),
    [anon_sym_u8_DQUOTE] = ACTIONS(2753),
    [anon_sym_DQUOTE] = ACTIONS(2753),
    [sym_true] = ACTIONS(2751),
    [sym_false] = ACTIONS(2751),
    [anon_sym_NULL] = ACTIONS(2751),
    [anon_sym_nullptr] = ACTIONS(2751),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2751),
    [anon_sym_decltype] = ACTIONS(2751),
    [anon_sym_explicit] = ACTIONS(2751),
    [anon_sym_typename] = ACTIONS(2751),
    [anon_sym_template] = ACTIONS(2751),
    [anon_sym_operator] = ACTIONS(2751),
    [anon_sym_try] = ACTIONS(2751),
    [anon_sym_delete] = ACTIONS(2751),
    [anon_sym_throw] = ACTIONS(2751),
    [anon_sym_namespace] = ACTIONS(2751),
    [anon_sym_using] = ACTIONS(2751),
    [anon_sym_static_assert] = ACTIONS(2751),
    [anon_sym_concept] = ACTIONS(2751),
    [anon_sym_co_return] = ACTIONS(2751),
    [anon_sym_co_yield] = ACTIONS(2751),
    [anon_sym_R_DQUOTE] = ACTIONS(2753),
    [anon_sym_LR_DQUOTE] = ACTIONS(2753),
    [anon_sym_uR_DQUOTE] = ACTIONS(2753),
    [anon_sym_UR_DQUOTE] = ACTIONS(2753),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2753),
    [anon_sym_co_await] = ACTIONS(2751),
    [anon_sym_new] = ACTIONS(2751),
    [anon_sym_requires] = ACTIONS(2751),
    [sym_this] = ACTIONS(2751),
  },
  [600] = {
    [ts_builtin_sym_end] = ACTIONS(2962),
    [sym_identifier] = ACTIONS(2960),
    [aux_sym_preproc_include_token1] = ACTIONS(2960),
    [aux_sym_preproc_def_token1] = ACTIONS(2960),
    [anon_sym_COMMA] = ACTIONS(2962),
    [aux_sym_preproc_if_token1] = ACTIONS(2960),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2960),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2960),
    [sym_preproc_directive] = ACTIONS(2960),
    [anon_sym_LPAREN2] = ACTIONS(2962),
    [anon_sym_BANG] = ACTIONS(2962),
    [anon_sym_TILDE] = ACTIONS(2962),
    [anon_sym_DASH] = ACTIONS(2960),
    [anon_sym_PLUS] = ACTIONS(2960),
    [anon_sym_STAR] = ACTIONS(2962),
    [anon_sym_AMP_AMP] = ACTIONS(2962),
    [anon_sym_AMP] = ACTIONS(2960),
    [anon_sym_SEMI] = ACTIONS(2962),
    [anon_sym___extension__] = ACTIONS(2960),
    [anon_sym_typedef] = ACTIONS(2960),
    [anon_sym_virtual] = ACTIONS(2960),
    [anon_sym_extern] = ACTIONS(2960),
    [anon_sym___attribute__] = ACTIONS(2960),
    [anon_sym___attribute] = ACTIONS(2960),
    [anon_sym_COLON_COLON] = ACTIONS(2962),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2962),
    [anon_sym___declspec] = ACTIONS(2960),
    [anon_sym___based] = ACTIONS(2960),
    [anon_sym___cdecl] = ACTIONS(2960),
    [anon_sym___clrcall] = ACTIONS(2960),
    [anon_sym___stdcall] = ACTIONS(2960),
    [anon_sym___fastcall] = ACTIONS(2960),
    [anon_sym___thiscall] = ACTIONS(2960),
    [anon_sym___vectorcall] = ACTIONS(2960),
    [anon_sym_LBRACE] = ACTIONS(2962),
    [anon_sym_RBRACE] = ACTIONS(2962),
    [anon_sym_signed] = ACTIONS(2960),
    [anon_sym_unsigned] = ACTIONS(2960),
    [anon_sym_long] = ACTIONS(2960),
    [anon_sym_short] = ACTIONS(2960),
    [anon_sym_LBRACK] = ACTIONS(2960),
    [anon_sym_static] = ACTIONS(2960),
    [anon_sym_register] = ACTIONS(2960),
    [anon_sym_inline] = ACTIONS(2960),
    [anon_sym___inline] = ACTIONS(2960),
    [anon_sym___inline__] = ACTIONS(2960),
    [anon_sym___forceinline] = ACTIONS(2960),
    [anon_sym_thread_local] = ACTIONS(2960),
    [anon_sym___thread] = ACTIONS(2960),
    [anon_sym_const] = ACTIONS(2960),
    [anon_sym_constexpr] = ACTIONS(2960),
    [anon_sym_volatile] = ACTIONS(2960),
    [anon_sym_restrict] = ACTIONS(2960),
    [anon_sym___restrict__] = ACTIONS(2960),
    [anon_sym__Atomic] = ACTIONS(2960),
    [anon_sym__Noreturn] = ACTIONS(2960),
    [anon_sym_noreturn] = ACTIONS(2960),
    [anon_sym__Nonnull] = ACTIONS(2960),
    [anon_sym_mutable] = ACTIONS(2960),
    [anon_sym_constinit] = ACTIONS(2960),
    [anon_sym_consteval] = ACTIONS(2960),
    [anon_sym_alignas] = ACTIONS(2960),
    [anon_sym__Alignas] = ACTIONS(2960),
    [sym_primitive_type] = ACTIONS(2960),
    [anon_sym_enum] = ACTIONS(2960),
    [anon_sym_class] = ACTIONS(2960),
    [anon_sym_struct] = ACTIONS(2960),
    [anon_sym_union] = ACTIONS(2960),
    [anon_sym_if] = ACTIONS(2960),
    [anon_sym_switch] = ACTIONS(2960),
    [anon_sym_case] = ACTIONS(2960),
    [anon_sym_default] = ACTIONS(2960),
    [anon_sym_while] = ACTIONS(2960),
    [anon_sym_do] = ACTIONS(2960),
    [anon_sym_for] = ACTIONS(2960),
    [anon_sym_return] = ACTIONS(2960),
    [anon_sym_break] = ACTIONS(2960),
    [anon_sym_continue] = ACTIONS(2960),
    [anon_sym_goto] = ACTIONS(2960),
    [anon_sym_not] = ACTIONS(2960),
    [anon_sym_compl] = ACTIONS(2960),
    [anon_sym_DASH_DASH] = ACTIONS(2962),
    [anon_sym_PLUS_PLUS] = ACTIONS(2962),
    [anon_sym_sizeof] = ACTIONS(2960),
    [anon_sym___alignof__] = ACTIONS(2960),
    [anon_sym___alignof] = ACTIONS(2960),
    [anon_sym__alignof] = ACTIONS(2960),
    [anon_sym_alignof] = ACTIONS(2960),
    [anon_sym__Alignof] = ACTIONS(2960),
    [anon_sym_offsetof] = ACTIONS(2960),
    [anon_sym__Generic] = ACTIONS(2960),
    [anon_sym_asm] = ACTIONS(2960),
    [anon_sym___asm__] = ACTIONS(2960),
    [anon_sym___asm] = ACTIONS(2960),
    [sym_number_literal] = ACTIONS(2962),
    [anon_sym_L_SQUOTE] = ACTIONS(2962),
    [anon_sym_u_SQUOTE] = ACTIONS(2962),
    [anon_sym_U_SQUOTE] = ACTIONS(2962),
    [anon_sym_u8_SQUOTE] = ACTIONS(2962),
    [anon_sym_SQUOTE] = ACTIONS(2962),
    [anon_sym_L_DQUOTE] = ACTIONS(2962),
    [anon_sym_u_DQUOTE] = ACTIONS(2962),
    [anon_sym_U_DQUOTE] = ACTIONS(2962),
    [anon_sym_u8_DQUOTE] = ACTIONS(2962),
    [anon_sym_DQUOTE] = ACTIONS(2962),
    [sym_true] = ACTIONS(2960),
    [sym_false] = ACTIONS(2960),
    [anon_sym_NULL] = ACTIONS(2960),
    [anon_sym_nullptr] = ACTIONS(2960),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2960),
    [anon_sym_decltype] = ACTIONS(2960),
    [anon_sym_explicit] = ACTIONS(2960),
    [anon_sym_typename] = ACTIONS(2960),
    [anon_sym_template] = ACTIONS(2960),
    [anon_sym_operator] = ACTIONS(2960),
    [anon_sym_try] = ACTIONS(2960),
    [anon_sym_delete] = ACTIONS(2960),
    [anon_sym_throw] = ACTIONS(2960),
    [anon_sym_namespace] = ACTIONS(2960),
    [anon_sym_using] = ACTIONS(2960),
    [anon_sym_static_assert] = ACTIONS(2960),
    [anon_sym_concept] = ACTIONS(2960),
    [anon_sym_co_return] = ACTIONS(2960),
    [anon_sym_co_yield] = ACTIONS(2960),
    [anon_sym_R_DQUOTE] = ACTIONS(2962),
    [anon_sym_LR_DQUOTE] = ACTIONS(2962),
    [anon_sym_uR_DQUOTE] = ACTIONS(2962),
    [anon_sym_UR_DQUOTE] = ACTIONS(2962),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2962),
    [anon_sym_co_await] = ACTIONS(2960),
    [anon_sym_new] = ACTIONS(2960),
    [anon_sym_requires] = ACTIONS(2960),
    [sym_this] = ACTIONS(2960),
  },
  [601] = {
    [sym_identifier] = ACTIONS(2842),
    [aux_sym_preproc_include_token1] = ACTIONS(2842),
    [aux_sym_preproc_def_token1] = ACTIONS(2842),
    [aux_sym_preproc_if_token1] = ACTIONS(2842),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2842),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2842),
    [sym_preproc_directive] = ACTIONS(2842),
    [anon_sym_LPAREN2] = ACTIONS(2844),
    [anon_sym_BANG] = ACTIONS(2844),
    [anon_sym_TILDE] = ACTIONS(2844),
    [anon_sym_DASH] = ACTIONS(2842),
    [anon_sym_PLUS] = ACTIONS(2842),
    [anon_sym_STAR] = ACTIONS(2844),
    [anon_sym_AMP_AMP] = ACTIONS(2844),
    [anon_sym_AMP] = ACTIONS(2842),
    [anon_sym_SEMI] = ACTIONS(2844),
    [anon_sym___extension__] = ACTIONS(2842),
    [anon_sym_typedef] = ACTIONS(2842),
    [anon_sym_virtual] = ACTIONS(2842),
    [anon_sym_extern] = ACTIONS(2842),
    [anon_sym___attribute__] = ACTIONS(2842),
    [anon_sym___attribute] = ACTIONS(2842),
    [anon_sym_COLON_COLON] = ACTIONS(2844),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2844),
    [anon_sym___declspec] = ACTIONS(2842),
    [anon_sym___based] = ACTIONS(2842),
    [anon_sym___cdecl] = ACTIONS(2842),
    [anon_sym___clrcall] = ACTIONS(2842),
    [anon_sym___stdcall] = ACTIONS(2842),
    [anon_sym___fastcall] = ACTIONS(2842),
    [anon_sym___thiscall] = ACTIONS(2842),
    [anon_sym___vectorcall] = ACTIONS(2842),
    [anon_sym_LBRACE] = ACTIONS(2844),
    [anon_sym_RBRACE] = ACTIONS(2844),
    [anon_sym_signed] = ACTIONS(2842),
    [anon_sym_unsigned] = ACTIONS(2842),
    [anon_sym_long] = ACTIONS(2842),
    [anon_sym_short] = ACTIONS(2842),
    [anon_sym_LBRACK] = ACTIONS(2842),
    [anon_sym_static] = ACTIONS(2842),
    [anon_sym_register] = ACTIONS(2842),
    [anon_sym_inline] = ACTIONS(2842),
    [anon_sym___inline] = ACTIONS(2842),
    [anon_sym___inline__] = ACTIONS(2842),
    [anon_sym___forceinline] = ACTIONS(2842),
    [anon_sym_thread_local] = ACTIONS(2842),
    [anon_sym___thread] = ACTIONS(2842),
    [anon_sym_const] = ACTIONS(2842),
    [anon_sym_constexpr] = ACTIONS(2842),
    [anon_sym_volatile] = ACTIONS(2842),
    [anon_sym_restrict] = ACTIONS(2842),
    [anon_sym___restrict__] = ACTIONS(2842),
    [anon_sym__Atomic] = ACTIONS(2842),
    [anon_sym__Noreturn] = ACTIONS(2842),
    [anon_sym_noreturn] = ACTIONS(2842),
    [anon_sym__Nonnull] = ACTIONS(2842),
    [anon_sym_mutable] = ACTIONS(2842),
    [anon_sym_constinit] = ACTIONS(2842),
    [anon_sym_consteval] = ACTIONS(2842),
    [anon_sym_alignas] = ACTIONS(2842),
    [anon_sym__Alignas] = ACTIONS(2842),
    [sym_primitive_type] = ACTIONS(2842),
    [anon_sym_enum] = ACTIONS(2842),
    [anon_sym_class] = ACTIONS(2842),
    [anon_sym_struct] = ACTIONS(2842),
    [anon_sym_union] = ACTIONS(2842),
    [anon_sym_if] = ACTIONS(2842),
    [anon_sym_switch] = ACTIONS(2842),
    [anon_sym_case] = ACTIONS(2842),
    [anon_sym_default] = ACTIONS(2842),
    [anon_sym_while] = ACTIONS(2842),
    [anon_sym_do] = ACTIONS(2842),
    [anon_sym_for] = ACTIONS(2842),
    [anon_sym_return] = ACTIONS(2842),
    [anon_sym_break] = ACTIONS(2842),
    [anon_sym_continue] = ACTIONS(2842),
    [anon_sym_goto] = ACTIONS(2842),
    [anon_sym___try] = ACTIONS(2842),
    [anon_sym___leave] = ACTIONS(2842),
    [anon_sym_not] = ACTIONS(2842),
    [anon_sym_compl] = ACTIONS(2842),
    [anon_sym_DASH_DASH] = ACTIONS(2844),
    [anon_sym_PLUS_PLUS] = ACTIONS(2844),
    [anon_sym_sizeof] = ACTIONS(2842),
    [anon_sym___alignof__] = ACTIONS(2842),
    [anon_sym___alignof] = ACTIONS(2842),
    [anon_sym__alignof] = ACTIONS(2842),
    [anon_sym_alignof] = ACTIONS(2842),
    [anon_sym__Alignof] = ACTIONS(2842),
    [anon_sym_offsetof] = ACTIONS(2842),
    [anon_sym__Generic] = ACTIONS(2842),
    [anon_sym_asm] = ACTIONS(2842),
    [anon_sym___asm__] = ACTIONS(2842),
    [anon_sym___asm] = ACTIONS(2842),
    [sym_number_literal] = ACTIONS(2844),
    [anon_sym_L_SQUOTE] = ACTIONS(2844),
    [anon_sym_u_SQUOTE] = ACTIONS(2844),
    [anon_sym_U_SQUOTE] = ACTIONS(2844),
    [anon_sym_u8_SQUOTE] = ACTIONS(2844),
    [anon_sym_SQUOTE] = ACTIONS(2844),
    [anon_sym_L_DQUOTE] = ACTIONS(2844),
    [anon_sym_u_DQUOTE] = ACTIONS(2844),
    [anon_sym_U_DQUOTE] = ACTIONS(2844),
    [anon_sym_u8_DQUOTE] = ACTIONS(2844),
    [anon_sym_DQUOTE] = ACTIONS(2844),
    [sym_true] = ACTIONS(2842),
    [sym_false] = ACTIONS(2842),
    [anon_sym_NULL] = ACTIONS(2842),
    [anon_sym_nullptr] = ACTIONS(2842),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2842),
    [anon_sym_decltype] = ACTIONS(2842),
    [anon_sym_explicit] = ACTIONS(2842),
    [anon_sym_typename] = ACTIONS(2842),
    [anon_sym_template] = ACTIONS(2842),
    [anon_sym_operator] = ACTIONS(2842),
    [anon_sym_try] = ACTIONS(2842),
    [anon_sym_delete] = ACTIONS(2842),
    [anon_sym_throw] = ACTIONS(2842),
    [anon_sym_namespace] = ACTIONS(2842),
    [anon_sym_using] = ACTIONS(2842),
    [anon_sym_static_assert] = ACTIONS(2842),
    [anon_sym_concept] = ACTIONS(2842),
    [anon_sym_co_return] = ACTIONS(2842),
    [anon_sym_co_yield] = ACTIONS(2842),
    [anon_sym_R_DQUOTE] = ACTIONS(2844),
    [anon_sym_LR_DQUOTE] = ACTIONS(2844),
    [anon_sym_uR_DQUOTE] = ACTIONS(2844),
    [anon_sym_UR_DQUOTE] = ACTIONS(2844),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2844),
    [anon_sym_co_await] = ACTIONS(2842),
    [anon_sym_new] = ACTIONS(2842),
    [anon_sym_requires] = ACTIONS(2842),
    [sym_this] = ACTIONS(2842),
  },
  [602] = {
    [sym_identifier] = ACTIONS(2846),
    [aux_sym_preproc_include_token1] = ACTIONS(2846),
    [aux_sym_preproc_def_token1] = ACTIONS(2846),
    [aux_sym_preproc_if_token1] = ACTIONS(2846),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2846),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2846),
    [sym_preproc_directive] = ACTIONS(2846),
    [anon_sym_LPAREN2] = ACTIONS(2848),
    [anon_sym_BANG] = ACTIONS(2848),
    [anon_sym_TILDE] = ACTIONS(2848),
    [anon_sym_DASH] = ACTIONS(2846),
    [anon_sym_PLUS] = ACTIONS(2846),
    [anon_sym_STAR] = ACTIONS(2848),
    [anon_sym_AMP_AMP] = ACTIONS(2848),
    [anon_sym_AMP] = ACTIONS(2846),
    [anon_sym_SEMI] = ACTIONS(2848),
    [anon_sym___extension__] = ACTIONS(2846),
    [anon_sym_typedef] = ACTIONS(2846),
    [anon_sym_virtual] = ACTIONS(2846),
    [anon_sym_extern] = ACTIONS(2846),
    [anon_sym___attribute__] = ACTIONS(2846),
    [anon_sym___attribute] = ACTIONS(2846),
    [anon_sym_COLON_COLON] = ACTIONS(2848),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2848),
    [anon_sym___declspec] = ACTIONS(2846),
    [anon_sym___based] = ACTIONS(2846),
    [anon_sym___cdecl] = ACTIONS(2846),
    [anon_sym___clrcall] = ACTIONS(2846),
    [anon_sym___stdcall] = ACTIONS(2846),
    [anon_sym___fastcall] = ACTIONS(2846),
    [anon_sym___thiscall] = ACTIONS(2846),
    [anon_sym___vectorcall] = ACTIONS(2846),
    [anon_sym_LBRACE] = ACTIONS(2848),
    [anon_sym_RBRACE] = ACTIONS(2848),
    [anon_sym_signed] = ACTIONS(2846),
    [anon_sym_unsigned] = ACTIONS(2846),
    [anon_sym_long] = ACTIONS(2846),
    [anon_sym_short] = ACTIONS(2846),
    [anon_sym_LBRACK] = ACTIONS(2846),
    [anon_sym_static] = ACTIONS(2846),
    [anon_sym_register] = ACTIONS(2846),
    [anon_sym_inline] = ACTIONS(2846),
    [anon_sym___inline] = ACTIONS(2846),
    [anon_sym___inline__] = ACTIONS(2846),
    [anon_sym___forceinline] = ACTIONS(2846),
    [anon_sym_thread_local] = ACTIONS(2846),
    [anon_sym___thread] = ACTIONS(2846),
    [anon_sym_const] = ACTIONS(2846),
    [anon_sym_constexpr] = ACTIONS(2846),
    [anon_sym_volatile] = ACTIONS(2846),
    [anon_sym_restrict] = ACTIONS(2846),
    [anon_sym___restrict__] = ACTIONS(2846),
    [anon_sym__Atomic] = ACTIONS(2846),
    [anon_sym__Noreturn] = ACTIONS(2846),
    [anon_sym_noreturn] = ACTIONS(2846),
    [anon_sym__Nonnull] = ACTIONS(2846),
    [anon_sym_mutable] = ACTIONS(2846),
    [anon_sym_constinit] = ACTIONS(2846),
    [anon_sym_consteval] = ACTIONS(2846),
    [anon_sym_alignas] = ACTIONS(2846),
    [anon_sym__Alignas] = ACTIONS(2846),
    [sym_primitive_type] = ACTIONS(2846),
    [anon_sym_enum] = ACTIONS(2846),
    [anon_sym_class] = ACTIONS(2846),
    [anon_sym_struct] = ACTIONS(2846),
    [anon_sym_union] = ACTIONS(2846),
    [anon_sym_if] = ACTIONS(2846),
    [anon_sym_switch] = ACTIONS(2846),
    [anon_sym_case] = ACTIONS(2846),
    [anon_sym_default] = ACTIONS(2846),
    [anon_sym_while] = ACTIONS(2846),
    [anon_sym_do] = ACTIONS(2846),
    [anon_sym_for] = ACTIONS(2846),
    [anon_sym_return] = ACTIONS(2846),
    [anon_sym_break] = ACTIONS(2846),
    [anon_sym_continue] = ACTIONS(2846),
    [anon_sym_goto] = ACTIONS(2846),
    [anon_sym___try] = ACTIONS(2846),
    [anon_sym___leave] = ACTIONS(2846),
    [anon_sym_not] = ACTIONS(2846),
    [anon_sym_compl] = ACTIONS(2846),
    [anon_sym_DASH_DASH] = ACTIONS(2848),
    [anon_sym_PLUS_PLUS] = ACTIONS(2848),
    [anon_sym_sizeof] = ACTIONS(2846),
    [anon_sym___alignof__] = ACTIONS(2846),
    [anon_sym___alignof] = ACTIONS(2846),
    [anon_sym__alignof] = ACTIONS(2846),
    [anon_sym_alignof] = ACTIONS(2846),
    [anon_sym__Alignof] = ACTIONS(2846),
    [anon_sym_offsetof] = ACTIONS(2846),
    [anon_sym__Generic] = ACTIONS(2846),
    [anon_sym_asm] = ACTIONS(2846),
    [anon_sym___asm__] = ACTIONS(2846),
    [anon_sym___asm] = ACTIONS(2846),
    [sym_number_literal] = ACTIONS(2848),
    [anon_sym_L_SQUOTE] = ACTIONS(2848),
    [anon_sym_u_SQUOTE] = ACTIONS(2848),
    [anon_sym_U_SQUOTE] = ACTIONS(2848),
    [anon_sym_u8_SQUOTE] = ACTIONS(2848),
    [anon_sym_SQUOTE] = ACTIONS(2848),
    [anon_sym_L_DQUOTE] = ACTIONS(2848),
    [anon_sym_u_DQUOTE] = ACTIONS(2848),
    [anon_sym_U_DQUOTE] = ACTIONS(2848),
    [anon_sym_u8_DQUOTE] = ACTIONS(2848),
    [anon_sym_DQUOTE] = ACTIONS(2848),
    [sym_true] = ACTIONS(2846),
    [sym_false] = ACTIONS(2846),
    [anon_sym_NULL] = ACTIONS(2846),
    [anon_sym_nullptr] = ACTIONS(2846),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2846),
    [anon_sym_decltype] = ACTIONS(2846),
    [anon_sym_explicit] = ACTIONS(2846),
    [anon_sym_typename] = ACTIONS(2846),
    [anon_sym_template] = ACTIONS(2846),
    [anon_sym_operator] = ACTIONS(2846),
    [anon_sym_try] = ACTIONS(2846),
    [anon_sym_delete] = ACTIONS(2846),
    [anon_sym_throw] = ACTIONS(2846),
    [anon_sym_namespace] = ACTIONS(2846),
    [anon_sym_using] = ACTIONS(2846),
    [anon_sym_static_assert] = ACTIONS(2846),
    [anon_sym_concept] = ACTIONS(2846),
    [anon_sym_co_return] = ACTIONS(2846),
    [anon_sym_co_yield] = ACTIONS(2846),
    [anon_sym_R_DQUOTE] = ACTIONS(2848),
    [anon_sym_LR_DQUOTE] = ACTIONS(2848),
    [anon_sym_uR_DQUOTE] = ACTIONS(2848),
    [anon_sym_UR_DQUOTE] = ACTIONS(2848),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2848),
    [anon_sym_co_await] = ACTIONS(2846),
    [anon_sym_new] = ACTIONS(2846),
    [anon_sym_requires] = ACTIONS(2846),
    [sym_this] = ACTIONS(2846),
  },
  [603] = {
    [sym_identifier] = ACTIONS(3166),
    [aux_sym_preproc_include_token1] = ACTIONS(3166),
    [aux_sym_preproc_def_token1] = ACTIONS(3166),
    [aux_sym_preproc_if_token1] = ACTIONS(3166),
    [aux_sym_preproc_if_token2] = ACTIONS(3166),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3166),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3166),
    [sym_preproc_directive] = ACTIONS(3166),
    [anon_sym_LPAREN2] = ACTIONS(3168),
    [anon_sym_BANG] = ACTIONS(3168),
    [anon_sym_TILDE] = ACTIONS(3168),
    [anon_sym_DASH] = ACTIONS(3166),
    [anon_sym_PLUS] = ACTIONS(3166),
    [anon_sym_STAR] = ACTIONS(3168),
    [anon_sym_AMP_AMP] = ACTIONS(3168),
    [anon_sym_AMP] = ACTIONS(3166),
    [anon_sym_SEMI] = ACTIONS(3168),
    [anon_sym___extension__] = ACTIONS(3166),
    [anon_sym_typedef] = ACTIONS(3166),
    [anon_sym_virtual] = ACTIONS(3166),
    [anon_sym_extern] = ACTIONS(3166),
    [anon_sym___attribute__] = ACTIONS(3166),
    [anon_sym___attribute] = ACTIONS(3166),
    [anon_sym_COLON_COLON] = ACTIONS(3168),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3168),
    [anon_sym___declspec] = ACTIONS(3166),
    [anon_sym___based] = ACTIONS(3166),
    [anon_sym___cdecl] = ACTIONS(3166),
    [anon_sym___clrcall] = ACTIONS(3166),
    [anon_sym___stdcall] = ACTIONS(3166),
    [anon_sym___fastcall] = ACTIONS(3166),
    [anon_sym___thiscall] = ACTIONS(3166),
    [anon_sym___vectorcall] = ACTIONS(3166),
    [anon_sym_LBRACE] = ACTIONS(3168),
    [anon_sym_signed] = ACTIONS(3166),
    [anon_sym_unsigned] = ACTIONS(3166),
    [anon_sym_long] = ACTIONS(3166),
    [anon_sym_short] = ACTIONS(3166),
    [anon_sym_LBRACK] = ACTIONS(3166),
    [anon_sym_static] = ACTIONS(3166),
    [anon_sym_register] = ACTIONS(3166),
    [anon_sym_inline] = ACTIONS(3166),
    [anon_sym___inline] = ACTIONS(3166),
    [anon_sym___inline__] = ACTIONS(3166),
    [anon_sym___forceinline] = ACTIONS(3166),
    [anon_sym_thread_local] = ACTIONS(3166),
    [anon_sym___thread] = ACTIONS(3166),
    [anon_sym_const] = ACTIONS(3166),
    [anon_sym_constexpr] = ACTIONS(3166),
    [anon_sym_volatile] = ACTIONS(3166),
    [anon_sym_restrict] = ACTIONS(3166),
    [anon_sym___restrict__] = ACTIONS(3166),
    [anon_sym__Atomic] = ACTIONS(3166),
    [anon_sym__Noreturn] = ACTIONS(3166),
    [anon_sym_noreturn] = ACTIONS(3166),
    [anon_sym__Nonnull] = ACTIONS(3166),
    [anon_sym_mutable] = ACTIONS(3166),
    [anon_sym_constinit] = ACTIONS(3166),
    [anon_sym_consteval] = ACTIONS(3166),
    [anon_sym_alignas] = ACTIONS(3166),
    [anon_sym__Alignas] = ACTIONS(3166),
    [sym_primitive_type] = ACTIONS(3166),
    [anon_sym_enum] = ACTIONS(3166),
    [anon_sym_class] = ACTIONS(3166),
    [anon_sym_struct] = ACTIONS(3166),
    [anon_sym_union] = ACTIONS(3166),
    [anon_sym_if] = ACTIONS(3166),
    [anon_sym_switch] = ACTIONS(3166),
    [anon_sym_case] = ACTIONS(3166),
    [anon_sym_default] = ACTIONS(3166),
    [anon_sym_while] = ACTIONS(3166),
    [anon_sym_do] = ACTIONS(3166),
    [anon_sym_for] = ACTIONS(3166),
    [anon_sym_return] = ACTIONS(3166),
    [anon_sym_break] = ACTIONS(3166),
    [anon_sym_continue] = ACTIONS(3166),
    [anon_sym_goto] = ACTIONS(3166),
    [anon_sym___try] = ACTIONS(3166),
    [anon_sym___leave] = ACTIONS(3166),
    [anon_sym_not] = ACTIONS(3166),
    [anon_sym_compl] = ACTIONS(3166),
    [anon_sym_DASH_DASH] = ACTIONS(3168),
    [anon_sym_PLUS_PLUS] = ACTIONS(3168),
    [anon_sym_sizeof] = ACTIONS(3166),
    [anon_sym___alignof__] = ACTIONS(3166),
    [anon_sym___alignof] = ACTIONS(3166),
    [anon_sym__alignof] = ACTIONS(3166),
    [anon_sym_alignof] = ACTIONS(3166),
    [anon_sym__Alignof] = ACTIONS(3166),
    [anon_sym_offsetof] = ACTIONS(3166),
    [anon_sym__Generic] = ACTIONS(3166),
    [anon_sym_asm] = ACTIONS(3166),
    [anon_sym___asm__] = ACTIONS(3166),
    [anon_sym___asm] = ACTIONS(3166),
    [sym_number_literal] = ACTIONS(3168),
    [anon_sym_L_SQUOTE] = ACTIONS(3168),
    [anon_sym_u_SQUOTE] = ACTIONS(3168),
    [anon_sym_U_SQUOTE] = ACTIONS(3168),
    [anon_sym_u8_SQUOTE] = ACTIONS(3168),
    [anon_sym_SQUOTE] = ACTIONS(3168),
    [anon_sym_L_DQUOTE] = ACTIONS(3168),
    [anon_sym_u_DQUOTE] = ACTIONS(3168),
    [anon_sym_U_DQUOTE] = ACTIONS(3168),
    [anon_sym_u8_DQUOTE] = ACTIONS(3168),
    [anon_sym_DQUOTE] = ACTIONS(3168),
    [sym_true] = ACTIONS(3166),
    [sym_false] = ACTIONS(3166),
    [anon_sym_NULL] = ACTIONS(3166),
    [anon_sym_nullptr] = ACTIONS(3166),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3166),
    [anon_sym_decltype] = ACTIONS(3166),
    [anon_sym_explicit] = ACTIONS(3166),
    [anon_sym_typename] = ACTIONS(3166),
    [anon_sym_template] = ACTIONS(3166),
    [anon_sym_operator] = ACTIONS(3166),
    [anon_sym_try] = ACTIONS(3166),
    [anon_sym_delete] = ACTIONS(3166),
    [anon_sym_throw] = ACTIONS(3166),
    [anon_sym_namespace] = ACTIONS(3166),
    [anon_sym_using] = ACTIONS(3166),
    [anon_sym_static_assert] = ACTIONS(3166),
    [anon_sym_concept] = ACTIONS(3166),
    [anon_sym_co_return] = ACTIONS(3166),
    [anon_sym_co_yield] = ACTIONS(3166),
    [anon_sym_R_DQUOTE] = ACTIONS(3168),
    [anon_sym_LR_DQUOTE] = ACTIONS(3168),
    [anon_sym_uR_DQUOTE] = ACTIONS(3168),
    [anon_sym_UR_DQUOTE] = ACTIONS(3168),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3168),
    [anon_sym_co_await] = ACTIONS(3166),
    [anon_sym_new] = ACTIONS(3166),
    [anon_sym_requires] = ACTIONS(3166),
    [sym_this] = ACTIONS(3166),
  },
  [604] = {
    [sym_identifier] = ACTIONS(3138),
    [aux_sym_preproc_include_token1] = ACTIONS(3138),
    [aux_sym_preproc_def_token1] = ACTIONS(3138),
    [aux_sym_preproc_if_token1] = ACTIONS(3138),
    [aux_sym_preproc_if_token2] = ACTIONS(3138),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3138),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3138),
    [sym_preproc_directive] = ACTIONS(3138),
    [anon_sym_LPAREN2] = ACTIONS(3140),
    [anon_sym_BANG] = ACTIONS(3140),
    [anon_sym_TILDE] = ACTIONS(3140),
    [anon_sym_DASH] = ACTIONS(3138),
    [anon_sym_PLUS] = ACTIONS(3138),
    [anon_sym_STAR] = ACTIONS(3140),
    [anon_sym_AMP_AMP] = ACTIONS(3140),
    [anon_sym_AMP] = ACTIONS(3138),
    [anon_sym_SEMI] = ACTIONS(3140),
    [anon_sym___extension__] = ACTIONS(3138),
    [anon_sym_typedef] = ACTIONS(3138),
    [anon_sym_virtual] = ACTIONS(3138),
    [anon_sym_extern] = ACTIONS(3138),
    [anon_sym___attribute__] = ACTIONS(3138),
    [anon_sym___attribute] = ACTIONS(3138),
    [anon_sym_COLON_COLON] = ACTIONS(3140),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3140),
    [anon_sym___declspec] = ACTIONS(3138),
    [anon_sym___based] = ACTIONS(3138),
    [anon_sym___cdecl] = ACTIONS(3138),
    [anon_sym___clrcall] = ACTIONS(3138),
    [anon_sym___stdcall] = ACTIONS(3138),
    [anon_sym___fastcall] = ACTIONS(3138),
    [anon_sym___thiscall] = ACTIONS(3138),
    [anon_sym___vectorcall] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [anon_sym_signed] = ACTIONS(3138),
    [anon_sym_unsigned] = ACTIONS(3138),
    [anon_sym_long] = ACTIONS(3138),
    [anon_sym_short] = ACTIONS(3138),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_static] = ACTIONS(3138),
    [anon_sym_register] = ACTIONS(3138),
    [anon_sym_inline] = ACTIONS(3138),
    [anon_sym___inline] = ACTIONS(3138),
    [anon_sym___inline__] = ACTIONS(3138),
    [anon_sym___forceinline] = ACTIONS(3138),
    [anon_sym_thread_local] = ACTIONS(3138),
    [anon_sym___thread] = ACTIONS(3138),
    [anon_sym_const] = ACTIONS(3138),
    [anon_sym_constexpr] = ACTIONS(3138),
    [anon_sym_volatile] = ACTIONS(3138),
    [anon_sym_restrict] = ACTIONS(3138),
    [anon_sym___restrict__] = ACTIONS(3138),
    [anon_sym__Atomic] = ACTIONS(3138),
    [anon_sym__Noreturn] = ACTIONS(3138),
    [anon_sym_noreturn] = ACTIONS(3138),
    [anon_sym__Nonnull] = ACTIONS(3138),
    [anon_sym_mutable] = ACTIONS(3138),
    [anon_sym_constinit] = ACTIONS(3138),
    [anon_sym_consteval] = ACTIONS(3138),
    [anon_sym_alignas] = ACTIONS(3138),
    [anon_sym__Alignas] = ACTIONS(3138),
    [sym_primitive_type] = ACTIONS(3138),
    [anon_sym_enum] = ACTIONS(3138),
    [anon_sym_class] = ACTIONS(3138),
    [anon_sym_struct] = ACTIONS(3138),
    [anon_sym_union] = ACTIONS(3138),
    [anon_sym_if] = ACTIONS(3138),
    [anon_sym_switch] = ACTIONS(3138),
    [anon_sym_case] = ACTIONS(3138),
    [anon_sym_default] = ACTIONS(3138),
    [anon_sym_while] = ACTIONS(3138),
    [anon_sym_do] = ACTIONS(3138),
    [anon_sym_for] = ACTIONS(3138),
    [anon_sym_return] = ACTIONS(3138),
    [anon_sym_break] = ACTIONS(3138),
    [anon_sym_continue] = ACTIONS(3138),
    [anon_sym_goto] = ACTIONS(3138),
    [anon_sym___try] = ACTIONS(3138),
    [anon_sym___leave] = ACTIONS(3138),
    [anon_sym_not] = ACTIONS(3138),
    [anon_sym_compl] = ACTIONS(3138),
    [anon_sym_DASH_DASH] = ACTIONS(3140),
    [anon_sym_PLUS_PLUS] = ACTIONS(3140),
    [anon_sym_sizeof] = ACTIONS(3138),
    [anon_sym___alignof__] = ACTIONS(3138),
    [anon_sym___alignof] = ACTIONS(3138),
    [anon_sym__alignof] = ACTIONS(3138),
    [anon_sym_alignof] = ACTIONS(3138),
    [anon_sym__Alignof] = ACTIONS(3138),
    [anon_sym_offsetof] = ACTIONS(3138),
    [anon_sym__Generic] = ACTIONS(3138),
    [anon_sym_asm] = ACTIONS(3138),
    [anon_sym___asm__] = ACTIONS(3138),
    [anon_sym___asm] = ACTIONS(3138),
    [sym_number_literal] = ACTIONS(3140),
    [anon_sym_L_SQUOTE] = ACTIONS(3140),
    [anon_sym_u_SQUOTE] = ACTIONS(3140),
    [anon_sym_U_SQUOTE] = ACTIONS(3140),
    [anon_sym_u8_SQUOTE] = ACTIONS(3140),
    [anon_sym_SQUOTE] = ACTIONS(3140),
    [anon_sym_L_DQUOTE] = ACTIONS(3140),
    [anon_sym_u_DQUOTE] = ACTIONS(3140),
    [anon_sym_U_DQUOTE] = ACTIONS(3140),
    [anon_sym_u8_DQUOTE] = ACTIONS(3140),
    [anon_sym_DQUOTE] = ACTIONS(3140),
    [sym_true] = ACTIONS(3138),
    [sym_false] = ACTIONS(3138),
    [anon_sym_NULL] = ACTIONS(3138),
    [anon_sym_nullptr] = ACTIONS(3138),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3138),
    [anon_sym_decltype] = ACTIONS(3138),
    [anon_sym_explicit] = ACTIONS(3138),
    [anon_sym_typename] = ACTIONS(3138),
    [anon_sym_template] = ACTIONS(3138),
    [anon_sym_operator] = ACTIONS(3138),
    [anon_sym_try] = ACTIONS(3138),
    [anon_sym_delete] = ACTIONS(3138),
    [anon_sym_throw] = ACTIONS(3138),
    [anon_sym_namespace] = ACTIONS(3138),
    [anon_sym_using] = ACTIONS(3138),
    [anon_sym_static_assert] = ACTIONS(3138),
    [anon_sym_concept] = ACTIONS(3138),
    [anon_sym_co_return] = ACTIONS(3138),
    [anon_sym_co_yield] = ACTIONS(3138),
    [anon_sym_R_DQUOTE] = ACTIONS(3140),
    [anon_sym_LR_DQUOTE] = ACTIONS(3140),
    [anon_sym_uR_DQUOTE] = ACTIONS(3140),
    [anon_sym_UR_DQUOTE] = ACTIONS(3140),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3140),
    [anon_sym_co_await] = ACTIONS(3138),
    [anon_sym_new] = ACTIONS(3138),
    [anon_sym_requires] = ACTIONS(3138),
    [sym_this] = ACTIONS(3138),
  },
  [605] = {
    [ts_builtin_sym_end] = ACTIONS(1911),
    [sym_identifier] = ACTIONS(1913),
    [aux_sym_preproc_include_token1] = ACTIONS(1913),
    [aux_sym_preproc_def_token1] = ACTIONS(1913),
    [anon_sym_COMMA] = ACTIONS(2721),
    [anon_sym_RPAREN] = ACTIONS(2721),
    [aux_sym_preproc_if_token1] = ACTIONS(1913),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1913),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1913),
    [sym_preproc_directive] = ACTIONS(1913),
    [anon_sym_LPAREN2] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_DASH] = ACTIONS(1913),
    [anon_sym_PLUS] = ACTIONS(1913),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_AMP_AMP] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1913),
    [anon_sym_SEMI] = ACTIONS(2721),
    [anon_sym___extension__] = ACTIONS(1913),
    [anon_sym_typedef] = ACTIONS(1913),
    [anon_sym_virtual] = ACTIONS(1913),
    [anon_sym_extern] = ACTIONS(1913),
    [anon_sym___attribute__] = ACTIONS(1913),
    [anon_sym___attribute] = ACTIONS(1913),
    [anon_sym_COLON_COLON] = ACTIONS(1911),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1911),
    [anon_sym___declspec] = ACTIONS(1913),
    [anon_sym___based] = ACTIONS(1913),
    [anon_sym___cdecl] = ACTIONS(1913),
    [anon_sym___clrcall] = ACTIONS(1913),
    [anon_sym___stdcall] = ACTIONS(1913),
    [anon_sym___fastcall] = ACTIONS(1913),
    [anon_sym___thiscall] = ACTIONS(1913),
    [anon_sym___vectorcall] = ACTIONS(1913),
    [anon_sym_LBRACE] = ACTIONS(1911),
    [anon_sym_signed] = ACTIONS(1913),
    [anon_sym_unsigned] = ACTIONS(1913),
    [anon_sym_long] = ACTIONS(1913),
    [anon_sym_short] = ACTIONS(1913),
    [anon_sym_LBRACK] = ACTIONS(1913),
    [anon_sym_static] = ACTIONS(1913),
    [anon_sym_register] = ACTIONS(1913),
    [anon_sym_inline] = ACTIONS(1913),
    [anon_sym___inline] = ACTIONS(1913),
    [anon_sym___inline__] = ACTIONS(1913),
    [anon_sym___forceinline] = ACTIONS(1913),
    [anon_sym_thread_local] = ACTIONS(1913),
    [anon_sym___thread] = ACTIONS(1913),
    [anon_sym_const] = ACTIONS(1913),
    [anon_sym_constexpr] = ACTIONS(1913),
    [anon_sym_volatile] = ACTIONS(1913),
    [anon_sym_restrict] = ACTIONS(1913),
    [anon_sym___restrict__] = ACTIONS(1913),
    [anon_sym__Atomic] = ACTIONS(1913),
    [anon_sym__Noreturn] = ACTIONS(1913),
    [anon_sym_noreturn] = ACTIONS(1913),
    [anon_sym__Nonnull] = ACTIONS(1913),
    [anon_sym_mutable] = ACTIONS(1913),
    [anon_sym_constinit] = ACTIONS(1913),
    [anon_sym_consteval] = ACTIONS(1913),
    [anon_sym_alignas] = ACTIONS(1913),
    [anon_sym__Alignas] = ACTIONS(1913),
    [sym_primitive_type] = ACTIONS(1913),
    [anon_sym_enum] = ACTIONS(1913),
    [anon_sym_class] = ACTIONS(1913),
    [anon_sym_struct] = ACTIONS(1913),
    [anon_sym_union] = ACTIONS(1913),
    [anon_sym_if] = ACTIONS(1913),
    [anon_sym_switch] = ACTIONS(1913),
    [anon_sym_case] = ACTIONS(1913),
    [anon_sym_default] = ACTIONS(1913),
    [anon_sym_while] = ACTIONS(1913),
    [anon_sym_do] = ACTIONS(1913),
    [anon_sym_for] = ACTIONS(1913),
    [anon_sym_return] = ACTIONS(1913),
    [anon_sym_break] = ACTIONS(1913),
    [anon_sym_continue] = ACTIONS(1913),
    [anon_sym_goto] = ACTIONS(1913),
    [anon_sym_not] = ACTIONS(1913),
    [anon_sym_compl] = ACTIONS(1913),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_sizeof] = ACTIONS(1913),
    [anon_sym___alignof__] = ACTIONS(1913),
    [anon_sym___alignof] = ACTIONS(1913),
    [anon_sym__alignof] = ACTIONS(1913),
    [anon_sym_alignof] = ACTIONS(1913),
    [anon_sym__Alignof] = ACTIONS(1913),
    [anon_sym_offsetof] = ACTIONS(1913),
    [anon_sym__Generic] = ACTIONS(1913),
    [anon_sym_asm] = ACTIONS(1913),
    [anon_sym___asm__] = ACTIONS(1913),
    [anon_sym___asm] = ACTIONS(1913),
    [sym_number_literal] = ACTIONS(1911),
    [anon_sym_L_SQUOTE] = ACTIONS(1911),
    [anon_sym_u_SQUOTE] = ACTIONS(1911),
    [anon_sym_U_SQUOTE] = ACTIONS(1911),
    [anon_sym_u8_SQUOTE] = ACTIONS(1911),
    [anon_sym_SQUOTE] = ACTIONS(1911),
    [anon_sym_L_DQUOTE] = ACTIONS(1911),
    [anon_sym_u_DQUOTE] = ACTIONS(1911),
    [anon_sym_U_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8_DQUOTE] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(1911),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1913),
    [anon_sym_nullptr] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1913),
    [anon_sym_decltype] = ACTIONS(1913),
    [anon_sym_explicit] = ACTIONS(1913),
    [anon_sym_typename] = ACTIONS(1913),
    [anon_sym_template] = ACTIONS(1913),
    [anon_sym_operator] = ACTIONS(1913),
    [anon_sym_try] = ACTIONS(1913),
    [anon_sym_delete] = ACTIONS(1913),
    [anon_sym_throw] = ACTIONS(1913),
    [anon_sym_namespace] = ACTIONS(1913),
    [anon_sym_using] = ACTIONS(1913),
    [anon_sym_static_assert] = ACTIONS(1913),
    [anon_sym_concept] = ACTIONS(1913),
    [anon_sym_co_return] = ACTIONS(1913),
    [anon_sym_co_yield] = ACTIONS(1913),
    [anon_sym_R_DQUOTE] = ACTIONS(1911),
    [anon_sym_LR_DQUOTE] = ACTIONS(1911),
    [anon_sym_uR_DQUOTE] = ACTIONS(1911),
    [anon_sym_UR_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1911),
    [anon_sym_co_await] = ACTIONS(1913),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_requires] = ACTIONS(1913),
    [sym_this] = ACTIONS(1913),
  },
  [606] = {
    [sym_identifier] = ACTIONS(2739),
    [aux_sym_preproc_include_token1] = ACTIONS(2739),
    [aux_sym_preproc_def_token1] = ACTIONS(2739),
    [aux_sym_preproc_if_token1] = ACTIONS(2739),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2739),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2739),
    [sym_preproc_directive] = ACTIONS(2739),
    [anon_sym_LPAREN2] = ACTIONS(2741),
    [anon_sym_BANG] = ACTIONS(2741),
    [anon_sym_TILDE] = ACTIONS(2741),
    [anon_sym_DASH] = ACTIONS(2739),
    [anon_sym_PLUS] = ACTIONS(2739),
    [anon_sym_STAR] = ACTIONS(2741),
    [anon_sym_AMP_AMP] = ACTIONS(2741),
    [anon_sym_AMP] = ACTIONS(2739),
    [anon_sym_SEMI] = ACTIONS(2741),
    [anon_sym___extension__] = ACTIONS(2739),
    [anon_sym_typedef] = ACTIONS(2739),
    [anon_sym_virtual] = ACTIONS(2739),
    [anon_sym_extern] = ACTIONS(2739),
    [anon_sym___attribute__] = ACTIONS(2739),
    [anon_sym___attribute] = ACTIONS(2739),
    [anon_sym_COLON_COLON] = ACTIONS(2741),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2741),
    [anon_sym___declspec] = ACTIONS(2739),
    [anon_sym___based] = ACTIONS(2739),
    [anon_sym___cdecl] = ACTIONS(2739),
    [anon_sym___clrcall] = ACTIONS(2739),
    [anon_sym___stdcall] = ACTIONS(2739),
    [anon_sym___fastcall] = ACTIONS(2739),
    [anon_sym___thiscall] = ACTIONS(2739),
    [anon_sym___vectorcall] = ACTIONS(2739),
    [anon_sym_LBRACE] = ACTIONS(2741),
    [anon_sym_RBRACE] = ACTIONS(2741),
    [anon_sym_signed] = ACTIONS(2739),
    [anon_sym_unsigned] = ACTIONS(2739),
    [anon_sym_long] = ACTIONS(2739),
    [anon_sym_short] = ACTIONS(2739),
    [anon_sym_LBRACK] = ACTIONS(2739),
    [anon_sym_static] = ACTIONS(2739),
    [anon_sym_register] = ACTIONS(2739),
    [anon_sym_inline] = ACTIONS(2739),
    [anon_sym___inline] = ACTIONS(2739),
    [anon_sym___inline__] = ACTIONS(2739),
    [anon_sym___forceinline] = ACTIONS(2739),
    [anon_sym_thread_local] = ACTIONS(2739),
    [anon_sym___thread] = ACTIONS(2739),
    [anon_sym_const] = ACTIONS(2739),
    [anon_sym_constexpr] = ACTIONS(2739),
    [anon_sym_volatile] = ACTIONS(2739),
    [anon_sym_restrict] = ACTIONS(2739),
    [anon_sym___restrict__] = ACTIONS(2739),
    [anon_sym__Atomic] = ACTIONS(2739),
    [anon_sym__Noreturn] = ACTIONS(2739),
    [anon_sym_noreturn] = ACTIONS(2739),
    [anon_sym__Nonnull] = ACTIONS(2739),
    [anon_sym_mutable] = ACTIONS(2739),
    [anon_sym_constinit] = ACTIONS(2739),
    [anon_sym_consteval] = ACTIONS(2739),
    [anon_sym_alignas] = ACTIONS(2739),
    [anon_sym__Alignas] = ACTIONS(2739),
    [sym_primitive_type] = ACTIONS(2739),
    [anon_sym_enum] = ACTIONS(2739),
    [anon_sym_class] = ACTIONS(2739),
    [anon_sym_struct] = ACTIONS(2739),
    [anon_sym_union] = ACTIONS(2739),
    [anon_sym_if] = ACTIONS(2739),
    [anon_sym_switch] = ACTIONS(2739),
    [anon_sym_case] = ACTIONS(2739),
    [anon_sym_default] = ACTIONS(2739),
    [anon_sym_while] = ACTIONS(2739),
    [anon_sym_do] = ACTIONS(2739),
    [anon_sym_for] = ACTIONS(2739),
    [anon_sym_return] = ACTIONS(2739),
    [anon_sym_break] = ACTIONS(2739),
    [anon_sym_continue] = ACTIONS(2739),
    [anon_sym_goto] = ACTIONS(2739),
    [anon_sym___try] = ACTIONS(2739),
    [anon_sym___leave] = ACTIONS(2739),
    [anon_sym_not] = ACTIONS(2739),
    [anon_sym_compl] = ACTIONS(2739),
    [anon_sym_DASH_DASH] = ACTIONS(2741),
    [anon_sym_PLUS_PLUS] = ACTIONS(2741),
    [anon_sym_sizeof] = ACTIONS(2739),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2739),
    [anon_sym__Generic] = ACTIONS(2739),
    [anon_sym_asm] = ACTIONS(2739),
    [anon_sym___asm__] = ACTIONS(2739),
    [anon_sym___asm] = ACTIONS(2739),
    [sym_number_literal] = ACTIONS(2741),
    [anon_sym_L_SQUOTE] = ACTIONS(2741),
    [anon_sym_u_SQUOTE] = ACTIONS(2741),
    [anon_sym_U_SQUOTE] = ACTIONS(2741),
    [anon_sym_u8_SQUOTE] = ACTIONS(2741),
    [anon_sym_SQUOTE] = ACTIONS(2741),
    [anon_sym_L_DQUOTE] = ACTIONS(2741),
    [anon_sym_u_DQUOTE] = ACTIONS(2741),
    [anon_sym_U_DQUOTE] = ACTIONS(2741),
    [anon_sym_u8_DQUOTE] = ACTIONS(2741),
    [anon_sym_DQUOTE] = ACTIONS(2741),
    [sym_true] = ACTIONS(2739),
    [sym_false] = ACTIONS(2739),
    [anon_sym_NULL] = ACTIONS(2739),
    [anon_sym_nullptr] = ACTIONS(2739),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2739),
    [anon_sym_decltype] = ACTIONS(2739),
    [anon_sym_explicit] = ACTIONS(2739),
    [anon_sym_typename] = ACTIONS(2739),
    [anon_sym_template] = ACTIONS(2739),
    [anon_sym_operator] = ACTIONS(2739),
    [anon_sym_try] = ACTIONS(2739),
    [anon_sym_delete] = ACTIONS(2739),
    [anon_sym_throw] = ACTIONS(2739),
    [anon_sym_namespace] = ACTIONS(2739),
    [anon_sym_using] = ACTIONS(2739),
    [anon_sym_static_assert] = ACTIONS(2739),
    [anon_sym_concept] = ACTIONS(2739),
    [anon_sym_co_return] = ACTIONS(2739),
    [anon_sym_co_yield] = ACTIONS(2739),
    [anon_sym_R_DQUOTE] = ACTIONS(2741),
    [anon_sym_LR_DQUOTE] = ACTIONS(2741),
    [anon_sym_uR_DQUOTE] = ACTIONS(2741),
    [anon_sym_UR_DQUOTE] = ACTIONS(2741),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2741),
    [anon_sym_co_await] = ACTIONS(2739),
    [anon_sym_new] = ACTIONS(2739),
    [anon_sym_requires] = ACTIONS(2739),
    [sym_this] = ACTIONS(2739),
  },
  [607] = {
    [sym_identifier] = ACTIONS(2739),
    [aux_sym_preproc_include_token1] = ACTIONS(2739),
    [aux_sym_preproc_def_token1] = ACTIONS(2739),
    [aux_sym_preproc_if_token1] = ACTIONS(2739),
    [aux_sym_preproc_if_token2] = ACTIONS(2739),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2739),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2739),
    [sym_preproc_directive] = ACTIONS(2739),
    [anon_sym_LPAREN2] = ACTIONS(2741),
    [anon_sym_BANG] = ACTIONS(2741),
    [anon_sym_TILDE] = ACTIONS(2741),
    [anon_sym_DASH] = ACTIONS(2739),
    [anon_sym_PLUS] = ACTIONS(2739),
    [anon_sym_STAR] = ACTIONS(2741),
    [anon_sym_AMP_AMP] = ACTIONS(2741),
    [anon_sym_AMP] = ACTIONS(2739),
    [anon_sym_SEMI] = ACTIONS(2741),
    [anon_sym___extension__] = ACTIONS(2739),
    [anon_sym_typedef] = ACTIONS(2739),
    [anon_sym_virtual] = ACTIONS(2739),
    [anon_sym_extern] = ACTIONS(2739),
    [anon_sym___attribute__] = ACTIONS(2739),
    [anon_sym___attribute] = ACTIONS(2739),
    [anon_sym_COLON_COLON] = ACTIONS(2741),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2741),
    [anon_sym___declspec] = ACTIONS(2739),
    [anon_sym___based] = ACTIONS(2739),
    [anon_sym___cdecl] = ACTIONS(2739),
    [anon_sym___clrcall] = ACTIONS(2739),
    [anon_sym___stdcall] = ACTIONS(2739),
    [anon_sym___fastcall] = ACTIONS(2739),
    [anon_sym___thiscall] = ACTIONS(2739),
    [anon_sym___vectorcall] = ACTIONS(2739),
    [anon_sym_LBRACE] = ACTIONS(2741),
    [anon_sym_signed] = ACTIONS(2739),
    [anon_sym_unsigned] = ACTIONS(2739),
    [anon_sym_long] = ACTIONS(2739),
    [anon_sym_short] = ACTIONS(2739),
    [anon_sym_LBRACK] = ACTIONS(2739),
    [anon_sym_static] = ACTIONS(2739),
    [anon_sym_register] = ACTIONS(2739),
    [anon_sym_inline] = ACTIONS(2739),
    [anon_sym___inline] = ACTIONS(2739),
    [anon_sym___inline__] = ACTIONS(2739),
    [anon_sym___forceinline] = ACTIONS(2739),
    [anon_sym_thread_local] = ACTIONS(2739),
    [anon_sym___thread] = ACTIONS(2739),
    [anon_sym_const] = ACTIONS(2739),
    [anon_sym_constexpr] = ACTIONS(2739),
    [anon_sym_volatile] = ACTIONS(2739),
    [anon_sym_restrict] = ACTIONS(2739),
    [anon_sym___restrict__] = ACTIONS(2739),
    [anon_sym__Atomic] = ACTIONS(2739),
    [anon_sym__Noreturn] = ACTIONS(2739),
    [anon_sym_noreturn] = ACTIONS(2739),
    [anon_sym__Nonnull] = ACTIONS(2739),
    [anon_sym_mutable] = ACTIONS(2739),
    [anon_sym_constinit] = ACTIONS(2739),
    [anon_sym_consteval] = ACTIONS(2739),
    [anon_sym_alignas] = ACTIONS(2739),
    [anon_sym__Alignas] = ACTIONS(2739),
    [sym_primitive_type] = ACTIONS(2739),
    [anon_sym_enum] = ACTIONS(2739),
    [anon_sym_class] = ACTIONS(2739),
    [anon_sym_struct] = ACTIONS(2739),
    [anon_sym_union] = ACTIONS(2739),
    [anon_sym_if] = ACTIONS(2739),
    [anon_sym_switch] = ACTIONS(2739),
    [anon_sym_case] = ACTIONS(2739),
    [anon_sym_default] = ACTIONS(2739),
    [anon_sym_while] = ACTIONS(2739),
    [anon_sym_do] = ACTIONS(2739),
    [anon_sym_for] = ACTIONS(2739),
    [anon_sym_return] = ACTIONS(2739),
    [anon_sym_break] = ACTIONS(2739),
    [anon_sym_continue] = ACTIONS(2739),
    [anon_sym_goto] = ACTIONS(2739),
    [anon_sym___try] = ACTIONS(2739),
    [anon_sym___leave] = ACTIONS(2739),
    [anon_sym_not] = ACTIONS(2739),
    [anon_sym_compl] = ACTIONS(2739),
    [anon_sym_DASH_DASH] = ACTIONS(2741),
    [anon_sym_PLUS_PLUS] = ACTIONS(2741),
    [anon_sym_sizeof] = ACTIONS(2739),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2739),
    [anon_sym__Generic] = ACTIONS(2739),
    [anon_sym_asm] = ACTIONS(2739),
    [anon_sym___asm__] = ACTIONS(2739),
    [anon_sym___asm] = ACTIONS(2739),
    [sym_number_literal] = ACTIONS(2741),
    [anon_sym_L_SQUOTE] = ACTIONS(2741),
    [anon_sym_u_SQUOTE] = ACTIONS(2741),
    [anon_sym_U_SQUOTE] = ACTIONS(2741),
    [anon_sym_u8_SQUOTE] = ACTIONS(2741),
    [anon_sym_SQUOTE] = ACTIONS(2741),
    [anon_sym_L_DQUOTE] = ACTIONS(2741),
    [anon_sym_u_DQUOTE] = ACTIONS(2741),
    [anon_sym_U_DQUOTE] = ACTIONS(2741),
    [anon_sym_u8_DQUOTE] = ACTIONS(2741),
    [anon_sym_DQUOTE] = ACTIONS(2741),
    [sym_true] = ACTIONS(2739),
    [sym_false] = ACTIONS(2739),
    [anon_sym_NULL] = ACTIONS(2739),
    [anon_sym_nullptr] = ACTIONS(2739),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2739),
    [anon_sym_decltype] = ACTIONS(2739),
    [anon_sym_explicit] = ACTIONS(2739),
    [anon_sym_typename] = ACTIONS(2739),
    [anon_sym_template] = ACTIONS(2739),
    [anon_sym_operator] = ACTIONS(2739),
    [anon_sym_try] = ACTIONS(2739),
    [anon_sym_delete] = ACTIONS(2739),
    [anon_sym_throw] = ACTIONS(2739),
    [anon_sym_namespace] = ACTIONS(2739),
    [anon_sym_using] = ACTIONS(2739),
    [anon_sym_static_assert] = ACTIONS(2739),
    [anon_sym_concept] = ACTIONS(2739),
    [anon_sym_co_return] = ACTIONS(2739),
    [anon_sym_co_yield] = ACTIONS(2739),
    [anon_sym_R_DQUOTE] = ACTIONS(2741),
    [anon_sym_LR_DQUOTE] = ACTIONS(2741),
    [anon_sym_uR_DQUOTE] = ACTIONS(2741),
    [anon_sym_UR_DQUOTE] = ACTIONS(2741),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2741),
    [anon_sym_co_await] = ACTIONS(2739),
    [anon_sym_new] = ACTIONS(2739),
    [anon_sym_requires] = ACTIONS(2739),
    [sym_this] = ACTIONS(2739),
  },
  [608] = {
    [sym_identifier] = ACTIONS(3038),
    [aux_sym_preproc_include_token1] = ACTIONS(3038),
    [aux_sym_preproc_def_token1] = ACTIONS(3038),
    [aux_sym_preproc_if_token1] = ACTIONS(3038),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3038),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3038),
    [sym_preproc_directive] = ACTIONS(3038),
    [anon_sym_LPAREN2] = ACTIONS(3040),
    [anon_sym_BANG] = ACTIONS(3040),
    [anon_sym_TILDE] = ACTIONS(3040),
    [anon_sym_DASH] = ACTIONS(3038),
    [anon_sym_PLUS] = ACTIONS(3038),
    [anon_sym_STAR] = ACTIONS(3040),
    [anon_sym_AMP_AMP] = ACTIONS(3040),
    [anon_sym_AMP] = ACTIONS(3038),
    [anon_sym_SEMI] = ACTIONS(3040),
    [anon_sym___extension__] = ACTIONS(3038),
    [anon_sym_typedef] = ACTIONS(3038),
    [anon_sym_virtual] = ACTIONS(3038),
    [anon_sym_extern] = ACTIONS(3038),
    [anon_sym___attribute__] = ACTIONS(3038),
    [anon_sym___attribute] = ACTIONS(3038),
    [anon_sym_COLON_COLON] = ACTIONS(3040),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3040),
    [anon_sym___declspec] = ACTIONS(3038),
    [anon_sym___based] = ACTIONS(3038),
    [anon_sym___cdecl] = ACTIONS(3038),
    [anon_sym___clrcall] = ACTIONS(3038),
    [anon_sym___stdcall] = ACTIONS(3038),
    [anon_sym___fastcall] = ACTIONS(3038),
    [anon_sym___thiscall] = ACTIONS(3038),
    [anon_sym___vectorcall] = ACTIONS(3038),
    [anon_sym_LBRACE] = ACTIONS(3040),
    [anon_sym_RBRACE] = ACTIONS(3040),
    [anon_sym_signed] = ACTIONS(3038),
    [anon_sym_unsigned] = ACTIONS(3038),
    [anon_sym_long] = ACTIONS(3038),
    [anon_sym_short] = ACTIONS(3038),
    [anon_sym_LBRACK] = ACTIONS(3038),
    [anon_sym_static] = ACTIONS(3038),
    [anon_sym_register] = ACTIONS(3038),
    [anon_sym_inline] = ACTIONS(3038),
    [anon_sym___inline] = ACTIONS(3038),
    [anon_sym___inline__] = ACTIONS(3038),
    [anon_sym___forceinline] = ACTIONS(3038),
    [anon_sym_thread_local] = ACTIONS(3038),
    [anon_sym___thread] = ACTIONS(3038),
    [anon_sym_const] = ACTIONS(3038),
    [anon_sym_constexpr] = ACTIONS(3038),
    [anon_sym_volatile] = ACTIONS(3038),
    [anon_sym_restrict] = ACTIONS(3038),
    [anon_sym___restrict__] = ACTIONS(3038),
    [anon_sym__Atomic] = ACTIONS(3038),
    [anon_sym__Noreturn] = ACTIONS(3038),
    [anon_sym_noreturn] = ACTIONS(3038),
    [anon_sym__Nonnull] = ACTIONS(3038),
    [anon_sym_mutable] = ACTIONS(3038),
    [anon_sym_constinit] = ACTIONS(3038),
    [anon_sym_consteval] = ACTIONS(3038),
    [anon_sym_alignas] = ACTIONS(3038),
    [anon_sym__Alignas] = ACTIONS(3038),
    [sym_primitive_type] = ACTIONS(3038),
    [anon_sym_enum] = ACTIONS(3038),
    [anon_sym_class] = ACTIONS(3038),
    [anon_sym_struct] = ACTIONS(3038),
    [anon_sym_union] = ACTIONS(3038),
    [anon_sym_if] = ACTIONS(3038),
    [anon_sym_switch] = ACTIONS(3038),
    [anon_sym_case] = ACTIONS(3038),
    [anon_sym_default] = ACTIONS(3038),
    [anon_sym_while] = ACTIONS(3038),
    [anon_sym_do] = ACTIONS(3038),
    [anon_sym_for] = ACTIONS(3038),
    [anon_sym_return] = ACTIONS(3038),
    [anon_sym_break] = ACTIONS(3038),
    [anon_sym_continue] = ACTIONS(3038),
    [anon_sym_goto] = ACTIONS(3038),
    [anon_sym___try] = ACTIONS(3038),
    [anon_sym___leave] = ACTIONS(3038),
    [anon_sym_not] = ACTIONS(3038),
    [anon_sym_compl] = ACTIONS(3038),
    [anon_sym_DASH_DASH] = ACTIONS(3040),
    [anon_sym_PLUS_PLUS] = ACTIONS(3040),
    [anon_sym_sizeof] = ACTIONS(3038),
    [anon_sym___alignof__] = ACTIONS(3038),
    [anon_sym___alignof] = ACTIONS(3038),
    [anon_sym__alignof] = ACTIONS(3038),
    [anon_sym_alignof] = ACTIONS(3038),
    [anon_sym__Alignof] = ACTIONS(3038),
    [anon_sym_offsetof] = ACTIONS(3038),
    [anon_sym__Generic] = ACTIONS(3038),
    [anon_sym_asm] = ACTIONS(3038),
    [anon_sym___asm__] = ACTIONS(3038),
    [anon_sym___asm] = ACTIONS(3038),
    [sym_number_literal] = ACTIONS(3040),
    [anon_sym_L_SQUOTE] = ACTIONS(3040),
    [anon_sym_u_SQUOTE] = ACTIONS(3040),
    [anon_sym_U_SQUOTE] = ACTIONS(3040),
    [anon_sym_u8_SQUOTE] = ACTIONS(3040),
    [anon_sym_SQUOTE] = ACTIONS(3040),
    [anon_sym_L_DQUOTE] = ACTIONS(3040),
    [anon_sym_u_DQUOTE] = ACTIONS(3040),
    [anon_sym_U_DQUOTE] = ACTIONS(3040),
    [anon_sym_u8_DQUOTE] = ACTIONS(3040),
    [anon_sym_DQUOTE] = ACTIONS(3040),
    [sym_true] = ACTIONS(3038),
    [sym_false] = ACTIONS(3038),
    [anon_sym_NULL] = ACTIONS(3038),
    [anon_sym_nullptr] = ACTIONS(3038),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3038),
    [anon_sym_decltype] = ACTIONS(3038),
    [anon_sym_explicit] = ACTIONS(3038),
    [anon_sym_typename] = ACTIONS(3038),
    [anon_sym_template] = ACTIONS(3038),
    [anon_sym_operator] = ACTIONS(3038),
    [anon_sym_try] = ACTIONS(3038),
    [anon_sym_delete] = ACTIONS(3038),
    [anon_sym_throw] = ACTIONS(3038),
    [anon_sym_namespace] = ACTIONS(3038),
    [anon_sym_using] = ACTIONS(3038),
    [anon_sym_static_assert] = ACTIONS(3038),
    [anon_sym_concept] = ACTIONS(3038),
    [anon_sym_co_return] = ACTIONS(3038),
    [anon_sym_co_yield] = ACTIONS(3038),
    [anon_sym_R_DQUOTE] = ACTIONS(3040),
    [anon_sym_LR_DQUOTE] = ACTIONS(3040),
    [anon_sym_uR_DQUOTE] = ACTIONS(3040),
    [anon_sym_UR_DQUOTE] = ACTIONS(3040),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3040),
    [anon_sym_co_await] = ACTIONS(3038),
    [anon_sym_new] = ACTIONS(3038),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3038),
  },
  [609] = {
    [sym_identifier] = ACTIONS(2834),
    [aux_sym_preproc_include_token1] = ACTIONS(2834),
    [aux_sym_preproc_def_token1] = ACTIONS(2834),
    [aux_sym_preproc_if_token1] = ACTIONS(2834),
    [aux_sym_preproc_if_token2] = ACTIONS(2834),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2834),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2834),
    [sym_preproc_directive] = ACTIONS(2834),
    [anon_sym_LPAREN2] = ACTIONS(2836),
    [anon_sym_BANG] = ACTIONS(2836),
    [anon_sym_TILDE] = ACTIONS(2836),
    [anon_sym_DASH] = ACTIONS(2834),
    [anon_sym_PLUS] = ACTIONS(2834),
    [anon_sym_STAR] = ACTIONS(2836),
    [anon_sym_AMP_AMP] = ACTIONS(2836),
    [anon_sym_AMP] = ACTIONS(2834),
    [anon_sym_SEMI] = ACTIONS(2836),
    [anon_sym___extension__] = ACTIONS(2834),
    [anon_sym_typedef] = ACTIONS(2834),
    [anon_sym_virtual] = ACTIONS(2834),
    [anon_sym_extern] = ACTIONS(2834),
    [anon_sym___attribute__] = ACTIONS(2834),
    [anon_sym___attribute] = ACTIONS(2834),
    [anon_sym_COLON_COLON] = ACTIONS(2836),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2836),
    [anon_sym___declspec] = ACTIONS(2834),
    [anon_sym___based] = ACTIONS(2834),
    [anon_sym___cdecl] = ACTIONS(2834),
    [anon_sym___clrcall] = ACTIONS(2834),
    [anon_sym___stdcall] = ACTIONS(2834),
    [anon_sym___fastcall] = ACTIONS(2834),
    [anon_sym___thiscall] = ACTIONS(2834),
    [anon_sym___vectorcall] = ACTIONS(2834),
    [anon_sym_LBRACE] = ACTIONS(2836),
    [anon_sym_signed] = ACTIONS(2834),
    [anon_sym_unsigned] = ACTIONS(2834),
    [anon_sym_long] = ACTIONS(2834),
    [anon_sym_short] = ACTIONS(2834),
    [anon_sym_LBRACK] = ACTIONS(2834),
    [anon_sym_static] = ACTIONS(2834),
    [anon_sym_register] = ACTIONS(2834),
    [anon_sym_inline] = ACTIONS(2834),
    [anon_sym___inline] = ACTIONS(2834),
    [anon_sym___inline__] = ACTIONS(2834),
    [anon_sym___forceinline] = ACTIONS(2834),
    [anon_sym_thread_local] = ACTIONS(2834),
    [anon_sym___thread] = ACTIONS(2834),
    [anon_sym_const] = ACTIONS(2834),
    [anon_sym_constexpr] = ACTIONS(2834),
    [anon_sym_volatile] = ACTIONS(2834),
    [anon_sym_restrict] = ACTIONS(2834),
    [anon_sym___restrict__] = ACTIONS(2834),
    [anon_sym__Atomic] = ACTIONS(2834),
    [anon_sym__Noreturn] = ACTIONS(2834),
    [anon_sym_noreturn] = ACTIONS(2834),
    [anon_sym__Nonnull] = ACTIONS(2834),
    [anon_sym_mutable] = ACTIONS(2834),
    [anon_sym_constinit] = ACTIONS(2834),
    [anon_sym_consteval] = ACTIONS(2834),
    [anon_sym_alignas] = ACTIONS(2834),
    [anon_sym__Alignas] = ACTIONS(2834),
    [sym_primitive_type] = ACTIONS(2834),
    [anon_sym_enum] = ACTIONS(2834),
    [anon_sym_class] = ACTIONS(2834),
    [anon_sym_struct] = ACTIONS(2834),
    [anon_sym_union] = ACTIONS(2834),
    [anon_sym_if] = ACTIONS(2834),
    [anon_sym_switch] = ACTIONS(2834),
    [anon_sym_case] = ACTIONS(2834),
    [anon_sym_default] = ACTIONS(2834),
    [anon_sym_while] = ACTIONS(2834),
    [anon_sym_do] = ACTIONS(2834),
    [anon_sym_for] = ACTIONS(2834),
    [anon_sym_return] = ACTIONS(2834),
    [anon_sym_break] = ACTIONS(2834),
    [anon_sym_continue] = ACTIONS(2834),
    [anon_sym_goto] = ACTIONS(2834),
    [anon_sym___try] = ACTIONS(2834),
    [anon_sym___leave] = ACTIONS(2834),
    [anon_sym_not] = ACTIONS(2834),
    [anon_sym_compl] = ACTIONS(2834),
    [anon_sym_DASH_DASH] = ACTIONS(2836),
    [anon_sym_PLUS_PLUS] = ACTIONS(2836),
    [anon_sym_sizeof] = ACTIONS(2834),
    [anon_sym___alignof__] = ACTIONS(2834),
    [anon_sym___alignof] = ACTIONS(2834),
    [anon_sym__alignof] = ACTIONS(2834),
    [anon_sym_alignof] = ACTIONS(2834),
    [anon_sym__Alignof] = ACTIONS(2834),
    [anon_sym_offsetof] = ACTIONS(2834),
    [anon_sym__Generic] = ACTIONS(2834),
    [anon_sym_asm] = ACTIONS(2834),
    [anon_sym___asm__] = ACTIONS(2834),
    [anon_sym___asm] = ACTIONS(2834),
    [sym_number_literal] = ACTIONS(2836),
    [anon_sym_L_SQUOTE] = ACTIONS(2836),
    [anon_sym_u_SQUOTE] = ACTIONS(2836),
    [anon_sym_U_SQUOTE] = ACTIONS(2836),
    [anon_sym_u8_SQUOTE] = ACTIONS(2836),
    [anon_sym_SQUOTE] = ACTIONS(2836),
    [anon_sym_L_DQUOTE] = ACTIONS(2836),
    [anon_sym_u_DQUOTE] = ACTIONS(2836),
    [anon_sym_U_DQUOTE] = ACTIONS(2836),
    [anon_sym_u8_DQUOTE] = ACTIONS(2836),
    [anon_sym_DQUOTE] = ACTIONS(2836),
    [sym_true] = ACTIONS(2834),
    [sym_false] = ACTIONS(2834),
    [anon_sym_NULL] = ACTIONS(2834),
    [anon_sym_nullptr] = ACTIONS(2834),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2834),
    [anon_sym_decltype] = ACTIONS(2834),
    [anon_sym_explicit] = ACTIONS(2834),
    [anon_sym_typename] = ACTIONS(2834),
    [anon_sym_template] = ACTIONS(2834),
    [anon_sym_operator] = ACTIONS(2834),
    [anon_sym_try] = ACTIONS(2834),
    [anon_sym_delete] = ACTIONS(2834),
    [anon_sym_throw] = ACTIONS(2834),
    [anon_sym_namespace] = ACTIONS(2834),
    [anon_sym_using] = ACTIONS(2834),
    [anon_sym_static_assert] = ACTIONS(2834),
    [anon_sym_concept] = ACTIONS(2834),
    [anon_sym_co_return] = ACTIONS(2834),
    [anon_sym_co_yield] = ACTIONS(2834),
    [anon_sym_R_DQUOTE] = ACTIONS(2836),
    [anon_sym_LR_DQUOTE] = ACTIONS(2836),
    [anon_sym_uR_DQUOTE] = ACTIONS(2836),
    [anon_sym_UR_DQUOTE] = ACTIONS(2836),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2836),
    [anon_sym_co_await] = ACTIONS(2834),
    [anon_sym_new] = ACTIONS(2834),
    [anon_sym_requires] = ACTIONS(2834),
    [sym_this] = ACTIONS(2834),
  },
  [610] = {
    [sym_identifier] = ACTIONS(2838),
    [aux_sym_preproc_include_token1] = ACTIONS(2838),
    [aux_sym_preproc_def_token1] = ACTIONS(2838),
    [aux_sym_preproc_if_token1] = ACTIONS(2838),
    [aux_sym_preproc_if_token2] = ACTIONS(2838),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2838),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2838),
    [sym_preproc_directive] = ACTIONS(2838),
    [anon_sym_LPAREN2] = ACTIONS(2840),
    [anon_sym_BANG] = ACTIONS(2840),
    [anon_sym_TILDE] = ACTIONS(2840),
    [anon_sym_DASH] = ACTIONS(2838),
    [anon_sym_PLUS] = ACTIONS(2838),
    [anon_sym_STAR] = ACTIONS(2840),
    [anon_sym_AMP_AMP] = ACTIONS(2840),
    [anon_sym_AMP] = ACTIONS(2838),
    [anon_sym_SEMI] = ACTIONS(2840),
    [anon_sym___extension__] = ACTIONS(2838),
    [anon_sym_typedef] = ACTIONS(2838),
    [anon_sym_virtual] = ACTIONS(2838),
    [anon_sym_extern] = ACTIONS(2838),
    [anon_sym___attribute__] = ACTIONS(2838),
    [anon_sym___attribute] = ACTIONS(2838),
    [anon_sym_COLON_COLON] = ACTIONS(2840),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2840),
    [anon_sym___declspec] = ACTIONS(2838),
    [anon_sym___based] = ACTIONS(2838),
    [anon_sym___cdecl] = ACTIONS(2838),
    [anon_sym___clrcall] = ACTIONS(2838),
    [anon_sym___stdcall] = ACTIONS(2838),
    [anon_sym___fastcall] = ACTIONS(2838),
    [anon_sym___thiscall] = ACTIONS(2838),
    [anon_sym___vectorcall] = ACTIONS(2838),
    [anon_sym_LBRACE] = ACTIONS(2840),
    [anon_sym_signed] = ACTIONS(2838),
    [anon_sym_unsigned] = ACTIONS(2838),
    [anon_sym_long] = ACTIONS(2838),
    [anon_sym_short] = ACTIONS(2838),
    [anon_sym_LBRACK] = ACTIONS(2838),
    [anon_sym_static] = ACTIONS(2838),
    [anon_sym_register] = ACTIONS(2838),
    [anon_sym_inline] = ACTIONS(2838),
    [anon_sym___inline] = ACTIONS(2838),
    [anon_sym___inline__] = ACTIONS(2838),
    [anon_sym___forceinline] = ACTIONS(2838),
    [anon_sym_thread_local] = ACTIONS(2838),
    [anon_sym___thread] = ACTIONS(2838),
    [anon_sym_const] = ACTIONS(2838),
    [anon_sym_constexpr] = ACTIONS(2838),
    [anon_sym_volatile] = ACTIONS(2838),
    [anon_sym_restrict] = ACTIONS(2838),
    [anon_sym___restrict__] = ACTIONS(2838),
    [anon_sym__Atomic] = ACTIONS(2838),
    [anon_sym__Noreturn] = ACTIONS(2838),
    [anon_sym_noreturn] = ACTIONS(2838),
    [anon_sym__Nonnull] = ACTIONS(2838),
    [anon_sym_mutable] = ACTIONS(2838),
    [anon_sym_constinit] = ACTIONS(2838),
    [anon_sym_consteval] = ACTIONS(2838),
    [anon_sym_alignas] = ACTIONS(2838),
    [anon_sym__Alignas] = ACTIONS(2838),
    [sym_primitive_type] = ACTIONS(2838),
    [anon_sym_enum] = ACTIONS(2838),
    [anon_sym_class] = ACTIONS(2838),
    [anon_sym_struct] = ACTIONS(2838),
    [anon_sym_union] = ACTIONS(2838),
    [anon_sym_if] = ACTIONS(2838),
    [anon_sym_switch] = ACTIONS(2838),
    [anon_sym_case] = ACTIONS(2838),
    [anon_sym_default] = ACTIONS(2838),
    [anon_sym_while] = ACTIONS(2838),
    [anon_sym_do] = ACTIONS(2838),
    [anon_sym_for] = ACTIONS(2838),
    [anon_sym_return] = ACTIONS(2838),
    [anon_sym_break] = ACTIONS(2838),
    [anon_sym_continue] = ACTIONS(2838),
    [anon_sym_goto] = ACTIONS(2838),
    [anon_sym___try] = ACTIONS(2838),
    [anon_sym___leave] = ACTIONS(2838),
    [anon_sym_not] = ACTIONS(2838),
    [anon_sym_compl] = ACTIONS(2838),
    [anon_sym_DASH_DASH] = ACTIONS(2840),
    [anon_sym_PLUS_PLUS] = ACTIONS(2840),
    [anon_sym_sizeof] = ACTIONS(2838),
    [anon_sym___alignof__] = ACTIONS(2838),
    [anon_sym___alignof] = ACTIONS(2838),
    [anon_sym__alignof] = ACTIONS(2838),
    [anon_sym_alignof] = ACTIONS(2838),
    [anon_sym__Alignof] = ACTIONS(2838),
    [anon_sym_offsetof] = ACTIONS(2838),
    [anon_sym__Generic] = ACTIONS(2838),
    [anon_sym_asm] = ACTIONS(2838),
    [anon_sym___asm__] = ACTIONS(2838),
    [anon_sym___asm] = ACTIONS(2838),
    [sym_number_literal] = ACTIONS(2840),
    [anon_sym_L_SQUOTE] = ACTIONS(2840),
    [anon_sym_u_SQUOTE] = ACTIONS(2840),
    [anon_sym_U_SQUOTE] = ACTIONS(2840),
    [anon_sym_u8_SQUOTE] = ACTIONS(2840),
    [anon_sym_SQUOTE] = ACTIONS(2840),
    [anon_sym_L_DQUOTE] = ACTIONS(2840),
    [anon_sym_u_DQUOTE] = ACTIONS(2840),
    [anon_sym_U_DQUOTE] = ACTIONS(2840),
    [anon_sym_u8_DQUOTE] = ACTIONS(2840),
    [anon_sym_DQUOTE] = ACTIONS(2840),
    [sym_true] = ACTIONS(2838),
    [sym_false] = ACTIONS(2838),
    [anon_sym_NULL] = ACTIONS(2838),
    [anon_sym_nullptr] = ACTIONS(2838),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2838),
    [anon_sym_decltype] = ACTIONS(2838),
    [anon_sym_explicit] = ACTIONS(2838),
    [anon_sym_typename] = ACTIONS(2838),
    [anon_sym_template] = ACTIONS(2838),
    [anon_sym_operator] = ACTIONS(2838),
    [anon_sym_try] = ACTIONS(2838),
    [anon_sym_delete] = ACTIONS(2838),
    [anon_sym_throw] = ACTIONS(2838),
    [anon_sym_namespace] = ACTIONS(2838),
    [anon_sym_using] = ACTIONS(2838),
    [anon_sym_static_assert] = ACTIONS(2838),
    [anon_sym_concept] = ACTIONS(2838),
    [anon_sym_co_return] = ACTIONS(2838),
    [anon_sym_co_yield] = ACTIONS(2838),
    [anon_sym_R_DQUOTE] = ACTIONS(2840),
    [anon_sym_LR_DQUOTE] = ACTIONS(2840),
    [anon_sym_uR_DQUOTE] = ACTIONS(2840),
    [anon_sym_UR_DQUOTE] = ACTIONS(2840),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2840),
    [anon_sym_co_await] = ACTIONS(2838),
    [anon_sym_new] = ACTIONS(2838),
    [anon_sym_requires] = ACTIONS(2838),
    [sym_this] = ACTIONS(2838),
  },
  [611] = {
    [sym_identifier] = ACTIONS(3094),
    [aux_sym_preproc_include_token1] = ACTIONS(3094),
    [aux_sym_preproc_def_token1] = ACTIONS(3094),
    [aux_sym_preproc_if_token1] = ACTIONS(3094),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3094),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3094),
    [sym_preproc_directive] = ACTIONS(3094),
    [anon_sym_LPAREN2] = ACTIONS(3096),
    [anon_sym_BANG] = ACTIONS(3096),
    [anon_sym_TILDE] = ACTIONS(3096),
    [anon_sym_DASH] = ACTIONS(3094),
    [anon_sym_PLUS] = ACTIONS(3094),
    [anon_sym_STAR] = ACTIONS(3096),
    [anon_sym_AMP_AMP] = ACTIONS(3096),
    [anon_sym_AMP] = ACTIONS(3094),
    [anon_sym_SEMI] = ACTIONS(3096),
    [anon_sym___extension__] = ACTIONS(3094),
    [anon_sym_typedef] = ACTIONS(3094),
    [anon_sym_virtual] = ACTIONS(3094),
    [anon_sym_extern] = ACTIONS(3094),
    [anon_sym___attribute__] = ACTIONS(3094),
    [anon_sym___attribute] = ACTIONS(3094),
    [anon_sym_COLON_COLON] = ACTIONS(3096),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3096),
    [anon_sym___declspec] = ACTIONS(3094),
    [anon_sym___based] = ACTIONS(3094),
    [anon_sym___cdecl] = ACTIONS(3094),
    [anon_sym___clrcall] = ACTIONS(3094),
    [anon_sym___stdcall] = ACTIONS(3094),
    [anon_sym___fastcall] = ACTIONS(3094),
    [anon_sym___thiscall] = ACTIONS(3094),
    [anon_sym___vectorcall] = ACTIONS(3094),
    [anon_sym_LBRACE] = ACTIONS(3096),
    [anon_sym_RBRACE] = ACTIONS(3096),
    [anon_sym_signed] = ACTIONS(3094),
    [anon_sym_unsigned] = ACTIONS(3094),
    [anon_sym_long] = ACTIONS(3094),
    [anon_sym_short] = ACTIONS(3094),
    [anon_sym_LBRACK] = ACTIONS(3094),
    [anon_sym_static] = ACTIONS(3094),
    [anon_sym_register] = ACTIONS(3094),
    [anon_sym_inline] = ACTIONS(3094),
    [anon_sym___inline] = ACTIONS(3094),
    [anon_sym___inline__] = ACTIONS(3094),
    [anon_sym___forceinline] = ACTIONS(3094),
    [anon_sym_thread_local] = ACTIONS(3094),
    [anon_sym___thread] = ACTIONS(3094),
    [anon_sym_const] = ACTIONS(3094),
    [anon_sym_constexpr] = ACTIONS(3094),
    [anon_sym_volatile] = ACTIONS(3094),
    [anon_sym_restrict] = ACTIONS(3094),
    [anon_sym___restrict__] = ACTIONS(3094),
    [anon_sym__Atomic] = ACTIONS(3094),
    [anon_sym__Noreturn] = ACTIONS(3094),
    [anon_sym_noreturn] = ACTIONS(3094),
    [anon_sym__Nonnull] = ACTIONS(3094),
    [anon_sym_mutable] = ACTIONS(3094),
    [anon_sym_constinit] = ACTIONS(3094),
    [anon_sym_consteval] = ACTIONS(3094),
    [anon_sym_alignas] = ACTIONS(3094),
    [anon_sym__Alignas] = ACTIONS(3094),
    [sym_primitive_type] = ACTIONS(3094),
    [anon_sym_enum] = ACTIONS(3094),
    [anon_sym_class] = ACTIONS(3094),
    [anon_sym_struct] = ACTIONS(3094),
    [anon_sym_union] = ACTIONS(3094),
    [anon_sym_if] = ACTIONS(3094),
    [anon_sym_switch] = ACTIONS(3094),
    [anon_sym_case] = ACTIONS(3094),
    [anon_sym_default] = ACTIONS(3094),
    [anon_sym_while] = ACTIONS(3094),
    [anon_sym_do] = ACTIONS(3094),
    [anon_sym_for] = ACTIONS(3094),
    [anon_sym_return] = ACTIONS(3094),
    [anon_sym_break] = ACTIONS(3094),
    [anon_sym_continue] = ACTIONS(3094),
    [anon_sym_goto] = ACTIONS(3094),
    [anon_sym___try] = ACTIONS(3094),
    [anon_sym___leave] = ACTIONS(3094),
    [anon_sym_not] = ACTIONS(3094),
    [anon_sym_compl] = ACTIONS(3094),
    [anon_sym_DASH_DASH] = ACTIONS(3096),
    [anon_sym_PLUS_PLUS] = ACTIONS(3096),
    [anon_sym_sizeof] = ACTIONS(3094),
    [anon_sym___alignof__] = ACTIONS(3094),
    [anon_sym___alignof] = ACTIONS(3094),
    [anon_sym__alignof] = ACTIONS(3094),
    [anon_sym_alignof] = ACTIONS(3094),
    [anon_sym__Alignof] = ACTIONS(3094),
    [anon_sym_offsetof] = ACTIONS(3094),
    [anon_sym__Generic] = ACTIONS(3094),
    [anon_sym_asm] = ACTIONS(3094),
    [anon_sym___asm__] = ACTIONS(3094),
    [anon_sym___asm] = ACTIONS(3094),
    [sym_number_literal] = ACTIONS(3096),
    [anon_sym_L_SQUOTE] = ACTIONS(3096),
    [anon_sym_u_SQUOTE] = ACTIONS(3096),
    [anon_sym_U_SQUOTE] = ACTIONS(3096),
    [anon_sym_u8_SQUOTE] = ACTIONS(3096),
    [anon_sym_SQUOTE] = ACTIONS(3096),
    [anon_sym_L_DQUOTE] = ACTIONS(3096),
    [anon_sym_u_DQUOTE] = ACTIONS(3096),
    [anon_sym_U_DQUOTE] = ACTIONS(3096),
    [anon_sym_u8_DQUOTE] = ACTIONS(3096),
    [anon_sym_DQUOTE] = ACTIONS(3096),
    [sym_true] = ACTIONS(3094),
    [sym_false] = ACTIONS(3094),
    [anon_sym_NULL] = ACTIONS(3094),
    [anon_sym_nullptr] = ACTIONS(3094),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3094),
    [anon_sym_decltype] = ACTIONS(3094),
    [anon_sym_explicit] = ACTIONS(3094),
    [anon_sym_typename] = ACTIONS(3094),
    [anon_sym_template] = ACTIONS(3094),
    [anon_sym_operator] = ACTIONS(3094),
    [anon_sym_try] = ACTIONS(3094),
    [anon_sym_delete] = ACTIONS(3094),
    [anon_sym_throw] = ACTIONS(3094),
    [anon_sym_namespace] = ACTIONS(3094),
    [anon_sym_using] = ACTIONS(3094),
    [anon_sym_static_assert] = ACTIONS(3094),
    [anon_sym_concept] = ACTIONS(3094),
    [anon_sym_co_return] = ACTIONS(3094),
    [anon_sym_co_yield] = ACTIONS(3094),
    [anon_sym_R_DQUOTE] = ACTIONS(3096),
    [anon_sym_LR_DQUOTE] = ACTIONS(3096),
    [anon_sym_uR_DQUOTE] = ACTIONS(3096),
    [anon_sym_UR_DQUOTE] = ACTIONS(3096),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3096),
    [anon_sym_co_await] = ACTIONS(3094),
    [anon_sym_new] = ACTIONS(3094),
    [anon_sym_requires] = ACTIONS(3094),
    [sym_this] = ACTIONS(3094),
  },
  [612] = {
    [sym_identifier] = ACTIONS(3098),
    [aux_sym_preproc_include_token1] = ACTIONS(3098),
    [aux_sym_preproc_def_token1] = ACTIONS(3098),
    [aux_sym_preproc_if_token1] = ACTIONS(3098),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3098),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3098),
    [sym_preproc_directive] = ACTIONS(3098),
    [anon_sym_LPAREN2] = ACTIONS(3100),
    [anon_sym_BANG] = ACTIONS(3100),
    [anon_sym_TILDE] = ACTIONS(3100),
    [anon_sym_DASH] = ACTIONS(3098),
    [anon_sym_PLUS] = ACTIONS(3098),
    [anon_sym_STAR] = ACTIONS(3100),
    [anon_sym_AMP_AMP] = ACTIONS(3100),
    [anon_sym_AMP] = ACTIONS(3098),
    [anon_sym_SEMI] = ACTIONS(3100),
    [anon_sym___extension__] = ACTIONS(3098),
    [anon_sym_typedef] = ACTIONS(3098),
    [anon_sym_virtual] = ACTIONS(3098),
    [anon_sym_extern] = ACTIONS(3098),
    [anon_sym___attribute__] = ACTIONS(3098),
    [anon_sym___attribute] = ACTIONS(3098),
    [anon_sym_COLON_COLON] = ACTIONS(3100),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3100),
    [anon_sym___declspec] = ACTIONS(3098),
    [anon_sym___based] = ACTIONS(3098),
    [anon_sym___cdecl] = ACTIONS(3098),
    [anon_sym___clrcall] = ACTIONS(3098),
    [anon_sym___stdcall] = ACTIONS(3098),
    [anon_sym___fastcall] = ACTIONS(3098),
    [anon_sym___thiscall] = ACTIONS(3098),
    [anon_sym___vectorcall] = ACTIONS(3098),
    [anon_sym_LBRACE] = ACTIONS(3100),
    [anon_sym_RBRACE] = ACTIONS(3100),
    [anon_sym_signed] = ACTIONS(3098),
    [anon_sym_unsigned] = ACTIONS(3098),
    [anon_sym_long] = ACTIONS(3098),
    [anon_sym_short] = ACTIONS(3098),
    [anon_sym_LBRACK] = ACTIONS(3098),
    [anon_sym_static] = ACTIONS(3098),
    [anon_sym_register] = ACTIONS(3098),
    [anon_sym_inline] = ACTIONS(3098),
    [anon_sym___inline] = ACTIONS(3098),
    [anon_sym___inline__] = ACTIONS(3098),
    [anon_sym___forceinline] = ACTIONS(3098),
    [anon_sym_thread_local] = ACTIONS(3098),
    [anon_sym___thread] = ACTIONS(3098),
    [anon_sym_const] = ACTIONS(3098),
    [anon_sym_constexpr] = ACTIONS(3098),
    [anon_sym_volatile] = ACTIONS(3098),
    [anon_sym_restrict] = ACTIONS(3098),
    [anon_sym___restrict__] = ACTIONS(3098),
    [anon_sym__Atomic] = ACTIONS(3098),
    [anon_sym__Noreturn] = ACTIONS(3098),
    [anon_sym_noreturn] = ACTIONS(3098),
    [anon_sym__Nonnull] = ACTIONS(3098),
    [anon_sym_mutable] = ACTIONS(3098),
    [anon_sym_constinit] = ACTIONS(3098),
    [anon_sym_consteval] = ACTIONS(3098),
    [anon_sym_alignas] = ACTIONS(3098),
    [anon_sym__Alignas] = ACTIONS(3098),
    [sym_primitive_type] = ACTIONS(3098),
    [anon_sym_enum] = ACTIONS(3098),
    [anon_sym_class] = ACTIONS(3098),
    [anon_sym_struct] = ACTIONS(3098),
    [anon_sym_union] = ACTIONS(3098),
    [anon_sym_if] = ACTIONS(3098),
    [anon_sym_switch] = ACTIONS(3098),
    [anon_sym_case] = ACTIONS(3098),
    [anon_sym_default] = ACTIONS(3098),
    [anon_sym_while] = ACTIONS(3098),
    [anon_sym_do] = ACTIONS(3098),
    [anon_sym_for] = ACTIONS(3098),
    [anon_sym_return] = ACTIONS(3098),
    [anon_sym_break] = ACTIONS(3098),
    [anon_sym_continue] = ACTIONS(3098),
    [anon_sym_goto] = ACTIONS(3098),
    [anon_sym___try] = ACTIONS(3098),
    [anon_sym___leave] = ACTIONS(3098),
    [anon_sym_not] = ACTIONS(3098),
    [anon_sym_compl] = ACTIONS(3098),
    [anon_sym_DASH_DASH] = ACTIONS(3100),
    [anon_sym_PLUS_PLUS] = ACTIONS(3100),
    [anon_sym_sizeof] = ACTIONS(3098),
    [anon_sym___alignof__] = ACTIONS(3098),
    [anon_sym___alignof] = ACTIONS(3098),
    [anon_sym__alignof] = ACTIONS(3098),
    [anon_sym_alignof] = ACTIONS(3098),
    [anon_sym__Alignof] = ACTIONS(3098),
    [anon_sym_offsetof] = ACTIONS(3098),
    [anon_sym__Generic] = ACTIONS(3098),
    [anon_sym_asm] = ACTIONS(3098),
    [anon_sym___asm__] = ACTIONS(3098),
    [anon_sym___asm] = ACTIONS(3098),
    [sym_number_literal] = ACTIONS(3100),
    [anon_sym_L_SQUOTE] = ACTIONS(3100),
    [anon_sym_u_SQUOTE] = ACTIONS(3100),
    [anon_sym_U_SQUOTE] = ACTIONS(3100),
    [anon_sym_u8_SQUOTE] = ACTIONS(3100),
    [anon_sym_SQUOTE] = ACTIONS(3100),
    [anon_sym_L_DQUOTE] = ACTIONS(3100),
    [anon_sym_u_DQUOTE] = ACTIONS(3100),
    [anon_sym_U_DQUOTE] = ACTIONS(3100),
    [anon_sym_u8_DQUOTE] = ACTIONS(3100),
    [anon_sym_DQUOTE] = ACTIONS(3100),
    [sym_true] = ACTIONS(3098),
    [sym_false] = ACTIONS(3098),
    [anon_sym_NULL] = ACTIONS(3098),
    [anon_sym_nullptr] = ACTIONS(3098),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3098),
    [anon_sym_decltype] = ACTIONS(3098),
    [anon_sym_explicit] = ACTIONS(3098),
    [anon_sym_typename] = ACTIONS(3098),
    [anon_sym_template] = ACTIONS(3098),
    [anon_sym_operator] = ACTIONS(3098),
    [anon_sym_try] = ACTIONS(3098),
    [anon_sym_delete] = ACTIONS(3098),
    [anon_sym_throw] = ACTIONS(3098),
    [anon_sym_namespace] = ACTIONS(3098),
    [anon_sym_using] = ACTIONS(3098),
    [anon_sym_static_assert] = ACTIONS(3098),
    [anon_sym_concept] = ACTIONS(3098),
    [anon_sym_co_return] = ACTIONS(3098),
    [anon_sym_co_yield] = ACTIONS(3098),
    [anon_sym_R_DQUOTE] = ACTIONS(3100),
    [anon_sym_LR_DQUOTE] = ACTIONS(3100),
    [anon_sym_uR_DQUOTE] = ACTIONS(3100),
    [anon_sym_UR_DQUOTE] = ACTIONS(3100),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3100),
    [anon_sym_co_await] = ACTIONS(3098),
    [anon_sym_new] = ACTIONS(3098),
    [anon_sym_requires] = ACTIONS(3098),
    [sym_this] = ACTIONS(3098),
  },
  [613] = {
    [sym_identifier] = ACTIONS(3154),
    [aux_sym_preproc_include_token1] = ACTIONS(3154),
    [aux_sym_preproc_def_token1] = ACTIONS(3154),
    [aux_sym_preproc_if_token1] = ACTIONS(3154),
    [aux_sym_preproc_if_token2] = ACTIONS(3154),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3154),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3154),
    [sym_preproc_directive] = ACTIONS(3154),
    [anon_sym_LPAREN2] = ACTIONS(3156),
    [anon_sym_BANG] = ACTIONS(3156),
    [anon_sym_TILDE] = ACTIONS(3156),
    [anon_sym_DASH] = ACTIONS(3154),
    [anon_sym_PLUS] = ACTIONS(3154),
    [anon_sym_STAR] = ACTIONS(3156),
    [anon_sym_AMP_AMP] = ACTIONS(3156),
    [anon_sym_AMP] = ACTIONS(3154),
    [anon_sym_SEMI] = ACTIONS(3156),
    [anon_sym___extension__] = ACTIONS(3154),
    [anon_sym_typedef] = ACTIONS(3154),
    [anon_sym_virtual] = ACTIONS(3154),
    [anon_sym_extern] = ACTIONS(3154),
    [anon_sym___attribute__] = ACTIONS(3154),
    [anon_sym___attribute] = ACTIONS(3154),
    [anon_sym_COLON_COLON] = ACTIONS(3156),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3156),
    [anon_sym___declspec] = ACTIONS(3154),
    [anon_sym___based] = ACTIONS(3154),
    [anon_sym___cdecl] = ACTIONS(3154),
    [anon_sym___clrcall] = ACTIONS(3154),
    [anon_sym___stdcall] = ACTIONS(3154),
    [anon_sym___fastcall] = ACTIONS(3154),
    [anon_sym___thiscall] = ACTIONS(3154),
    [anon_sym___vectorcall] = ACTIONS(3154),
    [anon_sym_LBRACE] = ACTIONS(3156),
    [anon_sym_signed] = ACTIONS(3154),
    [anon_sym_unsigned] = ACTIONS(3154),
    [anon_sym_long] = ACTIONS(3154),
    [anon_sym_short] = ACTIONS(3154),
    [anon_sym_LBRACK] = ACTIONS(3154),
    [anon_sym_static] = ACTIONS(3154),
    [anon_sym_register] = ACTIONS(3154),
    [anon_sym_inline] = ACTIONS(3154),
    [anon_sym___inline] = ACTIONS(3154),
    [anon_sym___inline__] = ACTIONS(3154),
    [anon_sym___forceinline] = ACTIONS(3154),
    [anon_sym_thread_local] = ACTIONS(3154),
    [anon_sym___thread] = ACTIONS(3154),
    [anon_sym_const] = ACTIONS(3154),
    [anon_sym_constexpr] = ACTIONS(3154),
    [anon_sym_volatile] = ACTIONS(3154),
    [anon_sym_restrict] = ACTIONS(3154),
    [anon_sym___restrict__] = ACTIONS(3154),
    [anon_sym__Atomic] = ACTIONS(3154),
    [anon_sym__Noreturn] = ACTIONS(3154),
    [anon_sym_noreturn] = ACTIONS(3154),
    [anon_sym__Nonnull] = ACTIONS(3154),
    [anon_sym_mutable] = ACTIONS(3154),
    [anon_sym_constinit] = ACTIONS(3154),
    [anon_sym_consteval] = ACTIONS(3154),
    [anon_sym_alignas] = ACTIONS(3154),
    [anon_sym__Alignas] = ACTIONS(3154),
    [sym_primitive_type] = ACTIONS(3154),
    [anon_sym_enum] = ACTIONS(3154),
    [anon_sym_class] = ACTIONS(3154),
    [anon_sym_struct] = ACTIONS(3154),
    [anon_sym_union] = ACTIONS(3154),
    [anon_sym_if] = ACTIONS(3154),
    [anon_sym_switch] = ACTIONS(3154),
    [anon_sym_case] = ACTIONS(3154),
    [anon_sym_default] = ACTIONS(3154),
    [anon_sym_while] = ACTIONS(3154),
    [anon_sym_do] = ACTIONS(3154),
    [anon_sym_for] = ACTIONS(3154),
    [anon_sym_return] = ACTIONS(3154),
    [anon_sym_break] = ACTIONS(3154),
    [anon_sym_continue] = ACTIONS(3154),
    [anon_sym_goto] = ACTIONS(3154),
    [anon_sym___try] = ACTIONS(3154),
    [anon_sym___leave] = ACTIONS(3154),
    [anon_sym_not] = ACTIONS(3154),
    [anon_sym_compl] = ACTIONS(3154),
    [anon_sym_DASH_DASH] = ACTIONS(3156),
    [anon_sym_PLUS_PLUS] = ACTIONS(3156),
    [anon_sym_sizeof] = ACTIONS(3154),
    [anon_sym___alignof__] = ACTIONS(3154),
    [anon_sym___alignof] = ACTIONS(3154),
    [anon_sym__alignof] = ACTIONS(3154),
    [anon_sym_alignof] = ACTIONS(3154),
    [anon_sym__Alignof] = ACTIONS(3154),
    [anon_sym_offsetof] = ACTIONS(3154),
    [anon_sym__Generic] = ACTIONS(3154),
    [anon_sym_asm] = ACTIONS(3154),
    [anon_sym___asm__] = ACTIONS(3154),
    [anon_sym___asm] = ACTIONS(3154),
    [sym_number_literal] = ACTIONS(3156),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3156),
    [anon_sym_u_DQUOTE] = ACTIONS(3156),
    [anon_sym_U_DQUOTE] = ACTIONS(3156),
    [anon_sym_u8_DQUOTE] = ACTIONS(3156),
    [anon_sym_DQUOTE] = ACTIONS(3156),
    [sym_true] = ACTIONS(3154),
    [sym_false] = ACTIONS(3154),
    [anon_sym_NULL] = ACTIONS(3154),
    [anon_sym_nullptr] = ACTIONS(3154),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3154),
    [anon_sym_decltype] = ACTIONS(3154),
    [anon_sym_explicit] = ACTIONS(3154),
    [anon_sym_typename] = ACTIONS(3154),
    [anon_sym_template] = ACTIONS(3154),
    [anon_sym_operator] = ACTIONS(3154),
    [anon_sym_try] = ACTIONS(3154),
    [anon_sym_delete] = ACTIONS(3154),
    [anon_sym_throw] = ACTIONS(3154),
    [anon_sym_namespace] = ACTIONS(3154),
    [anon_sym_using] = ACTIONS(3154),
    [anon_sym_static_assert] = ACTIONS(3154),
    [anon_sym_concept] = ACTIONS(3154),
    [anon_sym_co_return] = ACTIONS(3154),
    [anon_sym_co_yield] = ACTIONS(3154),
    [anon_sym_R_DQUOTE] = ACTIONS(3156),
    [anon_sym_LR_DQUOTE] = ACTIONS(3156),
    [anon_sym_uR_DQUOTE] = ACTIONS(3156),
    [anon_sym_UR_DQUOTE] = ACTIONS(3156),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3156),
    [anon_sym_co_await] = ACTIONS(3154),
    [anon_sym_new] = ACTIONS(3154),
    [anon_sym_requires] = ACTIONS(3154),
    [sym_this] = ACTIONS(3154),
  },
  [614] = {
    [sym_identifier] = ACTIONS(3104),
    [aux_sym_preproc_include_token1] = ACTIONS(3104),
    [aux_sym_preproc_def_token1] = ACTIONS(3104),
    [aux_sym_preproc_if_token1] = ACTIONS(3104),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3104),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3104),
    [sym_preproc_directive] = ACTIONS(3104),
    [anon_sym_LPAREN2] = ACTIONS(3106),
    [anon_sym_BANG] = ACTIONS(3106),
    [anon_sym_TILDE] = ACTIONS(3106),
    [anon_sym_DASH] = ACTIONS(3104),
    [anon_sym_PLUS] = ACTIONS(3104),
    [anon_sym_STAR] = ACTIONS(3106),
    [anon_sym_AMP_AMP] = ACTIONS(3106),
    [anon_sym_AMP] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(3106),
    [anon_sym___extension__] = ACTIONS(3104),
    [anon_sym_typedef] = ACTIONS(3104),
    [anon_sym_virtual] = ACTIONS(3104),
    [anon_sym_extern] = ACTIONS(3104),
    [anon_sym___attribute__] = ACTIONS(3104),
    [anon_sym___attribute] = ACTIONS(3104),
    [anon_sym_COLON_COLON] = ACTIONS(3106),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3106),
    [anon_sym___declspec] = ACTIONS(3104),
    [anon_sym___based] = ACTIONS(3104),
    [anon_sym___cdecl] = ACTIONS(3104),
    [anon_sym___clrcall] = ACTIONS(3104),
    [anon_sym___stdcall] = ACTIONS(3104),
    [anon_sym___fastcall] = ACTIONS(3104),
    [anon_sym___thiscall] = ACTIONS(3104),
    [anon_sym___vectorcall] = ACTIONS(3104),
    [anon_sym_LBRACE] = ACTIONS(3106),
    [anon_sym_RBRACE] = ACTIONS(3106),
    [anon_sym_signed] = ACTIONS(3104),
    [anon_sym_unsigned] = ACTIONS(3104),
    [anon_sym_long] = ACTIONS(3104),
    [anon_sym_short] = ACTIONS(3104),
    [anon_sym_LBRACK] = ACTIONS(3104),
    [anon_sym_static] = ACTIONS(3104),
    [anon_sym_register] = ACTIONS(3104),
    [anon_sym_inline] = ACTIONS(3104),
    [anon_sym___inline] = ACTIONS(3104),
    [anon_sym___inline__] = ACTIONS(3104),
    [anon_sym___forceinline] = ACTIONS(3104),
    [anon_sym_thread_local] = ACTIONS(3104),
    [anon_sym___thread] = ACTIONS(3104),
    [anon_sym_const] = ACTIONS(3104),
    [anon_sym_constexpr] = ACTIONS(3104),
    [anon_sym_volatile] = ACTIONS(3104),
    [anon_sym_restrict] = ACTIONS(3104),
    [anon_sym___restrict__] = ACTIONS(3104),
    [anon_sym__Atomic] = ACTIONS(3104),
    [anon_sym__Noreturn] = ACTIONS(3104),
    [anon_sym_noreturn] = ACTIONS(3104),
    [anon_sym__Nonnull] = ACTIONS(3104),
    [anon_sym_mutable] = ACTIONS(3104),
    [anon_sym_constinit] = ACTIONS(3104),
    [anon_sym_consteval] = ACTIONS(3104),
    [anon_sym_alignas] = ACTIONS(3104),
    [anon_sym__Alignas] = ACTIONS(3104),
    [sym_primitive_type] = ACTIONS(3104),
    [anon_sym_enum] = ACTIONS(3104),
    [anon_sym_class] = ACTIONS(3104),
    [anon_sym_struct] = ACTIONS(3104),
    [anon_sym_union] = ACTIONS(3104),
    [anon_sym_if] = ACTIONS(3104),
    [anon_sym_switch] = ACTIONS(3104),
    [anon_sym_case] = ACTIONS(3104),
    [anon_sym_default] = ACTIONS(3104),
    [anon_sym_while] = ACTIONS(3104),
    [anon_sym_do] = ACTIONS(3104),
    [anon_sym_for] = ACTIONS(3104),
    [anon_sym_return] = ACTIONS(3104),
    [anon_sym_break] = ACTIONS(3104),
    [anon_sym_continue] = ACTIONS(3104),
    [anon_sym_goto] = ACTIONS(3104),
    [anon_sym___try] = ACTIONS(3104),
    [anon_sym___leave] = ACTIONS(3104),
    [anon_sym_not] = ACTIONS(3104),
    [anon_sym_compl] = ACTIONS(3104),
    [anon_sym_DASH_DASH] = ACTIONS(3106),
    [anon_sym_PLUS_PLUS] = ACTIONS(3106),
    [anon_sym_sizeof] = ACTIONS(3104),
    [anon_sym___alignof__] = ACTIONS(3104),
    [anon_sym___alignof] = ACTIONS(3104),
    [anon_sym__alignof] = ACTIONS(3104),
    [anon_sym_alignof] = ACTIONS(3104),
    [anon_sym__Alignof] = ACTIONS(3104),
    [anon_sym_offsetof] = ACTIONS(3104),
    [anon_sym__Generic] = ACTIONS(3104),
    [anon_sym_asm] = ACTIONS(3104),
    [anon_sym___asm__] = ACTIONS(3104),
    [anon_sym___asm] = ACTIONS(3104),
    [sym_number_literal] = ACTIONS(3106),
    [anon_sym_L_SQUOTE] = ACTIONS(3106),
    [anon_sym_u_SQUOTE] = ACTIONS(3106),
    [anon_sym_U_SQUOTE] = ACTIONS(3106),
    [anon_sym_u8_SQUOTE] = ACTIONS(3106),
    [anon_sym_SQUOTE] = ACTIONS(3106),
    [anon_sym_L_DQUOTE] = ACTIONS(3106),
    [anon_sym_u_DQUOTE] = ACTIONS(3106),
    [anon_sym_U_DQUOTE] = ACTIONS(3106),
    [anon_sym_u8_DQUOTE] = ACTIONS(3106),
    [anon_sym_DQUOTE] = ACTIONS(3106),
    [sym_true] = ACTIONS(3104),
    [sym_false] = ACTIONS(3104),
    [anon_sym_NULL] = ACTIONS(3104),
    [anon_sym_nullptr] = ACTIONS(3104),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3104),
    [anon_sym_decltype] = ACTIONS(3104),
    [anon_sym_explicit] = ACTIONS(3104),
    [anon_sym_typename] = ACTIONS(3104),
    [anon_sym_template] = ACTIONS(3104),
    [anon_sym_operator] = ACTIONS(3104),
    [anon_sym_try] = ACTIONS(3104),
    [anon_sym_delete] = ACTIONS(3104),
    [anon_sym_throw] = ACTIONS(3104),
    [anon_sym_namespace] = ACTIONS(3104),
    [anon_sym_using] = ACTIONS(3104),
    [anon_sym_static_assert] = ACTIONS(3104),
    [anon_sym_concept] = ACTIONS(3104),
    [anon_sym_co_return] = ACTIONS(3104),
    [anon_sym_co_yield] = ACTIONS(3104),
    [anon_sym_R_DQUOTE] = ACTIONS(3106),
    [anon_sym_LR_DQUOTE] = ACTIONS(3106),
    [anon_sym_uR_DQUOTE] = ACTIONS(3106),
    [anon_sym_UR_DQUOTE] = ACTIONS(3106),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3106),
    [anon_sym_co_await] = ACTIONS(3104),
    [anon_sym_new] = ACTIONS(3104),
    [anon_sym_requires] = ACTIONS(3104),
    [sym_this] = ACTIONS(3104),
  },
  [615] = {
    [sym_identifier] = ACTIONS(3146),
    [aux_sym_preproc_include_token1] = ACTIONS(3146),
    [aux_sym_preproc_def_token1] = ACTIONS(3146),
    [aux_sym_preproc_if_token1] = ACTIONS(3146),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3146),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3146),
    [sym_preproc_directive] = ACTIONS(3146),
    [anon_sym_LPAREN2] = ACTIONS(3148),
    [anon_sym_BANG] = ACTIONS(3148),
    [anon_sym_TILDE] = ACTIONS(3148),
    [anon_sym_DASH] = ACTIONS(3146),
    [anon_sym_PLUS] = ACTIONS(3146),
    [anon_sym_STAR] = ACTIONS(3148),
    [anon_sym_AMP_AMP] = ACTIONS(3148),
    [anon_sym_AMP] = ACTIONS(3146),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym___extension__] = ACTIONS(3146),
    [anon_sym_typedef] = ACTIONS(3146),
    [anon_sym_virtual] = ACTIONS(3146),
    [anon_sym_extern] = ACTIONS(3146),
    [anon_sym___attribute__] = ACTIONS(3146),
    [anon_sym___attribute] = ACTIONS(3146),
    [anon_sym_COLON_COLON] = ACTIONS(3148),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3148),
    [anon_sym___declspec] = ACTIONS(3146),
    [anon_sym___based] = ACTIONS(3146),
    [anon_sym___cdecl] = ACTIONS(3146),
    [anon_sym___clrcall] = ACTIONS(3146),
    [anon_sym___stdcall] = ACTIONS(3146),
    [anon_sym___fastcall] = ACTIONS(3146),
    [anon_sym___thiscall] = ACTIONS(3146),
    [anon_sym___vectorcall] = ACTIONS(3146),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_RBRACE] = ACTIONS(3148),
    [anon_sym_signed] = ACTIONS(3146),
    [anon_sym_unsigned] = ACTIONS(3146),
    [anon_sym_long] = ACTIONS(3146),
    [anon_sym_short] = ACTIONS(3146),
    [anon_sym_LBRACK] = ACTIONS(3146),
    [anon_sym_static] = ACTIONS(3146),
    [anon_sym_register] = ACTIONS(3146),
    [anon_sym_inline] = ACTIONS(3146),
    [anon_sym___inline] = ACTIONS(3146),
    [anon_sym___inline__] = ACTIONS(3146),
    [anon_sym___forceinline] = ACTIONS(3146),
    [anon_sym_thread_local] = ACTIONS(3146),
    [anon_sym___thread] = ACTIONS(3146),
    [anon_sym_const] = ACTIONS(3146),
    [anon_sym_constexpr] = ACTIONS(3146),
    [anon_sym_volatile] = ACTIONS(3146),
    [anon_sym_restrict] = ACTIONS(3146),
    [anon_sym___restrict__] = ACTIONS(3146),
    [anon_sym__Atomic] = ACTIONS(3146),
    [anon_sym__Noreturn] = ACTIONS(3146),
    [anon_sym_noreturn] = ACTIONS(3146),
    [anon_sym__Nonnull] = ACTIONS(3146),
    [anon_sym_mutable] = ACTIONS(3146),
    [anon_sym_constinit] = ACTIONS(3146),
    [anon_sym_consteval] = ACTIONS(3146),
    [anon_sym_alignas] = ACTIONS(3146),
    [anon_sym__Alignas] = ACTIONS(3146),
    [sym_primitive_type] = ACTIONS(3146),
    [anon_sym_enum] = ACTIONS(3146),
    [anon_sym_class] = ACTIONS(3146),
    [anon_sym_struct] = ACTIONS(3146),
    [anon_sym_union] = ACTIONS(3146),
    [anon_sym_if] = ACTIONS(3146),
    [anon_sym_switch] = ACTIONS(3146),
    [anon_sym_case] = ACTIONS(3146),
    [anon_sym_default] = ACTIONS(3146),
    [anon_sym_while] = ACTIONS(3146),
    [anon_sym_do] = ACTIONS(3146),
    [anon_sym_for] = ACTIONS(3146),
    [anon_sym_return] = ACTIONS(3146),
    [anon_sym_break] = ACTIONS(3146),
    [anon_sym_continue] = ACTIONS(3146),
    [anon_sym_goto] = ACTIONS(3146),
    [anon_sym___try] = ACTIONS(3146),
    [anon_sym___leave] = ACTIONS(3146),
    [anon_sym_not] = ACTIONS(3146),
    [anon_sym_compl] = ACTIONS(3146),
    [anon_sym_DASH_DASH] = ACTIONS(3148),
    [anon_sym_PLUS_PLUS] = ACTIONS(3148),
    [anon_sym_sizeof] = ACTIONS(3146),
    [anon_sym___alignof__] = ACTIONS(3146),
    [anon_sym___alignof] = ACTIONS(3146),
    [anon_sym__alignof] = ACTIONS(3146),
    [anon_sym_alignof] = ACTIONS(3146),
    [anon_sym__Alignof] = ACTIONS(3146),
    [anon_sym_offsetof] = ACTIONS(3146),
    [anon_sym__Generic] = ACTIONS(3146),
    [anon_sym_asm] = ACTIONS(3146),
    [anon_sym___asm__] = ACTIONS(3146),
    [anon_sym___asm] = ACTIONS(3146),
    [sym_number_literal] = ACTIONS(3148),
    [anon_sym_L_SQUOTE] = ACTIONS(3148),
    [anon_sym_u_SQUOTE] = ACTIONS(3148),
    [anon_sym_U_SQUOTE] = ACTIONS(3148),
    [anon_sym_u8_SQUOTE] = ACTIONS(3148),
    [anon_sym_SQUOTE] = ACTIONS(3148),
    [anon_sym_L_DQUOTE] = ACTIONS(3148),
    [anon_sym_u_DQUOTE] = ACTIONS(3148),
    [anon_sym_U_DQUOTE] = ACTIONS(3148),
    [anon_sym_u8_DQUOTE] = ACTIONS(3148),
    [anon_sym_DQUOTE] = ACTIONS(3148),
    [sym_true] = ACTIONS(3146),
    [sym_false] = ACTIONS(3146),
    [anon_sym_NULL] = ACTIONS(3146),
    [anon_sym_nullptr] = ACTIONS(3146),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3146),
    [anon_sym_decltype] = ACTIONS(3146),
    [anon_sym_explicit] = ACTIONS(3146),
    [anon_sym_typename] = ACTIONS(3146),
    [anon_sym_template] = ACTIONS(3146),
    [anon_sym_operator] = ACTIONS(3146),
    [anon_sym_try] = ACTIONS(3146),
    [anon_sym_delete] = ACTIONS(3146),
    [anon_sym_throw] = ACTIONS(3146),
    [anon_sym_namespace] = ACTIONS(3146),
    [anon_sym_using] = ACTIONS(3146),
    [anon_sym_static_assert] = ACTIONS(3146),
    [anon_sym_concept] = ACTIONS(3146),
    [anon_sym_co_return] = ACTIONS(3146),
    [anon_sym_co_yield] = ACTIONS(3146),
    [anon_sym_R_DQUOTE] = ACTIONS(3148),
    [anon_sym_LR_DQUOTE] = ACTIONS(3148),
    [anon_sym_uR_DQUOTE] = ACTIONS(3148),
    [anon_sym_UR_DQUOTE] = ACTIONS(3148),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3148),
    [anon_sym_co_await] = ACTIONS(3146),
    [anon_sym_new] = ACTIONS(3146),
    [anon_sym_requires] = ACTIONS(3146),
    [sym_this] = ACTIONS(3146),
  },
  [616] = {
    [sym_identifier] = ACTIONS(3150),
    [aux_sym_preproc_include_token1] = ACTIONS(3150),
    [aux_sym_preproc_def_token1] = ACTIONS(3150),
    [aux_sym_preproc_if_token1] = ACTIONS(3150),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3150),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3150),
    [sym_preproc_directive] = ACTIONS(3150),
    [anon_sym_LPAREN2] = ACTIONS(3152),
    [anon_sym_BANG] = ACTIONS(3152),
    [anon_sym_TILDE] = ACTIONS(3152),
    [anon_sym_DASH] = ACTIONS(3150),
    [anon_sym_PLUS] = ACTIONS(3150),
    [anon_sym_STAR] = ACTIONS(3152),
    [anon_sym_AMP_AMP] = ACTIONS(3152),
    [anon_sym_AMP] = ACTIONS(3150),
    [anon_sym_SEMI] = ACTIONS(3152),
    [anon_sym___extension__] = ACTIONS(3150),
    [anon_sym_typedef] = ACTIONS(3150),
    [anon_sym_virtual] = ACTIONS(3150),
    [anon_sym_extern] = ACTIONS(3150),
    [anon_sym___attribute__] = ACTIONS(3150),
    [anon_sym___attribute] = ACTIONS(3150),
    [anon_sym_COLON_COLON] = ACTIONS(3152),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3152),
    [anon_sym___declspec] = ACTIONS(3150),
    [anon_sym___based] = ACTIONS(3150),
    [anon_sym___cdecl] = ACTIONS(3150),
    [anon_sym___clrcall] = ACTIONS(3150),
    [anon_sym___stdcall] = ACTIONS(3150),
    [anon_sym___fastcall] = ACTIONS(3150),
    [anon_sym___thiscall] = ACTIONS(3150),
    [anon_sym___vectorcall] = ACTIONS(3150),
    [anon_sym_LBRACE] = ACTIONS(3152),
    [anon_sym_RBRACE] = ACTIONS(3152),
    [anon_sym_signed] = ACTIONS(3150),
    [anon_sym_unsigned] = ACTIONS(3150),
    [anon_sym_long] = ACTIONS(3150),
    [anon_sym_short] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(3150),
    [anon_sym_static] = ACTIONS(3150),
    [anon_sym_register] = ACTIONS(3150),
    [anon_sym_inline] = ACTIONS(3150),
    [anon_sym___inline] = ACTIONS(3150),
    [anon_sym___inline__] = ACTIONS(3150),
    [anon_sym___forceinline] = ACTIONS(3150),
    [anon_sym_thread_local] = ACTIONS(3150),
    [anon_sym___thread] = ACTIONS(3150),
    [anon_sym_const] = ACTIONS(3150),
    [anon_sym_constexpr] = ACTIONS(3150),
    [anon_sym_volatile] = ACTIONS(3150),
    [anon_sym_restrict] = ACTIONS(3150),
    [anon_sym___restrict__] = ACTIONS(3150),
    [anon_sym__Atomic] = ACTIONS(3150),
    [anon_sym__Noreturn] = ACTIONS(3150),
    [anon_sym_noreturn] = ACTIONS(3150),
    [anon_sym__Nonnull] = ACTIONS(3150),
    [anon_sym_mutable] = ACTIONS(3150),
    [anon_sym_constinit] = ACTIONS(3150),
    [anon_sym_consteval] = ACTIONS(3150),
    [anon_sym_alignas] = ACTIONS(3150),
    [anon_sym__Alignas] = ACTIONS(3150),
    [sym_primitive_type] = ACTIONS(3150),
    [anon_sym_enum] = ACTIONS(3150),
    [anon_sym_class] = ACTIONS(3150),
    [anon_sym_struct] = ACTIONS(3150),
    [anon_sym_union] = ACTIONS(3150),
    [anon_sym_if] = ACTIONS(3150),
    [anon_sym_switch] = ACTIONS(3150),
    [anon_sym_case] = ACTIONS(3150),
    [anon_sym_default] = ACTIONS(3150),
    [anon_sym_while] = ACTIONS(3150),
    [anon_sym_do] = ACTIONS(3150),
    [anon_sym_for] = ACTIONS(3150),
    [anon_sym_return] = ACTIONS(3150),
    [anon_sym_break] = ACTIONS(3150),
    [anon_sym_continue] = ACTIONS(3150),
    [anon_sym_goto] = ACTIONS(3150),
    [anon_sym___try] = ACTIONS(3150),
    [anon_sym___leave] = ACTIONS(3150),
    [anon_sym_not] = ACTIONS(3150),
    [anon_sym_compl] = ACTIONS(3150),
    [anon_sym_DASH_DASH] = ACTIONS(3152),
    [anon_sym_PLUS_PLUS] = ACTIONS(3152),
    [anon_sym_sizeof] = ACTIONS(3150),
    [anon_sym___alignof__] = ACTIONS(3150),
    [anon_sym___alignof] = ACTIONS(3150),
    [anon_sym__alignof] = ACTIONS(3150),
    [anon_sym_alignof] = ACTIONS(3150),
    [anon_sym__Alignof] = ACTIONS(3150),
    [anon_sym_offsetof] = ACTIONS(3150),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3150),
    [anon_sym___asm__] = ACTIONS(3150),
    [anon_sym___asm] = ACTIONS(3150),
    [sym_number_literal] = ACTIONS(3152),
    [anon_sym_L_SQUOTE] = ACTIONS(3152),
    [anon_sym_u_SQUOTE] = ACTIONS(3152),
    [anon_sym_U_SQUOTE] = ACTIONS(3152),
    [anon_sym_u8_SQUOTE] = ACTIONS(3152),
    [anon_sym_SQUOTE] = ACTIONS(3152),
    [anon_sym_L_DQUOTE] = ACTIONS(3152),
    [anon_sym_u_DQUOTE] = ACTIONS(3152),
    [anon_sym_U_DQUOTE] = ACTIONS(3152),
    [anon_sym_u8_DQUOTE] = ACTIONS(3152),
    [anon_sym_DQUOTE] = ACTIONS(3152),
    [sym_true] = ACTIONS(3150),
    [sym_false] = ACTIONS(3150),
    [anon_sym_NULL] = ACTIONS(3150),
    [anon_sym_nullptr] = ACTIONS(3150),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3150),
    [anon_sym_decltype] = ACTIONS(3150),
    [anon_sym_explicit] = ACTIONS(3150),
    [anon_sym_typename] = ACTIONS(3150),
    [anon_sym_template] = ACTIONS(3150),
    [anon_sym_operator] = ACTIONS(3150),
    [anon_sym_try] = ACTIONS(3150),
    [anon_sym_delete] = ACTIONS(3150),
    [anon_sym_throw] = ACTIONS(3150),
    [anon_sym_namespace] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_static_assert] = ACTIONS(3150),
    [anon_sym_concept] = ACTIONS(3150),
    [anon_sym_co_return] = ACTIONS(3150),
    [anon_sym_co_yield] = ACTIONS(3150),
    [anon_sym_R_DQUOTE] = ACTIONS(3152),
    [anon_sym_LR_DQUOTE] = ACTIONS(3152),
    [anon_sym_uR_DQUOTE] = ACTIONS(3152),
    [anon_sym_UR_DQUOTE] = ACTIONS(3152),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3152),
    [anon_sym_co_await] = ACTIONS(3150),
    [anon_sym_new] = ACTIONS(3150),
    [anon_sym_requires] = ACTIONS(3150),
    [sym_this] = ACTIONS(3150),
  },
  [617] = {
    [sym_identifier] = ACTIONS(3158),
    [aux_sym_preproc_include_token1] = ACTIONS(3158),
    [aux_sym_preproc_def_token1] = ACTIONS(3158),
    [aux_sym_preproc_if_token1] = ACTIONS(3158),
    [aux_sym_preproc_if_token2] = ACTIONS(3158),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3158),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3158),
    [sym_preproc_directive] = ACTIONS(3158),
    [anon_sym_LPAREN2] = ACTIONS(3160),
    [anon_sym_BANG] = ACTIONS(3160),
    [anon_sym_TILDE] = ACTIONS(3160),
    [anon_sym_DASH] = ACTIONS(3158),
    [anon_sym_PLUS] = ACTIONS(3158),
    [anon_sym_STAR] = ACTIONS(3160),
    [anon_sym_AMP_AMP] = ACTIONS(3160),
    [anon_sym_AMP] = ACTIONS(3158),
    [anon_sym_SEMI] = ACTIONS(3160),
    [anon_sym___extension__] = ACTIONS(3158),
    [anon_sym_typedef] = ACTIONS(3158),
    [anon_sym_virtual] = ACTIONS(3158),
    [anon_sym_extern] = ACTIONS(3158),
    [anon_sym___attribute__] = ACTIONS(3158),
    [anon_sym___attribute] = ACTIONS(3158),
    [anon_sym_COLON_COLON] = ACTIONS(3160),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3160),
    [anon_sym___declspec] = ACTIONS(3158),
    [anon_sym___based] = ACTIONS(3158),
    [anon_sym___cdecl] = ACTIONS(3158),
    [anon_sym___clrcall] = ACTIONS(3158),
    [anon_sym___stdcall] = ACTIONS(3158),
    [anon_sym___fastcall] = ACTIONS(3158),
    [anon_sym___thiscall] = ACTIONS(3158),
    [anon_sym___vectorcall] = ACTIONS(3158),
    [anon_sym_LBRACE] = ACTIONS(3160),
    [anon_sym_signed] = ACTIONS(3158),
    [anon_sym_unsigned] = ACTIONS(3158),
    [anon_sym_long] = ACTIONS(3158),
    [anon_sym_short] = ACTIONS(3158),
    [anon_sym_LBRACK] = ACTIONS(3158),
    [anon_sym_static] = ACTIONS(3158),
    [anon_sym_register] = ACTIONS(3158),
    [anon_sym_inline] = ACTIONS(3158),
    [anon_sym___inline] = ACTIONS(3158),
    [anon_sym___inline__] = ACTIONS(3158),
    [anon_sym___forceinline] = ACTIONS(3158),
    [anon_sym_thread_local] = ACTIONS(3158),
    [anon_sym___thread] = ACTIONS(3158),
    [anon_sym_const] = ACTIONS(3158),
    [anon_sym_constexpr] = ACTIONS(3158),
    [anon_sym_volatile] = ACTIONS(3158),
    [anon_sym_restrict] = ACTIONS(3158),
    [anon_sym___restrict__] = ACTIONS(3158),
    [anon_sym__Atomic] = ACTIONS(3158),
    [anon_sym__Noreturn] = ACTIONS(3158),
    [anon_sym_noreturn] = ACTIONS(3158),
    [anon_sym__Nonnull] = ACTIONS(3158),
    [anon_sym_mutable] = ACTIONS(3158),
    [anon_sym_constinit] = ACTIONS(3158),
    [anon_sym_consteval] = ACTIONS(3158),
    [anon_sym_alignas] = ACTIONS(3158),
    [anon_sym__Alignas] = ACTIONS(3158),
    [sym_primitive_type] = ACTIONS(3158),
    [anon_sym_enum] = ACTIONS(3158),
    [anon_sym_class] = ACTIONS(3158),
    [anon_sym_struct] = ACTIONS(3158),
    [anon_sym_union] = ACTIONS(3158),
    [anon_sym_if] = ACTIONS(3158),
    [anon_sym_switch] = ACTIONS(3158),
    [anon_sym_case] = ACTIONS(3158),
    [anon_sym_default] = ACTIONS(3158),
    [anon_sym_while] = ACTIONS(3158),
    [anon_sym_do] = ACTIONS(3158),
    [anon_sym_for] = ACTIONS(3158),
    [anon_sym_return] = ACTIONS(3158),
    [anon_sym_break] = ACTIONS(3158),
    [anon_sym_continue] = ACTIONS(3158),
    [anon_sym_goto] = ACTIONS(3158),
    [anon_sym___try] = ACTIONS(3158),
    [anon_sym___leave] = ACTIONS(3158),
    [anon_sym_not] = ACTIONS(3158),
    [anon_sym_compl] = ACTIONS(3158),
    [anon_sym_DASH_DASH] = ACTIONS(3160),
    [anon_sym_PLUS_PLUS] = ACTIONS(3160),
    [anon_sym_sizeof] = ACTIONS(3158),
    [anon_sym___alignof__] = ACTIONS(3158),
    [anon_sym___alignof] = ACTIONS(3158),
    [anon_sym__alignof] = ACTIONS(3158),
    [anon_sym_alignof] = ACTIONS(3158),
    [anon_sym__Alignof] = ACTIONS(3158),
    [anon_sym_offsetof] = ACTIONS(3158),
    [anon_sym__Generic] = ACTIONS(3158),
    [anon_sym_asm] = ACTIONS(3158),
    [anon_sym___asm__] = ACTIONS(3158),
    [anon_sym___asm] = ACTIONS(3158),
    [sym_number_literal] = ACTIONS(3160),
    [anon_sym_L_SQUOTE] = ACTIONS(3160),
    [anon_sym_u_SQUOTE] = ACTIONS(3160),
    [anon_sym_U_SQUOTE] = ACTIONS(3160),
    [anon_sym_u8_SQUOTE] = ACTIONS(3160),
    [anon_sym_SQUOTE] = ACTIONS(3160),
    [anon_sym_L_DQUOTE] = ACTIONS(3160),
    [anon_sym_u_DQUOTE] = ACTIONS(3160),
    [anon_sym_U_DQUOTE] = ACTIONS(3160),
    [anon_sym_u8_DQUOTE] = ACTIONS(3160),
    [anon_sym_DQUOTE] = ACTIONS(3160),
    [sym_true] = ACTIONS(3158),
    [sym_false] = ACTIONS(3158),
    [anon_sym_NULL] = ACTIONS(3158),
    [anon_sym_nullptr] = ACTIONS(3158),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3158),
    [anon_sym_decltype] = ACTIONS(3158),
    [anon_sym_explicit] = ACTIONS(3158),
    [anon_sym_typename] = ACTIONS(3158),
    [anon_sym_template] = ACTIONS(3158),
    [anon_sym_operator] = ACTIONS(3158),
    [anon_sym_try] = ACTIONS(3158),
    [anon_sym_delete] = ACTIONS(3158),
    [anon_sym_throw] = ACTIONS(3158),
    [anon_sym_namespace] = ACTIONS(3158),
    [anon_sym_using] = ACTIONS(3158),
    [anon_sym_static_assert] = ACTIONS(3158),
    [anon_sym_concept] = ACTIONS(3158),
    [anon_sym_co_return] = ACTIONS(3158),
    [anon_sym_co_yield] = ACTIONS(3158),
    [anon_sym_R_DQUOTE] = ACTIONS(3160),
    [anon_sym_LR_DQUOTE] = ACTIONS(3160),
    [anon_sym_uR_DQUOTE] = ACTIONS(3160),
    [anon_sym_UR_DQUOTE] = ACTIONS(3160),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3160),
    [anon_sym_co_await] = ACTIONS(3158),
    [anon_sym_new] = ACTIONS(3158),
    [anon_sym_requires] = ACTIONS(3158),
    [sym_this] = ACTIONS(3158),
  },
  [618] = {
    [sym_identifier] = ACTIONS(2842),
    [aux_sym_preproc_include_token1] = ACTIONS(2842),
    [aux_sym_preproc_def_token1] = ACTIONS(2842),
    [aux_sym_preproc_if_token1] = ACTIONS(2842),
    [aux_sym_preproc_if_token2] = ACTIONS(2842),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2842),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2842),
    [sym_preproc_directive] = ACTIONS(2842),
    [anon_sym_LPAREN2] = ACTIONS(2844),
    [anon_sym_BANG] = ACTIONS(2844),
    [anon_sym_TILDE] = ACTIONS(2844),
    [anon_sym_DASH] = ACTIONS(2842),
    [anon_sym_PLUS] = ACTIONS(2842),
    [anon_sym_STAR] = ACTIONS(2844),
    [anon_sym_AMP_AMP] = ACTIONS(2844),
    [anon_sym_AMP] = ACTIONS(2842),
    [anon_sym_SEMI] = ACTIONS(2844),
    [anon_sym___extension__] = ACTIONS(2842),
    [anon_sym_typedef] = ACTIONS(2842),
    [anon_sym_virtual] = ACTIONS(2842),
    [anon_sym_extern] = ACTIONS(2842),
    [anon_sym___attribute__] = ACTIONS(2842),
    [anon_sym___attribute] = ACTIONS(2842),
    [anon_sym_COLON_COLON] = ACTIONS(2844),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2844),
    [anon_sym___declspec] = ACTIONS(2842),
    [anon_sym___based] = ACTIONS(2842),
    [anon_sym___cdecl] = ACTIONS(2842),
    [anon_sym___clrcall] = ACTIONS(2842),
    [anon_sym___stdcall] = ACTIONS(2842),
    [anon_sym___fastcall] = ACTIONS(2842),
    [anon_sym___thiscall] = ACTIONS(2842),
    [anon_sym___vectorcall] = ACTIONS(2842),
    [anon_sym_LBRACE] = ACTIONS(2844),
    [anon_sym_signed] = ACTIONS(2842),
    [anon_sym_unsigned] = ACTIONS(2842),
    [anon_sym_long] = ACTIONS(2842),
    [anon_sym_short] = ACTIONS(2842),
    [anon_sym_LBRACK] = ACTIONS(2842),
    [anon_sym_static] = ACTIONS(2842),
    [anon_sym_register] = ACTIONS(2842),
    [anon_sym_inline] = ACTIONS(2842),
    [anon_sym___inline] = ACTIONS(2842),
    [anon_sym___inline__] = ACTIONS(2842),
    [anon_sym___forceinline] = ACTIONS(2842),
    [anon_sym_thread_local] = ACTIONS(2842),
    [anon_sym___thread] = ACTIONS(2842),
    [anon_sym_const] = ACTIONS(2842),
    [anon_sym_constexpr] = ACTIONS(2842),
    [anon_sym_volatile] = ACTIONS(2842),
    [anon_sym_restrict] = ACTIONS(2842),
    [anon_sym___restrict__] = ACTIONS(2842),
    [anon_sym__Atomic] = ACTIONS(2842),
    [anon_sym__Noreturn] = ACTIONS(2842),
    [anon_sym_noreturn] = ACTIONS(2842),
    [anon_sym__Nonnull] = ACTIONS(2842),
    [anon_sym_mutable] = ACTIONS(2842),
    [anon_sym_constinit] = ACTIONS(2842),
    [anon_sym_consteval] = ACTIONS(2842),
    [anon_sym_alignas] = ACTIONS(2842),
    [anon_sym__Alignas] = ACTIONS(2842),
    [sym_primitive_type] = ACTIONS(2842),
    [anon_sym_enum] = ACTIONS(2842),
    [anon_sym_class] = ACTIONS(2842),
    [anon_sym_struct] = ACTIONS(2842),
    [anon_sym_union] = ACTIONS(2842),
    [anon_sym_if] = ACTIONS(2842),
    [anon_sym_switch] = ACTIONS(2842),
    [anon_sym_case] = ACTIONS(2842),
    [anon_sym_default] = ACTIONS(2842),
    [anon_sym_while] = ACTIONS(2842),
    [anon_sym_do] = ACTIONS(2842),
    [anon_sym_for] = ACTIONS(2842),
    [anon_sym_return] = ACTIONS(2842),
    [anon_sym_break] = ACTIONS(2842),
    [anon_sym_continue] = ACTIONS(2842),
    [anon_sym_goto] = ACTIONS(2842),
    [anon_sym___try] = ACTIONS(2842),
    [anon_sym___leave] = ACTIONS(2842),
    [anon_sym_not] = ACTIONS(2842),
    [anon_sym_compl] = ACTIONS(2842),
    [anon_sym_DASH_DASH] = ACTIONS(2844),
    [anon_sym_PLUS_PLUS] = ACTIONS(2844),
    [anon_sym_sizeof] = ACTIONS(2842),
    [anon_sym___alignof__] = ACTIONS(2842),
    [anon_sym___alignof] = ACTIONS(2842),
    [anon_sym__alignof] = ACTIONS(2842),
    [anon_sym_alignof] = ACTIONS(2842),
    [anon_sym__Alignof] = ACTIONS(2842),
    [anon_sym_offsetof] = ACTIONS(2842),
    [anon_sym__Generic] = ACTIONS(2842),
    [anon_sym_asm] = ACTIONS(2842),
    [anon_sym___asm__] = ACTIONS(2842),
    [anon_sym___asm] = ACTIONS(2842),
    [sym_number_literal] = ACTIONS(2844),
    [anon_sym_L_SQUOTE] = ACTIONS(2844),
    [anon_sym_u_SQUOTE] = ACTIONS(2844),
    [anon_sym_U_SQUOTE] = ACTIONS(2844),
    [anon_sym_u8_SQUOTE] = ACTIONS(2844),
    [anon_sym_SQUOTE] = ACTIONS(2844),
    [anon_sym_L_DQUOTE] = ACTIONS(2844),
    [anon_sym_u_DQUOTE] = ACTIONS(2844),
    [anon_sym_U_DQUOTE] = ACTIONS(2844),
    [anon_sym_u8_DQUOTE] = ACTIONS(2844),
    [anon_sym_DQUOTE] = ACTIONS(2844),
    [sym_true] = ACTIONS(2842),
    [sym_false] = ACTIONS(2842),
    [anon_sym_NULL] = ACTIONS(2842),
    [anon_sym_nullptr] = ACTIONS(2842),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2842),
    [anon_sym_decltype] = ACTIONS(2842),
    [anon_sym_explicit] = ACTIONS(2842),
    [anon_sym_typename] = ACTIONS(2842),
    [anon_sym_template] = ACTIONS(2842),
    [anon_sym_operator] = ACTIONS(2842),
    [anon_sym_try] = ACTIONS(2842),
    [anon_sym_delete] = ACTIONS(2842),
    [anon_sym_throw] = ACTIONS(2842),
    [anon_sym_namespace] = ACTIONS(2842),
    [anon_sym_using] = ACTIONS(2842),
    [anon_sym_static_assert] = ACTIONS(2842),
    [anon_sym_concept] = ACTIONS(2842),
    [anon_sym_co_return] = ACTIONS(2842),
    [anon_sym_co_yield] = ACTIONS(2842),
    [anon_sym_R_DQUOTE] = ACTIONS(2844),
    [anon_sym_LR_DQUOTE] = ACTIONS(2844),
    [anon_sym_uR_DQUOTE] = ACTIONS(2844),
    [anon_sym_UR_DQUOTE] = ACTIONS(2844),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2844),
    [anon_sym_co_await] = ACTIONS(2842),
    [anon_sym_new] = ACTIONS(2842),
    [anon_sym_requires] = ACTIONS(2842),
    [sym_this] = ACTIONS(2842),
  },
  [619] = {
    [sym_identifier] = ACTIONS(3068),
    [aux_sym_preproc_include_token1] = ACTIONS(3068),
    [aux_sym_preproc_def_token1] = ACTIONS(3068),
    [aux_sym_preproc_if_token1] = ACTIONS(3068),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3068),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3068),
    [sym_preproc_directive] = ACTIONS(3068),
    [anon_sym_LPAREN2] = ACTIONS(3070),
    [anon_sym_BANG] = ACTIONS(3070),
    [anon_sym_TILDE] = ACTIONS(3070),
    [anon_sym_DASH] = ACTIONS(3068),
    [anon_sym_PLUS] = ACTIONS(3068),
    [anon_sym_STAR] = ACTIONS(3070),
    [anon_sym_AMP_AMP] = ACTIONS(3070),
    [anon_sym_AMP] = ACTIONS(3068),
    [anon_sym_SEMI] = ACTIONS(3070),
    [anon_sym___extension__] = ACTIONS(3068),
    [anon_sym_typedef] = ACTIONS(3068),
    [anon_sym_virtual] = ACTIONS(3068),
    [anon_sym_extern] = ACTIONS(3068),
    [anon_sym___attribute__] = ACTIONS(3068),
    [anon_sym___attribute] = ACTIONS(3068),
    [anon_sym_COLON_COLON] = ACTIONS(3070),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3070),
    [anon_sym___declspec] = ACTIONS(3068),
    [anon_sym___based] = ACTIONS(3068),
    [anon_sym___cdecl] = ACTIONS(3068),
    [anon_sym___clrcall] = ACTIONS(3068),
    [anon_sym___stdcall] = ACTIONS(3068),
    [anon_sym___fastcall] = ACTIONS(3068),
    [anon_sym___thiscall] = ACTIONS(3068),
    [anon_sym___vectorcall] = ACTIONS(3068),
    [anon_sym_LBRACE] = ACTIONS(3070),
    [anon_sym_RBRACE] = ACTIONS(3070),
    [anon_sym_signed] = ACTIONS(3068),
    [anon_sym_unsigned] = ACTIONS(3068),
    [anon_sym_long] = ACTIONS(3068),
    [anon_sym_short] = ACTIONS(3068),
    [anon_sym_LBRACK] = ACTIONS(3068),
    [anon_sym_static] = ACTIONS(3068),
    [anon_sym_register] = ACTIONS(3068),
    [anon_sym_inline] = ACTIONS(3068),
    [anon_sym___inline] = ACTIONS(3068),
    [anon_sym___inline__] = ACTIONS(3068),
    [anon_sym___forceinline] = ACTIONS(3068),
    [anon_sym_thread_local] = ACTIONS(3068),
    [anon_sym___thread] = ACTIONS(3068),
    [anon_sym_const] = ACTIONS(3068),
    [anon_sym_constexpr] = ACTIONS(3068),
    [anon_sym_volatile] = ACTIONS(3068),
    [anon_sym_restrict] = ACTIONS(3068),
    [anon_sym___restrict__] = ACTIONS(3068),
    [anon_sym__Atomic] = ACTIONS(3068),
    [anon_sym__Noreturn] = ACTIONS(3068),
    [anon_sym_noreturn] = ACTIONS(3068),
    [anon_sym__Nonnull] = ACTIONS(3068),
    [anon_sym_mutable] = ACTIONS(3068),
    [anon_sym_constinit] = ACTIONS(3068),
    [anon_sym_consteval] = ACTIONS(3068),
    [anon_sym_alignas] = ACTIONS(3068),
    [anon_sym__Alignas] = ACTIONS(3068),
    [sym_primitive_type] = ACTIONS(3068),
    [anon_sym_enum] = ACTIONS(3068),
    [anon_sym_class] = ACTIONS(3068),
    [anon_sym_struct] = ACTIONS(3068),
    [anon_sym_union] = ACTIONS(3068),
    [anon_sym_if] = ACTIONS(3068),
    [anon_sym_switch] = ACTIONS(3068),
    [anon_sym_case] = ACTIONS(3068),
    [anon_sym_default] = ACTIONS(3068),
    [anon_sym_while] = ACTIONS(3068),
    [anon_sym_do] = ACTIONS(3068),
    [anon_sym_for] = ACTIONS(3068),
    [anon_sym_return] = ACTIONS(3068),
    [anon_sym_break] = ACTIONS(3068),
    [anon_sym_continue] = ACTIONS(3068),
    [anon_sym_goto] = ACTIONS(3068),
    [anon_sym___try] = ACTIONS(3068),
    [anon_sym___leave] = ACTIONS(3068),
    [anon_sym_not] = ACTIONS(3068),
    [anon_sym_compl] = ACTIONS(3068),
    [anon_sym_DASH_DASH] = ACTIONS(3070),
    [anon_sym_PLUS_PLUS] = ACTIONS(3070),
    [anon_sym_sizeof] = ACTIONS(3068),
    [anon_sym___alignof__] = ACTIONS(3068),
    [anon_sym___alignof] = ACTIONS(3068),
    [anon_sym__alignof] = ACTIONS(3068),
    [anon_sym_alignof] = ACTIONS(3068),
    [anon_sym__Alignof] = ACTIONS(3068),
    [anon_sym_offsetof] = ACTIONS(3068),
    [anon_sym__Generic] = ACTIONS(3068),
    [anon_sym_asm] = ACTIONS(3068),
    [anon_sym___asm__] = ACTIONS(3068),
    [anon_sym___asm] = ACTIONS(3068),
    [sym_number_literal] = ACTIONS(3070),
    [anon_sym_L_SQUOTE] = ACTIONS(3070),
    [anon_sym_u_SQUOTE] = ACTIONS(3070),
    [anon_sym_U_SQUOTE] = ACTIONS(3070),
    [anon_sym_u8_SQUOTE] = ACTIONS(3070),
    [anon_sym_SQUOTE] = ACTIONS(3070),
    [anon_sym_L_DQUOTE] = ACTIONS(3070),
    [anon_sym_u_DQUOTE] = ACTIONS(3070),
    [anon_sym_U_DQUOTE] = ACTIONS(3070),
    [anon_sym_u8_DQUOTE] = ACTIONS(3070),
    [anon_sym_DQUOTE] = ACTIONS(3070),
    [sym_true] = ACTIONS(3068),
    [sym_false] = ACTIONS(3068),
    [anon_sym_NULL] = ACTIONS(3068),
    [anon_sym_nullptr] = ACTIONS(3068),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3068),
    [anon_sym_decltype] = ACTIONS(3068),
    [anon_sym_explicit] = ACTIONS(3068),
    [anon_sym_typename] = ACTIONS(3068),
    [anon_sym_template] = ACTIONS(3068),
    [anon_sym_operator] = ACTIONS(3068),
    [anon_sym_try] = ACTIONS(3068),
    [anon_sym_delete] = ACTIONS(3068),
    [anon_sym_throw] = ACTIONS(3068),
    [anon_sym_namespace] = ACTIONS(3068),
    [anon_sym_using] = ACTIONS(3068),
    [anon_sym_static_assert] = ACTIONS(3068),
    [anon_sym_concept] = ACTIONS(3068),
    [anon_sym_co_return] = ACTIONS(3068),
    [anon_sym_co_yield] = ACTIONS(3068),
    [anon_sym_R_DQUOTE] = ACTIONS(3070),
    [anon_sym_LR_DQUOTE] = ACTIONS(3070),
    [anon_sym_uR_DQUOTE] = ACTIONS(3070),
    [anon_sym_UR_DQUOTE] = ACTIONS(3070),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3070),
    [anon_sym_co_await] = ACTIONS(3068),
    [anon_sym_new] = ACTIONS(3068),
    [anon_sym_requires] = ACTIONS(3068),
    [sym_this] = ACTIONS(3068),
  },
  [620] = {
    [sym_identifier] = ACTIONS(3013),
    [aux_sym_preproc_include_token1] = ACTIONS(3013),
    [aux_sym_preproc_def_token1] = ACTIONS(3013),
    [aux_sym_preproc_if_token1] = ACTIONS(3013),
    [aux_sym_preproc_if_token2] = ACTIONS(3013),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3013),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3013),
    [sym_preproc_directive] = ACTIONS(3013),
    [anon_sym_LPAREN2] = ACTIONS(3015),
    [anon_sym_BANG] = ACTIONS(3015),
    [anon_sym_TILDE] = ACTIONS(3015),
    [anon_sym_DASH] = ACTIONS(3013),
    [anon_sym_PLUS] = ACTIONS(3013),
    [anon_sym_STAR] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3015),
    [anon_sym_AMP] = ACTIONS(3013),
    [anon_sym_SEMI] = ACTIONS(3015),
    [anon_sym___extension__] = ACTIONS(3013),
    [anon_sym_typedef] = ACTIONS(3013),
    [anon_sym_virtual] = ACTIONS(3013),
    [anon_sym_extern] = ACTIONS(3013),
    [anon_sym___attribute__] = ACTIONS(3013),
    [anon_sym___attribute] = ACTIONS(3013),
    [anon_sym_COLON_COLON] = ACTIONS(3015),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3015),
    [anon_sym___declspec] = ACTIONS(3013),
    [anon_sym___based] = ACTIONS(3013),
    [anon_sym___cdecl] = ACTIONS(3013),
    [anon_sym___clrcall] = ACTIONS(3013),
    [anon_sym___stdcall] = ACTIONS(3013),
    [anon_sym___fastcall] = ACTIONS(3013),
    [anon_sym___thiscall] = ACTIONS(3013),
    [anon_sym___vectorcall] = ACTIONS(3013),
    [anon_sym_LBRACE] = ACTIONS(3015),
    [anon_sym_signed] = ACTIONS(3013),
    [anon_sym_unsigned] = ACTIONS(3013),
    [anon_sym_long] = ACTIONS(3013),
    [anon_sym_short] = ACTIONS(3013),
    [anon_sym_LBRACK] = ACTIONS(3013),
    [anon_sym_static] = ACTIONS(3013),
    [anon_sym_register] = ACTIONS(3013),
    [anon_sym_inline] = ACTIONS(3013),
    [anon_sym___inline] = ACTIONS(3013),
    [anon_sym___inline__] = ACTIONS(3013),
    [anon_sym___forceinline] = ACTIONS(3013),
    [anon_sym_thread_local] = ACTIONS(3013),
    [anon_sym___thread] = ACTIONS(3013),
    [anon_sym_const] = ACTIONS(3013),
    [anon_sym_constexpr] = ACTIONS(3013),
    [anon_sym_volatile] = ACTIONS(3013),
    [anon_sym_restrict] = ACTIONS(3013),
    [anon_sym___restrict__] = ACTIONS(3013),
    [anon_sym__Atomic] = ACTIONS(3013),
    [anon_sym__Noreturn] = ACTIONS(3013),
    [anon_sym_noreturn] = ACTIONS(3013),
    [anon_sym__Nonnull] = ACTIONS(3013),
    [anon_sym_mutable] = ACTIONS(3013),
    [anon_sym_constinit] = ACTIONS(3013),
    [anon_sym_consteval] = ACTIONS(3013),
    [anon_sym_alignas] = ACTIONS(3013),
    [anon_sym__Alignas] = ACTIONS(3013),
    [sym_primitive_type] = ACTIONS(3013),
    [anon_sym_enum] = ACTIONS(3013),
    [anon_sym_class] = ACTIONS(3013),
    [anon_sym_struct] = ACTIONS(3013),
    [anon_sym_union] = ACTIONS(3013),
    [anon_sym_if] = ACTIONS(3013),
    [anon_sym_switch] = ACTIONS(3013),
    [anon_sym_case] = ACTIONS(3013),
    [anon_sym_default] = ACTIONS(3013),
    [anon_sym_while] = ACTIONS(3013),
    [anon_sym_do] = ACTIONS(3013),
    [anon_sym_for] = ACTIONS(3013),
    [anon_sym_return] = ACTIONS(3013),
    [anon_sym_break] = ACTIONS(3013),
    [anon_sym_continue] = ACTIONS(3013),
    [anon_sym_goto] = ACTIONS(3013),
    [anon_sym___try] = ACTIONS(3013),
    [anon_sym___leave] = ACTIONS(3013),
    [anon_sym_not] = ACTIONS(3013),
    [anon_sym_compl] = ACTIONS(3013),
    [anon_sym_DASH_DASH] = ACTIONS(3015),
    [anon_sym_PLUS_PLUS] = ACTIONS(3015),
    [anon_sym_sizeof] = ACTIONS(3013),
    [anon_sym___alignof__] = ACTIONS(3013),
    [anon_sym___alignof] = ACTIONS(3013),
    [anon_sym__alignof] = ACTIONS(3013),
    [anon_sym_alignof] = ACTIONS(3013),
    [anon_sym__Alignof] = ACTIONS(3013),
    [anon_sym_offsetof] = ACTIONS(3013),
    [anon_sym__Generic] = ACTIONS(3013),
    [anon_sym_asm] = ACTIONS(3013),
    [anon_sym___asm__] = ACTIONS(3013),
    [anon_sym___asm] = ACTIONS(3013),
    [sym_number_literal] = ACTIONS(3015),
    [anon_sym_L_SQUOTE] = ACTIONS(3015),
    [anon_sym_u_SQUOTE] = ACTIONS(3015),
    [anon_sym_U_SQUOTE] = ACTIONS(3015),
    [anon_sym_u8_SQUOTE] = ACTIONS(3015),
    [anon_sym_SQUOTE] = ACTIONS(3015),
    [anon_sym_L_DQUOTE] = ACTIONS(3015),
    [anon_sym_u_DQUOTE] = ACTIONS(3015),
    [anon_sym_U_DQUOTE] = ACTIONS(3015),
    [anon_sym_u8_DQUOTE] = ACTIONS(3015),
    [anon_sym_DQUOTE] = ACTIONS(3015),
    [sym_true] = ACTIONS(3013),
    [sym_false] = ACTIONS(3013),
    [anon_sym_NULL] = ACTIONS(3013),
    [anon_sym_nullptr] = ACTIONS(3013),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3013),
    [anon_sym_decltype] = ACTIONS(3013),
    [anon_sym_explicit] = ACTIONS(3013),
    [anon_sym_typename] = ACTIONS(3013),
    [anon_sym_template] = ACTIONS(3013),
    [anon_sym_operator] = ACTIONS(3013),
    [anon_sym_try] = ACTIONS(3013),
    [anon_sym_delete] = ACTIONS(3013),
    [anon_sym_throw] = ACTIONS(3013),
    [anon_sym_namespace] = ACTIONS(3013),
    [anon_sym_using] = ACTIONS(3013),
    [anon_sym_static_assert] = ACTIONS(3013),
    [anon_sym_concept] = ACTIONS(3013),
    [anon_sym_co_return] = ACTIONS(3013),
    [anon_sym_co_yield] = ACTIONS(3013),
    [anon_sym_R_DQUOTE] = ACTIONS(3015),
    [anon_sym_LR_DQUOTE] = ACTIONS(3015),
    [anon_sym_uR_DQUOTE] = ACTIONS(3015),
    [anon_sym_UR_DQUOTE] = ACTIONS(3015),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3015),
    [anon_sym_co_await] = ACTIONS(3013),
    [anon_sym_new] = ACTIONS(3013),
    [anon_sym_requires] = ACTIONS(3013),
    [sym_this] = ACTIONS(3013),
  },
  [621] = {
    [sym_identifier] = ACTIONS(2850),
    [aux_sym_preproc_include_token1] = ACTIONS(2850),
    [aux_sym_preproc_def_token1] = ACTIONS(2850),
    [aux_sym_preproc_if_token1] = ACTIONS(2850),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2850),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2850),
    [sym_preproc_directive] = ACTIONS(2850),
    [anon_sym_LPAREN2] = ACTIONS(2852),
    [anon_sym_BANG] = ACTIONS(2852),
    [anon_sym_TILDE] = ACTIONS(2852),
    [anon_sym_DASH] = ACTIONS(2850),
    [anon_sym_PLUS] = ACTIONS(2850),
    [anon_sym_STAR] = ACTIONS(2852),
    [anon_sym_AMP_AMP] = ACTIONS(2852),
    [anon_sym_AMP] = ACTIONS(2850),
    [anon_sym_SEMI] = ACTIONS(2852),
    [anon_sym___extension__] = ACTIONS(2850),
    [anon_sym_typedef] = ACTIONS(2850),
    [anon_sym_virtual] = ACTIONS(2850),
    [anon_sym_extern] = ACTIONS(2850),
    [anon_sym___attribute__] = ACTIONS(2850),
    [anon_sym___attribute] = ACTIONS(2850),
    [anon_sym_COLON_COLON] = ACTIONS(2852),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2852),
    [anon_sym___declspec] = ACTIONS(2850),
    [anon_sym___based] = ACTIONS(2850),
    [anon_sym___cdecl] = ACTIONS(2850),
    [anon_sym___clrcall] = ACTIONS(2850),
    [anon_sym___stdcall] = ACTIONS(2850),
    [anon_sym___fastcall] = ACTIONS(2850),
    [anon_sym___thiscall] = ACTIONS(2850),
    [anon_sym___vectorcall] = ACTIONS(2850),
    [anon_sym_LBRACE] = ACTIONS(2852),
    [anon_sym_RBRACE] = ACTIONS(2852),
    [anon_sym_signed] = ACTIONS(2850),
    [anon_sym_unsigned] = ACTIONS(2850),
    [anon_sym_long] = ACTIONS(2850),
    [anon_sym_short] = ACTIONS(2850),
    [anon_sym_LBRACK] = ACTIONS(2850),
    [anon_sym_static] = ACTIONS(2850),
    [anon_sym_register] = ACTIONS(2850),
    [anon_sym_inline] = ACTIONS(2850),
    [anon_sym___inline] = ACTIONS(2850),
    [anon_sym___inline__] = ACTIONS(2850),
    [anon_sym___forceinline] = ACTIONS(2850),
    [anon_sym_thread_local] = ACTIONS(2850),
    [anon_sym___thread] = ACTIONS(2850),
    [anon_sym_const] = ACTIONS(2850),
    [anon_sym_constexpr] = ACTIONS(2850),
    [anon_sym_volatile] = ACTIONS(2850),
    [anon_sym_restrict] = ACTIONS(2850),
    [anon_sym___restrict__] = ACTIONS(2850),
    [anon_sym__Atomic] = ACTIONS(2850),
    [anon_sym__Noreturn] = ACTIONS(2850),
    [anon_sym_noreturn] = ACTIONS(2850),
    [anon_sym__Nonnull] = ACTIONS(2850),
    [anon_sym_mutable] = ACTIONS(2850),
    [anon_sym_constinit] = ACTIONS(2850),
    [anon_sym_consteval] = ACTIONS(2850),
    [anon_sym_alignas] = ACTIONS(2850),
    [anon_sym__Alignas] = ACTIONS(2850),
    [sym_primitive_type] = ACTIONS(2850),
    [anon_sym_enum] = ACTIONS(2850),
    [anon_sym_class] = ACTIONS(2850),
    [anon_sym_struct] = ACTIONS(2850),
    [anon_sym_union] = ACTIONS(2850),
    [anon_sym_if] = ACTIONS(2850),
    [anon_sym_switch] = ACTIONS(2850),
    [anon_sym_case] = ACTIONS(2850),
    [anon_sym_default] = ACTIONS(2850),
    [anon_sym_while] = ACTIONS(2850),
    [anon_sym_do] = ACTIONS(2850),
    [anon_sym_for] = ACTIONS(2850),
    [anon_sym_return] = ACTIONS(2850),
    [anon_sym_break] = ACTIONS(2850),
    [anon_sym_continue] = ACTIONS(2850),
    [anon_sym_goto] = ACTIONS(2850),
    [anon_sym___try] = ACTIONS(2850),
    [anon_sym___leave] = ACTIONS(2850),
    [anon_sym_not] = ACTIONS(2850),
    [anon_sym_compl] = ACTIONS(2850),
    [anon_sym_DASH_DASH] = ACTIONS(2852),
    [anon_sym_PLUS_PLUS] = ACTIONS(2852),
    [anon_sym_sizeof] = ACTIONS(2850),
    [anon_sym___alignof__] = ACTIONS(2850),
    [anon_sym___alignof] = ACTIONS(2850),
    [anon_sym__alignof] = ACTIONS(2850),
    [anon_sym_alignof] = ACTIONS(2850),
    [anon_sym__Alignof] = ACTIONS(2850),
    [anon_sym_offsetof] = ACTIONS(2850),
    [anon_sym__Generic] = ACTIONS(2850),
    [anon_sym_asm] = ACTIONS(2850),
    [anon_sym___asm__] = ACTIONS(2850),
    [anon_sym___asm] = ACTIONS(2850),
    [sym_number_literal] = ACTIONS(2852),
    [anon_sym_L_SQUOTE] = ACTIONS(2852),
    [anon_sym_u_SQUOTE] = ACTIONS(2852),
    [anon_sym_U_SQUOTE] = ACTIONS(2852),
    [anon_sym_u8_SQUOTE] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2852),
    [anon_sym_L_DQUOTE] = ACTIONS(2852),
    [anon_sym_u_DQUOTE] = ACTIONS(2852),
    [anon_sym_U_DQUOTE] = ACTIONS(2852),
    [anon_sym_u8_DQUOTE] = ACTIONS(2852),
    [anon_sym_DQUOTE] = ACTIONS(2852),
    [sym_true] = ACTIONS(2850),
    [sym_false] = ACTIONS(2850),
    [anon_sym_NULL] = ACTIONS(2850),
    [anon_sym_nullptr] = ACTIONS(2850),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2850),
    [anon_sym_decltype] = ACTIONS(2850),
    [anon_sym_explicit] = ACTIONS(2850),
    [anon_sym_typename] = ACTIONS(2850),
    [anon_sym_template] = ACTIONS(2850),
    [anon_sym_operator] = ACTIONS(2850),
    [anon_sym_try] = ACTIONS(2850),
    [anon_sym_delete] = ACTIONS(2850),
    [anon_sym_throw] = ACTIONS(2850),
    [anon_sym_namespace] = ACTIONS(2850),
    [anon_sym_using] = ACTIONS(2850),
    [anon_sym_static_assert] = ACTIONS(2850),
    [anon_sym_concept] = ACTIONS(2850),
    [anon_sym_co_return] = ACTIONS(2850),
    [anon_sym_co_yield] = ACTIONS(2850),
    [anon_sym_R_DQUOTE] = ACTIONS(2852),
    [anon_sym_LR_DQUOTE] = ACTIONS(2852),
    [anon_sym_uR_DQUOTE] = ACTIONS(2852),
    [anon_sym_UR_DQUOTE] = ACTIONS(2852),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2852),
    [anon_sym_co_await] = ACTIONS(2850),
    [anon_sym_new] = ACTIONS(2850),
    [anon_sym_requires] = ACTIONS(2850),
    [sym_this] = ACTIONS(2850),
  },
  [622] = {
    [sym_identifier] = ACTIONS(2771),
    [aux_sym_preproc_include_token1] = ACTIONS(2771),
    [aux_sym_preproc_def_token1] = ACTIONS(2771),
    [aux_sym_preproc_if_token1] = ACTIONS(2771),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2771),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2771),
    [sym_preproc_directive] = ACTIONS(2771),
    [anon_sym_LPAREN2] = ACTIONS(2773),
    [anon_sym_BANG] = ACTIONS(2773),
    [anon_sym_TILDE] = ACTIONS(2773),
    [anon_sym_DASH] = ACTIONS(2771),
    [anon_sym_PLUS] = ACTIONS(2771),
    [anon_sym_STAR] = ACTIONS(2773),
    [anon_sym_AMP_AMP] = ACTIONS(2773),
    [anon_sym_AMP] = ACTIONS(2771),
    [anon_sym_SEMI] = ACTIONS(2773),
    [anon_sym___extension__] = ACTIONS(2771),
    [anon_sym_typedef] = ACTIONS(2771),
    [anon_sym_virtual] = ACTIONS(2771),
    [anon_sym_extern] = ACTIONS(2771),
    [anon_sym___attribute__] = ACTIONS(2771),
    [anon_sym___attribute] = ACTIONS(2771),
    [anon_sym_COLON_COLON] = ACTIONS(2773),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2773),
    [anon_sym___declspec] = ACTIONS(2771),
    [anon_sym___based] = ACTIONS(2771),
    [anon_sym___cdecl] = ACTIONS(2771),
    [anon_sym___clrcall] = ACTIONS(2771),
    [anon_sym___stdcall] = ACTIONS(2771),
    [anon_sym___fastcall] = ACTIONS(2771),
    [anon_sym___thiscall] = ACTIONS(2771),
    [anon_sym___vectorcall] = ACTIONS(2771),
    [anon_sym_LBRACE] = ACTIONS(2773),
    [anon_sym_RBRACE] = ACTIONS(2773),
    [anon_sym_signed] = ACTIONS(2771),
    [anon_sym_unsigned] = ACTIONS(2771),
    [anon_sym_long] = ACTIONS(2771),
    [anon_sym_short] = ACTIONS(2771),
    [anon_sym_LBRACK] = ACTIONS(2771),
    [anon_sym_static] = ACTIONS(2771),
    [anon_sym_register] = ACTIONS(2771),
    [anon_sym_inline] = ACTIONS(2771),
    [anon_sym___inline] = ACTIONS(2771),
    [anon_sym___inline__] = ACTIONS(2771),
    [anon_sym___forceinline] = ACTIONS(2771),
    [anon_sym_thread_local] = ACTIONS(2771),
    [anon_sym___thread] = ACTIONS(2771),
    [anon_sym_const] = ACTIONS(2771),
    [anon_sym_constexpr] = ACTIONS(2771),
    [anon_sym_volatile] = ACTIONS(2771),
    [anon_sym_restrict] = ACTIONS(2771),
    [anon_sym___restrict__] = ACTIONS(2771),
    [anon_sym__Atomic] = ACTIONS(2771),
    [anon_sym__Noreturn] = ACTIONS(2771),
    [anon_sym_noreturn] = ACTIONS(2771),
    [anon_sym__Nonnull] = ACTIONS(2771),
    [anon_sym_mutable] = ACTIONS(2771),
    [anon_sym_constinit] = ACTIONS(2771),
    [anon_sym_consteval] = ACTIONS(2771),
    [anon_sym_alignas] = ACTIONS(2771),
    [anon_sym__Alignas] = ACTIONS(2771),
    [sym_primitive_type] = ACTIONS(2771),
    [anon_sym_enum] = ACTIONS(2771),
    [anon_sym_class] = ACTIONS(2771),
    [anon_sym_struct] = ACTIONS(2771),
    [anon_sym_union] = ACTIONS(2771),
    [anon_sym_if] = ACTIONS(2771),
    [anon_sym_switch] = ACTIONS(2771),
    [anon_sym_case] = ACTIONS(2771),
    [anon_sym_default] = ACTIONS(2771),
    [anon_sym_while] = ACTIONS(2771),
    [anon_sym_do] = ACTIONS(2771),
    [anon_sym_for] = ACTIONS(2771),
    [anon_sym_return] = ACTIONS(2771),
    [anon_sym_break] = ACTIONS(2771),
    [anon_sym_continue] = ACTIONS(2771),
    [anon_sym_goto] = ACTIONS(2771),
    [anon_sym___try] = ACTIONS(2771),
    [anon_sym___leave] = ACTIONS(2771),
    [anon_sym_not] = ACTIONS(2771),
    [anon_sym_compl] = ACTIONS(2771),
    [anon_sym_DASH_DASH] = ACTIONS(2773),
    [anon_sym_PLUS_PLUS] = ACTIONS(2773),
    [anon_sym_sizeof] = ACTIONS(2771),
    [anon_sym___alignof__] = ACTIONS(2771),
    [anon_sym___alignof] = ACTIONS(2771),
    [anon_sym__alignof] = ACTIONS(2771),
    [anon_sym_alignof] = ACTIONS(2771),
    [anon_sym__Alignof] = ACTIONS(2771),
    [anon_sym_offsetof] = ACTIONS(2771),
    [anon_sym__Generic] = ACTIONS(2771),
    [anon_sym_asm] = ACTIONS(2771),
    [anon_sym___asm__] = ACTIONS(2771),
    [anon_sym___asm] = ACTIONS(2771),
    [sym_number_literal] = ACTIONS(2773),
    [anon_sym_L_SQUOTE] = ACTIONS(2773),
    [anon_sym_u_SQUOTE] = ACTIONS(2773),
    [anon_sym_U_SQUOTE] = ACTIONS(2773),
    [anon_sym_u8_SQUOTE] = ACTIONS(2773),
    [anon_sym_SQUOTE] = ACTIONS(2773),
    [anon_sym_L_DQUOTE] = ACTIONS(2773),
    [anon_sym_u_DQUOTE] = ACTIONS(2773),
    [anon_sym_U_DQUOTE] = ACTIONS(2773),
    [anon_sym_u8_DQUOTE] = ACTIONS(2773),
    [anon_sym_DQUOTE] = ACTIONS(2773),
    [sym_true] = ACTIONS(2771),
    [sym_false] = ACTIONS(2771),
    [anon_sym_NULL] = ACTIONS(2771),
    [anon_sym_nullptr] = ACTIONS(2771),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2771),
    [anon_sym_decltype] = ACTIONS(2771),
    [anon_sym_explicit] = ACTIONS(2771),
    [anon_sym_typename] = ACTIONS(2771),
    [anon_sym_template] = ACTIONS(2771),
    [anon_sym_operator] = ACTIONS(2771),
    [anon_sym_try] = ACTIONS(2771),
    [anon_sym_delete] = ACTIONS(2771),
    [anon_sym_throw] = ACTIONS(2771),
    [anon_sym_namespace] = ACTIONS(2771),
    [anon_sym_using] = ACTIONS(2771),
    [anon_sym_static_assert] = ACTIONS(2771),
    [anon_sym_concept] = ACTIONS(2771),
    [anon_sym_co_return] = ACTIONS(2771),
    [anon_sym_co_yield] = ACTIONS(2771),
    [anon_sym_R_DQUOTE] = ACTIONS(2773),
    [anon_sym_LR_DQUOTE] = ACTIONS(2773),
    [anon_sym_uR_DQUOTE] = ACTIONS(2773),
    [anon_sym_UR_DQUOTE] = ACTIONS(2773),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2773),
    [anon_sym_co_await] = ACTIONS(2771),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2771),
    [sym_this] = ACTIONS(2771),
  },
  [623] = {
    [sym_identifier] = ACTIONS(2727),
    [aux_sym_preproc_include_token1] = ACTIONS(2727),
    [aux_sym_preproc_def_token1] = ACTIONS(2727),
    [aux_sym_preproc_if_token1] = ACTIONS(2727),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2727),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2727),
    [sym_preproc_directive] = ACTIONS(2727),
    [anon_sym_LPAREN2] = ACTIONS(2729),
    [anon_sym_BANG] = ACTIONS(2729),
    [anon_sym_TILDE] = ACTIONS(2729),
    [anon_sym_DASH] = ACTIONS(2727),
    [anon_sym_PLUS] = ACTIONS(2727),
    [anon_sym_STAR] = ACTIONS(2729),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_AMP] = ACTIONS(2727),
    [anon_sym_SEMI] = ACTIONS(2729),
    [anon_sym___extension__] = ACTIONS(2727),
    [anon_sym_typedef] = ACTIONS(2727),
    [anon_sym_virtual] = ACTIONS(2727),
    [anon_sym_extern] = ACTIONS(2727),
    [anon_sym___attribute__] = ACTIONS(2727),
    [anon_sym___attribute] = ACTIONS(2727),
    [anon_sym_COLON_COLON] = ACTIONS(2729),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2729),
    [anon_sym___declspec] = ACTIONS(2727),
    [anon_sym___based] = ACTIONS(2727),
    [anon_sym___cdecl] = ACTIONS(2727),
    [anon_sym___clrcall] = ACTIONS(2727),
    [anon_sym___stdcall] = ACTIONS(2727),
    [anon_sym___fastcall] = ACTIONS(2727),
    [anon_sym___thiscall] = ACTIONS(2727),
    [anon_sym___vectorcall] = ACTIONS(2727),
    [anon_sym_LBRACE] = ACTIONS(2729),
    [anon_sym_RBRACE] = ACTIONS(2729),
    [anon_sym_signed] = ACTIONS(2727),
    [anon_sym_unsigned] = ACTIONS(2727),
    [anon_sym_long] = ACTIONS(2727),
    [anon_sym_short] = ACTIONS(2727),
    [anon_sym_LBRACK] = ACTIONS(2727),
    [anon_sym_static] = ACTIONS(2727),
    [anon_sym_register] = ACTIONS(2727),
    [anon_sym_inline] = ACTIONS(2727),
    [anon_sym___inline] = ACTIONS(2727),
    [anon_sym___inline__] = ACTIONS(2727),
    [anon_sym___forceinline] = ACTIONS(2727),
    [anon_sym_thread_local] = ACTIONS(2727),
    [anon_sym___thread] = ACTIONS(2727),
    [anon_sym_const] = ACTIONS(2727),
    [anon_sym_constexpr] = ACTIONS(2727),
    [anon_sym_volatile] = ACTIONS(2727),
    [anon_sym_restrict] = ACTIONS(2727),
    [anon_sym___restrict__] = ACTIONS(2727),
    [anon_sym__Atomic] = ACTIONS(2727),
    [anon_sym__Noreturn] = ACTIONS(2727),
    [anon_sym_noreturn] = ACTIONS(2727),
    [anon_sym__Nonnull] = ACTIONS(2727),
    [anon_sym_mutable] = ACTIONS(2727),
    [anon_sym_constinit] = ACTIONS(2727),
    [anon_sym_consteval] = ACTIONS(2727),
    [anon_sym_alignas] = ACTIONS(2727),
    [anon_sym__Alignas] = ACTIONS(2727),
    [sym_primitive_type] = ACTIONS(2727),
    [anon_sym_enum] = ACTIONS(2727),
    [anon_sym_class] = ACTIONS(2727),
    [anon_sym_struct] = ACTIONS(2727),
    [anon_sym_union] = ACTIONS(2727),
    [anon_sym_if] = ACTIONS(2727),
    [anon_sym_switch] = ACTIONS(2727),
    [anon_sym_case] = ACTIONS(2727),
    [anon_sym_default] = ACTIONS(2727),
    [anon_sym_while] = ACTIONS(2727),
    [anon_sym_do] = ACTIONS(2727),
    [anon_sym_for] = ACTIONS(2727),
    [anon_sym_return] = ACTIONS(2727),
    [anon_sym_break] = ACTIONS(2727),
    [anon_sym_continue] = ACTIONS(2727),
    [anon_sym_goto] = ACTIONS(2727),
    [anon_sym___try] = ACTIONS(2727),
    [anon_sym___leave] = ACTIONS(2727),
    [anon_sym_not] = ACTIONS(2727),
    [anon_sym_compl] = ACTIONS(2727),
    [anon_sym_DASH_DASH] = ACTIONS(2729),
    [anon_sym_PLUS_PLUS] = ACTIONS(2729),
    [anon_sym_sizeof] = ACTIONS(2727),
    [anon_sym___alignof__] = ACTIONS(2727),
    [anon_sym___alignof] = ACTIONS(2727),
    [anon_sym__alignof] = ACTIONS(2727),
    [anon_sym_alignof] = ACTIONS(2727),
    [anon_sym__Alignof] = ACTIONS(2727),
    [anon_sym_offsetof] = ACTIONS(2727),
    [anon_sym__Generic] = ACTIONS(2727),
    [anon_sym_asm] = ACTIONS(2727),
    [anon_sym___asm__] = ACTIONS(2727),
    [anon_sym___asm] = ACTIONS(2727),
    [sym_number_literal] = ACTIONS(2729),
    [anon_sym_L_SQUOTE] = ACTIONS(2729),
    [anon_sym_u_SQUOTE] = ACTIONS(2729),
    [anon_sym_U_SQUOTE] = ACTIONS(2729),
    [anon_sym_u8_SQUOTE] = ACTIONS(2729),
    [anon_sym_SQUOTE] = ACTIONS(2729),
    [anon_sym_L_DQUOTE] = ACTIONS(2729),
    [anon_sym_u_DQUOTE] = ACTIONS(2729),
    [anon_sym_U_DQUOTE] = ACTIONS(2729),
    [anon_sym_u8_DQUOTE] = ACTIONS(2729),
    [anon_sym_DQUOTE] = ACTIONS(2729),
    [sym_true] = ACTIONS(2727),
    [sym_false] = ACTIONS(2727),
    [anon_sym_NULL] = ACTIONS(2727),
    [anon_sym_nullptr] = ACTIONS(2727),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2727),
    [anon_sym_decltype] = ACTIONS(2727),
    [anon_sym_explicit] = ACTIONS(2727),
    [anon_sym_typename] = ACTIONS(2727),
    [anon_sym_template] = ACTIONS(2727),
    [anon_sym_operator] = ACTIONS(2727),
    [anon_sym_try] = ACTIONS(2727),
    [anon_sym_delete] = ACTIONS(2727),
    [anon_sym_throw] = ACTIONS(2727),
    [anon_sym_namespace] = ACTIONS(2727),
    [anon_sym_using] = ACTIONS(2727),
    [anon_sym_static_assert] = ACTIONS(2727),
    [anon_sym_concept] = ACTIONS(2727),
    [anon_sym_co_return] = ACTIONS(2727),
    [anon_sym_co_yield] = ACTIONS(2727),
    [anon_sym_R_DQUOTE] = ACTIONS(2729),
    [anon_sym_LR_DQUOTE] = ACTIONS(2729),
    [anon_sym_uR_DQUOTE] = ACTIONS(2729),
    [anon_sym_UR_DQUOTE] = ACTIONS(2729),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2729),
    [anon_sym_co_await] = ACTIONS(2727),
    [anon_sym_new] = ACTIONS(2727),
    [anon_sym_requires] = ACTIONS(2727),
    [sym_this] = ACTIONS(2727),
  },
  [624] = {
    [sym_identifier] = ACTIONS(2960),
    [aux_sym_preproc_include_token1] = ACTIONS(2960),
    [aux_sym_preproc_def_token1] = ACTIONS(2960),
    [aux_sym_preproc_if_token1] = ACTIONS(2960),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2960),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2960),
    [sym_preproc_directive] = ACTIONS(2960),
    [anon_sym_LPAREN2] = ACTIONS(2962),
    [anon_sym_BANG] = ACTIONS(2962),
    [anon_sym_TILDE] = ACTIONS(2962),
    [anon_sym_DASH] = ACTIONS(2960),
    [anon_sym_PLUS] = ACTIONS(2960),
    [anon_sym_STAR] = ACTIONS(2962),
    [anon_sym_AMP_AMP] = ACTIONS(2962),
    [anon_sym_AMP] = ACTIONS(2960),
    [anon_sym_SEMI] = ACTIONS(2962),
    [anon_sym___extension__] = ACTIONS(2960),
    [anon_sym_typedef] = ACTIONS(2960),
    [anon_sym_virtual] = ACTIONS(2960),
    [anon_sym_extern] = ACTIONS(2960),
    [anon_sym___attribute__] = ACTIONS(2960),
    [anon_sym___attribute] = ACTIONS(2960),
    [anon_sym_COLON_COLON] = ACTIONS(2962),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2962),
    [anon_sym___declspec] = ACTIONS(2960),
    [anon_sym___based] = ACTIONS(2960),
    [anon_sym___cdecl] = ACTIONS(2960),
    [anon_sym___clrcall] = ACTIONS(2960),
    [anon_sym___stdcall] = ACTIONS(2960),
    [anon_sym___fastcall] = ACTIONS(2960),
    [anon_sym___thiscall] = ACTIONS(2960),
    [anon_sym___vectorcall] = ACTIONS(2960),
    [anon_sym_LBRACE] = ACTIONS(2962),
    [anon_sym_RBRACE] = ACTIONS(2962),
    [anon_sym_signed] = ACTIONS(2960),
    [anon_sym_unsigned] = ACTIONS(2960),
    [anon_sym_long] = ACTIONS(2960),
    [anon_sym_short] = ACTIONS(2960),
    [anon_sym_LBRACK] = ACTIONS(2960),
    [anon_sym_static] = ACTIONS(2960),
    [anon_sym_register] = ACTIONS(2960),
    [anon_sym_inline] = ACTIONS(2960),
    [anon_sym___inline] = ACTIONS(2960),
    [anon_sym___inline__] = ACTIONS(2960),
    [anon_sym___forceinline] = ACTIONS(2960),
    [anon_sym_thread_local] = ACTIONS(2960),
    [anon_sym___thread] = ACTIONS(2960),
    [anon_sym_const] = ACTIONS(2960),
    [anon_sym_constexpr] = ACTIONS(2960),
    [anon_sym_volatile] = ACTIONS(2960),
    [anon_sym_restrict] = ACTIONS(2960),
    [anon_sym___restrict__] = ACTIONS(2960),
    [anon_sym__Atomic] = ACTIONS(2960),
    [anon_sym__Noreturn] = ACTIONS(2960),
    [anon_sym_noreturn] = ACTIONS(2960),
    [anon_sym__Nonnull] = ACTIONS(2960),
    [anon_sym_mutable] = ACTIONS(2960),
    [anon_sym_constinit] = ACTIONS(2960),
    [anon_sym_consteval] = ACTIONS(2960),
    [anon_sym_alignas] = ACTIONS(2960),
    [anon_sym__Alignas] = ACTIONS(2960),
    [sym_primitive_type] = ACTIONS(2960),
    [anon_sym_enum] = ACTIONS(2960),
    [anon_sym_class] = ACTIONS(2960),
    [anon_sym_struct] = ACTIONS(2960),
    [anon_sym_union] = ACTIONS(2960),
    [anon_sym_if] = ACTIONS(2960),
    [anon_sym_switch] = ACTIONS(2960),
    [anon_sym_case] = ACTIONS(2960),
    [anon_sym_default] = ACTIONS(2960),
    [anon_sym_while] = ACTIONS(2960),
    [anon_sym_do] = ACTIONS(2960),
    [anon_sym_for] = ACTIONS(2960),
    [anon_sym_return] = ACTIONS(2960),
    [anon_sym_break] = ACTIONS(2960),
    [anon_sym_continue] = ACTIONS(2960),
    [anon_sym_goto] = ACTIONS(2960),
    [anon_sym___try] = ACTIONS(2960),
    [anon_sym___leave] = ACTIONS(2960),
    [anon_sym_not] = ACTIONS(2960),
    [anon_sym_compl] = ACTIONS(2960),
    [anon_sym_DASH_DASH] = ACTIONS(2962),
    [anon_sym_PLUS_PLUS] = ACTIONS(2962),
    [anon_sym_sizeof] = ACTIONS(2960),
    [anon_sym___alignof__] = ACTIONS(2960),
    [anon_sym___alignof] = ACTIONS(2960),
    [anon_sym__alignof] = ACTIONS(2960),
    [anon_sym_alignof] = ACTIONS(2960),
    [anon_sym__Alignof] = ACTIONS(2960),
    [anon_sym_offsetof] = ACTIONS(2960),
    [anon_sym__Generic] = ACTIONS(2960),
    [anon_sym_asm] = ACTIONS(2960),
    [anon_sym___asm__] = ACTIONS(2960),
    [anon_sym___asm] = ACTIONS(2960),
    [sym_number_literal] = ACTIONS(2962),
    [anon_sym_L_SQUOTE] = ACTIONS(2962),
    [anon_sym_u_SQUOTE] = ACTIONS(2962),
    [anon_sym_U_SQUOTE] = ACTIONS(2962),
    [anon_sym_u8_SQUOTE] = ACTIONS(2962),
    [anon_sym_SQUOTE] = ACTIONS(2962),
    [anon_sym_L_DQUOTE] = ACTIONS(2962),
    [anon_sym_u_DQUOTE] = ACTIONS(2962),
    [anon_sym_U_DQUOTE] = ACTIONS(2962),
    [anon_sym_u8_DQUOTE] = ACTIONS(2962),
    [anon_sym_DQUOTE] = ACTIONS(2962),
    [sym_true] = ACTIONS(2960),
    [sym_false] = ACTIONS(2960),
    [anon_sym_NULL] = ACTIONS(2960),
    [anon_sym_nullptr] = ACTIONS(2960),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2960),
    [anon_sym_decltype] = ACTIONS(2960),
    [anon_sym_explicit] = ACTIONS(2960),
    [anon_sym_typename] = ACTIONS(2960),
    [anon_sym_template] = ACTIONS(2960),
    [anon_sym_operator] = ACTIONS(2960),
    [anon_sym_try] = ACTIONS(2960),
    [anon_sym_delete] = ACTIONS(2960),
    [anon_sym_throw] = ACTIONS(2960),
    [anon_sym_namespace] = ACTIONS(2960),
    [anon_sym_using] = ACTIONS(2960),
    [anon_sym_static_assert] = ACTIONS(2960),
    [anon_sym_concept] = ACTIONS(2960),
    [anon_sym_co_return] = ACTIONS(2960),
    [anon_sym_co_yield] = ACTIONS(2960),
    [anon_sym_R_DQUOTE] = ACTIONS(2962),
    [anon_sym_LR_DQUOTE] = ACTIONS(2962),
    [anon_sym_uR_DQUOTE] = ACTIONS(2962),
    [anon_sym_UR_DQUOTE] = ACTIONS(2962),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2962),
    [anon_sym_co_await] = ACTIONS(2960),
    [anon_sym_new] = ACTIONS(2960),
    [anon_sym_requires] = ACTIONS(2960),
    [sym_this] = ACTIONS(2960),
  },
  [625] = {
    [sym_identifier] = ACTIONS(2920),
    [aux_sym_preproc_include_token1] = ACTIONS(2920),
    [aux_sym_preproc_def_token1] = ACTIONS(2920),
    [aux_sym_preproc_if_token1] = ACTIONS(2920),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2920),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2920),
    [sym_preproc_directive] = ACTIONS(2920),
    [anon_sym_LPAREN2] = ACTIONS(2922),
    [anon_sym_BANG] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2922),
    [anon_sym_DASH] = ACTIONS(2920),
    [anon_sym_PLUS] = ACTIONS(2920),
    [anon_sym_STAR] = ACTIONS(2922),
    [anon_sym_AMP_AMP] = ACTIONS(2922),
    [anon_sym_AMP] = ACTIONS(2920),
    [anon_sym_SEMI] = ACTIONS(2922),
    [anon_sym___extension__] = ACTIONS(2920),
    [anon_sym_typedef] = ACTIONS(2920),
    [anon_sym_virtual] = ACTIONS(2920),
    [anon_sym_extern] = ACTIONS(2920),
    [anon_sym___attribute__] = ACTIONS(2920),
    [anon_sym___attribute] = ACTIONS(2920),
    [anon_sym_COLON_COLON] = ACTIONS(2922),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2922),
    [anon_sym___declspec] = ACTIONS(2920),
    [anon_sym___based] = ACTIONS(2920),
    [anon_sym___cdecl] = ACTIONS(2920),
    [anon_sym___clrcall] = ACTIONS(2920),
    [anon_sym___stdcall] = ACTIONS(2920),
    [anon_sym___fastcall] = ACTIONS(2920),
    [anon_sym___thiscall] = ACTIONS(2920),
    [anon_sym___vectorcall] = ACTIONS(2920),
    [anon_sym_LBRACE] = ACTIONS(2922),
    [anon_sym_RBRACE] = ACTIONS(2922),
    [anon_sym_signed] = ACTIONS(2920),
    [anon_sym_unsigned] = ACTIONS(2920),
    [anon_sym_long] = ACTIONS(2920),
    [anon_sym_short] = ACTIONS(2920),
    [anon_sym_LBRACK] = ACTIONS(2920),
    [anon_sym_static] = ACTIONS(2920),
    [anon_sym_register] = ACTIONS(2920),
    [anon_sym_inline] = ACTIONS(2920),
    [anon_sym___inline] = ACTIONS(2920),
    [anon_sym___inline__] = ACTIONS(2920),
    [anon_sym___forceinline] = ACTIONS(2920),
    [anon_sym_thread_local] = ACTIONS(2920),
    [anon_sym___thread] = ACTIONS(2920),
    [anon_sym_const] = ACTIONS(2920),
    [anon_sym_constexpr] = ACTIONS(2920),
    [anon_sym_volatile] = ACTIONS(2920),
    [anon_sym_restrict] = ACTIONS(2920),
    [anon_sym___restrict__] = ACTIONS(2920),
    [anon_sym__Atomic] = ACTIONS(2920),
    [anon_sym__Noreturn] = ACTIONS(2920),
    [anon_sym_noreturn] = ACTIONS(2920),
    [anon_sym__Nonnull] = ACTIONS(2920),
    [anon_sym_mutable] = ACTIONS(2920),
    [anon_sym_constinit] = ACTIONS(2920),
    [anon_sym_consteval] = ACTIONS(2920),
    [anon_sym_alignas] = ACTIONS(2920),
    [anon_sym__Alignas] = ACTIONS(2920),
    [sym_primitive_type] = ACTIONS(2920),
    [anon_sym_enum] = ACTIONS(2920),
    [anon_sym_class] = ACTIONS(2920),
    [anon_sym_struct] = ACTIONS(2920),
    [anon_sym_union] = ACTIONS(2920),
    [anon_sym_if] = ACTIONS(2920),
    [anon_sym_switch] = ACTIONS(2920),
    [anon_sym_case] = ACTIONS(2920),
    [anon_sym_default] = ACTIONS(2920),
    [anon_sym_while] = ACTIONS(2920),
    [anon_sym_do] = ACTIONS(2920),
    [anon_sym_for] = ACTIONS(2920),
    [anon_sym_return] = ACTIONS(2920),
    [anon_sym_break] = ACTIONS(2920),
    [anon_sym_continue] = ACTIONS(2920),
    [anon_sym_goto] = ACTIONS(2920),
    [anon_sym___try] = ACTIONS(2920),
    [anon_sym___leave] = ACTIONS(2920),
    [anon_sym_not] = ACTIONS(2920),
    [anon_sym_compl] = ACTIONS(2920),
    [anon_sym_DASH_DASH] = ACTIONS(2922),
    [anon_sym_PLUS_PLUS] = ACTIONS(2922),
    [anon_sym_sizeof] = ACTIONS(2920),
    [anon_sym___alignof__] = ACTIONS(2920),
    [anon_sym___alignof] = ACTIONS(2920),
    [anon_sym__alignof] = ACTIONS(2920),
    [anon_sym_alignof] = ACTIONS(2920),
    [anon_sym__Alignof] = ACTIONS(2920),
    [anon_sym_offsetof] = ACTIONS(2920),
    [anon_sym__Generic] = ACTIONS(2920),
    [anon_sym_asm] = ACTIONS(2920),
    [anon_sym___asm__] = ACTIONS(2920),
    [anon_sym___asm] = ACTIONS(2920),
    [sym_number_literal] = ACTIONS(2922),
    [anon_sym_L_SQUOTE] = ACTIONS(2922),
    [anon_sym_u_SQUOTE] = ACTIONS(2922),
    [anon_sym_U_SQUOTE] = ACTIONS(2922),
    [anon_sym_u8_SQUOTE] = ACTIONS(2922),
    [anon_sym_SQUOTE] = ACTIONS(2922),
    [anon_sym_L_DQUOTE] = ACTIONS(2922),
    [anon_sym_u_DQUOTE] = ACTIONS(2922),
    [anon_sym_U_DQUOTE] = ACTIONS(2922),
    [anon_sym_u8_DQUOTE] = ACTIONS(2922),
    [anon_sym_DQUOTE] = ACTIONS(2922),
    [sym_true] = ACTIONS(2920),
    [sym_false] = ACTIONS(2920),
    [anon_sym_NULL] = ACTIONS(2920),
    [anon_sym_nullptr] = ACTIONS(2920),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2920),
    [anon_sym_decltype] = ACTIONS(2920),
    [anon_sym_explicit] = ACTIONS(2920),
    [anon_sym_typename] = ACTIONS(2920),
    [anon_sym_template] = ACTIONS(2920),
    [anon_sym_operator] = ACTIONS(2920),
    [anon_sym_try] = ACTIONS(2920),
    [anon_sym_delete] = ACTIONS(2920),
    [anon_sym_throw] = ACTIONS(2920),
    [anon_sym_namespace] = ACTIONS(2920),
    [anon_sym_using] = ACTIONS(2920),
    [anon_sym_static_assert] = ACTIONS(2920),
    [anon_sym_concept] = ACTIONS(2920),
    [anon_sym_co_return] = ACTIONS(2920),
    [anon_sym_co_yield] = ACTIONS(2920),
    [anon_sym_R_DQUOTE] = ACTIONS(2922),
    [anon_sym_LR_DQUOTE] = ACTIONS(2922),
    [anon_sym_uR_DQUOTE] = ACTIONS(2922),
    [anon_sym_UR_DQUOTE] = ACTIONS(2922),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2922),
    [anon_sym_co_await] = ACTIONS(2920),
    [anon_sym_new] = ACTIONS(2920),
    [anon_sym_requires] = ACTIONS(2920),
    [sym_this] = ACTIONS(2920),
  },
  [626] = {
    [sym_identifier] = ACTIONS(2964),
    [aux_sym_preproc_include_token1] = ACTIONS(2964),
    [aux_sym_preproc_def_token1] = ACTIONS(2964),
    [aux_sym_preproc_if_token1] = ACTIONS(2964),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2964),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2964),
    [sym_preproc_directive] = ACTIONS(2964),
    [anon_sym_LPAREN2] = ACTIONS(2966),
    [anon_sym_BANG] = ACTIONS(2966),
    [anon_sym_TILDE] = ACTIONS(2966),
    [anon_sym_DASH] = ACTIONS(2964),
    [anon_sym_PLUS] = ACTIONS(2964),
    [anon_sym_STAR] = ACTIONS(2966),
    [anon_sym_AMP_AMP] = ACTIONS(2966),
    [anon_sym_AMP] = ACTIONS(2964),
    [anon_sym_SEMI] = ACTIONS(2966),
    [anon_sym___extension__] = ACTIONS(2964),
    [anon_sym_typedef] = ACTIONS(2964),
    [anon_sym_virtual] = ACTIONS(2964),
    [anon_sym_extern] = ACTIONS(2964),
    [anon_sym___attribute__] = ACTIONS(2964),
    [anon_sym___attribute] = ACTIONS(2964),
    [anon_sym_COLON_COLON] = ACTIONS(2966),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2966),
    [anon_sym___declspec] = ACTIONS(2964),
    [anon_sym___based] = ACTIONS(2964),
    [anon_sym___cdecl] = ACTIONS(2964),
    [anon_sym___clrcall] = ACTIONS(2964),
    [anon_sym___stdcall] = ACTIONS(2964),
    [anon_sym___fastcall] = ACTIONS(2964),
    [anon_sym___thiscall] = ACTIONS(2964),
    [anon_sym___vectorcall] = ACTIONS(2964),
    [anon_sym_LBRACE] = ACTIONS(2966),
    [anon_sym_RBRACE] = ACTIONS(2966),
    [anon_sym_signed] = ACTIONS(2964),
    [anon_sym_unsigned] = ACTIONS(2964),
    [anon_sym_long] = ACTIONS(2964),
    [anon_sym_short] = ACTIONS(2964),
    [anon_sym_LBRACK] = ACTIONS(2964),
    [anon_sym_static] = ACTIONS(2964),
    [anon_sym_register] = ACTIONS(2964),
    [anon_sym_inline] = ACTIONS(2964),
    [anon_sym___inline] = ACTIONS(2964),
    [anon_sym___inline__] = ACTIONS(2964),
    [anon_sym___forceinline] = ACTIONS(2964),
    [anon_sym_thread_local] = ACTIONS(2964),
    [anon_sym___thread] = ACTIONS(2964),
    [anon_sym_const] = ACTIONS(2964),
    [anon_sym_constexpr] = ACTIONS(2964),
    [anon_sym_volatile] = ACTIONS(2964),
    [anon_sym_restrict] = ACTIONS(2964),
    [anon_sym___restrict__] = ACTIONS(2964),
    [anon_sym__Atomic] = ACTIONS(2964),
    [anon_sym__Noreturn] = ACTIONS(2964),
    [anon_sym_noreturn] = ACTIONS(2964),
    [anon_sym__Nonnull] = ACTIONS(2964),
    [anon_sym_mutable] = ACTIONS(2964),
    [anon_sym_constinit] = ACTIONS(2964),
    [anon_sym_consteval] = ACTIONS(2964),
    [anon_sym_alignas] = ACTIONS(2964),
    [anon_sym__Alignas] = ACTIONS(2964),
    [sym_primitive_type] = ACTIONS(2964),
    [anon_sym_enum] = ACTIONS(2964),
    [anon_sym_class] = ACTIONS(2964),
    [anon_sym_struct] = ACTIONS(2964),
    [anon_sym_union] = ACTIONS(2964),
    [anon_sym_if] = ACTIONS(2964),
    [anon_sym_switch] = ACTIONS(2964),
    [anon_sym_case] = ACTIONS(2964),
    [anon_sym_default] = ACTIONS(2964),
    [anon_sym_while] = ACTIONS(2964),
    [anon_sym_do] = ACTIONS(2964),
    [anon_sym_for] = ACTIONS(2964),
    [anon_sym_return] = ACTIONS(2964),
    [anon_sym_break] = ACTIONS(2964),
    [anon_sym_continue] = ACTIONS(2964),
    [anon_sym_goto] = ACTIONS(2964),
    [anon_sym___try] = ACTIONS(2964),
    [anon_sym___leave] = ACTIONS(2964),
    [anon_sym_not] = ACTIONS(2964),
    [anon_sym_compl] = ACTIONS(2964),
    [anon_sym_DASH_DASH] = ACTIONS(2966),
    [anon_sym_PLUS_PLUS] = ACTIONS(2966),
    [anon_sym_sizeof] = ACTIONS(2964),
    [anon_sym___alignof__] = ACTIONS(2964),
    [anon_sym___alignof] = ACTIONS(2964),
    [anon_sym__alignof] = ACTIONS(2964),
    [anon_sym_alignof] = ACTIONS(2964),
    [anon_sym__Alignof] = ACTIONS(2964),
    [anon_sym_offsetof] = ACTIONS(2964),
    [anon_sym__Generic] = ACTIONS(2964),
    [anon_sym_asm] = ACTIONS(2964),
    [anon_sym___asm__] = ACTIONS(2964),
    [anon_sym___asm] = ACTIONS(2964),
    [sym_number_literal] = ACTIONS(2966),
    [anon_sym_L_SQUOTE] = ACTIONS(2966),
    [anon_sym_u_SQUOTE] = ACTIONS(2966),
    [anon_sym_U_SQUOTE] = ACTIONS(2966),
    [anon_sym_u8_SQUOTE] = ACTIONS(2966),
    [anon_sym_SQUOTE] = ACTIONS(2966),
    [anon_sym_L_DQUOTE] = ACTIONS(2966),
    [anon_sym_u_DQUOTE] = ACTIONS(2966),
    [anon_sym_U_DQUOTE] = ACTIONS(2966),
    [anon_sym_u8_DQUOTE] = ACTIONS(2966),
    [anon_sym_DQUOTE] = ACTIONS(2966),
    [sym_true] = ACTIONS(2964),
    [sym_false] = ACTIONS(2964),
    [anon_sym_NULL] = ACTIONS(2964),
    [anon_sym_nullptr] = ACTIONS(2964),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2964),
    [anon_sym_decltype] = ACTIONS(2964),
    [anon_sym_explicit] = ACTIONS(2964),
    [anon_sym_typename] = ACTIONS(2964),
    [anon_sym_template] = ACTIONS(2964),
    [anon_sym_operator] = ACTIONS(2964),
    [anon_sym_try] = ACTIONS(2964),
    [anon_sym_delete] = ACTIONS(2964),
    [anon_sym_throw] = ACTIONS(2964),
    [anon_sym_namespace] = ACTIONS(2964),
    [anon_sym_using] = ACTIONS(2964),
    [anon_sym_static_assert] = ACTIONS(2964),
    [anon_sym_concept] = ACTIONS(2964),
    [anon_sym_co_return] = ACTIONS(2964),
    [anon_sym_co_yield] = ACTIONS(2964),
    [anon_sym_R_DQUOTE] = ACTIONS(2966),
    [anon_sym_LR_DQUOTE] = ACTIONS(2966),
    [anon_sym_uR_DQUOTE] = ACTIONS(2966),
    [anon_sym_UR_DQUOTE] = ACTIONS(2966),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2966),
    [anon_sym_co_await] = ACTIONS(2964),
    [anon_sym_new] = ACTIONS(2964),
    [anon_sym_requires] = ACTIONS(2964),
    [sym_this] = ACTIONS(2964),
  },
  [627] = {
    [sym_identifier] = ACTIONS(2924),
    [aux_sym_preproc_include_token1] = ACTIONS(2924),
    [aux_sym_preproc_def_token1] = ACTIONS(2924),
    [aux_sym_preproc_if_token1] = ACTIONS(2924),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2924),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2924),
    [sym_preproc_directive] = ACTIONS(2924),
    [anon_sym_LPAREN2] = ACTIONS(2926),
    [anon_sym_BANG] = ACTIONS(2926),
    [anon_sym_TILDE] = ACTIONS(2926),
    [anon_sym_DASH] = ACTIONS(2924),
    [anon_sym_PLUS] = ACTIONS(2924),
    [anon_sym_STAR] = ACTIONS(2926),
    [anon_sym_AMP_AMP] = ACTIONS(2926),
    [anon_sym_AMP] = ACTIONS(2924),
    [anon_sym_SEMI] = ACTIONS(2926),
    [anon_sym___extension__] = ACTIONS(2924),
    [anon_sym_typedef] = ACTIONS(2924),
    [anon_sym_virtual] = ACTIONS(2924),
    [anon_sym_extern] = ACTIONS(2924),
    [anon_sym___attribute__] = ACTIONS(2924),
    [anon_sym___attribute] = ACTIONS(2924),
    [anon_sym_COLON_COLON] = ACTIONS(2926),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2926),
    [anon_sym___declspec] = ACTIONS(2924),
    [anon_sym___based] = ACTIONS(2924),
    [anon_sym___cdecl] = ACTIONS(2924),
    [anon_sym___clrcall] = ACTIONS(2924),
    [anon_sym___stdcall] = ACTIONS(2924),
    [anon_sym___fastcall] = ACTIONS(2924),
    [anon_sym___thiscall] = ACTIONS(2924),
    [anon_sym___vectorcall] = ACTIONS(2924),
    [anon_sym_LBRACE] = ACTIONS(2926),
    [anon_sym_RBRACE] = ACTIONS(2926),
    [anon_sym_signed] = ACTIONS(2924),
    [anon_sym_unsigned] = ACTIONS(2924),
    [anon_sym_long] = ACTIONS(2924),
    [anon_sym_short] = ACTIONS(2924),
    [anon_sym_LBRACK] = ACTIONS(2924),
    [anon_sym_static] = ACTIONS(2924),
    [anon_sym_register] = ACTIONS(2924),
    [anon_sym_inline] = ACTIONS(2924),
    [anon_sym___inline] = ACTIONS(2924),
    [anon_sym___inline__] = ACTIONS(2924),
    [anon_sym___forceinline] = ACTIONS(2924),
    [anon_sym_thread_local] = ACTIONS(2924),
    [anon_sym___thread] = ACTIONS(2924),
    [anon_sym_const] = ACTIONS(2924),
    [anon_sym_constexpr] = ACTIONS(2924),
    [anon_sym_volatile] = ACTIONS(2924),
    [anon_sym_restrict] = ACTIONS(2924),
    [anon_sym___restrict__] = ACTIONS(2924),
    [anon_sym__Atomic] = ACTIONS(2924),
    [anon_sym__Noreturn] = ACTIONS(2924),
    [anon_sym_noreturn] = ACTIONS(2924),
    [anon_sym__Nonnull] = ACTIONS(2924),
    [anon_sym_mutable] = ACTIONS(2924),
    [anon_sym_constinit] = ACTIONS(2924),
    [anon_sym_consteval] = ACTIONS(2924),
    [anon_sym_alignas] = ACTIONS(2924),
    [anon_sym__Alignas] = ACTIONS(2924),
    [sym_primitive_type] = ACTIONS(2924),
    [anon_sym_enum] = ACTIONS(2924),
    [anon_sym_class] = ACTIONS(2924),
    [anon_sym_struct] = ACTIONS(2924),
    [anon_sym_union] = ACTIONS(2924),
    [anon_sym_if] = ACTIONS(2924),
    [anon_sym_switch] = ACTIONS(2924),
    [anon_sym_case] = ACTIONS(2924),
    [anon_sym_default] = ACTIONS(2924),
    [anon_sym_while] = ACTIONS(2924),
    [anon_sym_do] = ACTIONS(2924),
    [anon_sym_for] = ACTIONS(2924),
    [anon_sym_return] = ACTIONS(2924),
    [anon_sym_break] = ACTIONS(2924),
    [anon_sym_continue] = ACTIONS(2924),
    [anon_sym_goto] = ACTIONS(2924),
    [anon_sym___try] = ACTIONS(2924),
    [anon_sym___leave] = ACTIONS(2924),
    [anon_sym_not] = ACTIONS(2924),
    [anon_sym_compl] = ACTIONS(2924),
    [anon_sym_DASH_DASH] = ACTIONS(2926),
    [anon_sym_PLUS_PLUS] = ACTIONS(2926),
    [anon_sym_sizeof] = ACTIONS(2924),
    [anon_sym___alignof__] = ACTIONS(2924),
    [anon_sym___alignof] = ACTIONS(2924),
    [anon_sym__alignof] = ACTIONS(2924),
    [anon_sym_alignof] = ACTIONS(2924),
    [anon_sym__Alignof] = ACTIONS(2924),
    [anon_sym_offsetof] = ACTIONS(2924),
    [anon_sym__Generic] = ACTIONS(2924),
    [anon_sym_asm] = ACTIONS(2924),
    [anon_sym___asm__] = ACTIONS(2924),
    [anon_sym___asm] = ACTIONS(2924),
    [sym_number_literal] = ACTIONS(2926),
    [anon_sym_L_SQUOTE] = ACTIONS(2926),
    [anon_sym_u_SQUOTE] = ACTIONS(2926),
    [anon_sym_U_SQUOTE] = ACTIONS(2926),
    [anon_sym_u8_SQUOTE] = ACTIONS(2926),
    [anon_sym_SQUOTE] = ACTIONS(2926),
    [anon_sym_L_DQUOTE] = ACTIONS(2926),
    [anon_sym_u_DQUOTE] = ACTIONS(2926),
    [anon_sym_U_DQUOTE] = ACTIONS(2926),
    [anon_sym_u8_DQUOTE] = ACTIONS(2926),
    [anon_sym_DQUOTE] = ACTIONS(2926),
    [sym_true] = ACTIONS(2924),
    [sym_false] = ACTIONS(2924),
    [anon_sym_NULL] = ACTIONS(2924),
    [anon_sym_nullptr] = ACTIONS(2924),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2924),
    [anon_sym_decltype] = ACTIONS(2924),
    [anon_sym_explicit] = ACTIONS(2924),
    [anon_sym_typename] = ACTIONS(2924),
    [anon_sym_template] = ACTIONS(2924),
    [anon_sym_operator] = ACTIONS(2924),
    [anon_sym_try] = ACTIONS(2924),
    [anon_sym_delete] = ACTIONS(2924),
    [anon_sym_throw] = ACTIONS(2924),
    [anon_sym_namespace] = ACTIONS(2924),
    [anon_sym_using] = ACTIONS(2924),
    [anon_sym_static_assert] = ACTIONS(2924),
    [anon_sym_concept] = ACTIONS(2924),
    [anon_sym_co_return] = ACTIONS(2924),
    [anon_sym_co_yield] = ACTIONS(2924),
    [anon_sym_R_DQUOTE] = ACTIONS(2926),
    [anon_sym_LR_DQUOTE] = ACTIONS(2926),
    [anon_sym_uR_DQUOTE] = ACTIONS(2926),
    [anon_sym_UR_DQUOTE] = ACTIONS(2926),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2926),
    [anon_sym_co_await] = ACTIONS(2924),
    [anon_sym_new] = ACTIONS(2924),
    [anon_sym_requires] = ACTIONS(2924),
    [sym_this] = ACTIONS(2924),
  },
  [628] = {
    [sym_identifier] = ACTIONS(2799),
    [aux_sym_preproc_include_token1] = ACTIONS(2799),
    [aux_sym_preproc_def_token1] = ACTIONS(2799),
    [aux_sym_preproc_if_token1] = ACTIONS(2799),
    [aux_sym_preproc_if_token2] = ACTIONS(2799),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2799),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2799),
    [sym_preproc_directive] = ACTIONS(2799),
    [anon_sym_LPAREN2] = ACTIONS(2801),
    [anon_sym_BANG] = ACTIONS(2801),
    [anon_sym_TILDE] = ACTIONS(2801),
    [anon_sym_DASH] = ACTIONS(2799),
    [anon_sym_PLUS] = ACTIONS(2799),
    [anon_sym_STAR] = ACTIONS(2801),
    [anon_sym_AMP_AMP] = ACTIONS(2801),
    [anon_sym_AMP] = ACTIONS(2799),
    [anon_sym_SEMI] = ACTIONS(2801),
    [anon_sym___extension__] = ACTIONS(2799),
    [anon_sym_typedef] = ACTIONS(2799),
    [anon_sym_virtual] = ACTIONS(2799),
    [anon_sym_extern] = ACTIONS(2799),
    [anon_sym___attribute__] = ACTIONS(2799),
    [anon_sym___attribute] = ACTIONS(2799),
    [anon_sym_COLON_COLON] = ACTIONS(2801),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2801),
    [anon_sym___declspec] = ACTIONS(2799),
    [anon_sym___based] = ACTIONS(2799),
    [anon_sym___cdecl] = ACTIONS(2799),
    [anon_sym___clrcall] = ACTIONS(2799),
    [anon_sym___stdcall] = ACTIONS(2799),
    [anon_sym___fastcall] = ACTIONS(2799),
    [anon_sym___thiscall] = ACTIONS(2799),
    [anon_sym___vectorcall] = ACTIONS(2799),
    [anon_sym_LBRACE] = ACTIONS(2801),
    [anon_sym_signed] = ACTIONS(2799),
    [anon_sym_unsigned] = ACTIONS(2799),
    [anon_sym_long] = ACTIONS(2799),
    [anon_sym_short] = ACTIONS(2799),
    [anon_sym_LBRACK] = ACTIONS(2799),
    [anon_sym_static] = ACTIONS(2799),
    [anon_sym_register] = ACTIONS(2799),
    [anon_sym_inline] = ACTIONS(2799),
    [anon_sym___inline] = ACTIONS(2799),
    [anon_sym___inline__] = ACTIONS(2799),
    [anon_sym___forceinline] = ACTIONS(2799),
    [anon_sym_thread_local] = ACTIONS(2799),
    [anon_sym___thread] = ACTIONS(2799),
    [anon_sym_const] = ACTIONS(2799),
    [anon_sym_constexpr] = ACTIONS(2799),
    [anon_sym_volatile] = ACTIONS(2799),
    [anon_sym_restrict] = ACTIONS(2799),
    [anon_sym___restrict__] = ACTIONS(2799),
    [anon_sym__Atomic] = ACTIONS(2799),
    [anon_sym__Noreturn] = ACTIONS(2799),
    [anon_sym_noreturn] = ACTIONS(2799),
    [anon_sym__Nonnull] = ACTIONS(2799),
    [anon_sym_mutable] = ACTIONS(2799),
    [anon_sym_constinit] = ACTIONS(2799),
    [anon_sym_consteval] = ACTIONS(2799),
    [anon_sym_alignas] = ACTIONS(2799),
    [anon_sym__Alignas] = ACTIONS(2799),
    [sym_primitive_type] = ACTIONS(2799),
    [anon_sym_enum] = ACTIONS(2799),
    [anon_sym_class] = ACTIONS(2799),
    [anon_sym_struct] = ACTIONS(2799),
    [anon_sym_union] = ACTIONS(2799),
    [anon_sym_if] = ACTIONS(2799),
    [anon_sym_switch] = ACTIONS(2799),
    [anon_sym_case] = ACTIONS(2799),
    [anon_sym_default] = ACTIONS(2799),
    [anon_sym_while] = ACTIONS(2799),
    [anon_sym_do] = ACTIONS(2799),
    [anon_sym_for] = ACTIONS(2799),
    [anon_sym_return] = ACTIONS(2799),
    [anon_sym_break] = ACTIONS(2799),
    [anon_sym_continue] = ACTIONS(2799),
    [anon_sym_goto] = ACTIONS(2799),
    [anon_sym___try] = ACTIONS(2799),
    [anon_sym___leave] = ACTIONS(2799),
    [anon_sym_not] = ACTIONS(2799),
    [anon_sym_compl] = ACTIONS(2799),
    [anon_sym_DASH_DASH] = ACTIONS(2801),
    [anon_sym_PLUS_PLUS] = ACTIONS(2801),
    [anon_sym_sizeof] = ACTIONS(2799),
    [anon_sym___alignof__] = ACTIONS(2799),
    [anon_sym___alignof] = ACTIONS(2799),
    [anon_sym__alignof] = ACTIONS(2799),
    [anon_sym_alignof] = ACTIONS(2799),
    [anon_sym__Alignof] = ACTIONS(2799),
    [anon_sym_offsetof] = ACTIONS(2799),
    [anon_sym__Generic] = ACTIONS(2799),
    [anon_sym_asm] = ACTIONS(2799),
    [anon_sym___asm__] = ACTIONS(2799),
    [anon_sym___asm] = ACTIONS(2799),
    [sym_number_literal] = ACTIONS(2801),
    [anon_sym_L_SQUOTE] = ACTIONS(2801),
    [anon_sym_u_SQUOTE] = ACTIONS(2801),
    [anon_sym_U_SQUOTE] = ACTIONS(2801),
    [anon_sym_u8_SQUOTE] = ACTIONS(2801),
    [anon_sym_SQUOTE] = ACTIONS(2801),
    [anon_sym_L_DQUOTE] = ACTIONS(2801),
    [anon_sym_u_DQUOTE] = ACTIONS(2801),
    [anon_sym_U_DQUOTE] = ACTIONS(2801),
    [anon_sym_u8_DQUOTE] = ACTIONS(2801),
    [anon_sym_DQUOTE] = ACTIONS(2801),
    [sym_true] = ACTIONS(2799),
    [sym_false] = ACTIONS(2799),
    [anon_sym_NULL] = ACTIONS(2799),
    [anon_sym_nullptr] = ACTIONS(2799),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2799),
    [anon_sym_decltype] = ACTIONS(2799),
    [anon_sym_explicit] = ACTIONS(2799),
    [anon_sym_typename] = ACTIONS(2799),
    [anon_sym_template] = ACTIONS(2799),
    [anon_sym_operator] = ACTIONS(2799),
    [anon_sym_try] = ACTIONS(2799),
    [anon_sym_delete] = ACTIONS(2799),
    [anon_sym_throw] = ACTIONS(2799),
    [anon_sym_namespace] = ACTIONS(2799),
    [anon_sym_using] = ACTIONS(2799),
    [anon_sym_static_assert] = ACTIONS(2799),
    [anon_sym_concept] = ACTIONS(2799),
    [anon_sym_co_return] = ACTIONS(2799),
    [anon_sym_co_yield] = ACTIONS(2799),
    [anon_sym_R_DQUOTE] = ACTIONS(2801),
    [anon_sym_LR_DQUOTE] = ACTIONS(2801),
    [anon_sym_uR_DQUOTE] = ACTIONS(2801),
    [anon_sym_UR_DQUOTE] = ACTIONS(2801),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2801),
    [anon_sym_co_await] = ACTIONS(2799),
    [anon_sym_new] = ACTIONS(2799),
    [anon_sym_requires] = ACTIONS(2799),
    [sym_this] = ACTIONS(2799),
  },
  [629] = {
    [sym_identifier] = ACTIONS(3009),
    [aux_sym_preproc_include_token1] = ACTIONS(3009),
    [aux_sym_preproc_def_token1] = ACTIONS(3009),
    [aux_sym_preproc_if_token1] = ACTIONS(3009),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3009),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3009),
    [sym_preproc_directive] = ACTIONS(3009),
    [anon_sym_LPAREN2] = ACTIONS(3011),
    [anon_sym_BANG] = ACTIONS(3011),
    [anon_sym_TILDE] = ACTIONS(3011),
    [anon_sym_DASH] = ACTIONS(3009),
    [anon_sym_PLUS] = ACTIONS(3009),
    [anon_sym_STAR] = ACTIONS(3011),
    [anon_sym_AMP_AMP] = ACTIONS(3011),
    [anon_sym_AMP] = ACTIONS(3009),
    [anon_sym_SEMI] = ACTIONS(3011),
    [anon_sym___extension__] = ACTIONS(3009),
    [anon_sym_typedef] = ACTIONS(3009),
    [anon_sym_virtual] = ACTIONS(3009),
    [anon_sym_extern] = ACTIONS(3009),
    [anon_sym___attribute__] = ACTIONS(3009),
    [anon_sym___attribute] = ACTIONS(3009),
    [anon_sym_COLON_COLON] = ACTIONS(3011),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3011),
    [anon_sym___declspec] = ACTIONS(3009),
    [anon_sym___based] = ACTIONS(3009),
    [anon_sym___cdecl] = ACTIONS(3009),
    [anon_sym___clrcall] = ACTIONS(3009),
    [anon_sym___stdcall] = ACTIONS(3009),
    [anon_sym___fastcall] = ACTIONS(3009),
    [anon_sym___thiscall] = ACTIONS(3009),
    [anon_sym___vectorcall] = ACTIONS(3009),
    [anon_sym_LBRACE] = ACTIONS(3011),
    [anon_sym_RBRACE] = ACTIONS(3011),
    [anon_sym_signed] = ACTIONS(3009),
    [anon_sym_unsigned] = ACTIONS(3009),
    [anon_sym_long] = ACTIONS(3009),
    [anon_sym_short] = ACTIONS(3009),
    [anon_sym_LBRACK] = ACTIONS(3009),
    [anon_sym_static] = ACTIONS(3009),
    [anon_sym_register] = ACTIONS(3009),
    [anon_sym_inline] = ACTIONS(3009),
    [anon_sym___inline] = ACTIONS(3009),
    [anon_sym___inline__] = ACTIONS(3009),
    [anon_sym___forceinline] = ACTIONS(3009),
    [anon_sym_thread_local] = ACTIONS(3009),
    [anon_sym___thread] = ACTIONS(3009),
    [anon_sym_const] = ACTIONS(3009),
    [anon_sym_constexpr] = ACTIONS(3009),
    [anon_sym_volatile] = ACTIONS(3009),
    [anon_sym_restrict] = ACTIONS(3009),
    [anon_sym___restrict__] = ACTIONS(3009),
    [anon_sym__Atomic] = ACTIONS(3009),
    [anon_sym__Noreturn] = ACTIONS(3009),
    [anon_sym_noreturn] = ACTIONS(3009),
    [anon_sym__Nonnull] = ACTIONS(3009),
    [anon_sym_mutable] = ACTIONS(3009),
    [anon_sym_constinit] = ACTIONS(3009),
    [anon_sym_consteval] = ACTIONS(3009),
    [anon_sym_alignas] = ACTIONS(3009),
    [anon_sym__Alignas] = ACTIONS(3009),
    [sym_primitive_type] = ACTIONS(3009),
    [anon_sym_enum] = ACTIONS(3009),
    [anon_sym_class] = ACTIONS(3009),
    [anon_sym_struct] = ACTIONS(3009),
    [anon_sym_union] = ACTIONS(3009),
    [anon_sym_if] = ACTIONS(3009),
    [anon_sym_switch] = ACTIONS(3009),
    [anon_sym_case] = ACTIONS(3009),
    [anon_sym_default] = ACTIONS(3009),
    [anon_sym_while] = ACTIONS(3009),
    [anon_sym_do] = ACTIONS(3009),
    [anon_sym_for] = ACTIONS(3009),
    [anon_sym_return] = ACTIONS(3009),
    [anon_sym_break] = ACTIONS(3009),
    [anon_sym_continue] = ACTIONS(3009),
    [anon_sym_goto] = ACTIONS(3009),
    [anon_sym___try] = ACTIONS(3009),
    [anon_sym___leave] = ACTIONS(3009),
    [anon_sym_not] = ACTIONS(3009),
    [anon_sym_compl] = ACTIONS(3009),
    [anon_sym_DASH_DASH] = ACTIONS(3011),
    [anon_sym_PLUS_PLUS] = ACTIONS(3011),
    [anon_sym_sizeof] = ACTIONS(3009),
    [anon_sym___alignof__] = ACTIONS(3009),
    [anon_sym___alignof] = ACTIONS(3009),
    [anon_sym__alignof] = ACTIONS(3009),
    [anon_sym_alignof] = ACTIONS(3009),
    [anon_sym__Alignof] = ACTIONS(3009),
    [anon_sym_offsetof] = ACTIONS(3009),
    [anon_sym__Generic] = ACTIONS(3009),
    [anon_sym_asm] = ACTIONS(3009),
    [anon_sym___asm__] = ACTIONS(3009),
    [anon_sym___asm] = ACTIONS(3009),
    [sym_number_literal] = ACTIONS(3011),
    [anon_sym_L_SQUOTE] = ACTIONS(3011),
    [anon_sym_u_SQUOTE] = ACTIONS(3011),
    [anon_sym_U_SQUOTE] = ACTIONS(3011),
    [anon_sym_u8_SQUOTE] = ACTIONS(3011),
    [anon_sym_SQUOTE] = ACTIONS(3011),
    [anon_sym_L_DQUOTE] = ACTIONS(3011),
    [anon_sym_u_DQUOTE] = ACTIONS(3011),
    [anon_sym_U_DQUOTE] = ACTIONS(3011),
    [anon_sym_u8_DQUOTE] = ACTIONS(3011),
    [anon_sym_DQUOTE] = ACTIONS(3011),
    [sym_true] = ACTIONS(3009),
    [sym_false] = ACTIONS(3009),
    [anon_sym_NULL] = ACTIONS(3009),
    [anon_sym_nullptr] = ACTIONS(3009),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3009),
    [anon_sym_decltype] = ACTIONS(3009),
    [anon_sym_explicit] = ACTIONS(3009),
    [anon_sym_typename] = ACTIONS(3009),
    [anon_sym_template] = ACTIONS(3009),
    [anon_sym_operator] = ACTIONS(3009),
    [anon_sym_try] = ACTIONS(3009),
    [anon_sym_delete] = ACTIONS(3009),
    [anon_sym_throw] = ACTIONS(3009),
    [anon_sym_namespace] = ACTIONS(3009),
    [anon_sym_using] = ACTIONS(3009),
    [anon_sym_static_assert] = ACTIONS(3009),
    [anon_sym_concept] = ACTIONS(3009),
    [anon_sym_co_return] = ACTIONS(3009),
    [anon_sym_co_yield] = ACTIONS(3009),
    [anon_sym_R_DQUOTE] = ACTIONS(3011),
    [anon_sym_LR_DQUOTE] = ACTIONS(3011),
    [anon_sym_uR_DQUOTE] = ACTIONS(3011),
    [anon_sym_UR_DQUOTE] = ACTIONS(3011),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3011),
    [anon_sym_co_await] = ACTIONS(3009),
    [anon_sym_new] = ACTIONS(3009),
    [anon_sym_requires] = ACTIONS(3009),
    [sym_this] = ACTIONS(3009),
  },
  [630] = {
    [sym_identifier] = ACTIONS(2799),
    [aux_sym_preproc_include_token1] = ACTIONS(2799),
    [aux_sym_preproc_def_token1] = ACTIONS(2799),
    [aux_sym_preproc_if_token1] = ACTIONS(2799),
    [aux_sym_preproc_if_token2] = ACTIONS(2799),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2799),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2799),
    [sym_preproc_directive] = ACTIONS(2799),
    [anon_sym_LPAREN2] = ACTIONS(2801),
    [anon_sym_BANG] = ACTIONS(2801),
    [anon_sym_TILDE] = ACTIONS(2801),
    [anon_sym_DASH] = ACTIONS(2799),
    [anon_sym_PLUS] = ACTIONS(2799),
    [anon_sym_STAR] = ACTIONS(2801),
    [anon_sym_AMP_AMP] = ACTIONS(2801),
    [anon_sym_AMP] = ACTIONS(2799),
    [anon_sym_SEMI] = ACTIONS(2801),
    [anon_sym___extension__] = ACTIONS(2799),
    [anon_sym_typedef] = ACTIONS(2799),
    [anon_sym_virtual] = ACTIONS(2799),
    [anon_sym_extern] = ACTIONS(2799),
    [anon_sym___attribute__] = ACTIONS(2799),
    [anon_sym___attribute] = ACTIONS(2799),
    [anon_sym_COLON_COLON] = ACTIONS(2801),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2801),
    [anon_sym___declspec] = ACTIONS(2799),
    [anon_sym___based] = ACTIONS(2799),
    [anon_sym___cdecl] = ACTIONS(2799),
    [anon_sym___clrcall] = ACTIONS(2799),
    [anon_sym___stdcall] = ACTIONS(2799),
    [anon_sym___fastcall] = ACTIONS(2799),
    [anon_sym___thiscall] = ACTIONS(2799),
    [anon_sym___vectorcall] = ACTIONS(2799),
    [anon_sym_LBRACE] = ACTIONS(2801),
    [anon_sym_signed] = ACTIONS(2799),
    [anon_sym_unsigned] = ACTIONS(2799),
    [anon_sym_long] = ACTIONS(2799),
    [anon_sym_short] = ACTIONS(2799),
    [anon_sym_LBRACK] = ACTIONS(2799),
    [anon_sym_static] = ACTIONS(2799),
    [anon_sym_register] = ACTIONS(2799),
    [anon_sym_inline] = ACTIONS(2799),
    [anon_sym___inline] = ACTIONS(2799),
    [anon_sym___inline__] = ACTIONS(2799),
    [anon_sym___forceinline] = ACTIONS(2799),
    [anon_sym_thread_local] = ACTIONS(2799),
    [anon_sym___thread] = ACTIONS(2799),
    [anon_sym_const] = ACTIONS(2799),
    [anon_sym_constexpr] = ACTIONS(2799),
    [anon_sym_volatile] = ACTIONS(2799),
    [anon_sym_restrict] = ACTIONS(2799),
    [anon_sym___restrict__] = ACTIONS(2799),
    [anon_sym__Atomic] = ACTIONS(2799),
    [anon_sym__Noreturn] = ACTIONS(2799),
    [anon_sym_noreturn] = ACTIONS(2799),
    [anon_sym__Nonnull] = ACTIONS(2799),
    [anon_sym_mutable] = ACTIONS(2799),
    [anon_sym_constinit] = ACTIONS(2799),
    [anon_sym_consteval] = ACTIONS(2799),
    [anon_sym_alignas] = ACTIONS(2799),
    [anon_sym__Alignas] = ACTIONS(2799),
    [sym_primitive_type] = ACTIONS(2799),
    [anon_sym_enum] = ACTIONS(2799),
    [anon_sym_class] = ACTIONS(2799),
    [anon_sym_struct] = ACTIONS(2799),
    [anon_sym_union] = ACTIONS(2799),
    [anon_sym_if] = ACTIONS(2799),
    [anon_sym_switch] = ACTIONS(2799),
    [anon_sym_case] = ACTIONS(2799),
    [anon_sym_default] = ACTIONS(2799),
    [anon_sym_while] = ACTIONS(2799),
    [anon_sym_do] = ACTIONS(2799),
    [anon_sym_for] = ACTIONS(2799),
    [anon_sym_return] = ACTIONS(2799),
    [anon_sym_break] = ACTIONS(2799),
    [anon_sym_continue] = ACTIONS(2799),
    [anon_sym_goto] = ACTIONS(2799),
    [anon_sym___try] = ACTIONS(2799),
    [anon_sym___leave] = ACTIONS(2799),
    [anon_sym_not] = ACTIONS(2799),
    [anon_sym_compl] = ACTIONS(2799),
    [anon_sym_DASH_DASH] = ACTIONS(2801),
    [anon_sym_PLUS_PLUS] = ACTIONS(2801),
    [anon_sym_sizeof] = ACTIONS(2799),
    [anon_sym___alignof__] = ACTIONS(2799),
    [anon_sym___alignof] = ACTIONS(2799),
    [anon_sym__alignof] = ACTIONS(2799),
    [anon_sym_alignof] = ACTIONS(2799),
    [anon_sym__Alignof] = ACTIONS(2799),
    [anon_sym_offsetof] = ACTIONS(2799),
    [anon_sym__Generic] = ACTIONS(2799),
    [anon_sym_asm] = ACTIONS(2799),
    [anon_sym___asm__] = ACTIONS(2799),
    [anon_sym___asm] = ACTIONS(2799),
    [sym_number_literal] = ACTIONS(2801),
    [anon_sym_L_SQUOTE] = ACTIONS(2801),
    [anon_sym_u_SQUOTE] = ACTIONS(2801),
    [anon_sym_U_SQUOTE] = ACTIONS(2801),
    [anon_sym_u8_SQUOTE] = ACTIONS(2801),
    [anon_sym_SQUOTE] = ACTIONS(2801),
    [anon_sym_L_DQUOTE] = ACTIONS(2801),
    [anon_sym_u_DQUOTE] = ACTIONS(2801),
    [anon_sym_U_DQUOTE] = ACTIONS(2801),
    [anon_sym_u8_DQUOTE] = ACTIONS(2801),
    [anon_sym_DQUOTE] = ACTIONS(2801),
    [sym_true] = ACTIONS(2799),
    [sym_false] = ACTIONS(2799),
    [anon_sym_NULL] = ACTIONS(2799),
    [anon_sym_nullptr] = ACTIONS(2799),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2799),
    [anon_sym_decltype] = ACTIONS(2799),
    [anon_sym_explicit] = ACTIONS(2799),
    [anon_sym_typename] = ACTIONS(2799),
    [anon_sym_template] = ACTIONS(2799),
    [anon_sym_operator] = ACTIONS(2799),
    [anon_sym_try] = ACTIONS(2799),
    [anon_sym_delete] = ACTIONS(2799),
    [anon_sym_throw] = ACTIONS(2799),
    [anon_sym_namespace] = ACTIONS(2799),
    [anon_sym_using] = ACTIONS(2799),
    [anon_sym_static_assert] = ACTIONS(2799),
    [anon_sym_concept] = ACTIONS(2799),
    [anon_sym_co_return] = ACTIONS(2799),
    [anon_sym_co_yield] = ACTIONS(2799),
    [anon_sym_R_DQUOTE] = ACTIONS(2801),
    [anon_sym_LR_DQUOTE] = ACTIONS(2801),
    [anon_sym_uR_DQUOTE] = ACTIONS(2801),
    [anon_sym_UR_DQUOTE] = ACTIONS(2801),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2801),
    [anon_sym_co_await] = ACTIONS(2799),
    [anon_sym_new] = ACTIONS(2799),
    [anon_sym_requires] = ACTIONS(2799),
    [sym_this] = ACTIONS(2799),
  },
  [631] = {
    [sym_identifier] = ACTIONS(2928),
    [aux_sym_preproc_include_token1] = ACTIONS(2928),
    [aux_sym_preproc_def_token1] = ACTIONS(2928),
    [aux_sym_preproc_if_token1] = ACTIONS(2928),
    [aux_sym_preproc_if_token2] = ACTIONS(2928),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2928),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2928),
    [sym_preproc_directive] = ACTIONS(2928),
    [anon_sym_LPAREN2] = ACTIONS(2930),
    [anon_sym_BANG] = ACTIONS(2930),
    [anon_sym_TILDE] = ACTIONS(2930),
    [anon_sym_DASH] = ACTIONS(2928),
    [anon_sym_PLUS] = ACTIONS(2928),
    [anon_sym_STAR] = ACTIONS(2930),
    [anon_sym_AMP_AMP] = ACTIONS(2930),
    [anon_sym_AMP] = ACTIONS(2928),
    [anon_sym_SEMI] = ACTIONS(2930),
    [anon_sym___extension__] = ACTIONS(2928),
    [anon_sym_typedef] = ACTIONS(2928),
    [anon_sym_virtual] = ACTIONS(2928),
    [anon_sym_extern] = ACTIONS(2928),
    [anon_sym___attribute__] = ACTIONS(2928),
    [anon_sym___attribute] = ACTIONS(2928),
    [anon_sym_COLON_COLON] = ACTIONS(2930),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2930),
    [anon_sym___declspec] = ACTIONS(2928),
    [anon_sym___based] = ACTIONS(2928),
    [anon_sym___cdecl] = ACTIONS(2928),
    [anon_sym___clrcall] = ACTIONS(2928),
    [anon_sym___stdcall] = ACTIONS(2928),
    [anon_sym___fastcall] = ACTIONS(2928),
    [anon_sym___thiscall] = ACTIONS(2928),
    [anon_sym___vectorcall] = ACTIONS(2928),
    [anon_sym_LBRACE] = ACTIONS(2930),
    [anon_sym_signed] = ACTIONS(2928),
    [anon_sym_unsigned] = ACTIONS(2928),
    [anon_sym_long] = ACTIONS(2928),
    [anon_sym_short] = ACTIONS(2928),
    [anon_sym_LBRACK] = ACTIONS(2928),
    [anon_sym_static] = ACTIONS(2928),
    [anon_sym_register] = ACTIONS(2928),
    [anon_sym_inline] = ACTIONS(2928),
    [anon_sym___inline] = ACTIONS(2928),
    [anon_sym___inline__] = ACTIONS(2928),
    [anon_sym___forceinline] = ACTIONS(2928),
    [anon_sym_thread_local] = ACTIONS(2928),
    [anon_sym___thread] = ACTIONS(2928),
    [anon_sym_const] = ACTIONS(2928),
    [anon_sym_constexpr] = ACTIONS(2928),
    [anon_sym_volatile] = ACTIONS(2928),
    [anon_sym_restrict] = ACTIONS(2928),
    [anon_sym___restrict__] = ACTIONS(2928),
    [anon_sym__Atomic] = ACTIONS(2928),
    [anon_sym__Noreturn] = ACTIONS(2928),
    [anon_sym_noreturn] = ACTIONS(2928),
    [anon_sym__Nonnull] = ACTIONS(2928),
    [anon_sym_mutable] = ACTIONS(2928),
    [anon_sym_constinit] = ACTIONS(2928),
    [anon_sym_consteval] = ACTIONS(2928),
    [anon_sym_alignas] = ACTIONS(2928),
    [anon_sym__Alignas] = ACTIONS(2928),
    [sym_primitive_type] = ACTIONS(2928),
    [anon_sym_enum] = ACTIONS(2928),
    [anon_sym_class] = ACTIONS(2928),
    [anon_sym_struct] = ACTIONS(2928),
    [anon_sym_union] = ACTIONS(2928),
    [anon_sym_if] = ACTIONS(2928),
    [anon_sym_switch] = ACTIONS(2928),
    [anon_sym_case] = ACTIONS(2928),
    [anon_sym_default] = ACTIONS(2928),
    [anon_sym_while] = ACTIONS(2928),
    [anon_sym_do] = ACTIONS(2928),
    [anon_sym_for] = ACTIONS(2928),
    [anon_sym_return] = ACTIONS(2928),
    [anon_sym_break] = ACTIONS(2928),
    [anon_sym_continue] = ACTIONS(2928),
    [anon_sym_goto] = ACTIONS(2928),
    [anon_sym___try] = ACTIONS(2928),
    [anon_sym___leave] = ACTIONS(2928),
    [anon_sym_not] = ACTIONS(2928),
    [anon_sym_compl] = ACTIONS(2928),
    [anon_sym_DASH_DASH] = ACTIONS(2930),
    [anon_sym_PLUS_PLUS] = ACTIONS(2930),
    [anon_sym_sizeof] = ACTIONS(2928),
    [anon_sym___alignof__] = ACTIONS(2928),
    [anon_sym___alignof] = ACTIONS(2928),
    [anon_sym__alignof] = ACTIONS(2928),
    [anon_sym_alignof] = ACTIONS(2928),
    [anon_sym__Alignof] = ACTIONS(2928),
    [anon_sym_offsetof] = ACTIONS(2928),
    [anon_sym__Generic] = ACTIONS(2928),
    [anon_sym_asm] = ACTIONS(2928),
    [anon_sym___asm__] = ACTIONS(2928),
    [anon_sym___asm] = ACTIONS(2928),
    [sym_number_literal] = ACTIONS(2930),
    [anon_sym_L_SQUOTE] = ACTIONS(2930),
    [anon_sym_u_SQUOTE] = ACTIONS(2930),
    [anon_sym_U_SQUOTE] = ACTIONS(2930),
    [anon_sym_u8_SQUOTE] = ACTIONS(2930),
    [anon_sym_SQUOTE] = ACTIONS(2930),
    [anon_sym_L_DQUOTE] = ACTIONS(2930),
    [anon_sym_u_DQUOTE] = ACTIONS(2930),
    [anon_sym_U_DQUOTE] = ACTIONS(2930),
    [anon_sym_u8_DQUOTE] = ACTIONS(2930),
    [anon_sym_DQUOTE] = ACTIONS(2930),
    [sym_true] = ACTIONS(2928),
    [sym_false] = ACTIONS(2928),
    [anon_sym_NULL] = ACTIONS(2928),
    [anon_sym_nullptr] = ACTIONS(2928),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2928),
    [anon_sym_decltype] = ACTIONS(2928),
    [anon_sym_explicit] = ACTIONS(2928),
    [anon_sym_typename] = ACTIONS(2928),
    [anon_sym_template] = ACTIONS(2928),
    [anon_sym_operator] = ACTIONS(2928),
    [anon_sym_try] = ACTIONS(2928),
    [anon_sym_delete] = ACTIONS(2928),
    [anon_sym_throw] = ACTIONS(2928),
    [anon_sym_namespace] = ACTIONS(2928),
    [anon_sym_using] = ACTIONS(2928),
    [anon_sym_static_assert] = ACTIONS(2928),
    [anon_sym_concept] = ACTIONS(2928),
    [anon_sym_co_return] = ACTIONS(2928),
    [anon_sym_co_yield] = ACTIONS(2928),
    [anon_sym_R_DQUOTE] = ACTIONS(2930),
    [anon_sym_LR_DQUOTE] = ACTIONS(2930),
    [anon_sym_uR_DQUOTE] = ACTIONS(2930),
    [anon_sym_UR_DQUOTE] = ACTIONS(2930),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2930),
    [anon_sym_co_await] = ACTIONS(2928),
    [anon_sym_new] = ACTIONS(2928),
    [anon_sym_requires] = ACTIONS(2928),
    [sym_this] = ACTIONS(2928),
  },
  [632] = {
    [sym_identifier] = ACTIONS(2846),
    [aux_sym_preproc_include_token1] = ACTIONS(2846),
    [aux_sym_preproc_def_token1] = ACTIONS(2846),
    [aux_sym_preproc_if_token1] = ACTIONS(2846),
    [aux_sym_preproc_if_token2] = ACTIONS(2846),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2846),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2846),
    [sym_preproc_directive] = ACTIONS(2846),
    [anon_sym_LPAREN2] = ACTIONS(2848),
    [anon_sym_BANG] = ACTIONS(2848),
    [anon_sym_TILDE] = ACTIONS(2848),
    [anon_sym_DASH] = ACTIONS(2846),
    [anon_sym_PLUS] = ACTIONS(2846),
    [anon_sym_STAR] = ACTIONS(2848),
    [anon_sym_AMP_AMP] = ACTIONS(2848),
    [anon_sym_AMP] = ACTIONS(2846),
    [anon_sym_SEMI] = ACTIONS(2848),
    [anon_sym___extension__] = ACTIONS(2846),
    [anon_sym_typedef] = ACTIONS(2846),
    [anon_sym_virtual] = ACTIONS(2846),
    [anon_sym_extern] = ACTIONS(2846),
    [anon_sym___attribute__] = ACTIONS(2846),
    [anon_sym___attribute] = ACTIONS(2846),
    [anon_sym_COLON_COLON] = ACTIONS(2848),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2848),
    [anon_sym___declspec] = ACTIONS(2846),
    [anon_sym___based] = ACTIONS(2846),
    [anon_sym___cdecl] = ACTIONS(2846),
    [anon_sym___clrcall] = ACTIONS(2846),
    [anon_sym___stdcall] = ACTIONS(2846),
    [anon_sym___fastcall] = ACTIONS(2846),
    [anon_sym___thiscall] = ACTIONS(2846),
    [anon_sym___vectorcall] = ACTIONS(2846),
    [anon_sym_LBRACE] = ACTIONS(2848),
    [anon_sym_signed] = ACTIONS(2846),
    [anon_sym_unsigned] = ACTIONS(2846),
    [anon_sym_long] = ACTIONS(2846),
    [anon_sym_short] = ACTIONS(2846),
    [anon_sym_LBRACK] = ACTIONS(2846),
    [anon_sym_static] = ACTIONS(2846),
    [anon_sym_register] = ACTIONS(2846),
    [anon_sym_inline] = ACTIONS(2846),
    [anon_sym___inline] = ACTIONS(2846),
    [anon_sym___inline__] = ACTIONS(2846),
    [anon_sym___forceinline] = ACTIONS(2846),
    [anon_sym_thread_local] = ACTIONS(2846),
    [anon_sym___thread] = ACTIONS(2846),
    [anon_sym_const] = ACTIONS(2846),
    [anon_sym_constexpr] = ACTIONS(2846),
    [anon_sym_volatile] = ACTIONS(2846),
    [anon_sym_restrict] = ACTIONS(2846),
    [anon_sym___restrict__] = ACTIONS(2846),
    [anon_sym__Atomic] = ACTIONS(2846),
    [anon_sym__Noreturn] = ACTIONS(2846),
    [anon_sym_noreturn] = ACTIONS(2846),
    [anon_sym__Nonnull] = ACTIONS(2846),
    [anon_sym_mutable] = ACTIONS(2846),
    [anon_sym_constinit] = ACTIONS(2846),
    [anon_sym_consteval] = ACTIONS(2846),
    [anon_sym_alignas] = ACTIONS(2846),
    [anon_sym__Alignas] = ACTIONS(2846),
    [sym_primitive_type] = ACTIONS(2846),
    [anon_sym_enum] = ACTIONS(2846),
    [anon_sym_class] = ACTIONS(2846),
    [anon_sym_struct] = ACTIONS(2846),
    [anon_sym_union] = ACTIONS(2846),
    [anon_sym_if] = ACTIONS(2846),
    [anon_sym_switch] = ACTIONS(2846),
    [anon_sym_case] = ACTIONS(2846),
    [anon_sym_default] = ACTIONS(2846),
    [anon_sym_while] = ACTIONS(2846),
    [anon_sym_do] = ACTIONS(2846),
    [anon_sym_for] = ACTIONS(2846),
    [anon_sym_return] = ACTIONS(2846),
    [anon_sym_break] = ACTIONS(2846),
    [anon_sym_continue] = ACTIONS(2846),
    [anon_sym_goto] = ACTIONS(2846),
    [anon_sym___try] = ACTIONS(2846),
    [anon_sym___leave] = ACTIONS(2846),
    [anon_sym_not] = ACTIONS(2846),
    [anon_sym_compl] = ACTIONS(2846),
    [anon_sym_DASH_DASH] = ACTIONS(2848),
    [anon_sym_PLUS_PLUS] = ACTIONS(2848),
    [anon_sym_sizeof] = ACTIONS(2846),
    [anon_sym___alignof__] = ACTIONS(2846),
    [anon_sym___alignof] = ACTIONS(2846),
    [anon_sym__alignof] = ACTIONS(2846),
    [anon_sym_alignof] = ACTIONS(2846),
    [anon_sym__Alignof] = ACTIONS(2846),
    [anon_sym_offsetof] = ACTIONS(2846),
    [anon_sym__Generic] = ACTIONS(2846),
    [anon_sym_asm] = ACTIONS(2846),
    [anon_sym___asm__] = ACTIONS(2846),
    [anon_sym___asm] = ACTIONS(2846),
    [sym_number_literal] = ACTIONS(2848),
    [anon_sym_L_SQUOTE] = ACTIONS(2848),
    [anon_sym_u_SQUOTE] = ACTIONS(2848),
    [anon_sym_U_SQUOTE] = ACTIONS(2848),
    [anon_sym_u8_SQUOTE] = ACTIONS(2848),
    [anon_sym_SQUOTE] = ACTIONS(2848),
    [anon_sym_L_DQUOTE] = ACTIONS(2848),
    [anon_sym_u_DQUOTE] = ACTIONS(2848),
    [anon_sym_U_DQUOTE] = ACTIONS(2848),
    [anon_sym_u8_DQUOTE] = ACTIONS(2848),
    [anon_sym_DQUOTE] = ACTIONS(2848),
    [sym_true] = ACTIONS(2846),
    [sym_false] = ACTIONS(2846),
    [anon_sym_NULL] = ACTIONS(2846),
    [anon_sym_nullptr] = ACTIONS(2846),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2846),
    [anon_sym_decltype] = ACTIONS(2846),
    [anon_sym_explicit] = ACTIONS(2846),
    [anon_sym_typename] = ACTIONS(2846),
    [anon_sym_template] = ACTIONS(2846),
    [anon_sym_operator] = ACTIONS(2846),
    [anon_sym_try] = ACTIONS(2846),
    [anon_sym_delete] = ACTIONS(2846),
    [anon_sym_throw] = ACTIONS(2846),
    [anon_sym_namespace] = ACTIONS(2846),
    [anon_sym_using] = ACTIONS(2846),
    [anon_sym_static_assert] = ACTIONS(2846),
    [anon_sym_concept] = ACTIONS(2846),
    [anon_sym_co_return] = ACTIONS(2846),
    [anon_sym_co_yield] = ACTIONS(2846),
    [anon_sym_R_DQUOTE] = ACTIONS(2848),
    [anon_sym_LR_DQUOTE] = ACTIONS(2848),
    [anon_sym_uR_DQUOTE] = ACTIONS(2848),
    [anon_sym_UR_DQUOTE] = ACTIONS(2848),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2848),
    [anon_sym_co_await] = ACTIONS(2846),
    [anon_sym_new] = ACTIONS(2846),
    [anon_sym_requires] = ACTIONS(2846),
    [sym_this] = ACTIONS(2846),
  },
  [633] = {
    [sym_identifier] = ACTIONS(3034),
    [aux_sym_preproc_include_token1] = ACTIONS(3034),
    [aux_sym_preproc_def_token1] = ACTIONS(3034),
    [aux_sym_preproc_if_token1] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3034),
    [sym_preproc_directive] = ACTIONS(3034),
    [anon_sym_LPAREN2] = ACTIONS(3036),
    [anon_sym_BANG] = ACTIONS(3036),
    [anon_sym_TILDE] = ACTIONS(3036),
    [anon_sym_DASH] = ACTIONS(3034),
    [anon_sym_PLUS] = ACTIONS(3034),
    [anon_sym_STAR] = ACTIONS(3036),
    [anon_sym_AMP_AMP] = ACTIONS(3036),
    [anon_sym_AMP] = ACTIONS(3034),
    [anon_sym_SEMI] = ACTIONS(3036),
    [anon_sym___extension__] = ACTIONS(3034),
    [anon_sym_typedef] = ACTIONS(3034),
    [anon_sym_virtual] = ACTIONS(3034),
    [anon_sym_extern] = ACTIONS(3034),
    [anon_sym___attribute__] = ACTIONS(3034),
    [anon_sym___attribute] = ACTIONS(3034),
    [anon_sym_COLON_COLON] = ACTIONS(3036),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3036),
    [anon_sym___declspec] = ACTIONS(3034),
    [anon_sym___based] = ACTIONS(3034),
    [anon_sym___cdecl] = ACTIONS(3034),
    [anon_sym___clrcall] = ACTIONS(3034),
    [anon_sym___stdcall] = ACTIONS(3034),
    [anon_sym___fastcall] = ACTIONS(3034),
    [anon_sym___thiscall] = ACTIONS(3034),
    [anon_sym___vectorcall] = ACTIONS(3034),
    [anon_sym_LBRACE] = ACTIONS(3036),
    [anon_sym_RBRACE] = ACTIONS(3036),
    [anon_sym_signed] = ACTIONS(3034),
    [anon_sym_unsigned] = ACTIONS(3034),
    [anon_sym_long] = ACTIONS(3034),
    [anon_sym_short] = ACTIONS(3034),
    [anon_sym_LBRACK] = ACTIONS(3034),
    [anon_sym_static] = ACTIONS(3034),
    [anon_sym_register] = ACTIONS(3034),
    [anon_sym_inline] = ACTIONS(3034),
    [anon_sym___inline] = ACTIONS(3034),
    [anon_sym___inline__] = ACTIONS(3034),
    [anon_sym___forceinline] = ACTIONS(3034),
    [anon_sym_thread_local] = ACTIONS(3034),
    [anon_sym___thread] = ACTIONS(3034),
    [anon_sym_const] = ACTIONS(3034),
    [anon_sym_constexpr] = ACTIONS(3034),
    [anon_sym_volatile] = ACTIONS(3034),
    [anon_sym_restrict] = ACTIONS(3034),
    [anon_sym___restrict__] = ACTIONS(3034),
    [anon_sym__Atomic] = ACTIONS(3034),
    [anon_sym__Noreturn] = ACTIONS(3034),
    [anon_sym_noreturn] = ACTIONS(3034),
    [anon_sym__Nonnull] = ACTIONS(3034),
    [anon_sym_mutable] = ACTIONS(3034),
    [anon_sym_constinit] = ACTIONS(3034),
    [anon_sym_consteval] = ACTIONS(3034),
    [anon_sym_alignas] = ACTIONS(3034),
    [anon_sym__Alignas] = ACTIONS(3034),
    [sym_primitive_type] = ACTIONS(3034),
    [anon_sym_enum] = ACTIONS(3034),
    [anon_sym_class] = ACTIONS(3034),
    [anon_sym_struct] = ACTIONS(3034),
    [anon_sym_union] = ACTIONS(3034),
    [anon_sym_if] = ACTIONS(3034),
    [anon_sym_switch] = ACTIONS(3034),
    [anon_sym_case] = ACTIONS(3034),
    [anon_sym_default] = ACTIONS(3034),
    [anon_sym_while] = ACTIONS(3034),
    [anon_sym_do] = ACTIONS(3034),
    [anon_sym_for] = ACTIONS(3034),
    [anon_sym_return] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3034),
    [anon_sym_continue] = ACTIONS(3034),
    [anon_sym_goto] = ACTIONS(3034),
    [anon_sym___try] = ACTIONS(3034),
    [anon_sym___leave] = ACTIONS(3034),
    [anon_sym_not] = ACTIONS(3034),
    [anon_sym_compl] = ACTIONS(3034),
    [anon_sym_DASH_DASH] = ACTIONS(3036),
    [anon_sym_PLUS_PLUS] = ACTIONS(3036),
    [anon_sym_sizeof] = ACTIONS(3034),
    [anon_sym___alignof__] = ACTIONS(3034),
    [anon_sym___alignof] = ACTIONS(3034),
    [anon_sym__alignof] = ACTIONS(3034),
    [anon_sym_alignof] = ACTIONS(3034),
    [anon_sym__Alignof] = ACTIONS(3034),
    [anon_sym_offsetof] = ACTIONS(3034),
    [anon_sym__Generic] = ACTIONS(3034),
    [anon_sym_asm] = ACTIONS(3034),
    [anon_sym___asm__] = ACTIONS(3034),
    [anon_sym___asm] = ACTIONS(3034),
    [sym_number_literal] = ACTIONS(3036),
    [anon_sym_L_SQUOTE] = ACTIONS(3036),
    [anon_sym_u_SQUOTE] = ACTIONS(3036),
    [anon_sym_U_SQUOTE] = ACTIONS(3036),
    [anon_sym_u8_SQUOTE] = ACTIONS(3036),
    [anon_sym_SQUOTE] = ACTIONS(3036),
    [anon_sym_L_DQUOTE] = ACTIONS(3036),
    [anon_sym_u_DQUOTE] = ACTIONS(3036),
    [anon_sym_U_DQUOTE] = ACTIONS(3036),
    [anon_sym_u8_DQUOTE] = ACTIONS(3036),
    [anon_sym_DQUOTE] = ACTIONS(3036),
    [sym_true] = ACTIONS(3034),
    [sym_false] = ACTIONS(3034),
    [anon_sym_NULL] = ACTIONS(3034),
    [anon_sym_nullptr] = ACTIONS(3034),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3034),
    [anon_sym_decltype] = ACTIONS(3034),
    [anon_sym_explicit] = ACTIONS(3034),
    [anon_sym_typename] = ACTIONS(3034),
    [anon_sym_template] = ACTIONS(3034),
    [anon_sym_operator] = ACTIONS(3034),
    [anon_sym_try] = ACTIONS(3034),
    [anon_sym_delete] = ACTIONS(3034),
    [anon_sym_throw] = ACTIONS(3034),
    [anon_sym_namespace] = ACTIONS(3034),
    [anon_sym_using] = ACTIONS(3034),
    [anon_sym_static_assert] = ACTIONS(3034),
    [anon_sym_concept] = ACTIONS(3034),
    [anon_sym_co_return] = ACTIONS(3034),
    [anon_sym_co_yield] = ACTIONS(3034),
    [anon_sym_R_DQUOTE] = ACTIONS(3036),
    [anon_sym_LR_DQUOTE] = ACTIONS(3036),
    [anon_sym_uR_DQUOTE] = ACTIONS(3036),
    [anon_sym_UR_DQUOTE] = ACTIONS(3036),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3036),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3034),
    [anon_sym_requires] = ACTIONS(3034),
    [sym_this] = ACTIONS(3034),
  },
  [634] = {
    [sym_identifier] = ACTIONS(2932),
    [aux_sym_preproc_include_token1] = ACTIONS(2932),
    [aux_sym_preproc_def_token1] = ACTIONS(2932),
    [aux_sym_preproc_if_token1] = ACTIONS(2932),
    [aux_sym_preproc_if_token2] = ACTIONS(2932),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2932),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2932),
    [sym_preproc_directive] = ACTIONS(2932),
    [anon_sym_LPAREN2] = ACTIONS(2934),
    [anon_sym_BANG] = ACTIONS(2934),
    [anon_sym_TILDE] = ACTIONS(2934),
    [anon_sym_DASH] = ACTIONS(2932),
    [anon_sym_PLUS] = ACTIONS(2932),
    [anon_sym_STAR] = ACTIONS(2934),
    [anon_sym_AMP_AMP] = ACTIONS(2934),
    [anon_sym_AMP] = ACTIONS(2932),
    [anon_sym_SEMI] = ACTIONS(2934),
    [anon_sym___extension__] = ACTIONS(2932),
    [anon_sym_typedef] = ACTIONS(2932),
    [anon_sym_virtual] = ACTIONS(2932),
    [anon_sym_extern] = ACTIONS(2932),
    [anon_sym___attribute__] = ACTIONS(2932),
    [anon_sym___attribute] = ACTIONS(2932),
    [anon_sym_COLON_COLON] = ACTIONS(2934),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2934),
    [anon_sym___declspec] = ACTIONS(2932),
    [anon_sym___based] = ACTIONS(2932),
    [anon_sym___cdecl] = ACTIONS(2932),
    [anon_sym___clrcall] = ACTIONS(2932),
    [anon_sym___stdcall] = ACTIONS(2932),
    [anon_sym___fastcall] = ACTIONS(2932),
    [anon_sym___thiscall] = ACTIONS(2932),
    [anon_sym___vectorcall] = ACTIONS(2932),
    [anon_sym_LBRACE] = ACTIONS(2934),
    [anon_sym_signed] = ACTIONS(2932),
    [anon_sym_unsigned] = ACTIONS(2932),
    [anon_sym_long] = ACTIONS(2932),
    [anon_sym_short] = ACTIONS(2932),
    [anon_sym_LBRACK] = ACTIONS(2932),
    [anon_sym_static] = ACTIONS(2932),
    [anon_sym_register] = ACTIONS(2932),
    [anon_sym_inline] = ACTIONS(2932),
    [anon_sym___inline] = ACTIONS(2932),
    [anon_sym___inline__] = ACTIONS(2932),
    [anon_sym___forceinline] = ACTIONS(2932),
    [anon_sym_thread_local] = ACTIONS(2932),
    [anon_sym___thread] = ACTIONS(2932),
    [anon_sym_const] = ACTIONS(2932),
    [anon_sym_constexpr] = ACTIONS(2932),
    [anon_sym_volatile] = ACTIONS(2932),
    [anon_sym_restrict] = ACTIONS(2932),
    [anon_sym___restrict__] = ACTIONS(2932),
    [anon_sym__Atomic] = ACTIONS(2932),
    [anon_sym__Noreturn] = ACTIONS(2932),
    [anon_sym_noreturn] = ACTIONS(2932),
    [anon_sym__Nonnull] = ACTIONS(2932),
    [anon_sym_mutable] = ACTIONS(2932),
    [anon_sym_constinit] = ACTIONS(2932),
    [anon_sym_consteval] = ACTIONS(2932),
    [anon_sym_alignas] = ACTIONS(2932),
    [anon_sym__Alignas] = ACTIONS(2932),
    [sym_primitive_type] = ACTIONS(2932),
    [anon_sym_enum] = ACTIONS(2932),
    [anon_sym_class] = ACTIONS(2932),
    [anon_sym_struct] = ACTIONS(2932),
    [anon_sym_union] = ACTIONS(2932),
    [anon_sym_if] = ACTIONS(2932),
    [anon_sym_switch] = ACTIONS(2932),
    [anon_sym_case] = ACTIONS(2932),
    [anon_sym_default] = ACTIONS(2932),
    [anon_sym_while] = ACTIONS(2932),
    [anon_sym_do] = ACTIONS(2932),
    [anon_sym_for] = ACTIONS(2932),
    [anon_sym_return] = ACTIONS(2932),
    [anon_sym_break] = ACTIONS(2932),
    [anon_sym_continue] = ACTIONS(2932),
    [anon_sym_goto] = ACTIONS(2932),
    [anon_sym___try] = ACTIONS(2932),
    [anon_sym___leave] = ACTIONS(2932),
    [anon_sym_not] = ACTIONS(2932),
    [anon_sym_compl] = ACTIONS(2932),
    [anon_sym_DASH_DASH] = ACTIONS(2934),
    [anon_sym_PLUS_PLUS] = ACTIONS(2934),
    [anon_sym_sizeof] = ACTIONS(2932),
    [anon_sym___alignof__] = ACTIONS(2932),
    [anon_sym___alignof] = ACTIONS(2932),
    [anon_sym__alignof] = ACTIONS(2932),
    [anon_sym_alignof] = ACTIONS(2932),
    [anon_sym__Alignof] = ACTIONS(2932),
    [anon_sym_offsetof] = ACTIONS(2932),
    [anon_sym__Generic] = ACTIONS(2932),
    [anon_sym_asm] = ACTIONS(2932),
    [anon_sym___asm__] = ACTIONS(2932),
    [anon_sym___asm] = ACTIONS(2932),
    [sym_number_literal] = ACTIONS(2934),
    [anon_sym_L_SQUOTE] = ACTIONS(2934),
    [anon_sym_u_SQUOTE] = ACTIONS(2934),
    [anon_sym_U_SQUOTE] = ACTIONS(2934),
    [anon_sym_u8_SQUOTE] = ACTIONS(2934),
    [anon_sym_SQUOTE] = ACTIONS(2934),
    [anon_sym_L_DQUOTE] = ACTIONS(2934),
    [anon_sym_u_DQUOTE] = ACTIONS(2934),
    [anon_sym_U_DQUOTE] = ACTIONS(2934),
    [anon_sym_u8_DQUOTE] = ACTIONS(2934),
    [anon_sym_DQUOTE] = ACTIONS(2934),
    [sym_true] = ACTIONS(2932),
    [sym_false] = ACTIONS(2932),
    [anon_sym_NULL] = ACTIONS(2932),
    [anon_sym_nullptr] = ACTIONS(2932),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2932),
    [anon_sym_decltype] = ACTIONS(2932),
    [anon_sym_explicit] = ACTIONS(2932),
    [anon_sym_typename] = ACTIONS(2932),
    [anon_sym_template] = ACTIONS(2932),
    [anon_sym_operator] = ACTIONS(2932),
    [anon_sym_try] = ACTIONS(2932),
    [anon_sym_delete] = ACTIONS(2932),
    [anon_sym_throw] = ACTIONS(2932),
    [anon_sym_namespace] = ACTIONS(2932),
    [anon_sym_using] = ACTIONS(2932),
    [anon_sym_static_assert] = ACTIONS(2932),
    [anon_sym_concept] = ACTIONS(2932),
    [anon_sym_co_return] = ACTIONS(2932),
    [anon_sym_co_yield] = ACTIONS(2932),
    [anon_sym_R_DQUOTE] = ACTIONS(2934),
    [anon_sym_LR_DQUOTE] = ACTIONS(2934),
    [anon_sym_uR_DQUOTE] = ACTIONS(2934),
    [anon_sym_UR_DQUOTE] = ACTIONS(2934),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2934),
    [anon_sym_co_await] = ACTIONS(2932),
    [anon_sym_new] = ACTIONS(2932),
    [anon_sym_requires] = ACTIONS(2932),
    [sym_this] = ACTIONS(2932),
  },
  [635] = {
    [sym_identifier] = ACTIONS(2936),
    [aux_sym_preproc_include_token1] = ACTIONS(2936),
    [aux_sym_preproc_def_token1] = ACTIONS(2936),
    [aux_sym_preproc_if_token1] = ACTIONS(2936),
    [aux_sym_preproc_if_token2] = ACTIONS(2936),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2936),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2936),
    [sym_preproc_directive] = ACTIONS(2936),
    [anon_sym_LPAREN2] = ACTIONS(2938),
    [anon_sym_BANG] = ACTIONS(2938),
    [anon_sym_TILDE] = ACTIONS(2938),
    [anon_sym_DASH] = ACTIONS(2936),
    [anon_sym_PLUS] = ACTIONS(2936),
    [anon_sym_STAR] = ACTIONS(2938),
    [anon_sym_AMP_AMP] = ACTIONS(2938),
    [anon_sym_AMP] = ACTIONS(2936),
    [anon_sym_SEMI] = ACTIONS(2938),
    [anon_sym___extension__] = ACTIONS(2936),
    [anon_sym_typedef] = ACTIONS(2936),
    [anon_sym_virtual] = ACTIONS(2936),
    [anon_sym_extern] = ACTIONS(2936),
    [anon_sym___attribute__] = ACTIONS(2936),
    [anon_sym___attribute] = ACTIONS(2936),
    [anon_sym_COLON_COLON] = ACTIONS(2938),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2938),
    [anon_sym___declspec] = ACTIONS(2936),
    [anon_sym___based] = ACTIONS(2936),
    [anon_sym___cdecl] = ACTIONS(2936),
    [anon_sym___clrcall] = ACTIONS(2936),
    [anon_sym___stdcall] = ACTIONS(2936),
    [anon_sym___fastcall] = ACTIONS(2936),
    [anon_sym___thiscall] = ACTIONS(2936),
    [anon_sym___vectorcall] = ACTIONS(2936),
    [anon_sym_LBRACE] = ACTIONS(2938),
    [anon_sym_signed] = ACTIONS(2936),
    [anon_sym_unsigned] = ACTIONS(2936),
    [anon_sym_long] = ACTIONS(2936),
    [anon_sym_short] = ACTIONS(2936),
    [anon_sym_LBRACK] = ACTIONS(2936),
    [anon_sym_static] = ACTIONS(2936),
    [anon_sym_register] = ACTIONS(2936),
    [anon_sym_inline] = ACTIONS(2936),
    [anon_sym___inline] = ACTIONS(2936),
    [anon_sym___inline__] = ACTIONS(2936),
    [anon_sym___forceinline] = ACTIONS(2936),
    [anon_sym_thread_local] = ACTIONS(2936),
    [anon_sym___thread] = ACTIONS(2936),
    [anon_sym_const] = ACTIONS(2936),
    [anon_sym_constexpr] = ACTIONS(2936),
    [anon_sym_volatile] = ACTIONS(2936),
    [anon_sym_restrict] = ACTIONS(2936),
    [anon_sym___restrict__] = ACTIONS(2936),
    [anon_sym__Atomic] = ACTIONS(2936),
    [anon_sym__Noreturn] = ACTIONS(2936),
    [anon_sym_noreturn] = ACTIONS(2936),
    [anon_sym__Nonnull] = ACTIONS(2936),
    [anon_sym_mutable] = ACTIONS(2936),
    [anon_sym_constinit] = ACTIONS(2936),
    [anon_sym_consteval] = ACTIONS(2936),
    [anon_sym_alignas] = ACTIONS(2936),
    [anon_sym__Alignas] = ACTIONS(2936),
    [sym_primitive_type] = ACTIONS(2936),
    [anon_sym_enum] = ACTIONS(2936),
    [anon_sym_class] = ACTIONS(2936),
    [anon_sym_struct] = ACTIONS(2936),
    [anon_sym_union] = ACTIONS(2936),
    [anon_sym_if] = ACTIONS(2936),
    [anon_sym_switch] = ACTIONS(2936),
    [anon_sym_case] = ACTIONS(2936),
    [anon_sym_default] = ACTIONS(2936),
    [anon_sym_while] = ACTIONS(2936),
    [anon_sym_do] = ACTIONS(2936),
    [anon_sym_for] = ACTIONS(2936),
    [anon_sym_return] = ACTIONS(2936),
    [anon_sym_break] = ACTIONS(2936),
    [anon_sym_continue] = ACTIONS(2936),
    [anon_sym_goto] = ACTIONS(2936),
    [anon_sym___try] = ACTIONS(2936),
    [anon_sym___leave] = ACTIONS(2936),
    [anon_sym_not] = ACTIONS(2936),
    [anon_sym_compl] = ACTIONS(2936),
    [anon_sym_DASH_DASH] = ACTIONS(2938),
    [anon_sym_PLUS_PLUS] = ACTIONS(2938),
    [anon_sym_sizeof] = ACTIONS(2936),
    [anon_sym___alignof__] = ACTIONS(2936),
    [anon_sym___alignof] = ACTIONS(2936),
    [anon_sym__alignof] = ACTIONS(2936),
    [anon_sym_alignof] = ACTIONS(2936),
    [anon_sym__Alignof] = ACTIONS(2936),
    [anon_sym_offsetof] = ACTIONS(2936),
    [anon_sym__Generic] = ACTIONS(2936),
    [anon_sym_asm] = ACTIONS(2936),
    [anon_sym___asm__] = ACTIONS(2936),
    [anon_sym___asm] = ACTIONS(2936),
    [sym_number_literal] = ACTIONS(2938),
    [anon_sym_L_SQUOTE] = ACTIONS(2938),
    [anon_sym_u_SQUOTE] = ACTIONS(2938),
    [anon_sym_U_SQUOTE] = ACTIONS(2938),
    [anon_sym_u8_SQUOTE] = ACTIONS(2938),
    [anon_sym_SQUOTE] = ACTIONS(2938),
    [anon_sym_L_DQUOTE] = ACTIONS(2938),
    [anon_sym_u_DQUOTE] = ACTIONS(2938),
    [anon_sym_U_DQUOTE] = ACTIONS(2938),
    [anon_sym_u8_DQUOTE] = ACTIONS(2938),
    [anon_sym_DQUOTE] = ACTIONS(2938),
    [sym_true] = ACTIONS(2936),
    [sym_false] = ACTIONS(2936),
    [anon_sym_NULL] = ACTIONS(2936),
    [anon_sym_nullptr] = ACTIONS(2936),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2936),
    [anon_sym_decltype] = ACTIONS(2936),
    [anon_sym_explicit] = ACTIONS(2936),
    [anon_sym_typename] = ACTIONS(2936),
    [anon_sym_template] = ACTIONS(2936),
    [anon_sym_operator] = ACTIONS(2936),
    [anon_sym_try] = ACTIONS(2936),
    [anon_sym_delete] = ACTIONS(2936),
    [anon_sym_throw] = ACTIONS(2936),
    [anon_sym_namespace] = ACTIONS(2936),
    [anon_sym_using] = ACTIONS(2936),
    [anon_sym_static_assert] = ACTIONS(2936),
    [anon_sym_concept] = ACTIONS(2936),
    [anon_sym_co_return] = ACTIONS(2936),
    [anon_sym_co_yield] = ACTIONS(2936),
    [anon_sym_R_DQUOTE] = ACTIONS(2938),
    [anon_sym_LR_DQUOTE] = ACTIONS(2938),
    [anon_sym_uR_DQUOTE] = ACTIONS(2938),
    [anon_sym_UR_DQUOTE] = ACTIONS(2938),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2938),
    [anon_sym_co_await] = ACTIONS(2936),
    [anon_sym_new] = ACTIONS(2936),
    [anon_sym_requires] = ACTIONS(2936),
    [sym_this] = ACTIONS(2936),
  },
  [636] = {
    [sym_identifier] = ACTIONS(3013),
    [aux_sym_preproc_include_token1] = ACTIONS(3013),
    [aux_sym_preproc_def_token1] = ACTIONS(3013),
    [aux_sym_preproc_if_token1] = ACTIONS(3013),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3013),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3013),
    [sym_preproc_directive] = ACTIONS(3013),
    [anon_sym_LPAREN2] = ACTIONS(3015),
    [anon_sym_BANG] = ACTIONS(3015),
    [anon_sym_TILDE] = ACTIONS(3015),
    [anon_sym_DASH] = ACTIONS(3013),
    [anon_sym_PLUS] = ACTIONS(3013),
    [anon_sym_STAR] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3015),
    [anon_sym_AMP] = ACTIONS(3013),
    [anon_sym_SEMI] = ACTIONS(3015),
    [anon_sym___extension__] = ACTIONS(3013),
    [anon_sym_typedef] = ACTIONS(3013),
    [anon_sym_virtual] = ACTIONS(3013),
    [anon_sym_extern] = ACTIONS(3013),
    [anon_sym___attribute__] = ACTIONS(3013),
    [anon_sym___attribute] = ACTIONS(3013),
    [anon_sym_COLON_COLON] = ACTIONS(3015),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3015),
    [anon_sym___declspec] = ACTIONS(3013),
    [anon_sym___based] = ACTIONS(3013),
    [anon_sym___cdecl] = ACTIONS(3013),
    [anon_sym___clrcall] = ACTIONS(3013),
    [anon_sym___stdcall] = ACTIONS(3013),
    [anon_sym___fastcall] = ACTIONS(3013),
    [anon_sym___thiscall] = ACTIONS(3013),
    [anon_sym___vectorcall] = ACTIONS(3013),
    [anon_sym_LBRACE] = ACTIONS(3015),
    [anon_sym_RBRACE] = ACTIONS(3015),
    [anon_sym_signed] = ACTIONS(3013),
    [anon_sym_unsigned] = ACTIONS(3013),
    [anon_sym_long] = ACTIONS(3013),
    [anon_sym_short] = ACTIONS(3013),
    [anon_sym_LBRACK] = ACTIONS(3013),
    [anon_sym_static] = ACTIONS(3013),
    [anon_sym_register] = ACTIONS(3013),
    [anon_sym_inline] = ACTIONS(3013),
    [anon_sym___inline] = ACTIONS(3013),
    [anon_sym___inline__] = ACTIONS(3013),
    [anon_sym___forceinline] = ACTIONS(3013),
    [anon_sym_thread_local] = ACTIONS(3013),
    [anon_sym___thread] = ACTIONS(3013),
    [anon_sym_const] = ACTIONS(3013),
    [anon_sym_constexpr] = ACTIONS(3013),
    [anon_sym_volatile] = ACTIONS(3013),
    [anon_sym_restrict] = ACTIONS(3013),
    [anon_sym___restrict__] = ACTIONS(3013),
    [anon_sym__Atomic] = ACTIONS(3013),
    [anon_sym__Noreturn] = ACTIONS(3013),
    [anon_sym_noreturn] = ACTIONS(3013),
    [anon_sym__Nonnull] = ACTIONS(3013),
    [anon_sym_mutable] = ACTIONS(3013),
    [anon_sym_constinit] = ACTIONS(3013),
    [anon_sym_consteval] = ACTIONS(3013),
    [anon_sym_alignas] = ACTIONS(3013),
    [anon_sym__Alignas] = ACTIONS(3013),
    [sym_primitive_type] = ACTIONS(3013),
    [anon_sym_enum] = ACTIONS(3013),
    [anon_sym_class] = ACTIONS(3013),
    [anon_sym_struct] = ACTIONS(3013),
    [anon_sym_union] = ACTIONS(3013),
    [anon_sym_if] = ACTIONS(3013),
    [anon_sym_switch] = ACTIONS(3013),
    [anon_sym_case] = ACTIONS(3013),
    [anon_sym_default] = ACTIONS(3013),
    [anon_sym_while] = ACTIONS(3013),
    [anon_sym_do] = ACTIONS(3013),
    [anon_sym_for] = ACTIONS(3013),
    [anon_sym_return] = ACTIONS(3013),
    [anon_sym_break] = ACTIONS(3013),
    [anon_sym_continue] = ACTIONS(3013),
    [anon_sym_goto] = ACTIONS(3013),
    [anon_sym___try] = ACTIONS(3013),
    [anon_sym___leave] = ACTIONS(3013),
    [anon_sym_not] = ACTIONS(3013),
    [anon_sym_compl] = ACTIONS(3013),
    [anon_sym_DASH_DASH] = ACTIONS(3015),
    [anon_sym_PLUS_PLUS] = ACTIONS(3015),
    [anon_sym_sizeof] = ACTIONS(3013),
    [anon_sym___alignof__] = ACTIONS(3013),
    [anon_sym___alignof] = ACTIONS(3013),
    [anon_sym__alignof] = ACTIONS(3013),
    [anon_sym_alignof] = ACTIONS(3013),
    [anon_sym__Alignof] = ACTIONS(3013),
    [anon_sym_offsetof] = ACTIONS(3013),
    [anon_sym__Generic] = ACTIONS(3013),
    [anon_sym_asm] = ACTIONS(3013),
    [anon_sym___asm__] = ACTIONS(3013),
    [anon_sym___asm] = ACTIONS(3013),
    [sym_number_literal] = ACTIONS(3015),
    [anon_sym_L_SQUOTE] = ACTIONS(3015),
    [anon_sym_u_SQUOTE] = ACTIONS(3015),
    [anon_sym_U_SQUOTE] = ACTIONS(3015),
    [anon_sym_u8_SQUOTE] = ACTIONS(3015),
    [anon_sym_SQUOTE] = ACTIONS(3015),
    [anon_sym_L_DQUOTE] = ACTIONS(3015),
    [anon_sym_u_DQUOTE] = ACTIONS(3015),
    [anon_sym_U_DQUOTE] = ACTIONS(3015),
    [anon_sym_u8_DQUOTE] = ACTIONS(3015),
    [anon_sym_DQUOTE] = ACTIONS(3015),
    [sym_true] = ACTIONS(3013),
    [sym_false] = ACTIONS(3013),
    [anon_sym_NULL] = ACTIONS(3013),
    [anon_sym_nullptr] = ACTIONS(3013),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3013),
    [anon_sym_decltype] = ACTIONS(3013),
    [anon_sym_explicit] = ACTIONS(3013),
    [anon_sym_typename] = ACTIONS(3013),
    [anon_sym_template] = ACTIONS(3013),
    [anon_sym_operator] = ACTIONS(3013),
    [anon_sym_try] = ACTIONS(3013),
    [anon_sym_delete] = ACTIONS(3013),
    [anon_sym_throw] = ACTIONS(3013),
    [anon_sym_namespace] = ACTIONS(3013),
    [anon_sym_using] = ACTIONS(3013),
    [anon_sym_static_assert] = ACTIONS(3013),
    [anon_sym_concept] = ACTIONS(3013),
    [anon_sym_co_return] = ACTIONS(3013),
    [anon_sym_co_yield] = ACTIONS(3013),
    [anon_sym_R_DQUOTE] = ACTIONS(3015),
    [anon_sym_LR_DQUOTE] = ACTIONS(3015),
    [anon_sym_uR_DQUOTE] = ACTIONS(3015),
    [anon_sym_UR_DQUOTE] = ACTIONS(3015),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3015),
    [anon_sym_co_await] = ACTIONS(3013),
    [anon_sym_new] = ACTIONS(3013),
    [anon_sym_requires] = ACTIONS(3013),
    [sym_this] = ACTIONS(3013),
  },
  [637] = {
    [sym_identifier] = ACTIONS(2850),
    [aux_sym_preproc_include_token1] = ACTIONS(2850),
    [aux_sym_preproc_def_token1] = ACTIONS(2850),
    [aux_sym_preproc_if_token1] = ACTIONS(2850),
    [aux_sym_preproc_if_token2] = ACTIONS(2850),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2850),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2850),
    [sym_preproc_directive] = ACTIONS(2850),
    [anon_sym_LPAREN2] = ACTIONS(2852),
    [anon_sym_BANG] = ACTIONS(2852),
    [anon_sym_TILDE] = ACTIONS(2852),
    [anon_sym_DASH] = ACTIONS(2850),
    [anon_sym_PLUS] = ACTIONS(2850),
    [anon_sym_STAR] = ACTIONS(2852),
    [anon_sym_AMP_AMP] = ACTIONS(2852),
    [anon_sym_AMP] = ACTIONS(2850),
    [anon_sym_SEMI] = ACTIONS(2852),
    [anon_sym___extension__] = ACTIONS(2850),
    [anon_sym_typedef] = ACTIONS(2850),
    [anon_sym_virtual] = ACTIONS(2850),
    [anon_sym_extern] = ACTIONS(2850),
    [anon_sym___attribute__] = ACTIONS(2850),
    [anon_sym___attribute] = ACTIONS(2850),
    [anon_sym_COLON_COLON] = ACTIONS(2852),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2852),
    [anon_sym___declspec] = ACTIONS(2850),
    [anon_sym___based] = ACTIONS(2850),
    [anon_sym___cdecl] = ACTIONS(2850),
    [anon_sym___clrcall] = ACTIONS(2850),
    [anon_sym___stdcall] = ACTIONS(2850),
    [anon_sym___fastcall] = ACTIONS(2850),
    [anon_sym___thiscall] = ACTIONS(2850),
    [anon_sym___vectorcall] = ACTIONS(2850),
    [anon_sym_LBRACE] = ACTIONS(2852),
    [anon_sym_signed] = ACTIONS(2850),
    [anon_sym_unsigned] = ACTIONS(2850),
    [anon_sym_long] = ACTIONS(2850),
    [anon_sym_short] = ACTIONS(2850),
    [anon_sym_LBRACK] = ACTIONS(2850),
    [anon_sym_static] = ACTIONS(2850),
    [anon_sym_register] = ACTIONS(2850),
    [anon_sym_inline] = ACTIONS(2850),
    [anon_sym___inline] = ACTIONS(2850),
    [anon_sym___inline__] = ACTIONS(2850),
    [anon_sym___forceinline] = ACTIONS(2850),
    [anon_sym_thread_local] = ACTIONS(2850),
    [anon_sym___thread] = ACTIONS(2850),
    [anon_sym_const] = ACTIONS(2850),
    [anon_sym_constexpr] = ACTIONS(2850),
    [anon_sym_volatile] = ACTIONS(2850),
    [anon_sym_restrict] = ACTIONS(2850),
    [anon_sym___restrict__] = ACTIONS(2850),
    [anon_sym__Atomic] = ACTIONS(2850),
    [anon_sym__Noreturn] = ACTIONS(2850),
    [anon_sym_noreturn] = ACTIONS(2850),
    [anon_sym__Nonnull] = ACTIONS(2850),
    [anon_sym_mutable] = ACTIONS(2850),
    [anon_sym_constinit] = ACTIONS(2850),
    [anon_sym_consteval] = ACTIONS(2850),
    [anon_sym_alignas] = ACTIONS(2850),
    [anon_sym__Alignas] = ACTIONS(2850),
    [sym_primitive_type] = ACTIONS(2850),
    [anon_sym_enum] = ACTIONS(2850),
    [anon_sym_class] = ACTIONS(2850),
    [anon_sym_struct] = ACTIONS(2850),
    [anon_sym_union] = ACTIONS(2850),
    [anon_sym_if] = ACTIONS(2850),
    [anon_sym_switch] = ACTIONS(2850),
    [anon_sym_case] = ACTIONS(2850),
    [anon_sym_default] = ACTIONS(2850),
    [anon_sym_while] = ACTIONS(2850),
    [anon_sym_do] = ACTIONS(2850),
    [anon_sym_for] = ACTIONS(2850),
    [anon_sym_return] = ACTIONS(2850),
    [anon_sym_break] = ACTIONS(2850),
    [anon_sym_continue] = ACTIONS(2850),
    [anon_sym_goto] = ACTIONS(2850),
    [anon_sym___try] = ACTIONS(2850),
    [anon_sym___leave] = ACTIONS(2850),
    [anon_sym_not] = ACTIONS(2850),
    [anon_sym_compl] = ACTIONS(2850),
    [anon_sym_DASH_DASH] = ACTIONS(2852),
    [anon_sym_PLUS_PLUS] = ACTIONS(2852),
    [anon_sym_sizeof] = ACTIONS(2850),
    [anon_sym___alignof__] = ACTIONS(2850),
    [anon_sym___alignof] = ACTIONS(2850),
    [anon_sym__alignof] = ACTIONS(2850),
    [anon_sym_alignof] = ACTIONS(2850),
    [anon_sym__Alignof] = ACTIONS(2850),
    [anon_sym_offsetof] = ACTIONS(2850),
    [anon_sym__Generic] = ACTIONS(2850),
    [anon_sym_asm] = ACTIONS(2850),
    [anon_sym___asm__] = ACTIONS(2850),
    [anon_sym___asm] = ACTIONS(2850),
    [sym_number_literal] = ACTIONS(2852),
    [anon_sym_L_SQUOTE] = ACTIONS(2852),
    [anon_sym_u_SQUOTE] = ACTIONS(2852),
    [anon_sym_U_SQUOTE] = ACTIONS(2852),
    [anon_sym_u8_SQUOTE] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2852),
    [anon_sym_L_DQUOTE] = ACTIONS(2852),
    [anon_sym_u_DQUOTE] = ACTIONS(2852),
    [anon_sym_U_DQUOTE] = ACTIONS(2852),
    [anon_sym_u8_DQUOTE] = ACTIONS(2852),
    [anon_sym_DQUOTE] = ACTIONS(2852),
    [sym_true] = ACTIONS(2850),
    [sym_false] = ACTIONS(2850),
    [anon_sym_NULL] = ACTIONS(2850),
    [anon_sym_nullptr] = ACTIONS(2850),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2850),
    [anon_sym_decltype] = ACTIONS(2850),
    [anon_sym_explicit] = ACTIONS(2850),
    [anon_sym_typename] = ACTIONS(2850),
    [anon_sym_template] = ACTIONS(2850),
    [anon_sym_operator] = ACTIONS(2850),
    [anon_sym_try] = ACTIONS(2850),
    [anon_sym_delete] = ACTIONS(2850),
    [anon_sym_throw] = ACTIONS(2850),
    [anon_sym_namespace] = ACTIONS(2850),
    [anon_sym_using] = ACTIONS(2850),
    [anon_sym_static_assert] = ACTIONS(2850),
    [anon_sym_concept] = ACTIONS(2850),
    [anon_sym_co_return] = ACTIONS(2850),
    [anon_sym_co_yield] = ACTIONS(2850),
    [anon_sym_R_DQUOTE] = ACTIONS(2852),
    [anon_sym_LR_DQUOTE] = ACTIONS(2852),
    [anon_sym_uR_DQUOTE] = ACTIONS(2852),
    [anon_sym_UR_DQUOTE] = ACTIONS(2852),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2852),
    [anon_sym_co_await] = ACTIONS(2850),
    [anon_sym_new] = ACTIONS(2850),
    [anon_sym_requires] = ACTIONS(2850),
    [sym_this] = ACTIONS(2850),
  },
  [638] = {
    [sym_identifier] = ACTIONS(2928),
    [aux_sym_preproc_include_token1] = ACTIONS(2928),
    [aux_sym_preproc_def_token1] = ACTIONS(2928),
    [aux_sym_preproc_if_token1] = ACTIONS(2928),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2928),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2928),
    [sym_preproc_directive] = ACTIONS(2928),
    [anon_sym_LPAREN2] = ACTIONS(2930),
    [anon_sym_BANG] = ACTIONS(2930),
    [anon_sym_TILDE] = ACTIONS(2930),
    [anon_sym_DASH] = ACTIONS(2928),
    [anon_sym_PLUS] = ACTIONS(2928),
    [anon_sym_STAR] = ACTIONS(2930),
    [anon_sym_AMP_AMP] = ACTIONS(2930),
    [anon_sym_AMP] = ACTIONS(2928),
    [anon_sym_SEMI] = ACTIONS(2930),
    [anon_sym___extension__] = ACTIONS(2928),
    [anon_sym_typedef] = ACTIONS(2928),
    [anon_sym_virtual] = ACTIONS(2928),
    [anon_sym_extern] = ACTIONS(2928),
    [anon_sym___attribute__] = ACTIONS(2928),
    [anon_sym___attribute] = ACTIONS(2928),
    [anon_sym_COLON_COLON] = ACTIONS(2930),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2930),
    [anon_sym___declspec] = ACTIONS(2928),
    [anon_sym___based] = ACTIONS(2928),
    [anon_sym___cdecl] = ACTIONS(2928),
    [anon_sym___clrcall] = ACTIONS(2928),
    [anon_sym___stdcall] = ACTIONS(2928),
    [anon_sym___fastcall] = ACTIONS(2928),
    [anon_sym___thiscall] = ACTIONS(2928),
    [anon_sym___vectorcall] = ACTIONS(2928),
    [anon_sym_LBRACE] = ACTIONS(2930),
    [anon_sym_RBRACE] = ACTIONS(2930),
    [anon_sym_signed] = ACTIONS(2928),
    [anon_sym_unsigned] = ACTIONS(2928),
    [anon_sym_long] = ACTIONS(2928),
    [anon_sym_short] = ACTIONS(2928),
    [anon_sym_LBRACK] = ACTIONS(2928),
    [anon_sym_static] = ACTIONS(2928),
    [anon_sym_register] = ACTIONS(2928),
    [anon_sym_inline] = ACTIONS(2928),
    [anon_sym___inline] = ACTIONS(2928),
    [anon_sym___inline__] = ACTIONS(2928),
    [anon_sym___forceinline] = ACTIONS(2928),
    [anon_sym_thread_local] = ACTIONS(2928),
    [anon_sym___thread] = ACTIONS(2928),
    [anon_sym_const] = ACTIONS(2928),
    [anon_sym_constexpr] = ACTIONS(2928),
    [anon_sym_volatile] = ACTIONS(2928),
    [anon_sym_restrict] = ACTIONS(2928),
    [anon_sym___restrict__] = ACTIONS(2928),
    [anon_sym__Atomic] = ACTIONS(2928),
    [anon_sym__Noreturn] = ACTIONS(2928),
    [anon_sym_noreturn] = ACTIONS(2928),
    [anon_sym__Nonnull] = ACTIONS(2928),
    [anon_sym_mutable] = ACTIONS(2928),
    [anon_sym_constinit] = ACTIONS(2928),
    [anon_sym_consteval] = ACTIONS(2928),
    [anon_sym_alignas] = ACTIONS(2928),
    [anon_sym__Alignas] = ACTIONS(2928),
    [sym_primitive_type] = ACTIONS(2928),
    [anon_sym_enum] = ACTIONS(2928),
    [anon_sym_class] = ACTIONS(2928),
    [anon_sym_struct] = ACTIONS(2928),
    [anon_sym_union] = ACTIONS(2928),
    [anon_sym_if] = ACTIONS(2928),
    [anon_sym_switch] = ACTIONS(2928),
    [anon_sym_case] = ACTIONS(2928),
    [anon_sym_default] = ACTIONS(2928),
    [anon_sym_while] = ACTIONS(2928),
    [anon_sym_do] = ACTIONS(2928),
    [anon_sym_for] = ACTIONS(2928),
    [anon_sym_return] = ACTIONS(2928),
    [anon_sym_break] = ACTIONS(2928),
    [anon_sym_continue] = ACTIONS(2928),
    [anon_sym_goto] = ACTIONS(2928),
    [anon_sym___try] = ACTIONS(2928),
    [anon_sym___leave] = ACTIONS(2928),
    [anon_sym_not] = ACTIONS(2928),
    [anon_sym_compl] = ACTIONS(2928),
    [anon_sym_DASH_DASH] = ACTIONS(2930),
    [anon_sym_PLUS_PLUS] = ACTIONS(2930),
    [anon_sym_sizeof] = ACTIONS(2928),
    [anon_sym___alignof__] = ACTIONS(2928),
    [anon_sym___alignof] = ACTIONS(2928),
    [anon_sym__alignof] = ACTIONS(2928),
    [anon_sym_alignof] = ACTIONS(2928),
    [anon_sym__Alignof] = ACTIONS(2928),
    [anon_sym_offsetof] = ACTIONS(2928),
    [anon_sym__Generic] = ACTIONS(2928),
    [anon_sym_asm] = ACTIONS(2928),
    [anon_sym___asm__] = ACTIONS(2928),
    [anon_sym___asm] = ACTIONS(2928),
    [sym_number_literal] = ACTIONS(2930),
    [anon_sym_L_SQUOTE] = ACTIONS(2930),
    [anon_sym_u_SQUOTE] = ACTIONS(2930),
    [anon_sym_U_SQUOTE] = ACTIONS(2930),
    [anon_sym_u8_SQUOTE] = ACTIONS(2930),
    [anon_sym_SQUOTE] = ACTIONS(2930),
    [anon_sym_L_DQUOTE] = ACTIONS(2930),
    [anon_sym_u_DQUOTE] = ACTIONS(2930),
    [anon_sym_U_DQUOTE] = ACTIONS(2930),
    [anon_sym_u8_DQUOTE] = ACTIONS(2930),
    [anon_sym_DQUOTE] = ACTIONS(2930),
    [sym_true] = ACTIONS(2928),
    [sym_false] = ACTIONS(2928),
    [anon_sym_NULL] = ACTIONS(2928),
    [anon_sym_nullptr] = ACTIONS(2928),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2928),
    [anon_sym_decltype] = ACTIONS(2928),
    [anon_sym_explicit] = ACTIONS(2928),
    [anon_sym_typename] = ACTIONS(2928),
    [anon_sym_template] = ACTIONS(2928),
    [anon_sym_operator] = ACTIONS(2928),
    [anon_sym_try] = ACTIONS(2928),
    [anon_sym_delete] = ACTIONS(2928),
    [anon_sym_throw] = ACTIONS(2928),
    [anon_sym_namespace] = ACTIONS(2928),
    [anon_sym_using] = ACTIONS(2928),
    [anon_sym_static_assert] = ACTIONS(2928),
    [anon_sym_concept] = ACTIONS(2928),
    [anon_sym_co_return] = ACTIONS(2928),
    [anon_sym_co_yield] = ACTIONS(2928),
    [anon_sym_R_DQUOTE] = ACTIONS(2930),
    [anon_sym_LR_DQUOTE] = ACTIONS(2930),
    [anon_sym_uR_DQUOTE] = ACTIONS(2930),
    [anon_sym_UR_DQUOTE] = ACTIONS(2930),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2930),
    [anon_sym_co_await] = ACTIONS(2928),
    [anon_sym_new] = ACTIONS(2928),
    [anon_sym_requires] = ACTIONS(2928),
    [sym_this] = ACTIONS(2928),
  },
  [639] = {
    [sym_identifier] = ACTIONS(3020),
    [aux_sym_preproc_include_token1] = ACTIONS(3020),
    [aux_sym_preproc_def_token1] = ACTIONS(3020),
    [aux_sym_preproc_if_token1] = ACTIONS(3020),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3020),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3020),
    [sym_preproc_directive] = ACTIONS(3020),
    [anon_sym_LPAREN2] = ACTIONS(3022),
    [anon_sym_BANG] = ACTIONS(3022),
    [anon_sym_TILDE] = ACTIONS(3022),
    [anon_sym_DASH] = ACTIONS(3020),
    [anon_sym_PLUS] = ACTIONS(3020),
    [anon_sym_STAR] = ACTIONS(3022),
    [anon_sym_AMP_AMP] = ACTIONS(3022),
    [anon_sym_AMP] = ACTIONS(3020),
    [anon_sym_SEMI] = ACTIONS(3022),
    [anon_sym___extension__] = ACTIONS(3020),
    [anon_sym_typedef] = ACTIONS(3020),
    [anon_sym_virtual] = ACTIONS(3020),
    [anon_sym_extern] = ACTIONS(3020),
    [anon_sym___attribute__] = ACTIONS(3020),
    [anon_sym___attribute] = ACTIONS(3020),
    [anon_sym_COLON_COLON] = ACTIONS(3022),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3022),
    [anon_sym___declspec] = ACTIONS(3020),
    [anon_sym___based] = ACTIONS(3020),
    [anon_sym___cdecl] = ACTIONS(3020),
    [anon_sym___clrcall] = ACTIONS(3020),
    [anon_sym___stdcall] = ACTIONS(3020),
    [anon_sym___fastcall] = ACTIONS(3020),
    [anon_sym___thiscall] = ACTIONS(3020),
    [anon_sym___vectorcall] = ACTIONS(3020),
    [anon_sym_LBRACE] = ACTIONS(3022),
    [anon_sym_RBRACE] = ACTIONS(3022),
    [anon_sym_signed] = ACTIONS(3020),
    [anon_sym_unsigned] = ACTIONS(3020),
    [anon_sym_long] = ACTIONS(3020),
    [anon_sym_short] = ACTIONS(3020),
    [anon_sym_LBRACK] = ACTIONS(3020),
    [anon_sym_static] = ACTIONS(3020),
    [anon_sym_register] = ACTIONS(3020),
    [anon_sym_inline] = ACTIONS(3020),
    [anon_sym___inline] = ACTIONS(3020),
    [anon_sym___inline__] = ACTIONS(3020),
    [anon_sym___forceinline] = ACTIONS(3020),
    [anon_sym_thread_local] = ACTIONS(3020),
    [anon_sym___thread] = ACTIONS(3020),
    [anon_sym_const] = ACTIONS(3020),
    [anon_sym_constexpr] = ACTIONS(3020),
    [anon_sym_volatile] = ACTIONS(3020),
    [anon_sym_restrict] = ACTIONS(3020),
    [anon_sym___restrict__] = ACTIONS(3020),
    [anon_sym__Atomic] = ACTIONS(3020),
    [anon_sym__Noreturn] = ACTIONS(3020),
    [anon_sym_noreturn] = ACTIONS(3020),
    [anon_sym__Nonnull] = ACTIONS(3020),
    [anon_sym_mutable] = ACTIONS(3020),
    [anon_sym_constinit] = ACTIONS(3020),
    [anon_sym_consteval] = ACTIONS(3020),
    [anon_sym_alignas] = ACTIONS(3020),
    [anon_sym__Alignas] = ACTIONS(3020),
    [sym_primitive_type] = ACTIONS(3020),
    [anon_sym_enum] = ACTIONS(3020),
    [anon_sym_class] = ACTIONS(3020),
    [anon_sym_struct] = ACTIONS(3020),
    [anon_sym_union] = ACTIONS(3020),
    [anon_sym_if] = ACTIONS(3020),
    [anon_sym_switch] = ACTIONS(3020),
    [anon_sym_case] = ACTIONS(3020),
    [anon_sym_default] = ACTIONS(3020),
    [anon_sym_while] = ACTIONS(3020),
    [anon_sym_do] = ACTIONS(3020),
    [anon_sym_for] = ACTIONS(3020),
    [anon_sym_return] = ACTIONS(3020),
    [anon_sym_break] = ACTIONS(3020),
    [anon_sym_continue] = ACTIONS(3020),
    [anon_sym_goto] = ACTIONS(3020),
    [anon_sym___try] = ACTIONS(3020),
    [anon_sym___leave] = ACTIONS(3020),
    [anon_sym_not] = ACTIONS(3020),
    [anon_sym_compl] = ACTIONS(3020),
    [anon_sym_DASH_DASH] = ACTIONS(3022),
    [anon_sym_PLUS_PLUS] = ACTIONS(3022),
    [anon_sym_sizeof] = ACTIONS(3020),
    [anon_sym___alignof__] = ACTIONS(3020),
    [anon_sym___alignof] = ACTIONS(3020),
    [anon_sym__alignof] = ACTIONS(3020),
    [anon_sym_alignof] = ACTIONS(3020),
    [anon_sym__Alignof] = ACTIONS(3020),
    [anon_sym_offsetof] = ACTIONS(3020),
    [anon_sym__Generic] = ACTIONS(3020),
    [anon_sym_asm] = ACTIONS(3020),
    [anon_sym___asm__] = ACTIONS(3020),
    [anon_sym___asm] = ACTIONS(3020),
    [sym_number_literal] = ACTIONS(3022),
    [anon_sym_L_SQUOTE] = ACTIONS(3022),
    [anon_sym_u_SQUOTE] = ACTIONS(3022),
    [anon_sym_U_SQUOTE] = ACTIONS(3022),
    [anon_sym_u8_SQUOTE] = ACTIONS(3022),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [anon_sym_L_DQUOTE] = ACTIONS(3022),
    [anon_sym_u_DQUOTE] = ACTIONS(3022),
    [anon_sym_U_DQUOTE] = ACTIONS(3022),
    [anon_sym_u8_DQUOTE] = ACTIONS(3022),
    [anon_sym_DQUOTE] = ACTIONS(3022),
    [sym_true] = ACTIONS(3020),
    [sym_false] = ACTIONS(3020),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3020),
    [anon_sym_decltype] = ACTIONS(3020),
    [anon_sym_explicit] = ACTIONS(3020),
    [anon_sym_typename] = ACTIONS(3020),
    [anon_sym_template] = ACTIONS(3020),
    [anon_sym_operator] = ACTIONS(3020),
    [anon_sym_try] = ACTIONS(3020),
    [anon_sym_delete] = ACTIONS(3020),
    [anon_sym_throw] = ACTIONS(3020),
    [anon_sym_namespace] = ACTIONS(3020),
    [anon_sym_using] = ACTIONS(3020),
    [anon_sym_static_assert] = ACTIONS(3020),
    [anon_sym_concept] = ACTIONS(3020),
    [anon_sym_co_return] = ACTIONS(3020),
    [anon_sym_co_yield] = ACTIONS(3020),
    [anon_sym_R_DQUOTE] = ACTIONS(3022),
    [anon_sym_LR_DQUOTE] = ACTIONS(3022),
    [anon_sym_uR_DQUOTE] = ACTIONS(3022),
    [anon_sym_UR_DQUOTE] = ACTIONS(3022),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3022),
    [anon_sym_co_await] = ACTIONS(3020),
    [anon_sym_new] = ACTIONS(3020),
    [anon_sym_requires] = ACTIONS(3020),
    [sym_this] = ACTIONS(3020),
  },
  [640] = {
    [sym_identifier] = ACTIONS(2968),
    [aux_sym_preproc_include_token1] = ACTIONS(2968),
    [aux_sym_preproc_def_token1] = ACTIONS(2968),
    [aux_sym_preproc_if_token1] = ACTIONS(2968),
    [aux_sym_preproc_if_token2] = ACTIONS(2968),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2968),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2968),
    [sym_preproc_directive] = ACTIONS(2968),
    [anon_sym_LPAREN2] = ACTIONS(2970),
    [anon_sym_BANG] = ACTIONS(2970),
    [anon_sym_TILDE] = ACTIONS(2970),
    [anon_sym_DASH] = ACTIONS(2968),
    [anon_sym_PLUS] = ACTIONS(2968),
    [anon_sym_STAR] = ACTIONS(2970),
    [anon_sym_AMP_AMP] = ACTIONS(2970),
    [anon_sym_AMP] = ACTIONS(2968),
    [anon_sym_SEMI] = ACTIONS(2970),
    [anon_sym___extension__] = ACTIONS(2968),
    [anon_sym_typedef] = ACTIONS(2968),
    [anon_sym_virtual] = ACTIONS(2968),
    [anon_sym_extern] = ACTIONS(2968),
    [anon_sym___attribute__] = ACTIONS(2968),
    [anon_sym___attribute] = ACTIONS(2968),
    [anon_sym_COLON_COLON] = ACTIONS(2970),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2970),
    [anon_sym___declspec] = ACTIONS(2968),
    [anon_sym___based] = ACTIONS(2968),
    [anon_sym___cdecl] = ACTIONS(2968),
    [anon_sym___clrcall] = ACTIONS(2968),
    [anon_sym___stdcall] = ACTIONS(2968),
    [anon_sym___fastcall] = ACTIONS(2968),
    [anon_sym___thiscall] = ACTIONS(2968),
    [anon_sym___vectorcall] = ACTIONS(2968),
    [anon_sym_LBRACE] = ACTIONS(2970),
    [anon_sym_signed] = ACTIONS(2968),
    [anon_sym_unsigned] = ACTIONS(2968),
    [anon_sym_long] = ACTIONS(2968),
    [anon_sym_short] = ACTIONS(2968),
    [anon_sym_LBRACK] = ACTIONS(2968),
    [anon_sym_static] = ACTIONS(2968),
    [anon_sym_register] = ACTIONS(2968),
    [anon_sym_inline] = ACTIONS(2968),
    [anon_sym___inline] = ACTIONS(2968),
    [anon_sym___inline__] = ACTIONS(2968),
    [anon_sym___forceinline] = ACTIONS(2968),
    [anon_sym_thread_local] = ACTIONS(2968),
    [anon_sym___thread] = ACTIONS(2968),
    [anon_sym_const] = ACTIONS(2968),
    [anon_sym_constexpr] = ACTIONS(2968),
    [anon_sym_volatile] = ACTIONS(2968),
    [anon_sym_restrict] = ACTIONS(2968),
    [anon_sym___restrict__] = ACTIONS(2968),
    [anon_sym__Atomic] = ACTIONS(2968),
    [anon_sym__Noreturn] = ACTIONS(2968),
    [anon_sym_noreturn] = ACTIONS(2968),
    [anon_sym__Nonnull] = ACTIONS(2968),
    [anon_sym_mutable] = ACTIONS(2968),
    [anon_sym_constinit] = ACTIONS(2968),
    [anon_sym_consteval] = ACTIONS(2968),
    [anon_sym_alignas] = ACTIONS(2968),
    [anon_sym__Alignas] = ACTIONS(2968),
    [sym_primitive_type] = ACTIONS(2968),
    [anon_sym_enum] = ACTIONS(2968),
    [anon_sym_class] = ACTIONS(2968),
    [anon_sym_struct] = ACTIONS(2968),
    [anon_sym_union] = ACTIONS(2968),
    [anon_sym_if] = ACTIONS(2968),
    [anon_sym_switch] = ACTIONS(2968),
    [anon_sym_case] = ACTIONS(2968),
    [anon_sym_default] = ACTIONS(2968),
    [anon_sym_while] = ACTIONS(2968),
    [anon_sym_do] = ACTIONS(2968),
    [anon_sym_for] = ACTIONS(2968),
    [anon_sym_return] = ACTIONS(2968),
    [anon_sym_break] = ACTIONS(2968),
    [anon_sym_continue] = ACTIONS(2968),
    [anon_sym_goto] = ACTIONS(2968),
    [anon_sym___try] = ACTIONS(2968),
    [anon_sym___leave] = ACTIONS(2968),
    [anon_sym_not] = ACTIONS(2968),
    [anon_sym_compl] = ACTIONS(2968),
    [anon_sym_DASH_DASH] = ACTIONS(2970),
    [anon_sym_PLUS_PLUS] = ACTIONS(2970),
    [anon_sym_sizeof] = ACTIONS(2968),
    [anon_sym___alignof__] = ACTIONS(2968),
    [anon_sym___alignof] = ACTIONS(2968),
    [anon_sym__alignof] = ACTIONS(2968),
    [anon_sym_alignof] = ACTIONS(2968),
    [anon_sym__Alignof] = ACTIONS(2968),
    [anon_sym_offsetof] = ACTIONS(2968),
    [anon_sym__Generic] = ACTIONS(2968),
    [anon_sym_asm] = ACTIONS(2968),
    [anon_sym___asm__] = ACTIONS(2968),
    [anon_sym___asm] = ACTIONS(2968),
    [sym_number_literal] = ACTIONS(2970),
    [anon_sym_L_SQUOTE] = ACTIONS(2970),
    [anon_sym_u_SQUOTE] = ACTIONS(2970),
    [anon_sym_U_SQUOTE] = ACTIONS(2970),
    [anon_sym_u8_SQUOTE] = ACTIONS(2970),
    [anon_sym_SQUOTE] = ACTIONS(2970),
    [anon_sym_L_DQUOTE] = ACTIONS(2970),
    [anon_sym_u_DQUOTE] = ACTIONS(2970),
    [anon_sym_U_DQUOTE] = ACTIONS(2970),
    [anon_sym_u8_DQUOTE] = ACTIONS(2970),
    [anon_sym_DQUOTE] = ACTIONS(2970),
    [sym_true] = ACTIONS(2968),
    [sym_false] = ACTIONS(2968),
    [anon_sym_NULL] = ACTIONS(2968),
    [anon_sym_nullptr] = ACTIONS(2968),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2968),
    [anon_sym_decltype] = ACTIONS(2968),
    [anon_sym_explicit] = ACTIONS(2968),
    [anon_sym_typename] = ACTIONS(2968),
    [anon_sym_template] = ACTIONS(2968),
    [anon_sym_operator] = ACTIONS(2968),
    [anon_sym_try] = ACTIONS(2968),
    [anon_sym_delete] = ACTIONS(2968),
    [anon_sym_throw] = ACTIONS(2968),
    [anon_sym_namespace] = ACTIONS(2968),
    [anon_sym_using] = ACTIONS(2968),
    [anon_sym_static_assert] = ACTIONS(2968),
    [anon_sym_concept] = ACTIONS(2968),
    [anon_sym_co_return] = ACTIONS(2968),
    [anon_sym_co_yield] = ACTIONS(2968),
    [anon_sym_R_DQUOTE] = ACTIONS(2970),
    [anon_sym_LR_DQUOTE] = ACTIONS(2970),
    [anon_sym_uR_DQUOTE] = ACTIONS(2970),
    [anon_sym_UR_DQUOTE] = ACTIONS(2970),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2970),
    [anon_sym_co_await] = ACTIONS(2968),
    [anon_sym_new] = ACTIONS(2968),
    [anon_sym_requires] = ACTIONS(2968),
    [sym_this] = ACTIONS(2968),
  },
  [641] = {
    [sym_identifier] = ACTIONS(3026),
    [aux_sym_preproc_include_token1] = ACTIONS(3026),
    [aux_sym_preproc_def_token1] = ACTIONS(3026),
    [aux_sym_preproc_if_token1] = ACTIONS(3026),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3026),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3026),
    [sym_preproc_directive] = ACTIONS(3026),
    [anon_sym_LPAREN2] = ACTIONS(3028),
    [anon_sym_BANG] = ACTIONS(3028),
    [anon_sym_TILDE] = ACTIONS(3028),
    [anon_sym_DASH] = ACTIONS(3026),
    [anon_sym_PLUS] = ACTIONS(3026),
    [anon_sym_STAR] = ACTIONS(3028),
    [anon_sym_AMP_AMP] = ACTIONS(3028),
    [anon_sym_AMP] = ACTIONS(3026),
    [anon_sym_SEMI] = ACTIONS(3028),
    [anon_sym___extension__] = ACTIONS(3026),
    [anon_sym_typedef] = ACTIONS(3026),
    [anon_sym_virtual] = ACTIONS(3026),
    [anon_sym_extern] = ACTIONS(3026),
    [anon_sym___attribute__] = ACTIONS(3026),
    [anon_sym___attribute] = ACTIONS(3026),
    [anon_sym_COLON_COLON] = ACTIONS(3028),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3028),
    [anon_sym___declspec] = ACTIONS(3026),
    [anon_sym___based] = ACTIONS(3026),
    [anon_sym___cdecl] = ACTIONS(3026),
    [anon_sym___clrcall] = ACTIONS(3026),
    [anon_sym___stdcall] = ACTIONS(3026),
    [anon_sym___fastcall] = ACTIONS(3026),
    [anon_sym___thiscall] = ACTIONS(3026),
    [anon_sym___vectorcall] = ACTIONS(3026),
    [anon_sym_LBRACE] = ACTIONS(3028),
    [anon_sym_RBRACE] = ACTIONS(3028),
    [anon_sym_signed] = ACTIONS(3026),
    [anon_sym_unsigned] = ACTIONS(3026),
    [anon_sym_long] = ACTIONS(3026),
    [anon_sym_short] = ACTIONS(3026),
    [anon_sym_LBRACK] = ACTIONS(3026),
    [anon_sym_static] = ACTIONS(3026),
    [anon_sym_register] = ACTIONS(3026),
    [anon_sym_inline] = ACTIONS(3026),
    [anon_sym___inline] = ACTIONS(3026),
    [anon_sym___inline__] = ACTIONS(3026),
    [anon_sym___forceinline] = ACTIONS(3026),
    [anon_sym_thread_local] = ACTIONS(3026),
    [anon_sym___thread] = ACTIONS(3026),
    [anon_sym_const] = ACTIONS(3026),
    [anon_sym_constexpr] = ACTIONS(3026),
    [anon_sym_volatile] = ACTIONS(3026),
    [anon_sym_restrict] = ACTIONS(3026),
    [anon_sym___restrict__] = ACTIONS(3026),
    [anon_sym__Atomic] = ACTIONS(3026),
    [anon_sym__Noreturn] = ACTIONS(3026),
    [anon_sym_noreturn] = ACTIONS(3026),
    [anon_sym__Nonnull] = ACTIONS(3026),
    [anon_sym_mutable] = ACTIONS(3026),
    [anon_sym_constinit] = ACTIONS(3026),
    [anon_sym_consteval] = ACTIONS(3026),
    [anon_sym_alignas] = ACTIONS(3026),
    [anon_sym__Alignas] = ACTIONS(3026),
    [sym_primitive_type] = ACTIONS(3026),
    [anon_sym_enum] = ACTIONS(3026),
    [anon_sym_class] = ACTIONS(3026),
    [anon_sym_struct] = ACTIONS(3026),
    [anon_sym_union] = ACTIONS(3026),
    [anon_sym_if] = ACTIONS(3026),
    [anon_sym_switch] = ACTIONS(3026),
    [anon_sym_case] = ACTIONS(3026),
    [anon_sym_default] = ACTIONS(3026),
    [anon_sym_while] = ACTIONS(3026),
    [anon_sym_do] = ACTIONS(3026),
    [anon_sym_for] = ACTIONS(3026),
    [anon_sym_return] = ACTIONS(3026),
    [anon_sym_break] = ACTIONS(3026),
    [anon_sym_continue] = ACTIONS(3026),
    [anon_sym_goto] = ACTIONS(3026),
    [anon_sym___try] = ACTIONS(3026),
    [anon_sym___leave] = ACTIONS(3026),
    [anon_sym_not] = ACTIONS(3026),
    [anon_sym_compl] = ACTIONS(3026),
    [anon_sym_DASH_DASH] = ACTIONS(3028),
    [anon_sym_PLUS_PLUS] = ACTIONS(3028),
    [anon_sym_sizeof] = ACTIONS(3026),
    [anon_sym___alignof__] = ACTIONS(3026),
    [anon_sym___alignof] = ACTIONS(3026),
    [anon_sym__alignof] = ACTIONS(3026),
    [anon_sym_alignof] = ACTIONS(3026),
    [anon_sym__Alignof] = ACTIONS(3026),
    [anon_sym_offsetof] = ACTIONS(3026),
    [anon_sym__Generic] = ACTIONS(3026),
    [anon_sym_asm] = ACTIONS(3026),
    [anon_sym___asm__] = ACTIONS(3026),
    [anon_sym___asm] = ACTIONS(3026),
    [sym_number_literal] = ACTIONS(3028),
    [anon_sym_L_SQUOTE] = ACTIONS(3028),
    [anon_sym_u_SQUOTE] = ACTIONS(3028),
    [anon_sym_U_SQUOTE] = ACTIONS(3028),
    [anon_sym_u8_SQUOTE] = ACTIONS(3028),
    [anon_sym_SQUOTE] = ACTIONS(3028),
    [anon_sym_L_DQUOTE] = ACTIONS(3028),
    [anon_sym_u_DQUOTE] = ACTIONS(3028),
    [anon_sym_U_DQUOTE] = ACTIONS(3028),
    [anon_sym_u8_DQUOTE] = ACTIONS(3028),
    [anon_sym_DQUOTE] = ACTIONS(3028),
    [sym_true] = ACTIONS(3026),
    [sym_false] = ACTIONS(3026),
    [anon_sym_NULL] = ACTIONS(3026),
    [anon_sym_nullptr] = ACTIONS(3026),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3026),
    [anon_sym_decltype] = ACTIONS(3026),
    [anon_sym_explicit] = ACTIONS(3026),
    [anon_sym_typename] = ACTIONS(3026),
    [anon_sym_template] = ACTIONS(3026),
    [anon_sym_operator] = ACTIONS(3026),
    [anon_sym_try] = ACTIONS(3026),
    [anon_sym_delete] = ACTIONS(3026),
    [anon_sym_throw] = ACTIONS(3026),
    [anon_sym_namespace] = ACTIONS(3026),
    [anon_sym_using] = ACTIONS(3026),
    [anon_sym_static_assert] = ACTIONS(3026),
    [anon_sym_concept] = ACTIONS(3026),
    [anon_sym_co_return] = ACTIONS(3026),
    [anon_sym_co_yield] = ACTIONS(3026),
    [anon_sym_R_DQUOTE] = ACTIONS(3028),
    [anon_sym_LR_DQUOTE] = ACTIONS(3028),
    [anon_sym_uR_DQUOTE] = ACTIONS(3028),
    [anon_sym_UR_DQUOTE] = ACTIONS(3028),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3028),
    [anon_sym_co_await] = ACTIONS(3026),
    [anon_sym_new] = ACTIONS(3026),
    [anon_sym_requires] = ACTIONS(3026),
    [sym_this] = ACTIONS(3026),
  },
  [642] = {
    [sym_identifier] = ACTIONS(3030),
    [aux_sym_preproc_include_token1] = ACTIONS(3030),
    [aux_sym_preproc_def_token1] = ACTIONS(3030),
    [aux_sym_preproc_if_token1] = ACTIONS(3030),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3030),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3030),
    [sym_preproc_directive] = ACTIONS(3030),
    [anon_sym_LPAREN2] = ACTIONS(3032),
    [anon_sym_BANG] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3030),
    [anon_sym_PLUS] = ACTIONS(3030),
    [anon_sym_STAR] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_AMP] = ACTIONS(3030),
    [anon_sym_SEMI] = ACTIONS(3032),
    [anon_sym___extension__] = ACTIONS(3030),
    [anon_sym_typedef] = ACTIONS(3030),
    [anon_sym_virtual] = ACTIONS(3030),
    [anon_sym_extern] = ACTIONS(3030),
    [anon_sym___attribute__] = ACTIONS(3030),
    [anon_sym___attribute] = ACTIONS(3030),
    [anon_sym_COLON_COLON] = ACTIONS(3032),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3032),
    [anon_sym___declspec] = ACTIONS(3030),
    [anon_sym___based] = ACTIONS(3030),
    [anon_sym___cdecl] = ACTIONS(3030),
    [anon_sym___clrcall] = ACTIONS(3030),
    [anon_sym___stdcall] = ACTIONS(3030),
    [anon_sym___fastcall] = ACTIONS(3030),
    [anon_sym___thiscall] = ACTIONS(3030),
    [anon_sym___vectorcall] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_RBRACE] = ACTIONS(3032),
    [anon_sym_signed] = ACTIONS(3030),
    [anon_sym_unsigned] = ACTIONS(3030),
    [anon_sym_long] = ACTIONS(3030),
    [anon_sym_short] = ACTIONS(3030),
    [anon_sym_LBRACK] = ACTIONS(3030),
    [anon_sym_static] = ACTIONS(3030),
    [anon_sym_register] = ACTIONS(3030),
    [anon_sym_inline] = ACTIONS(3030),
    [anon_sym___inline] = ACTIONS(3030),
    [anon_sym___inline__] = ACTIONS(3030),
    [anon_sym___forceinline] = ACTIONS(3030),
    [anon_sym_thread_local] = ACTIONS(3030),
    [anon_sym___thread] = ACTIONS(3030),
    [anon_sym_const] = ACTIONS(3030),
    [anon_sym_constexpr] = ACTIONS(3030),
    [anon_sym_volatile] = ACTIONS(3030),
    [anon_sym_restrict] = ACTIONS(3030),
    [anon_sym___restrict__] = ACTIONS(3030),
    [anon_sym__Atomic] = ACTIONS(3030),
    [anon_sym__Noreturn] = ACTIONS(3030),
    [anon_sym_noreturn] = ACTIONS(3030),
    [anon_sym__Nonnull] = ACTIONS(3030),
    [anon_sym_mutable] = ACTIONS(3030),
    [anon_sym_constinit] = ACTIONS(3030),
    [anon_sym_consteval] = ACTIONS(3030),
    [anon_sym_alignas] = ACTIONS(3030),
    [anon_sym__Alignas] = ACTIONS(3030),
    [sym_primitive_type] = ACTIONS(3030),
    [anon_sym_enum] = ACTIONS(3030),
    [anon_sym_class] = ACTIONS(3030),
    [anon_sym_struct] = ACTIONS(3030),
    [anon_sym_union] = ACTIONS(3030),
    [anon_sym_if] = ACTIONS(3030),
    [anon_sym_switch] = ACTIONS(3030),
    [anon_sym_case] = ACTIONS(3030),
    [anon_sym_default] = ACTIONS(3030),
    [anon_sym_while] = ACTIONS(3030),
    [anon_sym_do] = ACTIONS(3030),
    [anon_sym_for] = ACTIONS(3030),
    [anon_sym_return] = ACTIONS(3030),
    [anon_sym_break] = ACTIONS(3030),
    [anon_sym_continue] = ACTIONS(3030),
    [anon_sym_goto] = ACTIONS(3030),
    [anon_sym___try] = ACTIONS(3030),
    [anon_sym___leave] = ACTIONS(3030),
    [anon_sym_not] = ACTIONS(3030),
    [anon_sym_compl] = ACTIONS(3030),
    [anon_sym_DASH_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_PLUS] = ACTIONS(3032),
    [anon_sym_sizeof] = ACTIONS(3030),
    [anon_sym___alignof__] = ACTIONS(3030),
    [anon_sym___alignof] = ACTIONS(3030),
    [anon_sym__alignof] = ACTIONS(3030),
    [anon_sym_alignof] = ACTIONS(3030),
    [anon_sym__Alignof] = ACTIONS(3030),
    [anon_sym_offsetof] = ACTIONS(3030),
    [anon_sym__Generic] = ACTIONS(3030),
    [anon_sym_asm] = ACTIONS(3030),
    [anon_sym___asm__] = ACTIONS(3030),
    [anon_sym___asm] = ACTIONS(3030),
    [sym_number_literal] = ACTIONS(3032),
    [anon_sym_L_SQUOTE] = ACTIONS(3032),
    [anon_sym_u_SQUOTE] = ACTIONS(3032),
    [anon_sym_U_SQUOTE] = ACTIONS(3032),
    [anon_sym_u8_SQUOTE] = ACTIONS(3032),
    [anon_sym_SQUOTE] = ACTIONS(3032),
    [anon_sym_L_DQUOTE] = ACTIONS(3032),
    [anon_sym_u_DQUOTE] = ACTIONS(3032),
    [anon_sym_U_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8_DQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [sym_true] = ACTIONS(3030),
    [sym_false] = ACTIONS(3030),
    [anon_sym_NULL] = ACTIONS(3030),
    [anon_sym_nullptr] = ACTIONS(3030),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3030),
    [anon_sym_decltype] = ACTIONS(3030),
    [anon_sym_explicit] = ACTIONS(3030),
    [anon_sym_typename] = ACTIONS(3030),
    [anon_sym_template] = ACTIONS(3030),
    [anon_sym_operator] = ACTIONS(3030),
    [anon_sym_try] = ACTIONS(3030),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_throw] = ACTIONS(3030),
    [anon_sym_namespace] = ACTIONS(3030),
    [anon_sym_using] = ACTIONS(3030),
    [anon_sym_static_assert] = ACTIONS(3030),
    [anon_sym_concept] = ACTIONS(3030),
    [anon_sym_co_return] = ACTIONS(3030),
    [anon_sym_co_yield] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3030),
    [anon_sym_new] = ACTIONS(3030),
    [anon_sym_requires] = ACTIONS(3030),
    [sym_this] = ACTIONS(3030),
  },
  [643] = {
    [sym_identifier] = ACTIONS(2972),
    [aux_sym_preproc_include_token1] = ACTIONS(2972),
    [aux_sym_preproc_def_token1] = ACTIONS(2972),
    [aux_sym_preproc_if_token1] = ACTIONS(2972),
    [aux_sym_preproc_if_token2] = ACTIONS(2972),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2972),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2972),
    [sym_preproc_directive] = ACTIONS(2972),
    [anon_sym_LPAREN2] = ACTIONS(2974),
    [anon_sym_BANG] = ACTIONS(2974),
    [anon_sym_TILDE] = ACTIONS(2974),
    [anon_sym_DASH] = ACTIONS(2972),
    [anon_sym_PLUS] = ACTIONS(2972),
    [anon_sym_STAR] = ACTIONS(2974),
    [anon_sym_AMP_AMP] = ACTIONS(2974),
    [anon_sym_AMP] = ACTIONS(2972),
    [anon_sym_SEMI] = ACTIONS(2974),
    [anon_sym___extension__] = ACTIONS(2972),
    [anon_sym_typedef] = ACTIONS(2972),
    [anon_sym_virtual] = ACTIONS(2972),
    [anon_sym_extern] = ACTIONS(2972),
    [anon_sym___attribute__] = ACTIONS(2972),
    [anon_sym___attribute] = ACTIONS(2972),
    [anon_sym_COLON_COLON] = ACTIONS(2974),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2974),
    [anon_sym___declspec] = ACTIONS(2972),
    [anon_sym___based] = ACTIONS(2972),
    [anon_sym___cdecl] = ACTIONS(2972),
    [anon_sym___clrcall] = ACTIONS(2972),
    [anon_sym___stdcall] = ACTIONS(2972),
    [anon_sym___fastcall] = ACTIONS(2972),
    [anon_sym___thiscall] = ACTIONS(2972),
    [anon_sym___vectorcall] = ACTIONS(2972),
    [anon_sym_LBRACE] = ACTIONS(2974),
    [anon_sym_signed] = ACTIONS(2972),
    [anon_sym_unsigned] = ACTIONS(2972),
    [anon_sym_long] = ACTIONS(2972),
    [anon_sym_short] = ACTIONS(2972),
    [anon_sym_LBRACK] = ACTIONS(2972),
    [anon_sym_static] = ACTIONS(2972),
    [anon_sym_register] = ACTIONS(2972),
    [anon_sym_inline] = ACTIONS(2972),
    [anon_sym___inline] = ACTIONS(2972),
    [anon_sym___inline__] = ACTIONS(2972),
    [anon_sym___forceinline] = ACTIONS(2972),
    [anon_sym_thread_local] = ACTIONS(2972),
    [anon_sym___thread] = ACTIONS(2972),
    [anon_sym_const] = ACTIONS(2972),
    [anon_sym_constexpr] = ACTIONS(2972),
    [anon_sym_volatile] = ACTIONS(2972),
    [anon_sym_restrict] = ACTIONS(2972),
    [anon_sym___restrict__] = ACTIONS(2972),
    [anon_sym__Atomic] = ACTIONS(2972),
    [anon_sym__Noreturn] = ACTIONS(2972),
    [anon_sym_noreturn] = ACTIONS(2972),
    [anon_sym__Nonnull] = ACTIONS(2972),
    [anon_sym_mutable] = ACTIONS(2972),
    [anon_sym_constinit] = ACTIONS(2972),
    [anon_sym_consteval] = ACTIONS(2972),
    [anon_sym_alignas] = ACTIONS(2972),
    [anon_sym__Alignas] = ACTIONS(2972),
    [sym_primitive_type] = ACTIONS(2972),
    [anon_sym_enum] = ACTIONS(2972),
    [anon_sym_class] = ACTIONS(2972),
    [anon_sym_struct] = ACTIONS(2972),
    [anon_sym_union] = ACTIONS(2972),
    [anon_sym_if] = ACTIONS(2972),
    [anon_sym_switch] = ACTIONS(2972),
    [anon_sym_case] = ACTIONS(2972),
    [anon_sym_default] = ACTIONS(2972),
    [anon_sym_while] = ACTIONS(2972),
    [anon_sym_do] = ACTIONS(2972),
    [anon_sym_for] = ACTIONS(2972),
    [anon_sym_return] = ACTIONS(2972),
    [anon_sym_break] = ACTIONS(2972),
    [anon_sym_continue] = ACTIONS(2972),
    [anon_sym_goto] = ACTIONS(2972),
    [anon_sym___try] = ACTIONS(2972),
    [anon_sym___leave] = ACTIONS(2972),
    [anon_sym_not] = ACTIONS(2972),
    [anon_sym_compl] = ACTIONS(2972),
    [anon_sym_DASH_DASH] = ACTIONS(2974),
    [anon_sym_PLUS_PLUS] = ACTIONS(2974),
    [anon_sym_sizeof] = ACTIONS(2972),
    [anon_sym___alignof__] = ACTIONS(2972),
    [anon_sym___alignof] = ACTIONS(2972),
    [anon_sym__alignof] = ACTIONS(2972),
    [anon_sym_alignof] = ACTIONS(2972),
    [anon_sym__Alignof] = ACTIONS(2972),
    [anon_sym_offsetof] = ACTIONS(2972),
    [anon_sym__Generic] = ACTIONS(2972),
    [anon_sym_asm] = ACTIONS(2972),
    [anon_sym___asm__] = ACTIONS(2972),
    [anon_sym___asm] = ACTIONS(2972),
    [sym_number_literal] = ACTIONS(2974),
    [anon_sym_L_SQUOTE] = ACTIONS(2974),
    [anon_sym_u_SQUOTE] = ACTIONS(2974),
    [anon_sym_U_SQUOTE] = ACTIONS(2974),
    [anon_sym_u8_SQUOTE] = ACTIONS(2974),
    [anon_sym_SQUOTE] = ACTIONS(2974),
    [anon_sym_L_DQUOTE] = ACTIONS(2974),
    [anon_sym_u_DQUOTE] = ACTIONS(2974),
    [anon_sym_U_DQUOTE] = ACTIONS(2974),
    [anon_sym_u8_DQUOTE] = ACTIONS(2974),
    [anon_sym_DQUOTE] = ACTIONS(2974),
    [sym_true] = ACTIONS(2972),
    [sym_false] = ACTIONS(2972),
    [anon_sym_NULL] = ACTIONS(2972),
    [anon_sym_nullptr] = ACTIONS(2972),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2972),
    [anon_sym_decltype] = ACTIONS(2972),
    [anon_sym_explicit] = ACTIONS(2972),
    [anon_sym_typename] = ACTIONS(2972),
    [anon_sym_template] = ACTIONS(2972),
    [anon_sym_operator] = ACTIONS(2972),
    [anon_sym_try] = ACTIONS(2972),
    [anon_sym_delete] = ACTIONS(2972),
    [anon_sym_throw] = ACTIONS(2972),
    [anon_sym_namespace] = ACTIONS(2972),
    [anon_sym_using] = ACTIONS(2972),
    [anon_sym_static_assert] = ACTIONS(2972),
    [anon_sym_concept] = ACTIONS(2972),
    [anon_sym_co_return] = ACTIONS(2972),
    [anon_sym_co_yield] = ACTIONS(2972),
    [anon_sym_R_DQUOTE] = ACTIONS(2974),
    [anon_sym_LR_DQUOTE] = ACTIONS(2974),
    [anon_sym_uR_DQUOTE] = ACTIONS(2974),
    [anon_sym_UR_DQUOTE] = ACTIONS(2974),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2974),
    [anon_sym_co_await] = ACTIONS(2972),
    [anon_sym_new] = ACTIONS(2972),
    [anon_sym_requires] = ACTIONS(2972),
    [sym_this] = ACTIONS(2972),
  },
  [644] = {
    [sym_identifier] = ACTIONS(3030),
    [aux_sym_preproc_include_token1] = ACTIONS(3030),
    [aux_sym_preproc_def_token1] = ACTIONS(3030),
    [aux_sym_preproc_if_token1] = ACTIONS(3030),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3030),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3030),
    [sym_preproc_directive] = ACTIONS(3030),
    [anon_sym_LPAREN2] = ACTIONS(3032),
    [anon_sym_BANG] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3030),
    [anon_sym_PLUS] = ACTIONS(3030),
    [anon_sym_STAR] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_AMP] = ACTIONS(3030),
    [anon_sym_SEMI] = ACTIONS(3032),
    [anon_sym___extension__] = ACTIONS(3030),
    [anon_sym_typedef] = ACTIONS(3030),
    [anon_sym_virtual] = ACTIONS(3030),
    [anon_sym_extern] = ACTIONS(3030),
    [anon_sym___attribute__] = ACTIONS(3030),
    [anon_sym___attribute] = ACTIONS(3030),
    [anon_sym_COLON_COLON] = ACTIONS(3032),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3032),
    [anon_sym___declspec] = ACTIONS(3030),
    [anon_sym___based] = ACTIONS(3030),
    [anon_sym___cdecl] = ACTIONS(3030),
    [anon_sym___clrcall] = ACTIONS(3030),
    [anon_sym___stdcall] = ACTIONS(3030),
    [anon_sym___fastcall] = ACTIONS(3030),
    [anon_sym___thiscall] = ACTIONS(3030),
    [anon_sym___vectorcall] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_RBRACE] = ACTIONS(3032),
    [anon_sym_signed] = ACTIONS(3030),
    [anon_sym_unsigned] = ACTIONS(3030),
    [anon_sym_long] = ACTIONS(3030),
    [anon_sym_short] = ACTIONS(3030),
    [anon_sym_LBRACK] = ACTIONS(3030),
    [anon_sym_static] = ACTIONS(3030),
    [anon_sym_register] = ACTIONS(3030),
    [anon_sym_inline] = ACTIONS(3030),
    [anon_sym___inline] = ACTIONS(3030),
    [anon_sym___inline__] = ACTIONS(3030),
    [anon_sym___forceinline] = ACTIONS(3030),
    [anon_sym_thread_local] = ACTIONS(3030),
    [anon_sym___thread] = ACTIONS(3030),
    [anon_sym_const] = ACTIONS(3030),
    [anon_sym_constexpr] = ACTIONS(3030),
    [anon_sym_volatile] = ACTIONS(3030),
    [anon_sym_restrict] = ACTIONS(3030),
    [anon_sym___restrict__] = ACTIONS(3030),
    [anon_sym__Atomic] = ACTIONS(3030),
    [anon_sym__Noreturn] = ACTIONS(3030),
    [anon_sym_noreturn] = ACTIONS(3030),
    [anon_sym__Nonnull] = ACTIONS(3030),
    [anon_sym_mutable] = ACTIONS(3030),
    [anon_sym_constinit] = ACTIONS(3030),
    [anon_sym_consteval] = ACTIONS(3030),
    [anon_sym_alignas] = ACTIONS(3030),
    [anon_sym__Alignas] = ACTIONS(3030),
    [sym_primitive_type] = ACTIONS(3030),
    [anon_sym_enum] = ACTIONS(3030),
    [anon_sym_class] = ACTIONS(3030),
    [anon_sym_struct] = ACTIONS(3030),
    [anon_sym_union] = ACTIONS(3030),
    [anon_sym_if] = ACTIONS(3030),
    [anon_sym_switch] = ACTIONS(3030),
    [anon_sym_case] = ACTIONS(3030),
    [anon_sym_default] = ACTIONS(3030),
    [anon_sym_while] = ACTIONS(3030),
    [anon_sym_do] = ACTIONS(3030),
    [anon_sym_for] = ACTIONS(3030),
    [anon_sym_return] = ACTIONS(3030),
    [anon_sym_break] = ACTIONS(3030),
    [anon_sym_continue] = ACTIONS(3030),
    [anon_sym_goto] = ACTIONS(3030),
    [anon_sym___try] = ACTIONS(3030),
    [anon_sym___leave] = ACTIONS(3030),
    [anon_sym_not] = ACTIONS(3030),
    [anon_sym_compl] = ACTIONS(3030),
    [anon_sym_DASH_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_PLUS] = ACTIONS(3032),
    [anon_sym_sizeof] = ACTIONS(3030),
    [anon_sym___alignof__] = ACTIONS(3030),
    [anon_sym___alignof] = ACTIONS(3030),
    [anon_sym__alignof] = ACTIONS(3030),
    [anon_sym_alignof] = ACTIONS(3030),
    [anon_sym__Alignof] = ACTIONS(3030),
    [anon_sym_offsetof] = ACTIONS(3030),
    [anon_sym__Generic] = ACTIONS(3030),
    [anon_sym_asm] = ACTIONS(3030),
    [anon_sym___asm__] = ACTIONS(3030),
    [anon_sym___asm] = ACTIONS(3030),
    [sym_number_literal] = ACTIONS(3032),
    [anon_sym_L_SQUOTE] = ACTIONS(3032),
    [anon_sym_u_SQUOTE] = ACTIONS(3032),
    [anon_sym_U_SQUOTE] = ACTIONS(3032),
    [anon_sym_u8_SQUOTE] = ACTIONS(3032),
    [anon_sym_SQUOTE] = ACTIONS(3032),
    [anon_sym_L_DQUOTE] = ACTIONS(3032),
    [anon_sym_u_DQUOTE] = ACTIONS(3032),
    [anon_sym_U_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8_DQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [sym_true] = ACTIONS(3030),
    [sym_false] = ACTIONS(3030),
    [anon_sym_NULL] = ACTIONS(3030),
    [anon_sym_nullptr] = ACTIONS(3030),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3030),
    [anon_sym_decltype] = ACTIONS(3030),
    [anon_sym_explicit] = ACTIONS(3030),
    [anon_sym_typename] = ACTIONS(3030),
    [anon_sym_template] = ACTIONS(3030),
    [anon_sym_operator] = ACTIONS(3030),
    [anon_sym_try] = ACTIONS(3030),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_throw] = ACTIONS(3030),
    [anon_sym_namespace] = ACTIONS(3030),
    [anon_sym_using] = ACTIONS(3030),
    [anon_sym_static_assert] = ACTIONS(3030),
    [anon_sym_concept] = ACTIONS(3030),
    [anon_sym_co_return] = ACTIONS(3030),
    [anon_sym_co_yield] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3030),
    [anon_sym_new] = ACTIONS(3030),
    [anon_sym_requires] = ACTIONS(3030),
    [sym_this] = ACTIONS(3030),
  },
  [645] = {
    [sym_identifier] = ACTIONS(2920),
    [aux_sym_preproc_include_token1] = ACTIONS(2920),
    [aux_sym_preproc_def_token1] = ACTIONS(2920),
    [aux_sym_preproc_if_token1] = ACTIONS(2920),
    [aux_sym_preproc_if_token2] = ACTIONS(2920),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2920),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2920),
    [sym_preproc_directive] = ACTIONS(2920),
    [anon_sym_LPAREN2] = ACTIONS(2922),
    [anon_sym_BANG] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2922),
    [anon_sym_DASH] = ACTIONS(2920),
    [anon_sym_PLUS] = ACTIONS(2920),
    [anon_sym_STAR] = ACTIONS(2922),
    [anon_sym_AMP_AMP] = ACTIONS(2922),
    [anon_sym_AMP] = ACTIONS(2920),
    [anon_sym_SEMI] = ACTIONS(2922),
    [anon_sym___extension__] = ACTIONS(2920),
    [anon_sym_typedef] = ACTIONS(2920),
    [anon_sym_virtual] = ACTIONS(2920),
    [anon_sym_extern] = ACTIONS(2920),
    [anon_sym___attribute__] = ACTIONS(2920),
    [anon_sym___attribute] = ACTIONS(2920),
    [anon_sym_COLON_COLON] = ACTIONS(2922),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2922),
    [anon_sym___declspec] = ACTIONS(2920),
    [anon_sym___based] = ACTIONS(2920),
    [anon_sym___cdecl] = ACTIONS(2920),
    [anon_sym___clrcall] = ACTIONS(2920),
    [anon_sym___stdcall] = ACTIONS(2920),
    [anon_sym___fastcall] = ACTIONS(2920),
    [anon_sym___thiscall] = ACTIONS(2920),
    [anon_sym___vectorcall] = ACTIONS(2920),
    [anon_sym_LBRACE] = ACTIONS(2922),
    [anon_sym_signed] = ACTIONS(2920),
    [anon_sym_unsigned] = ACTIONS(2920),
    [anon_sym_long] = ACTIONS(2920),
    [anon_sym_short] = ACTIONS(2920),
    [anon_sym_LBRACK] = ACTIONS(2920),
    [anon_sym_static] = ACTIONS(2920),
    [anon_sym_register] = ACTIONS(2920),
    [anon_sym_inline] = ACTIONS(2920),
    [anon_sym___inline] = ACTIONS(2920),
    [anon_sym___inline__] = ACTIONS(2920),
    [anon_sym___forceinline] = ACTIONS(2920),
    [anon_sym_thread_local] = ACTIONS(2920),
    [anon_sym___thread] = ACTIONS(2920),
    [anon_sym_const] = ACTIONS(2920),
    [anon_sym_constexpr] = ACTIONS(2920),
    [anon_sym_volatile] = ACTIONS(2920),
    [anon_sym_restrict] = ACTIONS(2920),
    [anon_sym___restrict__] = ACTIONS(2920),
    [anon_sym__Atomic] = ACTIONS(2920),
    [anon_sym__Noreturn] = ACTIONS(2920),
    [anon_sym_noreturn] = ACTIONS(2920),
    [anon_sym__Nonnull] = ACTIONS(2920),
    [anon_sym_mutable] = ACTIONS(2920),
    [anon_sym_constinit] = ACTIONS(2920),
    [anon_sym_consteval] = ACTIONS(2920),
    [anon_sym_alignas] = ACTIONS(2920),
    [anon_sym__Alignas] = ACTIONS(2920),
    [sym_primitive_type] = ACTIONS(2920),
    [anon_sym_enum] = ACTIONS(2920),
    [anon_sym_class] = ACTIONS(2920),
    [anon_sym_struct] = ACTIONS(2920),
    [anon_sym_union] = ACTIONS(2920),
    [anon_sym_if] = ACTIONS(2920),
    [anon_sym_switch] = ACTIONS(2920),
    [anon_sym_case] = ACTIONS(2920),
    [anon_sym_default] = ACTIONS(2920),
    [anon_sym_while] = ACTIONS(2920),
    [anon_sym_do] = ACTIONS(2920),
    [anon_sym_for] = ACTIONS(2920),
    [anon_sym_return] = ACTIONS(2920),
    [anon_sym_break] = ACTIONS(2920),
    [anon_sym_continue] = ACTIONS(2920),
    [anon_sym_goto] = ACTIONS(2920),
    [anon_sym___try] = ACTIONS(2920),
    [anon_sym___leave] = ACTIONS(2920),
    [anon_sym_not] = ACTIONS(2920),
    [anon_sym_compl] = ACTIONS(2920),
    [anon_sym_DASH_DASH] = ACTIONS(2922),
    [anon_sym_PLUS_PLUS] = ACTIONS(2922),
    [anon_sym_sizeof] = ACTIONS(2920),
    [anon_sym___alignof__] = ACTIONS(2920),
    [anon_sym___alignof] = ACTIONS(2920),
    [anon_sym__alignof] = ACTIONS(2920),
    [anon_sym_alignof] = ACTIONS(2920),
    [anon_sym__Alignof] = ACTIONS(2920),
    [anon_sym_offsetof] = ACTIONS(2920),
    [anon_sym__Generic] = ACTIONS(2920),
    [anon_sym_asm] = ACTIONS(2920),
    [anon_sym___asm__] = ACTIONS(2920),
    [anon_sym___asm] = ACTIONS(2920),
    [sym_number_literal] = ACTIONS(2922),
    [anon_sym_L_SQUOTE] = ACTIONS(2922),
    [anon_sym_u_SQUOTE] = ACTIONS(2922),
    [anon_sym_U_SQUOTE] = ACTIONS(2922),
    [anon_sym_u8_SQUOTE] = ACTIONS(2922),
    [anon_sym_SQUOTE] = ACTIONS(2922),
    [anon_sym_L_DQUOTE] = ACTIONS(2922),
    [anon_sym_u_DQUOTE] = ACTIONS(2922),
    [anon_sym_U_DQUOTE] = ACTIONS(2922),
    [anon_sym_u8_DQUOTE] = ACTIONS(2922),
    [anon_sym_DQUOTE] = ACTIONS(2922),
    [sym_true] = ACTIONS(2920),
    [sym_false] = ACTIONS(2920),
    [anon_sym_NULL] = ACTIONS(2920),
    [anon_sym_nullptr] = ACTIONS(2920),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2920),
    [anon_sym_decltype] = ACTIONS(2920),
    [anon_sym_explicit] = ACTIONS(2920),
    [anon_sym_typename] = ACTIONS(2920),
    [anon_sym_template] = ACTIONS(2920),
    [anon_sym_operator] = ACTIONS(2920),
    [anon_sym_try] = ACTIONS(2920),
    [anon_sym_delete] = ACTIONS(2920),
    [anon_sym_throw] = ACTIONS(2920),
    [anon_sym_namespace] = ACTIONS(2920),
    [anon_sym_using] = ACTIONS(2920),
    [anon_sym_static_assert] = ACTIONS(2920),
    [anon_sym_concept] = ACTIONS(2920),
    [anon_sym_co_return] = ACTIONS(2920),
    [anon_sym_co_yield] = ACTIONS(2920),
    [anon_sym_R_DQUOTE] = ACTIONS(2922),
    [anon_sym_LR_DQUOTE] = ACTIONS(2922),
    [anon_sym_uR_DQUOTE] = ACTIONS(2922),
    [anon_sym_UR_DQUOTE] = ACTIONS(2922),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2922),
    [anon_sym_co_await] = ACTIONS(2920),
    [anon_sym_new] = ACTIONS(2920),
    [anon_sym_requires] = ACTIONS(2920),
    [sym_this] = ACTIONS(2920),
  },
  [646] = {
    [sym_identifier] = ACTIONS(2924),
    [aux_sym_preproc_include_token1] = ACTIONS(2924),
    [aux_sym_preproc_def_token1] = ACTIONS(2924),
    [aux_sym_preproc_if_token1] = ACTIONS(2924),
    [aux_sym_preproc_if_token2] = ACTIONS(2924),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2924),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2924),
    [sym_preproc_directive] = ACTIONS(2924),
    [anon_sym_LPAREN2] = ACTIONS(2926),
    [anon_sym_BANG] = ACTIONS(2926),
    [anon_sym_TILDE] = ACTIONS(2926),
    [anon_sym_DASH] = ACTIONS(2924),
    [anon_sym_PLUS] = ACTIONS(2924),
    [anon_sym_STAR] = ACTIONS(2926),
    [anon_sym_AMP_AMP] = ACTIONS(2926),
    [anon_sym_AMP] = ACTIONS(2924),
    [anon_sym_SEMI] = ACTIONS(2926),
    [anon_sym___extension__] = ACTIONS(2924),
    [anon_sym_typedef] = ACTIONS(2924),
    [anon_sym_virtual] = ACTIONS(2924),
    [anon_sym_extern] = ACTIONS(2924),
    [anon_sym___attribute__] = ACTIONS(2924),
    [anon_sym___attribute] = ACTIONS(2924),
    [anon_sym_COLON_COLON] = ACTIONS(2926),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2926),
    [anon_sym___declspec] = ACTIONS(2924),
    [anon_sym___based] = ACTIONS(2924),
    [anon_sym___cdecl] = ACTIONS(2924),
    [anon_sym___clrcall] = ACTIONS(2924),
    [anon_sym___stdcall] = ACTIONS(2924),
    [anon_sym___fastcall] = ACTIONS(2924),
    [anon_sym___thiscall] = ACTIONS(2924),
    [anon_sym___vectorcall] = ACTIONS(2924),
    [anon_sym_LBRACE] = ACTIONS(2926),
    [anon_sym_signed] = ACTIONS(2924),
    [anon_sym_unsigned] = ACTIONS(2924),
    [anon_sym_long] = ACTIONS(2924),
    [anon_sym_short] = ACTIONS(2924),
    [anon_sym_LBRACK] = ACTIONS(2924),
    [anon_sym_static] = ACTIONS(2924),
    [anon_sym_register] = ACTIONS(2924),
    [anon_sym_inline] = ACTIONS(2924),
    [anon_sym___inline] = ACTIONS(2924),
    [anon_sym___inline__] = ACTIONS(2924),
    [anon_sym___forceinline] = ACTIONS(2924),
    [anon_sym_thread_local] = ACTIONS(2924),
    [anon_sym___thread] = ACTIONS(2924),
    [anon_sym_const] = ACTIONS(2924),
    [anon_sym_constexpr] = ACTIONS(2924),
    [anon_sym_volatile] = ACTIONS(2924),
    [anon_sym_restrict] = ACTIONS(2924),
    [anon_sym___restrict__] = ACTIONS(2924),
    [anon_sym__Atomic] = ACTIONS(2924),
    [anon_sym__Noreturn] = ACTIONS(2924),
    [anon_sym_noreturn] = ACTIONS(2924),
    [anon_sym__Nonnull] = ACTIONS(2924),
    [anon_sym_mutable] = ACTIONS(2924),
    [anon_sym_constinit] = ACTIONS(2924),
    [anon_sym_consteval] = ACTIONS(2924),
    [anon_sym_alignas] = ACTIONS(2924),
    [anon_sym__Alignas] = ACTIONS(2924),
    [sym_primitive_type] = ACTIONS(2924),
    [anon_sym_enum] = ACTIONS(2924),
    [anon_sym_class] = ACTIONS(2924),
    [anon_sym_struct] = ACTIONS(2924),
    [anon_sym_union] = ACTIONS(2924),
    [anon_sym_if] = ACTIONS(2924),
    [anon_sym_switch] = ACTIONS(2924),
    [anon_sym_case] = ACTIONS(2924),
    [anon_sym_default] = ACTIONS(2924),
    [anon_sym_while] = ACTIONS(2924),
    [anon_sym_do] = ACTIONS(2924),
    [anon_sym_for] = ACTIONS(2924),
    [anon_sym_return] = ACTIONS(2924),
    [anon_sym_break] = ACTIONS(2924),
    [anon_sym_continue] = ACTIONS(2924),
    [anon_sym_goto] = ACTIONS(2924),
    [anon_sym___try] = ACTIONS(2924),
    [anon_sym___leave] = ACTIONS(2924),
    [anon_sym_not] = ACTIONS(2924),
    [anon_sym_compl] = ACTIONS(2924),
    [anon_sym_DASH_DASH] = ACTIONS(2926),
    [anon_sym_PLUS_PLUS] = ACTIONS(2926),
    [anon_sym_sizeof] = ACTIONS(2924),
    [anon_sym___alignof__] = ACTIONS(2924),
    [anon_sym___alignof] = ACTIONS(2924),
    [anon_sym__alignof] = ACTIONS(2924),
    [anon_sym_alignof] = ACTIONS(2924),
    [anon_sym__Alignof] = ACTIONS(2924),
    [anon_sym_offsetof] = ACTIONS(2924),
    [anon_sym__Generic] = ACTIONS(2924),
    [anon_sym_asm] = ACTIONS(2924),
    [anon_sym___asm__] = ACTIONS(2924),
    [anon_sym___asm] = ACTIONS(2924),
    [sym_number_literal] = ACTIONS(2926),
    [anon_sym_L_SQUOTE] = ACTIONS(2926),
    [anon_sym_u_SQUOTE] = ACTIONS(2926),
    [anon_sym_U_SQUOTE] = ACTIONS(2926),
    [anon_sym_u8_SQUOTE] = ACTIONS(2926),
    [anon_sym_SQUOTE] = ACTIONS(2926),
    [anon_sym_L_DQUOTE] = ACTIONS(2926),
    [anon_sym_u_DQUOTE] = ACTIONS(2926),
    [anon_sym_U_DQUOTE] = ACTIONS(2926),
    [anon_sym_u8_DQUOTE] = ACTIONS(2926),
    [anon_sym_DQUOTE] = ACTIONS(2926),
    [sym_true] = ACTIONS(2924),
    [sym_false] = ACTIONS(2924),
    [anon_sym_NULL] = ACTIONS(2924),
    [anon_sym_nullptr] = ACTIONS(2924),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2924),
    [anon_sym_decltype] = ACTIONS(2924),
    [anon_sym_explicit] = ACTIONS(2924),
    [anon_sym_typename] = ACTIONS(2924),
    [anon_sym_template] = ACTIONS(2924),
    [anon_sym_operator] = ACTIONS(2924),
    [anon_sym_try] = ACTIONS(2924),
    [anon_sym_delete] = ACTIONS(2924),
    [anon_sym_throw] = ACTIONS(2924),
    [anon_sym_namespace] = ACTIONS(2924),
    [anon_sym_using] = ACTIONS(2924),
    [anon_sym_static_assert] = ACTIONS(2924),
    [anon_sym_concept] = ACTIONS(2924),
    [anon_sym_co_return] = ACTIONS(2924),
    [anon_sym_co_yield] = ACTIONS(2924),
    [anon_sym_R_DQUOTE] = ACTIONS(2926),
    [anon_sym_LR_DQUOTE] = ACTIONS(2926),
    [anon_sym_uR_DQUOTE] = ACTIONS(2926),
    [anon_sym_UR_DQUOTE] = ACTIONS(2926),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2926),
    [anon_sym_co_await] = ACTIONS(2924),
    [anon_sym_new] = ACTIONS(2924),
    [anon_sym_requires] = ACTIONS(2924),
    [sym_this] = ACTIONS(2924),
  },
  [647] = {
    [sym_identifier] = ACTIONS(3138),
    [aux_sym_preproc_include_token1] = ACTIONS(3138),
    [aux_sym_preproc_def_token1] = ACTIONS(3138),
    [aux_sym_preproc_if_token1] = ACTIONS(3138),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3138),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3138),
    [sym_preproc_directive] = ACTIONS(3138),
    [anon_sym_LPAREN2] = ACTIONS(3140),
    [anon_sym_BANG] = ACTIONS(3140),
    [anon_sym_TILDE] = ACTIONS(3140),
    [anon_sym_DASH] = ACTIONS(3138),
    [anon_sym_PLUS] = ACTIONS(3138),
    [anon_sym_STAR] = ACTIONS(3140),
    [anon_sym_AMP_AMP] = ACTIONS(3140),
    [anon_sym_AMP] = ACTIONS(3138),
    [anon_sym_SEMI] = ACTIONS(3140),
    [anon_sym___extension__] = ACTIONS(3138),
    [anon_sym_typedef] = ACTIONS(3138),
    [anon_sym_virtual] = ACTIONS(3138),
    [anon_sym_extern] = ACTIONS(3138),
    [anon_sym___attribute__] = ACTIONS(3138),
    [anon_sym___attribute] = ACTIONS(3138),
    [anon_sym_COLON_COLON] = ACTIONS(3140),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3140),
    [anon_sym___declspec] = ACTIONS(3138),
    [anon_sym___based] = ACTIONS(3138),
    [anon_sym___cdecl] = ACTIONS(3138),
    [anon_sym___clrcall] = ACTIONS(3138),
    [anon_sym___stdcall] = ACTIONS(3138),
    [anon_sym___fastcall] = ACTIONS(3138),
    [anon_sym___thiscall] = ACTIONS(3138),
    [anon_sym___vectorcall] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [anon_sym_RBRACE] = ACTIONS(3140),
    [anon_sym_signed] = ACTIONS(3138),
    [anon_sym_unsigned] = ACTIONS(3138),
    [anon_sym_long] = ACTIONS(3138),
    [anon_sym_short] = ACTIONS(3138),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_static] = ACTIONS(3138),
    [anon_sym_register] = ACTIONS(3138),
    [anon_sym_inline] = ACTIONS(3138),
    [anon_sym___inline] = ACTIONS(3138),
    [anon_sym___inline__] = ACTIONS(3138),
    [anon_sym___forceinline] = ACTIONS(3138),
    [anon_sym_thread_local] = ACTIONS(3138),
    [anon_sym___thread] = ACTIONS(3138),
    [anon_sym_const] = ACTIONS(3138),
    [anon_sym_constexpr] = ACTIONS(3138),
    [anon_sym_volatile] = ACTIONS(3138),
    [anon_sym_restrict] = ACTIONS(3138),
    [anon_sym___restrict__] = ACTIONS(3138),
    [anon_sym__Atomic] = ACTIONS(3138),
    [anon_sym__Noreturn] = ACTIONS(3138),
    [anon_sym_noreturn] = ACTIONS(3138),
    [anon_sym__Nonnull] = ACTIONS(3138),
    [anon_sym_mutable] = ACTIONS(3138),
    [anon_sym_constinit] = ACTIONS(3138),
    [anon_sym_consteval] = ACTIONS(3138),
    [anon_sym_alignas] = ACTIONS(3138),
    [anon_sym__Alignas] = ACTIONS(3138),
    [sym_primitive_type] = ACTIONS(3138),
    [anon_sym_enum] = ACTIONS(3138),
    [anon_sym_class] = ACTIONS(3138),
    [anon_sym_struct] = ACTIONS(3138),
    [anon_sym_union] = ACTIONS(3138),
    [anon_sym_if] = ACTIONS(3138),
    [anon_sym_switch] = ACTIONS(3138),
    [anon_sym_case] = ACTIONS(3138),
    [anon_sym_default] = ACTIONS(3138),
    [anon_sym_while] = ACTIONS(3138),
    [anon_sym_do] = ACTIONS(3138),
    [anon_sym_for] = ACTIONS(3138),
    [anon_sym_return] = ACTIONS(3138),
    [anon_sym_break] = ACTIONS(3138),
    [anon_sym_continue] = ACTIONS(3138),
    [anon_sym_goto] = ACTIONS(3138),
    [anon_sym___try] = ACTIONS(3138),
    [anon_sym___leave] = ACTIONS(3138),
    [anon_sym_not] = ACTIONS(3138),
    [anon_sym_compl] = ACTIONS(3138),
    [anon_sym_DASH_DASH] = ACTIONS(3140),
    [anon_sym_PLUS_PLUS] = ACTIONS(3140),
    [anon_sym_sizeof] = ACTIONS(3138),
    [anon_sym___alignof__] = ACTIONS(3138),
    [anon_sym___alignof] = ACTIONS(3138),
    [anon_sym__alignof] = ACTIONS(3138),
    [anon_sym_alignof] = ACTIONS(3138),
    [anon_sym__Alignof] = ACTIONS(3138),
    [anon_sym_offsetof] = ACTIONS(3138),
    [anon_sym__Generic] = ACTIONS(3138),
    [anon_sym_asm] = ACTIONS(3138),
    [anon_sym___asm__] = ACTIONS(3138),
    [anon_sym___asm] = ACTIONS(3138),
    [sym_number_literal] = ACTIONS(3140),
    [anon_sym_L_SQUOTE] = ACTIONS(3140),
    [anon_sym_u_SQUOTE] = ACTIONS(3140),
    [anon_sym_U_SQUOTE] = ACTIONS(3140),
    [anon_sym_u8_SQUOTE] = ACTIONS(3140),
    [anon_sym_SQUOTE] = ACTIONS(3140),
    [anon_sym_L_DQUOTE] = ACTIONS(3140),
    [anon_sym_u_DQUOTE] = ACTIONS(3140),
    [anon_sym_U_DQUOTE] = ACTIONS(3140),
    [anon_sym_u8_DQUOTE] = ACTIONS(3140),
    [anon_sym_DQUOTE] = ACTIONS(3140),
    [sym_true] = ACTIONS(3138),
    [sym_false] = ACTIONS(3138),
    [anon_sym_NULL] = ACTIONS(3138),
    [anon_sym_nullptr] = ACTIONS(3138),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3138),
    [anon_sym_decltype] = ACTIONS(3138),
    [anon_sym_explicit] = ACTIONS(3138),
    [anon_sym_typename] = ACTIONS(3138),
    [anon_sym_template] = ACTIONS(3138),
    [anon_sym_operator] = ACTIONS(3138),
    [anon_sym_try] = ACTIONS(3138),
    [anon_sym_delete] = ACTIONS(3138),
    [anon_sym_throw] = ACTIONS(3138),
    [anon_sym_namespace] = ACTIONS(3138),
    [anon_sym_using] = ACTIONS(3138),
    [anon_sym_static_assert] = ACTIONS(3138),
    [anon_sym_concept] = ACTIONS(3138),
    [anon_sym_co_return] = ACTIONS(3138),
    [anon_sym_co_yield] = ACTIONS(3138),
    [anon_sym_R_DQUOTE] = ACTIONS(3140),
    [anon_sym_LR_DQUOTE] = ACTIONS(3140),
    [anon_sym_uR_DQUOTE] = ACTIONS(3140),
    [anon_sym_UR_DQUOTE] = ACTIONS(3140),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3140),
    [anon_sym_co_await] = ACTIONS(3138),
    [anon_sym_new] = ACTIONS(3138),
    [anon_sym_requires] = ACTIONS(3138),
    [sym_this] = ACTIONS(3138),
  },
  [648] = {
    [sym_identifier] = ACTIONS(3142),
    [aux_sym_preproc_include_token1] = ACTIONS(3142),
    [aux_sym_preproc_def_token1] = ACTIONS(3142),
    [aux_sym_preproc_if_token1] = ACTIONS(3142),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3142),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3142),
    [sym_preproc_directive] = ACTIONS(3142),
    [anon_sym_LPAREN2] = ACTIONS(3144),
    [anon_sym_BANG] = ACTIONS(3144),
    [anon_sym_TILDE] = ACTIONS(3144),
    [anon_sym_DASH] = ACTIONS(3142),
    [anon_sym_PLUS] = ACTIONS(3142),
    [anon_sym_STAR] = ACTIONS(3144),
    [anon_sym_AMP_AMP] = ACTIONS(3144),
    [anon_sym_AMP] = ACTIONS(3142),
    [anon_sym_SEMI] = ACTIONS(3144),
    [anon_sym___extension__] = ACTIONS(3142),
    [anon_sym_typedef] = ACTIONS(3142),
    [anon_sym_virtual] = ACTIONS(3142),
    [anon_sym_extern] = ACTIONS(3142),
    [anon_sym___attribute__] = ACTIONS(3142),
    [anon_sym___attribute] = ACTIONS(3142),
    [anon_sym_COLON_COLON] = ACTIONS(3144),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3144),
    [anon_sym___declspec] = ACTIONS(3142),
    [anon_sym___based] = ACTIONS(3142),
    [anon_sym___cdecl] = ACTIONS(3142),
    [anon_sym___clrcall] = ACTIONS(3142),
    [anon_sym___stdcall] = ACTIONS(3142),
    [anon_sym___fastcall] = ACTIONS(3142),
    [anon_sym___thiscall] = ACTIONS(3142),
    [anon_sym___vectorcall] = ACTIONS(3142),
    [anon_sym_LBRACE] = ACTIONS(3144),
    [anon_sym_RBRACE] = ACTIONS(3144),
    [anon_sym_signed] = ACTIONS(3142),
    [anon_sym_unsigned] = ACTIONS(3142),
    [anon_sym_long] = ACTIONS(3142),
    [anon_sym_short] = ACTIONS(3142),
    [anon_sym_LBRACK] = ACTIONS(3142),
    [anon_sym_static] = ACTIONS(3142),
    [anon_sym_register] = ACTIONS(3142),
    [anon_sym_inline] = ACTIONS(3142),
    [anon_sym___inline] = ACTIONS(3142),
    [anon_sym___inline__] = ACTIONS(3142),
    [anon_sym___forceinline] = ACTIONS(3142),
    [anon_sym_thread_local] = ACTIONS(3142),
    [anon_sym___thread] = ACTIONS(3142),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_constexpr] = ACTIONS(3142),
    [anon_sym_volatile] = ACTIONS(3142),
    [anon_sym_restrict] = ACTIONS(3142),
    [anon_sym___restrict__] = ACTIONS(3142),
    [anon_sym__Atomic] = ACTIONS(3142),
    [anon_sym__Noreturn] = ACTIONS(3142),
    [anon_sym_noreturn] = ACTIONS(3142),
    [anon_sym__Nonnull] = ACTIONS(3142),
    [anon_sym_mutable] = ACTIONS(3142),
    [anon_sym_constinit] = ACTIONS(3142),
    [anon_sym_consteval] = ACTIONS(3142),
    [anon_sym_alignas] = ACTIONS(3142),
    [anon_sym__Alignas] = ACTIONS(3142),
    [sym_primitive_type] = ACTIONS(3142),
    [anon_sym_enum] = ACTIONS(3142),
    [anon_sym_class] = ACTIONS(3142),
    [anon_sym_struct] = ACTIONS(3142),
    [anon_sym_union] = ACTIONS(3142),
    [anon_sym_if] = ACTIONS(3142),
    [anon_sym_switch] = ACTIONS(3142),
    [anon_sym_case] = ACTIONS(3142),
    [anon_sym_default] = ACTIONS(3142),
    [anon_sym_while] = ACTIONS(3142),
    [anon_sym_do] = ACTIONS(3142),
    [anon_sym_for] = ACTIONS(3142),
    [anon_sym_return] = ACTIONS(3142),
    [anon_sym_break] = ACTIONS(3142),
    [anon_sym_continue] = ACTIONS(3142),
    [anon_sym_goto] = ACTIONS(3142),
    [anon_sym___try] = ACTIONS(3142),
    [anon_sym___leave] = ACTIONS(3142),
    [anon_sym_not] = ACTIONS(3142),
    [anon_sym_compl] = ACTIONS(3142),
    [anon_sym_DASH_DASH] = ACTIONS(3144),
    [anon_sym_PLUS_PLUS] = ACTIONS(3144),
    [anon_sym_sizeof] = ACTIONS(3142),
    [anon_sym___alignof__] = ACTIONS(3142),
    [anon_sym___alignof] = ACTIONS(3142),
    [anon_sym__alignof] = ACTIONS(3142),
    [anon_sym_alignof] = ACTIONS(3142),
    [anon_sym__Alignof] = ACTIONS(3142),
    [anon_sym_offsetof] = ACTIONS(3142),
    [anon_sym__Generic] = ACTIONS(3142),
    [anon_sym_asm] = ACTIONS(3142),
    [anon_sym___asm__] = ACTIONS(3142),
    [anon_sym___asm] = ACTIONS(3142),
    [sym_number_literal] = ACTIONS(3144),
    [anon_sym_L_SQUOTE] = ACTIONS(3144),
    [anon_sym_u_SQUOTE] = ACTIONS(3144),
    [anon_sym_U_SQUOTE] = ACTIONS(3144),
    [anon_sym_u8_SQUOTE] = ACTIONS(3144),
    [anon_sym_SQUOTE] = ACTIONS(3144),
    [anon_sym_L_DQUOTE] = ACTIONS(3144),
    [anon_sym_u_DQUOTE] = ACTIONS(3144),
    [anon_sym_U_DQUOTE] = ACTIONS(3144),
    [anon_sym_u8_DQUOTE] = ACTIONS(3144),
    [anon_sym_DQUOTE] = ACTIONS(3144),
    [sym_true] = ACTIONS(3142),
    [sym_false] = ACTIONS(3142),
    [anon_sym_NULL] = ACTIONS(3142),
    [anon_sym_nullptr] = ACTIONS(3142),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3142),
    [anon_sym_decltype] = ACTIONS(3142),
    [anon_sym_explicit] = ACTIONS(3142),
    [anon_sym_typename] = ACTIONS(3142),
    [anon_sym_template] = ACTIONS(3142),
    [anon_sym_operator] = ACTIONS(3142),
    [anon_sym_try] = ACTIONS(3142),
    [anon_sym_delete] = ACTIONS(3142),
    [anon_sym_throw] = ACTIONS(3142),
    [anon_sym_namespace] = ACTIONS(3142),
    [anon_sym_using] = ACTIONS(3142),
    [anon_sym_static_assert] = ACTIONS(3142),
    [anon_sym_concept] = ACTIONS(3142),
    [anon_sym_co_return] = ACTIONS(3142),
    [anon_sym_co_yield] = ACTIONS(3142),
    [anon_sym_R_DQUOTE] = ACTIONS(3144),
    [anon_sym_LR_DQUOTE] = ACTIONS(3144),
    [anon_sym_uR_DQUOTE] = ACTIONS(3144),
    [anon_sym_UR_DQUOTE] = ACTIONS(3144),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3144),
    [anon_sym_co_await] = ACTIONS(3142),
    [anon_sym_new] = ACTIONS(3142),
    [anon_sym_requires] = ACTIONS(3142),
    [sym_this] = ACTIONS(3142),
  },
  [649] = {
    [sym_identifier] = ACTIONS(2976),
    [aux_sym_preproc_include_token1] = ACTIONS(2976),
    [aux_sym_preproc_def_token1] = ACTIONS(2976),
    [aux_sym_preproc_if_token1] = ACTIONS(2976),
    [aux_sym_preproc_if_token2] = ACTIONS(2976),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2976),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2976),
    [sym_preproc_directive] = ACTIONS(2976),
    [anon_sym_LPAREN2] = ACTIONS(2978),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2976),
    [anon_sym_PLUS] = ACTIONS(2976),
    [anon_sym_STAR] = ACTIONS(2978),
    [anon_sym_AMP_AMP] = ACTIONS(2978),
    [anon_sym_AMP] = ACTIONS(2976),
    [anon_sym_SEMI] = ACTIONS(2978),
    [anon_sym___extension__] = ACTIONS(2976),
    [anon_sym_typedef] = ACTIONS(2976),
    [anon_sym_virtual] = ACTIONS(2976),
    [anon_sym_extern] = ACTIONS(2976),
    [anon_sym___attribute__] = ACTIONS(2976),
    [anon_sym___attribute] = ACTIONS(2976),
    [anon_sym_COLON_COLON] = ACTIONS(2978),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2978),
    [anon_sym___declspec] = ACTIONS(2976),
    [anon_sym___based] = ACTIONS(2976),
    [anon_sym___cdecl] = ACTIONS(2976),
    [anon_sym___clrcall] = ACTIONS(2976),
    [anon_sym___stdcall] = ACTIONS(2976),
    [anon_sym___fastcall] = ACTIONS(2976),
    [anon_sym___thiscall] = ACTIONS(2976),
    [anon_sym___vectorcall] = ACTIONS(2976),
    [anon_sym_LBRACE] = ACTIONS(2978),
    [anon_sym_signed] = ACTIONS(2976),
    [anon_sym_unsigned] = ACTIONS(2976),
    [anon_sym_long] = ACTIONS(2976),
    [anon_sym_short] = ACTIONS(2976),
    [anon_sym_LBRACK] = ACTIONS(2976),
    [anon_sym_static] = ACTIONS(2976),
    [anon_sym_register] = ACTIONS(2976),
    [anon_sym_inline] = ACTIONS(2976),
    [anon_sym___inline] = ACTIONS(2976),
    [anon_sym___inline__] = ACTIONS(2976),
    [anon_sym___forceinline] = ACTIONS(2976),
    [anon_sym_thread_local] = ACTIONS(2976),
    [anon_sym___thread] = ACTIONS(2976),
    [anon_sym_const] = ACTIONS(2976),
    [anon_sym_constexpr] = ACTIONS(2976),
    [anon_sym_volatile] = ACTIONS(2976),
    [anon_sym_restrict] = ACTIONS(2976),
    [anon_sym___restrict__] = ACTIONS(2976),
    [anon_sym__Atomic] = ACTIONS(2976),
    [anon_sym__Noreturn] = ACTIONS(2976),
    [anon_sym_noreturn] = ACTIONS(2976),
    [anon_sym__Nonnull] = ACTIONS(2976),
    [anon_sym_mutable] = ACTIONS(2976),
    [anon_sym_constinit] = ACTIONS(2976),
    [anon_sym_consteval] = ACTIONS(2976),
    [anon_sym_alignas] = ACTIONS(2976),
    [anon_sym__Alignas] = ACTIONS(2976),
    [sym_primitive_type] = ACTIONS(2976),
    [anon_sym_enum] = ACTIONS(2976),
    [anon_sym_class] = ACTIONS(2976),
    [anon_sym_struct] = ACTIONS(2976),
    [anon_sym_union] = ACTIONS(2976),
    [anon_sym_if] = ACTIONS(2976),
    [anon_sym_switch] = ACTIONS(2976),
    [anon_sym_case] = ACTIONS(2976),
    [anon_sym_default] = ACTIONS(2976),
    [anon_sym_while] = ACTIONS(2976),
    [anon_sym_do] = ACTIONS(2976),
    [anon_sym_for] = ACTIONS(2976),
    [anon_sym_return] = ACTIONS(2976),
    [anon_sym_break] = ACTIONS(2976),
    [anon_sym_continue] = ACTIONS(2976),
    [anon_sym_goto] = ACTIONS(2976),
    [anon_sym___try] = ACTIONS(2976),
    [anon_sym___leave] = ACTIONS(2976),
    [anon_sym_not] = ACTIONS(2976),
    [anon_sym_compl] = ACTIONS(2976),
    [anon_sym_DASH_DASH] = ACTIONS(2978),
    [anon_sym_PLUS_PLUS] = ACTIONS(2978),
    [anon_sym_sizeof] = ACTIONS(2976),
    [anon_sym___alignof__] = ACTIONS(2976),
    [anon_sym___alignof] = ACTIONS(2976),
    [anon_sym__alignof] = ACTIONS(2976),
    [anon_sym_alignof] = ACTIONS(2976),
    [anon_sym__Alignof] = ACTIONS(2976),
    [anon_sym_offsetof] = ACTIONS(2976),
    [anon_sym__Generic] = ACTIONS(2976),
    [anon_sym_asm] = ACTIONS(2976),
    [anon_sym___asm__] = ACTIONS(2976),
    [anon_sym___asm] = ACTIONS(2976),
    [sym_number_literal] = ACTIONS(2978),
    [anon_sym_L_SQUOTE] = ACTIONS(2978),
    [anon_sym_u_SQUOTE] = ACTIONS(2978),
    [anon_sym_U_SQUOTE] = ACTIONS(2978),
    [anon_sym_u8_SQUOTE] = ACTIONS(2978),
    [anon_sym_SQUOTE] = ACTIONS(2978),
    [anon_sym_L_DQUOTE] = ACTIONS(2978),
    [anon_sym_u_DQUOTE] = ACTIONS(2978),
    [anon_sym_U_DQUOTE] = ACTIONS(2978),
    [anon_sym_u8_DQUOTE] = ACTIONS(2978),
    [anon_sym_DQUOTE] = ACTIONS(2978),
    [sym_true] = ACTIONS(2976),
    [sym_false] = ACTIONS(2976),
    [anon_sym_NULL] = ACTIONS(2976),
    [anon_sym_nullptr] = ACTIONS(2976),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2976),
    [anon_sym_decltype] = ACTIONS(2976),
    [anon_sym_explicit] = ACTIONS(2976),
    [anon_sym_typename] = ACTIONS(2976),
    [anon_sym_template] = ACTIONS(2976),
    [anon_sym_operator] = ACTIONS(2976),
    [anon_sym_try] = ACTIONS(2976),
    [anon_sym_delete] = ACTIONS(2976),
    [anon_sym_throw] = ACTIONS(2976),
    [anon_sym_namespace] = ACTIONS(2976),
    [anon_sym_using] = ACTIONS(2976),
    [anon_sym_static_assert] = ACTIONS(2976),
    [anon_sym_concept] = ACTIONS(2976),
    [anon_sym_co_return] = ACTIONS(2976),
    [anon_sym_co_yield] = ACTIONS(2976),
    [anon_sym_R_DQUOTE] = ACTIONS(2978),
    [anon_sym_LR_DQUOTE] = ACTIONS(2978),
    [anon_sym_uR_DQUOTE] = ACTIONS(2978),
    [anon_sym_UR_DQUOTE] = ACTIONS(2978),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2978),
    [anon_sym_co_await] = ACTIONS(2976),
    [anon_sym_new] = ACTIONS(2976),
    [anon_sym_requires] = ACTIONS(2976),
    [sym_this] = ACTIONS(2976),
  },
  [650] = {
    [sym_identifier] = ACTIONS(2747),
    [aux_sym_preproc_include_token1] = ACTIONS(2747),
    [aux_sym_preproc_def_token1] = ACTIONS(2747),
    [aux_sym_preproc_if_token1] = ACTIONS(2747),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2747),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2747),
    [sym_preproc_directive] = ACTIONS(2747),
    [anon_sym_LPAREN2] = ACTIONS(2749),
    [anon_sym_BANG] = ACTIONS(2749),
    [anon_sym_TILDE] = ACTIONS(2749),
    [anon_sym_DASH] = ACTIONS(2747),
    [anon_sym_PLUS] = ACTIONS(2747),
    [anon_sym_STAR] = ACTIONS(2749),
    [anon_sym_AMP_AMP] = ACTIONS(2749),
    [anon_sym_AMP] = ACTIONS(2747),
    [anon_sym_SEMI] = ACTIONS(2749),
    [anon_sym___extension__] = ACTIONS(2747),
    [anon_sym_typedef] = ACTIONS(2747),
    [anon_sym_virtual] = ACTIONS(2747),
    [anon_sym_extern] = ACTIONS(2747),
    [anon_sym___attribute__] = ACTIONS(2747),
    [anon_sym___attribute] = ACTIONS(2747),
    [anon_sym_COLON_COLON] = ACTIONS(2749),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2749),
    [anon_sym___declspec] = ACTIONS(2747),
    [anon_sym___based] = ACTIONS(2747),
    [anon_sym___cdecl] = ACTIONS(2747),
    [anon_sym___clrcall] = ACTIONS(2747),
    [anon_sym___stdcall] = ACTIONS(2747),
    [anon_sym___fastcall] = ACTIONS(2747),
    [anon_sym___thiscall] = ACTIONS(2747),
    [anon_sym___vectorcall] = ACTIONS(2747),
    [anon_sym_LBRACE] = ACTIONS(2749),
    [anon_sym_RBRACE] = ACTIONS(2749),
    [anon_sym_signed] = ACTIONS(2747),
    [anon_sym_unsigned] = ACTIONS(2747),
    [anon_sym_long] = ACTIONS(2747),
    [anon_sym_short] = ACTIONS(2747),
    [anon_sym_LBRACK] = ACTIONS(2747),
    [anon_sym_static] = ACTIONS(2747),
    [anon_sym_register] = ACTIONS(2747),
    [anon_sym_inline] = ACTIONS(2747),
    [anon_sym___inline] = ACTIONS(2747),
    [anon_sym___inline__] = ACTIONS(2747),
    [anon_sym___forceinline] = ACTIONS(2747),
    [anon_sym_thread_local] = ACTIONS(2747),
    [anon_sym___thread] = ACTIONS(2747),
    [anon_sym_const] = ACTIONS(2747),
    [anon_sym_constexpr] = ACTIONS(2747),
    [anon_sym_volatile] = ACTIONS(2747),
    [anon_sym_restrict] = ACTIONS(2747),
    [anon_sym___restrict__] = ACTIONS(2747),
    [anon_sym__Atomic] = ACTIONS(2747),
    [anon_sym__Noreturn] = ACTIONS(2747),
    [anon_sym_noreturn] = ACTIONS(2747),
    [anon_sym__Nonnull] = ACTIONS(2747),
    [anon_sym_mutable] = ACTIONS(2747),
    [anon_sym_constinit] = ACTIONS(2747),
    [anon_sym_consteval] = ACTIONS(2747),
    [anon_sym_alignas] = ACTIONS(2747),
    [anon_sym__Alignas] = ACTIONS(2747),
    [sym_primitive_type] = ACTIONS(2747),
    [anon_sym_enum] = ACTIONS(2747),
    [anon_sym_class] = ACTIONS(2747),
    [anon_sym_struct] = ACTIONS(2747),
    [anon_sym_union] = ACTIONS(2747),
    [anon_sym_if] = ACTIONS(2747),
    [anon_sym_switch] = ACTIONS(2747),
    [anon_sym_case] = ACTIONS(2747),
    [anon_sym_default] = ACTIONS(2747),
    [anon_sym_while] = ACTIONS(2747),
    [anon_sym_do] = ACTIONS(2747),
    [anon_sym_for] = ACTIONS(2747),
    [anon_sym_return] = ACTIONS(2747),
    [anon_sym_break] = ACTIONS(2747),
    [anon_sym_continue] = ACTIONS(2747),
    [anon_sym_goto] = ACTIONS(2747),
    [anon_sym___try] = ACTIONS(2747),
    [anon_sym___leave] = ACTIONS(2747),
    [anon_sym_not] = ACTIONS(2747),
    [anon_sym_compl] = ACTIONS(2747),
    [anon_sym_DASH_DASH] = ACTIONS(2749),
    [anon_sym_PLUS_PLUS] = ACTIONS(2749),
    [anon_sym_sizeof] = ACTIONS(2747),
    [anon_sym___alignof__] = ACTIONS(2747),
    [anon_sym___alignof] = ACTIONS(2747),
    [anon_sym__alignof] = ACTIONS(2747),
    [anon_sym_alignof] = ACTIONS(2747),
    [anon_sym__Alignof] = ACTIONS(2747),
    [anon_sym_offsetof] = ACTIONS(2747),
    [anon_sym__Generic] = ACTIONS(2747),
    [anon_sym_asm] = ACTIONS(2747),
    [anon_sym___asm__] = ACTIONS(2747),
    [anon_sym___asm] = ACTIONS(2747),
    [sym_number_literal] = ACTIONS(2749),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2749),
    [anon_sym_u_DQUOTE] = ACTIONS(2749),
    [anon_sym_U_DQUOTE] = ACTIONS(2749),
    [anon_sym_u8_DQUOTE] = ACTIONS(2749),
    [anon_sym_DQUOTE] = ACTIONS(2749),
    [sym_true] = ACTIONS(2747),
    [sym_false] = ACTIONS(2747),
    [anon_sym_NULL] = ACTIONS(2747),
    [anon_sym_nullptr] = ACTIONS(2747),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2747),
    [anon_sym_decltype] = ACTIONS(2747),
    [anon_sym_explicit] = ACTIONS(2747),
    [anon_sym_typename] = ACTIONS(2747),
    [anon_sym_template] = ACTIONS(2747),
    [anon_sym_operator] = ACTIONS(2747),
    [anon_sym_try] = ACTIONS(2747),
    [anon_sym_delete] = ACTIONS(2747),
    [anon_sym_throw] = ACTIONS(2747),
    [anon_sym_namespace] = ACTIONS(2747),
    [anon_sym_using] = ACTIONS(2747),
    [anon_sym_static_assert] = ACTIONS(2747),
    [anon_sym_concept] = ACTIONS(2747),
    [anon_sym_co_return] = ACTIONS(2747),
    [anon_sym_co_yield] = ACTIONS(2747),
    [anon_sym_R_DQUOTE] = ACTIONS(2749),
    [anon_sym_LR_DQUOTE] = ACTIONS(2749),
    [anon_sym_uR_DQUOTE] = ACTIONS(2749),
    [anon_sym_UR_DQUOTE] = ACTIONS(2749),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2749),
    [anon_sym_co_await] = ACTIONS(2747),
    [anon_sym_new] = ACTIONS(2747),
    [anon_sym_requires] = ACTIONS(2747),
    [sym_this] = ACTIONS(2747),
  },
  [651] = {
    [sym_identifier] = ACTIONS(2747),
    [aux_sym_preproc_include_token1] = ACTIONS(2747),
    [aux_sym_preproc_def_token1] = ACTIONS(2747),
    [aux_sym_preproc_if_token1] = ACTIONS(2747),
    [aux_sym_preproc_if_token2] = ACTIONS(2747),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2747),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2747),
    [sym_preproc_directive] = ACTIONS(2747),
    [anon_sym_LPAREN2] = ACTIONS(2749),
    [anon_sym_BANG] = ACTIONS(2749),
    [anon_sym_TILDE] = ACTIONS(2749),
    [anon_sym_DASH] = ACTIONS(2747),
    [anon_sym_PLUS] = ACTIONS(2747),
    [anon_sym_STAR] = ACTIONS(2749),
    [anon_sym_AMP_AMP] = ACTIONS(2749),
    [anon_sym_AMP] = ACTIONS(2747),
    [anon_sym_SEMI] = ACTIONS(2749),
    [anon_sym___extension__] = ACTIONS(2747),
    [anon_sym_typedef] = ACTIONS(2747),
    [anon_sym_virtual] = ACTIONS(2747),
    [anon_sym_extern] = ACTIONS(2747),
    [anon_sym___attribute__] = ACTIONS(2747),
    [anon_sym___attribute] = ACTIONS(2747),
    [anon_sym_COLON_COLON] = ACTIONS(2749),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2749),
    [anon_sym___declspec] = ACTIONS(2747),
    [anon_sym___based] = ACTIONS(2747),
    [anon_sym___cdecl] = ACTIONS(2747),
    [anon_sym___clrcall] = ACTIONS(2747),
    [anon_sym___stdcall] = ACTIONS(2747),
    [anon_sym___fastcall] = ACTIONS(2747),
    [anon_sym___thiscall] = ACTIONS(2747),
    [anon_sym___vectorcall] = ACTIONS(2747),
    [anon_sym_LBRACE] = ACTIONS(2749),
    [anon_sym_signed] = ACTIONS(2747),
    [anon_sym_unsigned] = ACTIONS(2747),
    [anon_sym_long] = ACTIONS(2747),
    [anon_sym_short] = ACTIONS(2747),
    [anon_sym_LBRACK] = ACTIONS(2747),
    [anon_sym_static] = ACTIONS(2747),
    [anon_sym_register] = ACTIONS(2747),
    [anon_sym_inline] = ACTIONS(2747),
    [anon_sym___inline] = ACTIONS(2747),
    [anon_sym___inline__] = ACTIONS(2747),
    [anon_sym___forceinline] = ACTIONS(2747),
    [anon_sym_thread_local] = ACTIONS(2747),
    [anon_sym___thread] = ACTIONS(2747),
    [anon_sym_const] = ACTIONS(2747),
    [anon_sym_constexpr] = ACTIONS(2747),
    [anon_sym_volatile] = ACTIONS(2747),
    [anon_sym_restrict] = ACTIONS(2747),
    [anon_sym___restrict__] = ACTIONS(2747),
    [anon_sym__Atomic] = ACTIONS(2747),
    [anon_sym__Noreturn] = ACTIONS(2747),
    [anon_sym_noreturn] = ACTIONS(2747),
    [anon_sym__Nonnull] = ACTIONS(2747),
    [anon_sym_mutable] = ACTIONS(2747),
    [anon_sym_constinit] = ACTIONS(2747),
    [anon_sym_consteval] = ACTIONS(2747),
    [anon_sym_alignas] = ACTIONS(2747),
    [anon_sym__Alignas] = ACTIONS(2747),
    [sym_primitive_type] = ACTIONS(2747),
    [anon_sym_enum] = ACTIONS(2747),
    [anon_sym_class] = ACTIONS(2747),
    [anon_sym_struct] = ACTIONS(2747),
    [anon_sym_union] = ACTIONS(2747),
    [anon_sym_if] = ACTIONS(2747),
    [anon_sym_switch] = ACTIONS(2747),
    [anon_sym_case] = ACTIONS(2747),
    [anon_sym_default] = ACTIONS(2747),
    [anon_sym_while] = ACTIONS(2747),
    [anon_sym_do] = ACTIONS(2747),
    [anon_sym_for] = ACTIONS(2747),
    [anon_sym_return] = ACTIONS(2747),
    [anon_sym_break] = ACTIONS(2747),
    [anon_sym_continue] = ACTIONS(2747),
    [anon_sym_goto] = ACTIONS(2747),
    [anon_sym___try] = ACTIONS(2747),
    [anon_sym___leave] = ACTIONS(2747),
    [anon_sym_not] = ACTIONS(2747),
    [anon_sym_compl] = ACTIONS(2747),
    [anon_sym_DASH_DASH] = ACTIONS(2749),
    [anon_sym_PLUS_PLUS] = ACTIONS(2749),
    [anon_sym_sizeof] = ACTIONS(2747),
    [anon_sym___alignof__] = ACTIONS(2747),
    [anon_sym___alignof] = ACTIONS(2747),
    [anon_sym__alignof] = ACTIONS(2747),
    [anon_sym_alignof] = ACTIONS(2747),
    [anon_sym__Alignof] = ACTIONS(2747),
    [anon_sym_offsetof] = ACTIONS(2747),
    [anon_sym__Generic] = ACTIONS(2747),
    [anon_sym_asm] = ACTIONS(2747),
    [anon_sym___asm__] = ACTIONS(2747),
    [anon_sym___asm] = ACTIONS(2747),
    [sym_number_literal] = ACTIONS(2749),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2749),
    [anon_sym_u_DQUOTE] = ACTIONS(2749),
    [anon_sym_U_DQUOTE] = ACTIONS(2749),
    [anon_sym_u8_DQUOTE] = ACTIONS(2749),
    [anon_sym_DQUOTE] = ACTIONS(2749),
    [sym_true] = ACTIONS(2747),
    [sym_false] = ACTIONS(2747),
    [anon_sym_NULL] = ACTIONS(2747),
    [anon_sym_nullptr] = ACTIONS(2747),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2747),
    [anon_sym_decltype] = ACTIONS(2747),
    [anon_sym_explicit] = ACTIONS(2747),
    [anon_sym_typename] = ACTIONS(2747),
    [anon_sym_template] = ACTIONS(2747),
    [anon_sym_operator] = ACTIONS(2747),
    [anon_sym_try] = ACTIONS(2747),
    [anon_sym_delete] = ACTIONS(2747),
    [anon_sym_throw] = ACTIONS(2747),
    [anon_sym_namespace] = ACTIONS(2747),
    [anon_sym_using] = ACTIONS(2747),
    [anon_sym_static_assert] = ACTIONS(2747),
    [anon_sym_concept] = ACTIONS(2747),
    [anon_sym_co_return] = ACTIONS(2747),
    [anon_sym_co_yield] = ACTIONS(2747),
    [anon_sym_R_DQUOTE] = ACTIONS(2749),
    [anon_sym_LR_DQUOTE] = ACTIONS(2749),
    [anon_sym_uR_DQUOTE] = ACTIONS(2749),
    [anon_sym_UR_DQUOTE] = ACTIONS(2749),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2749),
    [anon_sym_co_await] = ACTIONS(2747),
    [anon_sym_new] = ACTIONS(2747),
    [anon_sym_requires] = ACTIONS(2747),
    [sym_this] = ACTIONS(2747),
  },
  [652] = {
    [sym_identifier] = ACTIONS(3154),
    [aux_sym_preproc_include_token1] = ACTIONS(3154),
    [aux_sym_preproc_def_token1] = ACTIONS(3154),
    [aux_sym_preproc_if_token1] = ACTIONS(3154),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3154),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3154),
    [sym_preproc_directive] = ACTIONS(3154),
    [anon_sym_LPAREN2] = ACTIONS(3156),
    [anon_sym_BANG] = ACTIONS(3156),
    [anon_sym_TILDE] = ACTIONS(3156),
    [anon_sym_DASH] = ACTIONS(3154),
    [anon_sym_PLUS] = ACTIONS(3154),
    [anon_sym_STAR] = ACTIONS(3156),
    [anon_sym_AMP_AMP] = ACTIONS(3156),
    [anon_sym_AMP] = ACTIONS(3154),
    [anon_sym_SEMI] = ACTIONS(3156),
    [anon_sym___extension__] = ACTIONS(3154),
    [anon_sym_typedef] = ACTIONS(3154),
    [anon_sym_virtual] = ACTIONS(3154),
    [anon_sym_extern] = ACTIONS(3154),
    [anon_sym___attribute__] = ACTIONS(3154),
    [anon_sym___attribute] = ACTIONS(3154),
    [anon_sym_COLON_COLON] = ACTIONS(3156),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3156),
    [anon_sym___declspec] = ACTIONS(3154),
    [anon_sym___based] = ACTIONS(3154),
    [anon_sym___cdecl] = ACTIONS(3154),
    [anon_sym___clrcall] = ACTIONS(3154),
    [anon_sym___stdcall] = ACTIONS(3154),
    [anon_sym___fastcall] = ACTIONS(3154),
    [anon_sym___thiscall] = ACTIONS(3154),
    [anon_sym___vectorcall] = ACTIONS(3154),
    [anon_sym_LBRACE] = ACTIONS(3156),
    [anon_sym_RBRACE] = ACTIONS(3156),
    [anon_sym_signed] = ACTIONS(3154),
    [anon_sym_unsigned] = ACTIONS(3154),
    [anon_sym_long] = ACTIONS(3154),
    [anon_sym_short] = ACTIONS(3154),
    [anon_sym_LBRACK] = ACTIONS(3154),
    [anon_sym_static] = ACTIONS(3154),
    [anon_sym_register] = ACTIONS(3154),
    [anon_sym_inline] = ACTIONS(3154),
    [anon_sym___inline] = ACTIONS(3154),
    [anon_sym___inline__] = ACTIONS(3154),
    [anon_sym___forceinline] = ACTIONS(3154),
    [anon_sym_thread_local] = ACTIONS(3154),
    [anon_sym___thread] = ACTIONS(3154),
    [anon_sym_const] = ACTIONS(3154),
    [anon_sym_constexpr] = ACTIONS(3154),
    [anon_sym_volatile] = ACTIONS(3154),
    [anon_sym_restrict] = ACTIONS(3154),
    [anon_sym___restrict__] = ACTIONS(3154),
    [anon_sym__Atomic] = ACTIONS(3154),
    [anon_sym__Noreturn] = ACTIONS(3154),
    [anon_sym_noreturn] = ACTIONS(3154),
    [anon_sym__Nonnull] = ACTIONS(3154),
    [anon_sym_mutable] = ACTIONS(3154),
    [anon_sym_constinit] = ACTIONS(3154),
    [anon_sym_consteval] = ACTIONS(3154),
    [anon_sym_alignas] = ACTIONS(3154),
    [anon_sym__Alignas] = ACTIONS(3154),
    [sym_primitive_type] = ACTIONS(3154),
    [anon_sym_enum] = ACTIONS(3154),
    [anon_sym_class] = ACTIONS(3154),
    [anon_sym_struct] = ACTIONS(3154),
    [anon_sym_union] = ACTIONS(3154),
    [anon_sym_if] = ACTIONS(3154),
    [anon_sym_switch] = ACTIONS(3154),
    [anon_sym_case] = ACTIONS(3154),
    [anon_sym_default] = ACTIONS(3154),
    [anon_sym_while] = ACTIONS(3154),
    [anon_sym_do] = ACTIONS(3154),
    [anon_sym_for] = ACTIONS(3154),
    [anon_sym_return] = ACTIONS(3154),
    [anon_sym_break] = ACTIONS(3154),
    [anon_sym_continue] = ACTIONS(3154),
    [anon_sym_goto] = ACTIONS(3154),
    [anon_sym___try] = ACTIONS(3154),
    [anon_sym___leave] = ACTIONS(3154),
    [anon_sym_not] = ACTIONS(3154),
    [anon_sym_compl] = ACTIONS(3154),
    [anon_sym_DASH_DASH] = ACTIONS(3156),
    [anon_sym_PLUS_PLUS] = ACTIONS(3156),
    [anon_sym_sizeof] = ACTIONS(3154),
    [anon_sym___alignof__] = ACTIONS(3154),
    [anon_sym___alignof] = ACTIONS(3154),
    [anon_sym__alignof] = ACTIONS(3154),
    [anon_sym_alignof] = ACTIONS(3154),
    [anon_sym__Alignof] = ACTIONS(3154),
    [anon_sym_offsetof] = ACTIONS(3154),
    [anon_sym__Generic] = ACTIONS(3154),
    [anon_sym_asm] = ACTIONS(3154),
    [anon_sym___asm__] = ACTIONS(3154),
    [anon_sym___asm] = ACTIONS(3154),
    [sym_number_literal] = ACTIONS(3156),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3156),
    [anon_sym_u_DQUOTE] = ACTIONS(3156),
    [anon_sym_U_DQUOTE] = ACTIONS(3156),
    [anon_sym_u8_DQUOTE] = ACTIONS(3156),
    [anon_sym_DQUOTE] = ACTIONS(3156),
    [sym_true] = ACTIONS(3154),
    [sym_false] = ACTIONS(3154),
    [anon_sym_NULL] = ACTIONS(3154),
    [anon_sym_nullptr] = ACTIONS(3154),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3154),
    [anon_sym_decltype] = ACTIONS(3154),
    [anon_sym_explicit] = ACTIONS(3154),
    [anon_sym_typename] = ACTIONS(3154),
    [anon_sym_template] = ACTIONS(3154),
    [anon_sym_operator] = ACTIONS(3154),
    [anon_sym_try] = ACTIONS(3154),
    [anon_sym_delete] = ACTIONS(3154),
    [anon_sym_throw] = ACTIONS(3154),
    [anon_sym_namespace] = ACTIONS(3154),
    [anon_sym_using] = ACTIONS(3154),
    [anon_sym_static_assert] = ACTIONS(3154),
    [anon_sym_concept] = ACTIONS(3154),
    [anon_sym_co_return] = ACTIONS(3154),
    [anon_sym_co_yield] = ACTIONS(3154),
    [anon_sym_R_DQUOTE] = ACTIONS(3156),
    [anon_sym_LR_DQUOTE] = ACTIONS(3156),
    [anon_sym_uR_DQUOTE] = ACTIONS(3156),
    [anon_sym_UR_DQUOTE] = ACTIONS(3156),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3156),
    [anon_sym_co_await] = ACTIONS(3154),
    [anon_sym_new] = ACTIONS(3154),
    [anon_sym_requires] = ACTIONS(3154),
    [sym_this] = ACTIONS(3154),
  },
  [653] = {
    [sym_identifier] = ACTIONS(2747),
    [aux_sym_preproc_include_token1] = ACTIONS(2747),
    [aux_sym_preproc_def_token1] = ACTIONS(2747),
    [aux_sym_preproc_if_token1] = ACTIONS(2747),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2747),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2747),
    [sym_preproc_directive] = ACTIONS(2747),
    [anon_sym_LPAREN2] = ACTIONS(2749),
    [anon_sym_BANG] = ACTIONS(2749),
    [anon_sym_TILDE] = ACTIONS(2749),
    [anon_sym_DASH] = ACTIONS(2747),
    [anon_sym_PLUS] = ACTIONS(2747),
    [anon_sym_STAR] = ACTIONS(2749),
    [anon_sym_AMP_AMP] = ACTIONS(2749),
    [anon_sym_AMP] = ACTIONS(2747),
    [anon_sym_SEMI] = ACTIONS(2749),
    [anon_sym___extension__] = ACTIONS(2747),
    [anon_sym_typedef] = ACTIONS(2747),
    [anon_sym_virtual] = ACTIONS(2747),
    [anon_sym_extern] = ACTIONS(2747),
    [anon_sym___attribute__] = ACTIONS(2747),
    [anon_sym___attribute] = ACTIONS(2747),
    [anon_sym_COLON_COLON] = ACTIONS(2749),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2749),
    [anon_sym___declspec] = ACTIONS(2747),
    [anon_sym___based] = ACTIONS(2747),
    [anon_sym___cdecl] = ACTIONS(2747),
    [anon_sym___clrcall] = ACTIONS(2747),
    [anon_sym___stdcall] = ACTIONS(2747),
    [anon_sym___fastcall] = ACTIONS(2747),
    [anon_sym___thiscall] = ACTIONS(2747),
    [anon_sym___vectorcall] = ACTIONS(2747),
    [anon_sym_LBRACE] = ACTIONS(2749),
    [anon_sym_RBRACE] = ACTIONS(2749),
    [anon_sym_signed] = ACTIONS(2747),
    [anon_sym_unsigned] = ACTIONS(2747),
    [anon_sym_long] = ACTIONS(2747),
    [anon_sym_short] = ACTIONS(2747),
    [anon_sym_LBRACK] = ACTIONS(2747),
    [anon_sym_static] = ACTIONS(2747),
    [anon_sym_register] = ACTIONS(2747),
    [anon_sym_inline] = ACTIONS(2747),
    [anon_sym___inline] = ACTIONS(2747),
    [anon_sym___inline__] = ACTIONS(2747),
    [anon_sym___forceinline] = ACTIONS(2747),
    [anon_sym_thread_local] = ACTIONS(2747),
    [anon_sym___thread] = ACTIONS(2747),
    [anon_sym_const] = ACTIONS(2747),
    [anon_sym_constexpr] = ACTIONS(2747),
    [anon_sym_volatile] = ACTIONS(2747),
    [anon_sym_restrict] = ACTIONS(2747),
    [anon_sym___restrict__] = ACTIONS(2747),
    [anon_sym__Atomic] = ACTIONS(2747),
    [anon_sym__Noreturn] = ACTIONS(2747),
    [anon_sym_noreturn] = ACTIONS(2747),
    [anon_sym__Nonnull] = ACTIONS(2747),
    [anon_sym_mutable] = ACTIONS(2747),
    [anon_sym_constinit] = ACTIONS(2747),
    [anon_sym_consteval] = ACTIONS(2747),
    [anon_sym_alignas] = ACTIONS(2747),
    [anon_sym__Alignas] = ACTIONS(2747),
    [sym_primitive_type] = ACTIONS(2747),
    [anon_sym_enum] = ACTIONS(2747),
    [anon_sym_class] = ACTIONS(2747),
    [anon_sym_struct] = ACTIONS(2747),
    [anon_sym_union] = ACTIONS(2747),
    [anon_sym_if] = ACTIONS(2747),
    [anon_sym_switch] = ACTIONS(2747),
    [anon_sym_case] = ACTIONS(2747),
    [anon_sym_default] = ACTIONS(2747),
    [anon_sym_while] = ACTIONS(2747),
    [anon_sym_do] = ACTIONS(2747),
    [anon_sym_for] = ACTIONS(2747),
    [anon_sym_return] = ACTIONS(2747),
    [anon_sym_break] = ACTIONS(2747),
    [anon_sym_continue] = ACTIONS(2747),
    [anon_sym_goto] = ACTIONS(2747),
    [anon_sym___try] = ACTIONS(2747),
    [anon_sym___leave] = ACTIONS(2747),
    [anon_sym_not] = ACTIONS(2747),
    [anon_sym_compl] = ACTIONS(2747),
    [anon_sym_DASH_DASH] = ACTIONS(2749),
    [anon_sym_PLUS_PLUS] = ACTIONS(2749),
    [anon_sym_sizeof] = ACTIONS(2747),
    [anon_sym___alignof__] = ACTIONS(2747),
    [anon_sym___alignof] = ACTIONS(2747),
    [anon_sym__alignof] = ACTIONS(2747),
    [anon_sym_alignof] = ACTIONS(2747),
    [anon_sym__Alignof] = ACTIONS(2747),
    [anon_sym_offsetof] = ACTIONS(2747),
    [anon_sym__Generic] = ACTIONS(2747),
    [anon_sym_asm] = ACTIONS(2747),
    [anon_sym___asm__] = ACTIONS(2747),
    [anon_sym___asm] = ACTIONS(2747),
    [sym_number_literal] = ACTIONS(2749),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2749),
    [anon_sym_u_DQUOTE] = ACTIONS(2749),
    [anon_sym_U_DQUOTE] = ACTIONS(2749),
    [anon_sym_u8_DQUOTE] = ACTIONS(2749),
    [anon_sym_DQUOTE] = ACTIONS(2749),
    [sym_true] = ACTIONS(2747),
    [sym_false] = ACTIONS(2747),
    [anon_sym_NULL] = ACTIONS(2747),
    [anon_sym_nullptr] = ACTIONS(2747),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2747),
    [anon_sym_decltype] = ACTIONS(2747),
    [anon_sym_explicit] = ACTIONS(2747),
    [anon_sym_typename] = ACTIONS(2747),
    [anon_sym_template] = ACTIONS(2747),
    [anon_sym_operator] = ACTIONS(2747),
    [anon_sym_try] = ACTIONS(2747),
    [anon_sym_delete] = ACTIONS(2747),
    [anon_sym_throw] = ACTIONS(2747),
    [anon_sym_namespace] = ACTIONS(2747),
    [anon_sym_using] = ACTIONS(2747),
    [anon_sym_static_assert] = ACTIONS(2747),
    [anon_sym_concept] = ACTIONS(2747),
    [anon_sym_co_return] = ACTIONS(2747),
    [anon_sym_co_yield] = ACTIONS(2747),
    [anon_sym_R_DQUOTE] = ACTIONS(2749),
    [anon_sym_LR_DQUOTE] = ACTIONS(2749),
    [anon_sym_uR_DQUOTE] = ACTIONS(2749),
    [anon_sym_UR_DQUOTE] = ACTIONS(2749),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2749),
    [anon_sym_co_await] = ACTIONS(2747),
    [anon_sym_new] = ACTIONS(2747),
    [anon_sym_requires] = ACTIONS(2747),
    [sym_this] = ACTIONS(2747),
  },
  [654] = {
    [sym_identifier] = ACTIONS(3042),
    [aux_sym_preproc_include_token1] = ACTIONS(3042),
    [aux_sym_preproc_def_token1] = ACTIONS(3042),
    [aux_sym_preproc_if_token1] = ACTIONS(3042),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3042),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3042),
    [sym_preproc_directive] = ACTIONS(3042),
    [anon_sym_LPAREN2] = ACTIONS(3044),
    [anon_sym_BANG] = ACTIONS(3044),
    [anon_sym_TILDE] = ACTIONS(3044),
    [anon_sym_DASH] = ACTIONS(3042),
    [anon_sym_PLUS] = ACTIONS(3042),
    [anon_sym_STAR] = ACTIONS(3044),
    [anon_sym_AMP_AMP] = ACTIONS(3044),
    [anon_sym_AMP] = ACTIONS(3042),
    [anon_sym_SEMI] = ACTIONS(3044),
    [anon_sym___extension__] = ACTIONS(3042),
    [anon_sym_typedef] = ACTIONS(3042),
    [anon_sym_virtual] = ACTIONS(3042),
    [anon_sym_extern] = ACTIONS(3042),
    [anon_sym___attribute__] = ACTIONS(3042),
    [anon_sym___attribute] = ACTIONS(3042),
    [anon_sym_COLON_COLON] = ACTIONS(3044),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3044),
    [anon_sym___declspec] = ACTIONS(3042),
    [anon_sym___based] = ACTIONS(3042),
    [anon_sym___cdecl] = ACTIONS(3042),
    [anon_sym___clrcall] = ACTIONS(3042),
    [anon_sym___stdcall] = ACTIONS(3042),
    [anon_sym___fastcall] = ACTIONS(3042),
    [anon_sym___thiscall] = ACTIONS(3042),
    [anon_sym___vectorcall] = ACTIONS(3042),
    [anon_sym_LBRACE] = ACTIONS(3044),
    [anon_sym_RBRACE] = ACTIONS(3044),
    [anon_sym_signed] = ACTIONS(3042),
    [anon_sym_unsigned] = ACTIONS(3042),
    [anon_sym_long] = ACTIONS(3042),
    [anon_sym_short] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3042),
    [anon_sym_static] = ACTIONS(3042),
    [anon_sym_register] = ACTIONS(3042),
    [anon_sym_inline] = ACTIONS(3042),
    [anon_sym___inline] = ACTIONS(3042),
    [anon_sym___inline__] = ACTIONS(3042),
    [anon_sym___forceinline] = ACTIONS(3042),
    [anon_sym_thread_local] = ACTIONS(3042),
    [anon_sym___thread] = ACTIONS(3042),
    [anon_sym_const] = ACTIONS(3042),
    [anon_sym_constexpr] = ACTIONS(3042),
    [anon_sym_volatile] = ACTIONS(3042),
    [anon_sym_restrict] = ACTIONS(3042),
    [anon_sym___restrict__] = ACTIONS(3042),
    [anon_sym__Atomic] = ACTIONS(3042),
    [anon_sym__Noreturn] = ACTIONS(3042),
    [anon_sym_noreturn] = ACTIONS(3042),
    [anon_sym__Nonnull] = ACTIONS(3042),
    [anon_sym_mutable] = ACTIONS(3042),
    [anon_sym_constinit] = ACTIONS(3042),
    [anon_sym_consteval] = ACTIONS(3042),
    [anon_sym_alignas] = ACTIONS(3042),
    [anon_sym__Alignas] = ACTIONS(3042),
    [sym_primitive_type] = ACTIONS(3042),
    [anon_sym_enum] = ACTIONS(3042),
    [anon_sym_class] = ACTIONS(3042),
    [anon_sym_struct] = ACTIONS(3042),
    [anon_sym_union] = ACTIONS(3042),
    [anon_sym_if] = ACTIONS(3042),
    [anon_sym_switch] = ACTIONS(3042),
    [anon_sym_case] = ACTIONS(3042),
    [anon_sym_default] = ACTIONS(3042),
    [anon_sym_while] = ACTIONS(3042),
    [anon_sym_do] = ACTIONS(3042),
    [anon_sym_for] = ACTIONS(3042),
    [anon_sym_return] = ACTIONS(3042),
    [anon_sym_break] = ACTIONS(3042),
    [anon_sym_continue] = ACTIONS(3042),
    [anon_sym_goto] = ACTIONS(3042),
    [anon_sym___try] = ACTIONS(3042),
    [anon_sym___leave] = ACTIONS(3042),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_compl] = ACTIONS(3042),
    [anon_sym_DASH_DASH] = ACTIONS(3044),
    [anon_sym_PLUS_PLUS] = ACTIONS(3044),
    [anon_sym_sizeof] = ACTIONS(3042),
    [anon_sym___alignof__] = ACTIONS(3042),
    [anon_sym___alignof] = ACTIONS(3042),
    [anon_sym__alignof] = ACTIONS(3042),
    [anon_sym_alignof] = ACTIONS(3042),
    [anon_sym__Alignof] = ACTIONS(3042),
    [anon_sym_offsetof] = ACTIONS(3042),
    [anon_sym__Generic] = ACTIONS(3042),
    [anon_sym_asm] = ACTIONS(3042),
    [anon_sym___asm__] = ACTIONS(3042),
    [anon_sym___asm] = ACTIONS(3042),
    [sym_number_literal] = ACTIONS(3044),
    [anon_sym_L_SQUOTE] = ACTIONS(3044),
    [anon_sym_u_SQUOTE] = ACTIONS(3044),
    [anon_sym_U_SQUOTE] = ACTIONS(3044),
    [anon_sym_u8_SQUOTE] = ACTIONS(3044),
    [anon_sym_SQUOTE] = ACTIONS(3044),
    [anon_sym_L_DQUOTE] = ACTIONS(3044),
    [anon_sym_u_DQUOTE] = ACTIONS(3044),
    [anon_sym_U_DQUOTE] = ACTIONS(3044),
    [anon_sym_u8_DQUOTE] = ACTIONS(3044),
    [anon_sym_DQUOTE] = ACTIONS(3044),
    [sym_true] = ACTIONS(3042),
    [sym_false] = ACTIONS(3042),
    [anon_sym_NULL] = ACTIONS(3042),
    [anon_sym_nullptr] = ACTIONS(3042),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3042),
    [anon_sym_decltype] = ACTIONS(3042),
    [anon_sym_explicit] = ACTIONS(3042),
    [anon_sym_typename] = ACTIONS(3042),
    [anon_sym_template] = ACTIONS(3042),
    [anon_sym_operator] = ACTIONS(3042),
    [anon_sym_try] = ACTIONS(3042),
    [anon_sym_delete] = ACTIONS(3042),
    [anon_sym_throw] = ACTIONS(3042),
    [anon_sym_namespace] = ACTIONS(3042),
    [anon_sym_using] = ACTIONS(3042),
    [anon_sym_static_assert] = ACTIONS(3042),
    [anon_sym_concept] = ACTIONS(3042),
    [anon_sym_co_return] = ACTIONS(3042),
    [anon_sym_co_yield] = ACTIONS(3042),
    [anon_sym_R_DQUOTE] = ACTIONS(3044),
    [anon_sym_LR_DQUOTE] = ACTIONS(3044),
    [anon_sym_uR_DQUOTE] = ACTIONS(3044),
    [anon_sym_UR_DQUOTE] = ACTIONS(3044),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3044),
    [anon_sym_co_await] = ACTIONS(3042),
    [anon_sym_new] = ACTIONS(3042),
    [anon_sym_requires] = ACTIONS(3042),
    [sym_this] = ACTIONS(3042),
  },
  [655] = {
    [sym_identifier] = ACTIONS(3042),
    [aux_sym_preproc_include_token1] = ACTIONS(3042),
    [aux_sym_preproc_def_token1] = ACTIONS(3042),
    [aux_sym_preproc_if_token1] = ACTIONS(3042),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3042),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3042),
    [sym_preproc_directive] = ACTIONS(3042),
    [anon_sym_LPAREN2] = ACTIONS(3044),
    [anon_sym_BANG] = ACTIONS(3044),
    [anon_sym_TILDE] = ACTIONS(3044),
    [anon_sym_DASH] = ACTIONS(3042),
    [anon_sym_PLUS] = ACTIONS(3042),
    [anon_sym_STAR] = ACTIONS(3044),
    [anon_sym_AMP_AMP] = ACTIONS(3044),
    [anon_sym_AMP] = ACTIONS(3042),
    [anon_sym_SEMI] = ACTIONS(3044),
    [anon_sym___extension__] = ACTIONS(3042),
    [anon_sym_typedef] = ACTIONS(3042),
    [anon_sym_virtual] = ACTIONS(3042),
    [anon_sym_extern] = ACTIONS(3042),
    [anon_sym___attribute__] = ACTIONS(3042),
    [anon_sym___attribute] = ACTIONS(3042),
    [anon_sym_COLON_COLON] = ACTIONS(3044),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3044),
    [anon_sym___declspec] = ACTIONS(3042),
    [anon_sym___based] = ACTIONS(3042),
    [anon_sym___cdecl] = ACTIONS(3042),
    [anon_sym___clrcall] = ACTIONS(3042),
    [anon_sym___stdcall] = ACTIONS(3042),
    [anon_sym___fastcall] = ACTIONS(3042),
    [anon_sym___thiscall] = ACTIONS(3042),
    [anon_sym___vectorcall] = ACTIONS(3042),
    [anon_sym_LBRACE] = ACTIONS(3044),
    [anon_sym_RBRACE] = ACTIONS(3044),
    [anon_sym_signed] = ACTIONS(3042),
    [anon_sym_unsigned] = ACTIONS(3042),
    [anon_sym_long] = ACTIONS(3042),
    [anon_sym_short] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3042),
    [anon_sym_static] = ACTIONS(3042),
    [anon_sym_register] = ACTIONS(3042),
    [anon_sym_inline] = ACTIONS(3042),
    [anon_sym___inline] = ACTIONS(3042),
    [anon_sym___inline__] = ACTIONS(3042),
    [anon_sym___forceinline] = ACTIONS(3042),
    [anon_sym_thread_local] = ACTIONS(3042),
    [anon_sym___thread] = ACTIONS(3042),
    [anon_sym_const] = ACTIONS(3042),
    [anon_sym_constexpr] = ACTIONS(3042),
    [anon_sym_volatile] = ACTIONS(3042),
    [anon_sym_restrict] = ACTIONS(3042),
    [anon_sym___restrict__] = ACTIONS(3042),
    [anon_sym__Atomic] = ACTIONS(3042),
    [anon_sym__Noreturn] = ACTIONS(3042),
    [anon_sym_noreturn] = ACTIONS(3042),
    [anon_sym__Nonnull] = ACTIONS(3042),
    [anon_sym_mutable] = ACTIONS(3042),
    [anon_sym_constinit] = ACTIONS(3042),
    [anon_sym_consteval] = ACTIONS(3042),
    [anon_sym_alignas] = ACTIONS(3042),
    [anon_sym__Alignas] = ACTIONS(3042),
    [sym_primitive_type] = ACTIONS(3042),
    [anon_sym_enum] = ACTIONS(3042),
    [anon_sym_class] = ACTIONS(3042),
    [anon_sym_struct] = ACTIONS(3042),
    [anon_sym_union] = ACTIONS(3042),
    [anon_sym_if] = ACTIONS(3042),
    [anon_sym_switch] = ACTIONS(3042),
    [anon_sym_case] = ACTIONS(3042),
    [anon_sym_default] = ACTIONS(3042),
    [anon_sym_while] = ACTIONS(3042),
    [anon_sym_do] = ACTIONS(3042),
    [anon_sym_for] = ACTIONS(3042),
    [anon_sym_return] = ACTIONS(3042),
    [anon_sym_break] = ACTIONS(3042),
    [anon_sym_continue] = ACTIONS(3042),
    [anon_sym_goto] = ACTIONS(3042),
    [anon_sym___try] = ACTIONS(3042),
    [anon_sym___leave] = ACTIONS(3042),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_compl] = ACTIONS(3042),
    [anon_sym_DASH_DASH] = ACTIONS(3044),
    [anon_sym_PLUS_PLUS] = ACTIONS(3044),
    [anon_sym_sizeof] = ACTIONS(3042),
    [anon_sym___alignof__] = ACTIONS(3042),
    [anon_sym___alignof] = ACTIONS(3042),
    [anon_sym__alignof] = ACTIONS(3042),
    [anon_sym_alignof] = ACTIONS(3042),
    [anon_sym__Alignof] = ACTIONS(3042),
    [anon_sym_offsetof] = ACTIONS(3042),
    [anon_sym__Generic] = ACTIONS(3042),
    [anon_sym_asm] = ACTIONS(3042),
    [anon_sym___asm__] = ACTIONS(3042),
    [anon_sym___asm] = ACTIONS(3042),
    [sym_number_literal] = ACTIONS(3044),
    [anon_sym_L_SQUOTE] = ACTIONS(3044),
    [anon_sym_u_SQUOTE] = ACTIONS(3044),
    [anon_sym_U_SQUOTE] = ACTIONS(3044),
    [anon_sym_u8_SQUOTE] = ACTIONS(3044),
    [anon_sym_SQUOTE] = ACTIONS(3044),
    [anon_sym_L_DQUOTE] = ACTIONS(3044),
    [anon_sym_u_DQUOTE] = ACTIONS(3044),
    [anon_sym_U_DQUOTE] = ACTIONS(3044),
    [anon_sym_u8_DQUOTE] = ACTIONS(3044),
    [anon_sym_DQUOTE] = ACTIONS(3044),
    [sym_true] = ACTIONS(3042),
    [sym_false] = ACTIONS(3042),
    [anon_sym_NULL] = ACTIONS(3042),
    [anon_sym_nullptr] = ACTIONS(3042),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3042),
    [anon_sym_decltype] = ACTIONS(3042),
    [anon_sym_explicit] = ACTIONS(3042),
    [anon_sym_typename] = ACTIONS(3042),
    [anon_sym_template] = ACTIONS(3042),
    [anon_sym_operator] = ACTIONS(3042),
    [anon_sym_try] = ACTIONS(3042),
    [anon_sym_delete] = ACTIONS(3042),
    [anon_sym_throw] = ACTIONS(3042),
    [anon_sym_namespace] = ACTIONS(3042),
    [anon_sym_using] = ACTIONS(3042),
    [anon_sym_static_assert] = ACTIONS(3042),
    [anon_sym_concept] = ACTIONS(3042),
    [anon_sym_co_return] = ACTIONS(3042),
    [anon_sym_co_yield] = ACTIONS(3042),
    [anon_sym_R_DQUOTE] = ACTIONS(3044),
    [anon_sym_LR_DQUOTE] = ACTIONS(3044),
    [anon_sym_uR_DQUOTE] = ACTIONS(3044),
    [anon_sym_UR_DQUOTE] = ACTIONS(3044),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3044),
    [anon_sym_co_await] = ACTIONS(3042),
    [anon_sym_new] = ACTIONS(3042),
    [anon_sym_requires] = ACTIONS(3042),
    [sym_this] = ACTIONS(3042),
  },
  [656] = {
    [sym_identifier] = ACTIONS(3046),
    [aux_sym_preproc_include_token1] = ACTIONS(3046),
    [aux_sym_preproc_def_token1] = ACTIONS(3046),
    [aux_sym_preproc_if_token1] = ACTIONS(3046),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3046),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3046),
    [sym_preproc_directive] = ACTIONS(3046),
    [anon_sym_LPAREN2] = ACTIONS(3048),
    [anon_sym_BANG] = ACTIONS(3048),
    [anon_sym_TILDE] = ACTIONS(3048),
    [anon_sym_DASH] = ACTIONS(3046),
    [anon_sym_PLUS] = ACTIONS(3046),
    [anon_sym_STAR] = ACTIONS(3048),
    [anon_sym_AMP_AMP] = ACTIONS(3048),
    [anon_sym_AMP] = ACTIONS(3046),
    [anon_sym_SEMI] = ACTIONS(3048),
    [anon_sym___extension__] = ACTIONS(3046),
    [anon_sym_typedef] = ACTIONS(3046),
    [anon_sym_virtual] = ACTIONS(3046),
    [anon_sym_extern] = ACTIONS(3046),
    [anon_sym___attribute__] = ACTIONS(3046),
    [anon_sym___attribute] = ACTIONS(3046),
    [anon_sym_COLON_COLON] = ACTIONS(3048),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3048),
    [anon_sym___declspec] = ACTIONS(3046),
    [anon_sym___based] = ACTIONS(3046),
    [anon_sym___cdecl] = ACTIONS(3046),
    [anon_sym___clrcall] = ACTIONS(3046),
    [anon_sym___stdcall] = ACTIONS(3046),
    [anon_sym___fastcall] = ACTIONS(3046),
    [anon_sym___thiscall] = ACTIONS(3046),
    [anon_sym___vectorcall] = ACTIONS(3046),
    [anon_sym_LBRACE] = ACTIONS(3048),
    [anon_sym_RBRACE] = ACTIONS(3048),
    [anon_sym_signed] = ACTIONS(3046),
    [anon_sym_unsigned] = ACTIONS(3046),
    [anon_sym_long] = ACTIONS(3046),
    [anon_sym_short] = ACTIONS(3046),
    [anon_sym_LBRACK] = ACTIONS(3046),
    [anon_sym_static] = ACTIONS(3046),
    [anon_sym_register] = ACTIONS(3046),
    [anon_sym_inline] = ACTIONS(3046),
    [anon_sym___inline] = ACTIONS(3046),
    [anon_sym___inline__] = ACTIONS(3046),
    [anon_sym___forceinline] = ACTIONS(3046),
    [anon_sym_thread_local] = ACTIONS(3046),
    [anon_sym___thread] = ACTIONS(3046),
    [anon_sym_const] = ACTIONS(3046),
    [anon_sym_constexpr] = ACTIONS(3046),
    [anon_sym_volatile] = ACTIONS(3046),
    [anon_sym_restrict] = ACTIONS(3046),
    [anon_sym___restrict__] = ACTIONS(3046),
    [anon_sym__Atomic] = ACTIONS(3046),
    [anon_sym__Noreturn] = ACTIONS(3046),
    [anon_sym_noreturn] = ACTIONS(3046),
    [anon_sym__Nonnull] = ACTIONS(3046),
    [anon_sym_mutable] = ACTIONS(3046),
    [anon_sym_constinit] = ACTIONS(3046),
    [anon_sym_consteval] = ACTIONS(3046),
    [anon_sym_alignas] = ACTIONS(3046),
    [anon_sym__Alignas] = ACTIONS(3046),
    [sym_primitive_type] = ACTIONS(3046),
    [anon_sym_enum] = ACTIONS(3046),
    [anon_sym_class] = ACTIONS(3046),
    [anon_sym_struct] = ACTIONS(3046),
    [anon_sym_union] = ACTIONS(3046),
    [anon_sym_if] = ACTIONS(3046),
    [anon_sym_switch] = ACTIONS(3046),
    [anon_sym_case] = ACTIONS(3046),
    [anon_sym_default] = ACTIONS(3046),
    [anon_sym_while] = ACTIONS(3046),
    [anon_sym_do] = ACTIONS(3046),
    [anon_sym_for] = ACTIONS(3046),
    [anon_sym_return] = ACTIONS(3046),
    [anon_sym_break] = ACTIONS(3046),
    [anon_sym_continue] = ACTIONS(3046),
    [anon_sym_goto] = ACTIONS(3046),
    [anon_sym___try] = ACTIONS(3046),
    [anon_sym___leave] = ACTIONS(3046),
    [anon_sym_not] = ACTIONS(3046),
    [anon_sym_compl] = ACTIONS(3046),
    [anon_sym_DASH_DASH] = ACTIONS(3048),
    [anon_sym_PLUS_PLUS] = ACTIONS(3048),
    [anon_sym_sizeof] = ACTIONS(3046),
    [anon_sym___alignof__] = ACTIONS(3046),
    [anon_sym___alignof] = ACTIONS(3046),
    [anon_sym__alignof] = ACTIONS(3046),
    [anon_sym_alignof] = ACTIONS(3046),
    [anon_sym__Alignof] = ACTIONS(3046),
    [anon_sym_offsetof] = ACTIONS(3046),
    [anon_sym__Generic] = ACTIONS(3046),
    [anon_sym_asm] = ACTIONS(3046),
    [anon_sym___asm__] = ACTIONS(3046),
    [anon_sym___asm] = ACTIONS(3046),
    [sym_number_literal] = ACTIONS(3048),
    [anon_sym_L_SQUOTE] = ACTIONS(3048),
    [anon_sym_u_SQUOTE] = ACTIONS(3048),
    [anon_sym_U_SQUOTE] = ACTIONS(3048),
    [anon_sym_u8_SQUOTE] = ACTIONS(3048),
    [anon_sym_SQUOTE] = ACTIONS(3048),
    [anon_sym_L_DQUOTE] = ACTIONS(3048),
    [anon_sym_u_DQUOTE] = ACTIONS(3048),
    [anon_sym_U_DQUOTE] = ACTIONS(3048),
    [anon_sym_u8_DQUOTE] = ACTIONS(3048),
    [anon_sym_DQUOTE] = ACTIONS(3048),
    [sym_true] = ACTIONS(3046),
    [sym_false] = ACTIONS(3046),
    [anon_sym_NULL] = ACTIONS(3046),
    [anon_sym_nullptr] = ACTIONS(3046),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3046),
    [anon_sym_decltype] = ACTIONS(3046),
    [anon_sym_explicit] = ACTIONS(3046),
    [anon_sym_typename] = ACTIONS(3046),
    [anon_sym_template] = ACTIONS(3046),
    [anon_sym_operator] = ACTIONS(3046),
    [anon_sym_try] = ACTIONS(3046),
    [anon_sym_delete] = ACTIONS(3046),
    [anon_sym_throw] = ACTIONS(3046),
    [anon_sym_namespace] = ACTIONS(3046),
    [anon_sym_using] = ACTIONS(3046),
    [anon_sym_static_assert] = ACTIONS(3046),
    [anon_sym_concept] = ACTIONS(3046),
    [anon_sym_co_return] = ACTIONS(3046),
    [anon_sym_co_yield] = ACTIONS(3046),
    [anon_sym_R_DQUOTE] = ACTIONS(3048),
    [anon_sym_LR_DQUOTE] = ACTIONS(3048),
    [anon_sym_uR_DQUOTE] = ACTIONS(3048),
    [anon_sym_UR_DQUOTE] = ACTIONS(3048),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3048),
    [anon_sym_co_await] = ACTIONS(3046),
    [anon_sym_new] = ACTIONS(3046),
    [anon_sym_requires] = ACTIONS(3046),
    [sym_this] = ACTIONS(3046),
  },
  [657] = {
    [sym_identifier] = ACTIONS(2747),
    [aux_sym_preproc_include_token1] = ACTIONS(2747),
    [aux_sym_preproc_def_token1] = ACTIONS(2747),
    [aux_sym_preproc_if_token1] = ACTIONS(2747),
    [aux_sym_preproc_if_token2] = ACTIONS(2747),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2747),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2747),
    [sym_preproc_directive] = ACTIONS(2747),
    [anon_sym_LPAREN2] = ACTIONS(2749),
    [anon_sym_BANG] = ACTIONS(2749),
    [anon_sym_TILDE] = ACTIONS(2749),
    [anon_sym_DASH] = ACTIONS(2747),
    [anon_sym_PLUS] = ACTIONS(2747),
    [anon_sym_STAR] = ACTIONS(2749),
    [anon_sym_AMP_AMP] = ACTIONS(2749),
    [anon_sym_AMP] = ACTIONS(2747),
    [anon_sym_SEMI] = ACTIONS(2749),
    [anon_sym___extension__] = ACTIONS(2747),
    [anon_sym_typedef] = ACTIONS(2747),
    [anon_sym_virtual] = ACTIONS(2747),
    [anon_sym_extern] = ACTIONS(2747),
    [anon_sym___attribute__] = ACTIONS(2747),
    [anon_sym___attribute] = ACTIONS(2747),
    [anon_sym_COLON_COLON] = ACTIONS(2749),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2749),
    [anon_sym___declspec] = ACTIONS(2747),
    [anon_sym___based] = ACTIONS(2747),
    [anon_sym___cdecl] = ACTIONS(2747),
    [anon_sym___clrcall] = ACTIONS(2747),
    [anon_sym___stdcall] = ACTIONS(2747),
    [anon_sym___fastcall] = ACTIONS(2747),
    [anon_sym___thiscall] = ACTIONS(2747),
    [anon_sym___vectorcall] = ACTIONS(2747),
    [anon_sym_LBRACE] = ACTIONS(2749),
    [anon_sym_signed] = ACTIONS(2747),
    [anon_sym_unsigned] = ACTIONS(2747),
    [anon_sym_long] = ACTIONS(2747),
    [anon_sym_short] = ACTIONS(2747),
    [anon_sym_LBRACK] = ACTIONS(2747),
    [anon_sym_static] = ACTIONS(2747),
    [anon_sym_register] = ACTIONS(2747),
    [anon_sym_inline] = ACTIONS(2747),
    [anon_sym___inline] = ACTIONS(2747),
    [anon_sym___inline__] = ACTIONS(2747),
    [anon_sym___forceinline] = ACTIONS(2747),
    [anon_sym_thread_local] = ACTIONS(2747),
    [anon_sym___thread] = ACTIONS(2747),
    [anon_sym_const] = ACTIONS(2747),
    [anon_sym_constexpr] = ACTIONS(2747),
    [anon_sym_volatile] = ACTIONS(2747),
    [anon_sym_restrict] = ACTIONS(2747),
    [anon_sym___restrict__] = ACTIONS(2747),
    [anon_sym__Atomic] = ACTIONS(2747),
    [anon_sym__Noreturn] = ACTIONS(2747),
    [anon_sym_noreturn] = ACTIONS(2747),
    [anon_sym__Nonnull] = ACTIONS(2747),
    [anon_sym_mutable] = ACTIONS(2747),
    [anon_sym_constinit] = ACTIONS(2747),
    [anon_sym_consteval] = ACTIONS(2747),
    [anon_sym_alignas] = ACTIONS(2747),
    [anon_sym__Alignas] = ACTIONS(2747),
    [sym_primitive_type] = ACTIONS(2747),
    [anon_sym_enum] = ACTIONS(2747),
    [anon_sym_class] = ACTIONS(2747),
    [anon_sym_struct] = ACTIONS(2747),
    [anon_sym_union] = ACTIONS(2747),
    [anon_sym_if] = ACTIONS(2747),
    [anon_sym_switch] = ACTIONS(2747),
    [anon_sym_case] = ACTIONS(2747),
    [anon_sym_default] = ACTIONS(2747),
    [anon_sym_while] = ACTIONS(2747),
    [anon_sym_do] = ACTIONS(2747),
    [anon_sym_for] = ACTIONS(2747),
    [anon_sym_return] = ACTIONS(2747),
    [anon_sym_break] = ACTIONS(2747),
    [anon_sym_continue] = ACTIONS(2747),
    [anon_sym_goto] = ACTIONS(2747),
    [anon_sym___try] = ACTIONS(2747),
    [anon_sym___leave] = ACTIONS(2747),
    [anon_sym_not] = ACTIONS(2747),
    [anon_sym_compl] = ACTIONS(2747),
    [anon_sym_DASH_DASH] = ACTIONS(2749),
    [anon_sym_PLUS_PLUS] = ACTIONS(2749),
    [anon_sym_sizeof] = ACTIONS(2747),
    [anon_sym___alignof__] = ACTIONS(2747),
    [anon_sym___alignof] = ACTIONS(2747),
    [anon_sym__alignof] = ACTIONS(2747),
    [anon_sym_alignof] = ACTIONS(2747),
    [anon_sym__Alignof] = ACTIONS(2747),
    [anon_sym_offsetof] = ACTIONS(2747),
    [anon_sym__Generic] = ACTIONS(2747),
    [anon_sym_asm] = ACTIONS(2747),
    [anon_sym___asm__] = ACTIONS(2747),
    [anon_sym___asm] = ACTIONS(2747),
    [sym_number_literal] = ACTIONS(2749),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2749),
    [anon_sym_u_DQUOTE] = ACTIONS(2749),
    [anon_sym_U_DQUOTE] = ACTIONS(2749),
    [anon_sym_u8_DQUOTE] = ACTIONS(2749),
    [anon_sym_DQUOTE] = ACTIONS(2749),
    [sym_true] = ACTIONS(2747),
    [sym_false] = ACTIONS(2747),
    [anon_sym_NULL] = ACTIONS(2747),
    [anon_sym_nullptr] = ACTIONS(2747),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2747),
    [anon_sym_decltype] = ACTIONS(2747),
    [anon_sym_explicit] = ACTIONS(2747),
    [anon_sym_typename] = ACTIONS(2747),
    [anon_sym_template] = ACTIONS(2747),
    [anon_sym_operator] = ACTIONS(2747),
    [anon_sym_try] = ACTIONS(2747),
    [anon_sym_delete] = ACTIONS(2747),
    [anon_sym_throw] = ACTIONS(2747),
    [anon_sym_namespace] = ACTIONS(2747),
    [anon_sym_using] = ACTIONS(2747),
    [anon_sym_static_assert] = ACTIONS(2747),
    [anon_sym_concept] = ACTIONS(2747),
    [anon_sym_co_return] = ACTIONS(2747),
    [anon_sym_co_yield] = ACTIONS(2747),
    [anon_sym_R_DQUOTE] = ACTIONS(2749),
    [anon_sym_LR_DQUOTE] = ACTIONS(2749),
    [anon_sym_uR_DQUOTE] = ACTIONS(2749),
    [anon_sym_UR_DQUOTE] = ACTIONS(2749),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2749),
    [anon_sym_co_await] = ACTIONS(2747),
    [anon_sym_new] = ACTIONS(2747),
    [anon_sym_requires] = ACTIONS(2747),
    [sym_this] = ACTIONS(2747),
  },
  [658] = {
    [sym_identifier] = ACTIONS(3009),
    [aux_sym_preproc_include_token1] = ACTIONS(3009),
    [aux_sym_preproc_def_token1] = ACTIONS(3009),
    [aux_sym_preproc_if_token1] = ACTIONS(3009),
    [aux_sym_preproc_if_token2] = ACTIONS(3009),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3009),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3009),
    [sym_preproc_directive] = ACTIONS(3009),
    [anon_sym_LPAREN2] = ACTIONS(3011),
    [anon_sym_BANG] = ACTIONS(3011),
    [anon_sym_TILDE] = ACTIONS(3011),
    [anon_sym_DASH] = ACTIONS(3009),
    [anon_sym_PLUS] = ACTIONS(3009),
    [anon_sym_STAR] = ACTIONS(3011),
    [anon_sym_AMP_AMP] = ACTIONS(3011),
    [anon_sym_AMP] = ACTIONS(3009),
    [anon_sym_SEMI] = ACTIONS(3011),
    [anon_sym___extension__] = ACTIONS(3009),
    [anon_sym_typedef] = ACTIONS(3009),
    [anon_sym_virtual] = ACTIONS(3009),
    [anon_sym_extern] = ACTIONS(3009),
    [anon_sym___attribute__] = ACTIONS(3009),
    [anon_sym___attribute] = ACTIONS(3009),
    [anon_sym_COLON_COLON] = ACTIONS(3011),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3011),
    [anon_sym___declspec] = ACTIONS(3009),
    [anon_sym___based] = ACTIONS(3009),
    [anon_sym___cdecl] = ACTIONS(3009),
    [anon_sym___clrcall] = ACTIONS(3009),
    [anon_sym___stdcall] = ACTIONS(3009),
    [anon_sym___fastcall] = ACTIONS(3009),
    [anon_sym___thiscall] = ACTIONS(3009),
    [anon_sym___vectorcall] = ACTIONS(3009),
    [anon_sym_LBRACE] = ACTIONS(3011),
    [anon_sym_signed] = ACTIONS(3009),
    [anon_sym_unsigned] = ACTIONS(3009),
    [anon_sym_long] = ACTIONS(3009),
    [anon_sym_short] = ACTIONS(3009),
    [anon_sym_LBRACK] = ACTIONS(3009),
    [anon_sym_static] = ACTIONS(3009),
    [anon_sym_register] = ACTIONS(3009),
    [anon_sym_inline] = ACTIONS(3009),
    [anon_sym___inline] = ACTIONS(3009),
    [anon_sym___inline__] = ACTIONS(3009),
    [anon_sym___forceinline] = ACTIONS(3009),
    [anon_sym_thread_local] = ACTIONS(3009),
    [anon_sym___thread] = ACTIONS(3009),
    [anon_sym_const] = ACTIONS(3009),
    [anon_sym_constexpr] = ACTIONS(3009),
    [anon_sym_volatile] = ACTIONS(3009),
    [anon_sym_restrict] = ACTIONS(3009),
    [anon_sym___restrict__] = ACTIONS(3009),
    [anon_sym__Atomic] = ACTIONS(3009),
    [anon_sym__Noreturn] = ACTIONS(3009),
    [anon_sym_noreturn] = ACTIONS(3009),
    [anon_sym__Nonnull] = ACTIONS(3009),
    [anon_sym_mutable] = ACTIONS(3009),
    [anon_sym_constinit] = ACTIONS(3009),
    [anon_sym_consteval] = ACTIONS(3009),
    [anon_sym_alignas] = ACTIONS(3009),
    [anon_sym__Alignas] = ACTIONS(3009),
    [sym_primitive_type] = ACTIONS(3009),
    [anon_sym_enum] = ACTIONS(3009),
    [anon_sym_class] = ACTIONS(3009),
    [anon_sym_struct] = ACTIONS(3009),
    [anon_sym_union] = ACTIONS(3009),
    [anon_sym_if] = ACTIONS(3009),
    [anon_sym_switch] = ACTIONS(3009),
    [anon_sym_case] = ACTIONS(3009),
    [anon_sym_default] = ACTIONS(3009),
    [anon_sym_while] = ACTIONS(3009),
    [anon_sym_do] = ACTIONS(3009),
    [anon_sym_for] = ACTIONS(3009),
    [anon_sym_return] = ACTIONS(3009),
    [anon_sym_break] = ACTIONS(3009),
    [anon_sym_continue] = ACTIONS(3009),
    [anon_sym_goto] = ACTIONS(3009),
    [anon_sym___try] = ACTIONS(3009),
    [anon_sym___leave] = ACTIONS(3009),
    [anon_sym_not] = ACTIONS(3009),
    [anon_sym_compl] = ACTIONS(3009),
    [anon_sym_DASH_DASH] = ACTIONS(3011),
    [anon_sym_PLUS_PLUS] = ACTIONS(3011),
    [anon_sym_sizeof] = ACTIONS(3009),
    [anon_sym___alignof__] = ACTIONS(3009),
    [anon_sym___alignof] = ACTIONS(3009),
    [anon_sym__alignof] = ACTIONS(3009),
    [anon_sym_alignof] = ACTIONS(3009),
    [anon_sym__Alignof] = ACTIONS(3009),
    [anon_sym_offsetof] = ACTIONS(3009),
    [anon_sym__Generic] = ACTIONS(3009),
    [anon_sym_asm] = ACTIONS(3009),
    [anon_sym___asm__] = ACTIONS(3009),
    [anon_sym___asm] = ACTIONS(3009),
    [sym_number_literal] = ACTIONS(3011),
    [anon_sym_L_SQUOTE] = ACTIONS(3011),
    [anon_sym_u_SQUOTE] = ACTIONS(3011),
    [anon_sym_U_SQUOTE] = ACTIONS(3011),
    [anon_sym_u8_SQUOTE] = ACTIONS(3011),
    [anon_sym_SQUOTE] = ACTIONS(3011),
    [anon_sym_L_DQUOTE] = ACTIONS(3011),
    [anon_sym_u_DQUOTE] = ACTIONS(3011),
    [anon_sym_U_DQUOTE] = ACTIONS(3011),
    [anon_sym_u8_DQUOTE] = ACTIONS(3011),
    [anon_sym_DQUOTE] = ACTIONS(3011),
    [sym_true] = ACTIONS(3009),
    [sym_false] = ACTIONS(3009),
    [anon_sym_NULL] = ACTIONS(3009),
    [anon_sym_nullptr] = ACTIONS(3009),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3009),
    [anon_sym_decltype] = ACTIONS(3009),
    [anon_sym_explicit] = ACTIONS(3009),
    [anon_sym_typename] = ACTIONS(3009),
    [anon_sym_template] = ACTIONS(3009),
    [anon_sym_operator] = ACTIONS(3009),
    [anon_sym_try] = ACTIONS(3009),
    [anon_sym_delete] = ACTIONS(3009),
    [anon_sym_throw] = ACTIONS(3009),
    [anon_sym_namespace] = ACTIONS(3009),
    [anon_sym_using] = ACTIONS(3009),
    [anon_sym_static_assert] = ACTIONS(3009),
    [anon_sym_concept] = ACTIONS(3009),
    [anon_sym_co_return] = ACTIONS(3009),
    [anon_sym_co_yield] = ACTIONS(3009),
    [anon_sym_R_DQUOTE] = ACTIONS(3011),
    [anon_sym_LR_DQUOTE] = ACTIONS(3011),
    [anon_sym_uR_DQUOTE] = ACTIONS(3011),
    [anon_sym_UR_DQUOTE] = ACTIONS(3011),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3011),
    [anon_sym_co_await] = ACTIONS(3009),
    [anon_sym_new] = ACTIONS(3009),
    [anon_sym_requires] = ACTIONS(3009),
    [sym_this] = ACTIONS(3009),
  },
  [659] = {
    [sym_identifier] = ACTIONS(3170),
    [aux_sym_preproc_include_token1] = ACTIONS(3170),
    [aux_sym_preproc_def_token1] = ACTIONS(3170),
    [aux_sym_preproc_if_token1] = ACTIONS(3170),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3170),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3170),
    [sym_preproc_directive] = ACTIONS(3170),
    [anon_sym_LPAREN2] = ACTIONS(3172),
    [anon_sym_BANG] = ACTIONS(3172),
    [anon_sym_TILDE] = ACTIONS(3172),
    [anon_sym_DASH] = ACTIONS(3170),
    [anon_sym_PLUS] = ACTIONS(3170),
    [anon_sym_STAR] = ACTIONS(3172),
    [anon_sym_AMP_AMP] = ACTIONS(3172),
    [anon_sym_AMP] = ACTIONS(3170),
    [anon_sym_SEMI] = ACTIONS(3172),
    [anon_sym___extension__] = ACTIONS(3170),
    [anon_sym_typedef] = ACTIONS(3170),
    [anon_sym_virtual] = ACTIONS(3170),
    [anon_sym_extern] = ACTIONS(3170),
    [anon_sym___attribute__] = ACTIONS(3170),
    [anon_sym___attribute] = ACTIONS(3170),
    [anon_sym_COLON_COLON] = ACTIONS(3172),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3172),
    [anon_sym___declspec] = ACTIONS(3170),
    [anon_sym___based] = ACTIONS(3170),
    [anon_sym___cdecl] = ACTIONS(3170),
    [anon_sym___clrcall] = ACTIONS(3170),
    [anon_sym___stdcall] = ACTIONS(3170),
    [anon_sym___fastcall] = ACTIONS(3170),
    [anon_sym___thiscall] = ACTIONS(3170),
    [anon_sym___vectorcall] = ACTIONS(3170),
    [anon_sym_LBRACE] = ACTIONS(3172),
    [anon_sym_RBRACE] = ACTIONS(3172),
    [anon_sym_signed] = ACTIONS(3170),
    [anon_sym_unsigned] = ACTIONS(3170),
    [anon_sym_long] = ACTIONS(3170),
    [anon_sym_short] = ACTIONS(3170),
    [anon_sym_LBRACK] = ACTIONS(3170),
    [anon_sym_static] = ACTIONS(3170),
    [anon_sym_register] = ACTIONS(3170),
    [anon_sym_inline] = ACTIONS(3170),
    [anon_sym___inline] = ACTIONS(3170),
    [anon_sym___inline__] = ACTIONS(3170),
    [anon_sym___forceinline] = ACTIONS(3170),
    [anon_sym_thread_local] = ACTIONS(3170),
    [anon_sym___thread] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3170),
    [anon_sym_constexpr] = ACTIONS(3170),
    [anon_sym_volatile] = ACTIONS(3170),
    [anon_sym_restrict] = ACTIONS(3170),
    [anon_sym___restrict__] = ACTIONS(3170),
    [anon_sym__Atomic] = ACTIONS(3170),
    [anon_sym__Noreturn] = ACTIONS(3170),
    [anon_sym_noreturn] = ACTIONS(3170),
    [anon_sym__Nonnull] = ACTIONS(3170),
    [anon_sym_mutable] = ACTIONS(3170),
    [anon_sym_constinit] = ACTIONS(3170),
    [anon_sym_consteval] = ACTIONS(3170),
    [anon_sym_alignas] = ACTIONS(3170),
    [anon_sym__Alignas] = ACTIONS(3170),
    [sym_primitive_type] = ACTIONS(3170),
    [anon_sym_enum] = ACTIONS(3170),
    [anon_sym_class] = ACTIONS(3170),
    [anon_sym_struct] = ACTIONS(3170),
    [anon_sym_union] = ACTIONS(3170),
    [anon_sym_if] = ACTIONS(3170),
    [anon_sym_switch] = ACTIONS(3170),
    [anon_sym_case] = ACTIONS(3170),
    [anon_sym_default] = ACTIONS(3170),
    [anon_sym_while] = ACTIONS(3170),
    [anon_sym_do] = ACTIONS(3170),
    [anon_sym_for] = ACTIONS(3170),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_break] = ACTIONS(3170),
    [anon_sym_continue] = ACTIONS(3170),
    [anon_sym_goto] = ACTIONS(3170),
    [anon_sym___try] = ACTIONS(3170),
    [anon_sym___leave] = ACTIONS(3170),
    [anon_sym_not] = ACTIONS(3170),
    [anon_sym_compl] = ACTIONS(3170),
    [anon_sym_DASH_DASH] = ACTIONS(3172),
    [anon_sym_PLUS_PLUS] = ACTIONS(3172),
    [anon_sym_sizeof] = ACTIONS(3170),
    [anon_sym___alignof__] = ACTIONS(3170),
    [anon_sym___alignof] = ACTIONS(3170),
    [anon_sym__alignof] = ACTIONS(3170),
    [anon_sym_alignof] = ACTIONS(3170),
    [anon_sym__Alignof] = ACTIONS(3170),
    [anon_sym_offsetof] = ACTIONS(3170),
    [anon_sym__Generic] = ACTIONS(3170),
    [anon_sym_asm] = ACTIONS(3170),
    [anon_sym___asm__] = ACTIONS(3170),
    [anon_sym___asm] = ACTIONS(3170),
    [sym_number_literal] = ACTIONS(3172),
    [anon_sym_L_SQUOTE] = ACTIONS(3172),
    [anon_sym_u_SQUOTE] = ACTIONS(3172),
    [anon_sym_U_SQUOTE] = ACTIONS(3172),
    [anon_sym_u8_SQUOTE] = ACTIONS(3172),
    [anon_sym_SQUOTE] = ACTIONS(3172),
    [anon_sym_L_DQUOTE] = ACTIONS(3172),
    [anon_sym_u_DQUOTE] = ACTIONS(3172),
    [anon_sym_U_DQUOTE] = ACTIONS(3172),
    [anon_sym_u8_DQUOTE] = ACTIONS(3172),
    [anon_sym_DQUOTE] = ACTIONS(3172),
    [sym_true] = ACTIONS(3170),
    [sym_false] = ACTIONS(3170),
    [anon_sym_NULL] = ACTIONS(3170),
    [anon_sym_nullptr] = ACTIONS(3170),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3170),
    [anon_sym_decltype] = ACTIONS(3170),
    [anon_sym_explicit] = ACTIONS(3170),
    [anon_sym_typename] = ACTIONS(3170),
    [anon_sym_template] = ACTIONS(3170),
    [anon_sym_operator] = ACTIONS(3170),
    [anon_sym_try] = ACTIONS(3170),
    [anon_sym_delete] = ACTIONS(3170),
    [anon_sym_throw] = ACTIONS(3170),
    [anon_sym_namespace] = ACTIONS(3170),
    [anon_sym_using] = ACTIONS(3170),
    [anon_sym_static_assert] = ACTIONS(3170),
    [anon_sym_concept] = ACTIONS(3170),
    [anon_sym_co_return] = ACTIONS(3170),
    [anon_sym_co_yield] = ACTIONS(3170),
    [anon_sym_R_DQUOTE] = ACTIONS(3172),
    [anon_sym_LR_DQUOTE] = ACTIONS(3172),
    [anon_sym_uR_DQUOTE] = ACTIONS(3172),
    [anon_sym_UR_DQUOTE] = ACTIONS(3172),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3172),
    [anon_sym_co_await] = ACTIONS(3170),
    [anon_sym_new] = ACTIONS(3170),
    [anon_sym_requires] = ACTIONS(3170),
    [sym_this] = ACTIONS(3170),
  },
  [660] = {
    [sym_identifier] = ACTIONS(3020),
    [aux_sym_preproc_include_token1] = ACTIONS(3020),
    [aux_sym_preproc_def_token1] = ACTIONS(3020),
    [aux_sym_preproc_if_token1] = ACTIONS(3020),
    [aux_sym_preproc_if_token2] = ACTIONS(3020),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3020),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3020),
    [sym_preproc_directive] = ACTIONS(3020),
    [anon_sym_LPAREN2] = ACTIONS(3022),
    [anon_sym_BANG] = ACTIONS(3022),
    [anon_sym_TILDE] = ACTIONS(3022),
    [anon_sym_DASH] = ACTIONS(3020),
    [anon_sym_PLUS] = ACTIONS(3020),
    [anon_sym_STAR] = ACTIONS(3022),
    [anon_sym_AMP_AMP] = ACTIONS(3022),
    [anon_sym_AMP] = ACTIONS(3020),
    [anon_sym_SEMI] = ACTIONS(3022),
    [anon_sym___extension__] = ACTIONS(3020),
    [anon_sym_typedef] = ACTIONS(3020),
    [anon_sym_virtual] = ACTIONS(3020),
    [anon_sym_extern] = ACTIONS(3020),
    [anon_sym___attribute__] = ACTIONS(3020),
    [anon_sym___attribute] = ACTIONS(3020),
    [anon_sym_COLON_COLON] = ACTIONS(3022),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3022),
    [anon_sym___declspec] = ACTIONS(3020),
    [anon_sym___based] = ACTIONS(3020),
    [anon_sym___cdecl] = ACTIONS(3020),
    [anon_sym___clrcall] = ACTIONS(3020),
    [anon_sym___stdcall] = ACTIONS(3020),
    [anon_sym___fastcall] = ACTIONS(3020),
    [anon_sym___thiscall] = ACTIONS(3020),
    [anon_sym___vectorcall] = ACTIONS(3020),
    [anon_sym_LBRACE] = ACTIONS(3022),
    [anon_sym_signed] = ACTIONS(3020),
    [anon_sym_unsigned] = ACTIONS(3020),
    [anon_sym_long] = ACTIONS(3020),
    [anon_sym_short] = ACTIONS(3020),
    [anon_sym_LBRACK] = ACTIONS(3020),
    [anon_sym_static] = ACTIONS(3020),
    [anon_sym_register] = ACTIONS(3020),
    [anon_sym_inline] = ACTIONS(3020),
    [anon_sym___inline] = ACTIONS(3020),
    [anon_sym___inline__] = ACTIONS(3020),
    [anon_sym___forceinline] = ACTIONS(3020),
    [anon_sym_thread_local] = ACTIONS(3020),
    [anon_sym___thread] = ACTIONS(3020),
    [anon_sym_const] = ACTIONS(3020),
    [anon_sym_constexpr] = ACTIONS(3020),
    [anon_sym_volatile] = ACTIONS(3020),
    [anon_sym_restrict] = ACTIONS(3020),
    [anon_sym___restrict__] = ACTIONS(3020),
    [anon_sym__Atomic] = ACTIONS(3020),
    [anon_sym__Noreturn] = ACTIONS(3020),
    [anon_sym_noreturn] = ACTIONS(3020),
    [anon_sym__Nonnull] = ACTIONS(3020),
    [anon_sym_mutable] = ACTIONS(3020),
    [anon_sym_constinit] = ACTIONS(3020),
    [anon_sym_consteval] = ACTIONS(3020),
    [anon_sym_alignas] = ACTIONS(3020),
    [anon_sym__Alignas] = ACTIONS(3020),
    [sym_primitive_type] = ACTIONS(3020),
    [anon_sym_enum] = ACTIONS(3020),
    [anon_sym_class] = ACTIONS(3020),
    [anon_sym_struct] = ACTIONS(3020),
    [anon_sym_union] = ACTIONS(3020),
    [anon_sym_if] = ACTIONS(3020),
    [anon_sym_switch] = ACTIONS(3020),
    [anon_sym_case] = ACTIONS(3020),
    [anon_sym_default] = ACTIONS(3020),
    [anon_sym_while] = ACTIONS(3020),
    [anon_sym_do] = ACTIONS(3020),
    [anon_sym_for] = ACTIONS(3020),
    [anon_sym_return] = ACTIONS(3020),
    [anon_sym_break] = ACTIONS(3020),
    [anon_sym_continue] = ACTIONS(3020),
    [anon_sym_goto] = ACTIONS(3020),
    [anon_sym___try] = ACTIONS(3020),
    [anon_sym___leave] = ACTIONS(3020),
    [anon_sym_not] = ACTIONS(3020),
    [anon_sym_compl] = ACTIONS(3020),
    [anon_sym_DASH_DASH] = ACTIONS(3022),
    [anon_sym_PLUS_PLUS] = ACTIONS(3022),
    [anon_sym_sizeof] = ACTIONS(3020),
    [anon_sym___alignof__] = ACTIONS(3020),
    [anon_sym___alignof] = ACTIONS(3020),
    [anon_sym__alignof] = ACTIONS(3020),
    [anon_sym_alignof] = ACTIONS(3020),
    [anon_sym__Alignof] = ACTIONS(3020),
    [anon_sym_offsetof] = ACTIONS(3020),
    [anon_sym__Generic] = ACTIONS(3020),
    [anon_sym_asm] = ACTIONS(3020),
    [anon_sym___asm__] = ACTIONS(3020),
    [anon_sym___asm] = ACTIONS(3020),
    [sym_number_literal] = ACTIONS(3022),
    [anon_sym_L_SQUOTE] = ACTIONS(3022),
    [anon_sym_u_SQUOTE] = ACTIONS(3022),
    [anon_sym_U_SQUOTE] = ACTIONS(3022),
    [anon_sym_u8_SQUOTE] = ACTIONS(3022),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [anon_sym_L_DQUOTE] = ACTIONS(3022),
    [anon_sym_u_DQUOTE] = ACTIONS(3022),
    [anon_sym_U_DQUOTE] = ACTIONS(3022),
    [anon_sym_u8_DQUOTE] = ACTIONS(3022),
    [anon_sym_DQUOTE] = ACTIONS(3022),
    [sym_true] = ACTIONS(3020),
    [sym_false] = ACTIONS(3020),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3020),
    [anon_sym_decltype] = ACTIONS(3020),
    [anon_sym_explicit] = ACTIONS(3020),
    [anon_sym_typename] = ACTIONS(3020),
    [anon_sym_template] = ACTIONS(3020),
    [anon_sym_operator] = ACTIONS(3020),
    [anon_sym_try] = ACTIONS(3020),
    [anon_sym_delete] = ACTIONS(3020),
    [anon_sym_throw] = ACTIONS(3020),
    [anon_sym_namespace] = ACTIONS(3020),
    [anon_sym_using] = ACTIONS(3020),
    [anon_sym_static_assert] = ACTIONS(3020),
    [anon_sym_concept] = ACTIONS(3020),
    [anon_sym_co_return] = ACTIONS(3020),
    [anon_sym_co_yield] = ACTIONS(3020),
    [anon_sym_R_DQUOTE] = ACTIONS(3022),
    [anon_sym_LR_DQUOTE] = ACTIONS(3022),
    [anon_sym_uR_DQUOTE] = ACTIONS(3022),
    [anon_sym_UR_DQUOTE] = ACTIONS(3022),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3022),
    [anon_sym_co_await] = ACTIONS(3020),
    [anon_sym_new] = ACTIONS(3020),
    [anon_sym_requires] = ACTIONS(3020),
    [sym_this] = ACTIONS(3020),
  },
  [661] = {
    [sym_identifier] = ACTIONS(3030),
    [aux_sym_preproc_include_token1] = ACTIONS(3030),
    [aux_sym_preproc_def_token1] = ACTIONS(3030),
    [aux_sym_preproc_if_token1] = ACTIONS(3030),
    [aux_sym_preproc_if_token2] = ACTIONS(3030),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3030),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3030),
    [sym_preproc_directive] = ACTIONS(3030),
    [anon_sym_LPAREN2] = ACTIONS(3032),
    [anon_sym_BANG] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3030),
    [anon_sym_PLUS] = ACTIONS(3030),
    [anon_sym_STAR] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_AMP] = ACTIONS(3030),
    [anon_sym_SEMI] = ACTIONS(3032),
    [anon_sym___extension__] = ACTIONS(3030),
    [anon_sym_typedef] = ACTIONS(3030),
    [anon_sym_virtual] = ACTIONS(3030),
    [anon_sym_extern] = ACTIONS(3030),
    [anon_sym___attribute__] = ACTIONS(3030),
    [anon_sym___attribute] = ACTIONS(3030),
    [anon_sym_COLON_COLON] = ACTIONS(3032),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3032),
    [anon_sym___declspec] = ACTIONS(3030),
    [anon_sym___based] = ACTIONS(3030),
    [anon_sym___cdecl] = ACTIONS(3030),
    [anon_sym___clrcall] = ACTIONS(3030),
    [anon_sym___stdcall] = ACTIONS(3030),
    [anon_sym___fastcall] = ACTIONS(3030),
    [anon_sym___thiscall] = ACTIONS(3030),
    [anon_sym___vectorcall] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_signed] = ACTIONS(3030),
    [anon_sym_unsigned] = ACTIONS(3030),
    [anon_sym_long] = ACTIONS(3030),
    [anon_sym_short] = ACTIONS(3030),
    [anon_sym_LBRACK] = ACTIONS(3030),
    [anon_sym_static] = ACTIONS(3030),
    [anon_sym_register] = ACTIONS(3030),
    [anon_sym_inline] = ACTIONS(3030),
    [anon_sym___inline] = ACTIONS(3030),
    [anon_sym___inline__] = ACTIONS(3030),
    [anon_sym___forceinline] = ACTIONS(3030),
    [anon_sym_thread_local] = ACTIONS(3030),
    [anon_sym___thread] = ACTIONS(3030),
    [anon_sym_const] = ACTIONS(3030),
    [anon_sym_constexpr] = ACTIONS(3030),
    [anon_sym_volatile] = ACTIONS(3030),
    [anon_sym_restrict] = ACTIONS(3030),
    [anon_sym___restrict__] = ACTIONS(3030),
    [anon_sym__Atomic] = ACTIONS(3030),
    [anon_sym__Noreturn] = ACTIONS(3030),
    [anon_sym_noreturn] = ACTIONS(3030),
    [anon_sym__Nonnull] = ACTIONS(3030),
    [anon_sym_mutable] = ACTIONS(3030),
    [anon_sym_constinit] = ACTIONS(3030),
    [anon_sym_consteval] = ACTIONS(3030),
    [anon_sym_alignas] = ACTIONS(3030),
    [anon_sym__Alignas] = ACTIONS(3030),
    [sym_primitive_type] = ACTIONS(3030),
    [anon_sym_enum] = ACTIONS(3030),
    [anon_sym_class] = ACTIONS(3030),
    [anon_sym_struct] = ACTIONS(3030),
    [anon_sym_union] = ACTIONS(3030),
    [anon_sym_if] = ACTIONS(3030),
    [anon_sym_switch] = ACTIONS(3030),
    [anon_sym_case] = ACTIONS(3030),
    [anon_sym_default] = ACTIONS(3030),
    [anon_sym_while] = ACTIONS(3030),
    [anon_sym_do] = ACTIONS(3030),
    [anon_sym_for] = ACTIONS(3030),
    [anon_sym_return] = ACTIONS(3030),
    [anon_sym_break] = ACTIONS(3030),
    [anon_sym_continue] = ACTIONS(3030),
    [anon_sym_goto] = ACTIONS(3030),
    [anon_sym___try] = ACTIONS(3030),
    [anon_sym___leave] = ACTIONS(3030),
    [anon_sym_not] = ACTIONS(3030),
    [anon_sym_compl] = ACTIONS(3030),
    [anon_sym_DASH_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_PLUS] = ACTIONS(3032),
    [anon_sym_sizeof] = ACTIONS(3030),
    [anon_sym___alignof__] = ACTIONS(3030),
    [anon_sym___alignof] = ACTIONS(3030),
    [anon_sym__alignof] = ACTIONS(3030),
    [anon_sym_alignof] = ACTIONS(3030),
    [anon_sym__Alignof] = ACTIONS(3030),
    [anon_sym_offsetof] = ACTIONS(3030),
    [anon_sym__Generic] = ACTIONS(3030),
    [anon_sym_asm] = ACTIONS(3030),
    [anon_sym___asm__] = ACTIONS(3030),
    [anon_sym___asm] = ACTIONS(3030),
    [sym_number_literal] = ACTIONS(3032),
    [anon_sym_L_SQUOTE] = ACTIONS(3032),
    [anon_sym_u_SQUOTE] = ACTIONS(3032),
    [anon_sym_U_SQUOTE] = ACTIONS(3032),
    [anon_sym_u8_SQUOTE] = ACTIONS(3032),
    [anon_sym_SQUOTE] = ACTIONS(3032),
    [anon_sym_L_DQUOTE] = ACTIONS(3032),
    [anon_sym_u_DQUOTE] = ACTIONS(3032),
    [anon_sym_U_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8_DQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [sym_true] = ACTIONS(3030),
    [sym_false] = ACTIONS(3030),
    [anon_sym_NULL] = ACTIONS(3030),
    [anon_sym_nullptr] = ACTIONS(3030),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3030),
    [anon_sym_decltype] = ACTIONS(3030),
    [anon_sym_explicit] = ACTIONS(3030),
    [anon_sym_typename] = ACTIONS(3030),
    [anon_sym_template] = ACTIONS(3030),
    [anon_sym_operator] = ACTIONS(3030),
    [anon_sym_try] = ACTIONS(3030),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_throw] = ACTIONS(3030),
    [anon_sym_namespace] = ACTIONS(3030),
    [anon_sym_using] = ACTIONS(3030),
    [anon_sym_static_assert] = ACTIONS(3030),
    [anon_sym_concept] = ACTIONS(3030),
    [anon_sym_co_return] = ACTIONS(3030),
    [anon_sym_co_yield] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3030),
    [anon_sym_new] = ACTIONS(3030),
    [anon_sym_requires] = ACTIONS(3030),
    [sym_this] = ACTIONS(3030),
  },
  [662] = {
    [sym_identifier] = ACTIONS(3158),
    [aux_sym_preproc_include_token1] = ACTIONS(3158),
    [aux_sym_preproc_def_token1] = ACTIONS(3158),
    [aux_sym_preproc_if_token1] = ACTIONS(3158),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3158),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3158),
    [sym_preproc_directive] = ACTIONS(3158),
    [anon_sym_LPAREN2] = ACTIONS(3160),
    [anon_sym_BANG] = ACTIONS(3160),
    [anon_sym_TILDE] = ACTIONS(3160),
    [anon_sym_DASH] = ACTIONS(3158),
    [anon_sym_PLUS] = ACTIONS(3158),
    [anon_sym_STAR] = ACTIONS(3160),
    [anon_sym_AMP_AMP] = ACTIONS(3160),
    [anon_sym_AMP] = ACTIONS(3158),
    [anon_sym_SEMI] = ACTIONS(3160),
    [anon_sym___extension__] = ACTIONS(3158),
    [anon_sym_typedef] = ACTIONS(3158),
    [anon_sym_virtual] = ACTIONS(3158),
    [anon_sym_extern] = ACTIONS(3158),
    [anon_sym___attribute__] = ACTIONS(3158),
    [anon_sym___attribute] = ACTIONS(3158),
    [anon_sym_COLON_COLON] = ACTIONS(3160),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3160),
    [anon_sym___declspec] = ACTIONS(3158),
    [anon_sym___based] = ACTIONS(3158),
    [anon_sym___cdecl] = ACTIONS(3158),
    [anon_sym___clrcall] = ACTIONS(3158),
    [anon_sym___stdcall] = ACTIONS(3158),
    [anon_sym___fastcall] = ACTIONS(3158),
    [anon_sym___thiscall] = ACTIONS(3158),
    [anon_sym___vectorcall] = ACTIONS(3158),
    [anon_sym_LBRACE] = ACTIONS(3160),
    [anon_sym_RBRACE] = ACTIONS(3160),
    [anon_sym_signed] = ACTIONS(3158),
    [anon_sym_unsigned] = ACTIONS(3158),
    [anon_sym_long] = ACTIONS(3158),
    [anon_sym_short] = ACTIONS(3158),
    [anon_sym_LBRACK] = ACTIONS(3158),
    [anon_sym_static] = ACTIONS(3158),
    [anon_sym_register] = ACTIONS(3158),
    [anon_sym_inline] = ACTIONS(3158),
    [anon_sym___inline] = ACTIONS(3158),
    [anon_sym___inline__] = ACTIONS(3158),
    [anon_sym___forceinline] = ACTIONS(3158),
    [anon_sym_thread_local] = ACTIONS(3158),
    [anon_sym___thread] = ACTIONS(3158),
    [anon_sym_const] = ACTIONS(3158),
    [anon_sym_constexpr] = ACTIONS(3158),
    [anon_sym_volatile] = ACTIONS(3158),
    [anon_sym_restrict] = ACTIONS(3158),
    [anon_sym___restrict__] = ACTIONS(3158),
    [anon_sym__Atomic] = ACTIONS(3158),
    [anon_sym__Noreturn] = ACTIONS(3158),
    [anon_sym_noreturn] = ACTIONS(3158),
    [anon_sym__Nonnull] = ACTIONS(3158),
    [anon_sym_mutable] = ACTIONS(3158),
    [anon_sym_constinit] = ACTIONS(3158),
    [anon_sym_consteval] = ACTIONS(3158),
    [anon_sym_alignas] = ACTIONS(3158),
    [anon_sym__Alignas] = ACTIONS(3158),
    [sym_primitive_type] = ACTIONS(3158),
    [anon_sym_enum] = ACTIONS(3158),
    [anon_sym_class] = ACTIONS(3158),
    [anon_sym_struct] = ACTIONS(3158),
    [anon_sym_union] = ACTIONS(3158),
    [anon_sym_if] = ACTIONS(3158),
    [anon_sym_switch] = ACTIONS(3158),
    [anon_sym_case] = ACTIONS(3158),
    [anon_sym_default] = ACTIONS(3158),
    [anon_sym_while] = ACTIONS(3158),
    [anon_sym_do] = ACTIONS(3158),
    [anon_sym_for] = ACTIONS(3158),
    [anon_sym_return] = ACTIONS(3158),
    [anon_sym_break] = ACTIONS(3158),
    [anon_sym_continue] = ACTIONS(3158),
    [anon_sym_goto] = ACTIONS(3158),
    [anon_sym___try] = ACTIONS(3158),
    [anon_sym___leave] = ACTIONS(3158),
    [anon_sym_not] = ACTIONS(3158),
    [anon_sym_compl] = ACTIONS(3158),
    [anon_sym_DASH_DASH] = ACTIONS(3160),
    [anon_sym_PLUS_PLUS] = ACTIONS(3160),
    [anon_sym_sizeof] = ACTIONS(3158),
    [anon_sym___alignof__] = ACTIONS(3158),
    [anon_sym___alignof] = ACTIONS(3158),
    [anon_sym__alignof] = ACTIONS(3158),
    [anon_sym_alignof] = ACTIONS(3158),
    [anon_sym__Alignof] = ACTIONS(3158),
    [anon_sym_offsetof] = ACTIONS(3158),
    [anon_sym__Generic] = ACTIONS(3158),
    [anon_sym_asm] = ACTIONS(3158),
    [anon_sym___asm__] = ACTIONS(3158),
    [anon_sym___asm] = ACTIONS(3158),
    [sym_number_literal] = ACTIONS(3160),
    [anon_sym_L_SQUOTE] = ACTIONS(3160),
    [anon_sym_u_SQUOTE] = ACTIONS(3160),
    [anon_sym_U_SQUOTE] = ACTIONS(3160),
    [anon_sym_u8_SQUOTE] = ACTIONS(3160),
    [anon_sym_SQUOTE] = ACTIONS(3160),
    [anon_sym_L_DQUOTE] = ACTIONS(3160),
    [anon_sym_u_DQUOTE] = ACTIONS(3160),
    [anon_sym_U_DQUOTE] = ACTIONS(3160),
    [anon_sym_u8_DQUOTE] = ACTIONS(3160),
    [anon_sym_DQUOTE] = ACTIONS(3160),
    [sym_true] = ACTIONS(3158),
    [sym_false] = ACTIONS(3158),
    [anon_sym_NULL] = ACTIONS(3158),
    [anon_sym_nullptr] = ACTIONS(3158),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3158),
    [anon_sym_decltype] = ACTIONS(3158),
    [anon_sym_explicit] = ACTIONS(3158),
    [anon_sym_typename] = ACTIONS(3158),
    [anon_sym_template] = ACTIONS(3158),
    [anon_sym_operator] = ACTIONS(3158),
    [anon_sym_try] = ACTIONS(3158),
    [anon_sym_delete] = ACTIONS(3158),
    [anon_sym_throw] = ACTIONS(3158),
    [anon_sym_namespace] = ACTIONS(3158),
    [anon_sym_using] = ACTIONS(3158),
    [anon_sym_static_assert] = ACTIONS(3158),
    [anon_sym_concept] = ACTIONS(3158),
    [anon_sym_co_return] = ACTIONS(3158),
    [anon_sym_co_yield] = ACTIONS(3158),
    [anon_sym_R_DQUOTE] = ACTIONS(3160),
    [anon_sym_LR_DQUOTE] = ACTIONS(3160),
    [anon_sym_uR_DQUOTE] = ACTIONS(3160),
    [anon_sym_UR_DQUOTE] = ACTIONS(3160),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3160),
    [anon_sym_co_await] = ACTIONS(3158),
    [anon_sym_new] = ACTIONS(3158),
    [anon_sym_requires] = ACTIONS(3158),
    [sym_this] = ACTIONS(3158),
  },
  [663] = {
    [sym_identifier] = ACTIONS(2743),
    [aux_sym_preproc_include_token1] = ACTIONS(2743),
    [aux_sym_preproc_def_token1] = ACTIONS(2743),
    [aux_sym_preproc_if_token1] = ACTIONS(2743),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2743),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2743),
    [sym_preproc_directive] = ACTIONS(2743),
    [anon_sym_LPAREN2] = ACTIONS(2745),
    [anon_sym_BANG] = ACTIONS(2745),
    [anon_sym_TILDE] = ACTIONS(2745),
    [anon_sym_DASH] = ACTIONS(2743),
    [anon_sym_PLUS] = ACTIONS(2743),
    [anon_sym_STAR] = ACTIONS(2745),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_AMP] = ACTIONS(2743),
    [anon_sym_SEMI] = ACTIONS(2745),
    [anon_sym___extension__] = ACTIONS(2743),
    [anon_sym_typedef] = ACTIONS(2743),
    [anon_sym_virtual] = ACTIONS(2743),
    [anon_sym_extern] = ACTIONS(2743),
    [anon_sym___attribute__] = ACTIONS(2743),
    [anon_sym___attribute] = ACTIONS(2743),
    [anon_sym_COLON_COLON] = ACTIONS(2745),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2745),
    [anon_sym___declspec] = ACTIONS(2743),
    [anon_sym___based] = ACTIONS(2743),
    [anon_sym___cdecl] = ACTIONS(2743),
    [anon_sym___clrcall] = ACTIONS(2743),
    [anon_sym___stdcall] = ACTIONS(2743),
    [anon_sym___fastcall] = ACTIONS(2743),
    [anon_sym___thiscall] = ACTIONS(2743),
    [anon_sym___vectorcall] = ACTIONS(2743),
    [anon_sym_LBRACE] = ACTIONS(2745),
    [anon_sym_RBRACE] = ACTIONS(2745),
    [anon_sym_signed] = ACTIONS(2743),
    [anon_sym_unsigned] = ACTIONS(2743),
    [anon_sym_long] = ACTIONS(2743),
    [anon_sym_short] = ACTIONS(2743),
    [anon_sym_LBRACK] = ACTIONS(2743),
    [anon_sym_static] = ACTIONS(2743),
    [anon_sym_register] = ACTIONS(2743),
    [anon_sym_inline] = ACTIONS(2743),
    [anon_sym___inline] = ACTIONS(2743),
    [anon_sym___inline__] = ACTIONS(2743),
    [anon_sym___forceinline] = ACTIONS(2743),
    [anon_sym_thread_local] = ACTIONS(2743),
    [anon_sym___thread] = ACTIONS(2743),
    [anon_sym_const] = ACTIONS(2743),
    [anon_sym_constexpr] = ACTIONS(2743),
    [anon_sym_volatile] = ACTIONS(2743),
    [anon_sym_restrict] = ACTIONS(2743),
    [anon_sym___restrict__] = ACTIONS(2743),
    [anon_sym__Atomic] = ACTIONS(2743),
    [anon_sym__Noreturn] = ACTIONS(2743),
    [anon_sym_noreturn] = ACTIONS(2743),
    [anon_sym__Nonnull] = ACTIONS(2743),
    [anon_sym_mutable] = ACTIONS(2743),
    [anon_sym_constinit] = ACTIONS(2743),
    [anon_sym_consteval] = ACTIONS(2743),
    [anon_sym_alignas] = ACTIONS(2743),
    [anon_sym__Alignas] = ACTIONS(2743),
    [sym_primitive_type] = ACTIONS(2743),
    [anon_sym_enum] = ACTIONS(2743),
    [anon_sym_class] = ACTIONS(2743),
    [anon_sym_struct] = ACTIONS(2743),
    [anon_sym_union] = ACTIONS(2743),
    [anon_sym_if] = ACTIONS(2743),
    [anon_sym_switch] = ACTIONS(2743),
    [anon_sym_case] = ACTIONS(2743),
    [anon_sym_default] = ACTIONS(2743),
    [anon_sym_while] = ACTIONS(2743),
    [anon_sym_do] = ACTIONS(2743),
    [anon_sym_for] = ACTIONS(2743),
    [anon_sym_return] = ACTIONS(2743),
    [anon_sym_break] = ACTIONS(2743),
    [anon_sym_continue] = ACTIONS(2743),
    [anon_sym_goto] = ACTIONS(2743),
    [anon_sym___try] = ACTIONS(2743),
    [anon_sym___leave] = ACTIONS(2743),
    [anon_sym_not] = ACTIONS(2743),
    [anon_sym_compl] = ACTIONS(2743),
    [anon_sym_DASH_DASH] = ACTIONS(2745),
    [anon_sym_PLUS_PLUS] = ACTIONS(2745),
    [anon_sym_sizeof] = ACTIONS(2743),
    [anon_sym___alignof__] = ACTIONS(2743),
    [anon_sym___alignof] = ACTIONS(2743),
    [anon_sym__alignof] = ACTIONS(2743),
    [anon_sym_alignof] = ACTIONS(2743),
    [anon_sym__Alignof] = ACTIONS(2743),
    [anon_sym_offsetof] = ACTIONS(2743),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2743),
    [anon_sym___asm__] = ACTIONS(2743),
    [anon_sym___asm] = ACTIONS(2743),
    [sym_number_literal] = ACTIONS(2745),
    [anon_sym_L_SQUOTE] = ACTIONS(2745),
    [anon_sym_u_SQUOTE] = ACTIONS(2745),
    [anon_sym_U_SQUOTE] = ACTIONS(2745),
    [anon_sym_u8_SQUOTE] = ACTIONS(2745),
    [anon_sym_SQUOTE] = ACTIONS(2745),
    [anon_sym_L_DQUOTE] = ACTIONS(2745),
    [anon_sym_u_DQUOTE] = ACTIONS(2745),
    [anon_sym_U_DQUOTE] = ACTIONS(2745),
    [anon_sym_u8_DQUOTE] = ACTIONS(2745),
    [anon_sym_DQUOTE] = ACTIONS(2745),
    [sym_true] = ACTIONS(2743),
    [sym_false] = ACTIONS(2743),
    [anon_sym_NULL] = ACTIONS(2743),
    [anon_sym_nullptr] = ACTIONS(2743),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2743),
    [anon_sym_decltype] = ACTIONS(2743),
    [anon_sym_explicit] = ACTIONS(2743),
    [anon_sym_typename] = ACTIONS(2743),
    [anon_sym_template] = ACTIONS(2743),
    [anon_sym_operator] = ACTIONS(2743),
    [anon_sym_try] = ACTIONS(2743),
    [anon_sym_delete] = ACTIONS(2743),
    [anon_sym_throw] = ACTIONS(2743),
    [anon_sym_namespace] = ACTIONS(2743),
    [anon_sym_using] = ACTIONS(2743),
    [anon_sym_static_assert] = ACTIONS(2743),
    [anon_sym_concept] = ACTIONS(2743),
    [anon_sym_co_return] = ACTIONS(2743),
    [anon_sym_co_yield] = ACTIONS(2743),
    [anon_sym_R_DQUOTE] = ACTIONS(2745),
    [anon_sym_LR_DQUOTE] = ACTIONS(2745),
    [anon_sym_uR_DQUOTE] = ACTIONS(2745),
    [anon_sym_UR_DQUOTE] = ACTIONS(2745),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2745),
    [anon_sym_co_await] = ACTIONS(2743),
    [anon_sym_new] = ACTIONS(2743),
    [anon_sym_requires] = ACTIONS(2743),
    [sym_this] = ACTIONS(2743),
  },
  [664] = {
    [sym_identifier] = ACTIONS(2751),
    [aux_sym_preproc_include_token1] = ACTIONS(2751),
    [aux_sym_preproc_def_token1] = ACTIONS(2751),
    [aux_sym_preproc_if_token1] = ACTIONS(2751),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2751),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2751),
    [sym_preproc_directive] = ACTIONS(2751),
    [anon_sym_LPAREN2] = ACTIONS(2753),
    [anon_sym_BANG] = ACTIONS(2753),
    [anon_sym_TILDE] = ACTIONS(2753),
    [anon_sym_DASH] = ACTIONS(2751),
    [anon_sym_PLUS] = ACTIONS(2751),
    [anon_sym_STAR] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2751),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym___extension__] = ACTIONS(2751),
    [anon_sym_typedef] = ACTIONS(2751),
    [anon_sym_virtual] = ACTIONS(2751),
    [anon_sym_extern] = ACTIONS(2751),
    [anon_sym___attribute__] = ACTIONS(2751),
    [anon_sym___attribute] = ACTIONS(2751),
    [anon_sym_COLON_COLON] = ACTIONS(2753),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2753),
    [anon_sym___declspec] = ACTIONS(2751),
    [anon_sym___based] = ACTIONS(2751),
    [anon_sym___cdecl] = ACTIONS(2751),
    [anon_sym___clrcall] = ACTIONS(2751),
    [anon_sym___stdcall] = ACTIONS(2751),
    [anon_sym___fastcall] = ACTIONS(2751),
    [anon_sym___thiscall] = ACTIONS(2751),
    [anon_sym___vectorcall] = ACTIONS(2751),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_RBRACE] = ACTIONS(2753),
    [anon_sym_signed] = ACTIONS(2751),
    [anon_sym_unsigned] = ACTIONS(2751),
    [anon_sym_long] = ACTIONS(2751),
    [anon_sym_short] = ACTIONS(2751),
    [anon_sym_LBRACK] = ACTIONS(2751),
    [anon_sym_static] = ACTIONS(2751),
    [anon_sym_register] = ACTIONS(2751),
    [anon_sym_inline] = ACTIONS(2751),
    [anon_sym___inline] = ACTIONS(2751),
    [anon_sym___inline__] = ACTIONS(2751),
    [anon_sym___forceinline] = ACTIONS(2751),
    [anon_sym_thread_local] = ACTIONS(2751),
    [anon_sym___thread] = ACTIONS(2751),
    [anon_sym_const] = ACTIONS(2751),
    [anon_sym_constexpr] = ACTIONS(2751),
    [anon_sym_volatile] = ACTIONS(2751),
    [anon_sym_restrict] = ACTIONS(2751),
    [anon_sym___restrict__] = ACTIONS(2751),
    [anon_sym__Atomic] = ACTIONS(2751),
    [anon_sym__Noreturn] = ACTIONS(2751),
    [anon_sym_noreturn] = ACTIONS(2751),
    [anon_sym__Nonnull] = ACTIONS(2751),
    [anon_sym_mutable] = ACTIONS(2751),
    [anon_sym_constinit] = ACTIONS(2751),
    [anon_sym_consteval] = ACTIONS(2751),
    [anon_sym_alignas] = ACTIONS(2751),
    [anon_sym__Alignas] = ACTIONS(2751),
    [sym_primitive_type] = ACTIONS(2751),
    [anon_sym_enum] = ACTIONS(2751),
    [anon_sym_class] = ACTIONS(2751),
    [anon_sym_struct] = ACTIONS(2751),
    [anon_sym_union] = ACTIONS(2751),
    [anon_sym_if] = ACTIONS(2751),
    [anon_sym_switch] = ACTIONS(2751),
    [anon_sym_case] = ACTIONS(2751),
    [anon_sym_default] = ACTIONS(2751),
    [anon_sym_while] = ACTIONS(2751),
    [anon_sym_do] = ACTIONS(2751),
    [anon_sym_for] = ACTIONS(2751),
    [anon_sym_return] = ACTIONS(2751),
    [anon_sym_break] = ACTIONS(2751),
    [anon_sym_continue] = ACTIONS(2751),
    [anon_sym_goto] = ACTIONS(2751),
    [anon_sym___try] = ACTIONS(2751),
    [anon_sym___leave] = ACTIONS(2751),
    [anon_sym_not] = ACTIONS(2751),
    [anon_sym_compl] = ACTIONS(2751),
    [anon_sym_DASH_DASH] = ACTIONS(2753),
    [anon_sym_PLUS_PLUS] = ACTIONS(2753),
    [anon_sym_sizeof] = ACTIONS(2751),
    [anon_sym___alignof__] = ACTIONS(2751),
    [anon_sym___alignof] = ACTIONS(2751),
    [anon_sym__alignof] = ACTIONS(2751),
    [anon_sym_alignof] = ACTIONS(2751),
    [anon_sym__Alignof] = ACTIONS(2751),
    [anon_sym_offsetof] = ACTIONS(2751),
    [anon_sym__Generic] = ACTIONS(2751),
    [anon_sym_asm] = ACTIONS(2751),
    [anon_sym___asm__] = ACTIONS(2751),
    [anon_sym___asm] = ACTIONS(2751),
    [sym_number_literal] = ACTIONS(2753),
    [anon_sym_L_SQUOTE] = ACTIONS(2753),
    [anon_sym_u_SQUOTE] = ACTIONS(2753),
    [anon_sym_U_SQUOTE] = ACTIONS(2753),
    [anon_sym_u8_SQUOTE] = ACTIONS(2753),
    [anon_sym_SQUOTE] = ACTIONS(2753),
    [anon_sym_L_DQUOTE] = ACTIONS(2753),
    [anon_sym_u_DQUOTE] = ACTIONS(2753),
    [anon_sym_U_DQUOTE] = ACTIONS(2753),
    [anon_sym_u8_DQUOTE] = ACTIONS(2753),
    [anon_sym_DQUOTE] = ACTIONS(2753),
    [sym_true] = ACTIONS(2751),
    [sym_false] = ACTIONS(2751),
    [anon_sym_NULL] = ACTIONS(2751),
    [anon_sym_nullptr] = ACTIONS(2751),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2751),
    [anon_sym_decltype] = ACTIONS(2751),
    [anon_sym_explicit] = ACTIONS(2751),
    [anon_sym_typename] = ACTIONS(2751),
    [anon_sym_template] = ACTIONS(2751),
    [anon_sym_operator] = ACTIONS(2751),
    [anon_sym_try] = ACTIONS(2751),
    [anon_sym_delete] = ACTIONS(2751),
    [anon_sym_throw] = ACTIONS(2751),
    [anon_sym_namespace] = ACTIONS(2751),
    [anon_sym_using] = ACTIONS(2751),
    [anon_sym_static_assert] = ACTIONS(2751),
    [anon_sym_concept] = ACTIONS(2751),
    [anon_sym_co_return] = ACTIONS(2751),
    [anon_sym_co_yield] = ACTIONS(2751),
    [anon_sym_R_DQUOTE] = ACTIONS(2753),
    [anon_sym_LR_DQUOTE] = ACTIONS(2753),
    [anon_sym_uR_DQUOTE] = ACTIONS(2753),
    [anon_sym_UR_DQUOTE] = ACTIONS(2753),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2753),
    [anon_sym_co_await] = ACTIONS(2751),
    [anon_sym_new] = ACTIONS(2751),
    [anon_sym_requires] = ACTIONS(2751),
    [sym_this] = ACTIONS(2751),
  },
  [665] = {
    [sym_identifier] = ACTIONS(3030),
    [aux_sym_preproc_include_token1] = ACTIONS(3030),
    [aux_sym_preproc_def_token1] = ACTIONS(3030),
    [aux_sym_preproc_if_token1] = ACTIONS(3030),
    [aux_sym_preproc_if_token2] = ACTIONS(3030),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3030),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3030),
    [sym_preproc_directive] = ACTIONS(3030),
    [anon_sym_LPAREN2] = ACTIONS(3032),
    [anon_sym_BANG] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3030),
    [anon_sym_PLUS] = ACTIONS(3030),
    [anon_sym_STAR] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_AMP] = ACTIONS(3030),
    [anon_sym_SEMI] = ACTIONS(3032),
    [anon_sym___extension__] = ACTIONS(3030),
    [anon_sym_typedef] = ACTIONS(3030),
    [anon_sym_virtual] = ACTIONS(3030),
    [anon_sym_extern] = ACTIONS(3030),
    [anon_sym___attribute__] = ACTIONS(3030),
    [anon_sym___attribute] = ACTIONS(3030),
    [anon_sym_COLON_COLON] = ACTIONS(3032),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3032),
    [anon_sym___declspec] = ACTIONS(3030),
    [anon_sym___based] = ACTIONS(3030),
    [anon_sym___cdecl] = ACTIONS(3030),
    [anon_sym___clrcall] = ACTIONS(3030),
    [anon_sym___stdcall] = ACTIONS(3030),
    [anon_sym___fastcall] = ACTIONS(3030),
    [anon_sym___thiscall] = ACTIONS(3030),
    [anon_sym___vectorcall] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_signed] = ACTIONS(3030),
    [anon_sym_unsigned] = ACTIONS(3030),
    [anon_sym_long] = ACTIONS(3030),
    [anon_sym_short] = ACTIONS(3030),
    [anon_sym_LBRACK] = ACTIONS(3030),
    [anon_sym_static] = ACTIONS(3030),
    [anon_sym_register] = ACTIONS(3030),
    [anon_sym_inline] = ACTIONS(3030),
    [anon_sym___inline] = ACTIONS(3030),
    [anon_sym___inline__] = ACTIONS(3030),
    [anon_sym___forceinline] = ACTIONS(3030),
    [anon_sym_thread_local] = ACTIONS(3030),
    [anon_sym___thread] = ACTIONS(3030),
    [anon_sym_const] = ACTIONS(3030),
    [anon_sym_constexpr] = ACTIONS(3030),
    [anon_sym_volatile] = ACTIONS(3030),
    [anon_sym_restrict] = ACTIONS(3030),
    [anon_sym___restrict__] = ACTIONS(3030),
    [anon_sym__Atomic] = ACTIONS(3030),
    [anon_sym__Noreturn] = ACTIONS(3030),
    [anon_sym_noreturn] = ACTIONS(3030),
    [anon_sym__Nonnull] = ACTIONS(3030),
    [anon_sym_mutable] = ACTIONS(3030),
    [anon_sym_constinit] = ACTIONS(3030),
    [anon_sym_consteval] = ACTIONS(3030),
    [anon_sym_alignas] = ACTIONS(3030),
    [anon_sym__Alignas] = ACTIONS(3030),
    [sym_primitive_type] = ACTIONS(3030),
    [anon_sym_enum] = ACTIONS(3030),
    [anon_sym_class] = ACTIONS(3030),
    [anon_sym_struct] = ACTIONS(3030),
    [anon_sym_union] = ACTIONS(3030),
    [anon_sym_if] = ACTIONS(3030),
    [anon_sym_switch] = ACTIONS(3030),
    [anon_sym_case] = ACTIONS(3030),
    [anon_sym_default] = ACTIONS(3030),
    [anon_sym_while] = ACTIONS(3030),
    [anon_sym_do] = ACTIONS(3030),
    [anon_sym_for] = ACTIONS(3030),
    [anon_sym_return] = ACTIONS(3030),
    [anon_sym_break] = ACTIONS(3030),
    [anon_sym_continue] = ACTIONS(3030),
    [anon_sym_goto] = ACTIONS(3030),
    [anon_sym___try] = ACTIONS(3030),
    [anon_sym___leave] = ACTIONS(3030),
    [anon_sym_not] = ACTIONS(3030),
    [anon_sym_compl] = ACTIONS(3030),
    [anon_sym_DASH_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_PLUS] = ACTIONS(3032),
    [anon_sym_sizeof] = ACTIONS(3030),
    [anon_sym___alignof__] = ACTIONS(3030),
    [anon_sym___alignof] = ACTIONS(3030),
    [anon_sym__alignof] = ACTIONS(3030),
    [anon_sym_alignof] = ACTIONS(3030),
    [anon_sym__Alignof] = ACTIONS(3030),
    [anon_sym_offsetof] = ACTIONS(3030),
    [anon_sym__Generic] = ACTIONS(3030),
    [anon_sym_asm] = ACTIONS(3030),
    [anon_sym___asm__] = ACTIONS(3030),
    [anon_sym___asm] = ACTIONS(3030),
    [sym_number_literal] = ACTIONS(3032),
    [anon_sym_L_SQUOTE] = ACTIONS(3032),
    [anon_sym_u_SQUOTE] = ACTIONS(3032),
    [anon_sym_U_SQUOTE] = ACTIONS(3032),
    [anon_sym_u8_SQUOTE] = ACTIONS(3032),
    [anon_sym_SQUOTE] = ACTIONS(3032),
    [anon_sym_L_DQUOTE] = ACTIONS(3032),
    [anon_sym_u_DQUOTE] = ACTIONS(3032),
    [anon_sym_U_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8_DQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [sym_true] = ACTIONS(3030),
    [sym_false] = ACTIONS(3030),
    [anon_sym_NULL] = ACTIONS(3030),
    [anon_sym_nullptr] = ACTIONS(3030),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3030),
    [anon_sym_decltype] = ACTIONS(3030),
    [anon_sym_explicit] = ACTIONS(3030),
    [anon_sym_typename] = ACTIONS(3030),
    [anon_sym_template] = ACTIONS(3030),
    [anon_sym_operator] = ACTIONS(3030),
    [anon_sym_try] = ACTIONS(3030),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_throw] = ACTIONS(3030),
    [anon_sym_namespace] = ACTIONS(3030),
    [anon_sym_using] = ACTIONS(3030),
    [anon_sym_static_assert] = ACTIONS(3030),
    [anon_sym_concept] = ACTIONS(3030),
    [anon_sym_co_return] = ACTIONS(3030),
    [anon_sym_co_yield] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3030),
    [anon_sym_new] = ACTIONS(3030),
    [anon_sym_requires] = ACTIONS(3030),
    [sym_this] = ACTIONS(3030),
  },
  [666] = {
    [sym_identifier] = ACTIONS(3042),
    [aux_sym_preproc_include_token1] = ACTIONS(3042),
    [aux_sym_preproc_def_token1] = ACTIONS(3042),
    [aux_sym_preproc_if_token1] = ACTIONS(3042),
    [aux_sym_preproc_if_token2] = ACTIONS(3042),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3042),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3042),
    [sym_preproc_directive] = ACTIONS(3042),
    [anon_sym_LPAREN2] = ACTIONS(3044),
    [anon_sym_BANG] = ACTIONS(3044),
    [anon_sym_TILDE] = ACTIONS(3044),
    [anon_sym_DASH] = ACTIONS(3042),
    [anon_sym_PLUS] = ACTIONS(3042),
    [anon_sym_STAR] = ACTIONS(3044),
    [anon_sym_AMP_AMP] = ACTIONS(3044),
    [anon_sym_AMP] = ACTIONS(3042),
    [anon_sym_SEMI] = ACTIONS(3044),
    [anon_sym___extension__] = ACTIONS(3042),
    [anon_sym_typedef] = ACTIONS(3042),
    [anon_sym_virtual] = ACTIONS(3042),
    [anon_sym_extern] = ACTIONS(3042),
    [anon_sym___attribute__] = ACTIONS(3042),
    [anon_sym___attribute] = ACTIONS(3042),
    [anon_sym_COLON_COLON] = ACTIONS(3044),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3044),
    [anon_sym___declspec] = ACTIONS(3042),
    [anon_sym___based] = ACTIONS(3042),
    [anon_sym___cdecl] = ACTIONS(3042),
    [anon_sym___clrcall] = ACTIONS(3042),
    [anon_sym___stdcall] = ACTIONS(3042),
    [anon_sym___fastcall] = ACTIONS(3042),
    [anon_sym___thiscall] = ACTIONS(3042),
    [anon_sym___vectorcall] = ACTIONS(3042),
    [anon_sym_LBRACE] = ACTIONS(3044),
    [anon_sym_signed] = ACTIONS(3042),
    [anon_sym_unsigned] = ACTIONS(3042),
    [anon_sym_long] = ACTIONS(3042),
    [anon_sym_short] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3042),
    [anon_sym_static] = ACTIONS(3042),
    [anon_sym_register] = ACTIONS(3042),
    [anon_sym_inline] = ACTIONS(3042),
    [anon_sym___inline] = ACTIONS(3042),
    [anon_sym___inline__] = ACTIONS(3042),
    [anon_sym___forceinline] = ACTIONS(3042),
    [anon_sym_thread_local] = ACTIONS(3042),
    [anon_sym___thread] = ACTIONS(3042),
    [anon_sym_const] = ACTIONS(3042),
    [anon_sym_constexpr] = ACTIONS(3042),
    [anon_sym_volatile] = ACTIONS(3042),
    [anon_sym_restrict] = ACTIONS(3042),
    [anon_sym___restrict__] = ACTIONS(3042),
    [anon_sym__Atomic] = ACTIONS(3042),
    [anon_sym__Noreturn] = ACTIONS(3042),
    [anon_sym_noreturn] = ACTIONS(3042),
    [anon_sym__Nonnull] = ACTIONS(3042),
    [anon_sym_mutable] = ACTIONS(3042),
    [anon_sym_constinit] = ACTIONS(3042),
    [anon_sym_consteval] = ACTIONS(3042),
    [anon_sym_alignas] = ACTIONS(3042),
    [anon_sym__Alignas] = ACTIONS(3042),
    [sym_primitive_type] = ACTIONS(3042),
    [anon_sym_enum] = ACTIONS(3042),
    [anon_sym_class] = ACTIONS(3042),
    [anon_sym_struct] = ACTIONS(3042),
    [anon_sym_union] = ACTIONS(3042),
    [anon_sym_if] = ACTIONS(3042),
    [anon_sym_switch] = ACTIONS(3042),
    [anon_sym_case] = ACTIONS(3042),
    [anon_sym_default] = ACTIONS(3042),
    [anon_sym_while] = ACTIONS(3042),
    [anon_sym_do] = ACTIONS(3042),
    [anon_sym_for] = ACTIONS(3042),
    [anon_sym_return] = ACTIONS(3042),
    [anon_sym_break] = ACTIONS(3042),
    [anon_sym_continue] = ACTIONS(3042),
    [anon_sym_goto] = ACTIONS(3042),
    [anon_sym___try] = ACTIONS(3042),
    [anon_sym___leave] = ACTIONS(3042),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_compl] = ACTIONS(3042),
    [anon_sym_DASH_DASH] = ACTIONS(3044),
    [anon_sym_PLUS_PLUS] = ACTIONS(3044),
    [anon_sym_sizeof] = ACTIONS(3042),
    [anon_sym___alignof__] = ACTIONS(3042),
    [anon_sym___alignof] = ACTIONS(3042),
    [anon_sym__alignof] = ACTIONS(3042),
    [anon_sym_alignof] = ACTIONS(3042),
    [anon_sym__Alignof] = ACTIONS(3042),
    [anon_sym_offsetof] = ACTIONS(3042),
    [anon_sym__Generic] = ACTIONS(3042),
    [anon_sym_asm] = ACTIONS(3042),
    [anon_sym___asm__] = ACTIONS(3042),
    [anon_sym___asm] = ACTIONS(3042),
    [sym_number_literal] = ACTIONS(3044),
    [anon_sym_L_SQUOTE] = ACTIONS(3044),
    [anon_sym_u_SQUOTE] = ACTIONS(3044),
    [anon_sym_U_SQUOTE] = ACTIONS(3044),
    [anon_sym_u8_SQUOTE] = ACTIONS(3044),
    [anon_sym_SQUOTE] = ACTIONS(3044),
    [anon_sym_L_DQUOTE] = ACTIONS(3044),
    [anon_sym_u_DQUOTE] = ACTIONS(3044),
    [anon_sym_U_DQUOTE] = ACTIONS(3044),
    [anon_sym_u8_DQUOTE] = ACTIONS(3044),
    [anon_sym_DQUOTE] = ACTIONS(3044),
    [sym_true] = ACTIONS(3042),
    [sym_false] = ACTIONS(3042),
    [anon_sym_NULL] = ACTIONS(3042),
    [anon_sym_nullptr] = ACTIONS(3042),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3042),
    [anon_sym_decltype] = ACTIONS(3042),
    [anon_sym_explicit] = ACTIONS(3042),
    [anon_sym_typename] = ACTIONS(3042),
    [anon_sym_template] = ACTIONS(3042),
    [anon_sym_operator] = ACTIONS(3042),
    [anon_sym_try] = ACTIONS(3042),
    [anon_sym_delete] = ACTIONS(3042),
    [anon_sym_throw] = ACTIONS(3042),
    [anon_sym_namespace] = ACTIONS(3042),
    [anon_sym_using] = ACTIONS(3042),
    [anon_sym_static_assert] = ACTIONS(3042),
    [anon_sym_concept] = ACTIONS(3042),
    [anon_sym_co_return] = ACTIONS(3042),
    [anon_sym_co_yield] = ACTIONS(3042),
    [anon_sym_R_DQUOTE] = ACTIONS(3044),
    [anon_sym_LR_DQUOTE] = ACTIONS(3044),
    [anon_sym_uR_DQUOTE] = ACTIONS(3044),
    [anon_sym_UR_DQUOTE] = ACTIONS(3044),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3044),
    [anon_sym_co_await] = ACTIONS(3042),
    [anon_sym_new] = ACTIONS(3042),
    [anon_sym_requires] = ACTIONS(3042),
    [sym_this] = ACTIONS(3042),
  },
  [667] = {
    [sym_identifier] = ACTIONS(2818),
    [aux_sym_preproc_include_token1] = ACTIONS(2818),
    [aux_sym_preproc_def_token1] = ACTIONS(2818),
    [aux_sym_preproc_if_token1] = ACTIONS(2818),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2818),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2818),
    [sym_preproc_directive] = ACTIONS(2818),
    [anon_sym_LPAREN2] = ACTIONS(2820),
    [anon_sym_BANG] = ACTIONS(2820),
    [anon_sym_TILDE] = ACTIONS(2820),
    [anon_sym_DASH] = ACTIONS(2818),
    [anon_sym_PLUS] = ACTIONS(2818),
    [anon_sym_STAR] = ACTIONS(2820),
    [anon_sym_AMP_AMP] = ACTIONS(2820),
    [anon_sym_AMP] = ACTIONS(2818),
    [anon_sym_SEMI] = ACTIONS(2820),
    [anon_sym___extension__] = ACTIONS(2818),
    [anon_sym_typedef] = ACTIONS(2818),
    [anon_sym_virtual] = ACTIONS(2818),
    [anon_sym_extern] = ACTIONS(2818),
    [anon_sym___attribute__] = ACTIONS(2818),
    [anon_sym___attribute] = ACTIONS(2818),
    [anon_sym_COLON_COLON] = ACTIONS(2820),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2820),
    [anon_sym___declspec] = ACTIONS(2818),
    [anon_sym___based] = ACTIONS(2818),
    [anon_sym___cdecl] = ACTIONS(2818),
    [anon_sym___clrcall] = ACTIONS(2818),
    [anon_sym___stdcall] = ACTIONS(2818),
    [anon_sym___fastcall] = ACTIONS(2818),
    [anon_sym___thiscall] = ACTIONS(2818),
    [anon_sym___vectorcall] = ACTIONS(2818),
    [anon_sym_LBRACE] = ACTIONS(2820),
    [anon_sym_RBRACE] = ACTIONS(2820),
    [anon_sym_signed] = ACTIONS(2818),
    [anon_sym_unsigned] = ACTIONS(2818),
    [anon_sym_long] = ACTIONS(2818),
    [anon_sym_short] = ACTIONS(2818),
    [anon_sym_LBRACK] = ACTIONS(2818),
    [anon_sym_static] = ACTIONS(2818),
    [anon_sym_register] = ACTIONS(2818),
    [anon_sym_inline] = ACTIONS(2818),
    [anon_sym___inline] = ACTIONS(2818),
    [anon_sym___inline__] = ACTIONS(2818),
    [anon_sym___forceinline] = ACTIONS(2818),
    [anon_sym_thread_local] = ACTIONS(2818),
    [anon_sym___thread] = ACTIONS(2818),
    [anon_sym_const] = ACTIONS(2818),
    [anon_sym_constexpr] = ACTIONS(2818),
    [anon_sym_volatile] = ACTIONS(2818),
    [anon_sym_restrict] = ACTIONS(2818),
    [anon_sym___restrict__] = ACTIONS(2818),
    [anon_sym__Atomic] = ACTIONS(2818),
    [anon_sym__Noreturn] = ACTIONS(2818),
    [anon_sym_noreturn] = ACTIONS(2818),
    [anon_sym__Nonnull] = ACTIONS(2818),
    [anon_sym_mutable] = ACTIONS(2818),
    [anon_sym_constinit] = ACTIONS(2818),
    [anon_sym_consteval] = ACTIONS(2818),
    [anon_sym_alignas] = ACTIONS(2818),
    [anon_sym__Alignas] = ACTIONS(2818),
    [sym_primitive_type] = ACTIONS(2818),
    [anon_sym_enum] = ACTIONS(2818),
    [anon_sym_class] = ACTIONS(2818),
    [anon_sym_struct] = ACTIONS(2818),
    [anon_sym_union] = ACTIONS(2818),
    [anon_sym_if] = ACTIONS(2818),
    [anon_sym_switch] = ACTIONS(2818),
    [anon_sym_case] = ACTIONS(2818),
    [anon_sym_default] = ACTIONS(2818),
    [anon_sym_while] = ACTIONS(2818),
    [anon_sym_do] = ACTIONS(2818),
    [anon_sym_for] = ACTIONS(2818),
    [anon_sym_return] = ACTIONS(2818),
    [anon_sym_break] = ACTIONS(2818),
    [anon_sym_continue] = ACTIONS(2818),
    [anon_sym_goto] = ACTIONS(2818),
    [anon_sym___try] = ACTIONS(2818),
    [anon_sym___leave] = ACTIONS(2818),
    [anon_sym_not] = ACTIONS(2818),
    [anon_sym_compl] = ACTIONS(2818),
    [anon_sym_DASH_DASH] = ACTIONS(2820),
    [anon_sym_PLUS_PLUS] = ACTIONS(2820),
    [anon_sym_sizeof] = ACTIONS(2818),
    [anon_sym___alignof__] = ACTIONS(2818),
    [anon_sym___alignof] = ACTIONS(2818),
    [anon_sym__alignof] = ACTIONS(2818),
    [anon_sym_alignof] = ACTIONS(2818),
    [anon_sym__Alignof] = ACTIONS(2818),
    [anon_sym_offsetof] = ACTIONS(2818),
    [anon_sym__Generic] = ACTIONS(2818),
    [anon_sym_asm] = ACTIONS(2818),
    [anon_sym___asm__] = ACTIONS(2818),
    [anon_sym___asm] = ACTIONS(2818),
    [sym_number_literal] = ACTIONS(2820),
    [anon_sym_L_SQUOTE] = ACTIONS(2820),
    [anon_sym_u_SQUOTE] = ACTIONS(2820),
    [anon_sym_U_SQUOTE] = ACTIONS(2820),
    [anon_sym_u8_SQUOTE] = ACTIONS(2820),
    [anon_sym_SQUOTE] = ACTIONS(2820),
    [anon_sym_L_DQUOTE] = ACTIONS(2820),
    [anon_sym_u_DQUOTE] = ACTIONS(2820),
    [anon_sym_U_DQUOTE] = ACTIONS(2820),
    [anon_sym_u8_DQUOTE] = ACTIONS(2820),
    [anon_sym_DQUOTE] = ACTIONS(2820),
    [sym_true] = ACTIONS(2818),
    [sym_false] = ACTIONS(2818),
    [anon_sym_NULL] = ACTIONS(2818),
    [anon_sym_nullptr] = ACTIONS(2818),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2818),
    [anon_sym_decltype] = ACTIONS(2818),
    [anon_sym_explicit] = ACTIONS(2818),
    [anon_sym_typename] = ACTIONS(2818),
    [anon_sym_template] = ACTIONS(2818),
    [anon_sym_operator] = ACTIONS(2818),
    [anon_sym_try] = ACTIONS(2818),
    [anon_sym_delete] = ACTIONS(2818),
    [anon_sym_throw] = ACTIONS(2818),
    [anon_sym_namespace] = ACTIONS(2818),
    [anon_sym_using] = ACTIONS(2818),
    [anon_sym_static_assert] = ACTIONS(2818),
    [anon_sym_concept] = ACTIONS(2818),
    [anon_sym_co_return] = ACTIONS(2818),
    [anon_sym_co_yield] = ACTIONS(2818),
    [anon_sym_R_DQUOTE] = ACTIONS(2820),
    [anon_sym_LR_DQUOTE] = ACTIONS(2820),
    [anon_sym_uR_DQUOTE] = ACTIONS(2820),
    [anon_sym_UR_DQUOTE] = ACTIONS(2820),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2820),
    [anon_sym_co_await] = ACTIONS(2818),
    [anon_sym_new] = ACTIONS(2818),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2818),
  },
  [668] = {
    [sym_identifier] = ACTIONS(2822),
    [aux_sym_preproc_include_token1] = ACTIONS(2822),
    [aux_sym_preproc_def_token1] = ACTIONS(2822),
    [aux_sym_preproc_if_token1] = ACTIONS(2822),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2822),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2822),
    [sym_preproc_directive] = ACTIONS(2822),
    [anon_sym_LPAREN2] = ACTIONS(2824),
    [anon_sym_BANG] = ACTIONS(2824),
    [anon_sym_TILDE] = ACTIONS(2824),
    [anon_sym_DASH] = ACTIONS(2822),
    [anon_sym_PLUS] = ACTIONS(2822),
    [anon_sym_STAR] = ACTIONS(2824),
    [anon_sym_AMP_AMP] = ACTIONS(2824),
    [anon_sym_AMP] = ACTIONS(2822),
    [anon_sym_SEMI] = ACTIONS(2824),
    [anon_sym___extension__] = ACTIONS(2822),
    [anon_sym_typedef] = ACTIONS(2822),
    [anon_sym_virtual] = ACTIONS(2822),
    [anon_sym_extern] = ACTIONS(2822),
    [anon_sym___attribute__] = ACTIONS(2822),
    [anon_sym___attribute] = ACTIONS(2822),
    [anon_sym_COLON_COLON] = ACTIONS(2824),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2824),
    [anon_sym___declspec] = ACTIONS(2822),
    [anon_sym___based] = ACTIONS(2822),
    [anon_sym___cdecl] = ACTIONS(2822),
    [anon_sym___clrcall] = ACTIONS(2822),
    [anon_sym___stdcall] = ACTIONS(2822),
    [anon_sym___fastcall] = ACTIONS(2822),
    [anon_sym___thiscall] = ACTIONS(2822),
    [anon_sym___vectorcall] = ACTIONS(2822),
    [anon_sym_LBRACE] = ACTIONS(2824),
    [anon_sym_RBRACE] = ACTIONS(2824),
    [anon_sym_signed] = ACTIONS(2822),
    [anon_sym_unsigned] = ACTIONS(2822),
    [anon_sym_long] = ACTIONS(2822),
    [anon_sym_short] = ACTIONS(2822),
    [anon_sym_LBRACK] = ACTIONS(2822),
    [anon_sym_static] = ACTIONS(2822),
    [anon_sym_register] = ACTIONS(2822),
    [anon_sym_inline] = ACTIONS(2822),
    [anon_sym___inline] = ACTIONS(2822),
    [anon_sym___inline__] = ACTIONS(2822),
    [anon_sym___forceinline] = ACTIONS(2822),
    [anon_sym_thread_local] = ACTIONS(2822),
    [anon_sym___thread] = ACTIONS(2822),
    [anon_sym_const] = ACTIONS(2822),
    [anon_sym_constexpr] = ACTIONS(2822),
    [anon_sym_volatile] = ACTIONS(2822),
    [anon_sym_restrict] = ACTIONS(2822),
    [anon_sym___restrict__] = ACTIONS(2822),
    [anon_sym__Atomic] = ACTIONS(2822),
    [anon_sym__Noreturn] = ACTIONS(2822),
    [anon_sym_noreturn] = ACTIONS(2822),
    [anon_sym__Nonnull] = ACTIONS(2822),
    [anon_sym_mutable] = ACTIONS(2822),
    [anon_sym_constinit] = ACTIONS(2822),
    [anon_sym_consteval] = ACTIONS(2822),
    [anon_sym_alignas] = ACTIONS(2822),
    [anon_sym__Alignas] = ACTIONS(2822),
    [sym_primitive_type] = ACTIONS(2822),
    [anon_sym_enum] = ACTIONS(2822),
    [anon_sym_class] = ACTIONS(2822),
    [anon_sym_struct] = ACTIONS(2822),
    [anon_sym_union] = ACTIONS(2822),
    [anon_sym_if] = ACTIONS(2822),
    [anon_sym_switch] = ACTIONS(2822),
    [anon_sym_case] = ACTIONS(2822),
    [anon_sym_default] = ACTIONS(2822),
    [anon_sym_while] = ACTIONS(2822),
    [anon_sym_do] = ACTIONS(2822),
    [anon_sym_for] = ACTIONS(2822),
    [anon_sym_return] = ACTIONS(2822),
    [anon_sym_break] = ACTIONS(2822),
    [anon_sym_continue] = ACTIONS(2822),
    [anon_sym_goto] = ACTIONS(2822),
    [anon_sym___try] = ACTIONS(2822),
    [anon_sym___leave] = ACTIONS(2822),
    [anon_sym_not] = ACTIONS(2822),
    [anon_sym_compl] = ACTIONS(2822),
    [anon_sym_DASH_DASH] = ACTIONS(2824),
    [anon_sym_PLUS_PLUS] = ACTIONS(2824),
    [anon_sym_sizeof] = ACTIONS(2822),
    [anon_sym___alignof__] = ACTIONS(2822),
    [anon_sym___alignof] = ACTIONS(2822),
    [anon_sym__alignof] = ACTIONS(2822),
    [anon_sym_alignof] = ACTIONS(2822),
    [anon_sym__Alignof] = ACTIONS(2822),
    [anon_sym_offsetof] = ACTIONS(2822),
    [anon_sym__Generic] = ACTIONS(2822),
    [anon_sym_asm] = ACTIONS(2822),
    [anon_sym___asm__] = ACTIONS(2822),
    [anon_sym___asm] = ACTIONS(2822),
    [sym_number_literal] = ACTIONS(2824),
    [anon_sym_L_SQUOTE] = ACTIONS(2824),
    [anon_sym_u_SQUOTE] = ACTIONS(2824),
    [anon_sym_U_SQUOTE] = ACTIONS(2824),
    [anon_sym_u8_SQUOTE] = ACTIONS(2824),
    [anon_sym_SQUOTE] = ACTIONS(2824),
    [anon_sym_L_DQUOTE] = ACTIONS(2824),
    [anon_sym_u_DQUOTE] = ACTIONS(2824),
    [anon_sym_U_DQUOTE] = ACTIONS(2824),
    [anon_sym_u8_DQUOTE] = ACTIONS(2824),
    [anon_sym_DQUOTE] = ACTIONS(2824),
    [sym_true] = ACTIONS(2822),
    [sym_false] = ACTIONS(2822),
    [anon_sym_NULL] = ACTIONS(2822),
    [anon_sym_nullptr] = ACTIONS(2822),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2822),
    [anon_sym_decltype] = ACTIONS(2822),
    [anon_sym_explicit] = ACTIONS(2822),
    [anon_sym_typename] = ACTIONS(2822),
    [anon_sym_template] = ACTIONS(2822),
    [anon_sym_operator] = ACTIONS(2822),
    [anon_sym_try] = ACTIONS(2822),
    [anon_sym_delete] = ACTIONS(2822),
    [anon_sym_throw] = ACTIONS(2822),
    [anon_sym_namespace] = ACTIONS(2822),
    [anon_sym_using] = ACTIONS(2822),
    [anon_sym_static_assert] = ACTIONS(2822),
    [anon_sym_concept] = ACTIONS(2822),
    [anon_sym_co_return] = ACTIONS(2822),
    [anon_sym_co_yield] = ACTIONS(2822),
    [anon_sym_R_DQUOTE] = ACTIONS(2824),
    [anon_sym_LR_DQUOTE] = ACTIONS(2824),
    [anon_sym_uR_DQUOTE] = ACTIONS(2824),
    [anon_sym_UR_DQUOTE] = ACTIONS(2824),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2824),
    [anon_sym_co_await] = ACTIONS(2822),
    [anon_sym_new] = ACTIONS(2822),
    [anon_sym_requires] = ACTIONS(2822),
    [sym_this] = ACTIONS(2822),
  },
  [669] = {
    [sym_identifier] = ACTIONS(2755),
    [aux_sym_preproc_include_token1] = ACTIONS(2755),
    [aux_sym_preproc_def_token1] = ACTIONS(2755),
    [aux_sym_preproc_if_token1] = ACTIONS(2755),
    [aux_sym_preproc_if_token2] = ACTIONS(2755),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2755),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2755),
    [sym_preproc_directive] = ACTIONS(2755),
    [anon_sym_LPAREN2] = ACTIONS(2757),
    [anon_sym_BANG] = ACTIONS(2757),
    [anon_sym_TILDE] = ACTIONS(2757),
    [anon_sym_DASH] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_STAR] = ACTIONS(2757),
    [anon_sym_AMP_AMP] = ACTIONS(2757),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2757),
    [anon_sym___extension__] = ACTIONS(2755),
    [anon_sym_typedef] = ACTIONS(2755),
    [anon_sym_virtual] = ACTIONS(2755),
    [anon_sym_extern] = ACTIONS(2755),
    [anon_sym___attribute__] = ACTIONS(2755),
    [anon_sym___attribute] = ACTIONS(2755),
    [anon_sym_COLON_COLON] = ACTIONS(2757),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2757),
    [anon_sym___declspec] = ACTIONS(2755),
    [anon_sym___based] = ACTIONS(2755),
    [anon_sym___cdecl] = ACTIONS(2755),
    [anon_sym___clrcall] = ACTIONS(2755),
    [anon_sym___stdcall] = ACTIONS(2755),
    [anon_sym___fastcall] = ACTIONS(2755),
    [anon_sym___thiscall] = ACTIONS(2755),
    [anon_sym___vectorcall] = ACTIONS(2755),
    [anon_sym_LBRACE] = ACTIONS(2757),
    [anon_sym_signed] = ACTIONS(2755),
    [anon_sym_unsigned] = ACTIONS(2755),
    [anon_sym_long] = ACTIONS(2755),
    [anon_sym_short] = ACTIONS(2755),
    [anon_sym_LBRACK] = ACTIONS(2755),
    [anon_sym_static] = ACTIONS(2755),
    [anon_sym_register] = ACTIONS(2755),
    [anon_sym_inline] = ACTIONS(2755),
    [anon_sym___inline] = ACTIONS(2755),
    [anon_sym___inline__] = ACTIONS(2755),
    [anon_sym___forceinline] = ACTIONS(2755),
    [anon_sym_thread_local] = ACTIONS(2755),
    [anon_sym___thread] = ACTIONS(2755),
    [anon_sym_const] = ACTIONS(2755),
    [anon_sym_constexpr] = ACTIONS(2755),
    [anon_sym_volatile] = ACTIONS(2755),
    [anon_sym_restrict] = ACTIONS(2755),
    [anon_sym___restrict__] = ACTIONS(2755),
    [anon_sym__Atomic] = ACTIONS(2755),
    [anon_sym__Noreturn] = ACTIONS(2755),
    [anon_sym_noreturn] = ACTIONS(2755),
    [anon_sym__Nonnull] = ACTIONS(2755),
    [anon_sym_mutable] = ACTIONS(2755),
    [anon_sym_constinit] = ACTIONS(2755),
    [anon_sym_consteval] = ACTIONS(2755),
    [anon_sym_alignas] = ACTIONS(2755),
    [anon_sym__Alignas] = ACTIONS(2755),
    [sym_primitive_type] = ACTIONS(2755),
    [anon_sym_enum] = ACTIONS(2755),
    [anon_sym_class] = ACTIONS(2755),
    [anon_sym_struct] = ACTIONS(2755),
    [anon_sym_union] = ACTIONS(2755),
    [anon_sym_if] = ACTIONS(2755),
    [anon_sym_switch] = ACTIONS(2755),
    [anon_sym_case] = ACTIONS(2755),
    [anon_sym_default] = ACTIONS(2755),
    [anon_sym_while] = ACTIONS(2755),
    [anon_sym_do] = ACTIONS(2755),
    [anon_sym_for] = ACTIONS(2755),
    [anon_sym_return] = ACTIONS(2755),
    [anon_sym_break] = ACTIONS(2755),
    [anon_sym_continue] = ACTIONS(2755),
    [anon_sym_goto] = ACTIONS(2755),
    [anon_sym___try] = ACTIONS(2755),
    [anon_sym___leave] = ACTIONS(2755),
    [anon_sym_not] = ACTIONS(2755),
    [anon_sym_compl] = ACTIONS(2755),
    [anon_sym_DASH_DASH] = ACTIONS(2757),
    [anon_sym_PLUS_PLUS] = ACTIONS(2757),
    [anon_sym_sizeof] = ACTIONS(2755),
    [anon_sym___alignof__] = ACTIONS(2755),
    [anon_sym___alignof] = ACTIONS(2755),
    [anon_sym__alignof] = ACTIONS(2755),
    [anon_sym_alignof] = ACTIONS(2755),
    [anon_sym__Alignof] = ACTIONS(2755),
    [anon_sym_offsetof] = ACTIONS(2755),
    [anon_sym__Generic] = ACTIONS(2755),
    [anon_sym_asm] = ACTIONS(2755),
    [anon_sym___asm__] = ACTIONS(2755),
    [anon_sym___asm] = ACTIONS(2755),
    [sym_number_literal] = ACTIONS(2757),
    [anon_sym_L_SQUOTE] = ACTIONS(2757),
    [anon_sym_u_SQUOTE] = ACTIONS(2757),
    [anon_sym_U_SQUOTE] = ACTIONS(2757),
    [anon_sym_u8_SQUOTE] = ACTIONS(2757),
    [anon_sym_SQUOTE] = ACTIONS(2757),
    [anon_sym_L_DQUOTE] = ACTIONS(2757),
    [anon_sym_u_DQUOTE] = ACTIONS(2757),
    [anon_sym_U_DQUOTE] = ACTIONS(2757),
    [anon_sym_u8_DQUOTE] = ACTIONS(2757),
    [anon_sym_DQUOTE] = ACTIONS(2757),
    [sym_true] = ACTIONS(2755),
    [sym_false] = ACTIONS(2755),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2755),
    [anon_sym_decltype] = ACTIONS(2755),
    [anon_sym_explicit] = ACTIONS(2755),
    [anon_sym_typename] = ACTIONS(2755),
    [anon_sym_template] = ACTIONS(2755),
    [anon_sym_operator] = ACTIONS(2755),
    [anon_sym_try] = ACTIONS(2755),
    [anon_sym_delete] = ACTIONS(2755),
    [anon_sym_throw] = ACTIONS(2755),
    [anon_sym_namespace] = ACTIONS(2755),
    [anon_sym_using] = ACTIONS(2755),
    [anon_sym_static_assert] = ACTIONS(2755),
    [anon_sym_concept] = ACTIONS(2755),
    [anon_sym_co_return] = ACTIONS(2755),
    [anon_sym_co_yield] = ACTIONS(2755),
    [anon_sym_R_DQUOTE] = ACTIONS(2757),
    [anon_sym_LR_DQUOTE] = ACTIONS(2757),
    [anon_sym_uR_DQUOTE] = ACTIONS(2757),
    [anon_sym_UR_DQUOTE] = ACTIONS(2757),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2757),
    [anon_sym_co_await] = ACTIONS(2755),
    [anon_sym_new] = ACTIONS(2755),
    [anon_sym_requires] = ACTIONS(2755),
    [sym_this] = ACTIONS(2755),
  },
  [670] = {
    [sym_identifier] = ACTIONS(3042),
    [aux_sym_preproc_include_token1] = ACTIONS(3042),
    [aux_sym_preproc_def_token1] = ACTIONS(3042),
    [aux_sym_preproc_if_token1] = ACTIONS(3042),
    [aux_sym_preproc_if_token2] = ACTIONS(3042),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3042),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3042),
    [sym_preproc_directive] = ACTIONS(3042),
    [anon_sym_LPAREN2] = ACTIONS(3044),
    [anon_sym_BANG] = ACTIONS(3044),
    [anon_sym_TILDE] = ACTIONS(3044),
    [anon_sym_DASH] = ACTIONS(3042),
    [anon_sym_PLUS] = ACTIONS(3042),
    [anon_sym_STAR] = ACTIONS(3044),
    [anon_sym_AMP_AMP] = ACTIONS(3044),
    [anon_sym_AMP] = ACTIONS(3042),
    [anon_sym_SEMI] = ACTIONS(3044),
    [anon_sym___extension__] = ACTIONS(3042),
    [anon_sym_typedef] = ACTIONS(3042),
    [anon_sym_virtual] = ACTIONS(3042),
    [anon_sym_extern] = ACTIONS(3042),
    [anon_sym___attribute__] = ACTIONS(3042),
    [anon_sym___attribute] = ACTIONS(3042),
    [anon_sym_COLON_COLON] = ACTIONS(3044),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3044),
    [anon_sym___declspec] = ACTIONS(3042),
    [anon_sym___based] = ACTIONS(3042),
    [anon_sym___cdecl] = ACTIONS(3042),
    [anon_sym___clrcall] = ACTIONS(3042),
    [anon_sym___stdcall] = ACTIONS(3042),
    [anon_sym___fastcall] = ACTIONS(3042),
    [anon_sym___thiscall] = ACTIONS(3042),
    [anon_sym___vectorcall] = ACTIONS(3042),
    [anon_sym_LBRACE] = ACTIONS(3044),
    [anon_sym_signed] = ACTIONS(3042),
    [anon_sym_unsigned] = ACTIONS(3042),
    [anon_sym_long] = ACTIONS(3042),
    [anon_sym_short] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3042),
    [anon_sym_static] = ACTIONS(3042),
    [anon_sym_register] = ACTIONS(3042),
    [anon_sym_inline] = ACTIONS(3042),
    [anon_sym___inline] = ACTIONS(3042),
    [anon_sym___inline__] = ACTIONS(3042),
    [anon_sym___forceinline] = ACTIONS(3042),
    [anon_sym_thread_local] = ACTIONS(3042),
    [anon_sym___thread] = ACTIONS(3042),
    [anon_sym_const] = ACTIONS(3042),
    [anon_sym_constexpr] = ACTIONS(3042),
    [anon_sym_volatile] = ACTIONS(3042),
    [anon_sym_restrict] = ACTIONS(3042),
    [anon_sym___restrict__] = ACTIONS(3042),
    [anon_sym__Atomic] = ACTIONS(3042),
    [anon_sym__Noreturn] = ACTIONS(3042),
    [anon_sym_noreturn] = ACTIONS(3042),
    [anon_sym__Nonnull] = ACTIONS(3042),
    [anon_sym_mutable] = ACTIONS(3042),
    [anon_sym_constinit] = ACTIONS(3042),
    [anon_sym_consteval] = ACTIONS(3042),
    [anon_sym_alignas] = ACTIONS(3042),
    [anon_sym__Alignas] = ACTIONS(3042),
    [sym_primitive_type] = ACTIONS(3042),
    [anon_sym_enum] = ACTIONS(3042),
    [anon_sym_class] = ACTIONS(3042),
    [anon_sym_struct] = ACTIONS(3042),
    [anon_sym_union] = ACTIONS(3042),
    [anon_sym_if] = ACTIONS(3042),
    [anon_sym_switch] = ACTIONS(3042),
    [anon_sym_case] = ACTIONS(3042),
    [anon_sym_default] = ACTIONS(3042),
    [anon_sym_while] = ACTIONS(3042),
    [anon_sym_do] = ACTIONS(3042),
    [anon_sym_for] = ACTIONS(3042),
    [anon_sym_return] = ACTIONS(3042),
    [anon_sym_break] = ACTIONS(3042),
    [anon_sym_continue] = ACTIONS(3042),
    [anon_sym_goto] = ACTIONS(3042),
    [anon_sym___try] = ACTIONS(3042),
    [anon_sym___leave] = ACTIONS(3042),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_compl] = ACTIONS(3042),
    [anon_sym_DASH_DASH] = ACTIONS(3044),
    [anon_sym_PLUS_PLUS] = ACTIONS(3044),
    [anon_sym_sizeof] = ACTIONS(3042),
    [anon_sym___alignof__] = ACTIONS(3042),
    [anon_sym___alignof] = ACTIONS(3042),
    [anon_sym__alignof] = ACTIONS(3042),
    [anon_sym_alignof] = ACTIONS(3042),
    [anon_sym__Alignof] = ACTIONS(3042),
    [anon_sym_offsetof] = ACTIONS(3042),
    [anon_sym__Generic] = ACTIONS(3042),
    [anon_sym_asm] = ACTIONS(3042),
    [anon_sym___asm__] = ACTIONS(3042),
    [anon_sym___asm] = ACTIONS(3042),
    [sym_number_literal] = ACTIONS(3044),
    [anon_sym_L_SQUOTE] = ACTIONS(3044),
    [anon_sym_u_SQUOTE] = ACTIONS(3044),
    [anon_sym_U_SQUOTE] = ACTIONS(3044),
    [anon_sym_u8_SQUOTE] = ACTIONS(3044),
    [anon_sym_SQUOTE] = ACTIONS(3044),
    [anon_sym_L_DQUOTE] = ACTIONS(3044),
    [anon_sym_u_DQUOTE] = ACTIONS(3044),
    [anon_sym_U_DQUOTE] = ACTIONS(3044),
    [anon_sym_u8_DQUOTE] = ACTIONS(3044),
    [anon_sym_DQUOTE] = ACTIONS(3044),
    [sym_true] = ACTIONS(3042),
    [sym_false] = ACTIONS(3042),
    [anon_sym_NULL] = ACTIONS(3042),
    [anon_sym_nullptr] = ACTIONS(3042),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3042),
    [anon_sym_decltype] = ACTIONS(3042),
    [anon_sym_explicit] = ACTIONS(3042),
    [anon_sym_typename] = ACTIONS(3042),
    [anon_sym_template] = ACTIONS(3042),
    [anon_sym_operator] = ACTIONS(3042),
    [anon_sym_try] = ACTIONS(3042),
    [anon_sym_delete] = ACTIONS(3042),
    [anon_sym_throw] = ACTIONS(3042),
    [anon_sym_namespace] = ACTIONS(3042),
    [anon_sym_using] = ACTIONS(3042),
    [anon_sym_static_assert] = ACTIONS(3042),
    [anon_sym_concept] = ACTIONS(3042),
    [anon_sym_co_return] = ACTIONS(3042),
    [anon_sym_co_yield] = ACTIONS(3042),
    [anon_sym_R_DQUOTE] = ACTIONS(3044),
    [anon_sym_LR_DQUOTE] = ACTIONS(3044),
    [anon_sym_uR_DQUOTE] = ACTIONS(3044),
    [anon_sym_UR_DQUOTE] = ACTIONS(3044),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3044),
    [anon_sym_co_await] = ACTIONS(3042),
    [anon_sym_new] = ACTIONS(3042),
    [anon_sym_requires] = ACTIONS(3042),
    [sym_this] = ACTIONS(3042),
  },
  [671] = {
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token2] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym___attribute] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym__Nonnull] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym__Alignas] = ACTIONS(3072),
    [sym_primitive_type] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym___try] = ACTIONS(3072),
    [anon_sym___leave] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [anon_sym___asm] = ACTIONS(3072),
    [sym_number_literal] = ACTIONS(3074),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [672] = {
    [sym_identifier] = ACTIONS(2799),
    [aux_sym_preproc_include_token1] = ACTIONS(2799),
    [aux_sym_preproc_def_token1] = ACTIONS(2799),
    [aux_sym_preproc_if_token1] = ACTIONS(2799),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2799),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2799),
    [sym_preproc_directive] = ACTIONS(2799),
    [anon_sym_LPAREN2] = ACTIONS(2801),
    [anon_sym_BANG] = ACTIONS(2801),
    [anon_sym_TILDE] = ACTIONS(2801),
    [anon_sym_DASH] = ACTIONS(2799),
    [anon_sym_PLUS] = ACTIONS(2799),
    [anon_sym_STAR] = ACTIONS(2801),
    [anon_sym_AMP_AMP] = ACTIONS(2801),
    [anon_sym_AMP] = ACTIONS(2799),
    [anon_sym_SEMI] = ACTIONS(2801),
    [anon_sym___extension__] = ACTIONS(2799),
    [anon_sym_typedef] = ACTIONS(2799),
    [anon_sym_virtual] = ACTIONS(2799),
    [anon_sym_extern] = ACTIONS(2799),
    [anon_sym___attribute__] = ACTIONS(2799),
    [anon_sym___attribute] = ACTIONS(2799),
    [anon_sym_COLON_COLON] = ACTIONS(2801),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2801),
    [anon_sym___declspec] = ACTIONS(2799),
    [anon_sym___based] = ACTIONS(2799),
    [anon_sym___cdecl] = ACTIONS(2799),
    [anon_sym___clrcall] = ACTIONS(2799),
    [anon_sym___stdcall] = ACTIONS(2799),
    [anon_sym___fastcall] = ACTIONS(2799),
    [anon_sym___thiscall] = ACTIONS(2799),
    [anon_sym___vectorcall] = ACTIONS(2799),
    [anon_sym_LBRACE] = ACTIONS(2801),
    [anon_sym_RBRACE] = ACTIONS(2801),
    [anon_sym_signed] = ACTIONS(2799),
    [anon_sym_unsigned] = ACTIONS(2799),
    [anon_sym_long] = ACTIONS(2799),
    [anon_sym_short] = ACTIONS(2799),
    [anon_sym_LBRACK] = ACTIONS(2799),
    [anon_sym_static] = ACTIONS(2799),
    [anon_sym_register] = ACTIONS(2799),
    [anon_sym_inline] = ACTIONS(2799),
    [anon_sym___inline] = ACTIONS(2799),
    [anon_sym___inline__] = ACTIONS(2799),
    [anon_sym___forceinline] = ACTIONS(2799),
    [anon_sym_thread_local] = ACTIONS(2799),
    [anon_sym___thread] = ACTIONS(2799),
    [anon_sym_const] = ACTIONS(2799),
    [anon_sym_constexpr] = ACTIONS(2799),
    [anon_sym_volatile] = ACTIONS(2799),
    [anon_sym_restrict] = ACTIONS(2799),
    [anon_sym___restrict__] = ACTIONS(2799),
    [anon_sym__Atomic] = ACTIONS(2799),
    [anon_sym__Noreturn] = ACTIONS(2799),
    [anon_sym_noreturn] = ACTIONS(2799),
    [anon_sym__Nonnull] = ACTIONS(2799),
    [anon_sym_mutable] = ACTIONS(2799),
    [anon_sym_constinit] = ACTIONS(2799),
    [anon_sym_consteval] = ACTIONS(2799),
    [anon_sym_alignas] = ACTIONS(2799),
    [anon_sym__Alignas] = ACTIONS(2799),
    [sym_primitive_type] = ACTIONS(2799),
    [anon_sym_enum] = ACTIONS(2799),
    [anon_sym_class] = ACTIONS(2799),
    [anon_sym_struct] = ACTIONS(2799),
    [anon_sym_union] = ACTIONS(2799),
    [anon_sym_if] = ACTIONS(2799),
    [anon_sym_switch] = ACTIONS(2799),
    [anon_sym_case] = ACTIONS(2799),
    [anon_sym_default] = ACTIONS(2799),
    [anon_sym_while] = ACTIONS(2799),
    [anon_sym_do] = ACTIONS(2799),
    [anon_sym_for] = ACTIONS(2799),
    [anon_sym_return] = ACTIONS(2799),
    [anon_sym_break] = ACTIONS(2799),
    [anon_sym_continue] = ACTIONS(2799),
    [anon_sym_goto] = ACTIONS(2799),
    [anon_sym___try] = ACTIONS(2799),
    [anon_sym___leave] = ACTIONS(2799),
    [anon_sym_not] = ACTIONS(2799),
    [anon_sym_compl] = ACTIONS(2799),
    [anon_sym_DASH_DASH] = ACTIONS(2801),
    [anon_sym_PLUS_PLUS] = ACTIONS(2801),
    [anon_sym_sizeof] = ACTIONS(2799),
    [anon_sym___alignof__] = ACTIONS(2799),
    [anon_sym___alignof] = ACTIONS(2799),
    [anon_sym__alignof] = ACTIONS(2799),
    [anon_sym_alignof] = ACTIONS(2799),
    [anon_sym__Alignof] = ACTIONS(2799),
    [anon_sym_offsetof] = ACTIONS(2799),
    [anon_sym__Generic] = ACTIONS(2799),
    [anon_sym_asm] = ACTIONS(2799),
    [anon_sym___asm__] = ACTIONS(2799),
    [anon_sym___asm] = ACTIONS(2799),
    [sym_number_literal] = ACTIONS(2801),
    [anon_sym_L_SQUOTE] = ACTIONS(2801),
    [anon_sym_u_SQUOTE] = ACTIONS(2801),
    [anon_sym_U_SQUOTE] = ACTIONS(2801),
    [anon_sym_u8_SQUOTE] = ACTIONS(2801),
    [anon_sym_SQUOTE] = ACTIONS(2801),
    [anon_sym_L_DQUOTE] = ACTIONS(2801),
    [anon_sym_u_DQUOTE] = ACTIONS(2801),
    [anon_sym_U_DQUOTE] = ACTIONS(2801),
    [anon_sym_u8_DQUOTE] = ACTIONS(2801),
    [anon_sym_DQUOTE] = ACTIONS(2801),
    [sym_true] = ACTIONS(2799),
    [sym_false] = ACTIONS(2799),
    [anon_sym_NULL] = ACTIONS(2799),
    [anon_sym_nullptr] = ACTIONS(2799),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2799),
    [anon_sym_decltype] = ACTIONS(2799),
    [anon_sym_explicit] = ACTIONS(2799),
    [anon_sym_typename] = ACTIONS(2799),
    [anon_sym_template] = ACTIONS(2799),
    [anon_sym_operator] = ACTIONS(2799),
    [anon_sym_try] = ACTIONS(2799),
    [anon_sym_delete] = ACTIONS(2799),
    [anon_sym_throw] = ACTIONS(2799),
    [anon_sym_namespace] = ACTIONS(2799),
    [anon_sym_using] = ACTIONS(2799),
    [anon_sym_static_assert] = ACTIONS(2799),
    [anon_sym_concept] = ACTIONS(2799),
    [anon_sym_co_return] = ACTIONS(2799),
    [anon_sym_co_yield] = ACTIONS(2799),
    [anon_sym_R_DQUOTE] = ACTIONS(2801),
    [anon_sym_LR_DQUOTE] = ACTIONS(2801),
    [anon_sym_uR_DQUOTE] = ACTIONS(2801),
    [anon_sym_UR_DQUOTE] = ACTIONS(2801),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2801),
    [anon_sym_co_await] = ACTIONS(2799),
    [anon_sym_new] = ACTIONS(2799),
    [anon_sym_requires] = ACTIONS(2799),
    [sym_this] = ACTIONS(2799),
  },
  [673] = {
    [sym_identifier] = ACTIONS(3076),
    [aux_sym_preproc_include_token1] = ACTIONS(3076),
    [aux_sym_preproc_def_token1] = ACTIONS(3076),
    [aux_sym_preproc_if_token1] = ACTIONS(3076),
    [aux_sym_preproc_if_token2] = ACTIONS(3076),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3076),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3076),
    [sym_preproc_directive] = ACTIONS(3076),
    [anon_sym_LPAREN2] = ACTIONS(3078),
    [anon_sym_BANG] = ACTIONS(3078),
    [anon_sym_TILDE] = ACTIONS(3078),
    [anon_sym_DASH] = ACTIONS(3076),
    [anon_sym_PLUS] = ACTIONS(3076),
    [anon_sym_STAR] = ACTIONS(3078),
    [anon_sym_AMP_AMP] = ACTIONS(3078),
    [anon_sym_AMP] = ACTIONS(3076),
    [anon_sym_SEMI] = ACTIONS(3078),
    [anon_sym___extension__] = ACTIONS(3076),
    [anon_sym_typedef] = ACTIONS(3076),
    [anon_sym_virtual] = ACTIONS(3076),
    [anon_sym_extern] = ACTIONS(3076),
    [anon_sym___attribute__] = ACTIONS(3076),
    [anon_sym___attribute] = ACTIONS(3076),
    [anon_sym_COLON_COLON] = ACTIONS(3078),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3078),
    [anon_sym___declspec] = ACTIONS(3076),
    [anon_sym___based] = ACTIONS(3076),
    [anon_sym___cdecl] = ACTIONS(3076),
    [anon_sym___clrcall] = ACTIONS(3076),
    [anon_sym___stdcall] = ACTIONS(3076),
    [anon_sym___fastcall] = ACTIONS(3076),
    [anon_sym___thiscall] = ACTIONS(3076),
    [anon_sym___vectorcall] = ACTIONS(3076),
    [anon_sym_LBRACE] = ACTIONS(3078),
    [anon_sym_signed] = ACTIONS(3076),
    [anon_sym_unsigned] = ACTIONS(3076),
    [anon_sym_long] = ACTIONS(3076),
    [anon_sym_short] = ACTIONS(3076),
    [anon_sym_LBRACK] = ACTIONS(3076),
    [anon_sym_static] = ACTIONS(3076),
    [anon_sym_register] = ACTIONS(3076),
    [anon_sym_inline] = ACTIONS(3076),
    [anon_sym___inline] = ACTIONS(3076),
    [anon_sym___inline__] = ACTIONS(3076),
    [anon_sym___forceinline] = ACTIONS(3076),
    [anon_sym_thread_local] = ACTIONS(3076),
    [anon_sym___thread] = ACTIONS(3076),
    [anon_sym_const] = ACTIONS(3076),
    [anon_sym_constexpr] = ACTIONS(3076),
    [anon_sym_volatile] = ACTIONS(3076),
    [anon_sym_restrict] = ACTIONS(3076),
    [anon_sym___restrict__] = ACTIONS(3076),
    [anon_sym__Atomic] = ACTIONS(3076),
    [anon_sym__Noreturn] = ACTIONS(3076),
    [anon_sym_noreturn] = ACTIONS(3076),
    [anon_sym__Nonnull] = ACTIONS(3076),
    [anon_sym_mutable] = ACTIONS(3076),
    [anon_sym_constinit] = ACTIONS(3076),
    [anon_sym_consteval] = ACTIONS(3076),
    [anon_sym_alignas] = ACTIONS(3076),
    [anon_sym__Alignas] = ACTIONS(3076),
    [sym_primitive_type] = ACTIONS(3076),
    [anon_sym_enum] = ACTIONS(3076),
    [anon_sym_class] = ACTIONS(3076),
    [anon_sym_struct] = ACTIONS(3076),
    [anon_sym_union] = ACTIONS(3076),
    [anon_sym_if] = ACTIONS(3076),
    [anon_sym_switch] = ACTIONS(3076),
    [anon_sym_case] = ACTIONS(3076),
    [anon_sym_default] = ACTIONS(3076),
    [anon_sym_while] = ACTIONS(3076),
    [anon_sym_do] = ACTIONS(3076),
    [anon_sym_for] = ACTIONS(3076),
    [anon_sym_return] = ACTIONS(3076),
    [anon_sym_break] = ACTIONS(3076),
    [anon_sym_continue] = ACTIONS(3076),
    [anon_sym_goto] = ACTIONS(3076),
    [anon_sym___try] = ACTIONS(3076),
    [anon_sym___leave] = ACTIONS(3076),
    [anon_sym_not] = ACTIONS(3076),
    [anon_sym_compl] = ACTIONS(3076),
    [anon_sym_DASH_DASH] = ACTIONS(3078),
    [anon_sym_PLUS_PLUS] = ACTIONS(3078),
    [anon_sym_sizeof] = ACTIONS(3076),
    [anon_sym___alignof__] = ACTIONS(3076),
    [anon_sym___alignof] = ACTIONS(3076),
    [anon_sym__alignof] = ACTIONS(3076),
    [anon_sym_alignof] = ACTIONS(3076),
    [anon_sym__Alignof] = ACTIONS(3076),
    [anon_sym_offsetof] = ACTIONS(3076),
    [anon_sym__Generic] = ACTIONS(3076),
    [anon_sym_asm] = ACTIONS(3076),
    [anon_sym___asm__] = ACTIONS(3076),
    [anon_sym___asm] = ACTIONS(3076),
    [sym_number_literal] = ACTIONS(3078),
    [anon_sym_L_SQUOTE] = ACTIONS(3078),
    [anon_sym_u_SQUOTE] = ACTIONS(3078),
    [anon_sym_U_SQUOTE] = ACTIONS(3078),
    [anon_sym_u8_SQUOTE] = ACTIONS(3078),
    [anon_sym_SQUOTE] = ACTIONS(3078),
    [anon_sym_L_DQUOTE] = ACTIONS(3078),
    [anon_sym_u_DQUOTE] = ACTIONS(3078),
    [anon_sym_U_DQUOTE] = ACTIONS(3078),
    [anon_sym_u8_DQUOTE] = ACTIONS(3078),
    [anon_sym_DQUOTE] = ACTIONS(3078),
    [sym_true] = ACTIONS(3076),
    [sym_false] = ACTIONS(3076),
    [anon_sym_NULL] = ACTIONS(3076),
    [anon_sym_nullptr] = ACTIONS(3076),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3076),
    [anon_sym_decltype] = ACTIONS(3076),
    [anon_sym_explicit] = ACTIONS(3076),
    [anon_sym_typename] = ACTIONS(3076),
    [anon_sym_template] = ACTIONS(3076),
    [anon_sym_operator] = ACTIONS(3076),
    [anon_sym_try] = ACTIONS(3076),
    [anon_sym_delete] = ACTIONS(3076),
    [anon_sym_throw] = ACTIONS(3076),
    [anon_sym_namespace] = ACTIONS(3076),
    [anon_sym_using] = ACTIONS(3076),
    [anon_sym_static_assert] = ACTIONS(3076),
    [anon_sym_concept] = ACTIONS(3076),
    [anon_sym_co_return] = ACTIONS(3076),
    [anon_sym_co_yield] = ACTIONS(3076),
    [anon_sym_R_DQUOTE] = ACTIONS(3078),
    [anon_sym_LR_DQUOTE] = ACTIONS(3078),
    [anon_sym_uR_DQUOTE] = ACTIONS(3078),
    [anon_sym_UR_DQUOTE] = ACTIONS(3078),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3078),
    [anon_sym_co_await] = ACTIONS(3076),
    [anon_sym_new] = ACTIONS(3076),
    [anon_sym_requires] = ACTIONS(3076),
    [sym_this] = ACTIONS(3076),
  },
  [674] = {
    [sym_identifier] = ACTIONS(2799),
    [aux_sym_preproc_include_token1] = ACTIONS(2799),
    [aux_sym_preproc_def_token1] = ACTIONS(2799),
    [aux_sym_preproc_if_token1] = ACTIONS(2799),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2799),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2799),
    [sym_preproc_directive] = ACTIONS(2799),
    [anon_sym_LPAREN2] = ACTIONS(2801),
    [anon_sym_BANG] = ACTIONS(2801),
    [anon_sym_TILDE] = ACTIONS(2801),
    [anon_sym_DASH] = ACTIONS(2799),
    [anon_sym_PLUS] = ACTIONS(2799),
    [anon_sym_STAR] = ACTIONS(2801),
    [anon_sym_AMP_AMP] = ACTIONS(2801),
    [anon_sym_AMP] = ACTIONS(2799),
    [anon_sym_SEMI] = ACTIONS(2801),
    [anon_sym___extension__] = ACTIONS(2799),
    [anon_sym_typedef] = ACTIONS(2799),
    [anon_sym_virtual] = ACTIONS(2799),
    [anon_sym_extern] = ACTIONS(2799),
    [anon_sym___attribute__] = ACTIONS(2799),
    [anon_sym___attribute] = ACTIONS(2799),
    [anon_sym_COLON_COLON] = ACTIONS(2801),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2801),
    [anon_sym___declspec] = ACTIONS(2799),
    [anon_sym___based] = ACTIONS(2799),
    [anon_sym___cdecl] = ACTIONS(2799),
    [anon_sym___clrcall] = ACTIONS(2799),
    [anon_sym___stdcall] = ACTIONS(2799),
    [anon_sym___fastcall] = ACTIONS(2799),
    [anon_sym___thiscall] = ACTIONS(2799),
    [anon_sym___vectorcall] = ACTIONS(2799),
    [anon_sym_LBRACE] = ACTIONS(2801),
    [anon_sym_RBRACE] = ACTIONS(2801),
    [anon_sym_signed] = ACTIONS(2799),
    [anon_sym_unsigned] = ACTIONS(2799),
    [anon_sym_long] = ACTIONS(2799),
    [anon_sym_short] = ACTIONS(2799),
    [anon_sym_LBRACK] = ACTIONS(2799),
    [anon_sym_static] = ACTIONS(2799),
    [anon_sym_register] = ACTIONS(2799),
    [anon_sym_inline] = ACTIONS(2799),
    [anon_sym___inline] = ACTIONS(2799),
    [anon_sym___inline__] = ACTIONS(2799),
    [anon_sym___forceinline] = ACTIONS(2799),
    [anon_sym_thread_local] = ACTIONS(2799),
    [anon_sym___thread] = ACTIONS(2799),
    [anon_sym_const] = ACTIONS(2799),
    [anon_sym_constexpr] = ACTIONS(2799),
    [anon_sym_volatile] = ACTIONS(2799),
    [anon_sym_restrict] = ACTIONS(2799),
    [anon_sym___restrict__] = ACTIONS(2799),
    [anon_sym__Atomic] = ACTIONS(2799),
    [anon_sym__Noreturn] = ACTIONS(2799),
    [anon_sym_noreturn] = ACTIONS(2799),
    [anon_sym__Nonnull] = ACTIONS(2799),
    [anon_sym_mutable] = ACTIONS(2799),
    [anon_sym_constinit] = ACTIONS(2799),
    [anon_sym_consteval] = ACTIONS(2799),
    [anon_sym_alignas] = ACTIONS(2799),
    [anon_sym__Alignas] = ACTIONS(2799),
    [sym_primitive_type] = ACTIONS(2799),
    [anon_sym_enum] = ACTIONS(2799),
    [anon_sym_class] = ACTIONS(2799),
    [anon_sym_struct] = ACTIONS(2799),
    [anon_sym_union] = ACTIONS(2799),
    [anon_sym_if] = ACTIONS(2799),
    [anon_sym_switch] = ACTIONS(2799),
    [anon_sym_case] = ACTIONS(2799),
    [anon_sym_default] = ACTIONS(2799),
    [anon_sym_while] = ACTIONS(2799),
    [anon_sym_do] = ACTIONS(2799),
    [anon_sym_for] = ACTIONS(2799),
    [anon_sym_return] = ACTIONS(2799),
    [anon_sym_break] = ACTIONS(2799),
    [anon_sym_continue] = ACTIONS(2799),
    [anon_sym_goto] = ACTIONS(2799),
    [anon_sym___try] = ACTIONS(2799),
    [anon_sym___leave] = ACTIONS(2799),
    [anon_sym_not] = ACTIONS(2799),
    [anon_sym_compl] = ACTIONS(2799),
    [anon_sym_DASH_DASH] = ACTIONS(2801),
    [anon_sym_PLUS_PLUS] = ACTIONS(2801),
    [anon_sym_sizeof] = ACTIONS(2799),
    [anon_sym___alignof__] = ACTIONS(2799),
    [anon_sym___alignof] = ACTIONS(2799),
    [anon_sym__alignof] = ACTIONS(2799),
    [anon_sym_alignof] = ACTIONS(2799),
    [anon_sym__Alignof] = ACTIONS(2799),
    [anon_sym_offsetof] = ACTIONS(2799),
    [anon_sym__Generic] = ACTIONS(2799),
    [anon_sym_asm] = ACTIONS(2799),
    [anon_sym___asm__] = ACTIONS(2799),
    [anon_sym___asm] = ACTIONS(2799),
    [sym_number_literal] = ACTIONS(2801),
    [anon_sym_L_SQUOTE] = ACTIONS(2801),
    [anon_sym_u_SQUOTE] = ACTIONS(2801),
    [anon_sym_U_SQUOTE] = ACTIONS(2801),
    [anon_sym_u8_SQUOTE] = ACTIONS(2801),
    [anon_sym_SQUOTE] = ACTIONS(2801),
    [anon_sym_L_DQUOTE] = ACTIONS(2801),
    [anon_sym_u_DQUOTE] = ACTIONS(2801),
    [anon_sym_U_DQUOTE] = ACTIONS(2801),
    [anon_sym_u8_DQUOTE] = ACTIONS(2801),
    [anon_sym_DQUOTE] = ACTIONS(2801),
    [sym_true] = ACTIONS(2799),
    [sym_false] = ACTIONS(2799),
    [anon_sym_NULL] = ACTIONS(2799),
    [anon_sym_nullptr] = ACTIONS(2799),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2799),
    [anon_sym_decltype] = ACTIONS(2799),
    [anon_sym_explicit] = ACTIONS(2799),
    [anon_sym_typename] = ACTIONS(2799),
    [anon_sym_template] = ACTIONS(2799),
    [anon_sym_operator] = ACTIONS(2799),
    [anon_sym_try] = ACTIONS(2799),
    [anon_sym_delete] = ACTIONS(2799),
    [anon_sym_throw] = ACTIONS(2799),
    [anon_sym_namespace] = ACTIONS(2799),
    [anon_sym_using] = ACTIONS(2799),
    [anon_sym_static_assert] = ACTIONS(2799),
    [anon_sym_concept] = ACTIONS(2799),
    [anon_sym_co_return] = ACTIONS(2799),
    [anon_sym_co_yield] = ACTIONS(2799),
    [anon_sym_R_DQUOTE] = ACTIONS(2801),
    [anon_sym_LR_DQUOTE] = ACTIONS(2801),
    [anon_sym_uR_DQUOTE] = ACTIONS(2801),
    [anon_sym_UR_DQUOTE] = ACTIONS(2801),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2801),
    [anon_sym_co_await] = ACTIONS(2799),
    [anon_sym_new] = ACTIONS(2799),
    [anon_sym_requires] = ACTIONS(2799),
    [sym_this] = ACTIONS(2799),
  },
  [675] = {
    [sym_identifier] = ACTIONS(3050),
    [aux_sym_preproc_include_token1] = ACTIONS(3050),
    [aux_sym_preproc_def_token1] = ACTIONS(3050),
    [aux_sym_preproc_if_token1] = ACTIONS(3050),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3050),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3050),
    [sym_preproc_directive] = ACTIONS(3050),
    [anon_sym_LPAREN2] = ACTIONS(3052),
    [anon_sym_BANG] = ACTIONS(3052),
    [anon_sym_TILDE] = ACTIONS(3052),
    [anon_sym_DASH] = ACTIONS(3050),
    [anon_sym_PLUS] = ACTIONS(3050),
    [anon_sym_STAR] = ACTIONS(3052),
    [anon_sym_AMP_AMP] = ACTIONS(3052),
    [anon_sym_AMP] = ACTIONS(3050),
    [anon_sym_SEMI] = ACTIONS(3052),
    [anon_sym___extension__] = ACTIONS(3050),
    [anon_sym_typedef] = ACTIONS(3050),
    [anon_sym_virtual] = ACTIONS(3050),
    [anon_sym_extern] = ACTIONS(3050),
    [anon_sym___attribute__] = ACTIONS(3050),
    [anon_sym___attribute] = ACTIONS(3050),
    [anon_sym_COLON_COLON] = ACTIONS(3052),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3052),
    [anon_sym___declspec] = ACTIONS(3050),
    [anon_sym___based] = ACTIONS(3050),
    [anon_sym___cdecl] = ACTIONS(3050),
    [anon_sym___clrcall] = ACTIONS(3050),
    [anon_sym___stdcall] = ACTIONS(3050),
    [anon_sym___fastcall] = ACTIONS(3050),
    [anon_sym___thiscall] = ACTIONS(3050),
    [anon_sym___vectorcall] = ACTIONS(3050),
    [anon_sym_LBRACE] = ACTIONS(3052),
    [anon_sym_RBRACE] = ACTIONS(3052),
    [anon_sym_signed] = ACTIONS(3050),
    [anon_sym_unsigned] = ACTIONS(3050),
    [anon_sym_long] = ACTIONS(3050),
    [anon_sym_short] = ACTIONS(3050),
    [anon_sym_LBRACK] = ACTIONS(3050),
    [anon_sym_static] = ACTIONS(3050),
    [anon_sym_register] = ACTIONS(3050),
    [anon_sym_inline] = ACTIONS(3050),
    [anon_sym___inline] = ACTIONS(3050),
    [anon_sym___inline__] = ACTIONS(3050),
    [anon_sym___forceinline] = ACTIONS(3050),
    [anon_sym_thread_local] = ACTIONS(3050),
    [anon_sym___thread] = ACTIONS(3050),
    [anon_sym_const] = ACTIONS(3050),
    [anon_sym_constexpr] = ACTIONS(3050),
    [anon_sym_volatile] = ACTIONS(3050),
    [anon_sym_restrict] = ACTIONS(3050),
    [anon_sym___restrict__] = ACTIONS(3050),
    [anon_sym__Atomic] = ACTIONS(3050),
    [anon_sym__Noreturn] = ACTIONS(3050),
    [anon_sym_noreturn] = ACTIONS(3050),
    [anon_sym__Nonnull] = ACTIONS(3050),
    [anon_sym_mutable] = ACTIONS(3050),
    [anon_sym_constinit] = ACTIONS(3050),
    [anon_sym_consteval] = ACTIONS(3050),
    [anon_sym_alignas] = ACTIONS(3050),
    [anon_sym__Alignas] = ACTIONS(3050),
    [sym_primitive_type] = ACTIONS(3050),
    [anon_sym_enum] = ACTIONS(3050),
    [anon_sym_class] = ACTIONS(3050),
    [anon_sym_struct] = ACTIONS(3050),
    [anon_sym_union] = ACTIONS(3050),
    [anon_sym_if] = ACTIONS(3050),
    [anon_sym_switch] = ACTIONS(3050),
    [anon_sym_case] = ACTIONS(3050),
    [anon_sym_default] = ACTIONS(3050),
    [anon_sym_while] = ACTIONS(3050),
    [anon_sym_do] = ACTIONS(3050),
    [anon_sym_for] = ACTIONS(3050),
    [anon_sym_return] = ACTIONS(3050),
    [anon_sym_break] = ACTIONS(3050),
    [anon_sym_continue] = ACTIONS(3050),
    [anon_sym_goto] = ACTIONS(3050),
    [anon_sym___try] = ACTIONS(3050),
    [anon_sym___leave] = ACTIONS(3050),
    [anon_sym_not] = ACTIONS(3050),
    [anon_sym_compl] = ACTIONS(3050),
    [anon_sym_DASH_DASH] = ACTIONS(3052),
    [anon_sym_PLUS_PLUS] = ACTIONS(3052),
    [anon_sym_sizeof] = ACTIONS(3050),
    [anon_sym___alignof__] = ACTIONS(3050),
    [anon_sym___alignof] = ACTIONS(3050),
    [anon_sym__alignof] = ACTIONS(3050),
    [anon_sym_alignof] = ACTIONS(3050),
    [anon_sym__Alignof] = ACTIONS(3050),
    [anon_sym_offsetof] = ACTIONS(3050),
    [anon_sym__Generic] = ACTIONS(3050),
    [anon_sym_asm] = ACTIONS(3050),
    [anon_sym___asm__] = ACTIONS(3050),
    [anon_sym___asm] = ACTIONS(3050),
    [sym_number_literal] = ACTIONS(3052),
    [anon_sym_L_SQUOTE] = ACTIONS(3052),
    [anon_sym_u_SQUOTE] = ACTIONS(3052),
    [anon_sym_U_SQUOTE] = ACTIONS(3052),
    [anon_sym_u8_SQUOTE] = ACTIONS(3052),
    [anon_sym_SQUOTE] = ACTIONS(3052),
    [anon_sym_L_DQUOTE] = ACTIONS(3052),
    [anon_sym_u_DQUOTE] = ACTIONS(3052),
    [anon_sym_U_DQUOTE] = ACTIONS(3052),
    [anon_sym_u8_DQUOTE] = ACTIONS(3052),
    [anon_sym_DQUOTE] = ACTIONS(3052),
    [sym_true] = ACTIONS(3050),
    [sym_false] = ACTIONS(3050),
    [anon_sym_NULL] = ACTIONS(3050),
    [anon_sym_nullptr] = ACTIONS(3050),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3050),
    [anon_sym_decltype] = ACTIONS(3050),
    [anon_sym_explicit] = ACTIONS(3050),
    [anon_sym_typename] = ACTIONS(3050),
    [anon_sym_template] = ACTIONS(3050),
    [anon_sym_operator] = ACTIONS(3050),
    [anon_sym_try] = ACTIONS(3050),
    [anon_sym_delete] = ACTIONS(3050),
    [anon_sym_throw] = ACTIONS(3050),
    [anon_sym_namespace] = ACTIONS(3050),
    [anon_sym_using] = ACTIONS(3050),
    [anon_sym_static_assert] = ACTIONS(3050),
    [anon_sym_concept] = ACTIONS(3050),
    [anon_sym_co_return] = ACTIONS(3050),
    [anon_sym_co_yield] = ACTIONS(3050),
    [anon_sym_R_DQUOTE] = ACTIONS(3052),
    [anon_sym_LR_DQUOTE] = ACTIONS(3052),
    [anon_sym_uR_DQUOTE] = ACTIONS(3052),
    [anon_sym_UR_DQUOTE] = ACTIONS(3052),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3052),
    [anon_sym_co_await] = ACTIONS(3050),
    [anon_sym_new] = ACTIONS(3050),
    [anon_sym_requires] = ACTIONS(3050),
    [sym_this] = ACTIONS(3050),
  },
  [676] = {
    [sym_identifier] = ACTIONS(3082),
    [aux_sym_preproc_include_token1] = ACTIONS(3082),
    [aux_sym_preproc_def_token1] = ACTIONS(3082),
    [aux_sym_preproc_if_token1] = ACTIONS(3082),
    [aux_sym_preproc_if_token2] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3082),
    [sym_preproc_directive] = ACTIONS(3082),
    [anon_sym_LPAREN2] = ACTIONS(3084),
    [anon_sym_BANG] = ACTIONS(3084),
    [anon_sym_TILDE] = ACTIONS(3084),
    [anon_sym_DASH] = ACTIONS(3082),
    [anon_sym_PLUS] = ACTIONS(3082),
    [anon_sym_STAR] = ACTIONS(3084),
    [anon_sym_AMP_AMP] = ACTIONS(3084),
    [anon_sym_AMP] = ACTIONS(3082),
    [anon_sym_SEMI] = ACTIONS(3084),
    [anon_sym___extension__] = ACTIONS(3082),
    [anon_sym_typedef] = ACTIONS(3082),
    [anon_sym_virtual] = ACTIONS(3082),
    [anon_sym_extern] = ACTIONS(3082),
    [anon_sym___attribute__] = ACTIONS(3082),
    [anon_sym___attribute] = ACTIONS(3082),
    [anon_sym_COLON_COLON] = ACTIONS(3084),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3084),
    [anon_sym___declspec] = ACTIONS(3082),
    [anon_sym___based] = ACTIONS(3082),
    [anon_sym___cdecl] = ACTIONS(3082),
    [anon_sym___clrcall] = ACTIONS(3082),
    [anon_sym___stdcall] = ACTIONS(3082),
    [anon_sym___fastcall] = ACTIONS(3082),
    [anon_sym___thiscall] = ACTIONS(3082),
    [anon_sym___vectorcall] = ACTIONS(3082),
    [anon_sym_LBRACE] = ACTIONS(3084),
    [anon_sym_signed] = ACTIONS(3082),
    [anon_sym_unsigned] = ACTIONS(3082),
    [anon_sym_long] = ACTIONS(3082),
    [anon_sym_short] = ACTIONS(3082),
    [anon_sym_LBRACK] = ACTIONS(3082),
    [anon_sym_static] = ACTIONS(3082),
    [anon_sym_register] = ACTIONS(3082),
    [anon_sym_inline] = ACTIONS(3082),
    [anon_sym___inline] = ACTIONS(3082),
    [anon_sym___inline__] = ACTIONS(3082),
    [anon_sym___forceinline] = ACTIONS(3082),
    [anon_sym_thread_local] = ACTIONS(3082),
    [anon_sym___thread] = ACTIONS(3082),
    [anon_sym_const] = ACTIONS(3082),
    [anon_sym_constexpr] = ACTIONS(3082),
    [anon_sym_volatile] = ACTIONS(3082),
    [anon_sym_restrict] = ACTIONS(3082),
    [anon_sym___restrict__] = ACTIONS(3082),
    [anon_sym__Atomic] = ACTIONS(3082),
    [anon_sym__Noreturn] = ACTIONS(3082),
    [anon_sym_noreturn] = ACTIONS(3082),
    [anon_sym__Nonnull] = ACTIONS(3082),
    [anon_sym_mutable] = ACTIONS(3082),
    [anon_sym_constinit] = ACTIONS(3082),
    [anon_sym_consteval] = ACTIONS(3082),
    [anon_sym_alignas] = ACTIONS(3082),
    [anon_sym__Alignas] = ACTIONS(3082),
    [sym_primitive_type] = ACTIONS(3082),
    [anon_sym_enum] = ACTIONS(3082),
    [anon_sym_class] = ACTIONS(3082),
    [anon_sym_struct] = ACTIONS(3082),
    [anon_sym_union] = ACTIONS(3082),
    [anon_sym_if] = ACTIONS(3082),
    [anon_sym_switch] = ACTIONS(3082),
    [anon_sym_case] = ACTIONS(3082),
    [anon_sym_default] = ACTIONS(3082),
    [anon_sym_while] = ACTIONS(3082),
    [anon_sym_do] = ACTIONS(3082),
    [anon_sym_for] = ACTIONS(3082),
    [anon_sym_return] = ACTIONS(3082),
    [anon_sym_break] = ACTIONS(3082),
    [anon_sym_continue] = ACTIONS(3082),
    [anon_sym_goto] = ACTIONS(3082),
    [anon_sym___try] = ACTIONS(3082),
    [anon_sym___leave] = ACTIONS(3082),
    [anon_sym_not] = ACTIONS(3082),
    [anon_sym_compl] = ACTIONS(3082),
    [anon_sym_DASH_DASH] = ACTIONS(3084),
    [anon_sym_PLUS_PLUS] = ACTIONS(3084),
    [anon_sym_sizeof] = ACTIONS(3082),
    [anon_sym___alignof__] = ACTIONS(3082),
    [anon_sym___alignof] = ACTIONS(3082),
    [anon_sym__alignof] = ACTIONS(3082),
    [anon_sym_alignof] = ACTIONS(3082),
    [anon_sym__Alignof] = ACTIONS(3082),
    [anon_sym_offsetof] = ACTIONS(3082),
    [anon_sym__Generic] = ACTIONS(3082),
    [anon_sym_asm] = ACTIONS(3082),
    [anon_sym___asm__] = ACTIONS(3082),
    [anon_sym___asm] = ACTIONS(3082),
    [sym_number_literal] = ACTIONS(3084),
    [anon_sym_L_SQUOTE] = ACTIONS(3084),
    [anon_sym_u_SQUOTE] = ACTIONS(3084),
    [anon_sym_U_SQUOTE] = ACTIONS(3084),
    [anon_sym_u8_SQUOTE] = ACTIONS(3084),
    [anon_sym_SQUOTE] = ACTIONS(3084),
    [anon_sym_L_DQUOTE] = ACTIONS(3084),
    [anon_sym_u_DQUOTE] = ACTIONS(3084),
    [anon_sym_U_DQUOTE] = ACTIONS(3084),
    [anon_sym_u8_DQUOTE] = ACTIONS(3084),
    [anon_sym_DQUOTE] = ACTIONS(3084),
    [sym_true] = ACTIONS(3082),
    [sym_false] = ACTIONS(3082),
    [anon_sym_NULL] = ACTIONS(3082),
    [anon_sym_nullptr] = ACTIONS(3082),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3082),
    [anon_sym_decltype] = ACTIONS(3082),
    [anon_sym_explicit] = ACTIONS(3082),
    [anon_sym_typename] = ACTIONS(3082),
    [anon_sym_template] = ACTIONS(3082),
    [anon_sym_operator] = ACTIONS(3082),
    [anon_sym_try] = ACTIONS(3082),
    [anon_sym_delete] = ACTIONS(3082),
    [anon_sym_throw] = ACTIONS(3082),
    [anon_sym_namespace] = ACTIONS(3082),
    [anon_sym_using] = ACTIONS(3082),
    [anon_sym_static_assert] = ACTIONS(3082),
    [anon_sym_concept] = ACTIONS(3082),
    [anon_sym_co_return] = ACTIONS(3082),
    [anon_sym_co_yield] = ACTIONS(3082),
    [anon_sym_R_DQUOTE] = ACTIONS(3084),
    [anon_sym_LR_DQUOTE] = ACTIONS(3084),
    [anon_sym_uR_DQUOTE] = ACTIONS(3084),
    [anon_sym_UR_DQUOTE] = ACTIONS(3084),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3084),
    [anon_sym_co_await] = ACTIONS(3082),
    [anon_sym_new] = ACTIONS(3082),
    [anon_sym_requires] = ACTIONS(3082),
    [sym_this] = ACTIONS(3082),
  },
  [677] = {
    [sym_identifier] = ACTIONS(3056),
    [aux_sym_preproc_include_token1] = ACTIONS(3056),
    [aux_sym_preproc_def_token1] = ACTIONS(3056),
    [aux_sym_preproc_if_token1] = ACTIONS(3056),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3056),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3056),
    [sym_preproc_directive] = ACTIONS(3056),
    [anon_sym_LPAREN2] = ACTIONS(3058),
    [anon_sym_BANG] = ACTIONS(3058),
    [anon_sym_TILDE] = ACTIONS(3058),
    [anon_sym_DASH] = ACTIONS(3056),
    [anon_sym_PLUS] = ACTIONS(3056),
    [anon_sym_STAR] = ACTIONS(3058),
    [anon_sym_AMP_AMP] = ACTIONS(3058),
    [anon_sym_AMP] = ACTIONS(3056),
    [anon_sym_SEMI] = ACTIONS(3058),
    [anon_sym___extension__] = ACTIONS(3056),
    [anon_sym_typedef] = ACTIONS(3056),
    [anon_sym_virtual] = ACTIONS(3056),
    [anon_sym_extern] = ACTIONS(3056),
    [anon_sym___attribute__] = ACTIONS(3056),
    [anon_sym___attribute] = ACTIONS(3056),
    [anon_sym_COLON_COLON] = ACTIONS(3058),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3058),
    [anon_sym___declspec] = ACTIONS(3056),
    [anon_sym___based] = ACTIONS(3056),
    [anon_sym___cdecl] = ACTIONS(3056),
    [anon_sym___clrcall] = ACTIONS(3056),
    [anon_sym___stdcall] = ACTIONS(3056),
    [anon_sym___fastcall] = ACTIONS(3056),
    [anon_sym___thiscall] = ACTIONS(3056),
    [anon_sym___vectorcall] = ACTIONS(3056),
    [anon_sym_LBRACE] = ACTIONS(3058),
    [anon_sym_RBRACE] = ACTIONS(3058),
    [anon_sym_signed] = ACTIONS(3056),
    [anon_sym_unsigned] = ACTIONS(3056),
    [anon_sym_long] = ACTIONS(3056),
    [anon_sym_short] = ACTIONS(3056),
    [anon_sym_LBRACK] = ACTIONS(3056),
    [anon_sym_static] = ACTIONS(3056),
    [anon_sym_register] = ACTIONS(3056),
    [anon_sym_inline] = ACTIONS(3056),
    [anon_sym___inline] = ACTIONS(3056),
    [anon_sym___inline__] = ACTIONS(3056),
    [anon_sym___forceinline] = ACTIONS(3056),
    [anon_sym_thread_local] = ACTIONS(3056),
    [anon_sym___thread] = ACTIONS(3056),
    [anon_sym_const] = ACTIONS(3056),
    [anon_sym_constexpr] = ACTIONS(3056),
    [anon_sym_volatile] = ACTIONS(3056),
    [anon_sym_restrict] = ACTIONS(3056),
    [anon_sym___restrict__] = ACTIONS(3056),
    [anon_sym__Atomic] = ACTIONS(3056),
    [anon_sym__Noreturn] = ACTIONS(3056),
    [anon_sym_noreturn] = ACTIONS(3056),
    [anon_sym__Nonnull] = ACTIONS(3056),
    [anon_sym_mutable] = ACTIONS(3056),
    [anon_sym_constinit] = ACTIONS(3056),
    [anon_sym_consteval] = ACTIONS(3056),
    [anon_sym_alignas] = ACTIONS(3056),
    [anon_sym__Alignas] = ACTIONS(3056),
    [sym_primitive_type] = ACTIONS(3056),
    [anon_sym_enum] = ACTIONS(3056),
    [anon_sym_class] = ACTIONS(3056),
    [anon_sym_struct] = ACTIONS(3056),
    [anon_sym_union] = ACTIONS(3056),
    [anon_sym_if] = ACTIONS(3056),
    [anon_sym_switch] = ACTIONS(3056),
    [anon_sym_case] = ACTIONS(3056),
    [anon_sym_default] = ACTIONS(3056),
    [anon_sym_while] = ACTIONS(3056),
    [anon_sym_do] = ACTIONS(3056),
    [anon_sym_for] = ACTIONS(3056),
    [anon_sym_return] = ACTIONS(3056),
    [anon_sym_break] = ACTIONS(3056),
    [anon_sym_continue] = ACTIONS(3056),
    [anon_sym_goto] = ACTIONS(3056),
    [anon_sym___try] = ACTIONS(3056),
    [anon_sym___leave] = ACTIONS(3056),
    [anon_sym_not] = ACTIONS(3056),
    [anon_sym_compl] = ACTIONS(3056),
    [anon_sym_DASH_DASH] = ACTIONS(3058),
    [anon_sym_PLUS_PLUS] = ACTIONS(3058),
    [anon_sym_sizeof] = ACTIONS(3056),
    [anon_sym___alignof__] = ACTIONS(3056),
    [anon_sym___alignof] = ACTIONS(3056),
    [anon_sym__alignof] = ACTIONS(3056),
    [anon_sym_alignof] = ACTIONS(3056),
    [anon_sym__Alignof] = ACTIONS(3056),
    [anon_sym_offsetof] = ACTIONS(3056),
    [anon_sym__Generic] = ACTIONS(3056),
    [anon_sym_asm] = ACTIONS(3056),
    [anon_sym___asm__] = ACTIONS(3056),
    [anon_sym___asm] = ACTIONS(3056),
    [sym_number_literal] = ACTIONS(3058),
    [anon_sym_L_SQUOTE] = ACTIONS(3058),
    [anon_sym_u_SQUOTE] = ACTIONS(3058),
    [anon_sym_U_SQUOTE] = ACTIONS(3058),
    [anon_sym_u8_SQUOTE] = ACTIONS(3058),
    [anon_sym_SQUOTE] = ACTIONS(3058),
    [anon_sym_L_DQUOTE] = ACTIONS(3058),
    [anon_sym_u_DQUOTE] = ACTIONS(3058),
    [anon_sym_U_DQUOTE] = ACTIONS(3058),
    [anon_sym_u8_DQUOTE] = ACTIONS(3058),
    [anon_sym_DQUOTE] = ACTIONS(3058),
    [sym_true] = ACTIONS(3056),
    [sym_false] = ACTIONS(3056),
    [anon_sym_NULL] = ACTIONS(3056),
    [anon_sym_nullptr] = ACTIONS(3056),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3056),
    [anon_sym_decltype] = ACTIONS(3056),
    [anon_sym_explicit] = ACTIONS(3056),
    [anon_sym_typename] = ACTIONS(3056),
    [anon_sym_template] = ACTIONS(3056),
    [anon_sym_operator] = ACTIONS(3056),
    [anon_sym_try] = ACTIONS(3056),
    [anon_sym_delete] = ACTIONS(3056),
    [anon_sym_throw] = ACTIONS(3056),
    [anon_sym_namespace] = ACTIONS(3056),
    [anon_sym_using] = ACTIONS(3056),
    [anon_sym_static_assert] = ACTIONS(3056),
    [anon_sym_concept] = ACTIONS(3056),
    [anon_sym_co_return] = ACTIONS(3056),
    [anon_sym_co_yield] = ACTIONS(3056),
    [anon_sym_R_DQUOTE] = ACTIONS(3058),
    [anon_sym_LR_DQUOTE] = ACTIONS(3058),
    [anon_sym_uR_DQUOTE] = ACTIONS(3058),
    [anon_sym_UR_DQUOTE] = ACTIONS(3058),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3058),
    [anon_sym_co_await] = ACTIONS(3056),
    [anon_sym_new] = ACTIONS(3056),
    [anon_sym_requires] = ACTIONS(3056),
    [sym_this] = ACTIONS(3056),
  },
  [678] = {
    [sym_identifier] = ACTIONS(2834),
    [aux_sym_preproc_include_token1] = ACTIONS(2834),
    [aux_sym_preproc_def_token1] = ACTIONS(2834),
    [aux_sym_preproc_if_token1] = ACTIONS(2834),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2834),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2834),
    [sym_preproc_directive] = ACTIONS(2834),
    [anon_sym_LPAREN2] = ACTIONS(2836),
    [anon_sym_BANG] = ACTIONS(2836),
    [anon_sym_TILDE] = ACTIONS(2836),
    [anon_sym_DASH] = ACTIONS(2834),
    [anon_sym_PLUS] = ACTIONS(2834),
    [anon_sym_STAR] = ACTIONS(2836),
    [anon_sym_AMP_AMP] = ACTIONS(2836),
    [anon_sym_AMP] = ACTIONS(2834),
    [anon_sym_SEMI] = ACTIONS(2836),
    [anon_sym___extension__] = ACTIONS(2834),
    [anon_sym_typedef] = ACTIONS(2834),
    [anon_sym_virtual] = ACTIONS(2834),
    [anon_sym_extern] = ACTIONS(2834),
    [anon_sym___attribute__] = ACTIONS(2834),
    [anon_sym___attribute] = ACTIONS(2834),
    [anon_sym_COLON_COLON] = ACTIONS(2836),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2836),
    [anon_sym___declspec] = ACTIONS(2834),
    [anon_sym___based] = ACTIONS(2834),
    [anon_sym___cdecl] = ACTIONS(2834),
    [anon_sym___clrcall] = ACTIONS(2834),
    [anon_sym___stdcall] = ACTIONS(2834),
    [anon_sym___fastcall] = ACTIONS(2834),
    [anon_sym___thiscall] = ACTIONS(2834),
    [anon_sym___vectorcall] = ACTIONS(2834),
    [anon_sym_LBRACE] = ACTIONS(2836),
    [anon_sym_RBRACE] = ACTIONS(2836),
    [anon_sym_signed] = ACTIONS(2834),
    [anon_sym_unsigned] = ACTIONS(2834),
    [anon_sym_long] = ACTIONS(2834),
    [anon_sym_short] = ACTIONS(2834),
    [anon_sym_LBRACK] = ACTIONS(2834),
    [anon_sym_static] = ACTIONS(2834),
    [anon_sym_register] = ACTIONS(2834),
    [anon_sym_inline] = ACTIONS(2834),
    [anon_sym___inline] = ACTIONS(2834),
    [anon_sym___inline__] = ACTIONS(2834),
    [anon_sym___forceinline] = ACTIONS(2834),
    [anon_sym_thread_local] = ACTIONS(2834),
    [anon_sym___thread] = ACTIONS(2834),
    [anon_sym_const] = ACTIONS(2834),
    [anon_sym_constexpr] = ACTIONS(2834),
    [anon_sym_volatile] = ACTIONS(2834),
    [anon_sym_restrict] = ACTIONS(2834),
    [anon_sym___restrict__] = ACTIONS(2834),
    [anon_sym__Atomic] = ACTIONS(2834),
    [anon_sym__Noreturn] = ACTIONS(2834),
    [anon_sym_noreturn] = ACTIONS(2834),
    [anon_sym__Nonnull] = ACTIONS(2834),
    [anon_sym_mutable] = ACTIONS(2834),
    [anon_sym_constinit] = ACTIONS(2834),
    [anon_sym_consteval] = ACTIONS(2834),
    [anon_sym_alignas] = ACTIONS(2834),
    [anon_sym__Alignas] = ACTIONS(2834),
    [sym_primitive_type] = ACTIONS(2834),
    [anon_sym_enum] = ACTIONS(2834),
    [anon_sym_class] = ACTIONS(2834),
    [anon_sym_struct] = ACTIONS(2834),
    [anon_sym_union] = ACTIONS(2834),
    [anon_sym_if] = ACTIONS(2834),
    [anon_sym_switch] = ACTIONS(2834),
    [anon_sym_case] = ACTIONS(2834),
    [anon_sym_default] = ACTIONS(2834),
    [anon_sym_while] = ACTIONS(2834),
    [anon_sym_do] = ACTIONS(2834),
    [anon_sym_for] = ACTIONS(2834),
    [anon_sym_return] = ACTIONS(2834),
    [anon_sym_break] = ACTIONS(2834),
    [anon_sym_continue] = ACTIONS(2834),
    [anon_sym_goto] = ACTIONS(2834),
    [anon_sym___try] = ACTIONS(2834),
    [anon_sym___leave] = ACTIONS(2834),
    [anon_sym_not] = ACTIONS(2834),
    [anon_sym_compl] = ACTIONS(2834),
    [anon_sym_DASH_DASH] = ACTIONS(2836),
    [anon_sym_PLUS_PLUS] = ACTIONS(2836),
    [anon_sym_sizeof] = ACTIONS(2834),
    [anon_sym___alignof__] = ACTIONS(2834),
    [anon_sym___alignof] = ACTIONS(2834),
    [anon_sym__alignof] = ACTIONS(2834),
    [anon_sym_alignof] = ACTIONS(2834),
    [anon_sym__Alignof] = ACTIONS(2834),
    [anon_sym_offsetof] = ACTIONS(2834),
    [anon_sym__Generic] = ACTIONS(2834),
    [anon_sym_asm] = ACTIONS(2834),
    [anon_sym___asm__] = ACTIONS(2834),
    [anon_sym___asm] = ACTIONS(2834),
    [sym_number_literal] = ACTIONS(2836),
    [anon_sym_L_SQUOTE] = ACTIONS(2836),
    [anon_sym_u_SQUOTE] = ACTIONS(2836),
    [anon_sym_U_SQUOTE] = ACTIONS(2836),
    [anon_sym_u8_SQUOTE] = ACTIONS(2836),
    [anon_sym_SQUOTE] = ACTIONS(2836),
    [anon_sym_L_DQUOTE] = ACTIONS(2836),
    [anon_sym_u_DQUOTE] = ACTIONS(2836),
    [anon_sym_U_DQUOTE] = ACTIONS(2836),
    [anon_sym_u8_DQUOTE] = ACTIONS(2836),
    [anon_sym_DQUOTE] = ACTIONS(2836),
    [sym_true] = ACTIONS(2834),
    [sym_false] = ACTIONS(2834),
    [anon_sym_NULL] = ACTIONS(2834),
    [anon_sym_nullptr] = ACTIONS(2834),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2834),
    [anon_sym_decltype] = ACTIONS(2834),
    [anon_sym_explicit] = ACTIONS(2834),
    [anon_sym_typename] = ACTIONS(2834),
    [anon_sym_template] = ACTIONS(2834),
    [anon_sym_operator] = ACTIONS(2834),
    [anon_sym_try] = ACTIONS(2834),
    [anon_sym_delete] = ACTIONS(2834),
    [anon_sym_throw] = ACTIONS(2834),
    [anon_sym_namespace] = ACTIONS(2834),
    [anon_sym_using] = ACTIONS(2834),
    [anon_sym_static_assert] = ACTIONS(2834),
    [anon_sym_concept] = ACTIONS(2834),
    [anon_sym_co_return] = ACTIONS(2834),
    [anon_sym_co_yield] = ACTIONS(2834),
    [anon_sym_R_DQUOTE] = ACTIONS(2836),
    [anon_sym_LR_DQUOTE] = ACTIONS(2836),
    [anon_sym_uR_DQUOTE] = ACTIONS(2836),
    [anon_sym_UR_DQUOTE] = ACTIONS(2836),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2836),
    [anon_sym_co_await] = ACTIONS(2834),
    [anon_sym_new] = ACTIONS(2834),
    [anon_sym_requires] = ACTIONS(2834),
    [sym_this] = ACTIONS(2834),
  },
  [679] = {
    [sym_identifier] = ACTIONS(3114),
    [aux_sym_preproc_include_token1] = ACTIONS(3114),
    [aux_sym_preproc_def_token1] = ACTIONS(3114),
    [aux_sym_preproc_if_token1] = ACTIONS(3114),
    [aux_sym_preproc_if_token2] = ACTIONS(3114),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3114),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3114),
    [sym_preproc_directive] = ACTIONS(3114),
    [anon_sym_LPAREN2] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3116),
    [anon_sym_TILDE] = ACTIONS(3116),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_PLUS] = ACTIONS(3114),
    [anon_sym_STAR] = ACTIONS(3116),
    [anon_sym_AMP_AMP] = ACTIONS(3116),
    [anon_sym_AMP] = ACTIONS(3114),
    [anon_sym_SEMI] = ACTIONS(3116),
    [anon_sym___extension__] = ACTIONS(3114),
    [anon_sym_typedef] = ACTIONS(3114),
    [anon_sym_virtual] = ACTIONS(3114),
    [anon_sym_extern] = ACTIONS(3114),
    [anon_sym___attribute__] = ACTIONS(3114),
    [anon_sym___attribute] = ACTIONS(3114),
    [anon_sym_COLON_COLON] = ACTIONS(3116),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3116),
    [anon_sym___declspec] = ACTIONS(3114),
    [anon_sym___based] = ACTIONS(3114),
    [anon_sym___cdecl] = ACTIONS(3114),
    [anon_sym___clrcall] = ACTIONS(3114),
    [anon_sym___stdcall] = ACTIONS(3114),
    [anon_sym___fastcall] = ACTIONS(3114),
    [anon_sym___thiscall] = ACTIONS(3114),
    [anon_sym___vectorcall] = ACTIONS(3114),
    [anon_sym_LBRACE] = ACTIONS(3116),
    [anon_sym_signed] = ACTIONS(3114),
    [anon_sym_unsigned] = ACTIONS(3114),
    [anon_sym_long] = ACTIONS(3114),
    [anon_sym_short] = ACTIONS(3114),
    [anon_sym_LBRACK] = ACTIONS(3114),
    [anon_sym_static] = ACTIONS(3114),
    [anon_sym_register] = ACTIONS(3114),
    [anon_sym_inline] = ACTIONS(3114),
    [anon_sym___inline] = ACTIONS(3114),
    [anon_sym___inline__] = ACTIONS(3114),
    [anon_sym___forceinline] = ACTIONS(3114),
    [anon_sym_thread_local] = ACTIONS(3114),
    [anon_sym___thread] = ACTIONS(3114),
    [anon_sym_const] = ACTIONS(3114),
    [anon_sym_constexpr] = ACTIONS(3114),
    [anon_sym_volatile] = ACTIONS(3114),
    [anon_sym_restrict] = ACTIONS(3114),
    [anon_sym___restrict__] = ACTIONS(3114),
    [anon_sym__Atomic] = ACTIONS(3114),
    [anon_sym__Noreturn] = ACTIONS(3114),
    [anon_sym_noreturn] = ACTIONS(3114),
    [anon_sym__Nonnull] = ACTIONS(3114),
    [anon_sym_mutable] = ACTIONS(3114),
    [anon_sym_constinit] = ACTIONS(3114),
    [anon_sym_consteval] = ACTIONS(3114),
    [anon_sym_alignas] = ACTIONS(3114),
    [anon_sym__Alignas] = ACTIONS(3114),
    [sym_primitive_type] = ACTIONS(3114),
    [anon_sym_enum] = ACTIONS(3114),
    [anon_sym_class] = ACTIONS(3114),
    [anon_sym_struct] = ACTIONS(3114),
    [anon_sym_union] = ACTIONS(3114),
    [anon_sym_if] = ACTIONS(3114),
    [anon_sym_switch] = ACTIONS(3114),
    [anon_sym_case] = ACTIONS(3114),
    [anon_sym_default] = ACTIONS(3114),
    [anon_sym_while] = ACTIONS(3114),
    [anon_sym_do] = ACTIONS(3114),
    [anon_sym_for] = ACTIONS(3114),
    [anon_sym_return] = ACTIONS(3114),
    [anon_sym_break] = ACTIONS(3114),
    [anon_sym_continue] = ACTIONS(3114),
    [anon_sym_goto] = ACTIONS(3114),
    [anon_sym___try] = ACTIONS(3114),
    [anon_sym___leave] = ACTIONS(3114),
    [anon_sym_not] = ACTIONS(3114),
    [anon_sym_compl] = ACTIONS(3114),
    [anon_sym_DASH_DASH] = ACTIONS(3116),
    [anon_sym_PLUS_PLUS] = ACTIONS(3116),
    [anon_sym_sizeof] = ACTIONS(3114),
    [anon_sym___alignof__] = ACTIONS(3114),
    [anon_sym___alignof] = ACTIONS(3114),
    [anon_sym__alignof] = ACTIONS(3114),
    [anon_sym_alignof] = ACTIONS(3114),
    [anon_sym__Alignof] = ACTIONS(3114),
    [anon_sym_offsetof] = ACTIONS(3114),
    [anon_sym__Generic] = ACTIONS(3114),
    [anon_sym_asm] = ACTIONS(3114),
    [anon_sym___asm__] = ACTIONS(3114),
    [anon_sym___asm] = ACTIONS(3114),
    [sym_number_literal] = ACTIONS(3116),
    [anon_sym_L_SQUOTE] = ACTIONS(3116),
    [anon_sym_u_SQUOTE] = ACTIONS(3116),
    [anon_sym_U_SQUOTE] = ACTIONS(3116),
    [anon_sym_u8_SQUOTE] = ACTIONS(3116),
    [anon_sym_SQUOTE] = ACTIONS(3116),
    [anon_sym_L_DQUOTE] = ACTIONS(3116),
    [anon_sym_u_DQUOTE] = ACTIONS(3116),
    [anon_sym_U_DQUOTE] = ACTIONS(3116),
    [anon_sym_u8_DQUOTE] = ACTIONS(3116),
    [anon_sym_DQUOTE] = ACTIONS(3116),
    [sym_true] = ACTIONS(3114),
    [sym_false] = ACTIONS(3114),
    [anon_sym_NULL] = ACTIONS(3114),
    [anon_sym_nullptr] = ACTIONS(3114),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3114),
    [anon_sym_decltype] = ACTIONS(3114),
    [anon_sym_explicit] = ACTIONS(3114),
    [anon_sym_typename] = ACTIONS(3114),
    [anon_sym_template] = ACTIONS(3114),
    [anon_sym_operator] = ACTIONS(3114),
    [anon_sym_try] = ACTIONS(3114),
    [anon_sym_delete] = ACTIONS(3114),
    [anon_sym_throw] = ACTIONS(3114),
    [anon_sym_namespace] = ACTIONS(3114),
    [anon_sym_using] = ACTIONS(3114),
    [anon_sym_static_assert] = ACTIONS(3114),
    [anon_sym_concept] = ACTIONS(3114),
    [anon_sym_co_return] = ACTIONS(3114),
    [anon_sym_co_yield] = ACTIONS(3114),
    [anon_sym_R_DQUOTE] = ACTIONS(3116),
    [anon_sym_LR_DQUOTE] = ACTIONS(3116),
    [anon_sym_uR_DQUOTE] = ACTIONS(3116),
    [anon_sym_UR_DQUOTE] = ACTIONS(3116),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3116),
    [anon_sym_co_await] = ACTIONS(3114),
    [anon_sym_new] = ACTIONS(3114),
    [anon_sym_requires] = ACTIONS(3114),
    [sym_this] = ACTIONS(3114),
  },
  [680] = {
    [sym_identifier] = ACTIONS(3128),
    [aux_sym_preproc_include_token1] = ACTIONS(3128),
    [aux_sym_preproc_def_token1] = ACTIONS(3128),
    [aux_sym_preproc_if_token1] = ACTIONS(3128),
    [aux_sym_preproc_if_token2] = ACTIONS(3128),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3128),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3128),
    [sym_preproc_directive] = ACTIONS(3128),
    [anon_sym_LPAREN2] = ACTIONS(3130),
    [anon_sym_BANG] = ACTIONS(3130),
    [anon_sym_TILDE] = ACTIONS(3130),
    [anon_sym_DASH] = ACTIONS(3128),
    [anon_sym_PLUS] = ACTIONS(3128),
    [anon_sym_STAR] = ACTIONS(3130),
    [anon_sym_AMP_AMP] = ACTIONS(3130),
    [anon_sym_AMP] = ACTIONS(3128),
    [anon_sym_SEMI] = ACTIONS(3130),
    [anon_sym___extension__] = ACTIONS(3128),
    [anon_sym_typedef] = ACTIONS(3128),
    [anon_sym_virtual] = ACTIONS(3128),
    [anon_sym_extern] = ACTIONS(3128),
    [anon_sym___attribute__] = ACTIONS(3128),
    [anon_sym___attribute] = ACTIONS(3128),
    [anon_sym_COLON_COLON] = ACTIONS(3130),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3130),
    [anon_sym___declspec] = ACTIONS(3128),
    [anon_sym___based] = ACTIONS(3128),
    [anon_sym___cdecl] = ACTIONS(3128),
    [anon_sym___clrcall] = ACTIONS(3128),
    [anon_sym___stdcall] = ACTIONS(3128),
    [anon_sym___fastcall] = ACTIONS(3128),
    [anon_sym___thiscall] = ACTIONS(3128),
    [anon_sym___vectorcall] = ACTIONS(3128),
    [anon_sym_LBRACE] = ACTIONS(3130),
    [anon_sym_signed] = ACTIONS(3128),
    [anon_sym_unsigned] = ACTIONS(3128),
    [anon_sym_long] = ACTIONS(3128),
    [anon_sym_short] = ACTIONS(3128),
    [anon_sym_LBRACK] = ACTIONS(3128),
    [anon_sym_static] = ACTIONS(3128),
    [anon_sym_register] = ACTIONS(3128),
    [anon_sym_inline] = ACTIONS(3128),
    [anon_sym___inline] = ACTIONS(3128),
    [anon_sym___inline__] = ACTIONS(3128),
    [anon_sym___forceinline] = ACTIONS(3128),
    [anon_sym_thread_local] = ACTIONS(3128),
    [anon_sym___thread] = ACTIONS(3128),
    [anon_sym_const] = ACTIONS(3128),
    [anon_sym_constexpr] = ACTIONS(3128),
    [anon_sym_volatile] = ACTIONS(3128),
    [anon_sym_restrict] = ACTIONS(3128),
    [anon_sym___restrict__] = ACTIONS(3128),
    [anon_sym__Atomic] = ACTIONS(3128),
    [anon_sym__Noreturn] = ACTIONS(3128),
    [anon_sym_noreturn] = ACTIONS(3128),
    [anon_sym__Nonnull] = ACTIONS(3128),
    [anon_sym_mutable] = ACTIONS(3128),
    [anon_sym_constinit] = ACTIONS(3128),
    [anon_sym_consteval] = ACTIONS(3128),
    [anon_sym_alignas] = ACTIONS(3128),
    [anon_sym__Alignas] = ACTIONS(3128),
    [sym_primitive_type] = ACTIONS(3128),
    [anon_sym_enum] = ACTIONS(3128),
    [anon_sym_class] = ACTIONS(3128),
    [anon_sym_struct] = ACTIONS(3128),
    [anon_sym_union] = ACTIONS(3128),
    [anon_sym_if] = ACTIONS(3128),
    [anon_sym_switch] = ACTIONS(3128),
    [anon_sym_case] = ACTIONS(3128),
    [anon_sym_default] = ACTIONS(3128),
    [anon_sym_while] = ACTIONS(3128),
    [anon_sym_do] = ACTIONS(3128),
    [anon_sym_for] = ACTIONS(3128),
    [anon_sym_return] = ACTIONS(3128),
    [anon_sym_break] = ACTIONS(3128),
    [anon_sym_continue] = ACTIONS(3128),
    [anon_sym_goto] = ACTIONS(3128),
    [anon_sym___try] = ACTIONS(3128),
    [anon_sym___leave] = ACTIONS(3128),
    [anon_sym_not] = ACTIONS(3128),
    [anon_sym_compl] = ACTIONS(3128),
    [anon_sym_DASH_DASH] = ACTIONS(3130),
    [anon_sym_PLUS_PLUS] = ACTIONS(3130),
    [anon_sym_sizeof] = ACTIONS(3128),
    [anon_sym___alignof__] = ACTIONS(3128),
    [anon_sym___alignof] = ACTIONS(3128),
    [anon_sym__alignof] = ACTIONS(3128),
    [anon_sym_alignof] = ACTIONS(3128),
    [anon_sym__Alignof] = ACTIONS(3128),
    [anon_sym_offsetof] = ACTIONS(3128),
    [anon_sym__Generic] = ACTIONS(3128),
    [anon_sym_asm] = ACTIONS(3128),
    [anon_sym___asm__] = ACTIONS(3128),
    [anon_sym___asm] = ACTIONS(3128),
    [sym_number_literal] = ACTIONS(3130),
    [anon_sym_L_SQUOTE] = ACTIONS(3130),
    [anon_sym_u_SQUOTE] = ACTIONS(3130),
    [anon_sym_U_SQUOTE] = ACTIONS(3130),
    [anon_sym_u8_SQUOTE] = ACTIONS(3130),
    [anon_sym_SQUOTE] = ACTIONS(3130),
    [anon_sym_L_DQUOTE] = ACTIONS(3130),
    [anon_sym_u_DQUOTE] = ACTIONS(3130),
    [anon_sym_U_DQUOTE] = ACTIONS(3130),
    [anon_sym_u8_DQUOTE] = ACTIONS(3130),
    [anon_sym_DQUOTE] = ACTIONS(3130),
    [sym_true] = ACTIONS(3128),
    [sym_false] = ACTIONS(3128),
    [anon_sym_NULL] = ACTIONS(3128),
    [anon_sym_nullptr] = ACTIONS(3128),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3128),
    [anon_sym_decltype] = ACTIONS(3128),
    [anon_sym_explicit] = ACTIONS(3128),
    [anon_sym_typename] = ACTIONS(3128),
    [anon_sym_template] = ACTIONS(3128),
    [anon_sym_operator] = ACTIONS(3128),
    [anon_sym_try] = ACTIONS(3128),
    [anon_sym_delete] = ACTIONS(3128),
    [anon_sym_throw] = ACTIONS(3128),
    [anon_sym_namespace] = ACTIONS(3128),
    [anon_sym_using] = ACTIONS(3128),
    [anon_sym_static_assert] = ACTIONS(3128),
    [anon_sym_concept] = ACTIONS(3128),
    [anon_sym_co_return] = ACTIONS(3128),
    [anon_sym_co_yield] = ACTIONS(3128),
    [anon_sym_R_DQUOTE] = ACTIONS(3130),
    [anon_sym_LR_DQUOTE] = ACTIONS(3130),
    [anon_sym_uR_DQUOTE] = ACTIONS(3130),
    [anon_sym_UR_DQUOTE] = ACTIONS(3130),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3130),
    [anon_sym_co_await] = ACTIONS(3128),
    [anon_sym_new] = ACTIONS(3128),
    [anon_sym_requires] = ACTIONS(3128),
    [sym_this] = ACTIONS(3128),
  },
  [681] = {
    [sym_identifier] = ACTIONS(2755),
    [aux_sym_preproc_include_token1] = ACTIONS(2755),
    [aux_sym_preproc_def_token1] = ACTIONS(2755),
    [aux_sym_preproc_if_token1] = ACTIONS(2755),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2755),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2755),
    [sym_preproc_directive] = ACTIONS(2755),
    [anon_sym_LPAREN2] = ACTIONS(2757),
    [anon_sym_BANG] = ACTIONS(2757),
    [anon_sym_TILDE] = ACTIONS(2757),
    [anon_sym_DASH] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_STAR] = ACTIONS(2757),
    [anon_sym_AMP_AMP] = ACTIONS(2757),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2757),
    [anon_sym___extension__] = ACTIONS(2755),
    [anon_sym_typedef] = ACTIONS(2755),
    [anon_sym_virtual] = ACTIONS(2755),
    [anon_sym_extern] = ACTIONS(2755),
    [anon_sym___attribute__] = ACTIONS(2755),
    [anon_sym___attribute] = ACTIONS(2755),
    [anon_sym_COLON_COLON] = ACTIONS(2757),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2757),
    [anon_sym___declspec] = ACTIONS(2755),
    [anon_sym___based] = ACTIONS(2755),
    [anon_sym___cdecl] = ACTIONS(2755),
    [anon_sym___clrcall] = ACTIONS(2755),
    [anon_sym___stdcall] = ACTIONS(2755),
    [anon_sym___fastcall] = ACTIONS(2755),
    [anon_sym___thiscall] = ACTIONS(2755),
    [anon_sym___vectorcall] = ACTIONS(2755),
    [anon_sym_LBRACE] = ACTIONS(2757),
    [anon_sym_RBRACE] = ACTIONS(2757),
    [anon_sym_signed] = ACTIONS(2755),
    [anon_sym_unsigned] = ACTIONS(2755),
    [anon_sym_long] = ACTIONS(2755),
    [anon_sym_short] = ACTIONS(2755),
    [anon_sym_LBRACK] = ACTIONS(2755),
    [anon_sym_static] = ACTIONS(2755),
    [anon_sym_register] = ACTIONS(2755),
    [anon_sym_inline] = ACTIONS(2755),
    [anon_sym___inline] = ACTIONS(2755),
    [anon_sym___inline__] = ACTIONS(2755),
    [anon_sym___forceinline] = ACTIONS(2755),
    [anon_sym_thread_local] = ACTIONS(2755),
    [anon_sym___thread] = ACTIONS(2755),
    [anon_sym_const] = ACTIONS(2755),
    [anon_sym_constexpr] = ACTIONS(2755),
    [anon_sym_volatile] = ACTIONS(2755),
    [anon_sym_restrict] = ACTIONS(2755),
    [anon_sym___restrict__] = ACTIONS(2755),
    [anon_sym__Atomic] = ACTIONS(2755),
    [anon_sym__Noreturn] = ACTIONS(2755),
    [anon_sym_noreturn] = ACTIONS(2755),
    [anon_sym__Nonnull] = ACTIONS(2755),
    [anon_sym_mutable] = ACTIONS(2755),
    [anon_sym_constinit] = ACTIONS(2755),
    [anon_sym_consteval] = ACTIONS(2755),
    [anon_sym_alignas] = ACTIONS(2755),
    [anon_sym__Alignas] = ACTIONS(2755),
    [sym_primitive_type] = ACTIONS(2755),
    [anon_sym_enum] = ACTIONS(2755),
    [anon_sym_class] = ACTIONS(2755),
    [anon_sym_struct] = ACTIONS(2755),
    [anon_sym_union] = ACTIONS(2755),
    [anon_sym_if] = ACTIONS(2755),
    [anon_sym_switch] = ACTIONS(2755),
    [anon_sym_case] = ACTIONS(2755),
    [anon_sym_default] = ACTIONS(2755),
    [anon_sym_while] = ACTIONS(2755),
    [anon_sym_do] = ACTIONS(2755),
    [anon_sym_for] = ACTIONS(2755),
    [anon_sym_return] = ACTIONS(2755),
    [anon_sym_break] = ACTIONS(2755),
    [anon_sym_continue] = ACTIONS(2755),
    [anon_sym_goto] = ACTIONS(2755),
    [anon_sym___try] = ACTIONS(2755),
    [anon_sym___leave] = ACTIONS(2755),
    [anon_sym_not] = ACTIONS(2755),
    [anon_sym_compl] = ACTIONS(2755),
    [anon_sym_DASH_DASH] = ACTIONS(2757),
    [anon_sym_PLUS_PLUS] = ACTIONS(2757),
    [anon_sym_sizeof] = ACTIONS(2755),
    [anon_sym___alignof__] = ACTIONS(2755),
    [anon_sym___alignof] = ACTIONS(2755),
    [anon_sym__alignof] = ACTIONS(2755),
    [anon_sym_alignof] = ACTIONS(2755),
    [anon_sym__Alignof] = ACTIONS(2755),
    [anon_sym_offsetof] = ACTIONS(2755),
    [anon_sym__Generic] = ACTIONS(2755),
    [anon_sym_asm] = ACTIONS(2755),
    [anon_sym___asm__] = ACTIONS(2755),
    [anon_sym___asm] = ACTIONS(2755),
    [sym_number_literal] = ACTIONS(2757),
    [anon_sym_L_SQUOTE] = ACTIONS(2757),
    [anon_sym_u_SQUOTE] = ACTIONS(2757),
    [anon_sym_U_SQUOTE] = ACTIONS(2757),
    [anon_sym_u8_SQUOTE] = ACTIONS(2757),
    [anon_sym_SQUOTE] = ACTIONS(2757),
    [anon_sym_L_DQUOTE] = ACTIONS(2757),
    [anon_sym_u_DQUOTE] = ACTIONS(2757),
    [anon_sym_U_DQUOTE] = ACTIONS(2757),
    [anon_sym_u8_DQUOTE] = ACTIONS(2757),
    [anon_sym_DQUOTE] = ACTIONS(2757),
    [sym_true] = ACTIONS(2755),
    [sym_false] = ACTIONS(2755),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2755),
    [anon_sym_decltype] = ACTIONS(2755),
    [anon_sym_explicit] = ACTIONS(2755),
    [anon_sym_typename] = ACTIONS(2755),
    [anon_sym_template] = ACTIONS(2755),
    [anon_sym_operator] = ACTIONS(2755),
    [anon_sym_try] = ACTIONS(2755),
    [anon_sym_delete] = ACTIONS(2755),
    [anon_sym_throw] = ACTIONS(2755),
    [anon_sym_namespace] = ACTIONS(2755),
    [anon_sym_using] = ACTIONS(2755),
    [anon_sym_static_assert] = ACTIONS(2755),
    [anon_sym_concept] = ACTIONS(2755),
    [anon_sym_co_return] = ACTIONS(2755),
    [anon_sym_co_yield] = ACTIONS(2755),
    [anon_sym_R_DQUOTE] = ACTIONS(2757),
    [anon_sym_LR_DQUOTE] = ACTIONS(2757),
    [anon_sym_uR_DQUOTE] = ACTIONS(2757),
    [anon_sym_UR_DQUOTE] = ACTIONS(2757),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2757),
    [anon_sym_co_await] = ACTIONS(2755),
    [anon_sym_new] = ACTIONS(2755),
    [anon_sym_requires] = ACTIONS(2755),
    [sym_this] = ACTIONS(2755),
  },
  [682] = {
    [sym_identifier] = ACTIONS(2932),
    [aux_sym_preproc_include_token1] = ACTIONS(2932),
    [aux_sym_preproc_def_token1] = ACTIONS(2932),
    [aux_sym_preproc_if_token1] = ACTIONS(2932),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2932),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2932),
    [sym_preproc_directive] = ACTIONS(2932),
    [anon_sym_LPAREN2] = ACTIONS(2934),
    [anon_sym_BANG] = ACTIONS(2934),
    [anon_sym_TILDE] = ACTIONS(2934),
    [anon_sym_DASH] = ACTIONS(2932),
    [anon_sym_PLUS] = ACTIONS(2932),
    [anon_sym_STAR] = ACTIONS(2934),
    [anon_sym_AMP_AMP] = ACTIONS(2934),
    [anon_sym_AMP] = ACTIONS(2932),
    [anon_sym_SEMI] = ACTIONS(2934),
    [anon_sym___extension__] = ACTIONS(2932),
    [anon_sym_typedef] = ACTIONS(2932),
    [anon_sym_virtual] = ACTIONS(2932),
    [anon_sym_extern] = ACTIONS(2932),
    [anon_sym___attribute__] = ACTIONS(2932),
    [anon_sym___attribute] = ACTIONS(2932),
    [anon_sym_COLON_COLON] = ACTIONS(2934),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2934),
    [anon_sym___declspec] = ACTIONS(2932),
    [anon_sym___based] = ACTIONS(2932),
    [anon_sym___cdecl] = ACTIONS(2932),
    [anon_sym___clrcall] = ACTIONS(2932),
    [anon_sym___stdcall] = ACTIONS(2932),
    [anon_sym___fastcall] = ACTIONS(2932),
    [anon_sym___thiscall] = ACTIONS(2932),
    [anon_sym___vectorcall] = ACTIONS(2932),
    [anon_sym_LBRACE] = ACTIONS(2934),
    [anon_sym_RBRACE] = ACTIONS(2934),
    [anon_sym_signed] = ACTIONS(2932),
    [anon_sym_unsigned] = ACTIONS(2932),
    [anon_sym_long] = ACTIONS(2932),
    [anon_sym_short] = ACTIONS(2932),
    [anon_sym_LBRACK] = ACTIONS(2932),
    [anon_sym_static] = ACTIONS(2932),
    [anon_sym_register] = ACTIONS(2932),
    [anon_sym_inline] = ACTIONS(2932),
    [anon_sym___inline] = ACTIONS(2932),
    [anon_sym___inline__] = ACTIONS(2932),
    [anon_sym___forceinline] = ACTIONS(2932),
    [anon_sym_thread_local] = ACTIONS(2932),
    [anon_sym___thread] = ACTIONS(2932),
    [anon_sym_const] = ACTIONS(2932),
    [anon_sym_constexpr] = ACTIONS(2932),
    [anon_sym_volatile] = ACTIONS(2932),
    [anon_sym_restrict] = ACTIONS(2932),
    [anon_sym___restrict__] = ACTIONS(2932),
    [anon_sym__Atomic] = ACTIONS(2932),
    [anon_sym__Noreturn] = ACTIONS(2932),
    [anon_sym_noreturn] = ACTIONS(2932),
    [anon_sym__Nonnull] = ACTIONS(2932),
    [anon_sym_mutable] = ACTIONS(2932),
    [anon_sym_constinit] = ACTIONS(2932),
    [anon_sym_consteval] = ACTIONS(2932),
    [anon_sym_alignas] = ACTIONS(2932),
    [anon_sym__Alignas] = ACTIONS(2932),
    [sym_primitive_type] = ACTIONS(2932),
    [anon_sym_enum] = ACTIONS(2932),
    [anon_sym_class] = ACTIONS(2932),
    [anon_sym_struct] = ACTIONS(2932),
    [anon_sym_union] = ACTIONS(2932),
    [anon_sym_if] = ACTIONS(2932),
    [anon_sym_switch] = ACTIONS(2932),
    [anon_sym_case] = ACTIONS(2932),
    [anon_sym_default] = ACTIONS(2932),
    [anon_sym_while] = ACTIONS(2932),
    [anon_sym_do] = ACTIONS(2932),
    [anon_sym_for] = ACTIONS(2932),
    [anon_sym_return] = ACTIONS(2932),
    [anon_sym_break] = ACTIONS(2932),
    [anon_sym_continue] = ACTIONS(2932),
    [anon_sym_goto] = ACTIONS(2932),
    [anon_sym___try] = ACTIONS(2932),
    [anon_sym___leave] = ACTIONS(2932),
    [anon_sym_not] = ACTIONS(2932),
    [anon_sym_compl] = ACTIONS(2932),
    [anon_sym_DASH_DASH] = ACTIONS(2934),
    [anon_sym_PLUS_PLUS] = ACTIONS(2934),
    [anon_sym_sizeof] = ACTIONS(2932),
    [anon_sym___alignof__] = ACTIONS(2932),
    [anon_sym___alignof] = ACTIONS(2932),
    [anon_sym__alignof] = ACTIONS(2932),
    [anon_sym_alignof] = ACTIONS(2932),
    [anon_sym__Alignof] = ACTIONS(2932),
    [anon_sym_offsetof] = ACTIONS(2932),
    [anon_sym__Generic] = ACTIONS(2932),
    [anon_sym_asm] = ACTIONS(2932),
    [anon_sym___asm__] = ACTIONS(2932),
    [anon_sym___asm] = ACTIONS(2932),
    [sym_number_literal] = ACTIONS(2934),
    [anon_sym_L_SQUOTE] = ACTIONS(2934),
    [anon_sym_u_SQUOTE] = ACTIONS(2934),
    [anon_sym_U_SQUOTE] = ACTIONS(2934),
    [anon_sym_u8_SQUOTE] = ACTIONS(2934),
    [anon_sym_SQUOTE] = ACTIONS(2934),
    [anon_sym_L_DQUOTE] = ACTIONS(2934),
    [anon_sym_u_DQUOTE] = ACTIONS(2934),
    [anon_sym_U_DQUOTE] = ACTIONS(2934),
    [anon_sym_u8_DQUOTE] = ACTIONS(2934),
    [anon_sym_DQUOTE] = ACTIONS(2934),
    [sym_true] = ACTIONS(2932),
    [sym_false] = ACTIONS(2932),
    [anon_sym_NULL] = ACTIONS(2932),
    [anon_sym_nullptr] = ACTIONS(2932),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2932),
    [anon_sym_decltype] = ACTIONS(2932),
    [anon_sym_explicit] = ACTIONS(2932),
    [anon_sym_typename] = ACTIONS(2932),
    [anon_sym_template] = ACTIONS(2932),
    [anon_sym_operator] = ACTIONS(2932),
    [anon_sym_try] = ACTIONS(2932),
    [anon_sym_delete] = ACTIONS(2932),
    [anon_sym_throw] = ACTIONS(2932),
    [anon_sym_namespace] = ACTIONS(2932),
    [anon_sym_using] = ACTIONS(2932),
    [anon_sym_static_assert] = ACTIONS(2932),
    [anon_sym_concept] = ACTIONS(2932),
    [anon_sym_co_return] = ACTIONS(2932),
    [anon_sym_co_yield] = ACTIONS(2932),
    [anon_sym_R_DQUOTE] = ACTIONS(2934),
    [anon_sym_LR_DQUOTE] = ACTIONS(2934),
    [anon_sym_uR_DQUOTE] = ACTIONS(2934),
    [anon_sym_UR_DQUOTE] = ACTIONS(2934),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2934),
    [anon_sym_co_await] = ACTIONS(2932),
    [anon_sym_new] = ACTIONS(2932),
    [anon_sym_requires] = ACTIONS(2932),
    [sym_this] = ACTIONS(2932),
  },
  [683] = {
    [sym_identifier] = ACTIONS(3060),
    [aux_sym_preproc_include_token1] = ACTIONS(3060),
    [aux_sym_preproc_def_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token1] = ACTIONS(3060),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3060),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3060),
    [sym_preproc_directive] = ACTIONS(3060),
    [anon_sym_LPAREN2] = ACTIONS(3062),
    [anon_sym_BANG] = ACTIONS(3062),
    [anon_sym_TILDE] = ACTIONS(3062),
    [anon_sym_DASH] = ACTIONS(3060),
    [anon_sym_PLUS] = ACTIONS(3060),
    [anon_sym_STAR] = ACTIONS(3062),
    [anon_sym_AMP_AMP] = ACTIONS(3062),
    [anon_sym_AMP] = ACTIONS(3060),
    [anon_sym_SEMI] = ACTIONS(3062),
    [anon_sym___extension__] = ACTIONS(3060),
    [anon_sym_typedef] = ACTIONS(3060),
    [anon_sym_virtual] = ACTIONS(3060),
    [anon_sym_extern] = ACTIONS(3060),
    [anon_sym___attribute__] = ACTIONS(3060),
    [anon_sym___attribute] = ACTIONS(3060),
    [anon_sym_COLON_COLON] = ACTIONS(3062),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3062),
    [anon_sym___declspec] = ACTIONS(3060),
    [anon_sym___based] = ACTIONS(3060),
    [anon_sym___cdecl] = ACTIONS(3060),
    [anon_sym___clrcall] = ACTIONS(3060),
    [anon_sym___stdcall] = ACTIONS(3060),
    [anon_sym___fastcall] = ACTIONS(3060),
    [anon_sym___thiscall] = ACTIONS(3060),
    [anon_sym___vectorcall] = ACTIONS(3060),
    [anon_sym_LBRACE] = ACTIONS(3062),
    [anon_sym_RBRACE] = ACTIONS(3062),
    [anon_sym_signed] = ACTIONS(3060),
    [anon_sym_unsigned] = ACTIONS(3060),
    [anon_sym_long] = ACTIONS(3060),
    [anon_sym_short] = ACTIONS(3060),
    [anon_sym_LBRACK] = ACTIONS(3060),
    [anon_sym_static] = ACTIONS(3060),
    [anon_sym_register] = ACTIONS(3060),
    [anon_sym_inline] = ACTIONS(3060),
    [anon_sym___inline] = ACTIONS(3060),
    [anon_sym___inline__] = ACTIONS(3060),
    [anon_sym___forceinline] = ACTIONS(3060),
    [anon_sym_thread_local] = ACTIONS(3060),
    [anon_sym___thread] = ACTIONS(3060),
    [anon_sym_const] = ACTIONS(3060),
    [anon_sym_constexpr] = ACTIONS(3060),
    [anon_sym_volatile] = ACTIONS(3060),
    [anon_sym_restrict] = ACTIONS(3060),
    [anon_sym___restrict__] = ACTIONS(3060),
    [anon_sym__Atomic] = ACTIONS(3060),
    [anon_sym__Noreturn] = ACTIONS(3060),
    [anon_sym_noreturn] = ACTIONS(3060),
    [anon_sym__Nonnull] = ACTIONS(3060),
    [anon_sym_mutable] = ACTIONS(3060),
    [anon_sym_constinit] = ACTIONS(3060),
    [anon_sym_consteval] = ACTIONS(3060),
    [anon_sym_alignas] = ACTIONS(3060),
    [anon_sym__Alignas] = ACTIONS(3060),
    [sym_primitive_type] = ACTIONS(3060),
    [anon_sym_enum] = ACTIONS(3060),
    [anon_sym_class] = ACTIONS(3060),
    [anon_sym_struct] = ACTIONS(3060),
    [anon_sym_union] = ACTIONS(3060),
    [anon_sym_if] = ACTIONS(3060),
    [anon_sym_switch] = ACTIONS(3060),
    [anon_sym_case] = ACTIONS(3060),
    [anon_sym_default] = ACTIONS(3060),
    [anon_sym_while] = ACTIONS(3060),
    [anon_sym_do] = ACTIONS(3060),
    [anon_sym_for] = ACTIONS(3060),
    [anon_sym_return] = ACTIONS(3060),
    [anon_sym_break] = ACTIONS(3060),
    [anon_sym_continue] = ACTIONS(3060),
    [anon_sym_goto] = ACTIONS(3060),
    [anon_sym___try] = ACTIONS(3060),
    [anon_sym___leave] = ACTIONS(3060),
    [anon_sym_not] = ACTIONS(3060),
    [anon_sym_compl] = ACTIONS(3060),
    [anon_sym_DASH_DASH] = ACTIONS(3062),
    [anon_sym_PLUS_PLUS] = ACTIONS(3062),
    [anon_sym_sizeof] = ACTIONS(3060),
    [anon_sym___alignof__] = ACTIONS(3060),
    [anon_sym___alignof] = ACTIONS(3060),
    [anon_sym__alignof] = ACTIONS(3060),
    [anon_sym_alignof] = ACTIONS(3060),
    [anon_sym__Alignof] = ACTIONS(3060),
    [anon_sym_offsetof] = ACTIONS(3060),
    [anon_sym__Generic] = ACTIONS(3060),
    [anon_sym_asm] = ACTIONS(3060),
    [anon_sym___asm__] = ACTIONS(3060),
    [anon_sym___asm] = ACTIONS(3060),
    [sym_number_literal] = ACTIONS(3062),
    [anon_sym_L_SQUOTE] = ACTIONS(3062),
    [anon_sym_u_SQUOTE] = ACTIONS(3062),
    [anon_sym_U_SQUOTE] = ACTIONS(3062),
    [anon_sym_u8_SQUOTE] = ACTIONS(3062),
    [anon_sym_SQUOTE] = ACTIONS(3062),
    [anon_sym_L_DQUOTE] = ACTIONS(3062),
    [anon_sym_u_DQUOTE] = ACTIONS(3062),
    [anon_sym_U_DQUOTE] = ACTIONS(3062),
    [anon_sym_u8_DQUOTE] = ACTIONS(3062),
    [anon_sym_DQUOTE] = ACTIONS(3062),
    [sym_true] = ACTIONS(3060),
    [sym_false] = ACTIONS(3060),
    [anon_sym_NULL] = ACTIONS(3060),
    [anon_sym_nullptr] = ACTIONS(3060),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3060),
    [anon_sym_decltype] = ACTIONS(3060),
    [anon_sym_explicit] = ACTIONS(3060),
    [anon_sym_typename] = ACTIONS(3060),
    [anon_sym_template] = ACTIONS(3060),
    [anon_sym_operator] = ACTIONS(3060),
    [anon_sym_try] = ACTIONS(3060),
    [anon_sym_delete] = ACTIONS(3060),
    [anon_sym_throw] = ACTIONS(3060),
    [anon_sym_namespace] = ACTIONS(3060),
    [anon_sym_using] = ACTIONS(3060),
    [anon_sym_static_assert] = ACTIONS(3060),
    [anon_sym_concept] = ACTIONS(3060),
    [anon_sym_co_return] = ACTIONS(3060),
    [anon_sym_co_yield] = ACTIONS(3060),
    [anon_sym_R_DQUOTE] = ACTIONS(3062),
    [anon_sym_LR_DQUOTE] = ACTIONS(3062),
    [anon_sym_uR_DQUOTE] = ACTIONS(3062),
    [anon_sym_UR_DQUOTE] = ACTIONS(3062),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3062),
    [anon_sym_co_await] = ACTIONS(3060),
    [anon_sym_new] = ACTIONS(3060),
    [anon_sym_requires] = ACTIONS(3060),
    [sym_this] = ACTIONS(3060),
  },
  [684] = {
    [sym_identifier] = ACTIONS(3064),
    [aux_sym_preproc_include_token1] = ACTIONS(3064),
    [aux_sym_preproc_def_token1] = ACTIONS(3064),
    [aux_sym_preproc_if_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3064),
    [sym_preproc_directive] = ACTIONS(3064),
    [anon_sym_LPAREN2] = ACTIONS(3066),
    [anon_sym_BANG] = ACTIONS(3066),
    [anon_sym_TILDE] = ACTIONS(3066),
    [anon_sym_DASH] = ACTIONS(3064),
    [anon_sym_PLUS] = ACTIONS(3064),
    [anon_sym_STAR] = ACTIONS(3066),
    [anon_sym_AMP_AMP] = ACTIONS(3066),
    [anon_sym_AMP] = ACTIONS(3064),
    [anon_sym_SEMI] = ACTIONS(3066),
    [anon_sym___extension__] = ACTIONS(3064),
    [anon_sym_typedef] = ACTIONS(3064),
    [anon_sym_virtual] = ACTIONS(3064),
    [anon_sym_extern] = ACTIONS(3064),
    [anon_sym___attribute__] = ACTIONS(3064),
    [anon_sym___attribute] = ACTIONS(3064),
    [anon_sym_COLON_COLON] = ACTIONS(3066),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3066),
    [anon_sym___declspec] = ACTIONS(3064),
    [anon_sym___based] = ACTIONS(3064),
    [anon_sym___cdecl] = ACTIONS(3064),
    [anon_sym___clrcall] = ACTIONS(3064),
    [anon_sym___stdcall] = ACTIONS(3064),
    [anon_sym___fastcall] = ACTIONS(3064),
    [anon_sym___thiscall] = ACTIONS(3064),
    [anon_sym___vectorcall] = ACTIONS(3064),
    [anon_sym_LBRACE] = ACTIONS(3066),
    [anon_sym_RBRACE] = ACTIONS(3066),
    [anon_sym_signed] = ACTIONS(3064),
    [anon_sym_unsigned] = ACTIONS(3064),
    [anon_sym_long] = ACTIONS(3064),
    [anon_sym_short] = ACTIONS(3064),
    [anon_sym_LBRACK] = ACTIONS(3064),
    [anon_sym_static] = ACTIONS(3064),
    [anon_sym_register] = ACTIONS(3064),
    [anon_sym_inline] = ACTIONS(3064),
    [anon_sym___inline] = ACTIONS(3064),
    [anon_sym___inline__] = ACTIONS(3064),
    [anon_sym___forceinline] = ACTIONS(3064),
    [anon_sym_thread_local] = ACTIONS(3064),
    [anon_sym___thread] = ACTIONS(3064),
    [anon_sym_const] = ACTIONS(3064),
    [anon_sym_constexpr] = ACTIONS(3064),
    [anon_sym_volatile] = ACTIONS(3064),
    [anon_sym_restrict] = ACTIONS(3064),
    [anon_sym___restrict__] = ACTIONS(3064),
    [anon_sym__Atomic] = ACTIONS(3064),
    [anon_sym__Noreturn] = ACTIONS(3064),
    [anon_sym_noreturn] = ACTIONS(3064),
    [anon_sym__Nonnull] = ACTIONS(3064),
    [anon_sym_mutable] = ACTIONS(3064),
    [anon_sym_constinit] = ACTIONS(3064),
    [anon_sym_consteval] = ACTIONS(3064),
    [anon_sym_alignas] = ACTIONS(3064),
    [anon_sym__Alignas] = ACTIONS(3064),
    [sym_primitive_type] = ACTIONS(3064),
    [anon_sym_enum] = ACTIONS(3064),
    [anon_sym_class] = ACTIONS(3064),
    [anon_sym_struct] = ACTIONS(3064),
    [anon_sym_union] = ACTIONS(3064),
    [anon_sym_if] = ACTIONS(3064),
    [anon_sym_switch] = ACTIONS(3064),
    [anon_sym_case] = ACTIONS(3064),
    [anon_sym_default] = ACTIONS(3064),
    [anon_sym_while] = ACTIONS(3064),
    [anon_sym_do] = ACTIONS(3064),
    [anon_sym_for] = ACTIONS(3064),
    [anon_sym_return] = ACTIONS(3064),
    [anon_sym_break] = ACTIONS(3064),
    [anon_sym_continue] = ACTIONS(3064),
    [anon_sym_goto] = ACTIONS(3064),
    [anon_sym___try] = ACTIONS(3064),
    [anon_sym___leave] = ACTIONS(3064),
    [anon_sym_not] = ACTIONS(3064),
    [anon_sym_compl] = ACTIONS(3064),
    [anon_sym_DASH_DASH] = ACTIONS(3066),
    [anon_sym_PLUS_PLUS] = ACTIONS(3066),
    [anon_sym_sizeof] = ACTIONS(3064),
    [anon_sym___alignof__] = ACTIONS(3064),
    [anon_sym___alignof] = ACTIONS(3064),
    [anon_sym__alignof] = ACTIONS(3064),
    [anon_sym_alignof] = ACTIONS(3064),
    [anon_sym__Alignof] = ACTIONS(3064),
    [anon_sym_offsetof] = ACTIONS(3064),
    [anon_sym__Generic] = ACTIONS(3064),
    [anon_sym_asm] = ACTIONS(3064),
    [anon_sym___asm__] = ACTIONS(3064),
    [anon_sym___asm] = ACTIONS(3064),
    [sym_number_literal] = ACTIONS(3066),
    [anon_sym_L_SQUOTE] = ACTIONS(3066),
    [anon_sym_u_SQUOTE] = ACTIONS(3066),
    [anon_sym_U_SQUOTE] = ACTIONS(3066),
    [anon_sym_u8_SQUOTE] = ACTIONS(3066),
    [anon_sym_SQUOTE] = ACTIONS(3066),
    [anon_sym_L_DQUOTE] = ACTIONS(3066),
    [anon_sym_u_DQUOTE] = ACTIONS(3066),
    [anon_sym_U_DQUOTE] = ACTIONS(3066),
    [anon_sym_u8_DQUOTE] = ACTIONS(3066),
    [anon_sym_DQUOTE] = ACTIONS(3066),
    [sym_true] = ACTIONS(3064),
    [sym_false] = ACTIONS(3064),
    [anon_sym_NULL] = ACTIONS(3064),
    [anon_sym_nullptr] = ACTIONS(3064),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3064),
    [anon_sym_decltype] = ACTIONS(3064),
    [anon_sym_explicit] = ACTIONS(3064),
    [anon_sym_typename] = ACTIONS(3064),
    [anon_sym_template] = ACTIONS(3064),
    [anon_sym_operator] = ACTIONS(3064),
    [anon_sym_try] = ACTIONS(3064),
    [anon_sym_delete] = ACTIONS(3064),
    [anon_sym_throw] = ACTIONS(3064),
    [anon_sym_namespace] = ACTIONS(3064),
    [anon_sym_using] = ACTIONS(3064),
    [anon_sym_static_assert] = ACTIONS(3064),
    [anon_sym_concept] = ACTIONS(3064),
    [anon_sym_co_return] = ACTIONS(3064),
    [anon_sym_co_yield] = ACTIONS(3064),
    [anon_sym_R_DQUOTE] = ACTIONS(3066),
    [anon_sym_LR_DQUOTE] = ACTIONS(3066),
    [anon_sym_uR_DQUOTE] = ACTIONS(3066),
    [anon_sym_UR_DQUOTE] = ACTIONS(3066),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3066),
    [anon_sym_co_await] = ACTIONS(3064),
    [anon_sym_new] = ACTIONS(3064),
    [anon_sym_requires] = ACTIONS(3064),
    [sym_this] = ACTIONS(3064),
  },
  [685] = {
    [sym_identifier] = ACTIONS(2759),
    [aux_sym_preproc_include_token1] = ACTIONS(2759),
    [aux_sym_preproc_def_token1] = ACTIONS(2759),
    [aux_sym_preproc_if_token1] = ACTIONS(2759),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2759),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2759),
    [sym_preproc_directive] = ACTIONS(2759),
    [anon_sym_LPAREN2] = ACTIONS(2761),
    [anon_sym_BANG] = ACTIONS(2761),
    [anon_sym_TILDE] = ACTIONS(2761),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_STAR] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2759),
    [anon_sym_SEMI] = ACTIONS(2761),
    [anon_sym___extension__] = ACTIONS(2759),
    [anon_sym_typedef] = ACTIONS(2759),
    [anon_sym_virtual] = ACTIONS(2759),
    [anon_sym_extern] = ACTIONS(2759),
    [anon_sym___attribute__] = ACTIONS(2759),
    [anon_sym___attribute] = ACTIONS(2759),
    [anon_sym_COLON_COLON] = ACTIONS(2761),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2761),
    [anon_sym___declspec] = ACTIONS(2759),
    [anon_sym___based] = ACTIONS(2759),
    [anon_sym___cdecl] = ACTIONS(2759),
    [anon_sym___clrcall] = ACTIONS(2759),
    [anon_sym___stdcall] = ACTIONS(2759),
    [anon_sym___fastcall] = ACTIONS(2759),
    [anon_sym___thiscall] = ACTIONS(2759),
    [anon_sym___vectorcall] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_RBRACE] = ACTIONS(2761),
    [anon_sym_signed] = ACTIONS(2759),
    [anon_sym_unsigned] = ACTIONS(2759),
    [anon_sym_long] = ACTIONS(2759),
    [anon_sym_short] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_static] = ACTIONS(2759),
    [anon_sym_register] = ACTIONS(2759),
    [anon_sym_inline] = ACTIONS(2759),
    [anon_sym___inline] = ACTIONS(2759),
    [anon_sym___inline__] = ACTIONS(2759),
    [anon_sym___forceinline] = ACTIONS(2759),
    [anon_sym_thread_local] = ACTIONS(2759),
    [anon_sym___thread] = ACTIONS(2759),
    [anon_sym_const] = ACTIONS(2759),
    [anon_sym_constexpr] = ACTIONS(2759),
    [anon_sym_volatile] = ACTIONS(2759),
    [anon_sym_restrict] = ACTIONS(2759),
    [anon_sym___restrict__] = ACTIONS(2759),
    [anon_sym__Atomic] = ACTIONS(2759),
    [anon_sym__Noreturn] = ACTIONS(2759),
    [anon_sym_noreturn] = ACTIONS(2759),
    [anon_sym__Nonnull] = ACTIONS(2759),
    [anon_sym_mutable] = ACTIONS(2759),
    [anon_sym_constinit] = ACTIONS(2759),
    [anon_sym_consteval] = ACTIONS(2759),
    [anon_sym_alignas] = ACTIONS(2759),
    [anon_sym__Alignas] = ACTIONS(2759),
    [sym_primitive_type] = ACTIONS(2759),
    [anon_sym_enum] = ACTIONS(2759),
    [anon_sym_class] = ACTIONS(2759),
    [anon_sym_struct] = ACTIONS(2759),
    [anon_sym_union] = ACTIONS(2759),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_switch] = ACTIONS(2759),
    [anon_sym_case] = ACTIONS(2759),
    [anon_sym_default] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_for] = ACTIONS(2759),
    [anon_sym_return] = ACTIONS(2759),
    [anon_sym_break] = ACTIONS(2759),
    [anon_sym_continue] = ACTIONS(2759),
    [anon_sym_goto] = ACTIONS(2759),
    [anon_sym___try] = ACTIONS(2759),
    [anon_sym___leave] = ACTIONS(2759),
    [anon_sym_not] = ACTIONS(2759),
    [anon_sym_compl] = ACTIONS(2759),
    [anon_sym_DASH_DASH] = ACTIONS(2761),
    [anon_sym_PLUS_PLUS] = ACTIONS(2761),
    [anon_sym_sizeof] = ACTIONS(2759),
    [anon_sym___alignof__] = ACTIONS(2759),
    [anon_sym___alignof] = ACTIONS(2759),
    [anon_sym__alignof] = ACTIONS(2759),
    [anon_sym_alignof] = ACTIONS(2759),
    [anon_sym__Alignof] = ACTIONS(2759),
    [anon_sym_offsetof] = ACTIONS(2759),
    [anon_sym__Generic] = ACTIONS(2759),
    [anon_sym_asm] = ACTIONS(2759),
    [anon_sym___asm__] = ACTIONS(2759),
    [anon_sym___asm] = ACTIONS(2759),
    [sym_number_literal] = ACTIONS(2761),
    [anon_sym_L_SQUOTE] = ACTIONS(2761),
    [anon_sym_u_SQUOTE] = ACTIONS(2761),
    [anon_sym_U_SQUOTE] = ACTIONS(2761),
    [anon_sym_u8_SQUOTE] = ACTIONS(2761),
    [anon_sym_SQUOTE] = ACTIONS(2761),
    [anon_sym_L_DQUOTE] = ACTIONS(2761),
    [anon_sym_u_DQUOTE] = ACTIONS(2761),
    [anon_sym_U_DQUOTE] = ACTIONS(2761),
    [anon_sym_u8_DQUOTE] = ACTIONS(2761),
    [anon_sym_DQUOTE] = ACTIONS(2761),
    [sym_true] = ACTIONS(2759),
    [sym_false] = ACTIONS(2759),
    [anon_sym_NULL] = ACTIONS(2759),
    [anon_sym_nullptr] = ACTIONS(2759),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2759),
    [anon_sym_decltype] = ACTIONS(2759),
    [anon_sym_explicit] = ACTIONS(2759),
    [anon_sym_typename] = ACTIONS(2759),
    [anon_sym_template] = ACTIONS(2759),
    [anon_sym_operator] = ACTIONS(2759),
    [anon_sym_try] = ACTIONS(2759),
    [anon_sym_delete] = ACTIONS(2759),
    [anon_sym_throw] = ACTIONS(2759),
    [anon_sym_namespace] = ACTIONS(2759),
    [anon_sym_using] = ACTIONS(2759),
    [anon_sym_static_assert] = ACTIONS(2759),
    [anon_sym_concept] = ACTIONS(2759),
    [anon_sym_co_return] = ACTIONS(2759),
    [anon_sym_co_yield] = ACTIONS(2759),
    [anon_sym_R_DQUOTE] = ACTIONS(2761),
    [anon_sym_LR_DQUOTE] = ACTIONS(2761),
    [anon_sym_uR_DQUOTE] = ACTIONS(2761),
    [anon_sym_UR_DQUOTE] = ACTIONS(2761),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2761),
    [anon_sym_co_await] = ACTIONS(2759),
    [anon_sym_new] = ACTIONS(2759),
    [anon_sym_requires] = ACTIONS(2759),
    [sym_this] = ACTIONS(2759),
  },
  [686] = {
    [ts_builtin_sym_end] = ACTIONS(3452),
    [sym_identifier] = ACTIONS(3455),
    [aux_sym_preproc_include_token1] = ACTIONS(3455),
    [aux_sym_preproc_def_token1] = ACTIONS(3455),
    [aux_sym_preproc_if_token1] = ACTIONS(3455),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3455),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3455),
    [sym_preproc_directive] = ACTIONS(3455),
    [anon_sym_LPAREN2] = ACTIONS(3452),
    [anon_sym_BANG] = ACTIONS(3452),
    [anon_sym_TILDE] = ACTIONS(3452),
    [anon_sym_DASH] = ACTIONS(3455),
    [anon_sym_PLUS] = ACTIONS(3455),
    [anon_sym_STAR] = ACTIONS(3452),
    [anon_sym_AMP_AMP] = ACTIONS(3452),
    [anon_sym_AMP] = ACTIONS(3455),
    [anon_sym_SEMI] = ACTIONS(3452),
    [anon_sym___extension__] = ACTIONS(3455),
    [anon_sym_typedef] = ACTIONS(3455),
    [anon_sym_virtual] = ACTIONS(3455),
    [anon_sym_extern] = ACTIONS(3455),
    [anon_sym___attribute__] = ACTIONS(3455),
    [anon_sym___attribute] = ACTIONS(3455),
    [anon_sym_COLON_COLON] = ACTIONS(3452),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3452),
    [anon_sym___declspec] = ACTIONS(3455),
    [anon_sym___based] = ACTIONS(3455),
    [anon_sym___cdecl] = ACTIONS(3455),
    [anon_sym___clrcall] = ACTIONS(3455),
    [anon_sym___stdcall] = ACTIONS(3455),
    [anon_sym___fastcall] = ACTIONS(3455),
    [anon_sym___thiscall] = ACTIONS(3455),
    [anon_sym___vectorcall] = ACTIONS(3455),
    [anon_sym_LBRACE] = ACTIONS(3452),
    [anon_sym_signed] = ACTIONS(3455),
    [anon_sym_unsigned] = ACTIONS(3455),
    [anon_sym_long] = ACTIONS(3455),
    [anon_sym_short] = ACTIONS(3455),
    [anon_sym_LBRACK] = ACTIONS(3455),
    [anon_sym_static] = ACTIONS(3455),
    [anon_sym_register] = ACTIONS(3455),
    [anon_sym_inline] = ACTIONS(3455),
    [anon_sym___inline] = ACTIONS(3455),
    [anon_sym___inline__] = ACTIONS(3455),
    [anon_sym___forceinline] = ACTIONS(3455),
    [anon_sym_thread_local] = ACTIONS(3455),
    [anon_sym___thread] = ACTIONS(3455),
    [anon_sym_const] = ACTIONS(3455),
    [anon_sym_constexpr] = ACTIONS(3455),
    [anon_sym_volatile] = ACTIONS(3455),
    [anon_sym_restrict] = ACTIONS(3455),
    [anon_sym___restrict__] = ACTIONS(3455),
    [anon_sym__Atomic] = ACTIONS(3455),
    [anon_sym__Noreturn] = ACTIONS(3455),
    [anon_sym_noreturn] = ACTIONS(3455),
    [anon_sym__Nonnull] = ACTIONS(3455),
    [anon_sym_mutable] = ACTIONS(3455),
    [anon_sym_constinit] = ACTIONS(3455),
    [anon_sym_consteval] = ACTIONS(3455),
    [anon_sym_alignas] = ACTIONS(3455),
    [anon_sym__Alignas] = ACTIONS(3455),
    [sym_primitive_type] = ACTIONS(3455),
    [anon_sym_enum] = ACTIONS(3455),
    [anon_sym_class] = ACTIONS(3455),
    [anon_sym_struct] = ACTIONS(3455),
    [anon_sym_union] = ACTIONS(3455),
    [anon_sym_if] = ACTIONS(3455),
    [anon_sym_switch] = ACTIONS(3455),
    [anon_sym_case] = ACTIONS(3455),
    [anon_sym_default] = ACTIONS(3455),
    [anon_sym_while] = ACTIONS(3455),
    [anon_sym_do] = ACTIONS(3455),
    [anon_sym_for] = ACTIONS(3455),
    [anon_sym_return] = ACTIONS(3455),
    [anon_sym_break] = ACTIONS(3455),
    [anon_sym_continue] = ACTIONS(3455),
    [anon_sym_goto] = ACTIONS(3455),
    [anon_sym_not] = ACTIONS(3455),
    [anon_sym_compl] = ACTIONS(3455),
    [anon_sym_DASH_DASH] = ACTIONS(3452),
    [anon_sym_PLUS_PLUS] = ACTIONS(3452),
    [anon_sym_sizeof] = ACTIONS(3455),
    [anon_sym___alignof__] = ACTIONS(3455),
    [anon_sym___alignof] = ACTIONS(3455),
    [anon_sym__alignof] = ACTIONS(3455),
    [anon_sym_alignof] = ACTIONS(3455),
    [anon_sym__Alignof] = ACTIONS(3455),
    [anon_sym_offsetof] = ACTIONS(3455),
    [anon_sym__Generic] = ACTIONS(3455),
    [anon_sym_asm] = ACTIONS(3455),
    [anon_sym___asm__] = ACTIONS(3455),
    [anon_sym___asm] = ACTIONS(3455),
    [sym_number_literal] = ACTIONS(3452),
    [anon_sym_L_SQUOTE] = ACTIONS(3452),
    [anon_sym_u_SQUOTE] = ACTIONS(3452),
    [anon_sym_U_SQUOTE] = ACTIONS(3452),
    [anon_sym_u8_SQUOTE] = ACTIONS(3452),
    [anon_sym_SQUOTE] = ACTIONS(3452),
    [anon_sym_L_DQUOTE] = ACTIONS(3452),
    [anon_sym_u_DQUOTE] = ACTIONS(3452),
    [anon_sym_U_DQUOTE] = ACTIONS(3452),
    [anon_sym_u8_DQUOTE] = ACTIONS(3452),
    [anon_sym_DQUOTE] = ACTIONS(3452),
    [sym_true] = ACTIONS(3455),
    [sym_false] = ACTIONS(3455),
    [anon_sym_NULL] = ACTIONS(3455),
    [anon_sym_nullptr] = ACTIONS(3455),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3455),
    [anon_sym_decltype] = ACTIONS(3455),
    [anon_sym_explicit] = ACTIONS(3455),
    [anon_sym_typename] = ACTIONS(3455),
    [anon_sym_template] = ACTIONS(3455),
    [anon_sym_operator] = ACTIONS(3455),
    [anon_sym_try] = ACTIONS(3455),
    [anon_sym_delete] = ACTIONS(3455),
    [anon_sym_throw] = ACTIONS(3455),
    [anon_sym_namespace] = ACTIONS(3455),
    [anon_sym_using] = ACTIONS(3455),
    [anon_sym_static_assert] = ACTIONS(3455),
    [anon_sym_concept] = ACTIONS(3455),
    [anon_sym_co_return] = ACTIONS(3455),
    [anon_sym_co_yield] = ACTIONS(3455),
    [anon_sym_R_DQUOTE] = ACTIONS(3452),
    [anon_sym_LR_DQUOTE] = ACTIONS(3452),
    [anon_sym_uR_DQUOTE] = ACTIONS(3452),
    [anon_sym_UR_DQUOTE] = ACTIONS(3452),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3452),
    [anon_sym_co_await] = ACTIONS(3455),
    [anon_sym_new] = ACTIONS(3455),
    [anon_sym_requires] = ACTIONS(3455),
    [sym_this] = ACTIONS(3455),
  },
  [687] = {
    [ts_builtin_sym_end] = ACTIONS(3048),
    [sym_identifier] = ACTIONS(3046),
    [aux_sym_preproc_include_token1] = ACTIONS(3046),
    [aux_sym_preproc_def_token1] = ACTIONS(3046),
    [aux_sym_preproc_if_token1] = ACTIONS(3046),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3046),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3046),
    [sym_preproc_directive] = ACTIONS(3046),
    [anon_sym_LPAREN2] = ACTIONS(3048),
    [anon_sym_BANG] = ACTIONS(3048),
    [anon_sym_TILDE] = ACTIONS(3048),
    [anon_sym_DASH] = ACTIONS(3046),
    [anon_sym_PLUS] = ACTIONS(3046),
    [anon_sym_STAR] = ACTIONS(3048),
    [anon_sym_AMP_AMP] = ACTIONS(3048),
    [anon_sym_AMP] = ACTIONS(3046),
    [anon_sym_SEMI] = ACTIONS(3048),
    [anon_sym___extension__] = ACTIONS(3046),
    [anon_sym_typedef] = ACTIONS(3046),
    [anon_sym_virtual] = ACTIONS(3046),
    [anon_sym_extern] = ACTIONS(3046),
    [anon_sym___attribute__] = ACTIONS(3046),
    [anon_sym___attribute] = ACTIONS(3046),
    [anon_sym_COLON_COLON] = ACTIONS(3048),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3048),
    [anon_sym___declspec] = ACTIONS(3046),
    [anon_sym___based] = ACTIONS(3046),
    [anon_sym___cdecl] = ACTIONS(3046),
    [anon_sym___clrcall] = ACTIONS(3046),
    [anon_sym___stdcall] = ACTIONS(3046),
    [anon_sym___fastcall] = ACTIONS(3046),
    [anon_sym___thiscall] = ACTIONS(3046),
    [anon_sym___vectorcall] = ACTIONS(3046),
    [anon_sym_LBRACE] = ACTIONS(3048),
    [anon_sym_signed] = ACTIONS(3046),
    [anon_sym_unsigned] = ACTIONS(3046),
    [anon_sym_long] = ACTIONS(3046),
    [anon_sym_short] = ACTIONS(3046),
    [anon_sym_LBRACK] = ACTIONS(3046),
    [anon_sym_static] = ACTIONS(3046),
    [anon_sym_register] = ACTIONS(3046),
    [anon_sym_inline] = ACTIONS(3046),
    [anon_sym___inline] = ACTIONS(3046),
    [anon_sym___inline__] = ACTIONS(3046),
    [anon_sym___forceinline] = ACTIONS(3046),
    [anon_sym_thread_local] = ACTIONS(3046),
    [anon_sym___thread] = ACTIONS(3046),
    [anon_sym_const] = ACTIONS(3046),
    [anon_sym_constexpr] = ACTIONS(3046),
    [anon_sym_volatile] = ACTIONS(3046),
    [anon_sym_restrict] = ACTIONS(3046),
    [anon_sym___restrict__] = ACTIONS(3046),
    [anon_sym__Atomic] = ACTIONS(3046),
    [anon_sym__Noreturn] = ACTIONS(3046),
    [anon_sym_noreturn] = ACTIONS(3046),
    [anon_sym__Nonnull] = ACTIONS(3046),
    [anon_sym_mutable] = ACTIONS(3046),
    [anon_sym_constinit] = ACTIONS(3046),
    [anon_sym_consteval] = ACTIONS(3046),
    [anon_sym_alignas] = ACTIONS(3046),
    [anon_sym__Alignas] = ACTIONS(3046),
    [sym_primitive_type] = ACTIONS(3046),
    [anon_sym_enum] = ACTIONS(3046),
    [anon_sym_class] = ACTIONS(3046),
    [anon_sym_struct] = ACTIONS(3046),
    [anon_sym_union] = ACTIONS(3046),
    [anon_sym_if] = ACTIONS(3046),
    [anon_sym_switch] = ACTIONS(3046),
    [anon_sym_case] = ACTIONS(3046),
    [anon_sym_default] = ACTIONS(3046),
    [anon_sym_while] = ACTIONS(3046),
    [anon_sym_do] = ACTIONS(3046),
    [anon_sym_for] = ACTIONS(3046),
    [anon_sym_return] = ACTIONS(3046),
    [anon_sym_break] = ACTIONS(3046),
    [anon_sym_continue] = ACTIONS(3046),
    [anon_sym_goto] = ACTIONS(3046),
    [anon_sym_not] = ACTIONS(3046),
    [anon_sym_compl] = ACTIONS(3046),
    [anon_sym_DASH_DASH] = ACTIONS(3048),
    [anon_sym_PLUS_PLUS] = ACTIONS(3048),
    [anon_sym_sizeof] = ACTIONS(3046),
    [anon_sym___alignof__] = ACTIONS(3046),
    [anon_sym___alignof] = ACTIONS(3046),
    [anon_sym__alignof] = ACTIONS(3046),
    [anon_sym_alignof] = ACTIONS(3046),
    [anon_sym__Alignof] = ACTIONS(3046),
    [anon_sym_offsetof] = ACTIONS(3046),
    [anon_sym__Generic] = ACTIONS(3046),
    [anon_sym_asm] = ACTIONS(3046),
    [anon_sym___asm__] = ACTIONS(3046),
    [anon_sym___asm] = ACTIONS(3046),
    [sym_number_literal] = ACTIONS(3048),
    [anon_sym_L_SQUOTE] = ACTIONS(3048),
    [anon_sym_u_SQUOTE] = ACTIONS(3048),
    [anon_sym_U_SQUOTE] = ACTIONS(3048),
    [anon_sym_u8_SQUOTE] = ACTIONS(3048),
    [anon_sym_SQUOTE] = ACTIONS(3048),
    [anon_sym_L_DQUOTE] = ACTIONS(3048),
    [anon_sym_u_DQUOTE] = ACTIONS(3048),
    [anon_sym_U_DQUOTE] = ACTIONS(3048),
    [anon_sym_u8_DQUOTE] = ACTIONS(3048),
    [anon_sym_DQUOTE] = ACTIONS(3048),
    [sym_true] = ACTIONS(3046),
    [sym_false] = ACTIONS(3046),
    [anon_sym_NULL] = ACTIONS(3046),
    [anon_sym_nullptr] = ACTIONS(3046),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3046),
    [anon_sym_decltype] = ACTIONS(3046),
    [anon_sym_explicit] = ACTIONS(3046),
    [anon_sym_typename] = ACTIONS(3046),
    [anon_sym_template] = ACTIONS(3046),
    [anon_sym_operator] = ACTIONS(3046),
    [anon_sym_try] = ACTIONS(3046),
    [anon_sym_delete] = ACTIONS(3046),
    [anon_sym_throw] = ACTIONS(3046),
    [anon_sym_namespace] = ACTIONS(3046),
    [anon_sym_using] = ACTIONS(3046),
    [anon_sym_static_assert] = ACTIONS(3046),
    [anon_sym_concept] = ACTIONS(3046),
    [anon_sym_co_return] = ACTIONS(3046),
    [anon_sym_co_yield] = ACTIONS(3046),
    [anon_sym_R_DQUOTE] = ACTIONS(3048),
    [anon_sym_LR_DQUOTE] = ACTIONS(3048),
    [anon_sym_uR_DQUOTE] = ACTIONS(3048),
    [anon_sym_UR_DQUOTE] = ACTIONS(3048),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3048),
    [anon_sym_co_await] = ACTIONS(3046),
    [anon_sym_new] = ACTIONS(3046),
    [anon_sym_requires] = ACTIONS(3046),
    [sym_this] = ACTIONS(3046),
  },
  [688] = {
    [ts_builtin_sym_end] = ACTIONS(3058),
    [sym_identifier] = ACTIONS(3056),
    [aux_sym_preproc_include_token1] = ACTIONS(3056),
    [aux_sym_preproc_def_token1] = ACTIONS(3056),
    [aux_sym_preproc_if_token1] = ACTIONS(3056),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3056),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3056),
    [sym_preproc_directive] = ACTIONS(3056),
    [anon_sym_LPAREN2] = ACTIONS(3058),
    [anon_sym_BANG] = ACTIONS(3058),
    [anon_sym_TILDE] = ACTIONS(3058),
    [anon_sym_DASH] = ACTIONS(3056),
    [anon_sym_PLUS] = ACTIONS(3056),
    [anon_sym_STAR] = ACTIONS(3058),
    [anon_sym_AMP_AMP] = ACTIONS(3058),
    [anon_sym_AMP] = ACTIONS(3056),
    [anon_sym_SEMI] = ACTIONS(3058),
    [anon_sym___extension__] = ACTIONS(3056),
    [anon_sym_typedef] = ACTIONS(3056),
    [anon_sym_virtual] = ACTIONS(3056),
    [anon_sym_extern] = ACTIONS(3056),
    [anon_sym___attribute__] = ACTIONS(3056),
    [anon_sym___attribute] = ACTIONS(3056),
    [anon_sym_COLON_COLON] = ACTIONS(3058),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3058),
    [anon_sym___declspec] = ACTIONS(3056),
    [anon_sym___based] = ACTIONS(3056),
    [anon_sym___cdecl] = ACTIONS(3056),
    [anon_sym___clrcall] = ACTIONS(3056),
    [anon_sym___stdcall] = ACTIONS(3056),
    [anon_sym___fastcall] = ACTIONS(3056),
    [anon_sym___thiscall] = ACTIONS(3056),
    [anon_sym___vectorcall] = ACTIONS(3056),
    [anon_sym_LBRACE] = ACTIONS(3058),
    [anon_sym_signed] = ACTIONS(3056),
    [anon_sym_unsigned] = ACTIONS(3056),
    [anon_sym_long] = ACTIONS(3056),
    [anon_sym_short] = ACTIONS(3056),
    [anon_sym_LBRACK] = ACTIONS(3056),
    [anon_sym_static] = ACTIONS(3056),
    [anon_sym_register] = ACTIONS(3056),
    [anon_sym_inline] = ACTIONS(3056),
    [anon_sym___inline] = ACTIONS(3056),
    [anon_sym___inline__] = ACTIONS(3056),
    [anon_sym___forceinline] = ACTIONS(3056),
    [anon_sym_thread_local] = ACTIONS(3056),
    [anon_sym___thread] = ACTIONS(3056),
    [anon_sym_const] = ACTIONS(3056),
    [anon_sym_constexpr] = ACTIONS(3056),
    [anon_sym_volatile] = ACTIONS(3056),
    [anon_sym_restrict] = ACTIONS(3056),
    [anon_sym___restrict__] = ACTIONS(3056),
    [anon_sym__Atomic] = ACTIONS(3056),
    [anon_sym__Noreturn] = ACTIONS(3056),
    [anon_sym_noreturn] = ACTIONS(3056),
    [anon_sym__Nonnull] = ACTIONS(3056),
    [anon_sym_mutable] = ACTIONS(3056),
    [anon_sym_constinit] = ACTIONS(3056),
    [anon_sym_consteval] = ACTIONS(3056),
    [anon_sym_alignas] = ACTIONS(3056),
    [anon_sym__Alignas] = ACTIONS(3056),
    [sym_primitive_type] = ACTIONS(3056),
    [anon_sym_enum] = ACTIONS(3056),
    [anon_sym_class] = ACTIONS(3056),
    [anon_sym_struct] = ACTIONS(3056),
    [anon_sym_union] = ACTIONS(3056),
    [anon_sym_if] = ACTIONS(3056),
    [anon_sym_switch] = ACTIONS(3056),
    [anon_sym_case] = ACTIONS(3056),
    [anon_sym_default] = ACTIONS(3056),
    [anon_sym_while] = ACTIONS(3056),
    [anon_sym_do] = ACTIONS(3056),
    [anon_sym_for] = ACTIONS(3056),
    [anon_sym_return] = ACTIONS(3056),
    [anon_sym_break] = ACTIONS(3056),
    [anon_sym_continue] = ACTIONS(3056),
    [anon_sym_goto] = ACTIONS(3056),
    [anon_sym_not] = ACTIONS(3056),
    [anon_sym_compl] = ACTIONS(3056),
    [anon_sym_DASH_DASH] = ACTIONS(3058),
    [anon_sym_PLUS_PLUS] = ACTIONS(3058),
    [anon_sym_sizeof] = ACTIONS(3056),
    [anon_sym___alignof__] = ACTIONS(3056),
    [anon_sym___alignof] = ACTIONS(3056),
    [anon_sym__alignof] = ACTIONS(3056),
    [anon_sym_alignof] = ACTIONS(3056),
    [anon_sym__Alignof] = ACTIONS(3056),
    [anon_sym_offsetof] = ACTIONS(3056),
    [anon_sym__Generic] = ACTIONS(3056),
    [anon_sym_asm] = ACTIONS(3056),
    [anon_sym___asm__] = ACTIONS(3056),
    [anon_sym___asm] = ACTIONS(3056),
    [sym_number_literal] = ACTIONS(3058),
    [anon_sym_L_SQUOTE] = ACTIONS(3058),
    [anon_sym_u_SQUOTE] = ACTIONS(3058),
    [anon_sym_U_SQUOTE] = ACTIONS(3058),
    [anon_sym_u8_SQUOTE] = ACTIONS(3058),
    [anon_sym_SQUOTE] = ACTIONS(3058),
    [anon_sym_L_DQUOTE] = ACTIONS(3058),
    [anon_sym_u_DQUOTE] = ACTIONS(3058),
    [anon_sym_U_DQUOTE] = ACTIONS(3058),
    [anon_sym_u8_DQUOTE] = ACTIONS(3058),
    [anon_sym_DQUOTE] = ACTIONS(3058),
    [sym_true] = ACTIONS(3056),
    [sym_false] = ACTIONS(3056),
    [anon_sym_NULL] = ACTIONS(3056),
    [anon_sym_nullptr] = ACTIONS(3056),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3056),
    [anon_sym_decltype] = ACTIONS(3056),
    [anon_sym_explicit] = ACTIONS(3056),
    [anon_sym_typename] = ACTIONS(3056),
    [anon_sym_template] = ACTIONS(3056),
    [anon_sym_operator] = ACTIONS(3056),
    [anon_sym_try] = ACTIONS(3056),
    [anon_sym_delete] = ACTIONS(3056),
    [anon_sym_throw] = ACTIONS(3056),
    [anon_sym_namespace] = ACTIONS(3056),
    [anon_sym_using] = ACTIONS(3056),
    [anon_sym_static_assert] = ACTIONS(3056),
    [anon_sym_concept] = ACTIONS(3056),
    [anon_sym_co_return] = ACTIONS(3056),
    [anon_sym_co_yield] = ACTIONS(3056),
    [anon_sym_R_DQUOTE] = ACTIONS(3058),
    [anon_sym_LR_DQUOTE] = ACTIONS(3058),
    [anon_sym_uR_DQUOTE] = ACTIONS(3058),
    [anon_sym_UR_DQUOTE] = ACTIONS(3058),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3058),
    [anon_sym_co_await] = ACTIONS(3056),
    [anon_sym_new] = ACTIONS(3056),
    [anon_sym_requires] = ACTIONS(3056),
    [sym_this] = ACTIONS(3056),
  },
  [689] = {
    [ts_builtin_sym_end] = ACTIONS(3062),
    [sym_identifier] = ACTIONS(3060),
    [aux_sym_preproc_include_token1] = ACTIONS(3060),
    [aux_sym_preproc_def_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token1] = ACTIONS(3060),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3060),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3060),
    [sym_preproc_directive] = ACTIONS(3060),
    [anon_sym_LPAREN2] = ACTIONS(3062),
    [anon_sym_BANG] = ACTIONS(3062),
    [anon_sym_TILDE] = ACTIONS(3062),
    [anon_sym_DASH] = ACTIONS(3060),
    [anon_sym_PLUS] = ACTIONS(3060),
    [anon_sym_STAR] = ACTIONS(3062),
    [anon_sym_AMP_AMP] = ACTIONS(3062),
    [anon_sym_AMP] = ACTIONS(3060),
    [anon_sym_SEMI] = ACTIONS(3062),
    [anon_sym___extension__] = ACTIONS(3060),
    [anon_sym_typedef] = ACTIONS(3060),
    [anon_sym_virtual] = ACTIONS(3060),
    [anon_sym_extern] = ACTIONS(3060),
    [anon_sym___attribute__] = ACTIONS(3060),
    [anon_sym___attribute] = ACTIONS(3060),
    [anon_sym_COLON_COLON] = ACTIONS(3062),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3062),
    [anon_sym___declspec] = ACTIONS(3060),
    [anon_sym___based] = ACTIONS(3060),
    [anon_sym___cdecl] = ACTIONS(3060),
    [anon_sym___clrcall] = ACTIONS(3060),
    [anon_sym___stdcall] = ACTIONS(3060),
    [anon_sym___fastcall] = ACTIONS(3060),
    [anon_sym___thiscall] = ACTIONS(3060),
    [anon_sym___vectorcall] = ACTIONS(3060),
    [anon_sym_LBRACE] = ACTIONS(3062),
    [anon_sym_signed] = ACTIONS(3060),
    [anon_sym_unsigned] = ACTIONS(3060),
    [anon_sym_long] = ACTIONS(3060),
    [anon_sym_short] = ACTIONS(3060),
    [anon_sym_LBRACK] = ACTIONS(3060),
    [anon_sym_static] = ACTIONS(3060),
    [anon_sym_register] = ACTIONS(3060),
    [anon_sym_inline] = ACTIONS(3060),
    [anon_sym___inline] = ACTIONS(3060),
    [anon_sym___inline__] = ACTIONS(3060),
    [anon_sym___forceinline] = ACTIONS(3060),
    [anon_sym_thread_local] = ACTIONS(3060),
    [anon_sym___thread] = ACTIONS(3060),
    [anon_sym_const] = ACTIONS(3060),
    [anon_sym_constexpr] = ACTIONS(3060),
    [anon_sym_volatile] = ACTIONS(3060),
    [anon_sym_restrict] = ACTIONS(3060),
    [anon_sym___restrict__] = ACTIONS(3060),
    [anon_sym__Atomic] = ACTIONS(3060),
    [anon_sym__Noreturn] = ACTIONS(3060),
    [anon_sym_noreturn] = ACTIONS(3060),
    [anon_sym__Nonnull] = ACTIONS(3060),
    [anon_sym_mutable] = ACTIONS(3060),
    [anon_sym_constinit] = ACTIONS(3060),
    [anon_sym_consteval] = ACTIONS(3060),
    [anon_sym_alignas] = ACTIONS(3060),
    [anon_sym__Alignas] = ACTIONS(3060),
    [sym_primitive_type] = ACTIONS(3060),
    [anon_sym_enum] = ACTIONS(3060),
    [anon_sym_class] = ACTIONS(3060),
    [anon_sym_struct] = ACTIONS(3060),
    [anon_sym_union] = ACTIONS(3060),
    [anon_sym_if] = ACTIONS(3060),
    [anon_sym_switch] = ACTIONS(3060),
    [anon_sym_case] = ACTIONS(3060),
    [anon_sym_default] = ACTIONS(3060),
    [anon_sym_while] = ACTIONS(3060),
    [anon_sym_do] = ACTIONS(3060),
    [anon_sym_for] = ACTIONS(3060),
    [anon_sym_return] = ACTIONS(3060),
    [anon_sym_break] = ACTIONS(3060),
    [anon_sym_continue] = ACTIONS(3060),
    [anon_sym_goto] = ACTIONS(3060),
    [anon_sym_not] = ACTIONS(3060),
    [anon_sym_compl] = ACTIONS(3060),
    [anon_sym_DASH_DASH] = ACTIONS(3062),
    [anon_sym_PLUS_PLUS] = ACTIONS(3062),
    [anon_sym_sizeof] = ACTIONS(3060),
    [anon_sym___alignof__] = ACTIONS(3060),
    [anon_sym___alignof] = ACTIONS(3060),
    [anon_sym__alignof] = ACTIONS(3060),
    [anon_sym_alignof] = ACTIONS(3060),
    [anon_sym__Alignof] = ACTIONS(3060),
    [anon_sym_offsetof] = ACTIONS(3060),
    [anon_sym__Generic] = ACTIONS(3060),
    [anon_sym_asm] = ACTIONS(3060),
    [anon_sym___asm__] = ACTIONS(3060),
    [anon_sym___asm] = ACTIONS(3060),
    [sym_number_literal] = ACTIONS(3062),
    [anon_sym_L_SQUOTE] = ACTIONS(3062),
    [anon_sym_u_SQUOTE] = ACTIONS(3062),
    [anon_sym_U_SQUOTE] = ACTIONS(3062),
    [anon_sym_u8_SQUOTE] = ACTIONS(3062),
    [anon_sym_SQUOTE] = ACTIONS(3062),
    [anon_sym_L_DQUOTE] = ACTIONS(3062),
    [anon_sym_u_DQUOTE] = ACTIONS(3062),
    [anon_sym_U_DQUOTE] = ACTIONS(3062),
    [anon_sym_u8_DQUOTE] = ACTIONS(3062),
    [anon_sym_DQUOTE] = ACTIONS(3062),
    [sym_true] = ACTIONS(3060),
    [sym_false] = ACTIONS(3060),
    [anon_sym_NULL] = ACTIONS(3060),
    [anon_sym_nullptr] = ACTIONS(3060),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3060),
    [anon_sym_decltype] = ACTIONS(3060),
    [anon_sym_explicit] = ACTIONS(3060),
    [anon_sym_typename] = ACTIONS(3060),
    [anon_sym_template] = ACTIONS(3060),
    [anon_sym_operator] = ACTIONS(3060),
    [anon_sym_try] = ACTIONS(3060),
    [anon_sym_delete] = ACTIONS(3060),
    [anon_sym_throw] = ACTIONS(3060),
    [anon_sym_namespace] = ACTIONS(3060),
    [anon_sym_using] = ACTIONS(3060),
    [anon_sym_static_assert] = ACTIONS(3060),
    [anon_sym_concept] = ACTIONS(3060),
    [anon_sym_co_return] = ACTIONS(3060),
    [anon_sym_co_yield] = ACTIONS(3060),
    [anon_sym_R_DQUOTE] = ACTIONS(3062),
    [anon_sym_LR_DQUOTE] = ACTIONS(3062),
    [anon_sym_uR_DQUOTE] = ACTIONS(3062),
    [anon_sym_UR_DQUOTE] = ACTIONS(3062),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3062),
    [anon_sym_co_await] = ACTIONS(3060),
    [anon_sym_new] = ACTIONS(3060),
    [anon_sym_requires] = ACTIONS(3060),
    [sym_this] = ACTIONS(3060),
  },
  [690] = {
    [ts_builtin_sym_end] = ACTIONS(3066),
    [sym_identifier] = ACTIONS(3064),
    [aux_sym_preproc_include_token1] = ACTIONS(3064),
    [aux_sym_preproc_def_token1] = ACTIONS(3064),
    [aux_sym_preproc_if_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3064),
    [sym_preproc_directive] = ACTIONS(3064),
    [anon_sym_LPAREN2] = ACTIONS(3066),
    [anon_sym_BANG] = ACTIONS(3066),
    [anon_sym_TILDE] = ACTIONS(3066),
    [anon_sym_DASH] = ACTIONS(3064),
    [anon_sym_PLUS] = ACTIONS(3064),
    [anon_sym_STAR] = ACTIONS(3066),
    [anon_sym_AMP_AMP] = ACTIONS(3066),
    [anon_sym_AMP] = ACTIONS(3064),
    [anon_sym_SEMI] = ACTIONS(3066),
    [anon_sym___extension__] = ACTIONS(3064),
    [anon_sym_typedef] = ACTIONS(3064),
    [anon_sym_virtual] = ACTIONS(3064),
    [anon_sym_extern] = ACTIONS(3064),
    [anon_sym___attribute__] = ACTIONS(3064),
    [anon_sym___attribute] = ACTIONS(3064),
    [anon_sym_COLON_COLON] = ACTIONS(3066),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3066),
    [anon_sym___declspec] = ACTIONS(3064),
    [anon_sym___based] = ACTIONS(3064),
    [anon_sym___cdecl] = ACTIONS(3064),
    [anon_sym___clrcall] = ACTIONS(3064),
    [anon_sym___stdcall] = ACTIONS(3064),
    [anon_sym___fastcall] = ACTIONS(3064),
    [anon_sym___thiscall] = ACTIONS(3064),
    [anon_sym___vectorcall] = ACTIONS(3064),
    [anon_sym_LBRACE] = ACTIONS(3066),
    [anon_sym_signed] = ACTIONS(3064),
    [anon_sym_unsigned] = ACTIONS(3064),
    [anon_sym_long] = ACTIONS(3064),
    [anon_sym_short] = ACTIONS(3064),
    [anon_sym_LBRACK] = ACTIONS(3064),
    [anon_sym_static] = ACTIONS(3064),
    [anon_sym_register] = ACTIONS(3064),
    [anon_sym_inline] = ACTIONS(3064),
    [anon_sym___inline] = ACTIONS(3064),
    [anon_sym___inline__] = ACTIONS(3064),
    [anon_sym___forceinline] = ACTIONS(3064),
    [anon_sym_thread_local] = ACTIONS(3064),
    [anon_sym___thread] = ACTIONS(3064),
    [anon_sym_const] = ACTIONS(3064),
    [anon_sym_constexpr] = ACTIONS(3064),
    [anon_sym_volatile] = ACTIONS(3064),
    [anon_sym_restrict] = ACTIONS(3064),
    [anon_sym___restrict__] = ACTIONS(3064),
    [anon_sym__Atomic] = ACTIONS(3064),
    [anon_sym__Noreturn] = ACTIONS(3064),
    [anon_sym_noreturn] = ACTIONS(3064),
    [anon_sym__Nonnull] = ACTIONS(3064),
    [anon_sym_mutable] = ACTIONS(3064),
    [anon_sym_constinit] = ACTIONS(3064),
    [anon_sym_consteval] = ACTIONS(3064),
    [anon_sym_alignas] = ACTIONS(3064),
    [anon_sym__Alignas] = ACTIONS(3064),
    [sym_primitive_type] = ACTIONS(3064),
    [anon_sym_enum] = ACTIONS(3064),
    [anon_sym_class] = ACTIONS(3064),
    [anon_sym_struct] = ACTIONS(3064),
    [anon_sym_union] = ACTIONS(3064),
    [anon_sym_if] = ACTIONS(3064),
    [anon_sym_switch] = ACTIONS(3064),
    [anon_sym_case] = ACTIONS(3064),
    [anon_sym_default] = ACTIONS(3064),
    [anon_sym_while] = ACTIONS(3064),
    [anon_sym_do] = ACTIONS(3064),
    [anon_sym_for] = ACTIONS(3064),
    [anon_sym_return] = ACTIONS(3064),
    [anon_sym_break] = ACTIONS(3064),
    [anon_sym_continue] = ACTIONS(3064),
    [anon_sym_goto] = ACTIONS(3064),
    [anon_sym_not] = ACTIONS(3064),
    [anon_sym_compl] = ACTIONS(3064),
    [anon_sym_DASH_DASH] = ACTIONS(3066),
    [anon_sym_PLUS_PLUS] = ACTIONS(3066),
    [anon_sym_sizeof] = ACTIONS(3064),
    [anon_sym___alignof__] = ACTIONS(3064),
    [anon_sym___alignof] = ACTIONS(3064),
    [anon_sym__alignof] = ACTIONS(3064),
    [anon_sym_alignof] = ACTIONS(3064),
    [anon_sym__Alignof] = ACTIONS(3064),
    [anon_sym_offsetof] = ACTIONS(3064),
    [anon_sym__Generic] = ACTIONS(3064),
    [anon_sym_asm] = ACTIONS(3064),
    [anon_sym___asm__] = ACTIONS(3064),
    [anon_sym___asm] = ACTIONS(3064),
    [sym_number_literal] = ACTIONS(3066),
    [anon_sym_L_SQUOTE] = ACTIONS(3066),
    [anon_sym_u_SQUOTE] = ACTIONS(3066),
    [anon_sym_U_SQUOTE] = ACTIONS(3066),
    [anon_sym_u8_SQUOTE] = ACTIONS(3066),
    [anon_sym_SQUOTE] = ACTIONS(3066),
    [anon_sym_L_DQUOTE] = ACTIONS(3066),
    [anon_sym_u_DQUOTE] = ACTIONS(3066),
    [anon_sym_U_DQUOTE] = ACTIONS(3066),
    [anon_sym_u8_DQUOTE] = ACTIONS(3066),
    [anon_sym_DQUOTE] = ACTIONS(3066),
    [sym_true] = ACTIONS(3064),
    [sym_false] = ACTIONS(3064),
    [anon_sym_NULL] = ACTIONS(3064),
    [anon_sym_nullptr] = ACTIONS(3064),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3064),
    [anon_sym_decltype] = ACTIONS(3064),
    [anon_sym_explicit] = ACTIONS(3064),
    [anon_sym_typename] = ACTIONS(3064),
    [anon_sym_template] = ACTIONS(3064),
    [anon_sym_operator] = ACTIONS(3064),
    [anon_sym_try] = ACTIONS(3064),
    [anon_sym_delete] = ACTIONS(3064),
    [anon_sym_throw] = ACTIONS(3064),
    [anon_sym_namespace] = ACTIONS(3064),
    [anon_sym_using] = ACTIONS(3064),
    [anon_sym_static_assert] = ACTIONS(3064),
    [anon_sym_concept] = ACTIONS(3064),
    [anon_sym_co_return] = ACTIONS(3064),
    [anon_sym_co_yield] = ACTIONS(3064),
    [anon_sym_R_DQUOTE] = ACTIONS(3066),
    [anon_sym_LR_DQUOTE] = ACTIONS(3066),
    [anon_sym_uR_DQUOTE] = ACTIONS(3066),
    [anon_sym_UR_DQUOTE] = ACTIONS(3066),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3066),
    [anon_sym_co_await] = ACTIONS(3064),
    [anon_sym_new] = ACTIONS(3064),
    [anon_sym_requires] = ACTIONS(3064),
    [sym_this] = ACTIONS(3064),
  },
  [691] = {
    [ts_builtin_sym_end] = ACTIONS(3070),
    [sym_identifier] = ACTIONS(3068),
    [aux_sym_preproc_include_token1] = ACTIONS(3068),
    [aux_sym_preproc_def_token1] = ACTIONS(3068),
    [aux_sym_preproc_if_token1] = ACTIONS(3068),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3068),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3068),
    [sym_preproc_directive] = ACTIONS(3068),
    [anon_sym_LPAREN2] = ACTIONS(3070),
    [anon_sym_BANG] = ACTIONS(3070),
    [anon_sym_TILDE] = ACTIONS(3070),
    [anon_sym_DASH] = ACTIONS(3068),
    [anon_sym_PLUS] = ACTIONS(3068),
    [anon_sym_STAR] = ACTIONS(3070),
    [anon_sym_AMP_AMP] = ACTIONS(3070),
    [anon_sym_AMP] = ACTIONS(3068),
    [anon_sym_SEMI] = ACTIONS(3070),
    [anon_sym___extension__] = ACTIONS(3068),
    [anon_sym_typedef] = ACTIONS(3068),
    [anon_sym_virtual] = ACTIONS(3068),
    [anon_sym_extern] = ACTIONS(3068),
    [anon_sym___attribute__] = ACTIONS(3068),
    [anon_sym___attribute] = ACTIONS(3068),
    [anon_sym_COLON_COLON] = ACTIONS(3070),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3070),
    [anon_sym___declspec] = ACTIONS(3068),
    [anon_sym___based] = ACTIONS(3068),
    [anon_sym___cdecl] = ACTIONS(3068),
    [anon_sym___clrcall] = ACTIONS(3068),
    [anon_sym___stdcall] = ACTIONS(3068),
    [anon_sym___fastcall] = ACTIONS(3068),
    [anon_sym___thiscall] = ACTIONS(3068),
    [anon_sym___vectorcall] = ACTIONS(3068),
    [anon_sym_LBRACE] = ACTIONS(3070),
    [anon_sym_signed] = ACTIONS(3068),
    [anon_sym_unsigned] = ACTIONS(3068),
    [anon_sym_long] = ACTIONS(3068),
    [anon_sym_short] = ACTIONS(3068),
    [anon_sym_LBRACK] = ACTIONS(3068),
    [anon_sym_static] = ACTIONS(3068),
    [anon_sym_register] = ACTIONS(3068),
    [anon_sym_inline] = ACTIONS(3068),
    [anon_sym___inline] = ACTIONS(3068),
    [anon_sym___inline__] = ACTIONS(3068),
    [anon_sym___forceinline] = ACTIONS(3068),
    [anon_sym_thread_local] = ACTIONS(3068),
    [anon_sym___thread] = ACTIONS(3068),
    [anon_sym_const] = ACTIONS(3068),
    [anon_sym_constexpr] = ACTIONS(3068),
    [anon_sym_volatile] = ACTIONS(3068),
    [anon_sym_restrict] = ACTIONS(3068),
    [anon_sym___restrict__] = ACTIONS(3068),
    [anon_sym__Atomic] = ACTIONS(3068),
    [anon_sym__Noreturn] = ACTIONS(3068),
    [anon_sym_noreturn] = ACTIONS(3068),
    [anon_sym__Nonnull] = ACTIONS(3068),
    [anon_sym_mutable] = ACTIONS(3068),
    [anon_sym_constinit] = ACTIONS(3068),
    [anon_sym_consteval] = ACTIONS(3068),
    [anon_sym_alignas] = ACTIONS(3068),
    [anon_sym__Alignas] = ACTIONS(3068),
    [sym_primitive_type] = ACTIONS(3068),
    [anon_sym_enum] = ACTIONS(3068),
    [anon_sym_class] = ACTIONS(3068),
    [anon_sym_struct] = ACTIONS(3068),
    [anon_sym_union] = ACTIONS(3068),
    [anon_sym_if] = ACTIONS(3068),
    [anon_sym_switch] = ACTIONS(3068),
    [anon_sym_case] = ACTIONS(3068),
    [anon_sym_default] = ACTIONS(3068),
    [anon_sym_while] = ACTIONS(3068),
    [anon_sym_do] = ACTIONS(3068),
    [anon_sym_for] = ACTIONS(3068),
    [anon_sym_return] = ACTIONS(3068),
    [anon_sym_break] = ACTIONS(3068),
    [anon_sym_continue] = ACTIONS(3068),
    [anon_sym_goto] = ACTIONS(3068),
    [anon_sym_not] = ACTIONS(3068),
    [anon_sym_compl] = ACTIONS(3068),
    [anon_sym_DASH_DASH] = ACTIONS(3070),
    [anon_sym_PLUS_PLUS] = ACTIONS(3070),
    [anon_sym_sizeof] = ACTIONS(3068),
    [anon_sym___alignof__] = ACTIONS(3068),
    [anon_sym___alignof] = ACTIONS(3068),
    [anon_sym__alignof] = ACTIONS(3068),
    [anon_sym_alignof] = ACTIONS(3068),
    [anon_sym__Alignof] = ACTIONS(3068),
    [anon_sym_offsetof] = ACTIONS(3068),
    [anon_sym__Generic] = ACTIONS(3068),
    [anon_sym_asm] = ACTIONS(3068),
    [anon_sym___asm__] = ACTIONS(3068),
    [anon_sym___asm] = ACTIONS(3068),
    [sym_number_literal] = ACTIONS(3070),
    [anon_sym_L_SQUOTE] = ACTIONS(3070),
    [anon_sym_u_SQUOTE] = ACTIONS(3070),
    [anon_sym_U_SQUOTE] = ACTIONS(3070),
    [anon_sym_u8_SQUOTE] = ACTIONS(3070),
    [anon_sym_SQUOTE] = ACTIONS(3070),
    [anon_sym_L_DQUOTE] = ACTIONS(3070),
    [anon_sym_u_DQUOTE] = ACTIONS(3070),
    [anon_sym_U_DQUOTE] = ACTIONS(3070),
    [anon_sym_u8_DQUOTE] = ACTIONS(3070),
    [anon_sym_DQUOTE] = ACTIONS(3070),
    [sym_true] = ACTIONS(3068),
    [sym_false] = ACTIONS(3068),
    [anon_sym_NULL] = ACTIONS(3068),
    [anon_sym_nullptr] = ACTIONS(3068),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3068),
    [anon_sym_decltype] = ACTIONS(3068),
    [anon_sym_explicit] = ACTIONS(3068),
    [anon_sym_typename] = ACTIONS(3068),
    [anon_sym_template] = ACTIONS(3068),
    [anon_sym_operator] = ACTIONS(3068),
    [anon_sym_try] = ACTIONS(3068),
    [anon_sym_delete] = ACTIONS(3068),
    [anon_sym_throw] = ACTIONS(3068),
    [anon_sym_namespace] = ACTIONS(3068),
    [anon_sym_using] = ACTIONS(3068),
    [anon_sym_static_assert] = ACTIONS(3068),
    [anon_sym_concept] = ACTIONS(3068),
    [anon_sym_co_return] = ACTIONS(3068),
    [anon_sym_co_yield] = ACTIONS(3068),
    [anon_sym_R_DQUOTE] = ACTIONS(3070),
    [anon_sym_LR_DQUOTE] = ACTIONS(3070),
    [anon_sym_uR_DQUOTE] = ACTIONS(3070),
    [anon_sym_UR_DQUOTE] = ACTIONS(3070),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3070),
    [anon_sym_co_await] = ACTIONS(3068),
    [anon_sym_new] = ACTIONS(3068),
    [anon_sym_requires] = ACTIONS(3068),
    [sym_this] = ACTIONS(3068),
  },
  [692] = {
    [ts_builtin_sym_end] = ACTIONS(3074),
    [sym_identifier] = ACTIONS(3072),
    [aux_sym_preproc_include_token1] = ACTIONS(3072),
    [aux_sym_preproc_def_token1] = ACTIONS(3072),
    [aux_sym_preproc_if_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3072),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3072),
    [sym_preproc_directive] = ACTIONS(3072),
    [anon_sym_LPAREN2] = ACTIONS(3074),
    [anon_sym_BANG] = ACTIONS(3074),
    [anon_sym_TILDE] = ACTIONS(3074),
    [anon_sym_DASH] = ACTIONS(3072),
    [anon_sym_PLUS] = ACTIONS(3072),
    [anon_sym_STAR] = ACTIONS(3074),
    [anon_sym_AMP_AMP] = ACTIONS(3074),
    [anon_sym_AMP] = ACTIONS(3072),
    [anon_sym_SEMI] = ACTIONS(3074),
    [anon_sym___extension__] = ACTIONS(3072),
    [anon_sym_typedef] = ACTIONS(3072),
    [anon_sym_virtual] = ACTIONS(3072),
    [anon_sym_extern] = ACTIONS(3072),
    [anon_sym___attribute__] = ACTIONS(3072),
    [anon_sym___attribute] = ACTIONS(3072),
    [anon_sym_COLON_COLON] = ACTIONS(3074),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3074),
    [anon_sym___declspec] = ACTIONS(3072),
    [anon_sym___based] = ACTIONS(3072),
    [anon_sym___cdecl] = ACTIONS(3072),
    [anon_sym___clrcall] = ACTIONS(3072),
    [anon_sym___stdcall] = ACTIONS(3072),
    [anon_sym___fastcall] = ACTIONS(3072),
    [anon_sym___thiscall] = ACTIONS(3072),
    [anon_sym___vectorcall] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(3074),
    [anon_sym_signed] = ACTIONS(3072),
    [anon_sym_unsigned] = ACTIONS(3072),
    [anon_sym_long] = ACTIONS(3072),
    [anon_sym_short] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_static] = ACTIONS(3072),
    [anon_sym_register] = ACTIONS(3072),
    [anon_sym_inline] = ACTIONS(3072),
    [anon_sym___inline] = ACTIONS(3072),
    [anon_sym___inline__] = ACTIONS(3072),
    [anon_sym___forceinline] = ACTIONS(3072),
    [anon_sym_thread_local] = ACTIONS(3072),
    [anon_sym___thread] = ACTIONS(3072),
    [anon_sym_const] = ACTIONS(3072),
    [anon_sym_constexpr] = ACTIONS(3072),
    [anon_sym_volatile] = ACTIONS(3072),
    [anon_sym_restrict] = ACTIONS(3072),
    [anon_sym___restrict__] = ACTIONS(3072),
    [anon_sym__Atomic] = ACTIONS(3072),
    [anon_sym__Noreturn] = ACTIONS(3072),
    [anon_sym_noreturn] = ACTIONS(3072),
    [anon_sym__Nonnull] = ACTIONS(3072),
    [anon_sym_mutable] = ACTIONS(3072),
    [anon_sym_constinit] = ACTIONS(3072),
    [anon_sym_consteval] = ACTIONS(3072),
    [anon_sym_alignas] = ACTIONS(3072),
    [anon_sym__Alignas] = ACTIONS(3072),
    [sym_primitive_type] = ACTIONS(3072),
    [anon_sym_enum] = ACTIONS(3072),
    [anon_sym_class] = ACTIONS(3072),
    [anon_sym_struct] = ACTIONS(3072),
    [anon_sym_union] = ACTIONS(3072),
    [anon_sym_if] = ACTIONS(3072),
    [anon_sym_switch] = ACTIONS(3072),
    [anon_sym_case] = ACTIONS(3072),
    [anon_sym_default] = ACTIONS(3072),
    [anon_sym_while] = ACTIONS(3072),
    [anon_sym_do] = ACTIONS(3072),
    [anon_sym_for] = ACTIONS(3072),
    [anon_sym_return] = ACTIONS(3072),
    [anon_sym_break] = ACTIONS(3072),
    [anon_sym_continue] = ACTIONS(3072),
    [anon_sym_goto] = ACTIONS(3072),
    [anon_sym_not] = ACTIONS(3072),
    [anon_sym_compl] = ACTIONS(3072),
    [anon_sym_DASH_DASH] = ACTIONS(3074),
    [anon_sym_PLUS_PLUS] = ACTIONS(3074),
    [anon_sym_sizeof] = ACTIONS(3072),
    [anon_sym___alignof__] = ACTIONS(3072),
    [anon_sym___alignof] = ACTIONS(3072),
    [anon_sym__alignof] = ACTIONS(3072),
    [anon_sym_alignof] = ACTIONS(3072),
    [anon_sym__Alignof] = ACTIONS(3072),
    [anon_sym_offsetof] = ACTIONS(3072),
    [anon_sym__Generic] = ACTIONS(3072),
    [anon_sym_asm] = ACTIONS(3072),
    [anon_sym___asm__] = ACTIONS(3072),
    [anon_sym___asm] = ACTIONS(3072),
    [sym_number_literal] = ACTIONS(3074),
    [anon_sym_L_SQUOTE] = ACTIONS(3074),
    [anon_sym_u_SQUOTE] = ACTIONS(3074),
    [anon_sym_U_SQUOTE] = ACTIONS(3074),
    [anon_sym_u8_SQUOTE] = ACTIONS(3074),
    [anon_sym_SQUOTE] = ACTIONS(3074),
    [anon_sym_L_DQUOTE] = ACTIONS(3074),
    [anon_sym_u_DQUOTE] = ACTIONS(3074),
    [anon_sym_U_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8_DQUOTE] = ACTIONS(3074),
    [anon_sym_DQUOTE] = ACTIONS(3074),
    [sym_true] = ACTIONS(3072),
    [sym_false] = ACTIONS(3072),
    [anon_sym_NULL] = ACTIONS(3072),
    [anon_sym_nullptr] = ACTIONS(3072),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3072),
    [anon_sym_decltype] = ACTIONS(3072),
    [anon_sym_explicit] = ACTIONS(3072),
    [anon_sym_typename] = ACTIONS(3072),
    [anon_sym_template] = ACTIONS(3072),
    [anon_sym_operator] = ACTIONS(3072),
    [anon_sym_try] = ACTIONS(3072),
    [anon_sym_delete] = ACTIONS(3072),
    [anon_sym_throw] = ACTIONS(3072),
    [anon_sym_namespace] = ACTIONS(3072),
    [anon_sym_using] = ACTIONS(3072),
    [anon_sym_static_assert] = ACTIONS(3072),
    [anon_sym_concept] = ACTIONS(3072),
    [anon_sym_co_return] = ACTIONS(3072),
    [anon_sym_co_yield] = ACTIONS(3072),
    [anon_sym_R_DQUOTE] = ACTIONS(3074),
    [anon_sym_LR_DQUOTE] = ACTIONS(3074),
    [anon_sym_uR_DQUOTE] = ACTIONS(3074),
    [anon_sym_UR_DQUOTE] = ACTIONS(3074),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3074),
    [anon_sym_co_await] = ACTIONS(3072),
    [anon_sym_new] = ACTIONS(3072),
    [anon_sym_requires] = ACTIONS(3072),
    [sym_this] = ACTIONS(3072),
  },
  [693] = {
    [ts_builtin_sym_end] = ACTIONS(3078),
    [sym_identifier] = ACTIONS(3076),
    [aux_sym_preproc_include_token1] = ACTIONS(3076),
    [aux_sym_preproc_def_token1] = ACTIONS(3076),
    [aux_sym_preproc_if_token1] = ACTIONS(3076),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3076),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3076),
    [sym_preproc_directive] = ACTIONS(3076),
    [anon_sym_LPAREN2] = ACTIONS(3078),
    [anon_sym_BANG] = ACTIONS(3078),
    [anon_sym_TILDE] = ACTIONS(3078),
    [anon_sym_DASH] = ACTIONS(3076),
    [anon_sym_PLUS] = ACTIONS(3076),
    [anon_sym_STAR] = ACTIONS(3078),
    [anon_sym_AMP_AMP] = ACTIONS(3078),
    [anon_sym_AMP] = ACTIONS(3076),
    [anon_sym_SEMI] = ACTIONS(3078),
    [anon_sym___extension__] = ACTIONS(3076),
    [anon_sym_typedef] = ACTIONS(3076),
    [anon_sym_virtual] = ACTIONS(3076),
    [anon_sym_extern] = ACTIONS(3076),
    [anon_sym___attribute__] = ACTIONS(3076),
    [anon_sym___attribute] = ACTIONS(3076),
    [anon_sym_COLON_COLON] = ACTIONS(3078),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3078),
    [anon_sym___declspec] = ACTIONS(3076),
    [anon_sym___based] = ACTIONS(3076),
    [anon_sym___cdecl] = ACTIONS(3076),
    [anon_sym___clrcall] = ACTIONS(3076),
    [anon_sym___stdcall] = ACTIONS(3076),
    [anon_sym___fastcall] = ACTIONS(3076),
    [anon_sym___thiscall] = ACTIONS(3076),
    [anon_sym___vectorcall] = ACTIONS(3076),
    [anon_sym_LBRACE] = ACTIONS(3078),
    [anon_sym_signed] = ACTIONS(3076),
    [anon_sym_unsigned] = ACTIONS(3076),
    [anon_sym_long] = ACTIONS(3076),
    [anon_sym_short] = ACTIONS(3076),
    [anon_sym_LBRACK] = ACTIONS(3076),
    [anon_sym_static] = ACTIONS(3076),
    [anon_sym_register] = ACTIONS(3076),
    [anon_sym_inline] = ACTIONS(3076),
    [anon_sym___inline] = ACTIONS(3076),
    [anon_sym___inline__] = ACTIONS(3076),
    [anon_sym___forceinline] = ACTIONS(3076),
    [anon_sym_thread_local] = ACTIONS(3076),
    [anon_sym___thread] = ACTIONS(3076),
    [anon_sym_const] = ACTIONS(3076),
    [anon_sym_constexpr] = ACTIONS(3076),
    [anon_sym_volatile] = ACTIONS(3076),
    [anon_sym_restrict] = ACTIONS(3076),
    [anon_sym___restrict__] = ACTIONS(3076),
    [anon_sym__Atomic] = ACTIONS(3076),
    [anon_sym__Noreturn] = ACTIONS(3076),
    [anon_sym_noreturn] = ACTIONS(3076),
    [anon_sym__Nonnull] = ACTIONS(3076),
    [anon_sym_mutable] = ACTIONS(3076),
    [anon_sym_constinit] = ACTIONS(3076),
    [anon_sym_consteval] = ACTIONS(3076),
    [anon_sym_alignas] = ACTIONS(3076),
    [anon_sym__Alignas] = ACTIONS(3076),
    [sym_primitive_type] = ACTIONS(3076),
    [anon_sym_enum] = ACTIONS(3076),
    [anon_sym_class] = ACTIONS(3076),
    [anon_sym_struct] = ACTIONS(3076),
    [anon_sym_union] = ACTIONS(3076),
    [anon_sym_if] = ACTIONS(3076),
    [anon_sym_switch] = ACTIONS(3076),
    [anon_sym_case] = ACTIONS(3076),
    [anon_sym_default] = ACTIONS(3076),
    [anon_sym_while] = ACTIONS(3076),
    [anon_sym_do] = ACTIONS(3076),
    [anon_sym_for] = ACTIONS(3076),
    [anon_sym_return] = ACTIONS(3076),
    [anon_sym_break] = ACTIONS(3076),
    [anon_sym_continue] = ACTIONS(3076),
    [anon_sym_goto] = ACTIONS(3076),
    [anon_sym_not] = ACTIONS(3076),
    [anon_sym_compl] = ACTIONS(3076),
    [anon_sym_DASH_DASH] = ACTIONS(3078),
    [anon_sym_PLUS_PLUS] = ACTIONS(3078),
    [anon_sym_sizeof] = ACTIONS(3076),
    [anon_sym___alignof__] = ACTIONS(3076),
    [anon_sym___alignof] = ACTIONS(3076),
    [anon_sym__alignof] = ACTIONS(3076),
    [anon_sym_alignof] = ACTIONS(3076),
    [anon_sym__Alignof] = ACTIONS(3076),
    [anon_sym_offsetof] = ACTIONS(3076),
    [anon_sym__Generic] = ACTIONS(3076),
    [anon_sym_asm] = ACTIONS(3076),
    [anon_sym___asm__] = ACTIONS(3076),
    [anon_sym___asm] = ACTIONS(3076),
    [sym_number_literal] = ACTIONS(3078),
    [anon_sym_L_SQUOTE] = ACTIONS(3078),
    [anon_sym_u_SQUOTE] = ACTIONS(3078),
    [anon_sym_U_SQUOTE] = ACTIONS(3078),
    [anon_sym_u8_SQUOTE] = ACTIONS(3078),
    [anon_sym_SQUOTE] = ACTIONS(3078),
    [anon_sym_L_DQUOTE] = ACTIONS(3078),
    [anon_sym_u_DQUOTE] = ACTIONS(3078),
    [anon_sym_U_DQUOTE] = ACTIONS(3078),
    [anon_sym_u8_DQUOTE] = ACTIONS(3078),
    [anon_sym_DQUOTE] = ACTIONS(3078),
    [sym_true] = ACTIONS(3076),
    [sym_false] = ACTIONS(3076),
    [anon_sym_NULL] = ACTIONS(3076),
    [anon_sym_nullptr] = ACTIONS(3076),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3076),
    [anon_sym_decltype] = ACTIONS(3076),
    [anon_sym_explicit] = ACTIONS(3076),
    [anon_sym_typename] = ACTIONS(3076),
    [anon_sym_template] = ACTIONS(3076),
    [anon_sym_operator] = ACTIONS(3076),
    [anon_sym_try] = ACTIONS(3076),
    [anon_sym_delete] = ACTIONS(3076),
    [anon_sym_throw] = ACTIONS(3076),
    [anon_sym_namespace] = ACTIONS(3076),
    [anon_sym_using] = ACTIONS(3076),
    [anon_sym_static_assert] = ACTIONS(3076),
    [anon_sym_concept] = ACTIONS(3076),
    [anon_sym_co_return] = ACTIONS(3076),
    [anon_sym_co_yield] = ACTIONS(3076),
    [anon_sym_R_DQUOTE] = ACTIONS(3078),
    [anon_sym_LR_DQUOTE] = ACTIONS(3078),
    [anon_sym_uR_DQUOTE] = ACTIONS(3078),
    [anon_sym_UR_DQUOTE] = ACTIONS(3078),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3078),
    [anon_sym_co_await] = ACTIONS(3076),
    [anon_sym_new] = ACTIONS(3076),
    [anon_sym_requires] = ACTIONS(3076),
    [sym_this] = ACTIONS(3076),
  },
  [694] = {
    [ts_builtin_sym_end] = ACTIONS(3084),
    [sym_identifier] = ACTIONS(3082),
    [aux_sym_preproc_include_token1] = ACTIONS(3082),
    [aux_sym_preproc_def_token1] = ACTIONS(3082),
    [aux_sym_preproc_if_token1] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3082),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3082),
    [sym_preproc_directive] = ACTIONS(3082),
    [anon_sym_LPAREN2] = ACTIONS(3084),
    [anon_sym_BANG] = ACTIONS(3084),
    [anon_sym_TILDE] = ACTIONS(3084),
    [anon_sym_DASH] = ACTIONS(3082),
    [anon_sym_PLUS] = ACTIONS(3082),
    [anon_sym_STAR] = ACTIONS(3084),
    [anon_sym_AMP_AMP] = ACTIONS(3084),
    [anon_sym_AMP] = ACTIONS(3082),
    [anon_sym_SEMI] = ACTIONS(3084),
    [anon_sym___extension__] = ACTIONS(3082),
    [anon_sym_typedef] = ACTIONS(3082),
    [anon_sym_virtual] = ACTIONS(3082),
    [anon_sym_extern] = ACTIONS(3082),
    [anon_sym___attribute__] = ACTIONS(3082),
    [anon_sym___attribute] = ACTIONS(3082),
    [anon_sym_COLON_COLON] = ACTIONS(3084),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3084),
    [anon_sym___declspec] = ACTIONS(3082),
    [anon_sym___based] = ACTIONS(3082),
    [anon_sym___cdecl] = ACTIONS(3082),
    [anon_sym___clrcall] = ACTIONS(3082),
    [anon_sym___stdcall] = ACTIONS(3082),
    [anon_sym___fastcall] = ACTIONS(3082),
    [anon_sym___thiscall] = ACTIONS(3082),
    [anon_sym___vectorcall] = ACTIONS(3082),
    [anon_sym_LBRACE] = ACTIONS(3084),
    [anon_sym_signed] = ACTIONS(3082),
    [anon_sym_unsigned] = ACTIONS(3082),
    [anon_sym_long] = ACTIONS(3082),
    [anon_sym_short] = ACTIONS(3082),
    [anon_sym_LBRACK] = ACTIONS(3082),
    [anon_sym_static] = ACTIONS(3082),
    [anon_sym_register] = ACTIONS(3082),
    [anon_sym_inline] = ACTIONS(3082),
    [anon_sym___inline] = ACTIONS(3082),
    [anon_sym___inline__] = ACTIONS(3082),
    [anon_sym___forceinline] = ACTIONS(3082),
    [anon_sym_thread_local] = ACTIONS(3082),
    [anon_sym___thread] = ACTIONS(3082),
    [anon_sym_const] = ACTIONS(3082),
    [anon_sym_constexpr] = ACTIONS(3082),
    [anon_sym_volatile] = ACTIONS(3082),
    [anon_sym_restrict] = ACTIONS(3082),
    [anon_sym___restrict__] = ACTIONS(3082),
    [anon_sym__Atomic] = ACTIONS(3082),
    [anon_sym__Noreturn] = ACTIONS(3082),
    [anon_sym_noreturn] = ACTIONS(3082),
    [anon_sym__Nonnull] = ACTIONS(3082),
    [anon_sym_mutable] = ACTIONS(3082),
    [anon_sym_constinit] = ACTIONS(3082),
    [anon_sym_consteval] = ACTIONS(3082),
    [anon_sym_alignas] = ACTIONS(3082),
    [anon_sym__Alignas] = ACTIONS(3082),
    [sym_primitive_type] = ACTIONS(3082),
    [anon_sym_enum] = ACTIONS(3082),
    [anon_sym_class] = ACTIONS(3082),
    [anon_sym_struct] = ACTIONS(3082),
    [anon_sym_union] = ACTIONS(3082),
    [anon_sym_if] = ACTIONS(3082),
    [anon_sym_switch] = ACTIONS(3082),
    [anon_sym_case] = ACTIONS(3082),
    [anon_sym_default] = ACTIONS(3082),
    [anon_sym_while] = ACTIONS(3082),
    [anon_sym_do] = ACTIONS(3082),
    [anon_sym_for] = ACTIONS(3082),
    [anon_sym_return] = ACTIONS(3082),
    [anon_sym_break] = ACTIONS(3082),
    [anon_sym_continue] = ACTIONS(3082),
    [anon_sym_goto] = ACTIONS(3082),
    [anon_sym_not] = ACTIONS(3082),
    [anon_sym_compl] = ACTIONS(3082),
    [anon_sym_DASH_DASH] = ACTIONS(3084),
    [anon_sym_PLUS_PLUS] = ACTIONS(3084),
    [anon_sym_sizeof] = ACTIONS(3082),
    [anon_sym___alignof__] = ACTIONS(3082),
    [anon_sym___alignof] = ACTIONS(3082),
    [anon_sym__alignof] = ACTIONS(3082),
    [anon_sym_alignof] = ACTIONS(3082),
    [anon_sym__Alignof] = ACTIONS(3082),
    [anon_sym_offsetof] = ACTIONS(3082),
    [anon_sym__Generic] = ACTIONS(3082),
    [anon_sym_asm] = ACTIONS(3082),
    [anon_sym___asm__] = ACTIONS(3082),
    [anon_sym___asm] = ACTIONS(3082),
    [sym_number_literal] = ACTIONS(3084),
    [anon_sym_L_SQUOTE] = ACTIONS(3084),
    [anon_sym_u_SQUOTE] = ACTIONS(3084),
    [anon_sym_U_SQUOTE] = ACTIONS(3084),
    [anon_sym_u8_SQUOTE] = ACTIONS(3084),
    [anon_sym_SQUOTE] = ACTIONS(3084),
    [anon_sym_L_DQUOTE] = ACTIONS(3084),
    [anon_sym_u_DQUOTE] = ACTIONS(3084),
    [anon_sym_U_DQUOTE] = ACTIONS(3084),
    [anon_sym_u8_DQUOTE] = ACTIONS(3084),
    [anon_sym_DQUOTE] = ACTIONS(3084),
    [sym_true] = ACTIONS(3082),
    [sym_false] = ACTIONS(3082),
    [anon_sym_NULL] = ACTIONS(3082),
    [anon_sym_nullptr] = ACTIONS(3082),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3082),
    [anon_sym_decltype] = ACTIONS(3082),
    [anon_sym_explicit] = ACTIONS(3082),
    [anon_sym_typename] = ACTIONS(3082),
    [anon_sym_template] = ACTIONS(3082),
    [anon_sym_operator] = ACTIONS(3082),
    [anon_sym_try] = ACTIONS(3082),
    [anon_sym_delete] = ACTIONS(3082),
    [anon_sym_throw] = ACTIONS(3082),
    [anon_sym_namespace] = ACTIONS(3082),
    [anon_sym_using] = ACTIONS(3082),
    [anon_sym_static_assert] = ACTIONS(3082),
    [anon_sym_concept] = ACTIONS(3082),
    [anon_sym_co_return] = ACTIONS(3082),
    [anon_sym_co_yield] = ACTIONS(3082),
    [anon_sym_R_DQUOTE] = ACTIONS(3084),
    [anon_sym_LR_DQUOTE] = ACTIONS(3084),
    [anon_sym_uR_DQUOTE] = ACTIONS(3084),
    [anon_sym_UR_DQUOTE] = ACTIONS(3084),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3084),
    [anon_sym_co_await] = ACTIONS(3082),
    [anon_sym_new] = ACTIONS(3082),
    [anon_sym_requires] = ACTIONS(3082),
    [sym_this] = ACTIONS(3082),
  },
  [695] = {
    [ts_builtin_sym_end] = ACTIONS(2828),
    [sym_identifier] = ACTIONS(2826),
    [aux_sym_preproc_include_token1] = ACTIONS(2826),
    [aux_sym_preproc_def_token1] = ACTIONS(2826),
    [aux_sym_preproc_if_token1] = ACTIONS(2826),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2826),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2826),
    [sym_preproc_directive] = ACTIONS(2826),
    [anon_sym_LPAREN2] = ACTIONS(2828),
    [anon_sym_BANG] = ACTIONS(2828),
    [anon_sym_TILDE] = ACTIONS(2828),
    [anon_sym_DASH] = ACTIONS(2826),
    [anon_sym_PLUS] = ACTIONS(2826),
    [anon_sym_STAR] = ACTIONS(2828),
    [anon_sym_AMP_AMP] = ACTIONS(2828),
    [anon_sym_AMP] = ACTIONS(2826),
    [anon_sym_SEMI] = ACTIONS(2828),
    [anon_sym___extension__] = ACTIONS(2826),
    [anon_sym_typedef] = ACTIONS(2826),
    [anon_sym_virtual] = ACTIONS(2826),
    [anon_sym_extern] = ACTIONS(2826),
    [anon_sym___attribute__] = ACTIONS(2826),
    [anon_sym___attribute] = ACTIONS(2826),
    [anon_sym_COLON_COLON] = ACTIONS(2828),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2828),
    [anon_sym___declspec] = ACTIONS(2826),
    [anon_sym___based] = ACTIONS(2826),
    [anon_sym___cdecl] = ACTIONS(2826),
    [anon_sym___clrcall] = ACTIONS(2826),
    [anon_sym___stdcall] = ACTIONS(2826),
    [anon_sym___fastcall] = ACTIONS(2826),
    [anon_sym___thiscall] = ACTIONS(2826),
    [anon_sym___vectorcall] = ACTIONS(2826),
    [anon_sym_LBRACE] = ACTIONS(2828),
    [anon_sym_signed] = ACTIONS(2826),
    [anon_sym_unsigned] = ACTIONS(2826),
    [anon_sym_long] = ACTIONS(2826),
    [anon_sym_short] = ACTIONS(2826),
    [anon_sym_LBRACK] = ACTIONS(2826),
    [anon_sym_static] = ACTIONS(2826),
    [anon_sym_register] = ACTIONS(2826),
    [anon_sym_inline] = ACTIONS(2826),
    [anon_sym___inline] = ACTIONS(2826),
    [anon_sym___inline__] = ACTIONS(2826),
    [anon_sym___forceinline] = ACTIONS(2826),
    [anon_sym_thread_local] = ACTIONS(2826),
    [anon_sym___thread] = ACTIONS(2826),
    [anon_sym_const] = ACTIONS(2826),
    [anon_sym_constexpr] = ACTIONS(2826),
    [anon_sym_volatile] = ACTIONS(2826),
    [anon_sym_restrict] = ACTIONS(2826),
    [anon_sym___restrict__] = ACTIONS(2826),
    [anon_sym__Atomic] = ACTIONS(2826),
    [anon_sym__Noreturn] = ACTIONS(2826),
    [anon_sym_noreturn] = ACTIONS(2826),
    [anon_sym__Nonnull] = ACTIONS(2826),
    [anon_sym_mutable] = ACTIONS(2826),
    [anon_sym_constinit] = ACTIONS(2826),
    [anon_sym_consteval] = ACTIONS(2826),
    [anon_sym_alignas] = ACTIONS(2826),
    [anon_sym__Alignas] = ACTIONS(2826),
    [sym_primitive_type] = ACTIONS(2826),
    [anon_sym_enum] = ACTIONS(2826),
    [anon_sym_class] = ACTIONS(2826),
    [anon_sym_struct] = ACTIONS(2826),
    [anon_sym_union] = ACTIONS(2826),
    [anon_sym_if] = ACTIONS(2826),
    [anon_sym_switch] = ACTIONS(2826),
    [anon_sym_case] = ACTIONS(2826),
    [anon_sym_default] = ACTIONS(2826),
    [anon_sym_while] = ACTIONS(2826),
    [anon_sym_do] = ACTIONS(2826),
    [anon_sym_for] = ACTIONS(2826),
    [anon_sym_return] = ACTIONS(2826),
    [anon_sym_break] = ACTIONS(2826),
    [anon_sym_continue] = ACTIONS(2826),
    [anon_sym_goto] = ACTIONS(2826),
    [anon_sym_not] = ACTIONS(2826),
    [anon_sym_compl] = ACTIONS(2826),
    [anon_sym_DASH_DASH] = ACTIONS(2828),
    [anon_sym_PLUS_PLUS] = ACTIONS(2828),
    [anon_sym_sizeof] = ACTIONS(2826),
    [anon_sym___alignof__] = ACTIONS(2826),
    [anon_sym___alignof] = ACTIONS(2826),
    [anon_sym__alignof] = ACTIONS(2826),
    [anon_sym_alignof] = ACTIONS(2826),
    [anon_sym__Alignof] = ACTIONS(2826),
    [anon_sym_offsetof] = ACTIONS(2826),
    [anon_sym__Generic] = ACTIONS(2826),
    [anon_sym_asm] = ACTIONS(2826),
    [anon_sym___asm__] = ACTIONS(2826),
    [anon_sym___asm] = ACTIONS(2826),
    [sym_number_literal] = ACTIONS(2828),
    [anon_sym_L_SQUOTE] = ACTIONS(2828),
    [anon_sym_u_SQUOTE] = ACTIONS(2828),
    [anon_sym_U_SQUOTE] = ACTIONS(2828),
    [anon_sym_u8_SQUOTE] = ACTIONS(2828),
    [anon_sym_SQUOTE] = ACTIONS(2828),
    [anon_sym_L_DQUOTE] = ACTIONS(2828),
    [anon_sym_u_DQUOTE] = ACTIONS(2828),
    [anon_sym_U_DQUOTE] = ACTIONS(2828),
    [anon_sym_u8_DQUOTE] = ACTIONS(2828),
    [anon_sym_DQUOTE] = ACTIONS(2828),
    [sym_true] = ACTIONS(2826),
    [sym_false] = ACTIONS(2826),
    [anon_sym_NULL] = ACTIONS(2826),
    [anon_sym_nullptr] = ACTIONS(2826),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2826),
    [anon_sym_decltype] = ACTIONS(2826),
    [anon_sym_explicit] = ACTIONS(2826),
    [anon_sym_typename] = ACTIONS(2826),
    [anon_sym_template] = ACTIONS(2826),
    [anon_sym_operator] = ACTIONS(2826),
    [anon_sym_try] = ACTIONS(2826),
    [anon_sym_delete] = ACTIONS(2826),
    [anon_sym_throw] = ACTIONS(2826),
    [anon_sym_namespace] = ACTIONS(2826),
    [anon_sym_using] = ACTIONS(2826),
    [anon_sym_static_assert] = ACTIONS(2826),
    [anon_sym_concept] = ACTIONS(2826),
    [anon_sym_co_return] = ACTIONS(2826),
    [anon_sym_co_yield] = ACTIONS(2826),
    [anon_sym_R_DQUOTE] = ACTIONS(2828),
    [anon_sym_LR_DQUOTE] = ACTIONS(2828),
    [anon_sym_uR_DQUOTE] = ACTIONS(2828),
    [anon_sym_UR_DQUOTE] = ACTIONS(2828),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2828),
    [anon_sym_co_await] = ACTIONS(2826),
    [anon_sym_new] = ACTIONS(2826),
    [anon_sym_requires] = ACTIONS(2826),
    [sym_this] = ACTIONS(2826),
  },
  [696] = {
    [ts_builtin_sym_end] = ACTIONS(2832),
    [sym_identifier] = ACTIONS(2830),
    [aux_sym_preproc_include_token1] = ACTIONS(2830),
    [aux_sym_preproc_def_token1] = ACTIONS(2830),
    [aux_sym_preproc_if_token1] = ACTIONS(2830),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2830),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2830),
    [sym_preproc_directive] = ACTIONS(2830),
    [anon_sym_LPAREN2] = ACTIONS(2832),
    [anon_sym_BANG] = ACTIONS(2832),
    [anon_sym_TILDE] = ACTIONS(2832),
    [anon_sym_DASH] = ACTIONS(2830),
    [anon_sym_PLUS] = ACTIONS(2830),
    [anon_sym_STAR] = ACTIONS(2832),
    [anon_sym_AMP_AMP] = ACTIONS(2832),
    [anon_sym_AMP] = ACTIONS(2830),
    [anon_sym_SEMI] = ACTIONS(2832),
    [anon_sym___extension__] = ACTIONS(2830),
    [anon_sym_typedef] = ACTIONS(2830),
    [anon_sym_virtual] = ACTIONS(2830),
    [anon_sym_extern] = ACTIONS(2830),
    [anon_sym___attribute__] = ACTIONS(2830),
    [anon_sym___attribute] = ACTIONS(2830),
    [anon_sym_COLON_COLON] = ACTIONS(2832),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2832),
    [anon_sym___declspec] = ACTIONS(2830),
    [anon_sym___based] = ACTIONS(2830),
    [anon_sym___cdecl] = ACTIONS(2830),
    [anon_sym___clrcall] = ACTIONS(2830),
    [anon_sym___stdcall] = ACTIONS(2830),
    [anon_sym___fastcall] = ACTIONS(2830),
    [anon_sym___thiscall] = ACTIONS(2830),
    [anon_sym___vectorcall] = ACTIONS(2830),
    [anon_sym_LBRACE] = ACTIONS(2832),
    [anon_sym_signed] = ACTIONS(2830),
    [anon_sym_unsigned] = ACTIONS(2830),
    [anon_sym_long] = ACTIONS(2830),
    [anon_sym_short] = ACTIONS(2830),
    [anon_sym_LBRACK] = ACTIONS(2830),
    [anon_sym_static] = ACTIONS(2830),
    [anon_sym_register] = ACTIONS(2830),
    [anon_sym_inline] = ACTIONS(2830),
    [anon_sym___inline] = ACTIONS(2830),
    [anon_sym___inline__] = ACTIONS(2830),
    [anon_sym___forceinline] = ACTIONS(2830),
    [anon_sym_thread_local] = ACTIONS(2830),
    [anon_sym___thread] = ACTIONS(2830),
    [anon_sym_const] = ACTIONS(2830),
    [anon_sym_constexpr] = ACTIONS(2830),
    [anon_sym_volatile] = ACTIONS(2830),
    [anon_sym_restrict] = ACTIONS(2830),
    [anon_sym___restrict__] = ACTIONS(2830),
    [anon_sym__Atomic] = ACTIONS(2830),
    [anon_sym__Noreturn] = ACTIONS(2830),
    [anon_sym_noreturn] = ACTIONS(2830),
    [anon_sym__Nonnull] = ACTIONS(2830),
    [anon_sym_mutable] = ACTIONS(2830),
    [anon_sym_constinit] = ACTIONS(2830),
    [anon_sym_consteval] = ACTIONS(2830),
    [anon_sym_alignas] = ACTIONS(2830),
    [anon_sym__Alignas] = ACTIONS(2830),
    [sym_primitive_type] = ACTIONS(2830),
    [anon_sym_enum] = ACTIONS(2830),
    [anon_sym_class] = ACTIONS(2830),
    [anon_sym_struct] = ACTIONS(2830),
    [anon_sym_union] = ACTIONS(2830),
    [anon_sym_if] = ACTIONS(2830),
    [anon_sym_switch] = ACTIONS(2830),
    [anon_sym_case] = ACTIONS(2830),
    [anon_sym_default] = ACTIONS(2830),
    [anon_sym_while] = ACTIONS(2830),
    [anon_sym_do] = ACTIONS(2830),
    [anon_sym_for] = ACTIONS(2830),
    [anon_sym_return] = ACTIONS(2830),
    [anon_sym_break] = ACTIONS(2830),
    [anon_sym_continue] = ACTIONS(2830),
    [anon_sym_goto] = ACTIONS(2830),
    [anon_sym_not] = ACTIONS(2830),
    [anon_sym_compl] = ACTIONS(2830),
    [anon_sym_DASH_DASH] = ACTIONS(2832),
    [anon_sym_PLUS_PLUS] = ACTIONS(2832),
    [anon_sym_sizeof] = ACTIONS(2830),
    [anon_sym___alignof__] = ACTIONS(2830),
    [anon_sym___alignof] = ACTIONS(2830),
    [anon_sym__alignof] = ACTIONS(2830),
    [anon_sym_alignof] = ACTIONS(2830),
    [anon_sym__Alignof] = ACTIONS(2830),
    [anon_sym_offsetof] = ACTIONS(2830),
    [anon_sym__Generic] = ACTIONS(2830),
    [anon_sym_asm] = ACTIONS(2830),
    [anon_sym___asm__] = ACTIONS(2830),
    [anon_sym___asm] = ACTIONS(2830),
    [sym_number_literal] = ACTIONS(2832),
    [anon_sym_L_SQUOTE] = ACTIONS(2832),
    [anon_sym_u_SQUOTE] = ACTIONS(2832),
    [anon_sym_U_SQUOTE] = ACTIONS(2832),
    [anon_sym_u8_SQUOTE] = ACTIONS(2832),
    [anon_sym_SQUOTE] = ACTIONS(2832),
    [anon_sym_L_DQUOTE] = ACTIONS(2832),
    [anon_sym_u_DQUOTE] = ACTIONS(2832),
    [anon_sym_U_DQUOTE] = ACTIONS(2832),
    [anon_sym_u8_DQUOTE] = ACTIONS(2832),
    [anon_sym_DQUOTE] = ACTIONS(2832),
    [sym_true] = ACTIONS(2830),
    [sym_false] = ACTIONS(2830),
    [anon_sym_NULL] = ACTIONS(2830),
    [anon_sym_nullptr] = ACTIONS(2830),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2830),
    [anon_sym_decltype] = ACTIONS(2830),
    [anon_sym_explicit] = ACTIONS(2830),
    [anon_sym_typename] = ACTIONS(2830),
    [anon_sym_template] = ACTIONS(2830),
    [anon_sym_operator] = ACTIONS(2830),
    [anon_sym_try] = ACTIONS(2830),
    [anon_sym_delete] = ACTIONS(2830),
    [anon_sym_throw] = ACTIONS(2830),
    [anon_sym_namespace] = ACTIONS(2830),
    [anon_sym_using] = ACTIONS(2830),
    [anon_sym_static_assert] = ACTIONS(2830),
    [anon_sym_concept] = ACTIONS(2830),
    [anon_sym_co_return] = ACTIONS(2830),
    [anon_sym_co_yield] = ACTIONS(2830),
    [anon_sym_R_DQUOTE] = ACTIONS(2832),
    [anon_sym_LR_DQUOTE] = ACTIONS(2832),
    [anon_sym_uR_DQUOTE] = ACTIONS(2832),
    [anon_sym_UR_DQUOTE] = ACTIONS(2832),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2832),
    [anon_sym_co_await] = ACTIONS(2830),
    [anon_sym_new] = ACTIONS(2830),
    [anon_sym_requires] = ACTIONS(2830),
    [sym_this] = ACTIONS(2830),
  },
  [697] = {
    [ts_builtin_sym_end] = ACTIONS(3116),
    [sym_identifier] = ACTIONS(3114),
    [aux_sym_preproc_include_token1] = ACTIONS(3114),
    [aux_sym_preproc_def_token1] = ACTIONS(3114),
    [aux_sym_preproc_if_token1] = ACTIONS(3114),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3114),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3114),
    [sym_preproc_directive] = ACTIONS(3114),
    [anon_sym_LPAREN2] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3116),
    [anon_sym_TILDE] = ACTIONS(3116),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_PLUS] = ACTIONS(3114),
    [anon_sym_STAR] = ACTIONS(3116),
    [anon_sym_AMP_AMP] = ACTIONS(3116),
    [anon_sym_AMP] = ACTIONS(3114),
    [anon_sym_SEMI] = ACTIONS(3116),
    [anon_sym___extension__] = ACTIONS(3114),
    [anon_sym_typedef] = ACTIONS(3114),
    [anon_sym_virtual] = ACTIONS(3114),
    [anon_sym_extern] = ACTIONS(3114),
    [anon_sym___attribute__] = ACTIONS(3114),
    [anon_sym___attribute] = ACTIONS(3114),
    [anon_sym_COLON_COLON] = ACTIONS(3116),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3116),
    [anon_sym___declspec] = ACTIONS(3114),
    [anon_sym___based] = ACTIONS(3114),
    [anon_sym___cdecl] = ACTIONS(3114),
    [anon_sym___clrcall] = ACTIONS(3114),
    [anon_sym___stdcall] = ACTIONS(3114),
    [anon_sym___fastcall] = ACTIONS(3114),
    [anon_sym___thiscall] = ACTIONS(3114),
    [anon_sym___vectorcall] = ACTIONS(3114),
    [anon_sym_LBRACE] = ACTIONS(3116),
    [anon_sym_signed] = ACTIONS(3114),
    [anon_sym_unsigned] = ACTIONS(3114),
    [anon_sym_long] = ACTIONS(3114),
    [anon_sym_short] = ACTIONS(3114),
    [anon_sym_LBRACK] = ACTIONS(3114),
    [anon_sym_static] = ACTIONS(3114),
    [anon_sym_register] = ACTIONS(3114),
    [anon_sym_inline] = ACTIONS(3114),
    [anon_sym___inline] = ACTIONS(3114),
    [anon_sym___inline__] = ACTIONS(3114),
    [anon_sym___forceinline] = ACTIONS(3114),
    [anon_sym_thread_local] = ACTIONS(3114),
    [anon_sym___thread] = ACTIONS(3114),
    [anon_sym_const] = ACTIONS(3114),
    [anon_sym_constexpr] = ACTIONS(3114),
    [anon_sym_volatile] = ACTIONS(3114),
    [anon_sym_restrict] = ACTIONS(3114),
    [anon_sym___restrict__] = ACTIONS(3114),
    [anon_sym__Atomic] = ACTIONS(3114),
    [anon_sym__Noreturn] = ACTIONS(3114),
    [anon_sym_noreturn] = ACTIONS(3114),
    [anon_sym__Nonnull] = ACTIONS(3114),
    [anon_sym_mutable] = ACTIONS(3114),
    [anon_sym_constinit] = ACTIONS(3114),
    [anon_sym_consteval] = ACTIONS(3114),
    [anon_sym_alignas] = ACTIONS(3114),
    [anon_sym__Alignas] = ACTIONS(3114),
    [sym_primitive_type] = ACTIONS(3114),
    [anon_sym_enum] = ACTIONS(3114),
    [anon_sym_class] = ACTIONS(3114),
    [anon_sym_struct] = ACTIONS(3114),
    [anon_sym_union] = ACTIONS(3114),
    [anon_sym_if] = ACTIONS(3114),
    [anon_sym_switch] = ACTIONS(3114),
    [anon_sym_case] = ACTIONS(3114),
    [anon_sym_default] = ACTIONS(3114),
    [anon_sym_while] = ACTIONS(3114),
    [anon_sym_do] = ACTIONS(3114),
    [anon_sym_for] = ACTIONS(3114),
    [anon_sym_return] = ACTIONS(3114),
    [anon_sym_break] = ACTIONS(3114),
    [anon_sym_continue] = ACTIONS(3114),
    [anon_sym_goto] = ACTIONS(3114),
    [anon_sym_not] = ACTIONS(3114),
    [anon_sym_compl] = ACTIONS(3114),
    [anon_sym_DASH_DASH] = ACTIONS(3116),
    [anon_sym_PLUS_PLUS] = ACTIONS(3116),
    [anon_sym_sizeof] = ACTIONS(3114),
    [anon_sym___alignof__] = ACTIONS(3114),
    [anon_sym___alignof] = ACTIONS(3114),
    [anon_sym__alignof] = ACTIONS(3114),
    [anon_sym_alignof] = ACTIONS(3114),
    [anon_sym__Alignof] = ACTIONS(3114),
    [anon_sym_offsetof] = ACTIONS(3114),
    [anon_sym__Generic] = ACTIONS(3114),
    [anon_sym_asm] = ACTIONS(3114),
    [anon_sym___asm__] = ACTIONS(3114),
    [anon_sym___asm] = ACTIONS(3114),
    [sym_number_literal] = ACTIONS(3116),
    [anon_sym_L_SQUOTE] = ACTIONS(3116),
    [anon_sym_u_SQUOTE] = ACTIONS(3116),
    [anon_sym_U_SQUOTE] = ACTIONS(3116),
    [anon_sym_u8_SQUOTE] = ACTIONS(3116),
    [anon_sym_SQUOTE] = ACTIONS(3116),
    [anon_sym_L_DQUOTE] = ACTIONS(3116),
    [anon_sym_u_DQUOTE] = ACTIONS(3116),
    [anon_sym_U_DQUOTE] = ACTIONS(3116),
    [anon_sym_u8_DQUOTE] = ACTIONS(3116),
    [anon_sym_DQUOTE] = ACTIONS(3116),
    [sym_true] = ACTIONS(3114),
    [sym_false] = ACTIONS(3114),
    [anon_sym_NULL] = ACTIONS(3114),
    [anon_sym_nullptr] = ACTIONS(3114),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3114),
    [anon_sym_decltype] = ACTIONS(3114),
    [anon_sym_explicit] = ACTIONS(3114),
    [anon_sym_typename] = ACTIONS(3114),
    [anon_sym_template] = ACTIONS(3114),
    [anon_sym_operator] = ACTIONS(3114),
    [anon_sym_try] = ACTIONS(3114),
    [anon_sym_delete] = ACTIONS(3114),
    [anon_sym_throw] = ACTIONS(3114),
    [anon_sym_namespace] = ACTIONS(3114),
    [anon_sym_using] = ACTIONS(3114),
    [anon_sym_static_assert] = ACTIONS(3114),
    [anon_sym_concept] = ACTIONS(3114),
    [anon_sym_co_return] = ACTIONS(3114),
    [anon_sym_co_yield] = ACTIONS(3114),
    [anon_sym_R_DQUOTE] = ACTIONS(3116),
    [anon_sym_LR_DQUOTE] = ACTIONS(3116),
    [anon_sym_uR_DQUOTE] = ACTIONS(3116),
    [anon_sym_UR_DQUOTE] = ACTIONS(3116),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3116),
    [anon_sym_co_await] = ACTIONS(3114),
    [anon_sym_new] = ACTIONS(3114),
    [anon_sym_requires] = ACTIONS(3114),
    [sym_this] = ACTIONS(3114),
  },
  [698] = {
    [ts_builtin_sym_end] = ACTIONS(3130),
    [sym_identifier] = ACTIONS(3128),
    [aux_sym_preproc_include_token1] = ACTIONS(3128),
    [aux_sym_preproc_def_token1] = ACTIONS(3128),
    [aux_sym_preproc_if_token1] = ACTIONS(3128),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3128),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3128),
    [sym_preproc_directive] = ACTIONS(3128),
    [anon_sym_LPAREN2] = ACTIONS(3130),
    [anon_sym_BANG] = ACTIONS(3130),
    [anon_sym_TILDE] = ACTIONS(3130),
    [anon_sym_DASH] = ACTIONS(3128),
    [anon_sym_PLUS] = ACTIONS(3128),
    [anon_sym_STAR] = ACTIONS(3130),
    [anon_sym_AMP_AMP] = ACTIONS(3130),
    [anon_sym_AMP] = ACTIONS(3128),
    [anon_sym_SEMI] = ACTIONS(3130),
    [anon_sym___extension__] = ACTIONS(3128),
    [anon_sym_typedef] = ACTIONS(3128),
    [anon_sym_virtual] = ACTIONS(3128),
    [anon_sym_extern] = ACTIONS(3128),
    [anon_sym___attribute__] = ACTIONS(3128),
    [anon_sym___attribute] = ACTIONS(3128),
    [anon_sym_COLON_COLON] = ACTIONS(3130),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3130),
    [anon_sym___declspec] = ACTIONS(3128),
    [anon_sym___based] = ACTIONS(3128),
    [anon_sym___cdecl] = ACTIONS(3128),
    [anon_sym___clrcall] = ACTIONS(3128),
    [anon_sym___stdcall] = ACTIONS(3128),
    [anon_sym___fastcall] = ACTIONS(3128),
    [anon_sym___thiscall] = ACTIONS(3128),
    [anon_sym___vectorcall] = ACTIONS(3128),
    [anon_sym_LBRACE] = ACTIONS(3130),
    [anon_sym_signed] = ACTIONS(3128),
    [anon_sym_unsigned] = ACTIONS(3128),
    [anon_sym_long] = ACTIONS(3128),
    [anon_sym_short] = ACTIONS(3128),
    [anon_sym_LBRACK] = ACTIONS(3128),
    [anon_sym_static] = ACTIONS(3128),
    [anon_sym_register] = ACTIONS(3128),
    [anon_sym_inline] = ACTIONS(3128),
    [anon_sym___inline] = ACTIONS(3128),
    [anon_sym___inline__] = ACTIONS(3128),
    [anon_sym___forceinline] = ACTIONS(3128),
    [anon_sym_thread_local] = ACTIONS(3128),
    [anon_sym___thread] = ACTIONS(3128),
    [anon_sym_const] = ACTIONS(3128),
    [anon_sym_constexpr] = ACTIONS(3128),
    [anon_sym_volatile] = ACTIONS(3128),
    [anon_sym_restrict] = ACTIONS(3128),
    [anon_sym___restrict__] = ACTIONS(3128),
    [anon_sym__Atomic] = ACTIONS(3128),
    [anon_sym__Noreturn] = ACTIONS(3128),
    [anon_sym_noreturn] = ACTIONS(3128),
    [anon_sym__Nonnull] = ACTIONS(3128),
    [anon_sym_mutable] = ACTIONS(3128),
    [anon_sym_constinit] = ACTIONS(3128),
    [anon_sym_consteval] = ACTIONS(3128),
    [anon_sym_alignas] = ACTIONS(3128),
    [anon_sym__Alignas] = ACTIONS(3128),
    [sym_primitive_type] = ACTIONS(3128),
    [anon_sym_enum] = ACTIONS(3128),
    [anon_sym_class] = ACTIONS(3128),
    [anon_sym_struct] = ACTIONS(3128),
    [anon_sym_union] = ACTIONS(3128),
    [anon_sym_if] = ACTIONS(3128),
    [anon_sym_switch] = ACTIONS(3128),
    [anon_sym_case] = ACTIONS(3128),
    [anon_sym_default] = ACTIONS(3128),
    [anon_sym_while] = ACTIONS(3128),
    [anon_sym_do] = ACTIONS(3128),
    [anon_sym_for] = ACTIONS(3128),
    [anon_sym_return] = ACTIONS(3128),
    [anon_sym_break] = ACTIONS(3128),
    [anon_sym_continue] = ACTIONS(3128),
    [anon_sym_goto] = ACTIONS(3128),
    [anon_sym_not] = ACTIONS(3128),
    [anon_sym_compl] = ACTIONS(3128),
    [anon_sym_DASH_DASH] = ACTIONS(3130),
    [anon_sym_PLUS_PLUS] = ACTIONS(3130),
    [anon_sym_sizeof] = ACTIONS(3128),
    [anon_sym___alignof__] = ACTIONS(3128),
    [anon_sym___alignof] = ACTIONS(3128),
    [anon_sym__alignof] = ACTIONS(3128),
    [anon_sym_alignof] = ACTIONS(3128),
    [anon_sym__Alignof] = ACTIONS(3128),
    [anon_sym_offsetof] = ACTIONS(3128),
    [anon_sym__Generic] = ACTIONS(3128),
    [anon_sym_asm] = ACTIONS(3128),
    [anon_sym___asm__] = ACTIONS(3128),
    [anon_sym___asm] = ACTIONS(3128),
    [sym_number_literal] = ACTIONS(3130),
    [anon_sym_L_SQUOTE] = ACTIONS(3130),
    [anon_sym_u_SQUOTE] = ACTIONS(3130),
    [anon_sym_U_SQUOTE] = ACTIONS(3130),
    [anon_sym_u8_SQUOTE] = ACTIONS(3130),
    [anon_sym_SQUOTE] = ACTIONS(3130),
    [anon_sym_L_DQUOTE] = ACTIONS(3130),
    [anon_sym_u_DQUOTE] = ACTIONS(3130),
    [anon_sym_U_DQUOTE] = ACTIONS(3130),
    [anon_sym_u8_DQUOTE] = ACTIONS(3130),
    [anon_sym_DQUOTE] = ACTIONS(3130),
    [sym_true] = ACTIONS(3128),
    [sym_false] = ACTIONS(3128),
    [anon_sym_NULL] = ACTIONS(3128),
    [anon_sym_nullptr] = ACTIONS(3128),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3128),
    [anon_sym_decltype] = ACTIONS(3128),
    [anon_sym_explicit] = ACTIONS(3128),
    [anon_sym_typename] = ACTIONS(3128),
    [anon_sym_template] = ACTIONS(3128),
    [anon_sym_operator] = ACTIONS(3128),
    [anon_sym_try] = ACTIONS(3128),
    [anon_sym_delete] = ACTIONS(3128),
    [anon_sym_throw] = ACTIONS(3128),
    [anon_sym_namespace] = ACTIONS(3128),
    [anon_sym_using] = ACTIONS(3128),
    [anon_sym_static_assert] = ACTIONS(3128),
    [anon_sym_concept] = ACTIONS(3128),
    [anon_sym_co_return] = ACTIONS(3128),
    [anon_sym_co_yield] = ACTIONS(3128),
    [anon_sym_R_DQUOTE] = ACTIONS(3130),
    [anon_sym_LR_DQUOTE] = ACTIONS(3130),
    [anon_sym_uR_DQUOTE] = ACTIONS(3130),
    [anon_sym_UR_DQUOTE] = ACTIONS(3130),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3130),
    [anon_sym_co_await] = ACTIONS(3128),
    [anon_sym_new] = ACTIONS(3128),
    [anon_sym_requires] = ACTIONS(3128),
    [sym_this] = ACTIONS(3128),
  },
  [699] = {
    [ts_builtin_sym_end] = ACTIONS(3164),
    [sym_identifier] = ACTIONS(3162),
    [aux_sym_preproc_include_token1] = ACTIONS(3162),
    [aux_sym_preproc_def_token1] = ACTIONS(3162),
    [aux_sym_preproc_if_token1] = ACTIONS(3162),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3162),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3162),
    [sym_preproc_directive] = ACTIONS(3162),
    [anon_sym_LPAREN2] = ACTIONS(3164),
    [anon_sym_BANG] = ACTIONS(3164),
    [anon_sym_TILDE] = ACTIONS(3164),
    [anon_sym_DASH] = ACTIONS(3162),
    [anon_sym_PLUS] = ACTIONS(3162),
    [anon_sym_STAR] = ACTIONS(3164),
    [anon_sym_AMP_AMP] = ACTIONS(3164),
    [anon_sym_AMP] = ACTIONS(3162),
    [anon_sym_SEMI] = ACTIONS(3164),
    [anon_sym___extension__] = ACTIONS(3162),
    [anon_sym_typedef] = ACTIONS(3162),
    [anon_sym_virtual] = ACTIONS(3162),
    [anon_sym_extern] = ACTIONS(3162),
    [anon_sym___attribute__] = ACTIONS(3162),
    [anon_sym___attribute] = ACTIONS(3162),
    [anon_sym_COLON_COLON] = ACTIONS(3164),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3164),
    [anon_sym___declspec] = ACTIONS(3162),
    [anon_sym___based] = ACTIONS(3162),
    [anon_sym___cdecl] = ACTIONS(3162),
    [anon_sym___clrcall] = ACTIONS(3162),
    [anon_sym___stdcall] = ACTIONS(3162),
    [anon_sym___fastcall] = ACTIONS(3162),
    [anon_sym___thiscall] = ACTIONS(3162),
    [anon_sym___vectorcall] = ACTIONS(3162),
    [anon_sym_LBRACE] = ACTIONS(3164),
    [anon_sym_signed] = ACTIONS(3162),
    [anon_sym_unsigned] = ACTIONS(3162),
    [anon_sym_long] = ACTIONS(3162),
    [anon_sym_short] = ACTIONS(3162),
    [anon_sym_LBRACK] = ACTIONS(3162),
    [anon_sym_static] = ACTIONS(3162),
    [anon_sym_register] = ACTIONS(3162),
    [anon_sym_inline] = ACTIONS(3162),
    [anon_sym___inline] = ACTIONS(3162),
    [anon_sym___inline__] = ACTIONS(3162),
    [anon_sym___forceinline] = ACTIONS(3162),
    [anon_sym_thread_local] = ACTIONS(3162),
    [anon_sym___thread] = ACTIONS(3162),
    [anon_sym_const] = ACTIONS(3162),
    [anon_sym_constexpr] = ACTIONS(3162),
    [anon_sym_volatile] = ACTIONS(3162),
    [anon_sym_restrict] = ACTIONS(3162),
    [anon_sym___restrict__] = ACTIONS(3162),
    [anon_sym__Atomic] = ACTIONS(3162),
    [anon_sym__Noreturn] = ACTIONS(3162),
    [anon_sym_noreturn] = ACTIONS(3162),
    [anon_sym__Nonnull] = ACTIONS(3162),
    [anon_sym_mutable] = ACTIONS(3162),
    [anon_sym_constinit] = ACTIONS(3162),
    [anon_sym_consteval] = ACTIONS(3162),
    [anon_sym_alignas] = ACTIONS(3162),
    [anon_sym__Alignas] = ACTIONS(3162),
    [sym_primitive_type] = ACTIONS(3162),
    [anon_sym_enum] = ACTIONS(3162),
    [anon_sym_class] = ACTIONS(3162),
    [anon_sym_struct] = ACTIONS(3162),
    [anon_sym_union] = ACTIONS(3162),
    [anon_sym_if] = ACTIONS(3162),
    [anon_sym_switch] = ACTIONS(3162),
    [anon_sym_case] = ACTIONS(3162),
    [anon_sym_default] = ACTIONS(3162),
    [anon_sym_while] = ACTIONS(3162),
    [anon_sym_do] = ACTIONS(3162),
    [anon_sym_for] = ACTIONS(3162),
    [anon_sym_return] = ACTIONS(3162),
    [anon_sym_break] = ACTIONS(3162),
    [anon_sym_continue] = ACTIONS(3162),
    [anon_sym_goto] = ACTIONS(3162),
    [anon_sym_not] = ACTIONS(3162),
    [anon_sym_compl] = ACTIONS(3162),
    [anon_sym_DASH_DASH] = ACTIONS(3164),
    [anon_sym_PLUS_PLUS] = ACTIONS(3164),
    [anon_sym_sizeof] = ACTIONS(3162),
    [anon_sym___alignof__] = ACTIONS(3162),
    [anon_sym___alignof] = ACTIONS(3162),
    [anon_sym__alignof] = ACTIONS(3162),
    [anon_sym_alignof] = ACTIONS(3162),
    [anon_sym__Alignof] = ACTIONS(3162),
    [anon_sym_offsetof] = ACTIONS(3162),
    [anon_sym__Generic] = ACTIONS(3162),
    [anon_sym_asm] = ACTIONS(3162),
    [anon_sym___asm__] = ACTIONS(3162),
    [anon_sym___asm] = ACTIONS(3162),
    [sym_number_literal] = ACTIONS(3164),
    [anon_sym_L_SQUOTE] = ACTIONS(3164),
    [anon_sym_u_SQUOTE] = ACTIONS(3164),
    [anon_sym_U_SQUOTE] = ACTIONS(3164),
    [anon_sym_u8_SQUOTE] = ACTIONS(3164),
    [anon_sym_SQUOTE] = ACTIONS(3164),
    [anon_sym_L_DQUOTE] = ACTIONS(3164),
    [anon_sym_u_DQUOTE] = ACTIONS(3164),
    [anon_sym_U_DQUOTE] = ACTIONS(3164),
    [anon_sym_u8_DQUOTE] = ACTIONS(3164),
    [anon_sym_DQUOTE] = ACTIONS(3164),
    [sym_true] = ACTIONS(3162),
    [sym_false] = ACTIONS(3162),
    [anon_sym_NULL] = ACTIONS(3162),
    [anon_sym_nullptr] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3162),
    [anon_sym_decltype] = ACTIONS(3162),
    [anon_sym_explicit] = ACTIONS(3162),
    [anon_sym_typename] = ACTIONS(3162),
    [anon_sym_template] = ACTIONS(3162),
    [anon_sym_operator] = ACTIONS(3162),
    [anon_sym_try] = ACTIONS(3162),
    [anon_sym_delete] = ACTIONS(3162),
    [anon_sym_throw] = ACTIONS(3162),
    [anon_sym_namespace] = ACTIONS(3162),
    [anon_sym_using] = ACTIONS(3162),
    [anon_sym_static_assert] = ACTIONS(3162),
    [anon_sym_concept] = ACTIONS(3162),
    [anon_sym_co_return] = ACTIONS(3162),
    [anon_sym_co_yield] = ACTIONS(3162),
    [anon_sym_R_DQUOTE] = ACTIONS(3164),
    [anon_sym_LR_DQUOTE] = ACTIONS(3164),
    [anon_sym_uR_DQUOTE] = ACTIONS(3164),
    [anon_sym_UR_DQUOTE] = ACTIONS(3164),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3164),
    [anon_sym_co_await] = ACTIONS(3162),
    [anon_sym_new] = ACTIONS(3162),
    [anon_sym_requires] = ACTIONS(3162),
    [sym_this] = ACTIONS(3162),
  },
  [700] = {
    [ts_builtin_sym_end] = ACTIONS(3168),
    [sym_identifier] = ACTIONS(3166),
    [aux_sym_preproc_include_token1] = ACTIONS(3166),
    [aux_sym_preproc_def_token1] = ACTIONS(3166),
    [aux_sym_preproc_if_token1] = ACTIONS(3166),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3166),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3166),
    [sym_preproc_directive] = ACTIONS(3166),
    [anon_sym_LPAREN2] = ACTIONS(3168),
    [anon_sym_BANG] = ACTIONS(3168),
    [anon_sym_TILDE] = ACTIONS(3168),
    [anon_sym_DASH] = ACTIONS(3166),
    [anon_sym_PLUS] = ACTIONS(3166),
    [anon_sym_STAR] = ACTIONS(3168),
    [anon_sym_AMP_AMP] = ACTIONS(3168),
    [anon_sym_AMP] = ACTIONS(3166),
    [anon_sym_SEMI] = ACTIONS(3168),
    [anon_sym___extension__] = ACTIONS(3166),
    [anon_sym_typedef] = ACTIONS(3166),
    [anon_sym_virtual] = ACTIONS(3166),
    [anon_sym_extern] = ACTIONS(3166),
    [anon_sym___attribute__] = ACTIONS(3166),
    [anon_sym___attribute] = ACTIONS(3166),
    [anon_sym_COLON_COLON] = ACTIONS(3168),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3168),
    [anon_sym___declspec] = ACTIONS(3166),
    [anon_sym___based] = ACTIONS(3166),
    [anon_sym___cdecl] = ACTIONS(3166),
    [anon_sym___clrcall] = ACTIONS(3166),
    [anon_sym___stdcall] = ACTIONS(3166),
    [anon_sym___fastcall] = ACTIONS(3166),
    [anon_sym___thiscall] = ACTIONS(3166),
    [anon_sym___vectorcall] = ACTIONS(3166),
    [anon_sym_LBRACE] = ACTIONS(3168),
    [anon_sym_signed] = ACTIONS(3166),
    [anon_sym_unsigned] = ACTIONS(3166),
    [anon_sym_long] = ACTIONS(3166),
    [anon_sym_short] = ACTIONS(3166),
    [anon_sym_LBRACK] = ACTIONS(3166),
    [anon_sym_static] = ACTIONS(3166),
    [anon_sym_register] = ACTIONS(3166),
    [anon_sym_inline] = ACTIONS(3166),
    [anon_sym___inline] = ACTIONS(3166),
    [anon_sym___inline__] = ACTIONS(3166),
    [anon_sym___forceinline] = ACTIONS(3166),
    [anon_sym_thread_local] = ACTIONS(3166),
    [anon_sym___thread] = ACTIONS(3166),
    [anon_sym_const] = ACTIONS(3166),
    [anon_sym_constexpr] = ACTIONS(3166),
    [anon_sym_volatile] = ACTIONS(3166),
    [anon_sym_restrict] = ACTIONS(3166),
    [anon_sym___restrict__] = ACTIONS(3166),
    [anon_sym__Atomic] = ACTIONS(3166),
    [anon_sym__Noreturn] = ACTIONS(3166),
    [anon_sym_noreturn] = ACTIONS(3166),
    [anon_sym__Nonnull] = ACTIONS(3166),
    [anon_sym_mutable] = ACTIONS(3166),
    [anon_sym_constinit] = ACTIONS(3166),
    [anon_sym_consteval] = ACTIONS(3166),
    [anon_sym_alignas] = ACTIONS(3166),
    [anon_sym__Alignas] = ACTIONS(3166),
    [sym_primitive_type] = ACTIONS(3166),
    [anon_sym_enum] = ACTIONS(3166),
    [anon_sym_class] = ACTIONS(3166),
    [anon_sym_struct] = ACTIONS(3166),
    [anon_sym_union] = ACTIONS(3166),
    [anon_sym_if] = ACTIONS(3166),
    [anon_sym_switch] = ACTIONS(3166),
    [anon_sym_case] = ACTIONS(3166),
    [anon_sym_default] = ACTIONS(3166),
    [anon_sym_while] = ACTIONS(3166),
    [anon_sym_do] = ACTIONS(3166),
    [anon_sym_for] = ACTIONS(3166),
    [anon_sym_return] = ACTIONS(3166),
    [anon_sym_break] = ACTIONS(3166),
    [anon_sym_continue] = ACTIONS(3166),
    [anon_sym_goto] = ACTIONS(3166),
    [anon_sym_not] = ACTIONS(3166),
    [anon_sym_compl] = ACTIONS(3166),
    [anon_sym_DASH_DASH] = ACTIONS(3168),
    [anon_sym_PLUS_PLUS] = ACTIONS(3168),
    [anon_sym_sizeof] = ACTIONS(3166),
    [anon_sym___alignof__] = ACTIONS(3166),
    [anon_sym___alignof] = ACTIONS(3166),
    [anon_sym__alignof] = ACTIONS(3166),
    [anon_sym_alignof] = ACTIONS(3166),
    [anon_sym__Alignof] = ACTIONS(3166),
    [anon_sym_offsetof] = ACTIONS(3166),
    [anon_sym__Generic] = ACTIONS(3166),
    [anon_sym_asm] = ACTIONS(3166),
    [anon_sym___asm__] = ACTIONS(3166),
    [anon_sym___asm] = ACTIONS(3166),
    [sym_number_literal] = ACTIONS(3168),
    [anon_sym_L_SQUOTE] = ACTIONS(3168),
    [anon_sym_u_SQUOTE] = ACTIONS(3168),
    [anon_sym_U_SQUOTE] = ACTIONS(3168),
    [anon_sym_u8_SQUOTE] = ACTIONS(3168),
    [anon_sym_SQUOTE] = ACTIONS(3168),
    [anon_sym_L_DQUOTE] = ACTIONS(3168),
    [anon_sym_u_DQUOTE] = ACTIONS(3168),
    [anon_sym_U_DQUOTE] = ACTIONS(3168),
    [anon_sym_u8_DQUOTE] = ACTIONS(3168),
    [anon_sym_DQUOTE] = ACTIONS(3168),
    [sym_true] = ACTIONS(3166),
    [sym_false] = ACTIONS(3166),
    [anon_sym_NULL] = ACTIONS(3166),
    [anon_sym_nullptr] = ACTIONS(3166),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3166),
    [anon_sym_decltype] = ACTIONS(3166),
    [anon_sym_explicit] = ACTIONS(3166),
    [anon_sym_typename] = ACTIONS(3166),
    [anon_sym_template] = ACTIONS(3166),
    [anon_sym_operator] = ACTIONS(3166),
    [anon_sym_try] = ACTIONS(3166),
    [anon_sym_delete] = ACTIONS(3166),
    [anon_sym_throw] = ACTIONS(3166),
    [anon_sym_namespace] = ACTIONS(3166),
    [anon_sym_using] = ACTIONS(3166),
    [anon_sym_static_assert] = ACTIONS(3166),
    [anon_sym_concept] = ACTIONS(3166),
    [anon_sym_co_return] = ACTIONS(3166),
    [anon_sym_co_yield] = ACTIONS(3166),
    [anon_sym_R_DQUOTE] = ACTIONS(3168),
    [anon_sym_LR_DQUOTE] = ACTIONS(3168),
    [anon_sym_uR_DQUOTE] = ACTIONS(3168),
    [anon_sym_UR_DQUOTE] = ACTIONS(3168),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3168),
    [anon_sym_co_await] = ACTIONS(3166),
    [anon_sym_new] = ACTIONS(3166),
    [anon_sym_requires] = ACTIONS(3166),
    [sym_this] = ACTIONS(3166),
  },
  [701] = {
    [ts_builtin_sym_end] = ACTIONS(2733),
    [sym_identifier] = ACTIONS(2731),
    [aux_sym_preproc_include_token1] = ACTIONS(2731),
    [aux_sym_preproc_def_token1] = ACTIONS(2731),
    [aux_sym_preproc_if_token1] = ACTIONS(2731),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2731),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2731),
    [sym_preproc_directive] = ACTIONS(2731),
    [anon_sym_LPAREN2] = ACTIONS(2733),
    [anon_sym_BANG] = ACTIONS(2733),
    [anon_sym_TILDE] = ACTIONS(2733),
    [anon_sym_DASH] = ACTIONS(2731),
    [anon_sym_PLUS] = ACTIONS(2731),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_AMP_AMP] = ACTIONS(2733),
    [anon_sym_AMP] = ACTIONS(2731),
    [anon_sym_SEMI] = ACTIONS(2733),
    [anon_sym___extension__] = ACTIONS(2731),
    [anon_sym_typedef] = ACTIONS(2731),
    [anon_sym_virtual] = ACTIONS(2731),
    [anon_sym_extern] = ACTIONS(2731),
    [anon_sym___attribute__] = ACTIONS(2731),
    [anon_sym___attribute] = ACTIONS(2731),
    [anon_sym_COLON_COLON] = ACTIONS(2733),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2733),
    [anon_sym___declspec] = ACTIONS(2731),
    [anon_sym___based] = ACTIONS(2731),
    [anon_sym___cdecl] = ACTIONS(2731),
    [anon_sym___clrcall] = ACTIONS(2731),
    [anon_sym___stdcall] = ACTIONS(2731),
    [anon_sym___fastcall] = ACTIONS(2731),
    [anon_sym___thiscall] = ACTIONS(2731),
    [anon_sym___vectorcall] = ACTIONS(2731),
    [anon_sym_LBRACE] = ACTIONS(2733),
    [anon_sym_signed] = ACTIONS(2731),
    [anon_sym_unsigned] = ACTIONS(2731),
    [anon_sym_long] = ACTIONS(2731),
    [anon_sym_short] = ACTIONS(2731),
    [anon_sym_LBRACK] = ACTIONS(2731),
    [anon_sym_static] = ACTIONS(2731),
    [anon_sym_register] = ACTIONS(2731),
    [anon_sym_inline] = ACTIONS(2731),
    [anon_sym___inline] = ACTIONS(2731),
    [anon_sym___inline__] = ACTIONS(2731),
    [anon_sym___forceinline] = ACTIONS(2731),
    [anon_sym_thread_local] = ACTIONS(2731),
    [anon_sym___thread] = ACTIONS(2731),
    [anon_sym_const] = ACTIONS(2731),
    [anon_sym_constexpr] = ACTIONS(2731),
    [anon_sym_volatile] = ACTIONS(2731),
    [anon_sym_restrict] = ACTIONS(2731),
    [anon_sym___restrict__] = ACTIONS(2731),
    [anon_sym__Atomic] = ACTIONS(2731),
    [anon_sym__Noreturn] = ACTIONS(2731),
    [anon_sym_noreturn] = ACTIONS(2731),
    [anon_sym__Nonnull] = ACTIONS(2731),
    [anon_sym_mutable] = ACTIONS(2731),
    [anon_sym_constinit] = ACTIONS(2731),
    [anon_sym_consteval] = ACTIONS(2731),
    [anon_sym_alignas] = ACTIONS(2731),
    [anon_sym__Alignas] = ACTIONS(2731),
    [sym_primitive_type] = ACTIONS(2731),
    [anon_sym_enum] = ACTIONS(2731),
    [anon_sym_class] = ACTIONS(2731),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2731),
    [anon_sym_if] = ACTIONS(2731),
    [anon_sym_switch] = ACTIONS(2731),
    [anon_sym_case] = ACTIONS(2731),
    [anon_sym_default] = ACTIONS(2731),
    [anon_sym_while] = ACTIONS(2731),
    [anon_sym_do] = ACTIONS(2731),
    [anon_sym_for] = ACTIONS(2731),
    [anon_sym_return] = ACTIONS(2731),
    [anon_sym_break] = ACTIONS(2731),
    [anon_sym_continue] = ACTIONS(2731),
    [anon_sym_goto] = ACTIONS(2731),
    [anon_sym_not] = ACTIONS(2731),
    [anon_sym_compl] = ACTIONS(2731),
    [anon_sym_DASH_DASH] = ACTIONS(2733),
    [anon_sym_PLUS_PLUS] = ACTIONS(2733),
    [anon_sym_sizeof] = ACTIONS(2731),
    [anon_sym___alignof__] = ACTIONS(2731),
    [anon_sym___alignof] = ACTIONS(2731),
    [anon_sym__alignof] = ACTIONS(2731),
    [anon_sym_alignof] = ACTIONS(2731),
    [anon_sym__Alignof] = ACTIONS(2731),
    [anon_sym_offsetof] = ACTIONS(2731),
    [anon_sym__Generic] = ACTIONS(2731),
    [anon_sym_asm] = ACTIONS(2731),
    [anon_sym___asm__] = ACTIONS(2731),
    [anon_sym___asm] = ACTIONS(2731),
    [sym_number_literal] = ACTIONS(2733),
    [anon_sym_L_SQUOTE] = ACTIONS(2733),
    [anon_sym_u_SQUOTE] = ACTIONS(2733),
    [anon_sym_U_SQUOTE] = ACTIONS(2733),
    [anon_sym_u8_SQUOTE] = ACTIONS(2733),
    [anon_sym_SQUOTE] = ACTIONS(2733),
    [anon_sym_L_DQUOTE] = ACTIONS(2733),
    [anon_sym_u_DQUOTE] = ACTIONS(2733),
    [anon_sym_U_DQUOTE] = ACTIONS(2733),
    [anon_sym_u8_DQUOTE] = ACTIONS(2733),
    [anon_sym_DQUOTE] = ACTIONS(2733),
    [sym_true] = ACTIONS(2731),
    [sym_false] = ACTIONS(2731),
    [anon_sym_NULL] = ACTIONS(2731),
    [anon_sym_nullptr] = ACTIONS(2731),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2731),
    [anon_sym_decltype] = ACTIONS(2731),
    [anon_sym_explicit] = ACTIONS(2731),
    [anon_sym_typename] = ACTIONS(2731),
    [anon_sym_template] = ACTIONS(2731),
    [anon_sym_operator] = ACTIONS(2731),
    [anon_sym_try] = ACTIONS(2731),
    [anon_sym_delete] = ACTIONS(2731),
    [anon_sym_throw] = ACTIONS(2731),
    [anon_sym_namespace] = ACTIONS(2731),
    [anon_sym_using] = ACTIONS(2731),
    [anon_sym_static_assert] = ACTIONS(2731),
    [anon_sym_concept] = ACTIONS(2731),
    [anon_sym_co_return] = ACTIONS(2731),
    [anon_sym_co_yield] = ACTIONS(2731),
    [anon_sym_R_DQUOTE] = ACTIONS(2733),
    [anon_sym_LR_DQUOTE] = ACTIONS(2733),
    [anon_sym_uR_DQUOTE] = ACTIONS(2733),
    [anon_sym_UR_DQUOTE] = ACTIONS(2733),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2733),
    [anon_sym_co_await] = ACTIONS(2731),
    [anon_sym_new] = ACTIONS(2731),
    [anon_sym_requires] = ACTIONS(2731),
    [sym_this] = ACTIONS(2731),
  },
  [702] = {
    [ts_builtin_sym_end] = ACTIONS(2737),
    [sym_identifier] = ACTIONS(2735),
    [aux_sym_preproc_include_token1] = ACTIONS(2735),
    [aux_sym_preproc_def_token1] = ACTIONS(2735),
    [aux_sym_preproc_if_token1] = ACTIONS(2735),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2735),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2735),
    [sym_preproc_directive] = ACTIONS(2735),
    [anon_sym_LPAREN2] = ACTIONS(2737),
    [anon_sym_BANG] = ACTIONS(2737),
    [anon_sym_TILDE] = ACTIONS(2737),
    [anon_sym_DASH] = ACTIONS(2735),
    [anon_sym_PLUS] = ACTIONS(2735),
    [anon_sym_STAR] = ACTIONS(2737),
    [anon_sym_AMP_AMP] = ACTIONS(2737),
    [anon_sym_AMP] = ACTIONS(2735),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym___extension__] = ACTIONS(2735),
    [anon_sym_typedef] = ACTIONS(2735),
    [anon_sym_virtual] = ACTIONS(2735),
    [anon_sym_extern] = ACTIONS(2735),
    [anon_sym___attribute__] = ACTIONS(2735),
    [anon_sym___attribute] = ACTIONS(2735),
    [anon_sym_COLON_COLON] = ACTIONS(2737),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2737),
    [anon_sym___declspec] = ACTIONS(2735),
    [anon_sym___based] = ACTIONS(2735),
    [anon_sym___cdecl] = ACTIONS(2735),
    [anon_sym___clrcall] = ACTIONS(2735),
    [anon_sym___stdcall] = ACTIONS(2735),
    [anon_sym___fastcall] = ACTIONS(2735),
    [anon_sym___thiscall] = ACTIONS(2735),
    [anon_sym___vectorcall] = ACTIONS(2735),
    [anon_sym_LBRACE] = ACTIONS(2737),
    [anon_sym_signed] = ACTIONS(2735),
    [anon_sym_unsigned] = ACTIONS(2735),
    [anon_sym_long] = ACTIONS(2735),
    [anon_sym_short] = ACTIONS(2735),
    [anon_sym_LBRACK] = ACTIONS(2735),
    [anon_sym_static] = ACTIONS(2735),
    [anon_sym_register] = ACTIONS(2735),
    [anon_sym_inline] = ACTIONS(2735),
    [anon_sym___inline] = ACTIONS(2735),
    [anon_sym___inline__] = ACTIONS(2735),
    [anon_sym___forceinline] = ACTIONS(2735),
    [anon_sym_thread_local] = ACTIONS(2735),
    [anon_sym___thread] = ACTIONS(2735),
    [anon_sym_const] = ACTIONS(2735),
    [anon_sym_constexpr] = ACTIONS(2735),
    [anon_sym_volatile] = ACTIONS(2735),
    [anon_sym_restrict] = ACTIONS(2735),
    [anon_sym___restrict__] = ACTIONS(2735),
    [anon_sym__Atomic] = ACTIONS(2735),
    [anon_sym__Noreturn] = ACTIONS(2735),
    [anon_sym_noreturn] = ACTIONS(2735),
    [anon_sym__Nonnull] = ACTIONS(2735),
    [anon_sym_mutable] = ACTIONS(2735),
    [anon_sym_constinit] = ACTIONS(2735),
    [anon_sym_consteval] = ACTIONS(2735),
    [anon_sym_alignas] = ACTIONS(2735),
    [anon_sym__Alignas] = ACTIONS(2735),
    [sym_primitive_type] = ACTIONS(2735),
    [anon_sym_enum] = ACTIONS(2735),
    [anon_sym_class] = ACTIONS(2735),
    [anon_sym_struct] = ACTIONS(2735),
    [anon_sym_union] = ACTIONS(2735),
    [anon_sym_if] = ACTIONS(2735),
    [anon_sym_switch] = ACTIONS(2735),
    [anon_sym_case] = ACTIONS(2735),
    [anon_sym_default] = ACTIONS(2735),
    [anon_sym_while] = ACTIONS(2735),
    [anon_sym_do] = ACTIONS(2735),
    [anon_sym_for] = ACTIONS(2735),
    [anon_sym_return] = ACTIONS(2735),
    [anon_sym_break] = ACTIONS(2735),
    [anon_sym_continue] = ACTIONS(2735),
    [anon_sym_goto] = ACTIONS(2735),
    [anon_sym_not] = ACTIONS(2735),
    [anon_sym_compl] = ACTIONS(2735),
    [anon_sym_DASH_DASH] = ACTIONS(2737),
    [anon_sym_PLUS_PLUS] = ACTIONS(2737),
    [anon_sym_sizeof] = ACTIONS(2735),
    [anon_sym___alignof__] = ACTIONS(2735),
    [anon_sym___alignof] = ACTIONS(2735),
    [anon_sym__alignof] = ACTIONS(2735),
    [anon_sym_alignof] = ACTIONS(2735),
    [anon_sym__Alignof] = ACTIONS(2735),
    [anon_sym_offsetof] = ACTIONS(2735),
    [anon_sym__Generic] = ACTIONS(2735),
    [anon_sym_asm] = ACTIONS(2735),
    [anon_sym___asm__] = ACTIONS(2735),
    [anon_sym___asm] = ACTIONS(2735),
    [sym_number_literal] = ACTIONS(2737),
    [anon_sym_L_SQUOTE] = ACTIONS(2737),
    [anon_sym_u_SQUOTE] = ACTIONS(2737),
    [anon_sym_U_SQUOTE] = ACTIONS(2737),
    [anon_sym_u8_SQUOTE] = ACTIONS(2737),
    [anon_sym_SQUOTE] = ACTIONS(2737),
    [anon_sym_L_DQUOTE] = ACTIONS(2737),
    [anon_sym_u_DQUOTE] = ACTIONS(2737),
    [anon_sym_U_DQUOTE] = ACTIONS(2737),
    [anon_sym_u8_DQUOTE] = ACTIONS(2737),
    [anon_sym_DQUOTE] = ACTIONS(2737),
    [sym_true] = ACTIONS(2735),
    [sym_false] = ACTIONS(2735),
    [anon_sym_NULL] = ACTIONS(2735),
    [anon_sym_nullptr] = ACTIONS(2735),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2735),
    [anon_sym_decltype] = ACTIONS(2735),
    [anon_sym_explicit] = ACTIONS(2735),
    [anon_sym_typename] = ACTIONS(2735),
    [anon_sym_template] = ACTIONS(2735),
    [anon_sym_operator] = ACTIONS(2735),
    [anon_sym_try] = ACTIONS(2735),
    [anon_sym_delete] = ACTIONS(2735),
    [anon_sym_throw] = ACTIONS(2735),
    [anon_sym_namespace] = ACTIONS(2735),
    [anon_sym_using] = ACTIONS(2735),
    [anon_sym_static_assert] = ACTIONS(2735),
    [anon_sym_concept] = ACTIONS(2735),
    [anon_sym_co_return] = ACTIONS(2735),
    [anon_sym_co_yield] = ACTIONS(2735),
    [anon_sym_R_DQUOTE] = ACTIONS(2737),
    [anon_sym_LR_DQUOTE] = ACTIONS(2737),
    [anon_sym_uR_DQUOTE] = ACTIONS(2737),
    [anon_sym_UR_DQUOTE] = ACTIONS(2737),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2737),
    [anon_sym_co_await] = ACTIONS(2735),
    [anon_sym_new] = ACTIONS(2735),
    [anon_sym_requires] = ACTIONS(2735),
    [sym_this] = ACTIONS(2735),
  },
  [703] = {
    [ts_builtin_sym_end] = ACTIONS(2741),
    [sym_identifier] = ACTIONS(2739),
    [aux_sym_preproc_include_token1] = ACTIONS(2739),
    [aux_sym_preproc_def_token1] = ACTIONS(2739),
    [aux_sym_preproc_if_token1] = ACTIONS(2739),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2739),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2739),
    [sym_preproc_directive] = ACTIONS(2739),
    [anon_sym_LPAREN2] = ACTIONS(2741),
    [anon_sym_BANG] = ACTIONS(2741),
    [anon_sym_TILDE] = ACTIONS(2741),
    [anon_sym_DASH] = ACTIONS(2739),
    [anon_sym_PLUS] = ACTIONS(2739),
    [anon_sym_STAR] = ACTIONS(2741),
    [anon_sym_AMP_AMP] = ACTIONS(2741),
    [anon_sym_AMP] = ACTIONS(2739),
    [anon_sym_SEMI] = ACTIONS(2741),
    [anon_sym___extension__] = ACTIONS(2739),
    [anon_sym_typedef] = ACTIONS(2739),
    [anon_sym_virtual] = ACTIONS(2739),
    [anon_sym_extern] = ACTIONS(2739),
    [anon_sym___attribute__] = ACTIONS(2739),
    [anon_sym___attribute] = ACTIONS(2739),
    [anon_sym_COLON_COLON] = ACTIONS(2741),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2741),
    [anon_sym___declspec] = ACTIONS(2739),
    [anon_sym___based] = ACTIONS(2739),
    [anon_sym___cdecl] = ACTIONS(2739),
    [anon_sym___clrcall] = ACTIONS(2739),
    [anon_sym___stdcall] = ACTIONS(2739),
    [anon_sym___fastcall] = ACTIONS(2739),
    [anon_sym___thiscall] = ACTIONS(2739),
    [anon_sym___vectorcall] = ACTIONS(2739),
    [anon_sym_LBRACE] = ACTIONS(2741),
    [anon_sym_signed] = ACTIONS(2739),
    [anon_sym_unsigned] = ACTIONS(2739),
    [anon_sym_long] = ACTIONS(2739),
    [anon_sym_short] = ACTIONS(2739),
    [anon_sym_LBRACK] = ACTIONS(2739),
    [anon_sym_static] = ACTIONS(2739),
    [anon_sym_register] = ACTIONS(2739),
    [anon_sym_inline] = ACTIONS(2739),
    [anon_sym___inline] = ACTIONS(2739),
    [anon_sym___inline__] = ACTIONS(2739),
    [anon_sym___forceinline] = ACTIONS(2739),
    [anon_sym_thread_local] = ACTIONS(2739),
    [anon_sym___thread] = ACTIONS(2739),
    [anon_sym_const] = ACTIONS(2739),
    [anon_sym_constexpr] = ACTIONS(2739),
    [anon_sym_volatile] = ACTIONS(2739),
    [anon_sym_restrict] = ACTIONS(2739),
    [anon_sym___restrict__] = ACTIONS(2739),
    [anon_sym__Atomic] = ACTIONS(2739),
    [anon_sym__Noreturn] = ACTIONS(2739),
    [anon_sym_noreturn] = ACTIONS(2739),
    [anon_sym__Nonnull] = ACTIONS(2739),
    [anon_sym_mutable] = ACTIONS(2739),
    [anon_sym_constinit] = ACTIONS(2739),
    [anon_sym_consteval] = ACTIONS(2739),
    [anon_sym_alignas] = ACTIONS(2739),
    [anon_sym__Alignas] = ACTIONS(2739),
    [sym_primitive_type] = ACTIONS(2739),
    [anon_sym_enum] = ACTIONS(2739),
    [anon_sym_class] = ACTIONS(2739),
    [anon_sym_struct] = ACTIONS(2739),
    [anon_sym_union] = ACTIONS(2739),
    [anon_sym_if] = ACTIONS(2739),
    [anon_sym_switch] = ACTIONS(2739),
    [anon_sym_case] = ACTIONS(2739),
    [anon_sym_default] = ACTIONS(2739),
    [anon_sym_while] = ACTIONS(2739),
    [anon_sym_do] = ACTIONS(2739),
    [anon_sym_for] = ACTIONS(2739),
    [anon_sym_return] = ACTIONS(2739),
    [anon_sym_break] = ACTIONS(2739),
    [anon_sym_continue] = ACTIONS(2739),
    [anon_sym_goto] = ACTIONS(2739),
    [anon_sym_not] = ACTIONS(2739),
    [anon_sym_compl] = ACTIONS(2739),
    [anon_sym_DASH_DASH] = ACTIONS(2741),
    [anon_sym_PLUS_PLUS] = ACTIONS(2741),
    [anon_sym_sizeof] = ACTIONS(2739),
    [anon_sym___alignof__] = ACTIONS(2739),
    [anon_sym___alignof] = ACTIONS(2739),
    [anon_sym__alignof] = ACTIONS(2739),
    [anon_sym_alignof] = ACTIONS(2739),
    [anon_sym__Alignof] = ACTIONS(2739),
    [anon_sym_offsetof] = ACTIONS(2739),
    [anon_sym__Generic] = ACTIONS(2739),
    [anon_sym_asm] = ACTIONS(2739),
    [anon_sym___asm__] = ACTIONS(2739),
    [anon_sym___asm] = ACTIONS(2739),
    [sym_number_literal] = ACTIONS(2741),
    [anon_sym_L_SQUOTE] = ACTIONS(2741),
    [anon_sym_u_SQUOTE] = ACTIONS(2741),
    [anon_sym_U_SQUOTE] = ACTIONS(2741),
    [anon_sym_u8_SQUOTE] = ACTIONS(2741),
    [anon_sym_SQUOTE] = ACTIONS(2741),
    [anon_sym_L_DQUOTE] = ACTIONS(2741),
    [anon_sym_u_DQUOTE] = ACTIONS(2741),
    [anon_sym_U_DQUOTE] = ACTIONS(2741),
    [anon_sym_u8_DQUOTE] = ACTIONS(2741),
    [anon_sym_DQUOTE] = ACTIONS(2741),
    [sym_true] = ACTIONS(2739),
    [sym_false] = ACTIONS(2739),
    [anon_sym_NULL] = ACTIONS(2739),
    [anon_sym_nullptr] = ACTIONS(2739),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2739),
    [anon_sym_decltype] = ACTIONS(2739),
    [anon_sym_explicit] = ACTIONS(2739),
    [anon_sym_typename] = ACTIONS(2739),
    [anon_sym_template] = ACTIONS(2739),
    [anon_sym_operator] = ACTIONS(2739),
    [anon_sym_try] = ACTIONS(2739),
    [anon_sym_delete] = ACTIONS(2739),
    [anon_sym_throw] = ACTIONS(2739),
    [anon_sym_namespace] = ACTIONS(2739),
    [anon_sym_using] = ACTIONS(2739),
    [anon_sym_static_assert] = ACTIONS(2739),
    [anon_sym_concept] = ACTIONS(2739),
    [anon_sym_co_return] = ACTIONS(2739),
    [anon_sym_co_yield] = ACTIONS(2739),
    [anon_sym_R_DQUOTE] = ACTIONS(2741),
    [anon_sym_LR_DQUOTE] = ACTIONS(2741),
    [anon_sym_uR_DQUOTE] = ACTIONS(2741),
    [anon_sym_UR_DQUOTE] = ACTIONS(2741),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2741),
    [anon_sym_co_await] = ACTIONS(2739),
    [anon_sym_new] = ACTIONS(2739),
    [anon_sym_requires] = ACTIONS(2739),
    [sym_this] = ACTIONS(2739),
  },
  [704] = {
    [sym_expression] = STATE(3655),
    [sym__string] = STATE(4127),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(2853),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(2853),
    [sym_call_expression] = STATE(2853),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(2853),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(2853),
    [sym_initializer_list] = STATE(3776),
    [sym_char_literal] = STATE(4127),
    [sym_concatenated_string] = STATE(4127),
    [sym_string_literal] = STATE(3058),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3058),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2853),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(2853),
    [sym_identifier] = ACTIONS(1915),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1917),
    [anon_sym_COMMA] = ACTIONS(1917),
    [aux_sym_preproc_if_token2] = ACTIONS(1917),
    [aux_sym_preproc_else_token1] = ACTIONS(1917),
    [aux_sym_preproc_elif_token1] = ACTIONS(1915),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1917),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1917),
    [anon_sym_LPAREN2] = ACTIONS(1917),
    [anon_sym_BANG] = ACTIONS(3458),
    [anon_sym_TILDE] = ACTIONS(3460),
    [anon_sym_DASH] = ACTIONS(1915),
    [anon_sym_PLUS] = ACTIONS(1915),
    [anon_sym_STAR] = ACTIONS(1917),
    [anon_sym_SLASH] = ACTIONS(1915),
    [anon_sym_PERCENT] = ACTIONS(1917),
    [anon_sym_PIPE_PIPE] = ACTIONS(1917),
    [anon_sym_AMP_AMP] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(1915),
    [anon_sym_CARET] = ACTIONS(1917),
    [anon_sym_AMP] = ACTIONS(1915),
    [anon_sym_EQ_EQ] = ACTIONS(1917),
    [anon_sym_BANG_EQ] = ACTIONS(1917),
    [anon_sym_GT] = ACTIONS(1915),
    [anon_sym_GT_EQ] = ACTIONS(1917),
    [anon_sym_LT_EQ] = ACTIONS(1915),
    [anon_sym_LT] = ACTIONS(1915),
    [anon_sym_LT_LT] = ACTIONS(1917),
    [anon_sym_GT_GT] = ACTIONS(1917),
    [anon_sym___extension__] = ACTIONS(3462),
    [anon_sym_COLON_COLON] = ACTIONS(3464),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(1917),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_QMARK] = ACTIONS(1917),
    [anon_sym_not] = ACTIONS(3458),
    [anon_sym_compl] = ACTIONS(3458),
    [anon_sym_LT_EQ_GT] = ACTIONS(1917),
    [anon_sym_or] = ACTIONS(1915),
    [anon_sym_and] = ACTIONS(1915),
    [anon_sym_bitor] = ACTIONS(1915),
    [anon_sym_xor] = ACTIONS(1915),
    [anon_sym_bitand] = ACTIONS(1915),
    [anon_sym_not_eq] = ACTIONS(1915),
    [anon_sym_DASH_DASH] = ACTIONS(1917),
    [anon_sym_PLUS_PLUS] = ACTIONS(1917),
    [anon_sym_sizeof] = ACTIONS(3468),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(1915),
    [anon_sym_DOT_STAR] = ACTIONS(1917),
    [anon_sym_DASH_GT] = ACTIONS(1917),
    [sym_number_literal] = ACTIONS(3470),
    [anon_sym_L_SQUOTE] = ACTIONS(3472),
    [anon_sym_u_SQUOTE] = ACTIONS(3472),
    [anon_sym_U_SQUOTE] = ACTIONS(3472),
    [anon_sym_u8_SQUOTE] = ACTIONS(3472),
    [anon_sym_SQUOTE] = ACTIONS(3472),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3476),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
    [anon_sym_co_await] = ACTIONS(3480),
    [anon_sym_new] = ACTIONS(3482),
    [anon_sym_requires] = ACTIONS(3484),
    [sym_this] = ACTIONS(221),
  },
  [705] = {
    [ts_builtin_sym_end] = ACTIONS(2749),
    [sym_identifier] = ACTIONS(2747),
    [aux_sym_preproc_include_token1] = ACTIONS(2747),
    [aux_sym_preproc_def_token1] = ACTIONS(2747),
    [aux_sym_preproc_if_token1] = ACTIONS(2747),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2747),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2747),
    [sym_preproc_directive] = ACTIONS(2747),
    [anon_sym_LPAREN2] = ACTIONS(2749),
    [anon_sym_BANG] = ACTIONS(2749),
    [anon_sym_TILDE] = ACTIONS(2749),
    [anon_sym_DASH] = ACTIONS(2747),
    [anon_sym_PLUS] = ACTIONS(2747),
    [anon_sym_STAR] = ACTIONS(2749),
    [anon_sym_AMP_AMP] = ACTIONS(2749),
    [anon_sym_AMP] = ACTIONS(2747),
    [anon_sym_SEMI] = ACTIONS(2749),
    [anon_sym___extension__] = ACTIONS(2747),
    [anon_sym_typedef] = ACTIONS(2747),
    [anon_sym_virtual] = ACTIONS(2747),
    [anon_sym_extern] = ACTIONS(2747),
    [anon_sym___attribute__] = ACTIONS(2747),
    [anon_sym___attribute] = ACTIONS(2747),
    [anon_sym_COLON_COLON] = ACTIONS(2749),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2749),
    [anon_sym___declspec] = ACTIONS(2747),
    [anon_sym___based] = ACTIONS(2747),
    [anon_sym___cdecl] = ACTIONS(2747),
    [anon_sym___clrcall] = ACTIONS(2747),
    [anon_sym___stdcall] = ACTIONS(2747),
    [anon_sym___fastcall] = ACTIONS(2747),
    [anon_sym___thiscall] = ACTIONS(2747),
    [anon_sym___vectorcall] = ACTIONS(2747),
    [anon_sym_LBRACE] = ACTIONS(2749),
    [anon_sym_signed] = ACTIONS(2747),
    [anon_sym_unsigned] = ACTIONS(2747),
    [anon_sym_long] = ACTIONS(2747),
    [anon_sym_short] = ACTIONS(2747),
    [anon_sym_LBRACK] = ACTIONS(2747),
    [anon_sym_static] = ACTIONS(2747),
    [anon_sym_register] = ACTIONS(2747),
    [anon_sym_inline] = ACTIONS(2747),
    [anon_sym___inline] = ACTIONS(2747),
    [anon_sym___inline__] = ACTIONS(2747),
    [anon_sym___forceinline] = ACTIONS(2747),
    [anon_sym_thread_local] = ACTIONS(2747),
    [anon_sym___thread] = ACTIONS(2747),
    [anon_sym_const] = ACTIONS(2747),
    [anon_sym_constexpr] = ACTIONS(2747),
    [anon_sym_volatile] = ACTIONS(2747),
    [anon_sym_restrict] = ACTIONS(2747),
    [anon_sym___restrict__] = ACTIONS(2747),
    [anon_sym__Atomic] = ACTIONS(2747),
    [anon_sym__Noreturn] = ACTIONS(2747),
    [anon_sym_noreturn] = ACTIONS(2747),
    [anon_sym__Nonnull] = ACTIONS(2747),
    [anon_sym_mutable] = ACTIONS(2747),
    [anon_sym_constinit] = ACTIONS(2747),
    [anon_sym_consteval] = ACTIONS(2747),
    [anon_sym_alignas] = ACTIONS(2747),
    [anon_sym__Alignas] = ACTIONS(2747),
    [sym_primitive_type] = ACTIONS(2747),
    [anon_sym_enum] = ACTIONS(2747),
    [anon_sym_class] = ACTIONS(2747),
    [anon_sym_struct] = ACTIONS(2747),
    [anon_sym_union] = ACTIONS(2747),
    [anon_sym_if] = ACTIONS(2747),
    [anon_sym_switch] = ACTIONS(2747),
    [anon_sym_case] = ACTIONS(2747),
    [anon_sym_default] = ACTIONS(2747),
    [anon_sym_while] = ACTIONS(2747),
    [anon_sym_do] = ACTIONS(2747),
    [anon_sym_for] = ACTIONS(2747),
    [anon_sym_return] = ACTIONS(2747),
    [anon_sym_break] = ACTIONS(2747),
    [anon_sym_continue] = ACTIONS(2747),
    [anon_sym_goto] = ACTIONS(2747),
    [anon_sym_not] = ACTIONS(2747),
    [anon_sym_compl] = ACTIONS(2747),
    [anon_sym_DASH_DASH] = ACTIONS(2749),
    [anon_sym_PLUS_PLUS] = ACTIONS(2749),
    [anon_sym_sizeof] = ACTIONS(2747),
    [anon_sym___alignof__] = ACTIONS(2747),
    [anon_sym___alignof] = ACTIONS(2747),
    [anon_sym__alignof] = ACTIONS(2747),
    [anon_sym_alignof] = ACTIONS(2747),
    [anon_sym__Alignof] = ACTIONS(2747),
    [anon_sym_offsetof] = ACTIONS(2747),
    [anon_sym__Generic] = ACTIONS(2747),
    [anon_sym_asm] = ACTIONS(2747),
    [anon_sym___asm__] = ACTIONS(2747),
    [anon_sym___asm] = ACTIONS(2747),
    [sym_number_literal] = ACTIONS(2749),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2749),
    [anon_sym_u_DQUOTE] = ACTIONS(2749),
    [anon_sym_U_DQUOTE] = ACTIONS(2749),
    [anon_sym_u8_DQUOTE] = ACTIONS(2749),
    [anon_sym_DQUOTE] = ACTIONS(2749),
    [sym_true] = ACTIONS(2747),
    [sym_false] = ACTIONS(2747),
    [anon_sym_NULL] = ACTIONS(2747),
    [anon_sym_nullptr] = ACTIONS(2747),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2747),
    [anon_sym_decltype] = ACTIONS(2747),
    [anon_sym_explicit] = ACTIONS(2747),
    [anon_sym_typename] = ACTIONS(2747),
    [anon_sym_template] = ACTIONS(2747),
    [anon_sym_operator] = ACTIONS(2747),
    [anon_sym_try] = ACTIONS(2747),
    [anon_sym_delete] = ACTIONS(2747),
    [anon_sym_throw] = ACTIONS(2747),
    [anon_sym_namespace] = ACTIONS(2747),
    [anon_sym_using] = ACTIONS(2747),
    [anon_sym_static_assert] = ACTIONS(2747),
    [anon_sym_concept] = ACTIONS(2747),
    [anon_sym_co_return] = ACTIONS(2747),
    [anon_sym_co_yield] = ACTIONS(2747),
    [anon_sym_R_DQUOTE] = ACTIONS(2749),
    [anon_sym_LR_DQUOTE] = ACTIONS(2749),
    [anon_sym_uR_DQUOTE] = ACTIONS(2749),
    [anon_sym_UR_DQUOTE] = ACTIONS(2749),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2749),
    [anon_sym_co_await] = ACTIONS(2747),
    [anon_sym_new] = ACTIONS(2747),
    [anon_sym_requires] = ACTIONS(2747),
    [sym_this] = ACTIONS(2747),
  },
  [706] = {
    [ts_builtin_sym_end] = ACTIONS(2749),
    [sym_identifier] = ACTIONS(2747),
    [aux_sym_preproc_include_token1] = ACTIONS(2747),
    [aux_sym_preproc_def_token1] = ACTIONS(2747),
    [aux_sym_preproc_if_token1] = ACTIONS(2747),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2747),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2747),
    [sym_preproc_directive] = ACTIONS(2747),
    [anon_sym_LPAREN2] = ACTIONS(2749),
    [anon_sym_BANG] = ACTIONS(2749),
    [anon_sym_TILDE] = ACTIONS(2749),
    [anon_sym_DASH] = ACTIONS(2747),
    [anon_sym_PLUS] = ACTIONS(2747),
    [anon_sym_STAR] = ACTIONS(2749),
    [anon_sym_AMP_AMP] = ACTIONS(2749),
    [anon_sym_AMP] = ACTIONS(2747),
    [anon_sym_SEMI] = ACTIONS(2749),
    [anon_sym___extension__] = ACTIONS(2747),
    [anon_sym_typedef] = ACTIONS(2747),
    [anon_sym_virtual] = ACTIONS(2747),
    [anon_sym_extern] = ACTIONS(2747),
    [anon_sym___attribute__] = ACTIONS(2747),
    [anon_sym___attribute] = ACTIONS(2747),
    [anon_sym_COLON_COLON] = ACTIONS(2749),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2749),
    [anon_sym___declspec] = ACTIONS(2747),
    [anon_sym___based] = ACTIONS(2747),
    [anon_sym___cdecl] = ACTIONS(2747),
    [anon_sym___clrcall] = ACTIONS(2747),
    [anon_sym___stdcall] = ACTIONS(2747),
    [anon_sym___fastcall] = ACTIONS(2747),
    [anon_sym___thiscall] = ACTIONS(2747),
    [anon_sym___vectorcall] = ACTIONS(2747),
    [anon_sym_LBRACE] = ACTIONS(2749),
    [anon_sym_signed] = ACTIONS(2747),
    [anon_sym_unsigned] = ACTIONS(2747),
    [anon_sym_long] = ACTIONS(2747),
    [anon_sym_short] = ACTIONS(2747),
    [anon_sym_LBRACK] = ACTIONS(2747),
    [anon_sym_static] = ACTIONS(2747),
    [anon_sym_register] = ACTIONS(2747),
    [anon_sym_inline] = ACTIONS(2747),
    [anon_sym___inline] = ACTIONS(2747),
    [anon_sym___inline__] = ACTIONS(2747),
    [anon_sym___forceinline] = ACTIONS(2747),
    [anon_sym_thread_local] = ACTIONS(2747),
    [anon_sym___thread] = ACTIONS(2747),
    [anon_sym_const] = ACTIONS(2747),
    [anon_sym_constexpr] = ACTIONS(2747),
    [anon_sym_volatile] = ACTIONS(2747),
    [anon_sym_restrict] = ACTIONS(2747),
    [anon_sym___restrict__] = ACTIONS(2747),
    [anon_sym__Atomic] = ACTIONS(2747),
    [anon_sym__Noreturn] = ACTIONS(2747),
    [anon_sym_noreturn] = ACTIONS(2747),
    [anon_sym__Nonnull] = ACTIONS(2747),
    [anon_sym_mutable] = ACTIONS(2747),
    [anon_sym_constinit] = ACTIONS(2747),
    [anon_sym_consteval] = ACTIONS(2747),
    [anon_sym_alignas] = ACTIONS(2747),
    [anon_sym__Alignas] = ACTIONS(2747),
    [sym_primitive_type] = ACTIONS(2747),
    [anon_sym_enum] = ACTIONS(2747),
    [anon_sym_class] = ACTIONS(2747),
    [anon_sym_struct] = ACTIONS(2747),
    [anon_sym_union] = ACTIONS(2747),
    [anon_sym_if] = ACTIONS(2747),
    [anon_sym_switch] = ACTIONS(2747),
    [anon_sym_case] = ACTIONS(2747),
    [anon_sym_default] = ACTIONS(2747),
    [anon_sym_while] = ACTIONS(2747),
    [anon_sym_do] = ACTIONS(2747),
    [anon_sym_for] = ACTIONS(2747),
    [anon_sym_return] = ACTIONS(2747),
    [anon_sym_break] = ACTIONS(2747),
    [anon_sym_continue] = ACTIONS(2747),
    [anon_sym_goto] = ACTIONS(2747),
    [anon_sym_not] = ACTIONS(2747),
    [anon_sym_compl] = ACTIONS(2747),
    [anon_sym_DASH_DASH] = ACTIONS(2749),
    [anon_sym_PLUS_PLUS] = ACTIONS(2749),
    [anon_sym_sizeof] = ACTIONS(2747),
    [anon_sym___alignof__] = ACTIONS(2747),
    [anon_sym___alignof] = ACTIONS(2747),
    [anon_sym__alignof] = ACTIONS(2747),
    [anon_sym_alignof] = ACTIONS(2747),
    [anon_sym__Alignof] = ACTIONS(2747),
    [anon_sym_offsetof] = ACTIONS(2747),
    [anon_sym__Generic] = ACTIONS(2747),
    [anon_sym_asm] = ACTIONS(2747),
    [anon_sym___asm__] = ACTIONS(2747),
    [anon_sym___asm] = ACTIONS(2747),
    [sym_number_literal] = ACTIONS(2749),
    [anon_sym_L_SQUOTE] = ACTIONS(2749),
    [anon_sym_u_SQUOTE] = ACTIONS(2749),
    [anon_sym_U_SQUOTE] = ACTIONS(2749),
    [anon_sym_u8_SQUOTE] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2749),
    [anon_sym_L_DQUOTE] = ACTIONS(2749),
    [anon_sym_u_DQUOTE] = ACTIONS(2749),
    [anon_sym_U_DQUOTE] = ACTIONS(2749),
    [anon_sym_u8_DQUOTE] = ACTIONS(2749),
    [anon_sym_DQUOTE] = ACTIONS(2749),
    [sym_true] = ACTIONS(2747),
    [sym_false] = ACTIONS(2747),
    [anon_sym_NULL] = ACTIONS(2747),
    [anon_sym_nullptr] = ACTIONS(2747),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2747),
    [anon_sym_decltype] = ACTIONS(2747),
    [anon_sym_explicit] = ACTIONS(2747),
    [anon_sym_typename] = ACTIONS(2747),
    [anon_sym_template] = ACTIONS(2747),
    [anon_sym_operator] = ACTIONS(2747),
    [anon_sym_try] = ACTIONS(2747),
    [anon_sym_delete] = ACTIONS(2747),
    [anon_sym_throw] = ACTIONS(2747),
    [anon_sym_namespace] = ACTIONS(2747),
    [anon_sym_using] = ACTIONS(2747),
    [anon_sym_static_assert] = ACTIONS(2747),
    [anon_sym_concept] = ACTIONS(2747),
    [anon_sym_co_return] = ACTIONS(2747),
    [anon_sym_co_yield] = ACTIONS(2747),
    [anon_sym_R_DQUOTE] = ACTIONS(2749),
    [anon_sym_LR_DQUOTE] = ACTIONS(2749),
    [anon_sym_uR_DQUOTE] = ACTIONS(2749),
    [anon_sym_UR_DQUOTE] = ACTIONS(2749),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2749),
    [anon_sym_co_await] = ACTIONS(2747),
    [anon_sym_new] = ACTIONS(2747),
    [anon_sym_requires] = ACTIONS(2747),
    [sym_this] = ACTIONS(2747),
  },
  [707] = {
    [ts_builtin_sym_end] = ACTIONS(3172),
    [sym_identifier] = ACTIONS(3170),
    [aux_sym_preproc_include_token1] = ACTIONS(3170),
    [aux_sym_preproc_def_token1] = ACTIONS(3170),
    [aux_sym_preproc_if_token1] = ACTIONS(3170),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3170),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3170),
    [sym_preproc_directive] = ACTIONS(3170),
    [anon_sym_LPAREN2] = ACTIONS(3172),
    [anon_sym_BANG] = ACTIONS(3172),
    [anon_sym_TILDE] = ACTIONS(3172),
    [anon_sym_DASH] = ACTIONS(3170),
    [anon_sym_PLUS] = ACTIONS(3170),
    [anon_sym_STAR] = ACTIONS(3172),
    [anon_sym_AMP_AMP] = ACTIONS(3172),
    [anon_sym_AMP] = ACTIONS(3170),
    [anon_sym_SEMI] = ACTIONS(3172),
    [anon_sym___extension__] = ACTIONS(3170),
    [anon_sym_typedef] = ACTIONS(3170),
    [anon_sym_virtual] = ACTIONS(3170),
    [anon_sym_extern] = ACTIONS(3170),
    [anon_sym___attribute__] = ACTIONS(3170),
    [anon_sym___attribute] = ACTIONS(3170),
    [anon_sym_COLON_COLON] = ACTIONS(3172),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3172),
    [anon_sym___declspec] = ACTIONS(3170),
    [anon_sym___based] = ACTIONS(3170),
    [anon_sym___cdecl] = ACTIONS(3170),
    [anon_sym___clrcall] = ACTIONS(3170),
    [anon_sym___stdcall] = ACTIONS(3170),
    [anon_sym___fastcall] = ACTIONS(3170),
    [anon_sym___thiscall] = ACTIONS(3170),
    [anon_sym___vectorcall] = ACTIONS(3170),
    [anon_sym_LBRACE] = ACTIONS(3172),
    [anon_sym_signed] = ACTIONS(3170),
    [anon_sym_unsigned] = ACTIONS(3170),
    [anon_sym_long] = ACTIONS(3170),
    [anon_sym_short] = ACTIONS(3170),
    [anon_sym_LBRACK] = ACTIONS(3170),
    [anon_sym_static] = ACTIONS(3170),
    [anon_sym_register] = ACTIONS(3170),
    [anon_sym_inline] = ACTIONS(3170),
    [anon_sym___inline] = ACTIONS(3170),
    [anon_sym___inline__] = ACTIONS(3170),
    [anon_sym___forceinline] = ACTIONS(3170),
    [anon_sym_thread_local] = ACTIONS(3170),
    [anon_sym___thread] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3170),
    [anon_sym_constexpr] = ACTIONS(3170),
    [anon_sym_volatile] = ACTIONS(3170),
    [anon_sym_restrict] = ACTIONS(3170),
    [anon_sym___restrict__] = ACTIONS(3170),
    [anon_sym__Atomic] = ACTIONS(3170),
    [anon_sym__Noreturn] = ACTIONS(3170),
    [anon_sym_noreturn] = ACTIONS(3170),
    [anon_sym__Nonnull] = ACTIONS(3170),
    [anon_sym_mutable] = ACTIONS(3170),
    [anon_sym_constinit] = ACTIONS(3170),
    [anon_sym_consteval] = ACTIONS(3170),
    [anon_sym_alignas] = ACTIONS(3170),
    [anon_sym__Alignas] = ACTIONS(3170),
    [sym_primitive_type] = ACTIONS(3170),
    [anon_sym_enum] = ACTIONS(3170),
    [anon_sym_class] = ACTIONS(3170),
    [anon_sym_struct] = ACTIONS(3170),
    [anon_sym_union] = ACTIONS(3170),
    [anon_sym_if] = ACTIONS(3170),
    [anon_sym_switch] = ACTIONS(3170),
    [anon_sym_case] = ACTIONS(3170),
    [anon_sym_default] = ACTIONS(3170),
    [anon_sym_while] = ACTIONS(3170),
    [anon_sym_do] = ACTIONS(3170),
    [anon_sym_for] = ACTIONS(3170),
    [anon_sym_return] = ACTIONS(3170),
    [anon_sym_break] = ACTIONS(3170),
    [anon_sym_continue] = ACTIONS(3170),
    [anon_sym_goto] = ACTIONS(3170),
    [anon_sym_not] = ACTIONS(3170),
    [anon_sym_compl] = ACTIONS(3170),
    [anon_sym_DASH_DASH] = ACTIONS(3172),
    [anon_sym_PLUS_PLUS] = ACTIONS(3172),
    [anon_sym_sizeof] = ACTIONS(3170),
    [anon_sym___alignof__] = ACTIONS(3170),
    [anon_sym___alignof] = ACTIONS(3170),
    [anon_sym__alignof] = ACTIONS(3170),
    [anon_sym_alignof] = ACTIONS(3170),
    [anon_sym__Alignof] = ACTIONS(3170),
    [anon_sym_offsetof] = ACTIONS(3170),
    [anon_sym__Generic] = ACTIONS(3170),
    [anon_sym_asm] = ACTIONS(3170),
    [anon_sym___asm__] = ACTIONS(3170),
    [anon_sym___asm] = ACTIONS(3170),
    [sym_number_literal] = ACTIONS(3172),
    [anon_sym_L_SQUOTE] = ACTIONS(3172),
    [anon_sym_u_SQUOTE] = ACTIONS(3172),
    [anon_sym_U_SQUOTE] = ACTIONS(3172),
    [anon_sym_u8_SQUOTE] = ACTIONS(3172),
    [anon_sym_SQUOTE] = ACTIONS(3172),
    [anon_sym_L_DQUOTE] = ACTIONS(3172),
    [anon_sym_u_DQUOTE] = ACTIONS(3172),
    [anon_sym_U_DQUOTE] = ACTIONS(3172),
    [anon_sym_u8_DQUOTE] = ACTIONS(3172),
    [anon_sym_DQUOTE] = ACTIONS(3172),
    [sym_true] = ACTIONS(3170),
    [sym_false] = ACTIONS(3170),
    [anon_sym_NULL] = ACTIONS(3170),
    [anon_sym_nullptr] = ACTIONS(3170),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3170),
    [anon_sym_decltype] = ACTIONS(3170),
    [anon_sym_explicit] = ACTIONS(3170),
    [anon_sym_typename] = ACTIONS(3170),
    [anon_sym_template] = ACTIONS(3170),
    [anon_sym_operator] = ACTIONS(3170),
    [anon_sym_try] = ACTIONS(3170),
    [anon_sym_delete] = ACTIONS(3170),
    [anon_sym_throw] = ACTIONS(3170),
    [anon_sym_namespace] = ACTIONS(3170),
    [anon_sym_using] = ACTIONS(3170),
    [anon_sym_static_assert] = ACTIONS(3170),
    [anon_sym_concept] = ACTIONS(3170),
    [anon_sym_co_return] = ACTIONS(3170),
    [anon_sym_co_yield] = ACTIONS(3170),
    [anon_sym_R_DQUOTE] = ACTIONS(3172),
    [anon_sym_LR_DQUOTE] = ACTIONS(3172),
    [anon_sym_uR_DQUOTE] = ACTIONS(3172),
    [anon_sym_UR_DQUOTE] = ACTIONS(3172),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3172),
    [anon_sym_co_await] = ACTIONS(3170),
    [anon_sym_new] = ACTIONS(3170),
    [anon_sym_requires] = ACTIONS(3170),
    [sym_this] = ACTIONS(3170),
  },
  [708] = {
    [ts_builtin_sym_end] = ACTIONS(2757),
    [sym_identifier] = ACTIONS(2755),
    [aux_sym_preproc_include_token1] = ACTIONS(2755),
    [aux_sym_preproc_def_token1] = ACTIONS(2755),
    [aux_sym_preproc_if_token1] = ACTIONS(2755),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2755),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2755),
    [sym_preproc_directive] = ACTIONS(2755),
    [anon_sym_LPAREN2] = ACTIONS(2757),
    [anon_sym_BANG] = ACTIONS(2757),
    [anon_sym_TILDE] = ACTIONS(2757),
    [anon_sym_DASH] = ACTIONS(2755),
    [anon_sym_PLUS] = ACTIONS(2755),
    [anon_sym_STAR] = ACTIONS(2757),
    [anon_sym_AMP_AMP] = ACTIONS(2757),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_SEMI] = ACTIONS(2757),
    [anon_sym___extension__] = ACTIONS(2755),
    [anon_sym_typedef] = ACTIONS(2755),
    [anon_sym_virtual] = ACTIONS(2755),
    [anon_sym_extern] = ACTIONS(2755),
    [anon_sym___attribute__] = ACTIONS(2755),
    [anon_sym___attribute] = ACTIONS(2755),
    [anon_sym_COLON_COLON] = ACTIONS(2757),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2757),
    [anon_sym___declspec] = ACTIONS(2755),
    [anon_sym___based] = ACTIONS(2755),
    [anon_sym___cdecl] = ACTIONS(2755),
    [anon_sym___clrcall] = ACTIONS(2755),
    [anon_sym___stdcall] = ACTIONS(2755),
    [anon_sym___fastcall] = ACTIONS(2755),
    [anon_sym___thiscall] = ACTIONS(2755),
    [anon_sym___vectorcall] = ACTIONS(2755),
    [anon_sym_LBRACE] = ACTIONS(2757),
    [anon_sym_signed] = ACTIONS(2755),
    [anon_sym_unsigned] = ACTIONS(2755),
    [anon_sym_long] = ACTIONS(2755),
    [anon_sym_short] = ACTIONS(2755),
    [anon_sym_LBRACK] = ACTIONS(2755),
    [anon_sym_static] = ACTIONS(2755),
    [anon_sym_register] = ACTIONS(2755),
    [anon_sym_inline] = ACTIONS(2755),
    [anon_sym___inline] = ACTIONS(2755),
    [anon_sym___inline__] = ACTIONS(2755),
    [anon_sym___forceinline] = ACTIONS(2755),
    [anon_sym_thread_local] = ACTIONS(2755),
    [anon_sym___thread] = ACTIONS(2755),
    [anon_sym_const] = ACTIONS(2755),
    [anon_sym_constexpr] = ACTIONS(2755),
    [anon_sym_volatile] = ACTIONS(2755),
    [anon_sym_restrict] = ACTIONS(2755),
    [anon_sym___restrict__] = ACTIONS(2755),
    [anon_sym__Atomic] = ACTIONS(2755),
    [anon_sym__Noreturn] = ACTIONS(2755),
    [anon_sym_noreturn] = ACTIONS(2755),
    [anon_sym__Nonnull] = ACTIONS(2755),
    [anon_sym_mutable] = ACTIONS(2755),
    [anon_sym_constinit] = ACTIONS(2755),
    [anon_sym_consteval] = ACTIONS(2755),
    [anon_sym_alignas] = ACTIONS(2755),
    [anon_sym__Alignas] = ACTIONS(2755),
    [sym_primitive_type] = ACTIONS(2755),
    [anon_sym_enum] = ACTIONS(2755),
    [anon_sym_class] = ACTIONS(2755),
    [anon_sym_struct] = ACTIONS(2755),
    [anon_sym_union] = ACTIONS(2755),
    [anon_sym_if] = ACTIONS(2755),
    [anon_sym_switch] = ACTIONS(2755),
    [anon_sym_case] = ACTIONS(2755),
    [anon_sym_default] = ACTIONS(2755),
    [anon_sym_while] = ACTIONS(2755),
    [anon_sym_do] = ACTIONS(2755),
    [anon_sym_for] = ACTIONS(2755),
    [anon_sym_return] = ACTIONS(2755),
    [anon_sym_break] = ACTIONS(2755),
    [anon_sym_continue] = ACTIONS(2755),
    [anon_sym_goto] = ACTIONS(2755),
    [anon_sym_not] = ACTIONS(2755),
    [anon_sym_compl] = ACTIONS(2755),
    [anon_sym_DASH_DASH] = ACTIONS(2757),
    [anon_sym_PLUS_PLUS] = ACTIONS(2757),
    [anon_sym_sizeof] = ACTIONS(2755),
    [anon_sym___alignof__] = ACTIONS(2755),
    [anon_sym___alignof] = ACTIONS(2755),
    [anon_sym__alignof] = ACTIONS(2755),
    [anon_sym_alignof] = ACTIONS(2755),
    [anon_sym__Alignof] = ACTIONS(2755),
    [anon_sym_offsetof] = ACTIONS(2755),
    [anon_sym__Generic] = ACTIONS(2755),
    [anon_sym_asm] = ACTIONS(2755),
    [anon_sym___asm__] = ACTIONS(2755),
    [anon_sym___asm] = ACTIONS(2755),
    [sym_number_literal] = ACTIONS(2757),
    [anon_sym_L_SQUOTE] = ACTIONS(2757),
    [anon_sym_u_SQUOTE] = ACTIONS(2757),
    [anon_sym_U_SQUOTE] = ACTIONS(2757),
    [anon_sym_u8_SQUOTE] = ACTIONS(2757),
    [anon_sym_SQUOTE] = ACTIONS(2757),
    [anon_sym_L_DQUOTE] = ACTIONS(2757),
    [anon_sym_u_DQUOTE] = ACTIONS(2757),
    [anon_sym_U_DQUOTE] = ACTIONS(2757),
    [anon_sym_u8_DQUOTE] = ACTIONS(2757),
    [anon_sym_DQUOTE] = ACTIONS(2757),
    [sym_true] = ACTIONS(2755),
    [sym_false] = ACTIONS(2755),
    [anon_sym_NULL] = ACTIONS(2755),
    [anon_sym_nullptr] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2755),
    [anon_sym_decltype] = ACTIONS(2755),
    [anon_sym_explicit] = ACTIONS(2755),
    [anon_sym_typename] = ACTIONS(2755),
    [anon_sym_template] = ACTIONS(2755),
    [anon_sym_operator] = ACTIONS(2755),
    [anon_sym_try] = ACTIONS(2755),
    [anon_sym_delete] = ACTIONS(2755),
    [anon_sym_throw] = ACTIONS(2755),
    [anon_sym_namespace] = ACTIONS(2755),
    [anon_sym_using] = ACTIONS(2755),
    [anon_sym_static_assert] = ACTIONS(2755),
    [anon_sym_concept] = ACTIONS(2755),
    [anon_sym_co_return] = ACTIONS(2755),
    [anon_sym_co_yield] = ACTIONS(2755),
    [anon_sym_R_DQUOTE] = ACTIONS(2757),
    [anon_sym_LR_DQUOTE] = ACTIONS(2757),
    [anon_sym_uR_DQUOTE] = ACTIONS(2757),
    [anon_sym_UR_DQUOTE] = ACTIONS(2757),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2757),
    [anon_sym_co_await] = ACTIONS(2755),
    [anon_sym_new] = ACTIONS(2755),
    [anon_sym_requires] = ACTIONS(2755),
    [sym_this] = ACTIONS(2755),
  },
  [709] = {
    [ts_builtin_sym_end] = ACTIONS(2765),
    [sym_identifier] = ACTIONS(2763),
    [aux_sym_preproc_include_token1] = ACTIONS(2763),
    [aux_sym_preproc_def_token1] = ACTIONS(2763),
    [aux_sym_preproc_if_token1] = ACTIONS(2763),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2763),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2763),
    [sym_preproc_directive] = ACTIONS(2763),
    [anon_sym_LPAREN2] = ACTIONS(2765),
    [anon_sym_BANG] = ACTIONS(2765),
    [anon_sym_TILDE] = ACTIONS(2765),
    [anon_sym_DASH] = ACTIONS(2763),
    [anon_sym_PLUS] = ACTIONS(2763),
    [anon_sym_STAR] = ACTIONS(2765),
    [anon_sym_AMP_AMP] = ACTIONS(2765),
    [anon_sym_AMP] = ACTIONS(2763),
    [anon_sym_SEMI] = ACTIONS(2765),
    [anon_sym___extension__] = ACTIONS(2763),
    [anon_sym_typedef] = ACTIONS(2763),
    [anon_sym_virtual] = ACTIONS(2763),
    [anon_sym_extern] = ACTIONS(2763),
    [anon_sym___attribute__] = ACTIONS(2763),
    [anon_sym___attribute] = ACTIONS(2763),
    [anon_sym_COLON_COLON] = ACTIONS(2765),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2765),
    [anon_sym___declspec] = ACTIONS(2763),
    [anon_sym___based] = ACTIONS(2763),
    [anon_sym___cdecl] = ACTIONS(2763),
    [anon_sym___clrcall] = ACTIONS(2763),
    [anon_sym___stdcall] = ACTIONS(2763),
    [anon_sym___fastcall] = ACTIONS(2763),
    [anon_sym___thiscall] = ACTIONS(2763),
    [anon_sym___vectorcall] = ACTIONS(2763),
    [anon_sym_LBRACE] = ACTIONS(2765),
    [anon_sym_signed] = ACTIONS(2763),
    [anon_sym_unsigned] = ACTIONS(2763),
    [anon_sym_long] = ACTIONS(2763),
    [anon_sym_short] = ACTIONS(2763),
    [anon_sym_LBRACK] = ACTIONS(2763),
    [anon_sym_static] = ACTIONS(2763),
    [anon_sym_register] = ACTIONS(2763),
    [anon_sym_inline] = ACTIONS(2763),
    [anon_sym___inline] = ACTIONS(2763),
    [anon_sym___inline__] = ACTIONS(2763),
    [anon_sym___forceinline] = ACTIONS(2763),
    [anon_sym_thread_local] = ACTIONS(2763),
    [anon_sym___thread] = ACTIONS(2763),
    [anon_sym_const] = ACTIONS(2763),
    [anon_sym_constexpr] = ACTIONS(2763),
    [anon_sym_volatile] = ACTIONS(2763),
    [anon_sym_restrict] = ACTIONS(2763),
    [anon_sym___restrict__] = ACTIONS(2763),
    [anon_sym__Atomic] = ACTIONS(2763),
    [anon_sym__Noreturn] = ACTIONS(2763),
    [anon_sym_noreturn] = ACTIONS(2763),
    [anon_sym__Nonnull] = ACTIONS(2763),
    [anon_sym_mutable] = ACTIONS(2763),
    [anon_sym_constinit] = ACTIONS(2763),
    [anon_sym_consteval] = ACTIONS(2763),
    [anon_sym_alignas] = ACTIONS(2763),
    [anon_sym__Alignas] = ACTIONS(2763),
    [sym_primitive_type] = ACTIONS(2763),
    [anon_sym_enum] = ACTIONS(2763),
    [anon_sym_class] = ACTIONS(2763),
    [anon_sym_struct] = ACTIONS(2763),
    [anon_sym_union] = ACTIONS(2763),
    [anon_sym_if] = ACTIONS(2763),
    [anon_sym_switch] = ACTIONS(2763),
    [anon_sym_case] = ACTIONS(2763),
    [anon_sym_default] = ACTIONS(2763),
    [anon_sym_while] = ACTIONS(2763),
    [anon_sym_do] = ACTIONS(2763),
    [anon_sym_for] = ACTIONS(2763),
    [anon_sym_return] = ACTIONS(2763),
    [anon_sym_break] = ACTIONS(2763),
    [anon_sym_continue] = ACTIONS(2763),
    [anon_sym_goto] = ACTIONS(2763),
    [anon_sym_not] = ACTIONS(2763),
    [anon_sym_compl] = ACTIONS(2763),
    [anon_sym_DASH_DASH] = ACTIONS(2765),
    [anon_sym_PLUS_PLUS] = ACTIONS(2765),
    [anon_sym_sizeof] = ACTIONS(2763),
    [anon_sym___alignof__] = ACTIONS(2763),
    [anon_sym___alignof] = ACTIONS(2763),
    [anon_sym__alignof] = ACTIONS(2763),
    [anon_sym_alignof] = ACTIONS(2763),
    [anon_sym__Alignof] = ACTIONS(2763),
    [anon_sym_offsetof] = ACTIONS(2763),
    [anon_sym__Generic] = ACTIONS(2763),
    [anon_sym_asm] = ACTIONS(2763),
    [anon_sym___asm__] = ACTIONS(2763),
    [anon_sym___asm] = ACTIONS(2763),
    [sym_number_literal] = ACTIONS(2765),
    [anon_sym_L_SQUOTE] = ACTIONS(2765),
    [anon_sym_u_SQUOTE] = ACTIONS(2765),
    [anon_sym_U_SQUOTE] = ACTIONS(2765),
    [anon_sym_u8_SQUOTE] = ACTIONS(2765),
    [anon_sym_SQUOTE] = ACTIONS(2765),
    [anon_sym_L_DQUOTE] = ACTIONS(2765),
    [anon_sym_u_DQUOTE] = ACTIONS(2765),
    [anon_sym_U_DQUOTE] = ACTIONS(2765),
    [anon_sym_u8_DQUOTE] = ACTIONS(2765),
    [anon_sym_DQUOTE] = ACTIONS(2765),
    [sym_true] = ACTIONS(2763),
    [sym_false] = ACTIONS(2763),
    [anon_sym_NULL] = ACTIONS(2763),
    [anon_sym_nullptr] = ACTIONS(2763),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2763),
    [anon_sym_decltype] = ACTIONS(2763),
    [anon_sym_explicit] = ACTIONS(2763),
    [anon_sym_typename] = ACTIONS(2763),
    [anon_sym_template] = ACTIONS(2763),
    [anon_sym_operator] = ACTIONS(2763),
    [anon_sym_try] = ACTIONS(2763),
    [anon_sym_delete] = ACTIONS(2763),
    [anon_sym_throw] = ACTIONS(2763),
    [anon_sym_namespace] = ACTIONS(2763),
    [anon_sym_using] = ACTIONS(2763),
    [anon_sym_static_assert] = ACTIONS(2763),
    [anon_sym_concept] = ACTIONS(2763),
    [anon_sym_co_return] = ACTIONS(2763),
    [anon_sym_co_yield] = ACTIONS(2763),
    [anon_sym_R_DQUOTE] = ACTIONS(2765),
    [anon_sym_LR_DQUOTE] = ACTIONS(2765),
    [anon_sym_uR_DQUOTE] = ACTIONS(2765),
    [anon_sym_UR_DQUOTE] = ACTIONS(2765),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2765),
    [anon_sym_co_await] = ACTIONS(2763),
    [anon_sym_new] = ACTIONS(2763),
    [anon_sym_requires] = ACTIONS(2763),
    [sym_this] = ACTIONS(2763),
  },
  [710] = {
    [ts_builtin_sym_end] = ACTIONS(2769),
    [sym_identifier] = ACTIONS(2767),
    [aux_sym_preproc_include_token1] = ACTIONS(2767),
    [aux_sym_preproc_def_token1] = ACTIONS(2767),
    [aux_sym_preproc_if_token1] = ACTIONS(2767),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2767),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2767),
    [sym_preproc_directive] = ACTIONS(2767),
    [anon_sym_LPAREN2] = ACTIONS(2769),
    [anon_sym_BANG] = ACTIONS(2769),
    [anon_sym_TILDE] = ACTIONS(2769),
    [anon_sym_DASH] = ACTIONS(2767),
    [anon_sym_PLUS] = ACTIONS(2767),
    [anon_sym_STAR] = ACTIONS(2769),
    [anon_sym_AMP_AMP] = ACTIONS(2769),
    [anon_sym_AMP] = ACTIONS(2767),
    [anon_sym_SEMI] = ACTIONS(2769),
    [anon_sym___extension__] = ACTIONS(2767),
    [anon_sym_typedef] = ACTIONS(2767),
    [anon_sym_virtual] = ACTIONS(2767),
    [anon_sym_extern] = ACTIONS(2767),
    [anon_sym___attribute__] = ACTIONS(2767),
    [anon_sym___attribute] = ACTIONS(2767),
    [anon_sym_COLON_COLON] = ACTIONS(2769),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2769),
    [anon_sym___declspec] = ACTIONS(2767),
    [anon_sym___based] = ACTIONS(2767),
    [anon_sym___cdecl] = ACTIONS(2767),
    [anon_sym___clrcall] = ACTIONS(2767),
    [anon_sym___stdcall] = ACTIONS(2767),
    [anon_sym___fastcall] = ACTIONS(2767),
    [anon_sym___thiscall] = ACTIONS(2767),
    [anon_sym___vectorcall] = ACTIONS(2767),
    [anon_sym_LBRACE] = ACTIONS(2769),
    [anon_sym_signed] = ACTIONS(2767),
    [anon_sym_unsigned] = ACTIONS(2767),
    [anon_sym_long] = ACTIONS(2767),
    [anon_sym_short] = ACTIONS(2767),
    [anon_sym_LBRACK] = ACTIONS(2767),
    [anon_sym_static] = ACTIONS(2767),
    [anon_sym_register] = ACTIONS(2767),
    [anon_sym_inline] = ACTIONS(2767),
    [anon_sym___inline] = ACTIONS(2767),
    [anon_sym___inline__] = ACTIONS(2767),
    [anon_sym___forceinline] = ACTIONS(2767),
    [anon_sym_thread_local] = ACTIONS(2767),
    [anon_sym___thread] = ACTIONS(2767),
    [anon_sym_const] = ACTIONS(2767),
    [anon_sym_constexpr] = ACTIONS(2767),
    [anon_sym_volatile] = ACTIONS(2767),
    [anon_sym_restrict] = ACTIONS(2767),
    [anon_sym___restrict__] = ACTIONS(2767),
    [anon_sym__Atomic] = ACTIONS(2767),
    [anon_sym__Noreturn] = ACTIONS(2767),
    [anon_sym_noreturn] = ACTIONS(2767),
    [anon_sym__Nonnull] = ACTIONS(2767),
    [anon_sym_mutable] = ACTIONS(2767),
    [anon_sym_constinit] = ACTIONS(2767),
    [anon_sym_consteval] = ACTIONS(2767),
    [anon_sym_alignas] = ACTIONS(2767),
    [anon_sym__Alignas] = ACTIONS(2767),
    [sym_primitive_type] = ACTIONS(2767),
    [anon_sym_enum] = ACTIONS(2767),
    [anon_sym_class] = ACTIONS(2767),
    [anon_sym_struct] = ACTIONS(2767),
    [anon_sym_union] = ACTIONS(2767),
    [anon_sym_if] = ACTIONS(2767),
    [anon_sym_switch] = ACTIONS(2767),
    [anon_sym_case] = ACTIONS(2767),
    [anon_sym_default] = ACTIONS(2767),
    [anon_sym_while] = ACTIONS(2767),
    [anon_sym_do] = ACTIONS(2767),
    [anon_sym_for] = ACTIONS(2767),
    [anon_sym_return] = ACTIONS(2767),
    [anon_sym_break] = ACTIONS(2767),
    [anon_sym_continue] = ACTIONS(2767),
    [anon_sym_goto] = ACTIONS(2767),
    [anon_sym_not] = ACTIONS(2767),
    [anon_sym_compl] = ACTIONS(2767),
    [anon_sym_DASH_DASH] = ACTIONS(2769),
    [anon_sym_PLUS_PLUS] = ACTIONS(2769),
    [anon_sym_sizeof] = ACTIONS(2767),
    [anon_sym___alignof__] = ACTIONS(2767),
    [anon_sym___alignof] = ACTIONS(2767),
    [anon_sym__alignof] = ACTIONS(2767),
    [anon_sym_alignof] = ACTIONS(2767),
    [anon_sym__Alignof] = ACTIONS(2767),
    [anon_sym_offsetof] = ACTIONS(2767),
    [anon_sym__Generic] = ACTIONS(2767),
    [anon_sym_asm] = ACTIONS(2767),
    [anon_sym___asm__] = ACTIONS(2767),
    [anon_sym___asm] = ACTIONS(2767),
    [sym_number_literal] = ACTIONS(2769),
    [anon_sym_L_SQUOTE] = ACTIONS(2769),
    [anon_sym_u_SQUOTE] = ACTIONS(2769),
    [anon_sym_U_SQUOTE] = ACTIONS(2769),
    [anon_sym_u8_SQUOTE] = ACTIONS(2769),
    [anon_sym_SQUOTE] = ACTIONS(2769),
    [anon_sym_L_DQUOTE] = ACTIONS(2769),
    [anon_sym_u_DQUOTE] = ACTIONS(2769),
    [anon_sym_U_DQUOTE] = ACTIONS(2769),
    [anon_sym_u8_DQUOTE] = ACTIONS(2769),
    [anon_sym_DQUOTE] = ACTIONS(2769),
    [sym_true] = ACTIONS(2767),
    [sym_false] = ACTIONS(2767),
    [anon_sym_NULL] = ACTIONS(2767),
    [anon_sym_nullptr] = ACTIONS(2767),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2767),
    [anon_sym_decltype] = ACTIONS(2767),
    [anon_sym_explicit] = ACTIONS(2767),
    [anon_sym_typename] = ACTIONS(2767),
    [anon_sym_template] = ACTIONS(2767),
    [anon_sym_operator] = ACTIONS(2767),
    [anon_sym_try] = ACTIONS(2767),
    [anon_sym_delete] = ACTIONS(2767),
    [anon_sym_throw] = ACTIONS(2767),
    [anon_sym_namespace] = ACTIONS(2767),
    [anon_sym_using] = ACTIONS(2767),
    [anon_sym_static_assert] = ACTIONS(2767),
    [anon_sym_concept] = ACTIONS(2767),
    [anon_sym_co_return] = ACTIONS(2767),
    [anon_sym_co_yield] = ACTIONS(2767),
    [anon_sym_R_DQUOTE] = ACTIONS(2769),
    [anon_sym_LR_DQUOTE] = ACTIONS(2769),
    [anon_sym_uR_DQUOTE] = ACTIONS(2769),
    [anon_sym_UR_DQUOTE] = ACTIONS(2769),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2769),
    [anon_sym_co_await] = ACTIONS(2767),
    [anon_sym_new] = ACTIONS(2767),
    [anon_sym_requires] = ACTIONS(2767),
    [sym_this] = ACTIONS(2767),
  },
  [711] = {
    [ts_builtin_sym_end] = ACTIONS(2966),
    [sym_identifier] = ACTIONS(2964),
    [aux_sym_preproc_include_token1] = ACTIONS(2964),
    [aux_sym_preproc_def_token1] = ACTIONS(2964),
    [aux_sym_preproc_if_token1] = ACTIONS(2964),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2964),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2964),
    [sym_preproc_directive] = ACTIONS(2964),
    [anon_sym_LPAREN2] = ACTIONS(2966),
    [anon_sym_BANG] = ACTIONS(2966),
    [anon_sym_TILDE] = ACTIONS(2966),
    [anon_sym_DASH] = ACTIONS(2964),
    [anon_sym_PLUS] = ACTIONS(2964),
    [anon_sym_STAR] = ACTIONS(2966),
    [anon_sym_AMP_AMP] = ACTIONS(2966),
    [anon_sym_AMP] = ACTIONS(2964),
    [anon_sym_SEMI] = ACTIONS(2966),
    [anon_sym___extension__] = ACTIONS(2964),
    [anon_sym_typedef] = ACTIONS(2964),
    [anon_sym_virtual] = ACTIONS(2964),
    [anon_sym_extern] = ACTIONS(2964),
    [anon_sym___attribute__] = ACTIONS(2964),
    [anon_sym___attribute] = ACTIONS(2964),
    [anon_sym_COLON_COLON] = ACTIONS(2966),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2966),
    [anon_sym___declspec] = ACTIONS(2964),
    [anon_sym___based] = ACTIONS(2964),
    [anon_sym___cdecl] = ACTIONS(2964),
    [anon_sym___clrcall] = ACTIONS(2964),
    [anon_sym___stdcall] = ACTIONS(2964),
    [anon_sym___fastcall] = ACTIONS(2964),
    [anon_sym___thiscall] = ACTIONS(2964),
    [anon_sym___vectorcall] = ACTIONS(2964),
    [anon_sym_LBRACE] = ACTIONS(2966),
    [anon_sym_signed] = ACTIONS(2964),
    [anon_sym_unsigned] = ACTIONS(2964),
    [anon_sym_long] = ACTIONS(2964),
    [anon_sym_short] = ACTIONS(2964),
    [anon_sym_LBRACK] = ACTIONS(2964),
    [anon_sym_static] = ACTIONS(2964),
    [anon_sym_register] = ACTIONS(2964),
    [anon_sym_inline] = ACTIONS(2964),
    [anon_sym___inline] = ACTIONS(2964),
    [anon_sym___inline__] = ACTIONS(2964),
    [anon_sym___forceinline] = ACTIONS(2964),
    [anon_sym_thread_local] = ACTIONS(2964),
    [anon_sym___thread] = ACTIONS(2964),
    [anon_sym_const] = ACTIONS(2964),
    [anon_sym_constexpr] = ACTIONS(2964),
    [anon_sym_volatile] = ACTIONS(2964),
    [anon_sym_restrict] = ACTIONS(2964),
    [anon_sym___restrict__] = ACTIONS(2964),
    [anon_sym__Atomic] = ACTIONS(2964),
    [anon_sym__Noreturn] = ACTIONS(2964),
    [anon_sym_noreturn] = ACTIONS(2964),
    [anon_sym__Nonnull] = ACTIONS(2964),
    [anon_sym_mutable] = ACTIONS(2964),
    [anon_sym_constinit] = ACTIONS(2964),
    [anon_sym_consteval] = ACTIONS(2964),
    [anon_sym_alignas] = ACTIONS(2964),
    [anon_sym__Alignas] = ACTIONS(2964),
    [sym_primitive_type] = ACTIONS(2964),
    [anon_sym_enum] = ACTIONS(2964),
    [anon_sym_class] = ACTIONS(2964),
    [anon_sym_struct] = ACTIONS(2964),
    [anon_sym_union] = ACTIONS(2964),
    [anon_sym_if] = ACTIONS(2964),
    [anon_sym_switch] = ACTIONS(2964),
    [anon_sym_case] = ACTIONS(2964),
    [anon_sym_default] = ACTIONS(2964),
    [anon_sym_while] = ACTIONS(2964),
    [anon_sym_do] = ACTIONS(2964),
    [anon_sym_for] = ACTIONS(2964),
    [anon_sym_return] = ACTIONS(2964),
    [anon_sym_break] = ACTIONS(2964),
    [anon_sym_continue] = ACTIONS(2964),
    [anon_sym_goto] = ACTIONS(2964),
    [anon_sym_not] = ACTIONS(2964),
    [anon_sym_compl] = ACTIONS(2964),
    [anon_sym_DASH_DASH] = ACTIONS(2966),
    [anon_sym_PLUS_PLUS] = ACTIONS(2966),
    [anon_sym_sizeof] = ACTIONS(2964),
    [anon_sym___alignof__] = ACTIONS(2964),
    [anon_sym___alignof] = ACTIONS(2964),
    [anon_sym__alignof] = ACTIONS(2964),
    [anon_sym_alignof] = ACTIONS(2964),
    [anon_sym__Alignof] = ACTIONS(2964),
    [anon_sym_offsetof] = ACTIONS(2964),
    [anon_sym__Generic] = ACTIONS(2964),
    [anon_sym_asm] = ACTIONS(2964),
    [anon_sym___asm__] = ACTIONS(2964),
    [anon_sym___asm] = ACTIONS(2964),
    [sym_number_literal] = ACTIONS(2966),
    [anon_sym_L_SQUOTE] = ACTIONS(2966),
    [anon_sym_u_SQUOTE] = ACTIONS(2966),
    [anon_sym_U_SQUOTE] = ACTIONS(2966),
    [anon_sym_u8_SQUOTE] = ACTIONS(2966),
    [anon_sym_SQUOTE] = ACTIONS(2966),
    [anon_sym_L_DQUOTE] = ACTIONS(2966),
    [anon_sym_u_DQUOTE] = ACTIONS(2966),
    [anon_sym_U_DQUOTE] = ACTIONS(2966),
    [anon_sym_u8_DQUOTE] = ACTIONS(2966),
    [anon_sym_DQUOTE] = ACTIONS(2966),
    [sym_true] = ACTIONS(2964),
    [sym_false] = ACTIONS(2964),
    [anon_sym_NULL] = ACTIONS(2964),
    [anon_sym_nullptr] = ACTIONS(2964),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2964),
    [anon_sym_decltype] = ACTIONS(2964),
    [anon_sym_explicit] = ACTIONS(2964),
    [anon_sym_typename] = ACTIONS(2964),
    [anon_sym_template] = ACTIONS(2964),
    [anon_sym_operator] = ACTIONS(2964),
    [anon_sym_try] = ACTIONS(2964),
    [anon_sym_delete] = ACTIONS(2964),
    [anon_sym_throw] = ACTIONS(2964),
    [anon_sym_namespace] = ACTIONS(2964),
    [anon_sym_using] = ACTIONS(2964),
    [anon_sym_static_assert] = ACTIONS(2964),
    [anon_sym_concept] = ACTIONS(2964),
    [anon_sym_co_return] = ACTIONS(2964),
    [anon_sym_co_yield] = ACTIONS(2964),
    [anon_sym_R_DQUOTE] = ACTIONS(2966),
    [anon_sym_LR_DQUOTE] = ACTIONS(2966),
    [anon_sym_uR_DQUOTE] = ACTIONS(2966),
    [anon_sym_UR_DQUOTE] = ACTIONS(2966),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2966),
    [anon_sym_co_await] = ACTIONS(2964),
    [anon_sym_new] = ACTIONS(2964),
    [anon_sym_requires] = ACTIONS(2964),
    [sym_this] = ACTIONS(2964),
  },
  [712] = {
    [ts_builtin_sym_end] = ACTIONS(3486),
    [sym_identifier] = ACTIONS(3488),
    [aux_sym_preproc_include_token1] = ACTIONS(3488),
    [aux_sym_preproc_def_token1] = ACTIONS(3488),
    [aux_sym_preproc_if_token1] = ACTIONS(3488),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3488),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3488),
    [sym_preproc_directive] = ACTIONS(3488),
    [anon_sym_LPAREN2] = ACTIONS(3486),
    [anon_sym_BANG] = ACTIONS(3486),
    [anon_sym_TILDE] = ACTIONS(3486),
    [anon_sym_DASH] = ACTIONS(3488),
    [anon_sym_PLUS] = ACTIONS(3488),
    [anon_sym_STAR] = ACTIONS(3486),
    [anon_sym_AMP_AMP] = ACTIONS(3486),
    [anon_sym_AMP] = ACTIONS(3488),
    [anon_sym_SEMI] = ACTIONS(3486),
    [anon_sym___extension__] = ACTIONS(3488),
    [anon_sym_typedef] = ACTIONS(3488),
    [anon_sym_virtual] = ACTIONS(3488),
    [anon_sym_extern] = ACTIONS(3488),
    [anon_sym___attribute__] = ACTIONS(3488),
    [anon_sym___attribute] = ACTIONS(3488),
    [anon_sym_COLON_COLON] = ACTIONS(3486),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3486),
    [anon_sym___declspec] = ACTIONS(3488),
    [anon_sym___based] = ACTIONS(3488),
    [anon_sym___cdecl] = ACTIONS(3488),
    [anon_sym___clrcall] = ACTIONS(3488),
    [anon_sym___stdcall] = ACTIONS(3488),
    [anon_sym___fastcall] = ACTIONS(3488),
    [anon_sym___thiscall] = ACTIONS(3488),
    [anon_sym___vectorcall] = ACTIONS(3488),
    [anon_sym_LBRACE] = ACTIONS(3486),
    [anon_sym_signed] = ACTIONS(3488),
    [anon_sym_unsigned] = ACTIONS(3488),
    [anon_sym_long] = ACTIONS(3488),
    [anon_sym_short] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(3488),
    [anon_sym_static] = ACTIONS(3488),
    [anon_sym_register] = ACTIONS(3488),
    [anon_sym_inline] = ACTIONS(3488),
    [anon_sym___inline] = ACTIONS(3488),
    [anon_sym___inline__] = ACTIONS(3488),
    [anon_sym___forceinline] = ACTIONS(3488),
    [anon_sym_thread_local] = ACTIONS(3488),
    [anon_sym___thread] = ACTIONS(3488),
    [anon_sym_const] = ACTIONS(3488),
    [anon_sym_constexpr] = ACTIONS(3488),
    [anon_sym_volatile] = ACTIONS(3488),
    [anon_sym_restrict] = ACTIONS(3488),
    [anon_sym___restrict__] = ACTIONS(3488),
    [anon_sym__Atomic] = ACTIONS(3488),
    [anon_sym__Noreturn] = ACTIONS(3488),
    [anon_sym_noreturn] = ACTIONS(3488),
    [anon_sym__Nonnull] = ACTIONS(3488),
    [anon_sym_mutable] = ACTIONS(3488),
    [anon_sym_constinit] = ACTIONS(3488),
    [anon_sym_consteval] = ACTIONS(3488),
    [anon_sym_alignas] = ACTIONS(3488),
    [anon_sym__Alignas] = ACTIONS(3488),
    [sym_primitive_type] = ACTIONS(3488),
    [anon_sym_enum] = ACTIONS(3488),
    [anon_sym_class] = ACTIONS(3488),
    [anon_sym_struct] = ACTIONS(3488),
    [anon_sym_union] = ACTIONS(3488),
    [anon_sym_if] = ACTIONS(3488),
    [anon_sym_switch] = ACTIONS(3488),
    [anon_sym_case] = ACTIONS(3488),
    [anon_sym_default] = ACTIONS(3488),
    [anon_sym_while] = ACTIONS(3488),
    [anon_sym_do] = ACTIONS(3488),
    [anon_sym_for] = ACTIONS(3488),
    [anon_sym_return] = ACTIONS(3488),
    [anon_sym_break] = ACTIONS(3488),
    [anon_sym_continue] = ACTIONS(3488),
    [anon_sym_goto] = ACTIONS(3488),
    [anon_sym_not] = ACTIONS(3488),
    [anon_sym_compl] = ACTIONS(3488),
    [anon_sym_DASH_DASH] = ACTIONS(3486),
    [anon_sym_PLUS_PLUS] = ACTIONS(3486),
    [anon_sym_sizeof] = ACTIONS(3488),
    [anon_sym___alignof__] = ACTIONS(3488),
    [anon_sym___alignof] = ACTIONS(3488),
    [anon_sym__alignof] = ACTIONS(3488),
    [anon_sym_alignof] = ACTIONS(3488),
    [anon_sym__Alignof] = ACTIONS(3488),
    [anon_sym_offsetof] = ACTIONS(3488),
    [anon_sym__Generic] = ACTIONS(3488),
    [anon_sym_asm] = ACTIONS(3488),
    [anon_sym___asm__] = ACTIONS(3488),
    [anon_sym___asm] = ACTIONS(3488),
    [sym_number_literal] = ACTIONS(3486),
    [anon_sym_L_SQUOTE] = ACTIONS(3486),
    [anon_sym_u_SQUOTE] = ACTIONS(3486),
    [anon_sym_U_SQUOTE] = ACTIONS(3486),
    [anon_sym_u8_SQUOTE] = ACTIONS(3486),
    [anon_sym_SQUOTE] = ACTIONS(3486),
    [anon_sym_L_DQUOTE] = ACTIONS(3486),
    [anon_sym_u_DQUOTE] = ACTIONS(3486),
    [anon_sym_U_DQUOTE] = ACTIONS(3486),
    [anon_sym_u8_DQUOTE] = ACTIONS(3486),
    [anon_sym_DQUOTE] = ACTIONS(3486),
    [sym_true] = ACTIONS(3488),
    [sym_false] = ACTIONS(3488),
    [anon_sym_NULL] = ACTIONS(3488),
    [anon_sym_nullptr] = ACTIONS(3488),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3488),
    [anon_sym_decltype] = ACTIONS(3488),
    [anon_sym_explicit] = ACTIONS(3488),
    [anon_sym_typename] = ACTIONS(3488),
    [anon_sym_template] = ACTIONS(3488),
    [anon_sym_operator] = ACTIONS(3488),
    [anon_sym_try] = ACTIONS(3488),
    [anon_sym_delete] = ACTIONS(3488),
    [anon_sym_throw] = ACTIONS(3488),
    [anon_sym_namespace] = ACTIONS(3488),
    [anon_sym_using] = ACTIONS(3488),
    [anon_sym_static_assert] = ACTIONS(3488),
    [anon_sym_concept] = ACTIONS(3488),
    [anon_sym_co_return] = ACTIONS(3488),
    [anon_sym_co_yield] = ACTIONS(3488),
    [anon_sym_R_DQUOTE] = ACTIONS(3486),
    [anon_sym_LR_DQUOTE] = ACTIONS(3486),
    [anon_sym_uR_DQUOTE] = ACTIONS(3486),
    [anon_sym_UR_DQUOTE] = ACTIONS(3486),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3486),
    [anon_sym_co_await] = ACTIONS(3488),
    [anon_sym_new] = ACTIONS(3488),
    [anon_sym_requires] = ACTIONS(3488),
    [sym_this] = ACTIONS(3488),
  },
  [713] = {
    [ts_builtin_sym_end] = ACTIONS(3490),
    [sym_identifier] = ACTIONS(3492),
    [aux_sym_preproc_include_token1] = ACTIONS(3492),
    [aux_sym_preproc_def_token1] = ACTIONS(3492),
    [aux_sym_preproc_if_token1] = ACTIONS(3492),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3492),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3492),
    [sym_preproc_directive] = ACTIONS(3492),
    [anon_sym_LPAREN2] = ACTIONS(3490),
    [anon_sym_BANG] = ACTIONS(3490),
    [anon_sym_TILDE] = ACTIONS(3490),
    [anon_sym_DASH] = ACTIONS(3492),
    [anon_sym_PLUS] = ACTIONS(3492),
    [anon_sym_STAR] = ACTIONS(3490),
    [anon_sym_AMP_AMP] = ACTIONS(3490),
    [anon_sym_AMP] = ACTIONS(3492),
    [anon_sym_SEMI] = ACTIONS(3490),
    [anon_sym___extension__] = ACTIONS(3492),
    [anon_sym_typedef] = ACTIONS(3492),
    [anon_sym_virtual] = ACTIONS(3492),
    [anon_sym_extern] = ACTIONS(3492),
    [anon_sym___attribute__] = ACTIONS(3492),
    [anon_sym___attribute] = ACTIONS(3492),
    [anon_sym_COLON_COLON] = ACTIONS(3490),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3490),
    [anon_sym___declspec] = ACTIONS(3492),
    [anon_sym___based] = ACTIONS(3492),
    [anon_sym___cdecl] = ACTIONS(3492),
    [anon_sym___clrcall] = ACTIONS(3492),
    [anon_sym___stdcall] = ACTIONS(3492),
    [anon_sym___fastcall] = ACTIONS(3492),
    [anon_sym___thiscall] = ACTIONS(3492),
    [anon_sym___vectorcall] = ACTIONS(3492),
    [anon_sym_LBRACE] = ACTIONS(3490),
    [anon_sym_signed] = ACTIONS(3492),
    [anon_sym_unsigned] = ACTIONS(3492),
    [anon_sym_long] = ACTIONS(3492),
    [anon_sym_short] = ACTIONS(3492),
    [anon_sym_LBRACK] = ACTIONS(3492),
    [anon_sym_static] = ACTIONS(3492),
    [anon_sym_register] = ACTIONS(3492),
    [anon_sym_inline] = ACTIONS(3492),
    [anon_sym___inline] = ACTIONS(3492),
    [anon_sym___inline__] = ACTIONS(3492),
    [anon_sym___forceinline] = ACTIONS(3492),
    [anon_sym_thread_local] = ACTIONS(3492),
    [anon_sym___thread] = ACTIONS(3492),
    [anon_sym_const] = ACTIONS(3492),
    [anon_sym_constexpr] = ACTIONS(3492),
    [anon_sym_volatile] = ACTIONS(3492),
    [anon_sym_restrict] = ACTIONS(3492),
    [anon_sym___restrict__] = ACTIONS(3492),
    [anon_sym__Atomic] = ACTIONS(3492),
    [anon_sym__Noreturn] = ACTIONS(3492),
    [anon_sym_noreturn] = ACTIONS(3492),
    [anon_sym__Nonnull] = ACTIONS(3492),
    [anon_sym_mutable] = ACTIONS(3492),
    [anon_sym_constinit] = ACTIONS(3492),
    [anon_sym_consteval] = ACTIONS(3492),
    [anon_sym_alignas] = ACTIONS(3492),
    [anon_sym__Alignas] = ACTIONS(3492),
    [sym_primitive_type] = ACTIONS(3492),
    [anon_sym_enum] = ACTIONS(3492),
    [anon_sym_class] = ACTIONS(3492),
    [anon_sym_struct] = ACTIONS(3492),
    [anon_sym_union] = ACTIONS(3492),
    [anon_sym_if] = ACTIONS(3492),
    [anon_sym_switch] = ACTIONS(3492),
    [anon_sym_case] = ACTIONS(3492),
    [anon_sym_default] = ACTIONS(3492),
    [anon_sym_while] = ACTIONS(3492),
    [anon_sym_do] = ACTIONS(3492),
    [anon_sym_for] = ACTIONS(3492),
    [anon_sym_return] = ACTIONS(3492),
    [anon_sym_break] = ACTIONS(3492),
    [anon_sym_continue] = ACTIONS(3492),
    [anon_sym_goto] = ACTIONS(3492),
    [anon_sym_not] = ACTIONS(3492),
    [anon_sym_compl] = ACTIONS(3492),
    [anon_sym_DASH_DASH] = ACTIONS(3490),
    [anon_sym_PLUS_PLUS] = ACTIONS(3490),
    [anon_sym_sizeof] = ACTIONS(3492),
    [anon_sym___alignof__] = ACTIONS(3492),
    [anon_sym___alignof] = ACTIONS(3492),
    [anon_sym__alignof] = ACTIONS(3492),
    [anon_sym_alignof] = ACTIONS(3492),
    [anon_sym__Alignof] = ACTIONS(3492),
    [anon_sym_offsetof] = ACTIONS(3492),
    [anon_sym__Generic] = ACTIONS(3492),
    [anon_sym_asm] = ACTIONS(3492),
    [anon_sym___asm__] = ACTIONS(3492),
    [anon_sym___asm] = ACTIONS(3492),
    [sym_number_literal] = ACTIONS(3490),
    [anon_sym_L_SQUOTE] = ACTIONS(3490),
    [anon_sym_u_SQUOTE] = ACTIONS(3490),
    [anon_sym_U_SQUOTE] = ACTIONS(3490),
    [anon_sym_u8_SQUOTE] = ACTIONS(3490),
    [anon_sym_SQUOTE] = ACTIONS(3490),
    [anon_sym_L_DQUOTE] = ACTIONS(3490),
    [anon_sym_u_DQUOTE] = ACTIONS(3490),
    [anon_sym_U_DQUOTE] = ACTIONS(3490),
    [anon_sym_u8_DQUOTE] = ACTIONS(3490),
    [anon_sym_DQUOTE] = ACTIONS(3490),
    [sym_true] = ACTIONS(3492),
    [sym_false] = ACTIONS(3492),
    [anon_sym_NULL] = ACTIONS(3492),
    [anon_sym_nullptr] = ACTIONS(3492),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3492),
    [anon_sym_decltype] = ACTIONS(3492),
    [anon_sym_explicit] = ACTIONS(3492),
    [anon_sym_typename] = ACTIONS(3492),
    [anon_sym_template] = ACTIONS(3492),
    [anon_sym_operator] = ACTIONS(3492),
    [anon_sym_try] = ACTIONS(3492),
    [anon_sym_delete] = ACTIONS(3492),
    [anon_sym_throw] = ACTIONS(3492),
    [anon_sym_namespace] = ACTIONS(3492),
    [anon_sym_using] = ACTIONS(3492),
    [anon_sym_static_assert] = ACTIONS(3492),
    [anon_sym_concept] = ACTIONS(3492),
    [anon_sym_co_return] = ACTIONS(3492),
    [anon_sym_co_yield] = ACTIONS(3492),
    [anon_sym_R_DQUOTE] = ACTIONS(3490),
    [anon_sym_LR_DQUOTE] = ACTIONS(3490),
    [anon_sym_uR_DQUOTE] = ACTIONS(3490),
    [anon_sym_UR_DQUOTE] = ACTIONS(3490),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3490),
    [anon_sym_co_await] = ACTIONS(3492),
    [anon_sym_new] = ACTIONS(3492),
    [anon_sym_requires] = ACTIONS(3492),
    [sym_this] = ACTIONS(3492),
  },
  [714] = {
    [ts_builtin_sym_end] = ACTIONS(3036),
    [sym_identifier] = ACTIONS(3034),
    [aux_sym_preproc_include_token1] = ACTIONS(3034),
    [aux_sym_preproc_def_token1] = ACTIONS(3034),
    [aux_sym_preproc_if_token1] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3034),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3034),
    [sym_preproc_directive] = ACTIONS(3034),
    [anon_sym_LPAREN2] = ACTIONS(3036),
    [anon_sym_BANG] = ACTIONS(3036),
    [anon_sym_TILDE] = ACTIONS(3036),
    [anon_sym_DASH] = ACTIONS(3034),
    [anon_sym_PLUS] = ACTIONS(3034),
    [anon_sym_STAR] = ACTIONS(3036),
    [anon_sym_AMP_AMP] = ACTIONS(3036),
    [anon_sym_AMP] = ACTIONS(3034),
    [anon_sym_SEMI] = ACTIONS(3036),
    [anon_sym___extension__] = ACTIONS(3034),
    [anon_sym_typedef] = ACTIONS(3034),
    [anon_sym_virtual] = ACTIONS(3034),
    [anon_sym_extern] = ACTIONS(3034),
    [anon_sym___attribute__] = ACTIONS(3034),
    [anon_sym___attribute] = ACTIONS(3034),
    [anon_sym_COLON_COLON] = ACTIONS(3036),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3036),
    [anon_sym___declspec] = ACTIONS(3034),
    [anon_sym___based] = ACTIONS(3034),
    [anon_sym___cdecl] = ACTIONS(3034),
    [anon_sym___clrcall] = ACTIONS(3034),
    [anon_sym___stdcall] = ACTIONS(3034),
    [anon_sym___fastcall] = ACTIONS(3034),
    [anon_sym___thiscall] = ACTIONS(3034),
    [anon_sym___vectorcall] = ACTIONS(3034),
    [anon_sym_LBRACE] = ACTIONS(3036),
    [anon_sym_signed] = ACTIONS(3034),
    [anon_sym_unsigned] = ACTIONS(3034),
    [anon_sym_long] = ACTIONS(3034),
    [anon_sym_short] = ACTIONS(3034),
    [anon_sym_LBRACK] = ACTIONS(3034),
    [anon_sym_static] = ACTIONS(3034),
    [anon_sym_register] = ACTIONS(3034),
    [anon_sym_inline] = ACTIONS(3034),
    [anon_sym___inline] = ACTIONS(3034),
    [anon_sym___inline__] = ACTIONS(3034),
    [anon_sym___forceinline] = ACTIONS(3034),
    [anon_sym_thread_local] = ACTIONS(3034),
    [anon_sym___thread] = ACTIONS(3034),
    [anon_sym_const] = ACTIONS(3034),
    [anon_sym_constexpr] = ACTIONS(3034),
    [anon_sym_volatile] = ACTIONS(3034),
    [anon_sym_restrict] = ACTIONS(3034),
    [anon_sym___restrict__] = ACTIONS(3034),
    [anon_sym__Atomic] = ACTIONS(3034),
    [anon_sym__Noreturn] = ACTIONS(3034),
    [anon_sym_noreturn] = ACTIONS(3034),
    [anon_sym__Nonnull] = ACTIONS(3034),
    [anon_sym_mutable] = ACTIONS(3034),
    [anon_sym_constinit] = ACTIONS(3034),
    [anon_sym_consteval] = ACTIONS(3034),
    [anon_sym_alignas] = ACTIONS(3034),
    [anon_sym__Alignas] = ACTIONS(3034),
    [sym_primitive_type] = ACTIONS(3034),
    [anon_sym_enum] = ACTIONS(3034),
    [anon_sym_class] = ACTIONS(3034),
    [anon_sym_struct] = ACTIONS(3034),
    [anon_sym_union] = ACTIONS(3034),
    [anon_sym_if] = ACTIONS(3034),
    [anon_sym_switch] = ACTIONS(3034),
    [anon_sym_case] = ACTIONS(3034),
    [anon_sym_default] = ACTIONS(3034),
    [anon_sym_while] = ACTIONS(3034),
    [anon_sym_do] = ACTIONS(3034),
    [anon_sym_for] = ACTIONS(3034),
    [anon_sym_return] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3034),
    [anon_sym_continue] = ACTIONS(3034),
    [anon_sym_goto] = ACTIONS(3034),
    [anon_sym_not] = ACTIONS(3034),
    [anon_sym_compl] = ACTIONS(3034),
    [anon_sym_DASH_DASH] = ACTIONS(3036),
    [anon_sym_PLUS_PLUS] = ACTIONS(3036),
    [anon_sym_sizeof] = ACTIONS(3034),
    [anon_sym___alignof__] = ACTIONS(3034),
    [anon_sym___alignof] = ACTIONS(3034),
    [anon_sym__alignof] = ACTIONS(3034),
    [anon_sym_alignof] = ACTIONS(3034),
    [anon_sym__Alignof] = ACTIONS(3034),
    [anon_sym_offsetof] = ACTIONS(3034),
    [anon_sym__Generic] = ACTIONS(3034),
    [anon_sym_asm] = ACTIONS(3034),
    [anon_sym___asm__] = ACTIONS(3034),
    [anon_sym___asm] = ACTIONS(3034),
    [sym_number_literal] = ACTIONS(3036),
    [anon_sym_L_SQUOTE] = ACTIONS(3036),
    [anon_sym_u_SQUOTE] = ACTIONS(3036),
    [anon_sym_U_SQUOTE] = ACTIONS(3036),
    [anon_sym_u8_SQUOTE] = ACTIONS(3036),
    [anon_sym_SQUOTE] = ACTIONS(3036),
    [anon_sym_L_DQUOTE] = ACTIONS(3036),
    [anon_sym_u_DQUOTE] = ACTIONS(3036),
    [anon_sym_U_DQUOTE] = ACTIONS(3036),
    [anon_sym_u8_DQUOTE] = ACTIONS(3036),
    [anon_sym_DQUOTE] = ACTIONS(3036),
    [sym_true] = ACTIONS(3034),
    [sym_false] = ACTIONS(3034),
    [anon_sym_NULL] = ACTIONS(3034),
    [anon_sym_nullptr] = ACTIONS(3034),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3034),
    [anon_sym_decltype] = ACTIONS(3034),
    [anon_sym_explicit] = ACTIONS(3034),
    [anon_sym_typename] = ACTIONS(3034),
    [anon_sym_template] = ACTIONS(3034),
    [anon_sym_operator] = ACTIONS(3034),
    [anon_sym_try] = ACTIONS(3034),
    [anon_sym_delete] = ACTIONS(3034),
    [anon_sym_throw] = ACTIONS(3034),
    [anon_sym_namespace] = ACTIONS(3034),
    [anon_sym_using] = ACTIONS(3034),
    [anon_sym_static_assert] = ACTIONS(3034),
    [anon_sym_concept] = ACTIONS(3034),
    [anon_sym_co_return] = ACTIONS(3034),
    [anon_sym_co_yield] = ACTIONS(3034),
    [anon_sym_R_DQUOTE] = ACTIONS(3036),
    [anon_sym_LR_DQUOTE] = ACTIONS(3036),
    [anon_sym_uR_DQUOTE] = ACTIONS(3036),
    [anon_sym_UR_DQUOTE] = ACTIONS(3036),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3036),
    [anon_sym_co_await] = ACTIONS(3034),
    [anon_sym_new] = ACTIONS(3034),
    [anon_sym_requires] = ACTIONS(3034),
    [sym_this] = ACTIONS(3034),
  },
  [715] = {
    [ts_builtin_sym_end] = ACTIONS(3040),
    [sym_identifier] = ACTIONS(3038),
    [aux_sym_preproc_include_token1] = ACTIONS(3038),
    [aux_sym_preproc_def_token1] = ACTIONS(3038),
    [aux_sym_preproc_if_token1] = ACTIONS(3038),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3038),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3038),
    [sym_preproc_directive] = ACTIONS(3038),
    [anon_sym_LPAREN2] = ACTIONS(3040),
    [anon_sym_BANG] = ACTIONS(3040),
    [anon_sym_TILDE] = ACTIONS(3040),
    [anon_sym_DASH] = ACTIONS(3038),
    [anon_sym_PLUS] = ACTIONS(3038),
    [anon_sym_STAR] = ACTIONS(3040),
    [anon_sym_AMP_AMP] = ACTIONS(3040),
    [anon_sym_AMP] = ACTIONS(3038),
    [anon_sym_SEMI] = ACTIONS(3040),
    [anon_sym___extension__] = ACTIONS(3038),
    [anon_sym_typedef] = ACTIONS(3038),
    [anon_sym_virtual] = ACTIONS(3038),
    [anon_sym_extern] = ACTIONS(3038),
    [anon_sym___attribute__] = ACTIONS(3038),
    [anon_sym___attribute] = ACTIONS(3038),
    [anon_sym_COLON_COLON] = ACTIONS(3040),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3040),
    [anon_sym___declspec] = ACTIONS(3038),
    [anon_sym___based] = ACTIONS(3038),
    [anon_sym___cdecl] = ACTIONS(3038),
    [anon_sym___clrcall] = ACTIONS(3038),
    [anon_sym___stdcall] = ACTIONS(3038),
    [anon_sym___fastcall] = ACTIONS(3038),
    [anon_sym___thiscall] = ACTIONS(3038),
    [anon_sym___vectorcall] = ACTIONS(3038),
    [anon_sym_LBRACE] = ACTIONS(3040),
    [anon_sym_signed] = ACTIONS(3038),
    [anon_sym_unsigned] = ACTIONS(3038),
    [anon_sym_long] = ACTIONS(3038),
    [anon_sym_short] = ACTIONS(3038),
    [anon_sym_LBRACK] = ACTIONS(3038),
    [anon_sym_static] = ACTIONS(3038),
    [anon_sym_register] = ACTIONS(3038),
    [anon_sym_inline] = ACTIONS(3038),
    [anon_sym___inline] = ACTIONS(3038),
    [anon_sym___inline__] = ACTIONS(3038),
    [anon_sym___forceinline] = ACTIONS(3038),
    [anon_sym_thread_local] = ACTIONS(3038),
    [anon_sym___thread] = ACTIONS(3038),
    [anon_sym_const] = ACTIONS(3038),
    [anon_sym_constexpr] = ACTIONS(3038),
    [anon_sym_volatile] = ACTIONS(3038),
    [anon_sym_restrict] = ACTIONS(3038),
    [anon_sym___restrict__] = ACTIONS(3038),
    [anon_sym__Atomic] = ACTIONS(3038),
    [anon_sym__Noreturn] = ACTIONS(3038),
    [anon_sym_noreturn] = ACTIONS(3038),
    [anon_sym__Nonnull] = ACTIONS(3038),
    [anon_sym_mutable] = ACTIONS(3038),
    [anon_sym_constinit] = ACTIONS(3038),
    [anon_sym_consteval] = ACTIONS(3038),
    [anon_sym_alignas] = ACTIONS(3038),
    [anon_sym__Alignas] = ACTIONS(3038),
    [sym_primitive_type] = ACTIONS(3038),
    [anon_sym_enum] = ACTIONS(3038),
    [anon_sym_class] = ACTIONS(3038),
    [anon_sym_struct] = ACTIONS(3038),
    [anon_sym_union] = ACTIONS(3038),
    [anon_sym_if] = ACTIONS(3038),
    [anon_sym_switch] = ACTIONS(3038),
    [anon_sym_case] = ACTIONS(3038),
    [anon_sym_default] = ACTIONS(3038),
    [anon_sym_while] = ACTIONS(3038),
    [anon_sym_do] = ACTIONS(3038),
    [anon_sym_for] = ACTIONS(3038),
    [anon_sym_return] = ACTIONS(3038),
    [anon_sym_break] = ACTIONS(3038),
    [anon_sym_continue] = ACTIONS(3038),
    [anon_sym_goto] = ACTIONS(3038),
    [anon_sym_not] = ACTIONS(3038),
    [anon_sym_compl] = ACTIONS(3038),
    [anon_sym_DASH_DASH] = ACTIONS(3040),
    [anon_sym_PLUS_PLUS] = ACTIONS(3040),
    [anon_sym_sizeof] = ACTIONS(3038),
    [anon_sym___alignof__] = ACTIONS(3038),
    [anon_sym___alignof] = ACTIONS(3038),
    [anon_sym__alignof] = ACTIONS(3038),
    [anon_sym_alignof] = ACTIONS(3038),
    [anon_sym__Alignof] = ACTIONS(3038),
    [anon_sym_offsetof] = ACTIONS(3038),
    [anon_sym__Generic] = ACTIONS(3038),
    [anon_sym_asm] = ACTIONS(3038),
    [anon_sym___asm__] = ACTIONS(3038),
    [anon_sym___asm] = ACTIONS(3038),
    [sym_number_literal] = ACTIONS(3040),
    [anon_sym_L_SQUOTE] = ACTIONS(3040),
    [anon_sym_u_SQUOTE] = ACTIONS(3040),
    [anon_sym_U_SQUOTE] = ACTIONS(3040),
    [anon_sym_u8_SQUOTE] = ACTIONS(3040),
    [anon_sym_SQUOTE] = ACTIONS(3040),
    [anon_sym_L_DQUOTE] = ACTIONS(3040),
    [anon_sym_u_DQUOTE] = ACTIONS(3040),
    [anon_sym_U_DQUOTE] = ACTIONS(3040),
    [anon_sym_u8_DQUOTE] = ACTIONS(3040),
    [anon_sym_DQUOTE] = ACTIONS(3040),
    [sym_true] = ACTIONS(3038),
    [sym_false] = ACTIONS(3038),
    [anon_sym_NULL] = ACTIONS(3038),
    [anon_sym_nullptr] = ACTIONS(3038),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3038),
    [anon_sym_decltype] = ACTIONS(3038),
    [anon_sym_explicit] = ACTIONS(3038),
    [anon_sym_typename] = ACTIONS(3038),
    [anon_sym_template] = ACTIONS(3038),
    [anon_sym_operator] = ACTIONS(3038),
    [anon_sym_try] = ACTIONS(3038),
    [anon_sym_delete] = ACTIONS(3038),
    [anon_sym_throw] = ACTIONS(3038),
    [anon_sym_namespace] = ACTIONS(3038),
    [anon_sym_using] = ACTIONS(3038),
    [anon_sym_static_assert] = ACTIONS(3038),
    [anon_sym_concept] = ACTIONS(3038),
    [anon_sym_co_return] = ACTIONS(3038),
    [anon_sym_co_yield] = ACTIONS(3038),
    [anon_sym_R_DQUOTE] = ACTIONS(3040),
    [anon_sym_LR_DQUOTE] = ACTIONS(3040),
    [anon_sym_uR_DQUOTE] = ACTIONS(3040),
    [anon_sym_UR_DQUOTE] = ACTIONS(3040),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3040),
    [anon_sym_co_await] = ACTIONS(3038),
    [anon_sym_new] = ACTIONS(3038),
    [anon_sym_requires] = ACTIONS(3038),
    [sym_this] = ACTIONS(3038),
  },
  [716] = {
    [ts_builtin_sym_end] = ACTIONS(3096),
    [sym_identifier] = ACTIONS(3094),
    [aux_sym_preproc_include_token1] = ACTIONS(3094),
    [aux_sym_preproc_def_token1] = ACTIONS(3094),
    [aux_sym_preproc_if_token1] = ACTIONS(3094),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3094),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3094),
    [sym_preproc_directive] = ACTIONS(3094),
    [anon_sym_LPAREN2] = ACTIONS(3096),
    [anon_sym_BANG] = ACTIONS(3096),
    [anon_sym_TILDE] = ACTIONS(3096),
    [anon_sym_DASH] = ACTIONS(3094),
    [anon_sym_PLUS] = ACTIONS(3094),
    [anon_sym_STAR] = ACTIONS(3096),
    [anon_sym_AMP_AMP] = ACTIONS(3096),
    [anon_sym_AMP] = ACTIONS(3094),
    [anon_sym_SEMI] = ACTIONS(3096),
    [anon_sym___extension__] = ACTIONS(3094),
    [anon_sym_typedef] = ACTIONS(3094),
    [anon_sym_virtual] = ACTIONS(3094),
    [anon_sym_extern] = ACTIONS(3094),
    [anon_sym___attribute__] = ACTIONS(3094),
    [anon_sym___attribute] = ACTIONS(3094),
    [anon_sym_COLON_COLON] = ACTIONS(3096),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3096),
    [anon_sym___declspec] = ACTIONS(3094),
    [anon_sym___based] = ACTIONS(3094),
    [anon_sym___cdecl] = ACTIONS(3094),
    [anon_sym___clrcall] = ACTIONS(3094),
    [anon_sym___stdcall] = ACTIONS(3094),
    [anon_sym___fastcall] = ACTIONS(3094),
    [anon_sym___thiscall] = ACTIONS(3094),
    [anon_sym___vectorcall] = ACTIONS(3094),
    [anon_sym_LBRACE] = ACTIONS(3096),
    [anon_sym_signed] = ACTIONS(3094),
    [anon_sym_unsigned] = ACTIONS(3094),
    [anon_sym_long] = ACTIONS(3094),
    [anon_sym_short] = ACTIONS(3094),
    [anon_sym_LBRACK] = ACTIONS(3094),
    [anon_sym_static] = ACTIONS(3094),
    [anon_sym_register] = ACTIONS(3094),
    [anon_sym_inline] = ACTIONS(3094),
    [anon_sym___inline] = ACTIONS(3094),
    [anon_sym___inline__] = ACTIONS(3094),
    [anon_sym___forceinline] = ACTIONS(3094),
    [anon_sym_thread_local] = ACTIONS(3094),
    [anon_sym___thread] = ACTIONS(3094),
    [anon_sym_const] = ACTIONS(3094),
    [anon_sym_constexpr] = ACTIONS(3094),
    [anon_sym_volatile] = ACTIONS(3094),
    [anon_sym_restrict] = ACTIONS(3094),
    [anon_sym___restrict__] = ACTIONS(3094),
    [anon_sym__Atomic] = ACTIONS(3094),
    [anon_sym__Noreturn] = ACTIONS(3094),
    [anon_sym_noreturn] = ACTIONS(3094),
    [anon_sym__Nonnull] = ACTIONS(3094),
    [anon_sym_mutable] = ACTIONS(3094),
    [anon_sym_constinit] = ACTIONS(3094),
    [anon_sym_consteval] = ACTIONS(3094),
    [anon_sym_alignas] = ACTIONS(3094),
    [anon_sym__Alignas] = ACTIONS(3094),
    [sym_primitive_type] = ACTIONS(3094),
    [anon_sym_enum] = ACTIONS(3094),
    [anon_sym_class] = ACTIONS(3094),
    [anon_sym_struct] = ACTIONS(3094),
    [anon_sym_union] = ACTIONS(3094),
    [anon_sym_if] = ACTIONS(3094),
    [anon_sym_switch] = ACTIONS(3094),
    [anon_sym_case] = ACTIONS(3094),
    [anon_sym_default] = ACTIONS(3094),
    [anon_sym_while] = ACTIONS(3094),
    [anon_sym_do] = ACTIONS(3094),
    [anon_sym_for] = ACTIONS(3094),
    [anon_sym_return] = ACTIONS(3094),
    [anon_sym_break] = ACTIONS(3094),
    [anon_sym_continue] = ACTIONS(3094),
    [anon_sym_goto] = ACTIONS(3094),
    [anon_sym_not] = ACTIONS(3094),
    [anon_sym_compl] = ACTIONS(3094),
    [anon_sym_DASH_DASH] = ACTIONS(3096),
    [anon_sym_PLUS_PLUS] = ACTIONS(3096),
    [anon_sym_sizeof] = ACTIONS(3094),
    [anon_sym___alignof__] = ACTIONS(3094),
    [anon_sym___alignof] = ACTIONS(3094),
    [anon_sym__alignof] = ACTIONS(3094),
    [anon_sym_alignof] = ACTIONS(3094),
    [anon_sym__Alignof] = ACTIONS(3094),
    [anon_sym_offsetof] = ACTIONS(3094),
    [anon_sym__Generic] = ACTIONS(3094),
    [anon_sym_asm] = ACTIONS(3094),
    [anon_sym___asm__] = ACTIONS(3094),
    [anon_sym___asm] = ACTIONS(3094),
    [sym_number_literal] = ACTIONS(3096),
    [anon_sym_L_SQUOTE] = ACTIONS(3096),
    [anon_sym_u_SQUOTE] = ACTIONS(3096),
    [anon_sym_U_SQUOTE] = ACTIONS(3096),
    [anon_sym_u8_SQUOTE] = ACTIONS(3096),
    [anon_sym_SQUOTE] = ACTIONS(3096),
    [anon_sym_L_DQUOTE] = ACTIONS(3096),
    [anon_sym_u_DQUOTE] = ACTIONS(3096),
    [anon_sym_U_DQUOTE] = ACTIONS(3096),
    [anon_sym_u8_DQUOTE] = ACTIONS(3096),
    [anon_sym_DQUOTE] = ACTIONS(3096),
    [sym_true] = ACTIONS(3094),
    [sym_false] = ACTIONS(3094),
    [anon_sym_NULL] = ACTIONS(3094),
    [anon_sym_nullptr] = ACTIONS(3094),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3094),
    [anon_sym_decltype] = ACTIONS(3094),
    [anon_sym_explicit] = ACTIONS(3094),
    [anon_sym_typename] = ACTIONS(3094),
    [anon_sym_template] = ACTIONS(3094),
    [anon_sym_operator] = ACTIONS(3094),
    [anon_sym_try] = ACTIONS(3094),
    [anon_sym_delete] = ACTIONS(3094),
    [anon_sym_throw] = ACTIONS(3094),
    [anon_sym_namespace] = ACTIONS(3094),
    [anon_sym_using] = ACTIONS(3094),
    [anon_sym_static_assert] = ACTIONS(3094),
    [anon_sym_concept] = ACTIONS(3094),
    [anon_sym_co_return] = ACTIONS(3094),
    [anon_sym_co_yield] = ACTIONS(3094),
    [anon_sym_R_DQUOTE] = ACTIONS(3096),
    [anon_sym_LR_DQUOTE] = ACTIONS(3096),
    [anon_sym_uR_DQUOTE] = ACTIONS(3096),
    [anon_sym_UR_DQUOTE] = ACTIONS(3096),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3096),
    [anon_sym_co_await] = ACTIONS(3094),
    [anon_sym_new] = ACTIONS(3094),
    [anon_sym_requires] = ACTIONS(3094),
    [sym_this] = ACTIONS(3094),
  },
  [717] = {
    [ts_builtin_sym_end] = ACTIONS(3100),
    [sym_identifier] = ACTIONS(3098),
    [aux_sym_preproc_include_token1] = ACTIONS(3098),
    [aux_sym_preproc_def_token1] = ACTIONS(3098),
    [aux_sym_preproc_if_token1] = ACTIONS(3098),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3098),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3098),
    [sym_preproc_directive] = ACTIONS(3098),
    [anon_sym_LPAREN2] = ACTIONS(3100),
    [anon_sym_BANG] = ACTIONS(3100),
    [anon_sym_TILDE] = ACTIONS(3100),
    [anon_sym_DASH] = ACTIONS(3098),
    [anon_sym_PLUS] = ACTIONS(3098),
    [anon_sym_STAR] = ACTIONS(3100),
    [anon_sym_AMP_AMP] = ACTIONS(3100),
    [anon_sym_AMP] = ACTIONS(3098),
    [anon_sym_SEMI] = ACTIONS(3100),
    [anon_sym___extension__] = ACTIONS(3098),
    [anon_sym_typedef] = ACTIONS(3098),
    [anon_sym_virtual] = ACTIONS(3098),
    [anon_sym_extern] = ACTIONS(3098),
    [anon_sym___attribute__] = ACTIONS(3098),
    [anon_sym___attribute] = ACTIONS(3098),
    [anon_sym_COLON_COLON] = ACTIONS(3100),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3100),
    [anon_sym___declspec] = ACTIONS(3098),
    [anon_sym___based] = ACTIONS(3098),
    [anon_sym___cdecl] = ACTIONS(3098),
    [anon_sym___clrcall] = ACTIONS(3098),
    [anon_sym___stdcall] = ACTIONS(3098),
    [anon_sym___fastcall] = ACTIONS(3098),
    [anon_sym___thiscall] = ACTIONS(3098),
    [anon_sym___vectorcall] = ACTIONS(3098),
    [anon_sym_LBRACE] = ACTIONS(3100),
    [anon_sym_signed] = ACTIONS(3098),
    [anon_sym_unsigned] = ACTIONS(3098),
    [anon_sym_long] = ACTIONS(3098),
    [anon_sym_short] = ACTIONS(3098),
    [anon_sym_LBRACK] = ACTIONS(3098),
    [anon_sym_static] = ACTIONS(3098),
    [anon_sym_register] = ACTIONS(3098),
    [anon_sym_inline] = ACTIONS(3098),
    [anon_sym___inline] = ACTIONS(3098),
    [anon_sym___inline__] = ACTIONS(3098),
    [anon_sym___forceinline] = ACTIONS(3098),
    [anon_sym_thread_local] = ACTIONS(3098),
    [anon_sym___thread] = ACTIONS(3098),
    [anon_sym_const] = ACTIONS(3098),
    [anon_sym_constexpr] = ACTIONS(3098),
    [anon_sym_volatile] = ACTIONS(3098),
    [anon_sym_restrict] = ACTIONS(3098),
    [anon_sym___restrict__] = ACTIONS(3098),
    [anon_sym__Atomic] = ACTIONS(3098),
    [anon_sym__Noreturn] = ACTIONS(3098),
    [anon_sym_noreturn] = ACTIONS(3098),
    [anon_sym__Nonnull] = ACTIONS(3098),
    [anon_sym_mutable] = ACTIONS(3098),
    [anon_sym_constinit] = ACTIONS(3098),
    [anon_sym_consteval] = ACTIONS(3098),
    [anon_sym_alignas] = ACTIONS(3098),
    [anon_sym__Alignas] = ACTIONS(3098),
    [sym_primitive_type] = ACTIONS(3098),
    [anon_sym_enum] = ACTIONS(3098),
    [anon_sym_class] = ACTIONS(3098),
    [anon_sym_struct] = ACTIONS(3098),
    [anon_sym_union] = ACTIONS(3098),
    [anon_sym_if] = ACTIONS(3098),
    [anon_sym_switch] = ACTIONS(3098),
    [anon_sym_case] = ACTIONS(3098),
    [anon_sym_default] = ACTIONS(3098),
    [anon_sym_while] = ACTIONS(3098),
    [anon_sym_do] = ACTIONS(3098),
    [anon_sym_for] = ACTIONS(3098),
    [anon_sym_return] = ACTIONS(3098),
    [anon_sym_break] = ACTIONS(3098),
    [anon_sym_continue] = ACTIONS(3098),
    [anon_sym_goto] = ACTIONS(3098),
    [anon_sym_not] = ACTIONS(3098),
    [anon_sym_compl] = ACTIONS(3098),
    [anon_sym_DASH_DASH] = ACTIONS(3100),
    [anon_sym_PLUS_PLUS] = ACTIONS(3100),
    [anon_sym_sizeof] = ACTIONS(3098),
    [anon_sym___alignof__] = ACTIONS(3098),
    [anon_sym___alignof] = ACTIONS(3098),
    [anon_sym__alignof] = ACTIONS(3098),
    [anon_sym_alignof] = ACTIONS(3098),
    [anon_sym__Alignof] = ACTIONS(3098),
    [anon_sym_offsetof] = ACTIONS(3098),
    [anon_sym__Generic] = ACTIONS(3098),
    [anon_sym_asm] = ACTIONS(3098),
    [anon_sym___asm__] = ACTIONS(3098),
    [anon_sym___asm] = ACTIONS(3098),
    [sym_number_literal] = ACTIONS(3100),
    [anon_sym_L_SQUOTE] = ACTIONS(3100),
    [anon_sym_u_SQUOTE] = ACTIONS(3100),
    [anon_sym_U_SQUOTE] = ACTIONS(3100),
    [anon_sym_u8_SQUOTE] = ACTIONS(3100),
    [anon_sym_SQUOTE] = ACTIONS(3100),
    [anon_sym_L_DQUOTE] = ACTIONS(3100),
    [anon_sym_u_DQUOTE] = ACTIONS(3100),
    [anon_sym_U_DQUOTE] = ACTIONS(3100),
    [anon_sym_u8_DQUOTE] = ACTIONS(3100),
    [anon_sym_DQUOTE] = ACTIONS(3100),
    [sym_true] = ACTIONS(3098),
    [sym_false] = ACTIONS(3098),
    [anon_sym_NULL] = ACTIONS(3098),
    [anon_sym_nullptr] = ACTIONS(3098),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3098),
    [anon_sym_decltype] = ACTIONS(3098),
    [anon_sym_explicit] = ACTIONS(3098),
    [anon_sym_typename] = ACTIONS(3098),
    [anon_sym_template] = ACTIONS(3098),
    [anon_sym_operator] = ACTIONS(3098),
    [anon_sym_try] = ACTIONS(3098),
    [anon_sym_delete] = ACTIONS(3098),
    [anon_sym_throw] = ACTIONS(3098),
    [anon_sym_namespace] = ACTIONS(3098),
    [anon_sym_using] = ACTIONS(3098),
    [anon_sym_static_assert] = ACTIONS(3098),
    [anon_sym_concept] = ACTIONS(3098),
    [anon_sym_co_return] = ACTIONS(3098),
    [anon_sym_co_yield] = ACTIONS(3098),
    [anon_sym_R_DQUOTE] = ACTIONS(3100),
    [anon_sym_LR_DQUOTE] = ACTIONS(3100),
    [anon_sym_uR_DQUOTE] = ACTIONS(3100),
    [anon_sym_UR_DQUOTE] = ACTIONS(3100),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3100),
    [anon_sym_co_await] = ACTIONS(3098),
    [anon_sym_new] = ACTIONS(3098),
    [anon_sym_requires] = ACTIONS(3098),
    [sym_this] = ACTIONS(3098),
  },
  [718] = {
    [ts_builtin_sym_end] = ACTIONS(3106),
    [sym_identifier] = ACTIONS(3104),
    [aux_sym_preproc_include_token1] = ACTIONS(3104),
    [aux_sym_preproc_def_token1] = ACTIONS(3104),
    [aux_sym_preproc_if_token1] = ACTIONS(3104),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3104),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3104),
    [sym_preproc_directive] = ACTIONS(3104),
    [anon_sym_LPAREN2] = ACTIONS(3106),
    [anon_sym_BANG] = ACTIONS(3106),
    [anon_sym_TILDE] = ACTIONS(3106),
    [anon_sym_DASH] = ACTIONS(3104),
    [anon_sym_PLUS] = ACTIONS(3104),
    [anon_sym_STAR] = ACTIONS(3106),
    [anon_sym_AMP_AMP] = ACTIONS(3106),
    [anon_sym_AMP] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(3106),
    [anon_sym___extension__] = ACTIONS(3104),
    [anon_sym_typedef] = ACTIONS(3104),
    [anon_sym_virtual] = ACTIONS(3104),
    [anon_sym_extern] = ACTIONS(3104),
    [anon_sym___attribute__] = ACTIONS(3104),
    [anon_sym___attribute] = ACTIONS(3104),
    [anon_sym_COLON_COLON] = ACTIONS(3106),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3106),
    [anon_sym___declspec] = ACTIONS(3104),
    [anon_sym___based] = ACTIONS(3104),
    [anon_sym___cdecl] = ACTIONS(3104),
    [anon_sym___clrcall] = ACTIONS(3104),
    [anon_sym___stdcall] = ACTIONS(3104),
    [anon_sym___fastcall] = ACTIONS(3104),
    [anon_sym___thiscall] = ACTIONS(3104),
    [anon_sym___vectorcall] = ACTIONS(3104),
    [anon_sym_LBRACE] = ACTIONS(3106),
    [anon_sym_signed] = ACTIONS(3104),
    [anon_sym_unsigned] = ACTIONS(3104),
    [anon_sym_long] = ACTIONS(3104),
    [anon_sym_short] = ACTIONS(3104),
    [anon_sym_LBRACK] = ACTIONS(3104),
    [anon_sym_static] = ACTIONS(3104),
    [anon_sym_register] = ACTIONS(3104),
    [anon_sym_inline] = ACTIONS(3104),
    [anon_sym___inline] = ACTIONS(3104),
    [anon_sym___inline__] = ACTIONS(3104),
    [anon_sym___forceinline] = ACTIONS(3104),
    [anon_sym_thread_local] = ACTIONS(3104),
    [anon_sym___thread] = ACTIONS(3104),
    [anon_sym_const] = ACTIONS(3104),
    [anon_sym_constexpr] = ACTIONS(3104),
    [anon_sym_volatile] = ACTIONS(3104),
    [anon_sym_restrict] = ACTIONS(3104),
    [anon_sym___restrict__] = ACTIONS(3104),
    [anon_sym__Atomic] = ACTIONS(3104),
    [anon_sym__Noreturn] = ACTIONS(3104),
    [anon_sym_noreturn] = ACTIONS(3104),
    [anon_sym__Nonnull] = ACTIONS(3104),
    [anon_sym_mutable] = ACTIONS(3104),
    [anon_sym_constinit] = ACTIONS(3104),
    [anon_sym_consteval] = ACTIONS(3104),
    [anon_sym_alignas] = ACTIONS(3104),
    [anon_sym__Alignas] = ACTIONS(3104),
    [sym_primitive_type] = ACTIONS(3104),
    [anon_sym_enum] = ACTIONS(3104),
    [anon_sym_class] = ACTIONS(3104),
    [anon_sym_struct] = ACTIONS(3104),
    [anon_sym_union] = ACTIONS(3104),
    [anon_sym_if] = ACTIONS(3104),
    [anon_sym_switch] = ACTIONS(3104),
    [anon_sym_case] = ACTIONS(3104),
    [anon_sym_default] = ACTIONS(3104),
    [anon_sym_while] = ACTIONS(3104),
    [anon_sym_do] = ACTIONS(3104),
    [anon_sym_for] = ACTIONS(3104),
    [anon_sym_return] = ACTIONS(3104),
    [anon_sym_break] = ACTIONS(3104),
    [anon_sym_continue] = ACTIONS(3104),
    [anon_sym_goto] = ACTIONS(3104),
    [anon_sym_not] = ACTIONS(3104),
    [anon_sym_compl] = ACTIONS(3104),
    [anon_sym_DASH_DASH] = ACTIONS(3106),
    [anon_sym_PLUS_PLUS] = ACTIONS(3106),
    [anon_sym_sizeof] = ACTIONS(3104),
    [anon_sym___alignof__] = ACTIONS(3104),
    [anon_sym___alignof] = ACTIONS(3104),
    [anon_sym__alignof] = ACTIONS(3104),
    [anon_sym_alignof] = ACTIONS(3104),
    [anon_sym__Alignof] = ACTIONS(3104),
    [anon_sym_offsetof] = ACTIONS(3104),
    [anon_sym__Generic] = ACTIONS(3104),
    [anon_sym_asm] = ACTIONS(3104),
    [anon_sym___asm__] = ACTIONS(3104),
    [anon_sym___asm] = ACTIONS(3104),
    [sym_number_literal] = ACTIONS(3106),
    [anon_sym_L_SQUOTE] = ACTIONS(3106),
    [anon_sym_u_SQUOTE] = ACTIONS(3106),
    [anon_sym_U_SQUOTE] = ACTIONS(3106),
    [anon_sym_u8_SQUOTE] = ACTIONS(3106),
    [anon_sym_SQUOTE] = ACTIONS(3106),
    [anon_sym_L_DQUOTE] = ACTIONS(3106),
    [anon_sym_u_DQUOTE] = ACTIONS(3106),
    [anon_sym_U_DQUOTE] = ACTIONS(3106),
    [anon_sym_u8_DQUOTE] = ACTIONS(3106),
    [anon_sym_DQUOTE] = ACTIONS(3106),
    [sym_true] = ACTIONS(3104),
    [sym_false] = ACTIONS(3104),
    [anon_sym_NULL] = ACTIONS(3104),
    [anon_sym_nullptr] = ACTIONS(3104),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3104),
    [anon_sym_decltype] = ACTIONS(3104),
    [anon_sym_explicit] = ACTIONS(3104),
    [anon_sym_typename] = ACTIONS(3104),
    [anon_sym_template] = ACTIONS(3104),
    [anon_sym_operator] = ACTIONS(3104),
    [anon_sym_try] = ACTIONS(3104),
    [anon_sym_delete] = ACTIONS(3104),
    [anon_sym_throw] = ACTIONS(3104),
    [anon_sym_namespace] = ACTIONS(3104),
    [anon_sym_using] = ACTIONS(3104),
    [anon_sym_static_assert] = ACTIONS(3104),
    [anon_sym_concept] = ACTIONS(3104),
    [anon_sym_co_return] = ACTIONS(3104),
    [anon_sym_co_yield] = ACTIONS(3104),
    [anon_sym_R_DQUOTE] = ACTIONS(3106),
    [anon_sym_LR_DQUOTE] = ACTIONS(3106),
    [anon_sym_uR_DQUOTE] = ACTIONS(3106),
    [anon_sym_UR_DQUOTE] = ACTIONS(3106),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3106),
    [anon_sym_co_await] = ACTIONS(3104),
    [anon_sym_new] = ACTIONS(3104),
    [anon_sym_requires] = ACTIONS(3104),
    [sym_this] = ACTIONS(3104),
  },
  [719] = {
    [ts_builtin_sym_end] = ACTIONS(3140),
    [sym_identifier] = ACTIONS(3138),
    [aux_sym_preproc_include_token1] = ACTIONS(3138),
    [aux_sym_preproc_def_token1] = ACTIONS(3138),
    [aux_sym_preproc_if_token1] = ACTIONS(3138),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3138),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3138),
    [sym_preproc_directive] = ACTIONS(3138),
    [anon_sym_LPAREN2] = ACTIONS(3140),
    [anon_sym_BANG] = ACTIONS(3140),
    [anon_sym_TILDE] = ACTIONS(3140),
    [anon_sym_DASH] = ACTIONS(3138),
    [anon_sym_PLUS] = ACTIONS(3138),
    [anon_sym_STAR] = ACTIONS(3140),
    [anon_sym_AMP_AMP] = ACTIONS(3140),
    [anon_sym_AMP] = ACTIONS(3138),
    [anon_sym_SEMI] = ACTIONS(3140),
    [anon_sym___extension__] = ACTIONS(3138),
    [anon_sym_typedef] = ACTIONS(3138),
    [anon_sym_virtual] = ACTIONS(3138),
    [anon_sym_extern] = ACTIONS(3138),
    [anon_sym___attribute__] = ACTIONS(3138),
    [anon_sym___attribute] = ACTIONS(3138),
    [anon_sym_COLON_COLON] = ACTIONS(3140),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3140),
    [anon_sym___declspec] = ACTIONS(3138),
    [anon_sym___based] = ACTIONS(3138),
    [anon_sym___cdecl] = ACTIONS(3138),
    [anon_sym___clrcall] = ACTIONS(3138),
    [anon_sym___stdcall] = ACTIONS(3138),
    [anon_sym___fastcall] = ACTIONS(3138),
    [anon_sym___thiscall] = ACTIONS(3138),
    [anon_sym___vectorcall] = ACTIONS(3138),
    [anon_sym_LBRACE] = ACTIONS(3140),
    [anon_sym_signed] = ACTIONS(3138),
    [anon_sym_unsigned] = ACTIONS(3138),
    [anon_sym_long] = ACTIONS(3138),
    [anon_sym_short] = ACTIONS(3138),
    [anon_sym_LBRACK] = ACTIONS(3138),
    [anon_sym_static] = ACTIONS(3138),
    [anon_sym_register] = ACTIONS(3138),
    [anon_sym_inline] = ACTIONS(3138),
    [anon_sym___inline] = ACTIONS(3138),
    [anon_sym___inline__] = ACTIONS(3138),
    [anon_sym___forceinline] = ACTIONS(3138),
    [anon_sym_thread_local] = ACTIONS(3138),
    [anon_sym___thread] = ACTIONS(3138),
    [anon_sym_const] = ACTIONS(3138),
    [anon_sym_constexpr] = ACTIONS(3138),
    [anon_sym_volatile] = ACTIONS(3138),
    [anon_sym_restrict] = ACTIONS(3138),
    [anon_sym___restrict__] = ACTIONS(3138),
    [anon_sym__Atomic] = ACTIONS(3138),
    [anon_sym__Noreturn] = ACTIONS(3138),
    [anon_sym_noreturn] = ACTIONS(3138),
    [anon_sym__Nonnull] = ACTIONS(3138),
    [anon_sym_mutable] = ACTIONS(3138),
    [anon_sym_constinit] = ACTIONS(3138),
    [anon_sym_consteval] = ACTIONS(3138),
    [anon_sym_alignas] = ACTIONS(3138),
    [anon_sym__Alignas] = ACTIONS(3138),
    [sym_primitive_type] = ACTIONS(3138),
    [anon_sym_enum] = ACTIONS(3138),
    [anon_sym_class] = ACTIONS(3138),
    [anon_sym_struct] = ACTIONS(3138),
    [anon_sym_union] = ACTIONS(3138),
    [anon_sym_if] = ACTIONS(3138),
    [anon_sym_switch] = ACTIONS(3138),
    [anon_sym_case] = ACTIONS(3138),
    [anon_sym_default] = ACTIONS(3138),
    [anon_sym_while] = ACTIONS(3138),
    [anon_sym_do] = ACTIONS(3138),
    [anon_sym_for] = ACTIONS(3138),
    [anon_sym_return] = ACTIONS(3138),
    [anon_sym_break] = ACTIONS(3138),
    [anon_sym_continue] = ACTIONS(3138),
    [anon_sym_goto] = ACTIONS(3138),
    [anon_sym_not] = ACTIONS(3138),
    [anon_sym_compl] = ACTIONS(3138),
    [anon_sym_DASH_DASH] = ACTIONS(3140),
    [anon_sym_PLUS_PLUS] = ACTIONS(3140),
    [anon_sym_sizeof] = ACTIONS(3138),
    [anon_sym___alignof__] = ACTIONS(3138),
    [anon_sym___alignof] = ACTIONS(3138),
    [anon_sym__alignof] = ACTIONS(3138),
    [anon_sym_alignof] = ACTIONS(3138),
    [anon_sym__Alignof] = ACTIONS(3138),
    [anon_sym_offsetof] = ACTIONS(3138),
    [anon_sym__Generic] = ACTIONS(3138),
    [anon_sym_asm] = ACTIONS(3138),
    [anon_sym___asm__] = ACTIONS(3138),
    [anon_sym___asm] = ACTIONS(3138),
    [sym_number_literal] = ACTIONS(3140),
    [anon_sym_L_SQUOTE] = ACTIONS(3140),
    [anon_sym_u_SQUOTE] = ACTIONS(3140),
    [anon_sym_U_SQUOTE] = ACTIONS(3140),
    [anon_sym_u8_SQUOTE] = ACTIONS(3140),
    [anon_sym_SQUOTE] = ACTIONS(3140),
    [anon_sym_L_DQUOTE] = ACTIONS(3140),
    [anon_sym_u_DQUOTE] = ACTIONS(3140),
    [anon_sym_U_DQUOTE] = ACTIONS(3140),
    [anon_sym_u8_DQUOTE] = ACTIONS(3140),
    [anon_sym_DQUOTE] = ACTIONS(3140),
    [sym_true] = ACTIONS(3138),
    [sym_false] = ACTIONS(3138),
    [anon_sym_NULL] = ACTIONS(3138),
    [anon_sym_nullptr] = ACTIONS(3138),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3138),
    [anon_sym_decltype] = ACTIONS(3138),
    [anon_sym_explicit] = ACTIONS(3138),
    [anon_sym_typename] = ACTIONS(3138),
    [anon_sym_template] = ACTIONS(3138),
    [anon_sym_operator] = ACTIONS(3138),
    [anon_sym_try] = ACTIONS(3138),
    [anon_sym_delete] = ACTIONS(3138),
    [anon_sym_throw] = ACTIONS(3138),
    [anon_sym_namespace] = ACTIONS(3138),
    [anon_sym_using] = ACTIONS(3138),
    [anon_sym_static_assert] = ACTIONS(3138),
    [anon_sym_concept] = ACTIONS(3138),
    [anon_sym_co_return] = ACTIONS(3138),
    [anon_sym_co_yield] = ACTIONS(3138),
    [anon_sym_R_DQUOTE] = ACTIONS(3140),
    [anon_sym_LR_DQUOTE] = ACTIONS(3140),
    [anon_sym_uR_DQUOTE] = ACTIONS(3140),
    [anon_sym_UR_DQUOTE] = ACTIONS(3140),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3140),
    [anon_sym_co_await] = ACTIONS(3138),
    [anon_sym_new] = ACTIONS(3138),
    [anon_sym_requires] = ACTIONS(3138),
    [sym_this] = ACTIONS(3138),
  },
  [720] = {
    [ts_builtin_sym_end] = ACTIONS(3144),
    [sym_identifier] = ACTIONS(3142),
    [aux_sym_preproc_include_token1] = ACTIONS(3142),
    [aux_sym_preproc_def_token1] = ACTIONS(3142),
    [aux_sym_preproc_if_token1] = ACTIONS(3142),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3142),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3142),
    [sym_preproc_directive] = ACTIONS(3142),
    [anon_sym_LPAREN2] = ACTIONS(3144),
    [anon_sym_BANG] = ACTIONS(3144),
    [anon_sym_TILDE] = ACTIONS(3144),
    [anon_sym_DASH] = ACTIONS(3142),
    [anon_sym_PLUS] = ACTIONS(3142),
    [anon_sym_STAR] = ACTIONS(3144),
    [anon_sym_AMP_AMP] = ACTIONS(3144),
    [anon_sym_AMP] = ACTIONS(3142),
    [anon_sym_SEMI] = ACTIONS(3144),
    [anon_sym___extension__] = ACTIONS(3142),
    [anon_sym_typedef] = ACTIONS(3142),
    [anon_sym_virtual] = ACTIONS(3142),
    [anon_sym_extern] = ACTIONS(3142),
    [anon_sym___attribute__] = ACTIONS(3142),
    [anon_sym___attribute] = ACTIONS(3142),
    [anon_sym_COLON_COLON] = ACTIONS(3144),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3144),
    [anon_sym___declspec] = ACTIONS(3142),
    [anon_sym___based] = ACTIONS(3142),
    [anon_sym___cdecl] = ACTIONS(3142),
    [anon_sym___clrcall] = ACTIONS(3142),
    [anon_sym___stdcall] = ACTIONS(3142),
    [anon_sym___fastcall] = ACTIONS(3142),
    [anon_sym___thiscall] = ACTIONS(3142),
    [anon_sym___vectorcall] = ACTIONS(3142),
    [anon_sym_LBRACE] = ACTIONS(3144),
    [anon_sym_signed] = ACTIONS(3142),
    [anon_sym_unsigned] = ACTIONS(3142),
    [anon_sym_long] = ACTIONS(3142),
    [anon_sym_short] = ACTIONS(3142),
    [anon_sym_LBRACK] = ACTIONS(3142),
    [anon_sym_static] = ACTIONS(3142),
    [anon_sym_register] = ACTIONS(3142),
    [anon_sym_inline] = ACTIONS(3142),
    [anon_sym___inline] = ACTIONS(3142),
    [anon_sym___inline__] = ACTIONS(3142),
    [anon_sym___forceinline] = ACTIONS(3142),
    [anon_sym_thread_local] = ACTIONS(3142),
    [anon_sym___thread] = ACTIONS(3142),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_constexpr] = ACTIONS(3142),
    [anon_sym_volatile] = ACTIONS(3142),
    [anon_sym_restrict] = ACTIONS(3142),
    [anon_sym___restrict__] = ACTIONS(3142),
    [anon_sym__Atomic] = ACTIONS(3142),
    [anon_sym__Noreturn] = ACTIONS(3142),
    [anon_sym_noreturn] = ACTIONS(3142),
    [anon_sym__Nonnull] = ACTIONS(3142),
    [anon_sym_mutable] = ACTIONS(3142),
    [anon_sym_constinit] = ACTIONS(3142),
    [anon_sym_consteval] = ACTIONS(3142),
    [anon_sym_alignas] = ACTIONS(3142),
    [anon_sym__Alignas] = ACTIONS(3142),
    [sym_primitive_type] = ACTIONS(3142),
    [anon_sym_enum] = ACTIONS(3142),
    [anon_sym_class] = ACTIONS(3142),
    [anon_sym_struct] = ACTIONS(3142),
    [anon_sym_union] = ACTIONS(3142),
    [anon_sym_if] = ACTIONS(3142),
    [anon_sym_switch] = ACTIONS(3142),
    [anon_sym_case] = ACTIONS(3142),
    [anon_sym_default] = ACTIONS(3142),
    [anon_sym_while] = ACTIONS(3142),
    [anon_sym_do] = ACTIONS(3142),
    [anon_sym_for] = ACTIONS(3142),
    [anon_sym_return] = ACTIONS(3142),
    [anon_sym_break] = ACTIONS(3142),
    [anon_sym_continue] = ACTIONS(3142),
    [anon_sym_goto] = ACTIONS(3142),
    [anon_sym_not] = ACTIONS(3142),
    [anon_sym_compl] = ACTIONS(3142),
    [anon_sym_DASH_DASH] = ACTIONS(3144),
    [anon_sym_PLUS_PLUS] = ACTIONS(3144),
    [anon_sym_sizeof] = ACTIONS(3142),
    [anon_sym___alignof__] = ACTIONS(3142),
    [anon_sym___alignof] = ACTIONS(3142),
    [anon_sym__alignof] = ACTIONS(3142),
    [anon_sym_alignof] = ACTIONS(3142),
    [anon_sym__Alignof] = ACTIONS(3142),
    [anon_sym_offsetof] = ACTIONS(3142),
    [anon_sym__Generic] = ACTIONS(3142),
    [anon_sym_asm] = ACTIONS(3142),
    [anon_sym___asm__] = ACTIONS(3142),
    [anon_sym___asm] = ACTIONS(3142),
    [sym_number_literal] = ACTIONS(3144),
    [anon_sym_L_SQUOTE] = ACTIONS(3144),
    [anon_sym_u_SQUOTE] = ACTIONS(3144),
    [anon_sym_U_SQUOTE] = ACTIONS(3144),
    [anon_sym_u8_SQUOTE] = ACTIONS(3144),
    [anon_sym_SQUOTE] = ACTIONS(3144),
    [anon_sym_L_DQUOTE] = ACTIONS(3144),
    [anon_sym_u_DQUOTE] = ACTIONS(3144),
    [anon_sym_U_DQUOTE] = ACTIONS(3144),
    [anon_sym_u8_DQUOTE] = ACTIONS(3144),
    [anon_sym_DQUOTE] = ACTIONS(3144),
    [sym_true] = ACTIONS(3142),
    [sym_false] = ACTIONS(3142),
    [anon_sym_NULL] = ACTIONS(3142),
    [anon_sym_nullptr] = ACTIONS(3142),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3142),
    [anon_sym_decltype] = ACTIONS(3142),
    [anon_sym_explicit] = ACTIONS(3142),
    [anon_sym_typename] = ACTIONS(3142),
    [anon_sym_template] = ACTIONS(3142),
    [anon_sym_operator] = ACTIONS(3142),
    [anon_sym_try] = ACTIONS(3142),
    [anon_sym_delete] = ACTIONS(3142),
    [anon_sym_throw] = ACTIONS(3142),
    [anon_sym_namespace] = ACTIONS(3142),
    [anon_sym_using] = ACTIONS(3142),
    [anon_sym_static_assert] = ACTIONS(3142),
    [anon_sym_concept] = ACTIONS(3142),
    [anon_sym_co_return] = ACTIONS(3142),
    [anon_sym_co_yield] = ACTIONS(3142),
    [anon_sym_R_DQUOTE] = ACTIONS(3144),
    [anon_sym_LR_DQUOTE] = ACTIONS(3144),
    [anon_sym_uR_DQUOTE] = ACTIONS(3144),
    [anon_sym_UR_DQUOTE] = ACTIONS(3144),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3144),
    [anon_sym_co_await] = ACTIONS(3142),
    [anon_sym_new] = ACTIONS(3142),
    [anon_sym_requires] = ACTIONS(3142),
    [sym_this] = ACTIONS(3142),
  },
  [721] = {
    [ts_builtin_sym_end] = ACTIONS(3156),
    [sym_identifier] = ACTIONS(3154),
    [aux_sym_preproc_include_token1] = ACTIONS(3154),
    [aux_sym_preproc_def_token1] = ACTIONS(3154),
    [aux_sym_preproc_if_token1] = ACTIONS(3154),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3154),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3154),
    [sym_preproc_directive] = ACTIONS(3154),
    [anon_sym_LPAREN2] = ACTIONS(3156),
    [anon_sym_BANG] = ACTIONS(3156),
    [anon_sym_TILDE] = ACTIONS(3156),
    [anon_sym_DASH] = ACTIONS(3154),
    [anon_sym_PLUS] = ACTIONS(3154),
    [anon_sym_STAR] = ACTIONS(3156),
    [anon_sym_AMP_AMP] = ACTIONS(3156),
    [anon_sym_AMP] = ACTIONS(3154),
    [anon_sym_SEMI] = ACTIONS(3156),
    [anon_sym___extension__] = ACTIONS(3154),
    [anon_sym_typedef] = ACTIONS(3154),
    [anon_sym_virtual] = ACTIONS(3154),
    [anon_sym_extern] = ACTIONS(3154),
    [anon_sym___attribute__] = ACTIONS(3154),
    [anon_sym___attribute] = ACTIONS(3154),
    [anon_sym_COLON_COLON] = ACTIONS(3156),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3156),
    [anon_sym___declspec] = ACTIONS(3154),
    [anon_sym___based] = ACTIONS(3154),
    [anon_sym___cdecl] = ACTIONS(3154),
    [anon_sym___clrcall] = ACTIONS(3154),
    [anon_sym___stdcall] = ACTIONS(3154),
    [anon_sym___fastcall] = ACTIONS(3154),
    [anon_sym___thiscall] = ACTIONS(3154),
    [anon_sym___vectorcall] = ACTIONS(3154),
    [anon_sym_LBRACE] = ACTIONS(3156),
    [anon_sym_signed] = ACTIONS(3154),
    [anon_sym_unsigned] = ACTIONS(3154),
    [anon_sym_long] = ACTIONS(3154),
    [anon_sym_short] = ACTIONS(3154),
    [anon_sym_LBRACK] = ACTIONS(3154),
    [anon_sym_static] = ACTIONS(3154),
    [anon_sym_register] = ACTIONS(3154),
    [anon_sym_inline] = ACTIONS(3154),
    [anon_sym___inline] = ACTIONS(3154),
    [anon_sym___inline__] = ACTIONS(3154),
    [anon_sym___forceinline] = ACTIONS(3154),
    [anon_sym_thread_local] = ACTIONS(3154),
    [anon_sym___thread] = ACTIONS(3154),
    [anon_sym_const] = ACTIONS(3154),
    [anon_sym_constexpr] = ACTIONS(3154),
    [anon_sym_volatile] = ACTIONS(3154),
    [anon_sym_restrict] = ACTIONS(3154),
    [anon_sym___restrict__] = ACTIONS(3154),
    [anon_sym__Atomic] = ACTIONS(3154),
    [anon_sym__Noreturn] = ACTIONS(3154),
    [anon_sym_noreturn] = ACTIONS(3154),
    [anon_sym__Nonnull] = ACTIONS(3154),
    [anon_sym_mutable] = ACTIONS(3154),
    [anon_sym_constinit] = ACTIONS(3154),
    [anon_sym_consteval] = ACTIONS(3154),
    [anon_sym_alignas] = ACTIONS(3154),
    [anon_sym__Alignas] = ACTIONS(3154),
    [sym_primitive_type] = ACTIONS(3154),
    [anon_sym_enum] = ACTIONS(3154),
    [anon_sym_class] = ACTIONS(3154),
    [anon_sym_struct] = ACTIONS(3154),
    [anon_sym_union] = ACTIONS(3154),
    [anon_sym_if] = ACTIONS(3154),
    [anon_sym_switch] = ACTIONS(3154),
    [anon_sym_case] = ACTIONS(3154),
    [anon_sym_default] = ACTIONS(3154),
    [anon_sym_while] = ACTIONS(3154),
    [anon_sym_do] = ACTIONS(3154),
    [anon_sym_for] = ACTIONS(3154),
    [anon_sym_return] = ACTIONS(3154),
    [anon_sym_break] = ACTIONS(3154),
    [anon_sym_continue] = ACTIONS(3154),
    [anon_sym_goto] = ACTIONS(3154),
    [anon_sym_not] = ACTIONS(3154),
    [anon_sym_compl] = ACTIONS(3154),
    [anon_sym_DASH_DASH] = ACTIONS(3156),
    [anon_sym_PLUS_PLUS] = ACTIONS(3156),
    [anon_sym_sizeof] = ACTIONS(3154),
    [anon_sym___alignof__] = ACTIONS(3154),
    [anon_sym___alignof] = ACTIONS(3154),
    [anon_sym__alignof] = ACTIONS(3154),
    [anon_sym_alignof] = ACTIONS(3154),
    [anon_sym__Alignof] = ACTIONS(3154),
    [anon_sym_offsetof] = ACTIONS(3154),
    [anon_sym__Generic] = ACTIONS(3154),
    [anon_sym_asm] = ACTIONS(3154),
    [anon_sym___asm__] = ACTIONS(3154),
    [anon_sym___asm] = ACTIONS(3154),
    [sym_number_literal] = ACTIONS(3156),
    [anon_sym_L_SQUOTE] = ACTIONS(3156),
    [anon_sym_u_SQUOTE] = ACTIONS(3156),
    [anon_sym_U_SQUOTE] = ACTIONS(3156),
    [anon_sym_u8_SQUOTE] = ACTIONS(3156),
    [anon_sym_SQUOTE] = ACTIONS(3156),
    [anon_sym_L_DQUOTE] = ACTIONS(3156),
    [anon_sym_u_DQUOTE] = ACTIONS(3156),
    [anon_sym_U_DQUOTE] = ACTIONS(3156),
    [anon_sym_u8_DQUOTE] = ACTIONS(3156),
    [anon_sym_DQUOTE] = ACTIONS(3156),
    [sym_true] = ACTIONS(3154),
    [sym_false] = ACTIONS(3154),
    [anon_sym_NULL] = ACTIONS(3154),
    [anon_sym_nullptr] = ACTIONS(3154),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3154),
    [anon_sym_decltype] = ACTIONS(3154),
    [anon_sym_explicit] = ACTIONS(3154),
    [anon_sym_typename] = ACTIONS(3154),
    [anon_sym_template] = ACTIONS(3154),
    [anon_sym_operator] = ACTIONS(3154),
    [anon_sym_try] = ACTIONS(3154),
    [anon_sym_delete] = ACTIONS(3154),
    [anon_sym_throw] = ACTIONS(3154),
    [anon_sym_namespace] = ACTIONS(3154),
    [anon_sym_using] = ACTIONS(3154),
    [anon_sym_static_assert] = ACTIONS(3154),
    [anon_sym_concept] = ACTIONS(3154),
    [anon_sym_co_return] = ACTIONS(3154),
    [anon_sym_co_yield] = ACTIONS(3154),
    [anon_sym_R_DQUOTE] = ACTIONS(3156),
    [anon_sym_LR_DQUOTE] = ACTIONS(3156),
    [anon_sym_uR_DQUOTE] = ACTIONS(3156),
    [anon_sym_UR_DQUOTE] = ACTIONS(3156),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3156),
    [anon_sym_co_await] = ACTIONS(3154),
    [anon_sym_new] = ACTIONS(3154),
    [anon_sym_requires] = ACTIONS(3154),
    [sym_this] = ACTIONS(3154),
  },
  [722] = {
    [ts_builtin_sym_end] = ACTIONS(3148),
    [sym_identifier] = ACTIONS(3146),
    [aux_sym_preproc_include_token1] = ACTIONS(3146),
    [aux_sym_preproc_def_token1] = ACTIONS(3146),
    [aux_sym_preproc_if_token1] = ACTIONS(3146),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3146),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3146),
    [sym_preproc_directive] = ACTIONS(3146),
    [anon_sym_LPAREN2] = ACTIONS(3148),
    [anon_sym_BANG] = ACTIONS(3148),
    [anon_sym_TILDE] = ACTIONS(3148),
    [anon_sym_DASH] = ACTIONS(3146),
    [anon_sym_PLUS] = ACTIONS(3146),
    [anon_sym_STAR] = ACTIONS(3148),
    [anon_sym_AMP_AMP] = ACTIONS(3148),
    [anon_sym_AMP] = ACTIONS(3146),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym___extension__] = ACTIONS(3146),
    [anon_sym_typedef] = ACTIONS(3146),
    [anon_sym_virtual] = ACTIONS(3146),
    [anon_sym_extern] = ACTIONS(3146),
    [anon_sym___attribute__] = ACTIONS(3146),
    [anon_sym___attribute] = ACTIONS(3146),
    [anon_sym_COLON_COLON] = ACTIONS(3148),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3148),
    [anon_sym___declspec] = ACTIONS(3146),
    [anon_sym___based] = ACTIONS(3146),
    [anon_sym___cdecl] = ACTIONS(3146),
    [anon_sym___clrcall] = ACTIONS(3146),
    [anon_sym___stdcall] = ACTIONS(3146),
    [anon_sym___fastcall] = ACTIONS(3146),
    [anon_sym___thiscall] = ACTIONS(3146),
    [anon_sym___vectorcall] = ACTIONS(3146),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_signed] = ACTIONS(3146),
    [anon_sym_unsigned] = ACTIONS(3146),
    [anon_sym_long] = ACTIONS(3146),
    [anon_sym_short] = ACTIONS(3146),
    [anon_sym_LBRACK] = ACTIONS(3146),
    [anon_sym_static] = ACTIONS(3146),
    [anon_sym_register] = ACTIONS(3146),
    [anon_sym_inline] = ACTIONS(3146),
    [anon_sym___inline] = ACTIONS(3146),
    [anon_sym___inline__] = ACTIONS(3146),
    [anon_sym___forceinline] = ACTIONS(3146),
    [anon_sym_thread_local] = ACTIONS(3146),
    [anon_sym___thread] = ACTIONS(3146),
    [anon_sym_const] = ACTIONS(3146),
    [anon_sym_constexpr] = ACTIONS(3146),
    [anon_sym_volatile] = ACTIONS(3146),
    [anon_sym_restrict] = ACTIONS(3146),
    [anon_sym___restrict__] = ACTIONS(3146),
    [anon_sym__Atomic] = ACTIONS(3146),
    [anon_sym__Noreturn] = ACTIONS(3146),
    [anon_sym_noreturn] = ACTIONS(3146),
    [anon_sym__Nonnull] = ACTIONS(3146),
    [anon_sym_mutable] = ACTIONS(3146),
    [anon_sym_constinit] = ACTIONS(3146),
    [anon_sym_consteval] = ACTIONS(3146),
    [anon_sym_alignas] = ACTIONS(3146),
    [anon_sym__Alignas] = ACTIONS(3146),
    [sym_primitive_type] = ACTIONS(3146),
    [anon_sym_enum] = ACTIONS(3146),
    [anon_sym_class] = ACTIONS(3146),
    [anon_sym_struct] = ACTIONS(3146),
    [anon_sym_union] = ACTIONS(3146),
    [anon_sym_if] = ACTIONS(3146),
    [anon_sym_switch] = ACTIONS(3146),
    [anon_sym_case] = ACTIONS(3146),
    [anon_sym_default] = ACTIONS(3146),
    [anon_sym_while] = ACTIONS(3146),
    [anon_sym_do] = ACTIONS(3146),
    [anon_sym_for] = ACTIONS(3146),
    [anon_sym_return] = ACTIONS(3146),
    [anon_sym_break] = ACTIONS(3146),
    [anon_sym_continue] = ACTIONS(3146),
    [anon_sym_goto] = ACTIONS(3146),
    [anon_sym_not] = ACTIONS(3146),
    [anon_sym_compl] = ACTIONS(3146),
    [anon_sym_DASH_DASH] = ACTIONS(3148),
    [anon_sym_PLUS_PLUS] = ACTIONS(3148),
    [anon_sym_sizeof] = ACTIONS(3146),
    [anon_sym___alignof__] = ACTIONS(3146),
    [anon_sym___alignof] = ACTIONS(3146),
    [anon_sym__alignof] = ACTIONS(3146),
    [anon_sym_alignof] = ACTIONS(3146),
    [anon_sym__Alignof] = ACTIONS(3146),
    [anon_sym_offsetof] = ACTIONS(3146),
    [anon_sym__Generic] = ACTIONS(3146),
    [anon_sym_asm] = ACTIONS(3146),
    [anon_sym___asm__] = ACTIONS(3146),
    [anon_sym___asm] = ACTIONS(3146),
    [sym_number_literal] = ACTIONS(3148),
    [anon_sym_L_SQUOTE] = ACTIONS(3148),
    [anon_sym_u_SQUOTE] = ACTIONS(3148),
    [anon_sym_U_SQUOTE] = ACTIONS(3148),
    [anon_sym_u8_SQUOTE] = ACTIONS(3148),
    [anon_sym_SQUOTE] = ACTIONS(3148),
    [anon_sym_L_DQUOTE] = ACTIONS(3148),
    [anon_sym_u_DQUOTE] = ACTIONS(3148),
    [anon_sym_U_DQUOTE] = ACTIONS(3148),
    [anon_sym_u8_DQUOTE] = ACTIONS(3148),
    [anon_sym_DQUOTE] = ACTIONS(3148),
    [sym_true] = ACTIONS(3146),
    [sym_false] = ACTIONS(3146),
    [anon_sym_NULL] = ACTIONS(3146),
    [anon_sym_nullptr] = ACTIONS(3146),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3146),
    [anon_sym_decltype] = ACTIONS(3146),
    [anon_sym_explicit] = ACTIONS(3146),
    [anon_sym_typename] = ACTIONS(3146),
    [anon_sym_template] = ACTIONS(3146),
    [anon_sym_operator] = ACTIONS(3146),
    [anon_sym_try] = ACTIONS(3146),
    [anon_sym_delete] = ACTIONS(3146),
    [anon_sym_throw] = ACTIONS(3146),
    [anon_sym_namespace] = ACTIONS(3146),
    [anon_sym_using] = ACTIONS(3146),
    [anon_sym_static_assert] = ACTIONS(3146),
    [anon_sym_concept] = ACTIONS(3146),
    [anon_sym_co_return] = ACTIONS(3146),
    [anon_sym_co_yield] = ACTIONS(3146),
    [anon_sym_R_DQUOTE] = ACTIONS(3148),
    [anon_sym_LR_DQUOTE] = ACTIONS(3148),
    [anon_sym_uR_DQUOTE] = ACTIONS(3148),
    [anon_sym_UR_DQUOTE] = ACTIONS(3148),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3148),
    [anon_sym_co_await] = ACTIONS(3146),
    [anon_sym_new] = ACTIONS(3146),
    [anon_sym_requires] = ACTIONS(3146),
    [sym_this] = ACTIONS(3146),
  },
  [723] = {
    [ts_builtin_sym_end] = ACTIONS(3160),
    [sym_identifier] = ACTIONS(3158),
    [aux_sym_preproc_include_token1] = ACTIONS(3158),
    [aux_sym_preproc_def_token1] = ACTIONS(3158),
    [aux_sym_preproc_if_token1] = ACTIONS(3158),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3158),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3158),
    [sym_preproc_directive] = ACTIONS(3158),
    [anon_sym_LPAREN2] = ACTIONS(3160),
    [anon_sym_BANG] = ACTIONS(3160),
    [anon_sym_TILDE] = ACTIONS(3160),
    [anon_sym_DASH] = ACTIONS(3158),
    [anon_sym_PLUS] = ACTIONS(3158),
    [anon_sym_STAR] = ACTIONS(3160),
    [anon_sym_AMP_AMP] = ACTIONS(3160),
    [anon_sym_AMP] = ACTIONS(3158),
    [anon_sym_SEMI] = ACTIONS(3160),
    [anon_sym___extension__] = ACTIONS(3158),
    [anon_sym_typedef] = ACTIONS(3158),
    [anon_sym_virtual] = ACTIONS(3158),
    [anon_sym_extern] = ACTIONS(3158),
    [anon_sym___attribute__] = ACTIONS(3158),
    [anon_sym___attribute] = ACTIONS(3158),
    [anon_sym_COLON_COLON] = ACTIONS(3160),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3160),
    [anon_sym___declspec] = ACTIONS(3158),
    [anon_sym___based] = ACTIONS(3158),
    [anon_sym___cdecl] = ACTIONS(3158),
    [anon_sym___clrcall] = ACTIONS(3158),
    [anon_sym___stdcall] = ACTIONS(3158),
    [anon_sym___fastcall] = ACTIONS(3158),
    [anon_sym___thiscall] = ACTIONS(3158),
    [anon_sym___vectorcall] = ACTIONS(3158),
    [anon_sym_LBRACE] = ACTIONS(3160),
    [anon_sym_signed] = ACTIONS(3158),
    [anon_sym_unsigned] = ACTIONS(3158),
    [anon_sym_long] = ACTIONS(3158),
    [anon_sym_short] = ACTIONS(3158),
    [anon_sym_LBRACK] = ACTIONS(3158),
    [anon_sym_static] = ACTIONS(3158),
    [anon_sym_register] = ACTIONS(3158),
    [anon_sym_inline] = ACTIONS(3158),
    [anon_sym___inline] = ACTIONS(3158),
    [anon_sym___inline__] = ACTIONS(3158),
    [anon_sym___forceinline] = ACTIONS(3158),
    [anon_sym_thread_local] = ACTIONS(3158),
    [anon_sym___thread] = ACTIONS(3158),
    [anon_sym_const] = ACTIONS(3158),
    [anon_sym_constexpr] = ACTIONS(3158),
    [anon_sym_volatile] = ACTIONS(3158),
    [anon_sym_restrict] = ACTIONS(3158),
    [anon_sym___restrict__] = ACTIONS(3158),
    [anon_sym__Atomic] = ACTIONS(3158),
    [anon_sym__Noreturn] = ACTIONS(3158),
    [anon_sym_noreturn] = ACTIONS(3158),
    [anon_sym__Nonnull] = ACTIONS(3158),
    [anon_sym_mutable] = ACTIONS(3158),
    [anon_sym_constinit] = ACTIONS(3158),
    [anon_sym_consteval] = ACTIONS(3158),
    [anon_sym_alignas] = ACTIONS(3158),
    [anon_sym__Alignas] = ACTIONS(3158),
    [sym_primitive_type] = ACTIONS(3158),
    [anon_sym_enum] = ACTIONS(3158),
    [anon_sym_class] = ACTIONS(3158),
    [anon_sym_struct] = ACTIONS(3158),
    [anon_sym_union] = ACTIONS(3158),
    [anon_sym_if] = ACTIONS(3158),
    [anon_sym_switch] = ACTIONS(3158),
    [anon_sym_case] = ACTIONS(3158),
    [anon_sym_default] = ACTIONS(3158),
    [anon_sym_while] = ACTIONS(3158),
    [anon_sym_do] = ACTIONS(3158),
    [anon_sym_for] = ACTIONS(3158),
    [anon_sym_return] = ACTIONS(3158),
    [anon_sym_break] = ACTIONS(3158),
    [anon_sym_continue] = ACTIONS(3158),
    [anon_sym_goto] = ACTIONS(3158),
    [anon_sym_not] = ACTIONS(3158),
    [anon_sym_compl] = ACTIONS(3158),
    [anon_sym_DASH_DASH] = ACTIONS(3160),
    [anon_sym_PLUS_PLUS] = ACTIONS(3160),
    [anon_sym_sizeof] = ACTIONS(3158),
    [anon_sym___alignof__] = ACTIONS(3158),
    [anon_sym___alignof] = ACTIONS(3158),
    [anon_sym__alignof] = ACTIONS(3158),
    [anon_sym_alignof] = ACTIONS(3158),
    [anon_sym__Alignof] = ACTIONS(3158),
    [anon_sym_offsetof] = ACTIONS(3158),
    [anon_sym__Generic] = ACTIONS(3158),
    [anon_sym_asm] = ACTIONS(3158),
    [anon_sym___asm__] = ACTIONS(3158),
    [anon_sym___asm] = ACTIONS(3158),
    [sym_number_literal] = ACTIONS(3160),
    [anon_sym_L_SQUOTE] = ACTIONS(3160),
    [anon_sym_u_SQUOTE] = ACTIONS(3160),
    [anon_sym_U_SQUOTE] = ACTIONS(3160),
    [anon_sym_u8_SQUOTE] = ACTIONS(3160),
    [anon_sym_SQUOTE] = ACTIONS(3160),
    [anon_sym_L_DQUOTE] = ACTIONS(3160),
    [anon_sym_u_DQUOTE] = ACTIONS(3160),
    [anon_sym_U_DQUOTE] = ACTIONS(3160),
    [anon_sym_u8_DQUOTE] = ACTIONS(3160),
    [anon_sym_DQUOTE] = ACTIONS(3160),
    [sym_true] = ACTIONS(3158),
    [sym_false] = ACTIONS(3158),
    [anon_sym_NULL] = ACTIONS(3158),
    [anon_sym_nullptr] = ACTIONS(3158),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3158),
    [anon_sym_decltype] = ACTIONS(3158),
    [anon_sym_explicit] = ACTIONS(3158),
    [anon_sym_typename] = ACTIONS(3158),
    [anon_sym_template] = ACTIONS(3158),
    [anon_sym_operator] = ACTIONS(3158),
    [anon_sym_try] = ACTIONS(3158),
    [anon_sym_delete] = ACTIONS(3158),
    [anon_sym_throw] = ACTIONS(3158),
    [anon_sym_namespace] = ACTIONS(3158),
    [anon_sym_using] = ACTIONS(3158),
    [anon_sym_static_assert] = ACTIONS(3158),
    [anon_sym_concept] = ACTIONS(3158),
    [anon_sym_co_return] = ACTIONS(3158),
    [anon_sym_co_yield] = ACTIONS(3158),
    [anon_sym_R_DQUOTE] = ACTIONS(3160),
    [anon_sym_LR_DQUOTE] = ACTIONS(3160),
    [anon_sym_uR_DQUOTE] = ACTIONS(3160),
    [anon_sym_UR_DQUOTE] = ACTIONS(3160),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3160),
    [anon_sym_co_await] = ACTIONS(3158),
    [anon_sym_new] = ACTIONS(3158),
    [anon_sym_requires] = ACTIONS(3158),
    [sym_this] = ACTIONS(3158),
  },
  [724] = {
    [ts_builtin_sym_end] = ACTIONS(2745),
    [sym_identifier] = ACTIONS(2743),
    [aux_sym_preproc_include_token1] = ACTIONS(2743),
    [aux_sym_preproc_def_token1] = ACTIONS(2743),
    [aux_sym_preproc_if_token1] = ACTIONS(2743),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2743),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2743),
    [sym_preproc_directive] = ACTIONS(2743),
    [anon_sym_LPAREN2] = ACTIONS(2745),
    [anon_sym_BANG] = ACTIONS(2745),
    [anon_sym_TILDE] = ACTIONS(2745),
    [anon_sym_DASH] = ACTIONS(2743),
    [anon_sym_PLUS] = ACTIONS(2743),
    [anon_sym_STAR] = ACTIONS(2745),
    [anon_sym_AMP_AMP] = ACTIONS(2745),
    [anon_sym_AMP] = ACTIONS(2743),
    [anon_sym_SEMI] = ACTIONS(2745),
    [anon_sym___extension__] = ACTIONS(2743),
    [anon_sym_typedef] = ACTIONS(2743),
    [anon_sym_virtual] = ACTIONS(2743),
    [anon_sym_extern] = ACTIONS(2743),
    [anon_sym___attribute__] = ACTIONS(2743),
    [anon_sym___attribute] = ACTIONS(2743),
    [anon_sym_COLON_COLON] = ACTIONS(2745),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2745),
    [anon_sym___declspec] = ACTIONS(2743),
    [anon_sym___based] = ACTIONS(2743),
    [anon_sym___cdecl] = ACTIONS(2743),
    [anon_sym___clrcall] = ACTIONS(2743),
    [anon_sym___stdcall] = ACTIONS(2743),
    [anon_sym___fastcall] = ACTIONS(2743),
    [anon_sym___thiscall] = ACTIONS(2743),
    [anon_sym___vectorcall] = ACTIONS(2743),
    [anon_sym_LBRACE] = ACTIONS(2745),
    [anon_sym_signed] = ACTIONS(2743),
    [anon_sym_unsigned] = ACTIONS(2743),
    [anon_sym_long] = ACTIONS(2743),
    [anon_sym_short] = ACTIONS(2743),
    [anon_sym_LBRACK] = ACTIONS(2743),
    [anon_sym_static] = ACTIONS(2743),
    [anon_sym_register] = ACTIONS(2743),
    [anon_sym_inline] = ACTIONS(2743),
    [anon_sym___inline] = ACTIONS(2743),
    [anon_sym___inline__] = ACTIONS(2743),
    [anon_sym___forceinline] = ACTIONS(2743),
    [anon_sym_thread_local] = ACTIONS(2743),
    [anon_sym___thread] = ACTIONS(2743),
    [anon_sym_const] = ACTIONS(2743),
    [anon_sym_constexpr] = ACTIONS(2743),
    [anon_sym_volatile] = ACTIONS(2743),
    [anon_sym_restrict] = ACTIONS(2743),
    [anon_sym___restrict__] = ACTIONS(2743),
    [anon_sym__Atomic] = ACTIONS(2743),
    [anon_sym__Noreturn] = ACTIONS(2743),
    [anon_sym_noreturn] = ACTIONS(2743),
    [anon_sym__Nonnull] = ACTIONS(2743),
    [anon_sym_mutable] = ACTIONS(2743),
    [anon_sym_constinit] = ACTIONS(2743),
    [anon_sym_consteval] = ACTIONS(2743),
    [anon_sym_alignas] = ACTIONS(2743),
    [anon_sym__Alignas] = ACTIONS(2743),
    [sym_primitive_type] = ACTIONS(2743),
    [anon_sym_enum] = ACTIONS(2743),
    [anon_sym_class] = ACTIONS(2743),
    [anon_sym_struct] = ACTIONS(2743),
    [anon_sym_union] = ACTIONS(2743),
    [anon_sym_if] = ACTIONS(2743),
    [anon_sym_switch] = ACTIONS(2743),
    [anon_sym_case] = ACTIONS(2743),
    [anon_sym_default] = ACTIONS(2743),
    [anon_sym_while] = ACTIONS(2743),
    [anon_sym_do] = ACTIONS(2743),
    [anon_sym_for] = ACTIONS(2743),
    [anon_sym_return] = ACTIONS(2743),
    [anon_sym_break] = ACTIONS(2743),
    [anon_sym_continue] = ACTIONS(2743),
    [anon_sym_goto] = ACTIONS(2743),
    [anon_sym_not] = ACTIONS(2743),
    [anon_sym_compl] = ACTIONS(2743),
    [anon_sym_DASH_DASH] = ACTIONS(2745),
    [anon_sym_PLUS_PLUS] = ACTIONS(2745),
    [anon_sym_sizeof] = ACTIONS(2743),
    [anon_sym___alignof__] = ACTIONS(2743),
    [anon_sym___alignof] = ACTIONS(2743),
    [anon_sym__alignof] = ACTIONS(2743),
    [anon_sym_alignof] = ACTIONS(2743),
    [anon_sym__Alignof] = ACTIONS(2743),
    [anon_sym_offsetof] = ACTIONS(2743),
    [anon_sym__Generic] = ACTIONS(2743),
    [anon_sym_asm] = ACTIONS(2743),
    [anon_sym___asm__] = ACTIONS(2743),
    [anon_sym___asm] = ACTIONS(2743),
    [sym_number_literal] = ACTIONS(2745),
    [anon_sym_L_SQUOTE] = ACTIONS(2745),
    [anon_sym_u_SQUOTE] = ACTIONS(2745),
    [anon_sym_U_SQUOTE] = ACTIONS(2745),
    [anon_sym_u8_SQUOTE] = ACTIONS(2745),
    [anon_sym_SQUOTE] = ACTIONS(2745),
    [anon_sym_L_DQUOTE] = ACTIONS(2745),
    [anon_sym_u_DQUOTE] = ACTIONS(2745),
    [anon_sym_U_DQUOTE] = ACTIONS(2745),
    [anon_sym_u8_DQUOTE] = ACTIONS(2745),
    [anon_sym_DQUOTE] = ACTIONS(2745),
    [sym_true] = ACTIONS(2743),
    [sym_false] = ACTIONS(2743),
    [anon_sym_NULL] = ACTIONS(2743),
    [anon_sym_nullptr] = ACTIONS(2743),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2743),
    [anon_sym_decltype] = ACTIONS(2743),
    [anon_sym_explicit] = ACTIONS(2743),
    [anon_sym_typename] = ACTIONS(2743),
    [anon_sym_template] = ACTIONS(2743),
    [anon_sym_operator] = ACTIONS(2743),
    [anon_sym_try] = ACTIONS(2743),
    [anon_sym_delete] = ACTIONS(2743),
    [anon_sym_throw] = ACTIONS(2743),
    [anon_sym_namespace] = ACTIONS(2743),
    [anon_sym_using] = ACTIONS(2743),
    [anon_sym_static_assert] = ACTIONS(2743),
    [anon_sym_concept] = ACTIONS(2743),
    [anon_sym_co_return] = ACTIONS(2743),
    [anon_sym_co_yield] = ACTIONS(2743),
    [anon_sym_R_DQUOTE] = ACTIONS(2745),
    [anon_sym_LR_DQUOTE] = ACTIONS(2745),
    [anon_sym_uR_DQUOTE] = ACTIONS(2745),
    [anon_sym_UR_DQUOTE] = ACTIONS(2745),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2745),
    [anon_sym_co_await] = ACTIONS(2743),
    [anon_sym_new] = ACTIONS(2743),
    [anon_sym_requires] = ACTIONS(2743),
    [sym_this] = ACTIONS(2743),
  },
  [725] = {
    [ts_builtin_sym_end] = ACTIONS(2753),
    [sym_identifier] = ACTIONS(2751),
    [aux_sym_preproc_include_token1] = ACTIONS(2751),
    [aux_sym_preproc_def_token1] = ACTIONS(2751),
    [aux_sym_preproc_if_token1] = ACTIONS(2751),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2751),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2751),
    [sym_preproc_directive] = ACTIONS(2751),
    [anon_sym_LPAREN2] = ACTIONS(2753),
    [anon_sym_BANG] = ACTIONS(2753),
    [anon_sym_TILDE] = ACTIONS(2753),
    [anon_sym_DASH] = ACTIONS(2751),
    [anon_sym_PLUS] = ACTIONS(2751),
    [anon_sym_STAR] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2751),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym___extension__] = ACTIONS(2751),
    [anon_sym_typedef] = ACTIONS(2751),
    [anon_sym_virtual] = ACTIONS(2751),
    [anon_sym_extern] = ACTIONS(2751),
    [anon_sym___attribute__] = ACTIONS(2751),
    [anon_sym___attribute] = ACTIONS(2751),
    [anon_sym_COLON_COLON] = ACTIONS(2753),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2753),
    [anon_sym___declspec] = ACTIONS(2751),
    [anon_sym___based] = ACTIONS(2751),
    [anon_sym___cdecl] = ACTIONS(2751),
    [anon_sym___clrcall] = ACTIONS(2751),
    [anon_sym___stdcall] = ACTIONS(2751),
    [anon_sym___fastcall] = ACTIONS(2751),
    [anon_sym___thiscall] = ACTIONS(2751),
    [anon_sym___vectorcall] = ACTIONS(2751),
    [anon_sym_LBRACE] = ACTIONS(2753),
    [anon_sym_signed] = ACTIONS(2751),
    [anon_sym_unsigned] = ACTIONS(2751),
    [anon_sym_long] = ACTIONS(2751),
    [anon_sym_short] = ACTIONS(2751),
    [anon_sym_LBRACK] = ACTIONS(2751),
    [anon_sym_static] = ACTIONS(2751),
    [anon_sym_register] = ACTIONS(2751),
    [anon_sym_inline] = ACTIONS(2751),
    [anon_sym___inline] = ACTIONS(2751),
    [anon_sym___inline__] = ACTIONS(2751),
    [anon_sym___forceinline] = ACTIONS(2751),
    [anon_sym_thread_local] = ACTIONS(2751),
    [anon_sym___thread] = ACTIONS(2751),
    [anon_sym_const] = ACTIONS(2751),
    [anon_sym_constexpr] = ACTIONS(2751),
    [anon_sym_volatile] = ACTIONS(2751),
    [anon_sym_restrict] = ACTIONS(2751),
    [anon_sym___restrict__] = ACTIONS(2751),
    [anon_sym__Atomic] = ACTIONS(2751),
    [anon_sym__Noreturn] = ACTIONS(2751),
    [anon_sym_noreturn] = ACTIONS(2751),
    [anon_sym__Nonnull] = ACTIONS(2751),
    [anon_sym_mutable] = ACTIONS(2751),
    [anon_sym_constinit] = ACTIONS(2751),
    [anon_sym_consteval] = ACTIONS(2751),
    [anon_sym_alignas] = ACTIONS(2751),
    [anon_sym__Alignas] = ACTIONS(2751),
    [sym_primitive_type] = ACTIONS(2751),
    [anon_sym_enum] = ACTIONS(2751),
    [anon_sym_class] = ACTIONS(2751),
    [anon_sym_struct] = ACTIONS(2751),
    [anon_sym_union] = ACTIONS(2751),
    [anon_sym_if] = ACTIONS(2751),
    [anon_sym_switch] = ACTIONS(2751),
    [anon_sym_case] = ACTIONS(2751),
    [anon_sym_default] = ACTIONS(2751),
    [anon_sym_while] = ACTIONS(2751),
    [anon_sym_do] = ACTIONS(2751),
    [anon_sym_for] = ACTIONS(2751),
    [anon_sym_return] = ACTIONS(2751),
    [anon_sym_break] = ACTIONS(2751),
    [anon_sym_continue] = ACTIONS(2751),
    [anon_sym_goto] = ACTIONS(2751),
    [anon_sym_not] = ACTIONS(2751),
    [anon_sym_compl] = ACTIONS(2751),
    [anon_sym_DASH_DASH] = ACTIONS(2753),
    [anon_sym_PLUS_PLUS] = ACTIONS(2753),
    [anon_sym_sizeof] = ACTIONS(2751),
    [anon_sym___alignof__] = ACTIONS(2751),
    [anon_sym___alignof] = ACTIONS(2751),
    [anon_sym__alignof] = ACTIONS(2751),
    [anon_sym_alignof] = ACTIONS(2751),
    [anon_sym__Alignof] = ACTIONS(2751),
    [anon_sym_offsetof] = ACTIONS(2751),
    [anon_sym__Generic] = ACTIONS(2751),
    [anon_sym_asm] = ACTIONS(2751),
    [anon_sym___asm__] = ACTIONS(2751),
    [anon_sym___asm] = ACTIONS(2751),
    [sym_number_literal] = ACTIONS(2753),
    [anon_sym_L_SQUOTE] = ACTIONS(2753),
    [anon_sym_u_SQUOTE] = ACTIONS(2753),
    [anon_sym_U_SQUOTE] = ACTIONS(2753),
    [anon_sym_u8_SQUOTE] = ACTIONS(2753),
    [anon_sym_SQUOTE] = ACTIONS(2753),
    [anon_sym_L_DQUOTE] = ACTIONS(2753),
    [anon_sym_u_DQUOTE] = ACTIONS(2753),
    [anon_sym_U_DQUOTE] = ACTIONS(2753),
    [anon_sym_u8_DQUOTE] = ACTIONS(2753),
    [anon_sym_DQUOTE] = ACTIONS(2753),
    [sym_true] = ACTIONS(2751),
    [sym_false] = ACTIONS(2751),
    [anon_sym_NULL] = ACTIONS(2751),
    [anon_sym_nullptr] = ACTIONS(2751),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2751),
    [anon_sym_decltype] = ACTIONS(2751),
    [anon_sym_explicit] = ACTIONS(2751),
    [anon_sym_typename] = ACTIONS(2751),
    [anon_sym_template] = ACTIONS(2751),
    [anon_sym_operator] = ACTIONS(2751),
    [anon_sym_try] = ACTIONS(2751),
    [anon_sym_delete] = ACTIONS(2751),
    [anon_sym_throw] = ACTIONS(2751),
    [anon_sym_namespace] = ACTIONS(2751),
    [anon_sym_using] = ACTIONS(2751),
    [anon_sym_static_assert] = ACTIONS(2751),
    [anon_sym_concept] = ACTIONS(2751),
    [anon_sym_co_return] = ACTIONS(2751),
    [anon_sym_co_yield] = ACTIONS(2751),
    [anon_sym_R_DQUOTE] = ACTIONS(2753),
    [anon_sym_LR_DQUOTE] = ACTIONS(2753),
    [anon_sym_uR_DQUOTE] = ACTIONS(2753),
    [anon_sym_UR_DQUOTE] = ACTIONS(2753),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2753),
    [anon_sym_co_await] = ACTIONS(2751),
    [anon_sym_new] = ACTIONS(2751),
    [anon_sym_requires] = ACTIONS(2751),
    [sym_this] = ACTIONS(2751),
  },
  [726] = {
    [ts_builtin_sym_end] = ACTIONS(3152),
    [sym_identifier] = ACTIONS(3150),
    [aux_sym_preproc_include_token1] = ACTIONS(3150),
    [aux_sym_preproc_def_token1] = ACTIONS(3150),
    [aux_sym_preproc_if_token1] = ACTIONS(3150),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3150),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3150),
    [sym_preproc_directive] = ACTIONS(3150),
    [anon_sym_LPAREN2] = ACTIONS(3152),
    [anon_sym_BANG] = ACTIONS(3152),
    [anon_sym_TILDE] = ACTIONS(3152),
    [anon_sym_DASH] = ACTIONS(3150),
    [anon_sym_PLUS] = ACTIONS(3150),
    [anon_sym_STAR] = ACTIONS(3152),
    [anon_sym_AMP_AMP] = ACTIONS(3152),
    [anon_sym_AMP] = ACTIONS(3150),
    [anon_sym_SEMI] = ACTIONS(3152),
    [anon_sym___extension__] = ACTIONS(3150),
    [anon_sym_typedef] = ACTIONS(3150),
    [anon_sym_virtual] = ACTIONS(3150),
    [anon_sym_extern] = ACTIONS(3150),
    [anon_sym___attribute__] = ACTIONS(3150),
    [anon_sym___attribute] = ACTIONS(3150),
    [anon_sym_COLON_COLON] = ACTIONS(3152),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3152),
    [anon_sym___declspec] = ACTIONS(3150),
    [anon_sym___based] = ACTIONS(3150),
    [anon_sym___cdecl] = ACTIONS(3150),
    [anon_sym___clrcall] = ACTIONS(3150),
    [anon_sym___stdcall] = ACTIONS(3150),
    [anon_sym___fastcall] = ACTIONS(3150),
    [anon_sym___thiscall] = ACTIONS(3150),
    [anon_sym___vectorcall] = ACTIONS(3150),
    [anon_sym_LBRACE] = ACTIONS(3152),
    [anon_sym_signed] = ACTIONS(3150),
    [anon_sym_unsigned] = ACTIONS(3150),
    [anon_sym_long] = ACTIONS(3150),
    [anon_sym_short] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(3150),
    [anon_sym_static] = ACTIONS(3150),
    [anon_sym_register] = ACTIONS(3150),
    [anon_sym_inline] = ACTIONS(3150),
    [anon_sym___inline] = ACTIONS(3150),
    [anon_sym___inline__] = ACTIONS(3150),
    [anon_sym___forceinline] = ACTIONS(3150),
    [anon_sym_thread_local] = ACTIONS(3150),
    [anon_sym___thread] = ACTIONS(3150),
    [anon_sym_const] = ACTIONS(3150),
    [anon_sym_constexpr] = ACTIONS(3150),
    [anon_sym_volatile] = ACTIONS(3150),
    [anon_sym_restrict] = ACTIONS(3150),
    [anon_sym___restrict__] = ACTIONS(3150),
    [anon_sym__Atomic] = ACTIONS(3150),
    [anon_sym__Noreturn] = ACTIONS(3150),
    [anon_sym_noreturn] = ACTIONS(3150),
    [anon_sym__Nonnull] = ACTIONS(3150),
    [anon_sym_mutable] = ACTIONS(3150),
    [anon_sym_constinit] = ACTIONS(3150),
    [anon_sym_consteval] = ACTIONS(3150),
    [anon_sym_alignas] = ACTIONS(3150),
    [anon_sym__Alignas] = ACTIONS(3150),
    [sym_primitive_type] = ACTIONS(3150),
    [anon_sym_enum] = ACTIONS(3150),
    [anon_sym_class] = ACTIONS(3150),
    [anon_sym_struct] = ACTIONS(3150),
    [anon_sym_union] = ACTIONS(3150),
    [anon_sym_if] = ACTIONS(3150),
    [anon_sym_switch] = ACTIONS(3150),
    [anon_sym_case] = ACTIONS(3150),
    [anon_sym_default] = ACTIONS(3150),
    [anon_sym_while] = ACTIONS(3150),
    [anon_sym_do] = ACTIONS(3150),
    [anon_sym_for] = ACTIONS(3150),
    [anon_sym_return] = ACTIONS(3150),
    [anon_sym_break] = ACTIONS(3150),
    [anon_sym_continue] = ACTIONS(3150),
    [anon_sym_goto] = ACTIONS(3150),
    [anon_sym_not] = ACTIONS(3150),
    [anon_sym_compl] = ACTIONS(3150),
    [anon_sym_DASH_DASH] = ACTIONS(3152),
    [anon_sym_PLUS_PLUS] = ACTIONS(3152),
    [anon_sym_sizeof] = ACTIONS(3150),
    [anon_sym___alignof__] = ACTIONS(3150),
    [anon_sym___alignof] = ACTIONS(3150),
    [anon_sym__alignof] = ACTIONS(3150),
    [anon_sym_alignof] = ACTIONS(3150),
    [anon_sym__Alignof] = ACTIONS(3150),
    [anon_sym_offsetof] = ACTIONS(3150),
    [anon_sym__Generic] = ACTIONS(3150),
    [anon_sym_asm] = ACTIONS(3150),
    [anon_sym___asm__] = ACTIONS(3150),
    [anon_sym___asm] = ACTIONS(3150),
    [sym_number_literal] = ACTIONS(3152),
    [anon_sym_L_SQUOTE] = ACTIONS(3152),
    [anon_sym_u_SQUOTE] = ACTIONS(3152),
    [anon_sym_U_SQUOTE] = ACTIONS(3152),
    [anon_sym_u8_SQUOTE] = ACTIONS(3152),
    [anon_sym_SQUOTE] = ACTIONS(3152),
    [anon_sym_L_DQUOTE] = ACTIONS(3152),
    [anon_sym_u_DQUOTE] = ACTIONS(3152),
    [anon_sym_U_DQUOTE] = ACTIONS(3152),
    [anon_sym_u8_DQUOTE] = ACTIONS(3152),
    [anon_sym_DQUOTE] = ACTIONS(3152),
    [sym_true] = ACTIONS(3150),
    [sym_false] = ACTIONS(3150),
    [anon_sym_NULL] = ACTIONS(3150),
    [anon_sym_nullptr] = ACTIONS(3150),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3150),
    [anon_sym_decltype] = ACTIONS(3150),
    [anon_sym_explicit] = ACTIONS(3150),
    [anon_sym_typename] = ACTIONS(3150),
    [anon_sym_template] = ACTIONS(3150),
    [anon_sym_operator] = ACTIONS(3150),
    [anon_sym_try] = ACTIONS(3150),
    [anon_sym_delete] = ACTIONS(3150),
    [anon_sym_throw] = ACTIONS(3150),
    [anon_sym_namespace] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_static_assert] = ACTIONS(3150),
    [anon_sym_concept] = ACTIONS(3150),
    [anon_sym_co_return] = ACTIONS(3150),
    [anon_sym_co_yield] = ACTIONS(3150),
    [anon_sym_R_DQUOTE] = ACTIONS(3152),
    [anon_sym_LR_DQUOTE] = ACTIONS(3152),
    [anon_sym_uR_DQUOTE] = ACTIONS(3152),
    [anon_sym_UR_DQUOTE] = ACTIONS(3152),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3152),
    [anon_sym_co_await] = ACTIONS(3150),
    [anon_sym_new] = ACTIONS(3150),
    [anon_sym_requires] = ACTIONS(3150),
    [sym_this] = ACTIONS(3150),
  },
  [727] = {
    [ts_builtin_sym_end] = ACTIONS(2801),
    [sym_identifier] = ACTIONS(2799),
    [aux_sym_preproc_include_token1] = ACTIONS(2799),
    [aux_sym_preproc_def_token1] = ACTIONS(2799),
    [aux_sym_preproc_if_token1] = ACTIONS(2799),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2799),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2799),
    [sym_preproc_directive] = ACTIONS(2799),
    [anon_sym_LPAREN2] = ACTIONS(2801),
    [anon_sym_BANG] = ACTIONS(2801),
    [anon_sym_TILDE] = ACTIONS(2801),
    [anon_sym_DASH] = ACTIONS(2799),
    [anon_sym_PLUS] = ACTIONS(2799),
    [anon_sym_STAR] = ACTIONS(2801),
    [anon_sym_AMP_AMP] = ACTIONS(2801),
    [anon_sym_AMP] = ACTIONS(2799),
    [anon_sym_SEMI] = ACTIONS(2801),
    [anon_sym___extension__] = ACTIONS(2799),
    [anon_sym_typedef] = ACTIONS(2799),
    [anon_sym_virtual] = ACTIONS(2799),
    [anon_sym_extern] = ACTIONS(2799),
    [anon_sym___attribute__] = ACTIONS(2799),
    [anon_sym___attribute] = ACTIONS(2799),
    [anon_sym_COLON_COLON] = ACTIONS(2801),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2801),
    [anon_sym___declspec] = ACTIONS(2799),
    [anon_sym___based] = ACTIONS(2799),
    [anon_sym___cdecl] = ACTIONS(2799),
    [anon_sym___clrcall] = ACTIONS(2799),
    [anon_sym___stdcall] = ACTIONS(2799),
    [anon_sym___fastcall] = ACTIONS(2799),
    [anon_sym___thiscall] = ACTIONS(2799),
    [anon_sym___vectorcall] = ACTIONS(2799),
    [anon_sym_LBRACE] = ACTIONS(2801),
    [anon_sym_signed] = ACTIONS(2799),
    [anon_sym_unsigned] = ACTIONS(2799),
    [anon_sym_long] = ACTIONS(2799),
    [anon_sym_short] = ACTIONS(2799),
    [anon_sym_LBRACK] = ACTIONS(2799),
    [anon_sym_static] = ACTIONS(2799),
    [anon_sym_register] = ACTIONS(2799),
    [anon_sym_inline] = ACTIONS(2799),
    [anon_sym___inline] = ACTIONS(2799),
    [anon_sym___inline__] = ACTIONS(2799),
    [anon_sym___forceinline] = ACTIONS(2799),
    [anon_sym_thread_local] = ACTIONS(2799),
    [anon_sym___thread] = ACTIONS(2799),
    [anon_sym_const] = ACTIONS(2799),
    [anon_sym_constexpr] = ACTIONS(2799),
    [anon_sym_volatile] = ACTIONS(2799),
    [anon_sym_restrict] = ACTIONS(2799),
    [anon_sym___restrict__] = ACTIONS(2799),
    [anon_sym__Atomic] = ACTIONS(2799),
    [anon_sym__Noreturn] = ACTIONS(2799),
    [anon_sym_noreturn] = ACTIONS(2799),
    [anon_sym__Nonnull] = ACTIONS(2799),
    [anon_sym_mutable] = ACTIONS(2799),
    [anon_sym_constinit] = ACTIONS(2799),
    [anon_sym_consteval] = ACTIONS(2799),
    [anon_sym_alignas] = ACTIONS(2799),
    [anon_sym__Alignas] = ACTIONS(2799),
    [sym_primitive_type] = ACTIONS(2799),
    [anon_sym_enum] = ACTIONS(2799),
    [anon_sym_class] = ACTIONS(2799),
    [anon_sym_struct] = ACTIONS(2799),
    [anon_sym_union] = ACTIONS(2799),
    [anon_sym_if] = ACTIONS(2799),
    [anon_sym_switch] = ACTIONS(2799),
    [anon_sym_case] = ACTIONS(2799),
    [anon_sym_default] = ACTIONS(2799),
    [anon_sym_while] = ACTIONS(2799),
    [anon_sym_do] = ACTIONS(2799),
    [anon_sym_for] = ACTIONS(2799),
    [anon_sym_return] = ACTIONS(2799),
    [anon_sym_break] = ACTIONS(2799),
    [anon_sym_continue] = ACTIONS(2799),
    [anon_sym_goto] = ACTIONS(2799),
    [anon_sym_not] = ACTIONS(2799),
    [anon_sym_compl] = ACTIONS(2799),
    [anon_sym_DASH_DASH] = ACTIONS(2801),
    [anon_sym_PLUS_PLUS] = ACTIONS(2801),
    [anon_sym_sizeof] = ACTIONS(2799),
    [anon_sym___alignof__] = ACTIONS(2799),
    [anon_sym___alignof] = ACTIONS(2799),
    [anon_sym__alignof] = ACTIONS(2799),
    [anon_sym_alignof] = ACTIONS(2799),
    [anon_sym__Alignof] = ACTIONS(2799),
    [anon_sym_offsetof] = ACTIONS(2799),
    [anon_sym__Generic] = ACTIONS(2799),
    [anon_sym_asm] = ACTIONS(2799),
    [anon_sym___asm__] = ACTIONS(2799),
    [anon_sym___asm] = ACTIONS(2799),
    [sym_number_literal] = ACTIONS(2801),
    [anon_sym_L_SQUOTE] = ACTIONS(2801),
    [anon_sym_u_SQUOTE] = ACTIONS(2801),
    [anon_sym_U_SQUOTE] = ACTIONS(2801),
    [anon_sym_u8_SQUOTE] = ACTIONS(2801),
    [anon_sym_SQUOTE] = ACTIONS(2801),
    [anon_sym_L_DQUOTE] = ACTIONS(2801),
    [anon_sym_u_DQUOTE] = ACTIONS(2801),
    [anon_sym_U_DQUOTE] = ACTIONS(2801),
    [anon_sym_u8_DQUOTE] = ACTIONS(2801),
    [anon_sym_DQUOTE] = ACTIONS(2801),
    [sym_true] = ACTIONS(2799),
    [sym_false] = ACTIONS(2799),
    [anon_sym_NULL] = ACTIONS(2799),
    [anon_sym_nullptr] = ACTIONS(2799),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2799),
    [anon_sym_decltype] = ACTIONS(2799),
    [anon_sym_explicit] = ACTIONS(2799),
    [anon_sym_typename] = ACTIONS(2799),
    [anon_sym_template] = ACTIONS(2799),
    [anon_sym_operator] = ACTIONS(2799),
    [anon_sym_try] = ACTIONS(2799),
    [anon_sym_delete] = ACTIONS(2799),
    [anon_sym_throw] = ACTIONS(2799),
    [anon_sym_namespace] = ACTIONS(2799),
    [anon_sym_using] = ACTIONS(2799),
    [anon_sym_static_assert] = ACTIONS(2799),
    [anon_sym_concept] = ACTIONS(2799),
    [anon_sym_co_return] = ACTIONS(2799),
    [anon_sym_co_yield] = ACTIONS(2799),
    [anon_sym_R_DQUOTE] = ACTIONS(2801),
    [anon_sym_LR_DQUOTE] = ACTIONS(2801),
    [anon_sym_uR_DQUOTE] = ACTIONS(2801),
    [anon_sym_UR_DQUOTE] = ACTIONS(2801),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2801),
    [anon_sym_co_await] = ACTIONS(2799),
    [anon_sym_new] = ACTIONS(2799),
    [anon_sym_requires] = ACTIONS(2799),
    [sym_this] = ACTIONS(2799),
  },
  [728] = {
    [ts_builtin_sym_end] = ACTIONS(2801),
    [sym_identifier] = ACTIONS(2799),
    [aux_sym_preproc_include_token1] = ACTIONS(2799),
    [aux_sym_preproc_def_token1] = ACTIONS(2799),
    [aux_sym_preproc_if_token1] = ACTIONS(2799),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2799),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2799),
    [sym_preproc_directive] = ACTIONS(2799),
    [anon_sym_LPAREN2] = ACTIONS(2801),
    [anon_sym_BANG] = ACTIONS(2801),
    [anon_sym_TILDE] = ACTIONS(2801),
    [anon_sym_DASH] = ACTIONS(2799),
    [anon_sym_PLUS] = ACTIONS(2799),
    [anon_sym_STAR] = ACTIONS(2801),
    [anon_sym_AMP_AMP] = ACTIONS(2801),
    [anon_sym_AMP] = ACTIONS(2799),
    [anon_sym_SEMI] = ACTIONS(2801),
    [anon_sym___extension__] = ACTIONS(2799),
    [anon_sym_typedef] = ACTIONS(2799),
    [anon_sym_virtual] = ACTIONS(2799),
    [anon_sym_extern] = ACTIONS(2799),
    [anon_sym___attribute__] = ACTIONS(2799),
    [anon_sym___attribute] = ACTIONS(2799),
    [anon_sym_COLON_COLON] = ACTIONS(2801),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2801),
    [anon_sym___declspec] = ACTIONS(2799),
    [anon_sym___based] = ACTIONS(2799),
    [anon_sym___cdecl] = ACTIONS(2799),
    [anon_sym___clrcall] = ACTIONS(2799),
    [anon_sym___stdcall] = ACTIONS(2799),
    [anon_sym___fastcall] = ACTIONS(2799),
    [anon_sym___thiscall] = ACTIONS(2799),
    [anon_sym___vectorcall] = ACTIONS(2799),
    [anon_sym_LBRACE] = ACTIONS(2801),
    [anon_sym_signed] = ACTIONS(2799),
    [anon_sym_unsigned] = ACTIONS(2799),
    [anon_sym_long] = ACTIONS(2799),
    [anon_sym_short] = ACTIONS(2799),
    [anon_sym_LBRACK] = ACTIONS(2799),
    [anon_sym_static] = ACTIONS(2799),
    [anon_sym_register] = ACTIONS(2799),
    [anon_sym_inline] = ACTIONS(2799),
    [anon_sym___inline] = ACTIONS(2799),
    [anon_sym___inline__] = ACTIONS(2799),
    [anon_sym___forceinline] = ACTIONS(2799),
    [anon_sym_thread_local] = ACTIONS(2799),
    [anon_sym___thread] = ACTIONS(2799),
    [anon_sym_const] = ACTIONS(2799),
    [anon_sym_constexpr] = ACTIONS(2799),
    [anon_sym_volatile] = ACTIONS(2799),
    [anon_sym_restrict] = ACTIONS(2799),
    [anon_sym___restrict__] = ACTIONS(2799),
    [anon_sym__Atomic] = ACTIONS(2799),
    [anon_sym__Noreturn] = ACTIONS(2799),
    [anon_sym_noreturn] = ACTIONS(2799),
    [anon_sym__Nonnull] = ACTIONS(2799),
    [anon_sym_mutable] = ACTIONS(2799),
    [anon_sym_constinit] = ACTIONS(2799),
    [anon_sym_consteval] = ACTIONS(2799),
    [anon_sym_alignas] = ACTIONS(2799),
    [anon_sym__Alignas] = ACTIONS(2799),
    [sym_primitive_type] = ACTIONS(2799),
    [anon_sym_enum] = ACTIONS(2799),
    [anon_sym_class] = ACTIONS(2799),
    [anon_sym_struct] = ACTIONS(2799),
    [anon_sym_union] = ACTIONS(2799),
    [anon_sym_if] = ACTIONS(2799),
    [anon_sym_switch] = ACTIONS(2799),
    [anon_sym_case] = ACTIONS(2799),
    [anon_sym_default] = ACTIONS(2799),
    [anon_sym_while] = ACTIONS(2799),
    [anon_sym_do] = ACTIONS(2799),
    [anon_sym_for] = ACTIONS(2799),
    [anon_sym_return] = ACTIONS(2799),
    [anon_sym_break] = ACTIONS(2799),
    [anon_sym_continue] = ACTIONS(2799),
    [anon_sym_goto] = ACTIONS(2799),
    [anon_sym_not] = ACTIONS(2799),
    [anon_sym_compl] = ACTIONS(2799),
    [anon_sym_DASH_DASH] = ACTIONS(2801),
    [anon_sym_PLUS_PLUS] = ACTIONS(2801),
    [anon_sym_sizeof] = ACTIONS(2799),
    [anon_sym___alignof__] = ACTIONS(2799),
    [anon_sym___alignof] = ACTIONS(2799),
    [anon_sym__alignof] = ACTIONS(2799),
    [anon_sym_alignof] = ACTIONS(2799),
    [anon_sym__Alignof] = ACTIONS(2799),
    [anon_sym_offsetof] = ACTIONS(2799),
    [anon_sym__Generic] = ACTIONS(2799),
    [anon_sym_asm] = ACTIONS(2799),
    [anon_sym___asm__] = ACTIONS(2799),
    [anon_sym___asm] = ACTIONS(2799),
    [sym_number_literal] = ACTIONS(2801),
    [anon_sym_L_SQUOTE] = ACTIONS(2801),
    [anon_sym_u_SQUOTE] = ACTIONS(2801),
    [anon_sym_U_SQUOTE] = ACTIONS(2801),
    [anon_sym_u8_SQUOTE] = ACTIONS(2801),
    [anon_sym_SQUOTE] = ACTIONS(2801),
    [anon_sym_L_DQUOTE] = ACTIONS(2801),
    [anon_sym_u_DQUOTE] = ACTIONS(2801),
    [anon_sym_U_DQUOTE] = ACTIONS(2801),
    [anon_sym_u8_DQUOTE] = ACTIONS(2801),
    [anon_sym_DQUOTE] = ACTIONS(2801),
    [sym_true] = ACTIONS(2799),
    [sym_false] = ACTIONS(2799),
    [anon_sym_NULL] = ACTIONS(2799),
    [anon_sym_nullptr] = ACTIONS(2799),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2799),
    [anon_sym_decltype] = ACTIONS(2799),
    [anon_sym_explicit] = ACTIONS(2799),
    [anon_sym_typename] = ACTIONS(2799),
    [anon_sym_template] = ACTIONS(2799),
    [anon_sym_operator] = ACTIONS(2799),
    [anon_sym_try] = ACTIONS(2799),
    [anon_sym_delete] = ACTIONS(2799),
    [anon_sym_throw] = ACTIONS(2799),
    [anon_sym_namespace] = ACTIONS(2799),
    [anon_sym_using] = ACTIONS(2799),
    [anon_sym_static_assert] = ACTIONS(2799),
    [anon_sym_concept] = ACTIONS(2799),
    [anon_sym_co_return] = ACTIONS(2799),
    [anon_sym_co_yield] = ACTIONS(2799),
    [anon_sym_R_DQUOTE] = ACTIONS(2801),
    [anon_sym_LR_DQUOTE] = ACTIONS(2801),
    [anon_sym_uR_DQUOTE] = ACTIONS(2801),
    [anon_sym_UR_DQUOTE] = ACTIONS(2801),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2801),
    [anon_sym_co_await] = ACTIONS(2799),
    [anon_sym_new] = ACTIONS(2799),
    [anon_sym_requires] = ACTIONS(2799),
    [sym_this] = ACTIONS(2799),
  },
  [729] = {
    [ts_builtin_sym_end] = ACTIONS(2836),
    [sym_identifier] = ACTIONS(2834),
    [aux_sym_preproc_include_token1] = ACTIONS(2834),
    [aux_sym_preproc_def_token1] = ACTIONS(2834),
    [aux_sym_preproc_if_token1] = ACTIONS(2834),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2834),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2834),
    [sym_preproc_directive] = ACTIONS(2834),
    [anon_sym_LPAREN2] = ACTIONS(2836),
    [anon_sym_BANG] = ACTIONS(2836),
    [anon_sym_TILDE] = ACTIONS(2836),
    [anon_sym_DASH] = ACTIONS(2834),
    [anon_sym_PLUS] = ACTIONS(2834),
    [anon_sym_STAR] = ACTIONS(2836),
    [anon_sym_AMP_AMP] = ACTIONS(2836),
    [anon_sym_AMP] = ACTIONS(2834),
    [anon_sym_SEMI] = ACTIONS(2836),
    [anon_sym___extension__] = ACTIONS(2834),
    [anon_sym_typedef] = ACTIONS(2834),
    [anon_sym_virtual] = ACTIONS(2834),
    [anon_sym_extern] = ACTIONS(2834),
    [anon_sym___attribute__] = ACTIONS(2834),
    [anon_sym___attribute] = ACTIONS(2834),
    [anon_sym_COLON_COLON] = ACTIONS(2836),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2836),
    [anon_sym___declspec] = ACTIONS(2834),
    [anon_sym___based] = ACTIONS(2834),
    [anon_sym___cdecl] = ACTIONS(2834),
    [anon_sym___clrcall] = ACTIONS(2834),
    [anon_sym___stdcall] = ACTIONS(2834),
    [anon_sym___fastcall] = ACTIONS(2834),
    [anon_sym___thiscall] = ACTIONS(2834),
    [anon_sym___vectorcall] = ACTIONS(2834),
    [anon_sym_LBRACE] = ACTIONS(2836),
    [anon_sym_signed] = ACTIONS(2834),
    [anon_sym_unsigned] = ACTIONS(2834),
    [anon_sym_long] = ACTIONS(2834),
    [anon_sym_short] = ACTIONS(2834),
    [anon_sym_LBRACK] = ACTIONS(2834),
    [anon_sym_static] = ACTIONS(2834),
    [anon_sym_register] = ACTIONS(2834),
    [anon_sym_inline] = ACTIONS(2834),
    [anon_sym___inline] = ACTIONS(2834),
    [anon_sym___inline__] = ACTIONS(2834),
    [anon_sym___forceinline] = ACTIONS(2834),
    [anon_sym_thread_local] = ACTIONS(2834),
    [anon_sym___thread] = ACTIONS(2834),
    [anon_sym_const] = ACTIONS(2834),
    [anon_sym_constexpr] = ACTIONS(2834),
    [anon_sym_volatile] = ACTIONS(2834),
    [anon_sym_restrict] = ACTIONS(2834),
    [anon_sym___restrict__] = ACTIONS(2834),
    [anon_sym__Atomic] = ACTIONS(2834),
    [anon_sym__Noreturn] = ACTIONS(2834),
    [anon_sym_noreturn] = ACTIONS(2834),
    [anon_sym__Nonnull] = ACTIONS(2834),
    [anon_sym_mutable] = ACTIONS(2834),
    [anon_sym_constinit] = ACTIONS(2834),
    [anon_sym_consteval] = ACTIONS(2834),
    [anon_sym_alignas] = ACTIONS(2834),
    [anon_sym__Alignas] = ACTIONS(2834),
    [sym_primitive_type] = ACTIONS(2834),
    [anon_sym_enum] = ACTIONS(2834),
    [anon_sym_class] = ACTIONS(2834),
    [anon_sym_struct] = ACTIONS(2834),
    [anon_sym_union] = ACTIONS(2834),
    [anon_sym_if] = ACTIONS(2834),
    [anon_sym_switch] = ACTIONS(2834),
    [anon_sym_case] = ACTIONS(2834),
    [anon_sym_default] = ACTIONS(2834),
    [anon_sym_while] = ACTIONS(2834),
    [anon_sym_do] = ACTIONS(2834),
    [anon_sym_for] = ACTIONS(2834),
    [anon_sym_return] = ACTIONS(2834),
    [anon_sym_break] = ACTIONS(2834),
    [anon_sym_continue] = ACTIONS(2834),
    [anon_sym_goto] = ACTIONS(2834),
    [anon_sym_not] = ACTIONS(2834),
    [anon_sym_compl] = ACTIONS(2834),
    [anon_sym_DASH_DASH] = ACTIONS(2836),
    [anon_sym_PLUS_PLUS] = ACTIONS(2836),
    [anon_sym_sizeof] = ACTIONS(2834),
    [anon_sym___alignof__] = ACTIONS(2834),
    [anon_sym___alignof] = ACTIONS(2834),
    [anon_sym__alignof] = ACTIONS(2834),
    [anon_sym_alignof] = ACTIONS(2834),
    [anon_sym__Alignof] = ACTIONS(2834),
    [anon_sym_offsetof] = ACTIONS(2834),
    [anon_sym__Generic] = ACTIONS(2834),
    [anon_sym_asm] = ACTIONS(2834),
    [anon_sym___asm__] = ACTIONS(2834),
    [anon_sym___asm] = ACTIONS(2834),
    [sym_number_literal] = ACTIONS(2836),
    [anon_sym_L_SQUOTE] = ACTIONS(2836),
    [anon_sym_u_SQUOTE] = ACTIONS(2836),
    [anon_sym_U_SQUOTE] = ACTIONS(2836),
    [anon_sym_u8_SQUOTE] = ACTIONS(2836),
    [anon_sym_SQUOTE] = ACTIONS(2836),
    [anon_sym_L_DQUOTE] = ACTIONS(2836),
    [anon_sym_u_DQUOTE] = ACTIONS(2836),
    [anon_sym_U_DQUOTE] = ACTIONS(2836),
    [anon_sym_u8_DQUOTE] = ACTIONS(2836),
    [anon_sym_DQUOTE] = ACTIONS(2836),
    [sym_true] = ACTIONS(2834),
    [sym_false] = ACTIONS(2834),
    [anon_sym_NULL] = ACTIONS(2834),
    [anon_sym_nullptr] = ACTIONS(2834),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2834),
    [anon_sym_decltype] = ACTIONS(2834),
    [anon_sym_explicit] = ACTIONS(2834),
    [anon_sym_typename] = ACTIONS(2834),
    [anon_sym_template] = ACTIONS(2834),
    [anon_sym_operator] = ACTIONS(2834),
    [anon_sym_try] = ACTIONS(2834),
    [anon_sym_delete] = ACTIONS(2834),
    [anon_sym_throw] = ACTIONS(2834),
    [anon_sym_namespace] = ACTIONS(2834),
    [anon_sym_using] = ACTIONS(2834),
    [anon_sym_static_assert] = ACTIONS(2834),
    [anon_sym_concept] = ACTIONS(2834),
    [anon_sym_co_return] = ACTIONS(2834),
    [anon_sym_co_yield] = ACTIONS(2834),
    [anon_sym_R_DQUOTE] = ACTIONS(2836),
    [anon_sym_LR_DQUOTE] = ACTIONS(2836),
    [anon_sym_uR_DQUOTE] = ACTIONS(2836),
    [anon_sym_UR_DQUOTE] = ACTIONS(2836),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2836),
    [anon_sym_co_await] = ACTIONS(2834),
    [anon_sym_new] = ACTIONS(2834),
    [anon_sym_requires] = ACTIONS(2834),
    [sym_this] = ACTIONS(2834),
  },
  [730] = {
    [ts_builtin_sym_end] = ACTIONS(2840),
    [sym_identifier] = ACTIONS(2838),
    [aux_sym_preproc_include_token1] = ACTIONS(2838),
    [aux_sym_preproc_def_token1] = ACTIONS(2838),
    [aux_sym_preproc_if_token1] = ACTIONS(2838),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2838),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2838),
    [sym_preproc_directive] = ACTIONS(2838),
    [anon_sym_LPAREN2] = ACTIONS(2840),
    [anon_sym_BANG] = ACTIONS(2840),
    [anon_sym_TILDE] = ACTIONS(2840),
    [anon_sym_DASH] = ACTIONS(2838),
    [anon_sym_PLUS] = ACTIONS(2838),
    [anon_sym_STAR] = ACTIONS(2840),
    [anon_sym_AMP_AMP] = ACTIONS(2840),
    [anon_sym_AMP] = ACTIONS(2838),
    [anon_sym_SEMI] = ACTIONS(2840),
    [anon_sym___extension__] = ACTIONS(2838),
    [anon_sym_typedef] = ACTIONS(2838),
    [anon_sym_virtual] = ACTIONS(2838),
    [anon_sym_extern] = ACTIONS(2838),
    [anon_sym___attribute__] = ACTIONS(2838),
    [anon_sym___attribute] = ACTIONS(2838),
    [anon_sym_COLON_COLON] = ACTIONS(2840),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2840),
    [anon_sym___declspec] = ACTIONS(2838),
    [anon_sym___based] = ACTIONS(2838),
    [anon_sym___cdecl] = ACTIONS(2838),
    [anon_sym___clrcall] = ACTIONS(2838),
    [anon_sym___stdcall] = ACTIONS(2838),
    [anon_sym___fastcall] = ACTIONS(2838),
    [anon_sym___thiscall] = ACTIONS(2838),
    [anon_sym___vectorcall] = ACTIONS(2838),
    [anon_sym_LBRACE] = ACTIONS(2840),
    [anon_sym_signed] = ACTIONS(2838),
    [anon_sym_unsigned] = ACTIONS(2838),
    [anon_sym_long] = ACTIONS(2838),
    [anon_sym_short] = ACTIONS(2838),
    [anon_sym_LBRACK] = ACTIONS(2838),
    [anon_sym_static] = ACTIONS(2838),
    [anon_sym_register] = ACTIONS(2838),
    [anon_sym_inline] = ACTIONS(2838),
    [anon_sym___inline] = ACTIONS(2838),
    [anon_sym___inline__] = ACTIONS(2838),
    [anon_sym___forceinline] = ACTIONS(2838),
    [anon_sym_thread_local] = ACTIONS(2838),
    [anon_sym___thread] = ACTIONS(2838),
    [anon_sym_const] = ACTIONS(2838),
    [anon_sym_constexpr] = ACTIONS(2838),
    [anon_sym_volatile] = ACTIONS(2838),
    [anon_sym_restrict] = ACTIONS(2838),
    [anon_sym___restrict__] = ACTIONS(2838),
    [anon_sym__Atomic] = ACTIONS(2838),
    [anon_sym__Noreturn] = ACTIONS(2838),
    [anon_sym_noreturn] = ACTIONS(2838),
    [anon_sym__Nonnull] = ACTIONS(2838),
    [anon_sym_mutable] = ACTIONS(2838),
    [anon_sym_constinit] = ACTIONS(2838),
    [anon_sym_consteval] = ACTIONS(2838),
    [anon_sym_alignas] = ACTIONS(2838),
    [anon_sym__Alignas] = ACTIONS(2838),
    [sym_primitive_type] = ACTIONS(2838),
    [anon_sym_enum] = ACTIONS(2838),
    [anon_sym_class] = ACTIONS(2838),
    [anon_sym_struct] = ACTIONS(2838),
    [anon_sym_union] = ACTIONS(2838),
    [anon_sym_if] = ACTIONS(2838),
    [anon_sym_switch] = ACTIONS(2838),
    [anon_sym_case] = ACTIONS(2838),
    [anon_sym_default] = ACTIONS(2838),
    [anon_sym_while] = ACTIONS(2838),
    [anon_sym_do] = ACTIONS(2838),
    [anon_sym_for] = ACTIONS(2838),
    [anon_sym_return] = ACTIONS(2838),
    [anon_sym_break] = ACTIONS(2838),
    [anon_sym_continue] = ACTIONS(2838),
    [anon_sym_goto] = ACTIONS(2838),
    [anon_sym_not] = ACTIONS(2838),
    [anon_sym_compl] = ACTIONS(2838),
    [anon_sym_DASH_DASH] = ACTIONS(2840),
    [anon_sym_PLUS_PLUS] = ACTIONS(2840),
    [anon_sym_sizeof] = ACTIONS(2838),
    [anon_sym___alignof__] = ACTIONS(2838),
    [anon_sym___alignof] = ACTIONS(2838),
    [anon_sym__alignof] = ACTIONS(2838),
    [anon_sym_alignof] = ACTIONS(2838),
    [anon_sym__Alignof] = ACTIONS(2838),
    [anon_sym_offsetof] = ACTIONS(2838),
    [anon_sym__Generic] = ACTIONS(2838),
    [anon_sym_asm] = ACTIONS(2838),
    [anon_sym___asm__] = ACTIONS(2838),
    [anon_sym___asm] = ACTIONS(2838),
    [sym_number_literal] = ACTIONS(2840),
    [anon_sym_L_SQUOTE] = ACTIONS(2840),
    [anon_sym_u_SQUOTE] = ACTIONS(2840),
    [anon_sym_U_SQUOTE] = ACTIONS(2840),
    [anon_sym_u8_SQUOTE] = ACTIONS(2840),
    [anon_sym_SQUOTE] = ACTIONS(2840),
    [anon_sym_L_DQUOTE] = ACTIONS(2840),
    [anon_sym_u_DQUOTE] = ACTIONS(2840),
    [anon_sym_U_DQUOTE] = ACTIONS(2840),
    [anon_sym_u8_DQUOTE] = ACTIONS(2840),
    [anon_sym_DQUOTE] = ACTIONS(2840),
    [sym_true] = ACTIONS(2838),
    [sym_false] = ACTIONS(2838),
    [anon_sym_NULL] = ACTIONS(2838),
    [anon_sym_nullptr] = ACTIONS(2838),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2838),
    [anon_sym_decltype] = ACTIONS(2838),
    [anon_sym_explicit] = ACTIONS(2838),
    [anon_sym_typename] = ACTIONS(2838),
    [anon_sym_template] = ACTIONS(2838),
    [anon_sym_operator] = ACTIONS(2838),
    [anon_sym_try] = ACTIONS(2838),
    [anon_sym_delete] = ACTIONS(2838),
    [anon_sym_throw] = ACTIONS(2838),
    [anon_sym_namespace] = ACTIONS(2838),
    [anon_sym_using] = ACTIONS(2838),
    [anon_sym_static_assert] = ACTIONS(2838),
    [anon_sym_concept] = ACTIONS(2838),
    [anon_sym_co_return] = ACTIONS(2838),
    [anon_sym_co_yield] = ACTIONS(2838),
    [anon_sym_R_DQUOTE] = ACTIONS(2840),
    [anon_sym_LR_DQUOTE] = ACTIONS(2840),
    [anon_sym_uR_DQUOTE] = ACTIONS(2840),
    [anon_sym_UR_DQUOTE] = ACTIONS(2840),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2840),
    [anon_sym_co_await] = ACTIONS(2838),
    [anon_sym_new] = ACTIONS(2838),
    [anon_sym_requires] = ACTIONS(2838),
    [sym_this] = ACTIONS(2838),
  },
  [731] = {
    [ts_builtin_sym_end] = ACTIONS(2844),
    [sym_identifier] = ACTIONS(2842),
    [aux_sym_preproc_include_token1] = ACTIONS(2842),
    [aux_sym_preproc_def_token1] = ACTIONS(2842),
    [aux_sym_preproc_if_token1] = ACTIONS(2842),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2842),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2842),
    [sym_preproc_directive] = ACTIONS(2842),
    [anon_sym_LPAREN2] = ACTIONS(2844),
    [anon_sym_BANG] = ACTIONS(2844),
    [anon_sym_TILDE] = ACTIONS(2844),
    [anon_sym_DASH] = ACTIONS(2842),
    [anon_sym_PLUS] = ACTIONS(2842),
    [anon_sym_STAR] = ACTIONS(2844),
    [anon_sym_AMP_AMP] = ACTIONS(2844),
    [anon_sym_AMP] = ACTIONS(2842),
    [anon_sym_SEMI] = ACTIONS(2844),
    [anon_sym___extension__] = ACTIONS(2842),
    [anon_sym_typedef] = ACTIONS(2842),
    [anon_sym_virtual] = ACTIONS(2842),
    [anon_sym_extern] = ACTIONS(2842),
    [anon_sym___attribute__] = ACTIONS(2842),
    [anon_sym___attribute] = ACTIONS(2842),
    [anon_sym_COLON_COLON] = ACTIONS(2844),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2844),
    [anon_sym___declspec] = ACTIONS(2842),
    [anon_sym___based] = ACTIONS(2842),
    [anon_sym___cdecl] = ACTIONS(2842),
    [anon_sym___clrcall] = ACTIONS(2842),
    [anon_sym___stdcall] = ACTIONS(2842),
    [anon_sym___fastcall] = ACTIONS(2842),
    [anon_sym___thiscall] = ACTIONS(2842),
    [anon_sym___vectorcall] = ACTIONS(2842),
    [anon_sym_LBRACE] = ACTIONS(2844),
    [anon_sym_signed] = ACTIONS(2842),
    [anon_sym_unsigned] = ACTIONS(2842),
    [anon_sym_long] = ACTIONS(2842),
    [anon_sym_short] = ACTIONS(2842),
    [anon_sym_LBRACK] = ACTIONS(2842),
    [anon_sym_static] = ACTIONS(2842),
    [anon_sym_register] = ACTIONS(2842),
    [anon_sym_inline] = ACTIONS(2842),
    [anon_sym___inline] = ACTIONS(2842),
    [anon_sym___inline__] = ACTIONS(2842),
    [anon_sym___forceinline] = ACTIONS(2842),
    [anon_sym_thread_local] = ACTIONS(2842),
    [anon_sym___thread] = ACTIONS(2842),
    [anon_sym_const] = ACTIONS(2842),
    [anon_sym_constexpr] = ACTIONS(2842),
    [anon_sym_volatile] = ACTIONS(2842),
    [anon_sym_restrict] = ACTIONS(2842),
    [anon_sym___restrict__] = ACTIONS(2842),
    [anon_sym__Atomic] = ACTIONS(2842),
    [anon_sym__Noreturn] = ACTIONS(2842),
    [anon_sym_noreturn] = ACTIONS(2842),
    [anon_sym__Nonnull] = ACTIONS(2842),
    [anon_sym_mutable] = ACTIONS(2842),
    [anon_sym_constinit] = ACTIONS(2842),
    [anon_sym_consteval] = ACTIONS(2842),
    [anon_sym_alignas] = ACTIONS(2842),
    [anon_sym__Alignas] = ACTIONS(2842),
    [sym_primitive_type] = ACTIONS(2842),
    [anon_sym_enum] = ACTIONS(2842),
    [anon_sym_class] = ACTIONS(2842),
    [anon_sym_struct] = ACTIONS(2842),
    [anon_sym_union] = ACTIONS(2842),
    [anon_sym_if] = ACTIONS(2842),
    [anon_sym_switch] = ACTIONS(2842),
    [anon_sym_case] = ACTIONS(2842),
    [anon_sym_default] = ACTIONS(2842),
    [anon_sym_while] = ACTIONS(2842),
    [anon_sym_do] = ACTIONS(2842),
    [anon_sym_for] = ACTIONS(2842),
    [anon_sym_return] = ACTIONS(2842),
    [anon_sym_break] = ACTIONS(2842),
    [anon_sym_continue] = ACTIONS(2842),
    [anon_sym_goto] = ACTIONS(2842),
    [anon_sym_not] = ACTIONS(2842),
    [anon_sym_compl] = ACTIONS(2842),
    [anon_sym_DASH_DASH] = ACTIONS(2844),
    [anon_sym_PLUS_PLUS] = ACTIONS(2844),
    [anon_sym_sizeof] = ACTIONS(2842),
    [anon_sym___alignof__] = ACTIONS(2842),
    [anon_sym___alignof] = ACTIONS(2842),
    [anon_sym__alignof] = ACTIONS(2842),
    [anon_sym_alignof] = ACTIONS(2842),
    [anon_sym__Alignof] = ACTIONS(2842),
    [anon_sym_offsetof] = ACTIONS(2842),
    [anon_sym__Generic] = ACTIONS(2842),
    [anon_sym_asm] = ACTIONS(2842),
    [anon_sym___asm__] = ACTIONS(2842),
    [anon_sym___asm] = ACTIONS(2842),
    [sym_number_literal] = ACTIONS(2844),
    [anon_sym_L_SQUOTE] = ACTIONS(2844),
    [anon_sym_u_SQUOTE] = ACTIONS(2844),
    [anon_sym_U_SQUOTE] = ACTIONS(2844),
    [anon_sym_u8_SQUOTE] = ACTIONS(2844),
    [anon_sym_SQUOTE] = ACTIONS(2844),
    [anon_sym_L_DQUOTE] = ACTIONS(2844),
    [anon_sym_u_DQUOTE] = ACTIONS(2844),
    [anon_sym_U_DQUOTE] = ACTIONS(2844),
    [anon_sym_u8_DQUOTE] = ACTIONS(2844),
    [anon_sym_DQUOTE] = ACTIONS(2844),
    [sym_true] = ACTIONS(2842),
    [sym_false] = ACTIONS(2842),
    [anon_sym_NULL] = ACTIONS(2842),
    [anon_sym_nullptr] = ACTIONS(2842),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2842),
    [anon_sym_decltype] = ACTIONS(2842),
    [anon_sym_explicit] = ACTIONS(2842),
    [anon_sym_typename] = ACTIONS(2842),
    [anon_sym_template] = ACTIONS(2842),
    [anon_sym_operator] = ACTIONS(2842),
    [anon_sym_try] = ACTIONS(2842),
    [anon_sym_delete] = ACTIONS(2842),
    [anon_sym_throw] = ACTIONS(2842),
    [anon_sym_namespace] = ACTIONS(2842),
    [anon_sym_using] = ACTIONS(2842),
    [anon_sym_static_assert] = ACTIONS(2842),
    [anon_sym_concept] = ACTIONS(2842),
    [anon_sym_co_return] = ACTIONS(2842),
    [anon_sym_co_yield] = ACTIONS(2842),
    [anon_sym_R_DQUOTE] = ACTIONS(2844),
    [anon_sym_LR_DQUOTE] = ACTIONS(2844),
    [anon_sym_uR_DQUOTE] = ACTIONS(2844),
    [anon_sym_UR_DQUOTE] = ACTIONS(2844),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2844),
    [anon_sym_co_await] = ACTIONS(2842),
    [anon_sym_new] = ACTIONS(2842),
    [anon_sym_requires] = ACTIONS(2842),
    [sym_this] = ACTIONS(2842),
  },
  [732] = {
    [ts_builtin_sym_end] = ACTIONS(2848),
    [sym_identifier] = ACTIONS(2846),
    [aux_sym_preproc_include_token1] = ACTIONS(2846),
    [aux_sym_preproc_def_token1] = ACTIONS(2846),
    [aux_sym_preproc_if_token1] = ACTIONS(2846),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2846),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2846),
    [sym_preproc_directive] = ACTIONS(2846),
    [anon_sym_LPAREN2] = ACTIONS(2848),
    [anon_sym_BANG] = ACTIONS(2848),
    [anon_sym_TILDE] = ACTIONS(2848),
    [anon_sym_DASH] = ACTIONS(2846),
    [anon_sym_PLUS] = ACTIONS(2846),
    [anon_sym_STAR] = ACTIONS(2848),
    [anon_sym_AMP_AMP] = ACTIONS(2848),
    [anon_sym_AMP] = ACTIONS(2846),
    [anon_sym_SEMI] = ACTIONS(2848),
    [anon_sym___extension__] = ACTIONS(2846),
    [anon_sym_typedef] = ACTIONS(2846),
    [anon_sym_virtual] = ACTIONS(2846),
    [anon_sym_extern] = ACTIONS(2846),
    [anon_sym___attribute__] = ACTIONS(2846),
    [anon_sym___attribute] = ACTIONS(2846),
    [anon_sym_COLON_COLON] = ACTIONS(2848),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2848),
    [anon_sym___declspec] = ACTIONS(2846),
    [anon_sym___based] = ACTIONS(2846),
    [anon_sym___cdecl] = ACTIONS(2846),
    [anon_sym___clrcall] = ACTIONS(2846),
    [anon_sym___stdcall] = ACTIONS(2846),
    [anon_sym___fastcall] = ACTIONS(2846),
    [anon_sym___thiscall] = ACTIONS(2846),
    [anon_sym___vectorcall] = ACTIONS(2846),
    [anon_sym_LBRACE] = ACTIONS(2848),
    [anon_sym_signed] = ACTIONS(2846),
    [anon_sym_unsigned] = ACTIONS(2846),
    [anon_sym_long] = ACTIONS(2846),
    [anon_sym_short] = ACTIONS(2846),
    [anon_sym_LBRACK] = ACTIONS(2846),
    [anon_sym_static] = ACTIONS(2846),
    [anon_sym_register] = ACTIONS(2846),
    [anon_sym_inline] = ACTIONS(2846),
    [anon_sym___inline] = ACTIONS(2846),
    [anon_sym___inline__] = ACTIONS(2846),
    [anon_sym___forceinline] = ACTIONS(2846),
    [anon_sym_thread_local] = ACTIONS(2846),
    [anon_sym___thread] = ACTIONS(2846),
    [anon_sym_const] = ACTIONS(2846),
    [anon_sym_constexpr] = ACTIONS(2846),
    [anon_sym_volatile] = ACTIONS(2846),
    [anon_sym_restrict] = ACTIONS(2846),
    [anon_sym___restrict__] = ACTIONS(2846),
    [anon_sym__Atomic] = ACTIONS(2846),
    [anon_sym__Noreturn] = ACTIONS(2846),
    [anon_sym_noreturn] = ACTIONS(2846),
    [anon_sym__Nonnull] = ACTIONS(2846),
    [anon_sym_mutable] = ACTIONS(2846),
    [anon_sym_constinit] = ACTIONS(2846),
    [anon_sym_consteval] = ACTIONS(2846),
    [anon_sym_alignas] = ACTIONS(2846),
    [anon_sym__Alignas] = ACTIONS(2846),
    [sym_primitive_type] = ACTIONS(2846),
    [anon_sym_enum] = ACTIONS(2846),
    [anon_sym_class] = ACTIONS(2846),
    [anon_sym_struct] = ACTIONS(2846),
    [anon_sym_union] = ACTIONS(2846),
    [anon_sym_if] = ACTIONS(2846),
    [anon_sym_switch] = ACTIONS(2846),
    [anon_sym_case] = ACTIONS(2846),
    [anon_sym_default] = ACTIONS(2846),
    [anon_sym_while] = ACTIONS(2846),
    [anon_sym_do] = ACTIONS(2846),
    [anon_sym_for] = ACTIONS(2846),
    [anon_sym_return] = ACTIONS(2846),
    [anon_sym_break] = ACTIONS(2846),
    [anon_sym_continue] = ACTIONS(2846),
    [anon_sym_goto] = ACTIONS(2846),
    [anon_sym_not] = ACTIONS(2846),
    [anon_sym_compl] = ACTIONS(2846),
    [anon_sym_DASH_DASH] = ACTIONS(2848),
    [anon_sym_PLUS_PLUS] = ACTIONS(2848),
    [anon_sym_sizeof] = ACTIONS(2846),
    [anon_sym___alignof__] = ACTIONS(2846),
    [anon_sym___alignof] = ACTIONS(2846),
    [anon_sym__alignof] = ACTIONS(2846),
    [anon_sym_alignof] = ACTIONS(2846),
    [anon_sym__Alignof] = ACTIONS(2846),
    [anon_sym_offsetof] = ACTIONS(2846),
    [anon_sym__Generic] = ACTIONS(2846),
    [anon_sym_asm] = ACTIONS(2846),
    [anon_sym___asm__] = ACTIONS(2846),
    [anon_sym___asm] = ACTIONS(2846),
    [sym_number_literal] = ACTIONS(2848),
    [anon_sym_L_SQUOTE] = ACTIONS(2848),
    [anon_sym_u_SQUOTE] = ACTIONS(2848),
    [anon_sym_U_SQUOTE] = ACTIONS(2848),
    [anon_sym_u8_SQUOTE] = ACTIONS(2848),
    [anon_sym_SQUOTE] = ACTIONS(2848),
    [anon_sym_L_DQUOTE] = ACTIONS(2848),
    [anon_sym_u_DQUOTE] = ACTIONS(2848),
    [anon_sym_U_DQUOTE] = ACTIONS(2848),
    [anon_sym_u8_DQUOTE] = ACTIONS(2848),
    [anon_sym_DQUOTE] = ACTIONS(2848),
    [sym_true] = ACTIONS(2846),
    [sym_false] = ACTIONS(2846),
    [anon_sym_NULL] = ACTIONS(2846),
    [anon_sym_nullptr] = ACTIONS(2846),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2846),
    [anon_sym_decltype] = ACTIONS(2846),
    [anon_sym_explicit] = ACTIONS(2846),
    [anon_sym_typename] = ACTIONS(2846),
    [anon_sym_template] = ACTIONS(2846),
    [anon_sym_operator] = ACTIONS(2846),
    [anon_sym_try] = ACTIONS(2846),
    [anon_sym_delete] = ACTIONS(2846),
    [anon_sym_throw] = ACTIONS(2846),
    [anon_sym_namespace] = ACTIONS(2846),
    [anon_sym_using] = ACTIONS(2846),
    [anon_sym_static_assert] = ACTIONS(2846),
    [anon_sym_concept] = ACTIONS(2846),
    [anon_sym_co_return] = ACTIONS(2846),
    [anon_sym_co_yield] = ACTIONS(2846),
    [anon_sym_R_DQUOTE] = ACTIONS(2848),
    [anon_sym_LR_DQUOTE] = ACTIONS(2848),
    [anon_sym_uR_DQUOTE] = ACTIONS(2848),
    [anon_sym_UR_DQUOTE] = ACTIONS(2848),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2848),
    [anon_sym_co_await] = ACTIONS(2846),
    [anon_sym_new] = ACTIONS(2846),
    [anon_sym_requires] = ACTIONS(2846),
    [sym_this] = ACTIONS(2846),
  },
  [733] = {
    [ts_builtin_sym_end] = ACTIONS(2852),
    [sym_identifier] = ACTIONS(2850),
    [aux_sym_preproc_include_token1] = ACTIONS(2850),
    [aux_sym_preproc_def_token1] = ACTIONS(2850),
    [aux_sym_preproc_if_token1] = ACTIONS(2850),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2850),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2850),
    [sym_preproc_directive] = ACTIONS(2850),
    [anon_sym_LPAREN2] = ACTIONS(2852),
    [anon_sym_BANG] = ACTIONS(2852),
    [anon_sym_TILDE] = ACTIONS(2852),
    [anon_sym_DASH] = ACTIONS(2850),
    [anon_sym_PLUS] = ACTIONS(2850),
    [anon_sym_STAR] = ACTIONS(2852),
    [anon_sym_AMP_AMP] = ACTIONS(2852),
    [anon_sym_AMP] = ACTIONS(2850),
    [anon_sym_SEMI] = ACTIONS(2852),
    [anon_sym___extension__] = ACTIONS(2850),
    [anon_sym_typedef] = ACTIONS(2850),
    [anon_sym_virtual] = ACTIONS(2850),
    [anon_sym_extern] = ACTIONS(2850),
    [anon_sym___attribute__] = ACTIONS(2850),
    [anon_sym___attribute] = ACTIONS(2850),
    [anon_sym_COLON_COLON] = ACTIONS(2852),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2852),
    [anon_sym___declspec] = ACTIONS(2850),
    [anon_sym___based] = ACTIONS(2850),
    [anon_sym___cdecl] = ACTIONS(2850),
    [anon_sym___clrcall] = ACTIONS(2850),
    [anon_sym___stdcall] = ACTIONS(2850),
    [anon_sym___fastcall] = ACTIONS(2850),
    [anon_sym___thiscall] = ACTIONS(2850),
    [anon_sym___vectorcall] = ACTIONS(2850),
    [anon_sym_LBRACE] = ACTIONS(2852),
    [anon_sym_signed] = ACTIONS(2850),
    [anon_sym_unsigned] = ACTIONS(2850),
    [anon_sym_long] = ACTIONS(2850),
    [anon_sym_short] = ACTIONS(2850),
    [anon_sym_LBRACK] = ACTIONS(2850),
    [anon_sym_static] = ACTIONS(2850),
    [anon_sym_register] = ACTIONS(2850),
    [anon_sym_inline] = ACTIONS(2850),
    [anon_sym___inline] = ACTIONS(2850),
    [anon_sym___inline__] = ACTIONS(2850),
    [anon_sym___forceinline] = ACTIONS(2850),
    [anon_sym_thread_local] = ACTIONS(2850),
    [anon_sym___thread] = ACTIONS(2850),
    [anon_sym_const] = ACTIONS(2850),
    [anon_sym_constexpr] = ACTIONS(2850),
    [anon_sym_volatile] = ACTIONS(2850),
    [anon_sym_restrict] = ACTIONS(2850),
    [anon_sym___restrict__] = ACTIONS(2850),
    [anon_sym__Atomic] = ACTIONS(2850),
    [anon_sym__Noreturn] = ACTIONS(2850),
    [anon_sym_noreturn] = ACTIONS(2850),
    [anon_sym__Nonnull] = ACTIONS(2850),
    [anon_sym_mutable] = ACTIONS(2850),
    [anon_sym_constinit] = ACTIONS(2850),
    [anon_sym_consteval] = ACTIONS(2850),
    [anon_sym_alignas] = ACTIONS(2850),
    [anon_sym__Alignas] = ACTIONS(2850),
    [sym_primitive_type] = ACTIONS(2850),
    [anon_sym_enum] = ACTIONS(2850),
    [anon_sym_class] = ACTIONS(2850),
    [anon_sym_struct] = ACTIONS(2850),
    [anon_sym_union] = ACTIONS(2850),
    [anon_sym_if] = ACTIONS(2850),
    [anon_sym_switch] = ACTIONS(2850),
    [anon_sym_case] = ACTIONS(2850),
    [anon_sym_default] = ACTIONS(2850),
    [anon_sym_while] = ACTIONS(2850),
    [anon_sym_do] = ACTIONS(2850),
    [anon_sym_for] = ACTIONS(2850),
    [anon_sym_return] = ACTIONS(2850),
    [anon_sym_break] = ACTIONS(2850),
    [anon_sym_continue] = ACTIONS(2850),
    [anon_sym_goto] = ACTIONS(2850),
    [anon_sym_not] = ACTIONS(2850),
    [anon_sym_compl] = ACTIONS(2850),
    [anon_sym_DASH_DASH] = ACTIONS(2852),
    [anon_sym_PLUS_PLUS] = ACTIONS(2852),
    [anon_sym_sizeof] = ACTIONS(2850),
    [anon_sym___alignof__] = ACTIONS(2850),
    [anon_sym___alignof] = ACTIONS(2850),
    [anon_sym__alignof] = ACTIONS(2850),
    [anon_sym_alignof] = ACTIONS(2850),
    [anon_sym__Alignof] = ACTIONS(2850),
    [anon_sym_offsetof] = ACTIONS(2850),
    [anon_sym__Generic] = ACTIONS(2850),
    [anon_sym_asm] = ACTIONS(2850),
    [anon_sym___asm__] = ACTIONS(2850),
    [anon_sym___asm] = ACTIONS(2850),
    [sym_number_literal] = ACTIONS(2852),
    [anon_sym_L_SQUOTE] = ACTIONS(2852),
    [anon_sym_u_SQUOTE] = ACTIONS(2852),
    [anon_sym_U_SQUOTE] = ACTIONS(2852),
    [anon_sym_u8_SQUOTE] = ACTIONS(2852),
    [anon_sym_SQUOTE] = ACTIONS(2852),
    [anon_sym_L_DQUOTE] = ACTIONS(2852),
    [anon_sym_u_DQUOTE] = ACTIONS(2852),
    [anon_sym_U_DQUOTE] = ACTIONS(2852),
    [anon_sym_u8_DQUOTE] = ACTIONS(2852),
    [anon_sym_DQUOTE] = ACTIONS(2852),
    [sym_true] = ACTIONS(2850),
    [sym_false] = ACTIONS(2850),
    [anon_sym_NULL] = ACTIONS(2850),
    [anon_sym_nullptr] = ACTIONS(2850),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2850),
    [anon_sym_decltype] = ACTIONS(2850),
    [anon_sym_explicit] = ACTIONS(2850),
    [anon_sym_typename] = ACTIONS(2850),
    [anon_sym_template] = ACTIONS(2850),
    [anon_sym_operator] = ACTIONS(2850),
    [anon_sym_try] = ACTIONS(2850),
    [anon_sym_delete] = ACTIONS(2850),
    [anon_sym_throw] = ACTIONS(2850),
    [anon_sym_namespace] = ACTIONS(2850),
    [anon_sym_using] = ACTIONS(2850),
    [anon_sym_static_assert] = ACTIONS(2850),
    [anon_sym_concept] = ACTIONS(2850),
    [anon_sym_co_return] = ACTIONS(2850),
    [anon_sym_co_yield] = ACTIONS(2850),
    [anon_sym_R_DQUOTE] = ACTIONS(2852),
    [anon_sym_LR_DQUOTE] = ACTIONS(2852),
    [anon_sym_uR_DQUOTE] = ACTIONS(2852),
    [anon_sym_UR_DQUOTE] = ACTIONS(2852),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2852),
    [anon_sym_co_await] = ACTIONS(2850),
    [anon_sym_new] = ACTIONS(2850),
    [anon_sym_requires] = ACTIONS(2850),
    [sym_this] = ACTIONS(2850),
  },
  [734] = {
    [ts_builtin_sym_end] = ACTIONS(2922),
    [sym_identifier] = ACTIONS(2920),
    [aux_sym_preproc_include_token1] = ACTIONS(2920),
    [aux_sym_preproc_def_token1] = ACTIONS(2920),
    [aux_sym_preproc_if_token1] = ACTIONS(2920),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2920),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2920),
    [sym_preproc_directive] = ACTIONS(2920),
    [anon_sym_LPAREN2] = ACTIONS(2922),
    [anon_sym_BANG] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2922),
    [anon_sym_DASH] = ACTIONS(2920),
    [anon_sym_PLUS] = ACTIONS(2920),
    [anon_sym_STAR] = ACTIONS(2922),
    [anon_sym_AMP_AMP] = ACTIONS(2922),
    [anon_sym_AMP] = ACTIONS(2920),
    [anon_sym_SEMI] = ACTIONS(2922),
    [anon_sym___extension__] = ACTIONS(2920),
    [anon_sym_typedef] = ACTIONS(2920),
    [anon_sym_virtual] = ACTIONS(2920),
    [anon_sym_extern] = ACTIONS(2920),
    [anon_sym___attribute__] = ACTIONS(2920),
    [anon_sym___attribute] = ACTIONS(2920),
    [anon_sym_COLON_COLON] = ACTIONS(2922),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2922),
    [anon_sym___declspec] = ACTIONS(2920),
    [anon_sym___based] = ACTIONS(2920),
    [anon_sym___cdecl] = ACTIONS(2920),
    [anon_sym___clrcall] = ACTIONS(2920),
    [anon_sym___stdcall] = ACTIONS(2920),
    [anon_sym___fastcall] = ACTIONS(2920),
    [anon_sym___thiscall] = ACTIONS(2920),
    [anon_sym___vectorcall] = ACTIONS(2920),
    [anon_sym_LBRACE] = ACTIONS(2922),
    [anon_sym_signed] = ACTIONS(2920),
    [anon_sym_unsigned] = ACTIONS(2920),
    [anon_sym_long] = ACTIONS(2920),
    [anon_sym_short] = ACTIONS(2920),
    [anon_sym_LBRACK] = ACTIONS(2920),
    [anon_sym_static] = ACTIONS(2920),
    [anon_sym_register] = ACTIONS(2920),
    [anon_sym_inline] = ACTIONS(2920),
    [anon_sym___inline] = ACTIONS(2920),
    [anon_sym___inline__] = ACTIONS(2920),
    [anon_sym___forceinline] = ACTIONS(2920),
    [anon_sym_thread_local] = ACTIONS(2920),
    [anon_sym___thread] = ACTIONS(2920),
    [anon_sym_const] = ACTIONS(2920),
    [anon_sym_constexpr] = ACTIONS(2920),
    [anon_sym_volatile] = ACTIONS(2920),
    [anon_sym_restrict] = ACTIONS(2920),
    [anon_sym___restrict__] = ACTIONS(2920),
    [anon_sym__Atomic] = ACTIONS(2920),
    [anon_sym__Noreturn] = ACTIONS(2920),
    [anon_sym_noreturn] = ACTIONS(2920),
    [anon_sym__Nonnull] = ACTIONS(2920),
    [anon_sym_mutable] = ACTIONS(2920),
    [anon_sym_constinit] = ACTIONS(2920),
    [anon_sym_consteval] = ACTIONS(2920),
    [anon_sym_alignas] = ACTIONS(2920),
    [anon_sym__Alignas] = ACTIONS(2920),
    [sym_primitive_type] = ACTIONS(2920),
    [anon_sym_enum] = ACTIONS(2920),
    [anon_sym_class] = ACTIONS(2920),
    [anon_sym_struct] = ACTIONS(2920),
    [anon_sym_union] = ACTIONS(2920),
    [anon_sym_if] = ACTIONS(2920),
    [anon_sym_switch] = ACTIONS(2920),
    [anon_sym_case] = ACTIONS(2920),
    [anon_sym_default] = ACTIONS(2920),
    [anon_sym_while] = ACTIONS(2920),
    [anon_sym_do] = ACTIONS(2920),
    [anon_sym_for] = ACTIONS(2920),
    [anon_sym_return] = ACTIONS(2920),
    [anon_sym_break] = ACTIONS(2920),
    [anon_sym_continue] = ACTIONS(2920),
    [anon_sym_goto] = ACTIONS(2920),
    [anon_sym_not] = ACTIONS(2920),
    [anon_sym_compl] = ACTIONS(2920),
    [anon_sym_DASH_DASH] = ACTIONS(2922),
    [anon_sym_PLUS_PLUS] = ACTIONS(2922),
    [anon_sym_sizeof] = ACTIONS(2920),
    [anon_sym___alignof__] = ACTIONS(2920),
    [anon_sym___alignof] = ACTIONS(2920),
    [anon_sym__alignof] = ACTIONS(2920),
    [anon_sym_alignof] = ACTIONS(2920),
    [anon_sym__Alignof] = ACTIONS(2920),
    [anon_sym_offsetof] = ACTIONS(2920),
    [anon_sym__Generic] = ACTIONS(2920),
    [anon_sym_asm] = ACTIONS(2920),
    [anon_sym___asm__] = ACTIONS(2920),
    [anon_sym___asm] = ACTIONS(2920),
    [sym_number_literal] = ACTIONS(2922),
    [anon_sym_L_SQUOTE] = ACTIONS(2922),
    [anon_sym_u_SQUOTE] = ACTIONS(2922),
    [anon_sym_U_SQUOTE] = ACTIONS(2922),
    [anon_sym_u8_SQUOTE] = ACTIONS(2922),
    [anon_sym_SQUOTE] = ACTIONS(2922),
    [anon_sym_L_DQUOTE] = ACTIONS(2922),
    [anon_sym_u_DQUOTE] = ACTIONS(2922),
    [anon_sym_U_DQUOTE] = ACTIONS(2922),
    [anon_sym_u8_DQUOTE] = ACTIONS(2922),
    [anon_sym_DQUOTE] = ACTIONS(2922),
    [sym_true] = ACTIONS(2920),
    [sym_false] = ACTIONS(2920),
    [anon_sym_NULL] = ACTIONS(2920),
    [anon_sym_nullptr] = ACTIONS(2920),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2920),
    [anon_sym_decltype] = ACTIONS(2920),
    [anon_sym_explicit] = ACTIONS(2920),
    [anon_sym_typename] = ACTIONS(2920),
    [anon_sym_template] = ACTIONS(2920),
    [anon_sym_operator] = ACTIONS(2920),
    [anon_sym_try] = ACTIONS(2920),
    [anon_sym_delete] = ACTIONS(2920),
    [anon_sym_throw] = ACTIONS(2920),
    [anon_sym_namespace] = ACTIONS(2920),
    [anon_sym_using] = ACTIONS(2920),
    [anon_sym_static_assert] = ACTIONS(2920),
    [anon_sym_concept] = ACTIONS(2920),
    [anon_sym_co_return] = ACTIONS(2920),
    [anon_sym_co_yield] = ACTIONS(2920),
    [anon_sym_R_DQUOTE] = ACTIONS(2922),
    [anon_sym_LR_DQUOTE] = ACTIONS(2922),
    [anon_sym_uR_DQUOTE] = ACTIONS(2922),
    [anon_sym_UR_DQUOTE] = ACTIONS(2922),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2922),
    [anon_sym_co_await] = ACTIONS(2920),
    [anon_sym_new] = ACTIONS(2920),
    [anon_sym_requires] = ACTIONS(2920),
    [sym_this] = ACTIONS(2920),
  },
  [735] = {
    [ts_builtin_sym_end] = ACTIONS(2926),
    [sym_identifier] = ACTIONS(2924),
    [aux_sym_preproc_include_token1] = ACTIONS(2924),
    [aux_sym_preproc_def_token1] = ACTIONS(2924),
    [aux_sym_preproc_if_token1] = ACTIONS(2924),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2924),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2924),
    [sym_preproc_directive] = ACTIONS(2924),
    [anon_sym_LPAREN2] = ACTIONS(2926),
    [anon_sym_BANG] = ACTIONS(2926),
    [anon_sym_TILDE] = ACTIONS(2926),
    [anon_sym_DASH] = ACTIONS(2924),
    [anon_sym_PLUS] = ACTIONS(2924),
    [anon_sym_STAR] = ACTIONS(2926),
    [anon_sym_AMP_AMP] = ACTIONS(2926),
    [anon_sym_AMP] = ACTIONS(2924),
    [anon_sym_SEMI] = ACTIONS(2926),
    [anon_sym___extension__] = ACTIONS(2924),
    [anon_sym_typedef] = ACTIONS(2924),
    [anon_sym_virtual] = ACTIONS(2924),
    [anon_sym_extern] = ACTIONS(2924),
    [anon_sym___attribute__] = ACTIONS(2924),
    [anon_sym___attribute] = ACTIONS(2924),
    [anon_sym_COLON_COLON] = ACTIONS(2926),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2926),
    [anon_sym___declspec] = ACTIONS(2924),
    [anon_sym___based] = ACTIONS(2924),
    [anon_sym___cdecl] = ACTIONS(2924),
    [anon_sym___clrcall] = ACTIONS(2924),
    [anon_sym___stdcall] = ACTIONS(2924),
    [anon_sym___fastcall] = ACTIONS(2924),
    [anon_sym___thiscall] = ACTIONS(2924),
    [anon_sym___vectorcall] = ACTIONS(2924),
    [anon_sym_LBRACE] = ACTIONS(2926),
    [anon_sym_signed] = ACTIONS(2924),
    [anon_sym_unsigned] = ACTIONS(2924),
    [anon_sym_long] = ACTIONS(2924),
    [anon_sym_short] = ACTIONS(2924),
    [anon_sym_LBRACK] = ACTIONS(2924),
    [anon_sym_static] = ACTIONS(2924),
    [anon_sym_register] = ACTIONS(2924),
    [anon_sym_inline] = ACTIONS(2924),
    [anon_sym___inline] = ACTIONS(2924),
    [anon_sym___inline__] = ACTIONS(2924),
    [anon_sym___forceinline] = ACTIONS(2924),
    [anon_sym_thread_local] = ACTIONS(2924),
    [anon_sym___thread] = ACTIONS(2924),
    [anon_sym_const] = ACTIONS(2924),
    [anon_sym_constexpr] = ACTIONS(2924),
    [anon_sym_volatile] = ACTIONS(2924),
    [anon_sym_restrict] = ACTIONS(2924),
    [anon_sym___restrict__] = ACTIONS(2924),
    [anon_sym__Atomic] = ACTIONS(2924),
    [anon_sym__Noreturn] = ACTIONS(2924),
    [anon_sym_noreturn] = ACTIONS(2924),
    [anon_sym__Nonnull] = ACTIONS(2924),
    [anon_sym_mutable] = ACTIONS(2924),
    [anon_sym_constinit] = ACTIONS(2924),
    [anon_sym_consteval] = ACTIONS(2924),
    [anon_sym_alignas] = ACTIONS(2924),
    [anon_sym__Alignas] = ACTIONS(2924),
    [sym_primitive_type] = ACTIONS(2924),
    [anon_sym_enum] = ACTIONS(2924),
    [anon_sym_class] = ACTIONS(2924),
    [anon_sym_struct] = ACTIONS(2924),
    [anon_sym_union] = ACTIONS(2924),
    [anon_sym_if] = ACTIONS(2924),
    [anon_sym_switch] = ACTIONS(2924),
    [anon_sym_case] = ACTIONS(2924),
    [anon_sym_default] = ACTIONS(2924),
    [anon_sym_while] = ACTIONS(2924),
    [anon_sym_do] = ACTIONS(2924),
    [anon_sym_for] = ACTIONS(2924),
    [anon_sym_return] = ACTIONS(2924),
    [anon_sym_break] = ACTIONS(2924),
    [anon_sym_continue] = ACTIONS(2924),
    [anon_sym_goto] = ACTIONS(2924),
    [anon_sym_not] = ACTIONS(2924),
    [anon_sym_compl] = ACTIONS(2924),
    [anon_sym_DASH_DASH] = ACTIONS(2926),
    [anon_sym_PLUS_PLUS] = ACTIONS(2926),
    [anon_sym_sizeof] = ACTIONS(2924),
    [anon_sym___alignof__] = ACTIONS(2924),
    [anon_sym___alignof] = ACTIONS(2924),
    [anon_sym__alignof] = ACTIONS(2924),
    [anon_sym_alignof] = ACTIONS(2924),
    [anon_sym__Alignof] = ACTIONS(2924),
    [anon_sym_offsetof] = ACTIONS(2924),
    [anon_sym__Generic] = ACTIONS(2924),
    [anon_sym_asm] = ACTIONS(2924),
    [anon_sym___asm__] = ACTIONS(2924),
    [anon_sym___asm] = ACTIONS(2924),
    [sym_number_literal] = ACTIONS(2926),
    [anon_sym_L_SQUOTE] = ACTIONS(2926),
    [anon_sym_u_SQUOTE] = ACTIONS(2926),
    [anon_sym_U_SQUOTE] = ACTIONS(2926),
    [anon_sym_u8_SQUOTE] = ACTIONS(2926),
    [anon_sym_SQUOTE] = ACTIONS(2926),
    [anon_sym_L_DQUOTE] = ACTIONS(2926),
    [anon_sym_u_DQUOTE] = ACTIONS(2926),
    [anon_sym_U_DQUOTE] = ACTIONS(2926),
    [anon_sym_u8_DQUOTE] = ACTIONS(2926),
    [anon_sym_DQUOTE] = ACTIONS(2926),
    [sym_true] = ACTIONS(2924),
    [sym_false] = ACTIONS(2924),
    [anon_sym_NULL] = ACTIONS(2924),
    [anon_sym_nullptr] = ACTIONS(2924),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2924),
    [anon_sym_decltype] = ACTIONS(2924),
    [anon_sym_explicit] = ACTIONS(2924),
    [anon_sym_typename] = ACTIONS(2924),
    [anon_sym_template] = ACTIONS(2924),
    [anon_sym_operator] = ACTIONS(2924),
    [anon_sym_try] = ACTIONS(2924),
    [anon_sym_delete] = ACTIONS(2924),
    [anon_sym_throw] = ACTIONS(2924),
    [anon_sym_namespace] = ACTIONS(2924),
    [anon_sym_using] = ACTIONS(2924),
    [anon_sym_static_assert] = ACTIONS(2924),
    [anon_sym_concept] = ACTIONS(2924),
    [anon_sym_co_return] = ACTIONS(2924),
    [anon_sym_co_yield] = ACTIONS(2924),
    [anon_sym_R_DQUOTE] = ACTIONS(2926),
    [anon_sym_LR_DQUOTE] = ACTIONS(2926),
    [anon_sym_uR_DQUOTE] = ACTIONS(2926),
    [anon_sym_UR_DQUOTE] = ACTIONS(2926),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2926),
    [anon_sym_co_await] = ACTIONS(2924),
    [anon_sym_new] = ACTIONS(2924),
    [anon_sym_requires] = ACTIONS(2924),
    [sym_this] = ACTIONS(2924),
  },
  [736] = {
    [ts_builtin_sym_end] = ACTIONS(2930),
    [sym_identifier] = ACTIONS(2928),
    [aux_sym_preproc_include_token1] = ACTIONS(2928),
    [aux_sym_preproc_def_token1] = ACTIONS(2928),
    [aux_sym_preproc_if_token1] = ACTIONS(2928),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2928),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2928),
    [sym_preproc_directive] = ACTIONS(2928),
    [anon_sym_LPAREN2] = ACTIONS(2930),
    [anon_sym_BANG] = ACTIONS(2930),
    [anon_sym_TILDE] = ACTIONS(2930),
    [anon_sym_DASH] = ACTIONS(2928),
    [anon_sym_PLUS] = ACTIONS(2928),
    [anon_sym_STAR] = ACTIONS(2930),
    [anon_sym_AMP_AMP] = ACTIONS(2930),
    [anon_sym_AMP] = ACTIONS(2928),
    [anon_sym_SEMI] = ACTIONS(2930),
    [anon_sym___extension__] = ACTIONS(2928),
    [anon_sym_typedef] = ACTIONS(2928),
    [anon_sym_virtual] = ACTIONS(2928),
    [anon_sym_extern] = ACTIONS(2928),
    [anon_sym___attribute__] = ACTIONS(2928),
    [anon_sym___attribute] = ACTIONS(2928),
    [anon_sym_COLON_COLON] = ACTIONS(2930),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2930),
    [anon_sym___declspec] = ACTIONS(2928),
    [anon_sym___based] = ACTIONS(2928),
    [anon_sym___cdecl] = ACTIONS(2928),
    [anon_sym___clrcall] = ACTIONS(2928),
    [anon_sym___stdcall] = ACTIONS(2928),
    [anon_sym___fastcall] = ACTIONS(2928),
    [anon_sym___thiscall] = ACTIONS(2928),
    [anon_sym___vectorcall] = ACTIONS(2928),
    [anon_sym_LBRACE] = ACTIONS(2930),
    [anon_sym_signed] = ACTIONS(2928),
    [anon_sym_unsigned] = ACTIONS(2928),
    [anon_sym_long] = ACTIONS(2928),
    [anon_sym_short] = ACTIONS(2928),
    [anon_sym_LBRACK] = ACTIONS(2928),
    [anon_sym_static] = ACTIONS(2928),
    [anon_sym_register] = ACTIONS(2928),
    [anon_sym_inline] = ACTIONS(2928),
    [anon_sym___inline] = ACTIONS(2928),
    [anon_sym___inline__] = ACTIONS(2928),
    [anon_sym___forceinline] = ACTIONS(2928),
    [anon_sym_thread_local] = ACTIONS(2928),
    [anon_sym___thread] = ACTIONS(2928),
    [anon_sym_const] = ACTIONS(2928),
    [anon_sym_constexpr] = ACTIONS(2928),
    [anon_sym_volatile] = ACTIONS(2928),
    [anon_sym_restrict] = ACTIONS(2928),
    [anon_sym___restrict__] = ACTIONS(2928),
    [anon_sym__Atomic] = ACTIONS(2928),
    [anon_sym__Noreturn] = ACTIONS(2928),
    [anon_sym_noreturn] = ACTIONS(2928),
    [anon_sym__Nonnull] = ACTIONS(2928),
    [anon_sym_mutable] = ACTIONS(2928),
    [anon_sym_constinit] = ACTIONS(2928),
    [anon_sym_consteval] = ACTIONS(2928),
    [anon_sym_alignas] = ACTIONS(2928),
    [anon_sym__Alignas] = ACTIONS(2928),
    [sym_primitive_type] = ACTIONS(2928),
    [anon_sym_enum] = ACTIONS(2928),
    [anon_sym_class] = ACTIONS(2928),
    [anon_sym_struct] = ACTIONS(2928),
    [anon_sym_union] = ACTIONS(2928),
    [anon_sym_if] = ACTIONS(2928),
    [anon_sym_switch] = ACTIONS(2928),
    [anon_sym_case] = ACTIONS(2928),
    [anon_sym_default] = ACTIONS(2928),
    [anon_sym_while] = ACTIONS(2928),
    [anon_sym_do] = ACTIONS(2928),
    [anon_sym_for] = ACTIONS(2928),
    [anon_sym_return] = ACTIONS(2928),
    [anon_sym_break] = ACTIONS(2928),
    [anon_sym_continue] = ACTIONS(2928),
    [anon_sym_goto] = ACTIONS(2928),
    [anon_sym_not] = ACTIONS(2928),
    [anon_sym_compl] = ACTIONS(2928),
    [anon_sym_DASH_DASH] = ACTIONS(2930),
    [anon_sym_PLUS_PLUS] = ACTIONS(2930),
    [anon_sym_sizeof] = ACTIONS(2928),
    [anon_sym___alignof__] = ACTIONS(2928),
    [anon_sym___alignof] = ACTIONS(2928),
    [anon_sym__alignof] = ACTIONS(2928),
    [anon_sym_alignof] = ACTIONS(2928),
    [anon_sym__Alignof] = ACTIONS(2928),
    [anon_sym_offsetof] = ACTIONS(2928),
    [anon_sym__Generic] = ACTIONS(2928),
    [anon_sym_asm] = ACTIONS(2928),
    [anon_sym___asm__] = ACTIONS(2928),
    [anon_sym___asm] = ACTIONS(2928),
    [sym_number_literal] = ACTIONS(2930),
    [anon_sym_L_SQUOTE] = ACTIONS(2930),
    [anon_sym_u_SQUOTE] = ACTIONS(2930),
    [anon_sym_U_SQUOTE] = ACTIONS(2930),
    [anon_sym_u8_SQUOTE] = ACTIONS(2930),
    [anon_sym_SQUOTE] = ACTIONS(2930),
    [anon_sym_L_DQUOTE] = ACTIONS(2930),
    [anon_sym_u_DQUOTE] = ACTIONS(2930),
    [anon_sym_U_DQUOTE] = ACTIONS(2930),
    [anon_sym_u8_DQUOTE] = ACTIONS(2930),
    [anon_sym_DQUOTE] = ACTIONS(2930),
    [sym_true] = ACTIONS(2928),
    [sym_false] = ACTIONS(2928),
    [anon_sym_NULL] = ACTIONS(2928),
    [anon_sym_nullptr] = ACTIONS(2928),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2928),
    [anon_sym_decltype] = ACTIONS(2928),
    [anon_sym_explicit] = ACTIONS(2928),
    [anon_sym_typename] = ACTIONS(2928),
    [anon_sym_template] = ACTIONS(2928),
    [anon_sym_operator] = ACTIONS(2928),
    [anon_sym_try] = ACTIONS(2928),
    [anon_sym_delete] = ACTIONS(2928),
    [anon_sym_throw] = ACTIONS(2928),
    [anon_sym_namespace] = ACTIONS(2928),
    [anon_sym_using] = ACTIONS(2928),
    [anon_sym_static_assert] = ACTIONS(2928),
    [anon_sym_concept] = ACTIONS(2928),
    [anon_sym_co_return] = ACTIONS(2928),
    [anon_sym_co_yield] = ACTIONS(2928),
    [anon_sym_R_DQUOTE] = ACTIONS(2930),
    [anon_sym_LR_DQUOTE] = ACTIONS(2930),
    [anon_sym_uR_DQUOTE] = ACTIONS(2930),
    [anon_sym_UR_DQUOTE] = ACTIONS(2930),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2930),
    [anon_sym_co_await] = ACTIONS(2928),
    [anon_sym_new] = ACTIONS(2928),
    [anon_sym_requires] = ACTIONS(2928),
    [sym_this] = ACTIONS(2928),
  },
  [737] = {
    [ts_builtin_sym_end] = ACTIONS(2761),
    [sym_identifier] = ACTIONS(2759),
    [aux_sym_preproc_include_token1] = ACTIONS(2759),
    [aux_sym_preproc_def_token1] = ACTIONS(2759),
    [aux_sym_preproc_if_token1] = ACTIONS(2759),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2759),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2759),
    [sym_preproc_directive] = ACTIONS(2759),
    [anon_sym_LPAREN2] = ACTIONS(2761),
    [anon_sym_BANG] = ACTIONS(2761),
    [anon_sym_TILDE] = ACTIONS(2761),
    [anon_sym_DASH] = ACTIONS(2759),
    [anon_sym_PLUS] = ACTIONS(2759),
    [anon_sym_STAR] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_AMP] = ACTIONS(2759),
    [anon_sym_SEMI] = ACTIONS(2761),
    [anon_sym___extension__] = ACTIONS(2759),
    [anon_sym_typedef] = ACTIONS(2759),
    [anon_sym_virtual] = ACTIONS(2759),
    [anon_sym_extern] = ACTIONS(2759),
    [anon_sym___attribute__] = ACTIONS(2759),
    [anon_sym___attribute] = ACTIONS(2759),
    [anon_sym_COLON_COLON] = ACTIONS(2761),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2761),
    [anon_sym___declspec] = ACTIONS(2759),
    [anon_sym___based] = ACTIONS(2759),
    [anon_sym___cdecl] = ACTIONS(2759),
    [anon_sym___clrcall] = ACTIONS(2759),
    [anon_sym___stdcall] = ACTIONS(2759),
    [anon_sym___fastcall] = ACTIONS(2759),
    [anon_sym___thiscall] = ACTIONS(2759),
    [anon_sym___vectorcall] = ACTIONS(2759),
    [anon_sym_LBRACE] = ACTIONS(2761),
    [anon_sym_signed] = ACTIONS(2759),
    [anon_sym_unsigned] = ACTIONS(2759),
    [anon_sym_long] = ACTIONS(2759),
    [anon_sym_short] = ACTIONS(2759),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_static] = ACTIONS(2759),
    [anon_sym_register] = ACTIONS(2759),
    [anon_sym_inline] = ACTIONS(2759),
    [anon_sym___inline] = ACTIONS(2759),
    [anon_sym___inline__] = ACTIONS(2759),
    [anon_sym___forceinline] = ACTIONS(2759),
    [anon_sym_thread_local] = ACTIONS(2759),
    [anon_sym___thread] = ACTIONS(2759),
    [anon_sym_const] = ACTIONS(2759),
    [anon_sym_constexpr] = ACTIONS(2759),
    [anon_sym_volatile] = ACTIONS(2759),
    [anon_sym_restrict] = ACTIONS(2759),
    [anon_sym___restrict__] = ACTIONS(2759),
    [anon_sym__Atomic] = ACTIONS(2759),
    [anon_sym__Noreturn] = ACTIONS(2759),
    [anon_sym_noreturn] = ACTIONS(2759),
    [anon_sym__Nonnull] = ACTIONS(2759),
    [anon_sym_mutable] = ACTIONS(2759),
    [anon_sym_constinit] = ACTIONS(2759),
    [anon_sym_consteval] = ACTIONS(2759),
    [anon_sym_alignas] = ACTIONS(2759),
    [anon_sym__Alignas] = ACTIONS(2759),
    [sym_primitive_type] = ACTIONS(2759),
    [anon_sym_enum] = ACTIONS(2759),
    [anon_sym_class] = ACTIONS(2759),
    [anon_sym_struct] = ACTIONS(2759),
    [anon_sym_union] = ACTIONS(2759),
    [anon_sym_if] = ACTIONS(2759),
    [anon_sym_switch] = ACTIONS(2759),
    [anon_sym_case] = ACTIONS(2759),
    [anon_sym_default] = ACTIONS(2759),
    [anon_sym_while] = ACTIONS(2759),
    [anon_sym_do] = ACTIONS(2759),
    [anon_sym_for] = ACTIONS(2759),
    [anon_sym_return] = ACTIONS(2759),
    [anon_sym_break] = ACTIONS(2759),
    [anon_sym_continue] = ACTIONS(2759),
    [anon_sym_goto] = ACTIONS(2759),
    [anon_sym_not] = ACTIONS(2759),
    [anon_sym_compl] = ACTIONS(2759),
    [anon_sym_DASH_DASH] = ACTIONS(2761),
    [anon_sym_PLUS_PLUS] = ACTIONS(2761),
    [anon_sym_sizeof] = ACTIONS(2759),
    [anon_sym___alignof__] = ACTIONS(2759),
    [anon_sym___alignof] = ACTIONS(2759),
    [anon_sym__alignof] = ACTIONS(2759),
    [anon_sym_alignof] = ACTIONS(2759),
    [anon_sym__Alignof] = ACTIONS(2759),
    [anon_sym_offsetof] = ACTIONS(2759),
    [anon_sym__Generic] = ACTIONS(2759),
    [anon_sym_asm] = ACTIONS(2759),
    [anon_sym___asm__] = ACTIONS(2759),
    [anon_sym___asm] = ACTIONS(2759),
    [sym_number_literal] = ACTIONS(2761),
    [anon_sym_L_SQUOTE] = ACTIONS(2761),
    [anon_sym_u_SQUOTE] = ACTIONS(2761),
    [anon_sym_U_SQUOTE] = ACTIONS(2761),
    [anon_sym_u8_SQUOTE] = ACTIONS(2761),
    [anon_sym_SQUOTE] = ACTIONS(2761),
    [anon_sym_L_DQUOTE] = ACTIONS(2761),
    [anon_sym_u_DQUOTE] = ACTIONS(2761),
    [anon_sym_U_DQUOTE] = ACTIONS(2761),
    [anon_sym_u8_DQUOTE] = ACTIONS(2761),
    [anon_sym_DQUOTE] = ACTIONS(2761),
    [sym_true] = ACTIONS(2759),
    [sym_false] = ACTIONS(2759),
    [anon_sym_NULL] = ACTIONS(2759),
    [anon_sym_nullptr] = ACTIONS(2759),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2759),
    [anon_sym_decltype] = ACTIONS(2759),
    [anon_sym_explicit] = ACTIONS(2759),
    [anon_sym_typename] = ACTIONS(2759),
    [anon_sym_template] = ACTIONS(2759),
    [anon_sym_operator] = ACTIONS(2759),
    [anon_sym_try] = ACTIONS(2759),
    [anon_sym_delete] = ACTIONS(2759),
    [anon_sym_throw] = ACTIONS(2759),
    [anon_sym_namespace] = ACTIONS(2759),
    [anon_sym_using] = ACTIONS(2759),
    [anon_sym_static_assert] = ACTIONS(2759),
    [anon_sym_concept] = ACTIONS(2759),
    [anon_sym_co_return] = ACTIONS(2759),
    [anon_sym_co_yield] = ACTIONS(2759),
    [anon_sym_R_DQUOTE] = ACTIONS(2761),
    [anon_sym_LR_DQUOTE] = ACTIONS(2761),
    [anon_sym_uR_DQUOTE] = ACTIONS(2761),
    [anon_sym_UR_DQUOTE] = ACTIONS(2761),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2761),
    [anon_sym_co_await] = ACTIONS(2759),
    [anon_sym_new] = ACTIONS(2759),
    [anon_sym_requires] = ACTIONS(2759),
    [sym_this] = ACTIONS(2759),
  },
  [738] = {
    [ts_builtin_sym_end] = ACTIONS(2773),
    [sym_identifier] = ACTIONS(2771),
    [aux_sym_preproc_include_token1] = ACTIONS(2771),
    [aux_sym_preproc_def_token1] = ACTIONS(2771),
    [aux_sym_preproc_if_token1] = ACTIONS(2771),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2771),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2771),
    [sym_preproc_directive] = ACTIONS(2771),
    [anon_sym_LPAREN2] = ACTIONS(2773),
    [anon_sym_BANG] = ACTIONS(2773),
    [anon_sym_TILDE] = ACTIONS(2773),
    [anon_sym_DASH] = ACTIONS(2771),
    [anon_sym_PLUS] = ACTIONS(2771),
    [anon_sym_STAR] = ACTIONS(2773),
    [anon_sym_AMP_AMP] = ACTIONS(2773),
    [anon_sym_AMP] = ACTIONS(2771),
    [anon_sym_SEMI] = ACTIONS(2773),
    [anon_sym___extension__] = ACTIONS(2771),
    [anon_sym_typedef] = ACTIONS(2771),
    [anon_sym_virtual] = ACTIONS(2771),
    [anon_sym_extern] = ACTIONS(2771),
    [anon_sym___attribute__] = ACTIONS(2771),
    [anon_sym___attribute] = ACTIONS(2771),
    [anon_sym_COLON_COLON] = ACTIONS(2773),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2773),
    [anon_sym___declspec] = ACTIONS(2771),
    [anon_sym___based] = ACTIONS(2771),
    [anon_sym___cdecl] = ACTIONS(2771),
    [anon_sym___clrcall] = ACTIONS(2771),
    [anon_sym___stdcall] = ACTIONS(2771),
    [anon_sym___fastcall] = ACTIONS(2771),
    [anon_sym___thiscall] = ACTIONS(2771),
    [anon_sym___vectorcall] = ACTIONS(2771),
    [anon_sym_LBRACE] = ACTIONS(2773),
    [anon_sym_signed] = ACTIONS(2771),
    [anon_sym_unsigned] = ACTIONS(2771),
    [anon_sym_long] = ACTIONS(2771),
    [anon_sym_short] = ACTIONS(2771),
    [anon_sym_LBRACK] = ACTIONS(2771),
    [anon_sym_static] = ACTIONS(2771),
    [anon_sym_register] = ACTIONS(2771),
    [anon_sym_inline] = ACTIONS(2771),
    [anon_sym___inline] = ACTIONS(2771),
    [anon_sym___inline__] = ACTIONS(2771),
    [anon_sym___forceinline] = ACTIONS(2771),
    [anon_sym_thread_local] = ACTIONS(2771),
    [anon_sym___thread] = ACTIONS(2771),
    [anon_sym_const] = ACTIONS(2771),
    [anon_sym_constexpr] = ACTIONS(2771),
    [anon_sym_volatile] = ACTIONS(2771),
    [anon_sym_restrict] = ACTIONS(2771),
    [anon_sym___restrict__] = ACTIONS(2771),
    [anon_sym__Atomic] = ACTIONS(2771),
    [anon_sym__Noreturn] = ACTIONS(2771),
    [anon_sym_noreturn] = ACTIONS(2771),
    [anon_sym__Nonnull] = ACTIONS(2771),
    [anon_sym_mutable] = ACTIONS(2771),
    [anon_sym_constinit] = ACTIONS(2771),
    [anon_sym_consteval] = ACTIONS(2771),
    [anon_sym_alignas] = ACTIONS(2771),
    [anon_sym__Alignas] = ACTIONS(2771),
    [sym_primitive_type] = ACTIONS(2771),
    [anon_sym_enum] = ACTIONS(2771),
    [anon_sym_class] = ACTIONS(2771),
    [anon_sym_struct] = ACTIONS(2771),
    [anon_sym_union] = ACTIONS(2771),
    [anon_sym_if] = ACTIONS(2771),
    [anon_sym_switch] = ACTIONS(2771),
    [anon_sym_case] = ACTIONS(2771),
    [anon_sym_default] = ACTIONS(2771),
    [anon_sym_while] = ACTIONS(2771),
    [anon_sym_do] = ACTIONS(2771),
    [anon_sym_for] = ACTIONS(2771),
    [anon_sym_return] = ACTIONS(2771),
    [anon_sym_break] = ACTIONS(2771),
    [anon_sym_continue] = ACTIONS(2771),
    [anon_sym_goto] = ACTIONS(2771),
    [anon_sym_not] = ACTIONS(2771),
    [anon_sym_compl] = ACTIONS(2771),
    [anon_sym_DASH_DASH] = ACTIONS(2773),
    [anon_sym_PLUS_PLUS] = ACTIONS(2773),
    [anon_sym_sizeof] = ACTIONS(2771),
    [anon_sym___alignof__] = ACTIONS(2771),
    [anon_sym___alignof] = ACTIONS(2771),
    [anon_sym__alignof] = ACTIONS(2771),
    [anon_sym_alignof] = ACTIONS(2771),
    [anon_sym__Alignof] = ACTIONS(2771),
    [anon_sym_offsetof] = ACTIONS(2771),
    [anon_sym__Generic] = ACTIONS(2771),
    [anon_sym_asm] = ACTIONS(2771),
    [anon_sym___asm__] = ACTIONS(2771),
    [anon_sym___asm] = ACTIONS(2771),
    [sym_number_literal] = ACTIONS(2773),
    [anon_sym_L_SQUOTE] = ACTIONS(2773),
    [anon_sym_u_SQUOTE] = ACTIONS(2773),
    [anon_sym_U_SQUOTE] = ACTIONS(2773),
    [anon_sym_u8_SQUOTE] = ACTIONS(2773),
    [anon_sym_SQUOTE] = ACTIONS(2773),
    [anon_sym_L_DQUOTE] = ACTIONS(2773),
    [anon_sym_u_DQUOTE] = ACTIONS(2773),
    [anon_sym_U_DQUOTE] = ACTIONS(2773),
    [anon_sym_u8_DQUOTE] = ACTIONS(2773),
    [anon_sym_DQUOTE] = ACTIONS(2773),
    [sym_true] = ACTIONS(2771),
    [sym_false] = ACTIONS(2771),
    [anon_sym_NULL] = ACTIONS(2771),
    [anon_sym_nullptr] = ACTIONS(2771),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2771),
    [anon_sym_decltype] = ACTIONS(2771),
    [anon_sym_explicit] = ACTIONS(2771),
    [anon_sym_typename] = ACTIONS(2771),
    [anon_sym_template] = ACTIONS(2771),
    [anon_sym_operator] = ACTIONS(2771),
    [anon_sym_try] = ACTIONS(2771),
    [anon_sym_delete] = ACTIONS(2771),
    [anon_sym_throw] = ACTIONS(2771),
    [anon_sym_namespace] = ACTIONS(2771),
    [anon_sym_using] = ACTIONS(2771),
    [anon_sym_static_assert] = ACTIONS(2771),
    [anon_sym_concept] = ACTIONS(2771),
    [anon_sym_co_return] = ACTIONS(2771),
    [anon_sym_co_yield] = ACTIONS(2771),
    [anon_sym_R_DQUOTE] = ACTIONS(2773),
    [anon_sym_LR_DQUOTE] = ACTIONS(2773),
    [anon_sym_uR_DQUOTE] = ACTIONS(2773),
    [anon_sym_UR_DQUOTE] = ACTIONS(2773),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2773),
    [anon_sym_co_await] = ACTIONS(2771),
    [anon_sym_new] = ACTIONS(2771),
    [anon_sym_requires] = ACTIONS(2771),
    [sym_this] = ACTIONS(2771),
  },
  [739] = {
    [ts_builtin_sym_end] = ACTIONS(2934),
    [sym_identifier] = ACTIONS(2932),
    [aux_sym_preproc_include_token1] = ACTIONS(2932),
    [aux_sym_preproc_def_token1] = ACTIONS(2932),
    [aux_sym_preproc_if_token1] = ACTIONS(2932),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2932),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2932),
    [sym_preproc_directive] = ACTIONS(2932),
    [anon_sym_LPAREN2] = ACTIONS(2934),
    [anon_sym_BANG] = ACTIONS(2934),
    [anon_sym_TILDE] = ACTIONS(2934),
    [anon_sym_DASH] = ACTIONS(2932),
    [anon_sym_PLUS] = ACTIONS(2932),
    [anon_sym_STAR] = ACTIONS(2934),
    [anon_sym_AMP_AMP] = ACTIONS(2934),
    [anon_sym_AMP] = ACTIONS(2932),
    [anon_sym_SEMI] = ACTIONS(2934),
    [anon_sym___extension__] = ACTIONS(2932),
    [anon_sym_typedef] = ACTIONS(2932),
    [anon_sym_virtual] = ACTIONS(2932),
    [anon_sym_extern] = ACTIONS(2932),
    [anon_sym___attribute__] = ACTIONS(2932),
    [anon_sym___attribute] = ACTIONS(2932),
    [anon_sym_COLON_COLON] = ACTIONS(2934),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2934),
    [anon_sym___declspec] = ACTIONS(2932),
    [anon_sym___based] = ACTIONS(2932),
    [anon_sym___cdecl] = ACTIONS(2932),
    [anon_sym___clrcall] = ACTIONS(2932),
    [anon_sym___stdcall] = ACTIONS(2932),
    [anon_sym___fastcall] = ACTIONS(2932),
    [anon_sym___thiscall] = ACTIONS(2932),
    [anon_sym___vectorcall] = ACTIONS(2932),
    [anon_sym_LBRACE] = ACTIONS(2934),
    [anon_sym_signed] = ACTIONS(2932),
    [anon_sym_unsigned] = ACTIONS(2932),
    [anon_sym_long] = ACTIONS(2932),
    [anon_sym_short] = ACTIONS(2932),
    [anon_sym_LBRACK] = ACTIONS(2932),
    [anon_sym_static] = ACTIONS(2932),
    [anon_sym_register] = ACTIONS(2932),
    [anon_sym_inline] = ACTIONS(2932),
    [anon_sym___inline] = ACTIONS(2932),
    [anon_sym___inline__] = ACTIONS(2932),
    [anon_sym___forceinline] = ACTIONS(2932),
    [anon_sym_thread_local] = ACTIONS(2932),
    [anon_sym___thread] = ACTIONS(2932),
    [anon_sym_const] = ACTIONS(2932),
    [anon_sym_constexpr] = ACTIONS(2932),
    [anon_sym_volatile] = ACTIONS(2932),
    [anon_sym_restrict] = ACTIONS(2932),
    [anon_sym___restrict__] = ACTIONS(2932),
    [anon_sym__Atomic] = ACTIONS(2932),
    [anon_sym__Noreturn] = ACTIONS(2932),
    [anon_sym_noreturn] = ACTIONS(2932),
    [anon_sym__Nonnull] = ACTIONS(2932),
    [anon_sym_mutable] = ACTIONS(2932),
    [anon_sym_constinit] = ACTIONS(2932),
    [anon_sym_consteval] = ACTIONS(2932),
    [anon_sym_alignas] = ACTIONS(2932),
    [anon_sym__Alignas] = ACTIONS(2932),
    [sym_primitive_type] = ACTIONS(2932),
    [anon_sym_enum] = ACTIONS(2932),
    [anon_sym_class] = ACTIONS(2932),
    [anon_sym_struct] = ACTIONS(2932),
    [anon_sym_union] = ACTIONS(2932),
    [anon_sym_if] = ACTIONS(2932),
    [anon_sym_switch] = ACTIONS(2932),
    [anon_sym_case] = ACTIONS(2932),
    [anon_sym_default] = ACTIONS(2932),
    [anon_sym_while] = ACTIONS(2932),
    [anon_sym_do] = ACTIONS(2932),
    [anon_sym_for] = ACTIONS(2932),
    [anon_sym_return] = ACTIONS(2932),
    [anon_sym_break] = ACTIONS(2932),
    [anon_sym_continue] = ACTIONS(2932),
    [anon_sym_goto] = ACTIONS(2932),
    [anon_sym_not] = ACTIONS(2932),
    [anon_sym_compl] = ACTIONS(2932),
    [anon_sym_DASH_DASH] = ACTIONS(2934),
    [anon_sym_PLUS_PLUS] = ACTIONS(2934),
    [anon_sym_sizeof] = ACTIONS(2932),
    [anon_sym___alignof__] = ACTIONS(2932),
    [anon_sym___alignof] = ACTIONS(2932),
    [anon_sym__alignof] = ACTIONS(2932),
    [anon_sym_alignof] = ACTIONS(2932),
    [anon_sym__Alignof] = ACTIONS(2932),
    [anon_sym_offsetof] = ACTIONS(2932),
    [anon_sym__Generic] = ACTIONS(2932),
    [anon_sym_asm] = ACTIONS(2932),
    [anon_sym___asm__] = ACTIONS(2932),
    [anon_sym___asm] = ACTIONS(2932),
    [sym_number_literal] = ACTIONS(2934),
    [anon_sym_L_SQUOTE] = ACTIONS(2934),
    [anon_sym_u_SQUOTE] = ACTIONS(2934),
    [anon_sym_U_SQUOTE] = ACTIONS(2934),
    [anon_sym_u8_SQUOTE] = ACTIONS(2934),
    [anon_sym_SQUOTE] = ACTIONS(2934),
    [anon_sym_L_DQUOTE] = ACTIONS(2934),
    [anon_sym_u_DQUOTE] = ACTIONS(2934),
    [anon_sym_U_DQUOTE] = ACTIONS(2934),
    [anon_sym_u8_DQUOTE] = ACTIONS(2934),
    [anon_sym_DQUOTE] = ACTIONS(2934),
    [sym_true] = ACTIONS(2932),
    [sym_false] = ACTIONS(2932),
    [anon_sym_NULL] = ACTIONS(2932),
    [anon_sym_nullptr] = ACTIONS(2932),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2932),
    [anon_sym_decltype] = ACTIONS(2932),
    [anon_sym_explicit] = ACTIONS(2932),
    [anon_sym_typename] = ACTIONS(2932),
    [anon_sym_template] = ACTIONS(2932),
    [anon_sym_operator] = ACTIONS(2932),
    [anon_sym_try] = ACTIONS(2932),
    [anon_sym_delete] = ACTIONS(2932),
    [anon_sym_throw] = ACTIONS(2932),
    [anon_sym_namespace] = ACTIONS(2932),
    [anon_sym_using] = ACTIONS(2932),
    [anon_sym_static_assert] = ACTIONS(2932),
    [anon_sym_concept] = ACTIONS(2932),
    [anon_sym_co_return] = ACTIONS(2932),
    [anon_sym_co_yield] = ACTIONS(2932),
    [anon_sym_R_DQUOTE] = ACTIONS(2934),
    [anon_sym_LR_DQUOTE] = ACTIONS(2934),
    [anon_sym_uR_DQUOTE] = ACTIONS(2934),
    [anon_sym_UR_DQUOTE] = ACTIONS(2934),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2934),
    [anon_sym_co_await] = ACTIONS(2932),
    [anon_sym_new] = ACTIONS(2932),
    [anon_sym_requires] = ACTIONS(2932),
    [sym_this] = ACTIONS(2932),
  },
  [740] = {
    [ts_builtin_sym_end] = ACTIONS(2938),
    [sym_identifier] = ACTIONS(2936),
    [aux_sym_preproc_include_token1] = ACTIONS(2936),
    [aux_sym_preproc_def_token1] = ACTIONS(2936),
    [aux_sym_preproc_if_token1] = ACTIONS(2936),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2936),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2936),
    [sym_preproc_directive] = ACTIONS(2936),
    [anon_sym_LPAREN2] = ACTIONS(2938),
    [anon_sym_BANG] = ACTIONS(2938),
    [anon_sym_TILDE] = ACTIONS(2938),
    [anon_sym_DASH] = ACTIONS(2936),
    [anon_sym_PLUS] = ACTIONS(2936),
    [anon_sym_STAR] = ACTIONS(2938),
    [anon_sym_AMP_AMP] = ACTIONS(2938),
    [anon_sym_AMP] = ACTIONS(2936),
    [anon_sym_SEMI] = ACTIONS(2938),
    [anon_sym___extension__] = ACTIONS(2936),
    [anon_sym_typedef] = ACTIONS(2936),
    [anon_sym_virtual] = ACTIONS(2936),
    [anon_sym_extern] = ACTIONS(2936),
    [anon_sym___attribute__] = ACTIONS(2936),
    [anon_sym___attribute] = ACTIONS(2936),
    [anon_sym_COLON_COLON] = ACTIONS(2938),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2938),
    [anon_sym___declspec] = ACTIONS(2936),
    [anon_sym___based] = ACTIONS(2936),
    [anon_sym___cdecl] = ACTIONS(2936),
    [anon_sym___clrcall] = ACTIONS(2936),
    [anon_sym___stdcall] = ACTIONS(2936),
    [anon_sym___fastcall] = ACTIONS(2936),
    [anon_sym___thiscall] = ACTIONS(2936),
    [anon_sym___vectorcall] = ACTIONS(2936),
    [anon_sym_LBRACE] = ACTIONS(2938),
    [anon_sym_signed] = ACTIONS(2936),
    [anon_sym_unsigned] = ACTIONS(2936),
    [anon_sym_long] = ACTIONS(2936),
    [anon_sym_short] = ACTIONS(2936),
    [anon_sym_LBRACK] = ACTIONS(2936),
    [anon_sym_static] = ACTIONS(2936),
    [anon_sym_register] = ACTIONS(2936),
    [anon_sym_inline] = ACTIONS(2936),
    [anon_sym___inline] = ACTIONS(2936),
    [anon_sym___inline__] = ACTIONS(2936),
    [anon_sym___forceinline] = ACTIONS(2936),
    [anon_sym_thread_local] = ACTIONS(2936),
    [anon_sym___thread] = ACTIONS(2936),
    [anon_sym_const] = ACTIONS(2936),
    [anon_sym_constexpr] = ACTIONS(2936),
    [anon_sym_volatile] = ACTIONS(2936),
    [anon_sym_restrict] = ACTIONS(2936),
    [anon_sym___restrict__] = ACTIONS(2936),
    [anon_sym__Atomic] = ACTIONS(2936),
    [anon_sym__Noreturn] = ACTIONS(2936),
    [anon_sym_noreturn] = ACTIONS(2936),
    [anon_sym__Nonnull] = ACTIONS(2936),
    [anon_sym_mutable] = ACTIONS(2936),
    [anon_sym_constinit] = ACTIONS(2936),
    [anon_sym_consteval] = ACTIONS(2936),
    [anon_sym_alignas] = ACTIONS(2936),
    [anon_sym__Alignas] = ACTIONS(2936),
    [sym_primitive_type] = ACTIONS(2936),
    [anon_sym_enum] = ACTIONS(2936),
    [anon_sym_class] = ACTIONS(2936),
    [anon_sym_struct] = ACTIONS(2936),
    [anon_sym_union] = ACTIONS(2936),
    [anon_sym_if] = ACTIONS(2936),
    [anon_sym_switch] = ACTIONS(2936),
    [anon_sym_case] = ACTIONS(2936),
    [anon_sym_default] = ACTIONS(2936),
    [anon_sym_while] = ACTIONS(2936),
    [anon_sym_do] = ACTIONS(2936),
    [anon_sym_for] = ACTIONS(2936),
    [anon_sym_return] = ACTIONS(2936),
    [anon_sym_break] = ACTIONS(2936),
    [anon_sym_continue] = ACTIONS(2936),
    [anon_sym_goto] = ACTIONS(2936),
    [anon_sym_not] = ACTIONS(2936),
    [anon_sym_compl] = ACTIONS(2936),
    [anon_sym_DASH_DASH] = ACTIONS(2938),
    [anon_sym_PLUS_PLUS] = ACTIONS(2938),
    [anon_sym_sizeof] = ACTIONS(2936),
    [anon_sym___alignof__] = ACTIONS(2936),
    [anon_sym___alignof] = ACTIONS(2936),
    [anon_sym__alignof] = ACTIONS(2936),
    [anon_sym_alignof] = ACTIONS(2936),
    [anon_sym__Alignof] = ACTIONS(2936),
    [anon_sym_offsetof] = ACTIONS(2936),
    [anon_sym__Generic] = ACTIONS(2936),
    [anon_sym_asm] = ACTIONS(2936),
    [anon_sym___asm__] = ACTIONS(2936),
    [anon_sym___asm] = ACTIONS(2936),
    [sym_number_literal] = ACTIONS(2938),
    [anon_sym_L_SQUOTE] = ACTIONS(2938),
    [anon_sym_u_SQUOTE] = ACTIONS(2938),
    [anon_sym_U_SQUOTE] = ACTIONS(2938),
    [anon_sym_u8_SQUOTE] = ACTIONS(2938),
    [anon_sym_SQUOTE] = ACTIONS(2938),
    [anon_sym_L_DQUOTE] = ACTIONS(2938),
    [anon_sym_u_DQUOTE] = ACTIONS(2938),
    [anon_sym_U_DQUOTE] = ACTIONS(2938),
    [anon_sym_u8_DQUOTE] = ACTIONS(2938),
    [anon_sym_DQUOTE] = ACTIONS(2938),
    [sym_true] = ACTIONS(2936),
    [sym_false] = ACTIONS(2936),
    [anon_sym_NULL] = ACTIONS(2936),
    [anon_sym_nullptr] = ACTIONS(2936),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2936),
    [anon_sym_decltype] = ACTIONS(2936),
    [anon_sym_explicit] = ACTIONS(2936),
    [anon_sym_typename] = ACTIONS(2936),
    [anon_sym_template] = ACTIONS(2936),
    [anon_sym_operator] = ACTIONS(2936),
    [anon_sym_try] = ACTIONS(2936),
    [anon_sym_delete] = ACTIONS(2936),
    [anon_sym_throw] = ACTIONS(2936),
    [anon_sym_namespace] = ACTIONS(2936),
    [anon_sym_using] = ACTIONS(2936),
    [anon_sym_static_assert] = ACTIONS(2936),
    [anon_sym_concept] = ACTIONS(2936),
    [anon_sym_co_return] = ACTIONS(2936),
    [anon_sym_co_yield] = ACTIONS(2936),
    [anon_sym_R_DQUOTE] = ACTIONS(2938),
    [anon_sym_LR_DQUOTE] = ACTIONS(2938),
    [anon_sym_uR_DQUOTE] = ACTIONS(2938),
    [anon_sym_UR_DQUOTE] = ACTIONS(2938),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2938),
    [anon_sym_co_await] = ACTIONS(2936),
    [anon_sym_new] = ACTIONS(2936),
    [anon_sym_requires] = ACTIONS(2936),
    [sym_this] = ACTIONS(2936),
  },
  [741] = {
    [ts_builtin_sym_end] = ACTIONS(2729),
    [sym_identifier] = ACTIONS(2727),
    [aux_sym_preproc_include_token1] = ACTIONS(2727),
    [aux_sym_preproc_def_token1] = ACTIONS(2727),
    [aux_sym_preproc_if_token1] = ACTIONS(2727),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2727),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2727),
    [sym_preproc_directive] = ACTIONS(2727),
    [anon_sym_LPAREN2] = ACTIONS(2729),
    [anon_sym_BANG] = ACTIONS(2729),
    [anon_sym_TILDE] = ACTIONS(2729),
    [anon_sym_DASH] = ACTIONS(2727),
    [anon_sym_PLUS] = ACTIONS(2727),
    [anon_sym_STAR] = ACTIONS(2729),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_AMP] = ACTIONS(2727),
    [anon_sym_SEMI] = ACTIONS(2729),
    [anon_sym___extension__] = ACTIONS(2727),
    [anon_sym_typedef] = ACTIONS(2727),
    [anon_sym_virtual] = ACTIONS(2727),
    [anon_sym_extern] = ACTIONS(2727),
    [anon_sym___attribute__] = ACTIONS(2727),
    [anon_sym___attribute] = ACTIONS(2727),
    [anon_sym_COLON_COLON] = ACTIONS(2729),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2729),
    [anon_sym___declspec] = ACTIONS(2727),
    [anon_sym___based] = ACTIONS(2727),
    [anon_sym___cdecl] = ACTIONS(2727),
    [anon_sym___clrcall] = ACTIONS(2727),
    [anon_sym___stdcall] = ACTIONS(2727),
    [anon_sym___fastcall] = ACTIONS(2727),
    [anon_sym___thiscall] = ACTIONS(2727),
    [anon_sym___vectorcall] = ACTIONS(2727),
    [anon_sym_LBRACE] = ACTIONS(2729),
    [anon_sym_signed] = ACTIONS(2727),
    [anon_sym_unsigned] = ACTIONS(2727),
    [anon_sym_long] = ACTIONS(2727),
    [anon_sym_short] = ACTIONS(2727),
    [anon_sym_LBRACK] = ACTIONS(2727),
    [anon_sym_static] = ACTIONS(2727),
    [anon_sym_register] = ACTIONS(2727),
    [anon_sym_inline] = ACTIONS(2727),
    [anon_sym___inline] = ACTIONS(2727),
    [anon_sym___inline__] = ACTIONS(2727),
    [anon_sym___forceinline] = ACTIONS(2727),
    [anon_sym_thread_local] = ACTIONS(2727),
    [anon_sym___thread] = ACTIONS(2727),
    [anon_sym_const] = ACTIONS(2727),
    [anon_sym_constexpr] = ACTIONS(2727),
    [anon_sym_volatile] = ACTIONS(2727),
    [anon_sym_restrict] = ACTIONS(2727),
    [anon_sym___restrict__] = ACTIONS(2727),
    [anon_sym__Atomic] = ACTIONS(2727),
    [anon_sym__Noreturn] = ACTIONS(2727),
    [anon_sym_noreturn] = ACTIONS(2727),
    [anon_sym__Nonnull] = ACTIONS(2727),
    [anon_sym_mutable] = ACTIONS(2727),
    [anon_sym_constinit] = ACTIONS(2727),
    [anon_sym_consteval] = ACTIONS(2727),
    [anon_sym_alignas] = ACTIONS(2727),
    [anon_sym__Alignas] = ACTIONS(2727),
    [sym_primitive_type] = ACTIONS(2727),
    [anon_sym_enum] = ACTIONS(2727),
    [anon_sym_class] = ACTIONS(2727),
    [anon_sym_struct] = ACTIONS(2727),
    [anon_sym_union] = ACTIONS(2727),
    [anon_sym_if] = ACTIONS(2727),
    [anon_sym_switch] = ACTIONS(2727),
    [anon_sym_case] = ACTIONS(2727),
    [anon_sym_default] = ACTIONS(2727),
    [anon_sym_while] = ACTIONS(2727),
    [anon_sym_do] = ACTIONS(2727),
    [anon_sym_for] = ACTIONS(2727),
    [anon_sym_return] = ACTIONS(2727),
    [anon_sym_break] = ACTIONS(2727),
    [anon_sym_continue] = ACTIONS(2727),
    [anon_sym_goto] = ACTIONS(2727),
    [anon_sym_not] = ACTIONS(2727),
    [anon_sym_compl] = ACTIONS(2727),
    [anon_sym_DASH_DASH] = ACTIONS(2729),
    [anon_sym_PLUS_PLUS] = ACTIONS(2729),
    [anon_sym_sizeof] = ACTIONS(2727),
    [anon_sym___alignof__] = ACTIONS(2727),
    [anon_sym___alignof] = ACTIONS(2727),
    [anon_sym__alignof] = ACTIONS(2727),
    [anon_sym_alignof] = ACTIONS(2727),
    [anon_sym__Alignof] = ACTIONS(2727),
    [anon_sym_offsetof] = ACTIONS(2727),
    [anon_sym__Generic] = ACTIONS(2727),
    [anon_sym_asm] = ACTIONS(2727),
    [anon_sym___asm__] = ACTIONS(2727),
    [anon_sym___asm] = ACTIONS(2727),
    [sym_number_literal] = ACTIONS(2729),
    [anon_sym_L_SQUOTE] = ACTIONS(2729),
    [anon_sym_u_SQUOTE] = ACTIONS(2729),
    [anon_sym_U_SQUOTE] = ACTIONS(2729),
    [anon_sym_u8_SQUOTE] = ACTIONS(2729),
    [anon_sym_SQUOTE] = ACTIONS(2729),
    [anon_sym_L_DQUOTE] = ACTIONS(2729),
    [anon_sym_u_DQUOTE] = ACTIONS(2729),
    [anon_sym_U_DQUOTE] = ACTIONS(2729),
    [anon_sym_u8_DQUOTE] = ACTIONS(2729),
    [anon_sym_DQUOTE] = ACTIONS(2729),
    [sym_true] = ACTIONS(2727),
    [sym_false] = ACTIONS(2727),
    [anon_sym_NULL] = ACTIONS(2727),
    [anon_sym_nullptr] = ACTIONS(2727),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2727),
    [anon_sym_decltype] = ACTIONS(2727),
    [anon_sym_explicit] = ACTIONS(2727),
    [anon_sym_typename] = ACTIONS(2727),
    [anon_sym_template] = ACTIONS(2727),
    [anon_sym_operator] = ACTIONS(2727),
    [anon_sym_try] = ACTIONS(2727),
    [anon_sym_delete] = ACTIONS(2727),
    [anon_sym_throw] = ACTIONS(2727),
    [anon_sym_namespace] = ACTIONS(2727),
    [anon_sym_using] = ACTIONS(2727),
    [anon_sym_static_assert] = ACTIONS(2727),
    [anon_sym_concept] = ACTIONS(2727),
    [anon_sym_co_return] = ACTIONS(2727),
    [anon_sym_co_yield] = ACTIONS(2727),
    [anon_sym_R_DQUOTE] = ACTIONS(2729),
    [anon_sym_LR_DQUOTE] = ACTIONS(2729),
    [anon_sym_uR_DQUOTE] = ACTIONS(2729),
    [anon_sym_UR_DQUOTE] = ACTIONS(2729),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2729),
    [anon_sym_co_await] = ACTIONS(2727),
    [anon_sym_new] = ACTIONS(2727),
    [anon_sym_requires] = ACTIONS(2727),
    [sym_this] = ACTIONS(2727),
  },
  [742] = {
    [ts_builtin_sym_end] = ACTIONS(2970),
    [sym_identifier] = ACTIONS(2968),
    [aux_sym_preproc_include_token1] = ACTIONS(2968),
    [aux_sym_preproc_def_token1] = ACTIONS(2968),
    [aux_sym_preproc_if_token1] = ACTIONS(2968),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2968),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2968),
    [sym_preproc_directive] = ACTIONS(2968),
    [anon_sym_LPAREN2] = ACTIONS(2970),
    [anon_sym_BANG] = ACTIONS(2970),
    [anon_sym_TILDE] = ACTIONS(2970),
    [anon_sym_DASH] = ACTIONS(2968),
    [anon_sym_PLUS] = ACTIONS(2968),
    [anon_sym_STAR] = ACTIONS(2970),
    [anon_sym_AMP_AMP] = ACTIONS(2970),
    [anon_sym_AMP] = ACTIONS(2968),
    [anon_sym_SEMI] = ACTIONS(2970),
    [anon_sym___extension__] = ACTIONS(2968),
    [anon_sym_typedef] = ACTIONS(2968),
    [anon_sym_virtual] = ACTIONS(2968),
    [anon_sym_extern] = ACTIONS(2968),
    [anon_sym___attribute__] = ACTIONS(2968),
    [anon_sym___attribute] = ACTIONS(2968),
    [anon_sym_COLON_COLON] = ACTIONS(2970),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2970),
    [anon_sym___declspec] = ACTIONS(2968),
    [anon_sym___based] = ACTIONS(2968),
    [anon_sym___cdecl] = ACTIONS(2968),
    [anon_sym___clrcall] = ACTIONS(2968),
    [anon_sym___stdcall] = ACTIONS(2968),
    [anon_sym___fastcall] = ACTIONS(2968),
    [anon_sym___thiscall] = ACTIONS(2968),
    [anon_sym___vectorcall] = ACTIONS(2968),
    [anon_sym_LBRACE] = ACTIONS(2970),
    [anon_sym_signed] = ACTIONS(2968),
    [anon_sym_unsigned] = ACTIONS(2968),
    [anon_sym_long] = ACTIONS(2968),
    [anon_sym_short] = ACTIONS(2968),
    [anon_sym_LBRACK] = ACTIONS(2968),
    [anon_sym_static] = ACTIONS(2968),
    [anon_sym_register] = ACTIONS(2968),
    [anon_sym_inline] = ACTIONS(2968),
    [anon_sym___inline] = ACTIONS(2968),
    [anon_sym___inline__] = ACTIONS(2968),
    [anon_sym___forceinline] = ACTIONS(2968),
    [anon_sym_thread_local] = ACTIONS(2968),
    [anon_sym___thread] = ACTIONS(2968),
    [anon_sym_const] = ACTIONS(2968),
    [anon_sym_constexpr] = ACTIONS(2968),
    [anon_sym_volatile] = ACTIONS(2968),
    [anon_sym_restrict] = ACTIONS(2968),
    [anon_sym___restrict__] = ACTIONS(2968),
    [anon_sym__Atomic] = ACTIONS(2968),
    [anon_sym__Noreturn] = ACTIONS(2968),
    [anon_sym_noreturn] = ACTIONS(2968),
    [anon_sym__Nonnull] = ACTIONS(2968),
    [anon_sym_mutable] = ACTIONS(2968),
    [anon_sym_constinit] = ACTIONS(2968),
    [anon_sym_consteval] = ACTIONS(2968),
    [anon_sym_alignas] = ACTIONS(2968),
    [anon_sym__Alignas] = ACTIONS(2968),
    [sym_primitive_type] = ACTIONS(2968),
    [anon_sym_enum] = ACTIONS(2968),
    [anon_sym_class] = ACTIONS(2968),
    [anon_sym_struct] = ACTIONS(2968),
    [anon_sym_union] = ACTIONS(2968),
    [anon_sym_if] = ACTIONS(2968),
    [anon_sym_switch] = ACTIONS(2968),
    [anon_sym_case] = ACTIONS(2968),
    [anon_sym_default] = ACTIONS(2968),
    [anon_sym_while] = ACTIONS(2968),
    [anon_sym_do] = ACTIONS(2968),
    [anon_sym_for] = ACTIONS(2968),
    [anon_sym_return] = ACTIONS(2968),
    [anon_sym_break] = ACTIONS(2968),
    [anon_sym_continue] = ACTIONS(2968),
    [anon_sym_goto] = ACTIONS(2968),
    [anon_sym_not] = ACTIONS(2968),
    [anon_sym_compl] = ACTIONS(2968),
    [anon_sym_DASH_DASH] = ACTIONS(2970),
    [anon_sym_PLUS_PLUS] = ACTIONS(2970),
    [anon_sym_sizeof] = ACTIONS(2968),
    [anon_sym___alignof__] = ACTIONS(2968),
    [anon_sym___alignof] = ACTIONS(2968),
    [anon_sym__alignof] = ACTIONS(2968),
    [anon_sym_alignof] = ACTIONS(2968),
    [anon_sym__Alignof] = ACTIONS(2968),
    [anon_sym_offsetof] = ACTIONS(2968),
    [anon_sym__Generic] = ACTIONS(2968),
    [anon_sym_asm] = ACTIONS(2968),
    [anon_sym___asm__] = ACTIONS(2968),
    [anon_sym___asm] = ACTIONS(2968),
    [sym_number_literal] = ACTIONS(2970),
    [anon_sym_L_SQUOTE] = ACTIONS(2970),
    [anon_sym_u_SQUOTE] = ACTIONS(2970),
    [anon_sym_U_SQUOTE] = ACTIONS(2970),
    [anon_sym_u8_SQUOTE] = ACTIONS(2970),
    [anon_sym_SQUOTE] = ACTIONS(2970),
    [anon_sym_L_DQUOTE] = ACTIONS(2970),
    [anon_sym_u_DQUOTE] = ACTIONS(2970),
    [anon_sym_U_DQUOTE] = ACTIONS(2970),
    [anon_sym_u8_DQUOTE] = ACTIONS(2970),
    [anon_sym_DQUOTE] = ACTIONS(2970),
    [sym_true] = ACTIONS(2968),
    [sym_false] = ACTIONS(2968),
    [anon_sym_NULL] = ACTIONS(2968),
    [anon_sym_nullptr] = ACTIONS(2968),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2968),
    [anon_sym_decltype] = ACTIONS(2968),
    [anon_sym_explicit] = ACTIONS(2968),
    [anon_sym_typename] = ACTIONS(2968),
    [anon_sym_template] = ACTIONS(2968),
    [anon_sym_operator] = ACTIONS(2968),
    [anon_sym_try] = ACTIONS(2968),
    [anon_sym_delete] = ACTIONS(2968),
    [anon_sym_throw] = ACTIONS(2968),
    [anon_sym_namespace] = ACTIONS(2968),
    [anon_sym_using] = ACTIONS(2968),
    [anon_sym_static_assert] = ACTIONS(2968),
    [anon_sym_concept] = ACTIONS(2968),
    [anon_sym_co_return] = ACTIONS(2968),
    [anon_sym_co_yield] = ACTIONS(2968),
    [anon_sym_R_DQUOTE] = ACTIONS(2970),
    [anon_sym_LR_DQUOTE] = ACTIONS(2970),
    [anon_sym_uR_DQUOTE] = ACTIONS(2970),
    [anon_sym_UR_DQUOTE] = ACTIONS(2970),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2970),
    [anon_sym_co_await] = ACTIONS(2968),
    [anon_sym_new] = ACTIONS(2968),
    [anon_sym_requires] = ACTIONS(2968),
    [sym_this] = ACTIONS(2968),
  },
  [743] = {
    [ts_builtin_sym_end] = ACTIONS(2807),
    [sym_identifier] = ACTIONS(2805),
    [aux_sym_preproc_include_token1] = ACTIONS(2805),
    [aux_sym_preproc_def_token1] = ACTIONS(2805),
    [aux_sym_preproc_if_token1] = ACTIONS(2805),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2805),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2805),
    [sym_preproc_directive] = ACTIONS(2805),
    [anon_sym_LPAREN2] = ACTIONS(2807),
    [anon_sym_BANG] = ACTIONS(2807),
    [anon_sym_TILDE] = ACTIONS(2807),
    [anon_sym_DASH] = ACTIONS(2805),
    [anon_sym_PLUS] = ACTIONS(2805),
    [anon_sym_STAR] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2805),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym___extension__] = ACTIONS(2805),
    [anon_sym_typedef] = ACTIONS(2805),
    [anon_sym_virtual] = ACTIONS(2805),
    [anon_sym_extern] = ACTIONS(2805),
    [anon_sym___attribute__] = ACTIONS(2805),
    [anon_sym___attribute] = ACTIONS(2805),
    [anon_sym_COLON_COLON] = ACTIONS(2807),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2807),
    [anon_sym___declspec] = ACTIONS(2805),
    [anon_sym___based] = ACTIONS(2805),
    [anon_sym___cdecl] = ACTIONS(2805),
    [anon_sym___clrcall] = ACTIONS(2805),
    [anon_sym___stdcall] = ACTIONS(2805),
    [anon_sym___fastcall] = ACTIONS(2805),
    [anon_sym___thiscall] = ACTIONS(2805),
    [anon_sym___vectorcall] = ACTIONS(2805),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_signed] = ACTIONS(2805),
    [anon_sym_unsigned] = ACTIONS(2805),
    [anon_sym_long] = ACTIONS(2805),
    [anon_sym_short] = ACTIONS(2805),
    [anon_sym_LBRACK] = ACTIONS(2805),
    [anon_sym_static] = ACTIONS(2805),
    [anon_sym_register] = ACTIONS(2805),
    [anon_sym_inline] = ACTIONS(2805),
    [anon_sym___inline] = ACTIONS(2805),
    [anon_sym___inline__] = ACTIONS(2805),
    [anon_sym___forceinline] = ACTIONS(2805),
    [anon_sym_thread_local] = ACTIONS(2805),
    [anon_sym___thread] = ACTIONS(2805),
    [anon_sym_const] = ACTIONS(2805),
    [anon_sym_constexpr] = ACTIONS(2805),
    [anon_sym_volatile] = ACTIONS(2805),
    [anon_sym_restrict] = ACTIONS(2805),
    [anon_sym___restrict__] = ACTIONS(2805),
    [anon_sym__Atomic] = ACTIONS(2805),
    [anon_sym__Noreturn] = ACTIONS(2805),
    [anon_sym_noreturn] = ACTIONS(2805),
    [anon_sym__Nonnull] = ACTIONS(2805),
    [anon_sym_mutable] = ACTIONS(2805),
    [anon_sym_constinit] = ACTIONS(2805),
    [anon_sym_consteval] = ACTIONS(2805),
    [anon_sym_alignas] = ACTIONS(2805),
    [anon_sym__Alignas] = ACTIONS(2805),
    [sym_primitive_type] = ACTIONS(2805),
    [anon_sym_enum] = ACTIONS(2805),
    [anon_sym_class] = ACTIONS(2805),
    [anon_sym_struct] = ACTIONS(2805),
    [anon_sym_union] = ACTIONS(2805),
    [anon_sym_if] = ACTIONS(2805),
    [anon_sym_switch] = ACTIONS(2805),
    [anon_sym_case] = ACTIONS(2805),
    [anon_sym_default] = ACTIONS(2805),
    [anon_sym_while] = ACTIONS(2805),
    [anon_sym_do] = ACTIONS(2805),
    [anon_sym_for] = ACTIONS(2805),
    [anon_sym_return] = ACTIONS(2805),
    [anon_sym_break] = ACTIONS(2805),
    [anon_sym_continue] = ACTIONS(2805),
    [anon_sym_goto] = ACTIONS(2805),
    [anon_sym_not] = ACTIONS(2805),
    [anon_sym_compl] = ACTIONS(2805),
    [anon_sym_DASH_DASH] = ACTIONS(2807),
    [anon_sym_PLUS_PLUS] = ACTIONS(2807),
    [anon_sym_sizeof] = ACTIONS(2805),
    [anon_sym___alignof__] = ACTIONS(2805),
    [anon_sym___alignof] = ACTIONS(2805),
    [anon_sym__alignof] = ACTIONS(2805),
    [anon_sym_alignof] = ACTIONS(2805),
    [anon_sym__Alignof] = ACTIONS(2805),
    [anon_sym_offsetof] = ACTIONS(2805),
    [anon_sym__Generic] = ACTIONS(2805),
    [anon_sym_asm] = ACTIONS(2805),
    [anon_sym___asm__] = ACTIONS(2805),
    [anon_sym___asm] = ACTIONS(2805),
    [sym_number_literal] = ACTIONS(2807),
    [anon_sym_L_SQUOTE] = ACTIONS(2807),
    [anon_sym_u_SQUOTE] = ACTIONS(2807),
    [anon_sym_U_SQUOTE] = ACTIONS(2807),
    [anon_sym_u8_SQUOTE] = ACTIONS(2807),
    [anon_sym_SQUOTE] = ACTIONS(2807),
    [anon_sym_L_DQUOTE] = ACTIONS(2807),
    [anon_sym_u_DQUOTE] = ACTIONS(2807),
    [anon_sym_U_DQUOTE] = ACTIONS(2807),
    [anon_sym_u8_DQUOTE] = ACTIONS(2807),
    [anon_sym_DQUOTE] = ACTIONS(2807),
    [sym_true] = ACTIONS(2805),
    [sym_false] = ACTIONS(2805),
    [anon_sym_NULL] = ACTIONS(2805),
    [anon_sym_nullptr] = ACTIONS(2805),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2805),
    [anon_sym_decltype] = ACTIONS(2805),
    [anon_sym_explicit] = ACTIONS(2805),
    [anon_sym_typename] = ACTIONS(2805),
    [anon_sym_template] = ACTIONS(2805),
    [anon_sym_operator] = ACTIONS(2805),
    [anon_sym_try] = ACTIONS(2805),
    [anon_sym_delete] = ACTIONS(2805),
    [anon_sym_throw] = ACTIONS(2805),
    [anon_sym_namespace] = ACTIONS(2805),
    [anon_sym_using] = ACTIONS(2805),
    [anon_sym_static_assert] = ACTIONS(2805),
    [anon_sym_concept] = ACTIONS(2805),
    [anon_sym_co_return] = ACTIONS(2805),
    [anon_sym_co_yield] = ACTIONS(2805),
    [anon_sym_R_DQUOTE] = ACTIONS(2807),
    [anon_sym_LR_DQUOTE] = ACTIONS(2807),
    [anon_sym_uR_DQUOTE] = ACTIONS(2807),
    [anon_sym_UR_DQUOTE] = ACTIONS(2807),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2807),
    [anon_sym_co_await] = ACTIONS(2805),
    [anon_sym_new] = ACTIONS(2805),
    [anon_sym_requires] = ACTIONS(2805),
    [sym_this] = ACTIONS(2805),
  },
  [744] = {
    [ts_builtin_sym_end] = ACTIONS(2811),
    [sym_identifier] = ACTIONS(2809),
    [aux_sym_preproc_include_token1] = ACTIONS(2809),
    [aux_sym_preproc_def_token1] = ACTIONS(2809),
    [aux_sym_preproc_if_token1] = ACTIONS(2809),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2809),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2809),
    [sym_preproc_directive] = ACTIONS(2809),
    [anon_sym_LPAREN2] = ACTIONS(2811),
    [anon_sym_BANG] = ACTIONS(2811),
    [anon_sym_TILDE] = ACTIONS(2811),
    [anon_sym_DASH] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_STAR] = ACTIONS(2811),
    [anon_sym_AMP_AMP] = ACTIONS(2811),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2811),
    [anon_sym___extension__] = ACTIONS(2809),
    [anon_sym_typedef] = ACTIONS(2809),
    [anon_sym_virtual] = ACTIONS(2809),
    [anon_sym_extern] = ACTIONS(2809),
    [anon_sym___attribute__] = ACTIONS(2809),
    [anon_sym___attribute] = ACTIONS(2809),
    [anon_sym_COLON_COLON] = ACTIONS(2811),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2811),
    [anon_sym___declspec] = ACTIONS(2809),
    [anon_sym___based] = ACTIONS(2809),
    [anon_sym___cdecl] = ACTIONS(2809),
    [anon_sym___clrcall] = ACTIONS(2809),
    [anon_sym___stdcall] = ACTIONS(2809),
    [anon_sym___fastcall] = ACTIONS(2809),
    [anon_sym___thiscall] = ACTIONS(2809),
    [anon_sym___vectorcall] = ACTIONS(2809),
    [anon_sym_LBRACE] = ACTIONS(2811),
    [anon_sym_signed] = ACTIONS(2809),
    [anon_sym_unsigned] = ACTIONS(2809),
    [anon_sym_long] = ACTIONS(2809),
    [anon_sym_short] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2809),
    [anon_sym_static] = ACTIONS(2809),
    [anon_sym_register] = ACTIONS(2809),
    [anon_sym_inline] = ACTIONS(2809),
    [anon_sym___inline] = ACTIONS(2809),
    [anon_sym___inline__] = ACTIONS(2809),
    [anon_sym___forceinline] = ACTIONS(2809),
    [anon_sym_thread_local] = ACTIONS(2809),
    [anon_sym___thread] = ACTIONS(2809),
    [anon_sym_const] = ACTIONS(2809),
    [anon_sym_constexpr] = ACTIONS(2809),
    [anon_sym_volatile] = ACTIONS(2809),
    [anon_sym_restrict] = ACTIONS(2809),
    [anon_sym___restrict__] = ACTIONS(2809),
    [anon_sym__Atomic] = ACTIONS(2809),
    [anon_sym__Noreturn] = ACTIONS(2809),
    [anon_sym_noreturn] = ACTIONS(2809),
    [anon_sym__Nonnull] = ACTIONS(2809),
    [anon_sym_mutable] = ACTIONS(2809),
    [anon_sym_constinit] = ACTIONS(2809),
    [anon_sym_consteval] = ACTIONS(2809),
    [anon_sym_alignas] = ACTIONS(2809),
    [anon_sym__Alignas] = ACTIONS(2809),
    [sym_primitive_type] = ACTIONS(2809),
    [anon_sym_enum] = ACTIONS(2809),
    [anon_sym_class] = ACTIONS(2809),
    [anon_sym_struct] = ACTIONS(2809),
    [anon_sym_union] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(2809),
    [anon_sym_switch] = ACTIONS(2809),
    [anon_sym_case] = ACTIONS(2809),
    [anon_sym_default] = ACTIONS(2809),
    [anon_sym_while] = ACTIONS(2809),
    [anon_sym_do] = ACTIONS(2809),
    [anon_sym_for] = ACTIONS(2809),
    [anon_sym_return] = ACTIONS(2809),
    [anon_sym_break] = ACTIONS(2809),
    [anon_sym_continue] = ACTIONS(2809),
    [anon_sym_goto] = ACTIONS(2809),
    [anon_sym_not] = ACTIONS(2809),
    [anon_sym_compl] = ACTIONS(2809),
    [anon_sym_DASH_DASH] = ACTIONS(2811),
    [anon_sym_PLUS_PLUS] = ACTIONS(2811),
    [anon_sym_sizeof] = ACTIONS(2809),
    [anon_sym___alignof__] = ACTIONS(2809),
    [anon_sym___alignof] = ACTIONS(2809),
    [anon_sym__alignof] = ACTIONS(2809),
    [anon_sym_alignof] = ACTIONS(2809),
    [anon_sym__Alignof] = ACTIONS(2809),
    [anon_sym_offsetof] = ACTIONS(2809),
    [anon_sym__Generic] = ACTIONS(2809),
    [anon_sym_asm] = ACTIONS(2809),
    [anon_sym___asm__] = ACTIONS(2809),
    [anon_sym___asm] = ACTIONS(2809),
    [sym_number_literal] = ACTIONS(2811),
    [anon_sym_L_SQUOTE] = ACTIONS(2811),
    [anon_sym_u_SQUOTE] = ACTIONS(2811),
    [anon_sym_U_SQUOTE] = ACTIONS(2811),
    [anon_sym_u8_SQUOTE] = ACTIONS(2811),
    [anon_sym_SQUOTE] = ACTIONS(2811),
    [anon_sym_L_DQUOTE] = ACTIONS(2811),
    [anon_sym_u_DQUOTE] = ACTIONS(2811),
    [anon_sym_U_DQUOTE] = ACTIONS(2811),
    [anon_sym_u8_DQUOTE] = ACTIONS(2811),
    [anon_sym_DQUOTE] = ACTIONS(2811),
    [sym_true] = ACTIONS(2809),
    [sym_false] = ACTIONS(2809),
    [anon_sym_NULL] = ACTIONS(2809),
    [anon_sym_nullptr] = ACTIONS(2809),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2809),
    [anon_sym_decltype] = ACTIONS(2809),
    [anon_sym_explicit] = ACTIONS(2809),
    [anon_sym_typename] = ACTIONS(2809),
    [anon_sym_template] = ACTIONS(2809),
    [anon_sym_operator] = ACTIONS(2809),
    [anon_sym_try] = ACTIONS(2809),
    [anon_sym_delete] = ACTIONS(2809),
    [anon_sym_throw] = ACTIONS(2809),
    [anon_sym_namespace] = ACTIONS(2809),
    [anon_sym_using] = ACTIONS(2809),
    [anon_sym_static_assert] = ACTIONS(2809),
    [anon_sym_concept] = ACTIONS(2809),
    [anon_sym_co_return] = ACTIONS(2809),
    [anon_sym_co_yield] = ACTIONS(2809),
    [anon_sym_R_DQUOTE] = ACTIONS(2811),
    [anon_sym_LR_DQUOTE] = ACTIONS(2811),
    [anon_sym_uR_DQUOTE] = ACTIONS(2811),
    [anon_sym_UR_DQUOTE] = ACTIONS(2811),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2811),
    [anon_sym_co_await] = ACTIONS(2809),
    [anon_sym_new] = ACTIONS(2809),
    [anon_sym_requires] = ACTIONS(2809),
    [sym_this] = ACTIONS(2809),
  },
  [745] = {
    [ts_builtin_sym_end] = ACTIONS(2974),
    [sym_identifier] = ACTIONS(2972),
    [aux_sym_preproc_include_token1] = ACTIONS(2972),
    [aux_sym_preproc_def_token1] = ACTIONS(2972),
    [aux_sym_preproc_if_token1] = ACTIONS(2972),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2972),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2972),
    [sym_preproc_directive] = ACTIONS(2972),
    [anon_sym_LPAREN2] = ACTIONS(2974),
    [anon_sym_BANG] = ACTIONS(2974),
    [anon_sym_TILDE] = ACTIONS(2974),
    [anon_sym_DASH] = ACTIONS(2972),
    [anon_sym_PLUS] = ACTIONS(2972),
    [anon_sym_STAR] = ACTIONS(2974),
    [anon_sym_AMP_AMP] = ACTIONS(2974),
    [anon_sym_AMP] = ACTIONS(2972),
    [anon_sym_SEMI] = ACTIONS(2974),
    [anon_sym___extension__] = ACTIONS(2972),
    [anon_sym_typedef] = ACTIONS(2972),
    [anon_sym_virtual] = ACTIONS(2972),
    [anon_sym_extern] = ACTIONS(2972),
    [anon_sym___attribute__] = ACTIONS(2972),
    [anon_sym___attribute] = ACTIONS(2972),
    [anon_sym_COLON_COLON] = ACTIONS(2974),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2974),
    [anon_sym___declspec] = ACTIONS(2972),
    [anon_sym___based] = ACTIONS(2972),
    [anon_sym___cdecl] = ACTIONS(2972),
    [anon_sym___clrcall] = ACTIONS(2972),
    [anon_sym___stdcall] = ACTIONS(2972),
    [anon_sym___fastcall] = ACTIONS(2972),
    [anon_sym___thiscall] = ACTIONS(2972),
    [anon_sym___vectorcall] = ACTIONS(2972),
    [anon_sym_LBRACE] = ACTIONS(2974),
    [anon_sym_signed] = ACTIONS(2972),
    [anon_sym_unsigned] = ACTIONS(2972),
    [anon_sym_long] = ACTIONS(2972),
    [anon_sym_short] = ACTIONS(2972),
    [anon_sym_LBRACK] = ACTIONS(2972),
    [anon_sym_static] = ACTIONS(2972),
    [anon_sym_register] = ACTIONS(2972),
    [anon_sym_inline] = ACTIONS(2972),
    [anon_sym___inline] = ACTIONS(2972),
    [anon_sym___inline__] = ACTIONS(2972),
    [anon_sym___forceinline] = ACTIONS(2972),
    [anon_sym_thread_local] = ACTIONS(2972),
    [anon_sym___thread] = ACTIONS(2972),
    [anon_sym_const] = ACTIONS(2972),
    [anon_sym_constexpr] = ACTIONS(2972),
    [anon_sym_volatile] = ACTIONS(2972),
    [anon_sym_restrict] = ACTIONS(2972),
    [anon_sym___restrict__] = ACTIONS(2972),
    [anon_sym__Atomic] = ACTIONS(2972),
    [anon_sym__Noreturn] = ACTIONS(2972),
    [anon_sym_noreturn] = ACTIONS(2972),
    [anon_sym__Nonnull] = ACTIONS(2972),
    [anon_sym_mutable] = ACTIONS(2972),
    [anon_sym_constinit] = ACTIONS(2972),
    [anon_sym_consteval] = ACTIONS(2972),
    [anon_sym_alignas] = ACTIONS(2972),
    [anon_sym__Alignas] = ACTIONS(2972),
    [sym_primitive_type] = ACTIONS(2972),
    [anon_sym_enum] = ACTIONS(2972),
    [anon_sym_class] = ACTIONS(2972),
    [anon_sym_struct] = ACTIONS(2972),
    [anon_sym_union] = ACTIONS(2972),
    [anon_sym_if] = ACTIONS(2972),
    [anon_sym_switch] = ACTIONS(2972),
    [anon_sym_case] = ACTIONS(2972),
    [anon_sym_default] = ACTIONS(2972),
    [anon_sym_while] = ACTIONS(2972),
    [anon_sym_do] = ACTIONS(2972),
    [anon_sym_for] = ACTIONS(2972),
    [anon_sym_return] = ACTIONS(2972),
    [anon_sym_break] = ACTIONS(2972),
    [anon_sym_continue] = ACTIONS(2972),
    [anon_sym_goto] = ACTIONS(2972),
    [anon_sym_not] = ACTIONS(2972),
    [anon_sym_compl] = ACTIONS(2972),
    [anon_sym_DASH_DASH] = ACTIONS(2974),
    [anon_sym_PLUS_PLUS] = ACTIONS(2974),
    [anon_sym_sizeof] = ACTIONS(2972),
    [anon_sym___alignof__] = ACTIONS(2972),
    [anon_sym___alignof] = ACTIONS(2972),
    [anon_sym__alignof] = ACTIONS(2972),
    [anon_sym_alignof] = ACTIONS(2972),
    [anon_sym__Alignof] = ACTIONS(2972),
    [anon_sym_offsetof] = ACTIONS(2972),
    [anon_sym__Generic] = ACTIONS(2972),
    [anon_sym_asm] = ACTIONS(2972),
    [anon_sym___asm__] = ACTIONS(2972),
    [anon_sym___asm] = ACTIONS(2972),
    [sym_number_literal] = ACTIONS(2974),
    [anon_sym_L_SQUOTE] = ACTIONS(2974),
    [anon_sym_u_SQUOTE] = ACTIONS(2974),
    [anon_sym_U_SQUOTE] = ACTIONS(2974),
    [anon_sym_u8_SQUOTE] = ACTIONS(2974),
    [anon_sym_SQUOTE] = ACTIONS(2974),
    [anon_sym_L_DQUOTE] = ACTIONS(2974),
    [anon_sym_u_DQUOTE] = ACTIONS(2974),
    [anon_sym_U_DQUOTE] = ACTIONS(2974),
    [anon_sym_u8_DQUOTE] = ACTIONS(2974),
    [anon_sym_DQUOTE] = ACTIONS(2974),
    [sym_true] = ACTIONS(2972),
    [sym_false] = ACTIONS(2972),
    [anon_sym_NULL] = ACTIONS(2972),
    [anon_sym_nullptr] = ACTIONS(2972),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2972),
    [anon_sym_decltype] = ACTIONS(2972),
    [anon_sym_explicit] = ACTIONS(2972),
    [anon_sym_typename] = ACTIONS(2972),
    [anon_sym_template] = ACTIONS(2972),
    [anon_sym_operator] = ACTIONS(2972),
    [anon_sym_try] = ACTIONS(2972),
    [anon_sym_delete] = ACTIONS(2972),
    [anon_sym_throw] = ACTIONS(2972),
    [anon_sym_namespace] = ACTIONS(2972),
    [anon_sym_using] = ACTIONS(2972),
    [anon_sym_static_assert] = ACTIONS(2972),
    [anon_sym_concept] = ACTIONS(2972),
    [anon_sym_co_return] = ACTIONS(2972),
    [anon_sym_co_yield] = ACTIONS(2972),
    [anon_sym_R_DQUOTE] = ACTIONS(2974),
    [anon_sym_LR_DQUOTE] = ACTIONS(2974),
    [anon_sym_uR_DQUOTE] = ACTIONS(2974),
    [anon_sym_UR_DQUOTE] = ACTIONS(2974),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2974),
    [anon_sym_co_await] = ACTIONS(2972),
    [anon_sym_new] = ACTIONS(2972),
    [anon_sym_requires] = ACTIONS(2972),
    [sym_this] = ACTIONS(2972),
  },
  [746] = {
    [ts_builtin_sym_end] = ACTIONS(2978),
    [sym_identifier] = ACTIONS(2976),
    [aux_sym_preproc_include_token1] = ACTIONS(2976),
    [aux_sym_preproc_def_token1] = ACTIONS(2976),
    [aux_sym_preproc_if_token1] = ACTIONS(2976),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2976),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2976),
    [sym_preproc_directive] = ACTIONS(2976),
    [anon_sym_LPAREN2] = ACTIONS(2978),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2976),
    [anon_sym_PLUS] = ACTIONS(2976),
    [anon_sym_STAR] = ACTIONS(2978),
    [anon_sym_AMP_AMP] = ACTIONS(2978),
    [anon_sym_AMP] = ACTIONS(2976),
    [anon_sym_SEMI] = ACTIONS(2978),
    [anon_sym___extension__] = ACTIONS(2976),
    [anon_sym_typedef] = ACTIONS(2976),
    [anon_sym_virtual] = ACTIONS(2976),
    [anon_sym_extern] = ACTIONS(2976),
    [anon_sym___attribute__] = ACTIONS(2976),
    [anon_sym___attribute] = ACTIONS(2976),
    [anon_sym_COLON_COLON] = ACTIONS(2978),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2978),
    [anon_sym___declspec] = ACTIONS(2976),
    [anon_sym___based] = ACTIONS(2976),
    [anon_sym___cdecl] = ACTIONS(2976),
    [anon_sym___clrcall] = ACTIONS(2976),
    [anon_sym___stdcall] = ACTIONS(2976),
    [anon_sym___fastcall] = ACTIONS(2976),
    [anon_sym___thiscall] = ACTIONS(2976),
    [anon_sym___vectorcall] = ACTIONS(2976),
    [anon_sym_LBRACE] = ACTIONS(2978),
    [anon_sym_signed] = ACTIONS(2976),
    [anon_sym_unsigned] = ACTIONS(2976),
    [anon_sym_long] = ACTIONS(2976),
    [anon_sym_short] = ACTIONS(2976),
    [anon_sym_LBRACK] = ACTIONS(2976),
    [anon_sym_static] = ACTIONS(2976),
    [anon_sym_register] = ACTIONS(2976),
    [anon_sym_inline] = ACTIONS(2976),
    [anon_sym___inline] = ACTIONS(2976),
    [anon_sym___inline__] = ACTIONS(2976),
    [anon_sym___forceinline] = ACTIONS(2976),
    [anon_sym_thread_local] = ACTIONS(2976),
    [anon_sym___thread] = ACTIONS(2976),
    [anon_sym_const] = ACTIONS(2976),
    [anon_sym_constexpr] = ACTIONS(2976),
    [anon_sym_volatile] = ACTIONS(2976),
    [anon_sym_restrict] = ACTIONS(2976),
    [anon_sym___restrict__] = ACTIONS(2976),
    [anon_sym__Atomic] = ACTIONS(2976),
    [anon_sym__Noreturn] = ACTIONS(2976),
    [anon_sym_noreturn] = ACTIONS(2976),
    [anon_sym__Nonnull] = ACTIONS(2976),
    [anon_sym_mutable] = ACTIONS(2976),
    [anon_sym_constinit] = ACTIONS(2976),
    [anon_sym_consteval] = ACTIONS(2976),
    [anon_sym_alignas] = ACTIONS(2976),
    [anon_sym__Alignas] = ACTIONS(2976),
    [sym_primitive_type] = ACTIONS(2976),
    [anon_sym_enum] = ACTIONS(2976),
    [anon_sym_class] = ACTIONS(2976),
    [anon_sym_struct] = ACTIONS(2976),
    [anon_sym_union] = ACTIONS(2976),
    [anon_sym_if] = ACTIONS(2976),
    [anon_sym_switch] = ACTIONS(2976),
    [anon_sym_case] = ACTIONS(2976),
    [anon_sym_default] = ACTIONS(2976),
    [anon_sym_while] = ACTIONS(2976),
    [anon_sym_do] = ACTIONS(2976),
    [anon_sym_for] = ACTIONS(2976),
    [anon_sym_return] = ACTIONS(2976),
    [anon_sym_break] = ACTIONS(2976),
    [anon_sym_continue] = ACTIONS(2976),
    [anon_sym_goto] = ACTIONS(2976),
    [anon_sym_not] = ACTIONS(2976),
    [anon_sym_compl] = ACTIONS(2976),
    [anon_sym_DASH_DASH] = ACTIONS(2978),
    [anon_sym_PLUS_PLUS] = ACTIONS(2978),
    [anon_sym_sizeof] = ACTIONS(2976),
    [anon_sym___alignof__] = ACTIONS(2976),
    [anon_sym___alignof] = ACTIONS(2976),
    [anon_sym__alignof] = ACTIONS(2976),
    [anon_sym_alignof] = ACTIONS(2976),
    [anon_sym__Alignof] = ACTIONS(2976),
    [anon_sym_offsetof] = ACTIONS(2976),
    [anon_sym__Generic] = ACTIONS(2976),
    [anon_sym_asm] = ACTIONS(2976),
    [anon_sym___asm__] = ACTIONS(2976),
    [anon_sym___asm] = ACTIONS(2976),
    [sym_number_literal] = ACTIONS(2978),
    [anon_sym_L_SQUOTE] = ACTIONS(2978),
    [anon_sym_u_SQUOTE] = ACTIONS(2978),
    [anon_sym_U_SQUOTE] = ACTIONS(2978),
    [anon_sym_u8_SQUOTE] = ACTIONS(2978),
    [anon_sym_SQUOTE] = ACTIONS(2978),
    [anon_sym_L_DQUOTE] = ACTIONS(2978),
    [anon_sym_u_DQUOTE] = ACTIONS(2978),
    [anon_sym_U_DQUOTE] = ACTIONS(2978),
    [anon_sym_u8_DQUOTE] = ACTIONS(2978),
    [anon_sym_DQUOTE] = ACTIONS(2978),
    [sym_true] = ACTIONS(2976),
    [sym_false] = ACTIONS(2976),
    [anon_sym_NULL] = ACTIONS(2976),
    [anon_sym_nullptr] = ACTIONS(2976),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2976),
    [anon_sym_decltype] = ACTIONS(2976),
    [anon_sym_explicit] = ACTIONS(2976),
    [anon_sym_typename] = ACTIONS(2976),
    [anon_sym_template] = ACTIONS(2976),
    [anon_sym_operator] = ACTIONS(2976),
    [anon_sym_try] = ACTIONS(2976),
    [anon_sym_delete] = ACTIONS(2976),
    [anon_sym_throw] = ACTIONS(2976),
    [anon_sym_namespace] = ACTIONS(2976),
    [anon_sym_using] = ACTIONS(2976),
    [anon_sym_static_assert] = ACTIONS(2976),
    [anon_sym_concept] = ACTIONS(2976),
    [anon_sym_co_return] = ACTIONS(2976),
    [anon_sym_co_yield] = ACTIONS(2976),
    [anon_sym_R_DQUOTE] = ACTIONS(2978),
    [anon_sym_LR_DQUOTE] = ACTIONS(2978),
    [anon_sym_uR_DQUOTE] = ACTIONS(2978),
    [anon_sym_UR_DQUOTE] = ACTIONS(2978),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2978),
    [anon_sym_co_await] = ACTIONS(2976),
    [anon_sym_new] = ACTIONS(2976),
    [anon_sym_requires] = ACTIONS(2976),
    [sym_this] = ACTIONS(2976),
  },
  [747] = {
    [ts_builtin_sym_end] = ACTIONS(3011),
    [sym_identifier] = ACTIONS(3009),
    [aux_sym_preproc_include_token1] = ACTIONS(3009),
    [aux_sym_preproc_def_token1] = ACTIONS(3009),
    [aux_sym_preproc_if_token1] = ACTIONS(3009),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3009),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3009),
    [sym_preproc_directive] = ACTIONS(3009),
    [anon_sym_LPAREN2] = ACTIONS(3011),
    [anon_sym_BANG] = ACTIONS(3011),
    [anon_sym_TILDE] = ACTIONS(3011),
    [anon_sym_DASH] = ACTIONS(3009),
    [anon_sym_PLUS] = ACTIONS(3009),
    [anon_sym_STAR] = ACTIONS(3011),
    [anon_sym_AMP_AMP] = ACTIONS(3011),
    [anon_sym_AMP] = ACTIONS(3009),
    [anon_sym_SEMI] = ACTIONS(3011),
    [anon_sym___extension__] = ACTIONS(3009),
    [anon_sym_typedef] = ACTIONS(3009),
    [anon_sym_virtual] = ACTIONS(3009),
    [anon_sym_extern] = ACTIONS(3009),
    [anon_sym___attribute__] = ACTIONS(3009),
    [anon_sym___attribute] = ACTIONS(3009),
    [anon_sym_COLON_COLON] = ACTIONS(3011),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3011),
    [anon_sym___declspec] = ACTIONS(3009),
    [anon_sym___based] = ACTIONS(3009),
    [anon_sym___cdecl] = ACTIONS(3009),
    [anon_sym___clrcall] = ACTIONS(3009),
    [anon_sym___stdcall] = ACTIONS(3009),
    [anon_sym___fastcall] = ACTIONS(3009),
    [anon_sym___thiscall] = ACTIONS(3009),
    [anon_sym___vectorcall] = ACTIONS(3009),
    [anon_sym_LBRACE] = ACTIONS(3011),
    [anon_sym_signed] = ACTIONS(3009),
    [anon_sym_unsigned] = ACTIONS(3009),
    [anon_sym_long] = ACTIONS(3009),
    [anon_sym_short] = ACTIONS(3009),
    [anon_sym_LBRACK] = ACTIONS(3009),
    [anon_sym_static] = ACTIONS(3009),
    [anon_sym_register] = ACTIONS(3009),
    [anon_sym_inline] = ACTIONS(3009),
    [anon_sym___inline] = ACTIONS(3009),
    [anon_sym___inline__] = ACTIONS(3009),
    [anon_sym___forceinline] = ACTIONS(3009),
    [anon_sym_thread_local] = ACTIONS(3009),
    [anon_sym___thread] = ACTIONS(3009),
    [anon_sym_const] = ACTIONS(3009),
    [anon_sym_constexpr] = ACTIONS(3009),
    [anon_sym_volatile] = ACTIONS(3009),
    [anon_sym_restrict] = ACTIONS(3009),
    [anon_sym___restrict__] = ACTIONS(3009),
    [anon_sym__Atomic] = ACTIONS(3009),
    [anon_sym__Noreturn] = ACTIONS(3009),
    [anon_sym_noreturn] = ACTIONS(3009),
    [anon_sym__Nonnull] = ACTIONS(3009),
    [anon_sym_mutable] = ACTIONS(3009),
    [anon_sym_constinit] = ACTIONS(3009),
    [anon_sym_consteval] = ACTIONS(3009),
    [anon_sym_alignas] = ACTIONS(3009),
    [anon_sym__Alignas] = ACTIONS(3009),
    [sym_primitive_type] = ACTIONS(3009),
    [anon_sym_enum] = ACTIONS(3009),
    [anon_sym_class] = ACTIONS(3009),
    [anon_sym_struct] = ACTIONS(3009),
    [anon_sym_union] = ACTIONS(3009),
    [anon_sym_if] = ACTIONS(3009),
    [anon_sym_switch] = ACTIONS(3009),
    [anon_sym_case] = ACTIONS(3009),
    [anon_sym_default] = ACTIONS(3009),
    [anon_sym_while] = ACTIONS(3009),
    [anon_sym_do] = ACTIONS(3009),
    [anon_sym_for] = ACTIONS(3009),
    [anon_sym_return] = ACTIONS(3009),
    [anon_sym_break] = ACTIONS(3009),
    [anon_sym_continue] = ACTIONS(3009),
    [anon_sym_goto] = ACTIONS(3009),
    [anon_sym_not] = ACTIONS(3009),
    [anon_sym_compl] = ACTIONS(3009),
    [anon_sym_DASH_DASH] = ACTIONS(3011),
    [anon_sym_PLUS_PLUS] = ACTIONS(3011),
    [anon_sym_sizeof] = ACTIONS(3009),
    [anon_sym___alignof__] = ACTIONS(3009),
    [anon_sym___alignof] = ACTIONS(3009),
    [anon_sym__alignof] = ACTIONS(3009),
    [anon_sym_alignof] = ACTIONS(3009),
    [anon_sym__Alignof] = ACTIONS(3009),
    [anon_sym_offsetof] = ACTIONS(3009),
    [anon_sym__Generic] = ACTIONS(3009),
    [anon_sym_asm] = ACTIONS(3009),
    [anon_sym___asm__] = ACTIONS(3009),
    [anon_sym___asm] = ACTIONS(3009),
    [sym_number_literal] = ACTIONS(3011),
    [anon_sym_L_SQUOTE] = ACTIONS(3011),
    [anon_sym_u_SQUOTE] = ACTIONS(3011),
    [anon_sym_U_SQUOTE] = ACTIONS(3011),
    [anon_sym_u8_SQUOTE] = ACTIONS(3011),
    [anon_sym_SQUOTE] = ACTIONS(3011),
    [anon_sym_L_DQUOTE] = ACTIONS(3011),
    [anon_sym_u_DQUOTE] = ACTIONS(3011),
    [anon_sym_U_DQUOTE] = ACTIONS(3011),
    [anon_sym_u8_DQUOTE] = ACTIONS(3011),
    [anon_sym_DQUOTE] = ACTIONS(3011),
    [sym_true] = ACTIONS(3009),
    [sym_false] = ACTIONS(3009),
    [anon_sym_NULL] = ACTIONS(3009),
    [anon_sym_nullptr] = ACTIONS(3009),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3009),
    [anon_sym_decltype] = ACTIONS(3009),
    [anon_sym_explicit] = ACTIONS(3009),
    [anon_sym_typename] = ACTIONS(3009),
    [anon_sym_template] = ACTIONS(3009),
    [anon_sym_operator] = ACTIONS(3009),
    [anon_sym_try] = ACTIONS(3009),
    [anon_sym_delete] = ACTIONS(3009),
    [anon_sym_throw] = ACTIONS(3009),
    [anon_sym_namespace] = ACTIONS(3009),
    [anon_sym_using] = ACTIONS(3009),
    [anon_sym_static_assert] = ACTIONS(3009),
    [anon_sym_concept] = ACTIONS(3009),
    [anon_sym_co_return] = ACTIONS(3009),
    [anon_sym_co_yield] = ACTIONS(3009),
    [anon_sym_R_DQUOTE] = ACTIONS(3011),
    [anon_sym_LR_DQUOTE] = ACTIONS(3011),
    [anon_sym_uR_DQUOTE] = ACTIONS(3011),
    [anon_sym_UR_DQUOTE] = ACTIONS(3011),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3011),
    [anon_sym_co_await] = ACTIONS(3009),
    [anon_sym_new] = ACTIONS(3009),
    [anon_sym_requires] = ACTIONS(3009),
    [sym_this] = ACTIONS(3009),
  },
  [748] = {
    [ts_builtin_sym_end] = ACTIONS(3015),
    [sym_identifier] = ACTIONS(3013),
    [aux_sym_preproc_include_token1] = ACTIONS(3013),
    [aux_sym_preproc_def_token1] = ACTIONS(3013),
    [aux_sym_preproc_if_token1] = ACTIONS(3013),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3013),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3013),
    [sym_preproc_directive] = ACTIONS(3013),
    [anon_sym_LPAREN2] = ACTIONS(3015),
    [anon_sym_BANG] = ACTIONS(3015),
    [anon_sym_TILDE] = ACTIONS(3015),
    [anon_sym_DASH] = ACTIONS(3013),
    [anon_sym_PLUS] = ACTIONS(3013),
    [anon_sym_STAR] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3015),
    [anon_sym_AMP] = ACTIONS(3013),
    [anon_sym_SEMI] = ACTIONS(3015),
    [anon_sym___extension__] = ACTIONS(3013),
    [anon_sym_typedef] = ACTIONS(3013),
    [anon_sym_virtual] = ACTIONS(3013),
    [anon_sym_extern] = ACTIONS(3013),
    [anon_sym___attribute__] = ACTIONS(3013),
    [anon_sym___attribute] = ACTIONS(3013),
    [anon_sym_COLON_COLON] = ACTIONS(3015),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3015),
    [anon_sym___declspec] = ACTIONS(3013),
    [anon_sym___based] = ACTIONS(3013),
    [anon_sym___cdecl] = ACTIONS(3013),
    [anon_sym___clrcall] = ACTIONS(3013),
    [anon_sym___stdcall] = ACTIONS(3013),
    [anon_sym___fastcall] = ACTIONS(3013),
    [anon_sym___thiscall] = ACTIONS(3013),
    [anon_sym___vectorcall] = ACTIONS(3013),
    [anon_sym_LBRACE] = ACTIONS(3015),
    [anon_sym_signed] = ACTIONS(3013),
    [anon_sym_unsigned] = ACTIONS(3013),
    [anon_sym_long] = ACTIONS(3013),
    [anon_sym_short] = ACTIONS(3013),
    [anon_sym_LBRACK] = ACTIONS(3013),
    [anon_sym_static] = ACTIONS(3013),
    [anon_sym_register] = ACTIONS(3013),
    [anon_sym_inline] = ACTIONS(3013),
    [anon_sym___inline] = ACTIONS(3013),
    [anon_sym___inline__] = ACTIONS(3013),
    [anon_sym___forceinline] = ACTIONS(3013),
    [anon_sym_thread_local] = ACTIONS(3013),
    [anon_sym___thread] = ACTIONS(3013),
    [anon_sym_const] = ACTIONS(3013),
    [anon_sym_constexpr] = ACTIONS(3013),
    [anon_sym_volatile] = ACTIONS(3013),
    [anon_sym_restrict] = ACTIONS(3013),
    [anon_sym___restrict__] = ACTIONS(3013),
    [anon_sym__Atomic] = ACTIONS(3013),
    [anon_sym__Noreturn] = ACTIONS(3013),
    [anon_sym_noreturn] = ACTIONS(3013),
    [anon_sym__Nonnull] = ACTIONS(3013),
    [anon_sym_mutable] = ACTIONS(3013),
    [anon_sym_constinit] = ACTIONS(3013),
    [anon_sym_consteval] = ACTIONS(3013),
    [anon_sym_alignas] = ACTIONS(3013),
    [anon_sym__Alignas] = ACTIONS(3013),
    [sym_primitive_type] = ACTIONS(3013),
    [anon_sym_enum] = ACTIONS(3013),
    [anon_sym_class] = ACTIONS(3013),
    [anon_sym_struct] = ACTIONS(3013),
    [anon_sym_union] = ACTIONS(3013),
    [anon_sym_if] = ACTIONS(3013),
    [anon_sym_switch] = ACTIONS(3013),
    [anon_sym_case] = ACTIONS(3013),
    [anon_sym_default] = ACTIONS(3013),
    [anon_sym_while] = ACTIONS(3013),
    [anon_sym_do] = ACTIONS(3013),
    [anon_sym_for] = ACTIONS(3013),
    [anon_sym_return] = ACTIONS(3013),
    [anon_sym_break] = ACTIONS(3013),
    [anon_sym_continue] = ACTIONS(3013),
    [anon_sym_goto] = ACTIONS(3013),
    [anon_sym_not] = ACTIONS(3013),
    [anon_sym_compl] = ACTIONS(3013),
    [anon_sym_DASH_DASH] = ACTIONS(3015),
    [anon_sym_PLUS_PLUS] = ACTIONS(3015),
    [anon_sym_sizeof] = ACTIONS(3013),
    [anon_sym___alignof__] = ACTIONS(3013),
    [anon_sym___alignof] = ACTIONS(3013),
    [anon_sym__alignof] = ACTIONS(3013),
    [anon_sym_alignof] = ACTIONS(3013),
    [anon_sym__Alignof] = ACTIONS(3013),
    [anon_sym_offsetof] = ACTIONS(3013),
    [anon_sym__Generic] = ACTIONS(3013),
    [anon_sym_asm] = ACTIONS(3013),
    [anon_sym___asm__] = ACTIONS(3013),
    [anon_sym___asm] = ACTIONS(3013),
    [sym_number_literal] = ACTIONS(3015),
    [anon_sym_L_SQUOTE] = ACTIONS(3015),
    [anon_sym_u_SQUOTE] = ACTIONS(3015),
    [anon_sym_U_SQUOTE] = ACTIONS(3015),
    [anon_sym_u8_SQUOTE] = ACTIONS(3015),
    [anon_sym_SQUOTE] = ACTIONS(3015),
    [anon_sym_L_DQUOTE] = ACTIONS(3015),
    [anon_sym_u_DQUOTE] = ACTIONS(3015),
    [anon_sym_U_DQUOTE] = ACTIONS(3015),
    [anon_sym_u8_DQUOTE] = ACTIONS(3015),
    [anon_sym_DQUOTE] = ACTIONS(3015),
    [sym_true] = ACTIONS(3013),
    [sym_false] = ACTIONS(3013),
    [anon_sym_NULL] = ACTIONS(3013),
    [anon_sym_nullptr] = ACTIONS(3013),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3013),
    [anon_sym_decltype] = ACTIONS(3013),
    [anon_sym_explicit] = ACTIONS(3013),
    [anon_sym_typename] = ACTIONS(3013),
    [anon_sym_template] = ACTIONS(3013),
    [anon_sym_operator] = ACTIONS(3013),
    [anon_sym_try] = ACTIONS(3013),
    [anon_sym_delete] = ACTIONS(3013),
    [anon_sym_throw] = ACTIONS(3013),
    [anon_sym_namespace] = ACTIONS(3013),
    [anon_sym_using] = ACTIONS(3013),
    [anon_sym_static_assert] = ACTIONS(3013),
    [anon_sym_concept] = ACTIONS(3013),
    [anon_sym_co_return] = ACTIONS(3013),
    [anon_sym_co_yield] = ACTIONS(3013),
    [anon_sym_R_DQUOTE] = ACTIONS(3015),
    [anon_sym_LR_DQUOTE] = ACTIONS(3015),
    [anon_sym_uR_DQUOTE] = ACTIONS(3015),
    [anon_sym_UR_DQUOTE] = ACTIONS(3015),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3015),
    [anon_sym_co_await] = ACTIONS(3013),
    [anon_sym_new] = ACTIONS(3013),
    [anon_sym_requires] = ACTIONS(3013),
    [sym_this] = ACTIONS(3013),
  },
  [749] = {
    [ts_builtin_sym_end] = ACTIONS(3022),
    [sym_identifier] = ACTIONS(3020),
    [aux_sym_preproc_include_token1] = ACTIONS(3020),
    [aux_sym_preproc_def_token1] = ACTIONS(3020),
    [aux_sym_preproc_if_token1] = ACTIONS(3020),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3020),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3020),
    [sym_preproc_directive] = ACTIONS(3020),
    [anon_sym_LPAREN2] = ACTIONS(3022),
    [anon_sym_BANG] = ACTIONS(3022),
    [anon_sym_TILDE] = ACTIONS(3022),
    [anon_sym_DASH] = ACTIONS(3020),
    [anon_sym_PLUS] = ACTIONS(3020),
    [anon_sym_STAR] = ACTIONS(3022),
    [anon_sym_AMP_AMP] = ACTIONS(3022),
    [anon_sym_AMP] = ACTIONS(3020),
    [anon_sym_SEMI] = ACTIONS(3022),
    [anon_sym___extension__] = ACTIONS(3020),
    [anon_sym_typedef] = ACTIONS(3020),
    [anon_sym_virtual] = ACTIONS(3020),
    [anon_sym_extern] = ACTIONS(3020),
    [anon_sym___attribute__] = ACTIONS(3020),
    [anon_sym___attribute] = ACTIONS(3020),
    [anon_sym_COLON_COLON] = ACTIONS(3022),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3022),
    [anon_sym___declspec] = ACTIONS(3020),
    [anon_sym___based] = ACTIONS(3020),
    [anon_sym___cdecl] = ACTIONS(3020),
    [anon_sym___clrcall] = ACTIONS(3020),
    [anon_sym___stdcall] = ACTIONS(3020),
    [anon_sym___fastcall] = ACTIONS(3020),
    [anon_sym___thiscall] = ACTIONS(3020),
    [anon_sym___vectorcall] = ACTIONS(3020),
    [anon_sym_LBRACE] = ACTIONS(3022),
    [anon_sym_signed] = ACTIONS(3020),
    [anon_sym_unsigned] = ACTIONS(3020),
    [anon_sym_long] = ACTIONS(3020),
    [anon_sym_short] = ACTIONS(3020),
    [anon_sym_LBRACK] = ACTIONS(3020),
    [anon_sym_static] = ACTIONS(3020),
    [anon_sym_register] = ACTIONS(3020),
    [anon_sym_inline] = ACTIONS(3020),
    [anon_sym___inline] = ACTIONS(3020),
    [anon_sym___inline__] = ACTIONS(3020),
    [anon_sym___forceinline] = ACTIONS(3020),
    [anon_sym_thread_local] = ACTIONS(3020),
    [anon_sym___thread] = ACTIONS(3020),
    [anon_sym_const] = ACTIONS(3020),
    [anon_sym_constexpr] = ACTIONS(3020),
    [anon_sym_volatile] = ACTIONS(3020),
    [anon_sym_restrict] = ACTIONS(3020),
    [anon_sym___restrict__] = ACTIONS(3020),
    [anon_sym__Atomic] = ACTIONS(3020),
    [anon_sym__Noreturn] = ACTIONS(3020),
    [anon_sym_noreturn] = ACTIONS(3020),
    [anon_sym__Nonnull] = ACTIONS(3020),
    [anon_sym_mutable] = ACTIONS(3020),
    [anon_sym_constinit] = ACTIONS(3020),
    [anon_sym_consteval] = ACTIONS(3020),
    [anon_sym_alignas] = ACTIONS(3020),
    [anon_sym__Alignas] = ACTIONS(3020),
    [sym_primitive_type] = ACTIONS(3020),
    [anon_sym_enum] = ACTIONS(3020),
    [anon_sym_class] = ACTIONS(3020),
    [anon_sym_struct] = ACTIONS(3020),
    [anon_sym_union] = ACTIONS(3020),
    [anon_sym_if] = ACTIONS(3020),
    [anon_sym_switch] = ACTIONS(3020),
    [anon_sym_case] = ACTIONS(3020),
    [anon_sym_default] = ACTIONS(3020),
    [anon_sym_while] = ACTIONS(3020),
    [anon_sym_do] = ACTIONS(3020),
    [anon_sym_for] = ACTIONS(3020),
    [anon_sym_return] = ACTIONS(3020),
    [anon_sym_break] = ACTIONS(3020),
    [anon_sym_continue] = ACTIONS(3020),
    [anon_sym_goto] = ACTIONS(3020),
    [anon_sym_not] = ACTIONS(3020),
    [anon_sym_compl] = ACTIONS(3020),
    [anon_sym_DASH_DASH] = ACTIONS(3022),
    [anon_sym_PLUS_PLUS] = ACTIONS(3022),
    [anon_sym_sizeof] = ACTIONS(3020),
    [anon_sym___alignof__] = ACTIONS(3020),
    [anon_sym___alignof] = ACTIONS(3020),
    [anon_sym__alignof] = ACTIONS(3020),
    [anon_sym_alignof] = ACTIONS(3020),
    [anon_sym__Alignof] = ACTIONS(3020),
    [anon_sym_offsetof] = ACTIONS(3020),
    [anon_sym__Generic] = ACTIONS(3020),
    [anon_sym_asm] = ACTIONS(3020),
    [anon_sym___asm__] = ACTIONS(3020),
    [anon_sym___asm] = ACTIONS(3020),
    [sym_number_literal] = ACTIONS(3022),
    [anon_sym_L_SQUOTE] = ACTIONS(3022),
    [anon_sym_u_SQUOTE] = ACTIONS(3022),
    [anon_sym_U_SQUOTE] = ACTIONS(3022),
    [anon_sym_u8_SQUOTE] = ACTIONS(3022),
    [anon_sym_SQUOTE] = ACTIONS(3022),
    [anon_sym_L_DQUOTE] = ACTIONS(3022),
    [anon_sym_u_DQUOTE] = ACTIONS(3022),
    [anon_sym_U_DQUOTE] = ACTIONS(3022),
    [anon_sym_u8_DQUOTE] = ACTIONS(3022),
    [anon_sym_DQUOTE] = ACTIONS(3022),
    [sym_true] = ACTIONS(3020),
    [sym_false] = ACTIONS(3020),
    [anon_sym_NULL] = ACTIONS(3020),
    [anon_sym_nullptr] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3020),
    [anon_sym_decltype] = ACTIONS(3020),
    [anon_sym_explicit] = ACTIONS(3020),
    [anon_sym_typename] = ACTIONS(3020),
    [anon_sym_template] = ACTIONS(3020),
    [anon_sym_operator] = ACTIONS(3020),
    [anon_sym_try] = ACTIONS(3020),
    [anon_sym_delete] = ACTIONS(3020),
    [anon_sym_throw] = ACTIONS(3020),
    [anon_sym_namespace] = ACTIONS(3020),
    [anon_sym_using] = ACTIONS(3020),
    [anon_sym_static_assert] = ACTIONS(3020),
    [anon_sym_concept] = ACTIONS(3020),
    [anon_sym_co_return] = ACTIONS(3020),
    [anon_sym_co_yield] = ACTIONS(3020),
    [anon_sym_R_DQUOTE] = ACTIONS(3022),
    [anon_sym_LR_DQUOTE] = ACTIONS(3022),
    [anon_sym_uR_DQUOTE] = ACTIONS(3022),
    [anon_sym_UR_DQUOTE] = ACTIONS(3022),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3022),
    [anon_sym_co_await] = ACTIONS(3020),
    [anon_sym_new] = ACTIONS(3020),
    [anon_sym_requires] = ACTIONS(3020),
    [sym_this] = ACTIONS(3020),
  },
  [750] = {
    [ts_builtin_sym_end] = ACTIONS(3028),
    [sym_identifier] = ACTIONS(3026),
    [aux_sym_preproc_include_token1] = ACTIONS(3026),
    [aux_sym_preproc_def_token1] = ACTIONS(3026),
    [aux_sym_preproc_if_token1] = ACTIONS(3026),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3026),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3026),
    [sym_preproc_directive] = ACTIONS(3026),
    [anon_sym_LPAREN2] = ACTIONS(3028),
    [anon_sym_BANG] = ACTIONS(3028),
    [anon_sym_TILDE] = ACTIONS(3028),
    [anon_sym_DASH] = ACTIONS(3026),
    [anon_sym_PLUS] = ACTIONS(3026),
    [anon_sym_STAR] = ACTIONS(3028),
    [anon_sym_AMP_AMP] = ACTIONS(3028),
    [anon_sym_AMP] = ACTIONS(3026),
    [anon_sym_SEMI] = ACTIONS(3028),
    [anon_sym___extension__] = ACTIONS(3026),
    [anon_sym_typedef] = ACTIONS(3026),
    [anon_sym_virtual] = ACTIONS(3026),
    [anon_sym_extern] = ACTIONS(3026),
    [anon_sym___attribute__] = ACTIONS(3026),
    [anon_sym___attribute] = ACTIONS(3026),
    [anon_sym_COLON_COLON] = ACTIONS(3028),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3028),
    [anon_sym___declspec] = ACTIONS(3026),
    [anon_sym___based] = ACTIONS(3026),
    [anon_sym___cdecl] = ACTIONS(3026),
    [anon_sym___clrcall] = ACTIONS(3026),
    [anon_sym___stdcall] = ACTIONS(3026),
    [anon_sym___fastcall] = ACTIONS(3026),
    [anon_sym___thiscall] = ACTIONS(3026),
    [anon_sym___vectorcall] = ACTIONS(3026),
    [anon_sym_LBRACE] = ACTIONS(3028),
    [anon_sym_signed] = ACTIONS(3026),
    [anon_sym_unsigned] = ACTIONS(3026),
    [anon_sym_long] = ACTIONS(3026),
    [anon_sym_short] = ACTIONS(3026),
    [anon_sym_LBRACK] = ACTIONS(3026),
    [anon_sym_static] = ACTIONS(3026),
    [anon_sym_register] = ACTIONS(3026),
    [anon_sym_inline] = ACTIONS(3026),
    [anon_sym___inline] = ACTIONS(3026),
    [anon_sym___inline__] = ACTIONS(3026),
    [anon_sym___forceinline] = ACTIONS(3026),
    [anon_sym_thread_local] = ACTIONS(3026),
    [anon_sym___thread] = ACTIONS(3026),
    [anon_sym_const] = ACTIONS(3026),
    [anon_sym_constexpr] = ACTIONS(3026),
    [anon_sym_volatile] = ACTIONS(3026),
    [anon_sym_restrict] = ACTIONS(3026),
    [anon_sym___restrict__] = ACTIONS(3026),
    [anon_sym__Atomic] = ACTIONS(3026),
    [anon_sym__Noreturn] = ACTIONS(3026),
    [anon_sym_noreturn] = ACTIONS(3026),
    [anon_sym__Nonnull] = ACTIONS(3026),
    [anon_sym_mutable] = ACTIONS(3026),
    [anon_sym_constinit] = ACTIONS(3026),
    [anon_sym_consteval] = ACTIONS(3026),
    [anon_sym_alignas] = ACTIONS(3026),
    [anon_sym__Alignas] = ACTIONS(3026),
    [sym_primitive_type] = ACTIONS(3026),
    [anon_sym_enum] = ACTIONS(3026),
    [anon_sym_class] = ACTIONS(3026),
    [anon_sym_struct] = ACTIONS(3026),
    [anon_sym_union] = ACTIONS(3026),
    [anon_sym_if] = ACTIONS(3026),
    [anon_sym_switch] = ACTIONS(3026),
    [anon_sym_case] = ACTIONS(3026),
    [anon_sym_default] = ACTIONS(3026),
    [anon_sym_while] = ACTIONS(3026),
    [anon_sym_do] = ACTIONS(3026),
    [anon_sym_for] = ACTIONS(3026),
    [anon_sym_return] = ACTIONS(3026),
    [anon_sym_break] = ACTIONS(3026),
    [anon_sym_continue] = ACTIONS(3026),
    [anon_sym_goto] = ACTIONS(3026),
    [anon_sym_not] = ACTIONS(3026),
    [anon_sym_compl] = ACTIONS(3026),
    [anon_sym_DASH_DASH] = ACTIONS(3028),
    [anon_sym_PLUS_PLUS] = ACTIONS(3028),
    [anon_sym_sizeof] = ACTIONS(3026),
    [anon_sym___alignof__] = ACTIONS(3026),
    [anon_sym___alignof] = ACTIONS(3026),
    [anon_sym__alignof] = ACTIONS(3026),
    [anon_sym_alignof] = ACTIONS(3026),
    [anon_sym__Alignof] = ACTIONS(3026),
    [anon_sym_offsetof] = ACTIONS(3026),
    [anon_sym__Generic] = ACTIONS(3026),
    [anon_sym_asm] = ACTIONS(3026),
    [anon_sym___asm__] = ACTIONS(3026),
    [anon_sym___asm] = ACTIONS(3026),
    [sym_number_literal] = ACTIONS(3028),
    [anon_sym_L_SQUOTE] = ACTIONS(3028),
    [anon_sym_u_SQUOTE] = ACTIONS(3028),
    [anon_sym_U_SQUOTE] = ACTIONS(3028),
    [anon_sym_u8_SQUOTE] = ACTIONS(3028),
    [anon_sym_SQUOTE] = ACTIONS(3028),
    [anon_sym_L_DQUOTE] = ACTIONS(3028),
    [anon_sym_u_DQUOTE] = ACTIONS(3028),
    [anon_sym_U_DQUOTE] = ACTIONS(3028),
    [anon_sym_u8_DQUOTE] = ACTIONS(3028),
    [anon_sym_DQUOTE] = ACTIONS(3028),
    [sym_true] = ACTIONS(3026),
    [sym_false] = ACTIONS(3026),
    [anon_sym_NULL] = ACTIONS(3026),
    [anon_sym_nullptr] = ACTIONS(3026),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3026),
    [anon_sym_decltype] = ACTIONS(3026),
    [anon_sym_explicit] = ACTIONS(3026),
    [anon_sym_typename] = ACTIONS(3026),
    [anon_sym_template] = ACTIONS(3026),
    [anon_sym_operator] = ACTIONS(3026),
    [anon_sym_try] = ACTIONS(3026),
    [anon_sym_delete] = ACTIONS(3026),
    [anon_sym_throw] = ACTIONS(3026),
    [anon_sym_namespace] = ACTIONS(3026),
    [anon_sym_using] = ACTIONS(3026),
    [anon_sym_static_assert] = ACTIONS(3026),
    [anon_sym_concept] = ACTIONS(3026),
    [anon_sym_co_return] = ACTIONS(3026),
    [anon_sym_co_yield] = ACTIONS(3026),
    [anon_sym_R_DQUOTE] = ACTIONS(3028),
    [anon_sym_LR_DQUOTE] = ACTIONS(3028),
    [anon_sym_uR_DQUOTE] = ACTIONS(3028),
    [anon_sym_UR_DQUOTE] = ACTIONS(3028),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3028),
    [anon_sym_co_await] = ACTIONS(3026),
    [anon_sym_new] = ACTIONS(3026),
    [anon_sym_requires] = ACTIONS(3026),
    [sym_this] = ACTIONS(3026),
  },
  [751] = {
    [ts_builtin_sym_end] = ACTIONS(3032),
    [sym_identifier] = ACTIONS(3030),
    [aux_sym_preproc_include_token1] = ACTIONS(3030),
    [aux_sym_preproc_def_token1] = ACTIONS(3030),
    [aux_sym_preproc_if_token1] = ACTIONS(3030),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3030),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3030),
    [sym_preproc_directive] = ACTIONS(3030),
    [anon_sym_LPAREN2] = ACTIONS(3032),
    [anon_sym_BANG] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3030),
    [anon_sym_PLUS] = ACTIONS(3030),
    [anon_sym_STAR] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_AMP] = ACTIONS(3030),
    [anon_sym_SEMI] = ACTIONS(3032),
    [anon_sym___extension__] = ACTIONS(3030),
    [anon_sym_typedef] = ACTIONS(3030),
    [anon_sym_virtual] = ACTIONS(3030),
    [anon_sym_extern] = ACTIONS(3030),
    [anon_sym___attribute__] = ACTIONS(3030),
    [anon_sym___attribute] = ACTIONS(3030),
    [anon_sym_COLON_COLON] = ACTIONS(3032),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3032),
    [anon_sym___declspec] = ACTIONS(3030),
    [anon_sym___based] = ACTIONS(3030),
    [anon_sym___cdecl] = ACTIONS(3030),
    [anon_sym___clrcall] = ACTIONS(3030),
    [anon_sym___stdcall] = ACTIONS(3030),
    [anon_sym___fastcall] = ACTIONS(3030),
    [anon_sym___thiscall] = ACTIONS(3030),
    [anon_sym___vectorcall] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_signed] = ACTIONS(3030),
    [anon_sym_unsigned] = ACTIONS(3030),
    [anon_sym_long] = ACTIONS(3030),
    [anon_sym_short] = ACTIONS(3030),
    [anon_sym_LBRACK] = ACTIONS(3030),
    [anon_sym_static] = ACTIONS(3030),
    [anon_sym_register] = ACTIONS(3030),
    [anon_sym_inline] = ACTIONS(3030),
    [anon_sym___inline] = ACTIONS(3030),
    [anon_sym___inline__] = ACTIONS(3030),
    [anon_sym___forceinline] = ACTIONS(3030),
    [anon_sym_thread_local] = ACTIONS(3030),
    [anon_sym___thread] = ACTIONS(3030),
    [anon_sym_const] = ACTIONS(3030),
    [anon_sym_constexpr] = ACTIONS(3030),
    [anon_sym_volatile] = ACTIONS(3030),
    [anon_sym_restrict] = ACTIONS(3030),
    [anon_sym___restrict__] = ACTIONS(3030),
    [anon_sym__Atomic] = ACTIONS(3030),
    [anon_sym__Noreturn] = ACTIONS(3030),
    [anon_sym_noreturn] = ACTIONS(3030),
    [anon_sym__Nonnull] = ACTIONS(3030),
    [anon_sym_mutable] = ACTIONS(3030),
    [anon_sym_constinit] = ACTIONS(3030),
    [anon_sym_consteval] = ACTIONS(3030),
    [anon_sym_alignas] = ACTIONS(3030),
    [anon_sym__Alignas] = ACTIONS(3030),
    [sym_primitive_type] = ACTIONS(3030),
    [anon_sym_enum] = ACTIONS(3030),
    [anon_sym_class] = ACTIONS(3030),
    [anon_sym_struct] = ACTIONS(3030),
    [anon_sym_union] = ACTIONS(3030),
    [anon_sym_if] = ACTIONS(3030),
    [anon_sym_switch] = ACTIONS(3030),
    [anon_sym_case] = ACTIONS(3030),
    [anon_sym_default] = ACTIONS(3030),
    [anon_sym_while] = ACTIONS(3030),
    [anon_sym_do] = ACTIONS(3030),
    [anon_sym_for] = ACTIONS(3030),
    [anon_sym_return] = ACTIONS(3030),
    [anon_sym_break] = ACTIONS(3030),
    [anon_sym_continue] = ACTIONS(3030),
    [anon_sym_goto] = ACTIONS(3030),
    [anon_sym_not] = ACTIONS(3030),
    [anon_sym_compl] = ACTIONS(3030),
    [anon_sym_DASH_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_PLUS] = ACTIONS(3032),
    [anon_sym_sizeof] = ACTIONS(3030),
    [anon_sym___alignof__] = ACTIONS(3030),
    [anon_sym___alignof] = ACTIONS(3030),
    [anon_sym__alignof] = ACTIONS(3030),
    [anon_sym_alignof] = ACTIONS(3030),
    [anon_sym__Alignof] = ACTIONS(3030),
    [anon_sym_offsetof] = ACTIONS(3030),
    [anon_sym__Generic] = ACTIONS(3030),
    [anon_sym_asm] = ACTIONS(3030),
    [anon_sym___asm__] = ACTIONS(3030),
    [anon_sym___asm] = ACTIONS(3030),
    [sym_number_literal] = ACTIONS(3032),
    [anon_sym_L_SQUOTE] = ACTIONS(3032),
    [anon_sym_u_SQUOTE] = ACTIONS(3032),
    [anon_sym_U_SQUOTE] = ACTIONS(3032),
    [anon_sym_u8_SQUOTE] = ACTIONS(3032),
    [anon_sym_SQUOTE] = ACTIONS(3032),
    [anon_sym_L_DQUOTE] = ACTIONS(3032),
    [anon_sym_u_DQUOTE] = ACTIONS(3032),
    [anon_sym_U_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8_DQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [sym_true] = ACTIONS(3030),
    [sym_false] = ACTIONS(3030),
    [anon_sym_NULL] = ACTIONS(3030),
    [anon_sym_nullptr] = ACTIONS(3030),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3030),
    [anon_sym_decltype] = ACTIONS(3030),
    [anon_sym_explicit] = ACTIONS(3030),
    [anon_sym_typename] = ACTIONS(3030),
    [anon_sym_template] = ACTIONS(3030),
    [anon_sym_operator] = ACTIONS(3030),
    [anon_sym_try] = ACTIONS(3030),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_throw] = ACTIONS(3030),
    [anon_sym_namespace] = ACTIONS(3030),
    [anon_sym_using] = ACTIONS(3030),
    [anon_sym_static_assert] = ACTIONS(3030),
    [anon_sym_concept] = ACTIONS(3030),
    [anon_sym_co_return] = ACTIONS(3030),
    [anon_sym_co_yield] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3030),
    [anon_sym_new] = ACTIONS(3030),
    [anon_sym_requires] = ACTIONS(3030),
    [sym_this] = ACTIONS(3030),
  },
  [752] = {
    [ts_builtin_sym_end] = ACTIONS(3032),
    [sym_identifier] = ACTIONS(3030),
    [aux_sym_preproc_include_token1] = ACTIONS(3030),
    [aux_sym_preproc_def_token1] = ACTIONS(3030),
    [aux_sym_preproc_if_token1] = ACTIONS(3030),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3030),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3030),
    [sym_preproc_directive] = ACTIONS(3030),
    [anon_sym_LPAREN2] = ACTIONS(3032),
    [anon_sym_BANG] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3032),
    [anon_sym_DASH] = ACTIONS(3030),
    [anon_sym_PLUS] = ACTIONS(3030),
    [anon_sym_STAR] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_AMP] = ACTIONS(3030),
    [anon_sym_SEMI] = ACTIONS(3032),
    [anon_sym___extension__] = ACTIONS(3030),
    [anon_sym_typedef] = ACTIONS(3030),
    [anon_sym_virtual] = ACTIONS(3030),
    [anon_sym_extern] = ACTIONS(3030),
    [anon_sym___attribute__] = ACTIONS(3030),
    [anon_sym___attribute] = ACTIONS(3030),
    [anon_sym_COLON_COLON] = ACTIONS(3032),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3032),
    [anon_sym___declspec] = ACTIONS(3030),
    [anon_sym___based] = ACTIONS(3030),
    [anon_sym___cdecl] = ACTIONS(3030),
    [anon_sym___clrcall] = ACTIONS(3030),
    [anon_sym___stdcall] = ACTIONS(3030),
    [anon_sym___fastcall] = ACTIONS(3030),
    [anon_sym___thiscall] = ACTIONS(3030),
    [anon_sym___vectorcall] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(3032),
    [anon_sym_signed] = ACTIONS(3030),
    [anon_sym_unsigned] = ACTIONS(3030),
    [anon_sym_long] = ACTIONS(3030),
    [anon_sym_short] = ACTIONS(3030),
    [anon_sym_LBRACK] = ACTIONS(3030),
    [anon_sym_static] = ACTIONS(3030),
    [anon_sym_register] = ACTIONS(3030),
    [anon_sym_inline] = ACTIONS(3030),
    [anon_sym___inline] = ACTIONS(3030),
    [anon_sym___inline__] = ACTIONS(3030),
    [anon_sym___forceinline] = ACTIONS(3030),
    [anon_sym_thread_local] = ACTIONS(3030),
    [anon_sym___thread] = ACTIONS(3030),
    [anon_sym_const] = ACTIONS(3030),
    [anon_sym_constexpr] = ACTIONS(3030),
    [anon_sym_volatile] = ACTIONS(3030),
    [anon_sym_restrict] = ACTIONS(3030),
    [anon_sym___restrict__] = ACTIONS(3030),
    [anon_sym__Atomic] = ACTIONS(3030),
    [anon_sym__Noreturn] = ACTIONS(3030),
    [anon_sym_noreturn] = ACTIONS(3030),
    [anon_sym__Nonnull] = ACTIONS(3030),
    [anon_sym_mutable] = ACTIONS(3030),
    [anon_sym_constinit] = ACTIONS(3030),
    [anon_sym_consteval] = ACTIONS(3030),
    [anon_sym_alignas] = ACTIONS(3030),
    [anon_sym__Alignas] = ACTIONS(3030),
    [sym_primitive_type] = ACTIONS(3030),
    [anon_sym_enum] = ACTIONS(3030),
    [anon_sym_class] = ACTIONS(3030),
    [anon_sym_struct] = ACTIONS(3030),
    [anon_sym_union] = ACTIONS(3030),
    [anon_sym_if] = ACTIONS(3030),
    [anon_sym_switch] = ACTIONS(3030),
    [anon_sym_case] = ACTIONS(3030),
    [anon_sym_default] = ACTIONS(3030),
    [anon_sym_while] = ACTIONS(3030),
    [anon_sym_do] = ACTIONS(3030),
    [anon_sym_for] = ACTIONS(3030),
    [anon_sym_return] = ACTIONS(3030),
    [anon_sym_break] = ACTIONS(3030),
    [anon_sym_continue] = ACTIONS(3030),
    [anon_sym_goto] = ACTIONS(3030),
    [anon_sym_not] = ACTIONS(3030),
    [anon_sym_compl] = ACTIONS(3030),
    [anon_sym_DASH_DASH] = ACTIONS(3032),
    [anon_sym_PLUS_PLUS] = ACTIONS(3032),
    [anon_sym_sizeof] = ACTIONS(3030),
    [anon_sym___alignof__] = ACTIONS(3030),
    [anon_sym___alignof] = ACTIONS(3030),
    [anon_sym__alignof] = ACTIONS(3030),
    [anon_sym_alignof] = ACTIONS(3030),
    [anon_sym__Alignof] = ACTIONS(3030),
    [anon_sym_offsetof] = ACTIONS(3030),
    [anon_sym__Generic] = ACTIONS(3030),
    [anon_sym_asm] = ACTIONS(3030),
    [anon_sym___asm__] = ACTIONS(3030),
    [anon_sym___asm] = ACTIONS(3030),
    [sym_number_literal] = ACTIONS(3032),
    [anon_sym_L_SQUOTE] = ACTIONS(3032),
    [anon_sym_u_SQUOTE] = ACTIONS(3032),
    [anon_sym_U_SQUOTE] = ACTIONS(3032),
    [anon_sym_u8_SQUOTE] = ACTIONS(3032),
    [anon_sym_SQUOTE] = ACTIONS(3032),
    [anon_sym_L_DQUOTE] = ACTIONS(3032),
    [anon_sym_u_DQUOTE] = ACTIONS(3032),
    [anon_sym_U_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8_DQUOTE] = ACTIONS(3032),
    [anon_sym_DQUOTE] = ACTIONS(3032),
    [sym_true] = ACTIONS(3030),
    [sym_false] = ACTIONS(3030),
    [anon_sym_NULL] = ACTIONS(3030),
    [anon_sym_nullptr] = ACTIONS(3030),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3030),
    [anon_sym_decltype] = ACTIONS(3030),
    [anon_sym_explicit] = ACTIONS(3030),
    [anon_sym_typename] = ACTIONS(3030),
    [anon_sym_template] = ACTIONS(3030),
    [anon_sym_operator] = ACTIONS(3030),
    [anon_sym_try] = ACTIONS(3030),
    [anon_sym_delete] = ACTIONS(3030),
    [anon_sym_throw] = ACTIONS(3030),
    [anon_sym_namespace] = ACTIONS(3030),
    [anon_sym_using] = ACTIONS(3030),
    [anon_sym_static_assert] = ACTIONS(3030),
    [anon_sym_concept] = ACTIONS(3030),
    [anon_sym_co_return] = ACTIONS(3030),
    [anon_sym_co_yield] = ACTIONS(3030),
    [anon_sym_R_DQUOTE] = ACTIONS(3032),
    [anon_sym_LR_DQUOTE] = ACTIONS(3032),
    [anon_sym_uR_DQUOTE] = ACTIONS(3032),
    [anon_sym_UR_DQUOTE] = ACTIONS(3032),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3032),
    [anon_sym_co_await] = ACTIONS(3030),
    [anon_sym_new] = ACTIONS(3030),
    [anon_sym_requires] = ACTIONS(3030),
    [sym_this] = ACTIONS(3030),
  },
  [753] = {
    [ts_builtin_sym_end] = ACTIONS(3044),
    [sym_identifier] = ACTIONS(3042),
    [aux_sym_preproc_include_token1] = ACTIONS(3042),
    [aux_sym_preproc_def_token1] = ACTIONS(3042),
    [aux_sym_preproc_if_token1] = ACTIONS(3042),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3042),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3042),
    [sym_preproc_directive] = ACTIONS(3042),
    [anon_sym_LPAREN2] = ACTIONS(3044),
    [anon_sym_BANG] = ACTIONS(3044),
    [anon_sym_TILDE] = ACTIONS(3044),
    [anon_sym_DASH] = ACTIONS(3042),
    [anon_sym_PLUS] = ACTIONS(3042),
    [anon_sym_STAR] = ACTIONS(3044),
    [anon_sym_AMP_AMP] = ACTIONS(3044),
    [anon_sym_AMP] = ACTIONS(3042),
    [anon_sym_SEMI] = ACTIONS(3044),
    [anon_sym___extension__] = ACTIONS(3042),
    [anon_sym_typedef] = ACTIONS(3042),
    [anon_sym_virtual] = ACTIONS(3042),
    [anon_sym_extern] = ACTIONS(3042),
    [anon_sym___attribute__] = ACTIONS(3042),
    [anon_sym___attribute] = ACTIONS(3042),
    [anon_sym_COLON_COLON] = ACTIONS(3044),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3044),
    [anon_sym___declspec] = ACTIONS(3042),
    [anon_sym___based] = ACTIONS(3042),
    [anon_sym___cdecl] = ACTIONS(3042),
    [anon_sym___clrcall] = ACTIONS(3042),
    [anon_sym___stdcall] = ACTIONS(3042),
    [anon_sym___fastcall] = ACTIONS(3042),
    [anon_sym___thiscall] = ACTIONS(3042),
    [anon_sym___vectorcall] = ACTIONS(3042),
    [anon_sym_LBRACE] = ACTIONS(3044),
    [anon_sym_signed] = ACTIONS(3042),
    [anon_sym_unsigned] = ACTIONS(3042),
    [anon_sym_long] = ACTIONS(3042),
    [anon_sym_short] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3042),
    [anon_sym_static] = ACTIONS(3042),
    [anon_sym_register] = ACTIONS(3042),
    [anon_sym_inline] = ACTIONS(3042),
    [anon_sym___inline] = ACTIONS(3042),
    [anon_sym___inline__] = ACTIONS(3042),
    [anon_sym___forceinline] = ACTIONS(3042),
    [anon_sym_thread_local] = ACTIONS(3042),
    [anon_sym___thread] = ACTIONS(3042),
    [anon_sym_const] = ACTIONS(3042),
    [anon_sym_constexpr] = ACTIONS(3042),
    [anon_sym_volatile] = ACTIONS(3042),
    [anon_sym_restrict] = ACTIONS(3042),
    [anon_sym___restrict__] = ACTIONS(3042),
    [anon_sym__Atomic] = ACTIONS(3042),
    [anon_sym__Noreturn] = ACTIONS(3042),
    [anon_sym_noreturn] = ACTIONS(3042),
    [anon_sym__Nonnull] = ACTIONS(3042),
    [anon_sym_mutable] = ACTIONS(3042),
    [anon_sym_constinit] = ACTIONS(3042),
    [anon_sym_consteval] = ACTIONS(3042),
    [anon_sym_alignas] = ACTIONS(3042),
    [anon_sym__Alignas] = ACTIONS(3042),
    [sym_primitive_type] = ACTIONS(3042),
    [anon_sym_enum] = ACTIONS(3042),
    [anon_sym_class] = ACTIONS(3042),
    [anon_sym_struct] = ACTIONS(3042),
    [anon_sym_union] = ACTIONS(3042),
    [anon_sym_if] = ACTIONS(3042),
    [anon_sym_switch] = ACTIONS(3042),
    [anon_sym_case] = ACTIONS(3042),
    [anon_sym_default] = ACTIONS(3042),
    [anon_sym_while] = ACTIONS(3042),
    [anon_sym_do] = ACTIONS(3042),
    [anon_sym_for] = ACTIONS(3042),
    [anon_sym_return] = ACTIONS(3042),
    [anon_sym_break] = ACTIONS(3042),
    [anon_sym_continue] = ACTIONS(3042),
    [anon_sym_goto] = ACTIONS(3042),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_compl] = ACTIONS(3042),
    [anon_sym_DASH_DASH] = ACTIONS(3044),
    [anon_sym_PLUS_PLUS] = ACTIONS(3044),
    [anon_sym_sizeof] = ACTIONS(3042),
    [anon_sym___alignof__] = ACTIONS(3042),
    [anon_sym___alignof] = ACTIONS(3042),
    [anon_sym__alignof] = ACTIONS(3042),
    [anon_sym_alignof] = ACTIONS(3042),
    [anon_sym__Alignof] = ACTIONS(3042),
    [anon_sym_offsetof] = ACTIONS(3042),
    [anon_sym__Generic] = ACTIONS(3042),
    [anon_sym_asm] = ACTIONS(3042),
    [anon_sym___asm__] = ACTIONS(3042),
    [anon_sym___asm] = ACTIONS(3042),
    [sym_number_literal] = ACTIONS(3044),
    [anon_sym_L_SQUOTE] = ACTIONS(3044),
    [anon_sym_u_SQUOTE] = ACTIONS(3044),
    [anon_sym_U_SQUOTE] = ACTIONS(3044),
    [anon_sym_u8_SQUOTE] = ACTIONS(3044),
    [anon_sym_SQUOTE] = ACTIONS(3044),
    [anon_sym_L_DQUOTE] = ACTIONS(3044),
    [anon_sym_u_DQUOTE] = ACTIONS(3044),
    [anon_sym_U_DQUOTE] = ACTIONS(3044),
    [anon_sym_u8_DQUOTE] = ACTIONS(3044),
    [anon_sym_DQUOTE] = ACTIONS(3044),
    [sym_true] = ACTIONS(3042),
    [sym_false] = ACTIONS(3042),
    [anon_sym_NULL] = ACTIONS(3042),
    [anon_sym_nullptr] = ACTIONS(3042),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3042),
    [anon_sym_decltype] = ACTIONS(3042),
    [anon_sym_explicit] = ACTIONS(3042),
    [anon_sym_typename] = ACTIONS(3042),
    [anon_sym_template] = ACTIONS(3042),
    [anon_sym_operator] = ACTIONS(3042),
    [anon_sym_try] = ACTIONS(3042),
    [anon_sym_delete] = ACTIONS(3042),
    [anon_sym_throw] = ACTIONS(3042),
    [anon_sym_namespace] = ACTIONS(3042),
    [anon_sym_using] = ACTIONS(3042),
    [anon_sym_static_assert] = ACTIONS(3042),
    [anon_sym_concept] = ACTIONS(3042),
    [anon_sym_co_return] = ACTIONS(3042),
    [anon_sym_co_yield] = ACTIONS(3042),
    [anon_sym_R_DQUOTE] = ACTIONS(3044),
    [anon_sym_LR_DQUOTE] = ACTIONS(3044),
    [anon_sym_uR_DQUOTE] = ACTIONS(3044),
    [anon_sym_UR_DQUOTE] = ACTIONS(3044),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3044),
    [anon_sym_co_await] = ACTIONS(3042),
    [anon_sym_new] = ACTIONS(3042),
    [anon_sym_requires] = ACTIONS(3042),
    [sym_this] = ACTIONS(3042),
  },
  [754] = {
    [ts_builtin_sym_end] = ACTIONS(2820),
    [sym_identifier] = ACTIONS(2818),
    [aux_sym_preproc_include_token1] = ACTIONS(2818),
    [aux_sym_preproc_def_token1] = ACTIONS(2818),
    [aux_sym_preproc_if_token1] = ACTIONS(2818),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2818),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2818),
    [sym_preproc_directive] = ACTIONS(2818),
    [anon_sym_LPAREN2] = ACTIONS(2820),
    [anon_sym_BANG] = ACTIONS(2820),
    [anon_sym_TILDE] = ACTIONS(2820),
    [anon_sym_DASH] = ACTIONS(2818),
    [anon_sym_PLUS] = ACTIONS(2818),
    [anon_sym_STAR] = ACTIONS(2820),
    [anon_sym_AMP_AMP] = ACTIONS(2820),
    [anon_sym_AMP] = ACTIONS(2818),
    [anon_sym_SEMI] = ACTIONS(2820),
    [anon_sym___extension__] = ACTIONS(2818),
    [anon_sym_typedef] = ACTIONS(2818),
    [anon_sym_virtual] = ACTIONS(2818),
    [anon_sym_extern] = ACTIONS(2818),
    [anon_sym___attribute__] = ACTIONS(2818),
    [anon_sym___attribute] = ACTIONS(2818),
    [anon_sym_COLON_COLON] = ACTIONS(2820),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2820),
    [anon_sym___declspec] = ACTIONS(2818),
    [anon_sym___based] = ACTIONS(2818),
    [anon_sym___cdecl] = ACTIONS(2818),
    [anon_sym___clrcall] = ACTIONS(2818),
    [anon_sym___stdcall] = ACTIONS(2818),
    [anon_sym___fastcall] = ACTIONS(2818),
    [anon_sym___thiscall] = ACTIONS(2818),
    [anon_sym___vectorcall] = ACTIONS(2818),
    [anon_sym_LBRACE] = ACTIONS(2820),
    [anon_sym_signed] = ACTIONS(2818),
    [anon_sym_unsigned] = ACTIONS(2818),
    [anon_sym_long] = ACTIONS(2818),
    [anon_sym_short] = ACTIONS(2818),
    [anon_sym_LBRACK] = ACTIONS(2818),
    [anon_sym_static] = ACTIONS(2818),
    [anon_sym_register] = ACTIONS(2818),
    [anon_sym_inline] = ACTIONS(2818),
    [anon_sym___inline] = ACTIONS(2818),
    [anon_sym___inline__] = ACTIONS(2818),
    [anon_sym___forceinline] = ACTIONS(2818),
    [anon_sym_thread_local] = ACTIONS(2818),
    [anon_sym___thread] = ACTIONS(2818),
    [anon_sym_const] = ACTIONS(2818),
    [anon_sym_constexpr] = ACTIONS(2818),
    [anon_sym_volatile] = ACTIONS(2818),
    [anon_sym_restrict] = ACTIONS(2818),
    [anon_sym___restrict__] = ACTIONS(2818),
    [anon_sym__Atomic] = ACTIONS(2818),
    [anon_sym__Noreturn] = ACTIONS(2818),
    [anon_sym_noreturn] = ACTIONS(2818),
    [anon_sym__Nonnull] = ACTIONS(2818),
    [anon_sym_mutable] = ACTIONS(2818),
    [anon_sym_constinit] = ACTIONS(2818),
    [anon_sym_consteval] = ACTIONS(2818),
    [anon_sym_alignas] = ACTIONS(2818),
    [anon_sym__Alignas] = ACTIONS(2818),
    [sym_primitive_type] = ACTIONS(2818),
    [anon_sym_enum] = ACTIONS(2818),
    [anon_sym_class] = ACTIONS(2818),
    [anon_sym_struct] = ACTIONS(2818),
    [anon_sym_union] = ACTIONS(2818),
    [anon_sym_if] = ACTIONS(2818),
    [anon_sym_switch] = ACTIONS(2818),
    [anon_sym_case] = ACTIONS(2818),
    [anon_sym_default] = ACTIONS(2818),
    [anon_sym_while] = ACTIONS(2818),
    [anon_sym_do] = ACTIONS(2818),
    [anon_sym_for] = ACTIONS(2818),
    [anon_sym_return] = ACTIONS(2818),
    [anon_sym_break] = ACTIONS(2818),
    [anon_sym_continue] = ACTIONS(2818),
    [anon_sym_goto] = ACTIONS(2818),
    [anon_sym_not] = ACTIONS(2818),
    [anon_sym_compl] = ACTIONS(2818),
    [anon_sym_DASH_DASH] = ACTIONS(2820),
    [anon_sym_PLUS_PLUS] = ACTIONS(2820),
    [anon_sym_sizeof] = ACTIONS(2818),
    [anon_sym___alignof__] = ACTIONS(2818),
    [anon_sym___alignof] = ACTIONS(2818),
    [anon_sym__alignof] = ACTIONS(2818),
    [anon_sym_alignof] = ACTIONS(2818),
    [anon_sym__Alignof] = ACTIONS(2818),
    [anon_sym_offsetof] = ACTIONS(2818),
    [anon_sym__Generic] = ACTIONS(2818),
    [anon_sym_asm] = ACTIONS(2818),
    [anon_sym___asm__] = ACTIONS(2818),
    [anon_sym___asm] = ACTIONS(2818),
    [sym_number_literal] = ACTIONS(2820),
    [anon_sym_L_SQUOTE] = ACTIONS(2820),
    [anon_sym_u_SQUOTE] = ACTIONS(2820),
    [anon_sym_U_SQUOTE] = ACTIONS(2820),
    [anon_sym_u8_SQUOTE] = ACTIONS(2820),
    [anon_sym_SQUOTE] = ACTIONS(2820),
    [anon_sym_L_DQUOTE] = ACTIONS(2820),
    [anon_sym_u_DQUOTE] = ACTIONS(2820),
    [anon_sym_U_DQUOTE] = ACTIONS(2820),
    [anon_sym_u8_DQUOTE] = ACTIONS(2820),
    [anon_sym_DQUOTE] = ACTIONS(2820),
    [sym_true] = ACTIONS(2818),
    [sym_false] = ACTIONS(2818),
    [anon_sym_NULL] = ACTIONS(2818),
    [anon_sym_nullptr] = ACTIONS(2818),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2818),
    [anon_sym_decltype] = ACTIONS(2818),
    [anon_sym_explicit] = ACTIONS(2818),
    [anon_sym_typename] = ACTIONS(2818),
    [anon_sym_template] = ACTIONS(2818),
    [anon_sym_operator] = ACTIONS(2818),
    [anon_sym_try] = ACTIONS(2818),
    [anon_sym_delete] = ACTIONS(2818),
    [anon_sym_throw] = ACTIONS(2818),
    [anon_sym_namespace] = ACTIONS(2818),
    [anon_sym_using] = ACTIONS(2818),
    [anon_sym_static_assert] = ACTIONS(2818),
    [anon_sym_concept] = ACTIONS(2818),
    [anon_sym_co_return] = ACTIONS(2818),
    [anon_sym_co_yield] = ACTIONS(2818),
    [anon_sym_R_DQUOTE] = ACTIONS(2820),
    [anon_sym_LR_DQUOTE] = ACTIONS(2820),
    [anon_sym_uR_DQUOTE] = ACTIONS(2820),
    [anon_sym_UR_DQUOTE] = ACTIONS(2820),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2820),
    [anon_sym_co_await] = ACTIONS(2818),
    [anon_sym_new] = ACTIONS(2818),
    [anon_sym_requires] = ACTIONS(2818),
    [sym_this] = ACTIONS(2818),
  },
  [755] = {
    [ts_builtin_sym_end] = ACTIONS(2824),
    [sym_identifier] = ACTIONS(2822),
    [aux_sym_preproc_include_token1] = ACTIONS(2822),
    [aux_sym_preproc_def_token1] = ACTIONS(2822),
    [aux_sym_preproc_if_token1] = ACTIONS(2822),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2822),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2822),
    [sym_preproc_directive] = ACTIONS(2822),
    [anon_sym_LPAREN2] = ACTIONS(2824),
    [anon_sym_BANG] = ACTIONS(2824),
    [anon_sym_TILDE] = ACTIONS(2824),
    [anon_sym_DASH] = ACTIONS(2822),
    [anon_sym_PLUS] = ACTIONS(2822),
    [anon_sym_STAR] = ACTIONS(2824),
    [anon_sym_AMP_AMP] = ACTIONS(2824),
    [anon_sym_AMP] = ACTIONS(2822),
    [anon_sym_SEMI] = ACTIONS(2824),
    [anon_sym___extension__] = ACTIONS(2822),
    [anon_sym_typedef] = ACTIONS(2822),
    [anon_sym_virtual] = ACTIONS(2822),
    [anon_sym_extern] = ACTIONS(2822),
    [anon_sym___attribute__] = ACTIONS(2822),
    [anon_sym___attribute] = ACTIONS(2822),
    [anon_sym_COLON_COLON] = ACTIONS(2824),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2824),
    [anon_sym___declspec] = ACTIONS(2822),
    [anon_sym___based] = ACTIONS(2822),
    [anon_sym___cdecl] = ACTIONS(2822),
    [anon_sym___clrcall] = ACTIONS(2822),
    [anon_sym___stdcall] = ACTIONS(2822),
    [anon_sym___fastcall] = ACTIONS(2822),
    [anon_sym___thiscall] = ACTIONS(2822),
    [anon_sym___vectorcall] = ACTIONS(2822),
    [anon_sym_LBRACE] = ACTIONS(2824),
    [anon_sym_signed] = ACTIONS(2822),
    [anon_sym_unsigned] = ACTIONS(2822),
    [anon_sym_long] = ACTIONS(2822),
    [anon_sym_short] = ACTIONS(2822),
    [anon_sym_LBRACK] = ACTIONS(2822),
    [anon_sym_static] = ACTIONS(2822),
    [anon_sym_register] = ACTIONS(2822),
    [anon_sym_inline] = ACTIONS(2822),
    [anon_sym___inline] = ACTIONS(2822),
    [anon_sym___inline__] = ACTIONS(2822),
    [anon_sym___forceinline] = ACTIONS(2822),
    [anon_sym_thread_local] = ACTIONS(2822),
    [anon_sym___thread] = ACTIONS(2822),
    [anon_sym_const] = ACTIONS(2822),
    [anon_sym_constexpr] = ACTIONS(2822),
    [anon_sym_volatile] = ACTIONS(2822),
    [anon_sym_restrict] = ACTIONS(2822),
    [anon_sym___restrict__] = ACTIONS(2822),
    [anon_sym__Atomic] = ACTIONS(2822),
    [anon_sym__Noreturn] = ACTIONS(2822),
    [anon_sym_noreturn] = ACTIONS(2822),
    [anon_sym__Nonnull] = ACTIONS(2822),
    [anon_sym_mutable] = ACTIONS(2822),
    [anon_sym_constinit] = ACTIONS(2822),
    [anon_sym_consteval] = ACTIONS(2822),
    [anon_sym_alignas] = ACTIONS(2822),
    [anon_sym__Alignas] = ACTIONS(2822),
    [sym_primitive_type] = ACTIONS(2822),
    [anon_sym_enum] = ACTIONS(2822),
    [anon_sym_class] = ACTIONS(2822),
    [anon_sym_struct] = ACTIONS(2822),
    [anon_sym_union] = ACTIONS(2822),
    [anon_sym_if] = ACTIONS(2822),
    [anon_sym_switch] = ACTIONS(2822),
    [anon_sym_case] = ACTIONS(2822),
    [anon_sym_default] = ACTIONS(2822),
    [anon_sym_while] = ACTIONS(2822),
    [anon_sym_do] = ACTIONS(2822),
    [anon_sym_for] = ACTIONS(2822),
    [anon_sym_return] = ACTIONS(2822),
    [anon_sym_break] = ACTIONS(2822),
    [anon_sym_continue] = ACTIONS(2822),
    [anon_sym_goto] = ACTIONS(2822),
    [anon_sym_not] = ACTIONS(2822),
    [anon_sym_compl] = ACTIONS(2822),
    [anon_sym_DASH_DASH] = ACTIONS(2824),
    [anon_sym_PLUS_PLUS] = ACTIONS(2824),
    [anon_sym_sizeof] = ACTIONS(2822),
    [anon_sym___alignof__] = ACTIONS(2822),
    [anon_sym___alignof] = ACTIONS(2822),
    [anon_sym__alignof] = ACTIONS(2822),
    [anon_sym_alignof] = ACTIONS(2822),
    [anon_sym__Alignof] = ACTIONS(2822),
    [anon_sym_offsetof] = ACTIONS(2822),
    [anon_sym__Generic] = ACTIONS(2822),
    [anon_sym_asm] = ACTIONS(2822),
    [anon_sym___asm__] = ACTIONS(2822),
    [anon_sym___asm] = ACTIONS(2822),
    [sym_number_literal] = ACTIONS(2824),
    [anon_sym_L_SQUOTE] = ACTIONS(2824),
    [anon_sym_u_SQUOTE] = ACTIONS(2824),
    [anon_sym_U_SQUOTE] = ACTIONS(2824),
    [anon_sym_u8_SQUOTE] = ACTIONS(2824),
    [anon_sym_SQUOTE] = ACTIONS(2824),
    [anon_sym_L_DQUOTE] = ACTIONS(2824),
    [anon_sym_u_DQUOTE] = ACTIONS(2824),
    [anon_sym_U_DQUOTE] = ACTIONS(2824),
    [anon_sym_u8_DQUOTE] = ACTIONS(2824),
    [anon_sym_DQUOTE] = ACTIONS(2824),
    [sym_true] = ACTIONS(2822),
    [sym_false] = ACTIONS(2822),
    [anon_sym_NULL] = ACTIONS(2822),
    [anon_sym_nullptr] = ACTIONS(2822),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2822),
    [anon_sym_decltype] = ACTIONS(2822),
    [anon_sym_explicit] = ACTIONS(2822),
    [anon_sym_typename] = ACTIONS(2822),
    [anon_sym_template] = ACTIONS(2822),
    [anon_sym_operator] = ACTIONS(2822),
    [anon_sym_try] = ACTIONS(2822),
    [anon_sym_delete] = ACTIONS(2822),
    [anon_sym_throw] = ACTIONS(2822),
    [anon_sym_namespace] = ACTIONS(2822),
    [anon_sym_using] = ACTIONS(2822),
    [anon_sym_static_assert] = ACTIONS(2822),
    [anon_sym_concept] = ACTIONS(2822),
    [anon_sym_co_return] = ACTIONS(2822),
    [anon_sym_co_yield] = ACTIONS(2822),
    [anon_sym_R_DQUOTE] = ACTIONS(2824),
    [anon_sym_LR_DQUOTE] = ACTIONS(2824),
    [anon_sym_uR_DQUOTE] = ACTIONS(2824),
    [anon_sym_UR_DQUOTE] = ACTIONS(2824),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2824),
    [anon_sym_co_await] = ACTIONS(2822),
    [anon_sym_new] = ACTIONS(2822),
    [anon_sym_requires] = ACTIONS(2822),
    [sym_this] = ACTIONS(2822),
  },
  [756] = {
    [ts_builtin_sym_end] = ACTIONS(3044),
    [sym_identifier] = ACTIONS(3042),
    [aux_sym_preproc_include_token1] = ACTIONS(3042),
    [aux_sym_preproc_def_token1] = ACTIONS(3042),
    [aux_sym_preproc_if_token1] = ACTIONS(3042),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3042),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3042),
    [sym_preproc_directive] = ACTIONS(3042),
    [anon_sym_LPAREN2] = ACTIONS(3044),
    [anon_sym_BANG] = ACTIONS(3044),
    [anon_sym_TILDE] = ACTIONS(3044),
    [anon_sym_DASH] = ACTIONS(3042),
    [anon_sym_PLUS] = ACTIONS(3042),
    [anon_sym_STAR] = ACTIONS(3044),
    [anon_sym_AMP_AMP] = ACTIONS(3044),
    [anon_sym_AMP] = ACTIONS(3042),
    [anon_sym_SEMI] = ACTIONS(3044),
    [anon_sym___extension__] = ACTIONS(3042),
    [anon_sym_typedef] = ACTIONS(3042),
    [anon_sym_virtual] = ACTIONS(3042),
    [anon_sym_extern] = ACTIONS(3042),
    [anon_sym___attribute__] = ACTIONS(3042),
    [anon_sym___attribute] = ACTIONS(3042),
    [anon_sym_COLON_COLON] = ACTIONS(3044),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3044),
    [anon_sym___declspec] = ACTIONS(3042),
    [anon_sym___based] = ACTIONS(3042),
    [anon_sym___cdecl] = ACTIONS(3042),
    [anon_sym___clrcall] = ACTIONS(3042),
    [anon_sym___stdcall] = ACTIONS(3042),
    [anon_sym___fastcall] = ACTIONS(3042),
    [anon_sym___thiscall] = ACTIONS(3042),
    [anon_sym___vectorcall] = ACTIONS(3042),
    [anon_sym_LBRACE] = ACTIONS(3044),
    [anon_sym_signed] = ACTIONS(3042),
    [anon_sym_unsigned] = ACTIONS(3042),
    [anon_sym_long] = ACTIONS(3042),
    [anon_sym_short] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3042),
    [anon_sym_static] = ACTIONS(3042),
    [anon_sym_register] = ACTIONS(3042),
    [anon_sym_inline] = ACTIONS(3042),
    [anon_sym___inline] = ACTIONS(3042),
    [anon_sym___inline__] = ACTIONS(3042),
    [anon_sym___forceinline] = ACTIONS(3042),
    [anon_sym_thread_local] = ACTIONS(3042),
    [anon_sym___thread] = ACTIONS(3042),
    [anon_sym_const] = ACTIONS(3042),
    [anon_sym_constexpr] = ACTIONS(3042),
    [anon_sym_volatile] = ACTIONS(3042),
    [anon_sym_restrict] = ACTIONS(3042),
    [anon_sym___restrict__] = ACTIONS(3042),
    [anon_sym__Atomic] = ACTIONS(3042),
    [anon_sym__Noreturn] = ACTIONS(3042),
    [anon_sym_noreturn] = ACTIONS(3042),
    [anon_sym__Nonnull] = ACTIONS(3042),
    [anon_sym_mutable] = ACTIONS(3042),
    [anon_sym_constinit] = ACTIONS(3042),
    [anon_sym_consteval] = ACTIONS(3042),
    [anon_sym_alignas] = ACTIONS(3042),
    [anon_sym__Alignas] = ACTIONS(3042),
    [sym_primitive_type] = ACTIONS(3042),
    [anon_sym_enum] = ACTIONS(3042),
    [anon_sym_class] = ACTIONS(3042),
    [anon_sym_struct] = ACTIONS(3042),
    [anon_sym_union] = ACTIONS(3042),
    [anon_sym_if] = ACTIONS(3042),
    [anon_sym_switch] = ACTIONS(3042),
    [anon_sym_case] = ACTIONS(3042),
    [anon_sym_default] = ACTIONS(3042),
    [anon_sym_while] = ACTIONS(3042),
    [anon_sym_do] = ACTIONS(3042),
    [anon_sym_for] = ACTIONS(3042),
    [anon_sym_return] = ACTIONS(3042),
    [anon_sym_break] = ACTIONS(3042),
    [anon_sym_continue] = ACTIONS(3042),
    [anon_sym_goto] = ACTIONS(3042),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_compl] = ACTIONS(3042),
    [anon_sym_DASH_DASH] = ACTIONS(3044),
    [anon_sym_PLUS_PLUS] = ACTIONS(3044),
    [anon_sym_sizeof] = ACTIONS(3042),
    [anon_sym___alignof__] = ACTIONS(3042),
    [anon_sym___alignof] = ACTIONS(3042),
    [anon_sym__alignof] = ACTIONS(3042),
    [anon_sym_alignof] = ACTIONS(3042),
    [anon_sym__Alignof] = ACTIONS(3042),
    [anon_sym_offsetof] = ACTIONS(3042),
    [anon_sym__Generic] = ACTIONS(3042),
    [anon_sym_asm] = ACTIONS(3042),
    [anon_sym___asm__] = ACTIONS(3042),
    [anon_sym___asm] = ACTIONS(3042),
    [sym_number_literal] = ACTIONS(3044),
    [anon_sym_L_SQUOTE] = ACTIONS(3044),
    [anon_sym_u_SQUOTE] = ACTIONS(3044),
    [anon_sym_U_SQUOTE] = ACTIONS(3044),
    [anon_sym_u8_SQUOTE] = ACTIONS(3044),
    [anon_sym_SQUOTE] = ACTIONS(3044),
    [anon_sym_L_DQUOTE] = ACTIONS(3044),
    [anon_sym_u_DQUOTE] = ACTIONS(3044),
    [anon_sym_U_DQUOTE] = ACTIONS(3044),
    [anon_sym_u8_DQUOTE] = ACTIONS(3044),
    [anon_sym_DQUOTE] = ACTIONS(3044),
    [sym_true] = ACTIONS(3042),
    [sym_false] = ACTIONS(3042),
    [anon_sym_NULL] = ACTIONS(3042),
    [anon_sym_nullptr] = ACTIONS(3042),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3042),
    [anon_sym_decltype] = ACTIONS(3042),
    [anon_sym_explicit] = ACTIONS(3042),
    [anon_sym_typename] = ACTIONS(3042),
    [anon_sym_template] = ACTIONS(3042),
    [anon_sym_operator] = ACTIONS(3042),
    [anon_sym_try] = ACTIONS(3042),
    [anon_sym_delete] = ACTIONS(3042),
    [anon_sym_throw] = ACTIONS(3042),
    [anon_sym_namespace] = ACTIONS(3042),
    [anon_sym_using] = ACTIONS(3042),
    [anon_sym_static_assert] = ACTIONS(3042),
    [anon_sym_concept] = ACTIONS(3042),
    [anon_sym_co_return] = ACTIONS(3042),
    [anon_sym_co_yield] = ACTIONS(3042),
    [anon_sym_R_DQUOTE] = ACTIONS(3044),
    [anon_sym_LR_DQUOTE] = ACTIONS(3044),
    [anon_sym_uR_DQUOTE] = ACTIONS(3044),
    [anon_sym_UR_DQUOTE] = ACTIONS(3044),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3044),
    [anon_sym_co_await] = ACTIONS(3042),
    [anon_sym_new] = ACTIONS(3042),
    [anon_sym_requires] = ACTIONS(3042),
    [sym_this] = ACTIONS(3042),
  },
  [757] = {
    [ts_builtin_sym_end] = ACTIONS(3052),
    [sym_identifier] = ACTIONS(3050),
    [aux_sym_preproc_include_token1] = ACTIONS(3050),
    [aux_sym_preproc_def_token1] = ACTIONS(3050),
    [aux_sym_preproc_if_token1] = ACTIONS(3050),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3050),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3050),
    [sym_preproc_directive] = ACTIONS(3050),
    [anon_sym_LPAREN2] = ACTIONS(3052),
    [anon_sym_BANG] = ACTIONS(3052),
    [anon_sym_TILDE] = ACTIONS(3052),
    [anon_sym_DASH] = ACTIONS(3050),
    [anon_sym_PLUS] = ACTIONS(3050),
    [anon_sym_STAR] = ACTIONS(3052),
    [anon_sym_AMP_AMP] = ACTIONS(3052),
    [anon_sym_AMP] = ACTIONS(3050),
    [anon_sym_SEMI] = ACTIONS(3052),
    [anon_sym___extension__] = ACTIONS(3050),
    [anon_sym_typedef] = ACTIONS(3050),
    [anon_sym_virtual] = ACTIONS(3050),
    [anon_sym_extern] = ACTIONS(3050),
    [anon_sym___attribute__] = ACTIONS(3050),
    [anon_sym___attribute] = ACTIONS(3050),
    [anon_sym_COLON_COLON] = ACTIONS(3052),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3052),
    [anon_sym___declspec] = ACTIONS(3050),
    [anon_sym___based] = ACTIONS(3050),
    [anon_sym___cdecl] = ACTIONS(3050),
    [anon_sym___clrcall] = ACTIONS(3050),
    [anon_sym___stdcall] = ACTIONS(3050),
    [anon_sym___fastcall] = ACTIONS(3050),
    [anon_sym___thiscall] = ACTIONS(3050),
    [anon_sym___vectorcall] = ACTIONS(3050),
    [anon_sym_LBRACE] = ACTIONS(3052),
    [anon_sym_signed] = ACTIONS(3050),
    [anon_sym_unsigned] = ACTIONS(3050),
    [anon_sym_long] = ACTIONS(3050),
    [anon_sym_short] = ACTIONS(3050),
    [anon_sym_LBRACK] = ACTIONS(3050),
    [anon_sym_static] = ACTIONS(3050),
    [anon_sym_register] = ACTIONS(3050),
    [anon_sym_inline] = ACTIONS(3050),
    [anon_sym___inline] = ACTIONS(3050),
    [anon_sym___inline__] = ACTIONS(3050),
    [anon_sym___forceinline] = ACTIONS(3050),
    [anon_sym_thread_local] = ACTIONS(3050),
    [anon_sym___thread] = ACTIONS(3050),
    [anon_sym_const] = ACTIONS(3050),
    [anon_sym_constexpr] = ACTIONS(3050),
    [anon_sym_volatile] = ACTIONS(3050),
    [anon_sym_restrict] = ACTIONS(3050),
    [anon_sym___restrict__] = ACTIONS(3050),
    [anon_sym__Atomic] = ACTIONS(3050),
    [anon_sym__Noreturn] = ACTIONS(3050),
    [anon_sym_noreturn] = ACTIONS(3050),
    [anon_sym__Nonnull] = ACTIONS(3050),
    [anon_sym_mutable] = ACTIONS(3050),
    [anon_sym_constinit] = ACTIONS(3050),
    [anon_sym_consteval] = ACTIONS(3050),
    [anon_sym_alignas] = ACTIONS(3050),
    [anon_sym__Alignas] = ACTIONS(3050),
    [sym_primitive_type] = ACTIONS(3050),
    [anon_sym_enum] = ACTIONS(3050),
    [anon_sym_class] = ACTIONS(3050),
    [anon_sym_struct] = ACTIONS(3050),
    [anon_sym_union] = ACTIONS(3050),
    [anon_sym_if] = ACTIONS(3050),
    [anon_sym_switch] = ACTIONS(3050),
    [anon_sym_case] = ACTIONS(3050),
    [anon_sym_default] = ACTIONS(3050),
    [anon_sym_while] = ACTIONS(3050),
    [anon_sym_do] = ACTIONS(3050),
    [anon_sym_for] = ACTIONS(3050),
    [anon_sym_return] = ACTIONS(3050),
    [anon_sym_break] = ACTIONS(3050),
    [anon_sym_continue] = ACTIONS(3050),
    [anon_sym_goto] = ACTIONS(3050),
    [anon_sym_not] = ACTIONS(3050),
    [anon_sym_compl] = ACTIONS(3050),
    [anon_sym_DASH_DASH] = ACTIONS(3052),
    [anon_sym_PLUS_PLUS] = ACTIONS(3052),
    [anon_sym_sizeof] = ACTIONS(3050),
    [anon_sym___alignof__] = ACTIONS(3050),
    [anon_sym___alignof] = ACTIONS(3050),
    [anon_sym__alignof] = ACTIONS(3050),
    [anon_sym_alignof] = ACTIONS(3050),
    [anon_sym__Alignof] = ACTIONS(3050),
    [anon_sym_offsetof] = ACTIONS(3050),
    [anon_sym__Generic] = ACTIONS(3050),
    [anon_sym_asm] = ACTIONS(3050),
    [anon_sym___asm__] = ACTIONS(3050),
    [anon_sym___asm] = ACTIONS(3050),
    [sym_number_literal] = ACTIONS(3052),
    [anon_sym_L_SQUOTE] = ACTIONS(3052),
    [anon_sym_u_SQUOTE] = ACTIONS(3052),
    [anon_sym_U_SQUOTE] = ACTIONS(3052),
    [anon_sym_u8_SQUOTE] = ACTIONS(3052),
    [anon_sym_SQUOTE] = ACTIONS(3052),
    [anon_sym_L_DQUOTE] = ACTIONS(3052),
    [anon_sym_u_DQUOTE] = ACTIONS(3052),
    [anon_sym_U_DQUOTE] = ACTIONS(3052),
    [anon_sym_u8_DQUOTE] = ACTIONS(3052),
    [anon_sym_DQUOTE] = ACTIONS(3052),
    [sym_true] = ACTIONS(3050),
    [sym_false] = ACTIONS(3050),
    [anon_sym_NULL] = ACTIONS(3050),
    [anon_sym_nullptr] = ACTIONS(3050),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3050),
    [anon_sym_decltype] = ACTIONS(3050),
    [anon_sym_explicit] = ACTIONS(3050),
    [anon_sym_typename] = ACTIONS(3050),
    [anon_sym_template] = ACTIONS(3050),
    [anon_sym_operator] = ACTIONS(3050),
    [anon_sym_try] = ACTIONS(3050),
    [anon_sym_delete] = ACTIONS(3050),
    [anon_sym_throw] = ACTIONS(3050),
    [anon_sym_namespace] = ACTIONS(3050),
    [anon_sym_using] = ACTIONS(3050),
    [anon_sym_static_assert] = ACTIONS(3050),
    [anon_sym_concept] = ACTIONS(3050),
    [anon_sym_co_return] = ACTIONS(3050),
    [anon_sym_co_yield] = ACTIONS(3050),
    [anon_sym_R_DQUOTE] = ACTIONS(3052),
    [anon_sym_LR_DQUOTE] = ACTIONS(3052),
    [anon_sym_uR_DQUOTE] = ACTIONS(3052),
    [anon_sym_UR_DQUOTE] = ACTIONS(3052),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3052),
    [anon_sym_co_await] = ACTIONS(3050),
    [anon_sym_new] = ACTIONS(3050),
    [anon_sym_requires] = ACTIONS(3050),
    [sym_this] = ACTIONS(3050),
  },
  [758] = {
    [sym_expression] = STATE(3655),
    [sym__string] = STATE(4345),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3286),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3286),
    [sym_call_expression] = STATE(3286),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3286),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3286),
    [sym_initializer_list] = STATE(3776),
    [sym_char_literal] = STATE(4345),
    [sym_concatenated_string] = STATE(4345),
    [sym_string_literal] = STATE(3370),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3370),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3286),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3286),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1917),
    [anon_sym_COMMA] = ACTIONS(1917),
    [anon_sym_LPAREN2] = ACTIONS(1917),
    [anon_sym_BANG] = ACTIONS(3496),
    [anon_sym_TILDE] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(1915),
    [anon_sym_PLUS] = ACTIONS(1915),
    [anon_sym_STAR] = ACTIONS(1917),
    [anon_sym_SLASH] = ACTIONS(1915),
    [anon_sym_PERCENT] = ACTIONS(1917),
    [anon_sym_PIPE_PIPE] = ACTIONS(1917),
    [anon_sym_AMP_AMP] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(1915),
    [anon_sym_CARET] = ACTIONS(1917),
    [anon_sym_AMP] = ACTIONS(1915),
    [anon_sym_EQ_EQ] = ACTIONS(1917),
    [anon_sym_BANG_EQ] = ACTIONS(1917),
    [anon_sym_GT] = ACTIONS(1915),
    [anon_sym_GT_EQ] = ACTIONS(1917),
    [anon_sym_LT_EQ] = ACTIONS(1915),
    [anon_sym_LT] = ACTIONS(1915),
    [anon_sym_LT_LT] = ACTIONS(1917),
    [anon_sym_GT_GT] = ACTIONS(1917),
    [anon_sym_SEMI] = ACTIONS(1917),
    [anon_sym___extension__] = ACTIONS(3500),
    [anon_sym___attribute__] = ACTIONS(1915),
    [anon_sym___attribute] = ACTIONS(1915),
    [anon_sym_COLON_COLON] = ACTIONS(3502),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(1917),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_QMARK] = ACTIONS(1917),
    [anon_sym_not] = ACTIONS(3496),
    [anon_sym_compl] = ACTIONS(3496),
    [anon_sym_LT_EQ_GT] = ACTIONS(1917),
    [anon_sym_or] = ACTIONS(1915),
    [anon_sym_and] = ACTIONS(1915),
    [anon_sym_bitor] = ACTIONS(1915),
    [anon_sym_xor] = ACTIONS(1915),
    [anon_sym_bitand] = ACTIONS(1915),
    [anon_sym_not_eq] = ACTIONS(1915),
    [anon_sym_DASH_DASH] = ACTIONS(1917),
    [anon_sym_PLUS_PLUS] = ACTIONS(1917),
    [anon_sym_sizeof] = ACTIONS(3504),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(1915),
    [anon_sym_DOT_STAR] = ACTIONS(1917),
    [anon_sym_DASH_GT] = ACTIONS(1917),
    [sym_number_literal] = ACTIONS(3506),
    [anon_sym_L_SQUOTE] = ACTIONS(3508),
    [anon_sym_u_SQUOTE] = ACTIONS(3508),
    [anon_sym_U_SQUOTE] = ACTIONS(3508),
    [anon_sym_u8_SQUOTE] = ACTIONS(3508),
    [anon_sym_SQUOTE] = ACTIONS(3508),
    [anon_sym_L_DQUOTE] = ACTIONS(3510),
    [anon_sym_u_DQUOTE] = ACTIONS(3510),
    [anon_sym_U_DQUOTE] = ACTIONS(3510),
    [anon_sym_u8_DQUOTE] = ACTIONS(3510),
    [anon_sym_DQUOTE] = ACTIONS(3510),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3512),
    [anon_sym_R_DQUOTE] = ACTIONS(3514),
    [anon_sym_LR_DQUOTE] = ACTIONS(3514),
    [anon_sym_uR_DQUOTE] = ACTIONS(3514),
    [anon_sym_UR_DQUOTE] = ACTIONS(3514),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3514),
    [anon_sym_co_await] = ACTIONS(3516),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [759] = {
    [sym_preproc_def] = STATE(761),
    [sym_preproc_function_def] = STATE(761),
    [sym_preproc_call] = STATE(761),
    [sym_preproc_if_in_field_declaration_list] = STATE(761),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(761),
    [sym_type_definition] = STATE(761),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(5454),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6137),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__field_declaration_list_item] = STATE(761),
    [sym_field_declaration] = STATE(761),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1688),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(761),
    [sym_operator_cast] = STATE(6717),
    [sym_inline_method_definition] = STATE(761),
    [sym__constructor_specifiers] = STATE(1688),
    [sym_operator_cast_definition] = STATE(761),
    [sym_operator_cast_declaration] = STATE(761),
    [sym_constructor_or_destructor_definition] = STATE(761),
    [sym_constructor_or_destructor_declaration] = STATE(761),
    [sym_friend_declaration] = STATE(761),
    [sym_access_specifier] = STATE(7890),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_using_declaration] = STATE(761),
    [sym_alias_declaration] = STATE(761),
    [sym_static_assert_declaration] = STATE(761),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5383),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6717),
    [sym_operator_name] = STATE(5896),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(761),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2008),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1688),
    [sym_identifier] = ACTIONS(3174),
    [aux_sym_preproc_def_token1] = ACTIONS(3518),
    [aux_sym_preproc_if_token1] = ACTIONS(3520),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3522),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3522),
    [sym_preproc_directive] = ACTIONS(3524),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3526),
    [anon_sym___extension__] = ACTIONS(3528),
    [anon_sym_typedef] = ACTIONS(3530),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3532),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(3534),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3216),
    [anon_sym_struct] = ACTIONS(3218),
    [anon_sym_union] = ACTIONS(3220),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3222),
    [anon_sym_template] = ACTIONS(3536),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3538),
    [anon_sym_public] = ACTIONS(3228),
    [anon_sym_private] = ACTIONS(3228),
    [anon_sym_protected] = ACTIONS(3228),
    [anon_sym_using] = ACTIONS(3540),
    [anon_sym_static_assert] = ACTIONS(3542),
  },
  [760] = {
    [sym_preproc_def] = STATE(763),
    [sym_preproc_function_def] = STATE(763),
    [sym_preproc_call] = STATE(763),
    [sym_preproc_if_in_field_declaration_list] = STATE(763),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(763),
    [sym_type_definition] = STATE(763),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(5437),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6172),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__field_declaration_list_item] = STATE(763),
    [sym_field_declaration] = STATE(763),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1754),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(763),
    [sym_operator_cast] = STATE(6687),
    [sym_inline_method_definition] = STATE(763),
    [sym__constructor_specifiers] = STATE(1754),
    [sym_operator_cast_definition] = STATE(763),
    [sym_operator_cast_declaration] = STATE(763),
    [sym_constructor_or_destructor_definition] = STATE(763),
    [sym_constructor_or_destructor_declaration] = STATE(763),
    [sym_friend_declaration] = STATE(763),
    [sym_access_specifier] = STATE(8106),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_using_declaration] = STATE(763),
    [sym_alias_declaration] = STATE(763),
    [sym_static_assert_declaration] = STATE(763),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5383),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6687),
    [sym_operator_name] = STATE(5896),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(763),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2008),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1754),
    [sym_identifier] = ACTIONS(3174),
    [aux_sym_preproc_def_token1] = ACTIONS(3544),
    [aux_sym_preproc_if_token1] = ACTIONS(3546),
    [aux_sym_preproc_if_token2] = ACTIONS(3548),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3550),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3550),
    [sym_preproc_directive] = ACTIONS(3552),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3554),
    [anon_sym___extension__] = ACTIONS(3556),
    [anon_sym_typedef] = ACTIONS(3558),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(3560),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3216),
    [anon_sym_struct] = ACTIONS(3218),
    [anon_sym_union] = ACTIONS(3220),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3222),
    [anon_sym_template] = ACTIONS(3562),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3564),
    [anon_sym_public] = ACTIONS(3228),
    [anon_sym_private] = ACTIONS(3228),
    [anon_sym_protected] = ACTIONS(3228),
    [anon_sym_using] = ACTIONS(3566),
    [anon_sym_static_assert] = ACTIONS(3568),
  },
  [761] = {
    [sym_preproc_def] = STATE(782),
    [sym_preproc_function_def] = STATE(782),
    [sym_preproc_call] = STATE(782),
    [sym_preproc_if_in_field_declaration_list] = STATE(782),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(782),
    [sym_type_definition] = STATE(782),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(5454),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6137),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__field_declaration_list_item] = STATE(782),
    [sym_field_declaration] = STATE(782),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1688),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(782),
    [sym_operator_cast] = STATE(6717),
    [sym_inline_method_definition] = STATE(782),
    [sym__constructor_specifiers] = STATE(1688),
    [sym_operator_cast_definition] = STATE(782),
    [sym_operator_cast_declaration] = STATE(782),
    [sym_constructor_or_destructor_definition] = STATE(782),
    [sym_constructor_or_destructor_declaration] = STATE(782),
    [sym_friend_declaration] = STATE(782),
    [sym_access_specifier] = STATE(7890),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_using_declaration] = STATE(782),
    [sym_alias_declaration] = STATE(782),
    [sym_static_assert_declaration] = STATE(782),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5383),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6717),
    [sym_operator_name] = STATE(5896),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(782),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2008),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1688),
    [sym_identifier] = ACTIONS(3174),
    [aux_sym_preproc_def_token1] = ACTIONS(3518),
    [aux_sym_preproc_if_token1] = ACTIONS(3520),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3522),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3522),
    [sym_preproc_directive] = ACTIONS(3524),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3570),
    [anon_sym___extension__] = ACTIONS(3528),
    [anon_sym_typedef] = ACTIONS(3530),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3572),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(3534),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3216),
    [anon_sym_struct] = ACTIONS(3218),
    [anon_sym_union] = ACTIONS(3220),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3222),
    [anon_sym_template] = ACTIONS(3536),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3538),
    [anon_sym_public] = ACTIONS(3228),
    [anon_sym_private] = ACTIONS(3228),
    [anon_sym_protected] = ACTIONS(3228),
    [anon_sym_using] = ACTIONS(3540),
    [anon_sym_static_assert] = ACTIONS(3542),
  },
  [762] = {
    [sym_preproc_def] = STATE(782),
    [sym_preproc_function_def] = STATE(782),
    [sym_preproc_call] = STATE(782),
    [sym_preproc_if_in_field_declaration_list] = STATE(782),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(782),
    [sym_type_definition] = STATE(782),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(5454),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6137),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__field_declaration_list_item] = STATE(782),
    [sym_field_declaration] = STATE(782),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1688),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(782),
    [sym_operator_cast] = STATE(6717),
    [sym_inline_method_definition] = STATE(782),
    [sym__constructor_specifiers] = STATE(1688),
    [sym_operator_cast_definition] = STATE(782),
    [sym_operator_cast_declaration] = STATE(782),
    [sym_constructor_or_destructor_definition] = STATE(782),
    [sym_constructor_or_destructor_declaration] = STATE(782),
    [sym_friend_declaration] = STATE(782),
    [sym_access_specifier] = STATE(7890),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_using_declaration] = STATE(782),
    [sym_alias_declaration] = STATE(782),
    [sym_static_assert_declaration] = STATE(782),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5383),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6717),
    [sym_operator_name] = STATE(5896),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(782),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2008),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1688),
    [sym_identifier] = ACTIONS(3174),
    [aux_sym_preproc_def_token1] = ACTIONS(3518),
    [aux_sym_preproc_if_token1] = ACTIONS(3520),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3522),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3522),
    [sym_preproc_directive] = ACTIONS(3524),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3570),
    [anon_sym___extension__] = ACTIONS(3528),
    [anon_sym_typedef] = ACTIONS(3530),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3574),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(3534),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3216),
    [anon_sym_struct] = ACTIONS(3218),
    [anon_sym_union] = ACTIONS(3220),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3222),
    [anon_sym_template] = ACTIONS(3536),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3538),
    [anon_sym_public] = ACTIONS(3228),
    [anon_sym_private] = ACTIONS(3228),
    [anon_sym_protected] = ACTIONS(3228),
    [anon_sym_using] = ACTIONS(3540),
    [anon_sym_static_assert] = ACTIONS(3542),
  },
  [763] = {
    [sym_preproc_def] = STATE(763),
    [sym_preproc_function_def] = STATE(763),
    [sym_preproc_call] = STATE(763),
    [sym_preproc_if_in_field_declaration_list] = STATE(763),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(763),
    [sym_type_definition] = STATE(763),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(5437),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6172),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__field_declaration_list_item] = STATE(763),
    [sym_field_declaration] = STATE(763),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1754),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(763),
    [sym_operator_cast] = STATE(6687),
    [sym_inline_method_definition] = STATE(763),
    [sym__constructor_specifiers] = STATE(1754),
    [sym_operator_cast_definition] = STATE(763),
    [sym_operator_cast_declaration] = STATE(763),
    [sym_constructor_or_destructor_definition] = STATE(763),
    [sym_constructor_or_destructor_declaration] = STATE(763),
    [sym_friend_declaration] = STATE(763),
    [sym_access_specifier] = STATE(8106),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_using_declaration] = STATE(763),
    [sym_alias_declaration] = STATE(763),
    [sym_static_assert_declaration] = STATE(763),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5383),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6687),
    [sym_operator_name] = STATE(5896),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(763),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2008),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1754),
    [sym_identifier] = ACTIONS(3330),
    [aux_sym_preproc_def_token1] = ACTIONS(3576),
    [aux_sym_preproc_if_token1] = ACTIONS(3579),
    [aux_sym_preproc_if_token2] = ACTIONS(3339),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3582),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3582),
    [sym_preproc_directive] = ACTIONS(3585),
    [anon_sym_LPAREN2] = ACTIONS(3347),
    [anon_sym_TILDE] = ACTIONS(3350),
    [anon_sym_STAR] = ACTIONS(3353),
    [anon_sym_AMP_AMP] = ACTIONS(3356),
    [anon_sym_AMP] = ACTIONS(3359),
    [anon_sym_SEMI] = ACTIONS(3588),
    [anon_sym___extension__] = ACTIONS(3591),
    [anon_sym_typedef] = ACTIONS(3594),
    [anon_sym_virtual] = ACTIONS(3371),
    [anon_sym_extern] = ACTIONS(3374),
    [anon_sym___attribute__] = ACTIONS(3377),
    [anon_sym___attribute] = ACTIONS(3377),
    [anon_sym_COLON_COLON] = ACTIONS(3380),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3383),
    [anon_sym___declspec] = ACTIONS(3386),
    [anon_sym___based] = ACTIONS(3389),
    [anon_sym_signed] = ACTIONS(3392),
    [anon_sym_unsigned] = ACTIONS(3392),
    [anon_sym_long] = ACTIONS(3392),
    [anon_sym_short] = ACTIONS(3392),
    [anon_sym_LBRACK] = ACTIONS(3395),
    [anon_sym_static] = ACTIONS(3374),
    [anon_sym_register] = ACTIONS(3374),
    [anon_sym_inline] = ACTIONS(3374),
    [anon_sym___inline] = ACTIONS(3374),
    [anon_sym___inline__] = ACTIONS(3374),
    [anon_sym___forceinline] = ACTIONS(3374),
    [anon_sym_thread_local] = ACTIONS(3374),
    [anon_sym___thread] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3398),
    [anon_sym_constexpr] = ACTIONS(3597),
    [anon_sym_volatile] = ACTIONS(3398),
    [anon_sym_restrict] = ACTIONS(3398),
    [anon_sym___restrict__] = ACTIONS(3398),
    [anon_sym__Atomic] = ACTIONS(3398),
    [anon_sym__Noreturn] = ACTIONS(3398),
    [anon_sym_noreturn] = ACTIONS(3398),
    [anon_sym__Nonnull] = ACTIONS(3398),
    [anon_sym_mutable] = ACTIONS(3398),
    [anon_sym_constinit] = ACTIONS(3398),
    [anon_sym_consteval] = ACTIONS(3398),
    [anon_sym_alignas] = ACTIONS(3404),
    [anon_sym__Alignas] = ACTIONS(3404),
    [sym_primitive_type] = ACTIONS(3407),
    [anon_sym_enum] = ACTIONS(3410),
    [anon_sym_class] = ACTIONS(3413),
    [anon_sym_struct] = ACTIONS(3416),
    [anon_sym_union] = ACTIONS(3419),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3422),
    [anon_sym_decltype] = ACTIONS(3425),
    [anon_sym_explicit] = ACTIONS(3428),
    [anon_sym_typename] = ACTIONS(3431),
    [anon_sym_template] = ACTIONS(3600),
    [anon_sym_operator] = ACTIONS(3437),
    [anon_sym_friend] = ACTIONS(3603),
    [anon_sym_public] = ACTIONS(3443),
    [anon_sym_private] = ACTIONS(3443),
    [anon_sym_protected] = ACTIONS(3443),
    [anon_sym_using] = ACTIONS(3606),
    [anon_sym_static_assert] = ACTIONS(3609),
  },
  [764] = {
    [sym_preproc_def] = STATE(782),
    [sym_preproc_function_def] = STATE(782),
    [sym_preproc_call] = STATE(782),
    [sym_preproc_if_in_field_declaration_list] = STATE(782),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(782),
    [sym_type_definition] = STATE(782),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(5454),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6137),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__field_declaration_list_item] = STATE(782),
    [sym_field_declaration] = STATE(782),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1688),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(782),
    [sym_operator_cast] = STATE(6717),
    [sym_inline_method_definition] = STATE(782),
    [sym__constructor_specifiers] = STATE(1688),
    [sym_operator_cast_definition] = STATE(782),
    [sym_operator_cast_declaration] = STATE(782),
    [sym_constructor_or_destructor_definition] = STATE(782),
    [sym_constructor_or_destructor_declaration] = STATE(782),
    [sym_friend_declaration] = STATE(782),
    [sym_access_specifier] = STATE(7890),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_using_declaration] = STATE(782),
    [sym_alias_declaration] = STATE(782),
    [sym_static_assert_declaration] = STATE(782),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5383),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6717),
    [sym_operator_name] = STATE(5896),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(782),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2008),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1688),
    [sym_identifier] = ACTIONS(3174),
    [aux_sym_preproc_def_token1] = ACTIONS(3518),
    [aux_sym_preproc_if_token1] = ACTIONS(3520),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3522),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3522),
    [sym_preproc_directive] = ACTIONS(3524),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3570),
    [anon_sym___extension__] = ACTIONS(3528),
    [anon_sym_typedef] = ACTIONS(3530),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3612),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(3534),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3216),
    [anon_sym_struct] = ACTIONS(3218),
    [anon_sym_union] = ACTIONS(3220),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3222),
    [anon_sym_template] = ACTIONS(3536),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3538),
    [anon_sym_public] = ACTIONS(3228),
    [anon_sym_private] = ACTIONS(3228),
    [anon_sym_protected] = ACTIONS(3228),
    [anon_sym_using] = ACTIONS(3540),
    [anon_sym_static_assert] = ACTIONS(3542),
  },
  [765] = {
    [sym_preproc_def] = STATE(767),
    [sym_preproc_function_def] = STATE(767),
    [sym_preproc_call] = STATE(767),
    [sym_preproc_if_in_field_declaration_list] = STATE(767),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(767),
    [sym_type_definition] = STATE(767),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(5454),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6137),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__field_declaration_list_item] = STATE(767),
    [sym_field_declaration] = STATE(767),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1688),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(767),
    [sym_operator_cast] = STATE(6717),
    [sym_inline_method_definition] = STATE(767),
    [sym__constructor_specifiers] = STATE(1688),
    [sym_operator_cast_definition] = STATE(767),
    [sym_operator_cast_declaration] = STATE(767),
    [sym_constructor_or_destructor_definition] = STATE(767),
    [sym_constructor_or_destructor_declaration] = STATE(767),
    [sym_friend_declaration] = STATE(767),
    [sym_access_specifier] = STATE(7890),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_using_declaration] = STATE(767),
    [sym_alias_declaration] = STATE(767),
    [sym_static_assert_declaration] = STATE(767),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5383),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6717),
    [sym_operator_name] = STATE(5896),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(767),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2008),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1688),
    [sym_identifier] = ACTIONS(3174),
    [aux_sym_preproc_def_token1] = ACTIONS(3518),
    [aux_sym_preproc_if_token1] = ACTIONS(3520),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3522),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3522),
    [sym_preproc_directive] = ACTIONS(3524),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3614),
    [anon_sym___extension__] = ACTIONS(3528),
    [anon_sym_typedef] = ACTIONS(3530),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3616),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(3534),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3216),
    [anon_sym_struct] = ACTIONS(3218),
    [anon_sym_union] = ACTIONS(3220),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3222),
    [anon_sym_template] = ACTIONS(3536),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3538),
    [anon_sym_public] = ACTIONS(3228),
    [anon_sym_private] = ACTIONS(3228),
    [anon_sym_protected] = ACTIONS(3228),
    [anon_sym_using] = ACTIONS(3540),
    [anon_sym_static_assert] = ACTIONS(3542),
  },
  [766] = {
    [sym_preproc_def] = STATE(762),
    [sym_preproc_function_def] = STATE(762),
    [sym_preproc_call] = STATE(762),
    [sym_preproc_if_in_field_declaration_list] = STATE(762),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(762),
    [sym_type_definition] = STATE(762),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(5454),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6137),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__field_declaration_list_item] = STATE(762),
    [sym_field_declaration] = STATE(762),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1688),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(762),
    [sym_operator_cast] = STATE(6717),
    [sym_inline_method_definition] = STATE(762),
    [sym__constructor_specifiers] = STATE(1688),
    [sym_operator_cast_definition] = STATE(762),
    [sym_operator_cast_declaration] = STATE(762),
    [sym_constructor_or_destructor_definition] = STATE(762),
    [sym_constructor_or_destructor_declaration] = STATE(762),
    [sym_friend_declaration] = STATE(762),
    [sym_access_specifier] = STATE(7890),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_using_declaration] = STATE(762),
    [sym_alias_declaration] = STATE(762),
    [sym_static_assert_declaration] = STATE(762),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5383),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6717),
    [sym_operator_name] = STATE(5896),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(762),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2008),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1688),
    [sym_identifier] = ACTIONS(3174),
    [aux_sym_preproc_def_token1] = ACTIONS(3518),
    [aux_sym_preproc_if_token1] = ACTIONS(3520),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3522),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3522),
    [sym_preproc_directive] = ACTIONS(3524),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3618),
    [anon_sym___extension__] = ACTIONS(3528),
    [anon_sym_typedef] = ACTIONS(3530),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3620),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(3534),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3216),
    [anon_sym_struct] = ACTIONS(3218),
    [anon_sym_union] = ACTIONS(3220),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3222),
    [anon_sym_template] = ACTIONS(3536),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3538),
    [anon_sym_public] = ACTIONS(3228),
    [anon_sym_private] = ACTIONS(3228),
    [anon_sym_protected] = ACTIONS(3228),
    [anon_sym_using] = ACTIONS(3540),
    [anon_sym_static_assert] = ACTIONS(3542),
  },
  [767] = {
    [sym_preproc_def] = STATE(782),
    [sym_preproc_function_def] = STATE(782),
    [sym_preproc_call] = STATE(782),
    [sym_preproc_if_in_field_declaration_list] = STATE(782),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(782),
    [sym_type_definition] = STATE(782),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(5454),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6137),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__field_declaration_list_item] = STATE(782),
    [sym_field_declaration] = STATE(782),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1688),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(782),
    [sym_operator_cast] = STATE(6717),
    [sym_inline_method_definition] = STATE(782),
    [sym__constructor_specifiers] = STATE(1688),
    [sym_operator_cast_definition] = STATE(782),
    [sym_operator_cast_declaration] = STATE(782),
    [sym_constructor_or_destructor_definition] = STATE(782),
    [sym_constructor_or_destructor_declaration] = STATE(782),
    [sym_friend_declaration] = STATE(782),
    [sym_access_specifier] = STATE(7890),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_using_declaration] = STATE(782),
    [sym_alias_declaration] = STATE(782),
    [sym_static_assert_declaration] = STATE(782),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5383),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6717),
    [sym_operator_name] = STATE(5896),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(782),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2008),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1688),
    [sym_identifier] = ACTIONS(3174),
    [aux_sym_preproc_def_token1] = ACTIONS(3518),
    [aux_sym_preproc_if_token1] = ACTIONS(3520),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3522),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3522),
    [sym_preproc_directive] = ACTIONS(3524),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3570),
    [anon_sym___extension__] = ACTIONS(3528),
    [anon_sym_typedef] = ACTIONS(3530),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3622),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(3534),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3216),
    [anon_sym_struct] = ACTIONS(3218),
    [anon_sym_union] = ACTIONS(3220),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3222),
    [anon_sym_template] = ACTIONS(3536),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3538),
    [anon_sym_public] = ACTIONS(3228),
    [anon_sym_private] = ACTIONS(3228),
    [anon_sym_protected] = ACTIONS(3228),
    [anon_sym_using] = ACTIONS(3540),
    [anon_sym_static_assert] = ACTIONS(3542),
  },
  [768] = {
    [sym_preproc_def] = STATE(764),
    [sym_preproc_function_def] = STATE(764),
    [sym_preproc_call] = STATE(764),
    [sym_preproc_if_in_field_declaration_list] = STATE(764),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(764),
    [sym_type_definition] = STATE(764),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(5454),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6137),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__field_declaration_list_item] = STATE(764),
    [sym_field_declaration] = STATE(764),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1688),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(764),
    [sym_operator_cast] = STATE(6717),
    [sym_inline_method_definition] = STATE(764),
    [sym__constructor_specifiers] = STATE(1688),
    [sym_operator_cast_definition] = STATE(764),
    [sym_operator_cast_declaration] = STATE(764),
    [sym_constructor_or_destructor_definition] = STATE(764),
    [sym_constructor_or_destructor_declaration] = STATE(764),
    [sym_friend_declaration] = STATE(764),
    [sym_access_specifier] = STATE(7890),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_using_declaration] = STATE(764),
    [sym_alias_declaration] = STATE(764),
    [sym_static_assert_declaration] = STATE(764),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5383),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6717),
    [sym_operator_name] = STATE(5896),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(764),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2008),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1688),
    [sym_identifier] = ACTIONS(3174),
    [aux_sym_preproc_def_token1] = ACTIONS(3518),
    [aux_sym_preproc_if_token1] = ACTIONS(3520),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3522),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3522),
    [sym_preproc_directive] = ACTIONS(3524),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3624),
    [anon_sym___extension__] = ACTIONS(3528),
    [anon_sym_typedef] = ACTIONS(3530),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3626),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(3534),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3216),
    [anon_sym_struct] = ACTIONS(3218),
    [anon_sym_union] = ACTIONS(3220),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3222),
    [anon_sym_template] = ACTIONS(3536),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3538),
    [anon_sym_public] = ACTIONS(3228),
    [anon_sym_private] = ACTIONS(3228),
    [anon_sym_protected] = ACTIONS(3228),
    [anon_sym_using] = ACTIONS(3540),
    [anon_sym_static_assert] = ACTIONS(3542),
  },
  [769] = {
    [sym_preproc_def] = STATE(760),
    [sym_preproc_function_def] = STATE(760),
    [sym_preproc_call] = STATE(760),
    [sym_preproc_if_in_field_declaration_list] = STATE(760),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(760),
    [sym_type_definition] = STATE(760),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(5437),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6172),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__field_declaration_list_item] = STATE(760),
    [sym_field_declaration] = STATE(760),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1754),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(760),
    [sym_operator_cast] = STATE(6687),
    [sym_inline_method_definition] = STATE(760),
    [sym__constructor_specifiers] = STATE(1754),
    [sym_operator_cast_definition] = STATE(760),
    [sym_operator_cast_declaration] = STATE(760),
    [sym_constructor_or_destructor_definition] = STATE(760),
    [sym_constructor_or_destructor_declaration] = STATE(760),
    [sym_friend_declaration] = STATE(760),
    [sym_access_specifier] = STATE(8106),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_using_declaration] = STATE(760),
    [sym_alias_declaration] = STATE(760),
    [sym_static_assert_declaration] = STATE(760),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5383),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6687),
    [sym_operator_name] = STATE(5896),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(760),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2008),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1754),
    [sym_identifier] = ACTIONS(3174),
    [aux_sym_preproc_def_token1] = ACTIONS(3544),
    [aux_sym_preproc_if_token1] = ACTIONS(3546),
    [aux_sym_preproc_if_token2] = ACTIONS(3628),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3550),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3550),
    [sym_preproc_directive] = ACTIONS(3552),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3630),
    [anon_sym___extension__] = ACTIONS(3556),
    [anon_sym_typedef] = ACTIONS(3558),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(3560),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3216),
    [anon_sym_struct] = ACTIONS(3218),
    [anon_sym_union] = ACTIONS(3220),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3222),
    [anon_sym_template] = ACTIONS(3562),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3564),
    [anon_sym_public] = ACTIONS(3228),
    [anon_sym_private] = ACTIONS(3228),
    [anon_sym_protected] = ACTIONS(3228),
    [anon_sym_using] = ACTIONS(3566),
    [anon_sym_static_assert] = ACTIONS(3568),
  },
  [770] = {
    [sym_preproc_def] = STATE(771),
    [sym_preproc_function_def] = STATE(771),
    [sym_preproc_call] = STATE(771),
    [sym_preproc_if_in_field_declaration_list] = STATE(771),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(771),
    [sym_type_definition] = STATE(771),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(5454),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6137),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__field_declaration_list_item] = STATE(771),
    [sym_field_declaration] = STATE(771),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1688),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(771),
    [sym_operator_cast] = STATE(6717),
    [sym_inline_method_definition] = STATE(771),
    [sym__constructor_specifiers] = STATE(1688),
    [sym_operator_cast_definition] = STATE(771),
    [sym_operator_cast_declaration] = STATE(771),
    [sym_constructor_or_destructor_definition] = STATE(771),
    [sym_constructor_or_destructor_declaration] = STATE(771),
    [sym_friend_declaration] = STATE(771),
    [sym_access_specifier] = STATE(7890),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_using_declaration] = STATE(771),
    [sym_alias_declaration] = STATE(771),
    [sym_static_assert_declaration] = STATE(771),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5383),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6717),
    [sym_operator_name] = STATE(5896),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(771),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2008),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1688),
    [sym_identifier] = ACTIONS(3174),
    [aux_sym_preproc_def_token1] = ACTIONS(3518),
    [aux_sym_preproc_if_token1] = ACTIONS(3520),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3522),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3522),
    [sym_preproc_directive] = ACTIONS(3524),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3632),
    [anon_sym___extension__] = ACTIONS(3528),
    [anon_sym_typedef] = ACTIONS(3530),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3634),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(3534),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3216),
    [anon_sym_struct] = ACTIONS(3218),
    [anon_sym_union] = ACTIONS(3220),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3222),
    [anon_sym_template] = ACTIONS(3536),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3538),
    [anon_sym_public] = ACTIONS(3228),
    [anon_sym_private] = ACTIONS(3228),
    [anon_sym_protected] = ACTIONS(3228),
    [anon_sym_using] = ACTIONS(3540),
    [anon_sym_static_assert] = ACTIONS(3542),
  },
  [771] = {
    [sym_preproc_def] = STATE(782),
    [sym_preproc_function_def] = STATE(782),
    [sym_preproc_call] = STATE(782),
    [sym_preproc_if_in_field_declaration_list] = STATE(782),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(782),
    [sym_type_definition] = STATE(782),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(5454),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6137),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__field_declaration_list_item] = STATE(782),
    [sym_field_declaration] = STATE(782),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1688),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(782),
    [sym_operator_cast] = STATE(6717),
    [sym_inline_method_definition] = STATE(782),
    [sym__constructor_specifiers] = STATE(1688),
    [sym_operator_cast_definition] = STATE(782),
    [sym_operator_cast_declaration] = STATE(782),
    [sym_constructor_or_destructor_definition] = STATE(782),
    [sym_constructor_or_destructor_declaration] = STATE(782),
    [sym_friend_declaration] = STATE(782),
    [sym_access_specifier] = STATE(7890),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_using_declaration] = STATE(782),
    [sym_alias_declaration] = STATE(782),
    [sym_static_assert_declaration] = STATE(782),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5383),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6717),
    [sym_operator_name] = STATE(5896),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(782),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2008),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1688),
    [sym_identifier] = ACTIONS(3174),
    [aux_sym_preproc_def_token1] = ACTIONS(3518),
    [aux_sym_preproc_if_token1] = ACTIONS(3520),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3522),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3522),
    [sym_preproc_directive] = ACTIONS(3524),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3570),
    [anon_sym___extension__] = ACTIONS(3528),
    [anon_sym_typedef] = ACTIONS(3530),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3636),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(3534),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3216),
    [anon_sym_struct] = ACTIONS(3218),
    [anon_sym_union] = ACTIONS(3220),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3222),
    [anon_sym_template] = ACTIONS(3536),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3538),
    [anon_sym_public] = ACTIONS(3228),
    [anon_sym_private] = ACTIONS(3228),
    [anon_sym_protected] = ACTIONS(3228),
    [anon_sym_using] = ACTIONS(3540),
    [anon_sym_static_assert] = ACTIONS(3542),
  },
  [772] = {
    [sym_preproc_def] = STATE(774),
    [sym_preproc_function_def] = STATE(774),
    [sym_preproc_call] = STATE(774),
    [sym_preproc_if_in_field_declaration_list] = STATE(774),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(774),
    [sym_type_definition] = STATE(774),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(5454),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6137),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__field_declaration_list_item] = STATE(774),
    [sym_field_declaration] = STATE(774),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1688),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(774),
    [sym_operator_cast] = STATE(6717),
    [sym_inline_method_definition] = STATE(774),
    [sym__constructor_specifiers] = STATE(1688),
    [sym_operator_cast_definition] = STATE(774),
    [sym_operator_cast_declaration] = STATE(774),
    [sym_constructor_or_destructor_definition] = STATE(774),
    [sym_constructor_or_destructor_declaration] = STATE(774),
    [sym_friend_declaration] = STATE(774),
    [sym_access_specifier] = STATE(7890),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_using_declaration] = STATE(774),
    [sym_alias_declaration] = STATE(774),
    [sym_static_assert_declaration] = STATE(774),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5383),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6717),
    [sym_operator_name] = STATE(5896),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(774),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2008),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1688),
    [sym_identifier] = ACTIONS(3174),
    [aux_sym_preproc_def_token1] = ACTIONS(3518),
    [aux_sym_preproc_if_token1] = ACTIONS(3520),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3522),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3522),
    [sym_preproc_directive] = ACTIONS(3524),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3638),
    [anon_sym___extension__] = ACTIONS(3528),
    [anon_sym_typedef] = ACTIONS(3530),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3640),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(3534),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3216),
    [anon_sym_struct] = ACTIONS(3218),
    [anon_sym_union] = ACTIONS(3220),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3222),
    [anon_sym_template] = ACTIONS(3536),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3538),
    [anon_sym_public] = ACTIONS(3228),
    [anon_sym_private] = ACTIONS(3228),
    [anon_sym_protected] = ACTIONS(3228),
    [anon_sym_using] = ACTIONS(3540),
    [anon_sym_static_assert] = ACTIONS(3542),
  },
  [773] = {
    [sym_preproc_def] = STATE(782),
    [sym_preproc_function_def] = STATE(782),
    [sym_preproc_call] = STATE(782),
    [sym_preproc_if_in_field_declaration_list] = STATE(782),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(782),
    [sym_type_definition] = STATE(782),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(5454),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6137),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__field_declaration_list_item] = STATE(782),
    [sym_field_declaration] = STATE(782),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1688),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(782),
    [sym_operator_cast] = STATE(6717),
    [sym_inline_method_definition] = STATE(782),
    [sym__constructor_specifiers] = STATE(1688),
    [sym_operator_cast_definition] = STATE(782),
    [sym_operator_cast_declaration] = STATE(782),
    [sym_constructor_or_destructor_definition] = STATE(782),
    [sym_constructor_or_destructor_declaration] = STATE(782),
    [sym_friend_declaration] = STATE(782),
    [sym_access_specifier] = STATE(7890),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_using_declaration] = STATE(782),
    [sym_alias_declaration] = STATE(782),
    [sym_static_assert_declaration] = STATE(782),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5383),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6717),
    [sym_operator_name] = STATE(5896),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(782),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2008),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1688),
    [sym_identifier] = ACTIONS(3174),
    [aux_sym_preproc_def_token1] = ACTIONS(3518),
    [aux_sym_preproc_if_token1] = ACTIONS(3520),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3522),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3522),
    [sym_preproc_directive] = ACTIONS(3524),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3570),
    [anon_sym___extension__] = ACTIONS(3528),
    [anon_sym_typedef] = ACTIONS(3530),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3642),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(3534),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3216),
    [anon_sym_struct] = ACTIONS(3218),
    [anon_sym_union] = ACTIONS(3220),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3222),
    [anon_sym_template] = ACTIONS(3536),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3538),
    [anon_sym_public] = ACTIONS(3228),
    [anon_sym_private] = ACTIONS(3228),
    [anon_sym_protected] = ACTIONS(3228),
    [anon_sym_using] = ACTIONS(3540),
    [anon_sym_static_assert] = ACTIONS(3542),
  },
  [774] = {
    [sym_preproc_def] = STATE(782),
    [sym_preproc_function_def] = STATE(782),
    [sym_preproc_call] = STATE(782),
    [sym_preproc_if_in_field_declaration_list] = STATE(782),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(782),
    [sym_type_definition] = STATE(782),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(5454),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6137),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__field_declaration_list_item] = STATE(782),
    [sym_field_declaration] = STATE(782),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1688),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(782),
    [sym_operator_cast] = STATE(6717),
    [sym_inline_method_definition] = STATE(782),
    [sym__constructor_specifiers] = STATE(1688),
    [sym_operator_cast_definition] = STATE(782),
    [sym_operator_cast_declaration] = STATE(782),
    [sym_constructor_or_destructor_definition] = STATE(782),
    [sym_constructor_or_destructor_declaration] = STATE(782),
    [sym_friend_declaration] = STATE(782),
    [sym_access_specifier] = STATE(7890),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_using_declaration] = STATE(782),
    [sym_alias_declaration] = STATE(782),
    [sym_static_assert_declaration] = STATE(782),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5383),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6717),
    [sym_operator_name] = STATE(5896),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(782),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2008),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1688),
    [sym_identifier] = ACTIONS(3174),
    [aux_sym_preproc_def_token1] = ACTIONS(3518),
    [aux_sym_preproc_if_token1] = ACTIONS(3520),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3522),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3522),
    [sym_preproc_directive] = ACTIONS(3524),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3570),
    [anon_sym___extension__] = ACTIONS(3528),
    [anon_sym_typedef] = ACTIONS(3530),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3644),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(3534),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3216),
    [anon_sym_struct] = ACTIONS(3218),
    [anon_sym_union] = ACTIONS(3220),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3222),
    [anon_sym_template] = ACTIONS(3536),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3538),
    [anon_sym_public] = ACTIONS(3228),
    [anon_sym_private] = ACTIONS(3228),
    [anon_sym_protected] = ACTIONS(3228),
    [anon_sym_using] = ACTIONS(3540),
    [anon_sym_static_assert] = ACTIONS(3542),
  },
  [775] = {
    [sym_preproc_def] = STATE(776),
    [sym_preproc_function_def] = STATE(776),
    [sym_preproc_call] = STATE(776),
    [sym_preproc_if_in_field_declaration_list] = STATE(776),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(776),
    [sym_type_definition] = STATE(776),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(5454),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6137),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__field_declaration_list_item] = STATE(776),
    [sym_field_declaration] = STATE(776),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1688),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(776),
    [sym_operator_cast] = STATE(6717),
    [sym_inline_method_definition] = STATE(776),
    [sym__constructor_specifiers] = STATE(1688),
    [sym_operator_cast_definition] = STATE(776),
    [sym_operator_cast_declaration] = STATE(776),
    [sym_constructor_or_destructor_definition] = STATE(776),
    [sym_constructor_or_destructor_declaration] = STATE(776),
    [sym_friend_declaration] = STATE(776),
    [sym_access_specifier] = STATE(7890),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_using_declaration] = STATE(776),
    [sym_alias_declaration] = STATE(776),
    [sym_static_assert_declaration] = STATE(776),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5383),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6717),
    [sym_operator_name] = STATE(5896),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(776),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2008),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1688),
    [sym_identifier] = ACTIONS(3174),
    [aux_sym_preproc_def_token1] = ACTIONS(3518),
    [aux_sym_preproc_if_token1] = ACTIONS(3520),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3522),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3522),
    [sym_preproc_directive] = ACTIONS(3524),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3646),
    [anon_sym___extension__] = ACTIONS(3528),
    [anon_sym_typedef] = ACTIONS(3530),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3648),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(3534),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3216),
    [anon_sym_struct] = ACTIONS(3218),
    [anon_sym_union] = ACTIONS(3220),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3222),
    [anon_sym_template] = ACTIONS(3536),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3538),
    [anon_sym_public] = ACTIONS(3228),
    [anon_sym_private] = ACTIONS(3228),
    [anon_sym_protected] = ACTIONS(3228),
    [anon_sym_using] = ACTIONS(3540),
    [anon_sym_static_assert] = ACTIONS(3542),
  },
  [776] = {
    [sym_preproc_def] = STATE(782),
    [sym_preproc_function_def] = STATE(782),
    [sym_preproc_call] = STATE(782),
    [sym_preproc_if_in_field_declaration_list] = STATE(782),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(782),
    [sym_type_definition] = STATE(782),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(5454),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6137),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__field_declaration_list_item] = STATE(782),
    [sym_field_declaration] = STATE(782),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1688),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(782),
    [sym_operator_cast] = STATE(6717),
    [sym_inline_method_definition] = STATE(782),
    [sym__constructor_specifiers] = STATE(1688),
    [sym_operator_cast_definition] = STATE(782),
    [sym_operator_cast_declaration] = STATE(782),
    [sym_constructor_or_destructor_definition] = STATE(782),
    [sym_constructor_or_destructor_declaration] = STATE(782),
    [sym_friend_declaration] = STATE(782),
    [sym_access_specifier] = STATE(7890),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_using_declaration] = STATE(782),
    [sym_alias_declaration] = STATE(782),
    [sym_static_assert_declaration] = STATE(782),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5383),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6717),
    [sym_operator_name] = STATE(5896),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(782),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2008),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1688),
    [sym_identifier] = ACTIONS(3174),
    [aux_sym_preproc_def_token1] = ACTIONS(3518),
    [aux_sym_preproc_if_token1] = ACTIONS(3520),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3522),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3522),
    [sym_preproc_directive] = ACTIONS(3524),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3570),
    [anon_sym___extension__] = ACTIONS(3528),
    [anon_sym_typedef] = ACTIONS(3530),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3650),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(3534),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3216),
    [anon_sym_struct] = ACTIONS(3218),
    [anon_sym_union] = ACTIONS(3220),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3222),
    [anon_sym_template] = ACTIONS(3536),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3538),
    [anon_sym_public] = ACTIONS(3228),
    [anon_sym_private] = ACTIONS(3228),
    [anon_sym_protected] = ACTIONS(3228),
    [anon_sym_using] = ACTIONS(3540),
    [anon_sym_static_assert] = ACTIONS(3542),
  },
  [777] = {
    [sym_preproc_def] = STATE(778),
    [sym_preproc_function_def] = STATE(778),
    [sym_preproc_call] = STATE(778),
    [sym_preproc_if_in_field_declaration_list] = STATE(778),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(778),
    [sym_type_definition] = STATE(778),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(5454),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6137),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__field_declaration_list_item] = STATE(778),
    [sym_field_declaration] = STATE(778),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1688),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(778),
    [sym_operator_cast] = STATE(6717),
    [sym_inline_method_definition] = STATE(778),
    [sym__constructor_specifiers] = STATE(1688),
    [sym_operator_cast_definition] = STATE(778),
    [sym_operator_cast_declaration] = STATE(778),
    [sym_constructor_or_destructor_definition] = STATE(778),
    [sym_constructor_or_destructor_declaration] = STATE(778),
    [sym_friend_declaration] = STATE(778),
    [sym_access_specifier] = STATE(7890),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_using_declaration] = STATE(778),
    [sym_alias_declaration] = STATE(778),
    [sym_static_assert_declaration] = STATE(778),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5383),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6717),
    [sym_operator_name] = STATE(5896),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(778),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2008),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1688),
    [sym_identifier] = ACTIONS(3174),
    [aux_sym_preproc_def_token1] = ACTIONS(3518),
    [aux_sym_preproc_if_token1] = ACTIONS(3520),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3522),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3522),
    [sym_preproc_directive] = ACTIONS(3524),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3652),
    [anon_sym___extension__] = ACTIONS(3528),
    [anon_sym_typedef] = ACTIONS(3530),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3654),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(3534),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3216),
    [anon_sym_struct] = ACTIONS(3218),
    [anon_sym_union] = ACTIONS(3220),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3222),
    [anon_sym_template] = ACTIONS(3536),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3538),
    [anon_sym_public] = ACTIONS(3228),
    [anon_sym_private] = ACTIONS(3228),
    [anon_sym_protected] = ACTIONS(3228),
    [anon_sym_using] = ACTIONS(3540),
    [anon_sym_static_assert] = ACTIONS(3542),
  },
  [778] = {
    [sym_preproc_def] = STATE(782),
    [sym_preproc_function_def] = STATE(782),
    [sym_preproc_call] = STATE(782),
    [sym_preproc_if_in_field_declaration_list] = STATE(782),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(782),
    [sym_type_definition] = STATE(782),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(5454),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6137),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__field_declaration_list_item] = STATE(782),
    [sym_field_declaration] = STATE(782),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1688),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(782),
    [sym_operator_cast] = STATE(6717),
    [sym_inline_method_definition] = STATE(782),
    [sym__constructor_specifiers] = STATE(1688),
    [sym_operator_cast_definition] = STATE(782),
    [sym_operator_cast_declaration] = STATE(782),
    [sym_constructor_or_destructor_definition] = STATE(782),
    [sym_constructor_or_destructor_declaration] = STATE(782),
    [sym_friend_declaration] = STATE(782),
    [sym_access_specifier] = STATE(7890),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_using_declaration] = STATE(782),
    [sym_alias_declaration] = STATE(782),
    [sym_static_assert_declaration] = STATE(782),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5383),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6717),
    [sym_operator_name] = STATE(5896),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(782),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2008),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1688),
    [sym_identifier] = ACTIONS(3174),
    [aux_sym_preproc_def_token1] = ACTIONS(3518),
    [aux_sym_preproc_if_token1] = ACTIONS(3520),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3522),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3522),
    [sym_preproc_directive] = ACTIONS(3524),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3570),
    [anon_sym___extension__] = ACTIONS(3528),
    [anon_sym_typedef] = ACTIONS(3530),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3656),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(3534),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3216),
    [anon_sym_struct] = ACTIONS(3218),
    [anon_sym_union] = ACTIONS(3220),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3222),
    [anon_sym_template] = ACTIONS(3536),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3538),
    [anon_sym_public] = ACTIONS(3228),
    [anon_sym_private] = ACTIONS(3228),
    [anon_sym_protected] = ACTIONS(3228),
    [anon_sym_using] = ACTIONS(3540),
    [anon_sym_static_assert] = ACTIONS(3542),
  },
  [779] = {
    [sym_preproc_def] = STATE(780),
    [sym_preproc_function_def] = STATE(780),
    [sym_preproc_call] = STATE(780),
    [sym_preproc_if_in_field_declaration_list] = STATE(780),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(780),
    [sym_type_definition] = STATE(780),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(5454),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6137),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__field_declaration_list_item] = STATE(780),
    [sym_field_declaration] = STATE(780),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1688),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(780),
    [sym_operator_cast] = STATE(6717),
    [sym_inline_method_definition] = STATE(780),
    [sym__constructor_specifiers] = STATE(1688),
    [sym_operator_cast_definition] = STATE(780),
    [sym_operator_cast_declaration] = STATE(780),
    [sym_constructor_or_destructor_definition] = STATE(780),
    [sym_constructor_or_destructor_declaration] = STATE(780),
    [sym_friend_declaration] = STATE(780),
    [sym_access_specifier] = STATE(7890),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_using_declaration] = STATE(780),
    [sym_alias_declaration] = STATE(780),
    [sym_static_assert_declaration] = STATE(780),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5383),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6717),
    [sym_operator_name] = STATE(5896),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(780),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2008),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1688),
    [sym_identifier] = ACTIONS(3174),
    [aux_sym_preproc_def_token1] = ACTIONS(3518),
    [aux_sym_preproc_if_token1] = ACTIONS(3520),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3522),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3522),
    [sym_preproc_directive] = ACTIONS(3524),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3658),
    [anon_sym___extension__] = ACTIONS(3528),
    [anon_sym_typedef] = ACTIONS(3530),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3660),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(3534),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3216),
    [anon_sym_struct] = ACTIONS(3218),
    [anon_sym_union] = ACTIONS(3220),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3222),
    [anon_sym_template] = ACTIONS(3536),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3538),
    [anon_sym_public] = ACTIONS(3228),
    [anon_sym_private] = ACTIONS(3228),
    [anon_sym_protected] = ACTIONS(3228),
    [anon_sym_using] = ACTIONS(3540),
    [anon_sym_static_assert] = ACTIONS(3542),
  },
  [780] = {
    [sym_preproc_def] = STATE(782),
    [sym_preproc_function_def] = STATE(782),
    [sym_preproc_call] = STATE(782),
    [sym_preproc_if_in_field_declaration_list] = STATE(782),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(782),
    [sym_type_definition] = STATE(782),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(5454),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6137),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__field_declaration_list_item] = STATE(782),
    [sym_field_declaration] = STATE(782),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1688),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(782),
    [sym_operator_cast] = STATE(6717),
    [sym_inline_method_definition] = STATE(782),
    [sym__constructor_specifiers] = STATE(1688),
    [sym_operator_cast_definition] = STATE(782),
    [sym_operator_cast_declaration] = STATE(782),
    [sym_constructor_or_destructor_definition] = STATE(782),
    [sym_constructor_or_destructor_declaration] = STATE(782),
    [sym_friend_declaration] = STATE(782),
    [sym_access_specifier] = STATE(7890),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_using_declaration] = STATE(782),
    [sym_alias_declaration] = STATE(782),
    [sym_static_assert_declaration] = STATE(782),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5383),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6717),
    [sym_operator_name] = STATE(5896),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(782),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2008),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1688),
    [sym_identifier] = ACTIONS(3174),
    [aux_sym_preproc_def_token1] = ACTIONS(3518),
    [aux_sym_preproc_if_token1] = ACTIONS(3520),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3522),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3522),
    [sym_preproc_directive] = ACTIONS(3524),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3570),
    [anon_sym___extension__] = ACTIONS(3528),
    [anon_sym_typedef] = ACTIONS(3530),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3662),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(3534),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3216),
    [anon_sym_struct] = ACTIONS(3218),
    [anon_sym_union] = ACTIONS(3220),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3222),
    [anon_sym_template] = ACTIONS(3536),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3538),
    [anon_sym_public] = ACTIONS(3228),
    [anon_sym_private] = ACTIONS(3228),
    [anon_sym_protected] = ACTIONS(3228),
    [anon_sym_using] = ACTIONS(3540),
    [anon_sym_static_assert] = ACTIONS(3542),
  },
  [781] = {
    [sym_preproc_def] = STATE(773),
    [sym_preproc_function_def] = STATE(773),
    [sym_preproc_call] = STATE(773),
    [sym_preproc_if_in_field_declaration_list] = STATE(773),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(773),
    [sym_type_definition] = STATE(773),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(5454),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6137),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__field_declaration_list_item] = STATE(773),
    [sym_field_declaration] = STATE(773),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1688),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(773),
    [sym_operator_cast] = STATE(6717),
    [sym_inline_method_definition] = STATE(773),
    [sym__constructor_specifiers] = STATE(1688),
    [sym_operator_cast_definition] = STATE(773),
    [sym_operator_cast_declaration] = STATE(773),
    [sym_constructor_or_destructor_definition] = STATE(773),
    [sym_constructor_or_destructor_declaration] = STATE(773),
    [sym_friend_declaration] = STATE(773),
    [sym_access_specifier] = STATE(7890),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_using_declaration] = STATE(773),
    [sym_alias_declaration] = STATE(773),
    [sym_static_assert_declaration] = STATE(773),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5383),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6717),
    [sym_operator_name] = STATE(5896),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(773),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2008),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1688),
    [sym_identifier] = ACTIONS(3174),
    [aux_sym_preproc_def_token1] = ACTIONS(3518),
    [aux_sym_preproc_if_token1] = ACTIONS(3520),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3522),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3522),
    [sym_preproc_directive] = ACTIONS(3524),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3664),
    [anon_sym___extension__] = ACTIONS(3528),
    [anon_sym_typedef] = ACTIONS(3530),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3206),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3666),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(3534),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3216),
    [anon_sym_struct] = ACTIONS(3218),
    [anon_sym_union] = ACTIONS(3220),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(3222),
    [anon_sym_template] = ACTIONS(3536),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3538),
    [anon_sym_public] = ACTIONS(3228),
    [anon_sym_private] = ACTIONS(3228),
    [anon_sym_protected] = ACTIONS(3228),
    [anon_sym_using] = ACTIONS(3540),
    [anon_sym_static_assert] = ACTIONS(3542),
  },
  [782] = {
    [sym_preproc_def] = STATE(782),
    [sym_preproc_function_def] = STATE(782),
    [sym_preproc_call] = STATE(782),
    [sym_preproc_if_in_field_declaration_list] = STATE(782),
    [sym_preproc_ifdef_in_field_declaration_list] = STATE(782),
    [sym_type_definition] = STATE(782),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(5454),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6137),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__field_declaration_list_item] = STATE(782),
    [sym_field_declaration] = STATE(782),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1688),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(782),
    [sym_operator_cast] = STATE(6717),
    [sym_inline_method_definition] = STATE(782),
    [sym__constructor_specifiers] = STATE(1688),
    [sym_operator_cast_definition] = STATE(782),
    [sym_operator_cast_declaration] = STATE(782),
    [sym_constructor_or_destructor_definition] = STATE(782),
    [sym_constructor_or_destructor_declaration] = STATE(782),
    [sym_friend_declaration] = STATE(782),
    [sym_access_specifier] = STATE(7890),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_using_declaration] = STATE(782),
    [sym_alias_declaration] = STATE(782),
    [sym_static_assert_declaration] = STATE(782),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5383),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6717),
    [sym_operator_name] = STATE(5896),
    [aux_sym_preproc_if_in_field_declaration_list_repeat1] = STATE(782),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2008),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1688),
    [sym_identifier] = ACTIONS(3330),
    [aux_sym_preproc_def_token1] = ACTIONS(3668),
    [aux_sym_preproc_if_token1] = ACTIONS(3671),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3674),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3674),
    [sym_preproc_directive] = ACTIONS(3677),
    [anon_sym_LPAREN2] = ACTIONS(3347),
    [anon_sym_TILDE] = ACTIONS(3350),
    [anon_sym_STAR] = ACTIONS(3353),
    [anon_sym_AMP_AMP] = ACTIONS(3356),
    [anon_sym_AMP] = ACTIONS(3359),
    [anon_sym_SEMI] = ACTIONS(3680),
    [anon_sym___extension__] = ACTIONS(3683),
    [anon_sym_typedef] = ACTIONS(3686),
    [anon_sym_virtual] = ACTIONS(3371),
    [anon_sym_extern] = ACTIONS(3374),
    [anon_sym___attribute__] = ACTIONS(3377),
    [anon_sym___attribute] = ACTIONS(3377),
    [anon_sym_COLON_COLON] = ACTIONS(3380),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3383),
    [anon_sym___declspec] = ACTIONS(3386),
    [anon_sym___based] = ACTIONS(3389),
    [anon_sym_RBRACE] = ACTIONS(3689),
    [anon_sym_signed] = ACTIONS(3392),
    [anon_sym_unsigned] = ACTIONS(3392),
    [anon_sym_long] = ACTIONS(3392),
    [anon_sym_short] = ACTIONS(3392),
    [anon_sym_LBRACK] = ACTIONS(3395),
    [anon_sym_static] = ACTIONS(3374),
    [anon_sym_register] = ACTIONS(3374),
    [anon_sym_inline] = ACTIONS(3374),
    [anon_sym___inline] = ACTIONS(3374),
    [anon_sym___inline__] = ACTIONS(3374),
    [anon_sym___forceinline] = ACTIONS(3374),
    [anon_sym_thread_local] = ACTIONS(3374),
    [anon_sym___thread] = ACTIONS(3374),
    [anon_sym_const] = ACTIONS(3398),
    [anon_sym_constexpr] = ACTIONS(3691),
    [anon_sym_volatile] = ACTIONS(3398),
    [anon_sym_restrict] = ACTIONS(3398),
    [anon_sym___restrict__] = ACTIONS(3398),
    [anon_sym__Atomic] = ACTIONS(3398),
    [anon_sym__Noreturn] = ACTIONS(3398),
    [anon_sym_noreturn] = ACTIONS(3398),
    [anon_sym__Nonnull] = ACTIONS(3398),
    [anon_sym_mutable] = ACTIONS(3398),
    [anon_sym_constinit] = ACTIONS(3398),
    [anon_sym_consteval] = ACTIONS(3398),
    [anon_sym_alignas] = ACTIONS(3404),
    [anon_sym__Alignas] = ACTIONS(3404),
    [sym_primitive_type] = ACTIONS(3407),
    [anon_sym_enum] = ACTIONS(3410),
    [anon_sym_class] = ACTIONS(3413),
    [anon_sym_struct] = ACTIONS(3416),
    [anon_sym_union] = ACTIONS(3419),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3422),
    [anon_sym_decltype] = ACTIONS(3425),
    [anon_sym_explicit] = ACTIONS(3428),
    [anon_sym_typename] = ACTIONS(3431),
    [anon_sym_template] = ACTIONS(3694),
    [anon_sym_operator] = ACTIONS(3437),
    [anon_sym_friend] = ACTIONS(3697),
    [anon_sym_public] = ACTIONS(3443),
    [anon_sym_private] = ACTIONS(3443),
    [anon_sym_protected] = ACTIONS(3443),
    [anon_sym_using] = ACTIONS(3700),
    [anon_sym_static_assert] = ACTIONS(3703),
  },
  [783] = {
    [sym_expression] = STATE(3655),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(3776),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1917),
    [anon_sym_COMMA] = ACTIONS(1917),
    [anon_sym_RPAREN] = ACTIONS(1917),
    [anon_sym_LPAREN2] = ACTIONS(1917),
    [anon_sym_BANG] = ACTIONS(25),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(1915),
    [anon_sym_PLUS] = ACTIONS(1915),
    [anon_sym_STAR] = ACTIONS(1917),
    [anon_sym_SLASH] = ACTIONS(1915),
    [anon_sym_PERCENT] = ACTIONS(1917),
    [anon_sym_PIPE_PIPE] = ACTIONS(1917),
    [anon_sym_AMP_AMP] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(1915),
    [anon_sym_CARET] = ACTIONS(1917),
    [anon_sym_AMP] = ACTIONS(1915),
    [anon_sym_EQ_EQ] = ACTIONS(1917),
    [anon_sym_BANG_EQ] = ACTIONS(1917),
    [anon_sym_GT] = ACTIONS(1915),
    [anon_sym_GT_EQ] = ACTIONS(1917),
    [anon_sym_LT_EQ] = ACTIONS(1915),
    [anon_sym_LT] = ACTIONS(1915),
    [anon_sym_LT_LT] = ACTIONS(1917),
    [anon_sym_GT_GT] = ACTIONS(1917),
    [anon_sym_SEMI] = ACTIONS(1917),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_RBRACE] = ACTIONS(1917),
    [anon_sym_LBRACK] = ACTIONS(1917),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_QMARK] = ACTIONS(1917),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_LT_EQ_GT] = ACTIONS(1917),
    [anon_sym_or] = ACTIONS(1915),
    [anon_sym_and] = ACTIONS(1915),
    [anon_sym_bitor] = ACTIONS(1915),
    [anon_sym_xor] = ACTIONS(1915),
    [anon_sym_bitand] = ACTIONS(1915),
    [anon_sym_not_eq] = ACTIONS(1915),
    [anon_sym_DASH_DASH] = ACTIONS(1917),
    [anon_sym_PLUS_PLUS] = ACTIONS(1917),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(1915),
    [anon_sym_DOT_STAR] = ACTIONS(1917),
    [anon_sym_DASH_GT] = ACTIONS(1917),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [784] = {
    [sym_expression] = STATE(4498),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_initializer_list] = STATE(3776),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1917),
    [anon_sym_COMMA] = ACTIONS(1917),
    [anon_sym_LPAREN2] = ACTIONS(1917),
    [anon_sym_BANG] = ACTIONS(3710),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(1915),
    [anon_sym_PLUS] = ACTIONS(1915),
    [anon_sym_STAR] = ACTIONS(1917),
    [anon_sym_SLASH] = ACTIONS(1915),
    [anon_sym_PERCENT] = ACTIONS(1917),
    [anon_sym_PIPE_PIPE] = ACTIONS(1917),
    [anon_sym_AMP_AMP] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(1915),
    [anon_sym_CARET] = ACTIONS(1917),
    [anon_sym_AMP] = ACTIONS(1915),
    [anon_sym_EQ_EQ] = ACTIONS(1917),
    [anon_sym_BANG_EQ] = ACTIONS(1917),
    [anon_sym_GT] = ACTIONS(1915),
    [anon_sym_GT_EQ] = ACTIONS(1917),
    [anon_sym_LT_EQ] = ACTIONS(1915),
    [anon_sym_LT] = ACTIONS(1915),
    [anon_sym_LT_LT] = ACTIONS(1917),
    [anon_sym_GT_GT] = ACTIONS(1917),
    [anon_sym___extension__] = ACTIONS(3714),
    [anon_sym_COLON_COLON] = ACTIONS(3716),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(1917),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_COLON] = ACTIONS(1915),
    [anon_sym_QMARK] = ACTIONS(1917),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_LT_EQ_GT] = ACTIONS(1917),
    [anon_sym_or] = ACTIONS(1915),
    [anon_sym_and] = ACTIONS(1915),
    [anon_sym_bitor] = ACTIONS(1915),
    [anon_sym_xor] = ACTIONS(1915),
    [anon_sym_bitand] = ACTIONS(1915),
    [anon_sym_not_eq] = ACTIONS(1915),
    [anon_sym_DASH_DASH] = ACTIONS(1917),
    [anon_sym_PLUS_PLUS] = ACTIONS(1917),
    [anon_sym_sizeof] = ACTIONS(3718),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(1915),
    [anon_sym_DOT_STAR] = ACTIONS(1917),
    [anon_sym_DASH_GT] = ACTIONS(1917),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3720),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3722),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [785] = {
    [sym_expression] = STATE(4366),
    [sym__string] = STATE(4637),
    [sym_conditional_expression] = STATE(4735),
    [sym_assignment_expression] = STATE(4735),
    [sym_pointer_expression] = STATE(3573),
    [sym_unary_expression] = STATE(4735),
    [sym_binary_expression] = STATE(4735),
    [sym_update_expression] = STATE(4735),
    [sym_cast_expression] = STATE(4735),
    [sym_sizeof_expression] = STATE(4735),
    [sym_alignof_expression] = STATE(4735),
    [sym_offsetof_expression] = STATE(4735),
    [sym_generic_expression] = STATE(4735),
    [sym_subscript_expression] = STATE(3573),
    [sym_call_expression] = STATE(3573),
    [sym_gnu_asm_expression] = STATE(4735),
    [sym_extension_expression] = STATE(4735),
    [sym_field_expression] = STATE(3573),
    [sym_compound_literal_expression] = STATE(4735),
    [sym_parenthesized_expression] = STATE(3573),
    [sym_initializer_list] = STATE(4793),
    [sym_char_literal] = STATE(4637),
    [sym_concatenated_string] = STATE(4637),
    [sym_string_literal] = STATE(3662),
    [sym_null] = STATE(4735),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7513),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(4735),
    [sym_raw_string_literal] = STATE(3662),
    [sym_co_await_expression] = STATE(4735),
    [sym_new_expression] = STATE(4735),
    [sym_delete_expression] = STATE(4735),
    [sym_requires_clause] = STATE(4735),
    [sym_requires_expression] = STATE(4735),
    [sym_lambda_expression] = STATE(4735),
    [sym_lambda_capture_specifier] = STATE(5854),
    [sym_fold_expression] = STATE(4735),
    [sym_parameter_pack_expansion] = STATE(4735),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3573),
    [sym_qualified_type_identifier] = STATE(7513),
    [sym_user_defined_literal] = STATE(3573),
    [sym_identifier] = ACTIONS(3726),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1917),
    [anon_sym_COMMA] = ACTIONS(1917),
    [anon_sym_LPAREN2] = ACTIONS(1917),
    [anon_sym_BANG] = ACTIONS(2860),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(1915),
    [anon_sym_PLUS] = ACTIONS(1915),
    [anon_sym_STAR] = ACTIONS(1917),
    [anon_sym_SLASH] = ACTIONS(1915),
    [anon_sym_PERCENT] = ACTIONS(1917),
    [anon_sym_PIPE_PIPE] = ACTIONS(1917),
    [anon_sym_AMP_AMP] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(1915),
    [anon_sym_CARET] = ACTIONS(1917),
    [anon_sym_AMP] = ACTIONS(1915),
    [anon_sym_EQ_EQ] = ACTIONS(1917),
    [anon_sym_BANG_EQ] = ACTIONS(1917),
    [anon_sym_GT] = ACTIONS(1915),
    [anon_sym_GT_EQ] = ACTIONS(1915),
    [anon_sym_LT_EQ] = ACTIONS(1915),
    [anon_sym_LT] = ACTIONS(1915),
    [anon_sym_LT_LT] = ACTIONS(1917),
    [anon_sym_GT_GT] = ACTIONS(1915),
    [anon_sym___extension__] = ACTIONS(3728),
    [anon_sym_COLON_COLON] = ACTIONS(2866),
    [anon_sym_LBRACE] = ACTIONS(3730),
    [anon_sym_LBRACK] = ACTIONS(1917),
    [sym_primitive_type] = ACTIONS(3732),
    [anon_sym_QMARK] = ACTIONS(1917),
    [anon_sym_not] = ACTIONS(2860),
    [anon_sym_compl] = ACTIONS(2860),
    [anon_sym_LT_EQ_GT] = ACTIONS(1917),
    [anon_sym_or] = ACTIONS(1915),
    [anon_sym_and] = ACTIONS(1915),
    [anon_sym_bitor] = ACTIONS(1915),
    [anon_sym_xor] = ACTIONS(1915),
    [anon_sym_bitand] = ACTIONS(1915),
    [anon_sym_not_eq] = ACTIONS(1915),
    [anon_sym_DASH_DASH] = ACTIONS(1917),
    [anon_sym_PLUS_PLUS] = ACTIONS(1917),
    [anon_sym_sizeof] = ACTIONS(2882),
    [anon_sym___alignof__] = ACTIONS(2884),
    [anon_sym___alignof] = ACTIONS(2884),
    [anon_sym__alignof] = ACTIONS(2884),
    [anon_sym_alignof] = ACTIONS(2884),
    [anon_sym__Alignof] = ACTIONS(2884),
    [anon_sym_offsetof] = ACTIONS(2886),
    [anon_sym__Generic] = ACTIONS(2888),
    [anon_sym_asm] = ACTIONS(2890),
    [anon_sym___asm__] = ACTIONS(2890),
    [anon_sym___asm] = ACTIONS(2890),
    [anon_sym_DOT] = ACTIONS(1915),
    [anon_sym_DOT_STAR] = ACTIONS(1917),
    [anon_sym_DASH_GT] = ACTIONS(1917),
    [sym_number_literal] = ACTIONS(2892),
    [anon_sym_L_SQUOTE] = ACTIONS(2894),
    [anon_sym_u_SQUOTE] = ACTIONS(2894),
    [anon_sym_U_SQUOTE] = ACTIONS(2894),
    [anon_sym_u8_SQUOTE] = ACTIONS(2894),
    [anon_sym_SQUOTE] = ACTIONS(2894),
    [anon_sym_L_DQUOTE] = ACTIONS(2896),
    [anon_sym_u_DQUOTE] = ACTIONS(2896),
    [anon_sym_U_DQUOTE] = ACTIONS(2896),
    [anon_sym_u8_DQUOTE] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [anon_sym_NULL] = ACTIONS(2900),
    [anon_sym_nullptr] = ACTIONS(2900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_GT2] = ACTIONS(1917),
    [anon_sym_delete] = ACTIONS(2910),
    [anon_sym_R_DQUOTE] = ACTIONS(2912),
    [anon_sym_LR_DQUOTE] = ACTIONS(2912),
    [anon_sym_uR_DQUOTE] = ACTIONS(2912),
    [anon_sym_UR_DQUOTE] = ACTIONS(2912),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2912),
    [anon_sym_co_await] = ACTIONS(2914),
    [anon_sym_new] = ACTIONS(2916),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2898),
  },
  [786] = {
    [sym_expression] = STATE(3655),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_initializer_list] = STATE(3776),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1917),
    [anon_sym_COMMA] = ACTIONS(1917),
    [anon_sym_LPAREN2] = ACTIONS(1917),
    [anon_sym_BANG] = ACTIONS(3736),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(1915),
    [anon_sym_PLUS] = ACTIONS(1915),
    [anon_sym_STAR] = ACTIONS(1917),
    [anon_sym_SLASH] = ACTIONS(1915),
    [anon_sym_PERCENT] = ACTIONS(1917),
    [anon_sym_PIPE_PIPE] = ACTIONS(1917),
    [anon_sym_AMP_AMP] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(1915),
    [anon_sym_CARET] = ACTIONS(1917),
    [anon_sym_AMP] = ACTIONS(1915),
    [anon_sym_EQ_EQ] = ACTIONS(1917),
    [anon_sym_BANG_EQ] = ACTIONS(1917),
    [anon_sym_GT] = ACTIONS(1915),
    [anon_sym_GT_EQ] = ACTIONS(1917),
    [anon_sym_LT_EQ] = ACTIONS(1915),
    [anon_sym_LT] = ACTIONS(1915),
    [anon_sym_LT_LT] = ACTIONS(1917),
    [anon_sym_GT_GT] = ACTIONS(1917),
    [anon_sym___extension__] = ACTIONS(3740),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(1917),
    [anon_sym_RBRACK] = ACTIONS(1917),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_QMARK] = ACTIONS(1917),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_LT_EQ_GT] = ACTIONS(1917),
    [anon_sym_or] = ACTIONS(1915),
    [anon_sym_and] = ACTIONS(1915),
    [anon_sym_bitor] = ACTIONS(1915),
    [anon_sym_xor] = ACTIONS(1915),
    [anon_sym_bitand] = ACTIONS(1915),
    [anon_sym_not_eq] = ACTIONS(1915),
    [anon_sym_DASH_DASH] = ACTIONS(1917),
    [anon_sym_PLUS_PLUS] = ACTIONS(1917),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(1915),
    [anon_sym_DOT_STAR] = ACTIONS(1917),
    [anon_sym_DASH_GT] = ACTIONS(1917),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [787] = {
    [sym_expression] = STATE(4715),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3750),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3736),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_SLASH] = ACTIONS(3754),
    [anon_sym_PERCENT] = ACTIONS(3750),
    [anon_sym_PIPE_PIPE] = ACTIONS(3750),
    [anon_sym_AMP_AMP] = ACTIONS(3750),
    [anon_sym_PIPE] = ACTIONS(3754),
    [anon_sym_CARET] = ACTIONS(3750),
    [anon_sym_AMP] = ACTIONS(1225),
    [anon_sym_EQ_EQ] = ACTIONS(3750),
    [anon_sym_BANG_EQ] = ACTIONS(3750),
    [anon_sym_GT] = ACTIONS(3754),
    [anon_sym_GT_EQ] = ACTIONS(3750),
    [anon_sym_LT_EQ] = ACTIONS(3754),
    [anon_sym_LT] = ACTIONS(3754),
    [anon_sym_LT_LT] = ACTIONS(3750),
    [anon_sym_GT_GT] = ACTIONS(3750),
    [anon_sym___extension__] = ACTIONS(3740),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_RBRACK] = ACTIONS(3750),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_QMARK] = ACTIONS(3750),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_LT_EQ_GT] = ACTIONS(3750),
    [anon_sym_or] = ACTIONS(3754),
    [anon_sym_and] = ACTIONS(3754),
    [anon_sym_bitor] = ACTIONS(3754),
    [anon_sym_xor] = ACTIONS(3754),
    [anon_sym_bitand] = ACTIONS(3754),
    [anon_sym_not_eq] = ACTIONS(3754),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(3754),
    [anon_sym_DOT_STAR] = ACTIONS(3750),
    [anon_sym_DASH_GT] = ACTIONS(3750),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [788] = {
    [sym__declaration_modifiers] = STATE(1978),
    [sym__declaration_specifiers] = STATE(6241),
    [sym_attribute_specifier] = STATE(1978),
    [sym_attribute_declaration] = STATE(1978),
    [sym_ms_declspec_modifier] = STATE(1978),
    [sym_storage_class_specifier] = STATE(1978),
    [sym_type_qualifier] = STATE(1978),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(3965),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2336),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(6476),
    [sym_qualified_type_identifier] = STATE(2788),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1978),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2667),
    [sym_identifier] = ACTIONS(3758),
    [anon_sym_COMMA] = ACTIONS(3760),
    [anon_sym_BANG] = ACTIONS(3762),
    [anon_sym_TILDE] = ACTIONS(3760),
    [anon_sym_DASH] = ACTIONS(3762),
    [anon_sym_PLUS] = ACTIONS(3762),
    [anon_sym_STAR] = ACTIONS(3762),
    [anon_sym_SLASH] = ACTIONS(3762),
    [anon_sym_PERCENT] = ACTIONS(3762),
    [anon_sym_PIPE_PIPE] = ACTIONS(3760),
    [anon_sym_AMP_AMP] = ACTIONS(3760),
    [anon_sym_PIPE] = ACTIONS(3762),
    [anon_sym_CARET] = ACTIONS(3762),
    [anon_sym_AMP] = ACTIONS(3762),
    [anon_sym_EQ_EQ] = ACTIONS(3760),
    [anon_sym_BANG_EQ] = ACTIONS(3760),
    [anon_sym_GT] = ACTIONS(3762),
    [anon_sym_GT_EQ] = ACTIONS(3760),
    [anon_sym_LT_EQ] = ACTIONS(3762),
    [anon_sym_LT] = ACTIONS(3762),
    [anon_sym_LT_LT] = ACTIONS(3762),
    [anon_sym_GT_GT] = ACTIONS(3762),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(3764),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3766),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(3768),
    [anon_sym_unsigned] = ACTIONS(3768),
    [anon_sym_long] = ACTIONS(3768),
    [anon_sym_short] = ACTIONS(3768),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_EQ] = ACTIONS(3762),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3770),
    [anon_sym_enum] = ACTIONS(3772),
    [anon_sym_class] = ACTIONS(3774),
    [anon_sym_struct] = ACTIONS(3776),
    [anon_sym_union] = ACTIONS(3778),
    [anon_sym_STAR_EQ] = ACTIONS(3760),
    [anon_sym_SLASH_EQ] = ACTIONS(3760),
    [anon_sym_PERCENT_EQ] = ACTIONS(3760),
    [anon_sym_PLUS_EQ] = ACTIONS(3760),
    [anon_sym_DASH_EQ] = ACTIONS(3760),
    [anon_sym_LT_LT_EQ] = ACTIONS(3760),
    [anon_sym_GT_GT_EQ] = ACTIONS(3760),
    [anon_sym_AMP_EQ] = ACTIONS(3760),
    [anon_sym_CARET_EQ] = ACTIONS(3760),
    [anon_sym_PIPE_EQ] = ACTIONS(3760),
    [anon_sym_and_eq] = ACTIONS(3762),
    [anon_sym_or_eq] = ACTIONS(3762),
    [anon_sym_xor_eq] = ACTIONS(3762),
    [anon_sym_not] = ACTIONS(3762),
    [anon_sym_compl] = ACTIONS(3762),
    [anon_sym_LT_EQ_GT] = ACTIONS(3760),
    [anon_sym_or] = ACTIONS(3762),
    [anon_sym_and] = ACTIONS(3762),
    [anon_sym_bitor] = ACTIONS(3762),
    [anon_sym_xor] = ACTIONS(3762),
    [anon_sym_bitand] = ACTIONS(3762),
    [anon_sym_not_eq] = ACTIONS(3762),
    [anon_sym_DASH_DASH] = ACTIONS(3760),
    [anon_sym_PLUS_PLUS] = ACTIONS(3760),
    [anon_sym_DASH_GT] = ACTIONS(3762),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(3780),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3782),
    [anon_sym_co_await] = ACTIONS(3762),
    [anon_sym_new] = ACTIONS(3782),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3760),
    [anon_sym_LPAREN_RPAREN] = ACTIONS(3760),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3760),
    [anon_sym_DQUOTE_DQUOTE] = ACTIONS(3784),
  },
  [789] = {
    [sym__declaration_modifiers] = STATE(1978),
    [sym__declaration_specifiers] = STATE(6241),
    [sym_attribute_specifier] = STATE(1978),
    [sym_attribute_declaration] = STATE(1978),
    [sym_ms_declspec_modifier] = STATE(1978),
    [sym_storage_class_specifier] = STATE(1978),
    [sym_type_qualifier] = STATE(1978),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(3965),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2336),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(6476),
    [sym_qualified_type_identifier] = STATE(2788),
    [aux_sym__declaration_specifiers_repeat1] = STATE(1978),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2667),
    [sym_identifier] = ACTIONS(3758),
    [anon_sym_COMMA] = ACTIONS(3786),
    [anon_sym_BANG] = ACTIONS(3788),
    [anon_sym_TILDE] = ACTIONS(3786),
    [anon_sym_DASH] = ACTIONS(3788),
    [anon_sym_PLUS] = ACTIONS(3788),
    [anon_sym_STAR] = ACTIONS(3788),
    [anon_sym_SLASH] = ACTIONS(3788),
    [anon_sym_PERCENT] = ACTIONS(3788),
    [anon_sym_PIPE_PIPE] = ACTIONS(3786),
    [anon_sym_AMP_AMP] = ACTIONS(3786),
    [anon_sym_PIPE] = ACTIONS(3788),
    [anon_sym_CARET] = ACTIONS(3788),
    [anon_sym_AMP] = ACTIONS(3788),
    [anon_sym_EQ_EQ] = ACTIONS(3786),
    [anon_sym_BANG_EQ] = ACTIONS(3786),
    [anon_sym_GT] = ACTIONS(3788),
    [anon_sym_GT_EQ] = ACTIONS(3786),
    [anon_sym_LT_EQ] = ACTIONS(3788),
    [anon_sym_LT] = ACTIONS(3788),
    [anon_sym_LT_LT] = ACTIONS(3788),
    [anon_sym_GT_GT] = ACTIONS(3788),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(3764),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3766),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(3768),
    [anon_sym_unsigned] = ACTIONS(3768),
    [anon_sym_long] = ACTIONS(3768),
    [anon_sym_short] = ACTIONS(3768),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_EQ] = ACTIONS(3788),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3770),
    [anon_sym_enum] = ACTIONS(3772),
    [anon_sym_class] = ACTIONS(3774),
    [anon_sym_struct] = ACTIONS(3776),
    [anon_sym_union] = ACTIONS(3778),
    [anon_sym_STAR_EQ] = ACTIONS(3786),
    [anon_sym_SLASH_EQ] = ACTIONS(3786),
    [anon_sym_PERCENT_EQ] = ACTIONS(3786),
    [anon_sym_PLUS_EQ] = ACTIONS(3786),
    [anon_sym_DASH_EQ] = ACTIONS(3786),
    [anon_sym_LT_LT_EQ] = ACTIONS(3786),
    [anon_sym_GT_GT_EQ] = ACTIONS(3786),
    [anon_sym_AMP_EQ] = ACTIONS(3786),
    [anon_sym_CARET_EQ] = ACTIONS(3786),
    [anon_sym_PIPE_EQ] = ACTIONS(3786),
    [anon_sym_and_eq] = ACTIONS(3788),
    [anon_sym_or_eq] = ACTIONS(3788),
    [anon_sym_xor_eq] = ACTIONS(3788),
    [anon_sym_not] = ACTIONS(3788),
    [anon_sym_compl] = ACTIONS(3788),
    [anon_sym_LT_EQ_GT] = ACTIONS(3786),
    [anon_sym_or] = ACTIONS(3788),
    [anon_sym_and] = ACTIONS(3788),
    [anon_sym_bitor] = ACTIONS(3788),
    [anon_sym_xor] = ACTIONS(3788),
    [anon_sym_bitand] = ACTIONS(3788),
    [anon_sym_not_eq] = ACTIONS(3788),
    [anon_sym_DASH_DASH] = ACTIONS(3786),
    [anon_sym_PLUS_PLUS] = ACTIONS(3786),
    [anon_sym_DASH_GT] = ACTIONS(3788),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(3780),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3790),
    [anon_sym_co_await] = ACTIONS(3788),
    [anon_sym_new] = ACTIONS(3790),
    [anon_sym_DASH_GT_STAR] = ACTIONS(3786),
    [anon_sym_LPAREN_RPAREN] = ACTIONS(3786),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3786),
    [anon_sym_DQUOTE_DQUOTE] = ACTIONS(3792),
  },
  [790] = {
    [sym_expression] = STATE(4444),
    [sym__string] = STATE(4637),
    [sym_conditional_expression] = STATE(4735),
    [sym_assignment_expression] = STATE(4735),
    [sym_pointer_expression] = STATE(3573),
    [sym_unary_expression] = STATE(4735),
    [sym_binary_expression] = STATE(4735),
    [sym_update_expression] = STATE(4735),
    [sym_cast_expression] = STATE(4735),
    [sym_sizeof_expression] = STATE(4735),
    [sym_alignof_expression] = STATE(4735),
    [sym_offsetof_expression] = STATE(4735),
    [sym_generic_expression] = STATE(4735),
    [sym_subscript_expression] = STATE(3573),
    [sym_call_expression] = STATE(3573),
    [sym_gnu_asm_expression] = STATE(4735),
    [sym_extension_expression] = STATE(4735),
    [sym_field_expression] = STATE(3573),
    [sym_compound_literal_expression] = STATE(4735),
    [sym_parenthesized_expression] = STATE(3573),
    [sym_char_literal] = STATE(4637),
    [sym_concatenated_string] = STATE(4637),
    [sym_string_literal] = STATE(3662),
    [sym_null] = STATE(4735),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7513),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(4735),
    [sym_raw_string_literal] = STATE(3662),
    [sym_co_await_expression] = STATE(4735),
    [sym_new_expression] = STATE(4735),
    [sym_delete_expression] = STATE(4735),
    [sym_requires_clause] = STATE(4735),
    [sym_requires_expression] = STATE(4735),
    [sym_lambda_expression] = STATE(4735),
    [sym_lambda_capture_specifier] = STATE(5854),
    [sym_fold_expression] = STATE(4735),
    [sym_parameter_pack_expansion] = STATE(4735),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3573),
    [sym_qualified_type_identifier] = STATE(7513),
    [sym_user_defined_literal] = STATE(3573),
    [sym_identifier] = ACTIONS(3794),
    [anon_sym_LPAREN2] = ACTIONS(2856),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(3797),
    [anon_sym_COLON_COLON] = ACTIONS(3800),
    [anon_sym_signed] = ACTIONS(2536),
    [anon_sym_unsigned] = ACTIONS(2536),
    [anon_sym_long] = ACTIONS(2536),
    [anon_sym_short] = ACTIONS(2536),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(2536),
    [anon_sym_constexpr] = ACTIONS(2536),
    [anon_sym_volatile] = ACTIONS(2536),
    [anon_sym_restrict] = ACTIONS(2536),
    [anon_sym___restrict__] = ACTIONS(2536),
    [anon_sym__Atomic] = ACTIONS(2536),
    [anon_sym__Noreturn] = ACTIONS(2536),
    [anon_sym_noreturn] = ACTIONS(2536),
    [anon_sym__Nonnull] = ACTIONS(2536),
    [anon_sym_mutable] = ACTIONS(2536),
    [anon_sym_constinit] = ACTIONS(2536),
    [anon_sym_consteval] = ACTIONS(2536),
    [anon_sym_alignas] = ACTIONS(2536),
    [anon_sym__Alignas] = ACTIONS(2536),
    [sym_primitive_type] = ACTIONS(3803),
    [anon_sym_enum] = ACTIONS(2536),
    [anon_sym_class] = ACTIONS(2536),
    [anon_sym_struct] = ACTIONS(2536),
    [anon_sym_union] = ACTIONS(2536),
    [anon_sym_not] = ACTIONS(2860),
    [anon_sym_compl] = ACTIONS(2860),
    [anon_sym_DASH_DASH] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(2880),
    [anon_sym_sizeof] = ACTIONS(2882),
    [anon_sym___alignof__] = ACTIONS(2884),
    [anon_sym___alignof] = ACTIONS(2884),
    [anon_sym__alignof] = ACTIONS(2884),
    [anon_sym_alignof] = ACTIONS(2884),
    [anon_sym__Alignof] = ACTIONS(2884),
    [anon_sym_offsetof] = ACTIONS(2886),
    [anon_sym__Generic] = ACTIONS(2888),
    [anon_sym_asm] = ACTIONS(2890),
    [anon_sym___asm__] = ACTIONS(2890),
    [anon_sym___asm] = ACTIONS(2890),
    [sym_number_literal] = ACTIONS(2892),
    [anon_sym_L_SQUOTE] = ACTIONS(2894),
    [anon_sym_u_SQUOTE] = ACTIONS(2894),
    [anon_sym_U_SQUOTE] = ACTIONS(2894),
    [anon_sym_u8_SQUOTE] = ACTIONS(2894),
    [anon_sym_SQUOTE] = ACTIONS(2894),
    [anon_sym_L_DQUOTE] = ACTIONS(2896),
    [anon_sym_u_DQUOTE] = ACTIONS(2896),
    [anon_sym_U_DQUOTE] = ACTIONS(2896),
    [anon_sym_u8_DQUOTE] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [anon_sym_NULL] = ACTIONS(2900),
    [anon_sym_nullptr] = ACTIONS(2900),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2536),
    [anon_sym_decltype] = ACTIONS(2547),
    [anon_sym_typename] = ACTIONS(2536),
    [anon_sym_template] = ACTIONS(2550),
    [anon_sym_delete] = ACTIONS(2910),
    [anon_sym_R_DQUOTE] = ACTIONS(2912),
    [anon_sym_LR_DQUOTE] = ACTIONS(2912),
    [anon_sym_uR_DQUOTE] = ACTIONS(2912),
    [anon_sym_UR_DQUOTE] = ACTIONS(2912),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2912),
    [anon_sym_co_await] = ACTIONS(2914),
    [anon_sym_new] = ACTIONS(2916),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2898),
  },
  [791] = {
    [sym_expression] = STATE(4247),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(2514),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2531),
    [anon_sym_COLON_COLON] = ACTIONS(2538),
    [anon_sym_signed] = ACTIONS(2536),
    [anon_sym_unsigned] = ACTIONS(2536),
    [anon_sym_long] = ACTIONS(2536),
    [anon_sym_short] = ACTIONS(2536),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(2536),
    [anon_sym_constexpr] = ACTIONS(2536),
    [anon_sym_volatile] = ACTIONS(2536),
    [anon_sym_restrict] = ACTIONS(2536),
    [anon_sym___restrict__] = ACTIONS(2536),
    [anon_sym__Atomic] = ACTIONS(2536),
    [anon_sym__Noreturn] = ACTIONS(2536),
    [anon_sym_noreturn] = ACTIONS(2536),
    [anon_sym__Nonnull] = ACTIONS(2536),
    [anon_sym_mutable] = ACTIONS(2536),
    [anon_sym_constinit] = ACTIONS(2536),
    [anon_sym_consteval] = ACTIONS(2536),
    [anon_sym_alignas] = ACTIONS(2536),
    [anon_sym__Alignas] = ACTIONS(2536),
    [sym_primitive_type] = ACTIONS(2544),
    [anon_sym_enum] = ACTIONS(2536),
    [anon_sym_class] = ACTIONS(2536),
    [anon_sym_struct] = ACTIONS(2536),
    [anon_sym_union] = ACTIONS(2536),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2536),
    [anon_sym_decltype] = ACTIONS(2547),
    [anon_sym_typename] = ACTIONS(2536),
    [anon_sym_template] = ACTIONS(2550),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [792] = {
    [sym_expression] = STATE(3153),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(3806),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(3809),
    [anon_sym_COLON_COLON] = ACTIONS(3812),
    [anon_sym_signed] = ACTIONS(2536),
    [anon_sym_unsigned] = ACTIONS(2536),
    [anon_sym_long] = ACTIONS(2536),
    [anon_sym_short] = ACTIONS(2536),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(2536),
    [anon_sym_constexpr] = ACTIONS(2536),
    [anon_sym_volatile] = ACTIONS(2536),
    [anon_sym_restrict] = ACTIONS(2536),
    [anon_sym___restrict__] = ACTIONS(2536),
    [anon_sym__Atomic] = ACTIONS(2536),
    [anon_sym__Noreturn] = ACTIONS(2536),
    [anon_sym_noreturn] = ACTIONS(2536),
    [anon_sym__Nonnull] = ACTIONS(2536),
    [anon_sym_mutable] = ACTIONS(2536),
    [anon_sym_constinit] = ACTIONS(2536),
    [anon_sym_consteval] = ACTIONS(2536),
    [anon_sym_alignas] = ACTIONS(2536),
    [anon_sym__Alignas] = ACTIONS(2536),
    [sym_primitive_type] = ACTIONS(3815),
    [anon_sym_enum] = ACTIONS(2536),
    [anon_sym_class] = ACTIONS(2536),
    [anon_sym_struct] = ACTIONS(2536),
    [anon_sym_union] = ACTIONS(2536),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2536),
    [anon_sym_decltype] = ACTIONS(2547),
    [anon_sym_typename] = ACTIONS(2536),
    [anon_sym_template] = ACTIONS(2550),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [793] = {
    [sym_identifier] = ACTIONS(3818),
    [anon_sym_COMMA] = ACTIONS(3820),
    [anon_sym_RPAREN] = ACTIONS(3820),
    [anon_sym_LPAREN2] = ACTIONS(3820),
    [anon_sym_BANG] = ACTIONS(3820),
    [anon_sym_TILDE] = ACTIONS(3820),
    [anon_sym_DASH] = ACTIONS(3818),
    [anon_sym_PLUS] = ACTIONS(3818),
    [anon_sym_STAR] = ACTIONS(3820),
    [anon_sym_AMP_AMP] = ACTIONS(3820),
    [anon_sym_AMP] = ACTIONS(3818),
    [anon_sym_SEMI] = ACTIONS(3820),
    [anon_sym___extension__] = ACTIONS(3818),
    [anon_sym_virtual] = ACTIONS(3818),
    [anon_sym_extern] = ACTIONS(3818),
    [anon_sym___attribute__] = ACTIONS(3818),
    [anon_sym___attribute] = ACTIONS(3818),
    [anon_sym_COLON_COLON] = ACTIONS(3820),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3820),
    [anon_sym___declspec] = ACTIONS(3818),
    [anon_sym___based] = ACTIONS(3818),
    [anon_sym_LBRACE] = ACTIONS(3820),
    [anon_sym_signed] = ACTIONS(3818),
    [anon_sym_unsigned] = ACTIONS(3818),
    [anon_sym_long] = ACTIONS(3818),
    [anon_sym_short] = ACTIONS(3818),
    [anon_sym_LBRACK] = ACTIONS(3818),
    [anon_sym_static] = ACTIONS(3818),
    [anon_sym_RBRACK] = ACTIONS(3820),
    [anon_sym_EQ] = ACTIONS(3820),
    [anon_sym_register] = ACTIONS(3818),
    [anon_sym_inline] = ACTIONS(3818),
    [anon_sym___inline] = ACTIONS(3818),
    [anon_sym___inline__] = ACTIONS(3818),
    [anon_sym___forceinline] = ACTIONS(3818),
    [anon_sym_thread_local] = ACTIONS(3818),
    [anon_sym___thread] = ACTIONS(3818),
    [anon_sym_const] = ACTIONS(3818),
    [anon_sym_constexpr] = ACTIONS(3818),
    [anon_sym_volatile] = ACTIONS(3818),
    [anon_sym_restrict] = ACTIONS(3818),
    [anon_sym___restrict__] = ACTIONS(3818),
    [anon_sym__Atomic] = ACTIONS(3818),
    [anon_sym__Noreturn] = ACTIONS(3818),
    [anon_sym_noreturn] = ACTIONS(3818),
    [anon_sym__Nonnull] = ACTIONS(3818),
    [anon_sym_mutable] = ACTIONS(3818),
    [anon_sym_constinit] = ACTIONS(3818),
    [anon_sym_consteval] = ACTIONS(3818),
    [anon_sym_alignas] = ACTIONS(3818),
    [anon_sym__Alignas] = ACTIONS(3818),
    [sym_primitive_type] = ACTIONS(3818),
    [anon_sym_enum] = ACTIONS(3818),
    [anon_sym_class] = ACTIONS(3818),
    [anon_sym_struct] = ACTIONS(3818),
    [anon_sym_union] = ACTIONS(3818),
    [anon_sym_if] = ACTIONS(3818),
    [anon_sym_switch] = ACTIONS(3818),
    [anon_sym_case] = ACTIONS(3818),
    [anon_sym_default] = ACTIONS(3818),
    [anon_sym_while] = ACTIONS(3818),
    [anon_sym_do] = ACTIONS(3818),
    [anon_sym_for] = ACTIONS(3818),
    [anon_sym_return] = ACTIONS(3818),
    [anon_sym_break] = ACTIONS(3818),
    [anon_sym_continue] = ACTIONS(3818),
    [anon_sym_goto] = ACTIONS(3818),
    [anon_sym___try] = ACTIONS(3818),
    [anon_sym___leave] = ACTIONS(3818),
    [anon_sym_not] = ACTIONS(3818),
    [anon_sym_compl] = ACTIONS(3818),
    [anon_sym_DASH_DASH] = ACTIONS(3820),
    [anon_sym_PLUS_PLUS] = ACTIONS(3820),
    [anon_sym_sizeof] = ACTIONS(3818),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3818),
    [anon_sym__Generic] = ACTIONS(3818),
    [anon_sym_asm] = ACTIONS(3818),
    [anon_sym___asm__] = ACTIONS(3818),
    [anon_sym___asm] = ACTIONS(3818),
    [sym_number_literal] = ACTIONS(3820),
    [anon_sym_L_SQUOTE] = ACTIONS(3820),
    [anon_sym_u_SQUOTE] = ACTIONS(3820),
    [anon_sym_U_SQUOTE] = ACTIONS(3820),
    [anon_sym_u8_SQUOTE] = ACTIONS(3820),
    [anon_sym_SQUOTE] = ACTIONS(3820),
    [anon_sym_L_DQUOTE] = ACTIONS(3820),
    [anon_sym_u_DQUOTE] = ACTIONS(3820),
    [anon_sym_U_DQUOTE] = ACTIONS(3820),
    [anon_sym_u8_DQUOTE] = ACTIONS(3820),
    [anon_sym_DQUOTE] = ACTIONS(3820),
    [sym_true] = ACTIONS(3818),
    [sym_false] = ACTIONS(3818),
    [anon_sym_NULL] = ACTIONS(3818),
    [anon_sym_nullptr] = ACTIONS(3818),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3818),
    [anon_sym_decltype] = ACTIONS(3818),
    [anon_sym_explicit] = ACTIONS(3818),
    [anon_sym_typename] = ACTIONS(3818),
    [anon_sym_template] = ACTIONS(3818),
    [anon_sym_GT2] = ACTIONS(3820),
    [anon_sym_operator] = ACTIONS(3818),
    [anon_sym_try] = ACTIONS(3818),
    [anon_sym_delete] = ACTIONS(3818),
    [anon_sym_throw] = ACTIONS(3818),
    [anon_sym_co_return] = ACTIONS(3818),
    [anon_sym_co_yield] = ACTIONS(3818),
    [anon_sym_R_DQUOTE] = ACTIONS(3820),
    [anon_sym_LR_DQUOTE] = ACTIONS(3820),
    [anon_sym_uR_DQUOTE] = ACTIONS(3820),
    [anon_sym_UR_DQUOTE] = ACTIONS(3820),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3820),
    [anon_sym_co_await] = ACTIONS(3818),
    [anon_sym_new] = ACTIONS(3818),
    [anon_sym_requires] = ACTIONS(3818),
    [sym_this] = ACTIONS(3818),
  },
  [794] = {
    [sym_identifier] = ACTIONS(3822),
    [anon_sym_COMMA] = ACTIONS(3824),
    [anon_sym_RPAREN] = ACTIONS(3824),
    [anon_sym_LPAREN2] = ACTIONS(3824),
    [anon_sym_BANG] = ACTIONS(3824),
    [anon_sym_TILDE] = ACTIONS(3824),
    [anon_sym_DASH] = ACTIONS(3822),
    [anon_sym_PLUS] = ACTIONS(3822),
    [anon_sym_STAR] = ACTIONS(3824),
    [anon_sym_AMP_AMP] = ACTIONS(3824),
    [anon_sym_AMP] = ACTIONS(3822),
    [anon_sym_SEMI] = ACTIONS(3824),
    [anon_sym___extension__] = ACTIONS(3822),
    [anon_sym_virtual] = ACTIONS(3822),
    [anon_sym_extern] = ACTIONS(3822),
    [anon_sym___attribute__] = ACTIONS(3822),
    [anon_sym___attribute] = ACTIONS(3822),
    [anon_sym_COLON_COLON] = ACTIONS(3824),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3824),
    [anon_sym___declspec] = ACTIONS(3822),
    [anon_sym___based] = ACTIONS(3822),
    [anon_sym_LBRACE] = ACTIONS(3824),
    [anon_sym_signed] = ACTIONS(3822),
    [anon_sym_unsigned] = ACTIONS(3822),
    [anon_sym_long] = ACTIONS(3822),
    [anon_sym_short] = ACTIONS(3822),
    [anon_sym_LBRACK] = ACTIONS(3822),
    [anon_sym_static] = ACTIONS(3822),
    [anon_sym_RBRACK] = ACTIONS(3824),
    [anon_sym_EQ] = ACTIONS(3824),
    [anon_sym_register] = ACTIONS(3822),
    [anon_sym_inline] = ACTIONS(3822),
    [anon_sym___inline] = ACTIONS(3822),
    [anon_sym___inline__] = ACTIONS(3822),
    [anon_sym___forceinline] = ACTIONS(3822),
    [anon_sym_thread_local] = ACTIONS(3822),
    [anon_sym___thread] = ACTIONS(3822),
    [anon_sym_const] = ACTIONS(3822),
    [anon_sym_constexpr] = ACTIONS(3822),
    [anon_sym_volatile] = ACTIONS(3822),
    [anon_sym_restrict] = ACTIONS(3822),
    [anon_sym___restrict__] = ACTIONS(3822),
    [anon_sym__Atomic] = ACTIONS(3822),
    [anon_sym__Noreturn] = ACTIONS(3822),
    [anon_sym_noreturn] = ACTIONS(3822),
    [anon_sym__Nonnull] = ACTIONS(3822),
    [anon_sym_mutable] = ACTIONS(3822),
    [anon_sym_constinit] = ACTIONS(3822),
    [anon_sym_consteval] = ACTIONS(3822),
    [anon_sym_alignas] = ACTIONS(3822),
    [anon_sym__Alignas] = ACTIONS(3822),
    [sym_primitive_type] = ACTIONS(3822),
    [anon_sym_enum] = ACTIONS(3822),
    [anon_sym_class] = ACTIONS(3822),
    [anon_sym_struct] = ACTIONS(3822),
    [anon_sym_union] = ACTIONS(3822),
    [anon_sym_if] = ACTIONS(3822),
    [anon_sym_switch] = ACTIONS(3822),
    [anon_sym_case] = ACTIONS(3822),
    [anon_sym_default] = ACTIONS(3822),
    [anon_sym_while] = ACTIONS(3822),
    [anon_sym_do] = ACTIONS(3822),
    [anon_sym_for] = ACTIONS(3822),
    [anon_sym_return] = ACTIONS(3822),
    [anon_sym_break] = ACTIONS(3822),
    [anon_sym_continue] = ACTIONS(3822),
    [anon_sym_goto] = ACTIONS(3822),
    [anon_sym___try] = ACTIONS(3822),
    [anon_sym___leave] = ACTIONS(3822),
    [anon_sym_not] = ACTIONS(3822),
    [anon_sym_compl] = ACTIONS(3822),
    [anon_sym_DASH_DASH] = ACTIONS(3824),
    [anon_sym_PLUS_PLUS] = ACTIONS(3824),
    [anon_sym_sizeof] = ACTIONS(3822),
    [anon_sym___alignof__] = ACTIONS(3822),
    [anon_sym___alignof] = ACTIONS(3822),
    [anon_sym__alignof] = ACTIONS(3822),
    [anon_sym_alignof] = ACTIONS(3822),
    [anon_sym__Alignof] = ACTIONS(3822),
    [anon_sym_offsetof] = ACTIONS(3822),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3822),
    [anon_sym___asm__] = ACTIONS(3822),
    [anon_sym___asm] = ACTIONS(3822),
    [sym_number_literal] = ACTIONS(3824),
    [anon_sym_L_SQUOTE] = ACTIONS(3824),
    [anon_sym_u_SQUOTE] = ACTIONS(3824),
    [anon_sym_U_SQUOTE] = ACTIONS(3824),
    [anon_sym_u8_SQUOTE] = ACTIONS(3824),
    [anon_sym_SQUOTE] = ACTIONS(3824),
    [anon_sym_L_DQUOTE] = ACTIONS(3824),
    [anon_sym_u_DQUOTE] = ACTIONS(3824),
    [anon_sym_U_DQUOTE] = ACTIONS(3824),
    [anon_sym_u8_DQUOTE] = ACTIONS(3824),
    [anon_sym_DQUOTE] = ACTIONS(3824),
    [sym_true] = ACTIONS(3822),
    [sym_false] = ACTIONS(3822),
    [anon_sym_NULL] = ACTIONS(3822),
    [anon_sym_nullptr] = ACTIONS(3822),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3822),
    [anon_sym_decltype] = ACTIONS(3822),
    [anon_sym_explicit] = ACTIONS(3822),
    [anon_sym_typename] = ACTIONS(3822),
    [anon_sym_template] = ACTIONS(3822),
    [anon_sym_GT2] = ACTIONS(3824),
    [anon_sym_operator] = ACTIONS(3822),
    [anon_sym_try] = ACTIONS(3822),
    [anon_sym_delete] = ACTIONS(3822),
    [anon_sym_throw] = ACTIONS(3822),
    [anon_sym_co_return] = ACTIONS(3822),
    [anon_sym_co_yield] = ACTIONS(3822),
    [anon_sym_R_DQUOTE] = ACTIONS(3824),
    [anon_sym_LR_DQUOTE] = ACTIONS(3824),
    [anon_sym_uR_DQUOTE] = ACTIONS(3824),
    [anon_sym_UR_DQUOTE] = ACTIONS(3824),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3824),
    [anon_sym_co_await] = ACTIONS(3822),
    [anon_sym_new] = ACTIONS(3822),
    [anon_sym_requires] = ACTIONS(3822),
    [sym_this] = ACTIONS(3822),
  },
  [795] = {
    [sym_function_definition] = STATE(596),
    [sym_declaration] = STATE(596),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4693),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1902),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6130),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2712),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__empty_declaration] = STATE(596),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1748),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(596),
    [sym_operator_cast] = STATE(6672),
    [sym__constructor_specifiers] = STATE(1748),
    [sym_operator_cast_definition] = STATE(596),
    [sym_operator_cast_declaration] = STATE(596),
    [sym_constructor_or_destructor_definition] = STATE(596),
    [sym_constructor_or_destructor_declaration] = STATE(596),
    [sym_friend_declaration] = STATE(596),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_alias_declaration] = STATE(596),
    [sym_concept_definition] = STATE(596),
    [sym_requires_clause] = STATE(803),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5360),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6672),
    [sym_operator_name] = STATE(5896),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1748),
    [sym_identifier] = ACTIONS(3826),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3828),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(3830),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(3832),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3834),
    [anon_sym_using] = ACTIONS(3836),
    [anon_sym_concept] = ACTIONS(686),
    [anon_sym_requires] = ACTIONS(3838),
  },
  [796] = {
    [sym_function_definition] = STATE(648),
    [sym_declaration] = STATE(648),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6188),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__empty_declaration] = STATE(648),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1732),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(648),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1732),
    [sym_operator_cast_definition] = STATE(648),
    [sym_operator_cast_declaration] = STATE(648),
    [sym_constructor_or_destructor_definition] = STATE(648),
    [sym_constructor_or_destructor_declaration] = STATE(648),
    [sym_friend_declaration] = STATE(648),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_alias_declaration] = STATE(648),
    [sym_concept_definition] = STATE(648),
    [sym_requires_clause] = STATE(802),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5360),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1732),
    [sym_identifier] = ACTIONS(3826),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3828),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(3840),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(3842),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3844),
    [anon_sym_using] = ACTIONS(3846),
    [anon_sym_concept] = ACTIONS(235),
    [anon_sym_requires] = ACTIONS(3838),
  },
  [797] = {
    [sym_function_definition] = STATE(1689),
    [sym_declaration] = STATE(1689),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4698),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1868),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6181),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2701),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__empty_declaration] = STATE(1689),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1743),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(1689),
    [sym_operator_cast] = STATE(6702),
    [sym__constructor_specifiers] = STATE(1743),
    [sym_operator_cast_definition] = STATE(1689),
    [sym_operator_cast_declaration] = STATE(1689),
    [sym_constructor_or_destructor_definition] = STATE(1689),
    [sym_constructor_or_destructor_declaration] = STATE(1689),
    [sym_friend_declaration] = STATE(1689),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_alias_declaration] = STATE(1689),
    [sym_concept_definition] = STATE(1689),
    [sym_requires_clause] = STATE(809),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5360),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6702),
    [sym_operator_name] = STATE(5896),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1743),
    [sym_identifier] = ACTIONS(3826),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3828),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(3210),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(3224),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3226),
    [anon_sym_using] = ACTIONS(3848),
    [anon_sym_concept] = ACTIONS(3850),
    [anon_sym_requires] = ACTIONS(3838),
  },
  [798] = {
    [sym_function_definition] = STATE(720),
    [sym_declaration] = STATE(720),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4592),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1881),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6165),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2704),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__empty_declaration] = STATE(720),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1783),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(720),
    [sym_operator_cast] = STATE(6688),
    [sym__constructor_specifiers] = STATE(1783),
    [sym_operator_cast_definition] = STATE(720),
    [sym_operator_cast_declaration] = STATE(720),
    [sym_constructor_or_destructor_definition] = STATE(720),
    [sym_constructor_or_destructor_declaration] = STATE(720),
    [sym_friend_declaration] = STATE(720),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_alias_declaration] = STATE(720),
    [sym_concept_definition] = STATE(720),
    [sym_requires_clause] = STATE(823),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5360),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6688),
    [sym_operator_name] = STATE(5896),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1783),
    [sym_identifier] = ACTIONS(3826),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3828),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(3852),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(3854),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3856),
    [anon_sym_using] = ACTIONS(3858),
    [anon_sym_concept] = ACTIONS(147),
    [anon_sym_requires] = ACTIONS(3838),
  },
  [799] = {
    [sym_function_definition] = STATE(2113),
    [sym_declaration] = STATE(2113),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4700),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1891),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6172),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2714),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__empty_declaration] = STATE(2113),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1754),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(2113),
    [sym_operator_cast] = STATE(6687),
    [sym__constructor_specifiers] = STATE(1754),
    [sym_operator_cast_definition] = STATE(2113),
    [sym_operator_cast_declaration] = STATE(2113),
    [sym_constructor_or_destructor_definition] = STATE(2113),
    [sym_constructor_or_destructor_declaration] = STATE(2113),
    [sym_friend_declaration] = STATE(2113),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_alias_declaration] = STATE(2113),
    [sym_concept_definition] = STATE(2113),
    [sym_requires_clause] = STATE(814),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5360),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6687),
    [sym_operator_name] = STATE(5896),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1754),
    [sym_identifier] = ACTIONS(3826),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3828),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(3560),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(3562),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3564),
    [anon_sym_using] = ACTIONS(3860),
    [anon_sym_concept] = ACTIONS(3862),
    [anon_sym_requires] = ACTIONS(3838),
  },
  [800] = {
    [sym_function_definition] = STATE(360),
    [sym_declaration] = STATE(360),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4677),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1899),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6149),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2675),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__empty_declaration] = STATE(360),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1739),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(360),
    [sym_operator_cast] = STATE(6707),
    [sym__constructor_specifiers] = STATE(1739),
    [sym_operator_cast_definition] = STATE(360),
    [sym_operator_cast_declaration] = STATE(360),
    [sym_constructor_or_destructor_definition] = STATE(360),
    [sym_constructor_or_destructor_declaration] = STATE(360),
    [sym_friend_declaration] = STATE(360),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_alias_declaration] = STATE(360),
    [sym_concept_definition] = STATE(360),
    [sym_requires_clause] = STATE(824),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5360),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6707),
    [sym_operator_name] = STATE(5896),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1739),
    [sym_identifier] = ACTIONS(3826),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3828),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(3864),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(3866),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3868),
    [anon_sym_using] = ACTIONS(3870),
    [anon_sym_concept] = ACTIONS(331),
    [anon_sym_requires] = ACTIONS(3838),
  },
  [801] = {
    [sym_function_definition] = STATE(1963),
    [sym_declaration] = STATE(1963),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4694),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1877),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6137),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2711),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__empty_declaration] = STATE(1963),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1688),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(1963),
    [sym_operator_cast] = STATE(6717),
    [sym__constructor_specifiers] = STATE(1688),
    [sym_operator_cast_definition] = STATE(1963),
    [sym_operator_cast_declaration] = STATE(1963),
    [sym_constructor_or_destructor_definition] = STATE(1963),
    [sym_constructor_or_destructor_declaration] = STATE(1963),
    [sym_friend_declaration] = STATE(1963),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_alias_declaration] = STATE(1963),
    [sym_concept_definition] = STATE(1963),
    [sym_requires_clause] = STATE(816),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5360),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6717),
    [sym_operator_name] = STATE(5896),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1688),
    [sym_identifier] = ACTIONS(3826),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3828),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(3534),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(3536),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3538),
    [anon_sym_using] = ACTIONS(3872),
    [anon_sym_concept] = ACTIONS(3874),
    [anon_sym_requires] = ACTIONS(3838),
  },
  [802] = {
    [sym_function_definition] = STATE(636),
    [sym_declaration] = STATE(636),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1865),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6188),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2708),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__empty_declaration] = STATE(636),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1732),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(636),
    [sym_operator_cast] = STATE(6708),
    [sym__constructor_specifiers] = STATE(1732),
    [sym_operator_cast_definition] = STATE(636),
    [sym_operator_cast_declaration] = STATE(636),
    [sym_constructor_or_destructor_definition] = STATE(636),
    [sym_constructor_or_destructor_declaration] = STATE(636),
    [sym_friend_declaration] = STATE(636),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_alias_declaration] = STATE(636),
    [sym_concept_definition] = STATE(636),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5360),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6708),
    [sym_operator_name] = STATE(5896),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1732),
    [sym_identifier] = ACTIONS(3826),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3828),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(3840),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(3842),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3844),
    [anon_sym_using] = ACTIONS(3846),
    [anon_sym_concept] = ACTIONS(235),
  },
  [803] = {
    [sym_function_definition] = STATE(620),
    [sym_declaration] = STATE(620),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4693),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1902),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6130),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2712),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__empty_declaration] = STATE(620),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1748),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(620),
    [sym_operator_cast] = STATE(6672),
    [sym__constructor_specifiers] = STATE(1748),
    [sym_operator_cast_definition] = STATE(620),
    [sym_operator_cast_declaration] = STATE(620),
    [sym_constructor_or_destructor_definition] = STATE(620),
    [sym_constructor_or_destructor_declaration] = STATE(620),
    [sym_friend_declaration] = STATE(620),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_alias_declaration] = STATE(620),
    [sym_concept_definition] = STATE(620),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5360),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6672),
    [sym_operator_name] = STATE(5896),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1748),
    [sym_identifier] = ACTIONS(3826),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3828),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(3830),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(3832),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3834),
    [anon_sym_using] = ACTIONS(3836),
    [anon_sym_concept] = ACTIONS(686),
  },
  [804] = {
    [sym_type_qualifier] = STATE(1662),
    [sym_alignas_qualifier] = STATE(1832),
    [sym_expression] = STATE(4565),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [aux_sym_array_declarator_repeat1] = STATE(1662),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(3876),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3878),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_static] = ACTIONS(3880),
    [anon_sym_RBRACK] = ACTIONS(3882),
    [anon_sym_const] = ACTIONS(3884),
    [anon_sym_constexpr] = ACTIONS(3884),
    [anon_sym_volatile] = ACTIONS(3884),
    [anon_sym_restrict] = ACTIONS(3884),
    [anon_sym___restrict__] = ACTIONS(3884),
    [anon_sym__Atomic] = ACTIONS(3884),
    [anon_sym__Noreturn] = ACTIONS(3884),
    [anon_sym_noreturn] = ACTIONS(3884),
    [anon_sym__Nonnull] = ACTIONS(3884),
    [anon_sym_mutable] = ACTIONS(3884),
    [anon_sym_constinit] = ACTIONS(3884),
    [anon_sym_consteval] = ACTIONS(3884),
    [anon_sym_alignas] = ACTIONS(3886),
    [anon_sym__Alignas] = ACTIONS(3886),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [805] = {
    [sym_type_qualifier] = STATE(812),
    [sym_alignas_qualifier] = STATE(1832),
    [sym_expression] = STATE(4557),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [aux_sym_array_declarator_repeat1] = STATE(812),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(3888),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3878),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_static] = ACTIONS(3890),
    [anon_sym_RBRACK] = ACTIONS(3892),
    [anon_sym_const] = ACTIONS(3884),
    [anon_sym_constexpr] = ACTIONS(3884),
    [anon_sym_volatile] = ACTIONS(3884),
    [anon_sym_restrict] = ACTIONS(3884),
    [anon_sym___restrict__] = ACTIONS(3884),
    [anon_sym__Atomic] = ACTIONS(3884),
    [anon_sym__Noreturn] = ACTIONS(3884),
    [anon_sym_noreturn] = ACTIONS(3884),
    [anon_sym__Nonnull] = ACTIONS(3884),
    [anon_sym_mutable] = ACTIONS(3884),
    [anon_sym_constinit] = ACTIONS(3884),
    [anon_sym_consteval] = ACTIONS(3884),
    [anon_sym_alignas] = ACTIONS(3886),
    [anon_sym__Alignas] = ACTIONS(3886),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [806] = {
    [sym_type_qualifier] = STATE(1662),
    [sym_alignas_qualifier] = STATE(1832),
    [sym_expression] = STATE(4702),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [aux_sym_array_declarator_repeat1] = STATE(1662),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(3894),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3878),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_static] = ACTIONS(3880),
    [anon_sym_RBRACK] = ACTIONS(3896),
    [anon_sym_const] = ACTIONS(3884),
    [anon_sym_constexpr] = ACTIONS(3884),
    [anon_sym_volatile] = ACTIONS(3884),
    [anon_sym_restrict] = ACTIONS(3884),
    [anon_sym___restrict__] = ACTIONS(3884),
    [anon_sym__Atomic] = ACTIONS(3884),
    [anon_sym__Noreturn] = ACTIONS(3884),
    [anon_sym_noreturn] = ACTIONS(3884),
    [anon_sym__Nonnull] = ACTIONS(3884),
    [anon_sym_mutable] = ACTIONS(3884),
    [anon_sym_constinit] = ACTIONS(3884),
    [anon_sym_consteval] = ACTIONS(3884),
    [anon_sym_alignas] = ACTIONS(3886),
    [anon_sym__Alignas] = ACTIONS(3886),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [807] = {
    [sym_type_qualifier] = STATE(815),
    [sym_alignas_qualifier] = STATE(1832),
    [sym_expression] = STATE(4654),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [aux_sym_array_declarator_repeat1] = STATE(815),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(3898),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3878),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_static] = ACTIONS(3900),
    [anon_sym_RBRACK] = ACTIONS(3902),
    [anon_sym_const] = ACTIONS(3884),
    [anon_sym_constexpr] = ACTIONS(3884),
    [anon_sym_volatile] = ACTIONS(3884),
    [anon_sym_restrict] = ACTIONS(3884),
    [anon_sym___restrict__] = ACTIONS(3884),
    [anon_sym__Atomic] = ACTIONS(3884),
    [anon_sym__Noreturn] = ACTIONS(3884),
    [anon_sym_noreturn] = ACTIONS(3884),
    [anon_sym__Nonnull] = ACTIONS(3884),
    [anon_sym_mutable] = ACTIONS(3884),
    [anon_sym_constinit] = ACTIONS(3884),
    [anon_sym_consteval] = ACTIONS(3884),
    [anon_sym_alignas] = ACTIONS(3886),
    [anon_sym__Alignas] = ACTIONS(3886),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [808] = {
    [sym_type_qualifier] = STATE(1662),
    [sym_alignas_qualifier] = STATE(1832),
    [sym_expression] = STATE(4638),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [aux_sym_array_declarator_repeat1] = STATE(1662),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(3904),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3878),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_static] = ACTIONS(3880),
    [anon_sym_RBRACK] = ACTIONS(3906),
    [anon_sym_const] = ACTIONS(3884),
    [anon_sym_constexpr] = ACTIONS(3884),
    [anon_sym_volatile] = ACTIONS(3884),
    [anon_sym_restrict] = ACTIONS(3884),
    [anon_sym___restrict__] = ACTIONS(3884),
    [anon_sym__Atomic] = ACTIONS(3884),
    [anon_sym__Noreturn] = ACTIONS(3884),
    [anon_sym_noreturn] = ACTIONS(3884),
    [anon_sym__Nonnull] = ACTIONS(3884),
    [anon_sym_mutable] = ACTIONS(3884),
    [anon_sym_constinit] = ACTIONS(3884),
    [anon_sym_consteval] = ACTIONS(3884),
    [anon_sym_alignas] = ACTIONS(3886),
    [anon_sym__Alignas] = ACTIONS(3886),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [809] = {
    [sym_function_definition] = STATE(1705),
    [sym_declaration] = STATE(1705),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4698),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1868),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6181),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2701),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__empty_declaration] = STATE(1705),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1743),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(1705),
    [sym_operator_cast] = STATE(6702),
    [sym__constructor_specifiers] = STATE(1743),
    [sym_operator_cast_definition] = STATE(1705),
    [sym_operator_cast_declaration] = STATE(1705),
    [sym_constructor_or_destructor_definition] = STATE(1705),
    [sym_constructor_or_destructor_declaration] = STATE(1705),
    [sym_friend_declaration] = STATE(1705),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_alias_declaration] = STATE(1705),
    [sym_concept_definition] = STATE(1705),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5360),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6702),
    [sym_operator_name] = STATE(5896),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1743),
    [sym_identifier] = ACTIONS(3826),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3828),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(3210),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(3224),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3226),
    [anon_sym_using] = ACTIONS(3848),
    [anon_sym_concept] = ACTIONS(3850),
  },
  [810] = {
    [sym_type_qualifier] = STATE(1662),
    [sym_alignas_qualifier] = STATE(1832),
    [sym_expression] = STATE(4604),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [aux_sym_array_declarator_repeat1] = STATE(1662),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(3908),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3878),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_static] = ACTIONS(3880),
    [anon_sym_RBRACK] = ACTIONS(3910),
    [anon_sym_const] = ACTIONS(3884),
    [anon_sym_constexpr] = ACTIONS(3884),
    [anon_sym_volatile] = ACTIONS(3884),
    [anon_sym_restrict] = ACTIONS(3884),
    [anon_sym___restrict__] = ACTIONS(3884),
    [anon_sym__Atomic] = ACTIONS(3884),
    [anon_sym__Noreturn] = ACTIONS(3884),
    [anon_sym_noreturn] = ACTIONS(3884),
    [anon_sym__Nonnull] = ACTIONS(3884),
    [anon_sym_mutable] = ACTIONS(3884),
    [anon_sym_constinit] = ACTIONS(3884),
    [anon_sym_consteval] = ACTIONS(3884),
    [anon_sym_alignas] = ACTIONS(3886),
    [anon_sym__Alignas] = ACTIONS(3886),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [811] = {
    [sym_type_qualifier] = STATE(808),
    [sym_alignas_qualifier] = STATE(1832),
    [sym_expression] = STATE(4647),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [aux_sym_array_declarator_repeat1] = STATE(808),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(3912),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3878),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_static] = ACTIONS(3914),
    [anon_sym_RBRACK] = ACTIONS(3916),
    [anon_sym_const] = ACTIONS(3884),
    [anon_sym_constexpr] = ACTIONS(3884),
    [anon_sym_volatile] = ACTIONS(3884),
    [anon_sym_restrict] = ACTIONS(3884),
    [anon_sym___restrict__] = ACTIONS(3884),
    [anon_sym__Atomic] = ACTIONS(3884),
    [anon_sym__Noreturn] = ACTIONS(3884),
    [anon_sym_noreturn] = ACTIONS(3884),
    [anon_sym__Nonnull] = ACTIONS(3884),
    [anon_sym_mutable] = ACTIONS(3884),
    [anon_sym_constinit] = ACTIONS(3884),
    [anon_sym_consteval] = ACTIONS(3884),
    [anon_sym_alignas] = ACTIONS(3886),
    [anon_sym__Alignas] = ACTIONS(3886),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [812] = {
    [sym_type_qualifier] = STATE(1662),
    [sym_alignas_qualifier] = STATE(1832),
    [sym_expression] = STATE(4639),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [aux_sym_array_declarator_repeat1] = STATE(1662),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(3918),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3878),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_static] = ACTIONS(3880),
    [anon_sym_RBRACK] = ACTIONS(3920),
    [anon_sym_const] = ACTIONS(3884),
    [anon_sym_constexpr] = ACTIONS(3884),
    [anon_sym_volatile] = ACTIONS(3884),
    [anon_sym_restrict] = ACTIONS(3884),
    [anon_sym___restrict__] = ACTIONS(3884),
    [anon_sym__Atomic] = ACTIONS(3884),
    [anon_sym__Noreturn] = ACTIONS(3884),
    [anon_sym_noreturn] = ACTIONS(3884),
    [anon_sym__Nonnull] = ACTIONS(3884),
    [anon_sym_mutable] = ACTIONS(3884),
    [anon_sym_constinit] = ACTIONS(3884),
    [anon_sym_consteval] = ACTIONS(3884),
    [anon_sym_alignas] = ACTIONS(3886),
    [anon_sym__Alignas] = ACTIONS(3886),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [813] = {
    [sym_type_qualifier] = STATE(822),
    [sym_alignas_qualifier] = STATE(1832),
    [sym_expression] = STATE(4641),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [aux_sym_array_declarator_repeat1] = STATE(822),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(3922),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3878),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_static] = ACTIONS(3924),
    [anon_sym_RBRACK] = ACTIONS(3926),
    [anon_sym_const] = ACTIONS(3884),
    [anon_sym_constexpr] = ACTIONS(3884),
    [anon_sym_volatile] = ACTIONS(3884),
    [anon_sym_restrict] = ACTIONS(3884),
    [anon_sym___restrict__] = ACTIONS(3884),
    [anon_sym__Atomic] = ACTIONS(3884),
    [anon_sym__Noreturn] = ACTIONS(3884),
    [anon_sym_noreturn] = ACTIONS(3884),
    [anon_sym__Nonnull] = ACTIONS(3884),
    [anon_sym_mutable] = ACTIONS(3884),
    [anon_sym_constinit] = ACTIONS(3884),
    [anon_sym_consteval] = ACTIONS(3884),
    [anon_sym_alignas] = ACTIONS(3886),
    [anon_sym__Alignas] = ACTIONS(3886),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [814] = {
    [sym_function_definition] = STATE(1916),
    [sym_declaration] = STATE(1916),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4700),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1891),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6172),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2714),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__empty_declaration] = STATE(1916),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1754),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(1916),
    [sym_operator_cast] = STATE(6687),
    [sym__constructor_specifiers] = STATE(1754),
    [sym_operator_cast_definition] = STATE(1916),
    [sym_operator_cast_declaration] = STATE(1916),
    [sym_constructor_or_destructor_definition] = STATE(1916),
    [sym_constructor_or_destructor_declaration] = STATE(1916),
    [sym_friend_declaration] = STATE(1916),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_alias_declaration] = STATE(1916),
    [sym_concept_definition] = STATE(1916),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5360),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6687),
    [sym_operator_name] = STATE(5896),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1754),
    [sym_identifier] = ACTIONS(3826),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3828),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(3560),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(3562),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3564),
    [anon_sym_using] = ACTIONS(3860),
    [anon_sym_concept] = ACTIONS(3862),
  },
  [815] = {
    [sym_type_qualifier] = STATE(1662),
    [sym_alignas_qualifier] = STATE(1832),
    [sym_expression] = STATE(4679),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [aux_sym_array_declarator_repeat1] = STATE(1662),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(3928),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3878),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_static] = ACTIONS(3880),
    [anon_sym_RBRACK] = ACTIONS(3930),
    [anon_sym_const] = ACTIONS(3884),
    [anon_sym_constexpr] = ACTIONS(3884),
    [anon_sym_volatile] = ACTIONS(3884),
    [anon_sym_restrict] = ACTIONS(3884),
    [anon_sym___restrict__] = ACTIONS(3884),
    [anon_sym__Atomic] = ACTIONS(3884),
    [anon_sym__Noreturn] = ACTIONS(3884),
    [anon_sym_noreturn] = ACTIONS(3884),
    [anon_sym__Nonnull] = ACTIONS(3884),
    [anon_sym_mutable] = ACTIONS(3884),
    [anon_sym_constinit] = ACTIONS(3884),
    [anon_sym_consteval] = ACTIONS(3884),
    [anon_sym_alignas] = ACTIONS(3886),
    [anon_sym__Alignas] = ACTIONS(3886),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [816] = {
    [sym_function_definition] = STATE(1983),
    [sym_declaration] = STATE(1983),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4694),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1877),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6137),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2711),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__empty_declaration] = STATE(1983),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1688),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(1983),
    [sym_operator_cast] = STATE(6717),
    [sym__constructor_specifiers] = STATE(1688),
    [sym_operator_cast_definition] = STATE(1983),
    [sym_operator_cast_declaration] = STATE(1983),
    [sym_constructor_or_destructor_definition] = STATE(1983),
    [sym_constructor_or_destructor_declaration] = STATE(1983),
    [sym_friend_declaration] = STATE(1983),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_alias_declaration] = STATE(1983),
    [sym_concept_definition] = STATE(1983),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5360),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6717),
    [sym_operator_name] = STATE(5896),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1688),
    [sym_identifier] = ACTIONS(3826),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3828),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(3534),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(3536),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3538),
    [anon_sym_using] = ACTIONS(3872),
    [anon_sym_concept] = ACTIONS(3874),
  },
  [817] = {
    [sym_type_qualifier] = STATE(810),
    [sym_alignas_qualifier] = STATE(1832),
    [sym_expression] = STATE(4589),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [aux_sym_array_declarator_repeat1] = STATE(810),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(3932),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3878),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_static] = ACTIONS(3934),
    [anon_sym_RBRACK] = ACTIONS(3936),
    [anon_sym_const] = ACTIONS(3884),
    [anon_sym_constexpr] = ACTIONS(3884),
    [anon_sym_volatile] = ACTIONS(3884),
    [anon_sym_restrict] = ACTIONS(3884),
    [anon_sym___restrict__] = ACTIONS(3884),
    [anon_sym__Atomic] = ACTIONS(3884),
    [anon_sym__Noreturn] = ACTIONS(3884),
    [anon_sym_noreturn] = ACTIONS(3884),
    [anon_sym__Nonnull] = ACTIONS(3884),
    [anon_sym_mutable] = ACTIONS(3884),
    [anon_sym_constinit] = ACTIONS(3884),
    [anon_sym_consteval] = ACTIONS(3884),
    [anon_sym_alignas] = ACTIONS(3886),
    [anon_sym__Alignas] = ACTIONS(3886),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [818] = {
    [sym_type_qualifier] = STATE(1662),
    [sym_alignas_qualifier] = STATE(1832),
    [sym_expression] = STATE(4645),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [aux_sym_array_declarator_repeat1] = STATE(1662),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(3938),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3878),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_static] = ACTIONS(3880),
    [anon_sym_RBRACK] = ACTIONS(3940),
    [anon_sym_const] = ACTIONS(3884),
    [anon_sym_constexpr] = ACTIONS(3884),
    [anon_sym_volatile] = ACTIONS(3884),
    [anon_sym_restrict] = ACTIONS(3884),
    [anon_sym___restrict__] = ACTIONS(3884),
    [anon_sym__Atomic] = ACTIONS(3884),
    [anon_sym__Noreturn] = ACTIONS(3884),
    [anon_sym_noreturn] = ACTIONS(3884),
    [anon_sym__Nonnull] = ACTIONS(3884),
    [anon_sym_mutable] = ACTIONS(3884),
    [anon_sym_constinit] = ACTIONS(3884),
    [anon_sym_consteval] = ACTIONS(3884),
    [anon_sym_alignas] = ACTIONS(3886),
    [anon_sym__Alignas] = ACTIONS(3886),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [819] = {
    [sym_type_qualifier] = STATE(829),
    [sym_alignas_qualifier] = STATE(1832),
    [sym_expression] = STATE(4685),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [aux_sym_array_declarator_repeat1] = STATE(829),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(3942),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3878),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_static] = ACTIONS(3944),
    [anon_sym_RBRACK] = ACTIONS(3946),
    [anon_sym_const] = ACTIONS(3884),
    [anon_sym_constexpr] = ACTIONS(3884),
    [anon_sym_volatile] = ACTIONS(3884),
    [anon_sym_restrict] = ACTIONS(3884),
    [anon_sym___restrict__] = ACTIONS(3884),
    [anon_sym__Atomic] = ACTIONS(3884),
    [anon_sym__Noreturn] = ACTIONS(3884),
    [anon_sym_noreturn] = ACTIONS(3884),
    [anon_sym__Nonnull] = ACTIONS(3884),
    [anon_sym_mutable] = ACTIONS(3884),
    [anon_sym_constinit] = ACTIONS(3884),
    [anon_sym_consteval] = ACTIONS(3884),
    [anon_sym_alignas] = ACTIONS(3886),
    [anon_sym__Alignas] = ACTIONS(3886),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [820] = {
    [sym_type_qualifier] = STATE(818),
    [sym_alignas_qualifier] = STATE(1832),
    [sym_expression] = STATE(4649),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [aux_sym_array_declarator_repeat1] = STATE(818),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(3948),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3878),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_static] = ACTIONS(3950),
    [anon_sym_RBRACK] = ACTIONS(3952),
    [anon_sym_const] = ACTIONS(3884),
    [anon_sym_constexpr] = ACTIONS(3884),
    [anon_sym_volatile] = ACTIONS(3884),
    [anon_sym_restrict] = ACTIONS(3884),
    [anon_sym___restrict__] = ACTIONS(3884),
    [anon_sym__Atomic] = ACTIONS(3884),
    [anon_sym__Noreturn] = ACTIONS(3884),
    [anon_sym_noreturn] = ACTIONS(3884),
    [anon_sym__Nonnull] = ACTIONS(3884),
    [anon_sym_mutable] = ACTIONS(3884),
    [anon_sym_constinit] = ACTIONS(3884),
    [anon_sym_consteval] = ACTIONS(3884),
    [anon_sym_alignas] = ACTIONS(3886),
    [anon_sym__Alignas] = ACTIONS(3886),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [821] = {
    [sym_type_qualifier] = STATE(804),
    [sym_alignas_qualifier] = STATE(1832),
    [sym_expression] = STATE(4564),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [aux_sym_array_declarator_repeat1] = STATE(804),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(3954),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3878),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_static] = ACTIONS(3956),
    [anon_sym_RBRACK] = ACTIONS(3958),
    [anon_sym_const] = ACTIONS(3884),
    [anon_sym_constexpr] = ACTIONS(3884),
    [anon_sym_volatile] = ACTIONS(3884),
    [anon_sym_restrict] = ACTIONS(3884),
    [anon_sym___restrict__] = ACTIONS(3884),
    [anon_sym__Atomic] = ACTIONS(3884),
    [anon_sym__Noreturn] = ACTIONS(3884),
    [anon_sym_noreturn] = ACTIONS(3884),
    [anon_sym__Nonnull] = ACTIONS(3884),
    [anon_sym_mutable] = ACTIONS(3884),
    [anon_sym_constinit] = ACTIONS(3884),
    [anon_sym_consteval] = ACTIONS(3884),
    [anon_sym_alignas] = ACTIONS(3886),
    [anon_sym__Alignas] = ACTIONS(3886),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [822] = {
    [sym_type_qualifier] = STATE(1662),
    [sym_alignas_qualifier] = STATE(1832),
    [sym_expression] = STATE(4725),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [aux_sym_array_declarator_repeat1] = STATE(1662),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(3960),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3878),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_static] = ACTIONS(3880),
    [anon_sym_RBRACK] = ACTIONS(3962),
    [anon_sym_const] = ACTIONS(3884),
    [anon_sym_constexpr] = ACTIONS(3884),
    [anon_sym_volatile] = ACTIONS(3884),
    [anon_sym_restrict] = ACTIONS(3884),
    [anon_sym___restrict__] = ACTIONS(3884),
    [anon_sym__Atomic] = ACTIONS(3884),
    [anon_sym__Noreturn] = ACTIONS(3884),
    [anon_sym_noreturn] = ACTIONS(3884),
    [anon_sym__Nonnull] = ACTIONS(3884),
    [anon_sym_mutable] = ACTIONS(3884),
    [anon_sym_constinit] = ACTIONS(3884),
    [anon_sym_consteval] = ACTIONS(3884),
    [anon_sym_alignas] = ACTIONS(3886),
    [anon_sym__Alignas] = ACTIONS(3886),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [823] = {
    [sym_function_definition] = STATE(748),
    [sym_declaration] = STATE(748),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4592),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1881),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6165),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2704),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__empty_declaration] = STATE(748),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1783),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(748),
    [sym_operator_cast] = STATE(6688),
    [sym__constructor_specifiers] = STATE(1783),
    [sym_operator_cast_definition] = STATE(748),
    [sym_operator_cast_declaration] = STATE(748),
    [sym_constructor_or_destructor_definition] = STATE(748),
    [sym_constructor_or_destructor_declaration] = STATE(748),
    [sym_friend_declaration] = STATE(748),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_alias_declaration] = STATE(748),
    [sym_concept_definition] = STATE(748),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5360),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6688),
    [sym_operator_name] = STATE(5896),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1783),
    [sym_identifier] = ACTIONS(3826),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3828),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(3852),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(3854),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3856),
    [anon_sym_using] = ACTIONS(3858),
    [anon_sym_concept] = ACTIONS(147),
  },
  [824] = {
    [sym_function_definition] = STATE(318),
    [sym_declaration] = STATE(318),
    [sym__declaration_modifiers] = STATE(3077),
    [sym__declaration_specifiers] = STATE(4677),
    [sym_attribute_specifier] = STATE(3077),
    [sym_attribute_declaration] = STATE(3077),
    [sym_ms_declspec_modifier] = STATE(3077),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(1899),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6149),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3077),
    [sym_type_qualifier] = STATE(3077),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2675),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym__empty_declaration] = STATE(318),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_explicit_function_specifier] = STATE(1739),
    [sym_dependent_type] = STATE(2383),
    [sym_template_declaration] = STATE(318),
    [sym_operator_cast] = STATE(6707),
    [sym__constructor_specifiers] = STATE(1739),
    [sym_operator_cast_definition] = STATE(318),
    [sym_operator_cast_declaration] = STATE(318),
    [sym_constructor_or_destructor_definition] = STATE(318),
    [sym_constructor_or_destructor_declaration] = STATE(318),
    [sym_friend_declaration] = STATE(318),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_alias_declaration] = STATE(318),
    [sym_concept_definition] = STATE(318),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5360),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_qualified_operator_cast_identifier] = STATE(6707),
    [sym_operator_name] = STATE(5896),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [aux_sym_operator_cast_definition_repeat1] = STATE(1739),
    [sym_identifier] = ACTIONS(3826),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(39),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3828),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(3864),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(3866),
    [anon_sym_operator] = ACTIONS(133),
    [anon_sym_friend] = ACTIONS(3868),
    [anon_sym_using] = ACTIONS(3870),
    [anon_sym_concept] = ACTIONS(331),
  },
  [825] = {
    [sym_type_qualifier] = STATE(826),
    [sym_alignas_qualifier] = STATE(1832),
    [sym_expression] = STATE(4546),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [aux_sym_array_declarator_repeat1] = STATE(826),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(3964),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3878),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_static] = ACTIONS(3966),
    [anon_sym_RBRACK] = ACTIONS(3968),
    [anon_sym_const] = ACTIONS(3884),
    [anon_sym_constexpr] = ACTIONS(3884),
    [anon_sym_volatile] = ACTIONS(3884),
    [anon_sym_restrict] = ACTIONS(3884),
    [anon_sym___restrict__] = ACTIONS(3884),
    [anon_sym__Atomic] = ACTIONS(3884),
    [anon_sym__Noreturn] = ACTIONS(3884),
    [anon_sym_noreturn] = ACTIONS(3884),
    [anon_sym__Nonnull] = ACTIONS(3884),
    [anon_sym_mutable] = ACTIONS(3884),
    [anon_sym_constinit] = ACTIONS(3884),
    [anon_sym_consteval] = ACTIONS(3884),
    [anon_sym_alignas] = ACTIONS(3886),
    [anon_sym__Alignas] = ACTIONS(3886),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [826] = {
    [sym_type_qualifier] = STATE(1662),
    [sym_alignas_qualifier] = STATE(1832),
    [sym_expression] = STATE(4547),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [aux_sym_array_declarator_repeat1] = STATE(1662),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(3970),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3878),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_static] = ACTIONS(3880),
    [anon_sym_RBRACK] = ACTIONS(3972),
    [anon_sym_const] = ACTIONS(3884),
    [anon_sym_constexpr] = ACTIONS(3884),
    [anon_sym_volatile] = ACTIONS(3884),
    [anon_sym_restrict] = ACTIONS(3884),
    [anon_sym___restrict__] = ACTIONS(3884),
    [anon_sym__Atomic] = ACTIONS(3884),
    [anon_sym__Noreturn] = ACTIONS(3884),
    [anon_sym_noreturn] = ACTIONS(3884),
    [anon_sym__Nonnull] = ACTIONS(3884),
    [anon_sym_mutable] = ACTIONS(3884),
    [anon_sym_constinit] = ACTIONS(3884),
    [anon_sym_consteval] = ACTIONS(3884),
    [anon_sym_alignas] = ACTIONS(3886),
    [anon_sym__Alignas] = ACTIONS(3886),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [827] = {
    [sym_type_qualifier] = STATE(812),
    [sym_alignas_qualifier] = STATE(1832),
    [sym_expression] = STATE(4557),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [aux_sym_array_declarator_repeat1] = STATE(812),
    [sym_identifier] = ACTIONS(3974),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(3888),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3878),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_static] = ACTIONS(3890),
    [anon_sym_RBRACK] = ACTIONS(3892),
    [anon_sym_const] = ACTIONS(3884),
    [anon_sym_constexpr] = ACTIONS(3884),
    [anon_sym_volatile] = ACTIONS(3884),
    [anon_sym_restrict] = ACTIONS(3884),
    [anon_sym___restrict__] = ACTIONS(3884),
    [anon_sym__Atomic] = ACTIONS(3884),
    [anon_sym__Noreturn] = ACTIONS(3884),
    [anon_sym_noreturn] = ACTIONS(3884),
    [anon_sym__Nonnull] = ACTIONS(3884),
    [anon_sym_mutable] = ACTIONS(3884),
    [anon_sym_constinit] = ACTIONS(3884),
    [anon_sym_consteval] = ACTIONS(3884),
    [anon_sym_alignas] = ACTIONS(3886),
    [anon_sym__Alignas] = ACTIONS(3886),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [828] = {
    [sym_type_qualifier] = STATE(806),
    [sym_alignas_qualifier] = STATE(1832),
    [sym_expression] = STATE(4690),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [aux_sym_array_declarator_repeat1] = STATE(806),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(3976),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3878),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_static] = ACTIONS(3978),
    [anon_sym_RBRACK] = ACTIONS(3980),
    [anon_sym_const] = ACTIONS(3884),
    [anon_sym_constexpr] = ACTIONS(3884),
    [anon_sym_volatile] = ACTIONS(3884),
    [anon_sym_restrict] = ACTIONS(3884),
    [anon_sym___restrict__] = ACTIONS(3884),
    [anon_sym__Atomic] = ACTIONS(3884),
    [anon_sym__Noreturn] = ACTIONS(3884),
    [anon_sym_noreturn] = ACTIONS(3884),
    [anon_sym__Nonnull] = ACTIONS(3884),
    [anon_sym_mutable] = ACTIONS(3884),
    [anon_sym_constinit] = ACTIONS(3884),
    [anon_sym_consteval] = ACTIONS(3884),
    [anon_sym_alignas] = ACTIONS(3886),
    [anon_sym__Alignas] = ACTIONS(3886),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [829] = {
    [sym_type_qualifier] = STATE(1662),
    [sym_alignas_qualifier] = STATE(1832),
    [sym_expression] = STATE(4701),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [aux_sym_array_declarator_repeat1] = STATE(1662),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(3982),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3878),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_static] = ACTIONS(3880),
    [anon_sym_RBRACK] = ACTIONS(3984),
    [anon_sym_const] = ACTIONS(3884),
    [anon_sym_constexpr] = ACTIONS(3884),
    [anon_sym_volatile] = ACTIONS(3884),
    [anon_sym_restrict] = ACTIONS(3884),
    [anon_sym___restrict__] = ACTIONS(3884),
    [anon_sym__Atomic] = ACTIONS(3884),
    [anon_sym__Noreturn] = ACTIONS(3884),
    [anon_sym_noreturn] = ACTIONS(3884),
    [anon_sym__Nonnull] = ACTIONS(3884),
    [anon_sym_mutable] = ACTIONS(3884),
    [anon_sym_constinit] = ACTIONS(3884),
    [anon_sym_consteval] = ACTIONS(3884),
    [anon_sym_alignas] = ACTIONS(3886),
    [anon_sym__Alignas] = ACTIONS(3886),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [830] = {
    [sym_identifier] = ACTIONS(3986),
    [anon_sym_LPAREN2] = ACTIONS(3989),
    [anon_sym_BANG] = ACTIONS(3992),
    [anon_sym_TILDE] = ACTIONS(3989),
    [anon_sym_DASH] = ACTIONS(3994),
    [anon_sym_PLUS] = ACTIONS(3994),
    [anon_sym_STAR] = ACTIONS(3989),
    [anon_sym_AMP_AMP] = ACTIONS(3996),
    [anon_sym_AMP] = ACTIONS(3986),
    [anon_sym_SEMI] = ACTIONS(3992),
    [anon_sym___extension__] = ACTIONS(3986),
    [anon_sym_virtual] = ACTIONS(3998),
    [anon_sym_extern] = ACTIONS(3998),
    [anon_sym___attribute__] = ACTIONS(3998),
    [anon_sym___attribute] = ACTIONS(3998),
    [anon_sym_COLON_COLON] = ACTIONS(3989),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3989),
    [anon_sym___declspec] = ACTIONS(3998),
    [anon_sym___based] = ACTIONS(3998),
    [anon_sym_LBRACE] = ACTIONS(3992),
    [anon_sym_signed] = ACTIONS(3998),
    [anon_sym_unsigned] = ACTIONS(3998),
    [anon_sym_long] = ACTIONS(3998),
    [anon_sym_short] = ACTIONS(3998),
    [anon_sym_LBRACK] = ACTIONS(3986),
    [anon_sym_static] = ACTIONS(3998),
    [anon_sym_register] = ACTIONS(3998),
    [anon_sym_inline] = ACTIONS(3998),
    [anon_sym___inline] = ACTIONS(3998),
    [anon_sym___inline__] = ACTIONS(3998),
    [anon_sym___forceinline] = ACTIONS(3998),
    [anon_sym_thread_local] = ACTIONS(3998),
    [anon_sym___thread] = ACTIONS(3998),
    [anon_sym_const] = ACTIONS(3998),
    [anon_sym_constexpr] = ACTIONS(3998),
    [anon_sym_volatile] = ACTIONS(3998),
    [anon_sym_restrict] = ACTIONS(3998),
    [anon_sym___restrict__] = ACTIONS(3998),
    [anon_sym__Atomic] = ACTIONS(3998),
    [anon_sym__Noreturn] = ACTIONS(3998),
    [anon_sym_noreturn] = ACTIONS(3998),
    [anon_sym__Nonnull] = ACTIONS(3998),
    [anon_sym_mutable] = ACTIONS(3998),
    [anon_sym_constinit] = ACTIONS(3998),
    [anon_sym_consteval] = ACTIONS(3998),
    [anon_sym_alignas] = ACTIONS(3998),
    [anon_sym__Alignas] = ACTIONS(3998),
    [sym_primitive_type] = ACTIONS(3986),
    [anon_sym_enum] = ACTIONS(3998),
    [anon_sym_class] = ACTIONS(3998),
    [anon_sym_struct] = ACTIONS(3998),
    [anon_sym_union] = ACTIONS(3998),
    [anon_sym_if] = ACTIONS(3994),
    [anon_sym_switch] = ACTIONS(3994),
    [anon_sym_case] = ACTIONS(3994),
    [anon_sym_default] = ACTIONS(3994),
    [anon_sym_while] = ACTIONS(3994),
    [anon_sym_do] = ACTIONS(3994),
    [anon_sym_for] = ACTIONS(3994),
    [anon_sym_return] = ACTIONS(3994),
    [anon_sym_break] = ACTIONS(3994),
    [anon_sym_continue] = ACTIONS(3994),
    [anon_sym_goto] = ACTIONS(3994),
    [anon_sym___try] = ACTIONS(3994),
    [anon_sym___leave] = ACTIONS(3994),
    [anon_sym_not] = ACTIONS(3994),
    [anon_sym_compl] = ACTIONS(3994),
    [anon_sym_DASH_DASH] = ACTIONS(3992),
    [anon_sym_PLUS_PLUS] = ACTIONS(3992),
    [anon_sym_sizeof] = ACTIONS(3994),
    [anon_sym___alignof__] = ACTIONS(3994),
    [anon_sym___alignof] = ACTIONS(3994),
    [anon_sym__alignof] = ACTIONS(3994),
    [anon_sym_alignof] = ACTIONS(3994),
    [anon_sym__Alignof] = ACTIONS(3994),
    [anon_sym_offsetof] = ACTIONS(3994),
    [anon_sym__Generic] = ACTIONS(3994),
    [anon_sym_asm] = ACTIONS(3994),
    [anon_sym___asm__] = ACTIONS(3994),
    [anon_sym___asm] = ACTIONS(3994),
    [sym_number_literal] = ACTIONS(3992),
    [anon_sym_L_SQUOTE] = ACTIONS(3992),
    [anon_sym_u_SQUOTE] = ACTIONS(3992),
    [anon_sym_U_SQUOTE] = ACTIONS(3992),
    [anon_sym_u8_SQUOTE] = ACTIONS(3992),
    [anon_sym_SQUOTE] = ACTIONS(3992),
    [anon_sym_L_DQUOTE] = ACTIONS(3992),
    [anon_sym_u_DQUOTE] = ACTIONS(3992),
    [anon_sym_U_DQUOTE] = ACTIONS(3992),
    [anon_sym_u8_DQUOTE] = ACTIONS(3992),
    [anon_sym_DQUOTE] = ACTIONS(3992),
    [sym_true] = ACTIONS(3994),
    [sym_false] = ACTIONS(3994),
    [anon_sym_NULL] = ACTIONS(3994),
    [anon_sym_nullptr] = ACTIONS(3994),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3998),
    [anon_sym_decltype] = ACTIONS(3986),
    [anon_sym_explicit] = ACTIONS(3998),
    [anon_sym_typename] = ACTIONS(3998),
    [anon_sym_template] = ACTIONS(3986),
    [anon_sym_operator] = ACTIONS(3998),
    [anon_sym_try] = ACTIONS(3994),
    [anon_sym_delete] = ACTIONS(3994),
    [anon_sym_throw] = ACTIONS(3994),
    [anon_sym_co_return] = ACTIONS(3994),
    [anon_sym_co_yield] = ACTIONS(3994),
    [anon_sym_R_DQUOTE] = ACTIONS(3992),
    [anon_sym_LR_DQUOTE] = ACTIONS(3992),
    [anon_sym_uR_DQUOTE] = ACTIONS(3992),
    [anon_sym_UR_DQUOTE] = ACTIONS(3992),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3992),
    [anon_sym_co_await] = ACTIONS(3994),
    [anon_sym_new] = ACTIONS(3994),
    [anon_sym_requires] = ACTIONS(3994),
    [sym_this] = ACTIONS(3994),
  },
  [831] = {
    [sym_expression] = STATE(2843),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(4000),
    [anon_sym_LPAREN2] = ACTIONS(4003),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(4006),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(2523),
    [anon_sym_AMP_AMP] = ACTIONS(2526),
    [anon_sym_AMP] = ACTIONS(2528),
    [anon_sym___extension__] = ACTIONS(4009),
    [anon_sym_COLON_COLON] = ACTIONS(4012),
    [anon_sym___based] = ACTIONS(2536),
    [anon_sym_LBRACK] = ACTIONS(4015),
    [anon_sym_const] = ACTIONS(2536),
    [anon_sym_constexpr] = ACTIONS(2536),
    [anon_sym_volatile] = ACTIONS(2536),
    [anon_sym_restrict] = ACTIONS(2536),
    [anon_sym___restrict__] = ACTIONS(2536),
    [anon_sym__Atomic] = ACTIONS(2536),
    [anon_sym__Noreturn] = ACTIONS(2536),
    [anon_sym_noreturn] = ACTIONS(2536),
    [anon_sym__Nonnull] = ACTIONS(2536),
    [anon_sym_mutable] = ACTIONS(2536),
    [anon_sym_constinit] = ACTIONS(2536),
    [anon_sym_consteval] = ACTIONS(2536),
    [anon_sym_alignas] = ACTIONS(2536),
    [anon_sym__Alignas] = ACTIONS(2536),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1965),
    [anon_sym_compl] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_sizeof] = ACTIONS(1973),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2547),
    [anon_sym_template] = ACTIONS(2550),
    [anon_sym_operator] = ACTIONS(2536),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [832] = {
    [sym_catch_clause] = STATE(832),
    [aux_sym_constructor_try_statement_repeat1] = STATE(832),
    [sym_identifier] = ACTIONS(2439),
    [anon_sym_LPAREN2] = ACTIONS(2441),
    [anon_sym_BANG] = ACTIONS(2441),
    [anon_sym_TILDE] = ACTIONS(2441),
    [anon_sym_DASH] = ACTIONS(2439),
    [anon_sym_PLUS] = ACTIONS(2439),
    [anon_sym_STAR] = ACTIONS(2441),
    [anon_sym_AMP] = ACTIONS(2441),
    [anon_sym_SEMI] = ACTIONS(2441),
    [anon_sym___extension__] = ACTIONS(2439),
    [anon_sym_typedef] = ACTIONS(2439),
    [anon_sym_virtual] = ACTIONS(2439),
    [anon_sym_extern] = ACTIONS(2439),
    [anon_sym___attribute__] = ACTIONS(2439),
    [anon_sym___attribute] = ACTIONS(2439),
    [anon_sym_COLON_COLON] = ACTIONS(2441),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2441),
    [anon_sym___declspec] = ACTIONS(2439),
    [anon_sym_LBRACE] = ACTIONS(2441),
    [anon_sym_signed] = ACTIONS(2439),
    [anon_sym_unsigned] = ACTIONS(2439),
    [anon_sym_long] = ACTIONS(2439),
    [anon_sym_short] = ACTIONS(2439),
    [anon_sym_LBRACK] = ACTIONS(2439),
    [anon_sym_static] = ACTIONS(2439),
    [anon_sym_register] = ACTIONS(2439),
    [anon_sym_inline] = ACTIONS(2439),
    [anon_sym___inline] = ACTIONS(2439),
    [anon_sym___inline__] = ACTIONS(2439),
    [anon_sym___forceinline] = ACTIONS(2439),
    [anon_sym_thread_local] = ACTIONS(2439),
    [anon_sym___thread] = ACTIONS(2439),
    [anon_sym_const] = ACTIONS(2439),
    [anon_sym_constexpr] = ACTIONS(2439),
    [anon_sym_volatile] = ACTIONS(2439),
    [anon_sym_restrict] = ACTIONS(2439),
    [anon_sym___restrict__] = ACTIONS(2439),
    [anon_sym__Atomic] = ACTIONS(2439),
    [anon_sym__Noreturn] = ACTIONS(2439),
    [anon_sym_noreturn] = ACTIONS(2439),
    [anon_sym__Nonnull] = ACTIONS(2439),
    [anon_sym_mutable] = ACTIONS(2439),
    [anon_sym_constinit] = ACTIONS(2439),
    [anon_sym_consteval] = ACTIONS(2439),
    [anon_sym_alignas] = ACTIONS(2439),
    [anon_sym__Alignas] = ACTIONS(2439),
    [sym_primitive_type] = ACTIONS(2439),
    [anon_sym_enum] = ACTIONS(2439),
    [anon_sym_class] = ACTIONS(2439),
    [anon_sym_struct] = ACTIONS(2439),
    [anon_sym_union] = ACTIONS(2439),
    [anon_sym_if] = ACTIONS(2439),
    [anon_sym_else] = ACTIONS(2439),
    [anon_sym_switch] = ACTIONS(2439),
    [anon_sym_while] = ACTIONS(2439),
    [anon_sym_do] = ACTIONS(2439),
    [anon_sym_for] = ACTIONS(2439),
    [anon_sym_return] = ACTIONS(2439),
    [anon_sym_break] = ACTIONS(2439),
    [anon_sym_continue] = ACTIONS(2439),
    [anon_sym_goto] = ACTIONS(2439),
    [anon_sym___try] = ACTIONS(2439),
    [anon_sym___leave] = ACTIONS(2439),
    [anon_sym_not] = ACTIONS(2439),
    [anon_sym_compl] = ACTIONS(2439),
    [anon_sym_DASH_DASH] = ACTIONS(2441),
    [anon_sym_PLUS_PLUS] = ACTIONS(2441),
    [anon_sym_sizeof] = ACTIONS(2439),
    [anon_sym___alignof__] = ACTIONS(2439),
    [anon_sym___alignof] = ACTIONS(2439),
    [anon_sym__alignof] = ACTIONS(2439),
    [anon_sym_alignof] = ACTIONS(2439),
    [anon_sym__Alignof] = ACTIONS(2439),
    [anon_sym_offsetof] = ACTIONS(2439),
    [anon_sym__Generic] = ACTIONS(2439),
    [anon_sym_asm] = ACTIONS(2439),
    [anon_sym___asm__] = ACTIONS(2439),
    [anon_sym___asm] = ACTIONS(2439),
    [sym_number_literal] = ACTIONS(2441),
    [anon_sym_L_SQUOTE] = ACTIONS(2441),
    [anon_sym_u_SQUOTE] = ACTIONS(2441),
    [anon_sym_U_SQUOTE] = ACTIONS(2441),
    [anon_sym_u8_SQUOTE] = ACTIONS(2441),
    [anon_sym_SQUOTE] = ACTIONS(2441),
    [anon_sym_L_DQUOTE] = ACTIONS(2441),
    [anon_sym_u_DQUOTE] = ACTIONS(2441),
    [anon_sym_U_DQUOTE] = ACTIONS(2441),
    [anon_sym_u8_DQUOTE] = ACTIONS(2441),
    [anon_sym_DQUOTE] = ACTIONS(2441),
    [sym_true] = ACTIONS(2439),
    [sym_false] = ACTIONS(2439),
    [anon_sym_NULL] = ACTIONS(2439),
    [anon_sym_nullptr] = ACTIONS(2439),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2439),
    [anon_sym_decltype] = ACTIONS(2439),
    [anon_sym_typename] = ACTIONS(2439),
    [anon_sym_template] = ACTIONS(2439),
    [anon_sym_try] = ACTIONS(2439),
    [anon_sym_delete] = ACTIONS(2439),
    [anon_sym_throw] = ACTIONS(2439),
    [anon_sym_co_return] = ACTIONS(2439),
    [anon_sym_co_yield] = ACTIONS(2439),
    [anon_sym_catch] = ACTIONS(4018),
    [anon_sym_R_DQUOTE] = ACTIONS(2441),
    [anon_sym_LR_DQUOTE] = ACTIONS(2441),
    [anon_sym_uR_DQUOTE] = ACTIONS(2441),
    [anon_sym_UR_DQUOTE] = ACTIONS(2441),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2441),
    [anon_sym_co_await] = ACTIONS(2439),
    [anon_sym_new] = ACTIONS(2439),
    [anon_sym_requires] = ACTIONS(2439),
    [sym_this] = ACTIONS(2439),
  },
  [833] = {
    [sym_expression] = STATE(3153),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(3806),
    [anon_sym_LPAREN2] = ACTIONS(4021),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(4024),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(4027),
    [anon_sym_AMP_AMP] = ACTIONS(2526),
    [anon_sym_AMP] = ACTIONS(4030),
    [anon_sym___extension__] = ACTIONS(3809),
    [anon_sym_COLON_COLON] = ACTIONS(3812),
    [anon_sym___based] = ACTIONS(2536),
    [anon_sym_LBRACK] = ACTIONS(4015),
    [anon_sym_const] = ACTIONS(2536),
    [anon_sym_constexpr] = ACTIONS(2536),
    [anon_sym_volatile] = ACTIONS(2536),
    [anon_sym_restrict] = ACTIONS(2536),
    [anon_sym___restrict__] = ACTIONS(2536),
    [anon_sym__Atomic] = ACTIONS(2536),
    [anon_sym__Noreturn] = ACTIONS(2536),
    [anon_sym_noreturn] = ACTIONS(2536),
    [anon_sym__Nonnull] = ACTIONS(2536),
    [anon_sym_mutable] = ACTIONS(2536),
    [anon_sym_constinit] = ACTIONS(2536),
    [anon_sym_consteval] = ACTIONS(2536),
    [anon_sym_alignas] = ACTIONS(2536),
    [anon_sym__Alignas] = ACTIONS(2536),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2547),
    [anon_sym_template] = ACTIONS(2550),
    [anon_sym_operator] = ACTIONS(2536),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [834] = {
    [sym_string_literal] = STATE(2570),
    [sym_template_argument_list] = STATE(1565),
    [sym_raw_string_literal] = STATE(2570),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2551),
    [sym_identifier] = ACTIONS(4033),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4035),
    [anon_sym_COMMA] = ACTIONS(4035),
    [anon_sym_LPAREN2] = ACTIONS(4037),
    [anon_sym_TILDE] = ACTIONS(4041),
    [anon_sym_DASH] = ACTIONS(4043),
    [anon_sym_PLUS] = ACTIONS(4043),
    [anon_sym_STAR] = ACTIONS(4045),
    [anon_sym_SLASH] = ACTIONS(4043),
    [anon_sym_PERCENT] = ACTIONS(4043),
    [anon_sym_PIPE_PIPE] = ACTIONS(4035),
    [anon_sym_AMP_AMP] = ACTIONS(4048),
    [anon_sym_PIPE] = ACTIONS(4043),
    [anon_sym_CARET] = ACTIONS(4043),
    [anon_sym_AMP] = ACTIONS(4045),
    [anon_sym_EQ_EQ] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4043),
    [anon_sym_GT_EQ] = ACTIONS(4035),
    [anon_sym_LT_EQ] = ACTIONS(4043),
    [anon_sym_LT] = ACTIONS(4051),
    [anon_sym_LT_LT] = ACTIONS(4043),
    [anon_sym_GT_GT] = ACTIONS(4043),
    [anon_sym_SEMI] = ACTIONS(4048),
    [anon_sym___extension__] = ACTIONS(4033),
    [anon_sym_virtual] = ACTIONS(4033),
    [anon_sym_extern] = ACTIONS(4033),
    [anon_sym___attribute__] = ACTIONS(4033),
    [anon_sym___attribute] = ACTIONS(4033),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4056),
    [anon_sym___declspec] = ACTIONS(4033),
    [anon_sym___based] = ACTIONS(4033),
    [anon_sym___cdecl] = ACTIONS(4033),
    [anon_sym___clrcall] = ACTIONS(4033),
    [anon_sym___stdcall] = ACTIONS(4033),
    [anon_sym___fastcall] = ACTIONS(4033),
    [anon_sym___thiscall] = ACTIONS(4033),
    [anon_sym___vectorcall] = ACTIONS(4033),
    [anon_sym_LBRACE] = ACTIONS(4059),
    [anon_sym_RBRACE] = ACTIONS(4035),
    [anon_sym_signed] = ACTIONS(4061),
    [anon_sym_unsigned] = ACTIONS(4061),
    [anon_sym_long] = ACTIONS(4061),
    [anon_sym_short] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(4063),
    [anon_sym_static] = ACTIONS(4033),
    [anon_sym_EQ] = ACTIONS(4067),
    [anon_sym_register] = ACTIONS(4033),
    [anon_sym_inline] = ACTIONS(4033),
    [anon_sym___inline] = ACTIONS(4033),
    [anon_sym___inline__] = ACTIONS(4033),
    [anon_sym___forceinline] = ACTIONS(4033),
    [anon_sym_thread_local] = ACTIONS(4033),
    [anon_sym___thread] = ACTIONS(4033),
    [anon_sym_const] = ACTIONS(4033),
    [anon_sym_constexpr] = ACTIONS(4033),
    [anon_sym_volatile] = ACTIONS(4033),
    [anon_sym_restrict] = ACTIONS(4033),
    [anon_sym___restrict__] = ACTIONS(4033),
    [anon_sym__Atomic] = ACTIONS(4033),
    [anon_sym__Noreturn] = ACTIONS(4033),
    [anon_sym_noreturn] = ACTIONS(4033),
    [anon_sym__Nonnull] = ACTIONS(4033),
    [anon_sym_mutable] = ACTIONS(4033),
    [anon_sym_constinit] = ACTIONS(4033),
    [anon_sym_consteval] = ACTIONS(4033),
    [anon_sym_alignas] = ACTIONS(4033),
    [anon_sym__Alignas] = ACTIONS(4033),
    [anon_sym_COLON] = ACTIONS(4069),
    [anon_sym_QMARK] = ACTIONS(4035),
    [anon_sym_STAR_EQ] = ACTIONS(4071),
    [anon_sym_SLASH_EQ] = ACTIONS(4071),
    [anon_sym_PERCENT_EQ] = ACTIONS(4071),
    [anon_sym_PLUS_EQ] = ACTIONS(4071),
    [anon_sym_DASH_EQ] = ACTIONS(4071),
    [anon_sym_LT_LT_EQ] = ACTIONS(4071),
    [anon_sym_GT_GT_EQ] = ACTIONS(4071),
    [anon_sym_AMP_EQ] = ACTIONS(4071),
    [anon_sym_CARET_EQ] = ACTIONS(4071),
    [anon_sym_PIPE_EQ] = ACTIONS(4071),
    [anon_sym_and_eq] = ACTIONS(4067),
    [anon_sym_or_eq] = ACTIONS(4067),
    [anon_sym_xor_eq] = ACTIONS(4067),
    [anon_sym_LT_EQ_GT] = ACTIONS(4035),
    [anon_sym_or] = ACTIONS(4043),
    [anon_sym_and] = ACTIONS(4043),
    [anon_sym_bitor] = ACTIONS(4043),
    [anon_sym_xor] = ACTIONS(4043),
    [anon_sym_bitand] = ACTIONS(4043),
    [anon_sym_not_eq] = ACTIONS(4043),
    [anon_sym_DASH_DASH] = ACTIONS(4035),
    [anon_sym_PLUS_PLUS] = ACTIONS(4035),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_DOT_STAR] = ACTIONS(4035),
    [anon_sym_DASH_GT] = ACTIONS(4035),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4033),
    [anon_sym_decltype] = ACTIONS(4033),
    [anon_sym_template] = ACTIONS(4033),
    [anon_sym_operator] = ACTIONS(4033),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
  },
  [835] = {
    [sym_catch_clause] = STATE(832),
    [aux_sym_constructor_try_statement_repeat1] = STATE(832),
    [sym_identifier] = ACTIONS(2490),
    [anon_sym_LPAREN2] = ACTIONS(2492),
    [anon_sym_BANG] = ACTIONS(2492),
    [anon_sym_TILDE] = ACTIONS(2492),
    [anon_sym_DASH] = ACTIONS(2490),
    [anon_sym_PLUS] = ACTIONS(2490),
    [anon_sym_STAR] = ACTIONS(2492),
    [anon_sym_AMP] = ACTIONS(2492),
    [anon_sym_SEMI] = ACTIONS(2492),
    [anon_sym___extension__] = ACTIONS(2490),
    [anon_sym_typedef] = ACTIONS(2490),
    [anon_sym_virtual] = ACTIONS(2490),
    [anon_sym_extern] = ACTIONS(2490),
    [anon_sym___attribute__] = ACTIONS(2490),
    [anon_sym___attribute] = ACTIONS(2490),
    [anon_sym_COLON_COLON] = ACTIONS(2492),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2492),
    [anon_sym___declspec] = ACTIONS(2490),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_signed] = ACTIONS(2490),
    [anon_sym_unsigned] = ACTIONS(2490),
    [anon_sym_long] = ACTIONS(2490),
    [anon_sym_short] = ACTIONS(2490),
    [anon_sym_LBRACK] = ACTIONS(2490),
    [anon_sym_static] = ACTIONS(2490),
    [anon_sym_register] = ACTIONS(2490),
    [anon_sym_inline] = ACTIONS(2490),
    [anon_sym___inline] = ACTIONS(2490),
    [anon_sym___inline__] = ACTIONS(2490),
    [anon_sym___forceinline] = ACTIONS(2490),
    [anon_sym_thread_local] = ACTIONS(2490),
    [anon_sym___thread] = ACTIONS(2490),
    [anon_sym_const] = ACTIONS(2490),
    [anon_sym_constexpr] = ACTIONS(2490),
    [anon_sym_volatile] = ACTIONS(2490),
    [anon_sym_restrict] = ACTIONS(2490),
    [anon_sym___restrict__] = ACTIONS(2490),
    [anon_sym__Atomic] = ACTIONS(2490),
    [anon_sym__Noreturn] = ACTIONS(2490),
    [anon_sym_noreturn] = ACTIONS(2490),
    [anon_sym__Nonnull] = ACTIONS(2490),
    [anon_sym_mutable] = ACTIONS(2490),
    [anon_sym_constinit] = ACTIONS(2490),
    [anon_sym_consteval] = ACTIONS(2490),
    [anon_sym_alignas] = ACTIONS(2490),
    [anon_sym__Alignas] = ACTIONS(2490),
    [sym_primitive_type] = ACTIONS(2490),
    [anon_sym_enum] = ACTIONS(2490),
    [anon_sym_class] = ACTIONS(2490),
    [anon_sym_struct] = ACTIONS(2490),
    [anon_sym_union] = ACTIONS(2490),
    [anon_sym_if] = ACTIONS(2490),
    [anon_sym_else] = ACTIONS(2490),
    [anon_sym_switch] = ACTIONS(2490),
    [anon_sym_while] = ACTIONS(2490),
    [anon_sym_do] = ACTIONS(2490),
    [anon_sym_for] = ACTIONS(2490),
    [anon_sym_return] = ACTIONS(2490),
    [anon_sym_break] = ACTIONS(2490),
    [anon_sym_continue] = ACTIONS(2490),
    [anon_sym_goto] = ACTIONS(2490),
    [anon_sym___try] = ACTIONS(2490),
    [anon_sym___leave] = ACTIONS(2490),
    [anon_sym_not] = ACTIONS(2490),
    [anon_sym_compl] = ACTIONS(2490),
    [anon_sym_DASH_DASH] = ACTIONS(2492),
    [anon_sym_PLUS_PLUS] = ACTIONS(2492),
    [anon_sym_sizeof] = ACTIONS(2490),
    [anon_sym___alignof__] = ACTIONS(2490),
    [anon_sym___alignof] = ACTIONS(2490),
    [anon_sym__alignof] = ACTIONS(2490),
    [anon_sym_alignof] = ACTIONS(2490),
    [anon_sym__Alignof] = ACTIONS(2490),
    [anon_sym_offsetof] = ACTIONS(2490),
    [anon_sym__Generic] = ACTIONS(2490),
    [anon_sym_asm] = ACTIONS(2490),
    [anon_sym___asm__] = ACTIONS(2490),
    [anon_sym___asm] = ACTIONS(2490),
    [sym_number_literal] = ACTIONS(2492),
    [anon_sym_L_SQUOTE] = ACTIONS(2492),
    [anon_sym_u_SQUOTE] = ACTIONS(2492),
    [anon_sym_U_SQUOTE] = ACTIONS(2492),
    [anon_sym_u8_SQUOTE] = ACTIONS(2492),
    [anon_sym_SQUOTE] = ACTIONS(2492),
    [anon_sym_L_DQUOTE] = ACTIONS(2492),
    [anon_sym_u_DQUOTE] = ACTIONS(2492),
    [anon_sym_U_DQUOTE] = ACTIONS(2492),
    [anon_sym_u8_DQUOTE] = ACTIONS(2492),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [sym_true] = ACTIONS(2490),
    [sym_false] = ACTIONS(2490),
    [anon_sym_NULL] = ACTIONS(2490),
    [anon_sym_nullptr] = ACTIONS(2490),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2490),
    [anon_sym_decltype] = ACTIONS(2490),
    [anon_sym_typename] = ACTIONS(2490),
    [anon_sym_template] = ACTIONS(2490),
    [anon_sym_try] = ACTIONS(2490),
    [anon_sym_delete] = ACTIONS(2490),
    [anon_sym_throw] = ACTIONS(2490),
    [anon_sym_co_return] = ACTIONS(2490),
    [anon_sym_co_yield] = ACTIONS(2490),
    [anon_sym_catch] = ACTIONS(4073),
    [anon_sym_R_DQUOTE] = ACTIONS(2492),
    [anon_sym_LR_DQUOTE] = ACTIONS(2492),
    [anon_sym_uR_DQUOTE] = ACTIONS(2492),
    [anon_sym_UR_DQUOTE] = ACTIONS(2492),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2492),
    [anon_sym_co_await] = ACTIONS(2490),
    [anon_sym_new] = ACTIONS(2490),
    [anon_sym_requires] = ACTIONS(2490),
    [sym_this] = ACTIONS(2490),
  },
  [836] = {
    [sym_string_literal] = STATE(2570),
    [sym_template_argument_list] = STATE(1565),
    [sym_raw_string_literal] = STATE(2570),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2551),
    [sym_identifier] = ACTIONS(4033),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4035),
    [anon_sym_COMMA] = ACTIONS(4035),
    [anon_sym_LPAREN2] = ACTIONS(4037),
    [anon_sym_TILDE] = ACTIONS(4041),
    [anon_sym_DASH] = ACTIONS(4043),
    [anon_sym_PLUS] = ACTIONS(4043),
    [anon_sym_STAR] = ACTIONS(4045),
    [anon_sym_SLASH] = ACTIONS(4043),
    [anon_sym_PERCENT] = ACTIONS(4043),
    [anon_sym_PIPE_PIPE] = ACTIONS(4035),
    [anon_sym_AMP_AMP] = ACTIONS(4048),
    [anon_sym_PIPE] = ACTIONS(4043),
    [anon_sym_CARET] = ACTIONS(4043),
    [anon_sym_AMP] = ACTIONS(4045),
    [anon_sym_EQ_EQ] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4043),
    [anon_sym_GT_EQ] = ACTIONS(4035),
    [anon_sym_LT_EQ] = ACTIONS(4043),
    [anon_sym_LT] = ACTIONS(4051),
    [anon_sym_LT_LT] = ACTIONS(4043),
    [anon_sym_GT_GT] = ACTIONS(4043),
    [anon_sym_SEMI] = ACTIONS(4048),
    [anon_sym___extension__] = ACTIONS(4033),
    [anon_sym_virtual] = ACTIONS(4033),
    [anon_sym_extern] = ACTIONS(4033),
    [anon_sym___attribute__] = ACTIONS(4033),
    [anon_sym___attribute] = ACTIONS(4033),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4056),
    [anon_sym___declspec] = ACTIONS(4033),
    [anon_sym___based] = ACTIONS(4033),
    [anon_sym___cdecl] = ACTIONS(4033),
    [anon_sym___clrcall] = ACTIONS(4033),
    [anon_sym___stdcall] = ACTIONS(4033),
    [anon_sym___fastcall] = ACTIONS(4033),
    [anon_sym___thiscall] = ACTIONS(4033),
    [anon_sym___vectorcall] = ACTIONS(4033),
    [anon_sym_LBRACE] = ACTIONS(4059),
    [anon_sym_signed] = ACTIONS(4061),
    [anon_sym_unsigned] = ACTIONS(4061),
    [anon_sym_long] = ACTIONS(4061),
    [anon_sym_short] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(4063),
    [anon_sym_static] = ACTIONS(4033),
    [anon_sym_EQ] = ACTIONS(4067),
    [anon_sym_register] = ACTIONS(4033),
    [anon_sym_inline] = ACTIONS(4033),
    [anon_sym___inline] = ACTIONS(4033),
    [anon_sym___inline__] = ACTIONS(4033),
    [anon_sym___forceinline] = ACTIONS(4033),
    [anon_sym_thread_local] = ACTIONS(4033),
    [anon_sym___thread] = ACTIONS(4033),
    [anon_sym_const] = ACTIONS(4033),
    [anon_sym_constexpr] = ACTIONS(4033),
    [anon_sym_volatile] = ACTIONS(4033),
    [anon_sym_restrict] = ACTIONS(4033),
    [anon_sym___restrict__] = ACTIONS(4033),
    [anon_sym__Atomic] = ACTIONS(4033),
    [anon_sym__Noreturn] = ACTIONS(4033),
    [anon_sym_noreturn] = ACTIONS(4033),
    [anon_sym__Nonnull] = ACTIONS(4033),
    [anon_sym_mutable] = ACTIONS(4033),
    [anon_sym_constinit] = ACTIONS(4033),
    [anon_sym_consteval] = ACTIONS(4033),
    [anon_sym_alignas] = ACTIONS(4033),
    [anon_sym__Alignas] = ACTIONS(4033),
    [anon_sym_COLON] = ACTIONS(4075),
    [anon_sym_QMARK] = ACTIONS(4035),
    [anon_sym_STAR_EQ] = ACTIONS(4071),
    [anon_sym_SLASH_EQ] = ACTIONS(4071),
    [anon_sym_PERCENT_EQ] = ACTIONS(4071),
    [anon_sym_PLUS_EQ] = ACTIONS(4071),
    [anon_sym_DASH_EQ] = ACTIONS(4071),
    [anon_sym_LT_LT_EQ] = ACTIONS(4071),
    [anon_sym_GT_GT_EQ] = ACTIONS(4071),
    [anon_sym_AMP_EQ] = ACTIONS(4071),
    [anon_sym_CARET_EQ] = ACTIONS(4071),
    [anon_sym_PIPE_EQ] = ACTIONS(4071),
    [anon_sym_and_eq] = ACTIONS(4067),
    [anon_sym_or_eq] = ACTIONS(4067),
    [anon_sym_xor_eq] = ACTIONS(4067),
    [anon_sym_LT_EQ_GT] = ACTIONS(4035),
    [anon_sym_or] = ACTIONS(4043),
    [anon_sym_and] = ACTIONS(4043),
    [anon_sym_bitor] = ACTIONS(4043),
    [anon_sym_xor] = ACTIONS(4043),
    [anon_sym_bitand] = ACTIONS(4043),
    [anon_sym_not_eq] = ACTIONS(4043),
    [anon_sym_DASH_DASH] = ACTIONS(4035),
    [anon_sym_PLUS_PLUS] = ACTIONS(4035),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_DOT_STAR] = ACTIONS(4035),
    [anon_sym_DASH_GT] = ACTIONS(4035),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4033),
    [anon_sym_decltype] = ACTIONS(4033),
    [anon_sym_template] = ACTIONS(4033),
    [anon_sym_operator] = ACTIONS(4033),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
  },
  [837] = {
    [sym_string_literal] = STATE(2570),
    [sym_template_argument_list] = STATE(1565),
    [sym_raw_string_literal] = STATE(2570),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2551),
    [sym_identifier] = ACTIONS(4033),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4035),
    [anon_sym_COMMA] = ACTIONS(4035),
    [anon_sym_LPAREN2] = ACTIONS(4037),
    [anon_sym_TILDE] = ACTIONS(4041),
    [anon_sym_DASH] = ACTIONS(4043),
    [anon_sym_PLUS] = ACTIONS(4043),
    [anon_sym_STAR] = ACTIONS(4045),
    [anon_sym_SLASH] = ACTIONS(4043),
    [anon_sym_PERCENT] = ACTIONS(4043),
    [anon_sym_PIPE_PIPE] = ACTIONS(4035),
    [anon_sym_AMP_AMP] = ACTIONS(4048),
    [anon_sym_PIPE] = ACTIONS(4043),
    [anon_sym_CARET] = ACTIONS(4043),
    [anon_sym_AMP] = ACTIONS(4045),
    [anon_sym_EQ_EQ] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4043),
    [anon_sym_GT_EQ] = ACTIONS(4035),
    [anon_sym_LT_EQ] = ACTIONS(4043),
    [anon_sym_LT] = ACTIONS(4051),
    [anon_sym_LT_LT] = ACTIONS(4043),
    [anon_sym_GT_GT] = ACTIONS(4043),
    [anon_sym_SEMI] = ACTIONS(4048),
    [anon_sym___extension__] = ACTIONS(4033),
    [anon_sym_virtual] = ACTIONS(4033),
    [anon_sym_extern] = ACTIONS(4033),
    [anon_sym___attribute__] = ACTIONS(4033),
    [anon_sym___attribute] = ACTIONS(4033),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4056),
    [anon_sym___declspec] = ACTIONS(4033),
    [anon_sym___based] = ACTIONS(4033),
    [anon_sym___cdecl] = ACTIONS(4033),
    [anon_sym___clrcall] = ACTIONS(4033),
    [anon_sym___stdcall] = ACTIONS(4033),
    [anon_sym___fastcall] = ACTIONS(4033),
    [anon_sym___thiscall] = ACTIONS(4033),
    [anon_sym___vectorcall] = ACTIONS(4033),
    [anon_sym_LBRACE] = ACTIONS(4059),
    [anon_sym_signed] = ACTIONS(4061),
    [anon_sym_unsigned] = ACTIONS(4061),
    [anon_sym_long] = ACTIONS(4061),
    [anon_sym_short] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(4063),
    [anon_sym_static] = ACTIONS(4033),
    [anon_sym_EQ] = ACTIONS(4067),
    [anon_sym_register] = ACTIONS(4033),
    [anon_sym_inline] = ACTIONS(4033),
    [anon_sym___inline] = ACTIONS(4033),
    [anon_sym___inline__] = ACTIONS(4033),
    [anon_sym___forceinline] = ACTIONS(4033),
    [anon_sym_thread_local] = ACTIONS(4033),
    [anon_sym___thread] = ACTIONS(4033),
    [anon_sym_const] = ACTIONS(4033),
    [anon_sym_constexpr] = ACTIONS(4033),
    [anon_sym_volatile] = ACTIONS(4033),
    [anon_sym_restrict] = ACTIONS(4033),
    [anon_sym___restrict__] = ACTIONS(4033),
    [anon_sym__Atomic] = ACTIONS(4033),
    [anon_sym__Noreturn] = ACTIONS(4033),
    [anon_sym_noreturn] = ACTIONS(4033),
    [anon_sym__Nonnull] = ACTIONS(4033),
    [anon_sym_mutable] = ACTIONS(4033),
    [anon_sym_constinit] = ACTIONS(4033),
    [anon_sym_consteval] = ACTIONS(4033),
    [anon_sym_alignas] = ACTIONS(4033),
    [anon_sym__Alignas] = ACTIONS(4033),
    [anon_sym_COLON] = ACTIONS(4077),
    [anon_sym_QMARK] = ACTIONS(4035),
    [anon_sym_STAR_EQ] = ACTIONS(4071),
    [anon_sym_SLASH_EQ] = ACTIONS(4071),
    [anon_sym_PERCENT_EQ] = ACTIONS(4071),
    [anon_sym_PLUS_EQ] = ACTIONS(4071),
    [anon_sym_DASH_EQ] = ACTIONS(4071),
    [anon_sym_LT_LT_EQ] = ACTIONS(4071),
    [anon_sym_GT_GT_EQ] = ACTIONS(4071),
    [anon_sym_AMP_EQ] = ACTIONS(4071),
    [anon_sym_CARET_EQ] = ACTIONS(4071),
    [anon_sym_PIPE_EQ] = ACTIONS(4071),
    [anon_sym_and_eq] = ACTIONS(4067),
    [anon_sym_or_eq] = ACTIONS(4067),
    [anon_sym_xor_eq] = ACTIONS(4067),
    [anon_sym_LT_EQ_GT] = ACTIONS(4035),
    [anon_sym_or] = ACTIONS(4043),
    [anon_sym_and] = ACTIONS(4043),
    [anon_sym_bitor] = ACTIONS(4043),
    [anon_sym_xor] = ACTIONS(4043),
    [anon_sym_bitand] = ACTIONS(4043),
    [anon_sym_not_eq] = ACTIONS(4043),
    [anon_sym_DASH_DASH] = ACTIONS(4035),
    [anon_sym_PLUS_PLUS] = ACTIONS(4035),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_DOT_STAR] = ACTIONS(4035),
    [anon_sym_DASH_GT] = ACTIONS(4035),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4033),
    [anon_sym_decltype] = ACTIONS(4033),
    [anon_sym_template] = ACTIONS(4033),
    [anon_sym_operator] = ACTIONS(4033),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
  },
  [838] = {
    [sym_expression] = STATE(4522),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [sym_identifier] = ACTIONS(4079),
    [anon_sym_LPAREN2] = ACTIONS(4082),
    [anon_sym_BANG] = ACTIONS(4085),
    [anon_sym_TILDE] = ACTIONS(4085),
    [anon_sym_DASH] = ACTIONS(4088),
    [anon_sym_PLUS] = ACTIONS(4088),
    [anon_sym_STAR] = ACTIONS(2523),
    [anon_sym_AMP] = ACTIONS(2523),
    [anon_sym___extension__] = ACTIONS(4091),
    [anon_sym_COLON_COLON] = ACTIONS(4094),
    [anon_sym_LBRACK] = ACTIONS(4015),
    [anon_sym_static] = ACTIONS(2536),
    [anon_sym_RBRACK] = ACTIONS(2526),
    [anon_sym_const] = ACTIONS(2536),
    [anon_sym_constexpr] = ACTIONS(2536),
    [anon_sym_volatile] = ACTIONS(2536),
    [anon_sym_restrict] = ACTIONS(2536),
    [anon_sym___restrict__] = ACTIONS(2536),
    [anon_sym__Atomic] = ACTIONS(2536),
    [anon_sym__Noreturn] = ACTIONS(2536),
    [anon_sym_noreturn] = ACTIONS(2536),
    [anon_sym__Nonnull] = ACTIONS(2536),
    [anon_sym_mutable] = ACTIONS(2536),
    [anon_sym_constinit] = ACTIONS(2536),
    [anon_sym_consteval] = ACTIONS(2536),
    [anon_sym_alignas] = ACTIONS(2536),
    [anon_sym__Alignas] = ACTIONS(2536),
    [sym_primitive_type] = ACTIONS(2544),
    [anon_sym_not] = ACTIONS(4088),
    [anon_sym_compl] = ACTIONS(4088),
    [anon_sym_DASH_DASH] = ACTIONS(4097),
    [anon_sym_PLUS_PLUS] = ACTIONS(4097),
    [anon_sym_sizeof] = ACTIONS(4100),
    [anon_sym___alignof__] = ACTIONS(4103),
    [anon_sym___alignof] = ACTIONS(4103),
    [anon_sym__alignof] = ACTIONS(4103),
    [anon_sym_alignof] = ACTIONS(4103),
    [anon_sym__Alignof] = ACTIONS(4103),
    [anon_sym_offsetof] = ACTIONS(4106),
    [anon_sym__Generic] = ACTIONS(4109),
    [anon_sym_asm] = ACTIONS(4112),
    [anon_sym___asm__] = ACTIONS(4112),
    [anon_sym___asm] = ACTIONS(4112),
    [sym_number_literal] = ACTIONS(4115),
    [anon_sym_L_SQUOTE] = ACTIONS(4118),
    [anon_sym_u_SQUOTE] = ACTIONS(4118),
    [anon_sym_U_SQUOTE] = ACTIONS(4118),
    [anon_sym_u8_SQUOTE] = ACTIONS(4118),
    [anon_sym_SQUOTE] = ACTIONS(4118),
    [anon_sym_L_DQUOTE] = ACTIONS(4121),
    [anon_sym_u_DQUOTE] = ACTIONS(4121),
    [anon_sym_U_DQUOTE] = ACTIONS(4121),
    [anon_sym_u8_DQUOTE] = ACTIONS(4121),
    [anon_sym_DQUOTE] = ACTIONS(4121),
    [sym_true] = ACTIONS(4124),
    [sym_false] = ACTIONS(4124),
    [anon_sym_NULL] = ACTIONS(4127),
    [anon_sym_nullptr] = ACTIONS(4127),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2547),
    [anon_sym_template] = ACTIONS(2550),
    [anon_sym_delete] = ACTIONS(4130),
    [anon_sym_R_DQUOTE] = ACTIONS(4133),
    [anon_sym_LR_DQUOTE] = ACTIONS(4133),
    [anon_sym_uR_DQUOTE] = ACTIONS(4133),
    [anon_sym_UR_DQUOTE] = ACTIONS(4133),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4133),
    [anon_sym_co_await] = ACTIONS(4136),
    [anon_sym_new] = ACTIONS(4139),
    [anon_sym_requires] = ACTIONS(4142),
    [sym_this] = ACTIONS(4124),
  },
  [839] = {
    [sym_string_literal] = STATE(2570),
    [sym_template_argument_list] = STATE(1565),
    [sym_raw_string_literal] = STATE(2570),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2551),
    [sym_identifier] = ACTIONS(4033),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4035),
    [anon_sym_COMMA] = ACTIONS(4035),
    [anon_sym_LPAREN2] = ACTIONS(4037),
    [anon_sym_TILDE] = ACTIONS(4041),
    [anon_sym_DASH] = ACTIONS(4043),
    [anon_sym_PLUS] = ACTIONS(4043),
    [anon_sym_STAR] = ACTIONS(4045),
    [anon_sym_SLASH] = ACTIONS(4043),
    [anon_sym_PERCENT] = ACTIONS(4043),
    [anon_sym_PIPE_PIPE] = ACTIONS(4035),
    [anon_sym_AMP_AMP] = ACTIONS(4048),
    [anon_sym_PIPE] = ACTIONS(4043),
    [anon_sym_CARET] = ACTIONS(4043),
    [anon_sym_AMP] = ACTIONS(4045),
    [anon_sym_EQ_EQ] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4043),
    [anon_sym_GT_EQ] = ACTIONS(4035),
    [anon_sym_LT_EQ] = ACTIONS(4043),
    [anon_sym_LT] = ACTIONS(4051),
    [anon_sym_LT_LT] = ACTIONS(4043),
    [anon_sym_GT_GT] = ACTIONS(4043),
    [anon_sym_SEMI] = ACTIONS(4048),
    [anon_sym___extension__] = ACTIONS(4033),
    [anon_sym_virtual] = ACTIONS(4033),
    [anon_sym_extern] = ACTIONS(4033),
    [anon_sym___attribute__] = ACTIONS(4033),
    [anon_sym___attribute] = ACTIONS(4033),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4056),
    [anon_sym___declspec] = ACTIONS(4033),
    [anon_sym___based] = ACTIONS(4033),
    [anon_sym___cdecl] = ACTIONS(4033),
    [anon_sym___clrcall] = ACTIONS(4033),
    [anon_sym___stdcall] = ACTIONS(4033),
    [anon_sym___fastcall] = ACTIONS(4033),
    [anon_sym___thiscall] = ACTIONS(4033),
    [anon_sym___vectorcall] = ACTIONS(4033),
    [anon_sym_LBRACE] = ACTIONS(4059),
    [anon_sym_signed] = ACTIONS(4061),
    [anon_sym_unsigned] = ACTIONS(4061),
    [anon_sym_long] = ACTIONS(4061),
    [anon_sym_short] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(4063),
    [anon_sym_static] = ACTIONS(4033),
    [anon_sym_EQ] = ACTIONS(4067),
    [anon_sym_register] = ACTIONS(4033),
    [anon_sym_inline] = ACTIONS(4033),
    [anon_sym___inline] = ACTIONS(4033),
    [anon_sym___inline__] = ACTIONS(4033),
    [anon_sym___forceinline] = ACTIONS(4033),
    [anon_sym_thread_local] = ACTIONS(4033),
    [anon_sym___thread] = ACTIONS(4033),
    [anon_sym_const] = ACTIONS(4033),
    [anon_sym_constexpr] = ACTIONS(4033),
    [anon_sym_volatile] = ACTIONS(4033),
    [anon_sym_restrict] = ACTIONS(4033),
    [anon_sym___restrict__] = ACTIONS(4033),
    [anon_sym__Atomic] = ACTIONS(4033),
    [anon_sym__Noreturn] = ACTIONS(4033),
    [anon_sym_noreturn] = ACTIONS(4033),
    [anon_sym__Nonnull] = ACTIONS(4033),
    [anon_sym_mutable] = ACTIONS(4033),
    [anon_sym_constinit] = ACTIONS(4033),
    [anon_sym_consteval] = ACTIONS(4033),
    [anon_sym_alignas] = ACTIONS(4033),
    [anon_sym__Alignas] = ACTIONS(4033),
    [anon_sym_COLON] = ACTIONS(4145),
    [anon_sym_QMARK] = ACTIONS(4035),
    [anon_sym_STAR_EQ] = ACTIONS(4071),
    [anon_sym_SLASH_EQ] = ACTIONS(4071),
    [anon_sym_PERCENT_EQ] = ACTIONS(4071),
    [anon_sym_PLUS_EQ] = ACTIONS(4071),
    [anon_sym_DASH_EQ] = ACTIONS(4071),
    [anon_sym_LT_LT_EQ] = ACTIONS(4071),
    [anon_sym_GT_GT_EQ] = ACTIONS(4071),
    [anon_sym_AMP_EQ] = ACTIONS(4071),
    [anon_sym_CARET_EQ] = ACTIONS(4071),
    [anon_sym_PIPE_EQ] = ACTIONS(4071),
    [anon_sym_and_eq] = ACTIONS(4067),
    [anon_sym_or_eq] = ACTIONS(4067),
    [anon_sym_xor_eq] = ACTIONS(4067),
    [anon_sym_LT_EQ_GT] = ACTIONS(4035),
    [anon_sym_or] = ACTIONS(4043),
    [anon_sym_and] = ACTIONS(4043),
    [anon_sym_bitor] = ACTIONS(4043),
    [anon_sym_xor] = ACTIONS(4043),
    [anon_sym_bitand] = ACTIONS(4043),
    [anon_sym_not_eq] = ACTIONS(4043),
    [anon_sym_DASH_DASH] = ACTIONS(4035),
    [anon_sym_PLUS_PLUS] = ACTIONS(4035),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_DOT_STAR] = ACTIONS(4035),
    [anon_sym_DASH_GT] = ACTIONS(4035),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4033),
    [anon_sym_decltype] = ACTIONS(4033),
    [anon_sym_template] = ACTIONS(4033),
    [anon_sym_operator] = ACTIONS(4033),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
  },
  [840] = {
    [sym_string_literal] = STATE(2570),
    [sym_template_argument_list] = STATE(1565),
    [sym_raw_string_literal] = STATE(2570),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2551),
    [sym_identifier] = ACTIONS(4033),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4035),
    [anon_sym_LPAREN2] = ACTIONS(4037),
    [anon_sym_TILDE] = ACTIONS(4041),
    [anon_sym_DASH] = ACTIONS(4043),
    [anon_sym_PLUS] = ACTIONS(4043),
    [anon_sym_STAR] = ACTIONS(4045),
    [anon_sym_SLASH] = ACTIONS(4043),
    [anon_sym_PERCENT] = ACTIONS(4043),
    [anon_sym_PIPE_PIPE] = ACTIONS(4035),
    [anon_sym_AMP_AMP] = ACTIONS(4048),
    [anon_sym_PIPE] = ACTIONS(4043),
    [anon_sym_CARET] = ACTIONS(4043),
    [anon_sym_AMP] = ACTIONS(4045),
    [anon_sym_EQ_EQ] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4043),
    [anon_sym_GT_EQ] = ACTIONS(4035),
    [anon_sym_LT_EQ] = ACTIONS(4043),
    [anon_sym_LT] = ACTIONS(4051),
    [anon_sym_LT_LT] = ACTIONS(4043),
    [anon_sym_GT_GT] = ACTIONS(4043),
    [anon_sym_SEMI] = ACTIONS(4147),
    [anon_sym___extension__] = ACTIONS(4033),
    [anon_sym_virtual] = ACTIONS(4033),
    [anon_sym_extern] = ACTIONS(4033),
    [anon_sym___attribute__] = ACTIONS(4033),
    [anon_sym___attribute] = ACTIONS(4033),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4056),
    [anon_sym___declspec] = ACTIONS(4033),
    [anon_sym___based] = ACTIONS(4033),
    [anon_sym___cdecl] = ACTIONS(4033),
    [anon_sym___clrcall] = ACTIONS(4033),
    [anon_sym___stdcall] = ACTIONS(4033),
    [anon_sym___fastcall] = ACTIONS(4033),
    [anon_sym___thiscall] = ACTIONS(4033),
    [anon_sym___vectorcall] = ACTIONS(4033),
    [anon_sym_LBRACE] = ACTIONS(4059),
    [anon_sym_signed] = ACTIONS(4061),
    [anon_sym_unsigned] = ACTIONS(4061),
    [anon_sym_long] = ACTIONS(4061),
    [anon_sym_short] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(4063),
    [anon_sym_static] = ACTIONS(4033),
    [anon_sym_EQ] = ACTIONS(4067),
    [anon_sym_register] = ACTIONS(4033),
    [anon_sym_inline] = ACTIONS(4033),
    [anon_sym___inline] = ACTIONS(4033),
    [anon_sym___inline__] = ACTIONS(4033),
    [anon_sym___forceinline] = ACTIONS(4033),
    [anon_sym_thread_local] = ACTIONS(4033),
    [anon_sym___thread] = ACTIONS(4033),
    [anon_sym_const] = ACTIONS(4033),
    [anon_sym_constexpr] = ACTIONS(4033),
    [anon_sym_volatile] = ACTIONS(4033),
    [anon_sym_restrict] = ACTIONS(4033),
    [anon_sym___restrict__] = ACTIONS(4033),
    [anon_sym__Atomic] = ACTIONS(4033),
    [anon_sym__Noreturn] = ACTIONS(4033),
    [anon_sym_noreturn] = ACTIONS(4033),
    [anon_sym__Nonnull] = ACTIONS(4033),
    [anon_sym_mutable] = ACTIONS(4033),
    [anon_sym_constinit] = ACTIONS(4033),
    [anon_sym_consteval] = ACTIONS(4033),
    [anon_sym_alignas] = ACTIONS(4033),
    [anon_sym__Alignas] = ACTIONS(4033),
    [anon_sym_COLON] = ACTIONS(4149),
    [anon_sym_QMARK] = ACTIONS(4035),
    [anon_sym_STAR_EQ] = ACTIONS(4071),
    [anon_sym_SLASH_EQ] = ACTIONS(4071),
    [anon_sym_PERCENT_EQ] = ACTIONS(4071),
    [anon_sym_PLUS_EQ] = ACTIONS(4071),
    [anon_sym_DASH_EQ] = ACTIONS(4071),
    [anon_sym_LT_LT_EQ] = ACTIONS(4071),
    [anon_sym_GT_GT_EQ] = ACTIONS(4071),
    [anon_sym_AMP_EQ] = ACTIONS(4071),
    [anon_sym_CARET_EQ] = ACTIONS(4071),
    [anon_sym_PIPE_EQ] = ACTIONS(4071),
    [anon_sym_and_eq] = ACTIONS(4067),
    [anon_sym_or_eq] = ACTIONS(4067),
    [anon_sym_xor_eq] = ACTIONS(4067),
    [anon_sym_LT_EQ_GT] = ACTIONS(4035),
    [anon_sym_or] = ACTIONS(4043),
    [anon_sym_and] = ACTIONS(4043),
    [anon_sym_bitor] = ACTIONS(4043),
    [anon_sym_xor] = ACTIONS(4043),
    [anon_sym_bitand] = ACTIONS(4043),
    [anon_sym_not_eq] = ACTIONS(4043),
    [anon_sym_DASH_DASH] = ACTIONS(4035),
    [anon_sym_PLUS_PLUS] = ACTIONS(4035),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_DOT_STAR] = ACTIONS(4035),
    [anon_sym_DASH_GT] = ACTIONS(4035),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4033),
    [anon_sym_decltype] = ACTIONS(4033),
    [anon_sym_template] = ACTIONS(4033),
    [anon_sym_operator] = ACTIONS(4033),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
  },
  [841] = {
    [sym_identifier] = ACTIONS(1909),
    [anon_sym_LPAREN2] = ACTIONS(1907),
    [anon_sym_BANG] = ACTIONS(1907),
    [anon_sym_TILDE] = ACTIONS(1907),
    [anon_sym_DASH] = ACTIONS(1909),
    [anon_sym_PLUS] = ACTIONS(1909),
    [anon_sym_STAR] = ACTIONS(1907),
    [anon_sym_AMP] = ACTIONS(1907),
    [anon_sym_SEMI] = ACTIONS(1907),
    [anon_sym___extension__] = ACTIONS(1909),
    [anon_sym_typedef] = ACTIONS(1909),
    [anon_sym_virtual] = ACTIONS(1909),
    [anon_sym_extern] = ACTIONS(1909),
    [anon_sym___attribute__] = ACTIONS(1909),
    [anon_sym___attribute] = ACTIONS(1909),
    [anon_sym_COLON_COLON] = ACTIONS(1907),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1907),
    [anon_sym___declspec] = ACTIONS(1909),
    [anon_sym_LBRACE] = ACTIONS(1907),
    [anon_sym_signed] = ACTIONS(1909),
    [anon_sym_unsigned] = ACTIONS(1909),
    [anon_sym_long] = ACTIONS(1909),
    [anon_sym_short] = ACTIONS(1909),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_static] = ACTIONS(1909),
    [anon_sym_register] = ACTIONS(1909),
    [anon_sym_inline] = ACTIONS(1909),
    [anon_sym___inline] = ACTIONS(1909),
    [anon_sym___inline__] = ACTIONS(1909),
    [anon_sym___forceinline] = ACTIONS(1909),
    [anon_sym_thread_local] = ACTIONS(1909),
    [anon_sym___thread] = ACTIONS(1909),
    [anon_sym_const] = ACTIONS(1909),
    [anon_sym_constexpr] = ACTIONS(1909),
    [anon_sym_volatile] = ACTIONS(1909),
    [anon_sym_restrict] = ACTIONS(1909),
    [anon_sym___restrict__] = ACTIONS(1909),
    [anon_sym__Atomic] = ACTIONS(1909),
    [anon_sym__Noreturn] = ACTIONS(1909),
    [anon_sym_noreturn] = ACTIONS(1909),
    [anon_sym__Nonnull] = ACTIONS(1909),
    [anon_sym_mutable] = ACTIONS(1909),
    [anon_sym_constinit] = ACTIONS(1909),
    [anon_sym_consteval] = ACTIONS(1909),
    [anon_sym_alignas] = ACTIONS(1909),
    [anon_sym__Alignas] = ACTIONS(1909),
    [sym_primitive_type] = ACTIONS(1909),
    [anon_sym_enum] = ACTIONS(1909),
    [anon_sym_class] = ACTIONS(1909),
    [anon_sym_struct] = ACTIONS(1909),
    [anon_sym_union] = ACTIONS(1909),
    [anon_sym_if] = ACTIONS(1909),
    [anon_sym_else] = ACTIONS(1909),
    [anon_sym_switch] = ACTIONS(1909),
    [anon_sym_while] = ACTIONS(1909),
    [anon_sym_do] = ACTIONS(1909),
    [anon_sym_for] = ACTIONS(1909),
    [anon_sym_return] = ACTIONS(1909),
    [anon_sym_break] = ACTIONS(1909),
    [anon_sym_continue] = ACTIONS(1909),
    [anon_sym_goto] = ACTIONS(1909),
    [anon_sym___try] = ACTIONS(1909),
    [anon_sym___leave] = ACTIONS(1909),
    [anon_sym_not] = ACTIONS(1909),
    [anon_sym_compl] = ACTIONS(1909),
    [anon_sym_DASH_DASH] = ACTIONS(1907),
    [anon_sym_PLUS_PLUS] = ACTIONS(1907),
    [anon_sym_sizeof] = ACTIONS(1909),
    [anon_sym___alignof__] = ACTIONS(1909),
    [anon_sym___alignof] = ACTIONS(1909),
    [anon_sym__alignof] = ACTIONS(1909),
    [anon_sym_alignof] = ACTIONS(1909),
    [anon_sym__Alignof] = ACTIONS(1909),
    [anon_sym_offsetof] = ACTIONS(1909),
    [anon_sym__Generic] = ACTIONS(1909),
    [anon_sym_asm] = ACTIONS(1909),
    [anon_sym___asm__] = ACTIONS(1909),
    [anon_sym___asm] = ACTIONS(1909),
    [sym_number_literal] = ACTIONS(1907),
    [anon_sym_L_SQUOTE] = ACTIONS(1907),
    [anon_sym_u_SQUOTE] = ACTIONS(1907),
    [anon_sym_U_SQUOTE] = ACTIONS(1907),
    [anon_sym_u8_SQUOTE] = ACTIONS(1907),
    [anon_sym_SQUOTE] = ACTIONS(1907),
    [anon_sym_L_DQUOTE] = ACTIONS(1907),
    [anon_sym_u_DQUOTE] = ACTIONS(1907),
    [anon_sym_U_DQUOTE] = ACTIONS(1907),
    [anon_sym_u8_DQUOTE] = ACTIONS(1907),
    [anon_sym_DQUOTE] = ACTIONS(1907),
    [sym_true] = ACTIONS(1909),
    [sym_false] = ACTIONS(1909),
    [anon_sym_NULL] = ACTIONS(1909),
    [anon_sym_nullptr] = ACTIONS(1909),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1909),
    [anon_sym_decltype] = ACTIONS(1909),
    [anon_sym_typename] = ACTIONS(1909),
    [anon_sym_template] = ACTIONS(1909),
    [anon_sym_try] = ACTIONS(1909),
    [anon_sym_delete] = ACTIONS(1909),
    [anon_sym_throw] = ACTIONS(1909),
    [anon_sym_co_return] = ACTIONS(1909),
    [anon_sym_co_yield] = ACTIONS(1909),
    [anon_sym_catch] = ACTIONS(1909),
    [anon_sym_R_DQUOTE] = ACTIONS(1907),
    [anon_sym_LR_DQUOTE] = ACTIONS(1907),
    [anon_sym_uR_DQUOTE] = ACTIONS(1907),
    [anon_sym_UR_DQUOTE] = ACTIONS(1907),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1907),
    [anon_sym_co_await] = ACTIONS(1909),
    [anon_sym_new] = ACTIONS(1909),
    [anon_sym_requires] = ACTIONS(1909),
    [sym_this] = ACTIONS(1909),
  },
  [842] = {
    [sym_else_clause] = STATE(852),
    [sym_identifier] = ACTIONS(2573),
    [anon_sym_LPAREN2] = ACTIONS(2575),
    [anon_sym_BANG] = ACTIONS(2575),
    [anon_sym_TILDE] = ACTIONS(2575),
    [anon_sym_DASH] = ACTIONS(2573),
    [anon_sym_PLUS] = ACTIONS(2573),
    [anon_sym_STAR] = ACTIONS(2575),
    [anon_sym_AMP] = ACTIONS(2575),
    [anon_sym_SEMI] = ACTIONS(2575),
    [anon_sym___extension__] = ACTIONS(2573),
    [anon_sym_typedef] = ACTIONS(2573),
    [anon_sym_virtual] = ACTIONS(2573),
    [anon_sym_extern] = ACTIONS(2573),
    [anon_sym___attribute__] = ACTIONS(2573),
    [anon_sym___attribute] = ACTIONS(2573),
    [anon_sym_COLON_COLON] = ACTIONS(2575),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2575),
    [anon_sym___declspec] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_signed] = ACTIONS(2573),
    [anon_sym_unsigned] = ACTIONS(2573),
    [anon_sym_long] = ACTIONS(2573),
    [anon_sym_short] = ACTIONS(2573),
    [anon_sym_LBRACK] = ACTIONS(2573),
    [anon_sym_static] = ACTIONS(2573),
    [anon_sym_register] = ACTIONS(2573),
    [anon_sym_inline] = ACTIONS(2573),
    [anon_sym___inline] = ACTIONS(2573),
    [anon_sym___inline__] = ACTIONS(2573),
    [anon_sym___forceinline] = ACTIONS(2573),
    [anon_sym_thread_local] = ACTIONS(2573),
    [anon_sym___thread] = ACTIONS(2573),
    [anon_sym_const] = ACTIONS(2573),
    [anon_sym_constexpr] = ACTIONS(2573),
    [anon_sym_volatile] = ACTIONS(2573),
    [anon_sym_restrict] = ACTIONS(2573),
    [anon_sym___restrict__] = ACTIONS(2573),
    [anon_sym__Atomic] = ACTIONS(2573),
    [anon_sym__Noreturn] = ACTIONS(2573),
    [anon_sym_noreturn] = ACTIONS(2573),
    [anon_sym__Nonnull] = ACTIONS(2573),
    [anon_sym_mutable] = ACTIONS(2573),
    [anon_sym_constinit] = ACTIONS(2573),
    [anon_sym_consteval] = ACTIONS(2573),
    [anon_sym_alignas] = ACTIONS(2573),
    [anon_sym__Alignas] = ACTIONS(2573),
    [sym_primitive_type] = ACTIONS(2573),
    [anon_sym_enum] = ACTIONS(2573),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_struct] = ACTIONS(2573),
    [anon_sym_union] = ACTIONS(2573),
    [anon_sym_if] = ACTIONS(2573),
    [anon_sym_else] = ACTIONS(4151),
    [anon_sym_switch] = ACTIONS(2573),
    [anon_sym_while] = ACTIONS(2573),
    [anon_sym_do] = ACTIONS(2573),
    [anon_sym_for] = ACTIONS(2573),
    [anon_sym_return] = ACTIONS(2573),
    [anon_sym_break] = ACTIONS(2573),
    [anon_sym_continue] = ACTIONS(2573),
    [anon_sym_goto] = ACTIONS(2573),
    [anon_sym___try] = ACTIONS(2573),
    [anon_sym___leave] = ACTIONS(2573),
    [anon_sym_not] = ACTIONS(2573),
    [anon_sym_compl] = ACTIONS(2573),
    [anon_sym_DASH_DASH] = ACTIONS(2575),
    [anon_sym_PLUS_PLUS] = ACTIONS(2575),
    [anon_sym_sizeof] = ACTIONS(2573),
    [anon_sym___alignof__] = ACTIONS(2573),
    [anon_sym___alignof] = ACTIONS(2573),
    [anon_sym__alignof] = ACTIONS(2573),
    [anon_sym_alignof] = ACTIONS(2573),
    [anon_sym__Alignof] = ACTIONS(2573),
    [anon_sym_offsetof] = ACTIONS(2573),
    [anon_sym__Generic] = ACTIONS(2573),
    [anon_sym_asm] = ACTIONS(2573),
    [anon_sym___asm__] = ACTIONS(2573),
    [anon_sym___asm] = ACTIONS(2573),
    [sym_number_literal] = ACTIONS(2575),
    [anon_sym_L_SQUOTE] = ACTIONS(2575),
    [anon_sym_u_SQUOTE] = ACTIONS(2575),
    [anon_sym_U_SQUOTE] = ACTIONS(2575),
    [anon_sym_u8_SQUOTE] = ACTIONS(2575),
    [anon_sym_SQUOTE] = ACTIONS(2575),
    [anon_sym_L_DQUOTE] = ACTIONS(2575),
    [anon_sym_u_DQUOTE] = ACTIONS(2575),
    [anon_sym_U_DQUOTE] = ACTIONS(2575),
    [anon_sym_u8_DQUOTE] = ACTIONS(2575),
    [anon_sym_DQUOTE] = ACTIONS(2575),
    [sym_true] = ACTIONS(2573),
    [sym_false] = ACTIONS(2573),
    [anon_sym_NULL] = ACTIONS(2573),
    [anon_sym_nullptr] = ACTIONS(2573),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2573),
    [anon_sym_decltype] = ACTIONS(2573),
    [anon_sym_typename] = ACTIONS(2573),
    [anon_sym_template] = ACTIONS(2573),
    [anon_sym_try] = ACTIONS(2573),
    [anon_sym_delete] = ACTIONS(2573),
    [anon_sym_throw] = ACTIONS(2573),
    [anon_sym_co_return] = ACTIONS(2573),
    [anon_sym_co_yield] = ACTIONS(2573),
    [anon_sym_R_DQUOTE] = ACTIONS(2575),
    [anon_sym_LR_DQUOTE] = ACTIONS(2575),
    [anon_sym_uR_DQUOTE] = ACTIONS(2575),
    [anon_sym_UR_DQUOTE] = ACTIONS(2575),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2575),
    [anon_sym_co_await] = ACTIONS(2573),
    [anon_sym_new] = ACTIONS(2573),
    [anon_sym_requires] = ACTIONS(2573),
    [sym_this] = ACTIONS(2573),
  },
  [843] = {
    [sym_identifier] = ACTIONS(2563),
    [anon_sym_LPAREN2] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2565),
    [anon_sym_TILDE] = ACTIONS(2565),
    [anon_sym_DASH] = ACTIONS(2563),
    [anon_sym_PLUS] = ACTIONS(2563),
    [anon_sym_STAR] = ACTIONS(2565),
    [anon_sym_AMP] = ACTIONS(2565),
    [anon_sym_SEMI] = ACTIONS(2565),
    [anon_sym___extension__] = ACTIONS(2563),
    [anon_sym_typedef] = ACTIONS(2563),
    [anon_sym_virtual] = ACTIONS(2563),
    [anon_sym_extern] = ACTIONS(2563),
    [anon_sym___attribute__] = ACTIONS(2563),
    [anon_sym___attribute] = ACTIONS(2563),
    [anon_sym_COLON_COLON] = ACTIONS(2565),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2565),
    [anon_sym___declspec] = ACTIONS(2563),
    [anon_sym_LBRACE] = ACTIONS(2565),
    [anon_sym_signed] = ACTIONS(2563),
    [anon_sym_unsigned] = ACTIONS(2563),
    [anon_sym_long] = ACTIONS(2563),
    [anon_sym_short] = ACTIONS(2563),
    [anon_sym_LBRACK] = ACTIONS(2563),
    [anon_sym_static] = ACTIONS(2563),
    [anon_sym_register] = ACTIONS(2563),
    [anon_sym_inline] = ACTIONS(2563),
    [anon_sym___inline] = ACTIONS(2563),
    [anon_sym___inline__] = ACTIONS(2563),
    [anon_sym___forceinline] = ACTIONS(2563),
    [anon_sym_thread_local] = ACTIONS(2563),
    [anon_sym___thread] = ACTIONS(2563),
    [anon_sym_const] = ACTIONS(2563),
    [anon_sym_constexpr] = ACTIONS(2563),
    [anon_sym_volatile] = ACTIONS(2563),
    [anon_sym_restrict] = ACTIONS(2563),
    [anon_sym___restrict__] = ACTIONS(2563),
    [anon_sym__Atomic] = ACTIONS(2563),
    [anon_sym__Noreturn] = ACTIONS(2563),
    [anon_sym_noreturn] = ACTIONS(2563),
    [anon_sym__Nonnull] = ACTIONS(2563),
    [anon_sym_mutable] = ACTIONS(2563),
    [anon_sym_constinit] = ACTIONS(2563),
    [anon_sym_consteval] = ACTIONS(2563),
    [anon_sym_alignas] = ACTIONS(2563),
    [anon_sym__Alignas] = ACTIONS(2563),
    [sym_primitive_type] = ACTIONS(2563),
    [anon_sym_enum] = ACTIONS(2563),
    [anon_sym_class] = ACTIONS(2563),
    [anon_sym_struct] = ACTIONS(2563),
    [anon_sym_union] = ACTIONS(2563),
    [anon_sym_if] = ACTIONS(2563),
    [anon_sym_else] = ACTIONS(2563),
    [anon_sym_switch] = ACTIONS(2563),
    [anon_sym_while] = ACTIONS(2563),
    [anon_sym_do] = ACTIONS(2563),
    [anon_sym_for] = ACTIONS(2563),
    [anon_sym_return] = ACTIONS(2563),
    [anon_sym_break] = ACTIONS(2563),
    [anon_sym_continue] = ACTIONS(2563),
    [anon_sym_goto] = ACTIONS(2563),
    [anon_sym___try] = ACTIONS(2563),
    [anon_sym___leave] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2563),
    [anon_sym_compl] = ACTIONS(2563),
    [anon_sym_DASH_DASH] = ACTIONS(2565),
    [anon_sym_PLUS_PLUS] = ACTIONS(2565),
    [anon_sym_sizeof] = ACTIONS(2563),
    [anon_sym___alignof__] = ACTIONS(2563),
    [anon_sym___alignof] = ACTIONS(2563),
    [anon_sym__alignof] = ACTIONS(2563),
    [anon_sym_alignof] = ACTIONS(2563),
    [anon_sym__Alignof] = ACTIONS(2563),
    [anon_sym_offsetof] = ACTIONS(2563),
    [anon_sym__Generic] = ACTIONS(2563),
    [anon_sym_asm] = ACTIONS(2563),
    [anon_sym___asm__] = ACTIONS(2563),
    [anon_sym___asm] = ACTIONS(2563),
    [sym_number_literal] = ACTIONS(2565),
    [anon_sym_L_SQUOTE] = ACTIONS(2565),
    [anon_sym_u_SQUOTE] = ACTIONS(2565),
    [anon_sym_U_SQUOTE] = ACTIONS(2565),
    [anon_sym_u8_SQUOTE] = ACTIONS(2565),
    [anon_sym_SQUOTE] = ACTIONS(2565),
    [anon_sym_L_DQUOTE] = ACTIONS(2565),
    [anon_sym_u_DQUOTE] = ACTIONS(2565),
    [anon_sym_U_DQUOTE] = ACTIONS(2565),
    [anon_sym_u8_DQUOTE] = ACTIONS(2565),
    [anon_sym_DQUOTE] = ACTIONS(2565),
    [sym_true] = ACTIONS(2563),
    [sym_false] = ACTIONS(2563),
    [anon_sym_NULL] = ACTIONS(2563),
    [anon_sym_nullptr] = ACTIONS(2563),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2563),
    [anon_sym_decltype] = ACTIONS(2563),
    [anon_sym_typename] = ACTIONS(2563),
    [anon_sym_template] = ACTIONS(2563),
    [anon_sym_try] = ACTIONS(2563),
    [anon_sym_delete] = ACTIONS(2563),
    [anon_sym_throw] = ACTIONS(2563),
    [anon_sym_co_return] = ACTIONS(2563),
    [anon_sym_co_yield] = ACTIONS(2563),
    [anon_sym_catch] = ACTIONS(2563),
    [anon_sym_R_DQUOTE] = ACTIONS(2565),
    [anon_sym_LR_DQUOTE] = ACTIONS(2565),
    [anon_sym_uR_DQUOTE] = ACTIONS(2565),
    [anon_sym_UR_DQUOTE] = ACTIONS(2565),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2565),
    [anon_sym_co_await] = ACTIONS(2563),
    [anon_sym_new] = ACTIONS(2563),
    [anon_sym_requires] = ACTIONS(2563),
    [sym_this] = ACTIONS(2563),
  },
  [844] = {
    [sym_else_clause] = STATE(848),
    [sym_identifier] = ACTIONS(2567),
    [anon_sym_LPAREN2] = ACTIONS(2569),
    [anon_sym_BANG] = ACTIONS(2569),
    [anon_sym_TILDE] = ACTIONS(2569),
    [anon_sym_DASH] = ACTIONS(2567),
    [anon_sym_PLUS] = ACTIONS(2567),
    [anon_sym_STAR] = ACTIONS(2569),
    [anon_sym_AMP] = ACTIONS(2569),
    [anon_sym_SEMI] = ACTIONS(2569),
    [anon_sym___extension__] = ACTIONS(2567),
    [anon_sym_typedef] = ACTIONS(2567),
    [anon_sym_virtual] = ACTIONS(2567),
    [anon_sym_extern] = ACTIONS(2567),
    [anon_sym___attribute__] = ACTIONS(2567),
    [anon_sym___attribute] = ACTIONS(2567),
    [anon_sym_COLON_COLON] = ACTIONS(2569),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2569),
    [anon_sym___declspec] = ACTIONS(2567),
    [anon_sym_LBRACE] = ACTIONS(2569),
    [anon_sym_signed] = ACTIONS(2567),
    [anon_sym_unsigned] = ACTIONS(2567),
    [anon_sym_long] = ACTIONS(2567),
    [anon_sym_short] = ACTIONS(2567),
    [anon_sym_LBRACK] = ACTIONS(2567),
    [anon_sym_static] = ACTIONS(2567),
    [anon_sym_register] = ACTIONS(2567),
    [anon_sym_inline] = ACTIONS(2567),
    [anon_sym___inline] = ACTIONS(2567),
    [anon_sym___inline__] = ACTIONS(2567),
    [anon_sym___forceinline] = ACTIONS(2567),
    [anon_sym_thread_local] = ACTIONS(2567),
    [anon_sym___thread] = ACTIONS(2567),
    [anon_sym_const] = ACTIONS(2567),
    [anon_sym_constexpr] = ACTIONS(2567),
    [anon_sym_volatile] = ACTIONS(2567),
    [anon_sym_restrict] = ACTIONS(2567),
    [anon_sym___restrict__] = ACTIONS(2567),
    [anon_sym__Atomic] = ACTIONS(2567),
    [anon_sym__Noreturn] = ACTIONS(2567),
    [anon_sym_noreturn] = ACTIONS(2567),
    [anon_sym__Nonnull] = ACTIONS(2567),
    [anon_sym_mutable] = ACTIONS(2567),
    [anon_sym_constinit] = ACTIONS(2567),
    [anon_sym_consteval] = ACTIONS(2567),
    [anon_sym_alignas] = ACTIONS(2567),
    [anon_sym__Alignas] = ACTIONS(2567),
    [sym_primitive_type] = ACTIONS(2567),
    [anon_sym_enum] = ACTIONS(2567),
    [anon_sym_class] = ACTIONS(2567),
    [anon_sym_struct] = ACTIONS(2567),
    [anon_sym_union] = ACTIONS(2567),
    [anon_sym_if] = ACTIONS(2567),
    [anon_sym_else] = ACTIONS(4151),
    [anon_sym_switch] = ACTIONS(2567),
    [anon_sym_while] = ACTIONS(2567),
    [anon_sym_do] = ACTIONS(2567),
    [anon_sym_for] = ACTIONS(2567),
    [anon_sym_return] = ACTIONS(2567),
    [anon_sym_break] = ACTIONS(2567),
    [anon_sym_continue] = ACTIONS(2567),
    [anon_sym_goto] = ACTIONS(2567),
    [anon_sym___try] = ACTIONS(2567),
    [anon_sym___leave] = ACTIONS(2567),
    [anon_sym_not] = ACTIONS(2567),
    [anon_sym_compl] = ACTIONS(2567),
    [anon_sym_DASH_DASH] = ACTIONS(2569),
    [anon_sym_PLUS_PLUS] = ACTIONS(2569),
    [anon_sym_sizeof] = ACTIONS(2567),
    [anon_sym___alignof__] = ACTIONS(2567),
    [anon_sym___alignof] = ACTIONS(2567),
    [anon_sym__alignof] = ACTIONS(2567),
    [anon_sym_alignof] = ACTIONS(2567),
    [anon_sym__Alignof] = ACTIONS(2567),
    [anon_sym_offsetof] = ACTIONS(2567),
    [anon_sym__Generic] = ACTIONS(2567),
    [anon_sym_asm] = ACTIONS(2567),
    [anon_sym___asm__] = ACTIONS(2567),
    [anon_sym___asm] = ACTIONS(2567),
    [sym_number_literal] = ACTIONS(2569),
    [anon_sym_L_SQUOTE] = ACTIONS(2569),
    [anon_sym_u_SQUOTE] = ACTIONS(2569),
    [anon_sym_U_SQUOTE] = ACTIONS(2569),
    [anon_sym_u8_SQUOTE] = ACTIONS(2569),
    [anon_sym_SQUOTE] = ACTIONS(2569),
    [anon_sym_L_DQUOTE] = ACTIONS(2569),
    [anon_sym_u_DQUOTE] = ACTIONS(2569),
    [anon_sym_U_DQUOTE] = ACTIONS(2569),
    [anon_sym_u8_DQUOTE] = ACTIONS(2569),
    [anon_sym_DQUOTE] = ACTIONS(2569),
    [sym_true] = ACTIONS(2567),
    [sym_false] = ACTIONS(2567),
    [anon_sym_NULL] = ACTIONS(2567),
    [anon_sym_nullptr] = ACTIONS(2567),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2567),
    [anon_sym_decltype] = ACTIONS(2567),
    [anon_sym_typename] = ACTIONS(2567),
    [anon_sym_template] = ACTIONS(2567),
    [anon_sym_try] = ACTIONS(2567),
    [anon_sym_delete] = ACTIONS(2567),
    [anon_sym_throw] = ACTIONS(2567),
    [anon_sym_co_return] = ACTIONS(2567),
    [anon_sym_co_yield] = ACTIONS(2567),
    [anon_sym_R_DQUOTE] = ACTIONS(2569),
    [anon_sym_LR_DQUOTE] = ACTIONS(2569),
    [anon_sym_uR_DQUOTE] = ACTIONS(2569),
    [anon_sym_UR_DQUOTE] = ACTIONS(2569),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2569),
    [anon_sym_co_await] = ACTIONS(2567),
    [anon_sym_new] = ACTIONS(2567),
    [anon_sym_requires] = ACTIONS(2567),
    [sym_this] = ACTIONS(2567),
  },
  [845] = {
    [sym_identifier] = ACTIONS(1913),
    [anon_sym_LPAREN2] = ACTIONS(1911),
    [anon_sym_BANG] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_DASH] = ACTIONS(1913),
    [anon_sym_PLUS] = ACTIONS(1913),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1911),
    [anon_sym_SEMI] = ACTIONS(1911),
    [anon_sym___extension__] = ACTIONS(1913),
    [anon_sym_typedef] = ACTIONS(1913),
    [anon_sym_virtual] = ACTIONS(1913),
    [anon_sym_extern] = ACTIONS(1913),
    [anon_sym___attribute__] = ACTIONS(1913),
    [anon_sym___attribute] = ACTIONS(1913),
    [anon_sym_COLON_COLON] = ACTIONS(1911),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1911),
    [anon_sym___declspec] = ACTIONS(1913),
    [anon_sym_LBRACE] = ACTIONS(1911),
    [anon_sym_signed] = ACTIONS(1913),
    [anon_sym_unsigned] = ACTIONS(1913),
    [anon_sym_long] = ACTIONS(1913),
    [anon_sym_short] = ACTIONS(1913),
    [anon_sym_LBRACK] = ACTIONS(1913),
    [anon_sym_static] = ACTIONS(1913),
    [anon_sym_register] = ACTIONS(1913),
    [anon_sym_inline] = ACTIONS(1913),
    [anon_sym___inline] = ACTIONS(1913),
    [anon_sym___inline__] = ACTIONS(1913),
    [anon_sym___forceinline] = ACTIONS(1913),
    [anon_sym_thread_local] = ACTIONS(1913),
    [anon_sym___thread] = ACTIONS(1913),
    [anon_sym_const] = ACTIONS(1913),
    [anon_sym_constexpr] = ACTIONS(1913),
    [anon_sym_volatile] = ACTIONS(1913),
    [anon_sym_restrict] = ACTIONS(1913),
    [anon_sym___restrict__] = ACTIONS(1913),
    [anon_sym__Atomic] = ACTIONS(1913),
    [anon_sym__Noreturn] = ACTIONS(1913),
    [anon_sym_noreturn] = ACTIONS(1913),
    [anon_sym__Nonnull] = ACTIONS(1913),
    [anon_sym_mutable] = ACTIONS(1913),
    [anon_sym_constinit] = ACTIONS(1913),
    [anon_sym_consteval] = ACTIONS(1913),
    [anon_sym_alignas] = ACTIONS(1913),
    [anon_sym__Alignas] = ACTIONS(1913),
    [sym_primitive_type] = ACTIONS(1913),
    [anon_sym_enum] = ACTIONS(1913),
    [anon_sym_class] = ACTIONS(1913),
    [anon_sym_struct] = ACTIONS(1913),
    [anon_sym_union] = ACTIONS(1913),
    [anon_sym_if] = ACTIONS(1913),
    [anon_sym_else] = ACTIONS(1913),
    [anon_sym_switch] = ACTIONS(1913),
    [anon_sym_while] = ACTIONS(1913),
    [anon_sym_do] = ACTIONS(1913),
    [anon_sym_for] = ACTIONS(1913),
    [anon_sym_return] = ACTIONS(1913),
    [anon_sym_break] = ACTIONS(1913),
    [anon_sym_continue] = ACTIONS(1913),
    [anon_sym_goto] = ACTIONS(1913),
    [anon_sym___try] = ACTIONS(1913),
    [anon_sym___leave] = ACTIONS(1913),
    [anon_sym_not] = ACTIONS(1913),
    [anon_sym_compl] = ACTIONS(1913),
    [anon_sym_DASH_DASH] = ACTIONS(1911),
    [anon_sym_PLUS_PLUS] = ACTIONS(1911),
    [anon_sym_sizeof] = ACTIONS(1913),
    [anon_sym___alignof__] = ACTIONS(1913),
    [anon_sym___alignof] = ACTIONS(1913),
    [anon_sym__alignof] = ACTIONS(1913),
    [anon_sym_alignof] = ACTIONS(1913),
    [anon_sym__Alignof] = ACTIONS(1913),
    [anon_sym_offsetof] = ACTIONS(1913),
    [anon_sym__Generic] = ACTIONS(1913),
    [anon_sym_asm] = ACTIONS(1913),
    [anon_sym___asm__] = ACTIONS(1913),
    [anon_sym___asm] = ACTIONS(1913),
    [sym_number_literal] = ACTIONS(1911),
    [anon_sym_L_SQUOTE] = ACTIONS(1911),
    [anon_sym_u_SQUOTE] = ACTIONS(1911),
    [anon_sym_U_SQUOTE] = ACTIONS(1911),
    [anon_sym_u8_SQUOTE] = ACTIONS(1911),
    [anon_sym_SQUOTE] = ACTIONS(1911),
    [anon_sym_L_DQUOTE] = ACTIONS(1911),
    [anon_sym_u_DQUOTE] = ACTIONS(1911),
    [anon_sym_U_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8_DQUOTE] = ACTIONS(1911),
    [anon_sym_DQUOTE] = ACTIONS(1911),
    [sym_true] = ACTIONS(1913),
    [sym_false] = ACTIONS(1913),
    [anon_sym_NULL] = ACTIONS(1913),
    [anon_sym_nullptr] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1913),
    [anon_sym_decltype] = ACTIONS(1913),
    [anon_sym_typename] = ACTIONS(1913),
    [anon_sym_template] = ACTIONS(1913),
    [anon_sym_try] = ACTIONS(1913),
    [anon_sym_delete] = ACTIONS(1913),
    [anon_sym_throw] = ACTIONS(1913),
    [anon_sym_co_return] = ACTIONS(1913),
    [anon_sym_co_yield] = ACTIONS(1913),
    [anon_sym_catch] = ACTIONS(1913),
    [anon_sym_R_DQUOTE] = ACTIONS(1911),
    [anon_sym_LR_DQUOTE] = ACTIONS(1911),
    [anon_sym_uR_DQUOTE] = ACTIONS(1911),
    [anon_sym_UR_DQUOTE] = ACTIONS(1911),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1911),
    [anon_sym_co_await] = ACTIONS(1913),
    [anon_sym_new] = ACTIONS(1913),
    [anon_sym_requires] = ACTIONS(1913),
    [sym_this] = ACTIONS(1913),
  },
  [846] = {
    [sym_identifier] = ACTIONS(2609),
    [anon_sym_LPAREN2] = ACTIONS(2611),
    [anon_sym_BANG] = ACTIONS(2611),
    [anon_sym_TILDE] = ACTIONS(2611),
    [anon_sym_DASH] = ACTIONS(2609),
    [anon_sym_PLUS] = ACTIONS(2609),
    [anon_sym_STAR] = ACTIONS(2611),
    [anon_sym_AMP] = ACTIONS(2611),
    [anon_sym_SEMI] = ACTIONS(2611),
    [anon_sym___extension__] = ACTIONS(2609),
    [anon_sym_typedef] = ACTIONS(2609),
    [anon_sym_virtual] = ACTIONS(2609),
    [anon_sym_extern] = ACTIONS(2609),
    [anon_sym___attribute__] = ACTIONS(2609),
    [anon_sym___attribute] = ACTIONS(2609),
    [anon_sym_COLON_COLON] = ACTIONS(2611),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2611),
    [anon_sym___declspec] = ACTIONS(2609),
    [anon_sym_LBRACE] = ACTIONS(2611),
    [anon_sym_signed] = ACTIONS(2609),
    [anon_sym_unsigned] = ACTIONS(2609),
    [anon_sym_long] = ACTIONS(2609),
    [anon_sym_short] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(2609),
    [anon_sym_static] = ACTIONS(2609),
    [anon_sym_register] = ACTIONS(2609),
    [anon_sym_inline] = ACTIONS(2609),
    [anon_sym___inline] = ACTIONS(2609),
    [anon_sym___inline__] = ACTIONS(2609),
    [anon_sym___forceinline] = ACTIONS(2609),
    [anon_sym_thread_local] = ACTIONS(2609),
    [anon_sym___thread] = ACTIONS(2609),
    [anon_sym_const] = ACTIONS(2609),
    [anon_sym_constexpr] = ACTIONS(2609),
    [anon_sym_volatile] = ACTIONS(2609),
    [anon_sym_restrict] = ACTIONS(2609),
    [anon_sym___restrict__] = ACTIONS(2609),
    [anon_sym__Atomic] = ACTIONS(2609),
    [anon_sym__Noreturn] = ACTIONS(2609),
    [anon_sym_noreturn] = ACTIONS(2609),
    [anon_sym__Nonnull] = ACTIONS(2609),
    [anon_sym_mutable] = ACTIONS(2609),
    [anon_sym_constinit] = ACTIONS(2609),
    [anon_sym_consteval] = ACTIONS(2609),
    [anon_sym_alignas] = ACTIONS(2609),
    [anon_sym__Alignas] = ACTIONS(2609),
    [sym_primitive_type] = ACTIONS(2609),
    [anon_sym_enum] = ACTIONS(2609),
    [anon_sym_class] = ACTIONS(2609),
    [anon_sym_struct] = ACTIONS(2609),
    [anon_sym_union] = ACTIONS(2609),
    [anon_sym_if] = ACTIONS(2609),
    [anon_sym_else] = ACTIONS(2609),
    [anon_sym_switch] = ACTIONS(2609),
    [anon_sym_while] = ACTIONS(2609),
    [anon_sym_do] = ACTIONS(2609),
    [anon_sym_for] = ACTIONS(2609),
    [anon_sym_return] = ACTIONS(2609),
    [anon_sym_break] = ACTIONS(2609),
    [anon_sym_continue] = ACTIONS(2609),
    [anon_sym_goto] = ACTIONS(2609),
    [anon_sym___try] = ACTIONS(2609),
    [anon_sym___leave] = ACTIONS(2609),
    [anon_sym_not] = ACTIONS(2609),
    [anon_sym_compl] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(2611),
    [anon_sym_PLUS_PLUS] = ACTIONS(2611),
    [anon_sym_sizeof] = ACTIONS(2609),
    [anon_sym___alignof__] = ACTIONS(2609),
    [anon_sym___alignof] = ACTIONS(2609),
    [anon_sym__alignof] = ACTIONS(2609),
    [anon_sym_alignof] = ACTIONS(2609),
    [anon_sym__Alignof] = ACTIONS(2609),
    [anon_sym_offsetof] = ACTIONS(2609),
    [anon_sym__Generic] = ACTIONS(2609),
    [anon_sym_asm] = ACTIONS(2609),
    [anon_sym___asm__] = ACTIONS(2609),
    [anon_sym___asm] = ACTIONS(2609),
    [sym_number_literal] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2611),
    [anon_sym_u_SQUOTE] = ACTIONS(2611),
    [anon_sym_U_SQUOTE] = ACTIONS(2611),
    [anon_sym_u8_SQUOTE] = ACTIONS(2611),
    [anon_sym_SQUOTE] = ACTIONS(2611),
    [anon_sym_L_DQUOTE] = ACTIONS(2611),
    [anon_sym_u_DQUOTE] = ACTIONS(2611),
    [anon_sym_U_DQUOTE] = ACTIONS(2611),
    [anon_sym_u8_DQUOTE] = ACTIONS(2611),
    [anon_sym_DQUOTE] = ACTIONS(2611),
    [sym_true] = ACTIONS(2609),
    [sym_false] = ACTIONS(2609),
    [anon_sym_NULL] = ACTIONS(2609),
    [anon_sym_nullptr] = ACTIONS(2609),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2609),
    [anon_sym_decltype] = ACTIONS(2609),
    [anon_sym_typename] = ACTIONS(2609),
    [anon_sym_template] = ACTIONS(2609),
    [anon_sym_try] = ACTIONS(2609),
    [anon_sym_delete] = ACTIONS(2609),
    [anon_sym_throw] = ACTIONS(2609),
    [anon_sym_co_return] = ACTIONS(2609),
    [anon_sym_co_yield] = ACTIONS(2609),
    [anon_sym_R_DQUOTE] = ACTIONS(2611),
    [anon_sym_LR_DQUOTE] = ACTIONS(2611),
    [anon_sym_uR_DQUOTE] = ACTIONS(2611),
    [anon_sym_UR_DQUOTE] = ACTIONS(2611),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2611),
    [anon_sym_co_await] = ACTIONS(2609),
    [anon_sym_new] = ACTIONS(2609),
    [anon_sym_requires] = ACTIONS(2609),
    [sym_this] = ACTIONS(2609),
  },
  [847] = {
    [sym_identifier] = ACTIONS(2649),
    [anon_sym_LPAREN2] = ACTIONS(2651),
    [anon_sym_BANG] = ACTIONS(2651),
    [anon_sym_TILDE] = ACTIONS(2651),
    [anon_sym_DASH] = ACTIONS(2649),
    [anon_sym_PLUS] = ACTIONS(2649),
    [anon_sym_STAR] = ACTIONS(2651),
    [anon_sym_AMP] = ACTIONS(2651),
    [anon_sym_SEMI] = ACTIONS(2651),
    [anon_sym___extension__] = ACTIONS(2649),
    [anon_sym_typedef] = ACTIONS(2649),
    [anon_sym_virtual] = ACTIONS(2649),
    [anon_sym_extern] = ACTIONS(2649),
    [anon_sym___attribute__] = ACTIONS(2649),
    [anon_sym___attribute] = ACTIONS(2649),
    [anon_sym_COLON_COLON] = ACTIONS(2651),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2651),
    [anon_sym___declspec] = ACTIONS(2649),
    [anon_sym_LBRACE] = ACTIONS(2651),
    [anon_sym_signed] = ACTIONS(2649),
    [anon_sym_unsigned] = ACTIONS(2649),
    [anon_sym_long] = ACTIONS(2649),
    [anon_sym_short] = ACTIONS(2649),
    [anon_sym_LBRACK] = ACTIONS(2649),
    [anon_sym_static] = ACTIONS(2649),
    [anon_sym_register] = ACTIONS(2649),
    [anon_sym_inline] = ACTIONS(2649),
    [anon_sym___inline] = ACTIONS(2649),
    [anon_sym___inline__] = ACTIONS(2649),
    [anon_sym___forceinline] = ACTIONS(2649),
    [anon_sym_thread_local] = ACTIONS(2649),
    [anon_sym___thread] = ACTIONS(2649),
    [anon_sym_const] = ACTIONS(2649),
    [anon_sym_constexpr] = ACTIONS(2649),
    [anon_sym_volatile] = ACTIONS(2649),
    [anon_sym_restrict] = ACTIONS(2649),
    [anon_sym___restrict__] = ACTIONS(2649),
    [anon_sym__Atomic] = ACTIONS(2649),
    [anon_sym__Noreturn] = ACTIONS(2649),
    [anon_sym_noreturn] = ACTIONS(2649),
    [anon_sym__Nonnull] = ACTIONS(2649),
    [anon_sym_mutable] = ACTIONS(2649),
    [anon_sym_constinit] = ACTIONS(2649),
    [anon_sym_consteval] = ACTIONS(2649),
    [anon_sym_alignas] = ACTIONS(2649),
    [anon_sym__Alignas] = ACTIONS(2649),
    [sym_primitive_type] = ACTIONS(2649),
    [anon_sym_enum] = ACTIONS(2649),
    [anon_sym_class] = ACTIONS(2649),
    [anon_sym_struct] = ACTIONS(2649),
    [anon_sym_union] = ACTIONS(2649),
    [anon_sym_if] = ACTIONS(2649),
    [anon_sym_else] = ACTIONS(2649),
    [anon_sym_switch] = ACTIONS(2649),
    [anon_sym_while] = ACTIONS(2649),
    [anon_sym_do] = ACTIONS(2649),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_return] = ACTIONS(2649),
    [anon_sym_break] = ACTIONS(2649),
    [anon_sym_continue] = ACTIONS(2649),
    [anon_sym_goto] = ACTIONS(2649),
    [anon_sym___try] = ACTIONS(2649),
    [anon_sym___leave] = ACTIONS(2649),
    [anon_sym_not] = ACTIONS(2649),
    [anon_sym_compl] = ACTIONS(2649),
    [anon_sym_DASH_DASH] = ACTIONS(2651),
    [anon_sym_PLUS_PLUS] = ACTIONS(2651),
    [anon_sym_sizeof] = ACTIONS(2649),
    [anon_sym___alignof__] = ACTIONS(2649),
    [anon_sym___alignof] = ACTIONS(2649),
    [anon_sym__alignof] = ACTIONS(2649),
    [anon_sym_alignof] = ACTIONS(2649),
    [anon_sym__Alignof] = ACTIONS(2649),
    [anon_sym_offsetof] = ACTIONS(2649),
    [anon_sym__Generic] = ACTIONS(2649),
    [anon_sym_asm] = ACTIONS(2649),
    [anon_sym___asm__] = ACTIONS(2649),
    [anon_sym___asm] = ACTIONS(2649),
    [sym_number_literal] = ACTIONS(2651),
    [anon_sym_L_SQUOTE] = ACTIONS(2651),
    [anon_sym_u_SQUOTE] = ACTIONS(2651),
    [anon_sym_U_SQUOTE] = ACTIONS(2651),
    [anon_sym_u8_SQUOTE] = ACTIONS(2651),
    [anon_sym_SQUOTE] = ACTIONS(2651),
    [anon_sym_L_DQUOTE] = ACTIONS(2651),
    [anon_sym_u_DQUOTE] = ACTIONS(2651),
    [anon_sym_U_DQUOTE] = ACTIONS(2651),
    [anon_sym_u8_DQUOTE] = ACTIONS(2651),
    [anon_sym_DQUOTE] = ACTIONS(2651),
    [sym_true] = ACTIONS(2649),
    [sym_false] = ACTIONS(2649),
    [anon_sym_NULL] = ACTIONS(2649),
    [anon_sym_nullptr] = ACTIONS(2649),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2649),
    [anon_sym_decltype] = ACTIONS(2649),
    [anon_sym_typename] = ACTIONS(2649),
    [anon_sym_template] = ACTIONS(2649),
    [anon_sym_try] = ACTIONS(2649),
    [anon_sym_delete] = ACTIONS(2649),
    [anon_sym_throw] = ACTIONS(2649),
    [anon_sym_co_return] = ACTIONS(2649),
    [anon_sym_co_yield] = ACTIONS(2649),
    [anon_sym_R_DQUOTE] = ACTIONS(2651),
    [anon_sym_LR_DQUOTE] = ACTIONS(2651),
    [anon_sym_uR_DQUOTE] = ACTIONS(2651),
    [anon_sym_UR_DQUOTE] = ACTIONS(2651),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2651),
    [anon_sym_co_await] = ACTIONS(2649),
    [anon_sym_new] = ACTIONS(2649),
    [anon_sym_requires] = ACTIONS(2649),
    [sym_this] = ACTIONS(2649),
  },
  [848] = {
    [sym_identifier] = ACTIONS(2625),
    [anon_sym_LPAREN2] = ACTIONS(2627),
    [anon_sym_BANG] = ACTIONS(2627),
    [anon_sym_TILDE] = ACTIONS(2627),
    [anon_sym_DASH] = ACTIONS(2625),
    [anon_sym_PLUS] = ACTIONS(2625),
    [anon_sym_STAR] = ACTIONS(2627),
    [anon_sym_AMP] = ACTIONS(2627),
    [anon_sym_SEMI] = ACTIONS(2627),
    [anon_sym___extension__] = ACTIONS(2625),
    [anon_sym_typedef] = ACTIONS(2625),
    [anon_sym_virtual] = ACTIONS(2625),
    [anon_sym_extern] = ACTIONS(2625),
    [anon_sym___attribute__] = ACTIONS(2625),
    [anon_sym___attribute] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(2627),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2627),
    [anon_sym___declspec] = ACTIONS(2625),
    [anon_sym_LBRACE] = ACTIONS(2627),
    [anon_sym_signed] = ACTIONS(2625),
    [anon_sym_unsigned] = ACTIONS(2625),
    [anon_sym_long] = ACTIONS(2625),
    [anon_sym_short] = ACTIONS(2625),
    [anon_sym_LBRACK] = ACTIONS(2625),
    [anon_sym_static] = ACTIONS(2625),
    [anon_sym_register] = ACTIONS(2625),
    [anon_sym_inline] = ACTIONS(2625),
    [anon_sym___inline] = ACTIONS(2625),
    [anon_sym___inline__] = ACTIONS(2625),
    [anon_sym___forceinline] = ACTIONS(2625),
    [anon_sym_thread_local] = ACTIONS(2625),
    [anon_sym___thread] = ACTIONS(2625),
    [anon_sym_const] = ACTIONS(2625),
    [anon_sym_constexpr] = ACTIONS(2625),
    [anon_sym_volatile] = ACTIONS(2625),
    [anon_sym_restrict] = ACTIONS(2625),
    [anon_sym___restrict__] = ACTIONS(2625),
    [anon_sym__Atomic] = ACTIONS(2625),
    [anon_sym__Noreturn] = ACTIONS(2625),
    [anon_sym_noreturn] = ACTIONS(2625),
    [anon_sym__Nonnull] = ACTIONS(2625),
    [anon_sym_mutable] = ACTIONS(2625),
    [anon_sym_constinit] = ACTIONS(2625),
    [anon_sym_consteval] = ACTIONS(2625),
    [anon_sym_alignas] = ACTIONS(2625),
    [anon_sym__Alignas] = ACTIONS(2625),
    [sym_primitive_type] = ACTIONS(2625),
    [anon_sym_enum] = ACTIONS(2625),
    [anon_sym_class] = ACTIONS(2625),
    [anon_sym_struct] = ACTIONS(2625),
    [anon_sym_union] = ACTIONS(2625),
    [anon_sym_if] = ACTIONS(2625),
    [anon_sym_else] = ACTIONS(2625),
    [anon_sym_switch] = ACTIONS(2625),
    [anon_sym_while] = ACTIONS(2625),
    [anon_sym_do] = ACTIONS(2625),
    [anon_sym_for] = ACTIONS(2625),
    [anon_sym_return] = ACTIONS(2625),
    [anon_sym_break] = ACTIONS(2625),
    [anon_sym_continue] = ACTIONS(2625),
    [anon_sym_goto] = ACTIONS(2625),
    [anon_sym___try] = ACTIONS(2625),
    [anon_sym___leave] = ACTIONS(2625),
    [anon_sym_not] = ACTIONS(2625),
    [anon_sym_compl] = ACTIONS(2625),
    [anon_sym_DASH_DASH] = ACTIONS(2627),
    [anon_sym_PLUS_PLUS] = ACTIONS(2627),
    [anon_sym_sizeof] = ACTIONS(2625),
    [anon_sym___alignof__] = ACTIONS(2625),
    [anon_sym___alignof] = ACTIONS(2625),
    [anon_sym__alignof] = ACTIONS(2625),
    [anon_sym_alignof] = ACTIONS(2625),
    [anon_sym__Alignof] = ACTIONS(2625),
    [anon_sym_offsetof] = ACTIONS(2625),
    [anon_sym__Generic] = ACTIONS(2625),
    [anon_sym_asm] = ACTIONS(2625),
    [anon_sym___asm__] = ACTIONS(2625),
    [anon_sym___asm] = ACTIONS(2625),
    [sym_number_literal] = ACTIONS(2627),
    [anon_sym_L_SQUOTE] = ACTIONS(2627),
    [anon_sym_u_SQUOTE] = ACTIONS(2627),
    [anon_sym_U_SQUOTE] = ACTIONS(2627),
    [anon_sym_u8_SQUOTE] = ACTIONS(2627),
    [anon_sym_SQUOTE] = ACTIONS(2627),
    [anon_sym_L_DQUOTE] = ACTIONS(2627),
    [anon_sym_u_DQUOTE] = ACTIONS(2627),
    [anon_sym_U_DQUOTE] = ACTIONS(2627),
    [anon_sym_u8_DQUOTE] = ACTIONS(2627),
    [anon_sym_DQUOTE] = ACTIONS(2627),
    [sym_true] = ACTIONS(2625),
    [sym_false] = ACTIONS(2625),
    [anon_sym_NULL] = ACTIONS(2625),
    [anon_sym_nullptr] = ACTIONS(2625),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2625),
    [anon_sym_decltype] = ACTIONS(2625),
    [anon_sym_typename] = ACTIONS(2625),
    [anon_sym_template] = ACTIONS(2625),
    [anon_sym_try] = ACTIONS(2625),
    [anon_sym_delete] = ACTIONS(2625),
    [anon_sym_throw] = ACTIONS(2625),
    [anon_sym_co_return] = ACTIONS(2625),
    [anon_sym_co_yield] = ACTIONS(2625),
    [anon_sym_R_DQUOTE] = ACTIONS(2627),
    [anon_sym_LR_DQUOTE] = ACTIONS(2627),
    [anon_sym_uR_DQUOTE] = ACTIONS(2627),
    [anon_sym_UR_DQUOTE] = ACTIONS(2627),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2627),
    [anon_sym_co_await] = ACTIONS(2625),
    [anon_sym_new] = ACTIONS(2625),
    [anon_sym_requires] = ACTIONS(2625),
    [sym_this] = ACTIONS(2625),
  },
  [849] = {
    [sym_identifier] = ACTIONS(2685),
    [anon_sym_LPAREN2] = ACTIONS(2687),
    [anon_sym_BANG] = ACTIONS(2687),
    [anon_sym_TILDE] = ACTIONS(2687),
    [anon_sym_DASH] = ACTIONS(2685),
    [anon_sym_PLUS] = ACTIONS(2685),
    [anon_sym_STAR] = ACTIONS(2687),
    [anon_sym_AMP] = ACTIONS(2687),
    [anon_sym_SEMI] = ACTIONS(2687),
    [anon_sym___extension__] = ACTIONS(2685),
    [anon_sym_typedef] = ACTIONS(2685),
    [anon_sym_virtual] = ACTIONS(2685),
    [anon_sym_extern] = ACTIONS(2685),
    [anon_sym___attribute__] = ACTIONS(2685),
    [anon_sym___attribute] = ACTIONS(2685),
    [anon_sym_COLON_COLON] = ACTIONS(2687),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2687),
    [anon_sym___declspec] = ACTIONS(2685),
    [anon_sym_LBRACE] = ACTIONS(2687),
    [anon_sym_signed] = ACTIONS(2685),
    [anon_sym_unsigned] = ACTIONS(2685),
    [anon_sym_long] = ACTIONS(2685),
    [anon_sym_short] = ACTIONS(2685),
    [anon_sym_LBRACK] = ACTIONS(2685),
    [anon_sym_static] = ACTIONS(2685),
    [anon_sym_register] = ACTIONS(2685),
    [anon_sym_inline] = ACTIONS(2685),
    [anon_sym___inline] = ACTIONS(2685),
    [anon_sym___inline__] = ACTIONS(2685),
    [anon_sym___forceinline] = ACTIONS(2685),
    [anon_sym_thread_local] = ACTIONS(2685),
    [anon_sym___thread] = ACTIONS(2685),
    [anon_sym_const] = ACTIONS(2685),
    [anon_sym_constexpr] = ACTIONS(2685),
    [anon_sym_volatile] = ACTIONS(2685),
    [anon_sym_restrict] = ACTIONS(2685),
    [anon_sym___restrict__] = ACTIONS(2685),
    [anon_sym__Atomic] = ACTIONS(2685),
    [anon_sym__Noreturn] = ACTIONS(2685),
    [anon_sym_noreturn] = ACTIONS(2685),
    [anon_sym__Nonnull] = ACTIONS(2685),
    [anon_sym_mutable] = ACTIONS(2685),
    [anon_sym_constinit] = ACTIONS(2685),
    [anon_sym_consteval] = ACTIONS(2685),
    [anon_sym_alignas] = ACTIONS(2685),
    [anon_sym__Alignas] = ACTIONS(2685),
    [sym_primitive_type] = ACTIONS(2685),
    [anon_sym_enum] = ACTIONS(2685),
    [anon_sym_class] = ACTIONS(2685),
    [anon_sym_struct] = ACTIONS(2685),
    [anon_sym_union] = ACTIONS(2685),
    [anon_sym_if] = ACTIONS(2685),
    [anon_sym_else] = ACTIONS(2685),
    [anon_sym_switch] = ACTIONS(2685),
    [anon_sym_while] = ACTIONS(2685),
    [anon_sym_do] = ACTIONS(2685),
    [anon_sym_for] = ACTIONS(2685),
    [anon_sym_return] = ACTIONS(2685),
    [anon_sym_break] = ACTIONS(2685),
    [anon_sym_continue] = ACTIONS(2685),
    [anon_sym_goto] = ACTIONS(2685),
    [anon_sym___try] = ACTIONS(2685),
    [anon_sym___leave] = ACTIONS(2685),
    [anon_sym_not] = ACTIONS(2685),
    [anon_sym_compl] = ACTIONS(2685),
    [anon_sym_DASH_DASH] = ACTIONS(2687),
    [anon_sym_PLUS_PLUS] = ACTIONS(2687),
    [anon_sym_sizeof] = ACTIONS(2685),
    [anon_sym___alignof__] = ACTIONS(2685),
    [anon_sym___alignof] = ACTIONS(2685),
    [anon_sym__alignof] = ACTIONS(2685),
    [anon_sym_alignof] = ACTIONS(2685),
    [anon_sym__Alignof] = ACTIONS(2685),
    [anon_sym_offsetof] = ACTIONS(2685),
    [anon_sym__Generic] = ACTIONS(2685),
    [anon_sym_asm] = ACTIONS(2685),
    [anon_sym___asm__] = ACTIONS(2685),
    [anon_sym___asm] = ACTIONS(2685),
    [sym_number_literal] = ACTIONS(2687),
    [anon_sym_L_SQUOTE] = ACTIONS(2687),
    [anon_sym_u_SQUOTE] = ACTIONS(2687),
    [anon_sym_U_SQUOTE] = ACTIONS(2687),
    [anon_sym_u8_SQUOTE] = ACTIONS(2687),
    [anon_sym_SQUOTE] = ACTIONS(2687),
    [anon_sym_L_DQUOTE] = ACTIONS(2687),
    [anon_sym_u_DQUOTE] = ACTIONS(2687),
    [anon_sym_U_DQUOTE] = ACTIONS(2687),
    [anon_sym_u8_DQUOTE] = ACTIONS(2687),
    [anon_sym_DQUOTE] = ACTIONS(2687),
    [sym_true] = ACTIONS(2685),
    [sym_false] = ACTIONS(2685),
    [anon_sym_NULL] = ACTIONS(2685),
    [anon_sym_nullptr] = ACTIONS(2685),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2685),
    [anon_sym_decltype] = ACTIONS(2685),
    [anon_sym_typename] = ACTIONS(2685),
    [anon_sym_template] = ACTIONS(2685),
    [anon_sym_try] = ACTIONS(2685),
    [anon_sym_delete] = ACTIONS(2685),
    [anon_sym_throw] = ACTIONS(2685),
    [anon_sym_co_return] = ACTIONS(2685),
    [anon_sym_co_yield] = ACTIONS(2685),
    [anon_sym_R_DQUOTE] = ACTIONS(2687),
    [anon_sym_LR_DQUOTE] = ACTIONS(2687),
    [anon_sym_uR_DQUOTE] = ACTIONS(2687),
    [anon_sym_UR_DQUOTE] = ACTIONS(2687),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2687),
    [anon_sym_co_await] = ACTIONS(2685),
    [anon_sym_new] = ACTIONS(2685),
    [anon_sym_requires] = ACTIONS(2685),
    [sym_this] = ACTIONS(2685),
  },
  [850] = {
    [sym_identifier] = ACTIONS(2653),
    [anon_sym_LPAREN2] = ACTIONS(2655),
    [anon_sym_BANG] = ACTIONS(2655),
    [anon_sym_TILDE] = ACTIONS(2655),
    [anon_sym_DASH] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(2653),
    [anon_sym_STAR] = ACTIONS(2655),
    [anon_sym_AMP] = ACTIONS(2655),
    [anon_sym_SEMI] = ACTIONS(2655),
    [anon_sym___extension__] = ACTIONS(2653),
    [anon_sym_typedef] = ACTIONS(2653),
    [anon_sym_virtual] = ACTIONS(2653),
    [anon_sym_extern] = ACTIONS(2653),
    [anon_sym___attribute__] = ACTIONS(2653),
    [anon_sym___attribute] = ACTIONS(2653),
    [anon_sym_COLON_COLON] = ACTIONS(2655),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2655),
    [anon_sym___declspec] = ACTIONS(2653),
    [anon_sym_LBRACE] = ACTIONS(2655),
    [anon_sym_signed] = ACTIONS(2653),
    [anon_sym_unsigned] = ACTIONS(2653),
    [anon_sym_long] = ACTIONS(2653),
    [anon_sym_short] = ACTIONS(2653),
    [anon_sym_LBRACK] = ACTIONS(2653),
    [anon_sym_static] = ACTIONS(2653),
    [anon_sym_register] = ACTIONS(2653),
    [anon_sym_inline] = ACTIONS(2653),
    [anon_sym___inline] = ACTIONS(2653),
    [anon_sym___inline__] = ACTIONS(2653),
    [anon_sym___forceinline] = ACTIONS(2653),
    [anon_sym_thread_local] = ACTIONS(2653),
    [anon_sym___thread] = ACTIONS(2653),
    [anon_sym_const] = ACTIONS(2653),
    [anon_sym_constexpr] = ACTIONS(2653),
    [anon_sym_volatile] = ACTIONS(2653),
    [anon_sym_restrict] = ACTIONS(2653),
    [anon_sym___restrict__] = ACTIONS(2653),
    [anon_sym__Atomic] = ACTIONS(2653),
    [anon_sym__Noreturn] = ACTIONS(2653),
    [anon_sym_noreturn] = ACTIONS(2653),
    [anon_sym__Nonnull] = ACTIONS(2653),
    [anon_sym_mutable] = ACTIONS(2653),
    [anon_sym_constinit] = ACTIONS(2653),
    [anon_sym_consteval] = ACTIONS(2653),
    [anon_sym_alignas] = ACTIONS(2653),
    [anon_sym__Alignas] = ACTIONS(2653),
    [sym_primitive_type] = ACTIONS(2653),
    [anon_sym_enum] = ACTIONS(2653),
    [anon_sym_class] = ACTIONS(2653),
    [anon_sym_struct] = ACTIONS(2653),
    [anon_sym_union] = ACTIONS(2653),
    [anon_sym_if] = ACTIONS(2653),
    [anon_sym_else] = ACTIONS(2653),
    [anon_sym_switch] = ACTIONS(2653),
    [anon_sym_while] = ACTIONS(2653),
    [anon_sym_do] = ACTIONS(2653),
    [anon_sym_for] = ACTIONS(2653),
    [anon_sym_return] = ACTIONS(2653),
    [anon_sym_break] = ACTIONS(2653),
    [anon_sym_continue] = ACTIONS(2653),
    [anon_sym_goto] = ACTIONS(2653),
    [anon_sym___try] = ACTIONS(2653),
    [anon_sym___leave] = ACTIONS(2653),
    [anon_sym_not] = ACTIONS(2653),
    [anon_sym_compl] = ACTIONS(2653),
    [anon_sym_DASH_DASH] = ACTIONS(2655),
    [anon_sym_PLUS_PLUS] = ACTIONS(2655),
    [anon_sym_sizeof] = ACTIONS(2653),
    [anon_sym___alignof__] = ACTIONS(2653),
    [anon_sym___alignof] = ACTIONS(2653),
    [anon_sym__alignof] = ACTIONS(2653),
    [anon_sym_alignof] = ACTIONS(2653),
    [anon_sym__Alignof] = ACTIONS(2653),
    [anon_sym_offsetof] = ACTIONS(2653),
    [anon_sym__Generic] = ACTIONS(2653),
    [anon_sym_asm] = ACTIONS(2653),
    [anon_sym___asm__] = ACTIONS(2653),
    [anon_sym___asm] = ACTIONS(2653),
    [sym_number_literal] = ACTIONS(2655),
    [anon_sym_L_SQUOTE] = ACTIONS(2655),
    [anon_sym_u_SQUOTE] = ACTIONS(2655),
    [anon_sym_U_SQUOTE] = ACTIONS(2655),
    [anon_sym_u8_SQUOTE] = ACTIONS(2655),
    [anon_sym_SQUOTE] = ACTIONS(2655),
    [anon_sym_L_DQUOTE] = ACTIONS(2655),
    [anon_sym_u_DQUOTE] = ACTIONS(2655),
    [anon_sym_U_DQUOTE] = ACTIONS(2655),
    [anon_sym_u8_DQUOTE] = ACTIONS(2655),
    [anon_sym_DQUOTE] = ACTIONS(2655),
    [sym_true] = ACTIONS(2653),
    [sym_false] = ACTIONS(2653),
    [anon_sym_NULL] = ACTIONS(2653),
    [anon_sym_nullptr] = ACTIONS(2653),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2653),
    [anon_sym_decltype] = ACTIONS(2653),
    [anon_sym_typename] = ACTIONS(2653),
    [anon_sym_template] = ACTIONS(2653),
    [anon_sym_try] = ACTIONS(2653),
    [anon_sym_delete] = ACTIONS(2653),
    [anon_sym_throw] = ACTIONS(2653),
    [anon_sym_co_return] = ACTIONS(2653),
    [anon_sym_co_yield] = ACTIONS(2653),
    [anon_sym_R_DQUOTE] = ACTIONS(2655),
    [anon_sym_LR_DQUOTE] = ACTIONS(2655),
    [anon_sym_uR_DQUOTE] = ACTIONS(2655),
    [anon_sym_UR_DQUOTE] = ACTIONS(2655),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2655),
    [anon_sym_co_await] = ACTIONS(2653),
    [anon_sym_new] = ACTIONS(2653),
    [anon_sym_requires] = ACTIONS(2653),
    [sym_this] = ACTIONS(2653),
  },
  [851] = {
    [sym_identifier] = ACTIONS(2605),
    [anon_sym_LPAREN2] = ACTIONS(2607),
    [anon_sym_BANG] = ACTIONS(2607),
    [anon_sym_TILDE] = ACTIONS(2607),
    [anon_sym_DASH] = ACTIONS(2605),
    [anon_sym_PLUS] = ACTIONS(2605),
    [anon_sym_STAR] = ACTIONS(2607),
    [anon_sym_AMP] = ACTIONS(2607),
    [anon_sym_SEMI] = ACTIONS(2607),
    [anon_sym___extension__] = ACTIONS(2605),
    [anon_sym_typedef] = ACTIONS(2605),
    [anon_sym_virtual] = ACTIONS(2605),
    [anon_sym_extern] = ACTIONS(2605),
    [anon_sym___attribute__] = ACTIONS(2605),
    [anon_sym___attribute] = ACTIONS(2605),
    [anon_sym_COLON_COLON] = ACTIONS(2607),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2607),
    [anon_sym___declspec] = ACTIONS(2605),
    [anon_sym_LBRACE] = ACTIONS(2607),
    [anon_sym_signed] = ACTIONS(2605),
    [anon_sym_unsigned] = ACTIONS(2605),
    [anon_sym_long] = ACTIONS(2605),
    [anon_sym_short] = ACTIONS(2605),
    [anon_sym_LBRACK] = ACTIONS(2605),
    [anon_sym_static] = ACTIONS(2605),
    [anon_sym_register] = ACTIONS(2605),
    [anon_sym_inline] = ACTIONS(2605),
    [anon_sym___inline] = ACTIONS(2605),
    [anon_sym___inline__] = ACTIONS(2605),
    [anon_sym___forceinline] = ACTIONS(2605),
    [anon_sym_thread_local] = ACTIONS(2605),
    [anon_sym___thread] = ACTIONS(2605),
    [anon_sym_const] = ACTIONS(2605),
    [anon_sym_constexpr] = ACTIONS(2605),
    [anon_sym_volatile] = ACTIONS(2605),
    [anon_sym_restrict] = ACTIONS(2605),
    [anon_sym___restrict__] = ACTIONS(2605),
    [anon_sym__Atomic] = ACTIONS(2605),
    [anon_sym__Noreturn] = ACTIONS(2605),
    [anon_sym_noreturn] = ACTIONS(2605),
    [anon_sym__Nonnull] = ACTIONS(2605),
    [anon_sym_mutable] = ACTIONS(2605),
    [anon_sym_constinit] = ACTIONS(2605),
    [anon_sym_consteval] = ACTIONS(2605),
    [anon_sym_alignas] = ACTIONS(2605),
    [anon_sym__Alignas] = ACTIONS(2605),
    [sym_primitive_type] = ACTIONS(2605),
    [anon_sym_enum] = ACTIONS(2605),
    [anon_sym_class] = ACTIONS(2605),
    [anon_sym_struct] = ACTIONS(2605),
    [anon_sym_union] = ACTIONS(2605),
    [anon_sym_if] = ACTIONS(2605),
    [anon_sym_else] = ACTIONS(2605),
    [anon_sym_switch] = ACTIONS(2605),
    [anon_sym_while] = ACTIONS(2605),
    [anon_sym_do] = ACTIONS(2605),
    [anon_sym_for] = ACTIONS(2605),
    [anon_sym_return] = ACTIONS(2605),
    [anon_sym_break] = ACTIONS(2605),
    [anon_sym_continue] = ACTIONS(2605),
    [anon_sym_goto] = ACTIONS(2605),
    [anon_sym___try] = ACTIONS(2605),
    [anon_sym___leave] = ACTIONS(2605),
    [anon_sym_not] = ACTIONS(2605),
    [anon_sym_compl] = ACTIONS(2605),
    [anon_sym_DASH_DASH] = ACTIONS(2607),
    [anon_sym_PLUS_PLUS] = ACTIONS(2607),
    [anon_sym_sizeof] = ACTIONS(2605),
    [anon_sym___alignof__] = ACTIONS(2605),
    [anon_sym___alignof] = ACTIONS(2605),
    [anon_sym__alignof] = ACTIONS(2605),
    [anon_sym_alignof] = ACTIONS(2605),
    [anon_sym__Alignof] = ACTIONS(2605),
    [anon_sym_offsetof] = ACTIONS(2605),
    [anon_sym__Generic] = ACTIONS(2605),
    [anon_sym_asm] = ACTIONS(2605),
    [anon_sym___asm__] = ACTIONS(2605),
    [anon_sym___asm] = ACTIONS(2605),
    [sym_number_literal] = ACTIONS(2607),
    [anon_sym_L_SQUOTE] = ACTIONS(2607),
    [anon_sym_u_SQUOTE] = ACTIONS(2607),
    [anon_sym_U_SQUOTE] = ACTIONS(2607),
    [anon_sym_u8_SQUOTE] = ACTIONS(2607),
    [anon_sym_SQUOTE] = ACTIONS(2607),
    [anon_sym_L_DQUOTE] = ACTIONS(2607),
    [anon_sym_u_DQUOTE] = ACTIONS(2607),
    [anon_sym_U_DQUOTE] = ACTIONS(2607),
    [anon_sym_u8_DQUOTE] = ACTIONS(2607),
    [anon_sym_DQUOTE] = ACTIONS(2607),
    [sym_true] = ACTIONS(2605),
    [sym_false] = ACTIONS(2605),
    [anon_sym_NULL] = ACTIONS(2605),
    [anon_sym_nullptr] = ACTIONS(2605),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2605),
    [anon_sym_decltype] = ACTIONS(2605),
    [anon_sym_typename] = ACTIONS(2605),
    [anon_sym_template] = ACTIONS(2605),
    [anon_sym_try] = ACTIONS(2605),
    [anon_sym_delete] = ACTIONS(2605),
    [anon_sym_throw] = ACTIONS(2605),
    [anon_sym_co_return] = ACTIONS(2605),
    [anon_sym_co_yield] = ACTIONS(2605),
    [anon_sym_R_DQUOTE] = ACTIONS(2607),
    [anon_sym_LR_DQUOTE] = ACTIONS(2607),
    [anon_sym_uR_DQUOTE] = ACTIONS(2607),
    [anon_sym_UR_DQUOTE] = ACTIONS(2607),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2607),
    [anon_sym_co_await] = ACTIONS(2605),
    [anon_sym_new] = ACTIONS(2605),
    [anon_sym_requires] = ACTIONS(2605),
    [sym_this] = ACTIONS(2605),
  },
  [852] = {
    [sym_identifier] = ACTIONS(2657),
    [anon_sym_LPAREN2] = ACTIONS(2659),
    [anon_sym_BANG] = ACTIONS(2659),
    [anon_sym_TILDE] = ACTIONS(2659),
    [anon_sym_DASH] = ACTIONS(2657),
    [anon_sym_PLUS] = ACTIONS(2657),
    [anon_sym_STAR] = ACTIONS(2659),
    [anon_sym_AMP] = ACTIONS(2659),
    [anon_sym_SEMI] = ACTIONS(2659),
    [anon_sym___extension__] = ACTIONS(2657),
    [anon_sym_typedef] = ACTIONS(2657),
    [anon_sym_virtual] = ACTIONS(2657),
    [anon_sym_extern] = ACTIONS(2657),
    [anon_sym___attribute__] = ACTIONS(2657),
    [anon_sym___attribute] = ACTIONS(2657),
    [anon_sym_COLON_COLON] = ACTIONS(2659),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2659),
    [anon_sym___declspec] = ACTIONS(2657),
    [anon_sym_LBRACE] = ACTIONS(2659),
    [anon_sym_signed] = ACTIONS(2657),
    [anon_sym_unsigned] = ACTIONS(2657),
    [anon_sym_long] = ACTIONS(2657),
    [anon_sym_short] = ACTIONS(2657),
    [anon_sym_LBRACK] = ACTIONS(2657),
    [anon_sym_static] = ACTIONS(2657),
    [anon_sym_register] = ACTIONS(2657),
    [anon_sym_inline] = ACTIONS(2657),
    [anon_sym___inline] = ACTIONS(2657),
    [anon_sym___inline__] = ACTIONS(2657),
    [anon_sym___forceinline] = ACTIONS(2657),
    [anon_sym_thread_local] = ACTIONS(2657),
    [anon_sym___thread] = ACTIONS(2657),
    [anon_sym_const] = ACTIONS(2657),
    [anon_sym_constexpr] = ACTIONS(2657),
    [anon_sym_volatile] = ACTIONS(2657),
    [anon_sym_restrict] = ACTIONS(2657),
    [anon_sym___restrict__] = ACTIONS(2657),
    [anon_sym__Atomic] = ACTIONS(2657),
    [anon_sym__Noreturn] = ACTIONS(2657),
    [anon_sym_noreturn] = ACTIONS(2657),
    [anon_sym__Nonnull] = ACTIONS(2657),
    [anon_sym_mutable] = ACTIONS(2657),
    [anon_sym_constinit] = ACTIONS(2657),
    [anon_sym_consteval] = ACTIONS(2657),
    [anon_sym_alignas] = ACTIONS(2657),
    [anon_sym__Alignas] = ACTIONS(2657),
    [sym_primitive_type] = ACTIONS(2657),
    [anon_sym_enum] = ACTIONS(2657),
    [anon_sym_class] = ACTIONS(2657),
    [anon_sym_struct] = ACTIONS(2657),
    [anon_sym_union] = ACTIONS(2657),
    [anon_sym_if] = ACTIONS(2657),
    [anon_sym_else] = ACTIONS(2657),
    [anon_sym_switch] = ACTIONS(2657),
    [anon_sym_while] = ACTIONS(2657),
    [anon_sym_do] = ACTIONS(2657),
    [anon_sym_for] = ACTIONS(2657),
    [anon_sym_return] = ACTIONS(2657),
    [anon_sym_break] = ACTIONS(2657),
    [anon_sym_continue] = ACTIONS(2657),
    [anon_sym_goto] = ACTIONS(2657),
    [anon_sym___try] = ACTIONS(2657),
    [anon_sym___leave] = ACTIONS(2657),
    [anon_sym_not] = ACTIONS(2657),
    [anon_sym_compl] = ACTIONS(2657),
    [anon_sym_DASH_DASH] = ACTIONS(2659),
    [anon_sym_PLUS_PLUS] = ACTIONS(2659),
    [anon_sym_sizeof] = ACTIONS(2657),
    [anon_sym___alignof__] = ACTIONS(2657),
    [anon_sym___alignof] = ACTIONS(2657),
    [anon_sym__alignof] = ACTIONS(2657),
    [anon_sym_alignof] = ACTIONS(2657),
    [anon_sym__Alignof] = ACTIONS(2657),
    [anon_sym_offsetof] = ACTIONS(2657),
    [anon_sym__Generic] = ACTIONS(2657),
    [anon_sym_asm] = ACTIONS(2657),
    [anon_sym___asm__] = ACTIONS(2657),
    [anon_sym___asm] = ACTIONS(2657),
    [sym_number_literal] = ACTIONS(2659),
    [anon_sym_L_SQUOTE] = ACTIONS(2659),
    [anon_sym_u_SQUOTE] = ACTIONS(2659),
    [anon_sym_U_SQUOTE] = ACTIONS(2659),
    [anon_sym_u8_SQUOTE] = ACTIONS(2659),
    [anon_sym_SQUOTE] = ACTIONS(2659),
    [anon_sym_L_DQUOTE] = ACTIONS(2659),
    [anon_sym_u_DQUOTE] = ACTIONS(2659),
    [anon_sym_U_DQUOTE] = ACTIONS(2659),
    [anon_sym_u8_DQUOTE] = ACTIONS(2659),
    [anon_sym_DQUOTE] = ACTIONS(2659),
    [sym_true] = ACTIONS(2657),
    [sym_false] = ACTIONS(2657),
    [anon_sym_NULL] = ACTIONS(2657),
    [anon_sym_nullptr] = ACTIONS(2657),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2657),
    [anon_sym_decltype] = ACTIONS(2657),
    [anon_sym_typename] = ACTIONS(2657),
    [anon_sym_template] = ACTIONS(2657),
    [anon_sym_try] = ACTIONS(2657),
    [anon_sym_delete] = ACTIONS(2657),
    [anon_sym_throw] = ACTIONS(2657),
    [anon_sym_co_return] = ACTIONS(2657),
    [anon_sym_co_yield] = ACTIONS(2657),
    [anon_sym_R_DQUOTE] = ACTIONS(2659),
    [anon_sym_LR_DQUOTE] = ACTIONS(2659),
    [anon_sym_uR_DQUOTE] = ACTIONS(2659),
    [anon_sym_UR_DQUOTE] = ACTIONS(2659),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2659),
    [anon_sym_co_await] = ACTIONS(2657),
    [anon_sym_new] = ACTIONS(2657),
    [anon_sym_requires] = ACTIONS(2657),
    [sym_this] = ACTIONS(2657),
  },
  [853] = {
    [sym_identifier] = ACTIONS(2641),
    [anon_sym_LPAREN2] = ACTIONS(2643),
    [anon_sym_BANG] = ACTIONS(2643),
    [anon_sym_TILDE] = ACTIONS(2643),
    [anon_sym_DASH] = ACTIONS(2641),
    [anon_sym_PLUS] = ACTIONS(2641),
    [anon_sym_STAR] = ACTIONS(2643),
    [anon_sym_AMP] = ACTIONS(2643),
    [anon_sym_SEMI] = ACTIONS(2643),
    [anon_sym___extension__] = ACTIONS(2641),
    [anon_sym_typedef] = ACTIONS(2641),
    [anon_sym_virtual] = ACTIONS(2641),
    [anon_sym_extern] = ACTIONS(2641),
    [anon_sym___attribute__] = ACTIONS(2641),
    [anon_sym___attribute] = ACTIONS(2641),
    [anon_sym_COLON_COLON] = ACTIONS(2643),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2643),
    [anon_sym___declspec] = ACTIONS(2641),
    [anon_sym_LBRACE] = ACTIONS(2643),
    [anon_sym_signed] = ACTIONS(2641),
    [anon_sym_unsigned] = ACTIONS(2641),
    [anon_sym_long] = ACTIONS(2641),
    [anon_sym_short] = ACTIONS(2641),
    [anon_sym_LBRACK] = ACTIONS(2641),
    [anon_sym_static] = ACTIONS(2641),
    [anon_sym_register] = ACTIONS(2641),
    [anon_sym_inline] = ACTIONS(2641),
    [anon_sym___inline] = ACTIONS(2641),
    [anon_sym___inline__] = ACTIONS(2641),
    [anon_sym___forceinline] = ACTIONS(2641),
    [anon_sym_thread_local] = ACTIONS(2641),
    [anon_sym___thread] = ACTIONS(2641),
    [anon_sym_const] = ACTIONS(2641),
    [anon_sym_constexpr] = ACTIONS(2641),
    [anon_sym_volatile] = ACTIONS(2641),
    [anon_sym_restrict] = ACTIONS(2641),
    [anon_sym___restrict__] = ACTIONS(2641),
    [anon_sym__Atomic] = ACTIONS(2641),
    [anon_sym__Noreturn] = ACTIONS(2641),
    [anon_sym_noreturn] = ACTIONS(2641),
    [anon_sym__Nonnull] = ACTIONS(2641),
    [anon_sym_mutable] = ACTIONS(2641),
    [anon_sym_constinit] = ACTIONS(2641),
    [anon_sym_consteval] = ACTIONS(2641),
    [anon_sym_alignas] = ACTIONS(2641),
    [anon_sym__Alignas] = ACTIONS(2641),
    [sym_primitive_type] = ACTIONS(2641),
    [anon_sym_enum] = ACTIONS(2641),
    [anon_sym_class] = ACTIONS(2641),
    [anon_sym_struct] = ACTIONS(2641),
    [anon_sym_union] = ACTIONS(2641),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_else] = ACTIONS(2641),
    [anon_sym_switch] = ACTIONS(2641),
    [anon_sym_while] = ACTIONS(2641),
    [anon_sym_do] = ACTIONS(2641),
    [anon_sym_for] = ACTIONS(2641),
    [anon_sym_return] = ACTIONS(2641),
    [anon_sym_break] = ACTIONS(2641),
    [anon_sym_continue] = ACTIONS(2641),
    [anon_sym_goto] = ACTIONS(2641),
    [anon_sym___try] = ACTIONS(2641),
    [anon_sym___leave] = ACTIONS(2641),
    [anon_sym_not] = ACTIONS(2641),
    [anon_sym_compl] = ACTIONS(2641),
    [anon_sym_DASH_DASH] = ACTIONS(2643),
    [anon_sym_PLUS_PLUS] = ACTIONS(2643),
    [anon_sym_sizeof] = ACTIONS(2641),
    [anon_sym___alignof__] = ACTIONS(2641),
    [anon_sym___alignof] = ACTIONS(2641),
    [anon_sym__alignof] = ACTIONS(2641),
    [anon_sym_alignof] = ACTIONS(2641),
    [anon_sym__Alignof] = ACTIONS(2641),
    [anon_sym_offsetof] = ACTIONS(2641),
    [anon_sym__Generic] = ACTIONS(2641),
    [anon_sym_asm] = ACTIONS(2641),
    [anon_sym___asm__] = ACTIONS(2641),
    [anon_sym___asm] = ACTIONS(2641),
    [sym_number_literal] = ACTIONS(2643),
    [anon_sym_L_SQUOTE] = ACTIONS(2643),
    [anon_sym_u_SQUOTE] = ACTIONS(2643),
    [anon_sym_U_SQUOTE] = ACTIONS(2643),
    [anon_sym_u8_SQUOTE] = ACTIONS(2643),
    [anon_sym_SQUOTE] = ACTIONS(2643),
    [anon_sym_L_DQUOTE] = ACTIONS(2643),
    [anon_sym_u_DQUOTE] = ACTIONS(2643),
    [anon_sym_U_DQUOTE] = ACTIONS(2643),
    [anon_sym_u8_DQUOTE] = ACTIONS(2643),
    [anon_sym_DQUOTE] = ACTIONS(2643),
    [sym_true] = ACTIONS(2641),
    [sym_false] = ACTIONS(2641),
    [anon_sym_NULL] = ACTIONS(2641),
    [anon_sym_nullptr] = ACTIONS(2641),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2641),
    [anon_sym_decltype] = ACTIONS(2641),
    [anon_sym_typename] = ACTIONS(2641),
    [anon_sym_template] = ACTIONS(2641),
    [anon_sym_try] = ACTIONS(2641),
    [anon_sym_delete] = ACTIONS(2641),
    [anon_sym_throw] = ACTIONS(2641),
    [anon_sym_co_return] = ACTIONS(2641),
    [anon_sym_co_yield] = ACTIONS(2641),
    [anon_sym_R_DQUOTE] = ACTIONS(2643),
    [anon_sym_LR_DQUOTE] = ACTIONS(2643),
    [anon_sym_uR_DQUOTE] = ACTIONS(2643),
    [anon_sym_UR_DQUOTE] = ACTIONS(2643),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2643),
    [anon_sym_co_await] = ACTIONS(2641),
    [anon_sym_new] = ACTIONS(2641),
    [anon_sym_requires] = ACTIONS(2641),
    [sym_this] = ACTIONS(2641),
  },
  [854] = {
    [sym_identifier] = ACTIONS(2661),
    [anon_sym_LPAREN2] = ACTIONS(2663),
    [anon_sym_BANG] = ACTIONS(2663),
    [anon_sym_TILDE] = ACTIONS(2663),
    [anon_sym_DASH] = ACTIONS(2661),
    [anon_sym_PLUS] = ACTIONS(2661),
    [anon_sym_STAR] = ACTIONS(2663),
    [anon_sym_AMP] = ACTIONS(2663),
    [anon_sym_SEMI] = ACTIONS(2663),
    [anon_sym___extension__] = ACTIONS(2661),
    [anon_sym_typedef] = ACTIONS(2661),
    [anon_sym_virtual] = ACTIONS(2661),
    [anon_sym_extern] = ACTIONS(2661),
    [anon_sym___attribute__] = ACTIONS(2661),
    [anon_sym___attribute] = ACTIONS(2661),
    [anon_sym_COLON_COLON] = ACTIONS(2663),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2663),
    [anon_sym___declspec] = ACTIONS(2661),
    [anon_sym_LBRACE] = ACTIONS(2663),
    [anon_sym_signed] = ACTIONS(2661),
    [anon_sym_unsigned] = ACTIONS(2661),
    [anon_sym_long] = ACTIONS(2661),
    [anon_sym_short] = ACTIONS(2661),
    [anon_sym_LBRACK] = ACTIONS(2661),
    [anon_sym_static] = ACTIONS(2661),
    [anon_sym_register] = ACTIONS(2661),
    [anon_sym_inline] = ACTIONS(2661),
    [anon_sym___inline] = ACTIONS(2661),
    [anon_sym___inline__] = ACTIONS(2661),
    [anon_sym___forceinline] = ACTIONS(2661),
    [anon_sym_thread_local] = ACTIONS(2661),
    [anon_sym___thread] = ACTIONS(2661),
    [anon_sym_const] = ACTIONS(2661),
    [anon_sym_constexpr] = ACTIONS(2661),
    [anon_sym_volatile] = ACTIONS(2661),
    [anon_sym_restrict] = ACTIONS(2661),
    [anon_sym___restrict__] = ACTIONS(2661),
    [anon_sym__Atomic] = ACTIONS(2661),
    [anon_sym__Noreturn] = ACTIONS(2661),
    [anon_sym_noreturn] = ACTIONS(2661),
    [anon_sym__Nonnull] = ACTIONS(2661),
    [anon_sym_mutable] = ACTIONS(2661),
    [anon_sym_constinit] = ACTIONS(2661),
    [anon_sym_consteval] = ACTIONS(2661),
    [anon_sym_alignas] = ACTIONS(2661),
    [anon_sym__Alignas] = ACTIONS(2661),
    [sym_primitive_type] = ACTIONS(2661),
    [anon_sym_enum] = ACTIONS(2661),
    [anon_sym_class] = ACTIONS(2661),
    [anon_sym_struct] = ACTIONS(2661),
    [anon_sym_union] = ACTIONS(2661),
    [anon_sym_if] = ACTIONS(2661),
    [anon_sym_else] = ACTIONS(2661),
    [anon_sym_switch] = ACTIONS(2661),
    [anon_sym_while] = ACTIONS(2661),
    [anon_sym_do] = ACTIONS(2661),
    [anon_sym_for] = ACTIONS(2661),
    [anon_sym_return] = ACTIONS(2661),
    [anon_sym_break] = ACTIONS(2661),
    [anon_sym_continue] = ACTIONS(2661),
    [anon_sym_goto] = ACTIONS(2661),
    [anon_sym___try] = ACTIONS(2661),
    [anon_sym___leave] = ACTIONS(2661),
    [anon_sym_not] = ACTIONS(2661),
    [anon_sym_compl] = ACTIONS(2661),
    [anon_sym_DASH_DASH] = ACTIONS(2663),
    [anon_sym_PLUS_PLUS] = ACTIONS(2663),
    [anon_sym_sizeof] = ACTIONS(2661),
    [anon_sym___alignof__] = ACTIONS(2661),
    [anon_sym___alignof] = ACTIONS(2661),
    [anon_sym__alignof] = ACTIONS(2661),
    [anon_sym_alignof] = ACTIONS(2661),
    [anon_sym__Alignof] = ACTIONS(2661),
    [anon_sym_offsetof] = ACTIONS(2661),
    [anon_sym__Generic] = ACTIONS(2661),
    [anon_sym_asm] = ACTIONS(2661),
    [anon_sym___asm__] = ACTIONS(2661),
    [anon_sym___asm] = ACTIONS(2661),
    [sym_number_literal] = ACTIONS(2663),
    [anon_sym_L_SQUOTE] = ACTIONS(2663),
    [anon_sym_u_SQUOTE] = ACTIONS(2663),
    [anon_sym_U_SQUOTE] = ACTIONS(2663),
    [anon_sym_u8_SQUOTE] = ACTIONS(2663),
    [anon_sym_SQUOTE] = ACTIONS(2663),
    [anon_sym_L_DQUOTE] = ACTIONS(2663),
    [anon_sym_u_DQUOTE] = ACTIONS(2663),
    [anon_sym_U_DQUOTE] = ACTIONS(2663),
    [anon_sym_u8_DQUOTE] = ACTIONS(2663),
    [anon_sym_DQUOTE] = ACTIONS(2663),
    [sym_true] = ACTIONS(2661),
    [sym_false] = ACTIONS(2661),
    [anon_sym_NULL] = ACTIONS(2661),
    [anon_sym_nullptr] = ACTIONS(2661),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2661),
    [anon_sym_decltype] = ACTIONS(2661),
    [anon_sym_typename] = ACTIONS(2661),
    [anon_sym_template] = ACTIONS(2661),
    [anon_sym_try] = ACTIONS(2661),
    [anon_sym_delete] = ACTIONS(2661),
    [anon_sym_throw] = ACTIONS(2661),
    [anon_sym_co_return] = ACTIONS(2661),
    [anon_sym_co_yield] = ACTIONS(2661),
    [anon_sym_R_DQUOTE] = ACTIONS(2663),
    [anon_sym_LR_DQUOTE] = ACTIONS(2663),
    [anon_sym_uR_DQUOTE] = ACTIONS(2663),
    [anon_sym_UR_DQUOTE] = ACTIONS(2663),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2663),
    [anon_sym_co_await] = ACTIONS(2661),
    [anon_sym_new] = ACTIONS(2661),
    [anon_sym_requires] = ACTIONS(2661),
    [sym_this] = ACTIONS(2661),
  },
  [855] = {
    [sym_identifier] = ACTIONS(2717),
    [anon_sym_LPAREN2] = ACTIONS(2719),
    [anon_sym_BANG] = ACTIONS(2719),
    [anon_sym_TILDE] = ACTIONS(2719),
    [anon_sym_DASH] = ACTIONS(2717),
    [anon_sym_PLUS] = ACTIONS(2717),
    [anon_sym_STAR] = ACTIONS(2719),
    [anon_sym_AMP] = ACTIONS(2719),
    [anon_sym_SEMI] = ACTIONS(2719),
    [anon_sym___extension__] = ACTIONS(2717),
    [anon_sym_typedef] = ACTIONS(2717),
    [anon_sym_virtual] = ACTIONS(2717),
    [anon_sym_extern] = ACTIONS(2717),
    [anon_sym___attribute__] = ACTIONS(2717),
    [anon_sym___attribute] = ACTIONS(2717),
    [anon_sym_COLON_COLON] = ACTIONS(2719),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2719),
    [anon_sym___declspec] = ACTIONS(2717),
    [anon_sym_LBRACE] = ACTIONS(2719),
    [anon_sym_signed] = ACTIONS(2717),
    [anon_sym_unsigned] = ACTIONS(2717),
    [anon_sym_long] = ACTIONS(2717),
    [anon_sym_short] = ACTIONS(2717),
    [anon_sym_LBRACK] = ACTIONS(2717),
    [anon_sym_static] = ACTIONS(2717),
    [anon_sym_register] = ACTIONS(2717),
    [anon_sym_inline] = ACTIONS(2717),
    [anon_sym___inline] = ACTIONS(2717),
    [anon_sym___inline__] = ACTIONS(2717),
    [anon_sym___forceinline] = ACTIONS(2717),
    [anon_sym_thread_local] = ACTIONS(2717),
    [anon_sym___thread] = ACTIONS(2717),
    [anon_sym_const] = ACTIONS(2717),
    [anon_sym_constexpr] = ACTIONS(2717),
    [anon_sym_volatile] = ACTIONS(2717),
    [anon_sym_restrict] = ACTIONS(2717),
    [anon_sym___restrict__] = ACTIONS(2717),
    [anon_sym__Atomic] = ACTIONS(2717),
    [anon_sym__Noreturn] = ACTIONS(2717),
    [anon_sym_noreturn] = ACTIONS(2717),
    [anon_sym__Nonnull] = ACTIONS(2717),
    [anon_sym_mutable] = ACTIONS(2717),
    [anon_sym_constinit] = ACTIONS(2717),
    [anon_sym_consteval] = ACTIONS(2717),
    [anon_sym_alignas] = ACTIONS(2717),
    [anon_sym__Alignas] = ACTIONS(2717),
    [sym_primitive_type] = ACTIONS(2717),
    [anon_sym_enum] = ACTIONS(2717),
    [anon_sym_class] = ACTIONS(2717),
    [anon_sym_struct] = ACTIONS(2717),
    [anon_sym_union] = ACTIONS(2717),
    [anon_sym_if] = ACTIONS(2717),
    [anon_sym_else] = ACTIONS(2717),
    [anon_sym_switch] = ACTIONS(2717),
    [anon_sym_while] = ACTIONS(2717),
    [anon_sym_do] = ACTIONS(2717),
    [anon_sym_for] = ACTIONS(2717),
    [anon_sym_return] = ACTIONS(2717),
    [anon_sym_break] = ACTIONS(2717),
    [anon_sym_continue] = ACTIONS(2717),
    [anon_sym_goto] = ACTIONS(2717),
    [anon_sym___try] = ACTIONS(2717),
    [anon_sym___leave] = ACTIONS(2717),
    [anon_sym_not] = ACTIONS(2717),
    [anon_sym_compl] = ACTIONS(2717),
    [anon_sym_DASH_DASH] = ACTIONS(2719),
    [anon_sym_PLUS_PLUS] = ACTIONS(2719),
    [anon_sym_sizeof] = ACTIONS(2717),
    [anon_sym___alignof__] = ACTIONS(2717),
    [anon_sym___alignof] = ACTIONS(2717),
    [anon_sym__alignof] = ACTIONS(2717),
    [anon_sym_alignof] = ACTIONS(2717),
    [anon_sym__Alignof] = ACTIONS(2717),
    [anon_sym_offsetof] = ACTIONS(2717),
    [anon_sym__Generic] = ACTIONS(2717),
    [anon_sym_asm] = ACTIONS(2717),
    [anon_sym___asm__] = ACTIONS(2717),
    [anon_sym___asm] = ACTIONS(2717),
    [sym_number_literal] = ACTIONS(2719),
    [anon_sym_L_SQUOTE] = ACTIONS(2719),
    [anon_sym_u_SQUOTE] = ACTIONS(2719),
    [anon_sym_U_SQUOTE] = ACTIONS(2719),
    [anon_sym_u8_SQUOTE] = ACTIONS(2719),
    [anon_sym_SQUOTE] = ACTIONS(2719),
    [anon_sym_L_DQUOTE] = ACTIONS(2719),
    [anon_sym_u_DQUOTE] = ACTIONS(2719),
    [anon_sym_U_DQUOTE] = ACTIONS(2719),
    [anon_sym_u8_DQUOTE] = ACTIONS(2719),
    [anon_sym_DQUOTE] = ACTIONS(2719),
    [sym_true] = ACTIONS(2717),
    [sym_false] = ACTIONS(2717),
    [anon_sym_NULL] = ACTIONS(2717),
    [anon_sym_nullptr] = ACTIONS(2717),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2717),
    [anon_sym_decltype] = ACTIONS(2717),
    [anon_sym_typename] = ACTIONS(2717),
    [anon_sym_template] = ACTIONS(2717),
    [anon_sym_try] = ACTIONS(2717),
    [anon_sym_delete] = ACTIONS(2717),
    [anon_sym_throw] = ACTIONS(2717),
    [anon_sym_co_return] = ACTIONS(2717),
    [anon_sym_co_yield] = ACTIONS(2717),
    [anon_sym_R_DQUOTE] = ACTIONS(2719),
    [anon_sym_LR_DQUOTE] = ACTIONS(2719),
    [anon_sym_uR_DQUOTE] = ACTIONS(2719),
    [anon_sym_UR_DQUOTE] = ACTIONS(2719),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2719),
    [anon_sym_co_await] = ACTIONS(2717),
    [anon_sym_new] = ACTIONS(2717),
    [anon_sym_requires] = ACTIONS(2717),
    [sym_this] = ACTIONS(2717),
  },
  [856] = {
    [sym_identifier] = ACTIONS(2665),
    [anon_sym_LPAREN2] = ACTIONS(2667),
    [anon_sym_BANG] = ACTIONS(2667),
    [anon_sym_TILDE] = ACTIONS(2667),
    [anon_sym_DASH] = ACTIONS(2665),
    [anon_sym_PLUS] = ACTIONS(2665),
    [anon_sym_STAR] = ACTIONS(2667),
    [anon_sym_AMP] = ACTIONS(2667),
    [anon_sym_SEMI] = ACTIONS(2667),
    [anon_sym___extension__] = ACTIONS(2665),
    [anon_sym_typedef] = ACTIONS(2665),
    [anon_sym_virtual] = ACTIONS(2665),
    [anon_sym_extern] = ACTIONS(2665),
    [anon_sym___attribute__] = ACTIONS(2665),
    [anon_sym___attribute] = ACTIONS(2665),
    [anon_sym_COLON_COLON] = ACTIONS(2667),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2667),
    [anon_sym___declspec] = ACTIONS(2665),
    [anon_sym_LBRACE] = ACTIONS(2667),
    [anon_sym_signed] = ACTIONS(2665),
    [anon_sym_unsigned] = ACTIONS(2665),
    [anon_sym_long] = ACTIONS(2665),
    [anon_sym_short] = ACTIONS(2665),
    [anon_sym_LBRACK] = ACTIONS(2665),
    [anon_sym_static] = ACTIONS(2665),
    [anon_sym_register] = ACTIONS(2665),
    [anon_sym_inline] = ACTIONS(2665),
    [anon_sym___inline] = ACTIONS(2665),
    [anon_sym___inline__] = ACTIONS(2665),
    [anon_sym___forceinline] = ACTIONS(2665),
    [anon_sym_thread_local] = ACTIONS(2665),
    [anon_sym___thread] = ACTIONS(2665),
    [anon_sym_const] = ACTIONS(2665),
    [anon_sym_constexpr] = ACTIONS(2665),
    [anon_sym_volatile] = ACTIONS(2665),
    [anon_sym_restrict] = ACTIONS(2665),
    [anon_sym___restrict__] = ACTIONS(2665),
    [anon_sym__Atomic] = ACTIONS(2665),
    [anon_sym__Noreturn] = ACTIONS(2665),
    [anon_sym_noreturn] = ACTIONS(2665),
    [anon_sym__Nonnull] = ACTIONS(2665),
    [anon_sym_mutable] = ACTIONS(2665),
    [anon_sym_constinit] = ACTIONS(2665),
    [anon_sym_consteval] = ACTIONS(2665),
    [anon_sym_alignas] = ACTIONS(2665),
    [anon_sym__Alignas] = ACTIONS(2665),
    [sym_primitive_type] = ACTIONS(2665),
    [anon_sym_enum] = ACTIONS(2665),
    [anon_sym_class] = ACTIONS(2665),
    [anon_sym_struct] = ACTIONS(2665),
    [anon_sym_union] = ACTIONS(2665),
    [anon_sym_if] = ACTIONS(2665),
    [anon_sym_else] = ACTIONS(2665),
    [anon_sym_switch] = ACTIONS(2665),
    [anon_sym_while] = ACTIONS(2665),
    [anon_sym_do] = ACTIONS(2665),
    [anon_sym_for] = ACTIONS(2665),
    [anon_sym_return] = ACTIONS(2665),
    [anon_sym_break] = ACTIONS(2665),
    [anon_sym_continue] = ACTIONS(2665),
    [anon_sym_goto] = ACTIONS(2665),
    [anon_sym___try] = ACTIONS(2665),
    [anon_sym___leave] = ACTIONS(2665),
    [anon_sym_not] = ACTIONS(2665),
    [anon_sym_compl] = ACTIONS(2665),
    [anon_sym_DASH_DASH] = ACTIONS(2667),
    [anon_sym_PLUS_PLUS] = ACTIONS(2667),
    [anon_sym_sizeof] = ACTIONS(2665),
    [anon_sym___alignof__] = ACTIONS(2665),
    [anon_sym___alignof] = ACTIONS(2665),
    [anon_sym__alignof] = ACTIONS(2665),
    [anon_sym_alignof] = ACTIONS(2665),
    [anon_sym__Alignof] = ACTIONS(2665),
    [anon_sym_offsetof] = ACTIONS(2665),
    [anon_sym__Generic] = ACTIONS(2665),
    [anon_sym_asm] = ACTIONS(2665),
    [anon_sym___asm__] = ACTIONS(2665),
    [anon_sym___asm] = ACTIONS(2665),
    [sym_number_literal] = ACTIONS(2667),
    [anon_sym_L_SQUOTE] = ACTIONS(2667),
    [anon_sym_u_SQUOTE] = ACTIONS(2667),
    [anon_sym_U_SQUOTE] = ACTIONS(2667),
    [anon_sym_u8_SQUOTE] = ACTIONS(2667),
    [anon_sym_SQUOTE] = ACTIONS(2667),
    [anon_sym_L_DQUOTE] = ACTIONS(2667),
    [anon_sym_u_DQUOTE] = ACTIONS(2667),
    [anon_sym_U_DQUOTE] = ACTIONS(2667),
    [anon_sym_u8_DQUOTE] = ACTIONS(2667),
    [anon_sym_DQUOTE] = ACTIONS(2667),
    [sym_true] = ACTIONS(2665),
    [sym_false] = ACTIONS(2665),
    [anon_sym_NULL] = ACTIONS(2665),
    [anon_sym_nullptr] = ACTIONS(2665),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2665),
    [anon_sym_decltype] = ACTIONS(2665),
    [anon_sym_typename] = ACTIONS(2665),
    [anon_sym_template] = ACTIONS(2665),
    [anon_sym_try] = ACTIONS(2665),
    [anon_sym_delete] = ACTIONS(2665),
    [anon_sym_throw] = ACTIONS(2665),
    [anon_sym_co_return] = ACTIONS(2665),
    [anon_sym_co_yield] = ACTIONS(2665),
    [anon_sym_R_DQUOTE] = ACTIONS(2667),
    [anon_sym_LR_DQUOTE] = ACTIONS(2667),
    [anon_sym_uR_DQUOTE] = ACTIONS(2667),
    [anon_sym_UR_DQUOTE] = ACTIONS(2667),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2667),
    [anon_sym_co_await] = ACTIONS(2665),
    [anon_sym_new] = ACTIONS(2665),
    [anon_sym_requires] = ACTIONS(2665),
    [sym_this] = ACTIONS(2665),
  },
  [857] = {
    [sym_identifier] = ACTIONS(2669),
    [anon_sym_LPAREN2] = ACTIONS(2671),
    [anon_sym_BANG] = ACTIONS(2671),
    [anon_sym_TILDE] = ACTIONS(2671),
    [anon_sym_DASH] = ACTIONS(2669),
    [anon_sym_PLUS] = ACTIONS(2669),
    [anon_sym_STAR] = ACTIONS(2671),
    [anon_sym_AMP] = ACTIONS(2671),
    [anon_sym_SEMI] = ACTIONS(2671),
    [anon_sym___extension__] = ACTIONS(2669),
    [anon_sym_typedef] = ACTIONS(2669),
    [anon_sym_virtual] = ACTIONS(2669),
    [anon_sym_extern] = ACTIONS(2669),
    [anon_sym___attribute__] = ACTIONS(2669),
    [anon_sym___attribute] = ACTIONS(2669),
    [anon_sym_COLON_COLON] = ACTIONS(2671),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2671),
    [anon_sym___declspec] = ACTIONS(2669),
    [anon_sym_LBRACE] = ACTIONS(2671),
    [anon_sym_signed] = ACTIONS(2669),
    [anon_sym_unsigned] = ACTIONS(2669),
    [anon_sym_long] = ACTIONS(2669),
    [anon_sym_short] = ACTIONS(2669),
    [anon_sym_LBRACK] = ACTIONS(2669),
    [anon_sym_static] = ACTIONS(2669),
    [anon_sym_register] = ACTIONS(2669),
    [anon_sym_inline] = ACTIONS(2669),
    [anon_sym___inline] = ACTIONS(2669),
    [anon_sym___inline__] = ACTIONS(2669),
    [anon_sym___forceinline] = ACTIONS(2669),
    [anon_sym_thread_local] = ACTIONS(2669),
    [anon_sym___thread] = ACTIONS(2669),
    [anon_sym_const] = ACTIONS(2669),
    [anon_sym_constexpr] = ACTIONS(2669),
    [anon_sym_volatile] = ACTIONS(2669),
    [anon_sym_restrict] = ACTIONS(2669),
    [anon_sym___restrict__] = ACTIONS(2669),
    [anon_sym__Atomic] = ACTIONS(2669),
    [anon_sym__Noreturn] = ACTIONS(2669),
    [anon_sym_noreturn] = ACTIONS(2669),
    [anon_sym__Nonnull] = ACTIONS(2669),
    [anon_sym_mutable] = ACTIONS(2669),
    [anon_sym_constinit] = ACTIONS(2669),
    [anon_sym_consteval] = ACTIONS(2669),
    [anon_sym_alignas] = ACTIONS(2669),
    [anon_sym__Alignas] = ACTIONS(2669),
    [sym_primitive_type] = ACTIONS(2669),
    [anon_sym_enum] = ACTIONS(2669),
    [anon_sym_class] = ACTIONS(2669),
    [anon_sym_struct] = ACTIONS(2669),
    [anon_sym_union] = ACTIONS(2669),
    [anon_sym_if] = ACTIONS(2669),
    [anon_sym_else] = ACTIONS(2669),
    [anon_sym_switch] = ACTIONS(2669),
    [anon_sym_while] = ACTIONS(2669),
    [anon_sym_do] = ACTIONS(2669),
    [anon_sym_for] = ACTIONS(2669),
    [anon_sym_return] = ACTIONS(2669),
    [anon_sym_break] = ACTIONS(2669),
    [anon_sym_continue] = ACTIONS(2669),
    [anon_sym_goto] = ACTIONS(2669),
    [anon_sym___try] = ACTIONS(2669),
    [anon_sym___leave] = ACTIONS(2669),
    [anon_sym_not] = ACTIONS(2669),
    [anon_sym_compl] = ACTIONS(2669),
    [anon_sym_DASH_DASH] = ACTIONS(2671),
    [anon_sym_PLUS_PLUS] = ACTIONS(2671),
    [anon_sym_sizeof] = ACTIONS(2669),
    [anon_sym___alignof__] = ACTIONS(2669),
    [anon_sym___alignof] = ACTIONS(2669),
    [anon_sym__alignof] = ACTIONS(2669),
    [anon_sym_alignof] = ACTIONS(2669),
    [anon_sym__Alignof] = ACTIONS(2669),
    [anon_sym_offsetof] = ACTIONS(2669),
    [anon_sym__Generic] = ACTIONS(2669),
    [anon_sym_asm] = ACTIONS(2669),
    [anon_sym___asm__] = ACTIONS(2669),
    [anon_sym___asm] = ACTIONS(2669),
    [sym_number_literal] = ACTIONS(2671),
    [anon_sym_L_SQUOTE] = ACTIONS(2671),
    [anon_sym_u_SQUOTE] = ACTIONS(2671),
    [anon_sym_U_SQUOTE] = ACTIONS(2671),
    [anon_sym_u8_SQUOTE] = ACTIONS(2671),
    [anon_sym_SQUOTE] = ACTIONS(2671),
    [anon_sym_L_DQUOTE] = ACTIONS(2671),
    [anon_sym_u_DQUOTE] = ACTIONS(2671),
    [anon_sym_U_DQUOTE] = ACTIONS(2671),
    [anon_sym_u8_DQUOTE] = ACTIONS(2671),
    [anon_sym_DQUOTE] = ACTIONS(2671),
    [sym_true] = ACTIONS(2669),
    [sym_false] = ACTIONS(2669),
    [anon_sym_NULL] = ACTIONS(2669),
    [anon_sym_nullptr] = ACTIONS(2669),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2669),
    [anon_sym_decltype] = ACTIONS(2669),
    [anon_sym_typename] = ACTIONS(2669),
    [anon_sym_template] = ACTIONS(2669),
    [anon_sym_try] = ACTIONS(2669),
    [anon_sym_delete] = ACTIONS(2669),
    [anon_sym_throw] = ACTIONS(2669),
    [anon_sym_co_return] = ACTIONS(2669),
    [anon_sym_co_yield] = ACTIONS(2669),
    [anon_sym_R_DQUOTE] = ACTIONS(2671),
    [anon_sym_LR_DQUOTE] = ACTIONS(2671),
    [anon_sym_uR_DQUOTE] = ACTIONS(2671),
    [anon_sym_UR_DQUOTE] = ACTIONS(2671),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2671),
    [anon_sym_co_await] = ACTIONS(2669),
    [anon_sym_new] = ACTIONS(2669),
    [anon_sym_requires] = ACTIONS(2669),
    [sym_this] = ACTIONS(2669),
  },
  [858] = {
    [sym_identifier] = ACTIONS(2673),
    [anon_sym_LPAREN2] = ACTIONS(2675),
    [anon_sym_BANG] = ACTIONS(2675),
    [anon_sym_TILDE] = ACTIONS(2675),
    [anon_sym_DASH] = ACTIONS(2673),
    [anon_sym_PLUS] = ACTIONS(2673),
    [anon_sym_STAR] = ACTIONS(2675),
    [anon_sym_AMP] = ACTIONS(2675),
    [anon_sym_SEMI] = ACTIONS(2675),
    [anon_sym___extension__] = ACTIONS(2673),
    [anon_sym_typedef] = ACTIONS(2673),
    [anon_sym_virtual] = ACTIONS(2673),
    [anon_sym_extern] = ACTIONS(2673),
    [anon_sym___attribute__] = ACTIONS(2673),
    [anon_sym___attribute] = ACTIONS(2673),
    [anon_sym_COLON_COLON] = ACTIONS(2675),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2675),
    [anon_sym___declspec] = ACTIONS(2673),
    [anon_sym_LBRACE] = ACTIONS(2675),
    [anon_sym_signed] = ACTIONS(2673),
    [anon_sym_unsigned] = ACTIONS(2673),
    [anon_sym_long] = ACTIONS(2673),
    [anon_sym_short] = ACTIONS(2673),
    [anon_sym_LBRACK] = ACTIONS(2673),
    [anon_sym_static] = ACTIONS(2673),
    [anon_sym_register] = ACTIONS(2673),
    [anon_sym_inline] = ACTIONS(2673),
    [anon_sym___inline] = ACTIONS(2673),
    [anon_sym___inline__] = ACTIONS(2673),
    [anon_sym___forceinline] = ACTIONS(2673),
    [anon_sym_thread_local] = ACTIONS(2673),
    [anon_sym___thread] = ACTIONS(2673),
    [anon_sym_const] = ACTIONS(2673),
    [anon_sym_constexpr] = ACTIONS(2673),
    [anon_sym_volatile] = ACTIONS(2673),
    [anon_sym_restrict] = ACTIONS(2673),
    [anon_sym___restrict__] = ACTIONS(2673),
    [anon_sym__Atomic] = ACTIONS(2673),
    [anon_sym__Noreturn] = ACTIONS(2673),
    [anon_sym_noreturn] = ACTIONS(2673),
    [anon_sym__Nonnull] = ACTIONS(2673),
    [anon_sym_mutable] = ACTIONS(2673),
    [anon_sym_constinit] = ACTIONS(2673),
    [anon_sym_consteval] = ACTIONS(2673),
    [anon_sym_alignas] = ACTIONS(2673),
    [anon_sym__Alignas] = ACTIONS(2673),
    [sym_primitive_type] = ACTIONS(2673),
    [anon_sym_enum] = ACTIONS(2673),
    [anon_sym_class] = ACTIONS(2673),
    [anon_sym_struct] = ACTIONS(2673),
    [anon_sym_union] = ACTIONS(2673),
    [anon_sym_if] = ACTIONS(2673),
    [anon_sym_else] = ACTIONS(2673),
    [anon_sym_switch] = ACTIONS(2673),
    [anon_sym_while] = ACTIONS(2673),
    [anon_sym_do] = ACTIONS(2673),
    [anon_sym_for] = ACTIONS(2673),
    [anon_sym_return] = ACTIONS(2673),
    [anon_sym_break] = ACTIONS(2673),
    [anon_sym_continue] = ACTIONS(2673),
    [anon_sym_goto] = ACTIONS(2673),
    [anon_sym___try] = ACTIONS(2673),
    [anon_sym___leave] = ACTIONS(2673),
    [anon_sym_not] = ACTIONS(2673),
    [anon_sym_compl] = ACTIONS(2673),
    [anon_sym_DASH_DASH] = ACTIONS(2675),
    [anon_sym_PLUS_PLUS] = ACTIONS(2675),
    [anon_sym_sizeof] = ACTIONS(2673),
    [anon_sym___alignof__] = ACTIONS(2673),
    [anon_sym___alignof] = ACTIONS(2673),
    [anon_sym__alignof] = ACTIONS(2673),
    [anon_sym_alignof] = ACTIONS(2673),
    [anon_sym__Alignof] = ACTIONS(2673),
    [anon_sym_offsetof] = ACTIONS(2673),
    [anon_sym__Generic] = ACTIONS(2673),
    [anon_sym_asm] = ACTIONS(2673),
    [anon_sym___asm__] = ACTIONS(2673),
    [anon_sym___asm] = ACTIONS(2673),
    [sym_number_literal] = ACTIONS(2675),
    [anon_sym_L_SQUOTE] = ACTIONS(2675),
    [anon_sym_u_SQUOTE] = ACTIONS(2675),
    [anon_sym_U_SQUOTE] = ACTIONS(2675),
    [anon_sym_u8_SQUOTE] = ACTIONS(2675),
    [anon_sym_SQUOTE] = ACTIONS(2675),
    [anon_sym_L_DQUOTE] = ACTIONS(2675),
    [anon_sym_u_DQUOTE] = ACTIONS(2675),
    [anon_sym_U_DQUOTE] = ACTIONS(2675),
    [anon_sym_u8_DQUOTE] = ACTIONS(2675),
    [anon_sym_DQUOTE] = ACTIONS(2675),
    [sym_true] = ACTIONS(2673),
    [sym_false] = ACTIONS(2673),
    [anon_sym_NULL] = ACTIONS(2673),
    [anon_sym_nullptr] = ACTIONS(2673),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2673),
    [anon_sym_decltype] = ACTIONS(2673),
    [anon_sym_typename] = ACTIONS(2673),
    [anon_sym_template] = ACTIONS(2673),
    [anon_sym_try] = ACTIONS(2673),
    [anon_sym_delete] = ACTIONS(2673),
    [anon_sym_throw] = ACTIONS(2673),
    [anon_sym_co_return] = ACTIONS(2673),
    [anon_sym_co_yield] = ACTIONS(2673),
    [anon_sym_R_DQUOTE] = ACTIONS(2675),
    [anon_sym_LR_DQUOTE] = ACTIONS(2675),
    [anon_sym_uR_DQUOTE] = ACTIONS(2675),
    [anon_sym_UR_DQUOTE] = ACTIONS(2675),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2675),
    [anon_sym_co_await] = ACTIONS(2673),
    [anon_sym_new] = ACTIONS(2673),
    [anon_sym_requires] = ACTIONS(2673),
    [sym_this] = ACTIONS(2673),
  },
  [859] = {
    [sym_identifier] = ACTIONS(2689),
    [anon_sym_LPAREN2] = ACTIONS(2691),
    [anon_sym_BANG] = ACTIONS(2691),
    [anon_sym_TILDE] = ACTIONS(2691),
    [anon_sym_DASH] = ACTIONS(2689),
    [anon_sym_PLUS] = ACTIONS(2689),
    [anon_sym_STAR] = ACTIONS(2691),
    [anon_sym_AMP] = ACTIONS(2691),
    [anon_sym_SEMI] = ACTIONS(2691),
    [anon_sym___extension__] = ACTIONS(2689),
    [anon_sym_typedef] = ACTIONS(2689),
    [anon_sym_virtual] = ACTIONS(2689),
    [anon_sym_extern] = ACTIONS(2689),
    [anon_sym___attribute__] = ACTIONS(2689),
    [anon_sym___attribute] = ACTIONS(2689),
    [anon_sym_COLON_COLON] = ACTIONS(2691),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2691),
    [anon_sym___declspec] = ACTIONS(2689),
    [anon_sym_LBRACE] = ACTIONS(2691),
    [anon_sym_signed] = ACTIONS(2689),
    [anon_sym_unsigned] = ACTIONS(2689),
    [anon_sym_long] = ACTIONS(2689),
    [anon_sym_short] = ACTIONS(2689),
    [anon_sym_LBRACK] = ACTIONS(2689),
    [anon_sym_static] = ACTIONS(2689),
    [anon_sym_register] = ACTIONS(2689),
    [anon_sym_inline] = ACTIONS(2689),
    [anon_sym___inline] = ACTIONS(2689),
    [anon_sym___inline__] = ACTIONS(2689),
    [anon_sym___forceinline] = ACTIONS(2689),
    [anon_sym_thread_local] = ACTIONS(2689),
    [anon_sym___thread] = ACTIONS(2689),
    [anon_sym_const] = ACTIONS(2689),
    [anon_sym_constexpr] = ACTIONS(2689),
    [anon_sym_volatile] = ACTIONS(2689),
    [anon_sym_restrict] = ACTIONS(2689),
    [anon_sym___restrict__] = ACTIONS(2689),
    [anon_sym__Atomic] = ACTIONS(2689),
    [anon_sym__Noreturn] = ACTIONS(2689),
    [anon_sym_noreturn] = ACTIONS(2689),
    [anon_sym__Nonnull] = ACTIONS(2689),
    [anon_sym_mutable] = ACTIONS(2689),
    [anon_sym_constinit] = ACTIONS(2689),
    [anon_sym_consteval] = ACTIONS(2689),
    [anon_sym_alignas] = ACTIONS(2689),
    [anon_sym__Alignas] = ACTIONS(2689),
    [sym_primitive_type] = ACTIONS(2689),
    [anon_sym_enum] = ACTIONS(2689),
    [anon_sym_class] = ACTIONS(2689),
    [anon_sym_struct] = ACTIONS(2689),
    [anon_sym_union] = ACTIONS(2689),
    [anon_sym_if] = ACTIONS(2689),
    [anon_sym_else] = ACTIONS(2689),
    [anon_sym_switch] = ACTIONS(2689),
    [anon_sym_while] = ACTIONS(2689),
    [anon_sym_do] = ACTIONS(2689),
    [anon_sym_for] = ACTIONS(2689),
    [anon_sym_return] = ACTIONS(2689),
    [anon_sym_break] = ACTIONS(2689),
    [anon_sym_continue] = ACTIONS(2689),
    [anon_sym_goto] = ACTIONS(2689),
    [anon_sym___try] = ACTIONS(2689),
    [anon_sym___leave] = ACTIONS(2689),
    [anon_sym_not] = ACTIONS(2689),
    [anon_sym_compl] = ACTIONS(2689),
    [anon_sym_DASH_DASH] = ACTIONS(2691),
    [anon_sym_PLUS_PLUS] = ACTIONS(2691),
    [anon_sym_sizeof] = ACTIONS(2689),
    [anon_sym___alignof__] = ACTIONS(2689),
    [anon_sym___alignof] = ACTIONS(2689),
    [anon_sym__alignof] = ACTIONS(2689),
    [anon_sym_alignof] = ACTIONS(2689),
    [anon_sym__Alignof] = ACTIONS(2689),
    [anon_sym_offsetof] = ACTIONS(2689),
    [anon_sym__Generic] = ACTIONS(2689),
    [anon_sym_asm] = ACTIONS(2689),
    [anon_sym___asm__] = ACTIONS(2689),
    [anon_sym___asm] = ACTIONS(2689),
    [sym_number_literal] = ACTIONS(2691),
    [anon_sym_L_SQUOTE] = ACTIONS(2691),
    [anon_sym_u_SQUOTE] = ACTIONS(2691),
    [anon_sym_U_SQUOTE] = ACTIONS(2691),
    [anon_sym_u8_SQUOTE] = ACTIONS(2691),
    [anon_sym_SQUOTE] = ACTIONS(2691),
    [anon_sym_L_DQUOTE] = ACTIONS(2691),
    [anon_sym_u_DQUOTE] = ACTIONS(2691),
    [anon_sym_U_DQUOTE] = ACTIONS(2691),
    [anon_sym_u8_DQUOTE] = ACTIONS(2691),
    [anon_sym_DQUOTE] = ACTIONS(2691),
    [sym_true] = ACTIONS(2689),
    [sym_false] = ACTIONS(2689),
    [anon_sym_NULL] = ACTIONS(2689),
    [anon_sym_nullptr] = ACTIONS(2689),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2689),
    [anon_sym_decltype] = ACTIONS(2689),
    [anon_sym_typename] = ACTIONS(2689),
    [anon_sym_template] = ACTIONS(2689),
    [anon_sym_try] = ACTIONS(2689),
    [anon_sym_delete] = ACTIONS(2689),
    [anon_sym_throw] = ACTIONS(2689),
    [anon_sym_co_return] = ACTIONS(2689),
    [anon_sym_co_yield] = ACTIONS(2689),
    [anon_sym_R_DQUOTE] = ACTIONS(2691),
    [anon_sym_LR_DQUOTE] = ACTIONS(2691),
    [anon_sym_uR_DQUOTE] = ACTIONS(2691),
    [anon_sym_UR_DQUOTE] = ACTIONS(2691),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2691),
    [anon_sym_co_await] = ACTIONS(2689),
    [anon_sym_new] = ACTIONS(2689),
    [anon_sym_requires] = ACTIONS(2689),
    [sym_this] = ACTIONS(2689),
  },
  [860] = {
    [sym_identifier] = ACTIONS(2585),
    [anon_sym_LPAREN2] = ACTIONS(2587),
    [anon_sym_BANG] = ACTIONS(2587),
    [anon_sym_TILDE] = ACTIONS(2587),
    [anon_sym_DASH] = ACTIONS(2585),
    [anon_sym_PLUS] = ACTIONS(2585),
    [anon_sym_STAR] = ACTIONS(2587),
    [anon_sym_AMP] = ACTIONS(2587),
    [anon_sym_SEMI] = ACTIONS(2587),
    [anon_sym___extension__] = ACTIONS(2585),
    [anon_sym_typedef] = ACTIONS(2585),
    [anon_sym_virtual] = ACTIONS(2585),
    [anon_sym_extern] = ACTIONS(2585),
    [anon_sym___attribute__] = ACTIONS(2585),
    [anon_sym___attribute] = ACTIONS(2585),
    [anon_sym_COLON_COLON] = ACTIONS(2587),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2587),
    [anon_sym___declspec] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2587),
    [anon_sym_signed] = ACTIONS(2585),
    [anon_sym_unsigned] = ACTIONS(2585),
    [anon_sym_long] = ACTIONS(2585),
    [anon_sym_short] = ACTIONS(2585),
    [anon_sym_LBRACK] = ACTIONS(2585),
    [anon_sym_static] = ACTIONS(2585),
    [anon_sym_register] = ACTIONS(2585),
    [anon_sym_inline] = ACTIONS(2585),
    [anon_sym___inline] = ACTIONS(2585),
    [anon_sym___inline__] = ACTIONS(2585),
    [anon_sym___forceinline] = ACTIONS(2585),
    [anon_sym_thread_local] = ACTIONS(2585),
    [anon_sym___thread] = ACTIONS(2585),
    [anon_sym_const] = ACTIONS(2585),
    [anon_sym_constexpr] = ACTIONS(2585),
    [anon_sym_volatile] = ACTIONS(2585),
    [anon_sym_restrict] = ACTIONS(2585),
    [anon_sym___restrict__] = ACTIONS(2585),
    [anon_sym__Atomic] = ACTIONS(2585),
    [anon_sym__Noreturn] = ACTIONS(2585),
    [anon_sym_noreturn] = ACTIONS(2585),
    [anon_sym__Nonnull] = ACTIONS(2585),
    [anon_sym_mutable] = ACTIONS(2585),
    [anon_sym_constinit] = ACTIONS(2585),
    [anon_sym_consteval] = ACTIONS(2585),
    [anon_sym_alignas] = ACTIONS(2585),
    [anon_sym__Alignas] = ACTIONS(2585),
    [sym_primitive_type] = ACTIONS(2585),
    [anon_sym_enum] = ACTIONS(2585),
    [anon_sym_class] = ACTIONS(2585),
    [anon_sym_struct] = ACTIONS(2585),
    [anon_sym_union] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2585),
    [anon_sym_else] = ACTIONS(2585),
    [anon_sym_switch] = ACTIONS(2585),
    [anon_sym_while] = ACTIONS(2585),
    [anon_sym_do] = ACTIONS(2585),
    [anon_sym_for] = ACTIONS(2585),
    [anon_sym_return] = ACTIONS(2585),
    [anon_sym_break] = ACTIONS(2585),
    [anon_sym_continue] = ACTIONS(2585),
    [anon_sym_goto] = ACTIONS(2585),
    [anon_sym___try] = ACTIONS(2585),
    [anon_sym___leave] = ACTIONS(2585),
    [anon_sym_not] = ACTIONS(2585),
    [anon_sym_compl] = ACTIONS(2585),
    [anon_sym_DASH_DASH] = ACTIONS(2587),
    [anon_sym_PLUS_PLUS] = ACTIONS(2587),
    [anon_sym_sizeof] = ACTIONS(2585),
    [anon_sym___alignof__] = ACTIONS(2585),
    [anon_sym___alignof] = ACTIONS(2585),
    [anon_sym__alignof] = ACTIONS(2585),
    [anon_sym_alignof] = ACTIONS(2585),
    [anon_sym__Alignof] = ACTIONS(2585),
    [anon_sym_offsetof] = ACTIONS(2585),
    [anon_sym__Generic] = ACTIONS(2585),
    [anon_sym_asm] = ACTIONS(2585),
    [anon_sym___asm__] = ACTIONS(2585),
    [anon_sym___asm] = ACTIONS(2585),
    [sym_number_literal] = ACTIONS(2587),
    [anon_sym_L_SQUOTE] = ACTIONS(2587),
    [anon_sym_u_SQUOTE] = ACTIONS(2587),
    [anon_sym_U_SQUOTE] = ACTIONS(2587),
    [anon_sym_u8_SQUOTE] = ACTIONS(2587),
    [anon_sym_SQUOTE] = ACTIONS(2587),
    [anon_sym_L_DQUOTE] = ACTIONS(2587),
    [anon_sym_u_DQUOTE] = ACTIONS(2587),
    [anon_sym_U_DQUOTE] = ACTIONS(2587),
    [anon_sym_u8_DQUOTE] = ACTIONS(2587),
    [anon_sym_DQUOTE] = ACTIONS(2587),
    [sym_true] = ACTIONS(2585),
    [sym_false] = ACTIONS(2585),
    [anon_sym_NULL] = ACTIONS(2585),
    [anon_sym_nullptr] = ACTIONS(2585),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2585),
    [anon_sym_decltype] = ACTIONS(2585),
    [anon_sym_typename] = ACTIONS(2585),
    [anon_sym_template] = ACTIONS(2585),
    [anon_sym_try] = ACTIONS(2585),
    [anon_sym_delete] = ACTIONS(2585),
    [anon_sym_throw] = ACTIONS(2585),
    [anon_sym_co_return] = ACTIONS(2585),
    [anon_sym_co_yield] = ACTIONS(2585),
    [anon_sym_R_DQUOTE] = ACTIONS(2587),
    [anon_sym_LR_DQUOTE] = ACTIONS(2587),
    [anon_sym_uR_DQUOTE] = ACTIONS(2587),
    [anon_sym_UR_DQUOTE] = ACTIONS(2587),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2587),
    [anon_sym_co_await] = ACTIONS(2585),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_requires] = ACTIONS(2585),
    [sym_this] = ACTIONS(2585),
  },
  [861] = {
    [sym_identifier] = ACTIONS(3818),
    [anon_sym_LPAREN2] = ACTIONS(3820),
    [anon_sym_BANG] = ACTIONS(3820),
    [anon_sym_TILDE] = ACTIONS(3820),
    [anon_sym_DASH] = ACTIONS(3818),
    [anon_sym_PLUS] = ACTIONS(3818),
    [anon_sym_STAR] = ACTIONS(3820),
    [anon_sym_AMP] = ACTIONS(3820),
    [anon_sym_SEMI] = ACTIONS(3820),
    [anon_sym___extension__] = ACTIONS(3818),
    [anon_sym_virtual] = ACTIONS(3818),
    [anon_sym_extern] = ACTIONS(3818),
    [anon_sym___attribute__] = ACTIONS(3818),
    [anon_sym___attribute] = ACTIONS(3818),
    [anon_sym_COLON_COLON] = ACTIONS(3820),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3820),
    [anon_sym___declspec] = ACTIONS(3818),
    [anon_sym_LBRACE] = ACTIONS(3820),
    [anon_sym_signed] = ACTIONS(3818),
    [anon_sym_unsigned] = ACTIONS(3818),
    [anon_sym_long] = ACTIONS(3818),
    [anon_sym_short] = ACTIONS(3818),
    [anon_sym_LBRACK] = ACTIONS(3818),
    [anon_sym_static] = ACTIONS(3818),
    [anon_sym_register] = ACTIONS(3818),
    [anon_sym_inline] = ACTIONS(3818),
    [anon_sym___inline] = ACTIONS(3818),
    [anon_sym___inline__] = ACTIONS(3818),
    [anon_sym___forceinline] = ACTIONS(3818),
    [anon_sym_thread_local] = ACTIONS(3818),
    [anon_sym___thread] = ACTIONS(3818),
    [anon_sym_const] = ACTIONS(3818),
    [anon_sym_constexpr] = ACTIONS(3818),
    [anon_sym_volatile] = ACTIONS(3818),
    [anon_sym_restrict] = ACTIONS(3818),
    [anon_sym___restrict__] = ACTIONS(3818),
    [anon_sym__Atomic] = ACTIONS(3818),
    [anon_sym__Noreturn] = ACTIONS(3818),
    [anon_sym_noreturn] = ACTIONS(3818),
    [anon_sym__Nonnull] = ACTIONS(3818),
    [anon_sym_mutable] = ACTIONS(3818),
    [anon_sym_constinit] = ACTIONS(3818),
    [anon_sym_consteval] = ACTIONS(3818),
    [anon_sym_alignas] = ACTIONS(3818),
    [anon_sym__Alignas] = ACTIONS(3818),
    [sym_primitive_type] = ACTIONS(3818),
    [anon_sym_enum] = ACTIONS(3818),
    [anon_sym_class] = ACTIONS(3818),
    [anon_sym_struct] = ACTIONS(3818),
    [anon_sym_union] = ACTIONS(3818),
    [anon_sym_if] = ACTIONS(3818),
    [anon_sym_switch] = ACTIONS(3818),
    [anon_sym_case] = ACTIONS(3818),
    [anon_sym_default] = ACTIONS(3818),
    [anon_sym_while] = ACTIONS(3818),
    [anon_sym_do] = ACTIONS(3818),
    [anon_sym_for] = ACTIONS(3818),
    [anon_sym_return] = ACTIONS(3818),
    [anon_sym_break] = ACTIONS(3818),
    [anon_sym_continue] = ACTIONS(3818),
    [anon_sym_goto] = ACTIONS(3818),
    [anon_sym___try] = ACTIONS(3818),
    [anon_sym___leave] = ACTIONS(3818),
    [anon_sym_not] = ACTIONS(3818),
    [anon_sym_compl] = ACTIONS(3818),
    [anon_sym_DASH_DASH] = ACTIONS(3820),
    [anon_sym_PLUS_PLUS] = ACTIONS(3820),
    [anon_sym_sizeof] = ACTIONS(3818),
    [anon_sym___alignof__] = ACTIONS(3818),
    [anon_sym___alignof] = ACTIONS(3818),
    [anon_sym__alignof] = ACTIONS(3818),
    [anon_sym_alignof] = ACTIONS(3818),
    [anon_sym__Alignof] = ACTIONS(3818),
    [anon_sym_offsetof] = ACTIONS(3818),
    [anon_sym__Generic] = ACTIONS(3818),
    [anon_sym_asm] = ACTIONS(3818),
    [anon_sym___asm__] = ACTIONS(3818),
    [anon_sym___asm] = ACTIONS(3818),
    [sym_number_literal] = ACTIONS(3820),
    [anon_sym_L_SQUOTE] = ACTIONS(3820),
    [anon_sym_u_SQUOTE] = ACTIONS(3820),
    [anon_sym_U_SQUOTE] = ACTIONS(3820),
    [anon_sym_u8_SQUOTE] = ACTIONS(3820),
    [anon_sym_SQUOTE] = ACTIONS(3820),
    [anon_sym_L_DQUOTE] = ACTIONS(3820),
    [anon_sym_u_DQUOTE] = ACTIONS(3820),
    [anon_sym_U_DQUOTE] = ACTIONS(3820),
    [anon_sym_u8_DQUOTE] = ACTIONS(3820),
    [anon_sym_DQUOTE] = ACTIONS(3820),
    [sym_true] = ACTIONS(3818),
    [sym_false] = ACTIONS(3818),
    [anon_sym_NULL] = ACTIONS(3818),
    [anon_sym_nullptr] = ACTIONS(3818),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3818),
    [anon_sym_decltype] = ACTIONS(3818),
    [anon_sym_typename] = ACTIONS(3818),
    [anon_sym_template] = ACTIONS(3818),
    [anon_sym_try] = ACTIONS(3818),
    [anon_sym_delete] = ACTIONS(3818),
    [anon_sym_throw] = ACTIONS(3818),
    [anon_sym_co_return] = ACTIONS(3818),
    [anon_sym_co_yield] = ACTIONS(3818),
    [anon_sym_R_DQUOTE] = ACTIONS(3820),
    [anon_sym_LR_DQUOTE] = ACTIONS(3820),
    [anon_sym_uR_DQUOTE] = ACTIONS(3820),
    [anon_sym_UR_DQUOTE] = ACTIONS(3820),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3820),
    [anon_sym_co_await] = ACTIONS(3818),
    [anon_sym_new] = ACTIONS(3818),
    [anon_sym_requires] = ACTIONS(3818),
    [sym_this] = ACTIONS(3818),
  },
  [862] = {
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6367),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(5896),
    [sym_array_declarator] = STATE(5896),
    [sym_expression] = STATE(2342),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3298),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5556),
    [sym_qualified_identifier] = STATE(3246),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(3294),
    [anon_sym_LPAREN2] = ACTIONS(3296),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(3298),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(27),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(31),
    [anon_sym___extension__] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1971),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1965),
    [anon_sym_compl] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_sizeof] = ACTIONS(1973),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_operator] = ACTIONS(1823),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [863] = {
    [sym_identifier] = ACTIONS(2613),
    [anon_sym_LPAREN2] = ACTIONS(2615),
    [anon_sym_BANG] = ACTIONS(2615),
    [anon_sym_TILDE] = ACTIONS(2615),
    [anon_sym_DASH] = ACTIONS(2613),
    [anon_sym_PLUS] = ACTIONS(2613),
    [anon_sym_STAR] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2615),
    [anon_sym_SEMI] = ACTIONS(2615),
    [anon_sym___extension__] = ACTIONS(2613),
    [anon_sym_typedef] = ACTIONS(2613),
    [anon_sym_virtual] = ACTIONS(2613),
    [anon_sym_extern] = ACTIONS(2613),
    [anon_sym___attribute__] = ACTIONS(2613),
    [anon_sym___attribute] = ACTIONS(2613),
    [anon_sym_COLON_COLON] = ACTIONS(2615),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2615),
    [anon_sym___declspec] = ACTIONS(2613),
    [anon_sym_LBRACE] = ACTIONS(2615),
    [anon_sym_signed] = ACTIONS(2613),
    [anon_sym_unsigned] = ACTIONS(2613),
    [anon_sym_long] = ACTIONS(2613),
    [anon_sym_short] = ACTIONS(2613),
    [anon_sym_LBRACK] = ACTIONS(2613),
    [anon_sym_static] = ACTIONS(2613),
    [anon_sym_register] = ACTIONS(2613),
    [anon_sym_inline] = ACTIONS(2613),
    [anon_sym___inline] = ACTIONS(2613),
    [anon_sym___inline__] = ACTIONS(2613),
    [anon_sym___forceinline] = ACTIONS(2613),
    [anon_sym_thread_local] = ACTIONS(2613),
    [anon_sym___thread] = ACTIONS(2613),
    [anon_sym_const] = ACTIONS(2613),
    [anon_sym_constexpr] = ACTIONS(2613),
    [anon_sym_volatile] = ACTIONS(2613),
    [anon_sym_restrict] = ACTIONS(2613),
    [anon_sym___restrict__] = ACTIONS(2613),
    [anon_sym__Atomic] = ACTIONS(2613),
    [anon_sym__Noreturn] = ACTIONS(2613),
    [anon_sym_noreturn] = ACTIONS(2613),
    [anon_sym__Nonnull] = ACTIONS(2613),
    [anon_sym_mutable] = ACTIONS(2613),
    [anon_sym_constinit] = ACTIONS(2613),
    [anon_sym_consteval] = ACTIONS(2613),
    [anon_sym_alignas] = ACTIONS(2613),
    [anon_sym__Alignas] = ACTIONS(2613),
    [sym_primitive_type] = ACTIONS(2613),
    [anon_sym_enum] = ACTIONS(2613),
    [anon_sym_class] = ACTIONS(2613),
    [anon_sym_struct] = ACTIONS(2613),
    [anon_sym_union] = ACTIONS(2613),
    [anon_sym_if] = ACTIONS(2613),
    [anon_sym_else] = ACTIONS(2613),
    [anon_sym_switch] = ACTIONS(2613),
    [anon_sym_while] = ACTIONS(2613),
    [anon_sym_do] = ACTIONS(2613),
    [anon_sym_for] = ACTIONS(2613),
    [anon_sym_return] = ACTIONS(2613),
    [anon_sym_break] = ACTIONS(2613),
    [anon_sym_continue] = ACTIONS(2613),
    [anon_sym_goto] = ACTIONS(2613),
    [anon_sym___try] = ACTIONS(2613),
    [anon_sym___leave] = ACTIONS(2613),
    [anon_sym_not] = ACTIONS(2613),
    [anon_sym_compl] = ACTIONS(2613),
    [anon_sym_DASH_DASH] = ACTIONS(2615),
    [anon_sym_PLUS_PLUS] = ACTIONS(2615),
    [anon_sym_sizeof] = ACTIONS(2613),
    [anon_sym___alignof__] = ACTIONS(2613),
    [anon_sym___alignof] = ACTIONS(2613),
    [anon_sym__alignof] = ACTIONS(2613),
    [anon_sym_alignof] = ACTIONS(2613),
    [anon_sym__Alignof] = ACTIONS(2613),
    [anon_sym_offsetof] = ACTIONS(2613),
    [anon_sym__Generic] = ACTIONS(2613),
    [anon_sym_asm] = ACTIONS(2613),
    [anon_sym___asm__] = ACTIONS(2613),
    [anon_sym___asm] = ACTIONS(2613),
    [sym_number_literal] = ACTIONS(2615),
    [anon_sym_L_SQUOTE] = ACTIONS(2615),
    [anon_sym_u_SQUOTE] = ACTIONS(2615),
    [anon_sym_U_SQUOTE] = ACTIONS(2615),
    [anon_sym_u8_SQUOTE] = ACTIONS(2615),
    [anon_sym_SQUOTE] = ACTIONS(2615),
    [anon_sym_L_DQUOTE] = ACTIONS(2615),
    [anon_sym_u_DQUOTE] = ACTIONS(2615),
    [anon_sym_U_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8_DQUOTE] = ACTIONS(2615),
    [anon_sym_DQUOTE] = ACTIONS(2615),
    [sym_true] = ACTIONS(2613),
    [sym_false] = ACTIONS(2613),
    [anon_sym_NULL] = ACTIONS(2613),
    [anon_sym_nullptr] = ACTIONS(2613),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2613),
    [anon_sym_decltype] = ACTIONS(2613),
    [anon_sym_typename] = ACTIONS(2613),
    [anon_sym_template] = ACTIONS(2613),
    [anon_sym_try] = ACTIONS(2613),
    [anon_sym_delete] = ACTIONS(2613),
    [anon_sym_throw] = ACTIONS(2613),
    [anon_sym_co_return] = ACTIONS(2613),
    [anon_sym_co_yield] = ACTIONS(2613),
    [anon_sym_R_DQUOTE] = ACTIONS(2615),
    [anon_sym_LR_DQUOTE] = ACTIONS(2615),
    [anon_sym_uR_DQUOTE] = ACTIONS(2615),
    [anon_sym_UR_DQUOTE] = ACTIONS(2615),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2615),
    [anon_sym_co_await] = ACTIONS(2613),
    [anon_sym_new] = ACTIONS(2613),
    [anon_sym_requires] = ACTIONS(2613),
    [sym_this] = ACTIONS(2613),
  },
  [864] = {
    [sym_identifier] = ACTIONS(2617),
    [anon_sym_LPAREN2] = ACTIONS(2619),
    [anon_sym_BANG] = ACTIONS(2619),
    [anon_sym_TILDE] = ACTIONS(2619),
    [anon_sym_DASH] = ACTIONS(2617),
    [anon_sym_PLUS] = ACTIONS(2617),
    [anon_sym_STAR] = ACTIONS(2619),
    [anon_sym_AMP] = ACTIONS(2619),
    [anon_sym_SEMI] = ACTIONS(2619),
    [anon_sym___extension__] = ACTIONS(2617),
    [anon_sym_typedef] = ACTIONS(2617),
    [anon_sym_virtual] = ACTIONS(2617),
    [anon_sym_extern] = ACTIONS(2617),
    [anon_sym___attribute__] = ACTIONS(2617),
    [anon_sym___attribute] = ACTIONS(2617),
    [anon_sym_COLON_COLON] = ACTIONS(2619),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2619),
    [anon_sym___declspec] = ACTIONS(2617),
    [anon_sym_LBRACE] = ACTIONS(2619),
    [anon_sym_signed] = ACTIONS(2617),
    [anon_sym_unsigned] = ACTIONS(2617),
    [anon_sym_long] = ACTIONS(2617),
    [anon_sym_short] = ACTIONS(2617),
    [anon_sym_LBRACK] = ACTIONS(2617),
    [anon_sym_static] = ACTIONS(2617),
    [anon_sym_register] = ACTIONS(2617),
    [anon_sym_inline] = ACTIONS(2617),
    [anon_sym___inline] = ACTIONS(2617),
    [anon_sym___inline__] = ACTIONS(2617),
    [anon_sym___forceinline] = ACTIONS(2617),
    [anon_sym_thread_local] = ACTIONS(2617),
    [anon_sym___thread] = ACTIONS(2617),
    [anon_sym_const] = ACTIONS(2617),
    [anon_sym_constexpr] = ACTIONS(2617),
    [anon_sym_volatile] = ACTIONS(2617),
    [anon_sym_restrict] = ACTIONS(2617),
    [anon_sym___restrict__] = ACTIONS(2617),
    [anon_sym__Atomic] = ACTIONS(2617),
    [anon_sym__Noreturn] = ACTIONS(2617),
    [anon_sym_noreturn] = ACTIONS(2617),
    [anon_sym__Nonnull] = ACTIONS(2617),
    [anon_sym_mutable] = ACTIONS(2617),
    [anon_sym_constinit] = ACTIONS(2617),
    [anon_sym_consteval] = ACTIONS(2617),
    [anon_sym_alignas] = ACTIONS(2617),
    [anon_sym__Alignas] = ACTIONS(2617),
    [sym_primitive_type] = ACTIONS(2617),
    [anon_sym_enum] = ACTIONS(2617),
    [anon_sym_class] = ACTIONS(2617),
    [anon_sym_struct] = ACTIONS(2617),
    [anon_sym_union] = ACTIONS(2617),
    [anon_sym_if] = ACTIONS(2617),
    [anon_sym_else] = ACTIONS(2617),
    [anon_sym_switch] = ACTIONS(2617),
    [anon_sym_while] = ACTIONS(2617),
    [anon_sym_do] = ACTIONS(2617),
    [anon_sym_for] = ACTIONS(2617),
    [anon_sym_return] = ACTIONS(2617),
    [anon_sym_break] = ACTIONS(2617),
    [anon_sym_continue] = ACTIONS(2617),
    [anon_sym_goto] = ACTIONS(2617),
    [anon_sym___try] = ACTIONS(2617),
    [anon_sym___leave] = ACTIONS(2617),
    [anon_sym_not] = ACTIONS(2617),
    [anon_sym_compl] = ACTIONS(2617),
    [anon_sym_DASH_DASH] = ACTIONS(2619),
    [anon_sym_PLUS_PLUS] = ACTIONS(2619),
    [anon_sym_sizeof] = ACTIONS(2617),
    [anon_sym___alignof__] = ACTIONS(2617),
    [anon_sym___alignof] = ACTIONS(2617),
    [anon_sym__alignof] = ACTIONS(2617),
    [anon_sym_alignof] = ACTIONS(2617),
    [anon_sym__Alignof] = ACTIONS(2617),
    [anon_sym_offsetof] = ACTIONS(2617),
    [anon_sym__Generic] = ACTIONS(2617),
    [anon_sym_asm] = ACTIONS(2617),
    [anon_sym___asm__] = ACTIONS(2617),
    [anon_sym___asm] = ACTIONS(2617),
    [sym_number_literal] = ACTIONS(2619),
    [anon_sym_L_SQUOTE] = ACTIONS(2619),
    [anon_sym_u_SQUOTE] = ACTIONS(2619),
    [anon_sym_U_SQUOTE] = ACTIONS(2619),
    [anon_sym_u8_SQUOTE] = ACTIONS(2619),
    [anon_sym_SQUOTE] = ACTIONS(2619),
    [anon_sym_L_DQUOTE] = ACTIONS(2619),
    [anon_sym_u_DQUOTE] = ACTIONS(2619),
    [anon_sym_U_DQUOTE] = ACTIONS(2619),
    [anon_sym_u8_DQUOTE] = ACTIONS(2619),
    [anon_sym_DQUOTE] = ACTIONS(2619),
    [sym_true] = ACTIONS(2617),
    [sym_false] = ACTIONS(2617),
    [anon_sym_NULL] = ACTIONS(2617),
    [anon_sym_nullptr] = ACTIONS(2617),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2617),
    [anon_sym_decltype] = ACTIONS(2617),
    [anon_sym_typename] = ACTIONS(2617),
    [anon_sym_template] = ACTIONS(2617),
    [anon_sym_try] = ACTIONS(2617),
    [anon_sym_delete] = ACTIONS(2617),
    [anon_sym_throw] = ACTIONS(2617),
    [anon_sym_co_return] = ACTIONS(2617),
    [anon_sym_co_yield] = ACTIONS(2617),
    [anon_sym_R_DQUOTE] = ACTIONS(2619),
    [anon_sym_LR_DQUOTE] = ACTIONS(2619),
    [anon_sym_uR_DQUOTE] = ACTIONS(2619),
    [anon_sym_UR_DQUOTE] = ACTIONS(2619),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2619),
    [anon_sym_co_await] = ACTIONS(2617),
    [anon_sym_new] = ACTIONS(2617),
    [anon_sym_requires] = ACTIONS(2617),
    [sym_this] = ACTIONS(2617),
  },
  [865] = {
    [sym_identifier] = ACTIONS(2609),
    [anon_sym_LPAREN2] = ACTIONS(2611),
    [anon_sym_BANG] = ACTIONS(2611),
    [anon_sym_TILDE] = ACTIONS(2611),
    [anon_sym_DASH] = ACTIONS(2609),
    [anon_sym_PLUS] = ACTIONS(2609),
    [anon_sym_STAR] = ACTIONS(2611),
    [anon_sym_AMP] = ACTIONS(2611),
    [anon_sym_SEMI] = ACTIONS(2611),
    [anon_sym___extension__] = ACTIONS(2609),
    [anon_sym_typedef] = ACTIONS(2609),
    [anon_sym_virtual] = ACTIONS(2609),
    [anon_sym_extern] = ACTIONS(2609),
    [anon_sym___attribute__] = ACTIONS(2609),
    [anon_sym___attribute] = ACTIONS(2609),
    [anon_sym_COLON_COLON] = ACTIONS(2611),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2611),
    [anon_sym___declspec] = ACTIONS(2609),
    [anon_sym_LBRACE] = ACTIONS(2611),
    [anon_sym_signed] = ACTIONS(2609),
    [anon_sym_unsigned] = ACTIONS(2609),
    [anon_sym_long] = ACTIONS(2609),
    [anon_sym_short] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(2609),
    [anon_sym_static] = ACTIONS(2609),
    [anon_sym_register] = ACTIONS(2609),
    [anon_sym_inline] = ACTIONS(2609),
    [anon_sym___inline] = ACTIONS(2609),
    [anon_sym___inline__] = ACTIONS(2609),
    [anon_sym___forceinline] = ACTIONS(2609),
    [anon_sym_thread_local] = ACTIONS(2609),
    [anon_sym___thread] = ACTIONS(2609),
    [anon_sym_const] = ACTIONS(2609),
    [anon_sym_constexpr] = ACTIONS(2609),
    [anon_sym_volatile] = ACTIONS(2609),
    [anon_sym_restrict] = ACTIONS(2609),
    [anon_sym___restrict__] = ACTIONS(2609),
    [anon_sym__Atomic] = ACTIONS(2609),
    [anon_sym__Noreturn] = ACTIONS(2609),
    [anon_sym_noreturn] = ACTIONS(2609),
    [anon_sym__Nonnull] = ACTIONS(2609),
    [anon_sym_mutable] = ACTIONS(2609),
    [anon_sym_constinit] = ACTIONS(2609),
    [anon_sym_consteval] = ACTIONS(2609),
    [anon_sym_alignas] = ACTIONS(2609),
    [anon_sym__Alignas] = ACTIONS(2609),
    [sym_primitive_type] = ACTIONS(2609),
    [anon_sym_enum] = ACTIONS(2609),
    [anon_sym_class] = ACTIONS(2609),
    [anon_sym_struct] = ACTIONS(2609),
    [anon_sym_union] = ACTIONS(2609),
    [anon_sym_if] = ACTIONS(2609),
    [anon_sym_else] = ACTIONS(2609),
    [anon_sym_switch] = ACTIONS(2609),
    [anon_sym_while] = ACTIONS(2609),
    [anon_sym_do] = ACTIONS(2609),
    [anon_sym_for] = ACTIONS(2609),
    [anon_sym_return] = ACTIONS(2609),
    [anon_sym_break] = ACTIONS(2609),
    [anon_sym_continue] = ACTIONS(2609),
    [anon_sym_goto] = ACTIONS(2609),
    [anon_sym___try] = ACTIONS(2609),
    [anon_sym___leave] = ACTIONS(2609),
    [anon_sym_not] = ACTIONS(2609),
    [anon_sym_compl] = ACTIONS(2609),
    [anon_sym_DASH_DASH] = ACTIONS(2611),
    [anon_sym_PLUS_PLUS] = ACTIONS(2611),
    [anon_sym_sizeof] = ACTIONS(2609),
    [anon_sym___alignof__] = ACTIONS(2609),
    [anon_sym___alignof] = ACTIONS(2609),
    [anon_sym__alignof] = ACTIONS(2609),
    [anon_sym_alignof] = ACTIONS(2609),
    [anon_sym__Alignof] = ACTIONS(2609),
    [anon_sym_offsetof] = ACTIONS(2609),
    [anon_sym__Generic] = ACTIONS(2609),
    [anon_sym_asm] = ACTIONS(2609),
    [anon_sym___asm__] = ACTIONS(2609),
    [anon_sym___asm] = ACTIONS(2609),
    [sym_number_literal] = ACTIONS(2611),
    [anon_sym_L_SQUOTE] = ACTIONS(2611),
    [anon_sym_u_SQUOTE] = ACTIONS(2611),
    [anon_sym_U_SQUOTE] = ACTIONS(2611),
    [anon_sym_u8_SQUOTE] = ACTIONS(2611),
    [anon_sym_SQUOTE] = ACTIONS(2611),
    [anon_sym_L_DQUOTE] = ACTIONS(2611),
    [anon_sym_u_DQUOTE] = ACTIONS(2611),
    [anon_sym_U_DQUOTE] = ACTIONS(2611),
    [anon_sym_u8_DQUOTE] = ACTIONS(2611),
    [anon_sym_DQUOTE] = ACTIONS(2611),
    [sym_true] = ACTIONS(2609),
    [sym_false] = ACTIONS(2609),
    [anon_sym_NULL] = ACTIONS(2609),
    [anon_sym_nullptr] = ACTIONS(2609),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2609),
    [anon_sym_decltype] = ACTIONS(2609),
    [anon_sym_typename] = ACTIONS(2609),
    [anon_sym_template] = ACTIONS(2609),
    [anon_sym_try] = ACTIONS(2609),
    [anon_sym_delete] = ACTIONS(2609),
    [anon_sym_throw] = ACTIONS(2609),
    [anon_sym_co_return] = ACTIONS(2609),
    [anon_sym_co_yield] = ACTIONS(2609),
    [anon_sym_R_DQUOTE] = ACTIONS(2611),
    [anon_sym_LR_DQUOTE] = ACTIONS(2611),
    [anon_sym_uR_DQUOTE] = ACTIONS(2611),
    [anon_sym_UR_DQUOTE] = ACTIONS(2611),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2611),
    [anon_sym_co_await] = ACTIONS(2609),
    [anon_sym_new] = ACTIONS(2609),
    [anon_sym_requires] = ACTIONS(2609),
    [sym_this] = ACTIONS(2609),
  },
  [866] = {
    [sym_identifier] = ACTIONS(2697),
    [anon_sym_LPAREN2] = ACTIONS(2699),
    [anon_sym_BANG] = ACTIONS(2699),
    [anon_sym_TILDE] = ACTIONS(2699),
    [anon_sym_DASH] = ACTIONS(2697),
    [anon_sym_PLUS] = ACTIONS(2697),
    [anon_sym_STAR] = ACTIONS(2699),
    [anon_sym_AMP] = ACTIONS(2699),
    [anon_sym_SEMI] = ACTIONS(2699),
    [anon_sym___extension__] = ACTIONS(2697),
    [anon_sym_typedef] = ACTIONS(2697),
    [anon_sym_virtual] = ACTIONS(2697),
    [anon_sym_extern] = ACTIONS(2697),
    [anon_sym___attribute__] = ACTIONS(2697),
    [anon_sym___attribute] = ACTIONS(2697),
    [anon_sym_COLON_COLON] = ACTIONS(2699),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2699),
    [anon_sym___declspec] = ACTIONS(2697),
    [anon_sym_LBRACE] = ACTIONS(2699),
    [anon_sym_signed] = ACTIONS(2697),
    [anon_sym_unsigned] = ACTIONS(2697),
    [anon_sym_long] = ACTIONS(2697),
    [anon_sym_short] = ACTIONS(2697),
    [anon_sym_LBRACK] = ACTIONS(2697),
    [anon_sym_static] = ACTIONS(2697),
    [anon_sym_register] = ACTIONS(2697),
    [anon_sym_inline] = ACTIONS(2697),
    [anon_sym___inline] = ACTIONS(2697),
    [anon_sym___inline__] = ACTIONS(2697),
    [anon_sym___forceinline] = ACTIONS(2697),
    [anon_sym_thread_local] = ACTIONS(2697),
    [anon_sym___thread] = ACTIONS(2697),
    [anon_sym_const] = ACTIONS(2697),
    [anon_sym_constexpr] = ACTIONS(2697),
    [anon_sym_volatile] = ACTIONS(2697),
    [anon_sym_restrict] = ACTIONS(2697),
    [anon_sym___restrict__] = ACTIONS(2697),
    [anon_sym__Atomic] = ACTIONS(2697),
    [anon_sym__Noreturn] = ACTIONS(2697),
    [anon_sym_noreturn] = ACTIONS(2697),
    [anon_sym__Nonnull] = ACTIONS(2697),
    [anon_sym_mutable] = ACTIONS(2697),
    [anon_sym_constinit] = ACTIONS(2697),
    [anon_sym_consteval] = ACTIONS(2697),
    [anon_sym_alignas] = ACTIONS(2697),
    [anon_sym__Alignas] = ACTIONS(2697),
    [sym_primitive_type] = ACTIONS(2697),
    [anon_sym_enum] = ACTIONS(2697),
    [anon_sym_class] = ACTIONS(2697),
    [anon_sym_struct] = ACTIONS(2697),
    [anon_sym_union] = ACTIONS(2697),
    [anon_sym_if] = ACTIONS(2697),
    [anon_sym_else] = ACTIONS(2697),
    [anon_sym_switch] = ACTIONS(2697),
    [anon_sym_while] = ACTIONS(2697),
    [anon_sym_do] = ACTIONS(2697),
    [anon_sym_for] = ACTIONS(2697),
    [anon_sym_return] = ACTIONS(2697),
    [anon_sym_break] = ACTIONS(2697),
    [anon_sym_continue] = ACTIONS(2697),
    [anon_sym_goto] = ACTIONS(2697),
    [anon_sym___try] = ACTIONS(2697),
    [anon_sym___leave] = ACTIONS(2697),
    [anon_sym_not] = ACTIONS(2697),
    [anon_sym_compl] = ACTIONS(2697),
    [anon_sym_DASH_DASH] = ACTIONS(2699),
    [anon_sym_PLUS_PLUS] = ACTIONS(2699),
    [anon_sym_sizeof] = ACTIONS(2697),
    [anon_sym___alignof__] = ACTIONS(2697),
    [anon_sym___alignof] = ACTIONS(2697),
    [anon_sym__alignof] = ACTIONS(2697),
    [anon_sym_alignof] = ACTIONS(2697),
    [anon_sym__Alignof] = ACTIONS(2697),
    [anon_sym_offsetof] = ACTIONS(2697),
    [anon_sym__Generic] = ACTIONS(2697),
    [anon_sym_asm] = ACTIONS(2697),
    [anon_sym___asm__] = ACTIONS(2697),
    [anon_sym___asm] = ACTIONS(2697),
    [sym_number_literal] = ACTIONS(2699),
    [anon_sym_L_SQUOTE] = ACTIONS(2699),
    [anon_sym_u_SQUOTE] = ACTIONS(2699),
    [anon_sym_U_SQUOTE] = ACTIONS(2699),
    [anon_sym_u8_SQUOTE] = ACTIONS(2699),
    [anon_sym_SQUOTE] = ACTIONS(2699),
    [anon_sym_L_DQUOTE] = ACTIONS(2699),
    [anon_sym_u_DQUOTE] = ACTIONS(2699),
    [anon_sym_U_DQUOTE] = ACTIONS(2699),
    [anon_sym_u8_DQUOTE] = ACTIONS(2699),
    [anon_sym_DQUOTE] = ACTIONS(2699),
    [sym_true] = ACTIONS(2697),
    [sym_false] = ACTIONS(2697),
    [anon_sym_NULL] = ACTIONS(2697),
    [anon_sym_nullptr] = ACTIONS(2697),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2697),
    [anon_sym_decltype] = ACTIONS(2697),
    [anon_sym_typename] = ACTIONS(2697),
    [anon_sym_template] = ACTIONS(2697),
    [anon_sym_try] = ACTIONS(2697),
    [anon_sym_delete] = ACTIONS(2697),
    [anon_sym_throw] = ACTIONS(2697),
    [anon_sym_co_return] = ACTIONS(2697),
    [anon_sym_co_yield] = ACTIONS(2697),
    [anon_sym_R_DQUOTE] = ACTIONS(2699),
    [anon_sym_LR_DQUOTE] = ACTIONS(2699),
    [anon_sym_uR_DQUOTE] = ACTIONS(2699),
    [anon_sym_UR_DQUOTE] = ACTIONS(2699),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2699),
    [anon_sym_co_await] = ACTIONS(2697),
    [anon_sym_new] = ACTIONS(2697),
    [anon_sym_requires] = ACTIONS(2697),
    [sym_this] = ACTIONS(2697),
  },
  [867] = {
    [sym_identifier] = ACTIONS(2723),
    [anon_sym_LPAREN2] = ACTIONS(2725),
    [anon_sym_BANG] = ACTIONS(2725),
    [anon_sym_TILDE] = ACTIONS(2725),
    [anon_sym_DASH] = ACTIONS(2723),
    [anon_sym_PLUS] = ACTIONS(2723),
    [anon_sym_STAR] = ACTIONS(2725),
    [anon_sym_AMP] = ACTIONS(2725),
    [anon_sym_SEMI] = ACTIONS(2725),
    [anon_sym___extension__] = ACTIONS(2723),
    [anon_sym_typedef] = ACTIONS(2723),
    [anon_sym_virtual] = ACTIONS(2723),
    [anon_sym_extern] = ACTIONS(2723),
    [anon_sym___attribute__] = ACTIONS(2723),
    [anon_sym___attribute] = ACTIONS(2723),
    [anon_sym_COLON_COLON] = ACTIONS(2725),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2725),
    [anon_sym___declspec] = ACTIONS(2723),
    [anon_sym_LBRACE] = ACTIONS(2725),
    [anon_sym_signed] = ACTIONS(2723),
    [anon_sym_unsigned] = ACTIONS(2723),
    [anon_sym_long] = ACTIONS(2723),
    [anon_sym_short] = ACTIONS(2723),
    [anon_sym_LBRACK] = ACTIONS(2723),
    [anon_sym_static] = ACTIONS(2723),
    [anon_sym_register] = ACTIONS(2723),
    [anon_sym_inline] = ACTIONS(2723),
    [anon_sym___inline] = ACTIONS(2723),
    [anon_sym___inline__] = ACTIONS(2723),
    [anon_sym___forceinline] = ACTIONS(2723),
    [anon_sym_thread_local] = ACTIONS(2723),
    [anon_sym___thread] = ACTIONS(2723),
    [anon_sym_const] = ACTIONS(2723),
    [anon_sym_constexpr] = ACTIONS(2723),
    [anon_sym_volatile] = ACTIONS(2723),
    [anon_sym_restrict] = ACTIONS(2723),
    [anon_sym___restrict__] = ACTIONS(2723),
    [anon_sym__Atomic] = ACTIONS(2723),
    [anon_sym__Noreturn] = ACTIONS(2723),
    [anon_sym_noreturn] = ACTIONS(2723),
    [anon_sym__Nonnull] = ACTIONS(2723),
    [anon_sym_mutable] = ACTIONS(2723),
    [anon_sym_constinit] = ACTIONS(2723),
    [anon_sym_consteval] = ACTIONS(2723),
    [anon_sym_alignas] = ACTIONS(2723),
    [anon_sym__Alignas] = ACTIONS(2723),
    [sym_primitive_type] = ACTIONS(2723),
    [anon_sym_enum] = ACTIONS(2723),
    [anon_sym_class] = ACTIONS(2723),
    [anon_sym_struct] = ACTIONS(2723),
    [anon_sym_union] = ACTIONS(2723),
    [anon_sym_if] = ACTIONS(2723),
    [anon_sym_else] = ACTIONS(2723),
    [anon_sym_switch] = ACTIONS(2723),
    [anon_sym_while] = ACTIONS(2723),
    [anon_sym_do] = ACTIONS(2723),
    [anon_sym_for] = ACTIONS(2723),
    [anon_sym_return] = ACTIONS(2723),
    [anon_sym_break] = ACTIONS(2723),
    [anon_sym_continue] = ACTIONS(2723),
    [anon_sym_goto] = ACTIONS(2723),
    [anon_sym___try] = ACTIONS(2723),
    [anon_sym___leave] = ACTIONS(2723),
    [anon_sym_not] = ACTIONS(2723),
    [anon_sym_compl] = ACTIONS(2723),
    [anon_sym_DASH_DASH] = ACTIONS(2725),
    [anon_sym_PLUS_PLUS] = ACTIONS(2725),
    [anon_sym_sizeof] = ACTIONS(2723),
    [anon_sym___alignof__] = ACTIONS(2723),
    [anon_sym___alignof] = ACTIONS(2723),
    [anon_sym__alignof] = ACTIONS(2723),
    [anon_sym_alignof] = ACTIONS(2723),
    [anon_sym__Alignof] = ACTIONS(2723),
    [anon_sym_offsetof] = ACTIONS(2723),
    [anon_sym__Generic] = ACTIONS(2723),
    [anon_sym_asm] = ACTIONS(2723),
    [anon_sym___asm__] = ACTIONS(2723),
    [anon_sym___asm] = ACTIONS(2723),
    [sym_number_literal] = ACTIONS(2725),
    [anon_sym_L_SQUOTE] = ACTIONS(2725),
    [anon_sym_u_SQUOTE] = ACTIONS(2725),
    [anon_sym_U_SQUOTE] = ACTIONS(2725),
    [anon_sym_u8_SQUOTE] = ACTIONS(2725),
    [anon_sym_SQUOTE] = ACTIONS(2725),
    [anon_sym_L_DQUOTE] = ACTIONS(2725),
    [anon_sym_u_DQUOTE] = ACTIONS(2725),
    [anon_sym_U_DQUOTE] = ACTIONS(2725),
    [anon_sym_u8_DQUOTE] = ACTIONS(2725),
    [anon_sym_DQUOTE] = ACTIONS(2725),
    [sym_true] = ACTIONS(2723),
    [sym_false] = ACTIONS(2723),
    [anon_sym_NULL] = ACTIONS(2723),
    [anon_sym_nullptr] = ACTIONS(2723),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2723),
    [anon_sym_decltype] = ACTIONS(2723),
    [anon_sym_typename] = ACTIONS(2723),
    [anon_sym_template] = ACTIONS(2723),
    [anon_sym_try] = ACTIONS(2723),
    [anon_sym_delete] = ACTIONS(2723),
    [anon_sym_throw] = ACTIONS(2723),
    [anon_sym_co_return] = ACTIONS(2723),
    [anon_sym_co_yield] = ACTIONS(2723),
    [anon_sym_R_DQUOTE] = ACTIONS(2725),
    [anon_sym_LR_DQUOTE] = ACTIONS(2725),
    [anon_sym_uR_DQUOTE] = ACTIONS(2725),
    [anon_sym_UR_DQUOTE] = ACTIONS(2725),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2725),
    [anon_sym_co_await] = ACTIONS(2723),
    [anon_sym_new] = ACTIONS(2723),
    [anon_sym_requires] = ACTIONS(2723),
    [sym_this] = ACTIONS(2723),
  },
  [868] = {
    [sym_identifier] = ACTIONS(2693),
    [anon_sym_LPAREN2] = ACTIONS(2695),
    [anon_sym_BANG] = ACTIONS(2695),
    [anon_sym_TILDE] = ACTIONS(2695),
    [anon_sym_DASH] = ACTIONS(2693),
    [anon_sym_PLUS] = ACTIONS(2693),
    [anon_sym_STAR] = ACTIONS(2695),
    [anon_sym_AMP] = ACTIONS(2695),
    [anon_sym_SEMI] = ACTIONS(2695),
    [anon_sym___extension__] = ACTIONS(2693),
    [anon_sym_typedef] = ACTIONS(2693),
    [anon_sym_virtual] = ACTIONS(2693),
    [anon_sym_extern] = ACTIONS(2693),
    [anon_sym___attribute__] = ACTIONS(2693),
    [anon_sym___attribute] = ACTIONS(2693),
    [anon_sym_COLON_COLON] = ACTIONS(2695),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2695),
    [anon_sym___declspec] = ACTIONS(2693),
    [anon_sym_LBRACE] = ACTIONS(2695),
    [anon_sym_signed] = ACTIONS(2693),
    [anon_sym_unsigned] = ACTIONS(2693),
    [anon_sym_long] = ACTIONS(2693),
    [anon_sym_short] = ACTIONS(2693),
    [anon_sym_LBRACK] = ACTIONS(2693),
    [anon_sym_static] = ACTIONS(2693),
    [anon_sym_register] = ACTIONS(2693),
    [anon_sym_inline] = ACTIONS(2693),
    [anon_sym___inline] = ACTIONS(2693),
    [anon_sym___inline__] = ACTIONS(2693),
    [anon_sym___forceinline] = ACTIONS(2693),
    [anon_sym_thread_local] = ACTIONS(2693),
    [anon_sym___thread] = ACTIONS(2693),
    [anon_sym_const] = ACTIONS(2693),
    [anon_sym_constexpr] = ACTIONS(2693),
    [anon_sym_volatile] = ACTIONS(2693),
    [anon_sym_restrict] = ACTIONS(2693),
    [anon_sym___restrict__] = ACTIONS(2693),
    [anon_sym__Atomic] = ACTIONS(2693),
    [anon_sym__Noreturn] = ACTIONS(2693),
    [anon_sym_noreturn] = ACTIONS(2693),
    [anon_sym__Nonnull] = ACTIONS(2693),
    [anon_sym_mutable] = ACTIONS(2693),
    [anon_sym_constinit] = ACTIONS(2693),
    [anon_sym_consteval] = ACTIONS(2693),
    [anon_sym_alignas] = ACTIONS(2693),
    [anon_sym__Alignas] = ACTIONS(2693),
    [sym_primitive_type] = ACTIONS(2693),
    [anon_sym_enum] = ACTIONS(2693),
    [anon_sym_class] = ACTIONS(2693),
    [anon_sym_struct] = ACTIONS(2693),
    [anon_sym_union] = ACTIONS(2693),
    [anon_sym_if] = ACTIONS(2693),
    [anon_sym_else] = ACTIONS(2693),
    [anon_sym_switch] = ACTIONS(2693),
    [anon_sym_while] = ACTIONS(2693),
    [anon_sym_do] = ACTIONS(2693),
    [anon_sym_for] = ACTIONS(2693),
    [anon_sym_return] = ACTIONS(2693),
    [anon_sym_break] = ACTIONS(2693),
    [anon_sym_continue] = ACTIONS(2693),
    [anon_sym_goto] = ACTIONS(2693),
    [anon_sym___try] = ACTIONS(2693),
    [anon_sym___leave] = ACTIONS(2693),
    [anon_sym_not] = ACTIONS(2693),
    [anon_sym_compl] = ACTIONS(2693),
    [anon_sym_DASH_DASH] = ACTIONS(2695),
    [anon_sym_PLUS_PLUS] = ACTIONS(2695),
    [anon_sym_sizeof] = ACTIONS(2693),
    [anon_sym___alignof__] = ACTIONS(2693),
    [anon_sym___alignof] = ACTIONS(2693),
    [anon_sym__alignof] = ACTIONS(2693),
    [anon_sym_alignof] = ACTIONS(2693),
    [anon_sym__Alignof] = ACTIONS(2693),
    [anon_sym_offsetof] = ACTIONS(2693),
    [anon_sym__Generic] = ACTIONS(2693),
    [anon_sym_asm] = ACTIONS(2693),
    [anon_sym___asm__] = ACTIONS(2693),
    [anon_sym___asm] = ACTIONS(2693),
    [sym_number_literal] = ACTIONS(2695),
    [anon_sym_L_SQUOTE] = ACTIONS(2695),
    [anon_sym_u_SQUOTE] = ACTIONS(2695),
    [anon_sym_U_SQUOTE] = ACTIONS(2695),
    [anon_sym_u8_SQUOTE] = ACTIONS(2695),
    [anon_sym_SQUOTE] = ACTIONS(2695),
    [anon_sym_L_DQUOTE] = ACTIONS(2695),
    [anon_sym_u_DQUOTE] = ACTIONS(2695),
    [anon_sym_U_DQUOTE] = ACTIONS(2695),
    [anon_sym_u8_DQUOTE] = ACTIONS(2695),
    [anon_sym_DQUOTE] = ACTIONS(2695),
    [sym_true] = ACTIONS(2693),
    [sym_false] = ACTIONS(2693),
    [anon_sym_NULL] = ACTIONS(2693),
    [anon_sym_nullptr] = ACTIONS(2693),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2693),
    [anon_sym_decltype] = ACTIONS(2693),
    [anon_sym_typename] = ACTIONS(2693),
    [anon_sym_template] = ACTIONS(2693),
    [anon_sym_try] = ACTIONS(2693),
    [anon_sym_delete] = ACTIONS(2693),
    [anon_sym_throw] = ACTIONS(2693),
    [anon_sym_co_return] = ACTIONS(2693),
    [anon_sym_co_yield] = ACTIONS(2693),
    [anon_sym_R_DQUOTE] = ACTIONS(2695),
    [anon_sym_LR_DQUOTE] = ACTIONS(2695),
    [anon_sym_uR_DQUOTE] = ACTIONS(2695),
    [anon_sym_UR_DQUOTE] = ACTIONS(2695),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2695),
    [anon_sym_co_await] = ACTIONS(2693),
    [anon_sym_new] = ACTIONS(2693),
    [anon_sym_requires] = ACTIONS(2693),
    [sym_this] = ACTIONS(2693),
  },
  [869] = {
    [sym_identifier] = ACTIONS(2621),
    [anon_sym_LPAREN2] = ACTIONS(2623),
    [anon_sym_BANG] = ACTIONS(2623),
    [anon_sym_TILDE] = ACTIONS(2623),
    [anon_sym_DASH] = ACTIONS(2621),
    [anon_sym_PLUS] = ACTIONS(2621),
    [anon_sym_STAR] = ACTIONS(2623),
    [anon_sym_AMP] = ACTIONS(2623),
    [anon_sym_SEMI] = ACTIONS(2623),
    [anon_sym___extension__] = ACTIONS(2621),
    [anon_sym_typedef] = ACTIONS(2621),
    [anon_sym_virtual] = ACTIONS(2621),
    [anon_sym_extern] = ACTIONS(2621),
    [anon_sym___attribute__] = ACTIONS(2621),
    [anon_sym___attribute] = ACTIONS(2621),
    [anon_sym_COLON_COLON] = ACTIONS(2623),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2623),
    [anon_sym___declspec] = ACTIONS(2621),
    [anon_sym_LBRACE] = ACTIONS(2623),
    [anon_sym_signed] = ACTIONS(2621),
    [anon_sym_unsigned] = ACTIONS(2621),
    [anon_sym_long] = ACTIONS(2621),
    [anon_sym_short] = ACTIONS(2621),
    [anon_sym_LBRACK] = ACTIONS(2621),
    [anon_sym_static] = ACTIONS(2621),
    [anon_sym_register] = ACTIONS(2621),
    [anon_sym_inline] = ACTIONS(2621),
    [anon_sym___inline] = ACTIONS(2621),
    [anon_sym___inline__] = ACTIONS(2621),
    [anon_sym___forceinline] = ACTIONS(2621),
    [anon_sym_thread_local] = ACTIONS(2621),
    [anon_sym___thread] = ACTIONS(2621),
    [anon_sym_const] = ACTIONS(2621),
    [anon_sym_constexpr] = ACTIONS(2621),
    [anon_sym_volatile] = ACTIONS(2621),
    [anon_sym_restrict] = ACTIONS(2621),
    [anon_sym___restrict__] = ACTIONS(2621),
    [anon_sym__Atomic] = ACTIONS(2621),
    [anon_sym__Noreturn] = ACTIONS(2621),
    [anon_sym_noreturn] = ACTIONS(2621),
    [anon_sym__Nonnull] = ACTIONS(2621),
    [anon_sym_mutable] = ACTIONS(2621),
    [anon_sym_constinit] = ACTIONS(2621),
    [anon_sym_consteval] = ACTIONS(2621),
    [anon_sym_alignas] = ACTIONS(2621),
    [anon_sym__Alignas] = ACTIONS(2621),
    [sym_primitive_type] = ACTIONS(2621),
    [anon_sym_enum] = ACTIONS(2621),
    [anon_sym_class] = ACTIONS(2621),
    [anon_sym_struct] = ACTIONS(2621),
    [anon_sym_union] = ACTIONS(2621),
    [anon_sym_if] = ACTIONS(2621),
    [anon_sym_else] = ACTIONS(2621),
    [anon_sym_switch] = ACTIONS(2621),
    [anon_sym_while] = ACTIONS(2621),
    [anon_sym_do] = ACTIONS(2621),
    [anon_sym_for] = ACTIONS(2621),
    [anon_sym_return] = ACTIONS(2621),
    [anon_sym_break] = ACTIONS(2621),
    [anon_sym_continue] = ACTIONS(2621),
    [anon_sym_goto] = ACTIONS(2621),
    [anon_sym___try] = ACTIONS(2621),
    [anon_sym___leave] = ACTIONS(2621),
    [anon_sym_not] = ACTIONS(2621),
    [anon_sym_compl] = ACTIONS(2621),
    [anon_sym_DASH_DASH] = ACTIONS(2623),
    [anon_sym_PLUS_PLUS] = ACTIONS(2623),
    [anon_sym_sizeof] = ACTIONS(2621),
    [anon_sym___alignof__] = ACTIONS(2621),
    [anon_sym___alignof] = ACTIONS(2621),
    [anon_sym__alignof] = ACTIONS(2621),
    [anon_sym_alignof] = ACTIONS(2621),
    [anon_sym__Alignof] = ACTIONS(2621),
    [anon_sym_offsetof] = ACTIONS(2621),
    [anon_sym__Generic] = ACTIONS(2621),
    [anon_sym_asm] = ACTIONS(2621),
    [anon_sym___asm__] = ACTIONS(2621),
    [anon_sym___asm] = ACTIONS(2621),
    [sym_number_literal] = ACTIONS(2623),
    [anon_sym_L_SQUOTE] = ACTIONS(2623),
    [anon_sym_u_SQUOTE] = ACTIONS(2623),
    [anon_sym_U_SQUOTE] = ACTIONS(2623),
    [anon_sym_u8_SQUOTE] = ACTIONS(2623),
    [anon_sym_SQUOTE] = ACTIONS(2623),
    [anon_sym_L_DQUOTE] = ACTIONS(2623),
    [anon_sym_u_DQUOTE] = ACTIONS(2623),
    [anon_sym_U_DQUOTE] = ACTIONS(2623),
    [anon_sym_u8_DQUOTE] = ACTIONS(2623),
    [anon_sym_DQUOTE] = ACTIONS(2623),
    [sym_true] = ACTIONS(2621),
    [sym_false] = ACTIONS(2621),
    [anon_sym_NULL] = ACTIONS(2621),
    [anon_sym_nullptr] = ACTIONS(2621),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2621),
    [anon_sym_decltype] = ACTIONS(2621),
    [anon_sym_typename] = ACTIONS(2621),
    [anon_sym_template] = ACTIONS(2621),
    [anon_sym_try] = ACTIONS(2621),
    [anon_sym_delete] = ACTIONS(2621),
    [anon_sym_throw] = ACTIONS(2621),
    [anon_sym_co_return] = ACTIONS(2621),
    [anon_sym_co_yield] = ACTIONS(2621),
    [anon_sym_R_DQUOTE] = ACTIONS(2623),
    [anon_sym_LR_DQUOTE] = ACTIONS(2623),
    [anon_sym_uR_DQUOTE] = ACTIONS(2623),
    [anon_sym_UR_DQUOTE] = ACTIONS(2623),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2623),
    [anon_sym_co_await] = ACTIONS(2621),
    [anon_sym_new] = ACTIONS(2621),
    [anon_sym_requires] = ACTIONS(2621),
    [sym_this] = ACTIONS(2621),
  },
  [870] = {
    [sym_identifier] = ACTIONS(2709),
    [anon_sym_LPAREN2] = ACTIONS(2711),
    [anon_sym_BANG] = ACTIONS(2711),
    [anon_sym_TILDE] = ACTIONS(2711),
    [anon_sym_DASH] = ACTIONS(2709),
    [anon_sym_PLUS] = ACTIONS(2709),
    [anon_sym_STAR] = ACTIONS(2711),
    [anon_sym_AMP] = ACTIONS(2711),
    [anon_sym_SEMI] = ACTIONS(2711),
    [anon_sym___extension__] = ACTIONS(2709),
    [anon_sym_typedef] = ACTIONS(2709),
    [anon_sym_virtual] = ACTIONS(2709),
    [anon_sym_extern] = ACTIONS(2709),
    [anon_sym___attribute__] = ACTIONS(2709),
    [anon_sym___attribute] = ACTIONS(2709),
    [anon_sym_COLON_COLON] = ACTIONS(2711),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2711),
    [anon_sym___declspec] = ACTIONS(2709),
    [anon_sym_LBRACE] = ACTIONS(2711),
    [anon_sym_signed] = ACTIONS(2709),
    [anon_sym_unsigned] = ACTIONS(2709),
    [anon_sym_long] = ACTIONS(2709),
    [anon_sym_short] = ACTIONS(2709),
    [anon_sym_LBRACK] = ACTIONS(2709),
    [anon_sym_static] = ACTIONS(2709),
    [anon_sym_register] = ACTIONS(2709),
    [anon_sym_inline] = ACTIONS(2709),
    [anon_sym___inline] = ACTIONS(2709),
    [anon_sym___inline__] = ACTIONS(2709),
    [anon_sym___forceinline] = ACTIONS(2709),
    [anon_sym_thread_local] = ACTIONS(2709),
    [anon_sym___thread] = ACTIONS(2709),
    [anon_sym_const] = ACTIONS(2709),
    [anon_sym_constexpr] = ACTIONS(2709),
    [anon_sym_volatile] = ACTIONS(2709),
    [anon_sym_restrict] = ACTIONS(2709),
    [anon_sym___restrict__] = ACTIONS(2709),
    [anon_sym__Atomic] = ACTIONS(2709),
    [anon_sym__Noreturn] = ACTIONS(2709),
    [anon_sym_noreturn] = ACTIONS(2709),
    [anon_sym__Nonnull] = ACTIONS(2709),
    [anon_sym_mutable] = ACTIONS(2709),
    [anon_sym_constinit] = ACTIONS(2709),
    [anon_sym_consteval] = ACTIONS(2709),
    [anon_sym_alignas] = ACTIONS(2709),
    [anon_sym__Alignas] = ACTIONS(2709),
    [sym_primitive_type] = ACTIONS(2709),
    [anon_sym_enum] = ACTIONS(2709),
    [anon_sym_class] = ACTIONS(2709),
    [anon_sym_struct] = ACTIONS(2709),
    [anon_sym_union] = ACTIONS(2709),
    [anon_sym_if] = ACTIONS(2709),
    [anon_sym_else] = ACTIONS(2709),
    [anon_sym_switch] = ACTIONS(2709),
    [anon_sym_while] = ACTIONS(2709),
    [anon_sym_do] = ACTIONS(2709),
    [anon_sym_for] = ACTIONS(2709),
    [anon_sym_return] = ACTIONS(2709),
    [anon_sym_break] = ACTIONS(2709),
    [anon_sym_continue] = ACTIONS(2709),
    [anon_sym_goto] = ACTIONS(2709),
    [anon_sym___try] = ACTIONS(2709),
    [anon_sym___leave] = ACTIONS(2709),
    [anon_sym_not] = ACTIONS(2709),
    [anon_sym_compl] = ACTIONS(2709),
    [anon_sym_DASH_DASH] = ACTIONS(2711),
    [anon_sym_PLUS_PLUS] = ACTIONS(2711),
    [anon_sym_sizeof] = ACTIONS(2709),
    [anon_sym___alignof__] = ACTIONS(2709),
    [anon_sym___alignof] = ACTIONS(2709),
    [anon_sym__alignof] = ACTIONS(2709),
    [anon_sym_alignof] = ACTIONS(2709),
    [anon_sym__Alignof] = ACTIONS(2709),
    [anon_sym_offsetof] = ACTIONS(2709),
    [anon_sym__Generic] = ACTIONS(2709),
    [anon_sym_asm] = ACTIONS(2709),
    [anon_sym___asm__] = ACTIONS(2709),
    [anon_sym___asm] = ACTIONS(2709),
    [sym_number_literal] = ACTIONS(2711),
    [anon_sym_L_SQUOTE] = ACTIONS(2711),
    [anon_sym_u_SQUOTE] = ACTIONS(2711),
    [anon_sym_U_SQUOTE] = ACTIONS(2711),
    [anon_sym_u8_SQUOTE] = ACTIONS(2711),
    [anon_sym_SQUOTE] = ACTIONS(2711),
    [anon_sym_L_DQUOTE] = ACTIONS(2711),
    [anon_sym_u_DQUOTE] = ACTIONS(2711),
    [anon_sym_U_DQUOTE] = ACTIONS(2711),
    [anon_sym_u8_DQUOTE] = ACTIONS(2711),
    [anon_sym_DQUOTE] = ACTIONS(2711),
    [sym_true] = ACTIONS(2709),
    [sym_false] = ACTIONS(2709),
    [anon_sym_NULL] = ACTIONS(2709),
    [anon_sym_nullptr] = ACTIONS(2709),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2709),
    [anon_sym_decltype] = ACTIONS(2709),
    [anon_sym_typename] = ACTIONS(2709),
    [anon_sym_template] = ACTIONS(2709),
    [anon_sym_try] = ACTIONS(2709),
    [anon_sym_delete] = ACTIONS(2709),
    [anon_sym_throw] = ACTIONS(2709),
    [anon_sym_co_return] = ACTIONS(2709),
    [anon_sym_co_yield] = ACTIONS(2709),
    [anon_sym_R_DQUOTE] = ACTIONS(2711),
    [anon_sym_LR_DQUOTE] = ACTIONS(2711),
    [anon_sym_uR_DQUOTE] = ACTIONS(2711),
    [anon_sym_UR_DQUOTE] = ACTIONS(2711),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2711),
    [anon_sym_co_await] = ACTIONS(2709),
    [anon_sym_new] = ACTIONS(2709),
    [anon_sym_requires] = ACTIONS(2709),
    [sym_this] = ACTIONS(2709),
  },
  [871] = {
    [sym_identifier] = ACTIONS(2633),
    [anon_sym_LPAREN2] = ACTIONS(2635),
    [anon_sym_BANG] = ACTIONS(2635),
    [anon_sym_TILDE] = ACTIONS(2635),
    [anon_sym_DASH] = ACTIONS(2633),
    [anon_sym_PLUS] = ACTIONS(2633),
    [anon_sym_STAR] = ACTIONS(2635),
    [anon_sym_AMP] = ACTIONS(2635),
    [anon_sym_SEMI] = ACTIONS(2635),
    [anon_sym___extension__] = ACTIONS(2633),
    [anon_sym_typedef] = ACTIONS(2633),
    [anon_sym_virtual] = ACTIONS(2633),
    [anon_sym_extern] = ACTIONS(2633),
    [anon_sym___attribute__] = ACTIONS(2633),
    [anon_sym___attribute] = ACTIONS(2633),
    [anon_sym_COLON_COLON] = ACTIONS(2635),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2635),
    [anon_sym___declspec] = ACTIONS(2633),
    [anon_sym_LBRACE] = ACTIONS(2635),
    [anon_sym_signed] = ACTIONS(2633),
    [anon_sym_unsigned] = ACTIONS(2633),
    [anon_sym_long] = ACTIONS(2633),
    [anon_sym_short] = ACTIONS(2633),
    [anon_sym_LBRACK] = ACTIONS(2633),
    [anon_sym_static] = ACTIONS(2633),
    [anon_sym_register] = ACTIONS(2633),
    [anon_sym_inline] = ACTIONS(2633),
    [anon_sym___inline] = ACTIONS(2633),
    [anon_sym___inline__] = ACTIONS(2633),
    [anon_sym___forceinline] = ACTIONS(2633),
    [anon_sym_thread_local] = ACTIONS(2633),
    [anon_sym___thread] = ACTIONS(2633),
    [anon_sym_const] = ACTIONS(2633),
    [anon_sym_constexpr] = ACTIONS(2633),
    [anon_sym_volatile] = ACTIONS(2633),
    [anon_sym_restrict] = ACTIONS(2633),
    [anon_sym___restrict__] = ACTIONS(2633),
    [anon_sym__Atomic] = ACTIONS(2633),
    [anon_sym__Noreturn] = ACTIONS(2633),
    [anon_sym_noreturn] = ACTIONS(2633),
    [anon_sym__Nonnull] = ACTIONS(2633),
    [anon_sym_mutable] = ACTIONS(2633),
    [anon_sym_constinit] = ACTIONS(2633),
    [anon_sym_consteval] = ACTIONS(2633),
    [anon_sym_alignas] = ACTIONS(2633),
    [anon_sym__Alignas] = ACTIONS(2633),
    [sym_primitive_type] = ACTIONS(2633),
    [anon_sym_enum] = ACTIONS(2633),
    [anon_sym_class] = ACTIONS(2633),
    [anon_sym_struct] = ACTIONS(2633),
    [anon_sym_union] = ACTIONS(2633),
    [anon_sym_if] = ACTIONS(2633),
    [anon_sym_else] = ACTIONS(2633),
    [anon_sym_switch] = ACTIONS(2633),
    [anon_sym_while] = ACTIONS(2633),
    [anon_sym_do] = ACTIONS(2633),
    [anon_sym_for] = ACTIONS(2633),
    [anon_sym_return] = ACTIONS(2633),
    [anon_sym_break] = ACTIONS(2633),
    [anon_sym_continue] = ACTIONS(2633),
    [anon_sym_goto] = ACTIONS(2633),
    [anon_sym___try] = ACTIONS(2633),
    [anon_sym___leave] = ACTIONS(2633),
    [anon_sym_not] = ACTIONS(2633),
    [anon_sym_compl] = ACTIONS(2633),
    [anon_sym_DASH_DASH] = ACTIONS(2635),
    [anon_sym_PLUS_PLUS] = ACTIONS(2635),
    [anon_sym_sizeof] = ACTIONS(2633),
    [anon_sym___alignof__] = ACTIONS(2633),
    [anon_sym___alignof] = ACTIONS(2633),
    [anon_sym__alignof] = ACTIONS(2633),
    [anon_sym_alignof] = ACTIONS(2633),
    [anon_sym__Alignof] = ACTIONS(2633),
    [anon_sym_offsetof] = ACTIONS(2633),
    [anon_sym__Generic] = ACTIONS(2633),
    [anon_sym_asm] = ACTIONS(2633),
    [anon_sym___asm__] = ACTIONS(2633),
    [anon_sym___asm] = ACTIONS(2633),
    [sym_number_literal] = ACTIONS(2635),
    [anon_sym_L_SQUOTE] = ACTIONS(2635),
    [anon_sym_u_SQUOTE] = ACTIONS(2635),
    [anon_sym_U_SQUOTE] = ACTIONS(2635),
    [anon_sym_u8_SQUOTE] = ACTIONS(2635),
    [anon_sym_SQUOTE] = ACTIONS(2635),
    [anon_sym_L_DQUOTE] = ACTIONS(2635),
    [anon_sym_u_DQUOTE] = ACTIONS(2635),
    [anon_sym_U_DQUOTE] = ACTIONS(2635),
    [anon_sym_u8_DQUOTE] = ACTIONS(2635),
    [anon_sym_DQUOTE] = ACTIONS(2635),
    [sym_true] = ACTIONS(2633),
    [sym_false] = ACTIONS(2633),
    [anon_sym_NULL] = ACTIONS(2633),
    [anon_sym_nullptr] = ACTIONS(2633),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2633),
    [anon_sym_decltype] = ACTIONS(2633),
    [anon_sym_typename] = ACTIONS(2633),
    [anon_sym_template] = ACTIONS(2633),
    [anon_sym_try] = ACTIONS(2633),
    [anon_sym_delete] = ACTIONS(2633),
    [anon_sym_throw] = ACTIONS(2633),
    [anon_sym_co_return] = ACTIONS(2633),
    [anon_sym_co_yield] = ACTIONS(2633),
    [anon_sym_R_DQUOTE] = ACTIONS(2635),
    [anon_sym_LR_DQUOTE] = ACTIONS(2635),
    [anon_sym_uR_DQUOTE] = ACTIONS(2635),
    [anon_sym_UR_DQUOTE] = ACTIONS(2635),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2635),
    [anon_sym_co_await] = ACTIONS(2633),
    [anon_sym_new] = ACTIONS(2633),
    [anon_sym_requires] = ACTIONS(2633),
    [sym_this] = ACTIONS(2633),
  },
  [872] = {
    [sym_identifier] = ACTIONS(2637),
    [anon_sym_LPAREN2] = ACTIONS(2639),
    [anon_sym_BANG] = ACTIONS(2639),
    [anon_sym_TILDE] = ACTIONS(2639),
    [anon_sym_DASH] = ACTIONS(2637),
    [anon_sym_PLUS] = ACTIONS(2637),
    [anon_sym_STAR] = ACTIONS(2639),
    [anon_sym_AMP] = ACTIONS(2639),
    [anon_sym_SEMI] = ACTIONS(2639),
    [anon_sym___extension__] = ACTIONS(2637),
    [anon_sym_typedef] = ACTIONS(2637),
    [anon_sym_virtual] = ACTIONS(2637),
    [anon_sym_extern] = ACTIONS(2637),
    [anon_sym___attribute__] = ACTIONS(2637),
    [anon_sym___attribute] = ACTIONS(2637),
    [anon_sym_COLON_COLON] = ACTIONS(2639),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2639),
    [anon_sym___declspec] = ACTIONS(2637),
    [anon_sym_LBRACE] = ACTIONS(2639),
    [anon_sym_signed] = ACTIONS(2637),
    [anon_sym_unsigned] = ACTIONS(2637),
    [anon_sym_long] = ACTIONS(2637),
    [anon_sym_short] = ACTIONS(2637),
    [anon_sym_LBRACK] = ACTIONS(2637),
    [anon_sym_static] = ACTIONS(2637),
    [anon_sym_register] = ACTIONS(2637),
    [anon_sym_inline] = ACTIONS(2637),
    [anon_sym___inline] = ACTIONS(2637),
    [anon_sym___inline__] = ACTIONS(2637),
    [anon_sym___forceinline] = ACTIONS(2637),
    [anon_sym_thread_local] = ACTIONS(2637),
    [anon_sym___thread] = ACTIONS(2637),
    [anon_sym_const] = ACTIONS(2637),
    [anon_sym_constexpr] = ACTIONS(2637),
    [anon_sym_volatile] = ACTIONS(2637),
    [anon_sym_restrict] = ACTIONS(2637),
    [anon_sym___restrict__] = ACTIONS(2637),
    [anon_sym__Atomic] = ACTIONS(2637),
    [anon_sym__Noreturn] = ACTIONS(2637),
    [anon_sym_noreturn] = ACTIONS(2637),
    [anon_sym__Nonnull] = ACTIONS(2637),
    [anon_sym_mutable] = ACTIONS(2637),
    [anon_sym_constinit] = ACTIONS(2637),
    [anon_sym_consteval] = ACTIONS(2637),
    [anon_sym_alignas] = ACTIONS(2637),
    [anon_sym__Alignas] = ACTIONS(2637),
    [sym_primitive_type] = ACTIONS(2637),
    [anon_sym_enum] = ACTIONS(2637),
    [anon_sym_class] = ACTIONS(2637),
    [anon_sym_struct] = ACTIONS(2637),
    [anon_sym_union] = ACTIONS(2637),
    [anon_sym_if] = ACTIONS(2637),
    [anon_sym_else] = ACTIONS(2637),
    [anon_sym_switch] = ACTIONS(2637),
    [anon_sym_while] = ACTIONS(2637),
    [anon_sym_do] = ACTIONS(2637),
    [anon_sym_for] = ACTIONS(2637),
    [anon_sym_return] = ACTIONS(2637),
    [anon_sym_break] = ACTIONS(2637),
    [anon_sym_continue] = ACTIONS(2637),
    [anon_sym_goto] = ACTIONS(2637),
    [anon_sym___try] = ACTIONS(2637),
    [anon_sym___leave] = ACTIONS(2637),
    [anon_sym_not] = ACTIONS(2637),
    [anon_sym_compl] = ACTIONS(2637),
    [anon_sym_DASH_DASH] = ACTIONS(2639),
    [anon_sym_PLUS_PLUS] = ACTIONS(2639),
    [anon_sym_sizeof] = ACTIONS(2637),
    [anon_sym___alignof__] = ACTIONS(2637),
    [anon_sym___alignof] = ACTIONS(2637),
    [anon_sym__alignof] = ACTIONS(2637),
    [anon_sym_alignof] = ACTIONS(2637),
    [anon_sym__Alignof] = ACTIONS(2637),
    [anon_sym_offsetof] = ACTIONS(2637),
    [anon_sym__Generic] = ACTIONS(2637),
    [anon_sym_asm] = ACTIONS(2637),
    [anon_sym___asm__] = ACTIONS(2637),
    [anon_sym___asm] = ACTIONS(2637),
    [sym_number_literal] = ACTIONS(2639),
    [anon_sym_L_SQUOTE] = ACTIONS(2639),
    [anon_sym_u_SQUOTE] = ACTIONS(2639),
    [anon_sym_U_SQUOTE] = ACTIONS(2639),
    [anon_sym_u8_SQUOTE] = ACTIONS(2639),
    [anon_sym_SQUOTE] = ACTIONS(2639),
    [anon_sym_L_DQUOTE] = ACTIONS(2639),
    [anon_sym_u_DQUOTE] = ACTIONS(2639),
    [anon_sym_U_DQUOTE] = ACTIONS(2639),
    [anon_sym_u8_DQUOTE] = ACTIONS(2639),
    [anon_sym_DQUOTE] = ACTIONS(2639),
    [sym_true] = ACTIONS(2637),
    [sym_false] = ACTIONS(2637),
    [anon_sym_NULL] = ACTIONS(2637),
    [anon_sym_nullptr] = ACTIONS(2637),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2637),
    [anon_sym_decltype] = ACTIONS(2637),
    [anon_sym_typename] = ACTIONS(2637),
    [anon_sym_template] = ACTIONS(2637),
    [anon_sym_try] = ACTIONS(2637),
    [anon_sym_delete] = ACTIONS(2637),
    [anon_sym_throw] = ACTIONS(2637),
    [anon_sym_co_return] = ACTIONS(2637),
    [anon_sym_co_yield] = ACTIONS(2637),
    [anon_sym_R_DQUOTE] = ACTIONS(2639),
    [anon_sym_LR_DQUOTE] = ACTIONS(2639),
    [anon_sym_uR_DQUOTE] = ACTIONS(2639),
    [anon_sym_UR_DQUOTE] = ACTIONS(2639),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2639),
    [anon_sym_co_await] = ACTIONS(2637),
    [anon_sym_new] = ACTIONS(2637),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2637),
  },
  [873] = {
    [sym_identifier] = ACTIONS(2637),
    [anon_sym_LPAREN2] = ACTIONS(2639),
    [anon_sym_BANG] = ACTIONS(2639),
    [anon_sym_TILDE] = ACTIONS(2639),
    [anon_sym_DASH] = ACTIONS(2637),
    [anon_sym_PLUS] = ACTIONS(2637),
    [anon_sym_STAR] = ACTIONS(2639),
    [anon_sym_AMP] = ACTIONS(2639),
    [anon_sym_SEMI] = ACTIONS(2639),
    [anon_sym___extension__] = ACTIONS(2637),
    [anon_sym_typedef] = ACTIONS(2637),
    [anon_sym_virtual] = ACTIONS(2637),
    [anon_sym_extern] = ACTIONS(2637),
    [anon_sym___attribute__] = ACTIONS(2637),
    [anon_sym___attribute] = ACTIONS(2637),
    [anon_sym_COLON_COLON] = ACTIONS(2639),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2639),
    [anon_sym___declspec] = ACTIONS(2637),
    [anon_sym_LBRACE] = ACTIONS(2639),
    [anon_sym_signed] = ACTIONS(2637),
    [anon_sym_unsigned] = ACTIONS(2637),
    [anon_sym_long] = ACTIONS(2637),
    [anon_sym_short] = ACTIONS(2637),
    [anon_sym_LBRACK] = ACTIONS(2637),
    [anon_sym_static] = ACTIONS(2637),
    [anon_sym_register] = ACTIONS(2637),
    [anon_sym_inline] = ACTIONS(2637),
    [anon_sym___inline] = ACTIONS(2637),
    [anon_sym___inline__] = ACTIONS(2637),
    [anon_sym___forceinline] = ACTIONS(2637),
    [anon_sym_thread_local] = ACTIONS(2637),
    [anon_sym___thread] = ACTIONS(2637),
    [anon_sym_const] = ACTIONS(2637),
    [anon_sym_constexpr] = ACTIONS(2637),
    [anon_sym_volatile] = ACTIONS(2637),
    [anon_sym_restrict] = ACTIONS(2637),
    [anon_sym___restrict__] = ACTIONS(2637),
    [anon_sym__Atomic] = ACTIONS(2637),
    [anon_sym__Noreturn] = ACTIONS(2637),
    [anon_sym_noreturn] = ACTIONS(2637),
    [anon_sym__Nonnull] = ACTIONS(2637),
    [anon_sym_mutable] = ACTIONS(2637),
    [anon_sym_constinit] = ACTIONS(2637),
    [anon_sym_consteval] = ACTIONS(2637),
    [anon_sym_alignas] = ACTIONS(2637),
    [anon_sym__Alignas] = ACTIONS(2637),
    [sym_primitive_type] = ACTIONS(2637),
    [anon_sym_enum] = ACTIONS(2637),
    [anon_sym_class] = ACTIONS(2637),
    [anon_sym_struct] = ACTIONS(2637),
    [anon_sym_union] = ACTIONS(2637),
    [anon_sym_if] = ACTIONS(2637),
    [anon_sym_else] = ACTIONS(2637),
    [anon_sym_switch] = ACTIONS(2637),
    [anon_sym_while] = ACTIONS(2637),
    [anon_sym_do] = ACTIONS(2637),
    [anon_sym_for] = ACTIONS(2637),
    [anon_sym_return] = ACTIONS(2637),
    [anon_sym_break] = ACTIONS(2637),
    [anon_sym_continue] = ACTIONS(2637),
    [anon_sym_goto] = ACTIONS(2637),
    [anon_sym___try] = ACTIONS(2637),
    [anon_sym___leave] = ACTIONS(2637),
    [anon_sym_not] = ACTIONS(2637),
    [anon_sym_compl] = ACTIONS(2637),
    [anon_sym_DASH_DASH] = ACTIONS(2639),
    [anon_sym_PLUS_PLUS] = ACTIONS(2639),
    [anon_sym_sizeof] = ACTIONS(2637),
    [anon_sym___alignof__] = ACTIONS(2637),
    [anon_sym___alignof] = ACTIONS(2637),
    [anon_sym__alignof] = ACTIONS(2637),
    [anon_sym_alignof] = ACTIONS(2637),
    [anon_sym__Alignof] = ACTIONS(2637),
    [anon_sym_offsetof] = ACTIONS(2637),
    [anon_sym__Generic] = ACTIONS(2637),
    [anon_sym_asm] = ACTIONS(2637),
    [anon_sym___asm__] = ACTIONS(2637),
    [anon_sym___asm] = ACTIONS(2637),
    [sym_number_literal] = ACTIONS(2639),
    [anon_sym_L_SQUOTE] = ACTIONS(2639),
    [anon_sym_u_SQUOTE] = ACTIONS(2639),
    [anon_sym_U_SQUOTE] = ACTIONS(2639),
    [anon_sym_u8_SQUOTE] = ACTIONS(2639),
    [anon_sym_SQUOTE] = ACTIONS(2639),
    [anon_sym_L_DQUOTE] = ACTIONS(2639),
    [anon_sym_u_DQUOTE] = ACTIONS(2639),
    [anon_sym_U_DQUOTE] = ACTIONS(2639),
    [anon_sym_u8_DQUOTE] = ACTIONS(2639),
    [anon_sym_DQUOTE] = ACTIONS(2639),
    [sym_true] = ACTIONS(2637),
    [sym_false] = ACTIONS(2637),
    [anon_sym_NULL] = ACTIONS(2637),
    [anon_sym_nullptr] = ACTIONS(2637),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2637),
    [anon_sym_decltype] = ACTIONS(2637),
    [anon_sym_typename] = ACTIONS(2637),
    [anon_sym_template] = ACTIONS(2637),
    [anon_sym_try] = ACTIONS(2637),
    [anon_sym_delete] = ACTIONS(2637),
    [anon_sym_throw] = ACTIONS(2637),
    [anon_sym_co_return] = ACTIONS(2637),
    [anon_sym_co_yield] = ACTIONS(2637),
    [anon_sym_R_DQUOTE] = ACTIONS(2639),
    [anon_sym_LR_DQUOTE] = ACTIONS(2639),
    [anon_sym_uR_DQUOTE] = ACTIONS(2639),
    [anon_sym_UR_DQUOTE] = ACTIONS(2639),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2639),
    [anon_sym_co_await] = ACTIONS(2637),
    [anon_sym_new] = ACTIONS(2637),
    [anon_sym_requires] = ACTIONS(2637),
    [sym_this] = ACTIONS(2637),
  },
  [874] = {
    [sym_identifier] = ACTIONS(2593),
    [anon_sym_LPAREN2] = ACTIONS(2595),
    [anon_sym_BANG] = ACTIONS(2595),
    [anon_sym_TILDE] = ACTIONS(2595),
    [anon_sym_DASH] = ACTIONS(2593),
    [anon_sym_PLUS] = ACTIONS(2593),
    [anon_sym_STAR] = ACTIONS(2595),
    [anon_sym_AMP] = ACTIONS(2595),
    [anon_sym_SEMI] = ACTIONS(2595),
    [anon_sym___extension__] = ACTIONS(2593),
    [anon_sym_typedef] = ACTIONS(2593),
    [anon_sym_virtual] = ACTIONS(2593),
    [anon_sym_extern] = ACTIONS(2593),
    [anon_sym___attribute__] = ACTIONS(2593),
    [anon_sym___attribute] = ACTIONS(2593),
    [anon_sym_COLON_COLON] = ACTIONS(2595),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2595),
    [anon_sym___declspec] = ACTIONS(2593),
    [anon_sym_LBRACE] = ACTIONS(2595),
    [anon_sym_signed] = ACTIONS(2593),
    [anon_sym_unsigned] = ACTIONS(2593),
    [anon_sym_long] = ACTIONS(2593),
    [anon_sym_short] = ACTIONS(2593),
    [anon_sym_LBRACK] = ACTIONS(2593),
    [anon_sym_static] = ACTIONS(2593),
    [anon_sym_register] = ACTIONS(2593),
    [anon_sym_inline] = ACTIONS(2593),
    [anon_sym___inline] = ACTIONS(2593),
    [anon_sym___inline__] = ACTIONS(2593),
    [anon_sym___forceinline] = ACTIONS(2593),
    [anon_sym_thread_local] = ACTIONS(2593),
    [anon_sym___thread] = ACTIONS(2593),
    [anon_sym_const] = ACTIONS(2593),
    [anon_sym_constexpr] = ACTIONS(2593),
    [anon_sym_volatile] = ACTIONS(2593),
    [anon_sym_restrict] = ACTIONS(2593),
    [anon_sym___restrict__] = ACTIONS(2593),
    [anon_sym__Atomic] = ACTIONS(2593),
    [anon_sym__Noreturn] = ACTIONS(2593),
    [anon_sym_noreturn] = ACTIONS(2593),
    [anon_sym__Nonnull] = ACTIONS(2593),
    [anon_sym_mutable] = ACTIONS(2593),
    [anon_sym_constinit] = ACTIONS(2593),
    [anon_sym_consteval] = ACTIONS(2593),
    [anon_sym_alignas] = ACTIONS(2593),
    [anon_sym__Alignas] = ACTIONS(2593),
    [sym_primitive_type] = ACTIONS(2593),
    [anon_sym_enum] = ACTIONS(2593),
    [anon_sym_class] = ACTIONS(2593),
    [anon_sym_struct] = ACTIONS(2593),
    [anon_sym_union] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2593),
    [anon_sym_else] = ACTIONS(2593),
    [anon_sym_switch] = ACTIONS(2593),
    [anon_sym_while] = ACTIONS(2593),
    [anon_sym_do] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2593),
    [anon_sym_return] = ACTIONS(2593),
    [anon_sym_break] = ACTIONS(2593),
    [anon_sym_continue] = ACTIONS(2593),
    [anon_sym_goto] = ACTIONS(2593),
    [anon_sym___try] = ACTIONS(2593),
    [anon_sym___leave] = ACTIONS(2593),
    [anon_sym_not] = ACTIONS(2593),
    [anon_sym_compl] = ACTIONS(2593),
    [anon_sym_DASH_DASH] = ACTIONS(2595),
    [anon_sym_PLUS_PLUS] = ACTIONS(2595),
    [anon_sym_sizeof] = ACTIONS(2593),
    [anon_sym___alignof__] = ACTIONS(2593),
    [anon_sym___alignof] = ACTIONS(2593),
    [anon_sym__alignof] = ACTIONS(2593),
    [anon_sym_alignof] = ACTIONS(2593),
    [anon_sym__Alignof] = ACTIONS(2593),
    [anon_sym_offsetof] = ACTIONS(2593),
    [anon_sym__Generic] = ACTIONS(2593),
    [anon_sym_asm] = ACTIONS(2593),
    [anon_sym___asm__] = ACTIONS(2593),
    [anon_sym___asm] = ACTIONS(2593),
    [sym_number_literal] = ACTIONS(2595),
    [anon_sym_L_SQUOTE] = ACTIONS(2595),
    [anon_sym_u_SQUOTE] = ACTIONS(2595),
    [anon_sym_U_SQUOTE] = ACTIONS(2595),
    [anon_sym_u8_SQUOTE] = ACTIONS(2595),
    [anon_sym_SQUOTE] = ACTIONS(2595),
    [anon_sym_L_DQUOTE] = ACTIONS(2595),
    [anon_sym_u_DQUOTE] = ACTIONS(2595),
    [anon_sym_U_DQUOTE] = ACTIONS(2595),
    [anon_sym_u8_DQUOTE] = ACTIONS(2595),
    [anon_sym_DQUOTE] = ACTIONS(2595),
    [sym_true] = ACTIONS(2593),
    [sym_false] = ACTIONS(2593),
    [anon_sym_NULL] = ACTIONS(2593),
    [anon_sym_nullptr] = ACTIONS(2593),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2593),
    [anon_sym_decltype] = ACTIONS(2593),
    [anon_sym_typename] = ACTIONS(2593),
    [anon_sym_template] = ACTIONS(2593),
    [anon_sym_try] = ACTIONS(2593),
    [anon_sym_delete] = ACTIONS(2593),
    [anon_sym_throw] = ACTIONS(2593),
    [anon_sym_co_return] = ACTIONS(2593),
    [anon_sym_co_yield] = ACTIONS(2593),
    [anon_sym_R_DQUOTE] = ACTIONS(2595),
    [anon_sym_LR_DQUOTE] = ACTIONS(2595),
    [anon_sym_uR_DQUOTE] = ACTIONS(2595),
    [anon_sym_UR_DQUOTE] = ACTIONS(2595),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2595),
    [anon_sym_co_await] = ACTIONS(2593),
    [anon_sym_new] = ACTIONS(2593),
    [anon_sym_requires] = ACTIONS(2593),
    [sym_this] = ACTIONS(2593),
  },
  [875] = {
    [sym_identifier] = ACTIONS(2705),
    [anon_sym_LPAREN2] = ACTIONS(2707),
    [anon_sym_BANG] = ACTIONS(2707),
    [anon_sym_TILDE] = ACTIONS(2707),
    [anon_sym_DASH] = ACTIONS(2705),
    [anon_sym_PLUS] = ACTIONS(2705),
    [anon_sym_STAR] = ACTIONS(2707),
    [anon_sym_AMP] = ACTIONS(2707),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym___extension__] = ACTIONS(2705),
    [anon_sym_typedef] = ACTIONS(2705),
    [anon_sym_virtual] = ACTIONS(2705),
    [anon_sym_extern] = ACTIONS(2705),
    [anon_sym___attribute__] = ACTIONS(2705),
    [anon_sym___attribute] = ACTIONS(2705),
    [anon_sym_COLON_COLON] = ACTIONS(2707),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2707),
    [anon_sym___declspec] = ACTIONS(2705),
    [anon_sym_LBRACE] = ACTIONS(2707),
    [anon_sym_signed] = ACTIONS(2705),
    [anon_sym_unsigned] = ACTIONS(2705),
    [anon_sym_long] = ACTIONS(2705),
    [anon_sym_short] = ACTIONS(2705),
    [anon_sym_LBRACK] = ACTIONS(2705),
    [anon_sym_static] = ACTIONS(2705),
    [anon_sym_register] = ACTIONS(2705),
    [anon_sym_inline] = ACTIONS(2705),
    [anon_sym___inline] = ACTIONS(2705),
    [anon_sym___inline__] = ACTIONS(2705),
    [anon_sym___forceinline] = ACTIONS(2705),
    [anon_sym_thread_local] = ACTIONS(2705),
    [anon_sym___thread] = ACTIONS(2705),
    [anon_sym_const] = ACTIONS(2705),
    [anon_sym_constexpr] = ACTIONS(2705),
    [anon_sym_volatile] = ACTIONS(2705),
    [anon_sym_restrict] = ACTIONS(2705),
    [anon_sym___restrict__] = ACTIONS(2705),
    [anon_sym__Atomic] = ACTIONS(2705),
    [anon_sym__Noreturn] = ACTIONS(2705),
    [anon_sym_noreturn] = ACTIONS(2705),
    [anon_sym__Nonnull] = ACTIONS(2705),
    [anon_sym_mutable] = ACTIONS(2705),
    [anon_sym_constinit] = ACTIONS(2705),
    [anon_sym_consteval] = ACTIONS(2705),
    [anon_sym_alignas] = ACTIONS(2705),
    [anon_sym__Alignas] = ACTIONS(2705),
    [sym_primitive_type] = ACTIONS(2705),
    [anon_sym_enum] = ACTIONS(2705),
    [anon_sym_class] = ACTIONS(2705),
    [anon_sym_struct] = ACTIONS(2705),
    [anon_sym_union] = ACTIONS(2705),
    [anon_sym_if] = ACTIONS(2705),
    [anon_sym_else] = ACTIONS(2705),
    [anon_sym_switch] = ACTIONS(2705),
    [anon_sym_while] = ACTIONS(2705),
    [anon_sym_do] = ACTIONS(2705),
    [anon_sym_for] = ACTIONS(2705),
    [anon_sym_return] = ACTIONS(2705),
    [anon_sym_break] = ACTIONS(2705),
    [anon_sym_continue] = ACTIONS(2705),
    [anon_sym_goto] = ACTIONS(2705),
    [anon_sym___try] = ACTIONS(2705),
    [anon_sym___leave] = ACTIONS(2705),
    [anon_sym_not] = ACTIONS(2705),
    [anon_sym_compl] = ACTIONS(2705),
    [anon_sym_DASH_DASH] = ACTIONS(2707),
    [anon_sym_PLUS_PLUS] = ACTIONS(2707),
    [anon_sym_sizeof] = ACTIONS(2705),
    [anon_sym___alignof__] = ACTIONS(2705),
    [anon_sym___alignof] = ACTIONS(2705),
    [anon_sym__alignof] = ACTIONS(2705),
    [anon_sym_alignof] = ACTIONS(2705),
    [anon_sym__Alignof] = ACTIONS(2705),
    [anon_sym_offsetof] = ACTIONS(2705),
    [anon_sym__Generic] = ACTIONS(2705),
    [anon_sym_asm] = ACTIONS(2705),
    [anon_sym___asm__] = ACTIONS(2705),
    [anon_sym___asm] = ACTIONS(2705),
    [sym_number_literal] = ACTIONS(2707),
    [anon_sym_L_SQUOTE] = ACTIONS(2707),
    [anon_sym_u_SQUOTE] = ACTIONS(2707),
    [anon_sym_U_SQUOTE] = ACTIONS(2707),
    [anon_sym_u8_SQUOTE] = ACTIONS(2707),
    [anon_sym_SQUOTE] = ACTIONS(2707),
    [anon_sym_L_DQUOTE] = ACTIONS(2707),
    [anon_sym_u_DQUOTE] = ACTIONS(2707),
    [anon_sym_U_DQUOTE] = ACTIONS(2707),
    [anon_sym_u8_DQUOTE] = ACTIONS(2707),
    [anon_sym_DQUOTE] = ACTIONS(2707),
    [sym_true] = ACTIONS(2705),
    [sym_false] = ACTIONS(2705),
    [anon_sym_NULL] = ACTIONS(2705),
    [anon_sym_nullptr] = ACTIONS(2705),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2705),
    [anon_sym_decltype] = ACTIONS(2705),
    [anon_sym_typename] = ACTIONS(2705),
    [anon_sym_template] = ACTIONS(2705),
    [anon_sym_try] = ACTIONS(2705),
    [anon_sym_delete] = ACTIONS(2705),
    [anon_sym_throw] = ACTIONS(2705),
    [anon_sym_co_return] = ACTIONS(2705),
    [anon_sym_co_yield] = ACTIONS(2705),
    [anon_sym_R_DQUOTE] = ACTIONS(2707),
    [anon_sym_LR_DQUOTE] = ACTIONS(2707),
    [anon_sym_uR_DQUOTE] = ACTIONS(2707),
    [anon_sym_UR_DQUOTE] = ACTIONS(2707),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2707),
    [anon_sym_co_await] = ACTIONS(2705),
    [anon_sym_new] = ACTIONS(2705),
    [anon_sym_requires] = ACTIONS(2705),
    [sym_this] = ACTIONS(2705),
  },
  [876] = {
    [sym_identifier] = ACTIONS(2713),
    [anon_sym_LPAREN2] = ACTIONS(2715),
    [anon_sym_BANG] = ACTIONS(2715),
    [anon_sym_TILDE] = ACTIONS(2715),
    [anon_sym_DASH] = ACTIONS(2713),
    [anon_sym_PLUS] = ACTIONS(2713),
    [anon_sym_STAR] = ACTIONS(2715),
    [anon_sym_AMP] = ACTIONS(2715),
    [anon_sym_SEMI] = ACTIONS(2715),
    [anon_sym___extension__] = ACTIONS(2713),
    [anon_sym_typedef] = ACTIONS(2713),
    [anon_sym_virtual] = ACTIONS(2713),
    [anon_sym_extern] = ACTIONS(2713),
    [anon_sym___attribute__] = ACTIONS(2713),
    [anon_sym___attribute] = ACTIONS(2713),
    [anon_sym_COLON_COLON] = ACTIONS(2715),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2715),
    [anon_sym___declspec] = ACTIONS(2713),
    [anon_sym_LBRACE] = ACTIONS(2715),
    [anon_sym_signed] = ACTIONS(2713),
    [anon_sym_unsigned] = ACTIONS(2713),
    [anon_sym_long] = ACTIONS(2713),
    [anon_sym_short] = ACTIONS(2713),
    [anon_sym_LBRACK] = ACTIONS(2713),
    [anon_sym_static] = ACTIONS(2713),
    [anon_sym_register] = ACTIONS(2713),
    [anon_sym_inline] = ACTIONS(2713),
    [anon_sym___inline] = ACTIONS(2713),
    [anon_sym___inline__] = ACTIONS(2713),
    [anon_sym___forceinline] = ACTIONS(2713),
    [anon_sym_thread_local] = ACTIONS(2713),
    [anon_sym___thread] = ACTIONS(2713),
    [anon_sym_const] = ACTIONS(2713),
    [anon_sym_constexpr] = ACTIONS(2713),
    [anon_sym_volatile] = ACTIONS(2713),
    [anon_sym_restrict] = ACTIONS(2713),
    [anon_sym___restrict__] = ACTIONS(2713),
    [anon_sym__Atomic] = ACTIONS(2713),
    [anon_sym__Noreturn] = ACTIONS(2713),
    [anon_sym_noreturn] = ACTIONS(2713),
    [anon_sym__Nonnull] = ACTIONS(2713),
    [anon_sym_mutable] = ACTIONS(2713),
    [anon_sym_constinit] = ACTIONS(2713),
    [anon_sym_consteval] = ACTIONS(2713),
    [anon_sym_alignas] = ACTIONS(2713),
    [anon_sym__Alignas] = ACTIONS(2713),
    [sym_primitive_type] = ACTIONS(2713),
    [anon_sym_enum] = ACTIONS(2713),
    [anon_sym_class] = ACTIONS(2713),
    [anon_sym_struct] = ACTIONS(2713),
    [anon_sym_union] = ACTIONS(2713),
    [anon_sym_if] = ACTIONS(2713),
    [anon_sym_else] = ACTIONS(2713),
    [anon_sym_switch] = ACTIONS(2713),
    [anon_sym_while] = ACTIONS(2713),
    [anon_sym_do] = ACTIONS(2713),
    [anon_sym_for] = ACTIONS(2713),
    [anon_sym_return] = ACTIONS(2713),
    [anon_sym_break] = ACTIONS(2713),
    [anon_sym_continue] = ACTIONS(2713),
    [anon_sym_goto] = ACTIONS(2713),
    [anon_sym___try] = ACTIONS(2713),
    [anon_sym___leave] = ACTIONS(2713),
    [anon_sym_not] = ACTIONS(2713),
    [anon_sym_compl] = ACTIONS(2713),
    [anon_sym_DASH_DASH] = ACTIONS(2715),
    [anon_sym_PLUS_PLUS] = ACTIONS(2715),
    [anon_sym_sizeof] = ACTIONS(2713),
    [anon_sym___alignof__] = ACTIONS(2713),
    [anon_sym___alignof] = ACTIONS(2713),
    [anon_sym__alignof] = ACTIONS(2713),
    [anon_sym_alignof] = ACTIONS(2713),
    [anon_sym__Alignof] = ACTIONS(2713),
    [anon_sym_offsetof] = ACTIONS(2713),
    [anon_sym__Generic] = ACTIONS(2713),
    [anon_sym_asm] = ACTIONS(2713),
    [anon_sym___asm__] = ACTIONS(2713),
    [anon_sym___asm] = ACTIONS(2713),
    [sym_number_literal] = ACTIONS(2715),
    [anon_sym_L_SQUOTE] = ACTIONS(2715),
    [anon_sym_u_SQUOTE] = ACTIONS(2715),
    [anon_sym_U_SQUOTE] = ACTIONS(2715),
    [anon_sym_u8_SQUOTE] = ACTIONS(2715),
    [anon_sym_SQUOTE] = ACTIONS(2715),
    [anon_sym_L_DQUOTE] = ACTIONS(2715),
    [anon_sym_u_DQUOTE] = ACTIONS(2715),
    [anon_sym_U_DQUOTE] = ACTIONS(2715),
    [anon_sym_u8_DQUOTE] = ACTIONS(2715),
    [anon_sym_DQUOTE] = ACTIONS(2715),
    [sym_true] = ACTIONS(2713),
    [sym_false] = ACTIONS(2713),
    [anon_sym_NULL] = ACTIONS(2713),
    [anon_sym_nullptr] = ACTIONS(2713),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2713),
    [anon_sym_decltype] = ACTIONS(2713),
    [anon_sym_typename] = ACTIONS(2713),
    [anon_sym_template] = ACTIONS(2713),
    [anon_sym_try] = ACTIONS(2713),
    [anon_sym_delete] = ACTIONS(2713),
    [anon_sym_throw] = ACTIONS(2713),
    [anon_sym_co_return] = ACTIONS(2713),
    [anon_sym_co_yield] = ACTIONS(2713),
    [anon_sym_R_DQUOTE] = ACTIONS(2715),
    [anon_sym_LR_DQUOTE] = ACTIONS(2715),
    [anon_sym_uR_DQUOTE] = ACTIONS(2715),
    [anon_sym_UR_DQUOTE] = ACTIONS(2715),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2715),
    [anon_sym_co_await] = ACTIONS(2713),
    [anon_sym_new] = ACTIONS(2713),
    [anon_sym_requires] = ACTIONS(2713),
    [sym_this] = ACTIONS(2713),
  },
  [877] = {
    [sym_identifier] = ACTIONS(2589),
    [anon_sym_LPAREN2] = ACTIONS(2591),
    [anon_sym_BANG] = ACTIONS(2591),
    [anon_sym_TILDE] = ACTIONS(2591),
    [anon_sym_DASH] = ACTIONS(2589),
    [anon_sym_PLUS] = ACTIONS(2589),
    [anon_sym_STAR] = ACTIONS(2591),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_SEMI] = ACTIONS(2591),
    [anon_sym___extension__] = ACTIONS(2589),
    [anon_sym_typedef] = ACTIONS(2589),
    [anon_sym_virtual] = ACTIONS(2589),
    [anon_sym_extern] = ACTIONS(2589),
    [anon_sym___attribute__] = ACTIONS(2589),
    [anon_sym___attribute] = ACTIONS(2589),
    [anon_sym_COLON_COLON] = ACTIONS(2591),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2591),
    [anon_sym___declspec] = ACTIONS(2589),
    [anon_sym_LBRACE] = ACTIONS(2591),
    [anon_sym_signed] = ACTIONS(2589),
    [anon_sym_unsigned] = ACTIONS(2589),
    [anon_sym_long] = ACTIONS(2589),
    [anon_sym_short] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(2589),
    [anon_sym_static] = ACTIONS(2589),
    [anon_sym_register] = ACTIONS(2589),
    [anon_sym_inline] = ACTIONS(2589),
    [anon_sym___inline] = ACTIONS(2589),
    [anon_sym___inline__] = ACTIONS(2589),
    [anon_sym___forceinline] = ACTIONS(2589),
    [anon_sym_thread_local] = ACTIONS(2589),
    [anon_sym___thread] = ACTIONS(2589),
    [anon_sym_const] = ACTIONS(2589),
    [anon_sym_constexpr] = ACTIONS(2589),
    [anon_sym_volatile] = ACTIONS(2589),
    [anon_sym_restrict] = ACTIONS(2589),
    [anon_sym___restrict__] = ACTIONS(2589),
    [anon_sym__Atomic] = ACTIONS(2589),
    [anon_sym__Noreturn] = ACTIONS(2589),
    [anon_sym_noreturn] = ACTIONS(2589),
    [anon_sym__Nonnull] = ACTIONS(2589),
    [anon_sym_mutable] = ACTIONS(2589),
    [anon_sym_constinit] = ACTIONS(2589),
    [anon_sym_consteval] = ACTIONS(2589),
    [anon_sym_alignas] = ACTIONS(2589),
    [anon_sym__Alignas] = ACTIONS(2589),
    [sym_primitive_type] = ACTIONS(2589),
    [anon_sym_enum] = ACTIONS(2589),
    [anon_sym_class] = ACTIONS(2589),
    [anon_sym_struct] = ACTIONS(2589),
    [anon_sym_union] = ACTIONS(2589),
    [anon_sym_if] = ACTIONS(2589),
    [anon_sym_else] = ACTIONS(2589),
    [anon_sym_switch] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2589),
    [anon_sym_do] = ACTIONS(2589),
    [anon_sym_for] = ACTIONS(2589),
    [anon_sym_return] = ACTIONS(2589),
    [anon_sym_break] = ACTIONS(2589),
    [anon_sym_continue] = ACTIONS(2589),
    [anon_sym_goto] = ACTIONS(2589),
    [anon_sym___try] = ACTIONS(2589),
    [anon_sym___leave] = ACTIONS(2589),
    [anon_sym_not] = ACTIONS(2589),
    [anon_sym_compl] = ACTIONS(2589),
    [anon_sym_DASH_DASH] = ACTIONS(2591),
    [anon_sym_PLUS_PLUS] = ACTIONS(2591),
    [anon_sym_sizeof] = ACTIONS(2589),
    [anon_sym___alignof__] = ACTIONS(2589),
    [anon_sym___alignof] = ACTIONS(2589),
    [anon_sym__alignof] = ACTIONS(2589),
    [anon_sym_alignof] = ACTIONS(2589),
    [anon_sym__Alignof] = ACTIONS(2589),
    [anon_sym_offsetof] = ACTIONS(2589),
    [anon_sym__Generic] = ACTIONS(2589),
    [anon_sym_asm] = ACTIONS(2589),
    [anon_sym___asm__] = ACTIONS(2589),
    [anon_sym___asm] = ACTIONS(2589),
    [sym_number_literal] = ACTIONS(2591),
    [anon_sym_L_SQUOTE] = ACTIONS(2591),
    [anon_sym_u_SQUOTE] = ACTIONS(2591),
    [anon_sym_U_SQUOTE] = ACTIONS(2591),
    [anon_sym_u8_SQUOTE] = ACTIONS(2591),
    [anon_sym_SQUOTE] = ACTIONS(2591),
    [anon_sym_L_DQUOTE] = ACTIONS(2591),
    [anon_sym_u_DQUOTE] = ACTIONS(2591),
    [anon_sym_U_DQUOTE] = ACTIONS(2591),
    [anon_sym_u8_DQUOTE] = ACTIONS(2591),
    [anon_sym_DQUOTE] = ACTIONS(2591),
    [sym_true] = ACTIONS(2589),
    [sym_false] = ACTIONS(2589),
    [anon_sym_NULL] = ACTIONS(2589),
    [anon_sym_nullptr] = ACTIONS(2589),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2589),
    [anon_sym_decltype] = ACTIONS(2589),
    [anon_sym_typename] = ACTIONS(2589),
    [anon_sym_template] = ACTIONS(2589),
    [anon_sym_try] = ACTIONS(2589),
    [anon_sym_delete] = ACTIONS(2589),
    [anon_sym_throw] = ACTIONS(2589),
    [anon_sym_co_return] = ACTIONS(2589),
    [anon_sym_co_yield] = ACTIONS(2589),
    [anon_sym_R_DQUOTE] = ACTIONS(2591),
    [anon_sym_LR_DQUOTE] = ACTIONS(2591),
    [anon_sym_uR_DQUOTE] = ACTIONS(2591),
    [anon_sym_UR_DQUOTE] = ACTIONS(2591),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2591),
    [anon_sym_co_await] = ACTIONS(2589),
    [anon_sym_new] = ACTIONS(2589),
    [anon_sym_requires] = ACTIONS(2589),
    [sym_this] = ACTIONS(2589),
  },
  [878] = {
    [sym_identifier] = ACTIONS(2701),
    [anon_sym_LPAREN2] = ACTIONS(2703),
    [anon_sym_BANG] = ACTIONS(2703),
    [anon_sym_TILDE] = ACTIONS(2703),
    [anon_sym_DASH] = ACTIONS(2701),
    [anon_sym_PLUS] = ACTIONS(2701),
    [anon_sym_STAR] = ACTIONS(2703),
    [anon_sym_AMP] = ACTIONS(2703),
    [anon_sym_SEMI] = ACTIONS(2703),
    [anon_sym___extension__] = ACTIONS(2701),
    [anon_sym_typedef] = ACTIONS(2701),
    [anon_sym_virtual] = ACTIONS(2701),
    [anon_sym_extern] = ACTIONS(2701),
    [anon_sym___attribute__] = ACTIONS(2701),
    [anon_sym___attribute] = ACTIONS(2701),
    [anon_sym_COLON_COLON] = ACTIONS(2703),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2703),
    [anon_sym___declspec] = ACTIONS(2701),
    [anon_sym_LBRACE] = ACTIONS(2703),
    [anon_sym_signed] = ACTIONS(2701),
    [anon_sym_unsigned] = ACTIONS(2701),
    [anon_sym_long] = ACTIONS(2701),
    [anon_sym_short] = ACTIONS(2701),
    [anon_sym_LBRACK] = ACTIONS(2701),
    [anon_sym_static] = ACTIONS(2701),
    [anon_sym_register] = ACTIONS(2701),
    [anon_sym_inline] = ACTIONS(2701),
    [anon_sym___inline] = ACTIONS(2701),
    [anon_sym___inline__] = ACTIONS(2701),
    [anon_sym___forceinline] = ACTIONS(2701),
    [anon_sym_thread_local] = ACTIONS(2701),
    [anon_sym___thread] = ACTIONS(2701),
    [anon_sym_const] = ACTIONS(2701),
    [anon_sym_constexpr] = ACTIONS(2701),
    [anon_sym_volatile] = ACTIONS(2701),
    [anon_sym_restrict] = ACTIONS(2701),
    [anon_sym___restrict__] = ACTIONS(2701),
    [anon_sym__Atomic] = ACTIONS(2701),
    [anon_sym__Noreturn] = ACTIONS(2701),
    [anon_sym_noreturn] = ACTIONS(2701),
    [anon_sym__Nonnull] = ACTIONS(2701),
    [anon_sym_mutable] = ACTIONS(2701),
    [anon_sym_constinit] = ACTIONS(2701),
    [anon_sym_consteval] = ACTIONS(2701),
    [anon_sym_alignas] = ACTIONS(2701),
    [anon_sym__Alignas] = ACTIONS(2701),
    [sym_primitive_type] = ACTIONS(2701),
    [anon_sym_enum] = ACTIONS(2701),
    [anon_sym_class] = ACTIONS(2701),
    [anon_sym_struct] = ACTIONS(2701),
    [anon_sym_union] = ACTIONS(2701),
    [anon_sym_if] = ACTIONS(2701),
    [anon_sym_else] = ACTIONS(2701),
    [anon_sym_switch] = ACTIONS(2701),
    [anon_sym_while] = ACTIONS(2701),
    [anon_sym_do] = ACTIONS(2701),
    [anon_sym_for] = ACTIONS(2701),
    [anon_sym_return] = ACTIONS(2701),
    [anon_sym_break] = ACTIONS(2701),
    [anon_sym_continue] = ACTIONS(2701),
    [anon_sym_goto] = ACTIONS(2701),
    [anon_sym___try] = ACTIONS(2701),
    [anon_sym___leave] = ACTIONS(2701),
    [anon_sym_not] = ACTIONS(2701),
    [anon_sym_compl] = ACTIONS(2701),
    [anon_sym_DASH_DASH] = ACTIONS(2703),
    [anon_sym_PLUS_PLUS] = ACTIONS(2703),
    [anon_sym_sizeof] = ACTIONS(2701),
    [anon_sym___alignof__] = ACTIONS(2701),
    [anon_sym___alignof] = ACTIONS(2701),
    [anon_sym__alignof] = ACTIONS(2701),
    [anon_sym_alignof] = ACTIONS(2701),
    [anon_sym__Alignof] = ACTIONS(2701),
    [anon_sym_offsetof] = ACTIONS(2701),
    [anon_sym__Generic] = ACTIONS(2701),
    [anon_sym_asm] = ACTIONS(2701),
    [anon_sym___asm__] = ACTIONS(2701),
    [anon_sym___asm] = ACTIONS(2701),
    [sym_number_literal] = ACTIONS(2703),
    [anon_sym_L_SQUOTE] = ACTIONS(2703),
    [anon_sym_u_SQUOTE] = ACTIONS(2703),
    [anon_sym_U_SQUOTE] = ACTIONS(2703),
    [anon_sym_u8_SQUOTE] = ACTIONS(2703),
    [anon_sym_SQUOTE] = ACTIONS(2703),
    [anon_sym_L_DQUOTE] = ACTIONS(2703),
    [anon_sym_u_DQUOTE] = ACTIONS(2703),
    [anon_sym_U_DQUOTE] = ACTIONS(2703),
    [anon_sym_u8_DQUOTE] = ACTIONS(2703),
    [anon_sym_DQUOTE] = ACTIONS(2703),
    [sym_true] = ACTIONS(2701),
    [sym_false] = ACTIONS(2701),
    [anon_sym_NULL] = ACTIONS(2701),
    [anon_sym_nullptr] = ACTIONS(2701),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2701),
    [anon_sym_decltype] = ACTIONS(2701),
    [anon_sym_typename] = ACTIONS(2701),
    [anon_sym_template] = ACTIONS(2701),
    [anon_sym_try] = ACTIONS(2701),
    [anon_sym_delete] = ACTIONS(2701),
    [anon_sym_throw] = ACTIONS(2701),
    [anon_sym_co_return] = ACTIONS(2701),
    [anon_sym_co_yield] = ACTIONS(2701),
    [anon_sym_R_DQUOTE] = ACTIONS(2703),
    [anon_sym_LR_DQUOTE] = ACTIONS(2703),
    [anon_sym_uR_DQUOTE] = ACTIONS(2703),
    [anon_sym_UR_DQUOTE] = ACTIONS(2703),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2703),
    [anon_sym_co_await] = ACTIONS(2701),
    [anon_sym_new] = ACTIONS(2701),
    [anon_sym_requires] = ACTIONS(2701),
    [sym_this] = ACTIONS(2701),
  },
  [879] = {
    [sym_identifier] = ACTIONS(2597),
    [anon_sym_LPAREN2] = ACTIONS(2599),
    [anon_sym_BANG] = ACTIONS(2599),
    [anon_sym_TILDE] = ACTIONS(2599),
    [anon_sym_DASH] = ACTIONS(2597),
    [anon_sym_PLUS] = ACTIONS(2597),
    [anon_sym_STAR] = ACTIONS(2599),
    [anon_sym_AMP] = ACTIONS(2599),
    [anon_sym_SEMI] = ACTIONS(2599),
    [anon_sym___extension__] = ACTIONS(2597),
    [anon_sym_typedef] = ACTIONS(2597),
    [anon_sym_virtual] = ACTIONS(2597),
    [anon_sym_extern] = ACTIONS(2597),
    [anon_sym___attribute__] = ACTIONS(2597),
    [anon_sym___attribute] = ACTIONS(2597),
    [anon_sym_COLON_COLON] = ACTIONS(2599),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2599),
    [anon_sym___declspec] = ACTIONS(2597),
    [anon_sym_LBRACE] = ACTIONS(2599),
    [anon_sym_signed] = ACTIONS(2597),
    [anon_sym_unsigned] = ACTIONS(2597),
    [anon_sym_long] = ACTIONS(2597),
    [anon_sym_short] = ACTIONS(2597),
    [anon_sym_LBRACK] = ACTIONS(2597),
    [anon_sym_static] = ACTIONS(2597),
    [anon_sym_register] = ACTIONS(2597),
    [anon_sym_inline] = ACTIONS(2597),
    [anon_sym___inline] = ACTIONS(2597),
    [anon_sym___inline__] = ACTIONS(2597),
    [anon_sym___forceinline] = ACTIONS(2597),
    [anon_sym_thread_local] = ACTIONS(2597),
    [anon_sym___thread] = ACTIONS(2597),
    [anon_sym_const] = ACTIONS(2597),
    [anon_sym_constexpr] = ACTIONS(2597),
    [anon_sym_volatile] = ACTIONS(2597),
    [anon_sym_restrict] = ACTIONS(2597),
    [anon_sym___restrict__] = ACTIONS(2597),
    [anon_sym__Atomic] = ACTIONS(2597),
    [anon_sym__Noreturn] = ACTIONS(2597),
    [anon_sym_noreturn] = ACTIONS(2597),
    [anon_sym__Nonnull] = ACTIONS(2597),
    [anon_sym_mutable] = ACTIONS(2597),
    [anon_sym_constinit] = ACTIONS(2597),
    [anon_sym_consteval] = ACTIONS(2597),
    [anon_sym_alignas] = ACTIONS(2597),
    [anon_sym__Alignas] = ACTIONS(2597),
    [sym_primitive_type] = ACTIONS(2597),
    [anon_sym_enum] = ACTIONS(2597),
    [anon_sym_class] = ACTIONS(2597),
    [anon_sym_struct] = ACTIONS(2597),
    [anon_sym_union] = ACTIONS(2597),
    [anon_sym_if] = ACTIONS(2597),
    [anon_sym_else] = ACTIONS(2597),
    [anon_sym_switch] = ACTIONS(2597),
    [anon_sym_while] = ACTIONS(2597),
    [anon_sym_do] = ACTIONS(2597),
    [anon_sym_for] = ACTIONS(2597),
    [anon_sym_return] = ACTIONS(2597),
    [anon_sym_break] = ACTIONS(2597),
    [anon_sym_continue] = ACTIONS(2597),
    [anon_sym_goto] = ACTIONS(2597),
    [anon_sym___try] = ACTIONS(2597),
    [anon_sym___leave] = ACTIONS(2597),
    [anon_sym_not] = ACTIONS(2597),
    [anon_sym_compl] = ACTIONS(2597),
    [anon_sym_DASH_DASH] = ACTIONS(2599),
    [anon_sym_PLUS_PLUS] = ACTIONS(2599),
    [anon_sym_sizeof] = ACTIONS(2597),
    [anon_sym___alignof__] = ACTIONS(2597),
    [anon_sym___alignof] = ACTIONS(2597),
    [anon_sym__alignof] = ACTIONS(2597),
    [anon_sym_alignof] = ACTIONS(2597),
    [anon_sym__Alignof] = ACTIONS(2597),
    [anon_sym_offsetof] = ACTIONS(2597),
    [anon_sym__Generic] = ACTIONS(2597),
    [anon_sym_asm] = ACTIONS(2597),
    [anon_sym___asm__] = ACTIONS(2597),
    [anon_sym___asm] = ACTIONS(2597),
    [sym_number_literal] = ACTIONS(2599),
    [anon_sym_L_SQUOTE] = ACTIONS(2599),
    [anon_sym_u_SQUOTE] = ACTIONS(2599),
    [anon_sym_U_SQUOTE] = ACTIONS(2599),
    [anon_sym_u8_SQUOTE] = ACTIONS(2599),
    [anon_sym_SQUOTE] = ACTIONS(2599),
    [anon_sym_L_DQUOTE] = ACTIONS(2599),
    [anon_sym_u_DQUOTE] = ACTIONS(2599),
    [anon_sym_U_DQUOTE] = ACTIONS(2599),
    [anon_sym_u8_DQUOTE] = ACTIONS(2599),
    [anon_sym_DQUOTE] = ACTIONS(2599),
    [sym_true] = ACTIONS(2597),
    [sym_false] = ACTIONS(2597),
    [anon_sym_NULL] = ACTIONS(2597),
    [anon_sym_nullptr] = ACTIONS(2597),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2597),
    [anon_sym_decltype] = ACTIONS(2597),
    [anon_sym_typename] = ACTIONS(2597),
    [anon_sym_template] = ACTIONS(2597),
    [anon_sym_try] = ACTIONS(2597),
    [anon_sym_delete] = ACTIONS(2597),
    [anon_sym_throw] = ACTIONS(2597),
    [anon_sym_co_return] = ACTIONS(2597),
    [anon_sym_co_yield] = ACTIONS(2597),
    [anon_sym_R_DQUOTE] = ACTIONS(2599),
    [anon_sym_LR_DQUOTE] = ACTIONS(2599),
    [anon_sym_uR_DQUOTE] = ACTIONS(2599),
    [anon_sym_UR_DQUOTE] = ACTIONS(2599),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2599),
    [anon_sym_co_await] = ACTIONS(2597),
    [anon_sym_new] = ACTIONS(2597),
    [anon_sym_requires] = ACTIONS(2597),
    [sym_this] = ACTIONS(2597),
  },
  [880] = {
    [sym_identifier] = ACTIONS(2677),
    [anon_sym_LPAREN2] = ACTIONS(2679),
    [anon_sym_BANG] = ACTIONS(2679),
    [anon_sym_TILDE] = ACTIONS(2679),
    [anon_sym_DASH] = ACTIONS(2677),
    [anon_sym_PLUS] = ACTIONS(2677),
    [anon_sym_STAR] = ACTIONS(2679),
    [anon_sym_AMP] = ACTIONS(2679),
    [anon_sym_SEMI] = ACTIONS(2679),
    [anon_sym___extension__] = ACTIONS(2677),
    [anon_sym_typedef] = ACTIONS(2677),
    [anon_sym_virtual] = ACTIONS(2677),
    [anon_sym_extern] = ACTIONS(2677),
    [anon_sym___attribute__] = ACTIONS(2677),
    [anon_sym___attribute] = ACTIONS(2677),
    [anon_sym_COLON_COLON] = ACTIONS(2679),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2679),
    [anon_sym___declspec] = ACTIONS(2677),
    [anon_sym_LBRACE] = ACTIONS(2679),
    [anon_sym_signed] = ACTIONS(2677),
    [anon_sym_unsigned] = ACTIONS(2677),
    [anon_sym_long] = ACTIONS(2677),
    [anon_sym_short] = ACTIONS(2677),
    [anon_sym_LBRACK] = ACTIONS(2677),
    [anon_sym_static] = ACTIONS(2677),
    [anon_sym_register] = ACTIONS(2677),
    [anon_sym_inline] = ACTIONS(2677),
    [anon_sym___inline] = ACTIONS(2677),
    [anon_sym___inline__] = ACTIONS(2677),
    [anon_sym___forceinline] = ACTIONS(2677),
    [anon_sym_thread_local] = ACTIONS(2677),
    [anon_sym___thread] = ACTIONS(2677),
    [anon_sym_const] = ACTIONS(2677),
    [anon_sym_constexpr] = ACTIONS(2677),
    [anon_sym_volatile] = ACTIONS(2677),
    [anon_sym_restrict] = ACTIONS(2677),
    [anon_sym___restrict__] = ACTIONS(2677),
    [anon_sym__Atomic] = ACTIONS(2677),
    [anon_sym__Noreturn] = ACTIONS(2677),
    [anon_sym_noreturn] = ACTIONS(2677),
    [anon_sym__Nonnull] = ACTIONS(2677),
    [anon_sym_mutable] = ACTIONS(2677),
    [anon_sym_constinit] = ACTIONS(2677),
    [anon_sym_consteval] = ACTIONS(2677),
    [anon_sym_alignas] = ACTIONS(2677),
    [anon_sym__Alignas] = ACTIONS(2677),
    [sym_primitive_type] = ACTIONS(2677),
    [anon_sym_enum] = ACTIONS(2677),
    [anon_sym_class] = ACTIONS(2677),
    [anon_sym_struct] = ACTIONS(2677),
    [anon_sym_union] = ACTIONS(2677),
    [anon_sym_if] = ACTIONS(2677),
    [anon_sym_else] = ACTIONS(2677),
    [anon_sym_switch] = ACTIONS(2677),
    [anon_sym_while] = ACTIONS(2677),
    [anon_sym_do] = ACTIONS(2677),
    [anon_sym_for] = ACTIONS(2677),
    [anon_sym_return] = ACTIONS(2677),
    [anon_sym_break] = ACTIONS(2677),
    [anon_sym_continue] = ACTIONS(2677),
    [anon_sym_goto] = ACTIONS(2677),
    [anon_sym___try] = ACTIONS(2677),
    [anon_sym___leave] = ACTIONS(2677),
    [anon_sym_not] = ACTIONS(2677),
    [anon_sym_compl] = ACTIONS(2677),
    [anon_sym_DASH_DASH] = ACTIONS(2679),
    [anon_sym_PLUS_PLUS] = ACTIONS(2679),
    [anon_sym_sizeof] = ACTIONS(2677),
    [anon_sym___alignof__] = ACTIONS(2677),
    [anon_sym___alignof] = ACTIONS(2677),
    [anon_sym__alignof] = ACTIONS(2677),
    [anon_sym_alignof] = ACTIONS(2677),
    [anon_sym__Alignof] = ACTIONS(2677),
    [anon_sym_offsetof] = ACTIONS(2677),
    [anon_sym__Generic] = ACTIONS(2677),
    [anon_sym_asm] = ACTIONS(2677),
    [anon_sym___asm__] = ACTIONS(2677),
    [anon_sym___asm] = ACTIONS(2677),
    [sym_number_literal] = ACTIONS(2679),
    [anon_sym_L_SQUOTE] = ACTIONS(2679),
    [anon_sym_u_SQUOTE] = ACTIONS(2679),
    [anon_sym_U_SQUOTE] = ACTIONS(2679),
    [anon_sym_u8_SQUOTE] = ACTIONS(2679),
    [anon_sym_SQUOTE] = ACTIONS(2679),
    [anon_sym_L_DQUOTE] = ACTIONS(2679),
    [anon_sym_u_DQUOTE] = ACTIONS(2679),
    [anon_sym_U_DQUOTE] = ACTIONS(2679),
    [anon_sym_u8_DQUOTE] = ACTIONS(2679),
    [anon_sym_DQUOTE] = ACTIONS(2679),
    [sym_true] = ACTIONS(2677),
    [sym_false] = ACTIONS(2677),
    [anon_sym_NULL] = ACTIONS(2677),
    [anon_sym_nullptr] = ACTIONS(2677),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2677),
    [anon_sym_decltype] = ACTIONS(2677),
    [anon_sym_typename] = ACTIONS(2677),
    [anon_sym_template] = ACTIONS(2677),
    [anon_sym_try] = ACTIONS(2677),
    [anon_sym_delete] = ACTIONS(2677),
    [anon_sym_throw] = ACTIONS(2677),
    [anon_sym_co_return] = ACTIONS(2677),
    [anon_sym_co_yield] = ACTIONS(2677),
    [anon_sym_R_DQUOTE] = ACTIONS(2679),
    [anon_sym_LR_DQUOTE] = ACTIONS(2679),
    [anon_sym_uR_DQUOTE] = ACTIONS(2679),
    [anon_sym_UR_DQUOTE] = ACTIONS(2679),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2679),
    [anon_sym_co_await] = ACTIONS(2677),
    [anon_sym_new] = ACTIONS(2677),
    [anon_sym_requires] = ACTIONS(2677),
    [sym_this] = ACTIONS(2677),
  },
  [881] = {
    [sym_identifier] = ACTIONS(2681),
    [anon_sym_LPAREN2] = ACTIONS(2683),
    [anon_sym_BANG] = ACTIONS(2683),
    [anon_sym_TILDE] = ACTIONS(2683),
    [anon_sym_DASH] = ACTIONS(2681),
    [anon_sym_PLUS] = ACTIONS(2681),
    [anon_sym_STAR] = ACTIONS(2683),
    [anon_sym_AMP] = ACTIONS(2683),
    [anon_sym_SEMI] = ACTIONS(2683),
    [anon_sym___extension__] = ACTIONS(2681),
    [anon_sym_typedef] = ACTIONS(2681),
    [anon_sym_virtual] = ACTIONS(2681),
    [anon_sym_extern] = ACTIONS(2681),
    [anon_sym___attribute__] = ACTIONS(2681),
    [anon_sym___attribute] = ACTIONS(2681),
    [anon_sym_COLON_COLON] = ACTIONS(2683),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2683),
    [anon_sym___declspec] = ACTIONS(2681),
    [anon_sym_LBRACE] = ACTIONS(2683),
    [anon_sym_signed] = ACTIONS(2681),
    [anon_sym_unsigned] = ACTIONS(2681),
    [anon_sym_long] = ACTIONS(2681),
    [anon_sym_short] = ACTIONS(2681),
    [anon_sym_LBRACK] = ACTIONS(2681),
    [anon_sym_static] = ACTIONS(2681),
    [anon_sym_register] = ACTIONS(2681),
    [anon_sym_inline] = ACTIONS(2681),
    [anon_sym___inline] = ACTIONS(2681),
    [anon_sym___inline__] = ACTIONS(2681),
    [anon_sym___forceinline] = ACTIONS(2681),
    [anon_sym_thread_local] = ACTIONS(2681),
    [anon_sym___thread] = ACTIONS(2681),
    [anon_sym_const] = ACTIONS(2681),
    [anon_sym_constexpr] = ACTIONS(2681),
    [anon_sym_volatile] = ACTIONS(2681),
    [anon_sym_restrict] = ACTIONS(2681),
    [anon_sym___restrict__] = ACTIONS(2681),
    [anon_sym__Atomic] = ACTIONS(2681),
    [anon_sym__Noreturn] = ACTIONS(2681),
    [anon_sym_noreturn] = ACTIONS(2681),
    [anon_sym__Nonnull] = ACTIONS(2681),
    [anon_sym_mutable] = ACTIONS(2681),
    [anon_sym_constinit] = ACTIONS(2681),
    [anon_sym_consteval] = ACTIONS(2681),
    [anon_sym_alignas] = ACTIONS(2681),
    [anon_sym__Alignas] = ACTIONS(2681),
    [sym_primitive_type] = ACTIONS(2681),
    [anon_sym_enum] = ACTIONS(2681),
    [anon_sym_class] = ACTIONS(2681),
    [anon_sym_struct] = ACTIONS(2681),
    [anon_sym_union] = ACTIONS(2681),
    [anon_sym_if] = ACTIONS(2681),
    [anon_sym_else] = ACTIONS(2681),
    [anon_sym_switch] = ACTIONS(2681),
    [anon_sym_while] = ACTIONS(2681),
    [anon_sym_do] = ACTIONS(2681),
    [anon_sym_for] = ACTIONS(2681),
    [anon_sym_return] = ACTIONS(2681),
    [anon_sym_break] = ACTIONS(2681),
    [anon_sym_continue] = ACTIONS(2681),
    [anon_sym_goto] = ACTIONS(2681),
    [anon_sym___try] = ACTIONS(2681),
    [anon_sym___leave] = ACTIONS(2681),
    [anon_sym_not] = ACTIONS(2681),
    [anon_sym_compl] = ACTIONS(2681),
    [anon_sym_DASH_DASH] = ACTIONS(2683),
    [anon_sym_PLUS_PLUS] = ACTIONS(2683),
    [anon_sym_sizeof] = ACTIONS(2681),
    [anon_sym___alignof__] = ACTIONS(2681),
    [anon_sym___alignof] = ACTIONS(2681),
    [anon_sym__alignof] = ACTIONS(2681),
    [anon_sym_alignof] = ACTIONS(2681),
    [anon_sym__Alignof] = ACTIONS(2681),
    [anon_sym_offsetof] = ACTIONS(2681),
    [anon_sym__Generic] = ACTIONS(2681),
    [anon_sym_asm] = ACTIONS(2681),
    [anon_sym___asm__] = ACTIONS(2681),
    [anon_sym___asm] = ACTIONS(2681),
    [sym_number_literal] = ACTIONS(2683),
    [anon_sym_L_SQUOTE] = ACTIONS(2683),
    [anon_sym_u_SQUOTE] = ACTIONS(2683),
    [anon_sym_U_SQUOTE] = ACTIONS(2683),
    [anon_sym_u8_SQUOTE] = ACTIONS(2683),
    [anon_sym_SQUOTE] = ACTIONS(2683),
    [anon_sym_L_DQUOTE] = ACTIONS(2683),
    [anon_sym_u_DQUOTE] = ACTIONS(2683),
    [anon_sym_U_DQUOTE] = ACTIONS(2683),
    [anon_sym_u8_DQUOTE] = ACTIONS(2683),
    [anon_sym_DQUOTE] = ACTIONS(2683),
    [sym_true] = ACTIONS(2681),
    [sym_false] = ACTIONS(2681),
    [anon_sym_NULL] = ACTIONS(2681),
    [anon_sym_nullptr] = ACTIONS(2681),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2681),
    [anon_sym_decltype] = ACTIONS(2681),
    [anon_sym_typename] = ACTIONS(2681),
    [anon_sym_template] = ACTIONS(2681),
    [anon_sym_try] = ACTIONS(2681),
    [anon_sym_delete] = ACTIONS(2681),
    [anon_sym_throw] = ACTIONS(2681),
    [anon_sym_co_return] = ACTIONS(2681),
    [anon_sym_co_yield] = ACTIONS(2681),
    [anon_sym_R_DQUOTE] = ACTIONS(2683),
    [anon_sym_LR_DQUOTE] = ACTIONS(2683),
    [anon_sym_uR_DQUOTE] = ACTIONS(2683),
    [anon_sym_UR_DQUOTE] = ACTIONS(2683),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2683),
    [anon_sym_co_await] = ACTIONS(2681),
    [anon_sym_new] = ACTIONS(2681),
    [anon_sym_requires] = ACTIONS(2681),
    [sym_this] = ACTIONS(2681),
  },
  [882] = {
    [sym_identifier] = ACTIONS(2645),
    [anon_sym_LPAREN2] = ACTIONS(2647),
    [anon_sym_BANG] = ACTIONS(2647),
    [anon_sym_TILDE] = ACTIONS(2647),
    [anon_sym_DASH] = ACTIONS(2645),
    [anon_sym_PLUS] = ACTIONS(2645),
    [anon_sym_STAR] = ACTIONS(2647),
    [anon_sym_AMP] = ACTIONS(2647),
    [anon_sym_SEMI] = ACTIONS(2647),
    [anon_sym___extension__] = ACTIONS(2645),
    [anon_sym_typedef] = ACTIONS(2645),
    [anon_sym_virtual] = ACTIONS(2645),
    [anon_sym_extern] = ACTIONS(2645),
    [anon_sym___attribute__] = ACTIONS(2645),
    [anon_sym___attribute] = ACTIONS(2645),
    [anon_sym_COLON_COLON] = ACTIONS(2647),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2647),
    [anon_sym___declspec] = ACTIONS(2645),
    [anon_sym_LBRACE] = ACTIONS(2647),
    [anon_sym_signed] = ACTIONS(2645),
    [anon_sym_unsigned] = ACTIONS(2645),
    [anon_sym_long] = ACTIONS(2645),
    [anon_sym_short] = ACTIONS(2645),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_static] = ACTIONS(2645),
    [anon_sym_register] = ACTIONS(2645),
    [anon_sym_inline] = ACTIONS(2645),
    [anon_sym___inline] = ACTIONS(2645),
    [anon_sym___inline__] = ACTIONS(2645),
    [anon_sym___forceinline] = ACTIONS(2645),
    [anon_sym_thread_local] = ACTIONS(2645),
    [anon_sym___thread] = ACTIONS(2645),
    [anon_sym_const] = ACTIONS(2645),
    [anon_sym_constexpr] = ACTIONS(2645),
    [anon_sym_volatile] = ACTIONS(2645),
    [anon_sym_restrict] = ACTIONS(2645),
    [anon_sym___restrict__] = ACTIONS(2645),
    [anon_sym__Atomic] = ACTIONS(2645),
    [anon_sym__Noreturn] = ACTIONS(2645),
    [anon_sym_noreturn] = ACTIONS(2645),
    [anon_sym__Nonnull] = ACTIONS(2645),
    [anon_sym_mutable] = ACTIONS(2645),
    [anon_sym_constinit] = ACTIONS(2645),
    [anon_sym_consteval] = ACTIONS(2645),
    [anon_sym_alignas] = ACTIONS(2645),
    [anon_sym__Alignas] = ACTIONS(2645),
    [sym_primitive_type] = ACTIONS(2645),
    [anon_sym_enum] = ACTIONS(2645),
    [anon_sym_class] = ACTIONS(2645),
    [anon_sym_struct] = ACTIONS(2645),
    [anon_sym_union] = ACTIONS(2645),
    [anon_sym_if] = ACTIONS(2645),
    [anon_sym_else] = ACTIONS(2645),
    [anon_sym_switch] = ACTIONS(2645),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_do] = ACTIONS(2645),
    [anon_sym_for] = ACTIONS(2645),
    [anon_sym_return] = ACTIONS(2645),
    [anon_sym_break] = ACTIONS(2645),
    [anon_sym_continue] = ACTIONS(2645),
    [anon_sym_goto] = ACTIONS(2645),
    [anon_sym___try] = ACTIONS(2645),
    [anon_sym___leave] = ACTIONS(2645),
    [anon_sym_not] = ACTIONS(2645),
    [anon_sym_compl] = ACTIONS(2645),
    [anon_sym_DASH_DASH] = ACTIONS(2647),
    [anon_sym_PLUS_PLUS] = ACTIONS(2647),
    [anon_sym_sizeof] = ACTIONS(2645),
    [anon_sym___alignof__] = ACTIONS(2645),
    [anon_sym___alignof] = ACTIONS(2645),
    [anon_sym__alignof] = ACTIONS(2645),
    [anon_sym_alignof] = ACTIONS(2645),
    [anon_sym__Alignof] = ACTIONS(2645),
    [anon_sym_offsetof] = ACTIONS(2645),
    [anon_sym__Generic] = ACTIONS(2645),
    [anon_sym_asm] = ACTIONS(2645),
    [anon_sym___asm__] = ACTIONS(2645),
    [anon_sym___asm] = ACTIONS(2645),
    [sym_number_literal] = ACTIONS(2647),
    [anon_sym_L_SQUOTE] = ACTIONS(2647),
    [anon_sym_u_SQUOTE] = ACTIONS(2647),
    [anon_sym_U_SQUOTE] = ACTIONS(2647),
    [anon_sym_u8_SQUOTE] = ACTIONS(2647),
    [anon_sym_SQUOTE] = ACTIONS(2647),
    [anon_sym_L_DQUOTE] = ACTIONS(2647),
    [anon_sym_u_DQUOTE] = ACTIONS(2647),
    [anon_sym_U_DQUOTE] = ACTIONS(2647),
    [anon_sym_u8_DQUOTE] = ACTIONS(2647),
    [anon_sym_DQUOTE] = ACTIONS(2647),
    [sym_true] = ACTIONS(2645),
    [sym_false] = ACTIONS(2645),
    [anon_sym_NULL] = ACTIONS(2645),
    [anon_sym_nullptr] = ACTIONS(2645),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2645),
    [anon_sym_decltype] = ACTIONS(2645),
    [anon_sym_typename] = ACTIONS(2645),
    [anon_sym_template] = ACTIONS(2645),
    [anon_sym_try] = ACTIONS(2645),
    [anon_sym_delete] = ACTIONS(2645),
    [anon_sym_throw] = ACTIONS(2645),
    [anon_sym_co_return] = ACTIONS(2645),
    [anon_sym_co_yield] = ACTIONS(2645),
    [anon_sym_R_DQUOTE] = ACTIONS(2647),
    [anon_sym_LR_DQUOTE] = ACTIONS(2647),
    [anon_sym_uR_DQUOTE] = ACTIONS(2647),
    [anon_sym_UR_DQUOTE] = ACTIONS(2647),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2647),
    [anon_sym_co_await] = ACTIONS(2645),
    [anon_sym_new] = ACTIONS(2645),
    [anon_sym_requires] = ACTIONS(2645),
    [sym_this] = ACTIONS(2645),
  },
  [883] = {
    [sym_identifier] = ACTIONS(3986),
    [anon_sym_LPAREN2] = ACTIONS(3992),
    [anon_sym_BANG] = ACTIONS(3992),
    [anon_sym_TILDE] = ACTIONS(3992),
    [anon_sym_DASH] = ACTIONS(3994),
    [anon_sym_PLUS] = ACTIONS(3994),
    [anon_sym_STAR] = ACTIONS(3992),
    [anon_sym_AMP] = ACTIONS(3992),
    [anon_sym_SEMI] = ACTIONS(3992),
    [anon_sym___extension__] = ACTIONS(3986),
    [anon_sym_virtual] = ACTIONS(3998),
    [anon_sym_extern] = ACTIONS(3998),
    [anon_sym___attribute__] = ACTIONS(3998),
    [anon_sym___attribute] = ACTIONS(3998),
    [anon_sym_COLON_COLON] = ACTIONS(3989),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3989),
    [anon_sym___declspec] = ACTIONS(3998),
    [anon_sym_LBRACE] = ACTIONS(3992),
    [anon_sym_signed] = ACTIONS(3998),
    [anon_sym_unsigned] = ACTIONS(3998),
    [anon_sym_long] = ACTIONS(3998),
    [anon_sym_short] = ACTIONS(3998),
    [anon_sym_LBRACK] = ACTIONS(3994),
    [anon_sym_static] = ACTIONS(3998),
    [anon_sym_register] = ACTIONS(3998),
    [anon_sym_inline] = ACTIONS(3998),
    [anon_sym___inline] = ACTIONS(3998),
    [anon_sym___inline__] = ACTIONS(3998),
    [anon_sym___forceinline] = ACTIONS(3998),
    [anon_sym_thread_local] = ACTIONS(3998),
    [anon_sym___thread] = ACTIONS(3998),
    [anon_sym_const] = ACTIONS(3998),
    [anon_sym_constexpr] = ACTIONS(3998),
    [anon_sym_volatile] = ACTIONS(3998),
    [anon_sym_restrict] = ACTIONS(3998),
    [anon_sym___restrict__] = ACTIONS(3998),
    [anon_sym__Atomic] = ACTIONS(3998),
    [anon_sym__Noreturn] = ACTIONS(3998),
    [anon_sym_noreturn] = ACTIONS(3998),
    [anon_sym__Nonnull] = ACTIONS(3998),
    [anon_sym_mutable] = ACTIONS(3998),
    [anon_sym_constinit] = ACTIONS(3998),
    [anon_sym_consteval] = ACTIONS(3998),
    [anon_sym_alignas] = ACTIONS(3998),
    [anon_sym__Alignas] = ACTIONS(3998),
    [sym_primitive_type] = ACTIONS(3986),
    [anon_sym_enum] = ACTIONS(3998),
    [anon_sym_class] = ACTIONS(3998),
    [anon_sym_struct] = ACTIONS(3998),
    [anon_sym_union] = ACTIONS(3998),
    [anon_sym_if] = ACTIONS(3994),
    [anon_sym_switch] = ACTIONS(3994),
    [anon_sym_case] = ACTIONS(3994),
    [anon_sym_default] = ACTIONS(3994),
    [anon_sym_while] = ACTIONS(3994),
    [anon_sym_do] = ACTIONS(3994),
    [anon_sym_for] = ACTIONS(3994),
    [anon_sym_return] = ACTIONS(3994),
    [anon_sym_break] = ACTIONS(3994),
    [anon_sym_continue] = ACTIONS(3994),
    [anon_sym_goto] = ACTIONS(3994),
    [anon_sym___try] = ACTIONS(3994),
    [anon_sym___leave] = ACTIONS(3994),
    [anon_sym_not] = ACTIONS(3994),
    [anon_sym_compl] = ACTIONS(3994),
    [anon_sym_DASH_DASH] = ACTIONS(3992),
    [anon_sym_PLUS_PLUS] = ACTIONS(3992),
    [anon_sym_sizeof] = ACTIONS(3994),
    [anon_sym___alignof__] = ACTIONS(3994),
    [anon_sym___alignof] = ACTIONS(3994),
    [anon_sym__alignof] = ACTIONS(3994),
    [anon_sym_alignof] = ACTIONS(3994),
    [anon_sym__Alignof] = ACTIONS(3994),
    [anon_sym_offsetof] = ACTIONS(3994),
    [anon_sym__Generic] = ACTIONS(3994),
    [anon_sym_asm] = ACTIONS(3994),
    [anon_sym___asm__] = ACTIONS(3994),
    [anon_sym___asm] = ACTIONS(3994),
    [sym_number_literal] = ACTIONS(3992),
    [anon_sym_L_SQUOTE] = ACTIONS(3992),
    [anon_sym_u_SQUOTE] = ACTIONS(3992),
    [anon_sym_U_SQUOTE] = ACTIONS(3992),
    [anon_sym_u8_SQUOTE] = ACTIONS(3992),
    [anon_sym_SQUOTE] = ACTIONS(3992),
    [anon_sym_L_DQUOTE] = ACTIONS(3992),
    [anon_sym_u_DQUOTE] = ACTIONS(3992),
    [anon_sym_U_DQUOTE] = ACTIONS(3992),
    [anon_sym_u8_DQUOTE] = ACTIONS(3992),
    [anon_sym_DQUOTE] = ACTIONS(3992),
    [sym_true] = ACTIONS(3994),
    [sym_false] = ACTIONS(3994),
    [anon_sym_NULL] = ACTIONS(3994),
    [anon_sym_nullptr] = ACTIONS(3994),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3998),
    [anon_sym_decltype] = ACTIONS(3986),
    [anon_sym_typename] = ACTIONS(3998),
    [anon_sym_template] = ACTIONS(3986),
    [anon_sym_try] = ACTIONS(3994),
    [anon_sym_delete] = ACTIONS(3994),
    [anon_sym_throw] = ACTIONS(3994),
    [anon_sym_co_return] = ACTIONS(3994),
    [anon_sym_co_yield] = ACTIONS(3994),
    [anon_sym_R_DQUOTE] = ACTIONS(3992),
    [anon_sym_LR_DQUOTE] = ACTIONS(3992),
    [anon_sym_uR_DQUOTE] = ACTIONS(3992),
    [anon_sym_UR_DQUOTE] = ACTIONS(3992),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3992),
    [anon_sym_co_await] = ACTIONS(3994),
    [anon_sym_new] = ACTIONS(3994),
    [anon_sym_requires] = ACTIONS(3994),
    [sym_this] = ACTIONS(3994),
  },
  [884] = {
    [sym_identifier] = ACTIONS(2601),
    [anon_sym_LPAREN2] = ACTIONS(2603),
    [anon_sym_BANG] = ACTIONS(2603),
    [anon_sym_TILDE] = ACTIONS(2603),
    [anon_sym_DASH] = ACTIONS(2601),
    [anon_sym_PLUS] = ACTIONS(2601),
    [anon_sym_STAR] = ACTIONS(2603),
    [anon_sym_AMP] = ACTIONS(2603),
    [anon_sym_SEMI] = ACTIONS(2603),
    [anon_sym___extension__] = ACTIONS(2601),
    [anon_sym_typedef] = ACTIONS(2601),
    [anon_sym_virtual] = ACTIONS(2601),
    [anon_sym_extern] = ACTIONS(2601),
    [anon_sym___attribute__] = ACTIONS(2601),
    [anon_sym___attribute] = ACTIONS(2601),
    [anon_sym_COLON_COLON] = ACTIONS(2603),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2603),
    [anon_sym___declspec] = ACTIONS(2601),
    [anon_sym_LBRACE] = ACTIONS(2603),
    [anon_sym_signed] = ACTIONS(2601),
    [anon_sym_unsigned] = ACTIONS(2601),
    [anon_sym_long] = ACTIONS(2601),
    [anon_sym_short] = ACTIONS(2601),
    [anon_sym_LBRACK] = ACTIONS(2601),
    [anon_sym_static] = ACTIONS(2601),
    [anon_sym_register] = ACTIONS(2601),
    [anon_sym_inline] = ACTIONS(2601),
    [anon_sym___inline] = ACTIONS(2601),
    [anon_sym___inline__] = ACTIONS(2601),
    [anon_sym___forceinline] = ACTIONS(2601),
    [anon_sym_thread_local] = ACTIONS(2601),
    [anon_sym___thread] = ACTIONS(2601),
    [anon_sym_const] = ACTIONS(2601),
    [anon_sym_constexpr] = ACTIONS(2601),
    [anon_sym_volatile] = ACTIONS(2601),
    [anon_sym_restrict] = ACTIONS(2601),
    [anon_sym___restrict__] = ACTIONS(2601),
    [anon_sym__Atomic] = ACTIONS(2601),
    [anon_sym__Noreturn] = ACTIONS(2601),
    [anon_sym_noreturn] = ACTIONS(2601),
    [anon_sym__Nonnull] = ACTIONS(2601),
    [anon_sym_mutable] = ACTIONS(2601),
    [anon_sym_constinit] = ACTIONS(2601),
    [anon_sym_consteval] = ACTIONS(2601),
    [anon_sym_alignas] = ACTIONS(2601),
    [anon_sym__Alignas] = ACTIONS(2601),
    [sym_primitive_type] = ACTIONS(2601),
    [anon_sym_enum] = ACTIONS(2601),
    [anon_sym_class] = ACTIONS(2601),
    [anon_sym_struct] = ACTIONS(2601),
    [anon_sym_union] = ACTIONS(2601),
    [anon_sym_if] = ACTIONS(2601),
    [anon_sym_else] = ACTIONS(2601),
    [anon_sym_switch] = ACTIONS(2601),
    [anon_sym_while] = ACTIONS(2601),
    [anon_sym_do] = ACTIONS(2601),
    [anon_sym_for] = ACTIONS(2601),
    [anon_sym_return] = ACTIONS(2601),
    [anon_sym_break] = ACTIONS(2601),
    [anon_sym_continue] = ACTIONS(2601),
    [anon_sym_goto] = ACTIONS(2601),
    [anon_sym___try] = ACTIONS(2601),
    [anon_sym___leave] = ACTIONS(2601),
    [anon_sym_not] = ACTIONS(2601),
    [anon_sym_compl] = ACTIONS(2601),
    [anon_sym_DASH_DASH] = ACTIONS(2603),
    [anon_sym_PLUS_PLUS] = ACTIONS(2603),
    [anon_sym_sizeof] = ACTIONS(2601),
    [anon_sym___alignof__] = ACTIONS(2601),
    [anon_sym___alignof] = ACTIONS(2601),
    [anon_sym__alignof] = ACTIONS(2601),
    [anon_sym_alignof] = ACTIONS(2601),
    [anon_sym__Alignof] = ACTIONS(2601),
    [anon_sym_offsetof] = ACTIONS(2601),
    [anon_sym__Generic] = ACTIONS(2601),
    [anon_sym_asm] = ACTIONS(2601),
    [anon_sym___asm__] = ACTIONS(2601),
    [anon_sym___asm] = ACTIONS(2601),
    [sym_number_literal] = ACTIONS(2603),
    [anon_sym_L_SQUOTE] = ACTIONS(2603),
    [anon_sym_u_SQUOTE] = ACTIONS(2603),
    [anon_sym_U_SQUOTE] = ACTIONS(2603),
    [anon_sym_u8_SQUOTE] = ACTIONS(2603),
    [anon_sym_SQUOTE] = ACTIONS(2603),
    [anon_sym_L_DQUOTE] = ACTIONS(2603),
    [anon_sym_u_DQUOTE] = ACTIONS(2603),
    [anon_sym_U_DQUOTE] = ACTIONS(2603),
    [anon_sym_u8_DQUOTE] = ACTIONS(2603),
    [anon_sym_DQUOTE] = ACTIONS(2603),
    [sym_true] = ACTIONS(2601),
    [sym_false] = ACTIONS(2601),
    [anon_sym_NULL] = ACTIONS(2601),
    [anon_sym_nullptr] = ACTIONS(2601),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2601),
    [anon_sym_decltype] = ACTIONS(2601),
    [anon_sym_typename] = ACTIONS(2601),
    [anon_sym_template] = ACTIONS(2601),
    [anon_sym_try] = ACTIONS(2601),
    [anon_sym_delete] = ACTIONS(2601),
    [anon_sym_throw] = ACTIONS(2601),
    [anon_sym_co_return] = ACTIONS(2601),
    [anon_sym_co_yield] = ACTIONS(2601),
    [anon_sym_R_DQUOTE] = ACTIONS(2603),
    [anon_sym_LR_DQUOTE] = ACTIONS(2603),
    [anon_sym_uR_DQUOTE] = ACTIONS(2603),
    [anon_sym_UR_DQUOTE] = ACTIONS(2603),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2603),
    [anon_sym_co_await] = ACTIONS(2601),
    [anon_sym_new] = ACTIONS(2601),
    [anon_sym_requires] = ACTIONS(2601),
    [sym_this] = ACTIONS(2601),
  },
  [885] = {
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6367),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(5896),
    [sym_array_declarator] = STATE(5896),
    [sym_expression] = STATE(3125),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3182),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5649),
    [sym_qualified_identifier] = STATE(3215),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_operator_name] = STATE(5896),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(3262),
    [anon_sym_LPAREN2] = ACTIONS(1763),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1767),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1771),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(1773),
    [anon_sym___extension__] = ACTIONS(2029),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_operator] = ACTIONS(1823),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [886] = {
    [sym_identifier] = ACTIONS(3822),
    [anon_sym_LPAREN2] = ACTIONS(3824),
    [anon_sym_BANG] = ACTIONS(3824),
    [anon_sym_TILDE] = ACTIONS(3824),
    [anon_sym_DASH] = ACTIONS(3822),
    [anon_sym_PLUS] = ACTIONS(3822),
    [anon_sym_STAR] = ACTIONS(3824),
    [anon_sym_AMP] = ACTIONS(3824),
    [anon_sym_SEMI] = ACTIONS(3824),
    [anon_sym___extension__] = ACTIONS(3822),
    [anon_sym_virtual] = ACTIONS(3822),
    [anon_sym_extern] = ACTIONS(3822),
    [anon_sym___attribute__] = ACTIONS(3822),
    [anon_sym___attribute] = ACTIONS(3822),
    [anon_sym_COLON_COLON] = ACTIONS(3824),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3824),
    [anon_sym___declspec] = ACTIONS(3822),
    [anon_sym_LBRACE] = ACTIONS(3824),
    [anon_sym_signed] = ACTIONS(3822),
    [anon_sym_unsigned] = ACTIONS(3822),
    [anon_sym_long] = ACTIONS(3822),
    [anon_sym_short] = ACTIONS(3822),
    [anon_sym_LBRACK] = ACTIONS(3822),
    [anon_sym_static] = ACTIONS(3822),
    [anon_sym_register] = ACTIONS(3822),
    [anon_sym_inline] = ACTIONS(3822),
    [anon_sym___inline] = ACTIONS(3822),
    [anon_sym___inline__] = ACTIONS(3822),
    [anon_sym___forceinline] = ACTIONS(3822),
    [anon_sym_thread_local] = ACTIONS(3822),
    [anon_sym___thread] = ACTIONS(3822),
    [anon_sym_const] = ACTIONS(3822),
    [anon_sym_constexpr] = ACTIONS(3822),
    [anon_sym_volatile] = ACTIONS(3822),
    [anon_sym_restrict] = ACTIONS(3822),
    [anon_sym___restrict__] = ACTIONS(3822),
    [anon_sym__Atomic] = ACTIONS(3822),
    [anon_sym__Noreturn] = ACTIONS(3822),
    [anon_sym_noreturn] = ACTIONS(3822),
    [anon_sym__Nonnull] = ACTIONS(3822),
    [anon_sym_mutable] = ACTIONS(3822),
    [anon_sym_constinit] = ACTIONS(3822),
    [anon_sym_consteval] = ACTIONS(3822),
    [anon_sym_alignas] = ACTIONS(3822),
    [anon_sym__Alignas] = ACTIONS(3822),
    [sym_primitive_type] = ACTIONS(3822),
    [anon_sym_enum] = ACTIONS(3822),
    [anon_sym_class] = ACTIONS(3822),
    [anon_sym_struct] = ACTIONS(3822),
    [anon_sym_union] = ACTIONS(3822),
    [anon_sym_if] = ACTIONS(3822),
    [anon_sym_switch] = ACTIONS(3822),
    [anon_sym_case] = ACTIONS(3822),
    [anon_sym_default] = ACTIONS(3822),
    [anon_sym_while] = ACTIONS(3822),
    [anon_sym_do] = ACTIONS(3822),
    [anon_sym_for] = ACTIONS(3822),
    [anon_sym_return] = ACTIONS(3822),
    [anon_sym_break] = ACTIONS(3822),
    [anon_sym_continue] = ACTIONS(3822),
    [anon_sym_goto] = ACTIONS(3822),
    [anon_sym___try] = ACTIONS(3822),
    [anon_sym___leave] = ACTIONS(3822),
    [anon_sym_not] = ACTIONS(3822),
    [anon_sym_compl] = ACTIONS(3822),
    [anon_sym_DASH_DASH] = ACTIONS(3824),
    [anon_sym_PLUS_PLUS] = ACTIONS(3824),
    [anon_sym_sizeof] = ACTIONS(3822),
    [anon_sym___alignof__] = ACTIONS(3822),
    [anon_sym___alignof] = ACTIONS(3822),
    [anon_sym__alignof] = ACTIONS(3822),
    [anon_sym_alignof] = ACTIONS(3822),
    [anon_sym__Alignof] = ACTIONS(3822),
    [anon_sym_offsetof] = ACTIONS(3822),
    [anon_sym__Generic] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3822),
    [anon_sym___asm__] = ACTIONS(3822),
    [anon_sym___asm] = ACTIONS(3822),
    [sym_number_literal] = ACTIONS(3824),
    [anon_sym_L_SQUOTE] = ACTIONS(3824),
    [anon_sym_u_SQUOTE] = ACTIONS(3824),
    [anon_sym_U_SQUOTE] = ACTIONS(3824),
    [anon_sym_u8_SQUOTE] = ACTIONS(3824),
    [anon_sym_SQUOTE] = ACTIONS(3824),
    [anon_sym_L_DQUOTE] = ACTIONS(3824),
    [anon_sym_u_DQUOTE] = ACTIONS(3824),
    [anon_sym_U_DQUOTE] = ACTIONS(3824),
    [anon_sym_u8_DQUOTE] = ACTIONS(3824),
    [anon_sym_DQUOTE] = ACTIONS(3824),
    [sym_true] = ACTIONS(3822),
    [sym_false] = ACTIONS(3822),
    [anon_sym_NULL] = ACTIONS(3822),
    [anon_sym_nullptr] = ACTIONS(3822),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3822),
    [anon_sym_decltype] = ACTIONS(3822),
    [anon_sym_typename] = ACTIONS(3822),
    [anon_sym_template] = ACTIONS(3822),
    [anon_sym_try] = ACTIONS(3822),
    [anon_sym_delete] = ACTIONS(3822),
    [anon_sym_throw] = ACTIONS(3822),
    [anon_sym_co_return] = ACTIONS(3822),
    [anon_sym_co_yield] = ACTIONS(3822),
    [anon_sym_R_DQUOTE] = ACTIONS(3824),
    [anon_sym_LR_DQUOTE] = ACTIONS(3824),
    [anon_sym_uR_DQUOTE] = ACTIONS(3824),
    [anon_sym_UR_DQUOTE] = ACTIONS(3824),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3824),
    [anon_sym_co_await] = ACTIONS(3822),
    [anon_sym_new] = ACTIONS(3822),
    [anon_sym_requires] = ACTIONS(3822),
    [sym_this] = ACTIONS(3822),
  },
  [887] = {
    [sym_identifier] = ACTIONS(2629),
    [anon_sym_LPAREN2] = ACTIONS(2631),
    [anon_sym_BANG] = ACTIONS(2631),
    [anon_sym_TILDE] = ACTIONS(2631),
    [anon_sym_DASH] = ACTIONS(2629),
    [anon_sym_PLUS] = ACTIONS(2629),
    [anon_sym_STAR] = ACTIONS(2631),
    [anon_sym_AMP] = ACTIONS(2631),
    [anon_sym_SEMI] = ACTIONS(2631),
    [anon_sym___extension__] = ACTIONS(2629),
    [anon_sym_typedef] = ACTIONS(2629),
    [anon_sym_virtual] = ACTIONS(2629),
    [anon_sym_extern] = ACTIONS(2629),
    [anon_sym___attribute__] = ACTIONS(2629),
    [anon_sym___attribute] = ACTIONS(2629),
    [anon_sym_COLON_COLON] = ACTIONS(2631),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2631),
    [anon_sym___declspec] = ACTIONS(2629),
    [anon_sym_LBRACE] = ACTIONS(2631),
    [anon_sym_signed] = ACTIONS(2629),
    [anon_sym_unsigned] = ACTIONS(2629),
    [anon_sym_long] = ACTIONS(2629),
    [anon_sym_short] = ACTIONS(2629),
    [anon_sym_LBRACK] = ACTIONS(2629),
    [anon_sym_static] = ACTIONS(2629),
    [anon_sym_register] = ACTIONS(2629),
    [anon_sym_inline] = ACTIONS(2629),
    [anon_sym___inline] = ACTIONS(2629),
    [anon_sym___inline__] = ACTIONS(2629),
    [anon_sym___forceinline] = ACTIONS(2629),
    [anon_sym_thread_local] = ACTIONS(2629),
    [anon_sym___thread] = ACTIONS(2629),
    [anon_sym_const] = ACTIONS(2629),
    [anon_sym_constexpr] = ACTIONS(2629),
    [anon_sym_volatile] = ACTIONS(2629),
    [anon_sym_restrict] = ACTIONS(2629),
    [anon_sym___restrict__] = ACTIONS(2629),
    [anon_sym__Atomic] = ACTIONS(2629),
    [anon_sym__Noreturn] = ACTIONS(2629),
    [anon_sym_noreturn] = ACTIONS(2629),
    [anon_sym__Nonnull] = ACTIONS(2629),
    [anon_sym_mutable] = ACTIONS(2629),
    [anon_sym_constinit] = ACTIONS(2629),
    [anon_sym_consteval] = ACTIONS(2629),
    [anon_sym_alignas] = ACTIONS(2629),
    [anon_sym__Alignas] = ACTIONS(2629),
    [sym_primitive_type] = ACTIONS(2629),
    [anon_sym_enum] = ACTIONS(2629),
    [anon_sym_class] = ACTIONS(2629),
    [anon_sym_struct] = ACTIONS(2629),
    [anon_sym_union] = ACTIONS(2629),
    [anon_sym_if] = ACTIONS(2629),
    [anon_sym_else] = ACTIONS(2629),
    [anon_sym_switch] = ACTIONS(2629),
    [anon_sym_while] = ACTIONS(2629),
    [anon_sym_do] = ACTIONS(2629),
    [anon_sym_for] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(2629),
    [anon_sym_break] = ACTIONS(2629),
    [anon_sym_continue] = ACTIONS(2629),
    [anon_sym_goto] = ACTIONS(2629),
    [anon_sym___try] = ACTIONS(2629),
    [anon_sym___leave] = ACTIONS(2629),
    [anon_sym_not] = ACTIONS(2629),
    [anon_sym_compl] = ACTIONS(2629),
    [anon_sym_DASH_DASH] = ACTIONS(2631),
    [anon_sym_PLUS_PLUS] = ACTIONS(2631),
    [anon_sym_sizeof] = ACTIONS(2629),
    [anon_sym___alignof__] = ACTIONS(2629),
    [anon_sym___alignof] = ACTIONS(2629),
    [anon_sym__alignof] = ACTIONS(2629),
    [anon_sym_alignof] = ACTIONS(2629),
    [anon_sym__Alignof] = ACTIONS(2629),
    [anon_sym_offsetof] = ACTIONS(2629),
    [anon_sym__Generic] = ACTIONS(2629),
    [anon_sym_asm] = ACTIONS(2629),
    [anon_sym___asm__] = ACTIONS(2629),
    [anon_sym___asm] = ACTIONS(2629),
    [sym_number_literal] = ACTIONS(2631),
    [anon_sym_L_SQUOTE] = ACTIONS(2631),
    [anon_sym_u_SQUOTE] = ACTIONS(2631),
    [anon_sym_U_SQUOTE] = ACTIONS(2631),
    [anon_sym_u8_SQUOTE] = ACTIONS(2631),
    [anon_sym_SQUOTE] = ACTIONS(2631),
    [anon_sym_L_DQUOTE] = ACTIONS(2631),
    [anon_sym_u_DQUOTE] = ACTIONS(2631),
    [anon_sym_U_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8_DQUOTE] = ACTIONS(2631),
    [anon_sym_DQUOTE] = ACTIONS(2631),
    [sym_true] = ACTIONS(2629),
    [sym_false] = ACTIONS(2629),
    [anon_sym_NULL] = ACTIONS(2629),
    [anon_sym_nullptr] = ACTIONS(2629),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2629),
    [anon_sym_decltype] = ACTIONS(2629),
    [anon_sym_typename] = ACTIONS(2629),
    [anon_sym_template] = ACTIONS(2629),
    [anon_sym_try] = ACTIONS(2629),
    [anon_sym_delete] = ACTIONS(2629),
    [anon_sym_throw] = ACTIONS(2629),
    [anon_sym_co_return] = ACTIONS(2629),
    [anon_sym_co_yield] = ACTIONS(2629),
    [anon_sym_R_DQUOTE] = ACTIONS(2631),
    [anon_sym_LR_DQUOTE] = ACTIONS(2631),
    [anon_sym_uR_DQUOTE] = ACTIONS(2631),
    [anon_sym_UR_DQUOTE] = ACTIONS(2631),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2631),
    [anon_sym_co_await] = ACTIONS(2629),
    [anon_sym_new] = ACTIONS(2629),
    [anon_sym_requires] = ACTIONS(2629),
    [sym_this] = ACTIONS(2629),
  },
  [888] = {
    [sym__declaration_modifiers] = STATE(2045),
    [sym__declaration_specifiers] = STATE(3895),
    [sym_attribute_specifier] = STATE(2045),
    [sym_attribute_declaration] = STATE(2045),
    [sym_ms_declspec_modifier] = STATE(2045),
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_call_modifier] = STATE(4714),
    [sym__declarator] = STATE(6536),
    [sym__abstract_declarator] = STATE(6752),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_abstract_parenthesized_declarator] = STATE(5942),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_abstract_pointer_declarator] = STATE(5942),
    [sym_function_declarator] = STATE(5896),
    [sym_abstract_function_declarator] = STATE(5942),
    [sym_array_declarator] = STATE(5896),
    [sym_abstract_array_declarator] = STATE(5942),
    [sym_storage_class_specifier] = STATE(2045),
    [sym_type_qualifier] = STATE(2045),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_parameter_list] = STATE(3055),
    [sym_parameter_declaration] = STATE(7110),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_dependent_type] = STATE(2383),
    [sym_optional_parameter_declaration] = STATE(7110),
    [sym_variadic_parameter_declaration] = STATE(7110),
    [sym_reference_declarator] = STATE(5896),
    [sym_abstract_reference_declarator] = STATE(5942),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym__function_declarator_seq] = STATE(5919),
    [sym_template_type] = STATE(2336),
    [sym_template_function] = STATE(5896),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5606),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_operator_name] = STATE(5896),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2045),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(4153),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1901),
    [anon_sym_RPAREN] = ACTIONS(4155),
    [anon_sym_LPAREN2] = ACTIONS(4157),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(4159),
    [anon_sym_AMP_AMP] = ACTIONS(4161),
    [anon_sym_AMP] = ACTIONS(4163),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(1851),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4165),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym___cdecl] = ACTIONS(1779),
    [anon_sym___clrcall] = ACTIONS(1779),
    [anon_sym___stdcall] = ACTIONS(1779),
    [anon_sym___fastcall] = ACTIONS(1779),
    [anon_sym___thiscall] = ACTIONS(1779),
    [anon_sym___vectorcall] = ACTIONS(1779),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(4167),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(1857),
    [anon_sym_class] = ACTIONS(1859),
    [anon_sym_struct] = ACTIONS(1861),
    [anon_sym_union] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(1887),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_operator] = ACTIONS(1823),
  },
  [889] = {
    [sym_string_literal] = STATE(2570),
    [sym_template_argument_list] = STATE(1623),
    [sym_raw_string_literal] = STATE(2570),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2551),
    [sym_identifier] = ACTIONS(4033),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4035),
    [anon_sym_COMMA] = ACTIONS(4035),
    [anon_sym_LPAREN2] = ACTIONS(4048),
    [anon_sym_TILDE] = ACTIONS(4041),
    [anon_sym_DASH] = ACTIONS(4043),
    [anon_sym_PLUS] = ACTIONS(4043),
    [anon_sym_STAR] = ACTIONS(4045),
    [anon_sym_SLASH] = ACTIONS(4043),
    [anon_sym_PERCENT] = ACTIONS(4043),
    [anon_sym_PIPE_PIPE] = ACTIONS(4035),
    [anon_sym_AMP_AMP] = ACTIONS(4048),
    [anon_sym_PIPE] = ACTIONS(4043),
    [anon_sym_CARET] = ACTIONS(4043),
    [anon_sym_AMP] = ACTIONS(4045),
    [anon_sym_EQ_EQ] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4043),
    [anon_sym_GT_EQ] = ACTIONS(4035),
    [anon_sym_LT_EQ] = ACTIONS(4043),
    [anon_sym_LT] = ACTIONS(4051),
    [anon_sym_LT_LT] = ACTIONS(4043),
    [anon_sym_GT_GT] = ACTIONS(4043),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym___extension__] = ACTIONS(4033),
    [anon_sym_virtual] = ACTIONS(4033),
    [anon_sym_extern] = ACTIONS(4033),
    [anon_sym___attribute__] = ACTIONS(4033),
    [anon_sym___attribute] = ACTIONS(4033),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym___declspec] = ACTIONS(4033),
    [anon_sym___based] = ACTIONS(4033),
    [anon_sym_LBRACE] = ACTIONS(4059),
    [anon_sym_RBRACE] = ACTIONS(4035),
    [anon_sym_signed] = ACTIONS(4061),
    [anon_sym_unsigned] = ACTIONS(4061),
    [anon_sym_long] = ACTIONS(4061),
    [anon_sym_short] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(4045),
    [anon_sym_static] = ACTIONS(4033),
    [anon_sym_EQ] = ACTIONS(4067),
    [anon_sym_register] = ACTIONS(4033),
    [anon_sym_inline] = ACTIONS(4033),
    [anon_sym___inline] = ACTIONS(4033),
    [anon_sym___inline__] = ACTIONS(4033),
    [anon_sym___forceinline] = ACTIONS(4033),
    [anon_sym_thread_local] = ACTIONS(4033),
    [anon_sym___thread] = ACTIONS(4033),
    [anon_sym_const] = ACTIONS(4033),
    [anon_sym_constexpr] = ACTIONS(4033),
    [anon_sym_volatile] = ACTIONS(4033),
    [anon_sym_restrict] = ACTIONS(4033),
    [anon_sym___restrict__] = ACTIONS(4033),
    [anon_sym__Atomic] = ACTIONS(4033),
    [anon_sym__Noreturn] = ACTIONS(4033),
    [anon_sym_noreturn] = ACTIONS(4033),
    [anon_sym__Nonnull] = ACTIONS(4033),
    [anon_sym_mutable] = ACTIONS(4033),
    [anon_sym_constinit] = ACTIONS(4033),
    [anon_sym_consteval] = ACTIONS(4033),
    [anon_sym_alignas] = ACTIONS(4033),
    [anon_sym__Alignas] = ACTIONS(4033),
    [anon_sym_COLON] = ACTIONS(4145),
    [anon_sym_QMARK] = ACTIONS(4035),
    [anon_sym_STAR_EQ] = ACTIONS(4071),
    [anon_sym_SLASH_EQ] = ACTIONS(4071),
    [anon_sym_PERCENT_EQ] = ACTIONS(4071),
    [anon_sym_PLUS_EQ] = ACTIONS(4071),
    [anon_sym_DASH_EQ] = ACTIONS(4071),
    [anon_sym_LT_LT_EQ] = ACTIONS(4071),
    [anon_sym_GT_GT_EQ] = ACTIONS(4071),
    [anon_sym_AMP_EQ] = ACTIONS(4071),
    [anon_sym_CARET_EQ] = ACTIONS(4071),
    [anon_sym_PIPE_EQ] = ACTIONS(4071),
    [anon_sym_and_eq] = ACTIONS(4067),
    [anon_sym_or_eq] = ACTIONS(4067),
    [anon_sym_xor_eq] = ACTIONS(4067),
    [anon_sym_LT_EQ_GT] = ACTIONS(4035),
    [anon_sym_or] = ACTIONS(4043),
    [anon_sym_and] = ACTIONS(4043),
    [anon_sym_bitor] = ACTIONS(4043),
    [anon_sym_xor] = ACTIONS(4043),
    [anon_sym_bitand] = ACTIONS(4043),
    [anon_sym_not_eq] = ACTIONS(4043),
    [anon_sym_DASH_DASH] = ACTIONS(4035),
    [anon_sym_PLUS_PLUS] = ACTIONS(4035),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_DOT_STAR] = ACTIONS(4035),
    [anon_sym_DASH_GT] = ACTIONS(4035),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4033),
    [anon_sym_decltype] = ACTIONS(4033),
    [anon_sym_template] = ACTIONS(4033),
    [anon_sym_operator] = ACTIONS(4033),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
  },
  [890] = {
    [sym_string_literal] = STATE(2570),
    [sym_template_argument_list] = STATE(1623),
    [sym_raw_string_literal] = STATE(2570),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2551),
    [sym_identifier] = ACTIONS(4033),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4035),
    [anon_sym_COMMA] = ACTIONS(4035),
    [anon_sym_RPAREN] = ACTIONS(4035),
    [anon_sym_LPAREN2] = ACTIONS(4048),
    [anon_sym_TILDE] = ACTIONS(4041),
    [anon_sym_DASH] = ACTIONS(4043),
    [anon_sym_PLUS] = ACTIONS(4043),
    [anon_sym_STAR] = ACTIONS(4045),
    [anon_sym_SLASH] = ACTIONS(4043),
    [anon_sym_PERCENT] = ACTIONS(4043),
    [anon_sym_PIPE_PIPE] = ACTIONS(4035),
    [anon_sym_AMP_AMP] = ACTIONS(4048),
    [anon_sym_PIPE] = ACTIONS(4043),
    [anon_sym_CARET] = ACTIONS(4043),
    [anon_sym_AMP] = ACTIONS(4045),
    [anon_sym_EQ_EQ] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4043),
    [anon_sym_GT_EQ] = ACTIONS(4035),
    [anon_sym_LT_EQ] = ACTIONS(4043),
    [anon_sym_LT] = ACTIONS(4051),
    [anon_sym_LT_LT] = ACTIONS(4043),
    [anon_sym_GT_GT] = ACTIONS(4043),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym___extension__] = ACTIONS(4033),
    [anon_sym_virtual] = ACTIONS(4033),
    [anon_sym_extern] = ACTIONS(4033),
    [anon_sym___attribute__] = ACTIONS(4033),
    [anon_sym___attribute] = ACTIONS(4033),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym___declspec] = ACTIONS(4033),
    [anon_sym___based] = ACTIONS(4033),
    [anon_sym_LBRACE] = ACTIONS(4059),
    [anon_sym_signed] = ACTIONS(4061),
    [anon_sym_unsigned] = ACTIONS(4061),
    [anon_sym_long] = ACTIONS(4061),
    [anon_sym_short] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(4045),
    [anon_sym_static] = ACTIONS(4033),
    [anon_sym_EQ] = ACTIONS(4067),
    [anon_sym_register] = ACTIONS(4033),
    [anon_sym_inline] = ACTIONS(4033),
    [anon_sym___inline] = ACTIONS(4033),
    [anon_sym___inline__] = ACTIONS(4033),
    [anon_sym___forceinline] = ACTIONS(4033),
    [anon_sym_thread_local] = ACTIONS(4033),
    [anon_sym___thread] = ACTIONS(4033),
    [anon_sym_const] = ACTIONS(4033),
    [anon_sym_constexpr] = ACTIONS(4033),
    [anon_sym_volatile] = ACTIONS(4033),
    [anon_sym_restrict] = ACTIONS(4033),
    [anon_sym___restrict__] = ACTIONS(4033),
    [anon_sym__Atomic] = ACTIONS(4033),
    [anon_sym__Noreturn] = ACTIONS(4033),
    [anon_sym_noreturn] = ACTIONS(4033),
    [anon_sym__Nonnull] = ACTIONS(4033),
    [anon_sym_mutable] = ACTIONS(4033),
    [anon_sym_constinit] = ACTIONS(4033),
    [anon_sym_consteval] = ACTIONS(4033),
    [anon_sym_alignas] = ACTIONS(4033),
    [anon_sym__Alignas] = ACTIONS(4033),
    [anon_sym_QMARK] = ACTIONS(4035),
    [anon_sym_STAR_EQ] = ACTIONS(4071),
    [anon_sym_SLASH_EQ] = ACTIONS(4071),
    [anon_sym_PERCENT_EQ] = ACTIONS(4071),
    [anon_sym_PLUS_EQ] = ACTIONS(4071),
    [anon_sym_DASH_EQ] = ACTIONS(4071),
    [anon_sym_LT_LT_EQ] = ACTIONS(4071),
    [anon_sym_GT_GT_EQ] = ACTIONS(4071),
    [anon_sym_AMP_EQ] = ACTIONS(4071),
    [anon_sym_CARET_EQ] = ACTIONS(4071),
    [anon_sym_PIPE_EQ] = ACTIONS(4071),
    [anon_sym_and_eq] = ACTIONS(4067),
    [anon_sym_or_eq] = ACTIONS(4067),
    [anon_sym_xor_eq] = ACTIONS(4067),
    [anon_sym_LT_EQ_GT] = ACTIONS(4035),
    [anon_sym_or] = ACTIONS(4043),
    [anon_sym_and] = ACTIONS(4043),
    [anon_sym_bitor] = ACTIONS(4043),
    [anon_sym_xor] = ACTIONS(4043),
    [anon_sym_bitand] = ACTIONS(4043),
    [anon_sym_not_eq] = ACTIONS(4043),
    [anon_sym_DASH_DASH] = ACTIONS(4035),
    [anon_sym_PLUS_PLUS] = ACTIONS(4035),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_DOT_STAR] = ACTIONS(4035),
    [anon_sym_DASH_GT] = ACTIONS(4035),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4033),
    [anon_sym_decltype] = ACTIONS(4033),
    [anon_sym_template] = ACTIONS(4033),
    [anon_sym_operator] = ACTIONS(4033),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
  },
  [891] = {
    [sym_expression_statement] = STATE(2681),
    [sym_expression] = STATE(4399),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(7876),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_type_requirement] = STATE(914),
    [sym_compound_requirement] = STATE(914),
    [sym__requirement] = STATE(914),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_requirement_seq_repeat1] = STATE(914),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(4169),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(4171),
    [anon_sym_RBRACE] = ACTIONS(4173),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_typename] = ACTIONS(4175),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [892] = {
    [sym_expression_statement] = STATE(2681),
    [sym_expression] = STATE(4399),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(7876),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_type_requirement] = STATE(898),
    [sym_compound_requirement] = STATE(898),
    [sym__requirement] = STATE(898),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_requirement_seq_repeat1] = STATE(898),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(4169),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(4171),
    [anon_sym_RBRACE] = ACTIONS(4177),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_typename] = ACTIONS(4175),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [893] = {
    [sym_expression] = STATE(4277),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(7087),
    [sym_initializer_pair] = STATE(7087),
    [sym_subscript_designator] = STATE(6635),
    [sym_subscript_range_designator] = STATE(6635),
    [sym_field_designator] = STATE(6635),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_initializer_pair_repeat1] = STATE(6635),
    [sym_identifier] = ACTIONS(4179),
    [anon_sym_COMMA] = ACTIONS(4181),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_RBRACE] = ACTIONS(4183),
    [anon_sym_LBRACK] = ACTIONS(4185),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [894] = {
    [sym_expression] = STATE(4294),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(7170),
    [sym_initializer_pair] = STATE(7170),
    [sym_subscript_designator] = STATE(6635),
    [sym_subscript_range_designator] = STATE(6635),
    [sym_field_designator] = STATE(6635),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_initializer_pair_repeat1] = STATE(6635),
    [sym_identifier] = ACTIONS(4179),
    [anon_sym_COMMA] = ACTIONS(4187),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_RBRACE] = ACTIONS(4189),
    [anon_sym_LBRACK] = ACTIONS(4185),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [895] = {
    [sym_string_literal] = STATE(2570),
    [sym_template_argument_list] = STATE(1623),
    [sym_raw_string_literal] = STATE(2570),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2551),
    [sym_identifier] = ACTIONS(4033),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4035),
    [anon_sym_COMMA] = ACTIONS(4035),
    [anon_sym_LPAREN2] = ACTIONS(4048),
    [anon_sym_TILDE] = ACTIONS(4041),
    [anon_sym_DASH] = ACTIONS(4043),
    [anon_sym_PLUS] = ACTIONS(4043),
    [anon_sym_STAR] = ACTIONS(4045),
    [anon_sym_SLASH] = ACTIONS(4043),
    [anon_sym_PERCENT] = ACTIONS(4043),
    [anon_sym_PIPE_PIPE] = ACTIONS(4035),
    [anon_sym_AMP_AMP] = ACTIONS(4048),
    [anon_sym_PIPE] = ACTIONS(4043),
    [anon_sym_CARET] = ACTIONS(4043),
    [anon_sym_AMP] = ACTIONS(4045),
    [anon_sym_EQ_EQ] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4043),
    [anon_sym_GT_EQ] = ACTIONS(4035),
    [anon_sym_LT_EQ] = ACTIONS(4043),
    [anon_sym_LT] = ACTIONS(4051),
    [anon_sym_LT_LT] = ACTIONS(4043),
    [anon_sym_GT_GT] = ACTIONS(4043),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym___extension__] = ACTIONS(4033),
    [anon_sym_virtual] = ACTIONS(4033),
    [anon_sym_extern] = ACTIONS(4033),
    [anon_sym___attribute__] = ACTIONS(4033),
    [anon_sym___attribute] = ACTIONS(4033),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym___declspec] = ACTIONS(4033),
    [anon_sym___based] = ACTIONS(4033),
    [anon_sym_LBRACE] = ACTIONS(4059),
    [anon_sym_signed] = ACTIONS(4061),
    [anon_sym_unsigned] = ACTIONS(4061),
    [anon_sym_long] = ACTIONS(4061),
    [anon_sym_short] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(4045),
    [anon_sym_static] = ACTIONS(4033),
    [anon_sym_EQ] = ACTIONS(4067),
    [anon_sym_register] = ACTIONS(4033),
    [anon_sym_inline] = ACTIONS(4033),
    [anon_sym___inline] = ACTIONS(4033),
    [anon_sym___inline__] = ACTIONS(4033),
    [anon_sym___forceinline] = ACTIONS(4033),
    [anon_sym_thread_local] = ACTIONS(4033),
    [anon_sym___thread] = ACTIONS(4033),
    [anon_sym_const] = ACTIONS(4033),
    [anon_sym_constexpr] = ACTIONS(4033),
    [anon_sym_volatile] = ACTIONS(4033),
    [anon_sym_restrict] = ACTIONS(4033),
    [anon_sym___restrict__] = ACTIONS(4033),
    [anon_sym__Atomic] = ACTIONS(4033),
    [anon_sym__Noreturn] = ACTIONS(4033),
    [anon_sym_noreturn] = ACTIONS(4033),
    [anon_sym__Nonnull] = ACTIONS(4033),
    [anon_sym_mutable] = ACTIONS(4033),
    [anon_sym_constinit] = ACTIONS(4033),
    [anon_sym_consteval] = ACTIONS(4033),
    [anon_sym_alignas] = ACTIONS(4033),
    [anon_sym__Alignas] = ACTIONS(4033),
    [anon_sym_COLON] = ACTIONS(4191),
    [anon_sym_QMARK] = ACTIONS(4035),
    [anon_sym_STAR_EQ] = ACTIONS(4071),
    [anon_sym_SLASH_EQ] = ACTIONS(4071),
    [anon_sym_PERCENT_EQ] = ACTIONS(4071),
    [anon_sym_PLUS_EQ] = ACTIONS(4071),
    [anon_sym_DASH_EQ] = ACTIONS(4071),
    [anon_sym_LT_LT_EQ] = ACTIONS(4071),
    [anon_sym_GT_GT_EQ] = ACTIONS(4071),
    [anon_sym_AMP_EQ] = ACTIONS(4071),
    [anon_sym_CARET_EQ] = ACTIONS(4071),
    [anon_sym_PIPE_EQ] = ACTIONS(4071),
    [anon_sym_and_eq] = ACTIONS(4067),
    [anon_sym_or_eq] = ACTIONS(4067),
    [anon_sym_xor_eq] = ACTIONS(4067),
    [anon_sym_LT_EQ_GT] = ACTIONS(4035),
    [anon_sym_or] = ACTIONS(4043),
    [anon_sym_and] = ACTIONS(4043),
    [anon_sym_bitor] = ACTIONS(4043),
    [anon_sym_xor] = ACTIONS(4043),
    [anon_sym_bitand] = ACTIONS(4043),
    [anon_sym_not_eq] = ACTIONS(4043),
    [anon_sym_DASH_DASH] = ACTIONS(4035),
    [anon_sym_PLUS_PLUS] = ACTIONS(4035),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_DOT_STAR] = ACTIONS(4035),
    [anon_sym_DASH_GT] = ACTIONS(4035),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4033),
    [anon_sym_decltype] = ACTIONS(4033),
    [anon_sym_template] = ACTIONS(4033),
    [anon_sym_operator] = ACTIONS(4033),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
  },
  [896] = {
    [sym_expression_statement] = STATE(2681),
    [sym_expression] = STATE(4399),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(7876),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_type_requirement] = STATE(899),
    [sym_compound_requirement] = STATE(899),
    [sym__requirement] = STATE(899),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_requirement_seq_repeat1] = STATE(899),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(4169),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(4171),
    [anon_sym_RBRACE] = ACTIONS(4193),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_typename] = ACTIONS(4175),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [897] = {
    [sym_expression_statement] = STATE(2681),
    [sym_expression] = STATE(4399),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(7876),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_type_requirement] = STATE(914),
    [sym_compound_requirement] = STATE(914),
    [sym__requirement] = STATE(914),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_requirement_seq_repeat1] = STATE(914),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(4169),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(4171),
    [anon_sym_RBRACE] = ACTIONS(4195),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_typename] = ACTIONS(4175),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [898] = {
    [sym_expression_statement] = STATE(2681),
    [sym_expression] = STATE(4399),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(7876),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_type_requirement] = STATE(914),
    [sym_compound_requirement] = STATE(914),
    [sym__requirement] = STATE(914),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_requirement_seq_repeat1] = STATE(914),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(4169),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(4171),
    [anon_sym_RBRACE] = ACTIONS(4197),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_typename] = ACTIONS(4175),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [899] = {
    [sym_expression_statement] = STATE(2681),
    [sym_expression] = STATE(4399),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(7876),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_type_requirement] = STATE(914),
    [sym_compound_requirement] = STATE(914),
    [sym__requirement] = STATE(914),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_requirement_seq_repeat1] = STATE(914),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(4169),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(4171),
    [anon_sym_RBRACE] = ACTIONS(4199),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_typename] = ACTIONS(4175),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [900] = {
    [sym_expression] = STATE(4300),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(7318),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(7523),
    [sym_initializer_pair] = STATE(7523),
    [sym_subscript_designator] = STATE(6635),
    [sym_subscript_range_designator] = STATE(6635),
    [sym_field_designator] = STATE(6635),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_initializer_pair_repeat1] = STATE(6635),
    [sym_identifier] = ACTIONS(4179),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_RBRACE] = ACTIONS(4201),
    [anon_sym_LBRACK] = ACTIONS(4185),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [901] = {
    [sym_expression_statement] = STATE(2681),
    [sym_expression] = STATE(4399),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(7876),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_type_requirement] = STATE(914),
    [sym_compound_requirement] = STATE(914),
    [sym__requirement] = STATE(914),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_requirement_seq_repeat1] = STATE(914),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(4169),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(4171),
    [anon_sym_RBRACE] = ACTIONS(4203),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_typename] = ACTIONS(4175),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [902] = {
    [sym_expression_statement] = STATE(2681),
    [sym_expression] = STATE(4399),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(7876),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_type_requirement] = STATE(906),
    [sym_compound_requirement] = STATE(906),
    [sym__requirement] = STATE(906),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_requirement_seq_repeat1] = STATE(906),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(4169),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(4171),
    [anon_sym_RBRACE] = ACTIONS(4205),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_typename] = ACTIONS(4175),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [903] = {
    [sym_expression] = STATE(4281),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(7038),
    [sym_initializer_pair] = STATE(7038),
    [sym_subscript_designator] = STATE(6635),
    [sym_subscript_range_designator] = STATE(6635),
    [sym_field_designator] = STATE(6635),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_initializer_pair_repeat1] = STATE(6635),
    [sym_identifier] = ACTIONS(4179),
    [anon_sym_COMMA] = ACTIONS(4207),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_RBRACE] = ACTIONS(4209),
    [anon_sym_LBRACK] = ACTIONS(4185),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [904] = {
    [sym_string_literal] = STATE(2570),
    [sym_template_argument_list] = STATE(1623),
    [sym_raw_string_literal] = STATE(2570),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2551),
    [sym_identifier] = ACTIONS(4033),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4035),
    [anon_sym_COMMA] = ACTIONS(4035),
    [anon_sym_LPAREN2] = ACTIONS(4048),
    [anon_sym_TILDE] = ACTIONS(4041),
    [anon_sym_DASH] = ACTIONS(4043),
    [anon_sym_PLUS] = ACTIONS(4043),
    [anon_sym_STAR] = ACTIONS(4045),
    [anon_sym_SLASH] = ACTIONS(4043),
    [anon_sym_PERCENT] = ACTIONS(4043),
    [anon_sym_PIPE_PIPE] = ACTIONS(4035),
    [anon_sym_AMP_AMP] = ACTIONS(4048),
    [anon_sym_PIPE] = ACTIONS(4043),
    [anon_sym_CARET] = ACTIONS(4043),
    [anon_sym_AMP] = ACTIONS(4045),
    [anon_sym_EQ_EQ] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4043),
    [anon_sym_GT_EQ] = ACTIONS(4035),
    [anon_sym_LT_EQ] = ACTIONS(4043),
    [anon_sym_LT] = ACTIONS(4051),
    [anon_sym_LT_LT] = ACTIONS(4043),
    [anon_sym_GT_GT] = ACTIONS(4043),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym___extension__] = ACTIONS(4033),
    [anon_sym_virtual] = ACTIONS(4033),
    [anon_sym_extern] = ACTIONS(4033),
    [anon_sym___attribute__] = ACTIONS(4033),
    [anon_sym___attribute] = ACTIONS(4033),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym___declspec] = ACTIONS(4033),
    [anon_sym___based] = ACTIONS(4033),
    [anon_sym_LBRACE] = ACTIONS(4059),
    [anon_sym_signed] = ACTIONS(4061),
    [anon_sym_unsigned] = ACTIONS(4061),
    [anon_sym_long] = ACTIONS(4061),
    [anon_sym_short] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(4045),
    [anon_sym_static] = ACTIONS(4033),
    [anon_sym_EQ] = ACTIONS(4067),
    [anon_sym_register] = ACTIONS(4033),
    [anon_sym_inline] = ACTIONS(4033),
    [anon_sym___inline] = ACTIONS(4033),
    [anon_sym___inline__] = ACTIONS(4033),
    [anon_sym___forceinline] = ACTIONS(4033),
    [anon_sym_thread_local] = ACTIONS(4033),
    [anon_sym___thread] = ACTIONS(4033),
    [anon_sym_const] = ACTIONS(4033),
    [anon_sym_constexpr] = ACTIONS(4033),
    [anon_sym_volatile] = ACTIONS(4033),
    [anon_sym_restrict] = ACTIONS(4033),
    [anon_sym___restrict__] = ACTIONS(4033),
    [anon_sym__Atomic] = ACTIONS(4033),
    [anon_sym__Noreturn] = ACTIONS(4033),
    [anon_sym_noreturn] = ACTIONS(4033),
    [anon_sym__Nonnull] = ACTIONS(4033),
    [anon_sym_mutable] = ACTIONS(4033),
    [anon_sym_constinit] = ACTIONS(4033),
    [anon_sym_consteval] = ACTIONS(4033),
    [anon_sym_alignas] = ACTIONS(4033),
    [anon_sym__Alignas] = ACTIONS(4033),
    [anon_sym_COLON] = ACTIONS(4077),
    [anon_sym_QMARK] = ACTIONS(4035),
    [anon_sym_STAR_EQ] = ACTIONS(4071),
    [anon_sym_SLASH_EQ] = ACTIONS(4071),
    [anon_sym_PERCENT_EQ] = ACTIONS(4071),
    [anon_sym_PLUS_EQ] = ACTIONS(4071),
    [anon_sym_DASH_EQ] = ACTIONS(4071),
    [anon_sym_LT_LT_EQ] = ACTIONS(4071),
    [anon_sym_GT_GT_EQ] = ACTIONS(4071),
    [anon_sym_AMP_EQ] = ACTIONS(4071),
    [anon_sym_CARET_EQ] = ACTIONS(4071),
    [anon_sym_PIPE_EQ] = ACTIONS(4071),
    [anon_sym_and_eq] = ACTIONS(4067),
    [anon_sym_or_eq] = ACTIONS(4067),
    [anon_sym_xor_eq] = ACTIONS(4067),
    [anon_sym_LT_EQ_GT] = ACTIONS(4035),
    [anon_sym_or] = ACTIONS(4043),
    [anon_sym_and] = ACTIONS(4043),
    [anon_sym_bitor] = ACTIONS(4043),
    [anon_sym_xor] = ACTIONS(4043),
    [anon_sym_bitand] = ACTIONS(4043),
    [anon_sym_not_eq] = ACTIONS(4043),
    [anon_sym_DASH_DASH] = ACTIONS(4035),
    [anon_sym_PLUS_PLUS] = ACTIONS(4035),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_DOT_STAR] = ACTIONS(4035),
    [anon_sym_DASH_GT] = ACTIONS(4035),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4033),
    [anon_sym_decltype] = ACTIONS(4033),
    [anon_sym_template] = ACTIONS(4033),
    [anon_sym_operator] = ACTIONS(4033),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
  },
  [905] = {
    [sym_expression_statement] = STATE(2681),
    [sym_expression] = STATE(4399),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(7876),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_type_requirement] = STATE(914),
    [sym_compound_requirement] = STATE(914),
    [sym__requirement] = STATE(914),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_requirement_seq_repeat1] = STATE(914),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(4169),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(4171),
    [anon_sym_RBRACE] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_typename] = ACTIONS(4175),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [906] = {
    [sym_expression_statement] = STATE(2681),
    [sym_expression] = STATE(4399),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(7876),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_type_requirement] = STATE(914),
    [sym_compound_requirement] = STATE(914),
    [sym__requirement] = STATE(914),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_requirement_seq_repeat1] = STATE(914),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(4169),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(4171),
    [anon_sym_RBRACE] = ACTIONS(4213),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_typename] = ACTIONS(4175),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [907] = {
    [sym_string_literal] = STATE(2326),
    [sym_template_argument_list] = STATE(1543),
    [sym_raw_string_literal] = STATE(2326),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2551),
    [sym_identifier] = ACTIONS(4033),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4048),
    [anon_sym_COMMA] = ACTIONS(4048),
    [anon_sym_RPAREN] = ACTIONS(4048),
    [anon_sym_LPAREN2] = ACTIONS(4048),
    [anon_sym_TILDE] = ACTIONS(4041),
    [anon_sym_DASH] = ACTIONS(4043),
    [anon_sym_PLUS] = ACTIONS(4043),
    [anon_sym_STAR] = ACTIONS(4045),
    [anon_sym_SLASH] = ACTIONS(4043),
    [anon_sym_PERCENT] = ACTIONS(4043),
    [anon_sym_PIPE_PIPE] = ACTIONS(4035),
    [anon_sym_AMP_AMP] = ACTIONS(4048),
    [anon_sym_PIPE] = ACTIONS(4043),
    [anon_sym_CARET] = ACTIONS(4043),
    [anon_sym_AMP] = ACTIONS(4045),
    [anon_sym_EQ_EQ] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4043),
    [anon_sym_GT_EQ] = ACTIONS(4035),
    [anon_sym_LT_EQ] = ACTIONS(4043),
    [anon_sym_LT] = ACTIONS(4215),
    [anon_sym_LT_LT] = ACTIONS(4043),
    [anon_sym_GT_GT] = ACTIONS(4043),
    [anon_sym___extension__] = ACTIONS(4033),
    [anon_sym_virtual] = ACTIONS(4033),
    [anon_sym_extern] = ACTIONS(4033),
    [anon_sym___attribute__] = ACTIONS(4033),
    [anon_sym___attribute] = ACTIONS(4033),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym___declspec] = ACTIONS(4033),
    [anon_sym___based] = ACTIONS(4033),
    [anon_sym_LBRACE] = ACTIONS(4059),
    [anon_sym_signed] = ACTIONS(4061),
    [anon_sym_unsigned] = ACTIONS(4061),
    [anon_sym_long] = ACTIONS(4061),
    [anon_sym_short] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(4045),
    [anon_sym_static] = ACTIONS(4033),
    [anon_sym_EQ] = ACTIONS(4045),
    [anon_sym_register] = ACTIONS(4033),
    [anon_sym_inline] = ACTIONS(4033),
    [anon_sym___inline] = ACTIONS(4033),
    [anon_sym___inline__] = ACTIONS(4033),
    [anon_sym___forceinline] = ACTIONS(4033),
    [anon_sym_thread_local] = ACTIONS(4033),
    [anon_sym___thread] = ACTIONS(4033),
    [anon_sym_const] = ACTIONS(4033),
    [anon_sym_constexpr] = ACTIONS(4033),
    [anon_sym_volatile] = ACTIONS(4033),
    [anon_sym_restrict] = ACTIONS(4033),
    [anon_sym___restrict__] = ACTIONS(4033),
    [anon_sym__Atomic] = ACTIONS(4033),
    [anon_sym__Noreturn] = ACTIONS(4033),
    [anon_sym_noreturn] = ACTIONS(4033),
    [anon_sym__Nonnull] = ACTIONS(4033),
    [anon_sym_mutable] = ACTIONS(4033),
    [anon_sym_constinit] = ACTIONS(4033),
    [anon_sym_consteval] = ACTIONS(4033),
    [anon_sym_alignas] = ACTIONS(4033),
    [anon_sym__Alignas] = ACTIONS(4033),
    [anon_sym_QMARK] = ACTIONS(4035),
    [anon_sym_STAR_EQ] = ACTIONS(4035),
    [anon_sym_SLASH_EQ] = ACTIONS(4035),
    [anon_sym_PERCENT_EQ] = ACTIONS(4035),
    [anon_sym_PLUS_EQ] = ACTIONS(4035),
    [anon_sym_DASH_EQ] = ACTIONS(4035),
    [anon_sym_LT_LT_EQ] = ACTIONS(4035),
    [anon_sym_GT_GT_EQ] = ACTIONS(4035),
    [anon_sym_AMP_EQ] = ACTIONS(4035),
    [anon_sym_CARET_EQ] = ACTIONS(4035),
    [anon_sym_PIPE_EQ] = ACTIONS(4035),
    [anon_sym_and_eq] = ACTIONS(4218),
    [anon_sym_or_eq] = ACTIONS(4218),
    [anon_sym_xor_eq] = ACTIONS(4218),
    [anon_sym_LT_EQ_GT] = ACTIONS(4035),
    [anon_sym_or] = ACTIONS(4043),
    [anon_sym_and] = ACTIONS(4043),
    [anon_sym_bitor] = ACTIONS(4043),
    [anon_sym_xor] = ACTIONS(4043),
    [anon_sym_bitand] = ACTIONS(4043),
    [anon_sym_not_eq] = ACTIONS(4043),
    [anon_sym_DASH_DASH] = ACTIONS(4035),
    [anon_sym_PLUS_PLUS] = ACTIONS(4035),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_DOT_STAR] = ACTIONS(4035),
    [anon_sym_DASH_GT] = ACTIONS(4043),
    [anon_sym_L_DQUOTE] = ACTIONS(4220),
    [anon_sym_u_DQUOTE] = ACTIONS(4220),
    [anon_sym_U_DQUOTE] = ACTIONS(4220),
    [anon_sym_u8_DQUOTE] = ACTIONS(4220),
    [anon_sym_DQUOTE] = ACTIONS(4220),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4033),
    [anon_sym_decltype] = ACTIONS(4033),
    [anon_sym_template] = ACTIONS(4033),
    [anon_sym_operator] = ACTIONS(4033),
    [anon_sym_R_DQUOTE] = ACTIONS(4222),
    [anon_sym_LR_DQUOTE] = ACTIONS(4222),
    [anon_sym_uR_DQUOTE] = ACTIONS(4222),
    [anon_sym_UR_DQUOTE] = ACTIONS(4222),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4222),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4035),
  },
  [908] = {
    [sym_string_literal] = STATE(2570),
    [sym_template_argument_list] = STATE(1623),
    [sym_raw_string_literal] = STATE(2570),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2551),
    [sym_identifier] = ACTIONS(4033),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4035),
    [anon_sym_COMMA] = ACTIONS(4035),
    [anon_sym_LPAREN2] = ACTIONS(4048),
    [anon_sym_TILDE] = ACTIONS(4041),
    [anon_sym_DASH] = ACTIONS(4043),
    [anon_sym_PLUS] = ACTIONS(4043),
    [anon_sym_STAR] = ACTIONS(4045),
    [anon_sym_SLASH] = ACTIONS(4043),
    [anon_sym_PERCENT] = ACTIONS(4043),
    [anon_sym_PIPE_PIPE] = ACTIONS(4035),
    [anon_sym_AMP_AMP] = ACTIONS(4048),
    [anon_sym_PIPE] = ACTIONS(4043),
    [anon_sym_CARET] = ACTIONS(4043),
    [anon_sym_AMP] = ACTIONS(4045),
    [anon_sym_EQ_EQ] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4043),
    [anon_sym_GT_EQ] = ACTIONS(4035),
    [anon_sym_LT_EQ] = ACTIONS(4043),
    [anon_sym_LT] = ACTIONS(4051),
    [anon_sym_LT_LT] = ACTIONS(4043),
    [anon_sym_GT_GT] = ACTIONS(4043),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym___extension__] = ACTIONS(4033),
    [anon_sym_virtual] = ACTIONS(4033),
    [anon_sym_extern] = ACTIONS(4033),
    [anon_sym___attribute__] = ACTIONS(4033),
    [anon_sym___attribute] = ACTIONS(4033),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym___declspec] = ACTIONS(4033),
    [anon_sym___based] = ACTIONS(4033),
    [anon_sym_LBRACE] = ACTIONS(4059),
    [anon_sym_signed] = ACTIONS(4061),
    [anon_sym_unsigned] = ACTIONS(4061),
    [anon_sym_long] = ACTIONS(4061),
    [anon_sym_short] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(4045),
    [anon_sym_static] = ACTIONS(4033),
    [anon_sym_EQ] = ACTIONS(4067),
    [anon_sym_register] = ACTIONS(4033),
    [anon_sym_inline] = ACTIONS(4033),
    [anon_sym___inline] = ACTIONS(4033),
    [anon_sym___inline__] = ACTIONS(4033),
    [anon_sym___forceinline] = ACTIONS(4033),
    [anon_sym_thread_local] = ACTIONS(4033),
    [anon_sym___thread] = ACTIONS(4033),
    [anon_sym_const] = ACTIONS(4033),
    [anon_sym_constexpr] = ACTIONS(4033),
    [anon_sym_volatile] = ACTIONS(4033),
    [anon_sym_restrict] = ACTIONS(4033),
    [anon_sym___restrict__] = ACTIONS(4033),
    [anon_sym__Atomic] = ACTIONS(4033),
    [anon_sym__Noreturn] = ACTIONS(4033),
    [anon_sym_noreturn] = ACTIONS(4033),
    [anon_sym__Nonnull] = ACTIONS(4033),
    [anon_sym_mutable] = ACTIONS(4033),
    [anon_sym_constinit] = ACTIONS(4033),
    [anon_sym_consteval] = ACTIONS(4033),
    [anon_sym_alignas] = ACTIONS(4033),
    [anon_sym__Alignas] = ACTIONS(4033),
    [anon_sym_COLON] = ACTIONS(4149),
    [anon_sym_QMARK] = ACTIONS(4035),
    [anon_sym_STAR_EQ] = ACTIONS(4071),
    [anon_sym_SLASH_EQ] = ACTIONS(4071),
    [anon_sym_PERCENT_EQ] = ACTIONS(4071),
    [anon_sym_PLUS_EQ] = ACTIONS(4071),
    [anon_sym_DASH_EQ] = ACTIONS(4071),
    [anon_sym_LT_LT_EQ] = ACTIONS(4071),
    [anon_sym_GT_GT_EQ] = ACTIONS(4071),
    [anon_sym_AMP_EQ] = ACTIONS(4071),
    [anon_sym_CARET_EQ] = ACTIONS(4071),
    [anon_sym_PIPE_EQ] = ACTIONS(4071),
    [anon_sym_and_eq] = ACTIONS(4067),
    [anon_sym_or_eq] = ACTIONS(4067),
    [anon_sym_xor_eq] = ACTIONS(4067),
    [anon_sym_LT_EQ_GT] = ACTIONS(4035),
    [anon_sym_or] = ACTIONS(4043),
    [anon_sym_and] = ACTIONS(4043),
    [anon_sym_bitor] = ACTIONS(4043),
    [anon_sym_xor] = ACTIONS(4043),
    [anon_sym_bitand] = ACTIONS(4043),
    [anon_sym_not_eq] = ACTIONS(4043),
    [anon_sym_DASH_DASH] = ACTIONS(4035),
    [anon_sym_PLUS_PLUS] = ACTIONS(4035),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_DOT_STAR] = ACTIONS(4035),
    [anon_sym_DASH_GT] = ACTIONS(4035),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4033),
    [anon_sym_decltype] = ACTIONS(4033),
    [anon_sym_template] = ACTIONS(4033),
    [anon_sym_operator] = ACTIONS(4033),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
  },
  [909] = {
    [sym_expression] = STATE(4331),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(7055),
    [sym_initializer_pair] = STATE(7055),
    [sym_subscript_designator] = STATE(6635),
    [sym_subscript_range_designator] = STATE(6635),
    [sym_field_designator] = STATE(6635),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_initializer_pair_repeat1] = STATE(6635),
    [sym_identifier] = ACTIONS(4179),
    [anon_sym_COMMA] = ACTIONS(167),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_RBRACE] = ACTIONS(4224),
    [anon_sym_LBRACK] = ACTIONS(4185),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [910] = {
    [sym_expression] = STATE(4342),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(7273),
    [sym_initializer_pair] = STATE(7273),
    [sym_subscript_designator] = STATE(6635),
    [sym_subscript_range_designator] = STATE(6635),
    [sym_field_designator] = STATE(6635),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_initializer_pair_repeat1] = STATE(6635),
    [sym_identifier] = ACTIONS(4179),
    [anon_sym_COMMA] = ACTIONS(4226),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_RBRACE] = ACTIONS(4228),
    [anon_sym_LBRACK] = ACTIONS(4185),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [911] = {
    [sym_expression_statement] = STATE(2681),
    [sym_expression] = STATE(4399),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(7876),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_type_requirement] = STATE(901),
    [sym_compound_requirement] = STATE(901),
    [sym__requirement] = STATE(901),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_requirement_seq_repeat1] = STATE(901),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(4169),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(4171),
    [anon_sym_RBRACE] = ACTIONS(4230),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_typename] = ACTIONS(4175),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [912] = {
    [sym_expression_statement] = STATE(2681),
    [sym_expression] = STATE(4399),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(7876),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_type_requirement] = STATE(916),
    [sym_compound_requirement] = STATE(916),
    [sym__requirement] = STATE(916),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_requirement_seq_repeat1] = STATE(916),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(4169),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(4171),
    [anon_sym_RBRACE] = ACTIONS(4232),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_typename] = ACTIONS(4175),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [913] = {
    [sym_expression_statement] = STATE(2681),
    [sym_expression] = STATE(4399),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(7876),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_type_requirement] = STATE(897),
    [sym_compound_requirement] = STATE(897),
    [sym__requirement] = STATE(897),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_requirement_seq_repeat1] = STATE(897),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(4169),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(4171),
    [anon_sym_RBRACE] = ACTIONS(4234),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_typename] = ACTIONS(4175),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [914] = {
    [sym_expression_statement] = STATE(2681),
    [sym_expression] = STATE(4399),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(7876),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_type_requirement] = STATE(914),
    [sym_compound_requirement] = STATE(914),
    [sym__requirement] = STATE(914),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_requirement_seq_repeat1] = STATE(914),
    [sym_identifier] = ACTIONS(4236),
    [anon_sym_LPAREN2] = ACTIONS(4239),
    [anon_sym_BANG] = ACTIONS(4242),
    [anon_sym_TILDE] = ACTIONS(4242),
    [anon_sym_DASH] = ACTIONS(4245),
    [anon_sym_PLUS] = ACTIONS(4245),
    [anon_sym_STAR] = ACTIONS(4248),
    [anon_sym_AMP] = ACTIONS(4248),
    [anon_sym_SEMI] = ACTIONS(4251),
    [anon_sym___extension__] = ACTIONS(4254),
    [anon_sym_COLON_COLON] = ACTIONS(4257),
    [anon_sym_LBRACE] = ACTIONS(4260),
    [anon_sym_RBRACE] = ACTIONS(4263),
    [anon_sym_LBRACK] = ACTIONS(4265),
    [sym_primitive_type] = ACTIONS(4268),
    [anon_sym_not] = ACTIONS(4245),
    [anon_sym_compl] = ACTIONS(4245),
    [anon_sym_DASH_DASH] = ACTIONS(4271),
    [anon_sym_PLUS_PLUS] = ACTIONS(4271),
    [anon_sym_sizeof] = ACTIONS(4274),
    [anon_sym___alignof__] = ACTIONS(4277),
    [anon_sym___alignof] = ACTIONS(4277),
    [anon_sym__alignof] = ACTIONS(4277),
    [anon_sym_alignof] = ACTIONS(4277),
    [anon_sym__Alignof] = ACTIONS(4277),
    [anon_sym_offsetof] = ACTIONS(4280),
    [anon_sym__Generic] = ACTIONS(4283),
    [anon_sym_asm] = ACTIONS(4286),
    [anon_sym___asm__] = ACTIONS(4286),
    [anon_sym___asm] = ACTIONS(4286),
    [sym_number_literal] = ACTIONS(4289),
    [anon_sym_L_SQUOTE] = ACTIONS(4292),
    [anon_sym_u_SQUOTE] = ACTIONS(4292),
    [anon_sym_U_SQUOTE] = ACTIONS(4292),
    [anon_sym_u8_SQUOTE] = ACTIONS(4292),
    [anon_sym_SQUOTE] = ACTIONS(4292),
    [anon_sym_L_DQUOTE] = ACTIONS(4295),
    [anon_sym_u_DQUOTE] = ACTIONS(4295),
    [anon_sym_U_DQUOTE] = ACTIONS(4295),
    [anon_sym_u8_DQUOTE] = ACTIONS(4295),
    [anon_sym_DQUOTE] = ACTIONS(4295),
    [sym_true] = ACTIONS(4298),
    [sym_false] = ACTIONS(4298),
    [anon_sym_NULL] = ACTIONS(4301),
    [anon_sym_nullptr] = ACTIONS(4301),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(4304),
    [anon_sym_typename] = ACTIONS(4307),
    [anon_sym_template] = ACTIONS(4310),
    [anon_sym_delete] = ACTIONS(4313),
    [anon_sym_R_DQUOTE] = ACTIONS(4316),
    [anon_sym_LR_DQUOTE] = ACTIONS(4316),
    [anon_sym_uR_DQUOTE] = ACTIONS(4316),
    [anon_sym_UR_DQUOTE] = ACTIONS(4316),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4316),
    [anon_sym_co_await] = ACTIONS(4319),
    [anon_sym_new] = ACTIONS(4322),
    [anon_sym_requires] = ACTIONS(4325),
    [sym_this] = ACTIONS(4298),
  },
  [915] = {
    [sym_expression] = STATE(4302),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(7295),
    [sym_initializer_pair] = STATE(7295),
    [sym_subscript_designator] = STATE(6635),
    [sym_subscript_range_designator] = STATE(6635),
    [sym_field_designator] = STATE(6635),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_initializer_pair_repeat1] = STATE(6635),
    [sym_identifier] = ACTIONS(4179),
    [anon_sym_COMMA] = ACTIONS(4328),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_RBRACE] = ACTIONS(4330),
    [anon_sym_LBRACK] = ACTIONS(4185),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [916] = {
    [sym_expression_statement] = STATE(2681),
    [sym_expression] = STATE(4399),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(7876),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_type_requirement] = STATE(914),
    [sym_compound_requirement] = STATE(914),
    [sym__requirement] = STATE(914),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_requirement_seq_repeat1] = STATE(914),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(4169),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(4171),
    [anon_sym_RBRACE] = ACTIONS(4332),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_typename] = ACTIONS(4175),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [917] = {
    [sym_expression_statement] = STATE(2681),
    [sym_expression] = STATE(4399),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(7876),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_type_requirement] = STATE(914),
    [sym_compound_requirement] = STATE(914),
    [sym__requirement] = STATE(914),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_requirement_seq_repeat1] = STATE(914),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(4169),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(4171),
    [anon_sym_RBRACE] = ACTIONS(4334),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_typename] = ACTIONS(4175),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [918] = {
    [sym_expression_statement] = STATE(2681),
    [sym_expression] = STATE(4399),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(7876),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_type_requirement] = STATE(917),
    [sym_compound_requirement] = STATE(917),
    [sym__requirement] = STATE(917),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_requirement_seq_repeat1] = STATE(917),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(4169),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(4171),
    [anon_sym_RBRACE] = ACTIONS(4336),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_typename] = ACTIONS(4175),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [919] = {
    [sym_expression_statement] = STATE(2681),
    [sym_expression] = STATE(4399),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(7876),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_type_requirement] = STATE(905),
    [sym_compound_requirement] = STATE(905),
    [sym__requirement] = STATE(905),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_requirement_seq_repeat1] = STATE(905),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(4169),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(4171),
    [anon_sym_RBRACE] = ACTIONS(4338),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_typename] = ACTIONS(4175),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [920] = {
    [sym_expression_statement] = STATE(2681),
    [sym_expression] = STATE(4399),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(7876),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_type_requirement] = STATE(891),
    [sym_compound_requirement] = STATE(891),
    [sym__requirement] = STATE(891),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_requirement_seq_repeat1] = STATE(891),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(4169),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(4171),
    [anon_sym_RBRACE] = ACTIONS(4340),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_typename] = ACTIONS(4175),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [921] = {
    [sym_string_literal] = STATE(2570),
    [sym_template_argument_list] = STATE(1623),
    [sym_raw_string_literal] = STATE(2570),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2551),
    [sym_identifier] = ACTIONS(4033),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4035),
    [anon_sym_COMMA] = ACTIONS(4035),
    [anon_sym_LPAREN2] = ACTIONS(4048),
    [anon_sym_TILDE] = ACTIONS(4041),
    [anon_sym_DASH] = ACTIONS(4043),
    [anon_sym_PLUS] = ACTIONS(4043),
    [anon_sym_STAR] = ACTIONS(4045),
    [anon_sym_SLASH] = ACTIONS(4043),
    [anon_sym_PERCENT] = ACTIONS(4043),
    [anon_sym_PIPE_PIPE] = ACTIONS(4035),
    [anon_sym_AMP_AMP] = ACTIONS(4048),
    [anon_sym_PIPE] = ACTIONS(4043),
    [anon_sym_CARET] = ACTIONS(4043),
    [anon_sym_AMP] = ACTIONS(4045),
    [anon_sym_EQ_EQ] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4043),
    [anon_sym_GT_EQ] = ACTIONS(4035),
    [anon_sym_LT_EQ] = ACTIONS(4043),
    [anon_sym_LT] = ACTIONS(4051),
    [anon_sym_LT_LT] = ACTIONS(4043),
    [anon_sym_GT_GT] = ACTIONS(4043),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym___extension__] = ACTIONS(4033),
    [anon_sym_virtual] = ACTIONS(4033),
    [anon_sym_extern] = ACTIONS(4033),
    [anon_sym___attribute__] = ACTIONS(4033),
    [anon_sym___attribute] = ACTIONS(4033),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym___declspec] = ACTIONS(4033),
    [anon_sym___based] = ACTIONS(4033),
    [anon_sym_LBRACE] = ACTIONS(4059),
    [anon_sym_signed] = ACTIONS(4061),
    [anon_sym_unsigned] = ACTIONS(4061),
    [anon_sym_long] = ACTIONS(4061),
    [anon_sym_short] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(4045),
    [anon_sym_static] = ACTIONS(4033),
    [anon_sym_EQ] = ACTIONS(4067),
    [anon_sym_register] = ACTIONS(4033),
    [anon_sym_inline] = ACTIONS(4033),
    [anon_sym___inline] = ACTIONS(4033),
    [anon_sym___inline__] = ACTIONS(4033),
    [anon_sym___forceinline] = ACTIONS(4033),
    [anon_sym_thread_local] = ACTIONS(4033),
    [anon_sym___thread] = ACTIONS(4033),
    [anon_sym_const] = ACTIONS(4033),
    [anon_sym_constexpr] = ACTIONS(4033),
    [anon_sym_volatile] = ACTIONS(4033),
    [anon_sym_restrict] = ACTIONS(4033),
    [anon_sym___restrict__] = ACTIONS(4033),
    [anon_sym__Atomic] = ACTIONS(4033),
    [anon_sym__Noreturn] = ACTIONS(4033),
    [anon_sym_noreturn] = ACTIONS(4033),
    [anon_sym__Nonnull] = ACTIONS(4033),
    [anon_sym_mutable] = ACTIONS(4033),
    [anon_sym_constinit] = ACTIONS(4033),
    [anon_sym_consteval] = ACTIONS(4033),
    [anon_sym_alignas] = ACTIONS(4033),
    [anon_sym__Alignas] = ACTIONS(4033),
    [anon_sym_COLON] = ACTIONS(4342),
    [anon_sym_QMARK] = ACTIONS(4035),
    [anon_sym_STAR_EQ] = ACTIONS(4071),
    [anon_sym_SLASH_EQ] = ACTIONS(4071),
    [anon_sym_PERCENT_EQ] = ACTIONS(4071),
    [anon_sym_PLUS_EQ] = ACTIONS(4071),
    [anon_sym_DASH_EQ] = ACTIONS(4071),
    [anon_sym_LT_LT_EQ] = ACTIONS(4071),
    [anon_sym_GT_GT_EQ] = ACTIONS(4071),
    [anon_sym_AMP_EQ] = ACTIONS(4071),
    [anon_sym_CARET_EQ] = ACTIONS(4071),
    [anon_sym_PIPE_EQ] = ACTIONS(4071),
    [anon_sym_and_eq] = ACTIONS(4067),
    [anon_sym_or_eq] = ACTIONS(4067),
    [anon_sym_xor_eq] = ACTIONS(4067),
    [anon_sym_LT_EQ_GT] = ACTIONS(4035),
    [anon_sym_or] = ACTIONS(4043),
    [anon_sym_and] = ACTIONS(4043),
    [anon_sym_bitor] = ACTIONS(4043),
    [anon_sym_xor] = ACTIONS(4043),
    [anon_sym_bitand] = ACTIONS(4043),
    [anon_sym_not_eq] = ACTIONS(4043),
    [anon_sym_DASH_DASH] = ACTIONS(4035),
    [anon_sym_PLUS_PLUS] = ACTIONS(4035),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_DOT_STAR] = ACTIONS(4035),
    [anon_sym_DASH_GT] = ACTIONS(4035),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4033),
    [anon_sym_decltype] = ACTIONS(4033),
    [anon_sym_template] = ACTIONS(4033),
    [anon_sym_operator] = ACTIONS(4033),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
  },
  [922] = {
    [sym_string_literal] = STATE(2570),
    [sym_template_argument_list] = STATE(1623),
    [sym_raw_string_literal] = STATE(2570),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2551),
    [sym_identifier] = ACTIONS(4033),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4035),
    [anon_sym_COMMA] = ACTIONS(4035),
    [anon_sym_LPAREN2] = ACTIONS(4048),
    [anon_sym_TILDE] = ACTIONS(4041),
    [anon_sym_DASH] = ACTIONS(4043),
    [anon_sym_PLUS] = ACTIONS(4043),
    [anon_sym_STAR] = ACTIONS(4045),
    [anon_sym_SLASH] = ACTIONS(4043),
    [anon_sym_PERCENT] = ACTIONS(4043),
    [anon_sym_PIPE_PIPE] = ACTIONS(4035),
    [anon_sym_AMP_AMP] = ACTIONS(4048),
    [anon_sym_PIPE] = ACTIONS(4043),
    [anon_sym_CARET] = ACTIONS(4043),
    [anon_sym_AMP] = ACTIONS(4045),
    [anon_sym_EQ_EQ] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4043),
    [anon_sym_GT_EQ] = ACTIONS(4035),
    [anon_sym_LT_EQ] = ACTIONS(4043),
    [anon_sym_LT] = ACTIONS(4051),
    [anon_sym_LT_LT] = ACTIONS(4043),
    [anon_sym_GT_GT] = ACTIONS(4043),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym___extension__] = ACTIONS(4033),
    [anon_sym_virtual] = ACTIONS(4033),
    [anon_sym_extern] = ACTIONS(4033),
    [anon_sym___attribute__] = ACTIONS(4033),
    [anon_sym___attribute] = ACTIONS(4033),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym___declspec] = ACTIONS(4033),
    [anon_sym___based] = ACTIONS(4033),
    [anon_sym_LBRACE] = ACTIONS(4059),
    [anon_sym_signed] = ACTIONS(4061),
    [anon_sym_unsigned] = ACTIONS(4061),
    [anon_sym_long] = ACTIONS(4061),
    [anon_sym_short] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(4045),
    [anon_sym_static] = ACTIONS(4033),
    [anon_sym_EQ] = ACTIONS(4067),
    [anon_sym_register] = ACTIONS(4033),
    [anon_sym_inline] = ACTIONS(4033),
    [anon_sym___inline] = ACTIONS(4033),
    [anon_sym___inline__] = ACTIONS(4033),
    [anon_sym___forceinline] = ACTIONS(4033),
    [anon_sym_thread_local] = ACTIONS(4033),
    [anon_sym___thread] = ACTIONS(4033),
    [anon_sym_const] = ACTIONS(4033),
    [anon_sym_constexpr] = ACTIONS(4033),
    [anon_sym_volatile] = ACTIONS(4033),
    [anon_sym_restrict] = ACTIONS(4033),
    [anon_sym___restrict__] = ACTIONS(4033),
    [anon_sym__Atomic] = ACTIONS(4033),
    [anon_sym__Noreturn] = ACTIONS(4033),
    [anon_sym_noreturn] = ACTIONS(4033),
    [anon_sym__Nonnull] = ACTIONS(4033),
    [anon_sym_mutable] = ACTIONS(4033),
    [anon_sym_constinit] = ACTIONS(4033),
    [anon_sym_consteval] = ACTIONS(4033),
    [anon_sym_alignas] = ACTIONS(4033),
    [anon_sym__Alignas] = ACTIONS(4033),
    [anon_sym_COLON] = ACTIONS(4075),
    [anon_sym_QMARK] = ACTIONS(4035),
    [anon_sym_STAR_EQ] = ACTIONS(4071),
    [anon_sym_SLASH_EQ] = ACTIONS(4071),
    [anon_sym_PERCENT_EQ] = ACTIONS(4071),
    [anon_sym_PLUS_EQ] = ACTIONS(4071),
    [anon_sym_DASH_EQ] = ACTIONS(4071),
    [anon_sym_LT_LT_EQ] = ACTIONS(4071),
    [anon_sym_GT_GT_EQ] = ACTIONS(4071),
    [anon_sym_AMP_EQ] = ACTIONS(4071),
    [anon_sym_CARET_EQ] = ACTIONS(4071),
    [anon_sym_PIPE_EQ] = ACTIONS(4071),
    [anon_sym_and_eq] = ACTIONS(4067),
    [anon_sym_or_eq] = ACTIONS(4067),
    [anon_sym_xor_eq] = ACTIONS(4067),
    [anon_sym_LT_EQ_GT] = ACTIONS(4035),
    [anon_sym_or] = ACTIONS(4043),
    [anon_sym_and] = ACTIONS(4043),
    [anon_sym_bitor] = ACTIONS(4043),
    [anon_sym_xor] = ACTIONS(4043),
    [anon_sym_bitand] = ACTIONS(4043),
    [anon_sym_not_eq] = ACTIONS(4043),
    [anon_sym_DASH_DASH] = ACTIONS(4035),
    [anon_sym_PLUS_PLUS] = ACTIONS(4035),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_DOT_STAR] = ACTIONS(4035),
    [anon_sym_DASH_GT] = ACTIONS(4035),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4033),
    [anon_sym_decltype] = ACTIONS(4033),
    [anon_sym_template] = ACTIONS(4033),
    [anon_sym_operator] = ACTIONS(4033),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
  },
  [923] = {
    [sym_expression] = STATE(4475),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(7523),
    [sym_initializer_pair] = STATE(7523),
    [sym_subscript_designator] = STATE(6635),
    [sym_subscript_range_designator] = STATE(6635),
    [sym_field_designator] = STATE(6635),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_initializer_pair_repeat1] = STATE(6635),
    [sym_identifier] = ACTIONS(4179),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_RBRACE] = ACTIONS(4344),
    [anon_sym_LBRACK] = ACTIONS(4185),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [924] = {
    [sym_expression] = STATE(4475),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(7523),
    [sym_initializer_pair] = STATE(7523),
    [sym_subscript_designator] = STATE(6635),
    [sym_subscript_range_designator] = STATE(6635),
    [sym_field_designator] = STATE(6635),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_initializer_pair_repeat1] = STATE(6635),
    [sym_identifier] = ACTIONS(4179),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_RBRACE] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4185),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [925] = {
    [sym_expression] = STATE(4475),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(7523),
    [sym_initializer_pair] = STATE(7523),
    [sym_subscript_designator] = STATE(6635),
    [sym_subscript_range_designator] = STATE(6635),
    [sym_field_designator] = STATE(6635),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_initializer_pair_repeat1] = STATE(6635),
    [sym_identifier] = ACTIONS(4179),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_RBRACE] = ACTIONS(4348),
    [anon_sym_LBRACK] = ACTIONS(4185),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [926] = {
    [sym_expression] = STATE(4475),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(7523),
    [sym_initializer_pair] = STATE(7523),
    [sym_subscript_designator] = STATE(6635),
    [sym_subscript_range_designator] = STATE(6635),
    [sym_field_designator] = STATE(6635),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_initializer_pair_repeat1] = STATE(6635),
    [sym_identifier] = ACTIONS(4179),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_RBRACE] = ACTIONS(4350),
    [anon_sym_LBRACK] = ACTIONS(4185),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [927] = {
    [sym_expression] = STATE(4475),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(7523),
    [sym_initializer_pair] = STATE(7523),
    [sym_subscript_designator] = STATE(6635),
    [sym_subscript_range_designator] = STATE(6635),
    [sym_field_designator] = STATE(6635),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_initializer_pair_repeat1] = STATE(6635),
    [sym_identifier] = ACTIONS(4179),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_RBRACE] = ACTIONS(4201),
    [anon_sym_LBRACK] = ACTIONS(4185),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [928] = {
    [sym_expression] = STATE(4475),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(7523),
    [sym_initializer_pair] = STATE(7523),
    [sym_subscript_designator] = STATE(6635),
    [sym_subscript_range_designator] = STATE(6635),
    [sym_field_designator] = STATE(6635),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_initializer_pair_repeat1] = STATE(6635),
    [sym_identifier] = ACTIONS(4179),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_RBRACE] = ACTIONS(4352),
    [anon_sym_LBRACK] = ACTIONS(4185),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [929] = {
    [sym_expression] = STATE(4475),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(7523),
    [sym_initializer_pair] = STATE(7523),
    [sym_subscript_designator] = STATE(6635),
    [sym_subscript_range_designator] = STATE(6635),
    [sym_field_designator] = STATE(6635),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_initializer_pair_repeat1] = STATE(6635),
    [sym_identifier] = ACTIONS(4179),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_RBRACE] = ACTIONS(4354),
    [anon_sym_LBRACK] = ACTIONS(4185),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [930] = {
    [sym_expression] = STATE(4475),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(7523),
    [sym_initializer_pair] = STATE(7523),
    [sym_subscript_designator] = STATE(6635),
    [sym_subscript_range_designator] = STATE(6635),
    [sym_field_designator] = STATE(6635),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_initializer_pair_repeat1] = STATE(6635),
    [sym_identifier] = ACTIONS(4179),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_RBRACE] = ACTIONS(4356),
    [anon_sym_LBRACK] = ACTIONS(4185),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [931] = {
    [sym_expression] = STATE(4475),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(7523),
    [sym_initializer_pair] = STATE(7523),
    [sym_subscript_designator] = STATE(6635),
    [sym_subscript_range_designator] = STATE(6635),
    [sym_field_designator] = STATE(6635),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_initializer_pair_repeat1] = STATE(6635),
    [sym_identifier] = ACTIONS(4179),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_RBRACE] = ACTIONS(4358),
    [anon_sym_LBRACK] = ACTIONS(4185),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [932] = {
    [sym_expression] = STATE(4475),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(7523),
    [sym_initializer_pair] = STATE(7523),
    [sym_subscript_designator] = STATE(6635),
    [sym_subscript_range_designator] = STATE(6635),
    [sym_field_designator] = STATE(6635),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_initializer_pair_repeat1] = STATE(6635),
    [sym_identifier] = ACTIONS(4179),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_RBRACE] = ACTIONS(4360),
    [anon_sym_LBRACK] = ACTIONS(4185),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [933] = {
    [sym_expression] = STATE(4475),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(7523),
    [sym_initializer_pair] = STATE(7523),
    [sym_subscript_designator] = STATE(6635),
    [sym_subscript_range_designator] = STATE(6635),
    [sym_field_designator] = STATE(6635),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_initializer_pair_repeat1] = STATE(6635),
    [sym_identifier] = ACTIONS(4179),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_RBRACE] = ACTIONS(4362),
    [anon_sym_LBRACK] = ACTIONS(4185),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [934] = {
    [sym_string_literal] = STATE(2570),
    [sym_template_argument_list] = STATE(1631),
    [sym_raw_string_literal] = STATE(2570),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2551),
    [sym_identifier] = ACTIONS(4033),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4048),
    [anon_sym_COMMA] = ACTIONS(4048),
    [anon_sym_RPAREN] = ACTIONS(4048),
    [anon_sym_LPAREN2] = ACTIONS(4048),
    [anon_sym_TILDE] = ACTIONS(4041),
    [anon_sym_DASH] = ACTIONS(4043),
    [anon_sym_PLUS] = ACTIONS(4043),
    [anon_sym_STAR] = ACTIONS(4045),
    [anon_sym_SLASH] = ACTIONS(4043),
    [anon_sym_PERCENT] = ACTIONS(4043),
    [anon_sym_PIPE_PIPE] = ACTIONS(4035),
    [anon_sym_AMP_AMP] = ACTIONS(4048),
    [anon_sym_PIPE] = ACTIONS(4043),
    [anon_sym_CARET] = ACTIONS(4043),
    [anon_sym_AMP] = ACTIONS(4045),
    [anon_sym_EQ_EQ] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4043),
    [anon_sym_GT_EQ] = ACTIONS(4035),
    [anon_sym_LT_EQ] = ACTIONS(4043),
    [anon_sym_LT] = ACTIONS(4051),
    [anon_sym_LT_LT] = ACTIONS(4043),
    [anon_sym_GT_GT] = ACTIONS(4043),
    [anon_sym___extension__] = ACTIONS(4033),
    [anon_sym_virtual] = ACTIONS(4033),
    [anon_sym_extern] = ACTIONS(4033),
    [anon_sym___attribute__] = ACTIONS(4033),
    [anon_sym___attribute] = ACTIONS(4033),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4041),
    [anon_sym___declspec] = ACTIONS(4033),
    [anon_sym___based] = ACTIONS(4033),
    [anon_sym_LBRACE] = ACTIONS(4059),
    [anon_sym_signed] = ACTIONS(4061),
    [anon_sym_unsigned] = ACTIONS(4061),
    [anon_sym_long] = ACTIONS(4061),
    [anon_sym_short] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(4045),
    [anon_sym_static] = ACTIONS(4033),
    [anon_sym_EQ] = ACTIONS(4033),
    [anon_sym_register] = ACTIONS(4033),
    [anon_sym_inline] = ACTIONS(4033),
    [anon_sym___inline] = ACTIONS(4033),
    [anon_sym___inline__] = ACTIONS(4033),
    [anon_sym___forceinline] = ACTIONS(4033),
    [anon_sym_thread_local] = ACTIONS(4033),
    [anon_sym___thread] = ACTIONS(4033),
    [anon_sym_const] = ACTIONS(4033),
    [anon_sym_constexpr] = ACTIONS(4033),
    [anon_sym_volatile] = ACTIONS(4033),
    [anon_sym_restrict] = ACTIONS(4033),
    [anon_sym___restrict__] = ACTIONS(4033),
    [anon_sym__Atomic] = ACTIONS(4033),
    [anon_sym__Noreturn] = ACTIONS(4033),
    [anon_sym_noreturn] = ACTIONS(4033),
    [anon_sym__Nonnull] = ACTIONS(4033),
    [anon_sym_mutable] = ACTIONS(4033),
    [anon_sym_constinit] = ACTIONS(4033),
    [anon_sym_consteval] = ACTIONS(4033),
    [anon_sym_alignas] = ACTIONS(4033),
    [anon_sym__Alignas] = ACTIONS(4033),
    [anon_sym_QMARK] = ACTIONS(4035),
    [anon_sym_STAR_EQ] = ACTIONS(4071),
    [anon_sym_SLASH_EQ] = ACTIONS(4071),
    [anon_sym_PERCENT_EQ] = ACTIONS(4071),
    [anon_sym_PLUS_EQ] = ACTIONS(4071),
    [anon_sym_DASH_EQ] = ACTIONS(4071),
    [anon_sym_LT_LT_EQ] = ACTIONS(4071),
    [anon_sym_GT_GT_EQ] = ACTIONS(4071),
    [anon_sym_AMP_EQ] = ACTIONS(4071),
    [anon_sym_CARET_EQ] = ACTIONS(4071),
    [anon_sym_PIPE_EQ] = ACTIONS(4071),
    [anon_sym_and_eq] = ACTIONS(4067),
    [anon_sym_or_eq] = ACTIONS(4067),
    [anon_sym_xor_eq] = ACTIONS(4067),
    [anon_sym_LT_EQ_GT] = ACTIONS(4035),
    [anon_sym_or] = ACTIONS(4043),
    [anon_sym_and] = ACTIONS(4043),
    [anon_sym_bitor] = ACTIONS(4043),
    [anon_sym_xor] = ACTIONS(4043),
    [anon_sym_bitand] = ACTIONS(4043),
    [anon_sym_not_eq] = ACTIONS(4043),
    [anon_sym_DASH_DASH] = ACTIONS(4035),
    [anon_sym_PLUS_PLUS] = ACTIONS(4035),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_DOT_STAR] = ACTIONS(4035),
    [anon_sym_DASH_GT] = ACTIONS(4035),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4033),
    [anon_sym_decltype] = ACTIONS(4033),
    [anon_sym_template] = ACTIONS(4033),
    [anon_sym_operator] = ACTIONS(4033),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
  },
  [935] = {
    [sym_expression] = STATE(4475),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(7523),
    [sym_initializer_pair] = STATE(7523),
    [sym_subscript_designator] = STATE(6635),
    [sym_subscript_range_designator] = STATE(6635),
    [sym_field_designator] = STATE(6635),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_initializer_pair_repeat1] = STATE(6635),
    [sym_identifier] = ACTIONS(4179),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_RBRACE] = ACTIONS(4364),
    [anon_sym_LBRACK] = ACTIONS(4185),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [936] = {
    [sym_expression] = STATE(4538),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_lambda_default_capture] = STATE(7453),
    [sym__lambda_capture_identifier] = STATE(7112),
    [sym_lambda_capture_initializer] = STATE(7112),
    [sym__lambda_capture] = STATE(7112),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_identifier_parameter_pack_expansion] = STATE(7112),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3555),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [sym_identifier] = ACTIONS(4366),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4368),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(4370),
    [anon_sym_AMP] = ACTIONS(4372),
    [anon_sym___extension__] = ACTIONS(3740),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_RBRACK] = ACTIONS(4374),
    [anon_sym_EQ] = ACTIONS(4376),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(4378),
  },
  [937] = {
    [sym_expression] = STATE(4475),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(7523),
    [sym_initializer_pair] = STATE(7523),
    [sym_subscript_designator] = STATE(6635),
    [sym_subscript_range_designator] = STATE(6635),
    [sym_field_designator] = STATE(6635),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [aux_sym_initializer_pair_repeat1] = STATE(6635),
    [sym_identifier] = ACTIONS(4179),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(4185),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(217),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [938] = {
    [sym_expression] = STATE(4538),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_lambda_default_capture] = STATE(7453),
    [sym__lambda_capture_identifier] = STATE(7112),
    [sym_lambda_capture_initializer] = STATE(7112),
    [sym__lambda_capture] = STATE(7112),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_identifier_parameter_pack_expansion] = STATE(7112),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3555),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [sym_identifier] = ACTIONS(4380),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4368),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(4370),
    [anon_sym_AMP] = ACTIONS(4372),
    [anon_sym___extension__] = ACTIONS(3740),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_RBRACK] = ACTIONS(4374),
    [anon_sym_EQ] = ACTIONS(4376),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(4378),
  },
  [939] = {
    [sym_expression] = STATE(4412),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8171),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(8171),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(4382),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [940] = {
    [sym_expression] = STATE(4402),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(7995),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(7995),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(4384),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [941] = {
    [sym_compound_statement] = STATE(7166),
    [sym_expression] = STATE(4293),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(7166),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_RPAREN] = ACTIONS(4386),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(1905),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [942] = {
    [sym_expression] = STATE(4128),
    [sym__string] = STATE(4345),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3286),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3286),
    [sym_call_expression] = STATE(3286),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3286),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3286),
    [sym_initializer_list] = STATE(6699),
    [sym_char_literal] = STATE(4345),
    [sym_concatenated_string] = STATE(4345),
    [sym_string_literal] = STATE(3370),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3370),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3286),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3286),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_LPAREN2] = ACTIONS(4388),
    [anon_sym_BANG] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3496),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym___extension__] = ACTIONS(3500),
    [anon_sym_COLON_COLON] = ACTIONS(3502),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_default] = ACTIONS(4392),
    [anon_sym_not] = ACTIONS(3496),
    [anon_sym_compl] = ACTIONS(3496),
    [anon_sym_DASH_DASH] = ACTIONS(4394),
    [anon_sym_PLUS_PLUS] = ACTIONS(4394),
    [anon_sym_sizeof] = ACTIONS(3504),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3506),
    [anon_sym_L_SQUOTE] = ACTIONS(3508),
    [anon_sym_u_SQUOTE] = ACTIONS(3508),
    [anon_sym_U_SQUOTE] = ACTIONS(3508),
    [anon_sym_u8_SQUOTE] = ACTIONS(3508),
    [anon_sym_SQUOTE] = ACTIONS(3508),
    [anon_sym_L_DQUOTE] = ACTIONS(3510),
    [anon_sym_u_DQUOTE] = ACTIONS(3510),
    [anon_sym_U_DQUOTE] = ACTIONS(3510),
    [anon_sym_u8_DQUOTE] = ACTIONS(3510),
    [anon_sym_DQUOTE] = ACTIONS(3510),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(4396),
    [aux_sym_pure_virtual_clause_token1] = ACTIONS(4398),
    [anon_sym_R_DQUOTE] = ACTIONS(3514),
    [anon_sym_LR_DQUOTE] = ACTIONS(3514),
    [anon_sym_uR_DQUOTE] = ACTIONS(3514),
    [anon_sym_UR_DQUOTE] = ACTIONS(3514),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3514),
    [anon_sym_co_await] = ACTIONS(3516),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [943] = {
    [sym_expression] = STATE(3204),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym__unary_left_fold] = STATE(8348),
    [sym__unary_right_fold] = STATE(8278),
    [sym__binary_fold] = STATE(8484),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [944] = {
    [sym_compound_statement] = STATE(7293),
    [sym_expression] = STATE(4301),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(7293),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_RPAREN] = ACTIONS(4400),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(1905),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [945] = {
    [sym_compound_statement] = STATE(7407),
    [sym_expression] = STATE(4309),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(7407),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_RPAREN] = ACTIONS(4402),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(1905),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [946] = {
    [sym_expression] = STATE(4388),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8584),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(8584),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(4404),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [947] = {
    [sym_expression] = STATE(4398),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(7864),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(7864),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(4406),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [948] = {
    [sym_compound_statement] = STATE(7263),
    [sym_expression] = STATE(4341),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(7263),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_RPAREN] = ACTIONS(4408),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(1905),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [949] = {
    [sym_expression] = STATE(4374),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8514),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(8514),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(4410),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [950] = {
    [sym_compound_statement] = STATE(7028),
    [sym_expression] = STATE(4314),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(7028),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_RPAREN] = ACTIONS(4412),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(1905),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [951] = {
    [sym_compound_statement] = STATE(7032),
    [sym_expression] = STATE(4280),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(7032),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_RPAREN] = ACTIONS(4414),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(1905),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [952] = {
    [sym_compound_statement] = STATE(7068),
    [sym_expression] = STATE(4362),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(7068),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_RPAREN] = ACTIONS(4416),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(1905),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [953] = {
    [sym_expression] = STATE(2342),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_identifier_parameter_pack_expansion] = STATE(7439),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3629),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(4418),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4420),
    [anon_sym_COMMA] = ACTIONS(4422),
    [anon_sym_LPAREN2] = ACTIONS(4424),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_RBRACK] = ACTIONS(4422),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1965),
    [anon_sym_compl] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_sizeof] = ACTIONS(1973),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [954] = {
    [sym_expression] = STATE(3198),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym__unary_left_fold] = STATE(8049),
    [sym__unary_right_fold] = STATE(8050),
    [sym__binary_fold] = STATE(8056),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [955] = {
    [sym_expression] = STATE(4146),
    [sym__string] = STATE(4345),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3286),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3286),
    [sym_call_expression] = STATE(3286),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3286),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3286),
    [sym_initializer_list] = STATE(6678),
    [sym_char_literal] = STATE(4345),
    [sym_concatenated_string] = STATE(4345),
    [sym_string_literal] = STATE(3370),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3370),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3286),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3286),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_LPAREN2] = ACTIONS(4388),
    [anon_sym_BANG] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3496),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym___extension__] = ACTIONS(3500),
    [anon_sym_COLON_COLON] = ACTIONS(3502),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_default] = ACTIONS(4426),
    [anon_sym_not] = ACTIONS(3496),
    [anon_sym_compl] = ACTIONS(3496),
    [anon_sym_DASH_DASH] = ACTIONS(4394),
    [anon_sym_PLUS_PLUS] = ACTIONS(4394),
    [anon_sym_sizeof] = ACTIONS(3504),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3506),
    [anon_sym_L_SQUOTE] = ACTIONS(3508),
    [anon_sym_u_SQUOTE] = ACTIONS(3508),
    [anon_sym_U_SQUOTE] = ACTIONS(3508),
    [anon_sym_u8_SQUOTE] = ACTIONS(3508),
    [anon_sym_SQUOTE] = ACTIONS(3508),
    [anon_sym_L_DQUOTE] = ACTIONS(3510),
    [anon_sym_u_DQUOTE] = ACTIONS(3510),
    [anon_sym_U_DQUOTE] = ACTIONS(3510),
    [anon_sym_u8_DQUOTE] = ACTIONS(3510),
    [anon_sym_DQUOTE] = ACTIONS(3510),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(4428),
    [aux_sym_pure_virtual_clause_token1] = ACTIONS(4430),
    [anon_sym_R_DQUOTE] = ACTIONS(3514),
    [anon_sym_LR_DQUOTE] = ACTIONS(3514),
    [anon_sym_uR_DQUOTE] = ACTIONS(3514),
    [anon_sym_UR_DQUOTE] = ACTIONS(3514),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3514),
    [anon_sym_co_await] = ACTIONS(3516),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [956] = {
    [sym_expression] = STATE(3193),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym__unary_left_fold] = STATE(8566),
    [sym__unary_right_fold] = STATE(8127),
    [sym__binary_fold] = STATE(8332),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [957] = {
    [sym_expression] = STATE(4151),
    [sym__string] = STATE(4345),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3286),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3286),
    [sym_call_expression] = STATE(3286),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3286),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3286),
    [sym_initializer_list] = STATE(6713),
    [sym_char_literal] = STATE(4345),
    [sym_concatenated_string] = STATE(4345),
    [sym_string_literal] = STATE(3370),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3370),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3286),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3286),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_LPAREN2] = ACTIONS(4388),
    [anon_sym_BANG] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3496),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym___extension__] = ACTIONS(3500),
    [anon_sym_COLON_COLON] = ACTIONS(3502),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_default] = ACTIONS(4432),
    [anon_sym_not] = ACTIONS(3496),
    [anon_sym_compl] = ACTIONS(3496),
    [anon_sym_DASH_DASH] = ACTIONS(4394),
    [anon_sym_PLUS_PLUS] = ACTIONS(4394),
    [anon_sym_sizeof] = ACTIONS(3504),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3506),
    [anon_sym_L_SQUOTE] = ACTIONS(3508),
    [anon_sym_u_SQUOTE] = ACTIONS(3508),
    [anon_sym_U_SQUOTE] = ACTIONS(3508),
    [anon_sym_u8_SQUOTE] = ACTIONS(3508),
    [anon_sym_SQUOTE] = ACTIONS(3508),
    [anon_sym_L_DQUOTE] = ACTIONS(3510),
    [anon_sym_u_DQUOTE] = ACTIONS(3510),
    [anon_sym_U_DQUOTE] = ACTIONS(3510),
    [anon_sym_u8_DQUOTE] = ACTIONS(3510),
    [anon_sym_DQUOTE] = ACTIONS(3510),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(4434),
    [aux_sym_pure_virtual_clause_token1] = ACTIONS(4436),
    [anon_sym_R_DQUOTE] = ACTIONS(3514),
    [anon_sym_LR_DQUOTE] = ACTIONS(3514),
    [anon_sym_uR_DQUOTE] = ACTIONS(3514),
    [anon_sym_UR_DQUOTE] = ACTIONS(3514),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3514),
    [anon_sym_co_await] = ACTIONS(3516),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [958] = {
    [sym_compound_statement] = STATE(8507),
    [sym_expression] = STATE(3211),
    [sym__string] = STATE(2890),
    [sym_comma_expression] = STATE(8507),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym__assignment_expression_lhs] = STATE(8151),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4424),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1971),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1965),
    [anon_sym_compl] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_sizeof] = ACTIONS(1973),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [959] = {
    [sym_expression] = STATE(3302),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym__unary_left_fold] = STATE(8079),
    [sym__unary_right_fold] = STATE(8083),
    [sym__binary_fold] = STATE(8110),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [960] = {
    [sym_expression] = STATE(3229),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym__unary_left_fold] = STATE(7964),
    [sym__unary_right_fold] = STATE(7969),
    [sym__binary_fold] = STATE(7971),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [961] = {
    [sym_expression] = STATE(3239),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym__unary_left_fold] = STATE(7788),
    [sym__unary_right_fold] = STATE(7790),
    [sym__binary_fold] = STATE(7792),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [962] = {
    [sym_expression] = STATE(3238),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym__unary_left_fold] = STATE(8039),
    [sym__unary_right_fold] = STATE(8043),
    [sym__binary_fold] = STATE(8046),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [963] = {
    [sym_expression] = STATE(3219),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym__unary_left_fold] = STATE(8004),
    [sym__unary_right_fold] = STATE(8005),
    [sym__binary_fold] = STATE(8006),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [964] = {
    [sym_expression] = STATE(3305),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym__unary_left_fold] = STATE(8378),
    [sym__unary_right_fold] = STATE(8382),
    [sym__binary_fold] = STATE(8385),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1761),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [965] = {
    [sym_expression] = STATE(4711),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(8135),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4438),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [966] = {
    [sym_expression] = STATE(2896),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4441),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(4441),
    [anon_sym_AMP_AMP] = ACTIONS(4441),
    [anon_sym_AMP] = ACTIONS(4443),
    [anon_sym_LT] = ACTIONS(4441),
    [anon_sym___extension__] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1971),
    [anon_sym_LBRACE] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(4441),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1965),
    [anon_sym_compl] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_sizeof] = ACTIONS(1973),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [967] = {
    [sym_expression] = STATE(4251),
    [sym__string] = STATE(4345),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3286),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3286),
    [sym_call_expression] = STATE(3286),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3286),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3286),
    [sym_char_literal] = STATE(4345),
    [sym_concatenated_string] = STATE(4345),
    [sym_string_literal] = STATE(3370),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3370),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3286),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3286),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_LPAREN2] = ACTIONS(4441),
    [anon_sym_BANG] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3496),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_STAR] = ACTIONS(4441),
    [anon_sym_AMP_AMP] = ACTIONS(4441),
    [anon_sym_AMP] = ACTIONS(4443),
    [anon_sym_LT] = ACTIONS(4441),
    [anon_sym___extension__] = ACTIONS(3500),
    [anon_sym_COLON_COLON] = ACTIONS(3502),
    [anon_sym_LBRACE] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(4441),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3496),
    [anon_sym_compl] = ACTIONS(3496),
    [anon_sym_DASH_DASH] = ACTIONS(4394),
    [anon_sym_PLUS_PLUS] = ACTIONS(4394),
    [anon_sym_sizeof] = ACTIONS(3504),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3506),
    [anon_sym_L_SQUOTE] = ACTIONS(3508),
    [anon_sym_u_SQUOTE] = ACTIONS(3508),
    [anon_sym_U_SQUOTE] = ACTIONS(3508),
    [anon_sym_u8_SQUOTE] = ACTIONS(3508),
    [anon_sym_SQUOTE] = ACTIONS(3508),
    [anon_sym_L_DQUOTE] = ACTIONS(3510),
    [anon_sym_u_DQUOTE] = ACTIONS(3510),
    [anon_sym_U_DQUOTE] = ACTIONS(3510),
    [anon_sym_u8_DQUOTE] = ACTIONS(3510),
    [anon_sym_DQUOTE] = ACTIONS(3510),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3512),
    [anon_sym_R_DQUOTE] = ACTIONS(3514),
    [anon_sym_LR_DQUOTE] = ACTIONS(3514),
    [anon_sym_uR_DQUOTE] = ACTIONS(3514),
    [anon_sym_UR_DQUOTE] = ACTIONS(3514),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3514),
    [anon_sym_co_await] = ACTIONS(3516),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [968] = {
    [sym_expression] = STATE(4711),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(8135),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4445),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [969] = {
    [sym_expression] = STATE(4711),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(8135),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4448),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [970] = {
    [sym_expression] = STATE(4339),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_initializer_list] = STATE(7218),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3740),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_RBRACK] = ACTIONS(4451),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [971] = {
    [sym_expression] = STATE(4711),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(8135),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4453),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [972] = {
    [sym_expression] = STATE(4711),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(8135),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4456),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [973] = {
    [sym_expression] = STATE(4711),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(8135),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4459),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [974] = {
    [sym_expression] = STATE(4711),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(8135),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4462),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [975] = {
    [sym_expression] = STATE(4255),
    [sym__string] = STATE(4345),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3286),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3286),
    [sym_call_expression] = STATE(3286),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3286),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3286),
    [sym_char_literal] = STATE(4345),
    [sym_concatenated_string] = STATE(4345),
    [sym_string_literal] = STATE(3370),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3370),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3286),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3286),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_LPAREN2] = ACTIONS(4441),
    [anon_sym_BANG] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3496),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_STAR] = ACTIONS(4441),
    [anon_sym_AMP_AMP] = ACTIONS(4441),
    [anon_sym_AMP] = ACTIONS(4443),
    [anon_sym_LT] = ACTIONS(4441),
    [anon_sym___extension__] = ACTIONS(3500),
    [anon_sym_COLON_COLON] = ACTIONS(3502),
    [anon_sym_LBRACE] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(4441),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3496),
    [anon_sym_compl] = ACTIONS(3496),
    [anon_sym_DASH_DASH] = ACTIONS(4394),
    [anon_sym_PLUS_PLUS] = ACTIONS(4394),
    [anon_sym_sizeof] = ACTIONS(3504),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3506),
    [anon_sym_L_SQUOTE] = ACTIONS(3508),
    [anon_sym_u_SQUOTE] = ACTIONS(3508),
    [anon_sym_U_SQUOTE] = ACTIONS(3508),
    [anon_sym_u8_SQUOTE] = ACTIONS(3508),
    [anon_sym_SQUOTE] = ACTIONS(3508),
    [anon_sym_L_DQUOTE] = ACTIONS(3510),
    [anon_sym_u_DQUOTE] = ACTIONS(3510),
    [anon_sym_U_DQUOTE] = ACTIONS(3510),
    [anon_sym_u8_DQUOTE] = ACTIONS(3510),
    [anon_sym_DQUOTE] = ACTIONS(3510),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3512),
    [anon_sym_R_DQUOTE] = ACTIONS(3514),
    [anon_sym_LR_DQUOTE] = ACTIONS(3514),
    [anon_sym_uR_DQUOTE] = ACTIONS(3514),
    [anon_sym_UR_DQUOTE] = ACTIONS(3514),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3514),
    [anon_sym_co_await] = ACTIONS(3516),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [976] = {
    [sym_expression] = STATE(4348),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_initializer_list] = STATE(7353),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3740),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_RBRACK] = ACTIONS(4465),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [977] = {
    [sym_expression] = STATE(4372),
    [sym__string] = STATE(4637),
    [sym_conditional_expression] = STATE(4735),
    [sym_assignment_expression] = STATE(4735),
    [sym_pointer_expression] = STATE(3573),
    [sym_unary_expression] = STATE(4735),
    [sym_binary_expression] = STATE(4735),
    [sym_update_expression] = STATE(4735),
    [sym_cast_expression] = STATE(4735),
    [sym_sizeof_expression] = STATE(4735),
    [sym_alignof_expression] = STATE(4735),
    [sym_offsetof_expression] = STATE(4735),
    [sym_generic_expression] = STATE(4735),
    [sym_subscript_expression] = STATE(3573),
    [sym_call_expression] = STATE(3573),
    [sym_gnu_asm_expression] = STATE(4735),
    [sym_extension_expression] = STATE(4735),
    [sym_field_expression] = STATE(3573),
    [sym_compound_literal_expression] = STATE(4735),
    [sym_parenthesized_expression] = STATE(3573),
    [sym_char_literal] = STATE(4637),
    [sym_concatenated_string] = STATE(4637),
    [sym_string_literal] = STATE(3662),
    [sym_null] = STATE(4735),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7513),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(4735),
    [sym_raw_string_literal] = STATE(3662),
    [sym_co_await_expression] = STATE(4735),
    [sym_new_expression] = STATE(4735),
    [sym_delete_expression] = STATE(4735),
    [sym_requires_clause] = STATE(4735),
    [sym_requires_expression] = STATE(4735),
    [sym_lambda_expression] = STATE(4735),
    [sym_lambda_capture_specifier] = STATE(5854),
    [sym_fold_expression] = STATE(4735),
    [sym_parameter_pack_expansion] = STATE(4735),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3573),
    [sym_qualified_type_identifier] = STATE(7513),
    [sym_user_defined_literal] = STATE(3573),
    [sym_identifier] = ACTIONS(3726),
    [anon_sym_LPAREN2] = ACTIONS(4441),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(4441),
    [anon_sym_AMP_AMP] = ACTIONS(4441),
    [anon_sym_AMP] = ACTIONS(4443),
    [anon_sym_LT] = ACTIONS(4441),
    [anon_sym___extension__] = ACTIONS(3728),
    [anon_sym_COLON_COLON] = ACTIONS(2866),
    [anon_sym_LBRACE] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(4441),
    [sym_primitive_type] = ACTIONS(3732),
    [anon_sym_not] = ACTIONS(2860),
    [anon_sym_compl] = ACTIONS(2860),
    [anon_sym_DASH_DASH] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(2880),
    [anon_sym_sizeof] = ACTIONS(2882),
    [anon_sym___alignof__] = ACTIONS(2884),
    [anon_sym___alignof] = ACTIONS(2884),
    [anon_sym__alignof] = ACTIONS(2884),
    [anon_sym_alignof] = ACTIONS(2884),
    [anon_sym__Alignof] = ACTIONS(2884),
    [anon_sym_offsetof] = ACTIONS(2886),
    [anon_sym__Generic] = ACTIONS(2888),
    [anon_sym_asm] = ACTIONS(2890),
    [anon_sym___asm__] = ACTIONS(2890),
    [anon_sym___asm] = ACTIONS(2890),
    [sym_number_literal] = ACTIONS(2892),
    [anon_sym_L_SQUOTE] = ACTIONS(2894),
    [anon_sym_u_SQUOTE] = ACTIONS(2894),
    [anon_sym_U_SQUOTE] = ACTIONS(2894),
    [anon_sym_u8_SQUOTE] = ACTIONS(2894),
    [anon_sym_SQUOTE] = ACTIONS(2894),
    [anon_sym_L_DQUOTE] = ACTIONS(2896),
    [anon_sym_u_DQUOTE] = ACTIONS(2896),
    [anon_sym_U_DQUOTE] = ACTIONS(2896),
    [anon_sym_u8_DQUOTE] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [anon_sym_NULL] = ACTIONS(2900),
    [anon_sym_nullptr] = ACTIONS(2900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2910),
    [anon_sym_R_DQUOTE] = ACTIONS(2912),
    [anon_sym_LR_DQUOTE] = ACTIONS(2912),
    [anon_sym_uR_DQUOTE] = ACTIONS(2912),
    [anon_sym_UR_DQUOTE] = ACTIONS(2912),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2912),
    [anon_sym_co_await] = ACTIONS(2914),
    [anon_sym_new] = ACTIONS(2916),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2898),
  },
  [978] = {
    [sym_expression] = STATE(3592),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_LPAREN2] = ACTIONS(4441),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(4441),
    [anon_sym_AMP_AMP] = ACTIONS(4441),
    [anon_sym_AMP] = ACTIONS(4443),
    [anon_sym_LT] = ACTIONS(4441),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACE] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(4441),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [979] = {
    [sym_expression] = STATE(4253),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(4441),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(4441),
    [anon_sym_AMP_AMP] = ACTIONS(4441),
    [anon_sym_AMP] = ACTIONS(4443),
    [anon_sym_LT] = ACTIONS(4441),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(4441),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [980] = {
    [sym_expression] = STATE(4711),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(8135),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4467),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [981] = {
    [sym_expression] = STATE(3108),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_LPAREN2] = ACTIONS(4441),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(4441),
    [anon_sym_AMP_AMP] = ACTIONS(4441),
    [anon_sym_AMP] = ACTIONS(4443),
    [anon_sym_LT] = ACTIONS(4441),
    [anon_sym___extension__] = ACTIONS(2029),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(4441),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [982] = {
    [sym_compound_statement] = STATE(7491),
    [sym_expression] = STATE(4470),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(7491),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(1905),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [983] = {
    [sym_expression] = STATE(4379),
    [sym__string] = STATE(4637),
    [sym_conditional_expression] = STATE(4735),
    [sym_assignment_expression] = STATE(4735),
    [sym_pointer_expression] = STATE(3573),
    [sym_unary_expression] = STATE(4735),
    [sym_binary_expression] = STATE(4735),
    [sym_update_expression] = STATE(4735),
    [sym_cast_expression] = STATE(4735),
    [sym_sizeof_expression] = STATE(4735),
    [sym_alignof_expression] = STATE(4735),
    [sym_offsetof_expression] = STATE(4735),
    [sym_generic_expression] = STATE(4735),
    [sym_subscript_expression] = STATE(3573),
    [sym_call_expression] = STATE(3573),
    [sym_gnu_asm_expression] = STATE(4735),
    [sym_extension_expression] = STATE(4735),
    [sym_field_expression] = STATE(3573),
    [sym_compound_literal_expression] = STATE(4735),
    [sym_parenthesized_expression] = STATE(3573),
    [sym_char_literal] = STATE(4637),
    [sym_concatenated_string] = STATE(4637),
    [sym_string_literal] = STATE(3662),
    [sym_null] = STATE(4735),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7513),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(4735),
    [sym_raw_string_literal] = STATE(3662),
    [sym_co_await_expression] = STATE(4735),
    [sym_new_expression] = STATE(4735),
    [sym_delete_expression] = STATE(4735),
    [sym_requires_clause] = STATE(4735),
    [sym_requires_expression] = STATE(4735),
    [sym_lambda_expression] = STATE(4735),
    [sym_lambda_capture_specifier] = STATE(5854),
    [sym_fold_expression] = STATE(4735),
    [sym_parameter_pack_expansion] = STATE(4735),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3573),
    [sym_qualified_type_identifier] = STATE(7513),
    [sym_user_defined_literal] = STATE(3573),
    [sym_identifier] = ACTIONS(3726),
    [anon_sym_LPAREN2] = ACTIONS(4441),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(4441),
    [anon_sym_AMP_AMP] = ACTIONS(4441),
    [anon_sym_AMP] = ACTIONS(4443),
    [anon_sym_LT] = ACTIONS(4441),
    [anon_sym___extension__] = ACTIONS(3728),
    [anon_sym_COLON_COLON] = ACTIONS(2866),
    [anon_sym_LBRACE] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(4441),
    [sym_primitive_type] = ACTIONS(3732),
    [anon_sym_not] = ACTIONS(2860),
    [anon_sym_compl] = ACTIONS(2860),
    [anon_sym_DASH_DASH] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(2880),
    [anon_sym_sizeof] = ACTIONS(2882),
    [anon_sym___alignof__] = ACTIONS(2884),
    [anon_sym___alignof] = ACTIONS(2884),
    [anon_sym__alignof] = ACTIONS(2884),
    [anon_sym_alignof] = ACTIONS(2884),
    [anon_sym__Alignof] = ACTIONS(2884),
    [anon_sym_offsetof] = ACTIONS(2886),
    [anon_sym__Generic] = ACTIONS(2888),
    [anon_sym_asm] = ACTIONS(2890),
    [anon_sym___asm__] = ACTIONS(2890),
    [anon_sym___asm] = ACTIONS(2890),
    [sym_number_literal] = ACTIONS(2892),
    [anon_sym_L_SQUOTE] = ACTIONS(2894),
    [anon_sym_u_SQUOTE] = ACTIONS(2894),
    [anon_sym_U_SQUOTE] = ACTIONS(2894),
    [anon_sym_u8_SQUOTE] = ACTIONS(2894),
    [anon_sym_SQUOTE] = ACTIONS(2894),
    [anon_sym_L_DQUOTE] = ACTIONS(2896),
    [anon_sym_u_DQUOTE] = ACTIONS(2896),
    [anon_sym_U_DQUOTE] = ACTIONS(2896),
    [anon_sym_u8_DQUOTE] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [anon_sym_NULL] = ACTIONS(2900),
    [anon_sym_nullptr] = ACTIONS(2900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2910),
    [anon_sym_R_DQUOTE] = ACTIONS(2912),
    [anon_sym_LR_DQUOTE] = ACTIONS(2912),
    [anon_sym_uR_DQUOTE] = ACTIONS(2912),
    [anon_sym_UR_DQUOTE] = ACTIONS(2912),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2912),
    [anon_sym_co_await] = ACTIONS(2914),
    [anon_sym_new] = ACTIONS(2916),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2898),
  },
  [984] = {
    [sym_expression] = STATE(4105),
    [sym__string] = STATE(4127),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(2853),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(2853),
    [sym_call_expression] = STATE(2853),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(2853),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(2853),
    [sym_char_literal] = STATE(4127),
    [sym_concatenated_string] = STATE(4127),
    [sym_string_literal] = STATE(3058),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3058),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2853),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(2853),
    [sym_identifier] = ACTIONS(4470),
    [anon_sym_LPAREN2] = ACTIONS(4441),
    [anon_sym_BANG] = ACTIONS(3460),
    [anon_sym_TILDE] = ACTIONS(3460),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(4441),
    [anon_sym_AMP_AMP] = ACTIONS(4441),
    [anon_sym_AMP] = ACTIONS(4443),
    [anon_sym_LT] = ACTIONS(4441),
    [anon_sym___extension__] = ACTIONS(3462),
    [anon_sym_COLON_COLON] = ACTIONS(3464),
    [anon_sym_LBRACE] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(4441),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3458),
    [anon_sym_compl] = ACTIONS(3458),
    [anon_sym_DASH_DASH] = ACTIONS(4472),
    [anon_sym_PLUS_PLUS] = ACTIONS(4472),
    [anon_sym_sizeof] = ACTIONS(3468),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3470),
    [anon_sym_L_SQUOTE] = ACTIONS(3472),
    [anon_sym_u_SQUOTE] = ACTIONS(3472),
    [anon_sym_U_SQUOTE] = ACTIONS(3472),
    [anon_sym_u8_SQUOTE] = ACTIONS(3472),
    [anon_sym_SQUOTE] = ACTIONS(3472),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3476),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
    [anon_sym_co_await] = ACTIONS(3480),
    [anon_sym_new] = ACTIONS(3482),
    [anon_sym_requires] = ACTIONS(3484),
    [sym_this] = ACTIONS(221),
  },
  [985] = {
    [sym_expression] = STATE(4299),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_initializer_list] = STATE(7196),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3740),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_RBRACK] = ACTIONS(4474),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [986] = {
    [sym_expression] = STATE(4460),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4441),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4441),
    [anon_sym_AMP_AMP] = ACTIONS(4441),
    [anon_sym_AMP] = ACTIONS(4443),
    [anon_sym_LT] = ACTIONS(4441),
    [anon_sym___extension__] = ACTIONS(3714),
    [anon_sym_COLON_COLON] = ACTIONS(3716),
    [anon_sym_LBRACE] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(4441),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4476),
    [anon_sym_PLUS_PLUS] = ACTIONS(4476),
    [anon_sym_sizeof] = ACTIONS(3718),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3720),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3722),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [987] = {
    [sym_expression] = STATE(4462),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4441),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4441),
    [anon_sym_AMP_AMP] = ACTIONS(4441),
    [anon_sym_AMP] = ACTIONS(4443),
    [anon_sym_LT] = ACTIONS(4441),
    [anon_sym___extension__] = ACTIONS(3714),
    [anon_sym_COLON_COLON] = ACTIONS(3716),
    [anon_sym_LBRACE] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(4441),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4476),
    [anon_sym_PLUS_PLUS] = ACTIONS(4476),
    [anon_sym_sizeof] = ACTIONS(3718),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3720),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3722),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [988] = {
    [sym_expression] = STATE(4082),
    [sym__string] = STATE(4127),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(2853),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(2853),
    [sym_call_expression] = STATE(2853),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(2853),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(2853),
    [sym_char_literal] = STATE(4127),
    [sym_concatenated_string] = STATE(4127),
    [sym_string_literal] = STATE(3058),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3058),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2853),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(2853),
    [sym_identifier] = ACTIONS(4470),
    [anon_sym_LPAREN2] = ACTIONS(4441),
    [anon_sym_BANG] = ACTIONS(3460),
    [anon_sym_TILDE] = ACTIONS(3460),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(4441),
    [anon_sym_AMP_AMP] = ACTIONS(4441),
    [anon_sym_AMP] = ACTIONS(4443),
    [anon_sym_LT] = ACTIONS(4441),
    [anon_sym___extension__] = ACTIONS(3462),
    [anon_sym_COLON_COLON] = ACTIONS(3464),
    [anon_sym_LBRACE] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(4441),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3458),
    [anon_sym_compl] = ACTIONS(3458),
    [anon_sym_DASH_DASH] = ACTIONS(4472),
    [anon_sym_PLUS_PLUS] = ACTIONS(4472),
    [anon_sym_sizeof] = ACTIONS(3468),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3470),
    [anon_sym_L_SQUOTE] = ACTIONS(3472),
    [anon_sym_u_SQUOTE] = ACTIONS(3472),
    [anon_sym_U_SQUOTE] = ACTIONS(3472),
    [anon_sym_u8_SQUOTE] = ACTIONS(3472),
    [anon_sym_SQUOTE] = ACTIONS(3472),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3476),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
    [anon_sym_co_await] = ACTIONS(3480),
    [anon_sym_new] = ACTIONS(3482),
    [anon_sym_requires] = ACTIONS(3484),
    [sym_this] = ACTIONS(221),
  },
  [989] = {
    [sym_expression] = STATE(3168),
    [sym__string] = STATE(3374),
    [sym_conditional_expression] = STATE(3536),
    [sym_assignment_expression] = STATE(3536),
    [sym_pointer_expression] = STATE(3544),
    [sym_unary_expression] = STATE(3536),
    [sym_binary_expression] = STATE(3536),
    [sym_update_expression] = STATE(3536),
    [sym_cast_expression] = STATE(3536),
    [sym_sizeof_expression] = STATE(3536),
    [sym_alignof_expression] = STATE(3536),
    [sym_offsetof_expression] = STATE(3536),
    [sym_generic_expression] = STATE(3536),
    [sym_subscript_expression] = STATE(3544),
    [sym_call_expression] = STATE(3544),
    [sym_gnu_asm_expression] = STATE(3536),
    [sym_extension_expression] = STATE(3536),
    [sym_field_expression] = STATE(3544),
    [sym_compound_literal_expression] = STATE(3536),
    [sym_parenthesized_expression] = STATE(3544),
    [sym_char_literal] = STATE(3374),
    [sym_concatenated_string] = STATE(3374),
    [sym_string_literal] = STATE(2363),
    [sym_null] = STATE(3536),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7597),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3536),
    [sym_raw_string_literal] = STATE(2363),
    [sym_co_await_expression] = STATE(3536),
    [sym_new_expression] = STATE(3536),
    [sym_delete_expression] = STATE(3536),
    [sym_requires_clause] = STATE(3536),
    [sym_requires_expression] = STATE(3536),
    [sym_lambda_expression] = STATE(3536),
    [sym_lambda_capture_specifier] = STATE(5874),
    [sym_fold_expression] = STATE(3536),
    [sym_parameter_pack_expansion] = STATE(3536),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3544),
    [sym_qualified_type_identifier] = STATE(7597),
    [sym_user_defined_literal] = STATE(3544),
    [sym_identifier] = ACTIONS(2446),
    [anon_sym_LPAREN2] = ACTIONS(4441),
    [anon_sym_BANG] = ACTIONS(2450),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2448),
    [anon_sym_PLUS] = ACTIONS(2448),
    [anon_sym_STAR] = ACTIONS(4441),
    [anon_sym_AMP_AMP] = ACTIONS(4441),
    [anon_sym_AMP] = ACTIONS(4443),
    [anon_sym_LT] = ACTIONS(4441),
    [anon_sym___extension__] = ACTIONS(2452),
    [anon_sym_COLON_COLON] = ACTIONS(2454),
    [anon_sym_LBRACE] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(4441),
    [sym_primitive_type] = ACTIONS(2458),
    [anon_sym_not] = ACTIONS(2448),
    [anon_sym_compl] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(4478),
    [anon_sym_PLUS_PLUS] = ACTIONS(4478),
    [anon_sym_sizeof] = ACTIONS(2460),
    [anon_sym___alignof__] = ACTIONS(2462),
    [anon_sym___alignof] = ACTIONS(2462),
    [anon_sym__alignof] = ACTIONS(2462),
    [anon_sym_alignof] = ACTIONS(2462),
    [anon_sym__Alignof] = ACTIONS(2462),
    [anon_sym_offsetof] = ACTIONS(2464),
    [anon_sym__Generic] = ACTIONS(2466),
    [anon_sym_asm] = ACTIONS(2468),
    [anon_sym___asm__] = ACTIONS(2468),
    [anon_sym___asm] = ACTIONS(2468),
    [sym_number_literal] = ACTIONS(2470),
    [anon_sym_L_SQUOTE] = ACTIONS(2472),
    [anon_sym_u_SQUOTE] = ACTIONS(2472),
    [anon_sym_U_SQUOTE] = ACTIONS(2472),
    [anon_sym_u8_SQUOTE] = ACTIONS(2472),
    [anon_sym_SQUOTE] = ACTIONS(2472),
    [anon_sym_L_DQUOTE] = ACTIONS(2474),
    [anon_sym_u_DQUOTE] = ACTIONS(2474),
    [anon_sym_U_DQUOTE] = ACTIONS(2474),
    [anon_sym_u8_DQUOTE] = ACTIONS(2474),
    [anon_sym_DQUOTE] = ACTIONS(2474),
    [sym_true] = ACTIONS(2476),
    [sym_false] = ACTIONS(2476),
    [anon_sym_NULL] = ACTIONS(2478),
    [anon_sym_nullptr] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2480),
    [anon_sym_R_DQUOTE] = ACTIONS(2482),
    [anon_sym_LR_DQUOTE] = ACTIONS(2482),
    [anon_sym_uR_DQUOTE] = ACTIONS(2482),
    [anon_sym_UR_DQUOTE] = ACTIONS(2482),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2482),
    [anon_sym_co_await] = ACTIONS(2484),
    [anon_sym_new] = ACTIONS(2486),
    [anon_sym_requires] = ACTIONS(2488),
    [sym_this] = ACTIONS(2476),
  },
  [990] = {
    [sym_expression] = STATE(3502),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_LPAREN2] = ACTIONS(4441),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(4441),
    [anon_sym_AMP_AMP] = ACTIONS(4441),
    [anon_sym_AMP] = ACTIONS(4443),
    [anon_sym_LT] = ACTIONS(4441),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACE] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(4441),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [991] = {
    [sym_expression] = STATE(4235),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(4441),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(4441),
    [anon_sym_AMP_AMP] = ACTIONS(4441),
    [anon_sym_AMP] = ACTIONS(4443),
    [anon_sym_LT] = ACTIONS(4441),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(4441),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [992] = {
    [sym_expression] = STATE(3212),
    [sym__string] = STATE(3374),
    [sym_conditional_expression] = STATE(3536),
    [sym_assignment_expression] = STATE(3536),
    [sym_pointer_expression] = STATE(3544),
    [sym_unary_expression] = STATE(3536),
    [sym_binary_expression] = STATE(3536),
    [sym_update_expression] = STATE(3536),
    [sym_cast_expression] = STATE(3536),
    [sym_sizeof_expression] = STATE(3536),
    [sym_alignof_expression] = STATE(3536),
    [sym_offsetof_expression] = STATE(3536),
    [sym_generic_expression] = STATE(3536),
    [sym_subscript_expression] = STATE(3544),
    [sym_call_expression] = STATE(3544),
    [sym_gnu_asm_expression] = STATE(3536),
    [sym_extension_expression] = STATE(3536),
    [sym_field_expression] = STATE(3544),
    [sym_compound_literal_expression] = STATE(3536),
    [sym_parenthesized_expression] = STATE(3544),
    [sym_char_literal] = STATE(3374),
    [sym_concatenated_string] = STATE(3374),
    [sym_string_literal] = STATE(2363),
    [sym_null] = STATE(3536),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7597),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3536),
    [sym_raw_string_literal] = STATE(2363),
    [sym_co_await_expression] = STATE(3536),
    [sym_new_expression] = STATE(3536),
    [sym_delete_expression] = STATE(3536),
    [sym_requires_clause] = STATE(3536),
    [sym_requires_expression] = STATE(3536),
    [sym_lambda_expression] = STATE(3536),
    [sym_lambda_capture_specifier] = STATE(5874),
    [sym_fold_expression] = STATE(3536),
    [sym_parameter_pack_expansion] = STATE(3536),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3544),
    [sym_qualified_type_identifier] = STATE(7597),
    [sym_user_defined_literal] = STATE(3544),
    [sym_identifier] = ACTIONS(2446),
    [anon_sym_LPAREN2] = ACTIONS(4441),
    [anon_sym_BANG] = ACTIONS(2450),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2448),
    [anon_sym_PLUS] = ACTIONS(2448),
    [anon_sym_STAR] = ACTIONS(4441),
    [anon_sym_AMP_AMP] = ACTIONS(4441),
    [anon_sym_AMP] = ACTIONS(4443),
    [anon_sym_LT] = ACTIONS(4441),
    [anon_sym___extension__] = ACTIONS(2452),
    [anon_sym_COLON_COLON] = ACTIONS(2454),
    [anon_sym_LBRACE] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(4441),
    [sym_primitive_type] = ACTIONS(2458),
    [anon_sym_not] = ACTIONS(2448),
    [anon_sym_compl] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(4478),
    [anon_sym_PLUS_PLUS] = ACTIONS(4478),
    [anon_sym_sizeof] = ACTIONS(2460),
    [anon_sym___alignof__] = ACTIONS(2462),
    [anon_sym___alignof] = ACTIONS(2462),
    [anon_sym__alignof] = ACTIONS(2462),
    [anon_sym_alignof] = ACTIONS(2462),
    [anon_sym__Alignof] = ACTIONS(2462),
    [anon_sym_offsetof] = ACTIONS(2464),
    [anon_sym__Generic] = ACTIONS(2466),
    [anon_sym_asm] = ACTIONS(2468),
    [anon_sym___asm__] = ACTIONS(2468),
    [anon_sym___asm] = ACTIONS(2468),
    [sym_number_literal] = ACTIONS(2470),
    [anon_sym_L_SQUOTE] = ACTIONS(2472),
    [anon_sym_u_SQUOTE] = ACTIONS(2472),
    [anon_sym_U_SQUOTE] = ACTIONS(2472),
    [anon_sym_u8_SQUOTE] = ACTIONS(2472),
    [anon_sym_SQUOTE] = ACTIONS(2472),
    [anon_sym_L_DQUOTE] = ACTIONS(2474),
    [anon_sym_u_DQUOTE] = ACTIONS(2474),
    [anon_sym_U_DQUOTE] = ACTIONS(2474),
    [anon_sym_u8_DQUOTE] = ACTIONS(2474),
    [anon_sym_DQUOTE] = ACTIONS(2474),
    [sym_true] = ACTIONS(2476),
    [sym_false] = ACTIONS(2476),
    [anon_sym_NULL] = ACTIONS(2478),
    [anon_sym_nullptr] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2480),
    [anon_sym_R_DQUOTE] = ACTIONS(2482),
    [anon_sym_LR_DQUOTE] = ACTIONS(2482),
    [anon_sym_uR_DQUOTE] = ACTIONS(2482),
    [anon_sym_UR_DQUOTE] = ACTIONS(2482),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2482),
    [anon_sym_co_await] = ACTIONS(2484),
    [anon_sym_new] = ACTIONS(2486),
    [anon_sym_requires] = ACTIONS(2488),
    [sym_this] = ACTIONS(2476),
  },
  [993] = {
    [sym_expression] = STATE(3030),
    [sym__string] = STATE(3071),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(3071),
    [sym_concatenated_string] = STATE(3071),
    [sym_string_literal] = STATE(2243),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(2243),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1989),
    [anon_sym_LPAREN2] = ACTIONS(4441),
    [anon_sym_BANG] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1993),
    [anon_sym_DASH] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1991),
    [anon_sym_STAR] = ACTIONS(4441),
    [anon_sym_AMP_AMP] = ACTIONS(4441),
    [anon_sym_AMP] = ACTIONS(4443),
    [anon_sym_LT] = ACTIONS(4441),
    [anon_sym___extension__] = ACTIONS(1995),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_LBRACE] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(4441),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_compl] = ACTIONS(1991),
    [anon_sym_DASH_DASH] = ACTIONS(4480),
    [anon_sym_PLUS_PLUS] = ACTIONS(4480),
    [anon_sym_sizeof] = ACTIONS(1999),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(2001),
    [anon_sym_L_SQUOTE] = ACTIONS(2003),
    [anon_sym_u_SQUOTE] = ACTIONS(2003),
    [anon_sym_U_SQUOTE] = ACTIONS(2003),
    [anon_sym_u8_SQUOTE] = ACTIONS(2003),
    [anon_sym_SQUOTE] = ACTIONS(2003),
    [anon_sym_L_DQUOTE] = ACTIONS(2005),
    [anon_sym_u_DQUOTE] = ACTIONS(2005),
    [anon_sym_U_DQUOTE] = ACTIONS(2005),
    [anon_sym_u8_DQUOTE] = ACTIONS(2005),
    [anon_sym_DQUOTE] = ACTIONS(2005),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2007),
    [anon_sym_R_DQUOTE] = ACTIONS(2009),
    [anon_sym_LR_DQUOTE] = ACTIONS(2009),
    [anon_sym_uR_DQUOTE] = ACTIONS(2009),
    [anon_sym_UR_DQUOTE] = ACTIONS(2009),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2009),
    [anon_sym_co_await] = ACTIONS(2011),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [994] = {
    [sym_expression] = STATE(3043),
    [sym__string] = STATE(3071),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(3071),
    [sym_concatenated_string] = STATE(3071),
    [sym_string_literal] = STATE(2243),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(2243),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1989),
    [anon_sym_LPAREN2] = ACTIONS(4441),
    [anon_sym_BANG] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1993),
    [anon_sym_DASH] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1991),
    [anon_sym_STAR] = ACTIONS(4441),
    [anon_sym_AMP_AMP] = ACTIONS(4441),
    [anon_sym_AMP] = ACTIONS(4443),
    [anon_sym_LT] = ACTIONS(4441),
    [anon_sym___extension__] = ACTIONS(1995),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_LBRACE] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(4441),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_compl] = ACTIONS(1991),
    [anon_sym_DASH_DASH] = ACTIONS(4480),
    [anon_sym_PLUS_PLUS] = ACTIONS(4480),
    [anon_sym_sizeof] = ACTIONS(1999),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(2001),
    [anon_sym_L_SQUOTE] = ACTIONS(2003),
    [anon_sym_u_SQUOTE] = ACTIONS(2003),
    [anon_sym_U_SQUOTE] = ACTIONS(2003),
    [anon_sym_u8_SQUOTE] = ACTIONS(2003),
    [anon_sym_SQUOTE] = ACTIONS(2003),
    [anon_sym_L_DQUOTE] = ACTIONS(2005),
    [anon_sym_u_DQUOTE] = ACTIONS(2005),
    [anon_sym_U_DQUOTE] = ACTIONS(2005),
    [anon_sym_u8_DQUOTE] = ACTIONS(2005),
    [anon_sym_DQUOTE] = ACTIONS(2005),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2007),
    [anon_sym_R_DQUOTE] = ACTIONS(2009),
    [anon_sym_LR_DQUOTE] = ACTIONS(2009),
    [anon_sym_uR_DQUOTE] = ACTIONS(2009),
    [anon_sym_UR_DQUOTE] = ACTIONS(2009),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2009),
    [anon_sym_co_await] = ACTIONS(2011),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [995] = {
    [sym_expression] = STATE(4711),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(8135),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4482),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [996] = {
    [sym_expression] = STATE(3090),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_LPAREN2] = ACTIONS(4441),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(4441),
    [anon_sym_AMP_AMP] = ACTIONS(4441),
    [anon_sym_AMP] = ACTIONS(4443),
    [anon_sym_LT] = ACTIONS(4441),
    [anon_sym___extension__] = ACTIONS(2029),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(4441),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [997] = {
    [sym_expression] = STATE(4711),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(8135),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4485),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [998] = {
    [sym_expression] = STATE(4711),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(8135),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4488),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [999] = {
    [sym_expression] = STATE(2758),
    [sym__string] = STATE(2808),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2808),
    [sym_concatenated_string] = STATE(2808),
    [sym_string_literal] = STATE(1900),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1900),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4441),
    [anon_sym_BANG] = ACTIONS(1921),
    [anon_sym_TILDE] = ACTIONS(1921),
    [anon_sym_DASH] = ACTIONS(1919),
    [anon_sym_PLUS] = ACTIONS(1919),
    [anon_sym_STAR] = ACTIONS(4441),
    [anon_sym_AMP_AMP] = ACTIONS(4441),
    [anon_sym_AMP] = ACTIONS(4443),
    [anon_sym_LT] = ACTIONS(4441),
    [anon_sym___extension__] = ACTIONS(1923),
    [anon_sym_COLON_COLON] = ACTIONS(1925),
    [anon_sym_LBRACE] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(4441),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1919),
    [anon_sym_compl] = ACTIONS(1919),
    [anon_sym_DASH_DASH] = ACTIONS(4491),
    [anon_sym_PLUS_PLUS] = ACTIONS(4491),
    [anon_sym_sizeof] = ACTIONS(1931),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1953),
    [anon_sym_R_DQUOTE] = ACTIONS(1955),
    [anon_sym_LR_DQUOTE] = ACTIONS(1955),
    [anon_sym_uR_DQUOTE] = ACTIONS(1955),
    [anon_sym_UR_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1955),
    [anon_sym_co_await] = ACTIONS(1957),
    [anon_sym_new] = ACTIONS(1959),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1000] = {
    [sym_expression] = STATE(2760),
    [sym__string] = STATE(2808),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2808),
    [sym_concatenated_string] = STATE(2808),
    [sym_string_literal] = STATE(1900),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1900),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4441),
    [anon_sym_BANG] = ACTIONS(1921),
    [anon_sym_TILDE] = ACTIONS(1921),
    [anon_sym_DASH] = ACTIONS(1919),
    [anon_sym_PLUS] = ACTIONS(1919),
    [anon_sym_STAR] = ACTIONS(4441),
    [anon_sym_AMP_AMP] = ACTIONS(4441),
    [anon_sym_AMP] = ACTIONS(4443),
    [anon_sym_LT] = ACTIONS(4441),
    [anon_sym___extension__] = ACTIONS(1923),
    [anon_sym_COLON_COLON] = ACTIONS(1925),
    [anon_sym_LBRACE] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(4441),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1919),
    [anon_sym_compl] = ACTIONS(1919),
    [anon_sym_DASH_DASH] = ACTIONS(4491),
    [anon_sym_PLUS_PLUS] = ACTIONS(4491),
    [anon_sym_sizeof] = ACTIONS(1931),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1953),
    [anon_sym_R_DQUOTE] = ACTIONS(1955),
    [anon_sym_LR_DQUOTE] = ACTIONS(1955),
    [anon_sym_uR_DQUOTE] = ACTIONS(1955),
    [anon_sym_UR_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1955),
    [anon_sym_co_await] = ACTIONS(1957),
    [anon_sym_new] = ACTIONS(1959),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1001] = {
    [sym_expression] = STATE(3282),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4441),
    [anon_sym_BANG] = ACTIONS(2498),
    [anon_sym_TILDE] = ACTIONS(2498),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_STAR] = ACTIONS(4441),
    [anon_sym_AMP_AMP] = ACTIONS(4441),
    [anon_sym_AMP] = ACTIONS(4443),
    [anon_sym_LT] = ACTIONS(4441),
    [anon_sym___extension__] = ACTIONS(2500),
    [anon_sym_COLON_COLON] = ACTIONS(2502),
    [anon_sym_LBRACE] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(4441),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(2496),
    [anon_sym_compl] = ACTIONS(2496),
    [anon_sym_DASH_DASH] = ACTIONS(4493),
    [anon_sym_PLUS_PLUS] = ACTIONS(4493),
    [anon_sym_sizeof] = ACTIONS(2504),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2506),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(2508),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1002] = {
    [sym_expression] = STATE(3284),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4441),
    [anon_sym_BANG] = ACTIONS(2498),
    [anon_sym_TILDE] = ACTIONS(2498),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_STAR] = ACTIONS(4441),
    [anon_sym_AMP_AMP] = ACTIONS(4441),
    [anon_sym_AMP] = ACTIONS(4443),
    [anon_sym_LT] = ACTIONS(4441),
    [anon_sym___extension__] = ACTIONS(2500),
    [anon_sym_COLON_COLON] = ACTIONS(2502),
    [anon_sym_LBRACE] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(4441),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(2496),
    [anon_sym_compl] = ACTIONS(2496),
    [anon_sym_DASH_DASH] = ACTIONS(4493),
    [anon_sym_PLUS_PLUS] = ACTIONS(4493),
    [anon_sym_sizeof] = ACTIONS(2504),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2506),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(2508),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1003] = {
    [sym_expression] = STATE(4518),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(4441),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(4441),
    [anon_sym_AMP_AMP] = ACTIONS(4441),
    [anon_sym_AMP] = ACTIONS(4443),
    [anon_sym_LT] = ACTIONS(4441),
    [anon_sym___extension__] = ACTIONS(3740),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACE] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(4441),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1004] = {
    [sym_expression] = STATE(4520),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(4441),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(4441),
    [anon_sym_AMP_AMP] = ACTIONS(4441),
    [anon_sym_AMP] = ACTIONS(4443),
    [anon_sym_LT] = ACTIONS(4441),
    [anon_sym___extension__] = ACTIONS(3740),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACE] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(4441),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1005] = {
    [sym_expression] = STATE(2849),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4441),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(4441),
    [anon_sym_AMP_AMP] = ACTIONS(4441),
    [anon_sym_AMP] = ACTIONS(4443),
    [anon_sym_LT] = ACTIONS(4441),
    [anon_sym___extension__] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1971),
    [anon_sym_LBRACE] = ACTIONS(4441),
    [anon_sym_LBRACK] = ACTIONS(4441),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1965),
    [anon_sym_compl] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_sizeof] = ACTIONS(1973),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1006] = {
    [sym_expression] = STATE(4531),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8494),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_RPAREN] = ACTIONS(4495),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1007] = {
    [sym_expression] = STATE(3655),
    [sym__string] = STATE(4345),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3286),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3286),
    [sym_call_expression] = STATE(3286),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3286),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3286),
    [sym_initializer_list] = STATE(3776),
    [sym_char_literal] = STATE(4345),
    [sym_concatenated_string] = STATE(4345),
    [sym_string_literal] = STATE(3370),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3370),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3286),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3286),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_LPAREN2] = ACTIONS(4388),
    [anon_sym_BANG] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3496),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym___extension__] = ACTIONS(3500),
    [anon_sym_COLON_COLON] = ACTIONS(3502),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3496),
    [anon_sym_compl] = ACTIONS(3496),
    [anon_sym_DASH_DASH] = ACTIONS(4394),
    [anon_sym_PLUS_PLUS] = ACTIONS(4394),
    [anon_sym_sizeof] = ACTIONS(3504),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3506),
    [anon_sym_L_SQUOTE] = ACTIONS(3508),
    [anon_sym_u_SQUOTE] = ACTIONS(3508),
    [anon_sym_U_SQUOTE] = ACTIONS(3508),
    [anon_sym_u8_SQUOTE] = ACTIONS(3508),
    [anon_sym_SQUOTE] = ACTIONS(3508),
    [anon_sym_L_DQUOTE] = ACTIONS(3510),
    [anon_sym_u_DQUOTE] = ACTIONS(3510),
    [anon_sym_U_DQUOTE] = ACTIONS(3510),
    [anon_sym_u8_DQUOTE] = ACTIONS(3510),
    [anon_sym_DQUOTE] = ACTIONS(3510),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3512),
    [anon_sym_R_DQUOTE] = ACTIONS(3514),
    [anon_sym_LR_DQUOTE] = ACTIONS(3514),
    [anon_sym_uR_DQUOTE] = ACTIONS(3514),
    [anon_sym_UR_DQUOTE] = ACTIONS(3514),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3514),
    [anon_sym_co_await] = ACTIONS(3516),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1008] = {
    [sym_expression] = STATE(4233),
    [sym__string] = STATE(4345),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3286),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3286),
    [sym_call_expression] = STATE(3286),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3286),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3286),
    [sym_initializer_list] = STATE(6850),
    [sym_char_literal] = STATE(4345),
    [sym_concatenated_string] = STATE(4345),
    [sym_string_literal] = STATE(3370),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3370),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3286),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3286),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_LPAREN2] = ACTIONS(4388),
    [anon_sym_BANG] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3496),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym___extension__] = ACTIONS(3500),
    [anon_sym_COLON_COLON] = ACTIONS(3502),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3496),
    [anon_sym_compl] = ACTIONS(3496),
    [anon_sym_DASH_DASH] = ACTIONS(4394),
    [anon_sym_PLUS_PLUS] = ACTIONS(4394),
    [anon_sym_sizeof] = ACTIONS(3504),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3506),
    [anon_sym_L_SQUOTE] = ACTIONS(3508),
    [anon_sym_u_SQUOTE] = ACTIONS(3508),
    [anon_sym_U_SQUOTE] = ACTIONS(3508),
    [anon_sym_u8_SQUOTE] = ACTIONS(3508),
    [anon_sym_SQUOTE] = ACTIONS(3508),
    [anon_sym_L_DQUOTE] = ACTIONS(3510),
    [anon_sym_u_DQUOTE] = ACTIONS(3510),
    [anon_sym_U_DQUOTE] = ACTIONS(3510),
    [anon_sym_u8_DQUOTE] = ACTIONS(3510),
    [anon_sym_DQUOTE] = ACTIONS(3510),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3512),
    [anon_sym_R_DQUOTE] = ACTIONS(3514),
    [anon_sym_LR_DQUOTE] = ACTIONS(3514),
    [anon_sym_uR_DQUOTE] = ACTIONS(3514),
    [anon_sym_UR_DQUOTE] = ACTIONS(3514),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3514),
    [anon_sym_co_await] = ACTIONS(3516),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1009] = {
    [sym_expression] = STATE(4270),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(3842),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1010] = {
    [sym_expression] = STATE(4433),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8070),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4497),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(3714),
    [anon_sym_COLON_COLON] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_COLON] = ACTIONS(4501),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4476),
    [anon_sym_PLUS_PLUS] = ACTIONS(4476),
    [anon_sym_sizeof] = ACTIONS(3718),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3720),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3722),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1011] = {
    [sym_expression] = STATE(4312),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(7648),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1012] = {
    [sym_expression] = STATE(2328),
    [sym__string] = STATE(2808),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_initializer_list] = STATE(2473),
    [sym_char_literal] = STATE(2808),
    [sym_concatenated_string] = STATE(2808),
    [sym_string_literal] = STATE(1900),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1900),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4503),
    [anon_sym_BANG] = ACTIONS(1921),
    [anon_sym_TILDE] = ACTIONS(1921),
    [anon_sym_DASH] = ACTIONS(1919),
    [anon_sym_PLUS] = ACTIONS(1919),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_AMP] = ACTIONS(4505),
    [anon_sym___extension__] = ACTIONS(1923),
    [anon_sym_COLON_COLON] = ACTIONS(1925),
    [anon_sym_LBRACE] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1919),
    [anon_sym_compl] = ACTIONS(1919),
    [anon_sym_DASH_DASH] = ACTIONS(4491),
    [anon_sym_PLUS_PLUS] = ACTIONS(4491),
    [anon_sym_sizeof] = ACTIONS(1931),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1953),
    [anon_sym_R_DQUOTE] = ACTIONS(1955),
    [anon_sym_LR_DQUOTE] = ACTIONS(1955),
    [anon_sym_uR_DQUOTE] = ACTIONS(1955),
    [anon_sym_UR_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1955),
    [anon_sym_co_await] = ACTIONS(1957),
    [anon_sym_new] = ACTIONS(1959),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1013] = {
    [sym_expression] = STATE(4582),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(8200),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1014] = {
    [sym_expression] = STATE(4366),
    [sym__string] = STATE(4637),
    [sym_conditional_expression] = STATE(4735),
    [sym_assignment_expression] = STATE(4735),
    [sym_pointer_expression] = STATE(3573),
    [sym_unary_expression] = STATE(4735),
    [sym_binary_expression] = STATE(4735),
    [sym_update_expression] = STATE(4735),
    [sym_cast_expression] = STATE(4735),
    [sym_sizeof_expression] = STATE(4735),
    [sym_alignof_expression] = STATE(4735),
    [sym_offsetof_expression] = STATE(4735),
    [sym_generic_expression] = STATE(4735),
    [sym_subscript_expression] = STATE(3573),
    [sym_call_expression] = STATE(3573),
    [sym_gnu_asm_expression] = STATE(4735),
    [sym_extension_expression] = STATE(4735),
    [sym_field_expression] = STATE(3573),
    [sym_compound_literal_expression] = STATE(4735),
    [sym_parenthesized_expression] = STATE(3573),
    [sym_initializer_list] = STATE(4793),
    [sym_char_literal] = STATE(4637),
    [sym_concatenated_string] = STATE(4637),
    [sym_string_literal] = STATE(3662),
    [sym_null] = STATE(4735),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7513),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(4735),
    [sym_raw_string_literal] = STATE(3662),
    [sym_co_await_expression] = STATE(4735),
    [sym_new_expression] = STATE(4735),
    [sym_delete_expression] = STATE(4735),
    [sym_requires_clause] = STATE(4735),
    [sym_requires_expression] = STATE(4735),
    [sym_lambda_expression] = STATE(4735),
    [sym_lambda_capture_specifier] = STATE(5854),
    [sym_fold_expression] = STATE(4735),
    [sym_parameter_pack_expansion] = STATE(4735),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3573),
    [sym_qualified_type_identifier] = STATE(7513),
    [sym_user_defined_literal] = STATE(3573),
    [sym_identifier] = ACTIONS(3726),
    [anon_sym_LPAREN2] = ACTIONS(2856),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(3728),
    [anon_sym_COLON_COLON] = ACTIONS(2866),
    [anon_sym_LBRACE] = ACTIONS(3730),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(3732),
    [anon_sym_not] = ACTIONS(2860),
    [anon_sym_compl] = ACTIONS(2860),
    [anon_sym_DASH_DASH] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(2880),
    [anon_sym_sizeof] = ACTIONS(2882),
    [anon_sym___alignof__] = ACTIONS(2884),
    [anon_sym___alignof] = ACTIONS(2884),
    [anon_sym__alignof] = ACTIONS(2884),
    [anon_sym_alignof] = ACTIONS(2884),
    [anon_sym__Alignof] = ACTIONS(2884),
    [anon_sym_offsetof] = ACTIONS(2886),
    [anon_sym__Generic] = ACTIONS(2888),
    [anon_sym_asm] = ACTIONS(2890),
    [anon_sym___asm__] = ACTIONS(2890),
    [anon_sym___asm] = ACTIONS(2890),
    [sym_number_literal] = ACTIONS(2892),
    [anon_sym_L_SQUOTE] = ACTIONS(2894),
    [anon_sym_u_SQUOTE] = ACTIONS(2894),
    [anon_sym_U_SQUOTE] = ACTIONS(2894),
    [anon_sym_u8_SQUOTE] = ACTIONS(2894),
    [anon_sym_SQUOTE] = ACTIONS(2894),
    [anon_sym_L_DQUOTE] = ACTIONS(2896),
    [anon_sym_u_DQUOTE] = ACTIONS(2896),
    [anon_sym_U_DQUOTE] = ACTIONS(2896),
    [anon_sym_u8_DQUOTE] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [anon_sym_NULL] = ACTIONS(2900),
    [anon_sym_nullptr] = ACTIONS(2900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2910),
    [anon_sym_R_DQUOTE] = ACTIONS(2912),
    [anon_sym_LR_DQUOTE] = ACTIONS(2912),
    [anon_sym_uR_DQUOTE] = ACTIONS(2912),
    [anon_sym_UR_DQUOTE] = ACTIONS(2912),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2912),
    [anon_sym_co_await] = ACTIONS(2914),
    [anon_sym_new] = ACTIONS(2916),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2898),
  },
  [1015] = {
    [sym_expression] = STATE(4434),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8416),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4497),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(3714),
    [anon_sym_COLON_COLON] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_COLON] = ACTIONS(4507),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4476),
    [anon_sym_PLUS_PLUS] = ACTIONS(4476),
    [anon_sym_sizeof] = ACTIONS(3718),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3720),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3722),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1016] = {
    [sym_expression] = STATE(3549),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_initializer_list] = STATE(3760),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACE] = ACTIONS(2581),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [1017] = {
    [sym_expression] = STATE(4711),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(8135),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1018] = {
    [sym_expression] = STATE(4117),
    [sym__string] = STATE(4127),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(2853),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(2853),
    [sym_call_expression] = STATE(2853),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(2853),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(2853),
    [sym_initializer_list] = STATE(3842),
    [sym_char_literal] = STATE(4127),
    [sym_concatenated_string] = STATE(4127),
    [sym_string_literal] = STATE(3058),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3058),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2853),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(2853),
    [sym_identifier] = ACTIONS(4470),
    [anon_sym_LPAREN2] = ACTIONS(4509),
    [anon_sym_BANG] = ACTIONS(3460),
    [anon_sym_TILDE] = ACTIONS(3460),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_AMP] = ACTIONS(4505),
    [anon_sym___extension__] = ACTIONS(3462),
    [anon_sym_COLON_COLON] = ACTIONS(3464),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3458),
    [anon_sym_compl] = ACTIONS(3458),
    [anon_sym_DASH_DASH] = ACTIONS(4472),
    [anon_sym_PLUS_PLUS] = ACTIONS(4472),
    [anon_sym_sizeof] = ACTIONS(3468),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3470),
    [anon_sym_L_SQUOTE] = ACTIONS(3472),
    [anon_sym_u_SQUOTE] = ACTIONS(3472),
    [anon_sym_U_SQUOTE] = ACTIONS(3472),
    [anon_sym_u8_SQUOTE] = ACTIONS(3472),
    [anon_sym_SQUOTE] = ACTIONS(3472),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3476),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
    [anon_sym_co_await] = ACTIONS(3480),
    [anon_sym_new] = ACTIONS(3482),
    [anon_sym_requires] = ACTIONS(3484),
    [sym_this] = ACTIONS(221),
  },
  [1019] = {
    [sym_expression] = STATE(4378),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8506),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_RPAREN] = ACTIONS(4511),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1020] = {
    [sym_expression] = STATE(4390),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8300),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4497),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(3714),
    [anon_sym_COLON_COLON] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_COLON] = ACTIONS(4513),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4476),
    [anon_sym_PLUS_PLUS] = ACTIONS(4476),
    [anon_sym_sizeof] = ACTIONS(3718),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3720),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3722),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1021] = {
    [sym_expression] = STATE(4405),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8016),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4497),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(3714),
    [anon_sym_COLON_COLON] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_COLON] = ACTIONS(4515),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4476),
    [anon_sym_PLUS_PLUS] = ACTIONS(4476),
    [anon_sym_sizeof] = ACTIONS(3718),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3720),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3722),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1022] = {
    [sym_expression] = STATE(3655),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(3776),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1023] = {
    [sym_expression] = STATE(4368),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8133),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_RPAREN] = ACTIONS(4517),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1024] = {
    [sym_expression] = STATE(3655),
    [sym__string] = STATE(4127),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(2853),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(2853),
    [sym_call_expression] = STATE(2853),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(2853),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(2853),
    [sym_initializer_list] = STATE(3776),
    [sym_char_literal] = STATE(4127),
    [sym_concatenated_string] = STATE(4127),
    [sym_string_literal] = STATE(3058),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3058),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2853),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(2853),
    [sym_identifier] = ACTIONS(4470),
    [anon_sym_LPAREN2] = ACTIONS(4509),
    [anon_sym_BANG] = ACTIONS(3460),
    [anon_sym_TILDE] = ACTIONS(3460),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_AMP] = ACTIONS(4505),
    [anon_sym___extension__] = ACTIONS(3462),
    [anon_sym_COLON_COLON] = ACTIONS(3464),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3458),
    [anon_sym_compl] = ACTIONS(3458),
    [anon_sym_DASH_DASH] = ACTIONS(4472),
    [anon_sym_PLUS_PLUS] = ACTIONS(4472),
    [anon_sym_sizeof] = ACTIONS(3468),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3470),
    [anon_sym_L_SQUOTE] = ACTIONS(3472),
    [anon_sym_u_SQUOTE] = ACTIONS(3472),
    [anon_sym_U_SQUOTE] = ACTIONS(3472),
    [anon_sym_u8_SQUOTE] = ACTIONS(3472),
    [anon_sym_SQUOTE] = ACTIONS(3472),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3476),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
    [anon_sym_co_await] = ACTIONS(3480),
    [anon_sym_new] = ACTIONS(3482),
    [anon_sym_requires] = ACTIONS(3484),
    [sym_this] = ACTIONS(221),
  },
  [1025] = {
    [sym_expression] = STATE(4369),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8187),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_RPAREN] = ACTIONS(4519),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1026] = {
    [sym_expression] = STATE(2328),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_initializer_list] = STATE(2473),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4424),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1971),
    [anon_sym_LBRACE] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1965),
    [anon_sym_compl] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_sizeof] = ACTIONS(1973),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1027] = {
    [sym_expression] = STATE(3232),
    [sym__string] = STATE(3374),
    [sym_conditional_expression] = STATE(3536),
    [sym_assignment_expression] = STATE(3536),
    [sym_pointer_expression] = STATE(3544),
    [sym_unary_expression] = STATE(3536),
    [sym_binary_expression] = STATE(3536),
    [sym_update_expression] = STATE(3536),
    [sym_cast_expression] = STATE(3536),
    [sym_sizeof_expression] = STATE(3536),
    [sym_alignof_expression] = STATE(3536),
    [sym_offsetof_expression] = STATE(3536),
    [sym_generic_expression] = STATE(3536),
    [sym_subscript_expression] = STATE(3544),
    [sym_call_expression] = STATE(3544),
    [sym_gnu_asm_expression] = STATE(3536),
    [sym_extension_expression] = STATE(3536),
    [sym_field_expression] = STATE(3544),
    [sym_compound_literal_expression] = STATE(3536),
    [sym_parenthesized_expression] = STATE(3544),
    [sym_initializer_list] = STATE(3497),
    [sym_char_literal] = STATE(3374),
    [sym_concatenated_string] = STATE(3374),
    [sym_string_literal] = STATE(2363),
    [sym_null] = STATE(3536),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7597),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3536),
    [sym_raw_string_literal] = STATE(2363),
    [sym_co_await_expression] = STATE(3536),
    [sym_new_expression] = STATE(3536),
    [sym_delete_expression] = STATE(3536),
    [sym_requires_clause] = STATE(3536),
    [sym_requires_expression] = STATE(3536),
    [sym_lambda_expression] = STATE(3536),
    [sym_lambda_capture_specifier] = STATE(5874),
    [sym_fold_expression] = STATE(3536),
    [sym_parameter_pack_expansion] = STATE(3536),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3544),
    [sym_qualified_type_identifier] = STATE(7597),
    [sym_user_defined_literal] = STATE(3544),
    [sym_identifier] = ACTIONS(2446),
    [anon_sym_LPAREN2] = ACTIONS(4521),
    [anon_sym_BANG] = ACTIONS(2450),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2448),
    [anon_sym_PLUS] = ACTIONS(2448),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(2452),
    [anon_sym_COLON_COLON] = ACTIONS(2454),
    [anon_sym_LBRACE] = ACTIONS(2456),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2458),
    [anon_sym_not] = ACTIONS(2448),
    [anon_sym_compl] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(4478),
    [anon_sym_PLUS_PLUS] = ACTIONS(4478),
    [anon_sym_sizeof] = ACTIONS(2460),
    [anon_sym___alignof__] = ACTIONS(2462),
    [anon_sym___alignof] = ACTIONS(2462),
    [anon_sym__alignof] = ACTIONS(2462),
    [anon_sym_alignof] = ACTIONS(2462),
    [anon_sym__Alignof] = ACTIONS(2462),
    [anon_sym_offsetof] = ACTIONS(2464),
    [anon_sym__Generic] = ACTIONS(2466),
    [anon_sym_asm] = ACTIONS(2468),
    [anon_sym___asm__] = ACTIONS(2468),
    [anon_sym___asm] = ACTIONS(2468),
    [sym_number_literal] = ACTIONS(2470),
    [anon_sym_L_SQUOTE] = ACTIONS(2472),
    [anon_sym_u_SQUOTE] = ACTIONS(2472),
    [anon_sym_U_SQUOTE] = ACTIONS(2472),
    [anon_sym_u8_SQUOTE] = ACTIONS(2472),
    [anon_sym_SQUOTE] = ACTIONS(2472),
    [anon_sym_L_DQUOTE] = ACTIONS(2474),
    [anon_sym_u_DQUOTE] = ACTIONS(2474),
    [anon_sym_U_DQUOTE] = ACTIONS(2474),
    [anon_sym_u8_DQUOTE] = ACTIONS(2474),
    [anon_sym_DQUOTE] = ACTIONS(2474),
    [sym_true] = ACTIONS(2476),
    [sym_false] = ACTIONS(2476),
    [anon_sym_NULL] = ACTIONS(2478),
    [anon_sym_nullptr] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2480),
    [anon_sym_R_DQUOTE] = ACTIONS(2482),
    [anon_sym_LR_DQUOTE] = ACTIONS(2482),
    [anon_sym_uR_DQUOTE] = ACTIONS(2482),
    [anon_sym_UR_DQUOTE] = ACTIONS(2482),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2482),
    [anon_sym_co_await] = ACTIONS(2484),
    [anon_sym_new] = ACTIONS(2486),
    [anon_sym_requires] = ACTIONS(2488),
    [sym_this] = ACTIONS(2476),
  },
  [1028] = {
    [sym_expression] = STATE(4535),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_initializer_list] = STATE(7741),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3740),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1029] = {
    [sym_expression] = STATE(4416),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(7791),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4497),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(3714),
    [anon_sym_COLON_COLON] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_COLON] = ACTIONS(4523),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4476),
    [anon_sym_PLUS_PLUS] = ACTIONS(4476),
    [anon_sym_sizeof] = ACTIONS(3718),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3720),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3722),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1030] = {
    [sym_expression] = STATE(4424),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8201),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4497),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(3714),
    [anon_sym_COLON_COLON] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_COLON] = ACTIONS(4525),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4476),
    [anon_sym_PLUS_PLUS] = ACTIONS(4476),
    [anon_sym_sizeof] = ACTIONS(3718),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3720),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3722),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1031] = {
    [sym_expression] = STATE(4477),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(7527),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1032] = {
    [sym_expression] = STATE(4446),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_initializer_list] = STATE(3842),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4497),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(3714),
    [anon_sym_COLON_COLON] = ACTIONS(3716),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4476),
    [anon_sym_PLUS_PLUS] = ACTIONS(4476),
    [anon_sym_sizeof] = ACTIONS(3718),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3720),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3722),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1033] = {
    [sym_expression] = STATE(4457),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8628),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4497),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(3714),
    [anon_sym_COLON_COLON] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_COLON] = ACTIONS(4527),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4476),
    [anon_sym_PLUS_PLUS] = ACTIONS(4476),
    [anon_sym_sizeof] = ACTIONS(3718),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3720),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3722),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1034] = {
    [sym_expression] = STATE(4498),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_initializer_list] = STATE(3776),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4497),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(3714),
    [anon_sym_COLON_COLON] = ACTIONS(3716),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4476),
    [anon_sym_PLUS_PLUS] = ACTIONS(4476),
    [anon_sym_sizeof] = ACTIONS(3718),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3720),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3722),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1035] = {
    [sym_expression] = STATE(3065),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_initializer_list] = STATE(3368),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2029),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [1036] = {
    [sym_expression] = STATE(4380),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(7852),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4497),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(3714),
    [anon_sym_COLON_COLON] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_COLON] = ACTIONS(4529),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4476),
    [anon_sym_PLUS_PLUS] = ACTIONS(4476),
    [anon_sym_sizeof] = ACTIONS(3718),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3720),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3722),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1037] = {
    [sym_expression] = STATE(2328),
    [sym__string] = STATE(3071),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_initializer_list] = STATE(2473),
    [sym_char_literal] = STATE(3071),
    [sym_concatenated_string] = STATE(3071),
    [sym_string_literal] = STATE(2243),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(2243),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1989),
    [anon_sym_LPAREN2] = ACTIONS(4531),
    [anon_sym_BANG] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1993),
    [anon_sym_DASH] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1991),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym___extension__] = ACTIONS(1995),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_LBRACE] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_compl] = ACTIONS(1991),
    [anon_sym_DASH_DASH] = ACTIONS(4480),
    [anon_sym_PLUS_PLUS] = ACTIONS(4480),
    [anon_sym_sizeof] = ACTIONS(1999),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(2001),
    [anon_sym_L_SQUOTE] = ACTIONS(2003),
    [anon_sym_u_SQUOTE] = ACTIONS(2003),
    [anon_sym_U_SQUOTE] = ACTIONS(2003),
    [anon_sym_u8_SQUOTE] = ACTIONS(2003),
    [anon_sym_SQUOTE] = ACTIONS(2003),
    [anon_sym_L_DQUOTE] = ACTIONS(2005),
    [anon_sym_u_DQUOTE] = ACTIONS(2005),
    [anon_sym_U_DQUOTE] = ACTIONS(2005),
    [anon_sym_u8_DQUOTE] = ACTIONS(2005),
    [anon_sym_DQUOTE] = ACTIONS(2005),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2007),
    [anon_sym_R_DQUOTE] = ACTIONS(2009),
    [anon_sym_LR_DQUOTE] = ACTIONS(2009),
    [anon_sym_uR_DQUOTE] = ACTIONS(2009),
    [anon_sym_UR_DQUOTE] = ACTIONS(2009),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2009),
    [anon_sym_co_await] = ACTIONS(2011),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1038] = {
    [sym_expression] = STATE(4721),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(8517),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1039] = {
    [sym_expression] = STATE(4229),
    [sym__string] = STATE(4345),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3286),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3286),
    [sym_call_expression] = STATE(3286),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3286),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3286),
    [sym_initializer_list] = STATE(3842),
    [sym_char_literal] = STATE(4345),
    [sym_concatenated_string] = STATE(4345),
    [sym_string_literal] = STATE(3370),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3370),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3286),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3286),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_LPAREN2] = ACTIONS(4388),
    [anon_sym_BANG] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3496),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym___extension__] = ACTIONS(3500),
    [anon_sym_COLON_COLON] = ACTIONS(3502),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3496),
    [anon_sym_compl] = ACTIONS(3496),
    [anon_sym_DASH_DASH] = ACTIONS(4394),
    [anon_sym_PLUS_PLUS] = ACTIONS(4394),
    [anon_sym_sizeof] = ACTIONS(3504),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3506),
    [anon_sym_L_SQUOTE] = ACTIONS(3508),
    [anon_sym_u_SQUOTE] = ACTIONS(3508),
    [anon_sym_U_SQUOTE] = ACTIONS(3508),
    [anon_sym_u8_SQUOTE] = ACTIONS(3508),
    [anon_sym_SQUOTE] = ACTIONS(3508),
    [anon_sym_L_DQUOTE] = ACTIONS(3510),
    [anon_sym_u_DQUOTE] = ACTIONS(3510),
    [anon_sym_U_DQUOTE] = ACTIONS(3510),
    [anon_sym_u8_DQUOTE] = ACTIONS(3510),
    [anon_sym_DQUOTE] = ACTIONS(3510),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3512),
    [anon_sym_R_DQUOTE] = ACTIONS(3514),
    [anon_sym_LR_DQUOTE] = ACTIONS(3514),
    [anon_sym_uR_DQUOTE] = ACTIONS(3514),
    [anon_sym_UR_DQUOTE] = ACTIONS(3514),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3514),
    [anon_sym_co_await] = ACTIONS(3516),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1040] = {
    [sym_expression] = STATE(4303),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(7318),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4533),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1041] = {
    [sym_expression] = STATE(4478),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8579),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4497),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(3714),
    [anon_sym_COLON_COLON] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_COLON] = ACTIONS(4536),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4476),
    [anon_sym_PLUS_PLUS] = ACTIONS(4476),
    [anon_sym_sizeof] = ACTIONS(3718),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3720),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3722),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1042] = {
    [sym_expression] = STATE(4501),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8186),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_RPAREN] = ACTIONS(4538),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1043] = {
    [sym_expression] = STATE(3594),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_initializer_list] = STATE(3870),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACE] = ACTIONS(2581),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [1044] = {
    [sym_expression] = STATE(4423),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(7648),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1045] = {
    [sym_expression] = STATE(4504),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8207),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_RPAREN] = ACTIONS(4540),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1046] = {
    [sym_expression] = STATE(4466),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_initializer_list] = STATE(3842),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3740),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1047] = {
    [sym_expression] = STATE(4497),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8164),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4497),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(3714),
    [anon_sym_COLON_COLON] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_COLON] = ACTIONS(4542),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4476),
    [anon_sym_PLUS_PLUS] = ACTIONS(4476),
    [anon_sym_sizeof] = ACTIONS(3718),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3720),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3722),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1048] = {
    [sym_expression] = STATE(3655),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_initializer_list] = STATE(3776),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3740),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1049] = {
    [sym_expression] = STATE(4371),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(7889),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4497),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(3714),
    [anon_sym_COLON_COLON] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_COLON] = ACTIONS(4544),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4476),
    [anon_sym_PLUS_PLUS] = ACTIONS(4476),
    [anon_sym_sizeof] = ACTIONS(3718),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3720),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3722),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1050] = {
    [sym_expression] = STATE(3280),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_initializer_list] = STATE(2473),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4546),
    [anon_sym_BANG] = ACTIONS(2498),
    [anon_sym_TILDE] = ACTIONS(2498),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(2500),
    [anon_sym_COLON_COLON] = ACTIONS(2502),
    [anon_sym_LBRACE] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(2496),
    [anon_sym_compl] = ACTIONS(2496),
    [anon_sym_DASH_DASH] = ACTIONS(4493),
    [anon_sym_PLUS_PLUS] = ACTIONS(4493),
    [anon_sym_sizeof] = ACTIONS(2504),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2506),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(2508),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1051] = {
    [sym_expression] = STATE(4430),
    [sym__string] = STATE(4637),
    [sym_conditional_expression] = STATE(4735),
    [sym_assignment_expression] = STATE(4735),
    [sym_pointer_expression] = STATE(3573),
    [sym_unary_expression] = STATE(4735),
    [sym_binary_expression] = STATE(4735),
    [sym_update_expression] = STATE(4735),
    [sym_cast_expression] = STATE(4735),
    [sym_sizeof_expression] = STATE(4735),
    [sym_alignof_expression] = STATE(4735),
    [sym_offsetof_expression] = STATE(4735),
    [sym_generic_expression] = STATE(4735),
    [sym_subscript_expression] = STATE(3573),
    [sym_call_expression] = STATE(3573),
    [sym_gnu_asm_expression] = STATE(4735),
    [sym_extension_expression] = STATE(4735),
    [sym_field_expression] = STATE(3573),
    [sym_compound_literal_expression] = STATE(4735),
    [sym_parenthesized_expression] = STATE(3573),
    [sym_initializer_list] = STATE(4760),
    [sym_char_literal] = STATE(4637),
    [sym_concatenated_string] = STATE(4637),
    [sym_string_literal] = STATE(3662),
    [sym_null] = STATE(4735),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7513),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(4735),
    [sym_raw_string_literal] = STATE(3662),
    [sym_co_await_expression] = STATE(4735),
    [sym_new_expression] = STATE(4735),
    [sym_delete_expression] = STATE(4735),
    [sym_requires_clause] = STATE(4735),
    [sym_requires_expression] = STATE(4735),
    [sym_lambda_expression] = STATE(4735),
    [sym_lambda_capture_specifier] = STATE(5854),
    [sym_fold_expression] = STATE(4735),
    [sym_parameter_pack_expansion] = STATE(4735),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3573),
    [sym_qualified_type_identifier] = STATE(7513),
    [sym_user_defined_literal] = STATE(3573),
    [sym_identifier] = ACTIONS(3726),
    [anon_sym_LPAREN2] = ACTIONS(2856),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(3728),
    [anon_sym_COLON_COLON] = ACTIONS(2866),
    [anon_sym_LBRACE] = ACTIONS(3730),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(3732),
    [anon_sym_not] = ACTIONS(2860),
    [anon_sym_compl] = ACTIONS(2860),
    [anon_sym_DASH_DASH] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(2880),
    [anon_sym_sizeof] = ACTIONS(2882),
    [anon_sym___alignof__] = ACTIONS(2884),
    [anon_sym___alignof] = ACTIONS(2884),
    [anon_sym__alignof] = ACTIONS(2884),
    [anon_sym_alignof] = ACTIONS(2884),
    [anon_sym__Alignof] = ACTIONS(2884),
    [anon_sym_offsetof] = ACTIONS(2886),
    [anon_sym__Generic] = ACTIONS(2888),
    [anon_sym_asm] = ACTIONS(2890),
    [anon_sym___asm__] = ACTIONS(2890),
    [anon_sym___asm] = ACTIONS(2890),
    [sym_number_literal] = ACTIONS(2892),
    [anon_sym_L_SQUOTE] = ACTIONS(2894),
    [anon_sym_u_SQUOTE] = ACTIONS(2894),
    [anon_sym_U_SQUOTE] = ACTIONS(2894),
    [anon_sym_u8_SQUOTE] = ACTIONS(2894),
    [anon_sym_SQUOTE] = ACTIONS(2894),
    [anon_sym_L_DQUOTE] = ACTIONS(2896),
    [anon_sym_u_DQUOTE] = ACTIONS(2896),
    [anon_sym_U_DQUOTE] = ACTIONS(2896),
    [anon_sym_u8_DQUOTE] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [anon_sym_NULL] = ACTIONS(2900),
    [anon_sym_nullptr] = ACTIONS(2900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2910),
    [anon_sym_R_DQUOTE] = ACTIONS(2912),
    [anon_sym_LR_DQUOTE] = ACTIONS(2912),
    [anon_sym_uR_DQUOTE] = ACTIONS(2912),
    [anon_sym_UR_DQUOTE] = ACTIONS(2912),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2912),
    [anon_sym_co_await] = ACTIONS(2914),
    [anon_sym_new] = ACTIONS(2916),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2898),
  },
  [1052] = {
    [sym_expression] = STATE(4532),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8503),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4497),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(3714),
    [anon_sym_COLON_COLON] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_COLON] = ACTIONS(4548),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4476),
    [anon_sym_PLUS_PLUS] = ACTIONS(4476),
    [anon_sym_sizeof] = ACTIONS(3718),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3720),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3722),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1053] = {
    [sym_expression] = STATE(4507),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_initializer_list] = STATE(3842),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3740),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1054] = {
    [sym_expression] = STATE(4534),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(8533),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4497),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(3714),
    [anon_sym_COLON_COLON] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_COLON] = ACTIONS(4550),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4476),
    [anon_sym_PLUS_PLUS] = ACTIONS(4476),
    [anon_sym_sizeof] = ACTIONS(3718),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3720),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3722),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1055] = {
    [sym_expression] = STATE(4474),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_initializer_list] = STATE(7521),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1056] = {
    [sym_expression] = STATE(3540),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4552),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [1057] = {
    [sym_expression] = STATE(2342),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4424),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_RBRACK] = ACTIONS(4555),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1965),
    [anon_sym_compl] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_sizeof] = ACTIONS(1973),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1058] = {
    [sym_expression] = STATE(4303),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(7318),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1059] = {
    [sym_expression] = STATE(3532),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4557),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [1060] = {
    [sym_expression] = STATE(3139),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4560),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2029),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [1061] = {
    [sym_expression] = STATE(4678),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(4563),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1062] = {
    [sym_expression] = STATE(2342),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4424),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_RBRACK] = ACTIONS(4565),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1965),
    [anon_sym_compl] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_sizeof] = ACTIONS(1973),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1063] = {
    [sym_expression] = STATE(3138),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4567),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2029),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [1064] = {
    [sym_expression] = STATE(3727),
    [sym__string] = STATE(4345),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3286),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3286),
    [sym_call_expression] = STATE(3286),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3286),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3286),
    [sym_char_literal] = STATE(4345),
    [sym_concatenated_string] = STATE(4345),
    [sym_string_literal] = STATE(3370),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3370),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3286),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3286),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4570),
    [anon_sym_LPAREN2] = ACTIONS(4572),
    [anon_sym_BANG] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3496),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym___extension__] = ACTIONS(3500),
    [anon_sym_COLON_COLON] = ACTIONS(3502),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3496),
    [anon_sym_compl] = ACTIONS(3496),
    [anon_sym_DASH_DASH] = ACTIONS(4394),
    [anon_sym_PLUS_PLUS] = ACTIONS(4394),
    [anon_sym_sizeof] = ACTIONS(3504),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3506),
    [anon_sym_L_SQUOTE] = ACTIONS(3508),
    [anon_sym_u_SQUOTE] = ACTIONS(3508),
    [anon_sym_U_SQUOTE] = ACTIONS(3508),
    [anon_sym_u8_SQUOTE] = ACTIONS(3508),
    [anon_sym_SQUOTE] = ACTIONS(3508),
    [anon_sym_L_DQUOTE] = ACTIONS(3510),
    [anon_sym_u_DQUOTE] = ACTIONS(3510),
    [anon_sym_U_DQUOTE] = ACTIONS(3510),
    [anon_sym_u8_DQUOTE] = ACTIONS(3510),
    [anon_sym_DQUOTE] = ACTIONS(3510),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3512),
    [anon_sym_R_DQUOTE] = ACTIONS(3514),
    [anon_sym_LR_DQUOTE] = ACTIONS(3514),
    [anon_sym_uR_DQUOTE] = ACTIONS(3514),
    [anon_sym_UR_DQUOTE] = ACTIONS(3514),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3514),
    [anon_sym_co_await] = ACTIONS(3516),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1065] = {
    [sym_expression] = STATE(3134),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4574),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2029),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [1066] = {
    [sym_expression] = STATE(3533),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4577),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [1067] = {
    [sym_expression] = STATE(2342),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4424),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_RBRACK] = ACTIONS(4580),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1965),
    [anon_sym_compl] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_sizeof] = ACTIONS(1973),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1068] = {
    [sym_expression] = STATE(4703),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(4582),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1069] = {
    [sym_expression] = STATE(3136),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4577),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2029),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [1070] = {
    [sym_expression] = STATE(3727),
    [sym__string] = STATE(4127),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(2853),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(2853),
    [sym_call_expression] = STATE(2853),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(2853),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(2853),
    [sym_char_literal] = STATE(4127),
    [sym_concatenated_string] = STATE(4127),
    [sym_string_literal] = STATE(3058),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3058),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2853),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(2853),
    [sym_identifier] = ACTIONS(4470),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4570),
    [anon_sym_LPAREN2] = ACTIONS(4584),
    [anon_sym_BANG] = ACTIONS(3460),
    [anon_sym_TILDE] = ACTIONS(3460),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_AMP] = ACTIONS(4505),
    [anon_sym___extension__] = ACTIONS(3462),
    [anon_sym_COLON_COLON] = ACTIONS(3464),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3458),
    [anon_sym_compl] = ACTIONS(3458),
    [anon_sym_DASH_DASH] = ACTIONS(4472),
    [anon_sym_PLUS_PLUS] = ACTIONS(4472),
    [anon_sym_sizeof] = ACTIONS(3468),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3470),
    [anon_sym_L_SQUOTE] = ACTIONS(3472),
    [anon_sym_u_SQUOTE] = ACTIONS(3472),
    [anon_sym_U_SQUOTE] = ACTIONS(3472),
    [anon_sym_u8_SQUOTE] = ACTIONS(3472),
    [anon_sym_SQUOTE] = ACTIONS(3472),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3476),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
    [anon_sym_co_await] = ACTIONS(3480),
    [anon_sym_new] = ACTIONS(3482),
    [anon_sym_requires] = ACTIONS(3484),
    [sym_this] = ACTIONS(221),
  },
  [1071] = {
    [sym_expression] = STATE(3535),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4567),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [1072] = {
    [sym_expression] = STATE(3135),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4557),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2029),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [1073] = {
    [sym_expression] = STATE(2342),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4424),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_RBRACK] = ACTIONS(4586),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1965),
    [anon_sym_compl] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_sizeof] = ACTIONS(1973),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1074] = {
    [sym_expression] = STATE(3503),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4588),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [1075] = {
    [sym_expression] = STATE(3140),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4552),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2029),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [1076] = {
    [sym_expression] = STATE(2347),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4591),
    [anon_sym_LPAREN2] = ACTIONS(4593),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1965),
    [anon_sym_compl] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_sizeof] = ACTIONS(1973),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1077] = {
    [sym_expression] = STATE(2342),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4424),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_RBRACK] = ACTIONS(4595),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1965),
    [anon_sym_compl] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_sizeof] = ACTIONS(1973),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1078] = {
    [sym_expression] = STATE(4722),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(4597),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1079] = {
    [sym_expression] = STATE(3503),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4599),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [1080] = {
    [sym_expression] = STATE(3139),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4602),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2029),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [1081] = {
    [sym_expression] = STATE(4723),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(4605),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1082] = {
    [sym_expression] = STATE(4646),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4607),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1083] = {
    [sym_expression] = STATE(4250),
    [sym__string] = STATE(4345),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3286),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3286),
    [sym_call_expression] = STATE(3286),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3286),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3286),
    [sym_char_literal] = STATE(4345),
    [sym_concatenated_string] = STATE(4345),
    [sym_string_literal] = STATE(3370),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3370),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3286),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3286),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_LPAREN2] = ACTIONS(4388),
    [anon_sym_BANG] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3496),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym_SEMI] = ACTIONS(4609),
    [anon_sym___extension__] = ACTIONS(3500),
    [anon_sym_COLON_COLON] = ACTIONS(3502),
    [anon_sym_LBRACK] = ACTIONS(4611),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3496),
    [anon_sym_compl] = ACTIONS(3496),
    [anon_sym_DASH_DASH] = ACTIONS(4394),
    [anon_sym_PLUS_PLUS] = ACTIONS(4394),
    [anon_sym_sizeof] = ACTIONS(3504),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3506),
    [anon_sym_L_SQUOTE] = ACTIONS(3508),
    [anon_sym_u_SQUOTE] = ACTIONS(3508),
    [anon_sym_U_SQUOTE] = ACTIONS(3508),
    [anon_sym_u8_SQUOTE] = ACTIONS(3508),
    [anon_sym_SQUOTE] = ACTIONS(3508),
    [anon_sym_L_DQUOTE] = ACTIONS(3510),
    [anon_sym_u_DQUOTE] = ACTIONS(3510),
    [anon_sym_U_DQUOTE] = ACTIONS(3510),
    [anon_sym_u8_DQUOTE] = ACTIONS(3510),
    [anon_sym_DQUOTE] = ACTIONS(3510),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3512),
    [anon_sym_R_DQUOTE] = ACTIONS(3514),
    [anon_sym_LR_DQUOTE] = ACTIONS(3514),
    [anon_sym_uR_DQUOTE] = ACTIONS(3514),
    [anon_sym_UR_DQUOTE] = ACTIONS(3514),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3514),
    [anon_sym_co_await] = ACTIONS(3516),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1084] = {
    [sym_expression] = STATE(4554),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4613),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1085] = {
    [sym_expression] = STATE(4459),
    [sym__string] = STATE(4168),
    [sym_comma_expression] = STATE(7318),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4497),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(3714),
    [anon_sym_COLON_COLON] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4476),
    [anon_sym_PLUS_PLUS] = ACTIONS(4476),
    [anon_sym_sizeof] = ACTIONS(3718),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3720),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3722),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1086] = {
    [sym_expression] = STATE(2342),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4424),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_RBRACK] = ACTIONS(4615),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1965),
    [anon_sym_compl] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_sizeof] = ACTIONS(1973),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1087] = {
    [sym_expression] = STATE(3139),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4617),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2029),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [1088] = {
    [sym_expression] = STATE(3538),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4602),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [1089] = {
    [sym_expression] = STATE(3517),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4620),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [1090] = {
    [sym_expression] = STATE(2347),
    [sym__string] = STATE(3071),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(3071),
    [sym_concatenated_string] = STATE(3071),
    [sym_string_literal] = STATE(2243),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(2243),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1989),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4591),
    [anon_sym_LPAREN2] = ACTIONS(4623),
    [anon_sym_BANG] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1993),
    [anon_sym_DASH] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1991),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym___extension__] = ACTIONS(1995),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_compl] = ACTIONS(1991),
    [anon_sym_DASH_DASH] = ACTIONS(4480),
    [anon_sym_PLUS_PLUS] = ACTIONS(4480),
    [anon_sym_sizeof] = ACTIONS(1999),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(2001),
    [anon_sym_L_SQUOTE] = ACTIONS(2003),
    [anon_sym_u_SQUOTE] = ACTIONS(2003),
    [anon_sym_U_SQUOTE] = ACTIONS(2003),
    [anon_sym_u8_SQUOTE] = ACTIONS(2003),
    [anon_sym_SQUOTE] = ACTIONS(2003),
    [anon_sym_L_DQUOTE] = ACTIONS(2005),
    [anon_sym_u_DQUOTE] = ACTIONS(2005),
    [anon_sym_U_DQUOTE] = ACTIONS(2005),
    [anon_sym_u8_DQUOTE] = ACTIONS(2005),
    [anon_sym_DQUOTE] = ACTIONS(2005),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2007),
    [anon_sym_R_DQUOTE] = ACTIONS(2009),
    [anon_sym_LR_DQUOTE] = ACTIONS(2009),
    [anon_sym_uR_DQUOTE] = ACTIONS(2009),
    [anon_sym_UR_DQUOTE] = ACTIONS(2009),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2009),
    [anon_sym_co_await] = ACTIONS(2011),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1091] = {
    [sym_expression] = STATE(2342),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4424),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_RBRACK] = ACTIONS(4625),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1965),
    [anon_sym_compl] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_sizeof] = ACTIONS(1973),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1092] = {
    [sym_expression] = STATE(3504),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4627),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [1093] = {
    [sym_expression] = STATE(3600),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4630),
    [anon_sym_LPAREN2] = ACTIONS(4632),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [1094] = {
    [sym_expression] = STATE(3129),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4588),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2029),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [1095] = {
    [sym_expression] = STATE(3504),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4634),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [1096] = {
    [sym_expression] = STATE(3129),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4599),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2029),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [1097] = {
    [sym_expression] = STATE(3130),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4627),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2029),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [1098] = {
    [sym_expression] = STATE(4540),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4637),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1099] = {
    [sym_expression] = STATE(3132),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4639),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2029),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [1100] = {
    [sym_expression] = STATE(2342),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4424),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_RBRACK] = ACTIONS(4642),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1965),
    [anon_sym_compl] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_sizeof] = ACTIONS(1973),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1101] = {
    [sym_expression] = STATE(2342),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4424),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_RBRACK] = ACTIONS(4644),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1965),
    [anon_sym_compl] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_sizeof] = ACTIONS(1973),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1102] = {
    [sym_expression] = STATE(3130),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4634),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2029),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [1103] = {
    [sym_expression] = STATE(3248),
    [sym__string] = STATE(3374),
    [sym_conditional_expression] = STATE(3536),
    [sym_assignment_expression] = STATE(3536),
    [sym_pointer_expression] = STATE(3544),
    [sym_unary_expression] = STATE(3536),
    [sym_binary_expression] = STATE(3536),
    [sym_update_expression] = STATE(3536),
    [sym_cast_expression] = STATE(3536),
    [sym_sizeof_expression] = STATE(3536),
    [sym_alignof_expression] = STATE(3536),
    [sym_offsetof_expression] = STATE(3536),
    [sym_generic_expression] = STATE(3536),
    [sym_subscript_expression] = STATE(3544),
    [sym_call_expression] = STATE(3544),
    [sym_gnu_asm_expression] = STATE(3536),
    [sym_extension_expression] = STATE(3536),
    [sym_field_expression] = STATE(3544),
    [sym_compound_literal_expression] = STATE(3536),
    [sym_parenthesized_expression] = STATE(3544),
    [sym_char_literal] = STATE(3374),
    [sym_concatenated_string] = STATE(3374),
    [sym_string_literal] = STATE(2363),
    [sym_null] = STATE(3536),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7597),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3536),
    [sym_raw_string_literal] = STATE(2363),
    [sym_co_await_expression] = STATE(3536),
    [sym_new_expression] = STATE(3536),
    [sym_delete_expression] = STATE(3536),
    [sym_requires_clause] = STATE(3536),
    [sym_requires_expression] = STATE(3536),
    [sym_lambda_expression] = STATE(3536),
    [sym_lambda_capture_specifier] = STATE(5874),
    [sym_fold_expression] = STATE(3536),
    [sym_parameter_pack_expansion] = STATE(3536),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3544),
    [sym_qualified_type_identifier] = STATE(7597),
    [sym_user_defined_literal] = STATE(3544),
    [sym_identifier] = ACTIONS(2446),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4646),
    [anon_sym_LPAREN2] = ACTIONS(4648),
    [anon_sym_BANG] = ACTIONS(2450),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2448),
    [anon_sym_PLUS] = ACTIONS(2448),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(2452),
    [anon_sym_COLON_COLON] = ACTIONS(2454),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2458),
    [anon_sym_not] = ACTIONS(2448),
    [anon_sym_compl] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(4478),
    [anon_sym_PLUS_PLUS] = ACTIONS(4478),
    [anon_sym_sizeof] = ACTIONS(2460),
    [anon_sym___alignof__] = ACTIONS(2462),
    [anon_sym___alignof] = ACTIONS(2462),
    [anon_sym__alignof] = ACTIONS(2462),
    [anon_sym_alignof] = ACTIONS(2462),
    [anon_sym__Alignof] = ACTIONS(2462),
    [anon_sym_offsetof] = ACTIONS(2464),
    [anon_sym__Generic] = ACTIONS(2466),
    [anon_sym_asm] = ACTIONS(2468),
    [anon_sym___asm__] = ACTIONS(2468),
    [anon_sym___asm] = ACTIONS(2468),
    [sym_number_literal] = ACTIONS(2470),
    [anon_sym_L_SQUOTE] = ACTIONS(2472),
    [anon_sym_u_SQUOTE] = ACTIONS(2472),
    [anon_sym_U_SQUOTE] = ACTIONS(2472),
    [anon_sym_u8_SQUOTE] = ACTIONS(2472),
    [anon_sym_SQUOTE] = ACTIONS(2472),
    [anon_sym_L_DQUOTE] = ACTIONS(2474),
    [anon_sym_u_DQUOTE] = ACTIONS(2474),
    [anon_sym_U_DQUOTE] = ACTIONS(2474),
    [anon_sym_u8_DQUOTE] = ACTIONS(2474),
    [anon_sym_DQUOTE] = ACTIONS(2474),
    [sym_true] = ACTIONS(2476),
    [sym_false] = ACTIONS(2476),
    [anon_sym_NULL] = ACTIONS(2478),
    [anon_sym_nullptr] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2480),
    [anon_sym_R_DQUOTE] = ACTIONS(2482),
    [anon_sym_LR_DQUOTE] = ACTIONS(2482),
    [anon_sym_uR_DQUOTE] = ACTIONS(2482),
    [anon_sym_UR_DQUOTE] = ACTIONS(2482),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2482),
    [anon_sym_co_await] = ACTIONS(2484),
    [anon_sym_new] = ACTIONS(2486),
    [anon_sym_requires] = ACTIONS(2488),
    [sym_this] = ACTIONS(2476),
  },
  [1104] = {
    [sym_expression] = STATE(4569),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(4650),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1105] = {
    [sym_expression] = STATE(4556),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4652),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1106] = {
    [sym_expression] = STATE(3100),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4654),
    [anon_sym_LPAREN2] = ACTIONS(4656),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2029),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [1107] = {
    [sym_expression] = STATE(3504),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4658),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [1108] = {
    [sym_expression] = STATE(4574),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4661),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1109] = {
    [sym_expression] = STATE(4570),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(4663),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1110] = {
    [sym_expression] = STATE(3515),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4665),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [1111] = {
    [sym_expression] = STATE(4594),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4668),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1112] = {
    [sym_expression] = STATE(2342),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4424),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_RBRACK] = ACTIONS(4670),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1965),
    [anon_sym_compl] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_sizeof] = ACTIONS(1973),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1113] = {
    [sym_expression] = STATE(2342),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4424),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_RBRACK] = ACTIONS(4672),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1965),
    [anon_sym_compl] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_sizeof] = ACTIONS(1973),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1114] = {
    [sym_expression] = STATE(4554),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4674),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1115] = {
    [sym_expression] = STATE(2342),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4424),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_RBRACK] = ACTIONS(4676),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1965),
    [anon_sym_compl] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_sizeof] = ACTIONS(1973),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1116] = {
    [sym_expression] = STATE(3727),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4570),
    [anon_sym_LPAREN2] = ACTIONS(4678),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1117] = {
    [sym_expression] = STATE(4609),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4680),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1118] = {
    [sym_expression] = STATE(3515),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4639),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [1119] = {
    [sym_expression] = STATE(3130),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4658),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2029),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [1120] = {
    [sym_expression] = STATE(4616),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4682),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1121] = {
    [sym_expression] = STATE(3132),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4665),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2029),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [1122] = {
    [sym_expression] = STATE(4620),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4684),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1123] = {
    [sym_expression] = STATE(3133),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4686),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2029),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [1124] = {
    [sym_expression] = STATE(4250),
    [sym__string] = STATE(4345),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3286),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3286),
    [sym_call_expression] = STATE(3286),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3286),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3286),
    [sym_char_literal] = STATE(4345),
    [sym_concatenated_string] = STATE(4345),
    [sym_string_literal] = STATE(3370),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3370),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3286),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3286),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_LPAREN2] = ACTIONS(4388),
    [anon_sym_BANG] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3496),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym_SEMI] = ACTIONS(4689),
    [anon_sym___extension__] = ACTIONS(3500),
    [anon_sym_COLON_COLON] = ACTIONS(3502),
    [anon_sym_LBRACK] = ACTIONS(4611),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3496),
    [anon_sym_compl] = ACTIONS(3496),
    [anon_sym_DASH_DASH] = ACTIONS(4394),
    [anon_sym_PLUS_PLUS] = ACTIONS(4394),
    [anon_sym_sizeof] = ACTIONS(3504),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3506),
    [anon_sym_L_SQUOTE] = ACTIONS(3508),
    [anon_sym_u_SQUOTE] = ACTIONS(3508),
    [anon_sym_U_SQUOTE] = ACTIONS(3508),
    [anon_sym_u8_SQUOTE] = ACTIONS(3508),
    [anon_sym_SQUOTE] = ACTIONS(3508),
    [anon_sym_L_DQUOTE] = ACTIONS(3510),
    [anon_sym_u_DQUOTE] = ACTIONS(3510),
    [anon_sym_U_DQUOTE] = ACTIONS(3510),
    [anon_sym_u8_DQUOTE] = ACTIONS(3510),
    [anon_sym_DQUOTE] = ACTIONS(3510),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3512),
    [anon_sym_R_DQUOTE] = ACTIONS(3514),
    [anon_sym_LR_DQUOTE] = ACTIONS(3514),
    [anon_sym_uR_DQUOTE] = ACTIONS(3514),
    [anon_sym_UR_DQUOTE] = ACTIONS(3514),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3514),
    [anon_sym_co_await] = ACTIONS(3516),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1125] = {
    [sym_expression] = STATE(4529),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4570),
    [anon_sym_LPAREN2] = ACTIONS(4691),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(3714),
    [anon_sym_COLON_COLON] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4476),
    [anon_sym_PLUS_PLUS] = ACTIONS(4476),
    [anon_sym_sizeof] = ACTIONS(3718),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3720),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3722),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1126] = {
    [sym_expression] = STATE(3134),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4693),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2029),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [1127] = {
    [sym_expression] = STATE(2342),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4424),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_RBRACK] = ACTIONS(4696),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1965),
    [anon_sym_compl] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_sizeof] = ACTIONS(1973),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1128] = {
    [sym_expression] = STATE(3517),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4686),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [1129] = {
    [sym_expression] = STATE(2347),
    [sym__string] = STATE(2808),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2808),
    [sym_concatenated_string] = STATE(2808),
    [sym_string_literal] = STATE(1900),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1900),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4591),
    [anon_sym_LPAREN2] = ACTIONS(4698),
    [anon_sym_BANG] = ACTIONS(1921),
    [anon_sym_TILDE] = ACTIONS(1921),
    [anon_sym_DASH] = ACTIONS(1919),
    [anon_sym_PLUS] = ACTIONS(1919),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_AMP] = ACTIONS(4505),
    [anon_sym___extension__] = ACTIONS(1923),
    [anon_sym_COLON_COLON] = ACTIONS(1925),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1919),
    [anon_sym_compl] = ACTIONS(1919),
    [anon_sym_DASH_DASH] = ACTIONS(4491),
    [anon_sym_PLUS_PLUS] = ACTIONS(4491),
    [anon_sym_sizeof] = ACTIONS(1931),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1953),
    [anon_sym_R_DQUOTE] = ACTIONS(1955),
    [anon_sym_LR_DQUOTE] = ACTIONS(1955),
    [anon_sym_uR_DQUOTE] = ACTIONS(1955),
    [anon_sym_UR_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1955),
    [anon_sym_co_await] = ACTIONS(1957),
    [anon_sym_new] = ACTIONS(1959),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1130] = {
    [sym_expression] = STATE(3531),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4693),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [1131] = {
    [sym_expression] = STATE(3139),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4700),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2029),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [1132] = {
    [sym_expression] = STATE(3264),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4591),
    [anon_sym_LPAREN2] = ACTIONS(4703),
    [anon_sym_BANG] = ACTIONS(2498),
    [anon_sym_TILDE] = ACTIONS(2498),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(2500),
    [anon_sym_COLON_COLON] = ACTIONS(2502),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(2496),
    [anon_sym_compl] = ACTIONS(2496),
    [anon_sym_DASH_DASH] = ACTIONS(4493),
    [anon_sym_PLUS_PLUS] = ACTIONS(4493),
    [anon_sym_sizeof] = ACTIONS(2504),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2506),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(2508),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1133] = {
    [sym_expression] = STATE(4591),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(4705),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1134] = {
    [sym_expression] = STATE(2342),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4424),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_RBRACK] = ACTIONS(4707),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1965),
    [anon_sym_compl] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_sizeof] = ACTIONS(1973),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1135] = {
    [sym_expression] = STATE(3532),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4709),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [1136] = {
    [sym_expression] = STATE(3135),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4709),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2029),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [1137] = {
    [sym_expression] = STATE(4250),
    [sym__string] = STATE(4345),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3286),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3286),
    [sym_call_expression] = STATE(3286),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3286),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3286),
    [sym_char_literal] = STATE(4345),
    [sym_concatenated_string] = STATE(4345),
    [sym_string_literal] = STATE(3370),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3370),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3286),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3286),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_LPAREN2] = ACTIONS(4388),
    [anon_sym_BANG] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3496),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym_SEMI] = ACTIONS(4712),
    [anon_sym___extension__] = ACTIONS(3500),
    [anon_sym_COLON_COLON] = ACTIONS(3502),
    [anon_sym_LBRACK] = ACTIONS(4611),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3496),
    [anon_sym_compl] = ACTIONS(3496),
    [anon_sym_DASH_DASH] = ACTIONS(4394),
    [anon_sym_PLUS_PLUS] = ACTIONS(4394),
    [anon_sym_sizeof] = ACTIONS(3504),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3506),
    [anon_sym_L_SQUOTE] = ACTIONS(3508),
    [anon_sym_u_SQUOTE] = ACTIONS(3508),
    [anon_sym_U_SQUOTE] = ACTIONS(3508),
    [anon_sym_u8_SQUOTE] = ACTIONS(3508),
    [anon_sym_SQUOTE] = ACTIONS(3508),
    [anon_sym_L_DQUOTE] = ACTIONS(3510),
    [anon_sym_u_DQUOTE] = ACTIONS(3510),
    [anon_sym_U_DQUOTE] = ACTIONS(3510),
    [anon_sym_u8_DQUOTE] = ACTIONS(3510),
    [anon_sym_DQUOTE] = ACTIONS(3510),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3512),
    [anon_sym_R_DQUOTE] = ACTIONS(3514),
    [anon_sym_LR_DQUOTE] = ACTIONS(3514),
    [anon_sym_uR_DQUOTE] = ACTIONS(3514),
    [anon_sym_UR_DQUOTE] = ACTIONS(3514),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3514),
    [anon_sym_co_await] = ACTIONS(3516),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1138] = {
    [sym_expression] = STATE(3533),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4714),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [1139] = {
    [sym_expression] = STATE(4595),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(4717),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1140] = {
    [sym_expression] = STATE(4456),
    [sym__string] = STATE(4637),
    [sym_conditional_expression] = STATE(4735),
    [sym_assignment_expression] = STATE(4735),
    [sym_pointer_expression] = STATE(3573),
    [sym_unary_expression] = STATE(4735),
    [sym_binary_expression] = STATE(4735),
    [sym_update_expression] = STATE(4735),
    [sym_cast_expression] = STATE(4735),
    [sym_sizeof_expression] = STATE(4735),
    [sym_alignof_expression] = STATE(4735),
    [sym_offsetof_expression] = STATE(4735),
    [sym_generic_expression] = STATE(4735),
    [sym_subscript_expression] = STATE(3573),
    [sym_call_expression] = STATE(3573),
    [sym_gnu_asm_expression] = STATE(4735),
    [sym_extension_expression] = STATE(4735),
    [sym_field_expression] = STATE(3573),
    [sym_compound_literal_expression] = STATE(4735),
    [sym_parenthesized_expression] = STATE(3573),
    [sym_char_literal] = STATE(4637),
    [sym_concatenated_string] = STATE(4637),
    [sym_string_literal] = STATE(3662),
    [sym_null] = STATE(4735),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7513),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(4735),
    [sym_raw_string_literal] = STATE(3662),
    [sym_co_await_expression] = STATE(4735),
    [sym_new_expression] = STATE(4735),
    [sym_delete_expression] = STATE(4735),
    [sym_requires_clause] = STATE(4735),
    [sym_requires_expression] = STATE(4735),
    [sym_lambda_expression] = STATE(4735),
    [sym_lambda_capture_specifier] = STATE(5854),
    [sym_fold_expression] = STATE(4735),
    [sym_parameter_pack_expansion] = STATE(4735),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3573),
    [sym_qualified_type_identifier] = STATE(7513),
    [sym_user_defined_literal] = STATE(3573),
    [sym_identifier] = ACTIONS(3726),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4719),
    [anon_sym_LPAREN2] = ACTIONS(4721),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(3728),
    [anon_sym_COLON_COLON] = ACTIONS(2866),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(3732),
    [anon_sym_not] = ACTIONS(2860),
    [anon_sym_compl] = ACTIONS(2860),
    [anon_sym_DASH_DASH] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(2880),
    [anon_sym_sizeof] = ACTIONS(2882),
    [anon_sym___alignof__] = ACTIONS(2884),
    [anon_sym___alignof] = ACTIONS(2884),
    [anon_sym__alignof] = ACTIONS(2884),
    [anon_sym_alignof] = ACTIONS(2884),
    [anon_sym__Alignof] = ACTIONS(2884),
    [anon_sym_offsetof] = ACTIONS(2886),
    [anon_sym__Generic] = ACTIONS(2888),
    [anon_sym_asm] = ACTIONS(2890),
    [anon_sym___asm__] = ACTIONS(2890),
    [anon_sym___asm] = ACTIONS(2890),
    [sym_number_literal] = ACTIONS(2892),
    [anon_sym_L_SQUOTE] = ACTIONS(2894),
    [anon_sym_u_SQUOTE] = ACTIONS(2894),
    [anon_sym_U_SQUOTE] = ACTIONS(2894),
    [anon_sym_u8_SQUOTE] = ACTIONS(2894),
    [anon_sym_SQUOTE] = ACTIONS(2894),
    [anon_sym_L_DQUOTE] = ACTIONS(2896),
    [anon_sym_u_DQUOTE] = ACTIONS(2896),
    [anon_sym_U_DQUOTE] = ACTIONS(2896),
    [anon_sym_u8_DQUOTE] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [anon_sym_NULL] = ACTIONS(2900),
    [anon_sym_nullptr] = ACTIONS(2900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2910),
    [anon_sym_R_DQUOTE] = ACTIONS(2912),
    [anon_sym_LR_DQUOTE] = ACTIONS(2912),
    [anon_sym_uR_DQUOTE] = ACTIONS(2912),
    [anon_sym_UR_DQUOTE] = ACTIONS(2912),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2912),
    [anon_sym_co_await] = ACTIONS(2914),
    [anon_sym_new] = ACTIONS(2916),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2898),
  },
  [1141] = {
    [sym_expression] = STATE(4551),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(4723),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1142] = {
    [sym_expression] = STATE(2342),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4424),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_RBRACK] = ACTIONS(4725),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1965),
    [anon_sym_compl] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_sizeof] = ACTIONS(1973),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1143] = {
    [sym_expression] = STATE(3140),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4727),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2029),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [1144] = {
    [sym_expression] = STATE(2342),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4424),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_RBRACK] = ACTIONS(4730),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1965),
    [anon_sym_compl] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_sizeof] = ACTIONS(1973),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1145] = {
    [sym_expression] = STATE(3136),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4714),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2029),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [1146] = {
    [sym_expression] = STATE(3138),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4732),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2029),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [1147] = {
    [sym_expression] = STATE(3133),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4620),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2029),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [1148] = {
    [sym_expression] = STATE(3531),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4574),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [1149] = {
    [sym_expression] = STATE(2342),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4424),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_RBRACK] = ACTIONS(4735),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1965),
    [anon_sym_compl] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_sizeof] = ACTIONS(1973),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1150] = {
    [sym_expression] = STATE(2342),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4424),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_RBRACK] = ACTIONS(4737),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1965),
    [anon_sym_compl] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_sizeof] = ACTIONS(1973),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1151] = {
    [sym_expression] = STATE(3727),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4570),
    [anon_sym_LPAREN2] = ACTIONS(4739),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3740),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1152] = {
    [sym_expression] = STATE(3538),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4560),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [1153] = {
    [sym_expression] = STATE(4552),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym_SEMI] = ACTIONS(4741),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1154] = {
    [sym_expression] = STATE(3138),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4743),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2029),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [1155] = {
    [sym_expression] = STATE(3535),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4732),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [1156] = {
    [sym_expression] = STATE(3535),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4743),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [1157] = {
    [sym_expression] = STATE(3538),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4700),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [1158] = {
    [sym_expression] = STATE(2342),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4424),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_RBRACK] = ACTIONS(4746),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1965),
    [anon_sym_compl] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_sizeof] = ACTIONS(1973),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1159] = {
    [sym_expression] = STATE(2342),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4424),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [anon_sym_RBRACK] = ACTIONS(4748),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1965),
    [anon_sym_compl] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_sizeof] = ACTIONS(1973),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1160] = {
    [sym_expression] = STATE(4720),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_RPAREN] = ACTIONS(4750),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1161] = {
    [sym_expression] = STATE(3538),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4617),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [1162] = {
    [sym_expression] = STATE(3540),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4727),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [1163] = {
    [sym_expression] = STATE(4550),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4497),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(3714),
    [anon_sym_COLON_COLON] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4476),
    [anon_sym_PLUS_PLUS] = ACTIONS(4476),
    [anon_sym_sizeof] = ACTIONS(3718),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3720),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3722),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1164] = {
    [sym_expression] = STATE(4730),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1165] = {
    [sym_expression] = STATE(2904),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4424),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(4752),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1965),
    [anon_sym_compl] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_sizeof] = ACTIONS(1973),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1166] = {
    [sym_expression] = STATE(2327),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4424),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1965),
    [anon_sym_compl] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_sizeof] = ACTIONS(1973),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1167] = {
    [sym_expression] = STATE(4657),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1168] = {
    [sym_expression] = STATE(3153),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2029),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [1169] = {
    [sym_expression] = STATE(2924),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4424),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(4754),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1965),
    [anon_sym_compl] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_sizeof] = ACTIONS(1973),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1170] = {
    [sym_expression] = STATE(4526),
    [sym__string] = STATE(4637),
    [sym_conditional_expression] = STATE(4735),
    [sym_assignment_expression] = STATE(4735),
    [sym_pointer_expression] = STATE(3573),
    [sym_unary_expression] = STATE(4735),
    [sym_binary_expression] = STATE(4735),
    [sym_update_expression] = STATE(4735),
    [sym_cast_expression] = STATE(4735),
    [sym_sizeof_expression] = STATE(4735),
    [sym_alignof_expression] = STATE(4735),
    [sym_offsetof_expression] = STATE(4735),
    [sym_generic_expression] = STATE(4735),
    [sym_subscript_expression] = STATE(3573),
    [sym_call_expression] = STATE(3573),
    [sym_gnu_asm_expression] = STATE(4735),
    [sym_extension_expression] = STATE(4735),
    [sym_field_expression] = STATE(3573),
    [sym_compound_literal_expression] = STATE(4735),
    [sym_parenthesized_expression] = STATE(3573),
    [sym_char_literal] = STATE(4637),
    [sym_concatenated_string] = STATE(4637),
    [sym_string_literal] = STATE(3662),
    [sym_null] = STATE(4735),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7513),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(4735),
    [sym_raw_string_literal] = STATE(3662),
    [sym_co_await_expression] = STATE(4735),
    [sym_new_expression] = STATE(4735),
    [sym_delete_expression] = STATE(4735),
    [sym_requires_clause] = STATE(4735),
    [sym_requires_expression] = STATE(4735),
    [sym_lambda_expression] = STATE(4735),
    [sym_lambda_capture_specifier] = STATE(5854),
    [sym_fold_expression] = STATE(4735),
    [sym_parameter_pack_expansion] = STATE(4735),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3573),
    [sym_qualified_type_identifier] = STATE(7513),
    [sym_user_defined_literal] = STATE(3573),
    [sym_identifier] = ACTIONS(3726),
    [anon_sym_LPAREN2] = ACTIONS(2856),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(3728),
    [anon_sym_COLON_COLON] = ACTIONS(2866),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(3732),
    [anon_sym_not] = ACTIONS(2860),
    [anon_sym_compl] = ACTIONS(2860),
    [anon_sym_DASH_DASH] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(2880),
    [anon_sym_sizeof] = ACTIONS(2882),
    [anon_sym___alignof__] = ACTIONS(2884),
    [anon_sym___alignof] = ACTIONS(2884),
    [anon_sym__alignof] = ACTIONS(2884),
    [anon_sym_alignof] = ACTIONS(2884),
    [anon_sym__Alignof] = ACTIONS(2884),
    [anon_sym_offsetof] = ACTIONS(2886),
    [anon_sym__Generic] = ACTIONS(2888),
    [anon_sym_asm] = ACTIONS(2890),
    [anon_sym___asm__] = ACTIONS(2890),
    [anon_sym___asm] = ACTIONS(2890),
    [sym_number_literal] = ACTIONS(2892),
    [anon_sym_L_SQUOTE] = ACTIONS(2894),
    [anon_sym_u_SQUOTE] = ACTIONS(2894),
    [anon_sym_U_SQUOTE] = ACTIONS(2894),
    [anon_sym_u8_SQUOTE] = ACTIONS(2894),
    [anon_sym_SQUOTE] = ACTIONS(2894),
    [anon_sym_L_DQUOTE] = ACTIONS(2896),
    [anon_sym_u_DQUOTE] = ACTIONS(2896),
    [anon_sym_U_DQUOTE] = ACTIONS(2896),
    [anon_sym_u8_DQUOTE] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [anon_sym_NULL] = ACTIONS(2900),
    [anon_sym_nullptr] = ACTIONS(2900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2910),
    [anon_sym_R_DQUOTE] = ACTIONS(2912),
    [anon_sym_LR_DQUOTE] = ACTIONS(2912),
    [anon_sym_uR_DQUOTE] = ACTIONS(2912),
    [anon_sym_UR_DQUOTE] = ACTIONS(2912),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2912),
    [anon_sym_co_await] = ACTIONS(2914),
    [anon_sym_new] = ACTIONS(2916),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2898),
  },
  [1171] = {
    [sym_expression] = STATE(3129),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2029),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [1172] = {
    [sym_expression] = STATE(3130),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2029),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [1173] = {
    [sym_expression] = STATE(3132),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2029),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [1174] = {
    [sym_expression] = STATE(3133),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2029),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [1175] = {
    [sym_expression] = STATE(3134),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2029),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [1176] = {
    [sym_expression] = STATE(3135),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2029),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [1177] = {
    [sym_expression] = STATE(3136),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2029),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [1178] = {
    [sym_expression] = STATE(3138),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2029),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [1179] = {
    [sym_expression] = STATE(3139),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2029),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [1180] = {
    [sym_expression] = STATE(3140),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2029),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [1181] = {
    [sym_expression] = STATE(2864),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4424),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1965),
    [anon_sym_compl] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_sizeof] = ACTIONS(1973),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1182] = {
    [sym_expression] = STATE(4242),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(4756),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1183] = {
    [sym_expression] = STATE(3706),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1184] = {
    [sym_expression] = STATE(4261),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(4758),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1185] = {
    [sym_expression] = STATE(4704),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1186] = {
    [sym_expression] = STATE(3653),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1187] = {
    [sym_expression] = STATE(2836),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4424),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1965),
    [anon_sym_compl] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_sizeof] = ACTIONS(1973),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1188] = {
    [sym_expression] = STATE(4215),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1189] = {
    [sym_expression] = STATE(4713),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1190] = {
    [sym_expression] = STATE(4420),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3740),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1191] = {
    [sym_expression] = STATE(2847),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4424),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1965),
    [anon_sym_compl] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_sizeof] = ACTIONS(1973),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1192] = {
    [sym_expression] = STATE(4554),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1193] = {
    [sym_expression] = STATE(4216),
    [sym__string] = STATE(4345),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3286),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3286),
    [sym_call_expression] = STATE(3286),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3286),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3286),
    [sym_char_literal] = STATE(4345),
    [sym_concatenated_string] = STATE(4345),
    [sym_string_literal] = STATE(3370),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3370),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3286),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3286),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_LPAREN2] = ACTIONS(4388),
    [anon_sym_BANG] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3496),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym___extension__] = ACTIONS(3500),
    [anon_sym_COLON_COLON] = ACTIONS(3502),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3496),
    [anon_sym_compl] = ACTIONS(3496),
    [anon_sym_DASH_DASH] = ACTIONS(4394),
    [anon_sym_PLUS_PLUS] = ACTIONS(4394),
    [anon_sym_sizeof] = ACTIONS(3504),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3506),
    [anon_sym_L_SQUOTE] = ACTIONS(3508),
    [anon_sym_u_SQUOTE] = ACTIONS(3508),
    [anon_sym_U_SQUOTE] = ACTIONS(3508),
    [anon_sym_u8_SQUOTE] = ACTIONS(3508),
    [anon_sym_SQUOTE] = ACTIONS(3508),
    [anon_sym_L_DQUOTE] = ACTIONS(3510),
    [anon_sym_u_DQUOTE] = ACTIONS(3510),
    [anon_sym_U_DQUOTE] = ACTIONS(3510),
    [anon_sym_u8_DQUOTE] = ACTIONS(3510),
    [anon_sym_DQUOTE] = ACTIONS(3510),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3512),
    [anon_sym_R_DQUOTE] = ACTIONS(3514),
    [anon_sym_LR_DQUOTE] = ACTIONS(3514),
    [anon_sym_uR_DQUOTE] = ACTIONS(3514),
    [anon_sym_UR_DQUOTE] = ACTIONS(3514),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3514),
    [anon_sym_co_await] = ACTIONS(3516),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1194] = {
    [sym_expression] = STATE(4365),
    [sym__string] = STATE(4637),
    [sym_conditional_expression] = STATE(4735),
    [sym_assignment_expression] = STATE(4735),
    [sym_pointer_expression] = STATE(3573),
    [sym_unary_expression] = STATE(4735),
    [sym_binary_expression] = STATE(4735),
    [sym_update_expression] = STATE(4735),
    [sym_cast_expression] = STATE(4735),
    [sym_sizeof_expression] = STATE(4735),
    [sym_alignof_expression] = STATE(4735),
    [sym_offsetof_expression] = STATE(4735),
    [sym_generic_expression] = STATE(4735),
    [sym_subscript_expression] = STATE(3573),
    [sym_call_expression] = STATE(3573),
    [sym_gnu_asm_expression] = STATE(4735),
    [sym_extension_expression] = STATE(4735),
    [sym_field_expression] = STATE(3573),
    [sym_compound_literal_expression] = STATE(4735),
    [sym_parenthesized_expression] = STATE(3573),
    [sym_char_literal] = STATE(4637),
    [sym_concatenated_string] = STATE(4637),
    [sym_string_literal] = STATE(3662),
    [sym_null] = STATE(4735),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7513),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(4735),
    [sym_raw_string_literal] = STATE(3662),
    [sym_co_await_expression] = STATE(4735),
    [sym_new_expression] = STATE(4735),
    [sym_delete_expression] = STATE(4735),
    [sym_requires_clause] = STATE(4735),
    [sym_requires_expression] = STATE(4735),
    [sym_lambda_expression] = STATE(4735),
    [sym_lambda_capture_specifier] = STATE(5854),
    [sym_fold_expression] = STATE(4735),
    [sym_parameter_pack_expansion] = STATE(4735),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3573),
    [sym_qualified_type_identifier] = STATE(7513),
    [sym_user_defined_literal] = STATE(3573),
    [sym_identifier] = ACTIONS(3726),
    [anon_sym_LPAREN2] = ACTIONS(2856),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(3728),
    [anon_sym_COLON_COLON] = ACTIONS(2866),
    [anon_sym_LBRACK] = ACTIONS(4760),
    [sym_primitive_type] = ACTIONS(3732),
    [anon_sym_not] = ACTIONS(2860),
    [anon_sym_compl] = ACTIONS(2860),
    [anon_sym_DASH_DASH] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(2880),
    [anon_sym_sizeof] = ACTIONS(2882),
    [anon_sym___alignof__] = ACTIONS(2884),
    [anon_sym___alignof] = ACTIONS(2884),
    [anon_sym__alignof] = ACTIONS(2884),
    [anon_sym_alignof] = ACTIONS(2884),
    [anon_sym__Alignof] = ACTIONS(2884),
    [anon_sym_offsetof] = ACTIONS(2886),
    [anon_sym__Generic] = ACTIONS(2888),
    [anon_sym_asm] = ACTIONS(2890),
    [anon_sym___asm__] = ACTIONS(2890),
    [anon_sym___asm] = ACTIONS(2890),
    [sym_number_literal] = ACTIONS(2892),
    [anon_sym_L_SQUOTE] = ACTIONS(2894),
    [anon_sym_u_SQUOTE] = ACTIONS(2894),
    [anon_sym_U_SQUOTE] = ACTIONS(2894),
    [anon_sym_u8_SQUOTE] = ACTIONS(2894),
    [anon_sym_SQUOTE] = ACTIONS(2894),
    [anon_sym_L_DQUOTE] = ACTIONS(2896),
    [anon_sym_u_DQUOTE] = ACTIONS(2896),
    [anon_sym_U_DQUOTE] = ACTIONS(2896),
    [anon_sym_u8_DQUOTE] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [anon_sym_NULL] = ACTIONS(2900),
    [anon_sym_nullptr] = ACTIONS(2900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2910),
    [anon_sym_R_DQUOTE] = ACTIONS(2912),
    [anon_sym_LR_DQUOTE] = ACTIONS(2912),
    [anon_sym_uR_DQUOTE] = ACTIONS(2912),
    [anon_sym_UR_DQUOTE] = ACTIONS(2912),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2912),
    [anon_sym_co_await] = ACTIONS(2914),
    [anon_sym_new] = ACTIONS(2916),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2898),
  },
  [1195] = {
    [sym_expression] = STATE(4367),
    [sym__string] = STATE(4637),
    [sym_conditional_expression] = STATE(4735),
    [sym_assignment_expression] = STATE(4735),
    [sym_pointer_expression] = STATE(3573),
    [sym_unary_expression] = STATE(4735),
    [sym_binary_expression] = STATE(4735),
    [sym_update_expression] = STATE(4735),
    [sym_cast_expression] = STATE(4735),
    [sym_sizeof_expression] = STATE(4735),
    [sym_alignof_expression] = STATE(4735),
    [sym_offsetof_expression] = STATE(4735),
    [sym_generic_expression] = STATE(4735),
    [sym_subscript_expression] = STATE(3573),
    [sym_call_expression] = STATE(3573),
    [sym_gnu_asm_expression] = STATE(4735),
    [sym_extension_expression] = STATE(4735),
    [sym_field_expression] = STATE(3573),
    [sym_compound_literal_expression] = STATE(4735),
    [sym_parenthesized_expression] = STATE(3573),
    [sym_char_literal] = STATE(4637),
    [sym_concatenated_string] = STATE(4637),
    [sym_string_literal] = STATE(3662),
    [sym_null] = STATE(4735),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7513),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(4735),
    [sym_raw_string_literal] = STATE(3662),
    [sym_co_await_expression] = STATE(4735),
    [sym_new_expression] = STATE(4735),
    [sym_delete_expression] = STATE(4735),
    [sym_requires_clause] = STATE(4735),
    [sym_requires_expression] = STATE(4735),
    [sym_lambda_expression] = STATE(4735),
    [sym_lambda_capture_specifier] = STATE(5854),
    [sym_fold_expression] = STATE(4735),
    [sym_parameter_pack_expansion] = STATE(4735),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3573),
    [sym_qualified_type_identifier] = STATE(7513),
    [sym_user_defined_literal] = STATE(3573),
    [sym_identifier] = ACTIONS(3726),
    [anon_sym_LPAREN2] = ACTIONS(2856),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(3728),
    [anon_sym_COLON_COLON] = ACTIONS(2866),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(3732),
    [anon_sym_not] = ACTIONS(2860),
    [anon_sym_compl] = ACTIONS(2860),
    [anon_sym_DASH_DASH] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(2880),
    [anon_sym_sizeof] = ACTIONS(2882),
    [anon_sym___alignof__] = ACTIONS(2884),
    [anon_sym___alignof] = ACTIONS(2884),
    [anon_sym__alignof] = ACTIONS(2884),
    [anon_sym_alignof] = ACTIONS(2884),
    [anon_sym__Alignof] = ACTIONS(2884),
    [anon_sym_offsetof] = ACTIONS(2886),
    [anon_sym__Generic] = ACTIONS(2888),
    [anon_sym_asm] = ACTIONS(2890),
    [anon_sym___asm__] = ACTIONS(2890),
    [anon_sym___asm] = ACTIONS(2890),
    [sym_number_literal] = ACTIONS(2892),
    [anon_sym_L_SQUOTE] = ACTIONS(2894),
    [anon_sym_u_SQUOTE] = ACTIONS(2894),
    [anon_sym_U_SQUOTE] = ACTIONS(2894),
    [anon_sym_u8_SQUOTE] = ACTIONS(2894),
    [anon_sym_SQUOTE] = ACTIONS(2894),
    [anon_sym_L_DQUOTE] = ACTIONS(2896),
    [anon_sym_u_DQUOTE] = ACTIONS(2896),
    [anon_sym_U_DQUOTE] = ACTIONS(2896),
    [anon_sym_u8_DQUOTE] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [anon_sym_NULL] = ACTIONS(2900),
    [anon_sym_nullptr] = ACTIONS(2900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2910),
    [anon_sym_R_DQUOTE] = ACTIONS(2912),
    [anon_sym_LR_DQUOTE] = ACTIONS(2912),
    [anon_sym_uR_DQUOTE] = ACTIONS(2912),
    [anon_sym_UR_DQUOTE] = ACTIONS(2912),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2912),
    [anon_sym_co_await] = ACTIONS(2914),
    [anon_sym_new] = ACTIONS(2916),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2898),
  },
  [1196] = {
    [sym_expression] = STATE(3580),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [1197] = {
    [sym_expression] = STATE(4413),
    [sym__string] = STATE(4637),
    [sym_conditional_expression] = STATE(4735),
    [sym_assignment_expression] = STATE(4735),
    [sym_pointer_expression] = STATE(3573),
    [sym_unary_expression] = STATE(4735),
    [sym_binary_expression] = STATE(4735),
    [sym_update_expression] = STATE(4735),
    [sym_cast_expression] = STATE(4735),
    [sym_sizeof_expression] = STATE(4735),
    [sym_alignof_expression] = STATE(4735),
    [sym_offsetof_expression] = STATE(4735),
    [sym_generic_expression] = STATE(4735),
    [sym_subscript_expression] = STATE(3573),
    [sym_call_expression] = STATE(3573),
    [sym_gnu_asm_expression] = STATE(4735),
    [sym_extension_expression] = STATE(4735),
    [sym_field_expression] = STATE(3573),
    [sym_compound_literal_expression] = STATE(4735),
    [sym_parenthesized_expression] = STATE(3573),
    [sym_char_literal] = STATE(4637),
    [sym_concatenated_string] = STATE(4637),
    [sym_string_literal] = STATE(3662),
    [sym_null] = STATE(4735),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7513),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(4735),
    [sym_raw_string_literal] = STATE(3662),
    [sym_co_await_expression] = STATE(4735),
    [sym_new_expression] = STATE(4735),
    [sym_delete_expression] = STATE(4735),
    [sym_requires_clause] = STATE(4735),
    [sym_requires_expression] = STATE(4735),
    [sym_lambda_expression] = STATE(4735),
    [sym_lambda_capture_specifier] = STATE(5854),
    [sym_fold_expression] = STATE(4735),
    [sym_parameter_pack_expansion] = STATE(4735),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3573),
    [sym_qualified_type_identifier] = STATE(7513),
    [sym_user_defined_literal] = STATE(3573),
    [sym_identifier] = ACTIONS(3726),
    [anon_sym_LPAREN2] = ACTIONS(2856),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(3728),
    [anon_sym_COLON_COLON] = ACTIONS(2866),
    [anon_sym_LBRACK] = ACTIONS(4762),
    [sym_primitive_type] = ACTIONS(3732),
    [anon_sym_not] = ACTIONS(2860),
    [anon_sym_compl] = ACTIONS(2860),
    [anon_sym_DASH_DASH] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(2880),
    [anon_sym_sizeof] = ACTIONS(2882),
    [anon_sym___alignof__] = ACTIONS(2884),
    [anon_sym___alignof] = ACTIONS(2884),
    [anon_sym__alignof] = ACTIONS(2884),
    [anon_sym_alignof] = ACTIONS(2884),
    [anon_sym__Alignof] = ACTIONS(2884),
    [anon_sym_offsetof] = ACTIONS(2886),
    [anon_sym__Generic] = ACTIONS(2888),
    [anon_sym_asm] = ACTIONS(2890),
    [anon_sym___asm__] = ACTIONS(2890),
    [anon_sym___asm] = ACTIONS(2890),
    [sym_number_literal] = ACTIONS(2892),
    [anon_sym_L_SQUOTE] = ACTIONS(2894),
    [anon_sym_u_SQUOTE] = ACTIONS(2894),
    [anon_sym_U_SQUOTE] = ACTIONS(2894),
    [anon_sym_u8_SQUOTE] = ACTIONS(2894),
    [anon_sym_SQUOTE] = ACTIONS(2894),
    [anon_sym_L_DQUOTE] = ACTIONS(2896),
    [anon_sym_u_DQUOTE] = ACTIONS(2896),
    [anon_sym_U_DQUOTE] = ACTIONS(2896),
    [anon_sym_u8_DQUOTE] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [anon_sym_NULL] = ACTIONS(2900),
    [anon_sym_nullptr] = ACTIONS(2900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2910),
    [anon_sym_R_DQUOTE] = ACTIONS(2912),
    [anon_sym_LR_DQUOTE] = ACTIONS(2912),
    [anon_sym_uR_DQUOTE] = ACTIONS(2912),
    [anon_sym_UR_DQUOTE] = ACTIONS(2912),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2912),
    [anon_sym_co_await] = ACTIONS(2914),
    [anon_sym_new] = ACTIONS(2916),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2898),
  },
  [1198] = {
    [sym_expression] = STATE(3503),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [1199] = {
    [sym_expression] = STATE(3504),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [1200] = {
    [sym_expression] = STATE(3515),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [1201] = {
    [sym_expression] = STATE(3517),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [1202] = {
    [sym_expression] = STATE(3531),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [1203] = {
    [sym_expression] = STATE(3532),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [1204] = {
    [sym_expression] = STATE(3533),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [1205] = {
    [sym_expression] = STATE(3535),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [1206] = {
    [sym_expression] = STATE(3538),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [1207] = {
    [sym_expression] = STATE(3540),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [1208] = {
    [sym_expression] = STATE(4502),
    [sym__string] = STATE(4637),
    [sym_conditional_expression] = STATE(4735),
    [sym_assignment_expression] = STATE(4735),
    [sym_pointer_expression] = STATE(3573),
    [sym_unary_expression] = STATE(4735),
    [sym_binary_expression] = STATE(4735),
    [sym_update_expression] = STATE(4735),
    [sym_cast_expression] = STATE(4735),
    [sym_sizeof_expression] = STATE(4735),
    [sym_alignof_expression] = STATE(4735),
    [sym_offsetof_expression] = STATE(4735),
    [sym_generic_expression] = STATE(4735),
    [sym_subscript_expression] = STATE(3573),
    [sym_call_expression] = STATE(3573),
    [sym_gnu_asm_expression] = STATE(4735),
    [sym_extension_expression] = STATE(4735),
    [sym_field_expression] = STATE(3573),
    [sym_compound_literal_expression] = STATE(4735),
    [sym_parenthesized_expression] = STATE(3573),
    [sym_char_literal] = STATE(4637),
    [sym_concatenated_string] = STATE(4637),
    [sym_string_literal] = STATE(3662),
    [sym_null] = STATE(4735),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7513),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(4735),
    [sym_raw_string_literal] = STATE(3662),
    [sym_co_await_expression] = STATE(4735),
    [sym_new_expression] = STATE(4735),
    [sym_delete_expression] = STATE(4735),
    [sym_requires_clause] = STATE(4735),
    [sym_requires_expression] = STATE(4735),
    [sym_lambda_expression] = STATE(4735),
    [sym_lambda_capture_specifier] = STATE(5854),
    [sym_fold_expression] = STATE(4735),
    [sym_parameter_pack_expansion] = STATE(4735),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3573),
    [sym_qualified_type_identifier] = STATE(7513),
    [sym_user_defined_literal] = STATE(3573),
    [sym_identifier] = ACTIONS(3726),
    [anon_sym_LPAREN2] = ACTIONS(2856),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(3728),
    [anon_sym_COLON_COLON] = ACTIONS(2866),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(3732),
    [anon_sym_not] = ACTIONS(2860),
    [anon_sym_compl] = ACTIONS(2860),
    [anon_sym_DASH_DASH] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(2880),
    [anon_sym_sizeof] = ACTIONS(2882),
    [anon_sym___alignof__] = ACTIONS(2884),
    [anon_sym___alignof] = ACTIONS(2884),
    [anon_sym__alignof] = ACTIONS(2884),
    [anon_sym_alignof] = ACTIONS(2884),
    [anon_sym__Alignof] = ACTIONS(2884),
    [anon_sym_offsetof] = ACTIONS(2886),
    [anon_sym__Generic] = ACTIONS(2888),
    [anon_sym_asm] = ACTIONS(2890),
    [anon_sym___asm__] = ACTIONS(2890),
    [anon_sym___asm] = ACTIONS(2890),
    [sym_number_literal] = ACTIONS(2892),
    [anon_sym_L_SQUOTE] = ACTIONS(2894),
    [anon_sym_u_SQUOTE] = ACTIONS(2894),
    [anon_sym_U_SQUOTE] = ACTIONS(2894),
    [anon_sym_u8_SQUOTE] = ACTIONS(2894),
    [anon_sym_SQUOTE] = ACTIONS(2894),
    [anon_sym_L_DQUOTE] = ACTIONS(2896),
    [anon_sym_u_DQUOTE] = ACTIONS(2896),
    [anon_sym_U_DQUOTE] = ACTIONS(2896),
    [anon_sym_u8_DQUOTE] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [anon_sym_NULL] = ACTIONS(2900),
    [anon_sym_nullptr] = ACTIONS(2900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2910),
    [anon_sym_R_DQUOTE] = ACTIONS(2912),
    [anon_sym_LR_DQUOTE] = ACTIONS(2912),
    [anon_sym_uR_DQUOTE] = ACTIONS(2912),
    [anon_sym_UR_DQUOTE] = ACTIONS(2912),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2912),
    [anon_sym_co_await] = ACTIONS(2914),
    [anon_sym_new] = ACTIONS(2916),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2898),
  },
  [1209] = {
    [sym_expression] = STATE(4383),
    [sym__string] = STATE(4637),
    [sym_conditional_expression] = STATE(4735),
    [sym_assignment_expression] = STATE(4735),
    [sym_pointer_expression] = STATE(3573),
    [sym_unary_expression] = STATE(4735),
    [sym_binary_expression] = STATE(4735),
    [sym_update_expression] = STATE(4735),
    [sym_cast_expression] = STATE(4735),
    [sym_sizeof_expression] = STATE(4735),
    [sym_alignof_expression] = STATE(4735),
    [sym_offsetof_expression] = STATE(4735),
    [sym_generic_expression] = STATE(4735),
    [sym_subscript_expression] = STATE(3573),
    [sym_call_expression] = STATE(3573),
    [sym_gnu_asm_expression] = STATE(4735),
    [sym_extension_expression] = STATE(4735),
    [sym_field_expression] = STATE(3573),
    [sym_compound_literal_expression] = STATE(4735),
    [sym_parenthesized_expression] = STATE(3573),
    [sym_char_literal] = STATE(4637),
    [sym_concatenated_string] = STATE(4637),
    [sym_string_literal] = STATE(3662),
    [sym_null] = STATE(4735),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7513),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(4735),
    [sym_raw_string_literal] = STATE(3662),
    [sym_co_await_expression] = STATE(4735),
    [sym_new_expression] = STATE(4735),
    [sym_delete_expression] = STATE(4735),
    [sym_requires_clause] = STATE(4735),
    [sym_requires_expression] = STATE(4735),
    [sym_lambda_expression] = STATE(4735),
    [sym_lambda_capture_specifier] = STATE(5854),
    [sym_fold_expression] = STATE(4735),
    [sym_parameter_pack_expansion] = STATE(4735),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3573),
    [sym_qualified_type_identifier] = STATE(7513),
    [sym_user_defined_literal] = STATE(3573),
    [sym_identifier] = ACTIONS(3726),
    [anon_sym_LPAREN2] = ACTIONS(2856),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(3728),
    [anon_sym_COLON_COLON] = ACTIONS(2866),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(3732),
    [anon_sym_not] = ACTIONS(2860),
    [anon_sym_compl] = ACTIONS(2860),
    [anon_sym_DASH_DASH] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(2880),
    [anon_sym_sizeof] = ACTIONS(2882),
    [anon_sym___alignof__] = ACTIONS(2884),
    [anon_sym___alignof] = ACTIONS(2884),
    [anon_sym__alignof] = ACTIONS(2884),
    [anon_sym_alignof] = ACTIONS(2884),
    [anon_sym__Alignof] = ACTIONS(2884),
    [anon_sym_offsetof] = ACTIONS(2886),
    [anon_sym__Generic] = ACTIONS(2888),
    [anon_sym_asm] = ACTIONS(2890),
    [anon_sym___asm__] = ACTIONS(2890),
    [anon_sym___asm] = ACTIONS(2890),
    [sym_number_literal] = ACTIONS(2892),
    [anon_sym_L_SQUOTE] = ACTIONS(2894),
    [anon_sym_u_SQUOTE] = ACTIONS(2894),
    [anon_sym_U_SQUOTE] = ACTIONS(2894),
    [anon_sym_u8_SQUOTE] = ACTIONS(2894),
    [anon_sym_SQUOTE] = ACTIONS(2894),
    [anon_sym_L_DQUOTE] = ACTIONS(2896),
    [anon_sym_u_DQUOTE] = ACTIONS(2896),
    [anon_sym_U_DQUOTE] = ACTIONS(2896),
    [anon_sym_u8_DQUOTE] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [anon_sym_NULL] = ACTIONS(2900),
    [anon_sym_nullptr] = ACTIONS(2900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2910),
    [anon_sym_R_DQUOTE] = ACTIONS(2912),
    [anon_sym_LR_DQUOTE] = ACTIONS(2912),
    [anon_sym_uR_DQUOTE] = ACTIONS(2912),
    [anon_sym_UR_DQUOTE] = ACTIONS(2912),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2912),
    [anon_sym_co_await] = ACTIONS(2914),
    [anon_sym_new] = ACTIONS(2916),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2898),
  },
  [1210] = {
    [sym_expression] = STATE(4395),
    [sym__string] = STATE(4637),
    [sym_conditional_expression] = STATE(4735),
    [sym_assignment_expression] = STATE(4735),
    [sym_pointer_expression] = STATE(3573),
    [sym_unary_expression] = STATE(4735),
    [sym_binary_expression] = STATE(4735),
    [sym_update_expression] = STATE(4735),
    [sym_cast_expression] = STATE(4735),
    [sym_sizeof_expression] = STATE(4735),
    [sym_alignof_expression] = STATE(4735),
    [sym_offsetof_expression] = STATE(4735),
    [sym_generic_expression] = STATE(4735),
    [sym_subscript_expression] = STATE(3573),
    [sym_call_expression] = STATE(3573),
    [sym_gnu_asm_expression] = STATE(4735),
    [sym_extension_expression] = STATE(4735),
    [sym_field_expression] = STATE(3573),
    [sym_compound_literal_expression] = STATE(4735),
    [sym_parenthesized_expression] = STATE(3573),
    [sym_char_literal] = STATE(4637),
    [sym_concatenated_string] = STATE(4637),
    [sym_string_literal] = STATE(3662),
    [sym_null] = STATE(4735),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7513),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(4735),
    [sym_raw_string_literal] = STATE(3662),
    [sym_co_await_expression] = STATE(4735),
    [sym_new_expression] = STATE(4735),
    [sym_delete_expression] = STATE(4735),
    [sym_requires_clause] = STATE(4735),
    [sym_requires_expression] = STATE(4735),
    [sym_lambda_expression] = STATE(4735),
    [sym_lambda_capture_specifier] = STATE(5854),
    [sym_fold_expression] = STATE(4735),
    [sym_parameter_pack_expansion] = STATE(4735),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3573),
    [sym_qualified_type_identifier] = STATE(7513),
    [sym_user_defined_literal] = STATE(3573),
    [sym_identifier] = ACTIONS(3726),
    [anon_sym_LPAREN2] = ACTIONS(2856),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(3728),
    [anon_sym_COLON_COLON] = ACTIONS(2866),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(3732),
    [anon_sym_not] = ACTIONS(2860),
    [anon_sym_compl] = ACTIONS(2860),
    [anon_sym_DASH_DASH] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(2880),
    [anon_sym_sizeof] = ACTIONS(2882),
    [anon_sym___alignof__] = ACTIONS(2884),
    [anon_sym___alignof] = ACTIONS(2884),
    [anon_sym__alignof] = ACTIONS(2884),
    [anon_sym_alignof] = ACTIONS(2884),
    [anon_sym__Alignof] = ACTIONS(2884),
    [anon_sym_offsetof] = ACTIONS(2886),
    [anon_sym__Generic] = ACTIONS(2888),
    [anon_sym_asm] = ACTIONS(2890),
    [anon_sym___asm__] = ACTIONS(2890),
    [anon_sym___asm] = ACTIONS(2890),
    [sym_number_literal] = ACTIONS(2892),
    [anon_sym_L_SQUOTE] = ACTIONS(2894),
    [anon_sym_u_SQUOTE] = ACTIONS(2894),
    [anon_sym_U_SQUOTE] = ACTIONS(2894),
    [anon_sym_u8_SQUOTE] = ACTIONS(2894),
    [anon_sym_SQUOTE] = ACTIONS(2894),
    [anon_sym_L_DQUOTE] = ACTIONS(2896),
    [anon_sym_u_DQUOTE] = ACTIONS(2896),
    [anon_sym_U_DQUOTE] = ACTIONS(2896),
    [anon_sym_u8_DQUOTE] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [anon_sym_NULL] = ACTIONS(2900),
    [anon_sym_nullptr] = ACTIONS(2900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2910),
    [anon_sym_R_DQUOTE] = ACTIONS(2912),
    [anon_sym_LR_DQUOTE] = ACTIONS(2912),
    [anon_sym_uR_DQUOTE] = ACTIONS(2912),
    [anon_sym_UR_DQUOTE] = ACTIONS(2912),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2912),
    [anon_sym_co_await] = ACTIONS(2914),
    [anon_sym_new] = ACTIONS(2916),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2898),
  },
  [1211] = {
    [sym_expression] = STATE(4716),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1212] = {
    [sym_expression] = STATE(4386),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3740),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1213] = {
    [sym_expression] = STATE(4377),
    [sym__string] = STATE(4637),
    [sym_conditional_expression] = STATE(4735),
    [sym_assignment_expression] = STATE(4735),
    [sym_pointer_expression] = STATE(3573),
    [sym_unary_expression] = STATE(4735),
    [sym_binary_expression] = STATE(4735),
    [sym_update_expression] = STATE(4735),
    [sym_cast_expression] = STATE(4735),
    [sym_sizeof_expression] = STATE(4735),
    [sym_alignof_expression] = STATE(4735),
    [sym_offsetof_expression] = STATE(4735),
    [sym_generic_expression] = STATE(4735),
    [sym_subscript_expression] = STATE(3573),
    [sym_call_expression] = STATE(3573),
    [sym_gnu_asm_expression] = STATE(4735),
    [sym_extension_expression] = STATE(4735),
    [sym_field_expression] = STATE(3573),
    [sym_compound_literal_expression] = STATE(4735),
    [sym_parenthesized_expression] = STATE(3573),
    [sym_char_literal] = STATE(4637),
    [sym_concatenated_string] = STATE(4637),
    [sym_string_literal] = STATE(3662),
    [sym_null] = STATE(4735),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7513),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(4735),
    [sym_raw_string_literal] = STATE(3662),
    [sym_co_await_expression] = STATE(4735),
    [sym_new_expression] = STATE(4735),
    [sym_delete_expression] = STATE(4735),
    [sym_requires_clause] = STATE(4735),
    [sym_requires_expression] = STATE(4735),
    [sym_lambda_expression] = STATE(4735),
    [sym_lambda_capture_specifier] = STATE(5854),
    [sym_fold_expression] = STATE(4735),
    [sym_parameter_pack_expansion] = STATE(4735),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3573),
    [sym_qualified_type_identifier] = STATE(7513),
    [sym_user_defined_literal] = STATE(3573),
    [sym_identifier] = ACTIONS(3726),
    [anon_sym_LPAREN2] = ACTIONS(2856),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(3728),
    [anon_sym_COLON_COLON] = ACTIONS(2866),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(3732),
    [anon_sym_not] = ACTIONS(2860),
    [anon_sym_compl] = ACTIONS(2860),
    [anon_sym_DASH_DASH] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(2880),
    [anon_sym_sizeof] = ACTIONS(2882),
    [anon_sym___alignof__] = ACTIONS(2884),
    [anon_sym___alignof] = ACTIONS(2884),
    [anon_sym__alignof] = ACTIONS(2884),
    [anon_sym_alignof] = ACTIONS(2884),
    [anon_sym__Alignof] = ACTIONS(2884),
    [anon_sym_offsetof] = ACTIONS(2886),
    [anon_sym__Generic] = ACTIONS(2888),
    [anon_sym_asm] = ACTIONS(2890),
    [anon_sym___asm__] = ACTIONS(2890),
    [anon_sym___asm] = ACTIONS(2890),
    [sym_number_literal] = ACTIONS(2892),
    [anon_sym_L_SQUOTE] = ACTIONS(2894),
    [anon_sym_u_SQUOTE] = ACTIONS(2894),
    [anon_sym_U_SQUOTE] = ACTIONS(2894),
    [anon_sym_u8_SQUOTE] = ACTIONS(2894),
    [anon_sym_SQUOTE] = ACTIONS(2894),
    [anon_sym_L_DQUOTE] = ACTIONS(2896),
    [anon_sym_u_DQUOTE] = ACTIONS(2896),
    [anon_sym_U_DQUOTE] = ACTIONS(2896),
    [anon_sym_u8_DQUOTE] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [anon_sym_NULL] = ACTIONS(2900),
    [anon_sym_nullptr] = ACTIONS(2900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2910),
    [anon_sym_R_DQUOTE] = ACTIONS(2912),
    [anon_sym_LR_DQUOTE] = ACTIONS(2912),
    [anon_sym_uR_DQUOTE] = ACTIONS(2912),
    [anon_sym_UR_DQUOTE] = ACTIONS(2912),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2912),
    [anon_sym_co_await] = ACTIONS(2914),
    [anon_sym_new] = ACTIONS(2916),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2898),
  },
  [1214] = {
    [sym_expression] = STATE(4382),
    [sym__string] = STATE(4637),
    [sym_conditional_expression] = STATE(4735),
    [sym_assignment_expression] = STATE(4735),
    [sym_pointer_expression] = STATE(3573),
    [sym_unary_expression] = STATE(4735),
    [sym_binary_expression] = STATE(4735),
    [sym_update_expression] = STATE(4735),
    [sym_cast_expression] = STATE(4735),
    [sym_sizeof_expression] = STATE(4735),
    [sym_alignof_expression] = STATE(4735),
    [sym_offsetof_expression] = STATE(4735),
    [sym_generic_expression] = STATE(4735),
    [sym_subscript_expression] = STATE(3573),
    [sym_call_expression] = STATE(3573),
    [sym_gnu_asm_expression] = STATE(4735),
    [sym_extension_expression] = STATE(4735),
    [sym_field_expression] = STATE(3573),
    [sym_compound_literal_expression] = STATE(4735),
    [sym_parenthesized_expression] = STATE(3573),
    [sym_char_literal] = STATE(4637),
    [sym_concatenated_string] = STATE(4637),
    [sym_string_literal] = STATE(3662),
    [sym_null] = STATE(4735),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7513),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(4735),
    [sym_raw_string_literal] = STATE(3662),
    [sym_co_await_expression] = STATE(4735),
    [sym_new_expression] = STATE(4735),
    [sym_delete_expression] = STATE(4735),
    [sym_requires_clause] = STATE(4735),
    [sym_requires_expression] = STATE(4735),
    [sym_lambda_expression] = STATE(4735),
    [sym_lambda_capture_specifier] = STATE(5854),
    [sym_fold_expression] = STATE(4735),
    [sym_parameter_pack_expansion] = STATE(4735),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3573),
    [sym_qualified_type_identifier] = STATE(7513),
    [sym_user_defined_literal] = STATE(3573),
    [sym_identifier] = ACTIONS(3726),
    [anon_sym_LPAREN2] = ACTIONS(2856),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(3728),
    [anon_sym_COLON_COLON] = ACTIONS(2866),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(3732),
    [anon_sym_not] = ACTIONS(2860),
    [anon_sym_compl] = ACTIONS(2860),
    [anon_sym_DASH_DASH] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(2880),
    [anon_sym_sizeof] = ACTIONS(2882),
    [anon_sym___alignof__] = ACTIONS(2884),
    [anon_sym___alignof] = ACTIONS(2884),
    [anon_sym__alignof] = ACTIONS(2884),
    [anon_sym_alignof] = ACTIONS(2884),
    [anon_sym__Alignof] = ACTIONS(2884),
    [anon_sym_offsetof] = ACTIONS(2886),
    [anon_sym__Generic] = ACTIONS(2888),
    [anon_sym_asm] = ACTIONS(2890),
    [anon_sym___asm__] = ACTIONS(2890),
    [anon_sym___asm] = ACTIONS(2890),
    [sym_number_literal] = ACTIONS(2892),
    [anon_sym_L_SQUOTE] = ACTIONS(2894),
    [anon_sym_u_SQUOTE] = ACTIONS(2894),
    [anon_sym_U_SQUOTE] = ACTIONS(2894),
    [anon_sym_u8_SQUOTE] = ACTIONS(2894),
    [anon_sym_SQUOTE] = ACTIONS(2894),
    [anon_sym_L_DQUOTE] = ACTIONS(2896),
    [anon_sym_u_DQUOTE] = ACTIONS(2896),
    [anon_sym_U_DQUOTE] = ACTIONS(2896),
    [anon_sym_u8_DQUOTE] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [anon_sym_NULL] = ACTIONS(2900),
    [anon_sym_nullptr] = ACTIONS(2900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2910),
    [anon_sym_R_DQUOTE] = ACTIONS(2912),
    [anon_sym_LR_DQUOTE] = ACTIONS(2912),
    [anon_sym_uR_DQUOTE] = ACTIONS(2912),
    [anon_sym_UR_DQUOTE] = ACTIONS(2912),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2912),
    [anon_sym_co_await] = ACTIONS(2914),
    [anon_sym_new] = ACTIONS(2916),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2898),
  },
  [1215] = {
    [sym_expression] = STATE(4717),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1216] = {
    [sym_expression] = STATE(4317),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1217] = {
    [sym_expression] = STATE(4643),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1218] = {
    [sym_expression] = STATE(3603),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(4764),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [1219] = {
    [sym_expression] = STATE(3608),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [1220] = {
    [sym_expression] = STATE(3542),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(4766),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [1221] = {
    [sym_expression] = STATE(4573),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1222] = {
    [sym_expression] = STATE(4548),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4497),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(3714),
    [anon_sym_COLON_COLON] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4476),
    [anon_sym_PLUS_PLUS] = ACTIONS(4476),
    [anon_sym_sizeof] = ACTIONS(3718),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3720),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3722),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1223] = {
    [sym_expression] = STATE(3541),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [1224] = {
    [sym_expression] = STATE(4606),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1225] = {
    [sym_expression] = STATE(4435),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1226] = {
    [sym_expression] = STATE(4621),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1227] = {
    [sym_expression] = STATE(3631),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [1228] = {
    [sym_expression] = STATE(3087),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2029),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(4768),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [1229] = {
    [sym_expression] = STATE(3127),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2029),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [1230] = {
    [sym_expression] = STATE(4566),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1231] = {
    [sym_expression] = STATE(3125),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2029),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [1232] = {
    [sym_expression] = STATE(2843),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4424),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1965),
    [anon_sym_compl] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_sizeof] = ACTIONS(1973),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1233] = {
    [sym_expression] = STATE(3498),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [1234] = {
    [sym_expression] = STATE(3086),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2029),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(4770),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [1235] = {
    [sym_expression] = STATE(3187),
    [sym__string] = STATE(3374),
    [sym_conditional_expression] = STATE(3536),
    [sym_assignment_expression] = STATE(3536),
    [sym_pointer_expression] = STATE(3544),
    [sym_unary_expression] = STATE(3536),
    [sym_binary_expression] = STATE(3536),
    [sym_update_expression] = STATE(3536),
    [sym_cast_expression] = STATE(3536),
    [sym_sizeof_expression] = STATE(3536),
    [sym_alignof_expression] = STATE(3536),
    [sym_offsetof_expression] = STATE(3536),
    [sym_generic_expression] = STATE(3536),
    [sym_subscript_expression] = STATE(3544),
    [sym_call_expression] = STATE(3544),
    [sym_gnu_asm_expression] = STATE(3536),
    [sym_extension_expression] = STATE(3536),
    [sym_field_expression] = STATE(3544),
    [sym_compound_literal_expression] = STATE(3536),
    [sym_parenthesized_expression] = STATE(3544),
    [sym_char_literal] = STATE(3374),
    [sym_concatenated_string] = STATE(3374),
    [sym_string_literal] = STATE(2363),
    [sym_null] = STATE(3536),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7597),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3536),
    [sym_raw_string_literal] = STATE(2363),
    [sym_co_await_expression] = STATE(3536),
    [sym_new_expression] = STATE(3536),
    [sym_delete_expression] = STATE(3536),
    [sym_requires_clause] = STATE(3536),
    [sym_requires_expression] = STATE(3536),
    [sym_lambda_expression] = STATE(3536),
    [sym_lambda_capture_specifier] = STATE(5874),
    [sym_fold_expression] = STATE(3536),
    [sym_parameter_pack_expansion] = STATE(3536),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3544),
    [sym_qualified_type_identifier] = STATE(7597),
    [sym_user_defined_literal] = STATE(3544),
    [sym_identifier] = ACTIONS(2446),
    [anon_sym_LPAREN2] = ACTIONS(4521),
    [anon_sym_BANG] = ACTIONS(2450),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2448),
    [anon_sym_PLUS] = ACTIONS(2448),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(2452),
    [anon_sym_COLON_COLON] = ACTIONS(2454),
    [anon_sym_LBRACK] = ACTIONS(4772),
    [sym_primitive_type] = ACTIONS(2458),
    [anon_sym_not] = ACTIONS(2448),
    [anon_sym_compl] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(4478),
    [anon_sym_PLUS_PLUS] = ACTIONS(4478),
    [anon_sym_sizeof] = ACTIONS(2460),
    [anon_sym___alignof__] = ACTIONS(2462),
    [anon_sym___alignof] = ACTIONS(2462),
    [anon_sym__alignof] = ACTIONS(2462),
    [anon_sym_alignof] = ACTIONS(2462),
    [anon_sym__Alignof] = ACTIONS(2462),
    [anon_sym_offsetof] = ACTIONS(2464),
    [anon_sym__Generic] = ACTIONS(2466),
    [anon_sym_asm] = ACTIONS(2468),
    [anon_sym___asm__] = ACTIONS(2468),
    [anon_sym___asm] = ACTIONS(2468),
    [sym_number_literal] = ACTIONS(2470),
    [anon_sym_L_SQUOTE] = ACTIONS(2472),
    [anon_sym_u_SQUOTE] = ACTIONS(2472),
    [anon_sym_U_SQUOTE] = ACTIONS(2472),
    [anon_sym_u8_SQUOTE] = ACTIONS(2472),
    [anon_sym_SQUOTE] = ACTIONS(2472),
    [anon_sym_L_DQUOTE] = ACTIONS(2474),
    [anon_sym_u_DQUOTE] = ACTIONS(2474),
    [anon_sym_U_DQUOTE] = ACTIONS(2474),
    [anon_sym_u8_DQUOTE] = ACTIONS(2474),
    [anon_sym_DQUOTE] = ACTIONS(2474),
    [sym_true] = ACTIONS(2476),
    [sym_false] = ACTIONS(2476),
    [anon_sym_NULL] = ACTIONS(2478),
    [anon_sym_nullptr] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2480),
    [anon_sym_R_DQUOTE] = ACTIONS(2482),
    [anon_sym_LR_DQUOTE] = ACTIONS(2482),
    [anon_sym_uR_DQUOTE] = ACTIONS(2482),
    [anon_sym_UR_DQUOTE] = ACTIONS(2482),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2482),
    [anon_sym_co_await] = ACTIONS(2484),
    [anon_sym_new] = ACTIONS(2486),
    [anon_sym_requires] = ACTIONS(2488),
    [sym_this] = ACTIONS(2476),
  },
  [1236] = {
    [sym_expression] = STATE(3214),
    [sym__string] = STATE(3374),
    [sym_conditional_expression] = STATE(3536),
    [sym_assignment_expression] = STATE(3536),
    [sym_pointer_expression] = STATE(3544),
    [sym_unary_expression] = STATE(3536),
    [sym_binary_expression] = STATE(3536),
    [sym_update_expression] = STATE(3536),
    [sym_cast_expression] = STATE(3536),
    [sym_sizeof_expression] = STATE(3536),
    [sym_alignof_expression] = STATE(3536),
    [sym_offsetof_expression] = STATE(3536),
    [sym_generic_expression] = STATE(3536),
    [sym_subscript_expression] = STATE(3544),
    [sym_call_expression] = STATE(3544),
    [sym_gnu_asm_expression] = STATE(3536),
    [sym_extension_expression] = STATE(3536),
    [sym_field_expression] = STATE(3544),
    [sym_compound_literal_expression] = STATE(3536),
    [sym_parenthesized_expression] = STATE(3544),
    [sym_char_literal] = STATE(3374),
    [sym_concatenated_string] = STATE(3374),
    [sym_string_literal] = STATE(2363),
    [sym_null] = STATE(3536),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7597),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3536),
    [sym_raw_string_literal] = STATE(2363),
    [sym_co_await_expression] = STATE(3536),
    [sym_new_expression] = STATE(3536),
    [sym_delete_expression] = STATE(3536),
    [sym_requires_clause] = STATE(3536),
    [sym_requires_expression] = STATE(3536),
    [sym_lambda_expression] = STATE(3536),
    [sym_lambda_capture_specifier] = STATE(5874),
    [sym_fold_expression] = STATE(3536),
    [sym_parameter_pack_expansion] = STATE(3536),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3544),
    [sym_qualified_type_identifier] = STATE(7597),
    [sym_user_defined_literal] = STATE(3544),
    [sym_identifier] = ACTIONS(2446),
    [anon_sym_LPAREN2] = ACTIONS(4521),
    [anon_sym_BANG] = ACTIONS(2450),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2448),
    [anon_sym_PLUS] = ACTIONS(2448),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(2452),
    [anon_sym_COLON_COLON] = ACTIONS(2454),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2458),
    [anon_sym_not] = ACTIONS(2448),
    [anon_sym_compl] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(4478),
    [anon_sym_PLUS_PLUS] = ACTIONS(4478),
    [anon_sym_sizeof] = ACTIONS(2460),
    [anon_sym___alignof__] = ACTIONS(2462),
    [anon_sym___alignof] = ACTIONS(2462),
    [anon_sym__alignof] = ACTIONS(2462),
    [anon_sym_alignof] = ACTIONS(2462),
    [anon_sym__Alignof] = ACTIONS(2462),
    [anon_sym_offsetof] = ACTIONS(2464),
    [anon_sym__Generic] = ACTIONS(2466),
    [anon_sym_asm] = ACTIONS(2468),
    [anon_sym___asm__] = ACTIONS(2468),
    [anon_sym___asm] = ACTIONS(2468),
    [sym_number_literal] = ACTIONS(2470),
    [anon_sym_L_SQUOTE] = ACTIONS(2472),
    [anon_sym_u_SQUOTE] = ACTIONS(2472),
    [anon_sym_U_SQUOTE] = ACTIONS(2472),
    [anon_sym_u8_SQUOTE] = ACTIONS(2472),
    [anon_sym_SQUOTE] = ACTIONS(2472),
    [anon_sym_L_DQUOTE] = ACTIONS(2474),
    [anon_sym_u_DQUOTE] = ACTIONS(2474),
    [anon_sym_U_DQUOTE] = ACTIONS(2474),
    [anon_sym_u8_DQUOTE] = ACTIONS(2474),
    [anon_sym_DQUOTE] = ACTIONS(2474),
    [sym_true] = ACTIONS(2476),
    [sym_false] = ACTIONS(2476),
    [anon_sym_NULL] = ACTIONS(2478),
    [anon_sym_nullptr] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2480),
    [anon_sym_R_DQUOTE] = ACTIONS(2482),
    [anon_sym_LR_DQUOTE] = ACTIONS(2482),
    [anon_sym_uR_DQUOTE] = ACTIONS(2482),
    [anon_sym_UR_DQUOTE] = ACTIONS(2482),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2482),
    [anon_sym_co_await] = ACTIONS(2484),
    [anon_sym_new] = ACTIONS(2486),
    [anon_sym_requires] = ACTIONS(2488),
    [sym_this] = ACTIONS(2476),
  },
  [1237] = {
    [sym_expression] = STATE(3236),
    [sym__string] = STATE(3374),
    [sym_conditional_expression] = STATE(3536),
    [sym_assignment_expression] = STATE(3536),
    [sym_pointer_expression] = STATE(3544),
    [sym_unary_expression] = STATE(3536),
    [sym_binary_expression] = STATE(3536),
    [sym_update_expression] = STATE(3536),
    [sym_cast_expression] = STATE(3536),
    [sym_sizeof_expression] = STATE(3536),
    [sym_alignof_expression] = STATE(3536),
    [sym_offsetof_expression] = STATE(3536),
    [sym_generic_expression] = STATE(3536),
    [sym_subscript_expression] = STATE(3544),
    [sym_call_expression] = STATE(3544),
    [sym_gnu_asm_expression] = STATE(3536),
    [sym_extension_expression] = STATE(3536),
    [sym_field_expression] = STATE(3544),
    [sym_compound_literal_expression] = STATE(3536),
    [sym_parenthesized_expression] = STATE(3544),
    [sym_char_literal] = STATE(3374),
    [sym_concatenated_string] = STATE(3374),
    [sym_string_literal] = STATE(2363),
    [sym_null] = STATE(3536),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7597),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3536),
    [sym_raw_string_literal] = STATE(2363),
    [sym_co_await_expression] = STATE(3536),
    [sym_new_expression] = STATE(3536),
    [sym_delete_expression] = STATE(3536),
    [sym_requires_clause] = STATE(3536),
    [sym_requires_expression] = STATE(3536),
    [sym_lambda_expression] = STATE(3536),
    [sym_lambda_capture_specifier] = STATE(5874),
    [sym_fold_expression] = STATE(3536),
    [sym_parameter_pack_expansion] = STATE(3536),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3544),
    [sym_qualified_type_identifier] = STATE(7597),
    [sym_user_defined_literal] = STATE(3544),
    [sym_identifier] = ACTIONS(2446),
    [anon_sym_LPAREN2] = ACTIONS(4521),
    [anon_sym_BANG] = ACTIONS(2450),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2448),
    [anon_sym_PLUS] = ACTIONS(2448),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(2452),
    [anon_sym_COLON_COLON] = ACTIONS(2454),
    [anon_sym_LBRACK] = ACTIONS(4774),
    [sym_primitive_type] = ACTIONS(2458),
    [anon_sym_not] = ACTIONS(2448),
    [anon_sym_compl] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(4478),
    [anon_sym_PLUS_PLUS] = ACTIONS(4478),
    [anon_sym_sizeof] = ACTIONS(2460),
    [anon_sym___alignof__] = ACTIONS(2462),
    [anon_sym___alignof] = ACTIONS(2462),
    [anon_sym__alignof] = ACTIONS(2462),
    [anon_sym_alignof] = ACTIONS(2462),
    [anon_sym__Alignof] = ACTIONS(2462),
    [anon_sym_offsetof] = ACTIONS(2464),
    [anon_sym__Generic] = ACTIONS(2466),
    [anon_sym_asm] = ACTIONS(2468),
    [anon_sym___asm__] = ACTIONS(2468),
    [anon_sym___asm] = ACTIONS(2468),
    [sym_number_literal] = ACTIONS(2470),
    [anon_sym_L_SQUOTE] = ACTIONS(2472),
    [anon_sym_u_SQUOTE] = ACTIONS(2472),
    [anon_sym_U_SQUOTE] = ACTIONS(2472),
    [anon_sym_u8_SQUOTE] = ACTIONS(2472),
    [anon_sym_SQUOTE] = ACTIONS(2472),
    [anon_sym_L_DQUOTE] = ACTIONS(2474),
    [anon_sym_u_DQUOTE] = ACTIONS(2474),
    [anon_sym_U_DQUOTE] = ACTIONS(2474),
    [anon_sym_u8_DQUOTE] = ACTIONS(2474),
    [anon_sym_DQUOTE] = ACTIONS(2474),
    [sym_true] = ACTIONS(2476),
    [sym_false] = ACTIONS(2476),
    [anon_sym_NULL] = ACTIONS(2478),
    [anon_sym_nullptr] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2480),
    [anon_sym_R_DQUOTE] = ACTIONS(2482),
    [anon_sym_LR_DQUOTE] = ACTIONS(2482),
    [anon_sym_uR_DQUOTE] = ACTIONS(2482),
    [anon_sym_UR_DQUOTE] = ACTIONS(2482),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2482),
    [anon_sym_co_await] = ACTIONS(2484),
    [anon_sym_new] = ACTIONS(2486),
    [anon_sym_requires] = ACTIONS(2488),
    [sym_this] = ACTIONS(2476),
  },
  [1238] = {
    [sym_expression] = STATE(3222),
    [sym__string] = STATE(3374),
    [sym_conditional_expression] = STATE(3536),
    [sym_assignment_expression] = STATE(3536),
    [sym_pointer_expression] = STATE(3544),
    [sym_unary_expression] = STATE(3536),
    [sym_binary_expression] = STATE(3536),
    [sym_update_expression] = STATE(3536),
    [sym_cast_expression] = STATE(3536),
    [sym_sizeof_expression] = STATE(3536),
    [sym_alignof_expression] = STATE(3536),
    [sym_offsetof_expression] = STATE(3536),
    [sym_generic_expression] = STATE(3536),
    [sym_subscript_expression] = STATE(3544),
    [sym_call_expression] = STATE(3544),
    [sym_gnu_asm_expression] = STATE(3536),
    [sym_extension_expression] = STATE(3536),
    [sym_field_expression] = STATE(3544),
    [sym_compound_literal_expression] = STATE(3536),
    [sym_parenthesized_expression] = STATE(3544),
    [sym_char_literal] = STATE(3374),
    [sym_concatenated_string] = STATE(3374),
    [sym_string_literal] = STATE(2363),
    [sym_null] = STATE(3536),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7597),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3536),
    [sym_raw_string_literal] = STATE(2363),
    [sym_co_await_expression] = STATE(3536),
    [sym_new_expression] = STATE(3536),
    [sym_delete_expression] = STATE(3536),
    [sym_requires_clause] = STATE(3536),
    [sym_requires_expression] = STATE(3536),
    [sym_lambda_expression] = STATE(3536),
    [sym_lambda_capture_specifier] = STATE(5874),
    [sym_fold_expression] = STATE(3536),
    [sym_parameter_pack_expansion] = STATE(3536),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3544),
    [sym_qualified_type_identifier] = STATE(7597),
    [sym_user_defined_literal] = STATE(3544),
    [sym_identifier] = ACTIONS(2446),
    [anon_sym_LPAREN2] = ACTIONS(4521),
    [anon_sym_BANG] = ACTIONS(2450),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2448),
    [anon_sym_PLUS] = ACTIONS(2448),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(2452),
    [anon_sym_COLON_COLON] = ACTIONS(2454),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2458),
    [anon_sym_not] = ACTIONS(2448),
    [anon_sym_compl] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(4478),
    [anon_sym_PLUS_PLUS] = ACTIONS(4478),
    [anon_sym_sizeof] = ACTIONS(2460),
    [anon_sym___alignof__] = ACTIONS(2462),
    [anon_sym___alignof] = ACTIONS(2462),
    [anon_sym__alignof] = ACTIONS(2462),
    [anon_sym_alignof] = ACTIONS(2462),
    [anon_sym__Alignof] = ACTIONS(2462),
    [anon_sym_offsetof] = ACTIONS(2464),
    [anon_sym__Generic] = ACTIONS(2466),
    [anon_sym_asm] = ACTIONS(2468),
    [anon_sym___asm__] = ACTIONS(2468),
    [anon_sym___asm] = ACTIONS(2468),
    [sym_number_literal] = ACTIONS(2470),
    [anon_sym_L_SQUOTE] = ACTIONS(2472),
    [anon_sym_u_SQUOTE] = ACTIONS(2472),
    [anon_sym_U_SQUOTE] = ACTIONS(2472),
    [anon_sym_u8_SQUOTE] = ACTIONS(2472),
    [anon_sym_SQUOTE] = ACTIONS(2472),
    [anon_sym_L_DQUOTE] = ACTIONS(2474),
    [anon_sym_u_DQUOTE] = ACTIONS(2474),
    [anon_sym_U_DQUOTE] = ACTIONS(2474),
    [anon_sym_u8_DQUOTE] = ACTIONS(2474),
    [anon_sym_DQUOTE] = ACTIONS(2474),
    [sym_true] = ACTIONS(2476),
    [sym_false] = ACTIONS(2476),
    [anon_sym_NULL] = ACTIONS(2478),
    [anon_sym_nullptr] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2480),
    [anon_sym_R_DQUOTE] = ACTIONS(2482),
    [anon_sym_LR_DQUOTE] = ACTIONS(2482),
    [anon_sym_uR_DQUOTE] = ACTIONS(2482),
    [anon_sym_UR_DQUOTE] = ACTIONS(2482),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2482),
    [anon_sym_co_await] = ACTIONS(2484),
    [anon_sym_new] = ACTIONS(2486),
    [anon_sym_requires] = ACTIONS(2488),
    [sym_this] = ACTIONS(2476),
  },
  [1239] = {
    [sym_expression] = STATE(3706),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(4776),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1240] = {
    [sym_expression] = STATE(3197),
    [sym__string] = STATE(3374),
    [sym_conditional_expression] = STATE(3536),
    [sym_assignment_expression] = STATE(3536),
    [sym_pointer_expression] = STATE(3544),
    [sym_unary_expression] = STATE(3536),
    [sym_binary_expression] = STATE(3536),
    [sym_update_expression] = STATE(3536),
    [sym_cast_expression] = STATE(3536),
    [sym_sizeof_expression] = STATE(3536),
    [sym_alignof_expression] = STATE(3536),
    [sym_offsetof_expression] = STATE(3536),
    [sym_generic_expression] = STATE(3536),
    [sym_subscript_expression] = STATE(3544),
    [sym_call_expression] = STATE(3544),
    [sym_gnu_asm_expression] = STATE(3536),
    [sym_extension_expression] = STATE(3536),
    [sym_field_expression] = STATE(3544),
    [sym_compound_literal_expression] = STATE(3536),
    [sym_parenthesized_expression] = STATE(3544),
    [sym_char_literal] = STATE(3374),
    [sym_concatenated_string] = STATE(3374),
    [sym_string_literal] = STATE(2363),
    [sym_null] = STATE(3536),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7597),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3536),
    [sym_raw_string_literal] = STATE(2363),
    [sym_co_await_expression] = STATE(3536),
    [sym_new_expression] = STATE(3536),
    [sym_delete_expression] = STATE(3536),
    [sym_requires_clause] = STATE(3536),
    [sym_requires_expression] = STATE(3536),
    [sym_lambda_expression] = STATE(3536),
    [sym_lambda_capture_specifier] = STATE(5874),
    [sym_fold_expression] = STATE(3536),
    [sym_parameter_pack_expansion] = STATE(3536),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3544),
    [sym_qualified_type_identifier] = STATE(7597),
    [sym_user_defined_literal] = STATE(3544),
    [sym_identifier] = ACTIONS(2446),
    [anon_sym_LPAREN2] = ACTIONS(4521),
    [anon_sym_BANG] = ACTIONS(2450),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2448),
    [anon_sym_PLUS] = ACTIONS(2448),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(2452),
    [anon_sym_COLON_COLON] = ACTIONS(2454),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2458),
    [anon_sym_not] = ACTIONS(2448),
    [anon_sym_compl] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(4478),
    [anon_sym_PLUS_PLUS] = ACTIONS(4478),
    [anon_sym_sizeof] = ACTIONS(2460),
    [anon_sym___alignof__] = ACTIONS(2462),
    [anon_sym___alignof] = ACTIONS(2462),
    [anon_sym__alignof] = ACTIONS(2462),
    [anon_sym_alignof] = ACTIONS(2462),
    [anon_sym__Alignof] = ACTIONS(2462),
    [anon_sym_offsetof] = ACTIONS(2464),
    [anon_sym__Generic] = ACTIONS(2466),
    [anon_sym_asm] = ACTIONS(2468),
    [anon_sym___asm__] = ACTIONS(2468),
    [anon_sym___asm] = ACTIONS(2468),
    [sym_number_literal] = ACTIONS(2470),
    [anon_sym_L_SQUOTE] = ACTIONS(2472),
    [anon_sym_u_SQUOTE] = ACTIONS(2472),
    [anon_sym_U_SQUOTE] = ACTIONS(2472),
    [anon_sym_u8_SQUOTE] = ACTIONS(2472),
    [anon_sym_SQUOTE] = ACTIONS(2472),
    [anon_sym_L_DQUOTE] = ACTIONS(2474),
    [anon_sym_u_DQUOTE] = ACTIONS(2474),
    [anon_sym_U_DQUOTE] = ACTIONS(2474),
    [anon_sym_u8_DQUOTE] = ACTIONS(2474),
    [anon_sym_DQUOTE] = ACTIONS(2474),
    [sym_true] = ACTIONS(2476),
    [sym_false] = ACTIONS(2476),
    [anon_sym_NULL] = ACTIONS(2478),
    [anon_sym_nullptr] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2480),
    [anon_sym_R_DQUOTE] = ACTIONS(2482),
    [anon_sym_LR_DQUOTE] = ACTIONS(2482),
    [anon_sym_uR_DQUOTE] = ACTIONS(2482),
    [anon_sym_UR_DQUOTE] = ACTIONS(2482),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2482),
    [anon_sym_co_await] = ACTIONS(2484),
    [anon_sym_new] = ACTIONS(2486),
    [anon_sym_requires] = ACTIONS(2488),
    [sym_this] = ACTIONS(2476),
  },
  [1241] = {
    [sym_expression] = STATE(3281),
    [sym__string] = STATE(3374),
    [sym_conditional_expression] = STATE(3536),
    [sym_assignment_expression] = STATE(3536),
    [sym_pointer_expression] = STATE(3544),
    [sym_unary_expression] = STATE(3536),
    [sym_binary_expression] = STATE(3536),
    [sym_update_expression] = STATE(3536),
    [sym_cast_expression] = STATE(3536),
    [sym_sizeof_expression] = STATE(3536),
    [sym_alignof_expression] = STATE(3536),
    [sym_offsetof_expression] = STATE(3536),
    [sym_generic_expression] = STATE(3536),
    [sym_subscript_expression] = STATE(3544),
    [sym_call_expression] = STATE(3544),
    [sym_gnu_asm_expression] = STATE(3536),
    [sym_extension_expression] = STATE(3536),
    [sym_field_expression] = STATE(3544),
    [sym_compound_literal_expression] = STATE(3536),
    [sym_parenthesized_expression] = STATE(3544),
    [sym_char_literal] = STATE(3374),
    [sym_concatenated_string] = STATE(3374),
    [sym_string_literal] = STATE(2363),
    [sym_null] = STATE(3536),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7597),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3536),
    [sym_raw_string_literal] = STATE(2363),
    [sym_co_await_expression] = STATE(3536),
    [sym_new_expression] = STATE(3536),
    [sym_delete_expression] = STATE(3536),
    [sym_requires_clause] = STATE(3536),
    [sym_requires_expression] = STATE(3536),
    [sym_lambda_expression] = STATE(3536),
    [sym_lambda_capture_specifier] = STATE(5874),
    [sym_fold_expression] = STATE(3536),
    [sym_parameter_pack_expansion] = STATE(3536),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3544),
    [sym_qualified_type_identifier] = STATE(7597),
    [sym_user_defined_literal] = STATE(3544),
    [sym_identifier] = ACTIONS(2446),
    [anon_sym_LPAREN2] = ACTIONS(4521),
    [anon_sym_BANG] = ACTIONS(2450),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2448),
    [anon_sym_PLUS] = ACTIONS(2448),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(2452),
    [anon_sym_COLON_COLON] = ACTIONS(2454),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2458),
    [anon_sym_not] = ACTIONS(2448),
    [anon_sym_compl] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(4478),
    [anon_sym_PLUS_PLUS] = ACTIONS(4478),
    [anon_sym_sizeof] = ACTIONS(2460),
    [anon_sym___alignof__] = ACTIONS(2462),
    [anon_sym___alignof] = ACTIONS(2462),
    [anon_sym__alignof] = ACTIONS(2462),
    [anon_sym_alignof] = ACTIONS(2462),
    [anon_sym__Alignof] = ACTIONS(2462),
    [anon_sym_offsetof] = ACTIONS(2464),
    [anon_sym__Generic] = ACTIONS(2466),
    [anon_sym_asm] = ACTIONS(2468),
    [anon_sym___asm__] = ACTIONS(2468),
    [anon_sym___asm] = ACTIONS(2468),
    [sym_number_literal] = ACTIONS(2470),
    [anon_sym_L_SQUOTE] = ACTIONS(2472),
    [anon_sym_u_SQUOTE] = ACTIONS(2472),
    [anon_sym_U_SQUOTE] = ACTIONS(2472),
    [anon_sym_u8_SQUOTE] = ACTIONS(2472),
    [anon_sym_SQUOTE] = ACTIONS(2472),
    [anon_sym_L_DQUOTE] = ACTIONS(2474),
    [anon_sym_u_DQUOTE] = ACTIONS(2474),
    [anon_sym_U_DQUOTE] = ACTIONS(2474),
    [anon_sym_u8_DQUOTE] = ACTIONS(2474),
    [anon_sym_DQUOTE] = ACTIONS(2474),
    [sym_true] = ACTIONS(2476),
    [sym_false] = ACTIONS(2476),
    [anon_sym_NULL] = ACTIONS(2478),
    [anon_sym_nullptr] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2480),
    [anon_sym_R_DQUOTE] = ACTIONS(2482),
    [anon_sym_LR_DQUOTE] = ACTIONS(2482),
    [anon_sym_uR_DQUOTE] = ACTIONS(2482),
    [anon_sym_UR_DQUOTE] = ACTIONS(2482),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2482),
    [anon_sym_co_await] = ACTIONS(2484),
    [anon_sym_new] = ACTIONS(2486),
    [anon_sym_requires] = ACTIONS(2488),
    [sym_this] = ACTIONS(2476),
  },
  [1242] = {
    [sym_expression] = STATE(2964),
    [sym__string] = STATE(3071),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(3071),
    [sym_concatenated_string] = STATE(3071),
    [sym_string_literal] = STATE(2243),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(2243),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1989),
    [anon_sym_LPAREN2] = ACTIONS(4531),
    [anon_sym_BANG] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1993),
    [anon_sym_DASH] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1991),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym___extension__] = ACTIONS(1995),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_LBRACK] = ACTIONS(4778),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_compl] = ACTIONS(1991),
    [anon_sym_DASH_DASH] = ACTIONS(4480),
    [anon_sym_PLUS_PLUS] = ACTIONS(4480),
    [anon_sym_sizeof] = ACTIONS(1999),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(2001),
    [anon_sym_L_SQUOTE] = ACTIONS(2003),
    [anon_sym_u_SQUOTE] = ACTIONS(2003),
    [anon_sym_U_SQUOTE] = ACTIONS(2003),
    [anon_sym_u8_SQUOTE] = ACTIONS(2003),
    [anon_sym_SQUOTE] = ACTIONS(2003),
    [anon_sym_L_DQUOTE] = ACTIONS(2005),
    [anon_sym_u_DQUOTE] = ACTIONS(2005),
    [anon_sym_U_DQUOTE] = ACTIONS(2005),
    [anon_sym_u8_DQUOTE] = ACTIONS(2005),
    [anon_sym_DQUOTE] = ACTIONS(2005),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2007),
    [anon_sym_R_DQUOTE] = ACTIONS(2009),
    [anon_sym_LR_DQUOTE] = ACTIONS(2009),
    [anon_sym_uR_DQUOTE] = ACTIONS(2009),
    [anon_sym_UR_DQUOTE] = ACTIONS(2009),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2009),
    [anon_sym_co_await] = ACTIONS(2011),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1243] = {
    [sym_expression] = STATE(2934),
    [sym__string] = STATE(3071),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(3071),
    [sym_concatenated_string] = STATE(3071),
    [sym_string_literal] = STATE(2243),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(2243),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1989),
    [anon_sym_LPAREN2] = ACTIONS(4531),
    [anon_sym_BANG] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1993),
    [anon_sym_DASH] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1991),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym___extension__] = ACTIONS(1995),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_compl] = ACTIONS(1991),
    [anon_sym_DASH_DASH] = ACTIONS(4480),
    [anon_sym_PLUS_PLUS] = ACTIONS(4480),
    [anon_sym_sizeof] = ACTIONS(1999),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(2001),
    [anon_sym_L_SQUOTE] = ACTIONS(2003),
    [anon_sym_u_SQUOTE] = ACTIONS(2003),
    [anon_sym_U_SQUOTE] = ACTIONS(2003),
    [anon_sym_u8_SQUOTE] = ACTIONS(2003),
    [anon_sym_SQUOTE] = ACTIONS(2003),
    [anon_sym_L_DQUOTE] = ACTIONS(2005),
    [anon_sym_u_DQUOTE] = ACTIONS(2005),
    [anon_sym_U_DQUOTE] = ACTIONS(2005),
    [anon_sym_u8_DQUOTE] = ACTIONS(2005),
    [anon_sym_DQUOTE] = ACTIONS(2005),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2007),
    [anon_sym_R_DQUOTE] = ACTIONS(2009),
    [anon_sym_LR_DQUOTE] = ACTIONS(2009),
    [anon_sym_uR_DQUOTE] = ACTIONS(2009),
    [anon_sym_UR_DQUOTE] = ACTIONS(2009),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2009),
    [anon_sym_co_await] = ACTIONS(2011),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1244] = {
    [sym_expression] = STATE(3039),
    [sym__string] = STATE(3071),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(3071),
    [sym_concatenated_string] = STATE(3071),
    [sym_string_literal] = STATE(2243),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(2243),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1989),
    [anon_sym_LPAREN2] = ACTIONS(4531),
    [anon_sym_BANG] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1993),
    [anon_sym_DASH] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1991),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym___extension__] = ACTIONS(1995),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_compl] = ACTIONS(1991),
    [anon_sym_DASH_DASH] = ACTIONS(4480),
    [anon_sym_PLUS_PLUS] = ACTIONS(4480),
    [anon_sym_sizeof] = ACTIONS(1999),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(2001),
    [anon_sym_L_SQUOTE] = ACTIONS(2003),
    [anon_sym_u_SQUOTE] = ACTIONS(2003),
    [anon_sym_U_SQUOTE] = ACTIONS(2003),
    [anon_sym_u8_SQUOTE] = ACTIONS(2003),
    [anon_sym_SQUOTE] = ACTIONS(2003),
    [anon_sym_L_DQUOTE] = ACTIONS(2005),
    [anon_sym_u_DQUOTE] = ACTIONS(2005),
    [anon_sym_U_DQUOTE] = ACTIONS(2005),
    [anon_sym_u8_DQUOTE] = ACTIONS(2005),
    [anon_sym_DQUOTE] = ACTIONS(2005),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2007),
    [anon_sym_R_DQUOTE] = ACTIONS(2009),
    [anon_sym_LR_DQUOTE] = ACTIONS(2009),
    [anon_sym_uR_DQUOTE] = ACTIONS(2009),
    [anon_sym_UR_DQUOTE] = ACTIONS(2009),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2009),
    [anon_sym_co_await] = ACTIONS(2011),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1245] = {
    [sym_expression] = STATE(3052),
    [sym__string] = STATE(3071),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(3071),
    [sym_concatenated_string] = STATE(3071),
    [sym_string_literal] = STATE(2243),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(2243),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1989),
    [anon_sym_LPAREN2] = ACTIONS(4531),
    [anon_sym_BANG] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1993),
    [anon_sym_DASH] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1991),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym___extension__] = ACTIONS(1995),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_compl] = ACTIONS(1991),
    [anon_sym_DASH_DASH] = ACTIONS(4480),
    [anon_sym_PLUS_PLUS] = ACTIONS(4480),
    [anon_sym_sizeof] = ACTIONS(1999),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(2001),
    [anon_sym_L_SQUOTE] = ACTIONS(2003),
    [anon_sym_u_SQUOTE] = ACTIONS(2003),
    [anon_sym_U_SQUOTE] = ACTIONS(2003),
    [anon_sym_u8_SQUOTE] = ACTIONS(2003),
    [anon_sym_SQUOTE] = ACTIONS(2003),
    [anon_sym_L_DQUOTE] = ACTIONS(2005),
    [anon_sym_u_DQUOTE] = ACTIONS(2005),
    [anon_sym_U_DQUOTE] = ACTIONS(2005),
    [anon_sym_u8_DQUOTE] = ACTIONS(2005),
    [anon_sym_DQUOTE] = ACTIONS(2005),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2007),
    [anon_sym_R_DQUOTE] = ACTIONS(2009),
    [anon_sym_LR_DQUOTE] = ACTIONS(2009),
    [anon_sym_uR_DQUOTE] = ACTIONS(2009),
    [anon_sym_UR_DQUOTE] = ACTIONS(2009),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2009),
    [anon_sym_co_await] = ACTIONS(2011),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1246] = {
    [sym_expression] = STATE(4404),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1247] = {
    [sym_expression] = STATE(3699),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1248] = {
    [sym_expression] = STATE(2848),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4424),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1965),
    [anon_sym_compl] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_sizeof] = ACTIONS(1973),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1249] = {
    [sym_expression] = STATE(3112),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2029),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [1250] = {
    [sym_expression] = STATE(3112),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(4780),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2029),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [1251] = {
    [sym_expression] = STATE(2325),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4424),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1965),
    [anon_sym_compl] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_sizeof] = ACTIONS(1973),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1252] = {
    [sym_expression] = STATE(2850),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4424),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1965),
    [anon_sym_compl] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_sizeof] = ACTIONS(1973),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1253] = {
    [sym_expression] = STATE(2851),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4424),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1965),
    [anon_sym_compl] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_sizeof] = ACTIONS(1973),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1254] = {
    [sym_expression] = STATE(2855),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4424),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1965),
    [anon_sym_compl] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_sizeof] = ACTIONS(1973),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1255] = {
    [sym_expression] = STATE(3099),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2029),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [1256] = {
    [sym_expression] = STATE(2856),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4424),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1965),
    [anon_sym_compl] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_sizeof] = ACTIONS(1973),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1257] = {
    [sym_expression] = STATE(2857),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4424),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1965),
    [anon_sym_compl] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_sizeof] = ACTIONS(1973),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1258] = {
    [sym_expression] = STATE(4250),
    [sym__string] = STATE(4345),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3286),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3286),
    [sym_call_expression] = STATE(3286),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3286),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3286),
    [sym_char_literal] = STATE(4345),
    [sym_concatenated_string] = STATE(4345),
    [sym_string_literal] = STATE(3370),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3370),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3286),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3286),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_LPAREN2] = ACTIONS(4388),
    [anon_sym_BANG] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3496),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym___extension__] = ACTIONS(3500),
    [anon_sym_COLON_COLON] = ACTIONS(3502),
    [anon_sym_LBRACK] = ACTIONS(4611),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3496),
    [anon_sym_compl] = ACTIONS(3496),
    [anon_sym_DASH_DASH] = ACTIONS(4394),
    [anon_sym_PLUS_PLUS] = ACTIONS(4394),
    [anon_sym_sizeof] = ACTIONS(3504),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3506),
    [anon_sym_L_SQUOTE] = ACTIONS(3508),
    [anon_sym_u_SQUOTE] = ACTIONS(3508),
    [anon_sym_U_SQUOTE] = ACTIONS(3508),
    [anon_sym_u8_SQUOTE] = ACTIONS(3508),
    [anon_sym_SQUOTE] = ACTIONS(3508),
    [anon_sym_L_DQUOTE] = ACTIONS(3510),
    [anon_sym_u_DQUOTE] = ACTIONS(3510),
    [anon_sym_U_DQUOTE] = ACTIONS(3510),
    [anon_sym_u8_DQUOTE] = ACTIONS(3510),
    [anon_sym_DQUOTE] = ACTIONS(3510),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3512),
    [anon_sym_R_DQUOTE] = ACTIONS(3514),
    [anon_sym_LR_DQUOTE] = ACTIONS(3514),
    [anon_sym_uR_DQUOTE] = ACTIONS(3514),
    [anon_sym_UR_DQUOTE] = ACTIONS(3514),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3514),
    [anon_sym_co_await] = ACTIONS(3516),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1259] = {
    [sym_expression] = STATE(2858),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4424),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1965),
    [anon_sym_compl] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_sizeof] = ACTIONS(1973),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1260] = {
    [sym_expression] = STATE(2859),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4424),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1965),
    [anon_sym_compl] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_sizeof] = ACTIONS(1973),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1261] = {
    [sym_expression] = STATE(3653),
    [sym__string] = STATE(4345),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3286),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3286),
    [sym_call_expression] = STATE(3286),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3286),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3286),
    [sym_char_literal] = STATE(4345),
    [sym_concatenated_string] = STATE(4345),
    [sym_string_literal] = STATE(3370),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3370),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3286),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3286),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_LPAREN2] = ACTIONS(4388),
    [anon_sym_BANG] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3496),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym___extension__] = ACTIONS(3500),
    [anon_sym_COLON_COLON] = ACTIONS(3502),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3496),
    [anon_sym_compl] = ACTIONS(3496),
    [anon_sym_DASH_DASH] = ACTIONS(4394),
    [anon_sym_PLUS_PLUS] = ACTIONS(4394),
    [anon_sym_sizeof] = ACTIONS(3504),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3506),
    [anon_sym_L_SQUOTE] = ACTIONS(3508),
    [anon_sym_u_SQUOTE] = ACTIONS(3508),
    [anon_sym_U_SQUOTE] = ACTIONS(3508),
    [anon_sym_u8_SQUOTE] = ACTIONS(3508),
    [anon_sym_SQUOTE] = ACTIONS(3508),
    [anon_sym_L_DQUOTE] = ACTIONS(3510),
    [anon_sym_u_DQUOTE] = ACTIONS(3510),
    [anon_sym_U_DQUOTE] = ACTIONS(3510),
    [anon_sym_u8_DQUOTE] = ACTIONS(3510),
    [anon_sym_DQUOTE] = ACTIONS(3510),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3512),
    [anon_sym_R_DQUOTE] = ACTIONS(3514),
    [anon_sym_LR_DQUOTE] = ACTIONS(3514),
    [anon_sym_uR_DQUOTE] = ACTIONS(3514),
    [anon_sym_UR_DQUOTE] = ACTIONS(3514),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3514),
    [anon_sym_co_await] = ACTIONS(3516),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1262] = {
    [sym_expression] = STATE(2860),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4424),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1965),
    [anon_sym_compl] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_sizeof] = ACTIONS(1973),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1263] = {
    [sym_expression] = STATE(3141),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2029),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [1264] = {
    [sym_expression] = STATE(3226),
    [sym__string] = STATE(3374),
    [sym_conditional_expression] = STATE(3536),
    [sym_assignment_expression] = STATE(3536),
    [sym_pointer_expression] = STATE(3544),
    [sym_unary_expression] = STATE(3536),
    [sym_binary_expression] = STATE(3536),
    [sym_update_expression] = STATE(3536),
    [sym_cast_expression] = STATE(3536),
    [sym_sizeof_expression] = STATE(3536),
    [sym_alignof_expression] = STATE(3536),
    [sym_offsetof_expression] = STATE(3536),
    [sym_generic_expression] = STATE(3536),
    [sym_subscript_expression] = STATE(3544),
    [sym_call_expression] = STATE(3544),
    [sym_gnu_asm_expression] = STATE(3536),
    [sym_extension_expression] = STATE(3536),
    [sym_field_expression] = STATE(3544),
    [sym_compound_literal_expression] = STATE(3536),
    [sym_parenthesized_expression] = STATE(3544),
    [sym_char_literal] = STATE(3374),
    [sym_concatenated_string] = STATE(3374),
    [sym_string_literal] = STATE(2363),
    [sym_null] = STATE(3536),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7597),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3536),
    [sym_raw_string_literal] = STATE(2363),
    [sym_co_await_expression] = STATE(3536),
    [sym_new_expression] = STATE(3536),
    [sym_delete_expression] = STATE(3536),
    [sym_requires_clause] = STATE(3536),
    [sym_requires_expression] = STATE(3536),
    [sym_lambda_expression] = STATE(3536),
    [sym_lambda_capture_specifier] = STATE(5874),
    [sym_fold_expression] = STATE(3536),
    [sym_parameter_pack_expansion] = STATE(3536),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3544),
    [sym_qualified_type_identifier] = STATE(7597),
    [sym_user_defined_literal] = STATE(3544),
    [sym_identifier] = ACTIONS(2446),
    [anon_sym_LPAREN2] = ACTIONS(4521),
    [anon_sym_BANG] = ACTIONS(2450),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2448),
    [anon_sym_PLUS] = ACTIONS(2448),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(2452),
    [anon_sym_COLON_COLON] = ACTIONS(2454),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2458),
    [anon_sym_not] = ACTIONS(2448),
    [anon_sym_compl] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(4478),
    [anon_sym_PLUS_PLUS] = ACTIONS(4478),
    [anon_sym_sizeof] = ACTIONS(2460),
    [anon_sym___alignof__] = ACTIONS(2462),
    [anon_sym___alignof] = ACTIONS(2462),
    [anon_sym__alignof] = ACTIONS(2462),
    [anon_sym_alignof] = ACTIONS(2462),
    [anon_sym__Alignof] = ACTIONS(2462),
    [anon_sym_offsetof] = ACTIONS(2464),
    [anon_sym__Generic] = ACTIONS(2466),
    [anon_sym_asm] = ACTIONS(2468),
    [anon_sym___asm__] = ACTIONS(2468),
    [anon_sym___asm] = ACTIONS(2468),
    [sym_number_literal] = ACTIONS(2470),
    [anon_sym_L_SQUOTE] = ACTIONS(2472),
    [anon_sym_u_SQUOTE] = ACTIONS(2472),
    [anon_sym_U_SQUOTE] = ACTIONS(2472),
    [anon_sym_u8_SQUOTE] = ACTIONS(2472),
    [anon_sym_SQUOTE] = ACTIONS(2472),
    [anon_sym_L_DQUOTE] = ACTIONS(2474),
    [anon_sym_u_DQUOTE] = ACTIONS(2474),
    [anon_sym_U_DQUOTE] = ACTIONS(2474),
    [anon_sym_u8_DQUOTE] = ACTIONS(2474),
    [anon_sym_DQUOTE] = ACTIONS(2474),
    [sym_true] = ACTIONS(2476),
    [sym_false] = ACTIONS(2476),
    [anon_sym_NULL] = ACTIONS(2478),
    [anon_sym_nullptr] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2480),
    [anon_sym_R_DQUOTE] = ACTIONS(2482),
    [anon_sym_LR_DQUOTE] = ACTIONS(2482),
    [anon_sym_uR_DQUOTE] = ACTIONS(2482),
    [anon_sym_UR_DQUOTE] = ACTIONS(2482),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2482),
    [anon_sym_co_await] = ACTIONS(2484),
    [anon_sym_new] = ACTIONS(2486),
    [anon_sym_requires] = ACTIONS(2488),
    [sym_this] = ACTIONS(2476),
  },
  [1265] = {
    [sym_expression] = STATE(4249),
    [sym__string] = STATE(4345),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3286),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3286),
    [sym_call_expression] = STATE(3286),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3286),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3286),
    [sym_char_literal] = STATE(4345),
    [sym_concatenated_string] = STATE(4345),
    [sym_string_literal] = STATE(3370),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3370),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3286),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3286),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_LPAREN2] = ACTIONS(4388),
    [anon_sym_BANG] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3496),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym___extension__] = ACTIONS(3500),
    [anon_sym_COLON_COLON] = ACTIONS(3502),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3496),
    [anon_sym_compl] = ACTIONS(3496),
    [anon_sym_DASH_DASH] = ACTIONS(4394),
    [anon_sym_PLUS_PLUS] = ACTIONS(4394),
    [anon_sym_sizeof] = ACTIONS(3504),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3506),
    [anon_sym_L_SQUOTE] = ACTIONS(3508),
    [anon_sym_u_SQUOTE] = ACTIONS(3508),
    [anon_sym_U_SQUOTE] = ACTIONS(3508),
    [anon_sym_u8_SQUOTE] = ACTIONS(3508),
    [anon_sym_SQUOTE] = ACTIONS(3508),
    [anon_sym_L_DQUOTE] = ACTIONS(3510),
    [anon_sym_u_DQUOTE] = ACTIONS(3510),
    [anon_sym_U_DQUOTE] = ACTIONS(3510),
    [anon_sym_u8_DQUOTE] = ACTIONS(3510),
    [anon_sym_DQUOTE] = ACTIONS(3510),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3512),
    [anon_sym_R_DQUOTE] = ACTIONS(3514),
    [anon_sym_LR_DQUOTE] = ACTIONS(3514),
    [anon_sym_uR_DQUOTE] = ACTIONS(3514),
    [anon_sym_UR_DQUOTE] = ACTIONS(3514),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3514),
    [anon_sym_co_await] = ACTIONS(3516),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1266] = {
    [sym_expression] = STATE(4226),
    [sym__string] = STATE(4345),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3286),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3286),
    [sym_call_expression] = STATE(3286),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3286),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3286),
    [sym_char_literal] = STATE(4345),
    [sym_concatenated_string] = STATE(4345),
    [sym_string_literal] = STATE(3370),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3370),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3286),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3286),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_LPAREN2] = ACTIONS(4388),
    [anon_sym_BANG] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3496),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym___extension__] = ACTIONS(3500),
    [anon_sym_COLON_COLON] = ACTIONS(3502),
    [anon_sym_LBRACK] = ACTIONS(4782),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3496),
    [anon_sym_compl] = ACTIONS(3496),
    [anon_sym_DASH_DASH] = ACTIONS(4394),
    [anon_sym_PLUS_PLUS] = ACTIONS(4394),
    [anon_sym_sizeof] = ACTIONS(3504),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3506),
    [anon_sym_L_SQUOTE] = ACTIONS(3508),
    [anon_sym_u_SQUOTE] = ACTIONS(3508),
    [anon_sym_U_SQUOTE] = ACTIONS(3508),
    [anon_sym_u8_SQUOTE] = ACTIONS(3508),
    [anon_sym_SQUOTE] = ACTIONS(3508),
    [anon_sym_L_DQUOTE] = ACTIONS(3510),
    [anon_sym_u_DQUOTE] = ACTIONS(3510),
    [anon_sym_U_DQUOTE] = ACTIONS(3510),
    [anon_sym_u8_DQUOTE] = ACTIONS(3510),
    [anon_sym_DQUOTE] = ACTIONS(3510),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3512),
    [anon_sym_R_DQUOTE] = ACTIONS(3514),
    [anon_sym_LR_DQUOTE] = ACTIONS(3514),
    [anon_sym_uR_DQUOTE] = ACTIONS(3514),
    [anon_sym_UR_DQUOTE] = ACTIONS(3514),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3514),
    [anon_sym_co_await] = ACTIONS(3516),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1267] = {
    [sym_expression] = STATE(4230),
    [sym__string] = STATE(4345),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3286),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3286),
    [sym_call_expression] = STATE(3286),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3286),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3286),
    [sym_char_literal] = STATE(4345),
    [sym_concatenated_string] = STATE(4345),
    [sym_string_literal] = STATE(3370),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3370),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3286),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3286),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_LPAREN2] = ACTIONS(4388),
    [anon_sym_BANG] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3496),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym___extension__] = ACTIONS(3500),
    [anon_sym_COLON_COLON] = ACTIONS(3502),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3496),
    [anon_sym_compl] = ACTIONS(3496),
    [anon_sym_DASH_DASH] = ACTIONS(4394),
    [anon_sym_PLUS_PLUS] = ACTIONS(4394),
    [anon_sym_sizeof] = ACTIONS(3504),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3506),
    [anon_sym_L_SQUOTE] = ACTIONS(3508),
    [anon_sym_u_SQUOTE] = ACTIONS(3508),
    [anon_sym_U_SQUOTE] = ACTIONS(3508),
    [anon_sym_u8_SQUOTE] = ACTIONS(3508),
    [anon_sym_SQUOTE] = ACTIONS(3508),
    [anon_sym_L_DQUOTE] = ACTIONS(3510),
    [anon_sym_u_DQUOTE] = ACTIONS(3510),
    [anon_sym_U_DQUOTE] = ACTIONS(3510),
    [anon_sym_u8_DQUOTE] = ACTIONS(3510),
    [anon_sym_DQUOTE] = ACTIONS(3510),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3512),
    [anon_sym_R_DQUOTE] = ACTIONS(3514),
    [anon_sym_LR_DQUOTE] = ACTIONS(3514),
    [anon_sym_uR_DQUOTE] = ACTIONS(3514),
    [anon_sym_UR_DQUOTE] = ACTIONS(3514),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3514),
    [anon_sym_co_await] = ACTIONS(3516),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1268] = {
    [sym_expression] = STATE(3675),
    [sym__string] = STATE(4345),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3286),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3286),
    [sym_call_expression] = STATE(3286),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3286),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3286),
    [sym_char_literal] = STATE(4345),
    [sym_concatenated_string] = STATE(4345),
    [sym_string_literal] = STATE(3370),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3370),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3286),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3286),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_LPAREN2] = ACTIONS(4388),
    [anon_sym_BANG] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3496),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym___extension__] = ACTIONS(3500),
    [anon_sym_COLON_COLON] = ACTIONS(3502),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3496),
    [anon_sym_compl] = ACTIONS(3496),
    [anon_sym_DASH_DASH] = ACTIONS(4394),
    [anon_sym_PLUS_PLUS] = ACTIONS(4394),
    [anon_sym_sizeof] = ACTIONS(3504),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3506),
    [anon_sym_L_SQUOTE] = ACTIONS(3508),
    [anon_sym_u_SQUOTE] = ACTIONS(3508),
    [anon_sym_U_SQUOTE] = ACTIONS(3508),
    [anon_sym_u8_SQUOTE] = ACTIONS(3508),
    [anon_sym_SQUOTE] = ACTIONS(3508),
    [anon_sym_L_DQUOTE] = ACTIONS(3510),
    [anon_sym_u_DQUOTE] = ACTIONS(3510),
    [anon_sym_U_DQUOTE] = ACTIONS(3510),
    [anon_sym_u8_DQUOTE] = ACTIONS(3510),
    [anon_sym_DQUOTE] = ACTIONS(3510),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3512),
    [anon_sym_R_DQUOTE] = ACTIONS(3514),
    [anon_sym_LR_DQUOTE] = ACTIONS(3514),
    [anon_sym_uR_DQUOTE] = ACTIONS(3514),
    [anon_sym_UR_DQUOTE] = ACTIONS(3514),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3514),
    [anon_sym_co_await] = ACTIONS(3516),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1269] = {
    [sym_expression] = STATE(4231),
    [sym__string] = STATE(4345),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3286),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3286),
    [sym_call_expression] = STATE(3286),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3286),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3286),
    [sym_char_literal] = STATE(4345),
    [sym_concatenated_string] = STATE(4345),
    [sym_string_literal] = STATE(3370),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3370),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3286),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3286),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_LPAREN2] = ACTIONS(4388),
    [anon_sym_BANG] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3496),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym___extension__] = ACTIONS(3500),
    [anon_sym_COLON_COLON] = ACTIONS(3502),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3496),
    [anon_sym_compl] = ACTIONS(3496),
    [anon_sym_DASH_DASH] = ACTIONS(4394),
    [anon_sym_PLUS_PLUS] = ACTIONS(4394),
    [anon_sym_sizeof] = ACTIONS(3504),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3506),
    [anon_sym_L_SQUOTE] = ACTIONS(3508),
    [anon_sym_u_SQUOTE] = ACTIONS(3508),
    [anon_sym_U_SQUOTE] = ACTIONS(3508),
    [anon_sym_u8_SQUOTE] = ACTIONS(3508),
    [anon_sym_SQUOTE] = ACTIONS(3508),
    [anon_sym_L_DQUOTE] = ACTIONS(3510),
    [anon_sym_u_DQUOTE] = ACTIONS(3510),
    [anon_sym_U_DQUOTE] = ACTIONS(3510),
    [anon_sym_u8_DQUOTE] = ACTIONS(3510),
    [anon_sym_DQUOTE] = ACTIONS(3510),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3512),
    [anon_sym_R_DQUOTE] = ACTIONS(3514),
    [anon_sym_LR_DQUOTE] = ACTIONS(3514),
    [anon_sym_uR_DQUOTE] = ACTIONS(3514),
    [anon_sym_UR_DQUOTE] = ACTIONS(3514),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3514),
    [anon_sym_co_await] = ACTIONS(3516),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1270] = {
    [sym_expression] = STATE(4232),
    [sym__string] = STATE(4345),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3286),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3286),
    [sym_call_expression] = STATE(3286),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3286),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3286),
    [sym_char_literal] = STATE(4345),
    [sym_concatenated_string] = STATE(4345),
    [sym_string_literal] = STATE(3370),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3370),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3286),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3286),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_LPAREN2] = ACTIONS(4388),
    [anon_sym_BANG] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3496),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym___extension__] = ACTIONS(3500),
    [anon_sym_COLON_COLON] = ACTIONS(3502),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3496),
    [anon_sym_compl] = ACTIONS(3496),
    [anon_sym_DASH_DASH] = ACTIONS(4394),
    [anon_sym_PLUS_PLUS] = ACTIONS(4394),
    [anon_sym_sizeof] = ACTIONS(3504),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3506),
    [anon_sym_L_SQUOTE] = ACTIONS(3508),
    [anon_sym_u_SQUOTE] = ACTIONS(3508),
    [anon_sym_U_SQUOTE] = ACTIONS(3508),
    [anon_sym_u8_SQUOTE] = ACTIONS(3508),
    [anon_sym_SQUOTE] = ACTIONS(3508),
    [anon_sym_L_DQUOTE] = ACTIONS(3510),
    [anon_sym_u_DQUOTE] = ACTIONS(3510),
    [anon_sym_U_DQUOTE] = ACTIONS(3510),
    [anon_sym_u8_DQUOTE] = ACTIONS(3510),
    [anon_sym_DQUOTE] = ACTIONS(3510),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3512),
    [anon_sym_R_DQUOTE] = ACTIONS(3514),
    [anon_sym_LR_DQUOTE] = ACTIONS(3514),
    [anon_sym_uR_DQUOTE] = ACTIONS(3514),
    [anon_sym_UR_DQUOTE] = ACTIONS(3514),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3514),
    [anon_sym_co_await] = ACTIONS(3516),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1271] = {
    [sym_expression] = STATE(4234),
    [sym__string] = STATE(4345),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3286),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3286),
    [sym_call_expression] = STATE(3286),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3286),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3286),
    [sym_char_literal] = STATE(4345),
    [sym_concatenated_string] = STATE(4345),
    [sym_string_literal] = STATE(3370),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3370),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3286),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3286),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_LPAREN2] = ACTIONS(4388),
    [anon_sym_BANG] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3496),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym___extension__] = ACTIONS(3500),
    [anon_sym_COLON_COLON] = ACTIONS(3502),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3496),
    [anon_sym_compl] = ACTIONS(3496),
    [anon_sym_DASH_DASH] = ACTIONS(4394),
    [anon_sym_PLUS_PLUS] = ACTIONS(4394),
    [anon_sym_sizeof] = ACTIONS(3504),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3506),
    [anon_sym_L_SQUOTE] = ACTIONS(3508),
    [anon_sym_u_SQUOTE] = ACTIONS(3508),
    [anon_sym_U_SQUOTE] = ACTIONS(3508),
    [anon_sym_u8_SQUOTE] = ACTIONS(3508),
    [anon_sym_SQUOTE] = ACTIONS(3508),
    [anon_sym_L_DQUOTE] = ACTIONS(3510),
    [anon_sym_u_DQUOTE] = ACTIONS(3510),
    [anon_sym_U_DQUOTE] = ACTIONS(3510),
    [anon_sym_u8_DQUOTE] = ACTIONS(3510),
    [anon_sym_DQUOTE] = ACTIONS(3510),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3512),
    [anon_sym_R_DQUOTE] = ACTIONS(3514),
    [anon_sym_LR_DQUOTE] = ACTIONS(3514),
    [anon_sym_uR_DQUOTE] = ACTIONS(3514),
    [anon_sym_UR_DQUOTE] = ACTIONS(3514),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3514),
    [anon_sym_co_await] = ACTIONS(3516),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1272] = {
    [sym_expression] = STATE(4238),
    [sym__string] = STATE(4345),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3286),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3286),
    [sym_call_expression] = STATE(3286),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3286),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3286),
    [sym_char_literal] = STATE(4345),
    [sym_concatenated_string] = STATE(4345),
    [sym_string_literal] = STATE(3370),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3370),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3286),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3286),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_LPAREN2] = ACTIONS(4388),
    [anon_sym_BANG] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3496),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym___extension__] = ACTIONS(3500),
    [anon_sym_COLON_COLON] = ACTIONS(3502),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3496),
    [anon_sym_compl] = ACTIONS(3496),
    [anon_sym_DASH_DASH] = ACTIONS(4394),
    [anon_sym_PLUS_PLUS] = ACTIONS(4394),
    [anon_sym_sizeof] = ACTIONS(3504),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3506),
    [anon_sym_L_SQUOTE] = ACTIONS(3508),
    [anon_sym_u_SQUOTE] = ACTIONS(3508),
    [anon_sym_U_SQUOTE] = ACTIONS(3508),
    [anon_sym_u8_SQUOTE] = ACTIONS(3508),
    [anon_sym_SQUOTE] = ACTIONS(3508),
    [anon_sym_L_DQUOTE] = ACTIONS(3510),
    [anon_sym_u_DQUOTE] = ACTIONS(3510),
    [anon_sym_U_DQUOTE] = ACTIONS(3510),
    [anon_sym_u8_DQUOTE] = ACTIONS(3510),
    [anon_sym_DQUOTE] = ACTIONS(3510),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3512),
    [anon_sym_R_DQUOTE] = ACTIONS(3514),
    [anon_sym_LR_DQUOTE] = ACTIONS(3514),
    [anon_sym_uR_DQUOTE] = ACTIONS(3514),
    [anon_sym_UR_DQUOTE] = ACTIONS(3514),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3514),
    [anon_sym_co_await] = ACTIONS(3516),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1273] = {
    [sym_expression] = STATE(4275),
    [sym__string] = STATE(4345),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3286),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3286),
    [sym_call_expression] = STATE(3286),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3286),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3286),
    [sym_char_literal] = STATE(4345),
    [sym_concatenated_string] = STATE(4345),
    [sym_string_literal] = STATE(3370),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3370),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3286),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3286),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_LPAREN2] = ACTIONS(4388),
    [anon_sym_BANG] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3496),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym___extension__] = ACTIONS(3500),
    [anon_sym_COLON_COLON] = ACTIONS(3502),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3496),
    [anon_sym_compl] = ACTIONS(3496),
    [anon_sym_DASH_DASH] = ACTIONS(4394),
    [anon_sym_PLUS_PLUS] = ACTIONS(4394),
    [anon_sym_sizeof] = ACTIONS(3504),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3506),
    [anon_sym_L_SQUOTE] = ACTIONS(3508),
    [anon_sym_u_SQUOTE] = ACTIONS(3508),
    [anon_sym_U_SQUOTE] = ACTIONS(3508),
    [anon_sym_u8_SQUOTE] = ACTIONS(3508),
    [anon_sym_SQUOTE] = ACTIONS(3508),
    [anon_sym_L_DQUOTE] = ACTIONS(3510),
    [anon_sym_u_DQUOTE] = ACTIONS(3510),
    [anon_sym_U_DQUOTE] = ACTIONS(3510),
    [anon_sym_u8_DQUOTE] = ACTIONS(3510),
    [anon_sym_DQUOTE] = ACTIONS(3510),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3512),
    [anon_sym_R_DQUOTE] = ACTIONS(3514),
    [anon_sym_LR_DQUOTE] = ACTIONS(3514),
    [anon_sym_uR_DQUOTE] = ACTIONS(3514),
    [anon_sym_UR_DQUOTE] = ACTIONS(3514),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3514),
    [anon_sym_co_await] = ACTIONS(3516),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1274] = {
    [sym_expression] = STATE(4241),
    [sym__string] = STATE(4345),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3286),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3286),
    [sym_call_expression] = STATE(3286),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3286),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3286),
    [sym_char_literal] = STATE(4345),
    [sym_concatenated_string] = STATE(4345),
    [sym_string_literal] = STATE(3370),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3370),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3286),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3286),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_LPAREN2] = ACTIONS(4388),
    [anon_sym_BANG] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3496),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym___extension__] = ACTIONS(3500),
    [anon_sym_COLON_COLON] = ACTIONS(3502),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3496),
    [anon_sym_compl] = ACTIONS(3496),
    [anon_sym_DASH_DASH] = ACTIONS(4394),
    [anon_sym_PLUS_PLUS] = ACTIONS(4394),
    [anon_sym_sizeof] = ACTIONS(3504),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3506),
    [anon_sym_L_SQUOTE] = ACTIONS(3508),
    [anon_sym_u_SQUOTE] = ACTIONS(3508),
    [anon_sym_U_SQUOTE] = ACTIONS(3508),
    [anon_sym_u8_SQUOTE] = ACTIONS(3508),
    [anon_sym_SQUOTE] = ACTIONS(3508),
    [anon_sym_L_DQUOTE] = ACTIONS(3510),
    [anon_sym_u_DQUOTE] = ACTIONS(3510),
    [anon_sym_U_DQUOTE] = ACTIONS(3510),
    [anon_sym_u8_DQUOTE] = ACTIONS(3510),
    [anon_sym_DQUOTE] = ACTIONS(3510),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3512),
    [anon_sym_R_DQUOTE] = ACTIONS(3514),
    [anon_sym_LR_DQUOTE] = ACTIONS(3514),
    [anon_sym_uR_DQUOTE] = ACTIONS(3514),
    [anon_sym_UR_DQUOTE] = ACTIONS(3514),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3514),
    [anon_sym_co_await] = ACTIONS(3516),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1275] = {
    [sym_expression] = STATE(4243),
    [sym__string] = STATE(4345),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3286),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3286),
    [sym_call_expression] = STATE(3286),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3286),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3286),
    [sym_char_literal] = STATE(4345),
    [sym_concatenated_string] = STATE(4345),
    [sym_string_literal] = STATE(3370),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3370),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3286),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3286),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_LPAREN2] = ACTIONS(4388),
    [anon_sym_BANG] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3496),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym___extension__] = ACTIONS(3500),
    [anon_sym_COLON_COLON] = ACTIONS(3502),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3496),
    [anon_sym_compl] = ACTIONS(3496),
    [anon_sym_DASH_DASH] = ACTIONS(4394),
    [anon_sym_PLUS_PLUS] = ACTIONS(4394),
    [anon_sym_sizeof] = ACTIONS(3504),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3506),
    [anon_sym_L_SQUOTE] = ACTIONS(3508),
    [anon_sym_u_SQUOTE] = ACTIONS(3508),
    [anon_sym_U_SQUOTE] = ACTIONS(3508),
    [anon_sym_u8_SQUOTE] = ACTIONS(3508),
    [anon_sym_SQUOTE] = ACTIONS(3508),
    [anon_sym_L_DQUOTE] = ACTIONS(3510),
    [anon_sym_u_DQUOTE] = ACTIONS(3510),
    [anon_sym_U_DQUOTE] = ACTIONS(3510),
    [anon_sym_u8_DQUOTE] = ACTIONS(3510),
    [anon_sym_DQUOTE] = ACTIONS(3510),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3512),
    [anon_sym_R_DQUOTE] = ACTIONS(3514),
    [anon_sym_LR_DQUOTE] = ACTIONS(3514),
    [anon_sym_uR_DQUOTE] = ACTIONS(3514),
    [anon_sym_UR_DQUOTE] = ACTIONS(3514),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3514),
    [anon_sym_co_await] = ACTIONS(3516),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1276] = {
    [sym_expression] = STATE(4244),
    [sym__string] = STATE(4345),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3286),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3286),
    [sym_call_expression] = STATE(3286),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3286),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3286),
    [sym_char_literal] = STATE(4345),
    [sym_concatenated_string] = STATE(4345),
    [sym_string_literal] = STATE(3370),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3370),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3286),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3286),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_LPAREN2] = ACTIONS(4388),
    [anon_sym_BANG] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3496),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym___extension__] = ACTIONS(3500),
    [anon_sym_COLON_COLON] = ACTIONS(3502),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3496),
    [anon_sym_compl] = ACTIONS(3496),
    [anon_sym_DASH_DASH] = ACTIONS(4394),
    [anon_sym_PLUS_PLUS] = ACTIONS(4394),
    [anon_sym_sizeof] = ACTIONS(3504),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3506),
    [anon_sym_L_SQUOTE] = ACTIONS(3508),
    [anon_sym_u_SQUOTE] = ACTIONS(3508),
    [anon_sym_U_SQUOTE] = ACTIONS(3508),
    [anon_sym_u8_SQUOTE] = ACTIONS(3508),
    [anon_sym_SQUOTE] = ACTIONS(3508),
    [anon_sym_L_DQUOTE] = ACTIONS(3510),
    [anon_sym_u_DQUOTE] = ACTIONS(3510),
    [anon_sym_U_DQUOTE] = ACTIONS(3510),
    [anon_sym_u8_DQUOTE] = ACTIONS(3510),
    [anon_sym_DQUOTE] = ACTIONS(3510),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3512),
    [anon_sym_R_DQUOTE] = ACTIONS(3514),
    [anon_sym_LR_DQUOTE] = ACTIONS(3514),
    [anon_sym_uR_DQUOTE] = ACTIONS(3514),
    [anon_sym_UR_DQUOTE] = ACTIONS(3514),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3514),
    [anon_sym_co_await] = ACTIONS(3516),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1277] = {
    [sym_expression] = STATE(4245),
    [sym__string] = STATE(4345),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3286),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3286),
    [sym_call_expression] = STATE(3286),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3286),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3286),
    [sym_char_literal] = STATE(4345),
    [sym_concatenated_string] = STATE(4345),
    [sym_string_literal] = STATE(3370),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3370),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3286),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3286),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_LPAREN2] = ACTIONS(4388),
    [anon_sym_BANG] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3496),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym___extension__] = ACTIONS(3500),
    [anon_sym_COLON_COLON] = ACTIONS(3502),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3496),
    [anon_sym_compl] = ACTIONS(3496),
    [anon_sym_DASH_DASH] = ACTIONS(4394),
    [anon_sym_PLUS_PLUS] = ACTIONS(4394),
    [anon_sym_sizeof] = ACTIONS(3504),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3506),
    [anon_sym_L_SQUOTE] = ACTIONS(3508),
    [anon_sym_u_SQUOTE] = ACTIONS(3508),
    [anon_sym_U_SQUOTE] = ACTIONS(3508),
    [anon_sym_u8_SQUOTE] = ACTIONS(3508),
    [anon_sym_SQUOTE] = ACTIONS(3508),
    [anon_sym_L_DQUOTE] = ACTIONS(3510),
    [anon_sym_u_DQUOTE] = ACTIONS(3510),
    [anon_sym_U_DQUOTE] = ACTIONS(3510),
    [anon_sym_u8_DQUOTE] = ACTIONS(3510),
    [anon_sym_DQUOTE] = ACTIONS(3510),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3512),
    [anon_sym_R_DQUOTE] = ACTIONS(3514),
    [anon_sym_LR_DQUOTE] = ACTIONS(3514),
    [anon_sym_uR_DQUOTE] = ACTIONS(3514),
    [anon_sym_UR_DQUOTE] = ACTIONS(3514),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3514),
    [anon_sym_co_await] = ACTIONS(3516),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1278] = {
    [sym_expression] = STATE(4575),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1279] = {
    [sym_expression] = STATE(4579),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3740),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1280] = {
    [sym_expression] = STATE(4585),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1281] = {
    [sym_expression] = STATE(4112),
    [sym__string] = STATE(4127),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(2853),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(2853),
    [sym_call_expression] = STATE(2853),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(2853),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(2853),
    [sym_char_literal] = STATE(4127),
    [sym_concatenated_string] = STATE(4127),
    [sym_string_literal] = STATE(3058),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3058),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2853),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(2853),
    [sym_identifier] = ACTIONS(4470),
    [anon_sym_LPAREN2] = ACTIONS(4509),
    [anon_sym_BANG] = ACTIONS(3460),
    [anon_sym_TILDE] = ACTIONS(3460),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_AMP] = ACTIONS(4505),
    [anon_sym___extension__] = ACTIONS(3462),
    [anon_sym_COLON_COLON] = ACTIONS(3464),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3458),
    [anon_sym_compl] = ACTIONS(3458),
    [anon_sym_DASH_DASH] = ACTIONS(4472),
    [anon_sym_PLUS_PLUS] = ACTIONS(4472),
    [anon_sym_sizeof] = ACTIONS(3468),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3470),
    [anon_sym_L_SQUOTE] = ACTIONS(3472),
    [anon_sym_u_SQUOTE] = ACTIONS(3472),
    [anon_sym_U_SQUOTE] = ACTIONS(3472),
    [anon_sym_u8_SQUOTE] = ACTIONS(3472),
    [anon_sym_SQUOTE] = ACTIONS(3472),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3476),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
    [anon_sym_co_await] = ACTIONS(3480),
    [anon_sym_new] = ACTIONS(3482),
    [anon_sym_requires] = ACTIONS(3484),
    [sym_this] = ACTIONS(221),
  },
  [1282] = {
    [sym_expression] = STATE(4264),
    [sym__string] = STATE(4345),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3286),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3286),
    [sym_call_expression] = STATE(3286),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3286),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3286),
    [sym_char_literal] = STATE(4345),
    [sym_concatenated_string] = STATE(4345),
    [sym_string_literal] = STATE(3370),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3370),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3286),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3286),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_LPAREN2] = ACTIONS(4388),
    [anon_sym_BANG] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3496),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym___extension__] = ACTIONS(3500),
    [anon_sym_COLON_COLON] = ACTIONS(3502),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3496),
    [anon_sym_compl] = ACTIONS(3496),
    [anon_sym_DASH_DASH] = ACTIONS(4394),
    [anon_sym_PLUS_PLUS] = ACTIONS(4394),
    [anon_sym_sizeof] = ACTIONS(3504),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3506),
    [anon_sym_L_SQUOTE] = ACTIONS(3508),
    [anon_sym_u_SQUOTE] = ACTIONS(3508),
    [anon_sym_U_SQUOTE] = ACTIONS(3508),
    [anon_sym_u8_SQUOTE] = ACTIONS(3508),
    [anon_sym_SQUOTE] = ACTIONS(3508),
    [anon_sym_L_DQUOTE] = ACTIONS(3510),
    [anon_sym_u_DQUOTE] = ACTIONS(3510),
    [anon_sym_U_DQUOTE] = ACTIONS(3510),
    [anon_sym_u8_DQUOTE] = ACTIONS(3510),
    [anon_sym_DQUOTE] = ACTIONS(3510),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3512),
    [anon_sym_R_DQUOTE] = ACTIONS(3514),
    [anon_sym_LR_DQUOTE] = ACTIONS(3514),
    [anon_sym_uR_DQUOTE] = ACTIONS(3514),
    [anon_sym_UR_DQUOTE] = ACTIONS(3514),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3514),
    [anon_sym_co_await] = ACTIONS(3516),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1283] = {
    [sym_expression] = STATE(4220),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1284] = {
    [sym_expression] = STATE(3675),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1285] = {
    [sym_expression] = STATE(4224),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1286] = {
    [sym_expression] = STATE(4225),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1287] = {
    [sym_expression] = STATE(4444),
    [sym__string] = STATE(4637),
    [sym_conditional_expression] = STATE(4735),
    [sym_assignment_expression] = STATE(4735),
    [sym_pointer_expression] = STATE(3573),
    [sym_unary_expression] = STATE(4735),
    [sym_binary_expression] = STATE(4735),
    [sym_update_expression] = STATE(4735),
    [sym_cast_expression] = STATE(4735),
    [sym_sizeof_expression] = STATE(4735),
    [sym_alignof_expression] = STATE(4735),
    [sym_offsetof_expression] = STATE(4735),
    [sym_generic_expression] = STATE(4735),
    [sym_subscript_expression] = STATE(3573),
    [sym_call_expression] = STATE(3573),
    [sym_gnu_asm_expression] = STATE(4735),
    [sym_extension_expression] = STATE(4735),
    [sym_field_expression] = STATE(3573),
    [sym_compound_literal_expression] = STATE(4735),
    [sym_parenthesized_expression] = STATE(3573),
    [sym_char_literal] = STATE(4637),
    [sym_concatenated_string] = STATE(4637),
    [sym_string_literal] = STATE(3662),
    [sym_null] = STATE(4735),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7513),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(4735),
    [sym_raw_string_literal] = STATE(3662),
    [sym_co_await_expression] = STATE(4735),
    [sym_new_expression] = STATE(4735),
    [sym_delete_expression] = STATE(4735),
    [sym_requires_clause] = STATE(4735),
    [sym_requires_expression] = STATE(4735),
    [sym_lambda_expression] = STATE(4735),
    [sym_lambda_capture_specifier] = STATE(5854),
    [sym_fold_expression] = STATE(4735),
    [sym_parameter_pack_expansion] = STATE(4735),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3573),
    [sym_qualified_type_identifier] = STATE(7513),
    [sym_user_defined_literal] = STATE(3573),
    [sym_identifier] = ACTIONS(3726),
    [anon_sym_LPAREN2] = ACTIONS(2856),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(3728),
    [anon_sym_COLON_COLON] = ACTIONS(2866),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(3732),
    [anon_sym_not] = ACTIONS(2860),
    [anon_sym_compl] = ACTIONS(2860),
    [anon_sym_DASH_DASH] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(2880),
    [anon_sym_sizeof] = ACTIONS(2882),
    [anon_sym___alignof__] = ACTIONS(2884),
    [anon_sym___alignof] = ACTIONS(2884),
    [anon_sym__alignof] = ACTIONS(2884),
    [anon_sym_alignof] = ACTIONS(2884),
    [anon_sym__Alignof] = ACTIONS(2884),
    [anon_sym_offsetof] = ACTIONS(2886),
    [anon_sym__Generic] = ACTIONS(2888),
    [anon_sym_asm] = ACTIONS(2890),
    [anon_sym___asm__] = ACTIONS(2890),
    [anon_sym___asm] = ACTIONS(2890),
    [sym_number_literal] = ACTIONS(2892),
    [anon_sym_L_SQUOTE] = ACTIONS(2894),
    [anon_sym_u_SQUOTE] = ACTIONS(2894),
    [anon_sym_U_SQUOTE] = ACTIONS(2894),
    [anon_sym_u8_SQUOTE] = ACTIONS(2894),
    [anon_sym_SQUOTE] = ACTIONS(2894),
    [anon_sym_L_DQUOTE] = ACTIONS(2896),
    [anon_sym_u_DQUOTE] = ACTIONS(2896),
    [anon_sym_U_DQUOTE] = ACTIONS(2896),
    [anon_sym_u8_DQUOTE] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [anon_sym_NULL] = ACTIONS(2900),
    [anon_sym_nullptr] = ACTIONS(2900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2910),
    [anon_sym_R_DQUOTE] = ACTIONS(2912),
    [anon_sym_LR_DQUOTE] = ACTIONS(2912),
    [anon_sym_uR_DQUOTE] = ACTIONS(2912),
    [anon_sym_UR_DQUOTE] = ACTIONS(2912),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2912),
    [anon_sym_co_await] = ACTIONS(2914),
    [anon_sym_new] = ACTIONS(2916),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2898),
  },
  [1288] = {
    [sym_expression] = STATE(4472),
    [sym__string] = STATE(4637),
    [sym_conditional_expression] = STATE(4735),
    [sym_assignment_expression] = STATE(4735),
    [sym_pointer_expression] = STATE(3573),
    [sym_unary_expression] = STATE(4735),
    [sym_binary_expression] = STATE(4735),
    [sym_update_expression] = STATE(4735),
    [sym_cast_expression] = STATE(4735),
    [sym_sizeof_expression] = STATE(4735),
    [sym_alignof_expression] = STATE(4735),
    [sym_offsetof_expression] = STATE(4735),
    [sym_generic_expression] = STATE(4735),
    [sym_subscript_expression] = STATE(3573),
    [sym_call_expression] = STATE(3573),
    [sym_gnu_asm_expression] = STATE(4735),
    [sym_extension_expression] = STATE(4735),
    [sym_field_expression] = STATE(3573),
    [sym_compound_literal_expression] = STATE(4735),
    [sym_parenthesized_expression] = STATE(3573),
    [sym_char_literal] = STATE(4637),
    [sym_concatenated_string] = STATE(4637),
    [sym_string_literal] = STATE(3662),
    [sym_null] = STATE(4735),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7513),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(4735),
    [sym_raw_string_literal] = STATE(3662),
    [sym_co_await_expression] = STATE(4735),
    [sym_new_expression] = STATE(4735),
    [sym_delete_expression] = STATE(4735),
    [sym_requires_clause] = STATE(4735),
    [sym_requires_expression] = STATE(4735),
    [sym_lambda_expression] = STATE(4735),
    [sym_lambda_capture_specifier] = STATE(5854),
    [sym_fold_expression] = STATE(4735),
    [sym_parameter_pack_expansion] = STATE(4735),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3573),
    [sym_qualified_type_identifier] = STATE(7513),
    [sym_user_defined_literal] = STATE(3573),
    [sym_identifier] = ACTIONS(3726),
    [anon_sym_LPAREN2] = ACTIONS(2856),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(3728),
    [anon_sym_COLON_COLON] = ACTIONS(2866),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(3732),
    [anon_sym_not] = ACTIONS(2860),
    [anon_sym_compl] = ACTIONS(2860),
    [anon_sym_DASH_DASH] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(2880),
    [anon_sym_sizeof] = ACTIONS(2882),
    [anon_sym___alignof__] = ACTIONS(2884),
    [anon_sym___alignof] = ACTIONS(2884),
    [anon_sym__alignof] = ACTIONS(2884),
    [anon_sym_alignof] = ACTIONS(2884),
    [anon_sym__Alignof] = ACTIONS(2884),
    [anon_sym_offsetof] = ACTIONS(2886),
    [anon_sym__Generic] = ACTIONS(2888),
    [anon_sym_asm] = ACTIONS(2890),
    [anon_sym___asm__] = ACTIONS(2890),
    [anon_sym___asm] = ACTIONS(2890),
    [sym_number_literal] = ACTIONS(2892),
    [anon_sym_L_SQUOTE] = ACTIONS(2894),
    [anon_sym_u_SQUOTE] = ACTIONS(2894),
    [anon_sym_U_SQUOTE] = ACTIONS(2894),
    [anon_sym_u8_SQUOTE] = ACTIONS(2894),
    [anon_sym_SQUOTE] = ACTIONS(2894),
    [anon_sym_L_DQUOTE] = ACTIONS(2896),
    [anon_sym_u_DQUOTE] = ACTIONS(2896),
    [anon_sym_U_DQUOTE] = ACTIONS(2896),
    [anon_sym_u8_DQUOTE] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [anon_sym_NULL] = ACTIONS(2900),
    [anon_sym_nullptr] = ACTIONS(2900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2910),
    [anon_sym_R_DQUOTE] = ACTIONS(2912),
    [anon_sym_LR_DQUOTE] = ACTIONS(2912),
    [anon_sym_uR_DQUOTE] = ACTIONS(2912),
    [anon_sym_UR_DQUOTE] = ACTIONS(2912),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2912),
    [anon_sym_co_await] = ACTIONS(2914),
    [anon_sym_new] = ACTIONS(2916),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2898),
  },
  [1289] = {
    [sym_expression] = STATE(4480),
    [sym__string] = STATE(4637),
    [sym_conditional_expression] = STATE(4735),
    [sym_assignment_expression] = STATE(4735),
    [sym_pointer_expression] = STATE(3573),
    [sym_unary_expression] = STATE(4735),
    [sym_binary_expression] = STATE(4735),
    [sym_update_expression] = STATE(4735),
    [sym_cast_expression] = STATE(4735),
    [sym_sizeof_expression] = STATE(4735),
    [sym_alignof_expression] = STATE(4735),
    [sym_offsetof_expression] = STATE(4735),
    [sym_generic_expression] = STATE(4735),
    [sym_subscript_expression] = STATE(3573),
    [sym_call_expression] = STATE(3573),
    [sym_gnu_asm_expression] = STATE(4735),
    [sym_extension_expression] = STATE(4735),
    [sym_field_expression] = STATE(3573),
    [sym_compound_literal_expression] = STATE(4735),
    [sym_parenthesized_expression] = STATE(3573),
    [sym_char_literal] = STATE(4637),
    [sym_concatenated_string] = STATE(4637),
    [sym_string_literal] = STATE(3662),
    [sym_null] = STATE(4735),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7513),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(4735),
    [sym_raw_string_literal] = STATE(3662),
    [sym_co_await_expression] = STATE(4735),
    [sym_new_expression] = STATE(4735),
    [sym_delete_expression] = STATE(4735),
    [sym_requires_clause] = STATE(4735),
    [sym_requires_expression] = STATE(4735),
    [sym_lambda_expression] = STATE(4735),
    [sym_lambda_capture_specifier] = STATE(5854),
    [sym_fold_expression] = STATE(4735),
    [sym_parameter_pack_expansion] = STATE(4735),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3573),
    [sym_qualified_type_identifier] = STATE(7513),
    [sym_user_defined_literal] = STATE(3573),
    [sym_identifier] = ACTIONS(3726),
    [anon_sym_LPAREN2] = ACTIONS(2856),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(3728),
    [anon_sym_COLON_COLON] = ACTIONS(2866),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(3732),
    [anon_sym_not] = ACTIONS(2860),
    [anon_sym_compl] = ACTIONS(2860),
    [anon_sym_DASH_DASH] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(2880),
    [anon_sym_sizeof] = ACTIONS(2882),
    [anon_sym___alignof__] = ACTIONS(2884),
    [anon_sym___alignof] = ACTIONS(2884),
    [anon_sym__alignof] = ACTIONS(2884),
    [anon_sym_alignof] = ACTIONS(2884),
    [anon_sym__Alignof] = ACTIONS(2884),
    [anon_sym_offsetof] = ACTIONS(2886),
    [anon_sym__Generic] = ACTIONS(2888),
    [anon_sym_asm] = ACTIONS(2890),
    [anon_sym___asm__] = ACTIONS(2890),
    [anon_sym___asm] = ACTIONS(2890),
    [sym_number_literal] = ACTIONS(2892),
    [anon_sym_L_SQUOTE] = ACTIONS(2894),
    [anon_sym_u_SQUOTE] = ACTIONS(2894),
    [anon_sym_U_SQUOTE] = ACTIONS(2894),
    [anon_sym_u8_SQUOTE] = ACTIONS(2894),
    [anon_sym_SQUOTE] = ACTIONS(2894),
    [anon_sym_L_DQUOTE] = ACTIONS(2896),
    [anon_sym_u_DQUOTE] = ACTIONS(2896),
    [anon_sym_U_DQUOTE] = ACTIONS(2896),
    [anon_sym_u8_DQUOTE] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [anon_sym_NULL] = ACTIONS(2900),
    [anon_sym_nullptr] = ACTIONS(2900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2910),
    [anon_sym_R_DQUOTE] = ACTIONS(2912),
    [anon_sym_LR_DQUOTE] = ACTIONS(2912),
    [anon_sym_uR_DQUOTE] = ACTIONS(2912),
    [anon_sym_UR_DQUOTE] = ACTIONS(2912),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2912),
    [anon_sym_co_await] = ACTIONS(2914),
    [anon_sym_new] = ACTIONS(2916),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2898),
  },
  [1290] = {
    [sym_expression] = STATE(4481),
    [sym__string] = STATE(4637),
    [sym_conditional_expression] = STATE(4735),
    [sym_assignment_expression] = STATE(4735),
    [sym_pointer_expression] = STATE(3573),
    [sym_unary_expression] = STATE(4735),
    [sym_binary_expression] = STATE(4735),
    [sym_update_expression] = STATE(4735),
    [sym_cast_expression] = STATE(4735),
    [sym_sizeof_expression] = STATE(4735),
    [sym_alignof_expression] = STATE(4735),
    [sym_offsetof_expression] = STATE(4735),
    [sym_generic_expression] = STATE(4735),
    [sym_subscript_expression] = STATE(3573),
    [sym_call_expression] = STATE(3573),
    [sym_gnu_asm_expression] = STATE(4735),
    [sym_extension_expression] = STATE(4735),
    [sym_field_expression] = STATE(3573),
    [sym_compound_literal_expression] = STATE(4735),
    [sym_parenthesized_expression] = STATE(3573),
    [sym_char_literal] = STATE(4637),
    [sym_concatenated_string] = STATE(4637),
    [sym_string_literal] = STATE(3662),
    [sym_null] = STATE(4735),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7513),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(4735),
    [sym_raw_string_literal] = STATE(3662),
    [sym_co_await_expression] = STATE(4735),
    [sym_new_expression] = STATE(4735),
    [sym_delete_expression] = STATE(4735),
    [sym_requires_clause] = STATE(4735),
    [sym_requires_expression] = STATE(4735),
    [sym_lambda_expression] = STATE(4735),
    [sym_lambda_capture_specifier] = STATE(5854),
    [sym_fold_expression] = STATE(4735),
    [sym_parameter_pack_expansion] = STATE(4735),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3573),
    [sym_qualified_type_identifier] = STATE(7513),
    [sym_user_defined_literal] = STATE(3573),
    [sym_identifier] = ACTIONS(3726),
    [anon_sym_LPAREN2] = ACTIONS(2856),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(3728),
    [anon_sym_COLON_COLON] = ACTIONS(2866),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(3732),
    [anon_sym_not] = ACTIONS(2860),
    [anon_sym_compl] = ACTIONS(2860),
    [anon_sym_DASH_DASH] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(2880),
    [anon_sym_sizeof] = ACTIONS(2882),
    [anon_sym___alignof__] = ACTIONS(2884),
    [anon_sym___alignof] = ACTIONS(2884),
    [anon_sym__alignof] = ACTIONS(2884),
    [anon_sym_alignof] = ACTIONS(2884),
    [anon_sym__Alignof] = ACTIONS(2884),
    [anon_sym_offsetof] = ACTIONS(2886),
    [anon_sym__Generic] = ACTIONS(2888),
    [anon_sym_asm] = ACTIONS(2890),
    [anon_sym___asm__] = ACTIONS(2890),
    [anon_sym___asm] = ACTIONS(2890),
    [sym_number_literal] = ACTIONS(2892),
    [anon_sym_L_SQUOTE] = ACTIONS(2894),
    [anon_sym_u_SQUOTE] = ACTIONS(2894),
    [anon_sym_U_SQUOTE] = ACTIONS(2894),
    [anon_sym_u8_SQUOTE] = ACTIONS(2894),
    [anon_sym_SQUOTE] = ACTIONS(2894),
    [anon_sym_L_DQUOTE] = ACTIONS(2896),
    [anon_sym_u_DQUOTE] = ACTIONS(2896),
    [anon_sym_U_DQUOTE] = ACTIONS(2896),
    [anon_sym_u8_DQUOTE] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [anon_sym_NULL] = ACTIONS(2900),
    [anon_sym_nullptr] = ACTIONS(2900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2910),
    [anon_sym_R_DQUOTE] = ACTIONS(2912),
    [anon_sym_LR_DQUOTE] = ACTIONS(2912),
    [anon_sym_uR_DQUOTE] = ACTIONS(2912),
    [anon_sym_UR_DQUOTE] = ACTIONS(2912),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2912),
    [anon_sym_co_await] = ACTIONS(2914),
    [anon_sym_new] = ACTIONS(2916),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2898),
  },
  [1291] = {
    [sym_expression] = STATE(4484),
    [sym__string] = STATE(4637),
    [sym_conditional_expression] = STATE(4735),
    [sym_assignment_expression] = STATE(4735),
    [sym_pointer_expression] = STATE(3573),
    [sym_unary_expression] = STATE(4735),
    [sym_binary_expression] = STATE(4735),
    [sym_update_expression] = STATE(4735),
    [sym_cast_expression] = STATE(4735),
    [sym_sizeof_expression] = STATE(4735),
    [sym_alignof_expression] = STATE(4735),
    [sym_offsetof_expression] = STATE(4735),
    [sym_generic_expression] = STATE(4735),
    [sym_subscript_expression] = STATE(3573),
    [sym_call_expression] = STATE(3573),
    [sym_gnu_asm_expression] = STATE(4735),
    [sym_extension_expression] = STATE(4735),
    [sym_field_expression] = STATE(3573),
    [sym_compound_literal_expression] = STATE(4735),
    [sym_parenthesized_expression] = STATE(3573),
    [sym_char_literal] = STATE(4637),
    [sym_concatenated_string] = STATE(4637),
    [sym_string_literal] = STATE(3662),
    [sym_null] = STATE(4735),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7513),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(4735),
    [sym_raw_string_literal] = STATE(3662),
    [sym_co_await_expression] = STATE(4735),
    [sym_new_expression] = STATE(4735),
    [sym_delete_expression] = STATE(4735),
    [sym_requires_clause] = STATE(4735),
    [sym_requires_expression] = STATE(4735),
    [sym_lambda_expression] = STATE(4735),
    [sym_lambda_capture_specifier] = STATE(5854),
    [sym_fold_expression] = STATE(4735),
    [sym_parameter_pack_expansion] = STATE(4735),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3573),
    [sym_qualified_type_identifier] = STATE(7513),
    [sym_user_defined_literal] = STATE(3573),
    [sym_identifier] = ACTIONS(3726),
    [anon_sym_LPAREN2] = ACTIONS(2856),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(3728),
    [anon_sym_COLON_COLON] = ACTIONS(2866),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(3732),
    [anon_sym_not] = ACTIONS(2860),
    [anon_sym_compl] = ACTIONS(2860),
    [anon_sym_DASH_DASH] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(2880),
    [anon_sym_sizeof] = ACTIONS(2882),
    [anon_sym___alignof__] = ACTIONS(2884),
    [anon_sym___alignof] = ACTIONS(2884),
    [anon_sym__alignof] = ACTIONS(2884),
    [anon_sym_alignof] = ACTIONS(2884),
    [anon_sym__Alignof] = ACTIONS(2884),
    [anon_sym_offsetof] = ACTIONS(2886),
    [anon_sym__Generic] = ACTIONS(2888),
    [anon_sym_asm] = ACTIONS(2890),
    [anon_sym___asm__] = ACTIONS(2890),
    [anon_sym___asm] = ACTIONS(2890),
    [sym_number_literal] = ACTIONS(2892),
    [anon_sym_L_SQUOTE] = ACTIONS(2894),
    [anon_sym_u_SQUOTE] = ACTIONS(2894),
    [anon_sym_U_SQUOTE] = ACTIONS(2894),
    [anon_sym_u8_SQUOTE] = ACTIONS(2894),
    [anon_sym_SQUOTE] = ACTIONS(2894),
    [anon_sym_L_DQUOTE] = ACTIONS(2896),
    [anon_sym_u_DQUOTE] = ACTIONS(2896),
    [anon_sym_U_DQUOTE] = ACTIONS(2896),
    [anon_sym_u8_DQUOTE] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [anon_sym_NULL] = ACTIONS(2900),
    [anon_sym_nullptr] = ACTIONS(2900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2910),
    [anon_sym_R_DQUOTE] = ACTIONS(2912),
    [anon_sym_LR_DQUOTE] = ACTIONS(2912),
    [anon_sym_uR_DQUOTE] = ACTIONS(2912),
    [anon_sym_UR_DQUOTE] = ACTIONS(2912),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2912),
    [anon_sym_co_await] = ACTIONS(2914),
    [anon_sym_new] = ACTIONS(2916),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2898),
  },
  [1292] = {
    [sym_expression] = STATE(4488),
    [sym__string] = STATE(4637),
    [sym_conditional_expression] = STATE(4735),
    [sym_assignment_expression] = STATE(4735),
    [sym_pointer_expression] = STATE(3573),
    [sym_unary_expression] = STATE(4735),
    [sym_binary_expression] = STATE(4735),
    [sym_update_expression] = STATE(4735),
    [sym_cast_expression] = STATE(4735),
    [sym_sizeof_expression] = STATE(4735),
    [sym_alignof_expression] = STATE(4735),
    [sym_offsetof_expression] = STATE(4735),
    [sym_generic_expression] = STATE(4735),
    [sym_subscript_expression] = STATE(3573),
    [sym_call_expression] = STATE(3573),
    [sym_gnu_asm_expression] = STATE(4735),
    [sym_extension_expression] = STATE(4735),
    [sym_field_expression] = STATE(3573),
    [sym_compound_literal_expression] = STATE(4735),
    [sym_parenthesized_expression] = STATE(3573),
    [sym_char_literal] = STATE(4637),
    [sym_concatenated_string] = STATE(4637),
    [sym_string_literal] = STATE(3662),
    [sym_null] = STATE(4735),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7513),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(4735),
    [sym_raw_string_literal] = STATE(3662),
    [sym_co_await_expression] = STATE(4735),
    [sym_new_expression] = STATE(4735),
    [sym_delete_expression] = STATE(4735),
    [sym_requires_clause] = STATE(4735),
    [sym_requires_expression] = STATE(4735),
    [sym_lambda_expression] = STATE(4735),
    [sym_lambda_capture_specifier] = STATE(5854),
    [sym_fold_expression] = STATE(4735),
    [sym_parameter_pack_expansion] = STATE(4735),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3573),
    [sym_qualified_type_identifier] = STATE(7513),
    [sym_user_defined_literal] = STATE(3573),
    [sym_identifier] = ACTIONS(3726),
    [anon_sym_LPAREN2] = ACTIONS(2856),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(3728),
    [anon_sym_COLON_COLON] = ACTIONS(2866),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(3732),
    [anon_sym_not] = ACTIONS(2860),
    [anon_sym_compl] = ACTIONS(2860),
    [anon_sym_DASH_DASH] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(2880),
    [anon_sym_sizeof] = ACTIONS(2882),
    [anon_sym___alignof__] = ACTIONS(2884),
    [anon_sym___alignof] = ACTIONS(2884),
    [anon_sym__alignof] = ACTIONS(2884),
    [anon_sym_alignof] = ACTIONS(2884),
    [anon_sym__Alignof] = ACTIONS(2884),
    [anon_sym_offsetof] = ACTIONS(2886),
    [anon_sym__Generic] = ACTIONS(2888),
    [anon_sym_asm] = ACTIONS(2890),
    [anon_sym___asm__] = ACTIONS(2890),
    [anon_sym___asm] = ACTIONS(2890),
    [sym_number_literal] = ACTIONS(2892),
    [anon_sym_L_SQUOTE] = ACTIONS(2894),
    [anon_sym_u_SQUOTE] = ACTIONS(2894),
    [anon_sym_U_SQUOTE] = ACTIONS(2894),
    [anon_sym_u8_SQUOTE] = ACTIONS(2894),
    [anon_sym_SQUOTE] = ACTIONS(2894),
    [anon_sym_L_DQUOTE] = ACTIONS(2896),
    [anon_sym_u_DQUOTE] = ACTIONS(2896),
    [anon_sym_U_DQUOTE] = ACTIONS(2896),
    [anon_sym_u8_DQUOTE] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [anon_sym_NULL] = ACTIONS(2900),
    [anon_sym_nullptr] = ACTIONS(2900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2910),
    [anon_sym_R_DQUOTE] = ACTIONS(2912),
    [anon_sym_LR_DQUOTE] = ACTIONS(2912),
    [anon_sym_uR_DQUOTE] = ACTIONS(2912),
    [anon_sym_UR_DQUOTE] = ACTIONS(2912),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2912),
    [anon_sym_co_await] = ACTIONS(2914),
    [anon_sym_new] = ACTIONS(2916),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2898),
  },
  [1293] = {
    [sym_expression] = STATE(4491),
    [sym__string] = STATE(4637),
    [sym_conditional_expression] = STATE(4735),
    [sym_assignment_expression] = STATE(4735),
    [sym_pointer_expression] = STATE(3573),
    [sym_unary_expression] = STATE(4735),
    [sym_binary_expression] = STATE(4735),
    [sym_update_expression] = STATE(4735),
    [sym_cast_expression] = STATE(4735),
    [sym_sizeof_expression] = STATE(4735),
    [sym_alignof_expression] = STATE(4735),
    [sym_offsetof_expression] = STATE(4735),
    [sym_generic_expression] = STATE(4735),
    [sym_subscript_expression] = STATE(3573),
    [sym_call_expression] = STATE(3573),
    [sym_gnu_asm_expression] = STATE(4735),
    [sym_extension_expression] = STATE(4735),
    [sym_field_expression] = STATE(3573),
    [sym_compound_literal_expression] = STATE(4735),
    [sym_parenthesized_expression] = STATE(3573),
    [sym_char_literal] = STATE(4637),
    [sym_concatenated_string] = STATE(4637),
    [sym_string_literal] = STATE(3662),
    [sym_null] = STATE(4735),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7513),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(4735),
    [sym_raw_string_literal] = STATE(3662),
    [sym_co_await_expression] = STATE(4735),
    [sym_new_expression] = STATE(4735),
    [sym_delete_expression] = STATE(4735),
    [sym_requires_clause] = STATE(4735),
    [sym_requires_expression] = STATE(4735),
    [sym_lambda_expression] = STATE(4735),
    [sym_lambda_capture_specifier] = STATE(5854),
    [sym_fold_expression] = STATE(4735),
    [sym_parameter_pack_expansion] = STATE(4735),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3573),
    [sym_qualified_type_identifier] = STATE(7513),
    [sym_user_defined_literal] = STATE(3573),
    [sym_identifier] = ACTIONS(3726),
    [anon_sym_LPAREN2] = ACTIONS(2856),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(3728),
    [anon_sym_COLON_COLON] = ACTIONS(2866),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(3732),
    [anon_sym_not] = ACTIONS(2860),
    [anon_sym_compl] = ACTIONS(2860),
    [anon_sym_DASH_DASH] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(2880),
    [anon_sym_sizeof] = ACTIONS(2882),
    [anon_sym___alignof__] = ACTIONS(2884),
    [anon_sym___alignof] = ACTIONS(2884),
    [anon_sym__alignof] = ACTIONS(2884),
    [anon_sym_alignof] = ACTIONS(2884),
    [anon_sym__Alignof] = ACTIONS(2884),
    [anon_sym_offsetof] = ACTIONS(2886),
    [anon_sym__Generic] = ACTIONS(2888),
    [anon_sym_asm] = ACTIONS(2890),
    [anon_sym___asm__] = ACTIONS(2890),
    [anon_sym___asm] = ACTIONS(2890),
    [sym_number_literal] = ACTIONS(2892),
    [anon_sym_L_SQUOTE] = ACTIONS(2894),
    [anon_sym_u_SQUOTE] = ACTIONS(2894),
    [anon_sym_U_SQUOTE] = ACTIONS(2894),
    [anon_sym_u8_SQUOTE] = ACTIONS(2894),
    [anon_sym_SQUOTE] = ACTIONS(2894),
    [anon_sym_L_DQUOTE] = ACTIONS(2896),
    [anon_sym_u_DQUOTE] = ACTIONS(2896),
    [anon_sym_U_DQUOTE] = ACTIONS(2896),
    [anon_sym_u8_DQUOTE] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [anon_sym_NULL] = ACTIONS(2900),
    [anon_sym_nullptr] = ACTIONS(2900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2910),
    [anon_sym_R_DQUOTE] = ACTIONS(2912),
    [anon_sym_LR_DQUOTE] = ACTIONS(2912),
    [anon_sym_uR_DQUOTE] = ACTIONS(2912),
    [anon_sym_UR_DQUOTE] = ACTIONS(2912),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2912),
    [anon_sym_co_await] = ACTIONS(2914),
    [anon_sym_new] = ACTIONS(2916),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2898),
  },
  [1294] = {
    [sym_expression] = STATE(4492),
    [sym__string] = STATE(4637),
    [sym_conditional_expression] = STATE(4735),
    [sym_assignment_expression] = STATE(4735),
    [sym_pointer_expression] = STATE(3573),
    [sym_unary_expression] = STATE(4735),
    [sym_binary_expression] = STATE(4735),
    [sym_update_expression] = STATE(4735),
    [sym_cast_expression] = STATE(4735),
    [sym_sizeof_expression] = STATE(4735),
    [sym_alignof_expression] = STATE(4735),
    [sym_offsetof_expression] = STATE(4735),
    [sym_generic_expression] = STATE(4735),
    [sym_subscript_expression] = STATE(3573),
    [sym_call_expression] = STATE(3573),
    [sym_gnu_asm_expression] = STATE(4735),
    [sym_extension_expression] = STATE(4735),
    [sym_field_expression] = STATE(3573),
    [sym_compound_literal_expression] = STATE(4735),
    [sym_parenthesized_expression] = STATE(3573),
    [sym_char_literal] = STATE(4637),
    [sym_concatenated_string] = STATE(4637),
    [sym_string_literal] = STATE(3662),
    [sym_null] = STATE(4735),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7513),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(4735),
    [sym_raw_string_literal] = STATE(3662),
    [sym_co_await_expression] = STATE(4735),
    [sym_new_expression] = STATE(4735),
    [sym_delete_expression] = STATE(4735),
    [sym_requires_clause] = STATE(4735),
    [sym_requires_expression] = STATE(4735),
    [sym_lambda_expression] = STATE(4735),
    [sym_lambda_capture_specifier] = STATE(5854),
    [sym_fold_expression] = STATE(4735),
    [sym_parameter_pack_expansion] = STATE(4735),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3573),
    [sym_qualified_type_identifier] = STATE(7513),
    [sym_user_defined_literal] = STATE(3573),
    [sym_identifier] = ACTIONS(3726),
    [anon_sym_LPAREN2] = ACTIONS(2856),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(3728),
    [anon_sym_COLON_COLON] = ACTIONS(2866),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(3732),
    [anon_sym_not] = ACTIONS(2860),
    [anon_sym_compl] = ACTIONS(2860),
    [anon_sym_DASH_DASH] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(2880),
    [anon_sym_sizeof] = ACTIONS(2882),
    [anon_sym___alignof__] = ACTIONS(2884),
    [anon_sym___alignof] = ACTIONS(2884),
    [anon_sym__alignof] = ACTIONS(2884),
    [anon_sym_alignof] = ACTIONS(2884),
    [anon_sym__Alignof] = ACTIONS(2884),
    [anon_sym_offsetof] = ACTIONS(2886),
    [anon_sym__Generic] = ACTIONS(2888),
    [anon_sym_asm] = ACTIONS(2890),
    [anon_sym___asm__] = ACTIONS(2890),
    [anon_sym___asm] = ACTIONS(2890),
    [sym_number_literal] = ACTIONS(2892),
    [anon_sym_L_SQUOTE] = ACTIONS(2894),
    [anon_sym_u_SQUOTE] = ACTIONS(2894),
    [anon_sym_U_SQUOTE] = ACTIONS(2894),
    [anon_sym_u8_SQUOTE] = ACTIONS(2894),
    [anon_sym_SQUOTE] = ACTIONS(2894),
    [anon_sym_L_DQUOTE] = ACTIONS(2896),
    [anon_sym_u_DQUOTE] = ACTIONS(2896),
    [anon_sym_U_DQUOTE] = ACTIONS(2896),
    [anon_sym_u8_DQUOTE] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [anon_sym_NULL] = ACTIONS(2900),
    [anon_sym_nullptr] = ACTIONS(2900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2910),
    [anon_sym_R_DQUOTE] = ACTIONS(2912),
    [anon_sym_LR_DQUOTE] = ACTIONS(2912),
    [anon_sym_uR_DQUOTE] = ACTIONS(2912),
    [anon_sym_UR_DQUOTE] = ACTIONS(2912),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2912),
    [anon_sym_co_await] = ACTIONS(2914),
    [anon_sym_new] = ACTIONS(2916),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2898),
  },
  [1295] = {
    [sym_expression] = STATE(4493),
    [sym__string] = STATE(4637),
    [sym_conditional_expression] = STATE(4735),
    [sym_assignment_expression] = STATE(4735),
    [sym_pointer_expression] = STATE(3573),
    [sym_unary_expression] = STATE(4735),
    [sym_binary_expression] = STATE(4735),
    [sym_update_expression] = STATE(4735),
    [sym_cast_expression] = STATE(4735),
    [sym_sizeof_expression] = STATE(4735),
    [sym_alignof_expression] = STATE(4735),
    [sym_offsetof_expression] = STATE(4735),
    [sym_generic_expression] = STATE(4735),
    [sym_subscript_expression] = STATE(3573),
    [sym_call_expression] = STATE(3573),
    [sym_gnu_asm_expression] = STATE(4735),
    [sym_extension_expression] = STATE(4735),
    [sym_field_expression] = STATE(3573),
    [sym_compound_literal_expression] = STATE(4735),
    [sym_parenthesized_expression] = STATE(3573),
    [sym_char_literal] = STATE(4637),
    [sym_concatenated_string] = STATE(4637),
    [sym_string_literal] = STATE(3662),
    [sym_null] = STATE(4735),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7513),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(4735),
    [sym_raw_string_literal] = STATE(3662),
    [sym_co_await_expression] = STATE(4735),
    [sym_new_expression] = STATE(4735),
    [sym_delete_expression] = STATE(4735),
    [sym_requires_clause] = STATE(4735),
    [sym_requires_expression] = STATE(4735),
    [sym_lambda_expression] = STATE(4735),
    [sym_lambda_capture_specifier] = STATE(5854),
    [sym_fold_expression] = STATE(4735),
    [sym_parameter_pack_expansion] = STATE(4735),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3573),
    [sym_qualified_type_identifier] = STATE(7513),
    [sym_user_defined_literal] = STATE(3573),
    [sym_identifier] = ACTIONS(3726),
    [anon_sym_LPAREN2] = ACTIONS(2856),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(3728),
    [anon_sym_COLON_COLON] = ACTIONS(2866),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(3732),
    [anon_sym_not] = ACTIONS(2860),
    [anon_sym_compl] = ACTIONS(2860),
    [anon_sym_DASH_DASH] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(2880),
    [anon_sym_sizeof] = ACTIONS(2882),
    [anon_sym___alignof__] = ACTIONS(2884),
    [anon_sym___alignof] = ACTIONS(2884),
    [anon_sym__alignof] = ACTIONS(2884),
    [anon_sym_alignof] = ACTIONS(2884),
    [anon_sym__Alignof] = ACTIONS(2884),
    [anon_sym_offsetof] = ACTIONS(2886),
    [anon_sym__Generic] = ACTIONS(2888),
    [anon_sym_asm] = ACTIONS(2890),
    [anon_sym___asm__] = ACTIONS(2890),
    [anon_sym___asm] = ACTIONS(2890),
    [sym_number_literal] = ACTIONS(2892),
    [anon_sym_L_SQUOTE] = ACTIONS(2894),
    [anon_sym_u_SQUOTE] = ACTIONS(2894),
    [anon_sym_U_SQUOTE] = ACTIONS(2894),
    [anon_sym_u8_SQUOTE] = ACTIONS(2894),
    [anon_sym_SQUOTE] = ACTIONS(2894),
    [anon_sym_L_DQUOTE] = ACTIONS(2896),
    [anon_sym_u_DQUOTE] = ACTIONS(2896),
    [anon_sym_U_DQUOTE] = ACTIONS(2896),
    [anon_sym_u8_DQUOTE] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [anon_sym_NULL] = ACTIONS(2900),
    [anon_sym_nullptr] = ACTIONS(2900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2910),
    [anon_sym_R_DQUOTE] = ACTIONS(2912),
    [anon_sym_LR_DQUOTE] = ACTIONS(2912),
    [anon_sym_uR_DQUOTE] = ACTIONS(2912),
    [anon_sym_UR_DQUOTE] = ACTIONS(2912),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2912),
    [anon_sym_co_await] = ACTIONS(2914),
    [anon_sym_new] = ACTIONS(2916),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2898),
  },
  [1296] = {
    [sym_expression] = STATE(4499),
    [sym__string] = STATE(4637),
    [sym_conditional_expression] = STATE(4735),
    [sym_assignment_expression] = STATE(4735),
    [sym_pointer_expression] = STATE(3573),
    [sym_unary_expression] = STATE(4735),
    [sym_binary_expression] = STATE(4735),
    [sym_update_expression] = STATE(4735),
    [sym_cast_expression] = STATE(4735),
    [sym_sizeof_expression] = STATE(4735),
    [sym_alignof_expression] = STATE(4735),
    [sym_offsetof_expression] = STATE(4735),
    [sym_generic_expression] = STATE(4735),
    [sym_subscript_expression] = STATE(3573),
    [sym_call_expression] = STATE(3573),
    [sym_gnu_asm_expression] = STATE(4735),
    [sym_extension_expression] = STATE(4735),
    [sym_field_expression] = STATE(3573),
    [sym_compound_literal_expression] = STATE(4735),
    [sym_parenthesized_expression] = STATE(3573),
    [sym_char_literal] = STATE(4637),
    [sym_concatenated_string] = STATE(4637),
    [sym_string_literal] = STATE(3662),
    [sym_null] = STATE(4735),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7513),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(4735),
    [sym_raw_string_literal] = STATE(3662),
    [sym_co_await_expression] = STATE(4735),
    [sym_new_expression] = STATE(4735),
    [sym_delete_expression] = STATE(4735),
    [sym_requires_clause] = STATE(4735),
    [sym_requires_expression] = STATE(4735),
    [sym_lambda_expression] = STATE(4735),
    [sym_lambda_capture_specifier] = STATE(5854),
    [sym_fold_expression] = STATE(4735),
    [sym_parameter_pack_expansion] = STATE(4735),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3573),
    [sym_qualified_type_identifier] = STATE(7513),
    [sym_user_defined_literal] = STATE(3573),
    [sym_identifier] = ACTIONS(3726),
    [anon_sym_LPAREN2] = ACTIONS(2856),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(3728),
    [anon_sym_COLON_COLON] = ACTIONS(2866),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(3732),
    [anon_sym_not] = ACTIONS(2860),
    [anon_sym_compl] = ACTIONS(2860),
    [anon_sym_DASH_DASH] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(2880),
    [anon_sym_sizeof] = ACTIONS(2882),
    [anon_sym___alignof__] = ACTIONS(2884),
    [anon_sym___alignof] = ACTIONS(2884),
    [anon_sym__alignof] = ACTIONS(2884),
    [anon_sym_alignof] = ACTIONS(2884),
    [anon_sym__Alignof] = ACTIONS(2884),
    [anon_sym_offsetof] = ACTIONS(2886),
    [anon_sym__Generic] = ACTIONS(2888),
    [anon_sym_asm] = ACTIONS(2890),
    [anon_sym___asm__] = ACTIONS(2890),
    [anon_sym___asm] = ACTIONS(2890),
    [sym_number_literal] = ACTIONS(2892),
    [anon_sym_L_SQUOTE] = ACTIONS(2894),
    [anon_sym_u_SQUOTE] = ACTIONS(2894),
    [anon_sym_U_SQUOTE] = ACTIONS(2894),
    [anon_sym_u8_SQUOTE] = ACTIONS(2894),
    [anon_sym_SQUOTE] = ACTIONS(2894),
    [anon_sym_L_DQUOTE] = ACTIONS(2896),
    [anon_sym_u_DQUOTE] = ACTIONS(2896),
    [anon_sym_U_DQUOTE] = ACTIONS(2896),
    [anon_sym_u8_DQUOTE] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [anon_sym_NULL] = ACTIONS(2900),
    [anon_sym_nullptr] = ACTIONS(2900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2910),
    [anon_sym_R_DQUOTE] = ACTIONS(2912),
    [anon_sym_LR_DQUOTE] = ACTIONS(2912),
    [anon_sym_uR_DQUOTE] = ACTIONS(2912),
    [anon_sym_UR_DQUOTE] = ACTIONS(2912),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2912),
    [anon_sym_co_await] = ACTIONS(2914),
    [anon_sym_new] = ACTIONS(2916),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2898),
  },
  [1297] = {
    [sym_expression] = STATE(4500),
    [sym__string] = STATE(4637),
    [sym_conditional_expression] = STATE(4735),
    [sym_assignment_expression] = STATE(4735),
    [sym_pointer_expression] = STATE(3573),
    [sym_unary_expression] = STATE(4735),
    [sym_binary_expression] = STATE(4735),
    [sym_update_expression] = STATE(4735),
    [sym_cast_expression] = STATE(4735),
    [sym_sizeof_expression] = STATE(4735),
    [sym_alignof_expression] = STATE(4735),
    [sym_offsetof_expression] = STATE(4735),
    [sym_generic_expression] = STATE(4735),
    [sym_subscript_expression] = STATE(3573),
    [sym_call_expression] = STATE(3573),
    [sym_gnu_asm_expression] = STATE(4735),
    [sym_extension_expression] = STATE(4735),
    [sym_field_expression] = STATE(3573),
    [sym_compound_literal_expression] = STATE(4735),
    [sym_parenthesized_expression] = STATE(3573),
    [sym_char_literal] = STATE(4637),
    [sym_concatenated_string] = STATE(4637),
    [sym_string_literal] = STATE(3662),
    [sym_null] = STATE(4735),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7513),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(4735),
    [sym_raw_string_literal] = STATE(3662),
    [sym_co_await_expression] = STATE(4735),
    [sym_new_expression] = STATE(4735),
    [sym_delete_expression] = STATE(4735),
    [sym_requires_clause] = STATE(4735),
    [sym_requires_expression] = STATE(4735),
    [sym_lambda_expression] = STATE(4735),
    [sym_lambda_capture_specifier] = STATE(5854),
    [sym_fold_expression] = STATE(4735),
    [sym_parameter_pack_expansion] = STATE(4735),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3573),
    [sym_qualified_type_identifier] = STATE(7513),
    [sym_user_defined_literal] = STATE(3573),
    [sym_identifier] = ACTIONS(3726),
    [anon_sym_LPAREN2] = ACTIONS(2856),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(3728),
    [anon_sym_COLON_COLON] = ACTIONS(2866),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(3732),
    [anon_sym_not] = ACTIONS(2860),
    [anon_sym_compl] = ACTIONS(2860),
    [anon_sym_DASH_DASH] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(2880),
    [anon_sym_sizeof] = ACTIONS(2882),
    [anon_sym___alignof__] = ACTIONS(2884),
    [anon_sym___alignof] = ACTIONS(2884),
    [anon_sym__alignof] = ACTIONS(2884),
    [anon_sym_alignof] = ACTIONS(2884),
    [anon_sym__Alignof] = ACTIONS(2884),
    [anon_sym_offsetof] = ACTIONS(2886),
    [anon_sym__Generic] = ACTIONS(2888),
    [anon_sym_asm] = ACTIONS(2890),
    [anon_sym___asm__] = ACTIONS(2890),
    [anon_sym___asm] = ACTIONS(2890),
    [sym_number_literal] = ACTIONS(2892),
    [anon_sym_L_SQUOTE] = ACTIONS(2894),
    [anon_sym_u_SQUOTE] = ACTIONS(2894),
    [anon_sym_U_SQUOTE] = ACTIONS(2894),
    [anon_sym_u8_SQUOTE] = ACTIONS(2894),
    [anon_sym_SQUOTE] = ACTIONS(2894),
    [anon_sym_L_DQUOTE] = ACTIONS(2896),
    [anon_sym_u_DQUOTE] = ACTIONS(2896),
    [anon_sym_U_DQUOTE] = ACTIONS(2896),
    [anon_sym_u8_DQUOTE] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [anon_sym_NULL] = ACTIONS(2900),
    [anon_sym_nullptr] = ACTIONS(2900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2910),
    [anon_sym_R_DQUOTE] = ACTIONS(2912),
    [anon_sym_LR_DQUOTE] = ACTIONS(2912),
    [anon_sym_uR_DQUOTE] = ACTIONS(2912),
    [anon_sym_UR_DQUOTE] = ACTIONS(2912),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2912),
    [anon_sym_co_await] = ACTIONS(2914),
    [anon_sym_new] = ACTIONS(2916),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2898),
  },
  [1298] = {
    [sym_expression] = STATE(3042),
    [sym__string] = STATE(3071),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(3071),
    [sym_concatenated_string] = STATE(3071),
    [sym_string_literal] = STATE(2243),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(2243),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1989),
    [anon_sym_LPAREN2] = ACTIONS(4531),
    [anon_sym_BANG] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1993),
    [anon_sym_DASH] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1991),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym___extension__] = ACTIONS(1995),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_LBRACK] = ACTIONS(4784),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_compl] = ACTIONS(1991),
    [anon_sym_DASH_DASH] = ACTIONS(4480),
    [anon_sym_PLUS_PLUS] = ACTIONS(4480),
    [anon_sym_sizeof] = ACTIONS(1999),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(2001),
    [anon_sym_L_SQUOTE] = ACTIONS(2003),
    [anon_sym_u_SQUOTE] = ACTIONS(2003),
    [anon_sym_U_SQUOTE] = ACTIONS(2003),
    [anon_sym_u8_SQUOTE] = ACTIONS(2003),
    [anon_sym_SQUOTE] = ACTIONS(2003),
    [anon_sym_L_DQUOTE] = ACTIONS(2005),
    [anon_sym_u_DQUOTE] = ACTIONS(2005),
    [anon_sym_U_DQUOTE] = ACTIONS(2005),
    [anon_sym_u8_DQUOTE] = ACTIONS(2005),
    [anon_sym_DQUOTE] = ACTIONS(2005),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2007),
    [anon_sym_R_DQUOTE] = ACTIONS(2009),
    [anon_sym_LR_DQUOTE] = ACTIONS(2009),
    [anon_sym_uR_DQUOTE] = ACTIONS(2009),
    [anon_sym_UR_DQUOTE] = ACTIONS(2009),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2009),
    [anon_sym_co_await] = ACTIONS(2011),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1299] = {
    [sym_expression] = STATE(2327),
    [sym__string] = STATE(3071),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(3071),
    [sym_concatenated_string] = STATE(3071),
    [sym_string_literal] = STATE(2243),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(2243),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1989),
    [anon_sym_LPAREN2] = ACTIONS(4531),
    [anon_sym_BANG] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1993),
    [anon_sym_DASH] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1991),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym___extension__] = ACTIONS(1995),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_compl] = ACTIONS(1991),
    [anon_sym_DASH_DASH] = ACTIONS(4480),
    [anon_sym_PLUS_PLUS] = ACTIONS(4480),
    [anon_sym_sizeof] = ACTIONS(1999),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(2001),
    [anon_sym_L_SQUOTE] = ACTIONS(2003),
    [anon_sym_u_SQUOTE] = ACTIONS(2003),
    [anon_sym_U_SQUOTE] = ACTIONS(2003),
    [anon_sym_u8_SQUOTE] = ACTIONS(2003),
    [anon_sym_SQUOTE] = ACTIONS(2003),
    [anon_sym_L_DQUOTE] = ACTIONS(2005),
    [anon_sym_u_DQUOTE] = ACTIONS(2005),
    [anon_sym_U_DQUOTE] = ACTIONS(2005),
    [anon_sym_u8_DQUOTE] = ACTIONS(2005),
    [anon_sym_DQUOTE] = ACTIONS(2005),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2007),
    [anon_sym_R_DQUOTE] = ACTIONS(2009),
    [anon_sym_LR_DQUOTE] = ACTIONS(2009),
    [anon_sym_uR_DQUOTE] = ACTIONS(2009),
    [anon_sym_UR_DQUOTE] = ACTIONS(2009),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2009),
    [anon_sym_co_await] = ACTIONS(2011),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1300] = {
    [sym_expression] = STATE(2749),
    [sym__string] = STATE(2808),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2808),
    [sym_concatenated_string] = STATE(2808),
    [sym_string_literal] = STATE(1900),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1900),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4503),
    [anon_sym_BANG] = ACTIONS(1921),
    [anon_sym_TILDE] = ACTIONS(1921),
    [anon_sym_DASH] = ACTIONS(1919),
    [anon_sym_PLUS] = ACTIONS(1919),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_AMP] = ACTIONS(4505),
    [anon_sym___extension__] = ACTIONS(1923),
    [anon_sym_COLON_COLON] = ACTIONS(1925),
    [anon_sym_LBRACK] = ACTIONS(4786),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1919),
    [anon_sym_compl] = ACTIONS(1919),
    [anon_sym_DASH_DASH] = ACTIONS(4491),
    [anon_sym_PLUS_PLUS] = ACTIONS(4491),
    [anon_sym_sizeof] = ACTIONS(1931),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1953),
    [anon_sym_R_DQUOTE] = ACTIONS(1955),
    [anon_sym_LR_DQUOTE] = ACTIONS(1955),
    [anon_sym_uR_DQUOTE] = ACTIONS(1955),
    [anon_sym_UR_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1955),
    [anon_sym_co_await] = ACTIONS(1957),
    [anon_sym_new] = ACTIONS(1959),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1301] = {
    [sym_expression] = STATE(2798),
    [sym__string] = STATE(2808),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2808),
    [sym_concatenated_string] = STATE(2808),
    [sym_string_literal] = STATE(1900),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1900),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4503),
    [anon_sym_BANG] = ACTIONS(1921),
    [anon_sym_TILDE] = ACTIONS(1921),
    [anon_sym_DASH] = ACTIONS(1919),
    [anon_sym_PLUS] = ACTIONS(1919),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_AMP] = ACTIONS(4505),
    [anon_sym___extension__] = ACTIONS(1923),
    [anon_sym_COLON_COLON] = ACTIONS(1925),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1919),
    [anon_sym_compl] = ACTIONS(1919),
    [anon_sym_DASH_DASH] = ACTIONS(4491),
    [anon_sym_PLUS_PLUS] = ACTIONS(4491),
    [anon_sym_sizeof] = ACTIONS(1931),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1953),
    [anon_sym_R_DQUOTE] = ACTIONS(1955),
    [anon_sym_LR_DQUOTE] = ACTIONS(1955),
    [anon_sym_uR_DQUOTE] = ACTIONS(1955),
    [anon_sym_UR_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1955),
    [anon_sym_co_await] = ACTIONS(1957),
    [anon_sym_new] = ACTIONS(1959),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1302] = {
    [sym_expression] = STATE(2759),
    [sym__string] = STATE(2808),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2808),
    [sym_concatenated_string] = STATE(2808),
    [sym_string_literal] = STATE(1900),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1900),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4503),
    [anon_sym_BANG] = ACTIONS(1921),
    [anon_sym_TILDE] = ACTIONS(1921),
    [anon_sym_DASH] = ACTIONS(1919),
    [anon_sym_PLUS] = ACTIONS(1919),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_AMP] = ACTIONS(4505),
    [anon_sym___extension__] = ACTIONS(1923),
    [anon_sym_COLON_COLON] = ACTIONS(1925),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1919),
    [anon_sym_compl] = ACTIONS(1919),
    [anon_sym_DASH_DASH] = ACTIONS(4491),
    [anon_sym_PLUS_PLUS] = ACTIONS(4491),
    [anon_sym_sizeof] = ACTIONS(1931),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1953),
    [anon_sym_R_DQUOTE] = ACTIONS(1955),
    [anon_sym_LR_DQUOTE] = ACTIONS(1955),
    [anon_sym_uR_DQUOTE] = ACTIONS(1955),
    [anon_sym_UR_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1955),
    [anon_sym_co_await] = ACTIONS(1957),
    [anon_sym_new] = ACTIONS(1959),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1303] = {
    [sym_expression] = STATE(2761),
    [sym__string] = STATE(2808),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2808),
    [sym_concatenated_string] = STATE(2808),
    [sym_string_literal] = STATE(1900),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1900),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4503),
    [anon_sym_BANG] = ACTIONS(1921),
    [anon_sym_TILDE] = ACTIONS(1921),
    [anon_sym_DASH] = ACTIONS(1919),
    [anon_sym_PLUS] = ACTIONS(1919),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_AMP] = ACTIONS(4505),
    [anon_sym___extension__] = ACTIONS(1923),
    [anon_sym_COLON_COLON] = ACTIONS(1925),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1919),
    [anon_sym_compl] = ACTIONS(1919),
    [anon_sym_DASH_DASH] = ACTIONS(4491),
    [anon_sym_PLUS_PLUS] = ACTIONS(4491),
    [anon_sym_sizeof] = ACTIONS(1931),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1953),
    [anon_sym_R_DQUOTE] = ACTIONS(1955),
    [anon_sym_LR_DQUOTE] = ACTIONS(1955),
    [anon_sym_uR_DQUOTE] = ACTIONS(1955),
    [anon_sym_UR_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1955),
    [anon_sym_co_await] = ACTIONS(1957),
    [anon_sym_new] = ACTIONS(1959),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1304] = {
    [sym_expression] = STATE(2358),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4424),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1965),
    [anon_sym_compl] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_sizeof] = ACTIONS(1973),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1305] = {
    [sym_expression] = STATE(2358),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(4788),
    [anon_sym_LPAREN2] = ACTIONS(4424),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1965),
    [anon_sym_compl] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_sizeof] = ACTIONS(1973),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1306] = {
    [sym_expression] = STATE(2352),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4424),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1965),
    [anon_sym_compl] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_sizeof] = ACTIONS(1973),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1307] = {
    [sym_expression] = STATE(4102),
    [sym__string] = STATE(4127),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(2853),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(2853),
    [sym_call_expression] = STATE(2853),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(2853),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(2853),
    [sym_char_literal] = STATE(4127),
    [sym_concatenated_string] = STATE(4127),
    [sym_string_literal] = STATE(3058),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3058),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2853),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(2853),
    [sym_identifier] = ACTIONS(4470),
    [anon_sym_LPAREN2] = ACTIONS(4509),
    [anon_sym_BANG] = ACTIONS(3460),
    [anon_sym_TILDE] = ACTIONS(3460),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_AMP] = ACTIONS(4505),
    [anon_sym___extension__] = ACTIONS(3462),
    [anon_sym_COLON_COLON] = ACTIONS(3464),
    [anon_sym_LBRACK] = ACTIONS(4790),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3458),
    [anon_sym_compl] = ACTIONS(3458),
    [anon_sym_DASH_DASH] = ACTIONS(4472),
    [anon_sym_PLUS_PLUS] = ACTIONS(4472),
    [anon_sym_sizeof] = ACTIONS(3468),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3470),
    [anon_sym_L_SQUOTE] = ACTIONS(3472),
    [anon_sym_u_SQUOTE] = ACTIONS(3472),
    [anon_sym_U_SQUOTE] = ACTIONS(3472),
    [anon_sym_u8_SQUOTE] = ACTIONS(3472),
    [anon_sym_SQUOTE] = ACTIONS(3472),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3476),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
    [anon_sym_co_await] = ACTIONS(3480),
    [anon_sym_new] = ACTIONS(3482),
    [anon_sym_requires] = ACTIONS(3484),
    [sym_this] = ACTIONS(221),
  },
  [1308] = {
    [sym_expression] = STATE(3653),
    [sym__string] = STATE(4127),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(2853),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(2853),
    [sym_call_expression] = STATE(2853),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(2853),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(2853),
    [sym_char_literal] = STATE(4127),
    [sym_concatenated_string] = STATE(4127),
    [sym_string_literal] = STATE(3058),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3058),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2853),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(2853),
    [sym_identifier] = ACTIONS(4470),
    [anon_sym_LPAREN2] = ACTIONS(4509),
    [anon_sym_BANG] = ACTIONS(3460),
    [anon_sym_TILDE] = ACTIONS(3460),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_AMP] = ACTIONS(4505),
    [anon_sym___extension__] = ACTIONS(3462),
    [anon_sym_COLON_COLON] = ACTIONS(3464),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3458),
    [anon_sym_compl] = ACTIONS(3458),
    [anon_sym_DASH_DASH] = ACTIONS(4472),
    [anon_sym_PLUS_PLUS] = ACTIONS(4472),
    [anon_sym_sizeof] = ACTIONS(3468),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3470),
    [anon_sym_L_SQUOTE] = ACTIONS(3472),
    [anon_sym_u_SQUOTE] = ACTIONS(3472),
    [anon_sym_U_SQUOTE] = ACTIONS(3472),
    [anon_sym_u8_SQUOTE] = ACTIONS(3472),
    [anon_sym_SQUOTE] = ACTIONS(3472),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3476),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
    [anon_sym_co_await] = ACTIONS(3480),
    [anon_sym_new] = ACTIONS(3482),
    [anon_sym_requires] = ACTIONS(3484),
    [sym_this] = ACTIONS(221),
  },
  [1309] = {
    [sym_expression] = STATE(4256),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1310] = {
    [sym_expression] = STATE(2342),
    [sym__string] = STATE(3071),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(3071),
    [sym_concatenated_string] = STATE(3071),
    [sym_string_literal] = STATE(2243),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(2243),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1989),
    [anon_sym_LPAREN2] = ACTIONS(4531),
    [anon_sym_BANG] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1993),
    [anon_sym_DASH] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1991),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym___extension__] = ACTIONS(1995),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_compl] = ACTIONS(1991),
    [anon_sym_DASH_DASH] = ACTIONS(4480),
    [anon_sym_PLUS_PLUS] = ACTIONS(4480),
    [anon_sym_sizeof] = ACTIONS(1999),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(2001),
    [anon_sym_L_SQUOTE] = ACTIONS(2003),
    [anon_sym_u_SQUOTE] = ACTIONS(2003),
    [anon_sym_U_SQUOTE] = ACTIONS(2003),
    [anon_sym_u8_SQUOTE] = ACTIONS(2003),
    [anon_sym_SQUOTE] = ACTIONS(2003),
    [anon_sym_L_DQUOTE] = ACTIONS(2005),
    [anon_sym_u_DQUOTE] = ACTIONS(2005),
    [anon_sym_U_DQUOTE] = ACTIONS(2005),
    [anon_sym_u8_DQUOTE] = ACTIONS(2005),
    [anon_sym_DQUOTE] = ACTIONS(2005),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2007),
    [anon_sym_R_DQUOTE] = ACTIONS(2009),
    [anon_sym_LR_DQUOTE] = ACTIONS(2009),
    [anon_sym_uR_DQUOTE] = ACTIONS(2009),
    [anon_sym_UR_DQUOTE] = ACTIONS(2009),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2009),
    [anon_sym_co_await] = ACTIONS(2011),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1311] = {
    [sym_expression] = STATE(4087),
    [sym__string] = STATE(4127),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(2853),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(2853),
    [sym_call_expression] = STATE(2853),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(2853),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(2853),
    [sym_char_literal] = STATE(4127),
    [sym_concatenated_string] = STATE(4127),
    [sym_string_literal] = STATE(3058),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3058),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2853),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(2853),
    [sym_identifier] = ACTIONS(4470),
    [anon_sym_LPAREN2] = ACTIONS(4509),
    [anon_sym_BANG] = ACTIONS(3460),
    [anon_sym_TILDE] = ACTIONS(3460),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_AMP] = ACTIONS(4505),
    [anon_sym___extension__] = ACTIONS(3462),
    [anon_sym_COLON_COLON] = ACTIONS(3464),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3458),
    [anon_sym_compl] = ACTIONS(3458),
    [anon_sym_DASH_DASH] = ACTIONS(4472),
    [anon_sym_PLUS_PLUS] = ACTIONS(4472),
    [anon_sym_sizeof] = ACTIONS(3468),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3470),
    [anon_sym_L_SQUOTE] = ACTIONS(3472),
    [anon_sym_u_SQUOTE] = ACTIONS(3472),
    [anon_sym_U_SQUOTE] = ACTIONS(3472),
    [anon_sym_u8_SQUOTE] = ACTIONS(3472),
    [anon_sym_SQUOTE] = ACTIONS(3472),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3476),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
    [anon_sym_co_await] = ACTIONS(3480),
    [anon_sym_new] = ACTIONS(3482),
    [anon_sym_requires] = ACTIONS(3484),
    [sym_this] = ACTIONS(221),
  },
  [1312] = {
    [sym_expression] = STATE(4086),
    [sym__string] = STATE(4127),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(2853),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(2853),
    [sym_call_expression] = STATE(2853),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(2853),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(2853),
    [sym_char_literal] = STATE(4127),
    [sym_concatenated_string] = STATE(4127),
    [sym_string_literal] = STATE(3058),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3058),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2853),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(2853),
    [sym_identifier] = ACTIONS(4470),
    [anon_sym_LPAREN2] = ACTIONS(4509),
    [anon_sym_BANG] = ACTIONS(3460),
    [anon_sym_TILDE] = ACTIONS(3460),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_AMP] = ACTIONS(4505),
    [anon_sym___extension__] = ACTIONS(3462),
    [anon_sym_COLON_COLON] = ACTIONS(3464),
    [anon_sym_LBRACK] = ACTIONS(4792),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3458),
    [anon_sym_compl] = ACTIONS(3458),
    [anon_sym_DASH_DASH] = ACTIONS(4472),
    [anon_sym_PLUS_PLUS] = ACTIONS(4472),
    [anon_sym_sizeof] = ACTIONS(3468),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3470),
    [anon_sym_L_SQUOTE] = ACTIONS(3472),
    [anon_sym_u_SQUOTE] = ACTIONS(3472),
    [anon_sym_U_SQUOTE] = ACTIONS(3472),
    [anon_sym_u8_SQUOTE] = ACTIONS(3472),
    [anon_sym_SQUOTE] = ACTIONS(3472),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3476),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
    [anon_sym_co_await] = ACTIONS(3480),
    [anon_sym_new] = ACTIONS(3482),
    [anon_sym_requires] = ACTIONS(3484),
    [sym_this] = ACTIONS(221),
  },
  [1313] = {
    [sym_expression] = STATE(4248),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1314] = {
    [sym_expression] = STATE(4119),
    [sym__string] = STATE(4127),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(2853),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(2853),
    [sym_call_expression] = STATE(2853),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(2853),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(2853),
    [sym_char_literal] = STATE(4127),
    [sym_concatenated_string] = STATE(4127),
    [sym_string_literal] = STATE(3058),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3058),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2853),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(2853),
    [sym_identifier] = ACTIONS(4470),
    [anon_sym_LPAREN2] = ACTIONS(4509),
    [anon_sym_BANG] = ACTIONS(3460),
    [anon_sym_TILDE] = ACTIONS(3460),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_AMP] = ACTIONS(4505),
    [anon_sym___extension__] = ACTIONS(3462),
    [anon_sym_COLON_COLON] = ACTIONS(3464),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3458),
    [anon_sym_compl] = ACTIONS(3458),
    [anon_sym_DASH_DASH] = ACTIONS(4472),
    [anon_sym_PLUS_PLUS] = ACTIONS(4472),
    [anon_sym_sizeof] = ACTIONS(3468),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3470),
    [anon_sym_L_SQUOTE] = ACTIONS(3472),
    [anon_sym_u_SQUOTE] = ACTIONS(3472),
    [anon_sym_U_SQUOTE] = ACTIONS(3472),
    [anon_sym_u8_SQUOTE] = ACTIONS(3472),
    [anon_sym_SQUOTE] = ACTIONS(3472),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3476),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
    [anon_sym_co_await] = ACTIONS(3480),
    [anon_sym_new] = ACTIONS(3482),
    [anon_sym_requires] = ACTIONS(3484),
    [sym_this] = ACTIONS(221),
  },
  [1315] = {
    [sym_expression] = STATE(3675),
    [sym__string] = STATE(4127),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(2853),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(2853),
    [sym_call_expression] = STATE(2853),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(2853),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(2853),
    [sym_char_literal] = STATE(4127),
    [sym_concatenated_string] = STATE(4127),
    [sym_string_literal] = STATE(3058),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3058),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2853),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(2853),
    [sym_identifier] = ACTIONS(4470),
    [anon_sym_LPAREN2] = ACTIONS(4509),
    [anon_sym_BANG] = ACTIONS(3460),
    [anon_sym_TILDE] = ACTIONS(3460),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_AMP] = ACTIONS(4505),
    [anon_sym___extension__] = ACTIONS(3462),
    [anon_sym_COLON_COLON] = ACTIONS(3464),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3458),
    [anon_sym_compl] = ACTIONS(3458),
    [anon_sym_DASH_DASH] = ACTIONS(4472),
    [anon_sym_PLUS_PLUS] = ACTIONS(4472),
    [anon_sym_sizeof] = ACTIONS(3468),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3470),
    [anon_sym_L_SQUOTE] = ACTIONS(3472),
    [anon_sym_u_SQUOTE] = ACTIONS(3472),
    [anon_sym_U_SQUOTE] = ACTIONS(3472),
    [anon_sym_u8_SQUOTE] = ACTIONS(3472),
    [anon_sym_SQUOTE] = ACTIONS(3472),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3476),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
    [anon_sym_co_await] = ACTIONS(3480),
    [anon_sym_new] = ACTIONS(3482),
    [anon_sym_requires] = ACTIONS(3484),
    [sym_this] = ACTIONS(221),
  },
  [1316] = {
    [sym_expression] = STATE(4101),
    [sym__string] = STATE(4127),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(2853),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(2853),
    [sym_call_expression] = STATE(2853),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(2853),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(2853),
    [sym_char_literal] = STATE(4127),
    [sym_concatenated_string] = STATE(4127),
    [sym_string_literal] = STATE(3058),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3058),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2853),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(2853),
    [sym_identifier] = ACTIONS(4470),
    [anon_sym_LPAREN2] = ACTIONS(4509),
    [anon_sym_BANG] = ACTIONS(3460),
    [anon_sym_TILDE] = ACTIONS(3460),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_AMP] = ACTIONS(4505),
    [anon_sym___extension__] = ACTIONS(3462),
    [anon_sym_COLON_COLON] = ACTIONS(3464),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3458),
    [anon_sym_compl] = ACTIONS(3458),
    [anon_sym_DASH_DASH] = ACTIONS(4472),
    [anon_sym_PLUS_PLUS] = ACTIONS(4472),
    [anon_sym_sizeof] = ACTIONS(3468),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3470),
    [anon_sym_L_SQUOTE] = ACTIONS(3472),
    [anon_sym_u_SQUOTE] = ACTIONS(3472),
    [anon_sym_U_SQUOTE] = ACTIONS(3472),
    [anon_sym_u8_SQUOTE] = ACTIONS(3472),
    [anon_sym_SQUOTE] = ACTIONS(3472),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3476),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
    [anon_sym_co_await] = ACTIONS(3480),
    [anon_sym_new] = ACTIONS(3482),
    [anon_sym_requires] = ACTIONS(3484),
    [sym_this] = ACTIONS(221),
  },
  [1317] = {
    [sym_expression] = STATE(4063),
    [sym__string] = STATE(4127),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(2853),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(2853),
    [sym_call_expression] = STATE(2853),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(2853),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(2853),
    [sym_char_literal] = STATE(4127),
    [sym_concatenated_string] = STATE(4127),
    [sym_string_literal] = STATE(3058),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3058),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2853),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(2853),
    [sym_identifier] = ACTIONS(4470),
    [anon_sym_LPAREN2] = ACTIONS(4509),
    [anon_sym_BANG] = ACTIONS(3460),
    [anon_sym_TILDE] = ACTIONS(3460),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_AMP] = ACTIONS(4505),
    [anon_sym___extension__] = ACTIONS(3462),
    [anon_sym_COLON_COLON] = ACTIONS(3464),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3458),
    [anon_sym_compl] = ACTIONS(3458),
    [anon_sym_DASH_DASH] = ACTIONS(4472),
    [anon_sym_PLUS_PLUS] = ACTIONS(4472),
    [anon_sym_sizeof] = ACTIONS(3468),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3470),
    [anon_sym_L_SQUOTE] = ACTIONS(3472),
    [anon_sym_u_SQUOTE] = ACTIONS(3472),
    [anon_sym_U_SQUOTE] = ACTIONS(3472),
    [anon_sym_u8_SQUOTE] = ACTIONS(3472),
    [anon_sym_SQUOTE] = ACTIONS(3472),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3476),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
    [anon_sym_co_await] = ACTIONS(3480),
    [anon_sym_new] = ACTIONS(3482),
    [anon_sym_requires] = ACTIONS(3484),
    [sym_this] = ACTIONS(221),
  },
  [1318] = {
    [sym_expression] = STATE(4111),
    [sym__string] = STATE(4127),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(2853),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(2853),
    [sym_call_expression] = STATE(2853),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(2853),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(2853),
    [sym_char_literal] = STATE(4127),
    [sym_concatenated_string] = STATE(4127),
    [sym_string_literal] = STATE(3058),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3058),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2853),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(2853),
    [sym_identifier] = ACTIONS(4470),
    [anon_sym_LPAREN2] = ACTIONS(4509),
    [anon_sym_BANG] = ACTIONS(3460),
    [anon_sym_TILDE] = ACTIONS(3460),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_AMP] = ACTIONS(4505),
    [anon_sym___extension__] = ACTIONS(3462),
    [anon_sym_COLON_COLON] = ACTIONS(3464),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3458),
    [anon_sym_compl] = ACTIONS(3458),
    [anon_sym_DASH_DASH] = ACTIONS(4472),
    [anon_sym_PLUS_PLUS] = ACTIONS(4472),
    [anon_sym_sizeof] = ACTIONS(3468),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3470),
    [anon_sym_L_SQUOTE] = ACTIONS(3472),
    [anon_sym_u_SQUOTE] = ACTIONS(3472),
    [anon_sym_U_SQUOTE] = ACTIONS(3472),
    [anon_sym_u8_SQUOTE] = ACTIONS(3472),
    [anon_sym_SQUOTE] = ACTIONS(3472),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3476),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
    [anon_sym_co_await] = ACTIONS(3480),
    [anon_sym_new] = ACTIONS(3482),
    [anon_sym_requires] = ACTIONS(3484),
    [sym_this] = ACTIONS(221),
  },
  [1319] = {
    [sym_expression] = STATE(4106),
    [sym__string] = STATE(4127),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(2853),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(2853),
    [sym_call_expression] = STATE(2853),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(2853),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(2853),
    [sym_char_literal] = STATE(4127),
    [sym_concatenated_string] = STATE(4127),
    [sym_string_literal] = STATE(3058),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3058),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2853),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(2853),
    [sym_identifier] = ACTIONS(4470),
    [anon_sym_LPAREN2] = ACTIONS(4509),
    [anon_sym_BANG] = ACTIONS(3460),
    [anon_sym_TILDE] = ACTIONS(3460),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_AMP] = ACTIONS(4505),
    [anon_sym___extension__] = ACTIONS(3462),
    [anon_sym_COLON_COLON] = ACTIONS(3464),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3458),
    [anon_sym_compl] = ACTIONS(3458),
    [anon_sym_DASH_DASH] = ACTIONS(4472),
    [anon_sym_PLUS_PLUS] = ACTIONS(4472),
    [anon_sym_sizeof] = ACTIONS(3468),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3470),
    [anon_sym_L_SQUOTE] = ACTIONS(3472),
    [anon_sym_u_SQUOTE] = ACTIONS(3472),
    [anon_sym_U_SQUOTE] = ACTIONS(3472),
    [anon_sym_u8_SQUOTE] = ACTIONS(3472),
    [anon_sym_SQUOTE] = ACTIONS(3472),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3476),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
    [anon_sym_co_await] = ACTIONS(3480),
    [anon_sym_new] = ACTIONS(3482),
    [anon_sym_requires] = ACTIONS(3484),
    [sym_this] = ACTIONS(221),
  },
  [1320] = {
    [sym_expression] = STATE(4115),
    [sym__string] = STATE(4127),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(2853),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(2853),
    [sym_call_expression] = STATE(2853),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(2853),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(2853),
    [sym_char_literal] = STATE(4127),
    [sym_concatenated_string] = STATE(4127),
    [sym_string_literal] = STATE(3058),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3058),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2853),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(2853),
    [sym_identifier] = ACTIONS(4470),
    [anon_sym_LPAREN2] = ACTIONS(4509),
    [anon_sym_BANG] = ACTIONS(3460),
    [anon_sym_TILDE] = ACTIONS(3460),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_AMP] = ACTIONS(4505),
    [anon_sym___extension__] = ACTIONS(3462),
    [anon_sym_COLON_COLON] = ACTIONS(3464),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3458),
    [anon_sym_compl] = ACTIONS(3458),
    [anon_sym_DASH_DASH] = ACTIONS(4472),
    [anon_sym_PLUS_PLUS] = ACTIONS(4472),
    [anon_sym_sizeof] = ACTIONS(3468),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3470),
    [anon_sym_L_SQUOTE] = ACTIONS(3472),
    [anon_sym_u_SQUOTE] = ACTIONS(3472),
    [anon_sym_U_SQUOTE] = ACTIONS(3472),
    [anon_sym_u8_SQUOTE] = ACTIONS(3472),
    [anon_sym_SQUOTE] = ACTIONS(3472),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3476),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
    [anon_sym_co_await] = ACTIONS(3480),
    [anon_sym_new] = ACTIONS(3482),
    [anon_sym_requires] = ACTIONS(3484),
    [sym_this] = ACTIONS(221),
  },
  [1321] = {
    [sym_expression] = STATE(4120),
    [sym__string] = STATE(4127),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(2853),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(2853),
    [sym_call_expression] = STATE(2853),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(2853),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(2853),
    [sym_char_literal] = STATE(4127),
    [sym_concatenated_string] = STATE(4127),
    [sym_string_literal] = STATE(3058),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3058),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2853),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(2853),
    [sym_identifier] = ACTIONS(4470),
    [anon_sym_LPAREN2] = ACTIONS(4509),
    [anon_sym_BANG] = ACTIONS(3460),
    [anon_sym_TILDE] = ACTIONS(3460),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_AMP] = ACTIONS(4505),
    [anon_sym___extension__] = ACTIONS(3462),
    [anon_sym_COLON_COLON] = ACTIONS(3464),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3458),
    [anon_sym_compl] = ACTIONS(3458),
    [anon_sym_DASH_DASH] = ACTIONS(4472),
    [anon_sym_PLUS_PLUS] = ACTIONS(4472),
    [anon_sym_sizeof] = ACTIONS(3468),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3470),
    [anon_sym_L_SQUOTE] = ACTIONS(3472),
    [anon_sym_u_SQUOTE] = ACTIONS(3472),
    [anon_sym_U_SQUOTE] = ACTIONS(3472),
    [anon_sym_u8_SQUOTE] = ACTIONS(3472),
    [anon_sym_SQUOTE] = ACTIONS(3472),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3476),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
    [anon_sym_co_await] = ACTIONS(3480),
    [anon_sym_new] = ACTIONS(3482),
    [anon_sym_requires] = ACTIONS(3484),
    [sym_this] = ACTIONS(221),
  },
  [1322] = {
    [sym_expression] = STATE(4064),
    [sym__string] = STATE(4127),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(2853),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(2853),
    [sym_call_expression] = STATE(2853),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(2853),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(2853),
    [sym_char_literal] = STATE(4127),
    [sym_concatenated_string] = STATE(4127),
    [sym_string_literal] = STATE(3058),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3058),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2853),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(2853),
    [sym_identifier] = ACTIONS(4470),
    [anon_sym_LPAREN2] = ACTIONS(4509),
    [anon_sym_BANG] = ACTIONS(3460),
    [anon_sym_TILDE] = ACTIONS(3460),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_AMP] = ACTIONS(4505),
    [anon_sym___extension__] = ACTIONS(3462),
    [anon_sym_COLON_COLON] = ACTIONS(3464),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3458),
    [anon_sym_compl] = ACTIONS(3458),
    [anon_sym_DASH_DASH] = ACTIONS(4472),
    [anon_sym_PLUS_PLUS] = ACTIONS(4472),
    [anon_sym_sizeof] = ACTIONS(3468),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3470),
    [anon_sym_L_SQUOTE] = ACTIONS(3472),
    [anon_sym_u_SQUOTE] = ACTIONS(3472),
    [anon_sym_U_SQUOTE] = ACTIONS(3472),
    [anon_sym_u8_SQUOTE] = ACTIONS(3472),
    [anon_sym_SQUOTE] = ACTIONS(3472),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3476),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
    [anon_sym_co_await] = ACTIONS(3480),
    [anon_sym_new] = ACTIONS(3482),
    [anon_sym_requires] = ACTIONS(3484),
    [sym_this] = ACTIONS(221),
  },
  [1323] = {
    [sym_expression] = STATE(4076),
    [sym__string] = STATE(4127),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(2853),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(2853),
    [sym_call_expression] = STATE(2853),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(2853),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(2853),
    [sym_char_literal] = STATE(4127),
    [sym_concatenated_string] = STATE(4127),
    [sym_string_literal] = STATE(3058),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3058),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2853),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(2853),
    [sym_identifier] = ACTIONS(4470),
    [anon_sym_LPAREN2] = ACTIONS(4509),
    [anon_sym_BANG] = ACTIONS(3460),
    [anon_sym_TILDE] = ACTIONS(3460),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_AMP] = ACTIONS(4505),
    [anon_sym___extension__] = ACTIONS(3462),
    [anon_sym_COLON_COLON] = ACTIONS(3464),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3458),
    [anon_sym_compl] = ACTIONS(3458),
    [anon_sym_DASH_DASH] = ACTIONS(4472),
    [anon_sym_PLUS_PLUS] = ACTIONS(4472),
    [anon_sym_sizeof] = ACTIONS(3468),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3470),
    [anon_sym_L_SQUOTE] = ACTIONS(3472),
    [anon_sym_u_SQUOTE] = ACTIONS(3472),
    [anon_sym_U_SQUOTE] = ACTIONS(3472),
    [anon_sym_u8_SQUOTE] = ACTIONS(3472),
    [anon_sym_SQUOTE] = ACTIONS(3472),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3476),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
    [anon_sym_co_await] = ACTIONS(3480),
    [anon_sym_new] = ACTIONS(3482),
    [anon_sym_requires] = ACTIONS(3484),
    [sym_this] = ACTIONS(221),
  },
  [1324] = {
    [sym_expression] = STATE(4083),
    [sym__string] = STATE(4127),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(2853),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(2853),
    [sym_call_expression] = STATE(2853),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(2853),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(2853),
    [sym_char_literal] = STATE(4127),
    [sym_concatenated_string] = STATE(4127),
    [sym_string_literal] = STATE(3058),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3058),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2853),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(2853),
    [sym_identifier] = ACTIONS(4470),
    [anon_sym_LPAREN2] = ACTIONS(4509),
    [anon_sym_BANG] = ACTIONS(3460),
    [anon_sym_TILDE] = ACTIONS(3460),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_AMP] = ACTIONS(4505),
    [anon_sym___extension__] = ACTIONS(3462),
    [anon_sym_COLON_COLON] = ACTIONS(3464),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3458),
    [anon_sym_compl] = ACTIONS(3458),
    [anon_sym_DASH_DASH] = ACTIONS(4472),
    [anon_sym_PLUS_PLUS] = ACTIONS(4472),
    [anon_sym_sizeof] = ACTIONS(3468),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3470),
    [anon_sym_L_SQUOTE] = ACTIONS(3472),
    [anon_sym_u_SQUOTE] = ACTIONS(3472),
    [anon_sym_U_SQUOTE] = ACTIONS(3472),
    [anon_sym_u8_SQUOTE] = ACTIONS(3472),
    [anon_sym_SQUOTE] = ACTIONS(3472),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3476),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
    [anon_sym_co_await] = ACTIONS(3480),
    [anon_sym_new] = ACTIONS(3482),
    [anon_sym_requires] = ACTIONS(3484),
    [sym_this] = ACTIONS(221),
  },
  [1325] = {
    [sym_expression] = STATE(4263),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1326] = {
    [sym_expression] = STATE(4265),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1327] = {
    [sym_expression] = STATE(4271),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1328] = {
    [sym_expression] = STATE(4090),
    [sym__string] = STATE(4127),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(2853),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(2853),
    [sym_call_expression] = STATE(2853),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(2853),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(2853),
    [sym_char_literal] = STATE(4127),
    [sym_concatenated_string] = STATE(4127),
    [sym_string_literal] = STATE(3058),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3058),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2853),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(2853),
    [sym_identifier] = ACTIONS(4470),
    [anon_sym_LPAREN2] = ACTIONS(4509),
    [anon_sym_BANG] = ACTIONS(3460),
    [anon_sym_TILDE] = ACTIONS(3460),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_AMP] = ACTIONS(4505),
    [anon_sym___extension__] = ACTIONS(3462),
    [anon_sym_COLON_COLON] = ACTIONS(3464),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3458),
    [anon_sym_compl] = ACTIONS(3458),
    [anon_sym_DASH_DASH] = ACTIONS(4472),
    [anon_sym_PLUS_PLUS] = ACTIONS(4472),
    [anon_sym_sizeof] = ACTIONS(3468),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3470),
    [anon_sym_L_SQUOTE] = ACTIONS(3472),
    [anon_sym_u_SQUOTE] = ACTIONS(3472),
    [anon_sym_U_SQUOTE] = ACTIONS(3472),
    [anon_sym_u8_SQUOTE] = ACTIONS(3472),
    [anon_sym_SQUOTE] = ACTIONS(3472),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3476),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
    [anon_sym_co_await] = ACTIONS(3480),
    [anon_sym_new] = ACTIONS(3482),
    [anon_sym_requires] = ACTIONS(3484),
    [sym_this] = ACTIONS(221),
  },
  [1329] = {
    [sym_expression] = STATE(4099),
    [sym__string] = STATE(4127),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(2853),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(2853),
    [sym_call_expression] = STATE(2853),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(2853),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(2853),
    [sym_char_literal] = STATE(4127),
    [sym_concatenated_string] = STATE(4127),
    [sym_string_literal] = STATE(3058),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3058),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2853),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(2853),
    [sym_identifier] = ACTIONS(4470),
    [anon_sym_LPAREN2] = ACTIONS(4509),
    [anon_sym_BANG] = ACTIONS(3460),
    [anon_sym_TILDE] = ACTIONS(3460),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_AMP] = ACTIONS(4505),
    [anon_sym___extension__] = ACTIONS(3462),
    [anon_sym_COLON_COLON] = ACTIONS(3464),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3458),
    [anon_sym_compl] = ACTIONS(3458),
    [anon_sym_DASH_DASH] = ACTIONS(4472),
    [anon_sym_PLUS_PLUS] = ACTIONS(4472),
    [anon_sym_sizeof] = ACTIONS(3468),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3470),
    [anon_sym_L_SQUOTE] = ACTIONS(3472),
    [anon_sym_u_SQUOTE] = ACTIONS(3472),
    [anon_sym_U_SQUOTE] = ACTIONS(3472),
    [anon_sym_u8_SQUOTE] = ACTIONS(3472),
    [anon_sym_SQUOTE] = ACTIONS(3472),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3476),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
    [anon_sym_co_await] = ACTIONS(3480),
    [anon_sym_new] = ACTIONS(3482),
    [anon_sym_requires] = ACTIONS(3484),
    [sym_this] = ACTIONS(221),
  },
  [1330] = {
    [sym_expression] = STATE(4272),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1331] = {
    [sym_expression] = STATE(4273),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1332] = {
    [sym_expression] = STATE(3169),
    [sym__string] = STATE(3374),
    [sym_conditional_expression] = STATE(3536),
    [sym_assignment_expression] = STATE(3536),
    [sym_pointer_expression] = STATE(3544),
    [sym_unary_expression] = STATE(3536),
    [sym_binary_expression] = STATE(3536),
    [sym_update_expression] = STATE(3536),
    [sym_cast_expression] = STATE(3536),
    [sym_sizeof_expression] = STATE(3536),
    [sym_alignof_expression] = STATE(3536),
    [sym_offsetof_expression] = STATE(3536),
    [sym_generic_expression] = STATE(3536),
    [sym_subscript_expression] = STATE(3544),
    [sym_call_expression] = STATE(3544),
    [sym_gnu_asm_expression] = STATE(3536),
    [sym_extension_expression] = STATE(3536),
    [sym_field_expression] = STATE(3544),
    [sym_compound_literal_expression] = STATE(3536),
    [sym_parenthesized_expression] = STATE(3544),
    [sym_char_literal] = STATE(3374),
    [sym_concatenated_string] = STATE(3374),
    [sym_string_literal] = STATE(2363),
    [sym_null] = STATE(3536),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7597),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3536),
    [sym_raw_string_literal] = STATE(2363),
    [sym_co_await_expression] = STATE(3536),
    [sym_new_expression] = STATE(3536),
    [sym_delete_expression] = STATE(3536),
    [sym_requires_clause] = STATE(3536),
    [sym_requires_expression] = STATE(3536),
    [sym_lambda_expression] = STATE(3536),
    [sym_lambda_capture_specifier] = STATE(5874),
    [sym_fold_expression] = STATE(3536),
    [sym_parameter_pack_expansion] = STATE(3536),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3544),
    [sym_qualified_type_identifier] = STATE(7597),
    [sym_user_defined_literal] = STATE(3544),
    [sym_identifier] = ACTIONS(2446),
    [anon_sym_LPAREN2] = ACTIONS(4521),
    [anon_sym_BANG] = ACTIONS(2450),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2448),
    [anon_sym_PLUS] = ACTIONS(2448),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(2452),
    [anon_sym_COLON_COLON] = ACTIONS(2454),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2458),
    [anon_sym_not] = ACTIONS(2448),
    [anon_sym_compl] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(4478),
    [anon_sym_PLUS_PLUS] = ACTIONS(4478),
    [anon_sym_sizeof] = ACTIONS(2460),
    [anon_sym___alignof__] = ACTIONS(2462),
    [anon_sym___alignof] = ACTIONS(2462),
    [anon_sym__alignof] = ACTIONS(2462),
    [anon_sym_alignof] = ACTIONS(2462),
    [anon_sym__Alignof] = ACTIONS(2462),
    [anon_sym_offsetof] = ACTIONS(2464),
    [anon_sym__Generic] = ACTIONS(2466),
    [anon_sym_asm] = ACTIONS(2468),
    [anon_sym___asm__] = ACTIONS(2468),
    [anon_sym___asm] = ACTIONS(2468),
    [sym_number_literal] = ACTIONS(2470),
    [anon_sym_L_SQUOTE] = ACTIONS(2472),
    [anon_sym_u_SQUOTE] = ACTIONS(2472),
    [anon_sym_U_SQUOTE] = ACTIONS(2472),
    [anon_sym_u8_SQUOTE] = ACTIONS(2472),
    [anon_sym_SQUOTE] = ACTIONS(2472),
    [anon_sym_L_DQUOTE] = ACTIONS(2474),
    [anon_sym_u_DQUOTE] = ACTIONS(2474),
    [anon_sym_U_DQUOTE] = ACTIONS(2474),
    [anon_sym_u8_DQUOTE] = ACTIONS(2474),
    [anon_sym_DQUOTE] = ACTIONS(2474),
    [sym_true] = ACTIONS(2476),
    [sym_false] = ACTIONS(2476),
    [anon_sym_NULL] = ACTIONS(2478),
    [anon_sym_nullptr] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2480),
    [anon_sym_R_DQUOTE] = ACTIONS(2482),
    [anon_sym_LR_DQUOTE] = ACTIONS(2482),
    [anon_sym_uR_DQUOTE] = ACTIONS(2482),
    [anon_sym_UR_DQUOTE] = ACTIONS(2482),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2482),
    [anon_sym_co_await] = ACTIONS(2484),
    [anon_sym_new] = ACTIONS(2486),
    [anon_sym_requires] = ACTIONS(2488),
    [sym_this] = ACTIONS(2476),
  },
  [1333] = {
    [sym_expression] = STATE(3189),
    [sym__string] = STATE(3374),
    [sym_conditional_expression] = STATE(3536),
    [sym_assignment_expression] = STATE(3536),
    [sym_pointer_expression] = STATE(3544),
    [sym_unary_expression] = STATE(3536),
    [sym_binary_expression] = STATE(3536),
    [sym_update_expression] = STATE(3536),
    [sym_cast_expression] = STATE(3536),
    [sym_sizeof_expression] = STATE(3536),
    [sym_alignof_expression] = STATE(3536),
    [sym_offsetof_expression] = STATE(3536),
    [sym_generic_expression] = STATE(3536),
    [sym_subscript_expression] = STATE(3544),
    [sym_call_expression] = STATE(3544),
    [sym_gnu_asm_expression] = STATE(3536),
    [sym_extension_expression] = STATE(3536),
    [sym_field_expression] = STATE(3544),
    [sym_compound_literal_expression] = STATE(3536),
    [sym_parenthesized_expression] = STATE(3544),
    [sym_char_literal] = STATE(3374),
    [sym_concatenated_string] = STATE(3374),
    [sym_string_literal] = STATE(2363),
    [sym_null] = STATE(3536),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7597),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3536),
    [sym_raw_string_literal] = STATE(2363),
    [sym_co_await_expression] = STATE(3536),
    [sym_new_expression] = STATE(3536),
    [sym_delete_expression] = STATE(3536),
    [sym_requires_clause] = STATE(3536),
    [sym_requires_expression] = STATE(3536),
    [sym_lambda_expression] = STATE(3536),
    [sym_lambda_capture_specifier] = STATE(5874),
    [sym_fold_expression] = STATE(3536),
    [sym_parameter_pack_expansion] = STATE(3536),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3544),
    [sym_qualified_type_identifier] = STATE(7597),
    [sym_user_defined_literal] = STATE(3544),
    [sym_identifier] = ACTIONS(2446),
    [anon_sym_LPAREN2] = ACTIONS(4521),
    [anon_sym_BANG] = ACTIONS(2450),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2448),
    [anon_sym_PLUS] = ACTIONS(2448),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(2452),
    [anon_sym_COLON_COLON] = ACTIONS(2454),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2458),
    [anon_sym_not] = ACTIONS(2448),
    [anon_sym_compl] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(4478),
    [anon_sym_PLUS_PLUS] = ACTIONS(4478),
    [anon_sym_sizeof] = ACTIONS(2460),
    [anon_sym___alignof__] = ACTIONS(2462),
    [anon_sym___alignof] = ACTIONS(2462),
    [anon_sym__alignof] = ACTIONS(2462),
    [anon_sym_alignof] = ACTIONS(2462),
    [anon_sym__Alignof] = ACTIONS(2462),
    [anon_sym_offsetof] = ACTIONS(2464),
    [anon_sym__Generic] = ACTIONS(2466),
    [anon_sym_asm] = ACTIONS(2468),
    [anon_sym___asm__] = ACTIONS(2468),
    [anon_sym___asm] = ACTIONS(2468),
    [sym_number_literal] = ACTIONS(2470),
    [anon_sym_L_SQUOTE] = ACTIONS(2472),
    [anon_sym_u_SQUOTE] = ACTIONS(2472),
    [anon_sym_U_SQUOTE] = ACTIONS(2472),
    [anon_sym_u8_SQUOTE] = ACTIONS(2472),
    [anon_sym_SQUOTE] = ACTIONS(2472),
    [anon_sym_L_DQUOTE] = ACTIONS(2474),
    [anon_sym_u_DQUOTE] = ACTIONS(2474),
    [anon_sym_U_DQUOTE] = ACTIONS(2474),
    [anon_sym_u8_DQUOTE] = ACTIONS(2474),
    [anon_sym_DQUOTE] = ACTIONS(2474),
    [sym_true] = ACTIONS(2476),
    [sym_false] = ACTIONS(2476),
    [anon_sym_NULL] = ACTIONS(2478),
    [anon_sym_nullptr] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2480),
    [anon_sym_R_DQUOTE] = ACTIONS(2482),
    [anon_sym_LR_DQUOTE] = ACTIONS(2482),
    [anon_sym_uR_DQUOTE] = ACTIONS(2482),
    [anon_sym_UR_DQUOTE] = ACTIONS(2482),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2482),
    [anon_sym_co_await] = ACTIONS(2484),
    [anon_sym_new] = ACTIONS(2486),
    [anon_sym_requires] = ACTIONS(2488),
    [sym_this] = ACTIONS(2476),
  },
  [1334] = {
    [sym_expression] = STATE(3190),
    [sym__string] = STATE(3374),
    [sym_conditional_expression] = STATE(3536),
    [sym_assignment_expression] = STATE(3536),
    [sym_pointer_expression] = STATE(3544),
    [sym_unary_expression] = STATE(3536),
    [sym_binary_expression] = STATE(3536),
    [sym_update_expression] = STATE(3536),
    [sym_cast_expression] = STATE(3536),
    [sym_sizeof_expression] = STATE(3536),
    [sym_alignof_expression] = STATE(3536),
    [sym_offsetof_expression] = STATE(3536),
    [sym_generic_expression] = STATE(3536),
    [sym_subscript_expression] = STATE(3544),
    [sym_call_expression] = STATE(3544),
    [sym_gnu_asm_expression] = STATE(3536),
    [sym_extension_expression] = STATE(3536),
    [sym_field_expression] = STATE(3544),
    [sym_compound_literal_expression] = STATE(3536),
    [sym_parenthesized_expression] = STATE(3544),
    [sym_char_literal] = STATE(3374),
    [sym_concatenated_string] = STATE(3374),
    [sym_string_literal] = STATE(2363),
    [sym_null] = STATE(3536),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7597),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3536),
    [sym_raw_string_literal] = STATE(2363),
    [sym_co_await_expression] = STATE(3536),
    [sym_new_expression] = STATE(3536),
    [sym_delete_expression] = STATE(3536),
    [sym_requires_clause] = STATE(3536),
    [sym_requires_expression] = STATE(3536),
    [sym_lambda_expression] = STATE(3536),
    [sym_lambda_capture_specifier] = STATE(5874),
    [sym_fold_expression] = STATE(3536),
    [sym_parameter_pack_expansion] = STATE(3536),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3544),
    [sym_qualified_type_identifier] = STATE(7597),
    [sym_user_defined_literal] = STATE(3544),
    [sym_identifier] = ACTIONS(2446),
    [anon_sym_LPAREN2] = ACTIONS(4521),
    [anon_sym_BANG] = ACTIONS(2450),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2448),
    [anon_sym_PLUS] = ACTIONS(2448),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(2452),
    [anon_sym_COLON_COLON] = ACTIONS(2454),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2458),
    [anon_sym_not] = ACTIONS(2448),
    [anon_sym_compl] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(4478),
    [anon_sym_PLUS_PLUS] = ACTIONS(4478),
    [anon_sym_sizeof] = ACTIONS(2460),
    [anon_sym___alignof__] = ACTIONS(2462),
    [anon_sym___alignof] = ACTIONS(2462),
    [anon_sym__alignof] = ACTIONS(2462),
    [anon_sym_alignof] = ACTIONS(2462),
    [anon_sym__Alignof] = ACTIONS(2462),
    [anon_sym_offsetof] = ACTIONS(2464),
    [anon_sym__Generic] = ACTIONS(2466),
    [anon_sym_asm] = ACTIONS(2468),
    [anon_sym___asm__] = ACTIONS(2468),
    [anon_sym___asm] = ACTIONS(2468),
    [sym_number_literal] = ACTIONS(2470),
    [anon_sym_L_SQUOTE] = ACTIONS(2472),
    [anon_sym_u_SQUOTE] = ACTIONS(2472),
    [anon_sym_U_SQUOTE] = ACTIONS(2472),
    [anon_sym_u8_SQUOTE] = ACTIONS(2472),
    [anon_sym_SQUOTE] = ACTIONS(2472),
    [anon_sym_L_DQUOTE] = ACTIONS(2474),
    [anon_sym_u_DQUOTE] = ACTIONS(2474),
    [anon_sym_U_DQUOTE] = ACTIONS(2474),
    [anon_sym_u8_DQUOTE] = ACTIONS(2474),
    [anon_sym_DQUOTE] = ACTIONS(2474),
    [sym_true] = ACTIONS(2476),
    [sym_false] = ACTIONS(2476),
    [anon_sym_NULL] = ACTIONS(2478),
    [anon_sym_nullptr] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2480),
    [anon_sym_R_DQUOTE] = ACTIONS(2482),
    [anon_sym_LR_DQUOTE] = ACTIONS(2482),
    [anon_sym_uR_DQUOTE] = ACTIONS(2482),
    [anon_sym_UR_DQUOTE] = ACTIONS(2482),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2482),
    [anon_sym_co_await] = ACTIONS(2484),
    [anon_sym_new] = ACTIONS(2486),
    [anon_sym_requires] = ACTIONS(2488),
    [sym_this] = ACTIONS(2476),
  },
  [1335] = {
    [sym_expression] = STATE(3195),
    [sym__string] = STATE(3374),
    [sym_conditional_expression] = STATE(3536),
    [sym_assignment_expression] = STATE(3536),
    [sym_pointer_expression] = STATE(3544),
    [sym_unary_expression] = STATE(3536),
    [sym_binary_expression] = STATE(3536),
    [sym_update_expression] = STATE(3536),
    [sym_cast_expression] = STATE(3536),
    [sym_sizeof_expression] = STATE(3536),
    [sym_alignof_expression] = STATE(3536),
    [sym_offsetof_expression] = STATE(3536),
    [sym_generic_expression] = STATE(3536),
    [sym_subscript_expression] = STATE(3544),
    [sym_call_expression] = STATE(3544),
    [sym_gnu_asm_expression] = STATE(3536),
    [sym_extension_expression] = STATE(3536),
    [sym_field_expression] = STATE(3544),
    [sym_compound_literal_expression] = STATE(3536),
    [sym_parenthesized_expression] = STATE(3544),
    [sym_char_literal] = STATE(3374),
    [sym_concatenated_string] = STATE(3374),
    [sym_string_literal] = STATE(2363),
    [sym_null] = STATE(3536),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7597),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3536),
    [sym_raw_string_literal] = STATE(2363),
    [sym_co_await_expression] = STATE(3536),
    [sym_new_expression] = STATE(3536),
    [sym_delete_expression] = STATE(3536),
    [sym_requires_clause] = STATE(3536),
    [sym_requires_expression] = STATE(3536),
    [sym_lambda_expression] = STATE(3536),
    [sym_lambda_capture_specifier] = STATE(5874),
    [sym_fold_expression] = STATE(3536),
    [sym_parameter_pack_expansion] = STATE(3536),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3544),
    [sym_qualified_type_identifier] = STATE(7597),
    [sym_user_defined_literal] = STATE(3544),
    [sym_identifier] = ACTIONS(2446),
    [anon_sym_LPAREN2] = ACTIONS(4521),
    [anon_sym_BANG] = ACTIONS(2450),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2448),
    [anon_sym_PLUS] = ACTIONS(2448),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(2452),
    [anon_sym_COLON_COLON] = ACTIONS(2454),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2458),
    [anon_sym_not] = ACTIONS(2448),
    [anon_sym_compl] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(4478),
    [anon_sym_PLUS_PLUS] = ACTIONS(4478),
    [anon_sym_sizeof] = ACTIONS(2460),
    [anon_sym___alignof__] = ACTIONS(2462),
    [anon_sym___alignof] = ACTIONS(2462),
    [anon_sym__alignof] = ACTIONS(2462),
    [anon_sym_alignof] = ACTIONS(2462),
    [anon_sym__Alignof] = ACTIONS(2462),
    [anon_sym_offsetof] = ACTIONS(2464),
    [anon_sym__Generic] = ACTIONS(2466),
    [anon_sym_asm] = ACTIONS(2468),
    [anon_sym___asm__] = ACTIONS(2468),
    [anon_sym___asm] = ACTIONS(2468),
    [sym_number_literal] = ACTIONS(2470),
    [anon_sym_L_SQUOTE] = ACTIONS(2472),
    [anon_sym_u_SQUOTE] = ACTIONS(2472),
    [anon_sym_U_SQUOTE] = ACTIONS(2472),
    [anon_sym_u8_SQUOTE] = ACTIONS(2472),
    [anon_sym_SQUOTE] = ACTIONS(2472),
    [anon_sym_L_DQUOTE] = ACTIONS(2474),
    [anon_sym_u_DQUOTE] = ACTIONS(2474),
    [anon_sym_U_DQUOTE] = ACTIONS(2474),
    [anon_sym_u8_DQUOTE] = ACTIONS(2474),
    [anon_sym_DQUOTE] = ACTIONS(2474),
    [sym_true] = ACTIONS(2476),
    [sym_false] = ACTIONS(2476),
    [anon_sym_NULL] = ACTIONS(2478),
    [anon_sym_nullptr] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2480),
    [anon_sym_R_DQUOTE] = ACTIONS(2482),
    [anon_sym_LR_DQUOTE] = ACTIONS(2482),
    [anon_sym_uR_DQUOTE] = ACTIONS(2482),
    [anon_sym_UR_DQUOTE] = ACTIONS(2482),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2482),
    [anon_sym_co_await] = ACTIONS(2484),
    [anon_sym_new] = ACTIONS(2486),
    [anon_sym_requires] = ACTIONS(2488),
    [sym_this] = ACTIONS(2476),
  },
  [1336] = {
    [sym_expression] = STATE(3196),
    [sym__string] = STATE(3374),
    [sym_conditional_expression] = STATE(3536),
    [sym_assignment_expression] = STATE(3536),
    [sym_pointer_expression] = STATE(3544),
    [sym_unary_expression] = STATE(3536),
    [sym_binary_expression] = STATE(3536),
    [sym_update_expression] = STATE(3536),
    [sym_cast_expression] = STATE(3536),
    [sym_sizeof_expression] = STATE(3536),
    [sym_alignof_expression] = STATE(3536),
    [sym_offsetof_expression] = STATE(3536),
    [sym_generic_expression] = STATE(3536),
    [sym_subscript_expression] = STATE(3544),
    [sym_call_expression] = STATE(3544),
    [sym_gnu_asm_expression] = STATE(3536),
    [sym_extension_expression] = STATE(3536),
    [sym_field_expression] = STATE(3544),
    [sym_compound_literal_expression] = STATE(3536),
    [sym_parenthesized_expression] = STATE(3544),
    [sym_char_literal] = STATE(3374),
    [sym_concatenated_string] = STATE(3374),
    [sym_string_literal] = STATE(2363),
    [sym_null] = STATE(3536),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7597),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3536),
    [sym_raw_string_literal] = STATE(2363),
    [sym_co_await_expression] = STATE(3536),
    [sym_new_expression] = STATE(3536),
    [sym_delete_expression] = STATE(3536),
    [sym_requires_clause] = STATE(3536),
    [sym_requires_expression] = STATE(3536),
    [sym_lambda_expression] = STATE(3536),
    [sym_lambda_capture_specifier] = STATE(5874),
    [sym_fold_expression] = STATE(3536),
    [sym_parameter_pack_expansion] = STATE(3536),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3544),
    [sym_qualified_type_identifier] = STATE(7597),
    [sym_user_defined_literal] = STATE(3544),
    [sym_identifier] = ACTIONS(2446),
    [anon_sym_LPAREN2] = ACTIONS(4521),
    [anon_sym_BANG] = ACTIONS(2450),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2448),
    [anon_sym_PLUS] = ACTIONS(2448),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(2452),
    [anon_sym_COLON_COLON] = ACTIONS(2454),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2458),
    [anon_sym_not] = ACTIONS(2448),
    [anon_sym_compl] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(4478),
    [anon_sym_PLUS_PLUS] = ACTIONS(4478),
    [anon_sym_sizeof] = ACTIONS(2460),
    [anon_sym___alignof__] = ACTIONS(2462),
    [anon_sym___alignof] = ACTIONS(2462),
    [anon_sym__alignof] = ACTIONS(2462),
    [anon_sym_alignof] = ACTIONS(2462),
    [anon_sym__Alignof] = ACTIONS(2462),
    [anon_sym_offsetof] = ACTIONS(2464),
    [anon_sym__Generic] = ACTIONS(2466),
    [anon_sym_asm] = ACTIONS(2468),
    [anon_sym___asm__] = ACTIONS(2468),
    [anon_sym___asm] = ACTIONS(2468),
    [sym_number_literal] = ACTIONS(2470),
    [anon_sym_L_SQUOTE] = ACTIONS(2472),
    [anon_sym_u_SQUOTE] = ACTIONS(2472),
    [anon_sym_U_SQUOTE] = ACTIONS(2472),
    [anon_sym_u8_SQUOTE] = ACTIONS(2472),
    [anon_sym_SQUOTE] = ACTIONS(2472),
    [anon_sym_L_DQUOTE] = ACTIONS(2474),
    [anon_sym_u_DQUOTE] = ACTIONS(2474),
    [anon_sym_U_DQUOTE] = ACTIONS(2474),
    [anon_sym_u8_DQUOTE] = ACTIONS(2474),
    [anon_sym_DQUOTE] = ACTIONS(2474),
    [sym_true] = ACTIONS(2476),
    [sym_false] = ACTIONS(2476),
    [anon_sym_NULL] = ACTIONS(2478),
    [anon_sym_nullptr] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2480),
    [anon_sym_R_DQUOTE] = ACTIONS(2482),
    [anon_sym_LR_DQUOTE] = ACTIONS(2482),
    [anon_sym_uR_DQUOTE] = ACTIONS(2482),
    [anon_sym_UR_DQUOTE] = ACTIONS(2482),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2482),
    [anon_sym_co_await] = ACTIONS(2484),
    [anon_sym_new] = ACTIONS(2486),
    [anon_sym_requires] = ACTIONS(2488),
    [sym_this] = ACTIONS(2476),
  },
  [1337] = {
    [sym_expression] = STATE(3200),
    [sym__string] = STATE(3374),
    [sym_conditional_expression] = STATE(3536),
    [sym_assignment_expression] = STATE(3536),
    [sym_pointer_expression] = STATE(3544),
    [sym_unary_expression] = STATE(3536),
    [sym_binary_expression] = STATE(3536),
    [sym_update_expression] = STATE(3536),
    [sym_cast_expression] = STATE(3536),
    [sym_sizeof_expression] = STATE(3536),
    [sym_alignof_expression] = STATE(3536),
    [sym_offsetof_expression] = STATE(3536),
    [sym_generic_expression] = STATE(3536),
    [sym_subscript_expression] = STATE(3544),
    [sym_call_expression] = STATE(3544),
    [sym_gnu_asm_expression] = STATE(3536),
    [sym_extension_expression] = STATE(3536),
    [sym_field_expression] = STATE(3544),
    [sym_compound_literal_expression] = STATE(3536),
    [sym_parenthesized_expression] = STATE(3544),
    [sym_char_literal] = STATE(3374),
    [sym_concatenated_string] = STATE(3374),
    [sym_string_literal] = STATE(2363),
    [sym_null] = STATE(3536),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7597),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3536),
    [sym_raw_string_literal] = STATE(2363),
    [sym_co_await_expression] = STATE(3536),
    [sym_new_expression] = STATE(3536),
    [sym_delete_expression] = STATE(3536),
    [sym_requires_clause] = STATE(3536),
    [sym_requires_expression] = STATE(3536),
    [sym_lambda_expression] = STATE(3536),
    [sym_lambda_capture_specifier] = STATE(5874),
    [sym_fold_expression] = STATE(3536),
    [sym_parameter_pack_expansion] = STATE(3536),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3544),
    [sym_qualified_type_identifier] = STATE(7597),
    [sym_user_defined_literal] = STATE(3544),
    [sym_identifier] = ACTIONS(2446),
    [anon_sym_LPAREN2] = ACTIONS(4521),
    [anon_sym_BANG] = ACTIONS(2450),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2448),
    [anon_sym_PLUS] = ACTIONS(2448),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(2452),
    [anon_sym_COLON_COLON] = ACTIONS(2454),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2458),
    [anon_sym_not] = ACTIONS(2448),
    [anon_sym_compl] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(4478),
    [anon_sym_PLUS_PLUS] = ACTIONS(4478),
    [anon_sym_sizeof] = ACTIONS(2460),
    [anon_sym___alignof__] = ACTIONS(2462),
    [anon_sym___alignof] = ACTIONS(2462),
    [anon_sym__alignof] = ACTIONS(2462),
    [anon_sym_alignof] = ACTIONS(2462),
    [anon_sym__Alignof] = ACTIONS(2462),
    [anon_sym_offsetof] = ACTIONS(2464),
    [anon_sym__Generic] = ACTIONS(2466),
    [anon_sym_asm] = ACTIONS(2468),
    [anon_sym___asm__] = ACTIONS(2468),
    [anon_sym___asm] = ACTIONS(2468),
    [sym_number_literal] = ACTIONS(2470),
    [anon_sym_L_SQUOTE] = ACTIONS(2472),
    [anon_sym_u_SQUOTE] = ACTIONS(2472),
    [anon_sym_U_SQUOTE] = ACTIONS(2472),
    [anon_sym_u8_SQUOTE] = ACTIONS(2472),
    [anon_sym_SQUOTE] = ACTIONS(2472),
    [anon_sym_L_DQUOTE] = ACTIONS(2474),
    [anon_sym_u_DQUOTE] = ACTIONS(2474),
    [anon_sym_U_DQUOTE] = ACTIONS(2474),
    [anon_sym_u8_DQUOTE] = ACTIONS(2474),
    [anon_sym_DQUOTE] = ACTIONS(2474),
    [sym_true] = ACTIONS(2476),
    [sym_false] = ACTIONS(2476),
    [anon_sym_NULL] = ACTIONS(2478),
    [anon_sym_nullptr] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2480),
    [anon_sym_R_DQUOTE] = ACTIONS(2482),
    [anon_sym_LR_DQUOTE] = ACTIONS(2482),
    [anon_sym_uR_DQUOTE] = ACTIONS(2482),
    [anon_sym_UR_DQUOTE] = ACTIONS(2482),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2482),
    [anon_sym_co_await] = ACTIONS(2484),
    [anon_sym_new] = ACTIONS(2486),
    [anon_sym_requires] = ACTIONS(2488),
    [sym_this] = ACTIONS(2476),
  },
  [1338] = {
    [sym_expression] = STATE(3203),
    [sym__string] = STATE(3374),
    [sym_conditional_expression] = STATE(3536),
    [sym_assignment_expression] = STATE(3536),
    [sym_pointer_expression] = STATE(3544),
    [sym_unary_expression] = STATE(3536),
    [sym_binary_expression] = STATE(3536),
    [sym_update_expression] = STATE(3536),
    [sym_cast_expression] = STATE(3536),
    [sym_sizeof_expression] = STATE(3536),
    [sym_alignof_expression] = STATE(3536),
    [sym_offsetof_expression] = STATE(3536),
    [sym_generic_expression] = STATE(3536),
    [sym_subscript_expression] = STATE(3544),
    [sym_call_expression] = STATE(3544),
    [sym_gnu_asm_expression] = STATE(3536),
    [sym_extension_expression] = STATE(3536),
    [sym_field_expression] = STATE(3544),
    [sym_compound_literal_expression] = STATE(3536),
    [sym_parenthesized_expression] = STATE(3544),
    [sym_char_literal] = STATE(3374),
    [sym_concatenated_string] = STATE(3374),
    [sym_string_literal] = STATE(2363),
    [sym_null] = STATE(3536),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7597),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3536),
    [sym_raw_string_literal] = STATE(2363),
    [sym_co_await_expression] = STATE(3536),
    [sym_new_expression] = STATE(3536),
    [sym_delete_expression] = STATE(3536),
    [sym_requires_clause] = STATE(3536),
    [sym_requires_expression] = STATE(3536),
    [sym_lambda_expression] = STATE(3536),
    [sym_lambda_capture_specifier] = STATE(5874),
    [sym_fold_expression] = STATE(3536),
    [sym_parameter_pack_expansion] = STATE(3536),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3544),
    [sym_qualified_type_identifier] = STATE(7597),
    [sym_user_defined_literal] = STATE(3544),
    [sym_identifier] = ACTIONS(2446),
    [anon_sym_LPAREN2] = ACTIONS(4521),
    [anon_sym_BANG] = ACTIONS(2450),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2448),
    [anon_sym_PLUS] = ACTIONS(2448),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(2452),
    [anon_sym_COLON_COLON] = ACTIONS(2454),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2458),
    [anon_sym_not] = ACTIONS(2448),
    [anon_sym_compl] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(4478),
    [anon_sym_PLUS_PLUS] = ACTIONS(4478),
    [anon_sym_sizeof] = ACTIONS(2460),
    [anon_sym___alignof__] = ACTIONS(2462),
    [anon_sym___alignof] = ACTIONS(2462),
    [anon_sym__alignof] = ACTIONS(2462),
    [anon_sym_alignof] = ACTIONS(2462),
    [anon_sym__Alignof] = ACTIONS(2462),
    [anon_sym_offsetof] = ACTIONS(2464),
    [anon_sym__Generic] = ACTIONS(2466),
    [anon_sym_asm] = ACTIONS(2468),
    [anon_sym___asm__] = ACTIONS(2468),
    [anon_sym___asm] = ACTIONS(2468),
    [sym_number_literal] = ACTIONS(2470),
    [anon_sym_L_SQUOTE] = ACTIONS(2472),
    [anon_sym_u_SQUOTE] = ACTIONS(2472),
    [anon_sym_U_SQUOTE] = ACTIONS(2472),
    [anon_sym_u8_SQUOTE] = ACTIONS(2472),
    [anon_sym_SQUOTE] = ACTIONS(2472),
    [anon_sym_L_DQUOTE] = ACTIONS(2474),
    [anon_sym_u_DQUOTE] = ACTIONS(2474),
    [anon_sym_U_DQUOTE] = ACTIONS(2474),
    [anon_sym_u8_DQUOTE] = ACTIONS(2474),
    [anon_sym_DQUOTE] = ACTIONS(2474),
    [sym_true] = ACTIONS(2476),
    [sym_false] = ACTIONS(2476),
    [anon_sym_NULL] = ACTIONS(2478),
    [anon_sym_nullptr] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2480),
    [anon_sym_R_DQUOTE] = ACTIONS(2482),
    [anon_sym_LR_DQUOTE] = ACTIONS(2482),
    [anon_sym_uR_DQUOTE] = ACTIONS(2482),
    [anon_sym_UR_DQUOTE] = ACTIONS(2482),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2482),
    [anon_sym_co_await] = ACTIONS(2484),
    [anon_sym_new] = ACTIONS(2486),
    [anon_sym_requires] = ACTIONS(2488),
    [sym_this] = ACTIONS(2476),
  },
  [1339] = {
    [sym_expression] = STATE(3205),
    [sym__string] = STATE(3374),
    [sym_conditional_expression] = STATE(3536),
    [sym_assignment_expression] = STATE(3536),
    [sym_pointer_expression] = STATE(3544),
    [sym_unary_expression] = STATE(3536),
    [sym_binary_expression] = STATE(3536),
    [sym_update_expression] = STATE(3536),
    [sym_cast_expression] = STATE(3536),
    [sym_sizeof_expression] = STATE(3536),
    [sym_alignof_expression] = STATE(3536),
    [sym_offsetof_expression] = STATE(3536),
    [sym_generic_expression] = STATE(3536),
    [sym_subscript_expression] = STATE(3544),
    [sym_call_expression] = STATE(3544),
    [sym_gnu_asm_expression] = STATE(3536),
    [sym_extension_expression] = STATE(3536),
    [sym_field_expression] = STATE(3544),
    [sym_compound_literal_expression] = STATE(3536),
    [sym_parenthesized_expression] = STATE(3544),
    [sym_char_literal] = STATE(3374),
    [sym_concatenated_string] = STATE(3374),
    [sym_string_literal] = STATE(2363),
    [sym_null] = STATE(3536),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7597),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3536),
    [sym_raw_string_literal] = STATE(2363),
    [sym_co_await_expression] = STATE(3536),
    [sym_new_expression] = STATE(3536),
    [sym_delete_expression] = STATE(3536),
    [sym_requires_clause] = STATE(3536),
    [sym_requires_expression] = STATE(3536),
    [sym_lambda_expression] = STATE(3536),
    [sym_lambda_capture_specifier] = STATE(5874),
    [sym_fold_expression] = STATE(3536),
    [sym_parameter_pack_expansion] = STATE(3536),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3544),
    [sym_qualified_type_identifier] = STATE(7597),
    [sym_user_defined_literal] = STATE(3544),
    [sym_identifier] = ACTIONS(2446),
    [anon_sym_LPAREN2] = ACTIONS(4521),
    [anon_sym_BANG] = ACTIONS(2450),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2448),
    [anon_sym_PLUS] = ACTIONS(2448),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(2452),
    [anon_sym_COLON_COLON] = ACTIONS(2454),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2458),
    [anon_sym_not] = ACTIONS(2448),
    [anon_sym_compl] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(4478),
    [anon_sym_PLUS_PLUS] = ACTIONS(4478),
    [anon_sym_sizeof] = ACTIONS(2460),
    [anon_sym___alignof__] = ACTIONS(2462),
    [anon_sym___alignof] = ACTIONS(2462),
    [anon_sym__alignof] = ACTIONS(2462),
    [anon_sym_alignof] = ACTIONS(2462),
    [anon_sym__Alignof] = ACTIONS(2462),
    [anon_sym_offsetof] = ACTIONS(2464),
    [anon_sym__Generic] = ACTIONS(2466),
    [anon_sym_asm] = ACTIONS(2468),
    [anon_sym___asm__] = ACTIONS(2468),
    [anon_sym___asm] = ACTIONS(2468),
    [sym_number_literal] = ACTIONS(2470),
    [anon_sym_L_SQUOTE] = ACTIONS(2472),
    [anon_sym_u_SQUOTE] = ACTIONS(2472),
    [anon_sym_U_SQUOTE] = ACTIONS(2472),
    [anon_sym_u8_SQUOTE] = ACTIONS(2472),
    [anon_sym_SQUOTE] = ACTIONS(2472),
    [anon_sym_L_DQUOTE] = ACTIONS(2474),
    [anon_sym_u_DQUOTE] = ACTIONS(2474),
    [anon_sym_U_DQUOTE] = ACTIONS(2474),
    [anon_sym_u8_DQUOTE] = ACTIONS(2474),
    [anon_sym_DQUOTE] = ACTIONS(2474),
    [sym_true] = ACTIONS(2476),
    [sym_false] = ACTIONS(2476),
    [anon_sym_NULL] = ACTIONS(2478),
    [anon_sym_nullptr] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2480),
    [anon_sym_R_DQUOTE] = ACTIONS(2482),
    [anon_sym_LR_DQUOTE] = ACTIONS(2482),
    [anon_sym_uR_DQUOTE] = ACTIONS(2482),
    [anon_sym_UR_DQUOTE] = ACTIONS(2482),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2482),
    [anon_sym_co_await] = ACTIONS(2484),
    [anon_sym_new] = ACTIONS(2486),
    [anon_sym_requires] = ACTIONS(2488),
    [sym_this] = ACTIONS(2476),
  },
  [1340] = {
    [sym_expression] = STATE(3206),
    [sym__string] = STATE(3374),
    [sym_conditional_expression] = STATE(3536),
    [sym_assignment_expression] = STATE(3536),
    [sym_pointer_expression] = STATE(3544),
    [sym_unary_expression] = STATE(3536),
    [sym_binary_expression] = STATE(3536),
    [sym_update_expression] = STATE(3536),
    [sym_cast_expression] = STATE(3536),
    [sym_sizeof_expression] = STATE(3536),
    [sym_alignof_expression] = STATE(3536),
    [sym_offsetof_expression] = STATE(3536),
    [sym_generic_expression] = STATE(3536),
    [sym_subscript_expression] = STATE(3544),
    [sym_call_expression] = STATE(3544),
    [sym_gnu_asm_expression] = STATE(3536),
    [sym_extension_expression] = STATE(3536),
    [sym_field_expression] = STATE(3544),
    [sym_compound_literal_expression] = STATE(3536),
    [sym_parenthesized_expression] = STATE(3544),
    [sym_char_literal] = STATE(3374),
    [sym_concatenated_string] = STATE(3374),
    [sym_string_literal] = STATE(2363),
    [sym_null] = STATE(3536),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7597),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3536),
    [sym_raw_string_literal] = STATE(2363),
    [sym_co_await_expression] = STATE(3536),
    [sym_new_expression] = STATE(3536),
    [sym_delete_expression] = STATE(3536),
    [sym_requires_clause] = STATE(3536),
    [sym_requires_expression] = STATE(3536),
    [sym_lambda_expression] = STATE(3536),
    [sym_lambda_capture_specifier] = STATE(5874),
    [sym_fold_expression] = STATE(3536),
    [sym_parameter_pack_expansion] = STATE(3536),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3544),
    [sym_qualified_type_identifier] = STATE(7597),
    [sym_user_defined_literal] = STATE(3544),
    [sym_identifier] = ACTIONS(2446),
    [anon_sym_LPAREN2] = ACTIONS(4521),
    [anon_sym_BANG] = ACTIONS(2450),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2448),
    [anon_sym_PLUS] = ACTIONS(2448),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(2452),
    [anon_sym_COLON_COLON] = ACTIONS(2454),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2458),
    [anon_sym_not] = ACTIONS(2448),
    [anon_sym_compl] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(4478),
    [anon_sym_PLUS_PLUS] = ACTIONS(4478),
    [anon_sym_sizeof] = ACTIONS(2460),
    [anon_sym___alignof__] = ACTIONS(2462),
    [anon_sym___alignof] = ACTIONS(2462),
    [anon_sym__alignof] = ACTIONS(2462),
    [anon_sym_alignof] = ACTIONS(2462),
    [anon_sym__Alignof] = ACTIONS(2462),
    [anon_sym_offsetof] = ACTIONS(2464),
    [anon_sym__Generic] = ACTIONS(2466),
    [anon_sym_asm] = ACTIONS(2468),
    [anon_sym___asm__] = ACTIONS(2468),
    [anon_sym___asm] = ACTIONS(2468),
    [sym_number_literal] = ACTIONS(2470),
    [anon_sym_L_SQUOTE] = ACTIONS(2472),
    [anon_sym_u_SQUOTE] = ACTIONS(2472),
    [anon_sym_U_SQUOTE] = ACTIONS(2472),
    [anon_sym_u8_SQUOTE] = ACTIONS(2472),
    [anon_sym_SQUOTE] = ACTIONS(2472),
    [anon_sym_L_DQUOTE] = ACTIONS(2474),
    [anon_sym_u_DQUOTE] = ACTIONS(2474),
    [anon_sym_U_DQUOTE] = ACTIONS(2474),
    [anon_sym_u8_DQUOTE] = ACTIONS(2474),
    [anon_sym_DQUOTE] = ACTIONS(2474),
    [sym_true] = ACTIONS(2476),
    [sym_false] = ACTIONS(2476),
    [anon_sym_NULL] = ACTIONS(2478),
    [anon_sym_nullptr] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2480),
    [anon_sym_R_DQUOTE] = ACTIONS(2482),
    [anon_sym_LR_DQUOTE] = ACTIONS(2482),
    [anon_sym_uR_DQUOTE] = ACTIONS(2482),
    [anon_sym_UR_DQUOTE] = ACTIONS(2482),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2482),
    [anon_sym_co_await] = ACTIONS(2484),
    [anon_sym_new] = ACTIONS(2486),
    [anon_sym_requires] = ACTIONS(2488),
    [sym_this] = ACTIONS(2476),
  },
  [1341] = {
    [sym_expression] = STATE(3208),
    [sym__string] = STATE(3374),
    [sym_conditional_expression] = STATE(3536),
    [sym_assignment_expression] = STATE(3536),
    [sym_pointer_expression] = STATE(3544),
    [sym_unary_expression] = STATE(3536),
    [sym_binary_expression] = STATE(3536),
    [sym_update_expression] = STATE(3536),
    [sym_cast_expression] = STATE(3536),
    [sym_sizeof_expression] = STATE(3536),
    [sym_alignof_expression] = STATE(3536),
    [sym_offsetof_expression] = STATE(3536),
    [sym_generic_expression] = STATE(3536),
    [sym_subscript_expression] = STATE(3544),
    [sym_call_expression] = STATE(3544),
    [sym_gnu_asm_expression] = STATE(3536),
    [sym_extension_expression] = STATE(3536),
    [sym_field_expression] = STATE(3544),
    [sym_compound_literal_expression] = STATE(3536),
    [sym_parenthesized_expression] = STATE(3544),
    [sym_char_literal] = STATE(3374),
    [sym_concatenated_string] = STATE(3374),
    [sym_string_literal] = STATE(2363),
    [sym_null] = STATE(3536),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7597),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3536),
    [sym_raw_string_literal] = STATE(2363),
    [sym_co_await_expression] = STATE(3536),
    [sym_new_expression] = STATE(3536),
    [sym_delete_expression] = STATE(3536),
    [sym_requires_clause] = STATE(3536),
    [sym_requires_expression] = STATE(3536),
    [sym_lambda_expression] = STATE(3536),
    [sym_lambda_capture_specifier] = STATE(5874),
    [sym_fold_expression] = STATE(3536),
    [sym_parameter_pack_expansion] = STATE(3536),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3544),
    [sym_qualified_type_identifier] = STATE(7597),
    [sym_user_defined_literal] = STATE(3544),
    [sym_identifier] = ACTIONS(2446),
    [anon_sym_LPAREN2] = ACTIONS(4521),
    [anon_sym_BANG] = ACTIONS(2450),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2448),
    [anon_sym_PLUS] = ACTIONS(2448),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(2452),
    [anon_sym_COLON_COLON] = ACTIONS(2454),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2458),
    [anon_sym_not] = ACTIONS(2448),
    [anon_sym_compl] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(4478),
    [anon_sym_PLUS_PLUS] = ACTIONS(4478),
    [anon_sym_sizeof] = ACTIONS(2460),
    [anon_sym___alignof__] = ACTIONS(2462),
    [anon_sym___alignof] = ACTIONS(2462),
    [anon_sym__alignof] = ACTIONS(2462),
    [anon_sym_alignof] = ACTIONS(2462),
    [anon_sym__Alignof] = ACTIONS(2462),
    [anon_sym_offsetof] = ACTIONS(2464),
    [anon_sym__Generic] = ACTIONS(2466),
    [anon_sym_asm] = ACTIONS(2468),
    [anon_sym___asm__] = ACTIONS(2468),
    [anon_sym___asm] = ACTIONS(2468),
    [sym_number_literal] = ACTIONS(2470),
    [anon_sym_L_SQUOTE] = ACTIONS(2472),
    [anon_sym_u_SQUOTE] = ACTIONS(2472),
    [anon_sym_U_SQUOTE] = ACTIONS(2472),
    [anon_sym_u8_SQUOTE] = ACTIONS(2472),
    [anon_sym_SQUOTE] = ACTIONS(2472),
    [anon_sym_L_DQUOTE] = ACTIONS(2474),
    [anon_sym_u_DQUOTE] = ACTIONS(2474),
    [anon_sym_U_DQUOTE] = ACTIONS(2474),
    [anon_sym_u8_DQUOTE] = ACTIONS(2474),
    [anon_sym_DQUOTE] = ACTIONS(2474),
    [sym_true] = ACTIONS(2476),
    [sym_false] = ACTIONS(2476),
    [anon_sym_NULL] = ACTIONS(2478),
    [anon_sym_nullptr] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2480),
    [anon_sym_R_DQUOTE] = ACTIONS(2482),
    [anon_sym_LR_DQUOTE] = ACTIONS(2482),
    [anon_sym_uR_DQUOTE] = ACTIONS(2482),
    [anon_sym_UR_DQUOTE] = ACTIONS(2482),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2482),
    [anon_sym_co_await] = ACTIONS(2484),
    [anon_sym_new] = ACTIONS(2486),
    [anon_sym_requires] = ACTIONS(2488),
    [sym_this] = ACTIONS(2476),
  },
  [1342] = {
    [sym_expression] = STATE(3213),
    [sym__string] = STATE(3374),
    [sym_conditional_expression] = STATE(3536),
    [sym_assignment_expression] = STATE(3536),
    [sym_pointer_expression] = STATE(3544),
    [sym_unary_expression] = STATE(3536),
    [sym_binary_expression] = STATE(3536),
    [sym_update_expression] = STATE(3536),
    [sym_cast_expression] = STATE(3536),
    [sym_sizeof_expression] = STATE(3536),
    [sym_alignof_expression] = STATE(3536),
    [sym_offsetof_expression] = STATE(3536),
    [sym_generic_expression] = STATE(3536),
    [sym_subscript_expression] = STATE(3544),
    [sym_call_expression] = STATE(3544),
    [sym_gnu_asm_expression] = STATE(3536),
    [sym_extension_expression] = STATE(3536),
    [sym_field_expression] = STATE(3544),
    [sym_compound_literal_expression] = STATE(3536),
    [sym_parenthesized_expression] = STATE(3544),
    [sym_char_literal] = STATE(3374),
    [sym_concatenated_string] = STATE(3374),
    [sym_string_literal] = STATE(2363),
    [sym_null] = STATE(3536),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7597),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3536),
    [sym_raw_string_literal] = STATE(2363),
    [sym_co_await_expression] = STATE(3536),
    [sym_new_expression] = STATE(3536),
    [sym_delete_expression] = STATE(3536),
    [sym_requires_clause] = STATE(3536),
    [sym_requires_expression] = STATE(3536),
    [sym_lambda_expression] = STATE(3536),
    [sym_lambda_capture_specifier] = STATE(5874),
    [sym_fold_expression] = STATE(3536),
    [sym_parameter_pack_expansion] = STATE(3536),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3544),
    [sym_qualified_type_identifier] = STATE(7597),
    [sym_user_defined_literal] = STATE(3544),
    [sym_identifier] = ACTIONS(2446),
    [anon_sym_LPAREN2] = ACTIONS(4521),
    [anon_sym_BANG] = ACTIONS(2450),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2448),
    [anon_sym_PLUS] = ACTIONS(2448),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(2452),
    [anon_sym_COLON_COLON] = ACTIONS(2454),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2458),
    [anon_sym_not] = ACTIONS(2448),
    [anon_sym_compl] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(4478),
    [anon_sym_PLUS_PLUS] = ACTIONS(4478),
    [anon_sym_sizeof] = ACTIONS(2460),
    [anon_sym___alignof__] = ACTIONS(2462),
    [anon_sym___alignof] = ACTIONS(2462),
    [anon_sym__alignof] = ACTIONS(2462),
    [anon_sym_alignof] = ACTIONS(2462),
    [anon_sym__Alignof] = ACTIONS(2462),
    [anon_sym_offsetof] = ACTIONS(2464),
    [anon_sym__Generic] = ACTIONS(2466),
    [anon_sym_asm] = ACTIONS(2468),
    [anon_sym___asm__] = ACTIONS(2468),
    [anon_sym___asm] = ACTIONS(2468),
    [sym_number_literal] = ACTIONS(2470),
    [anon_sym_L_SQUOTE] = ACTIONS(2472),
    [anon_sym_u_SQUOTE] = ACTIONS(2472),
    [anon_sym_U_SQUOTE] = ACTIONS(2472),
    [anon_sym_u8_SQUOTE] = ACTIONS(2472),
    [anon_sym_SQUOTE] = ACTIONS(2472),
    [anon_sym_L_DQUOTE] = ACTIONS(2474),
    [anon_sym_u_DQUOTE] = ACTIONS(2474),
    [anon_sym_U_DQUOTE] = ACTIONS(2474),
    [anon_sym_u8_DQUOTE] = ACTIONS(2474),
    [anon_sym_DQUOTE] = ACTIONS(2474),
    [sym_true] = ACTIONS(2476),
    [sym_false] = ACTIONS(2476),
    [anon_sym_NULL] = ACTIONS(2478),
    [anon_sym_nullptr] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2480),
    [anon_sym_R_DQUOTE] = ACTIONS(2482),
    [anon_sym_LR_DQUOTE] = ACTIONS(2482),
    [anon_sym_uR_DQUOTE] = ACTIONS(2482),
    [anon_sym_UR_DQUOTE] = ACTIONS(2482),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2482),
    [anon_sym_co_await] = ACTIONS(2484),
    [anon_sym_new] = ACTIONS(2486),
    [anon_sym_requires] = ACTIONS(2488),
    [sym_this] = ACTIONS(2476),
  },
  [1343] = {
    [sym_expression] = STATE(2769),
    [sym__string] = STATE(2808),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2808),
    [sym_concatenated_string] = STATE(2808),
    [sym_string_literal] = STATE(1900),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1900),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4503),
    [anon_sym_BANG] = ACTIONS(1921),
    [anon_sym_TILDE] = ACTIONS(1921),
    [anon_sym_DASH] = ACTIONS(1919),
    [anon_sym_PLUS] = ACTIONS(1919),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_AMP] = ACTIONS(4505),
    [anon_sym___extension__] = ACTIONS(1923),
    [anon_sym_COLON_COLON] = ACTIONS(1925),
    [anon_sym_LBRACK] = ACTIONS(4794),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1919),
    [anon_sym_compl] = ACTIONS(1919),
    [anon_sym_DASH_DASH] = ACTIONS(4491),
    [anon_sym_PLUS_PLUS] = ACTIONS(4491),
    [anon_sym_sizeof] = ACTIONS(1931),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1953),
    [anon_sym_R_DQUOTE] = ACTIONS(1955),
    [anon_sym_LR_DQUOTE] = ACTIONS(1955),
    [anon_sym_uR_DQUOTE] = ACTIONS(1955),
    [anon_sym_UR_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1955),
    [anon_sym_co_await] = ACTIONS(1957),
    [anon_sym_new] = ACTIONS(1959),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1344] = {
    [sym_expression] = STATE(2327),
    [sym__string] = STATE(2808),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2808),
    [sym_concatenated_string] = STATE(2808),
    [sym_string_literal] = STATE(1900),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1900),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4503),
    [anon_sym_BANG] = ACTIONS(1921),
    [anon_sym_TILDE] = ACTIONS(1921),
    [anon_sym_DASH] = ACTIONS(1919),
    [anon_sym_PLUS] = ACTIONS(1919),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_AMP] = ACTIONS(4505),
    [anon_sym___extension__] = ACTIONS(1923),
    [anon_sym_COLON_COLON] = ACTIONS(1925),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1919),
    [anon_sym_compl] = ACTIONS(1919),
    [anon_sym_DASH_DASH] = ACTIONS(4491),
    [anon_sym_PLUS_PLUS] = ACTIONS(4491),
    [anon_sym_sizeof] = ACTIONS(1931),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1953),
    [anon_sym_R_DQUOTE] = ACTIONS(1955),
    [anon_sym_LR_DQUOTE] = ACTIONS(1955),
    [anon_sym_uR_DQUOTE] = ACTIONS(1955),
    [anon_sym_UR_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1955),
    [anon_sym_co_await] = ACTIONS(1957),
    [anon_sym_new] = ACTIONS(1959),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1345] = {
    [sym_expression] = STATE(4443),
    [sym__string] = STATE(4637),
    [sym_conditional_expression] = STATE(4735),
    [sym_assignment_expression] = STATE(4735),
    [sym_pointer_expression] = STATE(3573),
    [sym_unary_expression] = STATE(4735),
    [sym_binary_expression] = STATE(4735),
    [sym_update_expression] = STATE(4735),
    [sym_cast_expression] = STATE(4735),
    [sym_sizeof_expression] = STATE(4735),
    [sym_alignof_expression] = STATE(4735),
    [sym_offsetof_expression] = STATE(4735),
    [sym_generic_expression] = STATE(4735),
    [sym_subscript_expression] = STATE(3573),
    [sym_call_expression] = STATE(3573),
    [sym_gnu_asm_expression] = STATE(4735),
    [sym_extension_expression] = STATE(4735),
    [sym_field_expression] = STATE(3573),
    [sym_compound_literal_expression] = STATE(4735),
    [sym_parenthesized_expression] = STATE(3573),
    [sym_char_literal] = STATE(4637),
    [sym_concatenated_string] = STATE(4637),
    [sym_string_literal] = STATE(3662),
    [sym_null] = STATE(4735),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7513),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(4735),
    [sym_raw_string_literal] = STATE(3662),
    [sym_co_await_expression] = STATE(4735),
    [sym_new_expression] = STATE(4735),
    [sym_delete_expression] = STATE(4735),
    [sym_requires_clause] = STATE(4735),
    [sym_requires_expression] = STATE(4735),
    [sym_lambda_expression] = STATE(4735),
    [sym_lambda_capture_specifier] = STATE(5854),
    [sym_fold_expression] = STATE(4735),
    [sym_parameter_pack_expansion] = STATE(4735),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3573),
    [sym_qualified_type_identifier] = STATE(7513),
    [sym_user_defined_literal] = STATE(3573),
    [sym_identifier] = ACTIONS(3726),
    [anon_sym_LPAREN2] = ACTIONS(2856),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(3728),
    [anon_sym_COLON_COLON] = ACTIONS(2866),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(3732),
    [anon_sym_not] = ACTIONS(2860),
    [anon_sym_compl] = ACTIONS(2860),
    [anon_sym_DASH_DASH] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(2880),
    [anon_sym_sizeof] = ACTIONS(2882),
    [anon_sym___alignof__] = ACTIONS(2884),
    [anon_sym___alignof] = ACTIONS(2884),
    [anon_sym__alignof] = ACTIONS(2884),
    [anon_sym_alignof] = ACTIONS(2884),
    [anon_sym__Alignof] = ACTIONS(2884),
    [anon_sym_offsetof] = ACTIONS(2886),
    [anon_sym__Generic] = ACTIONS(2888),
    [anon_sym_asm] = ACTIONS(2890),
    [anon_sym___asm__] = ACTIONS(2890),
    [anon_sym___asm] = ACTIONS(2890),
    [sym_number_literal] = ACTIONS(2892),
    [anon_sym_L_SQUOTE] = ACTIONS(2894),
    [anon_sym_u_SQUOTE] = ACTIONS(2894),
    [anon_sym_U_SQUOTE] = ACTIONS(2894),
    [anon_sym_u8_SQUOTE] = ACTIONS(2894),
    [anon_sym_SQUOTE] = ACTIONS(2894),
    [anon_sym_L_DQUOTE] = ACTIONS(2896),
    [anon_sym_u_DQUOTE] = ACTIONS(2896),
    [anon_sym_U_DQUOTE] = ACTIONS(2896),
    [anon_sym_u8_DQUOTE] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [anon_sym_NULL] = ACTIONS(2900),
    [anon_sym_nullptr] = ACTIONS(2900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2910),
    [anon_sym_R_DQUOTE] = ACTIONS(2912),
    [anon_sym_LR_DQUOTE] = ACTIONS(2912),
    [anon_sym_uR_DQUOTE] = ACTIONS(2912),
    [anon_sym_UR_DQUOTE] = ACTIONS(2912),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2912),
    [anon_sym_co_await] = ACTIONS(2914),
    [anon_sym_new] = ACTIONS(2916),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2898),
  },
  [1346] = {
    [sym_expression] = STATE(4644),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1347] = {
    [sym_expression] = STATE(4533),
    [sym__string] = STATE(4637),
    [sym_conditional_expression] = STATE(4735),
    [sym_assignment_expression] = STATE(4735),
    [sym_pointer_expression] = STATE(3573),
    [sym_unary_expression] = STATE(4735),
    [sym_binary_expression] = STATE(4735),
    [sym_update_expression] = STATE(4735),
    [sym_cast_expression] = STATE(4735),
    [sym_sizeof_expression] = STATE(4735),
    [sym_alignof_expression] = STATE(4735),
    [sym_offsetof_expression] = STATE(4735),
    [sym_generic_expression] = STATE(4735),
    [sym_subscript_expression] = STATE(3573),
    [sym_call_expression] = STATE(3573),
    [sym_gnu_asm_expression] = STATE(4735),
    [sym_extension_expression] = STATE(4735),
    [sym_field_expression] = STATE(3573),
    [sym_compound_literal_expression] = STATE(4735),
    [sym_parenthesized_expression] = STATE(3573),
    [sym_char_literal] = STATE(4637),
    [sym_concatenated_string] = STATE(4637),
    [sym_string_literal] = STATE(3662),
    [sym_null] = STATE(4735),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7513),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(4735),
    [sym_raw_string_literal] = STATE(3662),
    [sym_co_await_expression] = STATE(4735),
    [sym_new_expression] = STATE(4735),
    [sym_delete_expression] = STATE(4735),
    [sym_requires_clause] = STATE(4735),
    [sym_requires_expression] = STATE(4735),
    [sym_lambda_expression] = STATE(4735),
    [sym_lambda_capture_specifier] = STATE(5854),
    [sym_fold_expression] = STATE(4735),
    [sym_parameter_pack_expansion] = STATE(4735),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3573),
    [sym_qualified_type_identifier] = STATE(7513),
    [sym_user_defined_literal] = STATE(3573),
    [sym_identifier] = ACTIONS(3726),
    [anon_sym_LPAREN2] = ACTIONS(2856),
    [anon_sym_BANG] = ACTIONS(2858),
    [anon_sym_TILDE] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(3728),
    [anon_sym_COLON_COLON] = ACTIONS(2866),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(3732),
    [anon_sym_not] = ACTIONS(2860),
    [anon_sym_compl] = ACTIONS(2860),
    [anon_sym_DASH_DASH] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(2880),
    [anon_sym_sizeof] = ACTIONS(2882),
    [anon_sym___alignof__] = ACTIONS(2884),
    [anon_sym___alignof] = ACTIONS(2884),
    [anon_sym__alignof] = ACTIONS(2884),
    [anon_sym_alignof] = ACTIONS(2884),
    [anon_sym__Alignof] = ACTIONS(2884),
    [anon_sym_offsetof] = ACTIONS(2886),
    [anon_sym__Generic] = ACTIONS(2888),
    [anon_sym_asm] = ACTIONS(2890),
    [anon_sym___asm__] = ACTIONS(2890),
    [anon_sym___asm] = ACTIONS(2890),
    [sym_number_literal] = ACTIONS(2892),
    [anon_sym_L_SQUOTE] = ACTIONS(2894),
    [anon_sym_u_SQUOTE] = ACTIONS(2894),
    [anon_sym_U_SQUOTE] = ACTIONS(2894),
    [anon_sym_u8_SQUOTE] = ACTIONS(2894),
    [anon_sym_SQUOTE] = ACTIONS(2894),
    [anon_sym_L_DQUOTE] = ACTIONS(2896),
    [anon_sym_u_DQUOTE] = ACTIONS(2896),
    [anon_sym_U_DQUOTE] = ACTIONS(2896),
    [anon_sym_u8_DQUOTE] = ACTIONS(2896),
    [anon_sym_DQUOTE] = ACTIONS(2896),
    [sym_true] = ACTIONS(2898),
    [sym_false] = ACTIONS(2898),
    [anon_sym_NULL] = ACTIONS(2900),
    [anon_sym_nullptr] = ACTIONS(2900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2910),
    [anon_sym_R_DQUOTE] = ACTIONS(2912),
    [anon_sym_LR_DQUOTE] = ACTIONS(2912),
    [anon_sym_uR_DQUOTE] = ACTIONS(2912),
    [anon_sym_UR_DQUOTE] = ACTIONS(2912),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2912),
    [anon_sym_co_await] = ACTIONS(2914),
    [anon_sym_new] = ACTIONS(2916),
    [anon_sym_requires] = ACTIONS(2918),
    [sym_this] = ACTIONS(2898),
  },
  [1348] = {
    [sym_expression] = STATE(4213),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1349] = {
    [sym_expression] = STATE(2342),
    [sym__string] = STATE(2808),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2808),
    [sym_concatenated_string] = STATE(2808),
    [sym_string_literal] = STATE(1900),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1900),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4503),
    [anon_sym_BANG] = ACTIONS(1921),
    [anon_sym_TILDE] = ACTIONS(1921),
    [anon_sym_DASH] = ACTIONS(1919),
    [anon_sym_PLUS] = ACTIONS(1919),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_AMP] = ACTIONS(4505),
    [anon_sym___extension__] = ACTIONS(1923),
    [anon_sym_COLON_COLON] = ACTIONS(1925),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1919),
    [anon_sym_compl] = ACTIONS(1919),
    [anon_sym_DASH_DASH] = ACTIONS(4491),
    [anon_sym_PLUS_PLUS] = ACTIONS(4491),
    [anon_sym_sizeof] = ACTIONS(1931),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1953),
    [anon_sym_R_DQUOTE] = ACTIONS(1955),
    [anon_sym_LR_DQUOTE] = ACTIONS(1955),
    [anon_sym_uR_DQUOTE] = ACTIONS(1955),
    [anon_sym_UR_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1955),
    [anon_sym_co_await] = ACTIONS(1957),
    [anon_sym_new] = ACTIONS(1959),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1350] = {
    [sym_expression] = STATE(3098),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2029),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [1351] = {
    [sym_expression] = STATE(3028),
    [sym__string] = STATE(3071),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(3071),
    [sym_concatenated_string] = STATE(3071),
    [sym_string_literal] = STATE(2243),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(2243),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1989),
    [anon_sym_LPAREN2] = ACTIONS(4531),
    [anon_sym_BANG] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1993),
    [anon_sym_DASH] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1991),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym___extension__] = ACTIONS(1995),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_compl] = ACTIONS(1991),
    [anon_sym_DASH_DASH] = ACTIONS(4480),
    [anon_sym_PLUS_PLUS] = ACTIONS(4480),
    [anon_sym_sizeof] = ACTIONS(1999),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(2001),
    [anon_sym_L_SQUOTE] = ACTIONS(2003),
    [anon_sym_u_SQUOTE] = ACTIONS(2003),
    [anon_sym_U_SQUOTE] = ACTIONS(2003),
    [anon_sym_u8_SQUOTE] = ACTIONS(2003),
    [anon_sym_SQUOTE] = ACTIONS(2003),
    [anon_sym_L_DQUOTE] = ACTIONS(2005),
    [anon_sym_u_DQUOTE] = ACTIONS(2005),
    [anon_sym_U_DQUOTE] = ACTIONS(2005),
    [anon_sym_u8_DQUOTE] = ACTIONS(2005),
    [anon_sym_DQUOTE] = ACTIONS(2005),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2007),
    [anon_sym_R_DQUOTE] = ACTIONS(2009),
    [anon_sym_LR_DQUOTE] = ACTIONS(2009),
    [anon_sym_uR_DQUOTE] = ACTIONS(2009),
    [anon_sym_UR_DQUOTE] = ACTIONS(2009),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2009),
    [anon_sym_co_await] = ACTIONS(2011),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1352] = {
    [sym_expression] = STATE(3050),
    [sym__string] = STATE(3071),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(3071),
    [sym_concatenated_string] = STATE(3071),
    [sym_string_literal] = STATE(2243),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(2243),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1989),
    [anon_sym_LPAREN2] = ACTIONS(4531),
    [anon_sym_BANG] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1993),
    [anon_sym_DASH] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1991),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym___extension__] = ACTIONS(1995),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_compl] = ACTIONS(1991),
    [anon_sym_DASH_DASH] = ACTIONS(4480),
    [anon_sym_PLUS_PLUS] = ACTIONS(4480),
    [anon_sym_sizeof] = ACTIONS(1999),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(2001),
    [anon_sym_L_SQUOTE] = ACTIONS(2003),
    [anon_sym_u_SQUOTE] = ACTIONS(2003),
    [anon_sym_U_SQUOTE] = ACTIONS(2003),
    [anon_sym_u8_SQUOTE] = ACTIONS(2003),
    [anon_sym_SQUOTE] = ACTIONS(2003),
    [anon_sym_L_DQUOTE] = ACTIONS(2005),
    [anon_sym_u_DQUOTE] = ACTIONS(2005),
    [anon_sym_U_DQUOTE] = ACTIONS(2005),
    [anon_sym_u8_DQUOTE] = ACTIONS(2005),
    [anon_sym_DQUOTE] = ACTIONS(2005),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2007),
    [anon_sym_R_DQUOTE] = ACTIONS(2009),
    [anon_sym_LR_DQUOTE] = ACTIONS(2009),
    [anon_sym_uR_DQUOTE] = ACTIONS(2009),
    [anon_sym_UR_DQUOTE] = ACTIONS(2009),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2009),
    [anon_sym_co_await] = ACTIONS(2011),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1353] = {
    [sym_expression] = STATE(2325),
    [sym__string] = STATE(3071),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(3071),
    [sym_concatenated_string] = STATE(3071),
    [sym_string_literal] = STATE(2243),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(2243),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1989),
    [anon_sym_LPAREN2] = ACTIONS(4531),
    [anon_sym_BANG] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1993),
    [anon_sym_DASH] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1991),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym___extension__] = ACTIONS(1995),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_compl] = ACTIONS(1991),
    [anon_sym_DASH_DASH] = ACTIONS(4480),
    [anon_sym_PLUS_PLUS] = ACTIONS(4480),
    [anon_sym_sizeof] = ACTIONS(1999),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(2001),
    [anon_sym_L_SQUOTE] = ACTIONS(2003),
    [anon_sym_u_SQUOTE] = ACTIONS(2003),
    [anon_sym_U_SQUOTE] = ACTIONS(2003),
    [anon_sym_u8_SQUOTE] = ACTIONS(2003),
    [anon_sym_SQUOTE] = ACTIONS(2003),
    [anon_sym_L_DQUOTE] = ACTIONS(2005),
    [anon_sym_u_DQUOTE] = ACTIONS(2005),
    [anon_sym_U_DQUOTE] = ACTIONS(2005),
    [anon_sym_u8_DQUOTE] = ACTIONS(2005),
    [anon_sym_DQUOTE] = ACTIONS(2005),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2007),
    [anon_sym_R_DQUOTE] = ACTIONS(2009),
    [anon_sym_LR_DQUOTE] = ACTIONS(2009),
    [anon_sym_uR_DQUOTE] = ACTIONS(2009),
    [anon_sym_UR_DQUOTE] = ACTIONS(2009),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2009),
    [anon_sym_co_await] = ACTIONS(2011),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1354] = {
    [sym_expression] = STATE(2990),
    [sym__string] = STATE(3071),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(3071),
    [sym_concatenated_string] = STATE(3071),
    [sym_string_literal] = STATE(2243),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(2243),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1989),
    [anon_sym_LPAREN2] = ACTIONS(4531),
    [anon_sym_BANG] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1993),
    [anon_sym_DASH] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1991),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym___extension__] = ACTIONS(1995),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_compl] = ACTIONS(1991),
    [anon_sym_DASH_DASH] = ACTIONS(4480),
    [anon_sym_PLUS_PLUS] = ACTIONS(4480),
    [anon_sym_sizeof] = ACTIONS(1999),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(2001),
    [anon_sym_L_SQUOTE] = ACTIONS(2003),
    [anon_sym_u_SQUOTE] = ACTIONS(2003),
    [anon_sym_U_SQUOTE] = ACTIONS(2003),
    [anon_sym_u8_SQUOTE] = ACTIONS(2003),
    [anon_sym_SQUOTE] = ACTIONS(2003),
    [anon_sym_L_DQUOTE] = ACTIONS(2005),
    [anon_sym_u_DQUOTE] = ACTIONS(2005),
    [anon_sym_U_DQUOTE] = ACTIONS(2005),
    [anon_sym_u8_DQUOTE] = ACTIONS(2005),
    [anon_sym_DQUOTE] = ACTIONS(2005),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2007),
    [anon_sym_R_DQUOTE] = ACTIONS(2009),
    [anon_sym_LR_DQUOTE] = ACTIONS(2009),
    [anon_sym_uR_DQUOTE] = ACTIONS(2009),
    [anon_sym_UR_DQUOTE] = ACTIONS(2009),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2009),
    [anon_sym_co_await] = ACTIONS(2011),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1355] = {
    [sym_expression] = STATE(2991),
    [sym__string] = STATE(3071),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(3071),
    [sym_concatenated_string] = STATE(3071),
    [sym_string_literal] = STATE(2243),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(2243),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1989),
    [anon_sym_LPAREN2] = ACTIONS(4531),
    [anon_sym_BANG] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1993),
    [anon_sym_DASH] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1991),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym___extension__] = ACTIONS(1995),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_compl] = ACTIONS(1991),
    [anon_sym_DASH_DASH] = ACTIONS(4480),
    [anon_sym_PLUS_PLUS] = ACTIONS(4480),
    [anon_sym_sizeof] = ACTIONS(1999),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(2001),
    [anon_sym_L_SQUOTE] = ACTIONS(2003),
    [anon_sym_u_SQUOTE] = ACTIONS(2003),
    [anon_sym_U_SQUOTE] = ACTIONS(2003),
    [anon_sym_u8_SQUOTE] = ACTIONS(2003),
    [anon_sym_SQUOTE] = ACTIONS(2003),
    [anon_sym_L_DQUOTE] = ACTIONS(2005),
    [anon_sym_u_DQUOTE] = ACTIONS(2005),
    [anon_sym_U_DQUOTE] = ACTIONS(2005),
    [anon_sym_u8_DQUOTE] = ACTIONS(2005),
    [anon_sym_DQUOTE] = ACTIONS(2005),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2007),
    [anon_sym_R_DQUOTE] = ACTIONS(2009),
    [anon_sym_LR_DQUOTE] = ACTIONS(2009),
    [anon_sym_uR_DQUOTE] = ACTIONS(2009),
    [anon_sym_UR_DQUOTE] = ACTIONS(2009),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2009),
    [anon_sym_co_await] = ACTIONS(2011),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1356] = {
    [sym_expression] = STATE(2992),
    [sym__string] = STATE(3071),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(3071),
    [sym_concatenated_string] = STATE(3071),
    [sym_string_literal] = STATE(2243),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(2243),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1989),
    [anon_sym_LPAREN2] = ACTIONS(4531),
    [anon_sym_BANG] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1993),
    [anon_sym_DASH] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1991),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym___extension__] = ACTIONS(1995),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_compl] = ACTIONS(1991),
    [anon_sym_DASH_DASH] = ACTIONS(4480),
    [anon_sym_PLUS_PLUS] = ACTIONS(4480),
    [anon_sym_sizeof] = ACTIONS(1999),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(2001),
    [anon_sym_L_SQUOTE] = ACTIONS(2003),
    [anon_sym_u_SQUOTE] = ACTIONS(2003),
    [anon_sym_U_SQUOTE] = ACTIONS(2003),
    [anon_sym_u8_SQUOTE] = ACTIONS(2003),
    [anon_sym_SQUOTE] = ACTIONS(2003),
    [anon_sym_L_DQUOTE] = ACTIONS(2005),
    [anon_sym_u_DQUOTE] = ACTIONS(2005),
    [anon_sym_U_DQUOTE] = ACTIONS(2005),
    [anon_sym_u8_DQUOTE] = ACTIONS(2005),
    [anon_sym_DQUOTE] = ACTIONS(2005),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2007),
    [anon_sym_R_DQUOTE] = ACTIONS(2009),
    [anon_sym_LR_DQUOTE] = ACTIONS(2009),
    [anon_sym_uR_DQUOTE] = ACTIONS(2009),
    [anon_sym_UR_DQUOTE] = ACTIONS(2009),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2009),
    [anon_sym_co_await] = ACTIONS(2011),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1357] = {
    [sym_expression] = STATE(2993),
    [sym__string] = STATE(3071),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(3071),
    [sym_concatenated_string] = STATE(3071),
    [sym_string_literal] = STATE(2243),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(2243),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1989),
    [anon_sym_LPAREN2] = ACTIONS(4531),
    [anon_sym_BANG] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1993),
    [anon_sym_DASH] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1991),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym___extension__] = ACTIONS(1995),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_compl] = ACTIONS(1991),
    [anon_sym_DASH_DASH] = ACTIONS(4480),
    [anon_sym_PLUS_PLUS] = ACTIONS(4480),
    [anon_sym_sizeof] = ACTIONS(1999),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(2001),
    [anon_sym_L_SQUOTE] = ACTIONS(2003),
    [anon_sym_u_SQUOTE] = ACTIONS(2003),
    [anon_sym_U_SQUOTE] = ACTIONS(2003),
    [anon_sym_u8_SQUOTE] = ACTIONS(2003),
    [anon_sym_SQUOTE] = ACTIONS(2003),
    [anon_sym_L_DQUOTE] = ACTIONS(2005),
    [anon_sym_u_DQUOTE] = ACTIONS(2005),
    [anon_sym_U_DQUOTE] = ACTIONS(2005),
    [anon_sym_u8_DQUOTE] = ACTIONS(2005),
    [anon_sym_DQUOTE] = ACTIONS(2005),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2007),
    [anon_sym_R_DQUOTE] = ACTIONS(2009),
    [anon_sym_LR_DQUOTE] = ACTIONS(2009),
    [anon_sym_uR_DQUOTE] = ACTIONS(2009),
    [anon_sym_UR_DQUOTE] = ACTIONS(2009),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2009),
    [anon_sym_co_await] = ACTIONS(2011),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1358] = {
    [sym_expression] = STATE(2994),
    [sym__string] = STATE(3071),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(3071),
    [sym_concatenated_string] = STATE(3071),
    [sym_string_literal] = STATE(2243),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(2243),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1989),
    [anon_sym_LPAREN2] = ACTIONS(4531),
    [anon_sym_BANG] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1993),
    [anon_sym_DASH] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1991),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym___extension__] = ACTIONS(1995),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_compl] = ACTIONS(1991),
    [anon_sym_DASH_DASH] = ACTIONS(4480),
    [anon_sym_PLUS_PLUS] = ACTIONS(4480),
    [anon_sym_sizeof] = ACTIONS(1999),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(2001),
    [anon_sym_L_SQUOTE] = ACTIONS(2003),
    [anon_sym_u_SQUOTE] = ACTIONS(2003),
    [anon_sym_U_SQUOTE] = ACTIONS(2003),
    [anon_sym_u8_SQUOTE] = ACTIONS(2003),
    [anon_sym_SQUOTE] = ACTIONS(2003),
    [anon_sym_L_DQUOTE] = ACTIONS(2005),
    [anon_sym_u_DQUOTE] = ACTIONS(2005),
    [anon_sym_U_DQUOTE] = ACTIONS(2005),
    [anon_sym_u8_DQUOTE] = ACTIONS(2005),
    [anon_sym_DQUOTE] = ACTIONS(2005),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2007),
    [anon_sym_R_DQUOTE] = ACTIONS(2009),
    [anon_sym_LR_DQUOTE] = ACTIONS(2009),
    [anon_sym_uR_DQUOTE] = ACTIONS(2009),
    [anon_sym_UR_DQUOTE] = ACTIONS(2009),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2009),
    [anon_sym_co_await] = ACTIONS(2011),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1359] = {
    [sym_expression] = STATE(2995),
    [sym__string] = STATE(3071),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(3071),
    [sym_concatenated_string] = STATE(3071),
    [sym_string_literal] = STATE(2243),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(2243),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1989),
    [anon_sym_LPAREN2] = ACTIONS(4531),
    [anon_sym_BANG] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1993),
    [anon_sym_DASH] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1991),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym___extension__] = ACTIONS(1995),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_compl] = ACTIONS(1991),
    [anon_sym_DASH_DASH] = ACTIONS(4480),
    [anon_sym_PLUS_PLUS] = ACTIONS(4480),
    [anon_sym_sizeof] = ACTIONS(1999),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(2001),
    [anon_sym_L_SQUOTE] = ACTIONS(2003),
    [anon_sym_u_SQUOTE] = ACTIONS(2003),
    [anon_sym_U_SQUOTE] = ACTIONS(2003),
    [anon_sym_u8_SQUOTE] = ACTIONS(2003),
    [anon_sym_SQUOTE] = ACTIONS(2003),
    [anon_sym_L_DQUOTE] = ACTIONS(2005),
    [anon_sym_u_DQUOTE] = ACTIONS(2005),
    [anon_sym_U_DQUOTE] = ACTIONS(2005),
    [anon_sym_u8_DQUOTE] = ACTIONS(2005),
    [anon_sym_DQUOTE] = ACTIONS(2005),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2007),
    [anon_sym_R_DQUOTE] = ACTIONS(2009),
    [anon_sym_LR_DQUOTE] = ACTIONS(2009),
    [anon_sym_uR_DQUOTE] = ACTIONS(2009),
    [anon_sym_UR_DQUOTE] = ACTIONS(2009),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2009),
    [anon_sym_co_await] = ACTIONS(2011),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1360] = {
    [sym_expression] = STATE(2996),
    [sym__string] = STATE(3071),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(3071),
    [sym_concatenated_string] = STATE(3071),
    [sym_string_literal] = STATE(2243),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(2243),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1989),
    [anon_sym_LPAREN2] = ACTIONS(4531),
    [anon_sym_BANG] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1993),
    [anon_sym_DASH] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1991),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym___extension__] = ACTIONS(1995),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_compl] = ACTIONS(1991),
    [anon_sym_DASH_DASH] = ACTIONS(4480),
    [anon_sym_PLUS_PLUS] = ACTIONS(4480),
    [anon_sym_sizeof] = ACTIONS(1999),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(2001),
    [anon_sym_L_SQUOTE] = ACTIONS(2003),
    [anon_sym_u_SQUOTE] = ACTIONS(2003),
    [anon_sym_U_SQUOTE] = ACTIONS(2003),
    [anon_sym_u8_SQUOTE] = ACTIONS(2003),
    [anon_sym_SQUOTE] = ACTIONS(2003),
    [anon_sym_L_DQUOTE] = ACTIONS(2005),
    [anon_sym_u_DQUOTE] = ACTIONS(2005),
    [anon_sym_U_DQUOTE] = ACTIONS(2005),
    [anon_sym_u8_DQUOTE] = ACTIONS(2005),
    [anon_sym_DQUOTE] = ACTIONS(2005),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2007),
    [anon_sym_R_DQUOTE] = ACTIONS(2009),
    [anon_sym_LR_DQUOTE] = ACTIONS(2009),
    [anon_sym_uR_DQUOTE] = ACTIONS(2009),
    [anon_sym_UR_DQUOTE] = ACTIONS(2009),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2009),
    [anon_sym_co_await] = ACTIONS(2011),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1361] = {
    [sym_expression] = STATE(3002),
    [sym__string] = STATE(3071),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(3071),
    [sym_concatenated_string] = STATE(3071),
    [sym_string_literal] = STATE(2243),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(2243),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1989),
    [anon_sym_LPAREN2] = ACTIONS(4531),
    [anon_sym_BANG] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1993),
    [anon_sym_DASH] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1991),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym___extension__] = ACTIONS(1995),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_compl] = ACTIONS(1991),
    [anon_sym_DASH_DASH] = ACTIONS(4480),
    [anon_sym_PLUS_PLUS] = ACTIONS(4480),
    [anon_sym_sizeof] = ACTIONS(1999),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(2001),
    [anon_sym_L_SQUOTE] = ACTIONS(2003),
    [anon_sym_u_SQUOTE] = ACTIONS(2003),
    [anon_sym_U_SQUOTE] = ACTIONS(2003),
    [anon_sym_u8_SQUOTE] = ACTIONS(2003),
    [anon_sym_SQUOTE] = ACTIONS(2003),
    [anon_sym_L_DQUOTE] = ACTIONS(2005),
    [anon_sym_u_DQUOTE] = ACTIONS(2005),
    [anon_sym_U_DQUOTE] = ACTIONS(2005),
    [anon_sym_u8_DQUOTE] = ACTIONS(2005),
    [anon_sym_DQUOTE] = ACTIONS(2005),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2007),
    [anon_sym_R_DQUOTE] = ACTIONS(2009),
    [anon_sym_LR_DQUOTE] = ACTIONS(2009),
    [anon_sym_uR_DQUOTE] = ACTIONS(2009),
    [anon_sym_UR_DQUOTE] = ACTIONS(2009),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2009),
    [anon_sym_co_await] = ACTIONS(2011),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1362] = {
    [sym_expression] = STATE(3578),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [1363] = {
    [sym_expression] = STATE(3599),
    [sym__string] = STATE(3664),
    [sym_conditional_expression] = STATE(3827),
    [sym_assignment_expression] = STATE(3827),
    [sym_pointer_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3827),
    [sym_binary_expression] = STATE(3827),
    [sym_update_expression] = STATE(3827),
    [sym_cast_expression] = STATE(3827),
    [sym_sizeof_expression] = STATE(3827),
    [sym_alignof_expression] = STATE(3827),
    [sym_offsetof_expression] = STATE(3827),
    [sym_generic_expression] = STATE(3827),
    [sym_subscript_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_gnu_asm_expression] = STATE(3827),
    [sym_extension_expression] = STATE(3827),
    [sym_field_expression] = STATE(3428),
    [sym_compound_literal_expression] = STATE(3827),
    [sym_parenthesized_expression] = STATE(3428),
    [sym_char_literal] = STATE(3664),
    [sym_concatenated_string] = STATE(3664),
    [sym_string_literal] = STATE(2494),
    [sym_null] = STATE(3827),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7485),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3827),
    [sym_raw_string_literal] = STATE(2494),
    [sym_co_await_expression] = STATE(3827),
    [sym_new_expression] = STATE(3827),
    [sym_delete_expression] = STATE(3827),
    [sym_requires_clause] = STATE(3827),
    [sym_requires_expression] = STATE(3827),
    [sym_lambda_expression] = STATE(3827),
    [sym_lambda_capture_specifier] = STATE(5872),
    [sym_fold_expression] = STATE(3827),
    [sym_parameter_pack_expansion] = STATE(3827),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3428),
    [sym_qualified_type_identifier] = STATE(7485),
    [sym_user_defined_literal] = STATE(3428),
    [sym_identifier] = ACTIONS(2577),
    [anon_sym_LPAREN2] = ACTIONS(1841),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_TILDE] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2579),
    [anon_sym_COLON_COLON] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2583),
    [anon_sym_not] = ACTIONS(1845),
    [anon_sym_compl] = ACTIONS(1845),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_sizeof] = ACTIONS(1867),
    [anon_sym___alignof__] = ACTIONS(1869),
    [anon_sym___alignof] = ACTIONS(1869),
    [anon_sym__alignof] = ACTIONS(1869),
    [anon_sym_alignof] = ACTIONS(1869),
    [anon_sym__Alignof] = ACTIONS(1869),
    [anon_sym_offsetof] = ACTIONS(1871),
    [anon_sym__Generic] = ACTIONS(1873),
    [anon_sym_asm] = ACTIONS(1875),
    [anon_sym___asm__] = ACTIONS(1875),
    [anon_sym___asm] = ACTIONS(1875),
    [sym_number_literal] = ACTIONS(1877),
    [anon_sym_L_SQUOTE] = ACTIONS(1879),
    [anon_sym_u_SQUOTE] = ACTIONS(1879),
    [anon_sym_U_SQUOTE] = ACTIONS(1879),
    [anon_sym_u8_SQUOTE] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_L_DQUOTE] = ACTIONS(1881),
    [anon_sym_u_DQUOTE] = ACTIONS(1881),
    [anon_sym_U_DQUOTE] = ACTIONS(1881),
    [anon_sym_u8_DQUOTE] = ACTIONS(1881),
    [anon_sym_DQUOTE] = ACTIONS(1881),
    [sym_true] = ACTIONS(1883),
    [sym_false] = ACTIONS(1883),
    [anon_sym_NULL] = ACTIONS(1885),
    [anon_sym_nullptr] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1889),
    [anon_sym_R_DQUOTE] = ACTIONS(1891),
    [anon_sym_LR_DQUOTE] = ACTIONS(1891),
    [anon_sym_uR_DQUOTE] = ACTIONS(1891),
    [anon_sym_UR_DQUOTE] = ACTIONS(1891),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1891),
    [anon_sym_co_await] = ACTIONS(1893),
    [anon_sym_new] = ACTIONS(1895),
    [anon_sym_requires] = ACTIONS(1897),
    [sym_this] = ACTIONS(1883),
  },
  [1364] = {
    [sym_expression] = STATE(4549),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1365] = {
    [sym_expression] = STATE(2342),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4424),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1965),
    [anon_sym_compl] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_sizeof] = ACTIONS(1973),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1366] = {
    [sym_expression] = STATE(2768),
    [sym__string] = STATE(2808),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2808),
    [sym_concatenated_string] = STATE(2808),
    [sym_string_literal] = STATE(1900),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1900),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4503),
    [anon_sym_BANG] = ACTIONS(1921),
    [anon_sym_TILDE] = ACTIONS(1921),
    [anon_sym_DASH] = ACTIONS(1919),
    [anon_sym_PLUS] = ACTIONS(1919),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_AMP] = ACTIONS(4505),
    [anon_sym___extension__] = ACTIONS(1923),
    [anon_sym_COLON_COLON] = ACTIONS(1925),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1919),
    [anon_sym_compl] = ACTIONS(1919),
    [anon_sym_DASH_DASH] = ACTIONS(4491),
    [anon_sym_PLUS_PLUS] = ACTIONS(4491),
    [anon_sym_sizeof] = ACTIONS(1931),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1953),
    [anon_sym_R_DQUOTE] = ACTIONS(1955),
    [anon_sym_LR_DQUOTE] = ACTIONS(1955),
    [anon_sym_uR_DQUOTE] = ACTIONS(1955),
    [anon_sym_UR_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1955),
    [anon_sym_co_await] = ACTIONS(1957),
    [anon_sym_new] = ACTIONS(1959),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1367] = {
    [sym_expression] = STATE(2796),
    [sym__string] = STATE(2808),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2808),
    [sym_concatenated_string] = STATE(2808),
    [sym_string_literal] = STATE(1900),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1900),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4503),
    [anon_sym_BANG] = ACTIONS(1921),
    [anon_sym_TILDE] = ACTIONS(1921),
    [anon_sym_DASH] = ACTIONS(1919),
    [anon_sym_PLUS] = ACTIONS(1919),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_AMP] = ACTIONS(4505),
    [anon_sym___extension__] = ACTIONS(1923),
    [anon_sym_COLON_COLON] = ACTIONS(1925),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1919),
    [anon_sym_compl] = ACTIONS(1919),
    [anon_sym_DASH_DASH] = ACTIONS(4491),
    [anon_sym_PLUS_PLUS] = ACTIONS(4491),
    [anon_sym_sizeof] = ACTIONS(1931),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1953),
    [anon_sym_R_DQUOTE] = ACTIONS(1955),
    [anon_sym_LR_DQUOTE] = ACTIONS(1955),
    [anon_sym_uR_DQUOTE] = ACTIONS(1955),
    [anon_sym_UR_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1955),
    [anon_sym_co_await] = ACTIONS(1957),
    [anon_sym_new] = ACTIONS(1959),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1368] = {
    [sym_expression] = STATE(2325),
    [sym__string] = STATE(2808),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2808),
    [sym_concatenated_string] = STATE(2808),
    [sym_string_literal] = STATE(1900),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1900),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4503),
    [anon_sym_BANG] = ACTIONS(1921),
    [anon_sym_TILDE] = ACTIONS(1921),
    [anon_sym_DASH] = ACTIONS(1919),
    [anon_sym_PLUS] = ACTIONS(1919),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_AMP] = ACTIONS(4505),
    [anon_sym___extension__] = ACTIONS(1923),
    [anon_sym_COLON_COLON] = ACTIONS(1925),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1919),
    [anon_sym_compl] = ACTIONS(1919),
    [anon_sym_DASH_DASH] = ACTIONS(4491),
    [anon_sym_PLUS_PLUS] = ACTIONS(4491),
    [anon_sym_sizeof] = ACTIONS(1931),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1953),
    [anon_sym_R_DQUOTE] = ACTIONS(1955),
    [anon_sym_LR_DQUOTE] = ACTIONS(1955),
    [anon_sym_uR_DQUOTE] = ACTIONS(1955),
    [anon_sym_UR_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1955),
    [anon_sym_co_await] = ACTIONS(1957),
    [anon_sym_new] = ACTIONS(1959),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1369] = {
    [sym_expression] = STATE(2751),
    [sym__string] = STATE(2808),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2808),
    [sym_concatenated_string] = STATE(2808),
    [sym_string_literal] = STATE(1900),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1900),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4503),
    [anon_sym_BANG] = ACTIONS(1921),
    [anon_sym_TILDE] = ACTIONS(1921),
    [anon_sym_DASH] = ACTIONS(1919),
    [anon_sym_PLUS] = ACTIONS(1919),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_AMP] = ACTIONS(4505),
    [anon_sym___extension__] = ACTIONS(1923),
    [anon_sym_COLON_COLON] = ACTIONS(1925),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1919),
    [anon_sym_compl] = ACTIONS(1919),
    [anon_sym_DASH_DASH] = ACTIONS(4491),
    [anon_sym_PLUS_PLUS] = ACTIONS(4491),
    [anon_sym_sizeof] = ACTIONS(1931),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1953),
    [anon_sym_R_DQUOTE] = ACTIONS(1955),
    [anon_sym_LR_DQUOTE] = ACTIONS(1955),
    [anon_sym_uR_DQUOTE] = ACTIONS(1955),
    [anon_sym_UR_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1955),
    [anon_sym_co_await] = ACTIONS(1957),
    [anon_sym_new] = ACTIONS(1959),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1370] = {
    [sym_expression] = STATE(2752),
    [sym__string] = STATE(2808),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2808),
    [sym_concatenated_string] = STATE(2808),
    [sym_string_literal] = STATE(1900),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1900),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4503),
    [anon_sym_BANG] = ACTIONS(1921),
    [anon_sym_TILDE] = ACTIONS(1921),
    [anon_sym_DASH] = ACTIONS(1919),
    [anon_sym_PLUS] = ACTIONS(1919),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_AMP] = ACTIONS(4505),
    [anon_sym___extension__] = ACTIONS(1923),
    [anon_sym_COLON_COLON] = ACTIONS(1925),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1919),
    [anon_sym_compl] = ACTIONS(1919),
    [anon_sym_DASH_DASH] = ACTIONS(4491),
    [anon_sym_PLUS_PLUS] = ACTIONS(4491),
    [anon_sym_sizeof] = ACTIONS(1931),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1953),
    [anon_sym_R_DQUOTE] = ACTIONS(1955),
    [anon_sym_LR_DQUOTE] = ACTIONS(1955),
    [anon_sym_uR_DQUOTE] = ACTIONS(1955),
    [anon_sym_UR_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1955),
    [anon_sym_co_await] = ACTIONS(1957),
    [anon_sym_new] = ACTIONS(1959),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1371] = {
    [sym_expression] = STATE(2753),
    [sym__string] = STATE(2808),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2808),
    [sym_concatenated_string] = STATE(2808),
    [sym_string_literal] = STATE(1900),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1900),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4503),
    [anon_sym_BANG] = ACTIONS(1921),
    [anon_sym_TILDE] = ACTIONS(1921),
    [anon_sym_DASH] = ACTIONS(1919),
    [anon_sym_PLUS] = ACTIONS(1919),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_AMP] = ACTIONS(4505),
    [anon_sym___extension__] = ACTIONS(1923),
    [anon_sym_COLON_COLON] = ACTIONS(1925),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1919),
    [anon_sym_compl] = ACTIONS(1919),
    [anon_sym_DASH_DASH] = ACTIONS(4491),
    [anon_sym_PLUS_PLUS] = ACTIONS(4491),
    [anon_sym_sizeof] = ACTIONS(1931),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1953),
    [anon_sym_R_DQUOTE] = ACTIONS(1955),
    [anon_sym_LR_DQUOTE] = ACTIONS(1955),
    [anon_sym_uR_DQUOTE] = ACTIONS(1955),
    [anon_sym_UR_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1955),
    [anon_sym_co_await] = ACTIONS(1957),
    [anon_sym_new] = ACTIONS(1959),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1372] = {
    [sym_expression] = STATE(2754),
    [sym__string] = STATE(2808),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2808),
    [sym_concatenated_string] = STATE(2808),
    [sym_string_literal] = STATE(1900),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1900),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4503),
    [anon_sym_BANG] = ACTIONS(1921),
    [anon_sym_TILDE] = ACTIONS(1921),
    [anon_sym_DASH] = ACTIONS(1919),
    [anon_sym_PLUS] = ACTIONS(1919),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_AMP] = ACTIONS(4505),
    [anon_sym___extension__] = ACTIONS(1923),
    [anon_sym_COLON_COLON] = ACTIONS(1925),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1919),
    [anon_sym_compl] = ACTIONS(1919),
    [anon_sym_DASH_DASH] = ACTIONS(4491),
    [anon_sym_PLUS_PLUS] = ACTIONS(4491),
    [anon_sym_sizeof] = ACTIONS(1931),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1953),
    [anon_sym_R_DQUOTE] = ACTIONS(1955),
    [anon_sym_LR_DQUOTE] = ACTIONS(1955),
    [anon_sym_uR_DQUOTE] = ACTIONS(1955),
    [anon_sym_UR_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1955),
    [anon_sym_co_await] = ACTIONS(1957),
    [anon_sym_new] = ACTIONS(1959),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1373] = {
    [sym_expression] = STATE(2755),
    [sym__string] = STATE(2808),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2808),
    [sym_concatenated_string] = STATE(2808),
    [sym_string_literal] = STATE(1900),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1900),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4503),
    [anon_sym_BANG] = ACTIONS(1921),
    [anon_sym_TILDE] = ACTIONS(1921),
    [anon_sym_DASH] = ACTIONS(1919),
    [anon_sym_PLUS] = ACTIONS(1919),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_AMP] = ACTIONS(4505),
    [anon_sym___extension__] = ACTIONS(1923),
    [anon_sym_COLON_COLON] = ACTIONS(1925),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1919),
    [anon_sym_compl] = ACTIONS(1919),
    [anon_sym_DASH_DASH] = ACTIONS(4491),
    [anon_sym_PLUS_PLUS] = ACTIONS(4491),
    [anon_sym_sizeof] = ACTIONS(1931),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1953),
    [anon_sym_R_DQUOTE] = ACTIONS(1955),
    [anon_sym_LR_DQUOTE] = ACTIONS(1955),
    [anon_sym_uR_DQUOTE] = ACTIONS(1955),
    [anon_sym_UR_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1955),
    [anon_sym_co_await] = ACTIONS(1957),
    [anon_sym_new] = ACTIONS(1959),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1374] = {
    [sym_expression] = STATE(2756),
    [sym__string] = STATE(2808),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2808),
    [sym_concatenated_string] = STATE(2808),
    [sym_string_literal] = STATE(1900),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1900),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4503),
    [anon_sym_BANG] = ACTIONS(1921),
    [anon_sym_TILDE] = ACTIONS(1921),
    [anon_sym_DASH] = ACTIONS(1919),
    [anon_sym_PLUS] = ACTIONS(1919),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_AMP] = ACTIONS(4505),
    [anon_sym___extension__] = ACTIONS(1923),
    [anon_sym_COLON_COLON] = ACTIONS(1925),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1919),
    [anon_sym_compl] = ACTIONS(1919),
    [anon_sym_DASH_DASH] = ACTIONS(4491),
    [anon_sym_PLUS_PLUS] = ACTIONS(4491),
    [anon_sym_sizeof] = ACTIONS(1931),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1953),
    [anon_sym_R_DQUOTE] = ACTIONS(1955),
    [anon_sym_LR_DQUOTE] = ACTIONS(1955),
    [anon_sym_uR_DQUOTE] = ACTIONS(1955),
    [anon_sym_UR_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1955),
    [anon_sym_co_await] = ACTIONS(1957),
    [anon_sym_new] = ACTIONS(1959),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1375] = {
    [sym_expression] = STATE(2757),
    [sym__string] = STATE(2808),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2808),
    [sym_concatenated_string] = STATE(2808),
    [sym_string_literal] = STATE(1900),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1900),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4503),
    [anon_sym_BANG] = ACTIONS(1921),
    [anon_sym_TILDE] = ACTIONS(1921),
    [anon_sym_DASH] = ACTIONS(1919),
    [anon_sym_PLUS] = ACTIONS(1919),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_AMP] = ACTIONS(4505),
    [anon_sym___extension__] = ACTIONS(1923),
    [anon_sym_COLON_COLON] = ACTIONS(1925),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1919),
    [anon_sym_compl] = ACTIONS(1919),
    [anon_sym_DASH_DASH] = ACTIONS(4491),
    [anon_sym_PLUS_PLUS] = ACTIONS(4491),
    [anon_sym_sizeof] = ACTIONS(1931),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1953),
    [anon_sym_R_DQUOTE] = ACTIONS(1955),
    [anon_sym_LR_DQUOTE] = ACTIONS(1955),
    [anon_sym_uR_DQUOTE] = ACTIONS(1955),
    [anon_sym_UR_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1955),
    [anon_sym_co_await] = ACTIONS(1957),
    [anon_sym_new] = ACTIONS(1959),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1376] = {
    [sym_expression] = STATE(2797),
    [sym__string] = STATE(2808),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2808),
    [sym_concatenated_string] = STATE(2808),
    [sym_string_literal] = STATE(1900),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1900),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4503),
    [anon_sym_BANG] = ACTIONS(1921),
    [anon_sym_TILDE] = ACTIONS(1921),
    [anon_sym_DASH] = ACTIONS(1919),
    [anon_sym_PLUS] = ACTIONS(1919),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_AMP] = ACTIONS(4505),
    [anon_sym___extension__] = ACTIONS(1923),
    [anon_sym_COLON_COLON] = ACTIONS(1925),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1919),
    [anon_sym_compl] = ACTIONS(1919),
    [anon_sym_DASH_DASH] = ACTIONS(4491),
    [anon_sym_PLUS_PLUS] = ACTIONS(4491),
    [anon_sym_sizeof] = ACTIONS(1931),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1953),
    [anon_sym_R_DQUOTE] = ACTIONS(1955),
    [anon_sym_LR_DQUOTE] = ACTIONS(1955),
    [anon_sym_uR_DQUOTE] = ACTIONS(1955),
    [anon_sym_UR_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1955),
    [anon_sym_co_await] = ACTIONS(1957),
    [anon_sym_new] = ACTIONS(1959),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1377] = {
    [sym_expression] = STATE(3258),
    [sym__string] = STATE(3374),
    [sym_conditional_expression] = STATE(3536),
    [sym_assignment_expression] = STATE(3536),
    [sym_pointer_expression] = STATE(3544),
    [sym_unary_expression] = STATE(3536),
    [sym_binary_expression] = STATE(3536),
    [sym_update_expression] = STATE(3536),
    [sym_cast_expression] = STATE(3536),
    [sym_sizeof_expression] = STATE(3536),
    [sym_alignof_expression] = STATE(3536),
    [sym_offsetof_expression] = STATE(3536),
    [sym_generic_expression] = STATE(3536),
    [sym_subscript_expression] = STATE(3544),
    [sym_call_expression] = STATE(3544),
    [sym_gnu_asm_expression] = STATE(3536),
    [sym_extension_expression] = STATE(3536),
    [sym_field_expression] = STATE(3544),
    [sym_compound_literal_expression] = STATE(3536),
    [sym_parenthesized_expression] = STATE(3544),
    [sym_char_literal] = STATE(3374),
    [sym_concatenated_string] = STATE(3374),
    [sym_string_literal] = STATE(2363),
    [sym_null] = STATE(3536),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7597),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3536),
    [sym_raw_string_literal] = STATE(2363),
    [sym_co_await_expression] = STATE(3536),
    [sym_new_expression] = STATE(3536),
    [sym_delete_expression] = STATE(3536),
    [sym_requires_clause] = STATE(3536),
    [sym_requires_expression] = STATE(3536),
    [sym_lambda_expression] = STATE(3536),
    [sym_lambda_capture_specifier] = STATE(5874),
    [sym_fold_expression] = STATE(3536),
    [sym_parameter_pack_expansion] = STATE(3536),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3544),
    [sym_qualified_type_identifier] = STATE(7597),
    [sym_user_defined_literal] = STATE(3544),
    [sym_identifier] = ACTIONS(2446),
    [anon_sym_LPAREN2] = ACTIONS(4521),
    [anon_sym_BANG] = ACTIONS(2450),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2448),
    [anon_sym_PLUS] = ACTIONS(2448),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(2452),
    [anon_sym_COLON_COLON] = ACTIONS(2454),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2458),
    [anon_sym_not] = ACTIONS(2448),
    [anon_sym_compl] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(4478),
    [anon_sym_PLUS_PLUS] = ACTIONS(4478),
    [anon_sym_sizeof] = ACTIONS(2460),
    [anon_sym___alignof__] = ACTIONS(2462),
    [anon_sym___alignof] = ACTIONS(2462),
    [anon_sym__alignof] = ACTIONS(2462),
    [anon_sym_alignof] = ACTIONS(2462),
    [anon_sym__Alignof] = ACTIONS(2462),
    [anon_sym_offsetof] = ACTIONS(2464),
    [anon_sym__Generic] = ACTIONS(2466),
    [anon_sym_asm] = ACTIONS(2468),
    [anon_sym___asm__] = ACTIONS(2468),
    [anon_sym___asm] = ACTIONS(2468),
    [sym_number_literal] = ACTIONS(2470),
    [anon_sym_L_SQUOTE] = ACTIONS(2472),
    [anon_sym_u_SQUOTE] = ACTIONS(2472),
    [anon_sym_U_SQUOTE] = ACTIONS(2472),
    [anon_sym_u8_SQUOTE] = ACTIONS(2472),
    [anon_sym_SQUOTE] = ACTIONS(2472),
    [anon_sym_L_DQUOTE] = ACTIONS(2474),
    [anon_sym_u_DQUOTE] = ACTIONS(2474),
    [anon_sym_U_DQUOTE] = ACTIONS(2474),
    [anon_sym_u8_DQUOTE] = ACTIONS(2474),
    [anon_sym_DQUOTE] = ACTIONS(2474),
    [sym_true] = ACTIONS(2476),
    [sym_false] = ACTIONS(2476),
    [anon_sym_NULL] = ACTIONS(2478),
    [anon_sym_nullptr] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2480),
    [anon_sym_R_DQUOTE] = ACTIONS(2482),
    [anon_sym_LR_DQUOTE] = ACTIONS(2482),
    [anon_sym_uR_DQUOTE] = ACTIONS(2482),
    [anon_sym_UR_DQUOTE] = ACTIONS(2482),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2482),
    [anon_sym_co_await] = ACTIONS(2484),
    [anon_sym_new] = ACTIONS(2486),
    [anon_sym_requires] = ACTIONS(2488),
    [sym_this] = ACTIONS(2476),
  },
  [1378] = {
    [sym_expression] = STATE(3247),
    [sym__string] = STATE(3374),
    [sym_conditional_expression] = STATE(3536),
    [sym_assignment_expression] = STATE(3536),
    [sym_pointer_expression] = STATE(3544),
    [sym_unary_expression] = STATE(3536),
    [sym_binary_expression] = STATE(3536),
    [sym_update_expression] = STATE(3536),
    [sym_cast_expression] = STATE(3536),
    [sym_sizeof_expression] = STATE(3536),
    [sym_alignof_expression] = STATE(3536),
    [sym_offsetof_expression] = STATE(3536),
    [sym_generic_expression] = STATE(3536),
    [sym_subscript_expression] = STATE(3544),
    [sym_call_expression] = STATE(3544),
    [sym_gnu_asm_expression] = STATE(3536),
    [sym_extension_expression] = STATE(3536),
    [sym_field_expression] = STATE(3544),
    [sym_compound_literal_expression] = STATE(3536),
    [sym_parenthesized_expression] = STATE(3544),
    [sym_char_literal] = STATE(3374),
    [sym_concatenated_string] = STATE(3374),
    [sym_string_literal] = STATE(2363),
    [sym_null] = STATE(3536),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7597),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3536),
    [sym_raw_string_literal] = STATE(2363),
    [sym_co_await_expression] = STATE(3536),
    [sym_new_expression] = STATE(3536),
    [sym_delete_expression] = STATE(3536),
    [sym_requires_clause] = STATE(3536),
    [sym_requires_expression] = STATE(3536),
    [sym_lambda_expression] = STATE(3536),
    [sym_lambda_capture_specifier] = STATE(5874),
    [sym_fold_expression] = STATE(3536),
    [sym_parameter_pack_expansion] = STATE(3536),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5696),
    [sym_qualified_identifier] = STATE(3544),
    [sym_qualified_type_identifier] = STATE(7597),
    [sym_user_defined_literal] = STATE(3544),
    [sym_identifier] = ACTIONS(2446),
    [anon_sym_LPAREN2] = ACTIONS(4521),
    [anon_sym_BANG] = ACTIONS(2450),
    [anon_sym_TILDE] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2448),
    [anon_sym_PLUS] = ACTIONS(2448),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_AMP] = ACTIONS(2862),
    [anon_sym___extension__] = ACTIONS(2452),
    [anon_sym_COLON_COLON] = ACTIONS(2454),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2458),
    [anon_sym_not] = ACTIONS(2448),
    [anon_sym_compl] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(4478),
    [anon_sym_PLUS_PLUS] = ACTIONS(4478),
    [anon_sym_sizeof] = ACTIONS(2460),
    [anon_sym___alignof__] = ACTIONS(2462),
    [anon_sym___alignof] = ACTIONS(2462),
    [anon_sym__alignof] = ACTIONS(2462),
    [anon_sym_alignof] = ACTIONS(2462),
    [anon_sym__Alignof] = ACTIONS(2462),
    [anon_sym_offsetof] = ACTIONS(2464),
    [anon_sym__Generic] = ACTIONS(2466),
    [anon_sym_asm] = ACTIONS(2468),
    [anon_sym___asm__] = ACTIONS(2468),
    [anon_sym___asm] = ACTIONS(2468),
    [sym_number_literal] = ACTIONS(2470),
    [anon_sym_L_SQUOTE] = ACTIONS(2472),
    [anon_sym_u_SQUOTE] = ACTIONS(2472),
    [anon_sym_U_SQUOTE] = ACTIONS(2472),
    [anon_sym_u8_SQUOTE] = ACTIONS(2472),
    [anon_sym_SQUOTE] = ACTIONS(2472),
    [anon_sym_L_DQUOTE] = ACTIONS(2474),
    [anon_sym_u_DQUOTE] = ACTIONS(2474),
    [anon_sym_U_DQUOTE] = ACTIONS(2474),
    [anon_sym_u8_DQUOTE] = ACTIONS(2474),
    [anon_sym_DQUOTE] = ACTIONS(2474),
    [sym_true] = ACTIONS(2476),
    [sym_false] = ACTIONS(2476),
    [anon_sym_NULL] = ACTIONS(2478),
    [anon_sym_nullptr] = ACTIONS(2478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2480),
    [anon_sym_R_DQUOTE] = ACTIONS(2482),
    [anon_sym_LR_DQUOTE] = ACTIONS(2482),
    [anon_sym_uR_DQUOTE] = ACTIONS(2482),
    [anon_sym_UR_DQUOTE] = ACTIONS(2482),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2482),
    [anon_sym_co_await] = ACTIONS(2484),
    [anon_sym_new] = ACTIONS(2486),
    [anon_sym_requires] = ACTIONS(2488),
    [sym_this] = ACTIONS(2476),
  },
  [1379] = {
    [sym_expression] = STATE(3706),
    [sym__string] = STATE(4345),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3286),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3286),
    [sym_call_expression] = STATE(3286),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3286),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3286),
    [sym_char_literal] = STATE(4345),
    [sym_concatenated_string] = STATE(4345),
    [sym_string_literal] = STATE(3370),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3370),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3286),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3286),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_LPAREN2] = ACTIONS(4388),
    [anon_sym_BANG] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3496),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym___extension__] = ACTIONS(3500),
    [anon_sym_COLON_COLON] = ACTIONS(3502),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3496),
    [anon_sym_compl] = ACTIONS(3496),
    [anon_sym_DASH_DASH] = ACTIONS(4394),
    [anon_sym_PLUS_PLUS] = ACTIONS(4394),
    [anon_sym_sizeof] = ACTIONS(3504),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3506),
    [anon_sym_L_SQUOTE] = ACTIONS(3508),
    [anon_sym_u_SQUOTE] = ACTIONS(3508),
    [anon_sym_U_SQUOTE] = ACTIONS(3508),
    [anon_sym_u8_SQUOTE] = ACTIONS(3508),
    [anon_sym_SQUOTE] = ACTIONS(3508),
    [anon_sym_L_DQUOTE] = ACTIONS(3510),
    [anon_sym_u_DQUOTE] = ACTIONS(3510),
    [anon_sym_U_DQUOTE] = ACTIONS(3510),
    [anon_sym_u8_DQUOTE] = ACTIONS(3510),
    [anon_sym_DQUOTE] = ACTIONS(3510),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3512),
    [anon_sym_R_DQUOTE] = ACTIONS(3514),
    [anon_sym_LR_DQUOTE] = ACTIONS(3514),
    [anon_sym_uR_DQUOTE] = ACTIONS(3514),
    [anon_sym_UR_DQUOTE] = ACTIONS(3514),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3514),
    [anon_sym_co_await] = ACTIONS(3516),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1380] = {
    [sym_expression] = STATE(3699),
    [sym__string] = STATE(4345),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3286),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3286),
    [sym_call_expression] = STATE(3286),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3286),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3286),
    [sym_char_literal] = STATE(4345),
    [sym_concatenated_string] = STATE(4345),
    [sym_string_literal] = STATE(3370),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3370),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3286),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3286),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_LPAREN2] = ACTIONS(4388),
    [anon_sym_BANG] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3496),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym___extension__] = ACTIONS(3500),
    [anon_sym_COLON_COLON] = ACTIONS(3502),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3496),
    [anon_sym_compl] = ACTIONS(3496),
    [anon_sym_DASH_DASH] = ACTIONS(4394),
    [anon_sym_PLUS_PLUS] = ACTIONS(4394),
    [anon_sym_sizeof] = ACTIONS(3504),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3506),
    [anon_sym_L_SQUOTE] = ACTIONS(3508),
    [anon_sym_u_SQUOTE] = ACTIONS(3508),
    [anon_sym_U_SQUOTE] = ACTIONS(3508),
    [anon_sym_u8_SQUOTE] = ACTIONS(3508),
    [anon_sym_SQUOTE] = ACTIONS(3508),
    [anon_sym_L_DQUOTE] = ACTIONS(3510),
    [anon_sym_u_DQUOTE] = ACTIONS(3510),
    [anon_sym_U_DQUOTE] = ACTIONS(3510),
    [anon_sym_u8_DQUOTE] = ACTIONS(3510),
    [anon_sym_DQUOTE] = ACTIONS(3510),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3512),
    [anon_sym_R_DQUOTE] = ACTIONS(3514),
    [anon_sym_LR_DQUOTE] = ACTIONS(3514),
    [anon_sym_uR_DQUOTE] = ACTIONS(3514),
    [anon_sym_UR_DQUOTE] = ACTIONS(3514),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3514),
    [anon_sym_co_await] = ACTIONS(3516),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1381] = {
    [sym_expression] = STATE(4471),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3740),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1382] = {
    [sym_expression] = STATE(3706),
    [sym__string] = STATE(4127),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(2853),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(2853),
    [sym_call_expression] = STATE(2853),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(2853),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(2853),
    [sym_char_literal] = STATE(4127),
    [sym_concatenated_string] = STATE(4127),
    [sym_string_literal] = STATE(3058),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3058),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2853),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(2853),
    [sym_identifier] = ACTIONS(4470),
    [anon_sym_LPAREN2] = ACTIONS(4509),
    [anon_sym_BANG] = ACTIONS(3460),
    [anon_sym_TILDE] = ACTIONS(3460),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_AMP] = ACTIONS(4505),
    [anon_sym___extension__] = ACTIONS(3462),
    [anon_sym_COLON_COLON] = ACTIONS(3464),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3458),
    [anon_sym_compl] = ACTIONS(3458),
    [anon_sym_DASH_DASH] = ACTIONS(4472),
    [anon_sym_PLUS_PLUS] = ACTIONS(4472),
    [anon_sym_sizeof] = ACTIONS(3468),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3470),
    [anon_sym_L_SQUOTE] = ACTIONS(3472),
    [anon_sym_u_SQUOTE] = ACTIONS(3472),
    [anon_sym_U_SQUOTE] = ACTIONS(3472),
    [anon_sym_u8_SQUOTE] = ACTIONS(3472),
    [anon_sym_SQUOTE] = ACTIONS(3472),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3476),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
    [anon_sym_co_await] = ACTIONS(3480),
    [anon_sym_new] = ACTIONS(3482),
    [anon_sym_requires] = ACTIONS(3484),
    [sym_this] = ACTIONS(221),
  },
  [1383] = {
    [sym_expression] = STATE(3699),
    [sym__string] = STATE(4127),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(2853),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(2853),
    [sym_call_expression] = STATE(2853),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(2853),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(2853),
    [sym_char_literal] = STATE(4127),
    [sym_concatenated_string] = STATE(4127),
    [sym_string_literal] = STATE(3058),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3058),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2853),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(2853),
    [sym_identifier] = ACTIONS(4470),
    [anon_sym_LPAREN2] = ACTIONS(4509),
    [anon_sym_BANG] = ACTIONS(3460),
    [anon_sym_TILDE] = ACTIONS(3460),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_AMP] = ACTIONS(4505),
    [anon_sym___extension__] = ACTIONS(3462),
    [anon_sym_COLON_COLON] = ACTIONS(3464),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3458),
    [anon_sym_compl] = ACTIONS(3458),
    [anon_sym_DASH_DASH] = ACTIONS(4472),
    [anon_sym_PLUS_PLUS] = ACTIONS(4472),
    [anon_sym_sizeof] = ACTIONS(3468),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3470),
    [anon_sym_L_SQUOTE] = ACTIONS(3472),
    [anon_sym_u_SQUOTE] = ACTIONS(3472),
    [anon_sym_U_SQUOTE] = ACTIONS(3472),
    [anon_sym_u8_SQUOTE] = ACTIONS(3472),
    [anon_sym_SQUOTE] = ACTIONS(3472),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3476),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
    [anon_sym_co_await] = ACTIONS(3480),
    [anon_sym_new] = ACTIONS(3482),
    [anon_sym_requires] = ACTIONS(3484),
    [sym_this] = ACTIONS(221),
  },
  [1384] = {
    [sym_expression] = STATE(2358),
    [sym__string] = STATE(3071),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(3071),
    [sym_concatenated_string] = STATE(3071),
    [sym_string_literal] = STATE(2243),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(2243),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1989),
    [anon_sym_LPAREN2] = ACTIONS(4531),
    [anon_sym_BANG] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1993),
    [anon_sym_DASH] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1991),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym___extension__] = ACTIONS(1995),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_compl] = ACTIONS(1991),
    [anon_sym_DASH_DASH] = ACTIONS(4480),
    [anon_sym_PLUS_PLUS] = ACTIONS(4480),
    [anon_sym_sizeof] = ACTIONS(1999),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(2001),
    [anon_sym_L_SQUOTE] = ACTIONS(2003),
    [anon_sym_u_SQUOTE] = ACTIONS(2003),
    [anon_sym_U_SQUOTE] = ACTIONS(2003),
    [anon_sym_u8_SQUOTE] = ACTIONS(2003),
    [anon_sym_SQUOTE] = ACTIONS(2003),
    [anon_sym_L_DQUOTE] = ACTIONS(2005),
    [anon_sym_u_DQUOTE] = ACTIONS(2005),
    [anon_sym_U_DQUOTE] = ACTIONS(2005),
    [anon_sym_u8_DQUOTE] = ACTIONS(2005),
    [anon_sym_DQUOTE] = ACTIONS(2005),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2007),
    [anon_sym_R_DQUOTE] = ACTIONS(2009),
    [anon_sym_LR_DQUOTE] = ACTIONS(2009),
    [anon_sym_uR_DQUOTE] = ACTIONS(2009),
    [anon_sym_UR_DQUOTE] = ACTIONS(2009),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2009),
    [anon_sym_co_await] = ACTIONS(2011),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1385] = {
    [sym_expression] = STATE(4432),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1386] = {
    [sym_expression] = STATE(2352),
    [sym__string] = STATE(3071),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(3071),
    [sym_concatenated_string] = STATE(3071),
    [sym_string_literal] = STATE(2243),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(2243),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1989),
    [anon_sym_LPAREN2] = ACTIONS(4531),
    [anon_sym_BANG] = ACTIONS(1993),
    [anon_sym_TILDE] = ACTIONS(1993),
    [anon_sym_DASH] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1991),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym___extension__] = ACTIONS(1995),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1991),
    [anon_sym_compl] = ACTIONS(1991),
    [anon_sym_DASH_DASH] = ACTIONS(4480),
    [anon_sym_PLUS_PLUS] = ACTIONS(4480),
    [anon_sym_sizeof] = ACTIONS(1999),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(2001),
    [anon_sym_L_SQUOTE] = ACTIONS(2003),
    [anon_sym_u_SQUOTE] = ACTIONS(2003),
    [anon_sym_U_SQUOTE] = ACTIONS(2003),
    [anon_sym_u8_SQUOTE] = ACTIONS(2003),
    [anon_sym_SQUOTE] = ACTIONS(2003),
    [anon_sym_L_DQUOTE] = ACTIONS(2005),
    [anon_sym_u_DQUOTE] = ACTIONS(2005),
    [anon_sym_U_DQUOTE] = ACTIONS(2005),
    [anon_sym_u8_DQUOTE] = ACTIONS(2005),
    [anon_sym_DQUOTE] = ACTIONS(2005),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2007),
    [anon_sym_R_DQUOTE] = ACTIONS(2009),
    [anon_sym_LR_DQUOTE] = ACTIONS(2009),
    [anon_sym_uR_DQUOTE] = ACTIONS(2009),
    [anon_sym_UR_DQUOTE] = ACTIONS(2009),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2009),
    [anon_sym_co_await] = ACTIONS(2011),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1387] = {
    [sym_expression] = STATE(2342),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4424),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_TILDE] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1971),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1965),
    [anon_sym_compl] = ACTIONS(1965),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_sizeof] = ACTIONS(1973),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1981),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(1985),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(4796),
  },
  [1388] = {
    [sym_expression] = STATE(2358),
    [sym__string] = STATE(2808),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2808),
    [sym_concatenated_string] = STATE(2808),
    [sym_string_literal] = STATE(1900),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1900),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4503),
    [anon_sym_BANG] = ACTIONS(1921),
    [anon_sym_TILDE] = ACTIONS(1921),
    [anon_sym_DASH] = ACTIONS(1919),
    [anon_sym_PLUS] = ACTIONS(1919),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_AMP] = ACTIONS(4505),
    [anon_sym___extension__] = ACTIONS(1923),
    [anon_sym_COLON_COLON] = ACTIONS(1925),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1919),
    [anon_sym_compl] = ACTIONS(1919),
    [anon_sym_DASH_DASH] = ACTIONS(4491),
    [anon_sym_PLUS_PLUS] = ACTIONS(4491),
    [anon_sym_sizeof] = ACTIONS(1931),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1953),
    [anon_sym_R_DQUOTE] = ACTIONS(1955),
    [anon_sym_LR_DQUOTE] = ACTIONS(1955),
    [anon_sym_uR_DQUOTE] = ACTIONS(1955),
    [anon_sym_UR_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1955),
    [anon_sym_co_await] = ACTIONS(1957),
    [anon_sym_new] = ACTIONS(1959),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1389] = {
    [sym_expression] = STATE(2352),
    [sym__string] = STATE(2808),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2808),
    [sym_concatenated_string] = STATE(2808),
    [sym_string_literal] = STATE(1900),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1900),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4503),
    [anon_sym_BANG] = ACTIONS(1921),
    [anon_sym_TILDE] = ACTIONS(1921),
    [anon_sym_DASH] = ACTIONS(1919),
    [anon_sym_PLUS] = ACTIONS(1919),
    [anon_sym_STAR] = ACTIONS(4505),
    [anon_sym_AMP] = ACTIONS(4505),
    [anon_sym___extension__] = ACTIONS(1923),
    [anon_sym_COLON_COLON] = ACTIONS(1925),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(1919),
    [anon_sym_compl] = ACTIONS(1919),
    [anon_sym_DASH_DASH] = ACTIONS(4491),
    [anon_sym_PLUS_PLUS] = ACTIONS(4491),
    [anon_sym_sizeof] = ACTIONS(1931),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1941),
    [anon_sym_L_SQUOTE] = ACTIONS(1943),
    [anon_sym_u_SQUOTE] = ACTIONS(1943),
    [anon_sym_U_SQUOTE] = ACTIONS(1943),
    [anon_sym_u8_SQUOTE] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1953),
    [anon_sym_R_DQUOTE] = ACTIONS(1955),
    [anon_sym_LR_DQUOTE] = ACTIONS(1955),
    [anon_sym_uR_DQUOTE] = ACTIONS(1955),
    [anon_sym_UR_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1955),
    [anon_sym_co_await] = ACTIONS(1957),
    [anon_sym_new] = ACTIONS(1959),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1390] = {
    [sym_expression] = STATE(4247),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1391] = {
    [sym_expression] = STATE(4538),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3740),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1392] = {
    [sym_expression] = STATE(4483),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1393] = {
    [sym_expression] = STATE(3163),
    [sym__string] = STATE(3173),
    [sym_conditional_expression] = STATE(3378),
    [sym_assignment_expression] = STATE(3378),
    [sym_pointer_expression] = STATE(3443),
    [sym_unary_expression] = STATE(3378),
    [sym_binary_expression] = STATE(3378),
    [sym_update_expression] = STATE(3378),
    [sym_cast_expression] = STATE(3378),
    [sym_sizeof_expression] = STATE(3378),
    [sym_alignof_expression] = STATE(3378),
    [sym_offsetof_expression] = STATE(3378),
    [sym_generic_expression] = STATE(3378),
    [sym_subscript_expression] = STATE(3443),
    [sym_call_expression] = STATE(3443),
    [sym_gnu_asm_expression] = STATE(3378),
    [sym_extension_expression] = STATE(3378),
    [sym_field_expression] = STATE(3443),
    [sym_compound_literal_expression] = STATE(3378),
    [sym_parenthesized_expression] = STATE(3443),
    [sym_char_literal] = STATE(3173),
    [sym_concatenated_string] = STATE(3173),
    [sym_string_literal] = STATE(2310),
    [sym_null] = STATE(3378),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7687),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3378),
    [sym_raw_string_literal] = STATE(2310),
    [sym_co_await_expression] = STATE(3378),
    [sym_new_expression] = STATE(3378),
    [sym_delete_expression] = STATE(3378),
    [sym_requires_clause] = STATE(3378),
    [sym_requires_expression] = STATE(3378),
    [sym_lambda_expression] = STATE(3378),
    [sym_lambda_capture_specifier] = STATE(5873),
    [sym_fold_expression] = STATE(3378),
    [sym_parameter_pack_expansion] = STATE(3378),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5592),
    [sym_qualified_identifier] = STATE(3443),
    [sym_qualified_type_identifier] = STATE(7687),
    [sym_user_defined_literal] = STATE(3443),
    [sym_identifier] = ACTIONS(2027),
    [anon_sym_LPAREN2] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1769),
    [anon_sym_PLUS] = ACTIONS(1769),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym___extension__] = ACTIONS(2029),
    [anon_sym_COLON_COLON] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2033),
    [anon_sym_not] = ACTIONS(1769),
    [anon_sym_compl] = ACTIONS(1769),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_sizeof] = ACTIONS(1797),
    [anon_sym___alignof__] = ACTIONS(1799),
    [anon_sym___alignof] = ACTIONS(1799),
    [anon_sym__alignof] = ACTIONS(1799),
    [anon_sym_alignof] = ACTIONS(1799),
    [anon_sym__Alignof] = ACTIONS(1799),
    [anon_sym_offsetof] = ACTIONS(1801),
    [anon_sym__Generic] = ACTIONS(1803),
    [anon_sym_asm] = ACTIONS(1805),
    [anon_sym___asm__] = ACTIONS(1805),
    [anon_sym___asm] = ACTIONS(1805),
    [sym_number_literal] = ACTIONS(1807),
    [anon_sym_L_SQUOTE] = ACTIONS(1809),
    [anon_sym_u_SQUOTE] = ACTIONS(1809),
    [anon_sym_U_SQUOTE] = ACTIONS(1809),
    [anon_sym_u8_SQUOTE] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_L_DQUOTE] = ACTIONS(1811),
    [anon_sym_u_DQUOTE] = ACTIONS(1811),
    [anon_sym_U_DQUOTE] = ACTIONS(1811),
    [anon_sym_u8_DQUOTE] = ACTIONS(1811),
    [anon_sym_DQUOTE] = ACTIONS(1811),
    [sym_true] = ACTIONS(1813),
    [sym_false] = ACTIONS(1813),
    [anon_sym_NULL] = ACTIONS(1815),
    [anon_sym_nullptr] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(1825),
    [anon_sym_R_DQUOTE] = ACTIONS(1827),
    [anon_sym_LR_DQUOTE] = ACTIONS(1827),
    [anon_sym_uR_DQUOTE] = ACTIONS(1827),
    [anon_sym_UR_DQUOTE] = ACTIONS(1827),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1827),
    [anon_sym_co_await] = ACTIONS(1829),
    [anon_sym_new] = ACTIONS(1831),
    [anon_sym_requires] = ACTIONS(1833),
    [sym_this] = ACTIONS(1813),
  },
  [1394] = {
    [sym_expression] = STATE(4578),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4497),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(3714),
    [anon_sym_COLON_COLON] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4476),
    [anon_sym_PLUS_PLUS] = ACTIONS(4476),
    [anon_sym_sizeof] = ACTIONS(3718),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3720),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3722),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1395] = {
    [sym_expression] = STATE(4597),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1396] = {
    [sym_expression] = STATE(4494),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4497),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(3714),
    [anon_sym_COLON_COLON] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4476),
    [anon_sym_PLUS_PLUS] = ACTIONS(4476),
    [anon_sym_sizeof] = ACTIONS(3718),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3720),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3722),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1397] = {
    [sym_expression] = STATE(4445),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4497),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(3714),
    [anon_sym_COLON_COLON] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(4798),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4476),
    [anon_sym_PLUS_PLUS] = ACTIONS(4476),
    [anon_sym_sizeof] = ACTIONS(3718),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3720),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3722),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1398] = {
    [sym_expression] = STATE(4448),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4497),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(3714),
    [anon_sym_COLON_COLON] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4476),
    [anon_sym_PLUS_PLUS] = ACTIONS(4476),
    [anon_sym_sizeof] = ACTIONS(3718),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3720),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3722),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1399] = {
    [sym_expression] = STATE(4496),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4497),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(3714),
    [anon_sym_COLON_COLON] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4476),
    [anon_sym_PLUS_PLUS] = ACTIONS(4476),
    [anon_sym_sizeof] = ACTIONS(3718),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3720),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3722),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1400] = {
    [sym_expression] = STATE(4449),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4497),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(3714),
    [anon_sym_COLON_COLON] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4476),
    [anon_sym_PLUS_PLUS] = ACTIONS(4476),
    [anon_sym_sizeof] = ACTIONS(3718),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3720),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3722),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1401] = {
    [sym_expression] = STATE(4450),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4497),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(3714),
    [anon_sym_COLON_COLON] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4476),
    [anon_sym_PLUS_PLUS] = ACTIONS(4476),
    [anon_sym_sizeof] = ACTIONS(3718),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3720),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3722),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1402] = {
    [sym_expression] = STATE(4451),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4497),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(3714),
    [anon_sym_COLON_COLON] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4476),
    [anon_sym_PLUS_PLUS] = ACTIONS(4476),
    [anon_sym_sizeof] = ACTIONS(3718),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3720),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3722),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1403] = {
    [sym_expression] = STATE(4452),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4497),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(3714),
    [anon_sym_COLON_COLON] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4476),
    [anon_sym_PLUS_PLUS] = ACTIONS(4476),
    [anon_sym_sizeof] = ACTIONS(3718),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3720),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3722),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1404] = {
    [sym_expression] = STATE(4453),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4497),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(3714),
    [anon_sym_COLON_COLON] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4476),
    [anon_sym_PLUS_PLUS] = ACTIONS(4476),
    [anon_sym_sizeof] = ACTIONS(3718),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3720),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3722),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1405] = {
    [sym_expression] = STATE(4454),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4497),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(3714),
    [anon_sym_COLON_COLON] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4476),
    [anon_sym_PLUS_PLUS] = ACTIONS(4476),
    [anon_sym_sizeof] = ACTIONS(3718),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3720),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3722),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1406] = {
    [sym_expression] = STATE(4455),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4497),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(3714),
    [anon_sym_COLON_COLON] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4476),
    [anon_sym_PLUS_PLUS] = ACTIONS(4476),
    [anon_sym_sizeof] = ACTIONS(3718),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3720),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3722),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1407] = {
    [sym_expression] = STATE(4536),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4497),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(3714),
    [anon_sym_COLON_COLON] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4476),
    [anon_sym_PLUS_PLUS] = ACTIONS(4476),
    [anon_sym_sizeof] = ACTIONS(3718),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3720),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3722),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1408] = {
    [sym_expression] = STATE(4458),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4497),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(3714),
    [anon_sym_COLON_COLON] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4476),
    [anon_sym_PLUS_PLUS] = ACTIONS(4476),
    [anon_sym_sizeof] = ACTIONS(3718),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3720),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3722),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1409] = {
    [sym_expression] = STATE(4650),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1410] = {
    [sym_expression] = STATE(4675),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1411] = {
    [sym_expression] = STATE(4676),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3740),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1412] = {
    [sym_expression] = STATE(4461),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4497),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(3714),
    [anon_sym_COLON_COLON] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4476),
    [anon_sym_PLUS_PLUS] = ACTIONS(4476),
    [anon_sym_sizeof] = ACTIONS(3718),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3720),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3722),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1413] = {
    [sym_expression] = STATE(4689),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1414] = {
    [sym_expression] = STATE(4463),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4497),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(3714),
    [anon_sym_COLON_COLON] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4476),
    [anon_sym_PLUS_PLUS] = ACTIONS(4476),
    [anon_sym_sizeof] = ACTIONS(3718),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3720),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3722),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1415] = {
    [sym_expression] = STATE(4276),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1416] = {
    [sym_expression] = STATE(4719),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4497),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(3714),
    [anon_sym_COLON_COLON] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4476),
    [anon_sym_PLUS_PLUS] = ACTIONS(4476),
    [anon_sym_sizeof] = ACTIONS(3718),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3720),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3722),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1417] = {
    [sym_expression] = STATE(4724),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1418] = {
    [sym_expression] = STATE(4541),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1419] = {
    [sym_expression] = STATE(4543),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1420] = {
    [sym_expression] = STATE(4544),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3740),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1421] = {
    [sym_expression] = STATE(4545),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1422] = {
    [sym_expression] = STATE(4355),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1423] = {
    [sym_expression] = STATE(4553),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1424] = {
    [sym_expression] = STATE(4558),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1425] = {
    [sym_expression] = STATE(4560),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1426] = {
    [sym_expression] = STATE(4561),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3740),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1427] = {
    [sym_expression] = STATE(4563),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1428] = {
    [sym_expression] = STATE(4286),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1429] = {
    [sym_expression] = STATE(4568),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4497),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(3714),
    [anon_sym_COLON_COLON] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4476),
    [anon_sym_PLUS_PLUS] = ACTIONS(4476),
    [anon_sym_sizeof] = ACTIONS(3718),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3720),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3722),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1430] = {
    [sym_expression] = STATE(4571),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1431] = {
    [sym_expression] = STATE(4577),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1432] = {
    [sym_expression] = STATE(4580),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1433] = {
    [sym_expression] = STATE(4581),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3740),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1434] = {
    [sym_expression] = STATE(4583),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1435] = {
    [sym_expression] = STATE(4296),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1436] = {
    [sym_expression] = STATE(4596),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1437] = {
    [sym_expression] = STATE(4598),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1438] = {
    [sym_expression] = STATE(4537),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3740),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1439] = {
    [sym_expression] = STATE(4599),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1440] = {
    [sym_expression] = STATE(4305),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1441] = {
    [sym_expression] = STATE(4612),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1442] = {
    [sym_expression] = STATE(4613),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1443] = {
    [sym_expression] = STATE(4614),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1444] = {
    [sym_expression] = STATE(4527),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4497),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(3714),
    [anon_sym_COLON_COLON] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4476),
    [anon_sym_PLUS_PLUS] = ACTIONS(4476),
    [anon_sym_sizeof] = ACTIONS(3718),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3720),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3722),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1445] = {
    [sym_expression] = STATE(4528),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4497),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(3714),
    [anon_sym_COLON_COLON] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4476),
    [anon_sym_PLUS_PLUS] = ACTIONS(4476),
    [anon_sym_sizeof] = ACTIONS(3718),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3720),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3722),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1446] = {
    [sym_expression] = STATE(4495),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4497),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(3714),
    [anon_sym_COLON_COLON] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(4800),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4476),
    [anon_sym_PLUS_PLUS] = ACTIONS(4476),
    [anon_sym_sizeof] = ACTIONS(3718),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3720),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3722),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1447] = {
    [sym_expression] = STATE(4530),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3581),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3581),
    [sym_call_expression] = STATE(3581),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3581),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3581),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3581),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3581),
    [sym_identifier] = ACTIONS(3708),
    [anon_sym_LPAREN2] = ACTIONS(4497),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3710),
    [anon_sym_PLUS] = ACTIONS(3710),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(3714),
    [anon_sym_COLON_COLON] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3710),
    [anon_sym_compl] = ACTIONS(3710),
    [anon_sym_DASH_DASH] = ACTIONS(4476),
    [anon_sym_PLUS_PLUS] = ACTIONS(4476),
    [anon_sym_sizeof] = ACTIONS(3718),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3720),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3722),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1448] = {
    [sym_expression] = STATE(4447),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1449] = {
    [sym_expression] = STATE(4441),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1450] = {
    [sym_expression] = STATE(4442),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1451] = {
    [sym_expression] = STATE(3261),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4546),
    [anon_sym_BANG] = ACTIONS(2498),
    [anon_sym_TILDE] = ACTIONS(2498),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(2500),
    [anon_sym_COLON_COLON] = ACTIONS(2502),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(2496),
    [anon_sym_compl] = ACTIONS(2496),
    [anon_sym_DASH_DASH] = ACTIONS(4493),
    [anon_sym_PLUS_PLUS] = ACTIONS(4493),
    [anon_sym_sizeof] = ACTIONS(2504),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2506),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(2508),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1452] = {
    [sym_expression] = STATE(3263),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4546),
    [anon_sym_BANG] = ACTIONS(2498),
    [anon_sym_TILDE] = ACTIONS(2498),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(2500),
    [anon_sym_COLON_COLON] = ACTIONS(2502),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(2496),
    [anon_sym_compl] = ACTIONS(2496),
    [anon_sym_DASH_DASH] = ACTIONS(4493),
    [anon_sym_PLUS_PLUS] = ACTIONS(4493),
    [anon_sym_sizeof] = ACTIONS(2504),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2506),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(2508),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1453] = {
    [sym_expression] = STATE(3675),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3740),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1454] = {
    [sym_expression] = STATE(4476),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1455] = {
    [sym_expression] = STATE(4485),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1456] = {
    [sym_expression] = STATE(4486),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1457] = {
    [sym_expression] = STATE(4487),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1458] = {
    [sym_expression] = STATE(4490),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1459] = {
    [sym_expression] = STATE(3293),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4546),
    [anon_sym_BANG] = ACTIONS(2498),
    [anon_sym_TILDE] = ACTIONS(2498),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(2500),
    [anon_sym_COLON_COLON] = ACTIONS(2502),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(2496),
    [anon_sym_compl] = ACTIONS(2496),
    [anon_sym_DASH_DASH] = ACTIONS(4493),
    [anon_sym_PLUS_PLUS] = ACTIONS(4493),
    [anon_sym_sizeof] = ACTIONS(2504),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2506),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(2508),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1460] = {
    [sym_expression] = STATE(3262),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4546),
    [anon_sym_BANG] = ACTIONS(2498),
    [anon_sym_TILDE] = ACTIONS(2498),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(2500),
    [anon_sym_COLON_COLON] = ACTIONS(2502),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(2496),
    [anon_sym_compl] = ACTIONS(2496),
    [anon_sym_DASH_DASH] = ACTIONS(4493),
    [anon_sym_PLUS_PLUS] = ACTIONS(4493),
    [anon_sym_sizeof] = ACTIONS(2504),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2506),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(2508),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1461] = {
    [sym_expression] = STATE(3269),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4546),
    [anon_sym_BANG] = ACTIONS(2498),
    [anon_sym_TILDE] = ACTIONS(2498),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(2500),
    [anon_sym_COLON_COLON] = ACTIONS(2502),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(2496),
    [anon_sym_compl] = ACTIONS(2496),
    [anon_sym_DASH_DASH] = ACTIONS(4493),
    [anon_sym_PLUS_PLUS] = ACTIONS(4493),
    [anon_sym_sizeof] = ACTIONS(2504),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2506),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(2508),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1462] = {
    [sym_expression] = STATE(3270),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4546),
    [anon_sym_BANG] = ACTIONS(2498),
    [anon_sym_TILDE] = ACTIONS(2498),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(2500),
    [anon_sym_COLON_COLON] = ACTIONS(2502),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(2496),
    [anon_sym_compl] = ACTIONS(2496),
    [anon_sym_DASH_DASH] = ACTIONS(4493),
    [anon_sym_PLUS_PLUS] = ACTIONS(4493),
    [anon_sym_sizeof] = ACTIONS(2504),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2506),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(2508),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1463] = {
    [sym_expression] = STATE(3271),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4546),
    [anon_sym_BANG] = ACTIONS(2498),
    [anon_sym_TILDE] = ACTIONS(2498),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(2500),
    [anon_sym_COLON_COLON] = ACTIONS(2502),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(2496),
    [anon_sym_compl] = ACTIONS(2496),
    [anon_sym_DASH_DASH] = ACTIONS(4493),
    [anon_sym_PLUS_PLUS] = ACTIONS(4493),
    [anon_sym_sizeof] = ACTIONS(2504),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2506),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(2508),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1464] = {
    [sym_expression] = STATE(3272),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4546),
    [anon_sym_BANG] = ACTIONS(2498),
    [anon_sym_TILDE] = ACTIONS(2498),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(2500),
    [anon_sym_COLON_COLON] = ACTIONS(2502),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(2496),
    [anon_sym_compl] = ACTIONS(2496),
    [anon_sym_DASH_DASH] = ACTIONS(4493),
    [anon_sym_PLUS_PLUS] = ACTIONS(4493),
    [anon_sym_sizeof] = ACTIONS(2504),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2506),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(2508),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1465] = {
    [sym_expression] = STATE(3273),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4546),
    [anon_sym_BANG] = ACTIONS(2498),
    [anon_sym_TILDE] = ACTIONS(2498),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(2500),
    [anon_sym_COLON_COLON] = ACTIONS(2502),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(2496),
    [anon_sym_compl] = ACTIONS(2496),
    [anon_sym_DASH_DASH] = ACTIONS(4493),
    [anon_sym_PLUS_PLUS] = ACTIONS(4493),
    [anon_sym_sizeof] = ACTIONS(2504),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2506),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(2508),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1466] = {
    [sym_expression] = STATE(3274),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4546),
    [anon_sym_BANG] = ACTIONS(2498),
    [anon_sym_TILDE] = ACTIONS(2498),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(2500),
    [anon_sym_COLON_COLON] = ACTIONS(2502),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(2496),
    [anon_sym_compl] = ACTIONS(2496),
    [anon_sym_DASH_DASH] = ACTIONS(4493),
    [anon_sym_PLUS_PLUS] = ACTIONS(4493),
    [anon_sym_sizeof] = ACTIONS(2504),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2506),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(2508),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1467] = {
    [sym_expression] = STATE(3275),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4546),
    [anon_sym_BANG] = ACTIONS(2498),
    [anon_sym_TILDE] = ACTIONS(2498),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(2500),
    [anon_sym_COLON_COLON] = ACTIONS(2502),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(2496),
    [anon_sym_compl] = ACTIONS(2496),
    [anon_sym_DASH_DASH] = ACTIONS(4493),
    [anon_sym_PLUS_PLUS] = ACTIONS(4493),
    [anon_sym_sizeof] = ACTIONS(2504),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2506),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(2508),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1468] = {
    [sym_expression] = STATE(3276),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4546),
    [anon_sym_BANG] = ACTIONS(2498),
    [anon_sym_TILDE] = ACTIONS(2498),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(2500),
    [anon_sym_COLON_COLON] = ACTIONS(2502),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(2496),
    [anon_sym_compl] = ACTIONS(2496),
    [anon_sym_DASH_DASH] = ACTIONS(4493),
    [anon_sym_PLUS_PLUS] = ACTIONS(4493),
    [anon_sym_sizeof] = ACTIONS(2504),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2506),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(2508),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1469] = {
    [sym_expression] = STATE(3277),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4546),
    [anon_sym_BANG] = ACTIONS(2498),
    [anon_sym_TILDE] = ACTIONS(2498),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(2500),
    [anon_sym_COLON_COLON] = ACTIONS(2502),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(2496),
    [anon_sym_compl] = ACTIONS(2496),
    [anon_sym_DASH_DASH] = ACTIONS(4493),
    [anon_sym_PLUS_PLUS] = ACTIONS(4493),
    [anon_sym_sizeof] = ACTIONS(2504),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2506),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(2508),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1470] = {
    [sym_expression] = STATE(3278),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4546),
    [anon_sym_BANG] = ACTIONS(2498),
    [anon_sym_TILDE] = ACTIONS(2498),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(2500),
    [anon_sym_COLON_COLON] = ACTIONS(2502),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(2496),
    [anon_sym_compl] = ACTIONS(2496),
    [anon_sym_DASH_DASH] = ACTIONS(4493),
    [anon_sym_PLUS_PLUS] = ACTIONS(4493),
    [anon_sym_sizeof] = ACTIONS(2504),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2506),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(2508),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1471] = {
    [sym_expression] = STATE(3265),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4546),
    [anon_sym_BANG] = ACTIONS(2498),
    [anon_sym_TILDE] = ACTIONS(2498),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(2500),
    [anon_sym_COLON_COLON] = ACTIONS(2502),
    [anon_sym_LBRACK] = ACTIONS(4802),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(2496),
    [anon_sym_compl] = ACTIONS(2496),
    [anon_sym_DASH_DASH] = ACTIONS(4493),
    [anon_sym_PLUS_PLUS] = ACTIONS(4493),
    [anon_sym_sizeof] = ACTIONS(2504),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2506),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(2508),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1472] = {
    [sym_expression] = STATE(3266),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4546),
    [anon_sym_BANG] = ACTIONS(2498),
    [anon_sym_TILDE] = ACTIONS(2498),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(2500),
    [anon_sym_COLON_COLON] = ACTIONS(2502),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(2496),
    [anon_sym_compl] = ACTIONS(2496),
    [anon_sym_DASH_DASH] = ACTIONS(4493),
    [anon_sym_PLUS_PLUS] = ACTIONS(4493),
    [anon_sym_sizeof] = ACTIONS(2504),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2506),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(2508),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1473] = {
    [sym_expression] = STATE(3267),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4546),
    [anon_sym_BANG] = ACTIONS(2498),
    [anon_sym_TILDE] = ACTIONS(2498),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(2500),
    [anon_sym_COLON_COLON] = ACTIONS(2502),
    [anon_sym_LBRACK] = ACTIONS(4804),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(2496),
    [anon_sym_compl] = ACTIONS(2496),
    [anon_sym_DASH_DASH] = ACTIONS(4493),
    [anon_sym_PLUS_PLUS] = ACTIONS(4493),
    [anon_sym_sizeof] = ACTIONS(2504),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2506),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(2508),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1474] = {
    [sym_expression] = STATE(3279),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4546),
    [anon_sym_BANG] = ACTIONS(2498),
    [anon_sym_TILDE] = ACTIONS(2498),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(2500),
    [anon_sym_COLON_COLON] = ACTIONS(2502),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(2496),
    [anon_sym_compl] = ACTIONS(2496),
    [anon_sym_DASH_DASH] = ACTIONS(4493),
    [anon_sym_PLUS_PLUS] = ACTIONS(4493),
    [anon_sym_sizeof] = ACTIONS(2504),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2506),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(2508),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1475] = {
    [sym_expression] = STATE(3283),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4546),
    [anon_sym_BANG] = ACTIONS(2498),
    [anon_sym_TILDE] = ACTIONS(2498),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(2500),
    [anon_sym_COLON_COLON] = ACTIONS(2502),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(2496),
    [anon_sym_compl] = ACTIONS(2496),
    [anon_sym_DASH_DASH] = ACTIONS(4493),
    [anon_sym_PLUS_PLUS] = ACTIONS(4493),
    [anon_sym_sizeof] = ACTIONS(2504),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2506),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(2508),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1476] = {
    [sym_expression] = STATE(3285),
    [sym__string] = STATE(2890),
    [sym_conditional_expression] = STATE(2470),
    [sym_assignment_expression] = STATE(2470),
    [sym_pointer_expression] = STATE(2404),
    [sym_unary_expression] = STATE(2470),
    [sym_binary_expression] = STATE(2470),
    [sym_update_expression] = STATE(2470),
    [sym_cast_expression] = STATE(2470),
    [sym_sizeof_expression] = STATE(2470),
    [sym_alignof_expression] = STATE(2470),
    [sym_offsetof_expression] = STATE(2470),
    [sym_generic_expression] = STATE(2470),
    [sym_subscript_expression] = STATE(2404),
    [sym_call_expression] = STATE(2404),
    [sym_gnu_asm_expression] = STATE(2470),
    [sym_extension_expression] = STATE(2470),
    [sym_field_expression] = STATE(2404),
    [sym_compound_literal_expression] = STATE(2470),
    [sym_parenthesized_expression] = STATE(2404),
    [sym_char_literal] = STATE(2890),
    [sym_concatenated_string] = STATE(2890),
    [sym_string_literal] = STATE(1949),
    [sym_null] = STATE(2470),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7477),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(2470),
    [sym_raw_string_literal] = STATE(1949),
    [sym_co_await_expression] = STATE(2470),
    [sym_new_expression] = STATE(2470),
    [sym_delete_expression] = STATE(2470),
    [sym_requires_clause] = STATE(2470),
    [sym_requires_expression] = STATE(2470),
    [sym_lambda_expression] = STATE(2470),
    [sym_lambda_capture_specifier] = STATE(5876),
    [sym_fold_expression] = STATE(2470),
    [sym_parameter_pack_expansion] = STATE(2470),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(2404),
    [sym_qualified_type_identifier] = STATE(7477),
    [sym_user_defined_literal] = STATE(2404),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_LPAREN2] = ACTIONS(4546),
    [anon_sym_BANG] = ACTIONS(2498),
    [anon_sym_TILDE] = ACTIONS(2498),
    [anon_sym_DASH] = ACTIONS(2496),
    [anon_sym_PLUS] = ACTIONS(2496),
    [anon_sym_STAR] = ACTIONS(4499),
    [anon_sym_AMP] = ACTIONS(4499),
    [anon_sym___extension__] = ACTIONS(2500),
    [anon_sym_COLON_COLON] = ACTIONS(2502),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(1929),
    [anon_sym_not] = ACTIONS(2496),
    [anon_sym_compl] = ACTIONS(2496),
    [anon_sym_DASH_DASH] = ACTIONS(4493),
    [anon_sym_PLUS_PLUS] = ACTIONS(4493),
    [anon_sym_sizeof] = ACTIONS(2504),
    [anon_sym___alignof__] = ACTIONS(1933),
    [anon_sym___alignof] = ACTIONS(1933),
    [anon_sym__alignof] = ACTIONS(1933),
    [anon_sym_alignof] = ACTIONS(1933),
    [anon_sym__Alignof] = ACTIONS(1933),
    [anon_sym_offsetof] = ACTIONS(1935),
    [anon_sym__Generic] = ACTIONS(1937),
    [anon_sym_asm] = ACTIONS(1939),
    [anon_sym___asm__] = ACTIONS(1939),
    [anon_sym___asm] = ACTIONS(1939),
    [sym_number_literal] = ACTIONS(1975),
    [anon_sym_L_SQUOTE] = ACTIONS(1977),
    [anon_sym_u_SQUOTE] = ACTIONS(1977),
    [anon_sym_U_SQUOTE] = ACTIONS(1977),
    [anon_sym_u8_SQUOTE] = ACTIONS(1977),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [anon_sym_L_DQUOTE] = ACTIONS(1979),
    [anon_sym_u_DQUOTE] = ACTIONS(1979),
    [anon_sym_U_DQUOTE] = ACTIONS(1979),
    [anon_sym_u8_DQUOTE] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1979),
    [sym_true] = ACTIONS(1947),
    [sym_false] = ACTIONS(1947),
    [anon_sym_NULL] = ACTIONS(1949),
    [anon_sym_nullptr] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(2506),
    [anon_sym_R_DQUOTE] = ACTIONS(1983),
    [anon_sym_LR_DQUOTE] = ACTIONS(1983),
    [anon_sym_uR_DQUOTE] = ACTIONS(1983),
    [anon_sym_UR_DQUOTE] = ACTIONS(1983),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1983),
    [anon_sym_co_await] = ACTIONS(2508),
    [anon_sym_new] = ACTIONS(1987),
    [anon_sym_requires] = ACTIONS(1961),
    [sym_this] = ACTIONS(1947),
  },
  [1477] = {
    [sym_expression] = STATE(4522),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3740),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1478] = {
    [sym_expression] = STATE(4364),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3740),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(4806),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1479] = {
    [sym_expression] = STATE(4508),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3740),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1480] = {
    [sym_expression] = STATE(4509),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3740),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1481] = {
    [sym_expression] = STATE(4510),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3740),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1482] = {
    [sym_expression] = STATE(4511),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3740),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1483] = {
    [sym_expression] = STATE(4512),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3740),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1484] = {
    [sym_expression] = STATE(4513),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3740),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1485] = {
    [sym_expression] = STATE(4514),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3740),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1486] = {
    [sym_expression] = STATE(4515),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3740),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1487] = {
    [sym_expression] = STATE(4516),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3740),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1488] = {
    [sym_expression] = STATE(4517),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3740),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1489] = {
    [sym_expression] = STATE(4519),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3740),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1490] = {
    [sym_expression] = STATE(4521),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3740),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1491] = {
    [sym_expression] = STATE(3706),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3740),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1492] = {
    [sym_expression] = STATE(3699),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3740),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1493] = {
    [sym_expression] = STATE(4523),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3740),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(4808),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1494] = {
    [sym_expression] = STATE(3653),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3649),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3649),
    [sym_call_expression] = STATE(3649),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3649),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3649),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3649),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3649),
    [sym_identifier] = ACTIONS(3734),
    [anon_sym_LPAREN2] = ACTIONS(3752),
    [anon_sym_BANG] = ACTIONS(3738),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_DASH] = ACTIONS(3736),
    [anon_sym_PLUS] = ACTIONS(3736),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(3740),
    [anon_sym_COLON_COLON] = ACTIONS(3742),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3736),
    [anon_sym_compl] = ACTIONS(3736),
    [anon_sym_DASH_DASH] = ACTIONS(3756),
    [anon_sym_PLUS_PLUS] = ACTIONS(3756),
    [anon_sym_sizeof] = ACTIONS(3744),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3724),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1495] = {
    [sym_expression] = STATE(4726),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1496] = {
    [sym_expression] = STATE(4727),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1497] = {
    [sym_expression] = STATE(4728),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1498] = {
    [sym_expression] = STATE(4729),
    [sym__string] = STATE(4168),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3220),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3220),
    [sym_call_expression] = STATE(3220),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3220),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3220),
    [sym_char_literal] = STATE(4168),
    [sym_concatenated_string] = STATE(4168),
    [sym_string_literal] = STATE(3110),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3110),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3220),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3220),
    [sym_identifier] = ACTIONS(3706),
    [anon_sym_LPAREN2] = ACTIONS(1219),
    [anon_sym_BANG] = ACTIONS(21),
    [anon_sym_TILDE] = ACTIONS(21),
    [anon_sym_DASH] = ACTIONS(25),
    [anon_sym_PLUS] = ACTIONS(25),
    [anon_sym_STAR] = ACTIONS(1221),
    [anon_sym_AMP] = ACTIONS(1221),
    [anon_sym___extension__] = ACTIONS(2021),
    [anon_sym_COLON_COLON] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(25),
    [anon_sym_compl] = ACTIONS(25),
    [anon_sym_DASH_DASH] = ACTIONS(101),
    [anon_sym_PLUS_PLUS] = ACTIONS(101),
    [anon_sym_sizeof] = ACTIONS(103),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(219),
    [anon_sym_L_SQUOTE] = ACTIONS(115),
    [anon_sym_u_SQUOTE] = ACTIONS(115),
    [anon_sym_U_SQUOTE] = ACTIONS(115),
    [anon_sym_u8_SQUOTE] = ACTIONS(115),
    [anon_sym_SQUOTE] = ACTIONS(115),
    [anon_sym_L_DQUOTE] = ACTIONS(117),
    [anon_sym_u_DQUOTE] = ACTIONS(117),
    [anon_sym_U_DQUOTE] = ACTIONS(117),
    [anon_sym_u8_DQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(117),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(137),
    [anon_sym_R_DQUOTE] = ACTIONS(153),
    [anon_sym_LR_DQUOTE] = ACTIONS(153),
    [anon_sym_uR_DQUOTE] = ACTIONS(153),
    [anon_sym_UR_DQUOTE] = ACTIONS(153),
    [anon_sym_u8R_DQUOTE] = ACTIONS(153),
    [anon_sym_co_await] = ACTIONS(155),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1499] = {
    [sym_expression] = STATE(4252),
    [sym__string] = STATE(4345),
    [sym_conditional_expression] = STATE(3840),
    [sym_assignment_expression] = STATE(3840),
    [sym_pointer_expression] = STATE(3286),
    [sym_unary_expression] = STATE(3840),
    [sym_binary_expression] = STATE(3840),
    [sym_update_expression] = STATE(3840),
    [sym_cast_expression] = STATE(3840),
    [sym_sizeof_expression] = STATE(3840),
    [sym_alignof_expression] = STATE(3840),
    [sym_offsetof_expression] = STATE(3840),
    [sym_generic_expression] = STATE(3840),
    [sym_subscript_expression] = STATE(3286),
    [sym_call_expression] = STATE(3286),
    [sym_gnu_asm_expression] = STATE(3840),
    [sym_extension_expression] = STATE(3840),
    [sym_field_expression] = STATE(3286),
    [sym_compound_literal_expression] = STATE(3840),
    [sym_parenthesized_expression] = STATE(3286),
    [sym_char_literal] = STATE(4345),
    [sym_concatenated_string] = STATE(4345),
    [sym_string_literal] = STATE(3370),
    [sym_null] = STATE(3840),
    [sym_decltype] = STATE(8512),
    [sym__class_name] = STATE(7673),
    [sym_template_type] = STATE(2158),
    [sym_template_function] = STATE(3840),
    [sym_raw_string_literal] = STATE(3370),
    [sym_co_await_expression] = STATE(3840),
    [sym_new_expression] = STATE(3840),
    [sym_delete_expression] = STATE(3840),
    [sym_requires_clause] = STATE(3840),
    [sym_requires_expression] = STATE(3840),
    [sym_lambda_expression] = STATE(3840),
    [sym_lambda_capture_specifier] = STATE(5890),
    [sym_fold_expression] = STATE(3840),
    [sym_parameter_pack_expansion] = STATE(3840),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5664),
    [sym_qualified_identifier] = STATE(3286),
    [sym_qualified_type_identifier] = STATE(7673),
    [sym_user_defined_literal] = STATE(3286),
    [sym_identifier] = ACTIONS(3494),
    [anon_sym_LPAREN2] = ACTIONS(4388),
    [anon_sym_BANG] = ACTIONS(3498),
    [anon_sym_TILDE] = ACTIONS(3498),
    [anon_sym_DASH] = ACTIONS(3496),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym___extension__] = ACTIONS(3500),
    [anon_sym_COLON_COLON] = ACTIONS(3502),
    [anon_sym_LBRACK] = ACTIONS(2017),
    [sym_primitive_type] = ACTIONS(2023),
    [anon_sym_not] = ACTIONS(3496),
    [anon_sym_compl] = ACTIONS(3496),
    [anon_sym_DASH_DASH] = ACTIONS(4394),
    [anon_sym_PLUS_PLUS] = ACTIONS(4394),
    [anon_sym_sizeof] = ACTIONS(3504),
    [anon_sym___alignof__] = ACTIONS(105),
    [anon_sym___alignof] = ACTIONS(105),
    [anon_sym__alignof] = ACTIONS(105),
    [anon_sym_alignof] = ACTIONS(105),
    [anon_sym__Alignof] = ACTIONS(105),
    [anon_sym_offsetof] = ACTIONS(107),
    [anon_sym__Generic] = ACTIONS(109),
    [anon_sym_asm] = ACTIONS(111),
    [anon_sym___asm__] = ACTIONS(111),
    [anon_sym___asm] = ACTIONS(111),
    [sym_number_literal] = ACTIONS(3506),
    [anon_sym_L_SQUOTE] = ACTIONS(3508),
    [anon_sym_u_SQUOTE] = ACTIONS(3508),
    [anon_sym_U_SQUOTE] = ACTIONS(3508),
    [anon_sym_u8_SQUOTE] = ACTIONS(3508),
    [anon_sym_SQUOTE] = ACTIONS(3508),
    [anon_sym_L_DQUOTE] = ACTIONS(3510),
    [anon_sym_u_DQUOTE] = ACTIONS(3510),
    [anon_sym_U_DQUOTE] = ACTIONS(3510),
    [anon_sym_u8_DQUOTE] = ACTIONS(3510),
    [anon_sym_DQUOTE] = ACTIONS(3510),
    [sym_true] = ACTIONS(221),
    [sym_false] = ACTIONS(221),
    [anon_sym_NULL] = ACTIONS(121),
    [anon_sym_nullptr] = ACTIONS(121),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_delete] = ACTIONS(3512),
    [anon_sym_R_DQUOTE] = ACTIONS(3514),
    [anon_sym_LR_DQUOTE] = ACTIONS(3514),
    [anon_sym_uR_DQUOTE] = ACTIONS(3514),
    [anon_sym_UR_DQUOTE] = ACTIONS(3514),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3514),
    [anon_sym_co_await] = ACTIONS(3516),
    [anon_sym_new] = ACTIONS(157),
    [anon_sym_requires] = ACTIONS(159),
    [sym_this] = ACTIONS(221),
  },
  [1500] = {
    [sym_identifier] = ACTIONS(4810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4812),
    [anon_sym_COMMA] = ACTIONS(4812),
    [anon_sym_RPAREN] = ACTIONS(4812),
    [anon_sym_LPAREN2] = ACTIONS(4812),
    [anon_sym_TILDE] = ACTIONS(4812),
    [anon_sym_DASH] = ACTIONS(4810),
    [anon_sym_PLUS] = ACTIONS(4810),
    [anon_sym_STAR] = ACTIONS(4810),
    [anon_sym_SLASH] = ACTIONS(4810),
    [anon_sym_PERCENT] = ACTIONS(4810),
    [anon_sym_PIPE_PIPE] = ACTIONS(4812),
    [anon_sym_AMP_AMP] = ACTIONS(4812),
    [anon_sym_PIPE] = ACTIONS(4810),
    [anon_sym_CARET] = ACTIONS(4810),
    [anon_sym_AMP] = ACTIONS(4810),
    [anon_sym_EQ_EQ] = ACTIONS(4812),
    [anon_sym_BANG_EQ] = ACTIONS(4812),
    [anon_sym_GT] = ACTIONS(4810),
    [anon_sym_GT_EQ] = ACTIONS(4812),
    [anon_sym_LT_EQ] = ACTIONS(4810),
    [anon_sym_LT] = ACTIONS(4810),
    [anon_sym_LT_LT] = ACTIONS(4810),
    [anon_sym_GT_GT] = ACTIONS(4810),
    [anon_sym_SEMI] = ACTIONS(4812),
    [anon_sym___extension__] = ACTIONS(4810),
    [anon_sym_virtual] = ACTIONS(4810),
    [anon_sym_extern] = ACTIONS(4810),
    [anon_sym___attribute__] = ACTIONS(4810),
    [anon_sym___attribute] = ACTIONS(4810),
    [anon_sym_COLON_COLON] = ACTIONS(4812),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4812),
    [anon_sym___declspec] = ACTIONS(4810),
    [anon_sym___based] = ACTIONS(4810),
    [anon_sym___cdecl] = ACTIONS(4810),
    [anon_sym___clrcall] = ACTIONS(4810),
    [anon_sym___stdcall] = ACTIONS(4810),
    [anon_sym___fastcall] = ACTIONS(4810),
    [anon_sym___thiscall] = ACTIONS(4810),
    [anon_sym___vectorcall] = ACTIONS(4810),
    [anon_sym_LBRACE] = ACTIONS(4812),
    [anon_sym_RBRACE] = ACTIONS(4812),
    [anon_sym_LBRACK] = ACTIONS(4810),
    [anon_sym_static] = ACTIONS(4810),
    [anon_sym_EQ] = ACTIONS(4810),
    [anon_sym_register] = ACTIONS(4810),
    [anon_sym_inline] = ACTIONS(4810),
    [anon_sym___inline] = ACTIONS(4810),
    [anon_sym___inline__] = ACTIONS(4810),
    [anon_sym___forceinline] = ACTIONS(4810),
    [anon_sym_thread_local] = ACTIONS(4810),
    [anon_sym___thread] = ACTIONS(4810),
    [anon_sym_const] = ACTIONS(4810),
    [anon_sym_constexpr] = ACTIONS(4810),
    [anon_sym_volatile] = ACTIONS(4810),
    [anon_sym_restrict] = ACTIONS(4810),
    [anon_sym___restrict__] = ACTIONS(4810),
    [anon_sym__Atomic] = ACTIONS(4810),
    [anon_sym__Noreturn] = ACTIONS(4810),
    [anon_sym_noreturn] = ACTIONS(4810),
    [anon_sym__Nonnull] = ACTIONS(4810),
    [anon_sym_mutable] = ACTIONS(4810),
    [anon_sym_constinit] = ACTIONS(4810),
    [anon_sym_consteval] = ACTIONS(4810),
    [anon_sym_alignas] = ACTIONS(4810),
    [anon_sym__Alignas] = ACTIONS(4810),
    [anon_sym_QMARK] = ACTIONS(4812),
    [anon_sym_STAR_EQ] = ACTIONS(4812),
    [anon_sym_SLASH_EQ] = ACTIONS(4812),
    [anon_sym_PERCENT_EQ] = ACTIONS(4812),
    [anon_sym_PLUS_EQ] = ACTIONS(4812),
    [anon_sym_DASH_EQ] = ACTIONS(4812),
    [anon_sym_LT_LT_EQ] = ACTIONS(4812),
    [anon_sym_GT_GT_EQ] = ACTIONS(4812),
    [anon_sym_AMP_EQ] = ACTIONS(4812),
    [anon_sym_CARET_EQ] = ACTIONS(4812),
    [anon_sym_PIPE_EQ] = ACTIONS(4812),
    [anon_sym_and_eq] = ACTIONS(4810),
    [anon_sym_or_eq] = ACTIONS(4810),
    [anon_sym_xor_eq] = ACTIONS(4810),
    [anon_sym_LT_EQ_GT] = ACTIONS(4812),
    [anon_sym_or] = ACTIONS(4810),
    [anon_sym_and] = ACTIONS(4810),
    [anon_sym_bitor] = ACTIONS(4810),
    [anon_sym_xor] = ACTIONS(4810),
    [anon_sym_bitand] = ACTIONS(4810),
    [anon_sym_not_eq] = ACTIONS(4810),
    [anon_sym_DASH_DASH] = ACTIONS(4812),
    [anon_sym_PLUS_PLUS] = ACTIONS(4812),
    [anon_sym_DOT] = ACTIONS(4810),
    [anon_sym_DOT_STAR] = ACTIONS(4812),
    [anon_sym_DASH_GT] = ACTIONS(4812),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4810),
    [anon_sym_decltype] = ACTIONS(4810),
    [anon_sym_template] = ACTIONS(4810),
    [anon_sym_operator] = ACTIONS(4810),
  },
  [1501] = {
    [sym_identifier] = ACTIONS(4814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4816),
    [anon_sym_COMMA] = ACTIONS(4816),
    [anon_sym_RPAREN] = ACTIONS(4816),
    [anon_sym_LPAREN2] = ACTIONS(4816),
    [anon_sym_TILDE] = ACTIONS(4816),
    [anon_sym_DASH] = ACTIONS(4814),
    [anon_sym_PLUS] = ACTIONS(4814),
    [anon_sym_STAR] = ACTIONS(4814),
    [anon_sym_SLASH] = ACTIONS(4814),
    [anon_sym_PERCENT] = ACTIONS(4814),
    [anon_sym_PIPE_PIPE] = ACTIONS(4816),
    [anon_sym_AMP_AMP] = ACTIONS(4816),
    [anon_sym_PIPE] = ACTIONS(4814),
    [anon_sym_CARET] = ACTIONS(4814),
    [anon_sym_AMP] = ACTIONS(4814),
    [anon_sym_EQ_EQ] = ACTIONS(4816),
    [anon_sym_BANG_EQ] = ACTIONS(4816),
    [anon_sym_GT] = ACTIONS(4814),
    [anon_sym_GT_EQ] = ACTIONS(4816),
    [anon_sym_LT_EQ] = ACTIONS(4814),
    [anon_sym_LT] = ACTIONS(4814),
    [anon_sym_LT_LT] = ACTIONS(4814),
    [anon_sym_GT_GT] = ACTIONS(4814),
    [anon_sym_SEMI] = ACTIONS(4816),
    [anon_sym___extension__] = ACTIONS(4814),
    [anon_sym_virtual] = ACTIONS(4814),
    [anon_sym_extern] = ACTIONS(4814),
    [anon_sym___attribute__] = ACTIONS(4814),
    [anon_sym___attribute] = ACTIONS(4814),
    [anon_sym_COLON_COLON] = ACTIONS(4816),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4816),
    [anon_sym___declspec] = ACTIONS(4814),
    [anon_sym___based] = ACTIONS(4814),
    [anon_sym___cdecl] = ACTIONS(4814),
    [anon_sym___clrcall] = ACTIONS(4814),
    [anon_sym___stdcall] = ACTIONS(4814),
    [anon_sym___fastcall] = ACTIONS(4814),
    [anon_sym___thiscall] = ACTIONS(4814),
    [anon_sym___vectorcall] = ACTIONS(4814),
    [anon_sym_LBRACE] = ACTIONS(4816),
    [anon_sym_RBRACE] = ACTIONS(4816),
    [anon_sym_LBRACK] = ACTIONS(4814),
    [anon_sym_static] = ACTIONS(4814),
    [anon_sym_EQ] = ACTIONS(4814),
    [anon_sym_register] = ACTIONS(4814),
    [anon_sym_inline] = ACTIONS(4814),
    [anon_sym___inline] = ACTIONS(4814),
    [anon_sym___inline__] = ACTIONS(4814),
    [anon_sym___forceinline] = ACTIONS(4814),
    [anon_sym_thread_local] = ACTIONS(4814),
    [anon_sym___thread] = ACTIONS(4814),
    [anon_sym_const] = ACTIONS(4814),
    [anon_sym_constexpr] = ACTIONS(4814),
    [anon_sym_volatile] = ACTIONS(4814),
    [anon_sym_restrict] = ACTIONS(4814),
    [anon_sym___restrict__] = ACTIONS(4814),
    [anon_sym__Atomic] = ACTIONS(4814),
    [anon_sym__Noreturn] = ACTIONS(4814),
    [anon_sym_noreturn] = ACTIONS(4814),
    [anon_sym__Nonnull] = ACTIONS(4814),
    [anon_sym_mutable] = ACTIONS(4814),
    [anon_sym_constinit] = ACTIONS(4814),
    [anon_sym_consteval] = ACTIONS(4814),
    [anon_sym_alignas] = ACTIONS(4814),
    [anon_sym__Alignas] = ACTIONS(4814),
    [anon_sym_QMARK] = ACTIONS(4816),
    [anon_sym_STAR_EQ] = ACTIONS(4816),
    [anon_sym_SLASH_EQ] = ACTIONS(4816),
    [anon_sym_PERCENT_EQ] = ACTIONS(4816),
    [anon_sym_PLUS_EQ] = ACTIONS(4816),
    [anon_sym_DASH_EQ] = ACTIONS(4816),
    [anon_sym_LT_LT_EQ] = ACTIONS(4816),
    [anon_sym_GT_GT_EQ] = ACTIONS(4816),
    [anon_sym_AMP_EQ] = ACTIONS(4816),
    [anon_sym_CARET_EQ] = ACTIONS(4816),
    [anon_sym_PIPE_EQ] = ACTIONS(4816),
    [anon_sym_and_eq] = ACTIONS(4814),
    [anon_sym_or_eq] = ACTIONS(4814),
    [anon_sym_xor_eq] = ACTIONS(4814),
    [anon_sym_LT_EQ_GT] = ACTIONS(4816),
    [anon_sym_or] = ACTIONS(4814),
    [anon_sym_and] = ACTIONS(4814),
    [anon_sym_bitor] = ACTIONS(4814),
    [anon_sym_xor] = ACTIONS(4814),
    [anon_sym_bitand] = ACTIONS(4814),
    [anon_sym_not_eq] = ACTIONS(4814),
    [anon_sym_DASH_DASH] = ACTIONS(4816),
    [anon_sym_PLUS_PLUS] = ACTIONS(4816),
    [anon_sym_DOT] = ACTIONS(4814),
    [anon_sym_DOT_STAR] = ACTIONS(4816),
    [anon_sym_DASH_GT] = ACTIONS(4816),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4814),
    [anon_sym_decltype] = ACTIONS(4814),
    [anon_sym_template] = ACTIONS(4814),
    [anon_sym_operator] = ACTIONS(4814),
  },
  [1502] = {
    [sym_identifier] = ACTIONS(4818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4820),
    [anon_sym_COMMA] = ACTIONS(4820),
    [anon_sym_RPAREN] = ACTIONS(4820),
    [anon_sym_LPAREN2] = ACTIONS(4820),
    [anon_sym_TILDE] = ACTIONS(4820),
    [anon_sym_DASH] = ACTIONS(4818),
    [anon_sym_PLUS] = ACTIONS(4818),
    [anon_sym_STAR] = ACTIONS(4818),
    [anon_sym_SLASH] = ACTIONS(4818),
    [anon_sym_PERCENT] = ACTIONS(4818),
    [anon_sym_PIPE_PIPE] = ACTIONS(4820),
    [anon_sym_AMP_AMP] = ACTIONS(4820),
    [anon_sym_PIPE] = ACTIONS(4818),
    [anon_sym_CARET] = ACTIONS(4818),
    [anon_sym_AMP] = ACTIONS(4818),
    [anon_sym_EQ_EQ] = ACTIONS(4820),
    [anon_sym_BANG_EQ] = ACTIONS(4820),
    [anon_sym_GT] = ACTIONS(4818),
    [anon_sym_GT_EQ] = ACTIONS(4820),
    [anon_sym_LT_EQ] = ACTIONS(4818),
    [anon_sym_LT] = ACTIONS(4818),
    [anon_sym_LT_LT] = ACTIONS(4818),
    [anon_sym_GT_GT] = ACTIONS(4818),
    [anon_sym_SEMI] = ACTIONS(4820),
    [anon_sym___extension__] = ACTIONS(4818),
    [anon_sym_virtual] = ACTIONS(4818),
    [anon_sym_extern] = ACTIONS(4818),
    [anon_sym___attribute__] = ACTIONS(4818),
    [anon_sym___attribute] = ACTIONS(4818),
    [anon_sym_COLON_COLON] = ACTIONS(4820),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4820),
    [anon_sym___declspec] = ACTIONS(4818),
    [anon_sym___based] = ACTIONS(4818),
    [anon_sym___cdecl] = ACTIONS(4818),
    [anon_sym___clrcall] = ACTIONS(4818),
    [anon_sym___stdcall] = ACTIONS(4818),
    [anon_sym___fastcall] = ACTIONS(4818),
    [anon_sym___thiscall] = ACTIONS(4818),
    [anon_sym___vectorcall] = ACTIONS(4818),
    [anon_sym_LBRACE] = ACTIONS(4820),
    [anon_sym_RBRACE] = ACTIONS(4820),
    [anon_sym_LBRACK] = ACTIONS(4818),
    [anon_sym_static] = ACTIONS(4818),
    [anon_sym_EQ] = ACTIONS(4818),
    [anon_sym_register] = ACTIONS(4818),
    [anon_sym_inline] = ACTIONS(4818),
    [anon_sym___inline] = ACTIONS(4818),
    [anon_sym___inline__] = ACTIONS(4818),
    [anon_sym___forceinline] = ACTIONS(4818),
    [anon_sym_thread_local] = ACTIONS(4818),
    [anon_sym___thread] = ACTIONS(4818),
    [anon_sym_const] = ACTIONS(4818),
    [anon_sym_constexpr] = ACTIONS(4818),
    [anon_sym_volatile] = ACTIONS(4818),
    [anon_sym_restrict] = ACTIONS(4818),
    [anon_sym___restrict__] = ACTIONS(4818),
    [anon_sym__Atomic] = ACTIONS(4818),
    [anon_sym__Noreturn] = ACTIONS(4818),
    [anon_sym_noreturn] = ACTIONS(4818),
    [anon_sym__Nonnull] = ACTIONS(4818),
    [anon_sym_mutable] = ACTIONS(4818),
    [anon_sym_constinit] = ACTIONS(4818),
    [anon_sym_consteval] = ACTIONS(4818),
    [anon_sym_alignas] = ACTIONS(4818),
    [anon_sym__Alignas] = ACTIONS(4818),
    [anon_sym_QMARK] = ACTIONS(4820),
    [anon_sym_STAR_EQ] = ACTIONS(4820),
    [anon_sym_SLASH_EQ] = ACTIONS(4820),
    [anon_sym_PERCENT_EQ] = ACTIONS(4820),
    [anon_sym_PLUS_EQ] = ACTIONS(4820),
    [anon_sym_DASH_EQ] = ACTIONS(4820),
    [anon_sym_LT_LT_EQ] = ACTIONS(4820),
    [anon_sym_GT_GT_EQ] = ACTIONS(4820),
    [anon_sym_AMP_EQ] = ACTIONS(4820),
    [anon_sym_CARET_EQ] = ACTIONS(4820),
    [anon_sym_PIPE_EQ] = ACTIONS(4820),
    [anon_sym_and_eq] = ACTIONS(4818),
    [anon_sym_or_eq] = ACTIONS(4818),
    [anon_sym_xor_eq] = ACTIONS(4818),
    [anon_sym_LT_EQ_GT] = ACTIONS(4820),
    [anon_sym_or] = ACTIONS(4818),
    [anon_sym_and] = ACTIONS(4818),
    [anon_sym_bitor] = ACTIONS(4818),
    [anon_sym_xor] = ACTIONS(4818),
    [anon_sym_bitand] = ACTIONS(4818),
    [anon_sym_not_eq] = ACTIONS(4818),
    [anon_sym_DASH_DASH] = ACTIONS(4820),
    [anon_sym_PLUS_PLUS] = ACTIONS(4820),
    [anon_sym_DOT] = ACTIONS(4818),
    [anon_sym_DOT_STAR] = ACTIONS(4820),
    [anon_sym_DASH_GT] = ACTIONS(4820),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4818),
    [anon_sym_decltype] = ACTIONS(4818),
    [anon_sym_template] = ACTIONS(4818),
    [anon_sym_operator] = ACTIONS(4818),
  },
  [1503] = {
    [sym_identifier] = ACTIONS(4822),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4824),
    [anon_sym_COMMA] = ACTIONS(4824),
    [anon_sym_RPAREN] = ACTIONS(4824),
    [anon_sym_LPAREN2] = ACTIONS(4824),
    [anon_sym_TILDE] = ACTIONS(4824),
    [anon_sym_DASH] = ACTIONS(4822),
    [anon_sym_PLUS] = ACTIONS(4822),
    [anon_sym_STAR] = ACTIONS(4822),
    [anon_sym_SLASH] = ACTIONS(4822),
    [anon_sym_PERCENT] = ACTIONS(4822),
    [anon_sym_PIPE_PIPE] = ACTIONS(4824),
    [anon_sym_AMP_AMP] = ACTIONS(4824),
    [anon_sym_PIPE] = ACTIONS(4822),
    [anon_sym_CARET] = ACTIONS(4822),
    [anon_sym_AMP] = ACTIONS(4822),
    [anon_sym_EQ_EQ] = ACTIONS(4824),
    [anon_sym_BANG_EQ] = ACTIONS(4824),
    [anon_sym_GT] = ACTIONS(4822),
    [anon_sym_GT_EQ] = ACTIONS(4824),
    [anon_sym_LT_EQ] = ACTIONS(4822),
    [anon_sym_LT] = ACTIONS(4822),
    [anon_sym_LT_LT] = ACTIONS(4822),
    [anon_sym_GT_GT] = ACTIONS(4822),
    [anon_sym_SEMI] = ACTIONS(4824),
    [anon_sym___extension__] = ACTIONS(4822),
    [anon_sym_virtual] = ACTIONS(4822),
    [anon_sym_extern] = ACTIONS(4822),
    [anon_sym___attribute__] = ACTIONS(4822),
    [anon_sym___attribute] = ACTIONS(4822),
    [anon_sym_COLON_COLON] = ACTIONS(4824),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4824),
    [anon_sym___declspec] = ACTIONS(4822),
    [anon_sym___based] = ACTIONS(4822),
    [anon_sym___cdecl] = ACTIONS(4822),
    [anon_sym___clrcall] = ACTIONS(4822),
    [anon_sym___stdcall] = ACTIONS(4822),
    [anon_sym___fastcall] = ACTIONS(4822),
    [anon_sym___thiscall] = ACTIONS(4822),
    [anon_sym___vectorcall] = ACTIONS(4822),
    [anon_sym_LBRACE] = ACTIONS(4824),
    [anon_sym_RBRACE] = ACTIONS(4824),
    [anon_sym_LBRACK] = ACTIONS(4822),
    [anon_sym_static] = ACTIONS(4822),
    [anon_sym_EQ] = ACTIONS(4822),
    [anon_sym_register] = ACTIONS(4822),
    [anon_sym_inline] = ACTIONS(4822),
    [anon_sym___inline] = ACTIONS(4822),
    [anon_sym___inline__] = ACTIONS(4822),
    [anon_sym___forceinline] = ACTIONS(4822),
    [anon_sym_thread_local] = ACTIONS(4822),
    [anon_sym___thread] = ACTIONS(4822),
    [anon_sym_const] = ACTIONS(4822),
    [anon_sym_constexpr] = ACTIONS(4822),
    [anon_sym_volatile] = ACTIONS(4822),
    [anon_sym_restrict] = ACTIONS(4822),
    [anon_sym___restrict__] = ACTIONS(4822),
    [anon_sym__Atomic] = ACTIONS(4822),
    [anon_sym__Noreturn] = ACTIONS(4822),
    [anon_sym_noreturn] = ACTIONS(4822),
    [anon_sym__Nonnull] = ACTIONS(4822),
    [anon_sym_mutable] = ACTIONS(4822),
    [anon_sym_constinit] = ACTIONS(4822),
    [anon_sym_consteval] = ACTIONS(4822),
    [anon_sym_alignas] = ACTIONS(4822),
    [anon_sym__Alignas] = ACTIONS(4822),
    [anon_sym_QMARK] = ACTIONS(4824),
    [anon_sym_STAR_EQ] = ACTIONS(4824),
    [anon_sym_SLASH_EQ] = ACTIONS(4824),
    [anon_sym_PERCENT_EQ] = ACTIONS(4824),
    [anon_sym_PLUS_EQ] = ACTIONS(4824),
    [anon_sym_DASH_EQ] = ACTIONS(4824),
    [anon_sym_LT_LT_EQ] = ACTIONS(4824),
    [anon_sym_GT_GT_EQ] = ACTIONS(4824),
    [anon_sym_AMP_EQ] = ACTIONS(4824),
    [anon_sym_CARET_EQ] = ACTIONS(4824),
    [anon_sym_PIPE_EQ] = ACTIONS(4824),
    [anon_sym_and_eq] = ACTIONS(4822),
    [anon_sym_or_eq] = ACTIONS(4822),
    [anon_sym_xor_eq] = ACTIONS(4822),
    [anon_sym_LT_EQ_GT] = ACTIONS(4824),
    [anon_sym_or] = ACTIONS(4822),
    [anon_sym_and] = ACTIONS(4822),
    [anon_sym_bitor] = ACTIONS(4822),
    [anon_sym_xor] = ACTIONS(4822),
    [anon_sym_bitand] = ACTIONS(4822),
    [anon_sym_not_eq] = ACTIONS(4822),
    [anon_sym_DASH_DASH] = ACTIONS(4824),
    [anon_sym_PLUS_PLUS] = ACTIONS(4824),
    [anon_sym_DOT] = ACTIONS(4822),
    [anon_sym_DOT_STAR] = ACTIONS(4824),
    [anon_sym_DASH_GT] = ACTIONS(4824),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4822),
    [anon_sym_decltype] = ACTIONS(4822),
    [anon_sym_template] = ACTIONS(4822),
    [anon_sym_operator] = ACTIONS(4822),
  },
  [1504] = {
    [sym_identifier] = ACTIONS(4826),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4828),
    [anon_sym_COMMA] = ACTIONS(4828),
    [anon_sym_RPAREN] = ACTIONS(4828),
    [anon_sym_LPAREN2] = ACTIONS(4828),
    [anon_sym_TILDE] = ACTIONS(4828),
    [anon_sym_DASH] = ACTIONS(4826),
    [anon_sym_PLUS] = ACTIONS(4826),
    [anon_sym_STAR] = ACTIONS(4826),
    [anon_sym_SLASH] = ACTIONS(4826),
    [anon_sym_PERCENT] = ACTIONS(4826),
    [anon_sym_PIPE_PIPE] = ACTIONS(4828),
    [anon_sym_AMP_AMP] = ACTIONS(4828),
    [anon_sym_PIPE] = ACTIONS(4826),
    [anon_sym_CARET] = ACTIONS(4826),
    [anon_sym_AMP] = ACTIONS(4826),
    [anon_sym_EQ_EQ] = ACTIONS(4828),
    [anon_sym_BANG_EQ] = ACTIONS(4828),
    [anon_sym_GT] = ACTIONS(4826),
    [anon_sym_GT_EQ] = ACTIONS(4828),
    [anon_sym_LT_EQ] = ACTIONS(4826),
    [anon_sym_LT] = ACTIONS(4826),
    [anon_sym_LT_LT] = ACTIONS(4826),
    [anon_sym_GT_GT] = ACTIONS(4826),
    [anon_sym_SEMI] = ACTIONS(4828),
    [anon_sym___extension__] = ACTIONS(4826),
    [anon_sym_virtual] = ACTIONS(4826),
    [anon_sym_extern] = ACTIONS(4826),
    [anon_sym___attribute__] = ACTIONS(4826),
    [anon_sym___attribute] = ACTIONS(4826),
    [anon_sym_COLON_COLON] = ACTIONS(4828),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4828),
    [anon_sym___declspec] = ACTIONS(4826),
    [anon_sym___based] = ACTIONS(4826),
    [anon_sym___cdecl] = ACTIONS(4826),
    [anon_sym___clrcall] = ACTIONS(4826),
    [anon_sym___stdcall] = ACTIONS(4826),
    [anon_sym___fastcall] = ACTIONS(4826),
    [anon_sym___thiscall] = ACTIONS(4826),
    [anon_sym___vectorcall] = ACTIONS(4826),
    [anon_sym_LBRACE] = ACTIONS(4828),
    [anon_sym_RBRACE] = ACTIONS(4828),
    [anon_sym_LBRACK] = ACTIONS(4826),
    [anon_sym_static] = ACTIONS(4826),
    [anon_sym_EQ] = ACTIONS(4826),
    [anon_sym_register] = ACTIONS(4826),
    [anon_sym_inline] = ACTIONS(4826),
    [anon_sym___inline] = ACTIONS(4826),
    [anon_sym___inline__] = ACTIONS(4826),
    [anon_sym___forceinline] = ACTIONS(4826),
    [anon_sym_thread_local] = ACTIONS(4826),
    [anon_sym___thread] = ACTIONS(4826),
    [anon_sym_const] = ACTIONS(4826),
    [anon_sym_constexpr] = ACTIONS(4826),
    [anon_sym_volatile] = ACTIONS(4826),
    [anon_sym_restrict] = ACTIONS(4826),
    [anon_sym___restrict__] = ACTIONS(4826),
    [anon_sym__Atomic] = ACTIONS(4826),
    [anon_sym__Noreturn] = ACTIONS(4826),
    [anon_sym_noreturn] = ACTIONS(4826),
    [anon_sym__Nonnull] = ACTIONS(4826),
    [anon_sym_mutable] = ACTIONS(4826),
    [anon_sym_constinit] = ACTIONS(4826),
    [anon_sym_consteval] = ACTIONS(4826),
    [anon_sym_alignas] = ACTIONS(4826),
    [anon_sym__Alignas] = ACTIONS(4826),
    [anon_sym_QMARK] = ACTIONS(4828),
    [anon_sym_STAR_EQ] = ACTIONS(4828),
    [anon_sym_SLASH_EQ] = ACTIONS(4828),
    [anon_sym_PERCENT_EQ] = ACTIONS(4828),
    [anon_sym_PLUS_EQ] = ACTIONS(4828),
    [anon_sym_DASH_EQ] = ACTIONS(4828),
    [anon_sym_LT_LT_EQ] = ACTIONS(4828),
    [anon_sym_GT_GT_EQ] = ACTIONS(4828),
    [anon_sym_AMP_EQ] = ACTIONS(4828),
    [anon_sym_CARET_EQ] = ACTIONS(4828),
    [anon_sym_PIPE_EQ] = ACTIONS(4828),
    [anon_sym_and_eq] = ACTIONS(4826),
    [anon_sym_or_eq] = ACTIONS(4826),
    [anon_sym_xor_eq] = ACTIONS(4826),
    [anon_sym_LT_EQ_GT] = ACTIONS(4828),
    [anon_sym_or] = ACTIONS(4826),
    [anon_sym_and] = ACTIONS(4826),
    [anon_sym_bitor] = ACTIONS(4826),
    [anon_sym_xor] = ACTIONS(4826),
    [anon_sym_bitand] = ACTIONS(4826),
    [anon_sym_not_eq] = ACTIONS(4826),
    [anon_sym_DASH_DASH] = ACTIONS(4828),
    [anon_sym_PLUS_PLUS] = ACTIONS(4828),
    [anon_sym_DOT] = ACTIONS(4826),
    [anon_sym_DOT_STAR] = ACTIONS(4828),
    [anon_sym_DASH_GT] = ACTIONS(4828),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4826),
    [anon_sym_decltype] = ACTIONS(4826),
    [anon_sym_template] = ACTIONS(4826),
    [anon_sym_operator] = ACTIONS(4826),
  },
  [1505] = {
    [sym_identifier] = ACTIONS(4830),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4832),
    [anon_sym_COMMA] = ACTIONS(4832),
    [anon_sym_RPAREN] = ACTIONS(4832),
    [anon_sym_LPAREN2] = ACTIONS(4832),
    [anon_sym_TILDE] = ACTIONS(4832),
    [anon_sym_DASH] = ACTIONS(4830),
    [anon_sym_PLUS] = ACTIONS(4830),
    [anon_sym_STAR] = ACTIONS(4830),
    [anon_sym_SLASH] = ACTIONS(4830),
    [anon_sym_PERCENT] = ACTIONS(4830),
    [anon_sym_PIPE_PIPE] = ACTIONS(4832),
    [anon_sym_AMP_AMP] = ACTIONS(4832),
    [anon_sym_PIPE] = ACTIONS(4830),
    [anon_sym_CARET] = ACTIONS(4830),
    [anon_sym_AMP] = ACTIONS(4830),
    [anon_sym_EQ_EQ] = ACTIONS(4832),
    [anon_sym_BANG_EQ] = ACTIONS(4832),
    [anon_sym_GT] = ACTIONS(4830),
    [anon_sym_GT_EQ] = ACTIONS(4832),
    [anon_sym_LT_EQ] = ACTIONS(4830),
    [anon_sym_LT] = ACTIONS(4830),
    [anon_sym_LT_LT] = ACTIONS(4830),
    [anon_sym_GT_GT] = ACTIONS(4830),
    [anon_sym_SEMI] = ACTIONS(4832),
    [anon_sym___extension__] = ACTIONS(4830),
    [anon_sym_virtual] = ACTIONS(4830),
    [anon_sym_extern] = ACTIONS(4830),
    [anon_sym___attribute__] = ACTIONS(4830),
    [anon_sym___attribute] = ACTIONS(4830),
    [anon_sym_COLON_COLON] = ACTIONS(4832),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4832),
    [anon_sym___declspec] = ACTIONS(4830),
    [anon_sym___based] = ACTIONS(4830),
    [anon_sym___cdecl] = ACTIONS(4830),
    [anon_sym___clrcall] = ACTIONS(4830),
    [anon_sym___stdcall] = ACTIONS(4830),
    [anon_sym___fastcall] = ACTIONS(4830),
    [anon_sym___thiscall] = ACTIONS(4830),
    [anon_sym___vectorcall] = ACTIONS(4830),
    [anon_sym_LBRACE] = ACTIONS(4832),
    [anon_sym_RBRACE] = ACTIONS(4832),
    [anon_sym_LBRACK] = ACTIONS(4830),
    [anon_sym_static] = ACTIONS(4830),
    [anon_sym_EQ] = ACTIONS(4830),
    [anon_sym_register] = ACTIONS(4830),
    [anon_sym_inline] = ACTIONS(4830),
    [anon_sym___inline] = ACTIONS(4830),
    [anon_sym___inline__] = ACTIONS(4830),
    [anon_sym___forceinline] = ACTIONS(4830),
    [anon_sym_thread_local] = ACTIONS(4830),
    [anon_sym___thread] = ACTIONS(4830),
    [anon_sym_const] = ACTIONS(4830),
    [anon_sym_constexpr] = ACTIONS(4830),
    [anon_sym_volatile] = ACTIONS(4830),
    [anon_sym_restrict] = ACTIONS(4830),
    [anon_sym___restrict__] = ACTIONS(4830),
    [anon_sym__Atomic] = ACTIONS(4830),
    [anon_sym__Noreturn] = ACTIONS(4830),
    [anon_sym_noreturn] = ACTIONS(4830),
    [anon_sym__Nonnull] = ACTIONS(4830),
    [anon_sym_mutable] = ACTIONS(4830),
    [anon_sym_constinit] = ACTIONS(4830),
    [anon_sym_consteval] = ACTIONS(4830),
    [anon_sym_alignas] = ACTIONS(4830),
    [anon_sym__Alignas] = ACTIONS(4830),
    [anon_sym_QMARK] = ACTIONS(4832),
    [anon_sym_STAR_EQ] = ACTIONS(4832),
    [anon_sym_SLASH_EQ] = ACTIONS(4832),
    [anon_sym_PERCENT_EQ] = ACTIONS(4832),
    [anon_sym_PLUS_EQ] = ACTIONS(4832),
    [anon_sym_DASH_EQ] = ACTIONS(4832),
    [anon_sym_LT_LT_EQ] = ACTIONS(4832),
    [anon_sym_GT_GT_EQ] = ACTIONS(4832),
    [anon_sym_AMP_EQ] = ACTIONS(4832),
    [anon_sym_CARET_EQ] = ACTIONS(4832),
    [anon_sym_PIPE_EQ] = ACTIONS(4832),
    [anon_sym_and_eq] = ACTIONS(4830),
    [anon_sym_or_eq] = ACTIONS(4830),
    [anon_sym_xor_eq] = ACTIONS(4830),
    [anon_sym_LT_EQ_GT] = ACTIONS(4832),
    [anon_sym_or] = ACTIONS(4830),
    [anon_sym_and] = ACTIONS(4830),
    [anon_sym_bitor] = ACTIONS(4830),
    [anon_sym_xor] = ACTIONS(4830),
    [anon_sym_bitand] = ACTIONS(4830),
    [anon_sym_not_eq] = ACTIONS(4830),
    [anon_sym_DASH_DASH] = ACTIONS(4832),
    [anon_sym_PLUS_PLUS] = ACTIONS(4832),
    [anon_sym_DOT] = ACTIONS(4830),
    [anon_sym_DOT_STAR] = ACTIONS(4832),
    [anon_sym_DASH_GT] = ACTIONS(4832),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4830),
    [anon_sym_decltype] = ACTIONS(4830),
    [anon_sym_template] = ACTIONS(4830),
    [anon_sym_operator] = ACTIONS(4830),
  },
  [1506] = {
    [sym_identifier] = ACTIONS(4834),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4836),
    [anon_sym_COMMA] = ACTIONS(4836),
    [anon_sym_RPAREN] = ACTIONS(4836),
    [anon_sym_LPAREN2] = ACTIONS(4836),
    [anon_sym_TILDE] = ACTIONS(4836),
    [anon_sym_DASH] = ACTIONS(4834),
    [anon_sym_PLUS] = ACTIONS(4834),
    [anon_sym_STAR] = ACTIONS(4834),
    [anon_sym_SLASH] = ACTIONS(4834),
    [anon_sym_PERCENT] = ACTIONS(4834),
    [anon_sym_PIPE_PIPE] = ACTIONS(4836),
    [anon_sym_AMP_AMP] = ACTIONS(4836),
    [anon_sym_PIPE] = ACTIONS(4834),
    [anon_sym_CARET] = ACTIONS(4834),
    [anon_sym_AMP] = ACTIONS(4834),
    [anon_sym_EQ_EQ] = ACTIONS(4836),
    [anon_sym_BANG_EQ] = ACTIONS(4836),
    [anon_sym_GT] = ACTIONS(4834),
    [anon_sym_GT_EQ] = ACTIONS(4836),
    [anon_sym_LT_EQ] = ACTIONS(4834),
    [anon_sym_LT] = ACTIONS(4834),
    [anon_sym_LT_LT] = ACTIONS(4834),
    [anon_sym_GT_GT] = ACTIONS(4834),
    [anon_sym_SEMI] = ACTIONS(4836),
    [anon_sym___extension__] = ACTIONS(4834),
    [anon_sym_virtual] = ACTIONS(4834),
    [anon_sym_extern] = ACTIONS(4834),
    [anon_sym___attribute__] = ACTIONS(4834),
    [anon_sym___attribute] = ACTIONS(4834),
    [anon_sym_COLON_COLON] = ACTIONS(4836),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4836),
    [anon_sym___declspec] = ACTIONS(4834),
    [anon_sym___based] = ACTIONS(4834),
    [anon_sym___cdecl] = ACTIONS(4834),
    [anon_sym___clrcall] = ACTIONS(4834),
    [anon_sym___stdcall] = ACTIONS(4834),
    [anon_sym___fastcall] = ACTIONS(4834),
    [anon_sym___thiscall] = ACTIONS(4834),
    [anon_sym___vectorcall] = ACTIONS(4834),
    [anon_sym_LBRACE] = ACTIONS(4836),
    [anon_sym_RBRACE] = ACTIONS(4836),
    [anon_sym_LBRACK] = ACTIONS(4834),
    [anon_sym_static] = ACTIONS(4834),
    [anon_sym_EQ] = ACTIONS(4834),
    [anon_sym_register] = ACTIONS(4834),
    [anon_sym_inline] = ACTIONS(4834),
    [anon_sym___inline] = ACTIONS(4834),
    [anon_sym___inline__] = ACTIONS(4834),
    [anon_sym___forceinline] = ACTIONS(4834),
    [anon_sym_thread_local] = ACTIONS(4834),
    [anon_sym___thread] = ACTIONS(4834),
    [anon_sym_const] = ACTIONS(4834),
    [anon_sym_constexpr] = ACTIONS(4834),
    [anon_sym_volatile] = ACTIONS(4834),
    [anon_sym_restrict] = ACTIONS(4834),
    [anon_sym___restrict__] = ACTIONS(4834),
    [anon_sym__Atomic] = ACTIONS(4834),
    [anon_sym__Noreturn] = ACTIONS(4834),
    [anon_sym_noreturn] = ACTIONS(4834),
    [anon_sym__Nonnull] = ACTIONS(4834),
    [anon_sym_mutable] = ACTIONS(4834),
    [anon_sym_constinit] = ACTIONS(4834),
    [anon_sym_consteval] = ACTIONS(4834),
    [anon_sym_alignas] = ACTIONS(4834),
    [anon_sym__Alignas] = ACTIONS(4834),
    [anon_sym_QMARK] = ACTIONS(4836),
    [anon_sym_STAR_EQ] = ACTIONS(4836),
    [anon_sym_SLASH_EQ] = ACTIONS(4836),
    [anon_sym_PERCENT_EQ] = ACTIONS(4836),
    [anon_sym_PLUS_EQ] = ACTIONS(4836),
    [anon_sym_DASH_EQ] = ACTIONS(4836),
    [anon_sym_LT_LT_EQ] = ACTIONS(4836),
    [anon_sym_GT_GT_EQ] = ACTIONS(4836),
    [anon_sym_AMP_EQ] = ACTIONS(4836),
    [anon_sym_CARET_EQ] = ACTIONS(4836),
    [anon_sym_PIPE_EQ] = ACTIONS(4836),
    [anon_sym_and_eq] = ACTIONS(4834),
    [anon_sym_or_eq] = ACTIONS(4834),
    [anon_sym_xor_eq] = ACTIONS(4834),
    [anon_sym_LT_EQ_GT] = ACTIONS(4836),
    [anon_sym_or] = ACTIONS(4834),
    [anon_sym_and] = ACTIONS(4834),
    [anon_sym_bitor] = ACTIONS(4834),
    [anon_sym_xor] = ACTIONS(4834),
    [anon_sym_bitand] = ACTIONS(4834),
    [anon_sym_not_eq] = ACTIONS(4834),
    [anon_sym_DASH_DASH] = ACTIONS(4836),
    [anon_sym_PLUS_PLUS] = ACTIONS(4836),
    [anon_sym_DOT] = ACTIONS(4834),
    [anon_sym_DOT_STAR] = ACTIONS(4836),
    [anon_sym_DASH_GT] = ACTIONS(4836),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4834),
    [anon_sym_decltype] = ACTIONS(4834),
    [anon_sym_template] = ACTIONS(4834),
    [anon_sym_operator] = ACTIONS(4834),
  },
  [1507] = {
    [sym_template_argument_list] = STATE(1508),
    [sym_identifier] = ACTIONS(4838),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4840),
    [anon_sym_COMMA] = ACTIONS(4840),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_TILDE] = ACTIONS(4845),
    [anon_sym_DASH] = ACTIONS(4847),
    [anon_sym_PLUS] = ACTIONS(4847),
    [anon_sym_STAR] = ACTIONS(4849),
    [anon_sym_SLASH] = ACTIONS(4847),
    [anon_sym_PERCENT] = ACTIONS(4847),
    [anon_sym_PIPE_PIPE] = ACTIONS(4840),
    [anon_sym_AMP_AMP] = ACTIONS(4842),
    [anon_sym_PIPE] = ACTIONS(4847),
    [anon_sym_CARET] = ACTIONS(4847),
    [anon_sym_AMP] = ACTIONS(4849),
    [anon_sym_EQ_EQ] = ACTIONS(4840),
    [anon_sym_BANG_EQ] = ACTIONS(4840),
    [anon_sym_GT] = ACTIONS(4847),
    [anon_sym_GT_EQ] = ACTIONS(4840),
    [anon_sym_LT_EQ] = ACTIONS(4847),
    [anon_sym_LT] = ACTIONS(4852),
    [anon_sym_LT_LT] = ACTIONS(4847),
    [anon_sym_GT_GT] = ACTIONS(4847),
    [anon_sym_SEMI] = ACTIONS(4842),
    [anon_sym___extension__] = ACTIONS(4838),
    [anon_sym_virtual] = ACTIONS(4838),
    [anon_sym_extern] = ACTIONS(4838),
    [anon_sym___attribute__] = ACTIONS(4838),
    [anon_sym___attribute] = ACTIONS(4838),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4842),
    [anon_sym___declspec] = ACTIONS(4838),
    [anon_sym___based] = ACTIONS(4838),
    [anon_sym___cdecl] = ACTIONS(4838),
    [anon_sym___clrcall] = ACTIONS(4838),
    [anon_sym___stdcall] = ACTIONS(4838),
    [anon_sym___fastcall] = ACTIONS(4838),
    [anon_sym___thiscall] = ACTIONS(4838),
    [anon_sym___vectorcall] = ACTIONS(4838),
    [anon_sym_LBRACE] = ACTIONS(4845),
    [anon_sym_RBRACE] = ACTIONS(4840),
    [anon_sym_LBRACK] = ACTIONS(4849),
    [anon_sym_static] = ACTIONS(4838),
    [anon_sym_EQ] = ACTIONS(4847),
    [anon_sym_register] = ACTIONS(4838),
    [anon_sym_inline] = ACTIONS(4838),
    [anon_sym___inline] = ACTIONS(4838),
    [anon_sym___inline__] = ACTIONS(4838),
    [anon_sym___forceinline] = ACTIONS(4838),
    [anon_sym_thread_local] = ACTIONS(4838),
    [anon_sym___thread] = ACTIONS(4838),
    [anon_sym_const] = ACTIONS(4838),
    [anon_sym_constexpr] = ACTIONS(4838),
    [anon_sym_volatile] = ACTIONS(4838),
    [anon_sym_restrict] = ACTIONS(4838),
    [anon_sym___restrict__] = ACTIONS(4838),
    [anon_sym__Atomic] = ACTIONS(4838),
    [anon_sym__Noreturn] = ACTIONS(4838),
    [anon_sym_noreturn] = ACTIONS(4838),
    [anon_sym__Nonnull] = ACTIONS(4838),
    [anon_sym_mutable] = ACTIONS(4838),
    [anon_sym_constinit] = ACTIONS(4838),
    [anon_sym_consteval] = ACTIONS(4838),
    [anon_sym_alignas] = ACTIONS(4838),
    [anon_sym__Alignas] = ACTIONS(4838),
    [anon_sym_QMARK] = ACTIONS(4840),
    [anon_sym_STAR_EQ] = ACTIONS(4840),
    [anon_sym_SLASH_EQ] = ACTIONS(4840),
    [anon_sym_PERCENT_EQ] = ACTIONS(4840),
    [anon_sym_PLUS_EQ] = ACTIONS(4840),
    [anon_sym_DASH_EQ] = ACTIONS(4840),
    [anon_sym_LT_LT_EQ] = ACTIONS(4840),
    [anon_sym_GT_GT_EQ] = ACTIONS(4840),
    [anon_sym_AMP_EQ] = ACTIONS(4840),
    [anon_sym_CARET_EQ] = ACTIONS(4840),
    [anon_sym_PIPE_EQ] = ACTIONS(4840),
    [anon_sym_and_eq] = ACTIONS(4847),
    [anon_sym_or_eq] = ACTIONS(4847),
    [anon_sym_xor_eq] = ACTIONS(4847),
    [anon_sym_LT_EQ_GT] = ACTIONS(4840),
    [anon_sym_or] = ACTIONS(4847),
    [anon_sym_and] = ACTIONS(4847),
    [anon_sym_bitor] = ACTIONS(4847),
    [anon_sym_xor] = ACTIONS(4847),
    [anon_sym_bitand] = ACTIONS(4847),
    [anon_sym_not_eq] = ACTIONS(4847),
    [anon_sym_DASH_DASH] = ACTIONS(4840),
    [anon_sym_PLUS_PLUS] = ACTIONS(4840),
    [anon_sym_DOT] = ACTIONS(4847),
    [anon_sym_DOT_STAR] = ACTIONS(4840),
    [anon_sym_DASH_GT] = ACTIONS(4840),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4838),
    [anon_sym_decltype] = ACTIONS(4838),
    [anon_sym_template] = ACTIONS(4838),
    [anon_sym_operator] = ACTIONS(4838),
  },
  [1508] = {
    [sym_identifier] = ACTIONS(4855),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4857),
    [anon_sym_COMMA] = ACTIONS(4857),
    [anon_sym_LPAREN2] = ACTIONS(4859),
    [anon_sym_TILDE] = ACTIONS(4862),
    [anon_sym_DASH] = ACTIONS(4864),
    [anon_sym_PLUS] = ACTIONS(4864),
    [anon_sym_STAR] = ACTIONS(4866),
    [anon_sym_SLASH] = ACTIONS(4864),
    [anon_sym_PERCENT] = ACTIONS(4864),
    [anon_sym_PIPE_PIPE] = ACTIONS(4857),
    [anon_sym_AMP_AMP] = ACTIONS(4859),
    [anon_sym_PIPE] = ACTIONS(4864),
    [anon_sym_CARET] = ACTIONS(4864),
    [anon_sym_AMP] = ACTIONS(4866),
    [anon_sym_EQ_EQ] = ACTIONS(4857),
    [anon_sym_BANG_EQ] = ACTIONS(4857),
    [anon_sym_GT] = ACTIONS(4864),
    [anon_sym_GT_EQ] = ACTIONS(4857),
    [anon_sym_LT_EQ] = ACTIONS(4864),
    [anon_sym_LT] = ACTIONS(4864),
    [anon_sym_LT_LT] = ACTIONS(4864),
    [anon_sym_GT_GT] = ACTIONS(4864),
    [anon_sym_SEMI] = ACTIONS(4859),
    [anon_sym___extension__] = ACTIONS(4855),
    [anon_sym_virtual] = ACTIONS(4855),
    [anon_sym_extern] = ACTIONS(4855),
    [anon_sym___attribute__] = ACTIONS(4855),
    [anon_sym___attribute] = ACTIONS(4855),
    [anon_sym_COLON_COLON] = ACTIONS(4862),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4859),
    [anon_sym___declspec] = ACTIONS(4855),
    [anon_sym___based] = ACTIONS(4855),
    [anon_sym___cdecl] = ACTIONS(4855),
    [anon_sym___clrcall] = ACTIONS(4855),
    [anon_sym___stdcall] = ACTIONS(4855),
    [anon_sym___fastcall] = ACTIONS(4855),
    [anon_sym___thiscall] = ACTIONS(4855),
    [anon_sym___vectorcall] = ACTIONS(4855),
    [anon_sym_LBRACE] = ACTIONS(4862),
    [anon_sym_RBRACE] = ACTIONS(4857),
    [anon_sym_LBRACK] = ACTIONS(4866),
    [anon_sym_static] = ACTIONS(4855),
    [anon_sym_EQ] = ACTIONS(4864),
    [anon_sym_register] = ACTIONS(4855),
    [anon_sym_inline] = ACTIONS(4855),
    [anon_sym___inline] = ACTIONS(4855),
    [anon_sym___inline__] = ACTIONS(4855),
    [anon_sym___forceinline] = ACTIONS(4855),
    [anon_sym_thread_local] = ACTIONS(4855),
    [anon_sym___thread] = ACTIONS(4855),
    [anon_sym_const] = ACTIONS(4855),
    [anon_sym_constexpr] = ACTIONS(4855),
    [anon_sym_volatile] = ACTIONS(4855),
    [anon_sym_restrict] = ACTIONS(4855),
    [anon_sym___restrict__] = ACTIONS(4855),
    [anon_sym__Atomic] = ACTIONS(4855),
    [anon_sym__Noreturn] = ACTIONS(4855),
    [anon_sym_noreturn] = ACTIONS(4855),
    [anon_sym__Nonnull] = ACTIONS(4855),
    [anon_sym_mutable] = ACTIONS(4855),
    [anon_sym_constinit] = ACTIONS(4855),
    [anon_sym_consteval] = ACTIONS(4855),
    [anon_sym_alignas] = ACTIONS(4855),
    [anon_sym__Alignas] = ACTIONS(4855),
    [anon_sym_QMARK] = ACTIONS(4857),
    [anon_sym_STAR_EQ] = ACTIONS(4857),
    [anon_sym_SLASH_EQ] = ACTIONS(4857),
    [anon_sym_PERCENT_EQ] = ACTIONS(4857),
    [anon_sym_PLUS_EQ] = ACTIONS(4857),
    [anon_sym_DASH_EQ] = ACTIONS(4857),
    [anon_sym_LT_LT_EQ] = ACTIONS(4857),
    [anon_sym_GT_GT_EQ] = ACTIONS(4857),
    [anon_sym_AMP_EQ] = ACTIONS(4857),
    [anon_sym_CARET_EQ] = ACTIONS(4857),
    [anon_sym_PIPE_EQ] = ACTIONS(4857),
    [anon_sym_and_eq] = ACTIONS(4864),
    [anon_sym_or_eq] = ACTIONS(4864),
    [anon_sym_xor_eq] = ACTIONS(4864),
    [anon_sym_LT_EQ_GT] = ACTIONS(4857),
    [anon_sym_or] = ACTIONS(4864),
    [anon_sym_and] = ACTIONS(4864),
    [anon_sym_bitor] = ACTIONS(4864),
    [anon_sym_xor] = ACTIONS(4864),
    [anon_sym_bitand] = ACTIONS(4864),
    [anon_sym_not_eq] = ACTIONS(4864),
    [anon_sym_DASH_DASH] = ACTIONS(4857),
    [anon_sym_PLUS_PLUS] = ACTIONS(4857),
    [anon_sym_DOT] = ACTIONS(4864),
    [anon_sym_DOT_STAR] = ACTIONS(4857),
    [anon_sym_DASH_GT] = ACTIONS(4857),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4855),
    [anon_sym_decltype] = ACTIONS(4855),
    [anon_sym_template] = ACTIONS(4855),
    [anon_sym_operator] = ACTIONS(4855),
  },
  [1509] = {
    [sym__declaration_modifiers] = STATE(2045),
    [sym__declaration_specifiers] = STATE(3895),
    [sym_attribute_specifier] = STATE(2045),
    [sym_attribute_declaration] = STATE(2045),
    [sym_ms_declspec_modifier] = STATE(2045),
    [sym_ms_call_modifier] = STATE(6249),
    [sym__abstract_declarator] = STATE(6733),
    [sym_abstract_parenthesized_declarator] = STATE(5942),
    [sym_abstract_pointer_declarator] = STATE(5942),
    [sym_abstract_function_declarator] = STATE(5942),
    [sym_abstract_array_declarator] = STATE(5942),
    [sym_storage_class_specifier] = STATE(2045),
    [sym_type_qualifier] = STATE(2045),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_parameter_list] = STATE(3055),
    [sym_parameter_declaration] = STATE(7110),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_dependent_type] = STATE(2383),
    [sym_optional_parameter_declaration] = STATE(7110),
    [sym_variadic_parameter_declaration] = STATE(7110),
    [sym_abstract_reference_declarator] = STATE(5942),
    [sym__function_declarator_seq] = STATE(5919),
    [sym_template_type] = STATE(2336),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(6511),
    [sym_qualified_type_identifier] = STATE(2978),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2045),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(4869),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1901),
    [anon_sym_RPAREN] = ACTIONS(4155),
    [anon_sym_LPAREN2] = ACTIONS(4871),
    [anon_sym_STAR] = ACTIONS(4873),
    [anon_sym_AMP_AMP] = ACTIONS(4875),
    [anon_sym_AMP] = ACTIONS(4877),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(1851),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4879),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(1779),
    [anon_sym___clrcall] = ACTIONS(1779),
    [anon_sym___stdcall] = ACTIONS(1779),
    [anon_sym___fastcall] = ACTIONS(1779),
    [anon_sym___thiscall] = ACTIONS(1779),
    [anon_sym___vectorcall] = ACTIONS(1779),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(4881),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(1857),
    [anon_sym_class] = ACTIONS(1859),
    [anon_sym_struct] = ACTIONS(1861),
    [anon_sym_union] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(1887),
    [anon_sym_template] = ACTIONS(1235),
  },
  [1510] = {
    [sym__declaration_modifiers] = STATE(2045),
    [sym__declaration_specifiers] = STATE(3895),
    [sym_attribute_specifier] = STATE(2045),
    [sym_attribute_declaration] = STATE(2045),
    [sym_ms_declspec_modifier] = STATE(2045),
    [sym_ms_call_modifier] = STATE(6207),
    [sym__abstract_declarator] = STATE(6752),
    [sym_abstract_parenthesized_declarator] = STATE(5942),
    [sym_abstract_pointer_declarator] = STATE(5942),
    [sym_abstract_function_declarator] = STATE(5942),
    [sym_abstract_array_declarator] = STATE(5942),
    [sym_storage_class_specifier] = STATE(2045),
    [sym_type_qualifier] = STATE(2045),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_parameter_list] = STATE(3055),
    [sym_parameter_declaration] = STATE(7110),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_dependent_type] = STATE(2383),
    [sym_optional_parameter_declaration] = STATE(7110),
    [sym_variadic_parameter_declaration] = STATE(7110),
    [sym_abstract_reference_declarator] = STATE(5942),
    [sym__function_declarator_seq] = STATE(5919),
    [sym_template_type] = STATE(2336),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(6511),
    [sym_qualified_type_identifier] = STATE(2978),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2045),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(4869),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1901),
    [anon_sym_RPAREN] = ACTIONS(4155),
    [anon_sym_LPAREN2] = ACTIONS(4871),
    [anon_sym_STAR] = ACTIONS(4873),
    [anon_sym_AMP_AMP] = ACTIONS(4875),
    [anon_sym_AMP] = ACTIONS(4877),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(1851),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4879),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(1779),
    [anon_sym___clrcall] = ACTIONS(1779),
    [anon_sym___stdcall] = ACTIONS(1779),
    [anon_sym___fastcall] = ACTIONS(1779),
    [anon_sym___thiscall] = ACTIONS(1779),
    [anon_sym___vectorcall] = ACTIONS(1779),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(4881),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(1857),
    [anon_sym_class] = ACTIONS(1859),
    [anon_sym_struct] = ACTIONS(1861),
    [anon_sym_union] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(1887),
    [anon_sym_template] = ACTIONS(1235),
  },
  [1511] = {
    [sym_identifier] = ACTIONS(2763),
    [anon_sym_LPAREN2] = ACTIONS(2765),
    [anon_sym_BANG] = ACTIONS(2765),
    [anon_sym_TILDE] = ACTIONS(2765),
    [anon_sym_DASH] = ACTIONS(2763),
    [anon_sym_PLUS] = ACTIONS(2763),
    [anon_sym_STAR] = ACTIONS(2765),
    [anon_sym_AMP] = ACTIONS(2765),
    [anon_sym___extension__] = ACTIONS(2763),
    [anon_sym_virtual] = ACTIONS(2763),
    [anon_sym_extern] = ACTIONS(2763),
    [anon_sym___attribute__] = ACTIONS(2763),
    [anon_sym___attribute] = ACTIONS(2763),
    [anon_sym_COLON_COLON] = ACTIONS(2765),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2765),
    [anon_sym___declspec] = ACTIONS(2763),
    [anon_sym_signed] = ACTIONS(2763),
    [anon_sym_unsigned] = ACTIONS(2763),
    [anon_sym_long] = ACTIONS(2763),
    [anon_sym_short] = ACTIONS(2763),
    [anon_sym_LBRACK] = ACTIONS(2763),
    [anon_sym_static] = ACTIONS(2763),
    [anon_sym_register] = ACTIONS(2763),
    [anon_sym_inline] = ACTIONS(2763),
    [anon_sym___inline] = ACTIONS(2763),
    [anon_sym___inline__] = ACTIONS(2763),
    [anon_sym___forceinline] = ACTIONS(2763),
    [anon_sym_thread_local] = ACTIONS(2763),
    [anon_sym___thread] = ACTIONS(2763),
    [anon_sym_const] = ACTIONS(2763),
    [anon_sym_constexpr] = ACTIONS(2763),
    [anon_sym_volatile] = ACTIONS(2763),
    [anon_sym_restrict] = ACTIONS(2763),
    [anon_sym___restrict__] = ACTIONS(2763),
    [anon_sym__Atomic] = ACTIONS(2763),
    [anon_sym__Noreturn] = ACTIONS(2763),
    [anon_sym_noreturn] = ACTIONS(2763),
    [anon_sym__Nonnull] = ACTIONS(2763),
    [anon_sym_mutable] = ACTIONS(2763),
    [anon_sym_constinit] = ACTIONS(2763),
    [anon_sym_consteval] = ACTIONS(2763),
    [anon_sym_alignas] = ACTIONS(2763),
    [anon_sym__Alignas] = ACTIONS(2763),
    [sym_primitive_type] = ACTIONS(2763),
    [anon_sym_enum] = ACTIONS(2763),
    [anon_sym_class] = ACTIONS(2763),
    [anon_sym_struct] = ACTIONS(2763),
    [anon_sym_union] = ACTIONS(2763),
    [anon_sym_not] = ACTIONS(2763),
    [anon_sym_compl] = ACTIONS(2763),
    [anon_sym_DASH_DASH] = ACTIONS(2765),
    [anon_sym_PLUS_PLUS] = ACTIONS(2765),
    [anon_sym_sizeof] = ACTIONS(2763),
    [anon_sym___alignof__] = ACTIONS(2763),
    [anon_sym___alignof] = ACTIONS(2763),
    [anon_sym__alignof] = ACTIONS(2763),
    [anon_sym_alignof] = ACTIONS(2763),
    [anon_sym__Alignof] = ACTIONS(2763),
    [anon_sym_offsetof] = ACTIONS(2763),
    [anon_sym__Generic] = ACTIONS(2763),
    [anon_sym_asm] = ACTIONS(2763),
    [anon_sym___asm__] = ACTIONS(2763),
    [anon_sym___asm] = ACTIONS(2763),
    [sym_number_literal] = ACTIONS(2765),
    [anon_sym_L_SQUOTE] = ACTIONS(2765),
    [anon_sym_u_SQUOTE] = ACTIONS(2765),
    [anon_sym_U_SQUOTE] = ACTIONS(2765),
    [anon_sym_u8_SQUOTE] = ACTIONS(2765),
    [anon_sym_SQUOTE] = ACTIONS(2765),
    [anon_sym_L_DQUOTE] = ACTIONS(2765),
    [anon_sym_u_DQUOTE] = ACTIONS(2765),
    [anon_sym_U_DQUOTE] = ACTIONS(2765),
    [anon_sym_u8_DQUOTE] = ACTIONS(2765),
    [anon_sym_DQUOTE] = ACTIONS(2765),
    [sym_true] = ACTIONS(2763),
    [sym_false] = ACTIONS(2763),
    [anon_sym_NULL] = ACTIONS(2763),
    [anon_sym_nullptr] = ACTIONS(2763),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2763),
    [anon_sym_decltype] = ACTIONS(2763),
    [anon_sym_typename] = ACTIONS(2763),
    [anon_sym_template] = ACTIONS(2763),
    [anon_sym_delete] = ACTIONS(2763),
    [anon_sym_R_DQUOTE] = ACTIONS(2765),
    [anon_sym_LR_DQUOTE] = ACTIONS(2765),
    [anon_sym_uR_DQUOTE] = ACTIONS(2765),
    [anon_sym_UR_DQUOTE] = ACTIONS(2765),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2765),
    [anon_sym_co_await] = ACTIONS(2763),
    [anon_sym_new] = ACTIONS(2763),
    [anon_sym_requires] = ACTIONS(2763),
    [sym_this] = ACTIONS(2763),
  },
  [1512] = {
    [sym_identifier] = ACTIONS(2731),
    [anon_sym_LPAREN2] = ACTIONS(2733),
    [anon_sym_BANG] = ACTIONS(2733),
    [anon_sym_TILDE] = ACTIONS(2733),
    [anon_sym_DASH] = ACTIONS(2731),
    [anon_sym_PLUS] = ACTIONS(2731),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_AMP] = ACTIONS(2733),
    [anon_sym___extension__] = ACTIONS(2731),
    [anon_sym_virtual] = ACTIONS(2731),
    [anon_sym_extern] = ACTIONS(2731),
    [anon_sym___attribute__] = ACTIONS(2731),
    [anon_sym___attribute] = ACTIONS(2731),
    [anon_sym_COLON_COLON] = ACTIONS(2733),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2733),
    [anon_sym___declspec] = ACTIONS(2731),
    [anon_sym_signed] = ACTIONS(2731),
    [anon_sym_unsigned] = ACTIONS(2731),
    [anon_sym_long] = ACTIONS(2731),
    [anon_sym_short] = ACTIONS(2731),
    [anon_sym_LBRACK] = ACTIONS(2731),
    [anon_sym_static] = ACTIONS(2731),
    [anon_sym_register] = ACTIONS(2731),
    [anon_sym_inline] = ACTIONS(2731),
    [anon_sym___inline] = ACTIONS(2731),
    [anon_sym___inline__] = ACTIONS(2731),
    [anon_sym___forceinline] = ACTIONS(2731),
    [anon_sym_thread_local] = ACTIONS(2731),
    [anon_sym___thread] = ACTIONS(2731),
    [anon_sym_const] = ACTIONS(2731),
    [anon_sym_constexpr] = ACTIONS(2731),
    [anon_sym_volatile] = ACTIONS(2731),
    [anon_sym_restrict] = ACTIONS(2731),
    [anon_sym___restrict__] = ACTIONS(2731),
    [anon_sym__Atomic] = ACTIONS(2731),
    [anon_sym__Noreturn] = ACTIONS(2731),
    [anon_sym_noreturn] = ACTIONS(2731),
    [anon_sym__Nonnull] = ACTIONS(2731),
    [anon_sym_mutable] = ACTIONS(2731),
    [anon_sym_constinit] = ACTIONS(2731),
    [anon_sym_consteval] = ACTIONS(2731),
    [anon_sym_alignas] = ACTIONS(2731),
    [anon_sym__Alignas] = ACTIONS(2731),
    [sym_primitive_type] = ACTIONS(2731),
    [anon_sym_enum] = ACTIONS(2731),
    [anon_sym_class] = ACTIONS(2731),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2731),
    [anon_sym_not] = ACTIONS(2731),
    [anon_sym_compl] = ACTIONS(2731),
    [anon_sym_DASH_DASH] = ACTIONS(2733),
    [anon_sym_PLUS_PLUS] = ACTIONS(2733),
    [anon_sym_sizeof] = ACTIONS(2731),
    [anon_sym___alignof__] = ACTIONS(2731),
    [anon_sym___alignof] = ACTIONS(2731),
    [anon_sym__alignof] = ACTIONS(2731),
    [anon_sym_alignof] = ACTIONS(2731),
    [anon_sym__Alignof] = ACTIONS(2731),
    [anon_sym_offsetof] = ACTIONS(2731),
    [anon_sym__Generic] = ACTIONS(2731),
    [anon_sym_asm] = ACTIONS(2731),
    [anon_sym___asm__] = ACTIONS(2731),
    [anon_sym___asm] = ACTIONS(2731),
    [sym_number_literal] = ACTIONS(2733),
    [anon_sym_L_SQUOTE] = ACTIONS(2733),
    [anon_sym_u_SQUOTE] = ACTIONS(2733),
    [anon_sym_U_SQUOTE] = ACTIONS(2733),
    [anon_sym_u8_SQUOTE] = ACTIONS(2733),
    [anon_sym_SQUOTE] = ACTIONS(2733),
    [anon_sym_L_DQUOTE] = ACTIONS(2733),
    [anon_sym_u_DQUOTE] = ACTIONS(2733),
    [anon_sym_U_DQUOTE] = ACTIONS(2733),
    [anon_sym_u8_DQUOTE] = ACTIONS(2733),
    [anon_sym_DQUOTE] = ACTIONS(2733),
    [sym_true] = ACTIONS(2731),
    [sym_false] = ACTIONS(2731),
    [anon_sym_NULL] = ACTIONS(2731),
    [anon_sym_nullptr] = ACTIONS(2731),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2731),
    [anon_sym_decltype] = ACTIONS(2731),
    [anon_sym_typename] = ACTIONS(2731),
    [anon_sym_template] = ACTIONS(2731),
    [anon_sym_delete] = ACTIONS(2731),
    [anon_sym_R_DQUOTE] = ACTIONS(2733),
    [anon_sym_LR_DQUOTE] = ACTIONS(2733),
    [anon_sym_uR_DQUOTE] = ACTIONS(2733),
    [anon_sym_UR_DQUOTE] = ACTIONS(2733),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2733),
    [anon_sym_co_await] = ACTIONS(2731),
    [anon_sym_new] = ACTIONS(2731),
    [anon_sym_requires] = ACTIONS(2731),
    [sym_this] = ACTIONS(2731),
  },
  [1513] = {
    [sym_identifier] = ACTIONS(2783),
    [anon_sym_LPAREN2] = ACTIONS(2788),
    [anon_sym_BANG] = ACTIONS(2788),
    [anon_sym_TILDE] = ACTIONS(2788),
    [anon_sym_DASH] = ACTIONS(2783),
    [anon_sym_PLUS] = ACTIONS(2783),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_AMP] = ACTIONS(2788),
    [anon_sym___extension__] = ACTIONS(2783),
    [anon_sym_virtual] = ACTIONS(2783),
    [anon_sym_extern] = ACTIONS(2783),
    [anon_sym___attribute__] = ACTIONS(2783),
    [anon_sym___attribute] = ACTIONS(2783),
    [anon_sym_COLON_COLON] = ACTIONS(2788),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2788),
    [anon_sym___declspec] = ACTIONS(2783),
    [anon_sym_signed] = ACTIONS(2783),
    [anon_sym_unsigned] = ACTIONS(2783),
    [anon_sym_long] = ACTIONS(2783),
    [anon_sym_short] = ACTIONS(2783),
    [anon_sym_LBRACK] = ACTIONS(2783),
    [anon_sym_static] = ACTIONS(2783),
    [anon_sym_register] = ACTIONS(2783),
    [anon_sym_inline] = ACTIONS(2783),
    [anon_sym___inline] = ACTIONS(2783),
    [anon_sym___inline__] = ACTIONS(2783),
    [anon_sym___forceinline] = ACTIONS(2783),
    [anon_sym_thread_local] = ACTIONS(2783),
    [anon_sym___thread] = ACTIONS(2783),
    [anon_sym_const] = ACTIONS(2783),
    [anon_sym_constexpr] = ACTIONS(2783),
    [anon_sym_volatile] = ACTIONS(2783),
    [anon_sym_restrict] = ACTIONS(2783),
    [anon_sym___restrict__] = ACTIONS(2783),
    [anon_sym__Atomic] = ACTIONS(2783),
    [anon_sym__Noreturn] = ACTIONS(2783),
    [anon_sym_noreturn] = ACTIONS(2783),
    [anon_sym__Nonnull] = ACTIONS(2783),
    [anon_sym_mutable] = ACTIONS(2783),
    [anon_sym_constinit] = ACTIONS(2783),
    [anon_sym_consteval] = ACTIONS(2783),
    [anon_sym_alignas] = ACTIONS(2783),
    [anon_sym__Alignas] = ACTIONS(2783),
    [sym_primitive_type] = ACTIONS(2783),
    [anon_sym_enum] = ACTIONS(2783),
    [anon_sym_class] = ACTIONS(2783),
    [anon_sym_struct] = ACTIONS(2783),
    [anon_sym_union] = ACTIONS(2783),
    [anon_sym_not] = ACTIONS(2783),
    [anon_sym_compl] = ACTIONS(2783),
    [anon_sym_DASH_DASH] = ACTIONS(2788),
    [anon_sym_PLUS_PLUS] = ACTIONS(2788),
    [anon_sym_sizeof] = ACTIONS(2783),
    [anon_sym___alignof__] = ACTIONS(2783),
    [anon_sym___alignof] = ACTIONS(2783),
    [anon_sym__alignof] = ACTIONS(2783),
    [anon_sym_alignof] = ACTIONS(2783),
    [anon_sym__Alignof] = ACTIONS(2783),
    [anon_sym_offsetof] = ACTIONS(2783),
    [anon_sym__Generic] = ACTIONS(2783),
    [anon_sym_asm] = ACTIONS(2783),
    [anon_sym___asm__] = ACTIONS(2783),
    [anon_sym___asm] = ACTIONS(2783),
    [sym_number_literal] = ACTIONS(2788),
    [anon_sym_L_SQUOTE] = ACTIONS(2788),
    [anon_sym_u_SQUOTE] = ACTIONS(2788),
    [anon_sym_U_SQUOTE] = ACTIONS(2788),
    [anon_sym_u8_SQUOTE] = ACTIONS(2788),
    [anon_sym_SQUOTE] = ACTIONS(2788),
    [anon_sym_L_DQUOTE] = ACTIONS(2788),
    [anon_sym_u_DQUOTE] = ACTIONS(2788),
    [anon_sym_U_DQUOTE] = ACTIONS(2788),
    [anon_sym_u8_DQUOTE] = ACTIONS(2788),
    [anon_sym_DQUOTE] = ACTIONS(2788),
    [sym_true] = ACTIONS(2783),
    [sym_false] = ACTIONS(2783),
    [anon_sym_NULL] = ACTIONS(2783),
    [anon_sym_nullptr] = ACTIONS(2783),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2783),
    [anon_sym_decltype] = ACTIONS(2783),
    [anon_sym_typename] = ACTIONS(2783),
    [anon_sym_template] = ACTIONS(2783),
    [anon_sym_delete] = ACTIONS(2783),
    [anon_sym_R_DQUOTE] = ACTIONS(2788),
    [anon_sym_LR_DQUOTE] = ACTIONS(2788),
    [anon_sym_uR_DQUOTE] = ACTIONS(2788),
    [anon_sym_UR_DQUOTE] = ACTIONS(2788),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2788),
    [anon_sym_co_await] = ACTIONS(2783),
    [anon_sym_new] = ACTIONS(2783),
    [anon_sym_requires] = ACTIONS(2783),
    [sym_this] = ACTIONS(2783),
  },
  [1514] = {
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(5210),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(2033),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6581),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(5896),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_dependent_type] = STATE(2383),
    [sym_template_parameter_list] = STATE(798),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(4156),
    [sym_template_function] = STATE(5896),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5624),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_operator_name] = STATE(5896),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(4883),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_LT] = ACTIONS(4885),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4887),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_operator] = ACTIONS(1823),
  },
  [1515] = {
    [sym_template_argument_list] = STATE(1519),
    [sym_identifier] = ACTIONS(4838),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4840),
    [anon_sym_COMMA] = ACTIONS(4840),
    [anon_sym_RPAREN] = ACTIONS(4840),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_TILDE] = ACTIONS(4845),
    [anon_sym_DASH] = ACTIONS(4847),
    [anon_sym_PLUS] = ACTIONS(4847),
    [anon_sym_STAR] = ACTIONS(4849),
    [anon_sym_SLASH] = ACTIONS(4847),
    [anon_sym_PERCENT] = ACTIONS(4847),
    [anon_sym_PIPE_PIPE] = ACTIONS(4840),
    [anon_sym_AMP_AMP] = ACTIONS(4842),
    [anon_sym_PIPE] = ACTIONS(4847),
    [anon_sym_CARET] = ACTIONS(4847),
    [anon_sym_AMP] = ACTIONS(4849),
    [anon_sym_EQ_EQ] = ACTIONS(4840),
    [anon_sym_BANG_EQ] = ACTIONS(4840),
    [anon_sym_GT] = ACTIONS(4847),
    [anon_sym_GT_EQ] = ACTIONS(4840),
    [anon_sym_LT_EQ] = ACTIONS(4847),
    [anon_sym_LT] = ACTIONS(4852),
    [anon_sym_LT_LT] = ACTIONS(4847),
    [anon_sym_GT_GT] = ACTIONS(4847),
    [anon_sym_SEMI] = ACTIONS(4840),
    [anon_sym___extension__] = ACTIONS(4838),
    [anon_sym_virtual] = ACTIONS(4838),
    [anon_sym_extern] = ACTIONS(4838),
    [anon_sym___attribute__] = ACTIONS(4838),
    [anon_sym___attribute] = ACTIONS(4838),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4845),
    [anon_sym___declspec] = ACTIONS(4838),
    [anon_sym___based] = ACTIONS(4838),
    [anon_sym_LBRACE] = ACTIONS(4845),
    [anon_sym_RBRACE] = ACTIONS(4840),
    [anon_sym_LBRACK] = ACTIONS(4849),
    [anon_sym_static] = ACTIONS(4838),
    [anon_sym_EQ] = ACTIONS(4847),
    [anon_sym_register] = ACTIONS(4838),
    [anon_sym_inline] = ACTIONS(4838),
    [anon_sym___inline] = ACTIONS(4838),
    [anon_sym___inline__] = ACTIONS(4838),
    [anon_sym___forceinline] = ACTIONS(4838),
    [anon_sym_thread_local] = ACTIONS(4838),
    [anon_sym___thread] = ACTIONS(4838),
    [anon_sym_const] = ACTIONS(4838),
    [anon_sym_constexpr] = ACTIONS(4838),
    [anon_sym_volatile] = ACTIONS(4838),
    [anon_sym_restrict] = ACTIONS(4838),
    [anon_sym___restrict__] = ACTIONS(4838),
    [anon_sym__Atomic] = ACTIONS(4838),
    [anon_sym__Noreturn] = ACTIONS(4838),
    [anon_sym_noreturn] = ACTIONS(4838),
    [anon_sym__Nonnull] = ACTIONS(4838),
    [anon_sym_mutable] = ACTIONS(4838),
    [anon_sym_constinit] = ACTIONS(4838),
    [anon_sym_consteval] = ACTIONS(4838),
    [anon_sym_alignas] = ACTIONS(4838),
    [anon_sym__Alignas] = ACTIONS(4838),
    [anon_sym_QMARK] = ACTIONS(4840),
    [anon_sym_STAR_EQ] = ACTIONS(4840),
    [anon_sym_SLASH_EQ] = ACTIONS(4840),
    [anon_sym_PERCENT_EQ] = ACTIONS(4840),
    [anon_sym_PLUS_EQ] = ACTIONS(4840),
    [anon_sym_DASH_EQ] = ACTIONS(4840),
    [anon_sym_LT_LT_EQ] = ACTIONS(4840),
    [anon_sym_GT_GT_EQ] = ACTIONS(4840),
    [anon_sym_AMP_EQ] = ACTIONS(4840),
    [anon_sym_CARET_EQ] = ACTIONS(4840),
    [anon_sym_PIPE_EQ] = ACTIONS(4840),
    [anon_sym_and_eq] = ACTIONS(4847),
    [anon_sym_or_eq] = ACTIONS(4847),
    [anon_sym_xor_eq] = ACTIONS(4847),
    [anon_sym_LT_EQ_GT] = ACTIONS(4840),
    [anon_sym_or] = ACTIONS(4847),
    [anon_sym_and] = ACTIONS(4847),
    [anon_sym_bitor] = ACTIONS(4847),
    [anon_sym_xor] = ACTIONS(4847),
    [anon_sym_bitand] = ACTIONS(4847),
    [anon_sym_not_eq] = ACTIONS(4847),
    [anon_sym_DASH_DASH] = ACTIONS(4840),
    [anon_sym_PLUS_PLUS] = ACTIONS(4840),
    [anon_sym_DOT] = ACTIONS(4847),
    [anon_sym_DOT_STAR] = ACTIONS(4840),
    [anon_sym_DASH_GT] = ACTIONS(4840),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4838),
    [anon_sym_decltype] = ACTIONS(4838),
    [anon_sym_template] = ACTIONS(4838),
    [anon_sym_operator] = ACTIONS(4838),
  },
  [1516] = {
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(5205),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(2033),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6590),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(5896),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_dependent_type] = STATE(2383),
    [sym_template_parameter_list] = STATE(796),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(4156),
    [sym_template_function] = STATE(5896),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5624),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_operator_name] = STATE(5896),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(4883),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_LT] = ACTIONS(4885),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4887),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_operator] = ACTIONS(1823),
  },
  [1517] = {
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(5217),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(2033),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6537),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(5896),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_dependent_type] = STATE(2383),
    [sym_template_parameter_list] = STATE(800),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(4156),
    [sym_template_function] = STATE(5896),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5624),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_operator_name] = STATE(5896),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(4883),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_LT] = ACTIONS(4885),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4887),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_operator] = ACTIONS(1823),
  },
  [1518] = {
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(5226),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(2033),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6540),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(5896),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_dependent_type] = STATE(2383),
    [sym_template_parameter_list] = STATE(795),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(4156),
    [sym_template_function] = STATE(5896),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5624),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_type_identifier] = STATE(2978),
    [sym_operator_name] = STATE(5896),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(4883),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym_LT] = ACTIONS(4885),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4887),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_operator] = ACTIONS(1823),
  },
  [1519] = {
    [sym_identifier] = ACTIONS(4855),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4857),
    [anon_sym_COMMA] = ACTIONS(4857),
    [anon_sym_RPAREN] = ACTIONS(4857),
    [anon_sym_LPAREN2] = ACTIONS(4859),
    [anon_sym_TILDE] = ACTIONS(4862),
    [anon_sym_DASH] = ACTIONS(4864),
    [anon_sym_PLUS] = ACTIONS(4864),
    [anon_sym_STAR] = ACTIONS(4866),
    [anon_sym_SLASH] = ACTIONS(4864),
    [anon_sym_PERCENT] = ACTIONS(4864),
    [anon_sym_PIPE_PIPE] = ACTIONS(4857),
    [anon_sym_AMP_AMP] = ACTIONS(4859),
    [anon_sym_PIPE] = ACTIONS(4864),
    [anon_sym_CARET] = ACTIONS(4864),
    [anon_sym_AMP] = ACTIONS(4866),
    [anon_sym_EQ_EQ] = ACTIONS(4857),
    [anon_sym_BANG_EQ] = ACTIONS(4857),
    [anon_sym_GT] = ACTIONS(4864),
    [anon_sym_GT_EQ] = ACTIONS(4857),
    [anon_sym_LT_EQ] = ACTIONS(4864),
    [anon_sym_LT] = ACTIONS(4864),
    [anon_sym_LT_LT] = ACTIONS(4864),
    [anon_sym_GT_GT] = ACTIONS(4864),
    [anon_sym_SEMI] = ACTIONS(4857),
    [anon_sym___extension__] = ACTIONS(4855),
    [anon_sym_virtual] = ACTIONS(4855),
    [anon_sym_extern] = ACTIONS(4855),
    [anon_sym___attribute__] = ACTIONS(4855),
    [anon_sym___attribute] = ACTIONS(4855),
    [anon_sym_COLON_COLON] = ACTIONS(4862),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4862),
    [anon_sym___declspec] = ACTIONS(4855),
    [anon_sym___based] = ACTIONS(4855),
    [anon_sym_LBRACE] = ACTIONS(4862),
    [anon_sym_RBRACE] = ACTIONS(4857),
    [anon_sym_LBRACK] = ACTIONS(4866),
    [anon_sym_static] = ACTIONS(4855),
    [anon_sym_EQ] = ACTIONS(4864),
    [anon_sym_register] = ACTIONS(4855),
    [anon_sym_inline] = ACTIONS(4855),
    [anon_sym___inline] = ACTIONS(4855),
    [anon_sym___inline__] = ACTIONS(4855),
    [anon_sym___forceinline] = ACTIONS(4855),
    [anon_sym_thread_local] = ACTIONS(4855),
    [anon_sym___thread] = ACTIONS(4855),
    [anon_sym_const] = ACTIONS(4855),
    [anon_sym_constexpr] = ACTIONS(4855),
    [anon_sym_volatile] = ACTIONS(4855),
    [anon_sym_restrict] = ACTIONS(4855),
    [anon_sym___restrict__] = ACTIONS(4855),
    [anon_sym__Atomic] = ACTIONS(4855),
    [anon_sym__Noreturn] = ACTIONS(4855),
    [anon_sym_noreturn] = ACTIONS(4855),
    [anon_sym__Nonnull] = ACTIONS(4855),
    [anon_sym_mutable] = ACTIONS(4855),
    [anon_sym_constinit] = ACTIONS(4855),
    [anon_sym_consteval] = ACTIONS(4855),
    [anon_sym_alignas] = ACTIONS(4855),
    [anon_sym__Alignas] = ACTIONS(4855),
    [anon_sym_QMARK] = ACTIONS(4857),
    [anon_sym_STAR_EQ] = ACTIONS(4857),
    [anon_sym_SLASH_EQ] = ACTIONS(4857),
    [anon_sym_PERCENT_EQ] = ACTIONS(4857),
    [anon_sym_PLUS_EQ] = ACTIONS(4857),
    [anon_sym_DASH_EQ] = ACTIONS(4857),
    [anon_sym_LT_LT_EQ] = ACTIONS(4857),
    [anon_sym_GT_GT_EQ] = ACTIONS(4857),
    [anon_sym_AMP_EQ] = ACTIONS(4857),
    [anon_sym_CARET_EQ] = ACTIONS(4857),
    [anon_sym_PIPE_EQ] = ACTIONS(4857),
    [anon_sym_and_eq] = ACTIONS(4864),
    [anon_sym_or_eq] = ACTIONS(4864),
    [anon_sym_xor_eq] = ACTIONS(4864),
    [anon_sym_LT_EQ_GT] = ACTIONS(4857),
    [anon_sym_or] = ACTIONS(4864),
    [anon_sym_and] = ACTIONS(4864),
    [anon_sym_bitor] = ACTIONS(4864),
    [anon_sym_xor] = ACTIONS(4864),
    [anon_sym_bitand] = ACTIONS(4864),
    [anon_sym_not_eq] = ACTIONS(4864),
    [anon_sym_DASH_DASH] = ACTIONS(4857),
    [anon_sym_PLUS_PLUS] = ACTIONS(4857),
    [anon_sym_DOT] = ACTIONS(4864),
    [anon_sym_DOT_STAR] = ACTIONS(4857),
    [anon_sym_DASH_GT] = ACTIONS(4857),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4855),
    [anon_sym_decltype] = ACTIONS(4855),
    [anon_sym_template] = ACTIONS(4855),
    [anon_sym_operator] = ACTIONS(4855),
  },
  [1520] = {
    [sym_template_argument_list] = STATE(1524),
    [sym_identifier] = ACTIONS(4838),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4842),
    [anon_sym_COMMA] = ACTIONS(4842),
    [anon_sym_RPAREN] = ACTIONS(4842),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_TILDE] = ACTIONS(4845),
    [anon_sym_DASH] = ACTIONS(4847),
    [anon_sym_PLUS] = ACTIONS(4847),
    [anon_sym_STAR] = ACTIONS(4849),
    [anon_sym_SLASH] = ACTIONS(4847),
    [anon_sym_PERCENT] = ACTIONS(4847),
    [anon_sym_PIPE_PIPE] = ACTIONS(4840),
    [anon_sym_AMP_AMP] = ACTIONS(4842),
    [anon_sym_PIPE] = ACTIONS(4847),
    [anon_sym_CARET] = ACTIONS(4847),
    [anon_sym_AMP] = ACTIONS(4849),
    [anon_sym_EQ_EQ] = ACTIONS(4840),
    [anon_sym_BANG_EQ] = ACTIONS(4840),
    [anon_sym_GT] = ACTIONS(4847),
    [anon_sym_GT_EQ] = ACTIONS(4840),
    [anon_sym_LT_EQ] = ACTIONS(4847),
    [anon_sym_LT] = ACTIONS(4889),
    [anon_sym_LT_LT] = ACTIONS(4847),
    [anon_sym_GT_GT] = ACTIONS(4847),
    [anon_sym___extension__] = ACTIONS(4838),
    [anon_sym_virtual] = ACTIONS(4838),
    [anon_sym_extern] = ACTIONS(4838),
    [anon_sym___attribute__] = ACTIONS(4838),
    [anon_sym___attribute] = ACTIONS(4838),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4845),
    [anon_sym___declspec] = ACTIONS(4838),
    [anon_sym___based] = ACTIONS(4838),
    [anon_sym_LBRACE] = ACTIONS(4845),
    [anon_sym_LBRACK] = ACTIONS(4849),
    [anon_sym_static] = ACTIONS(4838),
    [anon_sym_EQ] = ACTIONS(4849),
    [anon_sym_register] = ACTIONS(4838),
    [anon_sym_inline] = ACTIONS(4838),
    [anon_sym___inline] = ACTIONS(4838),
    [anon_sym___inline__] = ACTIONS(4838),
    [anon_sym___forceinline] = ACTIONS(4838),
    [anon_sym_thread_local] = ACTIONS(4838),
    [anon_sym___thread] = ACTIONS(4838),
    [anon_sym_const] = ACTIONS(4838),
    [anon_sym_constexpr] = ACTIONS(4838),
    [anon_sym_volatile] = ACTIONS(4838),
    [anon_sym_restrict] = ACTIONS(4838),
    [anon_sym___restrict__] = ACTIONS(4838),
    [anon_sym__Atomic] = ACTIONS(4838),
    [anon_sym__Noreturn] = ACTIONS(4838),
    [anon_sym_noreturn] = ACTIONS(4838),
    [anon_sym__Nonnull] = ACTIONS(4838),
    [anon_sym_mutable] = ACTIONS(4838),
    [anon_sym_constinit] = ACTIONS(4838),
    [anon_sym_consteval] = ACTIONS(4838),
    [anon_sym_alignas] = ACTIONS(4838),
    [anon_sym__Alignas] = ACTIONS(4838),
    [anon_sym_QMARK] = ACTIONS(4840),
    [anon_sym_STAR_EQ] = ACTIONS(4840),
    [anon_sym_SLASH_EQ] = ACTIONS(4840),
    [anon_sym_PERCENT_EQ] = ACTIONS(4840),
    [anon_sym_PLUS_EQ] = ACTIONS(4840),
    [anon_sym_DASH_EQ] = ACTIONS(4840),
    [anon_sym_LT_LT_EQ] = ACTIONS(4840),
    [anon_sym_GT_GT_EQ] = ACTIONS(4840),
    [anon_sym_AMP_EQ] = ACTIONS(4840),
    [anon_sym_CARET_EQ] = ACTIONS(4840),
    [anon_sym_PIPE_EQ] = ACTIONS(4840),
    [anon_sym_and_eq] = ACTIONS(4847),
    [anon_sym_or_eq] = ACTIONS(4847),
    [anon_sym_xor_eq] = ACTIONS(4847),
    [anon_sym_LT_EQ_GT] = ACTIONS(4840),
    [anon_sym_or] = ACTIONS(4847),
    [anon_sym_and] = ACTIONS(4847),
    [anon_sym_bitor] = ACTIONS(4847),
    [anon_sym_xor] = ACTIONS(4847),
    [anon_sym_bitand] = ACTIONS(4847),
    [anon_sym_not_eq] = ACTIONS(4847),
    [anon_sym_DASH_DASH] = ACTIONS(4840),
    [anon_sym_PLUS_PLUS] = ACTIONS(4840),
    [anon_sym_DOT] = ACTIONS(4847),
    [anon_sym_DOT_STAR] = ACTIONS(4840),
    [anon_sym_DASH_GT] = ACTIONS(4847),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4838),
    [anon_sym_decltype] = ACTIONS(4838),
    [anon_sym_template] = ACTIONS(4838),
    [anon_sym_operator] = ACTIONS(4838),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4840),
  },
  [1521] = {
    [sym_template_argument_list] = STATE(1538),
    [sym_identifier] = ACTIONS(4838),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4842),
    [anon_sym_COMMA] = ACTIONS(4842),
    [anon_sym_RPAREN] = ACTIONS(4842),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_TILDE] = ACTIONS(4845),
    [anon_sym_DASH] = ACTIONS(4847),
    [anon_sym_PLUS] = ACTIONS(4847),
    [anon_sym_STAR] = ACTIONS(4849),
    [anon_sym_SLASH] = ACTIONS(4847),
    [anon_sym_PERCENT] = ACTIONS(4847),
    [anon_sym_PIPE_PIPE] = ACTIONS(4840),
    [anon_sym_AMP_AMP] = ACTIONS(4842),
    [anon_sym_PIPE] = ACTIONS(4847),
    [anon_sym_CARET] = ACTIONS(4847),
    [anon_sym_AMP] = ACTIONS(4849),
    [anon_sym_EQ_EQ] = ACTIONS(4840),
    [anon_sym_BANG_EQ] = ACTIONS(4840),
    [anon_sym_GT] = ACTIONS(4847),
    [anon_sym_GT_EQ] = ACTIONS(4840),
    [anon_sym_LT_EQ] = ACTIONS(4847),
    [anon_sym_LT] = ACTIONS(4852),
    [anon_sym_LT_LT] = ACTIONS(4847),
    [anon_sym_GT_GT] = ACTIONS(4847),
    [anon_sym___extension__] = ACTIONS(4838),
    [anon_sym_virtual] = ACTIONS(4838),
    [anon_sym_extern] = ACTIONS(4838),
    [anon_sym___attribute__] = ACTIONS(4838),
    [anon_sym___attribute] = ACTIONS(4838),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4845),
    [anon_sym___declspec] = ACTIONS(4838),
    [anon_sym___based] = ACTIONS(4838),
    [anon_sym_LBRACE] = ACTIONS(4845),
    [anon_sym_LBRACK] = ACTIONS(4849),
    [anon_sym_static] = ACTIONS(4838),
    [anon_sym_EQ] = ACTIONS(4849),
    [anon_sym_register] = ACTIONS(4838),
    [anon_sym_inline] = ACTIONS(4838),
    [anon_sym___inline] = ACTIONS(4838),
    [anon_sym___inline__] = ACTIONS(4838),
    [anon_sym___forceinline] = ACTIONS(4838),
    [anon_sym_thread_local] = ACTIONS(4838),
    [anon_sym___thread] = ACTIONS(4838),
    [anon_sym_const] = ACTIONS(4838),
    [anon_sym_constexpr] = ACTIONS(4838),
    [anon_sym_volatile] = ACTIONS(4838),
    [anon_sym_restrict] = ACTIONS(4838),
    [anon_sym___restrict__] = ACTIONS(4838),
    [anon_sym__Atomic] = ACTIONS(4838),
    [anon_sym__Noreturn] = ACTIONS(4838),
    [anon_sym_noreturn] = ACTIONS(4838),
    [anon_sym__Nonnull] = ACTIONS(4838),
    [anon_sym_mutable] = ACTIONS(4838),
    [anon_sym_constinit] = ACTIONS(4838),
    [anon_sym_consteval] = ACTIONS(4838),
    [anon_sym_alignas] = ACTIONS(4838),
    [anon_sym__Alignas] = ACTIONS(4838),
    [anon_sym_QMARK] = ACTIONS(4840),
    [anon_sym_STAR_EQ] = ACTIONS(4840),
    [anon_sym_SLASH_EQ] = ACTIONS(4840),
    [anon_sym_PERCENT_EQ] = ACTIONS(4840),
    [anon_sym_PLUS_EQ] = ACTIONS(4840),
    [anon_sym_DASH_EQ] = ACTIONS(4840),
    [anon_sym_LT_LT_EQ] = ACTIONS(4840),
    [anon_sym_GT_GT_EQ] = ACTIONS(4840),
    [anon_sym_AMP_EQ] = ACTIONS(4840),
    [anon_sym_CARET_EQ] = ACTIONS(4840),
    [anon_sym_PIPE_EQ] = ACTIONS(4840),
    [anon_sym_and_eq] = ACTIONS(4847),
    [anon_sym_or_eq] = ACTIONS(4847),
    [anon_sym_xor_eq] = ACTIONS(4847),
    [anon_sym_LT_EQ_GT] = ACTIONS(4840),
    [anon_sym_or] = ACTIONS(4847),
    [anon_sym_and] = ACTIONS(4847),
    [anon_sym_bitor] = ACTIONS(4847),
    [anon_sym_xor] = ACTIONS(4847),
    [anon_sym_bitand] = ACTIONS(4847),
    [anon_sym_not_eq] = ACTIONS(4847),
    [anon_sym_DASH_DASH] = ACTIONS(4840),
    [anon_sym_PLUS_PLUS] = ACTIONS(4840),
    [anon_sym_DOT] = ACTIONS(4847),
    [anon_sym_DOT_STAR] = ACTIONS(4840),
    [anon_sym_DASH_GT] = ACTIONS(4840),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4838),
    [anon_sym_decltype] = ACTIONS(4838),
    [anon_sym_template] = ACTIONS(4838),
    [anon_sym_operator] = ACTIONS(4838),
  },
  [1522] = {
    [sym_identifier] = ACTIONS(4834),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4836),
    [anon_sym_COMMA] = ACTIONS(4836),
    [anon_sym_RPAREN] = ACTIONS(4836),
    [anon_sym_LPAREN2] = ACTIONS(4836),
    [anon_sym_TILDE] = ACTIONS(4836),
    [anon_sym_DASH] = ACTIONS(4834),
    [anon_sym_PLUS] = ACTIONS(4834),
    [anon_sym_STAR] = ACTIONS(4836),
    [anon_sym_SLASH] = ACTIONS(4834),
    [anon_sym_PERCENT] = ACTIONS(4836),
    [anon_sym_PIPE_PIPE] = ACTIONS(4836),
    [anon_sym_AMP_AMP] = ACTIONS(4836),
    [anon_sym_PIPE] = ACTIONS(4834),
    [anon_sym_CARET] = ACTIONS(4836),
    [anon_sym_AMP] = ACTIONS(4834),
    [anon_sym_EQ_EQ] = ACTIONS(4836),
    [anon_sym_BANG_EQ] = ACTIONS(4836),
    [anon_sym_GT] = ACTIONS(4834),
    [anon_sym_GT_EQ] = ACTIONS(4836),
    [anon_sym_LT_EQ] = ACTIONS(4834),
    [anon_sym_LT] = ACTIONS(4834),
    [anon_sym_LT_LT] = ACTIONS(4836),
    [anon_sym_GT_GT] = ACTIONS(4836),
    [anon_sym_SEMI] = ACTIONS(4836),
    [anon_sym___extension__] = ACTIONS(4834),
    [anon_sym_virtual] = ACTIONS(4834),
    [anon_sym_extern] = ACTIONS(4834),
    [anon_sym___attribute__] = ACTIONS(4834),
    [anon_sym___attribute] = ACTIONS(4834),
    [anon_sym_COLON_COLON] = ACTIONS(4836),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4836),
    [anon_sym___declspec] = ACTIONS(4834),
    [anon_sym___based] = ACTIONS(4834),
    [anon_sym___cdecl] = ACTIONS(4834),
    [anon_sym___clrcall] = ACTIONS(4834),
    [anon_sym___stdcall] = ACTIONS(4834),
    [anon_sym___fastcall] = ACTIONS(4834),
    [anon_sym___thiscall] = ACTIONS(4834),
    [anon_sym___vectorcall] = ACTIONS(4834),
    [anon_sym_LBRACE] = ACTIONS(4836),
    [anon_sym_RBRACE] = ACTIONS(4836),
    [anon_sym_LBRACK] = ACTIONS(4834),
    [anon_sym_static] = ACTIONS(4834),
    [anon_sym_RBRACK] = ACTIONS(4836),
    [anon_sym_EQ] = ACTIONS(4834),
    [anon_sym_register] = ACTIONS(4834),
    [anon_sym_inline] = ACTIONS(4834),
    [anon_sym___inline] = ACTIONS(4834),
    [anon_sym___inline__] = ACTIONS(4834),
    [anon_sym___forceinline] = ACTIONS(4834),
    [anon_sym_thread_local] = ACTIONS(4834),
    [anon_sym___thread] = ACTIONS(4834),
    [anon_sym_const] = ACTIONS(4834),
    [anon_sym_constexpr] = ACTIONS(4834),
    [anon_sym_volatile] = ACTIONS(4834),
    [anon_sym_restrict] = ACTIONS(4834),
    [anon_sym___restrict__] = ACTIONS(4834),
    [anon_sym__Atomic] = ACTIONS(4834),
    [anon_sym__Noreturn] = ACTIONS(4834),
    [anon_sym_noreturn] = ACTIONS(4834),
    [anon_sym__Nonnull] = ACTIONS(4834),
    [anon_sym_mutable] = ACTIONS(4834),
    [anon_sym_constinit] = ACTIONS(4834),
    [anon_sym_consteval] = ACTIONS(4834),
    [anon_sym_alignas] = ACTIONS(4834),
    [anon_sym__Alignas] = ACTIONS(4834),
    [anon_sym_COLON] = ACTIONS(4834),
    [anon_sym_QMARK] = ACTIONS(4836),
    [anon_sym_LT_EQ_GT] = ACTIONS(4836),
    [anon_sym_or] = ACTIONS(4834),
    [anon_sym_and] = ACTIONS(4834),
    [anon_sym_bitor] = ACTIONS(4834),
    [anon_sym_xor] = ACTIONS(4834),
    [anon_sym_bitand] = ACTIONS(4834),
    [anon_sym_not_eq] = ACTIONS(4834),
    [anon_sym_DASH_DASH] = ACTIONS(4836),
    [anon_sym_PLUS_PLUS] = ACTIONS(4836),
    [anon_sym_DOT] = ACTIONS(4834),
    [anon_sym_DOT_STAR] = ACTIONS(4836),
    [anon_sym_DASH_GT] = ACTIONS(4836),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4834),
    [anon_sym_decltype] = ACTIONS(4834),
    [anon_sym_final] = ACTIONS(4834),
    [anon_sym_override] = ACTIONS(4834),
    [anon_sym_template] = ACTIONS(4834),
    [anon_sym_operator] = ACTIONS(4834),
    [anon_sym_try] = ACTIONS(4834),
    [anon_sym_requires] = ACTIONS(4834),
  },
  [1523] = {
    [sym_identifier] = ACTIONS(4810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4812),
    [anon_sym_COMMA] = ACTIONS(4812),
    [anon_sym_RPAREN] = ACTIONS(4812),
    [anon_sym_LPAREN2] = ACTIONS(4812),
    [anon_sym_TILDE] = ACTIONS(4812),
    [anon_sym_DASH] = ACTIONS(4810),
    [anon_sym_PLUS] = ACTIONS(4810),
    [anon_sym_STAR] = ACTIONS(4810),
    [anon_sym_SLASH] = ACTIONS(4810),
    [anon_sym_PERCENT] = ACTIONS(4810),
    [anon_sym_PIPE_PIPE] = ACTIONS(4812),
    [anon_sym_AMP_AMP] = ACTIONS(4812),
    [anon_sym_PIPE] = ACTIONS(4810),
    [anon_sym_CARET] = ACTIONS(4810),
    [anon_sym_AMP] = ACTIONS(4810),
    [anon_sym_EQ_EQ] = ACTIONS(4812),
    [anon_sym_BANG_EQ] = ACTIONS(4812),
    [anon_sym_GT] = ACTIONS(4810),
    [anon_sym_GT_EQ] = ACTIONS(4812),
    [anon_sym_LT_EQ] = ACTIONS(4810),
    [anon_sym_LT] = ACTIONS(4810),
    [anon_sym_LT_LT] = ACTIONS(4810),
    [anon_sym_GT_GT] = ACTIONS(4810),
    [anon_sym___extension__] = ACTIONS(4810),
    [anon_sym_virtual] = ACTIONS(4810),
    [anon_sym_extern] = ACTIONS(4810),
    [anon_sym___attribute__] = ACTIONS(4810),
    [anon_sym___attribute] = ACTIONS(4810),
    [anon_sym_COLON_COLON] = ACTIONS(4812),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4812),
    [anon_sym___declspec] = ACTIONS(4810),
    [anon_sym___based] = ACTIONS(4810),
    [anon_sym_LBRACE] = ACTIONS(4812),
    [anon_sym_LBRACK] = ACTIONS(4810),
    [anon_sym_static] = ACTIONS(4810),
    [anon_sym_EQ] = ACTIONS(4810),
    [anon_sym_register] = ACTIONS(4810),
    [anon_sym_inline] = ACTIONS(4810),
    [anon_sym___inline] = ACTIONS(4810),
    [anon_sym___inline__] = ACTIONS(4810),
    [anon_sym___forceinline] = ACTIONS(4810),
    [anon_sym_thread_local] = ACTIONS(4810),
    [anon_sym___thread] = ACTIONS(4810),
    [anon_sym_const] = ACTIONS(4810),
    [anon_sym_constexpr] = ACTIONS(4810),
    [anon_sym_volatile] = ACTIONS(4810),
    [anon_sym_restrict] = ACTIONS(4810),
    [anon_sym___restrict__] = ACTIONS(4810),
    [anon_sym__Atomic] = ACTIONS(4810),
    [anon_sym__Noreturn] = ACTIONS(4810),
    [anon_sym_noreturn] = ACTIONS(4810),
    [anon_sym__Nonnull] = ACTIONS(4810),
    [anon_sym_mutable] = ACTIONS(4810),
    [anon_sym_constinit] = ACTIONS(4810),
    [anon_sym_consteval] = ACTIONS(4810),
    [anon_sym_alignas] = ACTIONS(4810),
    [anon_sym__Alignas] = ACTIONS(4810),
    [anon_sym_QMARK] = ACTIONS(4812),
    [anon_sym_STAR_EQ] = ACTIONS(4812),
    [anon_sym_SLASH_EQ] = ACTIONS(4812),
    [anon_sym_PERCENT_EQ] = ACTIONS(4812),
    [anon_sym_PLUS_EQ] = ACTIONS(4812),
    [anon_sym_DASH_EQ] = ACTIONS(4812),
    [anon_sym_LT_LT_EQ] = ACTIONS(4812),
    [anon_sym_GT_GT_EQ] = ACTIONS(4812),
    [anon_sym_AMP_EQ] = ACTIONS(4812),
    [anon_sym_CARET_EQ] = ACTIONS(4812),
    [anon_sym_PIPE_EQ] = ACTIONS(4812),
    [anon_sym_and_eq] = ACTIONS(4810),
    [anon_sym_or_eq] = ACTIONS(4810),
    [anon_sym_xor_eq] = ACTIONS(4810),
    [anon_sym_LT_EQ_GT] = ACTIONS(4812),
    [anon_sym_or] = ACTIONS(4810),
    [anon_sym_and] = ACTIONS(4810),
    [anon_sym_bitor] = ACTIONS(4810),
    [anon_sym_xor] = ACTIONS(4810),
    [anon_sym_bitand] = ACTIONS(4810),
    [anon_sym_not_eq] = ACTIONS(4810),
    [anon_sym_DASH_DASH] = ACTIONS(4812),
    [anon_sym_PLUS_PLUS] = ACTIONS(4812),
    [anon_sym_DOT] = ACTIONS(4810),
    [anon_sym_DOT_STAR] = ACTIONS(4812),
    [anon_sym_DASH_GT] = ACTIONS(4810),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4810),
    [anon_sym_decltype] = ACTIONS(4810),
    [anon_sym_template] = ACTIONS(4810),
    [anon_sym_operator] = ACTIONS(4810),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4812),
  },
  [1524] = {
    [sym_identifier] = ACTIONS(4855),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4859),
    [anon_sym_COMMA] = ACTIONS(4859),
    [anon_sym_RPAREN] = ACTIONS(4859),
    [anon_sym_LPAREN2] = ACTIONS(4859),
    [anon_sym_TILDE] = ACTIONS(4862),
    [anon_sym_DASH] = ACTIONS(4864),
    [anon_sym_PLUS] = ACTIONS(4864),
    [anon_sym_STAR] = ACTIONS(4866),
    [anon_sym_SLASH] = ACTIONS(4864),
    [anon_sym_PERCENT] = ACTIONS(4864),
    [anon_sym_PIPE_PIPE] = ACTIONS(4857),
    [anon_sym_AMP_AMP] = ACTIONS(4859),
    [anon_sym_PIPE] = ACTIONS(4864),
    [anon_sym_CARET] = ACTIONS(4864),
    [anon_sym_AMP] = ACTIONS(4866),
    [anon_sym_EQ_EQ] = ACTIONS(4857),
    [anon_sym_BANG_EQ] = ACTIONS(4857),
    [anon_sym_GT] = ACTIONS(4864),
    [anon_sym_GT_EQ] = ACTIONS(4857),
    [anon_sym_LT_EQ] = ACTIONS(4864),
    [anon_sym_LT] = ACTIONS(4864),
    [anon_sym_LT_LT] = ACTIONS(4864),
    [anon_sym_GT_GT] = ACTIONS(4864),
    [anon_sym___extension__] = ACTIONS(4855),
    [anon_sym_virtual] = ACTIONS(4855),
    [anon_sym_extern] = ACTIONS(4855),
    [anon_sym___attribute__] = ACTIONS(4855),
    [anon_sym___attribute] = ACTIONS(4855),
    [anon_sym_COLON_COLON] = ACTIONS(4862),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4862),
    [anon_sym___declspec] = ACTIONS(4855),
    [anon_sym___based] = ACTIONS(4855),
    [anon_sym_LBRACE] = ACTIONS(4862),
    [anon_sym_LBRACK] = ACTIONS(4866),
    [anon_sym_static] = ACTIONS(4855),
    [anon_sym_EQ] = ACTIONS(4866),
    [anon_sym_register] = ACTIONS(4855),
    [anon_sym_inline] = ACTIONS(4855),
    [anon_sym___inline] = ACTIONS(4855),
    [anon_sym___inline__] = ACTIONS(4855),
    [anon_sym___forceinline] = ACTIONS(4855),
    [anon_sym_thread_local] = ACTIONS(4855),
    [anon_sym___thread] = ACTIONS(4855),
    [anon_sym_const] = ACTIONS(4855),
    [anon_sym_constexpr] = ACTIONS(4855),
    [anon_sym_volatile] = ACTIONS(4855),
    [anon_sym_restrict] = ACTIONS(4855),
    [anon_sym___restrict__] = ACTIONS(4855),
    [anon_sym__Atomic] = ACTIONS(4855),
    [anon_sym__Noreturn] = ACTIONS(4855),
    [anon_sym_noreturn] = ACTIONS(4855),
    [anon_sym__Nonnull] = ACTIONS(4855),
    [anon_sym_mutable] = ACTIONS(4855),
    [anon_sym_constinit] = ACTIONS(4855),
    [anon_sym_consteval] = ACTIONS(4855),
    [anon_sym_alignas] = ACTIONS(4855),
    [anon_sym__Alignas] = ACTIONS(4855),
    [anon_sym_QMARK] = ACTIONS(4857),
    [anon_sym_STAR_EQ] = ACTIONS(4857),
    [anon_sym_SLASH_EQ] = ACTIONS(4857),
    [anon_sym_PERCENT_EQ] = ACTIONS(4857),
    [anon_sym_PLUS_EQ] = ACTIONS(4857),
    [anon_sym_DASH_EQ] = ACTIONS(4857),
    [anon_sym_LT_LT_EQ] = ACTIONS(4857),
    [anon_sym_GT_GT_EQ] = ACTIONS(4857),
    [anon_sym_AMP_EQ] = ACTIONS(4857),
    [anon_sym_CARET_EQ] = ACTIONS(4857),
    [anon_sym_PIPE_EQ] = ACTIONS(4857),
    [anon_sym_and_eq] = ACTIONS(4864),
    [anon_sym_or_eq] = ACTIONS(4864),
    [anon_sym_xor_eq] = ACTIONS(4864),
    [anon_sym_LT_EQ_GT] = ACTIONS(4857),
    [anon_sym_or] = ACTIONS(4864),
    [anon_sym_and] = ACTIONS(4864),
    [anon_sym_bitor] = ACTIONS(4864),
    [anon_sym_xor] = ACTIONS(4864),
    [anon_sym_bitand] = ACTIONS(4864),
    [anon_sym_not_eq] = ACTIONS(4864),
    [anon_sym_DASH_DASH] = ACTIONS(4857),
    [anon_sym_PLUS_PLUS] = ACTIONS(4857),
    [anon_sym_DOT] = ACTIONS(4864),
    [anon_sym_DOT_STAR] = ACTIONS(4857),
    [anon_sym_DASH_GT] = ACTIONS(4864),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4855),
    [anon_sym_decltype] = ACTIONS(4855),
    [anon_sym_template] = ACTIONS(4855),
    [anon_sym_operator] = ACTIONS(4855),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4857),
  },
  [1525] = {
    [sym_identifier] = ACTIONS(4814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4816),
    [anon_sym_COMMA] = ACTIONS(4816),
    [anon_sym_RPAREN] = ACTIONS(4816),
    [anon_sym_LPAREN2] = ACTIONS(4816),
    [anon_sym_TILDE] = ACTIONS(4816),
    [anon_sym_DASH] = ACTIONS(4814),
    [anon_sym_PLUS] = ACTIONS(4814),
    [anon_sym_STAR] = ACTIONS(4816),
    [anon_sym_SLASH] = ACTIONS(4814),
    [anon_sym_PERCENT] = ACTIONS(4816),
    [anon_sym_PIPE_PIPE] = ACTIONS(4816),
    [anon_sym_AMP_AMP] = ACTIONS(4816),
    [anon_sym_PIPE] = ACTIONS(4814),
    [anon_sym_CARET] = ACTIONS(4816),
    [anon_sym_AMP] = ACTIONS(4814),
    [anon_sym_EQ_EQ] = ACTIONS(4816),
    [anon_sym_BANG_EQ] = ACTIONS(4816),
    [anon_sym_GT] = ACTIONS(4814),
    [anon_sym_GT_EQ] = ACTIONS(4816),
    [anon_sym_LT_EQ] = ACTIONS(4814),
    [anon_sym_LT] = ACTIONS(4814),
    [anon_sym_LT_LT] = ACTIONS(4816),
    [anon_sym_GT_GT] = ACTIONS(4816),
    [anon_sym_SEMI] = ACTIONS(4816),
    [anon_sym___extension__] = ACTIONS(4814),
    [anon_sym_virtual] = ACTIONS(4814),
    [anon_sym_extern] = ACTIONS(4814),
    [anon_sym___attribute__] = ACTIONS(4814),
    [anon_sym___attribute] = ACTIONS(4814),
    [anon_sym_COLON_COLON] = ACTIONS(4816),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4816),
    [anon_sym___declspec] = ACTIONS(4814),
    [anon_sym___based] = ACTIONS(4814),
    [anon_sym___cdecl] = ACTIONS(4814),
    [anon_sym___clrcall] = ACTIONS(4814),
    [anon_sym___stdcall] = ACTIONS(4814),
    [anon_sym___fastcall] = ACTIONS(4814),
    [anon_sym___thiscall] = ACTIONS(4814),
    [anon_sym___vectorcall] = ACTIONS(4814),
    [anon_sym_LBRACE] = ACTIONS(4816),
    [anon_sym_RBRACE] = ACTIONS(4816),
    [anon_sym_LBRACK] = ACTIONS(4814),
    [anon_sym_static] = ACTIONS(4814),
    [anon_sym_RBRACK] = ACTIONS(4816),
    [anon_sym_EQ] = ACTIONS(4814),
    [anon_sym_register] = ACTIONS(4814),
    [anon_sym_inline] = ACTIONS(4814),
    [anon_sym___inline] = ACTIONS(4814),
    [anon_sym___inline__] = ACTIONS(4814),
    [anon_sym___forceinline] = ACTIONS(4814),
    [anon_sym_thread_local] = ACTIONS(4814),
    [anon_sym___thread] = ACTIONS(4814),
    [anon_sym_const] = ACTIONS(4814),
    [anon_sym_constexpr] = ACTIONS(4814),
    [anon_sym_volatile] = ACTIONS(4814),
    [anon_sym_restrict] = ACTIONS(4814),
    [anon_sym___restrict__] = ACTIONS(4814),
    [anon_sym__Atomic] = ACTIONS(4814),
    [anon_sym__Noreturn] = ACTIONS(4814),
    [anon_sym_noreturn] = ACTIONS(4814),
    [anon_sym__Nonnull] = ACTIONS(4814),
    [anon_sym_mutable] = ACTIONS(4814),
    [anon_sym_constinit] = ACTIONS(4814),
    [anon_sym_consteval] = ACTIONS(4814),
    [anon_sym_alignas] = ACTIONS(4814),
    [anon_sym__Alignas] = ACTIONS(4814),
    [anon_sym_COLON] = ACTIONS(4814),
    [anon_sym_QMARK] = ACTIONS(4816),
    [anon_sym_LT_EQ_GT] = ACTIONS(4816),
    [anon_sym_or] = ACTIONS(4814),
    [anon_sym_and] = ACTIONS(4814),
    [anon_sym_bitor] = ACTIONS(4814),
    [anon_sym_xor] = ACTIONS(4814),
    [anon_sym_bitand] = ACTIONS(4814),
    [anon_sym_not_eq] = ACTIONS(4814),
    [anon_sym_DASH_DASH] = ACTIONS(4816),
    [anon_sym_PLUS_PLUS] = ACTIONS(4816),
    [anon_sym_DOT] = ACTIONS(4814),
    [anon_sym_DOT_STAR] = ACTIONS(4816),
    [anon_sym_DASH_GT] = ACTIONS(4816),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4814),
    [anon_sym_decltype] = ACTIONS(4814),
    [anon_sym_final] = ACTIONS(4814),
    [anon_sym_override] = ACTIONS(4814),
    [anon_sym_template] = ACTIONS(4814),
    [anon_sym_operator] = ACTIONS(4814),
    [anon_sym_try] = ACTIONS(4814),
    [anon_sym_requires] = ACTIONS(4814),
  },
  [1526] = {
    [sym_identifier] = ACTIONS(4830),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4832),
    [anon_sym_COMMA] = ACTIONS(4832),
    [anon_sym_RPAREN] = ACTIONS(4832),
    [anon_sym_LPAREN2] = ACTIONS(4832),
    [anon_sym_TILDE] = ACTIONS(4832),
    [anon_sym_DASH] = ACTIONS(4830),
    [anon_sym_PLUS] = ACTIONS(4830),
    [anon_sym_STAR] = ACTIONS(4832),
    [anon_sym_SLASH] = ACTIONS(4830),
    [anon_sym_PERCENT] = ACTIONS(4832),
    [anon_sym_PIPE_PIPE] = ACTIONS(4832),
    [anon_sym_AMP_AMP] = ACTIONS(4832),
    [anon_sym_PIPE] = ACTIONS(4830),
    [anon_sym_CARET] = ACTIONS(4832),
    [anon_sym_AMP] = ACTIONS(4830),
    [anon_sym_EQ_EQ] = ACTIONS(4832),
    [anon_sym_BANG_EQ] = ACTIONS(4832),
    [anon_sym_GT] = ACTIONS(4830),
    [anon_sym_GT_EQ] = ACTIONS(4832),
    [anon_sym_LT_EQ] = ACTIONS(4830),
    [anon_sym_LT] = ACTIONS(4830),
    [anon_sym_LT_LT] = ACTIONS(4832),
    [anon_sym_GT_GT] = ACTIONS(4832),
    [anon_sym_SEMI] = ACTIONS(4832),
    [anon_sym___extension__] = ACTIONS(4830),
    [anon_sym_virtual] = ACTIONS(4830),
    [anon_sym_extern] = ACTIONS(4830),
    [anon_sym___attribute__] = ACTIONS(4830),
    [anon_sym___attribute] = ACTIONS(4830),
    [anon_sym_COLON_COLON] = ACTIONS(4832),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4832),
    [anon_sym___declspec] = ACTIONS(4830),
    [anon_sym___based] = ACTIONS(4830),
    [anon_sym___cdecl] = ACTIONS(4830),
    [anon_sym___clrcall] = ACTIONS(4830),
    [anon_sym___stdcall] = ACTIONS(4830),
    [anon_sym___fastcall] = ACTIONS(4830),
    [anon_sym___thiscall] = ACTIONS(4830),
    [anon_sym___vectorcall] = ACTIONS(4830),
    [anon_sym_LBRACE] = ACTIONS(4832),
    [anon_sym_RBRACE] = ACTIONS(4832),
    [anon_sym_LBRACK] = ACTIONS(4830),
    [anon_sym_static] = ACTIONS(4830),
    [anon_sym_RBRACK] = ACTIONS(4832),
    [anon_sym_EQ] = ACTIONS(4830),
    [anon_sym_register] = ACTIONS(4830),
    [anon_sym_inline] = ACTIONS(4830),
    [anon_sym___inline] = ACTIONS(4830),
    [anon_sym___inline__] = ACTIONS(4830),
    [anon_sym___forceinline] = ACTIONS(4830),
    [anon_sym_thread_local] = ACTIONS(4830),
    [anon_sym___thread] = ACTIONS(4830),
    [anon_sym_const] = ACTIONS(4830),
    [anon_sym_constexpr] = ACTIONS(4830),
    [anon_sym_volatile] = ACTIONS(4830),
    [anon_sym_restrict] = ACTIONS(4830),
    [anon_sym___restrict__] = ACTIONS(4830),
    [anon_sym__Atomic] = ACTIONS(4830),
    [anon_sym__Noreturn] = ACTIONS(4830),
    [anon_sym_noreturn] = ACTIONS(4830),
    [anon_sym__Nonnull] = ACTIONS(4830),
    [anon_sym_mutable] = ACTIONS(4830),
    [anon_sym_constinit] = ACTIONS(4830),
    [anon_sym_consteval] = ACTIONS(4830),
    [anon_sym_alignas] = ACTIONS(4830),
    [anon_sym__Alignas] = ACTIONS(4830),
    [anon_sym_COLON] = ACTIONS(4830),
    [anon_sym_QMARK] = ACTIONS(4832),
    [anon_sym_LT_EQ_GT] = ACTIONS(4832),
    [anon_sym_or] = ACTIONS(4830),
    [anon_sym_and] = ACTIONS(4830),
    [anon_sym_bitor] = ACTIONS(4830),
    [anon_sym_xor] = ACTIONS(4830),
    [anon_sym_bitand] = ACTIONS(4830),
    [anon_sym_not_eq] = ACTIONS(4830),
    [anon_sym_DASH_DASH] = ACTIONS(4832),
    [anon_sym_PLUS_PLUS] = ACTIONS(4832),
    [anon_sym_DOT] = ACTIONS(4830),
    [anon_sym_DOT_STAR] = ACTIONS(4832),
    [anon_sym_DASH_GT] = ACTIONS(4832),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4830),
    [anon_sym_decltype] = ACTIONS(4830),
    [anon_sym_final] = ACTIONS(4830),
    [anon_sym_override] = ACTIONS(4830),
    [anon_sym_template] = ACTIONS(4830),
    [anon_sym_operator] = ACTIONS(4830),
    [anon_sym_try] = ACTIONS(4830),
    [anon_sym_requires] = ACTIONS(4830),
  },
  [1527] = {
    [sym_identifier] = ACTIONS(4826),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4828),
    [anon_sym_COMMA] = ACTIONS(4828),
    [anon_sym_RPAREN] = ACTIONS(4828),
    [anon_sym_LPAREN2] = ACTIONS(4828),
    [anon_sym_TILDE] = ACTIONS(4828),
    [anon_sym_DASH] = ACTIONS(4826),
    [anon_sym_PLUS] = ACTIONS(4826),
    [anon_sym_STAR] = ACTIONS(4828),
    [anon_sym_SLASH] = ACTIONS(4826),
    [anon_sym_PERCENT] = ACTIONS(4828),
    [anon_sym_PIPE_PIPE] = ACTIONS(4828),
    [anon_sym_AMP_AMP] = ACTIONS(4828),
    [anon_sym_PIPE] = ACTIONS(4826),
    [anon_sym_CARET] = ACTIONS(4828),
    [anon_sym_AMP] = ACTIONS(4826),
    [anon_sym_EQ_EQ] = ACTIONS(4828),
    [anon_sym_BANG_EQ] = ACTIONS(4828),
    [anon_sym_GT] = ACTIONS(4826),
    [anon_sym_GT_EQ] = ACTIONS(4828),
    [anon_sym_LT_EQ] = ACTIONS(4826),
    [anon_sym_LT] = ACTIONS(4826),
    [anon_sym_LT_LT] = ACTIONS(4828),
    [anon_sym_GT_GT] = ACTIONS(4828),
    [anon_sym_SEMI] = ACTIONS(4828),
    [anon_sym___extension__] = ACTIONS(4826),
    [anon_sym_virtual] = ACTIONS(4826),
    [anon_sym_extern] = ACTIONS(4826),
    [anon_sym___attribute__] = ACTIONS(4826),
    [anon_sym___attribute] = ACTIONS(4826),
    [anon_sym_COLON_COLON] = ACTIONS(4828),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4828),
    [anon_sym___declspec] = ACTIONS(4826),
    [anon_sym___based] = ACTIONS(4826),
    [anon_sym___cdecl] = ACTIONS(4826),
    [anon_sym___clrcall] = ACTIONS(4826),
    [anon_sym___stdcall] = ACTIONS(4826),
    [anon_sym___fastcall] = ACTIONS(4826),
    [anon_sym___thiscall] = ACTIONS(4826),
    [anon_sym___vectorcall] = ACTIONS(4826),
    [anon_sym_LBRACE] = ACTIONS(4828),
    [anon_sym_RBRACE] = ACTIONS(4828),
    [anon_sym_LBRACK] = ACTIONS(4826),
    [anon_sym_static] = ACTIONS(4826),
    [anon_sym_RBRACK] = ACTIONS(4828),
    [anon_sym_EQ] = ACTIONS(4826),
    [anon_sym_register] = ACTIONS(4826),
    [anon_sym_inline] = ACTIONS(4826),
    [anon_sym___inline] = ACTIONS(4826),
    [anon_sym___inline__] = ACTIONS(4826),
    [anon_sym___forceinline] = ACTIONS(4826),
    [anon_sym_thread_local] = ACTIONS(4826),
    [anon_sym___thread] = ACTIONS(4826),
    [anon_sym_const] = ACTIONS(4826),
    [anon_sym_constexpr] = ACTIONS(4826),
    [anon_sym_volatile] = ACTIONS(4826),
    [anon_sym_restrict] = ACTIONS(4826),
    [anon_sym___restrict__] = ACTIONS(4826),
    [anon_sym__Atomic] = ACTIONS(4826),
    [anon_sym__Noreturn] = ACTIONS(4826),
    [anon_sym_noreturn] = ACTIONS(4826),
    [anon_sym__Nonnull] = ACTIONS(4826),
    [anon_sym_mutable] = ACTIONS(4826),
    [anon_sym_constinit] = ACTIONS(4826),
    [anon_sym_consteval] = ACTIONS(4826),
    [anon_sym_alignas] = ACTIONS(4826),
    [anon_sym__Alignas] = ACTIONS(4826),
    [anon_sym_COLON] = ACTIONS(4826),
    [anon_sym_QMARK] = ACTIONS(4828),
    [anon_sym_LT_EQ_GT] = ACTIONS(4828),
    [anon_sym_or] = ACTIONS(4826),
    [anon_sym_and] = ACTIONS(4826),
    [anon_sym_bitor] = ACTIONS(4826),
    [anon_sym_xor] = ACTIONS(4826),
    [anon_sym_bitand] = ACTIONS(4826),
    [anon_sym_not_eq] = ACTIONS(4826),
    [anon_sym_DASH_DASH] = ACTIONS(4828),
    [anon_sym_PLUS_PLUS] = ACTIONS(4828),
    [anon_sym_DOT] = ACTIONS(4826),
    [anon_sym_DOT_STAR] = ACTIONS(4828),
    [anon_sym_DASH_GT] = ACTIONS(4828),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4826),
    [anon_sym_decltype] = ACTIONS(4826),
    [anon_sym_final] = ACTIONS(4826),
    [anon_sym_override] = ACTIONS(4826),
    [anon_sym_template] = ACTIONS(4826),
    [anon_sym_operator] = ACTIONS(4826),
    [anon_sym_try] = ACTIONS(4826),
    [anon_sym_requires] = ACTIONS(4826),
  },
  [1528] = {
    [sym_identifier] = ACTIONS(4810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4812),
    [anon_sym_COMMA] = ACTIONS(4812),
    [anon_sym_RPAREN] = ACTIONS(4812),
    [anon_sym_LPAREN2] = ACTIONS(4812),
    [anon_sym_TILDE] = ACTIONS(4812),
    [anon_sym_DASH] = ACTIONS(4810),
    [anon_sym_PLUS] = ACTIONS(4810),
    [anon_sym_STAR] = ACTIONS(4812),
    [anon_sym_SLASH] = ACTIONS(4810),
    [anon_sym_PERCENT] = ACTIONS(4812),
    [anon_sym_PIPE_PIPE] = ACTIONS(4812),
    [anon_sym_AMP_AMP] = ACTIONS(4812),
    [anon_sym_PIPE] = ACTIONS(4810),
    [anon_sym_CARET] = ACTIONS(4812),
    [anon_sym_AMP] = ACTIONS(4810),
    [anon_sym_EQ_EQ] = ACTIONS(4812),
    [anon_sym_BANG_EQ] = ACTIONS(4812),
    [anon_sym_GT] = ACTIONS(4810),
    [anon_sym_GT_EQ] = ACTIONS(4812),
    [anon_sym_LT_EQ] = ACTIONS(4810),
    [anon_sym_LT] = ACTIONS(4810),
    [anon_sym_LT_LT] = ACTIONS(4812),
    [anon_sym_GT_GT] = ACTIONS(4812),
    [anon_sym_SEMI] = ACTIONS(4812),
    [anon_sym___extension__] = ACTIONS(4810),
    [anon_sym_virtual] = ACTIONS(4810),
    [anon_sym_extern] = ACTIONS(4810),
    [anon_sym___attribute__] = ACTIONS(4810),
    [anon_sym___attribute] = ACTIONS(4810),
    [anon_sym_COLON_COLON] = ACTIONS(4812),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4812),
    [anon_sym___declspec] = ACTIONS(4810),
    [anon_sym___based] = ACTIONS(4810),
    [anon_sym___cdecl] = ACTIONS(4810),
    [anon_sym___clrcall] = ACTIONS(4810),
    [anon_sym___stdcall] = ACTIONS(4810),
    [anon_sym___fastcall] = ACTIONS(4810),
    [anon_sym___thiscall] = ACTIONS(4810),
    [anon_sym___vectorcall] = ACTIONS(4810),
    [anon_sym_LBRACE] = ACTIONS(4812),
    [anon_sym_RBRACE] = ACTIONS(4812),
    [anon_sym_LBRACK] = ACTIONS(4810),
    [anon_sym_static] = ACTIONS(4810),
    [anon_sym_RBRACK] = ACTIONS(4812),
    [anon_sym_EQ] = ACTIONS(4810),
    [anon_sym_register] = ACTIONS(4810),
    [anon_sym_inline] = ACTIONS(4810),
    [anon_sym___inline] = ACTIONS(4810),
    [anon_sym___inline__] = ACTIONS(4810),
    [anon_sym___forceinline] = ACTIONS(4810),
    [anon_sym_thread_local] = ACTIONS(4810),
    [anon_sym___thread] = ACTIONS(4810),
    [anon_sym_const] = ACTIONS(4810),
    [anon_sym_constexpr] = ACTIONS(4810),
    [anon_sym_volatile] = ACTIONS(4810),
    [anon_sym_restrict] = ACTIONS(4810),
    [anon_sym___restrict__] = ACTIONS(4810),
    [anon_sym__Atomic] = ACTIONS(4810),
    [anon_sym__Noreturn] = ACTIONS(4810),
    [anon_sym_noreturn] = ACTIONS(4810),
    [anon_sym__Nonnull] = ACTIONS(4810),
    [anon_sym_mutable] = ACTIONS(4810),
    [anon_sym_constinit] = ACTIONS(4810),
    [anon_sym_consteval] = ACTIONS(4810),
    [anon_sym_alignas] = ACTIONS(4810),
    [anon_sym__Alignas] = ACTIONS(4810),
    [anon_sym_COLON] = ACTIONS(4810),
    [anon_sym_QMARK] = ACTIONS(4812),
    [anon_sym_LT_EQ_GT] = ACTIONS(4812),
    [anon_sym_or] = ACTIONS(4810),
    [anon_sym_and] = ACTIONS(4810),
    [anon_sym_bitor] = ACTIONS(4810),
    [anon_sym_xor] = ACTIONS(4810),
    [anon_sym_bitand] = ACTIONS(4810),
    [anon_sym_not_eq] = ACTIONS(4810),
    [anon_sym_DASH_DASH] = ACTIONS(4812),
    [anon_sym_PLUS_PLUS] = ACTIONS(4812),
    [anon_sym_DOT] = ACTIONS(4810),
    [anon_sym_DOT_STAR] = ACTIONS(4812),
    [anon_sym_DASH_GT] = ACTIONS(4812),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4810),
    [anon_sym_decltype] = ACTIONS(4810),
    [anon_sym_final] = ACTIONS(4810),
    [anon_sym_override] = ACTIONS(4810),
    [anon_sym_template] = ACTIONS(4810),
    [anon_sym_operator] = ACTIONS(4810),
    [anon_sym_try] = ACTIONS(4810),
    [anon_sym_requires] = ACTIONS(4810),
  },
  [1529] = {
    [sym_identifier] = ACTIONS(4826),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4828),
    [anon_sym_COMMA] = ACTIONS(4828),
    [anon_sym_RPAREN] = ACTIONS(4828),
    [anon_sym_LPAREN2] = ACTIONS(4828),
    [anon_sym_TILDE] = ACTIONS(4828),
    [anon_sym_DASH] = ACTIONS(4826),
    [anon_sym_PLUS] = ACTIONS(4826),
    [anon_sym_STAR] = ACTIONS(4826),
    [anon_sym_SLASH] = ACTIONS(4826),
    [anon_sym_PERCENT] = ACTIONS(4826),
    [anon_sym_PIPE_PIPE] = ACTIONS(4828),
    [anon_sym_AMP_AMP] = ACTIONS(4828),
    [anon_sym_PIPE] = ACTIONS(4826),
    [anon_sym_CARET] = ACTIONS(4826),
    [anon_sym_AMP] = ACTIONS(4826),
    [anon_sym_EQ_EQ] = ACTIONS(4828),
    [anon_sym_BANG_EQ] = ACTIONS(4828),
    [anon_sym_GT] = ACTIONS(4826),
    [anon_sym_GT_EQ] = ACTIONS(4828),
    [anon_sym_LT_EQ] = ACTIONS(4826),
    [anon_sym_LT] = ACTIONS(4826),
    [anon_sym_LT_LT] = ACTIONS(4826),
    [anon_sym_GT_GT] = ACTIONS(4826),
    [anon_sym___extension__] = ACTIONS(4826),
    [anon_sym_virtual] = ACTIONS(4826),
    [anon_sym_extern] = ACTIONS(4826),
    [anon_sym___attribute__] = ACTIONS(4826),
    [anon_sym___attribute] = ACTIONS(4826),
    [anon_sym_COLON_COLON] = ACTIONS(4828),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4828),
    [anon_sym___declspec] = ACTIONS(4826),
    [anon_sym___based] = ACTIONS(4826),
    [anon_sym_LBRACE] = ACTIONS(4828),
    [anon_sym_LBRACK] = ACTIONS(4826),
    [anon_sym_static] = ACTIONS(4826),
    [anon_sym_EQ] = ACTIONS(4826),
    [anon_sym_register] = ACTIONS(4826),
    [anon_sym_inline] = ACTIONS(4826),
    [anon_sym___inline] = ACTIONS(4826),
    [anon_sym___inline__] = ACTIONS(4826),
    [anon_sym___forceinline] = ACTIONS(4826),
    [anon_sym_thread_local] = ACTIONS(4826),
    [anon_sym___thread] = ACTIONS(4826),
    [anon_sym_const] = ACTIONS(4826),
    [anon_sym_constexpr] = ACTIONS(4826),
    [anon_sym_volatile] = ACTIONS(4826),
    [anon_sym_restrict] = ACTIONS(4826),
    [anon_sym___restrict__] = ACTIONS(4826),
    [anon_sym__Atomic] = ACTIONS(4826),
    [anon_sym__Noreturn] = ACTIONS(4826),
    [anon_sym_noreturn] = ACTIONS(4826),
    [anon_sym__Nonnull] = ACTIONS(4826),
    [anon_sym_mutable] = ACTIONS(4826),
    [anon_sym_constinit] = ACTIONS(4826),
    [anon_sym_consteval] = ACTIONS(4826),
    [anon_sym_alignas] = ACTIONS(4826),
    [anon_sym__Alignas] = ACTIONS(4826),
    [anon_sym_QMARK] = ACTIONS(4828),
    [anon_sym_STAR_EQ] = ACTIONS(4828),
    [anon_sym_SLASH_EQ] = ACTIONS(4828),
    [anon_sym_PERCENT_EQ] = ACTIONS(4828),
    [anon_sym_PLUS_EQ] = ACTIONS(4828),
    [anon_sym_DASH_EQ] = ACTIONS(4828),
    [anon_sym_LT_LT_EQ] = ACTIONS(4828),
    [anon_sym_GT_GT_EQ] = ACTIONS(4828),
    [anon_sym_AMP_EQ] = ACTIONS(4828),
    [anon_sym_CARET_EQ] = ACTIONS(4828),
    [anon_sym_PIPE_EQ] = ACTIONS(4828),
    [anon_sym_and_eq] = ACTIONS(4826),
    [anon_sym_or_eq] = ACTIONS(4826),
    [anon_sym_xor_eq] = ACTIONS(4826),
    [anon_sym_LT_EQ_GT] = ACTIONS(4828),
    [anon_sym_or] = ACTIONS(4826),
    [anon_sym_and] = ACTIONS(4826),
    [anon_sym_bitor] = ACTIONS(4826),
    [anon_sym_xor] = ACTIONS(4826),
    [anon_sym_bitand] = ACTIONS(4826),
    [anon_sym_not_eq] = ACTIONS(4826),
    [anon_sym_DASH_DASH] = ACTIONS(4828),
    [anon_sym_PLUS_PLUS] = ACTIONS(4828),
    [anon_sym_DOT] = ACTIONS(4826),
    [anon_sym_DOT_STAR] = ACTIONS(4828),
    [anon_sym_DASH_GT] = ACTIONS(4826),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4826),
    [anon_sym_decltype] = ACTIONS(4826),
    [anon_sym_template] = ACTIONS(4826),
    [anon_sym_operator] = ACTIONS(4826),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4828),
  },
  [1530] = {
    [sym_identifier] = ACTIONS(4818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4820),
    [anon_sym_COMMA] = ACTIONS(4820),
    [anon_sym_RPAREN] = ACTIONS(4820),
    [anon_sym_LPAREN2] = ACTIONS(4820),
    [anon_sym_TILDE] = ACTIONS(4820),
    [anon_sym_DASH] = ACTIONS(4818),
    [anon_sym_PLUS] = ACTIONS(4818),
    [anon_sym_STAR] = ACTIONS(4818),
    [anon_sym_SLASH] = ACTIONS(4818),
    [anon_sym_PERCENT] = ACTIONS(4818),
    [anon_sym_PIPE_PIPE] = ACTIONS(4820),
    [anon_sym_AMP_AMP] = ACTIONS(4820),
    [anon_sym_PIPE] = ACTIONS(4818),
    [anon_sym_CARET] = ACTIONS(4818),
    [anon_sym_AMP] = ACTIONS(4818),
    [anon_sym_EQ_EQ] = ACTIONS(4820),
    [anon_sym_BANG_EQ] = ACTIONS(4820),
    [anon_sym_GT] = ACTIONS(4818),
    [anon_sym_GT_EQ] = ACTIONS(4820),
    [anon_sym_LT_EQ] = ACTIONS(4818),
    [anon_sym_LT] = ACTIONS(4818),
    [anon_sym_LT_LT] = ACTIONS(4818),
    [anon_sym_GT_GT] = ACTIONS(4818),
    [anon_sym___extension__] = ACTIONS(4818),
    [anon_sym_virtual] = ACTIONS(4818),
    [anon_sym_extern] = ACTIONS(4818),
    [anon_sym___attribute__] = ACTIONS(4818),
    [anon_sym___attribute] = ACTIONS(4818),
    [anon_sym_COLON_COLON] = ACTIONS(4820),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4820),
    [anon_sym___declspec] = ACTIONS(4818),
    [anon_sym___based] = ACTIONS(4818),
    [anon_sym_LBRACE] = ACTIONS(4820),
    [anon_sym_LBRACK] = ACTIONS(4818),
    [anon_sym_static] = ACTIONS(4818),
    [anon_sym_EQ] = ACTIONS(4818),
    [anon_sym_register] = ACTIONS(4818),
    [anon_sym_inline] = ACTIONS(4818),
    [anon_sym___inline] = ACTIONS(4818),
    [anon_sym___inline__] = ACTIONS(4818),
    [anon_sym___forceinline] = ACTIONS(4818),
    [anon_sym_thread_local] = ACTIONS(4818),
    [anon_sym___thread] = ACTIONS(4818),
    [anon_sym_const] = ACTIONS(4818),
    [anon_sym_constexpr] = ACTIONS(4818),
    [anon_sym_volatile] = ACTIONS(4818),
    [anon_sym_restrict] = ACTIONS(4818),
    [anon_sym___restrict__] = ACTIONS(4818),
    [anon_sym__Atomic] = ACTIONS(4818),
    [anon_sym__Noreturn] = ACTIONS(4818),
    [anon_sym_noreturn] = ACTIONS(4818),
    [anon_sym__Nonnull] = ACTIONS(4818),
    [anon_sym_mutable] = ACTIONS(4818),
    [anon_sym_constinit] = ACTIONS(4818),
    [anon_sym_consteval] = ACTIONS(4818),
    [anon_sym_alignas] = ACTIONS(4818),
    [anon_sym__Alignas] = ACTIONS(4818),
    [anon_sym_QMARK] = ACTIONS(4820),
    [anon_sym_STAR_EQ] = ACTIONS(4820),
    [anon_sym_SLASH_EQ] = ACTIONS(4820),
    [anon_sym_PERCENT_EQ] = ACTIONS(4820),
    [anon_sym_PLUS_EQ] = ACTIONS(4820),
    [anon_sym_DASH_EQ] = ACTIONS(4820),
    [anon_sym_LT_LT_EQ] = ACTIONS(4820),
    [anon_sym_GT_GT_EQ] = ACTIONS(4820),
    [anon_sym_AMP_EQ] = ACTIONS(4820),
    [anon_sym_CARET_EQ] = ACTIONS(4820),
    [anon_sym_PIPE_EQ] = ACTIONS(4820),
    [anon_sym_and_eq] = ACTIONS(4818),
    [anon_sym_or_eq] = ACTIONS(4818),
    [anon_sym_xor_eq] = ACTIONS(4818),
    [anon_sym_LT_EQ_GT] = ACTIONS(4820),
    [anon_sym_or] = ACTIONS(4818),
    [anon_sym_and] = ACTIONS(4818),
    [anon_sym_bitor] = ACTIONS(4818),
    [anon_sym_xor] = ACTIONS(4818),
    [anon_sym_bitand] = ACTIONS(4818),
    [anon_sym_not_eq] = ACTIONS(4818),
    [anon_sym_DASH_DASH] = ACTIONS(4820),
    [anon_sym_PLUS_PLUS] = ACTIONS(4820),
    [anon_sym_DOT] = ACTIONS(4818),
    [anon_sym_DOT_STAR] = ACTIONS(4820),
    [anon_sym_DASH_GT] = ACTIONS(4818),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4818),
    [anon_sym_decltype] = ACTIONS(4818),
    [anon_sym_template] = ACTIONS(4818),
    [anon_sym_operator] = ACTIONS(4818),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4820),
  },
  [1531] = {
    [sym_identifier] = ACTIONS(4822),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4824),
    [anon_sym_COMMA] = ACTIONS(4824),
    [anon_sym_RPAREN] = ACTIONS(4824),
    [anon_sym_LPAREN2] = ACTIONS(4824),
    [anon_sym_TILDE] = ACTIONS(4824),
    [anon_sym_DASH] = ACTIONS(4822),
    [anon_sym_PLUS] = ACTIONS(4822),
    [anon_sym_STAR] = ACTIONS(4822),
    [anon_sym_SLASH] = ACTIONS(4822),
    [anon_sym_PERCENT] = ACTIONS(4822),
    [anon_sym_PIPE_PIPE] = ACTIONS(4824),
    [anon_sym_AMP_AMP] = ACTIONS(4824),
    [anon_sym_PIPE] = ACTIONS(4822),
    [anon_sym_CARET] = ACTIONS(4822),
    [anon_sym_AMP] = ACTIONS(4822),
    [anon_sym_EQ_EQ] = ACTIONS(4824),
    [anon_sym_BANG_EQ] = ACTIONS(4824),
    [anon_sym_GT] = ACTIONS(4822),
    [anon_sym_GT_EQ] = ACTIONS(4824),
    [anon_sym_LT_EQ] = ACTIONS(4822),
    [anon_sym_LT] = ACTIONS(4822),
    [anon_sym_LT_LT] = ACTIONS(4822),
    [anon_sym_GT_GT] = ACTIONS(4822),
    [anon_sym___extension__] = ACTIONS(4822),
    [anon_sym_virtual] = ACTIONS(4822),
    [anon_sym_extern] = ACTIONS(4822),
    [anon_sym___attribute__] = ACTIONS(4822),
    [anon_sym___attribute] = ACTIONS(4822),
    [anon_sym_COLON_COLON] = ACTIONS(4824),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4824),
    [anon_sym___declspec] = ACTIONS(4822),
    [anon_sym___based] = ACTIONS(4822),
    [anon_sym_LBRACE] = ACTIONS(4824),
    [anon_sym_LBRACK] = ACTIONS(4822),
    [anon_sym_static] = ACTIONS(4822),
    [anon_sym_EQ] = ACTIONS(4822),
    [anon_sym_register] = ACTIONS(4822),
    [anon_sym_inline] = ACTIONS(4822),
    [anon_sym___inline] = ACTIONS(4822),
    [anon_sym___inline__] = ACTIONS(4822),
    [anon_sym___forceinline] = ACTIONS(4822),
    [anon_sym_thread_local] = ACTIONS(4822),
    [anon_sym___thread] = ACTIONS(4822),
    [anon_sym_const] = ACTIONS(4822),
    [anon_sym_constexpr] = ACTIONS(4822),
    [anon_sym_volatile] = ACTIONS(4822),
    [anon_sym_restrict] = ACTIONS(4822),
    [anon_sym___restrict__] = ACTIONS(4822),
    [anon_sym__Atomic] = ACTIONS(4822),
    [anon_sym__Noreturn] = ACTIONS(4822),
    [anon_sym_noreturn] = ACTIONS(4822),
    [anon_sym__Nonnull] = ACTIONS(4822),
    [anon_sym_mutable] = ACTIONS(4822),
    [anon_sym_constinit] = ACTIONS(4822),
    [anon_sym_consteval] = ACTIONS(4822),
    [anon_sym_alignas] = ACTIONS(4822),
    [anon_sym__Alignas] = ACTIONS(4822),
    [anon_sym_QMARK] = ACTIONS(4824),
    [anon_sym_STAR_EQ] = ACTIONS(4824),
    [anon_sym_SLASH_EQ] = ACTIONS(4824),
    [anon_sym_PERCENT_EQ] = ACTIONS(4824),
    [anon_sym_PLUS_EQ] = ACTIONS(4824),
    [anon_sym_DASH_EQ] = ACTIONS(4824),
    [anon_sym_LT_LT_EQ] = ACTIONS(4824),
    [anon_sym_GT_GT_EQ] = ACTIONS(4824),
    [anon_sym_AMP_EQ] = ACTIONS(4824),
    [anon_sym_CARET_EQ] = ACTIONS(4824),
    [anon_sym_PIPE_EQ] = ACTIONS(4824),
    [anon_sym_and_eq] = ACTIONS(4822),
    [anon_sym_or_eq] = ACTIONS(4822),
    [anon_sym_xor_eq] = ACTIONS(4822),
    [anon_sym_LT_EQ_GT] = ACTIONS(4824),
    [anon_sym_or] = ACTIONS(4822),
    [anon_sym_and] = ACTIONS(4822),
    [anon_sym_bitor] = ACTIONS(4822),
    [anon_sym_xor] = ACTIONS(4822),
    [anon_sym_bitand] = ACTIONS(4822),
    [anon_sym_not_eq] = ACTIONS(4822),
    [anon_sym_DASH_DASH] = ACTIONS(4824),
    [anon_sym_PLUS_PLUS] = ACTIONS(4824),
    [anon_sym_DOT] = ACTIONS(4822),
    [anon_sym_DOT_STAR] = ACTIONS(4824),
    [anon_sym_DASH_GT] = ACTIONS(4822),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4822),
    [anon_sym_decltype] = ACTIONS(4822),
    [anon_sym_template] = ACTIONS(4822),
    [anon_sym_operator] = ACTIONS(4822),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4824),
  },
  [1532] = {
    [sym_identifier] = ACTIONS(4818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4820),
    [anon_sym_COMMA] = ACTIONS(4820),
    [anon_sym_RPAREN] = ACTIONS(4820),
    [anon_sym_LPAREN2] = ACTIONS(4820),
    [anon_sym_TILDE] = ACTIONS(4820),
    [anon_sym_DASH] = ACTIONS(4818),
    [anon_sym_PLUS] = ACTIONS(4818),
    [anon_sym_STAR] = ACTIONS(4820),
    [anon_sym_SLASH] = ACTIONS(4818),
    [anon_sym_PERCENT] = ACTIONS(4820),
    [anon_sym_PIPE_PIPE] = ACTIONS(4820),
    [anon_sym_AMP_AMP] = ACTIONS(4820),
    [anon_sym_PIPE] = ACTIONS(4818),
    [anon_sym_CARET] = ACTIONS(4820),
    [anon_sym_AMP] = ACTIONS(4818),
    [anon_sym_EQ_EQ] = ACTIONS(4820),
    [anon_sym_BANG_EQ] = ACTIONS(4820),
    [anon_sym_GT] = ACTIONS(4818),
    [anon_sym_GT_EQ] = ACTIONS(4820),
    [anon_sym_LT_EQ] = ACTIONS(4818),
    [anon_sym_LT] = ACTIONS(4818),
    [anon_sym_LT_LT] = ACTIONS(4820),
    [anon_sym_GT_GT] = ACTIONS(4820),
    [anon_sym_SEMI] = ACTIONS(4820),
    [anon_sym___extension__] = ACTIONS(4818),
    [anon_sym_virtual] = ACTIONS(4818),
    [anon_sym_extern] = ACTIONS(4818),
    [anon_sym___attribute__] = ACTIONS(4818),
    [anon_sym___attribute] = ACTIONS(4818),
    [anon_sym_COLON_COLON] = ACTIONS(4820),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4820),
    [anon_sym___declspec] = ACTIONS(4818),
    [anon_sym___based] = ACTIONS(4818),
    [anon_sym___cdecl] = ACTIONS(4818),
    [anon_sym___clrcall] = ACTIONS(4818),
    [anon_sym___stdcall] = ACTIONS(4818),
    [anon_sym___fastcall] = ACTIONS(4818),
    [anon_sym___thiscall] = ACTIONS(4818),
    [anon_sym___vectorcall] = ACTIONS(4818),
    [anon_sym_LBRACE] = ACTIONS(4820),
    [anon_sym_RBRACE] = ACTIONS(4820),
    [anon_sym_LBRACK] = ACTIONS(4818),
    [anon_sym_static] = ACTIONS(4818),
    [anon_sym_RBRACK] = ACTIONS(4820),
    [anon_sym_EQ] = ACTIONS(4818),
    [anon_sym_register] = ACTIONS(4818),
    [anon_sym_inline] = ACTIONS(4818),
    [anon_sym___inline] = ACTIONS(4818),
    [anon_sym___inline__] = ACTIONS(4818),
    [anon_sym___forceinline] = ACTIONS(4818),
    [anon_sym_thread_local] = ACTIONS(4818),
    [anon_sym___thread] = ACTIONS(4818),
    [anon_sym_const] = ACTIONS(4818),
    [anon_sym_constexpr] = ACTIONS(4818),
    [anon_sym_volatile] = ACTIONS(4818),
    [anon_sym_restrict] = ACTIONS(4818),
    [anon_sym___restrict__] = ACTIONS(4818),
    [anon_sym__Atomic] = ACTIONS(4818),
    [anon_sym__Noreturn] = ACTIONS(4818),
    [anon_sym_noreturn] = ACTIONS(4818),
    [anon_sym__Nonnull] = ACTIONS(4818),
    [anon_sym_mutable] = ACTIONS(4818),
    [anon_sym_constinit] = ACTIONS(4818),
    [anon_sym_consteval] = ACTIONS(4818),
    [anon_sym_alignas] = ACTIONS(4818),
    [anon_sym__Alignas] = ACTIONS(4818),
    [anon_sym_COLON] = ACTIONS(4818),
    [anon_sym_QMARK] = ACTIONS(4820),
    [anon_sym_LT_EQ_GT] = ACTIONS(4820),
    [anon_sym_or] = ACTIONS(4818),
    [anon_sym_and] = ACTIONS(4818),
    [anon_sym_bitor] = ACTIONS(4818),
    [anon_sym_xor] = ACTIONS(4818),
    [anon_sym_bitand] = ACTIONS(4818),
    [anon_sym_not_eq] = ACTIONS(4818),
    [anon_sym_DASH_DASH] = ACTIONS(4820),
    [anon_sym_PLUS_PLUS] = ACTIONS(4820),
    [anon_sym_DOT] = ACTIONS(4818),
    [anon_sym_DOT_STAR] = ACTIONS(4820),
    [anon_sym_DASH_GT] = ACTIONS(4820),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4818),
    [anon_sym_decltype] = ACTIONS(4818),
    [anon_sym_final] = ACTIONS(4818),
    [anon_sym_override] = ACTIONS(4818),
    [anon_sym_template] = ACTIONS(4818),
    [anon_sym_operator] = ACTIONS(4818),
    [anon_sym_try] = ACTIONS(4818),
    [anon_sym_requires] = ACTIONS(4818),
  },
  [1533] = {
    [sym_string_literal] = STATE(2149),
    [sym_template_argument_list] = STATE(1668),
    [sym_raw_string_literal] = STATE(2149),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4035),
    [anon_sym_COMMA] = ACTIONS(4035),
    [anon_sym_RPAREN] = ACTIONS(4037),
    [anon_sym_LPAREN2] = ACTIONS(4037),
    [anon_sym_DASH] = ACTIONS(4043),
    [anon_sym_PLUS] = ACTIONS(4043),
    [anon_sym_STAR] = ACTIONS(4045),
    [anon_sym_SLASH] = ACTIONS(4043),
    [anon_sym_PERCENT] = ACTIONS(4043),
    [anon_sym_PIPE_PIPE] = ACTIONS(4035),
    [anon_sym_AMP_AMP] = ACTIONS(4048),
    [anon_sym_PIPE] = ACTIONS(4043),
    [anon_sym_CARET] = ACTIONS(4043),
    [anon_sym_AMP] = ACTIONS(4045),
    [anon_sym_EQ_EQ] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4043),
    [anon_sym_GT_EQ] = ACTIONS(4035),
    [anon_sym_LT_EQ] = ACTIONS(4043),
    [anon_sym_LT] = ACTIONS(4892),
    [anon_sym_LT_LT] = ACTIONS(4043),
    [anon_sym_GT_GT] = ACTIONS(4043),
    [anon_sym___extension__] = ACTIONS(4041),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4895),
    [anon_sym_LBRACE] = ACTIONS(4059),
    [anon_sym_signed] = ACTIONS(4897),
    [anon_sym_unsigned] = ACTIONS(4897),
    [anon_sym_long] = ACTIONS(4897),
    [anon_sym_short] = ACTIONS(4897),
    [anon_sym_LBRACK] = ACTIONS(4063),
    [anon_sym_EQ] = ACTIONS(4043),
    [anon_sym_const] = ACTIONS(4033),
    [anon_sym_constexpr] = ACTIONS(4041),
    [anon_sym_volatile] = ACTIONS(4041),
    [anon_sym_restrict] = ACTIONS(4041),
    [anon_sym___restrict__] = ACTIONS(4041),
    [anon_sym__Atomic] = ACTIONS(4041),
    [anon_sym__Noreturn] = ACTIONS(4041),
    [anon_sym_noreturn] = ACTIONS(4041),
    [anon_sym__Nonnull] = ACTIONS(4041),
    [anon_sym_mutable] = ACTIONS(4041),
    [anon_sym_constinit] = ACTIONS(4041),
    [anon_sym_consteval] = ACTIONS(4041),
    [anon_sym_alignas] = ACTIONS(4041),
    [anon_sym__Alignas] = ACTIONS(4041),
    [anon_sym_QMARK] = ACTIONS(4035),
    [anon_sym_STAR_EQ] = ACTIONS(4035),
    [anon_sym_SLASH_EQ] = ACTIONS(4035),
    [anon_sym_PERCENT_EQ] = ACTIONS(4035),
    [anon_sym_PLUS_EQ] = ACTIONS(4035),
    [anon_sym_DASH_EQ] = ACTIONS(4035),
    [anon_sym_LT_LT_EQ] = ACTIONS(4035),
    [anon_sym_GT_GT_EQ] = ACTIONS(4035),
    [anon_sym_AMP_EQ] = ACTIONS(4035),
    [anon_sym_CARET_EQ] = ACTIONS(4035),
    [anon_sym_PIPE_EQ] = ACTIONS(4035),
    [anon_sym_and_eq] = ACTIONS(4035),
    [anon_sym_or_eq] = ACTIONS(4035),
    [anon_sym_xor_eq] = ACTIONS(4035),
    [anon_sym_LT_EQ_GT] = ACTIONS(4035),
    [anon_sym_or] = ACTIONS(4043),
    [anon_sym_and] = ACTIONS(4043),
    [anon_sym_bitor] = ACTIONS(4035),
    [anon_sym_xor] = ACTIONS(4043),
    [anon_sym_bitand] = ACTIONS(4035),
    [anon_sym_not_eq] = ACTIONS(4035),
    [anon_sym_DASH_DASH] = ACTIONS(4035),
    [anon_sym_PLUS_PLUS] = ACTIONS(4035),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_DOT_STAR] = ACTIONS(4035),
    [anon_sym_DASH_GT] = ACTIONS(4043),
    [anon_sym_L_DQUOTE] = ACTIONS(4899),
    [anon_sym_u_DQUOTE] = ACTIONS(4899),
    [anon_sym_U_DQUOTE] = ACTIONS(4899),
    [anon_sym_u8_DQUOTE] = ACTIONS(4899),
    [anon_sym_DQUOTE] = ACTIONS(4899),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4041),
    [anon_sym_decltype] = ACTIONS(4041),
    [anon_sym_R_DQUOTE] = ACTIONS(4901),
    [anon_sym_LR_DQUOTE] = ACTIONS(4901),
    [anon_sym_uR_DQUOTE] = ACTIONS(4901),
    [anon_sym_UR_DQUOTE] = ACTIONS(4901),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4901),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4035),
  },
  [1534] = {
    [sym_identifier] = ACTIONS(4814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4816),
    [anon_sym_COMMA] = ACTIONS(4816),
    [anon_sym_RPAREN] = ACTIONS(4816),
    [anon_sym_LPAREN2] = ACTIONS(4816),
    [anon_sym_TILDE] = ACTIONS(4816),
    [anon_sym_DASH] = ACTIONS(4814),
    [anon_sym_PLUS] = ACTIONS(4814),
    [anon_sym_STAR] = ACTIONS(4814),
    [anon_sym_SLASH] = ACTIONS(4814),
    [anon_sym_PERCENT] = ACTIONS(4814),
    [anon_sym_PIPE_PIPE] = ACTIONS(4816),
    [anon_sym_AMP_AMP] = ACTIONS(4816),
    [anon_sym_PIPE] = ACTIONS(4814),
    [anon_sym_CARET] = ACTIONS(4814),
    [anon_sym_AMP] = ACTIONS(4814),
    [anon_sym_EQ_EQ] = ACTIONS(4816),
    [anon_sym_BANG_EQ] = ACTIONS(4816),
    [anon_sym_GT] = ACTIONS(4814),
    [anon_sym_GT_EQ] = ACTIONS(4816),
    [anon_sym_LT_EQ] = ACTIONS(4814),
    [anon_sym_LT] = ACTIONS(4814),
    [anon_sym_LT_LT] = ACTIONS(4814),
    [anon_sym_GT_GT] = ACTIONS(4814),
    [anon_sym___extension__] = ACTIONS(4814),
    [anon_sym_virtual] = ACTIONS(4814),
    [anon_sym_extern] = ACTIONS(4814),
    [anon_sym___attribute__] = ACTIONS(4814),
    [anon_sym___attribute] = ACTIONS(4814),
    [anon_sym_COLON_COLON] = ACTIONS(4816),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4816),
    [anon_sym___declspec] = ACTIONS(4814),
    [anon_sym___based] = ACTIONS(4814),
    [anon_sym_LBRACE] = ACTIONS(4816),
    [anon_sym_LBRACK] = ACTIONS(4814),
    [anon_sym_static] = ACTIONS(4814),
    [anon_sym_EQ] = ACTIONS(4814),
    [anon_sym_register] = ACTIONS(4814),
    [anon_sym_inline] = ACTIONS(4814),
    [anon_sym___inline] = ACTIONS(4814),
    [anon_sym___inline__] = ACTIONS(4814),
    [anon_sym___forceinline] = ACTIONS(4814),
    [anon_sym_thread_local] = ACTIONS(4814),
    [anon_sym___thread] = ACTIONS(4814),
    [anon_sym_const] = ACTIONS(4814),
    [anon_sym_constexpr] = ACTIONS(4814),
    [anon_sym_volatile] = ACTIONS(4814),
    [anon_sym_restrict] = ACTIONS(4814),
    [anon_sym___restrict__] = ACTIONS(4814),
    [anon_sym__Atomic] = ACTIONS(4814),
    [anon_sym__Noreturn] = ACTIONS(4814),
    [anon_sym_noreturn] = ACTIONS(4814),
    [anon_sym__Nonnull] = ACTIONS(4814),
    [anon_sym_mutable] = ACTIONS(4814),
    [anon_sym_constinit] = ACTIONS(4814),
    [anon_sym_consteval] = ACTIONS(4814),
    [anon_sym_alignas] = ACTIONS(4814),
    [anon_sym__Alignas] = ACTIONS(4814),
    [anon_sym_QMARK] = ACTIONS(4816),
    [anon_sym_STAR_EQ] = ACTIONS(4816),
    [anon_sym_SLASH_EQ] = ACTIONS(4816),
    [anon_sym_PERCENT_EQ] = ACTIONS(4816),
    [anon_sym_PLUS_EQ] = ACTIONS(4816),
    [anon_sym_DASH_EQ] = ACTIONS(4816),
    [anon_sym_LT_LT_EQ] = ACTIONS(4816),
    [anon_sym_GT_GT_EQ] = ACTIONS(4816),
    [anon_sym_AMP_EQ] = ACTIONS(4816),
    [anon_sym_CARET_EQ] = ACTIONS(4816),
    [anon_sym_PIPE_EQ] = ACTIONS(4816),
    [anon_sym_and_eq] = ACTIONS(4814),
    [anon_sym_or_eq] = ACTIONS(4814),
    [anon_sym_xor_eq] = ACTIONS(4814),
    [anon_sym_LT_EQ_GT] = ACTIONS(4816),
    [anon_sym_or] = ACTIONS(4814),
    [anon_sym_and] = ACTIONS(4814),
    [anon_sym_bitor] = ACTIONS(4814),
    [anon_sym_xor] = ACTIONS(4814),
    [anon_sym_bitand] = ACTIONS(4814),
    [anon_sym_not_eq] = ACTIONS(4814),
    [anon_sym_DASH_DASH] = ACTIONS(4816),
    [anon_sym_PLUS_PLUS] = ACTIONS(4816),
    [anon_sym_DOT] = ACTIONS(4814),
    [anon_sym_DOT_STAR] = ACTIONS(4816),
    [anon_sym_DASH_GT] = ACTIONS(4814),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4814),
    [anon_sym_decltype] = ACTIONS(4814),
    [anon_sym_template] = ACTIONS(4814),
    [anon_sym_operator] = ACTIONS(4814),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4816),
  },
  [1535] = {
    [sym_identifier] = ACTIONS(4830),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4832),
    [anon_sym_COMMA] = ACTIONS(4832),
    [anon_sym_RPAREN] = ACTIONS(4832),
    [anon_sym_LPAREN2] = ACTIONS(4832),
    [anon_sym_TILDE] = ACTIONS(4832),
    [anon_sym_DASH] = ACTIONS(4830),
    [anon_sym_PLUS] = ACTIONS(4830),
    [anon_sym_STAR] = ACTIONS(4830),
    [anon_sym_SLASH] = ACTIONS(4830),
    [anon_sym_PERCENT] = ACTIONS(4830),
    [anon_sym_PIPE_PIPE] = ACTIONS(4832),
    [anon_sym_AMP_AMP] = ACTIONS(4832),
    [anon_sym_PIPE] = ACTIONS(4830),
    [anon_sym_CARET] = ACTIONS(4830),
    [anon_sym_AMP] = ACTIONS(4830),
    [anon_sym_EQ_EQ] = ACTIONS(4832),
    [anon_sym_BANG_EQ] = ACTIONS(4832),
    [anon_sym_GT] = ACTIONS(4830),
    [anon_sym_GT_EQ] = ACTIONS(4832),
    [anon_sym_LT_EQ] = ACTIONS(4830),
    [anon_sym_LT] = ACTIONS(4830),
    [anon_sym_LT_LT] = ACTIONS(4830),
    [anon_sym_GT_GT] = ACTIONS(4830),
    [anon_sym___extension__] = ACTIONS(4830),
    [anon_sym_virtual] = ACTIONS(4830),
    [anon_sym_extern] = ACTIONS(4830),
    [anon_sym___attribute__] = ACTIONS(4830),
    [anon_sym___attribute] = ACTIONS(4830),
    [anon_sym_COLON_COLON] = ACTIONS(4832),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4832),
    [anon_sym___declspec] = ACTIONS(4830),
    [anon_sym___based] = ACTIONS(4830),
    [anon_sym_LBRACE] = ACTIONS(4832),
    [anon_sym_LBRACK] = ACTIONS(4830),
    [anon_sym_static] = ACTIONS(4830),
    [anon_sym_EQ] = ACTIONS(4830),
    [anon_sym_register] = ACTIONS(4830),
    [anon_sym_inline] = ACTIONS(4830),
    [anon_sym___inline] = ACTIONS(4830),
    [anon_sym___inline__] = ACTIONS(4830),
    [anon_sym___forceinline] = ACTIONS(4830),
    [anon_sym_thread_local] = ACTIONS(4830),
    [anon_sym___thread] = ACTIONS(4830),
    [anon_sym_const] = ACTIONS(4830),
    [anon_sym_constexpr] = ACTIONS(4830),
    [anon_sym_volatile] = ACTIONS(4830),
    [anon_sym_restrict] = ACTIONS(4830),
    [anon_sym___restrict__] = ACTIONS(4830),
    [anon_sym__Atomic] = ACTIONS(4830),
    [anon_sym__Noreturn] = ACTIONS(4830),
    [anon_sym_noreturn] = ACTIONS(4830),
    [anon_sym__Nonnull] = ACTIONS(4830),
    [anon_sym_mutable] = ACTIONS(4830),
    [anon_sym_constinit] = ACTIONS(4830),
    [anon_sym_consteval] = ACTIONS(4830),
    [anon_sym_alignas] = ACTIONS(4830),
    [anon_sym__Alignas] = ACTIONS(4830),
    [anon_sym_QMARK] = ACTIONS(4832),
    [anon_sym_STAR_EQ] = ACTIONS(4832),
    [anon_sym_SLASH_EQ] = ACTIONS(4832),
    [anon_sym_PERCENT_EQ] = ACTIONS(4832),
    [anon_sym_PLUS_EQ] = ACTIONS(4832),
    [anon_sym_DASH_EQ] = ACTIONS(4832),
    [anon_sym_LT_LT_EQ] = ACTIONS(4832),
    [anon_sym_GT_GT_EQ] = ACTIONS(4832),
    [anon_sym_AMP_EQ] = ACTIONS(4832),
    [anon_sym_CARET_EQ] = ACTIONS(4832),
    [anon_sym_PIPE_EQ] = ACTIONS(4832),
    [anon_sym_and_eq] = ACTIONS(4830),
    [anon_sym_or_eq] = ACTIONS(4830),
    [anon_sym_xor_eq] = ACTIONS(4830),
    [anon_sym_LT_EQ_GT] = ACTIONS(4832),
    [anon_sym_or] = ACTIONS(4830),
    [anon_sym_and] = ACTIONS(4830),
    [anon_sym_bitor] = ACTIONS(4830),
    [anon_sym_xor] = ACTIONS(4830),
    [anon_sym_bitand] = ACTIONS(4830),
    [anon_sym_not_eq] = ACTIONS(4830),
    [anon_sym_DASH_DASH] = ACTIONS(4832),
    [anon_sym_PLUS_PLUS] = ACTIONS(4832),
    [anon_sym_DOT] = ACTIONS(4830),
    [anon_sym_DOT_STAR] = ACTIONS(4832),
    [anon_sym_DASH_GT] = ACTIONS(4830),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4830),
    [anon_sym_decltype] = ACTIONS(4830),
    [anon_sym_template] = ACTIONS(4830),
    [anon_sym_operator] = ACTIONS(4830),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4832),
  },
  [1536] = {
    [sym_identifier] = ACTIONS(4834),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4836),
    [anon_sym_COMMA] = ACTIONS(4836),
    [anon_sym_RPAREN] = ACTIONS(4836),
    [anon_sym_LPAREN2] = ACTIONS(4836),
    [anon_sym_TILDE] = ACTIONS(4836),
    [anon_sym_DASH] = ACTIONS(4834),
    [anon_sym_PLUS] = ACTIONS(4834),
    [anon_sym_STAR] = ACTIONS(4834),
    [anon_sym_SLASH] = ACTIONS(4834),
    [anon_sym_PERCENT] = ACTIONS(4834),
    [anon_sym_PIPE_PIPE] = ACTIONS(4836),
    [anon_sym_AMP_AMP] = ACTIONS(4836),
    [anon_sym_PIPE] = ACTIONS(4834),
    [anon_sym_CARET] = ACTIONS(4834),
    [anon_sym_AMP] = ACTIONS(4834),
    [anon_sym_EQ_EQ] = ACTIONS(4836),
    [anon_sym_BANG_EQ] = ACTIONS(4836),
    [anon_sym_GT] = ACTIONS(4834),
    [anon_sym_GT_EQ] = ACTIONS(4836),
    [anon_sym_LT_EQ] = ACTIONS(4834),
    [anon_sym_LT] = ACTIONS(4834),
    [anon_sym_LT_LT] = ACTIONS(4834),
    [anon_sym_GT_GT] = ACTIONS(4834),
    [anon_sym___extension__] = ACTIONS(4834),
    [anon_sym_virtual] = ACTIONS(4834),
    [anon_sym_extern] = ACTIONS(4834),
    [anon_sym___attribute__] = ACTIONS(4834),
    [anon_sym___attribute] = ACTIONS(4834),
    [anon_sym_COLON_COLON] = ACTIONS(4836),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4836),
    [anon_sym___declspec] = ACTIONS(4834),
    [anon_sym___based] = ACTIONS(4834),
    [anon_sym_LBRACE] = ACTIONS(4836),
    [anon_sym_LBRACK] = ACTIONS(4834),
    [anon_sym_static] = ACTIONS(4834),
    [anon_sym_EQ] = ACTIONS(4834),
    [anon_sym_register] = ACTIONS(4834),
    [anon_sym_inline] = ACTIONS(4834),
    [anon_sym___inline] = ACTIONS(4834),
    [anon_sym___inline__] = ACTIONS(4834),
    [anon_sym___forceinline] = ACTIONS(4834),
    [anon_sym_thread_local] = ACTIONS(4834),
    [anon_sym___thread] = ACTIONS(4834),
    [anon_sym_const] = ACTIONS(4834),
    [anon_sym_constexpr] = ACTIONS(4834),
    [anon_sym_volatile] = ACTIONS(4834),
    [anon_sym_restrict] = ACTIONS(4834),
    [anon_sym___restrict__] = ACTIONS(4834),
    [anon_sym__Atomic] = ACTIONS(4834),
    [anon_sym__Noreturn] = ACTIONS(4834),
    [anon_sym_noreturn] = ACTIONS(4834),
    [anon_sym__Nonnull] = ACTIONS(4834),
    [anon_sym_mutable] = ACTIONS(4834),
    [anon_sym_constinit] = ACTIONS(4834),
    [anon_sym_consteval] = ACTIONS(4834),
    [anon_sym_alignas] = ACTIONS(4834),
    [anon_sym__Alignas] = ACTIONS(4834),
    [anon_sym_QMARK] = ACTIONS(4836),
    [anon_sym_STAR_EQ] = ACTIONS(4836),
    [anon_sym_SLASH_EQ] = ACTIONS(4836),
    [anon_sym_PERCENT_EQ] = ACTIONS(4836),
    [anon_sym_PLUS_EQ] = ACTIONS(4836),
    [anon_sym_DASH_EQ] = ACTIONS(4836),
    [anon_sym_LT_LT_EQ] = ACTIONS(4836),
    [anon_sym_GT_GT_EQ] = ACTIONS(4836),
    [anon_sym_AMP_EQ] = ACTIONS(4836),
    [anon_sym_CARET_EQ] = ACTIONS(4836),
    [anon_sym_PIPE_EQ] = ACTIONS(4836),
    [anon_sym_and_eq] = ACTIONS(4834),
    [anon_sym_or_eq] = ACTIONS(4834),
    [anon_sym_xor_eq] = ACTIONS(4834),
    [anon_sym_LT_EQ_GT] = ACTIONS(4836),
    [anon_sym_or] = ACTIONS(4834),
    [anon_sym_and] = ACTIONS(4834),
    [anon_sym_bitor] = ACTIONS(4834),
    [anon_sym_xor] = ACTIONS(4834),
    [anon_sym_bitand] = ACTIONS(4834),
    [anon_sym_not_eq] = ACTIONS(4834),
    [anon_sym_DASH_DASH] = ACTIONS(4836),
    [anon_sym_PLUS_PLUS] = ACTIONS(4836),
    [anon_sym_DOT] = ACTIONS(4834),
    [anon_sym_DOT_STAR] = ACTIONS(4836),
    [anon_sym_DASH_GT] = ACTIONS(4834),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4834),
    [anon_sym_decltype] = ACTIONS(4834),
    [anon_sym_template] = ACTIONS(4834),
    [anon_sym_operator] = ACTIONS(4834),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4836),
  },
  [1537] = {
    [sym_identifier] = ACTIONS(4822),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4824),
    [anon_sym_COMMA] = ACTIONS(4824),
    [anon_sym_RPAREN] = ACTIONS(4824),
    [anon_sym_LPAREN2] = ACTIONS(4824),
    [anon_sym_TILDE] = ACTIONS(4824),
    [anon_sym_DASH] = ACTIONS(4822),
    [anon_sym_PLUS] = ACTIONS(4822),
    [anon_sym_STAR] = ACTIONS(4824),
    [anon_sym_SLASH] = ACTIONS(4822),
    [anon_sym_PERCENT] = ACTIONS(4824),
    [anon_sym_PIPE_PIPE] = ACTIONS(4824),
    [anon_sym_AMP_AMP] = ACTIONS(4824),
    [anon_sym_PIPE] = ACTIONS(4822),
    [anon_sym_CARET] = ACTIONS(4824),
    [anon_sym_AMP] = ACTIONS(4822),
    [anon_sym_EQ_EQ] = ACTIONS(4824),
    [anon_sym_BANG_EQ] = ACTIONS(4824),
    [anon_sym_GT] = ACTIONS(4822),
    [anon_sym_GT_EQ] = ACTIONS(4824),
    [anon_sym_LT_EQ] = ACTIONS(4822),
    [anon_sym_LT] = ACTIONS(4822),
    [anon_sym_LT_LT] = ACTIONS(4824),
    [anon_sym_GT_GT] = ACTIONS(4824),
    [anon_sym_SEMI] = ACTIONS(4824),
    [anon_sym___extension__] = ACTIONS(4822),
    [anon_sym_virtual] = ACTIONS(4822),
    [anon_sym_extern] = ACTIONS(4822),
    [anon_sym___attribute__] = ACTIONS(4822),
    [anon_sym___attribute] = ACTIONS(4822),
    [anon_sym_COLON_COLON] = ACTIONS(4824),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4824),
    [anon_sym___declspec] = ACTIONS(4822),
    [anon_sym___based] = ACTIONS(4822),
    [anon_sym___cdecl] = ACTIONS(4822),
    [anon_sym___clrcall] = ACTIONS(4822),
    [anon_sym___stdcall] = ACTIONS(4822),
    [anon_sym___fastcall] = ACTIONS(4822),
    [anon_sym___thiscall] = ACTIONS(4822),
    [anon_sym___vectorcall] = ACTIONS(4822),
    [anon_sym_LBRACE] = ACTIONS(4824),
    [anon_sym_RBRACE] = ACTIONS(4824),
    [anon_sym_LBRACK] = ACTIONS(4822),
    [anon_sym_static] = ACTIONS(4822),
    [anon_sym_RBRACK] = ACTIONS(4824),
    [anon_sym_EQ] = ACTIONS(4822),
    [anon_sym_register] = ACTIONS(4822),
    [anon_sym_inline] = ACTIONS(4822),
    [anon_sym___inline] = ACTIONS(4822),
    [anon_sym___inline__] = ACTIONS(4822),
    [anon_sym___forceinline] = ACTIONS(4822),
    [anon_sym_thread_local] = ACTIONS(4822),
    [anon_sym___thread] = ACTIONS(4822),
    [anon_sym_const] = ACTIONS(4822),
    [anon_sym_constexpr] = ACTIONS(4822),
    [anon_sym_volatile] = ACTIONS(4822),
    [anon_sym_restrict] = ACTIONS(4822),
    [anon_sym___restrict__] = ACTIONS(4822),
    [anon_sym__Atomic] = ACTIONS(4822),
    [anon_sym__Noreturn] = ACTIONS(4822),
    [anon_sym_noreturn] = ACTIONS(4822),
    [anon_sym__Nonnull] = ACTIONS(4822),
    [anon_sym_mutable] = ACTIONS(4822),
    [anon_sym_constinit] = ACTIONS(4822),
    [anon_sym_consteval] = ACTIONS(4822),
    [anon_sym_alignas] = ACTIONS(4822),
    [anon_sym__Alignas] = ACTIONS(4822),
    [anon_sym_COLON] = ACTIONS(4822),
    [anon_sym_QMARK] = ACTIONS(4824),
    [anon_sym_LT_EQ_GT] = ACTIONS(4824),
    [anon_sym_or] = ACTIONS(4822),
    [anon_sym_and] = ACTIONS(4822),
    [anon_sym_bitor] = ACTIONS(4822),
    [anon_sym_xor] = ACTIONS(4822),
    [anon_sym_bitand] = ACTIONS(4822),
    [anon_sym_not_eq] = ACTIONS(4822),
    [anon_sym_DASH_DASH] = ACTIONS(4824),
    [anon_sym_PLUS_PLUS] = ACTIONS(4824),
    [anon_sym_DOT] = ACTIONS(4822),
    [anon_sym_DOT_STAR] = ACTIONS(4824),
    [anon_sym_DASH_GT] = ACTIONS(4824),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4822),
    [anon_sym_decltype] = ACTIONS(4822),
    [anon_sym_final] = ACTIONS(4822),
    [anon_sym_override] = ACTIONS(4822),
    [anon_sym_template] = ACTIONS(4822),
    [anon_sym_operator] = ACTIONS(4822),
    [anon_sym_try] = ACTIONS(4822),
    [anon_sym_requires] = ACTIONS(4822),
  },
  [1538] = {
    [sym_identifier] = ACTIONS(4855),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4859),
    [anon_sym_COMMA] = ACTIONS(4859),
    [anon_sym_RPAREN] = ACTIONS(4859),
    [anon_sym_LPAREN2] = ACTIONS(4859),
    [anon_sym_TILDE] = ACTIONS(4862),
    [anon_sym_DASH] = ACTIONS(4864),
    [anon_sym_PLUS] = ACTIONS(4864),
    [anon_sym_STAR] = ACTIONS(4866),
    [anon_sym_SLASH] = ACTIONS(4864),
    [anon_sym_PERCENT] = ACTIONS(4864),
    [anon_sym_PIPE_PIPE] = ACTIONS(4857),
    [anon_sym_AMP_AMP] = ACTIONS(4859),
    [anon_sym_PIPE] = ACTIONS(4864),
    [anon_sym_CARET] = ACTIONS(4864),
    [anon_sym_AMP] = ACTIONS(4866),
    [anon_sym_EQ_EQ] = ACTIONS(4857),
    [anon_sym_BANG_EQ] = ACTIONS(4857),
    [anon_sym_GT] = ACTIONS(4864),
    [anon_sym_GT_EQ] = ACTIONS(4857),
    [anon_sym_LT_EQ] = ACTIONS(4864),
    [anon_sym_LT] = ACTIONS(4864),
    [anon_sym_LT_LT] = ACTIONS(4864),
    [anon_sym_GT_GT] = ACTIONS(4864),
    [anon_sym___extension__] = ACTIONS(4855),
    [anon_sym_virtual] = ACTIONS(4855),
    [anon_sym_extern] = ACTIONS(4855),
    [anon_sym___attribute__] = ACTIONS(4855),
    [anon_sym___attribute] = ACTIONS(4855),
    [anon_sym_COLON_COLON] = ACTIONS(4862),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4862),
    [anon_sym___declspec] = ACTIONS(4855),
    [anon_sym___based] = ACTIONS(4855),
    [anon_sym_LBRACE] = ACTIONS(4862),
    [anon_sym_LBRACK] = ACTIONS(4866),
    [anon_sym_static] = ACTIONS(4855),
    [anon_sym_EQ] = ACTIONS(4866),
    [anon_sym_register] = ACTIONS(4855),
    [anon_sym_inline] = ACTIONS(4855),
    [anon_sym___inline] = ACTIONS(4855),
    [anon_sym___inline__] = ACTIONS(4855),
    [anon_sym___forceinline] = ACTIONS(4855),
    [anon_sym_thread_local] = ACTIONS(4855),
    [anon_sym___thread] = ACTIONS(4855),
    [anon_sym_const] = ACTIONS(4855),
    [anon_sym_constexpr] = ACTIONS(4855),
    [anon_sym_volatile] = ACTIONS(4855),
    [anon_sym_restrict] = ACTIONS(4855),
    [anon_sym___restrict__] = ACTIONS(4855),
    [anon_sym__Atomic] = ACTIONS(4855),
    [anon_sym__Noreturn] = ACTIONS(4855),
    [anon_sym_noreturn] = ACTIONS(4855),
    [anon_sym__Nonnull] = ACTIONS(4855),
    [anon_sym_mutable] = ACTIONS(4855),
    [anon_sym_constinit] = ACTIONS(4855),
    [anon_sym_consteval] = ACTIONS(4855),
    [anon_sym_alignas] = ACTIONS(4855),
    [anon_sym__Alignas] = ACTIONS(4855),
    [anon_sym_QMARK] = ACTIONS(4857),
    [anon_sym_STAR_EQ] = ACTIONS(4857),
    [anon_sym_SLASH_EQ] = ACTIONS(4857),
    [anon_sym_PERCENT_EQ] = ACTIONS(4857),
    [anon_sym_PLUS_EQ] = ACTIONS(4857),
    [anon_sym_DASH_EQ] = ACTIONS(4857),
    [anon_sym_LT_LT_EQ] = ACTIONS(4857),
    [anon_sym_GT_GT_EQ] = ACTIONS(4857),
    [anon_sym_AMP_EQ] = ACTIONS(4857),
    [anon_sym_CARET_EQ] = ACTIONS(4857),
    [anon_sym_PIPE_EQ] = ACTIONS(4857),
    [anon_sym_and_eq] = ACTIONS(4864),
    [anon_sym_or_eq] = ACTIONS(4864),
    [anon_sym_xor_eq] = ACTIONS(4864),
    [anon_sym_LT_EQ_GT] = ACTIONS(4857),
    [anon_sym_or] = ACTIONS(4864),
    [anon_sym_and] = ACTIONS(4864),
    [anon_sym_bitor] = ACTIONS(4864),
    [anon_sym_xor] = ACTIONS(4864),
    [anon_sym_bitand] = ACTIONS(4864),
    [anon_sym_not_eq] = ACTIONS(4864),
    [anon_sym_DASH_DASH] = ACTIONS(4857),
    [anon_sym_PLUS_PLUS] = ACTIONS(4857),
    [anon_sym_DOT] = ACTIONS(4864),
    [anon_sym_DOT_STAR] = ACTIONS(4857),
    [anon_sym_DASH_GT] = ACTIONS(4857),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4855),
    [anon_sym_decltype] = ACTIONS(4855),
    [anon_sym_template] = ACTIONS(4855),
    [anon_sym_operator] = ACTIONS(4855),
  },
  [1539] = {
    [sym_string_literal] = STATE(2149),
    [sym_template_argument_list] = STATE(1850),
    [sym_raw_string_literal] = STATE(2149),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4035),
    [anon_sym_COMMA] = ACTIONS(4035),
    [anon_sym_RPAREN] = ACTIONS(4048),
    [anon_sym_LPAREN2] = ACTIONS(4048),
    [anon_sym_DASH] = ACTIONS(4043),
    [anon_sym_PLUS] = ACTIONS(4043),
    [anon_sym_STAR] = ACTIONS(4045),
    [anon_sym_SLASH] = ACTIONS(4043),
    [anon_sym_PERCENT] = ACTIONS(4043),
    [anon_sym_PIPE_PIPE] = ACTIONS(4035),
    [anon_sym_AMP_AMP] = ACTIONS(4048),
    [anon_sym_PIPE] = ACTIONS(4043),
    [anon_sym_CARET] = ACTIONS(4043),
    [anon_sym_AMP] = ACTIONS(4045),
    [anon_sym_EQ_EQ] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4043),
    [anon_sym_GT_EQ] = ACTIONS(4035),
    [anon_sym_LT_EQ] = ACTIONS(4043),
    [anon_sym_LT] = ACTIONS(4903),
    [anon_sym_LT_LT] = ACTIONS(4043),
    [anon_sym_GT_GT] = ACTIONS(4043),
    [anon_sym___extension__] = ACTIONS(4041),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACE] = ACTIONS(4059),
    [anon_sym_signed] = ACTIONS(4897),
    [anon_sym_unsigned] = ACTIONS(4897),
    [anon_sym_long] = ACTIONS(4897),
    [anon_sym_short] = ACTIONS(4897),
    [anon_sym_LBRACK] = ACTIONS(4048),
    [anon_sym_EQ] = ACTIONS(4043),
    [anon_sym_const] = ACTIONS(4033),
    [anon_sym_constexpr] = ACTIONS(4041),
    [anon_sym_volatile] = ACTIONS(4041),
    [anon_sym_restrict] = ACTIONS(4041),
    [anon_sym___restrict__] = ACTIONS(4041),
    [anon_sym__Atomic] = ACTIONS(4041),
    [anon_sym__Noreturn] = ACTIONS(4041),
    [anon_sym_noreturn] = ACTIONS(4041),
    [anon_sym__Nonnull] = ACTIONS(4041),
    [anon_sym_mutable] = ACTIONS(4041),
    [anon_sym_constinit] = ACTIONS(4041),
    [anon_sym_consteval] = ACTIONS(4041),
    [anon_sym_alignas] = ACTIONS(4041),
    [anon_sym__Alignas] = ACTIONS(4041),
    [anon_sym_QMARK] = ACTIONS(4035),
    [anon_sym_STAR_EQ] = ACTIONS(4035),
    [anon_sym_SLASH_EQ] = ACTIONS(4035),
    [anon_sym_PERCENT_EQ] = ACTIONS(4035),
    [anon_sym_PLUS_EQ] = ACTIONS(4035),
    [anon_sym_DASH_EQ] = ACTIONS(4035),
    [anon_sym_LT_LT_EQ] = ACTIONS(4035),
    [anon_sym_GT_GT_EQ] = ACTIONS(4035),
    [anon_sym_AMP_EQ] = ACTIONS(4035),
    [anon_sym_CARET_EQ] = ACTIONS(4035),
    [anon_sym_PIPE_EQ] = ACTIONS(4035),
    [anon_sym_and_eq] = ACTIONS(4035),
    [anon_sym_or_eq] = ACTIONS(4035),
    [anon_sym_xor_eq] = ACTIONS(4035),
    [anon_sym_LT_EQ_GT] = ACTIONS(4035),
    [anon_sym_or] = ACTIONS(4043),
    [anon_sym_and] = ACTIONS(4043),
    [anon_sym_bitor] = ACTIONS(4035),
    [anon_sym_xor] = ACTIONS(4043),
    [anon_sym_bitand] = ACTIONS(4035),
    [anon_sym_not_eq] = ACTIONS(4035),
    [anon_sym_DASH_DASH] = ACTIONS(4035),
    [anon_sym_PLUS_PLUS] = ACTIONS(4035),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_DOT_STAR] = ACTIONS(4035),
    [anon_sym_DASH_GT] = ACTIONS(4043),
    [anon_sym_L_DQUOTE] = ACTIONS(4899),
    [anon_sym_u_DQUOTE] = ACTIONS(4899),
    [anon_sym_U_DQUOTE] = ACTIONS(4899),
    [anon_sym_u8_DQUOTE] = ACTIONS(4899),
    [anon_sym_DQUOTE] = ACTIONS(4899),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4041),
    [anon_sym_decltype] = ACTIONS(4041),
    [anon_sym_R_DQUOTE] = ACTIONS(4901),
    [anon_sym_LR_DQUOTE] = ACTIONS(4901),
    [anon_sym_uR_DQUOTE] = ACTIONS(4901),
    [anon_sym_UR_DQUOTE] = ACTIONS(4901),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4901),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4035),
  },
  [1540] = {
    [sym_type_qualifier] = STATE(1540),
    [sym_alignas_qualifier] = STATE(1552),
    [aux_sym__type_definition_type_repeat1] = STATE(1540),
    [sym_identifier] = ACTIONS(4906),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4908),
    [anon_sym_COMMA] = ACTIONS(4908),
    [anon_sym_RPAREN] = ACTIONS(4908),
    [aux_sym_preproc_if_token2] = ACTIONS(4908),
    [aux_sym_preproc_else_token1] = ACTIONS(4908),
    [aux_sym_preproc_elif_token1] = ACTIONS(4906),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4908),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4908),
    [anon_sym_LPAREN2] = ACTIONS(4908),
    [anon_sym_DASH] = ACTIONS(4906),
    [anon_sym_PLUS] = ACTIONS(4906),
    [anon_sym_STAR] = ACTIONS(4906),
    [anon_sym_SLASH] = ACTIONS(4906),
    [anon_sym_PERCENT] = ACTIONS(4906),
    [anon_sym_PIPE_PIPE] = ACTIONS(4908),
    [anon_sym_AMP_AMP] = ACTIONS(4908),
    [anon_sym_PIPE] = ACTIONS(4906),
    [anon_sym_CARET] = ACTIONS(4906),
    [anon_sym_AMP] = ACTIONS(4906),
    [anon_sym_EQ_EQ] = ACTIONS(4908),
    [anon_sym_BANG_EQ] = ACTIONS(4908),
    [anon_sym_GT] = ACTIONS(4906),
    [anon_sym_GT_EQ] = ACTIONS(4908),
    [anon_sym_LT_EQ] = ACTIONS(4906),
    [anon_sym_LT] = ACTIONS(4906),
    [anon_sym_LT_LT] = ACTIONS(4906),
    [anon_sym_GT_GT] = ACTIONS(4906),
    [anon_sym_SEMI] = ACTIONS(4908),
    [anon_sym___extension__] = ACTIONS(4910),
    [anon_sym___attribute__] = ACTIONS(4906),
    [anon_sym___attribute] = ACTIONS(4906),
    [anon_sym_LBRACE] = ACTIONS(4908),
    [anon_sym_RBRACE] = ACTIONS(4908),
    [anon_sym_signed] = ACTIONS(4906),
    [anon_sym_unsigned] = ACTIONS(4906),
    [anon_sym_long] = ACTIONS(4906),
    [anon_sym_short] = ACTIONS(4906),
    [anon_sym_LBRACK] = ACTIONS(4908),
    [anon_sym_RBRACK] = ACTIONS(4908),
    [anon_sym_EQ] = ACTIONS(4906),
    [anon_sym_const] = ACTIONS(4910),
    [anon_sym_constexpr] = ACTIONS(4910),
    [anon_sym_volatile] = ACTIONS(4910),
    [anon_sym_restrict] = ACTIONS(4910),
    [anon_sym___restrict__] = ACTIONS(4910),
    [anon_sym__Atomic] = ACTIONS(4910),
    [anon_sym__Noreturn] = ACTIONS(4910),
    [anon_sym_noreturn] = ACTIONS(4910),
    [anon_sym__Nonnull] = ACTIONS(4910),
    [anon_sym_mutable] = ACTIONS(4910),
    [anon_sym_constinit] = ACTIONS(4910),
    [anon_sym_consteval] = ACTIONS(4910),
    [anon_sym_alignas] = ACTIONS(4913),
    [anon_sym__Alignas] = ACTIONS(4913),
    [sym_primitive_type] = ACTIONS(4906),
    [anon_sym_COLON] = ACTIONS(4908),
    [anon_sym_QMARK] = ACTIONS(4908),
    [anon_sym_STAR_EQ] = ACTIONS(4908),
    [anon_sym_SLASH_EQ] = ACTIONS(4908),
    [anon_sym_PERCENT_EQ] = ACTIONS(4908),
    [anon_sym_PLUS_EQ] = ACTIONS(4908),
    [anon_sym_DASH_EQ] = ACTIONS(4908),
    [anon_sym_LT_LT_EQ] = ACTIONS(4908),
    [anon_sym_GT_GT_EQ] = ACTIONS(4908),
    [anon_sym_AMP_EQ] = ACTIONS(4908),
    [anon_sym_CARET_EQ] = ACTIONS(4908),
    [anon_sym_PIPE_EQ] = ACTIONS(4908),
    [anon_sym_and_eq] = ACTIONS(4906),
    [anon_sym_or_eq] = ACTIONS(4906),
    [anon_sym_xor_eq] = ACTIONS(4906),
    [anon_sym_LT_EQ_GT] = ACTIONS(4908),
    [anon_sym_or] = ACTIONS(4906),
    [anon_sym_and] = ACTIONS(4906),
    [anon_sym_bitor] = ACTIONS(4906),
    [anon_sym_xor] = ACTIONS(4906),
    [anon_sym_bitand] = ACTIONS(4906),
    [anon_sym_not_eq] = ACTIONS(4906),
    [anon_sym_DASH_DASH] = ACTIONS(4908),
    [anon_sym_PLUS_PLUS] = ACTIONS(4908),
    [anon_sym_DOT] = ACTIONS(4906),
    [anon_sym_DOT_STAR] = ACTIONS(4908),
    [anon_sym_DASH_GT] = ACTIONS(4908),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4906),
    [anon_sym_decltype] = ACTIONS(4906),
  },
  [1541] = {
    [sym_string_literal] = STATE(3454),
    [sym_template_argument_list] = STATE(2876),
    [sym_raw_string_literal] = STATE(3454),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2267),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4048),
    [anon_sym_COMMA] = ACTIONS(4048),
    [anon_sym_LPAREN2] = ACTIONS(4048),
    [anon_sym_DASH] = ACTIONS(4043),
    [anon_sym_PLUS] = ACTIONS(4043),
    [anon_sym_STAR] = ACTIONS(4045),
    [anon_sym_SLASH] = ACTIONS(4043),
    [anon_sym_PERCENT] = ACTIONS(4043),
    [anon_sym_PIPE_PIPE] = ACTIONS(4035),
    [anon_sym_AMP_AMP] = ACTIONS(4048),
    [anon_sym_PIPE] = ACTIONS(4043),
    [anon_sym_CARET] = ACTIONS(4043),
    [anon_sym_AMP] = ACTIONS(4045),
    [anon_sym_EQ_EQ] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4043),
    [anon_sym_GT_EQ] = ACTIONS(4043),
    [anon_sym_LT_EQ] = ACTIONS(4043),
    [anon_sym_LT] = ACTIONS(4916),
    [anon_sym_LT_LT] = ACTIONS(4043),
    [anon_sym_GT_GT] = ACTIONS(4043),
    [anon_sym___extension__] = ACTIONS(4041),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACE] = ACTIONS(4059),
    [anon_sym_signed] = ACTIONS(4919),
    [anon_sym_unsigned] = ACTIONS(4919),
    [anon_sym_long] = ACTIONS(4919),
    [anon_sym_short] = ACTIONS(4919),
    [anon_sym_LBRACK] = ACTIONS(4048),
    [anon_sym_EQ] = ACTIONS(4921),
    [anon_sym_const] = ACTIONS(4033),
    [anon_sym_constexpr] = ACTIONS(4041),
    [anon_sym_volatile] = ACTIONS(4041),
    [anon_sym_restrict] = ACTIONS(4041),
    [anon_sym___restrict__] = ACTIONS(4041),
    [anon_sym__Atomic] = ACTIONS(4041),
    [anon_sym__Noreturn] = ACTIONS(4041),
    [anon_sym_noreturn] = ACTIONS(4041),
    [anon_sym__Nonnull] = ACTIONS(4041),
    [anon_sym_mutable] = ACTIONS(4041),
    [anon_sym_constinit] = ACTIONS(4041),
    [anon_sym_consteval] = ACTIONS(4041),
    [anon_sym_alignas] = ACTIONS(4041),
    [anon_sym__Alignas] = ACTIONS(4041),
    [anon_sym_QMARK] = ACTIONS(4035),
    [anon_sym_STAR_EQ] = ACTIONS(4923),
    [anon_sym_SLASH_EQ] = ACTIONS(4923),
    [anon_sym_PERCENT_EQ] = ACTIONS(4923),
    [anon_sym_PLUS_EQ] = ACTIONS(4923),
    [anon_sym_DASH_EQ] = ACTIONS(4923),
    [anon_sym_LT_LT_EQ] = ACTIONS(4923),
    [anon_sym_GT_GT_EQ] = ACTIONS(4921),
    [anon_sym_AMP_EQ] = ACTIONS(4923),
    [anon_sym_CARET_EQ] = ACTIONS(4923),
    [anon_sym_PIPE_EQ] = ACTIONS(4923),
    [anon_sym_and_eq] = ACTIONS(4923),
    [anon_sym_or_eq] = ACTIONS(4923),
    [anon_sym_xor_eq] = ACTIONS(4923),
    [anon_sym_LT_EQ_GT] = ACTIONS(4035),
    [anon_sym_or] = ACTIONS(4043),
    [anon_sym_and] = ACTIONS(4043),
    [anon_sym_bitor] = ACTIONS(4035),
    [anon_sym_xor] = ACTIONS(4043),
    [anon_sym_bitand] = ACTIONS(4035),
    [anon_sym_not_eq] = ACTIONS(4035),
    [anon_sym_DASH_DASH] = ACTIONS(4035),
    [anon_sym_PLUS_PLUS] = ACTIONS(4035),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_DOT_STAR] = ACTIONS(4035),
    [anon_sym_DASH_GT] = ACTIONS(4035),
    [anon_sym_L_DQUOTE] = ACTIONS(4925),
    [anon_sym_u_DQUOTE] = ACTIONS(4925),
    [anon_sym_U_DQUOTE] = ACTIONS(4925),
    [anon_sym_u8_DQUOTE] = ACTIONS(4925),
    [anon_sym_DQUOTE] = ACTIONS(4925),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4041),
    [anon_sym_decltype] = ACTIONS(4041),
    [anon_sym_GT2] = ACTIONS(4048),
    [anon_sym_R_DQUOTE] = ACTIONS(4927),
    [anon_sym_LR_DQUOTE] = ACTIONS(4927),
    [anon_sym_uR_DQUOTE] = ACTIONS(4927),
    [anon_sym_UR_DQUOTE] = ACTIONS(4927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4927),
  },
  [1542] = {
    [sym_string_literal] = STATE(2570),
    [sym_template_argument_list] = STATE(2988),
    [sym_raw_string_literal] = STATE(2570),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1896),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4035),
    [anon_sym_RPAREN] = ACTIONS(4048),
    [anon_sym_LPAREN2] = ACTIONS(4048),
    [anon_sym_DASH] = ACTIONS(4043),
    [anon_sym_PLUS] = ACTIONS(4043),
    [anon_sym_STAR] = ACTIONS(4045),
    [anon_sym_SLASH] = ACTIONS(4043),
    [anon_sym_PERCENT] = ACTIONS(4043),
    [anon_sym_PIPE_PIPE] = ACTIONS(4035),
    [anon_sym_AMP_AMP] = ACTIONS(4048),
    [anon_sym_PIPE] = ACTIONS(4043),
    [anon_sym_CARET] = ACTIONS(4043),
    [anon_sym_AMP] = ACTIONS(4045),
    [anon_sym_EQ_EQ] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4043),
    [anon_sym_GT_EQ] = ACTIONS(4035),
    [anon_sym_LT_EQ] = ACTIONS(4043),
    [anon_sym_LT] = ACTIONS(4929),
    [anon_sym_LT_LT] = ACTIONS(4043),
    [anon_sym_GT_GT] = ACTIONS(4043),
    [anon_sym___extension__] = ACTIONS(4041),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACE] = ACTIONS(4059),
    [anon_sym_signed] = ACTIONS(4897),
    [anon_sym_unsigned] = ACTIONS(4897),
    [anon_sym_long] = ACTIONS(4897),
    [anon_sym_short] = ACTIONS(4897),
    [anon_sym_LBRACK] = ACTIONS(4048),
    [anon_sym_EQ] = ACTIONS(4067),
    [anon_sym_const] = ACTIONS(4033),
    [anon_sym_constexpr] = ACTIONS(4041),
    [anon_sym_volatile] = ACTIONS(4041),
    [anon_sym_restrict] = ACTIONS(4041),
    [anon_sym___restrict__] = ACTIONS(4041),
    [anon_sym__Atomic] = ACTIONS(4041),
    [anon_sym__Noreturn] = ACTIONS(4041),
    [anon_sym_noreturn] = ACTIONS(4041),
    [anon_sym__Nonnull] = ACTIONS(4041),
    [anon_sym_mutable] = ACTIONS(4041),
    [anon_sym_constinit] = ACTIONS(4041),
    [anon_sym_consteval] = ACTIONS(4041),
    [anon_sym_alignas] = ACTIONS(4041),
    [anon_sym__Alignas] = ACTIONS(4041),
    [anon_sym_QMARK] = ACTIONS(4035),
    [anon_sym_STAR_EQ] = ACTIONS(4071),
    [anon_sym_SLASH_EQ] = ACTIONS(4071),
    [anon_sym_PERCENT_EQ] = ACTIONS(4071),
    [anon_sym_PLUS_EQ] = ACTIONS(4071),
    [anon_sym_DASH_EQ] = ACTIONS(4071),
    [anon_sym_LT_LT_EQ] = ACTIONS(4071),
    [anon_sym_GT_GT_EQ] = ACTIONS(4071),
    [anon_sym_AMP_EQ] = ACTIONS(4071),
    [anon_sym_CARET_EQ] = ACTIONS(4071),
    [anon_sym_PIPE_EQ] = ACTIONS(4071),
    [anon_sym_and_eq] = ACTIONS(4071),
    [anon_sym_or_eq] = ACTIONS(4071),
    [anon_sym_xor_eq] = ACTIONS(4071),
    [anon_sym_LT_EQ_GT] = ACTIONS(4035),
    [anon_sym_or] = ACTIONS(4043),
    [anon_sym_and] = ACTIONS(4043),
    [anon_sym_bitor] = ACTIONS(4035),
    [anon_sym_xor] = ACTIONS(4043),
    [anon_sym_bitand] = ACTIONS(4035),
    [anon_sym_not_eq] = ACTIONS(4035),
    [anon_sym_DASH_DASH] = ACTIONS(4035),
    [anon_sym_PLUS_PLUS] = ACTIONS(4035),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_DOT_STAR] = ACTIONS(4035),
    [anon_sym_DASH_GT] = ACTIONS(4035),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4041),
    [anon_sym_decltype] = ACTIONS(4041),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
  },
  [1543] = {
    [sym_identifier] = ACTIONS(4855),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4859),
    [anon_sym_COMMA] = ACTIONS(4859),
    [anon_sym_RPAREN] = ACTIONS(4859),
    [anon_sym_LPAREN2] = ACTIONS(4859),
    [anon_sym_TILDE] = ACTIONS(4862),
    [anon_sym_DASH] = ACTIONS(4864),
    [anon_sym_PLUS] = ACTIONS(4864),
    [anon_sym_STAR] = ACTIONS(4866),
    [anon_sym_SLASH] = ACTIONS(4864),
    [anon_sym_PERCENT] = ACTIONS(4864),
    [anon_sym_PIPE_PIPE] = ACTIONS(4857),
    [anon_sym_AMP_AMP] = ACTIONS(4859),
    [anon_sym_PIPE] = ACTIONS(4864),
    [anon_sym_CARET] = ACTIONS(4864),
    [anon_sym_AMP] = ACTIONS(4866),
    [anon_sym_EQ_EQ] = ACTIONS(4857),
    [anon_sym_BANG_EQ] = ACTIONS(4857),
    [anon_sym_GT] = ACTIONS(4864),
    [anon_sym_GT_EQ] = ACTIONS(4857),
    [anon_sym_LT_EQ] = ACTIONS(4864),
    [anon_sym_LT] = ACTIONS(4864),
    [anon_sym_LT_LT] = ACTIONS(4864),
    [anon_sym_GT_GT] = ACTIONS(4864),
    [anon_sym___extension__] = ACTIONS(4855),
    [anon_sym_virtual] = ACTIONS(4855),
    [anon_sym_extern] = ACTIONS(4855),
    [anon_sym___attribute__] = ACTIONS(4855),
    [anon_sym___attribute] = ACTIONS(4855),
    [anon_sym_COLON_COLON] = ACTIONS(4862),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4862),
    [anon_sym___declspec] = ACTIONS(4855),
    [anon_sym___based] = ACTIONS(4855),
    [anon_sym_LBRACE] = ACTIONS(4862),
    [anon_sym_LBRACK] = ACTIONS(4866),
    [anon_sym_static] = ACTIONS(4855),
    [anon_sym_EQ] = ACTIONS(4866),
    [anon_sym_register] = ACTIONS(4855),
    [anon_sym_inline] = ACTIONS(4855),
    [anon_sym___inline] = ACTIONS(4855),
    [anon_sym___inline__] = ACTIONS(4855),
    [anon_sym___forceinline] = ACTIONS(4855),
    [anon_sym_thread_local] = ACTIONS(4855),
    [anon_sym___thread] = ACTIONS(4855),
    [anon_sym_const] = ACTIONS(4855),
    [anon_sym_constexpr] = ACTIONS(4855),
    [anon_sym_volatile] = ACTIONS(4855),
    [anon_sym_restrict] = ACTIONS(4855),
    [anon_sym___restrict__] = ACTIONS(4855),
    [anon_sym__Atomic] = ACTIONS(4855),
    [anon_sym__Noreturn] = ACTIONS(4855),
    [anon_sym_noreturn] = ACTIONS(4855),
    [anon_sym__Nonnull] = ACTIONS(4855),
    [anon_sym_mutable] = ACTIONS(4855),
    [anon_sym_constinit] = ACTIONS(4855),
    [anon_sym_consteval] = ACTIONS(4855),
    [anon_sym_alignas] = ACTIONS(4855),
    [anon_sym__Alignas] = ACTIONS(4855),
    [anon_sym_QMARK] = ACTIONS(4857),
    [anon_sym_STAR_EQ] = ACTIONS(4857),
    [anon_sym_SLASH_EQ] = ACTIONS(4857),
    [anon_sym_PERCENT_EQ] = ACTIONS(4857),
    [anon_sym_PLUS_EQ] = ACTIONS(4857),
    [anon_sym_DASH_EQ] = ACTIONS(4857),
    [anon_sym_LT_LT_EQ] = ACTIONS(4857),
    [anon_sym_GT_GT_EQ] = ACTIONS(4857),
    [anon_sym_AMP_EQ] = ACTIONS(4857),
    [anon_sym_CARET_EQ] = ACTIONS(4857),
    [anon_sym_PIPE_EQ] = ACTIONS(4857),
    [anon_sym_LT_EQ_GT] = ACTIONS(4857),
    [anon_sym_or] = ACTIONS(4864),
    [anon_sym_and] = ACTIONS(4864),
    [anon_sym_bitor] = ACTIONS(4864),
    [anon_sym_xor] = ACTIONS(4864),
    [anon_sym_bitand] = ACTIONS(4864),
    [anon_sym_not_eq] = ACTIONS(4864),
    [anon_sym_DASH_DASH] = ACTIONS(4857),
    [anon_sym_PLUS_PLUS] = ACTIONS(4857),
    [anon_sym_DOT] = ACTIONS(4864),
    [anon_sym_DOT_STAR] = ACTIONS(4857),
    [anon_sym_DASH_GT] = ACTIONS(4864),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4855),
    [anon_sym_decltype] = ACTIONS(4855),
    [anon_sym_template] = ACTIONS(4855),
    [anon_sym_operator] = ACTIONS(4855),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4857),
  },
  [1544] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1544),
    [sym_identifier] = ACTIONS(4932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4934),
    [anon_sym_COMMA] = ACTIONS(4934),
    [anon_sym_RPAREN] = ACTIONS(4934),
    [aux_sym_preproc_if_token2] = ACTIONS(4934),
    [aux_sym_preproc_else_token1] = ACTIONS(4934),
    [aux_sym_preproc_elif_token1] = ACTIONS(4932),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4934),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4934),
    [anon_sym_LPAREN2] = ACTIONS(4934),
    [anon_sym_DASH] = ACTIONS(4932),
    [anon_sym_PLUS] = ACTIONS(4932),
    [anon_sym_STAR] = ACTIONS(4932),
    [anon_sym_SLASH] = ACTIONS(4932),
    [anon_sym_PERCENT] = ACTIONS(4932),
    [anon_sym_PIPE_PIPE] = ACTIONS(4934),
    [anon_sym_AMP_AMP] = ACTIONS(4934),
    [anon_sym_PIPE] = ACTIONS(4932),
    [anon_sym_CARET] = ACTIONS(4932),
    [anon_sym_AMP] = ACTIONS(4932),
    [anon_sym_EQ_EQ] = ACTIONS(4934),
    [anon_sym_BANG_EQ] = ACTIONS(4934),
    [anon_sym_GT] = ACTIONS(4932),
    [anon_sym_GT_EQ] = ACTIONS(4934),
    [anon_sym_LT_EQ] = ACTIONS(4932),
    [anon_sym_LT] = ACTIONS(4932),
    [anon_sym_LT_LT] = ACTIONS(4932),
    [anon_sym_GT_GT] = ACTIONS(4932),
    [anon_sym_SEMI] = ACTIONS(4934),
    [anon_sym___extension__] = ACTIONS(4932),
    [anon_sym___attribute__] = ACTIONS(4932),
    [anon_sym___attribute] = ACTIONS(4932),
    [anon_sym_LBRACE] = ACTIONS(4934),
    [anon_sym_RBRACE] = ACTIONS(4934),
    [anon_sym_signed] = ACTIONS(4936),
    [anon_sym_unsigned] = ACTIONS(4936),
    [anon_sym_long] = ACTIONS(4936),
    [anon_sym_short] = ACTIONS(4936),
    [anon_sym_LBRACK] = ACTIONS(4934),
    [anon_sym_RBRACK] = ACTIONS(4934),
    [anon_sym_EQ] = ACTIONS(4932),
    [anon_sym_const] = ACTIONS(4932),
    [anon_sym_constexpr] = ACTIONS(4932),
    [anon_sym_volatile] = ACTIONS(4932),
    [anon_sym_restrict] = ACTIONS(4932),
    [anon_sym___restrict__] = ACTIONS(4932),
    [anon_sym__Atomic] = ACTIONS(4932),
    [anon_sym__Noreturn] = ACTIONS(4932),
    [anon_sym_noreturn] = ACTIONS(4932),
    [anon_sym__Nonnull] = ACTIONS(4932),
    [anon_sym_mutable] = ACTIONS(4932),
    [anon_sym_constinit] = ACTIONS(4932),
    [anon_sym_consteval] = ACTIONS(4932),
    [anon_sym_alignas] = ACTIONS(4932),
    [anon_sym__Alignas] = ACTIONS(4932),
    [sym_primitive_type] = ACTIONS(4932),
    [anon_sym_COLON] = ACTIONS(4934),
    [anon_sym_QMARK] = ACTIONS(4934),
    [anon_sym_STAR_EQ] = ACTIONS(4934),
    [anon_sym_SLASH_EQ] = ACTIONS(4934),
    [anon_sym_PERCENT_EQ] = ACTIONS(4934),
    [anon_sym_PLUS_EQ] = ACTIONS(4934),
    [anon_sym_DASH_EQ] = ACTIONS(4934),
    [anon_sym_LT_LT_EQ] = ACTIONS(4934),
    [anon_sym_GT_GT_EQ] = ACTIONS(4934),
    [anon_sym_AMP_EQ] = ACTIONS(4934),
    [anon_sym_CARET_EQ] = ACTIONS(4934),
    [anon_sym_PIPE_EQ] = ACTIONS(4934),
    [anon_sym_and_eq] = ACTIONS(4932),
    [anon_sym_or_eq] = ACTIONS(4932),
    [anon_sym_xor_eq] = ACTIONS(4932),
    [anon_sym_LT_EQ_GT] = ACTIONS(4934),
    [anon_sym_or] = ACTIONS(4932),
    [anon_sym_and] = ACTIONS(4932),
    [anon_sym_bitor] = ACTIONS(4932),
    [anon_sym_xor] = ACTIONS(4932),
    [anon_sym_bitand] = ACTIONS(4932),
    [anon_sym_not_eq] = ACTIONS(4932),
    [anon_sym_DASH_DASH] = ACTIONS(4934),
    [anon_sym_PLUS_PLUS] = ACTIONS(4934),
    [anon_sym_DOT] = ACTIONS(4932),
    [anon_sym_DOT_STAR] = ACTIONS(4934),
    [anon_sym_DASH_GT] = ACTIONS(4934),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4932),
    [anon_sym_decltype] = ACTIONS(4932),
  },
  [1545] = {
    [sym_identifier] = ACTIONS(4834),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4836),
    [anon_sym_COMMA] = ACTIONS(4836),
    [anon_sym_RPAREN] = ACTIONS(4836),
    [anon_sym_LPAREN2] = ACTIONS(4836),
    [anon_sym_TILDE] = ACTIONS(4836),
    [anon_sym_DASH] = ACTIONS(4834),
    [anon_sym_PLUS] = ACTIONS(4834),
    [anon_sym_STAR] = ACTIONS(4834),
    [anon_sym_SLASH] = ACTIONS(4834),
    [anon_sym_PERCENT] = ACTIONS(4834),
    [anon_sym_PIPE_PIPE] = ACTIONS(4836),
    [anon_sym_AMP_AMP] = ACTIONS(4836),
    [anon_sym_PIPE] = ACTIONS(4834),
    [anon_sym_CARET] = ACTIONS(4834),
    [anon_sym_AMP] = ACTIONS(4834),
    [anon_sym_EQ_EQ] = ACTIONS(4836),
    [anon_sym_BANG_EQ] = ACTIONS(4836),
    [anon_sym_GT] = ACTIONS(4834),
    [anon_sym_GT_EQ] = ACTIONS(4836),
    [anon_sym_LT_EQ] = ACTIONS(4834),
    [anon_sym_LT] = ACTIONS(4834),
    [anon_sym_LT_LT] = ACTIONS(4834),
    [anon_sym_GT_GT] = ACTIONS(4834),
    [anon_sym___extension__] = ACTIONS(4834),
    [anon_sym_virtual] = ACTIONS(4834),
    [anon_sym_extern] = ACTIONS(4834),
    [anon_sym___attribute__] = ACTIONS(4834),
    [anon_sym___attribute] = ACTIONS(4834),
    [anon_sym_COLON_COLON] = ACTIONS(4836),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4836),
    [anon_sym___declspec] = ACTIONS(4834),
    [anon_sym___based] = ACTIONS(4834),
    [anon_sym_LBRACE] = ACTIONS(4836),
    [anon_sym_LBRACK] = ACTIONS(4834),
    [anon_sym_static] = ACTIONS(4834),
    [anon_sym_EQ] = ACTIONS(4834),
    [anon_sym_register] = ACTIONS(4834),
    [anon_sym_inline] = ACTIONS(4834),
    [anon_sym___inline] = ACTIONS(4834),
    [anon_sym___inline__] = ACTIONS(4834),
    [anon_sym___forceinline] = ACTIONS(4834),
    [anon_sym_thread_local] = ACTIONS(4834),
    [anon_sym___thread] = ACTIONS(4834),
    [anon_sym_const] = ACTIONS(4834),
    [anon_sym_constexpr] = ACTIONS(4834),
    [anon_sym_volatile] = ACTIONS(4834),
    [anon_sym_restrict] = ACTIONS(4834),
    [anon_sym___restrict__] = ACTIONS(4834),
    [anon_sym__Atomic] = ACTIONS(4834),
    [anon_sym__Noreturn] = ACTIONS(4834),
    [anon_sym_noreturn] = ACTIONS(4834),
    [anon_sym__Nonnull] = ACTIONS(4834),
    [anon_sym_mutable] = ACTIONS(4834),
    [anon_sym_constinit] = ACTIONS(4834),
    [anon_sym_consteval] = ACTIONS(4834),
    [anon_sym_alignas] = ACTIONS(4834),
    [anon_sym__Alignas] = ACTIONS(4834),
    [anon_sym_QMARK] = ACTIONS(4836),
    [anon_sym_STAR_EQ] = ACTIONS(4836),
    [anon_sym_SLASH_EQ] = ACTIONS(4836),
    [anon_sym_PERCENT_EQ] = ACTIONS(4836),
    [anon_sym_PLUS_EQ] = ACTIONS(4836),
    [anon_sym_DASH_EQ] = ACTIONS(4836),
    [anon_sym_LT_LT_EQ] = ACTIONS(4836),
    [anon_sym_GT_GT_EQ] = ACTIONS(4836),
    [anon_sym_AMP_EQ] = ACTIONS(4836),
    [anon_sym_CARET_EQ] = ACTIONS(4836),
    [anon_sym_PIPE_EQ] = ACTIONS(4836),
    [anon_sym_LT_EQ_GT] = ACTIONS(4836),
    [anon_sym_or] = ACTIONS(4834),
    [anon_sym_and] = ACTIONS(4834),
    [anon_sym_bitor] = ACTIONS(4834),
    [anon_sym_xor] = ACTIONS(4834),
    [anon_sym_bitand] = ACTIONS(4834),
    [anon_sym_not_eq] = ACTIONS(4834),
    [anon_sym_DASH_DASH] = ACTIONS(4836),
    [anon_sym_PLUS_PLUS] = ACTIONS(4836),
    [anon_sym_DOT] = ACTIONS(4834),
    [anon_sym_DOT_STAR] = ACTIONS(4836),
    [anon_sym_DASH_GT] = ACTIONS(4834),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4834),
    [anon_sym_decltype] = ACTIONS(4834),
    [anon_sym_template] = ACTIONS(4834),
    [anon_sym_operator] = ACTIONS(4834),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4836),
  },
  [1546] = {
    [sym_identifier] = ACTIONS(4810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4812),
    [anon_sym_COMMA] = ACTIONS(4812),
    [anon_sym_RPAREN] = ACTIONS(4812),
    [anon_sym_LPAREN2] = ACTIONS(4812),
    [anon_sym_TILDE] = ACTIONS(4812),
    [anon_sym_DASH] = ACTIONS(4810),
    [anon_sym_PLUS] = ACTIONS(4810),
    [anon_sym_STAR] = ACTIONS(4810),
    [anon_sym_SLASH] = ACTIONS(4810),
    [anon_sym_PERCENT] = ACTIONS(4810),
    [anon_sym_PIPE_PIPE] = ACTIONS(4812),
    [anon_sym_AMP_AMP] = ACTIONS(4812),
    [anon_sym_PIPE] = ACTIONS(4810),
    [anon_sym_CARET] = ACTIONS(4810),
    [anon_sym_AMP] = ACTIONS(4810),
    [anon_sym_EQ_EQ] = ACTIONS(4812),
    [anon_sym_BANG_EQ] = ACTIONS(4812),
    [anon_sym_GT] = ACTIONS(4810),
    [anon_sym_GT_EQ] = ACTIONS(4812),
    [anon_sym_LT_EQ] = ACTIONS(4810),
    [anon_sym_LT] = ACTIONS(4810),
    [anon_sym_LT_LT] = ACTIONS(4810),
    [anon_sym_GT_GT] = ACTIONS(4810),
    [anon_sym___extension__] = ACTIONS(4810),
    [anon_sym_virtual] = ACTIONS(4810),
    [anon_sym_extern] = ACTIONS(4810),
    [anon_sym___attribute__] = ACTIONS(4810),
    [anon_sym___attribute] = ACTIONS(4810),
    [anon_sym_COLON_COLON] = ACTIONS(4812),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4812),
    [anon_sym___declspec] = ACTIONS(4810),
    [anon_sym___based] = ACTIONS(4810),
    [anon_sym_LBRACE] = ACTIONS(4812),
    [anon_sym_LBRACK] = ACTIONS(4810),
    [anon_sym_static] = ACTIONS(4810),
    [anon_sym_EQ] = ACTIONS(4810),
    [anon_sym_register] = ACTIONS(4810),
    [anon_sym_inline] = ACTIONS(4810),
    [anon_sym___inline] = ACTIONS(4810),
    [anon_sym___inline__] = ACTIONS(4810),
    [anon_sym___forceinline] = ACTIONS(4810),
    [anon_sym_thread_local] = ACTIONS(4810),
    [anon_sym___thread] = ACTIONS(4810),
    [anon_sym_const] = ACTIONS(4810),
    [anon_sym_constexpr] = ACTIONS(4810),
    [anon_sym_volatile] = ACTIONS(4810),
    [anon_sym_restrict] = ACTIONS(4810),
    [anon_sym___restrict__] = ACTIONS(4810),
    [anon_sym__Atomic] = ACTIONS(4810),
    [anon_sym__Noreturn] = ACTIONS(4810),
    [anon_sym_noreturn] = ACTIONS(4810),
    [anon_sym__Nonnull] = ACTIONS(4810),
    [anon_sym_mutable] = ACTIONS(4810),
    [anon_sym_constinit] = ACTIONS(4810),
    [anon_sym_consteval] = ACTIONS(4810),
    [anon_sym_alignas] = ACTIONS(4810),
    [anon_sym__Alignas] = ACTIONS(4810),
    [anon_sym_QMARK] = ACTIONS(4812),
    [anon_sym_STAR_EQ] = ACTIONS(4812),
    [anon_sym_SLASH_EQ] = ACTIONS(4812),
    [anon_sym_PERCENT_EQ] = ACTIONS(4812),
    [anon_sym_PLUS_EQ] = ACTIONS(4812),
    [anon_sym_DASH_EQ] = ACTIONS(4812),
    [anon_sym_LT_LT_EQ] = ACTIONS(4812),
    [anon_sym_GT_GT_EQ] = ACTIONS(4812),
    [anon_sym_AMP_EQ] = ACTIONS(4812),
    [anon_sym_CARET_EQ] = ACTIONS(4812),
    [anon_sym_PIPE_EQ] = ACTIONS(4812),
    [anon_sym_LT_EQ_GT] = ACTIONS(4812),
    [anon_sym_or] = ACTIONS(4810),
    [anon_sym_and] = ACTIONS(4810),
    [anon_sym_bitor] = ACTIONS(4810),
    [anon_sym_xor] = ACTIONS(4810),
    [anon_sym_bitand] = ACTIONS(4810),
    [anon_sym_not_eq] = ACTIONS(4810),
    [anon_sym_DASH_DASH] = ACTIONS(4812),
    [anon_sym_PLUS_PLUS] = ACTIONS(4812),
    [anon_sym_DOT] = ACTIONS(4810),
    [anon_sym_DOT_STAR] = ACTIONS(4812),
    [anon_sym_DASH_GT] = ACTIONS(4810),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4810),
    [anon_sym_decltype] = ACTIONS(4810),
    [anon_sym_template] = ACTIONS(4810),
    [anon_sym_operator] = ACTIONS(4810),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4812),
  },
  [1547] = {
    [sym_identifier] = ACTIONS(4826),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4828),
    [anon_sym_COMMA] = ACTIONS(4828),
    [anon_sym_RPAREN] = ACTIONS(4828),
    [anon_sym_LPAREN2] = ACTIONS(4828),
    [anon_sym_TILDE] = ACTIONS(4828),
    [anon_sym_DASH] = ACTIONS(4826),
    [anon_sym_PLUS] = ACTIONS(4826),
    [anon_sym_STAR] = ACTIONS(4826),
    [anon_sym_SLASH] = ACTIONS(4826),
    [anon_sym_PERCENT] = ACTIONS(4826),
    [anon_sym_PIPE_PIPE] = ACTIONS(4828),
    [anon_sym_AMP_AMP] = ACTIONS(4828),
    [anon_sym_PIPE] = ACTIONS(4826),
    [anon_sym_CARET] = ACTIONS(4826),
    [anon_sym_AMP] = ACTIONS(4826),
    [anon_sym_EQ_EQ] = ACTIONS(4828),
    [anon_sym_BANG_EQ] = ACTIONS(4828),
    [anon_sym_GT] = ACTIONS(4826),
    [anon_sym_GT_EQ] = ACTIONS(4828),
    [anon_sym_LT_EQ] = ACTIONS(4826),
    [anon_sym_LT] = ACTIONS(4826),
    [anon_sym_LT_LT] = ACTIONS(4826),
    [anon_sym_GT_GT] = ACTIONS(4826),
    [anon_sym___extension__] = ACTIONS(4826),
    [anon_sym_virtual] = ACTIONS(4826),
    [anon_sym_extern] = ACTIONS(4826),
    [anon_sym___attribute__] = ACTIONS(4826),
    [anon_sym___attribute] = ACTIONS(4826),
    [anon_sym_COLON_COLON] = ACTIONS(4828),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4828),
    [anon_sym___declspec] = ACTIONS(4826),
    [anon_sym___based] = ACTIONS(4826),
    [anon_sym_LBRACE] = ACTIONS(4828),
    [anon_sym_LBRACK] = ACTIONS(4826),
    [anon_sym_static] = ACTIONS(4826),
    [anon_sym_EQ] = ACTIONS(4826),
    [anon_sym_register] = ACTIONS(4826),
    [anon_sym_inline] = ACTIONS(4826),
    [anon_sym___inline] = ACTIONS(4826),
    [anon_sym___inline__] = ACTIONS(4826),
    [anon_sym___forceinline] = ACTIONS(4826),
    [anon_sym_thread_local] = ACTIONS(4826),
    [anon_sym___thread] = ACTIONS(4826),
    [anon_sym_const] = ACTIONS(4826),
    [anon_sym_constexpr] = ACTIONS(4826),
    [anon_sym_volatile] = ACTIONS(4826),
    [anon_sym_restrict] = ACTIONS(4826),
    [anon_sym___restrict__] = ACTIONS(4826),
    [anon_sym__Atomic] = ACTIONS(4826),
    [anon_sym__Noreturn] = ACTIONS(4826),
    [anon_sym_noreturn] = ACTIONS(4826),
    [anon_sym__Nonnull] = ACTIONS(4826),
    [anon_sym_mutable] = ACTIONS(4826),
    [anon_sym_constinit] = ACTIONS(4826),
    [anon_sym_consteval] = ACTIONS(4826),
    [anon_sym_alignas] = ACTIONS(4826),
    [anon_sym__Alignas] = ACTIONS(4826),
    [anon_sym_QMARK] = ACTIONS(4828),
    [anon_sym_STAR_EQ] = ACTIONS(4828),
    [anon_sym_SLASH_EQ] = ACTIONS(4828),
    [anon_sym_PERCENT_EQ] = ACTIONS(4828),
    [anon_sym_PLUS_EQ] = ACTIONS(4828),
    [anon_sym_DASH_EQ] = ACTIONS(4828),
    [anon_sym_LT_LT_EQ] = ACTIONS(4828),
    [anon_sym_GT_GT_EQ] = ACTIONS(4828),
    [anon_sym_AMP_EQ] = ACTIONS(4828),
    [anon_sym_CARET_EQ] = ACTIONS(4828),
    [anon_sym_PIPE_EQ] = ACTIONS(4828),
    [anon_sym_LT_EQ_GT] = ACTIONS(4828),
    [anon_sym_or] = ACTIONS(4826),
    [anon_sym_and] = ACTIONS(4826),
    [anon_sym_bitor] = ACTIONS(4826),
    [anon_sym_xor] = ACTIONS(4826),
    [anon_sym_bitand] = ACTIONS(4826),
    [anon_sym_not_eq] = ACTIONS(4826),
    [anon_sym_DASH_DASH] = ACTIONS(4828),
    [anon_sym_PLUS_PLUS] = ACTIONS(4828),
    [anon_sym_DOT] = ACTIONS(4826),
    [anon_sym_DOT_STAR] = ACTIONS(4828),
    [anon_sym_DASH_GT] = ACTIONS(4826),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4826),
    [anon_sym_decltype] = ACTIONS(4826),
    [anon_sym_template] = ACTIONS(4826),
    [anon_sym_operator] = ACTIONS(4826),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4828),
  },
  [1548] = {
    [sym_identifier] = ACTIONS(4822),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4824),
    [anon_sym_COMMA] = ACTIONS(4824),
    [anon_sym_RPAREN] = ACTIONS(4824),
    [anon_sym_LPAREN2] = ACTIONS(4824),
    [anon_sym_TILDE] = ACTIONS(4824),
    [anon_sym_DASH] = ACTIONS(4822),
    [anon_sym_PLUS] = ACTIONS(4822),
    [anon_sym_STAR] = ACTIONS(4822),
    [anon_sym_SLASH] = ACTIONS(4822),
    [anon_sym_PERCENT] = ACTIONS(4822),
    [anon_sym_PIPE_PIPE] = ACTIONS(4824),
    [anon_sym_AMP_AMP] = ACTIONS(4824),
    [anon_sym_PIPE] = ACTIONS(4822),
    [anon_sym_CARET] = ACTIONS(4822),
    [anon_sym_AMP] = ACTIONS(4822),
    [anon_sym_EQ_EQ] = ACTIONS(4824),
    [anon_sym_BANG_EQ] = ACTIONS(4824),
    [anon_sym_GT] = ACTIONS(4822),
    [anon_sym_GT_EQ] = ACTIONS(4824),
    [anon_sym_LT_EQ] = ACTIONS(4822),
    [anon_sym_LT] = ACTIONS(4822),
    [anon_sym_LT_LT] = ACTIONS(4822),
    [anon_sym_GT_GT] = ACTIONS(4822),
    [anon_sym___extension__] = ACTIONS(4822),
    [anon_sym_virtual] = ACTIONS(4822),
    [anon_sym_extern] = ACTIONS(4822),
    [anon_sym___attribute__] = ACTIONS(4822),
    [anon_sym___attribute] = ACTIONS(4822),
    [anon_sym_COLON_COLON] = ACTIONS(4824),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4824),
    [anon_sym___declspec] = ACTIONS(4822),
    [anon_sym___based] = ACTIONS(4822),
    [anon_sym_LBRACE] = ACTIONS(4824),
    [anon_sym_LBRACK] = ACTIONS(4822),
    [anon_sym_static] = ACTIONS(4822),
    [anon_sym_EQ] = ACTIONS(4822),
    [anon_sym_register] = ACTIONS(4822),
    [anon_sym_inline] = ACTIONS(4822),
    [anon_sym___inline] = ACTIONS(4822),
    [anon_sym___inline__] = ACTIONS(4822),
    [anon_sym___forceinline] = ACTIONS(4822),
    [anon_sym_thread_local] = ACTIONS(4822),
    [anon_sym___thread] = ACTIONS(4822),
    [anon_sym_const] = ACTIONS(4822),
    [anon_sym_constexpr] = ACTIONS(4822),
    [anon_sym_volatile] = ACTIONS(4822),
    [anon_sym_restrict] = ACTIONS(4822),
    [anon_sym___restrict__] = ACTIONS(4822),
    [anon_sym__Atomic] = ACTIONS(4822),
    [anon_sym__Noreturn] = ACTIONS(4822),
    [anon_sym_noreturn] = ACTIONS(4822),
    [anon_sym__Nonnull] = ACTIONS(4822),
    [anon_sym_mutable] = ACTIONS(4822),
    [anon_sym_constinit] = ACTIONS(4822),
    [anon_sym_consteval] = ACTIONS(4822),
    [anon_sym_alignas] = ACTIONS(4822),
    [anon_sym__Alignas] = ACTIONS(4822),
    [anon_sym_QMARK] = ACTIONS(4824),
    [anon_sym_STAR_EQ] = ACTIONS(4824),
    [anon_sym_SLASH_EQ] = ACTIONS(4824),
    [anon_sym_PERCENT_EQ] = ACTIONS(4824),
    [anon_sym_PLUS_EQ] = ACTIONS(4824),
    [anon_sym_DASH_EQ] = ACTIONS(4824),
    [anon_sym_LT_LT_EQ] = ACTIONS(4824),
    [anon_sym_GT_GT_EQ] = ACTIONS(4824),
    [anon_sym_AMP_EQ] = ACTIONS(4824),
    [anon_sym_CARET_EQ] = ACTIONS(4824),
    [anon_sym_PIPE_EQ] = ACTIONS(4824),
    [anon_sym_LT_EQ_GT] = ACTIONS(4824),
    [anon_sym_or] = ACTIONS(4822),
    [anon_sym_and] = ACTIONS(4822),
    [anon_sym_bitor] = ACTIONS(4822),
    [anon_sym_xor] = ACTIONS(4822),
    [anon_sym_bitand] = ACTIONS(4822),
    [anon_sym_not_eq] = ACTIONS(4822),
    [anon_sym_DASH_DASH] = ACTIONS(4824),
    [anon_sym_PLUS_PLUS] = ACTIONS(4824),
    [anon_sym_DOT] = ACTIONS(4822),
    [anon_sym_DOT_STAR] = ACTIONS(4824),
    [anon_sym_DASH_GT] = ACTIONS(4822),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4822),
    [anon_sym_decltype] = ACTIONS(4822),
    [anon_sym_template] = ACTIONS(4822),
    [anon_sym_operator] = ACTIONS(4822),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4824),
  },
  [1549] = {
    [sym_identifier] = ACTIONS(4818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4820),
    [anon_sym_COMMA] = ACTIONS(4820),
    [anon_sym_RPAREN] = ACTIONS(4820),
    [anon_sym_LPAREN2] = ACTIONS(4820),
    [anon_sym_TILDE] = ACTIONS(4820),
    [anon_sym_DASH] = ACTIONS(4818),
    [anon_sym_PLUS] = ACTIONS(4818),
    [anon_sym_STAR] = ACTIONS(4818),
    [anon_sym_SLASH] = ACTIONS(4818),
    [anon_sym_PERCENT] = ACTIONS(4818),
    [anon_sym_PIPE_PIPE] = ACTIONS(4820),
    [anon_sym_AMP_AMP] = ACTIONS(4820),
    [anon_sym_PIPE] = ACTIONS(4818),
    [anon_sym_CARET] = ACTIONS(4818),
    [anon_sym_AMP] = ACTIONS(4818),
    [anon_sym_EQ_EQ] = ACTIONS(4820),
    [anon_sym_BANG_EQ] = ACTIONS(4820),
    [anon_sym_GT] = ACTIONS(4818),
    [anon_sym_GT_EQ] = ACTIONS(4820),
    [anon_sym_LT_EQ] = ACTIONS(4818),
    [anon_sym_LT] = ACTIONS(4818),
    [anon_sym_LT_LT] = ACTIONS(4818),
    [anon_sym_GT_GT] = ACTIONS(4818),
    [anon_sym___extension__] = ACTIONS(4818),
    [anon_sym_virtual] = ACTIONS(4818),
    [anon_sym_extern] = ACTIONS(4818),
    [anon_sym___attribute__] = ACTIONS(4818),
    [anon_sym___attribute] = ACTIONS(4818),
    [anon_sym_COLON_COLON] = ACTIONS(4820),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4820),
    [anon_sym___declspec] = ACTIONS(4818),
    [anon_sym___based] = ACTIONS(4818),
    [anon_sym_LBRACE] = ACTIONS(4820),
    [anon_sym_LBRACK] = ACTIONS(4818),
    [anon_sym_static] = ACTIONS(4818),
    [anon_sym_EQ] = ACTIONS(4818),
    [anon_sym_register] = ACTIONS(4818),
    [anon_sym_inline] = ACTIONS(4818),
    [anon_sym___inline] = ACTIONS(4818),
    [anon_sym___inline__] = ACTIONS(4818),
    [anon_sym___forceinline] = ACTIONS(4818),
    [anon_sym_thread_local] = ACTIONS(4818),
    [anon_sym___thread] = ACTIONS(4818),
    [anon_sym_const] = ACTIONS(4818),
    [anon_sym_constexpr] = ACTIONS(4818),
    [anon_sym_volatile] = ACTIONS(4818),
    [anon_sym_restrict] = ACTIONS(4818),
    [anon_sym___restrict__] = ACTIONS(4818),
    [anon_sym__Atomic] = ACTIONS(4818),
    [anon_sym__Noreturn] = ACTIONS(4818),
    [anon_sym_noreturn] = ACTIONS(4818),
    [anon_sym__Nonnull] = ACTIONS(4818),
    [anon_sym_mutable] = ACTIONS(4818),
    [anon_sym_constinit] = ACTIONS(4818),
    [anon_sym_consteval] = ACTIONS(4818),
    [anon_sym_alignas] = ACTIONS(4818),
    [anon_sym__Alignas] = ACTIONS(4818),
    [anon_sym_QMARK] = ACTIONS(4820),
    [anon_sym_STAR_EQ] = ACTIONS(4820),
    [anon_sym_SLASH_EQ] = ACTIONS(4820),
    [anon_sym_PERCENT_EQ] = ACTIONS(4820),
    [anon_sym_PLUS_EQ] = ACTIONS(4820),
    [anon_sym_DASH_EQ] = ACTIONS(4820),
    [anon_sym_LT_LT_EQ] = ACTIONS(4820),
    [anon_sym_GT_GT_EQ] = ACTIONS(4820),
    [anon_sym_AMP_EQ] = ACTIONS(4820),
    [anon_sym_CARET_EQ] = ACTIONS(4820),
    [anon_sym_PIPE_EQ] = ACTIONS(4820),
    [anon_sym_LT_EQ_GT] = ACTIONS(4820),
    [anon_sym_or] = ACTIONS(4818),
    [anon_sym_and] = ACTIONS(4818),
    [anon_sym_bitor] = ACTIONS(4818),
    [anon_sym_xor] = ACTIONS(4818),
    [anon_sym_bitand] = ACTIONS(4818),
    [anon_sym_not_eq] = ACTIONS(4818),
    [anon_sym_DASH_DASH] = ACTIONS(4820),
    [anon_sym_PLUS_PLUS] = ACTIONS(4820),
    [anon_sym_DOT] = ACTIONS(4818),
    [anon_sym_DOT_STAR] = ACTIONS(4820),
    [anon_sym_DASH_GT] = ACTIONS(4818),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4818),
    [anon_sym_decltype] = ACTIONS(4818),
    [anon_sym_template] = ACTIONS(4818),
    [anon_sym_operator] = ACTIONS(4818),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4820),
  },
  [1550] = {
    [sym_identifier] = ACTIONS(4814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4816),
    [anon_sym_COMMA] = ACTIONS(4816),
    [anon_sym_RPAREN] = ACTIONS(4816),
    [anon_sym_LPAREN2] = ACTIONS(4816),
    [anon_sym_TILDE] = ACTIONS(4816),
    [anon_sym_DASH] = ACTIONS(4814),
    [anon_sym_PLUS] = ACTIONS(4814),
    [anon_sym_STAR] = ACTIONS(4814),
    [anon_sym_SLASH] = ACTIONS(4814),
    [anon_sym_PERCENT] = ACTIONS(4814),
    [anon_sym_PIPE_PIPE] = ACTIONS(4816),
    [anon_sym_AMP_AMP] = ACTIONS(4816),
    [anon_sym_PIPE] = ACTIONS(4814),
    [anon_sym_CARET] = ACTIONS(4814),
    [anon_sym_AMP] = ACTIONS(4814),
    [anon_sym_EQ_EQ] = ACTIONS(4816),
    [anon_sym_BANG_EQ] = ACTIONS(4816),
    [anon_sym_GT] = ACTIONS(4814),
    [anon_sym_GT_EQ] = ACTIONS(4816),
    [anon_sym_LT_EQ] = ACTIONS(4814),
    [anon_sym_LT] = ACTIONS(4814),
    [anon_sym_LT_LT] = ACTIONS(4814),
    [anon_sym_GT_GT] = ACTIONS(4814),
    [anon_sym___extension__] = ACTIONS(4814),
    [anon_sym_virtual] = ACTIONS(4814),
    [anon_sym_extern] = ACTIONS(4814),
    [anon_sym___attribute__] = ACTIONS(4814),
    [anon_sym___attribute] = ACTIONS(4814),
    [anon_sym_COLON_COLON] = ACTIONS(4816),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4816),
    [anon_sym___declspec] = ACTIONS(4814),
    [anon_sym___based] = ACTIONS(4814),
    [anon_sym_LBRACE] = ACTIONS(4816),
    [anon_sym_LBRACK] = ACTIONS(4814),
    [anon_sym_static] = ACTIONS(4814),
    [anon_sym_EQ] = ACTIONS(4814),
    [anon_sym_register] = ACTIONS(4814),
    [anon_sym_inline] = ACTIONS(4814),
    [anon_sym___inline] = ACTIONS(4814),
    [anon_sym___inline__] = ACTIONS(4814),
    [anon_sym___forceinline] = ACTIONS(4814),
    [anon_sym_thread_local] = ACTIONS(4814),
    [anon_sym___thread] = ACTIONS(4814),
    [anon_sym_const] = ACTIONS(4814),
    [anon_sym_constexpr] = ACTIONS(4814),
    [anon_sym_volatile] = ACTIONS(4814),
    [anon_sym_restrict] = ACTIONS(4814),
    [anon_sym___restrict__] = ACTIONS(4814),
    [anon_sym__Atomic] = ACTIONS(4814),
    [anon_sym__Noreturn] = ACTIONS(4814),
    [anon_sym_noreturn] = ACTIONS(4814),
    [anon_sym__Nonnull] = ACTIONS(4814),
    [anon_sym_mutable] = ACTIONS(4814),
    [anon_sym_constinit] = ACTIONS(4814),
    [anon_sym_consteval] = ACTIONS(4814),
    [anon_sym_alignas] = ACTIONS(4814),
    [anon_sym__Alignas] = ACTIONS(4814),
    [anon_sym_QMARK] = ACTIONS(4816),
    [anon_sym_STAR_EQ] = ACTIONS(4816),
    [anon_sym_SLASH_EQ] = ACTIONS(4816),
    [anon_sym_PERCENT_EQ] = ACTIONS(4816),
    [anon_sym_PLUS_EQ] = ACTIONS(4816),
    [anon_sym_DASH_EQ] = ACTIONS(4816),
    [anon_sym_LT_LT_EQ] = ACTIONS(4816),
    [anon_sym_GT_GT_EQ] = ACTIONS(4816),
    [anon_sym_AMP_EQ] = ACTIONS(4816),
    [anon_sym_CARET_EQ] = ACTIONS(4816),
    [anon_sym_PIPE_EQ] = ACTIONS(4816),
    [anon_sym_LT_EQ_GT] = ACTIONS(4816),
    [anon_sym_or] = ACTIONS(4814),
    [anon_sym_and] = ACTIONS(4814),
    [anon_sym_bitor] = ACTIONS(4814),
    [anon_sym_xor] = ACTIONS(4814),
    [anon_sym_bitand] = ACTIONS(4814),
    [anon_sym_not_eq] = ACTIONS(4814),
    [anon_sym_DASH_DASH] = ACTIONS(4816),
    [anon_sym_PLUS_PLUS] = ACTIONS(4816),
    [anon_sym_DOT] = ACTIONS(4814),
    [anon_sym_DOT_STAR] = ACTIONS(4816),
    [anon_sym_DASH_GT] = ACTIONS(4814),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4814),
    [anon_sym_decltype] = ACTIONS(4814),
    [anon_sym_template] = ACTIONS(4814),
    [anon_sym_operator] = ACTIONS(4814),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4816),
  },
  [1551] = {
    [sym_identifier] = ACTIONS(4830),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4832),
    [anon_sym_COMMA] = ACTIONS(4832),
    [anon_sym_RPAREN] = ACTIONS(4832),
    [anon_sym_LPAREN2] = ACTIONS(4832),
    [anon_sym_TILDE] = ACTIONS(4832),
    [anon_sym_DASH] = ACTIONS(4830),
    [anon_sym_PLUS] = ACTIONS(4830),
    [anon_sym_STAR] = ACTIONS(4830),
    [anon_sym_SLASH] = ACTIONS(4830),
    [anon_sym_PERCENT] = ACTIONS(4830),
    [anon_sym_PIPE_PIPE] = ACTIONS(4832),
    [anon_sym_AMP_AMP] = ACTIONS(4832),
    [anon_sym_PIPE] = ACTIONS(4830),
    [anon_sym_CARET] = ACTIONS(4830),
    [anon_sym_AMP] = ACTIONS(4830),
    [anon_sym_EQ_EQ] = ACTIONS(4832),
    [anon_sym_BANG_EQ] = ACTIONS(4832),
    [anon_sym_GT] = ACTIONS(4830),
    [anon_sym_GT_EQ] = ACTIONS(4832),
    [anon_sym_LT_EQ] = ACTIONS(4830),
    [anon_sym_LT] = ACTIONS(4830),
    [anon_sym_LT_LT] = ACTIONS(4830),
    [anon_sym_GT_GT] = ACTIONS(4830),
    [anon_sym___extension__] = ACTIONS(4830),
    [anon_sym_virtual] = ACTIONS(4830),
    [anon_sym_extern] = ACTIONS(4830),
    [anon_sym___attribute__] = ACTIONS(4830),
    [anon_sym___attribute] = ACTIONS(4830),
    [anon_sym_COLON_COLON] = ACTIONS(4832),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4832),
    [anon_sym___declspec] = ACTIONS(4830),
    [anon_sym___based] = ACTIONS(4830),
    [anon_sym_LBRACE] = ACTIONS(4832),
    [anon_sym_LBRACK] = ACTIONS(4830),
    [anon_sym_static] = ACTIONS(4830),
    [anon_sym_EQ] = ACTIONS(4830),
    [anon_sym_register] = ACTIONS(4830),
    [anon_sym_inline] = ACTIONS(4830),
    [anon_sym___inline] = ACTIONS(4830),
    [anon_sym___inline__] = ACTIONS(4830),
    [anon_sym___forceinline] = ACTIONS(4830),
    [anon_sym_thread_local] = ACTIONS(4830),
    [anon_sym___thread] = ACTIONS(4830),
    [anon_sym_const] = ACTIONS(4830),
    [anon_sym_constexpr] = ACTIONS(4830),
    [anon_sym_volatile] = ACTIONS(4830),
    [anon_sym_restrict] = ACTIONS(4830),
    [anon_sym___restrict__] = ACTIONS(4830),
    [anon_sym__Atomic] = ACTIONS(4830),
    [anon_sym__Noreturn] = ACTIONS(4830),
    [anon_sym_noreturn] = ACTIONS(4830),
    [anon_sym__Nonnull] = ACTIONS(4830),
    [anon_sym_mutable] = ACTIONS(4830),
    [anon_sym_constinit] = ACTIONS(4830),
    [anon_sym_consteval] = ACTIONS(4830),
    [anon_sym_alignas] = ACTIONS(4830),
    [anon_sym__Alignas] = ACTIONS(4830),
    [anon_sym_QMARK] = ACTIONS(4832),
    [anon_sym_STAR_EQ] = ACTIONS(4832),
    [anon_sym_SLASH_EQ] = ACTIONS(4832),
    [anon_sym_PERCENT_EQ] = ACTIONS(4832),
    [anon_sym_PLUS_EQ] = ACTIONS(4832),
    [anon_sym_DASH_EQ] = ACTIONS(4832),
    [anon_sym_LT_LT_EQ] = ACTIONS(4832),
    [anon_sym_GT_GT_EQ] = ACTIONS(4832),
    [anon_sym_AMP_EQ] = ACTIONS(4832),
    [anon_sym_CARET_EQ] = ACTIONS(4832),
    [anon_sym_PIPE_EQ] = ACTIONS(4832),
    [anon_sym_LT_EQ_GT] = ACTIONS(4832),
    [anon_sym_or] = ACTIONS(4830),
    [anon_sym_and] = ACTIONS(4830),
    [anon_sym_bitor] = ACTIONS(4830),
    [anon_sym_xor] = ACTIONS(4830),
    [anon_sym_bitand] = ACTIONS(4830),
    [anon_sym_not_eq] = ACTIONS(4830),
    [anon_sym_DASH_DASH] = ACTIONS(4832),
    [anon_sym_PLUS_PLUS] = ACTIONS(4832),
    [anon_sym_DOT] = ACTIONS(4830),
    [anon_sym_DOT_STAR] = ACTIONS(4832),
    [anon_sym_DASH_GT] = ACTIONS(4830),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4830),
    [anon_sym_decltype] = ACTIONS(4830),
    [anon_sym_template] = ACTIONS(4830),
    [anon_sym_operator] = ACTIONS(4830),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4832),
  },
  [1552] = {
    [sym_identifier] = ACTIONS(2536),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2526),
    [anon_sym_COMMA] = ACTIONS(2526),
    [anon_sym_RPAREN] = ACTIONS(2526),
    [aux_sym_preproc_if_token2] = ACTIONS(2526),
    [aux_sym_preproc_else_token1] = ACTIONS(2526),
    [aux_sym_preproc_elif_token1] = ACTIONS(2536),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2526),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2526),
    [anon_sym_LPAREN2] = ACTIONS(2526),
    [anon_sym_DASH] = ACTIONS(2536),
    [anon_sym_PLUS] = ACTIONS(2536),
    [anon_sym_STAR] = ACTIONS(2536),
    [anon_sym_SLASH] = ACTIONS(2536),
    [anon_sym_PERCENT] = ACTIONS(2536),
    [anon_sym_PIPE_PIPE] = ACTIONS(2526),
    [anon_sym_AMP_AMP] = ACTIONS(2526),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_CARET] = ACTIONS(2536),
    [anon_sym_AMP] = ACTIONS(2536),
    [anon_sym_EQ_EQ] = ACTIONS(2526),
    [anon_sym_BANG_EQ] = ACTIONS(2526),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_EQ] = ACTIONS(2526),
    [anon_sym_LT_EQ] = ACTIONS(2536),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2536),
    [anon_sym_SEMI] = ACTIONS(2526),
    [anon_sym___extension__] = ACTIONS(2536),
    [anon_sym___attribute__] = ACTIONS(2536),
    [anon_sym___attribute] = ACTIONS(2536),
    [anon_sym_LBRACE] = ACTIONS(2526),
    [anon_sym_RBRACE] = ACTIONS(2526),
    [anon_sym_signed] = ACTIONS(2536),
    [anon_sym_unsigned] = ACTIONS(2536),
    [anon_sym_long] = ACTIONS(2536),
    [anon_sym_short] = ACTIONS(2536),
    [anon_sym_LBRACK] = ACTIONS(2526),
    [anon_sym_RBRACK] = ACTIONS(2526),
    [anon_sym_EQ] = ACTIONS(2536),
    [anon_sym_const] = ACTIONS(2536),
    [anon_sym_constexpr] = ACTIONS(2536),
    [anon_sym_volatile] = ACTIONS(2536),
    [anon_sym_restrict] = ACTIONS(2536),
    [anon_sym___restrict__] = ACTIONS(2536),
    [anon_sym__Atomic] = ACTIONS(2536),
    [anon_sym__Noreturn] = ACTIONS(2536),
    [anon_sym_noreturn] = ACTIONS(2536),
    [anon_sym__Nonnull] = ACTIONS(2536),
    [anon_sym_mutable] = ACTIONS(2536),
    [anon_sym_constinit] = ACTIONS(2536),
    [anon_sym_consteval] = ACTIONS(2536),
    [anon_sym_alignas] = ACTIONS(2536),
    [anon_sym__Alignas] = ACTIONS(2536),
    [sym_primitive_type] = ACTIONS(2536),
    [anon_sym_COLON] = ACTIONS(2526),
    [anon_sym_QMARK] = ACTIONS(2526),
    [anon_sym_STAR_EQ] = ACTIONS(2526),
    [anon_sym_SLASH_EQ] = ACTIONS(2526),
    [anon_sym_PERCENT_EQ] = ACTIONS(2526),
    [anon_sym_PLUS_EQ] = ACTIONS(2526),
    [anon_sym_DASH_EQ] = ACTIONS(2526),
    [anon_sym_LT_LT_EQ] = ACTIONS(2526),
    [anon_sym_GT_GT_EQ] = ACTIONS(2526),
    [anon_sym_AMP_EQ] = ACTIONS(2526),
    [anon_sym_CARET_EQ] = ACTIONS(2526),
    [anon_sym_PIPE_EQ] = ACTIONS(2526),
    [anon_sym_and_eq] = ACTIONS(2536),
    [anon_sym_or_eq] = ACTIONS(2536),
    [anon_sym_xor_eq] = ACTIONS(2536),
    [anon_sym_LT_EQ_GT] = ACTIONS(2526),
    [anon_sym_or] = ACTIONS(2536),
    [anon_sym_and] = ACTIONS(2536),
    [anon_sym_bitor] = ACTIONS(2536),
    [anon_sym_xor] = ACTIONS(2536),
    [anon_sym_bitand] = ACTIONS(2536),
    [anon_sym_not_eq] = ACTIONS(2536),
    [anon_sym_DASH_DASH] = ACTIONS(2526),
    [anon_sym_PLUS_PLUS] = ACTIONS(2526),
    [anon_sym_DOT] = ACTIONS(2536),
    [anon_sym_DOT_STAR] = ACTIONS(2526),
    [anon_sym_DASH_GT] = ACTIONS(2526),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2536),
    [anon_sym_decltype] = ACTIONS(2536),
  },
  [1553] = {
    [sym_identifier] = ACTIONS(4939),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4941),
    [anon_sym_COMMA] = ACTIONS(4941),
    [anon_sym_RPAREN] = ACTIONS(4941),
    [aux_sym_preproc_if_token2] = ACTIONS(4941),
    [aux_sym_preproc_else_token1] = ACTIONS(4941),
    [aux_sym_preproc_elif_token1] = ACTIONS(4939),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4941),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4941),
    [anon_sym_LPAREN2] = ACTIONS(4941),
    [anon_sym_DASH] = ACTIONS(4939),
    [anon_sym_PLUS] = ACTIONS(4939),
    [anon_sym_STAR] = ACTIONS(4939),
    [anon_sym_SLASH] = ACTIONS(4939),
    [anon_sym_PERCENT] = ACTIONS(4939),
    [anon_sym_PIPE_PIPE] = ACTIONS(4941),
    [anon_sym_AMP_AMP] = ACTIONS(4941),
    [anon_sym_PIPE] = ACTIONS(4939),
    [anon_sym_CARET] = ACTIONS(4939),
    [anon_sym_AMP] = ACTIONS(4939),
    [anon_sym_EQ_EQ] = ACTIONS(4941),
    [anon_sym_BANG_EQ] = ACTIONS(4941),
    [anon_sym_GT] = ACTIONS(4939),
    [anon_sym_GT_EQ] = ACTIONS(4941),
    [anon_sym_LT_EQ] = ACTIONS(4939),
    [anon_sym_LT] = ACTIONS(4939),
    [anon_sym_LT_LT] = ACTIONS(4939),
    [anon_sym_GT_GT] = ACTIONS(4939),
    [anon_sym_SEMI] = ACTIONS(4941),
    [anon_sym___extension__] = ACTIONS(4939),
    [anon_sym___attribute__] = ACTIONS(4939),
    [anon_sym___attribute] = ACTIONS(4939),
    [anon_sym_LBRACE] = ACTIONS(4941),
    [anon_sym_RBRACE] = ACTIONS(4941),
    [anon_sym_signed] = ACTIONS(4939),
    [anon_sym_unsigned] = ACTIONS(4939),
    [anon_sym_long] = ACTIONS(4939),
    [anon_sym_short] = ACTIONS(4939),
    [anon_sym_LBRACK] = ACTIONS(4941),
    [anon_sym_RBRACK] = ACTIONS(4941),
    [anon_sym_EQ] = ACTIONS(4939),
    [anon_sym_const] = ACTIONS(4939),
    [anon_sym_constexpr] = ACTIONS(4939),
    [anon_sym_volatile] = ACTIONS(4939),
    [anon_sym_restrict] = ACTIONS(4939),
    [anon_sym___restrict__] = ACTIONS(4939),
    [anon_sym__Atomic] = ACTIONS(4939),
    [anon_sym__Noreturn] = ACTIONS(4939),
    [anon_sym_noreturn] = ACTIONS(4939),
    [anon_sym__Nonnull] = ACTIONS(4939),
    [anon_sym_mutable] = ACTIONS(4939),
    [anon_sym_constinit] = ACTIONS(4939),
    [anon_sym_consteval] = ACTIONS(4939),
    [anon_sym_alignas] = ACTIONS(4939),
    [anon_sym__Alignas] = ACTIONS(4939),
    [sym_primitive_type] = ACTIONS(4939),
    [anon_sym_COLON] = ACTIONS(4941),
    [anon_sym_QMARK] = ACTIONS(4941),
    [anon_sym_STAR_EQ] = ACTIONS(4941),
    [anon_sym_SLASH_EQ] = ACTIONS(4941),
    [anon_sym_PERCENT_EQ] = ACTIONS(4941),
    [anon_sym_PLUS_EQ] = ACTIONS(4941),
    [anon_sym_DASH_EQ] = ACTIONS(4941),
    [anon_sym_LT_LT_EQ] = ACTIONS(4941),
    [anon_sym_GT_GT_EQ] = ACTIONS(4941),
    [anon_sym_AMP_EQ] = ACTIONS(4941),
    [anon_sym_CARET_EQ] = ACTIONS(4941),
    [anon_sym_PIPE_EQ] = ACTIONS(4941),
    [anon_sym_and_eq] = ACTIONS(4939),
    [anon_sym_or_eq] = ACTIONS(4939),
    [anon_sym_xor_eq] = ACTIONS(4939),
    [anon_sym_LT_EQ_GT] = ACTIONS(4941),
    [anon_sym_or] = ACTIONS(4939),
    [anon_sym_and] = ACTIONS(4939),
    [anon_sym_bitor] = ACTIONS(4939),
    [anon_sym_xor] = ACTIONS(4939),
    [anon_sym_bitand] = ACTIONS(4939),
    [anon_sym_not_eq] = ACTIONS(4939),
    [anon_sym_DASH_DASH] = ACTIONS(4941),
    [anon_sym_PLUS_PLUS] = ACTIONS(4941),
    [anon_sym_DOT] = ACTIONS(4939),
    [anon_sym_DOT_STAR] = ACTIONS(4941),
    [anon_sym_DASH_GT] = ACTIONS(4941),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4939),
    [anon_sym_decltype] = ACTIONS(4939),
  },
  [1554] = {
    [sym_type_qualifier] = STATE(1555),
    [sym_alignas_qualifier] = STATE(1552),
    [aux_sym__type_definition_type_repeat1] = STATE(1555),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1567),
    [sym_identifier] = ACTIONS(4943),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4946),
    [anon_sym_COMMA] = ACTIONS(4946),
    [aux_sym_preproc_if_token2] = ACTIONS(4946),
    [aux_sym_preproc_else_token1] = ACTIONS(4946),
    [aux_sym_preproc_elif_token1] = ACTIONS(4948),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4946),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(4946),
    [anon_sym_DASH] = ACTIONS(4948),
    [anon_sym_PLUS] = ACTIONS(4948),
    [anon_sym_STAR] = ACTIONS(4948),
    [anon_sym_SLASH] = ACTIONS(4948),
    [anon_sym_PERCENT] = ACTIONS(4948),
    [anon_sym_PIPE_PIPE] = ACTIONS(4946),
    [anon_sym_AMP_AMP] = ACTIONS(4946),
    [anon_sym_PIPE] = ACTIONS(4948),
    [anon_sym_CARET] = ACTIONS(4948),
    [anon_sym_AMP] = ACTIONS(4948),
    [anon_sym_EQ_EQ] = ACTIONS(4946),
    [anon_sym_BANG_EQ] = ACTIONS(4946),
    [anon_sym_GT] = ACTIONS(4948),
    [anon_sym_GT_EQ] = ACTIONS(4946),
    [anon_sym_LT_EQ] = ACTIONS(4948),
    [anon_sym_LT] = ACTIONS(4948),
    [anon_sym_LT_LT] = ACTIONS(4948),
    [anon_sym_GT_GT] = ACTIONS(4948),
    [anon_sym___extension__] = ACTIONS(4950),
    [anon_sym___attribute__] = ACTIONS(4948),
    [anon_sym___attribute] = ACTIONS(4948),
    [anon_sym_LBRACE] = ACTIONS(4946),
    [anon_sym_signed] = ACTIONS(4952),
    [anon_sym_unsigned] = ACTIONS(4952),
    [anon_sym_long] = ACTIONS(4952),
    [anon_sym_short] = ACTIONS(4952),
    [anon_sym_LBRACK] = ACTIONS(4946),
    [anon_sym_EQ] = ACTIONS(4948),
    [anon_sym_const] = ACTIONS(4950),
    [anon_sym_constexpr] = ACTIONS(4950),
    [anon_sym_volatile] = ACTIONS(4950),
    [anon_sym_restrict] = ACTIONS(4950),
    [anon_sym___restrict__] = ACTIONS(4950),
    [anon_sym__Atomic] = ACTIONS(4950),
    [anon_sym__Noreturn] = ACTIONS(4950),
    [anon_sym_noreturn] = ACTIONS(4950),
    [anon_sym__Nonnull] = ACTIONS(4950),
    [anon_sym_mutable] = ACTIONS(4950),
    [anon_sym_constinit] = ACTIONS(4950),
    [anon_sym_consteval] = ACTIONS(4950),
    [anon_sym_alignas] = ACTIONS(4954),
    [anon_sym__Alignas] = ACTIONS(4954),
    [sym_primitive_type] = ACTIONS(4956),
    [anon_sym_QMARK] = ACTIONS(4946),
    [anon_sym_STAR_EQ] = ACTIONS(4946),
    [anon_sym_SLASH_EQ] = ACTIONS(4946),
    [anon_sym_PERCENT_EQ] = ACTIONS(4946),
    [anon_sym_PLUS_EQ] = ACTIONS(4946),
    [anon_sym_DASH_EQ] = ACTIONS(4946),
    [anon_sym_LT_LT_EQ] = ACTIONS(4946),
    [anon_sym_GT_GT_EQ] = ACTIONS(4946),
    [anon_sym_AMP_EQ] = ACTIONS(4946),
    [anon_sym_CARET_EQ] = ACTIONS(4946),
    [anon_sym_PIPE_EQ] = ACTIONS(4946),
    [anon_sym_and_eq] = ACTIONS(4948),
    [anon_sym_or_eq] = ACTIONS(4948),
    [anon_sym_xor_eq] = ACTIONS(4948),
    [anon_sym_LT_EQ_GT] = ACTIONS(4946),
    [anon_sym_or] = ACTIONS(4948),
    [anon_sym_and] = ACTIONS(4948),
    [anon_sym_bitor] = ACTIONS(4948),
    [anon_sym_xor] = ACTIONS(4948),
    [anon_sym_bitand] = ACTIONS(4948),
    [anon_sym_not_eq] = ACTIONS(4948),
    [anon_sym_DASH_DASH] = ACTIONS(4946),
    [anon_sym_PLUS_PLUS] = ACTIONS(4946),
    [anon_sym_DOT] = ACTIONS(4948),
    [anon_sym_DOT_STAR] = ACTIONS(4946),
    [anon_sym_DASH_GT] = ACTIONS(4946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4948),
    [anon_sym_decltype] = ACTIONS(4948),
  },
  [1555] = {
    [sym_type_qualifier] = STATE(1540),
    [sym_alignas_qualifier] = STATE(1552),
    [aux_sym__type_definition_type_repeat1] = STATE(1540),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2178),
    [sym_identifier] = ACTIONS(4958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4961),
    [anon_sym_COMMA] = ACTIONS(4961),
    [aux_sym_preproc_if_token2] = ACTIONS(4961),
    [aux_sym_preproc_else_token1] = ACTIONS(4961),
    [aux_sym_preproc_elif_token1] = ACTIONS(4963),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4961),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4961),
    [anon_sym_LPAREN2] = ACTIONS(4961),
    [anon_sym_DASH] = ACTIONS(4963),
    [anon_sym_PLUS] = ACTIONS(4963),
    [anon_sym_STAR] = ACTIONS(4963),
    [anon_sym_SLASH] = ACTIONS(4963),
    [anon_sym_PERCENT] = ACTIONS(4963),
    [anon_sym_PIPE_PIPE] = ACTIONS(4961),
    [anon_sym_AMP_AMP] = ACTIONS(4961),
    [anon_sym_PIPE] = ACTIONS(4963),
    [anon_sym_CARET] = ACTIONS(4963),
    [anon_sym_AMP] = ACTIONS(4963),
    [anon_sym_EQ_EQ] = ACTIONS(4961),
    [anon_sym_BANG_EQ] = ACTIONS(4961),
    [anon_sym_GT] = ACTIONS(4963),
    [anon_sym_GT_EQ] = ACTIONS(4961),
    [anon_sym_LT_EQ] = ACTIONS(4963),
    [anon_sym_LT] = ACTIONS(4963),
    [anon_sym_LT_LT] = ACTIONS(4963),
    [anon_sym_GT_GT] = ACTIONS(4963),
    [anon_sym___extension__] = ACTIONS(4950),
    [anon_sym___attribute__] = ACTIONS(4963),
    [anon_sym___attribute] = ACTIONS(4963),
    [anon_sym_LBRACE] = ACTIONS(4961),
    [anon_sym_signed] = ACTIONS(4965),
    [anon_sym_unsigned] = ACTIONS(4965),
    [anon_sym_long] = ACTIONS(4965),
    [anon_sym_short] = ACTIONS(4965),
    [anon_sym_LBRACK] = ACTIONS(4961),
    [anon_sym_EQ] = ACTIONS(4963),
    [anon_sym_const] = ACTIONS(4950),
    [anon_sym_constexpr] = ACTIONS(4950),
    [anon_sym_volatile] = ACTIONS(4950),
    [anon_sym_restrict] = ACTIONS(4950),
    [anon_sym___restrict__] = ACTIONS(4950),
    [anon_sym__Atomic] = ACTIONS(4950),
    [anon_sym__Noreturn] = ACTIONS(4950),
    [anon_sym_noreturn] = ACTIONS(4950),
    [anon_sym__Nonnull] = ACTIONS(4950),
    [anon_sym_mutable] = ACTIONS(4950),
    [anon_sym_constinit] = ACTIONS(4950),
    [anon_sym_consteval] = ACTIONS(4950),
    [anon_sym_alignas] = ACTIONS(4954),
    [anon_sym__Alignas] = ACTIONS(4954),
    [sym_primitive_type] = ACTIONS(4967),
    [anon_sym_QMARK] = ACTIONS(4961),
    [anon_sym_STAR_EQ] = ACTIONS(4961),
    [anon_sym_SLASH_EQ] = ACTIONS(4961),
    [anon_sym_PERCENT_EQ] = ACTIONS(4961),
    [anon_sym_PLUS_EQ] = ACTIONS(4961),
    [anon_sym_DASH_EQ] = ACTIONS(4961),
    [anon_sym_LT_LT_EQ] = ACTIONS(4961),
    [anon_sym_GT_GT_EQ] = ACTIONS(4961),
    [anon_sym_AMP_EQ] = ACTIONS(4961),
    [anon_sym_CARET_EQ] = ACTIONS(4961),
    [anon_sym_PIPE_EQ] = ACTIONS(4961),
    [anon_sym_and_eq] = ACTIONS(4963),
    [anon_sym_or_eq] = ACTIONS(4963),
    [anon_sym_xor_eq] = ACTIONS(4963),
    [anon_sym_LT_EQ_GT] = ACTIONS(4961),
    [anon_sym_or] = ACTIONS(4963),
    [anon_sym_and] = ACTIONS(4963),
    [anon_sym_bitor] = ACTIONS(4963),
    [anon_sym_xor] = ACTIONS(4963),
    [anon_sym_bitand] = ACTIONS(4963),
    [anon_sym_not_eq] = ACTIONS(4963),
    [anon_sym_DASH_DASH] = ACTIONS(4961),
    [anon_sym_PLUS_PLUS] = ACTIONS(4961),
    [anon_sym_DOT] = ACTIONS(4963),
    [anon_sym_DOT_STAR] = ACTIONS(4961),
    [anon_sym_DASH_GT] = ACTIONS(4961),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4963),
    [anon_sym_decltype] = ACTIONS(4963),
  },
  [1556] = {
    [sym_type_qualifier] = STATE(1557),
    [sym_alignas_qualifier] = STATE(1552),
    [aux_sym__type_definition_type_repeat1] = STATE(1557),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1566),
    [sym_identifier] = ACTIONS(4969),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4946),
    [anon_sym_COMMA] = ACTIONS(4946),
    [anon_sym_RPAREN] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(4946),
    [anon_sym_DASH] = ACTIONS(4948),
    [anon_sym_PLUS] = ACTIONS(4948),
    [anon_sym_STAR] = ACTIONS(4948),
    [anon_sym_SLASH] = ACTIONS(4948),
    [anon_sym_PERCENT] = ACTIONS(4948),
    [anon_sym_PIPE_PIPE] = ACTIONS(4946),
    [anon_sym_AMP_AMP] = ACTIONS(4946),
    [anon_sym_PIPE] = ACTIONS(4948),
    [anon_sym_CARET] = ACTIONS(4948),
    [anon_sym_AMP] = ACTIONS(4948),
    [anon_sym_EQ_EQ] = ACTIONS(4946),
    [anon_sym_BANG_EQ] = ACTIONS(4946),
    [anon_sym_GT] = ACTIONS(4948),
    [anon_sym_GT_EQ] = ACTIONS(4946),
    [anon_sym_LT_EQ] = ACTIONS(4948),
    [anon_sym_LT] = ACTIONS(4948),
    [anon_sym_LT_LT] = ACTIONS(4948),
    [anon_sym_GT_GT] = ACTIONS(4948),
    [anon_sym_SEMI] = ACTIONS(4946),
    [anon_sym___extension__] = ACTIONS(4950),
    [anon_sym___attribute__] = ACTIONS(4948),
    [anon_sym___attribute] = ACTIONS(4948),
    [anon_sym_LBRACE] = ACTIONS(4946),
    [anon_sym_RBRACE] = ACTIONS(4946),
    [anon_sym_signed] = ACTIONS(4971),
    [anon_sym_unsigned] = ACTIONS(4971),
    [anon_sym_long] = ACTIONS(4971),
    [anon_sym_short] = ACTIONS(4971),
    [anon_sym_LBRACK] = ACTIONS(4946),
    [anon_sym_RBRACK] = ACTIONS(4946),
    [anon_sym_EQ] = ACTIONS(4948),
    [anon_sym_const] = ACTIONS(4950),
    [anon_sym_constexpr] = ACTIONS(4950),
    [anon_sym_volatile] = ACTIONS(4950),
    [anon_sym_restrict] = ACTIONS(4950),
    [anon_sym___restrict__] = ACTIONS(4950),
    [anon_sym__Atomic] = ACTIONS(4950),
    [anon_sym__Noreturn] = ACTIONS(4950),
    [anon_sym_noreturn] = ACTIONS(4950),
    [anon_sym__Nonnull] = ACTIONS(4950),
    [anon_sym_mutable] = ACTIONS(4950),
    [anon_sym_constinit] = ACTIONS(4950),
    [anon_sym_consteval] = ACTIONS(4950),
    [anon_sym_alignas] = ACTIONS(4954),
    [anon_sym__Alignas] = ACTIONS(4954),
    [sym_primitive_type] = ACTIONS(4973),
    [anon_sym_COLON] = ACTIONS(4946),
    [anon_sym_QMARK] = ACTIONS(4946),
    [anon_sym_STAR_EQ] = ACTIONS(4946),
    [anon_sym_SLASH_EQ] = ACTIONS(4946),
    [anon_sym_PERCENT_EQ] = ACTIONS(4946),
    [anon_sym_PLUS_EQ] = ACTIONS(4946),
    [anon_sym_DASH_EQ] = ACTIONS(4946),
    [anon_sym_LT_LT_EQ] = ACTIONS(4946),
    [anon_sym_GT_GT_EQ] = ACTIONS(4946),
    [anon_sym_AMP_EQ] = ACTIONS(4946),
    [anon_sym_CARET_EQ] = ACTIONS(4946),
    [anon_sym_PIPE_EQ] = ACTIONS(4946),
    [anon_sym_and_eq] = ACTIONS(4948),
    [anon_sym_or_eq] = ACTIONS(4948),
    [anon_sym_xor_eq] = ACTIONS(4948),
    [anon_sym_LT_EQ_GT] = ACTIONS(4946),
    [anon_sym_or] = ACTIONS(4948),
    [anon_sym_and] = ACTIONS(4948),
    [anon_sym_bitor] = ACTIONS(4948),
    [anon_sym_xor] = ACTIONS(4948),
    [anon_sym_bitand] = ACTIONS(4948),
    [anon_sym_not_eq] = ACTIONS(4948),
    [anon_sym_DASH_DASH] = ACTIONS(4946),
    [anon_sym_PLUS_PLUS] = ACTIONS(4946),
    [anon_sym_DOT] = ACTIONS(4948),
    [anon_sym_DOT_STAR] = ACTIONS(4946),
    [anon_sym_DASH_GT] = ACTIONS(4946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4948),
    [anon_sym_decltype] = ACTIONS(4948),
  },
  [1557] = {
    [sym_type_qualifier] = STATE(1540),
    [sym_alignas_qualifier] = STATE(1552),
    [aux_sym__type_definition_type_repeat1] = STATE(1540),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2278),
    [sym_identifier] = ACTIONS(4975),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4961),
    [anon_sym_COMMA] = ACTIONS(4961),
    [anon_sym_RPAREN] = ACTIONS(4961),
    [anon_sym_LPAREN2] = ACTIONS(4961),
    [anon_sym_DASH] = ACTIONS(4963),
    [anon_sym_PLUS] = ACTIONS(4963),
    [anon_sym_STAR] = ACTIONS(4963),
    [anon_sym_SLASH] = ACTIONS(4963),
    [anon_sym_PERCENT] = ACTIONS(4963),
    [anon_sym_PIPE_PIPE] = ACTIONS(4961),
    [anon_sym_AMP_AMP] = ACTIONS(4961),
    [anon_sym_PIPE] = ACTIONS(4963),
    [anon_sym_CARET] = ACTIONS(4963),
    [anon_sym_AMP] = ACTIONS(4963),
    [anon_sym_EQ_EQ] = ACTIONS(4961),
    [anon_sym_BANG_EQ] = ACTIONS(4961),
    [anon_sym_GT] = ACTIONS(4963),
    [anon_sym_GT_EQ] = ACTIONS(4961),
    [anon_sym_LT_EQ] = ACTIONS(4963),
    [anon_sym_LT] = ACTIONS(4963),
    [anon_sym_LT_LT] = ACTIONS(4963),
    [anon_sym_GT_GT] = ACTIONS(4963),
    [anon_sym_SEMI] = ACTIONS(4961),
    [anon_sym___extension__] = ACTIONS(4950),
    [anon_sym___attribute__] = ACTIONS(4963),
    [anon_sym___attribute] = ACTIONS(4963),
    [anon_sym_LBRACE] = ACTIONS(4961),
    [anon_sym_RBRACE] = ACTIONS(4961),
    [anon_sym_signed] = ACTIONS(4977),
    [anon_sym_unsigned] = ACTIONS(4977),
    [anon_sym_long] = ACTIONS(4977),
    [anon_sym_short] = ACTIONS(4977),
    [anon_sym_LBRACK] = ACTIONS(4961),
    [anon_sym_RBRACK] = ACTIONS(4961),
    [anon_sym_EQ] = ACTIONS(4963),
    [anon_sym_const] = ACTIONS(4950),
    [anon_sym_constexpr] = ACTIONS(4950),
    [anon_sym_volatile] = ACTIONS(4950),
    [anon_sym_restrict] = ACTIONS(4950),
    [anon_sym___restrict__] = ACTIONS(4950),
    [anon_sym__Atomic] = ACTIONS(4950),
    [anon_sym__Noreturn] = ACTIONS(4950),
    [anon_sym_noreturn] = ACTIONS(4950),
    [anon_sym__Nonnull] = ACTIONS(4950),
    [anon_sym_mutable] = ACTIONS(4950),
    [anon_sym_constinit] = ACTIONS(4950),
    [anon_sym_consteval] = ACTIONS(4950),
    [anon_sym_alignas] = ACTIONS(4954),
    [anon_sym__Alignas] = ACTIONS(4954),
    [sym_primitive_type] = ACTIONS(4979),
    [anon_sym_COLON] = ACTIONS(4961),
    [anon_sym_QMARK] = ACTIONS(4961),
    [anon_sym_STAR_EQ] = ACTIONS(4961),
    [anon_sym_SLASH_EQ] = ACTIONS(4961),
    [anon_sym_PERCENT_EQ] = ACTIONS(4961),
    [anon_sym_PLUS_EQ] = ACTIONS(4961),
    [anon_sym_DASH_EQ] = ACTIONS(4961),
    [anon_sym_LT_LT_EQ] = ACTIONS(4961),
    [anon_sym_GT_GT_EQ] = ACTIONS(4961),
    [anon_sym_AMP_EQ] = ACTIONS(4961),
    [anon_sym_CARET_EQ] = ACTIONS(4961),
    [anon_sym_PIPE_EQ] = ACTIONS(4961),
    [anon_sym_and_eq] = ACTIONS(4963),
    [anon_sym_or_eq] = ACTIONS(4963),
    [anon_sym_xor_eq] = ACTIONS(4963),
    [anon_sym_LT_EQ_GT] = ACTIONS(4961),
    [anon_sym_or] = ACTIONS(4963),
    [anon_sym_and] = ACTIONS(4963),
    [anon_sym_bitor] = ACTIONS(4963),
    [anon_sym_xor] = ACTIONS(4963),
    [anon_sym_bitand] = ACTIONS(4963),
    [anon_sym_not_eq] = ACTIONS(4963),
    [anon_sym_DASH_DASH] = ACTIONS(4961),
    [anon_sym_PLUS_PLUS] = ACTIONS(4961),
    [anon_sym_DOT] = ACTIONS(4963),
    [anon_sym_DOT_STAR] = ACTIONS(4961),
    [anon_sym_DASH_GT] = ACTIONS(4961),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4963),
    [anon_sym_decltype] = ACTIONS(4963),
  },
  [1558] = {
    [sym_identifier] = ACTIONS(4826),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4828),
    [anon_sym_COMMA] = ACTIONS(4828),
    [anon_sym_RPAREN] = ACTIONS(4828),
    [aux_sym_preproc_if_token2] = ACTIONS(4828),
    [aux_sym_preproc_else_token1] = ACTIONS(4828),
    [aux_sym_preproc_elif_token1] = ACTIONS(4826),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4828),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4828),
    [anon_sym_LPAREN2] = ACTIONS(4828),
    [anon_sym_DASH] = ACTIONS(4826),
    [anon_sym_PLUS] = ACTIONS(4826),
    [anon_sym_STAR] = ACTIONS(4826),
    [anon_sym_SLASH] = ACTIONS(4826),
    [anon_sym_PERCENT] = ACTIONS(4826),
    [anon_sym_PIPE_PIPE] = ACTIONS(4828),
    [anon_sym_AMP_AMP] = ACTIONS(4828),
    [anon_sym_PIPE] = ACTIONS(4826),
    [anon_sym_CARET] = ACTIONS(4826),
    [anon_sym_AMP] = ACTIONS(4826),
    [anon_sym_EQ_EQ] = ACTIONS(4828),
    [anon_sym_BANG_EQ] = ACTIONS(4828),
    [anon_sym_GT] = ACTIONS(4826),
    [anon_sym_GT_EQ] = ACTIONS(4828),
    [anon_sym_LT_EQ] = ACTIONS(4826),
    [anon_sym_LT] = ACTIONS(4826),
    [anon_sym_LT_LT] = ACTIONS(4826),
    [anon_sym_GT_GT] = ACTIONS(4826),
    [anon_sym_SEMI] = ACTIONS(4828),
    [anon_sym___extension__] = ACTIONS(4826),
    [anon_sym___attribute__] = ACTIONS(4826),
    [anon_sym___attribute] = ACTIONS(4826),
    [anon_sym_COLON_COLON] = ACTIONS(4828),
    [anon_sym_LBRACE] = ACTIONS(4828),
    [anon_sym_RBRACE] = ACTIONS(4828),
    [anon_sym_LBRACK] = ACTIONS(4828),
    [anon_sym_RBRACK] = ACTIONS(4828),
    [anon_sym_EQ] = ACTIONS(4826),
    [anon_sym_const] = ACTIONS(4826),
    [anon_sym_constexpr] = ACTIONS(4826),
    [anon_sym_volatile] = ACTIONS(4826),
    [anon_sym_restrict] = ACTIONS(4826),
    [anon_sym___restrict__] = ACTIONS(4826),
    [anon_sym__Atomic] = ACTIONS(4826),
    [anon_sym__Noreturn] = ACTIONS(4826),
    [anon_sym_noreturn] = ACTIONS(4826),
    [anon_sym__Nonnull] = ACTIONS(4826),
    [anon_sym_mutable] = ACTIONS(4826),
    [anon_sym_constinit] = ACTIONS(4826),
    [anon_sym_consteval] = ACTIONS(4826),
    [anon_sym_alignas] = ACTIONS(4826),
    [anon_sym__Alignas] = ACTIONS(4826),
    [anon_sym_COLON] = ACTIONS(4826),
    [anon_sym_QMARK] = ACTIONS(4828),
    [anon_sym_STAR_EQ] = ACTIONS(4828),
    [anon_sym_SLASH_EQ] = ACTIONS(4828),
    [anon_sym_PERCENT_EQ] = ACTIONS(4828),
    [anon_sym_PLUS_EQ] = ACTIONS(4828),
    [anon_sym_DASH_EQ] = ACTIONS(4828),
    [anon_sym_LT_LT_EQ] = ACTIONS(4828),
    [anon_sym_GT_GT_EQ] = ACTIONS(4828),
    [anon_sym_AMP_EQ] = ACTIONS(4828),
    [anon_sym_CARET_EQ] = ACTIONS(4828),
    [anon_sym_PIPE_EQ] = ACTIONS(4828),
    [anon_sym_and_eq] = ACTIONS(4826),
    [anon_sym_or_eq] = ACTIONS(4826),
    [anon_sym_xor_eq] = ACTIONS(4826),
    [anon_sym_LT_EQ_GT] = ACTIONS(4828),
    [anon_sym_or] = ACTIONS(4826),
    [anon_sym_and] = ACTIONS(4826),
    [anon_sym_bitor] = ACTIONS(4826),
    [anon_sym_xor] = ACTIONS(4826),
    [anon_sym_bitand] = ACTIONS(4826),
    [anon_sym_not_eq] = ACTIONS(4826),
    [anon_sym_DASH_DASH] = ACTIONS(4828),
    [anon_sym_PLUS_PLUS] = ACTIONS(4828),
    [anon_sym_DOT] = ACTIONS(4826),
    [anon_sym_DOT_STAR] = ACTIONS(4828),
    [anon_sym_DASH_GT] = ACTIONS(4828),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4826),
    [anon_sym_decltype] = ACTIONS(4826),
    [anon_sym_final] = ACTIONS(4826),
    [anon_sym_override] = ACTIONS(4826),
  },
  [1559] = {
    [sym_identifier] = ACTIONS(4810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4812),
    [anon_sym_COMMA] = ACTIONS(4812),
    [anon_sym_RPAREN] = ACTIONS(4812),
    [aux_sym_preproc_if_token2] = ACTIONS(4812),
    [aux_sym_preproc_else_token1] = ACTIONS(4812),
    [aux_sym_preproc_elif_token1] = ACTIONS(4810),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4812),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4812),
    [anon_sym_LPAREN2] = ACTIONS(4812),
    [anon_sym_DASH] = ACTIONS(4810),
    [anon_sym_PLUS] = ACTIONS(4810),
    [anon_sym_STAR] = ACTIONS(4810),
    [anon_sym_SLASH] = ACTIONS(4810),
    [anon_sym_PERCENT] = ACTIONS(4810),
    [anon_sym_PIPE_PIPE] = ACTIONS(4812),
    [anon_sym_AMP_AMP] = ACTIONS(4812),
    [anon_sym_PIPE] = ACTIONS(4810),
    [anon_sym_CARET] = ACTIONS(4810),
    [anon_sym_AMP] = ACTIONS(4810),
    [anon_sym_EQ_EQ] = ACTIONS(4812),
    [anon_sym_BANG_EQ] = ACTIONS(4812),
    [anon_sym_GT] = ACTIONS(4810),
    [anon_sym_GT_EQ] = ACTIONS(4812),
    [anon_sym_LT_EQ] = ACTIONS(4810),
    [anon_sym_LT] = ACTIONS(4810),
    [anon_sym_LT_LT] = ACTIONS(4810),
    [anon_sym_GT_GT] = ACTIONS(4810),
    [anon_sym_SEMI] = ACTIONS(4812),
    [anon_sym___extension__] = ACTIONS(4810),
    [anon_sym___attribute__] = ACTIONS(4810),
    [anon_sym___attribute] = ACTIONS(4810),
    [anon_sym_COLON_COLON] = ACTIONS(4812),
    [anon_sym_LBRACE] = ACTIONS(4812),
    [anon_sym_RBRACE] = ACTIONS(4812),
    [anon_sym_LBRACK] = ACTIONS(4812),
    [anon_sym_RBRACK] = ACTIONS(4812),
    [anon_sym_EQ] = ACTIONS(4810),
    [anon_sym_const] = ACTIONS(4810),
    [anon_sym_constexpr] = ACTIONS(4810),
    [anon_sym_volatile] = ACTIONS(4810),
    [anon_sym_restrict] = ACTIONS(4810),
    [anon_sym___restrict__] = ACTIONS(4810),
    [anon_sym__Atomic] = ACTIONS(4810),
    [anon_sym__Noreturn] = ACTIONS(4810),
    [anon_sym_noreturn] = ACTIONS(4810),
    [anon_sym__Nonnull] = ACTIONS(4810),
    [anon_sym_mutable] = ACTIONS(4810),
    [anon_sym_constinit] = ACTIONS(4810),
    [anon_sym_consteval] = ACTIONS(4810),
    [anon_sym_alignas] = ACTIONS(4810),
    [anon_sym__Alignas] = ACTIONS(4810),
    [anon_sym_COLON] = ACTIONS(4810),
    [anon_sym_QMARK] = ACTIONS(4812),
    [anon_sym_STAR_EQ] = ACTIONS(4812),
    [anon_sym_SLASH_EQ] = ACTIONS(4812),
    [anon_sym_PERCENT_EQ] = ACTIONS(4812),
    [anon_sym_PLUS_EQ] = ACTIONS(4812),
    [anon_sym_DASH_EQ] = ACTIONS(4812),
    [anon_sym_LT_LT_EQ] = ACTIONS(4812),
    [anon_sym_GT_GT_EQ] = ACTIONS(4812),
    [anon_sym_AMP_EQ] = ACTIONS(4812),
    [anon_sym_CARET_EQ] = ACTIONS(4812),
    [anon_sym_PIPE_EQ] = ACTIONS(4812),
    [anon_sym_and_eq] = ACTIONS(4810),
    [anon_sym_or_eq] = ACTIONS(4810),
    [anon_sym_xor_eq] = ACTIONS(4810),
    [anon_sym_LT_EQ_GT] = ACTIONS(4812),
    [anon_sym_or] = ACTIONS(4810),
    [anon_sym_and] = ACTIONS(4810),
    [anon_sym_bitor] = ACTIONS(4810),
    [anon_sym_xor] = ACTIONS(4810),
    [anon_sym_bitand] = ACTIONS(4810),
    [anon_sym_not_eq] = ACTIONS(4810),
    [anon_sym_DASH_DASH] = ACTIONS(4812),
    [anon_sym_PLUS_PLUS] = ACTIONS(4812),
    [anon_sym_DOT] = ACTIONS(4810),
    [anon_sym_DOT_STAR] = ACTIONS(4812),
    [anon_sym_DASH_GT] = ACTIONS(4812),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4810),
    [anon_sym_decltype] = ACTIONS(4810),
    [anon_sym_final] = ACTIONS(4810),
    [anon_sym_override] = ACTIONS(4810),
  },
  [1560] = {
    [sym_identifier] = ACTIONS(4822),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4824),
    [anon_sym_COMMA] = ACTIONS(4824),
    [anon_sym_RPAREN] = ACTIONS(4824),
    [aux_sym_preproc_if_token2] = ACTIONS(4824),
    [aux_sym_preproc_else_token1] = ACTIONS(4824),
    [aux_sym_preproc_elif_token1] = ACTIONS(4822),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4824),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4824),
    [anon_sym_LPAREN2] = ACTIONS(4824),
    [anon_sym_DASH] = ACTIONS(4822),
    [anon_sym_PLUS] = ACTIONS(4822),
    [anon_sym_STAR] = ACTIONS(4822),
    [anon_sym_SLASH] = ACTIONS(4822),
    [anon_sym_PERCENT] = ACTIONS(4822),
    [anon_sym_PIPE_PIPE] = ACTIONS(4824),
    [anon_sym_AMP_AMP] = ACTIONS(4824),
    [anon_sym_PIPE] = ACTIONS(4822),
    [anon_sym_CARET] = ACTIONS(4822),
    [anon_sym_AMP] = ACTIONS(4822),
    [anon_sym_EQ_EQ] = ACTIONS(4824),
    [anon_sym_BANG_EQ] = ACTIONS(4824),
    [anon_sym_GT] = ACTIONS(4822),
    [anon_sym_GT_EQ] = ACTIONS(4824),
    [anon_sym_LT_EQ] = ACTIONS(4822),
    [anon_sym_LT] = ACTIONS(4822),
    [anon_sym_LT_LT] = ACTIONS(4822),
    [anon_sym_GT_GT] = ACTIONS(4822),
    [anon_sym_SEMI] = ACTIONS(4824),
    [anon_sym___extension__] = ACTIONS(4822),
    [anon_sym___attribute__] = ACTIONS(4822),
    [anon_sym___attribute] = ACTIONS(4822),
    [anon_sym_COLON_COLON] = ACTIONS(4824),
    [anon_sym_LBRACE] = ACTIONS(4824),
    [anon_sym_RBRACE] = ACTIONS(4824),
    [anon_sym_LBRACK] = ACTIONS(4824),
    [anon_sym_RBRACK] = ACTIONS(4824),
    [anon_sym_EQ] = ACTIONS(4822),
    [anon_sym_const] = ACTIONS(4822),
    [anon_sym_constexpr] = ACTIONS(4822),
    [anon_sym_volatile] = ACTIONS(4822),
    [anon_sym_restrict] = ACTIONS(4822),
    [anon_sym___restrict__] = ACTIONS(4822),
    [anon_sym__Atomic] = ACTIONS(4822),
    [anon_sym__Noreturn] = ACTIONS(4822),
    [anon_sym_noreturn] = ACTIONS(4822),
    [anon_sym__Nonnull] = ACTIONS(4822),
    [anon_sym_mutable] = ACTIONS(4822),
    [anon_sym_constinit] = ACTIONS(4822),
    [anon_sym_consteval] = ACTIONS(4822),
    [anon_sym_alignas] = ACTIONS(4822),
    [anon_sym__Alignas] = ACTIONS(4822),
    [anon_sym_COLON] = ACTIONS(4822),
    [anon_sym_QMARK] = ACTIONS(4824),
    [anon_sym_STAR_EQ] = ACTIONS(4824),
    [anon_sym_SLASH_EQ] = ACTIONS(4824),
    [anon_sym_PERCENT_EQ] = ACTIONS(4824),
    [anon_sym_PLUS_EQ] = ACTIONS(4824),
    [anon_sym_DASH_EQ] = ACTIONS(4824),
    [anon_sym_LT_LT_EQ] = ACTIONS(4824),
    [anon_sym_GT_GT_EQ] = ACTIONS(4824),
    [anon_sym_AMP_EQ] = ACTIONS(4824),
    [anon_sym_CARET_EQ] = ACTIONS(4824),
    [anon_sym_PIPE_EQ] = ACTIONS(4824),
    [anon_sym_and_eq] = ACTIONS(4822),
    [anon_sym_or_eq] = ACTIONS(4822),
    [anon_sym_xor_eq] = ACTIONS(4822),
    [anon_sym_LT_EQ_GT] = ACTIONS(4824),
    [anon_sym_or] = ACTIONS(4822),
    [anon_sym_and] = ACTIONS(4822),
    [anon_sym_bitor] = ACTIONS(4822),
    [anon_sym_xor] = ACTIONS(4822),
    [anon_sym_bitand] = ACTIONS(4822),
    [anon_sym_not_eq] = ACTIONS(4822),
    [anon_sym_DASH_DASH] = ACTIONS(4824),
    [anon_sym_PLUS_PLUS] = ACTIONS(4824),
    [anon_sym_DOT] = ACTIONS(4822),
    [anon_sym_DOT_STAR] = ACTIONS(4824),
    [anon_sym_DASH_GT] = ACTIONS(4824),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4822),
    [anon_sym_decltype] = ACTIONS(4822),
    [anon_sym_final] = ACTIONS(4822),
    [anon_sym_override] = ACTIONS(4822),
  },
  [1561] = {
    [sym_identifier] = ACTIONS(4818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4820),
    [anon_sym_COMMA] = ACTIONS(4820),
    [anon_sym_RPAREN] = ACTIONS(4820),
    [aux_sym_preproc_if_token2] = ACTIONS(4820),
    [aux_sym_preproc_else_token1] = ACTIONS(4820),
    [aux_sym_preproc_elif_token1] = ACTIONS(4818),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4820),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4820),
    [anon_sym_LPAREN2] = ACTIONS(4820),
    [anon_sym_DASH] = ACTIONS(4818),
    [anon_sym_PLUS] = ACTIONS(4818),
    [anon_sym_STAR] = ACTIONS(4818),
    [anon_sym_SLASH] = ACTIONS(4818),
    [anon_sym_PERCENT] = ACTIONS(4818),
    [anon_sym_PIPE_PIPE] = ACTIONS(4820),
    [anon_sym_AMP_AMP] = ACTIONS(4820),
    [anon_sym_PIPE] = ACTIONS(4818),
    [anon_sym_CARET] = ACTIONS(4818),
    [anon_sym_AMP] = ACTIONS(4818),
    [anon_sym_EQ_EQ] = ACTIONS(4820),
    [anon_sym_BANG_EQ] = ACTIONS(4820),
    [anon_sym_GT] = ACTIONS(4818),
    [anon_sym_GT_EQ] = ACTIONS(4820),
    [anon_sym_LT_EQ] = ACTIONS(4818),
    [anon_sym_LT] = ACTIONS(4818),
    [anon_sym_LT_LT] = ACTIONS(4818),
    [anon_sym_GT_GT] = ACTIONS(4818),
    [anon_sym_SEMI] = ACTIONS(4820),
    [anon_sym___extension__] = ACTIONS(4818),
    [anon_sym___attribute__] = ACTIONS(4818),
    [anon_sym___attribute] = ACTIONS(4818),
    [anon_sym_COLON_COLON] = ACTIONS(4820),
    [anon_sym_LBRACE] = ACTIONS(4820),
    [anon_sym_RBRACE] = ACTIONS(4820),
    [anon_sym_LBRACK] = ACTIONS(4820),
    [anon_sym_RBRACK] = ACTIONS(4820),
    [anon_sym_EQ] = ACTIONS(4818),
    [anon_sym_const] = ACTIONS(4818),
    [anon_sym_constexpr] = ACTIONS(4818),
    [anon_sym_volatile] = ACTIONS(4818),
    [anon_sym_restrict] = ACTIONS(4818),
    [anon_sym___restrict__] = ACTIONS(4818),
    [anon_sym__Atomic] = ACTIONS(4818),
    [anon_sym__Noreturn] = ACTIONS(4818),
    [anon_sym_noreturn] = ACTIONS(4818),
    [anon_sym__Nonnull] = ACTIONS(4818),
    [anon_sym_mutable] = ACTIONS(4818),
    [anon_sym_constinit] = ACTIONS(4818),
    [anon_sym_consteval] = ACTIONS(4818),
    [anon_sym_alignas] = ACTIONS(4818),
    [anon_sym__Alignas] = ACTIONS(4818),
    [anon_sym_COLON] = ACTIONS(4818),
    [anon_sym_QMARK] = ACTIONS(4820),
    [anon_sym_STAR_EQ] = ACTIONS(4820),
    [anon_sym_SLASH_EQ] = ACTIONS(4820),
    [anon_sym_PERCENT_EQ] = ACTIONS(4820),
    [anon_sym_PLUS_EQ] = ACTIONS(4820),
    [anon_sym_DASH_EQ] = ACTIONS(4820),
    [anon_sym_LT_LT_EQ] = ACTIONS(4820),
    [anon_sym_GT_GT_EQ] = ACTIONS(4820),
    [anon_sym_AMP_EQ] = ACTIONS(4820),
    [anon_sym_CARET_EQ] = ACTIONS(4820),
    [anon_sym_PIPE_EQ] = ACTIONS(4820),
    [anon_sym_and_eq] = ACTIONS(4818),
    [anon_sym_or_eq] = ACTIONS(4818),
    [anon_sym_xor_eq] = ACTIONS(4818),
    [anon_sym_LT_EQ_GT] = ACTIONS(4820),
    [anon_sym_or] = ACTIONS(4818),
    [anon_sym_and] = ACTIONS(4818),
    [anon_sym_bitor] = ACTIONS(4818),
    [anon_sym_xor] = ACTIONS(4818),
    [anon_sym_bitand] = ACTIONS(4818),
    [anon_sym_not_eq] = ACTIONS(4818),
    [anon_sym_DASH_DASH] = ACTIONS(4820),
    [anon_sym_PLUS_PLUS] = ACTIONS(4820),
    [anon_sym_DOT] = ACTIONS(4818),
    [anon_sym_DOT_STAR] = ACTIONS(4820),
    [anon_sym_DASH_GT] = ACTIONS(4820),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4818),
    [anon_sym_decltype] = ACTIONS(4818),
    [anon_sym_final] = ACTIONS(4818),
    [anon_sym_override] = ACTIONS(4818),
  },
  [1562] = {
    [sym_identifier] = ACTIONS(4814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4816),
    [anon_sym_COMMA] = ACTIONS(4816),
    [anon_sym_RPAREN] = ACTIONS(4816),
    [aux_sym_preproc_if_token2] = ACTIONS(4816),
    [aux_sym_preproc_else_token1] = ACTIONS(4816),
    [aux_sym_preproc_elif_token1] = ACTIONS(4814),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4816),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4816),
    [anon_sym_LPAREN2] = ACTIONS(4816),
    [anon_sym_DASH] = ACTIONS(4814),
    [anon_sym_PLUS] = ACTIONS(4814),
    [anon_sym_STAR] = ACTIONS(4814),
    [anon_sym_SLASH] = ACTIONS(4814),
    [anon_sym_PERCENT] = ACTIONS(4814),
    [anon_sym_PIPE_PIPE] = ACTIONS(4816),
    [anon_sym_AMP_AMP] = ACTIONS(4816),
    [anon_sym_PIPE] = ACTIONS(4814),
    [anon_sym_CARET] = ACTIONS(4814),
    [anon_sym_AMP] = ACTIONS(4814),
    [anon_sym_EQ_EQ] = ACTIONS(4816),
    [anon_sym_BANG_EQ] = ACTIONS(4816),
    [anon_sym_GT] = ACTIONS(4814),
    [anon_sym_GT_EQ] = ACTIONS(4816),
    [anon_sym_LT_EQ] = ACTIONS(4814),
    [anon_sym_LT] = ACTIONS(4814),
    [anon_sym_LT_LT] = ACTIONS(4814),
    [anon_sym_GT_GT] = ACTIONS(4814),
    [anon_sym_SEMI] = ACTIONS(4816),
    [anon_sym___extension__] = ACTIONS(4814),
    [anon_sym___attribute__] = ACTIONS(4814),
    [anon_sym___attribute] = ACTIONS(4814),
    [anon_sym_COLON_COLON] = ACTIONS(4816),
    [anon_sym_LBRACE] = ACTIONS(4816),
    [anon_sym_RBRACE] = ACTIONS(4816),
    [anon_sym_LBRACK] = ACTIONS(4816),
    [anon_sym_RBRACK] = ACTIONS(4816),
    [anon_sym_EQ] = ACTIONS(4814),
    [anon_sym_const] = ACTIONS(4814),
    [anon_sym_constexpr] = ACTIONS(4814),
    [anon_sym_volatile] = ACTIONS(4814),
    [anon_sym_restrict] = ACTIONS(4814),
    [anon_sym___restrict__] = ACTIONS(4814),
    [anon_sym__Atomic] = ACTIONS(4814),
    [anon_sym__Noreturn] = ACTIONS(4814),
    [anon_sym_noreturn] = ACTIONS(4814),
    [anon_sym__Nonnull] = ACTIONS(4814),
    [anon_sym_mutable] = ACTIONS(4814),
    [anon_sym_constinit] = ACTIONS(4814),
    [anon_sym_consteval] = ACTIONS(4814),
    [anon_sym_alignas] = ACTIONS(4814),
    [anon_sym__Alignas] = ACTIONS(4814),
    [anon_sym_COLON] = ACTIONS(4814),
    [anon_sym_QMARK] = ACTIONS(4816),
    [anon_sym_STAR_EQ] = ACTIONS(4816),
    [anon_sym_SLASH_EQ] = ACTIONS(4816),
    [anon_sym_PERCENT_EQ] = ACTIONS(4816),
    [anon_sym_PLUS_EQ] = ACTIONS(4816),
    [anon_sym_DASH_EQ] = ACTIONS(4816),
    [anon_sym_LT_LT_EQ] = ACTIONS(4816),
    [anon_sym_GT_GT_EQ] = ACTIONS(4816),
    [anon_sym_AMP_EQ] = ACTIONS(4816),
    [anon_sym_CARET_EQ] = ACTIONS(4816),
    [anon_sym_PIPE_EQ] = ACTIONS(4816),
    [anon_sym_and_eq] = ACTIONS(4814),
    [anon_sym_or_eq] = ACTIONS(4814),
    [anon_sym_xor_eq] = ACTIONS(4814),
    [anon_sym_LT_EQ_GT] = ACTIONS(4816),
    [anon_sym_or] = ACTIONS(4814),
    [anon_sym_and] = ACTIONS(4814),
    [anon_sym_bitor] = ACTIONS(4814),
    [anon_sym_xor] = ACTIONS(4814),
    [anon_sym_bitand] = ACTIONS(4814),
    [anon_sym_not_eq] = ACTIONS(4814),
    [anon_sym_DASH_DASH] = ACTIONS(4816),
    [anon_sym_PLUS_PLUS] = ACTIONS(4816),
    [anon_sym_DOT] = ACTIONS(4814),
    [anon_sym_DOT_STAR] = ACTIONS(4816),
    [anon_sym_DASH_GT] = ACTIONS(4816),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4814),
    [anon_sym_decltype] = ACTIONS(4814),
    [anon_sym_final] = ACTIONS(4814),
    [anon_sym_override] = ACTIONS(4814),
  },
  [1563] = {
    [sym_identifier] = ACTIONS(4834),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4836),
    [anon_sym_COMMA] = ACTIONS(4836),
    [anon_sym_RPAREN] = ACTIONS(4836),
    [aux_sym_preproc_if_token2] = ACTIONS(4836),
    [aux_sym_preproc_else_token1] = ACTIONS(4836),
    [aux_sym_preproc_elif_token1] = ACTIONS(4834),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4836),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4836),
    [anon_sym_LPAREN2] = ACTIONS(4836),
    [anon_sym_DASH] = ACTIONS(4834),
    [anon_sym_PLUS] = ACTIONS(4834),
    [anon_sym_STAR] = ACTIONS(4834),
    [anon_sym_SLASH] = ACTIONS(4834),
    [anon_sym_PERCENT] = ACTIONS(4834),
    [anon_sym_PIPE_PIPE] = ACTIONS(4836),
    [anon_sym_AMP_AMP] = ACTIONS(4836),
    [anon_sym_PIPE] = ACTIONS(4834),
    [anon_sym_CARET] = ACTIONS(4834),
    [anon_sym_AMP] = ACTIONS(4834),
    [anon_sym_EQ_EQ] = ACTIONS(4836),
    [anon_sym_BANG_EQ] = ACTIONS(4836),
    [anon_sym_GT] = ACTIONS(4834),
    [anon_sym_GT_EQ] = ACTIONS(4836),
    [anon_sym_LT_EQ] = ACTIONS(4834),
    [anon_sym_LT] = ACTIONS(4834),
    [anon_sym_LT_LT] = ACTIONS(4834),
    [anon_sym_GT_GT] = ACTIONS(4834),
    [anon_sym_SEMI] = ACTIONS(4836),
    [anon_sym___extension__] = ACTIONS(4834),
    [anon_sym___attribute__] = ACTIONS(4834),
    [anon_sym___attribute] = ACTIONS(4834),
    [anon_sym_COLON_COLON] = ACTIONS(4836),
    [anon_sym_LBRACE] = ACTIONS(4836),
    [anon_sym_RBRACE] = ACTIONS(4836),
    [anon_sym_LBRACK] = ACTIONS(4836),
    [anon_sym_RBRACK] = ACTIONS(4836),
    [anon_sym_EQ] = ACTIONS(4834),
    [anon_sym_const] = ACTIONS(4834),
    [anon_sym_constexpr] = ACTIONS(4834),
    [anon_sym_volatile] = ACTIONS(4834),
    [anon_sym_restrict] = ACTIONS(4834),
    [anon_sym___restrict__] = ACTIONS(4834),
    [anon_sym__Atomic] = ACTIONS(4834),
    [anon_sym__Noreturn] = ACTIONS(4834),
    [anon_sym_noreturn] = ACTIONS(4834),
    [anon_sym__Nonnull] = ACTIONS(4834),
    [anon_sym_mutable] = ACTIONS(4834),
    [anon_sym_constinit] = ACTIONS(4834),
    [anon_sym_consteval] = ACTIONS(4834),
    [anon_sym_alignas] = ACTIONS(4834),
    [anon_sym__Alignas] = ACTIONS(4834),
    [anon_sym_COLON] = ACTIONS(4834),
    [anon_sym_QMARK] = ACTIONS(4836),
    [anon_sym_STAR_EQ] = ACTIONS(4836),
    [anon_sym_SLASH_EQ] = ACTIONS(4836),
    [anon_sym_PERCENT_EQ] = ACTIONS(4836),
    [anon_sym_PLUS_EQ] = ACTIONS(4836),
    [anon_sym_DASH_EQ] = ACTIONS(4836),
    [anon_sym_LT_LT_EQ] = ACTIONS(4836),
    [anon_sym_GT_GT_EQ] = ACTIONS(4836),
    [anon_sym_AMP_EQ] = ACTIONS(4836),
    [anon_sym_CARET_EQ] = ACTIONS(4836),
    [anon_sym_PIPE_EQ] = ACTIONS(4836),
    [anon_sym_and_eq] = ACTIONS(4834),
    [anon_sym_or_eq] = ACTIONS(4834),
    [anon_sym_xor_eq] = ACTIONS(4834),
    [anon_sym_LT_EQ_GT] = ACTIONS(4836),
    [anon_sym_or] = ACTIONS(4834),
    [anon_sym_and] = ACTIONS(4834),
    [anon_sym_bitor] = ACTIONS(4834),
    [anon_sym_xor] = ACTIONS(4834),
    [anon_sym_bitand] = ACTIONS(4834),
    [anon_sym_not_eq] = ACTIONS(4834),
    [anon_sym_DASH_DASH] = ACTIONS(4836),
    [anon_sym_PLUS_PLUS] = ACTIONS(4836),
    [anon_sym_DOT] = ACTIONS(4834),
    [anon_sym_DOT_STAR] = ACTIONS(4836),
    [anon_sym_DASH_GT] = ACTIONS(4836),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4834),
    [anon_sym_decltype] = ACTIONS(4834),
    [anon_sym_final] = ACTIONS(4834),
    [anon_sym_override] = ACTIONS(4834),
  },
  [1564] = {
    [sym_identifier] = ACTIONS(4830),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4832),
    [anon_sym_COMMA] = ACTIONS(4832),
    [anon_sym_RPAREN] = ACTIONS(4832),
    [aux_sym_preproc_if_token2] = ACTIONS(4832),
    [aux_sym_preproc_else_token1] = ACTIONS(4832),
    [aux_sym_preproc_elif_token1] = ACTIONS(4830),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4832),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4832),
    [anon_sym_LPAREN2] = ACTIONS(4832),
    [anon_sym_DASH] = ACTIONS(4830),
    [anon_sym_PLUS] = ACTIONS(4830),
    [anon_sym_STAR] = ACTIONS(4830),
    [anon_sym_SLASH] = ACTIONS(4830),
    [anon_sym_PERCENT] = ACTIONS(4830),
    [anon_sym_PIPE_PIPE] = ACTIONS(4832),
    [anon_sym_AMP_AMP] = ACTIONS(4832),
    [anon_sym_PIPE] = ACTIONS(4830),
    [anon_sym_CARET] = ACTIONS(4830),
    [anon_sym_AMP] = ACTIONS(4830),
    [anon_sym_EQ_EQ] = ACTIONS(4832),
    [anon_sym_BANG_EQ] = ACTIONS(4832),
    [anon_sym_GT] = ACTIONS(4830),
    [anon_sym_GT_EQ] = ACTIONS(4832),
    [anon_sym_LT_EQ] = ACTIONS(4830),
    [anon_sym_LT] = ACTIONS(4830),
    [anon_sym_LT_LT] = ACTIONS(4830),
    [anon_sym_GT_GT] = ACTIONS(4830),
    [anon_sym_SEMI] = ACTIONS(4832),
    [anon_sym___extension__] = ACTIONS(4830),
    [anon_sym___attribute__] = ACTIONS(4830),
    [anon_sym___attribute] = ACTIONS(4830),
    [anon_sym_COLON_COLON] = ACTIONS(4832),
    [anon_sym_LBRACE] = ACTIONS(4832),
    [anon_sym_RBRACE] = ACTIONS(4832),
    [anon_sym_LBRACK] = ACTIONS(4832),
    [anon_sym_RBRACK] = ACTIONS(4832),
    [anon_sym_EQ] = ACTIONS(4830),
    [anon_sym_const] = ACTIONS(4830),
    [anon_sym_constexpr] = ACTIONS(4830),
    [anon_sym_volatile] = ACTIONS(4830),
    [anon_sym_restrict] = ACTIONS(4830),
    [anon_sym___restrict__] = ACTIONS(4830),
    [anon_sym__Atomic] = ACTIONS(4830),
    [anon_sym__Noreturn] = ACTIONS(4830),
    [anon_sym_noreturn] = ACTIONS(4830),
    [anon_sym__Nonnull] = ACTIONS(4830),
    [anon_sym_mutable] = ACTIONS(4830),
    [anon_sym_constinit] = ACTIONS(4830),
    [anon_sym_consteval] = ACTIONS(4830),
    [anon_sym_alignas] = ACTIONS(4830),
    [anon_sym__Alignas] = ACTIONS(4830),
    [anon_sym_COLON] = ACTIONS(4830),
    [anon_sym_QMARK] = ACTIONS(4832),
    [anon_sym_STAR_EQ] = ACTIONS(4832),
    [anon_sym_SLASH_EQ] = ACTIONS(4832),
    [anon_sym_PERCENT_EQ] = ACTIONS(4832),
    [anon_sym_PLUS_EQ] = ACTIONS(4832),
    [anon_sym_DASH_EQ] = ACTIONS(4832),
    [anon_sym_LT_LT_EQ] = ACTIONS(4832),
    [anon_sym_GT_GT_EQ] = ACTIONS(4832),
    [anon_sym_AMP_EQ] = ACTIONS(4832),
    [anon_sym_CARET_EQ] = ACTIONS(4832),
    [anon_sym_PIPE_EQ] = ACTIONS(4832),
    [anon_sym_and_eq] = ACTIONS(4830),
    [anon_sym_or_eq] = ACTIONS(4830),
    [anon_sym_xor_eq] = ACTIONS(4830),
    [anon_sym_LT_EQ_GT] = ACTIONS(4832),
    [anon_sym_or] = ACTIONS(4830),
    [anon_sym_and] = ACTIONS(4830),
    [anon_sym_bitor] = ACTIONS(4830),
    [anon_sym_xor] = ACTIONS(4830),
    [anon_sym_bitand] = ACTIONS(4830),
    [anon_sym_not_eq] = ACTIONS(4830),
    [anon_sym_DASH_DASH] = ACTIONS(4832),
    [anon_sym_PLUS_PLUS] = ACTIONS(4832),
    [anon_sym_DOT] = ACTIONS(4830),
    [anon_sym_DOT_STAR] = ACTIONS(4832),
    [anon_sym_DASH_GT] = ACTIONS(4832),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4830),
    [anon_sym_decltype] = ACTIONS(4830),
    [anon_sym_final] = ACTIONS(4830),
    [anon_sym_override] = ACTIONS(4830),
  },
  [1565] = {
    [sym_identifier] = ACTIONS(4855),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4857),
    [anon_sym_COMMA] = ACTIONS(4857),
    [anon_sym_LPAREN2] = ACTIONS(4859),
    [anon_sym_TILDE] = ACTIONS(4862),
    [anon_sym_DASH] = ACTIONS(4864),
    [anon_sym_PLUS] = ACTIONS(4864),
    [anon_sym_STAR] = ACTIONS(4859),
    [anon_sym_SLASH] = ACTIONS(4864),
    [anon_sym_PERCENT] = ACTIONS(4857),
    [anon_sym_PIPE_PIPE] = ACTIONS(4857),
    [anon_sym_AMP_AMP] = ACTIONS(4859),
    [anon_sym_PIPE] = ACTIONS(4864),
    [anon_sym_CARET] = ACTIONS(4857),
    [anon_sym_AMP] = ACTIONS(4866),
    [anon_sym_EQ_EQ] = ACTIONS(4857),
    [anon_sym_BANG_EQ] = ACTIONS(4857),
    [anon_sym_GT] = ACTIONS(4864),
    [anon_sym_GT_EQ] = ACTIONS(4857),
    [anon_sym_LT_EQ] = ACTIONS(4864),
    [anon_sym_LT] = ACTIONS(4864),
    [anon_sym_LT_LT] = ACTIONS(4857),
    [anon_sym_GT_GT] = ACTIONS(4857),
    [anon_sym_SEMI] = ACTIONS(4859),
    [anon_sym___extension__] = ACTIONS(4855),
    [anon_sym_virtual] = ACTIONS(4855),
    [anon_sym_extern] = ACTIONS(4855),
    [anon_sym___attribute__] = ACTIONS(4855),
    [anon_sym___attribute] = ACTIONS(4855),
    [anon_sym_COLON_COLON] = ACTIONS(4862),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4859),
    [anon_sym___declspec] = ACTIONS(4855),
    [anon_sym___based] = ACTIONS(4855),
    [anon_sym___cdecl] = ACTIONS(4855),
    [anon_sym___clrcall] = ACTIONS(4855),
    [anon_sym___stdcall] = ACTIONS(4855),
    [anon_sym___fastcall] = ACTIONS(4855),
    [anon_sym___thiscall] = ACTIONS(4855),
    [anon_sym___vectorcall] = ACTIONS(4855),
    [anon_sym_LBRACE] = ACTIONS(4862),
    [anon_sym_RBRACE] = ACTIONS(4857),
    [anon_sym_LBRACK] = ACTIONS(4866),
    [anon_sym_static] = ACTIONS(4855),
    [anon_sym_RBRACK] = ACTIONS(4857),
    [anon_sym_register] = ACTIONS(4855),
    [anon_sym_inline] = ACTIONS(4855),
    [anon_sym___inline] = ACTIONS(4855),
    [anon_sym___inline__] = ACTIONS(4855),
    [anon_sym___forceinline] = ACTIONS(4855),
    [anon_sym_thread_local] = ACTIONS(4855),
    [anon_sym___thread] = ACTIONS(4855),
    [anon_sym_const] = ACTIONS(4855),
    [anon_sym_constexpr] = ACTIONS(4855),
    [anon_sym_volatile] = ACTIONS(4855),
    [anon_sym_restrict] = ACTIONS(4855),
    [anon_sym___restrict__] = ACTIONS(4855),
    [anon_sym__Atomic] = ACTIONS(4855),
    [anon_sym__Noreturn] = ACTIONS(4855),
    [anon_sym_noreturn] = ACTIONS(4855),
    [anon_sym__Nonnull] = ACTIONS(4855),
    [anon_sym_mutable] = ACTIONS(4855),
    [anon_sym_constinit] = ACTIONS(4855),
    [anon_sym_consteval] = ACTIONS(4855),
    [anon_sym_alignas] = ACTIONS(4855),
    [anon_sym__Alignas] = ACTIONS(4855),
    [anon_sym_QMARK] = ACTIONS(4857),
    [anon_sym_LT_EQ_GT] = ACTIONS(4857),
    [anon_sym_or] = ACTIONS(4864),
    [anon_sym_and] = ACTIONS(4864),
    [anon_sym_bitor] = ACTIONS(4864),
    [anon_sym_xor] = ACTIONS(4864),
    [anon_sym_bitand] = ACTIONS(4864),
    [anon_sym_not_eq] = ACTIONS(4864),
    [anon_sym_DASH_DASH] = ACTIONS(4857),
    [anon_sym_PLUS_PLUS] = ACTIONS(4857),
    [anon_sym_DOT] = ACTIONS(4864),
    [anon_sym_DOT_STAR] = ACTIONS(4857),
    [anon_sym_DASH_GT] = ACTIONS(4857),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4855),
    [anon_sym_decltype] = ACTIONS(4855),
    [anon_sym_template] = ACTIONS(4855),
    [anon_sym_operator] = ACTIONS(4855),
  },
  [1566] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1544),
    [sym_identifier] = ACTIONS(4932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4981),
    [anon_sym_COMMA] = ACTIONS(4981),
    [anon_sym_RPAREN] = ACTIONS(4981),
    [anon_sym_LPAREN2] = ACTIONS(4981),
    [anon_sym_DASH] = ACTIONS(4984),
    [anon_sym_PLUS] = ACTIONS(4984),
    [anon_sym_STAR] = ACTIONS(4984),
    [anon_sym_SLASH] = ACTIONS(4984),
    [anon_sym_PERCENT] = ACTIONS(4984),
    [anon_sym_PIPE_PIPE] = ACTIONS(4981),
    [anon_sym_AMP_AMP] = ACTIONS(4981),
    [anon_sym_PIPE] = ACTIONS(4984),
    [anon_sym_CARET] = ACTIONS(4984),
    [anon_sym_AMP] = ACTIONS(4984),
    [anon_sym_EQ_EQ] = ACTIONS(4981),
    [anon_sym_BANG_EQ] = ACTIONS(4981),
    [anon_sym_GT] = ACTIONS(4984),
    [anon_sym_GT_EQ] = ACTIONS(4981),
    [anon_sym_LT_EQ] = ACTIONS(4984),
    [anon_sym_LT] = ACTIONS(4984),
    [anon_sym_LT_LT] = ACTIONS(4984),
    [anon_sym_GT_GT] = ACTIONS(4984),
    [anon_sym_SEMI] = ACTIONS(4981),
    [anon_sym___extension__] = ACTIONS(4932),
    [anon_sym___attribute__] = ACTIONS(4984),
    [anon_sym___attribute] = ACTIONS(4984),
    [anon_sym_LBRACE] = ACTIONS(4981),
    [anon_sym_RBRACE] = ACTIONS(4981),
    [anon_sym_signed] = ACTIONS(4936),
    [anon_sym_unsigned] = ACTIONS(4936),
    [anon_sym_long] = ACTIONS(4936),
    [anon_sym_short] = ACTIONS(4936),
    [anon_sym_LBRACK] = ACTIONS(4981),
    [anon_sym_RBRACK] = ACTIONS(4981),
    [anon_sym_EQ] = ACTIONS(4984),
    [anon_sym_const] = ACTIONS(4932),
    [anon_sym_constexpr] = ACTIONS(4932),
    [anon_sym_volatile] = ACTIONS(4932),
    [anon_sym_restrict] = ACTIONS(4932),
    [anon_sym___restrict__] = ACTIONS(4932),
    [anon_sym__Atomic] = ACTIONS(4932),
    [anon_sym__Noreturn] = ACTIONS(4932),
    [anon_sym_noreturn] = ACTIONS(4932),
    [anon_sym__Nonnull] = ACTIONS(4932),
    [anon_sym_mutable] = ACTIONS(4932),
    [anon_sym_constinit] = ACTIONS(4932),
    [anon_sym_consteval] = ACTIONS(4932),
    [anon_sym_alignas] = ACTIONS(4932),
    [anon_sym__Alignas] = ACTIONS(4932),
    [sym_primitive_type] = ACTIONS(4932),
    [anon_sym_COLON] = ACTIONS(4981),
    [anon_sym_QMARK] = ACTIONS(4981),
    [anon_sym_STAR_EQ] = ACTIONS(4981),
    [anon_sym_SLASH_EQ] = ACTIONS(4981),
    [anon_sym_PERCENT_EQ] = ACTIONS(4981),
    [anon_sym_PLUS_EQ] = ACTIONS(4981),
    [anon_sym_DASH_EQ] = ACTIONS(4981),
    [anon_sym_LT_LT_EQ] = ACTIONS(4981),
    [anon_sym_GT_GT_EQ] = ACTIONS(4981),
    [anon_sym_AMP_EQ] = ACTIONS(4981),
    [anon_sym_CARET_EQ] = ACTIONS(4981),
    [anon_sym_PIPE_EQ] = ACTIONS(4981),
    [anon_sym_and_eq] = ACTIONS(4984),
    [anon_sym_or_eq] = ACTIONS(4984),
    [anon_sym_xor_eq] = ACTIONS(4984),
    [anon_sym_LT_EQ_GT] = ACTIONS(4981),
    [anon_sym_or] = ACTIONS(4984),
    [anon_sym_and] = ACTIONS(4984),
    [anon_sym_bitor] = ACTIONS(4984),
    [anon_sym_xor] = ACTIONS(4984),
    [anon_sym_bitand] = ACTIONS(4984),
    [anon_sym_not_eq] = ACTIONS(4984),
    [anon_sym_DASH_DASH] = ACTIONS(4981),
    [anon_sym_PLUS_PLUS] = ACTIONS(4981),
    [anon_sym_DOT] = ACTIONS(4984),
    [anon_sym_DOT_STAR] = ACTIONS(4981),
    [anon_sym_DASH_GT] = ACTIONS(4981),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4984),
    [anon_sym_decltype] = ACTIONS(4984),
  },
  [1567] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1544),
    [sym_identifier] = ACTIONS(4984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4981),
    [anon_sym_COMMA] = ACTIONS(4981),
    [aux_sym_preproc_if_token2] = ACTIONS(4981),
    [aux_sym_preproc_else_token1] = ACTIONS(4981),
    [aux_sym_preproc_elif_token1] = ACTIONS(4984),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4981),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4981),
    [anon_sym_LPAREN2] = ACTIONS(4981),
    [anon_sym_DASH] = ACTIONS(4984),
    [anon_sym_PLUS] = ACTIONS(4984),
    [anon_sym_STAR] = ACTIONS(4984),
    [anon_sym_SLASH] = ACTIONS(4984),
    [anon_sym_PERCENT] = ACTIONS(4984),
    [anon_sym_PIPE_PIPE] = ACTIONS(4981),
    [anon_sym_AMP_AMP] = ACTIONS(4981),
    [anon_sym_PIPE] = ACTIONS(4984),
    [anon_sym_CARET] = ACTIONS(4984),
    [anon_sym_AMP] = ACTIONS(4984),
    [anon_sym_EQ_EQ] = ACTIONS(4981),
    [anon_sym_BANG_EQ] = ACTIONS(4981),
    [anon_sym_GT] = ACTIONS(4984),
    [anon_sym_GT_EQ] = ACTIONS(4981),
    [anon_sym_LT_EQ] = ACTIONS(4984),
    [anon_sym_LT] = ACTIONS(4984),
    [anon_sym_LT_LT] = ACTIONS(4984),
    [anon_sym_GT_GT] = ACTIONS(4984),
    [anon_sym___extension__] = ACTIONS(4932),
    [anon_sym___attribute__] = ACTIONS(4984),
    [anon_sym___attribute] = ACTIONS(4984),
    [anon_sym_LBRACE] = ACTIONS(4981),
    [anon_sym_signed] = ACTIONS(4936),
    [anon_sym_unsigned] = ACTIONS(4936),
    [anon_sym_long] = ACTIONS(4936),
    [anon_sym_short] = ACTIONS(4936),
    [anon_sym_LBRACK] = ACTIONS(4981),
    [anon_sym_EQ] = ACTIONS(4984),
    [anon_sym_const] = ACTIONS(4932),
    [anon_sym_constexpr] = ACTIONS(4932),
    [anon_sym_volatile] = ACTIONS(4932),
    [anon_sym_restrict] = ACTIONS(4932),
    [anon_sym___restrict__] = ACTIONS(4932),
    [anon_sym__Atomic] = ACTIONS(4932),
    [anon_sym__Noreturn] = ACTIONS(4932),
    [anon_sym_noreturn] = ACTIONS(4932),
    [anon_sym__Nonnull] = ACTIONS(4932),
    [anon_sym_mutable] = ACTIONS(4932),
    [anon_sym_constinit] = ACTIONS(4932),
    [anon_sym_consteval] = ACTIONS(4932),
    [anon_sym_alignas] = ACTIONS(4932),
    [anon_sym__Alignas] = ACTIONS(4932),
    [sym_primitive_type] = ACTIONS(4932),
    [anon_sym_QMARK] = ACTIONS(4981),
    [anon_sym_STAR_EQ] = ACTIONS(4981),
    [anon_sym_SLASH_EQ] = ACTIONS(4981),
    [anon_sym_PERCENT_EQ] = ACTIONS(4981),
    [anon_sym_PLUS_EQ] = ACTIONS(4981),
    [anon_sym_DASH_EQ] = ACTIONS(4981),
    [anon_sym_LT_LT_EQ] = ACTIONS(4981),
    [anon_sym_GT_GT_EQ] = ACTIONS(4981),
    [anon_sym_AMP_EQ] = ACTIONS(4981),
    [anon_sym_CARET_EQ] = ACTIONS(4981),
    [anon_sym_PIPE_EQ] = ACTIONS(4981),
    [anon_sym_and_eq] = ACTIONS(4984),
    [anon_sym_or_eq] = ACTIONS(4984),
    [anon_sym_xor_eq] = ACTIONS(4984),
    [anon_sym_LT_EQ_GT] = ACTIONS(4981),
    [anon_sym_or] = ACTIONS(4984),
    [anon_sym_and] = ACTIONS(4984),
    [anon_sym_bitor] = ACTIONS(4984),
    [anon_sym_xor] = ACTIONS(4984),
    [anon_sym_bitand] = ACTIONS(4984),
    [anon_sym_not_eq] = ACTIONS(4984),
    [anon_sym_DASH_DASH] = ACTIONS(4981),
    [anon_sym_PLUS_PLUS] = ACTIONS(4981),
    [anon_sym_DOT] = ACTIONS(4984),
    [anon_sym_DOT_STAR] = ACTIONS(4981),
    [anon_sym_DASH_GT] = ACTIONS(4981),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4984),
    [anon_sym_decltype] = ACTIONS(4984),
  },
  [1568] = {
    [sym_type_qualifier] = STATE(1571),
    [sym_alignas_qualifier] = STATE(1614),
    [aux_sym__type_definition_type_repeat1] = STATE(1571),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2510),
    [sym_identifier] = ACTIONS(4987),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4961),
    [anon_sym_COMMA] = ACTIONS(4961),
    [anon_sym_RPAREN] = ACTIONS(4961),
    [anon_sym_LPAREN2] = ACTIONS(4961),
    [anon_sym_DASH] = ACTIONS(4963),
    [anon_sym_PLUS] = ACTIONS(4963),
    [anon_sym_STAR] = ACTIONS(4963),
    [anon_sym_SLASH] = ACTIONS(4963),
    [anon_sym_PERCENT] = ACTIONS(4963),
    [anon_sym_PIPE_PIPE] = ACTIONS(4961),
    [anon_sym_AMP_AMP] = ACTIONS(4961),
    [anon_sym_PIPE] = ACTIONS(4963),
    [anon_sym_CARET] = ACTIONS(4963),
    [anon_sym_AMP] = ACTIONS(4963),
    [anon_sym_EQ_EQ] = ACTIONS(4961),
    [anon_sym_BANG_EQ] = ACTIONS(4961),
    [anon_sym_GT] = ACTIONS(4963),
    [anon_sym_GT_EQ] = ACTIONS(4961),
    [anon_sym_LT_EQ] = ACTIONS(4963),
    [anon_sym_LT] = ACTIONS(4963),
    [anon_sym_LT_LT] = ACTIONS(4963),
    [anon_sym_GT_GT] = ACTIONS(4963),
    [anon_sym___extension__] = ACTIONS(4989),
    [anon_sym___attribute__] = ACTIONS(4963),
    [anon_sym___attribute] = ACTIONS(4963),
    [anon_sym_LBRACE] = ACTIONS(4961),
    [anon_sym_signed] = ACTIONS(4991),
    [anon_sym_unsigned] = ACTIONS(4991),
    [anon_sym_long] = ACTIONS(4991),
    [anon_sym_short] = ACTIONS(4991),
    [anon_sym_LBRACK] = ACTIONS(4961),
    [anon_sym_EQ] = ACTIONS(4963),
    [anon_sym_const] = ACTIONS(4989),
    [anon_sym_constexpr] = ACTIONS(4989),
    [anon_sym_volatile] = ACTIONS(4989),
    [anon_sym_restrict] = ACTIONS(4989),
    [anon_sym___restrict__] = ACTIONS(4989),
    [anon_sym__Atomic] = ACTIONS(4989),
    [anon_sym__Noreturn] = ACTIONS(4989),
    [anon_sym_noreturn] = ACTIONS(4989),
    [anon_sym__Nonnull] = ACTIONS(4989),
    [anon_sym_mutable] = ACTIONS(4989),
    [anon_sym_constinit] = ACTIONS(4989),
    [anon_sym_consteval] = ACTIONS(4989),
    [anon_sym_alignas] = ACTIONS(4993),
    [anon_sym__Alignas] = ACTIONS(4993),
    [sym_primitive_type] = ACTIONS(4995),
    [anon_sym_QMARK] = ACTIONS(4961),
    [anon_sym_STAR_EQ] = ACTIONS(4961),
    [anon_sym_SLASH_EQ] = ACTIONS(4961),
    [anon_sym_PERCENT_EQ] = ACTIONS(4961),
    [anon_sym_PLUS_EQ] = ACTIONS(4961),
    [anon_sym_DASH_EQ] = ACTIONS(4961),
    [anon_sym_LT_LT_EQ] = ACTIONS(4961),
    [anon_sym_GT_GT_EQ] = ACTIONS(4961),
    [anon_sym_AMP_EQ] = ACTIONS(4961),
    [anon_sym_CARET_EQ] = ACTIONS(4961),
    [anon_sym_PIPE_EQ] = ACTIONS(4961),
    [anon_sym_and_eq] = ACTIONS(4963),
    [anon_sym_or_eq] = ACTIONS(4963),
    [anon_sym_xor_eq] = ACTIONS(4963),
    [anon_sym_LT_EQ_GT] = ACTIONS(4961),
    [anon_sym_or] = ACTIONS(4963),
    [anon_sym_and] = ACTIONS(4963),
    [anon_sym_bitor] = ACTIONS(4963),
    [anon_sym_xor] = ACTIONS(4963),
    [anon_sym_bitand] = ACTIONS(4963),
    [anon_sym_not_eq] = ACTIONS(4963),
    [anon_sym_DASH_DASH] = ACTIONS(4961),
    [anon_sym_PLUS_PLUS] = ACTIONS(4961),
    [anon_sym_DOT] = ACTIONS(4963),
    [anon_sym_DOT_STAR] = ACTIONS(4961),
    [anon_sym_DASH_GT] = ACTIONS(4963),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4963),
    [anon_sym_decltype] = ACTIONS(4963),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4961),
  },
  [1569] = {
    [sym_type_qualifier] = STATE(1568),
    [sym_alignas_qualifier] = STATE(1614),
    [aux_sym__type_definition_type_repeat1] = STATE(1568),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1579),
    [sym_identifier] = ACTIONS(4997),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4946),
    [anon_sym_COMMA] = ACTIONS(4946),
    [anon_sym_RPAREN] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(4946),
    [anon_sym_DASH] = ACTIONS(4948),
    [anon_sym_PLUS] = ACTIONS(4948),
    [anon_sym_STAR] = ACTIONS(4948),
    [anon_sym_SLASH] = ACTIONS(4948),
    [anon_sym_PERCENT] = ACTIONS(4948),
    [anon_sym_PIPE_PIPE] = ACTIONS(4946),
    [anon_sym_AMP_AMP] = ACTIONS(4946),
    [anon_sym_PIPE] = ACTIONS(4948),
    [anon_sym_CARET] = ACTIONS(4948),
    [anon_sym_AMP] = ACTIONS(4948),
    [anon_sym_EQ_EQ] = ACTIONS(4946),
    [anon_sym_BANG_EQ] = ACTIONS(4946),
    [anon_sym_GT] = ACTIONS(4948),
    [anon_sym_GT_EQ] = ACTIONS(4946),
    [anon_sym_LT_EQ] = ACTIONS(4948),
    [anon_sym_LT] = ACTIONS(4948),
    [anon_sym_LT_LT] = ACTIONS(4948),
    [anon_sym_GT_GT] = ACTIONS(4948),
    [anon_sym___extension__] = ACTIONS(4989),
    [anon_sym___attribute__] = ACTIONS(4948),
    [anon_sym___attribute] = ACTIONS(4948),
    [anon_sym_LBRACE] = ACTIONS(4946),
    [anon_sym_signed] = ACTIONS(4999),
    [anon_sym_unsigned] = ACTIONS(4999),
    [anon_sym_long] = ACTIONS(4999),
    [anon_sym_short] = ACTIONS(4999),
    [anon_sym_LBRACK] = ACTIONS(4946),
    [anon_sym_EQ] = ACTIONS(4948),
    [anon_sym_const] = ACTIONS(4989),
    [anon_sym_constexpr] = ACTIONS(4989),
    [anon_sym_volatile] = ACTIONS(4989),
    [anon_sym_restrict] = ACTIONS(4989),
    [anon_sym___restrict__] = ACTIONS(4989),
    [anon_sym__Atomic] = ACTIONS(4989),
    [anon_sym__Noreturn] = ACTIONS(4989),
    [anon_sym_noreturn] = ACTIONS(4989),
    [anon_sym__Nonnull] = ACTIONS(4989),
    [anon_sym_mutable] = ACTIONS(4989),
    [anon_sym_constinit] = ACTIONS(4989),
    [anon_sym_consteval] = ACTIONS(4989),
    [anon_sym_alignas] = ACTIONS(4993),
    [anon_sym__Alignas] = ACTIONS(4993),
    [sym_primitive_type] = ACTIONS(5001),
    [anon_sym_QMARK] = ACTIONS(4946),
    [anon_sym_STAR_EQ] = ACTIONS(4946),
    [anon_sym_SLASH_EQ] = ACTIONS(4946),
    [anon_sym_PERCENT_EQ] = ACTIONS(4946),
    [anon_sym_PLUS_EQ] = ACTIONS(4946),
    [anon_sym_DASH_EQ] = ACTIONS(4946),
    [anon_sym_LT_LT_EQ] = ACTIONS(4946),
    [anon_sym_GT_GT_EQ] = ACTIONS(4946),
    [anon_sym_AMP_EQ] = ACTIONS(4946),
    [anon_sym_CARET_EQ] = ACTIONS(4946),
    [anon_sym_PIPE_EQ] = ACTIONS(4946),
    [anon_sym_and_eq] = ACTIONS(4948),
    [anon_sym_or_eq] = ACTIONS(4948),
    [anon_sym_xor_eq] = ACTIONS(4948),
    [anon_sym_LT_EQ_GT] = ACTIONS(4946),
    [anon_sym_or] = ACTIONS(4948),
    [anon_sym_and] = ACTIONS(4948),
    [anon_sym_bitor] = ACTIONS(4948),
    [anon_sym_xor] = ACTIONS(4948),
    [anon_sym_bitand] = ACTIONS(4948),
    [anon_sym_not_eq] = ACTIONS(4948),
    [anon_sym_DASH_DASH] = ACTIONS(4946),
    [anon_sym_PLUS_PLUS] = ACTIONS(4946),
    [anon_sym_DOT] = ACTIONS(4948),
    [anon_sym_DOT_STAR] = ACTIONS(4946),
    [anon_sym_DASH_GT] = ACTIONS(4948),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4948),
    [anon_sym_decltype] = ACTIONS(4948),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4946),
  },
  [1570] = {
    [sym_identifier] = ACTIONS(4855),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4862),
    [anon_sym_COMMA] = ACTIONS(4862),
    [anon_sym_RPAREN] = ACTIONS(4862),
    [anon_sym_LPAREN2] = ACTIONS(4862),
    [anon_sym_TILDE] = ACTIONS(4862),
    [anon_sym_STAR] = ACTIONS(4862),
    [anon_sym_PIPE_PIPE] = ACTIONS(4862),
    [anon_sym_AMP_AMP] = ACTIONS(4862),
    [anon_sym_AMP] = ACTIONS(4855),
    [anon_sym_SEMI] = ACTIONS(4862),
    [anon_sym___extension__] = ACTIONS(4855),
    [anon_sym_virtual] = ACTIONS(4855),
    [anon_sym_extern] = ACTIONS(4855),
    [anon_sym___attribute__] = ACTIONS(4855),
    [anon_sym___attribute] = ACTIONS(4855),
    [anon_sym_COLON_COLON] = ACTIONS(4862),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4862),
    [anon_sym___declspec] = ACTIONS(4855),
    [anon_sym___based] = ACTIONS(4855),
    [anon_sym___cdecl] = ACTIONS(4855),
    [anon_sym___clrcall] = ACTIONS(4855),
    [anon_sym___stdcall] = ACTIONS(4855),
    [anon_sym___fastcall] = ACTIONS(4855),
    [anon_sym___thiscall] = ACTIONS(4855),
    [anon_sym___vectorcall] = ACTIONS(4855),
    [anon_sym_LBRACE] = ACTIONS(4862),
    [anon_sym_signed] = ACTIONS(4855),
    [anon_sym_unsigned] = ACTIONS(4855),
    [anon_sym_long] = ACTIONS(4855),
    [anon_sym_short] = ACTIONS(4855),
    [anon_sym_LBRACK] = ACTIONS(4855),
    [anon_sym_static] = ACTIONS(4855),
    [anon_sym_EQ] = ACTIONS(4862),
    [anon_sym_register] = ACTIONS(4855),
    [anon_sym_inline] = ACTIONS(4855),
    [anon_sym___inline] = ACTIONS(4855),
    [anon_sym___inline__] = ACTIONS(4855),
    [anon_sym___forceinline] = ACTIONS(4855),
    [anon_sym_thread_local] = ACTIONS(4855),
    [anon_sym___thread] = ACTIONS(4855),
    [anon_sym_const] = ACTIONS(4855),
    [anon_sym_constexpr] = ACTIONS(4855),
    [anon_sym_volatile] = ACTIONS(4855),
    [anon_sym_restrict] = ACTIONS(4855),
    [anon_sym___restrict__] = ACTIONS(4855),
    [anon_sym__Atomic] = ACTIONS(4855),
    [anon_sym__Noreturn] = ACTIONS(4855),
    [anon_sym_noreturn] = ACTIONS(4855),
    [anon_sym__Nonnull] = ACTIONS(4855),
    [anon_sym_mutable] = ACTIONS(4855),
    [anon_sym_constinit] = ACTIONS(4855),
    [anon_sym_consteval] = ACTIONS(4855),
    [anon_sym_alignas] = ACTIONS(4855),
    [anon_sym__Alignas] = ACTIONS(4855),
    [sym_primitive_type] = ACTIONS(4855),
    [anon_sym_enum] = ACTIONS(4855),
    [anon_sym_class] = ACTIONS(4855),
    [anon_sym_struct] = ACTIONS(4855),
    [anon_sym_union] = ACTIONS(4855),
    [anon_sym_COLON] = ACTIONS(4855),
    [anon_sym_or] = ACTIONS(4855),
    [anon_sym_and] = ACTIONS(4855),
    [anon_sym_asm] = ACTIONS(4855),
    [anon_sym___asm__] = ACTIONS(4855),
    [anon_sym___asm] = ACTIONS(4855),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4855),
    [anon_sym_decltype] = ACTIONS(4855),
    [anon_sym_final] = ACTIONS(4855),
    [anon_sym_override] = ACTIONS(4855),
    [anon_sym_explicit] = ACTIONS(4855),
    [anon_sym_typename] = ACTIONS(4855),
    [anon_sym_template] = ACTIONS(4855),
    [anon_sym_GT2] = ACTIONS(4862),
    [anon_sym_operator] = ACTIONS(4855),
    [anon_sym_try] = ACTIONS(4855),
    [anon_sym_friend] = ACTIONS(4855),
    [anon_sym_using] = ACTIONS(4855),
    [anon_sym_concept] = ACTIONS(4855),
    [anon_sym_requires] = ACTIONS(4855),
  },
  [1571] = {
    [sym_type_qualifier] = STATE(1571),
    [sym_alignas_qualifier] = STATE(1614),
    [aux_sym__type_definition_type_repeat1] = STATE(1571),
    [sym_identifier] = ACTIONS(4906),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4908),
    [anon_sym_COMMA] = ACTIONS(4908),
    [anon_sym_RPAREN] = ACTIONS(4908),
    [anon_sym_LPAREN2] = ACTIONS(4908),
    [anon_sym_DASH] = ACTIONS(4906),
    [anon_sym_PLUS] = ACTIONS(4906),
    [anon_sym_STAR] = ACTIONS(4906),
    [anon_sym_SLASH] = ACTIONS(4906),
    [anon_sym_PERCENT] = ACTIONS(4906),
    [anon_sym_PIPE_PIPE] = ACTIONS(4908),
    [anon_sym_AMP_AMP] = ACTIONS(4908),
    [anon_sym_PIPE] = ACTIONS(4906),
    [anon_sym_CARET] = ACTIONS(4906),
    [anon_sym_AMP] = ACTIONS(4906),
    [anon_sym_EQ_EQ] = ACTIONS(4908),
    [anon_sym_BANG_EQ] = ACTIONS(4908),
    [anon_sym_GT] = ACTIONS(4906),
    [anon_sym_GT_EQ] = ACTIONS(4908),
    [anon_sym_LT_EQ] = ACTIONS(4906),
    [anon_sym_LT] = ACTIONS(4906),
    [anon_sym_LT_LT] = ACTIONS(4906),
    [anon_sym_GT_GT] = ACTIONS(4906),
    [anon_sym___extension__] = ACTIONS(5003),
    [anon_sym___attribute__] = ACTIONS(4906),
    [anon_sym___attribute] = ACTIONS(4906),
    [anon_sym_LBRACE] = ACTIONS(4908),
    [anon_sym_signed] = ACTIONS(4906),
    [anon_sym_unsigned] = ACTIONS(4906),
    [anon_sym_long] = ACTIONS(4906),
    [anon_sym_short] = ACTIONS(4906),
    [anon_sym_LBRACK] = ACTIONS(4908),
    [anon_sym_EQ] = ACTIONS(4906),
    [anon_sym_const] = ACTIONS(5003),
    [anon_sym_constexpr] = ACTIONS(5003),
    [anon_sym_volatile] = ACTIONS(5003),
    [anon_sym_restrict] = ACTIONS(5003),
    [anon_sym___restrict__] = ACTIONS(5003),
    [anon_sym__Atomic] = ACTIONS(5003),
    [anon_sym__Noreturn] = ACTIONS(5003),
    [anon_sym_noreturn] = ACTIONS(5003),
    [anon_sym__Nonnull] = ACTIONS(5003),
    [anon_sym_mutable] = ACTIONS(5003),
    [anon_sym_constinit] = ACTIONS(5003),
    [anon_sym_consteval] = ACTIONS(5003),
    [anon_sym_alignas] = ACTIONS(5006),
    [anon_sym__Alignas] = ACTIONS(5006),
    [sym_primitive_type] = ACTIONS(4906),
    [anon_sym_QMARK] = ACTIONS(4908),
    [anon_sym_STAR_EQ] = ACTIONS(4908),
    [anon_sym_SLASH_EQ] = ACTIONS(4908),
    [anon_sym_PERCENT_EQ] = ACTIONS(4908),
    [anon_sym_PLUS_EQ] = ACTIONS(4908),
    [anon_sym_DASH_EQ] = ACTIONS(4908),
    [anon_sym_LT_LT_EQ] = ACTIONS(4908),
    [anon_sym_GT_GT_EQ] = ACTIONS(4908),
    [anon_sym_AMP_EQ] = ACTIONS(4908),
    [anon_sym_CARET_EQ] = ACTIONS(4908),
    [anon_sym_PIPE_EQ] = ACTIONS(4908),
    [anon_sym_and_eq] = ACTIONS(4906),
    [anon_sym_or_eq] = ACTIONS(4906),
    [anon_sym_xor_eq] = ACTIONS(4906),
    [anon_sym_LT_EQ_GT] = ACTIONS(4908),
    [anon_sym_or] = ACTIONS(4906),
    [anon_sym_and] = ACTIONS(4906),
    [anon_sym_bitor] = ACTIONS(4906),
    [anon_sym_xor] = ACTIONS(4906),
    [anon_sym_bitand] = ACTIONS(4906),
    [anon_sym_not_eq] = ACTIONS(4906),
    [anon_sym_DASH_DASH] = ACTIONS(4908),
    [anon_sym_PLUS_PLUS] = ACTIONS(4908),
    [anon_sym_DOT] = ACTIONS(4906),
    [anon_sym_DOT_STAR] = ACTIONS(4908),
    [anon_sym_DASH_GT] = ACTIONS(4906),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4906),
    [anon_sym_decltype] = ACTIONS(4906),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4908),
  },
  [1572] = {
    [sym_type_qualifier] = STATE(1575),
    [sym_alignas_qualifier] = STATE(1624),
    [aux_sym__type_definition_type_repeat1] = STATE(1575),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2585),
    [sym_identifier] = ACTIONS(5009),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4961),
    [anon_sym_COMMA] = ACTIONS(4961),
    [anon_sym_LPAREN2] = ACTIONS(4961),
    [anon_sym_DASH] = ACTIONS(4963),
    [anon_sym_PLUS] = ACTIONS(4963),
    [anon_sym_STAR] = ACTIONS(4963),
    [anon_sym_SLASH] = ACTIONS(4963),
    [anon_sym_PERCENT] = ACTIONS(4963),
    [anon_sym_PIPE_PIPE] = ACTIONS(4961),
    [anon_sym_AMP_AMP] = ACTIONS(4961),
    [anon_sym_PIPE] = ACTIONS(4963),
    [anon_sym_CARET] = ACTIONS(4963),
    [anon_sym_AMP] = ACTIONS(4963),
    [anon_sym_EQ_EQ] = ACTIONS(4961),
    [anon_sym_BANG_EQ] = ACTIONS(4961),
    [anon_sym_GT] = ACTIONS(4963),
    [anon_sym_GT_EQ] = ACTIONS(4963),
    [anon_sym_LT_EQ] = ACTIONS(4963),
    [anon_sym_LT] = ACTIONS(4963),
    [anon_sym_LT_LT] = ACTIONS(4963),
    [anon_sym_GT_GT] = ACTIONS(4963),
    [anon_sym___extension__] = ACTIONS(5011),
    [anon_sym___attribute__] = ACTIONS(4963),
    [anon_sym___attribute] = ACTIONS(4963),
    [anon_sym_LBRACE] = ACTIONS(4961),
    [anon_sym_signed] = ACTIONS(5013),
    [anon_sym_unsigned] = ACTIONS(5013),
    [anon_sym_long] = ACTIONS(5013),
    [anon_sym_short] = ACTIONS(5013),
    [anon_sym_LBRACK] = ACTIONS(4961),
    [anon_sym_EQ] = ACTIONS(4963),
    [anon_sym_const] = ACTIONS(5011),
    [anon_sym_constexpr] = ACTIONS(5011),
    [anon_sym_volatile] = ACTIONS(5011),
    [anon_sym_restrict] = ACTIONS(5011),
    [anon_sym___restrict__] = ACTIONS(5011),
    [anon_sym__Atomic] = ACTIONS(5011),
    [anon_sym__Noreturn] = ACTIONS(5011),
    [anon_sym_noreturn] = ACTIONS(5011),
    [anon_sym__Nonnull] = ACTIONS(5011),
    [anon_sym_mutable] = ACTIONS(5011),
    [anon_sym_constinit] = ACTIONS(5011),
    [anon_sym_consteval] = ACTIONS(5011),
    [anon_sym_alignas] = ACTIONS(5015),
    [anon_sym__Alignas] = ACTIONS(5015),
    [sym_primitive_type] = ACTIONS(5017),
    [anon_sym_QMARK] = ACTIONS(4961),
    [anon_sym_STAR_EQ] = ACTIONS(4961),
    [anon_sym_SLASH_EQ] = ACTIONS(4961),
    [anon_sym_PERCENT_EQ] = ACTIONS(4961),
    [anon_sym_PLUS_EQ] = ACTIONS(4961),
    [anon_sym_DASH_EQ] = ACTIONS(4961),
    [anon_sym_LT_LT_EQ] = ACTIONS(4961),
    [anon_sym_GT_GT_EQ] = ACTIONS(4963),
    [anon_sym_AMP_EQ] = ACTIONS(4961),
    [anon_sym_CARET_EQ] = ACTIONS(4961),
    [anon_sym_PIPE_EQ] = ACTIONS(4961),
    [anon_sym_and_eq] = ACTIONS(4963),
    [anon_sym_or_eq] = ACTIONS(4963),
    [anon_sym_xor_eq] = ACTIONS(4963),
    [anon_sym_LT_EQ_GT] = ACTIONS(4961),
    [anon_sym_or] = ACTIONS(4963),
    [anon_sym_and] = ACTIONS(4963),
    [anon_sym_bitor] = ACTIONS(4963),
    [anon_sym_xor] = ACTIONS(4963),
    [anon_sym_bitand] = ACTIONS(4963),
    [anon_sym_not_eq] = ACTIONS(4963),
    [anon_sym_DASH_DASH] = ACTIONS(4961),
    [anon_sym_PLUS_PLUS] = ACTIONS(4961),
    [anon_sym_DOT] = ACTIONS(4963),
    [anon_sym_DOT_STAR] = ACTIONS(4961),
    [anon_sym_DASH_GT] = ACTIONS(4961),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4963),
    [anon_sym_decltype] = ACTIONS(4963),
    [anon_sym_GT2] = ACTIONS(4961),
  },
  [1573] = {
    [sym_type_qualifier] = STATE(1572),
    [sym_alignas_qualifier] = STATE(1624),
    [aux_sym__type_definition_type_repeat1] = STATE(1572),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1615),
    [sym_identifier] = ACTIONS(5019),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4946),
    [anon_sym_COMMA] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(4946),
    [anon_sym_DASH] = ACTIONS(4948),
    [anon_sym_PLUS] = ACTIONS(4948),
    [anon_sym_STAR] = ACTIONS(4948),
    [anon_sym_SLASH] = ACTIONS(4948),
    [anon_sym_PERCENT] = ACTIONS(4948),
    [anon_sym_PIPE_PIPE] = ACTIONS(4946),
    [anon_sym_AMP_AMP] = ACTIONS(4946),
    [anon_sym_PIPE] = ACTIONS(4948),
    [anon_sym_CARET] = ACTIONS(4948),
    [anon_sym_AMP] = ACTIONS(4948),
    [anon_sym_EQ_EQ] = ACTIONS(4946),
    [anon_sym_BANG_EQ] = ACTIONS(4946),
    [anon_sym_GT] = ACTIONS(4948),
    [anon_sym_GT_EQ] = ACTIONS(4948),
    [anon_sym_LT_EQ] = ACTIONS(4948),
    [anon_sym_LT] = ACTIONS(4948),
    [anon_sym_LT_LT] = ACTIONS(4948),
    [anon_sym_GT_GT] = ACTIONS(4948),
    [anon_sym___extension__] = ACTIONS(5011),
    [anon_sym___attribute__] = ACTIONS(4948),
    [anon_sym___attribute] = ACTIONS(4948),
    [anon_sym_LBRACE] = ACTIONS(4946),
    [anon_sym_signed] = ACTIONS(5021),
    [anon_sym_unsigned] = ACTIONS(5021),
    [anon_sym_long] = ACTIONS(5021),
    [anon_sym_short] = ACTIONS(5021),
    [anon_sym_LBRACK] = ACTIONS(4946),
    [anon_sym_EQ] = ACTIONS(4948),
    [anon_sym_const] = ACTIONS(5011),
    [anon_sym_constexpr] = ACTIONS(5011),
    [anon_sym_volatile] = ACTIONS(5011),
    [anon_sym_restrict] = ACTIONS(5011),
    [anon_sym___restrict__] = ACTIONS(5011),
    [anon_sym__Atomic] = ACTIONS(5011),
    [anon_sym__Noreturn] = ACTIONS(5011),
    [anon_sym_noreturn] = ACTIONS(5011),
    [anon_sym__Nonnull] = ACTIONS(5011),
    [anon_sym_mutable] = ACTIONS(5011),
    [anon_sym_constinit] = ACTIONS(5011),
    [anon_sym_consteval] = ACTIONS(5011),
    [anon_sym_alignas] = ACTIONS(5015),
    [anon_sym__Alignas] = ACTIONS(5015),
    [sym_primitive_type] = ACTIONS(5023),
    [anon_sym_QMARK] = ACTIONS(4946),
    [anon_sym_STAR_EQ] = ACTIONS(4946),
    [anon_sym_SLASH_EQ] = ACTIONS(4946),
    [anon_sym_PERCENT_EQ] = ACTIONS(4946),
    [anon_sym_PLUS_EQ] = ACTIONS(4946),
    [anon_sym_DASH_EQ] = ACTIONS(4946),
    [anon_sym_LT_LT_EQ] = ACTIONS(4946),
    [anon_sym_GT_GT_EQ] = ACTIONS(4948),
    [anon_sym_AMP_EQ] = ACTIONS(4946),
    [anon_sym_CARET_EQ] = ACTIONS(4946),
    [anon_sym_PIPE_EQ] = ACTIONS(4946),
    [anon_sym_and_eq] = ACTIONS(4948),
    [anon_sym_or_eq] = ACTIONS(4948),
    [anon_sym_xor_eq] = ACTIONS(4948),
    [anon_sym_LT_EQ_GT] = ACTIONS(4946),
    [anon_sym_or] = ACTIONS(4948),
    [anon_sym_and] = ACTIONS(4948),
    [anon_sym_bitor] = ACTIONS(4948),
    [anon_sym_xor] = ACTIONS(4948),
    [anon_sym_bitand] = ACTIONS(4948),
    [anon_sym_not_eq] = ACTIONS(4948),
    [anon_sym_DASH_DASH] = ACTIONS(4946),
    [anon_sym_PLUS_PLUS] = ACTIONS(4946),
    [anon_sym_DOT] = ACTIONS(4948),
    [anon_sym_DOT_STAR] = ACTIONS(4946),
    [anon_sym_DASH_GT] = ACTIONS(4946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4948),
    [anon_sym_decltype] = ACTIONS(4948),
    [anon_sym_GT2] = ACTIONS(4946),
  },
  [1574] = {
    [sym_function_definition] = STATE(626),
    [sym_declaration] = STATE(626),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(2033),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_ms_call_modifier] = STATE(1865),
    [sym_declaration_list] = STATE(626),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2336),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(6493),
    [sym_qualified_type_identifier] = STATE(2978),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(5025),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5027),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(5029),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
  },
  [1575] = {
    [sym_type_qualifier] = STATE(1575),
    [sym_alignas_qualifier] = STATE(1624),
    [aux_sym__type_definition_type_repeat1] = STATE(1575),
    [sym_identifier] = ACTIONS(4906),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4908),
    [anon_sym_COMMA] = ACTIONS(4908),
    [anon_sym_LPAREN2] = ACTIONS(4908),
    [anon_sym_DASH] = ACTIONS(4906),
    [anon_sym_PLUS] = ACTIONS(4906),
    [anon_sym_STAR] = ACTIONS(4906),
    [anon_sym_SLASH] = ACTIONS(4906),
    [anon_sym_PERCENT] = ACTIONS(4906),
    [anon_sym_PIPE_PIPE] = ACTIONS(4908),
    [anon_sym_AMP_AMP] = ACTIONS(4908),
    [anon_sym_PIPE] = ACTIONS(4906),
    [anon_sym_CARET] = ACTIONS(4906),
    [anon_sym_AMP] = ACTIONS(4906),
    [anon_sym_EQ_EQ] = ACTIONS(4908),
    [anon_sym_BANG_EQ] = ACTIONS(4908),
    [anon_sym_GT] = ACTIONS(4906),
    [anon_sym_GT_EQ] = ACTIONS(4906),
    [anon_sym_LT_EQ] = ACTIONS(4906),
    [anon_sym_LT] = ACTIONS(4906),
    [anon_sym_LT_LT] = ACTIONS(4906),
    [anon_sym_GT_GT] = ACTIONS(4906),
    [anon_sym___extension__] = ACTIONS(5031),
    [anon_sym___attribute__] = ACTIONS(4906),
    [anon_sym___attribute] = ACTIONS(4906),
    [anon_sym_LBRACE] = ACTIONS(4908),
    [anon_sym_signed] = ACTIONS(4906),
    [anon_sym_unsigned] = ACTIONS(4906),
    [anon_sym_long] = ACTIONS(4906),
    [anon_sym_short] = ACTIONS(4906),
    [anon_sym_LBRACK] = ACTIONS(4908),
    [anon_sym_EQ] = ACTIONS(4906),
    [anon_sym_const] = ACTIONS(5031),
    [anon_sym_constexpr] = ACTIONS(5031),
    [anon_sym_volatile] = ACTIONS(5031),
    [anon_sym_restrict] = ACTIONS(5031),
    [anon_sym___restrict__] = ACTIONS(5031),
    [anon_sym__Atomic] = ACTIONS(5031),
    [anon_sym__Noreturn] = ACTIONS(5031),
    [anon_sym_noreturn] = ACTIONS(5031),
    [anon_sym__Nonnull] = ACTIONS(5031),
    [anon_sym_mutable] = ACTIONS(5031),
    [anon_sym_constinit] = ACTIONS(5031),
    [anon_sym_consteval] = ACTIONS(5031),
    [anon_sym_alignas] = ACTIONS(5034),
    [anon_sym__Alignas] = ACTIONS(5034),
    [sym_primitive_type] = ACTIONS(4906),
    [anon_sym_QMARK] = ACTIONS(4908),
    [anon_sym_STAR_EQ] = ACTIONS(4908),
    [anon_sym_SLASH_EQ] = ACTIONS(4908),
    [anon_sym_PERCENT_EQ] = ACTIONS(4908),
    [anon_sym_PLUS_EQ] = ACTIONS(4908),
    [anon_sym_DASH_EQ] = ACTIONS(4908),
    [anon_sym_LT_LT_EQ] = ACTIONS(4908),
    [anon_sym_GT_GT_EQ] = ACTIONS(4906),
    [anon_sym_AMP_EQ] = ACTIONS(4908),
    [anon_sym_CARET_EQ] = ACTIONS(4908),
    [anon_sym_PIPE_EQ] = ACTIONS(4908),
    [anon_sym_and_eq] = ACTIONS(4906),
    [anon_sym_or_eq] = ACTIONS(4906),
    [anon_sym_xor_eq] = ACTIONS(4906),
    [anon_sym_LT_EQ_GT] = ACTIONS(4908),
    [anon_sym_or] = ACTIONS(4906),
    [anon_sym_and] = ACTIONS(4906),
    [anon_sym_bitor] = ACTIONS(4906),
    [anon_sym_xor] = ACTIONS(4906),
    [anon_sym_bitand] = ACTIONS(4906),
    [anon_sym_not_eq] = ACTIONS(4906),
    [anon_sym_DASH_DASH] = ACTIONS(4908),
    [anon_sym_PLUS_PLUS] = ACTIONS(4908),
    [anon_sym_DOT] = ACTIONS(4906),
    [anon_sym_DOT_STAR] = ACTIONS(4908),
    [anon_sym_DASH_GT] = ACTIONS(4908),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4906),
    [anon_sym_decltype] = ACTIONS(4906),
    [anon_sym_GT2] = ACTIONS(4908),
  },
  [1576] = {
    [sym_function_definition] = STATE(711),
    [sym_declaration] = STATE(711),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(4592),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(2033),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_ms_call_modifier] = STATE(1881),
    [sym_declaration_list] = STATE(711),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2336),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(6493),
    [sym_qualified_type_identifier] = STATE(2978),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(5025),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5027),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(5037),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
  },
  [1577] = {
    [sym_function_definition] = STATE(586),
    [sym_declaration] = STATE(586),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(4693),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(2033),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_ms_call_modifier] = STATE(1902),
    [sym_declaration_list] = STATE(586),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2336),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(6493),
    [sym_qualified_type_identifier] = STATE(2978),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(5025),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5027),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(5039),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
  },
  [1578] = {
    [sym_function_definition] = STATE(309),
    [sym_declaration] = STATE(309),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(4677),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(2033),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_ms_call_modifier] = STATE(1899),
    [sym_declaration_list] = STATE(309),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2336),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(6493),
    [sym_qualified_type_identifier] = STATE(2978),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(5025),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5027),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(5041),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
  },
  [1579] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1608),
    [sym_identifier] = ACTIONS(4932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4981),
    [anon_sym_COMMA] = ACTIONS(4981),
    [anon_sym_RPAREN] = ACTIONS(4981),
    [anon_sym_LPAREN2] = ACTIONS(4981),
    [anon_sym_DASH] = ACTIONS(4984),
    [anon_sym_PLUS] = ACTIONS(4984),
    [anon_sym_STAR] = ACTIONS(4984),
    [anon_sym_SLASH] = ACTIONS(4984),
    [anon_sym_PERCENT] = ACTIONS(4984),
    [anon_sym_PIPE_PIPE] = ACTIONS(4981),
    [anon_sym_AMP_AMP] = ACTIONS(4981),
    [anon_sym_PIPE] = ACTIONS(4984),
    [anon_sym_CARET] = ACTIONS(4984),
    [anon_sym_AMP] = ACTIONS(4984),
    [anon_sym_EQ_EQ] = ACTIONS(4981),
    [anon_sym_BANG_EQ] = ACTIONS(4981),
    [anon_sym_GT] = ACTIONS(4984),
    [anon_sym_GT_EQ] = ACTIONS(4981),
    [anon_sym_LT_EQ] = ACTIONS(4984),
    [anon_sym_LT] = ACTIONS(4984),
    [anon_sym_LT_LT] = ACTIONS(4984),
    [anon_sym_GT_GT] = ACTIONS(4984),
    [anon_sym___extension__] = ACTIONS(4932),
    [anon_sym___attribute__] = ACTIONS(4984),
    [anon_sym___attribute] = ACTIONS(4984),
    [anon_sym_LBRACE] = ACTIONS(4981),
    [anon_sym_signed] = ACTIONS(5043),
    [anon_sym_unsigned] = ACTIONS(5043),
    [anon_sym_long] = ACTIONS(5043),
    [anon_sym_short] = ACTIONS(5043),
    [anon_sym_LBRACK] = ACTIONS(4981),
    [anon_sym_EQ] = ACTIONS(4984),
    [anon_sym_const] = ACTIONS(4932),
    [anon_sym_constexpr] = ACTIONS(4932),
    [anon_sym_volatile] = ACTIONS(4932),
    [anon_sym_restrict] = ACTIONS(4932),
    [anon_sym___restrict__] = ACTIONS(4932),
    [anon_sym__Atomic] = ACTIONS(4932),
    [anon_sym__Noreturn] = ACTIONS(4932),
    [anon_sym_noreturn] = ACTIONS(4932),
    [anon_sym__Nonnull] = ACTIONS(4932),
    [anon_sym_mutable] = ACTIONS(4932),
    [anon_sym_constinit] = ACTIONS(4932),
    [anon_sym_consteval] = ACTIONS(4932),
    [anon_sym_alignas] = ACTIONS(4932),
    [anon_sym__Alignas] = ACTIONS(4932),
    [sym_primitive_type] = ACTIONS(4932),
    [anon_sym_QMARK] = ACTIONS(4981),
    [anon_sym_STAR_EQ] = ACTIONS(4981),
    [anon_sym_SLASH_EQ] = ACTIONS(4981),
    [anon_sym_PERCENT_EQ] = ACTIONS(4981),
    [anon_sym_PLUS_EQ] = ACTIONS(4981),
    [anon_sym_DASH_EQ] = ACTIONS(4981),
    [anon_sym_LT_LT_EQ] = ACTIONS(4981),
    [anon_sym_GT_GT_EQ] = ACTIONS(4981),
    [anon_sym_AMP_EQ] = ACTIONS(4981),
    [anon_sym_CARET_EQ] = ACTIONS(4981),
    [anon_sym_PIPE_EQ] = ACTIONS(4981),
    [anon_sym_and_eq] = ACTIONS(4984),
    [anon_sym_or_eq] = ACTIONS(4984),
    [anon_sym_xor_eq] = ACTIONS(4984),
    [anon_sym_LT_EQ_GT] = ACTIONS(4981),
    [anon_sym_or] = ACTIONS(4984),
    [anon_sym_and] = ACTIONS(4984),
    [anon_sym_bitor] = ACTIONS(4984),
    [anon_sym_xor] = ACTIONS(4984),
    [anon_sym_bitand] = ACTIONS(4984),
    [anon_sym_not_eq] = ACTIONS(4984),
    [anon_sym_DASH_DASH] = ACTIONS(4981),
    [anon_sym_PLUS_PLUS] = ACTIONS(4981),
    [anon_sym_DOT] = ACTIONS(4984),
    [anon_sym_DOT_STAR] = ACTIONS(4981),
    [anon_sym_DASH_GT] = ACTIONS(4984),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4984),
    [anon_sym_decltype] = ACTIONS(4984),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4981),
  },
  [1580] = {
    [sym_type_qualifier] = STATE(1580),
    [sym_alignas_qualifier] = STATE(1619),
    [aux_sym__type_definition_type_repeat1] = STATE(1580),
    [sym_identifier] = ACTIONS(4906),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4908),
    [anon_sym_COMMA] = ACTIONS(4908),
    [anon_sym_RPAREN] = ACTIONS(4908),
    [anon_sym_LPAREN2] = ACTIONS(4908),
    [anon_sym_TILDE] = ACTIONS(4908),
    [anon_sym_STAR] = ACTIONS(4908),
    [anon_sym_AMP_AMP] = ACTIONS(4908),
    [anon_sym_AMP] = ACTIONS(4906),
    [anon_sym_SEMI] = ACTIONS(4908),
    [anon_sym___extension__] = ACTIONS(5046),
    [anon_sym_virtual] = ACTIONS(4906),
    [anon_sym_extern] = ACTIONS(4906),
    [anon_sym___attribute__] = ACTIONS(4906),
    [anon_sym___attribute] = ACTIONS(4906),
    [anon_sym_COLON_COLON] = ACTIONS(4908),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4908),
    [anon_sym___declspec] = ACTIONS(4906),
    [anon_sym___based] = ACTIONS(4906),
    [anon_sym___cdecl] = ACTIONS(4906),
    [anon_sym___clrcall] = ACTIONS(4906),
    [anon_sym___stdcall] = ACTIONS(4906),
    [anon_sym___fastcall] = ACTIONS(4906),
    [anon_sym___thiscall] = ACTIONS(4906),
    [anon_sym___vectorcall] = ACTIONS(4906),
    [anon_sym_LBRACE] = ACTIONS(4908),
    [anon_sym_signed] = ACTIONS(4906),
    [anon_sym_unsigned] = ACTIONS(4906),
    [anon_sym_long] = ACTIONS(4906),
    [anon_sym_short] = ACTIONS(4906),
    [anon_sym_LBRACK] = ACTIONS(4906),
    [anon_sym_static] = ACTIONS(4906),
    [anon_sym_EQ] = ACTIONS(4908),
    [anon_sym_register] = ACTIONS(4906),
    [anon_sym_inline] = ACTIONS(4906),
    [anon_sym___inline] = ACTIONS(4906),
    [anon_sym___inline__] = ACTIONS(4906),
    [anon_sym___forceinline] = ACTIONS(4906),
    [anon_sym_thread_local] = ACTIONS(4906),
    [anon_sym___thread] = ACTIONS(4906),
    [anon_sym_const] = ACTIONS(5046),
    [anon_sym_constexpr] = ACTIONS(5046),
    [anon_sym_volatile] = ACTIONS(5046),
    [anon_sym_restrict] = ACTIONS(5046),
    [anon_sym___restrict__] = ACTIONS(5046),
    [anon_sym__Atomic] = ACTIONS(5046),
    [anon_sym__Noreturn] = ACTIONS(5046),
    [anon_sym_noreturn] = ACTIONS(5046),
    [anon_sym__Nonnull] = ACTIONS(5046),
    [anon_sym_mutable] = ACTIONS(5046),
    [anon_sym_constinit] = ACTIONS(5046),
    [anon_sym_consteval] = ACTIONS(5046),
    [anon_sym_alignas] = ACTIONS(5049),
    [anon_sym__Alignas] = ACTIONS(5049),
    [sym_primitive_type] = ACTIONS(4906),
    [anon_sym_enum] = ACTIONS(4906),
    [anon_sym_class] = ACTIONS(4906),
    [anon_sym_struct] = ACTIONS(4906),
    [anon_sym_union] = ACTIONS(4906),
    [anon_sym_asm] = ACTIONS(4906),
    [anon_sym___asm__] = ACTIONS(4906),
    [anon_sym___asm] = ACTIONS(4906),
    [anon_sym_DASH_GT] = ACTIONS(4908),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4906),
    [anon_sym_decltype] = ACTIONS(4906),
    [anon_sym_final] = ACTIONS(4906),
    [anon_sym_override] = ACTIONS(4906),
    [anon_sym_typename] = ACTIONS(4906),
    [anon_sym_template] = ACTIONS(4906),
    [anon_sym_GT2] = ACTIONS(4908),
    [anon_sym_operator] = ACTIONS(4906),
    [anon_sym_try] = ACTIONS(4906),
    [anon_sym_noexcept] = ACTIONS(4906),
    [anon_sym_throw] = ACTIONS(4906),
    [anon_sym_requires] = ACTIONS(4906),
  },
  [1581] = {
    [sym_function_definition] = STATE(743),
    [sym_declaration] = STATE(743),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(4592),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(2033),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_ms_call_modifier] = STATE(1881),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(8184),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(3670),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(6493),
    [sym_qualified_type_identifier] = STATE(3651),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5027),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(5054),
    [anon_sym_struct] = ACTIONS(5056),
    [anon_sym_union] = ACTIONS(5058),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
  },
  [1582] = {
    [sym_function_definition] = STATE(1760),
    [sym_declaration] = STATE(1760),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(4698),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(2033),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_ms_call_modifier] = STATE(1868),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7831),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(3670),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(6493),
    [sym_qualified_type_identifier] = STATE(3651),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5027),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(5060),
    [anon_sym_struct] = ACTIONS(5062),
    [anon_sym_union] = ACTIONS(5064),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
  },
  [1583] = {
    [sym_function_definition] = STATE(1771),
    [sym_declaration] = STATE(1771),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(4698),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(2033),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_ms_call_modifier] = STATE(1868),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7881),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(3670),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(6493),
    [sym_qualified_type_identifier] = STATE(3651),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5027),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(5066),
    [anon_sym_struct] = ACTIONS(5068),
    [anon_sym_union] = ACTIONS(5070),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
  },
  [1584] = {
    [sym_function_definition] = STATE(754),
    [sym_declaration] = STATE(754),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(4592),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(2033),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_ms_call_modifier] = STATE(1881),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7935),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(3670),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(6493),
    [sym_qualified_type_identifier] = STATE(3651),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5027),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(5072),
    [anon_sym_struct] = ACTIONS(5074),
    [anon_sym_union] = ACTIONS(5076),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
  },
  [1585] = {
    [sym_function_definition] = STATE(571),
    [sym_declaration] = STATE(571),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(4693),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(2033),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_ms_call_modifier] = STATE(1902),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(8224),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(3670),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(6493),
    [sym_qualified_type_identifier] = STATE(3651),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5027),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(5078),
    [anon_sym_struct] = ACTIONS(5080),
    [anon_sym_union] = ACTIONS(5082),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
  },
  [1586] = {
    [sym_function_definition] = STATE(574),
    [sym_declaration] = STATE(574),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(4693),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(2033),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_ms_call_modifier] = STATE(1902),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(8267),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(3670),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(6493),
    [sym_qualified_type_identifier] = STATE(3651),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5027),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(5084),
    [anon_sym_struct] = ACTIONS(5086),
    [anon_sym_union] = ACTIONS(5088),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
  },
  [1587] = {
    [sym_function_definition] = STATE(1913),
    [sym_declaration] = STATE(1913),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(4700),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(2033),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_ms_call_modifier] = STATE(1891),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(8421),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(3670),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(6493),
    [sym_qualified_type_identifier] = STATE(3651),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5027),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(5090),
    [anon_sym_struct] = ACTIONS(5092),
    [anon_sym_union] = ACTIONS(5094),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
  },
  [1588] = {
    [sym_function_definition] = STATE(1927),
    [sym_declaration] = STATE(1927),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(4700),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(2033),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_ms_call_modifier] = STATE(1891),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(8557),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(3670),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(6493),
    [sym_qualified_type_identifier] = STATE(3651),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5027),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(5096),
    [anon_sym_struct] = ACTIONS(5098),
    [anon_sym_union] = ACTIONS(5100),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
  },
  [1589] = {
    [sym_function_definition] = STATE(2058),
    [sym_declaration] = STATE(2058),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(4694),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(2033),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_ms_call_modifier] = STATE(1877),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7942),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(3670),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(6493),
    [sym_qualified_type_identifier] = STATE(3651),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5027),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(5102),
    [anon_sym_struct] = ACTIONS(5104),
    [anon_sym_union] = ACTIONS(5106),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
  },
  [1590] = {
    [sym_function_definition] = STATE(2057),
    [sym_declaration] = STATE(2057),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(4694),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(2033),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_ms_call_modifier] = STATE(1877),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7953),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(3670),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(6493),
    [sym_qualified_type_identifier] = STATE(3651),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5027),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(5108),
    [anon_sym_struct] = ACTIONS(5110),
    [anon_sym_union] = ACTIONS(5112),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
  },
  [1591] = {
    [sym_identifier] = ACTIONS(5114),
    [anon_sym_COMMA] = ACTIONS(5116),
    [anon_sym_RPAREN] = ACTIONS(5116),
    [anon_sym_LPAREN2] = ACTIONS(5116),
    [anon_sym_TILDE] = ACTIONS(5116),
    [anon_sym_STAR] = ACTIONS(5116),
    [anon_sym_PIPE_PIPE] = ACTIONS(5116),
    [anon_sym_AMP_AMP] = ACTIONS(5116),
    [anon_sym_AMP] = ACTIONS(5114),
    [anon_sym_SEMI] = ACTIONS(5116),
    [anon_sym___extension__] = ACTIONS(5114),
    [anon_sym_virtual] = ACTIONS(5114),
    [anon_sym_extern] = ACTIONS(5114),
    [anon_sym___attribute__] = ACTIONS(5114),
    [anon_sym___attribute] = ACTIONS(5114),
    [anon_sym_COLON_COLON] = ACTIONS(5116),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5116),
    [anon_sym___declspec] = ACTIONS(5114),
    [anon_sym___based] = ACTIONS(5114),
    [anon_sym___cdecl] = ACTIONS(5114),
    [anon_sym___clrcall] = ACTIONS(5114),
    [anon_sym___stdcall] = ACTIONS(5114),
    [anon_sym___fastcall] = ACTIONS(5114),
    [anon_sym___thiscall] = ACTIONS(5114),
    [anon_sym___vectorcall] = ACTIONS(5114),
    [anon_sym_LBRACE] = ACTIONS(5116),
    [anon_sym_signed] = ACTIONS(5114),
    [anon_sym_unsigned] = ACTIONS(5114),
    [anon_sym_long] = ACTIONS(5114),
    [anon_sym_short] = ACTIONS(5114),
    [anon_sym_LBRACK] = ACTIONS(5114),
    [anon_sym_static] = ACTIONS(5114),
    [anon_sym_EQ] = ACTIONS(5116),
    [anon_sym_register] = ACTIONS(5114),
    [anon_sym_inline] = ACTIONS(5114),
    [anon_sym___inline] = ACTIONS(5114),
    [anon_sym___inline__] = ACTIONS(5114),
    [anon_sym___forceinline] = ACTIONS(5114),
    [anon_sym_thread_local] = ACTIONS(5114),
    [anon_sym___thread] = ACTIONS(5114),
    [anon_sym_const] = ACTIONS(5114),
    [anon_sym_constexpr] = ACTIONS(5114),
    [anon_sym_volatile] = ACTIONS(5114),
    [anon_sym_restrict] = ACTIONS(5114),
    [anon_sym___restrict__] = ACTIONS(5114),
    [anon_sym__Atomic] = ACTIONS(5114),
    [anon_sym__Noreturn] = ACTIONS(5114),
    [anon_sym_noreturn] = ACTIONS(5114),
    [anon_sym__Nonnull] = ACTIONS(5114),
    [anon_sym_mutable] = ACTIONS(5114),
    [anon_sym_constinit] = ACTIONS(5114),
    [anon_sym_consteval] = ACTIONS(5114),
    [anon_sym_alignas] = ACTIONS(5114),
    [anon_sym__Alignas] = ACTIONS(5114),
    [sym_primitive_type] = ACTIONS(5114),
    [anon_sym_enum] = ACTIONS(5114),
    [anon_sym_class] = ACTIONS(5114),
    [anon_sym_struct] = ACTIONS(5114),
    [anon_sym_union] = ACTIONS(5114),
    [anon_sym_or] = ACTIONS(5114),
    [anon_sym_and] = ACTIONS(5114),
    [anon_sym_asm] = ACTIONS(5114),
    [anon_sym___asm__] = ACTIONS(5114),
    [anon_sym___asm] = ACTIONS(5114),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5114),
    [anon_sym_decltype] = ACTIONS(5114),
    [anon_sym_final] = ACTIONS(5114),
    [anon_sym_override] = ACTIONS(5114),
    [anon_sym_explicit] = ACTIONS(5114),
    [anon_sym_typename] = ACTIONS(5114),
    [anon_sym_template] = ACTIONS(5114),
    [anon_sym_GT2] = ACTIONS(5116),
    [anon_sym_operator] = ACTIONS(5114),
    [anon_sym_try] = ACTIONS(5114),
    [anon_sym_friend] = ACTIONS(5114),
    [anon_sym_using] = ACTIONS(5114),
    [anon_sym_concept] = ACTIONS(5114),
    [anon_sym_requires] = ACTIONS(5114),
  },
  [1592] = {
    [sym_identifier] = ACTIONS(5118),
    [anon_sym_COMMA] = ACTIONS(5120),
    [anon_sym_RPAREN] = ACTIONS(5120),
    [anon_sym_LPAREN2] = ACTIONS(5120),
    [anon_sym_TILDE] = ACTIONS(5120),
    [anon_sym_STAR] = ACTIONS(5120),
    [anon_sym_PIPE_PIPE] = ACTIONS(5120),
    [anon_sym_AMP_AMP] = ACTIONS(5120),
    [anon_sym_AMP] = ACTIONS(5118),
    [anon_sym_SEMI] = ACTIONS(5120),
    [anon_sym___extension__] = ACTIONS(5118),
    [anon_sym_virtual] = ACTIONS(5118),
    [anon_sym_extern] = ACTIONS(5118),
    [anon_sym___attribute__] = ACTIONS(5118),
    [anon_sym___attribute] = ACTIONS(5118),
    [anon_sym_COLON_COLON] = ACTIONS(5120),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5120),
    [anon_sym___declspec] = ACTIONS(5118),
    [anon_sym___based] = ACTIONS(5118),
    [anon_sym___cdecl] = ACTIONS(5118),
    [anon_sym___clrcall] = ACTIONS(5118),
    [anon_sym___stdcall] = ACTIONS(5118),
    [anon_sym___fastcall] = ACTIONS(5118),
    [anon_sym___thiscall] = ACTIONS(5118),
    [anon_sym___vectorcall] = ACTIONS(5118),
    [anon_sym_LBRACE] = ACTIONS(5120),
    [anon_sym_signed] = ACTIONS(5118),
    [anon_sym_unsigned] = ACTIONS(5118),
    [anon_sym_long] = ACTIONS(5118),
    [anon_sym_short] = ACTIONS(5118),
    [anon_sym_LBRACK] = ACTIONS(5118),
    [anon_sym_static] = ACTIONS(5118),
    [anon_sym_EQ] = ACTIONS(5120),
    [anon_sym_register] = ACTIONS(5118),
    [anon_sym_inline] = ACTIONS(5118),
    [anon_sym___inline] = ACTIONS(5118),
    [anon_sym___inline__] = ACTIONS(5118),
    [anon_sym___forceinline] = ACTIONS(5118),
    [anon_sym_thread_local] = ACTIONS(5118),
    [anon_sym___thread] = ACTIONS(5118),
    [anon_sym_const] = ACTIONS(5118),
    [anon_sym_constexpr] = ACTIONS(5118),
    [anon_sym_volatile] = ACTIONS(5118),
    [anon_sym_restrict] = ACTIONS(5118),
    [anon_sym___restrict__] = ACTIONS(5118),
    [anon_sym__Atomic] = ACTIONS(5118),
    [anon_sym__Noreturn] = ACTIONS(5118),
    [anon_sym_noreturn] = ACTIONS(5118),
    [anon_sym__Nonnull] = ACTIONS(5118),
    [anon_sym_mutable] = ACTIONS(5118),
    [anon_sym_constinit] = ACTIONS(5118),
    [anon_sym_consteval] = ACTIONS(5118),
    [anon_sym_alignas] = ACTIONS(5118),
    [anon_sym__Alignas] = ACTIONS(5118),
    [sym_primitive_type] = ACTIONS(5118),
    [anon_sym_enum] = ACTIONS(5118),
    [anon_sym_class] = ACTIONS(5118),
    [anon_sym_struct] = ACTIONS(5118),
    [anon_sym_union] = ACTIONS(5118),
    [anon_sym_or] = ACTIONS(5118),
    [anon_sym_and] = ACTIONS(5118),
    [anon_sym_asm] = ACTIONS(5118),
    [anon_sym___asm__] = ACTIONS(5118),
    [anon_sym___asm] = ACTIONS(5118),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5118),
    [anon_sym_decltype] = ACTIONS(5118),
    [anon_sym_final] = ACTIONS(5118),
    [anon_sym_override] = ACTIONS(5118),
    [anon_sym_explicit] = ACTIONS(5118),
    [anon_sym_typename] = ACTIONS(5118),
    [anon_sym_template] = ACTIONS(5118),
    [anon_sym_GT2] = ACTIONS(5120),
    [anon_sym_operator] = ACTIONS(5118),
    [anon_sym_try] = ACTIONS(5118),
    [anon_sym_friend] = ACTIONS(5118),
    [anon_sym_using] = ACTIONS(5118),
    [anon_sym_concept] = ACTIONS(5118),
    [anon_sym_requires] = ACTIONS(5118),
  },
  [1593] = {
    [sym_identifier] = ACTIONS(5122),
    [anon_sym_COMMA] = ACTIONS(5124),
    [anon_sym_RPAREN] = ACTIONS(5124),
    [anon_sym_LPAREN2] = ACTIONS(5124),
    [anon_sym_TILDE] = ACTIONS(5124),
    [anon_sym_STAR] = ACTIONS(5124),
    [anon_sym_PIPE_PIPE] = ACTIONS(5124),
    [anon_sym_AMP_AMP] = ACTIONS(5124),
    [anon_sym_AMP] = ACTIONS(5122),
    [anon_sym_SEMI] = ACTIONS(5124),
    [anon_sym___extension__] = ACTIONS(5122),
    [anon_sym_virtual] = ACTIONS(5122),
    [anon_sym_extern] = ACTIONS(5122),
    [anon_sym___attribute__] = ACTIONS(5122),
    [anon_sym___attribute] = ACTIONS(5122),
    [anon_sym_COLON_COLON] = ACTIONS(5124),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5124),
    [anon_sym___declspec] = ACTIONS(5122),
    [anon_sym___based] = ACTIONS(5122),
    [anon_sym___cdecl] = ACTIONS(5122),
    [anon_sym___clrcall] = ACTIONS(5122),
    [anon_sym___stdcall] = ACTIONS(5122),
    [anon_sym___fastcall] = ACTIONS(5122),
    [anon_sym___thiscall] = ACTIONS(5122),
    [anon_sym___vectorcall] = ACTIONS(5122),
    [anon_sym_LBRACE] = ACTIONS(5124),
    [anon_sym_signed] = ACTIONS(5122),
    [anon_sym_unsigned] = ACTIONS(5122),
    [anon_sym_long] = ACTIONS(5122),
    [anon_sym_short] = ACTIONS(5122),
    [anon_sym_LBRACK] = ACTIONS(5122),
    [anon_sym_static] = ACTIONS(5122),
    [anon_sym_EQ] = ACTIONS(5124),
    [anon_sym_register] = ACTIONS(5122),
    [anon_sym_inline] = ACTIONS(5122),
    [anon_sym___inline] = ACTIONS(5122),
    [anon_sym___inline__] = ACTIONS(5122),
    [anon_sym___forceinline] = ACTIONS(5122),
    [anon_sym_thread_local] = ACTIONS(5122),
    [anon_sym___thread] = ACTIONS(5122),
    [anon_sym_const] = ACTIONS(5122),
    [anon_sym_constexpr] = ACTIONS(5122),
    [anon_sym_volatile] = ACTIONS(5122),
    [anon_sym_restrict] = ACTIONS(5122),
    [anon_sym___restrict__] = ACTIONS(5122),
    [anon_sym__Atomic] = ACTIONS(5122),
    [anon_sym__Noreturn] = ACTIONS(5122),
    [anon_sym_noreturn] = ACTIONS(5122),
    [anon_sym__Nonnull] = ACTIONS(5122),
    [anon_sym_mutable] = ACTIONS(5122),
    [anon_sym_constinit] = ACTIONS(5122),
    [anon_sym_consteval] = ACTIONS(5122),
    [anon_sym_alignas] = ACTIONS(5122),
    [anon_sym__Alignas] = ACTIONS(5122),
    [sym_primitive_type] = ACTIONS(5122),
    [anon_sym_enum] = ACTIONS(5122),
    [anon_sym_class] = ACTIONS(5122),
    [anon_sym_struct] = ACTIONS(5122),
    [anon_sym_union] = ACTIONS(5122),
    [anon_sym_or] = ACTIONS(5122),
    [anon_sym_and] = ACTIONS(5122),
    [anon_sym_asm] = ACTIONS(5122),
    [anon_sym___asm__] = ACTIONS(5122),
    [anon_sym___asm] = ACTIONS(5122),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5122),
    [anon_sym_decltype] = ACTIONS(5122),
    [anon_sym_final] = ACTIONS(5122),
    [anon_sym_override] = ACTIONS(5122),
    [anon_sym_explicit] = ACTIONS(5122),
    [anon_sym_typename] = ACTIONS(5122),
    [anon_sym_template] = ACTIONS(5122),
    [anon_sym_GT2] = ACTIONS(5124),
    [anon_sym_operator] = ACTIONS(5122),
    [anon_sym_try] = ACTIONS(5122),
    [anon_sym_friend] = ACTIONS(5122),
    [anon_sym_using] = ACTIONS(5122),
    [anon_sym_concept] = ACTIONS(5122),
    [anon_sym_requires] = ACTIONS(5122),
  },
  [1594] = {
    [sym_identifier] = ACTIONS(5122),
    [anon_sym_COMMA] = ACTIONS(5124),
    [anon_sym_RPAREN] = ACTIONS(5124),
    [anon_sym_LPAREN2] = ACTIONS(5124),
    [anon_sym_TILDE] = ACTIONS(5124),
    [anon_sym_STAR] = ACTIONS(5124),
    [anon_sym_PIPE_PIPE] = ACTIONS(5124),
    [anon_sym_AMP_AMP] = ACTIONS(5124),
    [anon_sym_AMP] = ACTIONS(5122),
    [anon_sym_SEMI] = ACTIONS(5124),
    [anon_sym___extension__] = ACTIONS(5122),
    [anon_sym_virtual] = ACTIONS(5122),
    [anon_sym_extern] = ACTIONS(5122),
    [anon_sym___attribute__] = ACTIONS(5122),
    [anon_sym___attribute] = ACTIONS(5122),
    [anon_sym_COLON_COLON] = ACTIONS(5124),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5124),
    [anon_sym___declspec] = ACTIONS(5122),
    [anon_sym___based] = ACTIONS(5122),
    [anon_sym___cdecl] = ACTIONS(5122),
    [anon_sym___clrcall] = ACTIONS(5122),
    [anon_sym___stdcall] = ACTIONS(5122),
    [anon_sym___fastcall] = ACTIONS(5122),
    [anon_sym___thiscall] = ACTIONS(5122),
    [anon_sym___vectorcall] = ACTIONS(5122),
    [anon_sym_LBRACE] = ACTIONS(5124),
    [anon_sym_signed] = ACTIONS(5122),
    [anon_sym_unsigned] = ACTIONS(5122),
    [anon_sym_long] = ACTIONS(5122),
    [anon_sym_short] = ACTIONS(5122),
    [anon_sym_LBRACK] = ACTIONS(5122),
    [anon_sym_static] = ACTIONS(5122),
    [anon_sym_EQ] = ACTIONS(5124),
    [anon_sym_register] = ACTIONS(5122),
    [anon_sym_inline] = ACTIONS(5122),
    [anon_sym___inline] = ACTIONS(5122),
    [anon_sym___inline__] = ACTIONS(5122),
    [anon_sym___forceinline] = ACTIONS(5122),
    [anon_sym_thread_local] = ACTIONS(5122),
    [anon_sym___thread] = ACTIONS(5122),
    [anon_sym_const] = ACTIONS(5122),
    [anon_sym_constexpr] = ACTIONS(5122),
    [anon_sym_volatile] = ACTIONS(5122),
    [anon_sym_restrict] = ACTIONS(5122),
    [anon_sym___restrict__] = ACTIONS(5122),
    [anon_sym__Atomic] = ACTIONS(5122),
    [anon_sym__Noreturn] = ACTIONS(5122),
    [anon_sym_noreturn] = ACTIONS(5122),
    [anon_sym__Nonnull] = ACTIONS(5122),
    [anon_sym_mutable] = ACTIONS(5122),
    [anon_sym_constinit] = ACTIONS(5122),
    [anon_sym_consteval] = ACTIONS(5122),
    [anon_sym_alignas] = ACTIONS(5122),
    [anon_sym__Alignas] = ACTIONS(5122),
    [sym_primitive_type] = ACTIONS(5122),
    [anon_sym_enum] = ACTIONS(5122),
    [anon_sym_class] = ACTIONS(5122),
    [anon_sym_struct] = ACTIONS(5122),
    [anon_sym_union] = ACTIONS(5122),
    [anon_sym_or] = ACTIONS(5122),
    [anon_sym_and] = ACTIONS(5122),
    [anon_sym_asm] = ACTIONS(5122),
    [anon_sym___asm__] = ACTIONS(5122),
    [anon_sym___asm] = ACTIONS(5122),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5122),
    [anon_sym_decltype] = ACTIONS(5122),
    [anon_sym_final] = ACTIONS(5122),
    [anon_sym_override] = ACTIONS(5122),
    [anon_sym_explicit] = ACTIONS(5122),
    [anon_sym_typename] = ACTIONS(5122),
    [anon_sym_template] = ACTIONS(5122),
    [anon_sym_GT2] = ACTIONS(5124),
    [anon_sym_operator] = ACTIONS(5122),
    [anon_sym_try] = ACTIONS(5122),
    [anon_sym_friend] = ACTIONS(5122),
    [anon_sym_using] = ACTIONS(5122),
    [anon_sym_concept] = ACTIONS(5122),
    [anon_sym_requires] = ACTIONS(5122),
  },
  [1595] = {
    [sym_identifier] = ACTIONS(5122),
    [anon_sym_COMMA] = ACTIONS(5124),
    [anon_sym_RPAREN] = ACTIONS(5124),
    [anon_sym_LPAREN2] = ACTIONS(5124),
    [anon_sym_TILDE] = ACTIONS(5124),
    [anon_sym_STAR] = ACTIONS(5124),
    [anon_sym_PIPE_PIPE] = ACTIONS(5124),
    [anon_sym_AMP_AMP] = ACTIONS(5124),
    [anon_sym_AMP] = ACTIONS(5122),
    [anon_sym_SEMI] = ACTIONS(5124),
    [anon_sym___extension__] = ACTIONS(5122),
    [anon_sym_virtual] = ACTIONS(5122),
    [anon_sym_extern] = ACTIONS(5122),
    [anon_sym___attribute__] = ACTIONS(5122),
    [anon_sym___attribute] = ACTIONS(5122),
    [anon_sym_COLON_COLON] = ACTIONS(5124),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5124),
    [anon_sym___declspec] = ACTIONS(5122),
    [anon_sym___based] = ACTIONS(5122),
    [anon_sym___cdecl] = ACTIONS(5122),
    [anon_sym___clrcall] = ACTIONS(5122),
    [anon_sym___stdcall] = ACTIONS(5122),
    [anon_sym___fastcall] = ACTIONS(5122),
    [anon_sym___thiscall] = ACTIONS(5122),
    [anon_sym___vectorcall] = ACTIONS(5122),
    [anon_sym_LBRACE] = ACTIONS(5124),
    [anon_sym_signed] = ACTIONS(5122),
    [anon_sym_unsigned] = ACTIONS(5122),
    [anon_sym_long] = ACTIONS(5122),
    [anon_sym_short] = ACTIONS(5122),
    [anon_sym_LBRACK] = ACTIONS(5122),
    [anon_sym_static] = ACTIONS(5122),
    [anon_sym_EQ] = ACTIONS(5124),
    [anon_sym_register] = ACTIONS(5122),
    [anon_sym_inline] = ACTIONS(5122),
    [anon_sym___inline] = ACTIONS(5122),
    [anon_sym___inline__] = ACTIONS(5122),
    [anon_sym___forceinline] = ACTIONS(5122),
    [anon_sym_thread_local] = ACTIONS(5122),
    [anon_sym___thread] = ACTIONS(5122),
    [anon_sym_const] = ACTIONS(5122),
    [anon_sym_constexpr] = ACTIONS(5122),
    [anon_sym_volatile] = ACTIONS(5122),
    [anon_sym_restrict] = ACTIONS(5122),
    [anon_sym___restrict__] = ACTIONS(5122),
    [anon_sym__Atomic] = ACTIONS(5122),
    [anon_sym__Noreturn] = ACTIONS(5122),
    [anon_sym_noreturn] = ACTIONS(5122),
    [anon_sym__Nonnull] = ACTIONS(5122),
    [anon_sym_mutable] = ACTIONS(5122),
    [anon_sym_constinit] = ACTIONS(5122),
    [anon_sym_consteval] = ACTIONS(5122),
    [anon_sym_alignas] = ACTIONS(5122),
    [anon_sym__Alignas] = ACTIONS(5122),
    [sym_primitive_type] = ACTIONS(5122),
    [anon_sym_enum] = ACTIONS(5122),
    [anon_sym_class] = ACTIONS(5122),
    [anon_sym_struct] = ACTIONS(5122),
    [anon_sym_union] = ACTIONS(5122),
    [anon_sym_or] = ACTIONS(5122),
    [anon_sym_and] = ACTIONS(5122),
    [anon_sym_asm] = ACTIONS(5122),
    [anon_sym___asm__] = ACTIONS(5122),
    [anon_sym___asm] = ACTIONS(5122),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5122),
    [anon_sym_decltype] = ACTIONS(5122),
    [anon_sym_final] = ACTIONS(5122),
    [anon_sym_override] = ACTIONS(5122),
    [anon_sym_explicit] = ACTIONS(5122),
    [anon_sym_typename] = ACTIONS(5122),
    [anon_sym_template] = ACTIONS(5122),
    [anon_sym_GT2] = ACTIONS(5124),
    [anon_sym_operator] = ACTIONS(5122),
    [anon_sym_try] = ACTIONS(5122),
    [anon_sym_friend] = ACTIONS(5122),
    [anon_sym_using] = ACTIONS(5122),
    [anon_sym_concept] = ACTIONS(5122),
    [anon_sym_requires] = ACTIONS(5122),
  },
  [1596] = {
    [sym_identifier] = ACTIONS(5126),
    [anon_sym_COMMA] = ACTIONS(5128),
    [anon_sym_RPAREN] = ACTIONS(5128),
    [anon_sym_LPAREN2] = ACTIONS(5128),
    [anon_sym_TILDE] = ACTIONS(5128),
    [anon_sym_STAR] = ACTIONS(5128),
    [anon_sym_PIPE_PIPE] = ACTIONS(5128),
    [anon_sym_AMP_AMP] = ACTIONS(5128),
    [anon_sym_AMP] = ACTIONS(5126),
    [anon_sym_SEMI] = ACTIONS(5128),
    [anon_sym___extension__] = ACTIONS(5126),
    [anon_sym_virtual] = ACTIONS(5126),
    [anon_sym_extern] = ACTIONS(5126),
    [anon_sym___attribute__] = ACTIONS(5126),
    [anon_sym___attribute] = ACTIONS(5126),
    [anon_sym_COLON_COLON] = ACTIONS(5128),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5128),
    [anon_sym___declspec] = ACTIONS(5126),
    [anon_sym___based] = ACTIONS(5126),
    [anon_sym___cdecl] = ACTIONS(5126),
    [anon_sym___clrcall] = ACTIONS(5126),
    [anon_sym___stdcall] = ACTIONS(5126),
    [anon_sym___fastcall] = ACTIONS(5126),
    [anon_sym___thiscall] = ACTIONS(5126),
    [anon_sym___vectorcall] = ACTIONS(5126),
    [anon_sym_LBRACE] = ACTIONS(5128),
    [anon_sym_signed] = ACTIONS(5126),
    [anon_sym_unsigned] = ACTIONS(5126),
    [anon_sym_long] = ACTIONS(5126),
    [anon_sym_short] = ACTIONS(5126),
    [anon_sym_LBRACK] = ACTIONS(5126),
    [anon_sym_static] = ACTIONS(5126),
    [anon_sym_EQ] = ACTIONS(5128),
    [anon_sym_register] = ACTIONS(5126),
    [anon_sym_inline] = ACTIONS(5126),
    [anon_sym___inline] = ACTIONS(5126),
    [anon_sym___inline__] = ACTIONS(5126),
    [anon_sym___forceinline] = ACTIONS(5126),
    [anon_sym_thread_local] = ACTIONS(5126),
    [anon_sym___thread] = ACTIONS(5126),
    [anon_sym_const] = ACTIONS(5126),
    [anon_sym_constexpr] = ACTIONS(5126),
    [anon_sym_volatile] = ACTIONS(5126),
    [anon_sym_restrict] = ACTIONS(5126),
    [anon_sym___restrict__] = ACTIONS(5126),
    [anon_sym__Atomic] = ACTIONS(5126),
    [anon_sym__Noreturn] = ACTIONS(5126),
    [anon_sym_noreturn] = ACTIONS(5126),
    [anon_sym__Nonnull] = ACTIONS(5126),
    [anon_sym_mutable] = ACTIONS(5126),
    [anon_sym_constinit] = ACTIONS(5126),
    [anon_sym_consteval] = ACTIONS(5126),
    [anon_sym_alignas] = ACTIONS(5126),
    [anon_sym__Alignas] = ACTIONS(5126),
    [sym_primitive_type] = ACTIONS(5126),
    [anon_sym_enum] = ACTIONS(5126),
    [anon_sym_class] = ACTIONS(5126),
    [anon_sym_struct] = ACTIONS(5126),
    [anon_sym_union] = ACTIONS(5126),
    [anon_sym_or] = ACTIONS(5126),
    [anon_sym_and] = ACTIONS(5126),
    [anon_sym_asm] = ACTIONS(5126),
    [anon_sym___asm__] = ACTIONS(5126),
    [anon_sym___asm] = ACTIONS(5126),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5126),
    [anon_sym_decltype] = ACTIONS(5126),
    [anon_sym_final] = ACTIONS(5126),
    [anon_sym_override] = ACTIONS(5126),
    [anon_sym_explicit] = ACTIONS(5126),
    [anon_sym_typename] = ACTIONS(5126),
    [anon_sym_template] = ACTIONS(5126),
    [anon_sym_GT2] = ACTIONS(5128),
    [anon_sym_operator] = ACTIONS(5126),
    [anon_sym_try] = ACTIONS(5126),
    [anon_sym_friend] = ACTIONS(5126),
    [anon_sym_using] = ACTIONS(5126),
    [anon_sym_concept] = ACTIONS(5126),
    [anon_sym_requires] = ACTIONS(5126),
  },
  [1597] = {
    [sym_identifier] = ACTIONS(5130),
    [anon_sym_COMMA] = ACTIONS(5132),
    [anon_sym_RPAREN] = ACTIONS(5132),
    [anon_sym_LPAREN2] = ACTIONS(5132),
    [anon_sym_TILDE] = ACTIONS(5132),
    [anon_sym_STAR] = ACTIONS(5132),
    [anon_sym_PIPE_PIPE] = ACTIONS(5132),
    [anon_sym_AMP_AMP] = ACTIONS(5132),
    [anon_sym_AMP] = ACTIONS(5130),
    [anon_sym_SEMI] = ACTIONS(5132),
    [anon_sym___extension__] = ACTIONS(5130),
    [anon_sym_virtual] = ACTIONS(5130),
    [anon_sym_extern] = ACTIONS(5130),
    [anon_sym___attribute__] = ACTIONS(5130),
    [anon_sym___attribute] = ACTIONS(5130),
    [anon_sym_COLON_COLON] = ACTIONS(5132),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5132),
    [anon_sym___declspec] = ACTIONS(5130),
    [anon_sym___based] = ACTIONS(5130),
    [anon_sym___cdecl] = ACTIONS(5130),
    [anon_sym___clrcall] = ACTIONS(5130),
    [anon_sym___stdcall] = ACTIONS(5130),
    [anon_sym___fastcall] = ACTIONS(5130),
    [anon_sym___thiscall] = ACTIONS(5130),
    [anon_sym___vectorcall] = ACTIONS(5130),
    [anon_sym_LBRACE] = ACTIONS(5132),
    [anon_sym_signed] = ACTIONS(5130),
    [anon_sym_unsigned] = ACTIONS(5130),
    [anon_sym_long] = ACTIONS(5130),
    [anon_sym_short] = ACTIONS(5130),
    [anon_sym_LBRACK] = ACTIONS(5130),
    [anon_sym_static] = ACTIONS(5130),
    [anon_sym_EQ] = ACTIONS(5132),
    [anon_sym_register] = ACTIONS(5130),
    [anon_sym_inline] = ACTIONS(5130),
    [anon_sym___inline] = ACTIONS(5130),
    [anon_sym___inline__] = ACTIONS(5130),
    [anon_sym___forceinline] = ACTIONS(5130),
    [anon_sym_thread_local] = ACTIONS(5130),
    [anon_sym___thread] = ACTIONS(5130),
    [anon_sym_const] = ACTIONS(5130),
    [anon_sym_constexpr] = ACTIONS(5130),
    [anon_sym_volatile] = ACTIONS(5130),
    [anon_sym_restrict] = ACTIONS(5130),
    [anon_sym___restrict__] = ACTIONS(5130),
    [anon_sym__Atomic] = ACTIONS(5130),
    [anon_sym__Noreturn] = ACTIONS(5130),
    [anon_sym_noreturn] = ACTIONS(5130),
    [anon_sym__Nonnull] = ACTIONS(5130),
    [anon_sym_mutable] = ACTIONS(5130),
    [anon_sym_constinit] = ACTIONS(5130),
    [anon_sym_consteval] = ACTIONS(5130),
    [anon_sym_alignas] = ACTIONS(5130),
    [anon_sym__Alignas] = ACTIONS(5130),
    [sym_primitive_type] = ACTIONS(5130),
    [anon_sym_enum] = ACTIONS(5130),
    [anon_sym_class] = ACTIONS(5130),
    [anon_sym_struct] = ACTIONS(5130),
    [anon_sym_union] = ACTIONS(5130),
    [anon_sym_or] = ACTIONS(5130),
    [anon_sym_and] = ACTIONS(5130),
    [anon_sym_asm] = ACTIONS(5130),
    [anon_sym___asm__] = ACTIONS(5130),
    [anon_sym___asm] = ACTIONS(5130),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5130),
    [anon_sym_decltype] = ACTIONS(5130),
    [anon_sym_final] = ACTIONS(5130),
    [anon_sym_override] = ACTIONS(5130),
    [anon_sym_explicit] = ACTIONS(5130),
    [anon_sym_typename] = ACTIONS(5130),
    [anon_sym_template] = ACTIONS(5130),
    [anon_sym_GT2] = ACTIONS(5132),
    [anon_sym_operator] = ACTIONS(5130),
    [anon_sym_try] = ACTIONS(5130),
    [anon_sym_friend] = ACTIONS(5130),
    [anon_sym_using] = ACTIONS(5130),
    [anon_sym_concept] = ACTIONS(5130),
    [anon_sym_requires] = ACTIONS(5130),
  },
  [1598] = {
    [sym_identifier] = ACTIONS(5134),
    [anon_sym_COMMA] = ACTIONS(5136),
    [anon_sym_RPAREN] = ACTIONS(5136),
    [anon_sym_LPAREN2] = ACTIONS(5136),
    [anon_sym_TILDE] = ACTIONS(5136),
    [anon_sym_STAR] = ACTIONS(5136),
    [anon_sym_PIPE_PIPE] = ACTIONS(5136),
    [anon_sym_AMP_AMP] = ACTIONS(5136),
    [anon_sym_AMP] = ACTIONS(5134),
    [anon_sym_SEMI] = ACTIONS(5136),
    [anon_sym___extension__] = ACTIONS(5134),
    [anon_sym_virtual] = ACTIONS(5134),
    [anon_sym_extern] = ACTIONS(5134),
    [anon_sym___attribute__] = ACTIONS(5134),
    [anon_sym___attribute] = ACTIONS(5134),
    [anon_sym_COLON_COLON] = ACTIONS(5136),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5136),
    [anon_sym___declspec] = ACTIONS(5134),
    [anon_sym___based] = ACTIONS(5134),
    [anon_sym___cdecl] = ACTIONS(5134),
    [anon_sym___clrcall] = ACTIONS(5134),
    [anon_sym___stdcall] = ACTIONS(5134),
    [anon_sym___fastcall] = ACTIONS(5134),
    [anon_sym___thiscall] = ACTIONS(5134),
    [anon_sym___vectorcall] = ACTIONS(5134),
    [anon_sym_LBRACE] = ACTIONS(5136),
    [anon_sym_signed] = ACTIONS(5134),
    [anon_sym_unsigned] = ACTIONS(5134),
    [anon_sym_long] = ACTIONS(5134),
    [anon_sym_short] = ACTIONS(5134),
    [anon_sym_LBRACK] = ACTIONS(5134),
    [anon_sym_static] = ACTIONS(5134),
    [anon_sym_EQ] = ACTIONS(5136),
    [anon_sym_register] = ACTIONS(5134),
    [anon_sym_inline] = ACTIONS(5134),
    [anon_sym___inline] = ACTIONS(5134),
    [anon_sym___inline__] = ACTIONS(5134),
    [anon_sym___forceinline] = ACTIONS(5134),
    [anon_sym_thread_local] = ACTIONS(5134),
    [anon_sym___thread] = ACTIONS(5134),
    [anon_sym_const] = ACTIONS(5134),
    [anon_sym_constexpr] = ACTIONS(5134),
    [anon_sym_volatile] = ACTIONS(5134),
    [anon_sym_restrict] = ACTIONS(5134),
    [anon_sym___restrict__] = ACTIONS(5134),
    [anon_sym__Atomic] = ACTIONS(5134),
    [anon_sym__Noreturn] = ACTIONS(5134),
    [anon_sym_noreturn] = ACTIONS(5134),
    [anon_sym__Nonnull] = ACTIONS(5134),
    [anon_sym_mutable] = ACTIONS(5134),
    [anon_sym_constinit] = ACTIONS(5134),
    [anon_sym_consteval] = ACTIONS(5134),
    [anon_sym_alignas] = ACTIONS(5134),
    [anon_sym__Alignas] = ACTIONS(5134),
    [sym_primitive_type] = ACTIONS(5134),
    [anon_sym_enum] = ACTIONS(5134),
    [anon_sym_class] = ACTIONS(5134),
    [anon_sym_struct] = ACTIONS(5134),
    [anon_sym_union] = ACTIONS(5134),
    [anon_sym_or] = ACTIONS(5134),
    [anon_sym_and] = ACTIONS(5134),
    [anon_sym_asm] = ACTIONS(5134),
    [anon_sym___asm__] = ACTIONS(5134),
    [anon_sym___asm] = ACTIONS(5134),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5134),
    [anon_sym_decltype] = ACTIONS(5134),
    [anon_sym_final] = ACTIONS(5134),
    [anon_sym_override] = ACTIONS(5134),
    [anon_sym_explicit] = ACTIONS(5134),
    [anon_sym_typename] = ACTIONS(5134),
    [anon_sym_template] = ACTIONS(5134),
    [anon_sym_GT2] = ACTIONS(5136),
    [anon_sym_operator] = ACTIONS(5134),
    [anon_sym_try] = ACTIONS(5134),
    [anon_sym_friend] = ACTIONS(5134),
    [anon_sym_using] = ACTIONS(5134),
    [anon_sym_concept] = ACTIONS(5134),
    [anon_sym_requires] = ACTIONS(5134),
  },
  [1599] = {
    [sym_identifier] = ACTIONS(5138),
    [anon_sym_COMMA] = ACTIONS(5140),
    [anon_sym_RPAREN] = ACTIONS(5140),
    [anon_sym_LPAREN2] = ACTIONS(5140),
    [anon_sym_TILDE] = ACTIONS(5140),
    [anon_sym_STAR] = ACTIONS(5140),
    [anon_sym_PIPE_PIPE] = ACTIONS(5140),
    [anon_sym_AMP_AMP] = ACTIONS(5140),
    [anon_sym_AMP] = ACTIONS(5138),
    [anon_sym_SEMI] = ACTIONS(5140),
    [anon_sym___extension__] = ACTIONS(5138),
    [anon_sym_virtual] = ACTIONS(5138),
    [anon_sym_extern] = ACTIONS(5138),
    [anon_sym___attribute__] = ACTIONS(5138),
    [anon_sym___attribute] = ACTIONS(5138),
    [anon_sym_COLON_COLON] = ACTIONS(5140),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5140),
    [anon_sym___declspec] = ACTIONS(5138),
    [anon_sym___based] = ACTIONS(5138),
    [anon_sym___cdecl] = ACTIONS(5138),
    [anon_sym___clrcall] = ACTIONS(5138),
    [anon_sym___stdcall] = ACTIONS(5138),
    [anon_sym___fastcall] = ACTIONS(5138),
    [anon_sym___thiscall] = ACTIONS(5138),
    [anon_sym___vectorcall] = ACTIONS(5138),
    [anon_sym_LBRACE] = ACTIONS(5140),
    [anon_sym_signed] = ACTIONS(5138),
    [anon_sym_unsigned] = ACTIONS(5138),
    [anon_sym_long] = ACTIONS(5138),
    [anon_sym_short] = ACTIONS(5138),
    [anon_sym_LBRACK] = ACTIONS(5138),
    [anon_sym_static] = ACTIONS(5138),
    [anon_sym_EQ] = ACTIONS(5140),
    [anon_sym_register] = ACTIONS(5138),
    [anon_sym_inline] = ACTIONS(5138),
    [anon_sym___inline] = ACTIONS(5138),
    [anon_sym___inline__] = ACTIONS(5138),
    [anon_sym___forceinline] = ACTIONS(5138),
    [anon_sym_thread_local] = ACTIONS(5138),
    [anon_sym___thread] = ACTIONS(5138),
    [anon_sym_const] = ACTIONS(5138),
    [anon_sym_constexpr] = ACTIONS(5138),
    [anon_sym_volatile] = ACTIONS(5138),
    [anon_sym_restrict] = ACTIONS(5138),
    [anon_sym___restrict__] = ACTIONS(5138),
    [anon_sym__Atomic] = ACTIONS(5138),
    [anon_sym__Noreturn] = ACTIONS(5138),
    [anon_sym_noreturn] = ACTIONS(5138),
    [anon_sym__Nonnull] = ACTIONS(5138),
    [anon_sym_mutable] = ACTIONS(5138),
    [anon_sym_constinit] = ACTIONS(5138),
    [anon_sym_consteval] = ACTIONS(5138),
    [anon_sym_alignas] = ACTIONS(5138),
    [anon_sym__Alignas] = ACTIONS(5138),
    [sym_primitive_type] = ACTIONS(5138),
    [anon_sym_enum] = ACTIONS(5138),
    [anon_sym_class] = ACTIONS(5138),
    [anon_sym_struct] = ACTIONS(5138),
    [anon_sym_union] = ACTIONS(5138),
    [anon_sym_or] = ACTIONS(5138),
    [anon_sym_and] = ACTIONS(5138),
    [anon_sym_asm] = ACTIONS(5138),
    [anon_sym___asm__] = ACTIONS(5138),
    [anon_sym___asm] = ACTIONS(5138),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5138),
    [anon_sym_decltype] = ACTIONS(5138),
    [anon_sym_final] = ACTIONS(5138),
    [anon_sym_override] = ACTIONS(5138),
    [anon_sym_explicit] = ACTIONS(5138),
    [anon_sym_typename] = ACTIONS(5138),
    [anon_sym_template] = ACTIONS(5138),
    [anon_sym_GT2] = ACTIONS(5140),
    [anon_sym_operator] = ACTIONS(5138),
    [anon_sym_try] = ACTIONS(5138),
    [anon_sym_friend] = ACTIONS(5138),
    [anon_sym_using] = ACTIONS(5138),
    [anon_sym_concept] = ACTIONS(5138),
    [anon_sym_requires] = ACTIONS(5138),
  },
  [1600] = {
    [sym_identifier] = ACTIONS(5142),
    [anon_sym_COMMA] = ACTIONS(5144),
    [anon_sym_RPAREN] = ACTIONS(5144),
    [anon_sym_LPAREN2] = ACTIONS(5144),
    [anon_sym_TILDE] = ACTIONS(5144),
    [anon_sym_STAR] = ACTIONS(5144),
    [anon_sym_PIPE_PIPE] = ACTIONS(5144),
    [anon_sym_AMP_AMP] = ACTIONS(5144),
    [anon_sym_AMP] = ACTIONS(5142),
    [anon_sym_SEMI] = ACTIONS(5144),
    [anon_sym___extension__] = ACTIONS(5142),
    [anon_sym_virtual] = ACTIONS(5142),
    [anon_sym_extern] = ACTIONS(5142),
    [anon_sym___attribute__] = ACTIONS(5142),
    [anon_sym___attribute] = ACTIONS(5142),
    [anon_sym_COLON_COLON] = ACTIONS(5144),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5144),
    [anon_sym___declspec] = ACTIONS(5142),
    [anon_sym___based] = ACTIONS(5142),
    [anon_sym___cdecl] = ACTIONS(5142),
    [anon_sym___clrcall] = ACTIONS(5142),
    [anon_sym___stdcall] = ACTIONS(5142),
    [anon_sym___fastcall] = ACTIONS(5142),
    [anon_sym___thiscall] = ACTIONS(5142),
    [anon_sym___vectorcall] = ACTIONS(5142),
    [anon_sym_LBRACE] = ACTIONS(5144),
    [anon_sym_signed] = ACTIONS(5142),
    [anon_sym_unsigned] = ACTIONS(5142),
    [anon_sym_long] = ACTIONS(5142),
    [anon_sym_short] = ACTIONS(5142),
    [anon_sym_LBRACK] = ACTIONS(5142),
    [anon_sym_static] = ACTIONS(5142),
    [anon_sym_EQ] = ACTIONS(5144),
    [anon_sym_register] = ACTIONS(5142),
    [anon_sym_inline] = ACTIONS(5142),
    [anon_sym___inline] = ACTIONS(5142),
    [anon_sym___inline__] = ACTIONS(5142),
    [anon_sym___forceinline] = ACTIONS(5142),
    [anon_sym_thread_local] = ACTIONS(5142),
    [anon_sym___thread] = ACTIONS(5142),
    [anon_sym_const] = ACTIONS(5142),
    [anon_sym_constexpr] = ACTIONS(5142),
    [anon_sym_volatile] = ACTIONS(5142),
    [anon_sym_restrict] = ACTIONS(5142),
    [anon_sym___restrict__] = ACTIONS(5142),
    [anon_sym__Atomic] = ACTIONS(5142),
    [anon_sym__Noreturn] = ACTIONS(5142),
    [anon_sym_noreturn] = ACTIONS(5142),
    [anon_sym__Nonnull] = ACTIONS(5142),
    [anon_sym_mutable] = ACTIONS(5142),
    [anon_sym_constinit] = ACTIONS(5142),
    [anon_sym_consteval] = ACTIONS(5142),
    [anon_sym_alignas] = ACTIONS(5142),
    [anon_sym__Alignas] = ACTIONS(5142),
    [sym_primitive_type] = ACTIONS(5142),
    [anon_sym_enum] = ACTIONS(5142),
    [anon_sym_class] = ACTIONS(5142),
    [anon_sym_struct] = ACTIONS(5142),
    [anon_sym_union] = ACTIONS(5142),
    [anon_sym_or] = ACTIONS(5142),
    [anon_sym_and] = ACTIONS(5142),
    [anon_sym_asm] = ACTIONS(5142),
    [anon_sym___asm__] = ACTIONS(5142),
    [anon_sym___asm] = ACTIONS(5142),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5142),
    [anon_sym_decltype] = ACTIONS(5142),
    [anon_sym_final] = ACTIONS(5142),
    [anon_sym_override] = ACTIONS(5142),
    [anon_sym_explicit] = ACTIONS(5142),
    [anon_sym_typename] = ACTIONS(5142),
    [anon_sym_template] = ACTIONS(5142),
    [anon_sym_GT2] = ACTIONS(5144),
    [anon_sym_operator] = ACTIONS(5142),
    [anon_sym_try] = ACTIONS(5142),
    [anon_sym_friend] = ACTIONS(5142),
    [anon_sym_using] = ACTIONS(5142),
    [anon_sym_concept] = ACTIONS(5142),
    [anon_sym_requires] = ACTIONS(5142),
  },
  [1601] = {
    [sym_identifier] = ACTIONS(5146),
    [anon_sym_COMMA] = ACTIONS(5148),
    [anon_sym_RPAREN] = ACTIONS(5148),
    [anon_sym_LPAREN2] = ACTIONS(5148),
    [anon_sym_TILDE] = ACTIONS(5148),
    [anon_sym_STAR] = ACTIONS(5148),
    [anon_sym_PIPE_PIPE] = ACTIONS(5148),
    [anon_sym_AMP_AMP] = ACTIONS(5148),
    [anon_sym_AMP] = ACTIONS(5146),
    [anon_sym_SEMI] = ACTIONS(5148),
    [anon_sym___extension__] = ACTIONS(5146),
    [anon_sym_virtual] = ACTIONS(5146),
    [anon_sym_extern] = ACTIONS(5146),
    [anon_sym___attribute__] = ACTIONS(5146),
    [anon_sym___attribute] = ACTIONS(5146),
    [anon_sym_COLON_COLON] = ACTIONS(5148),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5148),
    [anon_sym___declspec] = ACTIONS(5146),
    [anon_sym___based] = ACTIONS(5146),
    [anon_sym___cdecl] = ACTIONS(5146),
    [anon_sym___clrcall] = ACTIONS(5146),
    [anon_sym___stdcall] = ACTIONS(5146),
    [anon_sym___fastcall] = ACTIONS(5146),
    [anon_sym___thiscall] = ACTIONS(5146),
    [anon_sym___vectorcall] = ACTIONS(5146),
    [anon_sym_LBRACE] = ACTIONS(5148),
    [anon_sym_signed] = ACTIONS(5146),
    [anon_sym_unsigned] = ACTIONS(5146),
    [anon_sym_long] = ACTIONS(5146),
    [anon_sym_short] = ACTIONS(5146),
    [anon_sym_LBRACK] = ACTIONS(5146),
    [anon_sym_static] = ACTIONS(5146),
    [anon_sym_EQ] = ACTIONS(5148),
    [anon_sym_register] = ACTIONS(5146),
    [anon_sym_inline] = ACTIONS(5146),
    [anon_sym___inline] = ACTIONS(5146),
    [anon_sym___inline__] = ACTIONS(5146),
    [anon_sym___forceinline] = ACTIONS(5146),
    [anon_sym_thread_local] = ACTIONS(5146),
    [anon_sym___thread] = ACTIONS(5146),
    [anon_sym_const] = ACTIONS(5146),
    [anon_sym_constexpr] = ACTIONS(5146),
    [anon_sym_volatile] = ACTIONS(5146),
    [anon_sym_restrict] = ACTIONS(5146),
    [anon_sym___restrict__] = ACTIONS(5146),
    [anon_sym__Atomic] = ACTIONS(5146),
    [anon_sym__Noreturn] = ACTIONS(5146),
    [anon_sym_noreturn] = ACTIONS(5146),
    [anon_sym__Nonnull] = ACTIONS(5146),
    [anon_sym_mutable] = ACTIONS(5146),
    [anon_sym_constinit] = ACTIONS(5146),
    [anon_sym_consteval] = ACTIONS(5146),
    [anon_sym_alignas] = ACTIONS(5146),
    [anon_sym__Alignas] = ACTIONS(5146),
    [sym_primitive_type] = ACTIONS(5146),
    [anon_sym_enum] = ACTIONS(5146),
    [anon_sym_class] = ACTIONS(5146),
    [anon_sym_struct] = ACTIONS(5146),
    [anon_sym_union] = ACTIONS(5146),
    [anon_sym_or] = ACTIONS(5146),
    [anon_sym_and] = ACTIONS(5146),
    [anon_sym_asm] = ACTIONS(5146),
    [anon_sym___asm__] = ACTIONS(5146),
    [anon_sym___asm] = ACTIONS(5146),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5146),
    [anon_sym_decltype] = ACTIONS(5146),
    [anon_sym_final] = ACTIONS(5146),
    [anon_sym_override] = ACTIONS(5146),
    [anon_sym_explicit] = ACTIONS(5146),
    [anon_sym_typename] = ACTIONS(5146),
    [anon_sym_template] = ACTIONS(5146),
    [anon_sym_GT2] = ACTIONS(5148),
    [anon_sym_operator] = ACTIONS(5146),
    [anon_sym_try] = ACTIONS(5146),
    [anon_sym_friend] = ACTIONS(5146),
    [anon_sym_using] = ACTIONS(5146),
    [anon_sym_concept] = ACTIONS(5146),
    [anon_sym_requires] = ACTIONS(5146),
  },
  [1602] = {
    [sym_identifier] = ACTIONS(5150),
    [anon_sym_COMMA] = ACTIONS(5152),
    [anon_sym_RPAREN] = ACTIONS(5152),
    [anon_sym_LPAREN2] = ACTIONS(5152),
    [anon_sym_TILDE] = ACTIONS(5152),
    [anon_sym_STAR] = ACTIONS(5152),
    [anon_sym_PIPE_PIPE] = ACTIONS(5152),
    [anon_sym_AMP_AMP] = ACTIONS(5152),
    [anon_sym_AMP] = ACTIONS(5150),
    [anon_sym_SEMI] = ACTIONS(5152),
    [anon_sym___extension__] = ACTIONS(5150),
    [anon_sym_virtual] = ACTIONS(5150),
    [anon_sym_extern] = ACTIONS(5150),
    [anon_sym___attribute__] = ACTIONS(5150),
    [anon_sym___attribute] = ACTIONS(5150),
    [anon_sym_COLON_COLON] = ACTIONS(5152),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5152),
    [anon_sym___declspec] = ACTIONS(5150),
    [anon_sym___based] = ACTIONS(5150),
    [anon_sym___cdecl] = ACTIONS(5150),
    [anon_sym___clrcall] = ACTIONS(5150),
    [anon_sym___stdcall] = ACTIONS(5150),
    [anon_sym___fastcall] = ACTIONS(5150),
    [anon_sym___thiscall] = ACTIONS(5150),
    [anon_sym___vectorcall] = ACTIONS(5150),
    [anon_sym_LBRACE] = ACTIONS(5152),
    [anon_sym_signed] = ACTIONS(5150),
    [anon_sym_unsigned] = ACTIONS(5150),
    [anon_sym_long] = ACTIONS(5150),
    [anon_sym_short] = ACTIONS(5150),
    [anon_sym_LBRACK] = ACTIONS(5150),
    [anon_sym_static] = ACTIONS(5150),
    [anon_sym_EQ] = ACTIONS(5152),
    [anon_sym_register] = ACTIONS(5150),
    [anon_sym_inline] = ACTIONS(5150),
    [anon_sym___inline] = ACTIONS(5150),
    [anon_sym___inline__] = ACTIONS(5150),
    [anon_sym___forceinline] = ACTIONS(5150),
    [anon_sym_thread_local] = ACTIONS(5150),
    [anon_sym___thread] = ACTIONS(5150),
    [anon_sym_const] = ACTIONS(5150),
    [anon_sym_constexpr] = ACTIONS(5150),
    [anon_sym_volatile] = ACTIONS(5150),
    [anon_sym_restrict] = ACTIONS(5150),
    [anon_sym___restrict__] = ACTIONS(5150),
    [anon_sym__Atomic] = ACTIONS(5150),
    [anon_sym__Noreturn] = ACTIONS(5150),
    [anon_sym_noreturn] = ACTIONS(5150),
    [anon_sym__Nonnull] = ACTIONS(5150),
    [anon_sym_mutable] = ACTIONS(5150),
    [anon_sym_constinit] = ACTIONS(5150),
    [anon_sym_consteval] = ACTIONS(5150),
    [anon_sym_alignas] = ACTIONS(5150),
    [anon_sym__Alignas] = ACTIONS(5150),
    [sym_primitive_type] = ACTIONS(5150),
    [anon_sym_enum] = ACTIONS(5150),
    [anon_sym_class] = ACTIONS(5150),
    [anon_sym_struct] = ACTIONS(5150),
    [anon_sym_union] = ACTIONS(5150),
    [anon_sym_or] = ACTIONS(5150),
    [anon_sym_and] = ACTIONS(5150),
    [anon_sym_asm] = ACTIONS(5150),
    [anon_sym___asm__] = ACTIONS(5150),
    [anon_sym___asm] = ACTIONS(5150),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5150),
    [anon_sym_decltype] = ACTIONS(5150),
    [anon_sym_final] = ACTIONS(5150),
    [anon_sym_override] = ACTIONS(5150),
    [anon_sym_explicit] = ACTIONS(5150),
    [anon_sym_typename] = ACTIONS(5150),
    [anon_sym_template] = ACTIONS(5150),
    [anon_sym_GT2] = ACTIONS(5152),
    [anon_sym_operator] = ACTIONS(5150),
    [anon_sym_try] = ACTIONS(5150),
    [anon_sym_friend] = ACTIONS(5150),
    [anon_sym_using] = ACTIONS(5150),
    [anon_sym_concept] = ACTIONS(5150),
    [anon_sym_requires] = ACTIONS(5150),
  },
  [1603] = {
    [sym_function_definition] = STATE(544),
    [sym_declaration] = STATE(544),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(2033),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_ms_call_modifier] = STATE(1865),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(8497),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(3670),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(6493),
    [sym_qualified_type_identifier] = STATE(3651),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5027),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(5154),
    [anon_sym_struct] = ACTIONS(5156),
    [anon_sym_union] = ACTIONS(5158),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
  },
  [1604] = {
    [sym_function_definition] = STATE(667),
    [sym_declaration] = STATE(667),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(4640),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(2033),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_ms_call_modifier] = STATE(1865),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7880),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(3670),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(6493),
    [sym_qualified_type_identifier] = STATE(3651),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5027),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(5160),
    [anon_sym_struct] = ACTIONS(5162),
    [anon_sym_union] = ACTIONS(5164),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
  },
  [1605] = {
    [sym_identifier] = ACTIONS(5166),
    [anon_sym_COMMA] = ACTIONS(5168),
    [anon_sym_RPAREN] = ACTIONS(5168),
    [anon_sym_LPAREN2] = ACTIONS(5168),
    [anon_sym_TILDE] = ACTIONS(5168),
    [anon_sym_STAR] = ACTIONS(5168),
    [anon_sym_PIPE_PIPE] = ACTIONS(5168),
    [anon_sym_AMP_AMP] = ACTIONS(5168),
    [anon_sym_AMP] = ACTIONS(5166),
    [anon_sym_SEMI] = ACTIONS(5168),
    [anon_sym___extension__] = ACTIONS(5166),
    [anon_sym_virtual] = ACTIONS(5166),
    [anon_sym_extern] = ACTIONS(5166),
    [anon_sym___attribute__] = ACTIONS(5166),
    [anon_sym___attribute] = ACTIONS(5166),
    [anon_sym_COLON_COLON] = ACTIONS(5168),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5168),
    [anon_sym___declspec] = ACTIONS(5166),
    [anon_sym___based] = ACTIONS(5166),
    [anon_sym___cdecl] = ACTIONS(5166),
    [anon_sym___clrcall] = ACTIONS(5166),
    [anon_sym___stdcall] = ACTIONS(5166),
    [anon_sym___fastcall] = ACTIONS(5166),
    [anon_sym___thiscall] = ACTIONS(5166),
    [anon_sym___vectorcall] = ACTIONS(5166),
    [anon_sym_LBRACE] = ACTIONS(5168),
    [anon_sym_signed] = ACTIONS(5166),
    [anon_sym_unsigned] = ACTIONS(5166),
    [anon_sym_long] = ACTIONS(5166),
    [anon_sym_short] = ACTIONS(5166),
    [anon_sym_LBRACK] = ACTIONS(5166),
    [anon_sym_static] = ACTIONS(5166),
    [anon_sym_EQ] = ACTIONS(5168),
    [anon_sym_register] = ACTIONS(5166),
    [anon_sym_inline] = ACTIONS(5166),
    [anon_sym___inline] = ACTIONS(5166),
    [anon_sym___inline__] = ACTIONS(5166),
    [anon_sym___forceinline] = ACTIONS(5166),
    [anon_sym_thread_local] = ACTIONS(5166),
    [anon_sym___thread] = ACTIONS(5166),
    [anon_sym_const] = ACTIONS(5166),
    [anon_sym_constexpr] = ACTIONS(5166),
    [anon_sym_volatile] = ACTIONS(5166),
    [anon_sym_restrict] = ACTIONS(5166),
    [anon_sym___restrict__] = ACTIONS(5166),
    [anon_sym__Atomic] = ACTIONS(5166),
    [anon_sym__Noreturn] = ACTIONS(5166),
    [anon_sym_noreturn] = ACTIONS(5166),
    [anon_sym__Nonnull] = ACTIONS(5166),
    [anon_sym_mutable] = ACTIONS(5166),
    [anon_sym_constinit] = ACTIONS(5166),
    [anon_sym_consteval] = ACTIONS(5166),
    [anon_sym_alignas] = ACTIONS(5166),
    [anon_sym__Alignas] = ACTIONS(5166),
    [sym_primitive_type] = ACTIONS(5166),
    [anon_sym_enum] = ACTIONS(5166),
    [anon_sym_class] = ACTIONS(5166),
    [anon_sym_struct] = ACTIONS(5166),
    [anon_sym_union] = ACTIONS(5166),
    [anon_sym_or] = ACTIONS(5166),
    [anon_sym_and] = ACTIONS(5166),
    [anon_sym_asm] = ACTIONS(5166),
    [anon_sym___asm__] = ACTIONS(5166),
    [anon_sym___asm] = ACTIONS(5166),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5166),
    [anon_sym_decltype] = ACTIONS(5166),
    [anon_sym_final] = ACTIONS(5166),
    [anon_sym_override] = ACTIONS(5166),
    [anon_sym_explicit] = ACTIONS(5166),
    [anon_sym_typename] = ACTIONS(5166),
    [anon_sym_template] = ACTIONS(5166),
    [anon_sym_GT2] = ACTIONS(5168),
    [anon_sym_operator] = ACTIONS(5166),
    [anon_sym_try] = ACTIONS(5166),
    [anon_sym_friend] = ACTIONS(5166),
    [anon_sym_using] = ACTIONS(5166),
    [anon_sym_concept] = ACTIONS(5166),
    [anon_sym_requires] = ACTIONS(5166),
  },
  [1606] = {
    [sym_identifier] = ACTIONS(5170),
    [anon_sym_COMMA] = ACTIONS(5172),
    [anon_sym_RPAREN] = ACTIONS(5172),
    [anon_sym_LPAREN2] = ACTIONS(5172),
    [anon_sym_TILDE] = ACTIONS(5172),
    [anon_sym_STAR] = ACTIONS(5172),
    [anon_sym_PIPE_PIPE] = ACTIONS(5172),
    [anon_sym_AMP_AMP] = ACTIONS(5172),
    [anon_sym_AMP] = ACTIONS(5170),
    [anon_sym_SEMI] = ACTIONS(5172),
    [anon_sym___extension__] = ACTIONS(5170),
    [anon_sym_virtual] = ACTIONS(5170),
    [anon_sym_extern] = ACTIONS(5170),
    [anon_sym___attribute__] = ACTIONS(5170),
    [anon_sym___attribute] = ACTIONS(5170),
    [anon_sym_COLON_COLON] = ACTIONS(5172),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5172),
    [anon_sym___declspec] = ACTIONS(5170),
    [anon_sym___based] = ACTIONS(5170),
    [anon_sym___cdecl] = ACTIONS(5170),
    [anon_sym___clrcall] = ACTIONS(5170),
    [anon_sym___stdcall] = ACTIONS(5170),
    [anon_sym___fastcall] = ACTIONS(5170),
    [anon_sym___thiscall] = ACTIONS(5170),
    [anon_sym___vectorcall] = ACTIONS(5170),
    [anon_sym_LBRACE] = ACTIONS(5172),
    [anon_sym_signed] = ACTIONS(5170),
    [anon_sym_unsigned] = ACTIONS(5170),
    [anon_sym_long] = ACTIONS(5170),
    [anon_sym_short] = ACTIONS(5170),
    [anon_sym_LBRACK] = ACTIONS(5170),
    [anon_sym_static] = ACTIONS(5170),
    [anon_sym_EQ] = ACTIONS(5172),
    [anon_sym_register] = ACTIONS(5170),
    [anon_sym_inline] = ACTIONS(5170),
    [anon_sym___inline] = ACTIONS(5170),
    [anon_sym___inline__] = ACTIONS(5170),
    [anon_sym___forceinline] = ACTIONS(5170),
    [anon_sym_thread_local] = ACTIONS(5170),
    [anon_sym___thread] = ACTIONS(5170),
    [anon_sym_const] = ACTIONS(5170),
    [anon_sym_constexpr] = ACTIONS(5170),
    [anon_sym_volatile] = ACTIONS(5170),
    [anon_sym_restrict] = ACTIONS(5170),
    [anon_sym___restrict__] = ACTIONS(5170),
    [anon_sym__Atomic] = ACTIONS(5170),
    [anon_sym__Noreturn] = ACTIONS(5170),
    [anon_sym_noreturn] = ACTIONS(5170),
    [anon_sym__Nonnull] = ACTIONS(5170),
    [anon_sym_mutable] = ACTIONS(5170),
    [anon_sym_constinit] = ACTIONS(5170),
    [anon_sym_consteval] = ACTIONS(5170),
    [anon_sym_alignas] = ACTIONS(5170),
    [anon_sym__Alignas] = ACTIONS(5170),
    [sym_primitive_type] = ACTIONS(5170),
    [anon_sym_enum] = ACTIONS(5170),
    [anon_sym_class] = ACTIONS(5170),
    [anon_sym_struct] = ACTIONS(5170),
    [anon_sym_union] = ACTIONS(5170),
    [anon_sym_or] = ACTIONS(5170),
    [anon_sym_and] = ACTIONS(5170),
    [anon_sym_asm] = ACTIONS(5170),
    [anon_sym___asm__] = ACTIONS(5170),
    [anon_sym___asm] = ACTIONS(5170),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5170),
    [anon_sym_decltype] = ACTIONS(5170),
    [anon_sym_final] = ACTIONS(5170),
    [anon_sym_override] = ACTIONS(5170),
    [anon_sym_explicit] = ACTIONS(5170),
    [anon_sym_typename] = ACTIONS(5170),
    [anon_sym_template] = ACTIONS(5170),
    [anon_sym_GT2] = ACTIONS(5172),
    [anon_sym_operator] = ACTIONS(5170),
    [anon_sym_try] = ACTIONS(5170),
    [anon_sym_friend] = ACTIONS(5170),
    [anon_sym_using] = ACTIONS(5170),
    [anon_sym_concept] = ACTIONS(5170),
    [anon_sym_requires] = ACTIONS(5170),
  },
  [1607] = {
    [sym_identifier] = ACTIONS(5174),
    [anon_sym_COMMA] = ACTIONS(5176),
    [anon_sym_RPAREN] = ACTIONS(5176),
    [anon_sym_LPAREN2] = ACTIONS(5176),
    [anon_sym_TILDE] = ACTIONS(5176),
    [anon_sym_STAR] = ACTIONS(5176),
    [anon_sym_PIPE_PIPE] = ACTIONS(5176),
    [anon_sym_AMP_AMP] = ACTIONS(5176),
    [anon_sym_AMP] = ACTIONS(5174),
    [anon_sym_SEMI] = ACTIONS(5176),
    [anon_sym___extension__] = ACTIONS(5174),
    [anon_sym_virtual] = ACTIONS(5174),
    [anon_sym_extern] = ACTIONS(5174),
    [anon_sym___attribute__] = ACTIONS(5174),
    [anon_sym___attribute] = ACTIONS(5174),
    [anon_sym_COLON_COLON] = ACTIONS(5176),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5176),
    [anon_sym___declspec] = ACTIONS(5174),
    [anon_sym___based] = ACTIONS(5174),
    [anon_sym___cdecl] = ACTIONS(5174),
    [anon_sym___clrcall] = ACTIONS(5174),
    [anon_sym___stdcall] = ACTIONS(5174),
    [anon_sym___fastcall] = ACTIONS(5174),
    [anon_sym___thiscall] = ACTIONS(5174),
    [anon_sym___vectorcall] = ACTIONS(5174),
    [anon_sym_LBRACE] = ACTIONS(5176),
    [anon_sym_signed] = ACTIONS(5174),
    [anon_sym_unsigned] = ACTIONS(5174),
    [anon_sym_long] = ACTIONS(5174),
    [anon_sym_short] = ACTIONS(5174),
    [anon_sym_LBRACK] = ACTIONS(5174),
    [anon_sym_static] = ACTIONS(5174),
    [anon_sym_EQ] = ACTIONS(5176),
    [anon_sym_register] = ACTIONS(5174),
    [anon_sym_inline] = ACTIONS(5174),
    [anon_sym___inline] = ACTIONS(5174),
    [anon_sym___inline__] = ACTIONS(5174),
    [anon_sym___forceinline] = ACTIONS(5174),
    [anon_sym_thread_local] = ACTIONS(5174),
    [anon_sym___thread] = ACTIONS(5174),
    [anon_sym_const] = ACTIONS(5174),
    [anon_sym_constexpr] = ACTIONS(5174),
    [anon_sym_volatile] = ACTIONS(5174),
    [anon_sym_restrict] = ACTIONS(5174),
    [anon_sym___restrict__] = ACTIONS(5174),
    [anon_sym__Atomic] = ACTIONS(5174),
    [anon_sym__Noreturn] = ACTIONS(5174),
    [anon_sym_noreturn] = ACTIONS(5174),
    [anon_sym__Nonnull] = ACTIONS(5174),
    [anon_sym_mutable] = ACTIONS(5174),
    [anon_sym_constinit] = ACTIONS(5174),
    [anon_sym_consteval] = ACTIONS(5174),
    [anon_sym_alignas] = ACTIONS(5174),
    [anon_sym__Alignas] = ACTIONS(5174),
    [sym_primitive_type] = ACTIONS(5174),
    [anon_sym_enum] = ACTIONS(5174),
    [anon_sym_class] = ACTIONS(5174),
    [anon_sym_struct] = ACTIONS(5174),
    [anon_sym_union] = ACTIONS(5174),
    [anon_sym_or] = ACTIONS(5174),
    [anon_sym_and] = ACTIONS(5174),
    [anon_sym_asm] = ACTIONS(5174),
    [anon_sym___asm__] = ACTIONS(5174),
    [anon_sym___asm] = ACTIONS(5174),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5174),
    [anon_sym_decltype] = ACTIONS(5174),
    [anon_sym_final] = ACTIONS(5174),
    [anon_sym_override] = ACTIONS(5174),
    [anon_sym_explicit] = ACTIONS(5174),
    [anon_sym_typename] = ACTIONS(5174),
    [anon_sym_template] = ACTIONS(5174),
    [anon_sym_GT2] = ACTIONS(5176),
    [anon_sym_operator] = ACTIONS(5174),
    [anon_sym_try] = ACTIONS(5174),
    [anon_sym_friend] = ACTIONS(5174),
    [anon_sym_using] = ACTIONS(5174),
    [anon_sym_concept] = ACTIONS(5174),
    [anon_sym_requires] = ACTIONS(5174),
  },
  [1608] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1608),
    [sym_identifier] = ACTIONS(4932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4934),
    [anon_sym_COMMA] = ACTIONS(4934),
    [anon_sym_RPAREN] = ACTIONS(4934),
    [anon_sym_LPAREN2] = ACTIONS(4934),
    [anon_sym_DASH] = ACTIONS(4932),
    [anon_sym_PLUS] = ACTIONS(4932),
    [anon_sym_STAR] = ACTIONS(4932),
    [anon_sym_SLASH] = ACTIONS(4932),
    [anon_sym_PERCENT] = ACTIONS(4932),
    [anon_sym_PIPE_PIPE] = ACTIONS(4934),
    [anon_sym_AMP_AMP] = ACTIONS(4934),
    [anon_sym_PIPE] = ACTIONS(4932),
    [anon_sym_CARET] = ACTIONS(4932),
    [anon_sym_AMP] = ACTIONS(4932),
    [anon_sym_EQ_EQ] = ACTIONS(4934),
    [anon_sym_BANG_EQ] = ACTIONS(4934),
    [anon_sym_GT] = ACTIONS(4932),
    [anon_sym_GT_EQ] = ACTIONS(4934),
    [anon_sym_LT_EQ] = ACTIONS(4932),
    [anon_sym_LT] = ACTIONS(4932),
    [anon_sym_LT_LT] = ACTIONS(4932),
    [anon_sym_GT_GT] = ACTIONS(4932),
    [anon_sym___extension__] = ACTIONS(4932),
    [anon_sym___attribute__] = ACTIONS(4932),
    [anon_sym___attribute] = ACTIONS(4932),
    [anon_sym_LBRACE] = ACTIONS(4934),
    [anon_sym_signed] = ACTIONS(5043),
    [anon_sym_unsigned] = ACTIONS(5043),
    [anon_sym_long] = ACTIONS(5043),
    [anon_sym_short] = ACTIONS(5043),
    [anon_sym_LBRACK] = ACTIONS(4934),
    [anon_sym_EQ] = ACTIONS(4932),
    [anon_sym_const] = ACTIONS(4932),
    [anon_sym_constexpr] = ACTIONS(4932),
    [anon_sym_volatile] = ACTIONS(4932),
    [anon_sym_restrict] = ACTIONS(4932),
    [anon_sym___restrict__] = ACTIONS(4932),
    [anon_sym__Atomic] = ACTIONS(4932),
    [anon_sym__Noreturn] = ACTIONS(4932),
    [anon_sym_noreturn] = ACTIONS(4932),
    [anon_sym__Nonnull] = ACTIONS(4932),
    [anon_sym_mutable] = ACTIONS(4932),
    [anon_sym_constinit] = ACTIONS(4932),
    [anon_sym_consteval] = ACTIONS(4932),
    [anon_sym_alignas] = ACTIONS(4932),
    [anon_sym__Alignas] = ACTIONS(4932),
    [sym_primitive_type] = ACTIONS(4932),
    [anon_sym_QMARK] = ACTIONS(4934),
    [anon_sym_STAR_EQ] = ACTIONS(4934),
    [anon_sym_SLASH_EQ] = ACTIONS(4934),
    [anon_sym_PERCENT_EQ] = ACTIONS(4934),
    [anon_sym_PLUS_EQ] = ACTIONS(4934),
    [anon_sym_DASH_EQ] = ACTIONS(4934),
    [anon_sym_LT_LT_EQ] = ACTIONS(4934),
    [anon_sym_GT_GT_EQ] = ACTIONS(4934),
    [anon_sym_AMP_EQ] = ACTIONS(4934),
    [anon_sym_CARET_EQ] = ACTIONS(4934),
    [anon_sym_PIPE_EQ] = ACTIONS(4934),
    [anon_sym_and_eq] = ACTIONS(4932),
    [anon_sym_or_eq] = ACTIONS(4932),
    [anon_sym_xor_eq] = ACTIONS(4932),
    [anon_sym_LT_EQ_GT] = ACTIONS(4934),
    [anon_sym_or] = ACTIONS(4932),
    [anon_sym_and] = ACTIONS(4932),
    [anon_sym_bitor] = ACTIONS(4932),
    [anon_sym_xor] = ACTIONS(4932),
    [anon_sym_bitand] = ACTIONS(4932),
    [anon_sym_not_eq] = ACTIONS(4932),
    [anon_sym_DASH_DASH] = ACTIONS(4934),
    [anon_sym_PLUS_PLUS] = ACTIONS(4934),
    [anon_sym_DOT] = ACTIONS(4932),
    [anon_sym_DOT_STAR] = ACTIONS(4934),
    [anon_sym_DASH_GT] = ACTIONS(4932),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4932),
    [anon_sym_decltype] = ACTIONS(4932),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4934),
  },
  [1609] = {
    [sym_function_definition] = STATE(288),
    [sym_declaration] = STATE(288),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(4677),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(2033),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_ms_call_modifier] = STATE(1899),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(7998),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(3670),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(6493),
    [sym_qualified_type_identifier] = STATE(3651),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5027),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(5178),
    [anon_sym_struct] = ACTIONS(5180),
    [anon_sym_union] = ACTIONS(5182),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
  },
  [1610] = {
    [sym_type_qualifier] = STATE(1611),
    [sym_alignas_qualifier] = STATE(1650),
    [aux_sym__type_definition_type_repeat1] = STATE(1611),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1633),
    [sym_identifier] = ACTIONS(5184),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4946),
    [anon_sym_COMMA] = ACTIONS(4946),
    [anon_sym_RPAREN] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(4946),
    [anon_sym_DASH] = ACTIONS(4948),
    [anon_sym_PLUS] = ACTIONS(4948),
    [anon_sym_STAR] = ACTIONS(4948),
    [anon_sym_SLASH] = ACTIONS(4948),
    [anon_sym_PERCENT] = ACTIONS(4948),
    [anon_sym_PIPE_PIPE] = ACTIONS(4946),
    [anon_sym_AMP_AMP] = ACTIONS(4946),
    [anon_sym_PIPE] = ACTIONS(4948),
    [anon_sym_CARET] = ACTIONS(4948),
    [anon_sym_AMP] = ACTIONS(4948),
    [anon_sym_EQ_EQ] = ACTIONS(4946),
    [anon_sym_BANG_EQ] = ACTIONS(4946),
    [anon_sym_GT] = ACTIONS(4948),
    [anon_sym_GT_EQ] = ACTIONS(4946),
    [anon_sym_LT_EQ] = ACTIONS(4948),
    [anon_sym_LT] = ACTIONS(4948),
    [anon_sym_LT_LT] = ACTIONS(4948),
    [anon_sym_GT_GT] = ACTIONS(4948),
    [anon_sym___extension__] = ACTIONS(5186),
    [anon_sym___attribute__] = ACTIONS(4948),
    [anon_sym___attribute] = ACTIONS(4948),
    [anon_sym_LBRACE] = ACTIONS(4946),
    [anon_sym_signed] = ACTIONS(5188),
    [anon_sym_unsigned] = ACTIONS(5188),
    [anon_sym_long] = ACTIONS(5188),
    [anon_sym_short] = ACTIONS(5188),
    [anon_sym_LBRACK] = ACTIONS(4946),
    [anon_sym_EQ] = ACTIONS(4948),
    [anon_sym_const] = ACTIONS(5186),
    [anon_sym_constexpr] = ACTIONS(5186),
    [anon_sym_volatile] = ACTIONS(5186),
    [anon_sym_restrict] = ACTIONS(5186),
    [anon_sym___restrict__] = ACTIONS(5186),
    [anon_sym__Atomic] = ACTIONS(5186),
    [anon_sym__Noreturn] = ACTIONS(5186),
    [anon_sym_noreturn] = ACTIONS(5186),
    [anon_sym__Nonnull] = ACTIONS(5186),
    [anon_sym_mutable] = ACTIONS(5186),
    [anon_sym_constinit] = ACTIONS(5186),
    [anon_sym_consteval] = ACTIONS(5186),
    [anon_sym_alignas] = ACTIONS(5190),
    [anon_sym__Alignas] = ACTIONS(5190),
    [sym_primitive_type] = ACTIONS(5192),
    [anon_sym_QMARK] = ACTIONS(4946),
    [anon_sym_STAR_EQ] = ACTIONS(4946),
    [anon_sym_SLASH_EQ] = ACTIONS(4946),
    [anon_sym_PERCENT_EQ] = ACTIONS(4946),
    [anon_sym_PLUS_EQ] = ACTIONS(4946),
    [anon_sym_DASH_EQ] = ACTIONS(4946),
    [anon_sym_LT_LT_EQ] = ACTIONS(4946),
    [anon_sym_GT_GT_EQ] = ACTIONS(4946),
    [anon_sym_AMP_EQ] = ACTIONS(4946),
    [anon_sym_CARET_EQ] = ACTIONS(4946),
    [anon_sym_PIPE_EQ] = ACTIONS(4946),
    [anon_sym_LT_EQ_GT] = ACTIONS(4946),
    [anon_sym_or] = ACTIONS(4948),
    [anon_sym_and] = ACTIONS(4948),
    [anon_sym_bitor] = ACTIONS(4948),
    [anon_sym_xor] = ACTIONS(4948),
    [anon_sym_bitand] = ACTIONS(4948),
    [anon_sym_not_eq] = ACTIONS(4948),
    [anon_sym_DASH_DASH] = ACTIONS(4946),
    [anon_sym_PLUS_PLUS] = ACTIONS(4946),
    [anon_sym_DOT] = ACTIONS(4948),
    [anon_sym_DOT_STAR] = ACTIONS(4946),
    [anon_sym_DASH_GT] = ACTIONS(4948),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4948),
    [anon_sym_decltype] = ACTIONS(4948),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4946),
  },
  [1611] = {
    [sym_type_qualifier] = STATE(1616),
    [sym_alignas_qualifier] = STATE(1650),
    [aux_sym__type_definition_type_repeat1] = STATE(1616),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2678),
    [sym_identifier] = ACTIONS(5194),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4961),
    [anon_sym_COMMA] = ACTIONS(4961),
    [anon_sym_RPAREN] = ACTIONS(4961),
    [anon_sym_LPAREN2] = ACTIONS(4961),
    [anon_sym_DASH] = ACTIONS(4963),
    [anon_sym_PLUS] = ACTIONS(4963),
    [anon_sym_STAR] = ACTIONS(4963),
    [anon_sym_SLASH] = ACTIONS(4963),
    [anon_sym_PERCENT] = ACTIONS(4963),
    [anon_sym_PIPE_PIPE] = ACTIONS(4961),
    [anon_sym_AMP_AMP] = ACTIONS(4961),
    [anon_sym_PIPE] = ACTIONS(4963),
    [anon_sym_CARET] = ACTIONS(4963),
    [anon_sym_AMP] = ACTIONS(4963),
    [anon_sym_EQ_EQ] = ACTIONS(4961),
    [anon_sym_BANG_EQ] = ACTIONS(4961),
    [anon_sym_GT] = ACTIONS(4963),
    [anon_sym_GT_EQ] = ACTIONS(4961),
    [anon_sym_LT_EQ] = ACTIONS(4963),
    [anon_sym_LT] = ACTIONS(4963),
    [anon_sym_LT_LT] = ACTIONS(4963),
    [anon_sym_GT_GT] = ACTIONS(4963),
    [anon_sym___extension__] = ACTIONS(5186),
    [anon_sym___attribute__] = ACTIONS(4963),
    [anon_sym___attribute] = ACTIONS(4963),
    [anon_sym_LBRACE] = ACTIONS(4961),
    [anon_sym_signed] = ACTIONS(5196),
    [anon_sym_unsigned] = ACTIONS(5196),
    [anon_sym_long] = ACTIONS(5196),
    [anon_sym_short] = ACTIONS(5196),
    [anon_sym_LBRACK] = ACTIONS(4961),
    [anon_sym_EQ] = ACTIONS(4963),
    [anon_sym_const] = ACTIONS(5186),
    [anon_sym_constexpr] = ACTIONS(5186),
    [anon_sym_volatile] = ACTIONS(5186),
    [anon_sym_restrict] = ACTIONS(5186),
    [anon_sym___restrict__] = ACTIONS(5186),
    [anon_sym__Atomic] = ACTIONS(5186),
    [anon_sym__Noreturn] = ACTIONS(5186),
    [anon_sym_noreturn] = ACTIONS(5186),
    [anon_sym__Nonnull] = ACTIONS(5186),
    [anon_sym_mutable] = ACTIONS(5186),
    [anon_sym_constinit] = ACTIONS(5186),
    [anon_sym_consteval] = ACTIONS(5186),
    [anon_sym_alignas] = ACTIONS(5190),
    [anon_sym__Alignas] = ACTIONS(5190),
    [sym_primitive_type] = ACTIONS(5198),
    [anon_sym_QMARK] = ACTIONS(4961),
    [anon_sym_STAR_EQ] = ACTIONS(4961),
    [anon_sym_SLASH_EQ] = ACTIONS(4961),
    [anon_sym_PERCENT_EQ] = ACTIONS(4961),
    [anon_sym_PLUS_EQ] = ACTIONS(4961),
    [anon_sym_DASH_EQ] = ACTIONS(4961),
    [anon_sym_LT_LT_EQ] = ACTIONS(4961),
    [anon_sym_GT_GT_EQ] = ACTIONS(4961),
    [anon_sym_AMP_EQ] = ACTIONS(4961),
    [anon_sym_CARET_EQ] = ACTIONS(4961),
    [anon_sym_PIPE_EQ] = ACTIONS(4961),
    [anon_sym_LT_EQ_GT] = ACTIONS(4961),
    [anon_sym_or] = ACTIONS(4963),
    [anon_sym_and] = ACTIONS(4963),
    [anon_sym_bitor] = ACTIONS(4963),
    [anon_sym_xor] = ACTIONS(4963),
    [anon_sym_bitand] = ACTIONS(4963),
    [anon_sym_not_eq] = ACTIONS(4963),
    [anon_sym_DASH_DASH] = ACTIONS(4961),
    [anon_sym_PLUS_PLUS] = ACTIONS(4961),
    [anon_sym_DOT] = ACTIONS(4963),
    [anon_sym_DOT_STAR] = ACTIONS(4961),
    [anon_sym_DASH_GT] = ACTIONS(4963),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4963),
    [anon_sym_decltype] = ACTIONS(4963),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4961),
  },
  [1612] = {
    [sym_function_definition] = STATE(292),
    [sym_declaration] = STATE(292),
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(4677),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(2033),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_ms_call_modifier] = STATE(1899),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym__class_name] = STATE(8505),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(3670),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(6493),
    [sym_qualified_type_identifier] = STATE(3651),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(5052),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5027),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym___cdecl] = ACTIONS(53),
    [anon_sym___clrcall] = ACTIONS(53),
    [anon_sym___stdcall] = ACTIONS(53),
    [anon_sym___fastcall] = ACTIONS(53),
    [anon_sym___thiscall] = ACTIONS(53),
    [anon_sym___vectorcall] = ACTIONS(53),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(5200),
    [anon_sym_struct] = ACTIONS(5202),
    [anon_sym_union] = ACTIONS(5204),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
  },
  [1613] = {
    [sym_identifier] = ACTIONS(4939),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4941),
    [anon_sym_COMMA] = ACTIONS(4941),
    [anon_sym_RPAREN] = ACTIONS(4941),
    [anon_sym_LPAREN2] = ACTIONS(4941),
    [anon_sym_DASH] = ACTIONS(4939),
    [anon_sym_PLUS] = ACTIONS(4939),
    [anon_sym_STAR] = ACTIONS(4939),
    [anon_sym_SLASH] = ACTIONS(4939),
    [anon_sym_PERCENT] = ACTIONS(4939),
    [anon_sym_PIPE_PIPE] = ACTIONS(4941),
    [anon_sym_AMP_AMP] = ACTIONS(4941),
    [anon_sym_PIPE] = ACTIONS(4939),
    [anon_sym_CARET] = ACTIONS(4939),
    [anon_sym_AMP] = ACTIONS(4939),
    [anon_sym_EQ_EQ] = ACTIONS(4941),
    [anon_sym_BANG_EQ] = ACTIONS(4941),
    [anon_sym_GT] = ACTIONS(4939),
    [anon_sym_GT_EQ] = ACTIONS(4941),
    [anon_sym_LT_EQ] = ACTIONS(4939),
    [anon_sym_LT] = ACTIONS(4939),
    [anon_sym_LT_LT] = ACTIONS(4939),
    [anon_sym_GT_GT] = ACTIONS(4939),
    [anon_sym___extension__] = ACTIONS(4939),
    [anon_sym___attribute__] = ACTIONS(4939),
    [anon_sym___attribute] = ACTIONS(4939),
    [anon_sym_LBRACE] = ACTIONS(4941),
    [anon_sym_signed] = ACTIONS(4939),
    [anon_sym_unsigned] = ACTIONS(4939),
    [anon_sym_long] = ACTIONS(4939),
    [anon_sym_short] = ACTIONS(4939),
    [anon_sym_LBRACK] = ACTIONS(4941),
    [anon_sym_EQ] = ACTIONS(4939),
    [anon_sym_const] = ACTIONS(4939),
    [anon_sym_constexpr] = ACTIONS(4939),
    [anon_sym_volatile] = ACTIONS(4939),
    [anon_sym_restrict] = ACTIONS(4939),
    [anon_sym___restrict__] = ACTIONS(4939),
    [anon_sym__Atomic] = ACTIONS(4939),
    [anon_sym__Noreturn] = ACTIONS(4939),
    [anon_sym_noreturn] = ACTIONS(4939),
    [anon_sym__Nonnull] = ACTIONS(4939),
    [anon_sym_mutable] = ACTIONS(4939),
    [anon_sym_constinit] = ACTIONS(4939),
    [anon_sym_consteval] = ACTIONS(4939),
    [anon_sym_alignas] = ACTIONS(4939),
    [anon_sym__Alignas] = ACTIONS(4939),
    [sym_primitive_type] = ACTIONS(4939),
    [anon_sym_QMARK] = ACTIONS(4941),
    [anon_sym_STAR_EQ] = ACTIONS(4941),
    [anon_sym_SLASH_EQ] = ACTIONS(4941),
    [anon_sym_PERCENT_EQ] = ACTIONS(4941),
    [anon_sym_PLUS_EQ] = ACTIONS(4941),
    [anon_sym_DASH_EQ] = ACTIONS(4941),
    [anon_sym_LT_LT_EQ] = ACTIONS(4941),
    [anon_sym_GT_GT_EQ] = ACTIONS(4941),
    [anon_sym_AMP_EQ] = ACTIONS(4941),
    [anon_sym_CARET_EQ] = ACTIONS(4941),
    [anon_sym_PIPE_EQ] = ACTIONS(4941),
    [anon_sym_and_eq] = ACTIONS(4939),
    [anon_sym_or_eq] = ACTIONS(4939),
    [anon_sym_xor_eq] = ACTIONS(4939),
    [anon_sym_LT_EQ_GT] = ACTIONS(4941),
    [anon_sym_or] = ACTIONS(4939),
    [anon_sym_and] = ACTIONS(4939),
    [anon_sym_bitor] = ACTIONS(4939),
    [anon_sym_xor] = ACTIONS(4939),
    [anon_sym_bitand] = ACTIONS(4939),
    [anon_sym_not_eq] = ACTIONS(4939),
    [anon_sym_DASH_DASH] = ACTIONS(4941),
    [anon_sym_PLUS_PLUS] = ACTIONS(4941),
    [anon_sym_DOT] = ACTIONS(4939),
    [anon_sym_DOT_STAR] = ACTIONS(4941),
    [anon_sym_DASH_GT] = ACTIONS(4939),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4939),
    [anon_sym_decltype] = ACTIONS(4939),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4941),
  },
  [1614] = {
    [sym_identifier] = ACTIONS(2536),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2526),
    [anon_sym_COMMA] = ACTIONS(2526),
    [anon_sym_RPAREN] = ACTIONS(2526),
    [anon_sym_LPAREN2] = ACTIONS(2526),
    [anon_sym_DASH] = ACTIONS(2536),
    [anon_sym_PLUS] = ACTIONS(2536),
    [anon_sym_STAR] = ACTIONS(2536),
    [anon_sym_SLASH] = ACTIONS(2536),
    [anon_sym_PERCENT] = ACTIONS(2536),
    [anon_sym_PIPE_PIPE] = ACTIONS(2526),
    [anon_sym_AMP_AMP] = ACTIONS(2526),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_CARET] = ACTIONS(2536),
    [anon_sym_AMP] = ACTIONS(2536),
    [anon_sym_EQ_EQ] = ACTIONS(2526),
    [anon_sym_BANG_EQ] = ACTIONS(2526),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_EQ] = ACTIONS(2526),
    [anon_sym_LT_EQ] = ACTIONS(2536),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2536),
    [anon_sym___extension__] = ACTIONS(2536),
    [anon_sym___attribute__] = ACTIONS(2536),
    [anon_sym___attribute] = ACTIONS(2536),
    [anon_sym_LBRACE] = ACTIONS(2526),
    [anon_sym_signed] = ACTIONS(2536),
    [anon_sym_unsigned] = ACTIONS(2536),
    [anon_sym_long] = ACTIONS(2536),
    [anon_sym_short] = ACTIONS(2536),
    [anon_sym_LBRACK] = ACTIONS(2526),
    [anon_sym_EQ] = ACTIONS(2536),
    [anon_sym_const] = ACTIONS(2536),
    [anon_sym_constexpr] = ACTIONS(2536),
    [anon_sym_volatile] = ACTIONS(2536),
    [anon_sym_restrict] = ACTIONS(2536),
    [anon_sym___restrict__] = ACTIONS(2536),
    [anon_sym__Atomic] = ACTIONS(2536),
    [anon_sym__Noreturn] = ACTIONS(2536),
    [anon_sym_noreturn] = ACTIONS(2536),
    [anon_sym__Nonnull] = ACTIONS(2536),
    [anon_sym_mutable] = ACTIONS(2536),
    [anon_sym_constinit] = ACTIONS(2536),
    [anon_sym_consteval] = ACTIONS(2536),
    [anon_sym_alignas] = ACTIONS(2536),
    [anon_sym__Alignas] = ACTIONS(2536),
    [sym_primitive_type] = ACTIONS(2536),
    [anon_sym_QMARK] = ACTIONS(2526),
    [anon_sym_STAR_EQ] = ACTIONS(2526),
    [anon_sym_SLASH_EQ] = ACTIONS(2526),
    [anon_sym_PERCENT_EQ] = ACTIONS(2526),
    [anon_sym_PLUS_EQ] = ACTIONS(2526),
    [anon_sym_DASH_EQ] = ACTIONS(2526),
    [anon_sym_LT_LT_EQ] = ACTIONS(2526),
    [anon_sym_GT_GT_EQ] = ACTIONS(2526),
    [anon_sym_AMP_EQ] = ACTIONS(2526),
    [anon_sym_CARET_EQ] = ACTIONS(2526),
    [anon_sym_PIPE_EQ] = ACTIONS(2526),
    [anon_sym_and_eq] = ACTIONS(2536),
    [anon_sym_or_eq] = ACTIONS(2536),
    [anon_sym_xor_eq] = ACTIONS(2536),
    [anon_sym_LT_EQ_GT] = ACTIONS(2526),
    [anon_sym_or] = ACTIONS(2536),
    [anon_sym_and] = ACTIONS(2536),
    [anon_sym_bitor] = ACTIONS(2536),
    [anon_sym_xor] = ACTIONS(2536),
    [anon_sym_bitand] = ACTIONS(2536),
    [anon_sym_not_eq] = ACTIONS(2536),
    [anon_sym_DASH_DASH] = ACTIONS(2526),
    [anon_sym_PLUS_PLUS] = ACTIONS(2526),
    [anon_sym_DOT] = ACTIONS(2536),
    [anon_sym_DOT_STAR] = ACTIONS(2526),
    [anon_sym_DASH_GT] = ACTIONS(2536),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2536),
    [anon_sym_decltype] = ACTIONS(2536),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2526),
  },
  [1615] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1618),
    [sym_identifier] = ACTIONS(4932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4981),
    [anon_sym_COMMA] = ACTIONS(4981),
    [anon_sym_LPAREN2] = ACTIONS(4981),
    [anon_sym_DASH] = ACTIONS(4984),
    [anon_sym_PLUS] = ACTIONS(4984),
    [anon_sym_STAR] = ACTIONS(4984),
    [anon_sym_SLASH] = ACTIONS(4984),
    [anon_sym_PERCENT] = ACTIONS(4984),
    [anon_sym_PIPE_PIPE] = ACTIONS(4981),
    [anon_sym_AMP_AMP] = ACTIONS(4981),
    [anon_sym_PIPE] = ACTIONS(4984),
    [anon_sym_CARET] = ACTIONS(4984),
    [anon_sym_AMP] = ACTIONS(4984),
    [anon_sym_EQ_EQ] = ACTIONS(4981),
    [anon_sym_BANG_EQ] = ACTIONS(4981),
    [anon_sym_GT] = ACTIONS(4984),
    [anon_sym_GT_EQ] = ACTIONS(4984),
    [anon_sym_LT_EQ] = ACTIONS(4984),
    [anon_sym_LT] = ACTIONS(4984),
    [anon_sym_LT_LT] = ACTIONS(4984),
    [anon_sym_GT_GT] = ACTIONS(4984),
    [anon_sym___extension__] = ACTIONS(4932),
    [anon_sym___attribute__] = ACTIONS(4984),
    [anon_sym___attribute] = ACTIONS(4984),
    [anon_sym_LBRACE] = ACTIONS(4981),
    [anon_sym_signed] = ACTIONS(5206),
    [anon_sym_unsigned] = ACTIONS(5206),
    [anon_sym_long] = ACTIONS(5206),
    [anon_sym_short] = ACTIONS(5206),
    [anon_sym_LBRACK] = ACTIONS(4981),
    [anon_sym_EQ] = ACTIONS(4984),
    [anon_sym_const] = ACTIONS(4932),
    [anon_sym_constexpr] = ACTIONS(4932),
    [anon_sym_volatile] = ACTIONS(4932),
    [anon_sym_restrict] = ACTIONS(4932),
    [anon_sym___restrict__] = ACTIONS(4932),
    [anon_sym__Atomic] = ACTIONS(4932),
    [anon_sym__Noreturn] = ACTIONS(4932),
    [anon_sym_noreturn] = ACTIONS(4932),
    [anon_sym__Nonnull] = ACTIONS(4932),
    [anon_sym_mutable] = ACTIONS(4932),
    [anon_sym_constinit] = ACTIONS(4932),
    [anon_sym_consteval] = ACTIONS(4932),
    [anon_sym_alignas] = ACTIONS(4932),
    [anon_sym__Alignas] = ACTIONS(4932),
    [sym_primitive_type] = ACTIONS(4932),
    [anon_sym_QMARK] = ACTIONS(4981),
    [anon_sym_STAR_EQ] = ACTIONS(4981),
    [anon_sym_SLASH_EQ] = ACTIONS(4981),
    [anon_sym_PERCENT_EQ] = ACTIONS(4981),
    [anon_sym_PLUS_EQ] = ACTIONS(4981),
    [anon_sym_DASH_EQ] = ACTIONS(4981),
    [anon_sym_LT_LT_EQ] = ACTIONS(4981),
    [anon_sym_GT_GT_EQ] = ACTIONS(4984),
    [anon_sym_AMP_EQ] = ACTIONS(4981),
    [anon_sym_CARET_EQ] = ACTIONS(4981),
    [anon_sym_PIPE_EQ] = ACTIONS(4981),
    [anon_sym_and_eq] = ACTIONS(4984),
    [anon_sym_or_eq] = ACTIONS(4984),
    [anon_sym_xor_eq] = ACTIONS(4984),
    [anon_sym_LT_EQ_GT] = ACTIONS(4981),
    [anon_sym_or] = ACTIONS(4984),
    [anon_sym_and] = ACTIONS(4984),
    [anon_sym_bitor] = ACTIONS(4984),
    [anon_sym_xor] = ACTIONS(4984),
    [anon_sym_bitand] = ACTIONS(4984),
    [anon_sym_not_eq] = ACTIONS(4984),
    [anon_sym_DASH_DASH] = ACTIONS(4981),
    [anon_sym_PLUS_PLUS] = ACTIONS(4981),
    [anon_sym_DOT] = ACTIONS(4984),
    [anon_sym_DOT_STAR] = ACTIONS(4981),
    [anon_sym_DASH_GT] = ACTIONS(4981),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4984),
    [anon_sym_decltype] = ACTIONS(4984),
    [anon_sym_GT2] = ACTIONS(4981),
  },
  [1616] = {
    [sym_type_qualifier] = STATE(1616),
    [sym_alignas_qualifier] = STATE(1650),
    [aux_sym__type_definition_type_repeat1] = STATE(1616),
    [sym_identifier] = ACTIONS(4906),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4908),
    [anon_sym_COMMA] = ACTIONS(4908),
    [anon_sym_RPAREN] = ACTIONS(4908),
    [anon_sym_LPAREN2] = ACTIONS(4908),
    [anon_sym_DASH] = ACTIONS(4906),
    [anon_sym_PLUS] = ACTIONS(4906),
    [anon_sym_STAR] = ACTIONS(4906),
    [anon_sym_SLASH] = ACTIONS(4906),
    [anon_sym_PERCENT] = ACTIONS(4906),
    [anon_sym_PIPE_PIPE] = ACTIONS(4908),
    [anon_sym_AMP_AMP] = ACTIONS(4908),
    [anon_sym_PIPE] = ACTIONS(4906),
    [anon_sym_CARET] = ACTIONS(4906),
    [anon_sym_AMP] = ACTIONS(4906),
    [anon_sym_EQ_EQ] = ACTIONS(4908),
    [anon_sym_BANG_EQ] = ACTIONS(4908),
    [anon_sym_GT] = ACTIONS(4906),
    [anon_sym_GT_EQ] = ACTIONS(4908),
    [anon_sym_LT_EQ] = ACTIONS(4906),
    [anon_sym_LT] = ACTIONS(4906),
    [anon_sym_LT_LT] = ACTIONS(4906),
    [anon_sym_GT_GT] = ACTIONS(4906),
    [anon_sym___extension__] = ACTIONS(5209),
    [anon_sym___attribute__] = ACTIONS(4906),
    [anon_sym___attribute] = ACTIONS(4906),
    [anon_sym_LBRACE] = ACTIONS(4908),
    [anon_sym_signed] = ACTIONS(4906),
    [anon_sym_unsigned] = ACTIONS(4906),
    [anon_sym_long] = ACTIONS(4906),
    [anon_sym_short] = ACTIONS(4906),
    [anon_sym_LBRACK] = ACTIONS(4908),
    [anon_sym_EQ] = ACTIONS(4906),
    [anon_sym_const] = ACTIONS(5209),
    [anon_sym_constexpr] = ACTIONS(5209),
    [anon_sym_volatile] = ACTIONS(5209),
    [anon_sym_restrict] = ACTIONS(5209),
    [anon_sym___restrict__] = ACTIONS(5209),
    [anon_sym__Atomic] = ACTIONS(5209),
    [anon_sym__Noreturn] = ACTIONS(5209),
    [anon_sym_noreturn] = ACTIONS(5209),
    [anon_sym__Nonnull] = ACTIONS(5209),
    [anon_sym_mutable] = ACTIONS(5209),
    [anon_sym_constinit] = ACTIONS(5209),
    [anon_sym_consteval] = ACTIONS(5209),
    [anon_sym_alignas] = ACTIONS(5212),
    [anon_sym__Alignas] = ACTIONS(5212),
    [sym_primitive_type] = ACTIONS(4906),
    [anon_sym_QMARK] = ACTIONS(4908),
    [anon_sym_STAR_EQ] = ACTIONS(4908),
    [anon_sym_SLASH_EQ] = ACTIONS(4908),
    [anon_sym_PERCENT_EQ] = ACTIONS(4908),
    [anon_sym_PLUS_EQ] = ACTIONS(4908),
    [anon_sym_DASH_EQ] = ACTIONS(4908),
    [anon_sym_LT_LT_EQ] = ACTIONS(4908),
    [anon_sym_GT_GT_EQ] = ACTIONS(4908),
    [anon_sym_AMP_EQ] = ACTIONS(4908),
    [anon_sym_CARET_EQ] = ACTIONS(4908),
    [anon_sym_PIPE_EQ] = ACTIONS(4908),
    [anon_sym_LT_EQ_GT] = ACTIONS(4908),
    [anon_sym_or] = ACTIONS(4906),
    [anon_sym_and] = ACTIONS(4906),
    [anon_sym_bitor] = ACTIONS(4906),
    [anon_sym_xor] = ACTIONS(4906),
    [anon_sym_bitand] = ACTIONS(4906),
    [anon_sym_not_eq] = ACTIONS(4906),
    [anon_sym_DASH_DASH] = ACTIONS(4908),
    [anon_sym_PLUS_PLUS] = ACTIONS(4908),
    [anon_sym_DOT] = ACTIONS(4906),
    [anon_sym_DOT_STAR] = ACTIONS(4908),
    [anon_sym_DASH_GT] = ACTIONS(4906),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4906),
    [anon_sym_decltype] = ACTIONS(4906),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4908),
  },
  [1617] = {
    [sym_type_qualifier] = STATE(1617),
    [sym_alignas_qualifier] = STATE(1651),
    [aux_sym__type_definition_type_repeat1] = STATE(1617),
    [sym_identifier] = ACTIONS(4906),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4908),
    [anon_sym_COMMA] = ACTIONS(4908),
    [anon_sym_RPAREN] = ACTIONS(4908),
    [aux_sym_preproc_if_token2] = ACTIONS(4908),
    [aux_sym_preproc_else_token1] = ACTIONS(4908),
    [aux_sym_preproc_elif_token1] = ACTIONS(4906),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4908),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4908),
    [anon_sym_LPAREN2] = ACTIONS(4908),
    [anon_sym_DASH] = ACTIONS(4906),
    [anon_sym_PLUS] = ACTIONS(4906),
    [anon_sym_STAR] = ACTIONS(4908),
    [anon_sym_SLASH] = ACTIONS(4906),
    [anon_sym_PERCENT] = ACTIONS(4908),
    [anon_sym_PIPE_PIPE] = ACTIONS(4908),
    [anon_sym_AMP_AMP] = ACTIONS(4908),
    [anon_sym_PIPE] = ACTIONS(4906),
    [anon_sym_CARET] = ACTIONS(4908),
    [anon_sym_AMP] = ACTIONS(4906),
    [anon_sym_EQ_EQ] = ACTIONS(4908),
    [anon_sym_BANG_EQ] = ACTIONS(4908),
    [anon_sym_GT] = ACTIONS(4906),
    [anon_sym_GT_EQ] = ACTIONS(4908),
    [anon_sym_LT_EQ] = ACTIONS(4906),
    [anon_sym_LT] = ACTIONS(4906),
    [anon_sym_LT_LT] = ACTIONS(4908),
    [anon_sym_GT_GT] = ACTIONS(4908),
    [anon_sym_SEMI] = ACTIONS(4908),
    [anon_sym___extension__] = ACTIONS(5215),
    [anon_sym___attribute__] = ACTIONS(4906),
    [anon_sym___attribute] = ACTIONS(4906),
    [anon_sym_LBRACE] = ACTIONS(4908),
    [anon_sym_RBRACE] = ACTIONS(4908),
    [anon_sym_signed] = ACTIONS(4906),
    [anon_sym_unsigned] = ACTIONS(4906),
    [anon_sym_long] = ACTIONS(4906),
    [anon_sym_short] = ACTIONS(4906),
    [anon_sym_LBRACK] = ACTIONS(4908),
    [anon_sym_RBRACK] = ACTIONS(4908),
    [anon_sym_const] = ACTIONS(5215),
    [anon_sym_constexpr] = ACTIONS(5215),
    [anon_sym_volatile] = ACTIONS(5215),
    [anon_sym_restrict] = ACTIONS(5215),
    [anon_sym___restrict__] = ACTIONS(5215),
    [anon_sym__Atomic] = ACTIONS(5215),
    [anon_sym__Noreturn] = ACTIONS(5215),
    [anon_sym_noreturn] = ACTIONS(5215),
    [anon_sym__Nonnull] = ACTIONS(5215),
    [anon_sym_mutable] = ACTIONS(5215),
    [anon_sym_constinit] = ACTIONS(5215),
    [anon_sym_consteval] = ACTIONS(5215),
    [anon_sym_alignas] = ACTIONS(5218),
    [anon_sym__Alignas] = ACTIONS(5218),
    [sym_primitive_type] = ACTIONS(4906),
    [anon_sym_COLON] = ACTIONS(4908),
    [anon_sym_QMARK] = ACTIONS(4908),
    [anon_sym_LT_EQ_GT] = ACTIONS(4908),
    [anon_sym_or] = ACTIONS(4906),
    [anon_sym_and] = ACTIONS(4906),
    [anon_sym_bitor] = ACTIONS(4906),
    [anon_sym_xor] = ACTIONS(4906),
    [anon_sym_bitand] = ACTIONS(4906),
    [anon_sym_not_eq] = ACTIONS(4906),
    [anon_sym_DASH_DASH] = ACTIONS(4908),
    [anon_sym_PLUS_PLUS] = ACTIONS(4908),
    [anon_sym_DOT] = ACTIONS(4906),
    [anon_sym_DOT_STAR] = ACTIONS(4908),
    [anon_sym_DASH_GT] = ACTIONS(4908),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4906),
    [anon_sym_decltype] = ACTIONS(4906),
    [anon_sym_final] = ACTIONS(4906),
    [anon_sym_override] = ACTIONS(4906),
    [anon_sym_requires] = ACTIONS(4906),
  },
  [1618] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1618),
    [sym_identifier] = ACTIONS(4932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4934),
    [anon_sym_COMMA] = ACTIONS(4934),
    [anon_sym_LPAREN2] = ACTIONS(4934),
    [anon_sym_DASH] = ACTIONS(4932),
    [anon_sym_PLUS] = ACTIONS(4932),
    [anon_sym_STAR] = ACTIONS(4932),
    [anon_sym_SLASH] = ACTIONS(4932),
    [anon_sym_PERCENT] = ACTIONS(4932),
    [anon_sym_PIPE_PIPE] = ACTIONS(4934),
    [anon_sym_AMP_AMP] = ACTIONS(4934),
    [anon_sym_PIPE] = ACTIONS(4932),
    [anon_sym_CARET] = ACTIONS(4932),
    [anon_sym_AMP] = ACTIONS(4932),
    [anon_sym_EQ_EQ] = ACTIONS(4934),
    [anon_sym_BANG_EQ] = ACTIONS(4934),
    [anon_sym_GT] = ACTIONS(4932),
    [anon_sym_GT_EQ] = ACTIONS(4932),
    [anon_sym_LT_EQ] = ACTIONS(4932),
    [anon_sym_LT] = ACTIONS(4932),
    [anon_sym_LT_LT] = ACTIONS(4932),
    [anon_sym_GT_GT] = ACTIONS(4932),
    [anon_sym___extension__] = ACTIONS(4932),
    [anon_sym___attribute__] = ACTIONS(4932),
    [anon_sym___attribute] = ACTIONS(4932),
    [anon_sym_LBRACE] = ACTIONS(4934),
    [anon_sym_signed] = ACTIONS(5206),
    [anon_sym_unsigned] = ACTIONS(5206),
    [anon_sym_long] = ACTIONS(5206),
    [anon_sym_short] = ACTIONS(5206),
    [anon_sym_LBRACK] = ACTIONS(4934),
    [anon_sym_EQ] = ACTIONS(4932),
    [anon_sym_const] = ACTIONS(4932),
    [anon_sym_constexpr] = ACTIONS(4932),
    [anon_sym_volatile] = ACTIONS(4932),
    [anon_sym_restrict] = ACTIONS(4932),
    [anon_sym___restrict__] = ACTIONS(4932),
    [anon_sym__Atomic] = ACTIONS(4932),
    [anon_sym__Noreturn] = ACTIONS(4932),
    [anon_sym_noreturn] = ACTIONS(4932),
    [anon_sym__Nonnull] = ACTIONS(4932),
    [anon_sym_mutable] = ACTIONS(4932),
    [anon_sym_constinit] = ACTIONS(4932),
    [anon_sym_consteval] = ACTIONS(4932),
    [anon_sym_alignas] = ACTIONS(4932),
    [anon_sym__Alignas] = ACTIONS(4932),
    [sym_primitive_type] = ACTIONS(4932),
    [anon_sym_QMARK] = ACTIONS(4934),
    [anon_sym_STAR_EQ] = ACTIONS(4934),
    [anon_sym_SLASH_EQ] = ACTIONS(4934),
    [anon_sym_PERCENT_EQ] = ACTIONS(4934),
    [anon_sym_PLUS_EQ] = ACTIONS(4934),
    [anon_sym_DASH_EQ] = ACTIONS(4934),
    [anon_sym_LT_LT_EQ] = ACTIONS(4934),
    [anon_sym_GT_GT_EQ] = ACTIONS(4932),
    [anon_sym_AMP_EQ] = ACTIONS(4934),
    [anon_sym_CARET_EQ] = ACTIONS(4934),
    [anon_sym_PIPE_EQ] = ACTIONS(4934),
    [anon_sym_and_eq] = ACTIONS(4932),
    [anon_sym_or_eq] = ACTIONS(4932),
    [anon_sym_xor_eq] = ACTIONS(4932),
    [anon_sym_LT_EQ_GT] = ACTIONS(4934),
    [anon_sym_or] = ACTIONS(4932),
    [anon_sym_and] = ACTIONS(4932),
    [anon_sym_bitor] = ACTIONS(4932),
    [anon_sym_xor] = ACTIONS(4932),
    [anon_sym_bitand] = ACTIONS(4932),
    [anon_sym_not_eq] = ACTIONS(4932),
    [anon_sym_DASH_DASH] = ACTIONS(4934),
    [anon_sym_PLUS_PLUS] = ACTIONS(4934),
    [anon_sym_DOT] = ACTIONS(4932),
    [anon_sym_DOT_STAR] = ACTIONS(4934),
    [anon_sym_DASH_GT] = ACTIONS(4934),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4932),
    [anon_sym_decltype] = ACTIONS(4932),
    [anon_sym_GT2] = ACTIONS(4934),
  },
  [1619] = {
    [sym_identifier] = ACTIONS(2536),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2526),
    [anon_sym_COMMA] = ACTIONS(2526),
    [anon_sym_RPAREN] = ACTIONS(2526),
    [anon_sym_LPAREN2] = ACTIONS(2526),
    [anon_sym_TILDE] = ACTIONS(2526),
    [anon_sym_STAR] = ACTIONS(2526),
    [anon_sym_AMP_AMP] = ACTIONS(2526),
    [anon_sym_AMP] = ACTIONS(2536),
    [anon_sym_SEMI] = ACTIONS(2526),
    [anon_sym___extension__] = ACTIONS(2536),
    [anon_sym_virtual] = ACTIONS(2536),
    [anon_sym_extern] = ACTIONS(2536),
    [anon_sym___attribute__] = ACTIONS(2536),
    [anon_sym___attribute] = ACTIONS(2536),
    [anon_sym_COLON_COLON] = ACTIONS(2526),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2526),
    [anon_sym___declspec] = ACTIONS(2536),
    [anon_sym___based] = ACTIONS(2536),
    [anon_sym___cdecl] = ACTIONS(2536),
    [anon_sym___clrcall] = ACTIONS(2536),
    [anon_sym___stdcall] = ACTIONS(2536),
    [anon_sym___fastcall] = ACTIONS(2536),
    [anon_sym___thiscall] = ACTIONS(2536),
    [anon_sym___vectorcall] = ACTIONS(2536),
    [anon_sym_LBRACE] = ACTIONS(2526),
    [anon_sym_signed] = ACTIONS(2536),
    [anon_sym_unsigned] = ACTIONS(2536),
    [anon_sym_long] = ACTIONS(2536),
    [anon_sym_short] = ACTIONS(2536),
    [anon_sym_LBRACK] = ACTIONS(2536),
    [anon_sym_static] = ACTIONS(2536),
    [anon_sym_EQ] = ACTIONS(2526),
    [anon_sym_register] = ACTIONS(2536),
    [anon_sym_inline] = ACTIONS(2536),
    [anon_sym___inline] = ACTIONS(2536),
    [anon_sym___inline__] = ACTIONS(2536),
    [anon_sym___forceinline] = ACTIONS(2536),
    [anon_sym_thread_local] = ACTIONS(2536),
    [anon_sym___thread] = ACTIONS(2536),
    [anon_sym_const] = ACTIONS(2536),
    [anon_sym_constexpr] = ACTIONS(2536),
    [anon_sym_volatile] = ACTIONS(2536),
    [anon_sym_restrict] = ACTIONS(2536),
    [anon_sym___restrict__] = ACTIONS(2536),
    [anon_sym__Atomic] = ACTIONS(2536),
    [anon_sym__Noreturn] = ACTIONS(2536),
    [anon_sym_noreturn] = ACTIONS(2536),
    [anon_sym__Nonnull] = ACTIONS(2536),
    [anon_sym_mutable] = ACTIONS(2536),
    [anon_sym_constinit] = ACTIONS(2536),
    [anon_sym_consteval] = ACTIONS(2536),
    [anon_sym_alignas] = ACTIONS(2536),
    [anon_sym__Alignas] = ACTIONS(2536),
    [sym_primitive_type] = ACTIONS(2536),
    [anon_sym_enum] = ACTIONS(2536),
    [anon_sym_class] = ACTIONS(2536),
    [anon_sym_struct] = ACTIONS(2536),
    [anon_sym_union] = ACTIONS(2536),
    [anon_sym_asm] = ACTIONS(2536),
    [anon_sym___asm__] = ACTIONS(2536),
    [anon_sym___asm] = ACTIONS(2536),
    [anon_sym_DASH_GT] = ACTIONS(2526),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2536),
    [anon_sym_decltype] = ACTIONS(2536),
    [anon_sym_final] = ACTIONS(2536),
    [anon_sym_override] = ACTIONS(2536),
    [anon_sym_explicit] = ACTIONS(2536),
    [anon_sym_typename] = ACTIONS(2536),
    [anon_sym_template] = ACTIONS(2536),
    [anon_sym_GT2] = ACTIONS(2526),
    [anon_sym_operator] = ACTIONS(2536),
    [anon_sym_try] = ACTIONS(2536),
    [anon_sym_noexcept] = ACTIONS(2536),
    [anon_sym_throw] = ACTIONS(2536),
    [anon_sym_requires] = ACTIONS(2536),
  },
  [1620] = {
    [sym_identifier] = ACTIONS(4939),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4941),
    [anon_sym_COMMA] = ACTIONS(4941),
    [anon_sym_LPAREN2] = ACTIONS(4941),
    [anon_sym_DASH] = ACTIONS(4939),
    [anon_sym_PLUS] = ACTIONS(4939),
    [anon_sym_STAR] = ACTIONS(4939),
    [anon_sym_SLASH] = ACTIONS(4939),
    [anon_sym_PERCENT] = ACTIONS(4939),
    [anon_sym_PIPE_PIPE] = ACTIONS(4941),
    [anon_sym_AMP_AMP] = ACTIONS(4941),
    [anon_sym_PIPE] = ACTIONS(4939),
    [anon_sym_CARET] = ACTIONS(4939),
    [anon_sym_AMP] = ACTIONS(4939),
    [anon_sym_EQ_EQ] = ACTIONS(4941),
    [anon_sym_BANG_EQ] = ACTIONS(4941),
    [anon_sym_GT] = ACTIONS(4939),
    [anon_sym_GT_EQ] = ACTIONS(4939),
    [anon_sym_LT_EQ] = ACTIONS(4939),
    [anon_sym_LT] = ACTIONS(4939),
    [anon_sym_LT_LT] = ACTIONS(4939),
    [anon_sym_GT_GT] = ACTIONS(4939),
    [anon_sym___extension__] = ACTIONS(4939),
    [anon_sym___attribute__] = ACTIONS(4939),
    [anon_sym___attribute] = ACTIONS(4939),
    [anon_sym_LBRACE] = ACTIONS(4941),
    [anon_sym_signed] = ACTIONS(4939),
    [anon_sym_unsigned] = ACTIONS(4939),
    [anon_sym_long] = ACTIONS(4939),
    [anon_sym_short] = ACTIONS(4939),
    [anon_sym_LBRACK] = ACTIONS(4941),
    [anon_sym_EQ] = ACTIONS(4939),
    [anon_sym_const] = ACTIONS(4939),
    [anon_sym_constexpr] = ACTIONS(4939),
    [anon_sym_volatile] = ACTIONS(4939),
    [anon_sym_restrict] = ACTIONS(4939),
    [anon_sym___restrict__] = ACTIONS(4939),
    [anon_sym__Atomic] = ACTIONS(4939),
    [anon_sym__Noreturn] = ACTIONS(4939),
    [anon_sym_noreturn] = ACTIONS(4939),
    [anon_sym__Nonnull] = ACTIONS(4939),
    [anon_sym_mutable] = ACTIONS(4939),
    [anon_sym_constinit] = ACTIONS(4939),
    [anon_sym_consteval] = ACTIONS(4939),
    [anon_sym_alignas] = ACTIONS(4939),
    [anon_sym__Alignas] = ACTIONS(4939),
    [sym_primitive_type] = ACTIONS(4939),
    [anon_sym_QMARK] = ACTIONS(4941),
    [anon_sym_STAR_EQ] = ACTIONS(4941),
    [anon_sym_SLASH_EQ] = ACTIONS(4941),
    [anon_sym_PERCENT_EQ] = ACTIONS(4941),
    [anon_sym_PLUS_EQ] = ACTIONS(4941),
    [anon_sym_DASH_EQ] = ACTIONS(4941),
    [anon_sym_LT_LT_EQ] = ACTIONS(4941),
    [anon_sym_GT_GT_EQ] = ACTIONS(4939),
    [anon_sym_AMP_EQ] = ACTIONS(4941),
    [anon_sym_CARET_EQ] = ACTIONS(4941),
    [anon_sym_PIPE_EQ] = ACTIONS(4941),
    [anon_sym_and_eq] = ACTIONS(4939),
    [anon_sym_or_eq] = ACTIONS(4939),
    [anon_sym_xor_eq] = ACTIONS(4939),
    [anon_sym_LT_EQ_GT] = ACTIONS(4941),
    [anon_sym_or] = ACTIONS(4939),
    [anon_sym_and] = ACTIONS(4939),
    [anon_sym_bitor] = ACTIONS(4939),
    [anon_sym_xor] = ACTIONS(4939),
    [anon_sym_bitand] = ACTIONS(4939),
    [anon_sym_not_eq] = ACTIONS(4939),
    [anon_sym_DASH_DASH] = ACTIONS(4941),
    [anon_sym_PLUS_PLUS] = ACTIONS(4941),
    [anon_sym_DOT] = ACTIONS(4939),
    [anon_sym_DOT_STAR] = ACTIONS(4941),
    [anon_sym_DASH_GT] = ACTIONS(4941),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4939),
    [anon_sym_decltype] = ACTIONS(4939),
    [anon_sym_GT2] = ACTIONS(4941),
  },
  [1621] = {
    [sym__declaration_modifiers] = STATE(2045),
    [sym__declaration_specifiers] = STATE(3892),
    [sym_attribute_specifier] = STATE(2045),
    [sym_attribute_declaration] = STATE(2045),
    [sym_ms_declspec_modifier] = STATE(2045),
    [sym_storage_class_specifier] = STATE(2045),
    [sym_type_qualifier] = STATE(2045),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_parameter_declaration] = STATE(7120),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_dependent_type] = STATE(2383),
    [sym_type_parameter_declaration] = STATE(7120),
    [sym_variadic_type_parameter_declaration] = STATE(7120),
    [sym_optional_type_parameter_declaration] = STATE(7120),
    [sym_template_template_parameter_declaration] = STATE(7120),
    [sym_optional_parameter_declaration] = STATE(7120),
    [sym_variadic_parameter_declaration] = STATE(7120),
    [sym_template_type] = STATE(2336),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(6511),
    [sym_qualified_type_identifier] = STATE(2978),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2045),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(4869),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(1851),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4879),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(1857),
    [anon_sym_class] = ACTIONS(5221),
    [anon_sym_struct] = ACTIONS(1861),
    [anon_sym_union] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(5223),
    [anon_sym_template] = ACTIONS(5225),
    [anon_sym_GT2] = ACTIONS(5227),
  },
  [1622] = {
    [sym__declaration_modifiers] = STATE(2045),
    [sym__declaration_specifiers] = STATE(3892),
    [sym_attribute_specifier] = STATE(2045),
    [sym_attribute_declaration] = STATE(2045),
    [sym_ms_declspec_modifier] = STATE(2045),
    [sym_storage_class_specifier] = STATE(2045),
    [sym_type_qualifier] = STATE(2045),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_parameter_declaration] = STATE(7129),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_dependent_type] = STATE(2383),
    [sym_type_parameter_declaration] = STATE(7129),
    [sym_variadic_type_parameter_declaration] = STATE(7129),
    [sym_optional_type_parameter_declaration] = STATE(7129),
    [sym_template_template_parameter_declaration] = STATE(7129),
    [sym_optional_parameter_declaration] = STATE(7129),
    [sym_variadic_parameter_declaration] = STATE(7129),
    [sym_template_type] = STATE(2336),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(6511),
    [sym_qualified_type_identifier] = STATE(2978),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2045),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(4869),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(1851),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4879),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(1857),
    [anon_sym_class] = ACTIONS(5221),
    [anon_sym_struct] = ACTIONS(1861),
    [anon_sym_union] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(5223),
    [anon_sym_template] = ACTIONS(5225),
    [anon_sym_GT2] = ACTIONS(5229),
  },
  [1623] = {
    [sym_identifier] = ACTIONS(4855),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4857),
    [anon_sym_COMMA] = ACTIONS(4857),
    [anon_sym_RPAREN] = ACTIONS(4857),
    [anon_sym_LPAREN2] = ACTIONS(4859),
    [anon_sym_TILDE] = ACTIONS(4862),
    [anon_sym_DASH] = ACTIONS(4864),
    [anon_sym_PLUS] = ACTIONS(4864),
    [anon_sym_STAR] = ACTIONS(4859),
    [anon_sym_SLASH] = ACTIONS(4864),
    [anon_sym_PERCENT] = ACTIONS(4857),
    [anon_sym_PIPE_PIPE] = ACTIONS(4857),
    [anon_sym_AMP_AMP] = ACTIONS(4859),
    [anon_sym_PIPE] = ACTIONS(4864),
    [anon_sym_CARET] = ACTIONS(4857),
    [anon_sym_AMP] = ACTIONS(4866),
    [anon_sym_EQ_EQ] = ACTIONS(4857),
    [anon_sym_BANG_EQ] = ACTIONS(4857),
    [anon_sym_GT] = ACTIONS(4864),
    [anon_sym_GT_EQ] = ACTIONS(4857),
    [anon_sym_LT_EQ] = ACTIONS(4864),
    [anon_sym_LT] = ACTIONS(4864),
    [anon_sym_LT_LT] = ACTIONS(4857),
    [anon_sym_GT_GT] = ACTIONS(4857),
    [anon_sym_SEMI] = ACTIONS(4857),
    [anon_sym___extension__] = ACTIONS(4855),
    [anon_sym_virtual] = ACTIONS(4855),
    [anon_sym_extern] = ACTIONS(4855),
    [anon_sym___attribute__] = ACTIONS(4855),
    [anon_sym___attribute] = ACTIONS(4855),
    [anon_sym_COLON_COLON] = ACTIONS(4862),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4862),
    [anon_sym___declspec] = ACTIONS(4855),
    [anon_sym___based] = ACTIONS(4855),
    [anon_sym_LBRACE] = ACTIONS(4862),
    [anon_sym_RBRACE] = ACTIONS(4857),
    [anon_sym_LBRACK] = ACTIONS(4866),
    [anon_sym_static] = ACTIONS(4855),
    [anon_sym_register] = ACTIONS(4855),
    [anon_sym_inline] = ACTIONS(4855),
    [anon_sym___inline] = ACTIONS(4855),
    [anon_sym___inline__] = ACTIONS(4855),
    [anon_sym___forceinline] = ACTIONS(4855),
    [anon_sym_thread_local] = ACTIONS(4855),
    [anon_sym___thread] = ACTIONS(4855),
    [anon_sym_const] = ACTIONS(4855),
    [anon_sym_constexpr] = ACTIONS(4855),
    [anon_sym_volatile] = ACTIONS(4855),
    [anon_sym_restrict] = ACTIONS(4855),
    [anon_sym___restrict__] = ACTIONS(4855),
    [anon_sym__Atomic] = ACTIONS(4855),
    [anon_sym__Noreturn] = ACTIONS(4855),
    [anon_sym_noreturn] = ACTIONS(4855),
    [anon_sym__Nonnull] = ACTIONS(4855),
    [anon_sym_mutable] = ACTIONS(4855),
    [anon_sym_constinit] = ACTIONS(4855),
    [anon_sym_consteval] = ACTIONS(4855),
    [anon_sym_alignas] = ACTIONS(4855),
    [anon_sym__Alignas] = ACTIONS(4855),
    [anon_sym_QMARK] = ACTIONS(4857),
    [anon_sym_LT_EQ_GT] = ACTIONS(4857),
    [anon_sym_or] = ACTIONS(4864),
    [anon_sym_and] = ACTIONS(4864),
    [anon_sym_bitor] = ACTIONS(4864),
    [anon_sym_xor] = ACTIONS(4864),
    [anon_sym_bitand] = ACTIONS(4864),
    [anon_sym_not_eq] = ACTIONS(4864),
    [anon_sym_DASH_DASH] = ACTIONS(4857),
    [anon_sym_PLUS_PLUS] = ACTIONS(4857),
    [anon_sym_DOT] = ACTIONS(4864),
    [anon_sym_DOT_STAR] = ACTIONS(4857),
    [anon_sym_DASH_GT] = ACTIONS(4857),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4855),
    [anon_sym_decltype] = ACTIONS(4855),
    [anon_sym_template] = ACTIONS(4855),
    [anon_sym_operator] = ACTIONS(4855),
  },
  [1624] = {
    [sym_identifier] = ACTIONS(2536),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2526),
    [anon_sym_COMMA] = ACTIONS(2526),
    [anon_sym_LPAREN2] = ACTIONS(2526),
    [anon_sym_DASH] = ACTIONS(2536),
    [anon_sym_PLUS] = ACTIONS(2536),
    [anon_sym_STAR] = ACTIONS(2536),
    [anon_sym_SLASH] = ACTIONS(2536),
    [anon_sym_PERCENT] = ACTIONS(2536),
    [anon_sym_PIPE_PIPE] = ACTIONS(2526),
    [anon_sym_AMP_AMP] = ACTIONS(2526),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_CARET] = ACTIONS(2536),
    [anon_sym_AMP] = ACTIONS(2536),
    [anon_sym_EQ_EQ] = ACTIONS(2526),
    [anon_sym_BANG_EQ] = ACTIONS(2526),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_EQ] = ACTIONS(2536),
    [anon_sym_LT_EQ] = ACTIONS(2536),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2536),
    [anon_sym___extension__] = ACTIONS(2536),
    [anon_sym___attribute__] = ACTIONS(2536),
    [anon_sym___attribute] = ACTIONS(2536),
    [anon_sym_LBRACE] = ACTIONS(2526),
    [anon_sym_signed] = ACTIONS(2536),
    [anon_sym_unsigned] = ACTIONS(2536),
    [anon_sym_long] = ACTIONS(2536),
    [anon_sym_short] = ACTIONS(2536),
    [anon_sym_LBRACK] = ACTIONS(2526),
    [anon_sym_EQ] = ACTIONS(2536),
    [anon_sym_const] = ACTIONS(2536),
    [anon_sym_constexpr] = ACTIONS(2536),
    [anon_sym_volatile] = ACTIONS(2536),
    [anon_sym_restrict] = ACTIONS(2536),
    [anon_sym___restrict__] = ACTIONS(2536),
    [anon_sym__Atomic] = ACTIONS(2536),
    [anon_sym__Noreturn] = ACTIONS(2536),
    [anon_sym_noreturn] = ACTIONS(2536),
    [anon_sym__Nonnull] = ACTIONS(2536),
    [anon_sym_mutable] = ACTIONS(2536),
    [anon_sym_constinit] = ACTIONS(2536),
    [anon_sym_consteval] = ACTIONS(2536),
    [anon_sym_alignas] = ACTIONS(2536),
    [anon_sym__Alignas] = ACTIONS(2536),
    [sym_primitive_type] = ACTIONS(2536),
    [anon_sym_QMARK] = ACTIONS(2526),
    [anon_sym_STAR_EQ] = ACTIONS(2526),
    [anon_sym_SLASH_EQ] = ACTIONS(2526),
    [anon_sym_PERCENT_EQ] = ACTIONS(2526),
    [anon_sym_PLUS_EQ] = ACTIONS(2526),
    [anon_sym_DASH_EQ] = ACTIONS(2526),
    [anon_sym_LT_LT_EQ] = ACTIONS(2526),
    [anon_sym_GT_GT_EQ] = ACTIONS(2536),
    [anon_sym_AMP_EQ] = ACTIONS(2526),
    [anon_sym_CARET_EQ] = ACTIONS(2526),
    [anon_sym_PIPE_EQ] = ACTIONS(2526),
    [anon_sym_and_eq] = ACTIONS(2536),
    [anon_sym_or_eq] = ACTIONS(2536),
    [anon_sym_xor_eq] = ACTIONS(2536),
    [anon_sym_LT_EQ_GT] = ACTIONS(2526),
    [anon_sym_or] = ACTIONS(2536),
    [anon_sym_and] = ACTIONS(2536),
    [anon_sym_bitor] = ACTIONS(2536),
    [anon_sym_xor] = ACTIONS(2536),
    [anon_sym_bitand] = ACTIONS(2536),
    [anon_sym_not_eq] = ACTIONS(2536),
    [anon_sym_DASH_DASH] = ACTIONS(2526),
    [anon_sym_PLUS_PLUS] = ACTIONS(2526),
    [anon_sym_DOT] = ACTIONS(2536),
    [anon_sym_DOT_STAR] = ACTIONS(2526),
    [anon_sym_DASH_GT] = ACTIONS(2526),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2536),
    [anon_sym_decltype] = ACTIONS(2536),
    [anon_sym_GT2] = ACTIONS(2526),
  },
  [1625] = {
    [sym_identifier] = ACTIONS(4939),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4941),
    [anon_sym_COMMA] = ACTIONS(4941),
    [anon_sym_RPAREN] = ACTIONS(4941),
    [anon_sym_LPAREN2] = ACTIONS(4941),
    [anon_sym_TILDE] = ACTIONS(4941),
    [anon_sym_STAR] = ACTIONS(4941),
    [anon_sym_AMP_AMP] = ACTIONS(4941),
    [anon_sym_AMP] = ACTIONS(4939),
    [anon_sym_SEMI] = ACTIONS(4941),
    [anon_sym___extension__] = ACTIONS(4939),
    [anon_sym_virtual] = ACTIONS(4939),
    [anon_sym_extern] = ACTIONS(4939),
    [anon_sym___attribute__] = ACTIONS(4939),
    [anon_sym___attribute] = ACTIONS(4939),
    [anon_sym_COLON_COLON] = ACTIONS(4941),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4941),
    [anon_sym___declspec] = ACTIONS(4939),
    [anon_sym___based] = ACTIONS(4939),
    [anon_sym___cdecl] = ACTIONS(4939),
    [anon_sym___clrcall] = ACTIONS(4939),
    [anon_sym___stdcall] = ACTIONS(4939),
    [anon_sym___fastcall] = ACTIONS(4939),
    [anon_sym___thiscall] = ACTIONS(4939),
    [anon_sym___vectorcall] = ACTIONS(4939),
    [anon_sym_LBRACE] = ACTIONS(4941),
    [anon_sym_signed] = ACTIONS(4939),
    [anon_sym_unsigned] = ACTIONS(4939),
    [anon_sym_long] = ACTIONS(4939),
    [anon_sym_short] = ACTIONS(4939),
    [anon_sym_LBRACK] = ACTIONS(4939),
    [anon_sym_static] = ACTIONS(4939),
    [anon_sym_EQ] = ACTIONS(4941),
    [anon_sym_register] = ACTIONS(4939),
    [anon_sym_inline] = ACTIONS(4939),
    [anon_sym___inline] = ACTIONS(4939),
    [anon_sym___inline__] = ACTIONS(4939),
    [anon_sym___forceinline] = ACTIONS(4939),
    [anon_sym_thread_local] = ACTIONS(4939),
    [anon_sym___thread] = ACTIONS(4939),
    [anon_sym_const] = ACTIONS(4939),
    [anon_sym_constexpr] = ACTIONS(4939),
    [anon_sym_volatile] = ACTIONS(4939),
    [anon_sym_restrict] = ACTIONS(4939),
    [anon_sym___restrict__] = ACTIONS(4939),
    [anon_sym__Atomic] = ACTIONS(4939),
    [anon_sym__Noreturn] = ACTIONS(4939),
    [anon_sym_noreturn] = ACTIONS(4939),
    [anon_sym__Nonnull] = ACTIONS(4939),
    [anon_sym_mutable] = ACTIONS(4939),
    [anon_sym_constinit] = ACTIONS(4939),
    [anon_sym_consteval] = ACTIONS(4939),
    [anon_sym_alignas] = ACTIONS(4939),
    [anon_sym__Alignas] = ACTIONS(4939),
    [sym_primitive_type] = ACTIONS(4939),
    [anon_sym_enum] = ACTIONS(4939),
    [anon_sym_class] = ACTIONS(4939),
    [anon_sym_struct] = ACTIONS(4939),
    [anon_sym_union] = ACTIONS(4939),
    [anon_sym_asm] = ACTIONS(4939),
    [anon_sym___asm__] = ACTIONS(4939),
    [anon_sym___asm] = ACTIONS(4939),
    [anon_sym_DASH_GT] = ACTIONS(4941),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4939),
    [anon_sym_decltype] = ACTIONS(4939),
    [anon_sym_final] = ACTIONS(4939),
    [anon_sym_override] = ACTIONS(4939),
    [anon_sym_explicit] = ACTIONS(4939),
    [anon_sym_typename] = ACTIONS(4939),
    [anon_sym_template] = ACTIONS(4939),
    [anon_sym_GT2] = ACTIONS(4941),
    [anon_sym_operator] = ACTIONS(4939),
    [anon_sym_try] = ACTIONS(4939),
    [anon_sym_noexcept] = ACTIONS(4939),
    [anon_sym_throw] = ACTIONS(4939),
    [anon_sym_requires] = ACTIONS(4939),
  },
  [1626] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4816),
    [anon_sym_COMMA] = ACTIONS(4816),
    [anon_sym_RPAREN] = ACTIONS(4816),
    [anon_sym_LPAREN2] = ACTIONS(4816),
    [anon_sym_DASH] = ACTIONS(4814),
    [anon_sym_PLUS] = ACTIONS(4814),
    [anon_sym_STAR] = ACTIONS(4814),
    [anon_sym_SLASH] = ACTIONS(4814),
    [anon_sym_PERCENT] = ACTIONS(4814),
    [anon_sym_PIPE_PIPE] = ACTIONS(4816),
    [anon_sym_AMP_AMP] = ACTIONS(4816),
    [anon_sym_PIPE] = ACTIONS(4814),
    [anon_sym_CARET] = ACTIONS(4814),
    [anon_sym_AMP] = ACTIONS(4814),
    [anon_sym_EQ_EQ] = ACTIONS(4816),
    [anon_sym_BANG_EQ] = ACTIONS(4816),
    [anon_sym_GT] = ACTIONS(4814),
    [anon_sym_GT_EQ] = ACTIONS(4816),
    [anon_sym_LT_EQ] = ACTIONS(4814),
    [anon_sym_LT] = ACTIONS(4814),
    [anon_sym_LT_LT] = ACTIONS(4814),
    [anon_sym_GT_GT] = ACTIONS(4814),
    [anon_sym___extension__] = ACTIONS(4816),
    [anon_sym___attribute__] = ACTIONS(4816),
    [anon_sym___attribute] = ACTIONS(4814),
    [anon_sym_COLON_COLON] = ACTIONS(4816),
    [anon_sym_LBRACE] = ACTIONS(4816),
    [anon_sym_LBRACK] = ACTIONS(4816),
    [anon_sym_EQ] = ACTIONS(4814),
    [anon_sym_const] = ACTIONS(4814),
    [anon_sym_constexpr] = ACTIONS(4816),
    [anon_sym_volatile] = ACTIONS(4816),
    [anon_sym_restrict] = ACTIONS(4816),
    [anon_sym___restrict__] = ACTIONS(4816),
    [anon_sym__Atomic] = ACTIONS(4816),
    [anon_sym__Noreturn] = ACTIONS(4816),
    [anon_sym_noreturn] = ACTIONS(4816),
    [anon_sym__Nonnull] = ACTIONS(4816),
    [anon_sym_mutable] = ACTIONS(4816),
    [anon_sym_constinit] = ACTIONS(4816),
    [anon_sym_consteval] = ACTIONS(4816),
    [anon_sym_alignas] = ACTIONS(4816),
    [anon_sym__Alignas] = ACTIONS(4816),
    [anon_sym_COLON] = ACTIONS(4814),
    [anon_sym_QMARK] = ACTIONS(4816),
    [anon_sym_STAR_EQ] = ACTIONS(4816),
    [anon_sym_SLASH_EQ] = ACTIONS(4816),
    [anon_sym_PERCENT_EQ] = ACTIONS(4816),
    [anon_sym_PLUS_EQ] = ACTIONS(4816),
    [anon_sym_DASH_EQ] = ACTIONS(4816),
    [anon_sym_LT_LT_EQ] = ACTIONS(4816),
    [anon_sym_GT_GT_EQ] = ACTIONS(4816),
    [anon_sym_AMP_EQ] = ACTIONS(4816),
    [anon_sym_CARET_EQ] = ACTIONS(4816),
    [anon_sym_PIPE_EQ] = ACTIONS(4816),
    [anon_sym_and_eq] = ACTIONS(4816),
    [anon_sym_or_eq] = ACTIONS(4816),
    [anon_sym_xor_eq] = ACTIONS(4816),
    [anon_sym_LT_EQ_GT] = ACTIONS(4816),
    [anon_sym_or] = ACTIONS(4814),
    [anon_sym_and] = ACTIONS(4814),
    [anon_sym_bitor] = ACTIONS(4816),
    [anon_sym_xor] = ACTIONS(4814),
    [anon_sym_bitand] = ACTIONS(4816),
    [anon_sym_not_eq] = ACTIONS(4816),
    [anon_sym_DASH_DASH] = ACTIONS(4816),
    [anon_sym_PLUS_PLUS] = ACTIONS(4816),
    [anon_sym_DOT] = ACTIONS(4814),
    [anon_sym_DOT_STAR] = ACTIONS(4816),
    [anon_sym_DASH_GT] = ACTIONS(4814),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4816),
    [anon_sym_decltype] = ACTIONS(4816),
    [anon_sym_final] = ACTIONS(4816),
    [anon_sym_override] = ACTIONS(4816),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4816),
  },
  [1627] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4832),
    [anon_sym_COMMA] = ACTIONS(4832),
    [anon_sym_RPAREN] = ACTIONS(4832),
    [anon_sym_LPAREN2] = ACTIONS(4832),
    [anon_sym_DASH] = ACTIONS(4830),
    [anon_sym_PLUS] = ACTIONS(4830),
    [anon_sym_STAR] = ACTIONS(4830),
    [anon_sym_SLASH] = ACTIONS(4830),
    [anon_sym_PERCENT] = ACTIONS(4830),
    [anon_sym_PIPE_PIPE] = ACTIONS(4832),
    [anon_sym_AMP_AMP] = ACTIONS(4832),
    [anon_sym_PIPE] = ACTIONS(4830),
    [anon_sym_CARET] = ACTIONS(4830),
    [anon_sym_AMP] = ACTIONS(4830),
    [anon_sym_EQ_EQ] = ACTIONS(4832),
    [anon_sym_BANG_EQ] = ACTIONS(4832),
    [anon_sym_GT] = ACTIONS(4830),
    [anon_sym_GT_EQ] = ACTIONS(4832),
    [anon_sym_LT_EQ] = ACTIONS(4830),
    [anon_sym_LT] = ACTIONS(4830),
    [anon_sym_LT_LT] = ACTIONS(4830),
    [anon_sym_GT_GT] = ACTIONS(4830),
    [anon_sym___extension__] = ACTIONS(4832),
    [anon_sym___attribute__] = ACTIONS(4832),
    [anon_sym___attribute] = ACTIONS(4830),
    [anon_sym_COLON_COLON] = ACTIONS(4832),
    [anon_sym_LBRACE] = ACTIONS(4832),
    [anon_sym_LBRACK] = ACTIONS(4832),
    [anon_sym_EQ] = ACTIONS(4830),
    [anon_sym_const] = ACTIONS(4830),
    [anon_sym_constexpr] = ACTIONS(4832),
    [anon_sym_volatile] = ACTIONS(4832),
    [anon_sym_restrict] = ACTIONS(4832),
    [anon_sym___restrict__] = ACTIONS(4832),
    [anon_sym__Atomic] = ACTIONS(4832),
    [anon_sym__Noreturn] = ACTIONS(4832),
    [anon_sym_noreturn] = ACTIONS(4832),
    [anon_sym__Nonnull] = ACTIONS(4832),
    [anon_sym_mutable] = ACTIONS(4832),
    [anon_sym_constinit] = ACTIONS(4832),
    [anon_sym_consteval] = ACTIONS(4832),
    [anon_sym_alignas] = ACTIONS(4832),
    [anon_sym__Alignas] = ACTIONS(4832),
    [anon_sym_COLON] = ACTIONS(4830),
    [anon_sym_QMARK] = ACTIONS(4832),
    [anon_sym_STAR_EQ] = ACTIONS(4832),
    [anon_sym_SLASH_EQ] = ACTIONS(4832),
    [anon_sym_PERCENT_EQ] = ACTIONS(4832),
    [anon_sym_PLUS_EQ] = ACTIONS(4832),
    [anon_sym_DASH_EQ] = ACTIONS(4832),
    [anon_sym_LT_LT_EQ] = ACTIONS(4832),
    [anon_sym_GT_GT_EQ] = ACTIONS(4832),
    [anon_sym_AMP_EQ] = ACTIONS(4832),
    [anon_sym_CARET_EQ] = ACTIONS(4832),
    [anon_sym_PIPE_EQ] = ACTIONS(4832),
    [anon_sym_and_eq] = ACTIONS(4832),
    [anon_sym_or_eq] = ACTIONS(4832),
    [anon_sym_xor_eq] = ACTIONS(4832),
    [anon_sym_LT_EQ_GT] = ACTIONS(4832),
    [anon_sym_or] = ACTIONS(4830),
    [anon_sym_and] = ACTIONS(4830),
    [anon_sym_bitor] = ACTIONS(4832),
    [anon_sym_xor] = ACTIONS(4830),
    [anon_sym_bitand] = ACTIONS(4832),
    [anon_sym_not_eq] = ACTIONS(4832),
    [anon_sym_DASH_DASH] = ACTIONS(4832),
    [anon_sym_PLUS_PLUS] = ACTIONS(4832),
    [anon_sym_DOT] = ACTIONS(4830),
    [anon_sym_DOT_STAR] = ACTIONS(4832),
    [anon_sym_DASH_GT] = ACTIONS(4830),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4832),
    [anon_sym_decltype] = ACTIONS(4832),
    [anon_sym_final] = ACTIONS(4832),
    [anon_sym_override] = ACTIONS(4832),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4832),
  },
  [1628] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1628),
    [sym_identifier] = ACTIONS(4932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4934),
    [anon_sym_COMMA] = ACTIONS(4934),
    [anon_sym_RPAREN] = ACTIONS(4934),
    [aux_sym_preproc_if_token2] = ACTIONS(4934),
    [aux_sym_preproc_else_token1] = ACTIONS(4934),
    [aux_sym_preproc_elif_token1] = ACTIONS(4932),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4934),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4934),
    [anon_sym_LPAREN2] = ACTIONS(4934),
    [anon_sym_DASH] = ACTIONS(4932),
    [anon_sym_PLUS] = ACTIONS(4932),
    [anon_sym_STAR] = ACTIONS(4934),
    [anon_sym_SLASH] = ACTIONS(4932),
    [anon_sym_PERCENT] = ACTIONS(4934),
    [anon_sym_PIPE_PIPE] = ACTIONS(4934),
    [anon_sym_AMP_AMP] = ACTIONS(4934),
    [anon_sym_PIPE] = ACTIONS(4932),
    [anon_sym_CARET] = ACTIONS(4934),
    [anon_sym_AMP] = ACTIONS(4932),
    [anon_sym_EQ_EQ] = ACTIONS(4934),
    [anon_sym_BANG_EQ] = ACTIONS(4934),
    [anon_sym_GT] = ACTIONS(4932),
    [anon_sym_GT_EQ] = ACTIONS(4934),
    [anon_sym_LT_EQ] = ACTIONS(4932),
    [anon_sym_LT] = ACTIONS(4932),
    [anon_sym_LT_LT] = ACTIONS(4934),
    [anon_sym_GT_GT] = ACTIONS(4934),
    [anon_sym_SEMI] = ACTIONS(4934),
    [anon_sym___extension__] = ACTIONS(4932),
    [anon_sym___attribute__] = ACTIONS(4932),
    [anon_sym___attribute] = ACTIONS(4932),
    [anon_sym_LBRACE] = ACTIONS(4934),
    [anon_sym_RBRACE] = ACTIONS(4934),
    [anon_sym_signed] = ACTIONS(5231),
    [anon_sym_unsigned] = ACTIONS(5231),
    [anon_sym_long] = ACTIONS(5231),
    [anon_sym_short] = ACTIONS(5231),
    [anon_sym_LBRACK] = ACTIONS(4934),
    [anon_sym_RBRACK] = ACTIONS(4934),
    [anon_sym_const] = ACTIONS(4932),
    [anon_sym_constexpr] = ACTIONS(4932),
    [anon_sym_volatile] = ACTIONS(4932),
    [anon_sym_restrict] = ACTIONS(4932),
    [anon_sym___restrict__] = ACTIONS(4932),
    [anon_sym__Atomic] = ACTIONS(4932),
    [anon_sym__Noreturn] = ACTIONS(4932),
    [anon_sym_noreturn] = ACTIONS(4932),
    [anon_sym__Nonnull] = ACTIONS(4932),
    [anon_sym_mutable] = ACTIONS(4932),
    [anon_sym_constinit] = ACTIONS(4932),
    [anon_sym_consteval] = ACTIONS(4932),
    [anon_sym_alignas] = ACTIONS(4932),
    [anon_sym__Alignas] = ACTIONS(4932),
    [sym_primitive_type] = ACTIONS(4932),
    [anon_sym_COLON] = ACTIONS(4934),
    [anon_sym_QMARK] = ACTIONS(4934),
    [anon_sym_LT_EQ_GT] = ACTIONS(4934),
    [anon_sym_or] = ACTIONS(4932),
    [anon_sym_and] = ACTIONS(4932),
    [anon_sym_bitor] = ACTIONS(4932),
    [anon_sym_xor] = ACTIONS(4932),
    [anon_sym_bitand] = ACTIONS(4932),
    [anon_sym_not_eq] = ACTIONS(4932),
    [anon_sym_DASH_DASH] = ACTIONS(4934),
    [anon_sym_PLUS_PLUS] = ACTIONS(4934),
    [anon_sym_DOT] = ACTIONS(4932),
    [anon_sym_DOT_STAR] = ACTIONS(4934),
    [anon_sym_DASH_GT] = ACTIONS(4934),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4932),
    [anon_sym_decltype] = ACTIONS(4932),
    [anon_sym_final] = ACTIONS(4932),
    [anon_sym_override] = ACTIONS(4932),
    [anon_sym_requires] = ACTIONS(4932),
  },
  [1629] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4812),
    [anon_sym_COMMA] = ACTIONS(4812),
    [anon_sym_RPAREN] = ACTIONS(4812),
    [anon_sym_LPAREN2] = ACTIONS(4812),
    [anon_sym_DASH] = ACTIONS(4810),
    [anon_sym_PLUS] = ACTIONS(4810),
    [anon_sym_STAR] = ACTIONS(4810),
    [anon_sym_SLASH] = ACTIONS(4810),
    [anon_sym_PERCENT] = ACTIONS(4810),
    [anon_sym_PIPE_PIPE] = ACTIONS(4812),
    [anon_sym_AMP_AMP] = ACTIONS(4812),
    [anon_sym_PIPE] = ACTIONS(4810),
    [anon_sym_CARET] = ACTIONS(4810),
    [anon_sym_AMP] = ACTIONS(4810),
    [anon_sym_EQ_EQ] = ACTIONS(4812),
    [anon_sym_BANG_EQ] = ACTIONS(4812),
    [anon_sym_GT] = ACTIONS(4810),
    [anon_sym_GT_EQ] = ACTIONS(4812),
    [anon_sym_LT_EQ] = ACTIONS(4810),
    [anon_sym_LT] = ACTIONS(4810),
    [anon_sym_LT_LT] = ACTIONS(4810),
    [anon_sym_GT_GT] = ACTIONS(4810),
    [anon_sym___extension__] = ACTIONS(4812),
    [anon_sym___attribute__] = ACTIONS(4812),
    [anon_sym___attribute] = ACTIONS(4810),
    [anon_sym_COLON_COLON] = ACTIONS(4812),
    [anon_sym_LBRACE] = ACTIONS(4812),
    [anon_sym_LBRACK] = ACTIONS(4812),
    [anon_sym_EQ] = ACTIONS(4810),
    [anon_sym_const] = ACTIONS(4810),
    [anon_sym_constexpr] = ACTIONS(4812),
    [anon_sym_volatile] = ACTIONS(4812),
    [anon_sym_restrict] = ACTIONS(4812),
    [anon_sym___restrict__] = ACTIONS(4812),
    [anon_sym__Atomic] = ACTIONS(4812),
    [anon_sym__Noreturn] = ACTIONS(4812),
    [anon_sym_noreturn] = ACTIONS(4812),
    [anon_sym__Nonnull] = ACTIONS(4812),
    [anon_sym_mutable] = ACTIONS(4812),
    [anon_sym_constinit] = ACTIONS(4812),
    [anon_sym_consteval] = ACTIONS(4812),
    [anon_sym_alignas] = ACTIONS(4812),
    [anon_sym__Alignas] = ACTIONS(4812),
    [anon_sym_COLON] = ACTIONS(4810),
    [anon_sym_QMARK] = ACTIONS(4812),
    [anon_sym_STAR_EQ] = ACTIONS(4812),
    [anon_sym_SLASH_EQ] = ACTIONS(4812),
    [anon_sym_PERCENT_EQ] = ACTIONS(4812),
    [anon_sym_PLUS_EQ] = ACTIONS(4812),
    [anon_sym_DASH_EQ] = ACTIONS(4812),
    [anon_sym_LT_LT_EQ] = ACTIONS(4812),
    [anon_sym_GT_GT_EQ] = ACTIONS(4812),
    [anon_sym_AMP_EQ] = ACTIONS(4812),
    [anon_sym_CARET_EQ] = ACTIONS(4812),
    [anon_sym_PIPE_EQ] = ACTIONS(4812),
    [anon_sym_and_eq] = ACTIONS(4812),
    [anon_sym_or_eq] = ACTIONS(4812),
    [anon_sym_xor_eq] = ACTIONS(4812),
    [anon_sym_LT_EQ_GT] = ACTIONS(4812),
    [anon_sym_or] = ACTIONS(4810),
    [anon_sym_and] = ACTIONS(4810),
    [anon_sym_bitor] = ACTIONS(4812),
    [anon_sym_xor] = ACTIONS(4810),
    [anon_sym_bitand] = ACTIONS(4812),
    [anon_sym_not_eq] = ACTIONS(4812),
    [anon_sym_DASH_DASH] = ACTIONS(4812),
    [anon_sym_PLUS_PLUS] = ACTIONS(4812),
    [anon_sym_DOT] = ACTIONS(4810),
    [anon_sym_DOT_STAR] = ACTIONS(4812),
    [anon_sym_DASH_GT] = ACTIONS(4810),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4812),
    [anon_sym_decltype] = ACTIONS(4812),
    [anon_sym_final] = ACTIONS(4812),
    [anon_sym_override] = ACTIONS(4812),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4812),
  },
  [1630] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4836),
    [anon_sym_COMMA] = ACTIONS(4836),
    [anon_sym_RPAREN] = ACTIONS(4836),
    [anon_sym_LPAREN2] = ACTIONS(4836),
    [anon_sym_DASH] = ACTIONS(4834),
    [anon_sym_PLUS] = ACTIONS(4834),
    [anon_sym_STAR] = ACTIONS(4834),
    [anon_sym_SLASH] = ACTIONS(4834),
    [anon_sym_PERCENT] = ACTIONS(4834),
    [anon_sym_PIPE_PIPE] = ACTIONS(4836),
    [anon_sym_AMP_AMP] = ACTIONS(4836),
    [anon_sym_PIPE] = ACTIONS(4834),
    [anon_sym_CARET] = ACTIONS(4834),
    [anon_sym_AMP] = ACTIONS(4834),
    [anon_sym_EQ_EQ] = ACTIONS(4836),
    [anon_sym_BANG_EQ] = ACTIONS(4836),
    [anon_sym_GT] = ACTIONS(4834),
    [anon_sym_GT_EQ] = ACTIONS(4836),
    [anon_sym_LT_EQ] = ACTIONS(4834),
    [anon_sym_LT] = ACTIONS(4834),
    [anon_sym_LT_LT] = ACTIONS(4834),
    [anon_sym_GT_GT] = ACTIONS(4834),
    [anon_sym___extension__] = ACTIONS(4836),
    [anon_sym___attribute__] = ACTIONS(4836),
    [anon_sym___attribute] = ACTIONS(4834),
    [anon_sym_COLON_COLON] = ACTIONS(4836),
    [anon_sym_LBRACE] = ACTIONS(4836),
    [anon_sym_LBRACK] = ACTIONS(4836),
    [anon_sym_EQ] = ACTIONS(4834),
    [anon_sym_const] = ACTIONS(4834),
    [anon_sym_constexpr] = ACTIONS(4836),
    [anon_sym_volatile] = ACTIONS(4836),
    [anon_sym_restrict] = ACTIONS(4836),
    [anon_sym___restrict__] = ACTIONS(4836),
    [anon_sym__Atomic] = ACTIONS(4836),
    [anon_sym__Noreturn] = ACTIONS(4836),
    [anon_sym_noreturn] = ACTIONS(4836),
    [anon_sym__Nonnull] = ACTIONS(4836),
    [anon_sym_mutable] = ACTIONS(4836),
    [anon_sym_constinit] = ACTIONS(4836),
    [anon_sym_consteval] = ACTIONS(4836),
    [anon_sym_alignas] = ACTIONS(4836),
    [anon_sym__Alignas] = ACTIONS(4836),
    [anon_sym_COLON] = ACTIONS(4834),
    [anon_sym_QMARK] = ACTIONS(4836),
    [anon_sym_STAR_EQ] = ACTIONS(4836),
    [anon_sym_SLASH_EQ] = ACTIONS(4836),
    [anon_sym_PERCENT_EQ] = ACTIONS(4836),
    [anon_sym_PLUS_EQ] = ACTIONS(4836),
    [anon_sym_DASH_EQ] = ACTIONS(4836),
    [anon_sym_LT_LT_EQ] = ACTIONS(4836),
    [anon_sym_GT_GT_EQ] = ACTIONS(4836),
    [anon_sym_AMP_EQ] = ACTIONS(4836),
    [anon_sym_CARET_EQ] = ACTIONS(4836),
    [anon_sym_PIPE_EQ] = ACTIONS(4836),
    [anon_sym_and_eq] = ACTIONS(4836),
    [anon_sym_or_eq] = ACTIONS(4836),
    [anon_sym_xor_eq] = ACTIONS(4836),
    [anon_sym_LT_EQ_GT] = ACTIONS(4836),
    [anon_sym_or] = ACTIONS(4834),
    [anon_sym_and] = ACTIONS(4834),
    [anon_sym_bitor] = ACTIONS(4836),
    [anon_sym_xor] = ACTIONS(4834),
    [anon_sym_bitand] = ACTIONS(4836),
    [anon_sym_not_eq] = ACTIONS(4836),
    [anon_sym_DASH_DASH] = ACTIONS(4836),
    [anon_sym_PLUS_PLUS] = ACTIONS(4836),
    [anon_sym_DOT] = ACTIONS(4834),
    [anon_sym_DOT_STAR] = ACTIONS(4836),
    [anon_sym_DASH_GT] = ACTIONS(4834),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4836),
    [anon_sym_decltype] = ACTIONS(4836),
    [anon_sym_final] = ACTIONS(4836),
    [anon_sym_override] = ACTIONS(4836),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4836),
  },
  [1631] = {
    [sym_identifier] = ACTIONS(4855),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4859),
    [anon_sym_COMMA] = ACTIONS(4859),
    [anon_sym_RPAREN] = ACTIONS(4859),
    [anon_sym_LPAREN2] = ACTIONS(4859),
    [anon_sym_TILDE] = ACTIONS(4862),
    [anon_sym_DASH] = ACTIONS(4864),
    [anon_sym_PLUS] = ACTIONS(4864),
    [anon_sym_STAR] = ACTIONS(4859),
    [anon_sym_SLASH] = ACTIONS(4864),
    [anon_sym_PERCENT] = ACTIONS(4857),
    [anon_sym_PIPE_PIPE] = ACTIONS(4857),
    [anon_sym_AMP_AMP] = ACTIONS(4859),
    [anon_sym_PIPE] = ACTIONS(4864),
    [anon_sym_CARET] = ACTIONS(4857),
    [anon_sym_AMP] = ACTIONS(4866),
    [anon_sym_EQ_EQ] = ACTIONS(4857),
    [anon_sym_BANG_EQ] = ACTIONS(4857),
    [anon_sym_GT] = ACTIONS(4864),
    [anon_sym_GT_EQ] = ACTIONS(4857),
    [anon_sym_LT_EQ] = ACTIONS(4864),
    [anon_sym_LT] = ACTIONS(4864),
    [anon_sym_LT_LT] = ACTIONS(4857),
    [anon_sym_GT_GT] = ACTIONS(4857),
    [anon_sym___extension__] = ACTIONS(4855),
    [anon_sym_virtual] = ACTIONS(4855),
    [anon_sym_extern] = ACTIONS(4855),
    [anon_sym___attribute__] = ACTIONS(4855),
    [anon_sym___attribute] = ACTIONS(4855),
    [anon_sym_COLON_COLON] = ACTIONS(4862),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4862),
    [anon_sym___declspec] = ACTIONS(4855),
    [anon_sym___based] = ACTIONS(4855),
    [anon_sym_LBRACE] = ACTIONS(4862),
    [anon_sym_LBRACK] = ACTIONS(4866),
    [anon_sym_static] = ACTIONS(4855),
    [anon_sym_EQ] = ACTIONS(4855),
    [anon_sym_register] = ACTIONS(4855),
    [anon_sym_inline] = ACTIONS(4855),
    [anon_sym___inline] = ACTIONS(4855),
    [anon_sym___inline__] = ACTIONS(4855),
    [anon_sym___forceinline] = ACTIONS(4855),
    [anon_sym_thread_local] = ACTIONS(4855),
    [anon_sym___thread] = ACTIONS(4855),
    [anon_sym_const] = ACTIONS(4855),
    [anon_sym_constexpr] = ACTIONS(4855),
    [anon_sym_volatile] = ACTIONS(4855),
    [anon_sym_restrict] = ACTIONS(4855),
    [anon_sym___restrict__] = ACTIONS(4855),
    [anon_sym__Atomic] = ACTIONS(4855),
    [anon_sym__Noreturn] = ACTIONS(4855),
    [anon_sym_noreturn] = ACTIONS(4855),
    [anon_sym__Nonnull] = ACTIONS(4855),
    [anon_sym_mutable] = ACTIONS(4855),
    [anon_sym_constinit] = ACTIONS(4855),
    [anon_sym_consteval] = ACTIONS(4855),
    [anon_sym_alignas] = ACTIONS(4855),
    [anon_sym__Alignas] = ACTIONS(4855),
    [anon_sym_QMARK] = ACTIONS(4857),
    [anon_sym_LT_EQ_GT] = ACTIONS(4857),
    [anon_sym_or] = ACTIONS(4864),
    [anon_sym_and] = ACTIONS(4864),
    [anon_sym_bitor] = ACTIONS(4864),
    [anon_sym_xor] = ACTIONS(4864),
    [anon_sym_bitand] = ACTIONS(4864),
    [anon_sym_not_eq] = ACTIONS(4864),
    [anon_sym_DASH_DASH] = ACTIONS(4857),
    [anon_sym_PLUS_PLUS] = ACTIONS(4857),
    [anon_sym_DOT] = ACTIONS(4864),
    [anon_sym_DOT_STAR] = ACTIONS(4857),
    [anon_sym_DASH_GT] = ACTIONS(4857),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4855),
    [anon_sym_decltype] = ACTIONS(4855),
    [anon_sym_template] = ACTIONS(4855),
    [anon_sym_operator] = ACTIONS(4855),
  },
  [1632] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4820),
    [anon_sym_COMMA] = ACTIONS(4820),
    [anon_sym_RPAREN] = ACTIONS(4820),
    [anon_sym_LPAREN2] = ACTIONS(4820),
    [anon_sym_DASH] = ACTIONS(4818),
    [anon_sym_PLUS] = ACTIONS(4818),
    [anon_sym_STAR] = ACTIONS(4818),
    [anon_sym_SLASH] = ACTIONS(4818),
    [anon_sym_PERCENT] = ACTIONS(4818),
    [anon_sym_PIPE_PIPE] = ACTIONS(4820),
    [anon_sym_AMP_AMP] = ACTIONS(4820),
    [anon_sym_PIPE] = ACTIONS(4818),
    [anon_sym_CARET] = ACTIONS(4818),
    [anon_sym_AMP] = ACTIONS(4818),
    [anon_sym_EQ_EQ] = ACTIONS(4820),
    [anon_sym_BANG_EQ] = ACTIONS(4820),
    [anon_sym_GT] = ACTIONS(4818),
    [anon_sym_GT_EQ] = ACTIONS(4820),
    [anon_sym_LT_EQ] = ACTIONS(4818),
    [anon_sym_LT] = ACTIONS(4818),
    [anon_sym_LT_LT] = ACTIONS(4818),
    [anon_sym_GT_GT] = ACTIONS(4818),
    [anon_sym___extension__] = ACTIONS(4820),
    [anon_sym___attribute__] = ACTIONS(4820),
    [anon_sym___attribute] = ACTIONS(4818),
    [anon_sym_COLON_COLON] = ACTIONS(4820),
    [anon_sym_LBRACE] = ACTIONS(4820),
    [anon_sym_LBRACK] = ACTIONS(4820),
    [anon_sym_EQ] = ACTIONS(4818),
    [anon_sym_const] = ACTIONS(4818),
    [anon_sym_constexpr] = ACTIONS(4820),
    [anon_sym_volatile] = ACTIONS(4820),
    [anon_sym_restrict] = ACTIONS(4820),
    [anon_sym___restrict__] = ACTIONS(4820),
    [anon_sym__Atomic] = ACTIONS(4820),
    [anon_sym__Noreturn] = ACTIONS(4820),
    [anon_sym_noreturn] = ACTIONS(4820),
    [anon_sym__Nonnull] = ACTIONS(4820),
    [anon_sym_mutable] = ACTIONS(4820),
    [anon_sym_constinit] = ACTIONS(4820),
    [anon_sym_consteval] = ACTIONS(4820),
    [anon_sym_alignas] = ACTIONS(4820),
    [anon_sym__Alignas] = ACTIONS(4820),
    [anon_sym_COLON] = ACTIONS(4818),
    [anon_sym_QMARK] = ACTIONS(4820),
    [anon_sym_STAR_EQ] = ACTIONS(4820),
    [anon_sym_SLASH_EQ] = ACTIONS(4820),
    [anon_sym_PERCENT_EQ] = ACTIONS(4820),
    [anon_sym_PLUS_EQ] = ACTIONS(4820),
    [anon_sym_DASH_EQ] = ACTIONS(4820),
    [anon_sym_LT_LT_EQ] = ACTIONS(4820),
    [anon_sym_GT_GT_EQ] = ACTIONS(4820),
    [anon_sym_AMP_EQ] = ACTIONS(4820),
    [anon_sym_CARET_EQ] = ACTIONS(4820),
    [anon_sym_PIPE_EQ] = ACTIONS(4820),
    [anon_sym_and_eq] = ACTIONS(4820),
    [anon_sym_or_eq] = ACTIONS(4820),
    [anon_sym_xor_eq] = ACTIONS(4820),
    [anon_sym_LT_EQ_GT] = ACTIONS(4820),
    [anon_sym_or] = ACTIONS(4818),
    [anon_sym_and] = ACTIONS(4818),
    [anon_sym_bitor] = ACTIONS(4820),
    [anon_sym_xor] = ACTIONS(4818),
    [anon_sym_bitand] = ACTIONS(4820),
    [anon_sym_not_eq] = ACTIONS(4820),
    [anon_sym_DASH_DASH] = ACTIONS(4820),
    [anon_sym_PLUS_PLUS] = ACTIONS(4820),
    [anon_sym_DOT] = ACTIONS(4818),
    [anon_sym_DOT_STAR] = ACTIONS(4820),
    [anon_sym_DASH_GT] = ACTIONS(4818),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4820),
    [anon_sym_decltype] = ACTIONS(4820),
    [anon_sym_final] = ACTIONS(4820),
    [anon_sym_override] = ACTIONS(4820),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4820),
  },
  [1633] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1638),
    [sym_identifier] = ACTIONS(4932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4981),
    [anon_sym_COMMA] = ACTIONS(4981),
    [anon_sym_RPAREN] = ACTIONS(4981),
    [anon_sym_LPAREN2] = ACTIONS(4981),
    [anon_sym_DASH] = ACTIONS(4984),
    [anon_sym_PLUS] = ACTIONS(4984),
    [anon_sym_STAR] = ACTIONS(4984),
    [anon_sym_SLASH] = ACTIONS(4984),
    [anon_sym_PERCENT] = ACTIONS(4984),
    [anon_sym_PIPE_PIPE] = ACTIONS(4981),
    [anon_sym_AMP_AMP] = ACTIONS(4981),
    [anon_sym_PIPE] = ACTIONS(4984),
    [anon_sym_CARET] = ACTIONS(4984),
    [anon_sym_AMP] = ACTIONS(4984),
    [anon_sym_EQ_EQ] = ACTIONS(4981),
    [anon_sym_BANG_EQ] = ACTIONS(4981),
    [anon_sym_GT] = ACTIONS(4984),
    [anon_sym_GT_EQ] = ACTIONS(4981),
    [anon_sym_LT_EQ] = ACTIONS(4984),
    [anon_sym_LT] = ACTIONS(4984),
    [anon_sym_LT_LT] = ACTIONS(4984),
    [anon_sym_GT_GT] = ACTIONS(4984),
    [anon_sym___extension__] = ACTIONS(4932),
    [anon_sym___attribute__] = ACTIONS(4984),
    [anon_sym___attribute] = ACTIONS(4984),
    [anon_sym_LBRACE] = ACTIONS(4981),
    [anon_sym_signed] = ACTIONS(5234),
    [anon_sym_unsigned] = ACTIONS(5234),
    [anon_sym_long] = ACTIONS(5234),
    [anon_sym_short] = ACTIONS(5234),
    [anon_sym_LBRACK] = ACTIONS(4981),
    [anon_sym_EQ] = ACTIONS(4984),
    [anon_sym_const] = ACTIONS(4932),
    [anon_sym_constexpr] = ACTIONS(4932),
    [anon_sym_volatile] = ACTIONS(4932),
    [anon_sym_restrict] = ACTIONS(4932),
    [anon_sym___restrict__] = ACTIONS(4932),
    [anon_sym__Atomic] = ACTIONS(4932),
    [anon_sym__Noreturn] = ACTIONS(4932),
    [anon_sym_noreturn] = ACTIONS(4932),
    [anon_sym__Nonnull] = ACTIONS(4932),
    [anon_sym_mutable] = ACTIONS(4932),
    [anon_sym_constinit] = ACTIONS(4932),
    [anon_sym_consteval] = ACTIONS(4932),
    [anon_sym_alignas] = ACTIONS(4932),
    [anon_sym__Alignas] = ACTIONS(4932),
    [sym_primitive_type] = ACTIONS(4932),
    [anon_sym_QMARK] = ACTIONS(4981),
    [anon_sym_STAR_EQ] = ACTIONS(4981),
    [anon_sym_SLASH_EQ] = ACTIONS(4981),
    [anon_sym_PERCENT_EQ] = ACTIONS(4981),
    [anon_sym_PLUS_EQ] = ACTIONS(4981),
    [anon_sym_DASH_EQ] = ACTIONS(4981),
    [anon_sym_LT_LT_EQ] = ACTIONS(4981),
    [anon_sym_GT_GT_EQ] = ACTIONS(4981),
    [anon_sym_AMP_EQ] = ACTIONS(4981),
    [anon_sym_CARET_EQ] = ACTIONS(4981),
    [anon_sym_PIPE_EQ] = ACTIONS(4981),
    [anon_sym_LT_EQ_GT] = ACTIONS(4981),
    [anon_sym_or] = ACTIONS(4984),
    [anon_sym_and] = ACTIONS(4984),
    [anon_sym_bitor] = ACTIONS(4984),
    [anon_sym_xor] = ACTIONS(4984),
    [anon_sym_bitand] = ACTIONS(4984),
    [anon_sym_not_eq] = ACTIONS(4984),
    [anon_sym_DASH_DASH] = ACTIONS(4981),
    [anon_sym_PLUS_PLUS] = ACTIONS(4981),
    [anon_sym_DOT] = ACTIONS(4984),
    [anon_sym_DOT_STAR] = ACTIONS(4981),
    [anon_sym_DASH_GT] = ACTIONS(4984),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4984),
    [anon_sym_decltype] = ACTIONS(4984),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4981),
  },
  [1634] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4824),
    [anon_sym_COMMA] = ACTIONS(4824),
    [anon_sym_RPAREN] = ACTIONS(4824),
    [anon_sym_LPAREN2] = ACTIONS(4824),
    [anon_sym_DASH] = ACTIONS(4822),
    [anon_sym_PLUS] = ACTIONS(4822),
    [anon_sym_STAR] = ACTIONS(4822),
    [anon_sym_SLASH] = ACTIONS(4822),
    [anon_sym_PERCENT] = ACTIONS(4822),
    [anon_sym_PIPE_PIPE] = ACTIONS(4824),
    [anon_sym_AMP_AMP] = ACTIONS(4824),
    [anon_sym_PIPE] = ACTIONS(4822),
    [anon_sym_CARET] = ACTIONS(4822),
    [anon_sym_AMP] = ACTIONS(4822),
    [anon_sym_EQ_EQ] = ACTIONS(4824),
    [anon_sym_BANG_EQ] = ACTIONS(4824),
    [anon_sym_GT] = ACTIONS(4822),
    [anon_sym_GT_EQ] = ACTIONS(4824),
    [anon_sym_LT_EQ] = ACTIONS(4822),
    [anon_sym_LT] = ACTIONS(4822),
    [anon_sym_LT_LT] = ACTIONS(4822),
    [anon_sym_GT_GT] = ACTIONS(4822),
    [anon_sym___extension__] = ACTIONS(4824),
    [anon_sym___attribute__] = ACTIONS(4824),
    [anon_sym___attribute] = ACTIONS(4822),
    [anon_sym_COLON_COLON] = ACTIONS(4824),
    [anon_sym_LBRACE] = ACTIONS(4824),
    [anon_sym_LBRACK] = ACTIONS(4824),
    [anon_sym_EQ] = ACTIONS(4822),
    [anon_sym_const] = ACTIONS(4822),
    [anon_sym_constexpr] = ACTIONS(4824),
    [anon_sym_volatile] = ACTIONS(4824),
    [anon_sym_restrict] = ACTIONS(4824),
    [anon_sym___restrict__] = ACTIONS(4824),
    [anon_sym__Atomic] = ACTIONS(4824),
    [anon_sym__Noreturn] = ACTIONS(4824),
    [anon_sym_noreturn] = ACTIONS(4824),
    [anon_sym__Nonnull] = ACTIONS(4824),
    [anon_sym_mutable] = ACTIONS(4824),
    [anon_sym_constinit] = ACTIONS(4824),
    [anon_sym_consteval] = ACTIONS(4824),
    [anon_sym_alignas] = ACTIONS(4824),
    [anon_sym__Alignas] = ACTIONS(4824),
    [anon_sym_COLON] = ACTIONS(4822),
    [anon_sym_QMARK] = ACTIONS(4824),
    [anon_sym_STAR_EQ] = ACTIONS(4824),
    [anon_sym_SLASH_EQ] = ACTIONS(4824),
    [anon_sym_PERCENT_EQ] = ACTIONS(4824),
    [anon_sym_PLUS_EQ] = ACTIONS(4824),
    [anon_sym_DASH_EQ] = ACTIONS(4824),
    [anon_sym_LT_LT_EQ] = ACTIONS(4824),
    [anon_sym_GT_GT_EQ] = ACTIONS(4824),
    [anon_sym_AMP_EQ] = ACTIONS(4824),
    [anon_sym_CARET_EQ] = ACTIONS(4824),
    [anon_sym_PIPE_EQ] = ACTIONS(4824),
    [anon_sym_and_eq] = ACTIONS(4824),
    [anon_sym_or_eq] = ACTIONS(4824),
    [anon_sym_xor_eq] = ACTIONS(4824),
    [anon_sym_LT_EQ_GT] = ACTIONS(4824),
    [anon_sym_or] = ACTIONS(4822),
    [anon_sym_and] = ACTIONS(4822),
    [anon_sym_bitor] = ACTIONS(4824),
    [anon_sym_xor] = ACTIONS(4822),
    [anon_sym_bitand] = ACTIONS(4824),
    [anon_sym_not_eq] = ACTIONS(4824),
    [anon_sym_DASH_DASH] = ACTIONS(4824),
    [anon_sym_PLUS_PLUS] = ACTIONS(4824),
    [anon_sym_DOT] = ACTIONS(4822),
    [anon_sym_DOT_STAR] = ACTIONS(4824),
    [anon_sym_DASH_GT] = ACTIONS(4822),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4824),
    [anon_sym_decltype] = ACTIONS(4824),
    [anon_sym_final] = ACTIONS(4824),
    [anon_sym_override] = ACTIONS(4824),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4824),
  },
  [1635] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4828),
    [anon_sym_COMMA] = ACTIONS(4828),
    [anon_sym_RPAREN] = ACTIONS(4828),
    [anon_sym_LPAREN2] = ACTIONS(4828),
    [anon_sym_DASH] = ACTIONS(4826),
    [anon_sym_PLUS] = ACTIONS(4826),
    [anon_sym_STAR] = ACTIONS(4826),
    [anon_sym_SLASH] = ACTIONS(4826),
    [anon_sym_PERCENT] = ACTIONS(4826),
    [anon_sym_PIPE_PIPE] = ACTIONS(4828),
    [anon_sym_AMP_AMP] = ACTIONS(4828),
    [anon_sym_PIPE] = ACTIONS(4826),
    [anon_sym_CARET] = ACTIONS(4826),
    [anon_sym_AMP] = ACTIONS(4826),
    [anon_sym_EQ_EQ] = ACTIONS(4828),
    [anon_sym_BANG_EQ] = ACTIONS(4828),
    [anon_sym_GT] = ACTIONS(4826),
    [anon_sym_GT_EQ] = ACTIONS(4828),
    [anon_sym_LT_EQ] = ACTIONS(4826),
    [anon_sym_LT] = ACTIONS(4826),
    [anon_sym_LT_LT] = ACTIONS(4826),
    [anon_sym_GT_GT] = ACTIONS(4826),
    [anon_sym___extension__] = ACTIONS(4828),
    [anon_sym___attribute__] = ACTIONS(4828),
    [anon_sym___attribute] = ACTIONS(4826),
    [anon_sym_COLON_COLON] = ACTIONS(4828),
    [anon_sym_LBRACE] = ACTIONS(4828),
    [anon_sym_LBRACK] = ACTIONS(4828),
    [anon_sym_EQ] = ACTIONS(4826),
    [anon_sym_const] = ACTIONS(4826),
    [anon_sym_constexpr] = ACTIONS(4828),
    [anon_sym_volatile] = ACTIONS(4828),
    [anon_sym_restrict] = ACTIONS(4828),
    [anon_sym___restrict__] = ACTIONS(4828),
    [anon_sym__Atomic] = ACTIONS(4828),
    [anon_sym__Noreturn] = ACTIONS(4828),
    [anon_sym_noreturn] = ACTIONS(4828),
    [anon_sym__Nonnull] = ACTIONS(4828),
    [anon_sym_mutable] = ACTIONS(4828),
    [anon_sym_constinit] = ACTIONS(4828),
    [anon_sym_consteval] = ACTIONS(4828),
    [anon_sym_alignas] = ACTIONS(4828),
    [anon_sym__Alignas] = ACTIONS(4828),
    [anon_sym_COLON] = ACTIONS(4826),
    [anon_sym_QMARK] = ACTIONS(4828),
    [anon_sym_STAR_EQ] = ACTIONS(4828),
    [anon_sym_SLASH_EQ] = ACTIONS(4828),
    [anon_sym_PERCENT_EQ] = ACTIONS(4828),
    [anon_sym_PLUS_EQ] = ACTIONS(4828),
    [anon_sym_DASH_EQ] = ACTIONS(4828),
    [anon_sym_LT_LT_EQ] = ACTIONS(4828),
    [anon_sym_GT_GT_EQ] = ACTIONS(4828),
    [anon_sym_AMP_EQ] = ACTIONS(4828),
    [anon_sym_CARET_EQ] = ACTIONS(4828),
    [anon_sym_PIPE_EQ] = ACTIONS(4828),
    [anon_sym_and_eq] = ACTIONS(4828),
    [anon_sym_or_eq] = ACTIONS(4828),
    [anon_sym_xor_eq] = ACTIONS(4828),
    [anon_sym_LT_EQ_GT] = ACTIONS(4828),
    [anon_sym_or] = ACTIONS(4826),
    [anon_sym_and] = ACTIONS(4826),
    [anon_sym_bitor] = ACTIONS(4828),
    [anon_sym_xor] = ACTIONS(4826),
    [anon_sym_bitand] = ACTIONS(4828),
    [anon_sym_not_eq] = ACTIONS(4828),
    [anon_sym_DASH_DASH] = ACTIONS(4828),
    [anon_sym_PLUS_PLUS] = ACTIONS(4828),
    [anon_sym_DOT] = ACTIONS(4826),
    [anon_sym_DOT_STAR] = ACTIONS(4828),
    [anon_sym_DASH_GT] = ACTIONS(4826),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4828),
    [anon_sym_decltype] = ACTIONS(4828),
    [anon_sym_final] = ACTIONS(4828),
    [anon_sym_override] = ACTIONS(4828),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4828),
  },
  [1636] = {
    [sym_string_literal] = STATE(1656),
    [sym_template_argument_list] = STATE(2300),
    [sym_raw_string_literal] = STATE(1656),
    [sym_identifier] = ACTIONS(4043),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4035),
    [anon_sym_COMMA] = ACTIONS(4035),
    [anon_sym_RPAREN] = ACTIONS(4035),
    [aux_sym_preproc_if_token2] = ACTIONS(4035),
    [aux_sym_preproc_else_token1] = ACTIONS(4035),
    [aux_sym_preproc_elif_token1] = ACTIONS(4043),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4035),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4035),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_DASH] = ACTIONS(4043),
    [anon_sym_PLUS] = ACTIONS(4043),
    [anon_sym_STAR] = ACTIONS(4043),
    [anon_sym_SLASH] = ACTIONS(4043),
    [anon_sym_PERCENT] = ACTIONS(4043),
    [anon_sym_PIPE_PIPE] = ACTIONS(4035),
    [anon_sym_AMP_AMP] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4043),
    [anon_sym_CARET] = ACTIONS(4043),
    [anon_sym_AMP] = ACTIONS(4043),
    [anon_sym_EQ_EQ] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4043),
    [anon_sym_GT_EQ] = ACTIONS(4035),
    [anon_sym_LT_EQ] = ACTIONS(4043),
    [anon_sym_LT] = ACTIONS(5237),
    [anon_sym_LT_LT] = ACTIONS(4043),
    [anon_sym_GT_GT] = ACTIONS(4043),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACE] = ACTIONS(4059),
    [anon_sym_RBRACE] = ACTIONS(4035),
    [anon_sym_LBRACK] = ACTIONS(4035),
    [anon_sym_RBRACK] = ACTIONS(4035),
    [anon_sym_EQ] = ACTIONS(4043),
    [anon_sym_COLON] = ACTIONS(4043),
    [anon_sym_QMARK] = ACTIONS(4035),
    [anon_sym_STAR_EQ] = ACTIONS(4035),
    [anon_sym_SLASH_EQ] = ACTIONS(4035),
    [anon_sym_PERCENT_EQ] = ACTIONS(4035),
    [anon_sym_PLUS_EQ] = ACTIONS(4035),
    [anon_sym_DASH_EQ] = ACTIONS(4035),
    [anon_sym_LT_LT_EQ] = ACTIONS(4035),
    [anon_sym_GT_GT_EQ] = ACTIONS(4035),
    [anon_sym_AMP_EQ] = ACTIONS(4035),
    [anon_sym_CARET_EQ] = ACTIONS(4035),
    [anon_sym_PIPE_EQ] = ACTIONS(4035),
    [anon_sym_and_eq] = ACTIONS(4043),
    [anon_sym_or_eq] = ACTIONS(4043),
    [anon_sym_xor_eq] = ACTIONS(4043),
    [anon_sym_LT_EQ_GT] = ACTIONS(4035),
    [anon_sym_or] = ACTIONS(4043),
    [anon_sym_and] = ACTIONS(4043),
    [anon_sym_bitor] = ACTIONS(4043),
    [anon_sym_xor] = ACTIONS(4043),
    [anon_sym_bitand] = ACTIONS(4043),
    [anon_sym_not_eq] = ACTIONS(4043),
    [anon_sym_DASH_DASH] = ACTIONS(4035),
    [anon_sym_PLUS_PLUS] = ACTIONS(4035),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_DOT_STAR] = ACTIONS(4035),
    [anon_sym_DASH_GT] = ACTIONS(4035),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(1955),
    [anon_sym_LR_DQUOTE] = ACTIONS(1955),
    [anon_sym_uR_DQUOTE] = ACTIONS(1955),
    [anon_sym_UR_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1955),
  },
  [1637] = {
    [sym__declaration_modifiers] = STATE(2045),
    [sym__declaration_specifiers] = STATE(3892),
    [sym_attribute_specifier] = STATE(2045),
    [sym_attribute_declaration] = STATE(2045),
    [sym_ms_declspec_modifier] = STATE(2045),
    [sym_storage_class_specifier] = STATE(2045),
    [sym_type_qualifier] = STATE(2045),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_parameter_declaration] = STATE(7703),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_dependent_type] = STATE(2383),
    [sym_type_parameter_declaration] = STATE(7703),
    [sym_variadic_type_parameter_declaration] = STATE(7703),
    [sym_optional_type_parameter_declaration] = STATE(7703),
    [sym_template_template_parameter_declaration] = STATE(7703),
    [sym_optional_parameter_declaration] = STATE(7703),
    [sym_variadic_parameter_declaration] = STATE(7703),
    [sym_template_type] = STATE(2336),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(6511),
    [sym_qualified_type_identifier] = STATE(2978),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2045),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(4869),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(1851),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4879),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(1857),
    [anon_sym_class] = ACTIONS(5221),
    [anon_sym_struct] = ACTIONS(1861),
    [anon_sym_union] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(5223),
    [anon_sym_template] = ACTIONS(5225),
  },
  [1638] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1638),
    [sym_identifier] = ACTIONS(4932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4934),
    [anon_sym_COMMA] = ACTIONS(4934),
    [anon_sym_RPAREN] = ACTIONS(4934),
    [anon_sym_LPAREN2] = ACTIONS(4934),
    [anon_sym_DASH] = ACTIONS(4932),
    [anon_sym_PLUS] = ACTIONS(4932),
    [anon_sym_STAR] = ACTIONS(4932),
    [anon_sym_SLASH] = ACTIONS(4932),
    [anon_sym_PERCENT] = ACTIONS(4932),
    [anon_sym_PIPE_PIPE] = ACTIONS(4934),
    [anon_sym_AMP_AMP] = ACTIONS(4934),
    [anon_sym_PIPE] = ACTIONS(4932),
    [anon_sym_CARET] = ACTIONS(4932),
    [anon_sym_AMP] = ACTIONS(4932),
    [anon_sym_EQ_EQ] = ACTIONS(4934),
    [anon_sym_BANG_EQ] = ACTIONS(4934),
    [anon_sym_GT] = ACTIONS(4932),
    [anon_sym_GT_EQ] = ACTIONS(4934),
    [anon_sym_LT_EQ] = ACTIONS(4932),
    [anon_sym_LT] = ACTIONS(4932),
    [anon_sym_LT_LT] = ACTIONS(4932),
    [anon_sym_GT_GT] = ACTIONS(4932),
    [anon_sym___extension__] = ACTIONS(4932),
    [anon_sym___attribute__] = ACTIONS(4932),
    [anon_sym___attribute] = ACTIONS(4932),
    [anon_sym_LBRACE] = ACTIONS(4934),
    [anon_sym_signed] = ACTIONS(5234),
    [anon_sym_unsigned] = ACTIONS(5234),
    [anon_sym_long] = ACTIONS(5234),
    [anon_sym_short] = ACTIONS(5234),
    [anon_sym_LBRACK] = ACTIONS(4934),
    [anon_sym_EQ] = ACTIONS(4932),
    [anon_sym_const] = ACTIONS(4932),
    [anon_sym_constexpr] = ACTIONS(4932),
    [anon_sym_volatile] = ACTIONS(4932),
    [anon_sym_restrict] = ACTIONS(4932),
    [anon_sym___restrict__] = ACTIONS(4932),
    [anon_sym__Atomic] = ACTIONS(4932),
    [anon_sym__Noreturn] = ACTIONS(4932),
    [anon_sym_noreturn] = ACTIONS(4932),
    [anon_sym__Nonnull] = ACTIONS(4932),
    [anon_sym_mutable] = ACTIONS(4932),
    [anon_sym_constinit] = ACTIONS(4932),
    [anon_sym_consteval] = ACTIONS(4932),
    [anon_sym_alignas] = ACTIONS(4932),
    [anon_sym__Alignas] = ACTIONS(4932),
    [sym_primitive_type] = ACTIONS(4932),
    [anon_sym_QMARK] = ACTIONS(4934),
    [anon_sym_STAR_EQ] = ACTIONS(4934),
    [anon_sym_SLASH_EQ] = ACTIONS(4934),
    [anon_sym_PERCENT_EQ] = ACTIONS(4934),
    [anon_sym_PLUS_EQ] = ACTIONS(4934),
    [anon_sym_DASH_EQ] = ACTIONS(4934),
    [anon_sym_LT_LT_EQ] = ACTIONS(4934),
    [anon_sym_GT_GT_EQ] = ACTIONS(4934),
    [anon_sym_AMP_EQ] = ACTIONS(4934),
    [anon_sym_CARET_EQ] = ACTIONS(4934),
    [anon_sym_PIPE_EQ] = ACTIONS(4934),
    [anon_sym_LT_EQ_GT] = ACTIONS(4934),
    [anon_sym_or] = ACTIONS(4932),
    [anon_sym_and] = ACTIONS(4932),
    [anon_sym_bitor] = ACTIONS(4932),
    [anon_sym_xor] = ACTIONS(4932),
    [anon_sym_bitand] = ACTIONS(4932),
    [anon_sym_not_eq] = ACTIONS(4932),
    [anon_sym_DASH_DASH] = ACTIONS(4934),
    [anon_sym_PLUS_PLUS] = ACTIONS(4934),
    [anon_sym_DOT] = ACTIONS(4932),
    [anon_sym_DOT_STAR] = ACTIONS(4934),
    [anon_sym_DASH_GT] = ACTIONS(4932),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4932),
    [anon_sym_decltype] = ACTIONS(4932),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4934),
  },
  [1639] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4812),
    [anon_sym_COMMA] = ACTIONS(4812),
    [anon_sym_LPAREN2] = ACTIONS(4812),
    [anon_sym_DASH] = ACTIONS(4810),
    [anon_sym_PLUS] = ACTIONS(4810),
    [anon_sym_STAR] = ACTIONS(4810),
    [anon_sym_SLASH] = ACTIONS(4810),
    [anon_sym_PERCENT] = ACTIONS(4810),
    [anon_sym_PIPE_PIPE] = ACTIONS(4812),
    [anon_sym_AMP_AMP] = ACTIONS(4812),
    [anon_sym_PIPE] = ACTIONS(4810),
    [anon_sym_CARET] = ACTIONS(4810),
    [anon_sym_AMP] = ACTIONS(4810),
    [anon_sym_EQ_EQ] = ACTIONS(4812),
    [anon_sym_BANG_EQ] = ACTIONS(4812),
    [anon_sym_GT] = ACTIONS(4810),
    [anon_sym_GT_EQ] = ACTIONS(4810),
    [anon_sym_LT_EQ] = ACTIONS(4810),
    [anon_sym_LT] = ACTIONS(4810),
    [anon_sym_LT_LT] = ACTIONS(4810),
    [anon_sym_GT_GT] = ACTIONS(4810),
    [anon_sym___extension__] = ACTIONS(4812),
    [anon_sym___attribute__] = ACTIONS(4812),
    [anon_sym___attribute] = ACTIONS(4810),
    [anon_sym_COLON_COLON] = ACTIONS(4812),
    [anon_sym_LBRACE] = ACTIONS(4812),
    [anon_sym_LBRACK] = ACTIONS(4812),
    [anon_sym_EQ] = ACTIONS(4810),
    [anon_sym_const] = ACTIONS(4810),
    [anon_sym_constexpr] = ACTIONS(4812),
    [anon_sym_volatile] = ACTIONS(4812),
    [anon_sym_restrict] = ACTIONS(4812),
    [anon_sym___restrict__] = ACTIONS(4812),
    [anon_sym__Atomic] = ACTIONS(4812),
    [anon_sym__Noreturn] = ACTIONS(4812),
    [anon_sym_noreturn] = ACTIONS(4812),
    [anon_sym__Nonnull] = ACTIONS(4812),
    [anon_sym_mutable] = ACTIONS(4812),
    [anon_sym_constinit] = ACTIONS(4812),
    [anon_sym_consteval] = ACTIONS(4812),
    [anon_sym_alignas] = ACTIONS(4812),
    [anon_sym__Alignas] = ACTIONS(4812),
    [anon_sym_COLON] = ACTIONS(4810),
    [anon_sym_QMARK] = ACTIONS(4812),
    [anon_sym_STAR_EQ] = ACTIONS(4812),
    [anon_sym_SLASH_EQ] = ACTIONS(4812),
    [anon_sym_PERCENT_EQ] = ACTIONS(4812),
    [anon_sym_PLUS_EQ] = ACTIONS(4812),
    [anon_sym_DASH_EQ] = ACTIONS(4812),
    [anon_sym_LT_LT_EQ] = ACTIONS(4812),
    [anon_sym_GT_GT_EQ] = ACTIONS(4810),
    [anon_sym_AMP_EQ] = ACTIONS(4812),
    [anon_sym_CARET_EQ] = ACTIONS(4812),
    [anon_sym_PIPE_EQ] = ACTIONS(4812),
    [anon_sym_and_eq] = ACTIONS(4812),
    [anon_sym_or_eq] = ACTIONS(4812),
    [anon_sym_xor_eq] = ACTIONS(4812),
    [anon_sym_LT_EQ_GT] = ACTIONS(4812),
    [anon_sym_or] = ACTIONS(4810),
    [anon_sym_and] = ACTIONS(4810),
    [anon_sym_bitor] = ACTIONS(4812),
    [anon_sym_xor] = ACTIONS(4810),
    [anon_sym_bitand] = ACTIONS(4812),
    [anon_sym_not_eq] = ACTIONS(4812),
    [anon_sym_DASH_DASH] = ACTIONS(4812),
    [anon_sym_PLUS_PLUS] = ACTIONS(4812),
    [anon_sym_DOT] = ACTIONS(4810),
    [anon_sym_DOT_STAR] = ACTIONS(4812),
    [anon_sym_DASH_GT] = ACTIONS(4812),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4812),
    [anon_sym_decltype] = ACTIONS(4812),
    [anon_sym_final] = ACTIONS(4812),
    [anon_sym_override] = ACTIONS(4812),
    [anon_sym_GT2] = ACTIONS(4812),
  },
  [1640] = {
    [sym_catch_clause] = STATE(1640),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1640),
    [sym_identifier] = ACTIONS(2439),
    [aux_sym_preproc_def_token1] = ACTIONS(2439),
    [aux_sym_preproc_if_token1] = ACTIONS(2439),
    [aux_sym_preproc_if_token2] = ACTIONS(2439),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2439),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2439),
    [aux_sym_preproc_else_token1] = ACTIONS(2439),
    [aux_sym_preproc_elif_token1] = ACTIONS(2439),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2439),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2439),
    [sym_preproc_directive] = ACTIONS(2439),
    [anon_sym_LPAREN2] = ACTIONS(2441),
    [anon_sym_TILDE] = ACTIONS(2441),
    [anon_sym_STAR] = ACTIONS(2441),
    [anon_sym_AMP_AMP] = ACTIONS(2441),
    [anon_sym_AMP] = ACTIONS(2439),
    [anon_sym_SEMI] = ACTIONS(2441),
    [anon_sym___extension__] = ACTIONS(2439),
    [anon_sym_typedef] = ACTIONS(2439),
    [anon_sym_virtual] = ACTIONS(2439),
    [anon_sym_extern] = ACTIONS(2439),
    [anon_sym___attribute__] = ACTIONS(2439),
    [anon_sym___attribute] = ACTIONS(2439),
    [anon_sym_COLON_COLON] = ACTIONS(2441),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2441),
    [anon_sym___declspec] = ACTIONS(2439),
    [anon_sym___based] = ACTIONS(2439),
    [anon_sym_signed] = ACTIONS(2439),
    [anon_sym_unsigned] = ACTIONS(2439),
    [anon_sym_long] = ACTIONS(2439),
    [anon_sym_short] = ACTIONS(2439),
    [anon_sym_LBRACK] = ACTIONS(2439),
    [anon_sym_static] = ACTIONS(2439),
    [anon_sym_register] = ACTIONS(2439),
    [anon_sym_inline] = ACTIONS(2439),
    [anon_sym___inline] = ACTIONS(2439),
    [anon_sym___inline__] = ACTIONS(2439),
    [anon_sym___forceinline] = ACTIONS(2439),
    [anon_sym_thread_local] = ACTIONS(2439),
    [anon_sym___thread] = ACTIONS(2439),
    [anon_sym_const] = ACTIONS(2439),
    [anon_sym_constexpr] = ACTIONS(2439),
    [anon_sym_volatile] = ACTIONS(2439),
    [anon_sym_restrict] = ACTIONS(2439),
    [anon_sym___restrict__] = ACTIONS(2439),
    [anon_sym__Atomic] = ACTIONS(2439),
    [anon_sym__Noreturn] = ACTIONS(2439),
    [anon_sym_noreturn] = ACTIONS(2439),
    [anon_sym__Nonnull] = ACTIONS(2439),
    [anon_sym_mutable] = ACTIONS(2439),
    [anon_sym_constinit] = ACTIONS(2439),
    [anon_sym_consteval] = ACTIONS(2439),
    [anon_sym_alignas] = ACTIONS(2439),
    [anon_sym__Alignas] = ACTIONS(2439),
    [sym_primitive_type] = ACTIONS(2439),
    [anon_sym_enum] = ACTIONS(2439),
    [anon_sym_class] = ACTIONS(2439),
    [anon_sym_struct] = ACTIONS(2439),
    [anon_sym_union] = ACTIONS(2439),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2439),
    [anon_sym_decltype] = ACTIONS(2439),
    [anon_sym_explicit] = ACTIONS(2439),
    [anon_sym_typename] = ACTIONS(2439),
    [anon_sym_template] = ACTIONS(2439),
    [anon_sym_operator] = ACTIONS(2439),
    [anon_sym_friend] = ACTIONS(2439),
    [anon_sym_public] = ACTIONS(2439),
    [anon_sym_private] = ACTIONS(2439),
    [anon_sym_protected] = ACTIONS(2439),
    [anon_sym_using] = ACTIONS(2439),
    [anon_sym_static_assert] = ACTIONS(2439),
    [anon_sym_catch] = ACTIONS(5240),
  },
  [1641] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4828),
    [anon_sym_COMMA] = ACTIONS(4828),
    [anon_sym_LPAREN2] = ACTIONS(4828),
    [anon_sym_DASH] = ACTIONS(4826),
    [anon_sym_PLUS] = ACTIONS(4826),
    [anon_sym_STAR] = ACTIONS(4826),
    [anon_sym_SLASH] = ACTIONS(4826),
    [anon_sym_PERCENT] = ACTIONS(4826),
    [anon_sym_PIPE_PIPE] = ACTIONS(4828),
    [anon_sym_AMP_AMP] = ACTIONS(4828),
    [anon_sym_PIPE] = ACTIONS(4826),
    [anon_sym_CARET] = ACTIONS(4826),
    [anon_sym_AMP] = ACTIONS(4826),
    [anon_sym_EQ_EQ] = ACTIONS(4828),
    [anon_sym_BANG_EQ] = ACTIONS(4828),
    [anon_sym_GT] = ACTIONS(4826),
    [anon_sym_GT_EQ] = ACTIONS(4826),
    [anon_sym_LT_EQ] = ACTIONS(4826),
    [anon_sym_LT] = ACTIONS(4826),
    [anon_sym_LT_LT] = ACTIONS(4826),
    [anon_sym_GT_GT] = ACTIONS(4826),
    [anon_sym___extension__] = ACTIONS(4828),
    [anon_sym___attribute__] = ACTIONS(4828),
    [anon_sym___attribute] = ACTIONS(4826),
    [anon_sym_COLON_COLON] = ACTIONS(4828),
    [anon_sym_LBRACE] = ACTIONS(4828),
    [anon_sym_LBRACK] = ACTIONS(4828),
    [anon_sym_EQ] = ACTIONS(4826),
    [anon_sym_const] = ACTIONS(4826),
    [anon_sym_constexpr] = ACTIONS(4828),
    [anon_sym_volatile] = ACTIONS(4828),
    [anon_sym_restrict] = ACTIONS(4828),
    [anon_sym___restrict__] = ACTIONS(4828),
    [anon_sym__Atomic] = ACTIONS(4828),
    [anon_sym__Noreturn] = ACTIONS(4828),
    [anon_sym_noreturn] = ACTIONS(4828),
    [anon_sym__Nonnull] = ACTIONS(4828),
    [anon_sym_mutable] = ACTIONS(4828),
    [anon_sym_constinit] = ACTIONS(4828),
    [anon_sym_consteval] = ACTIONS(4828),
    [anon_sym_alignas] = ACTIONS(4828),
    [anon_sym__Alignas] = ACTIONS(4828),
    [anon_sym_COLON] = ACTIONS(4826),
    [anon_sym_QMARK] = ACTIONS(4828),
    [anon_sym_STAR_EQ] = ACTIONS(4828),
    [anon_sym_SLASH_EQ] = ACTIONS(4828),
    [anon_sym_PERCENT_EQ] = ACTIONS(4828),
    [anon_sym_PLUS_EQ] = ACTIONS(4828),
    [anon_sym_DASH_EQ] = ACTIONS(4828),
    [anon_sym_LT_LT_EQ] = ACTIONS(4828),
    [anon_sym_GT_GT_EQ] = ACTIONS(4826),
    [anon_sym_AMP_EQ] = ACTIONS(4828),
    [anon_sym_CARET_EQ] = ACTIONS(4828),
    [anon_sym_PIPE_EQ] = ACTIONS(4828),
    [anon_sym_and_eq] = ACTIONS(4828),
    [anon_sym_or_eq] = ACTIONS(4828),
    [anon_sym_xor_eq] = ACTIONS(4828),
    [anon_sym_LT_EQ_GT] = ACTIONS(4828),
    [anon_sym_or] = ACTIONS(4826),
    [anon_sym_and] = ACTIONS(4826),
    [anon_sym_bitor] = ACTIONS(4828),
    [anon_sym_xor] = ACTIONS(4826),
    [anon_sym_bitand] = ACTIONS(4828),
    [anon_sym_not_eq] = ACTIONS(4828),
    [anon_sym_DASH_DASH] = ACTIONS(4828),
    [anon_sym_PLUS_PLUS] = ACTIONS(4828),
    [anon_sym_DOT] = ACTIONS(4826),
    [anon_sym_DOT_STAR] = ACTIONS(4828),
    [anon_sym_DASH_GT] = ACTIONS(4828),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4828),
    [anon_sym_decltype] = ACTIONS(4828),
    [anon_sym_final] = ACTIONS(4828),
    [anon_sym_override] = ACTIONS(4828),
    [anon_sym_GT2] = ACTIONS(4828),
  },
  [1642] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4820),
    [anon_sym_COMMA] = ACTIONS(4820),
    [anon_sym_LPAREN2] = ACTIONS(4820),
    [anon_sym_DASH] = ACTIONS(4818),
    [anon_sym_PLUS] = ACTIONS(4818),
    [anon_sym_STAR] = ACTIONS(4818),
    [anon_sym_SLASH] = ACTIONS(4818),
    [anon_sym_PERCENT] = ACTIONS(4818),
    [anon_sym_PIPE_PIPE] = ACTIONS(4820),
    [anon_sym_AMP_AMP] = ACTIONS(4820),
    [anon_sym_PIPE] = ACTIONS(4818),
    [anon_sym_CARET] = ACTIONS(4818),
    [anon_sym_AMP] = ACTIONS(4818),
    [anon_sym_EQ_EQ] = ACTIONS(4820),
    [anon_sym_BANG_EQ] = ACTIONS(4820),
    [anon_sym_GT] = ACTIONS(4818),
    [anon_sym_GT_EQ] = ACTIONS(4818),
    [anon_sym_LT_EQ] = ACTIONS(4818),
    [anon_sym_LT] = ACTIONS(4818),
    [anon_sym_LT_LT] = ACTIONS(4818),
    [anon_sym_GT_GT] = ACTIONS(4818),
    [anon_sym___extension__] = ACTIONS(4820),
    [anon_sym___attribute__] = ACTIONS(4820),
    [anon_sym___attribute] = ACTIONS(4818),
    [anon_sym_COLON_COLON] = ACTIONS(4820),
    [anon_sym_LBRACE] = ACTIONS(4820),
    [anon_sym_LBRACK] = ACTIONS(4820),
    [anon_sym_EQ] = ACTIONS(4818),
    [anon_sym_const] = ACTIONS(4818),
    [anon_sym_constexpr] = ACTIONS(4820),
    [anon_sym_volatile] = ACTIONS(4820),
    [anon_sym_restrict] = ACTIONS(4820),
    [anon_sym___restrict__] = ACTIONS(4820),
    [anon_sym__Atomic] = ACTIONS(4820),
    [anon_sym__Noreturn] = ACTIONS(4820),
    [anon_sym_noreturn] = ACTIONS(4820),
    [anon_sym__Nonnull] = ACTIONS(4820),
    [anon_sym_mutable] = ACTIONS(4820),
    [anon_sym_constinit] = ACTIONS(4820),
    [anon_sym_consteval] = ACTIONS(4820),
    [anon_sym_alignas] = ACTIONS(4820),
    [anon_sym__Alignas] = ACTIONS(4820),
    [anon_sym_COLON] = ACTIONS(4818),
    [anon_sym_QMARK] = ACTIONS(4820),
    [anon_sym_STAR_EQ] = ACTIONS(4820),
    [anon_sym_SLASH_EQ] = ACTIONS(4820),
    [anon_sym_PERCENT_EQ] = ACTIONS(4820),
    [anon_sym_PLUS_EQ] = ACTIONS(4820),
    [anon_sym_DASH_EQ] = ACTIONS(4820),
    [anon_sym_LT_LT_EQ] = ACTIONS(4820),
    [anon_sym_GT_GT_EQ] = ACTIONS(4818),
    [anon_sym_AMP_EQ] = ACTIONS(4820),
    [anon_sym_CARET_EQ] = ACTIONS(4820),
    [anon_sym_PIPE_EQ] = ACTIONS(4820),
    [anon_sym_and_eq] = ACTIONS(4820),
    [anon_sym_or_eq] = ACTIONS(4820),
    [anon_sym_xor_eq] = ACTIONS(4820),
    [anon_sym_LT_EQ_GT] = ACTIONS(4820),
    [anon_sym_or] = ACTIONS(4818),
    [anon_sym_and] = ACTIONS(4818),
    [anon_sym_bitor] = ACTIONS(4820),
    [anon_sym_xor] = ACTIONS(4818),
    [anon_sym_bitand] = ACTIONS(4820),
    [anon_sym_not_eq] = ACTIONS(4820),
    [anon_sym_DASH_DASH] = ACTIONS(4820),
    [anon_sym_PLUS_PLUS] = ACTIONS(4820),
    [anon_sym_DOT] = ACTIONS(4818),
    [anon_sym_DOT_STAR] = ACTIONS(4820),
    [anon_sym_DASH_GT] = ACTIONS(4820),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4820),
    [anon_sym_decltype] = ACTIONS(4820),
    [anon_sym_final] = ACTIONS(4820),
    [anon_sym_override] = ACTIONS(4820),
    [anon_sym_GT2] = ACTIONS(4820),
  },
  [1643] = {
    [sym_catch_clause] = STATE(1640),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1640),
    [sym_identifier] = ACTIONS(2553),
    [aux_sym_preproc_def_token1] = ACTIONS(2553),
    [aux_sym_preproc_if_token1] = ACTIONS(2553),
    [aux_sym_preproc_if_token2] = ACTIONS(2553),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2553),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2553),
    [aux_sym_preproc_else_token1] = ACTIONS(2553),
    [aux_sym_preproc_elif_token1] = ACTIONS(2553),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2553),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2553),
    [sym_preproc_directive] = ACTIONS(2553),
    [anon_sym_LPAREN2] = ACTIONS(2555),
    [anon_sym_TILDE] = ACTIONS(2555),
    [anon_sym_STAR] = ACTIONS(2555),
    [anon_sym_AMP_AMP] = ACTIONS(2555),
    [anon_sym_AMP] = ACTIONS(2553),
    [anon_sym_SEMI] = ACTIONS(2555),
    [anon_sym___extension__] = ACTIONS(2553),
    [anon_sym_typedef] = ACTIONS(2553),
    [anon_sym_virtual] = ACTIONS(2553),
    [anon_sym_extern] = ACTIONS(2553),
    [anon_sym___attribute__] = ACTIONS(2553),
    [anon_sym___attribute] = ACTIONS(2553),
    [anon_sym_COLON_COLON] = ACTIONS(2555),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2555),
    [anon_sym___declspec] = ACTIONS(2553),
    [anon_sym___based] = ACTIONS(2553),
    [anon_sym_signed] = ACTIONS(2553),
    [anon_sym_unsigned] = ACTIONS(2553),
    [anon_sym_long] = ACTIONS(2553),
    [anon_sym_short] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(2553),
    [anon_sym_static] = ACTIONS(2553),
    [anon_sym_register] = ACTIONS(2553),
    [anon_sym_inline] = ACTIONS(2553),
    [anon_sym___inline] = ACTIONS(2553),
    [anon_sym___inline__] = ACTIONS(2553),
    [anon_sym___forceinline] = ACTIONS(2553),
    [anon_sym_thread_local] = ACTIONS(2553),
    [anon_sym___thread] = ACTIONS(2553),
    [anon_sym_const] = ACTIONS(2553),
    [anon_sym_constexpr] = ACTIONS(2553),
    [anon_sym_volatile] = ACTIONS(2553),
    [anon_sym_restrict] = ACTIONS(2553),
    [anon_sym___restrict__] = ACTIONS(2553),
    [anon_sym__Atomic] = ACTIONS(2553),
    [anon_sym__Noreturn] = ACTIONS(2553),
    [anon_sym_noreturn] = ACTIONS(2553),
    [anon_sym__Nonnull] = ACTIONS(2553),
    [anon_sym_mutable] = ACTIONS(2553),
    [anon_sym_constinit] = ACTIONS(2553),
    [anon_sym_consteval] = ACTIONS(2553),
    [anon_sym_alignas] = ACTIONS(2553),
    [anon_sym__Alignas] = ACTIONS(2553),
    [sym_primitive_type] = ACTIONS(2553),
    [anon_sym_enum] = ACTIONS(2553),
    [anon_sym_class] = ACTIONS(2553),
    [anon_sym_struct] = ACTIONS(2553),
    [anon_sym_union] = ACTIONS(2553),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2553),
    [anon_sym_decltype] = ACTIONS(2553),
    [anon_sym_explicit] = ACTIONS(2553),
    [anon_sym_typename] = ACTIONS(2553),
    [anon_sym_template] = ACTIONS(2553),
    [anon_sym_operator] = ACTIONS(2553),
    [anon_sym_friend] = ACTIONS(2553),
    [anon_sym_public] = ACTIONS(2553),
    [anon_sym_private] = ACTIONS(2553),
    [anon_sym_protected] = ACTIONS(2553),
    [anon_sym_using] = ACTIONS(2553),
    [anon_sym_static_assert] = ACTIONS(2553),
    [anon_sym_catch] = ACTIONS(5243),
  },
  [1644] = {
    [sym_identifier] = ACTIONS(5245),
    [anon_sym_LPAREN2] = ACTIONS(5247),
    [anon_sym_BANG] = ACTIONS(5247),
    [anon_sym_TILDE] = ACTIONS(5247),
    [anon_sym_DASH] = ACTIONS(5245),
    [anon_sym_PLUS] = ACTIONS(5245),
    [anon_sym_STAR] = ACTIONS(5247),
    [anon_sym_AMP] = ACTIONS(5247),
    [anon_sym_SEMI] = ACTIONS(5247),
    [anon_sym___extension__] = ACTIONS(5245),
    [anon_sym_COLON_COLON] = ACTIONS(5247),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5247),
    [anon_sym_LBRACE] = ACTIONS(5247),
    [anon_sym_LBRACK] = ACTIONS(5245),
    [sym_primitive_type] = ACTIONS(5245),
    [anon_sym_if] = ACTIONS(5245),
    [anon_sym_switch] = ACTIONS(5245),
    [anon_sym_case] = ACTIONS(5245),
    [anon_sym_default] = ACTIONS(5245),
    [anon_sym_while] = ACTIONS(5245),
    [anon_sym_do] = ACTIONS(5245),
    [anon_sym_for] = ACTIONS(5245),
    [anon_sym_return] = ACTIONS(5245),
    [anon_sym_break] = ACTIONS(5245),
    [anon_sym_continue] = ACTIONS(5245),
    [anon_sym_goto] = ACTIONS(5245),
    [anon_sym___try] = ACTIONS(5245),
    [anon_sym___leave] = ACTIONS(5245),
    [anon_sym_not] = ACTIONS(5245),
    [anon_sym_compl] = ACTIONS(5245),
    [anon_sym_DASH_DASH] = ACTIONS(5247),
    [anon_sym_PLUS_PLUS] = ACTIONS(5247),
    [anon_sym_sizeof] = ACTIONS(5245),
    [anon_sym___alignof__] = ACTIONS(5245),
    [anon_sym___alignof] = ACTIONS(5245),
    [anon_sym__alignof] = ACTIONS(5245),
    [anon_sym_alignof] = ACTIONS(5245),
    [anon_sym__Alignof] = ACTIONS(5245),
    [anon_sym_offsetof] = ACTIONS(5245),
    [anon_sym__Generic] = ACTIONS(5245),
    [anon_sym_asm] = ACTIONS(5245),
    [anon_sym___asm__] = ACTIONS(5245),
    [anon_sym___asm] = ACTIONS(5245),
    [sym_number_literal] = ACTIONS(5247),
    [anon_sym_L_SQUOTE] = ACTIONS(5247),
    [anon_sym_u_SQUOTE] = ACTIONS(5247),
    [anon_sym_U_SQUOTE] = ACTIONS(5247),
    [anon_sym_u8_SQUOTE] = ACTIONS(5247),
    [anon_sym_SQUOTE] = ACTIONS(5247),
    [anon_sym_L_DQUOTE] = ACTIONS(5247),
    [anon_sym_u_DQUOTE] = ACTIONS(5247),
    [anon_sym_U_DQUOTE] = ACTIONS(5247),
    [anon_sym_u8_DQUOTE] = ACTIONS(5247),
    [anon_sym_DQUOTE] = ACTIONS(5247),
    [sym_true] = ACTIONS(5245),
    [sym_false] = ACTIONS(5245),
    [anon_sym_NULL] = ACTIONS(5245),
    [anon_sym_nullptr] = ACTIONS(5245),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(5245),
    [anon_sym_template] = ACTIONS(5245),
    [anon_sym_try] = ACTIONS(5245),
    [anon_sym_delete] = ACTIONS(5245),
    [anon_sym_throw] = ACTIONS(5245),
    [anon_sym_co_return] = ACTIONS(5245),
    [anon_sym_co_yield] = ACTIONS(5245),
    [anon_sym_R_DQUOTE] = ACTIONS(5247),
    [anon_sym_LR_DQUOTE] = ACTIONS(5247),
    [anon_sym_uR_DQUOTE] = ACTIONS(5247),
    [anon_sym_UR_DQUOTE] = ACTIONS(5247),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5247),
    [anon_sym_co_await] = ACTIONS(5245),
    [anon_sym_new] = ACTIONS(5245),
    [anon_sym_requires] = ACTIONS(5245),
    [sym_this] = ACTIONS(5245),
  },
  [1645] = {
    [sym_identifier] = ACTIONS(4939),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4941),
    [anon_sym_COMMA] = ACTIONS(4941),
    [anon_sym_RPAREN] = ACTIONS(4941),
    [aux_sym_preproc_if_token2] = ACTIONS(4941),
    [aux_sym_preproc_else_token1] = ACTIONS(4941),
    [aux_sym_preproc_elif_token1] = ACTIONS(4939),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4941),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4941),
    [anon_sym_LPAREN2] = ACTIONS(4941),
    [anon_sym_DASH] = ACTIONS(4939),
    [anon_sym_PLUS] = ACTIONS(4939),
    [anon_sym_STAR] = ACTIONS(4941),
    [anon_sym_SLASH] = ACTIONS(4939),
    [anon_sym_PERCENT] = ACTIONS(4941),
    [anon_sym_PIPE_PIPE] = ACTIONS(4941),
    [anon_sym_AMP_AMP] = ACTIONS(4941),
    [anon_sym_PIPE] = ACTIONS(4939),
    [anon_sym_CARET] = ACTIONS(4941),
    [anon_sym_AMP] = ACTIONS(4939),
    [anon_sym_EQ_EQ] = ACTIONS(4941),
    [anon_sym_BANG_EQ] = ACTIONS(4941),
    [anon_sym_GT] = ACTIONS(4939),
    [anon_sym_GT_EQ] = ACTIONS(4941),
    [anon_sym_LT_EQ] = ACTIONS(4939),
    [anon_sym_LT] = ACTIONS(4939),
    [anon_sym_LT_LT] = ACTIONS(4941),
    [anon_sym_GT_GT] = ACTIONS(4941),
    [anon_sym_SEMI] = ACTIONS(4941),
    [anon_sym___extension__] = ACTIONS(4939),
    [anon_sym___attribute__] = ACTIONS(4939),
    [anon_sym___attribute] = ACTIONS(4939),
    [anon_sym_LBRACE] = ACTIONS(4941),
    [anon_sym_RBRACE] = ACTIONS(4941),
    [anon_sym_signed] = ACTIONS(4939),
    [anon_sym_unsigned] = ACTIONS(4939),
    [anon_sym_long] = ACTIONS(4939),
    [anon_sym_short] = ACTIONS(4939),
    [anon_sym_LBRACK] = ACTIONS(4941),
    [anon_sym_RBRACK] = ACTIONS(4941),
    [anon_sym_const] = ACTIONS(4939),
    [anon_sym_constexpr] = ACTIONS(4939),
    [anon_sym_volatile] = ACTIONS(4939),
    [anon_sym_restrict] = ACTIONS(4939),
    [anon_sym___restrict__] = ACTIONS(4939),
    [anon_sym__Atomic] = ACTIONS(4939),
    [anon_sym__Noreturn] = ACTIONS(4939),
    [anon_sym_noreturn] = ACTIONS(4939),
    [anon_sym__Nonnull] = ACTIONS(4939),
    [anon_sym_mutable] = ACTIONS(4939),
    [anon_sym_constinit] = ACTIONS(4939),
    [anon_sym_consteval] = ACTIONS(4939),
    [anon_sym_alignas] = ACTIONS(4939),
    [anon_sym__Alignas] = ACTIONS(4939),
    [sym_primitive_type] = ACTIONS(4939),
    [anon_sym_COLON] = ACTIONS(4941),
    [anon_sym_QMARK] = ACTIONS(4941),
    [anon_sym_LT_EQ_GT] = ACTIONS(4941),
    [anon_sym_or] = ACTIONS(4939),
    [anon_sym_and] = ACTIONS(4939),
    [anon_sym_bitor] = ACTIONS(4939),
    [anon_sym_xor] = ACTIONS(4939),
    [anon_sym_bitand] = ACTIONS(4939),
    [anon_sym_not_eq] = ACTIONS(4939),
    [anon_sym_DASH_DASH] = ACTIONS(4941),
    [anon_sym_PLUS_PLUS] = ACTIONS(4941),
    [anon_sym_DOT] = ACTIONS(4939),
    [anon_sym_DOT_STAR] = ACTIONS(4941),
    [anon_sym_DASH_GT] = ACTIONS(4941),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4939),
    [anon_sym_decltype] = ACTIONS(4939),
    [anon_sym_final] = ACTIONS(4939),
    [anon_sym_override] = ACTIONS(4939),
    [anon_sym_requires] = ACTIONS(4939),
  },
  [1646] = {
    [sym_string_literal] = STATE(1648),
    [sym_raw_string_literal] = STATE(1648),
    [aux_sym_concatenated_string_repeat1] = STATE(1648),
    [sym_identifier] = ACTIONS(5249),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5251),
    [anon_sym_COMMA] = ACTIONS(5251),
    [anon_sym_RPAREN] = ACTIONS(5251),
    [aux_sym_preproc_if_token2] = ACTIONS(5251),
    [aux_sym_preproc_else_token1] = ACTIONS(5251),
    [aux_sym_preproc_elif_token1] = ACTIONS(5253),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5251),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5251),
    [anon_sym_LPAREN2] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5253),
    [anon_sym_PLUS] = ACTIONS(5253),
    [anon_sym_STAR] = ACTIONS(5253),
    [anon_sym_SLASH] = ACTIONS(5253),
    [anon_sym_PERCENT] = ACTIONS(5253),
    [anon_sym_PIPE_PIPE] = ACTIONS(5251),
    [anon_sym_AMP_AMP] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5253),
    [anon_sym_CARET] = ACTIONS(5253),
    [anon_sym_AMP] = ACTIONS(5253),
    [anon_sym_EQ_EQ] = ACTIONS(5251),
    [anon_sym_BANG_EQ] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5253),
    [anon_sym_GT_EQ] = ACTIONS(5251),
    [anon_sym_LT_EQ] = ACTIONS(5253),
    [anon_sym_LT] = ACTIONS(5253),
    [anon_sym_LT_LT] = ACTIONS(5253),
    [anon_sym_GT_GT] = ACTIONS(5253),
    [anon_sym_SEMI] = ACTIONS(5251),
    [anon_sym_RBRACE] = ACTIONS(5251),
    [anon_sym_LBRACK] = ACTIONS(5251),
    [anon_sym_RBRACK] = ACTIONS(5251),
    [anon_sym_EQ] = ACTIONS(5253),
    [anon_sym_COLON] = ACTIONS(5251),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_STAR_EQ] = ACTIONS(5251),
    [anon_sym_SLASH_EQ] = ACTIONS(5251),
    [anon_sym_PERCENT_EQ] = ACTIONS(5251),
    [anon_sym_PLUS_EQ] = ACTIONS(5251),
    [anon_sym_DASH_EQ] = ACTIONS(5251),
    [anon_sym_LT_LT_EQ] = ACTIONS(5251),
    [anon_sym_GT_GT_EQ] = ACTIONS(5251),
    [anon_sym_AMP_EQ] = ACTIONS(5251),
    [anon_sym_CARET_EQ] = ACTIONS(5251),
    [anon_sym_PIPE_EQ] = ACTIONS(5251),
    [anon_sym_and_eq] = ACTIONS(5253),
    [anon_sym_or_eq] = ACTIONS(5253),
    [anon_sym_xor_eq] = ACTIONS(5253),
    [anon_sym_LT_EQ_GT] = ACTIONS(5251),
    [anon_sym_or] = ACTIONS(5253),
    [anon_sym_and] = ACTIONS(5253),
    [anon_sym_bitor] = ACTIONS(5253),
    [anon_sym_xor] = ACTIONS(5253),
    [anon_sym_bitand] = ACTIONS(5253),
    [anon_sym_not_eq] = ACTIONS(5253),
    [anon_sym_DASH_DASH] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5251),
    [anon_sym_DOT] = ACTIONS(5253),
    [anon_sym_DOT_STAR] = ACTIONS(5251),
    [anon_sym_DASH_GT] = ACTIONS(5251),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(1955),
    [anon_sym_LR_DQUOTE] = ACTIONS(1955),
    [anon_sym_uR_DQUOTE] = ACTIONS(1955),
    [anon_sym_UR_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1955),
    [sym_literal_suffix] = ACTIONS(5253),
  },
  [1647] = {
    [sym_catch_clause] = STATE(1640),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1640),
    [sym_identifier] = ACTIONS(2490),
    [aux_sym_preproc_def_token1] = ACTIONS(2490),
    [aux_sym_preproc_if_token1] = ACTIONS(2490),
    [aux_sym_preproc_if_token2] = ACTIONS(2490),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2490),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2490),
    [aux_sym_preproc_else_token1] = ACTIONS(2490),
    [aux_sym_preproc_elif_token1] = ACTIONS(2490),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2490),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2490),
    [sym_preproc_directive] = ACTIONS(2490),
    [anon_sym_LPAREN2] = ACTIONS(2492),
    [anon_sym_TILDE] = ACTIONS(2492),
    [anon_sym_STAR] = ACTIONS(2492),
    [anon_sym_AMP_AMP] = ACTIONS(2492),
    [anon_sym_AMP] = ACTIONS(2490),
    [anon_sym_SEMI] = ACTIONS(2492),
    [anon_sym___extension__] = ACTIONS(2490),
    [anon_sym_typedef] = ACTIONS(2490),
    [anon_sym_virtual] = ACTIONS(2490),
    [anon_sym_extern] = ACTIONS(2490),
    [anon_sym___attribute__] = ACTIONS(2490),
    [anon_sym___attribute] = ACTIONS(2490),
    [anon_sym_COLON_COLON] = ACTIONS(2492),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2492),
    [anon_sym___declspec] = ACTIONS(2490),
    [anon_sym___based] = ACTIONS(2490),
    [anon_sym_signed] = ACTIONS(2490),
    [anon_sym_unsigned] = ACTIONS(2490),
    [anon_sym_long] = ACTIONS(2490),
    [anon_sym_short] = ACTIONS(2490),
    [anon_sym_LBRACK] = ACTIONS(2490),
    [anon_sym_static] = ACTIONS(2490),
    [anon_sym_register] = ACTIONS(2490),
    [anon_sym_inline] = ACTIONS(2490),
    [anon_sym___inline] = ACTIONS(2490),
    [anon_sym___inline__] = ACTIONS(2490),
    [anon_sym___forceinline] = ACTIONS(2490),
    [anon_sym_thread_local] = ACTIONS(2490),
    [anon_sym___thread] = ACTIONS(2490),
    [anon_sym_const] = ACTIONS(2490),
    [anon_sym_constexpr] = ACTIONS(2490),
    [anon_sym_volatile] = ACTIONS(2490),
    [anon_sym_restrict] = ACTIONS(2490),
    [anon_sym___restrict__] = ACTIONS(2490),
    [anon_sym__Atomic] = ACTIONS(2490),
    [anon_sym__Noreturn] = ACTIONS(2490),
    [anon_sym_noreturn] = ACTIONS(2490),
    [anon_sym__Nonnull] = ACTIONS(2490),
    [anon_sym_mutable] = ACTIONS(2490),
    [anon_sym_constinit] = ACTIONS(2490),
    [anon_sym_consteval] = ACTIONS(2490),
    [anon_sym_alignas] = ACTIONS(2490),
    [anon_sym__Alignas] = ACTIONS(2490),
    [sym_primitive_type] = ACTIONS(2490),
    [anon_sym_enum] = ACTIONS(2490),
    [anon_sym_class] = ACTIONS(2490),
    [anon_sym_struct] = ACTIONS(2490),
    [anon_sym_union] = ACTIONS(2490),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2490),
    [anon_sym_decltype] = ACTIONS(2490),
    [anon_sym_explicit] = ACTIONS(2490),
    [anon_sym_typename] = ACTIONS(2490),
    [anon_sym_template] = ACTIONS(2490),
    [anon_sym_operator] = ACTIONS(2490),
    [anon_sym_friend] = ACTIONS(2490),
    [anon_sym_public] = ACTIONS(2490),
    [anon_sym_private] = ACTIONS(2490),
    [anon_sym_protected] = ACTIONS(2490),
    [anon_sym_using] = ACTIONS(2490),
    [anon_sym_static_assert] = ACTIONS(2490),
    [anon_sym_catch] = ACTIONS(5243),
  },
  [1648] = {
    [sym_string_literal] = STATE(1648),
    [sym_raw_string_literal] = STATE(1648),
    [aux_sym_concatenated_string_repeat1] = STATE(1648),
    [sym_identifier] = ACTIONS(5255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5258),
    [anon_sym_COMMA] = ACTIONS(5258),
    [anon_sym_RPAREN] = ACTIONS(5258),
    [aux_sym_preproc_if_token2] = ACTIONS(5258),
    [aux_sym_preproc_else_token1] = ACTIONS(5258),
    [aux_sym_preproc_elif_token1] = ACTIONS(5260),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5258),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5258),
    [anon_sym_LPAREN2] = ACTIONS(5258),
    [anon_sym_DASH] = ACTIONS(5260),
    [anon_sym_PLUS] = ACTIONS(5260),
    [anon_sym_STAR] = ACTIONS(5260),
    [anon_sym_SLASH] = ACTIONS(5260),
    [anon_sym_PERCENT] = ACTIONS(5260),
    [anon_sym_PIPE_PIPE] = ACTIONS(5258),
    [anon_sym_AMP_AMP] = ACTIONS(5258),
    [anon_sym_PIPE] = ACTIONS(5260),
    [anon_sym_CARET] = ACTIONS(5260),
    [anon_sym_AMP] = ACTIONS(5260),
    [anon_sym_EQ_EQ] = ACTIONS(5258),
    [anon_sym_BANG_EQ] = ACTIONS(5258),
    [anon_sym_GT] = ACTIONS(5260),
    [anon_sym_GT_EQ] = ACTIONS(5258),
    [anon_sym_LT_EQ] = ACTIONS(5260),
    [anon_sym_LT] = ACTIONS(5260),
    [anon_sym_LT_LT] = ACTIONS(5260),
    [anon_sym_GT_GT] = ACTIONS(5260),
    [anon_sym_SEMI] = ACTIONS(5258),
    [anon_sym_RBRACE] = ACTIONS(5258),
    [anon_sym_LBRACK] = ACTIONS(5258),
    [anon_sym_RBRACK] = ACTIONS(5258),
    [anon_sym_EQ] = ACTIONS(5260),
    [anon_sym_COLON] = ACTIONS(5258),
    [anon_sym_QMARK] = ACTIONS(5258),
    [anon_sym_STAR_EQ] = ACTIONS(5258),
    [anon_sym_SLASH_EQ] = ACTIONS(5258),
    [anon_sym_PERCENT_EQ] = ACTIONS(5258),
    [anon_sym_PLUS_EQ] = ACTIONS(5258),
    [anon_sym_DASH_EQ] = ACTIONS(5258),
    [anon_sym_LT_LT_EQ] = ACTIONS(5258),
    [anon_sym_GT_GT_EQ] = ACTIONS(5258),
    [anon_sym_AMP_EQ] = ACTIONS(5258),
    [anon_sym_CARET_EQ] = ACTIONS(5258),
    [anon_sym_PIPE_EQ] = ACTIONS(5258),
    [anon_sym_and_eq] = ACTIONS(5260),
    [anon_sym_or_eq] = ACTIONS(5260),
    [anon_sym_xor_eq] = ACTIONS(5260),
    [anon_sym_LT_EQ_GT] = ACTIONS(5258),
    [anon_sym_or] = ACTIONS(5260),
    [anon_sym_and] = ACTIONS(5260),
    [anon_sym_bitor] = ACTIONS(5260),
    [anon_sym_xor] = ACTIONS(5260),
    [anon_sym_bitand] = ACTIONS(5260),
    [anon_sym_not_eq] = ACTIONS(5260),
    [anon_sym_DASH_DASH] = ACTIONS(5258),
    [anon_sym_PLUS_PLUS] = ACTIONS(5258),
    [anon_sym_DOT] = ACTIONS(5260),
    [anon_sym_DOT_STAR] = ACTIONS(5258),
    [anon_sym_DASH_GT] = ACTIONS(5258),
    [anon_sym_L_DQUOTE] = ACTIONS(5262),
    [anon_sym_u_DQUOTE] = ACTIONS(5262),
    [anon_sym_U_DQUOTE] = ACTIONS(5262),
    [anon_sym_u8_DQUOTE] = ACTIONS(5262),
    [anon_sym_DQUOTE] = ACTIONS(5262),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5265),
    [anon_sym_LR_DQUOTE] = ACTIONS(5265),
    [anon_sym_uR_DQUOTE] = ACTIONS(5265),
    [anon_sym_UR_DQUOTE] = ACTIONS(5265),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5265),
    [sym_literal_suffix] = ACTIONS(5260),
  },
  [1649] = {
    [sym_identifier] = ACTIONS(5268),
    [anon_sym_LPAREN2] = ACTIONS(5270),
    [anon_sym_BANG] = ACTIONS(5270),
    [anon_sym_TILDE] = ACTIONS(5270),
    [anon_sym_DASH] = ACTIONS(5268),
    [anon_sym_PLUS] = ACTIONS(5268),
    [anon_sym_STAR] = ACTIONS(5270),
    [anon_sym_AMP] = ACTIONS(5270),
    [anon_sym_SEMI] = ACTIONS(5270),
    [anon_sym___extension__] = ACTIONS(5268),
    [anon_sym_COLON_COLON] = ACTIONS(5270),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5270),
    [anon_sym_LBRACE] = ACTIONS(5270),
    [anon_sym_LBRACK] = ACTIONS(5268),
    [sym_primitive_type] = ACTIONS(5268),
    [anon_sym_if] = ACTIONS(5268),
    [anon_sym_switch] = ACTIONS(5268),
    [anon_sym_case] = ACTIONS(5268),
    [anon_sym_default] = ACTIONS(5268),
    [anon_sym_while] = ACTIONS(5268),
    [anon_sym_do] = ACTIONS(5268),
    [anon_sym_for] = ACTIONS(5268),
    [anon_sym_return] = ACTIONS(5268),
    [anon_sym_break] = ACTIONS(5268),
    [anon_sym_continue] = ACTIONS(5268),
    [anon_sym_goto] = ACTIONS(5268),
    [anon_sym___try] = ACTIONS(5268),
    [anon_sym___leave] = ACTIONS(5268),
    [anon_sym_not] = ACTIONS(5268),
    [anon_sym_compl] = ACTIONS(5268),
    [anon_sym_DASH_DASH] = ACTIONS(5270),
    [anon_sym_PLUS_PLUS] = ACTIONS(5270),
    [anon_sym_sizeof] = ACTIONS(5268),
    [anon_sym___alignof__] = ACTIONS(5268),
    [anon_sym___alignof] = ACTIONS(5268),
    [anon_sym__alignof] = ACTIONS(5268),
    [anon_sym_alignof] = ACTIONS(5268),
    [anon_sym__Alignof] = ACTIONS(5268),
    [anon_sym_offsetof] = ACTIONS(5268),
    [anon_sym__Generic] = ACTIONS(5268),
    [anon_sym_asm] = ACTIONS(5268),
    [anon_sym___asm__] = ACTIONS(5268),
    [anon_sym___asm] = ACTIONS(5268),
    [sym_number_literal] = ACTIONS(5270),
    [anon_sym_L_SQUOTE] = ACTIONS(5270),
    [anon_sym_u_SQUOTE] = ACTIONS(5270),
    [anon_sym_U_SQUOTE] = ACTIONS(5270),
    [anon_sym_u8_SQUOTE] = ACTIONS(5270),
    [anon_sym_SQUOTE] = ACTIONS(5270),
    [anon_sym_L_DQUOTE] = ACTIONS(5270),
    [anon_sym_u_DQUOTE] = ACTIONS(5270),
    [anon_sym_U_DQUOTE] = ACTIONS(5270),
    [anon_sym_u8_DQUOTE] = ACTIONS(5270),
    [anon_sym_DQUOTE] = ACTIONS(5270),
    [sym_true] = ACTIONS(5268),
    [sym_false] = ACTIONS(5268),
    [anon_sym_NULL] = ACTIONS(5268),
    [anon_sym_nullptr] = ACTIONS(5268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(5268),
    [anon_sym_template] = ACTIONS(5268),
    [anon_sym_try] = ACTIONS(5268),
    [anon_sym_delete] = ACTIONS(5268),
    [anon_sym_throw] = ACTIONS(5268),
    [anon_sym_co_return] = ACTIONS(5268),
    [anon_sym_co_yield] = ACTIONS(5268),
    [anon_sym_R_DQUOTE] = ACTIONS(5270),
    [anon_sym_LR_DQUOTE] = ACTIONS(5270),
    [anon_sym_uR_DQUOTE] = ACTIONS(5270),
    [anon_sym_UR_DQUOTE] = ACTIONS(5270),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5270),
    [anon_sym_co_await] = ACTIONS(5268),
    [anon_sym_new] = ACTIONS(5268),
    [anon_sym_requires] = ACTIONS(5268),
    [sym_this] = ACTIONS(5268),
  },
  [1650] = {
    [sym_identifier] = ACTIONS(2536),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2526),
    [anon_sym_COMMA] = ACTIONS(2526),
    [anon_sym_RPAREN] = ACTIONS(2526),
    [anon_sym_LPAREN2] = ACTIONS(2526),
    [anon_sym_DASH] = ACTIONS(2536),
    [anon_sym_PLUS] = ACTIONS(2536),
    [anon_sym_STAR] = ACTIONS(2536),
    [anon_sym_SLASH] = ACTIONS(2536),
    [anon_sym_PERCENT] = ACTIONS(2536),
    [anon_sym_PIPE_PIPE] = ACTIONS(2526),
    [anon_sym_AMP_AMP] = ACTIONS(2526),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_CARET] = ACTIONS(2536),
    [anon_sym_AMP] = ACTIONS(2536),
    [anon_sym_EQ_EQ] = ACTIONS(2526),
    [anon_sym_BANG_EQ] = ACTIONS(2526),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_EQ] = ACTIONS(2526),
    [anon_sym_LT_EQ] = ACTIONS(2536),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_LT_LT] = ACTIONS(2536),
    [anon_sym_GT_GT] = ACTIONS(2536),
    [anon_sym___extension__] = ACTIONS(2536),
    [anon_sym___attribute__] = ACTIONS(2536),
    [anon_sym___attribute] = ACTIONS(2536),
    [anon_sym_LBRACE] = ACTIONS(2526),
    [anon_sym_signed] = ACTIONS(2536),
    [anon_sym_unsigned] = ACTIONS(2536),
    [anon_sym_long] = ACTIONS(2536),
    [anon_sym_short] = ACTIONS(2536),
    [anon_sym_LBRACK] = ACTIONS(2526),
    [anon_sym_EQ] = ACTIONS(2536),
    [anon_sym_const] = ACTIONS(2536),
    [anon_sym_constexpr] = ACTIONS(2536),
    [anon_sym_volatile] = ACTIONS(2536),
    [anon_sym_restrict] = ACTIONS(2536),
    [anon_sym___restrict__] = ACTIONS(2536),
    [anon_sym__Atomic] = ACTIONS(2536),
    [anon_sym__Noreturn] = ACTIONS(2536),
    [anon_sym_noreturn] = ACTIONS(2536),
    [anon_sym__Nonnull] = ACTIONS(2536),
    [anon_sym_mutable] = ACTIONS(2536),
    [anon_sym_constinit] = ACTIONS(2536),
    [anon_sym_consteval] = ACTIONS(2536),
    [anon_sym_alignas] = ACTIONS(2536),
    [anon_sym__Alignas] = ACTIONS(2536),
    [sym_primitive_type] = ACTIONS(2536),
    [anon_sym_QMARK] = ACTIONS(2526),
    [anon_sym_STAR_EQ] = ACTIONS(2526),
    [anon_sym_SLASH_EQ] = ACTIONS(2526),
    [anon_sym_PERCENT_EQ] = ACTIONS(2526),
    [anon_sym_PLUS_EQ] = ACTIONS(2526),
    [anon_sym_DASH_EQ] = ACTIONS(2526),
    [anon_sym_LT_LT_EQ] = ACTIONS(2526),
    [anon_sym_GT_GT_EQ] = ACTIONS(2526),
    [anon_sym_AMP_EQ] = ACTIONS(2526),
    [anon_sym_CARET_EQ] = ACTIONS(2526),
    [anon_sym_PIPE_EQ] = ACTIONS(2526),
    [anon_sym_LT_EQ_GT] = ACTIONS(2526),
    [anon_sym_or] = ACTIONS(2536),
    [anon_sym_and] = ACTIONS(2536),
    [anon_sym_bitor] = ACTIONS(2536),
    [anon_sym_xor] = ACTIONS(2536),
    [anon_sym_bitand] = ACTIONS(2536),
    [anon_sym_not_eq] = ACTIONS(2536),
    [anon_sym_DASH_DASH] = ACTIONS(2526),
    [anon_sym_PLUS_PLUS] = ACTIONS(2526),
    [anon_sym_DOT] = ACTIONS(2536),
    [anon_sym_DOT_STAR] = ACTIONS(2526),
    [anon_sym_DASH_GT] = ACTIONS(2536),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2536),
    [anon_sym_decltype] = ACTIONS(2536),
    [anon_sym_DASH_GT_STAR] = ACTIONS(2526),
  },
  [1651] = {
    [sym_identifier] = ACTIONS(2536),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2526),
    [anon_sym_COMMA] = ACTIONS(2526),
    [anon_sym_RPAREN] = ACTIONS(2526),
    [aux_sym_preproc_if_token2] = ACTIONS(2526),
    [aux_sym_preproc_else_token1] = ACTIONS(2526),
    [aux_sym_preproc_elif_token1] = ACTIONS(2536),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2526),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2526),
    [anon_sym_LPAREN2] = ACTIONS(2526),
    [anon_sym_DASH] = ACTIONS(2536),
    [anon_sym_PLUS] = ACTIONS(2536),
    [anon_sym_STAR] = ACTIONS(2526),
    [anon_sym_SLASH] = ACTIONS(2536),
    [anon_sym_PERCENT] = ACTIONS(2526),
    [anon_sym_PIPE_PIPE] = ACTIONS(2526),
    [anon_sym_AMP_AMP] = ACTIONS(2526),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_CARET] = ACTIONS(2526),
    [anon_sym_AMP] = ACTIONS(2536),
    [anon_sym_EQ_EQ] = ACTIONS(2526),
    [anon_sym_BANG_EQ] = ACTIONS(2526),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_EQ] = ACTIONS(2526),
    [anon_sym_LT_EQ] = ACTIONS(2536),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_LT_LT] = ACTIONS(2526),
    [anon_sym_GT_GT] = ACTIONS(2526),
    [anon_sym_SEMI] = ACTIONS(2526),
    [anon_sym___extension__] = ACTIONS(2536),
    [anon_sym___attribute__] = ACTIONS(2536),
    [anon_sym___attribute] = ACTIONS(2536),
    [anon_sym_LBRACE] = ACTIONS(2526),
    [anon_sym_RBRACE] = ACTIONS(2526),
    [anon_sym_signed] = ACTIONS(2536),
    [anon_sym_unsigned] = ACTIONS(2536),
    [anon_sym_long] = ACTIONS(2536),
    [anon_sym_short] = ACTIONS(2536),
    [anon_sym_LBRACK] = ACTIONS(2526),
    [anon_sym_RBRACK] = ACTIONS(2526),
    [anon_sym_const] = ACTIONS(2536),
    [anon_sym_constexpr] = ACTIONS(2536),
    [anon_sym_volatile] = ACTIONS(2536),
    [anon_sym_restrict] = ACTIONS(2536),
    [anon_sym___restrict__] = ACTIONS(2536),
    [anon_sym__Atomic] = ACTIONS(2536),
    [anon_sym__Noreturn] = ACTIONS(2536),
    [anon_sym_noreturn] = ACTIONS(2536),
    [anon_sym__Nonnull] = ACTIONS(2536),
    [anon_sym_mutable] = ACTIONS(2536),
    [anon_sym_constinit] = ACTIONS(2536),
    [anon_sym_consteval] = ACTIONS(2536),
    [anon_sym_alignas] = ACTIONS(2536),
    [anon_sym__Alignas] = ACTIONS(2536),
    [sym_primitive_type] = ACTIONS(2536),
    [anon_sym_COLON] = ACTIONS(2526),
    [anon_sym_QMARK] = ACTIONS(2526),
    [anon_sym_LT_EQ_GT] = ACTIONS(2526),
    [anon_sym_or] = ACTIONS(2536),
    [anon_sym_and] = ACTIONS(2536),
    [anon_sym_bitor] = ACTIONS(2536),
    [anon_sym_xor] = ACTIONS(2536),
    [anon_sym_bitand] = ACTIONS(2536),
    [anon_sym_not_eq] = ACTIONS(2536),
    [anon_sym_DASH_DASH] = ACTIONS(2526),
    [anon_sym_PLUS_PLUS] = ACTIONS(2526),
    [anon_sym_DOT] = ACTIONS(2536),
    [anon_sym_DOT_STAR] = ACTIONS(2526),
    [anon_sym_DASH_GT] = ACTIONS(2526),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2536),
    [anon_sym_decltype] = ACTIONS(2536),
    [anon_sym_final] = ACTIONS(2536),
    [anon_sym_override] = ACTIONS(2536),
    [anon_sym_requires] = ACTIONS(2536),
  },
  [1652] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4824),
    [anon_sym_COMMA] = ACTIONS(4824),
    [anon_sym_LPAREN2] = ACTIONS(4824),
    [anon_sym_DASH] = ACTIONS(4822),
    [anon_sym_PLUS] = ACTIONS(4822),
    [anon_sym_STAR] = ACTIONS(4822),
    [anon_sym_SLASH] = ACTIONS(4822),
    [anon_sym_PERCENT] = ACTIONS(4822),
    [anon_sym_PIPE_PIPE] = ACTIONS(4824),
    [anon_sym_AMP_AMP] = ACTIONS(4824),
    [anon_sym_PIPE] = ACTIONS(4822),
    [anon_sym_CARET] = ACTIONS(4822),
    [anon_sym_AMP] = ACTIONS(4822),
    [anon_sym_EQ_EQ] = ACTIONS(4824),
    [anon_sym_BANG_EQ] = ACTIONS(4824),
    [anon_sym_GT] = ACTIONS(4822),
    [anon_sym_GT_EQ] = ACTIONS(4822),
    [anon_sym_LT_EQ] = ACTIONS(4822),
    [anon_sym_LT] = ACTIONS(4822),
    [anon_sym_LT_LT] = ACTIONS(4822),
    [anon_sym_GT_GT] = ACTIONS(4822),
    [anon_sym___extension__] = ACTIONS(4824),
    [anon_sym___attribute__] = ACTIONS(4824),
    [anon_sym___attribute] = ACTIONS(4822),
    [anon_sym_COLON_COLON] = ACTIONS(4824),
    [anon_sym_LBRACE] = ACTIONS(4824),
    [anon_sym_LBRACK] = ACTIONS(4824),
    [anon_sym_EQ] = ACTIONS(4822),
    [anon_sym_const] = ACTIONS(4822),
    [anon_sym_constexpr] = ACTIONS(4824),
    [anon_sym_volatile] = ACTIONS(4824),
    [anon_sym_restrict] = ACTIONS(4824),
    [anon_sym___restrict__] = ACTIONS(4824),
    [anon_sym__Atomic] = ACTIONS(4824),
    [anon_sym__Noreturn] = ACTIONS(4824),
    [anon_sym_noreturn] = ACTIONS(4824),
    [anon_sym__Nonnull] = ACTIONS(4824),
    [anon_sym_mutable] = ACTIONS(4824),
    [anon_sym_constinit] = ACTIONS(4824),
    [anon_sym_consteval] = ACTIONS(4824),
    [anon_sym_alignas] = ACTIONS(4824),
    [anon_sym__Alignas] = ACTIONS(4824),
    [anon_sym_COLON] = ACTIONS(4822),
    [anon_sym_QMARK] = ACTIONS(4824),
    [anon_sym_STAR_EQ] = ACTIONS(4824),
    [anon_sym_SLASH_EQ] = ACTIONS(4824),
    [anon_sym_PERCENT_EQ] = ACTIONS(4824),
    [anon_sym_PLUS_EQ] = ACTIONS(4824),
    [anon_sym_DASH_EQ] = ACTIONS(4824),
    [anon_sym_LT_LT_EQ] = ACTIONS(4824),
    [anon_sym_GT_GT_EQ] = ACTIONS(4822),
    [anon_sym_AMP_EQ] = ACTIONS(4824),
    [anon_sym_CARET_EQ] = ACTIONS(4824),
    [anon_sym_PIPE_EQ] = ACTIONS(4824),
    [anon_sym_and_eq] = ACTIONS(4824),
    [anon_sym_or_eq] = ACTIONS(4824),
    [anon_sym_xor_eq] = ACTIONS(4824),
    [anon_sym_LT_EQ_GT] = ACTIONS(4824),
    [anon_sym_or] = ACTIONS(4822),
    [anon_sym_and] = ACTIONS(4822),
    [anon_sym_bitor] = ACTIONS(4824),
    [anon_sym_xor] = ACTIONS(4822),
    [anon_sym_bitand] = ACTIONS(4824),
    [anon_sym_not_eq] = ACTIONS(4824),
    [anon_sym_DASH_DASH] = ACTIONS(4824),
    [anon_sym_PLUS_PLUS] = ACTIONS(4824),
    [anon_sym_DOT] = ACTIONS(4822),
    [anon_sym_DOT_STAR] = ACTIONS(4824),
    [anon_sym_DASH_GT] = ACTIONS(4824),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4824),
    [anon_sym_decltype] = ACTIONS(4824),
    [anon_sym_final] = ACTIONS(4824),
    [anon_sym_override] = ACTIONS(4824),
    [anon_sym_GT2] = ACTIONS(4824),
  },
  [1653] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4816),
    [anon_sym_COMMA] = ACTIONS(4816),
    [anon_sym_LPAREN2] = ACTIONS(4816),
    [anon_sym_DASH] = ACTIONS(4814),
    [anon_sym_PLUS] = ACTIONS(4814),
    [anon_sym_STAR] = ACTIONS(4814),
    [anon_sym_SLASH] = ACTIONS(4814),
    [anon_sym_PERCENT] = ACTIONS(4814),
    [anon_sym_PIPE_PIPE] = ACTIONS(4816),
    [anon_sym_AMP_AMP] = ACTIONS(4816),
    [anon_sym_PIPE] = ACTIONS(4814),
    [anon_sym_CARET] = ACTIONS(4814),
    [anon_sym_AMP] = ACTIONS(4814),
    [anon_sym_EQ_EQ] = ACTIONS(4816),
    [anon_sym_BANG_EQ] = ACTIONS(4816),
    [anon_sym_GT] = ACTIONS(4814),
    [anon_sym_GT_EQ] = ACTIONS(4814),
    [anon_sym_LT_EQ] = ACTIONS(4814),
    [anon_sym_LT] = ACTIONS(4814),
    [anon_sym_LT_LT] = ACTIONS(4814),
    [anon_sym_GT_GT] = ACTIONS(4814),
    [anon_sym___extension__] = ACTIONS(4816),
    [anon_sym___attribute__] = ACTIONS(4816),
    [anon_sym___attribute] = ACTIONS(4814),
    [anon_sym_COLON_COLON] = ACTIONS(4816),
    [anon_sym_LBRACE] = ACTIONS(4816),
    [anon_sym_LBRACK] = ACTIONS(4816),
    [anon_sym_EQ] = ACTIONS(4814),
    [anon_sym_const] = ACTIONS(4814),
    [anon_sym_constexpr] = ACTIONS(4816),
    [anon_sym_volatile] = ACTIONS(4816),
    [anon_sym_restrict] = ACTIONS(4816),
    [anon_sym___restrict__] = ACTIONS(4816),
    [anon_sym__Atomic] = ACTIONS(4816),
    [anon_sym__Noreturn] = ACTIONS(4816),
    [anon_sym_noreturn] = ACTIONS(4816),
    [anon_sym__Nonnull] = ACTIONS(4816),
    [anon_sym_mutable] = ACTIONS(4816),
    [anon_sym_constinit] = ACTIONS(4816),
    [anon_sym_consteval] = ACTIONS(4816),
    [anon_sym_alignas] = ACTIONS(4816),
    [anon_sym__Alignas] = ACTIONS(4816),
    [anon_sym_COLON] = ACTIONS(4814),
    [anon_sym_QMARK] = ACTIONS(4816),
    [anon_sym_STAR_EQ] = ACTIONS(4816),
    [anon_sym_SLASH_EQ] = ACTIONS(4816),
    [anon_sym_PERCENT_EQ] = ACTIONS(4816),
    [anon_sym_PLUS_EQ] = ACTIONS(4816),
    [anon_sym_DASH_EQ] = ACTIONS(4816),
    [anon_sym_LT_LT_EQ] = ACTIONS(4816),
    [anon_sym_GT_GT_EQ] = ACTIONS(4814),
    [anon_sym_AMP_EQ] = ACTIONS(4816),
    [anon_sym_CARET_EQ] = ACTIONS(4816),
    [anon_sym_PIPE_EQ] = ACTIONS(4816),
    [anon_sym_and_eq] = ACTIONS(4816),
    [anon_sym_or_eq] = ACTIONS(4816),
    [anon_sym_xor_eq] = ACTIONS(4816),
    [anon_sym_LT_EQ_GT] = ACTIONS(4816),
    [anon_sym_or] = ACTIONS(4814),
    [anon_sym_and] = ACTIONS(4814),
    [anon_sym_bitor] = ACTIONS(4816),
    [anon_sym_xor] = ACTIONS(4814),
    [anon_sym_bitand] = ACTIONS(4816),
    [anon_sym_not_eq] = ACTIONS(4816),
    [anon_sym_DASH_DASH] = ACTIONS(4816),
    [anon_sym_PLUS_PLUS] = ACTIONS(4816),
    [anon_sym_DOT] = ACTIONS(4814),
    [anon_sym_DOT_STAR] = ACTIONS(4816),
    [anon_sym_DASH_GT] = ACTIONS(4816),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4816),
    [anon_sym_decltype] = ACTIONS(4816),
    [anon_sym_final] = ACTIONS(4816),
    [anon_sym_override] = ACTIONS(4816),
    [anon_sym_GT2] = ACTIONS(4816),
  },
  [1654] = {
    [sym_identifier] = ACTIONS(4939),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4941),
    [anon_sym_COMMA] = ACTIONS(4941),
    [anon_sym_RPAREN] = ACTIONS(4941),
    [anon_sym_LPAREN2] = ACTIONS(4941),
    [anon_sym_DASH] = ACTIONS(4939),
    [anon_sym_PLUS] = ACTIONS(4939),
    [anon_sym_STAR] = ACTIONS(4939),
    [anon_sym_SLASH] = ACTIONS(4939),
    [anon_sym_PERCENT] = ACTIONS(4939),
    [anon_sym_PIPE_PIPE] = ACTIONS(4941),
    [anon_sym_AMP_AMP] = ACTIONS(4941),
    [anon_sym_PIPE] = ACTIONS(4939),
    [anon_sym_CARET] = ACTIONS(4939),
    [anon_sym_AMP] = ACTIONS(4939),
    [anon_sym_EQ_EQ] = ACTIONS(4941),
    [anon_sym_BANG_EQ] = ACTIONS(4941),
    [anon_sym_GT] = ACTIONS(4939),
    [anon_sym_GT_EQ] = ACTIONS(4941),
    [anon_sym_LT_EQ] = ACTIONS(4939),
    [anon_sym_LT] = ACTIONS(4939),
    [anon_sym_LT_LT] = ACTIONS(4939),
    [anon_sym_GT_GT] = ACTIONS(4939),
    [anon_sym___extension__] = ACTIONS(4939),
    [anon_sym___attribute__] = ACTIONS(4939),
    [anon_sym___attribute] = ACTIONS(4939),
    [anon_sym_LBRACE] = ACTIONS(4941),
    [anon_sym_signed] = ACTIONS(4939),
    [anon_sym_unsigned] = ACTIONS(4939),
    [anon_sym_long] = ACTIONS(4939),
    [anon_sym_short] = ACTIONS(4939),
    [anon_sym_LBRACK] = ACTIONS(4941),
    [anon_sym_EQ] = ACTIONS(4939),
    [anon_sym_const] = ACTIONS(4939),
    [anon_sym_constexpr] = ACTIONS(4939),
    [anon_sym_volatile] = ACTIONS(4939),
    [anon_sym_restrict] = ACTIONS(4939),
    [anon_sym___restrict__] = ACTIONS(4939),
    [anon_sym__Atomic] = ACTIONS(4939),
    [anon_sym__Noreturn] = ACTIONS(4939),
    [anon_sym_noreturn] = ACTIONS(4939),
    [anon_sym__Nonnull] = ACTIONS(4939),
    [anon_sym_mutable] = ACTIONS(4939),
    [anon_sym_constinit] = ACTIONS(4939),
    [anon_sym_consteval] = ACTIONS(4939),
    [anon_sym_alignas] = ACTIONS(4939),
    [anon_sym__Alignas] = ACTIONS(4939),
    [sym_primitive_type] = ACTIONS(4939),
    [anon_sym_QMARK] = ACTIONS(4941),
    [anon_sym_STAR_EQ] = ACTIONS(4941),
    [anon_sym_SLASH_EQ] = ACTIONS(4941),
    [anon_sym_PERCENT_EQ] = ACTIONS(4941),
    [anon_sym_PLUS_EQ] = ACTIONS(4941),
    [anon_sym_DASH_EQ] = ACTIONS(4941),
    [anon_sym_LT_LT_EQ] = ACTIONS(4941),
    [anon_sym_GT_GT_EQ] = ACTIONS(4941),
    [anon_sym_AMP_EQ] = ACTIONS(4941),
    [anon_sym_CARET_EQ] = ACTIONS(4941),
    [anon_sym_PIPE_EQ] = ACTIONS(4941),
    [anon_sym_LT_EQ_GT] = ACTIONS(4941),
    [anon_sym_or] = ACTIONS(4939),
    [anon_sym_and] = ACTIONS(4939),
    [anon_sym_bitor] = ACTIONS(4939),
    [anon_sym_xor] = ACTIONS(4939),
    [anon_sym_bitand] = ACTIONS(4939),
    [anon_sym_not_eq] = ACTIONS(4939),
    [anon_sym_DASH_DASH] = ACTIONS(4941),
    [anon_sym_PLUS_PLUS] = ACTIONS(4941),
    [anon_sym_DOT] = ACTIONS(4939),
    [anon_sym_DOT_STAR] = ACTIONS(4941),
    [anon_sym_DASH_GT] = ACTIONS(4939),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4939),
    [anon_sym_decltype] = ACTIONS(4939),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4941),
  },
  [1655] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4836),
    [anon_sym_COMMA] = ACTIONS(4836),
    [anon_sym_LPAREN2] = ACTIONS(4836),
    [anon_sym_DASH] = ACTIONS(4834),
    [anon_sym_PLUS] = ACTIONS(4834),
    [anon_sym_STAR] = ACTIONS(4834),
    [anon_sym_SLASH] = ACTIONS(4834),
    [anon_sym_PERCENT] = ACTIONS(4834),
    [anon_sym_PIPE_PIPE] = ACTIONS(4836),
    [anon_sym_AMP_AMP] = ACTIONS(4836),
    [anon_sym_PIPE] = ACTIONS(4834),
    [anon_sym_CARET] = ACTIONS(4834),
    [anon_sym_AMP] = ACTIONS(4834),
    [anon_sym_EQ_EQ] = ACTIONS(4836),
    [anon_sym_BANG_EQ] = ACTIONS(4836),
    [anon_sym_GT] = ACTIONS(4834),
    [anon_sym_GT_EQ] = ACTIONS(4834),
    [anon_sym_LT_EQ] = ACTIONS(4834),
    [anon_sym_LT] = ACTIONS(4834),
    [anon_sym_LT_LT] = ACTIONS(4834),
    [anon_sym_GT_GT] = ACTIONS(4834),
    [anon_sym___extension__] = ACTIONS(4836),
    [anon_sym___attribute__] = ACTIONS(4836),
    [anon_sym___attribute] = ACTIONS(4834),
    [anon_sym_COLON_COLON] = ACTIONS(4836),
    [anon_sym_LBRACE] = ACTIONS(4836),
    [anon_sym_LBRACK] = ACTIONS(4836),
    [anon_sym_EQ] = ACTIONS(4834),
    [anon_sym_const] = ACTIONS(4834),
    [anon_sym_constexpr] = ACTIONS(4836),
    [anon_sym_volatile] = ACTIONS(4836),
    [anon_sym_restrict] = ACTIONS(4836),
    [anon_sym___restrict__] = ACTIONS(4836),
    [anon_sym__Atomic] = ACTIONS(4836),
    [anon_sym__Noreturn] = ACTIONS(4836),
    [anon_sym_noreturn] = ACTIONS(4836),
    [anon_sym__Nonnull] = ACTIONS(4836),
    [anon_sym_mutable] = ACTIONS(4836),
    [anon_sym_constinit] = ACTIONS(4836),
    [anon_sym_consteval] = ACTIONS(4836),
    [anon_sym_alignas] = ACTIONS(4836),
    [anon_sym__Alignas] = ACTIONS(4836),
    [anon_sym_COLON] = ACTIONS(4834),
    [anon_sym_QMARK] = ACTIONS(4836),
    [anon_sym_STAR_EQ] = ACTIONS(4836),
    [anon_sym_SLASH_EQ] = ACTIONS(4836),
    [anon_sym_PERCENT_EQ] = ACTIONS(4836),
    [anon_sym_PLUS_EQ] = ACTIONS(4836),
    [anon_sym_DASH_EQ] = ACTIONS(4836),
    [anon_sym_LT_LT_EQ] = ACTIONS(4836),
    [anon_sym_GT_GT_EQ] = ACTIONS(4834),
    [anon_sym_AMP_EQ] = ACTIONS(4836),
    [anon_sym_CARET_EQ] = ACTIONS(4836),
    [anon_sym_PIPE_EQ] = ACTIONS(4836),
    [anon_sym_and_eq] = ACTIONS(4836),
    [anon_sym_or_eq] = ACTIONS(4836),
    [anon_sym_xor_eq] = ACTIONS(4836),
    [anon_sym_LT_EQ_GT] = ACTIONS(4836),
    [anon_sym_or] = ACTIONS(4834),
    [anon_sym_and] = ACTIONS(4834),
    [anon_sym_bitor] = ACTIONS(4836),
    [anon_sym_xor] = ACTIONS(4834),
    [anon_sym_bitand] = ACTIONS(4836),
    [anon_sym_not_eq] = ACTIONS(4836),
    [anon_sym_DASH_DASH] = ACTIONS(4836),
    [anon_sym_PLUS_PLUS] = ACTIONS(4836),
    [anon_sym_DOT] = ACTIONS(4834),
    [anon_sym_DOT_STAR] = ACTIONS(4836),
    [anon_sym_DASH_GT] = ACTIONS(4836),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4836),
    [anon_sym_decltype] = ACTIONS(4836),
    [anon_sym_final] = ACTIONS(4836),
    [anon_sym_override] = ACTIONS(4836),
    [anon_sym_GT2] = ACTIONS(4836),
  },
  [1656] = {
    [sym_string_literal] = STATE(1646),
    [sym_raw_string_literal] = STATE(1646),
    [aux_sym_concatenated_string_repeat1] = STATE(1646),
    [sym_identifier] = ACTIONS(5272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5274),
    [anon_sym_COMMA] = ACTIONS(5274),
    [anon_sym_RPAREN] = ACTIONS(5274),
    [aux_sym_preproc_if_token2] = ACTIONS(5274),
    [aux_sym_preproc_else_token1] = ACTIONS(5274),
    [aux_sym_preproc_elif_token1] = ACTIONS(5276),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5274),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5274),
    [anon_sym_LPAREN2] = ACTIONS(5274),
    [anon_sym_DASH] = ACTIONS(5276),
    [anon_sym_PLUS] = ACTIONS(5276),
    [anon_sym_STAR] = ACTIONS(5276),
    [anon_sym_SLASH] = ACTIONS(5276),
    [anon_sym_PERCENT] = ACTIONS(5276),
    [anon_sym_PIPE_PIPE] = ACTIONS(5274),
    [anon_sym_AMP_AMP] = ACTIONS(5274),
    [anon_sym_PIPE] = ACTIONS(5276),
    [anon_sym_CARET] = ACTIONS(5276),
    [anon_sym_AMP] = ACTIONS(5276),
    [anon_sym_EQ_EQ] = ACTIONS(5274),
    [anon_sym_BANG_EQ] = ACTIONS(5274),
    [anon_sym_GT] = ACTIONS(5276),
    [anon_sym_GT_EQ] = ACTIONS(5274),
    [anon_sym_LT_EQ] = ACTIONS(5276),
    [anon_sym_LT] = ACTIONS(5276),
    [anon_sym_LT_LT] = ACTIONS(5276),
    [anon_sym_GT_GT] = ACTIONS(5276),
    [anon_sym_SEMI] = ACTIONS(5274),
    [anon_sym_RBRACE] = ACTIONS(5274),
    [anon_sym_LBRACK] = ACTIONS(5274),
    [anon_sym_RBRACK] = ACTIONS(5274),
    [anon_sym_EQ] = ACTIONS(5276),
    [anon_sym_COLON] = ACTIONS(5274),
    [anon_sym_QMARK] = ACTIONS(5274),
    [anon_sym_STAR_EQ] = ACTIONS(5274),
    [anon_sym_SLASH_EQ] = ACTIONS(5274),
    [anon_sym_PERCENT_EQ] = ACTIONS(5274),
    [anon_sym_PLUS_EQ] = ACTIONS(5274),
    [anon_sym_DASH_EQ] = ACTIONS(5274),
    [anon_sym_LT_LT_EQ] = ACTIONS(5274),
    [anon_sym_GT_GT_EQ] = ACTIONS(5274),
    [anon_sym_AMP_EQ] = ACTIONS(5274),
    [anon_sym_CARET_EQ] = ACTIONS(5274),
    [anon_sym_PIPE_EQ] = ACTIONS(5274),
    [anon_sym_and_eq] = ACTIONS(5276),
    [anon_sym_or_eq] = ACTIONS(5276),
    [anon_sym_xor_eq] = ACTIONS(5276),
    [anon_sym_LT_EQ_GT] = ACTIONS(5274),
    [anon_sym_or] = ACTIONS(5276),
    [anon_sym_and] = ACTIONS(5276),
    [anon_sym_bitor] = ACTIONS(5276),
    [anon_sym_xor] = ACTIONS(5276),
    [anon_sym_bitand] = ACTIONS(5276),
    [anon_sym_not_eq] = ACTIONS(5276),
    [anon_sym_DASH_DASH] = ACTIONS(5274),
    [anon_sym_PLUS_PLUS] = ACTIONS(5274),
    [anon_sym_DOT] = ACTIONS(5276),
    [anon_sym_DOT_STAR] = ACTIONS(5274),
    [anon_sym_DASH_GT] = ACTIONS(5274),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(1955),
    [anon_sym_LR_DQUOTE] = ACTIONS(1955),
    [anon_sym_uR_DQUOTE] = ACTIONS(1955),
    [anon_sym_UR_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1955),
    [sym_literal_suffix] = ACTIONS(5276),
  },
  [1657] = {
    [sym_catch_clause] = STATE(1640),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1640),
    [sym_identifier] = ACTIONS(2510),
    [aux_sym_preproc_def_token1] = ACTIONS(2510),
    [aux_sym_preproc_if_token1] = ACTIONS(2510),
    [aux_sym_preproc_if_token2] = ACTIONS(2510),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2510),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2510),
    [aux_sym_preproc_else_token1] = ACTIONS(2510),
    [aux_sym_preproc_elif_token1] = ACTIONS(2510),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2510),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2510),
    [sym_preproc_directive] = ACTIONS(2510),
    [anon_sym_LPAREN2] = ACTIONS(2512),
    [anon_sym_TILDE] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2510),
    [anon_sym_SEMI] = ACTIONS(2512),
    [anon_sym___extension__] = ACTIONS(2510),
    [anon_sym_typedef] = ACTIONS(2510),
    [anon_sym_virtual] = ACTIONS(2510),
    [anon_sym_extern] = ACTIONS(2510),
    [anon_sym___attribute__] = ACTIONS(2510),
    [anon_sym___attribute] = ACTIONS(2510),
    [anon_sym_COLON_COLON] = ACTIONS(2512),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2512),
    [anon_sym___declspec] = ACTIONS(2510),
    [anon_sym___based] = ACTIONS(2510),
    [anon_sym_signed] = ACTIONS(2510),
    [anon_sym_unsigned] = ACTIONS(2510),
    [anon_sym_long] = ACTIONS(2510),
    [anon_sym_short] = ACTIONS(2510),
    [anon_sym_LBRACK] = ACTIONS(2510),
    [anon_sym_static] = ACTIONS(2510),
    [anon_sym_register] = ACTIONS(2510),
    [anon_sym_inline] = ACTIONS(2510),
    [anon_sym___inline] = ACTIONS(2510),
    [anon_sym___inline__] = ACTIONS(2510),
    [anon_sym___forceinline] = ACTIONS(2510),
    [anon_sym_thread_local] = ACTIONS(2510),
    [anon_sym___thread] = ACTIONS(2510),
    [anon_sym_const] = ACTIONS(2510),
    [anon_sym_constexpr] = ACTIONS(2510),
    [anon_sym_volatile] = ACTIONS(2510),
    [anon_sym_restrict] = ACTIONS(2510),
    [anon_sym___restrict__] = ACTIONS(2510),
    [anon_sym__Atomic] = ACTIONS(2510),
    [anon_sym__Noreturn] = ACTIONS(2510),
    [anon_sym_noreturn] = ACTIONS(2510),
    [anon_sym__Nonnull] = ACTIONS(2510),
    [anon_sym_mutable] = ACTIONS(2510),
    [anon_sym_constinit] = ACTIONS(2510),
    [anon_sym_consteval] = ACTIONS(2510),
    [anon_sym_alignas] = ACTIONS(2510),
    [anon_sym__Alignas] = ACTIONS(2510),
    [sym_primitive_type] = ACTIONS(2510),
    [anon_sym_enum] = ACTIONS(2510),
    [anon_sym_class] = ACTIONS(2510),
    [anon_sym_struct] = ACTIONS(2510),
    [anon_sym_union] = ACTIONS(2510),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2510),
    [anon_sym_decltype] = ACTIONS(2510),
    [anon_sym_explicit] = ACTIONS(2510),
    [anon_sym_typename] = ACTIONS(2510),
    [anon_sym_template] = ACTIONS(2510),
    [anon_sym_operator] = ACTIONS(2510),
    [anon_sym_friend] = ACTIONS(2510),
    [anon_sym_public] = ACTIONS(2510),
    [anon_sym_private] = ACTIONS(2510),
    [anon_sym_protected] = ACTIONS(2510),
    [anon_sym_using] = ACTIONS(2510),
    [anon_sym_static_assert] = ACTIONS(2510),
    [anon_sym_catch] = ACTIONS(5243),
  },
  [1658] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4832),
    [anon_sym_COMMA] = ACTIONS(4832),
    [anon_sym_LPAREN2] = ACTIONS(4832),
    [anon_sym_DASH] = ACTIONS(4830),
    [anon_sym_PLUS] = ACTIONS(4830),
    [anon_sym_STAR] = ACTIONS(4830),
    [anon_sym_SLASH] = ACTIONS(4830),
    [anon_sym_PERCENT] = ACTIONS(4830),
    [anon_sym_PIPE_PIPE] = ACTIONS(4832),
    [anon_sym_AMP_AMP] = ACTIONS(4832),
    [anon_sym_PIPE] = ACTIONS(4830),
    [anon_sym_CARET] = ACTIONS(4830),
    [anon_sym_AMP] = ACTIONS(4830),
    [anon_sym_EQ_EQ] = ACTIONS(4832),
    [anon_sym_BANG_EQ] = ACTIONS(4832),
    [anon_sym_GT] = ACTIONS(4830),
    [anon_sym_GT_EQ] = ACTIONS(4830),
    [anon_sym_LT_EQ] = ACTIONS(4830),
    [anon_sym_LT] = ACTIONS(4830),
    [anon_sym_LT_LT] = ACTIONS(4830),
    [anon_sym_GT_GT] = ACTIONS(4830),
    [anon_sym___extension__] = ACTIONS(4832),
    [anon_sym___attribute__] = ACTIONS(4832),
    [anon_sym___attribute] = ACTIONS(4830),
    [anon_sym_COLON_COLON] = ACTIONS(4832),
    [anon_sym_LBRACE] = ACTIONS(4832),
    [anon_sym_LBRACK] = ACTIONS(4832),
    [anon_sym_EQ] = ACTIONS(4830),
    [anon_sym_const] = ACTIONS(4830),
    [anon_sym_constexpr] = ACTIONS(4832),
    [anon_sym_volatile] = ACTIONS(4832),
    [anon_sym_restrict] = ACTIONS(4832),
    [anon_sym___restrict__] = ACTIONS(4832),
    [anon_sym__Atomic] = ACTIONS(4832),
    [anon_sym__Noreturn] = ACTIONS(4832),
    [anon_sym_noreturn] = ACTIONS(4832),
    [anon_sym__Nonnull] = ACTIONS(4832),
    [anon_sym_mutable] = ACTIONS(4832),
    [anon_sym_constinit] = ACTIONS(4832),
    [anon_sym_consteval] = ACTIONS(4832),
    [anon_sym_alignas] = ACTIONS(4832),
    [anon_sym__Alignas] = ACTIONS(4832),
    [anon_sym_COLON] = ACTIONS(4830),
    [anon_sym_QMARK] = ACTIONS(4832),
    [anon_sym_STAR_EQ] = ACTIONS(4832),
    [anon_sym_SLASH_EQ] = ACTIONS(4832),
    [anon_sym_PERCENT_EQ] = ACTIONS(4832),
    [anon_sym_PLUS_EQ] = ACTIONS(4832),
    [anon_sym_DASH_EQ] = ACTIONS(4832),
    [anon_sym_LT_LT_EQ] = ACTIONS(4832),
    [anon_sym_GT_GT_EQ] = ACTIONS(4830),
    [anon_sym_AMP_EQ] = ACTIONS(4832),
    [anon_sym_CARET_EQ] = ACTIONS(4832),
    [anon_sym_PIPE_EQ] = ACTIONS(4832),
    [anon_sym_and_eq] = ACTIONS(4832),
    [anon_sym_or_eq] = ACTIONS(4832),
    [anon_sym_xor_eq] = ACTIONS(4832),
    [anon_sym_LT_EQ_GT] = ACTIONS(4832),
    [anon_sym_or] = ACTIONS(4830),
    [anon_sym_and] = ACTIONS(4830),
    [anon_sym_bitor] = ACTIONS(4832),
    [anon_sym_xor] = ACTIONS(4830),
    [anon_sym_bitand] = ACTIONS(4832),
    [anon_sym_not_eq] = ACTIONS(4832),
    [anon_sym_DASH_DASH] = ACTIONS(4832),
    [anon_sym_PLUS_PLUS] = ACTIONS(4832),
    [anon_sym_DOT] = ACTIONS(4830),
    [anon_sym_DOT_STAR] = ACTIONS(4832),
    [anon_sym_DASH_GT] = ACTIONS(4832),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4832),
    [anon_sym_decltype] = ACTIONS(4832),
    [anon_sym_final] = ACTIONS(4832),
    [anon_sym_override] = ACTIONS(4832),
    [anon_sym_GT2] = ACTIONS(4832),
  },
  [1659] = {
    [sym__declaration_modifiers] = STATE(2045),
    [sym__declaration_specifiers] = STATE(3895),
    [sym_attribute_specifier] = STATE(2045),
    [sym_attribute_declaration] = STATE(2045),
    [sym_ms_declspec_modifier] = STATE(2045),
    [sym_storage_class_specifier] = STATE(2045),
    [sym_type_qualifier] = STATE(2045),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_parameter_declaration] = STATE(7054),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_dependent_type] = STATE(2383),
    [sym_optional_parameter_declaration] = STATE(7054),
    [sym_variadic_parameter_declaration] = STATE(7054),
    [sym_template_type] = STATE(2336),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(6511),
    [sym_qualified_type_identifier] = STATE(2978),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2045),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(4869),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5278),
    [anon_sym_RPAREN] = ACTIONS(5280),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(1851),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4879),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(1857),
    [anon_sym_class] = ACTIONS(1859),
    [anon_sym_struct] = ACTIONS(1861),
    [anon_sym_union] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(1887),
    [anon_sym_template] = ACTIONS(1235),
  },
  [1660] = {
    [sym__declaration_modifiers] = STATE(2045),
    [sym__declaration_specifiers] = STATE(3895),
    [sym_attribute_specifier] = STATE(2045),
    [sym_attribute_declaration] = STATE(2045),
    [sym_ms_declspec_modifier] = STATE(2045),
    [sym_storage_class_specifier] = STATE(2045),
    [sym_type_qualifier] = STATE(2045),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_parameter_declaration] = STATE(7329),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_dependent_type] = STATE(2383),
    [sym_optional_parameter_declaration] = STATE(7329),
    [sym_variadic_parameter_declaration] = STATE(7329),
    [sym_template_type] = STATE(2336),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(6511),
    [sym_qualified_type_identifier] = STATE(2978),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2045),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(4869),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5282),
    [anon_sym_RPAREN] = ACTIONS(5284),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(1851),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4879),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(1857),
    [anon_sym_class] = ACTIONS(1859),
    [anon_sym_struct] = ACTIONS(1861),
    [anon_sym_union] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(1887),
    [anon_sym_template] = ACTIONS(1235),
  },
  [1661] = {
    [sym__declaration_modifiers] = STATE(2045),
    [sym__declaration_specifiers] = STATE(3895),
    [sym_attribute_specifier] = STATE(2045),
    [sym_attribute_declaration] = STATE(2045),
    [sym_ms_declspec_modifier] = STATE(2045),
    [sym_storage_class_specifier] = STATE(2045),
    [sym_type_qualifier] = STATE(2045),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_parameter_declaration] = STATE(7157),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_dependent_type] = STATE(2383),
    [sym_optional_parameter_declaration] = STATE(7157),
    [sym_variadic_parameter_declaration] = STATE(7157),
    [sym_template_type] = STATE(2336),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(6511),
    [sym_qualified_type_identifier] = STATE(2978),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2045),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(4869),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5286),
    [anon_sym_RPAREN] = ACTIONS(5288),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(1851),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4879),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(1857),
    [anon_sym_class] = ACTIONS(1859),
    [anon_sym_struct] = ACTIONS(1861),
    [anon_sym_union] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(1887),
    [anon_sym_template] = ACTIONS(1235),
  },
  [1662] = {
    [sym_type_qualifier] = STATE(1662),
    [sym_alignas_qualifier] = STATE(1832),
    [aux_sym_array_declarator_repeat1] = STATE(1662),
    [sym_identifier] = ACTIONS(5290),
    [anon_sym_LPAREN2] = ACTIONS(5292),
    [anon_sym_BANG] = ACTIONS(5292),
    [anon_sym_TILDE] = ACTIONS(5292),
    [anon_sym_DASH] = ACTIONS(5290),
    [anon_sym_PLUS] = ACTIONS(5290),
    [anon_sym_STAR] = ACTIONS(5292),
    [anon_sym_AMP] = ACTIONS(5292),
    [anon_sym___extension__] = ACTIONS(5294),
    [anon_sym_COLON_COLON] = ACTIONS(5292),
    [anon_sym_LBRACK] = ACTIONS(5292),
    [anon_sym_static] = ACTIONS(5297),
    [anon_sym_RBRACK] = ACTIONS(5292),
    [anon_sym_const] = ACTIONS(5294),
    [anon_sym_constexpr] = ACTIONS(5294),
    [anon_sym_volatile] = ACTIONS(5294),
    [anon_sym_restrict] = ACTIONS(5294),
    [anon_sym___restrict__] = ACTIONS(5294),
    [anon_sym__Atomic] = ACTIONS(5294),
    [anon_sym__Noreturn] = ACTIONS(5294),
    [anon_sym_noreturn] = ACTIONS(5294),
    [anon_sym__Nonnull] = ACTIONS(5294),
    [anon_sym_mutable] = ACTIONS(5294),
    [anon_sym_constinit] = ACTIONS(5294),
    [anon_sym_consteval] = ACTIONS(5294),
    [anon_sym_alignas] = ACTIONS(5300),
    [anon_sym__Alignas] = ACTIONS(5300),
    [sym_primitive_type] = ACTIONS(5290),
    [anon_sym_not] = ACTIONS(5290),
    [anon_sym_compl] = ACTIONS(5290),
    [anon_sym_DASH_DASH] = ACTIONS(5292),
    [anon_sym_PLUS_PLUS] = ACTIONS(5292),
    [anon_sym_sizeof] = ACTIONS(5290),
    [anon_sym___alignof__] = ACTIONS(5290),
    [anon_sym___alignof] = ACTIONS(5290),
    [anon_sym__alignof] = ACTIONS(5290),
    [anon_sym_alignof] = ACTIONS(5290),
    [anon_sym__Alignof] = ACTIONS(5290),
    [anon_sym_offsetof] = ACTIONS(5290),
    [anon_sym__Generic] = ACTIONS(5290),
    [anon_sym_asm] = ACTIONS(5290),
    [anon_sym___asm__] = ACTIONS(5290),
    [anon_sym___asm] = ACTIONS(5290),
    [sym_number_literal] = ACTIONS(5292),
    [anon_sym_L_SQUOTE] = ACTIONS(5292),
    [anon_sym_u_SQUOTE] = ACTIONS(5292),
    [anon_sym_U_SQUOTE] = ACTIONS(5292),
    [anon_sym_u8_SQUOTE] = ACTIONS(5292),
    [anon_sym_SQUOTE] = ACTIONS(5292),
    [anon_sym_L_DQUOTE] = ACTIONS(5292),
    [anon_sym_u_DQUOTE] = ACTIONS(5292),
    [anon_sym_U_DQUOTE] = ACTIONS(5292),
    [anon_sym_u8_DQUOTE] = ACTIONS(5292),
    [anon_sym_DQUOTE] = ACTIONS(5292),
    [sym_true] = ACTIONS(5290),
    [sym_false] = ACTIONS(5290),
    [anon_sym_NULL] = ACTIONS(5290),
    [anon_sym_nullptr] = ACTIONS(5290),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(5290),
    [anon_sym_template] = ACTIONS(5290),
    [anon_sym_delete] = ACTIONS(5290),
    [anon_sym_R_DQUOTE] = ACTIONS(5292),
    [anon_sym_LR_DQUOTE] = ACTIONS(5292),
    [anon_sym_uR_DQUOTE] = ACTIONS(5292),
    [anon_sym_UR_DQUOTE] = ACTIONS(5292),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5292),
    [anon_sym_co_await] = ACTIONS(5290),
    [anon_sym_new] = ACTIONS(5290),
    [anon_sym_requires] = ACTIONS(5290),
    [sym_this] = ACTIONS(5290),
  },
  [1663] = {
    [sym__declaration_modifiers] = STATE(2045),
    [sym__declaration_specifiers] = STATE(3895),
    [sym_attribute_specifier] = STATE(2045),
    [sym_attribute_declaration] = STATE(2045),
    [sym_ms_declspec_modifier] = STATE(2045),
    [sym_storage_class_specifier] = STATE(2045),
    [sym_type_qualifier] = STATE(2045),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_parameter_declaration] = STATE(7110),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_dependent_type] = STATE(2383),
    [sym_optional_parameter_declaration] = STATE(7110),
    [sym_variadic_parameter_declaration] = STATE(7110),
    [sym_template_type] = STATE(2336),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(6511),
    [sym_qualified_type_identifier] = STATE(2978),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2045),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(4869),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1901),
    [anon_sym_RPAREN] = ACTIONS(4155),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(1851),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4879),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(1857),
    [anon_sym_class] = ACTIONS(1859),
    [anon_sym_struct] = ACTIONS(1861),
    [anon_sym_union] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(1887),
    [anon_sym_template] = ACTIONS(1235),
  },
  [1664] = {
    [sym__declaration_modifiers] = STATE(2045),
    [sym__declaration_specifiers] = STATE(3895),
    [sym_attribute_specifier] = STATE(2045),
    [sym_attribute_declaration] = STATE(2045),
    [sym_ms_declspec_modifier] = STATE(2045),
    [sym_storage_class_specifier] = STATE(2045),
    [sym_type_qualifier] = STATE(2045),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_parameter_declaration] = STATE(7728),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_dependent_type] = STATE(2383),
    [sym_optional_parameter_declaration] = STATE(7728),
    [sym_variadic_parameter_declaration] = STATE(7728),
    [sym_template_type] = STATE(2336),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(6511),
    [sym_qualified_type_identifier] = STATE(2978),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2045),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(4869),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5303),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(1851),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4879),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(1857),
    [anon_sym_class] = ACTIONS(1859),
    [anon_sym_struct] = ACTIONS(1861),
    [anon_sym_union] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(1887),
    [anon_sym_template] = ACTIONS(1235),
  },
  [1665] = {
    [sym_identifier] = ACTIONS(1913),
    [aux_sym_preproc_def_token1] = ACTIONS(1913),
    [anon_sym_COMMA] = ACTIONS(2721),
    [aux_sym_preproc_if_token1] = ACTIONS(1913),
    [aux_sym_preproc_if_token2] = ACTIONS(1913),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1913),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1913),
    [aux_sym_preproc_else_token1] = ACTIONS(1913),
    [aux_sym_preproc_elif_token1] = ACTIONS(1913),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1913),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1913),
    [sym_preproc_directive] = ACTIONS(1913),
    [anon_sym_LPAREN2] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_AMP_AMP] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1913),
    [anon_sym_SEMI] = ACTIONS(2721),
    [anon_sym___extension__] = ACTIONS(1913),
    [anon_sym_typedef] = ACTIONS(1913),
    [anon_sym_virtual] = ACTIONS(1913),
    [anon_sym_extern] = ACTIONS(1913),
    [anon_sym___attribute__] = ACTIONS(1913),
    [anon_sym___attribute] = ACTIONS(1913),
    [anon_sym_COLON_COLON] = ACTIONS(1911),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1911),
    [anon_sym___declspec] = ACTIONS(1913),
    [anon_sym___based] = ACTIONS(1913),
    [anon_sym_signed] = ACTIONS(1913),
    [anon_sym_unsigned] = ACTIONS(1913),
    [anon_sym_long] = ACTIONS(1913),
    [anon_sym_short] = ACTIONS(1913),
    [anon_sym_LBRACK] = ACTIONS(1913),
    [anon_sym_static] = ACTIONS(1913),
    [anon_sym_register] = ACTIONS(1913),
    [anon_sym_inline] = ACTIONS(1913),
    [anon_sym___inline] = ACTIONS(1913),
    [anon_sym___inline__] = ACTIONS(1913),
    [anon_sym___forceinline] = ACTIONS(1913),
    [anon_sym_thread_local] = ACTIONS(1913),
    [anon_sym___thread] = ACTIONS(1913),
    [anon_sym_const] = ACTIONS(1913),
    [anon_sym_constexpr] = ACTIONS(1913),
    [anon_sym_volatile] = ACTIONS(1913),
    [anon_sym_restrict] = ACTIONS(1913),
    [anon_sym___restrict__] = ACTIONS(1913),
    [anon_sym__Atomic] = ACTIONS(1913),
    [anon_sym__Noreturn] = ACTIONS(1913),
    [anon_sym_noreturn] = ACTIONS(1913),
    [anon_sym__Nonnull] = ACTIONS(1913),
    [anon_sym_mutable] = ACTIONS(1913),
    [anon_sym_constinit] = ACTIONS(1913),
    [anon_sym_consteval] = ACTIONS(1913),
    [anon_sym_alignas] = ACTIONS(1913),
    [anon_sym__Alignas] = ACTIONS(1913),
    [sym_primitive_type] = ACTIONS(1913),
    [anon_sym_enum] = ACTIONS(1913),
    [anon_sym_class] = ACTIONS(1913),
    [anon_sym_struct] = ACTIONS(1913),
    [anon_sym_union] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1913),
    [anon_sym_decltype] = ACTIONS(1913),
    [anon_sym_explicit] = ACTIONS(1913),
    [anon_sym_typename] = ACTIONS(1913),
    [anon_sym_template] = ACTIONS(1913),
    [anon_sym_operator] = ACTIONS(1913),
    [anon_sym_friend] = ACTIONS(1913),
    [anon_sym_public] = ACTIONS(1913),
    [anon_sym_private] = ACTIONS(1913),
    [anon_sym_protected] = ACTIONS(1913),
    [anon_sym_using] = ACTIONS(1913),
    [anon_sym_static_assert] = ACTIONS(1913),
  },
  [1666] = {
    [sym__declaration_modifiers] = STATE(2045),
    [sym__declaration_specifiers] = STATE(3895),
    [sym_attribute_specifier] = STATE(2045),
    [sym_attribute_declaration] = STATE(2045),
    [sym_ms_declspec_modifier] = STATE(2045),
    [sym_storage_class_specifier] = STATE(2045),
    [sym_type_qualifier] = STATE(2045),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_parameter_declaration] = STATE(7330),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_dependent_type] = STATE(2383),
    [sym_optional_parameter_declaration] = STATE(7330),
    [sym_variadic_parameter_declaration] = STATE(7330),
    [sym_template_type] = STATE(2336),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(6511),
    [sym_qualified_type_identifier] = STATE(2978),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2045),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(4869),
    [anon_sym_RPAREN] = ACTIONS(1839),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(1851),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4879),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(1857),
    [anon_sym_class] = ACTIONS(1859),
    [anon_sym_struct] = ACTIONS(1861),
    [anon_sym_union] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(1887),
    [anon_sym_template] = ACTIONS(1235),
  },
  [1667] = {
    [sym_identifier] = ACTIONS(2563),
    [aux_sym_preproc_def_token1] = ACTIONS(2563),
    [aux_sym_preproc_if_token1] = ACTIONS(2563),
    [aux_sym_preproc_if_token2] = ACTIONS(2563),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2563),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2563),
    [aux_sym_preproc_else_token1] = ACTIONS(2563),
    [aux_sym_preproc_elif_token1] = ACTIONS(2563),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2563),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2563),
    [sym_preproc_directive] = ACTIONS(2563),
    [anon_sym_LPAREN2] = ACTIONS(2565),
    [anon_sym_TILDE] = ACTIONS(2565),
    [anon_sym_STAR] = ACTIONS(2565),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_AMP] = ACTIONS(2563),
    [anon_sym_SEMI] = ACTIONS(2565),
    [anon_sym___extension__] = ACTIONS(2563),
    [anon_sym_typedef] = ACTIONS(2563),
    [anon_sym_virtual] = ACTIONS(2563),
    [anon_sym_extern] = ACTIONS(2563),
    [anon_sym___attribute__] = ACTIONS(2563),
    [anon_sym___attribute] = ACTIONS(2563),
    [anon_sym_COLON_COLON] = ACTIONS(2565),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2565),
    [anon_sym___declspec] = ACTIONS(2563),
    [anon_sym___based] = ACTIONS(2563),
    [anon_sym_signed] = ACTIONS(2563),
    [anon_sym_unsigned] = ACTIONS(2563),
    [anon_sym_long] = ACTIONS(2563),
    [anon_sym_short] = ACTIONS(2563),
    [anon_sym_LBRACK] = ACTIONS(2563),
    [anon_sym_static] = ACTIONS(2563),
    [anon_sym_register] = ACTIONS(2563),
    [anon_sym_inline] = ACTIONS(2563),
    [anon_sym___inline] = ACTIONS(2563),
    [anon_sym___inline__] = ACTIONS(2563),
    [anon_sym___forceinline] = ACTIONS(2563),
    [anon_sym_thread_local] = ACTIONS(2563),
    [anon_sym___thread] = ACTIONS(2563),
    [anon_sym_const] = ACTIONS(2563),
    [anon_sym_constexpr] = ACTIONS(2563),
    [anon_sym_volatile] = ACTIONS(2563),
    [anon_sym_restrict] = ACTIONS(2563),
    [anon_sym___restrict__] = ACTIONS(2563),
    [anon_sym__Atomic] = ACTIONS(2563),
    [anon_sym__Noreturn] = ACTIONS(2563),
    [anon_sym_noreturn] = ACTIONS(2563),
    [anon_sym__Nonnull] = ACTIONS(2563),
    [anon_sym_mutable] = ACTIONS(2563),
    [anon_sym_constinit] = ACTIONS(2563),
    [anon_sym_consteval] = ACTIONS(2563),
    [anon_sym_alignas] = ACTIONS(2563),
    [anon_sym__Alignas] = ACTIONS(2563),
    [sym_primitive_type] = ACTIONS(2563),
    [anon_sym_enum] = ACTIONS(2563),
    [anon_sym_class] = ACTIONS(2563),
    [anon_sym_struct] = ACTIONS(2563),
    [anon_sym_union] = ACTIONS(2563),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2563),
    [anon_sym_decltype] = ACTIONS(2563),
    [anon_sym_explicit] = ACTIONS(2563),
    [anon_sym_typename] = ACTIONS(2563),
    [anon_sym_template] = ACTIONS(2563),
    [anon_sym_operator] = ACTIONS(2563),
    [anon_sym_friend] = ACTIONS(2563),
    [anon_sym_public] = ACTIONS(2563),
    [anon_sym_private] = ACTIONS(2563),
    [anon_sym_protected] = ACTIONS(2563),
    [anon_sym_using] = ACTIONS(2563),
    [anon_sym_static_assert] = ACTIONS(2563),
    [anon_sym_catch] = ACTIONS(2563),
  },
  [1668] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4857),
    [anon_sym_COMMA] = ACTIONS(4857),
    [anon_sym_RPAREN] = ACTIONS(4859),
    [anon_sym_LPAREN2] = ACTIONS(4859),
    [anon_sym_DASH] = ACTIONS(4864),
    [anon_sym_PLUS] = ACTIONS(4864),
    [anon_sym_STAR] = ACTIONS(4866),
    [anon_sym_SLASH] = ACTIONS(4864),
    [anon_sym_PERCENT] = ACTIONS(4864),
    [anon_sym_PIPE_PIPE] = ACTIONS(4857),
    [anon_sym_AMP_AMP] = ACTIONS(4859),
    [anon_sym_PIPE] = ACTIONS(4864),
    [anon_sym_CARET] = ACTIONS(4864),
    [anon_sym_AMP] = ACTIONS(4866),
    [anon_sym_EQ_EQ] = ACTIONS(4857),
    [anon_sym_BANG_EQ] = ACTIONS(4857),
    [anon_sym_GT] = ACTIONS(4864),
    [anon_sym_GT_EQ] = ACTIONS(4857),
    [anon_sym_LT_EQ] = ACTIONS(4864),
    [anon_sym_LT] = ACTIONS(4864),
    [anon_sym_LT_LT] = ACTIONS(4864),
    [anon_sym_GT_GT] = ACTIONS(4864),
    [anon_sym_SEMI] = ACTIONS(4857),
    [anon_sym___extension__] = ACTIONS(4862),
    [anon_sym_COLON_COLON] = ACTIONS(4862),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4857),
    [anon_sym_LBRACE] = ACTIONS(4862),
    [anon_sym_LBRACK] = ACTIONS(4866),
    [anon_sym_EQ] = ACTIONS(4864),
    [anon_sym_const] = ACTIONS(4855),
    [anon_sym_constexpr] = ACTIONS(4862),
    [anon_sym_volatile] = ACTIONS(4862),
    [anon_sym_restrict] = ACTIONS(4862),
    [anon_sym___restrict__] = ACTIONS(4862),
    [anon_sym__Atomic] = ACTIONS(4862),
    [anon_sym__Noreturn] = ACTIONS(4862),
    [anon_sym_noreturn] = ACTIONS(4862),
    [anon_sym__Nonnull] = ACTIONS(4862),
    [anon_sym_mutable] = ACTIONS(4862),
    [anon_sym_constinit] = ACTIONS(4862),
    [anon_sym_consteval] = ACTIONS(4862),
    [anon_sym_alignas] = ACTIONS(4862),
    [anon_sym__Alignas] = ACTIONS(4862),
    [anon_sym_QMARK] = ACTIONS(4857),
    [anon_sym_STAR_EQ] = ACTIONS(4857),
    [anon_sym_SLASH_EQ] = ACTIONS(4857),
    [anon_sym_PERCENT_EQ] = ACTIONS(4857),
    [anon_sym_PLUS_EQ] = ACTIONS(4857),
    [anon_sym_DASH_EQ] = ACTIONS(4857),
    [anon_sym_LT_LT_EQ] = ACTIONS(4857),
    [anon_sym_GT_GT_EQ] = ACTIONS(4857),
    [anon_sym_AMP_EQ] = ACTIONS(4857),
    [anon_sym_CARET_EQ] = ACTIONS(4857),
    [anon_sym_PIPE_EQ] = ACTIONS(4857),
    [anon_sym_and_eq] = ACTIONS(4857),
    [anon_sym_or_eq] = ACTIONS(4857),
    [anon_sym_xor_eq] = ACTIONS(4857),
    [anon_sym_LT_EQ_GT] = ACTIONS(4857),
    [anon_sym_or] = ACTIONS(4864),
    [anon_sym_and] = ACTIONS(4864),
    [anon_sym_bitor] = ACTIONS(4857),
    [anon_sym_xor] = ACTIONS(4864),
    [anon_sym_bitand] = ACTIONS(4857),
    [anon_sym_not_eq] = ACTIONS(4857),
    [anon_sym_DASH_DASH] = ACTIONS(4857),
    [anon_sym_PLUS_PLUS] = ACTIONS(4857),
    [anon_sym_DOT] = ACTIONS(4864),
    [anon_sym_DOT_STAR] = ACTIONS(4857),
    [anon_sym_DASH_GT] = ACTIONS(4864),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4862),
    [anon_sym_decltype] = ACTIONS(4862),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4857),
  },
  [1669] = {
    [sym_identifier] = ACTIONS(1913),
    [aux_sym_preproc_def_token1] = ACTIONS(1913),
    [anon_sym_COMMA] = ACTIONS(2721),
    [aux_sym_preproc_if_token1] = ACTIONS(1913),
    [aux_sym_preproc_if_token2] = ACTIONS(1913),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1913),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1913),
    [aux_sym_preproc_else_token1] = ACTIONS(1913),
    [aux_sym_preproc_elif_token1] = ACTIONS(1913),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1913),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1913),
    [sym_preproc_directive] = ACTIONS(1913),
    [anon_sym_LPAREN2] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_AMP_AMP] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1913),
    [anon_sym_SEMI] = ACTIONS(2721),
    [anon_sym___extension__] = ACTIONS(1913),
    [anon_sym_typedef] = ACTIONS(1913),
    [anon_sym_virtual] = ACTIONS(1913),
    [anon_sym_extern] = ACTIONS(1913),
    [anon_sym___attribute__] = ACTIONS(5305),
    [anon_sym___attribute] = ACTIONS(5305),
    [anon_sym_COLON_COLON] = ACTIONS(1911),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1911),
    [anon_sym___declspec] = ACTIONS(1913),
    [anon_sym___based] = ACTIONS(1913),
    [anon_sym_signed] = ACTIONS(1913),
    [anon_sym_unsigned] = ACTIONS(1913),
    [anon_sym_long] = ACTIONS(1913),
    [anon_sym_short] = ACTIONS(1913),
    [anon_sym_LBRACK] = ACTIONS(1913),
    [anon_sym_static] = ACTIONS(1913),
    [anon_sym_register] = ACTIONS(1913),
    [anon_sym_inline] = ACTIONS(1913),
    [anon_sym___inline] = ACTIONS(1913),
    [anon_sym___inline__] = ACTIONS(1913),
    [anon_sym___forceinline] = ACTIONS(1913),
    [anon_sym_thread_local] = ACTIONS(1913),
    [anon_sym___thread] = ACTIONS(1913),
    [anon_sym_const] = ACTIONS(1913),
    [anon_sym_constexpr] = ACTIONS(1913),
    [anon_sym_volatile] = ACTIONS(1913),
    [anon_sym_restrict] = ACTIONS(1913),
    [anon_sym___restrict__] = ACTIONS(1913),
    [anon_sym__Atomic] = ACTIONS(1913),
    [anon_sym__Noreturn] = ACTIONS(1913),
    [anon_sym_noreturn] = ACTIONS(1913),
    [anon_sym__Nonnull] = ACTIONS(1913),
    [anon_sym_mutable] = ACTIONS(1913),
    [anon_sym_constinit] = ACTIONS(1913),
    [anon_sym_consteval] = ACTIONS(1913),
    [anon_sym_alignas] = ACTIONS(1913),
    [anon_sym__Alignas] = ACTIONS(1913),
    [sym_primitive_type] = ACTIONS(1913),
    [anon_sym_enum] = ACTIONS(1913),
    [anon_sym_class] = ACTIONS(1913),
    [anon_sym_struct] = ACTIONS(1913),
    [anon_sym_union] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1913),
    [anon_sym_decltype] = ACTIONS(1913),
    [anon_sym_explicit] = ACTIONS(1913),
    [anon_sym_typename] = ACTIONS(1913),
    [anon_sym_template] = ACTIONS(1913),
    [anon_sym_operator] = ACTIONS(1913),
    [anon_sym_friend] = ACTIONS(1913),
    [anon_sym_public] = ACTIONS(1913),
    [anon_sym_private] = ACTIONS(1913),
    [anon_sym_protected] = ACTIONS(1913),
    [anon_sym_using] = ACTIONS(1913),
    [anon_sym_static_assert] = ACTIONS(1913),
  },
  [1670] = {
    [sym_identifier] = ACTIONS(1909),
    [aux_sym_preproc_def_token1] = ACTIONS(1909),
    [aux_sym_preproc_if_token1] = ACTIONS(1909),
    [aux_sym_preproc_if_token2] = ACTIONS(1909),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1909),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1909),
    [aux_sym_preproc_else_token1] = ACTIONS(1909),
    [aux_sym_preproc_elif_token1] = ACTIONS(1909),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1909),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1909),
    [sym_preproc_directive] = ACTIONS(1909),
    [anon_sym_LPAREN2] = ACTIONS(1907),
    [anon_sym_TILDE] = ACTIONS(1907),
    [anon_sym_STAR] = ACTIONS(1907),
    [anon_sym_AMP_AMP] = ACTIONS(1907),
    [anon_sym_AMP] = ACTIONS(1909),
    [anon_sym_SEMI] = ACTIONS(1907),
    [anon_sym___extension__] = ACTIONS(1909),
    [anon_sym_typedef] = ACTIONS(1909),
    [anon_sym_virtual] = ACTIONS(1909),
    [anon_sym_extern] = ACTIONS(1909),
    [anon_sym___attribute__] = ACTIONS(1909),
    [anon_sym___attribute] = ACTIONS(1909),
    [anon_sym_COLON_COLON] = ACTIONS(1907),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1907),
    [anon_sym___declspec] = ACTIONS(1909),
    [anon_sym___based] = ACTIONS(1909),
    [anon_sym_signed] = ACTIONS(1909),
    [anon_sym_unsigned] = ACTIONS(1909),
    [anon_sym_long] = ACTIONS(1909),
    [anon_sym_short] = ACTIONS(1909),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_static] = ACTIONS(1909),
    [anon_sym_register] = ACTIONS(1909),
    [anon_sym_inline] = ACTIONS(1909),
    [anon_sym___inline] = ACTIONS(1909),
    [anon_sym___inline__] = ACTIONS(1909),
    [anon_sym___forceinline] = ACTIONS(1909),
    [anon_sym_thread_local] = ACTIONS(1909),
    [anon_sym___thread] = ACTIONS(1909),
    [anon_sym_const] = ACTIONS(1909),
    [anon_sym_constexpr] = ACTIONS(1909),
    [anon_sym_volatile] = ACTIONS(1909),
    [anon_sym_restrict] = ACTIONS(1909),
    [anon_sym___restrict__] = ACTIONS(1909),
    [anon_sym__Atomic] = ACTIONS(1909),
    [anon_sym__Noreturn] = ACTIONS(1909),
    [anon_sym_noreturn] = ACTIONS(1909),
    [anon_sym__Nonnull] = ACTIONS(1909),
    [anon_sym_mutable] = ACTIONS(1909),
    [anon_sym_constinit] = ACTIONS(1909),
    [anon_sym_consteval] = ACTIONS(1909),
    [anon_sym_alignas] = ACTIONS(1909),
    [anon_sym__Alignas] = ACTIONS(1909),
    [sym_primitive_type] = ACTIONS(1909),
    [anon_sym_enum] = ACTIONS(1909),
    [anon_sym_class] = ACTIONS(1909),
    [anon_sym_struct] = ACTIONS(1909),
    [anon_sym_union] = ACTIONS(1909),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1909),
    [anon_sym_decltype] = ACTIONS(1909),
    [anon_sym_explicit] = ACTIONS(1909),
    [anon_sym_typename] = ACTIONS(1909),
    [anon_sym_template] = ACTIONS(1909),
    [anon_sym_operator] = ACTIONS(1909),
    [anon_sym_friend] = ACTIONS(1909),
    [anon_sym_public] = ACTIONS(1909),
    [anon_sym_private] = ACTIONS(1909),
    [anon_sym_protected] = ACTIONS(1909),
    [anon_sym_using] = ACTIONS(1909),
    [anon_sym_static_assert] = ACTIONS(1909),
    [anon_sym_catch] = ACTIONS(1909),
  },
  [1671] = {
    [sym_template_argument_list] = STATE(1668),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4840),
    [anon_sym_COMMA] = ACTIONS(4840),
    [anon_sym_RPAREN] = ACTIONS(4842),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DASH] = ACTIONS(4847),
    [anon_sym_PLUS] = ACTIONS(4847),
    [anon_sym_STAR] = ACTIONS(4849),
    [anon_sym_SLASH] = ACTIONS(4847),
    [anon_sym_PERCENT] = ACTIONS(4847),
    [anon_sym_PIPE_PIPE] = ACTIONS(4840),
    [anon_sym_AMP_AMP] = ACTIONS(4842),
    [anon_sym_PIPE] = ACTIONS(4847),
    [anon_sym_CARET] = ACTIONS(4847),
    [anon_sym_AMP] = ACTIONS(4849),
    [anon_sym_EQ_EQ] = ACTIONS(4840),
    [anon_sym_BANG_EQ] = ACTIONS(4840),
    [anon_sym_GT] = ACTIONS(4847),
    [anon_sym_GT_EQ] = ACTIONS(4840),
    [anon_sym_LT_EQ] = ACTIONS(4847),
    [anon_sym_LT] = ACTIONS(4889),
    [anon_sym_LT_LT] = ACTIONS(4847),
    [anon_sym_GT_GT] = ACTIONS(4847),
    [anon_sym___extension__] = ACTIONS(4845),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4840),
    [anon_sym_LBRACE] = ACTIONS(4845),
    [anon_sym_LBRACK] = ACTIONS(4849),
    [anon_sym_EQ] = ACTIONS(4847),
    [anon_sym_const] = ACTIONS(4838),
    [anon_sym_constexpr] = ACTIONS(4845),
    [anon_sym_volatile] = ACTIONS(4845),
    [anon_sym_restrict] = ACTIONS(4845),
    [anon_sym___restrict__] = ACTIONS(4845),
    [anon_sym__Atomic] = ACTIONS(4845),
    [anon_sym__Noreturn] = ACTIONS(4845),
    [anon_sym_noreturn] = ACTIONS(4845),
    [anon_sym__Nonnull] = ACTIONS(4845),
    [anon_sym_mutable] = ACTIONS(4845),
    [anon_sym_constinit] = ACTIONS(4845),
    [anon_sym_consteval] = ACTIONS(4845),
    [anon_sym_alignas] = ACTIONS(4845),
    [anon_sym__Alignas] = ACTIONS(4845),
    [anon_sym_QMARK] = ACTIONS(4840),
    [anon_sym_STAR_EQ] = ACTIONS(4840),
    [anon_sym_SLASH_EQ] = ACTIONS(4840),
    [anon_sym_PERCENT_EQ] = ACTIONS(4840),
    [anon_sym_PLUS_EQ] = ACTIONS(4840),
    [anon_sym_DASH_EQ] = ACTIONS(4840),
    [anon_sym_LT_LT_EQ] = ACTIONS(4840),
    [anon_sym_GT_GT_EQ] = ACTIONS(4840),
    [anon_sym_AMP_EQ] = ACTIONS(4840),
    [anon_sym_CARET_EQ] = ACTIONS(4840),
    [anon_sym_PIPE_EQ] = ACTIONS(4840),
    [anon_sym_and_eq] = ACTIONS(4840),
    [anon_sym_or_eq] = ACTIONS(4840),
    [anon_sym_xor_eq] = ACTIONS(4840),
    [anon_sym_LT_EQ_GT] = ACTIONS(4840),
    [anon_sym_or] = ACTIONS(4847),
    [anon_sym_and] = ACTIONS(4847),
    [anon_sym_bitor] = ACTIONS(4840),
    [anon_sym_xor] = ACTIONS(4847),
    [anon_sym_bitand] = ACTIONS(4840),
    [anon_sym_not_eq] = ACTIONS(4840),
    [anon_sym_DASH_DASH] = ACTIONS(4840),
    [anon_sym_PLUS_PLUS] = ACTIONS(4840),
    [anon_sym_DOT] = ACTIONS(4847),
    [anon_sym_DOT_STAR] = ACTIONS(4840),
    [anon_sym_DASH_GT] = ACTIONS(4847),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4845),
    [anon_sym_decltype] = ACTIONS(4845),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4840),
  },
  [1672] = {
    [sym_identifier] = ACTIONS(1913),
    [aux_sym_preproc_def_token1] = ACTIONS(1913),
    [aux_sym_preproc_if_token1] = ACTIONS(1913),
    [aux_sym_preproc_if_token2] = ACTIONS(1913),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1913),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1913),
    [aux_sym_preproc_else_token1] = ACTIONS(1913),
    [aux_sym_preproc_elif_token1] = ACTIONS(1913),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(1913),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(1913),
    [sym_preproc_directive] = ACTIONS(1913),
    [anon_sym_LPAREN2] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_AMP_AMP] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1913),
    [anon_sym_SEMI] = ACTIONS(1911),
    [anon_sym___extension__] = ACTIONS(1913),
    [anon_sym_typedef] = ACTIONS(1913),
    [anon_sym_virtual] = ACTIONS(1913),
    [anon_sym_extern] = ACTIONS(1913),
    [anon_sym___attribute__] = ACTIONS(1913),
    [anon_sym___attribute] = ACTIONS(1913),
    [anon_sym_COLON_COLON] = ACTIONS(1911),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1911),
    [anon_sym___declspec] = ACTIONS(1913),
    [anon_sym___based] = ACTIONS(1913),
    [anon_sym_signed] = ACTIONS(1913),
    [anon_sym_unsigned] = ACTIONS(1913),
    [anon_sym_long] = ACTIONS(1913),
    [anon_sym_short] = ACTIONS(1913),
    [anon_sym_LBRACK] = ACTIONS(1913),
    [anon_sym_static] = ACTIONS(1913),
    [anon_sym_register] = ACTIONS(1913),
    [anon_sym_inline] = ACTIONS(1913),
    [anon_sym___inline] = ACTIONS(1913),
    [anon_sym___inline__] = ACTIONS(1913),
    [anon_sym___forceinline] = ACTIONS(1913),
    [anon_sym_thread_local] = ACTIONS(1913),
    [anon_sym___thread] = ACTIONS(1913),
    [anon_sym_const] = ACTIONS(1913),
    [anon_sym_constexpr] = ACTIONS(1913),
    [anon_sym_volatile] = ACTIONS(1913),
    [anon_sym_restrict] = ACTIONS(1913),
    [anon_sym___restrict__] = ACTIONS(1913),
    [anon_sym__Atomic] = ACTIONS(1913),
    [anon_sym__Noreturn] = ACTIONS(1913),
    [anon_sym_noreturn] = ACTIONS(1913),
    [anon_sym__Nonnull] = ACTIONS(1913),
    [anon_sym_mutable] = ACTIONS(1913),
    [anon_sym_constinit] = ACTIONS(1913),
    [anon_sym_consteval] = ACTIONS(1913),
    [anon_sym_alignas] = ACTIONS(1913),
    [anon_sym__Alignas] = ACTIONS(1913),
    [sym_primitive_type] = ACTIONS(1913),
    [anon_sym_enum] = ACTIONS(1913),
    [anon_sym_class] = ACTIONS(1913),
    [anon_sym_struct] = ACTIONS(1913),
    [anon_sym_union] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1913),
    [anon_sym_decltype] = ACTIONS(1913),
    [anon_sym_explicit] = ACTIONS(1913),
    [anon_sym_typename] = ACTIONS(1913),
    [anon_sym_template] = ACTIONS(1913),
    [anon_sym_operator] = ACTIONS(1913),
    [anon_sym_friend] = ACTIONS(1913),
    [anon_sym_public] = ACTIONS(1913),
    [anon_sym_private] = ACTIONS(1913),
    [anon_sym_protected] = ACTIONS(1913),
    [anon_sym_using] = ACTIONS(1913),
    [anon_sym_static_assert] = ACTIONS(1913),
    [anon_sym_catch] = ACTIONS(1913),
  },
  [1673] = {
    [sym_identifier] = ACTIONS(5307),
    [aux_sym_preproc_def_token1] = ACTIONS(5307),
    [aux_sym_preproc_if_token1] = ACTIONS(5307),
    [aux_sym_preproc_if_token2] = ACTIONS(5307),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5307),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5307),
    [aux_sym_preproc_else_token1] = ACTIONS(5307),
    [aux_sym_preproc_elif_token1] = ACTIONS(5307),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5307),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5307),
    [sym_preproc_directive] = ACTIONS(5307),
    [anon_sym_LPAREN2] = ACTIONS(5309),
    [anon_sym_TILDE] = ACTIONS(5309),
    [anon_sym_STAR] = ACTIONS(5309),
    [anon_sym_AMP_AMP] = ACTIONS(5309),
    [anon_sym_AMP] = ACTIONS(5307),
    [anon_sym_SEMI] = ACTIONS(5309),
    [anon_sym___extension__] = ACTIONS(5307),
    [anon_sym_typedef] = ACTIONS(5307),
    [anon_sym_virtual] = ACTIONS(5307),
    [anon_sym_extern] = ACTIONS(5307),
    [anon_sym___attribute__] = ACTIONS(5307),
    [anon_sym___attribute] = ACTIONS(5307),
    [anon_sym_COLON_COLON] = ACTIONS(5309),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5309),
    [anon_sym___declspec] = ACTIONS(5307),
    [anon_sym___based] = ACTIONS(5307),
    [anon_sym_signed] = ACTIONS(5307),
    [anon_sym_unsigned] = ACTIONS(5307),
    [anon_sym_long] = ACTIONS(5307),
    [anon_sym_short] = ACTIONS(5307),
    [anon_sym_LBRACK] = ACTIONS(5307),
    [anon_sym_static] = ACTIONS(5307),
    [anon_sym_register] = ACTIONS(5307),
    [anon_sym_inline] = ACTIONS(5307),
    [anon_sym___inline] = ACTIONS(5307),
    [anon_sym___inline__] = ACTIONS(5307),
    [anon_sym___forceinline] = ACTIONS(5307),
    [anon_sym_thread_local] = ACTIONS(5307),
    [anon_sym___thread] = ACTIONS(5307),
    [anon_sym_const] = ACTIONS(5307),
    [anon_sym_constexpr] = ACTIONS(5307),
    [anon_sym_volatile] = ACTIONS(5307),
    [anon_sym_restrict] = ACTIONS(5307),
    [anon_sym___restrict__] = ACTIONS(5307),
    [anon_sym__Atomic] = ACTIONS(5307),
    [anon_sym__Noreturn] = ACTIONS(5307),
    [anon_sym_noreturn] = ACTIONS(5307),
    [anon_sym__Nonnull] = ACTIONS(5307),
    [anon_sym_mutable] = ACTIONS(5307),
    [anon_sym_constinit] = ACTIONS(5307),
    [anon_sym_consteval] = ACTIONS(5307),
    [anon_sym_alignas] = ACTIONS(5307),
    [anon_sym__Alignas] = ACTIONS(5307),
    [sym_primitive_type] = ACTIONS(5307),
    [anon_sym_enum] = ACTIONS(5307),
    [anon_sym_class] = ACTIONS(5307),
    [anon_sym_struct] = ACTIONS(5307),
    [anon_sym_union] = ACTIONS(5307),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5307),
    [anon_sym_decltype] = ACTIONS(5307),
    [anon_sym_explicit] = ACTIONS(5307),
    [anon_sym_typename] = ACTIONS(5307),
    [anon_sym_template] = ACTIONS(5307),
    [anon_sym_operator] = ACTIONS(5307),
    [anon_sym_friend] = ACTIONS(5307),
    [anon_sym_public] = ACTIONS(5307),
    [anon_sym_private] = ACTIONS(5307),
    [anon_sym_protected] = ACTIONS(5307),
    [anon_sym_using] = ACTIONS(5307),
    [anon_sym_static_assert] = ACTIONS(5307),
  },
  [1674] = {
    [sym__declaration_modifiers] = STATE(2045),
    [sym__declaration_specifiers] = STATE(3895),
    [sym_attribute_specifier] = STATE(2045),
    [sym_attribute_declaration] = STATE(2045),
    [sym_ms_declspec_modifier] = STATE(2045),
    [sym_storage_class_specifier] = STATE(2045),
    [sym_type_qualifier] = STATE(2045),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_parameter_declaration] = STATE(7718),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_dependent_type] = STATE(2383),
    [sym_optional_parameter_declaration] = STATE(7718),
    [sym_variadic_parameter_declaration] = STATE(7718),
    [sym_template_type] = STATE(2336),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(6511),
    [sym_qualified_type_identifier] = STATE(2978),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2045),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(4869),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(1851),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4879),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(1857),
    [anon_sym_class] = ACTIONS(1859),
    [anon_sym_struct] = ACTIONS(1861),
    [anon_sym_union] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(1887),
    [anon_sym_template] = ACTIONS(1235),
  },
  [1675] = {
    [sym_identifier] = ACTIONS(3094),
    [aux_sym_preproc_def_token1] = ACTIONS(3094),
    [aux_sym_preproc_if_token1] = ACTIONS(3094),
    [aux_sym_preproc_if_token2] = ACTIONS(3094),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3094),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3094),
    [aux_sym_preproc_else_token1] = ACTIONS(3094),
    [aux_sym_preproc_elif_token1] = ACTIONS(3094),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3094),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3094),
    [sym_preproc_directive] = ACTIONS(3094),
    [anon_sym_LPAREN2] = ACTIONS(3096),
    [anon_sym_TILDE] = ACTIONS(3096),
    [anon_sym_STAR] = ACTIONS(3096),
    [anon_sym_AMP_AMP] = ACTIONS(3096),
    [anon_sym_AMP] = ACTIONS(3094),
    [anon_sym_SEMI] = ACTIONS(3096),
    [anon_sym___extension__] = ACTIONS(3094),
    [anon_sym_typedef] = ACTIONS(3094),
    [anon_sym_virtual] = ACTIONS(3094),
    [anon_sym_extern] = ACTIONS(3094),
    [anon_sym___attribute__] = ACTIONS(3094),
    [anon_sym___attribute] = ACTIONS(3094),
    [anon_sym_COLON_COLON] = ACTIONS(3096),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3096),
    [anon_sym___declspec] = ACTIONS(3094),
    [anon_sym___based] = ACTIONS(3094),
    [anon_sym_signed] = ACTIONS(3094),
    [anon_sym_unsigned] = ACTIONS(3094),
    [anon_sym_long] = ACTIONS(3094),
    [anon_sym_short] = ACTIONS(3094),
    [anon_sym_LBRACK] = ACTIONS(3094),
    [anon_sym_static] = ACTIONS(3094),
    [anon_sym_register] = ACTIONS(3094),
    [anon_sym_inline] = ACTIONS(3094),
    [anon_sym___inline] = ACTIONS(3094),
    [anon_sym___inline__] = ACTIONS(3094),
    [anon_sym___forceinline] = ACTIONS(3094),
    [anon_sym_thread_local] = ACTIONS(3094),
    [anon_sym___thread] = ACTIONS(3094),
    [anon_sym_const] = ACTIONS(3094),
    [anon_sym_constexpr] = ACTIONS(3094),
    [anon_sym_volatile] = ACTIONS(3094),
    [anon_sym_restrict] = ACTIONS(3094),
    [anon_sym___restrict__] = ACTIONS(3094),
    [anon_sym__Atomic] = ACTIONS(3094),
    [anon_sym__Noreturn] = ACTIONS(3094),
    [anon_sym_noreturn] = ACTIONS(3094),
    [anon_sym__Nonnull] = ACTIONS(3094),
    [anon_sym_mutable] = ACTIONS(3094),
    [anon_sym_constinit] = ACTIONS(3094),
    [anon_sym_consteval] = ACTIONS(3094),
    [anon_sym_alignas] = ACTIONS(3094),
    [anon_sym__Alignas] = ACTIONS(3094),
    [sym_primitive_type] = ACTIONS(3094),
    [anon_sym_enum] = ACTIONS(3094),
    [anon_sym_class] = ACTIONS(3094),
    [anon_sym_struct] = ACTIONS(3094),
    [anon_sym_union] = ACTIONS(3094),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3094),
    [anon_sym_decltype] = ACTIONS(3094),
    [anon_sym_explicit] = ACTIONS(3094),
    [anon_sym_typename] = ACTIONS(3094),
    [anon_sym_template] = ACTIONS(3094),
    [anon_sym_operator] = ACTIONS(3094),
    [anon_sym_friend] = ACTIONS(3094),
    [anon_sym_public] = ACTIONS(3094),
    [anon_sym_private] = ACTIONS(3094),
    [anon_sym_protected] = ACTIONS(3094),
    [anon_sym_using] = ACTIONS(3094),
    [anon_sym_static_assert] = ACTIONS(3094),
  },
  [1676] = {
    [sym_identifier] = ACTIONS(3098),
    [aux_sym_preproc_def_token1] = ACTIONS(3098),
    [aux_sym_preproc_if_token1] = ACTIONS(3098),
    [aux_sym_preproc_if_token2] = ACTIONS(3098),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3098),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3098),
    [aux_sym_preproc_else_token1] = ACTIONS(3098),
    [aux_sym_preproc_elif_token1] = ACTIONS(3098),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3098),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3098),
    [sym_preproc_directive] = ACTIONS(3098),
    [anon_sym_LPAREN2] = ACTIONS(3100),
    [anon_sym_TILDE] = ACTIONS(3100),
    [anon_sym_STAR] = ACTIONS(3100),
    [anon_sym_AMP_AMP] = ACTIONS(3100),
    [anon_sym_AMP] = ACTIONS(3098),
    [anon_sym_SEMI] = ACTIONS(3100),
    [anon_sym___extension__] = ACTIONS(3098),
    [anon_sym_typedef] = ACTIONS(3098),
    [anon_sym_virtual] = ACTIONS(3098),
    [anon_sym_extern] = ACTIONS(3098),
    [anon_sym___attribute__] = ACTIONS(3098),
    [anon_sym___attribute] = ACTIONS(3098),
    [anon_sym_COLON_COLON] = ACTIONS(3100),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3100),
    [anon_sym___declspec] = ACTIONS(3098),
    [anon_sym___based] = ACTIONS(3098),
    [anon_sym_signed] = ACTIONS(3098),
    [anon_sym_unsigned] = ACTIONS(3098),
    [anon_sym_long] = ACTIONS(3098),
    [anon_sym_short] = ACTIONS(3098),
    [anon_sym_LBRACK] = ACTIONS(3098),
    [anon_sym_static] = ACTIONS(3098),
    [anon_sym_register] = ACTIONS(3098),
    [anon_sym_inline] = ACTIONS(3098),
    [anon_sym___inline] = ACTIONS(3098),
    [anon_sym___inline__] = ACTIONS(3098),
    [anon_sym___forceinline] = ACTIONS(3098),
    [anon_sym_thread_local] = ACTIONS(3098),
    [anon_sym___thread] = ACTIONS(3098),
    [anon_sym_const] = ACTIONS(3098),
    [anon_sym_constexpr] = ACTIONS(3098),
    [anon_sym_volatile] = ACTIONS(3098),
    [anon_sym_restrict] = ACTIONS(3098),
    [anon_sym___restrict__] = ACTIONS(3098),
    [anon_sym__Atomic] = ACTIONS(3098),
    [anon_sym__Noreturn] = ACTIONS(3098),
    [anon_sym_noreturn] = ACTIONS(3098),
    [anon_sym__Nonnull] = ACTIONS(3098),
    [anon_sym_mutable] = ACTIONS(3098),
    [anon_sym_constinit] = ACTIONS(3098),
    [anon_sym_consteval] = ACTIONS(3098),
    [anon_sym_alignas] = ACTIONS(3098),
    [anon_sym__Alignas] = ACTIONS(3098),
    [sym_primitive_type] = ACTIONS(3098),
    [anon_sym_enum] = ACTIONS(3098),
    [anon_sym_class] = ACTIONS(3098),
    [anon_sym_struct] = ACTIONS(3098),
    [anon_sym_union] = ACTIONS(3098),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3098),
    [anon_sym_decltype] = ACTIONS(3098),
    [anon_sym_explicit] = ACTIONS(3098),
    [anon_sym_typename] = ACTIONS(3098),
    [anon_sym_template] = ACTIONS(3098),
    [anon_sym_operator] = ACTIONS(3098),
    [anon_sym_friend] = ACTIONS(3098),
    [anon_sym_public] = ACTIONS(3098),
    [anon_sym_private] = ACTIONS(3098),
    [anon_sym_protected] = ACTIONS(3098),
    [anon_sym_using] = ACTIONS(3098),
    [anon_sym_static_assert] = ACTIONS(3098),
  },
  [1677] = {
    [sym_identifier] = ACTIONS(3104),
    [aux_sym_preproc_def_token1] = ACTIONS(3104),
    [aux_sym_preproc_if_token1] = ACTIONS(3104),
    [aux_sym_preproc_if_token2] = ACTIONS(3104),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3104),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3104),
    [aux_sym_preproc_else_token1] = ACTIONS(3104),
    [aux_sym_preproc_elif_token1] = ACTIONS(3104),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3104),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3104),
    [sym_preproc_directive] = ACTIONS(3104),
    [anon_sym_LPAREN2] = ACTIONS(3106),
    [anon_sym_TILDE] = ACTIONS(3106),
    [anon_sym_STAR] = ACTIONS(3106),
    [anon_sym_AMP_AMP] = ACTIONS(3106),
    [anon_sym_AMP] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(3106),
    [anon_sym___extension__] = ACTIONS(3104),
    [anon_sym_typedef] = ACTIONS(3104),
    [anon_sym_virtual] = ACTIONS(3104),
    [anon_sym_extern] = ACTIONS(3104),
    [anon_sym___attribute__] = ACTIONS(3104),
    [anon_sym___attribute] = ACTIONS(3104),
    [anon_sym_COLON_COLON] = ACTIONS(3106),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3106),
    [anon_sym___declspec] = ACTIONS(3104),
    [anon_sym___based] = ACTIONS(3104),
    [anon_sym_signed] = ACTIONS(3104),
    [anon_sym_unsigned] = ACTIONS(3104),
    [anon_sym_long] = ACTIONS(3104),
    [anon_sym_short] = ACTIONS(3104),
    [anon_sym_LBRACK] = ACTIONS(3104),
    [anon_sym_static] = ACTIONS(3104),
    [anon_sym_register] = ACTIONS(3104),
    [anon_sym_inline] = ACTIONS(3104),
    [anon_sym___inline] = ACTIONS(3104),
    [anon_sym___inline__] = ACTIONS(3104),
    [anon_sym___forceinline] = ACTIONS(3104),
    [anon_sym_thread_local] = ACTIONS(3104),
    [anon_sym___thread] = ACTIONS(3104),
    [anon_sym_const] = ACTIONS(3104),
    [anon_sym_constexpr] = ACTIONS(3104),
    [anon_sym_volatile] = ACTIONS(3104),
    [anon_sym_restrict] = ACTIONS(3104),
    [anon_sym___restrict__] = ACTIONS(3104),
    [anon_sym__Atomic] = ACTIONS(3104),
    [anon_sym__Noreturn] = ACTIONS(3104),
    [anon_sym_noreturn] = ACTIONS(3104),
    [anon_sym__Nonnull] = ACTIONS(3104),
    [anon_sym_mutable] = ACTIONS(3104),
    [anon_sym_constinit] = ACTIONS(3104),
    [anon_sym_consteval] = ACTIONS(3104),
    [anon_sym_alignas] = ACTIONS(3104),
    [anon_sym__Alignas] = ACTIONS(3104),
    [sym_primitive_type] = ACTIONS(3104),
    [anon_sym_enum] = ACTIONS(3104),
    [anon_sym_class] = ACTIONS(3104),
    [anon_sym_struct] = ACTIONS(3104),
    [anon_sym_union] = ACTIONS(3104),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3104),
    [anon_sym_decltype] = ACTIONS(3104),
    [anon_sym_explicit] = ACTIONS(3104),
    [anon_sym_typename] = ACTIONS(3104),
    [anon_sym_template] = ACTIONS(3104),
    [anon_sym_operator] = ACTIONS(3104),
    [anon_sym_friend] = ACTIONS(3104),
    [anon_sym_public] = ACTIONS(3104),
    [anon_sym_private] = ACTIONS(3104),
    [anon_sym_protected] = ACTIONS(3104),
    [anon_sym_using] = ACTIONS(3104),
    [anon_sym_static_assert] = ACTIONS(3104),
  },
  [1678] = {
    [sym_identifier] = ACTIONS(5311),
    [aux_sym_preproc_def_token1] = ACTIONS(5311),
    [aux_sym_preproc_if_token1] = ACTIONS(5311),
    [aux_sym_preproc_if_token2] = ACTIONS(5311),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5311),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5311),
    [aux_sym_preproc_else_token1] = ACTIONS(5311),
    [aux_sym_preproc_elif_token1] = ACTIONS(5311),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5311),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5311),
    [sym_preproc_directive] = ACTIONS(5311),
    [anon_sym_LPAREN2] = ACTIONS(5313),
    [anon_sym_TILDE] = ACTIONS(5313),
    [anon_sym_STAR] = ACTIONS(5313),
    [anon_sym_AMP_AMP] = ACTIONS(5313),
    [anon_sym_AMP] = ACTIONS(5311),
    [anon_sym_SEMI] = ACTIONS(5313),
    [anon_sym___extension__] = ACTIONS(5311),
    [anon_sym_typedef] = ACTIONS(5311),
    [anon_sym_virtual] = ACTIONS(5311),
    [anon_sym_extern] = ACTIONS(5311),
    [anon_sym___attribute__] = ACTIONS(5311),
    [anon_sym___attribute] = ACTIONS(5311),
    [anon_sym_COLON_COLON] = ACTIONS(5313),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5313),
    [anon_sym___declspec] = ACTIONS(5311),
    [anon_sym___based] = ACTIONS(5311),
    [anon_sym_signed] = ACTIONS(5311),
    [anon_sym_unsigned] = ACTIONS(5311),
    [anon_sym_long] = ACTIONS(5311),
    [anon_sym_short] = ACTIONS(5311),
    [anon_sym_LBRACK] = ACTIONS(5311),
    [anon_sym_static] = ACTIONS(5311),
    [anon_sym_register] = ACTIONS(5311),
    [anon_sym_inline] = ACTIONS(5311),
    [anon_sym___inline] = ACTIONS(5311),
    [anon_sym___inline__] = ACTIONS(5311),
    [anon_sym___forceinline] = ACTIONS(5311),
    [anon_sym_thread_local] = ACTIONS(5311),
    [anon_sym___thread] = ACTIONS(5311),
    [anon_sym_const] = ACTIONS(5311),
    [anon_sym_constexpr] = ACTIONS(5311),
    [anon_sym_volatile] = ACTIONS(5311),
    [anon_sym_restrict] = ACTIONS(5311),
    [anon_sym___restrict__] = ACTIONS(5311),
    [anon_sym__Atomic] = ACTIONS(5311),
    [anon_sym__Noreturn] = ACTIONS(5311),
    [anon_sym_noreturn] = ACTIONS(5311),
    [anon_sym__Nonnull] = ACTIONS(5311),
    [anon_sym_mutable] = ACTIONS(5311),
    [anon_sym_constinit] = ACTIONS(5311),
    [anon_sym_consteval] = ACTIONS(5311),
    [anon_sym_alignas] = ACTIONS(5311),
    [anon_sym__Alignas] = ACTIONS(5311),
    [sym_primitive_type] = ACTIONS(5311),
    [anon_sym_enum] = ACTIONS(5311),
    [anon_sym_class] = ACTIONS(5311),
    [anon_sym_struct] = ACTIONS(5311),
    [anon_sym_union] = ACTIONS(5311),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5311),
    [anon_sym_decltype] = ACTIONS(5311),
    [anon_sym_explicit] = ACTIONS(5311),
    [anon_sym_typename] = ACTIONS(5311),
    [anon_sym_template] = ACTIONS(5311),
    [anon_sym_operator] = ACTIONS(5311),
    [anon_sym_friend] = ACTIONS(5311),
    [anon_sym_public] = ACTIONS(5311),
    [anon_sym_private] = ACTIONS(5311),
    [anon_sym_protected] = ACTIONS(5311),
    [anon_sym_using] = ACTIONS(5311),
    [anon_sym_static_assert] = ACTIONS(5311),
  },
  [1679] = {
    [sym_identifier] = ACTIONS(3146),
    [aux_sym_preproc_def_token1] = ACTIONS(3146),
    [aux_sym_preproc_if_token1] = ACTIONS(3146),
    [aux_sym_preproc_if_token2] = ACTIONS(3146),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3146),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3146),
    [aux_sym_preproc_else_token1] = ACTIONS(3146),
    [aux_sym_preproc_elif_token1] = ACTIONS(3146),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3146),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3146),
    [sym_preproc_directive] = ACTIONS(3146),
    [anon_sym_LPAREN2] = ACTIONS(3148),
    [anon_sym_TILDE] = ACTIONS(3148),
    [anon_sym_STAR] = ACTIONS(3148),
    [anon_sym_AMP_AMP] = ACTIONS(3148),
    [anon_sym_AMP] = ACTIONS(3146),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym___extension__] = ACTIONS(3146),
    [anon_sym_typedef] = ACTIONS(3146),
    [anon_sym_virtual] = ACTIONS(3146),
    [anon_sym_extern] = ACTIONS(3146),
    [anon_sym___attribute__] = ACTIONS(3146),
    [anon_sym___attribute] = ACTIONS(3146),
    [anon_sym_COLON_COLON] = ACTIONS(3148),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3148),
    [anon_sym___declspec] = ACTIONS(3146),
    [anon_sym___based] = ACTIONS(3146),
    [anon_sym_signed] = ACTIONS(3146),
    [anon_sym_unsigned] = ACTIONS(3146),
    [anon_sym_long] = ACTIONS(3146),
    [anon_sym_short] = ACTIONS(3146),
    [anon_sym_LBRACK] = ACTIONS(3146),
    [anon_sym_static] = ACTIONS(3146),
    [anon_sym_register] = ACTIONS(3146),
    [anon_sym_inline] = ACTIONS(3146),
    [anon_sym___inline] = ACTIONS(3146),
    [anon_sym___inline__] = ACTIONS(3146),
    [anon_sym___forceinline] = ACTIONS(3146),
    [anon_sym_thread_local] = ACTIONS(3146),
    [anon_sym___thread] = ACTIONS(3146),
    [anon_sym_const] = ACTIONS(3146),
    [anon_sym_constexpr] = ACTIONS(3146),
    [anon_sym_volatile] = ACTIONS(3146),
    [anon_sym_restrict] = ACTIONS(3146),
    [anon_sym___restrict__] = ACTIONS(3146),
    [anon_sym__Atomic] = ACTIONS(3146),
    [anon_sym__Noreturn] = ACTIONS(3146),
    [anon_sym_noreturn] = ACTIONS(3146),
    [anon_sym__Nonnull] = ACTIONS(3146),
    [anon_sym_mutable] = ACTIONS(3146),
    [anon_sym_constinit] = ACTIONS(3146),
    [anon_sym_consteval] = ACTIONS(3146),
    [anon_sym_alignas] = ACTIONS(3146),
    [anon_sym__Alignas] = ACTIONS(3146),
    [sym_primitive_type] = ACTIONS(3146),
    [anon_sym_enum] = ACTIONS(3146),
    [anon_sym_class] = ACTIONS(3146),
    [anon_sym_struct] = ACTIONS(3146),
    [anon_sym_union] = ACTIONS(3146),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3146),
    [anon_sym_decltype] = ACTIONS(3146),
    [anon_sym_explicit] = ACTIONS(3146),
    [anon_sym_typename] = ACTIONS(3146),
    [anon_sym_template] = ACTIONS(3146),
    [anon_sym_operator] = ACTIONS(3146),
    [anon_sym_friend] = ACTIONS(3146),
    [anon_sym_public] = ACTIONS(3146),
    [anon_sym_private] = ACTIONS(3146),
    [anon_sym_protected] = ACTIONS(3146),
    [anon_sym_using] = ACTIONS(3146),
    [anon_sym_static_assert] = ACTIONS(3146),
  },
  [1680] = {
    [sym_identifier] = ACTIONS(3150),
    [aux_sym_preproc_def_token1] = ACTIONS(3150),
    [aux_sym_preproc_if_token1] = ACTIONS(3150),
    [aux_sym_preproc_if_token2] = ACTIONS(3150),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3150),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3150),
    [aux_sym_preproc_else_token1] = ACTIONS(3150),
    [aux_sym_preproc_elif_token1] = ACTIONS(3150),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3150),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3150),
    [sym_preproc_directive] = ACTIONS(3150),
    [anon_sym_LPAREN2] = ACTIONS(3152),
    [anon_sym_TILDE] = ACTIONS(3152),
    [anon_sym_STAR] = ACTIONS(3152),
    [anon_sym_AMP_AMP] = ACTIONS(3152),
    [anon_sym_AMP] = ACTIONS(3150),
    [anon_sym_SEMI] = ACTIONS(3152),
    [anon_sym___extension__] = ACTIONS(3150),
    [anon_sym_typedef] = ACTIONS(3150),
    [anon_sym_virtual] = ACTIONS(3150),
    [anon_sym_extern] = ACTIONS(3150),
    [anon_sym___attribute__] = ACTIONS(3150),
    [anon_sym___attribute] = ACTIONS(3150),
    [anon_sym_COLON_COLON] = ACTIONS(3152),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3152),
    [anon_sym___declspec] = ACTIONS(3150),
    [anon_sym___based] = ACTIONS(3150),
    [anon_sym_signed] = ACTIONS(3150),
    [anon_sym_unsigned] = ACTIONS(3150),
    [anon_sym_long] = ACTIONS(3150),
    [anon_sym_short] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(3150),
    [anon_sym_static] = ACTIONS(3150),
    [anon_sym_register] = ACTIONS(3150),
    [anon_sym_inline] = ACTIONS(3150),
    [anon_sym___inline] = ACTIONS(3150),
    [anon_sym___inline__] = ACTIONS(3150),
    [anon_sym___forceinline] = ACTIONS(3150),
    [anon_sym_thread_local] = ACTIONS(3150),
    [anon_sym___thread] = ACTIONS(3150),
    [anon_sym_const] = ACTIONS(3150),
    [anon_sym_constexpr] = ACTIONS(3150),
    [anon_sym_volatile] = ACTIONS(3150),
    [anon_sym_restrict] = ACTIONS(3150),
    [anon_sym___restrict__] = ACTIONS(3150),
    [anon_sym__Atomic] = ACTIONS(3150),
    [anon_sym__Noreturn] = ACTIONS(3150),
    [anon_sym_noreturn] = ACTIONS(3150),
    [anon_sym__Nonnull] = ACTIONS(3150),
    [anon_sym_mutable] = ACTIONS(3150),
    [anon_sym_constinit] = ACTIONS(3150),
    [anon_sym_consteval] = ACTIONS(3150),
    [anon_sym_alignas] = ACTIONS(3150),
    [anon_sym__Alignas] = ACTIONS(3150),
    [sym_primitive_type] = ACTIONS(3150),
    [anon_sym_enum] = ACTIONS(3150),
    [anon_sym_class] = ACTIONS(3150),
    [anon_sym_struct] = ACTIONS(3150),
    [anon_sym_union] = ACTIONS(3150),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3150),
    [anon_sym_decltype] = ACTIONS(3150),
    [anon_sym_explicit] = ACTIONS(3150),
    [anon_sym_typename] = ACTIONS(3150),
    [anon_sym_template] = ACTIONS(3150),
    [anon_sym_operator] = ACTIONS(3150),
    [anon_sym_friend] = ACTIONS(3150),
    [anon_sym_public] = ACTIONS(3150),
    [anon_sym_private] = ACTIONS(3150),
    [anon_sym_protected] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_static_assert] = ACTIONS(3150),
  },
  [1681] = {
    [sym_identifier] = ACTIONS(5315),
    [aux_sym_preproc_def_token1] = ACTIONS(5315),
    [aux_sym_preproc_if_token1] = ACTIONS(5315),
    [aux_sym_preproc_if_token2] = ACTIONS(5315),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5315),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5315),
    [aux_sym_preproc_else_token1] = ACTIONS(5315),
    [aux_sym_preproc_elif_token1] = ACTIONS(5315),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5315),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5315),
    [sym_preproc_directive] = ACTIONS(5315),
    [anon_sym_LPAREN2] = ACTIONS(5317),
    [anon_sym_TILDE] = ACTIONS(5317),
    [anon_sym_STAR] = ACTIONS(5317),
    [anon_sym_AMP_AMP] = ACTIONS(5317),
    [anon_sym_AMP] = ACTIONS(5315),
    [anon_sym_SEMI] = ACTIONS(5317),
    [anon_sym___extension__] = ACTIONS(5315),
    [anon_sym_typedef] = ACTIONS(5315),
    [anon_sym_virtual] = ACTIONS(5315),
    [anon_sym_extern] = ACTIONS(5315),
    [anon_sym___attribute__] = ACTIONS(5315),
    [anon_sym___attribute] = ACTIONS(5315),
    [anon_sym_COLON_COLON] = ACTIONS(5317),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5317),
    [anon_sym___declspec] = ACTIONS(5315),
    [anon_sym___based] = ACTIONS(5315),
    [anon_sym_signed] = ACTIONS(5315),
    [anon_sym_unsigned] = ACTIONS(5315),
    [anon_sym_long] = ACTIONS(5315),
    [anon_sym_short] = ACTIONS(5315),
    [anon_sym_LBRACK] = ACTIONS(5315),
    [anon_sym_static] = ACTIONS(5315),
    [anon_sym_register] = ACTIONS(5315),
    [anon_sym_inline] = ACTIONS(5315),
    [anon_sym___inline] = ACTIONS(5315),
    [anon_sym___inline__] = ACTIONS(5315),
    [anon_sym___forceinline] = ACTIONS(5315),
    [anon_sym_thread_local] = ACTIONS(5315),
    [anon_sym___thread] = ACTIONS(5315),
    [anon_sym_const] = ACTIONS(5315),
    [anon_sym_constexpr] = ACTIONS(5315),
    [anon_sym_volatile] = ACTIONS(5315),
    [anon_sym_restrict] = ACTIONS(5315),
    [anon_sym___restrict__] = ACTIONS(5315),
    [anon_sym__Atomic] = ACTIONS(5315),
    [anon_sym__Noreturn] = ACTIONS(5315),
    [anon_sym_noreturn] = ACTIONS(5315),
    [anon_sym__Nonnull] = ACTIONS(5315),
    [anon_sym_mutable] = ACTIONS(5315),
    [anon_sym_constinit] = ACTIONS(5315),
    [anon_sym_consteval] = ACTIONS(5315),
    [anon_sym_alignas] = ACTIONS(5315),
    [anon_sym__Alignas] = ACTIONS(5315),
    [sym_primitive_type] = ACTIONS(5315),
    [anon_sym_enum] = ACTIONS(5315),
    [anon_sym_class] = ACTIONS(5315),
    [anon_sym_struct] = ACTIONS(5315),
    [anon_sym_union] = ACTIONS(5315),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5315),
    [anon_sym_decltype] = ACTIONS(5315),
    [anon_sym_explicit] = ACTIONS(5315),
    [anon_sym_typename] = ACTIONS(5315),
    [anon_sym_template] = ACTIONS(5315),
    [anon_sym_operator] = ACTIONS(5315),
    [anon_sym_friend] = ACTIONS(5315),
    [anon_sym_public] = ACTIONS(5315),
    [anon_sym_private] = ACTIONS(5315),
    [anon_sym_protected] = ACTIONS(5315),
    [anon_sym_using] = ACTIONS(5315),
    [anon_sym_static_assert] = ACTIONS(5315),
  },
  [1682] = {
    [sym_identifier] = ACTIONS(2771),
    [aux_sym_preproc_def_token1] = ACTIONS(2771),
    [aux_sym_preproc_if_token1] = ACTIONS(2771),
    [aux_sym_preproc_if_token2] = ACTIONS(2771),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2771),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2771),
    [aux_sym_preproc_else_token1] = ACTIONS(2771),
    [aux_sym_preproc_elif_token1] = ACTIONS(2771),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2771),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2771),
    [sym_preproc_directive] = ACTIONS(2771),
    [anon_sym_LPAREN2] = ACTIONS(2773),
    [anon_sym_TILDE] = ACTIONS(2773),
    [anon_sym_STAR] = ACTIONS(2773),
    [anon_sym_AMP_AMP] = ACTIONS(2773),
    [anon_sym_AMP] = ACTIONS(2771),
    [anon_sym_SEMI] = ACTIONS(2773),
    [anon_sym___extension__] = ACTIONS(2771),
    [anon_sym_typedef] = ACTIONS(2771),
    [anon_sym_virtual] = ACTIONS(2771),
    [anon_sym_extern] = ACTIONS(2771),
    [anon_sym___attribute__] = ACTIONS(2771),
    [anon_sym___attribute] = ACTIONS(2771),
    [anon_sym_COLON_COLON] = ACTIONS(2773),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2773),
    [anon_sym___declspec] = ACTIONS(2771),
    [anon_sym___based] = ACTIONS(2771),
    [anon_sym_signed] = ACTIONS(2771),
    [anon_sym_unsigned] = ACTIONS(2771),
    [anon_sym_long] = ACTIONS(2771),
    [anon_sym_short] = ACTIONS(2771),
    [anon_sym_LBRACK] = ACTIONS(2771),
    [anon_sym_static] = ACTIONS(2771),
    [anon_sym_register] = ACTIONS(2771),
    [anon_sym_inline] = ACTIONS(2771),
    [anon_sym___inline] = ACTIONS(2771),
    [anon_sym___inline__] = ACTIONS(2771),
    [anon_sym___forceinline] = ACTIONS(2771),
    [anon_sym_thread_local] = ACTIONS(2771),
    [anon_sym___thread] = ACTIONS(2771),
    [anon_sym_const] = ACTIONS(2771),
    [anon_sym_constexpr] = ACTIONS(2771),
    [anon_sym_volatile] = ACTIONS(2771),
    [anon_sym_restrict] = ACTIONS(2771),
    [anon_sym___restrict__] = ACTIONS(2771),
    [anon_sym__Atomic] = ACTIONS(2771),
    [anon_sym__Noreturn] = ACTIONS(2771),
    [anon_sym_noreturn] = ACTIONS(2771),
    [anon_sym__Nonnull] = ACTIONS(2771),
    [anon_sym_mutable] = ACTIONS(2771),
    [anon_sym_constinit] = ACTIONS(2771),
    [anon_sym_consteval] = ACTIONS(2771),
    [anon_sym_alignas] = ACTIONS(2771),
    [anon_sym__Alignas] = ACTIONS(2771),
    [sym_primitive_type] = ACTIONS(2771),
    [anon_sym_enum] = ACTIONS(2771),
    [anon_sym_class] = ACTIONS(2771),
    [anon_sym_struct] = ACTIONS(2771),
    [anon_sym_union] = ACTIONS(2771),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2771),
    [anon_sym_decltype] = ACTIONS(2771),
    [anon_sym_explicit] = ACTIONS(2771),
    [anon_sym_typename] = ACTIONS(2771),
    [anon_sym_template] = ACTIONS(2771),
    [anon_sym_operator] = ACTIONS(2771),
    [anon_sym_friend] = ACTIONS(2771),
    [anon_sym_public] = ACTIONS(2771),
    [anon_sym_private] = ACTIONS(2771),
    [anon_sym_protected] = ACTIONS(2771),
    [anon_sym_using] = ACTIONS(2771),
    [anon_sym_static_assert] = ACTIONS(2771),
  },
  [1683] = {
    [sym_identifier] = ACTIONS(2960),
    [aux_sym_preproc_def_token1] = ACTIONS(2960),
    [aux_sym_preproc_if_token1] = ACTIONS(2960),
    [aux_sym_preproc_if_token2] = ACTIONS(2960),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2960),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2960),
    [aux_sym_preproc_else_token1] = ACTIONS(2960),
    [aux_sym_preproc_elif_token1] = ACTIONS(2960),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2960),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2960),
    [sym_preproc_directive] = ACTIONS(2960),
    [anon_sym_LPAREN2] = ACTIONS(2962),
    [anon_sym_TILDE] = ACTIONS(2962),
    [anon_sym_STAR] = ACTIONS(2962),
    [anon_sym_AMP_AMP] = ACTIONS(2962),
    [anon_sym_AMP] = ACTIONS(2960),
    [anon_sym_SEMI] = ACTIONS(2962),
    [anon_sym___extension__] = ACTIONS(2960),
    [anon_sym_typedef] = ACTIONS(2960),
    [anon_sym_virtual] = ACTIONS(2960),
    [anon_sym_extern] = ACTIONS(2960),
    [anon_sym___attribute__] = ACTIONS(2960),
    [anon_sym___attribute] = ACTIONS(2960),
    [anon_sym_COLON_COLON] = ACTIONS(2962),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2962),
    [anon_sym___declspec] = ACTIONS(2960),
    [anon_sym___based] = ACTIONS(2960),
    [anon_sym_signed] = ACTIONS(2960),
    [anon_sym_unsigned] = ACTIONS(2960),
    [anon_sym_long] = ACTIONS(2960),
    [anon_sym_short] = ACTIONS(2960),
    [anon_sym_LBRACK] = ACTIONS(2960),
    [anon_sym_static] = ACTIONS(2960),
    [anon_sym_register] = ACTIONS(2960),
    [anon_sym_inline] = ACTIONS(2960),
    [anon_sym___inline] = ACTIONS(2960),
    [anon_sym___inline__] = ACTIONS(2960),
    [anon_sym___forceinline] = ACTIONS(2960),
    [anon_sym_thread_local] = ACTIONS(2960),
    [anon_sym___thread] = ACTIONS(2960),
    [anon_sym_const] = ACTIONS(2960),
    [anon_sym_constexpr] = ACTIONS(2960),
    [anon_sym_volatile] = ACTIONS(2960),
    [anon_sym_restrict] = ACTIONS(2960),
    [anon_sym___restrict__] = ACTIONS(2960),
    [anon_sym__Atomic] = ACTIONS(2960),
    [anon_sym__Noreturn] = ACTIONS(2960),
    [anon_sym_noreturn] = ACTIONS(2960),
    [anon_sym__Nonnull] = ACTIONS(2960),
    [anon_sym_mutable] = ACTIONS(2960),
    [anon_sym_constinit] = ACTIONS(2960),
    [anon_sym_consteval] = ACTIONS(2960),
    [anon_sym_alignas] = ACTIONS(2960),
    [anon_sym__Alignas] = ACTIONS(2960),
    [sym_primitive_type] = ACTIONS(2960),
    [anon_sym_enum] = ACTIONS(2960),
    [anon_sym_class] = ACTIONS(2960),
    [anon_sym_struct] = ACTIONS(2960),
    [anon_sym_union] = ACTIONS(2960),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2960),
    [anon_sym_decltype] = ACTIONS(2960),
    [anon_sym_explicit] = ACTIONS(2960),
    [anon_sym_typename] = ACTIONS(2960),
    [anon_sym_template] = ACTIONS(2960),
    [anon_sym_operator] = ACTIONS(2960),
    [anon_sym_friend] = ACTIONS(2960),
    [anon_sym_public] = ACTIONS(2960),
    [anon_sym_private] = ACTIONS(2960),
    [anon_sym_protected] = ACTIONS(2960),
    [anon_sym_using] = ACTIONS(2960),
    [anon_sym_static_assert] = ACTIONS(2960),
  },
  [1684] = {
    [sym_identifier] = ACTIONS(5319),
    [aux_sym_preproc_def_token1] = ACTIONS(5319),
    [aux_sym_preproc_if_token1] = ACTIONS(5319),
    [aux_sym_preproc_if_token2] = ACTIONS(5319),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5319),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5319),
    [aux_sym_preproc_else_token1] = ACTIONS(5319),
    [aux_sym_preproc_elif_token1] = ACTIONS(5319),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5319),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5319),
    [sym_preproc_directive] = ACTIONS(5319),
    [anon_sym_LPAREN2] = ACTIONS(5321),
    [anon_sym_TILDE] = ACTIONS(5321),
    [anon_sym_STAR] = ACTIONS(5321),
    [anon_sym_AMP_AMP] = ACTIONS(5321),
    [anon_sym_AMP] = ACTIONS(5319),
    [anon_sym_SEMI] = ACTIONS(5321),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_typedef] = ACTIONS(5319),
    [anon_sym_virtual] = ACTIONS(5319),
    [anon_sym_extern] = ACTIONS(5319),
    [anon_sym___attribute__] = ACTIONS(5319),
    [anon_sym___attribute] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(5321),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5321),
    [anon_sym___declspec] = ACTIONS(5319),
    [anon_sym___based] = ACTIONS(5319),
    [anon_sym_signed] = ACTIONS(5319),
    [anon_sym_unsigned] = ACTIONS(5319),
    [anon_sym_long] = ACTIONS(5319),
    [anon_sym_short] = ACTIONS(5319),
    [anon_sym_LBRACK] = ACTIONS(5319),
    [anon_sym_static] = ACTIONS(5319),
    [anon_sym_register] = ACTIONS(5319),
    [anon_sym_inline] = ACTIONS(5319),
    [anon_sym___inline] = ACTIONS(5319),
    [anon_sym___inline__] = ACTIONS(5319),
    [anon_sym___forceinline] = ACTIONS(5319),
    [anon_sym_thread_local] = ACTIONS(5319),
    [anon_sym___thread] = ACTIONS(5319),
    [anon_sym_const] = ACTIONS(5319),
    [anon_sym_constexpr] = ACTIONS(5319),
    [anon_sym_volatile] = ACTIONS(5319),
    [anon_sym_restrict] = ACTIONS(5319),
    [anon_sym___restrict__] = ACTIONS(5319),
    [anon_sym__Atomic] = ACTIONS(5319),
    [anon_sym__Noreturn] = ACTIONS(5319),
    [anon_sym_noreturn] = ACTIONS(5319),
    [anon_sym__Nonnull] = ACTIONS(5319),
    [anon_sym_mutable] = ACTIONS(5319),
    [anon_sym_constinit] = ACTIONS(5319),
    [anon_sym_consteval] = ACTIONS(5319),
    [anon_sym_alignas] = ACTIONS(5319),
    [anon_sym__Alignas] = ACTIONS(5319),
    [sym_primitive_type] = ACTIONS(5319),
    [anon_sym_enum] = ACTIONS(5319),
    [anon_sym_class] = ACTIONS(5319),
    [anon_sym_struct] = ACTIONS(5319),
    [anon_sym_union] = ACTIONS(5319),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5319),
    [anon_sym_decltype] = ACTIONS(5319),
    [anon_sym_explicit] = ACTIONS(5319),
    [anon_sym_typename] = ACTIONS(5319),
    [anon_sym_template] = ACTIONS(5319),
    [anon_sym_operator] = ACTIONS(5319),
    [anon_sym_friend] = ACTIONS(5319),
    [anon_sym_public] = ACTIONS(5319),
    [anon_sym_private] = ACTIONS(5319),
    [anon_sym_protected] = ACTIONS(5319),
    [anon_sym_using] = ACTIONS(5319),
    [anon_sym_static_assert] = ACTIONS(5319),
  },
  [1685] = {
    [sym_identifier] = ACTIONS(5323),
    [aux_sym_preproc_def_token1] = ACTIONS(5323),
    [aux_sym_preproc_if_token1] = ACTIONS(5323),
    [aux_sym_preproc_if_token2] = ACTIONS(5323),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5323),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5323),
    [aux_sym_preproc_else_token1] = ACTIONS(5323),
    [aux_sym_preproc_elif_token1] = ACTIONS(5323),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5323),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5323),
    [sym_preproc_directive] = ACTIONS(5323),
    [anon_sym_LPAREN2] = ACTIONS(5325),
    [anon_sym_TILDE] = ACTIONS(5325),
    [anon_sym_STAR] = ACTIONS(5325),
    [anon_sym_AMP_AMP] = ACTIONS(5325),
    [anon_sym_AMP] = ACTIONS(5323),
    [anon_sym_SEMI] = ACTIONS(5325),
    [anon_sym___extension__] = ACTIONS(5323),
    [anon_sym_typedef] = ACTIONS(5323),
    [anon_sym_virtual] = ACTIONS(5323),
    [anon_sym_extern] = ACTIONS(5323),
    [anon_sym___attribute__] = ACTIONS(5323),
    [anon_sym___attribute] = ACTIONS(5323),
    [anon_sym_COLON_COLON] = ACTIONS(5325),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5325),
    [anon_sym___declspec] = ACTIONS(5323),
    [anon_sym___based] = ACTIONS(5323),
    [anon_sym_signed] = ACTIONS(5323),
    [anon_sym_unsigned] = ACTIONS(5323),
    [anon_sym_long] = ACTIONS(5323),
    [anon_sym_short] = ACTIONS(5323),
    [anon_sym_LBRACK] = ACTIONS(5323),
    [anon_sym_static] = ACTIONS(5323),
    [anon_sym_register] = ACTIONS(5323),
    [anon_sym_inline] = ACTIONS(5323),
    [anon_sym___inline] = ACTIONS(5323),
    [anon_sym___inline__] = ACTIONS(5323),
    [anon_sym___forceinline] = ACTIONS(5323),
    [anon_sym_thread_local] = ACTIONS(5323),
    [anon_sym___thread] = ACTIONS(5323),
    [anon_sym_const] = ACTIONS(5323),
    [anon_sym_constexpr] = ACTIONS(5323),
    [anon_sym_volatile] = ACTIONS(5323),
    [anon_sym_restrict] = ACTIONS(5323),
    [anon_sym___restrict__] = ACTIONS(5323),
    [anon_sym__Atomic] = ACTIONS(5323),
    [anon_sym__Noreturn] = ACTIONS(5323),
    [anon_sym_noreturn] = ACTIONS(5323),
    [anon_sym__Nonnull] = ACTIONS(5323),
    [anon_sym_mutable] = ACTIONS(5323),
    [anon_sym_constinit] = ACTIONS(5323),
    [anon_sym_consteval] = ACTIONS(5323),
    [anon_sym_alignas] = ACTIONS(5323),
    [anon_sym__Alignas] = ACTIONS(5323),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_enum] = ACTIONS(5323),
    [anon_sym_class] = ACTIONS(5323),
    [anon_sym_struct] = ACTIONS(5323),
    [anon_sym_union] = ACTIONS(5323),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5323),
    [anon_sym_decltype] = ACTIONS(5323),
    [anon_sym_explicit] = ACTIONS(5323),
    [anon_sym_typename] = ACTIONS(5323),
    [anon_sym_template] = ACTIONS(5323),
    [anon_sym_operator] = ACTIONS(5323),
    [anon_sym_friend] = ACTIONS(5323),
    [anon_sym_public] = ACTIONS(5323),
    [anon_sym_private] = ACTIONS(5323),
    [anon_sym_protected] = ACTIONS(5323),
    [anon_sym_using] = ACTIONS(5323),
    [anon_sym_static_assert] = ACTIONS(5323),
  },
  [1686] = {
    [sym_identifier] = ACTIONS(5319),
    [aux_sym_preproc_def_token1] = ACTIONS(5319),
    [aux_sym_preproc_if_token1] = ACTIONS(5319),
    [aux_sym_preproc_if_token2] = ACTIONS(5319),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5319),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5319),
    [aux_sym_preproc_else_token1] = ACTIONS(5319),
    [aux_sym_preproc_elif_token1] = ACTIONS(5319),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5319),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5319),
    [sym_preproc_directive] = ACTIONS(5319),
    [anon_sym_LPAREN2] = ACTIONS(5321),
    [anon_sym_TILDE] = ACTIONS(5321),
    [anon_sym_STAR] = ACTIONS(5321),
    [anon_sym_AMP_AMP] = ACTIONS(5321),
    [anon_sym_AMP] = ACTIONS(5319),
    [anon_sym_SEMI] = ACTIONS(5321),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_typedef] = ACTIONS(5319),
    [anon_sym_virtual] = ACTIONS(5319),
    [anon_sym_extern] = ACTIONS(5319),
    [anon_sym___attribute__] = ACTIONS(5319),
    [anon_sym___attribute] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(5321),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5321),
    [anon_sym___declspec] = ACTIONS(5319),
    [anon_sym___based] = ACTIONS(5319),
    [anon_sym_signed] = ACTIONS(5319),
    [anon_sym_unsigned] = ACTIONS(5319),
    [anon_sym_long] = ACTIONS(5319),
    [anon_sym_short] = ACTIONS(5319),
    [anon_sym_LBRACK] = ACTIONS(5319),
    [anon_sym_static] = ACTIONS(5319),
    [anon_sym_register] = ACTIONS(5319),
    [anon_sym_inline] = ACTIONS(5319),
    [anon_sym___inline] = ACTIONS(5319),
    [anon_sym___inline__] = ACTIONS(5319),
    [anon_sym___forceinline] = ACTIONS(5319),
    [anon_sym_thread_local] = ACTIONS(5319),
    [anon_sym___thread] = ACTIONS(5319),
    [anon_sym_const] = ACTIONS(5319),
    [anon_sym_constexpr] = ACTIONS(5319),
    [anon_sym_volatile] = ACTIONS(5319),
    [anon_sym_restrict] = ACTIONS(5319),
    [anon_sym___restrict__] = ACTIONS(5319),
    [anon_sym__Atomic] = ACTIONS(5319),
    [anon_sym__Noreturn] = ACTIONS(5319),
    [anon_sym_noreturn] = ACTIONS(5319),
    [anon_sym__Nonnull] = ACTIONS(5319),
    [anon_sym_mutable] = ACTIONS(5319),
    [anon_sym_constinit] = ACTIONS(5319),
    [anon_sym_consteval] = ACTIONS(5319),
    [anon_sym_alignas] = ACTIONS(5319),
    [anon_sym__Alignas] = ACTIONS(5319),
    [sym_primitive_type] = ACTIONS(5319),
    [anon_sym_enum] = ACTIONS(5319),
    [anon_sym_class] = ACTIONS(5319),
    [anon_sym_struct] = ACTIONS(5319),
    [anon_sym_union] = ACTIONS(5319),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5319),
    [anon_sym_decltype] = ACTIONS(5319),
    [anon_sym_explicit] = ACTIONS(5319),
    [anon_sym_typename] = ACTIONS(5319),
    [anon_sym_template] = ACTIONS(5319),
    [anon_sym_operator] = ACTIONS(5319),
    [anon_sym_friend] = ACTIONS(5319),
    [anon_sym_public] = ACTIONS(5319),
    [anon_sym_private] = ACTIONS(5319),
    [anon_sym_protected] = ACTIONS(5319),
    [anon_sym_using] = ACTIONS(5319),
    [anon_sym_static_assert] = ACTIONS(5319),
  },
  [1687] = {
    [sym_identifier] = ACTIONS(5323),
    [aux_sym_preproc_def_token1] = ACTIONS(5323),
    [aux_sym_preproc_if_token1] = ACTIONS(5323),
    [aux_sym_preproc_if_token2] = ACTIONS(5323),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5323),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5323),
    [aux_sym_preproc_else_token1] = ACTIONS(5323),
    [aux_sym_preproc_elif_token1] = ACTIONS(5323),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5323),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5323),
    [sym_preproc_directive] = ACTIONS(5323),
    [anon_sym_LPAREN2] = ACTIONS(5325),
    [anon_sym_TILDE] = ACTIONS(5325),
    [anon_sym_STAR] = ACTIONS(5325),
    [anon_sym_AMP_AMP] = ACTIONS(5325),
    [anon_sym_AMP] = ACTIONS(5323),
    [anon_sym_SEMI] = ACTIONS(5325),
    [anon_sym___extension__] = ACTIONS(5323),
    [anon_sym_typedef] = ACTIONS(5323),
    [anon_sym_virtual] = ACTIONS(5323),
    [anon_sym_extern] = ACTIONS(5323),
    [anon_sym___attribute__] = ACTIONS(5323),
    [anon_sym___attribute] = ACTIONS(5323),
    [anon_sym_COLON_COLON] = ACTIONS(5325),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5325),
    [anon_sym___declspec] = ACTIONS(5323),
    [anon_sym___based] = ACTIONS(5323),
    [anon_sym_signed] = ACTIONS(5323),
    [anon_sym_unsigned] = ACTIONS(5323),
    [anon_sym_long] = ACTIONS(5323),
    [anon_sym_short] = ACTIONS(5323),
    [anon_sym_LBRACK] = ACTIONS(5323),
    [anon_sym_static] = ACTIONS(5323),
    [anon_sym_register] = ACTIONS(5323),
    [anon_sym_inline] = ACTIONS(5323),
    [anon_sym___inline] = ACTIONS(5323),
    [anon_sym___inline__] = ACTIONS(5323),
    [anon_sym___forceinline] = ACTIONS(5323),
    [anon_sym_thread_local] = ACTIONS(5323),
    [anon_sym___thread] = ACTIONS(5323),
    [anon_sym_const] = ACTIONS(5323),
    [anon_sym_constexpr] = ACTIONS(5323),
    [anon_sym_volatile] = ACTIONS(5323),
    [anon_sym_restrict] = ACTIONS(5323),
    [anon_sym___restrict__] = ACTIONS(5323),
    [anon_sym__Atomic] = ACTIONS(5323),
    [anon_sym__Noreturn] = ACTIONS(5323),
    [anon_sym_noreturn] = ACTIONS(5323),
    [anon_sym__Nonnull] = ACTIONS(5323),
    [anon_sym_mutable] = ACTIONS(5323),
    [anon_sym_constinit] = ACTIONS(5323),
    [anon_sym_consteval] = ACTIONS(5323),
    [anon_sym_alignas] = ACTIONS(5323),
    [anon_sym__Alignas] = ACTIONS(5323),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_enum] = ACTIONS(5323),
    [anon_sym_class] = ACTIONS(5323),
    [anon_sym_struct] = ACTIONS(5323),
    [anon_sym_union] = ACTIONS(5323),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5323),
    [anon_sym_decltype] = ACTIONS(5323),
    [anon_sym_explicit] = ACTIONS(5323),
    [anon_sym_typename] = ACTIONS(5323),
    [anon_sym_template] = ACTIONS(5323),
    [anon_sym_operator] = ACTIONS(5323),
    [anon_sym_friend] = ACTIONS(5323),
    [anon_sym_public] = ACTIONS(5323),
    [anon_sym_private] = ACTIONS(5323),
    [anon_sym_protected] = ACTIONS(5323),
    [anon_sym_using] = ACTIONS(5323),
    [anon_sym_static_assert] = ACTIONS(5323),
  },
  [1688] = {
    [sym__declaration_modifiers] = STATE(3299),
    [sym_attribute_specifier] = STATE(3299),
    [sym_attribute_declaration] = STATE(3299),
    [sym_ms_declspec_modifier] = STATE(3299),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6166),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3299),
    [sym_type_qualifier] = STATE(3299),
    [sym_alignas_qualifier] = STATE(3049),
    [sym_decltype] = STATE(8512),
    [sym_explicit_function_specifier] = STATE(3299),
    [sym_operator_cast] = STATE(6671),
    [sym__constructor_specifiers] = STATE(3299),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(8512),
    [sym_template_function] = STATE(5896),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5444),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_operator_cast_identifier] = STATE(6671),
    [sym_operator_name] = STATE(5896),
    [aux_sym_operator_cast_definition_repeat1] = STATE(3299),
    [sym_identifier] = ACTIONS(5327),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym___extension__] = ACTIONS(5329),
    [anon_sym_virtual] = ACTIONS(5331),
    [anon_sym_extern] = ACTIONS(5333),
    [anon_sym___attribute__] = ACTIONS(5335),
    [anon_sym___attribute] = ACTIONS(5335),
    [anon_sym_COLON_COLON] = ACTIONS(5337),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5339),
    [anon_sym___declspec] = ACTIONS(5341),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(5333),
    [anon_sym_register] = ACTIONS(5333),
    [anon_sym_inline] = ACTIONS(5333),
    [anon_sym___inline] = ACTIONS(5333),
    [anon_sym___inline__] = ACTIONS(5333),
    [anon_sym___forceinline] = ACTIONS(5333),
    [anon_sym_thread_local] = ACTIONS(5333),
    [anon_sym___thread] = ACTIONS(5333),
    [anon_sym_const] = ACTIONS(5329),
    [anon_sym_constexpr] = ACTIONS(5329),
    [anon_sym_volatile] = ACTIONS(5329),
    [anon_sym_restrict] = ACTIONS(5329),
    [anon_sym___restrict__] = ACTIONS(5329),
    [anon_sym__Atomic] = ACTIONS(5329),
    [anon_sym__Noreturn] = ACTIONS(5329),
    [anon_sym_noreturn] = ACTIONS(5329),
    [anon_sym__Nonnull] = ACTIONS(5329),
    [anon_sym_mutable] = ACTIONS(5329),
    [anon_sym_constinit] = ACTIONS(5329),
    [anon_sym_consteval] = ACTIONS(5329),
    [anon_sym_alignas] = ACTIONS(5343),
    [anon_sym__Alignas] = ACTIONS(5343),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_operator] = ACTIONS(133),
  },
  [1689] = {
    [sym_identifier] = ACTIONS(3142),
    [aux_sym_preproc_def_token1] = ACTIONS(3142),
    [aux_sym_preproc_if_token1] = ACTIONS(3142),
    [aux_sym_preproc_if_token2] = ACTIONS(3142),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3142),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3142),
    [aux_sym_preproc_else_token1] = ACTIONS(3142),
    [aux_sym_preproc_elif_token1] = ACTIONS(3142),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3142),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3142),
    [sym_preproc_directive] = ACTIONS(3142),
    [anon_sym_LPAREN2] = ACTIONS(3144),
    [anon_sym_TILDE] = ACTIONS(3144),
    [anon_sym_STAR] = ACTIONS(3144),
    [anon_sym_AMP_AMP] = ACTIONS(3144),
    [anon_sym_AMP] = ACTIONS(3142),
    [anon_sym_SEMI] = ACTIONS(3144),
    [anon_sym___extension__] = ACTIONS(3142),
    [anon_sym_typedef] = ACTIONS(3142),
    [anon_sym_virtual] = ACTIONS(3142),
    [anon_sym_extern] = ACTIONS(3142),
    [anon_sym___attribute__] = ACTIONS(3142),
    [anon_sym___attribute] = ACTIONS(3142),
    [anon_sym_COLON_COLON] = ACTIONS(3144),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3144),
    [anon_sym___declspec] = ACTIONS(3142),
    [anon_sym___based] = ACTIONS(3142),
    [anon_sym_signed] = ACTIONS(3142),
    [anon_sym_unsigned] = ACTIONS(3142),
    [anon_sym_long] = ACTIONS(3142),
    [anon_sym_short] = ACTIONS(3142),
    [anon_sym_LBRACK] = ACTIONS(3142),
    [anon_sym_static] = ACTIONS(3142),
    [anon_sym_register] = ACTIONS(3142),
    [anon_sym_inline] = ACTIONS(3142),
    [anon_sym___inline] = ACTIONS(3142),
    [anon_sym___inline__] = ACTIONS(3142),
    [anon_sym___forceinline] = ACTIONS(3142),
    [anon_sym_thread_local] = ACTIONS(3142),
    [anon_sym___thread] = ACTIONS(3142),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_constexpr] = ACTIONS(3142),
    [anon_sym_volatile] = ACTIONS(3142),
    [anon_sym_restrict] = ACTIONS(3142),
    [anon_sym___restrict__] = ACTIONS(3142),
    [anon_sym__Atomic] = ACTIONS(3142),
    [anon_sym__Noreturn] = ACTIONS(3142),
    [anon_sym_noreturn] = ACTIONS(3142),
    [anon_sym__Nonnull] = ACTIONS(3142),
    [anon_sym_mutable] = ACTIONS(3142),
    [anon_sym_constinit] = ACTIONS(3142),
    [anon_sym_consteval] = ACTIONS(3142),
    [anon_sym_alignas] = ACTIONS(3142),
    [anon_sym__Alignas] = ACTIONS(3142),
    [sym_primitive_type] = ACTIONS(3142),
    [anon_sym_enum] = ACTIONS(3142),
    [anon_sym_class] = ACTIONS(3142),
    [anon_sym_struct] = ACTIONS(3142),
    [anon_sym_union] = ACTIONS(3142),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3142),
    [anon_sym_decltype] = ACTIONS(3142),
    [anon_sym_explicit] = ACTIONS(3142),
    [anon_sym_typename] = ACTIONS(3142),
    [anon_sym_template] = ACTIONS(3142),
    [anon_sym_operator] = ACTIONS(3142),
    [anon_sym_friend] = ACTIONS(3142),
    [anon_sym_public] = ACTIONS(3142),
    [anon_sym_private] = ACTIONS(3142),
    [anon_sym_protected] = ACTIONS(3142),
    [anon_sym_using] = ACTIONS(3142),
    [anon_sym_static_assert] = ACTIONS(3142),
  },
  [1690] = {
    [sym_identifier] = ACTIONS(2751),
    [aux_sym_preproc_def_token1] = ACTIONS(2751),
    [aux_sym_preproc_if_token1] = ACTIONS(2751),
    [aux_sym_preproc_if_token2] = ACTIONS(2751),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2751),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2751),
    [aux_sym_preproc_else_token1] = ACTIONS(2751),
    [aux_sym_preproc_elif_token1] = ACTIONS(2751),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2751),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2751),
    [sym_preproc_directive] = ACTIONS(2751),
    [anon_sym_LPAREN2] = ACTIONS(2753),
    [anon_sym_TILDE] = ACTIONS(2753),
    [anon_sym_STAR] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2751),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym___extension__] = ACTIONS(2751),
    [anon_sym_typedef] = ACTIONS(2751),
    [anon_sym_virtual] = ACTIONS(2751),
    [anon_sym_extern] = ACTIONS(2751),
    [anon_sym___attribute__] = ACTIONS(2751),
    [anon_sym___attribute] = ACTIONS(2751),
    [anon_sym_COLON_COLON] = ACTIONS(2753),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2753),
    [anon_sym___declspec] = ACTIONS(2751),
    [anon_sym___based] = ACTIONS(2751),
    [anon_sym_signed] = ACTIONS(2751),
    [anon_sym_unsigned] = ACTIONS(2751),
    [anon_sym_long] = ACTIONS(2751),
    [anon_sym_short] = ACTIONS(2751),
    [anon_sym_LBRACK] = ACTIONS(2751),
    [anon_sym_static] = ACTIONS(2751),
    [anon_sym_register] = ACTIONS(2751),
    [anon_sym_inline] = ACTIONS(2751),
    [anon_sym___inline] = ACTIONS(2751),
    [anon_sym___inline__] = ACTIONS(2751),
    [anon_sym___forceinline] = ACTIONS(2751),
    [anon_sym_thread_local] = ACTIONS(2751),
    [anon_sym___thread] = ACTIONS(2751),
    [anon_sym_const] = ACTIONS(2751),
    [anon_sym_constexpr] = ACTIONS(2751),
    [anon_sym_volatile] = ACTIONS(2751),
    [anon_sym_restrict] = ACTIONS(2751),
    [anon_sym___restrict__] = ACTIONS(2751),
    [anon_sym__Atomic] = ACTIONS(2751),
    [anon_sym__Noreturn] = ACTIONS(2751),
    [anon_sym_noreturn] = ACTIONS(2751),
    [anon_sym__Nonnull] = ACTIONS(2751),
    [anon_sym_mutable] = ACTIONS(2751),
    [anon_sym_constinit] = ACTIONS(2751),
    [anon_sym_consteval] = ACTIONS(2751),
    [anon_sym_alignas] = ACTIONS(2751),
    [anon_sym__Alignas] = ACTIONS(2751),
    [sym_primitive_type] = ACTIONS(2751),
    [anon_sym_enum] = ACTIONS(2751),
    [anon_sym_class] = ACTIONS(2751),
    [anon_sym_struct] = ACTIONS(2751),
    [anon_sym_union] = ACTIONS(2751),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2751),
    [anon_sym_decltype] = ACTIONS(2751),
    [anon_sym_explicit] = ACTIONS(2751),
    [anon_sym_typename] = ACTIONS(2751),
    [anon_sym_template] = ACTIONS(2751),
    [anon_sym_operator] = ACTIONS(2751),
    [anon_sym_friend] = ACTIONS(2751),
    [anon_sym_public] = ACTIONS(2751),
    [anon_sym_private] = ACTIONS(2751),
    [anon_sym_protected] = ACTIONS(2751),
    [anon_sym_using] = ACTIONS(2751),
    [anon_sym_static_assert] = ACTIONS(2751),
  },
  [1691] = {
    [sym_identifier] = ACTIONS(2799),
    [aux_sym_preproc_def_token1] = ACTIONS(2799),
    [aux_sym_preproc_if_token1] = ACTIONS(2799),
    [aux_sym_preproc_if_token2] = ACTIONS(2799),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2799),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2799),
    [aux_sym_preproc_else_token1] = ACTIONS(2799),
    [aux_sym_preproc_elif_token1] = ACTIONS(2799),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2799),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2799),
    [sym_preproc_directive] = ACTIONS(2799),
    [anon_sym_LPAREN2] = ACTIONS(2801),
    [anon_sym_TILDE] = ACTIONS(2801),
    [anon_sym_STAR] = ACTIONS(2801),
    [anon_sym_AMP_AMP] = ACTIONS(2801),
    [anon_sym_AMP] = ACTIONS(2799),
    [anon_sym_SEMI] = ACTIONS(2801),
    [anon_sym___extension__] = ACTIONS(2799),
    [anon_sym_typedef] = ACTIONS(2799),
    [anon_sym_virtual] = ACTIONS(2799),
    [anon_sym_extern] = ACTIONS(2799),
    [anon_sym___attribute__] = ACTIONS(2799),
    [anon_sym___attribute] = ACTIONS(2799),
    [anon_sym_COLON_COLON] = ACTIONS(2801),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2801),
    [anon_sym___declspec] = ACTIONS(2799),
    [anon_sym___based] = ACTIONS(2799),
    [anon_sym_signed] = ACTIONS(2799),
    [anon_sym_unsigned] = ACTIONS(2799),
    [anon_sym_long] = ACTIONS(2799),
    [anon_sym_short] = ACTIONS(2799),
    [anon_sym_LBRACK] = ACTIONS(2799),
    [anon_sym_static] = ACTIONS(2799),
    [anon_sym_register] = ACTIONS(2799),
    [anon_sym_inline] = ACTIONS(2799),
    [anon_sym___inline] = ACTIONS(2799),
    [anon_sym___inline__] = ACTIONS(2799),
    [anon_sym___forceinline] = ACTIONS(2799),
    [anon_sym_thread_local] = ACTIONS(2799),
    [anon_sym___thread] = ACTIONS(2799),
    [anon_sym_const] = ACTIONS(2799),
    [anon_sym_constexpr] = ACTIONS(2799),
    [anon_sym_volatile] = ACTIONS(2799),
    [anon_sym_restrict] = ACTIONS(2799),
    [anon_sym___restrict__] = ACTIONS(2799),
    [anon_sym__Atomic] = ACTIONS(2799),
    [anon_sym__Noreturn] = ACTIONS(2799),
    [anon_sym_noreturn] = ACTIONS(2799),
    [anon_sym__Nonnull] = ACTIONS(2799),
    [anon_sym_mutable] = ACTIONS(2799),
    [anon_sym_constinit] = ACTIONS(2799),
    [anon_sym_consteval] = ACTIONS(2799),
    [anon_sym_alignas] = ACTIONS(2799),
    [anon_sym__Alignas] = ACTIONS(2799),
    [sym_primitive_type] = ACTIONS(2799),
    [anon_sym_enum] = ACTIONS(2799),
    [anon_sym_class] = ACTIONS(2799),
    [anon_sym_struct] = ACTIONS(2799),
    [anon_sym_union] = ACTIONS(2799),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2799),
    [anon_sym_decltype] = ACTIONS(2799),
    [anon_sym_explicit] = ACTIONS(2799),
    [anon_sym_typename] = ACTIONS(2799),
    [anon_sym_template] = ACTIONS(2799),
    [anon_sym_operator] = ACTIONS(2799),
    [anon_sym_friend] = ACTIONS(2799),
    [anon_sym_public] = ACTIONS(2799),
    [anon_sym_private] = ACTIONS(2799),
    [anon_sym_protected] = ACTIONS(2799),
    [anon_sym_using] = ACTIONS(2799),
    [anon_sym_static_assert] = ACTIONS(2799),
  },
  [1692] = {
    [sym_identifier] = ACTIONS(2799),
    [aux_sym_preproc_def_token1] = ACTIONS(2799),
    [aux_sym_preproc_if_token1] = ACTIONS(2799),
    [aux_sym_preproc_if_token2] = ACTIONS(2799),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2799),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2799),
    [aux_sym_preproc_else_token1] = ACTIONS(2799),
    [aux_sym_preproc_elif_token1] = ACTIONS(2799),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2799),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2799),
    [sym_preproc_directive] = ACTIONS(2799),
    [anon_sym_LPAREN2] = ACTIONS(2801),
    [anon_sym_TILDE] = ACTIONS(2801),
    [anon_sym_STAR] = ACTIONS(2801),
    [anon_sym_AMP_AMP] = ACTIONS(2801),
    [anon_sym_AMP] = ACTIONS(2799),
    [anon_sym_SEMI] = ACTIONS(2801),
    [anon_sym___extension__] = ACTIONS(2799),
    [anon_sym_typedef] = ACTIONS(2799),
    [anon_sym_virtual] = ACTIONS(2799),
    [anon_sym_extern] = ACTIONS(2799),
    [anon_sym___attribute__] = ACTIONS(2799),
    [anon_sym___attribute] = ACTIONS(2799),
    [anon_sym_COLON_COLON] = ACTIONS(2801),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2801),
    [anon_sym___declspec] = ACTIONS(2799),
    [anon_sym___based] = ACTIONS(2799),
    [anon_sym_signed] = ACTIONS(2799),
    [anon_sym_unsigned] = ACTIONS(2799),
    [anon_sym_long] = ACTIONS(2799),
    [anon_sym_short] = ACTIONS(2799),
    [anon_sym_LBRACK] = ACTIONS(2799),
    [anon_sym_static] = ACTIONS(2799),
    [anon_sym_register] = ACTIONS(2799),
    [anon_sym_inline] = ACTIONS(2799),
    [anon_sym___inline] = ACTIONS(2799),
    [anon_sym___inline__] = ACTIONS(2799),
    [anon_sym___forceinline] = ACTIONS(2799),
    [anon_sym_thread_local] = ACTIONS(2799),
    [anon_sym___thread] = ACTIONS(2799),
    [anon_sym_const] = ACTIONS(2799),
    [anon_sym_constexpr] = ACTIONS(2799),
    [anon_sym_volatile] = ACTIONS(2799),
    [anon_sym_restrict] = ACTIONS(2799),
    [anon_sym___restrict__] = ACTIONS(2799),
    [anon_sym__Atomic] = ACTIONS(2799),
    [anon_sym__Noreturn] = ACTIONS(2799),
    [anon_sym_noreturn] = ACTIONS(2799),
    [anon_sym__Nonnull] = ACTIONS(2799),
    [anon_sym_mutable] = ACTIONS(2799),
    [anon_sym_constinit] = ACTIONS(2799),
    [anon_sym_consteval] = ACTIONS(2799),
    [anon_sym_alignas] = ACTIONS(2799),
    [anon_sym__Alignas] = ACTIONS(2799),
    [sym_primitive_type] = ACTIONS(2799),
    [anon_sym_enum] = ACTIONS(2799),
    [anon_sym_class] = ACTIONS(2799),
    [anon_sym_struct] = ACTIONS(2799),
    [anon_sym_union] = ACTIONS(2799),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2799),
    [anon_sym_decltype] = ACTIONS(2799),
    [anon_sym_explicit] = ACTIONS(2799),
    [anon_sym_typename] = ACTIONS(2799),
    [anon_sym_template] = ACTIONS(2799),
    [anon_sym_operator] = ACTIONS(2799),
    [anon_sym_friend] = ACTIONS(2799),
    [anon_sym_public] = ACTIONS(2799),
    [anon_sym_private] = ACTIONS(2799),
    [anon_sym_protected] = ACTIONS(2799),
    [anon_sym_using] = ACTIONS(2799),
    [anon_sym_static_assert] = ACTIONS(2799),
  },
  [1693] = {
    [sym_identifier] = ACTIONS(2834),
    [aux_sym_preproc_def_token1] = ACTIONS(2834),
    [aux_sym_preproc_if_token1] = ACTIONS(2834),
    [aux_sym_preproc_if_token2] = ACTIONS(2834),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2834),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2834),
    [aux_sym_preproc_else_token1] = ACTIONS(2834),
    [aux_sym_preproc_elif_token1] = ACTIONS(2834),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2834),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2834),
    [sym_preproc_directive] = ACTIONS(2834),
    [anon_sym_LPAREN2] = ACTIONS(2836),
    [anon_sym_TILDE] = ACTIONS(2836),
    [anon_sym_STAR] = ACTIONS(2836),
    [anon_sym_AMP_AMP] = ACTIONS(2836),
    [anon_sym_AMP] = ACTIONS(2834),
    [anon_sym_SEMI] = ACTIONS(2836),
    [anon_sym___extension__] = ACTIONS(2834),
    [anon_sym_typedef] = ACTIONS(2834),
    [anon_sym_virtual] = ACTIONS(2834),
    [anon_sym_extern] = ACTIONS(2834),
    [anon_sym___attribute__] = ACTIONS(2834),
    [anon_sym___attribute] = ACTIONS(2834),
    [anon_sym_COLON_COLON] = ACTIONS(2836),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2836),
    [anon_sym___declspec] = ACTIONS(2834),
    [anon_sym___based] = ACTIONS(2834),
    [anon_sym_signed] = ACTIONS(2834),
    [anon_sym_unsigned] = ACTIONS(2834),
    [anon_sym_long] = ACTIONS(2834),
    [anon_sym_short] = ACTIONS(2834),
    [anon_sym_LBRACK] = ACTIONS(2834),
    [anon_sym_static] = ACTIONS(2834),
    [anon_sym_register] = ACTIONS(2834),
    [anon_sym_inline] = ACTIONS(2834),
    [anon_sym___inline] = ACTIONS(2834),
    [anon_sym___inline__] = ACTIONS(2834),
    [anon_sym___forceinline] = ACTIONS(2834),
    [anon_sym_thread_local] = ACTIONS(2834),
    [anon_sym___thread] = ACTIONS(2834),
    [anon_sym_const] = ACTIONS(2834),
    [anon_sym_constexpr] = ACTIONS(2834),
    [anon_sym_volatile] = ACTIONS(2834),
    [anon_sym_restrict] = ACTIONS(2834),
    [anon_sym___restrict__] = ACTIONS(2834),
    [anon_sym__Atomic] = ACTIONS(2834),
    [anon_sym__Noreturn] = ACTIONS(2834),
    [anon_sym_noreturn] = ACTIONS(2834),
    [anon_sym__Nonnull] = ACTIONS(2834),
    [anon_sym_mutable] = ACTIONS(2834),
    [anon_sym_constinit] = ACTIONS(2834),
    [anon_sym_consteval] = ACTIONS(2834),
    [anon_sym_alignas] = ACTIONS(2834),
    [anon_sym__Alignas] = ACTIONS(2834),
    [sym_primitive_type] = ACTIONS(2834),
    [anon_sym_enum] = ACTIONS(2834),
    [anon_sym_class] = ACTIONS(2834),
    [anon_sym_struct] = ACTIONS(2834),
    [anon_sym_union] = ACTIONS(2834),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2834),
    [anon_sym_decltype] = ACTIONS(2834),
    [anon_sym_explicit] = ACTIONS(2834),
    [anon_sym_typename] = ACTIONS(2834),
    [anon_sym_template] = ACTIONS(2834),
    [anon_sym_operator] = ACTIONS(2834),
    [anon_sym_friend] = ACTIONS(2834),
    [anon_sym_public] = ACTIONS(2834),
    [anon_sym_private] = ACTIONS(2834),
    [anon_sym_protected] = ACTIONS(2834),
    [anon_sym_using] = ACTIONS(2834),
    [anon_sym_static_assert] = ACTIONS(2834),
  },
  [1694] = {
    [sym_identifier] = ACTIONS(2838),
    [aux_sym_preproc_def_token1] = ACTIONS(2838),
    [aux_sym_preproc_if_token1] = ACTIONS(2838),
    [aux_sym_preproc_if_token2] = ACTIONS(2838),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2838),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2838),
    [aux_sym_preproc_else_token1] = ACTIONS(2838),
    [aux_sym_preproc_elif_token1] = ACTIONS(2838),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2838),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2838),
    [sym_preproc_directive] = ACTIONS(2838),
    [anon_sym_LPAREN2] = ACTIONS(2840),
    [anon_sym_TILDE] = ACTIONS(2840),
    [anon_sym_STAR] = ACTIONS(2840),
    [anon_sym_AMP_AMP] = ACTIONS(2840),
    [anon_sym_AMP] = ACTIONS(2838),
    [anon_sym_SEMI] = ACTIONS(2840),
    [anon_sym___extension__] = ACTIONS(2838),
    [anon_sym_typedef] = ACTIONS(2838),
    [anon_sym_virtual] = ACTIONS(2838),
    [anon_sym_extern] = ACTIONS(2838),
    [anon_sym___attribute__] = ACTIONS(2838),
    [anon_sym___attribute] = ACTIONS(2838),
    [anon_sym_COLON_COLON] = ACTIONS(2840),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2840),
    [anon_sym___declspec] = ACTIONS(2838),
    [anon_sym___based] = ACTIONS(2838),
    [anon_sym_signed] = ACTIONS(2838),
    [anon_sym_unsigned] = ACTIONS(2838),
    [anon_sym_long] = ACTIONS(2838),
    [anon_sym_short] = ACTIONS(2838),
    [anon_sym_LBRACK] = ACTIONS(2838),
    [anon_sym_static] = ACTIONS(2838),
    [anon_sym_register] = ACTIONS(2838),
    [anon_sym_inline] = ACTIONS(2838),
    [anon_sym___inline] = ACTIONS(2838),
    [anon_sym___inline__] = ACTIONS(2838),
    [anon_sym___forceinline] = ACTIONS(2838),
    [anon_sym_thread_local] = ACTIONS(2838),
    [anon_sym___thread] = ACTIONS(2838),
    [anon_sym_const] = ACTIONS(2838),
    [anon_sym_constexpr] = ACTIONS(2838),
    [anon_sym_volatile] = ACTIONS(2838),
    [anon_sym_restrict] = ACTIONS(2838),
    [anon_sym___restrict__] = ACTIONS(2838),
    [anon_sym__Atomic] = ACTIONS(2838),
    [anon_sym__Noreturn] = ACTIONS(2838),
    [anon_sym_noreturn] = ACTIONS(2838),
    [anon_sym__Nonnull] = ACTIONS(2838),
    [anon_sym_mutable] = ACTIONS(2838),
    [anon_sym_constinit] = ACTIONS(2838),
    [anon_sym_consteval] = ACTIONS(2838),
    [anon_sym_alignas] = ACTIONS(2838),
    [anon_sym__Alignas] = ACTIONS(2838),
    [sym_primitive_type] = ACTIONS(2838),
    [anon_sym_enum] = ACTIONS(2838),
    [anon_sym_class] = ACTIONS(2838),
    [anon_sym_struct] = ACTIONS(2838),
    [anon_sym_union] = ACTIONS(2838),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2838),
    [anon_sym_decltype] = ACTIONS(2838),
    [anon_sym_explicit] = ACTIONS(2838),
    [anon_sym_typename] = ACTIONS(2838),
    [anon_sym_template] = ACTIONS(2838),
    [anon_sym_operator] = ACTIONS(2838),
    [anon_sym_friend] = ACTIONS(2838),
    [anon_sym_public] = ACTIONS(2838),
    [anon_sym_private] = ACTIONS(2838),
    [anon_sym_protected] = ACTIONS(2838),
    [anon_sym_using] = ACTIONS(2838),
    [anon_sym_static_assert] = ACTIONS(2838),
  },
  [1695] = {
    [sym_identifier] = ACTIONS(2842),
    [aux_sym_preproc_def_token1] = ACTIONS(2842),
    [aux_sym_preproc_if_token1] = ACTIONS(2842),
    [aux_sym_preproc_if_token2] = ACTIONS(2842),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2842),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2842),
    [aux_sym_preproc_else_token1] = ACTIONS(2842),
    [aux_sym_preproc_elif_token1] = ACTIONS(2842),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2842),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2842),
    [sym_preproc_directive] = ACTIONS(2842),
    [anon_sym_LPAREN2] = ACTIONS(2844),
    [anon_sym_TILDE] = ACTIONS(2844),
    [anon_sym_STAR] = ACTIONS(2844),
    [anon_sym_AMP_AMP] = ACTIONS(2844),
    [anon_sym_AMP] = ACTIONS(2842),
    [anon_sym_SEMI] = ACTIONS(2844),
    [anon_sym___extension__] = ACTIONS(2842),
    [anon_sym_typedef] = ACTIONS(2842),
    [anon_sym_virtual] = ACTIONS(2842),
    [anon_sym_extern] = ACTIONS(2842),
    [anon_sym___attribute__] = ACTIONS(2842),
    [anon_sym___attribute] = ACTIONS(2842),
    [anon_sym_COLON_COLON] = ACTIONS(2844),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2844),
    [anon_sym___declspec] = ACTIONS(2842),
    [anon_sym___based] = ACTIONS(2842),
    [anon_sym_signed] = ACTIONS(2842),
    [anon_sym_unsigned] = ACTIONS(2842),
    [anon_sym_long] = ACTIONS(2842),
    [anon_sym_short] = ACTIONS(2842),
    [anon_sym_LBRACK] = ACTIONS(2842),
    [anon_sym_static] = ACTIONS(2842),
    [anon_sym_register] = ACTIONS(2842),
    [anon_sym_inline] = ACTIONS(2842),
    [anon_sym___inline] = ACTIONS(2842),
    [anon_sym___inline__] = ACTIONS(2842),
    [anon_sym___forceinline] = ACTIONS(2842),
    [anon_sym_thread_local] = ACTIONS(2842),
    [anon_sym___thread] = ACTIONS(2842),
    [anon_sym_const] = ACTIONS(2842),
    [anon_sym_constexpr] = ACTIONS(2842),
    [anon_sym_volatile] = ACTIONS(2842),
    [anon_sym_restrict] = ACTIONS(2842),
    [anon_sym___restrict__] = ACTIONS(2842),
    [anon_sym__Atomic] = ACTIONS(2842),
    [anon_sym__Noreturn] = ACTIONS(2842),
    [anon_sym_noreturn] = ACTIONS(2842),
    [anon_sym__Nonnull] = ACTIONS(2842),
    [anon_sym_mutable] = ACTIONS(2842),
    [anon_sym_constinit] = ACTIONS(2842),
    [anon_sym_consteval] = ACTIONS(2842),
    [anon_sym_alignas] = ACTIONS(2842),
    [anon_sym__Alignas] = ACTIONS(2842),
    [sym_primitive_type] = ACTIONS(2842),
    [anon_sym_enum] = ACTIONS(2842),
    [anon_sym_class] = ACTIONS(2842),
    [anon_sym_struct] = ACTIONS(2842),
    [anon_sym_union] = ACTIONS(2842),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2842),
    [anon_sym_decltype] = ACTIONS(2842),
    [anon_sym_explicit] = ACTIONS(2842),
    [anon_sym_typename] = ACTIONS(2842),
    [anon_sym_template] = ACTIONS(2842),
    [anon_sym_operator] = ACTIONS(2842),
    [anon_sym_friend] = ACTIONS(2842),
    [anon_sym_public] = ACTIONS(2842),
    [anon_sym_private] = ACTIONS(2842),
    [anon_sym_protected] = ACTIONS(2842),
    [anon_sym_using] = ACTIONS(2842),
    [anon_sym_static_assert] = ACTIONS(2842),
  },
  [1696] = {
    [sym_identifier] = ACTIONS(2846),
    [aux_sym_preproc_def_token1] = ACTIONS(2846),
    [aux_sym_preproc_if_token1] = ACTIONS(2846),
    [aux_sym_preproc_if_token2] = ACTIONS(2846),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2846),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2846),
    [aux_sym_preproc_else_token1] = ACTIONS(2846),
    [aux_sym_preproc_elif_token1] = ACTIONS(2846),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2846),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2846),
    [sym_preproc_directive] = ACTIONS(2846),
    [anon_sym_LPAREN2] = ACTIONS(2848),
    [anon_sym_TILDE] = ACTIONS(2848),
    [anon_sym_STAR] = ACTIONS(2848),
    [anon_sym_AMP_AMP] = ACTIONS(2848),
    [anon_sym_AMP] = ACTIONS(2846),
    [anon_sym_SEMI] = ACTIONS(2848),
    [anon_sym___extension__] = ACTIONS(2846),
    [anon_sym_typedef] = ACTIONS(2846),
    [anon_sym_virtual] = ACTIONS(2846),
    [anon_sym_extern] = ACTIONS(2846),
    [anon_sym___attribute__] = ACTIONS(2846),
    [anon_sym___attribute] = ACTIONS(2846),
    [anon_sym_COLON_COLON] = ACTIONS(2848),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2848),
    [anon_sym___declspec] = ACTIONS(2846),
    [anon_sym___based] = ACTIONS(2846),
    [anon_sym_signed] = ACTIONS(2846),
    [anon_sym_unsigned] = ACTIONS(2846),
    [anon_sym_long] = ACTIONS(2846),
    [anon_sym_short] = ACTIONS(2846),
    [anon_sym_LBRACK] = ACTIONS(2846),
    [anon_sym_static] = ACTIONS(2846),
    [anon_sym_register] = ACTIONS(2846),
    [anon_sym_inline] = ACTIONS(2846),
    [anon_sym___inline] = ACTIONS(2846),
    [anon_sym___inline__] = ACTIONS(2846),
    [anon_sym___forceinline] = ACTIONS(2846),
    [anon_sym_thread_local] = ACTIONS(2846),
    [anon_sym___thread] = ACTIONS(2846),
    [anon_sym_const] = ACTIONS(2846),
    [anon_sym_constexpr] = ACTIONS(2846),
    [anon_sym_volatile] = ACTIONS(2846),
    [anon_sym_restrict] = ACTIONS(2846),
    [anon_sym___restrict__] = ACTIONS(2846),
    [anon_sym__Atomic] = ACTIONS(2846),
    [anon_sym__Noreturn] = ACTIONS(2846),
    [anon_sym_noreturn] = ACTIONS(2846),
    [anon_sym__Nonnull] = ACTIONS(2846),
    [anon_sym_mutable] = ACTIONS(2846),
    [anon_sym_constinit] = ACTIONS(2846),
    [anon_sym_consteval] = ACTIONS(2846),
    [anon_sym_alignas] = ACTIONS(2846),
    [anon_sym__Alignas] = ACTIONS(2846),
    [sym_primitive_type] = ACTIONS(2846),
    [anon_sym_enum] = ACTIONS(2846),
    [anon_sym_class] = ACTIONS(2846),
    [anon_sym_struct] = ACTIONS(2846),
    [anon_sym_union] = ACTIONS(2846),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2846),
    [anon_sym_decltype] = ACTIONS(2846),
    [anon_sym_explicit] = ACTIONS(2846),
    [anon_sym_typename] = ACTIONS(2846),
    [anon_sym_template] = ACTIONS(2846),
    [anon_sym_operator] = ACTIONS(2846),
    [anon_sym_friend] = ACTIONS(2846),
    [anon_sym_public] = ACTIONS(2846),
    [anon_sym_private] = ACTIONS(2846),
    [anon_sym_protected] = ACTIONS(2846),
    [anon_sym_using] = ACTIONS(2846),
    [anon_sym_static_assert] = ACTIONS(2846),
  },
  [1697] = {
    [sym_identifier] = ACTIONS(2850),
    [aux_sym_preproc_def_token1] = ACTIONS(2850),
    [aux_sym_preproc_if_token1] = ACTIONS(2850),
    [aux_sym_preproc_if_token2] = ACTIONS(2850),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2850),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2850),
    [aux_sym_preproc_else_token1] = ACTIONS(2850),
    [aux_sym_preproc_elif_token1] = ACTIONS(2850),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2850),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2850),
    [sym_preproc_directive] = ACTIONS(2850),
    [anon_sym_LPAREN2] = ACTIONS(2852),
    [anon_sym_TILDE] = ACTIONS(2852),
    [anon_sym_STAR] = ACTIONS(2852),
    [anon_sym_AMP_AMP] = ACTIONS(2852),
    [anon_sym_AMP] = ACTIONS(2850),
    [anon_sym_SEMI] = ACTIONS(2852),
    [anon_sym___extension__] = ACTIONS(2850),
    [anon_sym_typedef] = ACTIONS(2850),
    [anon_sym_virtual] = ACTIONS(2850),
    [anon_sym_extern] = ACTIONS(2850),
    [anon_sym___attribute__] = ACTIONS(2850),
    [anon_sym___attribute] = ACTIONS(2850),
    [anon_sym_COLON_COLON] = ACTIONS(2852),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2852),
    [anon_sym___declspec] = ACTIONS(2850),
    [anon_sym___based] = ACTIONS(2850),
    [anon_sym_signed] = ACTIONS(2850),
    [anon_sym_unsigned] = ACTIONS(2850),
    [anon_sym_long] = ACTIONS(2850),
    [anon_sym_short] = ACTIONS(2850),
    [anon_sym_LBRACK] = ACTIONS(2850),
    [anon_sym_static] = ACTIONS(2850),
    [anon_sym_register] = ACTIONS(2850),
    [anon_sym_inline] = ACTIONS(2850),
    [anon_sym___inline] = ACTIONS(2850),
    [anon_sym___inline__] = ACTIONS(2850),
    [anon_sym___forceinline] = ACTIONS(2850),
    [anon_sym_thread_local] = ACTIONS(2850),
    [anon_sym___thread] = ACTIONS(2850),
    [anon_sym_const] = ACTIONS(2850),
    [anon_sym_constexpr] = ACTIONS(2850),
    [anon_sym_volatile] = ACTIONS(2850),
    [anon_sym_restrict] = ACTIONS(2850),
    [anon_sym___restrict__] = ACTIONS(2850),
    [anon_sym__Atomic] = ACTIONS(2850),
    [anon_sym__Noreturn] = ACTIONS(2850),
    [anon_sym_noreturn] = ACTIONS(2850),
    [anon_sym__Nonnull] = ACTIONS(2850),
    [anon_sym_mutable] = ACTIONS(2850),
    [anon_sym_constinit] = ACTIONS(2850),
    [anon_sym_consteval] = ACTIONS(2850),
    [anon_sym_alignas] = ACTIONS(2850),
    [anon_sym__Alignas] = ACTIONS(2850),
    [sym_primitive_type] = ACTIONS(2850),
    [anon_sym_enum] = ACTIONS(2850),
    [anon_sym_class] = ACTIONS(2850),
    [anon_sym_struct] = ACTIONS(2850),
    [anon_sym_union] = ACTIONS(2850),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2850),
    [anon_sym_decltype] = ACTIONS(2850),
    [anon_sym_explicit] = ACTIONS(2850),
    [anon_sym_typename] = ACTIONS(2850),
    [anon_sym_template] = ACTIONS(2850),
    [anon_sym_operator] = ACTIONS(2850),
    [anon_sym_friend] = ACTIONS(2850),
    [anon_sym_public] = ACTIONS(2850),
    [anon_sym_private] = ACTIONS(2850),
    [anon_sym_protected] = ACTIONS(2850),
    [anon_sym_using] = ACTIONS(2850),
    [anon_sym_static_assert] = ACTIONS(2850),
  },
  [1698] = {
    [sym_identifier] = ACTIONS(2920),
    [aux_sym_preproc_def_token1] = ACTIONS(2920),
    [aux_sym_preproc_if_token1] = ACTIONS(2920),
    [aux_sym_preproc_if_token2] = ACTIONS(2920),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2920),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2920),
    [aux_sym_preproc_else_token1] = ACTIONS(2920),
    [aux_sym_preproc_elif_token1] = ACTIONS(2920),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2920),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2920),
    [sym_preproc_directive] = ACTIONS(2920),
    [anon_sym_LPAREN2] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2922),
    [anon_sym_STAR] = ACTIONS(2922),
    [anon_sym_AMP_AMP] = ACTIONS(2922),
    [anon_sym_AMP] = ACTIONS(2920),
    [anon_sym_SEMI] = ACTIONS(2922),
    [anon_sym___extension__] = ACTIONS(2920),
    [anon_sym_typedef] = ACTIONS(2920),
    [anon_sym_virtual] = ACTIONS(2920),
    [anon_sym_extern] = ACTIONS(2920),
    [anon_sym___attribute__] = ACTIONS(2920),
    [anon_sym___attribute] = ACTIONS(2920),
    [anon_sym_COLON_COLON] = ACTIONS(2922),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2922),
    [anon_sym___declspec] = ACTIONS(2920),
    [anon_sym___based] = ACTIONS(2920),
    [anon_sym_signed] = ACTIONS(2920),
    [anon_sym_unsigned] = ACTIONS(2920),
    [anon_sym_long] = ACTIONS(2920),
    [anon_sym_short] = ACTIONS(2920),
    [anon_sym_LBRACK] = ACTIONS(2920),
    [anon_sym_static] = ACTIONS(2920),
    [anon_sym_register] = ACTIONS(2920),
    [anon_sym_inline] = ACTIONS(2920),
    [anon_sym___inline] = ACTIONS(2920),
    [anon_sym___inline__] = ACTIONS(2920),
    [anon_sym___forceinline] = ACTIONS(2920),
    [anon_sym_thread_local] = ACTIONS(2920),
    [anon_sym___thread] = ACTIONS(2920),
    [anon_sym_const] = ACTIONS(2920),
    [anon_sym_constexpr] = ACTIONS(2920),
    [anon_sym_volatile] = ACTIONS(2920),
    [anon_sym_restrict] = ACTIONS(2920),
    [anon_sym___restrict__] = ACTIONS(2920),
    [anon_sym__Atomic] = ACTIONS(2920),
    [anon_sym__Noreturn] = ACTIONS(2920),
    [anon_sym_noreturn] = ACTIONS(2920),
    [anon_sym__Nonnull] = ACTIONS(2920),
    [anon_sym_mutable] = ACTIONS(2920),
    [anon_sym_constinit] = ACTIONS(2920),
    [anon_sym_consteval] = ACTIONS(2920),
    [anon_sym_alignas] = ACTIONS(2920),
    [anon_sym__Alignas] = ACTIONS(2920),
    [sym_primitive_type] = ACTIONS(2920),
    [anon_sym_enum] = ACTIONS(2920),
    [anon_sym_class] = ACTIONS(2920),
    [anon_sym_struct] = ACTIONS(2920),
    [anon_sym_union] = ACTIONS(2920),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2920),
    [anon_sym_decltype] = ACTIONS(2920),
    [anon_sym_explicit] = ACTIONS(2920),
    [anon_sym_typename] = ACTIONS(2920),
    [anon_sym_template] = ACTIONS(2920),
    [anon_sym_operator] = ACTIONS(2920),
    [anon_sym_friend] = ACTIONS(2920),
    [anon_sym_public] = ACTIONS(2920),
    [anon_sym_private] = ACTIONS(2920),
    [anon_sym_protected] = ACTIONS(2920),
    [anon_sym_using] = ACTIONS(2920),
    [anon_sym_static_assert] = ACTIONS(2920),
  },
  [1699] = {
    [sym_identifier] = ACTIONS(2924),
    [aux_sym_preproc_def_token1] = ACTIONS(2924),
    [aux_sym_preproc_if_token1] = ACTIONS(2924),
    [aux_sym_preproc_if_token2] = ACTIONS(2924),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2924),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2924),
    [aux_sym_preproc_else_token1] = ACTIONS(2924),
    [aux_sym_preproc_elif_token1] = ACTIONS(2924),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2924),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2924),
    [sym_preproc_directive] = ACTIONS(2924),
    [anon_sym_LPAREN2] = ACTIONS(2926),
    [anon_sym_TILDE] = ACTIONS(2926),
    [anon_sym_STAR] = ACTIONS(2926),
    [anon_sym_AMP_AMP] = ACTIONS(2926),
    [anon_sym_AMP] = ACTIONS(2924),
    [anon_sym_SEMI] = ACTIONS(2926),
    [anon_sym___extension__] = ACTIONS(2924),
    [anon_sym_typedef] = ACTIONS(2924),
    [anon_sym_virtual] = ACTIONS(2924),
    [anon_sym_extern] = ACTIONS(2924),
    [anon_sym___attribute__] = ACTIONS(2924),
    [anon_sym___attribute] = ACTIONS(2924),
    [anon_sym_COLON_COLON] = ACTIONS(2926),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2926),
    [anon_sym___declspec] = ACTIONS(2924),
    [anon_sym___based] = ACTIONS(2924),
    [anon_sym_signed] = ACTIONS(2924),
    [anon_sym_unsigned] = ACTIONS(2924),
    [anon_sym_long] = ACTIONS(2924),
    [anon_sym_short] = ACTIONS(2924),
    [anon_sym_LBRACK] = ACTIONS(2924),
    [anon_sym_static] = ACTIONS(2924),
    [anon_sym_register] = ACTIONS(2924),
    [anon_sym_inline] = ACTIONS(2924),
    [anon_sym___inline] = ACTIONS(2924),
    [anon_sym___inline__] = ACTIONS(2924),
    [anon_sym___forceinline] = ACTIONS(2924),
    [anon_sym_thread_local] = ACTIONS(2924),
    [anon_sym___thread] = ACTIONS(2924),
    [anon_sym_const] = ACTIONS(2924),
    [anon_sym_constexpr] = ACTIONS(2924),
    [anon_sym_volatile] = ACTIONS(2924),
    [anon_sym_restrict] = ACTIONS(2924),
    [anon_sym___restrict__] = ACTIONS(2924),
    [anon_sym__Atomic] = ACTIONS(2924),
    [anon_sym__Noreturn] = ACTIONS(2924),
    [anon_sym_noreturn] = ACTIONS(2924),
    [anon_sym__Nonnull] = ACTIONS(2924),
    [anon_sym_mutable] = ACTIONS(2924),
    [anon_sym_constinit] = ACTIONS(2924),
    [anon_sym_consteval] = ACTIONS(2924),
    [anon_sym_alignas] = ACTIONS(2924),
    [anon_sym__Alignas] = ACTIONS(2924),
    [sym_primitive_type] = ACTIONS(2924),
    [anon_sym_enum] = ACTIONS(2924),
    [anon_sym_class] = ACTIONS(2924),
    [anon_sym_struct] = ACTIONS(2924),
    [anon_sym_union] = ACTIONS(2924),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2924),
    [anon_sym_decltype] = ACTIONS(2924),
    [anon_sym_explicit] = ACTIONS(2924),
    [anon_sym_typename] = ACTIONS(2924),
    [anon_sym_template] = ACTIONS(2924),
    [anon_sym_operator] = ACTIONS(2924),
    [anon_sym_friend] = ACTIONS(2924),
    [anon_sym_public] = ACTIONS(2924),
    [anon_sym_private] = ACTIONS(2924),
    [anon_sym_protected] = ACTIONS(2924),
    [anon_sym_using] = ACTIONS(2924),
    [anon_sym_static_assert] = ACTIONS(2924),
  },
  [1700] = {
    [sym_identifier] = ACTIONS(5345),
    [aux_sym_preproc_def_token1] = ACTIONS(5345),
    [aux_sym_preproc_if_token1] = ACTIONS(5345),
    [aux_sym_preproc_if_token2] = ACTIONS(5345),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5345),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5345),
    [aux_sym_preproc_else_token1] = ACTIONS(5345),
    [aux_sym_preproc_elif_token1] = ACTIONS(5345),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5345),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5345),
    [sym_preproc_directive] = ACTIONS(5345),
    [anon_sym_LPAREN2] = ACTIONS(5347),
    [anon_sym_TILDE] = ACTIONS(5347),
    [anon_sym_STAR] = ACTIONS(5347),
    [anon_sym_AMP_AMP] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5345),
    [anon_sym_SEMI] = ACTIONS(5347),
    [anon_sym___extension__] = ACTIONS(5345),
    [anon_sym_typedef] = ACTIONS(5345),
    [anon_sym_virtual] = ACTIONS(5345),
    [anon_sym_extern] = ACTIONS(5345),
    [anon_sym___attribute__] = ACTIONS(5345),
    [anon_sym___attribute] = ACTIONS(5345),
    [anon_sym_COLON_COLON] = ACTIONS(5347),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5347),
    [anon_sym___declspec] = ACTIONS(5345),
    [anon_sym___based] = ACTIONS(5345),
    [anon_sym_signed] = ACTIONS(5345),
    [anon_sym_unsigned] = ACTIONS(5345),
    [anon_sym_long] = ACTIONS(5345),
    [anon_sym_short] = ACTIONS(5345),
    [anon_sym_LBRACK] = ACTIONS(5345),
    [anon_sym_static] = ACTIONS(5345),
    [anon_sym_register] = ACTIONS(5345),
    [anon_sym_inline] = ACTIONS(5345),
    [anon_sym___inline] = ACTIONS(5345),
    [anon_sym___inline__] = ACTIONS(5345),
    [anon_sym___forceinline] = ACTIONS(5345),
    [anon_sym_thread_local] = ACTIONS(5345),
    [anon_sym___thread] = ACTIONS(5345),
    [anon_sym_const] = ACTIONS(5345),
    [anon_sym_constexpr] = ACTIONS(5345),
    [anon_sym_volatile] = ACTIONS(5345),
    [anon_sym_restrict] = ACTIONS(5345),
    [anon_sym___restrict__] = ACTIONS(5345),
    [anon_sym__Atomic] = ACTIONS(5345),
    [anon_sym__Noreturn] = ACTIONS(5345),
    [anon_sym_noreturn] = ACTIONS(5345),
    [anon_sym__Nonnull] = ACTIONS(5345),
    [anon_sym_mutable] = ACTIONS(5345),
    [anon_sym_constinit] = ACTIONS(5345),
    [anon_sym_consteval] = ACTIONS(5345),
    [anon_sym_alignas] = ACTIONS(5345),
    [anon_sym__Alignas] = ACTIONS(5345),
    [sym_primitive_type] = ACTIONS(5345),
    [anon_sym_enum] = ACTIONS(5345),
    [anon_sym_class] = ACTIONS(5345),
    [anon_sym_struct] = ACTIONS(5345),
    [anon_sym_union] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5345),
    [anon_sym_decltype] = ACTIONS(5345),
    [anon_sym_explicit] = ACTIONS(5345),
    [anon_sym_typename] = ACTIONS(5345),
    [anon_sym_template] = ACTIONS(5345),
    [anon_sym_operator] = ACTIONS(5345),
    [anon_sym_friend] = ACTIONS(5345),
    [anon_sym_public] = ACTIONS(5345),
    [anon_sym_private] = ACTIONS(5345),
    [anon_sym_protected] = ACTIONS(5345),
    [anon_sym_using] = ACTIONS(5345),
    [anon_sym_static_assert] = ACTIONS(5345),
  },
  [1701] = {
    [sym_identifier] = ACTIONS(5349),
    [aux_sym_preproc_def_token1] = ACTIONS(5349),
    [aux_sym_preproc_if_token1] = ACTIONS(5349),
    [aux_sym_preproc_if_token2] = ACTIONS(5349),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5349),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5349),
    [aux_sym_preproc_else_token1] = ACTIONS(5349),
    [aux_sym_preproc_elif_token1] = ACTIONS(5349),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5349),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5349),
    [sym_preproc_directive] = ACTIONS(5349),
    [anon_sym_LPAREN2] = ACTIONS(5351),
    [anon_sym_TILDE] = ACTIONS(5351),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_AMP_AMP] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5349),
    [anon_sym_SEMI] = ACTIONS(5351),
    [anon_sym___extension__] = ACTIONS(5349),
    [anon_sym_typedef] = ACTIONS(5349),
    [anon_sym_virtual] = ACTIONS(5349),
    [anon_sym_extern] = ACTIONS(5349),
    [anon_sym___attribute__] = ACTIONS(5349),
    [anon_sym___attribute] = ACTIONS(5349),
    [anon_sym_COLON_COLON] = ACTIONS(5351),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5351),
    [anon_sym___declspec] = ACTIONS(5349),
    [anon_sym___based] = ACTIONS(5349),
    [anon_sym_signed] = ACTIONS(5349),
    [anon_sym_unsigned] = ACTIONS(5349),
    [anon_sym_long] = ACTIONS(5349),
    [anon_sym_short] = ACTIONS(5349),
    [anon_sym_LBRACK] = ACTIONS(5349),
    [anon_sym_static] = ACTIONS(5349),
    [anon_sym_register] = ACTIONS(5349),
    [anon_sym_inline] = ACTIONS(5349),
    [anon_sym___inline] = ACTIONS(5349),
    [anon_sym___inline__] = ACTIONS(5349),
    [anon_sym___forceinline] = ACTIONS(5349),
    [anon_sym_thread_local] = ACTIONS(5349),
    [anon_sym___thread] = ACTIONS(5349),
    [anon_sym_const] = ACTIONS(5349),
    [anon_sym_constexpr] = ACTIONS(5349),
    [anon_sym_volatile] = ACTIONS(5349),
    [anon_sym_restrict] = ACTIONS(5349),
    [anon_sym___restrict__] = ACTIONS(5349),
    [anon_sym__Atomic] = ACTIONS(5349),
    [anon_sym__Noreturn] = ACTIONS(5349),
    [anon_sym_noreturn] = ACTIONS(5349),
    [anon_sym__Nonnull] = ACTIONS(5349),
    [anon_sym_mutable] = ACTIONS(5349),
    [anon_sym_constinit] = ACTIONS(5349),
    [anon_sym_consteval] = ACTIONS(5349),
    [anon_sym_alignas] = ACTIONS(5349),
    [anon_sym__Alignas] = ACTIONS(5349),
    [sym_primitive_type] = ACTIONS(5349),
    [anon_sym_enum] = ACTIONS(5349),
    [anon_sym_class] = ACTIONS(5349),
    [anon_sym_struct] = ACTIONS(5349),
    [anon_sym_union] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5349),
    [anon_sym_decltype] = ACTIONS(5349),
    [anon_sym_explicit] = ACTIONS(5349),
    [anon_sym_typename] = ACTIONS(5349),
    [anon_sym_template] = ACTIONS(5349),
    [anon_sym_operator] = ACTIONS(5349),
    [anon_sym_friend] = ACTIONS(5349),
    [anon_sym_public] = ACTIONS(5349),
    [anon_sym_private] = ACTIONS(5349),
    [anon_sym_protected] = ACTIONS(5349),
    [anon_sym_using] = ACTIONS(5349),
    [anon_sym_static_assert] = ACTIONS(5349),
  },
  [1702] = {
    [sym_identifier] = ACTIONS(5353),
    [aux_sym_preproc_def_token1] = ACTIONS(5353),
    [aux_sym_preproc_if_token1] = ACTIONS(5353),
    [aux_sym_preproc_if_token2] = ACTIONS(5353),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5353),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5353),
    [aux_sym_preproc_else_token1] = ACTIONS(5353),
    [aux_sym_preproc_elif_token1] = ACTIONS(5353),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5353),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5353),
    [sym_preproc_directive] = ACTIONS(5353),
    [anon_sym_LPAREN2] = ACTIONS(5355),
    [anon_sym_TILDE] = ACTIONS(5355),
    [anon_sym_STAR] = ACTIONS(5355),
    [anon_sym_AMP_AMP] = ACTIONS(5355),
    [anon_sym_AMP] = ACTIONS(5353),
    [anon_sym_SEMI] = ACTIONS(5355),
    [anon_sym___extension__] = ACTIONS(5353),
    [anon_sym_typedef] = ACTIONS(5353),
    [anon_sym_virtual] = ACTIONS(5353),
    [anon_sym_extern] = ACTIONS(5353),
    [anon_sym___attribute__] = ACTIONS(5353),
    [anon_sym___attribute] = ACTIONS(5353),
    [anon_sym_COLON_COLON] = ACTIONS(5355),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5355),
    [anon_sym___declspec] = ACTIONS(5353),
    [anon_sym___based] = ACTIONS(5353),
    [anon_sym_signed] = ACTIONS(5353),
    [anon_sym_unsigned] = ACTIONS(5353),
    [anon_sym_long] = ACTIONS(5353),
    [anon_sym_short] = ACTIONS(5353),
    [anon_sym_LBRACK] = ACTIONS(5353),
    [anon_sym_static] = ACTIONS(5353),
    [anon_sym_register] = ACTIONS(5353),
    [anon_sym_inline] = ACTIONS(5353),
    [anon_sym___inline] = ACTIONS(5353),
    [anon_sym___inline__] = ACTIONS(5353),
    [anon_sym___forceinline] = ACTIONS(5353),
    [anon_sym_thread_local] = ACTIONS(5353),
    [anon_sym___thread] = ACTIONS(5353),
    [anon_sym_const] = ACTIONS(5353),
    [anon_sym_constexpr] = ACTIONS(5353),
    [anon_sym_volatile] = ACTIONS(5353),
    [anon_sym_restrict] = ACTIONS(5353),
    [anon_sym___restrict__] = ACTIONS(5353),
    [anon_sym__Atomic] = ACTIONS(5353),
    [anon_sym__Noreturn] = ACTIONS(5353),
    [anon_sym_noreturn] = ACTIONS(5353),
    [anon_sym__Nonnull] = ACTIONS(5353),
    [anon_sym_mutable] = ACTIONS(5353),
    [anon_sym_constinit] = ACTIONS(5353),
    [anon_sym_consteval] = ACTIONS(5353),
    [anon_sym_alignas] = ACTIONS(5353),
    [anon_sym__Alignas] = ACTIONS(5353),
    [sym_primitive_type] = ACTIONS(5353),
    [anon_sym_enum] = ACTIONS(5353),
    [anon_sym_class] = ACTIONS(5353),
    [anon_sym_struct] = ACTIONS(5353),
    [anon_sym_union] = ACTIONS(5353),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5353),
    [anon_sym_decltype] = ACTIONS(5353),
    [anon_sym_explicit] = ACTIONS(5353),
    [anon_sym_typename] = ACTIONS(5353),
    [anon_sym_template] = ACTIONS(5353),
    [anon_sym_operator] = ACTIONS(5353),
    [anon_sym_friend] = ACTIONS(5353),
    [anon_sym_public] = ACTIONS(5353),
    [anon_sym_private] = ACTIONS(5353),
    [anon_sym_protected] = ACTIONS(5353),
    [anon_sym_using] = ACTIONS(5353),
    [anon_sym_static_assert] = ACTIONS(5353),
  },
  [1703] = {
    [sym_identifier] = ACTIONS(5357),
    [aux_sym_preproc_def_token1] = ACTIONS(5357),
    [aux_sym_preproc_if_token1] = ACTIONS(5357),
    [aux_sym_preproc_if_token2] = ACTIONS(5357),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5357),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5357),
    [aux_sym_preproc_else_token1] = ACTIONS(5357),
    [aux_sym_preproc_elif_token1] = ACTIONS(5357),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5357),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5357),
    [sym_preproc_directive] = ACTIONS(5357),
    [anon_sym_LPAREN2] = ACTIONS(5359),
    [anon_sym_TILDE] = ACTIONS(5359),
    [anon_sym_STAR] = ACTIONS(5359),
    [anon_sym_AMP_AMP] = ACTIONS(5359),
    [anon_sym_AMP] = ACTIONS(5357),
    [anon_sym_SEMI] = ACTIONS(5359),
    [anon_sym___extension__] = ACTIONS(5357),
    [anon_sym_typedef] = ACTIONS(5357),
    [anon_sym_virtual] = ACTIONS(5357),
    [anon_sym_extern] = ACTIONS(5357),
    [anon_sym___attribute__] = ACTIONS(5357),
    [anon_sym___attribute] = ACTIONS(5357),
    [anon_sym_COLON_COLON] = ACTIONS(5359),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5359),
    [anon_sym___declspec] = ACTIONS(5357),
    [anon_sym___based] = ACTIONS(5357),
    [anon_sym_signed] = ACTIONS(5357),
    [anon_sym_unsigned] = ACTIONS(5357),
    [anon_sym_long] = ACTIONS(5357),
    [anon_sym_short] = ACTIONS(5357),
    [anon_sym_LBRACK] = ACTIONS(5357),
    [anon_sym_static] = ACTIONS(5357),
    [anon_sym_register] = ACTIONS(5357),
    [anon_sym_inline] = ACTIONS(5357),
    [anon_sym___inline] = ACTIONS(5357),
    [anon_sym___inline__] = ACTIONS(5357),
    [anon_sym___forceinline] = ACTIONS(5357),
    [anon_sym_thread_local] = ACTIONS(5357),
    [anon_sym___thread] = ACTIONS(5357),
    [anon_sym_const] = ACTIONS(5357),
    [anon_sym_constexpr] = ACTIONS(5357),
    [anon_sym_volatile] = ACTIONS(5357),
    [anon_sym_restrict] = ACTIONS(5357),
    [anon_sym___restrict__] = ACTIONS(5357),
    [anon_sym__Atomic] = ACTIONS(5357),
    [anon_sym__Noreturn] = ACTIONS(5357),
    [anon_sym_noreturn] = ACTIONS(5357),
    [anon_sym__Nonnull] = ACTIONS(5357),
    [anon_sym_mutable] = ACTIONS(5357),
    [anon_sym_constinit] = ACTIONS(5357),
    [anon_sym_consteval] = ACTIONS(5357),
    [anon_sym_alignas] = ACTIONS(5357),
    [anon_sym__Alignas] = ACTIONS(5357),
    [sym_primitive_type] = ACTIONS(5357),
    [anon_sym_enum] = ACTIONS(5357),
    [anon_sym_class] = ACTIONS(5357),
    [anon_sym_struct] = ACTIONS(5357),
    [anon_sym_union] = ACTIONS(5357),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5357),
    [anon_sym_decltype] = ACTIONS(5357),
    [anon_sym_explicit] = ACTIONS(5357),
    [anon_sym_typename] = ACTIONS(5357),
    [anon_sym_template] = ACTIONS(5357),
    [anon_sym_operator] = ACTIONS(5357),
    [anon_sym_friend] = ACTIONS(5357),
    [anon_sym_public] = ACTIONS(5357),
    [anon_sym_private] = ACTIONS(5357),
    [anon_sym_protected] = ACTIONS(5357),
    [anon_sym_using] = ACTIONS(5357),
    [anon_sym_static_assert] = ACTIONS(5357),
  },
  [1704] = {
    [sym_identifier] = ACTIONS(5361),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5363),
    [anon_sym_COMMA] = ACTIONS(5363),
    [anon_sym_RPAREN] = ACTIONS(5363),
    [anon_sym_LPAREN2] = ACTIONS(5363),
    [anon_sym_DASH] = ACTIONS(5361),
    [anon_sym_PLUS] = ACTIONS(5361),
    [anon_sym_STAR] = ACTIONS(5363),
    [anon_sym_SLASH] = ACTIONS(5361),
    [anon_sym_PERCENT] = ACTIONS(5363),
    [anon_sym_PIPE_PIPE] = ACTIONS(5363),
    [anon_sym_AMP_AMP] = ACTIONS(5363),
    [anon_sym_PIPE] = ACTIONS(5361),
    [anon_sym_CARET] = ACTIONS(5363),
    [anon_sym_AMP] = ACTIONS(5361),
    [anon_sym_EQ_EQ] = ACTIONS(5363),
    [anon_sym_BANG_EQ] = ACTIONS(5363),
    [anon_sym_GT] = ACTIONS(5361),
    [anon_sym_GT_EQ] = ACTIONS(5363),
    [anon_sym_LT_EQ] = ACTIONS(5361),
    [anon_sym_LT] = ACTIONS(5361),
    [anon_sym_LT_LT] = ACTIONS(5363),
    [anon_sym_GT_GT] = ACTIONS(5363),
    [anon_sym_SEMI] = ACTIONS(5363),
    [anon_sym___extension__] = ACTIONS(5361),
    [anon_sym___attribute__] = ACTIONS(5361),
    [anon_sym___attribute] = ACTIONS(5361),
    [anon_sym_COLON_COLON] = ACTIONS(5365),
    [anon_sym___based] = ACTIONS(5361),
    [anon_sym_LBRACE] = ACTIONS(5363),
    [anon_sym_RBRACE] = ACTIONS(5363),
    [anon_sym_signed] = ACTIONS(5361),
    [anon_sym_unsigned] = ACTIONS(5361),
    [anon_sym_long] = ACTIONS(5361),
    [anon_sym_short] = ACTIONS(5361),
    [anon_sym_LBRACK] = ACTIONS(5363),
    [anon_sym_RBRACK] = ACTIONS(5363),
    [anon_sym_const] = ACTIONS(5361),
    [anon_sym_constexpr] = ACTIONS(5361),
    [anon_sym_volatile] = ACTIONS(5361),
    [anon_sym_restrict] = ACTIONS(5361),
    [anon_sym___restrict__] = ACTIONS(5361),
    [anon_sym__Atomic] = ACTIONS(5361),
    [anon_sym__Noreturn] = ACTIONS(5361),
    [anon_sym_noreturn] = ACTIONS(5361),
    [anon_sym__Nonnull] = ACTIONS(5361),
    [anon_sym_mutable] = ACTIONS(5361),
    [anon_sym_constinit] = ACTIONS(5361),
    [anon_sym_consteval] = ACTIONS(5361),
    [anon_sym_alignas] = ACTIONS(5361),
    [anon_sym__Alignas] = ACTIONS(5361),
    [sym_primitive_type] = ACTIONS(5361),
    [anon_sym_COLON] = ACTIONS(5361),
    [anon_sym_QMARK] = ACTIONS(5363),
    [anon_sym_LT_EQ_GT] = ACTIONS(5363),
    [anon_sym_or] = ACTIONS(5361),
    [anon_sym_and] = ACTIONS(5361),
    [anon_sym_bitor] = ACTIONS(5361),
    [anon_sym_xor] = ACTIONS(5361),
    [anon_sym_bitand] = ACTIONS(5361),
    [anon_sym_not_eq] = ACTIONS(5361),
    [anon_sym_DASH_DASH] = ACTIONS(5363),
    [anon_sym_PLUS_PLUS] = ACTIONS(5363),
    [anon_sym_DOT] = ACTIONS(5361),
    [anon_sym_DOT_STAR] = ACTIONS(5363),
    [anon_sym_DASH_GT] = ACTIONS(5363),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5361),
    [anon_sym_decltype] = ACTIONS(5361),
    [anon_sym_final] = ACTIONS(5361),
    [anon_sym_override] = ACTIONS(5361),
    [anon_sym_requires] = ACTIONS(5361),
  },
  [1705] = {
    [sym_identifier] = ACTIONS(3013),
    [aux_sym_preproc_def_token1] = ACTIONS(3013),
    [aux_sym_preproc_if_token1] = ACTIONS(3013),
    [aux_sym_preproc_if_token2] = ACTIONS(3013),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3013),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3013),
    [aux_sym_preproc_else_token1] = ACTIONS(3013),
    [aux_sym_preproc_elif_token1] = ACTIONS(3013),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3013),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3013),
    [sym_preproc_directive] = ACTIONS(3013),
    [anon_sym_LPAREN2] = ACTIONS(3015),
    [anon_sym_TILDE] = ACTIONS(3015),
    [anon_sym_STAR] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3015),
    [anon_sym_AMP] = ACTIONS(3013),
    [anon_sym_SEMI] = ACTIONS(3015),
    [anon_sym___extension__] = ACTIONS(3013),
    [anon_sym_typedef] = ACTIONS(3013),
    [anon_sym_virtual] = ACTIONS(3013),
    [anon_sym_extern] = ACTIONS(3013),
    [anon_sym___attribute__] = ACTIONS(3013),
    [anon_sym___attribute] = ACTIONS(3013),
    [anon_sym_COLON_COLON] = ACTIONS(3015),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3015),
    [anon_sym___declspec] = ACTIONS(3013),
    [anon_sym___based] = ACTIONS(3013),
    [anon_sym_signed] = ACTIONS(3013),
    [anon_sym_unsigned] = ACTIONS(3013),
    [anon_sym_long] = ACTIONS(3013),
    [anon_sym_short] = ACTIONS(3013),
    [anon_sym_LBRACK] = ACTIONS(3013),
    [anon_sym_static] = ACTIONS(3013),
    [anon_sym_register] = ACTIONS(3013),
    [anon_sym_inline] = ACTIONS(3013),
    [anon_sym___inline] = ACTIONS(3013),
    [anon_sym___inline__] = ACTIONS(3013),
    [anon_sym___forceinline] = ACTIONS(3013),
    [anon_sym_thread_local] = ACTIONS(3013),
    [anon_sym___thread] = ACTIONS(3013),
    [anon_sym_const] = ACTIONS(3013),
    [anon_sym_constexpr] = ACTIONS(3013),
    [anon_sym_volatile] = ACTIONS(3013),
    [anon_sym_restrict] = ACTIONS(3013),
    [anon_sym___restrict__] = ACTIONS(3013),
    [anon_sym__Atomic] = ACTIONS(3013),
    [anon_sym__Noreturn] = ACTIONS(3013),
    [anon_sym_noreturn] = ACTIONS(3013),
    [anon_sym__Nonnull] = ACTIONS(3013),
    [anon_sym_mutable] = ACTIONS(3013),
    [anon_sym_constinit] = ACTIONS(3013),
    [anon_sym_consteval] = ACTIONS(3013),
    [anon_sym_alignas] = ACTIONS(3013),
    [anon_sym__Alignas] = ACTIONS(3013),
    [sym_primitive_type] = ACTIONS(3013),
    [anon_sym_enum] = ACTIONS(3013),
    [anon_sym_class] = ACTIONS(3013),
    [anon_sym_struct] = ACTIONS(3013),
    [anon_sym_union] = ACTIONS(3013),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3013),
    [anon_sym_decltype] = ACTIONS(3013),
    [anon_sym_explicit] = ACTIONS(3013),
    [anon_sym_typename] = ACTIONS(3013),
    [anon_sym_template] = ACTIONS(3013),
    [anon_sym_operator] = ACTIONS(3013),
    [anon_sym_friend] = ACTIONS(3013),
    [anon_sym_public] = ACTIONS(3013),
    [anon_sym_private] = ACTIONS(3013),
    [anon_sym_protected] = ACTIONS(3013),
    [anon_sym_using] = ACTIONS(3013),
    [anon_sym_static_assert] = ACTIONS(3013),
  },
  [1706] = {
    [sym_identifier] = ACTIONS(5361),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5363),
    [anon_sym_COMMA] = ACTIONS(5363),
    [anon_sym_RPAREN] = ACTIONS(5363),
    [anon_sym_LPAREN2] = ACTIONS(5363),
    [anon_sym_DASH] = ACTIONS(5361),
    [anon_sym_PLUS] = ACTIONS(5361),
    [anon_sym_STAR] = ACTIONS(5363),
    [anon_sym_SLASH] = ACTIONS(5361),
    [anon_sym_PERCENT] = ACTIONS(5363),
    [anon_sym_PIPE_PIPE] = ACTIONS(5363),
    [anon_sym_AMP_AMP] = ACTIONS(5363),
    [anon_sym_PIPE] = ACTIONS(5361),
    [anon_sym_CARET] = ACTIONS(5363),
    [anon_sym_AMP] = ACTIONS(5361),
    [anon_sym_EQ_EQ] = ACTIONS(5363),
    [anon_sym_BANG_EQ] = ACTIONS(5363),
    [anon_sym_GT] = ACTIONS(5361),
    [anon_sym_GT_EQ] = ACTIONS(5363),
    [anon_sym_LT_EQ] = ACTIONS(5361),
    [anon_sym_LT] = ACTIONS(5361),
    [anon_sym_LT_LT] = ACTIONS(5363),
    [anon_sym_GT_GT] = ACTIONS(5363),
    [anon_sym_SEMI] = ACTIONS(5363),
    [anon_sym___extension__] = ACTIONS(5361),
    [anon_sym___attribute__] = ACTIONS(5361),
    [anon_sym___attribute] = ACTIONS(5361),
    [anon_sym_COLON_COLON] = ACTIONS(5365),
    [anon_sym___based] = ACTIONS(5361),
    [anon_sym_LBRACE] = ACTIONS(5363),
    [anon_sym_RBRACE] = ACTIONS(5363),
    [anon_sym_signed] = ACTIONS(5361),
    [anon_sym_unsigned] = ACTIONS(5361),
    [anon_sym_long] = ACTIONS(5361),
    [anon_sym_short] = ACTIONS(5361),
    [anon_sym_LBRACK] = ACTIONS(5363),
    [anon_sym_RBRACK] = ACTIONS(5363),
    [anon_sym_const] = ACTIONS(5361),
    [anon_sym_constexpr] = ACTIONS(5361),
    [anon_sym_volatile] = ACTIONS(5361),
    [anon_sym_restrict] = ACTIONS(5361),
    [anon_sym___restrict__] = ACTIONS(5361),
    [anon_sym__Atomic] = ACTIONS(5361),
    [anon_sym__Noreturn] = ACTIONS(5361),
    [anon_sym_noreturn] = ACTIONS(5361),
    [anon_sym__Nonnull] = ACTIONS(5361),
    [anon_sym_mutable] = ACTIONS(5361),
    [anon_sym_constinit] = ACTIONS(5361),
    [anon_sym_consteval] = ACTIONS(5361),
    [anon_sym_alignas] = ACTIONS(5361),
    [anon_sym__Alignas] = ACTIONS(5361),
    [sym_primitive_type] = ACTIONS(5361),
    [anon_sym_COLON] = ACTIONS(5361),
    [anon_sym_QMARK] = ACTIONS(5363),
    [anon_sym_LT_EQ_GT] = ACTIONS(5363),
    [anon_sym_or] = ACTIONS(5361),
    [anon_sym_and] = ACTIONS(5361),
    [anon_sym_bitor] = ACTIONS(5361),
    [anon_sym_xor] = ACTIONS(5361),
    [anon_sym_bitand] = ACTIONS(5361),
    [anon_sym_not_eq] = ACTIONS(5361),
    [anon_sym_DASH_DASH] = ACTIONS(5363),
    [anon_sym_PLUS_PLUS] = ACTIONS(5363),
    [anon_sym_DOT] = ACTIONS(5361),
    [anon_sym_DOT_STAR] = ACTIONS(5363),
    [anon_sym_DASH_GT] = ACTIONS(5363),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5361),
    [anon_sym_decltype] = ACTIONS(5361),
    [anon_sym_final] = ACTIONS(5361),
    [anon_sym_override] = ACTIONS(5361),
    [anon_sym_requires] = ACTIONS(5361),
  },
  [1707] = {
    [sym_identifier] = ACTIONS(4810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4812),
    [anon_sym_COMMA] = ACTIONS(4812),
    [anon_sym_RPAREN] = ACTIONS(4812),
    [anon_sym_LPAREN2] = ACTIONS(4812),
    [anon_sym_DASH] = ACTIONS(4810),
    [anon_sym_PLUS] = ACTIONS(4810),
    [anon_sym_STAR] = ACTIONS(4812),
    [anon_sym_SLASH] = ACTIONS(4810),
    [anon_sym_PERCENT] = ACTIONS(4812),
    [anon_sym_PIPE_PIPE] = ACTIONS(4812),
    [anon_sym_AMP_AMP] = ACTIONS(4812),
    [anon_sym_PIPE] = ACTIONS(4810),
    [anon_sym_CARET] = ACTIONS(4812),
    [anon_sym_AMP] = ACTIONS(4810),
    [anon_sym_EQ_EQ] = ACTIONS(4812),
    [anon_sym_BANG_EQ] = ACTIONS(4812),
    [anon_sym_GT] = ACTIONS(4810),
    [anon_sym_GT_EQ] = ACTIONS(4812),
    [anon_sym_LT_EQ] = ACTIONS(4810),
    [anon_sym_LT] = ACTIONS(4810),
    [anon_sym_LT_LT] = ACTIONS(4812),
    [anon_sym_GT_GT] = ACTIONS(4812),
    [anon_sym_SEMI] = ACTIONS(4812),
    [anon_sym___extension__] = ACTIONS(4810),
    [anon_sym___attribute__] = ACTIONS(4810),
    [anon_sym___attribute] = ACTIONS(4810),
    [anon_sym_COLON_COLON] = ACTIONS(4812),
    [anon_sym___based] = ACTIONS(4810),
    [anon_sym_LBRACE] = ACTIONS(4812),
    [anon_sym_RBRACE] = ACTIONS(4812),
    [anon_sym_signed] = ACTIONS(4810),
    [anon_sym_unsigned] = ACTIONS(4810),
    [anon_sym_long] = ACTIONS(4810),
    [anon_sym_short] = ACTIONS(4810),
    [anon_sym_LBRACK] = ACTIONS(4812),
    [anon_sym_RBRACK] = ACTIONS(4812),
    [anon_sym_const] = ACTIONS(4810),
    [anon_sym_constexpr] = ACTIONS(4810),
    [anon_sym_volatile] = ACTIONS(4810),
    [anon_sym_restrict] = ACTIONS(4810),
    [anon_sym___restrict__] = ACTIONS(4810),
    [anon_sym__Atomic] = ACTIONS(4810),
    [anon_sym__Noreturn] = ACTIONS(4810),
    [anon_sym_noreturn] = ACTIONS(4810),
    [anon_sym__Nonnull] = ACTIONS(4810),
    [anon_sym_mutable] = ACTIONS(4810),
    [anon_sym_constinit] = ACTIONS(4810),
    [anon_sym_consteval] = ACTIONS(4810),
    [anon_sym_alignas] = ACTIONS(4810),
    [anon_sym__Alignas] = ACTIONS(4810),
    [sym_primitive_type] = ACTIONS(4810),
    [anon_sym_COLON] = ACTIONS(4810),
    [anon_sym_QMARK] = ACTIONS(4812),
    [anon_sym_LT_EQ_GT] = ACTIONS(4812),
    [anon_sym_or] = ACTIONS(4810),
    [anon_sym_and] = ACTIONS(4810),
    [anon_sym_bitor] = ACTIONS(4810),
    [anon_sym_xor] = ACTIONS(4810),
    [anon_sym_bitand] = ACTIONS(4810),
    [anon_sym_not_eq] = ACTIONS(4810),
    [anon_sym_DASH_DASH] = ACTIONS(4812),
    [anon_sym_PLUS_PLUS] = ACTIONS(4812),
    [anon_sym_DOT] = ACTIONS(4810),
    [anon_sym_DOT_STAR] = ACTIONS(4812),
    [anon_sym_DASH_GT] = ACTIONS(4812),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4810),
    [anon_sym_decltype] = ACTIONS(4810),
    [anon_sym_final] = ACTIONS(4810),
    [anon_sym_override] = ACTIONS(4810),
    [anon_sym_requires] = ACTIONS(4810),
  },
  [1708] = {
    [sym_identifier] = ACTIONS(5367),
    [aux_sym_preproc_def_token1] = ACTIONS(5367),
    [aux_sym_preproc_if_token1] = ACTIONS(5367),
    [aux_sym_preproc_if_token2] = ACTIONS(5367),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5367),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5367),
    [aux_sym_preproc_else_token1] = ACTIONS(5367),
    [aux_sym_preproc_elif_token1] = ACTIONS(5367),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5367),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5367),
    [sym_preproc_directive] = ACTIONS(5367),
    [anon_sym_LPAREN2] = ACTIONS(5369),
    [anon_sym_TILDE] = ACTIONS(5369),
    [anon_sym_STAR] = ACTIONS(5369),
    [anon_sym_AMP_AMP] = ACTIONS(5369),
    [anon_sym_AMP] = ACTIONS(5367),
    [anon_sym_SEMI] = ACTIONS(5369),
    [anon_sym___extension__] = ACTIONS(5367),
    [anon_sym_typedef] = ACTIONS(5367),
    [anon_sym_virtual] = ACTIONS(5367),
    [anon_sym_extern] = ACTIONS(5367),
    [anon_sym___attribute__] = ACTIONS(5367),
    [anon_sym___attribute] = ACTIONS(5367),
    [anon_sym_COLON_COLON] = ACTIONS(5369),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5369),
    [anon_sym___declspec] = ACTIONS(5367),
    [anon_sym___based] = ACTIONS(5367),
    [anon_sym_signed] = ACTIONS(5367),
    [anon_sym_unsigned] = ACTIONS(5367),
    [anon_sym_long] = ACTIONS(5367),
    [anon_sym_short] = ACTIONS(5367),
    [anon_sym_LBRACK] = ACTIONS(5367),
    [anon_sym_static] = ACTIONS(5367),
    [anon_sym_register] = ACTIONS(5367),
    [anon_sym_inline] = ACTIONS(5367),
    [anon_sym___inline] = ACTIONS(5367),
    [anon_sym___inline__] = ACTIONS(5367),
    [anon_sym___forceinline] = ACTIONS(5367),
    [anon_sym_thread_local] = ACTIONS(5367),
    [anon_sym___thread] = ACTIONS(5367),
    [anon_sym_const] = ACTIONS(5367),
    [anon_sym_constexpr] = ACTIONS(5367),
    [anon_sym_volatile] = ACTIONS(5367),
    [anon_sym_restrict] = ACTIONS(5367),
    [anon_sym___restrict__] = ACTIONS(5367),
    [anon_sym__Atomic] = ACTIONS(5367),
    [anon_sym__Noreturn] = ACTIONS(5367),
    [anon_sym_noreturn] = ACTIONS(5367),
    [anon_sym__Nonnull] = ACTIONS(5367),
    [anon_sym_mutable] = ACTIONS(5367),
    [anon_sym_constinit] = ACTIONS(5367),
    [anon_sym_consteval] = ACTIONS(5367),
    [anon_sym_alignas] = ACTIONS(5367),
    [anon_sym__Alignas] = ACTIONS(5367),
    [sym_primitive_type] = ACTIONS(5367),
    [anon_sym_enum] = ACTIONS(5367),
    [anon_sym_class] = ACTIONS(5367),
    [anon_sym_struct] = ACTIONS(5367),
    [anon_sym_union] = ACTIONS(5367),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5367),
    [anon_sym_decltype] = ACTIONS(5367),
    [anon_sym_explicit] = ACTIONS(5367),
    [anon_sym_typename] = ACTIONS(5367),
    [anon_sym_template] = ACTIONS(5367),
    [anon_sym_operator] = ACTIONS(5367),
    [anon_sym_friend] = ACTIONS(5367),
    [anon_sym_public] = ACTIONS(5367),
    [anon_sym_private] = ACTIONS(5367),
    [anon_sym_protected] = ACTIONS(5367),
    [anon_sym_using] = ACTIONS(5367),
    [anon_sym_static_assert] = ACTIONS(5367),
  },
  [1709] = {
    [sym_identifier] = ACTIONS(5371),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5373),
    [anon_sym_COMMA] = ACTIONS(5373),
    [anon_sym_RPAREN] = ACTIONS(5373),
    [anon_sym_LPAREN2] = ACTIONS(5373),
    [anon_sym_DASH] = ACTIONS(5371),
    [anon_sym_PLUS] = ACTIONS(5371),
    [anon_sym_STAR] = ACTIONS(5373),
    [anon_sym_SLASH] = ACTIONS(5371),
    [anon_sym_PERCENT] = ACTIONS(5373),
    [anon_sym_PIPE_PIPE] = ACTIONS(5373),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_PIPE] = ACTIONS(5371),
    [anon_sym_CARET] = ACTIONS(5373),
    [anon_sym_AMP] = ACTIONS(5371),
    [anon_sym_EQ_EQ] = ACTIONS(5373),
    [anon_sym_BANG_EQ] = ACTIONS(5373),
    [anon_sym_GT] = ACTIONS(5371),
    [anon_sym_GT_EQ] = ACTIONS(5373),
    [anon_sym_LT_EQ] = ACTIONS(5371),
    [anon_sym_LT] = ACTIONS(5371),
    [anon_sym_LT_LT] = ACTIONS(5373),
    [anon_sym_GT_GT] = ACTIONS(5373),
    [anon_sym_SEMI] = ACTIONS(5373),
    [anon_sym___extension__] = ACTIONS(5371),
    [anon_sym___attribute__] = ACTIONS(5371),
    [anon_sym___attribute] = ACTIONS(5371),
    [anon_sym_COLON_COLON] = ACTIONS(5373),
    [anon_sym___based] = ACTIONS(5371),
    [anon_sym_LBRACE] = ACTIONS(5373),
    [anon_sym_RBRACE] = ACTIONS(5373),
    [anon_sym_signed] = ACTIONS(5371),
    [anon_sym_unsigned] = ACTIONS(5371),
    [anon_sym_long] = ACTIONS(5371),
    [anon_sym_short] = ACTIONS(5371),
    [anon_sym_LBRACK] = ACTIONS(5373),
    [anon_sym_RBRACK] = ACTIONS(5373),
    [anon_sym_const] = ACTIONS(5371),
    [anon_sym_constexpr] = ACTIONS(5371),
    [anon_sym_volatile] = ACTIONS(5371),
    [anon_sym_restrict] = ACTIONS(5371),
    [anon_sym___restrict__] = ACTIONS(5371),
    [anon_sym__Atomic] = ACTIONS(5371),
    [anon_sym__Noreturn] = ACTIONS(5371),
    [anon_sym_noreturn] = ACTIONS(5371),
    [anon_sym__Nonnull] = ACTIONS(5371),
    [anon_sym_mutable] = ACTIONS(5371),
    [anon_sym_constinit] = ACTIONS(5371),
    [anon_sym_consteval] = ACTIONS(5371),
    [anon_sym_alignas] = ACTIONS(5371),
    [anon_sym__Alignas] = ACTIONS(5371),
    [sym_primitive_type] = ACTIONS(5371),
    [anon_sym_COLON] = ACTIONS(5371),
    [anon_sym_QMARK] = ACTIONS(5373),
    [anon_sym_LT_EQ_GT] = ACTIONS(5373),
    [anon_sym_or] = ACTIONS(5371),
    [anon_sym_and] = ACTIONS(5371),
    [anon_sym_bitor] = ACTIONS(5371),
    [anon_sym_xor] = ACTIONS(5371),
    [anon_sym_bitand] = ACTIONS(5371),
    [anon_sym_not_eq] = ACTIONS(5371),
    [anon_sym_DASH_DASH] = ACTIONS(5373),
    [anon_sym_PLUS_PLUS] = ACTIONS(5373),
    [anon_sym_DOT] = ACTIONS(5371),
    [anon_sym_DOT_STAR] = ACTIONS(5373),
    [anon_sym_DASH_GT] = ACTIONS(5373),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5371),
    [anon_sym_decltype] = ACTIONS(5371),
    [anon_sym_final] = ACTIONS(5371),
    [anon_sym_override] = ACTIONS(5371),
    [anon_sym_requires] = ACTIONS(5371),
  },
  [1710] = {
    [sym__declaration_modifiers] = STATE(3299),
    [sym_attribute_specifier] = STATE(3299),
    [sym_attribute_declaration] = STATE(3299),
    [sym_ms_declspec_modifier] = STATE(3299),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6271),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3299),
    [sym_type_qualifier] = STATE(3299),
    [sym_alignas_qualifier] = STATE(3049),
    [sym_decltype] = STATE(8512),
    [sym_explicit_function_specifier] = STATE(3299),
    [sym_operator_cast] = STATE(6718),
    [sym__constructor_specifiers] = STATE(3299),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(8512),
    [sym_template_function] = STATE(5896),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5444),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_operator_cast_identifier] = STATE(6718),
    [sym_operator_name] = STATE(5896),
    [aux_sym_operator_cast_definition_repeat1] = STATE(3299),
    [sym_identifier] = ACTIONS(5327),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym___extension__] = ACTIONS(5329),
    [anon_sym_virtual] = ACTIONS(5331),
    [anon_sym_extern] = ACTIONS(5333),
    [anon_sym___attribute__] = ACTIONS(5335),
    [anon_sym___attribute] = ACTIONS(5335),
    [anon_sym_COLON_COLON] = ACTIONS(5337),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5339),
    [anon_sym___declspec] = ACTIONS(5341),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(5333),
    [anon_sym_register] = ACTIONS(5333),
    [anon_sym_inline] = ACTIONS(5333),
    [anon_sym___inline] = ACTIONS(5333),
    [anon_sym___inline__] = ACTIONS(5333),
    [anon_sym___forceinline] = ACTIONS(5333),
    [anon_sym_thread_local] = ACTIONS(5333),
    [anon_sym___thread] = ACTIONS(5333),
    [anon_sym_const] = ACTIONS(5329),
    [anon_sym_constexpr] = ACTIONS(5329),
    [anon_sym_volatile] = ACTIONS(5329),
    [anon_sym_restrict] = ACTIONS(5329),
    [anon_sym___restrict__] = ACTIONS(5329),
    [anon_sym__Atomic] = ACTIONS(5329),
    [anon_sym__Noreturn] = ACTIONS(5329),
    [anon_sym_noreturn] = ACTIONS(5329),
    [anon_sym__Nonnull] = ACTIONS(5329),
    [anon_sym_mutable] = ACTIONS(5329),
    [anon_sym_constinit] = ACTIONS(5329),
    [anon_sym_consteval] = ACTIONS(5329),
    [anon_sym_alignas] = ACTIONS(5343),
    [anon_sym__Alignas] = ACTIONS(5343),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_operator] = ACTIONS(133),
  },
  [1711] = {
    [sym_identifier] = ACTIONS(3026),
    [aux_sym_preproc_def_token1] = ACTIONS(3026),
    [aux_sym_preproc_if_token1] = ACTIONS(3026),
    [aux_sym_preproc_if_token2] = ACTIONS(3026),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3026),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3026),
    [aux_sym_preproc_else_token1] = ACTIONS(3026),
    [aux_sym_preproc_elif_token1] = ACTIONS(3026),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3026),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3026),
    [sym_preproc_directive] = ACTIONS(3026),
    [anon_sym_LPAREN2] = ACTIONS(3028),
    [anon_sym_TILDE] = ACTIONS(3028),
    [anon_sym_STAR] = ACTIONS(3028),
    [anon_sym_AMP_AMP] = ACTIONS(3028),
    [anon_sym_AMP] = ACTIONS(3026),
    [anon_sym_SEMI] = ACTIONS(3028),
    [anon_sym___extension__] = ACTIONS(3026),
    [anon_sym_typedef] = ACTIONS(3026),
    [anon_sym_virtual] = ACTIONS(3026),
    [anon_sym_extern] = ACTIONS(3026),
    [anon_sym___attribute__] = ACTIONS(3026),
    [anon_sym___attribute] = ACTIONS(3026),
    [anon_sym_COLON_COLON] = ACTIONS(3028),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3028),
    [anon_sym___declspec] = ACTIONS(3026),
    [anon_sym___based] = ACTIONS(3026),
    [anon_sym_signed] = ACTIONS(3026),
    [anon_sym_unsigned] = ACTIONS(3026),
    [anon_sym_long] = ACTIONS(3026),
    [anon_sym_short] = ACTIONS(3026),
    [anon_sym_LBRACK] = ACTIONS(3026),
    [anon_sym_static] = ACTIONS(3026),
    [anon_sym_register] = ACTIONS(3026),
    [anon_sym_inline] = ACTIONS(3026),
    [anon_sym___inline] = ACTIONS(3026),
    [anon_sym___inline__] = ACTIONS(3026),
    [anon_sym___forceinline] = ACTIONS(3026),
    [anon_sym_thread_local] = ACTIONS(3026),
    [anon_sym___thread] = ACTIONS(3026),
    [anon_sym_const] = ACTIONS(3026),
    [anon_sym_constexpr] = ACTIONS(3026),
    [anon_sym_volatile] = ACTIONS(3026),
    [anon_sym_restrict] = ACTIONS(3026),
    [anon_sym___restrict__] = ACTIONS(3026),
    [anon_sym__Atomic] = ACTIONS(3026),
    [anon_sym__Noreturn] = ACTIONS(3026),
    [anon_sym_noreturn] = ACTIONS(3026),
    [anon_sym__Nonnull] = ACTIONS(3026),
    [anon_sym_mutable] = ACTIONS(3026),
    [anon_sym_constinit] = ACTIONS(3026),
    [anon_sym_consteval] = ACTIONS(3026),
    [anon_sym_alignas] = ACTIONS(3026),
    [anon_sym__Alignas] = ACTIONS(3026),
    [sym_primitive_type] = ACTIONS(3026),
    [anon_sym_enum] = ACTIONS(3026),
    [anon_sym_class] = ACTIONS(3026),
    [anon_sym_struct] = ACTIONS(3026),
    [anon_sym_union] = ACTIONS(3026),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3026),
    [anon_sym_decltype] = ACTIONS(3026),
    [anon_sym_explicit] = ACTIONS(3026),
    [anon_sym_typename] = ACTIONS(3026),
    [anon_sym_template] = ACTIONS(3026),
    [anon_sym_operator] = ACTIONS(3026),
    [anon_sym_friend] = ACTIONS(3026),
    [anon_sym_public] = ACTIONS(3026),
    [anon_sym_private] = ACTIONS(3026),
    [anon_sym_protected] = ACTIONS(3026),
    [anon_sym_using] = ACTIONS(3026),
    [anon_sym_static_assert] = ACTIONS(3026),
  },
  [1712] = {
    [sym_identifier] = ACTIONS(3030),
    [aux_sym_preproc_def_token1] = ACTIONS(3030),
    [aux_sym_preproc_if_token1] = ACTIONS(3030),
    [aux_sym_preproc_if_token2] = ACTIONS(3030),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3030),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3030),
    [aux_sym_preproc_else_token1] = ACTIONS(3030),
    [aux_sym_preproc_elif_token1] = ACTIONS(3030),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3030),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3030),
    [sym_preproc_directive] = ACTIONS(3030),
    [anon_sym_LPAREN2] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3032),
    [anon_sym_STAR] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_AMP] = ACTIONS(3030),
    [anon_sym_SEMI] = ACTIONS(3032),
    [anon_sym___extension__] = ACTIONS(3030),
    [anon_sym_typedef] = ACTIONS(3030),
    [anon_sym_virtual] = ACTIONS(3030),
    [anon_sym_extern] = ACTIONS(3030),
    [anon_sym___attribute__] = ACTIONS(3030),
    [anon_sym___attribute] = ACTIONS(3030),
    [anon_sym_COLON_COLON] = ACTIONS(3032),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3032),
    [anon_sym___declspec] = ACTIONS(3030),
    [anon_sym___based] = ACTIONS(3030),
    [anon_sym_signed] = ACTIONS(3030),
    [anon_sym_unsigned] = ACTIONS(3030),
    [anon_sym_long] = ACTIONS(3030),
    [anon_sym_short] = ACTIONS(3030),
    [anon_sym_LBRACK] = ACTIONS(3030),
    [anon_sym_static] = ACTIONS(3030),
    [anon_sym_register] = ACTIONS(3030),
    [anon_sym_inline] = ACTIONS(3030),
    [anon_sym___inline] = ACTIONS(3030),
    [anon_sym___inline__] = ACTIONS(3030),
    [anon_sym___forceinline] = ACTIONS(3030),
    [anon_sym_thread_local] = ACTIONS(3030),
    [anon_sym___thread] = ACTIONS(3030),
    [anon_sym_const] = ACTIONS(3030),
    [anon_sym_constexpr] = ACTIONS(3030),
    [anon_sym_volatile] = ACTIONS(3030),
    [anon_sym_restrict] = ACTIONS(3030),
    [anon_sym___restrict__] = ACTIONS(3030),
    [anon_sym__Atomic] = ACTIONS(3030),
    [anon_sym__Noreturn] = ACTIONS(3030),
    [anon_sym_noreturn] = ACTIONS(3030),
    [anon_sym__Nonnull] = ACTIONS(3030),
    [anon_sym_mutable] = ACTIONS(3030),
    [anon_sym_constinit] = ACTIONS(3030),
    [anon_sym_consteval] = ACTIONS(3030),
    [anon_sym_alignas] = ACTIONS(3030),
    [anon_sym__Alignas] = ACTIONS(3030),
    [sym_primitive_type] = ACTIONS(3030),
    [anon_sym_enum] = ACTIONS(3030),
    [anon_sym_class] = ACTIONS(3030),
    [anon_sym_struct] = ACTIONS(3030),
    [anon_sym_union] = ACTIONS(3030),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3030),
    [anon_sym_decltype] = ACTIONS(3030),
    [anon_sym_explicit] = ACTIONS(3030),
    [anon_sym_typename] = ACTIONS(3030),
    [anon_sym_template] = ACTIONS(3030),
    [anon_sym_operator] = ACTIONS(3030),
    [anon_sym_friend] = ACTIONS(3030),
    [anon_sym_public] = ACTIONS(3030),
    [anon_sym_private] = ACTIONS(3030),
    [anon_sym_protected] = ACTIONS(3030),
    [anon_sym_using] = ACTIONS(3030),
    [anon_sym_static_assert] = ACTIONS(3030),
  },
  [1713] = {
    [sym_identifier] = ACTIONS(3030),
    [aux_sym_preproc_def_token1] = ACTIONS(3030),
    [aux_sym_preproc_if_token1] = ACTIONS(3030),
    [aux_sym_preproc_if_token2] = ACTIONS(3030),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3030),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3030),
    [aux_sym_preproc_else_token1] = ACTIONS(3030),
    [aux_sym_preproc_elif_token1] = ACTIONS(3030),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3030),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3030),
    [sym_preproc_directive] = ACTIONS(3030),
    [anon_sym_LPAREN2] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3032),
    [anon_sym_STAR] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_AMP] = ACTIONS(3030),
    [anon_sym_SEMI] = ACTIONS(3032),
    [anon_sym___extension__] = ACTIONS(3030),
    [anon_sym_typedef] = ACTIONS(3030),
    [anon_sym_virtual] = ACTIONS(3030),
    [anon_sym_extern] = ACTIONS(3030),
    [anon_sym___attribute__] = ACTIONS(3030),
    [anon_sym___attribute] = ACTIONS(3030),
    [anon_sym_COLON_COLON] = ACTIONS(3032),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3032),
    [anon_sym___declspec] = ACTIONS(3030),
    [anon_sym___based] = ACTIONS(3030),
    [anon_sym_signed] = ACTIONS(3030),
    [anon_sym_unsigned] = ACTIONS(3030),
    [anon_sym_long] = ACTIONS(3030),
    [anon_sym_short] = ACTIONS(3030),
    [anon_sym_LBRACK] = ACTIONS(3030),
    [anon_sym_static] = ACTIONS(3030),
    [anon_sym_register] = ACTIONS(3030),
    [anon_sym_inline] = ACTIONS(3030),
    [anon_sym___inline] = ACTIONS(3030),
    [anon_sym___inline__] = ACTIONS(3030),
    [anon_sym___forceinline] = ACTIONS(3030),
    [anon_sym_thread_local] = ACTIONS(3030),
    [anon_sym___thread] = ACTIONS(3030),
    [anon_sym_const] = ACTIONS(3030),
    [anon_sym_constexpr] = ACTIONS(3030),
    [anon_sym_volatile] = ACTIONS(3030),
    [anon_sym_restrict] = ACTIONS(3030),
    [anon_sym___restrict__] = ACTIONS(3030),
    [anon_sym__Atomic] = ACTIONS(3030),
    [anon_sym__Noreturn] = ACTIONS(3030),
    [anon_sym_noreturn] = ACTIONS(3030),
    [anon_sym__Nonnull] = ACTIONS(3030),
    [anon_sym_mutable] = ACTIONS(3030),
    [anon_sym_constinit] = ACTIONS(3030),
    [anon_sym_consteval] = ACTIONS(3030),
    [anon_sym_alignas] = ACTIONS(3030),
    [anon_sym__Alignas] = ACTIONS(3030),
    [sym_primitive_type] = ACTIONS(3030),
    [anon_sym_enum] = ACTIONS(3030),
    [anon_sym_class] = ACTIONS(3030),
    [anon_sym_struct] = ACTIONS(3030),
    [anon_sym_union] = ACTIONS(3030),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3030),
    [anon_sym_decltype] = ACTIONS(3030),
    [anon_sym_explicit] = ACTIONS(3030),
    [anon_sym_typename] = ACTIONS(3030),
    [anon_sym_template] = ACTIONS(3030),
    [anon_sym_operator] = ACTIONS(3030),
    [anon_sym_friend] = ACTIONS(3030),
    [anon_sym_public] = ACTIONS(3030),
    [anon_sym_private] = ACTIONS(3030),
    [anon_sym_protected] = ACTIONS(3030),
    [anon_sym_using] = ACTIONS(3030),
    [anon_sym_static_assert] = ACTIONS(3030),
  },
  [1714] = {
    [sym_identifier] = ACTIONS(3042),
    [aux_sym_preproc_def_token1] = ACTIONS(3042),
    [aux_sym_preproc_if_token1] = ACTIONS(3042),
    [aux_sym_preproc_if_token2] = ACTIONS(3042),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3042),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3042),
    [aux_sym_preproc_else_token1] = ACTIONS(3042),
    [aux_sym_preproc_elif_token1] = ACTIONS(3042),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3042),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3042),
    [sym_preproc_directive] = ACTIONS(3042),
    [anon_sym_LPAREN2] = ACTIONS(3044),
    [anon_sym_TILDE] = ACTIONS(3044),
    [anon_sym_STAR] = ACTIONS(3044),
    [anon_sym_AMP_AMP] = ACTIONS(3044),
    [anon_sym_AMP] = ACTIONS(3042),
    [anon_sym_SEMI] = ACTIONS(3044),
    [anon_sym___extension__] = ACTIONS(3042),
    [anon_sym_typedef] = ACTIONS(3042),
    [anon_sym_virtual] = ACTIONS(3042),
    [anon_sym_extern] = ACTIONS(3042),
    [anon_sym___attribute__] = ACTIONS(3042),
    [anon_sym___attribute] = ACTIONS(3042),
    [anon_sym_COLON_COLON] = ACTIONS(3044),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3044),
    [anon_sym___declspec] = ACTIONS(3042),
    [anon_sym___based] = ACTIONS(3042),
    [anon_sym_signed] = ACTIONS(3042),
    [anon_sym_unsigned] = ACTIONS(3042),
    [anon_sym_long] = ACTIONS(3042),
    [anon_sym_short] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3042),
    [anon_sym_static] = ACTIONS(3042),
    [anon_sym_register] = ACTIONS(3042),
    [anon_sym_inline] = ACTIONS(3042),
    [anon_sym___inline] = ACTIONS(3042),
    [anon_sym___inline__] = ACTIONS(3042),
    [anon_sym___forceinline] = ACTIONS(3042),
    [anon_sym_thread_local] = ACTIONS(3042),
    [anon_sym___thread] = ACTIONS(3042),
    [anon_sym_const] = ACTIONS(3042),
    [anon_sym_constexpr] = ACTIONS(3042),
    [anon_sym_volatile] = ACTIONS(3042),
    [anon_sym_restrict] = ACTIONS(3042),
    [anon_sym___restrict__] = ACTIONS(3042),
    [anon_sym__Atomic] = ACTIONS(3042),
    [anon_sym__Noreturn] = ACTIONS(3042),
    [anon_sym_noreturn] = ACTIONS(3042),
    [anon_sym__Nonnull] = ACTIONS(3042),
    [anon_sym_mutable] = ACTIONS(3042),
    [anon_sym_constinit] = ACTIONS(3042),
    [anon_sym_consteval] = ACTIONS(3042),
    [anon_sym_alignas] = ACTIONS(3042),
    [anon_sym__Alignas] = ACTIONS(3042),
    [sym_primitive_type] = ACTIONS(3042),
    [anon_sym_enum] = ACTIONS(3042),
    [anon_sym_class] = ACTIONS(3042),
    [anon_sym_struct] = ACTIONS(3042),
    [anon_sym_union] = ACTIONS(3042),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3042),
    [anon_sym_decltype] = ACTIONS(3042),
    [anon_sym_explicit] = ACTIONS(3042),
    [anon_sym_typename] = ACTIONS(3042),
    [anon_sym_template] = ACTIONS(3042),
    [anon_sym_operator] = ACTIONS(3042),
    [anon_sym_friend] = ACTIONS(3042),
    [anon_sym_public] = ACTIONS(3042),
    [anon_sym_private] = ACTIONS(3042),
    [anon_sym_protected] = ACTIONS(3042),
    [anon_sym_using] = ACTIONS(3042),
    [anon_sym_static_assert] = ACTIONS(3042),
  },
  [1715] = {
    [sym_identifier] = ACTIONS(3042),
    [aux_sym_preproc_def_token1] = ACTIONS(3042),
    [aux_sym_preproc_if_token1] = ACTIONS(3042),
    [aux_sym_preproc_if_token2] = ACTIONS(3042),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3042),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3042),
    [aux_sym_preproc_else_token1] = ACTIONS(3042),
    [aux_sym_preproc_elif_token1] = ACTIONS(3042),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3042),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3042),
    [sym_preproc_directive] = ACTIONS(3042),
    [anon_sym_LPAREN2] = ACTIONS(3044),
    [anon_sym_TILDE] = ACTIONS(3044),
    [anon_sym_STAR] = ACTIONS(3044),
    [anon_sym_AMP_AMP] = ACTIONS(3044),
    [anon_sym_AMP] = ACTIONS(3042),
    [anon_sym_SEMI] = ACTIONS(3044),
    [anon_sym___extension__] = ACTIONS(3042),
    [anon_sym_typedef] = ACTIONS(3042),
    [anon_sym_virtual] = ACTIONS(3042),
    [anon_sym_extern] = ACTIONS(3042),
    [anon_sym___attribute__] = ACTIONS(3042),
    [anon_sym___attribute] = ACTIONS(3042),
    [anon_sym_COLON_COLON] = ACTIONS(3044),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3044),
    [anon_sym___declspec] = ACTIONS(3042),
    [anon_sym___based] = ACTIONS(3042),
    [anon_sym_signed] = ACTIONS(3042),
    [anon_sym_unsigned] = ACTIONS(3042),
    [anon_sym_long] = ACTIONS(3042),
    [anon_sym_short] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3042),
    [anon_sym_static] = ACTIONS(3042),
    [anon_sym_register] = ACTIONS(3042),
    [anon_sym_inline] = ACTIONS(3042),
    [anon_sym___inline] = ACTIONS(3042),
    [anon_sym___inline__] = ACTIONS(3042),
    [anon_sym___forceinline] = ACTIONS(3042),
    [anon_sym_thread_local] = ACTIONS(3042),
    [anon_sym___thread] = ACTIONS(3042),
    [anon_sym_const] = ACTIONS(3042),
    [anon_sym_constexpr] = ACTIONS(3042),
    [anon_sym_volatile] = ACTIONS(3042),
    [anon_sym_restrict] = ACTIONS(3042),
    [anon_sym___restrict__] = ACTIONS(3042),
    [anon_sym__Atomic] = ACTIONS(3042),
    [anon_sym__Noreturn] = ACTIONS(3042),
    [anon_sym_noreturn] = ACTIONS(3042),
    [anon_sym__Nonnull] = ACTIONS(3042),
    [anon_sym_mutable] = ACTIONS(3042),
    [anon_sym_constinit] = ACTIONS(3042),
    [anon_sym_consteval] = ACTIONS(3042),
    [anon_sym_alignas] = ACTIONS(3042),
    [anon_sym__Alignas] = ACTIONS(3042),
    [sym_primitive_type] = ACTIONS(3042),
    [anon_sym_enum] = ACTIONS(3042),
    [anon_sym_class] = ACTIONS(3042),
    [anon_sym_struct] = ACTIONS(3042),
    [anon_sym_union] = ACTIONS(3042),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3042),
    [anon_sym_decltype] = ACTIONS(3042),
    [anon_sym_explicit] = ACTIONS(3042),
    [anon_sym_typename] = ACTIONS(3042),
    [anon_sym_template] = ACTIONS(3042),
    [anon_sym_operator] = ACTIONS(3042),
    [anon_sym_friend] = ACTIONS(3042),
    [anon_sym_public] = ACTIONS(3042),
    [anon_sym_private] = ACTIONS(3042),
    [anon_sym_protected] = ACTIONS(3042),
    [anon_sym_using] = ACTIONS(3042),
    [anon_sym_static_assert] = ACTIONS(3042),
  },
  [1716] = {
    [sym_identifier] = ACTIONS(3046),
    [aux_sym_preproc_def_token1] = ACTIONS(3046),
    [aux_sym_preproc_if_token1] = ACTIONS(3046),
    [aux_sym_preproc_if_token2] = ACTIONS(3046),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3046),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3046),
    [aux_sym_preproc_else_token1] = ACTIONS(3046),
    [aux_sym_preproc_elif_token1] = ACTIONS(3046),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3046),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3046),
    [sym_preproc_directive] = ACTIONS(3046),
    [anon_sym_LPAREN2] = ACTIONS(3048),
    [anon_sym_TILDE] = ACTIONS(3048),
    [anon_sym_STAR] = ACTIONS(3048),
    [anon_sym_AMP_AMP] = ACTIONS(3048),
    [anon_sym_AMP] = ACTIONS(3046),
    [anon_sym_SEMI] = ACTIONS(3048),
    [anon_sym___extension__] = ACTIONS(3046),
    [anon_sym_typedef] = ACTIONS(3046),
    [anon_sym_virtual] = ACTIONS(3046),
    [anon_sym_extern] = ACTIONS(3046),
    [anon_sym___attribute__] = ACTIONS(3046),
    [anon_sym___attribute] = ACTIONS(3046),
    [anon_sym_COLON_COLON] = ACTIONS(3048),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3048),
    [anon_sym___declspec] = ACTIONS(3046),
    [anon_sym___based] = ACTIONS(3046),
    [anon_sym_signed] = ACTIONS(3046),
    [anon_sym_unsigned] = ACTIONS(3046),
    [anon_sym_long] = ACTIONS(3046),
    [anon_sym_short] = ACTIONS(3046),
    [anon_sym_LBRACK] = ACTIONS(3046),
    [anon_sym_static] = ACTIONS(3046),
    [anon_sym_register] = ACTIONS(3046),
    [anon_sym_inline] = ACTIONS(3046),
    [anon_sym___inline] = ACTIONS(3046),
    [anon_sym___inline__] = ACTIONS(3046),
    [anon_sym___forceinline] = ACTIONS(3046),
    [anon_sym_thread_local] = ACTIONS(3046),
    [anon_sym___thread] = ACTIONS(3046),
    [anon_sym_const] = ACTIONS(3046),
    [anon_sym_constexpr] = ACTIONS(3046),
    [anon_sym_volatile] = ACTIONS(3046),
    [anon_sym_restrict] = ACTIONS(3046),
    [anon_sym___restrict__] = ACTIONS(3046),
    [anon_sym__Atomic] = ACTIONS(3046),
    [anon_sym__Noreturn] = ACTIONS(3046),
    [anon_sym_noreturn] = ACTIONS(3046),
    [anon_sym__Nonnull] = ACTIONS(3046),
    [anon_sym_mutable] = ACTIONS(3046),
    [anon_sym_constinit] = ACTIONS(3046),
    [anon_sym_consteval] = ACTIONS(3046),
    [anon_sym_alignas] = ACTIONS(3046),
    [anon_sym__Alignas] = ACTIONS(3046),
    [sym_primitive_type] = ACTIONS(3046),
    [anon_sym_enum] = ACTIONS(3046),
    [anon_sym_class] = ACTIONS(3046),
    [anon_sym_struct] = ACTIONS(3046),
    [anon_sym_union] = ACTIONS(3046),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3046),
    [anon_sym_decltype] = ACTIONS(3046),
    [anon_sym_explicit] = ACTIONS(3046),
    [anon_sym_typename] = ACTIONS(3046),
    [anon_sym_template] = ACTIONS(3046),
    [anon_sym_operator] = ACTIONS(3046),
    [anon_sym_friend] = ACTIONS(3046),
    [anon_sym_public] = ACTIONS(3046),
    [anon_sym_private] = ACTIONS(3046),
    [anon_sym_protected] = ACTIONS(3046),
    [anon_sym_using] = ACTIONS(3046),
    [anon_sym_static_assert] = ACTIONS(3046),
  },
  [1717] = {
    [sym_identifier] = ACTIONS(3050),
    [aux_sym_preproc_def_token1] = ACTIONS(3050),
    [aux_sym_preproc_if_token1] = ACTIONS(3050),
    [aux_sym_preproc_if_token2] = ACTIONS(3050),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3050),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3050),
    [aux_sym_preproc_else_token1] = ACTIONS(3050),
    [aux_sym_preproc_elif_token1] = ACTIONS(3050),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3050),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3050),
    [sym_preproc_directive] = ACTIONS(3050),
    [anon_sym_LPAREN2] = ACTIONS(3052),
    [anon_sym_TILDE] = ACTIONS(3052),
    [anon_sym_STAR] = ACTIONS(3052),
    [anon_sym_AMP_AMP] = ACTIONS(3052),
    [anon_sym_AMP] = ACTIONS(3050),
    [anon_sym_SEMI] = ACTIONS(3052),
    [anon_sym___extension__] = ACTIONS(3050),
    [anon_sym_typedef] = ACTIONS(3050),
    [anon_sym_virtual] = ACTIONS(3050),
    [anon_sym_extern] = ACTIONS(3050),
    [anon_sym___attribute__] = ACTIONS(3050),
    [anon_sym___attribute] = ACTIONS(3050),
    [anon_sym_COLON_COLON] = ACTIONS(3052),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3052),
    [anon_sym___declspec] = ACTIONS(3050),
    [anon_sym___based] = ACTIONS(3050),
    [anon_sym_signed] = ACTIONS(3050),
    [anon_sym_unsigned] = ACTIONS(3050),
    [anon_sym_long] = ACTIONS(3050),
    [anon_sym_short] = ACTIONS(3050),
    [anon_sym_LBRACK] = ACTIONS(3050),
    [anon_sym_static] = ACTIONS(3050),
    [anon_sym_register] = ACTIONS(3050),
    [anon_sym_inline] = ACTIONS(3050),
    [anon_sym___inline] = ACTIONS(3050),
    [anon_sym___inline__] = ACTIONS(3050),
    [anon_sym___forceinline] = ACTIONS(3050),
    [anon_sym_thread_local] = ACTIONS(3050),
    [anon_sym___thread] = ACTIONS(3050),
    [anon_sym_const] = ACTIONS(3050),
    [anon_sym_constexpr] = ACTIONS(3050),
    [anon_sym_volatile] = ACTIONS(3050),
    [anon_sym_restrict] = ACTIONS(3050),
    [anon_sym___restrict__] = ACTIONS(3050),
    [anon_sym__Atomic] = ACTIONS(3050),
    [anon_sym__Noreturn] = ACTIONS(3050),
    [anon_sym_noreturn] = ACTIONS(3050),
    [anon_sym__Nonnull] = ACTIONS(3050),
    [anon_sym_mutable] = ACTIONS(3050),
    [anon_sym_constinit] = ACTIONS(3050),
    [anon_sym_consteval] = ACTIONS(3050),
    [anon_sym_alignas] = ACTIONS(3050),
    [anon_sym__Alignas] = ACTIONS(3050),
    [sym_primitive_type] = ACTIONS(3050),
    [anon_sym_enum] = ACTIONS(3050),
    [anon_sym_class] = ACTIONS(3050),
    [anon_sym_struct] = ACTIONS(3050),
    [anon_sym_union] = ACTIONS(3050),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3050),
    [anon_sym_decltype] = ACTIONS(3050),
    [anon_sym_explicit] = ACTIONS(3050),
    [anon_sym_typename] = ACTIONS(3050),
    [anon_sym_template] = ACTIONS(3050),
    [anon_sym_operator] = ACTIONS(3050),
    [anon_sym_friend] = ACTIONS(3050),
    [anon_sym_public] = ACTIONS(3050),
    [anon_sym_private] = ACTIONS(3050),
    [anon_sym_protected] = ACTIONS(3050),
    [anon_sym_using] = ACTIONS(3050),
    [anon_sym_static_assert] = ACTIONS(3050),
  },
  [1718] = {
    [sym_identifier] = ACTIONS(3056),
    [aux_sym_preproc_def_token1] = ACTIONS(3056),
    [aux_sym_preproc_if_token1] = ACTIONS(3056),
    [aux_sym_preproc_if_token2] = ACTIONS(3056),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3056),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3056),
    [aux_sym_preproc_else_token1] = ACTIONS(3056),
    [aux_sym_preproc_elif_token1] = ACTIONS(3056),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3056),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3056),
    [sym_preproc_directive] = ACTIONS(3056),
    [anon_sym_LPAREN2] = ACTIONS(3058),
    [anon_sym_TILDE] = ACTIONS(3058),
    [anon_sym_STAR] = ACTIONS(3058),
    [anon_sym_AMP_AMP] = ACTIONS(3058),
    [anon_sym_AMP] = ACTIONS(3056),
    [anon_sym_SEMI] = ACTIONS(3058),
    [anon_sym___extension__] = ACTIONS(3056),
    [anon_sym_typedef] = ACTIONS(3056),
    [anon_sym_virtual] = ACTIONS(3056),
    [anon_sym_extern] = ACTIONS(3056),
    [anon_sym___attribute__] = ACTIONS(3056),
    [anon_sym___attribute] = ACTIONS(3056),
    [anon_sym_COLON_COLON] = ACTIONS(3058),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3058),
    [anon_sym___declspec] = ACTIONS(3056),
    [anon_sym___based] = ACTIONS(3056),
    [anon_sym_signed] = ACTIONS(3056),
    [anon_sym_unsigned] = ACTIONS(3056),
    [anon_sym_long] = ACTIONS(3056),
    [anon_sym_short] = ACTIONS(3056),
    [anon_sym_LBRACK] = ACTIONS(3056),
    [anon_sym_static] = ACTIONS(3056),
    [anon_sym_register] = ACTIONS(3056),
    [anon_sym_inline] = ACTIONS(3056),
    [anon_sym___inline] = ACTIONS(3056),
    [anon_sym___inline__] = ACTIONS(3056),
    [anon_sym___forceinline] = ACTIONS(3056),
    [anon_sym_thread_local] = ACTIONS(3056),
    [anon_sym___thread] = ACTIONS(3056),
    [anon_sym_const] = ACTIONS(3056),
    [anon_sym_constexpr] = ACTIONS(3056),
    [anon_sym_volatile] = ACTIONS(3056),
    [anon_sym_restrict] = ACTIONS(3056),
    [anon_sym___restrict__] = ACTIONS(3056),
    [anon_sym__Atomic] = ACTIONS(3056),
    [anon_sym__Noreturn] = ACTIONS(3056),
    [anon_sym_noreturn] = ACTIONS(3056),
    [anon_sym__Nonnull] = ACTIONS(3056),
    [anon_sym_mutable] = ACTIONS(3056),
    [anon_sym_constinit] = ACTIONS(3056),
    [anon_sym_consteval] = ACTIONS(3056),
    [anon_sym_alignas] = ACTIONS(3056),
    [anon_sym__Alignas] = ACTIONS(3056),
    [sym_primitive_type] = ACTIONS(3056),
    [anon_sym_enum] = ACTIONS(3056),
    [anon_sym_class] = ACTIONS(3056),
    [anon_sym_struct] = ACTIONS(3056),
    [anon_sym_union] = ACTIONS(3056),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3056),
    [anon_sym_decltype] = ACTIONS(3056),
    [anon_sym_explicit] = ACTIONS(3056),
    [anon_sym_typename] = ACTIONS(3056),
    [anon_sym_template] = ACTIONS(3056),
    [anon_sym_operator] = ACTIONS(3056),
    [anon_sym_friend] = ACTIONS(3056),
    [anon_sym_public] = ACTIONS(3056),
    [anon_sym_private] = ACTIONS(3056),
    [anon_sym_protected] = ACTIONS(3056),
    [anon_sym_using] = ACTIONS(3056),
    [anon_sym_static_assert] = ACTIONS(3056),
  },
  [1719] = {
    [sym_identifier] = ACTIONS(4814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4816),
    [anon_sym_COMMA] = ACTIONS(4816),
    [anon_sym_RPAREN] = ACTIONS(4816),
    [anon_sym_LPAREN2] = ACTIONS(4816),
    [anon_sym_DASH] = ACTIONS(4814),
    [anon_sym_PLUS] = ACTIONS(4814),
    [anon_sym_STAR] = ACTIONS(4816),
    [anon_sym_SLASH] = ACTIONS(4814),
    [anon_sym_PERCENT] = ACTIONS(4816),
    [anon_sym_PIPE_PIPE] = ACTIONS(4816),
    [anon_sym_AMP_AMP] = ACTIONS(4816),
    [anon_sym_PIPE] = ACTIONS(4814),
    [anon_sym_CARET] = ACTIONS(4816),
    [anon_sym_AMP] = ACTIONS(4814),
    [anon_sym_EQ_EQ] = ACTIONS(4816),
    [anon_sym_BANG_EQ] = ACTIONS(4816),
    [anon_sym_GT] = ACTIONS(4814),
    [anon_sym_GT_EQ] = ACTIONS(4816),
    [anon_sym_LT_EQ] = ACTIONS(4814),
    [anon_sym_LT] = ACTIONS(4814),
    [anon_sym_LT_LT] = ACTIONS(4816),
    [anon_sym_GT_GT] = ACTIONS(4816),
    [anon_sym_SEMI] = ACTIONS(4816),
    [anon_sym___extension__] = ACTIONS(4814),
    [anon_sym___attribute__] = ACTIONS(4814),
    [anon_sym___attribute] = ACTIONS(4814),
    [anon_sym_COLON_COLON] = ACTIONS(4816),
    [anon_sym___based] = ACTIONS(4814),
    [anon_sym_LBRACE] = ACTIONS(4816),
    [anon_sym_RBRACE] = ACTIONS(4816),
    [anon_sym_signed] = ACTIONS(4814),
    [anon_sym_unsigned] = ACTIONS(4814),
    [anon_sym_long] = ACTIONS(4814),
    [anon_sym_short] = ACTIONS(4814),
    [anon_sym_LBRACK] = ACTIONS(4816),
    [anon_sym_RBRACK] = ACTIONS(4816),
    [anon_sym_const] = ACTIONS(4814),
    [anon_sym_constexpr] = ACTIONS(4814),
    [anon_sym_volatile] = ACTIONS(4814),
    [anon_sym_restrict] = ACTIONS(4814),
    [anon_sym___restrict__] = ACTIONS(4814),
    [anon_sym__Atomic] = ACTIONS(4814),
    [anon_sym__Noreturn] = ACTIONS(4814),
    [anon_sym_noreturn] = ACTIONS(4814),
    [anon_sym__Nonnull] = ACTIONS(4814),
    [anon_sym_mutable] = ACTIONS(4814),
    [anon_sym_constinit] = ACTIONS(4814),
    [anon_sym_consteval] = ACTIONS(4814),
    [anon_sym_alignas] = ACTIONS(4814),
    [anon_sym__Alignas] = ACTIONS(4814),
    [sym_primitive_type] = ACTIONS(4814),
    [anon_sym_COLON] = ACTIONS(4814),
    [anon_sym_QMARK] = ACTIONS(4816),
    [anon_sym_LT_EQ_GT] = ACTIONS(4816),
    [anon_sym_or] = ACTIONS(4814),
    [anon_sym_and] = ACTIONS(4814),
    [anon_sym_bitor] = ACTIONS(4814),
    [anon_sym_xor] = ACTIONS(4814),
    [anon_sym_bitand] = ACTIONS(4814),
    [anon_sym_not_eq] = ACTIONS(4814),
    [anon_sym_DASH_DASH] = ACTIONS(4816),
    [anon_sym_PLUS_PLUS] = ACTIONS(4816),
    [anon_sym_DOT] = ACTIONS(4814),
    [anon_sym_DOT_STAR] = ACTIONS(4816),
    [anon_sym_DASH_GT] = ACTIONS(4816),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4814),
    [anon_sym_decltype] = ACTIONS(4814),
    [anon_sym_final] = ACTIONS(4814),
    [anon_sym_override] = ACTIONS(4814),
    [anon_sym_requires] = ACTIONS(4814),
  },
  [1720] = {
    [sym_identifier] = ACTIONS(3060),
    [aux_sym_preproc_def_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token2] = ACTIONS(3060),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3060),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3060),
    [aux_sym_preproc_else_token1] = ACTIONS(3060),
    [aux_sym_preproc_elif_token1] = ACTIONS(3060),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3060),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3060),
    [sym_preproc_directive] = ACTIONS(3060),
    [anon_sym_LPAREN2] = ACTIONS(3062),
    [anon_sym_TILDE] = ACTIONS(3062),
    [anon_sym_STAR] = ACTIONS(3062),
    [anon_sym_AMP_AMP] = ACTIONS(3062),
    [anon_sym_AMP] = ACTIONS(3060),
    [anon_sym_SEMI] = ACTIONS(3062),
    [anon_sym___extension__] = ACTIONS(3060),
    [anon_sym_typedef] = ACTIONS(3060),
    [anon_sym_virtual] = ACTIONS(3060),
    [anon_sym_extern] = ACTIONS(3060),
    [anon_sym___attribute__] = ACTIONS(3060),
    [anon_sym___attribute] = ACTIONS(3060),
    [anon_sym_COLON_COLON] = ACTIONS(3062),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3062),
    [anon_sym___declspec] = ACTIONS(3060),
    [anon_sym___based] = ACTIONS(3060),
    [anon_sym_signed] = ACTIONS(3060),
    [anon_sym_unsigned] = ACTIONS(3060),
    [anon_sym_long] = ACTIONS(3060),
    [anon_sym_short] = ACTIONS(3060),
    [anon_sym_LBRACK] = ACTIONS(3060),
    [anon_sym_static] = ACTIONS(3060),
    [anon_sym_register] = ACTIONS(3060),
    [anon_sym_inline] = ACTIONS(3060),
    [anon_sym___inline] = ACTIONS(3060),
    [anon_sym___inline__] = ACTIONS(3060),
    [anon_sym___forceinline] = ACTIONS(3060),
    [anon_sym_thread_local] = ACTIONS(3060),
    [anon_sym___thread] = ACTIONS(3060),
    [anon_sym_const] = ACTIONS(3060),
    [anon_sym_constexpr] = ACTIONS(3060),
    [anon_sym_volatile] = ACTIONS(3060),
    [anon_sym_restrict] = ACTIONS(3060),
    [anon_sym___restrict__] = ACTIONS(3060),
    [anon_sym__Atomic] = ACTIONS(3060),
    [anon_sym__Noreturn] = ACTIONS(3060),
    [anon_sym_noreturn] = ACTIONS(3060),
    [anon_sym__Nonnull] = ACTIONS(3060),
    [anon_sym_mutable] = ACTIONS(3060),
    [anon_sym_constinit] = ACTIONS(3060),
    [anon_sym_consteval] = ACTIONS(3060),
    [anon_sym_alignas] = ACTIONS(3060),
    [anon_sym__Alignas] = ACTIONS(3060),
    [sym_primitive_type] = ACTIONS(3060),
    [anon_sym_enum] = ACTIONS(3060),
    [anon_sym_class] = ACTIONS(3060),
    [anon_sym_struct] = ACTIONS(3060),
    [anon_sym_union] = ACTIONS(3060),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3060),
    [anon_sym_decltype] = ACTIONS(3060),
    [anon_sym_explicit] = ACTIONS(3060),
    [anon_sym_typename] = ACTIONS(3060),
    [anon_sym_template] = ACTIONS(3060),
    [anon_sym_operator] = ACTIONS(3060),
    [anon_sym_friend] = ACTIONS(3060),
    [anon_sym_public] = ACTIONS(3060),
    [anon_sym_private] = ACTIONS(3060),
    [anon_sym_protected] = ACTIONS(3060),
    [anon_sym_using] = ACTIONS(3060),
    [anon_sym_static_assert] = ACTIONS(3060),
  },
  [1721] = {
    [sym__declaration_modifiers] = STATE(3299),
    [sym_attribute_specifier] = STATE(3299),
    [sym_attribute_declaration] = STATE(3299),
    [sym_ms_declspec_modifier] = STATE(3299),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6268),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3299),
    [sym_type_qualifier] = STATE(3299),
    [sym_alignas_qualifier] = STATE(3049),
    [sym_decltype] = STATE(8512),
    [sym_explicit_function_specifier] = STATE(3299),
    [sym_operator_cast] = STATE(6689),
    [sym__constructor_specifiers] = STATE(3299),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(8512),
    [sym_template_function] = STATE(5896),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5444),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_operator_cast_identifier] = STATE(6689),
    [sym_operator_name] = STATE(5896),
    [aux_sym_operator_cast_definition_repeat1] = STATE(3299),
    [sym_identifier] = ACTIONS(5327),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym___extension__] = ACTIONS(5329),
    [anon_sym_virtual] = ACTIONS(5331),
    [anon_sym_extern] = ACTIONS(5333),
    [anon_sym___attribute__] = ACTIONS(5335),
    [anon_sym___attribute] = ACTIONS(5335),
    [anon_sym_COLON_COLON] = ACTIONS(5337),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5339),
    [anon_sym___declspec] = ACTIONS(5341),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(5333),
    [anon_sym_register] = ACTIONS(5333),
    [anon_sym_inline] = ACTIONS(5333),
    [anon_sym___inline] = ACTIONS(5333),
    [anon_sym___inline__] = ACTIONS(5333),
    [anon_sym___forceinline] = ACTIONS(5333),
    [anon_sym_thread_local] = ACTIONS(5333),
    [anon_sym___thread] = ACTIONS(5333),
    [anon_sym_const] = ACTIONS(5329),
    [anon_sym_constexpr] = ACTIONS(5329),
    [anon_sym_volatile] = ACTIONS(5329),
    [anon_sym_restrict] = ACTIONS(5329),
    [anon_sym___restrict__] = ACTIONS(5329),
    [anon_sym__Atomic] = ACTIONS(5329),
    [anon_sym__Noreturn] = ACTIONS(5329),
    [anon_sym_noreturn] = ACTIONS(5329),
    [anon_sym__Nonnull] = ACTIONS(5329),
    [anon_sym_mutable] = ACTIONS(5329),
    [anon_sym_constinit] = ACTIONS(5329),
    [anon_sym_consteval] = ACTIONS(5329),
    [anon_sym_alignas] = ACTIONS(5343),
    [anon_sym__Alignas] = ACTIONS(5343),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_operator] = ACTIONS(133),
  },
  [1722] = {
    [sym_identifier] = ACTIONS(3064),
    [aux_sym_preproc_def_token1] = ACTIONS(3064),
    [aux_sym_preproc_if_token1] = ACTIONS(3064),
    [aux_sym_preproc_if_token2] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3064),
    [aux_sym_preproc_else_token1] = ACTIONS(3064),
    [aux_sym_preproc_elif_token1] = ACTIONS(3064),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3064),
    [sym_preproc_directive] = ACTIONS(3064),
    [anon_sym_LPAREN2] = ACTIONS(3066),
    [anon_sym_TILDE] = ACTIONS(3066),
    [anon_sym_STAR] = ACTIONS(3066),
    [anon_sym_AMP_AMP] = ACTIONS(3066),
    [anon_sym_AMP] = ACTIONS(3064),
    [anon_sym_SEMI] = ACTIONS(3066),
    [anon_sym___extension__] = ACTIONS(3064),
    [anon_sym_typedef] = ACTIONS(3064),
    [anon_sym_virtual] = ACTIONS(3064),
    [anon_sym_extern] = ACTIONS(3064),
    [anon_sym___attribute__] = ACTIONS(3064),
    [anon_sym___attribute] = ACTIONS(3064),
    [anon_sym_COLON_COLON] = ACTIONS(3066),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3066),
    [anon_sym___declspec] = ACTIONS(3064),
    [anon_sym___based] = ACTIONS(3064),
    [anon_sym_signed] = ACTIONS(3064),
    [anon_sym_unsigned] = ACTIONS(3064),
    [anon_sym_long] = ACTIONS(3064),
    [anon_sym_short] = ACTIONS(3064),
    [anon_sym_LBRACK] = ACTIONS(3064),
    [anon_sym_static] = ACTIONS(3064),
    [anon_sym_register] = ACTIONS(3064),
    [anon_sym_inline] = ACTIONS(3064),
    [anon_sym___inline] = ACTIONS(3064),
    [anon_sym___inline__] = ACTIONS(3064),
    [anon_sym___forceinline] = ACTIONS(3064),
    [anon_sym_thread_local] = ACTIONS(3064),
    [anon_sym___thread] = ACTIONS(3064),
    [anon_sym_const] = ACTIONS(3064),
    [anon_sym_constexpr] = ACTIONS(3064),
    [anon_sym_volatile] = ACTIONS(3064),
    [anon_sym_restrict] = ACTIONS(3064),
    [anon_sym___restrict__] = ACTIONS(3064),
    [anon_sym__Atomic] = ACTIONS(3064),
    [anon_sym__Noreturn] = ACTIONS(3064),
    [anon_sym_noreturn] = ACTIONS(3064),
    [anon_sym__Nonnull] = ACTIONS(3064),
    [anon_sym_mutable] = ACTIONS(3064),
    [anon_sym_constinit] = ACTIONS(3064),
    [anon_sym_consteval] = ACTIONS(3064),
    [anon_sym_alignas] = ACTIONS(3064),
    [anon_sym__Alignas] = ACTIONS(3064),
    [sym_primitive_type] = ACTIONS(3064),
    [anon_sym_enum] = ACTIONS(3064),
    [anon_sym_class] = ACTIONS(3064),
    [anon_sym_struct] = ACTIONS(3064),
    [anon_sym_union] = ACTIONS(3064),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3064),
    [anon_sym_decltype] = ACTIONS(3064),
    [anon_sym_explicit] = ACTIONS(3064),
    [anon_sym_typename] = ACTIONS(3064),
    [anon_sym_template] = ACTIONS(3064),
    [anon_sym_operator] = ACTIONS(3064),
    [anon_sym_friend] = ACTIONS(3064),
    [anon_sym_public] = ACTIONS(3064),
    [anon_sym_private] = ACTIONS(3064),
    [anon_sym_protected] = ACTIONS(3064),
    [anon_sym_using] = ACTIONS(3064),
    [anon_sym_static_assert] = ACTIONS(3064),
  },
  [1723] = {
    [sym_identifier] = ACTIONS(3068),
    [aux_sym_preproc_def_token1] = ACTIONS(3068),
    [aux_sym_preproc_if_token1] = ACTIONS(3068),
    [aux_sym_preproc_if_token2] = ACTIONS(3068),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3068),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3068),
    [aux_sym_preproc_else_token1] = ACTIONS(3068),
    [aux_sym_preproc_elif_token1] = ACTIONS(3068),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3068),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3068),
    [sym_preproc_directive] = ACTIONS(3068),
    [anon_sym_LPAREN2] = ACTIONS(3070),
    [anon_sym_TILDE] = ACTIONS(3070),
    [anon_sym_STAR] = ACTIONS(3070),
    [anon_sym_AMP_AMP] = ACTIONS(3070),
    [anon_sym_AMP] = ACTIONS(3068),
    [anon_sym_SEMI] = ACTIONS(3070),
    [anon_sym___extension__] = ACTIONS(3068),
    [anon_sym_typedef] = ACTIONS(3068),
    [anon_sym_virtual] = ACTIONS(3068),
    [anon_sym_extern] = ACTIONS(3068),
    [anon_sym___attribute__] = ACTIONS(3068),
    [anon_sym___attribute] = ACTIONS(3068),
    [anon_sym_COLON_COLON] = ACTIONS(3070),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3070),
    [anon_sym___declspec] = ACTIONS(3068),
    [anon_sym___based] = ACTIONS(3068),
    [anon_sym_signed] = ACTIONS(3068),
    [anon_sym_unsigned] = ACTIONS(3068),
    [anon_sym_long] = ACTIONS(3068),
    [anon_sym_short] = ACTIONS(3068),
    [anon_sym_LBRACK] = ACTIONS(3068),
    [anon_sym_static] = ACTIONS(3068),
    [anon_sym_register] = ACTIONS(3068),
    [anon_sym_inline] = ACTIONS(3068),
    [anon_sym___inline] = ACTIONS(3068),
    [anon_sym___inline__] = ACTIONS(3068),
    [anon_sym___forceinline] = ACTIONS(3068),
    [anon_sym_thread_local] = ACTIONS(3068),
    [anon_sym___thread] = ACTIONS(3068),
    [anon_sym_const] = ACTIONS(3068),
    [anon_sym_constexpr] = ACTIONS(3068),
    [anon_sym_volatile] = ACTIONS(3068),
    [anon_sym_restrict] = ACTIONS(3068),
    [anon_sym___restrict__] = ACTIONS(3068),
    [anon_sym__Atomic] = ACTIONS(3068),
    [anon_sym__Noreturn] = ACTIONS(3068),
    [anon_sym_noreturn] = ACTIONS(3068),
    [anon_sym__Nonnull] = ACTIONS(3068),
    [anon_sym_mutable] = ACTIONS(3068),
    [anon_sym_constinit] = ACTIONS(3068),
    [anon_sym_consteval] = ACTIONS(3068),
    [anon_sym_alignas] = ACTIONS(3068),
    [anon_sym__Alignas] = ACTIONS(3068),
    [sym_primitive_type] = ACTIONS(3068),
    [anon_sym_enum] = ACTIONS(3068),
    [anon_sym_class] = ACTIONS(3068),
    [anon_sym_struct] = ACTIONS(3068),
    [anon_sym_union] = ACTIONS(3068),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3068),
    [anon_sym_decltype] = ACTIONS(3068),
    [anon_sym_explicit] = ACTIONS(3068),
    [anon_sym_typename] = ACTIONS(3068),
    [anon_sym_template] = ACTIONS(3068),
    [anon_sym_operator] = ACTIONS(3068),
    [anon_sym_friend] = ACTIONS(3068),
    [anon_sym_public] = ACTIONS(3068),
    [anon_sym_private] = ACTIONS(3068),
    [anon_sym_protected] = ACTIONS(3068),
    [anon_sym_using] = ACTIONS(3068),
    [anon_sym_static_assert] = ACTIONS(3068),
  },
  [1724] = {
    [sym_attribute_specifier] = STATE(2208),
    [sym_field_declaration_list] = STATE(2126),
    [sym_virtual_specifier] = STATE(6899),
    [sym_base_class_clause] = STATE(7724),
    [sym_identifier] = ACTIONS(5375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5377),
    [anon_sym_COMMA] = ACTIONS(5377),
    [anon_sym_RPAREN] = ACTIONS(5377),
    [aux_sym_preproc_if_token2] = ACTIONS(5377),
    [aux_sym_preproc_else_token1] = ACTIONS(5377),
    [aux_sym_preproc_elif_token1] = ACTIONS(5375),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5377),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5377),
    [anon_sym_LPAREN2] = ACTIONS(5377),
    [anon_sym_DASH] = ACTIONS(5375),
    [anon_sym_PLUS] = ACTIONS(5375),
    [anon_sym_STAR] = ACTIONS(5375),
    [anon_sym_SLASH] = ACTIONS(5375),
    [anon_sym_PERCENT] = ACTIONS(5375),
    [anon_sym_PIPE_PIPE] = ACTIONS(5377),
    [anon_sym_AMP_AMP] = ACTIONS(5377),
    [anon_sym_PIPE] = ACTIONS(5375),
    [anon_sym_CARET] = ACTIONS(5375),
    [anon_sym_AMP] = ACTIONS(5375),
    [anon_sym_EQ_EQ] = ACTIONS(5377),
    [anon_sym_BANG_EQ] = ACTIONS(5377),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5377),
    [anon_sym_LT_EQ] = ACTIONS(5375),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_LT] = ACTIONS(5375),
    [anon_sym_GT_GT] = ACTIONS(5375),
    [anon_sym_SEMI] = ACTIONS(5377),
    [anon_sym___attribute__] = ACTIONS(5379),
    [anon_sym___attribute] = ACTIONS(5379),
    [anon_sym_LBRACE] = ACTIONS(5381),
    [anon_sym_RBRACE] = ACTIONS(5377),
    [anon_sym_LBRACK] = ACTIONS(5377),
    [anon_sym_RBRACK] = ACTIONS(5377),
    [anon_sym_EQ] = ACTIONS(5375),
    [anon_sym_COLON] = ACTIONS(5383),
    [anon_sym_QMARK] = ACTIONS(5377),
    [anon_sym_STAR_EQ] = ACTIONS(5377),
    [anon_sym_SLASH_EQ] = ACTIONS(5377),
    [anon_sym_PERCENT_EQ] = ACTIONS(5377),
    [anon_sym_PLUS_EQ] = ACTIONS(5377),
    [anon_sym_DASH_EQ] = ACTIONS(5377),
    [anon_sym_LT_LT_EQ] = ACTIONS(5377),
    [anon_sym_GT_GT_EQ] = ACTIONS(5377),
    [anon_sym_AMP_EQ] = ACTIONS(5377),
    [anon_sym_CARET_EQ] = ACTIONS(5377),
    [anon_sym_PIPE_EQ] = ACTIONS(5377),
    [anon_sym_and_eq] = ACTIONS(5375),
    [anon_sym_or_eq] = ACTIONS(5375),
    [anon_sym_xor_eq] = ACTIONS(5375),
    [anon_sym_LT_EQ_GT] = ACTIONS(5377),
    [anon_sym_or] = ACTIONS(5375),
    [anon_sym_and] = ACTIONS(5375),
    [anon_sym_bitor] = ACTIONS(5375),
    [anon_sym_xor] = ACTIONS(5375),
    [anon_sym_bitand] = ACTIONS(5375),
    [anon_sym_not_eq] = ACTIONS(5375),
    [anon_sym_DASH_DASH] = ACTIONS(5377),
    [anon_sym_PLUS_PLUS] = ACTIONS(5377),
    [anon_sym_DOT] = ACTIONS(5375),
    [anon_sym_DOT_STAR] = ACTIONS(5377),
    [anon_sym_DASH_GT] = ACTIONS(5377),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5375),
    [anon_sym_decltype] = ACTIONS(5375),
    [anon_sym_final] = ACTIONS(5385),
    [anon_sym_override] = ACTIONS(5385),
  },
  [1725] = {
    [sym_identifier] = ACTIONS(5367),
    [aux_sym_preproc_def_token1] = ACTIONS(5367),
    [aux_sym_preproc_if_token1] = ACTIONS(5367),
    [aux_sym_preproc_if_token2] = ACTIONS(5367),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5367),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5367),
    [aux_sym_preproc_else_token1] = ACTIONS(5367),
    [aux_sym_preproc_elif_token1] = ACTIONS(5367),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5367),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5367),
    [sym_preproc_directive] = ACTIONS(5367),
    [anon_sym_LPAREN2] = ACTIONS(5369),
    [anon_sym_TILDE] = ACTIONS(5369),
    [anon_sym_STAR] = ACTIONS(5369),
    [anon_sym_AMP_AMP] = ACTIONS(5369),
    [anon_sym_AMP] = ACTIONS(5367),
    [anon_sym_SEMI] = ACTIONS(5369),
    [anon_sym___extension__] = ACTIONS(5367),
    [anon_sym_typedef] = ACTIONS(5367),
    [anon_sym_virtual] = ACTIONS(5367),
    [anon_sym_extern] = ACTIONS(5367),
    [anon_sym___attribute__] = ACTIONS(5367),
    [anon_sym___attribute] = ACTIONS(5367),
    [anon_sym_COLON_COLON] = ACTIONS(5369),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5369),
    [anon_sym___declspec] = ACTIONS(5367),
    [anon_sym___based] = ACTIONS(5367),
    [anon_sym_signed] = ACTIONS(5367),
    [anon_sym_unsigned] = ACTIONS(5367),
    [anon_sym_long] = ACTIONS(5367),
    [anon_sym_short] = ACTIONS(5367),
    [anon_sym_LBRACK] = ACTIONS(5367),
    [anon_sym_static] = ACTIONS(5367),
    [anon_sym_register] = ACTIONS(5367),
    [anon_sym_inline] = ACTIONS(5367),
    [anon_sym___inline] = ACTIONS(5367),
    [anon_sym___inline__] = ACTIONS(5367),
    [anon_sym___forceinline] = ACTIONS(5367),
    [anon_sym_thread_local] = ACTIONS(5367),
    [anon_sym___thread] = ACTIONS(5367),
    [anon_sym_const] = ACTIONS(5367),
    [anon_sym_constexpr] = ACTIONS(5367),
    [anon_sym_volatile] = ACTIONS(5367),
    [anon_sym_restrict] = ACTIONS(5367),
    [anon_sym___restrict__] = ACTIONS(5367),
    [anon_sym__Atomic] = ACTIONS(5367),
    [anon_sym__Noreturn] = ACTIONS(5367),
    [anon_sym_noreturn] = ACTIONS(5367),
    [anon_sym__Nonnull] = ACTIONS(5367),
    [anon_sym_mutable] = ACTIONS(5367),
    [anon_sym_constinit] = ACTIONS(5367),
    [anon_sym_consteval] = ACTIONS(5367),
    [anon_sym_alignas] = ACTIONS(5367),
    [anon_sym__Alignas] = ACTIONS(5367),
    [sym_primitive_type] = ACTIONS(5367),
    [anon_sym_enum] = ACTIONS(5367),
    [anon_sym_class] = ACTIONS(5367),
    [anon_sym_struct] = ACTIONS(5367),
    [anon_sym_union] = ACTIONS(5367),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5367),
    [anon_sym_decltype] = ACTIONS(5367),
    [anon_sym_explicit] = ACTIONS(5367),
    [anon_sym_typename] = ACTIONS(5367),
    [anon_sym_template] = ACTIONS(5367),
    [anon_sym_operator] = ACTIONS(5367),
    [anon_sym_friend] = ACTIONS(5367),
    [anon_sym_public] = ACTIONS(5367),
    [anon_sym_private] = ACTIONS(5367),
    [anon_sym_protected] = ACTIONS(5367),
    [anon_sym_using] = ACTIONS(5367),
    [anon_sym_static_assert] = ACTIONS(5367),
  },
  [1726] = {
    [sym_identifier] = ACTIONS(2735),
    [aux_sym_preproc_def_token1] = ACTIONS(2735),
    [aux_sym_preproc_if_token1] = ACTIONS(2735),
    [aux_sym_preproc_if_token2] = ACTIONS(2735),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2735),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2735),
    [aux_sym_preproc_else_token1] = ACTIONS(2735),
    [aux_sym_preproc_elif_token1] = ACTIONS(2735),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2735),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2735),
    [sym_preproc_directive] = ACTIONS(2735),
    [anon_sym_LPAREN2] = ACTIONS(2737),
    [anon_sym_TILDE] = ACTIONS(2737),
    [anon_sym_STAR] = ACTIONS(2737),
    [anon_sym_AMP_AMP] = ACTIONS(2737),
    [anon_sym_AMP] = ACTIONS(2735),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym___extension__] = ACTIONS(2735),
    [anon_sym_typedef] = ACTIONS(2735),
    [anon_sym_virtual] = ACTIONS(2735),
    [anon_sym_extern] = ACTIONS(2735),
    [anon_sym___attribute__] = ACTIONS(2735),
    [anon_sym___attribute] = ACTIONS(2735),
    [anon_sym_COLON_COLON] = ACTIONS(2737),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2737),
    [anon_sym___declspec] = ACTIONS(2735),
    [anon_sym___based] = ACTIONS(2735),
    [anon_sym_signed] = ACTIONS(2735),
    [anon_sym_unsigned] = ACTIONS(2735),
    [anon_sym_long] = ACTIONS(2735),
    [anon_sym_short] = ACTIONS(2735),
    [anon_sym_LBRACK] = ACTIONS(2735),
    [anon_sym_static] = ACTIONS(2735),
    [anon_sym_register] = ACTIONS(2735),
    [anon_sym_inline] = ACTIONS(2735),
    [anon_sym___inline] = ACTIONS(2735),
    [anon_sym___inline__] = ACTIONS(2735),
    [anon_sym___forceinline] = ACTIONS(2735),
    [anon_sym_thread_local] = ACTIONS(2735),
    [anon_sym___thread] = ACTIONS(2735),
    [anon_sym_const] = ACTIONS(2735),
    [anon_sym_constexpr] = ACTIONS(2735),
    [anon_sym_volatile] = ACTIONS(2735),
    [anon_sym_restrict] = ACTIONS(2735),
    [anon_sym___restrict__] = ACTIONS(2735),
    [anon_sym__Atomic] = ACTIONS(2735),
    [anon_sym__Noreturn] = ACTIONS(2735),
    [anon_sym_noreturn] = ACTIONS(2735),
    [anon_sym__Nonnull] = ACTIONS(2735),
    [anon_sym_mutable] = ACTIONS(2735),
    [anon_sym_constinit] = ACTIONS(2735),
    [anon_sym_consteval] = ACTIONS(2735),
    [anon_sym_alignas] = ACTIONS(2735),
    [anon_sym__Alignas] = ACTIONS(2735),
    [sym_primitive_type] = ACTIONS(2735),
    [anon_sym_enum] = ACTIONS(2735),
    [anon_sym_class] = ACTIONS(2735),
    [anon_sym_struct] = ACTIONS(2735),
    [anon_sym_union] = ACTIONS(2735),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2735),
    [anon_sym_decltype] = ACTIONS(2735),
    [anon_sym_explicit] = ACTIONS(2735),
    [anon_sym_typename] = ACTIONS(2735),
    [anon_sym_template] = ACTIONS(2735),
    [anon_sym_operator] = ACTIONS(2735),
    [anon_sym_friend] = ACTIONS(2735),
    [anon_sym_public] = ACTIONS(2735),
    [anon_sym_private] = ACTIONS(2735),
    [anon_sym_protected] = ACTIONS(2735),
    [anon_sym_using] = ACTIONS(2735),
    [anon_sym_static_assert] = ACTIONS(2735),
  },
  [1727] = {
    [sym_identifier] = ACTIONS(2739),
    [aux_sym_preproc_def_token1] = ACTIONS(2739),
    [aux_sym_preproc_if_token1] = ACTIONS(2739),
    [aux_sym_preproc_if_token2] = ACTIONS(2739),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2739),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2739),
    [aux_sym_preproc_else_token1] = ACTIONS(2739),
    [aux_sym_preproc_elif_token1] = ACTIONS(2739),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2739),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2739),
    [sym_preproc_directive] = ACTIONS(2739),
    [anon_sym_LPAREN2] = ACTIONS(2741),
    [anon_sym_TILDE] = ACTIONS(2741),
    [anon_sym_STAR] = ACTIONS(2741),
    [anon_sym_AMP_AMP] = ACTIONS(2741),
    [anon_sym_AMP] = ACTIONS(2739),
    [anon_sym_SEMI] = ACTIONS(2741),
    [anon_sym___extension__] = ACTIONS(2739),
    [anon_sym_typedef] = ACTIONS(2739),
    [anon_sym_virtual] = ACTIONS(2739),
    [anon_sym_extern] = ACTIONS(2739),
    [anon_sym___attribute__] = ACTIONS(2739),
    [anon_sym___attribute] = ACTIONS(2739),
    [anon_sym_COLON_COLON] = ACTIONS(2741),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2741),
    [anon_sym___declspec] = ACTIONS(2739),
    [anon_sym___based] = ACTIONS(2739),
    [anon_sym_signed] = ACTIONS(2739),
    [anon_sym_unsigned] = ACTIONS(2739),
    [anon_sym_long] = ACTIONS(2739),
    [anon_sym_short] = ACTIONS(2739),
    [anon_sym_LBRACK] = ACTIONS(2739),
    [anon_sym_static] = ACTIONS(2739),
    [anon_sym_register] = ACTIONS(2739),
    [anon_sym_inline] = ACTIONS(2739),
    [anon_sym___inline] = ACTIONS(2739),
    [anon_sym___inline__] = ACTIONS(2739),
    [anon_sym___forceinline] = ACTIONS(2739),
    [anon_sym_thread_local] = ACTIONS(2739),
    [anon_sym___thread] = ACTIONS(2739),
    [anon_sym_const] = ACTIONS(2739),
    [anon_sym_constexpr] = ACTIONS(2739),
    [anon_sym_volatile] = ACTIONS(2739),
    [anon_sym_restrict] = ACTIONS(2739),
    [anon_sym___restrict__] = ACTIONS(2739),
    [anon_sym__Atomic] = ACTIONS(2739),
    [anon_sym__Noreturn] = ACTIONS(2739),
    [anon_sym_noreturn] = ACTIONS(2739),
    [anon_sym__Nonnull] = ACTIONS(2739),
    [anon_sym_mutable] = ACTIONS(2739),
    [anon_sym_constinit] = ACTIONS(2739),
    [anon_sym_consteval] = ACTIONS(2739),
    [anon_sym_alignas] = ACTIONS(2739),
    [anon_sym__Alignas] = ACTIONS(2739),
    [sym_primitive_type] = ACTIONS(2739),
    [anon_sym_enum] = ACTIONS(2739),
    [anon_sym_class] = ACTIONS(2739),
    [anon_sym_struct] = ACTIONS(2739),
    [anon_sym_union] = ACTIONS(2739),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2739),
    [anon_sym_decltype] = ACTIONS(2739),
    [anon_sym_explicit] = ACTIONS(2739),
    [anon_sym_typename] = ACTIONS(2739),
    [anon_sym_template] = ACTIONS(2739),
    [anon_sym_operator] = ACTIONS(2739),
    [anon_sym_friend] = ACTIONS(2739),
    [anon_sym_public] = ACTIONS(2739),
    [anon_sym_private] = ACTIONS(2739),
    [anon_sym_protected] = ACTIONS(2739),
    [anon_sym_using] = ACTIONS(2739),
    [anon_sym_static_assert] = ACTIONS(2739),
  },
  [1728] = {
    [sym_identifier] = ACTIONS(5387),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5389),
    [anon_sym_COMMA] = ACTIONS(5389),
    [anon_sym_RPAREN] = ACTIONS(5389),
    [aux_sym_preproc_if_token2] = ACTIONS(5389),
    [aux_sym_preproc_else_token1] = ACTIONS(5389),
    [aux_sym_preproc_elif_token1] = ACTIONS(5387),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5389),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5389),
    [anon_sym_LPAREN2] = ACTIONS(5389),
    [anon_sym_DASH] = ACTIONS(5387),
    [anon_sym_PLUS] = ACTIONS(5387),
    [anon_sym_STAR] = ACTIONS(5387),
    [anon_sym_SLASH] = ACTIONS(5387),
    [anon_sym_PERCENT] = ACTIONS(5387),
    [anon_sym_PIPE_PIPE] = ACTIONS(5389),
    [anon_sym_AMP_AMP] = ACTIONS(5389),
    [anon_sym_PIPE] = ACTIONS(5387),
    [anon_sym_CARET] = ACTIONS(5387),
    [anon_sym_AMP] = ACTIONS(5387),
    [anon_sym_EQ_EQ] = ACTIONS(5389),
    [anon_sym_BANG_EQ] = ACTIONS(5389),
    [anon_sym_GT] = ACTIONS(5387),
    [anon_sym_GT_EQ] = ACTIONS(5389),
    [anon_sym_LT_EQ] = ACTIONS(5387),
    [anon_sym_LT] = ACTIONS(5387),
    [anon_sym_LT_LT] = ACTIONS(5387),
    [anon_sym_GT_GT] = ACTIONS(5387),
    [anon_sym_SEMI] = ACTIONS(5389),
    [anon_sym_RBRACE] = ACTIONS(5389),
    [anon_sym_LBRACK] = ACTIONS(5389),
    [anon_sym_RBRACK] = ACTIONS(5389),
    [anon_sym_EQ] = ACTIONS(5387),
    [anon_sym_COLON] = ACTIONS(5389),
    [anon_sym_QMARK] = ACTIONS(5389),
    [anon_sym_STAR_EQ] = ACTIONS(5389),
    [anon_sym_SLASH_EQ] = ACTIONS(5389),
    [anon_sym_PERCENT_EQ] = ACTIONS(5389),
    [anon_sym_PLUS_EQ] = ACTIONS(5389),
    [anon_sym_DASH_EQ] = ACTIONS(5389),
    [anon_sym_LT_LT_EQ] = ACTIONS(5389),
    [anon_sym_GT_GT_EQ] = ACTIONS(5389),
    [anon_sym_AMP_EQ] = ACTIONS(5389),
    [anon_sym_CARET_EQ] = ACTIONS(5389),
    [anon_sym_PIPE_EQ] = ACTIONS(5389),
    [anon_sym_and_eq] = ACTIONS(5387),
    [anon_sym_or_eq] = ACTIONS(5387),
    [anon_sym_xor_eq] = ACTIONS(5387),
    [anon_sym_LT_EQ_GT] = ACTIONS(5389),
    [anon_sym_or] = ACTIONS(5387),
    [anon_sym_and] = ACTIONS(5387),
    [anon_sym_bitor] = ACTIONS(5387),
    [anon_sym_xor] = ACTIONS(5387),
    [anon_sym_bitand] = ACTIONS(5387),
    [anon_sym_not_eq] = ACTIONS(5387),
    [anon_sym_DASH_DASH] = ACTIONS(5389),
    [anon_sym_PLUS_PLUS] = ACTIONS(5389),
    [anon_sym_DOT] = ACTIONS(5387),
    [anon_sym_DOT_STAR] = ACTIONS(5389),
    [anon_sym_DASH_GT] = ACTIONS(5389),
    [anon_sym_L_DQUOTE] = ACTIONS(5389),
    [anon_sym_u_DQUOTE] = ACTIONS(5389),
    [anon_sym_U_DQUOTE] = ACTIONS(5389),
    [anon_sym_u8_DQUOTE] = ACTIONS(5389),
    [anon_sym_DQUOTE] = ACTIONS(5389),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5389),
    [anon_sym_LR_DQUOTE] = ACTIONS(5389),
    [anon_sym_uR_DQUOTE] = ACTIONS(5389),
    [anon_sym_UR_DQUOTE] = ACTIONS(5389),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5389),
    [sym_literal_suffix] = ACTIONS(5387),
  },
  [1729] = {
    [sym_identifier] = ACTIONS(2747),
    [aux_sym_preproc_def_token1] = ACTIONS(2747),
    [aux_sym_preproc_if_token1] = ACTIONS(2747),
    [aux_sym_preproc_if_token2] = ACTIONS(2747),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2747),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2747),
    [aux_sym_preproc_else_token1] = ACTIONS(2747),
    [aux_sym_preproc_elif_token1] = ACTIONS(2747),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2747),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2747),
    [sym_preproc_directive] = ACTIONS(2747),
    [anon_sym_LPAREN2] = ACTIONS(2749),
    [anon_sym_TILDE] = ACTIONS(2749),
    [anon_sym_STAR] = ACTIONS(2749),
    [anon_sym_AMP_AMP] = ACTIONS(2749),
    [anon_sym_AMP] = ACTIONS(2747),
    [anon_sym_SEMI] = ACTIONS(2749),
    [anon_sym___extension__] = ACTIONS(2747),
    [anon_sym_typedef] = ACTIONS(2747),
    [anon_sym_virtual] = ACTIONS(2747),
    [anon_sym_extern] = ACTIONS(2747),
    [anon_sym___attribute__] = ACTIONS(2747),
    [anon_sym___attribute] = ACTIONS(2747),
    [anon_sym_COLON_COLON] = ACTIONS(2749),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2749),
    [anon_sym___declspec] = ACTIONS(2747),
    [anon_sym___based] = ACTIONS(2747),
    [anon_sym_signed] = ACTIONS(2747),
    [anon_sym_unsigned] = ACTIONS(2747),
    [anon_sym_long] = ACTIONS(2747),
    [anon_sym_short] = ACTIONS(2747),
    [anon_sym_LBRACK] = ACTIONS(2747),
    [anon_sym_static] = ACTIONS(2747),
    [anon_sym_register] = ACTIONS(2747),
    [anon_sym_inline] = ACTIONS(2747),
    [anon_sym___inline] = ACTIONS(2747),
    [anon_sym___inline__] = ACTIONS(2747),
    [anon_sym___forceinline] = ACTIONS(2747),
    [anon_sym_thread_local] = ACTIONS(2747),
    [anon_sym___thread] = ACTIONS(2747),
    [anon_sym_const] = ACTIONS(2747),
    [anon_sym_constexpr] = ACTIONS(2747),
    [anon_sym_volatile] = ACTIONS(2747),
    [anon_sym_restrict] = ACTIONS(2747),
    [anon_sym___restrict__] = ACTIONS(2747),
    [anon_sym__Atomic] = ACTIONS(2747),
    [anon_sym__Noreturn] = ACTIONS(2747),
    [anon_sym_noreturn] = ACTIONS(2747),
    [anon_sym__Nonnull] = ACTIONS(2747),
    [anon_sym_mutable] = ACTIONS(2747),
    [anon_sym_constinit] = ACTIONS(2747),
    [anon_sym_consteval] = ACTIONS(2747),
    [anon_sym_alignas] = ACTIONS(2747),
    [anon_sym__Alignas] = ACTIONS(2747),
    [sym_primitive_type] = ACTIONS(2747),
    [anon_sym_enum] = ACTIONS(2747),
    [anon_sym_class] = ACTIONS(2747),
    [anon_sym_struct] = ACTIONS(2747),
    [anon_sym_union] = ACTIONS(2747),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2747),
    [anon_sym_decltype] = ACTIONS(2747),
    [anon_sym_explicit] = ACTIONS(2747),
    [anon_sym_typename] = ACTIONS(2747),
    [anon_sym_template] = ACTIONS(2747),
    [anon_sym_operator] = ACTIONS(2747),
    [anon_sym_friend] = ACTIONS(2747),
    [anon_sym_public] = ACTIONS(2747),
    [anon_sym_private] = ACTIONS(2747),
    [anon_sym_protected] = ACTIONS(2747),
    [anon_sym_using] = ACTIONS(2747),
    [anon_sym_static_assert] = ACTIONS(2747),
  },
  [1730] = {
    [sym_identifier] = ACTIONS(2747),
    [aux_sym_preproc_def_token1] = ACTIONS(2747),
    [aux_sym_preproc_if_token1] = ACTIONS(2747),
    [aux_sym_preproc_if_token2] = ACTIONS(2747),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2747),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2747),
    [aux_sym_preproc_else_token1] = ACTIONS(2747),
    [aux_sym_preproc_elif_token1] = ACTIONS(2747),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2747),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2747),
    [sym_preproc_directive] = ACTIONS(2747),
    [anon_sym_LPAREN2] = ACTIONS(2749),
    [anon_sym_TILDE] = ACTIONS(2749),
    [anon_sym_STAR] = ACTIONS(2749),
    [anon_sym_AMP_AMP] = ACTIONS(2749),
    [anon_sym_AMP] = ACTIONS(2747),
    [anon_sym_SEMI] = ACTIONS(2749),
    [anon_sym___extension__] = ACTIONS(2747),
    [anon_sym_typedef] = ACTIONS(2747),
    [anon_sym_virtual] = ACTIONS(2747),
    [anon_sym_extern] = ACTIONS(2747),
    [anon_sym___attribute__] = ACTIONS(2747),
    [anon_sym___attribute] = ACTIONS(2747),
    [anon_sym_COLON_COLON] = ACTIONS(2749),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2749),
    [anon_sym___declspec] = ACTIONS(2747),
    [anon_sym___based] = ACTIONS(2747),
    [anon_sym_signed] = ACTIONS(2747),
    [anon_sym_unsigned] = ACTIONS(2747),
    [anon_sym_long] = ACTIONS(2747),
    [anon_sym_short] = ACTIONS(2747),
    [anon_sym_LBRACK] = ACTIONS(2747),
    [anon_sym_static] = ACTIONS(2747),
    [anon_sym_register] = ACTIONS(2747),
    [anon_sym_inline] = ACTIONS(2747),
    [anon_sym___inline] = ACTIONS(2747),
    [anon_sym___inline__] = ACTIONS(2747),
    [anon_sym___forceinline] = ACTIONS(2747),
    [anon_sym_thread_local] = ACTIONS(2747),
    [anon_sym___thread] = ACTIONS(2747),
    [anon_sym_const] = ACTIONS(2747),
    [anon_sym_constexpr] = ACTIONS(2747),
    [anon_sym_volatile] = ACTIONS(2747),
    [anon_sym_restrict] = ACTIONS(2747),
    [anon_sym___restrict__] = ACTIONS(2747),
    [anon_sym__Atomic] = ACTIONS(2747),
    [anon_sym__Noreturn] = ACTIONS(2747),
    [anon_sym_noreturn] = ACTIONS(2747),
    [anon_sym__Nonnull] = ACTIONS(2747),
    [anon_sym_mutable] = ACTIONS(2747),
    [anon_sym_constinit] = ACTIONS(2747),
    [anon_sym_consteval] = ACTIONS(2747),
    [anon_sym_alignas] = ACTIONS(2747),
    [anon_sym__Alignas] = ACTIONS(2747),
    [sym_primitive_type] = ACTIONS(2747),
    [anon_sym_enum] = ACTIONS(2747),
    [anon_sym_class] = ACTIONS(2747),
    [anon_sym_struct] = ACTIONS(2747),
    [anon_sym_union] = ACTIONS(2747),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2747),
    [anon_sym_decltype] = ACTIONS(2747),
    [anon_sym_explicit] = ACTIONS(2747),
    [anon_sym_typename] = ACTIONS(2747),
    [anon_sym_template] = ACTIONS(2747),
    [anon_sym_operator] = ACTIONS(2747),
    [anon_sym_friend] = ACTIONS(2747),
    [anon_sym_public] = ACTIONS(2747),
    [anon_sym_private] = ACTIONS(2747),
    [anon_sym_protected] = ACTIONS(2747),
    [anon_sym_using] = ACTIONS(2747),
    [anon_sym_static_assert] = ACTIONS(2747),
  },
  [1731] = {
    [sym_identifier] = ACTIONS(3170),
    [aux_sym_preproc_def_token1] = ACTIONS(3170),
    [aux_sym_preproc_if_token1] = ACTIONS(3170),
    [aux_sym_preproc_if_token2] = ACTIONS(3170),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3170),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3170),
    [aux_sym_preproc_else_token1] = ACTIONS(3170),
    [aux_sym_preproc_elif_token1] = ACTIONS(3170),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(3170),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(3170),
    [sym_preproc_directive] = ACTIONS(3170),
    [anon_sym_LPAREN2] = ACTIONS(3172),
    [anon_sym_TILDE] = ACTIONS(3172),
    [anon_sym_STAR] = ACTIONS(3172),
    [anon_sym_AMP_AMP] = ACTIONS(3172),
    [anon_sym_AMP] = ACTIONS(3170),
    [anon_sym_SEMI] = ACTIONS(3172),
    [anon_sym___extension__] = ACTIONS(3170),
    [anon_sym_typedef] = ACTIONS(3170),
    [anon_sym_virtual] = ACTIONS(3170),
    [anon_sym_extern] = ACTIONS(3170),
    [anon_sym___attribute__] = ACTIONS(3170),
    [anon_sym___attribute] = ACTIONS(3170),
    [anon_sym_COLON_COLON] = ACTIONS(3172),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3172),
    [anon_sym___declspec] = ACTIONS(3170),
    [anon_sym___based] = ACTIONS(3170),
    [anon_sym_signed] = ACTIONS(3170),
    [anon_sym_unsigned] = ACTIONS(3170),
    [anon_sym_long] = ACTIONS(3170),
    [anon_sym_short] = ACTIONS(3170),
    [anon_sym_LBRACK] = ACTIONS(3170),
    [anon_sym_static] = ACTIONS(3170),
    [anon_sym_register] = ACTIONS(3170),
    [anon_sym_inline] = ACTIONS(3170),
    [anon_sym___inline] = ACTIONS(3170),
    [anon_sym___inline__] = ACTIONS(3170),
    [anon_sym___forceinline] = ACTIONS(3170),
    [anon_sym_thread_local] = ACTIONS(3170),
    [anon_sym___thread] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3170),
    [anon_sym_constexpr] = ACTIONS(3170),
    [anon_sym_volatile] = ACTIONS(3170),
    [anon_sym_restrict] = ACTIONS(3170),
    [anon_sym___restrict__] = ACTIONS(3170),
    [anon_sym__Atomic] = ACTIONS(3170),
    [anon_sym__Noreturn] = ACTIONS(3170),
    [anon_sym_noreturn] = ACTIONS(3170),
    [anon_sym__Nonnull] = ACTIONS(3170),
    [anon_sym_mutable] = ACTIONS(3170),
    [anon_sym_constinit] = ACTIONS(3170),
    [anon_sym_consteval] = ACTIONS(3170),
    [anon_sym_alignas] = ACTIONS(3170),
    [anon_sym__Alignas] = ACTIONS(3170),
    [sym_primitive_type] = ACTIONS(3170),
    [anon_sym_enum] = ACTIONS(3170),
    [anon_sym_class] = ACTIONS(3170),
    [anon_sym_struct] = ACTIONS(3170),
    [anon_sym_union] = ACTIONS(3170),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3170),
    [anon_sym_decltype] = ACTIONS(3170),
    [anon_sym_explicit] = ACTIONS(3170),
    [anon_sym_typename] = ACTIONS(3170),
    [anon_sym_template] = ACTIONS(3170),
    [anon_sym_operator] = ACTIONS(3170),
    [anon_sym_friend] = ACTIONS(3170),
    [anon_sym_public] = ACTIONS(3170),
    [anon_sym_private] = ACTIONS(3170),
    [anon_sym_protected] = ACTIONS(3170),
    [anon_sym_using] = ACTIONS(3170),
    [anon_sym_static_assert] = ACTIONS(3170),
  },
  [1732] = {
    [sym__declaration_modifiers] = STATE(3299),
    [sym_attribute_specifier] = STATE(3299),
    [sym_attribute_declaration] = STATE(3299),
    [sym_ms_declspec_modifier] = STATE(3299),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6122),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3299),
    [sym_type_qualifier] = STATE(3299),
    [sym_alignas_qualifier] = STATE(3049),
    [sym_decltype] = STATE(8512),
    [sym_explicit_function_specifier] = STATE(3299),
    [sym_operator_cast] = STATE(6689),
    [sym__constructor_specifiers] = STATE(3299),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(8512),
    [sym_template_function] = STATE(5896),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5444),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_operator_cast_identifier] = STATE(6689),
    [sym_operator_name] = STATE(5896),
    [aux_sym_operator_cast_definition_repeat1] = STATE(3299),
    [sym_identifier] = ACTIONS(5327),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym___extension__] = ACTIONS(5329),
    [anon_sym_virtual] = ACTIONS(5331),
    [anon_sym_extern] = ACTIONS(5333),
    [anon_sym___attribute__] = ACTIONS(5335),
    [anon_sym___attribute] = ACTIONS(5335),
    [anon_sym_COLON_COLON] = ACTIONS(5337),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5339),
    [anon_sym___declspec] = ACTIONS(5341),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(5333),
    [anon_sym_register] = ACTIONS(5333),
    [anon_sym_inline] = ACTIONS(5333),
    [anon_sym___inline] = ACTIONS(5333),
    [anon_sym___inline__] = ACTIONS(5333),
    [anon_sym___forceinline] = ACTIONS(5333),
    [anon_sym_thread_local] = ACTIONS(5333),
    [anon_sym___thread] = ACTIONS(5333),
    [anon_sym_const] = ACTIONS(5329),
    [anon_sym_constexpr] = ACTIONS(5329),
    [anon_sym_volatile] = ACTIONS(5329),
    [anon_sym_restrict] = ACTIONS(5329),
    [anon_sym___restrict__] = ACTIONS(5329),
    [anon_sym__Atomic] = ACTIONS(5329),
    [anon_sym__Noreturn] = ACTIONS(5329),
    [anon_sym_noreturn] = ACTIONS(5329),
    [anon_sym__Nonnull] = ACTIONS(5329),
    [anon_sym_mutable] = ACTIONS(5329),
    [anon_sym_constinit] = ACTIONS(5329),
    [anon_sym_consteval] = ACTIONS(5329),
    [anon_sym_alignas] = ACTIONS(5343),
    [anon_sym__Alignas] = ACTIONS(5343),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_operator] = ACTIONS(133),
  },
  [1733] = {
    [sym_decltype_auto] = STATE(1837),
    [sym_identifier] = ACTIONS(5391),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5393),
    [anon_sym_COMMA] = ACTIONS(5393),
    [anon_sym_RPAREN] = ACTIONS(5393),
    [anon_sym_LPAREN2] = ACTIONS(5393),
    [anon_sym_DASH] = ACTIONS(5391),
    [anon_sym_PLUS] = ACTIONS(5391),
    [anon_sym_STAR] = ACTIONS(5393),
    [anon_sym_SLASH] = ACTIONS(5391),
    [anon_sym_PERCENT] = ACTIONS(5393),
    [anon_sym_PIPE_PIPE] = ACTIONS(5393),
    [anon_sym_AMP_AMP] = ACTIONS(5393),
    [anon_sym_PIPE] = ACTIONS(5391),
    [anon_sym_CARET] = ACTIONS(5393),
    [anon_sym_AMP] = ACTIONS(5391),
    [anon_sym_EQ_EQ] = ACTIONS(5393),
    [anon_sym_BANG_EQ] = ACTIONS(5393),
    [anon_sym_GT] = ACTIONS(5391),
    [anon_sym_GT_EQ] = ACTIONS(5393),
    [anon_sym_LT_EQ] = ACTIONS(5391),
    [anon_sym_LT] = ACTIONS(5391),
    [anon_sym_LT_LT] = ACTIONS(5393),
    [anon_sym_GT_GT] = ACTIONS(5393),
    [anon_sym_SEMI] = ACTIONS(5393),
    [anon_sym___extension__] = ACTIONS(5391),
    [anon_sym___attribute__] = ACTIONS(5391),
    [anon_sym___attribute] = ACTIONS(5391),
    [anon_sym___based] = ACTIONS(5391),
    [anon_sym_LBRACE] = ACTIONS(5393),
    [anon_sym_RBRACE] = ACTIONS(5393),
    [anon_sym_signed] = ACTIONS(5391),
    [anon_sym_unsigned] = ACTIONS(5391),
    [anon_sym_long] = ACTIONS(5391),
    [anon_sym_short] = ACTIONS(5391),
    [anon_sym_LBRACK] = ACTIONS(5393),
    [anon_sym_RBRACK] = ACTIONS(5393),
    [anon_sym_const] = ACTIONS(5391),
    [anon_sym_constexpr] = ACTIONS(5391),
    [anon_sym_volatile] = ACTIONS(5391),
    [anon_sym_restrict] = ACTIONS(5391),
    [anon_sym___restrict__] = ACTIONS(5391),
    [anon_sym__Atomic] = ACTIONS(5391),
    [anon_sym__Noreturn] = ACTIONS(5391),
    [anon_sym_noreturn] = ACTIONS(5391),
    [anon_sym__Nonnull] = ACTIONS(5391),
    [anon_sym_mutable] = ACTIONS(5391),
    [anon_sym_constinit] = ACTIONS(5391),
    [anon_sym_consteval] = ACTIONS(5391),
    [anon_sym_alignas] = ACTIONS(5391),
    [anon_sym__Alignas] = ACTIONS(5391),
    [sym_primitive_type] = ACTIONS(5391),
    [anon_sym_COLON] = ACTIONS(5393),
    [anon_sym_QMARK] = ACTIONS(5393),
    [anon_sym_LT_EQ_GT] = ACTIONS(5393),
    [anon_sym_or] = ACTIONS(5391),
    [anon_sym_and] = ACTIONS(5391),
    [anon_sym_bitor] = ACTIONS(5391),
    [anon_sym_xor] = ACTIONS(5391),
    [anon_sym_bitand] = ACTIONS(5391),
    [anon_sym_not_eq] = ACTIONS(5391),
    [anon_sym_DASH_DASH] = ACTIONS(5393),
    [anon_sym_PLUS_PLUS] = ACTIONS(5393),
    [anon_sym_DOT] = ACTIONS(5391),
    [anon_sym_DOT_STAR] = ACTIONS(5393),
    [anon_sym_DASH_GT] = ACTIONS(5393),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5395),
    [anon_sym_decltype] = ACTIONS(5397),
    [anon_sym_final] = ACTIONS(5391),
    [anon_sym_override] = ACTIONS(5391),
    [anon_sym_requires] = ACTIONS(5391),
  },
  [1734] = {
    [sym_identifier] = ACTIONS(2767),
    [aux_sym_preproc_def_token1] = ACTIONS(2767),
    [aux_sym_preproc_if_token1] = ACTIONS(2767),
    [aux_sym_preproc_if_token2] = ACTIONS(2767),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2767),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2767),
    [aux_sym_preproc_else_token1] = ACTIONS(2767),
    [aux_sym_preproc_elif_token1] = ACTIONS(2767),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2767),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2767),
    [sym_preproc_directive] = ACTIONS(2767),
    [anon_sym_LPAREN2] = ACTIONS(2769),
    [anon_sym_TILDE] = ACTIONS(2769),
    [anon_sym_STAR] = ACTIONS(2769),
    [anon_sym_AMP_AMP] = ACTIONS(2769),
    [anon_sym_AMP] = ACTIONS(2767),
    [anon_sym_SEMI] = ACTIONS(2769),
    [anon_sym___extension__] = ACTIONS(2767),
    [anon_sym_typedef] = ACTIONS(2767),
    [anon_sym_virtual] = ACTIONS(2767),
    [anon_sym_extern] = ACTIONS(2767),
    [anon_sym___attribute__] = ACTIONS(2767),
    [anon_sym___attribute] = ACTIONS(2767),
    [anon_sym_COLON_COLON] = ACTIONS(2769),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2769),
    [anon_sym___declspec] = ACTIONS(2767),
    [anon_sym___based] = ACTIONS(2767),
    [anon_sym_signed] = ACTIONS(2767),
    [anon_sym_unsigned] = ACTIONS(2767),
    [anon_sym_long] = ACTIONS(2767),
    [anon_sym_short] = ACTIONS(2767),
    [anon_sym_LBRACK] = ACTIONS(2767),
    [anon_sym_static] = ACTIONS(2767),
    [anon_sym_register] = ACTIONS(2767),
    [anon_sym_inline] = ACTIONS(2767),
    [anon_sym___inline] = ACTIONS(2767),
    [anon_sym___inline__] = ACTIONS(2767),
    [anon_sym___forceinline] = ACTIONS(2767),
    [anon_sym_thread_local] = ACTIONS(2767),
    [anon_sym___thread] = ACTIONS(2767),
    [anon_sym_const] = ACTIONS(2767),
    [anon_sym_constexpr] = ACTIONS(2767),
    [anon_sym_volatile] = ACTIONS(2767),
    [anon_sym_restrict] = ACTIONS(2767),
    [anon_sym___restrict__] = ACTIONS(2767),
    [anon_sym__Atomic] = ACTIONS(2767),
    [anon_sym__Noreturn] = ACTIONS(2767),
    [anon_sym_noreturn] = ACTIONS(2767),
    [anon_sym__Nonnull] = ACTIONS(2767),
    [anon_sym_mutable] = ACTIONS(2767),
    [anon_sym_constinit] = ACTIONS(2767),
    [anon_sym_consteval] = ACTIONS(2767),
    [anon_sym_alignas] = ACTIONS(2767),
    [anon_sym__Alignas] = ACTIONS(2767),
    [sym_primitive_type] = ACTIONS(2767),
    [anon_sym_enum] = ACTIONS(2767),
    [anon_sym_class] = ACTIONS(2767),
    [anon_sym_struct] = ACTIONS(2767),
    [anon_sym_union] = ACTIONS(2767),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2767),
    [anon_sym_decltype] = ACTIONS(2767),
    [anon_sym_explicit] = ACTIONS(2767),
    [anon_sym_typename] = ACTIONS(2767),
    [anon_sym_template] = ACTIONS(2767),
    [anon_sym_operator] = ACTIONS(2767),
    [anon_sym_friend] = ACTIONS(2767),
    [anon_sym_public] = ACTIONS(2767),
    [anon_sym_private] = ACTIONS(2767),
    [anon_sym_protected] = ACTIONS(2767),
    [anon_sym_using] = ACTIONS(2767),
    [anon_sym_static_assert] = ACTIONS(2767),
  },
  [1735] = {
    [sym_identifier] = ACTIONS(5399),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5401),
    [anon_sym_COMMA] = ACTIONS(5401),
    [anon_sym_RPAREN] = ACTIONS(5401),
    [aux_sym_preproc_if_token2] = ACTIONS(5401),
    [aux_sym_preproc_else_token1] = ACTIONS(5401),
    [aux_sym_preproc_elif_token1] = ACTIONS(5399),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5401),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5401),
    [anon_sym_LPAREN2] = ACTIONS(5401),
    [anon_sym_DASH] = ACTIONS(5399),
    [anon_sym_PLUS] = ACTIONS(5399),
    [anon_sym_STAR] = ACTIONS(5399),
    [anon_sym_SLASH] = ACTIONS(5399),
    [anon_sym_PERCENT] = ACTIONS(5399),
    [anon_sym_PIPE_PIPE] = ACTIONS(5401),
    [anon_sym_AMP_AMP] = ACTIONS(5401),
    [anon_sym_PIPE] = ACTIONS(5399),
    [anon_sym_CARET] = ACTIONS(5399),
    [anon_sym_AMP] = ACTIONS(5399),
    [anon_sym_EQ_EQ] = ACTIONS(5401),
    [anon_sym_BANG_EQ] = ACTIONS(5401),
    [anon_sym_GT] = ACTIONS(5399),
    [anon_sym_GT_EQ] = ACTIONS(5401),
    [anon_sym_LT_EQ] = ACTIONS(5399),
    [anon_sym_LT] = ACTIONS(5399),
    [anon_sym_LT_LT] = ACTIONS(5399),
    [anon_sym_GT_GT] = ACTIONS(5399),
    [anon_sym_SEMI] = ACTIONS(5401),
    [anon_sym_RBRACE] = ACTIONS(5401),
    [anon_sym_LBRACK] = ACTIONS(5401),
    [anon_sym_RBRACK] = ACTIONS(5401),
    [anon_sym_EQ] = ACTIONS(5399),
    [anon_sym_COLON] = ACTIONS(5401),
    [anon_sym_QMARK] = ACTIONS(5401),
    [anon_sym_STAR_EQ] = ACTIONS(5401),
    [anon_sym_SLASH_EQ] = ACTIONS(5401),
    [anon_sym_PERCENT_EQ] = ACTIONS(5401),
    [anon_sym_PLUS_EQ] = ACTIONS(5401),
    [anon_sym_DASH_EQ] = ACTIONS(5401),
    [anon_sym_LT_LT_EQ] = ACTIONS(5401),
    [anon_sym_GT_GT_EQ] = ACTIONS(5401),
    [anon_sym_AMP_EQ] = ACTIONS(5401),
    [anon_sym_CARET_EQ] = ACTIONS(5401),
    [anon_sym_PIPE_EQ] = ACTIONS(5401),
    [anon_sym_and_eq] = ACTIONS(5399),
    [anon_sym_or_eq] = ACTIONS(5399),
    [anon_sym_xor_eq] = ACTIONS(5399),
    [anon_sym_LT_EQ_GT] = ACTIONS(5401),
    [anon_sym_or] = ACTIONS(5399),
    [anon_sym_and] = ACTIONS(5399),
    [anon_sym_bitor] = ACTIONS(5399),
    [anon_sym_xor] = ACTIONS(5399),
    [anon_sym_bitand] = ACTIONS(5399),
    [anon_sym_not_eq] = ACTIONS(5399),
    [anon_sym_DASH_DASH] = ACTIONS(5401),
    [anon_sym_PLUS_PLUS] = ACTIONS(5401),
    [anon_sym_DOT] = ACTIONS(5399),
    [anon_sym_DOT_STAR] = ACTIONS(5401),
    [anon_sym_DASH_GT] = ACTIONS(5401),
    [anon_sym_L_DQUOTE] = ACTIONS(5401),
    [anon_sym_u_DQUOTE] = ACTIONS(5401),
    [anon_sym_U_DQUOTE] = ACTIONS(5401),
    [anon_sym_u8_DQUOTE] = ACTIONS(5401),
    [anon_sym_DQUOTE] = ACTIONS(5401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5401),
    [anon_sym_LR_DQUOTE] = ACTIONS(5401),
    [anon_sym_uR_DQUOTE] = ACTIONS(5401),
    [anon_sym_UR_DQUOTE] = ACTIONS(5401),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5401),
    [sym_literal_suffix] = ACTIONS(5399),
  },
  [1736] = {
    [sym_identifier] = ACTIONS(4830),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4832),
    [anon_sym_COMMA] = ACTIONS(4832),
    [anon_sym_RPAREN] = ACTIONS(4832),
    [anon_sym_LPAREN2] = ACTIONS(4832),
    [anon_sym_DASH] = ACTIONS(4830),
    [anon_sym_PLUS] = ACTIONS(4830),
    [anon_sym_STAR] = ACTIONS(4832),
    [anon_sym_SLASH] = ACTIONS(4830),
    [anon_sym_PERCENT] = ACTIONS(4832),
    [anon_sym_PIPE_PIPE] = ACTIONS(4832),
    [anon_sym_AMP_AMP] = ACTIONS(4832),
    [anon_sym_PIPE] = ACTIONS(4830),
    [anon_sym_CARET] = ACTIONS(4832),
    [anon_sym_AMP] = ACTIONS(4830),
    [anon_sym_EQ_EQ] = ACTIONS(4832),
    [anon_sym_BANG_EQ] = ACTIONS(4832),
    [anon_sym_GT] = ACTIONS(4830),
    [anon_sym_GT_EQ] = ACTIONS(4832),
    [anon_sym_LT_EQ] = ACTIONS(4830),
    [anon_sym_LT] = ACTIONS(4830),
    [anon_sym_LT_LT] = ACTIONS(4832),
    [anon_sym_GT_GT] = ACTIONS(4832),
    [anon_sym_SEMI] = ACTIONS(4832),
    [anon_sym___extension__] = ACTIONS(4830),
    [anon_sym___attribute__] = ACTIONS(4830),
    [anon_sym___attribute] = ACTIONS(4830),
    [anon_sym_COLON_COLON] = ACTIONS(4832),
    [anon_sym___based] = ACTIONS(4830),
    [anon_sym_LBRACE] = ACTIONS(4832),
    [anon_sym_RBRACE] = ACTIONS(4832),
    [anon_sym_signed] = ACTIONS(4830),
    [anon_sym_unsigned] = ACTIONS(4830),
    [anon_sym_long] = ACTIONS(4830),
    [anon_sym_short] = ACTIONS(4830),
    [anon_sym_LBRACK] = ACTIONS(4832),
    [anon_sym_RBRACK] = ACTIONS(4832),
    [anon_sym_const] = ACTIONS(4830),
    [anon_sym_constexpr] = ACTIONS(4830),
    [anon_sym_volatile] = ACTIONS(4830),
    [anon_sym_restrict] = ACTIONS(4830),
    [anon_sym___restrict__] = ACTIONS(4830),
    [anon_sym__Atomic] = ACTIONS(4830),
    [anon_sym__Noreturn] = ACTIONS(4830),
    [anon_sym_noreturn] = ACTIONS(4830),
    [anon_sym__Nonnull] = ACTIONS(4830),
    [anon_sym_mutable] = ACTIONS(4830),
    [anon_sym_constinit] = ACTIONS(4830),
    [anon_sym_consteval] = ACTIONS(4830),
    [anon_sym_alignas] = ACTIONS(4830),
    [anon_sym__Alignas] = ACTIONS(4830),
    [sym_primitive_type] = ACTIONS(4830),
    [anon_sym_COLON] = ACTIONS(4830),
    [anon_sym_QMARK] = ACTIONS(4832),
    [anon_sym_LT_EQ_GT] = ACTIONS(4832),
    [anon_sym_or] = ACTIONS(4830),
    [anon_sym_and] = ACTIONS(4830),
    [anon_sym_bitor] = ACTIONS(4830),
    [anon_sym_xor] = ACTIONS(4830),
    [anon_sym_bitand] = ACTIONS(4830),
    [anon_sym_not_eq] = ACTIONS(4830),
    [anon_sym_DASH_DASH] = ACTIONS(4832),
    [anon_sym_PLUS_PLUS] = ACTIONS(4832),
    [anon_sym_DOT] = ACTIONS(4830),
    [anon_sym_DOT_STAR] = ACTIONS(4832),
    [anon_sym_DASH_GT] = ACTIONS(4832),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4830),
    [anon_sym_decltype] = ACTIONS(4830),
    [anon_sym_final] = ACTIONS(4830),
    [anon_sym_override] = ACTIONS(4830),
    [anon_sym_requires] = ACTIONS(4830),
  },
  [1737] = {
    [sym_identifier] = ACTIONS(5403),
    [aux_sym_preproc_def_token1] = ACTIONS(5403),
    [aux_sym_preproc_if_token1] = ACTIONS(5403),
    [aux_sym_preproc_if_token2] = ACTIONS(5403),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5403),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5403),
    [aux_sym_preproc_else_token1] = ACTIONS(5403),
    [aux_sym_preproc_elif_token1] = ACTIONS(5403),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5403),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5403),
    [sym_preproc_directive] = ACTIONS(5403),
    [anon_sym_LPAREN2] = ACTIONS(5405),
    [anon_sym_TILDE] = ACTIONS(5405),
    [anon_sym_STAR] = ACTIONS(5405),
    [anon_sym_AMP_AMP] = ACTIONS(5405),
    [anon_sym_AMP] = ACTIONS(5403),
    [anon_sym_SEMI] = ACTIONS(5405),
    [anon_sym___extension__] = ACTIONS(5403),
    [anon_sym_typedef] = ACTIONS(5403),
    [anon_sym_virtual] = ACTIONS(5403),
    [anon_sym_extern] = ACTIONS(5403),
    [anon_sym___attribute__] = ACTIONS(5403),
    [anon_sym___attribute] = ACTIONS(5403),
    [anon_sym_COLON_COLON] = ACTIONS(5405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5405),
    [anon_sym___declspec] = ACTIONS(5403),
    [anon_sym___based] = ACTIONS(5403),
    [anon_sym_signed] = ACTIONS(5403),
    [anon_sym_unsigned] = ACTIONS(5403),
    [anon_sym_long] = ACTIONS(5403),
    [anon_sym_short] = ACTIONS(5403),
    [anon_sym_LBRACK] = ACTIONS(5403),
    [anon_sym_static] = ACTIONS(5403),
    [anon_sym_register] = ACTIONS(5403),
    [anon_sym_inline] = ACTIONS(5403),
    [anon_sym___inline] = ACTIONS(5403),
    [anon_sym___inline__] = ACTIONS(5403),
    [anon_sym___forceinline] = ACTIONS(5403),
    [anon_sym_thread_local] = ACTIONS(5403),
    [anon_sym___thread] = ACTIONS(5403),
    [anon_sym_const] = ACTIONS(5403),
    [anon_sym_constexpr] = ACTIONS(5403),
    [anon_sym_volatile] = ACTIONS(5403),
    [anon_sym_restrict] = ACTIONS(5403),
    [anon_sym___restrict__] = ACTIONS(5403),
    [anon_sym__Atomic] = ACTIONS(5403),
    [anon_sym__Noreturn] = ACTIONS(5403),
    [anon_sym_noreturn] = ACTIONS(5403),
    [anon_sym__Nonnull] = ACTIONS(5403),
    [anon_sym_mutable] = ACTIONS(5403),
    [anon_sym_constinit] = ACTIONS(5403),
    [anon_sym_consteval] = ACTIONS(5403),
    [anon_sym_alignas] = ACTIONS(5403),
    [anon_sym__Alignas] = ACTIONS(5403),
    [sym_primitive_type] = ACTIONS(5403),
    [anon_sym_enum] = ACTIONS(5403),
    [anon_sym_class] = ACTIONS(5403),
    [anon_sym_struct] = ACTIONS(5403),
    [anon_sym_union] = ACTIONS(5403),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5403),
    [anon_sym_decltype] = ACTIONS(5403),
    [anon_sym_explicit] = ACTIONS(5403),
    [anon_sym_typename] = ACTIONS(5403),
    [anon_sym_template] = ACTIONS(5403),
    [anon_sym_operator] = ACTIONS(5403),
    [anon_sym_friend] = ACTIONS(5403),
    [anon_sym_public] = ACTIONS(5403),
    [anon_sym_private] = ACTIONS(5403),
    [anon_sym_protected] = ACTIONS(5403),
    [anon_sym_using] = ACTIONS(5403),
    [anon_sym_static_assert] = ACTIONS(5403),
  },
  [1738] = {
    [sym__declaration_modifiers] = STATE(3299),
    [sym_attribute_specifier] = STATE(3299),
    [sym_attribute_declaration] = STATE(3299),
    [sym_ms_declspec_modifier] = STATE(3299),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6255),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3299),
    [sym_type_qualifier] = STATE(3299),
    [sym_alignas_qualifier] = STATE(3049),
    [sym_decltype] = STATE(8512),
    [sym_explicit_function_specifier] = STATE(3299),
    [sym_operator_cast] = STATE(6700),
    [sym__constructor_specifiers] = STATE(3299),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(8512),
    [sym_template_function] = STATE(5896),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5444),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_operator_cast_identifier] = STATE(6700),
    [sym_operator_name] = STATE(5896),
    [aux_sym_operator_cast_definition_repeat1] = STATE(3299),
    [sym_identifier] = ACTIONS(5327),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym___extension__] = ACTIONS(5329),
    [anon_sym_virtual] = ACTIONS(5331),
    [anon_sym_extern] = ACTIONS(5333),
    [anon_sym___attribute__] = ACTIONS(5335),
    [anon_sym___attribute] = ACTIONS(5335),
    [anon_sym_COLON_COLON] = ACTIONS(5337),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5339),
    [anon_sym___declspec] = ACTIONS(5341),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(5333),
    [anon_sym_register] = ACTIONS(5333),
    [anon_sym_inline] = ACTIONS(5333),
    [anon_sym___inline] = ACTIONS(5333),
    [anon_sym___inline__] = ACTIONS(5333),
    [anon_sym___forceinline] = ACTIONS(5333),
    [anon_sym_thread_local] = ACTIONS(5333),
    [anon_sym___thread] = ACTIONS(5333),
    [anon_sym_const] = ACTIONS(5329),
    [anon_sym_constexpr] = ACTIONS(5329),
    [anon_sym_volatile] = ACTIONS(5329),
    [anon_sym_restrict] = ACTIONS(5329),
    [anon_sym___restrict__] = ACTIONS(5329),
    [anon_sym__Atomic] = ACTIONS(5329),
    [anon_sym__Noreturn] = ACTIONS(5329),
    [anon_sym_noreturn] = ACTIONS(5329),
    [anon_sym__Nonnull] = ACTIONS(5329),
    [anon_sym_mutable] = ACTIONS(5329),
    [anon_sym_constinit] = ACTIONS(5329),
    [anon_sym_consteval] = ACTIONS(5329),
    [anon_sym_alignas] = ACTIONS(5343),
    [anon_sym__Alignas] = ACTIONS(5343),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_operator] = ACTIONS(133),
  },
  [1739] = {
    [sym__declaration_modifiers] = STATE(3299),
    [sym_attribute_specifier] = STATE(3299),
    [sym_attribute_declaration] = STATE(3299),
    [sym_ms_declspec_modifier] = STATE(3299),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6141),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3299),
    [sym_type_qualifier] = STATE(3299),
    [sym_alignas_qualifier] = STATE(3049),
    [sym_decltype] = STATE(8512),
    [sym_explicit_function_specifier] = STATE(3299),
    [sym_operator_cast] = STATE(6700),
    [sym__constructor_specifiers] = STATE(3299),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(8512),
    [sym_template_function] = STATE(5896),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5444),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_operator_cast_identifier] = STATE(6700),
    [sym_operator_name] = STATE(5896),
    [aux_sym_operator_cast_definition_repeat1] = STATE(3299),
    [sym_identifier] = ACTIONS(5327),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym___extension__] = ACTIONS(5329),
    [anon_sym_virtual] = ACTIONS(5331),
    [anon_sym_extern] = ACTIONS(5333),
    [anon_sym___attribute__] = ACTIONS(5335),
    [anon_sym___attribute] = ACTIONS(5335),
    [anon_sym_COLON_COLON] = ACTIONS(5337),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5339),
    [anon_sym___declspec] = ACTIONS(5341),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(5333),
    [anon_sym_register] = ACTIONS(5333),
    [anon_sym_inline] = ACTIONS(5333),
    [anon_sym___inline] = ACTIONS(5333),
    [anon_sym___inline__] = ACTIONS(5333),
    [anon_sym___forceinline] = ACTIONS(5333),
    [anon_sym_thread_local] = ACTIONS(5333),
    [anon_sym___thread] = ACTIONS(5333),
    [anon_sym_const] = ACTIONS(5329),
    [anon_sym_constexpr] = ACTIONS(5329),
    [anon_sym_volatile] = ACTIONS(5329),
    [anon_sym_restrict] = ACTIONS(5329),
    [anon_sym___restrict__] = ACTIONS(5329),
    [anon_sym__Atomic] = ACTIONS(5329),
    [anon_sym__Noreturn] = ACTIONS(5329),
    [anon_sym_noreturn] = ACTIONS(5329),
    [anon_sym__Nonnull] = ACTIONS(5329),
    [anon_sym_mutable] = ACTIONS(5329),
    [anon_sym_constinit] = ACTIONS(5329),
    [anon_sym_consteval] = ACTIONS(5329),
    [anon_sym_alignas] = ACTIONS(5343),
    [anon_sym__Alignas] = ACTIONS(5343),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_operator] = ACTIONS(133),
  },
  [1740] = {
    [sym_identifier] = ACTIONS(4834),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4836),
    [anon_sym_COMMA] = ACTIONS(4836),
    [anon_sym_RPAREN] = ACTIONS(4836),
    [anon_sym_LPAREN2] = ACTIONS(4836),
    [anon_sym_DASH] = ACTIONS(4834),
    [anon_sym_PLUS] = ACTIONS(4834),
    [anon_sym_STAR] = ACTIONS(4836),
    [anon_sym_SLASH] = ACTIONS(4834),
    [anon_sym_PERCENT] = ACTIONS(4836),
    [anon_sym_PIPE_PIPE] = ACTIONS(4836),
    [anon_sym_AMP_AMP] = ACTIONS(4836),
    [anon_sym_PIPE] = ACTIONS(4834),
    [anon_sym_CARET] = ACTIONS(4836),
    [anon_sym_AMP] = ACTIONS(4834),
    [anon_sym_EQ_EQ] = ACTIONS(4836),
    [anon_sym_BANG_EQ] = ACTIONS(4836),
    [anon_sym_GT] = ACTIONS(4834),
    [anon_sym_GT_EQ] = ACTIONS(4836),
    [anon_sym_LT_EQ] = ACTIONS(4834),
    [anon_sym_LT] = ACTIONS(4834),
    [anon_sym_LT_LT] = ACTIONS(4836),
    [anon_sym_GT_GT] = ACTIONS(4836),
    [anon_sym_SEMI] = ACTIONS(4836),
    [anon_sym___extension__] = ACTIONS(4834),
    [anon_sym___attribute__] = ACTIONS(4834),
    [anon_sym___attribute] = ACTIONS(4834),
    [anon_sym_COLON_COLON] = ACTIONS(4836),
    [anon_sym___based] = ACTIONS(4834),
    [anon_sym_LBRACE] = ACTIONS(4836),
    [anon_sym_RBRACE] = ACTIONS(4836),
    [anon_sym_signed] = ACTIONS(4834),
    [anon_sym_unsigned] = ACTIONS(4834),
    [anon_sym_long] = ACTIONS(4834),
    [anon_sym_short] = ACTIONS(4834),
    [anon_sym_LBRACK] = ACTIONS(4836),
    [anon_sym_RBRACK] = ACTIONS(4836),
    [anon_sym_const] = ACTIONS(4834),
    [anon_sym_constexpr] = ACTIONS(4834),
    [anon_sym_volatile] = ACTIONS(4834),
    [anon_sym_restrict] = ACTIONS(4834),
    [anon_sym___restrict__] = ACTIONS(4834),
    [anon_sym__Atomic] = ACTIONS(4834),
    [anon_sym__Noreturn] = ACTIONS(4834),
    [anon_sym_noreturn] = ACTIONS(4834),
    [anon_sym__Nonnull] = ACTIONS(4834),
    [anon_sym_mutable] = ACTIONS(4834),
    [anon_sym_constinit] = ACTIONS(4834),
    [anon_sym_consteval] = ACTIONS(4834),
    [anon_sym_alignas] = ACTIONS(4834),
    [anon_sym__Alignas] = ACTIONS(4834),
    [sym_primitive_type] = ACTIONS(4834),
    [anon_sym_COLON] = ACTIONS(4834),
    [anon_sym_QMARK] = ACTIONS(4836),
    [anon_sym_LT_EQ_GT] = ACTIONS(4836),
    [anon_sym_or] = ACTIONS(4834),
    [anon_sym_and] = ACTIONS(4834),
    [anon_sym_bitor] = ACTIONS(4834),
    [anon_sym_xor] = ACTIONS(4834),
    [anon_sym_bitand] = ACTIONS(4834),
    [anon_sym_not_eq] = ACTIONS(4834),
    [anon_sym_DASH_DASH] = ACTIONS(4836),
    [anon_sym_PLUS_PLUS] = ACTIONS(4836),
    [anon_sym_DOT] = ACTIONS(4834),
    [anon_sym_DOT_STAR] = ACTIONS(4836),
    [anon_sym_DASH_GT] = ACTIONS(4836),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4834),
    [anon_sym_decltype] = ACTIONS(4834),
    [anon_sym_final] = ACTIONS(4834),
    [anon_sym_override] = ACTIONS(4834),
    [anon_sym_requires] = ACTIONS(4834),
  },
  [1741] = {
    [sym__declaration_modifiers] = STATE(3299),
    [sym_attribute_specifier] = STATE(3299),
    [sym_attribute_declaration] = STATE(3299),
    [sym_ms_declspec_modifier] = STATE(3299),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6236),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3299),
    [sym_type_qualifier] = STATE(3299),
    [sym_alignas_qualifier] = STATE(3049),
    [sym_decltype] = STATE(8512),
    [sym_explicit_function_specifier] = STATE(3299),
    [sym_operator_cast] = STATE(6690),
    [sym__constructor_specifiers] = STATE(3299),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(8512),
    [sym_template_function] = STATE(5896),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5444),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_operator_cast_identifier] = STATE(6690),
    [sym_operator_name] = STATE(5896),
    [aux_sym_operator_cast_definition_repeat1] = STATE(3299),
    [sym_identifier] = ACTIONS(5327),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym___extension__] = ACTIONS(5329),
    [anon_sym_virtual] = ACTIONS(5331),
    [anon_sym_extern] = ACTIONS(5333),
    [anon_sym___attribute__] = ACTIONS(5335),
    [anon_sym___attribute] = ACTIONS(5335),
    [anon_sym_COLON_COLON] = ACTIONS(5337),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5339),
    [anon_sym___declspec] = ACTIONS(5341),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(5333),
    [anon_sym_register] = ACTIONS(5333),
    [anon_sym_inline] = ACTIONS(5333),
    [anon_sym___inline] = ACTIONS(5333),
    [anon_sym___inline__] = ACTIONS(5333),
    [anon_sym___forceinline] = ACTIONS(5333),
    [anon_sym_thread_local] = ACTIONS(5333),
    [anon_sym___thread] = ACTIONS(5333),
    [anon_sym_const] = ACTIONS(5329),
    [anon_sym_constexpr] = ACTIONS(5329),
    [anon_sym_volatile] = ACTIONS(5329),
    [anon_sym_restrict] = ACTIONS(5329),
    [anon_sym___restrict__] = ACTIONS(5329),
    [anon_sym__Atomic] = ACTIONS(5329),
    [anon_sym__Noreturn] = ACTIONS(5329),
    [anon_sym_noreturn] = ACTIONS(5329),
    [anon_sym__Nonnull] = ACTIONS(5329),
    [anon_sym_mutable] = ACTIONS(5329),
    [anon_sym_constinit] = ACTIONS(5329),
    [anon_sym_consteval] = ACTIONS(5329),
    [anon_sym_alignas] = ACTIONS(5343),
    [anon_sym__Alignas] = ACTIONS(5343),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_operator] = ACTIONS(133),
  },
  [1742] = {
    [sym_identifier] = ACTIONS(5407),
    [aux_sym_preproc_def_token1] = ACTIONS(5407),
    [aux_sym_preproc_if_token1] = ACTIONS(5407),
    [aux_sym_preproc_if_token2] = ACTIONS(5407),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5407),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5407),
    [aux_sym_preproc_else_token1] = ACTIONS(5407),
    [aux_sym_preproc_elif_token1] = ACTIONS(5407),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5407),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5407),
    [sym_preproc_directive] = ACTIONS(5407),
    [anon_sym_LPAREN2] = ACTIONS(5409),
    [anon_sym_TILDE] = ACTIONS(5409),
    [anon_sym_STAR] = ACTIONS(5409),
    [anon_sym_AMP_AMP] = ACTIONS(5409),
    [anon_sym_AMP] = ACTIONS(5407),
    [anon_sym_SEMI] = ACTIONS(5409),
    [anon_sym___extension__] = ACTIONS(5407),
    [anon_sym_typedef] = ACTIONS(5407),
    [anon_sym_virtual] = ACTIONS(5407),
    [anon_sym_extern] = ACTIONS(5407),
    [anon_sym___attribute__] = ACTIONS(5407),
    [anon_sym___attribute] = ACTIONS(5407),
    [anon_sym_COLON_COLON] = ACTIONS(5409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5409),
    [anon_sym___declspec] = ACTIONS(5407),
    [anon_sym___based] = ACTIONS(5407),
    [anon_sym_signed] = ACTIONS(5407),
    [anon_sym_unsigned] = ACTIONS(5407),
    [anon_sym_long] = ACTIONS(5407),
    [anon_sym_short] = ACTIONS(5407),
    [anon_sym_LBRACK] = ACTIONS(5407),
    [anon_sym_static] = ACTIONS(5407),
    [anon_sym_register] = ACTIONS(5407),
    [anon_sym_inline] = ACTIONS(5407),
    [anon_sym___inline] = ACTIONS(5407),
    [anon_sym___inline__] = ACTIONS(5407),
    [anon_sym___forceinline] = ACTIONS(5407),
    [anon_sym_thread_local] = ACTIONS(5407),
    [anon_sym___thread] = ACTIONS(5407),
    [anon_sym_const] = ACTIONS(5407),
    [anon_sym_constexpr] = ACTIONS(5407),
    [anon_sym_volatile] = ACTIONS(5407),
    [anon_sym_restrict] = ACTIONS(5407),
    [anon_sym___restrict__] = ACTIONS(5407),
    [anon_sym__Atomic] = ACTIONS(5407),
    [anon_sym__Noreturn] = ACTIONS(5407),
    [anon_sym_noreturn] = ACTIONS(5407),
    [anon_sym__Nonnull] = ACTIONS(5407),
    [anon_sym_mutable] = ACTIONS(5407),
    [anon_sym_constinit] = ACTIONS(5407),
    [anon_sym_consteval] = ACTIONS(5407),
    [anon_sym_alignas] = ACTIONS(5407),
    [anon_sym__Alignas] = ACTIONS(5407),
    [sym_primitive_type] = ACTIONS(5407),
    [anon_sym_enum] = ACTIONS(5407),
    [anon_sym_class] = ACTIONS(5407),
    [anon_sym_struct] = ACTIONS(5407),
    [anon_sym_union] = ACTIONS(5407),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5407),
    [anon_sym_decltype] = ACTIONS(5407),
    [anon_sym_explicit] = ACTIONS(5407),
    [anon_sym_typename] = ACTIONS(5407),
    [anon_sym_template] = ACTIONS(5407),
    [anon_sym_operator] = ACTIONS(5407),
    [anon_sym_friend] = ACTIONS(5407),
    [anon_sym_public] = ACTIONS(5407),
    [anon_sym_private] = ACTIONS(5407),
    [anon_sym_protected] = ACTIONS(5407),
    [anon_sym_using] = ACTIONS(5407),
    [anon_sym_static_assert] = ACTIONS(5407),
  },
  [1743] = {
    [sym__declaration_modifiers] = STATE(3299),
    [sym_attribute_specifier] = STATE(3299),
    [sym_attribute_declaration] = STATE(3299),
    [sym_ms_declspec_modifier] = STATE(3299),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6169),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3299),
    [sym_type_qualifier] = STATE(3299),
    [sym_alignas_qualifier] = STATE(3049),
    [sym_decltype] = STATE(8512),
    [sym_explicit_function_specifier] = STATE(3299),
    [sym_operator_cast] = STATE(6721),
    [sym__constructor_specifiers] = STATE(3299),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(8512),
    [sym_template_function] = STATE(5896),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5444),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_operator_cast_identifier] = STATE(6721),
    [sym_operator_name] = STATE(5896),
    [aux_sym_operator_cast_definition_repeat1] = STATE(3299),
    [sym_identifier] = ACTIONS(5327),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym___extension__] = ACTIONS(5329),
    [anon_sym_virtual] = ACTIONS(5331),
    [anon_sym_extern] = ACTIONS(5333),
    [anon_sym___attribute__] = ACTIONS(5335),
    [anon_sym___attribute] = ACTIONS(5335),
    [anon_sym_COLON_COLON] = ACTIONS(5337),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5339),
    [anon_sym___declspec] = ACTIONS(5341),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(5333),
    [anon_sym_register] = ACTIONS(5333),
    [anon_sym_inline] = ACTIONS(5333),
    [anon_sym___inline] = ACTIONS(5333),
    [anon_sym___inline__] = ACTIONS(5333),
    [anon_sym___forceinline] = ACTIONS(5333),
    [anon_sym_thread_local] = ACTIONS(5333),
    [anon_sym___thread] = ACTIONS(5333),
    [anon_sym_const] = ACTIONS(5329),
    [anon_sym_constexpr] = ACTIONS(5329),
    [anon_sym_volatile] = ACTIONS(5329),
    [anon_sym_restrict] = ACTIONS(5329),
    [anon_sym___restrict__] = ACTIONS(5329),
    [anon_sym__Atomic] = ACTIONS(5329),
    [anon_sym__Noreturn] = ACTIONS(5329),
    [anon_sym_noreturn] = ACTIONS(5329),
    [anon_sym__Nonnull] = ACTIONS(5329),
    [anon_sym_mutable] = ACTIONS(5329),
    [anon_sym_constinit] = ACTIONS(5329),
    [anon_sym_consteval] = ACTIONS(5329),
    [anon_sym_alignas] = ACTIONS(5343),
    [anon_sym__Alignas] = ACTIONS(5343),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_operator] = ACTIONS(133),
  },
  [1744] = {
    [sym_identifier] = ACTIONS(5411),
    [aux_sym_preproc_def_token1] = ACTIONS(5411),
    [aux_sym_preproc_if_token1] = ACTIONS(5411),
    [aux_sym_preproc_if_token2] = ACTIONS(5411),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5411),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5411),
    [aux_sym_preproc_else_token1] = ACTIONS(5411),
    [aux_sym_preproc_elif_token1] = ACTIONS(5411),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5411),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5411),
    [sym_preproc_directive] = ACTIONS(5411),
    [anon_sym_LPAREN2] = ACTIONS(5413),
    [anon_sym_TILDE] = ACTIONS(5413),
    [anon_sym_STAR] = ACTIONS(5413),
    [anon_sym_AMP_AMP] = ACTIONS(5413),
    [anon_sym_AMP] = ACTIONS(5411),
    [anon_sym_SEMI] = ACTIONS(5413),
    [anon_sym___extension__] = ACTIONS(5411),
    [anon_sym_typedef] = ACTIONS(5411),
    [anon_sym_virtual] = ACTIONS(5411),
    [anon_sym_extern] = ACTIONS(5411),
    [anon_sym___attribute__] = ACTIONS(5411),
    [anon_sym___attribute] = ACTIONS(5411),
    [anon_sym_COLON_COLON] = ACTIONS(5413),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5413),
    [anon_sym___declspec] = ACTIONS(5411),
    [anon_sym___based] = ACTIONS(5411),
    [anon_sym_signed] = ACTIONS(5411),
    [anon_sym_unsigned] = ACTIONS(5411),
    [anon_sym_long] = ACTIONS(5411),
    [anon_sym_short] = ACTIONS(5411),
    [anon_sym_LBRACK] = ACTIONS(5411),
    [anon_sym_static] = ACTIONS(5411),
    [anon_sym_register] = ACTIONS(5411),
    [anon_sym_inline] = ACTIONS(5411),
    [anon_sym___inline] = ACTIONS(5411),
    [anon_sym___inline__] = ACTIONS(5411),
    [anon_sym___forceinline] = ACTIONS(5411),
    [anon_sym_thread_local] = ACTIONS(5411),
    [anon_sym___thread] = ACTIONS(5411),
    [anon_sym_const] = ACTIONS(5411),
    [anon_sym_constexpr] = ACTIONS(5411),
    [anon_sym_volatile] = ACTIONS(5411),
    [anon_sym_restrict] = ACTIONS(5411),
    [anon_sym___restrict__] = ACTIONS(5411),
    [anon_sym__Atomic] = ACTIONS(5411),
    [anon_sym__Noreturn] = ACTIONS(5411),
    [anon_sym_noreturn] = ACTIONS(5411),
    [anon_sym__Nonnull] = ACTIONS(5411),
    [anon_sym_mutable] = ACTIONS(5411),
    [anon_sym_constinit] = ACTIONS(5411),
    [anon_sym_consteval] = ACTIONS(5411),
    [anon_sym_alignas] = ACTIONS(5411),
    [anon_sym__Alignas] = ACTIONS(5411),
    [sym_primitive_type] = ACTIONS(5411),
    [anon_sym_enum] = ACTIONS(5411),
    [anon_sym_class] = ACTIONS(5411),
    [anon_sym_struct] = ACTIONS(5411),
    [anon_sym_union] = ACTIONS(5411),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5411),
    [anon_sym_decltype] = ACTIONS(5411),
    [anon_sym_explicit] = ACTIONS(5411),
    [anon_sym_typename] = ACTIONS(5411),
    [anon_sym_template] = ACTIONS(5411),
    [anon_sym_operator] = ACTIONS(5411),
    [anon_sym_friend] = ACTIONS(5411),
    [anon_sym_public] = ACTIONS(5411),
    [anon_sym_private] = ACTIONS(5411),
    [anon_sym_protected] = ACTIONS(5411),
    [anon_sym_using] = ACTIONS(5411),
    [anon_sym_static_assert] = ACTIONS(5411),
  },
  [1745] = {
    [sym_identifier] = ACTIONS(5415),
    [aux_sym_preproc_def_token1] = ACTIONS(5415),
    [aux_sym_preproc_if_token1] = ACTIONS(5415),
    [aux_sym_preproc_if_token2] = ACTIONS(5415),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5415),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5415),
    [aux_sym_preproc_else_token1] = ACTIONS(5415),
    [aux_sym_preproc_elif_token1] = ACTIONS(5415),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5415),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5415),
    [sym_preproc_directive] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(5417),
    [anon_sym_TILDE] = ACTIONS(5417),
    [anon_sym_STAR] = ACTIONS(5417),
    [anon_sym_AMP_AMP] = ACTIONS(5417),
    [anon_sym_AMP] = ACTIONS(5415),
    [anon_sym_SEMI] = ACTIONS(5417),
    [anon_sym___extension__] = ACTIONS(5415),
    [anon_sym_typedef] = ACTIONS(5415),
    [anon_sym_virtual] = ACTIONS(5415),
    [anon_sym_extern] = ACTIONS(5415),
    [anon_sym___attribute__] = ACTIONS(5415),
    [anon_sym___attribute] = ACTIONS(5415),
    [anon_sym_COLON_COLON] = ACTIONS(5417),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5417),
    [anon_sym___declspec] = ACTIONS(5415),
    [anon_sym___based] = ACTIONS(5415),
    [anon_sym_signed] = ACTIONS(5415),
    [anon_sym_unsigned] = ACTIONS(5415),
    [anon_sym_long] = ACTIONS(5415),
    [anon_sym_short] = ACTIONS(5415),
    [anon_sym_LBRACK] = ACTIONS(5415),
    [anon_sym_static] = ACTIONS(5415),
    [anon_sym_register] = ACTIONS(5415),
    [anon_sym_inline] = ACTIONS(5415),
    [anon_sym___inline] = ACTIONS(5415),
    [anon_sym___inline__] = ACTIONS(5415),
    [anon_sym___forceinline] = ACTIONS(5415),
    [anon_sym_thread_local] = ACTIONS(5415),
    [anon_sym___thread] = ACTIONS(5415),
    [anon_sym_const] = ACTIONS(5415),
    [anon_sym_constexpr] = ACTIONS(5415),
    [anon_sym_volatile] = ACTIONS(5415),
    [anon_sym_restrict] = ACTIONS(5415),
    [anon_sym___restrict__] = ACTIONS(5415),
    [anon_sym__Atomic] = ACTIONS(5415),
    [anon_sym__Noreturn] = ACTIONS(5415),
    [anon_sym_noreturn] = ACTIONS(5415),
    [anon_sym__Nonnull] = ACTIONS(5415),
    [anon_sym_mutable] = ACTIONS(5415),
    [anon_sym_constinit] = ACTIONS(5415),
    [anon_sym_consteval] = ACTIONS(5415),
    [anon_sym_alignas] = ACTIONS(5415),
    [anon_sym__Alignas] = ACTIONS(5415),
    [sym_primitive_type] = ACTIONS(5415),
    [anon_sym_enum] = ACTIONS(5415),
    [anon_sym_class] = ACTIONS(5415),
    [anon_sym_struct] = ACTIONS(5415),
    [anon_sym_union] = ACTIONS(5415),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5415),
    [anon_sym_decltype] = ACTIONS(5415),
    [anon_sym_explicit] = ACTIONS(5415),
    [anon_sym_typename] = ACTIONS(5415),
    [anon_sym_template] = ACTIONS(5415),
    [anon_sym_operator] = ACTIONS(5415),
    [anon_sym_friend] = ACTIONS(5415),
    [anon_sym_public] = ACTIONS(5415),
    [anon_sym_private] = ACTIONS(5415),
    [anon_sym_protected] = ACTIONS(5415),
    [anon_sym_using] = ACTIONS(5415),
    [anon_sym_static_assert] = ACTIONS(5415),
  },
  [1746] = {
    [sym_identifier] = ACTIONS(5419),
    [aux_sym_preproc_def_token1] = ACTIONS(5419),
    [aux_sym_preproc_if_token1] = ACTIONS(5419),
    [aux_sym_preproc_if_token2] = ACTIONS(5419),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5419),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5419),
    [aux_sym_preproc_else_token1] = ACTIONS(5419),
    [aux_sym_preproc_elif_token1] = ACTIONS(5419),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5419),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5419),
    [sym_preproc_directive] = ACTIONS(5419),
    [anon_sym_LPAREN2] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5421),
    [anon_sym_STAR] = ACTIONS(5421),
    [anon_sym_AMP_AMP] = ACTIONS(5421),
    [anon_sym_AMP] = ACTIONS(5419),
    [anon_sym_SEMI] = ACTIONS(5421),
    [anon_sym___extension__] = ACTIONS(5419),
    [anon_sym_typedef] = ACTIONS(5419),
    [anon_sym_virtual] = ACTIONS(5419),
    [anon_sym_extern] = ACTIONS(5419),
    [anon_sym___attribute__] = ACTIONS(5419),
    [anon_sym___attribute] = ACTIONS(5419),
    [anon_sym_COLON_COLON] = ACTIONS(5421),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5421),
    [anon_sym___declspec] = ACTIONS(5419),
    [anon_sym___based] = ACTIONS(5419),
    [anon_sym_signed] = ACTIONS(5419),
    [anon_sym_unsigned] = ACTIONS(5419),
    [anon_sym_long] = ACTIONS(5419),
    [anon_sym_short] = ACTIONS(5419),
    [anon_sym_LBRACK] = ACTIONS(5419),
    [anon_sym_static] = ACTIONS(5419),
    [anon_sym_register] = ACTIONS(5419),
    [anon_sym_inline] = ACTIONS(5419),
    [anon_sym___inline] = ACTIONS(5419),
    [anon_sym___inline__] = ACTIONS(5419),
    [anon_sym___forceinline] = ACTIONS(5419),
    [anon_sym_thread_local] = ACTIONS(5419),
    [anon_sym___thread] = ACTIONS(5419),
    [anon_sym_const] = ACTIONS(5419),
    [anon_sym_constexpr] = ACTIONS(5419),
    [anon_sym_volatile] = ACTIONS(5419),
    [anon_sym_restrict] = ACTIONS(5419),
    [anon_sym___restrict__] = ACTIONS(5419),
    [anon_sym__Atomic] = ACTIONS(5419),
    [anon_sym__Noreturn] = ACTIONS(5419),
    [anon_sym_noreturn] = ACTIONS(5419),
    [anon_sym__Nonnull] = ACTIONS(5419),
    [anon_sym_mutable] = ACTIONS(5419),
    [anon_sym_constinit] = ACTIONS(5419),
    [anon_sym_consteval] = ACTIONS(5419),
    [anon_sym_alignas] = ACTIONS(5419),
    [anon_sym__Alignas] = ACTIONS(5419),
    [sym_primitive_type] = ACTIONS(5419),
    [anon_sym_enum] = ACTIONS(5419),
    [anon_sym_class] = ACTIONS(5419),
    [anon_sym_struct] = ACTIONS(5419),
    [anon_sym_union] = ACTIONS(5419),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5419),
    [anon_sym_decltype] = ACTIONS(5419),
    [anon_sym_explicit] = ACTIONS(5419),
    [anon_sym_typename] = ACTIONS(5419),
    [anon_sym_template] = ACTIONS(5419),
    [anon_sym_operator] = ACTIONS(5419),
    [anon_sym_friend] = ACTIONS(5419),
    [anon_sym_public] = ACTIONS(5419),
    [anon_sym_private] = ACTIONS(5419),
    [anon_sym_protected] = ACTIONS(5419),
    [anon_sym_using] = ACTIONS(5419),
    [anon_sym_static_assert] = ACTIONS(5419),
  },
  [1747] = {
    [sym_identifier] = ACTIONS(5423),
    [aux_sym_preproc_def_token1] = ACTIONS(5423),
    [aux_sym_preproc_if_token1] = ACTIONS(5423),
    [aux_sym_preproc_if_token2] = ACTIONS(5423),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5423),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5423),
    [aux_sym_preproc_else_token1] = ACTIONS(5423),
    [aux_sym_preproc_elif_token1] = ACTIONS(5423),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5423),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5423),
    [sym_preproc_directive] = ACTIONS(5423),
    [anon_sym_LPAREN2] = ACTIONS(5425),
    [anon_sym_TILDE] = ACTIONS(5425),
    [anon_sym_STAR] = ACTIONS(5425),
    [anon_sym_AMP_AMP] = ACTIONS(5425),
    [anon_sym_AMP] = ACTIONS(5423),
    [anon_sym_SEMI] = ACTIONS(5425),
    [anon_sym___extension__] = ACTIONS(5423),
    [anon_sym_typedef] = ACTIONS(5423),
    [anon_sym_virtual] = ACTIONS(5423),
    [anon_sym_extern] = ACTIONS(5423),
    [anon_sym___attribute__] = ACTIONS(5423),
    [anon_sym___attribute] = ACTIONS(5423),
    [anon_sym_COLON_COLON] = ACTIONS(5425),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5425),
    [anon_sym___declspec] = ACTIONS(5423),
    [anon_sym___based] = ACTIONS(5423),
    [anon_sym_signed] = ACTIONS(5423),
    [anon_sym_unsigned] = ACTIONS(5423),
    [anon_sym_long] = ACTIONS(5423),
    [anon_sym_short] = ACTIONS(5423),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_static] = ACTIONS(5423),
    [anon_sym_register] = ACTIONS(5423),
    [anon_sym_inline] = ACTIONS(5423),
    [anon_sym___inline] = ACTIONS(5423),
    [anon_sym___inline__] = ACTIONS(5423),
    [anon_sym___forceinline] = ACTIONS(5423),
    [anon_sym_thread_local] = ACTIONS(5423),
    [anon_sym___thread] = ACTIONS(5423),
    [anon_sym_const] = ACTIONS(5423),
    [anon_sym_constexpr] = ACTIONS(5423),
    [anon_sym_volatile] = ACTIONS(5423),
    [anon_sym_restrict] = ACTIONS(5423),
    [anon_sym___restrict__] = ACTIONS(5423),
    [anon_sym__Atomic] = ACTIONS(5423),
    [anon_sym__Noreturn] = ACTIONS(5423),
    [anon_sym_noreturn] = ACTIONS(5423),
    [anon_sym__Nonnull] = ACTIONS(5423),
    [anon_sym_mutable] = ACTIONS(5423),
    [anon_sym_constinit] = ACTIONS(5423),
    [anon_sym_consteval] = ACTIONS(5423),
    [anon_sym_alignas] = ACTIONS(5423),
    [anon_sym__Alignas] = ACTIONS(5423),
    [sym_primitive_type] = ACTIONS(5423),
    [anon_sym_enum] = ACTIONS(5423),
    [anon_sym_class] = ACTIONS(5423),
    [anon_sym_struct] = ACTIONS(5423),
    [anon_sym_union] = ACTIONS(5423),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5423),
    [anon_sym_decltype] = ACTIONS(5423),
    [anon_sym_explicit] = ACTIONS(5423),
    [anon_sym_typename] = ACTIONS(5423),
    [anon_sym_template] = ACTIONS(5423),
    [anon_sym_operator] = ACTIONS(5423),
    [anon_sym_friend] = ACTIONS(5423),
    [anon_sym_public] = ACTIONS(5423),
    [anon_sym_private] = ACTIONS(5423),
    [anon_sym_protected] = ACTIONS(5423),
    [anon_sym_using] = ACTIONS(5423),
    [anon_sym_static_assert] = ACTIONS(5423),
  },
  [1748] = {
    [sym__declaration_modifiers] = STATE(3299),
    [sym_attribute_specifier] = STATE(3299),
    [sym_attribute_declaration] = STATE(3299),
    [sym_ms_declspec_modifier] = STATE(3299),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6171),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3299),
    [sym_type_qualifier] = STATE(3299),
    [sym_alignas_qualifier] = STATE(3049),
    [sym_decltype] = STATE(8512),
    [sym_explicit_function_specifier] = STATE(3299),
    [sym_operator_cast] = STATE(6690),
    [sym__constructor_specifiers] = STATE(3299),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(8512),
    [sym_template_function] = STATE(5896),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5444),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_operator_cast_identifier] = STATE(6690),
    [sym_operator_name] = STATE(5896),
    [aux_sym_operator_cast_definition_repeat1] = STATE(3299),
    [sym_identifier] = ACTIONS(5327),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym___extension__] = ACTIONS(5329),
    [anon_sym_virtual] = ACTIONS(5331),
    [anon_sym_extern] = ACTIONS(5333),
    [anon_sym___attribute__] = ACTIONS(5335),
    [anon_sym___attribute] = ACTIONS(5335),
    [anon_sym_COLON_COLON] = ACTIONS(5337),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5339),
    [anon_sym___declspec] = ACTIONS(5341),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(5333),
    [anon_sym_register] = ACTIONS(5333),
    [anon_sym_inline] = ACTIONS(5333),
    [anon_sym___inline] = ACTIONS(5333),
    [anon_sym___inline__] = ACTIONS(5333),
    [anon_sym___forceinline] = ACTIONS(5333),
    [anon_sym_thread_local] = ACTIONS(5333),
    [anon_sym___thread] = ACTIONS(5333),
    [anon_sym_const] = ACTIONS(5329),
    [anon_sym_constexpr] = ACTIONS(5329),
    [anon_sym_volatile] = ACTIONS(5329),
    [anon_sym_restrict] = ACTIONS(5329),
    [anon_sym___restrict__] = ACTIONS(5329),
    [anon_sym__Atomic] = ACTIONS(5329),
    [anon_sym__Noreturn] = ACTIONS(5329),
    [anon_sym_noreturn] = ACTIONS(5329),
    [anon_sym__Nonnull] = ACTIONS(5329),
    [anon_sym_mutable] = ACTIONS(5329),
    [anon_sym_constinit] = ACTIONS(5329),
    [anon_sym_consteval] = ACTIONS(5329),
    [anon_sym_alignas] = ACTIONS(5343),
    [anon_sym__Alignas] = ACTIONS(5343),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_operator] = ACTIONS(133),
  },
  [1749] = {
    [sym_identifier] = ACTIONS(2609),
    [aux_sym_preproc_def_token1] = ACTIONS(2609),
    [aux_sym_preproc_if_token1] = ACTIONS(2609),
    [aux_sym_preproc_if_token2] = ACTIONS(2609),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2609),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2609),
    [aux_sym_preproc_else_token1] = ACTIONS(2609),
    [aux_sym_preproc_elif_token1] = ACTIONS(2609),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2609),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2609),
    [sym_preproc_directive] = ACTIONS(2609),
    [anon_sym_LPAREN2] = ACTIONS(2611),
    [anon_sym_TILDE] = ACTIONS(2611),
    [anon_sym_STAR] = ACTIONS(2611),
    [anon_sym_AMP_AMP] = ACTIONS(2611),
    [anon_sym_AMP] = ACTIONS(2609),
    [anon_sym_SEMI] = ACTIONS(2611),
    [anon_sym___extension__] = ACTIONS(2609),
    [anon_sym_typedef] = ACTIONS(2609),
    [anon_sym_virtual] = ACTIONS(2609),
    [anon_sym_extern] = ACTIONS(2609),
    [anon_sym___attribute__] = ACTIONS(2609),
    [anon_sym___attribute] = ACTIONS(2609),
    [anon_sym_COLON_COLON] = ACTIONS(2611),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2611),
    [anon_sym___declspec] = ACTIONS(2609),
    [anon_sym___based] = ACTIONS(2609),
    [anon_sym_signed] = ACTIONS(2609),
    [anon_sym_unsigned] = ACTIONS(2609),
    [anon_sym_long] = ACTIONS(2609),
    [anon_sym_short] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(2609),
    [anon_sym_static] = ACTIONS(2609),
    [anon_sym_register] = ACTIONS(2609),
    [anon_sym_inline] = ACTIONS(2609),
    [anon_sym___inline] = ACTIONS(2609),
    [anon_sym___inline__] = ACTIONS(2609),
    [anon_sym___forceinline] = ACTIONS(2609),
    [anon_sym_thread_local] = ACTIONS(2609),
    [anon_sym___thread] = ACTIONS(2609),
    [anon_sym_const] = ACTIONS(2609),
    [anon_sym_constexpr] = ACTIONS(2609),
    [anon_sym_volatile] = ACTIONS(2609),
    [anon_sym_restrict] = ACTIONS(2609),
    [anon_sym___restrict__] = ACTIONS(2609),
    [anon_sym__Atomic] = ACTIONS(2609),
    [anon_sym__Noreturn] = ACTIONS(2609),
    [anon_sym_noreturn] = ACTIONS(2609),
    [anon_sym__Nonnull] = ACTIONS(2609),
    [anon_sym_mutable] = ACTIONS(2609),
    [anon_sym_constinit] = ACTIONS(2609),
    [anon_sym_consteval] = ACTIONS(2609),
    [anon_sym_alignas] = ACTIONS(2609),
    [anon_sym__Alignas] = ACTIONS(2609),
    [sym_primitive_type] = ACTIONS(2609),
    [anon_sym_enum] = ACTIONS(2609),
    [anon_sym_class] = ACTIONS(2609),
    [anon_sym_struct] = ACTIONS(2609),
    [anon_sym_union] = ACTIONS(2609),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2609),
    [anon_sym_decltype] = ACTIONS(2609),
    [anon_sym_explicit] = ACTIONS(2609),
    [anon_sym_typename] = ACTIONS(2609),
    [anon_sym_template] = ACTIONS(2609),
    [anon_sym_operator] = ACTIONS(2609),
    [anon_sym_friend] = ACTIONS(2609),
    [anon_sym_public] = ACTIONS(2609),
    [anon_sym_private] = ACTIONS(2609),
    [anon_sym_protected] = ACTIONS(2609),
    [anon_sym_using] = ACTIONS(2609),
    [anon_sym_static_assert] = ACTIONS(2609),
  },
  [1750] = {
    [sym_identifier] = ACTIONS(2609),
    [aux_sym_preproc_def_token1] = ACTIONS(2609),
    [aux_sym_preproc_if_token1] = ACTIONS(2609),
    [aux_sym_preproc_if_token2] = ACTIONS(2609),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2609),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2609),
    [aux_sym_preproc_else_token1] = ACTIONS(2609),
    [aux_sym_preproc_elif_token1] = ACTIONS(2609),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2609),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2609),
    [sym_preproc_directive] = ACTIONS(2609),
    [anon_sym_LPAREN2] = ACTIONS(2611),
    [anon_sym_TILDE] = ACTIONS(2611),
    [anon_sym_STAR] = ACTIONS(2611),
    [anon_sym_AMP_AMP] = ACTIONS(2611),
    [anon_sym_AMP] = ACTIONS(2609),
    [anon_sym_SEMI] = ACTIONS(2611),
    [anon_sym___extension__] = ACTIONS(2609),
    [anon_sym_typedef] = ACTIONS(2609),
    [anon_sym_virtual] = ACTIONS(2609),
    [anon_sym_extern] = ACTIONS(2609),
    [anon_sym___attribute__] = ACTIONS(2609),
    [anon_sym___attribute] = ACTIONS(2609),
    [anon_sym_COLON_COLON] = ACTIONS(2611),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2611),
    [anon_sym___declspec] = ACTIONS(2609),
    [anon_sym___based] = ACTIONS(2609),
    [anon_sym_signed] = ACTIONS(2609),
    [anon_sym_unsigned] = ACTIONS(2609),
    [anon_sym_long] = ACTIONS(2609),
    [anon_sym_short] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(2609),
    [anon_sym_static] = ACTIONS(2609),
    [anon_sym_register] = ACTIONS(2609),
    [anon_sym_inline] = ACTIONS(2609),
    [anon_sym___inline] = ACTIONS(2609),
    [anon_sym___inline__] = ACTIONS(2609),
    [anon_sym___forceinline] = ACTIONS(2609),
    [anon_sym_thread_local] = ACTIONS(2609),
    [anon_sym___thread] = ACTIONS(2609),
    [anon_sym_const] = ACTIONS(2609),
    [anon_sym_constexpr] = ACTIONS(2609),
    [anon_sym_volatile] = ACTIONS(2609),
    [anon_sym_restrict] = ACTIONS(2609),
    [anon_sym___restrict__] = ACTIONS(2609),
    [anon_sym__Atomic] = ACTIONS(2609),
    [anon_sym__Noreturn] = ACTIONS(2609),
    [anon_sym_noreturn] = ACTIONS(2609),
    [anon_sym__Nonnull] = ACTIONS(2609),
    [anon_sym_mutable] = ACTIONS(2609),
    [anon_sym_constinit] = ACTIONS(2609),
    [anon_sym_consteval] = ACTIONS(2609),
    [anon_sym_alignas] = ACTIONS(2609),
    [anon_sym__Alignas] = ACTIONS(2609),
    [sym_primitive_type] = ACTIONS(2609),
    [anon_sym_enum] = ACTIONS(2609),
    [anon_sym_class] = ACTIONS(2609),
    [anon_sym_struct] = ACTIONS(2609),
    [anon_sym_union] = ACTIONS(2609),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2609),
    [anon_sym_decltype] = ACTIONS(2609),
    [anon_sym_explicit] = ACTIONS(2609),
    [anon_sym_typename] = ACTIONS(2609),
    [anon_sym_template] = ACTIONS(2609),
    [anon_sym_operator] = ACTIONS(2609),
    [anon_sym_friend] = ACTIONS(2609),
    [anon_sym_public] = ACTIONS(2609),
    [anon_sym_private] = ACTIONS(2609),
    [anon_sym_protected] = ACTIONS(2609),
    [anon_sym_using] = ACTIONS(2609),
    [anon_sym_static_assert] = ACTIONS(2609),
  },
  [1751] = {
    [sym_identifier] = ACTIONS(5427),
    [aux_sym_preproc_def_token1] = ACTIONS(5427),
    [aux_sym_preproc_if_token1] = ACTIONS(5427),
    [aux_sym_preproc_if_token2] = ACTIONS(5427),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5427),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5427),
    [aux_sym_preproc_else_token1] = ACTIONS(5427),
    [aux_sym_preproc_elif_token1] = ACTIONS(5427),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5427),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5427),
    [sym_preproc_directive] = ACTIONS(5427),
    [anon_sym_LPAREN2] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(5429),
    [anon_sym_STAR] = ACTIONS(5429),
    [anon_sym_AMP_AMP] = ACTIONS(5429),
    [anon_sym_AMP] = ACTIONS(5427),
    [anon_sym_SEMI] = ACTIONS(5429),
    [anon_sym___extension__] = ACTIONS(5427),
    [anon_sym_typedef] = ACTIONS(5427),
    [anon_sym_virtual] = ACTIONS(5427),
    [anon_sym_extern] = ACTIONS(5427),
    [anon_sym___attribute__] = ACTIONS(5427),
    [anon_sym___attribute] = ACTIONS(5427),
    [anon_sym_COLON_COLON] = ACTIONS(5429),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5429),
    [anon_sym___declspec] = ACTIONS(5427),
    [anon_sym___based] = ACTIONS(5427),
    [anon_sym_signed] = ACTIONS(5427),
    [anon_sym_unsigned] = ACTIONS(5427),
    [anon_sym_long] = ACTIONS(5427),
    [anon_sym_short] = ACTIONS(5427),
    [anon_sym_LBRACK] = ACTIONS(5427),
    [anon_sym_static] = ACTIONS(5427),
    [anon_sym_register] = ACTIONS(5427),
    [anon_sym_inline] = ACTIONS(5427),
    [anon_sym___inline] = ACTIONS(5427),
    [anon_sym___inline__] = ACTIONS(5427),
    [anon_sym___forceinline] = ACTIONS(5427),
    [anon_sym_thread_local] = ACTIONS(5427),
    [anon_sym___thread] = ACTIONS(5427),
    [anon_sym_const] = ACTIONS(5427),
    [anon_sym_constexpr] = ACTIONS(5427),
    [anon_sym_volatile] = ACTIONS(5427),
    [anon_sym_restrict] = ACTIONS(5427),
    [anon_sym___restrict__] = ACTIONS(5427),
    [anon_sym__Atomic] = ACTIONS(5427),
    [anon_sym__Noreturn] = ACTIONS(5427),
    [anon_sym_noreturn] = ACTIONS(5427),
    [anon_sym__Nonnull] = ACTIONS(5427),
    [anon_sym_mutable] = ACTIONS(5427),
    [anon_sym_constinit] = ACTIONS(5427),
    [anon_sym_consteval] = ACTIONS(5427),
    [anon_sym_alignas] = ACTIONS(5427),
    [anon_sym__Alignas] = ACTIONS(5427),
    [sym_primitive_type] = ACTIONS(5427),
    [anon_sym_enum] = ACTIONS(5427),
    [anon_sym_class] = ACTIONS(5427),
    [anon_sym_struct] = ACTIONS(5427),
    [anon_sym_union] = ACTIONS(5427),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5427),
    [anon_sym_decltype] = ACTIONS(5427),
    [anon_sym_explicit] = ACTIONS(5427),
    [anon_sym_typename] = ACTIONS(5427),
    [anon_sym_template] = ACTIONS(5427),
    [anon_sym_operator] = ACTIONS(5427),
    [anon_sym_friend] = ACTIONS(5427),
    [anon_sym_public] = ACTIONS(5427),
    [anon_sym_private] = ACTIONS(5427),
    [anon_sym_protected] = ACTIONS(5427),
    [anon_sym_using] = ACTIONS(5427),
    [anon_sym_static_assert] = ACTIONS(5427),
  },
  [1752] = {
    [sym_identifier] = ACTIONS(5427),
    [aux_sym_preproc_def_token1] = ACTIONS(5427),
    [aux_sym_preproc_if_token1] = ACTIONS(5427),
    [aux_sym_preproc_if_token2] = ACTIONS(5427),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5427),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5427),
    [aux_sym_preproc_else_token1] = ACTIONS(5427),
    [aux_sym_preproc_elif_token1] = ACTIONS(5427),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5427),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5427),
    [sym_preproc_directive] = ACTIONS(5427),
    [anon_sym_LPAREN2] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(5429),
    [anon_sym_STAR] = ACTIONS(5429),
    [anon_sym_AMP_AMP] = ACTIONS(5429),
    [anon_sym_AMP] = ACTIONS(5427),
    [anon_sym_SEMI] = ACTIONS(5429),
    [anon_sym___extension__] = ACTIONS(5427),
    [anon_sym_typedef] = ACTIONS(5427),
    [anon_sym_virtual] = ACTIONS(5427),
    [anon_sym_extern] = ACTIONS(5427),
    [anon_sym___attribute__] = ACTIONS(5427),
    [anon_sym___attribute] = ACTIONS(5427),
    [anon_sym_COLON_COLON] = ACTIONS(5429),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5429),
    [anon_sym___declspec] = ACTIONS(5427),
    [anon_sym___based] = ACTIONS(5427),
    [anon_sym_signed] = ACTIONS(5427),
    [anon_sym_unsigned] = ACTIONS(5427),
    [anon_sym_long] = ACTIONS(5427),
    [anon_sym_short] = ACTIONS(5427),
    [anon_sym_LBRACK] = ACTIONS(5427),
    [anon_sym_static] = ACTIONS(5427),
    [anon_sym_register] = ACTIONS(5427),
    [anon_sym_inline] = ACTIONS(5427),
    [anon_sym___inline] = ACTIONS(5427),
    [anon_sym___inline__] = ACTIONS(5427),
    [anon_sym___forceinline] = ACTIONS(5427),
    [anon_sym_thread_local] = ACTIONS(5427),
    [anon_sym___thread] = ACTIONS(5427),
    [anon_sym_const] = ACTIONS(5427),
    [anon_sym_constexpr] = ACTIONS(5427),
    [anon_sym_volatile] = ACTIONS(5427),
    [anon_sym_restrict] = ACTIONS(5427),
    [anon_sym___restrict__] = ACTIONS(5427),
    [anon_sym__Atomic] = ACTIONS(5427),
    [anon_sym__Noreturn] = ACTIONS(5427),
    [anon_sym_noreturn] = ACTIONS(5427),
    [anon_sym__Nonnull] = ACTIONS(5427),
    [anon_sym_mutable] = ACTIONS(5427),
    [anon_sym_constinit] = ACTIONS(5427),
    [anon_sym_consteval] = ACTIONS(5427),
    [anon_sym_alignas] = ACTIONS(5427),
    [anon_sym__Alignas] = ACTIONS(5427),
    [sym_primitive_type] = ACTIONS(5427),
    [anon_sym_enum] = ACTIONS(5427),
    [anon_sym_class] = ACTIONS(5427),
    [anon_sym_struct] = ACTIONS(5427),
    [anon_sym_union] = ACTIONS(5427),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5427),
    [anon_sym_decltype] = ACTIONS(5427),
    [anon_sym_explicit] = ACTIONS(5427),
    [anon_sym_typename] = ACTIONS(5427),
    [anon_sym_template] = ACTIONS(5427),
    [anon_sym_operator] = ACTIONS(5427),
    [anon_sym_friend] = ACTIONS(5427),
    [anon_sym_public] = ACTIONS(5427),
    [anon_sym_private] = ACTIONS(5427),
    [anon_sym_protected] = ACTIONS(5427),
    [anon_sym_using] = ACTIONS(5427),
    [anon_sym_static_assert] = ACTIONS(5427),
  },
  [1753] = {
    [sym_identifier] = ACTIONS(5427),
    [aux_sym_preproc_def_token1] = ACTIONS(5427),
    [aux_sym_preproc_if_token1] = ACTIONS(5427),
    [aux_sym_preproc_if_token2] = ACTIONS(5427),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5427),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5427),
    [aux_sym_preproc_else_token1] = ACTIONS(5427),
    [aux_sym_preproc_elif_token1] = ACTIONS(5427),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5427),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5427),
    [sym_preproc_directive] = ACTIONS(5427),
    [anon_sym_LPAREN2] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(5429),
    [anon_sym_STAR] = ACTIONS(5429),
    [anon_sym_AMP_AMP] = ACTIONS(5429),
    [anon_sym_AMP] = ACTIONS(5427),
    [anon_sym_SEMI] = ACTIONS(5429),
    [anon_sym___extension__] = ACTIONS(5427),
    [anon_sym_typedef] = ACTIONS(5427),
    [anon_sym_virtual] = ACTIONS(5427),
    [anon_sym_extern] = ACTIONS(5427),
    [anon_sym___attribute__] = ACTIONS(5427),
    [anon_sym___attribute] = ACTIONS(5427),
    [anon_sym_COLON_COLON] = ACTIONS(5429),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5429),
    [anon_sym___declspec] = ACTIONS(5427),
    [anon_sym___based] = ACTIONS(5427),
    [anon_sym_signed] = ACTIONS(5427),
    [anon_sym_unsigned] = ACTIONS(5427),
    [anon_sym_long] = ACTIONS(5427),
    [anon_sym_short] = ACTIONS(5427),
    [anon_sym_LBRACK] = ACTIONS(5427),
    [anon_sym_static] = ACTIONS(5427),
    [anon_sym_register] = ACTIONS(5427),
    [anon_sym_inline] = ACTIONS(5427),
    [anon_sym___inline] = ACTIONS(5427),
    [anon_sym___inline__] = ACTIONS(5427),
    [anon_sym___forceinline] = ACTIONS(5427),
    [anon_sym_thread_local] = ACTIONS(5427),
    [anon_sym___thread] = ACTIONS(5427),
    [anon_sym_const] = ACTIONS(5427),
    [anon_sym_constexpr] = ACTIONS(5427),
    [anon_sym_volatile] = ACTIONS(5427),
    [anon_sym_restrict] = ACTIONS(5427),
    [anon_sym___restrict__] = ACTIONS(5427),
    [anon_sym__Atomic] = ACTIONS(5427),
    [anon_sym__Noreturn] = ACTIONS(5427),
    [anon_sym_noreturn] = ACTIONS(5427),
    [anon_sym__Nonnull] = ACTIONS(5427),
    [anon_sym_mutable] = ACTIONS(5427),
    [anon_sym_constinit] = ACTIONS(5427),
    [anon_sym_consteval] = ACTIONS(5427),
    [anon_sym_alignas] = ACTIONS(5427),
    [anon_sym__Alignas] = ACTIONS(5427),
    [sym_primitive_type] = ACTIONS(5427),
    [anon_sym_enum] = ACTIONS(5427),
    [anon_sym_class] = ACTIONS(5427),
    [anon_sym_struct] = ACTIONS(5427),
    [anon_sym_union] = ACTIONS(5427),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5427),
    [anon_sym_decltype] = ACTIONS(5427),
    [anon_sym_explicit] = ACTIONS(5427),
    [anon_sym_typename] = ACTIONS(5427),
    [anon_sym_template] = ACTIONS(5427),
    [anon_sym_operator] = ACTIONS(5427),
    [anon_sym_friend] = ACTIONS(5427),
    [anon_sym_public] = ACTIONS(5427),
    [anon_sym_private] = ACTIONS(5427),
    [anon_sym_protected] = ACTIONS(5427),
    [anon_sym_using] = ACTIONS(5427),
    [anon_sym_static_assert] = ACTIONS(5427),
  },
  [1754] = {
    [sym__declaration_modifiers] = STATE(3299),
    [sym_attribute_specifier] = STATE(3299),
    [sym_attribute_declaration] = STATE(3299),
    [sym_ms_declspec_modifier] = STATE(3299),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6198),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3299),
    [sym_type_qualifier] = STATE(3299),
    [sym_alignas_qualifier] = STATE(3049),
    [sym_decltype] = STATE(8512),
    [sym_explicit_function_specifier] = STATE(3299),
    [sym_operator_cast] = STATE(6675),
    [sym__constructor_specifiers] = STATE(3299),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(8512),
    [sym_template_function] = STATE(5896),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5444),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_operator_cast_identifier] = STATE(6675),
    [sym_operator_name] = STATE(5896),
    [aux_sym_operator_cast_definition_repeat1] = STATE(3299),
    [sym_identifier] = ACTIONS(5327),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym___extension__] = ACTIONS(5329),
    [anon_sym_virtual] = ACTIONS(5331),
    [anon_sym_extern] = ACTIONS(5333),
    [anon_sym___attribute__] = ACTIONS(5335),
    [anon_sym___attribute] = ACTIONS(5335),
    [anon_sym_COLON_COLON] = ACTIONS(5337),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5339),
    [anon_sym___declspec] = ACTIONS(5341),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(5333),
    [anon_sym_register] = ACTIONS(5333),
    [anon_sym_inline] = ACTIONS(5333),
    [anon_sym___inline] = ACTIONS(5333),
    [anon_sym___inline__] = ACTIONS(5333),
    [anon_sym___forceinline] = ACTIONS(5333),
    [anon_sym_thread_local] = ACTIONS(5333),
    [anon_sym___thread] = ACTIONS(5333),
    [anon_sym_const] = ACTIONS(5329),
    [anon_sym_constexpr] = ACTIONS(5329),
    [anon_sym_volatile] = ACTIONS(5329),
    [anon_sym_restrict] = ACTIONS(5329),
    [anon_sym___restrict__] = ACTIONS(5329),
    [anon_sym__Atomic] = ACTIONS(5329),
    [anon_sym__Noreturn] = ACTIONS(5329),
    [anon_sym_noreturn] = ACTIONS(5329),
    [anon_sym__Nonnull] = ACTIONS(5329),
    [anon_sym_mutable] = ACTIONS(5329),
    [anon_sym_constinit] = ACTIONS(5329),
    [anon_sym_consteval] = ACTIONS(5329),
    [anon_sym_alignas] = ACTIONS(5343),
    [anon_sym__Alignas] = ACTIONS(5343),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_operator] = ACTIONS(133),
  },
  [1755] = {
    [sym_identifier] = ACTIONS(5431),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5433),
    [anon_sym_COMMA] = ACTIONS(5433),
    [anon_sym_RPAREN] = ACTIONS(5433),
    [anon_sym_LPAREN2] = ACTIONS(5433),
    [anon_sym_DASH] = ACTIONS(5431),
    [anon_sym_PLUS] = ACTIONS(5431),
    [anon_sym_STAR] = ACTIONS(5433),
    [anon_sym_SLASH] = ACTIONS(5431),
    [anon_sym_PERCENT] = ACTIONS(5433),
    [anon_sym_PIPE_PIPE] = ACTIONS(5433),
    [anon_sym_AMP_AMP] = ACTIONS(5433),
    [anon_sym_PIPE] = ACTIONS(5431),
    [anon_sym_CARET] = ACTIONS(5433),
    [anon_sym_AMP] = ACTIONS(5431),
    [anon_sym_EQ_EQ] = ACTIONS(5433),
    [anon_sym_BANG_EQ] = ACTIONS(5433),
    [anon_sym_GT] = ACTIONS(5431),
    [anon_sym_GT_EQ] = ACTIONS(5433),
    [anon_sym_LT_EQ] = ACTIONS(5431),
    [anon_sym_LT] = ACTIONS(5431),
    [anon_sym_LT_LT] = ACTIONS(5433),
    [anon_sym_GT_GT] = ACTIONS(5433),
    [anon_sym_SEMI] = ACTIONS(5433),
    [anon_sym___extension__] = ACTIONS(5431),
    [anon_sym___attribute__] = ACTIONS(5431),
    [anon_sym___attribute] = ACTIONS(5431),
    [anon_sym_COLON_COLON] = ACTIONS(5365),
    [anon_sym___based] = ACTIONS(5431),
    [anon_sym_LBRACE] = ACTIONS(5433),
    [anon_sym_RBRACE] = ACTIONS(5433),
    [anon_sym_signed] = ACTIONS(5431),
    [anon_sym_unsigned] = ACTIONS(5431),
    [anon_sym_long] = ACTIONS(5431),
    [anon_sym_short] = ACTIONS(5431),
    [anon_sym_LBRACK] = ACTIONS(5433),
    [anon_sym_RBRACK] = ACTIONS(5433),
    [anon_sym_const] = ACTIONS(5431),
    [anon_sym_constexpr] = ACTIONS(5431),
    [anon_sym_volatile] = ACTIONS(5431),
    [anon_sym_restrict] = ACTIONS(5431),
    [anon_sym___restrict__] = ACTIONS(5431),
    [anon_sym__Atomic] = ACTIONS(5431),
    [anon_sym__Noreturn] = ACTIONS(5431),
    [anon_sym_noreturn] = ACTIONS(5431),
    [anon_sym__Nonnull] = ACTIONS(5431),
    [anon_sym_mutable] = ACTIONS(5431),
    [anon_sym_constinit] = ACTIONS(5431),
    [anon_sym_consteval] = ACTIONS(5431),
    [anon_sym_alignas] = ACTIONS(5431),
    [anon_sym__Alignas] = ACTIONS(5431),
    [sym_primitive_type] = ACTIONS(5431),
    [anon_sym_COLON] = ACTIONS(5431),
    [anon_sym_QMARK] = ACTIONS(5433),
    [anon_sym_LT_EQ_GT] = ACTIONS(5433),
    [anon_sym_or] = ACTIONS(5431),
    [anon_sym_and] = ACTIONS(5431),
    [anon_sym_bitor] = ACTIONS(5431),
    [anon_sym_xor] = ACTIONS(5431),
    [anon_sym_bitand] = ACTIONS(5431),
    [anon_sym_not_eq] = ACTIONS(5431),
    [anon_sym_DASH_DASH] = ACTIONS(5433),
    [anon_sym_PLUS_PLUS] = ACTIONS(5433),
    [anon_sym_DOT] = ACTIONS(5431),
    [anon_sym_DOT_STAR] = ACTIONS(5433),
    [anon_sym_DASH_GT] = ACTIONS(5433),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5431),
    [anon_sym_decltype] = ACTIONS(5431),
    [anon_sym_final] = ACTIONS(5431),
    [anon_sym_override] = ACTIONS(5431),
    [anon_sym_requires] = ACTIONS(5431),
  },
  [1756] = {
    [sym_identifier] = ACTIONS(5419),
    [aux_sym_preproc_def_token1] = ACTIONS(5419),
    [aux_sym_preproc_if_token1] = ACTIONS(5419),
    [aux_sym_preproc_if_token2] = ACTIONS(5419),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5419),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5419),
    [aux_sym_preproc_else_token1] = ACTIONS(5419),
    [aux_sym_preproc_elif_token1] = ACTIONS(5419),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5419),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5419),
    [sym_preproc_directive] = ACTIONS(5419),
    [anon_sym_LPAREN2] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5421),
    [anon_sym_STAR] = ACTIONS(5421),
    [anon_sym_AMP_AMP] = ACTIONS(5421),
    [anon_sym_AMP] = ACTIONS(5419),
    [anon_sym_SEMI] = ACTIONS(5421),
    [anon_sym___extension__] = ACTIONS(5419),
    [anon_sym_typedef] = ACTIONS(5419),
    [anon_sym_virtual] = ACTIONS(5419),
    [anon_sym_extern] = ACTIONS(5419),
    [anon_sym___attribute__] = ACTIONS(5419),
    [anon_sym___attribute] = ACTIONS(5419),
    [anon_sym_COLON_COLON] = ACTIONS(5421),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5421),
    [anon_sym___declspec] = ACTIONS(5419),
    [anon_sym___based] = ACTIONS(5419),
    [anon_sym_signed] = ACTIONS(5419),
    [anon_sym_unsigned] = ACTIONS(5419),
    [anon_sym_long] = ACTIONS(5419),
    [anon_sym_short] = ACTIONS(5419),
    [anon_sym_LBRACK] = ACTIONS(5419),
    [anon_sym_static] = ACTIONS(5419),
    [anon_sym_register] = ACTIONS(5419),
    [anon_sym_inline] = ACTIONS(5419),
    [anon_sym___inline] = ACTIONS(5419),
    [anon_sym___inline__] = ACTIONS(5419),
    [anon_sym___forceinline] = ACTIONS(5419),
    [anon_sym_thread_local] = ACTIONS(5419),
    [anon_sym___thread] = ACTIONS(5419),
    [anon_sym_const] = ACTIONS(5419),
    [anon_sym_constexpr] = ACTIONS(5419),
    [anon_sym_volatile] = ACTIONS(5419),
    [anon_sym_restrict] = ACTIONS(5419),
    [anon_sym___restrict__] = ACTIONS(5419),
    [anon_sym__Atomic] = ACTIONS(5419),
    [anon_sym__Noreturn] = ACTIONS(5419),
    [anon_sym_noreturn] = ACTIONS(5419),
    [anon_sym__Nonnull] = ACTIONS(5419),
    [anon_sym_mutable] = ACTIONS(5419),
    [anon_sym_constinit] = ACTIONS(5419),
    [anon_sym_consteval] = ACTIONS(5419),
    [anon_sym_alignas] = ACTIONS(5419),
    [anon_sym__Alignas] = ACTIONS(5419),
    [sym_primitive_type] = ACTIONS(5419),
    [anon_sym_enum] = ACTIONS(5419),
    [anon_sym_class] = ACTIONS(5419),
    [anon_sym_struct] = ACTIONS(5419),
    [anon_sym_union] = ACTIONS(5419),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5419),
    [anon_sym_decltype] = ACTIONS(5419),
    [anon_sym_explicit] = ACTIONS(5419),
    [anon_sym_typename] = ACTIONS(5419),
    [anon_sym_template] = ACTIONS(5419),
    [anon_sym_operator] = ACTIONS(5419),
    [anon_sym_friend] = ACTIONS(5419),
    [anon_sym_public] = ACTIONS(5419),
    [anon_sym_private] = ACTIONS(5419),
    [anon_sym_protected] = ACTIONS(5419),
    [anon_sym_using] = ACTIONS(5419),
    [anon_sym_static_assert] = ACTIONS(5419),
  },
  [1757] = {
    [sym_identifier] = ACTIONS(2633),
    [aux_sym_preproc_def_token1] = ACTIONS(2633),
    [aux_sym_preproc_if_token1] = ACTIONS(2633),
    [aux_sym_preproc_if_token2] = ACTIONS(2633),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2633),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2633),
    [aux_sym_preproc_else_token1] = ACTIONS(2633),
    [aux_sym_preproc_elif_token1] = ACTIONS(2633),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2633),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2633),
    [sym_preproc_directive] = ACTIONS(2633),
    [anon_sym_LPAREN2] = ACTIONS(2635),
    [anon_sym_TILDE] = ACTIONS(2635),
    [anon_sym_STAR] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2635),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_SEMI] = ACTIONS(2635),
    [anon_sym___extension__] = ACTIONS(2633),
    [anon_sym_typedef] = ACTIONS(2633),
    [anon_sym_virtual] = ACTIONS(2633),
    [anon_sym_extern] = ACTIONS(2633),
    [anon_sym___attribute__] = ACTIONS(2633),
    [anon_sym___attribute] = ACTIONS(2633),
    [anon_sym_COLON_COLON] = ACTIONS(2635),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2635),
    [anon_sym___declspec] = ACTIONS(2633),
    [anon_sym___based] = ACTIONS(2633),
    [anon_sym_signed] = ACTIONS(2633),
    [anon_sym_unsigned] = ACTIONS(2633),
    [anon_sym_long] = ACTIONS(2633),
    [anon_sym_short] = ACTIONS(2633),
    [anon_sym_LBRACK] = ACTIONS(2633),
    [anon_sym_static] = ACTIONS(2633),
    [anon_sym_register] = ACTIONS(2633),
    [anon_sym_inline] = ACTIONS(2633),
    [anon_sym___inline] = ACTIONS(2633),
    [anon_sym___inline__] = ACTIONS(2633),
    [anon_sym___forceinline] = ACTIONS(2633),
    [anon_sym_thread_local] = ACTIONS(2633),
    [anon_sym___thread] = ACTIONS(2633),
    [anon_sym_const] = ACTIONS(2633),
    [anon_sym_constexpr] = ACTIONS(2633),
    [anon_sym_volatile] = ACTIONS(2633),
    [anon_sym_restrict] = ACTIONS(2633),
    [anon_sym___restrict__] = ACTIONS(2633),
    [anon_sym__Atomic] = ACTIONS(2633),
    [anon_sym__Noreturn] = ACTIONS(2633),
    [anon_sym_noreturn] = ACTIONS(2633),
    [anon_sym__Nonnull] = ACTIONS(2633),
    [anon_sym_mutable] = ACTIONS(2633),
    [anon_sym_constinit] = ACTIONS(2633),
    [anon_sym_consteval] = ACTIONS(2633),
    [anon_sym_alignas] = ACTIONS(2633),
    [anon_sym__Alignas] = ACTIONS(2633),
    [sym_primitive_type] = ACTIONS(2633),
    [anon_sym_enum] = ACTIONS(2633),
    [anon_sym_class] = ACTIONS(2633),
    [anon_sym_struct] = ACTIONS(2633),
    [anon_sym_union] = ACTIONS(2633),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2633),
    [anon_sym_decltype] = ACTIONS(2633),
    [anon_sym_explicit] = ACTIONS(2633),
    [anon_sym_typename] = ACTIONS(2633),
    [anon_sym_template] = ACTIONS(2633),
    [anon_sym_operator] = ACTIONS(2633),
    [anon_sym_friend] = ACTIONS(2633),
    [anon_sym_public] = ACTIONS(2633),
    [anon_sym_private] = ACTIONS(2633),
    [anon_sym_protected] = ACTIONS(2633),
    [anon_sym_using] = ACTIONS(2633),
    [anon_sym_static_assert] = ACTIONS(2633),
  },
  [1758] = {
    [sym_identifier] = ACTIONS(2637),
    [aux_sym_preproc_def_token1] = ACTIONS(2637),
    [aux_sym_preproc_if_token1] = ACTIONS(2637),
    [aux_sym_preproc_if_token2] = ACTIONS(2637),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2637),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2637),
    [aux_sym_preproc_else_token1] = ACTIONS(2637),
    [aux_sym_preproc_elif_token1] = ACTIONS(2637),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2637),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2637),
    [sym_preproc_directive] = ACTIONS(2637),
    [anon_sym_LPAREN2] = ACTIONS(2639),
    [anon_sym_TILDE] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(2639),
    [anon_sym_AMP_AMP] = ACTIONS(2639),
    [anon_sym_AMP] = ACTIONS(2637),
    [anon_sym_SEMI] = ACTIONS(2639),
    [anon_sym___extension__] = ACTIONS(2637),
    [anon_sym_typedef] = ACTIONS(2637),
    [anon_sym_virtual] = ACTIONS(2637),
    [anon_sym_extern] = ACTIONS(2637),
    [anon_sym___attribute__] = ACTIONS(2637),
    [anon_sym___attribute] = ACTIONS(2637),
    [anon_sym_COLON_COLON] = ACTIONS(2639),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2639),
    [anon_sym___declspec] = ACTIONS(2637),
    [anon_sym___based] = ACTIONS(2637),
    [anon_sym_signed] = ACTIONS(2637),
    [anon_sym_unsigned] = ACTIONS(2637),
    [anon_sym_long] = ACTIONS(2637),
    [anon_sym_short] = ACTIONS(2637),
    [anon_sym_LBRACK] = ACTIONS(2637),
    [anon_sym_static] = ACTIONS(2637),
    [anon_sym_register] = ACTIONS(2637),
    [anon_sym_inline] = ACTIONS(2637),
    [anon_sym___inline] = ACTIONS(2637),
    [anon_sym___inline__] = ACTIONS(2637),
    [anon_sym___forceinline] = ACTIONS(2637),
    [anon_sym_thread_local] = ACTIONS(2637),
    [anon_sym___thread] = ACTIONS(2637),
    [anon_sym_const] = ACTIONS(2637),
    [anon_sym_constexpr] = ACTIONS(2637),
    [anon_sym_volatile] = ACTIONS(2637),
    [anon_sym_restrict] = ACTIONS(2637),
    [anon_sym___restrict__] = ACTIONS(2637),
    [anon_sym__Atomic] = ACTIONS(2637),
    [anon_sym__Noreturn] = ACTIONS(2637),
    [anon_sym_noreturn] = ACTIONS(2637),
    [anon_sym__Nonnull] = ACTIONS(2637),
    [anon_sym_mutable] = ACTIONS(2637),
    [anon_sym_constinit] = ACTIONS(2637),
    [anon_sym_consteval] = ACTIONS(2637),
    [anon_sym_alignas] = ACTIONS(2637),
    [anon_sym__Alignas] = ACTIONS(2637),
    [sym_primitive_type] = ACTIONS(2637),
    [anon_sym_enum] = ACTIONS(2637),
    [anon_sym_class] = ACTIONS(2637),
    [anon_sym_struct] = ACTIONS(2637),
    [anon_sym_union] = ACTIONS(2637),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2637),
    [anon_sym_decltype] = ACTIONS(2637),
    [anon_sym_explicit] = ACTIONS(2637),
    [anon_sym_typename] = ACTIONS(2637),
    [anon_sym_template] = ACTIONS(2637),
    [anon_sym_operator] = ACTIONS(2637),
    [anon_sym_friend] = ACTIONS(2637),
    [anon_sym_public] = ACTIONS(2637),
    [anon_sym_private] = ACTIONS(2637),
    [anon_sym_protected] = ACTIONS(2637),
    [anon_sym_using] = ACTIONS(2637),
    [anon_sym_static_assert] = ACTIONS(2637),
  },
  [1759] = {
    [sym_identifier] = ACTIONS(2637),
    [aux_sym_preproc_def_token1] = ACTIONS(2637),
    [aux_sym_preproc_if_token1] = ACTIONS(2637),
    [aux_sym_preproc_if_token2] = ACTIONS(2637),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2637),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2637),
    [aux_sym_preproc_else_token1] = ACTIONS(2637),
    [aux_sym_preproc_elif_token1] = ACTIONS(2637),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2637),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2637),
    [sym_preproc_directive] = ACTIONS(2637),
    [anon_sym_LPAREN2] = ACTIONS(2639),
    [anon_sym_TILDE] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(2639),
    [anon_sym_AMP_AMP] = ACTIONS(2639),
    [anon_sym_AMP] = ACTIONS(2637),
    [anon_sym_SEMI] = ACTIONS(2639),
    [anon_sym___extension__] = ACTIONS(2637),
    [anon_sym_typedef] = ACTIONS(2637),
    [anon_sym_virtual] = ACTIONS(2637),
    [anon_sym_extern] = ACTIONS(2637),
    [anon_sym___attribute__] = ACTIONS(2637),
    [anon_sym___attribute] = ACTIONS(2637),
    [anon_sym_COLON_COLON] = ACTIONS(2639),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2639),
    [anon_sym___declspec] = ACTIONS(2637),
    [anon_sym___based] = ACTIONS(2637),
    [anon_sym_signed] = ACTIONS(2637),
    [anon_sym_unsigned] = ACTIONS(2637),
    [anon_sym_long] = ACTIONS(2637),
    [anon_sym_short] = ACTIONS(2637),
    [anon_sym_LBRACK] = ACTIONS(2637),
    [anon_sym_static] = ACTIONS(2637),
    [anon_sym_register] = ACTIONS(2637),
    [anon_sym_inline] = ACTIONS(2637),
    [anon_sym___inline] = ACTIONS(2637),
    [anon_sym___inline__] = ACTIONS(2637),
    [anon_sym___forceinline] = ACTIONS(2637),
    [anon_sym_thread_local] = ACTIONS(2637),
    [anon_sym___thread] = ACTIONS(2637),
    [anon_sym_const] = ACTIONS(2637),
    [anon_sym_constexpr] = ACTIONS(2637),
    [anon_sym_volatile] = ACTIONS(2637),
    [anon_sym_restrict] = ACTIONS(2637),
    [anon_sym___restrict__] = ACTIONS(2637),
    [anon_sym__Atomic] = ACTIONS(2637),
    [anon_sym__Noreturn] = ACTIONS(2637),
    [anon_sym_noreturn] = ACTIONS(2637),
    [anon_sym__Nonnull] = ACTIONS(2637),
    [anon_sym_mutable] = ACTIONS(2637),
    [anon_sym_constinit] = ACTIONS(2637),
    [anon_sym_consteval] = ACTIONS(2637),
    [anon_sym_alignas] = ACTIONS(2637),
    [anon_sym__Alignas] = ACTIONS(2637),
    [sym_primitive_type] = ACTIONS(2637),
    [anon_sym_enum] = ACTIONS(2637),
    [anon_sym_class] = ACTIONS(2637),
    [anon_sym_struct] = ACTIONS(2637),
    [anon_sym_union] = ACTIONS(2637),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2637),
    [anon_sym_decltype] = ACTIONS(2637),
    [anon_sym_explicit] = ACTIONS(2637),
    [anon_sym_typename] = ACTIONS(2637),
    [anon_sym_template] = ACTIONS(2637),
    [anon_sym_operator] = ACTIONS(2637),
    [anon_sym_friend] = ACTIONS(2637),
    [anon_sym_public] = ACTIONS(2637),
    [anon_sym_private] = ACTIONS(2637),
    [anon_sym_protected] = ACTIONS(2637),
    [anon_sym_using] = ACTIONS(2637),
    [anon_sym_static_assert] = ACTIONS(2637),
  },
  [1760] = {
    [sym_identifier] = ACTIONS(2805),
    [aux_sym_preproc_def_token1] = ACTIONS(2805),
    [aux_sym_preproc_if_token1] = ACTIONS(2805),
    [aux_sym_preproc_if_token2] = ACTIONS(2805),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2805),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2805),
    [aux_sym_preproc_else_token1] = ACTIONS(2805),
    [aux_sym_preproc_elif_token1] = ACTIONS(2805),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2805),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2805),
    [sym_preproc_directive] = ACTIONS(2805),
    [anon_sym_LPAREN2] = ACTIONS(2807),
    [anon_sym_TILDE] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2805),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym___extension__] = ACTIONS(2805),
    [anon_sym_typedef] = ACTIONS(2805),
    [anon_sym_virtual] = ACTIONS(2805),
    [anon_sym_extern] = ACTIONS(2805),
    [anon_sym___attribute__] = ACTIONS(2805),
    [anon_sym___attribute] = ACTIONS(2805),
    [anon_sym_COLON_COLON] = ACTIONS(2807),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2807),
    [anon_sym___declspec] = ACTIONS(2805),
    [anon_sym___based] = ACTIONS(2805),
    [anon_sym_signed] = ACTIONS(2805),
    [anon_sym_unsigned] = ACTIONS(2805),
    [anon_sym_long] = ACTIONS(2805),
    [anon_sym_short] = ACTIONS(2805),
    [anon_sym_LBRACK] = ACTIONS(2805),
    [anon_sym_static] = ACTIONS(2805),
    [anon_sym_register] = ACTIONS(2805),
    [anon_sym_inline] = ACTIONS(2805),
    [anon_sym___inline] = ACTIONS(2805),
    [anon_sym___inline__] = ACTIONS(2805),
    [anon_sym___forceinline] = ACTIONS(2805),
    [anon_sym_thread_local] = ACTIONS(2805),
    [anon_sym___thread] = ACTIONS(2805),
    [anon_sym_const] = ACTIONS(2805),
    [anon_sym_constexpr] = ACTIONS(2805),
    [anon_sym_volatile] = ACTIONS(2805),
    [anon_sym_restrict] = ACTIONS(2805),
    [anon_sym___restrict__] = ACTIONS(2805),
    [anon_sym__Atomic] = ACTIONS(2805),
    [anon_sym__Noreturn] = ACTIONS(2805),
    [anon_sym_noreturn] = ACTIONS(2805),
    [anon_sym__Nonnull] = ACTIONS(2805),
    [anon_sym_mutable] = ACTIONS(2805),
    [anon_sym_constinit] = ACTIONS(2805),
    [anon_sym_consteval] = ACTIONS(2805),
    [anon_sym_alignas] = ACTIONS(2805),
    [anon_sym__Alignas] = ACTIONS(2805),
    [sym_primitive_type] = ACTIONS(2805),
    [anon_sym_enum] = ACTIONS(2805),
    [anon_sym_class] = ACTIONS(2805),
    [anon_sym_struct] = ACTIONS(2805),
    [anon_sym_union] = ACTIONS(2805),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2805),
    [anon_sym_decltype] = ACTIONS(2805),
    [anon_sym_explicit] = ACTIONS(2805),
    [anon_sym_typename] = ACTIONS(2805),
    [anon_sym_template] = ACTIONS(2805),
    [anon_sym_operator] = ACTIONS(2805),
    [anon_sym_friend] = ACTIONS(2805),
    [anon_sym_public] = ACTIONS(2805),
    [anon_sym_private] = ACTIONS(2805),
    [anon_sym_protected] = ACTIONS(2805),
    [anon_sym_using] = ACTIONS(2805),
    [anon_sym_static_assert] = ACTIONS(2805),
  },
  [1761] = {
    [sym_identifier] = ACTIONS(2809),
    [aux_sym_preproc_def_token1] = ACTIONS(2809),
    [aux_sym_preproc_if_token1] = ACTIONS(2809),
    [aux_sym_preproc_if_token2] = ACTIONS(2809),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2809),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2809),
    [aux_sym_preproc_else_token1] = ACTIONS(2809),
    [aux_sym_preproc_elif_token1] = ACTIONS(2809),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2809),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2809),
    [sym_preproc_directive] = ACTIONS(2809),
    [anon_sym_LPAREN2] = ACTIONS(2811),
    [anon_sym_TILDE] = ACTIONS(2811),
    [anon_sym_STAR] = ACTIONS(2811),
    [anon_sym_AMP_AMP] = ACTIONS(2811),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2811),
    [anon_sym___extension__] = ACTIONS(2809),
    [anon_sym_typedef] = ACTIONS(2809),
    [anon_sym_virtual] = ACTIONS(2809),
    [anon_sym_extern] = ACTIONS(2809),
    [anon_sym___attribute__] = ACTIONS(2809),
    [anon_sym___attribute] = ACTIONS(2809),
    [anon_sym_COLON_COLON] = ACTIONS(2811),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2811),
    [anon_sym___declspec] = ACTIONS(2809),
    [anon_sym___based] = ACTIONS(2809),
    [anon_sym_signed] = ACTIONS(2809),
    [anon_sym_unsigned] = ACTIONS(2809),
    [anon_sym_long] = ACTIONS(2809),
    [anon_sym_short] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2809),
    [anon_sym_static] = ACTIONS(2809),
    [anon_sym_register] = ACTIONS(2809),
    [anon_sym_inline] = ACTIONS(2809),
    [anon_sym___inline] = ACTIONS(2809),
    [anon_sym___inline__] = ACTIONS(2809),
    [anon_sym___forceinline] = ACTIONS(2809),
    [anon_sym_thread_local] = ACTIONS(2809),
    [anon_sym___thread] = ACTIONS(2809),
    [anon_sym_const] = ACTIONS(2809),
    [anon_sym_constexpr] = ACTIONS(2809),
    [anon_sym_volatile] = ACTIONS(2809),
    [anon_sym_restrict] = ACTIONS(2809),
    [anon_sym___restrict__] = ACTIONS(2809),
    [anon_sym__Atomic] = ACTIONS(2809),
    [anon_sym__Noreturn] = ACTIONS(2809),
    [anon_sym_noreturn] = ACTIONS(2809),
    [anon_sym__Nonnull] = ACTIONS(2809),
    [anon_sym_mutable] = ACTIONS(2809),
    [anon_sym_constinit] = ACTIONS(2809),
    [anon_sym_consteval] = ACTIONS(2809),
    [anon_sym_alignas] = ACTIONS(2809),
    [anon_sym__Alignas] = ACTIONS(2809),
    [sym_primitive_type] = ACTIONS(2809),
    [anon_sym_enum] = ACTIONS(2809),
    [anon_sym_class] = ACTIONS(2809),
    [anon_sym_struct] = ACTIONS(2809),
    [anon_sym_union] = ACTIONS(2809),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2809),
    [anon_sym_decltype] = ACTIONS(2809),
    [anon_sym_explicit] = ACTIONS(2809),
    [anon_sym_typename] = ACTIONS(2809),
    [anon_sym_template] = ACTIONS(2809),
    [anon_sym_operator] = ACTIONS(2809),
    [anon_sym_friend] = ACTIONS(2809),
    [anon_sym_public] = ACTIONS(2809),
    [anon_sym_private] = ACTIONS(2809),
    [anon_sym_protected] = ACTIONS(2809),
    [anon_sym_using] = ACTIONS(2809),
    [anon_sym_static_assert] = ACTIONS(2809),
  },
  [1762] = {
    [sym_identifier] = ACTIONS(4826),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4828),
    [anon_sym_COMMA] = ACTIONS(4828),
    [anon_sym_RPAREN] = ACTIONS(4828),
    [anon_sym_LPAREN2] = ACTIONS(4828),
    [anon_sym_DASH] = ACTIONS(4826),
    [anon_sym_PLUS] = ACTIONS(4826),
    [anon_sym_STAR] = ACTIONS(4828),
    [anon_sym_SLASH] = ACTIONS(4826),
    [anon_sym_PERCENT] = ACTIONS(4828),
    [anon_sym_PIPE_PIPE] = ACTIONS(4828),
    [anon_sym_AMP_AMP] = ACTIONS(4828),
    [anon_sym_PIPE] = ACTIONS(4826),
    [anon_sym_CARET] = ACTIONS(4828),
    [anon_sym_AMP] = ACTIONS(4826),
    [anon_sym_EQ_EQ] = ACTIONS(4828),
    [anon_sym_BANG_EQ] = ACTIONS(4828),
    [anon_sym_GT] = ACTIONS(4826),
    [anon_sym_GT_EQ] = ACTIONS(4828),
    [anon_sym_LT_EQ] = ACTIONS(4826),
    [anon_sym_LT] = ACTIONS(4826),
    [anon_sym_LT_LT] = ACTIONS(4828),
    [anon_sym_GT_GT] = ACTIONS(4828),
    [anon_sym_SEMI] = ACTIONS(4828),
    [anon_sym___extension__] = ACTIONS(4826),
    [anon_sym___attribute__] = ACTIONS(4826),
    [anon_sym___attribute] = ACTIONS(4826),
    [anon_sym_COLON_COLON] = ACTIONS(4828),
    [anon_sym___based] = ACTIONS(4826),
    [anon_sym_LBRACE] = ACTIONS(4828),
    [anon_sym_RBRACE] = ACTIONS(4828),
    [anon_sym_signed] = ACTIONS(4826),
    [anon_sym_unsigned] = ACTIONS(4826),
    [anon_sym_long] = ACTIONS(4826),
    [anon_sym_short] = ACTIONS(4826),
    [anon_sym_LBRACK] = ACTIONS(4828),
    [anon_sym_RBRACK] = ACTIONS(4828),
    [anon_sym_const] = ACTIONS(4826),
    [anon_sym_constexpr] = ACTIONS(4826),
    [anon_sym_volatile] = ACTIONS(4826),
    [anon_sym_restrict] = ACTIONS(4826),
    [anon_sym___restrict__] = ACTIONS(4826),
    [anon_sym__Atomic] = ACTIONS(4826),
    [anon_sym__Noreturn] = ACTIONS(4826),
    [anon_sym_noreturn] = ACTIONS(4826),
    [anon_sym__Nonnull] = ACTIONS(4826),
    [anon_sym_mutable] = ACTIONS(4826),
    [anon_sym_constinit] = ACTIONS(4826),
    [anon_sym_consteval] = ACTIONS(4826),
    [anon_sym_alignas] = ACTIONS(4826),
    [anon_sym__Alignas] = ACTIONS(4826),
    [sym_primitive_type] = ACTIONS(4826),
    [anon_sym_COLON] = ACTIONS(4826),
    [anon_sym_QMARK] = ACTIONS(4828),
    [anon_sym_LT_EQ_GT] = ACTIONS(4828),
    [anon_sym_or] = ACTIONS(4826),
    [anon_sym_and] = ACTIONS(4826),
    [anon_sym_bitor] = ACTIONS(4826),
    [anon_sym_xor] = ACTIONS(4826),
    [anon_sym_bitand] = ACTIONS(4826),
    [anon_sym_not_eq] = ACTIONS(4826),
    [anon_sym_DASH_DASH] = ACTIONS(4828),
    [anon_sym_PLUS_PLUS] = ACTIONS(4828),
    [anon_sym_DOT] = ACTIONS(4826),
    [anon_sym_DOT_STAR] = ACTIONS(4828),
    [anon_sym_DASH_GT] = ACTIONS(4828),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4826),
    [anon_sym_decltype] = ACTIONS(4826),
    [anon_sym_final] = ACTIONS(4826),
    [anon_sym_override] = ACTIONS(4826),
    [anon_sym_requires] = ACTIONS(4826),
  },
  [1763] = {
    [sym_identifier] = ACTIONS(5435),
    [aux_sym_preproc_def_token1] = ACTIONS(5435),
    [aux_sym_preproc_if_token1] = ACTIONS(5435),
    [aux_sym_preproc_if_token2] = ACTIONS(5435),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5435),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5435),
    [aux_sym_preproc_else_token1] = ACTIONS(5435),
    [aux_sym_preproc_elif_token1] = ACTIONS(5435),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5435),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5435),
    [sym_preproc_directive] = ACTIONS(5435),
    [anon_sym_LPAREN2] = ACTIONS(5437),
    [anon_sym_TILDE] = ACTIONS(5437),
    [anon_sym_STAR] = ACTIONS(5437),
    [anon_sym_AMP_AMP] = ACTIONS(5437),
    [anon_sym_AMP] = ACTIONS(5435),
    [anon_sym_SEMI] = ACTIONS(5437),
    [anon_sym___extension__] = ACTIONS(5435),
    [anon_sym_typedef] = ACTIONS(5435),
    [anon_sym_virtual] = ACTIONS(5435),
    [anon_sym_extern] = ACTIONS(5435),
    [anon_sym___attribute__] = ACTIONS(5435),
    [anon_sym___attribute] = ACTIONS(5435),
    [anon_sym_COLON_COLON] = ACTIONS(5437),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5437),
    [anon_sym___declspec] = ACTIONS(5435),
    [anon_sym___based] = ACTIONS(5435),
    [anon_sym_signed] = ACTIONS(5435),
    [anon_sym_unsigned] = ACTIONS(5435),
    [anon_sym_long] = ACTIONS(5435),
    [anon_sym_short] = ACTIONS(5435),
    [anon_sym_LBRACK] = ACTIONS(5435),
    [anon_sym_static] = ACTIONS(5435),
    [anon_sym_register] = ACTIONS(5435),
    [anon_sym_inline] = ACTIONS(5435),
    [anon_sym___inline] = ACTIONS(5435),
    [anon_sym___inline__] = ACTIONS(5435),
    [anon_sym___forceinline] = ACTIONS(5435),
    [anon_sym_thread_local] = ACTIONS(5435),
    [anon_sym___thread] = ACTIONS(5435),
    [anon_sym_const] = ACTIONS(5435),
    [anon_sym_constexpr] = ACTIONS(5435),
    [anon_sym_volatile] = ACTIONS(5435),
    [anon_sym_restrict] = ACTIONS(5435),
    [anon_sym___restrict__] = ACTIONS(5435),
    [anon_sym__Atomic] = ACTIONS(5435),
    [anon_sym__Noreturn] = ACTIONS(5435),
    [anon_sym_noreturn] = ACTIONS(5435),
    [anon_sym__Nonnull] = ACTIONS(5435),
    [anon_sym_mutable] = ACTIONS(5435),
    [anon_sym_constinit] = ACTIONS(5435),
    [anon_sym_consteval] = ACTIONS(5435),
    [anon_sym_alignas] = ACTIONS(5435),
    [anon_sym__Alignas] = ACTIONS(5435),
    [sym_primitive_type] = ACTIONS(5435),
    [anon_sym_enum] = ACTIONS(5435),
    [anon_sym_class] = ACTIONS(5435),
    [anon_sym_struct] = ACTIONS(5435),
    [anon_sym_union] = ACTIONS(5435),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5435),
    [anon_sym_decltype] = ACTIONS(5435),
    [anon_sym_explicit] = ACTIONS(5435),
    [anon_sym_typename] = ACTIONS(5435),
    [anon_sym_template] = ACTIONS(5435),
    [anon_sym_operator] = ACTIONS(5435),
    [anon_sym_friend] = ACTIONS(5435),
    [anon_sym_public] = ACTIONS(5435),
    [anon_sym_private] = ACTIONS(5435),
    [anon_sym_protected] = ACTIONS(5435),
    [anon_sym_using] = ACTIONS(5435),
    [anon_sym_static_assert] = ACTIONS(5435),
  },
  [1764] = {
    [sym_identifier] = ACTIONS(5439),
    [aux_sym_preproc_def_token1] = ACTIONS(5439),
    [aux_sym_preproc_if_token1] = ACTIONS(5439),
    [aux_sym_preproc_if_token2] = ACTIONS(5439),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5439),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5439),
    [aux_sym_preproc_else_token1] = ACTIONS(5439),
    [aux_sym_preproc_elif_token1] = ACTIONS(5439),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5439),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5439),
    [sym_preproc_directive] = ACTIONS(5439),
    [anon_sym_LPAREN2] = ACTIONS(5441),
    [anon_sym_TILDE] = ACTIONS(5441),
    [anon_sym_STAR] = ACTIONS(5441),
    [anon_sym_AMP_AMP] = ACTIONS(5441),
    [anon_sym_AMP] = ACTIONS(5439),
    [anon_sym_SEMI] = ACTIONS(5441),
    [anon_sym___extension__] = ACTIONS(5439),
    [anon_sym_typedef] = ACTIONS(5439),
    [anon_sym_virtual] = ACTIONS(5439),
    [anon_sym_extern] = ACTIONS(5439),
    [anon_sym___attribute__] = ACTIONS(5439),
    [anon_sym___attribute] = ACTIONS(5439),
    [anon_sym_COLON_COLON] = ACTIONS(5441),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5441),
    [anon_sym___declspec] = ACTIONS(5439),
    [anon_sym___based] = ACTIONS(5439),
    [anon_sym_signed] = ACTIONS(5439),
    [anon_sym_unsigned] = ACTIONS(5439),
    [anon_sym_long] = ACTIONS(5439),
    [anon_sym_short] = ACTIONS(5439),
    [anon_sym_LBRACK] = ACTIONS(5439),
    [anon_sym_static] = ACTIONS(5439),
    [anon_sym_register] = ACTIONS(5439),
    [anon_sym_inline] = ACTIONS(5439),
    [anon_sym___inline] = ACTIONS(5439),
    [anon_sym___inline__] = ACTIONS(5439),
    [anon_sym___forceinline] = ACTIONS(5439),
    [anon_sym_thread_local] = ACTIONS(5439),
    [anon_sym___thread] = ACTIONS(5439),
    [anon_sym_const] = ACTIONS(5439),
    [anon_sym_constexpr] = ACTIONS(5439),
    [anon_sym_volatile] = ACTIONS(5439),
    [anon_sym_restrict] = ACTIONS(5439),
    [anon_sym___restrict__] = ACTIONS(5439),
    [anon_sym__Atomic] = ACTIONS(5439),
    [anon_sym__Noreturn] = ACTIONS(5439),
    [anon_sym_noreturn] = ACTIONS(5439),
    [anon_sym__Nonnull] = ACTIONS(5439),
    [anon_sym_mutable] = ACTIONS(5439),
    [anon_sym_constinit] = ACTIONS(5439),
    [anon_sym_consteval] = ACTIONS(5439),
    [anon_sym_alignas] = ACTIONS(5439),
    [anon_sym__Alignas] = ACTIONS(5439),
    [sym_primitive_type] = ACTIONS(5439),
    [anon_sym_enum] = ACTIONS(5439),
    [anon_sym_class] = ACTIONS(5439),
    [anon_sym_struct] = ACTIONS(5439),
    [anon_sym_union] = ACTIONS(5439),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5439),
    [anon_sym_decltype] = ACTIONS(5439),
    [anon_sym_explicit] = ACTIONS(5439),
    [anon_sym_typename] = ACTIONS(5439),
    [anon_sym_template] = ACTIONS(5439),
    [anon_sym_operator] = ACTIONS(5439),
    [anon_sym_friend] = ACTIONS(5439),
    [anon_sym_public] = ACTIONS(5439),
    [anon_sym_private] = ACTIONS(5439),
    [anon_sym_protected] = ACTIONS(5439),
    [anon_sym_using] = ACTIONS(5439),
    [anon_sym_static_assert] = ACTIONS(5439),
  },
  [1765] = {
    [sym_identifier] = ACTIONS(4818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4820),
    [anon_sym_COMMA] = ACTIONS(4820),
    [anon_sym_RPAREN] = ACTIONS(4820),
    [anon_sym_LPAREN2] = ACTIONS(4820),
    [anon_sym_DASH] = ACTIONS(4818),
    [anon_sym_PLUS] = ACTIONS(4818),
    [anon_sym_STAR] = ACTIONS(4820),
    [anon_sym_SLASH] = ACTIONS(4818),
    [anon_sym_PERCENT] = ACTIONS(4820),
    [anon_sym_PIPE_PIPE] = ACTIONS(4820),
    [anon_sym_AMP_AMP] = ACTIONS(4820),
    [anon_sym_PIPE] = ACTIONS(4818),
    [anon_sym_CARET] = ACTIONS(4820),
    [anon_sym_AMP] = ACTIONS(4818),
    [anon_sym_EQ_EQ] = ACTIONS(4820),
    [anon_sym_BANG_EQ] = ACTIONS(4820),
    [anon_sym_GT] = ACTIONS(4818),
    [anon_sym_GT_EQ] = ACTIONS(4820),
    [anon_sym_LT_EQ] = ACTIONS(4818),
    [anon_sym_LT] = ACTIONS(4818),
    [anon_sym_LT_LT] = ACTIONS(4820),
    [anon_sym_GT_GT] = ACTIONS(4820),
    [anon_sym_SEMI] = ACTIONS(4820),
    [anon_sym___extension__] = ACTIONS(4818),
    [anon_sym___attribute__] = ACTIONS(4818),
    [anon_sym___attribute] = ACTIONS(4818),
    [anon_sym_COLON_COLON] = ACTIONS(4820),
    [anon_sym___based] = ACTIONS(4818),
    [anon_sym_LBRACE] = ACTIONS(4820),
    [anon_sym_RBRACE] = ACTIONS(4820),
    [anon_sym_signed] = ACTIONS(4818),
    [anon_sym_unsigned] = ACTIONS(4818),
    [anon_sym_long] = ACTIONS(4818),
    [anon_sym_short] = ACTIONS(4818),
    [anon_sym_LBRACK] = ACTIONS(4820),
    [anon_sym_RBRACK] = ACTIONS(4820),
    [anon_sym_const] = ACTIONS(4818),
    [anon_sym_constexpr] = ACTIONS(4818),
    [anon_sym_volatile] = ACTIONS(4818),
    [anon_sym_restrict] = ACTIONS(4818),
    [anon_sym___restrict__] = ACTIONS(4818),
    [anon_sym__Atomic] = ACTIONS(4818),
    [anon_sym__Noreturn] = ACTIONS(4818),
    [anon_sym_noreturn] = ACTIONS(4818),
    [anon_sym__Nonnull] = ACTIONS(4818),
    [anon_sym_mutable] = ACTIONS(4818),
    [anon_sym_constinit] = ACTIONS(4818),
    [anon_sym_consteval] = ACTIONS(4818),
    [anon_sym_alignas] = ACTIONS(4818),
    [anon_sym__Alignas] = ACTIONS(4818),
    [sym_primitive_type] = ACTIONS(4818),
    [anon_sym_COLON] = ACTIONS(4818),
    [anon_sym_QMARK] = ACTIONS(4820),
    [anon_sym_LT_EQ_GT] = ACTIONS(4820),
    [anon_sym_or] = ACTIONS(4818),
    [anon_sym_and] = ACTIONS(4818),
    [anon_sym_bitor] = ACTIONS(4818),
    [anon_sym_xor] = ACTIONS(4818),
    [anon_sym_bitand] = ACTIONS(4818),
    [anon_sym_not_eq] = ACTIONS(4818),
    [anon_sym_DASH_DASH] = ACTIONS(4820),
    [anon_sym_PLUS_PLUS] = ACTIONS(4820),
    [anon_sym_DOT] = ACTIONS(4818),
    [anon_sym_DOT_STAR] = ACTIONS(4820),
    [anon_sym_DASH_GT] = ACTIONS(4820),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4818),
    [anon_sym_decltype] = ACTIONS(4818),
    [anon_sym_final] = ACTIONS(4818),
    [anon_sym_override] = ACTIONS(4818),
    [anon_sym_requires] = ACTIONS(4818),
  },
  [1766] = {
    [sym_identifier] = ACTIONS(5443),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5445),
    [anon_sym_COMMA] = ACTIONS(5445),
    [anon_sym_RPAREN] = ACTIONS(5445),
    [anon_sym_LPAREN2] = ACTIONS(5445),
    [anon_sym_DASH] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5443),
    [anon_sym_STAR] = ACTIONS(5445),
    [anon_sym_SLASH] = ACTIONS(5443),
    [anon_sym_PERCENT] = ACTIONS(5445),
    [anon_sym_PIPE_PIPE] = ACTIONS(5445),
    [anon_sym_AMP_AMP] = ACTIONS(5445),
    [anon_sym_PIPE] = ACTIONS(5443),
    [anon_sym_CARET] = ACTIONS(5445),
    [anon_sym_AMP] = ACTIONS(5443),
    [anon_sym_EQ_EQ] = ACTIONS(5445),
    [anon_sym_BANG_EQ] = ACTIONS(5445),
    [anon_sym_GT] = ACTIONS(5443),
    [anon_sym_GT_EQ] = ACTIONS(5445),
    [anon_sym_LT_EQ] = ACTIONS(5443),
    [anon_sym_LT] = ACTIONS(5443),
    [anon_sym_LT_LT] = ACTIONS(5445),
    [anon_sym_GT_GT] = ACTIONS(5445),
    [anon_sym_SEMI] = ACTIONS(5445),
    [anon_sym___extension__] = ACTIONS(5443),
    [anon_sym___attribute__] = ACTIONS(5443),
    [anon_sym___attribute] = ACTIONS(5443),
    [anon_sym_COLON_COLON] = ACTIONS(5365),
    [anon_sym___based] = ACTIONS(5443),
    [anon_sym_LBRACE] = ACTIONS(5445),
    [anon_sym_RBRACE] = ACTIONS(5445),
    [anon_sym_signed] = ACTIONS(5443),
    [anon_sym_unsigned] = ACTIONS(5443),
    [anon_sym_long] = ACTIONS(5443),
    [anon_sym_short] = ACTIONS(5443),
    [anon_sym_LBRACK] = ACTIONS(5445),
    [anon_sym_RBRACK] = ACTIONS(5445),
    [anon_sym_const] = ACTIONS(5443),
    [anon_sym_constexpr] = ACTIONS(5443),
    [anon_sym_volatile] = ACTIONS(5443),
    [anon_sym_restrict] = ACTIONS(5443),
    [anon_sym___restrict__] = ACTIONS(5443),
    [anon_sym__Atomic] = ACTIONS(5443),
    [anon_sym__Noreturn] = ACTIONS(5443),
    [anon_sym_noreturn] = ACTIONS(5443),
    [anon_sym__Nonnull] = ACTIONS(5443),
    [anon_sym_mutable] = ACTIONS(5443),
    [anon_sym_constinit] = ACTIONS(5443),
    [anon_sym_consteval] = ACTIONS(5443),
    [anon_sym_alignas] = ACTIONS(5443),
    [anon_sym__Alignas] = ACTIONS(5443),
    [sym_primitive_type] = ACTIONS(5443),
    [anon_sym_COLON] = ACTIONS(5443),
    [anon_sym_QMARK] = ACTIONS(5445),
    [anon_sym_LT_EQ_GT] = ACTIONS(5445),
    [anon_sym_or] = ACTIONS(5443),
    [anon_sym_and] = ACTIONS(5443),
    [anon_sym_bitor] = ACTIONS(5443),
    [anon_sym_xor] = ACTIONS(5443),
    [anon_sym_bitand] = ACTIONS(5443),
    [anon_sym_not_eq] = ACTIONS(5443),
    [anon_sym_DASH_DASH] = ACTIONS(5445),
    [anon_sym_PLUS_PLUS] = ACTIONS(5445),
    [anon_sym_DOT] = ACTIONS(5443),
    [anon_sym_DOT_STAR] = ACTIONS(5445),
    [anon_sym_DASH_GT] = ACTIONS(5445),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5443),
    [anon_sym_decltype] = ACTIONS(5443),
    [anon_sym_final] = ACTIONS(5443),
    [anon_sym_override] = ACTIONS(5443),
    [anon_sym_requires] = ACTIONS(5443),
  },
  [1767] = {
    [sym_identifier] = ACTIONS(2681),
    [aux_sym_preproc_def_token1] = ACTIONS(2681),
    [aux_sym_preproc_if_token1] = ACTIONS(2681),
    [aux_sym_preproc_if_token2] = ACTIONS(2681),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2681),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2681),
    [aux_sym_preproc_else_token1] = ACTIONS(2681),
    [aux_sym_preproc_elif_token1] = ACTIONS(2681),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2681),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2681),
    [sym_preproc_directive] = ACTIONS(2681),
    [anon_sym_LPAREN2] = ACTIONS(2683),
    [anon_sym_TILDE] = ACTIONS(2683),
    [anon_sym_STAR] = ACTIONS(2683),
    [anon_sym_AMP_AMP] = ACTIONS(2683),
    [anon_sym_AMP] = ACTIONS(2681),
    [anon_sym_SEMI] = ACTIONS(2683),
    [anon_sym___extension__] = ACTIONS(2681),
    [anon_sym_typedef] = ACTIONS(2681),
    [anon_sym_virtual] = ACTIONS(2681),
    [anon_sym_extern] = ACTIONS(2681),
    [anon_sym___attribute__] = ACTIONS(2681),
    [anon_sym___attribute] = ACTIONS(2681),
    [anon_sym_COLON_COLON] = ACTIONS(2683),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2683),
    [anon_sym___declspec] = ACTIONS(2681),
    [anon_sym___based] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2681),
    [anon_sym_unsigned] = ACTIONS(2681),
    [anon_sym_long] = ACTIONS(2681),
    [anon_sym_short] = ACTIONS(2681),
    [anon_sym_LBRACK] = ACTIONS(2681),
    [anon_sym_static] = ACTIONS(2681),
    [anon_sym_register] = ACTIONS(2681),
    [anon_sym_inline] = ACTIONS(2681),
    [anon_sym___inline] = ACTIONS(2681),
    [anon_sym___inline__] = ACTIONS(2681),
    [anon_sym___forceinline] = ACTIONS(2681),
    [anon_sym_thread_local] = ACTIONS(2681),
    [anon_sym___thread] = ACTIONS(2681),
    [anon_sym_const] = ACTIONS(2681),
    [anon_sym_constexpr] = ACTIONS(2681),
    [anon_sym_volatile] = ACTIONS(2681),
    [anon_sym_restrict] = ACTIONS(2681),
    [anon_sym___restrict__] = ACTIONS(2681),
    [anon_sym__Atomic] = ACTIONS(2681),
    [anon_sym__Noreturn] = ACTIONS(2681),
    [anon_sym_noreturn] = ACTIONS(2681),
    [anon_sym__Nonnull] = ACTIONS(2681),
    [anon_sym_mutable] = ACTIONS(2681),
    [anon_sym_constinit] = ACTIONS(2681),
    [anon_sym_consteval] = ACTIONS(2681),
    [anon_sym_alignas] = ACTIONS(2681),
    [anon_sym__Alignas] = ACTIONS(2681),
    [sym_primitive_type] = ACTIONS(2681),
    [anon_sym_enum] = ACTIONS(2681),
    [anon_sym_class] = ACTIONS(2681),
    [anon_sym_struct] = ACTIONS(2681),
    [anon_sym_union] = ACTIONS(2681),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2681),
    [anon_sym_decltype] = ACTIONS(2681),
    [anon_sym_explicit] = ACTIONS(2681),
    [anon_sym_typename] = ACTIONS(2681),
    [anon_sym_template] = ACTIONS(2681),
    [anon_sym_operator] = ACTIONS(2681),
    [anon_sym_friend] = ACTIONS(2681),
    [anon_sym_public] = ACTIONS(2681),
    [anon_sym_private] = ACTIONS(2681),
    [anon_sym_protected] = ACTIONS(2681),
    [anon_sym_using] = ACTIONS(2681),
    [anon_sym_static_assert] = ACTIONS(2681),
  },
  [1768] = {
    [sym_identifier] = ACTIONS(4822),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4824),
    [anon_sym_COMMA] = ACTIONS(4824),
    [anon_sym_RPAREN] = ACTIONS(4824),
    [anon_sym_LPAREN2] = ACTIONS(4824),
    [anon_sym_DASH] = ACTIONS(4822),
    [anon_sym_PLUS] = ACTIONS(4822),
    [anon_sym_STAR] = ACTIONS(4824),
    [anon_sym_SLASH] = ACTIONS(4822),
    [anon_sym_PERCENT] = ACTIONS(4824),
    [anon_sym_PIPE_PIPE] = ACTIONS(4824),
    [anon_sym_AMP_AMP] = ACTIONS(4824),
    [anon_sym_PIPE] = ACTIONS(4822),
    [anon_sym_CARET] = ACTIONS(4824),
    [anon_sym_AMP] = ACTIONS(4822),
    [anon_sym_EQ_EQ] = ACTIONS(4824),
    [anon_sym_BANG_EQ] = ACTIONS(4824),
    [anon_sym_GT] = ACTIONS(4822),
    [anon_sym_GT_EQ] = ACTIONS(4824),
    [anon_sym_LT_EQ] = ACTIONS(4822),
    [anon_sym_LT] = ACTIONS(4822),
    [anon_sym_LT_LT] = ACTIONS(4824),
    [anon_sym_GT_GT] = ACTIONS(4824),
    [anon_sym_SEMI] = ACTIONS(4824),
    [anon_sym___extension__] = ACTIONS(4822),
    [anon_sym___attribute__] = ACTIONS(4822),
    [anon_sym___attribute] = ACTIONS(4822),
    [anon_sym_COLON_COLON] = ACTIONS(4824),
    [anon_sym___based] = ACTIONS(4822),
    [anon_sym_LBRACE] = ACTIONS(4824),
    [anon_sym_RBRACE] = ACTIONS(4824),
    [anon_sym_signed] = ACTIONS(4822),
    [anon_sym_unsigned] = ACTIONS(4822),
    [anon_sym_long] = ACTIONS(4822),
    [anon_sym_short] = ACTIONS(4822),
    [anon_sym_LBRACK] = ACTIONS(4824),
    [anon_sym_RBRACK] = ACTIONS(4824),
    [anon_sym_const] = ACTIONS(4822),
    [anon_sym_constexpr] = ACTIONS(4822),
    [anon_sym_volatile] = ACTIONS(4822),
    [anon_sym_restrict] = ACTIONS(4822),
    [anon_sym___restrict__] = ACTIONS(4822),
    [anon_sym__Atomic] = ACTIONS(4822),
    [anon_sym__Noreturn] = ACTIONS(4822),
    [anon_sym_noreturn] = ACTIONS(4822),
    [anon_sym__Nonnull] = ACTIONS(4822),
    [anon_sym_mutable] = ACTIONS(4822),
    [anon_sym_constinit] = ACTIONS(4822),
    [anon_sym_consteval] = ACTIONS(4822),
    [anon_sym_alignas] = ACTIONS(4822),
    [anon_sym__Alignas] = ACTIONS(4822),
    [sym_primitive_type] = ACTIONS(4822),
    [anon_sym_COLON] = ACTIONS(4822),
    [anon_sym_QMARK] = ACTIONS(4824),
    [anon_sym_LT_EQ_GT] = ACTIONS(4824),
    [anon_sym_or] = ACTIONS(4822),
    [anon_sym_and] = ACTIONS(4822),
    [anon_sym_bitor] = ACTIONS(4822),
    [anon_sym_xor] = ACTIONS(4822),
    [anon_sym_bitand] = ACTIONS(4822),
    [anon_sym_not_eq] = ACTIONS(4822),
    [anon_sym_DASH_DASH] = ACTIONS(4824),
    [anon_sym_PLUS_PLUS] = ACTIONS(4824),
    [anon_sym_DOT] = ACTIONS(4822),
    [anon_sym_DOT_STAR] = ACTIONS(4824),
    [anon_sym_DASH_GT] = ACTIONS(4824),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4822),
    [anon_sym_decltype] = ACTIONS(4822),
    [anon_sym_final] = ACTIONS(4822),
    [anon_sym_override] = ACTIONS(4822),
    [anon_sym_requires] = ACTIONS(4822),
  },
  [1769] = {
    [sym_identifier] = ACTIONS(5447),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5449),
    [anon_sym_COMMA] = ACTIONS(5449),
    [anon_sym_RPAREN] = ACTIONS(5449),
    [aux_sym_preproc_if_token2] = ACTIONS(5449),
    [aux_sym_preproc_else_token1] = ACTIONS(5449),
    [aux_sym_preproc_elif_token1] = ACTIONS(5447),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5449),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5449),
    [anon_sym_LPAREN2] = ACTIONS(5449),
    [anon_sym_DASH] = ACTIONS(5447),
    [anon_sym_PLUS] = ACTIONS(5447),
    [anon_sym_STAR] = ACTIONS(5447),
    [anon_sym_SLASH] = ACTIONS(5447),
    [anon_sym_PERCENT] = ACTIONS(5447),
    [anon_sym_PIPE_PIPE] = ACTIONS(5449),
    [anon_sym_AMP_AMP] = ACTIONS(5449),
    [anon_sym_PIPE] = ACTIONS(5447),
    [anon_sym_CARET] = ACTIONS(5447),
    [anon_sym_AMP] = ACTIONS(5447),
    [anon_sym_EQ_EQ] = ACTIONS(5449),
    [anon_sym_BANG_EQ] = ACTIONS(5449),
    [anon_sym_GT] = ACTIONS(5447),
    [anon_sym_GT_EQ] = ACTIONS(5449),
    [anon_sym_LT_EQ] = ACTIONS(5447),
    [anon_sym_LT] = ACTIONS(5447),
    [anon_sym_LT_LT] = ACTIONS(5447),
    [anon_sym_GT_GT] = ACTIONS(5447),
    [anon_sym_SEMI] = ACTIONS(5449),
    [anon_sym_RBRACE] = ACTIONS(5449),
    [anon_sym_LBRACK] = ACTIONS(5449),
    [anon_sym_RBRACK] = ACTIONS(5449),
    [anon_sym_EQ] = ACTIONS(5447),
    [anon_sym_COLON] = ACTIONS(5449),
    [anon_sym_QMARK] = ACTIONS(5449),
    [anon_sym_STAR_EQ] = ACTIONS(5449),
    [anon_sym_SLASH_EQ] = ACTIONS(5449),
    [anon_sym_PERCENT_EQ] = ACTIONS(5449),
    [anon_sym_PLUS_EQ] = ACTIONS(5449),
    [anon_sym_DASH_EQ] = ACTIONS(5449),
    [anon_sym_LT_LT_EQ] = ACTIONS(5449),
    [anon_sym_GT_GT_EQ] = ACTIONS(5449),
    [anon_sym_AMP_EQ] = ACTIONS(5449),
    [anon_sym_CARET_EQ] = ACTIONS(5449),
    [anon_sym_PIPE_EQ] = ACTIONS(5449),
    [anon_sym_and_eq] = ACTIONS(5447),
    [anon_sym_or_eq] = ACTIONS(5447),
    [anon_sym_xor_eq] = ACTIONS(5447),
    [anon_sym_LT_EQ_GT] = ACTIONS(5449),
    [anon_sym_or] = ACTIONS(5447),
    [anon_sym_and] = ACTIONS(5447),
    [anon_sym_bitor] = ACTIONS(5447),
    [anon_sym_xor] = ACTIONS(5447),
    [anon_sym_bitand] = ACTIONS(5447),
    [anon_sym_not_eq] = ACTIONS(5447),
    [anon_sym_DASH_DASH] = ACTIONS(5449),
    [anon_sym_PLUS_PLUS] = ACTIONS(5449),
    [anon_sym_DOT] = ACTIONS(5447),
    [anon_sym_DOT_STAR] = ACTIONS(5449),
    [anon_sym_DASH_GT] = ACTIONS(5449),
    [anon_sym_L_DQUOTE] = ACTIONS(5449),
    [anon_sym_u_DQUOTE] = ACTIONS(5449),
    [anon_sym_U_DQUOTE] = ACTIONS(5449),
    [anon_sym_u8_DQUOTE] = ACTIONS(5449),
    [anon_sym_DQUOTE] = ACTIONS(5449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5449),
    [anon_sym_LR_DQUOTE] = ACTIONS(5449),
    [anon_sym_uR_DQUOTE] = ACTIONS(5449),
    [anon_sym_UR_DQUOTE] = ACTIONS(5449),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5449),
    [sym_literal_suffix] = ACTIONS(5447),
  },
  [1770] = {
    [sym_template_argument_list] = STATE(1850),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4840),
    [anon_sym_COMMA] = ACTIONS(4840),
    [anon_sym_RPAREN] = ACTIONS(4842),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DASH] = ACTIONS(4847),
    [anon_sym_PLUS] = ACTIONS(4847),
    [anon_sym_STAR] = ACTIONS(4849),
    [anon_sym_SLASH] = ACTIONS(4847),
    [anon_sym_PERCENT] = ACTIONS(4847),
    [anon_sym_PIPE_PIPE] = ACTIONS(4840),
    [anon_sym_AMP_AMP] = ACTIONS(4842),
    [anon_sym_PIPE] = ACTIONS(4847),
    [anon_sym_CARET] = ACTIONS(4847),
    [anon_sym_AMP] = ACTIONS(4849),
    [anon_sym_EQ_EQ] = ACTIONS(4840),
    [anon_sym_BANG_EQ] = ACTIONS(4840),
    [anon_sym_GT] = ACTIONS(4847),
    [anon_sym_GT_EQ] = ACTIONS(4840),
    [anon_sym_LT_EQ] = ACTIONS(4847),
    [anon_sym_LT] = ACTIONS(5451),
    [anon_sym_LT_LT] = ACTIONS(4847),
    [anon_sym_GT_GT] = ACTIONS(4847),
    [anon_sym___extension__] = ACTIONS(4845),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACE] = ACTIONS(4845),
    [anon_sym_LBRACK] = ACTIONS(4842),
    [anon_sym_EQ] = ACTIONS(4847),
    [anon_sym_const] = ACTIONS(4838),
    [anon_sym_constexpr] = ACTIONS(4845),
    [anon_sym_volatile] = ACTIONS(4845),
    [anon_sym_restrict] = ACTIONS(4845),
    [anon_sym___restrict__] = ACTIONS(4845),
    [anon_sym__Atomic] = ACTIONS(4845),
    [anon_sym__Noreturn] = ACTIONS(4845),
    [anon_sym_noreturn] = ACTIONS(4845),
    [anon_sym__Nonnull] = ACTIONS(4845),
    [anon_sym_mutable] = ACTIONS(4845),
    [anon_sym_constinit] = ACTIONS(4845),
    [anon_sym_consteval] = ACTIONS(4845),
    [anon_sym_alignas] = ACTIONS(4845),
    [anon_sym__Alignas] = ACTIONS(4845),
    [anon_sym_QMARK] = ACTIONS(4840),
    [anon_sym_STAR_EQ] = ACTIONS(4840),
    [anon_sym_SLASH_EQ] = ACTIONS(4840),
    [anon_sym_PERCENT_EQ] = ACTIONS(4840),
    [anon_sym_PLUS_EQ] = ACTIONS(4840),
    [anon_sym_DASH_EQ] = ACTIONS(4840),
    [anon_sym_LT_LT_EQ] = ACTIONS(4840),
    [anon_sym_GT_GT_EQ] = ACTIONS(4840),
    [anon_sym_AMP_EQ] = ACTIONS(4840),
    [anon_sym_CARET_EQ] = ACTIONS(4840),
    [anon_sym_PIPE_EQ] = ACTIONS(4840),
    [anon_sym_and_eq] = ACTIONS(4840),
    [anon_sym_or_eq] = ACTIONS(4840),
    [anon_sym_xor_eq] = ACTIONS(4840),
    [anon_sym_LT_EQ_GT] = ACTIONS(4840),
    [anon_sym_or] = ACTIONS(4847),
    [anon_sym_and] = ACTIONS(4847),
    [anon_sym_bitor] = ACTIONS(4840),
    [anon_sym_xor] = ACTIONS(4847),
    [anon_sym_bitand] = ACTIONS(4840),
    [anon_sym_not_eq] = ACTIONS(4840),
    [anon_sym_DASH_DASH] = ACTIONS(4840),
    [anon_sym_PLUS_PLUS] = ACTIONS(4840),
    [anon_sym_DOT] = ACTIONS(4847),
    [anon_sym_DOT_STAR] = ACTIONS(4840),
    [anon_sym_DASH_GT] = ACTIONS(4847),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4845),
    [anon_sym_decltype] = ACTIONS(4845),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4840),
  },
  [1771] = {
    [sym_identifier] = ACTIONS(2818),
    [aux_sym_preproc_def_token1] = ACTIONS(2818),
    [aux_sym_preproc_if_token1] = ACTIONS(2818),
    [aux_sym_preproc_if_token2] = ACTIONS(2818),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2818),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2818),
    [aux_sym_preproc_else_token1] = ACTIONS(2818),
    [aux_sym_preproc_elif_token1] = ACTIONS(2818),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2818),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2818),
    [sym_preproc_directive] = ACTIONS(2818),
    [anon_sym_LPAREN2] = ACTIONS(2820),
    [anon_sym_TILDE] = ACTIONS(2820),
    [anon_sym_STAR] = ACTIONS(2820),
    [anon_sym_AMP_AMP] = ACTIONS(2820),
    [anon_sym_AMP] = ACTIONS(2818),
    [anon_sym_SEMI] = ACTIONS(2820),
    [anon_sym___extension__] = ACTIONS(2818),
    [anon_sym_typedef] = ACTIONS(2818),
    [anon_sym_virtual] = ACTIONS(2818),
    [anon_sym_extern] = ACTIONS(2818),
    [anon_sym___attribute__] = ACTIONS(2818),
    [anon_sym___attribute] = ACTIONS(2818),
    [anon_sym_COLON_COLON] = ACTIONS(2820),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2820),
    [anon_sym___declspec] = ACTIONS(2818),
    [anon_sym___based] = ACTIONS(2818),
    [anon_sym_signed] = ACTIONS(2818),
    [anon_sym_unsigned] = ACTIONS(2818),
    [anon_sym_long] = ACTIONS(2818),
    [anon_sym_short] = ACTIONS(2818),
    [anon_sym_LBRACK] = ACTIONS(2818),
    [anon_sym_static] = ACTIONS(2818),
    [anon_sym_register] = ACTIONS(2818),
    [anon_sym_inline] = ACTIONS(2818),
    [anon_sym___inline] = ACTIONS(2818),
    [anon_sym___inline__] = ACTIONS(2818),
    [anon_sym___forceinline] = ACTIONS(2818),
    [anon_sym_thread_local] = ACTIONS(2818),
    [anon_sym___thread] = ACTIONS(2818),
    [anon_sym_const] = ACTIONS(2818),
    [anon_sym_constexpr] = ACTIONS(2818),
    [anon_sym_volatile] = ACTIONS(2818),
    [anon_sym_restrict] = ACTIONS(2818),
    [anon_sym___restrict__] = ACTIONS(2818),
    [anon_sym__Atomic] = ACTIONS(2818),
    [anon_sym__Noreturn] = ACTIONS(2818),
    [anon_sym_noreturn] = ACTIONS(2818),
    [anon_sym__Nonnull] = ACTIONS(2818),
    [anon_sym_mutable] = ACTIONS(2818),
    [anon_sym_constinit] = ACTIONS(2818),
    [anon_sym_consteval] = ACTIONS(2818),
    [anon_sym_alignas] = ACTIONS(2818),
    [anon_sym__Alignas] = ACTIONS(2818),
    [sym_primitive_type] = ACTIONS(2818),
    [anon_sym_enum] = ACTIONS(2818),
    [anon_sym_class] = ACTIONS(2818),
    [anon_sym_struct] = ACTIONS(2818),
    [anon_sym_union] = ACTIONS(2818),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2818),
    [anon_sym_decltype] = ACTIONS(2818),
    [anon_sym_explicit] = ACTIONS(2818),
    [anon_sym_typename] = ACTIONS(2818),
    [anon_sym_template] = ACTIONS(2818),
    [anon_sym_operator] = ACTIONS(2818),
    [anon_sym_friend] = ACTIONS(2818),
    [anon_sym_public] = ACTIONS(2818),
    [anon_sym_private] = ACTIONS(2818),
    [anon_sym_protected] = ACTIONS(2818),
    [anon_sym_using] = ACTIONS(2818),
    [anon_sym_static_assert] = ACTIONS(2818),
  },
  [1772] = {
    [sym_identifier] = ACTIONS(5454),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5456),
    [anon_sym_COMMA] = ACTIONS(5456),
    [anon_sym_RPAREN] = ACTIONS(5456),
    [aux_sym_preproc_if_token2] = ACTIONS(5456),
    [aux_sym_preproc_else_token1] = ACTIONS(5456),
    [aux_sym_preproc_elif_token1] = ACTIONS(5454),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5456),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5456),
    [anon_sym_LPAREN2] = ACTIONS(5456),
    [anon_sym_DASH] = ACTIONS(5454),
    [anon_sym_PLUS] = ACTIONS(5454),
    [anon_sym_STAR] = ACTIONS(5454),
    [anon_sym_SLASH] = ACTIONS(5454),
    [anon_sym_PERCENT] = ACTIONS(5454),
    [anon_sym_PIPE_PIPE] = ACTIONS(5456),
    [anon_sym_AMP_AMP] = ACTIONS(5456),
    [anon_sym_PIPE] = ACTIONS(5454),
    [anon_sym_CARET] = ACTIONS(5454),
    [anon_sym_AMP] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5456),
    [anon_sym_BANG_EQ] = ACTIONS(5456),
    [anon_sym_GT] = ACTIONS(5454),
    [anon_sym_GT_EQ] = ACTIONS(5456),
    [anon_sym_LT_EQ] = ACTIONS(5454),
    [anon_sym_LT] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5454),
    [anon_sym_SEMI] = ACTIONS(5456),
    [anon_sym_RBRACE] = ACTIONS(5456),
    [anon_sym_LBRACK] = ACTIONS(5456),
    [anon_sym_RBRACK] = ACTIONS(5456),
    [anon_sym_EQ] = ACTIONS(5454),
    [anon_sym_COLON] = ACTIONS(5456),
    [anon_sym_QMARK] = ACTIONS(5456),
    [anon_sym_STAR_EQ] = ACTIONS(5456),
    [anon_sym_SLASH_EQ] = ACTIONS(5456),
    [anon_sym_PERCENT_EQ] = ACTIONS(5456),
    [anon_sym_PLUS_EQ] = ACTIONS(5456),
    [anon_sym_DASH_EQ] = ACTIONS(5456),
    [anon_sym_LT_LT_EQ] = ACTIONS(5456),
    [anon_sym_GT_GT_EQ] = ACTIONS(5456),
    [anon_sym_AMP_EQ] = ACTIONS(5456),
    [anon_sym_CARET_EQ] = ACTIONS(5456),
    [anon_sym_PIPE_EQ] = ACTIONS(5456),
    [anon_sym_and_eq] = ACTIONS(5454),
    [anon_sym_or_eq] = ACTIONS(5454),
    [anon_sym_xor_eq] = ACTIONS(5454),
    [anon_sym_LT_EQ_GT] = ACTIONS(5456),
    [anon_sym_or] = ACTIONS(5454),
    [anon_sym_and] = ACTIONS(5454),
    [anon_sym_bitor] = ACTIONS(5454),
    [anon_sym_xor] = ACTIONS(5454),
    [anon_sym_bitand] = ACTIONS(5454),
    [anon_sym_not_eq] = ACTIONS(5454),
    [anon_sym_DASH_DASH] = ACTIONS(5456),
    [anon_sym_PLUS_PLUS] = ACTIONS(5456),
    [anon_sym_DOT] = ACTIONS(5454),
    [anon_sym_DOT_STAR] = ACTIONS(5456),
    [anon_sym_DASH_GT] = ACTIONS(5456),
    [anon_sym_L_DQUOTE] = ACTIONS(5456),
    [anon_sym_u_DQUOTE] = ACTIONS(5456),
    [anon_sym_U_DQUOTE] = ACTIONS(5456),
    [anon_sym_u8_DQUOTE] = ACTIONS(5456),
    [anon_sym_DQUOTE] = ACTIONS(5456),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5456),
    [anon_sym_LR_DQUOTE] = ACTIONS(5456),
    [anon_sym_uR_DQUOTE] = ACTIONS(5456),
    [anon_sym_UR_DQUOTE] = ACTIONS(5456),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5456),
    [sym_literal_suffix] = ACTIONS(5454),
  },
  [1773] = {
    [sym_identifier] = ACTIONS(2613),
    [aux_sym_preproc_def_token1] = ACTIONS(2613),
    [aux_sym_preproc_if_token1] = ACTIONS(2613),
    [aux_sym_preproc_if_token2] = ACTIONS(2613),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2613),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2613),
    [aux_sym_preproc_else_token1] = ACTIONS(2613),
    [aux_sym_preproc_elif_token1] = ACTIONS(2613),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2613),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2613),
    [sym_preproc_directive] = ACTIONS(2613),
    [anon_sym_LPAREN2] = ACTIONS(2615),
    [anon_sym_TILDE] = ACTIONS(2615),
    [anon_sym_STAR] = ACTIONS(2615),
    [anon_sym_AMP_AMP] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2613),
    [anon_sym_SEMI] = ACTIONS(2615),
    [anon_sym___extension__] = ACTIONS(2613),
    [anon_sym_typedef] = ACTIONS(2613),
    [anon_sym_virtual] = ACTIONS(2613),
    [anon_sym_extern] = ACTIONS(2613),
    [anon_sym___attribute__] = ACTIONS(2613),
    [anon_sym___attribute] = ACTIONS(2613),
    [anon_sym_COLON_COLON] = ACTIONS(2615),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2615),
    [anon_sym___declspec] = ACTIONS(2613),
    [anon_sym___based] = ACTIONS(2613),
    [anon_sym_signed] = ACTIONS(2613),
    [anon_sym_unsigned] = ACTIONS(2613),
    [anon_sym_long] = ACTIONS(2613),
    [anon_sym_short] = ACTIONS(2613),
    [anon_sym_LBRACK] = ACTIONS(2613),
    [anon_sym_static] = ACTIONS(2613),
    [anon_sym_register] = ACTIONS(2613),
    [anon_sym_inline] = ACTIONS(2613),
    [anon_sym___inline] = ACTIONS(2613),
    [anon_sym___inline__] = ACTIONS(2613),
    [anon_sym___forceinline] = ACTIONS(2613),
    [anon_sym_thread_local] = ACTIONS(2613),
    [anon_sym___thread] = ACTIONS(2613),
    [anon_sym_const] = ACTIONS(2613),
    [anon_sym_constexpr] = ACTIONS(2613),
    [anon_sym_volatile] = ACTIONS(2613),
    [anon_sym_restrict] = ACTIONS(2613),
    [anon_sym___restrict__] = ACTIONS(2613),
    [anon_sym__Atomic] = ACTIONS(2613),
    [anon_sym__Noreturn] = ACTIONS(2613),
    [anon_sym_noreturn] = ACTIONS(2613),
    [anon_sym__Nonnull] = ACTIONS(2613),
    [anon_sym_mutable] = ACTIONS(2613),
    [anon_sym_constinit] = ACTIONS(2613),
    [anon_sym_consteval] = ACTIONS(2613),
    [anon_sym_alignas] = ACTIONS(2613),
    [anon_sym__Alignas] = ACTIONS(2613),
    [sym_primitive_type] = ACTIONS(2613),
    [anon_sym_enum] = ACTIONS(2613),
    [anon_sym_class] = ACTIONS(2613),
    [anon_sym_struct] = ACTIONS(2613),
    [anon_sym_union] = ACTIONS(2613),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2613),
    [anon_sym_decltype] = ACTIONS(2613),
    [anon_sym_explicit] = ACTIONS(2613),
    [anon_sym_typename] = ACTIONS(2613),
    [anon_sym_template] = ACTIONS(2613),
    [anon_sym_operator] = ACTIONS(2613),
    [anon_sym_friend] = ACTIONS(2613),
    [anon_sym_public] = ACTIONS(2613),
    [anon_sym_private] = ACTIONS(2613),
    [anon_sym_protected] = ACTIONS(2613),
    [anon_sym_using] = ACTIONS(2613),
    [anon_sym_static_assert] = ACTIONS(2613),
  },
  [1774] = {
    [sym_identifier] = ACTIONS(2822),
    [aux_sym_preproc_def_token1] = ACTIONS(2822),
    [aux_sym_preproc_if_token1] = ACTIONS(2822),
    [aux_sym_preproc_if_token2] = ACTIONS(2822),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2822),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2822),
    [aux_sym_preproc_else_token1] = ACTIONS(2822),
    [aux_sym_preproc_elif_token1] = ACTIONS(2822),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2822),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2822),
    [sym_preproc_directive] = ACTIONS(2822),
    [anon_sym_LPAREN2] = ACTIONS(2824),
    [anon_sym_TILDE] = ACTIONS(2824),
    [anon_sym_STAR] = ACTIONS(2824),
    [anon_sym_AMP_AMP] = ACTIONS(2824),
    [anon_sym_AMP] = ACTIONS(2822),
    [anon_sym_SEMI] = ACTIONS(2824),
    [anon_sym___extension__] = ACTIONS(2822),
    [anon_sym_typedef] = ACTIONS(2822),
    [anon_sym_virtual] = ACTIONS(2822),
    [anon_sym_extern] = ACTIONS(2822),
    [anon_sym___attribute__] = ACTIONS(2822),
    [anon_sym___attribute] = ACTIONS(2822),
    [anon_sym_COLON_COLON] = ACTIONS(2824),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2824),
    [anon_sym___declspec] = ACTIONS(2822),
    [anon_sym___based] = ACTIONS(2822),
    [anon_sym_signed] = ACTIONS(2822),
    [anon_sym_unsigned] = ACTIONS(2822),
    [anon_sym_long] = ACTIONS(2822),
    [anon_sym_short] = ACTIONS(2822),
    [anon_sym_LBRACK] = ACTIONS(2822),
    [anon_sym_static] = ACTIONS(2822),
    [anon_sym_register] = ACTIONS(2822),
    [anon_sym_inline] = ACTIONS(2822),
    [anon_sym___inline] = ACTIONS(2822),
    [anon_sym___inline__] = ACTIONS(2822),
    [anon_sym___forceinline] = ACTIONS(2822),
    [anon_sym_thread_local] = ACTIONS(2822),
    [anon_sym___thread] = ACTIONS(2822),
    [anon_sym_const] = ACTIONS(2822),
    [anon_sym_constexpr] = ACTIONS(2822),
    [anon_sym_volatile] = ACTIONS(2822),
    [anon_sym_restrict] = ACTIONS(2822),
    [anon_sym___restrict__] = ACTIONS(2822),
    [anon_sym__Atomic] = ACTIONS(2822),
    [anon_sym__Noreturn] = ACTIONS(2822),
    [anon_sym_noreturn] = ACTIONS(2822),
    [anon_sym__Nonnull] = ACTIONS(2822),
    [anon_sym_mutable] = ACTIONS(2822),
    [anon_sym_constinit] = ACTIONS(2822),
    [anon_sym_consteval] = ACTIONS(2822),
    [anon_sym_alignas] = ACTIONS(2822),
    [anon_sym__Alignas] = ACTIONS(2822),
    [sym_primitive_type] = ACTIONS(2822),
    [anon_sym_enum] = ACTIONS(2822),
    [anon_sym_class] = ACTIONS(2822),
    [anon_sym_struct] = ACTIONS(2822),
    [anon_sym_union] = ACTIONS(2822),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2822),
    [anon_sym_decltype] = ACTIONS(2822),
    [anon_sym_explicit] = ACTIONS(2822),
    [anon_sym_typename] = ACTIONS(2822),
    [anon_sym_template] = ACTIONS(2822),
    [anon_sym_operator] = ACTIONS(2822),
    [anon_sym_friend] = ACTIONS(2822),
    [anon_sym_public] = ACTIONS(2822),
    [anon_sym_private] = ACTIONS(2822),
    [anon_sym_protected] = ACTIONS(2822),
    [anon_sym_using] = ACTIONS(2822),
    [anon_sym_static_assert] = ACTIONS(2822),
  },
  [1775] = {
    [sym_identifier] = ACTIONS(5439),
    [aux_sym_preproc_def_token1] = ACTIONS(5439),
    [aux_sym_preproc_if_token1] = ACTIONS(5439),
    [aux_sym_preproc_if_token2] = ACTIONS(5439),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5439),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5439),
    [aux_sym_preproc_else_token1] = ACTIONS(5439),
    [aux_sym_preproc_elif_token1] = ACTIONS(5439),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5439),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5439),
    [sym_preproc_directive] = ACTIONS(5439),
    [anon_sym_LPAREN2] = ACTIONS(5441),
    [anon_sym_TILDE] = ACTIONS(5441),
    [anon_sym_STAR] = ACTIONS(5441),
    [anon_sym_AMP_AMP] = ACTIONS(5441),
    [anon_sym_AMP] = ACTIONS(5439),
    [anon_sym_SEMI] = ACTIONS(5441),
    [anon_sym___extension__] = ACTIONS(5439),
    [anon_sym_typedef] = ACTIONS(5439),
    [anon_sym_virtual] = ACTIONS(5439),
    [anon_sym_extern] = ACTIONS(5439),
    [anon_sym___attribute__] = ACTIONS(5439),
    [anon_sym___attribute] = ACTIONS(5439),
    [anon_sym_COLON_COLON] = ACTIONS(5441),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5441),
    [anon_sym___declspec] = ACTIONS(5439),
    [anon_sym___based] = ACTIONS(5439),
    [anon_sym_signed] = ACTIONS(5439),
    [anon_sym_unsigned] = ACTIONS(5439),
    [anon_sym_long] = ACTIONS(5439),
    [anon_sym_short] = ACTIONS(5439),
    [anon_sym_LBRACK] = ACTIONS(5439),
    [anon_sym_static] = ACTIONS(5439),
    [anon_sym_register] = ACTIONS(5439),
    [anon_sym_inline] = ACTIONS(5439),
    [anon_sym___inline] = ACTIONS(5439),
    [anon_sym___inline__] = ACTIONS(5439),
    [anon_sym___forceinline] = ACTIONS(5439),
    [anon_sym_thread_local] = ACTIONS(5439),
    [anon_sym___thread] = ACTIONS(5439),
    [anon_sym_const] = ACTIONS(5439),
    [anon_sym_constexpr] = ACTIONS(5439),
    [anon_sym_volatile] = ACTIONS(5439),
    [anon_sym_restrict] = ACTIONS(5439),
    [anon_sym___restrict__] = ACTIONS(5439),
    [anon_sym__Atomic] = ACTIONS(5439),
    [anon_sym__Noreturn] = ACTIONS(5439),
    [anon_sym_noreturn] = ACTIONS(5439),
    [anon_sym__Nonnull] = ACTIONS(5439),
    [anon_sym_mutable] = ACTIONS(5439),
    [anon_sym_constinit] = ACTIONS(5439),
    [anon_sym_consteval] = ACTIONS(5439),
    [anon_sym_alignas] = ACTIONS(5439),
    [anon_sym__Alignas] = ACTIONS(5439),
    [sym_primitive_type] = ACTIONS(5439),
    [anon_sym_enum] = ACTIONS(5439),
    [anon_sym_class] = ACTIONS(5439),
    [anon_sym_struct] = ACTIONS(5439),
    [anon_sym_union] = ACTIONS(5439),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5439),
    [anon_sym_decltype] = ACTIONS(5439),
    [anon_sym_explicit] = ACTIONS(5439),
    [anon_sym_typename] = ACTIONS(5439),
    [anon_sym_template] = ACTIONS(5439),
    [anon_sym_operator] = ACTIONS(5439),
    [anon_sym_friend] = ACTIONS(5439),
    [anon_sym_public] = ACTIONS(5439),
    [anon_sym_private] = ACTIONS(5439),
    [anon_sym_protected] = ACTIONS(5439),
    [anon_sym_using] = ACTIONS(5439),
    [anon_sym_static_assert] = ACTIONS(5439),
  },
  [1776] = {
    [sym_identifier] = ACTIONS(2645),
    [aux_sym_preproc_def_token1] = ACTIONS(2645),
    [aux_sym_preproc_if_token1] = ACTIONS(2645),
    [aux_sym_preproc_if_token2] = ACTIONS(2645),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2645),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2645),
    [aux_sym_preproc_else_token1] = ACTIONS(2645),
    [aux_sym_preproc_elif_token1] = ACTIONS(2645),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2645),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2645),
    [sym_preproc_directive] = ACTIONS(2645),
    [anon_sym_LPAREN2] = ACTIONS(2647),
    [anon_sym_TILDE] = ACTIONS(2647),
    [anon_sym_STAR] = ACTIONS(2647),
    [anon_sym_AMP_AMP] = ACTIONS(2647),
    [anon_sym_AMP] = ACTIONS(2645),
    [anon_sym_SEMI] = ACTIONS(2647),
    [anon_sym___extension__] = ACTIONS(2645),
    [anon_sym_typedef] = ACTIONS(2645),
    [anon_sym_virtual] = ACTIONS(2645),
    [anon_sym_extern] = ACTIONS(2645),
    [anon_sym___attribute__] = ACTIONS(2645),
    [anon_sym___attribute] = ACTIONS(2645),
    [anon_sym_COLON_COLON] = ACTIONS(2647),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2647),
    [anon_sym___declspec] = ACTIONS(2645),
    [anon_sym___based] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2645),
    [anon_sym_unsigned] = ACTIONS(2645),
    [anon_sym_long] = ACTIONS(2645),
    [anon_sym_short] = ACTIONS(2645),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_static] = ACTIONS(2645),
    [anon_sym_register] = ACTIONS(2645),
    [anon_sym_inline] = ACTIONS(2645),
    [anon_sym___inline] = ACTIONS(2645),
    [anon_sym___inline__] = ACTIONS(2645),
    [anon_sym___forceinline] = ACTIONS(2645),
    [anon_sym_thread_local] = ACTIONS(2645),
    [anon_sym___thread] = ACTIONS(2645),
    [anon_sym_const] = ACTIONS(2645),
    [anon_sym_constexpr] = ACTIONS(2645),
    [anon_sym_volatile] = ACTIONS(2645),
    [anon_sym_restrict] = ACTIONS(2645),
    [anon_sym___restrict__] = ACTIONS(2645),
    [anon_sym__Atomic] = ACTIONS(2645),
    [anon_sym__Noreturn] = ACTIONS(2645),
    [anon_sym_noreturn] = ACTIONS(2645),
    [anon_sym__Nonnull] = ACTIONS(2645),
    [anon_sym_mutable] = ACTIONS(2645),
    [anon_sym_constinit] = ACTIONS(2645),
    [anon_sym_consteval] = ACTIONS(2645),
    [anon_sym_alignas] = ACTIONS(2645),
    [anon_sym__Alignas] = ACTIONS(2645),
    [sym_primitive_type] = ACTIONS(2645),
    [anon_sym_enum] = ACTIONS(2645),
    [anon_sym_class] = ACTIONS(2645),
    [anon_sym_struct] = ACTIONS(2645),
    [anon_sym_union] = ACTIONS(2645),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2645),
    [anon_sym_decltype] = ACTIONS(2645),
    [anon_sym_explicit] = ACTIONS(2645),
    [anon_sym_typename] = ACTIONS(2645),
    [anon_sym_template] = ACTIONS(2645),
    [anon_sym_operator] = ACTIONS(2645),
    [anon_sym_friend] = ACTIONS(2645),
    [anon_sym_public] = ACTIONS(2645),
    [anon_sym_private] = ACTIONS(2645),
    [anon_sym_protected] = ACTIONS(2645),
    [anon_sym_using] = ACTIONS(2645),
    [anon_sym_static_assert] = ACTIONS(2645),
  },
  [1777] = {
    [sym_identifier] = ACTIONS(2649),
    [aux_sym_preproc_def_token1] = ACTIONS(2649),
    [aux_sym_preproc_if_token1] = ACTIONS(2649),
    [aux_sym_preproc_if_token2] = ACTIONS(2649),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2649),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2649),
    [aux_sym_preproc_else_token1] = ACTIONS(2649),
    [aux_sym_preproc_elif_token1] = ACTIONS(2649),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2649),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2649),
    [sym_preproc_directive] = ACTIONS(2649),
    [anon_sym_LPAREN2] = ACTIONS(2651),
    [anon_sym_TILDE] = ACTIONS(2651),
    [anon_sym_STAR] = ACTIONS(2651),
    [anon_sym_AMP_AMP] = ACTIONS(2651),
    [anon_sym_AMP] = ACTIONS(2649),
    [anon_sym_SEMI] = ACTIONS(2651),
    [anon_sym___extension__] = ACTIONS(2649),
    [anon_sym_typedef] = ACTIONS(2649),
    [anon_sym_virtual] = ACTIONS(2649),
    [anon_sym_extern] = ACTIONS(2649),
    [anon_sym___attribute__] = ACTIONS(2649),
    [anon_sym___attribute] = ACTIONS(2649),
    [anon_sym_COLON_COLON] = ACTIONS(2651),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2651),
    [anon_sym___declspec] = ACTIONS(2649),
    [anon_sym___based] = ACTIONS(2649),
    [anon_sym_signed] = ACTIONS(2649),
    [anon_sym_unsigned] = ACTIONS(2649),
    [anon_sym_long] = ACTIONS(2649),
    [anon_sym_short] = ACTIONS(2649),
    [anon_sym_LBRACK] = ACTIONS(2649),
    [anon_sym_static] = ACTIONS(2649),
    [anon_sym_register] = ACTIONS(2649),
    [anon_sym_inline] = ACTIONS(2649),
    [anon_sym___inline] = ACTIONS(2649),
    [anon_sym___inline__] = ACTIONS(2649),
    [anon_sym___forceinline] = ACTIONS(2649),
    [anon_sym_thread_local] = ACTIONS(2649),
    [anon_sym___thread] = ACTIONS(2649),
    [anon_sym_const] = ACTIONS(2649),
    [anon_sym_constexpr] = ACTIONS(2649),
    [anon_sym_volatile] = ACTIONS(2649),
    [anon_sym_restrict] = ACTIONS(2649),
    [anon_sym___restrict__] = ACTIONS(2649),
    [anon_sym__Atomic] = ACTIONS(2649),
    [anon_sym__Noreturn] = ACTIONS(2649),
    [anon_sym_noreturn] = ACTIONS(2649),
    [anon_sym__Nonnull] = ACTIONS(2649),
    [anon_sym_mutable] = ACTIONS(2649),
    [anon_sym_constinit] = ACTIONS(2649),
    [anon_sym_consteval] = ACTIONS(2649),
    [anon_sym_alignas] = ACTIONS(2649),
    [anon_sym__Alignas] = ACTIONS(2649),
    [sym_primitive_type] = ACTIONS(2649),
    [anon_sym_enum] = ACTIONS(2649),
    [anon_sym_class] = ACTIONS(2649),
    [anon_sym_struct] = ACTIONS(2649),
    [anon_sym_union] = ACTIONS(2649),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2649),
    [anon_sym_decltype] = ACTIONS(2649),
    [anon_sym_explicit] = ACTIONS(2649),
    [anon_sym_typename] = ACTIONS(2649),
    [anon_sym_template] = ACTIONS(2649),
    [anon_sym_operator] = ACTIONS(2649),
    [anon_sym_friend] = ACTIONS(2649),
    [anon_sym_public] = ACTIONS(2649),
    [anon_sym_private] = ACTIONS(2649),
    [anon_sym_protected] = ACTIONS(2649),
    [anon_sym_using] = ACTIONS(2649),
    [anon_sym_static_assert] = ACTIONS(2649),
  },
  [1778] = {
    [sym_identifier] = ACTIONS(2731),
    [aux_sym_preproc_def_token1] = ACTIONS(2731),
    [aux_sym_preproc_if_token1] = ACTIONS(2731),
    [aux_sym_preproc_if_token2] = ACTIONS(2731),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2731),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2731),
    [aux_sym_preproc_else_token1] = ACTIONS(2731),
    [aux_sym_preproc_elif_token1] = ACTIONS(2731),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2731),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2731),
    [sym_preproc_directive] = ACTIONS(2731),
    [anon_sym_LPAREN2] = ACTIONS(2733),
    [anon_sym_TILDE] = ACTIONS(2733),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_AMP_AMP] = ACTIONS(2733),
    [anon_sym_AMP] = ACTIONS(2731),
    [anon_sym_SEMI] = ACTIONS(2733),
    [anon_sym___extension__] = ACTIONS(2731),
    [anon_sym_typedef] = ACTIONS(2731),
    [anon_sym_virtual] = ACTIONS(2731),
    [anon_sym_extern] = ACTIONS(2731),
    [anon_sym___attribute__] = ACTIONS(2731),
    [anon_sym___attribute] = ACTIONS(2731),
    [anon_sym_COLON_COLON] = ACTIONS(2733),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2733),
    [anon_sym___declspec] = ACTIONS(2731),
    [anon_sym___based] = ACTIONS(2731),
    [anon_sym_signed] = ACTIONS(2731),
    [anon_sym_unsigned] = ACTIONS(2731),
    [anon_sym_long] = ACTIONS(2731),
    [anon_sym_short] = ACTIONS(2731),
    [anon_sym_LBRACK] = ACTIONS(2731),
    [anon_sym_static] = ACTIONS(2731),
    [anon_sym_register] = ACTIONS(2731),
    [anon_sym_inline] = ACTIONS(2731),
    [anon_sym___inline] = ACTIONS(2731),
    [anon_sym___inline__] = ACTIONS(2731),
    [anon_sym___forceinline] = ACTIONS(2731),
    [anon_sym_thread_local] = ACTIONS(2731),
    [anon_sym___thread] = ACTIONS(2731),
    [anon_sym_const] = ACTIONS(2731),
    [anon_sym_constexpr] = ACTIONS(2731),
    [anon_sym_volatile] = ACTIONS(2731),
    [anon_sym_restrict] = ACTIONS(2731),
    [anon_sym___restrict__] = ACTIONS(2731),
    [anon_sym__Atomic] = ACTIONS(2731),
    [anon_sym__Noreturn] = ACTIONS(2731),
    [anon_sym_noreturn] = ACTIONS(2731),
    [anon_sym__Nonnull] = ACTIONS(2731),
    [anon_sym_mutable] = ACTIONS(2731),
    [anon_sym_constinit] = ACTIONS(2731),
    [anon_sym_consteval] = ACTIONS(2731),
    [anon_sym_alignas] = ACTIONS(2731),
    [anon_sym__Alignas] = ACTIONS(2731),
    [sym_primitive_type] = ACTIONS(2731),
    [anon_sym_enum] = ACTIONS(2731),
    [anon_sym_class] = ACTIONS(2731),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2731),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2731),
    [anon_sym_decltype] = ACTIONS(2731),
    [anon_sym_explicit] = ACTIONS(2731),
    [anon_sym_typename] = ACTIONS(2731),
    [anon_sym_template] = ACTIONS(2731),
    [anon_sym_operator] = ACTIONS(2731),
    [anon_sym_friend] = ACTIONS(2731),
    [anon_sym_public] = ACTIONS(2731),
    [anon_sym_private] = ACTIONS(2731),
    [anon_sym_protected] = ACTIONS(2731),
    [anon_sym_using] = ACTIONS(2731),
    [anon_sym_static_assert] = ACTIONS(2731),
  },
  [1779] = {
    [sym_identifier] = ACTIONS(2689),
    [aux_sym_preproc_def_token1] = ACTIONS(2689),
    [aux_sym_preproc_if_token1] = ACTIONS(2689),
    [aux_sym_preproc_if_token2] = ACTIONS(2689),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2689),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2689),
    [aux_sym_preproc_else_token1] = ACTIONS(2689),
    [aux_sym_preproc_elif_token1] = ACTIONS(2689),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2689),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2689),
    [sym_preproc_directive] = ACTIONS(2689),
    [anon_sym_LPAREN2] = ACTIONS(2691),
    [anon_sym_TILDE] = ACTIONS(2691),
    [anon_sym_STAR] = ACTIONS(2691),
    [anon_sym_AMP_AMP] = ACTIONS(2691),
    [anon_sym_AMP] = ACTIONS(2689),
    [anon_sym_SEMI] = ACTIONS(2691),
    [anon_sym___extension__] = ACTIONS(2689),
    [anon_sym_typedef] = ACTIONS(2689),
    [anon_sym_virtual] = ACTIONS(2689),
    [anon_sym_extern] = ACTIONS(2689),
    [anon_sym___attribute__] = ACTIONS(2689),
    [anon_sym___attribute] = ACTIONS(2689),
    [anon_sym_COLON_COLON] = ACTIONS(2691),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2691),
    [anon_sym___declspec] = ACTIONS(2689),
    [anon_sym___based] = ACTIONS(2689),
    [anon_sym_signed] = ACTIONS(2689),
    [anon_sym_unsigned] = ACTIONS(2689),
    [anon_sym_long] = ACTIONS(2689),
    [anon_sym_short] = ACTIONS(2689),
    [anon_sym_LBRACK] = ACTIONS(2689),
    [anon_sym_static] = ACTIONS(2689),
    [anon_sym_register] = ACTIONS(2689),
    [anon_sym_inline] = ACTIONS(2689),
    [anon_sym___inline] = ACTIONS(2689),
    [anon_sym___inline__] = ACTIONS(2689),
    [anon_sym___forceinline] = ACTIONS(2689),
    [anon_sym_thread_local] = ACTIONS(2689),
    [anon_sym___thread] = ACTIONS(2689),
    [anon_sym_const] = ACTIONS(2689),
    [anon_sym_constexpr] = ACTIONS(2689),
    [anon_sym_volatile] = ACTIONS(2689),
    [anon_sym_restrict] = ACTIONS(2689),
    [anon_sym___restrict__] = ACTIONS(2689),
    [anon_sym__Atomic] = ACTIONS(2689),
    [anon_sym__Noreturn] = ACTIONS(2689),
    [anon_sym_noreturn] = ACTIONS(2689),
    [anon_sym__Nonnull] = ACTIONS(2689),
    [anon_sym_mutable] = ACTIONS(2689),
    [anon_sym_constinit] = ACTIONS(2689),
    [anon_sym_consteval] = ACTIONS(2689),
    [anon_sym_alignas] = ACTIONS(2689),
    [anon_sym__Alignas] = ACTIONS(2689),
    [sym_primitive_type] = ACTIONS(2689),
    [anon_sym_enum] = ACTIONS(2689),
    [anon_sym_class] = ACTIONS(2689),
    [anon_sym_struct] = ACTIONS(2689),
    [anon_sym_union] = ACTIONS(2689),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2689),
    [anon_sym_decltype] = ACTIONS(2689),
    [anon_sym_explicit] = ACTIONS(2689),
    [anon_sym_typename] = ACTIONS(2689),
    [anon_sym_template] = ACTIONS(2689),
    [anon_sym_operator] = ACTIONS(2689),
    [anon_sym_friend] = ACTIONS(2689),
    [anon_sym_public] = ACTIONS(2689),
    [anon_sym_private] = ACTIONS(2689),
    [anon_sym_protected] = ACTIONS(2689),
    [anon_sym_using] = ACTIONS(2689),
    [anon_sym_static_assert] = ACTIONS(2689),
  },
  [1780] = {
    [sym_identifier] = ACTIONS(2763),
    [aux_sym_preproc_def_token1] = ACTIONS(2763),
    [aux_sym_preproc_if_token1] = ACTIONS(2763),
    [aux_sym_preproc_if_token2] = ACTIONS(2763),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2763),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2763),
    [aux_sym_preproc_else_token1] = ACTIONS(2763),
    [aux_sym_preproc_elif_token1] = ACTIONS(2763),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2763),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2763),
    [sym_preproc_directive] = ACTIONS(2763),
    [anon_sym_LPAREN2] = ACTIONS(2765),
    [anon_sym_TILDE] = ACTIONS(2765),
    [anon_sym_STAR] = ACTIONS(2765),
    [anon_sym_AMP_AMP] = ACTIONS(2765),
    [anon_sym_AMP] = ACTIONS(2763),
    [anon_sym_SEMI] = ACTIONS(2765),
    [anon_sym___extension__] = ACTIONS(2763),
    [anon_sym_typedef] = ACTIONS(2763),
    [anon_sym_virtual] = ACTIONS(2763),
    [anon_sym_extern] = ACTIONS(2763),
    [anon_sym___attribute__] = ACTIONS(2763),
    [anon_sym___attribute] = ACTIONS(2763),
    [anon_sym_COLON_COLON] = ACTIONS(2765),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2765),
    [anon_sym___declspec] = ACTIONS(2763),
    [anon_sym___based] = ACTIONS(2763),
    [anon_sym_signed] = ACTIONS(2763),
    [anon_sym_unsigned] = ACTIONS(2763),
    [anon_sym_long] = ACTIONS(2763),
    [anon_sym_short] = ACTIONS(2763),
    [anon_sym_LBRACK] = ACTIONS(2763),
    [anon_sym_static] = ACTIONS(2763),
    [anon_sym_register] = ACTIONS(2763),
    [anon_sym_inline] = ACTIONS(2763),
    [anon_sym___inline] = ACTIONS(2763),
    [anon_sym___inline__] = ACTIONS(2763),
    [anon_sym___forceinline] = ACTIONS(2763),
    [anon_sym_thread_local] = ACTIONS(2763),
    [anon_sym___thread] = ACTIONS(2763),
    [anon_sym_const] = ACTIONS(2763),
    [anon_sym_constexpr] = ACTIONS(2763),
    [anon_sym_volatile] = ACTIONS(2763),
    [anon_sym_restrict] = ACTIONS(2763),
    [anon_sym___restrict__] = ACTIONS(2763),
    [anon_sym__Atomic] = ACTIONS(2763),
    [anon_sym__Noreturn] = ACTIONS(2763),
    [anon_sym_noreturn] = ACTIONS(2763),
    [anon_sym__Nonnull] = ACTIONS(2763),
    [anon_sym_mutable] = ACTIONS(2763),
    [anon_sym_constinit] = ACTIONS(2763),
    [anon_sym_consteval] = ACTIONS(2763),
    [anon_sym_alignas] = ACTIONS(2763),
    [anon_sym__Alignas] = ACTIONS(2763),
    [sym_primitive_type] = ACTIONS(2763),
    [anon_sym_enum] = ACTIONS(2763),
    [anon_sym_class] = ACTIONS(2763),
    [anon_sym_struct] = ACTIONS(2763),
    [anon_sym_union] = ACTIONS(2763),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2763),
    [anon_sym_decltype] = ACTIONS(2763),
    [anon_sym_explicit] = ACTIONS(2763),
    [anon_sym_typename] = ACTIONS(2763),
    [anon_sym_template] = ACTIONS(2763),
    [anon_sym_operator] = ACTIONS(2763),
    [anon_sym_friend] = ACTIONS(2763),
    [anon_sym_public] = ACTIONS(2763),
    [anon_sym_private] = ACTIONS(2763),
    [anon_sym_protected] = ACTIONS(2763),
    [anon_sym_using] = ACTIONS(2763),
    [anon_sym_static_assert] = ACTIONS(2763),
  },
  [1781] = {
    [sym_identifier] = ACTIONS(5458),
    [aux_sym_preproc_def_token1] = ACTIONS(5458),
    [aux_sym_preproc_if_token1] = ACTIONS(5458),
    [aux_sym_preproc_if_token2] = ACTIONS(5458),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5458),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5458),
    [aux_sym_preproc_else_token1] = ACTIONS(5458),
    [aux_sym_preproc_elif_token1] = ACTIONS(5458),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5458),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5458),
    [sym_preproc_directive] = ACTIONS(5458),
    [anon_sym_LPAREN2] = ACTIONS(5460),
    [anon_sym_TILDE] = ACTIONS(5460),
    [anon_sym_STAR] = ACTIONS(5460),
    [anon_sym_AMP_AMP] = ACTIONS(5460),
    [anon_sym_AMP] = ACTIONS(5458),
    [anon_sym_SEMI] = ACTIONS(5460),
    [anon_sym___extension__] = ACTIONS(5458),
    [anon_sym_typedef] = ACTIONS(5458),
    [anon_sym_virtual] = ACTIONS(5458),
    [anon_sym_extern] = ACTIONS(5458),
    [anon_sym___attribute__] = ACTIONS(5458),
    [anon_sym___attribute] = ACTIONS(5458),
    [anon_sym_COLON_COLON] = ACTIONS(5460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5460),
    [anon_sym___declspec] = ACTIONS(5458),
    [anon_sym___based] = ACTIONS(5458),
    [anon_sym_signed] = ACTIONS(5458),
    [anon_sym_unsigned] = ACTIONS(5458),
    [anon_sym_long] = ACTIONS(5458),
    [anon_sym_short] = ACTIONS(5458),
    [anon_sym_LBRACK] = ACTIONS(5458),
    [anon_sym_static] = ACTIONS(5458),
    [anon_sym_register] = ACTIONS(5458),
    [anon_sym_inline] = ACTIONS(5458),
    [anon_sym___inline] = ACTIONS(5458),
    [anon_sym___inline__] = ACTIONS(5458),
    [anon_sym___forceinline] = ACTIONS(5458),
    [anon_sym_thread_local] = ACTIONS(5458),
    [anon_sym___thread] = ACTIONS(5458),
    [anon_sym_const] = ACTIONS(5458),
    [anon_sym_constexpr] = ACTIONS(5458),
    [anon_sym_volatile] = ACTIONS(5458),
    [anon_sym_restrict] = ACTIONS(5458),
    [anon_sym___restrict__] = ACTIONS(5458),
    [anon_sym__Atomic] = ACTIONS(5458),
    [anon_sym__Noreturn] = ACTIONS(5458),
    [anon_sym_noreturn] = ACTIONS(5458),
    [anon_sym__Nonnull] = ACTIONS(5458),
    [anon_sym_mutable] = ACTIONS(5458),
    [anon_sym_constinit] = ACTIONS(5458),
    [anon_sym_consteval] = ACTIONS(5458),
    [anon_sym_alignas] = ACTIONS(5458),
    [anon_sym__Alignas] = ACTIONS(5458),
    [sym_primitive_type] = ACTIONS(5458),
    [anon_sym_enum] = ACTIONS(5458),
    [anon_sym_class] = ACTIONS(5458),
    [anon_sym_struct] = ACTIONS(5458),
    [anon_sym_union] = ACTIONS(5458),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5458),
    [anon_sym_decltype] = ACTIONS(5458),
    [anon_sym_explicit] = ACTIONS(5458),
    [anon_sym_typename] = ACTIONS(5458),
    [anon_sym_template] = ACTIONS(5458),
    [anon_sym_operator] = ACTIONS(5458),
    [anon_sym_friend] = ACTIONS(5458),
    [anon_sym_public] = ACTIONS(5458),
    [anon_sym_private] = ACTIONS(5458),
    [anon_sym_protected] = ACTIONS(5458),
    [anon_sym_using] = ACTIONS(5458),
    [anon_sym_static_assert] = ACTIONS(5458),
  },
  [1782] = {
    [sym_identifier] = ACTIONS(2826),
    [aux_sym_preproc_def_token1] = ACTIONS(2826),
    [aux_sym_preproc_if_token1] = ACTIONS(2826),
    [aux_sym_preproc_if_token2] = ACTIONS(2826),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2826),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2826),
    [aux_sym_preproc_else_token1] = ACTIONS(2826),
    [aux_sym_preproc_elif_token1] = ACTIONS(2826),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2826),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2826),
    [sym_preproc_directive] = ACTIONS(2826),
    [anon_sym_LPAREN2] = ACTIONS(2828),
    [anon_sym_TILDE] = ACTIONS(2828),
    [anon_sym_STAR] = ACTIONS(2828),
    [anon_sym_AMP_AMP] = ACTIONS(2828),
    [anon_sym_AMP] = ACTIONS(2826),
    [anon_sym_SEMI] = ACTIONS(2828),
    [anon_sym___extension__] = ACTIONS(2826),
    [anon_sym_typedef] = ACTIONS(2826),
    [anon_sym_virtual] = ACTIONS(2826),
    [anon_sym_extern] = ACTIONS(2826),
    [anon_sym___attribute__] = ACTIONS(2826),
    [anon_sym___attribute] = ACTIONS(2826),
    [anon_sym_COLON_COLON] = ACTIONS(2828),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2828),
    [anon_sym___declspec] = ACTIONS(2826),
    [anon_sym___based] = ACTIONS(2826),
    [anon_sym_signed] = ACTIONS(2826),
    [anon_sym_unsigned] = ACTIONS(2826),
    [anon_sym_long] = ACTIONS(2826),
    [anon_sym_short] = ACTIONS(2826),
    [anon_sym_LBRACK] = ACTIONS(2826),
    [anon_sym_static] = ACTIONS(2826),
    [anon_sym_register] = ACTIONS(2826),
    [anon_sym_inline] = ACTIONS(2826),
    [anon_sym___inline] = ACTIONS(2826),
    [anon_sym___inline__] = ACTIONS(2826),
    [anon_sym___forceinline] = ACTIONS(2826),
    [anon_sym_thread_local] = ACTIONS(2826),
    [anon_sym___thread] = ACTIONS(2826),
    [anon_sym_const] = ACTIONS(2826),
    [anon_sym_constexpr] = ACTIONS(2826),
    [anon_sym_volatile] = ACTIONS(2826),
    [anon_sym_restrict] = ACTIONS(2826),
    [anon_sym___restrict__] = ACTIONS(2826),
    [anon_sym__Atomic] = ACTIONS(2826),
    [anon_sym__Noreturn] = ACTIONS(2826),
    [anon_sym_noreturn] = ACTIONS(2826),
    [anon_sym__Nonnull] = ACTIONS(2826),
    [anon_sym_mutable] = ACTIONS(2826),
    [anon_sym_constinit] = ACTIONS(2826),
    [anon_sym_consteval] = ACTIONS(2826),
    [anon_sym_alignas] = ACTIONS(2826),
    [anon_sym__Alignas] = ACTIONS(2826),
    [sym_primitive_type] = ACTIONS(2826),
    [anon_sym_enum] = ACTIONS(2826),
    [anon_sym_class] = ACTIONS(2826),
    [anon_sym_struct] = ACTIONS(2826),
    [anon_sym_union] = ACTIONS(2826),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2826),
    [anon_sym_decltype] = ACTIONS(2826),
    [anon_sym_explicit] = ACTIONS(2826),
    [anon_sym_typename] = ACTIONS(2826),
    [anon_sym_template] = ACTIONS(2826),
    [anon_sym_operator] = ACTIONS(2826),
    [anon_sym_friend] = ACTIONS(2826),
    [anon_sym_public] = ACTIONS(2826),
    [anon_sym_private] = ACTIONS(2826),
    [anon_sym_protected] = ACTIONS(2826),
    [anon_sym_using] = ACTIONS(2826),
    [anon_sym_static_assert] = ACTIONS(2826),
  },
  [1783] = {
    [sym__declaration_modifiers] = STATE(3299),
    [sym_attribute_specifier] = STATE(3299),
    [sym_attribute_declaration] = STATE(3299),
    [sym_ms_declspec_modifier] = STATE(3299),
    [sym_ms_based_modifier] = STATE(7870),
    [sym__declarator] = STATE(6663),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_function_declarator] = STATE(6186),
    [sym_array_declarator] = STATE(5896),
    [sym_storage_class_specifier] = STATE(3299),
    [sym_type_qualifier] = STATE(3299),
    [sym_alignas_qualifier] = STATE(3049),
    [sym_decltype] = STATE(8512),
    [sym_explicit_function_specifier] = STATE(3299),
    [sym_operator_cast] = STATE(6718),
    [sym__constructor_specifiers] = STATE(3299),
    [sym_reference_declarator] = STATE(5896),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym_template_type] = STATE(8512),
    [sym_template_function] = STATE(5896),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5444),
    [sym_qualified_identifier] = STATE(5896),
    [sym_qualified_operator_cast_identifier] = STATE(6718),
    [sym_operator_name] = STATE(5896),
    [aux_sym_operator_cast_definition_repeat1] = STATE(3299),
    [sym_identifier] = ACTIONS(5327),
    [anon_sym_LPAREN2] = ACTIONS(3192),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3196),
    [anon_sym_AMP_AMP] = ACTIONS(29),
    [anon_sym_AMP] = ACTIONS(3198),
    [anon_sym___extension__] = ACTIONS(5329),
    [anon_sym_virtual] = ACTIONS(5331),
    [anon_sym_extern] = ACTIONS(5333),
    [anon_sym___attribute__] = ACTIONS(5335),
    [anon_sym___attribute] = ACTIONS(5335),
    [anon_sym_COLON_COLON] = ACTIONS(5337),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5339),
    [anon_sym___declspec] = ACTIONS(5341),
    [anon_sym___based] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(3208),
    [anon_sym_static] = ACTIONS(5333),
    [anon_sym_register] = ACTIONS(5333),
    [anon_sym_inline] = ACTIONS(5333),
    [anon_sym___inline] = ACTIONS(5333),
    [anon_sym___inline__] = ACTIONS(5333),
    [anon_sym___forceinline] = ACTIONS(5333),
    [anon_sym_thread_local] = ACTIONS(5333),
    [anon_sym___thread] = ACTIONS(5333),
    [anon_sym_const] = ACTIONS(5329),
    [anon_sym_constexpr] = ACTIONS(5329),
    [anon_sym_volatile] = ACTIONS(5329),
    [anon_sym_restrict] = ACTIONS(5329),
    [anon_sym___restrict__] = ACTIONS(5329),
    [anon_sym__Atomic] = ACTIONS(5329),
    [anon_sym__Noreturn] = ACTIONS(5329),
    [anon_sym_noreturn] = ACTIONS(5329),
    [anon_sym__Nonnull] = ACTIONS(5329),
    [anon_sym_mutable] = ACTIONS(5329),
    [anon_sym_constinit] = ACTIONS(5329),
    [anon_sym_consteval] = ACTIONS(5329),
    [anon_sym_alignas] = ACTIONS(5343),
    [anon_sym__Alignas] = ACTIONS(5343),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_explicit] = ACTIONS(127),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_operator] = ACTIONS(133),
  },
  [1784] = {
    [sym_identifier] = ACTIONS(2830),
    [aux_sym_preproc_def_token1] = ACTIONS(2830),
    [aux_sym_preproc_if_token1] = ACTIONS(2830),
    [aux_sym_preproc_if_token2] = ACTIONS(2830),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2830),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2830),
    [aux_sym_preproc_else_token1] = ACTIONS(2830),
    [aux_sym_preproc_elif_token1] = ACTIONS(2830),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2830),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2830),
    [sym_preproc_directive] = ACTIONS(2830),
    [anon_sym_LPAREN2] = ACTIONS(2832),
    [anon_sym_TILDE] = ACTIONS(2832),
    [anon_sym_STAR] = ACTIONS(2832),
    [anon_sym_AMP_AMP] = ACTIONS(2832),
    [anon_sym_AMP] = ACTIONS(2830),
    [anon_sym_SEMI] = ACTIONS(2832),
    [anon_sym___extension__] = ACTIONS(2830),
    [anon_sym_typedef] = ACTIONS(2830),
    [anon_sym_virtual] = ACTIONS(2830),
    [anon_sym_extern] = ACTIONS(2830),
    [anon_sym___attribute__] = ACTIONS(2830),
    [anon_sym___attribute] = ACTIONS(2830),
    [anon_sym_COLON_COLON] = ACTIONS(2832),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2832),
    [anon_sym___declspec] = ACTIONS(2830),
    [anon_sym___based] = ACTIONS(2830),
    [anon_sym_signed] = ACTIONS(2830),
    [anon_sym_unsigned] = ACTIONS(2830),
    [anon_sym_long] = ACTIONS(2830),
    [anon_sym_short] = ACTIONS(2830),
    [anon_sym_LBRACK] = ACTIONS(2830),
    [anon_sym_static] = ACTIONS(2830),
    [anon_sym_register] = ACTIONS(2830),
    [anon_sym_inline] = ACTIONS(2830),
    [anon_sym___inline] = ACTIONS(2830),
    [anon_sym___inline__] = ACTIONS(2830),
    [anon_sym___forceinline] = ACTIONS(2830),
    [anon_sym_thread_local] = ACTIONS(2830),
    [anon_sym___thread] = ACTIONS(2830),
    [anon_sym_const] = ACTIONS(2830),
    [anon_sym_constexpr] = ACTIONS(2830),
    [anon_sym_volatile] = ACTIONS(2830),
    [anon_sym_restrict] = ACTIONS(2830),
    [anon_sym___restrict__] = ACTIONS(2830),
    [anon_sym__Atomic] = ACTIONS(2830),
    [anon_sym__Noreturn] = ACTIONS(2830),
    [anon_sym_noreturn] = ACTIONS(2830),
    [anon_sym__Nonnull] = ACTIONS(2830),
    [anon_sym_mutable] = ACTIONS(2830),
    [anon_sym_constinit] = ACTIONS(2830),
    [anon_sym_consteval] = ACTIONS(2830),
    [anon_sym_alignas] = ACTIONS(2830),
    [anon_sym__Alignas] = ACTIONS(2830),
    [sym_primitive_type] = ACTIONS(2830),
    [anon_sym_enum] = ACTIONS(2830),
    [anon_sym_class] = ACTIONS(2830),
    [anon_sym_struct] = ACTIONS(2830),
    [anon_sym_union] = ACTIONS(2830),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2830),
    [anon_sym_decltype] = ACTIONS(2830),
    [anon_sym_explicit] = ACTIONS(2830),
    [anon_sym_typename] = ACTIONS(2830),
    [anon_sym_template] = ACTIONS(2830),
    [anon_sym_operator] = ACTIONS(2830),
    [anon_sym_friend] = ACTIONS(2830),
    [anon_sym_public] = ACTIONS(2830),
    [anon_sym_private] = ACTIONS(2830),
    [anon_sym_protected] = ACTIONS(2830),
    [anon_sym_using] = ACTIONS(2830),
    [anon_sym_static_assert] = ACTIONS(2830),
  },
  [1785] = {
    [sym_identifier] = ACTIONS(5462),
    [aux_sym_preproc_def_token1] = ACTIONS(5462),
    [aux_sym_preproc_if_token1] = ACTIONS(5462),
    [aux_sym_preproc_if_token2] = ACTIONS(5462),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5462),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5462),
    [aux_sym_preproc_else_token1] = ACTIONS(5462),
    [aux_sym_preproc_elif_token1] = ACTIONS(5462),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5462),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5462),
    [sym_preproc_directive] = ACTIONS(5462),
    [anon_sym_LPAREN2] = ACTIONS(5464),
    [anon_sym_TILDE] = ACTIONS(5464),
    [anon_sym_STAR] = ACTIONS(5464),
    [anon_sym_AMP_AMP] = ACTIONS(5464),
    [anon_sym_AMP] = ACTIONS(5462),
    [anon_sym_SEMI] = ACTIONS(5464),
    [anon_sym___extension__] = ACTIONS(5462),
    [anon_sym_typedef] = ACTIONS(5462),
    [anon_sym_virtual] = ACTIONS(5462),
    [anon_sym_extern] = ACTIONS(5462),
    [anon_sym___attribute__] = ACTIONS(5462),
    [anon_sym___attribute] = ACTIONS(5462),
    [anon_sym_COLON_COLON] = ACTIONS(5464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5464),
    [anon_sym___declspec] = ACTIONS(5462),
    [anon_sym___based] = ACTIONS(5462),
    [anon_sym_signed] = ACTIONS(5462),
    [anon_sym_unsigned] = ACTIONS(5462),
    [anon_sym_long] = ACTIONS(5462),
    [anon_sym_short] = ACTIONS(5462),
    [anon_sym_LBRACK] = ACTIONS(5462),
    [anon_sym_static] = ACTIONS(5462),
    [anon_sym_register] = ACTIONS(5462),
    [anon_sym_inline] = ACTIONS(5462),
    [anon_sym___inline] = ACTIONS(5462),
    [anon_sym___inline__] = ACTIONS(5462),
    [anon_sym___forceinline] = ACTIONS(5462),
    [anon_sym_thread_local] = ACTIONS(5462),
    [anon_sym___thread] = ACTIONS(5462),
    [anon_sym_const] = ACTIONS(5462),
    [anon_sym_constexpr] = ACTIONS(5462),
    [anon_sym_volatile] = ACTIONS(5462),
    [anon_sym_restrict] = ACTIONS(5462),
    [anon_sym___restrict__] = ACTIONS(5462),
    [anon_sym__Atomic] = ACTIONS(5462),
    [anon_sym__Noreturn] = ACTIONS(5462),
    [anon_sym_noreturn] = ACTIONS(5462),
    [anon_sym__Nonnull] = ACTIONS(5462),
    [anon_sym_mutable] = ACTIONS(5462),
    [anon_sym_constinit] = ACTIONS(5462),
    [anon_sym_consteval] = ACTIONS(5462),
    [anon_sym_alignas] = ACTIONS(5462),
    [anon_sym__Alignas] = ACTIONS(5462),
    [sym_primitive_type] = ACTIONS(5462),
    [anon_sym_enum] = ACTIONS(5462),
    [anon_sym_class] = ACTIONS(5462),
    [anon_sym_struct] = ACTIONS(5462),
    [anon_sym_union] = ACTIONS(5462),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5462),
    [anon_sym_decltype] = ACTIONS(5462),
    [anon_sym_explicit] = ACTIONS(5462),
    [anon_sym_typename] = ACTIONS(5462),
    [anon_sym_template] = ACTIONS(5462),
    [anon_sym_operator] = ACTIONS(5462),
    [anon_sym_friend] = ACTIONS(5462),
    [anon_sym_public] = ACTIONS(5462),
    [anon_sym_private] = ACTIONS(5462),
    [anon_sym_protected] = ACTIONS(5462),
    [anon_sym_using] = ACTIONS(5462),
    [anon_sym_static_assert] = ACTIONS(5462),
  },
  [1786] = {
    [sym_identifier] = ACTIONS(5466),
    [aux_sym_preproc_def_token1] = ACTIONS(5466),
    [aux_sym_preproc_if_token1] = ACTIONS(5466),
    [aux_sym_preproc_if_token2] = ACTIONS(5466),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5466),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5466),
    [aux_sym_preproc_else_token1] = ACTIONS(5466),
    [aux_sym_preproc_elif_token1] = ACTIONS(5466),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5466),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5466),
    [sym_preproc_directive] = ACTIONS(5466),
    [anon_sym_LPAREN2] = ACTIONS(5468),
    [anon_sym_TILDE] = ACTIONS(5468),
    [anon_sym_STAR] = ACTIONS(5468),
    [anon_sym_AMP_AMP] = ACTIONS(5468),
    [anon_sym_AMP] = ACTIONS(5466),
    [anon_sym_SEMI] = ACTIONS(5468),
    [anon_sym___extension__] = ACTIONS(5466),
    [anon_sym_typedef] = ACTIONS(5466),
    [anon_sym_virtual] = ACTIONS(5466),
    [anon_sym_extern] = ACTIONS(5466),
    [anon_sym___attribute__] = ACTIONS(5466),
    [anon_sym___attribute] = ACTIONS(5466),
    [anon_sym_COLON_COLON] = ACTIONS(5468),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5468),
    [anon_sym___declspec] = ACTIONS(5466),
    [anon_sym___based] = ACTIONS(5466),
    [anon_sym_signed] = ACTIONS(5466),
    [anon_sym_unsigned] = ACTIONS(5466),
    [anon_sym_long] = ACTIONS(5466),
    [anon_sym_short] = ACTIONS(5466),
    [anon_sym_LBRACK] = ACTIONS(5466),
    [anon_sym_static] = ACTIONS(5466),
    [anon_sym_register] = ACTIONS(5466),
    [anon_sym_inline] = ACTIONS(5466),
    [anon_sym___inline] = ACTIONS(5466),
    [anon_sym___inline__] = ACTIONS(5466),
    [anon_sym___forceinline] = ACTIONS(5466),
    [anon_sym_thread_local] = ACTIONS(5466),
    [anon_sym___thread] = ACTIONS(5466),
    [anon_sym_const] = ACTIONS(5466),
    [anon_sym_constexpr] = ACTIONS(5466),
    [anon_sym_volatile] = ACTIONS(5466),
    [anon_sym_restrict] = ACTIONS(5466),
    [anon_sym___restrict__] = ACTIONS(5466),
    [anon_sym__Atomic] = ACTIONS(5466),
    [anon_sym__Noreturn] = ACTIONS(5466),
    [anon_sym_noreturn] = ACTIONS(5466),
    [anon_sym__Nonnull] = ACTIONS(5466),
    [anon_sym_mutable] = ACTIONS(5466),
    [anon_sym_constinit] = ACTIONS(5466),
    [anon_sym_consteval] = ACTIONS(5466),
    [anon_sym_alignas] = ACTIONS(5466),
    [anon_sym__Alignas] = ACTIONS(5466),
    [sym_primitive_type] = ACTIONS(5466),
    [anon_sym_enum] = ACTIONS(5466),
    [anon_sym_class] = ACTIONS(5466),
    [anon_sym_struct] = ACTIONS(5466),
    [anon_sym_union] = ACTIONS(5466),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5466),
    [anon_sym_decltype] = ACTIONS(5466),
    [anon_sym_explicit] = ACTIONS(5466),
    [anon_sym_typename] = ACTIONS(5466),
    [anon_sym_template] = ACTIONS(5466),
    [anon_sym_operator] = ACTIONS(5466),
    [anon_sym_friend] = ACTIONS(5466),
    [anon_sym_public] = ACTIONS(5466),
    [anon_sym_private] = ACTIONS(5466),
    [anon_sym_protected] = ACTIONS(5466),
    [anon_sym_using] = ACTIONS(5466),
    [anon_sym_static_assert] = ACTIONS(5466),
  },
  [1787] = {
    [sym_identifier] = ACTIONS(5470),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5472),
    [anon_sym_COMMA] = ACTIONS(5472),
    [anon_sym_RPAREN] = ACTIONS(5472),
    [anon_sym_LPAREN2] = ACTIONS(5472),
    [anon_sym_DASH] = ACTIONS(5470),
    [anon_sym_PLUS] = ACTIONS(5470),
    [anon_sym_STAR] = ACTIONS(5472),
    [anon_sym_SLASH] = ACTIONS(5470),
    [anon_sym_PERCENT] = ACTIONS(5472),
    [anon_sym_PIPE_PIPE] = ACTIONS(5472),
    [anon_sym_AMP_AMP] = ACTIONS(5472),
    [anon_sym_PIPE] = ACTIONS(5470),
    [anon_sym_CARET] = ACTIONS(5472),
    [anon_sym_AMP] = ACTIONS(5470),
    [anon_sym_EQ_EQ] = ACTIONS(5472),
    [anon_sym_BANG_EQ] = ACTIONS(5472),
    [anon_sym_GT] = ACTIONS(5470),
    [anon_sym_GT_EQ] = ACTIONS(5472),
    [anon_sym_LT_EQ] = ACTIONS(5470),
    [anon_sym_LT] = ACTIONS(5470),
    [anon_sym_LT_LT] = ACTIONS(5472),
    [anon_sym_GT_GT] = ACTIONS(5472),
    [anon_sym_SEMI] = ACTIONS(5472),
    [anon_sym___extension__] = ACTIONS(5470),
    [anon_sym___attribute__] = ACTIONS(5470),
    [anon_sym___attribute] = ACTIONS(5470),
    [anon_sym_COLON_COLON] = ACTIONS(5472),
    [anon_sym___based] = ACTIONS(5470),
    [anon_sym_LBRACE] = ACTIONS(5472),
    [anon_sym_RBRACE] = ACTIONS(5472),
    [anon_sym_signed] = ACTIONS(5470),
    [anon_sym_unsigned] = ACTIONS(5470),
    [anon_sym_long] = ACTIONS(5470),
    [anon_sym_short] = ACTIONS(5470),
    [anon_sym_LBRACK] = ACTIONS(5472),
    [anon_sym_RBRACK] = ACTIONS(5472),
    [anon_sym_const] = ACTIONS(5470),
    [anon_sym_constexpr] = ACTIONS(5470),
    [anon_sym_volatile] = ACTIONS(5470),
    [anon_sym_restrict] = ACTIONS(5470),
    [anon_sym___restrict__] = ACTIONS(5470),
    [anon_sym__Atomic] = ACTIONS(5470),
    [anon_sym__Noreturn] = ACTIONS(5470),
    [anon_sym_noreturn] = ACTIONS(5470),
    [anon_sym__Nonnull] = ACTIONS(5470),
    [anon_sym_mutable] = ACTIONS(5470),
    [anon_sym_constinit] = ACTIONS(5470),
    [anon_sym_consteval] = ACTIONS(5470),
    [anon_sym_alignas] = ACTIONS(5470),
    [anon_sym__Alignas] = ACTIONS(5470),
    [sym_primitive_type] = ACTIONS(5470),
    [anon_sym_COLON] = ACTIONS(5470),
    [anon_sym_QMARK] = ACTIONS(5472),
    [anon_sym_LT_EQ_GT] = ACTIONS(5472),
    [anon_sym_or] = ACTIONS(5470),
    [anon_sym_and] = ACTIONS(5470),
    [anon_sym_bitor] = ACTIONS(5470),
    [anon_sym_xor] = ACTIONS(5470),
    [anon_sym_bitand] = ACTIONS(5470),
    [anon_sym_not_eq] = ACTIONS(5470),
    [anon_sym_DASH_DASH] = ACTIONS(5472),
    [anon_sym_PLUS_PLUS] = ACTIONS(5472),
    [anon_sym_DOT] = ACTIONS(5470),
    [anon_sym_DOT_STAR] = ACTIONS(5472),
    [anon_sym_DASH_GT] = ACTIONS(5472),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5470),
    [anon_sym_decltype] = ACTIONS(5470),
    [anon_sym_final] = ACTIONS(5470),
    [anon_sym_override] = ACTIONS(5470),
    [anon_sym_requires] = ACTIONS(5470),
  },
  [1788] = {
    [sym_identifier] = ACTIONS(2980),
    [aux_sym_preproc_def_token1] = ACTIONS(2980),
    [aux_sym_preproc_if_token1] = ACTIONS(2980),
    [aux_sym_preproc_if_token2] = ACTIONS(2980),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2980),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2980),
    [aux_sym_preproc_else_token1] = ACTIONS(2980),
    [aux_sym_preproc_elif_token1] = ACTIONS(2980),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(2980),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(2980),
    [sym_preproc_directive] = ACTIONS(2980),
    [anon_sym_LPAREN2] = ACTIONS(2982),
    [anon_sym_TILDE] = ACTIONS(2982),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP_AMP] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2980),
    [anon_sym_SEMI] = ACTIONS(2982),
    [anon_sym___extension__] = ACTIONS(2980),
    [anon_sym_typedef] = ACTIONS(2980),
    [anon_sym_virtual] = ACTIONS(2980),
    [anon_sym_extern] = ACTIONS(2980),
    [anon_sym___attribute__] = ACTIONS(2980),
    [anon_sym___attribute] = ACTIONS(2980),
    [anon_sym_COLON_COLON] = ACTIONS(2982),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2982),
    [anon_sym___declspec] = ACTIONS(2980),
    [anon_sym___based] = ACTIONS(2980),
    [anon_sym_signed] = ACTIONS(2980),
    [anon_sym_unsigned] = ACTIONS(2980),
    [anon_sym_long] = ACTIONS(2980),
    [anon_sym_short] = ACTIONS(2980),
    [anon_sym_LBRACK] = ACTIONS(2980),
    [anon_sym_static] = ACTIONS(2980),
    [anon_sym_register] = ACTIONS(2980),
    [anon_sym_inline] = ACTIONS(2980),
    [anon_sym___inline] = ACTIONS(2980),
    [anon_sym___inline__] = ACTIONS(2980),
    [anon_sym___forceinline] = ACTIONS(2980),
    [anon_sym_thread_local] = ACTIONS(2980),
    [anon_sym___thread] = ACTIONS(2980),
    [anon_sym_const] = ACTIONS(2980),
    [anon_sym_constexpr] = ACTIONS(2980),
    [anon_sym_volatile] = ACTIONS(2980),
    [anon_sym_restrict] = ACTIONS(2980),
    [anon_sym___restrict__] = ACTIONS(2980),
    [anon_sym__Atomic] = ACTIONS(2980),
    [anon_sym__Noreturn] = ACTIONS(2980),
    [anon_sym_noreturn] = ACTIONS(2980),
    [anon_sym__Nonnull] = ACTIONS(2980),
    [anon_sym_mutable] = ACTIONS(2980),
    [anon_sym_constinit] = ACTIONS(2980),
    [anon_sym_consteval] = ACTIONS(2980),
    [anon_sym_alignas] = ACTIONS(2980),
    [anon_sym__Alignas] = ACTIONS(2980),
    [sym_primitive_type] = ACTIONS(2980),
    [anon_sym_enum] = ACTIONS(2980),
    [anon_sym_class] = ACTIONS(2980),
    [anon_sym_struct] = ACTIONS(2980),
    [anon_sym_union] = ACTIONS(2980),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2980),
    [anon_sym_decltype] = ACTIONS(2980),
    [anon_sym_explicit] = ACTIONS(2980),
    [anon_sym_typename] = ACTIONS(2980),
    [anon_sym_template] = ACTIONS(2980),
    [anon_sym_operator] = ACTIONS(2980),
    [anon_sym_friend] = ACTIONS(2980),
    [anon_sym_public] = ACTIONS(2980),
    [anon_sym_private] = ACTIONS(2980),
    [anon_sym_protected] = ACTIONS(2980),
    [anon_sym_using] = ACTIONS(2980),
    [anon_sym_static_assert] = ACTIONS(2980),
  },
  [1789] = {
    [sym_identifier] = ACTIONS(5474),
    [aux_sym_preproc_def_token1] = ACTIONS(5474),
    [aux_sym_preproc_if_token1] = ACTIONS(5474),
    [aux_sym_preproc_if_token2] = ACTIONS(5474),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5474),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5474),
    [aux_sym_preproc_else_token1] = ACTIONS(5474),
    [aux_sym_preproc_elif_token1] = ACTIONS(5474),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5474),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5474),
    [sym_preproc_directive] = ACTIONS(5474),
    [anon_sym_LPAREN2] = ACTIONS(5476),
    [anon_sym_TILDE] = ACTIONS(5476),
    [anon_sym_STAR] = ACTIONS(5476),
    [anon_sym_AMP_AMP] = ACTIONS(5476),
    [anon_sym_AMP] = ACTIONS(5474),
    [anon_sym_SEMI] = ACTIONS(5476),
    [anon_sym___extension__] = ACTIONS(5474),
    [anon_sym_typedef] = ACTIONS(5474),
    [anon_sym_virtual] = ACTIONS(5474),
    [anon_sym_extern] = ACTIONS(5474),
    [anon_sym___attribute__] = ACTIONS(5474),
    [anon_sym___attribute] = ACTIONS(5474),
    [anon_sym_COLON_COLON] = ACTIONS(5476),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5476),
    [anon_sym___declspec] = ACTIONS(5474),
    [anon_sym___based] = ACTIONS(5474),
    [anon_sym_signed] = ACTIONS(5474),
    [anon_sym_unsigned] = ACTIONS(5474),
    [anon_sym_long] = ACTIONS(5474),
    [anon_sym_short] = ACTIONS(5474),
    [anon_sym_LBRACK] = ACTIONS(5474),
    [anon_sym_static] = ACTIONS(5474),
    [anon_sym_register] = ACTIONS(5474),
    [anon_sym_inline] = ACTIONS(5474),
    [anon_sym___inline] = ACTIONS(5474),
    [anon_sym___inline__] = ACTIONS(5474),
    [anon_sym___forceinline] = ACTIONS(5474),
    [anon_sym_thread_local] = ACTIONS(5474),
    [anon_sym___thread] = ACTIONS(5474),
    [anon_sym_const] = ACTIONS(5474),
    [anon_sym_constexpr] = ACTIONS(5474),
    [anon_sym_volatile] = ACTIONS(5474),
    [anon_sym_restrict] = ACTIONS(5474),
    [anon_sym___restrict__] = ACTIONS(5474),
    [anon_sym__Atomic] = ACTIONS(5474),
    [anon_sym__Noreturn] = ACTIONS(5474),
    [anon_sym_noreturn] = ACTIONS(5474),
    [anon_sym__Nonnull] = ACTIONS(5474),
    [anon_sym_mutable] = ACTIONS(5474),
    [anon_sym_constinit] = ACTIONS(5474),
    [anon_sym_consteval] = ACTIONS(5474),
    [anon_sym_alignas] = ACTIONS(5474),
    [anon_sym__Alignas] = ACTIONS(5474),
    [sym_primitive_type] = ACTIONS(5474),
    [anon_sym_enum] = ACTIONS(5474),
    [anon_sym_class] = ACTIONS(5474),
    [anon_sym_struct] = ACTIONS(5474),
    [anon_sym_union] = ACTIONS(5474),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5474),
    [anon_sym_decltype] = ACTIONS(5474),
    [anon_sym_explicit] = ACTIONS(5474),
    [anon_sym_typename] = ACTIONS(5474),
    [anon_sym_template] = ACTIONS(5474),
    [anon_sym_operator] = ACTIONS(5474),
    [anon_sym_friend] = ACTIONS(5474),
    [anon_sym_public] = ACTIONS(5474),
    [anon_sym_private] = ACTIONS(5474),
    [anon_sym_protected] = ACTIONS(5474),
    [anon_sym_using] = ACTIONS(5474),
    [anon_sym_static_assert] = ACTIONS(5474),
  },
  [1790] = {
    [sym_identifier] = ACTIONS(5478),
    [aux_sym_preproc_def_token1] = ACTIONS(5478),
    [aux_sym_preproc_if_token1] = ACTIONS(5478),
    [aux_sym_preproc_if_token2] = ACTIONS(5478),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5478),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5478),
    [aux_sym_preproc_else_token1] = ACTIONS(5478),
    [aux_sym_preproc_elif_token1] = ACTIONS(5478),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5478),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5478),
    [sym_preproc_directive] = ACTIONS(5478),
    [anon_sym_LPAREN2] = ACTIONS(5480),
    [anon_sym_TILDE] = ACTIONS(5480),
    [anon_sym_STAR] = ACTIONS(5480),
    [anon_sym_AMP_AMP] = ACTIONS(5480),
    [anon_sym_AMP] = ACTIONS(5478),
    [anon_sym_SEMI] = ACTIONS(5480),
    [anon_sym___extension__] = ACTIONS(5478),
    [anon_sym_typedef] = ACTIONS(5478),
    [anon_sym_virtual] = ACTIONS(5478),
    [anon_sym_extern] = ACTIONS(5478),
    [anon_sym___attribute__] = ACTIONS(5478),
    [anon_sym___attribute] = ACTIONS(5478),
    [anon_sym_COLON_COLON] = ACTIONS(5480),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5480),
    [anon_sym___declspec] = ACTIONS(5478),
    [anon_sym___based] = ACTIONS(5478),
    [anon_sym_signed] = ACTIONS(5478),
    [anon_sym_unsigned] = ACTIONS(5478),
    [anon_sym_long] = ACTIONS(5478),
    [anon_sym_short] = ACTIONS(5478),
    [anon_sym_LBRACK] = ACTIONS(5478),
    [anon_sym_static] = ACTIONS(5478),
    [anon_sym_register] = ACTIONS(5478),
    [anon_sym_inline] = ACTIONS(5478),
    [anon_sym___inline] = ACTIONS(5478),
    [anon_sym___inline__] = ACTIONS(5478),
    [anon_sym___forceinline] = ACTIONS(5478),
    [anon_sym_thread_local] = ACTIONS(5478),
    [anon_sym___thread] = ACTIONS(5478),
    [anon_sym_const] = ACTIONS(5478),
    [anon_sym_constexpr] = ACTIONS(5478),
    [anon_sym_volatile] = ACTIONS(5478),
    [anon_sym_restrict] = ACTIONS(5478),
    [anon_sym___restrict__] = ACTIONS(5478),
    [anon_sym__Atomic] = ACTIONS(5478),
    [anon_sym__Noreturn] = ACTIONS(5478),
    [anon_sym_noreturn] = ACTIONS(5478),
    [anon_sym__Nonnull] = ACTIONS(5478),
    [anon_sym_mutable] = ACTIONS(5478),
    [anon_sym_constinit] = ACTIONS(5478),
    [anon_sym_consteval] = ACTIONS(5478),
    [anon_sym_alignas] = ACTIONS(5478),
    [anon_sym__Alignas] = ACTIONS(5478),
    [sym_primitive_type] = ACTIONS(5478),
    [anon_sym_enum] = ACTIONS(5478),
    [anon_sym_class] = ACTIONS(5478),
    [anon_sym_struct] = ACTIONS(5478),
    [anon_sym_union] = ACTIONS(5478),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5478),
    [anon_sym_decltype] = ACTIONS(5478),
    [anon_sym_explicit] = ACTIONS(5478),
    [anon_sym_typename] = ACTIONS(5478),
    [anon_sym_template] = ACTIONS(5478),
    [anon_sym_operator] = ACTIONS(5478),
    [anon_sym_friend] = ACTIONS(5478),
    [anon_sym_public] = ACTIONS(5478),
    [anon_sym_private] = ACTIONS(5478),
    [anon_sym_protected] = ACTIONS(5478),
    [anon_sym_using] = ACTIONS(5478),
    [anon_sym_static_assert] = ACTIONS(5478),
  },
  [1791] = {
    [sym_identifier] = ACTIONS(5482),
    [aux_sym_preproc_def_token1] = ACTIONS(5482),
    [aux_sym_preproc_if_token1] = ACTIONS(5482),
    [aux_sym_preproc_if_token2] = ACTIONS(5482),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5482),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5482),
    [aux_sym_preproc_else_token1] = ACTIONS(5482),
    [aux_sym_preproc_elif_token1] = ACTIONS(5482),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5482),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5482),
    [sym_preproc_directive] = ACTIONS(5482),
    [anon_sym_LPAREN2] = ACTIONS(5484),
    [anon_sym_TILDE] = ACTIONS(5484),
    [anon_sym_STAR] = ACTIONS(5484),
    [anon_sym_AMP_AMP] = ACTIONS(5484),
    [anon_sym_AMP] = ACTIONS(5482),
    [anon_sym_SEMI] = ACTIONS(5484),
    [anon_sym___extension__] = ACTIONS(5482),
    [anon_sym_typedef] = ACTIONS(5482),
    [anon_sym_virtual] = ACTIONS(5482),
    [anon_sym_extern] = ACTIONS(5482),
    [anon_sym___attribute__] = ACTIONS(5482),
    [anon_sym___attribute] = ACTIONS(5482),
    [anon_sym_COLON_COLON] = ACTIONS(5484),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5484),
    [anon_sym___declspec] = ACTIONS(5482),
    [anon_sym___based] = ACTIONS(5482),
    [anon_sym_signed] = ACTIONS(5482),
    [anon_sym_unsigned] = ACTIONS(5482),
    [anon_sym_long] = ACTIONS(5482),
    [anon_sym_short] = ACTIONS(5482),
    [anon_sym_LBRACK] = ACTIONS(5482),
    [anon_sym_static] = ACTIONS(5482),
    [anon_sym_register] = ACTIONS(5482),
    [anon_sym_inline] = ACTIONS(5482),
    [anon_sym___inline] = ACTIONS(5482),
    [anon_sym___inline__] = ACTIONS(5482),
    [anon_sym___forceinline] = ACTIONS(5482),
    [anon_sym_thread_local] = ACTIONS(5482),
    [anon_sym___thread] = ACTIONS(5482),
    [anon_sym_const] = ACTIONS(5482),
    [anon_sym_constexpr] = ACTIONS(5482),
    [anon_sym_volatile] = ACTIONS(5482),
    [anon_sym_restrict] = ACTIONS(5482),
    [anon_sym___restrict__] = ACTIONS(5482),
    [anon_sym__Atomic] = ACTIONS(5482),
    [anon_sym__Noreturn] = ACTIONS(5482),
    [anon_sym_noreturn] = ACTIONS(5482),
    [anon_sym__Nonnull] = ACTIONS(5482),
    [anon_sym_mutable] = ACTIONS(5482),
    [anon_sym_constinit] = ACTIONS(5482),
    [anon_sym_consteval] = ACTIONS(5482),
    [anon_sym_alignas] = ACTIONS(5482),
    [anon_sym__Alignas] = ACTIONS(5482),
    [sym_primitive_type] = ACTIONS(5482),
    [anon_sym_enum] = ACTIONS(5482),
    [anon_sym_class] = ACTIONS(5482),
    [anon_sym_struct] = ACTIONS(5482),
    [anon_sym_union] = ACTIONS(5482),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5482),
    [anon_sym_decltype] = ACTIONS(5482),
    [anon_sym_explicit] = ACTIONS(5482),
    [anon_sym_typename] = ACTIONS(5482),
    [anon_sym_template] = ACTIONS(5482),
    [anon_sym_operator] = ACTIONS(5482),
    [anon_sym_friend] = ACTIONS(5482),
    [anon_sym_public] = ACTIONS(5482),
    [anon_sym_private] = ACTIONS(5482),
    [anon_sym_protected] = ACTIONS(5482),
    [anon_sym_using] = ACTIONS(5482),
    [anon_sym_static_assert] = ACTIONS(5482),
  },
  [1792] = {
    [sym_identifier] = ACTIONS(5486),
    [aux_sym_preproc_def_token1] = ACTIONS(5486),
    [aux_sym_preproc_if_token1] = ACTIONS(5486),
    [aux_sym_preproc_if_token2] = ACTIONS(5486),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5486),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5486),
    [aux_sym_preproc_else_token1] = ACTIONS(5486),
    [aux_sym_preproc_elif_token1] = ACTIONS(5486),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5486),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5486),
    [sym_preproc_directive] = ACTIONS(5486),
    [anon_sym_LPAREN2] = ACTIONS(5488),
    [anon_sym_TILDE] = ACTIONS(5488),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP_AMP] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5486),
    [anon_sym_SEMI] = ACTIONS(5488),
    [anon_sym___extension__] = ACTIONS(5486),
    [anon_sym_typedef] = ACTIONS(5486),
    [anon_sym_virtual] = ACTIONS(5486),
    [anon_sym_extern] = ACTIONS(5486),
    [anon_sym___attribute__] = ACTIONS(5486),
    [anon_sym___attribute] = ACTIONS(5486),
    [anon_sym_COLON_COLON] = ACTIONS(5488),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5488),
    [anon_sym___declspec] = ACTIONS(5486),
    [anon_sym___based] = ACTIONS(5486),
    [anon_sym_signed] = ACTIONS(5486),
    [anon_sym_unsigned] = ACTIONS(5486),
    [anon_sym_long] = ACTIONS(5486),
    [anon_sym_short] = ACTIONS(5486),
    [anon_sym_LBRACK] = ACTIONS(5486),
    [anon_sym_static] = ACTIONS(5486),
    [anon_sym_register] = ACTIONS(5486),
    [anon_sym_inline] = ACTIONS(5486),
    [anon_sym___inline] = ACTIONS(5486),
    [anon_sym___inline__] = ACTIONS(5486),
    [anon_sym___forceinline] = ACTIONS(5486),
    [anon_sym_thread_local] = ACTIONS(5486),
    [anon_sym___thread] = ACTIONS(5486),
    [anon_sym_const] = ACTIONS(5486),
    [anon_sym_constexpr] = ACTIONS(5486),
    [anon_sym_volatile] = ACTIONS(5486),
    [anon_sym_restrict] = ACTIONS(5486),
    [anon_sym___restrict__] = ACTIONS(5486),
    [anon_sym__Atomic] = ACTIONS(5486),
    [anon_sym__Noreturn] = ACTIONS(5486),
    [anon_sym_noreturn] = ACTIONS(5486),
    [anon_sym__Nonnull] = ACTIONS(5486),
    [anon_sym_mutable] = ACTIONS(5486),
    [anon_sym_constinit] = ACTIONS(5486),
    [anon_sym_consteval] = ACTIONS(5486),
    [anon_sym_alignas] = ACTIONS(5486),
    [anon_sym__Alignas] = ACTIONS(5486),
    [sym_primitive_type] = ACTIONS(5486),
    [anon_sym_enum] = ACTIONS(5486),
    [anon_sym_class] = ACTIONS(5486),
    [anon_sym_struct] = ACTIONS(5486),
    [anon_sym_union] = ACTIONS(5486),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5486),
    [anon_sym_decltype] = ACTIONS(5486),
    [anon_sym_explicit] = ACTIONS(5486),
    [anon_sym_typename] = ACTIONS(5486),
    [anon_sym_template] = ACTIONS(5486),
    [anon_sym_operator] = ACTIONS(5486),
    [anon_sym_friend] = ACTIONS(5486),
    [anon_sym_public] = ACTIONS(5486),
    [anon_sym_private] = ACTIONS(5486),
    [anon_sym_protected] = ACTIONS(5486),
    [anon_sym_using] = ACTIONS(5486),
    [anon_sym_static_assert] = ACTIONS(5486),
  },
  [1793] = {
    [sym_identifier] = ACTIONS(5435),
    [aux_sym_preproc_def_token1] = ACTIONS(5435),
    [aux_sym_preproc_if_token1] = ACTIONS(5435),
    [aux_sym_preproc_if_token2] = ACTIONS(5435),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5435),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5435),
    [aux_sym_preproc_else_token1] = ACTIONS(5435),
    [aux_sym_preproc_elif_token1] = ACTIONS(5435),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5435),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5435),
    [sym_preproc_directive] = ACTIONS(5435),
    [anon_sym_LPAREN2] = ACTIONS(5437),
    [anon_sym_TILDE] = ACTIONS(5437),
    [anon_sym_STAR] = ACTIONS(5437),
    [anon_sym_AMP_AMP] = ACTIONS(5437),
    [anon_sym_AMP] = ACTIONS(5435),
    [anon_sym_SEMI] = ACTIONS(5437),
    [anon_sym___extension__] = ACTIONS(5435),
    [anon_sym_typedef] = ACTIONS(5435),
    [anon_sym_virtual] = ACTIONS(5435),
    [anon_sym_extern] = ACTIONS(5435),
    [anon_sym___attribute__] = ACTIONS(5435),
    [anon_sym___attribute] = ACTIONS(5435),
    [anon_sym_COLON_COLON] = ACTIONS(5437),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5437),
    [anon_sym___declspec] = ACTIONS(5435),
    [anon_sym___based] = ACTIONS(5435),
    [anon_sym_signed] = ACTIONS(5435),
    [anon_sym_unsigned] = ACTIONS(5435),
    [anon_sym_long] = ACTIONS(5435),
    [anon_sym_short] = ACTIONS(5435),
    [anon_sym_LBRACK] = ACTIONS(5435),
    [anon_sym_static] = ACTIONS(5435),
    [anon_sym_register] = ACTIONS(5435),
    [anon_sym_inline] = ACTIONS(5435),
    [anon_sym___inline] = ACTIONS(5435),
    [anon_sym___inline__] = ACTIONS(5435),
    [anon_sym___forceinline] = ACTIONS(5435),
    [anon_sym_thread_local] = ACTIONS(5435),
    [anon_sym___thread] = ACTIONS(5435),
    [anon_sym_const] = ACTIONS(5435),
    [anon_sym_constexpr] = ACTIONS(5435),
    [anon_sym_volatile] = ACTIONS(5435),
    [anon_sym_restrict] = ACTIONS(5435),
    [anon_sym___restrict__] = ACTIONS(5435),
    [anon_sym__Atomic] = ACTIONS(5435),
    [anon_sym__Noreturn] = ACTIONS(5435),
    [anon_sym_noreturn] = ACTIONS(5435),
    [anon_sym__Nonnull] = ACTIONS(5435),
    [anon_sym_mutable] = ACTIONS(5435),
    [anon_sym_constinit] = ACTIONS(5435),
    [anon_sym_consteval] = ACTIONS(5435),
    [anon_sym_alignas] = ACTIONS(5435),
    [anon_sym__Alignas] = ACTIONS(5435),
    [sym_primitive_type] = ACTIONS(5435),
    [anon_sym_enum] = ACTIONS(5435),
    [anon_sym_class] = ACTIONS(5435),
    [anon_sym_struct] = ACTIONS(5435),
    [anon_sym_union] = ACTIONS(5435),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5435),
    [anon_sym_decltype] = ACTIONS(5435),
    [anon_sym_explicit] = ACTIONS(5435),
    [anon_sym_typename] = ACTIONS(5435),
    [anon_sym_template] = ACTIONS(5435),
    [anon_sym_operator] = ACTIONS(5435),
    [anon_sym_friend] = ACTIONS(5435),
    [anon_sym_public] = ACTIONS(5435),
    [anon_sym_private] = ACTIONS(5435),
    [anon_sym_protected] = ACTIONS(5435),
    [anon_sym_using] = ACTIONS(5435),
    [anon_sym_static_assert] = ACTIONS(5435),
  },
  [1794] = {
    [sym_identifier] = ACTIONS(5490),
    [aux_sym_preproc_def_token1] = ACTIONS(5490),
    [aux_sym_preproc_if_token1] = ACTIONS(5490),
    [aux_sym_preproc_if_token2] = ACTIONS(5490),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5490),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5490),
    [aux_sym_preproc_else_token1] = ACTIONS(5490),
    [aux_sym_preproc_elif_token1] = ACTIONS(5490),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5490),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5490),
    [sym_preproc_directive] = ACTIONS(5490),
    [anon_sym_LPAREN2] = ACTIONS(5492),
    [anon_sym_TILDE] = ACTIONS(5492),
    [anon_sym_STAR] = ACTIONS(5492),
    [anon_sym_AMP_AMP] = ACTIONS(5492),
    [anon_sym_AMP] = ACTIONS(5490),
    [anon_sym_SEMI] = ACTIONS(5492),
    [anon_sym___extension__] = ACTIONS(5490),
    [anon_sym_typedef] = ACTIONS(5490),
    [anon_sym_virtual] = ACTIONS(5490),
    [anon_sym_extern] = ACTIONS(5490),
    [anon_sym___attribute__] = ACTIONS(5490),
    [anon_sym___attribute] = ACTIONS(5490),
    [anon_sym_COLON_COLON] = ACTIONS(5492),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5492),
    [anon_sym___declspec] = ACTIONS(5490),
    [anon_sym___based] = ACTIONS(5490),
    [anon_sym_signed] = ACTIONS(5490),
    [anon_sym_unsigned] = ACTIONS(5490),
    [anon_sym_long] = ACTIONS(5490),
    [anon_sym_short] = ACTIONS(5490),
    [anon_sym_LBRACK] = ACTIONS(5490),
    [anon_sym_static] = ACTIONS(5490),
    [anon_sym_register] = ACTIONS(5490),
    [anon_sym_inline] = ACTIONS(5490),
    [anon_sym___inline] = ACTIONS(5490),
    [anon_sym___inline__] = ACTIONS(5490),
    [anon_sym___forceinline] = ACTIONS(5490),
    [anon_sym_thread_local] = ACTIONS(5490),
    [anon_sym___thread] = ACTIONS(5490),
    [anon_sym_const] = ACTIONS(5490),
    [anon_sym_constexpr] = ACTIONS(5490),
    [anon_sym_volatile] = ACTIONS(5490),
    [anon_sym_restrict] = ACTIONS(5490),
    [anon_sym___restrict__] = ACTIONS(5490),
    [anon_sym__Atomic] = ACTIONS(5490),
    [anon_sym__Noreturn] = ACTIONS(5490),
    [anon_sym_noreturn] = ACTIONS(5490),
    [anon_sym__Nonnull] = ACTIONS(5490),
    [anon_sym_mutable] = ACTIONS(5490),
    [anon_sym_constinit] = ACTIONS(5490),
    [anon_sym_consteval] = ACTIONS(5490),
    [anon_sym_alignas] = ACTIONS(5490),
    [anon_sym__Alignas] = ACTIONS(5490),
    [sym_primitive_type] = ACTIONS(5490),
    [anon_sym_enum] = ACTIONS(5490),
    [anon_sym_class] = ACTIONS(5490),
    [anon_sym_struct] = ACTIONS(5490),
    [anon_sym_union] = ACTIONS(5490),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5490),
    [anon_sym_decltype] = ACTIONS(5490),
    [anon_sym_explicit] = ACTIONS(5490),
    [anon_sym_typename] = ACTIONS(5490),
    [anon_sym_template] = ACTIONS(5490),
    [anon_sym_operator] = ACTIONS(5490),
    [anon_sym_friend] = ACTIONS(5490),
    [anon_sym_public] = ACTIONS(5490),
    [anon_sym_private] = ACTIONS(5490),
    [anon_sym_protected] = ACTIONS(5490),
    [anon_sym_using] = ACTIONS(5490),
    [anon_sym_static_assert] = ACTIONS(5490),
  },
  [1795] = {
    [sym_identifier] = ACTIONS(5494),
    [aux_sym_preproc_def_token1] = ACTIONS(5494),
    [aux_sym_preproc_if_token1] = ACTIONS(5494),
    [aux_sym_preproc_if_token2] = ACTIONS(5494),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5494),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5494),
    [aux_sym_preproc_else_token1] = ACTIONS(5494),
    [aux_sym_preproc_elif_token1] = ACTIONS(5494),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5494),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5494),
    [sym_preproc_directive] = ACTIONS(5494),
    [anon_sym_LPAREN2] = ACTIONS(5496),
    [anon_sym_TILDE] = ACTIONS(5496),
    [anon_sym_STAR] = ACTIONS(5496),
    [anon_sym_AMP_AMP] = ACTIONS(5496),
    [anon_sym_AMP] = ACTIONS(5494),
    [anon_sym_SEMI] = ACTIONS(5496),
    [anon_sym___extension__] = ACTIONS(5494),
    [anon_sym_typedef] = ACTIONS(5494),
    [anon_sym_virtual] = ACTIONS(5494),
    [anon_sym_extern] = ACTIONS(5494),
    [anon_sym___attribute__] = ACTIONS(5494),
    [anon_sym___attribute] = ACTIONS(5494),
    [anon_sym_COLON_COLON] = ACTIONS(5496),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5496),
    [anon_sym___declspec] = ACTIONS(5494),
    [anon_sym___based] = ACTIONS(5494),
    [anon_sym_signed] = ACTIONS(5494),
    [anon_sym_unsigned] = ACTIONS(5494),
    [anon_sym_long] = ACTIONS(5494),
    [anon_sym_short] = ACTIONS(5494),
    [anon_sym_LBRACK] = ACTIONS(5494),
    [anon_sym_static] = ACTIONS(5494),
    [anon_sym_register] = ACTIONS(5494),
    [anon_sym_inline] = ACTIONS(5494),
    [anon_sym___inline] = ACTIONS(5494),
    [anon_sym___inline__] = ACTIONS(5494),
    [anon_sym___forceinline] = ACTIONS(5494),
    [anon_sym_thread_local] = ACTIONS(5494),
    [anon_sym___thread] = ACTIONS(5494),
    [anon_sym_const] = ACTIONS(5494),
    [anon_sym_constexpr] = ACTIONS(5494),
    [anon_sym_volatile] = ACTIONS(5494),
    [anon_sym_restrict] = ACTIONS(5494),
    [anon_sym___restrict__] = ACTIONS(5494),
    [anon_sym__Atomic] = ACTIONS(5494),
    [anon_sym__Noreturn] = ACTIONS(5494),
    [anon_sym_noreturn] = ACTIONS(5494),
    [anon_sym__Nonnull] = ACTIONS(5494),
    [anon_sym_mutable] = ACTIONS(5494),
    [anon_sym_constinit] = ACTIONS(5494),
    [anon_sym_consteval] = ACTIONS(5494),
    [anon_sym_alignas] = ACTIONS(5494),
    [anon_sym__Alignas] = ACTIONS(5494),
    [sym_primitive_type] = ACTIONS(5494),
    [anon_sym_enum] = ACTIONS(5494),
    [anon_sym_class] = ACTIONS(5494),
    [anon_sym_struct] = ACTIONS(5494),
    [anon_sym_union] = ACTIONS(5494),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5494),
    [anon_sym_decltype] = ACTIONS(5494),
    [anon_sym_explicit] = ACTIONS(5494),
    [anon_sym_typename] = ACTIONS(5494),
    [anon_sym_template] = ACTIONS(5494),
    [anon_sym_operator] = ACTIONS(5494),
    [anon_sym_friend] = ACTIONS(5494),
    [anon_sym_public] = ACTIONS(5494),
    [anon_sym_private] = ACTIONS(5494),
    [anon_sym_protected] = ACTIONS(5494),
    [anon_sym_using] = ACTIONS(5494),
    [anon_sym_static_assert] = ACTIONS(5494),
  },
  [1796] = {
    [sym_identifier] = ACTIONS(5498),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5500),
    [anon_sym_COMMA] = ACTIONS(5500),
    [anon_sym_RPAREN] = ACTIONS(5500),
    [anon_sym_LPAREN2] = ACTIONS(5500),
    [anon_sym_DASH] = ACTIONS(5498),
    [anon_sym_PLUS] = ACTIONS(5498),
    [anon_sym_STAR] = ACTIONS(5500),
    [anon_sym_SLASH] = ACTIONS(5498),
    [anon_sym_PERCENT] = ACTIONS(5500),
    [anon_sym_PIPE_PIPE] = ACTIONS(5500),
    [anon_sym_AMP_AMP] = ACTIONS(5500),
    [anon_sym_PIPE] = ACTIONS(5498),
    [anon_sym_CARET] = ACTIONS(5500),
    [anon_sym_AMP] = ACTIONS(5498),
    [anon_sym_EQ_EQ] = ACTIONS(5500),
    [anon_sym_BANG_EQ] = ACTIONS(5500),
    [anon_sym_GT] = ACTIONS(5498),
    [anon_sym_GT_EQ] = ACTIONS(5500),
    [anon_sym_LT_EQ] = ACTIONS(5498),
    [anon_sym_LT] = ACTIONS(5498),
    [anon_sym_LT_LT] = ACTIONS(5500),
    [anon_sym_GT_GT] = ACTIONS(5500),
    [anon_sym_SEMI] = ACTIONS(5500),
    [anon_sym___extension__] = ACTIONS(5498),
    [anon_sym___attribute__] = ACTIONS(5498),
    [anon_sym___attribute] = ACTIONS(5498),
    [anon_sym___based] = ACTIONS(5498),
    [anon_sym_LBRACE] = ACTIONS(5500),
    [anon_sym_RBRACE] = ACTIONS(5500),
    [anon_sym_signed] = ACTIONS(5498),
    [anon_sym_unsigned] = ACTIONS(5498),
    [anon_sym_long] = ACTIONS(5498),
    [anon_sym_short] = ACTIONS(5498),
    [anon_sym_LBRACK] = ACTIONS(5500),
    [anon_sym_RBRACK] = ACTIONS(5500),
    [anon_sym_const] = ACTIONS(5498),
    [anon_sym_constexpr] = ACTIONS(5498),
    [anon_sym_volatile] = ACTIONS(5498),
    [anon_sym_restrict] = ACTIONS(5498),
    [anon_sym___restrict__] = ACTIONS(5498),
    [anon_sym__Atomic] = ACTIONS(5498),
    [anon_sym__Noreturn] = ACTIONS(5498),
    [anon_sym_noreturn] = ACTIONS(5498),
    [anon_sym__Nonnull] = ACTIONS(5498),
    [anon_sym_mutable] = ACTIONS(5498),
    [anon_sym_constinit] = ACTIONS(5498),
    [anon_sym_consteval] = ACTIONS(5498),
    [anon_sym_alignas] = ACTIONS(5498),
    [anon_sym__Alignas] = ACTIONS(5498),
    [sym_primitive_type] = ACTIONS(5498),
    [anon_sym_COLON] = ACTIONS(5500),
    [anon_sym_QMARK] = ACTIONS(5500),
    [anon_sym_LT_EQ_GT] = ACTIONS(5500),
    [anon_sym_or] = ACTIONS(5498),
    [anon_sym_and] = ACTIONS(5498),
    [anon_sym_bitor] = ACTIONS(5498),
    [anon_sym_xor] = ACTIONS(5498),
    [anon_sym_bitand] = ACTIONS(5498),
    [anon_sym_not_eq] = ACTIONS(5498),
    [anon_sym_DASH_DASH] = ACTIONS(5500),
    [anon_sym_PLUS_PLUS] = ACTIONS(5500),
    [anon_sym_DOT] = ACTIONS(5498),
    [anon_sym_DOT_STAR] = ACTIONS(5500),
    [anon_sym_DASH_GT] = ACTIONS(5500),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5498),
    [anon_sym_decltype] = ACTIONS(5498),
    [anon_sym_final] = ACTIONS(5498),
    [anon_sym_override] = ACTIONS(5498),
    [anon_sym_requires] = ACTIONS(5498),
  },
  [1797] = {
    [sym_identifier] = ACTIONS(5502),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5504),
    [anon_sym_COMMA] = ACTIONS(5504),
    [anon_sym_RPAREN] = ACTIONS(5504),
    [anon_sym_LPAREN2] = ACTIONS(5504),
    [anon_sym_DASH] = ACTIONS(5502),
    [anon_sym_PLUS] = ACTIONS(5502),
    [anon_sym_STAR] = ACTIONS(5504),
    [anon_sym_SLASH] = ACTIONS(5502),
    [anon_sym_PERCENT] = ACTIONS(5504),
    [anon_sym_PIPE_PIPE] = ACTIONS(5504),
    [anon_sym_AMP_AMP] = ACTIONS(5504),
    [anon_sym_PIPE] = ACTIONS(5502),
    [anon_sym_CARET] = ACTIONS(5504),
    [anon_sym_AMP] = ACTIONS(5502),
    [anon_sym_EQ_EQ] = ACTIONS(5504),
    [anon_sym_BANG_EQ] = ACTIONS(5504),
    [anon_sym_GT] = ACTIONS(5502),
    [anon_sym_GT_EQ] = ACTIONS(5504),
    [anon_sym_LT_EQ] = ACTIONS(5502),
    [anon_sym_LT] = ACTIONS(5502),
    [anon_sym_LT_LT] = ACTIONS(5504),
    [anon_sym_GT_GT] = ACTIONS(5504),
    [anon_sym_SEMI] = ACTIONS(5504),
    [anon_sym___extension__] = ACTIONS(5502),
    [anon_sym___attribute__] = ACTIONS(5502),
    [anon_sym___attribute] = ACTIONS(5502),
    [anon_sym___based] = ACTIONS(5502),
    [anon_sym_LBRACE] = ACTIONS(5504),
    [anon_sym_RBRACE] = ACTIONS(5504),
    [anon_sym_signed] = ACTIONS(5502),
    [anon_sym_unsigned] = ACTIONS(5502),
    [anon_sym_long] = ACTIONS(5502),
    [anon_sym_short] = ACTIONS(5502),
    [anon_sym_LBRACK] = ACTIONS(5504),
    [anon_sym_RBRACK] = ACTIONS(5504),
    [anon_sym_const] = ACTIONS(5502),
    [anon_sym_constexpr] = ACTIONS(5502),
    [anon_sym_volatile] = ACTIONS(5502),
    [anon_sym_restrict] = ACTIONS(5502),
    [anon_sym___restrict__] = ACTIONS(5502),
    [anon_sym__Atomic] = ACTIONS(5502),
    [anon_sym__Noreturn] = ACTIONS(5502),
    [anon_sym_noreturn] = ACTIONS(5502),
    [anon_sym__Nonnull] = ACTIONS(5502),
    [anon_sym_mutable] = ACTIONS(5502),
    [anon_sym_constinit] = ACTIONS(5502),
    [anon_sym_consteval] = ACTIONS(5502),
    [anon_sym_alignas] = ACTIONS(5502),
    [anon_sym__Alignas] = ACTIONS(5502),
    [sym_primitive_type] = ACTIONS(5502),
    [anon_sym_COLON] = ACTIONS(5504),
    [anon_sym_QMARK] = ACTIONS(5504),
    [anon_sym_LT_EQ_GT] = ACTIONS(5504),
    [anon_sym_or] = ACTIONS(5502),
    [anon_sym_and] = ACTIONS(5502),
    [anon_sym_bitor] = ACTIONS(5502),
    [anon_sym_xor] = ACTIONS(5502),
    [anon_sym_bitand] = ACTIONS(5502),
    [anon_sym_not_eq] = ACTIONS(5502),
    [anon_sym_DASH_DASH] = ACTIONS(5504),
    [anon_sym_PLUS_PLUS] = ACTIONS(5504),
    [anon_sym_DOT] = ACTIONS(5502),
    [anon_sym_DOT_STAR] = ACTIONS(5504),
    [anon_sym_DASH_GT] = ACTIONS(5504),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5502),
    [anon_sym_decltype] = ACTIONS(5502),
    [anon_sym_final] = ACTIONS(5502),
    [anon_sym_override] = ACTIONS(5502),
    [anon_sym_requires] = ACTIONS(5502),
  },
  [1798] = {
    [sym_identifier] = ACTIONS(5506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5508),
    [anon_sym_COMMA] = ACTIONS(5508),
    [anon_sym_RPAREN] = ACTIONS(5508),
    [anon_sym_LPAREN2] = ACTIONS(5508),
    [anon_sym_DASH] = ACTIONS(5506),
    [anon_sym_PLUS] = ACTIONS(5506),
    [anon_sym_STAR] = ACTIONS(5508),
    [anon_sym_SLASH] = ACTIONS(5506),
    [anon_sym_PERCENT] = ACTIONS(5508),
    [anon_sym_PIPE_PIPE] = ACTIONS(5508),
    [anon_sym_AMP_AMP] = ACTIONS(5508),
    [anon_sym_PIPE] = ACTIONS(5506),
    [anon_sym_CARET] = ACTIONS(5508),
    [anon_sym_AMP] = ACTIONS(5506),
    [anon_sym_EQ_EQ] = ACTIONS(5508),
    [anon_sym_BANG_EQ] = ACTIONS(5508),
    [anon_sym_GT] = ACTIONS(5506),
    [anon_sym_GT_EQ] = ACTIONS(5508),
    [anon_sym_LT_EQ] = ACTIONS(5506),
    [anon_sym_LT] = ACTIONS(5506),
    [anon_sym_LT_LT] = ACTIONS(5508),
    [anon_sym_GT_GT] = ACTIONS(5508),
    [anon_sym_SEMI] = ACTIONS(5508),
    [anon_sym___extension__] = ACTIONS(5506),
    [anon_sym___attribute__] = ACTIONS(5506),
    [anon_sym___attribute] = ACTIONS(5506),
    [anon_sym___based] = ACTIONS(5506),
    [anon_sym_LBRACE] = ACTIONS(5508),
    [anon_sym_RBRACE] = ACTIONS(5508),
    [anon_sym_signed] = ACTIONS(5506),
    [anon_sym_unsigned] = ACTIONS(5506),
    [anon_sym_long] = ACTIONS(5506),
    [anon_sym_short] = ACTIONS(5506),
    [anon_sym_LBRACK] = ACTIONS(5508),
    [anon_sym_RBRACK] = ACTIONS(5508),
    [anon_sym_const] = ACTIONS(5506),
    [anon_sym_constexpr] = ACTIONS(5506),
    [anon_sym_volatile] = ACTIONS(5506),
    [anon_sym_restrict] = ACTIONS(5506),
    [anon_sym___restrict__] = ACTIONS(5506),
    [anon_sym__Atomic] = ACTIONS(5506),
    [anon_sym__Noreturn] = ACTIONS(5506),
    [anon_sym_noreturn] = ACTIONS(5506),
    [anon_sym__Nonnull] = ACTIONS(5506),
    [anon_sym_mutable] = ACTIONS(5506),
    [anon_sym_constinit] = ACTIONS(5506),
    [anon_sym_consteval] = ACTIONS(5506),
    [anon_sym_alignas] = ACTIONS(5506),
    [anon_sym__Alignas] = ACTIONS(5506),
    [sym_primitive_type] = ACTIONS(5506),
    [anon_sym_COLON] = ACTIONS(5508),
    [anon_sym_QMARK] = ACTIONS(5508),
    [anon_sym_LT_EQ_GT] = ACTIONS(5508),
    [anon_sym_or] = ACTIONS(5506),
    [anon_sym_and] = ACTIONS(5506),
    [anon_sym_bitor] = ACTIONS(5506),
    [anon_sym_xor] = ACTIONS(5506),
    [anon_sym_bitand] = ACTIONS(5506),
    [anon_sym_not_eq] = ACTIONS(5506),
    [anon_sym_DASH_DASH] = ACTIONS(5508),
    [anon_sym_PLUS_PLUS] = ACTIONS(5508),
    [anon_sym_DOT] = ACTIONS(5506),
    [anon_sym_DOT_STAR] = ACTIONS(5508),
    [anon_sym_DASH_GT] = ACTIONS(5508),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5506),
    [anon_sym_decltype] = ACTIONS(5506),
    [anon_sym_final] = ACTIONS(5506),
    [anon_sym_override] = ACTIONS(5506),
    [anon_sym_requires] = ACTIONS(5506),
  },
  [1799] = {
    [sym_identifier] = ACTIONS(5510),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5512),
    [anon_sym_COMMA] = ACTIONS(5512),
    [anon_sym_RPAREN] = ACTIONS(5512),
    [anon_sym_LPAREN2] = ACTIONS(5512),
    [anon_sym_DASH] = ACTIONS(5510),
    [anon_sym_PLUS] = ACTIONS(5510),
    [anon_sym_STAR] = ACTIONS(5512),
    [anon_sym_SLASH] = ACTIONS(5510),
    [anon_sym_PERCENT] = ACTIONS(5512),
    [anon_sym_PIPE_PIPE] = ACTIONS(5512),
    [anon_sym_AMP_AMP] = ACTIONS(5512),
    [anon_sym_PIPE] = ACTIONS(5510),
    [anon_sym_CARET] = ACTIONS(5512),
    [anon_sym_AMP] = ACTIONS(5510),
    [anon_sym_EQ_EQ] = ACTIONS(5512),
    [anon_sym_BANG_EQ] = ACTIONS(5512),
    [anon_sym_GT] = ACTIONS(5510),
    [anon_sym_GT_EQ] = ACTIONS(5512),
    [anon_sym_LT_EQ] = ACTIONS(5510),
    [anon_sym_LT] = ACTIONS(5510),
    [anon_sym_LT_LT] = ACTIONS(5512),
    [anon_sym_GT_GT] = ACTIONS(5512),
    [anon_sym_SEMI] = ACTIONS(5512),
    [anon_sym___extension__] = ACTIONS(5510),
    [anon_sym___attribute__] = ACTIONS(5510),
    [anon_sym___attribute] = ACTIONS(5510),
    [anon_sym___based] = ACTIONS(5510),
    [anon_sym_LBRACE] = ACTIONS(5512),
    [anon_sym_RBRACE] = ACTIONS(5512),
    [anon_sym_signed] = ACTIONS(5510),
    [anon_sym_unsigned] = ACTIONS(5510),
    [anon_sym_long] = ACTIONS(5510),
    [anon_sym_short] = ACTIONS(5510),
    [anon_sym_LBRACK] = ACTIONS(5512),
    [anon_sym_RBRACK] = ACTIONS(5512),
    [anon_sym_const] = ACTIONS(5510),
    [anon_sym_constexpr] = ACTIONS(5510),
    [anon_sym_volatile] = ACTIONS(5510),
    [anon_sym_restrict] = ACTIONS(5510),
    [anon_sym___restrict__] = ACTIONS(5510),
    [anon_sym__Atomic] = ACTIONS(5510),
    [anon_sym__Noreturn] = ACTIONS(5510),
    [anon_sym_noreturn] = ACTIONS(5510),
    [anon_sym__Nonnull] = ACTIONS(5510),
    [anon_sym_mutable] = ACTIONS(5510),
    [anon_sym_constinit] = ACTIONS(5510),
    [anon_sym_consteval] = ACTIONS(5510),
    [anon_sym_alignas] = ACTIONS(5510),
    [anon_sym__Alignas] = ACTIONS(5510),
    [sym_primitive_type] = ACTIONS(5510),
    [anon_sym_COLON] = ACTIONS(5512),
    [anon_sym_QMARK] = ACTIONS(5512),
    [anon_sym_LT_EQ_GT] = ACTIONS(5512),
    [anon_sym_or] = ACTIONS(5510),
    [anon_sym_and] = ACTIONS(5510),
    [anon_sym_bitor] = ACTIONS(5510),
    [anon_sym_xor] = ACTIONS(5510),
    [anon_sym_bitand] = ACTIONS(5510),
    [anon_sym_not_eq] = ACTIONS(5510),
    [anon_sym_DASH_DASH] = ACTIONS(5512),
    [anon_sym_PLUS_PLUS] = ACTIONS(5512),
    [anon_sym_DOT] = ACTIONS(5510),
    [anon_sym_DOT_STAR] = ACTIONS(5512),
    [anon_sym_DASH_GT] = ACTIONS(5512),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5510),
    [anon_sym_decltype] = ACTIONS(5510),
    [anon_sym_final] = ACTIONS(5510),
    [anon_sym_override] = ACTIONS(5510),
    [anon_sym_requires] = ACTIONS(5510),
  },
  [1800] = {
    [sym_identifier] = ACTIONS(5514),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5516),
    [anon_sym_COMMA] = ACTIONS(5516),
    [anon_sym_RPAREN] = ACTIONS(5516),
    [anon_sym_LPAREN2] = ACTIONS(5516),
    [anon_sym_DASH] = ACTIONS(5514),
    [anon_sym_PLUS] = ACTIONS(5514),
    [anon_sym_STAR] = ACTIONS(5516),
    [anon_sym_SLASH] = ACTIONS(5514),
    [anon_sym_PERCENT] = ACTIONS(5516),
    [anon_sym_PIPE_PIPE] = ACTIONS(5516),
    [anon_sym_AMP_AMP] = ACTIONS(5516),
    [anon_sym_PIPE] = ACTIONS(5514),
    [anon_sym_CARET] = ACTIONS(5516),
    [anon_sym_AMP] = ACTIONS(5514),
    [anon_sym_EQ_EQ] = ACTIONS(5516),
    [anon_sym_BANG_EQ] = ACTIONS(5516),
    [anon_sym_GT] = ACTIONS(5514),
    [anon_sym_GT_EQ] = ACTIONS(5516),
    [anon_sym_LT_EQ] = ACTIONS(5514),
    [anon_sym_LT] = ACTIONS(5514),
    [anon_sym_LT_LT] = ACTIONS(5516),
    [anon_sym_GT_GT] = ACTIONS(5516),
    [anon_sym_SEMI] = ACTIONS(5516),
    [anon_sym___extension__] = ACTIONS(5514),
    [anon_sym___attribute__] = ACTIONS(5514),
    [anon_sym___attribute] = ACTIONS(5514),
    [anon_sym___based] = ACTIONS(5514),
    [anon_sym_LBRACE] = ACTIONS(5516),
    [anon_sym_RBRACE] = ACTIONS(5516),
    [anon_sym_signed] = ACTIONS(5514),
    [anon_sym_unsigned] = ACTIONS(5514),
    [anon_sym_long] = ACTIONS(5514),
    [anon_sym_short] = ACTIONS(5514),
    [anon_sym_LBRACK] = ACTIONS(5516),
    [anon_sym_RBRACK] = ACTIONS(5516),
    [anon_sym_const] = ACTIONS(5514),
    [anon_sym_constexpr] = ACTIONS(5514),
    [anon_sym_volatile] = ACTIONS(5514),
    [anon_sym_restrict] = ACTIONS(5514),
    [anon_sym___restrict__] = ACTIONS(5514),
    [anon_sym__Atomic] = ACTIONS(5514),
    [anon_sym__Noreturn] = ACTIONS(5514),
    [anon_sym_noreturn] = ACTIONS(5514),
    [anon_sym__Nonnull] = ACTIONS(5514),
    [anon_sym_mutable] = ACTIONS(5514),
    [anon_sym_constinit] = ACTIONS(5514),
    [anon_sym_consteval] = ACTIONS(5514),
    [anon_sym_alignas] = ACTIONS(5514),
    [anon_sym__Alignas] = ACTIONS(5514),
    [sym_primitive_type] = ACTIONS(5514),
    [anon_sym_COLON] = ACTIONS(5516),
    [anon_sym_QMARK] = ACTIONS(5516),
    [anon_sym_LT_EQ_GT] = ACTIONS(5516),
    [anon_sym_or] = ACTIONS(5514),
    [anon_sym_and] = ACTIONS(5514),
    [anon_sym_bitor] = ACTIONS(5514),
    [anon_sym_xor] = ACTIONS(5514),
    [anon_sym_bitand] = ACTIONS(5514),
    [anon_sym_not_eq] = ACTIONS(5514),
    [anon_sym_DASH_DASH] = ACTIONS(5516),
    [anon_sym_PLUS_PLUS] = ACTIONS(5516),
    [anon_sym_DOT] = ACTIONS(5514),
    [anon_sym_DOT_STAR] = ACTIONS(5516),
    [anon_sym_DASH_GT] = ACTIONS(5516),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5514),
    [anon_sym_decltype] = ACTIONS(5514),
    [anon_sym_final] = ACTIONS(5514),
    [anon_sym_override] = ACTIONS(5514),
    [anon_sym_requires] = ACTIONS(5514),
  },
  [1801] = {
    [sym_type_qualifier] = STATE(1821),
    [sym_alignas_qualifier] = STATE(1651),
    [aux_sym__type_definition_type_repeat1] = STATE(1821),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1967),
    [sym_identifier] = ACTIONS(5518),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4946),
    [anon_sym_COMMA] = ACTIONS(4946),
    [aux_sym_preproc_if_token2] = ACTIONS(4946),
    [aux_sym_preproc_else_token1] = ACTIONS(4946),
    [aux_sym_preproc_elif_token1] = ACTIONS(4948),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4946),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(4946),
    [anon_sym_DASH] = ACTIONS(4948),
    [anon_sym_PLUS] = ACTIONS(4948),
    [anon_sym_STAR] = ACTIONS(4946),
    [anon_sym_SLASH] = ACTIONS(4948),
    [anon_sym_PERCENT] = ACTIONS(4946),
    [anon_sym_PIPE_PIPE] = ACTIONS(4946),
    [anon_sym_AMP_AMP] = ACTIONS(4946),
    [anon_sym_PIPE] = ACTIONS(4948),
    [anon_sym_CARET] = ACTIONS(4946),
    [anon_sym_AMP] = ACTIONS(4948),
    [anon_sym_EQ_EQ] = ACTIONS(4946),
    [anon_sym_BANG_EQ] = ACTIONS(4946),
    [anon_sym_GT] = ACTIONS(4948),
    [anon_sym_GT_EQ] = ACTIONS(4946),
    [anon_sym_LT_EQ] = ACTIONS(4948),
    [anon_sym_LT] = ACTIONS(4948),
    [anon_sym_LT_LT] = ACTIONS(4946),
    [anon_sym_GT_GT] = ACTIONS(4946),
    [anon_sym___extension__] = ACTIONS(5521),
    [anon_sym___attribute__] = ACTIONS(4948),
    [anon_sym___attribute] = ACTIONS(4948),
    [anon_sym_LBRACE] = ACTIONS(4946),
    [anon_sym_signed] = ACTIONS(5523),
    [anon_sym_unsigned] = ACTIONS(5523),
    [anon_sym_long] = ACTIONS(5523),
    [anon_sym_short] = ACTIONS(5523),
    [anon_sym_LBRACK] = ACTIONS(4946),
    [anon_sym_const] = ACTIONS(5521),
    [anon_sym_constexpr] = ACTIONS(5521),
    [anon_sym_volatile] = ACTIONS(5521),
    [anon_sym_restrict] = ACTIONS(5521),
    [anon_sym___restrict__] = ACTIONS(5521),
    [anon_sym__Atomic] = ACTIONS(5521),
    [anon_sym__Noreturn] = ACTIONS(5521),
    [anon_sym_noreturn] = ACTIONS(5521),
    [anon_sym__Nonnull] = ACTIONS(5521),
    [anon_sym_mutable] = ACTIONS(5521),
    [anon_sym_constinit] = ACTIONS(5521),
    [anon_sym_consteval] = ACTIONS(5521),
    [anon_sym_alignas] = ACTIONS(5525),
    [anon_sym__Alignas] = ACTIONS(5525),
    [sym_primitive_type] = ACTIONS(5527),
    [anon_sym_QMARK] = ACTIONS(4946),
    [anon_sym_LT_EQ_GT] = ACTIONS(4946),
    [anon_sym_or] = ACTIONS(4948),
    [anon_sym_and] = ACTIONS(4948),
    [anon_sym_bitor] = ACTIONS(4948),
    [anon_sym_xor] = ACTIONS(4948),
    [anon_sym_bitand] = ACTIONS(4948),
    [anon_sym_not_eq] = ACTIONS(4948),
    [anon_sym_DASH_DASH] = ACTIONS(4946),
    [anon_sym_PLUS_PLUS] = ACTIONS(4946),
    [anon_sym_DOT] = ACTIONS(4948),
    [anon_sym_DOT_STAR] = ACTIONS(4946),
    [anon_sym_DASH_GT] = ACTIONS(4946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4948),
    [anon_sym_decltype] = ACTIONS(4948),
  },
  [1802] = {
    [sym_identifier] = ACTIONS(5529),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5531),
    [anon_sym_COMMA] = ACTIONS(5531),
    [anon_sym_RPAREN] = ACTIONS(5531),
    [anon_sym_LPAREN2] = ACTIONS(5531),
    [anon_sym_DASH] = ACTIONS(5529),
    [anon_sym_PLUS] = ACTIONS(5529),
    [anon_sym_STAR] = ACTIONS(5531),
    [anon_sym_SLASH] = ACTIONS(5529),
    [anon_sym_PERCENT] = ACTIONS(5531),
    [anon_sym_PIPE_PIPE] = ACTIONS(5531),
    [anon_sym_AMP_AMP] = ACTIONS(5531),
    [anon_sym_PIPE] = ACTIONS(5529),
    [anon_sym_CARET] = ACTIONS(5531),
    [anon_sym_AMP] = ACTIONS(5529),
    [anon_sym_EQ_EQ] = ACTIONS(5531),
    [anon_sym_BANG_EQ] = ACTIONS(5531),
    [anon_sym_GT] = ACTIONS(5529),
    [anon_sym_GT_EQ] = ACTIONS(5531),
    [anon_sym_LT_EQ] = ACTIONS(5529),
    [anon_sym_LT] = ACTIONS(5529),
    [anon_sym_LT_LT] = ACTIONS(5531),
    [anon_sym_GT_GT] = ACTIONS(5531),
    [anon_sym_SEMI] = ACTIONS(5531),
    [anon_sym___extension__] = ACTIONS(5529),
    [anon_sym___attribute__] = ACTIONS(5529),
    [anon_sym___attribute] = ACTIONS(5529),
    [anon_sym___based] = ACTIONS(5529),
    [anon_sym_LBRACE] = ACTIONS(5531),
    [anon_sym_RBRACE] = ACTIONS(5531),
    [anon_sym_signed] = ACTIONS(5529),
    [anon_sym_unsigned] = ACTIONS(5529),
    [anon_sym_long] = ACTIONS(5529),
    [anon_sym_short] = ACTIONS(5529),
    [anon_sym_LBRACK] = ACTIONS(5531),
    [anon_sym_RBRACK] = ACTIONS(5531),
    [anon_sym_const] = ACTIONS(5529),
    [anon_sym_constexpr] = ACTIONS(5529),
    [anon_sym_volatile] = ACTIONS(5529),
    [anon_sym_restrict] = ACTIONS(5529),
    [anon_sym___restrict__] = ACTIONS(5529),
    [anon_sym__Atomic] = ACTIONS(5529),
    [anon_sym__Noreturn] = ACTIONS(5529),
    [anon_sym_noreturn] = ACTIONS(5529),
    [anon_sym__Nonnull] = ACTIONS(5529),
    [anon_sym_mutable] = ACTIONS(5529),
    [anon_sym_constinit] = ACTIONS(5529),
    [anon_sym_consteval] = ACTIONS(5529),
    [anon_sym_alignas] = ACTIONS(5529),
    [anon_sym__Alignas] = ACTIONS(5529),
    [sym_primitive_type] = ACTIONS(5529),
    [anon_sym_COLON] = ACTIONS(5531),
    [anon_sym_QMARK] = ACTIONS(5531),
    [anon_sym_LT_EQ_GT] = ACTIONS(5531),
    [anon_sym_or] = ACTIONS(5529),
    [anon_sym_and] = ACTIONS(5529),
    [anon_sym_bitor] = ACTIONS(5529),
    [anon_sym_xor] = ACTIONS(5529),
    [anon_sym_bitand] = ACTIONS(5529),
    [anon_sym_not_eq] = ACTIONS(5529),
    [anon_sym_DASH_DASH] = ACTIONS(5531),
    [anon_sym_PLUS_PLUS] = ACTIONS(5531),
    [anon_sym_DOT] = ACTIONS(5529),
    [anon_sym_DOT_STAR] = ACTIONS(5531),
    [anon_sym_DASH_GT] = ACTIONS(5531),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5529),
    [anon_sym_decltype] = ACTIONS(5529),
    [anon_sym_final] = ACTIONS(5529),
    [anon_sym_override] = ACTIONS(5529),
    [anon_sym_requires] = ACTIONS(5529),
  },
  [1803] = {
    [sym_identifier] = ACTIONS(5533),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5535),
    [anon_sym_COMMA] = ACTIONS(5535),
    [anon_sym_RPAREN] = ACTIONS(5535),
    [anon_sym_LPAREN2] = ACTIONS(5535),
    [anon_sym_DASH] = ACTIONS(5533),
    [anon_sym_PLUS] = ACTIONS(5533),
    [anon_sym_STAR] = ACTIONS(5535),
    [anon_sym_SLASH] = ACTIONS(5533),
    [anon_sym_PERCENT] = ACTIONS(5535),
    [anon_sym_PIPE_PIPE] = ACTIONS(5535),
    [anon_sym_AMP_AMP] = ACTIONS(5535),
    [anon_sym_PIPE] = ACTIONS(5533),
    [anon_sym_CARET] = ACTIONS(5535),
    [anon_sym_AMP] = ACTIONS(5533),
    [anon_sym_EQ_EQ] = ACTIONS(5535),
    [anon_sym_BANG_EQ] = ACTIONS(5535),
    [anon_sym_GT] = ACTIONS(5533),
    [anon_sym_GT_EQ] = ACTIONS(5535),
    [anon_sym_LT_EQ] = ACTIONS(5533),
    [anon_sym_LT] = ACTIONS(5533),
    [anon_sym_LT_LT] = ACTIONS(5535),
    [anon_sym_GT_GT] = ACTIONS(5535),
    [anon_sym_SEMI] = ACTIONS(5535),
    [anon_sym___extension__] = ACTIONS(5533),
    [anon_sym___attribute__] = ACTIONS(5533),
    [anon_sym___attribute] = ACTIONS(5533),
    [anon_sym___based] = ACTIONS(5533),
    [anon_sym_LBRACE] = ACTIONS(5535),
    [anon_sym_RBRACE] = ACTIONS(5535),
    [anon_sym_signed] = ACTIONS(5533),
    [anon_sym_unsigned] = ACTIONS(5533),
    [anon_sym_long] = ACTIONS(5533),
    [anon_sym_short] = ACTIONS(5533),
    [anon_sym_LBRACK] = ACTIONS(5535),
    [anon_sym_RBRACK] = ACTIONS(5535),
    [anon_sym_const] = ACTIONS(5533),
    [anon_sym_constexpr] = ACTIONS(5533),
    [anon_sym_volatile] = ACTIONS(5533),
    [anon_sym_restrict] = ACTIONS(5533),
    [anon_sym___restrict__] = ACTIONS(5533),
    [anon_sym__Atomic] = ACTIONS(5533),
    [anon_sym__Noreturn] = ACTIONS(5533),
    [anon_sym_noreturn] = ACTIONS(5533),
    [anon_sym__Nonnull] = ACTIONS(5533),
    [anon_sym_mutable] = ACTIONS(5533),
    [anon_sym_constinit] = ACTIONS(5533),
    [anon_sym_consteval] = ACTIONS(5533),
    [anon_sym_alignas] = ACTIONS(5533),
    [anon_sym__Alignas] = ACTIONS(5533),
    [sym_primitive_type] = ACTIONS(5533),
    [anon_sym_COLON] = ACTIONS(5535),
    [anon_sym_QMARK] = ACTIONS(5535),
    [anon_sym_LT_EQ_GT] = ACTIONS(5535),
    [anon_sym_or] = ACTIONS(5533),
    [anon_sym_and] = ACTIONS(5533),
    [anon_sym_bitor] = ACTIONS(5533),
    [anon_sym_xor] = ACTIONS(5533),
    [anon_sym_bitand] = ACTIONS(5533),
    [anon_sym_not_eq] = ACTIONS(5533),
    [anon_sym_DASH_DASH] = ACTIONS(5535),
    [anon_sym_PLUS_PLUS] = ACTIONS(5535),
    [anon_sym_DOT] = ACTIONS(5533),
    [anon_sym_DOT_STAR] = ACTIONS(5535),
    [anon_sym_DASH_GT] = ACTIONS(5535),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5533),
    [anon_sym_decltype] = ACTIONS(5533),
    [anon_sym_final] = ACTIONS(5533),
    [anon_sym_override] = ACTIONS(5533),
    [anon_sym_requires] = ACTIONS(5533),
  },
  [1804] = {
    [sym_identifier] = ACTIONS(5537),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5539),
    [anon_sym_COMMA] = ACTIONS(5539),
    [anon_sym_RPAREN] = ACTIONS(5539),
    [anon_sym_LPAREN2] = ACTIONS(5539),
    [anon_sym_DASH] = ACTIONS(5537),
    [anon_sym_PLUS] = ACTIONS(5537),
    [anon_sym_STAR] = ACTIONS(5539),
    [anon_sym_SLASH] = ACTIONS(5537),
    [anon_sym_PERCENT] = ACTIONS(5539),
    [anon_sym_PIPE_PIPE] = ACTIONS(5539),
    [anon_sym_AMP_AMP] = ACTIONS(5539),
    [anon_sym_PIPE] = ACTIONS(5537),
    [anon_sym_CARET] = ACTIONS(5539),
    [anon_sym_AMP] = ACTIONS(5537),
    [anon_sym_EQ_EQ] = ACTIONS(5539),
    [anon_sym_BANG_EQ] = ACTIONS(5539),
    [anon_sym_GT] = ACTIONS(5537),
    [anon_sym_GT_EQ] = ACTIONS(5539),
    [anon_sym_LT_EQ] = ACTIONS(5537),
    [anon_sym_LT] = ACTIONS(5537),
    [anon_sym_LT_LT] = ACTIONS(5539),
    [anon_sym_GT_GT] = ACTIONS(5539),
    [anon_sym_SEMI] = ACTIONS(5539),
    [anon_sym___extension__] = ACTIONS(5537),
    [anon_sym___attribute__] = ACTIONS(5537),
    [anon_sym___attribute] = ACTIONS(5537),
    [anon_sym___based] = ACTIONS(5537),
    [anon_sym_LBRACE] = ACTIONS(5539),
    [anon_sym_RBRACE] = ACTIONS(5539),
    [anon_sym_signed] = ACTIONS(5537),
    [anon_sym_unsigned] = ACTIONS(5537),
    [anon_sym_long] = ACTIONS(5537),
    [anon_sym_short] = ACTIONS(5537),
    [anon_sym_LBRACK] = ACTIONS(5539),
    [anon_sym_RBRACK] = ACTIONS(5539),
    [anon_sym_const] = ACTIONS(5537),
    [anon_sym_constexpr] = ACTIONS(5537),
    [anon_sym_volatile] = ACTIONS(5537),
    [anon_sym_restrict] = ACTIONS(5537),
    [anon_sym___restrict__] = ACTIONS(5537),
    [anon_sym__Atomic] = ACTIONS(5537),
    [anon_sym__Noreturn] = ACTIONS(5537),
    [anon_sym_noreturn] = ACTIONS(5537),
    [anon_sym__Nonnull] = ACTIONS(5537),
    [anon_sym_mutable] = ACTIONS(5537),
    [anon_sym_constinit] = ACTIONS(5537),
    [anon_sym_consteval] = ACTIONS(5537),
    [anon_sym_alignas] = ACTIONS(5537),
    [anon_sym__Alignas] = ACTIONS(5537),
    [sym_primitive_type] = ACTIONS(5537),
    [anon_sym_COLON] = ACTIONS(5539),
    [anon_sym_QMARK] = ACTIONS(5539),
    [anon_sym_LT_EQ_GT] = ACTIONS(5539),
    [anon_sym_or] = ACTIONS(5537),
    [anon_sym_and] = ACTIONS(5537),
    [anon_sym_bitor] = ACTIONS(5537),
    [anon_sym_xor] = ACTIONS(5537),
    [anon_sym_bitand] = ACTIONS(5537),
    [anon_sym_not_eq] = ACTIONS(5537),
    [anon_sym_DASH_DASH] = ACTIONS(5539),
    [anon_sym_PLUS_PLUS] = ACTIONS(5539),
    [anon_sym_DOT] = ACTIONS(5537),
    [anon_sym_DOT_STAR] = ACTIONS(5539),
    [anon_sym_DASH_GT] = ACTIONS(5539),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5537),
    [anon_sym_decltype] = ACTIONS(5537),
    [anon_sym_final] = ACTIONS(5537),
    [anon_sym_override] = ACTIONS(5537),
    [anon_sym_requires] = ACTIONS(5537),
  },
  [1805] = {
    [sym_identifier] = ACTIONS(5541),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5543),
    [anon_sym_COMMA] = ACTIONS(5543),
    [anon_sym_RPAREN] = ACTIONS(5543),
    [anon_sym_LPAREN2] = ACTIONS(5543),
    [anon_sym_DASH] = ACTIONS(5541),
    [anon_sym_PLUS] = ACTIONS(5541),
    [anon_sym_STAR] = ACTIONS(5543),
    [anon_sym_SLASH] = ACTIONS(5541),
    [anon_sym_PERCENT] = ACTIONS(5543),
    [anon_sym_PIPE_PIPE] = ACTIONS(5543),
    [anon_sym_AMP_AMP] = ACTIONS(5543),
    [anon_sym_PIPE] = ACTIONS(5541),
    [anon_sym_CARET] = ACTIONS(5543),
    [anon_sym_AMP] = ACTIONS(5541),
    [anon_sym_EQ_EQ] = ACTIONS(5543),
    [anon_sym_BANG_EQ] = ACTIONS(5543),
    [anon_sym_GT] = ACTIONS(5541),
    [anon_sym_GT_EQ] = ACTIONS(5543),
    [anon_sym_LT_EQ] = ACTIONS(5541),
    [anon_sym_LT] = ACTIONS(5541),
    [anon_sym_LT_LT] = ACTIONS(5543),
    [anon_sym_GT_GT] = ACTIONS(5543),
    [anon_sym_SEMI] = ACTIONS(5543),
    [anon_sym___extension__] = ACTIONS(5541),
    [anon_sym___attribute__] = ACTIONS(5541),
    [anon_sym___attribute] = ACTIONS(5541),
    [anon_sym___based] = ACTIONS(5541),
    [anon_sym_LBRACE] = ACTIONS(5543),
    [anon_sym_RBRACE] = ACTIONS(5543),
    [anon_sym_signed] = ACTIONS(5541),
    [anon_sym_unsigned] = ACTIONS(5541),
    [anon_sym_long] = ACTIONS(5541),
    [anon_sym_short] = ACTIONS(5541),
    [anon_sym_LBRACK] = ACTIONS(5543),
    [anon_sym_RBRACK] = ACTIONS(5543),
    [anon_sym_const] = ACTIONS(5541),
    [anon_sym_constexpr] = ACTIONS(5541),
    [anon_sym_volatile] = ACTIONS(5541),
    [anon_sym_restrict] = ACTIONS(5541),
    [anon_sym___restrict__] = ACTIONS(5541),
    [anon_sym__Atomic] = ACTIONS(5541),
    [anon_sym__Noreturn] = ACTIONS(5541),
    [anon_sym_noreturn] = ACTIONS(5541),
    [anon_sym__Nonnull] = ACTIONS(5541),
    [anon_sym_mutable] = ACTIONS(5541),
    [anon_sym_constinit] = ACTIONS(5541),
    [anon_sym_consteval] = ACTIONS(5541),
    [anon_sym_alignas] = ACTIONS(5541),
    [anon_sym__Alignas] = ACTIONS(5541),
    [sym_primitive_type] = ACTIONS(5541),
    [anon_sym_COLON] = ACTIONS(5543),
    [anon_sym_QMARK] = ACTIONS(5543),
    [anon_sym_LT_EQ_GT] = ACTIONS(5543),
    [anon_sym_or] = ACTIONS(5541),
    [anon_sym_and] = ACTIONS(5541),
    [anon_sym_bitor] = ACTIONS(5541),
    [anon_sym_xor] = ACTIONS(5541),
    [anon_sym_bitand] = ACTIONS(5541),
    [anon_sym_not_eq] = ACTIONS(5541),
    [anon_sym_DASH_DASH] = ACTIONS(5543),
    [anon_sym_PLUS_PLUS] = ACTIONS(5543),
    [anon_sym_DOT] = ACTIONS(5541),
    [anon_sym_DOT_STAR] = ACTIONS(5543),
    [anon_sym_DASH_GT] = ACTIONS(5543),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5541),
    [anon_sym_decltype] = ACTIONS(5541),
    [anon_sym_final] = ACTIONS(5541),
    [anon_sym_override] = ACTIONS(5541),
    [anon_sym_requires] = ACTIONS(5541),
  },
  [1806] = {
    [sym_identifier] = ACTIONS(5545),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5547),
    [anon_sym_COMMA] = ACTIONS(5547),
    [anon_sym_RPAREN] = ACTIONS(5547),
    [anon_sym_LPAREN2] = ACTIONS(5547),
    [anon_sym_DASH] = ACTIONS(5545),
    [anon_sym_PLUS] = ACTIONS(5545),
    [anon_sym_STAR] = ACTIONS(5547),
    [anon_sym_SLASH] = ACTIONS(5545),
    [anon_sym_PERCENT] = ACTIONS(5547),
    [anon_sym_PIPE_PIPE] = ACTIONS(5547),
    [anon_sym_AMP_AMP] = ACTIONS(5547),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_CARET] = ACTIONS(5547),
    [anon_sym_AMP] = ACTIONS(5545),
    [anon_sym_EQ_EQ] = ACTIONS(5547),
    [anon_sym_BANG_EQ] = ACTIONS(5547),
    [anon_sym_GT] = ACTIONS(5545),
    [anon_sym_GT_EQ] = ACTIONS(5547),
    [anon_sym_LT_EQ] = ACTIONS(5545),
    [anon_sym_LT] = ACTIONS(5545),
    [anon_sym_LT_LT] = ACTIONS(5547),
    [anon_sym_GT_GT] = ACTIONS(5547),
    [anon_sym_SEMI] = ACTIONS(5547),
    [anon_sym___extension__] = ACTIONS(5545),
    [anon_sym___attribute__] = ACTIONS(5545),
    [anon_sym___attribute] = ACTIONS(5545),
    [anon_sym___based] = ACTIONS(5545),
    [anon_sym_LBRACE] = ACTIONS(5547),
    [anon_sym_RBRACE] = ACTIONS(5547),
    [anon_sym_signed] = ACTIONS(5545),
    [anon_sym_unsigned] = ACTIONS(5545),
    [anon_sym_long] = ACTIONS(5545),
    [anon_sym_short] = ACTIONS(5545),
    [anon_sym_LBRACK] = ACTIONS(5547),
    [anon_sym_RBRACK] = ACTIONS(5547),
    [anon_sym_const] = ACTIONS(5545),
    [anon_sym_constexpr] = ACTIONS(5545),
    [anon_sym_volatile] = ACTIONS(5545),
    [anon_sym_restrict] = ACTIONS(5545),
    [anon_sym___restrict__] = ACTIONS(5545),
    [anon_sym__Atomic] = ACTIONS(5545),
    [anon_sym__Noreturn] = ACTIONS(5545),
    [anon_sym_noreturn] = ACTIONS(5545),
    [anon_sym__Nonnull] = ACTIONS(5545),
    [anon_sym_mutable] = ACTIONS(5545),
    [anon_sym_constinit] = ACTIONS(5545),
    [anon_sym_consteval] = ACTIONS(5545),
    [anon_sym_alignas] = ACTIONS(5545),
    [anon_sym__Alignas] = ACTIONS(5545),
    [sym_primitive_type] = ACTIONS(5545),
    [anon_sym_COLON] = ACTIONS(5547),
    [anon_sym_QMARK] = ACTIONS(5547),
    [anon_sym_LT_EQ_GT] = ACTIONS(5547),
    [anon_sym_or] = ACTIONS(5545),
    [anon_sym_and] = ACTIONS(5545),
    [anon_sym_bitor] = ACTIONS(5545),
    [anon_sym_xor] = ACTIONS(5545),
    [anon_sym_bitand] = ACTIONS(5545),
    [anon_sym_not_eq] = ACTIONS(5545),
    [anon_sym_DASH_DASH] = ACTIONS(5547),
    [anon_sym_PLUS_PLUS] = ACTIONS(5547),
    [anon_sym_DOT] = ACTIONS(5545),
    [anon_sym_DOT_STAR] = ACTIONS(5547),
    [anon_sym_DASH_GT] = ACTIONS(5547),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5545),
    [anon_sym_decltype] = ACTIONS(5545),
    [anon_sym_final] = ACTIONS(5545),
    [anon_sym_override] = ACTIONS(5545),
    [anon_sym_requires] = ACTIONS(5545),
  },
  [1807] = {
    [sym_identifier] = ACTIONS(5549),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5551),
    [anon_sym_COMMA] = ACTIONS(5551),
    [anon_sym_RPAREN] = ACTIONS(5551),
    [anon_sym_LPAREN2] = ACTIONS(5551),
    [anon_sym_DASH] = ACTIONS(5549),
    [anon_sym_PLUS] = ACTIONS(5549),
    [anon_sym_STAR] = ACTIONS(5551),
    [anon_sym_SLASH] = ACTIONS(5549),
    [anon_sym_PERCENT] = ACTIONS(5551),
    [anon_sym_PIPE_PIPE] = ACTIONS(5551),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_PIPE] = ACTIONS(5549),
    [anon_sym_CARET] = ACTIONS(5551),
    [anon_sym_AMP] = ACTIONS(5549),
    [anon_sym_EQ_EQ] = ACTIONS(5551),
    [anon_sym_BANG_EQ] = ACTIONS(5551),
    [anon_sym_GT] = ACTIONS(5549),
    [anon_sym_GT_EQ] = ACTIONS(5551),
    [anon_sym_LT_EQ] = ACTIONS(5549),
    [anon_sym_LT] = ACTIONS(5549),
    [anon_sym_LT_LT] = ACTIONS(5551),
    [anon_sym_GT_GT] = ACTIONS(5551),
    [anon_sym_SEMI] = ACTIONS(5551),
    [anon_sym___extension__] = ACTIONS(5549),
    [anon_sym___attribute__] = ACTIONS(5549),
    [anon_sym___attribute] = ACTIONS(5549),
    [anon_sym___based] = ACTIONS(5549),
    [anon_sym_LBRACE] = ACTIONS(5551),
    [anon_sym_RBRACE] = ACTIONS(5551),
    [anon_sym_signed] = ACTIONS(5549),
    [anon_sym_unsigned] = ACTIONS(5549),
    [anon_sym_long] = ACTIONS(5549),
    [anon_sym_short] = ACTIONS(5549),
    [anon_sym_LBRACK] = ACTIONS(5551),
    [anon_sym_RBRACK] = ACTIONS(5551),
    [anon_sym_const] = ACTIONS(5549),
    [anon_sym_constexpr] = ACTIONS(5549),
    [anon_sym_volatile] = ACTIONS(5549),
    [anon_sym_restrict] = ACTIONS(5549),
    [anon_sym___restrict__] = ACTIONS(5549),
    [anon_sym__Atomic] = ACTIONS(5549),
    [anon_sym__Noreturn] = ACTIONS(5549),
    [anon_sym_noreturn] = ACTIONS(5549),
    [anon_sym__Nonnull] = ACTIONS(5549),
    [anon_sym_mutable] = ACTIONS(5549),
    [anon_sym_constinit] = ACTIONS(5549),
    [anon_sym_consteval] = ACTIONS(5549),
    [anon_sym_alignas] = ACTIONS(5549),
    [anon_sym__Alignas] = ACTIONS(5549),
    [sym_primitive_type] = ACTIONS(5549),
    [anon_sym_COLON] = ACTIONS(5551),
    [anon_sym_QMARK] = ACTIONS(5551),
    [anon_sym_LT_EQ_GT] = ACTIONS(5551),
    [anon_sym_or] = ACTIONS(5549),
    [anon_sym_and] = ACTIONS(5549),
    [anon_sym_bitor] = ACTIONS(5549),
    [anon_sym_xor] = ACTIONS(5549),
    [anon_sym_bitand] = ACTIONS(5549),
    [anon_sym_not_eq] = ACTIONS(5549),
    [anon_sym_DASH_DASH] = ACTIONS(5551),
    [anon_sym_PLUS_PLUS] = ACTIONS(5551),
    [anon_sym_DOT] = ACTIONS(5549),
    [anon_sym_DOT_STAR] = ACTIONS(5551),
    [anon_sym_DASH_GT] = ACTIONS(5551),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5549),
    [anon_sym_decltype] = ACTIONS(5549),
    [anon_sym_final] = ACTIONS(5549),
    [anon_sym_override] = ACTIONS(5549),
    [anon_sym_requires] = ACTIONS(5549),
  },
  [1808] = {
    [sym_identifier] = ACTIONS(5361),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5363),
    [anon_sym_COMMA] = ACTIONS(5363),
    [anon_sym_RPAREN] = ACTIONS(5363),
    [anon_sym_LPAREN2] = ACTIONS(5363),
    [anon_sym_DASH] = ACTIONS(5361),
    [anon_sym_PLUS] = ACTIONS(5361),
    [anon_sym_STAR] = ACTIONS(5363),
    [anon_sym_SLASH] = ACTIONS(5361),
    [anon_sym_PERCENT] = ACTIONS(5363),
    [anon_sym_PIPE_PIPE] = ACTIONS(5363),
    [anon_sym_AMP_AMP] = ACTIONS(5363),
    [anon_sym_PIPE] = ACTIONS(5361),
    [anon_sym_CARET] = ACTIONS(5363),
    [anon_sym_AMP] = ACTIONS(5361),
    [anon_sym_EQ_EQ] = ACTIONS(5363),
    [anon_sym_BANG_EQ] = ACTIONS(5363),
    [anon_sym_GT] = ACTIONS(5361),
    [anon_sym_GT_EQ] = ACTIONS(5363),
    [anon_sym_LT_EQ] = ACTIONS(5361),
    [anon_sym_LT] = ACTIONS(5361),
    [anon_sym_LT_LT] = ACTIONS(5363),
    [anon_sym_GT_GT] = ACTIONS(5363),
    [anon_sym_SEMI] = ACTIONS(5363),
    [anon_sym___extension__] = ACTIONS(5361),
    [anon_sym___attribute__] = ACTIONS(5361),
    [anon_sym___attribute] = ACTIONS(5361),
    [anon_sym___based] = ACTIONS(5361),
    [anon_sym_LBRACE] = ACTIONS(5363),
    [anon_sym_RBRACE] = ACTIONS(5363),
    [anon_sym_signed] = ACTIONS(5361),
    [anon_sym_unsigned] = ACTIONS(5361),
    [anon_sym_long] = ACTIONS(5361),
    [anon_sym_short] = ACTIONS(5361),
    [anon_sym_LBRACK] = ACTIONS(5363),
    [anon_sym_RBRACK] = ACTIONS(5363),
    [anon_sym_const] = ACTIONS(5361),
    [anon_sym_constexpr] = ACTIONS(5361),
    [anon_sym_volatile] = ACTIONS(5361),
    [anon_sym_restrict] = ACTIONS(5361),
    [anon_sym___restrict__] = ACTIONS(5361),
    [anon_sym__Atomic] = ACTIONS(5361),
    [anon_sym__Noreturn] = ACTIONS(5361),
    [anon_sym_noreturn] = ACTIONS(5361),
    [anon_sym__Nonnull] = ACTIONS(5361),
    [anon_sym_mutable] = ACTIONS(5361),
    [anon_sym_constinit] = ACTIONS(5361),
    [anon_sym_consteval] = ACTIONS(5361),
    [anon_sym_alignas] = ACTIONS(5361),
    [anon_sym__Alignas] = ACTIONS(5361),
    [sym_primitive_type] = ACTIONS(5361),
    [anon_sym_COLON] = ACTIONS(5363),
    [anon_sym_QMARK] = ACTIONS(5363),
    [anon_sym_LT_EQ_GT] = ACTIONS(5363),
    [anon_sym_or] = ACTIONS(5361),
    [anon_sym_and] = ACTIONS(5361),
    [anon_sym_bitor] = ACTIONS(5361),
    [anon_sym_xor] = ACTIONS(5361),
    [anon_sym_bitand] = ACTIONS(5361),
    [anon_sym_not_eq] = ACTIONS(5361),
    [anon_sym_DASH_DASH] = ACTIONS(5363),
    [anon_sym_PLUS_PLUS] = ACTIONS(5363),
    [anon_sym_DOT] = ACTIONS(5361),
    [anon_sym_DOT_STAR] = ACTIONS(5363),
    [anon_sym_DASH_GT] = ACTIONS(5363),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5361),
    [anon_sym_decltype] = ACTIONS(5361),
    [anon_sym_final] = ACTIONS(5361),
    [anon_sym_override] = ACTIONS(5361),
    [anon_sym_requires] = ACTIONS(5361),
  },
  [1809] = {
    [sym_identifier] = ACTIONS(5553),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5555),
    [anon_sym_COMMA] = ACTIONS(5555),
    [anon_sym_RPAREN] = ACTIONS(5555),
    [anon_sym_LPAREN2] = ACTIONS(5555),
    [anon_sym_DASH] = ACTIONS(5553),
    [anon_sym_PLUS] = ACTIONS(5553),
    [anon_sym_STAR] = ACTIONS(5555),
    [anon_sym_SLASH] = ACTIONS(5553),
    [anon_sym_PERCENT] = ACTIONS(5555),
    [anon_sym_PIPE_PIPE] = ACTIONS(5555),
    [anon_sym_AMP_AMP] = ACTIONS(5555),
    [anon_sym_PIPE] = ACTIONS(5553),
    [anon_sym_CARET] = ACTIONS(5555),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym_EQ_EQ] = ACTIONS(5555),
    [anon_sym_BANG_EQ] = ACTIONS(5555),
    [anon_sym_GT] = ACTIONS(5553),
    [anon_sym_GT_EQ] = ACTIONS(5555),
    [anon_sym_LT_EQ] = ACTIONS(5553),
    [anon_sym_LT] = ACTIONS(5553),
    [anon_sym_LT_LT] = ACTIONS(5555),
    [anon_sym_GT_GT] = ACTIONS(5555),
    [anon_sym_SEMI] = ACTIONS(5555),
    [anon_sym___extension__] = ACTIONS(5553),
    [anon_sym___attribute__] = ACTIONS(5553),
    [anon_sym___attribute] = ACTIONS(5553),
    [anon_sym___based] = ACTIONS(5553),
    [anon_sym_LBRACE] = ACTIONS(5555),
    [anon_sym_RBRACE] = ACTIONS(5555),
    [anon_sym_signed] = ACTIONS(5553),
    [anon_sym_unsigned] = ACTIONS(5553),
    [anon_sym_long] = ACTIONS(5553),
    [anon_sym_short] = ACTIONS(5553),
    [anon_sym_LBRACK] = ACTIONS(5555),
    [anon_sym_RBRACK] = ACTIONS(5555),
    [anon_sym_const] = ACTIONS(5553),
    [anon_sym_constexpr] = ACTIONS(5553),
    [anon_sym_volatile] = ACTIONS(5553),
    [anon_sym_restrict] = ACTIONS(5553),
    [anon_sym___restrict__] = ACTIONS(5553),
    [anon_sym__Atomic] = ACTIONS(5553),
    [anon_sym__Noreturn] = ACTIONS(5553),
    [anon_sym_noreturn] = ACTIONS(5553),
    [anon_sym__Nonnull] = ACTIONS(5553),
    [anon_sym_mutable] = ACTIONS(5553),
    [anon_sym_constinit] = ACTIONS(5553),
    [anon_sym_consteval] = ACTIONS(5553),
    [anon_sym_alignas] = ACTIONS(5553),
    [anon_sym__Alignas] = ACTIONS(5553),
    [sym_primitive_type] = ACTIONS(5553),
    [anon_sym_COLON] = ACTIONS(5555),
    [anon_sym_QMARK] = ACTIONS(5555),
    [anon_sym_LT_EQ_GT] = ACTIONS(5555),
    [anon_sym_or] = ACTIONS(5553),
    [anon_sym_and] = ACTIONS(5553),
    [anon_sym_bitor] = ACTIONS(5553),
    [anon_sym_xor] = ACTIONS(5553),
    [anon_sym_bitand] = ACTIONS(5553),
    [anon_sym_not_eq] = ACTIONS(5553),
    [anon_sym_DASH_DASH] = ACTIONS(5555),
    [anon_sym_PLUS_PLUS] = ACTIONS(5555),
    [anon_sym_DOT] = ACTIONS(5553),
    [anon_sym_DOT_STAR] = ACTIONS(5555),
    [anon_sym_DASH_GT] = ACTIONS(5555),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5553),
    [anon_sym_decltype] = ACTIONS(5553),
    [anon_sym_final] = ACTIONS(5553),
    [anon_sym_override] = ACTIONS(5553),
    [anon_sym_requires] = ACTIONS(5553),
  },
  [1810] = {
    [sym_identifier] = ACTIONS(5431),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5433),
    [anon_sym_COMMA] = ACTIONS(5433),
    [anon_sym_RPAREN] = ACTIONS(5433),
    [anon_sym_LPAREN2] = ACTIONS(5433),
    [anon_sym_DASH] = ACTIONS(5431),
    [anon_sym_PLUS] = ACTIONS(5431),
    [anon_sym_STAR] = ACTIONS(5433),
    [anon_sym_SLASH] = ACTIONS(5431),
    [anon_sym_PERCENT] = ACTIONS(5433),
    [anon_sym_PIPE_PIPE] = ACTIONS(5433),
    [anon_sym_AMP_AMP] = ACTIONS(5433),
    [anon_sym_PIPE] = ACTIONS(5431),
    [anon_sym_CARET] = ACTIONS(5433),
    [anon_sym_AMP] = ACTIONS(5431),
    [anon_sym_EQ_EQ] = ACTIONS(5433),
    [anon_sym_BANG_EQ] = ACTIONS(5433),
    [anon_sym_GT] = ACTIONS(5431),
    [anon_sym_GT_EQ] = ACTIONS(5433),
    [anon_sym_LT_EQ] = ACTIONS(5431),
    [anon_sym_LT] = ACTIONS(5431),
    [anon_sym_LT_LT] = ACTIONS(5433),
    [anon_sym_GT_GT] = ACTIONS(5433),
    [anon_sym_SEMI] = ACTIONS(5433),
    [anon_sym___extension__] = ACTIONS(5431),
    [anon_sym___attribute__] = ACTIONS(5431),
    [anon_sym___attribute] = ACTIONS(5431),
    [anon_sym___based] = ACTIONS(5431),
    [anon_sym_LBRACE] = ACTIONS(5433),
    [anon_sym_RBRACE] = ACTIONS(5433),
    [anon_sym_signed] = ACTIONS(5431),
    [anon_sym_unsigned] = ACTIONS(5431),
    [anon_sym_long] = ACTIONS(5431),
    [anon_sym_short] = ACTIONS(5431),
    [anon_sym_LBRACK] = ACTIONS(5433),
    [anon_sym_RBRACK] = ACTIONS(5433),
    [anon_sym_const] = ACTIONS(5431),
    [anon_sym_constexpr] = ACTIONS(5431),
    [anon_sym_volatile] = ACTIONS(5431),
    [anon_sym_restrict] = ACTIONS(5431),
    [anon_sym___restrict__] = ACTIONS(5431),
    [anon_sym__Atomic] = ACTIONS(5431),
    [anon_sym__Noreturn] = ACTIONS(5431),
    [anon_sym_noreturn] = ACTIONS(5431),
    [anon_sym__Nonnull] = ACTIONS(5431),
    [anon_sym_mutable] = ACTIONS(5431),
    [anon_sym_constinit] = ACTIONS(5431),
    [anon_sym_consteval] = ACTIONS(5431),
    [anon_sym_alignas] = ACTIONS(5431),
    [anon_sym__Alignas] = ACTIONS(5431),
    [sym_primitive_type] = ACTIONS(5431),
    [anon_sym_COLON] = ACTIONS(5433),
    [anon_sym_QMARK] = ACTIONS(5433),
    [anon_sym_LT_EQ_GT] = ACTIONS(5433),
    [anon_sym_or] = ACTIONS(5431),
    [anon_sym_and] = ACTIONS(5431),
    [anon_sym_bitor] = ACTIONS(5431),
    [anon_sym_xor] = ACTIONS(5431),
    [anon_sym_bitand] = ACTIONS(5431),
    [anon_sym_not_eq] = ACTIONS(5431),
    [anon_sym_DASH_DASH] = ACTIONS(5433),
    [anon_sym_PLUS_PLUS] = ACTIONS(5433),
    [anon_sym_DOT] = ACTIONS(5431),
    [anon_sym_DOT_STAR] = ACTIONS(5433),
    [anon_sym_DASH_GT] = ACTIONS(5433),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5431),
    [anon_sym_decltype] = ACTIONS(5431),
    [anon_sym_final] = ACTIONS(5431),
    [anon_sym_override] = ACTIONS(5431),
    [anon_sym_requires] = ACTIONS(5431),
  },
  [1811] = {
    [sym_string_literal] = STATE(2570),
    [sym_template_argument_list] = STATE(3643),
    [sym_raw_string_literal] = STATE(2570),
    [sym_identifier] = ACTIONS(4043),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4035),
    [anon_sym_COMMA] = ACTIONS(4035),
    [aux_sym_preproc_if_token2] = ACTIONS(4035),
    [aux_sym_preproc_else_token1] = ACTIONS(4035),
    [aux_sym_preproc_elif_token1] = ACTIONS(4043),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4035),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4035),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_DASH] = ACTIONS(4043),
    [anon_sym_PLUS] = ACTIONS(4043),
    [anon_sym_STAR] = ACTIONS(4043),
    [anon_sym_SLASH] = ACTIONS(4043),
    [anon_sym_PERCENT] = ACTIONS(4043),
    [anon_sym_PIPE_PIPE] = ACTIONS(4035),
    [anon_sym_AMP_AMP] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4043),
    [anon_sym_CARET] = ACTIONS(4043),
    [anon_sym_AMP] = ACTIONS(4043),
    [anon_sym_EQ_EQ] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4043),
    [anon_sym_GT_EQ] = ACTIONS(4035),
    [anon_sym_LT_EQ] = ACTIONS(4043),
    [anon_sym_LT] = ACTIONS(5557),
    [anon_sym_LT_LT] = ACTIONS(4043),
    [anon_sym_GT_GT] = ACTIONS(4043),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACE] = ACTIONS(4059),
    [anon_sym_LBRACK] = ACTIONS(4035),
    [anon_sym_EQ] = ACTIONS(5560),
    [anon_sym_QMARK] = ACTIONS(4035),
    [anon_sym_STAR_EQ] = ACTIONS(5562),
    [anon_sym_SLASH_EQ] = ACTIONS(5562),
    [anon_sym_PERCENT_EQ] = ACTIONS(5562),
    [anon_sym_PLUS_EQ] = ACTIONS(5562),
    [anon_sym_DASH_EQ] = ACTIONS(5562),
    [anon_sym_LT_LT_EQ] = ACTIONS(5562),
    [anon_sym_GT_GT_EQ] = ACTIONS(5562),
    [anon_sym_AMP_EQ] = ACTIONS(5562),
    [anon_sym_CARET_EQ] = ACTIONS(5562),
    [anon_sym_PIPE_EQ] = ACTIONS(5562),
    [anon_sym_and_eq] = ACTIONS(5560),
    [anon_sym_or_eq] = ACTIONS(5560),
    [anon_sym_xor_eq] = ACTIONS(5560),
    [anon_sym_LT_EQ_GT] = ACTIONS(4035),
    [anon_sym_or] = ACTIONS(4043),
    [anon_sym_and] = ACTIONS(4043),
    [anon_sym_bitor] = ACTIONS(4043),
    [anon_sym_xor] = ACTIONS(4043),
    [anon_sym_bitand] = ACTIONS(4043),
    [anon_sym_not_eq] = ACTIONS(4043),
    [anon_sym_DASH_DASH] = ACTIONS(4035),
    [anon_sym_PLUS_PLUS] = ACTIONS(4035),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_DOT_STAR] = ACTIONS(4035),
    [anon_sym_DASH_GT] = ACTIONS(4035),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
  },
  [1812] = {
    [sym_identifier] = ACTIONS(5564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5566),
    [anon_sym_COMMA] = ACTIONS(5566),
    [anon_sym_RPAREN] = ACTIONS(5566),
    [anon_sym_LPAREN2] = ACTIONS(5566),
    [anon_sym_DASH] = ACTIONS(5564),
    [anon_sym_PLUS] = ACTIONS(5564),
    [anon_sym_STAR] = ACTIONS(5566),
    [anon_sym_SLASH] = ACTIONS(5564),
    [anon_sym_PERCENT] = ACTIONS(5566),
    [anon_sym_PIPE_PIPE] = ACTIONS(5566),
    [anon_sym_AMP_AMP] = ACTIONS(5566),
    [anon_sym_PIPE] = ACTIONS(5564),
    [anon_sym_CARET] = ACTIONS(5566),
    [anon_sym_AMP] = ACTIONS(5564),
    [anon_sym_EQ_EQ] = ACTIONS(5566),
    [anon_sym_BANG_EQ] = ACTIONS(5566),
    [anon_sym_GT] = ACTIONS(5564),
    [anon_sym_GT_EQ] = ACTIONS(5566),
    [anon_sym_LT_EQ] = ACTIONS(5564),
    [anon_sym_LT] = ACTIONS(5564),
    [anon_sym_LT_LT] = ACTIONS(5566),
    [anon_sym_GT_GT] = ACTIONS(5566),
    [anon_sym_SEMI] = ACTIONS(5566),
    [anon_sym___extension__] = ACTIONS(5564),
    [anon_sym___attribute__] = ACTIONS(5564),
    [anon_sym___attribute] = ACTIONS(5564),
    [anon_sym___based] = ACTIONS(5564),
    [anon_sym_LBRACE] = ACTIONS(5566),
    [anon_sym_RBRACE] = ACTIONS(5566),
    [anon_sym_signed] = ACTIONS(5564),
    [anon_sym_unsigned] = ACTIONS(5564),
    [anon_sym_long] = ACTIONS(5564),
    [anon_sym_short] = ACTIONS(5564),
    [anon_sym_LBRACK] = ACTIONS(5566),
    [anon_sym_RBRACK] = ACTIONS(5566),
    [anon_sym_const] = ACTIONS(5564),
    [anon_sym_constexpr] = ACTIONS(5564),
    [anon_sym_volatile] = ACTIONS(5564),
    [anon_sym_restrict] = ACTIONS(5564),
    [anon_sym___restrict__] = ACTIONS(5564),
    [anon_sym__Atomic] = ACTIONS(5564),
    [anon_sym__Noreturn] = ACTIONS(5564),
    [anon_sym_noreturn] = ACTIONS(5564),
    [anon_sym__Nonnull] = ACTIONS(5564),
    [anon_sym_mutable] = ACTIONS(5564),
    [anon_sym_constinit] = ACTIONS(5564),
    [anon_sym_consteval] = ACTIONS(5564),
    [anon_sym_alignas] = ACTIONS(5564),
    [anon_sym__Alignas] = ACTIONS(5564),
    [sym_primitive_type] = ACTIONS(5564),
    [anon_sym_COLON] = ACTIONS(5566),
    [anon_sym_QMARK] = ACTIONS(5566),
    [anon_sym_LT_EQ_GT] = ACTIONS(5566),
    [anon_sym_or] = ACTIONS(5564),
    [anon_sym_and] = ACTIONS(5564),
    [anon_sym_bitor] = ACTIONS(5564),
    [anon_sym_xor] = ACTIONS(5564),
    [anon_sym_bitand] = ACTIONS(5564),
    [anon_sym_not_eq] = ACTIONS(5564),
    [anon_sym_DASH_DASH] = ACTIONS(5566),
    [anon_sym_PLUS_PLUS] = ACTIONS(5566),
    [anon_sym_DOT] = ACTIONS(5564),
    [anon_sym_DOT_STAR] = ACTIONS(5566),
    [anon_sym_DASH_GT] = ACTIONS(5566),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5564),
    [anon_sym_decltype] = ACTIONS(5564),
    [anon_sym_final] = ACTIONS(5564),
    [anon_sym_override] = ACTIONS(5564),
    [anon_sym_requires] = ACTIONS(5564),
  },
  [1813] = {
    [sym_identifier] = ACTIONS(4939),
    [anon_sym_LPAREN2] = ACTIONS(4941),
    [anon_sym_BANG] = ACTIONS(4941),
    [anon_sym_TILDE] = ACTIONS(4941),
    [anon_sym_DASH] = ACTIONS(4939),
    [anon_sym_PLUS] = ACTIONS(4939),
    [anon_sym_STAR] = ACTIONS(4941),
    [anon_sym_AMP] = ACTIONS(4941),
    [anon_sym___extension__] = ACTIONS(4939),
    [anon_sym_COLON_COLON] = ACTIONS(4941),
    [anon_sym_LBRACK] = ACTIONS(4941),
    [anon_sym_static] = ACTIONS(4939),
    [anon_sym_RBRACK] = ACTIONS(4941),
    [anon_sym_const] = ACTIONS(4939),
    [anon_sym_constexpr] = ACTIONS(4939),
    [anon_sym_volatile] = ACTIONS(4939),
    [anon_sym_restrict] = ACTIONS(4939),
    [anon_sym___restrict__] = ACTIONS(4939),
    [anon_sym__Atomic] = ACTIONS(4939),
    [anon_sym__Noreturn] = ACTIONS(4939),
    [anon_sym_noreturn] = ACTIONS(4939),
    [anon_sym__Nonnull] = ACTIONS(4939),
    [anon_sym_mutable] = ACTIONS(4939),
    [anon_sym_constinit] = ACTIONS(4939),
    [anon_sym_consteval] = ACTIONS(4939),
    [anon_sym_alignas] = ACTIONS(4939),
    [anon_sym__Alignas] = ACTIONS(4939),
    [sym_primitive_type] = ACTIONS(4939),
    [anon_sym_not] = ACTIONS(4939),
    [anon_sym_compl] = ACTIONS(4939),
    [anon_sym_DASH_DASH] = ACTIONS(4941),
    [anon_sym_PLUS_PLUS] = ACTIONS(4941),
    [anon_sym_sizeof] = ACTIONS(4939),
    [anon_sym___alignof__] = ACTIONS(4939),
    [anon_sym___alignof] = ACTIONS(4939),
    [anon_sym__alignof] = ACTIONS(4939),
    [anon_sym_alignof] = ACTIONS(4939),
    [anon_sym__Alignof] = ACTIONS(4939),
    [anon_sym_offsetof] = ACTIONS(4939),
    [anon_sym__Generic] = ACTIONS(4939),
    [anon_sym_asm] = ACTIONS(4939),
    [anon_sym___asm__] = ACTIONS(4939),
    [anon_sym___asm] = ACTIONS(4939),
    [sym_number_literal] = ACTIONS(4941),
    [anon_sym_L_SQUOTE] = ACTIONS(4941),
    [anon_sym_u_SQUOTE] = ACTIONS(4941),
    [anon_sym_U_SQUOTE] = ACTIONS(4941),
    [anon_sym_u8_SQUOTE] = ACTIONS(4941),
    [anon_sym_SQUOTE] = ACTIONS(4941),
    [anon_sym_L_DQUOTE] = ACTIONS(4941),
    [anon_sym_u_DQUOTE] = ACTIONS(4941),
    [anon_sym_U_DQUOTE] = ACTIONS(4941),
    [anon_sym_u8_DQUOTE] = ACTIONS(4941),
    [anon_sym_DQUOTE] = ACTIONS(4941),
    [sym_true] = ACTIONS(4939),
    [sym_false] = ACTIONS(4939),
    [anon_sym_NULL] = ACTIONS(4939),
    [anon_sym_nullptr] = ACTIONS(4939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(4939),
    [anon_sym_template] = ACTIONS(4939),
    [anon_sym_delete] = ACTIONS(4939),
    [anon_sym_R_DQUOTE] = ACTIONS(4941),
    [anon_sym_LR_DQUOTE] = ACTIONS(4941),
    [anon_sym_uR_DQUOTE] = ACTIONS(4941),
    [anon_sym_UR_DQUOTE] = ACTIONS(4941),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4941),
    [anon_sym_co_await] = ACTIONS(4939),
    [anon_sym_new] = ACTIONS(4939),
    [anon_sym_requires] = ACTIONS(4939),
    [sym_this] = ACTIONS(4939),
  },
  [1814] = {
    [sym_identifier] = ACTIONS(5502),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5504),
    [anon_sym_COMMA] = ACTIONS(5504),
    [anon_sym_RPAREN] = ACTIONS(5504),
    [anon_sym_LPAREN2] = ACTIONS(5504),
    [anon_sym_DASH] = ACTIONS(5502),
    [anon_sym_PLUS] = ACTIONS(5502),
    [anon_sym_STAR] = ACTIONS(5504),
    [anon_sym_SLASH] = ACTIONS(5502),
    [anon_sym_PERCENT] = ACTIONS(5504),
    [anon_sym_PIPE_PIPE] = ACTIONS(5504),
    [anon_sym_AMP_AMP] = ACTIONS(5504),
    [anon_sym_PIPE] = ACTIONS(5502),
    [anon_sym_CARET] = ACTIONS(5504),
    [anon_sym_AMP] = ACTIONS(5502),
    [anon_sym_EQ_EQ] = ACTIONS(5504),
    [anon_sym_BANG_EQ] = ACTIONS(5504),
    [anon_sym_GT] = ACTIONS(5502),
    [anon_sym_GT_EQ] = ACTIONS(5504),
    [anon_sym_LT_EQ] = ACTIONS(5502),
    [anon_sym_LT] = ACTIONS(5502),
    [anon_sym_LT_LT] = ACTIONS(5504),
    [anon_sym_GT_GT] = ACTIONS(5504),
    [anon_sym_SEMI] = ACTIONS(5504),
    [anon_sym___extension__] = ACTIONS(5502),
    [anon_sym___attribute__] = ACTIONS(5502),
    [anon_sym___attribute] = ACTIONS(5502),
    [anon_sym___based] = ACTIONS(5502),
    [anon_sym_LBRACE] = ACTIONS(5504),
    [anon_sym_RBRACE] = ACTIONS(5504),
    [anon_sym_signed] = ACTIONS(5502),
    [anon_sym_unsigned] = ACTIONS(5502),
    [anon_sym_long] = ACTIONS(5502),
    [anon_sym_short] = ACTIONS(5502),
    [anon_sym_LBRACK] = ACTIONS(5504),
    [anon_sym_RBRACK] = ACTIONS(5504),
    [anon_sym_const] = ACTIONS(5502),
    [anon_sym_constexpr] = ACTIONS(5502),
    [anon_sym_volatile] = ACTIONS(5502),
    [anon_sym_restrict] = ACTIONS(5502),
    [anon_sym___restrict__] = ACTIONS(5502),
    [anon_sym__Atomic] = ACTIONS(5502),
    [anon_sym__Noreturn] = ACTIONS(5502),
    [anon_sym_noreturn] = ACTIONS(5502),
    [anon_sym__Nonnull] = ACTIONS(5502),
    [anon_sym_mutable] = ACTIONS(5502),
    [anon_sym_constinit] = ACTIONS(5502),
    [anon_sym_consteval] = ACTIONS(5502),
    [anon_sym_alignas] = ACTIONS(5502),
    [anon_sym__Alignas] = ACTIONS(5502),
    [sym_primitive_type] = ACTIONS(5502),
    [anon_sym_COLON] = ACTIONS(5504),
    [anon_sym_QMARK] = ACTIONS(5504),
    [anon_sym_LT_EQ_GT] = ACTIONS(5504),
    [anon_sym_or] = ACTIONS(5502),
    [anon_sym_and] = ACTIONS(5502),
    [anon_sym_bitor] = ACTIONS(5502),
    [anon_sym_xor] = ACTIONS(5502),
    [anon_sym_bitand] = ACTIONS(5502),
    [anon_sym_not_eq] = ACTIONS(5502),
    [anon_sym_DASH_DASH] = ACTIONS(5504),
    [anon_sym_PLUS_PLUS] = ACTIONS(5504),
    [anon_sym_DOT] = ACTIONS(5502),
    [anon_sym_DOT_STAR] = ACTIONS(5504),
    [anon_sym_DASH_GT] = ACTIONS(5504),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5502),
    [anon_sym_decltype] = ACTIONS(5502),
    [anon_sym_final] = ACTIONS(5502),
    [anon_sym_override] = ACTIONS(5502),
    [anon_sym_requires] = ACTIONS(5502),
  },
  [1815] = {
    [sym_identifier] = ACTIONS(5502),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5504),
    [anon_sym_COMMA] = ACTIONS(5504),
    [anon_sym_RPAREN] = ACTIONS(5504),
    [anon_sym_LPAREN2] = ACTIONS(5504),
    [anon_sym_DASH] = ACTIONS(5502),
    [anon_sym_PLUS] = ACTIONS(5502),
    [anon_sym_STAR] = ACTIONS(5504),
    [anon_sym_SLASH] = ACTIONS(5502),
    [anon_sym_PERCENT] = ACTIONS(5504),
    [anon_sym_PIPE_PIPE] = ACTIONS(5504),
    [anon_sym_AMP_AMP] = ACTIONS(5504),
    [anon_sym_PIPE] = ACTIONS(5502),
    [anon_sym_CARET] = ACTIONS(5504),
    [anon_sym_AMP] = ACTIONS(5502),
    [anon_sym_EQ_EQ] = ACTIONS(5504),
    [anon_sym_BANG_EQ] = ACTIONS(5504),
    [anon_sym_GT] = ACTIONS(5502),
    [anon_sym_GT_EQ] = ACTIONS(5504),
    [anon_sym_LT_EQ] = ACTIONS(5502),
    [anon_sym_LT] = ACTIONS(5502),
    [anon_sym_LT_LT] = ACTIONS(5504),
    [anon_sym_GT_GT] = ACTIONS(5504),
    [anon_sym_SEMI] = ACTIONS(5504),
    [anon_sym___extension__] = ACTIONS(5502),
    [anon_sym___attribute__] = ACTIONS(5502),
    [anon_sym___attribute] = ACTIONS(5502),
    [anon_sym___based] = ACTIONS(5502),
    [anon_sym_LBRACE] = ACTIONS(5504),
    [anon_sym_RBRACE] = ACTIONS(5504),
    [anon_sym_signed] = ACTIONS(5502),
    [anon_sym_unsigned] = ACTIONS(5502),
    [anon_sym_long] = ACTIONS(5502),
    [anon_sym_short] = ACTIONS(5502),
    [anon_sym_LBRACK] = ACTIONS(5504),
    [anon_sym_RBRACK] = ACTIONS(5504),
    [anon_sym_const] = ACTIONS(5502),
    [anon_sym_constexpr] = ACTIONS(5502),
    [anon_sym_volatile] = ACTIONS(5502),
    [anon_sym_restrict] = ACTIONS(5502),
    [anon_sym___restrict__] = ACTIONS(5502),
    [anon_sym__Atomic] = ACTIONS(5502),
    [anon_sym__Noreturn] = ACTIONS(5502),
    [anon_sym_noreturn] = ACTIONS(5502),
    [anon_sym__Nonnull] = ACTIONS(5502),
    [anon_sym_mutable] = ACTIONS(5502),
    [anon_sym_constinit] = ACTIONS(5502),
    [anon_sym_consteval] = ACTIONS(5502),
    [anon_sym_alignas] = ACTIONS(5502),
    [anon_sym__Alignas] = ACTIONS(5502),
    [sym_primitive_type] = ACTIONS(5502),
    [anon_sym_COLON] = ACTIONS(5504),
    [anon_sym_QMARK] = ACTIONS(5504),
    [anon_sym_LT_EQ_GT] = ACTIONS(5504),
    [anon_sym_or] = ACTIONS(5502),
    [anon_sym_and] = ACTIONS(5502),
    [anon_sym_bitor] = ACTIONS(5502),
    [anon_sym_xor] = ACTIONS(5502),
    [anon_sym_bitand] = ACTIONS(5502),
    [anon_sym_not_eq] = ACTIONS(5502),
    [anon_sym_DASH_DASH] = ACTIONS(5504),
    [anon_sym_PLUS_PLUS] = ACTIONS(5504),
    [anon_sym_DOT] = ACTIONS(5502),
    [anon_sym_DOT_STAR] = ACTIONS(5504),
    [anon_sym_DASH_GT] = ACTIONS(5504),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5502),
    [anon_sym_decltype] = ACTIONS(5502),
    [anon_sym_final] = ACTIONS(5502),
    [anon_sym_override] = ACTIONS(5502),
    [anon_sym_requires] = ACTIONS(5502),
  },
  [1816] = {
    [sym_identifier] = ACTIONS(5568),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5570),
    [anon_sym_COMMA] = ACTIONS(5570),
    [anon_sym_RPAREN] = ACTIONS(5570),
    [anon_sym_LPAREN2] = ACTIONS(5570),
    [anon_sym_DASH] = ACTIONS(5568),
    [anon_sym_PLUS] = ACTIONS(5568),
    [anon_sym_STAR] = ACTIONS(5570),
    [anon_sym_SLASH] = ACTIONS(5568),
    [anon_sym_PERCENT] = ACTIONS(5570),
    [anon_sym_PIPE_PIPE] = ACTIONS(5570),
    [anon_sym_AMP_AMP] = ACTIONS(5570),
    [anon_sym_PIPE] = ACTIONS(5568),
    [anon_sym_CARET] = ACTIONS(5570),
    [anon_sym_AMP] = ACTIONS(5568),
    [anon_sym_EQ_EQ] = ACTIONS(5570),
    [anon_sym_BANG_EQ] = ACTIONS(5570),
    [anon_sym_GT] = ACTIONS(5568),
    [anon_sym_GT_EQ] = ACTIONS(5570),
    [anon_sym_LT_EQ] = ACTIONS(5568),
    [anon_sym_LT] = ACTIONS(5568),
    [anon_sym_LT_LT] = ACTIONS(5570),
    [anon_sym_GT_GT] = ACTIONS(5570),
    [anon_sym_SEMI] = ACTIONS(5570),
    [anon_sym___extension__] = ACTIONS(5568),
    [anon_sym___attribute__] = ACTIONS(5568),
    [anon_sym___attribute] = ACTIONS(5568),
    [anon_sym___based] = ACTIONS(5568),
    [anon_sym_LBRACE] = ACTIONS(5570),
    [anon_sym_RBRACE] = ACTIONS(5570),
    [anon_sym_signed] = ACTIONS(5568),
    [anon_sym_unsigned] = ACTIONS(5568),
    [anon_sym_long] = ACTIONS(5568),
    [anon_sym_short] = ACTIONS(5568),
    [anon_sym_LBRACK] = ACTIONS(5570),
    [anon_sym_RBRACK] = ACTIONS(5570),
    [anon_sym_const] = ACTIONS(5568),
    [anon_sym_constexpr] = ACTIONS(5568),
    [anon_sym_volatile] = ACTIONS(5568),
    [anon_sym_restrict] = ACTIONS(5568),
    [anon_sym___restrict__] = ACTIONS(5568),
    [anon_sym__Atomic] = ACTIONS(5568),
    [anon_sym__Noreturn] = ACTIONS(5568),
    [anon_sym_noreturn] = ACTIONS(5568),
    [anon_sym__Nonnull] = ACTIONS(5568),
    [anon_sym_mutable] = ACTIONS(5568),
    [anon_sym_constinit] = ACTIONS(5568),
    [anon_sym_consteval] = ACTIONS(5568),
    [anon_sym_alignas] = ACTIONS(5568),
    [anon_sym__Alignas] = ACTIONS(5568),
    [sym_primitive_type] = ACTIONS(5568),
    [anon_sym_COLON] = ACTIONS(5570),
    [anon_sym_QMARK] = ACTIONS(5570),
    [anon_sym_LT_EQ_GT] = ACTIONS(5570),
    [anon_sym_or] = ACTIONS(5568),
    [anon_sym_and] = ACTIONS(5568),
    [anon_sym_bitor] = ACTIONS(5568),
    [anon_sym_xor] = ACTIONS(5568),
    [anon_sym_bitand] = ACTIONS(5568),
    [anon_sym_not_eq] = ACTIONS(5568),
    [anon_sym_DASH_DASH] = ACTIONS(5570),
    [anon_sym_PLUS_PLUS] = ACTIONS(5570),
    [anon_sym_DOT] = ACTIONS(5568),
    [anon_sym_DOT_STAR] = ACTIONS(5570),
    [anon_sym_DASH_GT] = ACTIONS(5570),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5568),
    [anon_sym_decltype] = ACTIONS(5568),
    [anon_sym_final] = ACTIONS(5568),
    [anon_sym_override] = ACTIONS(5568),
    [anon_sym_requires] = ACTIONS(5568),
  },
  [1817] = {
    [sym_identifier] = ACTIONS(5572),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5574),
    [anon_sym_COMMA] = ACTIONS(5574),
    [anon_sym_RPAREN] = ACTIONS(5574),
    [anon_sym_LPAREN2] = ACTIONS(5574),
    [anon_sym_DASH] = ACTIONS(5572),
    [anon_sym_PLUS] = ACTIONS(5572),
    [anon_sym_STAR] = ACTIONS(5574),
    [anon_sym_SLASH] = ACTIONS(5572),
    [anon_sym_PERCENT] = ACTIONS(5574),
    [anon_sym_PIPE_PIPE] = ACTIONS(5574),
    [anon_sym_AMP_AMP] = ACTIONS(5574),
    [anon_sym_PIPE] = ACTIONS(5572),
    [anon_sym_CARET] = ACTIONS(5574),
    [anon_sym_AMP] = ACTIONS(5572),
    [anon_sym_EQ_EQ] = ACTIONS(5574),
    [anon_sym_BANG_EQ] = ACTIONS(5574),
    [anon_sym_GT] = ACTIONS(5572),
    [anon_sym_GT_EQ] = ACTIONS(5574),
    [anon_sym_LT_EQ] = ACTIONS(5572),
    [anon_sym_LT] = ACTIONS(5572),
    [anon_sym_LT_LT] = ACTIONS(5574),
    [anon_sym_GT_GT] = ACTIONS(5574),
    [anon_sym_SEMI] = ACTIONS(5574),
    [anon_sym___extension__] = ACTIONS(5572),
    [anon_sym___attribute__] = ACTIONS(5572),
    [anon_sym___attribute] = ACTIONS(5572),
    [anon_sym___based] = ACTIONS(5572),
    [anon_sym_LBRACE] = ACTIONS(5574),
    [anon_sym_RBRACE] = ACTIONS(5574),
    [anon_sym_signed] = ACTIONS(5572),
    [anon_sym_unsigned] = ACTIONS(5572),
    [anon_sym_long] = ACTIONS(5572),
    [anon_sym_short] = ACTIONS(5572),
    [anon_sym_LBRACK] = ACTIONS(5574),
    [anon_sym_RBRACK] = ACTIONS(5574),
    [anon_sym_const] = ACTIONS(5572),
    [anon_sym_constexpr] = ACTIONS(5572),
    [anon_sym_volatile] = ACTIONS(5572),
    [anon_sym_restrict] = ACTIONS(5572),
    [anon_sym___restrict__] = ACTIONS(5572),
    [anon_sym__Atomic] = ACTIONS(5572),
    [anon_sym__Noreturn] = ACTIONS(5572),
    [anon_sym_noreturn] = ACTIONS(5572),
    [anon_sym__Nonnull] = ACTIONS(5572),
    [anon_sym_mutable] = ACTIONS(5572),
    [anon_sym_constinit] = ACTIONS(5572),
    [anon_sym_consteval] = ACTIONS(5572),
    [anon_sym_alignas] = ACTIONS(5572),
    [anon_sym__Alignas] = ACTIONS(5572),
    [sym_primitive_type] = ACTIONS(5572),
    [anon_sym_COLON] = ACTIONS(5574),
    [anon_sym_QMARK] = ACTIONS(5574),
    [anon_sym_LT_EQ_GT] = ACTIONS(5574),
    [anon_sym_or] = ACTIONS(5572),
    [anon_sym_and] = ACTIONS(5572),
    [anon_sym_bitor] = ACTIONS(5572),
    [anon_sym_xor] = ACTIONS(5572),
    [anon_sym_bitand] = ACTIONS(5572),
    [anon_sym_not_eq] = ACTIONS(5572),
    [anon_sym_DASH_DASH] = ACTIONS(5574),
    [anon_sym_PLUS_PLUS] = ACTIONS(5574),
    [anon_sym_DOT] = ACTIONS(5572),
    [anon_sym_DOT_STAR] = ACTIONS(5574),
    [anon_sym_DASH_GT] = ACTIONS(5574),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5572),
    [anon_sym_decltype] = ACTIONS(5572),
    [anon_sym_final] = ACTIONS(5572),
    [anon_sym_override] = ACTIONS(5572),
    [anon_sym_requires] = ACTIONS(5572),
  },
  [1818] = {
    [sym_catch_clause] = STATE(1833),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1833),
    [sym_identifier] = ACTIONS(2510),
    [aux_sym_preproc_def_token1] = ACTIONS(2510),
    [aux_sym_preproc_if_token1] = ACTIONS(2510),
    [aux_sym_preproc_if_token2] = ACTIONS(2510),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2510),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2510),
    [sym_preproc_directive] = ACTIONS(2510),
    [anon_sym_LPAREN2] = ACTIONS(2512),
    [anon_sym_TILDE] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2510),
    [anon_sym_SEMI] = ACTIONS(2512),
    [anon_sym___extension__] = ACTIONS(2510),
    [anon_sym_typedef] = ACTIONS(2510),
    [anon_sym_virtual] = ACTIONS(2510),
    [anon_sym_extern] = ACTIONS(2510),
    [anon_sym___attribute__] = ACTIONS(2510),
    [anon_sym___attribute] = ACTIONS(2510),
    [anon_sym_COLON_COLON] = ACTIONS(2512),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2512),
    [anon_sym___declspec] = ACTIONS(2510),
    [anon_sym___based] = ACTIONS(2510),
    [anon_sym_signed] = ACTIONS(2510),
    [anon_sym_unsigned] = ACTIONS(2510),
    [anon_sym_long] = ACTIONS(2510),
    [anon_sym_short] = ACTIONS(2510),
    [anon_sym_LBRACK] = ACTIONS(2510),
    [anon_sym_static] = ACTIONS(2510),
    [anon_sym_register] = ACTIONS(2510),
    [anon_sym_inline] = ACTIONS(2510),
    [anon_sym___inline] = ACTIONS(2510),
    [anon_sym___inline__] = ACTIONS(2510),
    [anon_sym___forceinline] = ACTIONS(2510),
    [anon_sym_thread_local] = ACTIONS(2510),
    [anon_sym___thread] = ACTIONS(2510),
    [anon_sym_const] = ACTIONS(2510),
    [anon_sym_constexpr] = ACTIONS(2510),
    [anon_sym_volatile] = ACTIONS(2510),
    [anon_sym_restrict] = ACTIONS(2510),
    [anon_sym___restrict__] = ACTIONS(2510),
    [anon_sym__Atomic] = ACTIONS(2510),
    [anon_sym__Noreturn] = ACTIONS(2510),
    [anon_sym_noreturn] = ACTIONS(2510),
    [anon_sym__Nonnull] = ACTIONS(2510),
    [anon_sym_mutable] = ACTIONS(2510),
    [anon_sym_constinit] = ACTIONS(2510),
    [anon_sym_consteval] = ACTIONS(2510),
    [anon_sym_alignas] = ACTIONS(2510),
    [anon_sym__Alignas] = ACTIONS(2510),
    [sym_primitive_type] = ACTIONS(2510),
    [anon_sym_enum] = ACTIONS(2510),
    [anon_sym_class] = ACTIONS(2510),
    [anon_sym_struct] = ACTIONS(2510),
    [anon_sym_union] = ACTIONS(2510),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2510),
    [anon_sym_decltype] = ACTIONS(2510),
    [anon_sym_explicit] = ACTIONS(2510),
    [anon_sym_typename] = ACTIONS(2510),
    [anon_sym_template] = ACTIONS(2510),
    [anon_sym_operator] = ACTIONS(2510),
    [anon_sym_friend] = ACTIONS(2510),
    [anon_sym_public] = ACTIONS(2510),
    [anon_sym_private] = ACTIONS(2510),
    [anon_sym_protected] = ACTIONS(2510),
    [anon_sym_using] = ACTIONS(2510),
    [anon_sym_static_assert] = ACTIONS(2510),
    [anon_sym_catch] = ACTIONS(5576),
  },
  [1819] = {
    [sym_identifier] = ACTIONS(5578),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5580),
    [anon_sym_COMMA] = ACTIONS(5580),
    [anon_sym_RPAREN] = ACTIONS(5580),
    [anon_sym_LPAREN2] = ACTIONS(5580),
    [anon_sym_DASH] = ACTIONS(5578),
    [anon_sym_PLUS] = ACTIONS(5578),
    [anon_sym_STAR] = ACTIONS(5580),
    [anon_sym_SLASH] = ACTIONS(5578),
    [anon_sym_PERCENT] = ACTIONS(5580),
    [anon_sym_PIPE_PIPE] = ACTIONS(5580),
    [anon_sym_AMP_AMP] = ACTIONS(5580),
    [anon_sym_PIPE] = ACTIONS(5578),
    [anon_sym_CARET] = ACTIONS(5580),
    [anon_sym_AMP] = ACTIONS(5578),
    [anon_sym_EQ_EQ] = ACTIONS(5580),
    [anon_sym_BANG_EQ] = ACTIONS(5580),
    [anon_sym_GT] = ACTIONS(5578),
    [anon_sym_GT_EQ] = ACTIONS(5580),
    [anon_sym_LT_EQ] = ACTIONS(5578),
    [anon_sym_LT] = ACTIONS(5578),
    [anon_sym_LT_LT] = ACTIONS(5580),
    [anon_sym_GT_GT] = ACTIONS(5580),
    [anon_sym_SEMI] = ACTIONS(5580),
    [anon_sym___extension__] = ACTIONS(5578),
    [anon_sym___attribute__] = ACTIONS(5578),
    [anon_sym___attribute] = ACTIONS(5578),
    [anon_sym___based] = ACTIONS(5578),
    [anon_sym_LBRACE] = ACTIONS(5580),
    [anon_sym_RBRACE] = ACTIONS(5580),
    [anon_sym_signed] = ACTIONS(5578),
    [anon_sym_unsigned] = ACTIONS(5578),
    [anon_sym_long] = ACTIONS(5578),
    [anon_sym_short] = ACTIONS(5578),
    [anon_sym_LBRACK] = ACTIONS(5580),
    [anon_sym_RBRACK] = ACTIONS(5580),
    [anon_sym_const] = ACTIONS(5578),
    [anon_sym_constexpr] = ACTIONS(5578),
    [anon_sym_volatile] = ACTIONS(5578),
    [anon_sym_restrict] = ACTIONS(5578),
    [anon_sym___restrict__] = ACTIONS(5578),
    [anon_sym__Atomic] = ACTIONS(5578),
    [anon_sym__Noreturn] = ACTIONS(5578),
    [anon_sym_noreturn] = ACTIONS(5578),
    [anon_sym__Nonnull] = ACTIONS(5578),
    [anon_sym_mutable] = ACTIONS(5578),
    [anon_sym_constinit] = ACTIONS(5578),
    [anon_sym_consteval] = ACTIONS(5578),
    [anon_sym_alignas] = ACTIONS(5578),
    [anon_sym__Alignas] = ACTIONS(5578),
    [sym_primitive_type] = ACTIONS(5578),
    [anon_sym_COLON] = ACTIONS(5580),
    [anon_sym_QMARK] = ACTIONS(5580),
    [anon_sym_LT_EQ_GT] = ACTIONS(5580),
    [anon_sym_or] = ACTIONS(5578),
    [anon_sym_and] = ACTIONS(5578),
    [anon_sym_bitor] = ACTIONS(5578),
    [anon_sym_xor] = ACTIONS(5578),
    [anon_sym_bitand] = ACTIONS(5578),
    [anon_sym_not_eq] = ACTIONS(5578),
    [anon_sym_DASH_DASH] = ACTIONS(5580),
    [anon_sym_PLUS_PLUS] = ACTIONS(5580),
    [anon_sym_DOT] = ACTIONS(5578),
    [anon_sym_DOT_STAR] = ACTIONS(5580),
    [anon_sym_DASH_GT] = ACTIONS(5580),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5578),
    [anon_sym_decltype] = ACTIONS(5578),
    [anon_sym_final] = ACTIONS(5578),
    [anon_sym_override] = ACTIONS(5578),
    [anon_sym_requires] = ACTIONS(5578),
  },
  [1820] = {
    [sym_catch_clause] = STATE(1820),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1820),
    [sym_identifier] = ACTIONS(2439),
    [aux_sym_preproc_def_token1] = ACTIONS(2439),
    [aux_sym_preproc_if_token1] = ACTIONS(2439),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2439),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2439),
    [sym_preproc_directive] = ACTIONS(2439),
    [anon_sym_LPAREN2] = ACTIONS(2441),
    [anon_sym_TILDE] = ACTIONS(2441),
    [anon_sym_STAR] = ACTIONS(2441),
    [anon_sym_AMP_AMP] = ACTIONS(2441),
    [anon_sym_AMP] = ACTIONS(2439),
    [anon_sym_SEMI] = ACTIONS(2441),
    [anon_sym___extension__] = ACTIONS(2439),
    [anon_sym_typedef] = ACTIONS(2439),
    [anon_sym_virtual] = ACTIONS(2439),
    [anon_sym_extern] = ACTIONS(2439),
    [anon_sym___attribute__] = ACTIONS(2439),
    [anon_sym___attribute] = ACTIONS(2439),
    [anon_sym_COLON_COLON] = ACTIONS(2441),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2441),
    [anon_sym___declspec] = ACTIONS(2439),
    [anon_sym___based] = ACTIONS(2439),
    [anon_sym_RBRACE] = ACTIONS(2441),
    [anon_sym_signed] = ACTIONS(2439),
    [anon_sym_unsigned] = ACTIONS(2439),
    [anon_sym_long] = ACTIONS(2439),
    [anon_sym_short] = ACTIONS(2439),
    [anon_sym_LBRACK] = ACTIONS(2439),
    [anon_sym_static] = ACTIONS(2439),
    [anon_sym_register] = ACTIONS(2439),
    [anon_sym_inline] = ACTIONS(2439),
    [anon_sym___inline] = ACTIONS(2439),
    [anon_sym___inline__] = ACTIONS(2439),
    [anon_sym___forceinline] = ACTIONS(2439),
    [anon_sym_thread_local] = ACTIONS(2439),
    [anon_sym___thread] = ACTIONS(2439),
    [anon_sym_const] = ACTIONS(2439),
    [anon_sym_constexpr] = ACTIONS(2439),
    [anon_sym_volatile] = ACTIONS(2439),
    [anon_sym_restrict] = ACTIONS(2439),
    [anon_sym___restrict__] = ACTIONS(2439),
    [anon_sym__Atomic] = ACTIONS(2439),
    [anon_sym__Noreturn] = ACTIONS(2439),
    [anon_sym_noreturn] = ACTIONS(2439),
    [anon_sym__Nonnull] = ACTIONS(2439),
    [anon_sym_mutable] = ACTIONS(2439),
    [anon_sym_constinit] = ACTIONS(2439),
    [anon_sym_consteval] = ACTIONS(2439),
    [anon_sym_alignas] = ACTIONS(2439),
    [anon_sym__Alignas] = ACTIONS(2439),
    [sym_primitive_type] = ACTIONS(2439),
    [anon_sym_enum] = ACTIONS(2439),
    [anon_sym_class] = ACTIONS(2439),
    [anon_sym_struct] = ACTIONS(2439),
    [anon_sym_union] = ACTIONS(2439),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2439),
    [anon_sym_decltype] = ACTIONS(2439),
    [anon_sym_explicit] = ACTIONS(2439),
    [anon_sym_typename] = ACTIONS(2439),
    [anon_sym_template] = ACTIONS(2439),
    [anon_sym_operator] = ACTIONS(2439),
    [anon_sym_friend] = ACTIONS(2439),
    [anon_sym_public] = ACTIONS(2439),
    [anon_sym_private] = ACTIONS(2439),
    [anon_sym_protected] = ACTIONS(2439),
    [anon_sym_using] = ACTIONS(2439),
    [anon_sym_static_assert] = ACTIONS(2439),
    [anon_sym_catch] = ACTIONS(5582),
  },
  [1821] = {
    [sym_type_qualifier] = STATE(1617),
    [sym_alignas_qualifier] = STATE(1651),
    [aux_sym__type_definition_type_repeat1] = STATE(1617),
    [aux_sym_sized_type_specifier_repeat1] = STATE(3318),
    [sym_identifier] = ACTIONS(5585),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4961),
    [anon_sym_COMMA] = ACTIONS(4961),
    [aux_sym_preproc_if_token2] = ACTIONS(4961),
    [aux_sym_preproc_else_token1] = ACTIONS(4961),
    [aux_sym_preproc_elif_token1] = ACTIONS(4963),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4961),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4961),
    [anon_sym_LPAREN2] = ACTIONS(4961),
    [anon_sym_DASH] = ACTIONS(4963),
    [anon_sym_PLUS] = ACTIONS(4963),
    [anon_sym_STAR] = ACTIONS(4961),
    [anon_sym_SLASH] = ACTIONS(4963),
    [anon_sym_PERCENT] = ACTIONS(4961),
    [anon_sym_PIPE_PIPE] = ACTIONS(4961),
    [anon_sym_AMP_AMP] = ACTIONS(4961),
    [anon_sym_PIPE] = ACTIONS(4963),
    [anon_sym_CARET] = ACTIONS(4961),
    [anon_sym_AMP] = ACTIONS(4963),
    [anon_sym_EQ_EQ] = ACTIONS(4961),
    [anon_sym_BANG_EQ] = ACTIONS(4961),
    [anon_sym_GT] = ACTIONS(4963),
    [anon_sym_GT_EQ] = ACTIONS(4961),
    [anon_sym_LT_EQ] = ACTIONS(4963),
    [anon_sym_LT] = ACTIONS(4963),
    [anon_sym_LT_LT] = ACTIONS(4961),
    [anon_sym_GT_GT] = ACTIONS(4961),
    [anon_sym___extension__] = ACTIONS(5521),
    [anon_sym___attribute__] = ACTIONS(4963),
    [anon_sym___attribute] = ACTIONS(4963),
    [anon_sym_LBRACE] = ACTIONS(4961),
    [anon_sym_signed] = ACTIONS(5588),
    [anon_sym_unsigned] = ACTIONS(5588),
    [anon_sym_long] = ACTIONS(5588),
    [anon_sym_short] = ACTIONS(5588),
    [anon_sym_LBRACK] = ACTIONS(4961),
    [anon_sym_const] = ACTIONS(5521),
    [anon_sym_constexpr] = ACTIONS(5521),
    [anon_sym_volatile] = ACTIONS(5521),
    [anon_sym_restrict] = ACTIONS(5521),
    [anon_sym___restrict__] = ACTIONS(5521),
    [anon_sym__Atomic] = ACTIONS(5521),
    [anon_sym__Noreturn] = ACTIONS(5521),
    [anon_sym_noreturn] = ACTIONS(5521),
    [anon_sym__Nonnull] = ACTIONS(5521),
    [anon_sym_mutable] = ACTIONS(5521),
    [anon_sym_constinit] = ACTIONS(5521),
    [anon_sym_consteval] = ACTIONS(5521),
    [anon_sym_alignas] = ACTIONS(5525),
    [anon_sym__Alignas] = ACTIONS(5525),
    [sym_primitive_type] = ACTIONS(5590),
    [anon_sym_QMARK] = ACTIONS(4961),
    [anon_sym_LT_EQ_GT] = ACTIONS(4961),
    [anon_sym_or] = ACTIONS(4963),
    [anon_sym_and] = ACTIONS(4963),
    [anon_sym_bitor] = ACTIONS(4963),
    [anon_sym_xor] = ACTIONS(4963),
    [anon_sym_bitand] = ACTIONS(4963),
    [anon_sym_not_eq] = ACTIONS(4963),
    [anon_sym_DASH_DASH] = ACTIONS(4961),
    [anon_sym_PLUS_PLUS] = ACTIONS(4961),
    [anon_sym_DOT] = ACTIONS(4963),
    [anon_sym_DOT_STAR] = ACTIONS(4961),
    [anon_sym_DASH_GT] = ACTIONS(4961),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4963),
    [anon_sym_decltype] = ACTIONS(4963),
  },
  [1822] = {
    [sym_identifier] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5594),
    [anon_sym_COMMA] = ACTIONS(5594),
    [anon_sym_RPAREN] = ACTIONS(5594),
    [anon_sym_LPAREN2] = ACTIONS(5594),
    [anon_sym_DASH] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_STAR] = ACTIONS(5594),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5594),
    [anon_sym_PIPE_PIPE] = ACTIONS(5594),
    [anon_sym_AMP_AMP] = ACTIONS(5594),
    [anon_sym_PIPE] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5594),
    [anon_sym_AMP] = ACTIONS(5592),
    [anon_sym_EQ_EQ] = ACTIONS(5594),
    [anon_sym_BANG_EQ] = ACTIONS(5594),
    [anon_sym_GT] = ACTIONS(5592),
    [anon_sym_GT_EQ] = ACTIONS(5594),
    [anon_sym_LT_EQ] = ACTIONS(5592),
    [anon_sym_LT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5594),
    [anon_sym_GT_GT] = ACTIONS(5594),
    [anon_sym_SEMI] = ACTIONS(5594),
    [anon_sym___extension__] = ACTIONS(5592),
    [anon_sym___attribute__] = ACTIONS(5592),
    [anon_sym___attribute] = ACTIONS(5592),
    [anon_sym___based] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5594),
    [anon_sym_RBRACE] = ACTIONS(5594),
    [anon_sym_signed] = ACTIONS(5592),
    [anon_sym_unsigned] = ACTIONS(5592),
    [anon_sym_long] = ACTIONS(5592),
    [anon_sym_short] = ACTIONS(5592),
    [anon_sym_LBRACK] = ACTIONS(5594),
    [anon_sym_RBRACK] = ACTIONS(5594),
    [anon_sym_const] = ACTIONS(5592),
    [anon_sym_constexpr] = ACTIONS(5592),
    [anon_sym_volatile] = ACTIONS(5592),
    [anon_sym_restrict] = ACTIONS(5592),
    [anon_sym___restrict__] = ACTIONS(5592),
    [anon_sym__Atomic] = ACTIONS(5592),
    [anon_sym__Noreturn] = ACTIONS(5592),
    [anon_sym_noreturn] = ACTIONS(5592),
    [anon_sym__Nonnull] = ACTIONS(5592),
    [anon_sym_mutable] = ACTIONS(5592),
    [anon_sym_constinit] = ACTIONS(5592),
    [anon_sym_consteval] = ACTIONS(5592),
    [anon_sym_alignas] = ACTIONS(5592),
    [anon_sym__Alignas] = ACTIONS(5592),
    [sym_primitive_type] = ACTIONS(5592),
    [anon_sym_COLON] = ACTIONS(5594),
    [anon_sym_QMARK] = ACTIONS(5594),
    [anon_sym_LT_EQ_GT] = ACTIONS(5594),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_bitor] = ACTIONS(5592),
    [anon_sym_xor] = ACTIONS(5592),
    [anon_sym_bitand] = ACTIONS(5592),
    [anon_sym_not_eq] = ACTIONS(5592),
    [anon_sym_DASH_DASH] = ACTIONS(5594),
    [anon_sym_PLUS_PLUS] = ACTIONS(5594),
    [anon_sym_DOT] = ACTIONS(5592),
    [anon_sym_DOT_STAR] = ACTIONS(5594),
    [anon_sym_DASH_GT] = ACTIONS(5594),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5592),
    [anon_sym_decltype] = ACTIONS(5592),
    [anon_sym_final] = ACTIONS(5592),
    [anon_sym_override] = ACTIONS(5592),
    [anon_sym_requires] = ACTIONS(5592),
  },
  [1823] = {
    [sym_identifier] = ACTIONS(5596),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5598),
    [anon_sym_COMMA] = ACTIONS(5598),
    [anon_sym_RPAREN] = ACTIONS(5598),
    [anon_sym_LPAREN2] = ACTIONS(5598),
    [anon_sym_DASH] = ACTIONS(5596),
    [anon_sym_PLUS] = ACTIONS(5596),
    [anon_sym_STAR] = ACTIONS(5598),
    [anon_sym_SLASH] = ACTIONS(5596),
    [anon_sym_PERCENT] = ACTIONS(5598),
    [anon_sym_PIPE_PIPE] = ACTIONS(5598),
    [anon_sym_AMP_AMP] = ACTIONS(5598),
    [anon_sym_PIPE] = ACTIONS(5596),
    [anon_sym_CARET] = ACTIONS(5598),
    [anon_sym_AMP] = ACTIONS(5596),
    [anon_sym_EQ_EQ] = ACTIONS(5598),
    [anon_sym_BANG_EQ] = ACTIONS(5598),
    [anon_sym_GT] = ACTIONS(5596),
    [anon_sym_GT_EQ] = ACTIONS(5598),
    [anon_sym_LT_EQ] = ACTIONS(5596),
    [anon_sym_LT] = ACTIONS(5596),
    [anon_sym_LT_LT] = ACTIONS(5598),
    [anon_sym_GT_GT] = ACTIONS(5598),
    [anon_sym_SEMI] = ACTIONS(5598),
    [anon_sym___extension__] = ACTIONS(5596),
    [anon_sym___attribute__] = ACTIONS(5596),
    [anon_sym___attribute] = ACTIONS(5596),
    [anon_sym___based] = ACTIONS(5596),
    [anon_sym_LBRACE] = ACTIONS(5598),
    [anon_sym_RBRACE] = ACTIONS(5598),
    [anon_sym_signed] = ACTIONS(5596),
    [anon_sym_unsigned] = ACTIONS(5596),
    [anon_sym_long] = ACTIONS(5596),
    [anon_sym_short] = ACTIONS(5596),
    [anon_sym_LBRACK] = ACTIONS(5598),
    [anon_sym_RBRACK] = ACTIONS(5598),
    [anon_sym_const] = ACTIONS(5596),
    [anon_sym_constexpr] = ACTIONS(5596),
    [anon_sym_volatile] = ACTIONS(5596),
    [anon_sym_restrict] = ACTIONS(5596),
    [anon_sym___restrict__] = ACTIONS(5596),
    [anon_sym__Atomic] = ACTIONS(5596),
    [anon_sym__Noreturn] = ACTIONS(5596),
    [anon_sym_noreturn] = ACTIONS(5596),
    [anon_sym__Nonnull] = ACTIONS(5596),
    [anon_sym_mutable] = ACTIONS(5596),
    [anon_sym_constinit] = ACTIONS(5596),
    [anon_sym_consteval] = ACTIONS(5596),
    [anon_sym_alignas] = ACTIONS(5596),
    [anon_sym__Alignas] = ACTIONS(5596),
    [sym_primitive_type] = ACTIONS(5596),
    [anon_sym_COLON] = ACTIONS(5598),
    [anon_sym_QMARK] = ACTIONS(5598),
    [anon_sym_LT_EQ_GT] = ACTIONS(5598),
    [anon_sym_or] = ACTIONS(5596),
    [anon_sym_and] = ACTIONS(5596),
    [anon_sym_bitor] = ACTIONS(5596),
    [anon_sym_xor] = ACTIONS(5596),
    [anon_sym_bitand] = ACTIONS(5596),
    [anon_sym_not_eq] = ACTIONS(5596),
    [anon_sym_DASH_DASH] = ACTIONS(5598),
    [anon_sym_PLUS_PLUS] = ACTIONS(5598),
    [anon_sym_DOT] = ACTIONS(5596),
    [anon_sym_DOT_STAR] = ACTIONS(5598),
    [anon_sym_DASH_GT] = ACTIONS(5598),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5596),
    [anon_sym_decltype] = ACTIONS(5596),
    [anon_sym_final] = ACTIONS(5596),
    [anon_sym_override] = ACTIONS(5596),
    [anon_sym_requires] = ACTIONS(5596),
  },
  [1824] = {
    [sym_identifier] = ACTIONS(5600),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5602),
    [anon_sym_COMMA] = ACTIONS(5602),
    [anon_sym_RPAREN] = ACTIONS(5602),
    [anon_sym_LPAREN2] = ACTIONS(5602),
    [anon_sym_DASH] = ACTIONS(5600),
    [anon_sym_PLUS] = ACTIONS(5600),
    [anon_sym_STAR] = ACTIONS(5602),
    [anon_sym_SLASH] = ACTIONS(5600),
    [anon_sym_PERCENT] = ACTIONS(5602),
    [anon_sym_PIPE_PIPE] = ACTIONS(5602),
    [anon_sym_AMP_AMP] = ACTIONS(5602),
    [anon_sym_PIPE] = ACTIONS(5600),
    [anon_sym_CARET] = ACTIONS(5602),
    [anon_sym_AMP] = ACTIONS(5600),
    [anon_sym_EQ_EQ] = ACTIONS(5602),
    [anon_sym_BANG_EQ] = ACTIONS(5602),
    [anon_sym_GT] = ACTIONS(5600),
    [anon_sym_GT_EQ] = ACTIONS(5602),
    [anon_sym_LT_EQ] = ACTIONS(5600),
    [anon_sym_LT] = ACTIONS(5600),
    [anon_sym_LT_LT] = ACTIONS(5602),
    [anon_sym_GT_GT] = ACTIONS(5602),
    [anon_sym_SEMI] = ACTIONS(5602),
    [anon_sym___extension__] = ACTIONS(5600),
    [anon_sym___attribute__] = ACTIONS(5600),
    [anon_sym___attribute] = ACTIONS(5600),
    [anon_sym___based] = ACTIONS(5600),
    [anon_sym_LBRACE] = ACTIONS(5602),
    [anon_sym_RBRACE] = ACTIONS(5602),
    [anon_sym_signed] = ACTIONS(5600),
    [anon_sym_unsigned] = ACTIONS(5600),
    [anon_sym_long] = ACTIONS(5600),
    [anon_sym_short] = ACTIONS(5600),
    [anon_sym_LBRACK] = ACTIONS(5602),
    [anon_sym_RBRACK] = ACTIONS(5602),
    [anon_sym_const] = ACTIONS(5600),
    [anon_sym_constexpr] = ACTIONS(5600),
    [anon_sym_volatile] = ACTIONS(5600),
    [anon_sym_restrict] = ACTIONS(5600),
    [anon_sym___restrict__] = ACTIONS(5600),
    [anon_sym__Atomic] = ACTIONS(5600),
    [anon_sym__Noreturn] = ACTIONS(5600),
    [anon_sym_noreturn] = ACTIONS(5600),
    [anon_sym__Nonnull] = ACTIONS(5600),
    [anon_sym_mutable] = ACTIONS(5600),
    [anon_sym_constinit] = ACTIONS(5600),
    [anon_sym_consteval] = ACTIONS(5600),
    [anon_sym_alignas] = ACTIONS(5600),
    [anon_sym__Alignas] = ACTIONS(5600),
    [sym_primitive_type] = ACTIONS(5600),
    [anon_sym_COLON] = ACTIONS(5602),
    [anon_sym_QMARK] = ACTIONS(5602),
    [anon_sym_LT_EQ_GT] = ACTIONS(5602),
    [anon_sym_or] = ACTIONS(5600),
    [anon_sym_and] = ACTIONS(5600),
    [anon_sym_bitor] = ACTIONS(5600),
    [anon_sym_xor] = ACTIONS(5600),
    [anon_sym_bitand] = ACTIONS(5600),
    [anon_sym_not_eq] = ACTIONS(5600),
    [anon_sym_DASH_DASH] = ACTIONS(5602),
    [anon_sym_PLUS_PLUS] = ACTIONS(5602),
    [anon_sym_DOT] = ACTIONS(5600),
    [anon_sym_DOT_STAR] = ACTIONS(5602),
    [anon_sym_DASH_GT] = ACTIONS(5602),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5600),
    [anon_sym_decltype] = ACTIONS(5600),
    [anon_sym_final] = ACTIONS(5600),
    [anon_sym_override] = ACTIONS(5600),
    [anon_sym_requires] = ACTIONS(5600),
  },
  [1825] = {
    [sym_catch_clause] = STATE(1833),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1833),
    [sym_identifier] = ACTIONS(2553),
    [aux_sym_preproc_def_token1] = ACTIONS(2553),
    [aux_sym_preproc_if_token1] = ACTIONS(2553),
    [aux_sym_preproc_if_token2] = ACTIONS(2553),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2553),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2553),
    [sym_preproc_directive] = ACTIONS(2553),
    [anon_sym_LPAREN2] = ACTIONS(2555),
    [anon_sym_TILDE] = ACTIONS(2555),
    [anon_sym_STAR] = ACTIONS(2555),
    [anon_sym_AMP_AMP] = ACTIONS(2555),
    [anon_sym_AMP] = ACTIONS(2553),
    [anon_sym_SEMI] = ACTIONS(2555),
    [anon_sym___extension__] = ACTIONS(2553),
    [anon_sym_typedef] = ACTIONS(2553),
    [anon_sym_virtual] = ACTIONS(2553),
    [anon_sym_extern] = ACTIONS(2553),
    [anon_sym___attribute__] = ACTIONS(2553),
    [anon_sym___attribute] = ACTIONS(2553),
    [anon_sym_COLON_COLON] = ACTIONS(2555),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2555),
    [anon_sym___declspec] = ACTIONS(2553),
    [anon_sym___based] = ACTIONS(2553),
    [anon_sym_signed] = ACTIONS(2553),
    [anon_sym_unsigned] = ACTIONS(2553),
    [anon_sym_long] = ACTIONS(2553),
    [anon_sym_short] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(2553),
    [anon_sym_static] = ACTIONS(2553),
    [anon_sym_register] = ACTIONS(2553),
    [anon_sym_inline] = ACTIONS(2553),
    [anon_sym___inline] = ACTIONS(2553),
    [anon_sym___inline__] = ACTIONS(2553),
    [anon_sym___forceinline] = ACTIONS(2553),
    [anon_sym_thread_local] = ACTIONS(2553),
    [anon_sym___thread] = ACTIONS(2553),
    [anon_sym_const] = ACTIONS(2553),
    [anon_sym_constexpr] = ACTIONS(2553),
    [anon_sym_volatile] = ACTIONS(2553),
    [anon_sym_restrict] = ACTIONS(2553),
    [anon_sym___restrict__] = ACTIONS(2553),
    [anon_sym__Atomic] = ACTIONS(2553),
    [anon_sym__Noreturn] = ACTIONS(2553),
    [anon_sym_noreturn] = ACTIONS(2553),
    [anon_sym__Nonnull] = ACTIONS(2553),
    [anon_sym_mutable] = ACTIONS(2553),
    [anon_sym_constinit] = ACTIONS(2553),
    [anon_sym_consteval] = ACTIONS(2553),
    [anon_sym_alignas] = ACTIONS(2553),
    [anon_sym__Alignas] = ACTIONS(2553),
    [sym_primitive_type] = ACTIONS(2553),
    [anon_sym_enum] = ACTIONS(2553),
    [anon_sym_class] = ACTIONS(2553),
    [anon_sym_struct] = ACTIONS(2553),
    [anon_sym_union] = ACTIONS(2553),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2553),
    [anon_sym_decltype] = ACTIONS(2553),
    [anon_sym_explicit] = ACTIONS(2553),
    [anon_sym_typename] = ACTIONS(2553),
    [anon_sym_template] = ACTIONS(2553),
    [anon_sym_operator] = ACTIONS(2553),
    [anon_sym_friend] = ACTIONS(2553),
    [anon_sym_public] = ACTIONS(2553),
    [anon_sym_private] = ACTIONS(2553),
    [anon_sym_protected] = ACTIONS(2553),
    [anon_sym_using] = ACTIONS(2553),
    [anon_sym_static_assert] = ACTIONS(2553),
    [anon_sym_catch] = ACTIONS(5576),
  },
  [1826] = {
    [sym_identifier] = ACTIONS(5498),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5500),
    [anon_sym_COMMA] = ACTIONS(5500),
    [anon_sym_RPAREN] = ACTIONS(5500),
    [anon_sym_LPAREN2] = ACTIONS(5500),
    [anon_sym_DASH] = ACTIONS(5498),
    [anon_sym_PLUS] = ACTIONS(5498),
    [anon_sym_STAR] = ACTIONS(5500),
    [anon_sym_SLASH] = ACTIONS(5498),
    [anon_sym_PERCENT] = ACTIONS(5500),
    [anon_sym_PIPE_PIPE] = ACTIONS(5500),
    [anon_sym_AMP_AMP] = ACTIONS(5500),
    [anon_sym_PIPE] = ACTIONS(5498),
    [anon_sym_CARET] = ACTIONS(5500),
    [anon_sym_AMP] = ACTIONS(5498),
    [anon_sym_EQ_EQ] = ACTIONS(5500),
    [anon_sym_BANG_EQ] = ACTIONS(5500),
    [anon_sym_GT] = ACTIONS(5498),
    [anon_sym_GT_EQ] = ACTIONS(5500),
    [anon_sym_LT_EQ] = ACTIONS(5498),
    [anon_sym_LT] = ACTIONS(5498),
    [anon_sym_LT_LT] = ACTIONS(5500),
    [anon_sym_GT_GT] = ACTIONS(5500),
    [anon_sym_SEMI] = ACTIONS(5500),
    [anon_sym___extension__] = ACTIONS(5498),
    [anon_sym___attribute__] = ACTIONS(5498),
    [anon_sym___attribute] = ACTIONS(5498),
    [anon_sym___based] = ACTIONS(5498),
    [anon_sym_LBRACE] = ACTIONS(5500),
    [anon_sym_RBRACE] = ACTIONS(5500),
    [anon_sym_signed] = ACTIONS(5498),
    [anon_sym_unsigned] = ACTIONS(5498),
    [anon_sym_long] = ACTIONS(5498),
    [anon_sym_short] = ACTIONS(5498),
    [anon_sym_LBRACK] = ACTIONS(5500),
    [anon_sym_RBRACK] = ACTIONS(5500),
    [anon_sym_const] = ACTIONS(5498),
    [anon_sym_constexpr] = ACTIONS(5498),
    [anon_sym_volatile] = ACTIONS(5498),
    [anon_sym_restrict] = ACTIONS(5498),
    [anon_sym___restrict__] = ACTIONS(5498),
    [anon_sym__Atomic] = ACTIONS(5498),
    [anon_sym__Noreturn] = ACTIONS(5498),
    [anon_sym_noreturn] = ACTIONS(5498),
    [anon_sym__Nonnull] = ACTIONS(5498),
    [anon_sym_mutable] = ACTIONS(5498),
    [anon_sym_constinit] = ACTIONS(5498),
    [anon_sym_consteval] = ACTIONS(5498),
    [anon_sym_alignas] = ACTIONS(5498),
    [anon_sym__Alignas] = ACTIONS(5498),
    [sym_primitive_type] = ACTIONS(5498),
    [anon_sym_COLON] = ACTIONS(5500),
    [anon_sym_QMARK] = ACTIONS(5500),
    [anon_sym_LT_EQ_GT] = ACTIONS(5500),
    [anon_sym_or] = ACTIONS(5498),
    [anon_sym_and] = ACTIONS(5498),
    [anon_sym_bitor] = ACTIONS(5498),
    [anon_sym_xor] = ACTIONS(5498),
    [anon_sym_bitand] = ACTIONS(5498),
    [anon_sym_not_eq] = ACTIONS(5498),
    [anon_sym_DASH_DASH] = ACTIONS(5500),
    [anon_sym_PLUS_PLUS] = ACTIONS(5500),
    [anon_sym_DOT] = ACTIONS(5498),
    [anon_sym_DOT_STAR] = ACTIONS(5500),
    [anon_sym_DASH_GT] = ACTIONS(5500),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5498),
    [anon_sym_decltype] = ACTIONS(5498),
    [anon_sym_final] = ACTIONS(5498),
    [anon_sym_override] = ACTIONS(5498),
    [anon_sym_requires] = ACTIONS(5498),
  },
  [1827] = {
    [sym_type_qualifier] = STATE(1617),
    [sym_alignas_qualifier] = STATE(1651),
    [aux_sym__type_definition_type_repeat1] = STATE(1617),
    [aux_sym_sized_type_specifier_repeat1] = STATE(1884),
    [sym_identifier] = ACTIONS(5604),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4961),
    [anon_sym_COMMA] = ACTIONS(4961),
    [anon_sym_RPAREN] = ACTIONS(4961),
    [anon_sym_LPAREN2] = ACTIONS(4961),
    [anon_sym_DASH] = ACTIONS(4963),
    [anon_sym_PLUS] = ACTIONS(4963),
    [anon_sym_STAR] = ACTIONS(4961),
    [anon_sym_SLASH] = ACTIONS(4963),
    [anon_sym_PERCENT] = ACTIONS(4961),
    [anon_sym_PIPE_PIPE] = ACTIONS(4961),
    [anon_sym_AMP_AMP] = ACTIONS(4961),
    [anon_sym_PIPE] = ACTIONS(4963),
    [anon_sym_CARET] = ACTIONS(4961),
    [anon_sym_AMP] = ACTIONS(4963),
    [anon_sym_EQ_EQ] = ACTIONS(4961),
    [anon_sym_BANG_EQ] = ACTIONS(4961),
    [anon_sym_GT] = ACTIONS(4963),
    [anon_sym_GT_EQ] = ACTIONS(4961),
    [anon_sym_LT_EQ] = ACTIONS(4963),
    [anon_sym_LT] = ACTIONS(4963),
    [anon_sym_LT_LT] = ACTIONS(4961),
    [anon_sym_GT_GT] = ACTIONS(4961),
    [anon_sym_SEMI] = ACTIONS(4961),
    [anon_sym___extension__] = ACTIONS(5521),
    [anon_sym___attribute__] = ACTIONS(4963),
    [anon_sym___attribute] = ACTIONS(4963),
    [anon_sym_LBRACE] = ACTIONS(4961),
    [anon_sym_RBRACE] = ACTIONS(4961),
    [anon_sym_signed] = ACTIONS(5606),
    [anon_sym_unsigned] = ACTIONS(5606),
    [anon_sym_long] = ACTIONS(5606),
    [anon_sym_short] = ACTIONS(5606),
    [anon_sym_LBRACK] = ACTIONS(4961),
    [anon_sym_RBRACK] = ACTIONS(4961),
    [anon_sym_const] = ACTIONS(5521),
    [anon_sym_constexpr] = ACTIONS(5521),
    [anon_sym_volatile] = ACTIONS(5521),
    [anon_sym_restrict] = ACTIONS(5521),
    [anon_sym___restrict__] = ACTIONS(5521),
    [anon_sym__Atomic] = ACTIONS(5521),
    [anon_sym__Noreturn] = ACTIONS(5521),
    [anon_sym_noreturn] = ACTIONS(5521),
    [anon_sym__Nonnull] = ACTIONS(5521),
    [anon_sym_mutable] = ACTIONS(5521),
    [anon_sym_constinit] = ACTIONS(5521),
    [anon_sym_consteval] = ACTIONS(5521),
    [anon_sym_alignas] = ACTIONS(5525),
    [anon_sym__Alignas] = ACTIONS(5525),
    [sym_primitive_type] = ACTIONS(5608),
    [anon_sym_COLON] = ACTIONS(4961),
    [anon_sym_QMARK] = ACTIONS(4961),
    [anon_sym_LT_EQ_GT] = ACTIONS(4961),
    [anon_sym_or] = ACTIONS(4963),
    [anon_sym_and] = ACTIONS(4963),
    [anon_sym_bitor] = ACTIONS(4963),
    [anon_sym_xor] = ACTIONS(4963),
    [anon_sym_bitand] = ACTIONS(4963),
    [anon_sym_not_eq] = ACTIONS(4963),
    [anon_sym_DASH_DASH] = ACTIONS(4961),
    [anon_sym_PLUS_PLUS] = ACTIONS(4961),
    [anon_sym_DOT] = ACTIONS(4963),
    [anon_sym_DOT_STAR] = ACTIONS(4961),
    [anon_sym_DASH_GT] = ACTIONS(4961),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4963),
    [anon_sym_decltype] = ACTIONS(4963),
  },
  [1828] = {
    [sym_catch_clause] = STATE(1820),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1820),
    [sym_identifier] = ACTIONS(2553),
    [aux_sym_preproc_def_token1] = ACTIONS(2553),
    [aux_sym_preproc_if_token1] = ACTIONS(2553),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2553),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2553),
    [sym_preproc_directive] = ACTIONS(2553),
    [anon_sym_LPAREN2] = ACTIONS(2555),
    [anon_sym_TILDE] = ACTIONS(2555),
    [anon_sym_STAR] = ACTIONS(2555),
    [anon_sym_AMP_AMP] = ACTIONS(2555),
    [anon_sym_AMP] = ACTIONS(2553),
    [anon_sym_SEMI] = ACTIONS(2555),
    [anon_sym___extension__] = ACTIONS(2553),
    [anon_sym_typedef] = ACTIONS(2553),
    [anon_sym_virtual] = ACTIONS(2553),
    [anon_sym_extern] = ACTIONS(2553),
    [anon_sym___attribute__] = ACTIONS(2553),
    [anon_sym___attribute] = ACTIONS(2553),
    [anon_sym_COLON_COLON] = ACTIONS(2555),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2555),
    [anon_sym___declspec] = ACTIONS(2553),
    [anon_sym___based] = ACTIONS(2553),
    [anon_sym_RBRACE] = ACTIONS(2555),
    [anon_sym_signed] = ACTIONS(2553),
    [anon_sym_unsigned] = ACTIONS(2553),
    [anon_sym_long] = ACTIONS(2553),
    [anon_sym_short] = ACTIONS(2553),
    [anon_sym_LBRACK] = ACTIONS(2553),
    [anon_sym_static] = ACTIONS(2553),
    [anon_sym_register] = ACTIONS(2553),
    [anon_sym_inline] = ACTIONS(2553),
    [anon_sym___inline] = ACTIONS(2553),
    [anon_sym___inline__] = ACTIONS(2553),
    [anon_sym___forceinline] = ACTIONS(2553),
    [anon_sym_thread_local] = ACTIONS(2553),
    [anon_sym___thread] = ACTIONS(2553),
    [anon_sym_const] = ACTIONS(2553),
    [anon_sym_constexpr] = ACTIONS(2553),
    [anon_sym_volatile] = ACTIONS(2553),
    [anon_sym_restrict] = ACTIONS(2553),
    [anon_sym___restrict__] = ACTIONS(2553),
    [anon_sym__Atomic] = ACTIONS(2553),
    [anon_sym__Noreturn] = ACTIONS(2553),
    [anon_sym_noreturn] = ACTIONS(2553),
    [anon_sym__Nonnull] = ACTIONS(2553),
    [anon_sym_mutable] = ACTIONS(2553),
    [anon_sym_constinit] = ACTIONS(2553),
    [anon_sym_consteval] = ACTIONS(2553),
    [anon_sym_alignas] = ACTIONS(2553),
    [anon_sym__Alignas] = ACTIONS(2553),
    [sym_primitive_type] = ACTIONS(2553),
    [anon_sym_enum] = ACTIONS(2553),
    [anon_sym_class] = ACTIONS(2553),
    [anon_sym_struct] = ACTIONS(2553),
    [anon_sym_union] = ACTIONS(2553),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2553),
    [anon_sym_decltype] = ACTIONS(2553),
    [anon_sym_explicit] = ACTIONS(2553),
    [anon_sym_typename] = ACTIONS(2553),
    [anon_sym_template] = ACTIONS(2553),
    [anon_sym_operator] = ACTIONS(2553),
    [anon_sym_friend] = ACTIONS(2553),
    [anon_sym_public] = ACTIONS(2553),
    [anon_sym_private] = ACTIONS(2553),
    [anon_sym_protected] = ACTIONS(2553),
    [anon_sym_using] = ACTIONS(2553),
    [anon_sym_static_assert] = ACTIONS(2553),
    [anon_sym_catch] = ACTIONS(5610),
  },
  [1829] = {
    [sym_identifier] = ACTIONS(4855),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4862),
    [anon_sym_COMMA] = ACTIONS(4862),
    [anon_sym_RPAREN] = ACTIONS(4862),
    [aux_sym_preproc_if_token2] = ACTIONS(4862),
    [aux_sym_preproc_else_token1] = ACTIONS(4862),
    [aux_sym_preproc_elif_token1] = ACTIONS(4855),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4862),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4862),
    [anon_sym_LPAREN2] = ACTIONS(4862),
    [anon_sym_DASH] = ACTIONS(4855),
    [anon_sym_PLUS] = ACTIONS(4855),
    [anon_sym_STAR] = ACTIONS(4862),
    [anon_sym_SLASH] = ACTIONS(4855),
    [anon_sym_PERCENT] = ACTIONS(4862),
    [anon_sym_PIPE_PIPE] = ACTIONS(4862),
    [anon_sym_AMP_AMP] = ACTIONS(4862),
    [anon_sym_PIPE] = ACTIONS(4855),
    [anon_sym_CARET] = ACTIONS(4862),
    [anon_sym_AMP] = ACTIONS(4855),
    [anon_sym_EQ_EQ] = ACTIONS(4862),
    [anon_sym_BANG_EQ] = ACTIONS(4862),
    [anon_sym_GT] = ACTIONS(4855),
    [anon_sym_GT_EQ] = ACTIONS(4862),
    [anon_sym_LT_EQ] = ACTIONS(4855),
    [anon_sym_LT] = ACTIONS(4855),
    [anon_sym_LT_LT] = ACTIONS(4862),
    [anon_sym_GT_GT] = ACTIONS(4862),
    [anon_sym_SEMI] = ACTIONS(4862),
    [anon_sym___extension__] = ACTIONS(4855),
    [anon_sym___attribute__] = ACTIONS(4855),
    [anon_sym___attribute] = ACTIONS(4855),
    [anon_sym_COLON_COLON] = ACTIONS(4862),
    [anon_sym_LBRACE] = ACTIONS(4862),
    [anon_sym_RBRACE] = ACTIONS(4862),
    [anon_sym_LBRACK] = ACTIONS(4862),
    [anon_sym_RBRACK] = ACTIONS(4862),
    [anon_sym_const] = ACTIONS(4855),
    [anon_sym_constexpr] = ACTIONS(4855),
    [anon_sym_volatile] = ACTIONS(4855),
    [anon_sym_restrict] = ACTIONS(4855),
    [anon_sym___restrict__] = ACTIONS(4855),
    [anon_sym__Atomic] = ACTIONS(4855),
    [anon_sym__Noreturn] = ACTIONS(4855),
    [anon_sym_noreturn] = ACTIONS(4855),
    [anon_sym__Nonnull] = ACTIONS(4855),
    [anon_sym_mutable] = ACTIONS(4855),
    [anon_sym_constinit] = ACTIONS(4855),
    [anon_sym_consteval] = ACTIONS(4855),
    [anon_sym_alignas] = ACTIONS(4855),
    [anon_sym__Alignas] = ACTIONS(4855),
    [anon_sym_COLON] = ACTIONS(4855),
    [anon_sym_QMARK] = ACTIONS(4862),
    [anon_sym_LT_EQ_GT] = ACTIONS(4862),
    [anon_sym_or] = ACTIONS(4855),
    [anon_sym_and] = ACTIONS(4855),
    [anon_sym_bitor] = ACTIONS(4855),
    [anon_sym_xor] = ACTIONS(4855),
    [anon_sym_bitand] = ACTIONS(4855),
    [anon_sym_not_eq] = ACTIONS(4855),
    [anon_sym_DASH_DASH] = ACTIONS(4862),
    [anon_sym_PLUS_PLUS] = ACTIONS(4862),
    [anon_sym_DOT] = ACTIONS(4855),
    [anon_sym_DOT_STAR] = ACTIONS(4862),
    [anon_sym_DASH_GT] = ACTIONS(4862),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4855),
    [anon_sym_decltype] = ACTIONS(4855),
    [anon_sym_final] = ACTIONS(4855),
    [anon_sym_override] = ACTIONS(4855),
    [anon_sym_requires] = ACTIONS(4855),
  },
  [1830] = {
    [sym_catch_clause] = STATE(1833),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1833),
    [sym_identifier] = ACTIONS(2490),
    [aux_sym_preproc_def_token1] = ACTIONS(2490),
    [aux_sym_preproc_if_token1] = ACTIONS(2490),
    [aux_sym_preproc_if_token2] = ACTIONS(2490),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2490),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2490),
    [sym_preproc_directive] = ACTIONS(2490),
    [anon_sym_LPAREN2] = ACTIONS(2492),
    [anon_sym_TILDE] = ACTIONS(2492),
    [anon_sym_STAR] = ACTIONS(2492),
    [anon_sym_AMP_AMP] = ACTIONS(2492),
    [anon_sym_AMP] = ACTIONS(2490),
    [anon_sym_SEMI] = ACTIONS(2492),
    [anon_sym___extension__] = ACTIONS(2490),
    [anon_sym_typedef] = ACTIONS(2490),
    [anon_sym_virtual] = ACTIONS(2490),
    [anon_sym_extern] = ACTIONS(2490),
    [anon_sym___attribute__] = ACTIONS(2490),
    [anon_sym___attribute] = ACTIONS(2490),
    [anon_sym_COLON_COLON] = ACTIONS(2492),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2492),
    [anon_sym___declspec] = ACTIONS(2490),
    [anon_sym___based] = ACTIONS(2490),
    [anon_sym_signed] = ACTIONS(2490),
    [anon_sym_unsigned] = ACTIONS(2490),
    [anon_sym_long] = ACTIONS(2490),
    [anon_sym_short] = ACTIONS(2490),
    [anon_sym_LBRACK] = ACTIONS(2490),
    [anon_sym_static] = ACTIONS(2490),
    [anon_sym_register] = ACTIONS(2490),
    [anon_sym_inline] = ACTIONS(2490),
    [anon_sym___inline] = ACTIONS(2490),
    [anon_sym___inline__] = ACTIONS(2490),
    [anon_sym___forceinline] = ACTIONS(2490),
    [anon_sym_thread_local] = ACTIONS(2490),
    [anon_sym___thread] = ACTIONS(2490),
    [anon_sym_const] = ACTIONS(2490),
    [anon_sym_constexpr] = ACTIONS(2490),
    [anon_sym_volatile] = ACTIONS(2490),
    [anon_sym_restrict] = ACTIONS(2490),
    [anon_sym___restrict__] = ACTIONS(2490),
    [anon_sym__Atomic] = ACTIONS(2490),
    [anon_sym__Noreturn] = ACTIONS(2490),
    [anon_sym_noreturn] = ACTIONS(2490),
    [anon_sym__Nonnull] = ACTIONS(2490),
    [anon_sym_mutable] = ACTIONS(2490),
    [anon_sym_constinit] = ACTIONS(2490),
    [anon_sym_consteval] = ACTIONS(2490),
    [anon_sym_alignas] = ACTIONS(2490),
    [anon_sym__Alignas] = ACTIONS(2490),
    [sym_primitive_type] = ACTIONS(2490),
    [anon_sym_enum] = ACTIONS(2490),
    [anon_sym_class] = ACTIONS(2490),
    [anon_sym_struct] = ACTIONS(2490),
    [anon_sym_union] = ACTIONS(2490),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2490),
    [anon_sym_decltype] = ACTIONS(2490),
    [anon_sym_explicit] = ACTIONS(2490),
    [anon_sym_typename] = ACTIONS(2490),
    [anon_sym_template] = ACTIONS(2490),
    [anon_sym_operator] = ACTIONS(2490),
    [anon_sym_friend] = ACTIONS(2490),
    [anon_sym_public] = ACTIONS(2490),
    [anon_sym_private] = ACTIONS(2490),
    [anon_sym_protected] = ACTIONS(2490),
    [anon_sym_using] = ACTIONS(2490),
    [anon_sym_static_assert] = ACTIONS(2490),
    [anon_sym_catch] = ACTIONS(5576),
  },
  [1831] = {
    [sym_template_argument_list] = STATE(1862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4842),
    [anon_sym_COMMA] = ACTIONS(4842),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DASH] = ACTIONS(4847),
    [anon_sym_PLUS] = ACTIONS(4847),
    [anon_sym_STAR] = ACTIONS(4849),
    [anon_sym_SLASH] = ACTIONS(4847),
    [anon_sym_PERCENT] = ACTIONS(4847),
    [anon_sym_PIPE_PIPE] = ACTIONS(4840),
    [anon_sym_AMP_AMP] = ACTIONS(4842),
    [anon_sym_PIPE] = ACTIONS(4847),
    [anon_sym_CARET] = ACTIONS(4847),
    [anon_sym_AMP] = ACTIONS(4849),
    [anon_sym_EQ_EQ] = ACTIONS(4840),
    [anon_sym_BANG_EQ] = ACTIONS(4840),
    [anon_sym_GT] = ACTIONS(4847),
    [anon_sym_GT_EQ] = ACTIONS(4847),
    [anon_sym_LT_EQ] = ACTIONS(4847),
    [anon_sym_LT] = ACTIONS(5612),
    [anon_sym_LT_LT] = ACTIONS(4847),
    [anon_sym_GT_GT] = ACTIONS(4847),
    [anon_sym___extension__] = ACTIONS(4845),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACE] = ACTIONS(4845),
    [anon_sym_LBRACK] = ACTIONS(4842),
    [anon_sym_EQ] = ACTIONS(4847),
    [anon_sym_const] = ACTIONS(4838),
    [anon_sym_constexpr] = ACTIONS(4845),
    [anon_sym_volatile] = ACTIONS(4845),
    [anon_sym_restrict] = ACTIONS(4845),
    [anon_sym___restrict__] = ACTIONS(4845),
    [anon_sym__Atomic] = ACTIONS(4845),
    [anon_sym__Noreturn] = ACTIONS(4845),
    [anon_sym_noreturn] = ACTIONS(4845),
    [anon_sym__Nonnull] = ACTIONS(4845),
    [anon_sym_mutable] = ACTIONS(4845),
    [anon_sym_constinit] = ACTIONS(4845),
    [anon_sym_consteval] = ACTIONS(4845),
    [anon_sym_alignas] = ACTIONS(4845),
    [anon_sym__Alignas] = ACTIONS(4845),
    [anon_sym_QMARK] = ACTIONS(4840),
    [anon_sym_STAR_EQ] = ACTIONS(4840),
    [anon_sym_SLASH_EQ] = ACTIONS(4840),
    [anon_sym_PERCENT_EQ] = ACTIONS(4840),
    [anon_sym_PLUS_EQ] = ACTIONS(4840),
    [anon_sym_DASH_EQ] = ACTIONS(4840),
    [anon_sym_LT_LT_EQ] = ACTIONS(4840),
    [anon_sym_GT_GT_EQ] = ACTIONS(4847),
    [anon_sym_AMP_EQ] = ACTIONS(4840),
    [anon_sym_CARET_EQ] = ACTIONS(4840),
    [anon_sym_PIPE_EQ] = ACTIONS(4840),
    [anon_sym_and_eq] = ACTIONS(4840),
    [anon_sym_or_eq] = ACTIONS(4840),
    [anon_sym_xor_eq] = ACTIONS(4840),
    [anon_sym_LT_EQ_GT] = ACTIONS(4840),
    [anon_sym_or] = ACTIONS(4847),
    [anon_sym_and] = ACTIONS(4847),
    [anon_sym_bitor] = ACTIONS(4840),
    [anon_sym_xor] = ACTIONS(4847),
    [anon_sym_bitand] = ACTIONS(4840),
    [anon_sym_not_eq] = ACTIONS(4840),
    [anon_sym_DASH_DASH] = ACTIONS(4840),
    [anon_sym_PLUS_PLUS] = ACTIONS(4840),
    [anon_sym_DOT] = ACTIONS(4847),
    [anon_sym_DOT_STAR] = ACTIONS(4840),
    [anon_sym_DASH_GT] = ACTIONS(4840),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4845),
    [anon_sym_decltype] = ACTIONS(4845),
    [anon_sym_GT2] = ACTIONS(4842),
  },
  [1832] = {
    [sym_identifier] = ACTIONS(2536),
    [anon_sym_LPAREN2] = ACTIONS(2526),
    [anon_sym_BANG] = ACTIONS(2526),
    [anon_sym_TILDE] = ACTIONS(2526),
    [anon_sym_DASH] = ACTIONS(2536),
    [anon_sym_PLUS] = ACTIONS(2536),
    [anon_sym_STAR] = ACTIONS(2526),
    [anon_sym_AMP] = ACTIONS(2526),
    [anon_sym___extension__] = ACTIONS(2536),
    [anon_sym_COLON_COLON] = ACTIONS(2526),
    [anon_sym_LBRACK] = ACTIONS(2526),
    [anon_sym_static] = ACTIONS(2536),
    [anon_sym_RBRACK] = ACTIONS(2526),
    [anon_sym_const] = ACTIONS(2536),
    [anon_sym_constexpr] = ACTIONS(2536),
    [anon_sym_volatile] = ACTIONS(2536),
    [anon_sym_restrict] = ACTIONS(2536),
    [anon_sym___restrict__] = ACTIONS(2536),
    [anon_sym__Atomic] = ACTIONS(2536),
    [anon_sym__Noreturn] = ACTIONS(2536),
    [anon_sym_noreturn] = ACTIONS(2536),
    [anon_sym__Nonnull] = ACTIONS(2536),
    [anon_sym_mutable] = ACTIONS(2536),
    [anon_sym_constinit] = ACTIONS(2536),
    [anon_sym_consteval] = ACTIONS(2536),
    [anon_sym_alignas] = ACTIONS(2536),
    [anon_sym__Alignas] = ACTIONS(2536),
    [sym_primitive_type] = ACTIONS(2536),
    [anon_sym_not] = ACTIONS(2536),
    [anon_sym_compl] = ACTIONS(2536),
    [anon_sym_DASH_DASH] = ACTIONS(2526),
    [anon_sym_PLUS_PLUS] = ACTIONS(2526),
    [anon_sym_sizeof] = ACTIONS(2536),
    [anon_sym___alignof__] = ACTIONS(2536),
    [anon_sym___alignof] = ACTIONS(2536),
    [anon_sym__alignof] = ACTIONS(2536),
    [anon_sym_alignof] = ACTIONS(2536),
    [anon_sym__Alignof] = ACTIONS(2536),
    [anon_sym_offsetof] = ACTIONS(2536),
    [anon_sym__Generic] = ACTIONS(2536),
    [anon_sym_asm] = ACTIONS(2536),
    [anon_sym___asm__] = ACTIONS(2536),
    [anon_sym___asm] = ACTIONS(2536),
    [sym_number_literal] = ACTIONS(2526),
    [anon_sym_L_SQUOTE] = ACTIONS(2526),
    [anon_sym_u_SQUOTE] = ACTIONS(2526),
    [anon_sym_U_SQUOTE] = ACTIONS(2526),
    [anon_sym_u8_SQUOTE] = ACTIONS(2526),
    [anon_sym_SQUOTE] = ACTIONS(2526),
    [anon_sym_L_DQUOTE] = ACTIONS(2526),
    [anon_sym_u_DQUOTE] = ACTIONS(2526),
    [anon_sym_U_DQUOTE] = ACTIONS(2526),
    [anon_sym_u8_DQUOTE] = ACTIONS(2526),
    [anon_sym_DQUOTE] = ACTIONS(2526),
    [sym_true] = ACTIONS(2536),
    [sym_false] = ACTIONS(2536),
    [anon_sym_NULL] = ACTIONS(2536),
    [anon_sym_nullptr] = ACTIONS(2536),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(2536),
    [anon_sym_template] = ACTIONS(2536),
    [anon_sym_delete] = ACTIONS(2536),
    [anon_sym_R_DQUOTE] = ACTIONS(2526),
    [anon_sym_LR_DQUOTE] = ACTIONS(2526),
    [anon_sym_uR_DQUOTE] = ACTIONS(2526),
    [anon_sym_UR_DQUOTE] = ACTIONS(2526),
    [anon_sym_u8R_DQUOTE] = ACTIONS(2526),
    [anon_sym_co_await] = ACTIONS(2536),
    [anon_sym_new] = ACTIONS(2536),
    [anon_sym_requires] = ACTIONS(2536),
    [sym_this] = ACTIONS(2536),
  },
  [1833] = {
    [sym_catch_clause] = STATE(1833),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1833),
    [sym_identifier] = ACTIONS(2439),
    [aux_sym_preproc_def_token1] = ACTIONS(2439),
    [aux_sym_preproc_if_token1] = ACTIONS(2439),
    [aux_sym_preproc_if_token2] = ACTIONS(2439),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2439),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2439),
    [sym_preproc_directive] = ACTIONS(2439),
    [anon_sym_LPAREN2] = ACTIONS(2441),
    [anon_sym_TILDE] = ACTIONS(2441),
    [anon_sym_STAR] = ACTIONS(2441),
    [anon_sym_AMP_AMP] = ACTIONS(2441),
    [anon_sym_AMP] = ACTIONS(2439),
    [anon_sym_SEMI] = ACTIONS(2441),
    [anon_sym___extension__] = ACTIONS(2439),
    [anon_sym_typedef] = ACTIONS(2439),
    [anon_sym_virtual] = ACTIONS(2439),
    [anon_sym_extern] = ACTIONS(2439),
    [anon_sym___attribute__] = ACTIONS(2439),
    [anon_sym___attribute] = ACTIONS(2439),
    [anon_sym_COLON_COLON] = ACTIONS(2441),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2441),
    [anon_sym___declspec] = ACTIONS(2439),
    [anon_sym___based] = ACTIONS(2439),
    [anon_sym_signed] = ACTIONS(2439),
    [anon_sym_unsigned] = ACTIONS(2439),
    [anon_sym_long] = ACTIONS(2439),
    [anon_sym_short] = ACTIONS(2439),
    [anon_sym_LBRACK] = ACTIONS(2439),
    [anon_sym_static] = ACTIONS(2439),
    [anon_sym_register] = ACTIONS(2439),
    [anon_sym_inline] = ACTIONS(2439),
    [anon_sym___inline] = ACTIONS(2439),
    [anon_sym___inline__] = ACTIONS(2439),
    [anon_sym___forceinline] = ACTIONS(2439),
    [anon_sym_thread_local] = ACTIONS(2439),
    [anon_sym___thread] = ACTIONS(2439),
    [anon_sym_const] = ACTIONS(2439),
    [anon_sym_constexpr] = ACTIONS(2439),
    [anon_sym_volatile] = ACTIONS(2439),
    [anon_sym_restrict] = ACTIONS(2439),
    [anon_sym___restrict__] = ACTIONS(2439),
    [anon_sym__Atomic] = ACTIONS(2439),
    [anon_sym__Noreturn] = ACTIONS(2439),
    [anon_sym_noreturn] = ACTIONS(2439),
    [anon_sym__Nonnull] = ACTIONS(2439),
    [anon_sym_mutable] = ACTIONS(2439),
    [anon_sym_constinit] = ACTIONS(2439),
    [anon_sym_consteval] = ACTIONS(2439),
    [anon_sym_alignas] = ACTIONS(2439),
    [anon_sym__Alignas] = ACTIONS(2439),
    [sym_primitive_type] = ACTIONS(2439),
    [anon_sym_enum] = ACTIONS(2439),
    [anon_sym_class] = ACTIONS(2439),
    [anon_sym_struct] = ACTIONS(2439),
    [anon_sym_union] = ACTIONS(2439),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2439),
    [anon_sym_decltype] = ACTIONS(2439),
    [anon_sym_explicit] = ACTIONS(2439),
    [anon_sym_typename] = ACTIONS(2439),
    [anon_sym_template] = ACTIONS(2439),
    [anon_sym_operator] = ACTIONS(2439),
    [anon_sym_friend] = ACTIONS(2439),
    [anon_sym_public] = ACTIONS(2439),
    [anon_sym_private] = ACTIONS(2439),
    [anon_sym_protected] = ACTIONS(2439),
    [anon_sym_using] = ACTIONS(2439),
    [anon_sym_static_assert] = ACTIONS(2439),
    [anon_sym_catch] = ACTIONS(5615),
  },
  [1834] = {
    [sym_identifier] = ACTIONS(5618),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5620),
    [anon_sym_COMMA] = ACTIONS(5620),
    [anon_sym_RPAREN] = ACTIONS(5620),
    [anon_sym_LPAREN2] = ACTIONS(5620),
    [anon_sym_TILDE] = ACTIONS(5620),
    [anon_sym_STAR] = ACTIONS(5620),
    [anon_sym_AMP_AMP] = ACTIONS(5620),
    [anon_sym_AMP] = ACTIONS(5618),
    [anon_sym_SEMI] = ACTIONS(5620),
    [anon_sym___extension__] = ACTIONS(5618),
    [anon_sym_virtual] = ACTIONS(5618),
    [anon_sym_extern] = ACTIONS(5618),
    [anon_sym___attribute__] = ACTIONS(5618),
    [anon_sym___attribute] = ACTIONS(5618),
    [anon_sym_COLON_COLON] = ACTIONS(5620),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5620),
    [anon_sym___declspec] = ACTIONS(5618),
    [anon_sym___based] = ACTIONS(5618),
    [anon_sym_LBRACE] = ACTIONS(5620),
    [anon_sym_signed] = ACTIONS(5618),
    [anon_sym_unsigned] = ACTIONS(5618),
    [anon_sym_long] = ACTIONS(5618),
    [anon_sym_short] = ACTIONS(5618),
    [anon_sym_LBRACK] = ACTIONS(5618),
    [anon_sym_static] = ACTIONS(5618),
    [anon_sym_EQ] = ACTIONS(5620),
    [anon_sym_register] = ACTIONS(5618),
    [anon_sym_inline] = ACTIONS(5618),
    [anon_sym___inline] = ACTIONS(5618),
    [anon_sym___inline__] = ACTIONS(5618),
    [anon_sym___forceinline] = ACTIONS(5618),
    [anon_sym_thread_local] = ACTIONS(5618),
    [anon_sym___thread] = ACTIONS(5618),
    [anon_sym_const] = ACTIONS(5618),
    [anon_sym_constexpr] = ACTIONS(5618),
    [anon_sym_volatile] = ACTIONS(5618),
    [anon_sym_restrict] = ACTIONS(5618),
    [anon_sym___restrict__] = ACTIONS(5618),
    [anon_sym__Atomic] = ACTIONS(5618),
    [anon_sym__Noreturn] = ACTIONS(5618),
    [anon_sym_noreturn] = ACTIONS(5618),
    [anon_sym__Nonnull] = ACTIONS(5618),
    [anon_sym_mutable] = ACTIONS(5618),
    [anon_sym_constinit] = ACTIONS(5618),
    [anon_sym_consteval] = ACTIONS(5618),
    [anon_sym_alignas] = ACTIONS(5618),
    [anon_sym__Alignas] = ACTIONS(5618),
    [sym_primitive_type] = ACTIONS(5618),
    [anon_sym_enum] = ACTIONS(5618),
    [anon_sym_class] = ACTIONS(5618),
    [anon_sym_struct] = ACTIONS(5618),
    [anon_sym_union] = ACTIONS(5618),
    [anon_sym_asm] = ACTIONS(5618),
    [anon_sym___asm__] = ACTIONS(5618),
    [anon_sym___asm] = ACTIONS(5618),
    [anon_sym_DASH_GT] = ACTIONS(5620),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5618),
    [anon_sym_decltype] = ACTIONS(5618),
    [anon_sym_final] = ACTIONS(5618),
    [anon_sym_override] = ACTIONS(5618),
    [anon_sym_explicit] = ACTIONS(5618),
    [anon_sym_typename] = ACTIONS(5618),
    [anon_sym_template] = ACTIONS(5618),
    [anon_sym_GT2] = ACTIONS(5620),
    [anon_sym_operator] = ACTIONS(5618),
    [anon_sym_try] = ACTIONS(5618),
    [anon_sym_noexcept] = ACTIONS(5618),
    [anon_sym_throw] = ACTIONS(5618),
    [anon_sym_requires] = ACTIONS(5618),
  },
  [1835] = {
    [sym_catch_clause] = STATE(1820),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1820),
    [sym_identifier] = ACTIONS(2490),
    [aux_sym_preproc_def_token1] = ACTIONS(2490),
    [aux_sym_preproc_if_token1] = ACTIONS(2490),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2490),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2490),
    [sym_preproc_directive] = ACTIONS(2490),
    [anon_sym_LPAREN2] = ACTIONS(2492),
    [anon_sym_TILDE] = ACTIONS(2492),
    [anon_sym_STAR] = ACTIONS(2492),
    [anon_sym_AMP_AMP] = ACTIONS(2492),
    [anon_sym_AMP] = ACTIONS(2490),
    [anon_sym_SEMI] = ACTIONS(2492),
    [anon_sym___extension__] = ACTIONS(2490),
    [anon_sym_typedef] = ACTIONS(2490),
    [anon_sym_virtual] = ACTIONS(2490),
    [anon_sym_extern] = ACTIONS(2490),
    [anon_sym___attribute__] = ACTIONS(2490),
    [anon_sym___attribute] = ACTIONS(2490),
    [anon_sym_COLON_COLON] = ACTIONS(2492),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2492),
    [anon_sym___declspec] = ACTIONS(2490),
    [anon_sym___based] = ACTIONS(2490),
    [anon_sym_RBRACE] = ACTIONS(2492),
    [anon_sym_signed] = ACTIONS(2490),
    [anon_sym_unsigned] = ACTIONS(2490),
    [anon_sym_long] = ACTIONS(2490),
    [anon_sym_short] = ACTIONS(2490),
    [anon_sym_LBRACK] = ACTIONS(2490),
    [anon_sym_static] = ACTIONS(2490),
    [anon_sym_register] = ACTIONS(2490),
    [anon_sym_inline] = ACTIONS(2490),
    [anon_sym___inline] = ACTIONS(2490),
    [anon_sym___inline__] = ACTIONS(2490),
    [anon_sym___forceinline] = ACTIONS(2490),
    [anon_sym_thread_local] = ACTIONS(2490),
    [anon_sym___thread] = ACTIONS(2490),
    [anon_sym_const] = ACTIONS(2490),
    [anon_sym_constexpr] = ACTIONS(2490),
    [anon_sym_volatile] = ACTIONS(2490),
    [anon_sym_restrict] = ACTIONS(2490),
    [anon_sym___restrict__] = ACTIONS(2490),
    [anon_sym__Atomic] = ACTIONS(2490),
    [anon_sym__Noreturn] = ACTIONS(2490),
    [anon_sym_noreturn] = ACTIONS(2490),
    [anon_sym__Nonnull] = ACTIONS(2490),
    [anon_sym_mutable] = ACTIONS(2490),
    [anon_sym_constinit] = ACTIONS(2490),
    [anon_sym_consteval] = ACTIONS(2490),
    [anon_sym_alignas] = ACTIONS(2490),
    [anon_sym__Alignas] = ACTIONS(2490),
    [sym_primitive_type] = ACTIONS(2490),
    [anon_sym_enum] = ACTIONS(2490),
    [anon_sym_class] = ACTIONS(2490),
    [anon_sym_struct] = ACTIONS(2490),
    [anon_sym_union] = ACTIONS(2490),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2490),
    [anon_sym_decltype] = ACTIONS(2490),
    [anon_sym_explicit] = ACTIONS(2490),
    [anon_sym_typename] = ACTIONS(2490),
    [anon_sym_template] = ACTIONS(2490),
    [anon_sym_operator] = ACTIONS(2490),
    [anon_sym_friend] = ACTIONS(2490),
    [anon_sym_public] = ACTIONS(2490),
    [anon_sym_private] = ACTIONS(2490),
    [anon_sym_protected] = ACTIONS(2490),
    [anon_sym_using] = ACTIONS(2490),
    [anon_sym_static_assert] = ACTIONS(2490),
    [anon_sym_catch] = ACTIONS(5610),
  },
  [1836] = {
    [sym_identifier] = ACTIONS(5622),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5624),
    [anon_sym_COMMA] = ACTIONS(5624),
    [anon_sym_RPAREN] = ACTIONS(5624),
    [anon_sym_LPAREN2] = ACTIONS(5624),
    [anon_sym_DASH] = ACTIONS(5622),
    [anon_sym_PLUS] = ACTIONS(5622),
    [anon_sym_STAR] = ACTIONS(5624),
    [anon_sym_SLASH] = ACTIONS(5622),
    [anon_sym_PERCENT] = ACTIONS(5624),
    [anon_sym_PIPE_PIPE] = ACTIONS(5624),
    [anon_sym_AMP_AMP] = ACTIONS(5624),
    [anon_sym_PIPE] = ACTIONS(5622),
    [anon_sym_CARET] = ACTIONS(5624),
    [anon_sym_AMP] = ACTIONS(5622),
    [anon_sym_EQ_EQ] = ACTIONS(5624),
    [anon_sym_BANG_EQ] = ACTIONS(5624),
    [anon_sym_GT] = ACTIONS(5622),
    [anon_sym_GT_EQ] = ACTIONS(5624),
    [anon_sym_LT_EQ] = ACTIONS(5622),
    [anon_sym_LT] = ACTIONS(5622),
    [anon_sym_LT_LT] = ACTIONS(5624),
    [anon_sym_GT_GT] = ACTIONS(5624),
    [anon_sym_SEMI] = ACTIONS(5624),
    [anon_sym___extension__] = ACTIONS(5622),
    [anon_sym___attribute__] = ACTIONS(5622),
    [anon_sym___attribute] = ACTIONS(5622),
    [anon_sym___based] = ACTIONS(5622),
    [anon_sym_LBRACE] = ACTIONS(5624),
    [anon_sym_RBRACE] = ACTIONS(5624),
    [anon_sym_signed] = ACTIONS(5622),
    [anon_sym_unsigned] = ACTIONS(5622),
    [anon_sym_long] = ACTIONS(5622),
    [anon_sym_short] = ACTIONS(5622),
    [anon_sym_LBRACK] = ACTIONS(5624),
    [anon_sym_RBRACK] = ACTIONS(5624),
    [anon_sym_const] = ACTIONS(5622),
    [anon_sym_constexpr] = ACTIONS(5622),
    [anon_sym_volatile] = ACTIONS(5622),
    [anon_sym_restrict] = ACTIONS(5622),
    [anon_sym___restrict__] = ACTIONS(5622),
    [anon_sym__Atomic] = ACTIONS(5622),
    [anon_sym__Noreturn] = ACTIONS(5622),
    [anon_sym_noreturn] = ACTIONS(5622),
    [anon_sym__Nonnull] = ACTIONS(5622),
    [anon_sym_mutable] = ACTIONS(5622),
    [anon_sym_constinit] = ACTIONS(5622),
    [anon_sym_consteval] = ACTIONS(5622),
    [anon_sym_alignas] = ACTIONS(5622),
    [anon_sym__Alignas] = ACTIONS(5622),
    [sym_primitive_type] = ACTIONS(5622),
    [anon_sym_COLON] = ACTIONS(5624),
    [anon_sym_QMARK] = ACTIONS(5624),
    [anon_sym_LT_EQ_GT] = ACTIONS(5624),
    [anon_sym_or] = ACTIONS(5622),
    [anon_sym_and] = ACTIONS(5622),
    [anon_sym_bitor] = ACTIONS(5622),
    [anon_sym_xor] = ACTIONS(5622),
    [anon_sym_bitand] = ACTIONS(5622),
    [anon_sym_not_eq] = ACTIONS(5622),
    [anon_sym_DASH_DASH] = ACTIONS(5624),
    [anon_sym_PLUS_PLUS] = ACTIONS(5624),
    [anon_sym_DOT] = ACTIONS(5622),
    [anon_sym_DOT_STAR] = ACTIONS(5624),
    [anon_sym_DASH_GT] = ACTIONS(5624),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5622),
    [anon_sym_decltype] = ACTIONS(5622),
    [anon_sym_final] = ACTIONS(5622),
    [anon_sym_override] = ACTIONS(5622),
    [anon_sym_requires] = ACTIONS(5622),
  },
  [1837] = {
    [sym_identifier] = ACTIONS(5626),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5628),
    [anon_sym_COMMA] = ACTIONS(5628),
    [anon_sym_RPAREN] = ACTIONS(5628),
    [anon_sym_LPAREN2] = ACTIONS(5628),
    [anon_sym_DASH] = ACTIONS(5626),
    [anon_sym_PLUS] = ACTIONS(5626),
    [anon_sym_STAR] = ACTIONS(5628),
    [anon_sym_SLASH] = ACTIONS(5626),
    [anon_sym_PERCENT] = ACTIONS(5628),
    [anon_sym_PIPE_PIPE] = ACTIONS(5628),
    [anon_sym_AMP_AMP] = ACTIONS(5628),
    [anon_sym_PIPE] = ACTIONS(5626),
    [anon_sym_CARET] = ACTIONS(5628),
    [anon_sym_AMP] = ACTIONS(5626),
    [anon_sym_EQ_EQ] = ACTIONS(5628),
    [anon_sym_BANG_EQ] = ACTIONS(5628),
    [anon_sym_GT] = ACTIONS(5626),
    [anon_sym_GT_EQ] = ACTIONS(5628),
    [anon_sym_LT_EQ] = ACTIONS(5626),
    [anon_sym_LT] = ACTIONS(5626),
    [anon_sym_LT_LT] = ACTIONS(5628),
    [anon_sym_GT_GT] = ACTIONS(5628),
    [anon_sym_SEMI] = ACTIONS(5628),
    [anon_sym___extension__] = ACTIONS(5626),
    [anon_sym___attribute__] = ACTIONS(5626),
    [anon_sym___attribute] = ACTIONS(5626),
    [anon_sym___based] = ACTIONS(5626),
    [anon_sym_LBRACE] = ACTIONS(5628),
    [anon_sym_RBRACE] = ACTIONS(5628),
    [anon_sym_signed] = ACTIONS(5626),
    [anon_sym_unsigned] = ACTIONS(5626),
    [anon_sym_long] = ACTIONS(5626),
    [anon_sym_short] = ACTIONS(5626),
    [anon_sym_LBRACK] = ACTIONS(5628),
    [anon_sym_RBRACK] = ACTIONS(5628),
    [anon_sym_const] = ACTIONS(5626),
    [anon_sym_constexpr] = ACTIONS(5626),
    [anon_sym_volatile] = ACTIONS(5626),
    [anon_sym_restrict] = ACTIONS(5626),
    [anon_sym___restrict__] = ACTIONS(5626),
    [anon_sym__Atomic] = ACTIONS(5626),
    [anon_sym__Noreturn] = ACTIONS(5626),
    [anon_sym_noreturn] = ACTIONS(5626),
    [anon_sym__Nonnull] = ACTIONS(5626),
    [anon_sym_mutable] = ACTIONS(5626),
    [anon_sym_constinit] = ACTIONS(5626),
    [anon_sym_consteval] = ACTIONS(5626),
    [anon_sym_alignas] = ACTIONS(5626),
    [anon_sym__Alignas] = ACTIONS(5626),
    [sym_primitive_type] = ACTIONS(5626),
    [anon_sym_COLON] = ACTIONS(5628),
    [anon_sym_QMARK] = ACTIONS(5628),
    [anon_sym_LT_EQ_GT] = ACTIONS(5628),
    [anon_sym_or] = ACTIONS(5626),
    [anon_sym_and] = ACTIONS(5626),
    [anon_sym_bitor] = ACTIONS(5626),
    [anon_sym_xor] = ACTIONS(5626),
    [anon_sym_bitand] = ACTIONS(5626),
    [anon_sym_not_eq] = ACTIONS(5626),
    [anon_sym_DASH_DASH] = ACTIONS(5628),
    [anon_sym_PLUS_PLUS] = ACTIONS(5628),
    [anon_sym_DOT] = ACTIONS(5626),
    [anon_sym_DOT_STAR] = ACTIONS(5628),
    [anon_sym_DASH_GT] = ACTIONS(5628),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5626),
    [anon_sym_decltype] = ACTIONS(5626),
    [anon_sym_final] = ACTIONS(5626),
    [anon_sym_override] = ACTIONS(5626),
    [anon_sym_requires] = ACTIONS(5626),
  },
  [1838] = {
    [sym_identifier] = ACTIONS(5630),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5632),
    [anon_sym_COMMA] = ACTIONS(5632),
    [anon_sym_RPAREN] = ACTIONS(5632),
    [anon_sym_LPAREN2] = ACTIONS(5632),
    [anon_sym_DASH] = ACTIONS(5630),
    [anon_sym_PLUS] = ACTIONS(5630),
    [anon_sym_STAR] = ACTIONS(5632),
    [anon_sym_SLASH] = ACTIONS(5630),
    [anon_sym_PERCENT] = ACTIONS(5632),
    [anon_sym_PIPE_PIPE] = ACTIONS(5632),
    [anon_sym_AMP_AMP] = ACTIONS(5632),
    [anon_sym_PIPE] = ACTIONS(5630),
    [anon_sym_CARET] = ACTIONS(5632),
    [anon_sym_AMP] = ACTIONS(5630),
    [anon_sym_EQ_EQ] = ACTIONS(5632),
    [anon_sym_BANG_EQ] = ACTIONS(5632),
    [anon_sym_GT] = ACTIONS(5630),
    [anon_sym_GT_EQ] = ACTIONS(5632),
    [anon_sym_LT_EQ] = ACTIONS(5630),
    [anon_sym_LT] = ACTIONS(5630),
    [anon_sym_LT_LT] = ACTIONS(5632),
    [anon_sym_GT_GT] = ACTIONS(5632),
    [anon_sym_SEMI] = ACTIONS(5632),
    [anon_sym___extension__] = ACTIONS(5630),
    [anon_sym___attribute__] = ACTIONS(5630),
    [anon_sym___attribute] = ACTIONS(5630),
    [anon_sym___based] = ACTIONS(5630),
    [anon_sym_LBRACE] = ACTIONS(5632),
    [anon_sym_RBRACE] = ACTIONS(5632),
    [anon_sym_signed] = ACTIONS(5630),
    [anon_sym_unsigned] = ACTIONS(5630),
    [anon_sym_long] = ACTIONS(5630),
    [anon_sym_short] = ACTIONS(5630),
    [anon_sym_LBRACK] = ACTIONS(5632),
    [anon_sym_RBRACK] = ACTIONS(5632),
    [anon_sym_const] = ACTIONS(5630),
    [anon_sym_constexpr] = ACTIONS(5630),
    [anon_sym_volatile] = ACTIONS(5630),
    [anon_sym_restrict] = ACTIONS(5630),
    [anon_sym___restrict__] = ACTIONS(5630),
    [anon_sym__Atomic] = ACTIONS(5630),
    [anon_sym__Noreturn] = ACTIONS(5630),
    [anon_sym_noreturn] = ACTIONS(5630),
    [anon_sym__Nonnull] = ACTIONS(5630),
    [anon_sym_mutable] = ACTIONS(5630),
    [anon_sym_constinit] = ACTIONS(5630),
    [anon_sym_consteval] = ACTIONS(5630),
    [anon_sym_alignas] = ACTIONS(5630),
    [anon_sym__Alignas] = ACTIONS(5630),
    [sym_primitive_type] = ACTIONS(5630),
    [anon_sym_COLON] = ACTIONS(5632),
    [anon_sym_QMARK] = ACTIONS(5632),
    [anon_sym_LT_EQ_GT] = ACTIONS(5632),
    [anon_sym_or] = ACTIONS(5630),
    [anon_sym_and] = ACTIONS(5630),
    [anon_sym_bitor] = ACTIONS(5630),
    [anon_sym_xor] = ACTIONS(5630),
    [anon_sym_bitand] = ACTIONS(5630),
    [anon_sym_not_eq] = ACTIONS(5630),
    [anon_sym_DASH_DASH] = ACTIONS(5632),
    [anon_sym_PLUS_PLUS] = ACTIONS(5632),
    [anon_sym_DOT] = ACTIONS(5630),
    [anon_sym_DOT_STAR] = ACTIONS(5632),
    [anon_sym_DASH_GT] = ACTIONS(5632),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5630),
    [anon_sym_decltype] = ACTIONS(5630),
    [anon_sym_final] = ACTIONS(5630),
    [anon_sym_override] = ACTIONS(5630),
    [anon_sym_requires] = ACTIONS(5630),
  },
  [1839] = {
    [sym_type_qualifier] = STATE(1827),
    [sym_alignas_qualifier] = STATE(1651),
    [aux_sym__type_definition_type_repeat1] = STATE(1827),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2020),
    [sym_identifier] = ACTIONS(5634),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4946),
    [anon_sym_COMMA] = ACTIONS(4946),
    [anon_sym_RPAREN] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(4946),
    [anon_sym_DASH] = ACTIONS(4948),
    [anon_sym_PLUS] = ACTIONS(4948),
    [anon_sym_STAR] = ACTIONS(4946),
    [anon_sym_SLASH] = ACTIONS(4948),
    [anon_sym_PERCENT] = ACTIONS(4946),
    [anon_sym_PIPE_PIPE] = ACTIONS(4946),
    [anon_sym_AMP_AMP] = ACTIONS(4946),
    [anon_sym_PIPE] = ACTIONS(4948),
    [anon_sym_CARET] = ACTIONS(4946),
    [anon_sym_AMP] = ACTIONS(4948),
    [anon_sym_EQ_EQ] = ACTIONS(4946),
    [anon_sym_BANG_EQ] = ACTIONS(4946),
    [anon_sym_GT] = ACTIONS(4948),
    [anon_sym_GT_EQ] = ACTIONS(4946),
    [anon_sym_LT_EQ] = ACTIONS(4948),
    [anon_sym_LT] = ACTIONS(4948),
    [anon_sym_LT_LT] = ACTIONS(4946),
    [anon_sym_GT_GT] = ACTIONS(4946),
    [anon_sym_SEMI] = ACTIONS(4946),
    [anon_sym___extension__] = ACTIONS(5521),
    [anon_sym___attribute__] = ACTIONS(4948),
    [anon_sym___attribute] = ACTIONS(4948),
    [anon_sym_LBRACE] = ACTIONS(4946),
    [anon_sym_RBRACE] = ACTIONS(4946),
    [anon_sym_signed] = ACTIONS(5636),
    [anon_sym_unsigned] = ACTIONS(5636),
    [anon_sym_long] = ACTIONS(5636),
    [anon_sym_short] = ACTIONS(5636),
    [anon_sym_LBRACK] = ACTIONS(4946),
    [anon_sym_RBRACK] = ACTIONS(4946),
    [anon_sym_const] = ACTIONS(5521),
    [anon_sym_constexpr] = ACTIONS(5521),
    [anon_sym_volatile] = ACTIONS(5521),
    [anon_sym_restrict] = ACTIONS(5521),
    [anon_sym___restrict__] = ACTIONS(5521),
    [anon_sym__Atomic] = ACTIONS(5521),
    [anon_sym__Noreturn] = ACTIONS(5521),
    [anon_sym_noreturn] = ACTIONS(5521),
    [anon_sym__Nonnull] = ACTIONS(5521),
    [anon_sym_mutable] = ACTIONS(5521),
    [anon_sym_constinit] = ACTIONS(5521),
    [anon_sym_consteval] = ACTIONS(5521),
    [anon_sym_alignas] = ACTIONS(5525),
    [anon_sym__Alignas] = ACTIONS(5525),
    [sym_primitive_type] = ACTIONS(5638),
    [anon_sym_COLON] = ACTIONS(4946),
    [anon_sym_QMARK] = ACTIONS(4946),
    [anon_sym_LT_EQ_GT] = ACTIONS(4946),
    [anon_sym_or] = ACTIONS(4948),
    [anon_sym_and] = ACTIONS(4948),
    [anon_sym_bitor] = ACTIONS(4948),
    [anon_sym_xor] = ACTIONS(4948),
    [anon_sym_bitand] = ACTIONS(4948),
    [anon_sym_not_eq] = ACTIONS(4948),
    [anon_sym_DASH_DASH] = ACTIONS(4946),
    [anon_sym_PLUS_PLUS] = ACTIONS(4946),
    [anon_sym_DOT] = ACTIONS(4948),
    [anon_sym_DOT_STAR] = ACTIONS(4946),
    [anon_sym_DASH_GT] = ACTIONS(4946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4948),
    [anon_sym_decltype] = ACTIONS(4948),
  },
  [1840] = {
    [sym_identifier] = ACTIONS(5640),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5642),
    [anon_sym_COMMA] = ACTIONS(5642),
    [anon_sym_RPAREN] = ACTIONS(5642),
    [anon_sym_LPAREN2] = ACTIONS(5642),
    [anon_sym_DASH] = ACTIONS(5640),
    [anon_sym_PLUS] = ACTIONS(5640),
    [anon_sym_STAR] = ACTIONS(5642),
    [anon_sym_SLASH] = ACTIONS(5640),
    [anon_sym_PERCENT] = ACTIONS(5642),
    [anon_sym_PIPE_PIPE] = ACTIONS(5642),
    [anon_sym_AMP_AMP] = ACTIONS(5642),
    [anon_sym_PIPE] = ACTIONS(5640),
    [anon_sym_CARET] = ACTIONS(5642),
    [anon_sym_AMP] = ACTIONS(5640),
    [anon_sym_EQ_EQ] = ACTIONS(5642),
    [anon_sym_BANG_EQ] = ACTIONS(5642),
    [anon_sym_GT] = ACTIONS(5640),
    [anon_sym_GT_EQ] = ACTIONS(5642),
    [anon_sym_LT_EQ] = ACTIONS(5640),
    [anon_sym_LT] = ACTIONS(5640),
    [anon_sym_LT_LT] = ACTIONS(5642),
    [anon_sym_GT_GT] = ACTIONS(5642),
    [anon_sym_SEMI] = ACTIONS(5642),
    [anon_sym___extension__] = ACTIONS(5640),
    [anon_sym___attribute__] = ACTIONS(5640),
    [anon_sym___attribute] = ACTIONS(5640),
    [anon_sym___based] = ACTIONS(5640),
    [anon_sym_LBRACE] = ACTIONS(5642),
    [anon_sym_RBRACE] = ACTIONS(5642),
    [anon_sym_signed] = ACTIONS(5640),
    [anon_sym_unsigned] = ACTIONS(5640),
    [anon_sym_long] = ACTIONS(5640),
    [anon_sym_short] = ACTIONS(5640),
    [anon_sym_LBRACK] = ACTIONS(5642),
    [anon_sym_RBRACK] = ACTIONS(5642),
    [anon_sym_const] = ACTIONS(5640),
    [anon_sym_constexpr] = ACTIONS(5640),
    [anon_sym_volatile] = ACTIONS(5640),
    [anon_sym_restrict] = ACTIONS(5640),
    [anon_sym___restrict__] = ACTIONS(5640),
    [anon_sym__Atomic] = ACTIONS(5640),
    [anon_sym__Noreturn] = ACTIONS(5640),
    [anon_sym_noreturn] = ACTIONS(5640),
    [anon_sym__Nonnull] = ACTIONS(5640),
    [anon_sym_mutable] = ACTIONS(5640),
    [anon_sym_constinit] = ACTIONS(5640),
    [anon_sym_consteval] = ACTIONS(5640),
    [anon_sym_alignas] = ACTIONS(5640),
    [anon_sym__Alignas] = ACTIONS(5640),
    [sym_primitive_type] = ACTIONS(5640),
    [anon_sym_COLON] = ACTIONS(5642),
    [anon_sym_QMARK] = ACTIONS(5642),
    [anon_sym_LT_EQ_GT] = ACTIONS(5642),
    [anon_sym_or] = ACTIONS(5640),
    [anon_sym_and] = ACTIONS(5640),
    [anon_sym_bitor] = ACTIONS(5640),
    [anon_sym_xor] = ACTIONS(5640),
    [anon_sym_bitand] = ACTIONS(5640),
    [anon_sym_not_eq] = ACTIONS(5640),
    [anon_sym_DASH_DASH] = ACTIONS(5642),
    [anon_sym_PLUS_PLUS] = ACTIONS(5642),
    [anon_sym_DOT] = ACTIONS(5640),
    [anon_sym_DOT_STAR] = ACTIONS(5642),
    [anon_sym_DASH_GT] = ACTIONS(5642),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5640),
    [anon_sym_decltype] = ACTIONS(5640),
    [anon_sym_final] = ACTIONS(5640),
    [anon_sym_override] = ACTIONS(5640),
    [anon_sym_requires] = ACTIONS(5640),
  },
  [1841] = {
    [sym_identifier] = ACTIONS(5644),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5646),
    [anon_sym_COMMA] = ACTIONS(5646),
    [anon_sym_RPAREN] = ACTIONS(5646),
    [anon_sym_LPAREN2] = ACTIONS(5646),
    [anon_sym_DASH] = ACTIONS(5644),
    [anon_sym_PLUS] = ACTIONS(5644),
    [anon_sym_STAR] = ACTIONS(5646),
    [anon_sym_SLASH] = ACTIONS(5644),
    [anon_sym_PERCENT] = ACTIONS(5646),
    [anon_sym_PIPE_PIPE] = ACTIONS(5646),
    [anon_sym_AMP_AMP] = ACTIONS(5646),
    [anon_sym_PIPE] = ACTIONS(5644),
    [anon_sym_CARET] = ACTIONS(5646),
    [anon_sym_AMP] = ACTIONS(5644),
    [anon_sym_EQ_EQ] = ACTIONS(5646),
    [anon_sym_BANG_EQ] = ACTIONS(5646),
    [anon_sym_GT] = ACTIONS(5644),
    [anon_sym_GT_EQ] = ACTIONS(5646),
    [anon_sym_LT_EQ] = ACTIONS(5644),
    [anon_sym_LT] = ACTIONS(5644),
    [anon_sym_LT_LT] = ACTIONS(5646),
    [anon_sym_GT_GT] = ACTIONS(5646),
    [anon_sym_SEMI] = ACTIONS(5646),
    [anon_sym___extension__] = ACTIONS(5644),
    [anon_sym___attribute__] = ACTIONS(5644),
    [anon_sym___attribute] = ACTIONS(5644),
    [anon_sym___based] = ACTIONS(5644),
    [anon_sym_LBRACE] = ACTIONS(5646),
    [anon_sym_RBRACE] = ACTIONS(5646),
    [anon_sym_signed] = ACTIONS(5644),
    [anon_sym_unsigned] = ACTIONS(5644),
    [anon_sym_long] = ACTIONS(5644),
    [anon_sym_short] = ACTIONS(5644),
    [anon_sym_LBRACK] = ACTIONS(5646),
    [anon_sym_RBRACK] = ACTIONS(5646),
    [anon_sym_const] = ACTIONS(5644),
    [anon_sym_constexpr] = ACTIONS(5644),
    [anon_sym_volatile] = ACTIONS(5644),
    [anon_sym_restrict] = ACTIONS(5644),
    [anon_sym___restrict__] = ACTIONS(5644),
    [anon_sym__Atomic] = ACTIONS(5644),
    [anon_sym__Noreturn] = ACTIONS(5644),
    [anon_sym_noreturn] = ACTIONS(5644),
    [anon_sym__Nonnull] = ACTIONS(5644),
    [anon_sym_mutable] = ACTIONS(5644),
    [anon_sym_constinit] = ACTIONS(5644),
    [anon_sym_consteval] = ACTIONS(5644),
    [anon_sym_alignas] = ACTIONS(5644),
    [anon_sym__Alignas] = ACTIONS(5644),
    [sym_primitive_type] = ACTIONS(5644),
    [anon_sym_COLON] = ACTIONS(5646),
    [anon_sym_QMARK] = ACTIONS(5646),
    [anon_sym_LT_EQ_GT] = ACTIONS(5646),
    [anon_sym_or] = ACTIONS(5644),
    [anon_sym_and] = ACTIONS(5644),
    [anon_sym_bitor] = ACTIONS(5644),
    [anon_sym_xor] = ACTIONS(5644),
    [anon_sym_bitand] = ACTIONS(5644),
    [anon_sym_not_eq] = ACTIONS(5644),
    [anon_sym_DASH_DASH] = ACTIONS(5646),
    [anon_sym_PLUS_PLUS] = ACTIONS(5646),
    [anon_sym_DOT] = ACTIONS(5644),
    [anon_sym_DOT_STAR] = ACTIONS(5646),
    [anon_sym_DASH_GT] = ACTIONS(5646),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5644),
    [anon_sym_decltype] = ACTIONS(5644),
    [anon_sym_final] = ACTIONS(5644),
    [anon_sym_override] = ACTIONS(5644),
    [anon_sym_requires] = ACTIONS(5644),
  },
  [1842] = {
    [sym_identifier] = ACTIONS(5648),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5650),
    [anon_sym_COMMA] = ACTIONS(5650),
    [anon_sym_RPAREN] = ACTIONS(5650),
    [anon_sym_LPAREN2] = ACTIONS(5650),
    [anon_sym_DASH] = ACTIONS(5648),
    [anon_sym_PLUS] = ACTIONS(5648),
    [anon_sym_STAR] = ACTIONS(5650),
    [anon_sym_SLASH] = ACTIONS(5648),
    [anon_sym_PERCENT] = ACTIONS(5650),
    [anon_sym_PIPE_PIPE] = ACTIONS(5650),
    [anon_sym_AMP_AMP] = ACTIONS(5650),
    [anon_sym_PIPE] = ACTIONS(5648),
    [anon_sym_CARET] = ACTIONS(5650),
    [anon_sym_AMP] = ACTIONS(5648),
    [anon_sym_EQ_EQ] = ACTIONS(5650),
    [anon_sym_BANG_EQ] = ACTIONS(5650),
    [anon_sym_GT] = ACTIONS(5648),
    [anon_sym_GT_EQ] = ACTIONS(5650),
    [anon_sym_LT_EQ] = ACTIONS(5648),
    [anon_sym_LT] = ACTIONS(5648),
    [anon_sym_LT_LT] = ACTIONS(5650),
    [anon_sym_GT_GT] = ACTIONS(5650),
    [anon_sym_SEMI] = ACTIONS(5650),
    [anon_sym___extension__] = ACTIONS(5648),
    [anon_sym___attribute__] = ACTIONS(5648),
    [anon_sym___attribute] = ACTIONS(5648),
    [anon_sym___based] = ACTIONS(5648),
    [anon_sym_LBRACE] = ACTIONS(5650),
    [anon_sym_RBRACE] = ACTIONS(5650),
    [anon_sym_signed] = ACTIONS(5648),
    [anon_sym_unsigned] = ACTIONS(5648),
    [anon_sym_long] = ACTIONS(5648),
    [anon_sym_short] = ACTIONS(5648),
    [anon_sym_LBRACK] = ACTIONS(5650),
    [anon_sym_RBRACK] = ACTIONS(5650),
    [anon_sym_const] = ACTIONS(5648),
    [anon_sym_constexpr] = ACTIONS(5648),
    [anon_sym_volatile] = ACTIONS(5648),
    [anon_sym_restrict] = ACTIONS(5648),
    [anon_sym___restrict__] = ACTIONS(5648),
    [anon_sym__Atomic] = ACTIONS(5648),
    [anon_sym__Noreturn] = ACTIONS(5648),
    [anon_sym_noreturn] = ACTIONS(5648),
    [anon_sym__Nonnull] = ACTIONS(5648),
    [anon_sym_mutable] = ACTIONS(5648),
    [anon_sym_constinit] = ACTIONS(5648),
    [anon_sym_consteval] = ACTIONS(5648),
    [anon_sym_alignas] = ACTIONS(5648),
    [anon_sym__Alignas] = ACTIONS(5648),
    [sym_primitive_type] = ACTIONS(5648),
    [anon_sym_COLON] = ACTIONS(5650),
    [anon_sym_QMARK] = ACTIONS(5650),
    [anon_sym_LT_EQ_GT] = ACTIONS(5650),
    [anon_sym_or] = ACTIONS(5648),
    [anon_sym_and] = ACTIONS(5648),
    [anon_sym_bitor] = ACTIONS(5648),
    [anon_sym_xor] = ACTIONS(5648),
    [anon_sym_bitand] = ACTIONS(5648),
    [anon_sym_not_eq] = ACTIONS(5648),
    [anon_sym_DASH_DASH] = ACTIONS(5650),
    [anon_sym_PLUS_PLUS] = ACTIONS(5650),
    [anon_sym_DOT] = ACTIONS(5648),
    [anon_sym_DOT_STAR] = ACTIONS(5650),
    [anon_sym_DASH_GT] = ACTIONS(5650),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5648),
    [anon_sym_decltype] = ACTIONS(5648),
    [anon_sym_final] = ACTIONS(5648),
    [anon_sym_override] = ACTIONS(5648),
    [anon_sym_requires] = ACTIONS(5648),
  },
  [1843] = {
    [sym_catch_clause] = STATE(1820),
    [aux_sym_constructor_try_statement_repeat1] = STATE(1820),
    [sym_identifier] = ACTIONS(2510),
    [aux_sym_preproc_def_token1] = ACTIONS(2510),
    [aux_sym_preproc_if_token1] = ACTIONS(2510),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2510),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2510),
    [sym_preproc_directive] = ACTIONS(2510),
    [anon_sym_LPAREN2] = ACTIONS(2512),
    [anon_sym_TILDE] = ACTIONS(2512),
    [anon_sym_STAR] = ACTIONS(2512),
    [anon_sym_AMP_AMP] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2510),
    [anon_sym_SEMI] = ACTIONS(2512),
    [anon_sym___extension__] = ACTIONS(2510),
    [anon_sym_typedef] = ACTIONS(2510),
    [anon_sym_virtual] = ACTIONS(2510),
    [anon_sym_extern] = ACTIONS(2510),
    [anon_sym___attribute__] = ACTIONS(2510),
    [anon_sym___attribute] = ACTIONS(2510),
    [anon_sym_COLON_COLON] = ACTIONS(2512),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2512),
    [anon_sym___declspec] = ACTIONS(2510),
    [anon_sym___based] = ACTIONS(2510),
    [anon_sym_RBRACE] = ACTIONS(2512),
    [anon_sym_signed] = ACTIONS(2510),
    [anon_sym_unsigned] = ACTIONS(2510),
    [anon_sym_long] = ACTIONS(2510),
    [anon_sym_short] = ACTIONS(2510),
    [anon_sym_LBRACK] = ACTIONS(2510),
    [anon_sym_static] = ACTIONS(2510),
    [anon_sym_register] = ACTIONS(2510),
    [anon_sym_inline] = ACTIONS(2510),
    [anon_sym___inline] = ACTIONS(2510),
    [anon_sym___inline__] = ACTIONS(2510),
    [anon_sym___forceinline] = ACTIONS(2510),
    [anon_sym_thread_local] = ACTIONS(2510),
    [anon_sym___thread] = ACTIONS(2510),
    [anon_sym_const] = ACTIONS(2510),
    [anon_sym_constexpr] = ACTIONS(2510),
    [anon_sym_volatile] = ACTIONS(2510),
    [anon_sym_restrict] = ACTIONS(2510),
    [anon_sym___restrict__] = ACTIONS(2510),
    [anon_sym__Atomic] = ACTIONS(2510),
    [anon_sym__Noreturn] = ACTIONS(2510),
    [anon_sym_noreturn] = ACTIONS(2510),
    [anon_sym__Nonnull] = ACTIONS(2510),
    [anon_sym_mutable] = ACTIONS(2510),
    [anon_sym_constinit] = ACTIONS(2510),
    [anon_sym_consteval] = ACTIONS(2510),
    [anon_sym_alignas] = ACTIONS(2510),
    [anon_sym__Alignas] = ACTIONS(2510),
    [sym_primitive_type] = ACTIONS(2510),
    [anon_sym_enum] = ACTIONS(2510),
    [anon_sym_class] = ACTIONS(2510),
    [anon_sym_struct] = ACTIONS(2510),
    [anon_sym_union] = ACTIONS(2510),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2510),
    [anon_sym_decltype] = ACTIONS(2510),
    [anon_sym_explicit] = ACTIONS(2510),
    [anon_sym_typename] = ACTIONS(2510),
    [anon_sym_template] = ACTIONS(2510),
    [anon_sym_operator] = ACTIONS(2510),
    [anon_sym_friend] = ACTIONS(2510),
    [anon_sym_public] = ACTIONS(2510),
    [anon_sym_private] = ACTIONS(2510),
    [anon_sym_protected] = ACTIONS(2510),
    [anon_sym_using] = ACTIONS(2510),
    [anon_sym_static_assert] = ACTIONS(2510),
    [anon_sym_catch] = ACTIONS(5610),
  },
  [1844] = {
    [sym_identifier] = ACTIONS(5652),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5654),
    [anon_sym_COMMA] = ACTIONS(5654),
    [anon_sym_RPAREN] = ACTIONS(5654),
    [anon_sym_LPAREN2] = ACTIONS(5654),
    [anon_sym_DASH] = ACTIONS(5652),
    [anon_sym_PLUS] = ACTIONS(5652),
    [anon_sym_STAR] = ACTIONS(5654),
    [anon_sym_SLASH] = ACTIONS(5652),
    [anon_sym_PERCENT] = ACTIONS(5654),
    [anon_sym_PIPE_PIPE] = ACTIONS(5654),
    [anon_sym_AMP_AMP] = ACTIONS(5654),
    [anon_sym_PIPE] = ACTIONS(5652),
    [anon_sym_CARET] = ACTIONS(5654),
    [anon_sym_AMP] = ACTIONS(5652),
    [anon_sym_EQ_EQ] = ACTIONS(5654),
    [anon_sym_BANG_EQ] = ACTIONS(5654),
    [anon_sym_GT] = ACTIONS(5652),
    [anon_sym_GT_EQ] = ACTIONS(5654),
    [anon_sym_LT_EQ] = ACTIONS(5652),
    [anon_sym_LT] = ACTIONS(5652),
    [anon_sym_LT_LT] = ACTIONS(5654),
    [anon_sym_GT_GT] = ACTIONS(5654),
    [anon_sym_SEMI] = ACTIONS(5654),
    [anon_sym___extension__] = ACTIONS(5652),
    [anon_sym___attribute__] = ACTIONS(5652),
    [anon_sym___attribute] = ACTIONS(5652),
    [anon_sym___based] = ACTIONS(5652),
    [anon_sym_LBRACE] = ACTIONS(5654),
    [anon_sym_RBRACE] = ACTIONS(5654),
    [anon_sym_signed] = ACTIONS(5652),
    [anon_sym_unsigned] = ACTIONS(5652),
    [anon_sym_long] = ACTIONS(5652),
    [anon_sym_short] = ACTIONS(5652),
    [anon_sym_LBRACK] = ACTIONS(5654),
    [anon_sym_RBRACK] = ACTIONS(5654),
    [anon_sym_const] = ACTIONS(5652),
    [anon_sym_constexpr] = ACTIONS(5652),
    [anon_sym_volatile] = ACTIONS(5652),
    [anon_sym_restrict] = ACTIONS(5652),
    [anon_sym___restrict__] = ACTIONS(5652),
    [anon_sym__Atomic] = ACTIONS(5652),
    [anon_sym__Noreturn] = ACTIONS(5652),
    [anon_sym_noreturn] = ACTIONS(5652),
    [anon_sym__Nonnull] = ACTIONS(5652),
    [anon_sym_mutable] = ACTIONS(5652),
    [anon_sym_constinit] = ACTIONS(5652),
    [anon_sym_consteval] = ACTIONS(5652),
    [anon_sym_alignas] = ACTIONS(5652),
    [anon_sym__Alignas] = ACTIONS(5652),
    [sym_primitive_type] = ACTIONS(5652),
    [anon_sym_COLON] = ACTIONS(5654),
    [anon_sym_QMARK] = ACTIONS(5654),
    [anon_sym_LT_EQ_GT] = ACTIONS(5654),
    [anon_sym_or] = ACTIONS(5652),
    [anon_sym_and] = ACTIONS(5652),
    [anon_sym_bitor] = ACTIONS(5652),
    [anon_sym_xor] = ACTIONS(5652),
    [anon_sym_bitand] = ACTIONS(5652),
    [anon_sym_not_eq] = ACTIONS(5652),
    [anon_sym_DASH_DASH] = ACTIONS(5654),
    [anon_sym_PLUS_PLUS] = ACTIONS(5654),
    [anon_sym_DOT] = ACTIONS(5652),
    [anon_sym_DOT_STAR] = ACTIONS(5654),
    [anon_sym_DASH_GT] = ACTIONS(5654),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5652),
    [anon_sym_decltype] = ACTIONS(5652),
    [anon_sym_final] = ACTIONS(5652),
    [anon_sym_override] = ACTIONS(5652),
    [anon_sym_requires] = ACTIONS(5652),
  },
  [1845] = {
    [sym_identifier] = ACTIONS(5656),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5658),
    [anon_sym_COMMA] = ACTIONS(5658),
    [anon_sym_RPAREN] = ACTIONS(5658),
    [anon_sym_LPAREN2] = ACTIONS(5658),
    [anon_sym_DASH] = ACTIONS(5656),
    [anon_sym_PLUS] = ACTIONS(5656),
    [anon_sym_STAR] = ACTIONS(5658),
    [anon_sym_SLASH] = ACTIONS(5656),
    [anon_sym_PERCENT] = ACTIONS(5658),
    [anon_sym_PIPE_PIPE] = ACTIONS(5658),
    [anon_sym_AMP_AMP] = ACTIONS(5658),
    [anon_sym_PIPE] = ACTIONS(5656),
    [anon_sym_CARET] = ACTIONS(5658),
    [anon_sym_AMP] = ACTIONS(5656),
    [anon_sym_EQ_EQ] = ACTIONS(5658),
    [anon_sym_BANG_EQ] = ACTIONS(5658),
    [anon_sym_GT] = ACTIONS(5656),
    [anon_sym_GT_EQ] = ACTIONS(5658),
    [anon_sym_LT_EQ] = ACTIONS(5656),
    [anon_sym_LT] = ACTIONS(5656),
    [anon_sym_LT_LT] = ACTIONS(5658),
    [anon_sym_GT_GT] = ACTIONS(5658),
    [anon_sym_SEMI] = ACTIONS(5658),
    [anon_sym___extension__] = ACTIONS(5656),
    [anon_sym___attribute__] = ACTIONS(5656),
    [anon_sym___attribute] = ACTIONS(5656),
    [anon_sym___based] = ACTIONS(5656),
    [anon_sym_LBRACE] = ACTIONS(5658),
    [anon_sym_RBRACE] = ACTIONS(5658),
    [anon_sym_signed] = ACTIONS(5656),
    [anon_sym_unsigned] = ACTIONS(5656),
    [anon_sym_long] = ACTIONS(5656),
    [anon_sym_short] = ACTIONS(5656),
    [anon_sym_LBRACK] = ACTIONS(5658),
    [anon_sym_RBRACK] = ACTIONS(5658),
    [anon_sym_const] = ACTIONS(5656),
    [anon_sym_constexpr] = ACTIONS(5656),
    [anon_sym_volatile] = ACTIONS(5656),
    [anon_sym_restrict] = ACTIONS(5656),
    [anon_sym___restrict__] = ACTIONS(5656),
    [anon_sym__Atomic] = ACTIONS(5656),
    [anon_sym__Noreturn] = ACTIONS(5656),
    [anon_sym_noreturn] = ACTIONS(5656),
    [anon_sym__Nonnull] = ACTIONS(5656),
    [anon_sym_mutable] = ACTIONS(5656),
    [anon_sym_constinit] = ACTIONS(5656),
    [anon_sym_consteval] = ACTIONS(5656),
    [anon_sym_alignas] = ACTIONS(5656),
    [anon_sym__Alignas] = ACTIONS(5656),
    [sym_primitive_type] = ACTIONS(5656),
    [anon_sym_COLON] = ACTIONS(5658),
    [anon_sym_QMARK] = ACTIONS(5658),
    [anon_sym_LT_EQ_GT] = ACTIONS(5658),
    [anon_sym_or] = ACTIONS(5656),
    [anon_sym_and] = ACTIONS(5656),
    [anon_sym_bitor] = ACTIONS(5656),
    [anon_sym_xor] = ACTIONS(5656),
    [anon_sym_bitand] = ACTIONS(5656),
    [anon_sym_not_eq] = ACTIONS(5656),
    [anon_sym_DASH_DASH] = ACTIONS(5658),
    [anon_sym_PLUS_PLUS] = ACTIONS(5658),
    [anon_sym_DOT] = ACTIONS(5656),
    [anon_sym_DOT_STAR] = ACTIONS(5658),
    [anon_sym_DASH_GT] = ACTIONS(5658),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5656),
    [anon_sym_decltype] = ACTIONS(5656),
    [anon_sym_final] = ACTIONS(5656),
    [anon_sym_override] = ACTIONS(5656),
    [anon_sym_requires] = ACTIONS(5656),
  },
  [1846] = {
    [sym_identifier] = ACTIONS(5660),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5662),
    [anon_sym_COMMA] = ACTIONS(5662),
    [anon_sym_RPAREN] = ACTIONS(5662),
    [anon_sym_LPAREN2] = ACTIONS(5662),
    [anon_sym_DASH] = ACTIONS(5660),
    [anon_sym_PLUS] = ACTIONS(5660),
    [anon_sym_STAR] = ACTIONS(5662),
    [anon_sym_SLASH] = ACTIONS(5660),
    [anon_sym_PERCENT] = ACTIONS(5662),
    [anon_sym_PIPE_PIPE] = ACTIONS(5662),
    [anon_sym_AMP_AMP] = ACTIONS(5662),
    [anon_sym_PIPE] = ACTIONS(5660),
    [anon_sym_CARET] = ACTIONS(5662),
    [anon_sym_AMP] = ACTIONS(5660),
    [anon_sym_EQ_EQ] = ACTIONS(5662),
    [anon_sym_BANG_EQ] = ACTIONS(5662),
    [anon_sym_GT] = ACTIONS(5660),
    [anon_sym_GT_EQ] = ACTIONS(5662),
    [anon_sym_LT_EQ] = ACTIONS(5660),
    [anon_sym_LT] = ACTIONS(5660),
    [anon_sym_LT_LT] = ACTIONS(5662),
    [anon_sym_GT_GT] = ACTIONS(5662),
    [anon_sym_SEMI] = ACTIONS(5662),
    [anon_sym___extension__] = ACTIONS(5660),
    [anon_sym___attribute__] = ACTIONS(5660),
    [anon_sym___attribute] = ACTIONS(5660),
    [anon_sym___based] = ACTIONS(5660),
    [anon_sym_LBRACE] = ACTIONS(5662),
    [anon_sym_RBRACE] = ACTIONS(5662),
    [anon_sym_signed] = ACTIONS(5660),
    [anon_sym_unsigned] = ACTIONS(5660),
    [anon_sym_long] = ACTIONS(5660),
    [anon_sym_short] = ACTIONS(5660),
    [anon_sym_LBRACK] = ACTIONS(5662),
    [anon_sym_RBRACK] = ACTIONS(5662),
    [anon_sym_const] = ACTIONS(5660),
    [anon_sym_constexpr] = ACTIONS(5660),
    [anon_sym_volatile] = ACTIONS(5660),
    [anon_sym_restrict] = ACTIONS(5660),
    [anon_sym___restrict__] = ACTIONS(5660),
    [anon_sym__Atomic] = ACTIONS(5660),
    [anon_sym__Noreturn] = ACTIONS(5660),
    [anon_sym_noreturn] = ACTIONS(5660),
    [anon_sym__Nonnull] = ACTIONS(5660),
    [anon_sym_mutable] = ACTIONS(5660),
    [anon_sym_constinit] = ACTIONS(5660),
    [anon_sym_consteval] = ACTIONS(5660),
    [anon_sym_alignas] = ACTIONS(5660),
    [anon_sym__Alignas] = ACTIONS(5660),
    [sym_primitive_type] = ACTIONS(5660),
    [anon_sym_COLON] = ACTIONS(5662),
    [anon_sym_QMARK] = ACTIONS(5662),
    [anon_sym_LT_EQ_GT] = ACTIONS(5662),
    [anon_sym_or] = ACTIONS(5660),
    [anon_sym_and] = ACTIONS(5660),
    [anon_sym_bitor] = ACTIONS(5660),
    [anon_sym_xor] = ACTIONS(5660),
    [anon_sym_bitand] = ACTIONS(5660),
    [anon_sym_not_eq] = ACTIONS(5660),
    [anon_sym_DASH_DASH] = ACTIONS(5662),
    [anon_sym_PLUS_PLUS] = ACTIONS(5662),
    [anon_sym_DOT] = ACTIONS(5660),
    [anon_sym_DOT_STAR] = ACTIONS(5662),
    [anon_sym_DASH_GT] = ACTIONS(5662),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5660),
    [anon_sym_decltype] = ACTIONS(5660),
    [anon_sym_final] = ACTIONS(5660),
    [anon_sym_override] = ACTIONS(5660),
    [anon_sym_requires] = ACTIONS(5660),
  },
  [1847] = {
    [sym_identifier] = ACTIONS(5664),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5666),
    [anon_sym_COMMA] = ACTIONS(5666),
    [anon_sym_RPAREN] = ACTIONS(5666),
    [anon_sym_LPAREN2] = ACTIONS(5666),
    [anon_sym_DASH] = ACTIONS(5664),
    [anon_sym_PLUS] = ACTIONS(5664),
    [anon_sym_STAR] = ACTIONS(5666),
    [anon_sym_SLASH] = ACTIONS(5664),
    [anon_sym_PERCENT] = ACTIONS(5666),
    [anon_sym_PIPE_PIPE] = ACTIONS(5666),
    [anon_sym_AMP_AMP] = ACTIONS(5666),
    [anon_sym_PIPE] = ACTIONS(5664),
    [anon_sym_CARET] = ACTIONS(5666),
    [anon_sym_AMP] = ACTIONS(5664),
    [anon_sym_EQ_EQ] = ACTIONS(5666),
    [anon_sym_BANG_EQ] = ACTIONS(5666),
    [anon_sym_GT] = ACTIONS(5664),
    [anon_sym_GT_EQ] = ACTIONS(5666),
    [anon_sym_LT_EQ] = ACTIONS(5664),
    [anon_sym_LT] = ACTIONS(5664),
    [anon_sym_LT_LT] = ACTIONS(5666),
    [anon_sym_GT_GT] = ACTIONS(5666),
    [anon_sym_SEMI] = ACTIONS(5666),
    [anon_sym___extension__] = ACTIONS(5664),
    [anon_sym___attribute__] = ACTIONS(5664),
    [anon_sym___attribute] = ACTIONS(5664),
    [anon_sym___based] = ACTIONS(5664),
    [anon_sym_LBRACE] = ACTIONS(5666),
    [anon_sym_RBRACE] = ACTIONS(5666),
    [anon_sym_signed] = ACTIONS(5664),
    [anon_sym_unsigned] = ACTIONS(5664),
    [anon_sym_long] = ACTIONS(5664),
    [anon_sym_short] = ACTIONS(5664),
    [anon_sym_LBRACK] = ACTIONS(5666),
    [anon_sym_RBRACK] = ACTIONS(5666),
    [anon_sym_const] = ACTIONS(5664),
    [anon_sym_constexpr] = ACTIONS(5664),
    [anon_sym_volatile] = ACTIONS(5664),
    [anon_sym_restrict] = ACTIONS(5664),
    [anon_sym___restrict__] = ACTIONS(5664),
    [anon_sym__Atomic] = ACTIONS(5664),
    [anon_sym__Noreturn] = ACTIONS(5664),
    [anon_sym_noreturn] = ACTIONS(5664),
    [anon_sym__Nonnull] = ACTIONS(5664),
    [anon_sym_mutable] = ACTIONS(5664),
    [anon_sym_constinit] = ACTIONS(5664),
    [anon_sym_consteval] = ACTIONS(5664),
    [anon_sym_alignas] = ACTIONS(5664),
    [anon_sym__Alignas] = ACTIONS(5664),
    [sym_primitive_type] = ACTIONS(5664),
    [anon_sym_COLON] = ACTIONS(5666),
    [anon_sym_QMARK] = ACTIONS(5666),
    [anon_sym_LT_EQ_GT] = ACTIONS(5666),
    [anon_sym_or] = ACTIONS(5664),
    [anon_sym_and] = ACTIONS(5664),
    [anon_sym_bitor] = ACTIONS(5664),
    [anon_sym_xor] = ACTIONS(5664),
    [anon_sym_bitand] = ACTIONS(5664),
    [anon_sym_not_eq] = ACTIONS(5664),
    [anon_sym_DASH_DASH] = ACTIONS(5666),
    [anon_sym_PLUS_PLUS] = ACTIONS(5666),
    [anon_sym_DOT] = ACTIONS(5664),
    [anon_sym_DOT_STAR] = ACTIONS(5666),
    [anon_sym_DASH_GT] = ACTIONS(5666),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5664),
    [anon_sym_decltype] = ACTIONS(5664),
    [anon_sym_final] = ACTIONS(5664),
    [anon_sym_override] = ACTIONS(5664),
    [anon_sym_requires] = ACTIONS(5664),
  },
  [1848] = {
    [sym_identifier] = ACTIONS(5668),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5670),
    [anon_sym_COMMA] = ACTIONS(5670),
    [anon_sym_RPAREN] = ACTIONS(5670),
    [anon_sym_LPAREN2] = ACTIONS(5670),
    [anon_sym_DASH] = ACTIONS(5668),
    [anon_sym_PLUS] = ACTIONS(5668),
    [anon_sym_STAR] = ACTIONS(5670),
    [anon_sym_SLASH] = ACTIONS(5668),
    [anon_sym_PERCENT] = ACTIONS(5670),
    [anon_sym_PIPE_PIPE] = ACTIONS(5670),
    [anon_sym_AMP_AMP] = ACTIONS(5670),
    [anon_sym_PIPE] = ACTIONS(5668),
    [anon_sym_CARET] = ACTIONS(5670),
    [anon_sym_AMP] = ACTIONS(5668),
    [anon_sym_EQ_EQ] = ACTIONS(5670),
    [anon_sym_BANG_EQ] = ACTIONS(5670),
    [anon_sym_GT] = ACTIONS(5668),
    [anon_sym_GT_EQ] = ACTIONS(5670),
    [anon_sym_LT_EQ] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5668),
    [anon_sym_LT_LT] = ACTIONS(5670),
    [anon_sym_GT_GT] = ACTIONS(5670),
    [anon_sym_SEMI] = ACTIONS(5670),
    [anon_sym___extension__] = ACTIONS(5668),
    [anon_sym___attribute__] = ACTIONS(5668),
    [anon_sym___attribute] = ACTIONS(5668),
    [anon_sym___based] = ACTIONS(5668),
    [anon_sym_LBRACE] = ACTIONS(5670),
    [anon_sym_RBRACE] = ACTIONS(5670),
    [anon_sym_signed] = ACTIONS(5668),
    [anon_sym_unsigned] = ACTIONS(5668),
    [anon_sym_long] = ACTIONS(5668),
    [anon_sym_short] = ACTIONS(5668),
    [anon_sym_LBRACK] = ACTIONS(5670),
    [anon_sym_RBRACK] = ACTIONS(5670),
    [anon_sym_const] = ACTIONS(5668),
    [anon_sym_constexpr] = ACTIONS(5668),
    [anon_sym_volatile] = ACTIONS(5668),
    [anon_sym_restrict] = ACTIONS(5668),
    [anon_sym___restrict__] = ACTIONS(5668),
    [anon_sym__Atomic] = ACTIONS(5668),
    [anon_sym__Noreturn] = ACTIONS(5668),
    [anon_sym_noreturn] = ACTIONS(5668),
    [anon_sym__Nonnull] = ACTIONS(5668),
    [anon_sym_mutable] = ACTIONS(5668),
    [anon_sym_constinit] = ACTIONS(5668),
    [anon_sym_consteval] = ACTIONS(5668),
    [anon_sym_alignas] = ACTIONS(5668),
    [anon_sym__Alignas] = ACTIONS(5668),
    [sym_primitive_type] = ACTIONS(5668),
    [anon_sym_COLON] = ACTIONS(5670),
    [anon_sym_QMARK] = ACTIONS(5670),
    [anon_sym_LT_EQ_GT] = ACTIONS(5670),
    [anon_sym_or] = ACTIONS(5668),
    [anon_sym_and] = ACTIONS(5668),
    [anon_sym_bitor] = ACTIONS(5668),
    [anon_sym_xor] = ACTIONS(5668),
    [anon_sym_bitand] = ACTIONS(5668),
    [anon_sym_not_eq] = ACTIONS(5668),
    [anon_sym_DASH_DASH] = ACTIONS(5670),
    [anon_sym_PLUS_PLUS] = ACTIONS(5670),
    [anon_sym_DOT] = ACTIONS(5668),
    [anon_sym_DOT_STAR] = ACTIONS(5670),
    [anon_sym_DASH_GT] = ACTIONS(5670),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5668),
    [anon_sym_decltype] = ACTIONS(5668),
    [anon_sym_final] = ACTIONS(5668),
    [anon_sym_override] = ACTIONS(5668),
    [anon_sym_requires] = ACTIONS(5668),
  },
  [1849] = {
    [sym_identifier] = ACTIONS(5672),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5674),
    [anon_sym_COMMA] = ACTIONS(5674),
    [anon_sym_RPAREN] = ACTIONS(5674),
    [anon_sym_LPAREN2] = ACTIONS(5674),
    [anon_sym_DASH] = ACTIONS(5672),
    [anon_sym_PLUS] = ACTIONS(5672),
    [anon_sym_STAR] = ACTIONS(5674),
    [anon_sym_SLASH] = ACTIONS(5672),
    [anon_sym_PERCENT] = ACTIONS(5674),
    [anon_sym_PIPE_PIPE] = ACTIONS(5674),
    [anon_sym_AMP_AMP] = ACTIONS(5674),
    [anon_sym_PIPE] = ACTIONS(5672),
    [anon_sym_CARET] = ACTIONS(5674),
    [anon_sym_AMP] = ACTIONS(5672),
    [anon_sym_EQ_EQ] = ACTIONS(5674),
    [anon_sym_BANG_EQ] = ACTIONS(5674),
    [anon_sym_GT] = ACTIONS(5672),
    [anon_sym_GT_EQ] = ACTIONS(5674),
    [anon_sym_LT_EQ] = ACTIONS(5672),
    [anon_sym_LT] = ACTIONS(5672),
    [anon_sym_LT_LT] = ACTIONS(5674),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_SEMI] = ACTIONS(5674),
    [anon_sym___extension__] = ACTIONS(5672),
    [anon_sym___attribute__] = ACTIONS(5672),
    [anon_sym___attribute] = ACTIONS(5672),
    [anon_sym___based] = ACTIONS(5672),
    [anon_sym_LBRACE] = ACTIONS(5674),
    [anon_sym_RBRACE] = ACTIONS(5674),
    [anon_sym_signed] = ACTIONS(5672),
    [anon_sym_unsigned] = ACTIONS(5672),
    [anon_sym_long] = ACTIONS(5672),
    [anon_sym_short] = ACTIONS(5672),
    [anon_sym_LBRACK] = ACTIONS(5674),
    [anon_sym_RBRACK] = ACTIONS(5674),
    [anon_sym_const] = ACTIONS(5672),
    [anon_sym_constexpr] = ACTIONS(5672),
    [anon_sym_volatile] = ACTIONS(5672),
    [anon_sym_restrict] = ACTIONS(5672),
    [anon_sym___restrict__] = ACTIONS(5672),
    [anon_sym__Atomic] = ACTIONS(5672),
    [anon_sym__Noreturn] = ACTIONS(5672),
    [anon_sym_noreturn] = ACTIONS(5672),
    [anon_sym__Nonnull] = ACTIONS(5672),
    [anon_sym_mutable] = ACTIONS(5672),
    [anon_sym_constinit] = ACTIONS(5672),
    [anon_sym_consteval] = ACTIONS(5672),
    [anon_sym_alignas] = ACTIONS(5672),
    [anon_sym__Alignas] = ACTIONS(5672),
    [sym_primitive_type] = ACTIONS(5672),
    [anon_sym_COLON] = ACTIONS(5674),
    [anon_sym_QMARK] = ACTIONS(5674),
    [anon_sym_LT_EQ_GT] = ACTIONS(5674),
    [anon_sym_or] = ACTIONS(5672),
    [anon_sym_and] = ACTIONS(5672),
    [anon_sym_bitor] = ACTIONS(5672),
    [anon_sym_xor] = ACTIONS(5672),
    [anon_sym_bitand] = ACTIONS(5672),
    [anon_sym_not_eq] = ACTIONS(5672),
    [anon_sym_DASH_DASH] = ACTIONS(5674),
    [anon_sym_PLUS_PLUS] = ACTIONS(5674),
    [anon_sym_DOT] = ACTIONS(5672),
    [anon_sym_DOT_STAR] = ACTIONS(5674),
    [anon_sym_DASH_GT] = ACTIONS(5674),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5672),
    [anon_sym_decltype] = ACTIONS(5672),
    [anon_sym_final] = ACTIONS(5672),
    [anon_sym_override] = ACTIONS(5672),
    [anon_sym_requires] = ACTIONS(5672),
  },
  [1850] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4857),
    [anon_sym_COMMA] = ACTIONS(4857),
    [anon_sym_RPAREN] = ACTIONS(4859),
    [anon_sym_LPAREN2] = ACTIONS(4859),
    [anon_sym_DASH] = ACTIONS(4864),
    [anon_sym_PLUS] = ACTIONS(4864),
    [anon_sym_STAR] = ACTIONS(4866),
    [anon_sym_SLASH] = ACTIONS(4864),
    [anon_sym_PERCENT] = ACTIONS(4864),
    [anon_sym_PIPE_PIPE] = ACTIONS(4857),
    [anon_sym_AMP_AMP] = ACTIONS(4859),
    [anon_sym_PIPE] = ACTIONS(4864),
    [anon_sym_CARET] = ACTIONS(4864),
    [anon_sym_AMP] = ACTIONS(4866),
    [anon_sym_EQ_EQ] = ACTIONS(4857),
    [anon_sym_BANG_EQ] = ACTIONS(4857),
    [anon_sym_GT] = ACTIONS(4864),
    [anon_sym_GT_EQ] = ACTIONS(4857),
    [anon_sym_LT_EQ] = ACTIONS(4864),
    [anon_sym_LT] = ACTIONS(4864),
    [anon_sym_LT_LT] = ACTIONS(4864),
    [anon_sym_GT_GT] = ACTIONS(4864),
    [anon_sym___extension__] = ACTIONS(4862),
    [anon_sym_COLON_COLON] = ACTIONS(4862),
    [anon_sym_LBRACE] = ACTIONS(4862),
    [anon_sym_LBRACK] = ACTIONS(4859),
    [anon_sym_EQ] = ACTIONS(4864),
    [anon_sym_const] = ACTIONS(4855),
    [anon_sym_constexpr] = ACTIONS(4862),
    [anon_sym_volatile] = ACTIONS(4862),
    [anon_sym_restrict] = ACTIONS(4862),
    [anon_sym___restrict__] = ACTIONS(4862),
    [anon_sym__Atomic] = ACTIONS(4862),
    [anon_sym__Noreturn] = ACTIONS(4862),
    [anon_sym_noreturn] = ACTIONS(4862),
    [anon_sym__Nonnull] = ACTIONS(4862),
    [anon_sym_mutable] = ACTIONS(4862),
    [anon_sym_constinit] = ACTIONS(4862),
    [anon_sym_consteval] = ACTIONS(4862),
    [anon_sym_alignas] = ACTIONS(4862),
    [anon_sym__Alignas] = ACTIONS(4862),
    [anon_sym_QMARK] = ACTIONS(4857),
    [anon_sym_STAR_EQ] = ACTIONS(4857),
    [anon_sym_SLASH_EQ] = ACTIONS(4857),
    [anon_sym_PERCENT_EQ] = ACTIONS(4857),
    [anon_sym_PLUS_EQ] = ACTIONS(4857),
    [anon_sym_DASH_EQ] = ACTIONS(4857),
    [anon_sym_LT_LT_EQ] = ACTIONS(4857),
    [anon_sym_GT_GT_EQ] = ACTIONS(4857),
    [anon_sym_AMP_EQ] = ACTIONS(4857),
    [anon_sym_CARET_EQ] = ACTIONS(4857),
    [anon_sym_PIPE_EQ] = ACTIONS(4857),
    [anon_sym_and_eq] = ACTIONS(4857),
    [anon_sym_or_eq] = ACTIONS(4857),
    [anon_sym_xor_eq] = ACTIONS(4857),
    [anon_sym_LT_EQ_GT] = ACTIONS(4857),
    [anon_sym_or] = ACTIONS(4864),
    [anon_sym_and] = ACTIONS(4864),
    [anon_sym_bitor] = ACTIONS(4857),
    [anon_sym_xor] = ACTIONS(4864),
    [anon_sym_bitand] = ACTIONS(4857),
    [anon_sym_not_eq] = ACTIONS(4857),
    [anon_sym_DASH_DASH] = ACTIONS(4857),
    [anon_sym_PLUS_PLUS] = ACTIONS(4857),
    [anon_sym_DOT] = ACTIONS(4864),
    [anon_sym_DOT_STAR] = ACTIONS(4857),
    [anon_sym_DASH_GT] = ACTIONS(4864),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4862),
    [anon_sym_decltype] = ACTIONS(4862),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4857),
  },
  [1851] = {
    [sym_identifier] = ACTIONS(5676),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5678),
    [anon_sym_COMMA] = ACTIONS(5678),
    [anon_sym_RPAREN] = ACTIONS(5678),
    [anon_sym_LPAREN2] = ACTIONS(5678),
    [anon_sym_DASH] = ACTIONS(5676),
    [anon_sym_PLUS] = ACTIONS(5676),
    [anon_sym_STAR] = ACTIONS(5678),
    [anon_sym_SLASH] = ACTIONS(5676),
    [anon_sym_PERCENT] = ACTIONS(5678),
    [anon_sym_PIPE_PIPE] = ACTIONS(5678),
    [anon_sym_AMP_AMP] = ACTIONS(5678),
    [anon_sym_PIPE] = ACTIONS(5676),
    [anon_sym_CARET] = ACTIONS(5678),
    [anon_sym_AMP] = ACTIONS(5676),
    [anon_sym_EQ_EQ] = ACTIONS(5678),
    [anon_sym_BANG_EQ] = ACTIONS(5678),
    [anon_sym_GT] = ACTIONS(5676),
    [anon_sym_GT_EQ] = ACTIONS(5678),
    [anon_sym_LT_EQ] = ACTIONS(5676),
    [anon_sym_LT] = ACTIONS(5676),
    [anon_sym_LT_LT] = ACTIONS(5678),
    [anon_sym_GT_GT] = ACTIONS(5678),
    [anon_sym_SEMI] = ACTIONS(5678),
    [anon_sym___extension__] = ACTIONS(5676),
    [anon_sym___attribute__] = ACTIONS(5676),
    [anon_sym___attribute] = ACTIONS(5676),
    [anon_sym___based] = ACTIONS(5676),
    [anon_sym_LBRACE] = ACTIONS(5678),
    [anon_sym_RBRACE] = ACTIONS(5678),
    [anon_sym_signed] = ACTIONS(5676),
    [anon_sym_unsigned] = ACTIONS(5676),
    [anon_sym_long] = ACTIONS(5676),
    [anon_sym_short] = ACTIONS(5676),
    [anon_sym_LBRACK] = ACTIONS(5678),
    [anon_sym_RBRACK] = ACTIONS(5678),
    [anon_sym_const] = ACTIONS(5676),
    [anon_sym_constexpr] = ACTIONS(5676),
    [anon_sym_volatile] = ACTIONS(5676),
    [anon_sym_restrict] = ACTIONS(5676),
    [anon_sym___restrict__] = ACTIONS(5676),
    [anon_sym__Atomic] = ACTIONS(5676),
    [anon_sym__Noreturn] = ACTIONS(5676),
    [anon_sym_noreturn] = ACTIONS(5676),
    [anon_sym__Nonnull] = ACTIONS(5676),
    [anon_sym_mutable] = ACTIONS(5676),
    [anon_sym_constinit] = ACTIONS(5676),
    [anon_sym_consteval] = ACTIONS(5676),
    [anon_sym_alignas] = ACTIONS(5676),
    [anon_sym__Alignas] = ACTIONS(5676),
    [sym_primitive_type] = ACTIONS(5676),
    [anon_sym_COLON] = ACTIONS(5678),
    [anon_sym_QMARK] = ACTIONS(5678),
    [anon_sym_LT_EQ_GT] = ACTIONS(5678),
    [anon_sym_or] = ACTIONS(5676),
    [anon_sym_and] = ACTIONS(5676),
    [anon_sym_bitor] = ACTIONS(5676),
    [anon_sym_xor] = ACTIONS(5676),
    [anon_sym_bitand] = ACTIONS(5676),
    [anon_sym_not_eq] = ACTIONS(5676),
    [anon_sym_DASH_DASH] = ACTIONS(5678),
    [anon_sym_PLUS_PLUS] = ACTIONS(5678),
    [anon_sym_DOT] = ACTIONS(5676),
    [anon_sym_DOT_STAR] = ACTIONS(5678),
    [anon_sym_DASH_GT] = ACTIONS(5678),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5676),
    [anon_sym_decltype] = ACTIONS(5676),
    [anon_sym_final] = ACTIONS(5676),
    [anon_sym_override] = ACTIONS(5676),
    [anon_sym_requires] = ACTIONS(5676),
  },
  [1852] = {
    [sym_identifier] = ACTIONS(5680),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5682),
    [anon_sym_COMMA] = ACTIONS(5682),
    [anon_sym_RPAREN] = ACTIONS(5682),
    [anon_sym_LPAREN2] = ACTIONS(5682),
    [anon_sym_DASH] = ACTIONS(5680),
    [anon_sym_PLUS] = ACTIONS(5680),
    [anon_sym_STAR] = ACTIONS(5682),
    [anon_sym_SLASH] = ACTIONS(5680),
    [anon_sym_PERCENT] = ACTIONS(5682),
    [anon_sym_PIPE_PIPE] = ACTIONS(5682),
    [anon_sym_AMP_AMP] = ACTIONS(5682),
    [anon_sym_PIPE] = ACTIONS(5680),
    [anon_sym_CARET] = ACTIONS(5682),
    [anon_sym_AMP] = ACTIONS(5680),
    [anon_sym_EQ_EQ] = ACTIONS(5682),
    [anon_sym_BANG_EQ] = ACTIONS(5682),
    [anon_sym_GT] = ACTIONS(5680),
    [anon_sym_GT_EQ] = ACTIONS(5682),
    [anon_sym_LT_EQ] = ACTIONS(5680),
    [anon_sym_LT] = ACTIONS(5680),
    [anon_sym_LT_LT] = ACTIONS(5682),
    [anon_sym_GT_GT] = ACTIONS(5682),
    [anon_sym_SEMI] = ACTIONS(5682),
    [anon_sym___extension__] = ACTIONS(5680),
    [anon_sym___attribute__] = ACTIONS(5680),
    [anon_sym___attribute] = ACTIONS(5680),
    [anon_sym___based] = ACTIONS(5680),
    [anon_sym_LBRACE] = ACTIONS(5682),
    [anon_sym_RBRACE] = ACTIONS(5682),
    [anon_sym_signed] = ACTIONS(5680),
    [anon_sym_unsigned] = ACTIONS(5680),
    [anon_sym_long] = ACTIONS(5680),
    [anon_sym_short] = ACTIONS(5680),
    [anon_sym_LBRACK] = ACTIONS(5682),
    [anon_sym_RBRACK] = ACTIONS(5682),
    [anon_sym_const] = ACTIONS(5680),
    [anon_sym_constexpr] = ACTIONS(5680),
    [anon_sym_volatile] = ACTIONS(5680),
    [anon_sym_restrict] = ACTIONS(5680),
    [anon_sym___restrict__] = ACTIONS(5680),
    [anon_sym__Atomic] = ACTIONS(5680),
    [anon_sym__Noreturn] = ACTIONS(5680),
    [anon_sym_noreturn] = ACTIONS(5680),
    [anon_sym__Nonnull] = ACTIONS(5680),
    [anon_sym_mutable] = ACTIONS(5680),
    [anon_sym_constinit] = ACTIONS(5680),
    [anon_sym_consteval] = ACTIONS(5680),
    [anon_sym_alignas] = ACTIONS(5680),
    [anon_sym__Alignas] = ACTIONS(5680),
    [sym_primitive_type] = ACTIONS(5680),
    [anon_sym_COLON] = ACTIONS(5682),
    [anon_sym_QMARK] = ACTIONS(5682),
    [anon_sym_LT_EQ_GT] = ACTIONS(5682),
    [anon_sym_or] = ACTIONS(5680),
    [anon_sym_and] = ACTIONS(5680),
    [anon_sym_bitor] = ACTIONS(5680),
    [anon_sym_xor] = ACTIONS(5680),
    [anon_sym_bitand] = ACTIONS(5680),
    [anon_sym_not_eq] = ACTIONS(5680),
    [anon_sym_DASH_DASH] = ACTIONS(5682),
    [anon_sym_PLUS_PLUS] = ACTIONS(5682),
    [anon_sym_DOT] = ACTIONS(5680),
    [anon_sym_DOT_STAR] = ACTIONS(5682),
    [anon_sym_DASH_GT] = ACTIONS(5682),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5680),
    [anon_sym_decltype] = ACTIONS(5680),
    [anon_sym_final] = ACTIONS(5680),
    [anon_sym_override] = ACTIONS(5680),
    [anon_sym_requires] = ACTIONS(5680),
  },
  [1853] = {
    [sym_argument_list] = STATE(2479),
    [sym_initializer_list] = STATE(2479),
    [sym_decltype_auto] = STATE(2183),
    [sym_new_declarator] = STATE(2213),
    [sym_identifier] = ACTIONS(5684),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5686),
    [anon_sym_COMMA] = ACTIONS(5686),
    [anon_sym_RPAREN] = ACTIONS(5686),
    [aux_sym_preproc_if_token2] = ACTIONS(5686),
    [aux_sym_preproc_else_token1] = ACTIONS(5686),
    [aux_sym_preproc_elif_token1] = ACTIONS(5684),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5686),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5686),
    [anon_sym_LPAREN2] = ACTIONS(5688),
    [anon_sym_DASH] = ACTIONS(5684),
    [anon_sym_PLUS] = ACTIONS(5684),
    [anon_sym_STAR] = ACTIONS(5684),
    [anon_sym_SLASH] = ACTIONS(5684),
    [anon_sym_PERCENT] = ACTIONS(5684),
    [anon_sym_PIPE_PIPE] = ACTIONS(5686),
    [anon_sym_AMP_AMP] = ACTIONS(5686),
    [anon_sym_PIPE] = ACTIONS(5684),
    [anon_sym_CARET] = ACTIONS(5684),
    [anon_sym_AMP] = ACTIONS(5684),
    [anon_sym_EQ_EQ] = ACTIONS(5686),
    [anon_sym_BANG_EQ] = ACTIONS(5686),
    [anon_sym_GT] = ACTIONS(5684),
    [anon_sym_GT_EQ] = ACTIONS(5686),
    [anon_sym_LT_EQ] = ACTIONS(5684),
    [anon_sym_LT] = ACTIONS(5684),
    [anon_sym_LT_LT] = ACTIONS(5684),
    [anon_sym_GT_GT] = ACTIONS(5684),
    [anon_sym_SEMI] = ACTIONS(5686),
    [anon_sym___attribute__] = ACTIONS(5684),
    [anon_sym___attribute] = ACTIONS(5684),
    [anon_sym_LBRACE] = ACTIONS(1927),
    [anon_sym_RBRACE] = ACTIONS(5686),
    [anon_sym_LBRACK] = ACTIONS(5690),
    [anon_sym_RBRACK] = ACTIONS(5686),
    [anon_sym_EQ] = ACTIONS(5684),
    [anon_sym_COLON] = ACTIONS(5686),
    [anon_sym_QMARK] = ACTIONS(5686),
    [anon_sym_STAR_EQ] = ACTIONS(5686),
    [anon_sym_SLASH_EQ] = ACTIONS(5686),
    [anon_sym_PERCENT_EQ] = ACTIONS(5686),
    [anon_sym_PLUS_EQ] = ACTIONS(5686),
    [anon_sym_DASH_EQ] = ACTIONS(5686),
    [anon_sym_LT_LT_EQ] = ACTIONS(5686),
    [anon_sym_GT_GT_EQ] = ACTIONS(5686),
    [anon_sym_AMP_EQ] = ACTIONS(5686),
    [anon_sym_CARET_EQ] = ACTIONS(5686),
    [anon_sym_PIPE_EQ] = ACTIONS(5686),
    [anon_sym_and_eq] = ACTIONS(5684),
    [anon_sym_or_eq] = ACTIONS(5684),
    [anon_sym_xor_eq] = ACTIONS(5684),
    [anon_sym_LT_EQ_GT] = ACTIONS(5686),
    [anon_sym_or] = ACTIONS(5684),
    [anon_sym_and] = ACTIONS(5684),
    [anon_sym_bitor] = ACTIONS(5684),
    [anon_sym_xor] = ACTIONS(5684),
    [anon_sym_bitand] = ACTIONS(5684),
    [anon_sym_not_eq] = ACTIONS(5684),
    [anon_sym_DASH_DASH] = ACTIONS(5686),
    [anon_sym_PLUS_PLUS] = ACTIONS(5686),
    [anon_sym_DOT] = ACTIONS(5684),
    [anon_sym_DOT_STAR] = ACTIONS(5686),
    [anon_sym_DASH_GT] = ACTIONS(5686),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5692),
    [anon_sym_decltype] = ACTIONS(5694),
  },
  [1854] = {
    [sym_ms_based_modifier] = STATE(7915),
    [sym_ms_unaligned_ptr_modifier] = STATE(3998),
    [sym_ms_pointer_modifier] = STATE(3851),
    [sym__declarator] = STATE(6275),
    [sym__abstract_declarator] = STATE(6473),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_abstract_parenthesized_declarator] = STATE(5942),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_abstract_pointer_declarator] = STATE(5942),
    [sym_function_declarator] = STATE(5896),
    [sym_abstract_function_declarator] = STATE(5942),
    [sym_array_declarator] = STATE(5896),
    [sym_abstract_array_declarator] = STATE(5942),
    [sym_type_qualifier] = STATE(2519),
    [sym_alignas_qualifier] = STATE(4266),
    [sym_parameter_list] = STATE(3005),
    [sym_decltype] = STATE(8512),
    [sym_reference_declarator] = STATE(5896),
    [sym_abstract_reference_declarator] = STATE(5942),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym__function_declarator_seq] = STATE(5919),
    [sym_template_type] = STATE(8512),
    [sym_template_function] = STATE(5896),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5765),
    [sym_qualified_identifier] = STATE(5896),
    [sym_operator_name] = STATE(5896),
    [aux_sym__type_definition_type_repeat1] = STATE(2519),
    [aux_sym_pointer_declarator_repeat1] = STATE(3851),
    [sym_identifier] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5698),
    [anon_sym_RPAREN] = ACTIONS(5698),
    [anon_sym_LPAREN2] = ACTIONS(4157),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(5700),
    [anon_sym_AMP_AMP] = ACTIONS(5702),
    [anon_sym_AMP] = ACTIONS(5704),
    [anon_sym___extension__] = ACTIONS(3270),
    [anon_sym___attribute__] = ACTIONS(5706),
    [anon_sym___attribute] = ACTIONS(5706),
    [anon_sym_COLON_COLON] = ACTIONS(5708),
    [anon_sym___based] = ACTIONS(51),
    [sym_ms_restrict_modifier] = ACTIONS(3266),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(3266),
    [sym_ms_signed_ptr_modifier] = ACTIONS(3266),
    [anon_sym__unaligned] = ACTIONS(3268),
    [anon_sym___unaligned] = ACTIONS(3268),
    [anon_sym_LBRACK] = ACTIONS(5710),
    [anon_sym_EQ] = ACTIONS(5698),
    [anon_sym_const] = ACTIONS(3270),
    [anon_sym_constexpr] = ACTIONS(3270),
    [anon_sym_volatile] = ACTIONS(3270),
    [anon_sym_restrict] = ACTIONS(3270),
    [anon_sym___restrict__] = ACTIONS(3270),
    [anon_sym__Atomic] = ACTIONS(3270),
    [anon_sym__Noreturn] = ACTIONS(3270),
    [anon_sym_noreturn] = ACTIONS(3270),
    [anon_sym__Nonnull] = ACTIONS(3270),
    [anon_sym_mutable] = ACTIONS(3270),
    [anon_sym_constinit] = ACTIONS(3270),
    [anon_sym_consteval] = ACTIONS(3270),
    [anon_sym_alignas] = ACTIONS(3272),
    [anon_sym__Alignas] = ACTIONS(3272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_GT2] = ACTIONS(5698),
    [anon_sym_operator] = ACTIONS(1823),
  },
  [1855] = {
    [sym_argument_list] = STATE(2414),
    [sym_initializer_list] = STATE(2414),
    [sym_decltype_auto] = STATE(2183),
    [sym_new_declarator] = STATE(2204),
    [sym_identifier] = ACTIONS(5712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5714),
    [anon_sym_COMMA] = ACTIONS(5714),
    [anon_sym_RPAREN] = ACTIONS(5714),
    [aux_sym_preproc_if_token2] = ACTIONS(5714),
    [aux_sym_preproc_else_token1] = ACTIONS(5714),
    [aux_sym_preproc_elif_token1] = ACTIONS(5712),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5714),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5714),
    [anon_sym_LPAREN2] = ACTIONS(5688),
    [anon_sym_DASH] = ACTIONS(5712),
    [anon_sym_PLUS] = ACTIONS(5712),
    [anon_sym_STAR] = ACTIONS(5712),
    [anon_sym_SLASH] = ACTIONS(5712),
    [anon_sym_PERCENT] = ACTIONS(5712),
    [anon_sym_PIPE_PIPE] = ACTIONS(5714),
    [anon_sym_AMP_AMP] = ACTIONS(5714),
    [anon_sym_PIPE] = ACTIONS(5712),
    [anon_sym_CARET] = ACTIONS(5712),
    [anon_sym_AMP] = ACTIONS(5712),
    [anon_sym_EQ_EQ] = ACTIONS(5714),
    [anon_sym_BANG_EQ] = ACTIONS(5714),
    [anon_sym_GT] = ACTIONS(5712),
    [anon_sym_GT_EQ] = ACTIONS(5714),
    [anon_sym_LT_EQ] = ACTIONS(5712),
    [anon_sym_LT] = ACTIONS(5712),
    [anon_sym_LT_LT] = ACTIONS(5712),
    [anon_sym_GT_GT] = ACTIONS(5712),
    [anon_sym_SEMI] = ACTIONS(5714),
    [anon_sym___attribute__] = ACTIONS(5712),
    [anon_sym___attribute] = ACTIONS(5712),
    [anon_sym_LBRACE] = ACTIONS(1927),
    [anon_sym_RBRACE] = ACTIONS(5714),
    [anon_sym_LBRACK] = ACTIONS(5690),
    [anon_sym_RBRACK] = ACTIONS(5714),
    [anon_sym_EQ] = ACTIONS(5712),
    [anon_sym_COLON] = ACTIONS(5714),
    [anon_sym_QMARK] = ACTIONS(5714),
    [anon_sym_STAR_EQ] = ACTIONS(5714),
    [anon_sym_SLASH_EQ] = ACTIONS(5714),
    [anon_sym_PERCENT_EQ] = ACTIONS(5714),
    [anon_sym_PLUS_EQ] = ACTIONS(5714),
    [anon_sym_DASH_EQ] = ACTIONS(5714),
    [anon_sym_LT_LT_EQ] = ACTIONS(5714),
    [anon_sym_GT_GT_EQ] = ACTIONS(5714),
    [anon_sym_AMP_EQ] = ACTIONS(5714),
    [anon_sym_CARET_EQ] = ACTIONS(5714),
    [anon_sym_PIPE_EQ] = ACTIONS(5714),
    [anon_sym_and_eq] = ACTIONS(5712),
    [anon_sym_or_eq] = ACTIONS(5712),
    [anon_sym_xor_eq] = ACTIONS(5712),
    [anon_sym_LT_EQ_GT] = ACTIONS(5714),
    [anon_sym_or] = ACTIONS(5712),
    [anon_sym_and] = ACTIONS(5712),
    [anon_sym_bitor] = ACTIONS(5712),
    [anon_sym_xor] = ACTIONS(5712),
    [anon_sym_bitand] = ACTIONS(5712),
    [anon_sym_not_eq] = ACTIONS(5712),
    [anon_sym_DASH_DASH] = ACTIONS(5714),
    [anon_sym_PLUS_PLUS] = ACTIONS(5714),
    [anon_sym_DOT] = ACTIONS(5712),
    [anon_sym_DOT_STAR] = ACTIONS(5714),
    [anon_sym_DASH_GT] = ACTIONS(5714),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5692),
    [anon_sym_decltype] = ACTIONS(5694),
  },
  [1856] = {
    [sym_argument_list] = STATE(2435),
    [sym_initializer_list] = STATE(2435),
    [sym_decltype_auto] = STATE(2183),
    [sym_new_declarator] = STATE(2253),
    [sym_identifier] = ACTIONS(5716),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5718),
    [anon_sym_COMMA] = ACTIONS(5718),
    [anon_sym_RPAREN] = ACTIONS(5718),
    [aux_sym_preproc_if_token2] = ACTIONS(5718),
    [aux_sym_preproc_else_token1] = ACTIONS(5718),
    [aux_sym_preproc_elif_token1] = ACTIONS(5716),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5718),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5718),
    [anon_sym_LPAREN2] = ACTIONS(5688),
    [anon_sym_DASH] = ACTIONS(5716),
    [anon_sym_PLUS] = ACTIONS(5716),
    [anon_sym_STAR] = ACTIONS(5716),
    [anon_sym_SLASH] = ACTIONS(5716),
    [anon_sym_PERCENT] = ACTIONS(5716),
    [anon_sym_PIPE_PIPE] = ACTIONS(5718),
    [anon_sym_AMP_AMP] = ACTIONS(5718),
    [anon_sym_PIPE] = ACTIONS(5716),
    [anon_sym_CARET] = ACTIONS(5716),
    [anon_sym_AMP] = ACTIONS(5716),
    [anon_sym_EQ_EQ] = ACTIONS(5718),
    [anon_sym_BANG_EQ] = ACTIONS(5718),
    [anon_sym_GT] = ACTIONS(5716),
    [anon_sym_GT_EQ] = ACTIONS(5718),
    [anon_sym_LT_EQ] = ACTIONS(5716),
    [anon_sym_LT] = ACTIONS(5716),
    [anon_sym_LT_LT] = ACTIONS(5716),
    [anon_sym_GT_GT] = ACTIONS(5716),
    [anon_sym_SEMI] = ACTIONS(5718),
    [anon_sym___attribute__] = ACTIONS(5716),
    [anon_sym___attribute] = ACTIONS(5716),
    [anon_sym_LBRACE] = ACTIONS(1927),
    [anon_sym_RBRACE] = ACTIONS(5718),
    [anon_sym_LBRACK] = ACTIONS(5690),
    [anon_sym_RBRACK] = ACTIONS(5718),
    [anon_sym_EQ] = ACTIONS(5716),
    [anon_sym_COLON] = ACTIONS(5718),
    [anon_sym_QMARK] = ACTIONS(5718),
    [anon_sym_STAR_EQ] = ACTIONS(5718),
    [anon_sym_SLASH_EQ] = ACTIONS(5718),
    [anon_sym_PERCENT_EQ] = ACTIONS(5718),
    [anon_sym_PLUS_EQ] = ACTIONS(5718),
    [anon_sym_DASH_EQ] = ACTIONS(5718),
    [anon_sym_LT_LT_EQ] = ACTIONS(5718),
    [anon_sym_GT_GT_EQ] = ACTIONS(5718),
    [anon_sym_AMP_EQ] = ACTIONS(5718),
    [anon_sym_CARET_EQ] = ACTIONS(5718),
    [anon_sym_PIPE_EQ] = ACTIONS(5718),
    [anon_sym_and_eq] = ACTIONS(5716),
    [anon_sym_or_eq] = ACTIONS(5716),
    [anon_sym_xor_eq] = ACTIONS(5716),
    [anon_sym_LT_EQ_GT] = ACTIONS(5718),
    [anon_sym_or] = ACTIONS(5716),
    [anon_sym_and] = ACTIONS(5716),
    [anon_sym_bitor] = ACTIONS(5716),
    [anon_sym_xor] = ACTIONS(5716),
    [anon_sym_bitand] = ACTIONS(5716),
    [anon_sym_not_eq] = ACTIONS(5716),
    [anon_sym_DASH_DASH] = ACTIONS(5718),
    [anon_sym_PLUS_PLUS] = ACTIONS(5718),
    [anon_sym_DOT] = ACTIONS(5716),
    [anon_sym_DOT_STAR] = ACTIONS(5718),
    [anon_sym_DASH_GT] = ACTIONS(5718),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5692),
    [anon_sym_decltype] = ACTIONS(5694),
  },
  [1857] = {
    [sym_template_argument_list] = STATE(1874),
    [sym_identifier] = ACTIONS(5720),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4059),
    [anon_sym_COMMA] = ACTIONS(4059),
    [anon_sym_RPAREN] = ACTIONS(4059),
    [aux_sym_preproc_if_token2] = ACTIONS(4059),
    [aux_sym_preproc_else_token1] = ACTIONS(4059),
    [aux_sym_preproc_elif_token1] = ACTIONS(5720),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4059),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4059),
    [anon_sym_LPAREN2] = ACTIONS(4059),
    [anon_sym_DASH] = ACTIONS(5720),
    [anon_sym_PLUS] = ACTIONS(5720),
    [anon_sym_STAR] = ACTIONS(5720),
    [anon_sym_SLASH] = ACTIONS(5720),
    [anon_sym_PERCENT] = ACTIONS(5720),
    [anon_sym_PIPE_PIPE] = ACTIONS(4059),
    [anon_sym_AMP_AMP] = ACTIONS(4059),
    [anon_sym_PIPE] = ACTIONS(5720),
    [anon_sym_CARET] = ACTIONS(5720),
    [anon_sym_AMP] = ACTIONS(5720),
    [anon_sym_EQ_EQ] = ACTIONS(4059),
    [anon_sym_BANG_EQ] = ACTIONS(4059),
    [anon_sym_GT] = ACTIONS(5720),
    [anon_sym_GT_EQ] = ACTIONS(4059),
    [anon_sym_LT_EQ] = ACTIONS(5720),
    [anon_sym_LT] = ACTIONS(5722),
    [anon_sym_LT_LT] = ACTIONS(5720),
    [anon_sym_GT_GT] = ACTIONS(5720),
    [anon_sym_SEMI] = ACTIONS(4059),
    [anon_sym___attribute__] = ACTIONS(5720),
    [anon_sym___attribute] = ACTIONS(5720),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACE] = ACTIONS(4059),
    [anon_sym_RBRACE] = ACTIONS(4059),
    [anon_sym_LBRACK] = ACTIONS(4059),
    [anon_sym_RBRACK] = ACTIONS(4059),
    [anon_sym_EQ] = ACTIONS(5720),
    [anon_sym_COLON] = ACTIONS(5720),
    [anon_sym_QMARK] = ACTIONS(4059),
    [anon_sym_STAR_EQ] = ACTIONS(4059),
    [anon_sym_SLASH_EQ] = ACTIONS(4059),
    [anon_sym_PERCENT_EQ] = ACTIONS(4059),
    [anon_sym_PLUS_EQ] = ACTIONS(4059),
    [anon_sym_DASH_EQ] = ACTIONS(4059),
    [anon_sym_LT_LT_EQ] = ACTIONS(4059),
    [anon_sym_GT_GT_EQ] = ACTIONS(4059),
    [anon_sym_AMP_EQ] = ACTIONS(4059),
    [anon_sym_CARET_EQ] = ACTIONS(4059),
    [anon_sym_PIPE_EQ] = ACTIONS(4059),
    [anon_sym_and_eq] = ACTIONS(5720),
    [anon_sym_or_eq] = ACTIONS(5720),
    [anon_sym_xor_eq] = ACTIONS(5720),
    [anon_sym_LT_EQ_GT] = ACTIONS(4059),
    [anon_sym_or] = ACTIONS(5720),
    [anon_sym_and] = ACTIONS(5720),
    [anon_sym_bitor] = ACTIONS(5720),
    [anon_sym_xor] = ACTIONS(5720),
    [anon_sym_bitand] = ACTIONS(5720),
    [anon_sym_not_eq] = ACTIONS(5720),
    [anon_sym_DASH_DASH] = ACTIONS(4059),
    [anon_sym_PLUS_PLUS] = ACTIONS(4059),
    [anon_sym_DOT] = ACTIONS(5720),
    [anon_sym_DOT_STAR] = ACTIONS(4059),
    [anon_sym_DASH_GT] = ACTIONS(4059),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5720),
    [anon_sym_decltype] = ACTIONS(5720),
    [anon_sym_final] = ACTIONS(5720),
    [anon_sym_override] = ACTIONS(5720),
  },
  [1858] = {
    [sym_identifier] = ACTIONS(5618),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5620),
    [anon_sym_COMMA] = ACTIONS(5620),
    [anon_sym_RPAREN] = ACTIONS(5620),
    [aux_sym_preproc_if_token2] = ACTIONS(5620),
    [aux_sym_preproc_else_token1] = ACTIONS(5620),
    [aux_sym_preproc_elif_token1] = ACTIONS(5618),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5620),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5620),
    [anon_sym_LPAREN2] = ACTIONS(5620),
    [anon_sym_DASH] = ACTIONS(5618),
    [anon_sym_PLUS] = ACTIONS(5618),
    [anon_sym_STAR] = ACTIONS(5620),
    [anon_sym_SLASH] = ACTIONS(5618),
    [anon_sym_PERCENT] = ACTIONS(5620),
    [anon_sym_PIPE_PIPE] = ACTIONS(5620),
    [anon_sym_AMP_AMP] = ACTIONS(5620),
    [anon_sym_PIPE] = ACTIONS(5618),
    [anon_sym_CARET] = ACTIONS(5620),
    [anon_sym_AMP] = ACTIONS(5618),
    [anon_sym_EQ_EQ] = ACTIONS(5620),
    [anon_sym_BANG_EQ] = ACTIONS(5620),
    [anon_sym_GT] = ACTIONS(5618),
    [anon_sym_GT_EQ] = ACTIONS(5620),
    [anon_sym_LT_EQ] = ACTIONS(5618),
    [anon_sym_LT] = ACTIONS(5618),
    [anon_sym_LT_LT] = ACTIONS(5620),
    [anon_sym_GT_GT] = ACTIONS(5620),
    [anon_sym_SEMI] = ACTIONS(5620),
    [anon_sym___extension__] = ACTIONS(5618),
    [anon_sym___attribute__] = ACTIONS(5618),
    [anon_sym___attribute] = ACTIONS(5618),
    [anon_sym_LBRACE] = ACTIONS(5620),
    [anon_sym_RBRACE] = ACTIONS(5620),
    [anon_sym_LBRACK] = ACTIONS(5620),
    [anon_sym_RBRACK] = ACTIONS(5620),
    [anon_sym_const] = ACTIONS(5618),
    [anon_sym_constexpr] = ACTIONS(5618),
    [anon_sym_volatile] = ACTIONS(5618),
    [anon_sym_restrict] = ACTIONS(5618),
    [anon_sym___restrict__] = ACTIONS(5618),
    [anon_sym__Atomic] = ACTIONS(5618),
    [anon_sym__Noreturn] = ACTIONS(5618),
    [anon_sym_noreturn] = ACTIONS(5618),
    [anon_sym__Nonnull] = ACTIONS(5618),
    [anon_sym_mutable] = ACTIONS(5618),
    [anon_sym_constinit] = ACTIONS(5618),
    [anon_sym_consteval] = ACTIONS(5618),
    [anon_sym_alignas] = ACTIONS(5618),
    [anon_sym__Alignas] = ACTIONS(5618),
    [anon_sym_COLON] = ACTIONS(5620),
    [anon_sym_QMARK] = ACTIONS(5620),
    [anon_sym_LT_EQ_GT] = ACTIONS(5620),
    [anon_sym_or] = ACTIONS(5618),
    [anon_sym_and] = ACTIONS(5618),
    [anon_sym_bitor] = ACTIONS(5618),
    [anon_sym_xor] = ACTIONS(5618),
    [anon_sym_bitand] = ACTIONS(5618),
    [anon_sym_not_eq] = ACTIONS(5618),
    [anon_sym_DASH_DASH] = ACTIONS(5620),
    [anon_sym_PLUS_PLUS] = ACTIONS(5620),
    [anon_sym_DOT] = ACTIONS(5618),
    [anon_sym_DOT_STAR] = ACTIONS(5620),
    [anon_sym_DASH_GT] = ACTIONS(5620),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5618),
    [anon_sym_decltype] = ACTIONS(5618),
    [anon_sym_final] = ACTIONS(5618),
    [anon_sym_override] = ACTIONS(5618),
    [anon_sym_requires] = ACTIONS(5618),
  },
  [1859] = {
    [sym_template_argument_list] = STATE(1874),
    [sym_identifier] = ACTIONS(4838),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4845),
    [anon_sym_COMMA] = ACTIONS(4845),
    [anon_sym_RPAREN] = ACTIONS(4845),
    [aux_sym_preproc_if_token2] = ACTIONS(4845),
    [aux_sym_preproc_else_token1] = ACTIONS(4845),
    [aux_sym_preproc_elif_token1] = ACTIONS(4838),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4845),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4845),
    [anon_sym_LPAREN2] = ACTIONS(4845),
    [anon_sym_DASH] = ACTIONS(4838),
    [anon_sym_PLUS] = ACTIONS(4838),
    [anon_sym_STAR] = ACTIONS(4838),
    [anon_sym_SLASH] = ACTIONS(4838),
    [anon_sym_PERCENT] = ACTIONS(4838),
    [anon_sym_PIPE_PIPE] = ACTIONS(4845),
    [anon_sym_AMP_AMP] = ACTIONS(4845),
    [anon_sym_PIPE] = ACTIONS(4838),
    [anon_sym_CARET] = ACTIONS(4838),
    [anon_sym_AMP] = ACTIONS(4838),
    [anon_sym_EQ_EQ] = ACTIONS(4845),
    [anon_sym_BANG_EQ] = ACTIONS(4845),
    [anon_sym_GT] = ACTIONS(4838),
    [anon_sym_GT_EQ] = ACTIONS(4845),
    [anon_sym_LT_EQ] = ACTIONS(4838),
    [anon_sym_LT] = ACTIONS(5724),
    [anon_sym_LT_LT] = ACTIONS(4838),
    [anon_sym_GT_GT] = ACTIONS(4838),
    [anon_sym_SEMI] = ACTIONS(4845),
    [anon_sym___attribute__] = ACTIONS(4838),
    [anon_sym___attribute] = ACTIONS(4838),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACE] = ACTIONS(4845),
    [anon_sym_RBRACE] = ACTIONS(4845),
    [anon_sym_LBRACK] = ACTIONS(4845),
    [anon_sym_RBRACK] = ACTIONS(4845),
    [anon_sym_EQ] = ACTIONS(4838),
    [anon_sym_COLON] = ACTIONS(4838),
    [anon_sym_QMARK] = ACTIONS(4845),
    [anon_sym_STAR_EQ] = ACTIONS(4845),
    [anon_sym_SLASH_EQ] = ACTIONS(4845),
    [anon_sym_PERCENT_EQ] = ACTIONS(4845),
    [anon_sym_PLUS_EQ] = ACTIONS(4845),
    [anon_sym_DASH_EQ] = ACTIONS(4845),
    [anon_sym_LT_LT_EQ] = ACTIONS(4845),
    [anon_sym_GT_GT_EQ] = ACTIONS(4845),
    [anon_sym_AMP_EQ] = ACTIONS(4845),
    [anon_sym_CARET_EQ] = ACTIONS(4845),
    [anon_sym_PIPE_EQ] = ACTIONS(4845),
    [anon_sym_and_eq] = ACTIONS(4838),
    [anon_sym_or_eq] = ACTIONS(4838),
    [anon_sym_xor_eq] = ACTIONS(4838),
    [anon_sym_LT_EQ_GT] = ACTIONS(4845),
    [anon_sym_or] = ACTIONS(4838),
    [anon_sym_and] = ACTIONS(4838),
    [anon_sym_bitor] = ACTIONS(4838),
    [anon_sym_xor] = ACTIONS(4838),
    [anon_sym_bitand] = ACTIONS(4838),
    [anon_sym_not_eq] = ACTIONS(4838),
    [anon_sym_DASH_DASH] = ACTIONS(4845),
    [anon_sym_PLUS_PLUS] = ACTIONS(4845),
    [anon_sym_DOT] = ACTIONS(4838),
    [anon_sym_DOT_STAR] = ACTIONS(4845),
    [anon_sym_DASH_GT] = ACTIONS(4845),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4838),
    [anon_sym_decltype] = ACTIONS(4838),
    [anon_sym_final] = ACTIONS(4838),
    [anon_sym_override] = ACTIONS(4838),
  },
  [1860] = {
    [sym_identifier] = ACTIONS(5431),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5433),
    [anon_sym_COMMA] = ACTIONS(5433),
    [anon_sym_RPAREN] = ACTIONS(5433),
    [aux_sym_preproc_if_token2] = ACTIONS(5433),
    [aux_sym_preproc_else_token1] = ACTIONS(5433),
    [aux_sym_preproc_elif_token1] = ACTIONS(5431),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5433),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5433),
    [anon_sym_LPAREN2] = ACTIONS(5433),
    [anon_sym_DASH] = ACTIONS(5431),
    [anon_sym_PLUS] = ACTIONS(5431),
    [anon_sym_STAR] = ACTIONS(5433),
    [anon_sym_SLASH] = ACTIONS(5431),
    [anon_sym_PERCENT] = ACTIONS(5433),
    [anon_sym_PIPE_PIPE] = ACTIONS(5433),
    [anon_sym_AMP_AMP] = ACTIONS(5433),
    [anon_sym_PIPE] = ACTIONS(5431),
    [anon_sym_CARET] = ACTIONS(5433),
    [anon_sym_AMP] = ACTIONS(5431),
    [anon_sym_EQ_EQ] = ACTIONS(5433),
    [anon_sym_BANG_EQ] = ACTIONS(5433),
    [anon_sym_GT] = ACTIONS(5431),
    [anon_sym_GT_EQ] = ACTIONS(5433),
    [anon_sym_LT_EQ] = ACTIONS(5431),
    [anon_sym_LT] = ACTIONS(5431),
    [anon_sym_LT_LT] = ACTIONS(5433),
    [anon_sym_GT_GT] = ACTIONS(5433),
    [anon_sym_SEMI] = ACTIONS(5433),
    [anon_sym___extension__] = ACTIONS(5431),
    [anon_sym___attribute__] = ACTIONS(5431),
    [anon_sym___attribute] = ACTIONS(5431),
    [anon_sym_LBRACE] = ACTIONS(5433),
    [anon_sym_RBRACE] = ACTIONS(5433),
    [anon_sym_LBRACK] = ACTIONS(5433),
    [anon_sym_RBRACK] = ACTIONS(5433),
    [anon_sym_const] = ACTIONS(5431),
    [anon_sym_constexpr] = ACTIONS(5431),
    [anon_sym_volatile] = ACTIONS(5431),
    [anon_sym_restrict] = ACTIONS(5431),
    [anon_sym___restrict__] = ACTIONS(5431),
    [anon_sym__Atomic] = ACTIONS(5431),
    [anon_sym__Noreturn] = ACTIONS(5431),
    [anon_sym_noreturn] = ACTIONS(5431),
    [anon_sym__Nonnull] = ACTIONS(5431),
    [anon_sym_mutable] = ACTIONS(5431),
    [anon_sym_constinit] = ACTIONS(5431),
    [anon_sym_consteval] = ACTIONS(5431),
    [anon_sym_alignas] = ACTIONS(5431),
    [anon_sym__Alignas] = ACTIONS(5431),
    [anon_sym_COLON] = ACTIONS(5433),
    [anon_sym_QMARK] = ACTIONS(5433),
    [anon_sym_LT_EQ_GT] = ACTIONS(5433),
    [anon_sym_or] = ACTIONS(5431),
    [anon_sym_and] = ACTIONS(5431),
    [anon_sym_bitor] = ACTIONS(5431),
    [anon_sym_xor] = ACTIONS(5431),
    [anon_sym_bitand] = ACTIONS(5431),
    [anon_sym_not_eq] = ACTIONS(5431),
    [anon_sym_DASH_DASH] = ACTIONS(5433),
    [anon_sym_PLUS_PLUS] = ACTIONS(5433),
    [anon_sym_DOT] = ACTIONS(5431),
    [anon_sym_DOT_STAR] = ACTIONS(5433),
    [anon_sym_DASH_GT] = ACTIONS(5433),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5431),
    [anon_sym_decltype] = ACTIONS(5431),
    [anon_sym_final] = ACTIONS(5431),
    [anon_sym_override] = ACTIONS(5431),
    [anon_sym_requires] = ACTIONS(5431),
  },
  [1861] = {
    [sym_template_argument_list] = STATE(1879),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4840),
    [anon_sym_RPAREN] = ACTIONS(4842),
    [anon_sym_LPAREN2] = ACTIONS(4842),
    [anon_sym_DASH] = ACTIONS(4847),
    [anon_sym_PLUS] = ACTIONS(4847),
    [anon_sym_STAR] = ACTIONS(4849),
    [anon_sym_SLASH] = ACTIONS(4847),
    [anon_sym_PERCENT] = ACTIONS(4847),
    [anon_sym_PIPE_PIPE] = ACTIONS(4840),
    [anon_sym_AMP_AMP] = ACTIONS(4842),
    [anon_sym_PIPE] = ACTIONS(4847),
    [anon_sym_CARET] = ACTIONS(4847),
    [anon_sym_AMP] = ACTIONS(4849),
    [anon_sym_EQ_EQ] = ACTIONS(4840),
    [anon_sym_BANG_EQ] = ACTIONS(4840),
    [anon_sym_GT] = ACTIONS(4847),
    [anon_sym_GT_EQ] = ACTIONS(4840),
    [anon_sym_LT_EQ] = ACTIONS(4847),
    [anon_sym_LT] = ACTIONS(5727),
    [anon_sym_LT_LT] = ACTIONS(4847),
    [anon_sym_GT_GT] = ACTIONS(4847),
    [anon_sym___extension__] = ACTIONS(4845),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACE] = ACTIONS(4845),
    [anon_sym_LBRACK] = ACTIONS(4842),
    [anon_sym_EQ] = ACTIONS(4847),
    [anon_sym_const] = ACTIONS(4838),
    [anon_sym_constexpr] = ACTIONS(4845),
    [anon_sym_volatile] = ACTIONS(4845),
    [anon_sym_restrict] = ACTIONS(4845),
    [anon_sym___restrict__] = ACTIONS(4845),
    [anon_sym__Atomic] = ACTIONS(4845),
    [anon_sym__Noreturn] = ACTIONS(4845),
    [anon_sym_noreturn] = ACTIONS(4845),
    [anon_sym__Nonnull] = ACTIONS(4845),
    [anon_sym_mutable] = ACTIONS(4845),
    [anon_sym_constinit] = ACTIONS(4845),
    [anon_sym_consteval] = ACTIONS(4845),
    [anon_sym_alignas] = ACTIONS(4845),
    [anon_sym__Alignas] = ACTIONS(4845),
    [anon_sym_QMARK] = ACTIONS(4840),
    [anon_sym_STAR_EQ] = ACTIONS(4840),
    [anon_sym_SLASH_EQ] = ACTIONS(4840),
    [anon_sym_PERCENT_EQ] = ACTIONS(4840),
    [anon_sym_PLUS_EQ] = ACTIONS(4840),
    [anon_sym_DASH_EQ] = ACTIONS(4840),
    [anon_sym_LT_LT_EQ] = ACTIONS(4840),
    [anon_sym_GT_GT_EQ] = ACTIONS(4840),
    [anon_sym_AMP_EQ] = ACTIONS(4840),
    [anon_sym_CARET_EQ] = ACTIONS(4840),
    [anon_sym_PIPE_EQ] = ACTIONS(4840),
    [anon_sym_and_eq] = ACTIONS(4840),
    [anon_sym_or_eq] = ACTIONS(4840),
    [anon_sym_xor_eq] = ACTIONS(4840),
    [anon_sym_LT_EQ_GT] = ACTIONS(4840),
    [anon_sym_or] = ACTIONS(4847),
    [anon_sym_and] = ACTIONS(4847),
    [anon_sym_bitor] = ACTIONS(4840),
    [anon_sym_xor] = ACTIONS(4847),
    [anon_sym_bitand] = ACTIONS(4840),
    [anon_sym_not_eq] = ACTIONS(4840),
    [anon_sym_DASH_DASH] = ACTIONS(4840),
    [anon_sym_PLUS_PLUS] = ACTIONS(4840),
    [anon_sym_DOT] = ACTIONS(4847),
    [anon_sym_DOT_STAR] = ACTIONS(4840),
    [anon_sym_DASH_GT] = ACTIONS(4840),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4845),
    [anon_sym_decltype] = ACTIONS(4845),
  },
  [1862] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4859),
    [anon_sym_COMMA] = ACTIONS(4859),
    [anon_sym_LPAREN2] = ACTIONS(4859),
    [anon_sym_DASH] = ACTIONS(4864),
    [anon_sym_PLUS] = ACTIONS(4864),
    [anon_sym_STAR] = ACTIONS(4866),
    [anon_sym_SLASH] = ACTIONS(4864),
    [anon_sym_PERCENT] = ACTIONS(4864),
    [anon_sym_PIPE_PIPE] = ACTIONS(4857),
    [anon_sym_AMP_AMP] = ACTIONS(4859),
    [anon_sym_PIPE] = ACTIONS(4864),
    [anon_sym_CARET] = ACTIONS(4864),
    [anon_sym_AMP] = ACTIONS(4866),
    [anon_sym_EQ_EQ] = ACTIONS(4857),
    [anon_sym_BANG_EQ] = ACTIONS(4857),
    [anon_sym_GT] = ACTIONS(4864),
    [anon_sym_GT_EQ] = ACTIONS(4864),
    [anon_sym_LT_EQ] = ACTIONS(4864),
    [anon_sym_LT] = ACTIONS(4864),
    [anon_sym_LT_LT] = ACTIONS(4864),
    [anon_sym_GT_GT] = ACTIONS(4864),
    [anon_sym___extension__] = ACTIONS(4862),
    [anon_sym_COLON_COLON] = ACTIONS(4862),
    [anon_sym_LBRACE] = ACTIONS(4862),
    [anon_sym_LBRACK] = ACTIONS(4859),
    [anon_sym_EQ] = ACTIONS(4864),
    [anon_sym_const] = ACTIONS(4855),
    [anon_sym_constexpr] = ACTIONS(4862),
    [anon_sym_volatile] = ACTIONS(4862),
    [anon_sym_restrict] = ACTIONS(4862),
    [anon_sym___restrict__] = ACTIONS(4862),
    [anon_sym__Atomic] = ACTIONS(4862),
    [anon_sym__Noreturn] = ACTIONS(4862),
    [anon_sym_noreturn] = ACTIONS(4862),
    [anon_sym__Nonnull] = ACTIONS(4862),
    [anon_sym_mutable] = ACTIONS(4862),
    [anon_sym_constinit] = ACTIONS(4862),
    [anon_sym_consteval] = ACTIONS(4862),
    [anon_sym_alignas] = ACTIONS(4862),
    [anon_sym__Alignas] = ACTIONS(4862),
    [anon_sym_QMARK] = ACTIONS(4857),
    [anon_sym_STAR_EQ] = ACTIONS(4857),
    [anon_sym_SLASH_EQ] = ACTIONS(4857),
    [anon_sym_PERCENT_EQ] = ACTIONS(4857),
    [anon_sym_PLUS_EQ] = ACTIONS(4857),
    [anon_sym_DASH_EQ] = ACTIONS(4857),
    [anon_sym_LT_LT_EQ] = ACTIONS(4857),
    [anon_sym_GT_GT_EQ] = ACTIONS(4864),
    [anon_sym_AMP_EQ] = ACTIONS(4857),
    [anon_sym_CARET_EQ] = ACTIONS(4857),
    [anon_sym_PIPE_EQ] = ACTIONS(4857),
    [anon_sym_and_eq] = ACTIONS(4857),
    [anon_sym_or_eq] = ACTIONS(4857),
    [anon_sym_xor_eq] = ACTIONS(4857),
    [anon_sym_LT_EQ_GT] = ACTIONS(4857),
    [anon_sym_or] = ACTIONS(4864),
    [anon_sym_and] = ACTIONS(4864),
    [anon_sym_bitor] = ACTIONS(4857),
    [anon_sym_xor] = ACTIONS(4864),
    [anon_sym_bitand] = ACTIONS(4857),
    [anon_sym_not_eq] = ACTIONS(4857),
    [anon_sym_DASH_DASH] = ACTIONS(4857),
    [anon_sym_PLUS_PLUS] = ACTIONS(4857),
    [anon_sym_DOT] = ACTIONS(4864),
    [anon_sym_DOT_STAR] = ACTIONS(4857),
    [anon_sym_DASH_GT] = ACTIONS(4857),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4862),
    [anon_sym_decltype] = ACTIONS(4862),
    [anon_sym_GT2] = ACTIONS(4859),
  },
  [1863] = {
    [sym_ms_based_modifier] = STATE(7915),
    [sym_ms_unaligned_ptr_modifier] = STATE(3998),
    [sym_ms_pointer_modifier] = STATE(1854),
    [sym__declarator] = STATE(6269),
    [sym__abstract_declarator] = STATE(6472),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_abstract_parenthesized_declarator] = STATE(5942),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_abstract_pointer_declarator] = STATE(5942),
    [sym_function_declarator] = STATE(5896),
    [sym_abstract_function_declarator] = STATE(5942),
    [sym_array_declarator] = STATE(5896),
    [sym_abstract_array_declarator] = STATE(5942),
    [sym_type_qualifier] = STATE(2518),
    [sym_alignas_qualifier] = STATE(4266),
    [sym_parameter_list] = STATE(3005),
    [sym_decltype] = STATE(8512),
    [sym_reference_declarator] = STATE(5896),
    [sym_abstract_reference_declarator] = STATE(5942),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym__function_declarator_seq] = STATE(5919),
    [sym_template_type] = STATE(8512),
    [sym_template_function] = STATE(5896),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5765),
    [sym_qualified_identifier] = STATE(5896),
    [sym_operator_name] = STATE(5896),
    [aux_sym__type_definition_type_repeat1] = STATE(2518),
    [aux_sym_pointer_declarator_repeat1] = STATE(1854),
    [sym_identifier] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5730),
    [anon_sym_RPAREN] = ACTIONS(5730),
    [anon_sym_LPAREN2] = ACTIONS(4157),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(5700),
    [anon_sym_AMP_AMP] = ACTIONS(5702),
    [anon_sym_AMP] = ACTIONS(5704),
    [anon_sym___extension__] = ACTIONS(3270),
    [anon_sym___attribute__] = ACTIONS(5732),
    [anon_sym___attribute] = ACTIONS(5732),
    [anon_sym_COLON_COLON] = ACTIONS(5708),
    [anon_sym___based] = ACTIONS(51),
    [sym_ms_restrict_modifier] = ACTIONS(3266),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(3266),
    [sym_ms_signed_ptr_modifier] = ACTIONS(3266),
    [anon_sym__unaligned] = ACTIONS(3268),
    [anon_sym___unaligned] = ACTIONS(3268),
    [anon_sym_LBRACK] = ACTIONS(5710),
    [anon_sym_EQ] = ACTIONS(5730),
    [anon_sym_const] = ACTIONS(3270),
    [anon_sym_constexpr] = ACTIONS(3270),
    [anon_sym_volatile] = ACTIONS(3270),
    [anon_sym_restrict] = ACTIONS(3270),
    [anon_sym___restrict__] = ACTIONS(3270),
    [anon_sym__Atomic] = ACTIONS(3270),
    [anon_sym__Noreturn] = ACTIONS(3270),
    [anon_sym_noreturn] = ACTIONS(3270),
    [anon_sym__Nonnull] = ACTIONS(3270),
    [anon_sym_mutable] = ACTIONS(3270),
    [anon_sym_constinit] = ACTIONS(3270),
    [anon_sym_consteval] = ACTIONS(3270),
    [anon_sym_alignas] = ACTIONS(3272),
    [anon_sym__Alignas] = ACTIONS(3272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_GT2] = ACTIONS(5730),
    [anon_sym_operator] = ACTIONS(1823),
  },
  [1864] = {
    [sym_argument_list] = STATE(2393),
    [sym_initializer_list] = STATE(2393),
    [sym_decltype_auto] = STATE(2183),
    [sym_new_declarator] = STATE(2190),
    [sym_identifier] = ACTIONS(5734),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5736),
    [anon_sym_COMMA] = ACTIONS(5736),
    [anon_sym_RPAREN] = ACTIONS(5736),
    [aux_sym_preproc_if_token2] = ACTIONS(5736),
    [aux_sym_preproc_else_token1] = ACTIONS(5736),
    [aux_sym_preproc_elif_token1] = ACTIONS(5734),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5736),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5736),
    [anon_sym_LPAREN2] = ACTIONS(5688),
    [anon_sym_DASH] = ACTIONS(5734),
    [anon_sym_PLUS] = ACTIONS(5734),
    [anon_sym_STAR] = ACTIONS(5734),
    [anon_sym_SLASH] = ACTIONS(5734),
    [anon_sym_PERCENT] = ACTIONS(5734),
    [anon_sym_PIPE_PIPE] = ACTIONS(5736),
    [anon_sym_AMP_AMP] = ACTIONS(5736),
    [anon_sym_PIPE] = ACTIONS(5734),
    [anon_sym_CARET] = ACTIONS(5734),
    [anon_sym_AMP] = ACTIONS(5734),
    [anon_sym_EQ_EQ] = ACTIONS(5736),
    [anon_sym_BANG_EQ] = ACTIONS(5736),
    [anon_sym_GT] = ACTIONS(5734),
    [anon_sym_GT_EQ] = ACTIONS(5736),
    [anon_sym_LT_EQ] = ACTIONS(5734),
    [anon_sym_LT] = ACTIONS(5734),
    [anon_sym_LT_LT] = ACTIONS(5734),
    [anon_sym_GT_GT] = ACTIONS(5734),
    [anon_sym_SEMI] = ACTIONS(5736),
    [anon_sym___attribute__] = ACTIONS(5734),
    [anon_sym___attribute] = ACTIONS(5734),
    [anon_sym_LBRACE] = ACTIONS(1927),
    [anon_sym_RBRACE] = ACTIONS(5736),
    [anon_sym_LBRACK] = ACTIONS(5690),
    [anon_sym_RBRACK] = ACTIONS(5736),
    [anon_sym_EQ] = ACTIONS(5734),
    [anon_sym_COLON] = ACTIONS(5736),
    [anon_sym_QMARK] = ACTIONS(5736),
    [anon_sym_STAR_EQ] = ACTIONS(5736),
    [anon_sym_SLASH_EQ] = ACTIONS(5736),
    [anon_sym_PERCENT_EQ] = ACTIONS(5736),
    [anon_sym_PLUS_EQ] = ACTIONS(5736),
    [anon_sym_DASH_EQ] = ACTIONS(5736),
    [anon_sym_LT_LT_EQ] = ACTIONS(5736),
    [anon_sym_GT_GT_EQ] = ACTIONS(5736),
    [anon_sym_AMP_EQ] = ACTIONS(5736),
    [anon_sym_CARET_EQ] = ACTIONS(5736),
    [anon_sym_PIPE_EQ] = ACTIONS(5736),
    [anon_sym_and_eq] = ACTIONS(5734),
    [anon_sym_or_eq] = ACTIONS(5734),
    [anon_sym_xor_eq] = ACTIONS(5734),
    [anon_sym_LT_EQ_GT] = ACTIONS(5736),
    [anon_sym_or] = ACTIONS(5734),
    [anon_sym_and] = ACTIONS(5734),
    [anon_sym_bitor] = ACTIONS(5734),
    [anon_sym_xor] = ACTIONS(5734),
    [anon_sym_bitand] = ACTIONS(5734),
    [anon_sym_not_eq] = ACTIONS(5734),
    [anon_sym_DASH_DASH] = ACTIONS(5736),
    [anon_sym_PLUS_PLUS] = ACTIONS(5736),
    [anon_sym_DOT] = ACTIONS(5734),
    [anon_sym_DOT_STAR] = ACTIONS(5736),
    [anon_sym_DASH_GT] = ACTIONS(5736),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5692),
    [anon_sym_decltype] = ACTIONS(5694),
  },
  [1865] = {
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(4740),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(2033),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2336),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(6493),
    [sym_qualified_type_identifier] = STATE(2978),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(5025),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5027),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
  },
  [1866] = {
    [sym_identifier] = ACTIONS(1913),
    [aux_sym_preproc_def_token1] = ACTIONS(1913),
    [anon_sym_COMMA] = ACTIONS(2721),
    [aux_sym_preproc_if_token1] = ACTIONS(1913),
    [aux_sym_preproc_if_token2] = ACTIONS(1913),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1913),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1913),
    [sym_preproc_directive] = ACTIONS(1913),
    [anon_sym_LPAREN2] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_AMP_AMP] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1913),
    [anon_sym_SEMI] = ACTIONS(2721),
    [anon_sym___extension__] = ACTIONS(1913),
    [anon_sym_typedef] = ACTIONS(1913),
    [anon_sym_virtual] = ACTIONS(1913),
    [anon_sym_extern] = ACTIONS(1913),
    [anon_sym___attribute__] = ACTIONS(1913),
    [anon_sym___attribute] = ACTIONS(1913),
    [anon_sym_COLON_COLON] = ACTIONS(1911),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1911),
    [anon_sym___declspec] = ACTIONS(1913),
    [anon_sym___based] = ACTIONS(1913),
    [anon_sym_signed] = ACTIONS(1913),
    [anon_sym_unsigned] = ACTIONS(1913),
    [anon_sym_long] = ACTIONS(1913),
    [anon_sym_short] = ACTIONS(1913),
    [anon_sym_LBRACK] = ACTIONS(1913),
    [anon_sym_static] = ACTIONS(1913),
    [anon_sym_register] = ACTIONS(1913),
    [anon_sym_inline] = ACTIONS(1913),
    [anon_sym___inline] = ACTIONS(1913),
    [anon_sym___inline__] = ACTIONS(1913),
    [anon_sym___forceinline] = ACTIONS(1913),
    [anon_sym_thread_local] = ACTIONS(1913),
    [anon_sym___thread] = ACTIONS(1913),
    [anon_sym_const] = ACTIONS(1913),
    [anon_sym_constexpr] = ACTIONS(1913),
    [anon_sym_volatile] = ACTIONS(1913),
    [anon_sym_restrict] = ACTIONS(1913),
    [anon_sym___restrict__] = ACTIONS(1913),
    [anon_sym__Atomic] = ACTIONS(1913),
    [anon_sym__Noreturn] = ACTIONS(1913),
    [anon_sym_noreturn] = ACTIONS(1913),
    [anon_sym__Nonnull] = ACTIONS(1913),
    [anon_sym_mutable] = ACTIONS(1913),
    [anon_sym_constinit] = ACTIONS(1913),
    [anon_sym_consteval] = ACTIONS(1913),
    [anon_sym_alignas] = ACTIONS(1913),
    [anon_sym__Alignas] = ACTIONS(1913),
    [sym_primitive_type] = ACTIONS(1913),
    [anon_sym_enum] = ACTIONS(1913),
    [anon_sym_class] = ACTIONS(1913),
    [anon_sym_struct] = ACTIONS(1913),
    [anon_sym_union] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1913),
    [anon_sym_decltype] = ACTIONS(1913),
    [anon_sym_explicit] = ACTIONS(1913),
    [anon_sym_typename] = ACTIONS(1913),
    [anon_sym_template] = ACTIONS(1913),
    [anon_sym_operator] = ACTIONS(1913),
    [anon_sym_friend] = ACTIONS(1913),
    [anon_sym_public] = ACTIONS(1913),
    [anon_sym_private] = ACTIONS(1913),
    [anon_sym_protected] = ACTIONS(1913),
    [anon_sym_using] = ACTIONS(1913),
    [anon_sym_static_assert] = ACTIONS(1913),
  },
  [1867] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1870),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5738),
    [anon_sym_COMMA] = ACTIONS(5738),
    [anon_sym_RPAREN] = ACTIONS(5738),
    [anon_sym_LPAREN2] = ACTIONS(5738),
    [anon_sym_DASH] = ACTIONS(5740),
    [anon_sym_PLUS] = ACTIONS(5740),
    [anon_sym_STAR] = ACTIONS(5738),
    [anon_sym_SLASH] = ACTIONS(5740),
    [anon_sym_PERCENT] = ACTIONS(5738),
    [anon_sym_PIPE_PIPE] = ACTIONS(5738),
    [anon_sym_AMP_AMP] = ACTIONS(5738),
    [anon_sym_PIPE] = ACTIONS(5740),
    [anon_sym_CARET] = ACTIONS(5738),
    [anon_sym_AMP] = ACTIONS(5740),
    [anon_sym_EQ_EQ] = ACTIONS(5738),
    [anon_sym_BANG_EQ] = ACTIONS(5738),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5738),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_LT_LT] = ACTIONS(5738),
    [anon_sym_GT_GT] = ACTIONS(5738),
    [anon_sym_SEMI] = ACTIONS(5738),
    [anon_sym___extension__] = ACTIONS(5738),
    [anon_sym___attribute__] = ACTIONS(5738),
    [anon_sym___attribute] = ACTIONS(5740),
    [anon_sym_LBRACE] = ACTIONS(5738),
    [anon_sym_RBRACE] = ACTIONS(5738),
    [anon_sym_signed] = ACTIONS(5742),
    [anon_sym_unsigned] = ACTIONS(5742),
    [anon_sym_long] = ACTIONS(5742),
    [anon_sym_short] = ACTIONS(5742),
    [anon_sym_LBRACK] = ACTIONS(5738),
    [anon_sym_RBRACK] = ACTIONS(5738),
    [anon_sym_const] = ACTIONS(5740),
    [anon_sym_constexpr] = ACTIONS(5738),
    [anon_sym_volatile] = ACTIONS(5738),
    [anon_sym_restrict] = ACTIONS(5738),
    [anon_sym___restrict__] = ACTIONS(5738),
    [anon_sym__Atomic] = ACTIONS(5738),
    [anon_sym__Noreturn] = ACTIONS(5738),
    [anon_sym_noreturn] = ACTIONS(5738),
    [anon_sym__Nonnull] = ACTIONS(5738),
    [anon_sym_mutable] = ACTIONS(5738),
    [anon_sym_constinit] = ACTIONS(5738),
    [anon_sym_consteval] = ACTIONS(5738),
    [anon_sym_alignas] = ACTIONS(5738),
    [anon_sym__Alignas] = ACTIONS(5738),
    [anon_sym_COLON] = ACTIONS(5738),
    [anon_sym_QMARK] = ACTIONS(5738),
    [anon_sym_LT_EQ_GT] = ACTIONS(5738),
    [anon_sym_or] = ACTIONS(5738),
    [anon_sym_and] = ACTIONS(5738),
    [anon_sym_bitor] = ACTIONS(5738),
    [anon_sym_xor] = ACTIONS(5738),
    [anon_sym_bitand] = ACTIONS(5738),
    [anon_sym_not_eq] = ACTIONS(5738),
    [anon_sym_DASH_DASH] = ACTIONS(5738),
    [anon_sym_PLUS_PLUS] = ACTIONS(5738),
    [anon_sym_DOT] = ACTIONS(5740),
    [anon_sym_DOT_STAR] = ACTIONS(5738),
    [anon_sym_DASH_GT] = ACTIONS(5738),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5738),
    [anon_sym_decltype] = ACTIONS(5738),
    [anon_sym_final] = ACTIONS(5738),
    [anon_sym_override] = ACTIONS(5738),
    [anon_sym_requires] = ACTIONS(5738),
  },
  [1868] = {
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(4768),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(2033),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2336),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(6493),
    [sym_qualified_type_identifier] = STATE(2978),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(5025),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5027),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
  },
  [1869] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1887),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5744),
    [anon_sym_COMMA] = ACTIONS(5744),
    [anon_sym_RPAREN] = ACTIONS(5744),
    [anon_sym_LPAREN2] = ACTIONS(5744),
    [anon_sym_DASH] = ACTIONS(5746),
    [anon_sym_PLUS] = ACTIONS(5746),
    [anon_sym_STAR] = ACTIONS(5744),
    [anon_sym_SLASH] = ACTIONS(5746),
    [anon_sym_PERCENT] = ACTIONS(5744),
    [anon_sym_PIPE_PIPE] = ACTIONS(5744),
    [anon_sym_AMP_AMP] = ACTIONS(5744),
    [anon_sym_PIPE] = ACTIONS(5746),
    [anon_sym_CARET] = ACTIONS(5744),
    [anon_sym_AMP] = ACTIONS(5746),
    [anon_sym_EQ_EQ] = ACTIONS(5744),
    [anon_sym_BANG_EQ] = ACTIONS(5744),
    [anon_sym_GT] = ACTIONS(5746),
    [anon_sym_GT_EQ] = ACTIONS(5744),
    [anon_sym_LT_EQ] = ACTIONS(5746),
    [anon_sym_LT] = ACTIONS(5746),
    [anon_sym_LT_LT] = ACTIONS(5744),
    [anon_sym_GT_GT] = ACTIONS(5744),
    [anon_sym_SEMI] = ACTIONS(5744),
    [anon_sym___extension__] = ACTIONS(5744),
    [anon_sym___attribute__] = ACTIONS(5744),
    [anon_sym___attribute] = ACTIONS(5746),
    [anon_sym_LBRACE] = ACTIONS(5744),
    [anon_sym_RBRACE] = ACTIONS(5744),
    [anon_sym_signed] = ACTIONS(5748),
    [anon_sym_unsigned] = ACTIONS(5748),
    [anon_sym_long] = ACTIONS(5748),
    [anon_sym_short] = ACTIONS(5748),
    [anon_sym_LBRACK] = ACTIONS(5744),
    [anon_sym_RBRACK] = ACTIONS(5744),
    [anon_sym_const] = ACTIONS(5746),
    [anon_sym_constexpr] = ACTIONS(5744),
    [anon_sym_volatile] = ACTIONS(5744),
    [anon_sym_restrict] = ACTIONS(5744),
    [anon_sym___restrict__] = ACTIONS(5744),
    [anon_sym__Atomic] = ACTIONS(5744),
    [anon_sym__Noreturn] = ACTIONS(5744),
    [anon_sym_noreturn] = ACTIONS(5744),
    [anon_sym__Nonnull] = ACTIONS(5744),
    [anon_sym_mutable] = ACTIONS(5744),
    [anon_sym_constinit] = ACTIONS(5744),
    [anon_sym_consteval] = ACTIONS(5744),
    [anon_sym_alignas] = ACTIONS(5744),
    [anon_sym__Alignas] = ACTIONS(5744),
    [anon_sym_COLON] = ACTIONS(5744),
    [anon_sym_QMARK] = ACTIONS(5744),
    [anon_sym_LT_EQ_GT] = ACTIONS(5744),
    [anon_sym_or] = ACTIONS(5744),
    [anon_sym_and] = ACTIONS(5744),
    [anon_sym_bitor] = ACTIONS(5744),
    [anon_sym_xor] = ACTIONS(5744),
    [anon_sym_bitand] = ACTIONS(5744),
    [anon_sym_not_eq] = ACTIONS(5744),
    [anon_sym_DASH_DASH] = ACTIONS(5744),
    [anon_sym_PLUS_PLUS] = ACTIONS(5744),
    [anon_sym_DOT] = ACTIONS(5746),
    [anon_sym_DOT_STAR] = ACTIONS(5744),
    [anon_sym_DASH_GT] = ACTIONS(5744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5744),
    [anon_sym_decltype] = ACTIONS(5744),
    [anon_sym_final] = ACTIONS(5744),
    [anon_sym_override] = ACTIONS(5744),
    [anon_sym_requires] = ACTIONS(5744),
  },
  [1870] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5750),
    [anon_sym_COMMA] = ACTIONS(5750),
    [anon_sym_RPAREN] = ACTIONS(5750),
    [anon_sym_LPAREN2] = ACTIONS(5750),
    [anon_sym_DASH] = ACTIONS(5752),
    [anon_sym_PLUS] = ACTIONS(5752),
    [anon_sym_STAR] = ACTIONS(5750),
    [anon_sym_SLASH] = ACTIONS(5752),
    [anon_sym_PERCENT] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5750),
    [anon_sym_AMP_AMP] = ACTIONS(5750),
    [anon_sym_PIPE] = ACTIONS(5752),
    [anon_sym_CARET] = ACTIONS(5750),
    [anon_sym_AMP] = ACTIONS(5752),
    [anon_sym_EQ_EQ] = ACTIONS(5750),
    [anon_sym_BANG_EQ] = ACTIONS(5750),
    [anon_sym_GT] = ACTIONS(5752),
    [anon_sym_GT_EQ] = ACTIONS(5750),
    [anon_sym_LT_EQ] = ACTIONS(5752),
    [anon_sym_LT] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5750),
    [anon_sym_GT_GT] = ACTIONS(5750),
    [anon_sym_SEMI] = ACTIONS(5750),
    [anon_sym___extension__] = ACTIONS(5750),
    [anon_sym___attribute__] = ACTIONS(5750),
    [anon_sym___attribute] = ACTIONS(5752),
    [anon_sym_LBRACE] = ACTIONS(5750),
    [anon_sym_RBRACE] = ACTIONS(5750),
    [anon_sym_signed] = ACTIONS(5754),
    [anon_sym_unsigned] = ACTIONS(5754),
    [anon_sym_long] = ACTIONS(5754),
    [anon_sym_short] = ACTIONS(5754),
    [anon_sym_LBRACK] = ACTIONS(5750),
    [anon_sym_RBRACK] = ACTIONS(5750),
    [anon_sym_const] = ACTIONS(5752),
    [anon_sym_constexpr] = ACTIONS(5750),
    [anon_sym_volatile] = ACTIONS(5750),
    [anon_sym_restrict] = ACTIONS(5750),
    [anon_sym___restrict__] = ACTIONS(5750),
    [anon_sym__Atomic] = ACTIONS(5750),
    [anon_sym__Noreturn] = ACTIONS(5750),
    [anon_sym_noreturn] = ACTIONS(5750),
    [anon_sym__Nonnull] = ACTIONS(5750),
    [anon_sym_mutable] = ACTIONS(5750),
    [anon_sym_constinit] = ACTIONS(5750),
    [anon_sym_consteval] = ACTIONS(5750),
    [anon_sym_alignas] = ACTIONS(5750),
    [anon_sym__Alignas] = ACTIONS(5750),
    [anon_sym_COLON] = ACTIONS(5750),
    [anon_sym_QMARK] = ACTIONS(5750),
    [anon_sym_LT_EQ_GT] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_bitor] = ACTIONS(5750),
    [anon_sym_xor] = ACTIONS(5750),
    [anon_sym_bitand] = ACTIONS(5750),
    [anon_sym_not_eq] = ACTIONS(5750),
    [anon_sym_DASH_DASH] = ACTIONS(5750),
    [anon_sym_PLUS_PLUS] = ACTIONS(5750),
    [anon_sym_DOT] = ACTIONS(5752),
    [anon_sym_DOT_STAR] = ACTIONS(5750),
    [anon_sym_DASH_GT] = ACTIONS(5750),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5750),
    [anon_sym_decltype] = ACTIONS(5750),
    [anon_sym_final] = ACTIONS(5750),
    [anon_sym_override] = ACTIONS(5750),
    [anon_sym_requires] = ACTIONS(5750),
  },
  [1871] = {
    [sym_identifier] = ACTIONS(2563),
    [aux_sym_preproc_def_token1] = ACTIONS(2563),
    [aux_sym_preproc_if_token1] = ACTIONS(2563),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2563),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2563),
    [sym_preproc_directive] = ACTIONS(2563),
    [anon_sym_LPAREN2] = ACTIONS(2565),
    [anon_sym_TILDE] = ACTIONS(2565),
    [anon_sym_STAR] = ACTIONS(2565),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_AMP] = ACTIONS(2563),
    [anon_sym_SEMI] = ACTIONS(2565),
    [anon_sym___extension__] = ACTIONS(2563),
    [anon_sym_typedef] = ACTIONS(2563),
    [anon_sym_virtual] = ACTIONS(2563),
    [anon_sym_extern] = ACTIONS(2563),
    [anon_sym___attribute__] = ACTIONS(2563),
    [anon_sym___attribute] = ACTIONS(2563),
    [anon_sym_COLON_COLON] = ACTIONS(2565),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2565),
    [anon_sym___declspec] = ACTIONS(2563),
    [anon_sym___based] = ACTIONS(2563),
    [anon_sym_RBRACE] = ACTIONS(2565),
    [anon_sym_signed] = ACTIONS(2563),
    [anon_sym_unsigned] = ACTIONS(2563),
    [anon_sym_long] = ACTIONS(2563),
    [anon_sym_short] = ACTIONS(2563),
    [anon_sym_LBRACK] = ACTIONS(2563),
    [anon_sym_static] = ACTIONS(2563),
    [anon_sym_register] = ACTIONS(2563),
    [anon_sym_inline] = ACTIONS(2563),
    [anon_sym___inline] = ACTIONS(2563),
    [anon_sym___inline__] = ACTIONS(2563),
    [anon_sym___forceinline] = ACTIONS(2563),
    [anon_sym_thread_local] = ACTIONS(2563),
    [anon_sym___thread] = ACTIONS(2563),
    [anon_sym_const] = ACTIONS(2563),
    [anon_sym_constexpr] = ACTIONS(2563),
    [anon_sym_volatile] = ACTIONS(2563),
    [anon_sym_restrict] = ACTIONS(2563),
    [anon_sym___restrict__] = ACTIONS(2563),
    [anon_sym__Atomic] = ACTIONS(2563),
    [anon_sym__Noreturn] = ACTIONS(2563),
    [anon_sym_noreturn] = ACTIONS(2563),
    [anon_sym__Nonnull] = ACTIONS(2563),
    [anon_sym_mutable] = ACTIONS(2563),
    [anon_sym_constinit] = ACTIONS(2563),
    [anon_sym_consteval] = ACTIONS(2563),
    [anon_sym_alignas] = ACTIONS(2563),
    [anon_sym__Alignas] = ACTIONS(2563),
    [sym_primitive_type] = ACTIONS(2563),
    [anon_sym_enum] = ACTIONS(2563),
    [anon_sym_class] = ACTIONS(2563),
    [anon_sym_struct] = ACTIONS(2563),
    [anon_sym_union] = ACTIONS(2563),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2563),
    [anon_sym_decltype] = ACTIONS(2563),
    [anon_sym_explicit] = ACTIONS(2563),
    [anon_sym_typename] = ACTIONS(2563),
    [anon_sym_template] = ACTIONS(2563),
    [anon_sym_operator] = ACTIONS(2563),
    [anon_sym_friend] = ACTIONS(2563),
    [anon_sym_public] = ACTIONS(2563),
    [anon_sym_private] = ACTIONS(2563),
    [anon_sym_protected] = ACTIONS(2563),
    [anon_sym_using] = ACTIONS(2563),
    [anon_sym_static_assert] = ACTIONS(2563),
    [anon_sym_catch] = ACTIONS(2563),
  },
  [1872] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5756),
    [anon_sym_COMMA] = ACTIONS(5756),
    [anon_sym_RPAREN] = ACTIONS(5756),
    [anon_sym_LPAREN2] = ACTIONS(5756),
    [anon_sym_DASH] = ACTIONS(5758),
    [anon_sym_PLUS] = ACTIONS(5758),
    [anon_sym_STAR] = ACTIONS(5756),
    [anon_sym_SLASH] = ACTIONS(5758),
    [anon_sym_PERCENT] = ACTIONS(5756),
    [anon_sym_PIPE_PIPE] = ACTIONS(5756),
    [anon_sym_AMP_AMP] = ACTIONS(5756),
    [anon_sym_PIPE] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5756),
    [anon_sym_AMP] = ACTIONS(5758),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5756),
    [anon_sym_GT] = ACTIONS(5758),
    [anon_sym_GT_EQ] = ACTIONS(5756),
    [anon_sym_LT_EQ] = ACTIONS(5758),
    [anon_sym_LT] = ACTIONS(5758),
    [anon_sym_LT_LT] = ACTIONS(5756),
    [anon_sym_GT_GT] = ACTIONS(5756),
    [anon_sym_SEMI] = ACTIONS(5756),
    [anon_sym___extension__] = ACTIONS(5756),
    [anon_sym___attribute__] = ACTIONS(5756),
    [anon_sym___attribute] = ACTIONS(5758),
    [anon_sym_LBRACE] = ACTIONS(5756),
    [anon_sym_RBRACE] = ACTIONS(5756),
    [anon_sym_signed] = ACTIONS(5754),
    [anon_sym_unsigned] = ACTIONS(5754),
    [anon_sym_long] = ACTIONS(5754),
    [anon_sym_short] = ACTIONS(5754),
    [anon_sym_LBRACK] = ACTIONS(5756),
    [anon_sym_RBRACK] = ACTIONS(5756),
    [anon_sym_const] = ACTIONS(5758),
    [anon_sym_constexpr] = ACTIONS(5756),
    [anon_sym_volatile] = ACTIONS(5756),
    [anon_sym_restrict] = ACTIONS(5756),
    [anon_sym___restrict__] = ACTIONS(5756),
    [anon_sym__Atomic] = ACTIONS(5756),
    [anon_sym__Noreturn] = ACTIONS(5756),
    [anon_sym_noreturn] = ACTIONS(5756),
    [anon_sym__Nonnull] = ACTIONS(5756),
    [anon_sym_mutable] = ACTIONS(5756),
    [anon_sym_constinit] = ACTIONS(5756),
    [anon_sym_consteval] = ACTIONS(5756),
    [anon_sym_alignas] = ACTIONS(5756),
    [anon_sym__Alignas] = ACTIONS(5756),
    [anon_sym_COLON] = ACTIONS(5756),
    [anon_sym_QMARK] = ACTIONS(5756),
    [anon_sym_LT_EQ_GT] = ACTIONS(5756),
    [anon_sym_or] = ACTIONS(5756),
    [anon_sym_and] = ACTIONS(5756),
    [anon_sym_bitor] = ACTIONS(5756),
    [anon_sym_xor] = ACTIONS(5756),
    [anon_sym_bitand] = ACTIONS(5756),
    [anon_sym_not_eq] = ACTIONS(5756),
    [anon_sym_DASH_DASH] = ACTIONS(5756),
    [anon_sym_PLUS_PLUS] = ACTIONS(5756),
    [anon_sym_DOT] = ACTIONS(5758),
    [anon_sym_DOT_STAR] = ACTIONS(5756),
    [anon_sym_DASH_GT] = ACTIONS(5756),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5756),
    [anon_sym_decltype] = ACTIONS(5756),
    [anon_sym_final] = ACTIONS(5756),
    [anon_sym_override] = ACTIONS(5756),
    [anon_sym_requires] = ACTIONS(5756),
  },
  [1873] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1872),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5760),
    [anon_sym_COMMA] = ACTIONS(5760),
    [anon_sym_RPAREN] = ACTIONS(5760),
    [anon_sym_LPAREN2] = ACTIONS(5760),
    [anon_sym_DASH] = ACTIONS(5762),
    [anon_sym_PLUS] = ACTIONS(5762),
    [anon_sym_STAR] = ACTIONS(5760),
    [anon_sym_SLASH] = ACTIONS(5762),
    [anon_sym_PERCENT] = ACTIONS(5760),
    [anon_sym_PIPE_PIPE] = ACTIONS(5760),
    [anon_sym_AMP_AMP] = ACTIONS(5760),
    [anon_sym_PIPE] = ACTIONS(5762),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_AMP] = ACTIONS(5762),
    [anon_sym_EQ_EQ] = ACTIONS(5760),
    [anon_sym_BANG_EQ] = ACTIONS(5760),
    [anon_sym_GT] = ACTIONS(5762),
    [anon_sym_GT_EQ] = ACTIONS(5760),
    [anon_sym_LT_EQ] = ACTIONS(5762),
    [anon_sym_LT] = ACTIONS(5762),
    [anon_sym_LT_LT] = ACTIONS(5760),
    [anon_sym_GT_GT] = ACTIONS(5760),
    [anon_sym_SEMI] = ACTIONS(5760),
    [anon_sym___extension__] = ACTIONS(5760),
    [anon_sym___attribute__] = ACTIONS(5760),
    [anon_sym___attribute] = ACTIONS(5762),
    [anon_sym_LBRACE] = ACTIONS(5760),
    [anon_sym_RBRACE] = ACTIONS(5760),
    [anon_sym_signed] = ACTIONS(5764),
    [anon_sym_unsigned] = ACTIONS(5764),
    [anon_sym_long] = ACTIONS(5764),
    [anon_sym_short] = ACTIONS(5764),
    [anon_sym_LBRACK] = ACTIONS(5760),
    [anon_sym_RBRACK] = ACTIONS(5760),
    [anon_sym_const] = ACTIONS(5762),
    [anon_sym_constexpr] = ACTIONS(5760),
    [anon_sym_volatile] = ACTIONS(5760),
    [anon_sym_restrict] = ACTIONS(5760),
    [anon_sym___restrict__] = ACTIONS(5760),
    [anon_sym__Atomic] = ACTIONS(5760),
    [anon_sym__Noreturn] = ACTIONS(5760),
    [anon_sym_noreturn] = ACTIONS(5760),
    [anon_sym__Nonnull] = ACTIONS(5760),
    [anon_sym_mutable] = ACTIONS(5760),
    [anon_sym_constinit] = ACTIONS(5760),
    [anon_sym_consteval] = ACTIONS(5760),
    [anon_sym_alignas] = ACTIONS(5760),
    [anon_sym__Alignas] = ACTIONS(5760),
    [anon_sym_COLON] = ACTIONS(5760),
    [anon_sym_QMARK] = ACTIONS(5760),
    [anon_sym_LT_EQ_GT] = ACTIONS(5760),
    [anon_sym_or] = ACTIONS(5760),
    [anon_sym_and] = ACTIONS(5760),
    [anon_sym_bitor] = ACTIONS(5760),
    [anon_sym_xor] = ACTIONS(5760),
    [anon_sym_bitand] = ACTIONS(5760),
    [anon_sym_not_eq] = ACTIONS(5760),
    [anon_sym_DASH_DASH] = ACTIONS(5760),
    [anon_sym_PLUS_PLUS] = ACTIONS(5760),
    [anon_sym_DOT] = ACTIONS(5762),
    [anon_sym_DOT_STAR] = ACTIONS(5760),
    [anon_sym_DASH_GT] = ACTIONS(5760),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5760),
    [anon_sym_decltype] = ACTIONS(5760),
    [anon_sym_final] = ACTIONS(5760),
    [anon_sym_override] = ACTIONS(5760),
    [anon_sym_requires] = ACTIONS(5760),
  },
  [1874] = {
    [sym_identifier] = ACTIONS(4855),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4862),
    [anon_sym_COMMA] = ACTIONS(4862),
    [anon_sym_RPAREN] = ACTIONS(4862),
    [aux_sym_preproc_if_token2] = ACTIONS(4862),
    [aux_sym_preproc_else_token1] = ACTIONS(4862),
    [aux_sym_preproc_elif_token1] = ACTIONS(4855),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4862),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4862),
    [anon_sym_LPAREN2] = ACTIONS(4862),
    [anon_sym_DASH] = ACTIONS(4855),
    [anon_sym_PLUS] = ACTIONS(4855),
    [anon_sym_STAR] = ACTIONS(4855),
    [anon_sym_SLASH] = ACTIONS(4855),
    [anon_sym_PERCENT] = ACTIONS(4855),
    [anon_sym_PIPE_PIPE] = ACTIONS(4862),
    [anon_sym_AMP_AMP] = ACTIONS(4862),
    [anon_sym_PIPE] = ACTIONS(4855),
    [anon_sym_CARET] = ACTIONS(4855),
    [anon_sym_AMP] = ACTIONS(4855),
    [anon_sym_EQ_EQ] = ACTIONS(4862),
    [anon_sym_BANG_EQ] = ACTIONS(4862),
    [anon_sym_GT] = ACTIONS(4855),
    [anon_sym_GT_EQ] = ACTIONS(4862),
    [anon_sym_LT_EQ] = ACTIONS(4855),
    [anon_sym_LT] = ACTIONS(4855),
    [anon_sym_LT_LT] = ACTIONS(4855),
    [anon_sym_GT_GT] = ACTIONS(4855),
    [anon_sym_SEMI] = ACTIONS(4862),
    [anon_sym___attribute__] = ACTIONS(4855),
    [anon_sym___attribute] = ACTIONS(4855),
    [anon_sym_COLON_COLON] = ACTIONS(4862),
    [anon_sym_LBRACE] = ACTIONS(4862),
    [anon_sym_RBRACE] = ACTIONS(4862),
    [anon_sym_LBRACK] = ACTIONS(4862),
    [anon_sym_RBRACK] = ACTIONS(4862),
    [anon_sym_EQ] = ACTIONS(4855),
    [anon_sym_COLON] = ACTIONS(4855),
    [anon_sym_QMARK] = ACTIONS(4862),
    [anon_sym_STAR_EQ] = ACTIONS(4862),
    [anon_sym_SLASH_EQ] = ACTIONS(4862),
    [anon_sym_PERCENT_EQ] = ACTIONS(4862),
    [anon_sym_PLUS_EQ] = ACTIONS(4862),
    [anon_sym_DASH_EQ] = ACTIONS(4862),
    [anon_sym_LT_LT_EQ] = ACTIONS(4862),
    [anon_sym_GT_GT_EQ] = ACTIONS(4862),
    [anon_sym_AMP_EQ] = ACTIONS(4862),
    [anon_sym_CARET_EQ] = ACTIONS(4862),
    [anon_sym_PIPE_EQ] = ACTIONS(4862),
    [anon_sym_and_eq] = ACTIONS(4855),
    [anon_sym_or_eq] = ACTIONS(4855),
    [anon_sym_xor_eq] = ACTIONS(4855),
    [anon_sym_LT_EQ_GT] = ACTIONS(4862),
    [anon_sym_or] = ACTIONS(4855),
    [anon_sym_and] = ACTIONS(4855),
    [anon_sym_bitor] = ACTIONS(4855),
    [anon_sym_xor] = ACTIONS(4855),
    [anon_sym_bitand] = ACTIONS(4855),
    [anon_sym_not_eq] = ACTIONS(4855),
    [anon_sym_DASH_DASH] = ACTIONS(4862),
    [anon_sym_PLUS_PLUS] = ACTIONS(4862),
    [anon_sym_DOT] = ACTIONS(4855),
    [anon_sym_DOT_STAR] = ACTIONS(4862),
    [anon_sym_DASH_GT] = ACTIONS(4862),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4855),
    [anon_sym_decltype] = ACTIONS(4855),
    [anon_sym_final] = ACTIONS(4855),
    [anon_sym_override] = ACTIONS(4855),
  },
  [1875] = {
    [sym_identifier] = ACTIONS(2563),
    [aux_sym_preproc_def_token1] = ACTIONS(2563),
    [aux_sym_preproc_if_token1] = ACTIONS(2563),
    [aux_sym_preproc_if_token2] = ACTIONS(2563),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2563),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2563),
    [sym_preproc_directive] = ACTIONS(2563),
    [anon_sym_LPAREN2] = ACTIONS(2565),
    [anon_sym_TILDE] = ACTIONS(2565),
    [anon_sym_STAR] = ACTIONS(2565),
    [anon_sym_AMP_AMP] = ACTIONS(2565),
    [anon_sym_AMP] = ACTIONS(2563),
    [anon_sym_SEMI] = ACTIONS(2565),
    [anon_sym___extension__] = ACTIONS(2563),
    [anon_sym_typedef] = ACTIONS(2563),
    [anon_sym_virtual] = ACTIONS(2563),
    [anon_sym_extern] = ACTIONS(2563),
    [anon_sym___attribute__] = ACTIONS(2563),
    [anon_sym___attribute] = ACTIONS(2563),
    [anon_sym_COLON_COLON] = ACTIONS(2565),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2565),
    [anon_sym___declspec] = ACTIONS(2563),
    [anon_sym___based] = ACTIONS(2563),
    [anon_sym_signed] = ACTIONS(2563),
    [anon_sym_unsigned] = ACTIONS(2563),
    [anon_sym_long] = ACTIONS(2563),
    [anon_sym_short] = ACTIONS(2563),
    [anon_sym_LBRACK] = ACTIONS(2563),
    [anon_sym_static] = ACTIONS(2563),
    [anon_sym_register] = ACTIONS(2563),
    [anon_sym_inline] = ACTIONS(2563),
    [anon_sym___inline] = ACTIONS(2563),
    [anon_sym___inline__] = ACTIONS(2563),
    [anon_sym___forceinline] = ACTIONS(2563),
    [anon_sym_thread_local] = ACTIONS(2563),
    [anon_sym___thread] = ACTIONS(2563),
    [anon_sym_const] = ACTIONS(2563),
    [anon_sym_constexpr] = ACTIONS(2563),
    [anon_sym_volatile] = ACTIONS(2563),
    [anon_sym_restrict] = ACTIONS(2563),
    [anon_sym___restrict__] = ACTIONS(2563),
    [anon_sym__Atomic] = ACTIONS(2563),
    [anon_sym__Noreturn] = ACTIONS(2563),
    [anon_sym_noreturn] = ACTIONS(2563),
    [anon_sym__Nonnull] = ACTIONS(2563),
    [anon_sym_mutable] = ACTIONS(2563),
    [anon_sym_constinit] = ACTIONS(2563),
    [anon_sym_consteval] = ACTIONS(2563),
    [anon_sym_alignas] = ACTIONS(2563),
    [anon_sym__Alignas] = ACTIONS(2563),
    [sym_primitive_type] = ACTIONS(2563),
    [anon_sym_enum] = ACTIONS(2563),
    [anon_sym_class] = ACTIONS(2563),
    [anon_sym_struct] = ACTIONS(2563),
    [anon_sym_union] = ACTIONS(2563),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2563),
    [anon_sym_decltype] = ACTIONS(2563),
    [anon_sym_explicit] = ACTIONS(2563),
    [anon_sym_typename] = ACTIONS(2563),
    [anon_sym_template] = ACTIONS(2563),
    [anon_sym_operator] = ACTIONS(2563),
    [anon_sym_friend] = ACTIONS(2563),
    [anon_sym_public] = ACTIONS(2563),
    [anon_sym_private] = ACTIONS(2563),
    [anon_sym_protected] = ACTIONS(2563),
    [anon_sym_using] = ACTIONS(2563),
    [anon_sym_static_assert] = ACTIONS(2563),
    [anon_sym_catch] = ACTIONS(2563),
  },
  [1876] = {
    [sym_identifier] = ACTIONS(1913),
    [aux_sym_preproc_def_token1] = ACTIONS(1913),
    [aux_sym_preproc_if_token1] = ACTIONS(1913),
    [aux_sym_preproc_if_token2] = ACTIONS(1913),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1913),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1913),
    [sym_preproc_directive] = ACTIONS(1913),
    [anon_sym_LPAREN2] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_AMP_AMP] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1913),
    [anon_sym_SEMI] = ACTIONS(1911),
    [anon_sym___extension__] = ACTIONS(1913),
    [anon_sym_typedef] = ACTIONS(1913),
    [anon_sym_virtual] = ACTIONS(1913),
    [anon_sym_extern] = ACTIONS(1913),
    [anon_sym___attribute__] = ACTIONS(1913),
    [anon_sym___attribute] = ACTIONS(1913),
    [anon_sym_COLON_COLON] = ACTIONS(1911),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1911),
    [anon_sym___declspec] = ACTIONS(1913),
    [anon_sym___based] = ACTIONS(1913),
    [anon_sym_signed] = ACTIONS(1913),
    [anon_sym_unsigned] = ACTIONS(1913),
    [anon_sym_long] = ACTIONS(1913),
    [anon_sym_short] = ACTIONS(1913),
    [anon_sym_LBRACK] = ACTIONS(1913),
    [anon_sym_static] = ACTIONS(1913),
    [anon_sym_register] = ACTIONS(1913),
    [anon_sym_inline] = ACTIONS(1913),
    [anon_sym___inline] = ACTIONS(1913),
    [anon_sym___inline__] = ACTIONS(1913),
    [anon_sym___forceinline] = ACTIONS(1913),
    [anon_sym_thread_local] = ACTIONS(1913),
    [anon_sym___thread] = ACTIONS(1913),
    [anon_sym_const] = ACTIONS(1913),
    [anon_sym_constexpr] = ACTIONS(1913),
    [anon_sym_volatile] = ACTIONS(1913),
    [anon_sym_restrict] = ACTIONS(1913),
    [anon_sym___restrict__] = ACTIONS(1913),
    [anon_sym__Atomic] = ACTIONS(1913),
    [anon_sym__Noreturn] = ACTIONS(1913),
    [anon_sym_noreturn] = ACTIONS(1913),
    [anon_sym__Nonnull] = ACTIONS(1913),
    [anon_sym_mutable] = ACTIONS(1913),
    [anon_sym_constinit] = ACTIONS(1913),
    [anon_sym_consteval] = ACTIONS(1913),
    [anon_sym_alignas] = ACTIONS(1913),
    [anon_sym__Alignas] = ACTIONS(1913),
    [sym_primitive_type] = ACTIONS(1913),
    [anon_sym_enum] = ACTIONS(1913),
    [anon_sym_class] = ACTIONS(1913),
    [anon_sym_struct] = ACTIONS(1913),
    [anon_sym_union] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1913),
    [anon_sym_decltype] = ACTIONS(1913),
    [anon_sym_explicit] = ACTIONS(1913),
    [anon_sym_typename] = ACTIONS(1913),
    [anon_sym_template] = ACTIONS(1913),
    [anon_sym_operator] = ACTIONS(1913),
    [anon_sym_friend] = ACTIONS(1913),
    [anon_sym_public] = ACTIONS(1913),
    [anon_sym_private] = ACTIONS(1913),
    [anon_sym_protected] = ACTIONS(1913),
    [anon_sym_using] = ACTIONS(1913),
    [anon_sym_static_assert] = ACTIONS(1913),
    [anon_sym_catch] = ACTIONS(1913),
  },
  [1877] = {
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(4765),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(2033),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2336),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(6493),
    [sym_qualified_type_identifier] = STATE(2978),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(5025),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5027),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
  },
  [1878] = {
    [sym_identifier] = ACTIONS(1913),
    [aux_sym_preproc_def_token1] = ACTIONS(1913),
    [aux_sym_preproc_if_token1] = ACTIONS(1913),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1913),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1913),
    [sym_preproc_directive] = ACTIONS(1913),
    [anon_sym_LPAREN2] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_AMP_AMP] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1913),
    [anon_sym_SEMI] = ACTIONS(1911),
    [anon_sym___extension__] = ACTIONS(1913),
    [anon_sym_typedef] = ACTIONS(1913),
    [anon_sym_virtual] = ACTIONS(1913),
    [anon_sym_extern] = ACTIONS(1913),
    [anon_sym___attribute__] = ACTIONS(1913),
    [anon_sym___attribute] = ACTIONS(1913),
    [anon_sym_COLON_COLON] = ACTIONS(1911),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1911),
    [anon_sym___declspec] = ACTIONS(1913),
    [anon_sym___based] = ACTIONS(1913),
    [anon_sym_RBRACE] = ACTIONS(1911),
    [anon_sym_signed] = ACTIONS(1913),
    [anon_sym_unsigned] = ACTIONS(1913),
    [anon_sym_long] = ACTIONS(1913),
    [anon_sym_short] = ACTIONS(1913),
    [anon_sym_LBRACK] = ACTIONS(1913),
    [anon_sym_static] = ACTIONS(1913),
    [anon_sym_register] = ACTIONS(1913),
    [anon_sym_inline] = ACTIONS(1913),
    [anon_sym___inline] = ACTIONS(1913),
    [anon_sym___inline__] = ACTIONS(1913),
    [anon_sym___forceinline] = ACTIONS(1913),
    [anon_sym_thread_local] = ACTIONS(1913),
    [anon_sym___thread] = ACTIONS(1913),
    [anon_sym_const] = ACTIONS(1913),
    [anon_sym_constexpr] = ACTIONS(1913),
    [anon_sym_volatile] = ACTIONS(1913),
    [anon_sym_restrict] = ACTIONS(1913),
    [anon_sym___restrict__] = ACTIONS(1913),
    [anon_sym__Atomic] = ACTIONS(1913),
    [anon_sym__Noreturn] = ACTIONS(1913),
    [anon_sym_noreturn] = ACTIONS(1913),
    [anon_sym__Nonnull] = ACTIONS(1913),
    [anon_sym_mutable] = ACTIONS(1913),
    [anon_sym_constinit] = ACTIONS(1913),
    [anon_sym_consteval] = ACTIONS(1913),
    [anon_sym_alignas] = ACTIONS(1913),
    [anon_sym__Alignas] = ACTIONS(1913),
    [sym_primitive_type] = ACTIONS(1913),
    [anon_sym_enum] = ACTIONS(1913),
    [anon_sym_class] = ACTIONS(1913),
    [anon_sym_struct] = ACTIONS(1913),
    [anon_sym_union] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1913),
    [anon_sym_decltype] = ACTIONS(1913),
    [anon_sym_explicit] = ACTIONS(1913),
    [anon_sym_typename] = ACTIONS(1913),
    [anon_sym_template] = ACTIONS(1913),
    [anon_sym_operator] = ACTIONS(1913),
    [anon_sym_friend] = ACTIONS(1913),
    [anon_sym_public] = ACTIONS(1913),
    [anon_sym_private] = ACTIONS(1913),
    [anon_sym_protected] = ACTIONS(1913),
    [anon_sym_using] = ACTIONS(1913),
    [anon_sym_static_assert] = ACTIONS(1913),
    [anon_sym_catch] = ACTIONS(1913),
  },
  [1879] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4857),
    [anon_sym_RPAREN] = ACTIONS(4859),
    [anon_sym_LPAREN2] = ACTIONS(4859),
    [anon_sym_DASH] = ACTIONS(4864),
    [anon_sym_PLUS] = ACTIONS(4864),
    [anon_sym_STAR] = ACTIONS(4866),
    [anon_sym_SLASH] = ACTIONS(4864),
    [anon_sym_PERCENT] = ACTIONS(4864),
    [anon_sym_PIPE_PIPE] = ACTIONS(4857),
    [anon_sym_AMP_AMP] = ACTIONS(4859),
    [anon_sym_PIPE] = ACTIONS(4864),
    [anon_sym_CARET] = ACTIONS(4864),
    [anon_sym_AMP] = ACTIONS(4866),
    [anon_sym_EQ_EQ] = ACTIONS(4857),
    [anon_sym_BANG_EQ] = ACTIONS(4857),
    [anon_sym_GT] = ACTIONS(4864),
    [anon_sym_GT_EQ] = ACTIONS(4857),
    [anon_sym_LT_EQ] = ACTIONS(4864),
    [anon_sym_LT] = ACTIONS(4864),
    [anon_sym_LT_LT] = ACTIONS(4864),
    [anon_sym_GT_GT] = ACTIONS(4864),
    [anon_sym___extension__] = ACTIONS(4862),
    [anon_sym_COLON_COLON] = ACTIONS(4862),
    [anon_sym_LBRACE] = ACTIONS(4862),
    [anon_sym_LBRACK] = ACTIONS(4859),
    [anon_sym_EQ] = ACTIONS(4864),
    [anon_sym_const] = ACTIONS(4855),
    [anon_sym_constexpr] = ACTIONS(4862),
    [anon_sym_volatile] = ACTIONS(4862),
    [anon_sym_restrict] = ACTIONS(4862),
    [anon_sym___restrict__] = ACTIONS(4862),
    [anon_sym__Atomic] = ACTIONS(4862),
    [anon_sym__Noreturn] = ACTIONS(4862),
    [anon_sym_noreturn] = ACTIONS(4862),
    [anon_sym__Nonnull] = ACTIONS(4862),
    [anon_sym_mutable] = ACTIONS(4862),
    [anon_sym_constinit] = ACTIONS(4862),
    [anon_sym_consteval] = ACTIONS(4862),
    [anon_sym_alignas] = ACTIONS(4862),
    [anon_sym__Alignas] = ACTIONS(4862),
    [anon_sym_QMARK] = ACTIONS(4857),
    [anon_sym_STAR_EQ] = ACTIONS(4857),
    [anon_sym_SLASH_EQ] = ACTIONS(4857),
    [anon_sym_PERCENT_EQ] = ACTIONS(4857),
    [anon_sym_PLUS_EQ] = ACTIONS(4857),
    [anon_sym_DASH_EQ] = ACTIONS(4857),
    [anon_sym_LT_LT_EQ] = ACTIONS(4857),
    [anon_sym_GT_GT_EQ] = ACTIONS(4857),
    [anon_sym_AMP_EQ] = ACTIONS(4857),
    [anon_sym_CARET_EQ] = ACTIONS(4857),
    [anon_sym_PIPE_EQ] = ACTIONS(4857),
    [anon_sym_and_eq] = ACTIONS(4857),
    [anon_sym_or_eq] = ACTIONS(4857),
    [anon_sym_xor_eq] = ACTIONS(4857),
    [anon_sym_LT_EQ_GT] = ACTIONS(4857),
    [anon_sym_or] = ACTIONS(4864),
    [anon_sym_and] = ACTIONS(4864),
    [anon_sym_bitor] = ACTIONS(4857),
    [anon_sym_xor] = ACTIONS(4864),
    [anon_sym_bitand] = ACTIONS(4857),
    [anon_sym_not_eq] = ACTIONS(4857),
    [anon_sym_DASH_DASH] = ACTIONS(4857),
    [anon_sym_PLUS_PLUS] = ACTIONS(4857),
    [anon_sym_DOT] = ACTIONS(4864),
    [anon_sym_DOT_STAR] = ACTIONS(4857),
    [anon_sym_DASH_GT] = ACTIONS(4857),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4862),
    [anon_sym_decltype] = ACTIONS(4862),
  },
  [1880] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5766),
    [anon_sym_COMMA] = ACTIONS(5766),
    [anon_sym_RPAREN] = ACTIONS(5766),
    [anon_sym_LPAREN2] = ACTIONS(5766),
    [anon_sym_DASH] = ACTIONS(5768),
    [anon_sym_PLUS] = ACTIONS(5768),
    [anon_sym_STAR] = ACTIONS(5766),
    [anon_sym_SLASH] = ACTIONS(5768),
    [anon_sym_PERCENT] = ACTIONS(5766),
    [anon_sym_PIPE_PIPE] = ACTIONS(5766),
    [anon_sym_AMP_AMP] = ACTIONS(5766),
    [anon_sym_PIPE] = ACTIONS(5768),
    [anon_sym_CARET] = ACTIONS(5766),
    [anon_sym_AMP] = ACTIONS(5768),
    [anon_sym_EQ_EQ] = ACTIONS(5766),
    [anon_sym_BANG_EQ] = ACTIONS(5766),
    [anon_sym_GT] = ACTIONS(5768),
    [anon_sym_GT_EQ] = ACTIONS(5766),
    [anon_sym_LT_EQ] = ACTIONS(5768),
    [anon_sym_LT] = ACTIONS(5768),
    [anon_sym_LT_LT] = ACTIONS(5766),
    [anon_sym_GT_GT] = ACTIONS(5766),
    [anon_sym_SEMI] = ACTIONS(5766),
    [anon_sym___extension__] = ACTIONS(5766),
    [anon_sym___attribute__] = ACTIONS(5766),
    [anon_sym___attribute] = ACTIONS(5768),
    [anon_sym_LBRACE] = ACTIONS(5766),
    [anon_sym_RBRACE] = ACTIONS(5766),
    [anon_sym_signed] = ACTIONS(5754),
    [anon_sym_unsigned] = ACTIONS(5754),
    [anon_sym_long] = ACTIONS(5754),
    [anon_sym_short] = ACTIONS(5754),
    [anon_sym_LBRACK] = ACTIONS(5766),
    [anon_sym_RBRACK] = ACTIONS(5766),
    [anon_sym_const] = ACTIONS(5768),
    [anon_sym_constexpr] = ACTIONS(5766),
    [anon_sym_volatile] = ACTIONS(5766),
    [anon_sym_restrict] = ACTIONS(5766),
    [anon_sym___restrict__] = ACTIONS(5766),
    [anon_sym__Atomic] = ACTIONS(5766),
    [anon_sym__Noreturn] = ACTIONS(5766),
    [anon_sym_noreturn] = ACTIONS(5766),
    [anon_sym__Nonnull] = ACTIONS(5766),
    [anon_sym_mutable] = ACTIONS(5766),
    [anon_sym_constinit] = ACTIONS(5766),
    [anon_sym_consteval] = ACTIONS(5766),
    [anon_sym_alignas] = ACTIONS(5766),
    [anon_sym__Alignas] = ACTIONS(5766),
    [anon_sym_COLON] = ACTIONS(5766),
    [anon_sym_QMARK] = ACTIONS(5766),
    [anon_sym_LT_EQ_GT] = ACTIONS(5766),
    [anon_sym_or] = ACTIONS(5766),
    [anon_sym_and] = ACTIONS(5766),
    [anon_sym_bitor] = ACTIONS(5766),
    [anon_sym_xor] = ACTIONS(5766),
    [anon_sym_bitand] = ACTIONS(5766),
    [anon_sym_not_eq] = ACTIONS(5766),
    [anon_sym_DASH_DASH] = ACTIONS(5766),
    [anon_sym_PLUS_PLUS] = ACTIONS(5766),
    [anon_sym_DOT] = ACTIONS(5768),
    [anon_sym_DOT_STAR] = ACTIONS(5766),
    [anon_sym_DASH_GT] = ACTIONS(5766),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5766),
    [anon_sym_decltype] = ACTIONS(5766),
    [anon_sym_final] = ACTIONS(5766),
    [anon_sym_override] = ACTIONS(5766),
    [anon_sym_requires] = ACTIONS(5766),
  },
  [1881] = {
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(4756),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(2033),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2336),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(6493),
    [sym_qualified_type_identifier] = STATE(2978),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(5025),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5027),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
  },
  [1882] = {
    [sym_type_qualifier] = STATE(1882),
    [sym_alignas_qualifier] = STATE(2209),
    [aux_sym__type_definition_type_repeat1] = STATE(1882),
    [sym_identifier] = ACTIONS(4906),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4908),
    [anon_sym_COMMA] = ACTIONS(4908),
    [anon_sym_LPAREN2] = ACTIONS(4908),
    [anon_sym_DASH] = ACTIONS(4906),
    [anon_sym_PLUS] = ACTIONS(4906),
    [anon_sym_STAR] = ACTIONS(4908),
    [anon_sym_SLASH] = ACTIONS(4906),
    [anon_sym_PERCENT] = ACTIONS(4908),
    [anon_sym_PIPE_PIPE] = ACTIONS(4908),
    [anon_sym_AMP_AMP] = ACTIONS(4908),
    [anon_sym_PIPE] = ACTIONS(4906),
    [anon_sym_CARET] = ACTIONS(4908),
    [anon_sym_AMP] = ACTIONS(4906),
    [anon_sym_EQ_EQ] = ACTIONS(4908),
    [anon_sym_BANG_EQ] = ACTIONS(4908),
    [anon_sym_GT] = ACTIONS(4906),
    [anon_sym_GT_EQ] = ACTIONS(4906),
    [anon_sym_LT_EQ] = ACTIONS(4906),
    [anon_sym_LT] = ACTIONS(4906),
    [anon_sym_LT_LT] = ACTIONS(4908),
    [anon_sym_GT_GT] = ACTIONS(4906),
    [anon_sym___extension__] = ACTIONS(5770),
    [anon_sym___attribute__] = ACTIONS(4906),
    [anon_sym___attribute] = ACTIONS(4906),
    [anon_sym_LBRACE] = ACTIONS(4908),
    [anon_sym_signed] = ACTIONS(4906),
    [anon_sym_unsigned] = ACTIONS(4906),
    [anon_sym_long] = ACTIONS(4906),
    [anon_sym_short] = ACTIONS(4906),
    [anon_sym_LBRACK] = ACTIONS(4908),
    [anon_sym_const] = ACTIONS(5770),
    [anon_sym_constexpr] = ACTIONS(5770),
    [anon_sym_volatile] = ACTIONS(5770),
    [anon_sym_restrict] = ACTIONS(5770),
    [anon_sym___restrict__] = ACTIONS(5770),
    [anon_sym__Atomic] = ACTIONS(5770),
    [anon_sym__Noreturn] = ACTIONS(5770),
    [anon_sym_noreturn] = ACTIONS(5770),
    [anon_sym__Nonnull] = ACTIONS(5770),
    [anon_sym_mutable] = ACTIONS(5770),
    [anon_sym_constinit] = ACTIONS(5770),
    [anon_sym_consteval] = ACTIONS(5770),
    [anon_sym_alignas] = ACTIONS(5773),
    [anon_sym__Alignas] = ACTIONS(5773),
    [sym_primitive_type] = ACTIONS(4906),
    [anon_sym_QMARK] = ACTIONS(4908),
    [anon_sym_LT_EQ_GT] = ACTIONS(4908),
    [anon_sym_or] = ACTIONS(4906),
    [anon_sym_and] = ACTIONS(4906),
    [anon_sym_bitor] = ACTIONS(4906),
    [anon_sym_xor] = ACTIONS(4906),
    [anon_sym_bitand] = ACTIONS(4906),
    [anon_sym_not_eq] = ACTIONS(4906),
    [anon_sym_DASH_DASH] = ACTIONS(4908),
    [anon_sym_PLUS_PLUS] = ACTIONS(4908),
    [anon_sym_DOT] = ACTIONS(4906),
    [anon_sym_DOT_STAR] = ACTIONS(4908),
    [anon_sym_DASH_GT] = ACTIONS(4908),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4906),
    [anon_sym_decltype] = ACTIONS(4906),
    [anon_sym_final] = ACTIONS(4906),
    [anon_sym_override] = ACTIONS(4906),
    [anon_sym_GT2] = ACTIONS(4908),
    [anon_sym_requires] = ACTIONS(4906),
  },
  [1883] = {
    [sym_identifier] = ACTIONS(5443),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5445),
    [anon_sym_COMMA] = ACTIONS(5445),
    [anon_sym_RPAREN] = ACTIONS(5445),
    [aux_sym_preproc_if_token2] = ACTIONS(5445),
    [aux_sym_preproc_else_token1] = ACTIONS(5445),
    [aux_sym_preproc_elif_token1] = ACTIONS(5443),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5445),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5445),
    [anon_sym_LPAREN2] = ACTIONS(5445),
    [anon_sym_DASH] = ACTIONS(5443),
    [anon_sym_PLUS] = ACTIONS(5443),
    [anon_sym_STAR] = ACTIONS(5443),
    [anon_sym_SLASH] = ACTIONS(5443),
    [anon_sym_PERCENT] = ACTIONS(5443),
    [anon_sym_PIPE_PIPE] = ACTIONS(5445),
    [anon_sym_AMP_AMP] = ACTIONS(5445),
    [anon_sym_PIPE] = ACTIONS(5443),
    [anon_sym_CARET] = ACTIONS(5443),
    [anon_sym_AMP] = ACTIONS(5443),
    [anon_sym_EQ_EQ] = ACTIONS(5445),
    [anon_sym_BANG_EQ] = ACTIONS(5445),
    [anon_sym_GT] = ACTIONS(5443),
    [anon_sym_GT_EQ] = ACTIONS(5445),
    [anon_sym_LT_EQ] = ACTIONS(5443),
    [anon_sym_LT] = ACTIONS(5443),
    [anon_sym_LT_LT] = ACTIONS(5443),
    [anon_sym_GT_GT] = ACTIONS(5443),
    [anon_sym_SEMI] = ACTIONS(5445),
    [anon_sym___attribute__] = ACTIONS(5443),
    [anon_sym___attribute] = ACTIONS(5443),
    [anon_sym_COLON_COLON] = ACTIONS(5365),
    [anon_sym_LBRACE] = ACTIONS(5445),
    [anon_sym_RBRACE] = ACTIONS(5445),
    [anon_sym_LBRACK] = ACTIONS(5445),
    [anon_sym_RBRACK] = ACTIONS(5445),
    [anon_sym_EQ] = ACTIONS(5443),
    [anon_sym_COLON] = ACTIONS(5443),
    [anon_sym_QMARK] = ACTIONS(5445),
    [anon_sym_STAR_EQ] = ACTIONS(5445),
    [anon_sym_SLASH_EQ] = ACTIONS(5445),
    [anon_sym_PERCENT_EQ] = ACTIONS(5445),
    [anon_sym_PLUS_EQ] = ACTIONS(5445),
    [anon_sym_DASH_EQ] = ACTIONS(5445),
    [anon_sym_LT_LT_EQ] = ACTIONS(5445),
    [anon_sym_GT_GT_EQ] = ACTIONS(5445),
    [anon_sym_AMP_EQ] = ACTIONS(5445),
    [anon_sym_CARET_EQ] = ACTIONS(5445),
    [anon_sym_PIPE_EQ] = ACTIONS(5445),
    [anon_sym_and_eq] = ACTIONS(5443),
    [anon_sym_or_eq] = ACTIONS(5443),
    [anon_sym_xor_eq] = ACTIONS(5443),
    [anon_sym_LT_EQ_GT] = ACTIONS(5445),
    [anon_sym_or] = ACTIONS(5443),
    [anon_sym_and] = ACTIONS(5443),
    [anon_sym_bitor] = ACTIONS(5443),
    [anon_sym_xor] = ACTIONS(5443),
    [anon_sym_bitand] = ACTIONS(5443),
    [anon_sym_not_eq] = ACTIONS(5443),
    [anon_sym_DASH_DASH] = ACTIONS(5445),
    [anon_sym_PLUS_PLUS] = ACTIONS(5445),
    [anon_sym_DOT] = ACTIONS(5443),
    [anon_sym_DOT_STAR] = ACTIONS(5445),
    [anon_sym_DASH_GT] = ACTIONS(5445),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5443),
    [anon_sym_decltype] = ACTIONS(5443),
    [anon_sym_final] = ACTIONS(5443),
    [anon_sym_override] = ACTIONS(5443),
  },
  [1884] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5776),
    [anon_sym_COMMA] = ACTIONS(5776),
    [anon_sym_RPAREN] = ACTIONS(5776),
    [anon_sym_LPAREN2] = ACTIONS(5776),
    [anon_sym_DASH] = ACTIONS(5778),
    [anon_sym_PLUS] = ACTIONS(5778),
    [anon_sym_STAR] = ACTIONS(5776),
    [anon_sym_SLASH] = ACTIONS(5778),
    [anon_sym_PERCENT] = ACTIONS(5776),
    [anon_sym_PIPE_PIPE] = ACTIONS(5776),
    [anon_sym_AMP_AMP] = ACTIONS(5776),
    [anon_sym_PIPE] = ACTIONS(5778),
    [anon_sym_CARET] = ACTIONS(5776),
    [anon_sym_AMP] = ACTIONS(5778),
    [anon_sym_EQ_EQ] = ACTIONS(5776),
    [anon_sym_BANG_EQ] = ACTIONS(5776),
    [anon_sym_GT] = ACTIONS(5778),
    [anon_sym_GT_EQ] = ACTIONS(5776),
    [anon_sym_LT_EQ] = ACTIONS(5778),
    [anon_sym_LT] = ACTIONS(5778),
    [anon_sym_LT_LT] = ACTIONS(5776),
    [anon_sym_GT_GT] = ACTIONS(5776),
    [anon_sym_SEMI] = ACTIONS(5776),
    [anon_sym___extension__] = ACTIONS(5776),
    [anon_sym___attribute__] = ACTIONS(5776),
    [anon_sym___attribute] = ACTIONS(5778),
    [anon_sym_LBRACE] = ACTIONS(5776),
    [anon_sym_RBRACE] = ACTIONS(5776),
    [anon_sym_signed] = ACTIONS(5754),
    [anon_sym_unsigned] = ACTIONS(5754),
    [anon_sym_long] = ACTIONS(5754),
    [anon_sym_short] = ACTIONS(5754),
    [anon_sym_LBRACK] = ACTIONS(5776),
    [anon_sym_RBRACK] = ACTIONS(5776),
    [anon_sym_const] = ACTIONS(5778),
    [anon_sym_constexpr] = ACTIONS(5776),
    [anon_sym_volatile] = ACTIONS(5776),
    [anon_sym_restrict] = ACTIONS(5776),
    [anon_sym___restrict__] = ACTIONS(5776),
    [anon_sym__Atomic] = ACTIONS(5776),
    [anon_sym__Noreturn] = ACTIONS(5776),
    [anon_sym_noreturn] = ACTIONS(5776),
    [anon_sym__Nonnull] = ACTIONS(5776),
    [anon_sym_mutable] = ACTIONS(5776),
    [anon_sym_constinit] = ACTIONS(5776),
    [anon_sym_consteval] = ACTIONS(5776),
    [anon_sym_alignas] = ACTIONS(5776),
    [anon_sym__Alignas] = ACTIONS(5776),
    [anon_sym_COLON] = ACTIONS(5776),
    [anon_sym_QMARK] = ACTIONS(5776),
    [anon_sym_LT_EQ_GT] = ACTIONS(5776),
    [anon_sym_or] = ACTIONS(5776),
    [anon_sym_and] = ACTIONS(5776),
    [anon_sym_bitor] = ACTIONS(5776),
    [anon_sym_xor] = ACTIONS(5776),
    [anon_sym_bitand] = ACTIONS(5776),
    [anon_sym_not_eq] = ACTIONS(5776),
    [anon_sym_DASH_DASH] = ACTIONS(5776),
    [anon_sym_PLUS_PLUS] = ACTIONS(5776),
    [anon_sym_DOT] = ACTIONS(5778),
    [anon_sym_DOT_STAR] = ACTIONS(5776),
    [anon_sym_DASH_GT] = ACTIONS(5776),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5776),
    [anon_sym_decltype] = ACTIONS(5776),
    [anon_sym_final] = ACTIONS(5776),
    [anon_sym_override] = ACTIONS(5776),
    [anon_sym_requires] = ACTIONS(5776),
  },
  [1885] = {
    [sym_identifier] = ACTIONS(5470),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5472),
    [anon_sym_COMMA] = ACTIONS(5472),
    [anon_sym_RPAREN] = ACTIONS(5472),
    [aux_sym_preproc_if_token2] = ACTIONS(5472),
    [aux_sym_preproc_else_token1] = ACTIONS(5472),
    [aux_sym_preproc_elif_token1] = ACTIONS(5470),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5472),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5472),
    [anon_sym_LPAREN2] = ACTIONS(5472),
    [anon_sym_DASH] = ACTIONS(5470),
    [anon_sym_PLUS] = ACTIONS(5470),
    [anon_sym_STAR] = ACTIONS(5470),
    [anon_sym_SLASH] = ACTIONS(5470),
    [anon_sym_PERCENT] = ACTIONS(5470),
    [anon_sym_PIPE_PIPE] = ACTIONS(5472),
    [anon_sym_AMP_AMP] = ACTIONS(5472),
    [anon_sym_PIPE] = ACTIONS(5470),
    [anon_sym_CARET] = ACTIONS(5470),
    [anon_sym_AMP] = ACTIONS(5470),
    [anon_sym_EQ_EQ] = ACTIONS(5472),
    [anon_sym_BANG_EQ] = ACTIONS(5472),
    [anon_sym_GT] = ACTIONS(5470),
    [anon_sym_GT_EQ] = ACTIONS(5472),
    [anon_sym_LT_EQ] = ACTIONS(5470),
    [anon_sym_LT] = ACTIONS(5470),
    [anon_sym_LT_LT] = ACTIONS(5470),
    [anon_sym_GT_GT] = ACTIONS(5470),
    [anon_sym_SEMI] = ACTIONS(5472),
    [anon_sym___attribute__] = ACTIONS(5470),
    [anon_sym___attribute] = ACTIONS(5470),
    [anon_sym_COLON_COLON] = ACTIONS(5472),
    [anon_sym_LBRACE] = ACTIONS(5472),
    [anon_sym_RBRACE] = ACTIONS(5472),
    [anon_sym_LBRACK] = ACTIONS(5472),
    [anon_sym_RBRACK] = ACTIONS(5472),
    [anon_sym_EQ] = ACTIONS(5470),
    [anon_sym_COLON] = ACTIONS(5470),
    [anon_sym_QMARK] = ACTIONS(5472),
    [anon_sym_STAR_EQ] = ACTIONS(5472),
    [anon_sym_SLASH_EQ] = ACTIONS(5472),
    [anon_sym_PERCENT_EQ] = ACTIONS(5472),
    [anon_sym_PLUS_EQ] = ACTIONS(5472),
    [anon_sym_DASH_EQ] = ACTIONS(5472),
    [anon_sym_LT_LT_EQ] = ACTIONS(5472),
    [anon_sym_GT_GT_EQ] = ACTIONS(5472),
    [anon_sym_AMP_EQ] = ACTIONS(5472),
    [anon_sym_CARET_EQ] = ACTIONS(5472),
    [anon_sym_PIPE_EQ] = ACTIONS(5472),
    [anon_sym_and_eq] = ACTIONS(5470),
    [anon_sym_or_eq] = ACTIONS(5470),
    [anon_sym_xor_eq] = ACTIONS(5470),
    [anon_sym_LT_EQ_GT] = ACTIONS(5472),
    [anon_sym_or] = ACTIONS(5470),
    [anon_sym_and] = ACTIONS(5470),
    [anon_sym_bitor] = ACTIONS(5470),
    [anon_sym_xor] = ACTIONS(5470),
    [anon_sym_bitand] = ACTIONS(5470),
    [anon_sym_not_eq] = ACTIONS(5470),
    [anon_sym_DASH_DASH] = ACTIONS(5472),
    [anon_sym_PLUS_PLUS] = ACTIONS(5472),
    [anon_sym_DOT] = ACTIONS(5470),
    [anon_sym_DOT_STAR] = ACTIONS(5472),
    [anon_sym_DASH_GT] = ACTIONS(5472),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5470),
    [anon_sym_decltype] = ACTIONS(5470),
    [anon_sym_final] = ACTIONS(5470),
    [anon_sym_override] = ACTIONS(5470),
  },
  [1886] = {
    [sym_identifier] = ACTIONS(1913),
    [aux_sym_preproc_def_token1] = ACTIONS(1913),
    [anon_sym_COMMA] = ACTIONS(2721),
    [aux_sym_preproc_if_token1] = ACTIONS(1913),
    [aux_sym_preproc_if_token2] = ACTIONS(1913),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1913),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1913),
    [sym_preproc_directive] = ACTIONS(1913),
    [anon_sym_LPAREN2] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_AMP_AMP] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1913),
    [anon_sym_SEMI] = ACTIONS(2721),
    [anon_sym___extension__] = ACTIONS(1913),
    [anon_sym_typedef] = ACTIONS(1913),
    [anon_sym_virtual] = ACTIONS(1913),
    [anon_sym_extern] = ACTIONS(1913),
    [anon_sym___attribute__] = ACTIONS(5305),
    [anon_sym___attribute] = ACTIONS(5305),
    [anon_sym_COLON_COLON] = ACTIONS(1911),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1911),
    [anon_sym___declspec] = ACTIONS(1913),
    [anon_sym___based] = ACTIONS(1913),
    [anon_sym_signed] = ACTIONS(1913),
    [anon_sym_unsigned] = ACTIONS(1913),
    [anon_sym_long] = ACTIONS(1913),
    [anon_sym_short] = ACTIONS(1913),
    [anon_sym_LBRACK] = ACTIONS(1913),
    [anon_sym_static] = ACTIONS(1913),
    [anon_sym_register] = ACTIONS(1913),
    [anon_sym_inline] = ACTIONS(1913),
    [anon_sym___inline] = ACTIONS(1913),
    [anon_sym___inline__] = ACTIONS(1913),
    [anon_sym___forceinline] = ACTIONS(1913),
    [anon_sym_thread_local] = ACTIONS(1913),
    [anon_sym___thread] = ACTIONS(1913),
    [anon_sym_const] = ACTIONS(1913),
    [anon_sym_constexpr] = ACTIONS(1913),
    [anon_sym_volatile] = ACTIONS(1913),
    [anon_sym_restrict] = ACTIONS(1913),
    [anon_sym___restrict__] = ACTIONS(1913),
    [anon_sym__Atomic] = ACTIONS(1913),
    [anon_sym__Noreturn] = ACTIONS(1913),
    [anon_sym_noreturn] = ACTIONS(1913),
    [anon_sym__Nonnull] = ACTIONS(1913),
    [anon_sym_mutable] = ACTIONS(1913),
    [anon_sym_constinit] = ACTIONS(1913),
    [anon_sym_consteval] = ACTIONS(1913),
    [anon_sym_alignas] = ACTIONS(1913),
    [anon_sym__Alignas] = ACTIONS(1913),
    [sym_primitive_type] = ACTIONS(1913),
    [anon_sym_enum] = ACTIONS(1913),
    [anon_sym_class] = ACTIONS(1913),
    [anon_sym_struct] = ACTIONS(1913),
    [anon_sym_union] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1913),
    [anon_sym_decltype] = ACTIONS(1913),
    [anon_sym_explicit] = ACTIONS(1913),
    [anon_sym_typename] = ACTIONS(1913),
    [anon_sym_template] = ACTIONS(1913),
    [anon_sym_operator] = ACTIONS(1913),
    [anon_sym_friend] = ACTIONS(1913),
    [anon_sym_public] = ACTIONS(1913),
    [anon_sym_private] = ACTIONS(1913),
    [anon_sym_protected] = ACTIONS(1913),
    [anon_sym_using] = ACTIONS(1913),
    [anon_sym_static_assert] = ACTIONS(1913),
  },
  [1887] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5780),
    [anon_sym_COMMA] = ACTIONS(5780),
    [anon_sym_RPAREN] = ACTIONS(5780),
    [anon_sym_LPAREN2] = ACTIONS(5780),
    [anon_sym_DASH] = ACTIONS(5782),
    [anon_sym_PLUS] = ACTIONS(5782),
    [anon_sym_STAR] = ACTIONS(5780),
    [anon_sym_SLASH] = ACTIONS(5782),
    [anon_sym_PERCENT] = ACTIONS(5780),
    [anon_sym_PIPE_PIPE] = ACTIONS(5780),
    [anon_sym_AMP_AMP] = ACTIONS(5780),
    [anon_sym_PIPE] = ACTIONS(5782),
    [anon_sym_CARET] = ACTIONS(5780),
    [anon_sym_AMP] = ACTIONS(5782),
    [anon_sym_EQ_EQ] = ACTIONS(5780),
    [anon_sym_BANG_EQ] = ACTIONS(5780),
    [anon_sym_GT] = ACTIONS(5782),
    [anon_sym_GT_EQ] = ACTIONS(5780),
    [anon_sym_LT_EQ] = ACTIONS(5782),
    [anon_sym_LT] = ACTIONS(5782),
    [anon_sym_LT_LT] = ACTIONS(5780),
    [anon_sym_GT_GT] = ACTIONS(5780),
    [anon_sym_SEMI] = ACTIONS(5780),
    [anon_sym___extension__] = ACTIONS(5780),
    [anon_sym___attribute__] = ACTIONS(5780),
    [anon_sym___attribute] = ACTIONS(5782),
    [anon_sym_LBRACE] = ACTIONS(5780),
    [anon_sym_RBRACE] = ACTIONS(5780),
    [anon_sym_signed] = ACTIONS(5754),
    [anon_sym_unsigned] = ACTIONS(5754),
    [anon_sym_long] = ACTIONS(5754),
    [anon_sym_short] = ACTIONS(5754),
    [anon_sym_LBRACK] = ACTIONS(5780),
    [anon_sym_RBRACK] = ACTIONS(5780),
    [anon_sym_const] = ACTIONS(5782),
    [anon_sym_constexpr] = ACTIONS(5780),
    [anon_sym_volatile] = ACTIONS(5780),
    [anon_sym_restrict] = ACTIONS(5780),
    [anon_sym___restrict__] = ACTIONS(5780),
    [anon_sym__Atomic] = ACTIONS(5780),
    [anon_sym__Noreturn] = ACTIONS(5780),
    [anon_sym_noreturn] = ACTIONS(5780),
    [anon_sym__Nonnull] = ACTIONS(5780),
    [anon_sym_mutable] = ACTIONS(5780),
    [anon_sym_constinit] = ACTIONS(5780),
    [anon_sym_consteval] = ACTIONS(5780),
    [anon_sym_alignas] = ACTIONS(5780),
    [anon_sym__Alignas] = ACTIONS(5780),
    [anon_sym_COLON] = ACTIONS(5780),
    [anon_sym_QMARK] = ACTIONS(5780),
    [anon_sym_LT_EQ_GT] = ACTIONS(5780),
    [anon_sym_or] = ACTIONS(5780),
    [anon_sym_and] = ACTIONS(5780),
    [anon_sym_bitor] = ACTIONS(5780),
    [anon_sym_xor] = ACTIONS(5780),
    [anon_sym_bitand] = ACTIONS(5780),
    [anon_sym_not_eq] = ACTIONS(5780),
    [anon_sym_DASH_DASH] = ACTIONS(5780),
    [anon_sym_PLUS_PLUS] = ACTIONS(5780),
    [anon_sym_DOT] = ACTIONS(5782),
    [anon_sym_DOT_STAR] = ACTIONS(5780),
    [anon_sym_DASH_GT] = ACTIONS(5780),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5780),
    [anon_sym_decltype] = ACTIONS(5780),
    [anon_sym_final] = ACTIONS(5780),
    [anon_sym_override] = ACTIONS(5780),
    [anon_sym_requires] = ACTIONS(5780),
  },
  [1888] = {
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(5223),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(2033),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2336),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(6493),
    [sym_qualified_type_identifier] = STATE(2978),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(5025),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5027),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
  },
  [1889] = {
    [sym_identifier] = ACTIONS(1913),
    [aux_sym_preproc_def_token1] = ACTIONS(1913),
    [anon_sym_COMMA] = ACTIONS(2721),
    [aux_sym_preproc_if_token1] = ACTIONS(1913),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1913),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1913),
    [sym_preproc_directive] = ACTIONS(1913),
    [anon_sym_LPAREN2] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_AMP_AMP] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1913),
    [anon_sym_SEMI] = ACTIONS(2721),
    [anon_sym___extension__] = ACTIONS(1913),
    [anon_sym_typedef] = ACTIONS(1913),
    [anon_sym_virtual] = ACTIONS(1913),
    [anon_sym_extern] = ACTIONS(1913),
    [anon_sym___attribute__] = ACTIONS(1913),
    [anon_sym___attribute] = ACTIONS(1913),
    [anon_sym_COLON_COLON] = ACTIONS(1911),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1911),
    [anon_sym___declspec] = ACTIONS(1913),
    [anon_sym___based] = ACTIONS(1913),
    [anon_sym_RBRACE] = ACTIONS(1911),
    [anon_sym_signed] = ACTIONS(1913),
    [anon_sym_unsigned] = ACTIONS(1913),
    [anon_sym_long] = ACTIONS(1913),
    [anon_sym_short] = ACTIONS(1913),
    [anon_sym_LBRACK] = ACTIONS(1913),
    [anon_sym_static] = ACTIONS(1913),
    [anon_sym_register] = ACTIONS(1913),
    [anon_sym_inline] = ACTIONS(1913),
    [anon_sym___inline] = ACTIONS(1913),
    [anon_sym___inline__] = ACTIONS(1913),
    [anon_sym___forceinline] = ACTIONS(1913),
    [anon_sym_thread_local] = ACTIONS(1913),
    [anon_sym___thread] = ACTIONS(1913),
    [anon_sym_const] = ACTIONS(1913),
    [anon_sym_constexpr] = ACTIONS(1913),
    [anon_sym_volatile] = ACTIONS(1913),
    [anon_sym_restrict] = ACTIONS(1913),
    [anon_sym___restrict__] = ACTIONS(1913),
    [anon_sym__Atomic] = ACTIONS(1913),
    [anon_sym__Noreturn] = ACTIONS(1913),
    [anon_sym_noreturn] = ACTIONS(1913),
    [anon_sym__Nonnull] = ACTIONS(1913),
    [anon_sym_mutable] = ACTIONS(1913),
    [anon_sym_constinit] = ACTIONS(1913),
    [anon_sym_consteval] = ACTIONS(1913),
    [anon_sym_alignas] = ACTIONS(1913),
    [anon_sym__Alignas] = ACTIONS(1913),
    [sym_primitive_type] = ACTIONS(1913),
    [anon_sym_enum] = ACTIONS(1913),
    [anon_sym_class] = ACTIONS(1913),
    [anon_sym_struct] = ACTIONS(1913),
    [anon_sym_union] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1913),
    [anon_sym_decltype] = ACTIONS(1913),
    [anon_sym_explicit] = ACTIONS(1913),
    [anon_sym_typename] = ACTIONS(1913),
    [anon_sym_template] = ACTIONS(1913),
    [anon_sym_operator] = ACTIONS(1913),
    [anon_sym_friend] = ACTIONS(1913),
    [anon_sym_public] = ACTIONS(1913),
    [anon_sym_private] = ACTIONS(1913),
    [anon_sym_protected] = ACTIONS(1913),
    [anon_sym_using] = ACTIONS(1913),
    [anon_sym_static_assert] = ACTIONS(1913),
  },
  [1890] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1880),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5547),
    [anon_sym_COMMA] = ACTIONS(5547),
    [anon_sym_RPAREN] = ACTIONS(5547),
    [anon_sym_LPAREN2] = ACTIONS(5547),
    [anon_sym_DASH] = ACTIONS(5545),
    [anon_sym_PLUS] = ACTIONS(5545),
    [anon_sym_STAR] = ACTIONS(5547),
    [anon_sym_SLASH] = ACTIONS(5545),
    [anon_sym_PERCENT] = ACTIONS(5547),
    [anon_sym_PIPE_PIPE] = ACTIONS(5547),
    [anon_sym_AMP_AMP] = ACTIONS(5547),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_CARET] = ACTIONS(5547),
    [anon_sym_AMP] = ACTIONS(5545),
    [anon_sym_EQ_EQ] = ACTIONS(5547),
    [anon_sym_BANG_EQ] = ACTIONS(5547),
    [anon_sym_GT] = ACTIONS(5545),
    [anon_sym_GT_EQ] = ACTIONS(5547),
    [anon_sym_LT_EQ] = ACTIONS(5545),
    [anon_sym_LT] = ACTIONS(5545),
    [anon_sym_LT_LT] = ACTIONS(5547),
    [anon_sym_GT_GT] = ACTIONS(5547),
    [anon_sym_SEMI] = ACTIONS(5547),
    [anon_sym___extension__] = ACTIONS(5547),
    [anon_sym___attribute__] = ACTIONS(5547),
    [anon_sym___attribute] = ACTIONS(5545),
    [anon_sym_LBRACE] = ACTIONS(5547),
    [anon_sym_RBRACE] = ACTIONS(5547),
    [anon_sym_signed] = ACTIONS(5784),
    [anon_sym_unsigned] = ACTIONS(5784),
    [anon_sym_long] = ACTIONS(5784),
    [anon_sym_short] = ACTIONS(5784),
    [anon_sym_LBRACK] = ACTIONS(5547),
    [anon_sym_RBRACK] = ACTIONS(5547),
    [anon_sym_const] = ACTIONS(5545),
    [anon_sym_constexpr] = ACTIONS(5547),
    [anon_sym_volatile] = ACTIONS(5547),
    [anon_sym_restrict] = ACTIONS(5547),
    [anon_sym___restrict__] = ACTIONS(5547),
    [anon_sym__Atomic] = ACTIONS(5547),
    [anon_sym__Noreturn] = ACTIONS(5547),
    [anon_sym_noreturn] = ACTIONS(5547),
    [anon_sym__Nonnull] = ACTIONS(5547),
    [anon_sym_mutable] = ACTIONS(5547),
    [anon_sym_constinit] = ACTIONS(5547),
    [anon_sym_consteval] = ACTIONS(5547),
    [anon_sym_alignas] = ACTIONS(5547),
    [anon_sym__Alignas] = ACTIONS(5547),
    [anon_sym_COLON] = ACTIONS(5547),
    [anon_sym_QMARK] = ACTIONS(5547),
    [anon_sym_LT_EQ_GT] = ACTIONS(5547),
    [anon_sym_or] = ACTIONS(5547),
    [anon_sym_and] = ACTIONS(5547),
    [anon_sym_bitor] = ACTIONS(5547),
    [anon_sym_xor] = ACTIONS(5547),
    [anon_sym_bitand] = ACTIONS(5547),
    [anon_sym_not_eq] = ACTIONS(5547),
    [anon_sym_DASH_DASH] = ACTIONS(5547),
    [anon_sym_PLUS_PLUS] = ACTIONS(5547),
    [anon_sym_DOT] = ACTIONS(5545),
    [anon_sym_DOT_STAR] = ACTIONS(5547),
    [anon_sym_DASH_GT] = ACTIONS(5547),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5547),
    [anon_sym_decltype] = ACTIONS(5547),
    [anon_sym_final] = ACTIONS(5547),
    [anon_sym_override] = ACTIONS(5547),
    [anon_sym_requires] = ACTIONS(5547),
  },
  [1891] = {
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(4769),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(2033),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2336),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(6493),
    [sym_qualified_type_identifier] = STATE(2978),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(5025),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5027),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
  },
  [1892] = {
    [sym_identifier] = ACTIONS(1909),
    [aux_sym_preproc_def_token1] = ACTIONS(1909),
    [aux_sym_preproc_if_token1] = ACTIONS(1909),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1909),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1909),
    [sym_preproc_directive] = ACTIONS(1909),
    [anon_sym_LPAREN2] = ACTIONS(1907),
    [anon_sym_TILDE] = ACTIONS(1907),
    [anon_sym_STAR] = ACTIONS(1907),
    [anon_sym_AMP_AMP] = ACTIONS(1907),
    [anon_sym_AMP] = ACTIONS(1909),
    [anon_sym_SEMI] = ACTIONS(1907),
    [anon_sym___extension__] = ACTIONS(1909),
    [anon_sym_typedef] = ACTIONS(1909),
    [anon_sym_virtual] = ACTIONS(1909),
    [anon_sym_extern] = ACTIONS(1909),
    [anon_sym___attribute__] = ACTIONS(1909),
    [anon_sym___attribute] = ACTIONS(1909),
    [anon_sym_COLON_COLON] = ACTIONS(1907),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1907),
    [anon_sym___declspec] = ACTIONS(1909),
    [anon_sym___based] = ACTIONS(1909),
    [anon_sym_RBRACE] = ACTIONS(1907),
    [anon_sym_signed] = ACTIONS(1909),
    [anon_sym_unsigned] = ACTIONS(1909),
    [anon_sym_long] = ACTIONS(1909),
    [anon_sym_short] = ACTIONS(1909),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_static] = ACTIONS(1909),
    [anon_sym_register] = ACTIONS(1909),
    [anon_sym_inline] = ACTIONS(1909),
    [anon_sym___inline] = ACTIONS(1909),
    [anon_sym___inline__] = ACTIONS(1909),
    [anon_sym___forceinline] = ACTIONS(1909),
    [anon_sym_thread_local] = ACTIONS(1909),
    [anon_sym___thread] = ACTIONS(1909),
    [anon_sym_const] = ACTIONS(1909),
    [anon_sym_constexpr] = ACTIONS(1909),
    [anon_sym_volatile] = ACTIONS(1909),
    [anon_sym_restrict] = ACTIONS(1909),
    [anon_sym___restrict__] = ACTIONS(1909),
    [anon_sym__Atomic] = ACTIONS(1909),
    [anon_sym__Noreturn] = ACTIONS(1909),
    [anon_sym_noreturn] = ACTIONS(1909),
    [anon_sym__Nonnull] = ACTIONS(1909),
    [anon_sym_mutable] = ACTIONS(1909),
    [anon_sym_constinit] = ACTIONS(1909),
    [anon_sym_consteval] = ACTIONS(1909),
    [anon_sym_alignas] = ACTIONS(1909),
    [anon_sym__Alignas] = ACTIONS(1909),
    [sym_primitive_type] = ACTIONS(1909),
    [anon_sym_enum] = ACTIONS(1909),
    [anon_sym_class] = ACTIONS(1909),
    [anon_sym_struct] = ACTIONS(1909),
    [anon_sym_union] = ACTIONS(1909),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1909),
    [anon_sym_decltype] = ACTIONS(1909),
    [anon_sym_explicit] = ACTIONS(1909),
    [anon_sym_typename] = ACTIONS(1909),
    [anon_sym_template] = ACTIONS(1909),
    [anon_sym_operator] = ACTIONS(1909),
    [anon_sym_friend] = ACTIONS(1909),
    [anon_sym_public] = ACTIONS(1909),
    [anon_sym_private] = ACTIONS(1909),
    [anon_sym_protected] = ACTIONS(1909),
    [anon_sym_using] = ACTIONS(1909),
    [anon_sym_static_assert] = ACTIONS(1909),
    [anon_sym_catch] = ACTIONS(1909),
  },
  [1893] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1880),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5433),
    [anon_sym_COMMA] = ACTIONS(5433),
    [anon_sym_RPAREN] = ACTIONS(5433),
    [anon_sym_LPAREN2] = ACTIONS(5433),
    [anon_sym_DASH] = ACTIONS(5431),
    [anon_sym_PLUS] = ACTIONS(5431),
    [anon_sym_STAR] = ACTIONS(5433),
    [anon_sym_SLASH] = ACTIONS(5431),
    [anon_sym_PERCENT] = ACTIONS(5433),
    [anon_sym_PIPE_PIPE] = ACTIONS(5433),
    [anon_sym_AMP_AMP] = ACTIONS(5433),
    [anon_sym_PIPE] = ACTIONS(5431),
    [anon_sym_CARET] = ACTIONS(5433),
    [anon_sym_AMP] = ACTIONS(5431),
    [anon_sym_EQ_EQ] = ACTIONS(5433),
    [anon_sym_BANG_EQ] = ACTIONS(5433),
    [anon_sym_GT] = ACTIONS(5431),
    [anon_sym_GT_EQ] = ACTIONS(5433),
    [anon_sym_LT_EQ] = ACTIONS(5431),
    [anon_sym_LT] = ACTIONS(5431),
    [anon_sym_LT_LT] = ACTIONS(5433),
    [anon_sym_GT_GT] = ACTIONS(5433),
    [anon_sym_SEMI] = ACTIONS(5433),
    [anon_sym___extension__] = ACTIONS(5433),
    [anon_sym___attribute__] = ACTIONS(5433),
    [anon_sym___attribute] = ACTIONS(5431),
    [anon_sym_LBRACE] = ACTIONS(5433),
    [anon_sym_RBRACE] = ACTIONS(5433),
    [anon_sym_signed] = ACTIONS(5784),
    [anon_sym_unsigned] = ACTIONS(5784),
    [anon_sym_long] = ACTIONS(5784),
    [anon_sym_short] = ACTIONS(5784),
    [anon_sym_LBRACK] = ACTIONS(5433),
    [anon_sym_RBRACK] = ACTIONS(5433),
    [anon_sym_const] = ACTIONS(5431),
    [anon_sym_constexpr] = ACTIONS(5433),
    [anon_sym_volatile] = ACTIONS(5433),
    [anon_sym_restrict] = ACTIONS(5433),
    [anon_sym___restrict__] = ACTIONS(5433),
    [anon_sym__Atomic] = ACTIONS(5433),
    [anon_sym__Noreturn] = ACTIONS(5433),
    [anon_sym_noreturn] = ACTIONS(5433),
    [anon_sym__Nonnull] = ACTIONS(5433),
    [anon_sym_mutable] = ACTIONS(5433),
    [anon_sym_constinit] = ACTIONS(5433),
    [anon_sym_consteval] = ACTIONS(5433),
    [anon_sym_alignas] = ACTIONS(5433),
    [anon_sym__Alignas] = ACTIONS(5433),
    [anon_sym_COLON] = ACTIONS(5433),
    [anon_sym_QMARK] = ACTIONS(5433),
    [anon_sym_LT_EQ_GT] = ACTIONS(5433),
    [anon_sym_or] = ACTIONS(5433),
    [anon_sym_and] = ACTIONS(5433),
    [anon_sym_bitor] = ACTIONS(5433),
    [anon_sym_xor] = ACTIONS(5433),
    [anon_sym_bitand] = ACTIONS(5433),
    [anon_sym_not_eq] = ACTIONS(5433),
    [anon_sym_DASH_DASH] = ACTIONS(5433),
    [anon_sym_PLUS_PLUS] = ACTIONS(5433),
    [anon_sym_DOT] = ACTIONS(5431),
    [anon_sym_DOT_STAR] = ACTIONS(5433),
    [anon_sym_DASH_GT] = ACTIONS(5433),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5433),
    [anon_sym_decltype] = ACTIONS(5433),
    [anon_sym_final] = ACTIONS(5433),
    [anon_sym_override] = ACTIONS(5433),
    [anon_sym_requires] = ACTIONS(5433),
  },
  [1894] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1894),
    [sym_identifier] = ACTIONS(4932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4934),
    [anon_sym_COMMA] = ACTIONS(4934),
    [anon_sym_RPAREN] = ACTIONS(4934),
    [anon_sym_LPAREN2] = ACTIONS(4934),
    [anon_sym_TILDE] = ACTIONS(4934),
    [anon_sym_STAR] = ACTIONS(4934),
    [anon_sym_AMP_AMP] = ACTIONS(4934),
    [anon_sym_AMP] = ACTIONS(4932),
    [anon_sym_SEMI] = ACTIONS(4934),
    [anon_sym___extension__] = ACTIONS(4932),
    [anon_sym_virtual] = ACTIONS(4932),
    [anon_sym_extern] = ACTIONS(4932),
    [anon_sym___attribute__] = ACTIONS(4932),
    [anon_sym___attribute] = ACTIONS(4932),
    [anon_sym_COLON_COLON] = ACTIONS(4934),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4934),
    [anon_sym___declspec] = ACTIONS(4932),
    [anon_sym___based] = ACTIONS(4932),
    [anon_sym___cdecl] = ACTIONS(4932),
    [anon_sym___clrcall] = ACTIONS(4932),
    [anon_sym___stdcall] = ACTIONS(4932),
    [anon_sym___fastcall] = ACTIONS(4932),
    [anon_sym___thiscall] = ACTIONS(4932),
    [anon_sym___vectorcall] = ACTIONS(4932),
    [anon_sym_LBRACE] = ACTIONS(4934),
    [anon_sym_signed] = ACTIONS(5786),
    [anon_sym_unsigned] = ACTIONS(5786),
    [anon_sym_long] = ACTIONS(5786),
    [anon_sym_short] = ACTIONS(5786),
    [anon_sym_LBRACK] = ACTIONS(4932),
    [anon_sym_static] = ACTIONS(4932),
    [anon_sym_EQ] = ACTIONS(4934),
    [anon_sym_register] = ACTIONS(4932),
    [anon_sym_inline] = ACTIONS(4932),
    [anon_sym___inline] = ACTIONS(4932),
    [anon_sym___inline__] = ACTIONS(4932),
    [anon_sym___forceinline] = ACTIONS(4932),
    [anon_sym_thread_local] = ACTIONS(4932),
    [anon_sym___thread] = ACTIONS(4932),
    [anon_sym_const] = ACTIONS(4932),
    [anon_sym_constexpr] = ACTIONS(4932),
    [anon_sym_volatile] = ACTIONS(4932),
    [anon_sym_restrict] = ACTIONS(4932),
    [anon_sym___restrict__] = ACTIONS(4932),
    [anon_sym__Atomic] = ACTIONS(4932),
    [anon_sym__Noreturn] = ACTIONS(4932),
    [anon_sym_noreturn] = ACTIONS(4932),
    [anon_sym__Nonnull] = ACTIONS(4932),
    [anon_sym_mutable] = ACTIONS(4932),
    [anon_sym_constinit] = ACTIONS(4932),
    [anon_sym_consteval] = ACTIONS(4932),
    [anon_sym_alignas] = ACTIONS(4932),
    [anon_sym__Alignas] = ACTIONS(4932),
    [sym_primitive_type] = ACTIONS(4932),
    [anon_sym_asm] = ACTIONS(4932),
    [anon_sym___asm__] = ACTIONS(4932),
    [anon_sym___asm] = ACTIONS(4932),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4932),
    [anon_sym_decltype] = ACTIONS(4932),
    [anon_sym_final] = ACTIONS(4932),
    [anon_sym_override] = ACTIONS(4932),
    [anon_sym_template] = ACTIONS(4932),
    [anon_sym_GT2] = ACTIONS(4934),
    [anon_sym_operator] = ACTIONS(4932),
    [anon_sym_try] = ACTIONS(4932),
    [anon_sym_requires] = ACTIONS(4932),
  },
  [1895] = {
    [sym_identifier] = ACTIONS(5361),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5363),
    [anon_sym_COMMA] = ACTIONS(5363),
    [anon_sym_RPAREN] = ACTIONS(5363),
    [aux_sym_preproc_if_token2] = ACTIONS(5363),
    [aux_sym_preproc_else_token1] = ACTIONS(5363),
    [aux_sym_preproc_elif_token1] = ACTIONS(5361),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5363),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5363),
    [anon_sym_LPAREN2] = ACTIONS(5363),
    [anon_sym_DASH] = ACTIONS(5361),
    [anon_sym_PLUS] = ACTIONS(5361),
    [anon_sym_STAR] = ACTIONS(5361),
    [anon_sym_SLASH] = ACTIONS(5361),
    [anon_sym_PERCENT] = ACTIONS(5361),
    [anon_sym_PIPE_PIPE] = ACTIONS(5363),
    [anon_sym_AMP_AMP] = ACTIONS(5363),
    [anon_sym_PIPE] = ACTIONS(5361),
    [anon_sym_CARET] = ACTIONS(5361),
    [anon_sym_AMP] = ACTIONS(5361),
    [anon_sym_EQ_EQ] = ACTIONS(5363),
    [anon_sym_BANG_EQ] = ACTIONS(5363),
    [anon_sym_GT] = ACTIONS(5361),
    [anon_sym_GT_EQ] = ACTIONS(5363),
    [anon_sym_LT_EQ] = ACTIONS(5361),
    [anon_sym_LT] = ACTIONS(5361),
    [anon_sym_LT_LT] = ACTIONS(5361),
    [anon_sym_GT_GT] = ACTIONS(5361),
    [anon_sym_SEMI] = ACTIONS(5363),
    [anon_sym___attribute__] = ACTIONS(5361),
    [anon_sym___attribute] = ACTIONS(5361),
    [anon_sym_COLON_COLON] = ACTIONS(5365),
    [anon_sym_LBRACE] = ACTIONS(5363),
    [anon_sym_RBRACE] = ACTIONS(5363),
    [anon_sym_LBRACK] = ACTIONS(5363),
    [anon_sym_RBRACK] = ACTIONS(5363),
    [anon_sym_EQ] = ACTIONS(5361),
    [anon_sym_COLON] = ACTIONS(5361),
    [anon_sym_QMARK] = ACTIONS(5363),
    [anon_sym_STAR_EQ] = ACTIONS(5363),
    [anon_sym_SLASH_EQ] = ACTIONS(5363),
    [anon_sym_PERCENT_EQ] = ACTIONS(5363),
    [anon_sym_PLUS_EQ] = ACTIONS(5363),
    [anon_sym_DASH_EQ] = ACTIONS(5363),
    [anon_sym_LT_LT_EQ] = ACTIONS(5363),
    [anon_sym_GT_GT_EQ] = ACTIONS(5363),
    [anon_sym_AMP_EQ] = ACTIONS(5363),
    [anon_sym_CARET_EQ] = ACTIONS(5363),
    [anon_sym_PIPE_EQ] = ACTIONS(5363),
    [anon_sym_and_eq] = ACTIONS(5361),
    [anon_sym_or_eq] = ACTIONS(5361),
    [anon_sym_xor_eq] = ACTIONS(5361),
    [anon_sym_LT_EQ_GT] = ACTIONS(5363),
    [anon_sym_or] = ACTIONS(5361),
    [anon_sym_and] = ACTIONS(5361),
    [anon_sym_bitor] = ACTIONS(5361),
    [anon_sym_xor] = ACTIONS(5361),
    [anon_sym_bitand] = ACTIONS(5361),
    [anon_sym_not_eq] = ACTIONS(5361),
    [anon_sym_DASH_DASH] = ACTIONS(5363),
    [anon_sym_PLUS_PLUS] = ACTIONS(5363),
    [anon_sym_DOT] = ACTIONS(5361),
    [anon_sym_DOT_STAR] = ACTIONS(5363),
    [anon_sym_DASH_GT] = ACTIONS(5363),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5361),
    [anon_sym_decltype] = ACTIONS(5361),
    [anon_sym_final] = ACTIONS(5361),
    [anon_sym_override] = ACTIONS(5361),
  },
  [1896] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5789),
    [anon_sym_COMMA] = ACTIONS(5789),
    [anon_sym_RPAREN] = ACTIONS(5789),
    [anon_sym_LPAREN2] = ACTIONS(5789),
    [anon_sym_DASH] = ACTIONS(5791),
    [anon_sym_PLUS] = ACTIONS(5791),
    [anon_sym_STAR] = ACTIONS(5789),
    [anon_sym_SLASH] = ACTIONS(5791),
    [anon_sym_PERCENT] = ACTIONS(5789),
    [anon_sym_PIPE_PIPE] = ACTIONS(5789),
    [anon_sym_AMP_AMP] = ACTIONS(5789),
    [anon_sym_PIPE] = ACTIONS(5791),
    [anon_sym_CARET] = ACTIONS(5789),
    [anon_sym_AMP] = ACTIONS(5791),
    [anon_sym_EQ_EQ] = ACTIONS(5789),
    [anon_sym_BANG_EQ] = ACTIONS(5789),
    [anon_sym_GT] = ACTIONS(5791),
    [anon_sym_GT_EQ] = ACTIONS(5789),
    [anon_sym_LT_EQ] = ACTIONS(5791),
    [anon_sym_LT] = ACTIONS(5791),
    [anon_sym_LT_LT] = ACTIONS(5789),
    [anon_sym_GT_GT] = ACTIONS(5789),
    [anon_sym_SEMI] = ACTIONS(5789),
    [anon_sym___extension__] = ACTIONS(5789),
    [anon_sym___attribute__] = ACTIONS(5789),
    [anon_sym___attribute] = ACTIONS(5791),
    [anon_sym_LBRACE] = ACTIONS(5789),
    [anon_sym_RBRACE] = ACTIONS(5789),
    [anon_sym_signed] = ACTIONS(5754),
    [anon_sym_unsigned] = ACTIONS(5754),
    [anon_sym_long] = ACTIONS(5754),
    [anon_sym_short] = ACTIONS(5754),
    [anon_sym_LBRACK] = ACTIONS(5789),
    [anon_sym_RBRACK] = ACTIONS(5789),
    [anon_sym_const] = ACTIONS(5791),
    [anon_sym_constexpr] = ACTIONS(5789),
    [anon_sym_volatile] = ACTIONS(5789),
    [anon_sym_restrict] = ACTIONS(5789),
    [anon_sym___restrict__] = ACTIONS(5789),
    [anon_sym__Atomic] = ACTIONS(5789),
    [anon_sym__Noreturn] = ACTIONS(5789),
    [anon_sym_noreturn] = ACTIONS(5789),
    [anon_sym__Nonnull] = ACTIONS(5789),
    [anon_sym_mutable] = ACTIONS(5789),
    [anon_sym_constinit] = ACTIONS(5789),
    [anon_sym_consteval] = ACTIONS(5789),
    [anon_sym_alignas] = ACTIONS(5789),
    [anon_sym__Alignas] = ACTIONS(5789),
    [anon_sym_COLON] = ACTIONS(5789),
    [anon_sym_QMARK] = ACTIONS(5789),
    [anon_sym_LT_EQ_GT] = ACTIONS(5789),
    [anon_sym_or] = ACTIONS(5789),
    [anon_sym_and] = ACTIONS(5789),
    [anon_sym_bitor] = ACTIONS(5789),
    [anon_sym_xor] = ACTIONS(5789),
    [anon_sym_bitand] = ACTIONS(5789),
    [anon_sym_not_eq] = ACTIONS(5789),
    [anon_sym_DASH_DASH] = ACTIONS(5789),
    [anon_sym_PLUS_PLUS] = ACTIONS(5789),
    [anon_sym_DOT] = ACTIONS(5791),
    [anon_sym_DOT_STAR] = ACTIONS(5789),
    [anon_sym_DASH_GT] = ACTIONS(5789),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5789),
    [anon_sym_decltype] = ACTIONS(5789),
    [anon_sym_final] = ACTIONS(5789),
    [anon_sym_override] = ACTIONS(5789),
    [anon_sym_requires] = ACTIONS(5789),
  },
  [1897] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5793),
    [anon_sym_COMMA] = ACTIONS(5793),
    [anon_sym_RPAREN] = ACTIONS(5793),
    [anon_sym_LPAREN2] = ACTIONS(5793),
    [anon_sym_DASH] = ACTIONS(5795),
    [anon_sym_PLUS] = ACTIONS(5795),
    [anon_sym_STAR] = ACTIONS(5793),
    [anon_sym_SLASH] = ACTIONS(5795),
    [anon_sym_PERCENT] = ACTIONS(5793),
    [anon_sym_PIPE_PIPE] = ACTIONS(5793),
    [anon_sym_AMP_AMP] = ACTIONS(5793),
    [anon_sym_PIPE] = ACTIONS(5795),
    [anon_sym_CARET] = ACTIONS(5793),
    [anon_sym_AMP] = ACTIONS(5795),
    [anon_sym_EQ_EQ] = ACTIONS(5793),
    [anon_sym_BANG_EQ] = ACTIONS(5793),
    [anon_sym_GT] = ACTIONS(5795),
    [anon_sym_GT_EQ] = ACTIONS(5793),
    [anon_sym_LT_EQ] = ACTIONS(5795),
    [anon_sym_LT] = ACTIONS(5795),
    [anon_sym_LT_LT] = ACTIONS(5793),
    [anon_sym_GT_GT] = ACTIONS(5793),
    [anon_sym_SEMI] = ACTIONS(5793),
    [anon_sym___extension__] = ACTIONS(5793),
    [anon_sym___attribute__] = ACTIONS(5793),
    [anon_sym___attribute] = ACTIONS(5795),
    [anon_sym_LBRACE] = ACTIONS(5793),
    [anon_sym_RBRACE] = ACTIONS(5793),
    [anon_sym_signed] = ACTIONS(5754),
    [anon_sym_unsigned] = ACTIONS(5754),
    [anon_sym_long] = ACTIONS(5754),
    [anon_sym_short] = ACTIONS(5754),
    [anon_sym_LBRACK] = ACTIONS(5793),
    [anon_sym_RBRACK] = ACTIONS(5793),
    [anon_sym_const] = ACTIONS(5795),
    [anon_sym_constexpr] = ACTIONS(5793),
    [anon_sym_volatile] = ACTIONS(5793),
    [anon_sym_restrict] = ACTIONS(5793),
    [anon_sym___restrict__] = ACTIONS(5793),
    [anon_sym__Atomic] = ACTIONS(5793),
    [anon_sym__Noreturn] = ACTIONS(5793),
    [anon_sym_noreturn] = ACTIONS(5793),
    [anon_sym__Nonnull] = ACTIONS(5793),
    [anon_sym_mutable] = ACTIONS(5793),
    [anon_sym_constinit] = ACTIONS(5793),
    [anon_sym_consteval] = ACTIONS(5793),
    [anon_sym_alignas] = ACTIONS(5793),
    [anon_sym__Alignas] = ACTIONS(5793),
    [anon_sym_COLON] = ACTIONS(5793),
    [anon_sym_QMARK] = ACTIONS(5793),
    [anon_sym_LT_EQ_GT] = ACTIONS(5793),
    [anon_sym_or] = ACTIONS(5793),
    [anon_sym_and] = ACTIONS(5793),
    [anon_sym_bitor] = ACTIONS(5793),
    [anon_sym_xor] = ACTIONS(5793),
    [anon_sym_bitand] = ACTIONS(5793),
    [anon_sym_not_eq] = ACTIONS(5793),
    [anon_sym_DASH_DASH] = ACTIONS(5793),
    [anon_sym_PLUS_PLUS] = ACTIONS(5793),
    [anon_sym_DOT] = ACTIONS(5795),
    [anon_sym_DOT_STAR] = ACTIONS(5793),
    [anon_sym_DASH_GT] = ACTIONS(5793),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5793),
    [anon_sym_decltype] = ACTIONS(5793),
    [anon_sym_final] = ACTIONS(5793),
    [anon_sym_override] = ACTIONS(5793),
    [anon_sym_requires] = ACTIONS(5793),
  },
  [1898] = {
    [sym_identifier] = ACTIONS(1913),
    [aux_sym_preproc_def_token1] = ACTIONS(1913),
    [anon_sym_COMMA] = ACTIONS(2721),
    [aux_sym_preproc_if_token1] = ACTIONS(1913),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1913),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1913),
    [sym_preproc_directive] = ACTIONS(1913),
    [anon_sym_LPAREN2] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_AMP_AMP] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1913),
    [anon_sym_SEMI] = ACTIONS(2721),
    [anon_sym___extension__] = ACTIONS(1913),
    [anon_sym_typedef] = ACTIONS(1913),
    [anon_sym_virtual] = ACTIONS(1913),
    [anon_sym_extern] = ACTIONS(1913),
    [anon_sym___attribute__] = ACTIONS(5305),
    [anon_sym___attribute] = ACTIONS(5305),
    [anon_sym_COLON_COLON] = ACTIONS(1911),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1911),
    [anon_sym___declspec] = ACTIONS(1913),
    [anon_sym___based] = ACTIONS(1913),
    [anon_sym_RBRACE] = ACTIONS(1911),
    [anon_sym_signed] = ACTIONS(1913),
    [anon_sym_unsigned] = ACTIONS(1913),
    [anon_sym_long] = ACTIONS(1913),
    [anon_sym_short] = ACTIONS(1913),
    [anon_sym_LBRACK] = ACTIONS(1913),
    [anon_sym_static] = ACTIONS(1913),
    [anon_sym_register] = ACTIONS(1913),
    [anon_sym_inline] = ACTIONS(1913),
    [anon_sym___inline] = ACTIONS(1913),
    [anon_sym___inline__] = ACTIONS(1913),
    [anon_sym___forceinline] = ACTIONS(1913),
    [anon_sym_thread_local] = ACTIONS(1913),
    [anon_sym___thread] = ACTIONS(1913),
    [anon_sym_const] = ACTIONS(1913),
    [anon_sym_constexpr] = ACTIONS(1913),
    [anon_sym_volatile] = ACTIONS(1913),
    [anon_sym_restrict] = ACTIONS(1913),
    [anon_sym___restrict__] = ACTIONS(1913),
    [anon_sym__Atomic] = ACTIONS(1913),
    [anon_sym__Noreturn] = ACTIONS(1913),
    [anon_sym_noreturn] = ACTIONS(1913),
    [anon_sym__Nonnull] = ACTIONS(1913),
    [anon_sym_mutable] = ACTIONS(1913),
    [anon_sym_constinit] = ACTIONS(1913),
    [anon_sym_consteval] = ACTIONS(1913),
    [anon_sym_alignas] = ACTIONS(1913),
    [anon_sym__Alignas] = ACTIONS(1913),
    [sym_primitive_type] = ACTIONS(1913),
    [anon_sym_enum] = ACTIONS(1913),
    [anon_sym_class] = ACTIONS(1913),
    [anon_sym_struct] = ACTIONS(1913),
    [anon_sym_union] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1913),
    [anon_sym_decltype] = ACTIONS(1913),
    [anon_sym_explicit] = ACTIONS(1913),
    [anon_sym_typename] = ACTIONS(1913),
    [anon_sym_template] = ACTIONS(1913),
    [anon_sym_operator] = ACTIONS(1913),
    [anon_sym_friend] = ACTIONS(1913),
    [anon_sym_public] = ACTIONS(1913),
    [anon_sym_private] = ACTIONS(1913),
    [anon_sym_protected] = ACTIONS(1913),
    [anon_sym_using] = ACTIONS(1913),
    [anon_sym_static_assert] = ACTIONS(1913),
  },
  [1899] = {
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(4757),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(2033),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2336),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(6493),
    [sym_qualified_type_identifier] = STATE(2978),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(5025),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5027),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
  },
  [1900] = {
    [sym_string_literal] = STATE(1656),
    [sym_raw_string_literal] = STATE(1656),
    [sym_identifier] = ACTIONS(5797),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5799),
    [anon_sym_COMMA] = ACTIONS(5799),
    [aux_sym_preproc_if_token2] = ACTIONS(5799),
    [aux_sym_preproc_else_token1] = ACTIONS(5799),
    [aux_sym_preproc_elif_token1] = ACTIONS(5797),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5799),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5799),
    [anon_sym_LPAREN2] = ACTIONS(5799),
    [anon_sym_DASH] = ACTIONS(5797),
    [anon_sym_PLUS] = ACTIONS(5797),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_SLASH] = ACTIONS(5797),
    [anon_sym_PERCENT] = ACTIONS(5797),
    [anon_sym_PIPE_PIPE] = ACTIONS(5799),
    [anon_sym_AMP_AMP] = ACTIONS(5799),
    [anon_sym_PIPE] = ACTIONS(5797),
    [anon_sym_CARET] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5797),
    [anon_sym_EQ_EQ] = ACTIONS(5799),
    [anon_sym_BANG_EQ] = ACTIONS(5799),
    [anon_sym_GT] = ACTIONS(5797),
    [anon_sym_GT_EQ] = ACTIONS(5799),
    [anon_sym_LT_EQ] = ACTIONS(5797),
    [anon_sym_LT] = ACTIONS(5797),
    [anon_sym_LT_LT] = ACTIONS(5797),
    [anon_sym_GT_GT] = ACTIONS(5797),
    [anon_sym_LBRACK] = ACTIONS(5799),
    [anon_sym_EQ] = ACTIONS(5797),
    [anon_sym_QMARK] = ACTIONS(5799),
    [anon_sym_STAR_EQ] = ACTIONS(5799),
    [anon_sym_SLASH_EQ] = ACTIONS(5799),
    [anon_sym_PERCENT_EQ] = ACTIONS(5799),
    [anon_sym_PLUS_EQ] = ACTIONS(5799),
    [anon_sym_DASH_EQ] = ACTIONS(5799),
    [anon_sym_LT_LT_EQ] = ACTIONS(5799),
    [anon_sym_GT_GT_EQ] = ACTIONS(5799),
    [anon_sym_AMP_EQ] = ACTIONS(5799),
    [anon_sym_CARET_EQ] = ACTIONS(5799),
    [anon_sym_PIPE_EQ] = ACTIONS(5799),
    [anon_sym_and_eq] = ACTIONS(5797),
    [anon_sym_or_eq] = ACTIONS(5797),
    [anon_sym_xor_eq] = ACTIONS(5797),
    [anon_sym_LT_EQ_GT] = ACTIONS(5799),
    [anon_sym_or] = ACTIONS(5797),
    [anon_sym_and] = ACTIONS(5797),
    [anon_sym_bitor] = ACTIONS(5797),
    [anon_sym_xor] = ACTIONS(5797),
    [anon_sym_bitand] = ACTIONS(5797),
    [anon_sym_not_eq] = ACTIONS(5797),
    [anon_sym_DASH_DASH] = ACTIONS(5799),
    [anon_sym_PLUS_PLUS] = ACTIONS(5799),
    [anon_sym_DOT] = ACTIONS(5797),
    [anon_sym_DOT_STAR] = ACTIONS(5799),
    [anon_sym_DASH_GT] = ACTIONS(5799),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(1955),
    [anon_sym_LR_DQUOTE] = ACTIONS(1955),
    [anon_sym_uR_DQUOTE] = ACTIONS(1955),
    [anon_sym_UR_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1955),
    [sym_literal_suffix] = ACTIONS(5797),
  },
  [1901] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5801),
    [anon_sym_COMMA] = ACTIONS(5801),
    [anon_sym_RPAREN] = ACTIONS(5801),
    [anon_sym_LPAREN2] = ACTIONS(5801),
    [anon_sym_DASH] = ACTIONS(5803),
    [anon_sym_PLUS] = ACTIONS(5803),
    [anon_sym_STAR] = ACTIONS(5801),
    [anon_sym_SLASH] = ACTIONS(5803),
    [anon_sym_PERCENT] = ACTIONS(5801),
    [anon_sym_PIPE_PIPE] = ACTIONS(5801),
    [anon_sym_AMP_AMP] = ACTIONS(5801),
    [anon_sym_PIPE] = ACTIONS(5803),
    [anon_sym_CARET] = ACTIONS(5801),
    [anon_sym_AMP] = ACTIONS(5803),
    [anon_sym_EQ_EQ] = ACTIONS(5801),
    [anon_sym_BANG_EQ] = ACTIONS(5801),
    [anon_sym_GT] = ACTIONS(5803),
    [anon_sym_GT_EQ] = ACTIONS(5801),
    [anon_sym_LT_EQ] = ACTIONS(5803),
    [anon_sym_LT] = ACTIONS(5803),
    [anon_sym_LT_LT] = ACTIONS(5801),
    [anon_sym_GT_GT] = ACTIONS(5801),
    [anon_sym_SEMI] = ACTIONS(5801),
    [anon_sym___extension__] = ACTIONS(5801),
    [anon_sym___attribute__] = ACTIONS(5801),
    [anon_sym___attribute] = ACTIONS(5803),
    [anon_sym_LBRACE] = ACTIONS(5801),
    [anon_sym_RBRACE] = ACTIONS(5801),
    [anon_sym_signed] = ACTIONS(5805),
    [anon_sym_unsigned] = ACTIONS(5805),
    [anon_sym_long] = ACTIONS(5805),
    [anon_sym_short] = ACTIONS(5805),
    [anon_sym_LBRACK] = ACTIONS(5801),
    [anon_sym_RBRACK] = ACTIONS(5801),
    [anon_sym_const] = ACTIONS(5803),
    [anon_sym_constexpr] = ACTIONS(5801),
    [anon_sym_volatile] = ACTIONS(5801),
    [anon_sym_restrict] = ACTIONS(5801),
    [anon_sym___restrict__] = ACTIONS(5801),
    [anon_sym__Atomic] = ACTIONS(5801),
    [anon_sym__Noreturn] = ACTIONS(5801),
    [anon_sym_noreturn] = ACTIONS(5801),
    [anon_sym__Nonnull] = ACTIONS(5801),
    [anon_sym_mutable] = ACTIONS(5801),
    [anon_sym_constinit] = ACTIONS(5801),
    [anon_sym_consteval] = ACTIONS(5801),
    [anon_sym_alignas] = ACTIONS(5801),
    [anon_sym__Alignas] = ACTIONS(5801),
    [anon_sym_COLON] = ACTIONS(5801),
    [anon_sym_QMARK] = ACTIONS(5801),
    [anon_sym_LT_EQ_GT] = ACTIONS(5801),
    [anon_sym_or] = ACTIONS(5801),
    [anon_sym_and] = ACTIONS(5801),
    [anon_sym_bitor] = ACTIONS(5801),
    [anon_sym_xor] = ACTIONS(5801),
    [anon_sym_bitand] = ACTIONS(5801),
    [anon_sym_not_eq] = ACTIONS(5801),
    [anon_sym_DASH_DASH] = ACTIONS(5801),
    [anon_sym_PLUS_PLUS] = ACTIONS(5801),
    [anon_sym_DOT] = ACTIONS(5803),
    [anon_sym_DOT_STAR] = ACTIONS(5801),
    [anon_sym_DASH_GT] = ACTIONS(5801),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5801),
    [anon_sym_decltype] = ACTIONS(5801),
    [anon_sym_final] = ACTIONS(5801),
    [anon_sym_override] = ACTIONS(5801),
    [anon_sym_requires] = ACTIONS(5801),
  },
  [1902] = {
    [sym__declaration_modifiers] = STATE(2033),
    [sym__declaration_specifiers] = STATE(4763),
    [sym_attribute_specifier] = STATE(2033),
    [sym_attribute_declaration] = STATE(2033),
    [sym_ms_declspec_modifier] = STATE(2033),
    [sym_storage_class_specifier] = STATE(2033),
    [sym_type_qualifier] = STATE(2033),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2357),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2336),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(6493),
    [sym_qualified_type_identifier] = STATE(2978),
    [aux_sym__declaration_specifiers_repeat1] = STATE(2033),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(5025),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(1229),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5027),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
  },
  [1903] = {
    [sym_identifier] = ACTIONS(1909),
    [aux_sym_preproc_def_token1] = ACTIONS(1909),
    [aux_sym_preproc_if_token1] = ACTIONS(1909),
    [aux_sym_preproc_if_token2] = ACTIONS(1909),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(1909),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(1909),
    [sym_preproc_directive] = ACTIONS(1909),
    [anon_sym_LPAREN2] = ACTIONS(1907),
    [anon_sym_TILDE] = ACTIONS(1907),
    [anon_sym_STAR] = ACTIONS(1907),
    [anon_sym_AMP_AMP] = ACTIONS(1907),
    [anon_sym_AMP] = ACTIONS(1909),
    [anon_sym_SEMI] = ACTIONS(1907),
    [anon_sym___extension__] = ACTIONS(1909),
    [anon_sym_typedef] = ACTIONS(1909),
    [anon_sym_virtual] = ACTIONS(1909),
    [anon_sym_extern] = ACTIONS(1909),
    [anon_sym___attribute__] = ACTIONS(1909),
    [anon_sym___attribute] = ACTIONS(1909),
    [anon_sym_COLON_COLON] = ACTIONS(1907),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1907),
    [anon_sym___declspec] = ACTIONS(1909),
    [anon_sym___based] = ACTIONS(1909),
    [anon_sym_signed] = ACTIONS(1909),
    [anon_sym_unsigned] = ACTIONS(1909),
    [anon_sym_long] = ACTIONS(1909),
    [anon_sym_short] = ACTIONS(1909),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_static] = ACTIONS(1909),
    [anon_sym_register] = ACTIONS(1909),
    [anon_sym_inline] = ACTIONS(1909),
    [anon_sym___inline] = ACTIONS(1909),
    [anon_sym___inline__] = ACTIONS(1909),
    [anon_sym___forceinline] = ACTIONS(1909),
    [anon_sym_thread_local] = ACTIONS(1909),
    [anon_sym___thread] = ACTIONS(1909),
    [anon_sym_const] = ACTIONS(1909),
    [anon_sym_constexpr] = ACTIONS(1909),
    [anon_sym_volatile] = ACTIONS(1909),
    [anon_sym_restrict] = ACTIONS(1909),
    [anon_sym___restrict__] = ACTIONS(1909),
    [anon_sym__Atomic] = ACTIONS(1909),
    [anon_sym__Noreturn] = ACTIONS(1909),
    [anon_sym_noreturn] = ACTIONS(1909),
    [anon_sym__Nonnull] = ACTIONS(1909),
    [anon_sym_mutable] = ACTIONS(1909),
    [anon_sym_constinit] = ACTIONS(1909),
    [anon_sym_consteval] = ACTIONS(1909),
    [anon_sym_alignas] = ACTIONS(1909),
    [anon_sym__Alignas] = ACTIONS(1909),
    [sym_primitive_type] = ACTIONS(1909),
    [anon_sym_enum] = ACTIONS(1909),
    [anon_sym_class] = ACTIONS(1909),
    [anon_sym_struct] = ACTIONS(1909),
    [anon_sym_union] = ACTIONS(1909),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1909),
    [anon_sym_decltype] = ACTIONS(1909),
    [anon_sym_explicit] = ACTIONS(1909),
    [anon_sym_typename] = ACTIONS(1909),
    [anon_sym_template] = ACTIONS(1909),
    [anon_sym_operator] = ACTIONS(1909),
    [anon_sym_friend] = ACTIONS(1909),
    [anon_sym_public] = ACTIONS(1909),
    [anon_sym_private] = ACTIONS(1909),
    [anon_sym_protected] = ACTIONS(1909),
    [anon_sym_using] = ACTIONS(1909),
    [anon_sym_static_assert] = ACTIONS(1909),
    [anon_sym_catch] = ACTIONS(1909),
  },
  [1904] = {
    [sym_identifier] = ACTIONS(5361),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5363),
    [anon_sym_COMMA] = ACTIONS(5363),
    [anon_sym_RPAREN] = ACTIONS(5363),
    [aux_sym_preproc_if_token2] = ACTIONS(5363),
    [aux_sym_preproc_else_token1] = ACTIONS(5363),
    [aux_sym_preproc_elif_token1] = ACTIONS(5361),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5363),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5363),
    [anon_sym_LPAREN2] = ACTIONS(5363),
    [anon_sym_DASH] = ACTIONS(5361),
    [anon_sym_PLUS] = ACTIONS(5361),
    [anon_sym_STAR] = ACTIONS(5361),
    [anon_sym_SLASH] = ACTIONS(5361),
    [anon_sym_PERCENT] = ACTIONS(5361),
    [anon_sym_PIPE_PIPE] = ACTIONS(5363),
    [anon_sym_AMP_AMP] = ACTIONS(5363),
    [anon_sym_PIPE] = ACTIONS(5361),
    [anon_sym_CARET] = ACTIONS(5361),
    [anon_sym_AMP] = ACTIONS(5361),
    [anon_sym_EQ_EQ] = ACTIONS(5363),
    [anon_sym_BANG_EQ] = ACTIONS(5363),
    [anon_sym_GT] = ACTIONS(5361),
    [anon_sym_GT_EQ] = ACTIONS(5363),
    [anon_sym_LT_EQ] = ACTIONS(5361),
    [anon_sym_LT] = ACTIONS(5361),
    [anon_sym_LT_LT] = ACTIONS(5361),
    [anon_sym_GT_GT] = ACTIONS(5361),
    [anon_sym_SEMI] = ACTIONS(5363),
    [anon_sym___attribute__] = ACTIONS(5361),
    [anon_sym___attribute] = ACTIONS(5361),
    [anon_sym_COLON_COLON] = ACTIONS(5365),
    [anon_sym_LBRACE] = ACTIONS(5363),
    [anon_sym_RBRACE] = ACTIONS(5363),
    [anon_sym_LBRACK] = ACTIONS(5363),
    [anon_sym_RBRACK] = ACTIONS(5363),
    [anon_sym_EQ] = ACTIONS(5361),
    [anon_sym_COLON] = ACTIONS(5361),
    [anon_sym_QMARK] = ACTIONS(5363),
    [anon_sym_STAR_EQ] = ACTIONS(5363),
    [anon_sym_SLASH_EQ] = ACTIONS(5363),
    [anon_sym_PERCENT_EQ] = ACTIONS(5363),
    [anon_sym_PLUS_EQ] = ACTIONS(5363),
    [anon_sym_DASH_EQ] = ACTIONS(5363),
    [anon_sym_LT_LT_EQ] = ACTIONS(5363),
    [anon_sym_GT_GT_EQ] = ACTIONS(5363),
    [anon_sym_AMP_EQ] = ACTIONS(5363),
    [anon_sym_CARET_EQ] = ACTIONS(5363),
    [anon_sym_PIPE_EQ] = ACTIONS(5363),
    [anon_sym_and_eq] = ACTIONS(5361),
    [anon_sym_or_eq] = ACTIONS(5361),
    [anon_sym_xor_eq] = ACTIONS(5361),
    [anon_sym_LT_EQ_GT] = ACTIONS(5363),
    [anon_sym_or] = ACTIONS(5361),
    [anon_sym_and] = ACTIONS(5361),
    [anon_sym_bitor] = ACTIONS(5361),
    [anon_sym_xor] = ACTIONS(5361),
    [anon_sym_bitand] = ACTIONS(5361),
    [anon_sym_not_eq] = ACTIONS(5361),
    [anon_sym_DASH_DASH] = ACTIONS(5363),
    [anon_sym_PLUS_PLUS] = ACTIONS(5363),
    [anon_sym_DOT] = ACTIONS(5361),
    [anon_sym_DOT_STAR] = ACTIONS(5363),
    [anon_sym_DASH_GT] = ACTIONS(5363),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5361),
    [anon_sym_decltype] = ACTIONS(5361),
    [anon_sym_final] = ACTIONS(5361),
    [anon_sym_override] = ACTIONS(5361),
  },
  [1905] = {
    [sym_identifier] = ACTIONS(3064),
    [aux_sym_preproc_def_token1] = ACTIONS(3064),
    [aux_sym_preproc_if_token1] = ACTIONS(3064),
    [aux_sym_preproc_if_token2] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3064),
    [sym_preproc_directive] = ACTIONS(3064),
    [anon_sym_LPAREN2] = ACTIONS(3066),
    [anon_sym_TILDE] = ACTIONS(3066),
    [anon_sym_STAR] = ACTIONS(3066),
    [anon_sym_AMP_AMP] = ACTIONS(3066),
    [anon_sym_AMP] = ACTIONS(3064),
    [anon_sym_SEMI] = ACTIONS(3066),
    [anon_sym___extension__] = ACTIONS(3064),
    [anon_sym_typedef] = ACTIONS(3064),
    [anon_sym_virtual] = ACTIONS(3064),
    [anon_sym_extern] = ACTIONS(3064),
    [anon_sym___attribute__] = ACTIONS(3064),
    [anon_sym___attribute] = ACTIONS(3064),
    [anon_sym_COLON_COLON] = ACTIONS(3066),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3066),
    [anon_sym___declspec] = ACTIONS(3064),
    [anon_sym___based] = ACTIONS(3064),
    [anon_sym_signed] = ACTIONS(3064),
    [anon_sym_unsigned] = ACTIONS(3064),
    [anon_sym_long] = ACTIONS(3064),
    [anon_sym_short] = ACTIONS(3064),
    [anon_sym_LBRACK] = ACTIONS(3064),
    [anon_sym_static] = ACTIONS(3064),
    [anon_sym_register] = ACTIONS(3064),
    [anon_sym_inline] = ACTIONS(3064),
    [anon_sym___inline] = ACTIONS(3064),
    [anon_sym___inline__] = ACTIONS(3064),
    [anon_sym___forceinline] = ACTIONS(3064),
    [anon_sym_thread_local] = ACTIONS(3064),
    [anon_sym___thread] = ACTIONS(3064),
    [anon_sym_const] = ACTIONS(3064),
    [anon_sym_constexpr] = ACTIONS(3064),
    [anon_sym_volatile] = ACTIONS(3064),
    [anon_sym_restrict] = ACTIONS(3064),
    [anon_sym___restrict__] = ACTIONS(3064),
    [anon_sym__Atomic] = ACTIONS(3064),
    [anon_sym__Noreturn] = ACTIONS(3064),
    [anon_sym_noreturn] = ACTIONS(3064),
    [anon_sym__Nonnull] = ACTIONS(3064),
    [anon_sym_mutable] = ACTIONS(3064),
    [anon_sym_constinit] = ACTIONS(3064),
    [anon_sym_consteval] = ACTIONS(3064),
    [anon_sym_alignas] = ACTIONS(3064),
    [anon_sym__Alignas] = ACTIONS(3064),
    [sym_primitive_type] = ACTIONS(3064),
    [anon_sym_enum] = ACTIONS(3064),
    [anon_sym_class] = ACTIONS(3064),
    [anon_sym_struct] = ACTIONS(3064),
    [anon_sym_union] = ACTIONS(3064),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3064),
    [anon_sym_decltype] = ACTIONS(3064),
    [anon_sym_explicit] = ACTIONS(3064),
    [anon_sym_typename] = ACTIONS(3064),
    [anon_sym_template] = ACTIONS(3064),
    [anon_sym_operator] = ACTIONS(3064),
    [anon_sym_friend] = ACTIONS(3064),
    [anon_sym_public] = ACTIONS(3064),
    [anon_sym_private] = ACTIONS(3064),
    [anon_sym_protected] = ACTIONS(3064),
    [anon_sym_using] = ACTIONS(3064),
    [anon_sym_static_assert] = ACTIONS(3064),
  },
  [1906] = {
    [sym_identifier] = ACTIONS(2834),
    [aux_sym_preproc_def_token1] = ACTIONS(2834),
    [aux_sym_preproc_if_token1] = ACTIONS(2834),
    [aux_sym_preproc_if_token2] = ACTIONS(2834),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2834),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2834),
    [sym_preproc_directive] = ACTIONS(2834),
    [anon_sym_LPAREN2] = ACTIONS(2836),
    [anon_sym_TILDE] = ACTIONS(2836),
    [anon_sym_STAR] = ACTIONS(2836),
    [anon_sym_AMP_AMP] = ACTIONS(2836),
    [anon_sym_AMP] = ACTIONS(2834),
    [anon_sym_SEMI] = ACTIONS(2836),
    [anon_sym___extension__] = ACTIONS(2834),
    [anon_sym_typedef] = ACTIONS(2834),
    [anon_sym_virtual] = ACTIONS(2834),
    [anon_sym_extern] = ACTIONS(2834),
    [anon_sym___attribute__] = ACTIONS(2834),
    [anon_sym___attribute] = ACTIONS(2834),
    [anon_sym_COLON_COLON] = ACTIONS(2836),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2836),
    [anon_sym___declspec] = ACTIONS(2834),
    [anon_sym___based] = ACTIONS(2834),
    [anon_sym_signed] = ACTIONS(2834),
    [anon_sym_unsigned] = ACTIONS(2834),
    [anon_sym_long] = ACTIONS(2834),
    [anon_sym_short] = ACTIONS(2834),
    [anon_sym_LBRACK] = ACTIONS(2834),
    [anon_sym_static] = ACTIONS(2834),
    [anon_sym_register] = ACTIONS(2834),
    [anon_sym_inline] = ACTIONS(2834),
    [anon_sym___inline] = ACTIONS(2834),
    [anon_sym___inline__] = ACTIONS(2834),
    [anon_sym___forceinline] = ACTIONS(2834),
    [anon_sym_thread_local] = ACTIONS(2834),
    [anon_sym___thread] = ACTIONS(2834),
    [anon_sym_const] = ACTIONS(2834),
    [anon_sym_constexpr] = ACTIONS(2834),
    [anon_sym_volatile] = ACTIONS(2834),
    [anon_sym_restrict] = ACTIONS(2834),
    [anon_sym___restrict__] = ACTIONS(2834),
    [anon_sym__Atomic] = ACTIONS(2834),
    [anon_sym__Noreturn] = ACTIONS(2834),
    [anon_sym_noreturn] = ACTIONS(2834),
    [anon_sym__Nonnull] = ACTIONS(2834),
    [anon_sym_mutable] = ACTIONS(2834),
    [anon_sym_constinit] = ACTIONS(2834),
    [anon_sym_consteval] = ACTIONS(2834),
    [anon_sym_alignas] = ACTIONS(2834),
    [anon_sym__Alignas] = ACTIONS(2834),
    [sym_primitive_type] = ACTIONS(2834),
    [anon_sym_enum] = ACTIONS(2834),
    [anon_sym_class] = ACTIONS(2834),
    [anon_sym_struct] = ACTIONS(2834),
    [anon_sym_union] = ACTIONS(2834),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2834),
    [anon_sym_decltype] = ACTIONS(2834),
    [anon_sym_explicit] = ACTIONS(2834),
    [anon_sym_typename] = ACTIONS(2834),
    [anon_sym_template] = ACTIONS(2834),
    [anon_sym_operator] = ACTIONS(2834),
    [anon_sym_friend] = ACTIONS(2834),
    [anon_sym_public] = ACTIONS(2834),
    [anon_sym_private] = ACTIONS(2834),
    [anon_sym_protected] = ACTIONS(2834),
    [anon_sym_using] = ACTIONS(2834),
    [anon_sym_static_assert] = ACTIONS(2834),
  },
  [1907] = {
    [sym_identifier] = ACTIONS(2838),
    [aux_sym_preproc_def_token1] = ACTIONS(2838),
    [aux_sym_preproc_if_token1] = ACTIONS(2838),
    [aux_sym_preproc_if_token2] = ACTIONS(2838),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2838),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2838),
    [sym_preproc_directive] = ACTIONS(2838),
    [anon_sym_LPAREN2] = ACTIONS(2840),
    [anon_sym_TILDE] = ACTIONS(2840),
    [anon_sym_STAR] = ACTIONS(2840),
    [anon_sym_AMP_AMP] = ACTIONS(2840),
    [anon_sym_AMP] = ACTIONS(2838),
    [anon_sym_SEMI] = ACTIONS(2840),
    [anon_sym___extension__] = ACTIONS(2838),
    [anon_sym_typedef] = ACTIONS(2838),
    [anon_sym_virtual] = ACTIONS(2838),
    [anon_sym_extern] = ACTIONS(2838),
    [anon_sym___attribute__] = ACTIONS(2838),
    [anon_sym___attribute] = ACTIONS(2838),
    [anon_sym_COLON_COLON] = ACTIONS(2840),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2840),
    [anon_sym___declspec] = ACTIONS(2838),
    [anon_sym___based] = ACTIONS(2838),
    [anon_sym_signed] = ACTIONS(2838),
    [anon_sym_unsigned] = ACTIONS(2838),
    [anon_sym_long] = ACTIONS(2838),
    [anon_sym_short] = ACTIONS(2838),
    [anon_sym_LBRACK] = ACTIONS(2838),
    [anon_sym_static] = ACTIONS(2838),
    [anon_sym_register] = ACTIONS(2838),
    [anon_sym_inline] = ACTIONS(2838),
    [anon_sym___inline] = ACTIONS(2838),
    [anon_sym___inline__] = ACTIONS(2838),
    [anon_sym___forceinline] = ACTIONS(2838),
    [anon_sym_thread_local] = ACTIONS(2838),
    [anon_sym___thread] = ACTIONS(2838),
    [anon_sym_const] = ACTIONS(2838),
    [anon_sym_constexpr] = ACTIONS(2838),
    [anon_sym_volatile] = ACTIONS(2838),
    [anon_sym_restrict] = ACTIONS(2838),
    [anon_sym___restrict__] = ACTIONS(2838),
    [anon_sym__Atomic] = ACTIONS(2838),
    [anon_sym__Noreturn] = ACTIONS(2838),
    [anon_sym_noreturn] = ACTIONS(2838),
    [anon_sym__Nonnull] = ACTIONS(2838),
    [anon_sym_mutable] = ACTIONS(2838),
    [anon_sym_constinit] = ACTIONS(2838),
    [anon_sym_consteval] = ACTIONS(2838),
    [anon_sym_alignas] = ACTIONS(2838),
    [anon_sym__Alignas] = ACTIONS(2838),
    [sym_primitive_type] = ACTIONS(2838),
    [anon_sym_enum] = ACTIONS(2838),
    [anon_sym_class] = ACTIONS(2838),
    [anon_sym_struct] = ACTIONS(2838),
    [anon_sym_union] = ACTIONS(2838),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2838),
    [anon_sym_decltype] = ACTIONS(2838),
    [anon_sym_explicit] = ACTIONS(2838),
    [anon_sym_typename] = ACTIONS(2838),
    [anon_sym_template] = ACTIONS(2838),
    [anon_sym_operator] = ACTIONS(2838),
    [anon_sym_friend] = ACTIONS(2838),
    [anon_sym_public] = ACTIONS(2838),
    [anon_sym_private] = ACTIONS(2838),
    [anon_sym_protected] = ACTIONS(2838),
    [anon_sym_using] = ACTIONS(2838),
    [anon_sym_static_assert] = ACTIONS(2838),
  },
  [1908] = {
    [sym_identifier] = ACTIONS(2842),
    [aux_sym_preproc_def_token1] = ACTIONS(2842),
    [aux_sym_preproc_if_token1] = ACTIONS(2842),
    [aux_sym_preproc_if_token2] = ACTIONS(2842),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2842),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2842),
    [sym_preproc_directive] = ACTIONS(2842),
    [anon_sym_LPAREN2] = ACTIONS(2844),
    [anon_sym_TILDE] = ACTIONS(2844),
    [anon_sym_STAR] = ACTIONS(2844),
    [anon_sym_AMP_AMP] = ACTIONS(2844),
    [anon_sym_AMP] = ACTIONS(2842),
    [anon_sym_SEMI] = ACTIONS(2844),
    [anon_sym___extension__] = ACTIONS(2842),
    [anon_sym_typedef] = ACTIONS(2842),
    [anon_sym_virtual] = ACTIONS(2842),
    [anon_sym_extern] = ACTIONS(2842),
    [anon_sym___attribute__] = ACTIONS(2842),
    [anon_sym___attribute] = ACTIONS(2842),
    [anon_sym_COLON_COLON] = ACTIONS(2844),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2844),
    [anon_sym___declspec] = ACTIONS(2842),
    [anon_sym___based] = ACTIONS(2842),
    [anon_sym_signed] = ACTIONS(2842),
    [anon_sym_unsigned] = ACTIONS(2842),
    [anon_sym_long] = ACTIONS(2842),
    [anon_sym_short] = ACTIONS(2842),
    [anon_sym_LBRACK] = ACTIONS(2842),
    [anon_sym_static] = ACTIONS(2842),
    [anon_sym_register] = ACTIONS(2842),
    [anon_sym_inline] = ACTIONS(2842),
    [anon_sym___inline] = ACTIONS(2842),
    [anon_sym___inline__] = ACTIONS(2842),
    [anon_sym___forceinline] = ACTIONS(2842),
    [anon_sym_thread_local] = ACTIONS(2842),
    [anon_sym___thread] = ACTIONS(2842),
    [anon_sym_const] = ACTIONS(2842),
    [anon_sym_constexpr] = ACTIONS(2842),
    [anon_sym_volatile] = ACTIONS(2842),
    [anon_sym_restrict] = ACTIONS(2842),
    [anon_sym___restrict__] = ACTIONS(2842),
    [anon_sym__Atomic] = ACTIONS(2842),
    [anon_sym__Noreturn] = ACTIONS(2842),
    [anon_sym_noreturn] = ACTIONS(2842),
    [anon_sym__Nonnull] = ACTIONS(2842),
    [anon_sym_mutable] = ACTIONS(2842),
    [anon_sym_constinit] = ACTIONS(2842),
    [anon_sym_consteval] = ACTIONS(2842),
    [anon_sym_alignas] = ACTIONS(2842),
    [anon_sym__Alignas] = ACTIONS(2842),
    [sym_primitive_type] = ACTIONS(2842),
    [anon_sym_enum] = ACTIONS(2842),
    [anon_sym_class] = ACTIONS(2842),
    [anon_sym_struct] = ACTIONS(2842),
    [anon_sym_union] = ACTIONS(2842),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2842),
    [anon_sym_decltype] = ACTIONS(2842),
    [anon_sym_explicit] = ACTIONS(2842),
    [anon_sym_typename] = ACTIONS(2842),
    [anon_sym_template] = ACTIONS(2842),
    [anon_sym_operator] = ACTIONS(2842),
    [anon_sym_friend] = ACTIONS(2842),
    [anon_sym_public] = ACTIONS(2842),
    [anon_sym_private] = ACTIONS(2842),
    [anon_sym_protected] = ACTIONS(2842),
    [anon_sym_using] = ACTIONS(2842),
    [anon_sym_static_assert] = ACTIONS(2842),
  },
  [1909] = {
    [sym_identifier] = ACTIONS(2846),
    [aux_sym_preproc_def_token1] = ACTIONS(2846),
    [aux_sym_preproc_if_token1] = ACTIONS(2846),
    [aux_sym_preproc_if_token2] = ACTIONS(2846),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2846),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2846),
    [sym_preproc_directive] = ACTIONS(2846),
    [anon_sym_LPAREN2] = ACTIONS(2848),
    [anon_sym_TILDE] = ACTIONS(2848),
    [anon_sym_STAR] = ACTIONS(2848),
    [anon_sym_AMP_AMP] = ACTIONS(2848),
    [anon_sym_AMP] = ACTIONS(2846),
    [anon_sym_SEMI] = ACTIONS(2848),
    [anon_sym___extension__] = ACTIONS(2846),
    [anon_sym_typedef] = ACTIONS(2846),
    [anon_sym_virtual] = ACTIONS(2846),
    [anon_sym_extern] = ACTIONS(2846),
    [anon_sym___attribute__] = ACTIONS(2846),
    [anon_sym___attribute] = ACTIONS(2846),
    [anon_sym_COLON_COLON] = ACTIONS(2848),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2848),
    [anon_sym___declspec] = ACTIONS(2846),
    [anon_sym___based] = ACTIONS(2846),
    [anon_sym_signed] = ACTIONS(2846),
    [anon_sym_unsigned] = ACTIONS(2846),
    [anon_sym_long] = ACTIONS(2846),
    [anon_sym_short] = ACTIONS(2846),
    [anon_sym_LBRACK] = ACTIONS(2846),
    [anon_sym_static] = ACTIONS(2846),
    [anon_sym_register] = ACTIONS(2846),
    [anon_sym_inline] = ACTIONS(2846),
    [anon_sym___inline] = ACTIONS(2846),
    [anon_sym___inline__] = ACTIONS(2846),
    [anon_sym___forceinline] = ACTIONS(2846),
    [anon_sym_thread_local] = ACTIONS(2846),
    [anon_sym___thread] = ACTIONS(2846),
    [anon_sym_const] = ACTIONS(2846),
    [anon_sym_constexpr] = ACTIONS(2846),
    [anon_sym_volatile] = ACTIONS(2846),
    [anon_sym_restrict] = ACTIONS(2846),
    [anon_sym___restrict__] = ACTIONS(2846),
    [anon_sym__Atomic] = ACTIONS(2846),
    [anon_sym__Noreturn] = ACTIONS(2846),
    [anon_sym_noreturn] = ACTIONS(2846),
    [anon_sym__Nonnull] = ACTIONS(2846),
    [anon_sym_mutable] = ACTIONS(2846),
    [anon_sym_constinit] = ACTIONS(2846),
    [anon_sym_consteval] = ACTIONS(2846),
    [anon_sym_alignas] = ACTIONS(2846),
    [anon_sym__Alignas] = ACTIONS(2846),
    [sym_primitive_type] = ACTIONS(2846),
    [anon_sym_enum] = ACTIONS(2846),
    [anon_sym_class] = ACTIONS(2846),
    [anon_sym_struct] = ACTIONS(2846),
    [anon_sym_union] = ACTIONS(2846),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2846),
    [anon_sym_decltype] = ACTIONS(2846),
    [anon_sym_explicit] = ACTIONS(2846),
    [anon_sym_typename] = ACTIONS(2846),
    [anon_sym_template] = ACTIONS(2846),
    [anon_sym_operator] = ACTIONS(2846),
    [anon_sym_friend] = ACTIONS(2846),
    [anon_sym_public] = ACTIONS(2846),
    [anon_sym_private] = ACTIONS(2846),
    [anon_sym_protected] = ACTIONS(2846),
    [anon_sym_using] = ACTIONS(2846),
    [anon_sym_static_assert] = ACTIONS(2846),
  },
  [1910] = {
    [sym_identifier] = ACTIONS(2850),
    [aux_sym_preproc_def_token1] = ACTIONS(2850),
    [aux_sym_preproc_if_token1] = ACTIONS(2850),
    [aux_sym_preproc_if_token2] = ACTIONS(2850),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2850),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2850),
    [sym_preproc_directive] = ACTIONS(2850),
    [anon_sym_LPAREN2] = ACTIONS(2852),
    [anon_sym_TILDE] = ACTIONS(2852),
    [anon_sym_STAR] = ACTIONS(2852),
    [anon_sym_AMP_AMP] = ACTIONS(2852),
    [anon_sym_AMP] = ACTIONS(2850),
    [anon_sym_SEMI] = ACTIONS(2852),
    [anon_sym___extension__] = ACTIONS(2850),
    [anon_sym_typedef] = ACTIONS(2850),
    [anon_sym_virtual] = ACTIONS(2850),
    [anon_sym_extern] = ACTIONS(2850),
    [anon_sym___attribute__] = ACTIONS(2850),
    [anon_sym___attribute] = ACTIONS(2850),
    [anon_sym_COLON_COLON] = ACTIONS(2852),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2852),
    [anon_sym___declspec] = ACTIONS(2850),
    [anon_sym___based] = ACTIONS(2850),
    [anon_sym_signed] = ACTIONS(2850),
    [anon_sym_unsigned] = ACTIONS(2850),
    [anon_sym_long] = ACTIONS(2850),
    [anon_sym_short] = ACTIONS(2850),
    [anon_sym_LBRACK] = ACTIONS(2850),
    [anon_sym_static] = ACTIONS(2850),
    [anon_sym_register] = ACTIONS(2850),
    [anon_sym_inline] = ACTIONS(2850),
    [anon_sym___inline] = ACTIONS(2850),
    [anon_sym___inline__] = ACTIONS(2850),
    [anon_sym___forceinline] = ACTIONS(2850),
    [anon_sym_thread_local] = ACTIONS(2850),
    [anon_sym___thread] = ACTIONS(2850),
    [anon_sym_const] = ACTIONS(2850),
    [anon_sym_constexpr] = ACTIONS(2850),
    [anon_sym_volatile] = ACTIONS(2850),
    [anon_sym_restrict] = ACTIONS(2850),
    [anon_sym___restrict__] = ACTIONS(2850),
    [anon_sym__Atomic] = ACTIONS(2850),
    [anon_sym__Noreturn] = ACTIONS(2850),
    [anon_sym_noreturn] = ACTIONS(2850),
    [anon_sym__Nonnull] = ACTIONS(2850),
    [anon_sym_mutable] = ACTIONS(2850),
    [anon_sym_constinit] = ACTIONS(2850),
    [anon_sym_consteval] = ACTIONS(2850),
    [anon_sym_alignas] = ACTIONS(2850),
    [anon_sym__Alignas] = ACTIONS(2850),
    [sym_primitive_type] = ACTIONS(2850),
    [anon_sym_enum] = ACTIONS(2850),
    [anon_sym_class] = ACTIONS(2850),
    [anon_sym_struct] = ACTIONS(2850),
    [anon_sym_union] = ACTIONS(2850),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2850),
    [anon_sym_decltype] = ACTIONS(2850),
    [anon_sym_explicit] = ACTIONS(2850),
    [anon_sym_typename] = ACTIONS(2850),
    [anon_sym_template] = ACTIONS(2850),
    [anon_sym_operator] = ACTIONS(2850),
    [anon_sym_friend] = ACTIONS(2850),
    [anon_sym_public] = ACTIONS(2850),
    [anon_sym_private] = ACTIONS(2850),
    [anon_sym_protected] = ACTIONS(2850),
    [anon_sym_using] = ACTIONS(2850),
    [anon_sym_static_assert] = ACTIONS(2850),
  },
  [1911] = {
    [sym_identifier] = ACTIONS(2920),
    [aux_sym_preproc_def_token1] = ACTIONS(2920),
    [aux_sym_preproc_if_token1] = ACTIONS(2920),
    [aux_sym_preproc_if_token2] = ACTIONS(2920),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2920),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2920),
    [sym_preproc_directive] = ACTIONS(2920),
    [anon_sym_LPAREN2] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2922),
    [anon_sym_STAR] = ACTIONS(2922),
    [anon_sym_AMP_AMP] = ACTIONS(2922),
    [anon_sym_AMP] = ACTIONS(2920),
    [anon_sym_SEMI] = ACTIONS(2922),
    [anon_sym___extension__] = ACTIONS(2920),
    [anon_sym_typedef] = ACTIONS(2920),
    [anon_sym_virtual] = ACTIONS(2920),
    [anon_sym_extern] = ACTIONS(2920),
    [anon_sym___attribute__] = ACTIONS(2920),
    [anon_sym___attribute] = ACTIONS(2920),
    [anon_sym_COLON_COLON] = ACTIONS(2922),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2922),
    [anon_sym___declspec] = ACTIONS(2920),
    [anon_sym___based] = ACTIONS(2920),
    [anon_sym_signed] = ACTIONS(2920),
    [anon_sym_unsigned] = ACTIONS(2920),
    [anon_sym_long] = ACTIONS(2920),
    [anon_sym_short] = ACTIONS(2920),
    [anon_sym_LBRACK] = ACTIONS(2920),
    [anon_sym_static] = ACTIONS(2920),
    [anon_sym_register] = ACTIONS(2920),
    [anon_sym_inline] = ACTIONS(2920),
    [anon_sym___inline] = ACTIONS(2920),
    [anon_sym___inline__] = ACTIONS(2920),
    [anon_sym___forceinline] = ACTIONS(2920),
    [anon_sym_thread_local] = ACTIONS(2920),
    [anon_sym___thread] = ACTIONS(2920),
    [anon_sym_const] = ACTIONS(2920),
    [anon_sym_constexpr] = ACTIONS(2920),
    [anon_sym_volatile] = ACTIONS(2920),
    [anon_sym_restrict] = ACTIONS(2920),
    [anon_sym___restrict__] = ACTIONS(2920),
    [anon_sym__Atomic] = ACTIONS(2920),
    [anon_sym__Noreturn] = ACTIONS(2920),
    [anon_sym_noreturn] = ACTIONS(2920),
    [anon_sym__Nonnull] = ACTIONS(2920),
    [anon_sym_mutable] = ACTIONS(2920),
    [anon_sym_constinit] = ACTIONS(2920),
    [anon_sym_consteval] = ACTIONS(2920),
    [anon_sym_alignas] = ACTIONS(2920),
    [anon_sym__Alignas] = ACTIONS(2920),
    [sym_primitive_type] = ACTIONS(2920),
    [anon_sym_enum] = ACTIONS(2920),
    [anon_sym_class] = ACTIONS(2920),
    [anon_sym_struct] = ACTIONS(2920),
    [anon_sym_union] = ACTIONS(2920),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2920),
    [anon_sym_decltype] = ACTIONS(2920),
    [anon_sym_explicit] = ACTIONS(2920),
    [anon_sym_typename] = ACTIONS(2920),
    [anon_sym_template] = ACTIONS(2920),
    [anon_sym_operator] = ACTIONS(2920),
    [anon_sym_friend] = ACTIONS(2920),
    [anon_sym_public] = ACTIONS(2920),
    [anon_sym_private] = ACTIONS(2920),
    [anon_sym_protected] = ACTIONS(2920),
    [anon_sym_using] = ACTIONS(2920),
    [anon_sym_static_assert] = ACTIONS(2920),
  },
  [1912] = {
    [sym_identifier] = ACTIONS(2924),
    [aux_sym_preproc_def_token1] = ACTIONS(2924),
    [aux_sym_preproc_if_token1] = ACTIONS(2924),
    [aux_sym_preproc_if_token2] = ACTIONS(2924),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2924),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2924),
    [sym_preproc_directive] = ACTIONS(2924),
    [anon_sym_LPAREN2] = ACTIONS(2926),
    [anon_sym_TILDE] = ACTIONS(2926),
    [anon_sym_STAR] = ACTIONS(2926),
    [anon_sym_AMP_AMP] = ACTIONS(2926),
    [anon_sym_AMP] = ACTIONS(2924),
    [anon_sym_SEMI] = ACTIONS(2926),
    [anon_sym___extension__] = ACTIONS(2924),
    [anon_sym_typedef] = ACTIONS(2924),
    [anon_sym_virtual] = ACTIONS(2924),
    [anon_sym_extern] = ACTIONS(2924),
    [anon_sym___attribute__] = ACTIONS(2924),
    [anon_sym___attribute] = ACTIONS(2924),
    [anon_sym_COLON_COLON] = ACTIONS(2926),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2926),
    [anon_sym___declspec] = ACTIONS(2924),
    [anon_sym___based] = ACTIONS(2924),
    [anon_sym_signed] = ACTIONS(2924),
    [anon_sym_unsigned] = ACTIONS(2924),
    [anon_sym_long] = ACTIONS(2924),
    [anon_sym_short] = ACTIONS(2924),
    [anon_sym_LBRACK] = ACTIONS(2924),
    [anon_sym_static] = ACTIONS(2924),
    [anon_sym_register] = ACTIONS(2924),
    [anon_sym_inline] = ACTIONS(2924),
    [anon_sym___inline] = ACTIONS(2924),
    [anon_sym___inline__] = ACTIONS(2924),
    [anon_sym___forceinline] = ACTIONS(2924),
    [anon_sym_thread_local] = ACTIONS(2924),
    [anon_sym___thread] = ACTIONS(2924),
    [anon_sym_const] = ACTIONS(2924),
    [anon_sym_constexpr] = ACTIONS(2924),
    [anon_sym_volatile] = ACTIONS(2924),
    [anon_sym_restrict] = ACTIONS(2924),
    [anon_sym___restrict__] = ACTIONS(2924),
    [anon_sym__Atomic] = ACTIONS(2924),
    [anon_sym__Noreturn] = ACTIONS(2924),
    [anon_sym_noreturn] = ACTIONS(2924),
    [anon_sym__Nonnull] = ACTIONS(2924),
    [anon_sym_mutable] = ACTIONS(2924),
    [anon_sym_constinit] = ACTIONS(2924),
    [anon_sym_consteval] = ACTIONS(2924),
    [anon_sym_alignas] = ACTIONS(2924),
    [anon_sym__Alignas] = ACTIONS(2924),
    [sym_primitive_type] = ACTIONS(2924),
    [anon_sym_enum] = ACTIONS(2924),
    [anon_sym_class] = ACTIONS(2924),
    [anon_sym_struct] = ACTIONS(2924),
    [anon_sym_union] = ACTIONS(2924),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2924),
    [anon_sym_decltype] = ACTIONS(2924),
    [anon_sym_explicit] = ACTIONS(2924),
    [anon_sym_typename] = ACTIONS(2924),
    [anon_sym_template] = ACTIONS(2924),
    [anon_sym_operator] = ACTIONS(2924),
    [anon_sym_friend] = ACTIONS(2924),
    [anon_sym_public] = ACTIONS(2924),
    [anon_sym_private] = ACTIONS(2924),
    [anon_sym_protected] = ACTIONS(2924),
    [anon_sym_using] = ACTIONS(2924),
    [anon_sym_static_assert] = ACTIONS(2924),
  },
  [1913] = {
    [sym_identifier] = ACTIONS(2805),
    [aux_sym_preproc_def_token1] = ACTIONS(2805),
    [aux_sym_preproc_if_token1] = ACTIONS(2805),
    [aux_sym_preproc_if_token2] = ACTIONS(2805),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2805),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2805),
    [sym_preproc_directive] = ACTIONS(2805),
    [anon_sym_LPAREN2] = ACTIONS(2807),
    [anon_sym_TILDE] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2805),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym___extension__] = ACTIONS(2805),
    [anon_sym_typedef] = ACTIONS(2805),
    [anon_sym_virtual] = ACTIONS(2805),
    [anon_sym_extern] = ACTIONS(2805),
    [anon_sym___attribute__] = ACTIONS(2805),
    [anon_sym___attribute] = ACTIONS(2805),
    [anon_sym_COLON_COLON] = ACTIONS(2807),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2807),
    [anon_sym___declspec] = ACTIONS(2805),
    [anon_sym___based] = ACTIONS(2805),
    [anon_sym_signed] = ACTIONS(2805),
    [anon_sym_unsigned] = ACTIONS(2805),
    [anon_sym_long] = ACTIONS(2805),
    [anon_sym_short] = ACTIONS(2805),
    [anon_sym_LBRACK] = ACTIONS(2805),
    [anon_sym_static] = ACTIONS(2805),
    [anon_sym_register] = ACTIONS(2805),
    [anon_sym_inline] = ACTIONS(2805),
    [anon_sym___inline] = ACTIONS(2805),
    [anon_sym___inline__] = ACTIONS(2805),
    [anon_sym___forceinline] = ACTIONS(2805),
    [anon_sym_thread_local] = ACTIONS(2805),
    [anon_sym___thread] = ACTIONS(2805),
    [anon_sym_const] = ACTIONS(2805),
    [anon_sym_constexpr] = ACTIONS(2805),
    [anon_sym_volatile] = ACTIONS(2805),
    [anon_sym_restrict] = ACTIONS(2805),
    [anon_sym___restrict__] = ACTIONS(2805),
    [anon_sym__Atomic] = ACTIONS(2805),
    [anon_sym__Noreturn] = ACTIONS(2805),
    [anon_sym_noreturn] = ACTIONS(2805),
    [anon_sym__Nonnull] = ACTIONS(2805),
    [anon_sym_mutable] = ACTIONS(2805),
    [anon_sym_constinit] = ACTIONS(2805),
    [anon_sym_consteval] = ACTIONS(2805),
    [anon_sym_alignas] = ACTIONS(2805),
    [anon_sym__Alignas] = ACTIONS(2805),
    [sym_primitive_type] = ACTIONS(2805),
    [anon_sym_enum] = ACTIONS(2805),
    [anon_sym_class] = ACTIONS(2805),
    [anon_sym_struct] = ACTIONS(2805),
    [anon_sym_union] = ACTIONS(2805),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2805),
    [anon_sym_decltype] = ACTIONS(2805),
    [anon_sym_explicit] = ACTIONS(2805),
    [anon_sym_typename] = ACTIONS(2805),
    [anon_sym_template] = ACTIONS(2805),
    [anon_sym_operator] = ACTIONS(2805),
    [anon_sym_friend] = ACTIONS(2805),
    [anon_sym_public] = ACTIONS(2805),
    [anon_sym_private] = ACTIONS(2805),
    [anon_sym_protected] = ACTIONS(2805),
    [anon_sym_using] = ACTIONS(2805),
    [anon_sym_static_assert] = ACTIONS(2805),
  },
  [1914] = {
    [sym_identifier] = ACTIONS(2809),
    [aux_sym_preproc_def_token1] = ACTIONS(2809),
    [aux_sym_preproc_if_token1] = ACTIONS(2809),
    [aux_sym_preproc_if_token2] = ACTIONS(2809),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2809),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2809),
    [sym_preproc_directive] = ACTIONS(2809),
    [anon_sym_LPAREN2] = ACTIONS(2811),
    [anon_sym_TILDE] = ACTIONS(2811),
    [anon_sym_STAR] = ACTIONS(2811),
    [anon_sym_AMP_AMP] = ACTIONS(2811),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2811),
    [anon_sym___extension__] = ACTIONS(2809),
    [anon_sym_typedef] = ACTIONS(2809),
    [anon_sym_virtual] = ACTIONS(2809),
    [anon_sym_extern] = ACTIONS(2809),
    [anon_sym___attribute__] = ACTIONS(2809),
    [anon_sym___attribute] = ACTIONS(2809),
    [anon_sym_COLON_COLON] = ACTIONS(2811),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2811),
    [anon_sym___declspec] = ACTIONS(2809),
    [anon_sym___based] = ACTIONS(2809),
    [anon_sym_signed] = ACTIONS(2809),
    [anon_sym_unsigned] = ACTIONS(2809),
    [anon_sym_long] = ACTIONS(2809),
    [anon_sym_short] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2809),
    [anon_sym_static] = ACTIONS(2809),
    [anon_sym_register] = ACTIONS(2809),
    [anon_sym_inline] = ACTIONS(2809),
    [anon_sym___inline] = ACTIONS(2809),
    [anon_sym___inline__] = ACTIONS(2809),
    [anon_sym___forceinline] = ACTIONS(2809),
    [anon_sym_thread_local] = ACTIONS(2809),
    [anon_sym___thread] = ACTIONS(2809),
    [anon_sym_const] = ACTIONS(2809),
    [anon_sym_constexpr] = ACTIONS(2809),
    [anon_sym_volatile] = ACTIONS(2809),
    [anon_sym_restrict] = ACTIONS(2809),
    [anon_sym___restrict__] = ACTIONS(2809),
    [anon_sym__Atomic] = ACTIONS(2809),
    [anon_sym__Noreturn] = ACTIONS(2809),
    [anon_sym_noreturn] = ACTIONS(2809),
    [anon_sym__Nonnull] = ACTIONS(2809),
    [anon_sym_mutable] = ACTIONS(2809),
    [anon_sym_constinit] = ACTIONS(2809),
    [anon_sym_consteval] = ACTIONS(2809),
    [anon_sym_alignas] = ACTIONS(2809),
    [anon_sym__Alignas] = ACTIONS(2809),
    [sym_primitive_type] = ACTIONS(2809),
    [anon_sym_enum] = ACTIONS(2809),
    [anon_sym_class] = ACTIONS(2809),
    [anon_sym_struct] = ACTIONS(2809),
    [anon_sym_union] = ACTIONS(2809),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2809),
    [anon_sym_decltype] = ACTIONS(2809),
    [anon_sym_explicit] = ACTIONS(2809),
    [anon_sym_typename] = ACTIONS(2809),
    [anon_sym_template] = ACTIONS(2809),
    [anon_sym_operator] = ACTIONS(2809),
    [anon_sym_friend] = ACTIONS(2809),
    [anon_sym_public] = ACTIONS(2809),
    [anon_sym_private] = ACTIONS(2809),
    [anon_sym_protected] = ACTIONS(2809),
    [anon_sym_using] = ACTIONS(2809),
    [anon_sym_static_assert] = ACTIONS(2809),
  },
  [1915] = {
    [sym_ms_based_modifier] = STATE(7915),
    [sym_ms_unaligned_ptr_modifier] = STATE(3998),
    [sym_ms_pointer_modifier] = STATE(1955),
    [sym__declarator] = STATE(6269),
    [sym__abstract_declarator] = STATE(6585),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_abstract_parenthesized_declarator] = STATE(5942),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_abstract_pointer_declarator] = STATE(5942),
    [sym_function_declarator] = STATE(5896),
    [sym_abstract_function_declarator] = STATE(5942),
    [sym_array_declarator] = STATE(5896),
    [sym_abstract_array_declarator] = STATE(5942),
    [sym_type_qualifier] = STATE(2625),
    [sym_alignas_qualifier] = STATE(4266),
    [sym_parameter_list] = STATE(3166),
    [sym_decltype] = STATE(8512),
    [sym_reference_declarator] = STATE(5896),
    [sym_abstract_reference_declarator] = STATE(5942),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym__function_declarator_seq] = STATE(5919),
    [sym_template_type] = STATE(8512),
    [sym_template_function] = STATE(5896),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5765),
    [sym_qualified_identifier] = STATE(5896),
    [sym_operator_name] = STATE(5896),
    [aux_sym__type_definition_type_repeat1] = STATE(2625),
    [aux_sym_pointer_declarator_repeat1] = STATE(1955),
    [sym_identifier] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5730),
    [anon_sym_LPAREN2] = ACTIONS(4157),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(5807),
    [anon_sym_AMP_AMP] = ACTIONS(5809),
    [anon_sym_AMP] = ACTIONS(5811),
    [anon_sym___extension__] = ACTIONS(3270),
    [anon_sym___attribute__] = ACTIONS(5732),
    [anon_sym___attribute] = ACTIONS(5732),
    [anon_sym_COLON_COLON] = ACTIONS(5708),
    [anon_sym___based] = ACTIONS(51),
    [sym_ms_restrict_modifier] = ACTIONS(3266),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(3266),
    [sym_ms_signed_ptr_modifier] = ACTIONS(3266),
    [anon_sym__unaligned] = ACTIONS(3268),
    [anon_sym___unaligned] = ACTIONS(3268),
    [anon_sym_LBRACK] = ACTIONS(5710),
    [anon_sym_const] = ACTIONS(3270),
    [anon_sym_constexpr] = ACTIONS(3270),
    [anon_sym_volatile] = ACTIONS(3270),
    [anon_sym_restrict] = ACTIONS(3270),
    [anon_sym___restrict__] = ACTIONS(3270),
    [anon_sym__Atomic] = ACTIONS(3270),
    [anon_sym__Noreturn] = ACTIONS(3270),
    [anon_sym_noreturn] = ACTIONS(3270),
    [anon_sym__Nonnull] = ACTIONS(3270),
    [anon_sym_mutable] = ACTIONS(3270),
    [anon_sym_constinit] = ACTIONS(3270),
    [anon_sym_consteval] = ACTIONS(3270),
    [anon_sym_alignas] = ACTIONS(3272),
    [anon_sym__Alignas] = ACTIONS(3272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_GT2] = ACTIONS(5730),
    [anon_sym_operator] = ACTIONS(1823),
  },
  [1916] = {
    [sym_identifier] = ACTIONS(3013),
    [aux_sym_preproc_def_token1] = ACTIONS(3013),
    [aux_sym_preproc_if_token1] = ACTIONS(3013),
    [aux_sym_preproc_if_token2] = ACTIONS(3013),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3013),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3013),
    [sym_preproc_directive] = ACTIONS(3013),
    [anon_sym_LPAREN2] = ACTIONS(3015),
    [anon_sym_TILDE] = ACTIONS(3015),
    [anon_sym_STAR] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3015),
    [anon_sym_AMP] = ACTIONS(3013),
    [anon_sym_SEMI] = ACTIONS(3015),
    [anon_sym___extension__] = ACTIONS(3013),
    [anon_sym_typedef] = ACTIONS(3013),
    [anon_sym_virtual] = ACTIONS(3013),
    [anon_sym_extern] = ACTIONS(3013),
    [anon_sym___attribute__] = ACTIONS(3013),
    [anon_sym___attribute] = ACTIONS(3013),
    [anon_sym_COLON_COLON] = ACTIONS(3015),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3015),
    [anon_sym___declspec] = ACTIONS(3013),
    [anon_sym___based] = ACTIONS(3013),
    [anon_sym_signed] = ACTIONS(3013),
    [anon_sym_unsigned] = ACTIONS(3013),
    [anon_sym_long] = ACTIONS(3013),
    [anon_sym_short] = ACTIONS(3013),
    [anon_sym_LBRACK] = ACTIONS(3013),
    [anon_sym_static] = ACTIONS(3013),
    [anon_sym_register] = ACTIONS(3013),
    [anon_sym_inline] = ACTIONS(3013),
    [anon_sym___inline] = ACTIONS(3013),
    [anon_sym___inline__] = ACTIONS(3013),
    [anon_sym___forceinline] = ACTIONS(3013),
    [anon_sym_thread_local] = ACTIONS(3013),
    [anon_sym___thread] = ACTIONS(3013),
    [anon_sym_const] = ACTIONS(3013),
    [anon_sym_constexpr] = ACTIONS(3013),
    [anon_sym_volatile] = ACTIONS(3013),
    [anon_sym_restrict] = ACTIONS(3013),
    [anon_sym___restrict__] = ACTIONS(3013),
    [anon_sym__Atomic] = ACTIONS(3013),
    [anon_sym__Noreturn] = ACTIONS(3013),
    [anon_sym_noreturn] = ACTIONS(3013),
    [anon_sym__Nonnull] = ACTIONS(3013),
    [anon_sym_mutable] = ACTIONS(3013),
    [anon_sym_constinit] = ACTIONS(3013),
    [anon_sym_consteval] = ACTIONS(3013),
    [anon_sym_alignas] = ACTIONS(3013),
    [anon_sym__Alignas] = ACTIONS(3013),
    [sym_primitive_type] = ACTIONS(3013),
    [anon_sym_enum] = ACTIONS(3013),
    [anon_sym_class] = ACTIONS(3013),
    [anon_sym_struct] = ACTIONS(3013),
    [anon_sym_union] = ACTIONS(3013),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3013),
    [anon_sym_decltype] = ACTIONS(3013),
    [anon_sym_explicit] = ACTIONS(3013),
    [anon_sym_typename] = ACTIONS(3013),
    [anon_sym_template] = ACTIONS(3013),
    [anon_sym_operator] = ACTIONS(3013),
    [anon_sym_friend] = ACTIONS(3013),
    [anon_sym_public] = ACTIONS(3013),
    [anon_sym_private] = ACTIONS(3013),
    [anon_sym_protected] = ACTIONS(3013),
    [anon_sym_using] = ACTIONS(3013),
    [anon_sym_static_assert] = ACTIONS(3013),
  },
  [1917] = {
    [sym_identifier] = ACTIONS(3026),
    [aux_sym_preproc_def_token1] = ACTIONS(3026),
    [aux_sym_preproc_if_token1] = ACTIONS(3026),
    [aux_sym_preproc_if_token2] = ACTIONS(3026),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3026),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3026),
    [sym_preproc_directive] = ACTIONS(3026),
    [anon_sym_LPAREN2] = ACTIONS(3028),
    [anon_sym_TILDE] = ACTIONS(3028),
    [anon_sym_STAR] = ACTIONS(3028),
    [anon_sym_AMP_AMP] = ACTIONS(3028),
    [anon_sym_AMP] = ACTIONS(3026),
    [anon_sym_SEMI] = ACTIONS(3028),
    [anon_sym___extension__] = ACTIONS(3026),
    [anon_sym_typedef] = ACTIONS(3026),
    [anon_sym_virtual] = ACTIONS(3026),
    [anon_sym_extern] = ACTIONS(3026),
    [anon_sym___attribute__] = ACTIONS(3026),
    [anon_sym___attribute] = ACTIONS(3026),
    [anon_sym_COLON_COLON] = ACTIONS(3028),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3028),
    [anon_sym___declspec] = ACTIONS(3026),
    [anon_sym___based] = ACTIONS(3026),
    [anon_sym_signed] = ACTIONS(3026),
    [anon_sym_unsigned] = ACTIONS(3026),
    [anon_sym_long] = ACTIONS(3026),
    [anon_sym_short] = ACTIONS(3026),
    [anon_sym_LBRACK] = ACTIONS(3026),
    [anon_sym_static] = ACTIONS(3026),
    [anon_sym_register] = ACTIONS(3026),
    [anon_sym_inline] = ACTIONS(3026),
    [anon_sym___inline] = ACTIONS(3026),
    [anon_sym___inline__] = ACTIONS(3026),
    [anon_sym___forceinline] = ACTIONS(3026),
    [anon_sym_thread_local] = ACTIONS(3026),
    [anon_sym___thread] = ACTIONS(3026),
    [anon_sym_const] = ACTIONS(3026),
    [anon_sym_constexpr] = ACTIONS(3026),
    [anon_sym_volatile] = ACTIONS(3026),
    [anon_sym_restrict] = ACTIONS(3026),
    [anon_sym___restrict__] = ACTIONS(3026),
    [anon_sym__Atomic] = ACTIONS(3026),
    [anon_sym__Noreturn] = ACTIONS(3026),
    [anon_sym_noreturn] = ACTIONS(3026),
    [anon_sym__Nonnull] = ACTIONS(3026),
    [anon_sym_mutable] = ACTIONS(3026),
    [anon_sym_constinit] = ACTIONS(3026),
    [anon_sym_consteval] = ACTIONS(3026),
    [anon_sym_alignas] = ACTIONS(3026),
    [anon_sym__Alignas] = ACTIONS(3026),
    [sym_primitive_type] = ACTIONS(3026),
    [anon_sym_enum] = ACTIONS(3026),
    [anon_sym_class] = ACTIONS(3026),
    [anon_sym_struct] = ACTIONS(3026),
    [anon_sym_union] = ACTIONS(3026),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3026),
    [anon_sym_decltype] = ACTIONS(3026),
    [anon_sym_explicit] = ACTIONS(3026),
    [anon_sym_typename] = ACTIONS(3026),
    [anon_sym_template] = ACTIONS(3026),
    [anon_sym_operator] = ACTIONS(3026),
    [anon_sym_friend] = ACTIONS(3026),
    [anon_sym_public] = ACTIONS(3026),
    [anon_sym_private] = ACTIONS(3026),
    [anon_sym_protected] = ACTIONS(3026),
    [anon_sym_using] = ACTIONS(3026),
    [anon_sym_static_assert] = ACTIONS(3026),
  },
  [1918] = {
    [sym_identifier] = ACTIONS(3030),
    [aux_sym_preproc_def_token1] = ACTIONS(3030),
    [aux_sym_preproc_if_token1] = ACTIONS(3030),
    [aux_sym_preproc_if_token2] = ACTIONS(3030),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3030),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3030),
    [sym_preproc_directive] = ACTIONS(3030),
    [anon_sym_LPAREN2] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3032),
    [anon_sym_STAR] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_AMP] = ACTIONS(3030),
    [anon_sym_SEMI] = ACTIONS(3032),
    [anon_sym___extension__] = ACTIONS(3030),
    [anon_sym_typedef] = ACTIONS(3030),
    [anon_sym_virtual] = ACTIONS(3030),
    [anon_sym_extern] = ACTIONS(3030),
    [anon_sym___attribute__] = ACTIONS(3030),
    [anon_sym___attribute] = ACTIONS(3030),
    [anon_sym_COLON_COLON] = ACTIONS(3032),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3032),
    [anon_sym___declspec] = ACTIONS(3030),
    [anon_sym___based] = ACTIONS(3030),
    [anon_sym_signed] = ACTIONS(3030),
    [anon_sym_unsigned] = ACTIONS(3030),
    [anon_sym_long] = ACTIONS(3030),
    [anon_sym_short] = ACTIONS(3030),
    [anon_sym_LBRACK] = ACTIONS(3030),
    [anon_sym_static] = ACTIONS(3030),
    [anon_sym_register] = ACTIONS(3030),
    [anon_sym_inline] = ACTIONS(3030),
    [anon_sym___inline] = ACTIONS(3030),
    [anon_sym___inline__] = ACTIONS(3030),
    [anon_sym___forceinline] = ACTIONS(3030),
    [anon_sym_thread_local] = ACTIONS(3030),
    [anon_sym___thread] = ACTIONS(3030),
    [anon_sym_const] = ACTIONS(3030),
    [anon_sym_constexpr] = ACTIONS(3030),
    [anon_sym_volatile] = ACTIONS(3030),
    [anon_sym_restrict] = ACTIONS(3030),
    [anon_sym___restrict__] = ACTIONS(3030),
    [anon_sym__Atomic] = ACTIONS(3030),
    [anon_sym__Noreturn] = ACTIONS(3030),
    [anon_sym_noreturn] = ACTIONS(3030),
    [anon_sym__Nonnull] = ACTIONS(3030),
    [anon_sym_mutable] = ACTIONS(3030),
    [anon_sym_constinit] = ACTIONS(3030),
    [anon_sym_consteval] = ACTIONS(3030),
    [anon_sym_alignas] = ACTIONS(3030),
    [anon_sym__Alignas] = ACTIONS(3030),
    [sym_primitive_type] = ACTIONS(3030),
    [anon_sym_enum] = ACTIONS(3030),
    [anon_sym_class] = ACTIONS(3030),
    [anon_sym_struct] = ACTIONS(3030),
    [anon_sym_union] = ACTIONS(3030),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3030),
    [anon_sym_decltype] = ACTIONS(3030),
    [anon_sym_explicit] = ACTIONS(3030),
    [anon_sym_typename] = ACTIONS(3030),
    [anon_sym_template] = ACTIONS(3030),
    [anon_sym_operator] = ACTIONS(3030),
    [anon_sym_friend] = ACTIONS(3030),
    [anon_sym_public] = ACTIONS(3030),
    [anon_sym_private] = ACTIONS(3030),
    [anon_sym_protected] = ACTIONS(3030),
    [anon_sym_using] = ACTIONS(3030),
    [anon_sym_static_assert] = ACTIONS(3030),
  },
  [1919] = {
    [sym_identifier] = ACTIONS(3030),
    [aux_sym_preproc_def_token1] = ACTIONS(3030),
    [aux_sym_preproc_if_token1] = ACTIONS(3030),
    [aux_sym_preproc_if_token2] = ACTIONS(3030),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3030),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3030),
    [sym_preproc_directive] = ACTIONS(3030),
    [anon_sym_LPAREN2] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3032),
    [anon_sym_STAR] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_AMP] = ACTIONS(3030),
    [anon_sym_SEMI] = ACTIONS(3032),
    [anon_sym___extension__] = ACTIONS(3030),
    [anon_sym_typedef] = ACTIONS(3030),
    [anon_sym_virtual] = ACTIONS(3030),
    [anon_sym_extern] = ACTIONS(3030),
    [anon_sym___attribute__] = ACTIONS(3030),
    [anon_sym___attribute] = ACTIONS(3030),
    [anon_sym_COLON_COLON] = ACTIONS(3032),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3032),
    [anon_sym___declspec] = ACTIONS(3030),
    [anon_sym___based] = ACTIONS(3030),
    [anon_sym_signed] = ACTIONS(3030),
    [anon_sym_unsigned] = ACTIONS(3030),
    [anon_sym_long] = ACTIONS(3030),
    [anon_sym_short] = ACTIONS(3030),
    [anon_sym_LBRACK] = ACTIONS(3030),
    [anon_sym_static] = ACTIONS(3030),
    [anon_sym_register] = ACTIONS(3030),
    [anon_sym_inline] = ACTIONS(3030),
    [anon_sym___inline] = ACTIONS(3030),
    [anon_sym___inline__] = ACTIONS(3030),
    [anon_sym___forceinline] = ACTIONS(3030),
    [anon_sym_thread_local] = ACTIONS(3030),
    [anon_sym___thread] = ACTIONS(3030),
    [anon_sym_const] = ACTIONS(3030),
    [anon_sym_constexpr] = ACTIONS(3030),
    [anon_sym_volatile] = ACTIONS(3030),
    [anon_sym_restrict] = ACTIONS(3030),
    [anon_sym___restrict__] = ACTIONS(3030),
    [anon_sym__Atomic] = ACTIONS(3030),
    [anon_sym__Noreturn] = ACTIONS(3030),
    [anon_sym_noreturn] = ACTIONS(3030),
    [anon_sym__Nonnull] = ACTIONS(3030),
    [anon_sym_mutable] = ACTIONS(3030),
    [anon_sym_constinit] = ACTIONS(3030),
    [anon_sym_consteval] = ACTIONS(3030),
    [anon_sym_alignas] = ACTIONS(3030),
    [anon_sym__Alignas] = ACTIONS(3030),
    [sym_primitive_type] = ACTIONS(3030),
    [anon_sym_enum] = ACTIONS(3030),
    [anon_sym_class] = ACTIONS(3030),
    [anon_sym_struct] = ACTIONS(3030),
    [anon_sym_union] = ACTIONS(3030),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3030),
    [anon_sym_decltype] = ACTIONS(3030),
    [anon_sym_explicit] = ACTIONS(3030),
    [anon_sym_typename] = ACTIONS(3030),
    [anon_sym_template] = ACTIONS(3030),
    [anon_sym_operator] = ACTIONS(3030),
    [anon_sym_friend] = ACTIONS(3030),
    [anon_sym_public] = ACTIONS(3030),
    [anon_sym_private] = ACTIONS(3030),
    [anon_sym_protected] = ACTIONS(3030),
    [anon_sym_using] = ACTIONS(3030),
    [anon_sym_static_assert] = ACTIONS(3030),
  },
  [1920] = {
    [sym_identifier] = ACTIONS(3042),
    [aux_sym_preproc_def_token1] = ACTIONS(3042),
    [aux_sym_preproc_if_token1] = ACTIONS(3042),
    [aux_sym_preproc_if_token2] = ACTIONS(3042),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3042),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3042),
    [sym_preproc_directive] = ACTIONS(3042),
    [anon_sym_LPAREN2] = ACTIONS(3044),
    [anon_sym_TILDE] = ACTIONS(3044),
    [anon_sym_STAR] = ACTIONS(3044),
    [anon_sym_AMP_AMP] = ACTIONS(3044),
    [anon_sym_AMP] = ACTIONS(3042),
    [anon_sym_SEMI] = ACTIONS(3044),
    [anon_sym___extension__] = ACTIONS(3042),
    [anon_sym_typedef] = ACTIONS(3042),
    [anon_sym_virtual] = ACTIONS(3042),
    [anon_sym_extern] = ACTIONS(3042),
    [anon_sym___attribute__] = ACTIONS(3042),
    [anon_sym___attribute] = ACTIONS(3042),
    [anon_sym_COLON_COLON] = ACTIONS(3044),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3044),
    [anon_sym___declspec] = ACTIONS(3042),
    [anon_sym___based] = ACTIONS(3042),
    [anon_sym_signed] = ACTIONS(3042),
    [anon_sym_unsigned] = ACTIONS(3042),
    [anon_sym_long] = ACTIONS(3042),
    [anon_sym_short] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3042),
    [anon_sym_static] = ACTIONS(3042),
    [anon_sym_register] = ACTIONS(3042),
    [anon_sym_inline] = ACTIONS(3042),
    [anon_sym___inline] = ACTIONS(3042),
    [anon_sym___inline__] = ACTIONS(3042),
    [anon_sym___forceinline] = ACTIONS(3042),
    [anon_sym_thread_local] = ACTIONS(3042),
    [anon_sym___thread] = ACTIONS(3042),
    [anon_sym_const] = ACTIONS(3042),
    [anon_sym_constexpr] = ACTIONS(3042),
    [anon_sym_volatile] = ACTIONS(3042),
    [anon_sym_restrict] = ACTIONS(3042),
    [anon_sym___restrict__] = ACTIONS(3042),
    [anon_sym__Atomic] = ACTIONS(3042),
    [anon_sym__Noreturn] = ACTIONS(3042),
    [anon_sym_noreturn] = ACTIONS(3042),
    [anon_sym__Nonnull] = ACTIONS(3042),
    [anon_sym_mutable] = ACTIONS(3042),
    [anon_sym_constinit] = ACTIONS(3042),
    [anon_sym_consteval] = ACTIONS(3042),
    [anon_sym_alignas] = ACTIONS(3042),
    [anon_sym__Alignas] = ACTIONS(3042),
    [sym_primitive_type] = ACTIONS(3042),
    [anon_sym_enum] = ACTIONS(3042),
    [anon_sym_class] = ACTIONS(3042),
    [anon_sym_struct] = ACTIONS(3042),
    [anon_sym_union] = ACTIONS(3042),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3042),
    [anon_sym_decltype] = ACTIONS(3042),
    [anon_sym_explicit] = ACTIONS(3042),
    [anon_sym_typename] = ACTIONS(3042),
    [anon_sym_template] = ACTIONS(3042),
    [anon_sym_operator] = ACTIONS(3042),
    [anon_sym_friend] = ACTIONS(3042),
    [anon_sym_public] = ACTIONS(3042),
    [anon_sym_private] = ACTIONS(3042),
    [anon_sym_protected] = ACTIONS(3042),
    [anon_sym_using] = ACTIONS(3042),
    [anon_sym_static_assert] = ACTIONS(3042),
  },
  [1921] = {
    [sym_identifier] = ACTIONS(3042),
    [aux_sym_preproc_def_token1] = ACTIONS(3042),
    [aux_sym_preproc_if_token1] = ACTIONS(3042),
    [aux_sym_preproc_if_token2] = ACTIONS(3042),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3042),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3042),
    [sym_preproc_directive] = ACTIONS(3042),
    [anon_sym_LPAREN2] = ACTIONS(3044),
    [anon_sym_TILDE] = ACTIONS(3044),
    [anon_sym_STAR] = ACTIONS(3044),
    [anon_sym_AMP_AMP] = ACTIONS(3044),
    [anon_sym_AMP] = ACTIONS(3042),
    [anon_sym_SEMI] = ACTIONS(3044),
    [anon_sym___extension__] = ACTIONS(3042),
    [anon_sym_typedef] = ACTIONS(3042),
    [anon_sym_virtual] = ACTIONS(3042),
    [anon_sym_extern] = ACTIONS(3042),
    [anon_sym___attribute__] = ACTIONS(3042),
    [anon_sym___attribute] = ACTIONS(3042),
    [anon_sym_COLON_COLON] = ACTIONS(3044),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3044),
    [anon_sym___declspec] = ACTIONS(3042),
    [anon_sym___based] = ACTIONS(3042),
    [anon_sym_signed] = ACTIONS(3042),
    [anon_sym_unsigned] = ACTIONS(3042),
    [anon_sym_long] = ACTIONS(3042),
    [anon_sym_short] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3042),
    [anon_sym_static] = ACTIONS(3042),
    [anon_sym_register] = ACTIONS(3042),
    [anon_sym_inline] = ACTIONS(3042),
    [anon_sym___inline] = ACTIONS(3042),
    [anon_sym___inline__] = ACTIONS(3042),
    [anon_sym___forceinline] = ACTIONS(3042),
    [anon_sym_thread_local] = ACTIONS(3042),
    [anon_sym___thread] = ACTIONS(3042),
    [anon_sym_const] = ACTIONS(3042),
    [anon_sym_constexpr] = ACTIONS(3042),
    [anon_sym_volatile] = ACTIONS(3042),
    [anon_sym_restrict] = ACTIONS(3042),
    [anon_sym___restrict__] = ACTIONS(3042),
    [anon_sym__Atomic] = ACTIONS(3042),
    [anon_sym__Noreturn] = ACTIONS(3042),
    [anon_sym_noreturn] = ACTIONS(3042),
    [anon_sym__Nonnull] = ACTIONS(3042),
    [anon_sym_mutable] = ACTIONS(3042),
    [anon_sym_constinit] = ACTIONS(3042),
    [anon_sym_consteval] = ACTIONS(3042),
    [anon_sym_alignas] = ACTIONS(3042),
    [anon_sym__Alignas] = ACTIONS(3042),
    [sym_primitive_type] = ACTIONS(3042),
    [anon_sym_enum] = ACTIONS(3042),
    [anon_sym_class] = ACTIONS(3042),
    [anon_sym_struct] = ACTIONS(3042),
    [anon_sym_union] = ACTIONS(3042),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3042),
    [anon_sym_decltype] = ACTIONS(3042),
    [anon_sym_explicit] = ACTIONS(3042),
    [anon_sym_typename] = ACTIONS(3042),
    [anon_sym_template] = ACTIONS(3042),
    [anon_sym_operator] = ACTIONS(3042),
    [anon_sym_friend] = ACTIONS(3042),
    [anon_sym_public] = ACTIONS(3042),
    [anon_sym_private] = ACTIONS(3042),
    [anon_sym_protected] = ACTIONS(3042),
    [anon_sym_using] = ACTIONS(3042),
    [anon_sym_static_assert] = ACTIONS(3042),
  },
  [1922] = {
    [sym_identifier] = ACTIONS(3046),
    [aux_sym_preproc_def_token1] = ACTIONS(3046),
    [aux_sym_preproc_if_token1] = ACTIONS(3046),
    [aux_sym_preproc_if_token2] = ACTIONS(3046),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3046),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3046),
    [sym_preproc_directive] = ACTIONS(3046),
    [anon_sym_LPAREN2] = ACTIONS(3048),
    [anon_sym_TILDE] = ACTIONS(3048),
    [anon_sym_STAR] = ACTIONS(3048),
    [anon_sym_AMP_AMP] = ACTIONS(3048),
    [anon_sym_AMP] = ACTIONS(3046),
    [anon_sym_SEMI] = ACTIONS(3048),
    [anon_sym___extension__] = ACTIONS(3046),
    [anon_sym_typedef] = ACTIONS(3046),
    [anon_sym_virtual] = ACTIONS(3046),
    [anon_sym_extern] = ACTIONS(3046),
    [anon_sym___attribute__] = ACTIONS(3046),
    [anon_sym___attribute] = ACTIONS(3046),
    [anon_sym_COLON_COLON] = ACTIONS(3048),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3048),
    [anon_sym___declspec] = ACTIONS(3046),
    [anon_sym___based] = ACTIONS(3046),
    [anon_sym_signed] = ACTIONS(3046),
    [anon_sym_unsigned] = ACTIONS(3046),
    [anon_sym_long] = ACTIONS(3046),
    [anon_sym_short] = ACTIONS(3046),
    [anon_sym_LBRACK] = ACTIONS(3046),
    [anon_sym_static] = ACTIONS(3046),
    [anon_sym_register] = ACTIONS(3046),
    [anon_sym_inline] = ACTIONS(3046),
    [anon_sym___inline] = ACTIONS(3046),
    [anon_sym___inline__] = ACTIONS(3046),
    [anon_sym___forceinline] = ACTIONS(3046),
    [anon_sym_thread_local] = ACTIONS(3046),
    [anon_sym___thread] = ACTIONS(3046),
    [anon_sym_const] = ACTIONS(3046),
    [anon_sym_constexpr] = ACTIONS(3046),
    [anon_sym_volatile] = ACTIONS(3046),
    [anon_sym_restrict] = ACTIONS(3046),
    [anon_sym___restrict__] = ACTIONS(3046),
    [anon_sym__Atomic] = ACTIONS(3046),
    [anon_sym__Noreturn] = ACTIONS(3046),
    [anon_sym_noreturn] = ACTIONS(3046),
    [anon_sym__Nonnull] = ACTIONS(3046),
    [anon_sym_mutable] = ACTIONS(3046),
    [anon_sym_constinit] = ACTIONS(3046),
    [anon_sym_consteval] = ACTIONS(3046),
    [anon_sym_alignas] = ACTIONS(3046),
    [anon_sym__Alignas] = ACTIONS(3046),
    [sym_primitive_type] = ACTIONS(3046),
    [anon_sym_enum] = ACTIONS(3046),
    [anon_sym_class] = ACTIONS(3046),
    [anon_sym_struct] = ACTIONS(3046),
    [anon_sym_union] = ACTIONS(3046),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3046),
    [anon_sym_decltype] = ACTIONS(3046),
    [anon_sym_explicit] = ACTIONS(3046),
    [anon_sym_typename] = ACTIONS(3046),
    [anon_sym_template] = ACTIONS(3046),
    [anon_sym_operator] = ACTIONS(3046),
    [anon_sym_friend] = ACTIONS(3046),
    [anon_sym_public] = ACTIONS(3046),
    [anon_sym_private] = ACTIONS(3046),
    [anon_sym_protected] = ACTIONS(3046),
    [anon_sym_using] = ACTIONS(3046),
    [anon_sym_static_assert] = ACTIONS(3046),
  },
  [1923] = {
    [sym_identifier] = ACTIONS(3050),
    [aux_sym_preproc_def_token1] = ACTIONS(3050),
    [aux_sym_preproc_if_token1] = ACTIONS(3050),
    [aux_sym_preproc_if_token2] = ACTIONS(3050),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3050),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3050),
    [sym_preproc_directive] = ACTIONS(3050),
    [anon_sym_LPAREN2] = ACTIONS(3052),
    [anon_sym_TILDE] = ACTIONS(3052),
    [anon_sym_STAR] = ACTIONS(3052),
    [anon_sym_AMP_AMP] = ACTIONS(3052),
    [anon_sym_AMP] = ACTIONS(3050),
    [anon_sym_SEMI] = ACTIONS(3052),
    [anon_sym___extension__] = ACTIONS(3050),
    [anon_sym_typedef] = ACTIONS(3050),
    [anon_sym_virtual] = ACTIONS(3050),
    [anon_sym_extern] = ACTIONS(3050),
    [anon_sym___attribute__] = ACTIONS(3050),
    [anon_sym___attribute] = ACTIONS(3050),
    [anon_sym_COLON_COLON] = ACTIONS(3052),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3052),
    [anon_sym___declspec] = ACTIONS(3050),
    [anon_sym___based] = ACTIONS(3050),
    [anon_sym_signed] = ACTIONS(3050),
    [anon_sym_unsigned] = ACTIONS(3050),
    [anon_sym_long] = ACTIONS(3050),
    [anon_sym_short] = ACTIONS(3050),
    [anon_sym_LBRACK] = ACTIONS(3050),
    [anon_sym_static] = ACTIONS(3050),
    [anon_sym_register] = ACTIONS(3050),
    [anon_sym_inline] = ACTIONS(3050),
    [anon_sym___inline] = ACTIONS(3050),
    [anon_sym___inline__] = ACTIONS(3050),
    [anon_sym___forceinline] = ACTIONS(3050),
    [anon_sym_thread_local] = ACTIONS(3050),
    [anon_sym___thread] = ACTIONS(3050),
    [anon_sym_const] = ACTIONS(3050),
    [anon_sym_constexpr] = ACTIONS(3050),
    [anon_sym_volatile] = ACTIONS(3050),
    [anon_sym_restrict] = ACTIONS(3050),
    [anon_sym___restrict__] = ACTIONS(3050),
    [anon_sym__Atomic] = ACTIONS(3050),
    [anon_sym__Noreturn] = ACTIONS(3050),
    [anon_sym_noreturn] = ACTIONS(3050),
    [anon_sym__Nonnull] = ACTIONS(3050),
    [anon_sym_mutable] = ACTIONS(3050),
    [anon_sym_constinit] = ACTIONS(3050),
    [anon_sym_consteval] = ACTIONS(3050),
    [anon_sym_alignas] = ACTIONS(3050),
    [anon_sym__Alignas] = ACTIONS(3050),
    [sym_primitive_type] = ACTIONS(3050),
    [anon_sym_enum] = ACTIONS(3050),
    [anon_sym_class] = ACTIONS(3050),
    [anon_sym_struct] = ACTIONS(3050),
    [anon_sym_union] = ACTIONS(3050),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3050),
    [anon_sym_decltype] = ACTIONS(3050),
    [anon_sym_explicit] = ACTIONS(3050),
    [anon_sym_typename] = ACTIONS(3050),
    [anon_sym_template] = ACTIONS(3050),
    [anon_sym_operator] = ACTIONS(3050),
    [anon_sym_friend] = ACTIONS(3050),
    [anon_sym_public] = ACTIONS(3050),
    [anon_sym_private] = ACTIONS(3050),
    [anon_sym_protected] = ACTIONS(3050),
    [anon_sym_using] = ACTIONS(3050),
    [anon_sym_static_assert] = ACTIONS(3050),
  },
  [1924] = {
    [sym_identifier] = ACTIONS(3056),
    [aux_sym_preproc_def_token1] = ACTIONS(3056),
    [aux_sym_preproc_if_token1] = ACTIONS(3056),
    [aux_sym_preproc_if_token2] = ACTIONS(3056),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3056),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3056),
    [sym_preproc_directive] = ACTIONS(3056),
    [anon_sym_LPAREN2] = ACTIONS(3058),
    [anon_sym_TILDE] = ACTIONS(3058),
    [anon_sym_STAR] = ACTIONS(3058),
    [anon_sym_AMP_AMP] = ACTIONS(3058),
    [anon_sym_AMP] = ACTIONS(3056),
    [anon_sym_SEMI] = ACTIONS(3058),
    [anon_sym___extension__] = ACTIONS(3056),
    [anon_sym_typedef] = ACTIONS(3056),
    [anon_sym_virtual] = ACTIONS(3056),
    [anon_sym_extern] = ACTIONS(3056),
    [anon_sym___attribute__] = ACTIONS(3056),
    [anon_sym___attribute] = ACTIONS(3056),
    [anon_sym_COLON_COLON] = ACTIONS(3058),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3058),
    [anon_sym___declspec] = ACTIONS(3056),
    [anon_sym___based] = ACTIONS(3056),
    [anon_sym_signed] = ACTIONS(3056),
    [anon_sym_unsigned] = ACTIONS(3056),
    [anon_sym_long] = ACTIONS(3056),
    [anon_sym_short] = ACTIONS(3056),
    [anon_sym_LBRACK] = ACTIONS(3056),
    [anon_sym_static] = ACTIONS(3056),
    [anon_sym_register] = ACTIONS(3056),
    [anon_sym_inline] = ACTIONS(3056),
    [anon_sym___inline] = ACTIONS(3056),
    [anon_sym___inline__] = ACTIONS(3056),
    [anon_sym___forceinline] = ACTIONS(3056),
    [anon_sym_thread_local] = ACTIONS(3056),
    [anon_sym___thread] = ACTIONS(3056),
    [anon_sym_const] = ACTIONS(3056),
    [anon_sym_constexpr] = ACTIONS(3056),
    [anon_sym_volatile] = ACTIONS(3056),
    [anon_sym_restrict] = ACTIONS(3056),
    [anon_sym___restrict__] = ACTIONS(3056),
    [anon_sym__Atomic] = ACTIONS(3056),
    [anon_sym__Noreturn] = ACTIONS(3056),
    [anon_sym_noreturn] = ACTIONS(3056),
    [anon_sym__Nonnull] = ACTIONS(3056),
    [anon_sym_mutable] = ACTIONS(3056),
    [anon_sym_constinit] = ACTIONS(3056),
    [anon_sym_consteval] = ACTIONS(3056),
    [anon_sym_alignas] = ACTIONS(3056),
    [anon_sym__Alignas] = ACTIONS(3056),
    [sym_primitive_type] = ACTIONS(3056),
    [anon_sym_enum] = ACTIONS(3056),
    [anon_sym_class] = ACTIONS(3056),
    [anon_sym_struct] = ACTIONS(3056),
    [anon_sym_union] = ACTIONS(3056),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3056),
    [anon_sym_decltype] = ACTIONS(3056),
    [anon_sym_explicit] = ACTIONS(3056),
    [anon_sym_typename] = ACTIONS(3056),
    [anon_sym_template] = ACTIONS(3056),
    [anon_sym_operator] = ACTIONS(3056),
    [anon_sym_friend] = ACTIONS(3056),
    [anon_sym_public] = ACTIONS(3056),
    [anon_sym_private] = ACTIONS(3056),
    [anon_sym_protected] = ACTIONS(3056),
    [anon_sym_using] = ACTIONS(3056),
    [anon_sym_static_assert] = ACTIONS(3056),
  },
  [1925] = {
    [sym_identifier] = ACTIONS(3060),
    [aux_sym_preproc_def_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token2] = ACTIONS(3060),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3060),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3060),
    [sym_preproc_directive] = ACTIONS(3060),
    [anon_sym_LPAREN2] = ACTIONS(3062),
    [anon_sym_TILDE] = ACTIONS(3062),
    [anon_sym_STAR] = ACTIONS(3062),
    [anon_sym_AMP_AMP] = ACTIONS(3062),
    [anon_sym_AMP] = ACTIONS(3060),
    [anon_sym_SEMI] = ACTIONS(3062),
    [anon_sym___extension__] = ACTIONS(3060),
    [anon_sym_typedef] = ACTIONS(3060),
    [anon_sym_virtual] = ACTIONS(3060),
    [anon_sym_extern] = ACTIONS(3060),
    [anon_sym___attribute__] = ACTIONS(3060),
    [anon_sym___attribute] = ACTIONS(3060),
    [anon_sym_COLON_COLON] = ACTIONS(3062),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3062),
    [anon_sym___declspec] = ACTIONS(3060),
    [anon_sym___based] = ACTIONS(3060),
    [anon_sym_signed] = ACTIONS(3060),
    [anon_sym_unsigned] = ACTIONS(3060),
    [anon_sym_long] = ACTIONS(3060),
    [anon_sym_short] = ACTIONS(3060),
    [anon_sym_LBRACK] = ACTIONS(3060),
    [anon_sym_static] = ACTIONS(3060),
    [anon_sym_register] = ACTIONS(3060),
    [anon_sym_inline] = ACTIONS(3060),
    [anon_sym___inline] = ACTIONS(3060),
    [anon_sym___inline__] = ACTIONS(3060),
    [anon_sym___forceinline] = ACTIONS(3060),
    [anon_sym_thread_local] = ACTIONS(3060),
    [anon_sym___thread] = ACTIONS(3060),
    [anon_sym_const] = ACTIONS(3060),
    [anon_sym_constexpr] = ACTIONS(3060),
    [anon_sym_volatile] = ACTIONS(3060),
    [anon_sym_restrict] = ACTIONS(3060),
    [anon_sym___restrict__] = ACTIONS(3060),
    [anon_sym__Atomic] = ACTIONS(3060),
    [anon_sym__Noreturn] = ACTIONS(3060),
    [anon_sym_noreturn] = ACTIONS(3060),
    [anon_sym__Nonnull] = ACTIONS(3060),
    [anon_sym_mutable] = ACTIONS(3060),
    [anon_sym_constinit] = ACTIONS(3060),
    [anon_sym_consteval] = ACTIONS(3060),
    [anon_sym_alignas] = ACTIONS(3060),
    [anon_sym__Alignas] = ACTIONS(3060),
    [sym_primitive_type] = ACTIONS(3060),
    [anon_sym_enum] = ACTIONS(3060),
    [anon_sym_class] = ACTIONS(3060),
    [anon_sym_struct] = ACTIONS(3060),
    [anon_sym_union] = ACTIONS(3060),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3060),
    [anon_sym_decltype] = ACTIONS(3060),
    [anon_sym_explicit] = ACTIONS(3060),
    [anon_sym_typename] = ACTIONS(3060),
    [anon_sym_template] = ACTIONS(3060),
    [anon_sym_operator] = ACTIONS(3060),
    [anon_sym_friend] = ACTIONS(3060),
    [anon_sym_public] = ACTIONS(3060),
    [anon_sym_private] = ACTIONS(3060),
    [anon_sym_protected] = ACTIONS(3060),
    [anon_sym_using] = ACTIONS(3060),
    [anon_sym_static_assert] = ACTIONS(3060),
  },
  [1926] = {
    [sym_identifier] = ACTIONS(3068),
    [aux_sym_preproc_def_token1] = ACTIONS(3068),
    [aux_sym_preproc_if_token1] = ACTIONS(3068),
    [aux_sym_preproc_if_token2] = ACTIONS(3068),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3068),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3068),
    [sym_preproc_directive] = ACTIONS(3068),
    [anon_sym_LPAREN2] = ACTIONS(3070),
    [anon_sym_TILDE] = ACTIONS(3070),
    [anon_sym_STAR] = ACTIONS(3070),
    [anon_sym_AMP_AMP] = ACTIONS(3070),
    [anon_sym_AMP] = ACTIONS(3068),
    [anon_sym_SEMI] = ACTIONS(3070),
    [anon_sym___extension__] = ACTIONS(3068),
    [anon_sym_typedef] = ACTIONS(3068),
    [anon_sym_virtual] = ACTIONS(3068),
    [anon_sym_extern] = ACTIONS(3068),
    [anon_sym___attribute__] = ACTIONS(3068),
    [anon_sym___attribute] = ACTIONS(3068),
    [anon_sym_COLON_COLON] = ACTIONS(3070),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3070),
    [anon_sym___declspec] = ACTIONS(3068),
    [anon_sym___based] = ACTIONS(3068),
    [anon_sym_signed] = ACTIONS(3068),
    [anon_sym_unsigned] = ACTIONS(3068),
    [anon_sym_long] = ACTIONS(3068),
    [anon_sym_short] = ACTIONS(3068),
    [anon_sym_LBRACK] = ACTIONS(3068),
    [anon_sym_static] = ACTIONS(3068),
    [anon_sym_register] = ACTIONS(3068),
    [anon_sym_inline] = ACTIONS(3068),
    [anon_sym___inline] = ACTIONS(3068),
    [anon_sym___inline__] = ACTIONS(3068),
    [anon_sym___forceinline] = ACTIONS(3068),
    [anon_sym_thread_local] = ACTIONS(3068),
    [anon_sym___thread] = ACTIONS(3068),
    [anon_sym_const] = ACTIONS(3068),
    [anon_sym_constexpr] = ACTIONS(3068),
    [anon_sym_volatile] = ACTIONS(3068),
    [anon_sym_restrict] = ACTIONS(3068),
    [anon_sym___restrict__] = ACTIONS(3068),
    [anon_sym__Atomic] = ACTIONS(3068),
    [anon_sym__Noreturn] = ACTIONS(3068),
    [anon_sym_noreturn] = ACTIONS(3068),
    [anon_sym__Nonnull] = ACTIONS(3068),
    [anon_sym_mutable] = ACTIONS(3068),
    [anon_sym_constinit] = ACTIONS(3068),
    [anon_sym_consteval] = ACTIONS(3068),
    [anon_sym_alignas] = ACTIONS(3068),
    [anon_sym__Alignas] = ACTIONS(3068),
    [sym_primitive_type] = ACTIONS(3068),
    [anon_sym_enum] = ACTIONS(3068),
    [anon_sym_class] = ACTIONS(3068),
    [anon_sym_struct] = ACTIONS(3068),
    [anon_sym_union] = ACTIONS(3068),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3068),
    [anon_sym_decltype] = ACTIONS(3068),
    [anon_sym_explicit] = ACTIONS(3068),
    [anon_sym_typename] = ACTIONS(3068),
    [anon_sym_template] = ACTIONS(3068),
    [anon_sym_operator] = ACTIONS(3068),
    [anon_sym_friend] = ACTIONS(3068),
    [anon_sym_public] = ACTIONS(3068),
    [anon_sym_private] = ACTIONS(3068),
    [anon_sym_protected] = ACTIONS(3068),
    [anon_sym_using] = ACTIONS(3068),
    [anon_sym_static_assert] = ACTIONS(3068),
  },
  [1927] = {
    [sym_identifier] = ACTIONS(2818),
    [aux_sym_preproc_def_token1] = ACTIONS(2818),
    [aux_sym_preproc_if_token1] = ACTIONS(2818),
    [aux_sym_preproc_if_token2] = ACTIONS(2818),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2818),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2818),
    [sym_preproc_directive] = ACTIONS(2818),
    [anon_sym_LPAREN2] = ACTIONS(2820),
    [anon_sym_TILDE] = ACTIONS(2820),
    [anon_sym_STAR] = ACTIONS(2820),
    [anon_sym_AMP_AMP] = ACTIONS(2820),
    [anon_sym_AMP] = ACTIONS(2818),
    [anon_sym_SEMI] = ACTIONS(2820),
    [anon_sym___extension__] = ACTIONS(2818),
    [anon_sym_typedef] = ACTIONS(2818),
    [anon_sym_virtual] = ACTIONS(2818),
    [anon_sym_extern] = ACTIONS(2818),
    [anon_sym___attribute__] = ACTIONS(2818),
    [anon_sym___attribute] = ACTIONS(2818),
    [anon_sym_COLON_COLON] = ACTIONS(2820),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2820),
    [anon_sym___declspec] = ACTIONS(2818),
    [anon_sym___based] = ACTIONS(2818),
    [anon_sym_signed] = ACTIONS(2818),
    [anon_sym_unsigned] = ACTIONS(2818),
    [anon_sym_long] = ACTIONS(2818),
    [anon_sym_short] = ACTIONS(2818),
    [anon_sym_LBRACK] = ACTIONS(2818),
    [anon_sym_static] = ACTIONS(2818),
    [anon_sym_register] = ACTIONS(2818),
    [anon_sym_inline] = ACTIONS(2818),
    [anon_sym___inline] = ACTIONS(2818),
    [anon_sym___inline__] = ACTIONS(2818),
    [anon_sym___forceinline] = ACTIONS(2818),
    [anon_sym_thread_local] = ACTIONS(2818),
    [anon_sym___thread] = ACTIONS(2818),
    [anon_sym_const] = ACTIONS(2818),
    [anon_sym_constexpr] = ACTIONS(2818),
    [anon_sym_volatile] = ACTIONS(2818),
    [anon_sym_restrict] = ACTIONS(2818),
    [anon_sym___restrict__] = ACTIONS(2818),
    [anon_sym__Atomic] = ACTIONS(2818),
    [anon_sym__Noreturn] = ACTIONS(2818),
    [anon_sym_noreturn] = ACTIONS(2818),
    [anon_sym__Nonnull] = ACTIONS(2818),
    [anon_sym_mutable] = ACTIONS(2818),
    [anon_sym_constinit] = ACTIONS(2818),
    [anon_sym_consteval] = ACTIONS(2818),
    [anon_sym_alignas] = ACTIONS(2818),
    [anon_sym__Alignas] = ACTIONS(2818),
    [sym_primitive_type] = ACTIONS(2818),
    [anon_sym_enum] = ACTIONS(2818),
    [anon_sym_class] = ACTIONS(2818),
    [anon_sym_struct] = ACTIONS(2818),
    [anon_sym_union] = ACTIONS(2818),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2818),
    [anon_sym_decltype] = ACTIONS(2818),
    [anon_sym_explicit] = ACTIONS(2818),
    [anon_sym_typename] = ACTIONS(2818),
    [anon_sym_template] = ACTIONS(2818),
    [anon_sym_operator] = ACTIONS(2818),
    [anon_sym_friend] = ACTIONS(2818),
    [anon_sym_public] = ACTIONS(2818),
    [anon_sym_private] = ACTIONS(2818),
    [anon_sym_protected] = ACTIONS(2818),
    [anon_sym_using] = ACTIONS(2818),
    [anon_sym_static_assert] = ACTIONS(2818),
  },
  [1928] = {
    [sym_identifier] = ACTIONS(2822),
    [aux_sym_preproc_def_token1] = ACTIONS(2822),
    [aux_sym_preproc_if_token1] = ACTIONS(2822),
    [aux_sym_preproc_if_token2] = ACTIONS(2822),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2822),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2822),
    [sym_preproc_directive] = ACTIONS(2822),
    [anon_sym_LPAREN2] = ACTIONS(2824),
    [anon_sym_TILDE] = ACTIONS(2824),
    [anon_sym_STAR] = ACTIONS(2824),
    [anon_sym_AMP_AMP] = ACTIONS(2824),
    [anon_sym_AMP] = ACTIONS(2822),
    [anon_sym_SEMI] = ACTIONS(2824),
    [anon_sym___extension__] = ACTIONS(2822),
    [anon_sym_typedef] = ACTIONS(2822),
    [anon_sym_virtual] = ACTIONS(2822),
    [anon_sym_extern] = ACTIONS(2822),
    [anon_sym___attribute__] = ACTIONS(2822),
    [anon_sym___attribute] = ACTIONS(2822),
    [anon_sym_COLON_COLON] = ACTIONS(2824),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2824),
    [anon_sym___declspec] = ACTIONS(2822),
    [anon_sym___based] = ACTIONS(2822),
    [anon_sym_signed] = ACTIONS(2822),
    [anon_sym_unsigned] = ACTIONS(2822),
    [anon_sym_long] = ACTIONS(2822),
    [anon_sym_short] = ACTIONS(2822),
    [anon_sym_LBRACK] = ACTIONS(2822),
    [anon_sym_static] = ACTIONS(2822),
    [anon_sym_register] = ACTIONS(2822),
    [anon_sym_inline] = ACTIONS(2822),
    [anon_sym___inline] = ACTIONS(2822),
    [anon_sym___inline__] = ACTIONS(2822),
    [anon_sym___forceinline] = ACTIONS(2822),
    [anon_sym_thread_local] = ACTIONS(2822),
    [anon_sym___thread] = ACTIONS(2822),
    [anon_sym_const] = ACTIONS(2822),
    [anon_sym_constexpr] = ACTIONS(2822),
    [anon_sym_volatile] = ACTIONS(2822),
    [anon_sym_restrict] = ACTIONS(2822),
    [anon_sym___restrict__] = ACTIONS(2822),
    [anon_sym__Atomic] = ACTIONS(2822),
    [anon_sym__Noreturn] = ACTIONS(2822),
    [anon_sym_noreturn] = ACTIONS(2822),
    [anon_sym__Nonnull] = ACTIONS(2822),
    [anon_sym_mutable] = ACTIONS(2822),
    [anon_sym_constinit] = ACTIONS(2822),
    [anon_sym_consteval] = ACTIONS(2822),
    [anon_sym_alignas] = ACTIONS(2822),
    [anon_sym__Alignas] = ACTIONS(2822),
    [sym_primitive_type] = ACTIONS(2822),
    [anon_sym_enum] = ACTIONS(2822),
    [anon_sym_class] = ACTIONS(2822),
    [anon_sym_struct] = ACTIONS(2822),
    [anon_sym_union] = ACTIONS(2822),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2822),
    [anon_sym_decltype] = ACTIONS(2822),
    [anon_sym_explicit] = ACTIONS(2822),
    [anon_sym_typename] = ACTIONS(2822),
    [anon_sym_template] = ACTIONS(2822),
    [anon_sym_operator] = ACTIONS(2822),
    [anon_sym_friend] = ACTIONS(2822),
    [anon_sym_public] = ACTIONS(2822),
    [anon_sym_private] = ACTIONS(2822),
    [anon_sym_protected] = ACTIONS(2822),
    [anon_sym_using] = ACTIONS(2822),
    [anon_sym_static_assert] = ACTIONS(2822),
  },
  [1929] = {
    [sym_identifier] = ACTIONS(2735),
    [aux_sym_preproc_def_token1] = ACTIONS(2735),
    [aux_sym_preproc_if_token1] = ACTIONS(2735),
    [aux_sym_preproc_if_token2] = ACTIONS(2735),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2735),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2735),
    [sym_preproc_directive] = ACTIONS(2735),
    [anon_sym_LPAREN2] = ACTIONS(2737),
    [anon_sym_TILDE] = ACTIONS(2737),
    [anon_sym_STAR] = ACTIONS(2737),
    [anon_sym_AMP_AMP] = ACTIONS(2737),
    [anon_sym_AMP] = ACTIONS(2735),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym___extension__] = ACTIONS(2735),
    [anon_sym_typedef] = ACTIONS(2735),
    [anon_sym_virtual] = ACTIONS(2735),
    [anon_sym_extern] = ACTIONS(2735),
    [anon_sym___attribute__] = ACTIONS(2735),
    [anon_sym___attribute] = ACTIONS(2735),
    [anon_sym_COLON_COLON] = ACTIONS(2737),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2737),
    [anon_sym___declspec] = ACTIONS(2735),
    [anon_sym___based] = ACTIONS(2735),
    [anon_sym_signed] = ACTIONS(2735),
    [anon_sym_unsigned] = ACTIONS(2735),
    [anon_sym_long] = ACTIONS(2735),
    [anon_sym_short] = ACTIONS(2735),
    [anon_sym_LBRACK] = ACTIONS(2735),
    [anon_sym_static] = ACTIONS(2735),
    [anon_sym_register] = ACTIONS(2735),
    [anon_sym_inline] = ACTIONS(2735),
    [anon_sym___inline] = ACTIONS(2735),
    [anon_sym___inline__] = ACTIONS(2735),
    [anon_sym___forceinline] = ACTIONS(2735),
    [anon_sym_thread_local] = ACTIONS(2735),
    [anon_sym___thread] = ACTIONS(2735),
    [anon_sym_const] = ACTIONS(2735),
    [anon_sym_constexpr] = ACTIONS(2735),
    [anon_sym_volatile] = ACTIONS(2735),
    [anon_sym_restrict] = ACTIONS(2735),
    [anon_sym___restrict__] = ACTIONS(2735),
    [anon_sym__Atomic] = ACTIONS(2735),
    [anon_sym__Noreturn] = ACTIONS(2735),
    [anon_sym_noreturn] = ACTIONS(2735),
    [anon_sym__Nonnull] = ACTIONS(2735),
    [anon_sym_mutable] = ACTIONS(2735),
    [anon_sym_constinit] = ACTIONS(2735),
    [anon_sym_consteval] = ACTIONS(2735),
    [anon_sym_alignas] = ACTIONS(2735),
    [anon_sym__Alignas] = ACTIONS(2735),
    [sym_primitive_type] = ACTIONS(2735),
    [anon_sym_enum] = ACTIONS(2735),
    [anon_sym_class] = ACTIONS(2735),
    [anon_sym_struct] = ACTIONS(2735),
    [anon_sym_union] = ACTIONS(2735),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2735),
    [anon_sym_decltype] = ACTIONS(2735),
    [anon_sym_explicit] = ACTIONS(2735),
    [anon_sym_typename] = ACTIONS(2735),
    [anon_sym_template] = ACTIONS(2735),
    [anon_sym_operator] = ACTIONS(2735),
    [anon_sym_friend] = ACTIONS(2735),
    [anon_sym_public] = ACTIONS(2735),
    [anon_sym_private] = ACTIONS(2735),
    [anon_sym_protected] = ACTIONS(2735),
    [anon_sym_using] = ACTIONS(2735),
    [anon_sym_static_assert] = ACTIONS(2735),
  },
  [1930] = {
    [sym_identifier] = ACTIONS(2739),
    [aux_sym_preproc_def_token1] = ACTIONS(2739),
    [aux_sym_preproc_if_token1] = ACTIONS(2739),
    [aux_sym_preproc_if_token2] = ACTIONS(2739),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2739),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2739),
    [sym_preproc_directive] = ACTIONS(2739),
    [anon_sym_LPAREN2] = ACTIONS(2741),
    [anon_sym_TILDE] = ACTIONS(2741),
    [anon_sym_STAR] = ACTIONS(2741),
    [anon_sym_AMP_AMP] = ACTIONS(2741),
    [anon_sym_AMP] = ACTIONS(2739),
    [anon_sym_SEMI] = ACTIONS(2741),
    [anon_sym___extension__] = ACTIONS(2739),
    [anon_sym_typedef] = ACTIONS(2739),
    [anon_sym_virtual] = ACTIONS(2739),
    [anon_sym_extern] = ACTIONS(2739),
    [anon_sym___attribute__] = ACTIONS(2739),
    [anon_sym___attribute] = ACTIONS(2739),
    [anon_sym_COLON_COLON] = ACTIONS(2741),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2741),
    [anon_sym___declspec] = ACTIONS(2739),
    [anon_sym___based] = ACTIONS(2739),
    [anon_sym_signed] = ACTIONS(2739),
    [anon_sym_unsigned] = ACTIONS(2739),
    [anon_sym_long] = ACTIONS(2739),
    [anon_sym_short] = ACTIONS(2739),
    [anon_sym_LBRACK] = ACTIONS(2739),
    [anon_sym_static] = ACTIONS(2739),
    [anon_sym_register] = ACTIONS(2739),
    [anon_sym_inline] = ACTIONS(2739),
    [anon_sym___inline] = ACTIONS(2739),
    [anon_sym___inline__] = ACTIONS(2739),
    [anon_sym___forceinline] = ACTIONS(2739),
    [anon_sym_thread_local] = ACTIONS(2739),
    [anon_sym___thread] = ACTIONS(2739),
    [anon_sym_const] = ACTIONS(2739),
    [anon_sym_constexpr] = ACTIONS(2739),
    [anon_sym_volatile] = ACTIONS(2739),
    [anon_sym_restrict] = ACTIONS(2739),
    [anon_sym___restrict__] = ACTIONS(2739),
    [anon_sym__Atomic] = ACTIONS(2739),
    [anon_sym__Noreturn] = ACTIONS(2739),
    [anon_sym_noreturn] = ACTIONS(2739),
    [anon_sym__Nonnull] = ACTIONS(2739),
    [anon_sym_mutable] = ACTIONS(2739),
    [anon_sym_constinit] = ACTIONS(2739),
    [anon_sym_consteval] = ACTIONS(2739),
    [anon_sym_alignas] = ACTIONS(2739),
    [anon_sym__Alignas] = ACTIONS(2739),
    [sym_primitive_type] = ACTIONS(2739),
    [anon_sym_enum] = ACTIONS(2739),
    [anon_sym_class] = ACTIONS(2739),
    [anon_sym_struct] = ACTIONS(2739),
    [anon_sym_union] = ACTIONS(2739),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2739),
    [anon_sym_decltype] = ACTIONS(2739),
    [anon_sym_explicit] = ACTIONS(2739),
    [anon_sym_typename] = ACTIONS(2739),
    [anon_sym_template] = ACTIONS(2739),
    [anon_sym_operator] = ACTIONS(2739),
    [anon_sym_friend] = ACTIONS(2739),
    [anon_sym_public] = ACTIONS(2739),
    [anon_sym_private] = ACTIONS(2739),
    [anon_sym_protected] = ACTIONS(2739),
    [anon_sym_using] = ACTIONS(2739),
    [anon_sym_static_assert] = ACTIONS(2739),
  },
  [1931] = {
    [sym_identifier] = ACTIONS(3094),
    [aux_sym_preproc_def_token1] = ACTIONS(3094),
    [aux_sym_preproc_if_token1] = ACTIONS(3094),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3094),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3094),
    [sym_preproc_directive] = ACTIONS(3094),
    [anon_sym_LPAREN2] = ACTIONS(3096),
    [anon_sym_TILDE] = ACTIONS(3096),
    [anon_sym_STAR] = ACTIONS(3096),
    [anon_sym_AMP_AMP] = ACTIONS(3096),
    [anon_sym_AMP] = ACTIONS(3094),
    [anon_sym_SEMI] = ACTIONS(3096),
    [anon_sym___extension__] = ACTIONS(3094),
    [anon_sym_typedef] = ACTIONS(3094),
    [anon_sym_virtual] = ACTIONS(3094),
    [anon_sym_extern] = ACTIONS(3094),
    [anon_sym___attribute__] = ACTIONS(3094),
    [anon_sym___attribute] = ACTIONS(3094),
    [anon_sym_COLON_COLON] = ACTIONS(3096),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3096),
    [anon_sym___declspec] = ACTIONS(3094),
    [anon_sym___based] = ACTIONS(3094),
    [anon_sym_RBRACE] = ACTIONS(3096),
    [anon_sym_signed] = ACTIONS(3094),
    [anon_sym_unsigned] = ACTIONS(3094),
    [anon_sym_long] = ACTIONS(3094),
    [anon_sym_short] = ACTIONS(3094),
    [anon_sym_LBRACK] = ACTIONS(3094),
    [anon_sym_static] = ACTIONS(3094),
    [anon_sym_register] = ACTIONS(3094),
    [anon_sym_inline] = ACTIONS(3094),
    [anon_sym___inline] = ACTIONS(3094),
    [anon_sym___inline__] = ACTIONS(3094),
    [anon_sym___forceinline] = ACTIONS(3094),
    [anon_sym_thread_local] = ACTIONS(3094),
    [anon_sym___thread] = ACTIONS(3094),
    [anon_sym_const] = ACTIONS(3094),
    [anon_sym_constexpr] = ACTIONS(3094),
    [anon_sym_volatile] = ACTIONS(3094),
    [anon_sym_restrict] = ACTIONS(3094),
    [anon_sym___restrict__] = ACTIONS(3094),
    [anon_sym__Atomic] = ACTIONS(3094),
    [anon_sym__Noreturn] = ACTIONS(3094),
    [anon_sym_noreturn] = ACTIONS(3094),
    [anon_sym__Nonnull] = ACTIONS(3094),
    [anon_sym_mutable] = ACTIONS(3094),
    [anon_sym_constinit] = ACTIONS(3094),
    [anon_sym_consteval] = ACTIONS(3094),
    [anon_sym_alignas] = ACTIONS(3094),
    [anon_sym__Alignas] = ACTIONS(3094),
    [sym_primitive_type] = ACTIONS(3094),
    [anon_sym_enum] = ACTIONS(3094),
    [anon_sym_class] = ACTIONS(3094),
    [anon_sym_struct] = ACTIONS(3094),
    [anon_sym_union] = ACTIONS(3094),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3094),
    [anon_sym_decltype] = ACTIONS(3094),
    [anon_sym_explicit] = ACTIONS(3094),
    [anon_sym_typename] = ACTIONS(3094),
    [anon_sym_template] = ACTIONS(3094),
    [anon_sym_operator] = ACTIONS(3094),
    [anon_sym_friend] = ACTIONS(3094),
    [anon_sym_public] = ACTIONS(3094),
    [anon_sym_private] = ACTIONS(3094),
    [anon_sym_protected] = ACTIONS(3094),
    [anon_sym_using] = ACTIONS(3094),
    [anon_sym_static_assert] = ACTIONS(3094),
  },
  [1932] = {
    [sym_identifier] = ACTIONS(2747),
    [aux_sym_preproc_def_token1] = ACTIONS(2747),
    [aux_sym_preproc_if_token1] = ACTIONS(2747),
    [aux_sym_preproc_if_token2] = ACTIONS(2747),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2747),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2747),
    [sym_preproc_directive] = ACTIONS(2747),
    [anon_sym_LPAREN2] = ACTIONS(2749),
    [anon_sym_TILDE] = ACTIONS(2749),
    [anon_sym_STAR] = ACTIONS(2749),
    [anon_sym_AMP_AMP] = ACTIONS(2749),
    [anon_sym_AMP] = ACTIONS(2747),
    [anon_sym_SEMI] = ACTIONS(2749),
    [anon_sym___extension__] = ACTIONS(2747),
    [anon_sym_typedef] = ACTIONS(2747),
    [anon_sym_virtual] = ACTIONS(2747),
    [anon_sym_extern] = ACTIONS(2747),
    [anon_sym___attribute__] = ACTIONS(2747),
    [anon_sym___attribute] = ACTIONS(2747),
    [anon_sym_COLON_COLON] = ACTIONS(2749),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2749),
    [anon_sym___declspec] = ACTIONS(2747),
    [anon_sym___based] = ACTIONS(2747),
    [anon_sym_signed] = ACTIONS(2747),
    [anon_sym_unsigned] = ACTIONS(2747),
    [anon_sym_long] = ACTIONS(2747),
    [anon_sym_short] = ACTIONS(2747),
    [anon_sym_LBRACK] = ACTIONS(2747),
    [anon_sym_static] = ACTIONS(2747),
    [anon_sym_register] = ACTIONS(2747),
    [anon_sym_inline] = ACTIONS(2747),
    [anon_sym___inline] = ACTIONS(2747),
    [anon_sym___inline__] = ACTIONS(2747),
    [anon_sym___forceinline] = ACTIONS(2747),
    [anon_sym_thread_local] = ACTIONS(2747),
    [anon_sym___thread] = ACTIONS(2747),
    [anon_sym_const] = ACTIONS(2747),
    [anon_sym_constexpr] = ACTIONS(2747),
    [anon_sym_volatile] = ACTIONS(2747),
    [anon_sym_restrict] = ACTIONS(2747),
    [anon_sym___restrict__] = ACTIONS(2747),
    [anon_sym__Atomic] = ACTIONS(2747),
    [anon_sym__Noreturn] = ACTIONS(2747),
    [anon_sym_noreturn] = ACTIONS(2747),
    [anon_sym__Nonnull] = ACTIONS(2747),
    [anon_sym_mutable] = ACTIONS(2747),
    [anon_sym_constinit] = ACTIONS(2747),
    [anon_sym_consteval] = ACTIONS(2747),
    [anon_sym_alignas] = ACTIONS(2747),
    [anon_sym__Alignas] = ACTIONS(2747),
    [sym_primitive_type] = ACTIONS(2747),
    [anon_sym_enum] = ACTIONS(2747),
    [anon_sym_class] = ACTIONS(2747),
    [anon_sym_struct] = ACTIONS(2747),
    [anon_sym_union] = ACTIONS(2747),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2747),
    [anon_sym_decltype] = ACTIONS(2747),
    [anon_sym_explicit] = ACTIONS(2747),
    [anon_sym_typename] = ACTIONS(2747),
    [anon_sym_template] = ACTIONS(2747),
    [anon_sym_operator] = ACTIONS(2747),
    [anon_sym_friend] = ACTIONS(2747),
    [anon_sym_public] = ACTIONS(2747),
    [anon_sym_private] = ACTIONS(2747),
    [anon_sym_protected] = ACTIONS(2747),
    [anon_sym_using] = ACTIONS(2747),
    [anon_sym_static_assert] = ACTIONS(2747),
  },
  [1933] = {
    [sym_identifier] = ACTIONS(2747),
    [aux_sym_preproc_def_token1] = ACTIONS(2747),
    [aux_sym_preproc_if_token1] = ACTIONS(2747),
    [aux_sym_preproc_if_token2] = ACTIONS(2747),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2747),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2747),
    [sym_preproc_directive] = ACTIONS(2747),
    [anon_sym_LPAREN2] = ACTIONS(2749),
    [anon_sym_TILDE] = ACTIONS(2749),
    [anon_sym_STAR] = ACTIONS(2749),
    [anon_sym_AMP_AMP] = ACTIONS(2749),
    [anon_sym_AMP] = ACTIONS(2747),
    [anon_sym_SEMI] = ACTIONS(2749),
    [anon_sym___extension__] = ACTIONS(2747),
    [anon_sym_typedef] = ACTIONS(2747),
    [anon_sym_virtual] = ACTIONS(2747),
    [anon_sym_extern] = ACTIONS(2747),
    [anon_sym___attribute__] = ACTIONS(2747),
    [anon_sym___attribute] = ACTIONS(2747),
    [anon_sym_COLON_COLON] = ACTIONS(2749),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2749),
    [anon_sym___declspec] = ACTIONS(2747),
    [anon_sym___based] = ACTIONS(2747),
    [anon_sym_signed] = ACTIONS(2747),
    [anon_sym_unsigned] = ACTIONS(2747),
    [anon_sym_long] = ACTIONS(2747),
    [anon_sym_short] = ACTIONS(2747),
    [anon_sym_LBRACK] = ACTIONS(2747),
    [anon_sym_static] = ACTIONS(2747),
    [anon_sym_register] = ACTIONS(2747),
    [anon_sym_inline] = ACTIONS(2747),
    [anon_sym___inline] = ACTIONS(2747),
    [anon_sym___inline__] = ACTIONS(2747),
    [anon_sym___forceinline] = ACTIONS(2747),
    [anon_sym_thread_local] = ACTIONS(2747),
    [anon_sym___thread] = ACTIONS(2747),
    [anon_sym_const] = ACTIONS(2747),
    [anon_sym_constexpr] = ACTIONS(2747),
    [anon_sym_volatile] = ACTIONS(2747),
    [anon_sym_restrict] = ACTIONS(2747),
    [anon_sym___restrict__] = ACTIONS(2747),
    [anon_sym__Atomic] = ACTIONS(2747),
    [anon_sym__Noreturn] = ACTIONS(2747),
    [anon_sym_noreturn] = ACTIONS(2747),
    [anon_sym__Nonnull] = ACTIONS(2747),
    [anon_sym_mutable] = ACTIONS(2747),
    [anon_sym_constinit] = ACTIONS(2747),
    [anon_sym_consteval] = ACTIONS(2747),
    [anon_sym_alignas] = ACTIONS(2747),
    [anon_sym__Alignas] = ACTIONS(2747),
    [sym_primitive_type] = ACTIONS(2747),
    [anon_sym_enum] = ACTIONS(2747),
    [anon_sym_class] = ACTIONS(2747),
    [anon_sym_struct] = ACTIONS(2747),
    [anon_sym_union] = ACTIONS(2747),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2747),
    [anon_sym_decltype] = ACTIONS(2747),
    [anon_sym_explicit] = ACTIONS(2747),
    [anon_sym_typename] = ACTIONS(2747),
    [anon_sym_template] = ACTIONS(2747),
    [anon_sym_operator] = ACTIONS(2747),
    [anon_sym_friend] = ACTIONS(2747),
    [anon_sym_public] = ACTIONS(2747),
    [anon_sym_private] = ACTIONS(2747),
    [anon_sym_protected] = ACTIONS(2747),
    [anon_sym_using] = ACTIONS(2747),
    [anon_sym_static_assert] = ACTIONS(2747),
  },
  [1934] = {
    [sym_identifier] = ACTIONS(3098),
    [aux_sym_preproc_def_token1] = ACTIONS(3098),
    [aux_sym_preproc_if_token1] = ACTIONS(3098),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3098),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3098),
    [sym_preproc_directive] = ACTIONS(3098),
    [anon_sym_LPAREN2] = ACTIONS(3100),
    [anon_sym_TILDE] = ACTIONS(3100),
    [anon_sym_STAR] = ACTIONS(3100),
    [anon_sym_AMP_AMP] = ACTIONS(3100),
    [anon_sym_AMP] = ACTIONS(3098),
    [anon_sym_SEMI] = ACTIONS(3100),
    [anon_sym___extension__] = ACTIONS(3098),
    [anon_sym_typedef] = ACTIONS(3098),
    [anon_sym_virtual] = ACTIONS(3098),
    [anon_sym_extern] = ACTIONS(3098),
    [anon_sym___attribute__] = ACTIONS(3098),
    [anon_sym___attribute] = ACTIONS(3098),
    [anon_sym_COLON_COLON] = ACTIONS(3100),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3100),
    [anon_sym___declspec] = ACTIONS(3098),
    [anon_sym___based] = ACTIONS(3098),
    [anon_sym_RBRACE] = ACTIONS(3100),
    [anon_sym_signed] = ACTIONS(3098),
    [anon_sym_unsigned] = ACTIONS(3098),
    [anon_sym_long] = ACTIONS(3098),
    [anon_sym_short] = ACTIONS(3098),
    [anon_sym_LBRACK] = ACTIONS(3098),
    [anon_sym_static] = ACTIONS(3098),
    [anon_sym_register] = ACTIONS(3098),
    [anon_sym_inline] = ACTIONS(3098),
    [anon_sym___inline] = ACTIONS(3098),
    [anon_sym___inline__] = ACTIONS(3098),
    [anon_sym___forceinline] = ACTIONS(3098),
    [anon_sym_thread_local] = ACTIONS(3098),
    [anon_sym___thread] = ACTIONS(3098),
    [anon_sym_const] = ACTIONS(3098),
    [anon_sym_constexpr] = ACTIONS(3098),
    [anon_sym_volatile] = ACTIONS(3098),
    [anon_sym_restrict] = ACTIONS(3098),
    [anon_sym___restrict__] = ACTIONS(3098),
    [anon_sym__Atomic] = ACTIONS(3098),
    [anon_sym__Noreturn] = ACTIONS(3098),
    [anon_sym_noreturn] = ACTIONS(3098),
    [anon_sym__Nonnull] = ACTIONS(3098),
    [anon_sym_mutable] = ACTIONS(3098),
    [anon_sym_constinit] = ACTIONS(3098),
    [anon_sym_consteval] = ACTIONS(3098),
    [anon_sym_alignas] = ACTIONS(3098),
    [anon_sym__Alignas] = ACTIONS(3098),
    [sym_primitive_type] = ACTIONS(3098),
    [anon_sym_enum] = ACTIONS(3098),
    [anon_sym_class] = ACTIONS(3098),
    [anon_sym_struct] = ACTIONS(3098),
    [anon_sym_union] = ACTIONS(3098),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3098),
    [anon_sym_decltype] = ACTIONS(3098),
    [anon_sym_explicit] = ACTIONS(3098),
    [anon_sym_typename] = ACTIONS(3098),
    [anon_sym_template] = ACTIONS(3098),
    [anon_sym_operator] = ACTIONS(3098),
    [anon_sym_friend] = ACTIONS(3098),
    [anon_sym_public] = ACTIONS(3098),
    [anon_sym_private] = ACTIONS(3098),
    [anon_sym_protected] = ACTIONS(3098),
    [anon_sym_using] = ACTIONS(3098),
    [anon_sym_static_assert] = ACTIONS(3098),
  },
  [1935] = {
    [sym_identifier] = ACTIONS(3170),
    [aux_sym_preproc_def_token1] = ACTIONS(3170),
    [aux_sym_preproc_if_token1] = ACTIONS(3170),
    [aux_sym_preproc_if_token2] = ACTIONS(3170),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3170),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3170),
    [sym_preproc_directive] = ACTIONS(3170),
    [anon_sym_LPAREN2] = ACTIONS(3172),
    [anon_sym_TILDE] = ACTIONS(3172),
    [anon_sym_STAR] = ACTIONS(3172),
    [anon_sym_AMP_AMP] = ACTIONS(3172),
    [anon_sym_AMP] = ACTIONS(3170),
    [anon_sym_SEMI] = ACTIONS(3172),
    [anon_sym___extension__] = ACTIONS(3170),
    [anon_sym_typedef] = ACTIONS(3170),
    [anon_sym_virtual] = ACTIONS(3170),
    [anon_sym_extern] = ACTIONS(3170),
    [anon_sym___attribute__] = ACTIONS(3170),
    [anon_sym___attribute] = ACTIONS(3170),
    [anon_sym_COLON_COLON] = ACTIONS(3172),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3172),
    [anon_sym___declspec] = ACTIONS(3170),
    [anon_sym___based] = ACTIONS(3170),
    [anon_sym_signed] = ACTIONS(3170),
    [anon_sym_unsigned] = ACTIONS(3170),
    [anon_sym_long] = ACTIONS(3170),
    [anon_sym_short] = ACTIONS(3170),
    [anon_sym_LBRACK] = ACTIONS(3170),
    [anon_sym_static] = ACTIONS(3170),
    [anon_sym_register] = ACTIONS(3170),
    [anon_sym_inline] = ACTIONS(3170),
    [anon_sym___inline] = ACTIONS(3170),
    [anon_sym___inline__] = ACTIONS(3170),
    [anon_sym___forceinline] = ACTIONS(3170),
    [anon_sym_thread_local] = ACTIONS(3170),
    [anon_sym___thread] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3170),
    [anon_sym_constexpr] = ACTIONS(3170),
    [anon_sym_volatile] = ACTIONS(3170),
    [anon_sym_restrict] = ACTIONS(3170),
    [anon_sym___restrict__] = ACTIONS(3170),
    [anon_sym__Atomic] = ACTIONS(3170),
    [anon_sym__Noreturn] = ACTIONS(3170),
    [anon_sym_noreturn] = ACTIONS(3170),
    [anon_sym__Nonnull] = ACTIONS(3170),
    [anon_sym_mutable] = ACTIONS(3170),
    [anon_sym_constinit] = ACTIONS(3170),
    [anon_sym_consteval] = ACTIONS(3170),
    [anon_sym_alignas] = ACTIONS(3170),
    [anon_sym__Alignas] = ACTIONS(3170),
    [sym_primitive_type] = ACTIONS(3170),
    [anon_sym_enum] = ACTIONS(3170),
    [anon_sym_class] = ACTIONS(3170),
    [anon_sym_struct] = ACTIONS(3170),
    [anon_sym_union] = ACTIONS(3170),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3170),
    [anon_sym_decltype] = ACTIONS(3170),
    [anon_sym_explicit] = ACTIONS(3170),
    [anon_sym_typename] = ACTIONS(3170),
    [anon_sym_template] = ACTIONS(3170),
    [anon_sym_operator] = ACTIONS(3170),
    [anon_sym_friend] = ACTIONS(3170),
    [anon_sym_public] = ACTIONS(3170),
    [anon_sym_private] = ACTIONS(3170),
    [anon_sym_protected] = ACTIONS(3170),
    [anon_sym_using] = ACTIONS(3170),
    [anon_sym_static_assert] = ACTIONS(3170),
  },
  [1936] = {
    [sym_identifier] = ACTIONS(2826),
    [aux_sym_preproc_def_token1] = ACTIONS(2826),
    [aux_sym_preproc_if_token1] = ACTIONS(2826),
    [aux_sym_preproc_if_token2] = ACTIONS(2826),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2826),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2826),
    [sym_preproc_directive] = ACTIONS(2826),
    [anon_sym_LPAREN2] = ACTIONS(2828),
    [anon_sym_TILDE] = ACTIONS(2828),
    [anon_sym_STAR] = ACTIONS(2828),
    [anon_sym_AMP_AMP] = ACTIONS(2828),
    [anon_sym_AMP] = ACTIONS(2826),
    [anon_sym_SEMI] = ACTIONS(2828),
    [anon_sym___extension__] = ACTIONS(2826),
    [anon_sym_typedef] = ACTIONS(2826),
    [anon_sym_virtual] = ACTIONS(2826),
    [anon_sym_extern] = ACTIONS(2826),
    [anon_sym___attribute__] = ACTIONS(2826),
    [anon_sym___attribute] = ACTIONS(2826),
    [anon_sym_COLON_COLON] = ACTIONS(2828),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2828),
    [anon_sym___declspec] = ACTIONS(2826),
    [anon_sym___based] = ACTIONS(2826),
    [anon_sym_signed] = ACTIONS(2826),
    [anon_sym_unsigned] = ACTIONS(2826),
    [anon_sym_long] = ACTIONS(2826),
    [anon_sym_short] = ACTIONS(2826),
    [anon_sym_LBRACK] = ACTIONS(2826),
    [anon_sym_static] = ACTIONS(2826),
    [anon_sym_register] = ACTIONS(2826),
    [anon_sym_inline] = ACTIONS(2826),
    [anon_sym___inline] = ACTIONS(2826),
    [anon_sym___inline__] = ACTIONS(2826),
    [anon_sym___forceinline] = ACTIONS(2826),
    [anon_sym_thread_local] = ACTIONS(2826),
    [anon_sym___thread] = ACTIONS(2826),
    [anon_sym_const] = ACTIONS(2826),
    [anon_sym_constexpr] = ACTIONS(2826),
    [anon_sym_volatile] = ACTIONS(2826),
    [anon_sym_restrict] = ACTIONS(2826),
    [anon_sym___restrict__] = ACTIONS(2826),
    [anon_sym__Atomic] = ACTIONS(2826),
    [anon_sym__Noreturn] = ACTIONS(2826),
    [anon_sym_noreturn] = ACTIONS(2826),
    [anon_sym__Nonnull] = ACTIONS(2826),
    [anon_sym_mutable] = ACTIONS(2826),
    [anon_sym_constinit] = ACTIONS(2826),
    [anon_sym_consteval] = ACTIONS(2826),
    [anon_sym_alignas] = ACTIONS(2826),
    [anon_sym__Alignas] = ACTIONS(2826),
    [sym_primitive_type] = ACTIONS(2826),
    [anon_sym_enum] = ACTIONS(2826),
    [anon_sym_class] = ACTIONS(2826),
    [anon_sym_struct] = ACTIONS(2826),
    [anon_sym_union] = ACTIONS(2826),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2826),
    [anon_sym_decltype] = ACTIONS(2826),
    [anon_sym_explicit] = ACTIONS(2826),
    [anon_sym_typename] = ACTIONS(2826),
    [anon_sym_template] = ACTIONS(2826),
    [anon_sym_operator] = ACTIONS(2826),
    [anon_sym_friend] = ACTIONS(2826),
    [anon_sym_public] = ACTIONS(2826),
    [anon_sym_private] = ACTIONS(2826),
    [anon_sym_protected] = ACTIONS(2826),
    [anon_sym_using] = ACTIONS(2826),
    [anon_sym_static_assert] = ACTIONS(2826),
  },
  [1937] = {
    [sym_identifier] = ACTIONS(2830),
    [aux_sym_preproc_def_token1] = ACTIONS(2830),
    [aux_sym_preproc_if_token1] = ACTIONS(2830),
    [aux_sym_preproc_if_token2] = ACTIONS(2830),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2830),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2830),
    [sym_preproc_directive] = ACTIONS(2830),
    [anon_sym_LPAREN2] = ACTIONS(2832),
    [anon_sym_TILDE] = ACTIONS(2832),
    [anon_sym_STAR] = ACTIONS(2832),
    [anon_sym_AMP_AMP] = ACTIONS(2832),
    [anon_sym_AMP] = ACTIONS(2830),
    [anon_sym_SEMI] = ACTIONS(2832),
    [anon_sym___extension__] = ACTIONS(2830),
    [anon_sym_typedef] = ACTIONS(2830),
    [anon_sym_virtual] = ACTIONS(2830),
    [anon_sym_extern] = ACTIONS(2830),
    [anon_sym___attribute__] = ACTIONS(2830),
    [anon_sym___attribute] = ACTIONS(2830),
    [anon_sym_COLON_COLON] = ACTIONS(2832),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2832),
    [anon_sym___declspec] = ACTIONS(2830),
    [anon_sym___based] = ACTIONS(2830),
    [anon_sym_signed] = ACTIONS(2830),
    [anon_sym_unsigned] = ACTIONS(2830),
    [anon_sym_long] = ACTIONS(2830),
    [anon_sym_short] = ACTIONS(2830),
    [anon_sym_LBRACK] = ACTIONS(2830),
    [anon_sym_static] = ACTIONS(2830),
    [anon_sym_register] = ACTIONS(2830),
    [anon_sym_inline] = ACTIONS(2830),
    [anon_sym___inline] = ACTIONS(2830),
    [anon_sym___inline__] = ACTIONS(2830),
    [anon_sym___forceinline] = ACTIONS(2830),
    [anon_sym_thread_local] = ACTIONS(2830),
    [anon_sym___thread] = ACTIONS(2830),
    [anon_sym_const] = ACTIONS(2830),
    [anon_sym_constexpr] = ACTIONS(2830),
    [anon_sym_volatile] = ACTIONS(2830),
    [anon_sym_restrict] = ACTIONS(2830),
    [anon_sym___restrict__] = ACTIONS(2830),
    [anon_sym__Atomic] = ACTIONS(2830),
    [anon_sym__Noreturn] = ACTIONS(2830),
    [anon_sym_noreturn] = ACTIONS(2830),
    [anon_sym__Nonnull] = ACTIONS(2830),
    [anon_sym_mutable] = ACTIONS(2830),
    [anon_sym_constinit] = ACTIONS(2830),
    [anon_sym_consteval] = ACTIONS(2830),
    [anon_sym_alignas] = ACTIONS(2830),
    [anon_sym__Alignas] = ACTIONS(2830),
    [sym_primitive_type] = ACTIONS(2830),
    [anon_sym_enum] = ACTIONS(2830),
    [anon_sym_class] = ACTIONS(2830),
    [anon_sym_struct] = ACTIONS(2830),
    [anon_sym_union] = ACTIONS(2830),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2830),
    [anon_sym_decltype] = ACTIONS(2830),
    [anon_sym_explicit] = ACTIONS(2830),
    [anon_sym_typename] = ACTIONS(2830),
    [anon_sym_template] = ACTIONS(2830),
    [anon_sym_operator] = ACTIONS(2830),
    [anon_sym_friend] = ACTIONS(2830),
    [anon_sym_public] = ACTIONS(2830),
    [anon_sym_private] = ACTIONS(2830),
    [anon_sym_protected] = ACTIONS(2830),
    [anon_sym_using] = ACTIONS(2830),
    [anon_sym_static_assert] = ACTIONS(2830),
  },
  [1938] = {
    [sym_identifier] = ACTIONS(2767),
    [aux_sym_preproc_def_token1] = ACTIONS(2767),
    [aux_sym_preproc_if_token1] = ACTIONS(2767),
    [aux_sym_preproc_if_token2] = ACTIONS(2767),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2767),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2767),
    [sym_preproc_directive] = ACTIONS(2767),
    [anon_sym_LPAREN2] = ACTIONS(2769),
    [anon_sym_TILDE] = ACTIONS(2769),
    [anon_sym_STAR] = ACTIONS(2769),
    [anon_sym_AMP_AMP] = ACTIONS(2769),
    [anon_sym_AMP] = ACTIONS(2767),
    [anon_sym_SEMI] = ACTIONS(2769),
    [anon_sym___extension__] = ACTIONS(2767),
    [anon_sym_typedef] = ACTIONS(2767),
    [anon_sym_virtual] = ACTIONS(2767),
    [anon_sym_extern] = ACTIONS(2767),
    [anon_sym___attribute__] = ACTIONS(2767),
    [anon_sym___attribute] = ACTIONS(2767),
    [anon_sym_COLON_COLON] = ACTIONS(2769),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2769),
    [anon_sym___declspec] = ACTIONS(2767),
    [anon_sym___based] = ACTIONS(2767),
    [anon_sym_signed] = ACTIONS(2767),
    [anon_sym_unsigned] = ACTIONS(2767),
    [anon_sym_long] = ACTIONS(2767),
    [anon_sym_short] = ACTIONS(2767),
    [anon_sym_LBRACK] = ACTIONS(2767),
    [anon_sym_static] = ACTIONS(2767),
    [anon_sym_register] = ACTIONS(2767),
    [anon_sym_inline] = ACTIONS(2767),
    [anon_sym___inline] = ACTIONS(2767),
    [anon_sym___inline__] = ACTIONS(2767),
    [anon_sym___forceinline] = ACTIONS(2767),
    [anon_sym_thread_local] = ACTIONS(2767),
    [anon_sym___thread] = ACTIONS(2767),
    [anon_sym_const] = ACTIONS(2767),
    [anon_sym_constexpr] = ACTIONS(2767),
    [anon_sym_volatile] = ACTIONS(2767),
    [anon_sym_restrict] = ACTIONS(2767),
    [anon_sym___restrict__] = ACTIONS(2767),
    [anon_sym__Atomic] = ACTIONS(2767),
    [anon_sym__Noreturn] = ACTIONS(2767),
    [anon_sym_noreturn] = ACTIONS(2767),
    [anon_sym__Nonnull] = ACTIONS(2767),
    [anon_sym_mutable] = ACTIONS(2767),
    [anon_sym_constinit] = ACTIONS(2767),
    [anon_sym_consteval] = ACTIONS(2767),
    [anon_sym_alignas] = ACTIONS(2767),
    [anon_sym__Alignas] = ACTIONS(2767),
    [sym_primitive_type] = ACTIONS(2767),
    [anon_sym_enum] = ACTIONS(2767),
    [anon_sym_class] = ACTIONS(2767),
    [anon_sym_struct] = ACTIONS(2767),
    [anon_sym_union] = ACTIONS(2767),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2767),
    [anon_sym_decltype] = ACTIONS(2767),
    [anon_sym_explicit] = ACTIONS(2767),
    [anon_sym_typename] = ACTIONS(2767),
    [anon_sym_template] = ACTIONS(2767),
    [anon_sym_operator] = ACTIONS(2767),
    [anon_sym_friend] = ACTIONS(2767),
    [anon_sym_public] = ACTIONS(2767),
    [anon_sym_private] = ACTIONS(2767),
    [anon_sym_protected] = ACTIONS(2767),
    [anon_sym_using] = ACTIONS(2767),
    [anon_sym_static_assert] = ACTIONS(2767),
  },
  [1939] = {
    [sym_identifier] = ACTIONS(2609),
    [aux_sym_preproc_def_token1] = ACTIONS(2609),
    [aux_sym_preproc_if_token1] = ACTIONS(2609),
    [aux_sym_preproc_if_token2] = ACTIONS(2609),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2609),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2609),
    [sym_preproc_directive] = ACTIONS(2609),
    [anon_sym_LPAREN2] = ACTIONS(2611),
    [anon_sym_TILDE] = ACTIONS(2611),
    [anon_sym_STAR] = ACTIONS(2611),
    [anon_sym_AMP_AMP] = ACTIONS(2611),
    [anon_sym_AMP] = ACTIONS(2609),
    [anon_sym_SEMI] = ACTIONS(2611),
    [anon_sym___extension__] = ACTIONS(2609),
    [anon_sym_typedef] = ACTIONS(2609),
    [anon_sym_virtual] = ACTIONS(2609),
    [anon_sym_extern] = ACTIONS(2609),
    [anon_sym___attribute__] = ACTIONS(2609),
    [anon_sym___attribute] = ACTIONS(2609),
    [anon_sym_COLON_COLON] = ACTIONS(2611),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2611),
    [anon_sym___declspec] = ACTIONS(2609),
    [anon_sym___based] = ACTIONS(2609),
    [anon_sym_signed] = ACTIONS(2609),
    [anon_sym_unsigned] = ACTIONS(2609),
    [anon_sym_long] = ACTIONS(2609),
    [anon_sym_short] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(2609),
    [anon_sym_static] = ACTIONS(2609),
    [anon_sym_register] = ACTIONS(2609),
    [anon_sym_inline] = ACTIONS(2609),
    [anon_sym___inline] = ACTIONS(2609),
    [anon_sym___inline__] = ACTIONS(2609),
    [anon_sym___forceinline] = ACTIONS(2609),
    [anon_sym_thread_local] = ACTIONS(2609),
    [anon_sym___thread] = ACTIONS(2609),
    [anon_sym_const] = ACTIONS(2609),
    [anon_sym_constexpr] = ACTIONS(2609),
    [anon_sym_volatile] = ACTIONS(2609),
    [anon_sym_restrict] = ACTIONS(2609),
    [anon_sym___restrict__] = ACTIONS(2609),
    [anon_sym__Atomic] = ACTIONS(2609),
    [anon_sym__Noreturn] = ACTIONS(2609),
    [anon_sym_noreturn] = ACTIONS(2609),
    [anon_sym__Nonnull] = ACTIONS(2609),
    [anon_sym_mutable] = ACTIONS(2609),
    [anon_sym_constinit] = ACTIONS(2609),
    [anon_sym_consteval] = ACTIONS(2609),
    [anon_sym_alignas] = ACTIONS(2609),
    [anon_sym__Alignas] = ACTIONS(2609),
    [sym_primitive_type] = ACTIONS(2609),
    [anon_sym_enum] = ACTIONS(2609),
    [anon_sym_class] = ACTIONS(2609),
    [anon_sym_struct] = ACTIONS(2609),
    [anon_sym_union] = ACTIONS(2609),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2609),
    [anon_sym_decltype] = ACTIONS(2609),
    [anon_sym_explicit] = ACTIONS(2609),
    [anon_sym_typename] = ACTIONS(2609),
    [anon_sym_template] = ACTIONS(2609),
    [anon_sym_operator] = ACTIONS(2609),
    [anon_sym_friend] = ACTIONS(2609),
    [anon_sym_public] = ACTIONS(2609),
    [anon_sym_private] = ACTIONS(2609),
    [anon_sym_protected] = ACTIONS(2609),
    [anon_sym_using] = ACTIONS(2609),
    [anon_sym_static_assert] = ACTIONS(2609),
  },
  [1940] = {
    [sym_identifier] = ACTIONS(2609),
    [aux_sym_preproc_def_token1] = ACTIONS(2609),
    [aux_sym_preproc_if_token1] = ACTIONS(2609),
    [aux_sym_preproc_if_token2] = ACTIONS(2609),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2609),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2609),
    [sym_preproc_directive] = ACTIONS(2609),
    [anon_sym_LPAREN2] = ACTIONS(2611),
    [anon_sym_TILDE] = ACTIONS(2611),
    [anon_sym_STAR] = ACTIONS(2611),
    [anon_sym_AMP_AMP] = ACTIONS(2611),
    [anon_sym_AMP] = ACTIONS(2609),
    [anon_sym_SEMI] = ACTIONS(2611),
    [anon_sym___extension__] = ACTIONS(2609),
    [anon_sym_typedef] = ACTIONS(2609),
    [anon_sym_virtual] = ACTIONS(2609),
    [anon_sym_extern] = ACTIONS(2609),
    [anon_sym___attribute__] = ACTIONS(2609),
    [anon_sym___attribute] = ACTIONS(2609),
    [anon_sym_COLON_COLON] = ACTIONS(2611),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2611),
    [anon_sym___declspec] = ACTIONS(2609),
    [anon_sym___based] = ACTIONS(2609),
    [anon_sym_signed] = ACTIONS(2609),
    [anon_sym_unsigned] = ACTIONS(2609),
    [anon_sym_long] = ACTIONS(2609),
    [anon_sym_short] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(2609),
    [anon_sym_static] = ACTIONS(2609),
    [anon_sym_register] = ACTIONS(2609),
    [anon_sym_inline] = ACTIONS(2609),
    [anon_sym___inline] = ACTIONS(2609),
    [anon_sym___inline__] = ACTIONS(2609),
    [anon_sym___forceinline] = ACTIONS(2609),
    [anon_sym_thread_local] = ACTIONS(2609),
    [anon_sym___thread] = ACTIONS(2609),
    [anon_sym_const] = ACTIONS(2609),
    [anon_sym_constexpr] = ACTIONS(2609),
    [anon_sym_volatile] = ACTIONS(2609),
    [anon_sym_restrict] = ACTIONS(2609),
    [anon_sym___restrict__] = ACTIONS(2609),
    [anon_sym__Atomic] = ACTIONS(2609),
    [anon_sym__Noreturn] = ACTIONS(2609),
    [anon_sym_noreturn] = ACTIONS(2609),
    [anon_sym__Nonnull] = ACTIONS(2609),
    [anon_sym_mutable] = ACTIONS(2609),
    [anon_sym_constinit] = ACTIONS(2609),
    [anon_sym_consteval] = ACTIONS(2609),
    [anon_sym_alignas] = ACTIONS(2609),
    [anon_sym__Alignas] = ACTIONS(2609),
    [sym_primitive_type] = ACTIONS(2609),
    [anon_sym_enum] = ACTIONS(2609),
    [anon_sym_class] = ACTIONS(2609),
    [anon_sym_struct] = ACTIONS(2609),
    [anon_sym_union] = ACTIONS(2609),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2609),
    [anon_sym_decltype] = ACTIONS(2609),
    [anon_sym_explicit] = ACTIONS(2609),
    [anon_sym_typename] = ACTIONS(2609),
    [anon_sym_template] = ACTIONS(2609),
    [anon_sym_operator] = ACTIONS(2609),
    [anon_sym_friend] = ACTIONS(2609),
    [anon_sym_public] = ACTIONS(2609),
    [anon_sym_private] = ACTIONS(2609),
    [anon_sym_protected] = ACTIONS(2609),
    [anon_sym_using] = ACTIONS(2609),
    [anon_sym_static_assert] = ACTIONS(2609),
  },
  [1941] = {
    [sym_identifier] = ACTIONS(3146),
    [aux_sym_preproc_def_token1] = ACTIONS(3146),
    [aux_sym_preproc_if_token1] = ACTIONS(3146),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3146),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3146),
    [sym_preproc_directive] = ACTIONS(3146),
    [anon_sym_LPAREN2] = ACTIONS(3148),
    [anon_sym_TILDE] = ACTIONS(3148),
    [anon_sym_STAR] = ACTIONS(3148),
    [anon_sym_AMP_AMP] = ACTIONS(3148),
    [anon_sym_AMP] = ACTIONS(3146),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym___extension__] = ACTIONS(3146),
    [anon_sym_typedef] = ACTIONS(3146),
    [anon_sym_virtual] = ACTIONS(3146),
    [anon_sym_extern] = ACTIONS(3146),
    [anon_sym___attribute__] = ACTIONS(3146),
    [anon_sym___attribute] = ACTIONS(3146),
    [anon_sym_COLON_COLON] = ACTIONS(3148),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3148),
    [anon_sym___declspec] = ACTIONS(3146),
    [anon_sym___based] = ACTIONS(3146),
    [anon_sym_RBRACE] = ACTIONS(3148),
    [anon_sym_signed] = ACTIONS(3146),
    [anon_sym_unsigned] = ACTIONS(3146),
    [anon_sym_long] = ACTIONS(3146),
    [anon_sym_short] = ACTIONS(3146),
    [anon_sym_LBRACK] = ACTIONS(3146),
    [anon_sym_static] = ACTIONS(3146),
    [anon_sym_register] = ACTIONS(3146),
    [anon_sym_inline] = ACTIONS(3146),
    [anon_sym___inline] = ACTIONS(3146),
    [anon_sym___inline__] = ACTIONS(3146),
    [anon_sym___forceinline] = ACTIONS(3146),
    [anon_sym_thread_local] = ACTIONS(3146),
    [anon_sym___thread] = ACTIONS(3146),
    [anon_sym_const] = ACTIONS(3146),
    [anon_sym_constexpr] = ACTIONS(3146),
    [anon_sym_volatile] = ACTIONS(3146),
    [anon_sym_restrict] = ACTIONS(3146),
    [anon_sym___restrict__] = ACTIONS(3146),
    [anon_sym__Atomic] = ACTIONS(3146),
    [anon_sym__Noreturn] = ACTIONS(3146),
    [anon_sym_noreturn] = ACTIONS(3146),
    [anon_sym__Nonnull] = ACTIONS(3146),
    [anon_sym_mutable] = ACTIONS(3146),
    [anon_sym_constinit] = ACTIONS(3146),
    [anon_sym_consteval] = ACTIONS(3146),
    [anon_sym_alignas] = ACTIONS(3146),
    [anon_sym__Alignas] = ACTIONS(3146),
    [sym_primitive_type] = ACTIONS(3146),
    [anon_sym_enum] = ACTIONS(3146),
    [anon_sym_class] = ACTIONS(3146),
    [anon_sym_struct] = ACTIONS(3146),
    [anon_sym_union] = ACTIONS(3146),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3146),
    [anon_sym_decltype] = ACTIONS(3146),
    [anon_sym_explicit] = ACTIONS(3146),
    [anon_sym_typename] = ACTIONS(3146),
    [anon_sym_template] = ACTIONS(3146),
    [anon_sym_operator] = ACTIONS(3146),
    [anon_sym_friend] = ACTIONS(3146),
    [anon_sym_public] = ACTIONS(3146),
    [anon_sym_private] = ACTIONS(3146),
    [anon_sym_protected] = ACTIONS(3146),
    [anon_sym_using] = ACTIONS(3146),
    [anon_sym_static_assert] = ACTIONS(3146),
  },
  [1942] = {
    [sym_identifier] = ACTIONS(3150),
    [aux_sym_preproc_def_token1] = ACTIONS(3150),
    [aux_sym_preproc_if_token1] = ACTIONS(3150),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3150),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3150),
    [sym_preproc_directive] = ACTIONS(3150),
    [anon_sym_LPAREN2] = ACTIONS(3152),
    [anon_sym_TILDE] = ACTIONS(3152),
    [anon_sym_STAR] = ACTIONS(3152),
    [anon_sym_AMP_AMP] = ACTIONS(3152),
    [anon_sym_AMP] = ACTIONS(3150),
    [anon_sym_SEMI] = ACTIONS(3152),
    [anon_sym___extension__] = ACTIONS(3150),
    [anon_sym_typedef] = ACTIONS(3150),
    [anon_sym_virtual] = ACTIONS(3150),
    [anon_sym_extern] = ACTIONS(3150),
    [anon_sym___attribute__] = ACTIONS(3150),
    [anon_sym___attribute] = ACTIONS(3150),
    [anon_sym_COLON_COLON] = ACTIONS(3152),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3152),
    [anon_sym___declspec] = ACTIONS(3150),
    [anon_sym___based] = ACTIONS(3150),
    [anon_sym_RBRACE] = ACTIONS(3152),
    [anon_sym_signed] = ACTIONS(3150),
    [anon_sym_unsigned] = ACTIONS(3150),
    [anon_sym_long] = ACTIONS(3150),
    [anon_sym_short] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(3150),
    [anon_sym_static] = ACTIONS(3150),
    [anon_sym_register] = ACTIONS(3150),
    [anon_sym_inline] = ACTIONS(3150),
    [anon_sym___inline] = ACTIONS(3150),
    [anon_sym___inline__] = ACTIONS(3150),
    [anon_sym___forceinline] = ACTIONS(3150),
    [anon_sym_thread_local] = ACTIONS(3150),
    [anon_sym___thread] = ACTIONS(3150),
    [anon_sym_const] = ACTIONS(3150),
    [anon_sym_constexpr] = ACTIONS(3150),
    [anon_sym_volatile] = ACTIONS(3150),
    [anon_sym_restrict] = ACTIONS(3150),
    [anon_sym___restrict__] = ACTIONS(3150),
    [anon_sym__Atomic] = ACTIONS(3150),
    [anon_sym__Noreturn] = ACTIONS(3150),
    [anon_sym_noreturn] = ACTIONS(3150),
    [anon_sym__Nonnull] = ACTIONS(3150),
    [anon_sym_mutable] = ACTIONS(3150),
    [anon_sym_constinit] = ACTIONS(3150),
    [anon_sym_consteval] = ACTIONS(3150),
    [anon_sym_alignas] = ACTIONS(3150),
    [anon_sym__Alignas] = ACTIONS(3150),
    [sym_primitive_type] = ACTIONS(3150),
    [anon_sym_enum] = ACTIONS(3150),
    [anon_sym_class] = ACTIONS(3150),
    [anon_sym_struct] = ACTIONS(3150),
    [anon_sym_union] = ACTIONS(3150),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3150),
    [anon_sym_decltype] = ACTIONS(3150),
    [anon_sym_explicit] = ACTIONS(3150),
    [anon_sym_typename] = ACTIONS(3150),
    [anon_sym_template] = ACTIONS(3150),
    [anon_sym_operator] = ACTIONS(3150),
    [anon_sym_friend] = ACTIONS(3150),
    [anon_sym_public] = ACTIONS(3150),
    [anon_sym_private] = ACTIONS(3150),
    [anon_sym_protected] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_static_assert] = ACTIONS(3150),
  },
  [1943] = {
    [sym_identifier] = ACTIONS(2633),
    [aux_sym_preproc_def_token1] = ACTIONS(2633),
    [aux_sym_preproc_if_token1] = ACTIONS(2633),
    [aux_sym_preproc_if_token2] = ACTIONS(2633),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2633),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2633),
    [sym_preproc_directive] = ACTIONS(2633),
    [anon_sym_LPAREN2] = ACTIONS(2635),
    [anon_sym_TILDE] = ACTIONS(2635),
    [anon_sym_STAR] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2635),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_SEMI] = ACTIONS(2635),
    [anon_sym___extension__] = ACTIONS(2633),
    [anon_sym_typedef] = ACTIONS(2633),
    [anon_sym_virtual] = ACTIONS(2633),
    [anon_sym_extern] = ACTIONS(2633),
    [anon_sym___attribute__] = ACTIONS(2633),
    [anon_sym___attribute] = ACTIONS(2633),
    [anon_sym_COLON_COLON] = ACTIONS(2635),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2635),
    [anon_sym___declspec] = ACTIONS(2633),
    [anon_sym___based] = ACTIONS(2633),
    [anon_sym_signed] = ACTIONS(2633),
    [anon_sym_unsigned] = ACTIONS(2633),
    [anon_sym_long] = ACTIONS(2633),
    [anon_sym_short] = ACTIONS(2633),
    [anon_sym_LBRACK] = ACTIONS(2633),
    [anon_sym_static] = ACTIONS(2633),
    [anon_sym_register] = ACTIONS(2633),
    [anon_sym_inline] = ACTIONS(2633),
    [anon_sym___inline] = ACTIONS(2633),
    [anon_sym___inline__] = ACTIONS(2633),
    [anon_sym___forceinline] = ACTIONS(2633),
    [anon_sym_thread_local] = ACTIONS(2633),
    [anon_sym___thread] = ACTIONS(2633),
    [anon_sym_const] = ACTIONS(2633),
    [anon_sym_constexpr] = ACTIONS(2633),
    [anon_sym_volatile] = ACTIONS(2633),
    [anon_sym_restrict] = ACTIONS(2633),
    [anon_sym___restrict__] = ACTIONS(2633),
    [anon_sym__Atomic] = ACTIONS(2633),
    [anon_sym__Noreturn] = ACTIONS(2633),
    [anon_sym_noreturn] = ACTIONS(2633),
    [anon_sym__Nonnull] = ACTIONS(2633),
    [anon_sym_mutable] = ACTIONS(2633),
    [anon_sym_constinit] = ACTIONS(2633),
    [anon_sym_consteval] = ACTIONS(2633),
    [anon_sym_alignas] = ACTIONS(2633),
    [anon_sym__Alignas] = ACTIONS(2633),
    [sym_primitive_type] = ACTIONS(2633),
    [anon_sym_enum] = ACTIONS(2633),
    [anon_sym_class] = ACTIONS(2633),
    [anon_sym_struct] = ACTIONS(2633),
    [anon_sym_union] = ACTIONS(2633),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2633),
    [anon_sym_decltype] = ACTIONS(2633),
    [anon_sym_explicit] = ACTIONS(2633),
    [anon_sym_typename] = ACTIONS(2633),
    [anon_sym_template] = ACTIONS(2633),
    [anon_sym_operator] = ACTIONS(2633),
    [anon_sym_friend] = ACTIONS(2633),
    [anon_sym_public] = ACTIONS(2633),
    [anon_sym_private] = ACTIONS(2633),
    [anon_sym_protected] = ACTIONS(2633),
    [anon_sym_using] = ACTIONS(2633),
    [anon_sym_static_assert] = ACTIONS(2633),
  },
  [1944] = {
    [sym_identifier] = ACTIONS(2637),
    [aux_sym_preproc_def_token1] = ACTIONS(2637),
    [aux_sym_preproc_if_token1] = ACTIONS(2637),
    [aux_sym_preproc_if_token2] = ACTIONS(2637),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2637),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2637),
    [sym_preproc_directive] = ACTIONS(2637),
    [anon_sym_LPAREN2] = ACTIONS(2639),
    [anon_sym_TILDE] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(2639),
    [anon_sym_AMP_AMP] = ACTIONS(2639),
    [anon_sym_AMP] = ACTIONS(2637),
    [anon_sym_SEMI] = ACTIONS(2639),
    [anon_sym___extension__] = ACTIONS(2637),
    [anon_sym_typedef] = ACTIONS(2637),
    [anon_sym_virtual] = ACTIONS(2637),
    [anon_sym_extern] = ACTIONS(2637),
    [anon_sym___attribute__] = ACTIONS(2637),
    [anon_sym___attribute] = ACTIONS(2637),
    [anon_sym_COLON_COLON] = ACTIONS(2639),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2639),
    [anon_sym___declspec] = ACTIONS(2637),
    [anon_sym___based] = ACTIONS(2637),
    [anon_sym_signed] = ACTIONS(2637),
    [anon_sym_unsigned] = ACTIONS(2637),
    [anon_sym_long] = ACTIONS(2637),
    [anon_sym_short] = ACTIONS(2637),
    [anon_sym_LBRACK] = ACTIONS(2637),
    [anon_sym_static] = ACTIONS(2637),
    [anon_sym_register] = ACTIONS(2637),
    [anon_sym_inline] = ACTIONS(2637),
    [anon_sym___inline] = ACTIONS(2637),
    [anon_sym___inline__] = ACTIONS(2637),
    [anon_sym___forceinline] = ACTIONS(2637),
    [anon_sym_thread_local] = ACTIONS(2637),
    [anon_sym___thread] = ACTIONS(2637),
    [anon_sym_const] = ACTIONS(2637),
    [anon_sym_constexpr] = ACTIONS(2637),
    [anon_sym_volatile] = ACTIONS(2637),
    [anon_sym_restrict] = ACTIONS(2637),
    [anon_sym___restrict__] = ACTIONS(2637),
    [anon_sym__Atomic] = ACTIONS(2637),
    [anon_sym__Noreturn] = ACTIONS(2637),
    [anon_sym_noreturn] = ACTIONS(2637),
    [anon_sym__Nonnull] = ACTIONS(2637),
    [anon_sym_mutable] = ACTIONS(2637),
    [anon_sym_constinit] = ACTIONS(2637),
    [anon_sym_consteval] = ACTIONS(2637),
    [anon_sym_alignas] = ACTIONS(2637),
    [anon_sym__Alignas] = ACTIONS(2637),
    [sym_primitive_type] = ACTIONS(2637),
    [anon_sym_enum] = ACTIONS(2637),
    [anon_sym_class] = ACTIONS(2637),
    [anon_sym_struct] = ACTIONS(2637),
    [anon_sym_union] = ACTIONS(2637),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2637),
    [anon_sym_decltype] = ACTIONS(2637),
    [anon_sym_explicit] = ACTIONS(2637),
    [anon_sym_typename] = ACTIONS(2637),
    [anon_sym_template] = ACTIONS(2637),
    [anon_sym_operator] = ACTIONS(2637),
    [anon_sym_friend] = ACTIONS(2637),
    [anon_sym_public] = ACTIONS(2637),
    [anon_sym_private] = ACTIONS(2637),
    [anon_sym_protected] = ACTIONS(2637),
    [anon_sym_using] = ACTIONS(2637),
    [anon_sym_static_assert] = ACTIONS(2637),
  },
  [1945] = {
    [sym_identifier] = ACTIONS(2637),
    [aux_sym_preproc_def_token1] = ACTIONS(2637),
    [aux_sym_preproc_if_token1] = ACTIONS(2637),
    [aux_sym_preproc_if_token2] = ACTIONS(2637),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2637),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2637),
    [sym_preproc_directive] = ACTIONS(2637),
    [anon_sym_LPAREN2] = ACTIONS(2639),
    [anon_sym_TILDE] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(2639),
    [anon_sym_AMP_AMP] = ACTIONS(2639),
    [anon_sym_AMP] = ACTIONS(2637),
    [anon_sym_SEMI] = ACTIONS(2639),
    [anon_sym___extension__] = ACTIONS(2637),
    [anon_sym_typedef] = ACTIONS(2637),
    [anon_sym_virtual] = ACTIONS(2637),
    [anon_sym_extern] = ACTIONS(2637),
    [anon_sym___attribute__] = ACTIONS(2637),
    [anon_sym___attribute] = ACTIONS(2637),
    [anon_sym_COLON_COLON] = ACTIONS(2639),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2639),
    [anon_sym___declspec] = ACTIONS(2637),
    [anon_sym___based] = ACTIONS(2637),
    [anon_sym_signed] = ACTIONS(2637),
    [anon_sym_unsigned] = ACTIONS(2637),
    [anon_sym_long] = ACTIONS(2637),
    [anon_sym_short] = ACTIONS(2637),
    [anon_sym_LBRACK] = ACTIONS(2637),
    [anon_sym_static] = ACTIONS(2637),
    [anon_sym_register] = ACTIONS(2637),
    [anon_sym_inline] = ACTIONS(2637),
    [anon_sym___inline] = ACTIONS(2637),
    [anon_sym___inline__] = ACTIONS(2637),
    [anon_sym___forceinline] = ACTIONS(2637),
    [anon_sym_thread_local] = ACTIONS(2637),
    [anon_sym___thread] = ACTIONS(2637),
    [anon_sym_const] = ACTIONS(2637),
    [anon_sym_constexpr] = ACTIONS(2637),
    [anon_sym_volatile] = ACTIONS(2637),
    [anon_sym_restrict] = ACTIONS(2637),
    [anon_sym___restrict__] = ACTIONS(2637),
    [anon_sym__Atomic] = ACTIONS(2637),
    [anon_sym__Noreturn] = ACTIONS(2637),
    [anon_sym_noreturn] = ACTIONS(2637),
    [anon_sym__Nonnull] = ACTIONS(2637),
    [anon_sym_mutable] = ACTIONS(2637),
    [anon_sym_constinit] = ACTIONS(2637),
    [anon_sym_consteval] = ACTIONS(2637),
    [anon_sym_alignas] = ACTIONS(2637),
    [anon_sym__Alignas] = ACTIONS(2637),
    [sym_primitive_type] = ACTIONS(2637),
    [anon_sym_enum] = ACTIONS(2637),
    [anon_sym_class] = ACTIONS(2637),
    [anon_sym_struct] = ACTIONS(2637),
    [anon_sym_union] = ACTIONS(2637),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2637),
    [anon_sym_decltype] = ACTIONS(2637),
    [anon_sym_explicit] = ACTIONS(2637),
    [anon_sym_typename] = ACTIONS(2637),
    [anon_sym_template] = ACTIONS(2637),
    [anon_sym_operator] = ACTIONS(2637),
    [anon_sym_friend] = ACTIONS(2637),
    [anon_sym_public] = ACTIONS(2637),
    [anon_sym_private] = ACTIONS(2637),
    [anon_sym_protected] = ACTIONS(2637),
    [anon_sym_using] = ACTIONS(2637),
    [anon_sym_static_assert] = ACTIONS(2637),
  },
  [1946] = {
    [sym_identifier] = ACTIONS(5361),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5363),
    [anon_sym_COMMA] = ACTIONS(5363),
    [anon_sym_RPAREN] = ACTIONS(5363),
    [aux_sym_preproc_if_token2] = ACTIONS(5363),
    [aux_sym_preproc_else_token1] = ACTIONS(5363),
    [aux_sym_preproc_elif_token1] = ACTIONS(5361),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5363),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5363),
    [anon_sym_LPAREN2] = ACTIONS(5363),
    [anon_sym_DASH] = ACTIONS(5361),
    [anon_sym_PLUS] = ACTIONS(5361),
    [anon_sym_STAR] = ACTIONS(5361),
    [anon_sym_SLASH] = ACTIONS(5361),
    [anon_sym_PERCENT] = ACTIONS(5361),
    [anon_sym_PIPE_PIPE] = ACTIONS(5363),
    [anon_sym_AMP_AMP] = ACTIONS(5363),
    [anon_sym_PIPE] = ACTIONS(5361),
    [anon_sym_CARET] = ACTIONS(5361),
    [anon_sym_AMP] = ACTIONS(5361),
    [anon_sym_EQ_EQ] = ACTIONS(5363),
    [anon_sym_BANG_EQ] = ACTIONS(5363),
    [anon_sym_GT] = ACTIONS(5361),
    [anon_sym_GT_EQ] = ACTIONS(5363),
    [anon_sym_LT_EQ] = ACTIONS(5361),
    [anon_sym_LT] = ACTIONS(5361),
    [anon_sym_LT_LT] = ACTIONS(5361),
    [anon_sym_GT_GT] = ACTIONS(5361),
    [anon_sym_SEMI] = ACTIONS(5363),
    [anon_sym___attribute__] = ACTIONS(5361),
    [anon_sym___attribute] = ACTIONS(5361),
    [anon_sym_LBRACE] = ACTIONS(5363),
    [anon_sym_RBRACE] = ACTIONS(5363),
    [anon_sym_LBRACK] = ACTIONS(5363),
    [anon_sym_RBRACK] = ACTIONS(5363),
    [anon_sym_EQ] = ACTIONS(5361),
    [anon_sym_COLON] = ACTIONS(5363),
    [anon_sym_QMARK] = ACTIONS(5363),
    [anon_sym_STAR_EQ] = ACTIONS(5363),
    [anon_sym_SLASH_EQ] = ACTIONS(5363),
    [anon_sym_PERCENT_EQ] = ACTIONS(5363),
    [anon_sym_PLUS_EQ] = ACTIONS(5363),
    [anon_sym_DASH_EQ] = ACTIONS(5363),
    [anon_sym_LT_LT_EQ] = ACTIONS(5363),
    [anon_sym_GT_GT_EQ] = ACTIONS(5363),
    [anon_sym_AMP_EQ] = ACTIONS(5363),
    [anon_sym_CARET_EQ] = ACTIONS(5363),
    [anon_sym_PIPE_EQ] = ACTIONS(5363),
    [anon_sym_and_eq] = ACTIONS(5361),
    [anon_sym_or_eq] = ACTIONS(5361),
    [anon_sym_xor_eq] = ACTIONS(5361),
    [anon_sym_LT_EQ_GT] = ACTIONS(5363),
    [anon_sym_or] = ACTIONS(5361),
    [anon_sym_and] = ACTIONS(5361),
    [anon_sym_bitor] = ACTIONS(5361),
    [anon_sym_xor] = ACTIONS(5361),
    [anon_sym_bitand] = ACTIONS(5361),
    [anon_sym_not_eq] = ACTIONS(5361),
    [anon_sym_DASH_DASH] = ACTIONS(5363),
    [anon_sym_PLUS_PLUS] = ACTIONS(5363),
    [anon_sym_DOT] = ACTIONS(5361),
    [anon_sym_DOT_STAR] = ACTIONS(5363),
    [anon_sym_DASH_GT] = ACTIONS(5363),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5361),
    [anon_sym_decltype] = ACTIONS(5361),
    [anon_sym_final] = ACTIONS(5361),
    [anon_sym_override] = ACTIONS(5361),
  },
  [1947] = {
    [sym_string_literal] = STATE(1656),
    [sym_template_argument_list] = STATE(2300),
    [sym_raw_string_literal] = STATE(1656),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4035),
    [anon_sym_COMMA] = ACTIONS(4035),
    [anon_sym_LPAREN2] = ACTIONS(5813),
    [anon_sym_DASH] = ACTIONS(4043),
    [anon_sym_PLUS] = ACTIONS(4043),
    [anon_sym_STAR] = ACTIONS(4043),
    [anon_sym_SLASH] = ACTIONS(4043),
    [anon_sym_PERCENT] = ACTIONS(4043),
    [anon_sym_PIPE_PIPE] = ACTIONS(4035),
    [anon_sym_AMP_AMP] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4043),
    [anon_sym_CARET] = ACTIONS(4043),
    [anon_sym_AMP] = ACTIONS(4043),
    [anon_sym_EQ_EQ] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4043),
    [anon_sym_GT_EQ] = ACTIONS(4035),
    [anon_sym_LT_EQ] = ACTIONS(4043),
    [anon_sym_LT] = ACTIONS(5237),
    [anon_sym_LT_LT] = ACTIONS(4043),
    [anon_sym_GT_GT] = ACTIONS(4043),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5813),
    [anon_sym_LBRACE] = ACTIONS(4059),
    [anon_sym_RBRACE] = ACTIONS(4035),
    [anon_sym_LBRACK] = ACTIONS(5815),
    [anon_sym_EQ] = ACTIONS(4043),
    [anon_sym_QMARK] = ACTIONS(4035),
    [anon_sym_STAR_EQ] = ACTIONS(4035),
    [anon_sym_SLASH_EQ] = ACTIONS(4035),
    [anon_sym_PERCENT_EQ] = ACTIONS(4035),
    [anon_sym_PLUS_EQ] = ACTIONS(4035),
    [anon_sym_DASH_EQ] = ACTIONS(4035),
    [anon_sym_LT_LT_EQ] = ACTIONS(4035),
    [anon_sym_GT_GT_EQ] = ACTIONS(4035),
    [anon_sym_AMP_EQ] = ACTIONS(4035),
    [anon_sym_CARET_EQ] = ACTIONS(4035),
    [anon_sym_PIPE_EQ] = ACTIONS(4035),
    [anon_sym_and_eq] = ACTIONS(4035),
    [anon_sym_or_eq] = ACTIONS(4035),
    [anon_sym_xor_eq] = ACTIONS(4035),
    [anon_sym_LT_EQ_GT] = ACTIONS(4035),
    [anon_sym_or] = ACTIONS(4043),
    [anon_sym_and] = ACTIONS(4043),
    [anon_sym_bitor] = ACTIONS(4035),
    [anon_sym_xor] = ACTIONS(4043),
    [anon_sym_bitand] = ACTIONS(4035),
    [anon_sym_not_eq] = ACTIONS(4035),
    [anon_sym_DASH_DASH] = ACTIONS(4035),
    [anon_sym_PLUS_PLUS] = ACTIONS(4035),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_DOT_STAR] = ACTIONS(4035),
    [anon_sym_DASH_GT] = ACTIONS(4035),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(1955),
    [anon_sym_LR_DQUOTE] = ACTIONS(1955),
    [anon_sym_uR_DQUOTE] = ACTIONS(1955),
    [anon_sym_UR_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1955),
  },
  [1948] = {
    [sym_identifier] = ACTIONS(2681),
    [aux_sym_preproc_def_token1] = ACTIONS(2681),
    [aux_sym_preproc_if_token1] = ACTIONS(2681),
    [aux_sym_preproc_if_token2] = ACTIONS(2681),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2681),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2681),
    [sym_preproc_directive] = ACTIONS(2681),
    [anon_sym_LPAREN2] = ACTIONS(2683),
    [anon_sym_TILDE] = ACTIONS(2683),
    [anon_sym_STAR] = ACTIONS(2683),
    [anon_sym_AMP_AMP] = ACTIONS(2683),
    [anon_sym_AMP] = ACTIONS(2681),
    [anon_sym_SEMI] = ACTIONS(2683),
    [anon_sym___extension__] = ACTIONS(2681),
    [anon_sym_typedef] = ACTIONS(2681),
    [anon_sym_virtual] = ACTIONS(2681),
    [anon_sym_extern] = ACTIONS(2681),
    [anon_sym___attribute__] = ACTIONS(2681),
    [anon_sym___attribute] = ACTIONS(2681),
    [anon_sym_COLON_COLON] = ACTIONS(2683),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2683),
    [anon_sym___declspec] = ACTIONS(2681),
    [anon_sym___based] = ACTIONS(2681),
    [anon_sym_signed] = ACTIONS(2681),
    [anon_sym_unsigned] = ACTIONS(2681),
    [anon_sym_long] = ACTIONS(2681),
    [anon_sym_short] = ACTIONS(2681),
    [anon_sym_LBRACK] = ACTIONS(2681),
    [anon_sym_static] = ACTIONS(2681),
    [anon_sym_register] = ACTIONS(2681),
    [anon_sym_inline] = ACTIONS(2681),
    [anon_sym___inline] = ACTIONS(2681),
    [anon_sym___inline__] = ACTIONS(2681),
    [anon_sym___forceinline] = ACTIONS(2681),
    [anon_sym_thread_local] = ACTIONS(2681),
    [anon_sym___thread] = ACTIONS(2681),
    [anon_sym_const] = ACTIONS(2681),
    [anon_sym_constexpr] = ACTIONS(2681),
    [anon_sym_volatile] = ACTIONS(2681),
    [anon_sym_restrict] = ACTIONS(2681),
    [anon_sym___restrict__] = ACTIONS(2681),
    [anon_sym__Atomic] = ACTIONS(2681),
    [anon_sym__Noreturn] = ACTIONS(2681),
    [anon_sym_noreturn] = ACTIONS(2681),
    [anon_sym__Nonnull] = ACTIONS(2681),
    [anon_sym_mutable] = ACTIONS(2681),
    [anon_sym_constinit] = ACTIONS(2681),
    [anon_sym_consteval] = ACTIONS(2681),
    [anon_sym_alignas] = ACTIONS(2681),
    [anon_sym__Alignas] = ACTIONS(2681),
    [sym_primitive_type] = ACTIONS(2681),
    [anon_sym_enum] = ACTIONS(2681),
    [anon_sym_class] = ACTIONS(2681),
    [anon_sym_struct] = ACTIONS(2681),
    [anon_sym_union] = ACTIONS(2681),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2681),
    [anon_sym_decltype] = ACTIONS(2681),
    [anon_sym_explicit] = ACTIONS(2681),
    [anon_sym_typename] = ACTIONS(2681),
    [anon_sym_template] = ACTIONS(2681),
    [anon_sym_operator] = ACTIONS(2681),
    [anon_sym_friend] = ACTIONS(2681),
    [anon_sym_public] = ACTIONS(2681),
    [anon_sym_private] = ACTIONS(2681),
    [anon_sym_protected] = ACTIONS(2681),
    [anon_sym_using] = ACTIONS(2681),
    [anon_sym_static_assert] = ACTIONS(2681),
  },
  [1949] = {
    [sym_string_literal] = STATE(1656),
    [sym_raw_string_literal] = STATE(1656),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5799),
    [anon_sym_COMMA] = ACTIONS(5799),
    [anon_sym_RPAREN] = ACTIONS(5799),
    [anon_sym_LPAREN2] = ACTIONS(5799),
    [anon_sym_DASH] = ACTIONS(5797),
    [anon_sym_PLUS] = ACTIONS(5797),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_SLASH] = ACTIONS(5797),
    [anon_sym_PERCENT] = ACTIONS(5797),
    [anon_sym_PIPE_PIPE] = ACTIONS(5799),
    [anon_sym_AMP_AMP] = ACTIONS(5799),
    [anon_sym_PIPE] = ACTIONS(5797),
    [anon_sym_CARET] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5797),
    [anon_sym_EQ_EQ] = ACTIONS(5799),
    [anon_sym_BANG_EQ] = ACTIONS(5799),
    [anon_sym_GT] = ACTIONS(5797),
    [anon_sym_GT_EQ] = ACTIONS(5799),
    [anon_sym_LT_EQ] = ACTIONS(5797),
    [anon_sym_LT] = ACTIONS(5797),
    [anon_sym_LT_LT] = ACTIONS(5797),
    [anon_sym_GT_GT] = ACTIONS(5797),
    [anon_sym_SEMI] = ACTIONS(5799),
    [anon_sym_RBRACE] = ACTIONS(5799),
    [anon_sym_LBRACK] = ACTIONS(5799),
    [anon_sym_RBRACK] = ACTIONS(5799),
    [anon_sym_EQ] = ACTIONS(5797),
    [anon_sym_COLON] = ACTIONS(5799),
    [anon_sym_QMARK] = ACTIONS(5799),
    [anon_sym_STAR_EQ] = ACTIONS(5799),
    [anon_sym_SLASH_EQ] = ACTIONS(5799),
    [anon_sym_PERCENT_EQ] = ACTIONS(5799),
    [anon_sym_PLUS_EQ] = ACTIONS(5799),
    [anon_sym_DASH_EQ] = ACTIONS(5799),
    [anon_sym_LT_LT_EQ] = ACTIONS(5799),
    [anon_sym_GT_GT_EQ] = ACTIONS(5799),
    [anon_sym_AMP_EQ] = ACTIONS(5799),
    [anon_sym_CARET_EQ] = ACTIONS(5799),
    [anon_sym_PIPE_EQ] = ACTIONS(5799),
    [anon_sym_and_eq] = ACTIONS(5797),
    [anon_sym_or_eq] = ACTIONS(5797),
    [anon_sym_xor_eq] = ACTIONS(5797),
    [anon_sym_LT_EQ_GT] = ACTIONS(5799),
    [anon_sym_or] = ACTIONS(5797),
    [anon_sym_and] = ACTIONS(5797),
    [anon_sym_bitor] = ACTIONS(5797),
    [anon_sym_xor] = ACTIONS(5797),
    [anon_sym_bitand] = ACTIONS(5797),
    [anon_sym_not_eq] = ACTIONS(5797),
    [anon_sym_DASH_DASH] = ACTIONS(5799),
    [anon_sym_PLUS_PLUS] = ACTIONS(5799),
    [anon_sym_DOT] = ACTIONS(5797),
    [anon_sym_DOT_STAR] = ACTIONS(5799),
    [anon_sym_DASH_GT] = ACTIONS(5799),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(1955),
    [anon_sym_LR_DQUOTE] = ACTIONS(1955),
    [anon_sym_uR_DQUOTE] = ACTIONS(1955),
    [anon_sym_UR_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1955),
    [sym_literal_suffix] = ACTIONS(5797),
  },
  [1950] = {
    [sym_identifier] = ACTIONS(2771),
    [aux_sym_preproc_def_token1] = ACTIONS(2771),
    [aux_sym_preproc_if_token1] = ACTIONS(2771),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2771),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2771),
    [sym_preproc_directive] = ACTIONS(2771),
    [anon_sym_LPAREN2] = ACTIONS(2773),
    [anon_sym_TILDE] = ACTIONS(2773),
    [anon_sym_STAR] = ACTIONS(2773),
    [anon_sym_AMP_AMP] = ACTIONS(2773),
    [anon_sym_AMP] = ACTIONS(2771),
    [anon_sym_SEMI] = ACTIONS(2773),
    [anon_sym___extension__] = ACTIONS(2771),
    [anon_sym_typedef] = ACTIONS(2771),
    [anon_sym_virtual] = ACTIONS(2771),
    [anon_sym_extern] = ACTIONS(2771),
    [anon_sym___attribute__] = ACTIONS(2771),
    [anon_sym___attribute] = ACTIONS(2771),
    [anon_sym_COLON_COLON] = ACTIONS(2773),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2773),
    [anon_sym___declspec] = ACTIONS(2771),
    [anon_sym___based] = ACTIONS(2771),
    [anon_sym_RBRACE] = ACTIONS(2773),
    [anon_sym_signed] = ACTIONS(2771),
    [anon_sym_unsigned] = ACTIONS(2771),
    [anon_sym_long] = ACTIONS(2771),
    [anon_sym_short] = ACTIONS(2771),
    [anon_sym_LBRACK] = ACTIONS(2771),
    [anon_sym_static] = ACTIONS(2771),
    [anon_sym_register] = ACTIONS(2771),
    [anon_sym_inline] = ACTIONS(2771),
    [anon_sym___inline] = ACTIONS(2771),
    [anon_sym___inline__] = ACTIONS(2771),
    [anon_sym___forceinline] = ACTIONS(2771),
    [anon_sym_thread_local] = ACTIONS(2771),
    [anon_sym___thread] = ACTIONS(2771),
    [anon_sym_const] = ACTIONS(2771),
    [anon_sym_constexpr] = ACTIONS(2771),
    [anon_sym_volatile] = ACTIONS(2771),
    [anon_sym_restrict] = ACTIONS(2771),
    [anon_sym___restrict__] = ACTIONS(2771),
    [anon_sym__Atomic] = ACTIONS(2771),
    [anon_sym__Noreturn] = ACTIONS(2771),
    [anon_sym_noreturn] = ACTIONS(2771),
    [anon_sym__Nonnull] = ACTIONS(2771),
    [anon_sym_mutable] = ACTIONS(2771),
    [anon_sym_constinit] = ACTIONS(2771),
    [anon_sym_consteval] = ACTIONS(2771),
    [anon_sym_alignas] = ACTIONS(2771),
    [anon_sym__Alignas] = ACTIONS(2771),
    [sym_primitive_type] = ACTIONS(2771),
    [anon_sym_enum] = ACTIONS(2771),
    [anon_sym_class] = ACTIONS(2771),
    [anon_sym_struct] = ACTIONS(2771),
    [anon_sym_union] = ACTIONS(2771),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2771),
    [anon_sym_decltype] = ACTIONS(2771),
    [anon_sym_explicit] = ACTIONS(2771),
    [anon_sym_typename] = ACTIONS(2771),
    [anon_sym_template] = ACTIONS(2771),
    [anon_sym_operator] = ACTIONS(2771),
    [anon_sym_friend] = ACTIONS(2771),
    [anon_sym_public] = ACTIONS(2771),
    [anon_sym_private] = ACTIONS(2771),
    [anon_sym_protected] = ACTIONS(2771),
    [anon_sym_using] = ACTIONS(2771),
    [anon_sym_static_assert] = ACTIONS(2771),
  },
  [1951] = {
    [sym_identifier] = ACTIONS(2960),
    [aux_sym_preproc_def_token1] = ACTIONS(2960),
    [aux_sym_preproc_if_token1] = ACTIONS(2960),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2960),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2960),
    [sym_preproc_directive] = ACTIONS(2960),
    [anon_sym_LPAREN2] = ACTIONS(2962),
    [anon_sym_TILDE] = ACTIONS(2962),
    [anon_sym_STAR] = ACTIONS(2962),
    [anon_sym_AMP_AMP] = ACTIONS(2962),
    [anon_sym_AMP] = ACTIONS(2960),
    [anon_sym_SEMI] = ACTIONS(2962),
    [anon_sym___extension__] = ACTIONS(2960),
    [anon_sym_typedef] = ACTIONS(2960),
    [anon_sym_virtual] = ACTIONS(2960),
    [anon_sym_extern] = ACTIONS(2960),
    [anon_sym___attribute__] = ACTIONS(2960),
    [anon_sym___attribute] = ACTIONS(2960),
    [anon_sym_COLON_COLON] = ACTIONS(2962),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2962),
    [anon_sym___declspec] = ACTIONS(2960),
    [anon_sym___based] = ACTIONS(2960),
    [anon_sym_RBRACE] = ACTIONS(2962),
    [anon_sym_signed] = ACTIONS(2960),
    [anon_sym_unsigned] = ACTIONS(2960),
    [anon_sym_long] = ACTIONS(2960),
    [anon_sym_short] = ACTIONS(2960),
    [anon_sym_LBRACK] = ACTIONS(2960),
    [anon_sym_static] = ACTIONS(2960),
    [anon_sym_register] = ACTIONS(2960),
    [anon_sym_inline] = ACTIONS(2960),
    [anon_sym___inline] = ACTIONS(2960),
    [anon_sym___inline__] = ACTIONS(2960),
    [anon_sym___forceinline] = ACTIONS(2960),
    [anon_sym_thread_local] = ACTIONS(2960),
    [anon_sym___thread] = ACTIONS(2960),
    [anon_sym_const] = ACTIONS(2960),
    [anon_sym_constexpr] = ACTIONS(2960),
    [anon_sym_volatile] = ACTIONS(2960),
    [anon_sym_restrict] = ACTIONS(2960),
    [anon_sym___restrict__] = ACTIONS(2960),
    [anon_sym__Atomic] = ACTIONS(2960),
    [anon_sym__Noreturn] = ACTIONS(2960),
    [anon_sym_noreturn] = ACTIONS(2960),
    [anon_sym__Nonnull] = ACTIONS(2960),
    [anon_sym_mutable] = ACTIONS(2960),
    [anon_sym_constinit] = ACTIONS(2960),
    [anon_sym_consteval] = ACTIONS(2960),
    [anon_sym_alignas] = ACTIONS(2960),
    [anon_sym__Alignas] = ACTIONS(2960),
    [sym_primitive_type] = ACTIONS(2960),
    [anon_sym_enum] = ACTIONS(2960),
    [anon_sym_class] = ACTIONS(2960),
    [anon_sym_struct] = ACTIONS(2960),
    [anon_sym_union] = ACTIONS(2960),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2960),
    [anon_sym_decltype] = ACTIONS(2960),
    [anon_sym_explicit] = ACTIONS(2960),
    [anon_sym_typename] = ACTIONS(2960),
    [anon_sym_template] = ACTIONS(2960),
    [anon_sym_operator] = ACTIONS(2960),
    [anon_sym_friend] = ACTIONS(2960),
    [anon_sym_public] = ACTIONS(2960),
    [anon_sym_private] = ACTIONS(2960),
    [anon_sym_protected] = ACTIONS(2960),
    [anon_sym_using] = ACTIONS(2960),
    [anon_sym_static_assert] = ACTIONS(2960),
  },
  [1952] = {
    [sym_string_literal] = STATE(1953),
    [sym_raw_string_literal] = STATE(1953),
    [aux_sym_concatenated_string_repeat1] = STATE(1953),
    [sym_identifier] = ACTIONS(5817),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5274),
    [anon_sym_COMMA] = ACTIONS(5274),
    [anon_sym_LPAREN2] = ACTIONS(5274),
    [anon_sym_DASH] = ACTIONS(5276),
    [anon_sym_PLUS] = ACTIONS(5276),
    [anon_sym_STAR] = ACTIONS(5276),
    [anon_sym_SLASH] = ACTIONS(5276),
    [anon_sym_PERCENT] = ACTIONS(5276),
    [anon_sym_PIPE_PIPE] = ACTIONS(5274),
    [anon_sym_AMP_AMP] = ACTIONS(5274),
    [anon_sym_PIPE] = ACTIONS(5276),
    [anon_sym_CARET] = ACTIONS(5276),
    [anon_sym_AMP] = ACTIONS(5276),
    [anon_sym_EQ_EQ] = ACTIONS(5274),
    [anon_sym_BANG_EQ] = ACTIONS(5274),
    [anon_sym_GT] = ACTIONS(5276),
    [anon_sym_GT_EQ] = ACTIONS(5274),
    [anon_sym_LT_EQ] = ACTIONS(5276),
    [anon_sym_LT] = ACTIONS(5276),
    [anon_sym_LT_LT] = ACTIONS(5276),
    [anon_sym_GT_GT] = ACTIONS(5276),
    [anon_sym_SEMI] = ACTIONS(5274),
    [anon_sym___attribute__] = ACTIONS(5276),
    [anon_sym___attribute] = ACTIONS(5276),
    [anon_sym_LBRACK] = ACTIONS(5274),
    [anon_sym_EQ] = ACTIONS(5276),
    [anon_sym_QMARK] = ACTIONS(5274),
    [anon_sym_STAR_EQ] = ACTIONS(5274),
    [anon_sym_SLASH_EQ] = ACTIONS(5274),
    [anon_sym_PERCENT_EQ] = ACTIONS(5274),
    [anon_sym_PLUS_EQ] = ACTIONS(5274),
    [anon_sym_DASH_EQ] = ACTIONS(5274),
    [anon_sym_LT_LT_EQ] = ACTIONS(5274),
    [anon_sym_GT_GT_EQ] = ACTIONS(5274),
    [anon_sym_AMP_EQ] = ACTIONS(5274),
    [anon_sym_CARET_EQ] = ACTIONS(5274),
    [anon_sym_PIPE_EQ] = ACTIONS(5274),
    [anon_sym_and_eq] = ACTIONS(5276),
    [anon_sym_or_eq] = ACTIONS(5276),
    [anon_sym_xor_eq] = ACTIONS(5276),
    [anon_sym_LT_EQ_GT] = ACTIONS(5274),
    [anon_sym_or] = ACTIONS(5276),
    [anon_sym_and] = ACTIONS(5276),
    [anon_sym_bitor] = ACTIONS(5276),
    [anon_sym_xor] = ACTIONS(5276),
    [anon_sym_bitand] = ACTIONS(5276),
    [anon_sym_not_eq] = ACTIONS(5276),
    [anon_sym_DASH_DASH] = ACTIONS(5274),
    [anon_sym_PLUS_PLUS] = ACTIONS(5274),
    [anon_sym_DOT] = ACTIONS(5276),
    [anon_sym_DOT_STAR] = ACTIONS(5274),
    [anon_sym_DASH_GT] = ACTIONS(5274),
    [anon_sym_L_DQUOTE] = ACTIONS(5819),
    [anon_sym_u_DQUOTE] = ACTIONS(5819),
    [anon_sym_U_DQUOTE] = ACTIONS(5819),
    [anon_sym_u8_DQUOTE] = ACTIONS(5819),
    [anon_sym_DQUOTE] = ACTIONS(5819),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5821),
    [anon_sym_LR_DQUOTE] = ACTIONS(5821),
    [anon_sym_uR_DQUOTE] = ACTIONS(5821),
    [anon_sym_UR_DQUOTE] = ACTIONS(5821),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5821),
    [sym_literal_suffix] = ACTIONS(5276),
  },
  [1953] = {
    [sym_string_literal] = STATE(1956),
    [sym_raw_string_literal] = STATE(1956),
    [aux_sym_concatenated_string_repeat1] = STATE(1956),
    [sym_identifier] = ACTIONS(5823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5251),
    [anon_sym_COMMA] = ACTIONS(5251),
    [anon_sym_LPAREN2] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5253),
    [anon_sym_PLUS] = ACTIONS(5253),
    [anon_sym_STAR] = ACTIONS(5253),
    [anon_sym_SLASH] = ACTIONS(5253),
    [anon_sym_PERCENT] = ACTIONS(5253),
    [anon_sym_PIPE_PIPE] = ACTIONS(5251),
    [anon_sym_AMP_AMP] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5253),
    [anon_sym_CARET] = ACTIONS(5253),
    [anon_sym_AMP] = ACTIONS(5253),
    [anon_sym_EQ_EQ] = ACTIONS(5251),
    [anon_sym_BANG_EQ] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5253),
    [anon_sym_GT_EQ] = ACTIONS(5251),
    [anon_sym_LT_EQ] = ACTIONS(5253),
    [anon_sym_LT] = ACTIONS(5253),
    [anon_sym_LT_LT] = ACTIONS(5253),
    [anon_sym_GT_GT] = ACTIONS(5253),
    [anon_sym_SEMI] = ACTIONS(5251),
    [anon_sym___attribute__] = ACTIONS(5253),
    [anon_sym___attribute] = ACTIONS(5253),
    [anon_sym_LBRACK] = ACTIONS(5251),
    [anon_sym_EQ] = ACTIONS(5253),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_STAR_EQ] = ACTIONS(5251),
    [anon_sym_SLASH_EQ] = ACTIONS(5251),
    [anon_sym_PERCENT_EQ] = ACTIONS(5251),
    [anon_sym_PLUS_EQ] = ACTIONS(5251),
    [anon_sym_DASH_EQ] = ACTIONS(5251),
    [anon_sym_LT_LT_EQ] = ACTIONS(5251),
    [anon_sym_GT_GT_EQ] = ACTIONS(5251),
    [anon_sym_AMP_EQ] = ACTIONS(5251),
    [anon_sym_CARET_EQ] = ACTIONS(5251),
    [anon_sym_PIPE_EQ] = ACTIONS(5251),
    [anon_sym_and_eq] = ACTIONS(5253),
    [anon_sym_or_eq] = ACTIONS(5253),
    [anon_sym_xor_eq] = ACTIONS(5253),
    [anon_sym_LT_EQ_GT] = ACTIONS(5251),
    [anon_sym_or] = ACTIONS(5253),
    [anon_sym_and] = ACTIONS(5253),
    [anon_sym_bitor] = ACTIONS(5253),
    [anon_sym_xor] = ACTIONS(5253),
    [anon_sym_bitand] = ACTIONS(5253),
    [anon_sym_not_eq] = ACTIONS(5253),
    [anon_sym_DASH_DASH] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5251),
    [anon_sym_DOT] = ACTIONS(5253),
    [anon_sym_DOT_STAR] = ACTIONS(5251),
    [anon_sym_DASH_GT] = ACTIONS(5251),
    [anon_sym_L_DQUOTE] = ACTIONS(5819),
    [anon_sym_u_DQUOTE] = ACTIONS(5819),
    [anon_sym_U_DQUOTE] = ACTIONS(5819),
    [anon_sym_u8_DQUOTE] = ACTIONS(5819),
    [anon_sym_DQUOTE] = ACTIONS(5819),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5821),
    [anon_sym_LR_DQUOTE] = ACTIONS(5821),
    [anon_sym_uR_DQUOTE] = ACTIONS(5821),
    [anon_sym_UR_DQUOTE] = ACTIONS(5821),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5821),
    [sym_literal_suffix] = ACTIONS(5253),
  },
  [1954] = {
    [sym_identifier] = ACTIONS(2613),
    [aux_sym_preproc_def_token1] = ACTIONS(2613),
    [aux_sym_preproc_if_token1] = ACTIONS(2613),
    [aux_sym_preproc_if_token2] = ACTIONS(2613),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2613),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2613),
    [sym_preproc_directive] = ACTIONS(2613),
    [anon_sym_LPAREN2] = ACTIONS(2615),
    [anon_sym_TILDE] = ACTIONS(2615),
    [anon_sym_STAR] = ACTIONS(2615),
    [anon_sym_AMP_AMP] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2613),
    [anon_sym_SEMI] = ACTIONS(2615),
    [anon_sym___extension__] = ACTIONS(2613),
    [anon_sym_typedef] = ACTIONS(2613),
    [anon_sym_virtual] = ACTIONS(2613),
    [anon_sym_extern] = ACTIONS(2613),
    [anon_sym___attribute__] = ACTIONS(2613),
    [anon_sym___attribute] = ACTIONS(2613),
    [anon_sym_COLON_COLON] = ACTIONS(2615),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2615),
    [anon_sym___declspec] = ACTIONS(2613),
    [anon_sym___based] = ACTIONS(2613),
    [anon_sym_signed] = ACTIONS(2613),
    [anon_sym_unsigned] = ACTIONS(2613),
    [anon_sym_long] = ACTIONS(2613),
    [anon_sym_short] = ACTIONS(2613),
    [anon_sym_LBRACK] = ACTIONS(2613),
    [anon_sym_static] = ACTIONS(2613),
    [anon_sym_register] = ACTIONS(2613),
    [anon_sym_inline] = ACTIONS(2613),
    [anon_sym___inline] = ACTIONS(2613),
    [anon_sym___inline__] = ACTIONS(2613),
    [anon_sym___forceinline] = ACTIONS(2613),
    [anon_sym_thread_local] = ACTIONS(2613),
    [anon_sym___thread] = ACTIONS(2613),
    [anon_sym_const] = ACTIONS(2613),
    [anon_sym_constexpr] = ACTIONS(2613),
    [anon_sym_volatile] = ACTIONS(2613),
    [anon_sym_restrict] = ACTIONS(2613),
    [anon_sym___restrict__] = ACTIONS(2613),
    [anon_sym__Atomic] = ACTIONS(2613),
    [anon_sym__Noreturn] = ACTIONS(2613),
    [anon_sym_noreturn] = ACTIONS(2613),
    [anon_sym__Nonnull] = ACTIONS(2613),
    [anon_sym_mutable] = ACTIONS(2613),
    [anon_sym_constinit] = ACTIONS(2613),
    [anon_sym_consteval] = ACTIONS(2613),
    [anon_sym_alignas] = ACTIONS(2613),
    [anon_sym__Alignas] = ACTIONS(2613),
    [sym_primitive_type] = ACTIONS(2613),
    [anon_sym_enum] = ACTIONS(2613),
    [anon_sym_class] = ACTIONS(2613),
    [anon_sym_struct] = ACTIONS(2613),
    [anon_sym_union] = ACTIONS(2613),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2613),
    [anon_sym_decltype] = ACTIONS(2613),
    [anon_sym_explicit] = ACTIONS(2613),
    [anon_sym_typename] = ACTIONS(2613),
    [anon_sym_template] = ACTIONS(2613),
    [anon_sym_operator] = ACTIONS(2613),
    [anon_sym_friend] = ACTIONS(2613),
    [anon_sym_public] = ACTIONS(2613),
    [anon_sym_private] = ACTIONS(2613),
    [anon_sym_protected] = ACTIONS(2613),
    [anon_sym_using] = ACTIONS(2613),
    [anon_sym_static_assert] = ACTIONS(2613),
  },
  [1955] = {
    [sym_ms_based_modifier] = STATE(7915),
    [sym_ms_unaligned_ptr_modifier] = STATE(3998),
    [sym_ms_pointer_modifier] = STATE(3851),
    [sym__declarator] = STATE(6275),
    [sym__abstract_declarator] = STATE(6578),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_abstract_parenthesized_declarator] = STATE(5942),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_abstract_pointer_declarator] = STATE(5942),
    [sym_function_declarator] = STATE(5896),
    [sym_abstract_function_declarator] = STATE(5942),
    [sym_array_declarator] = STATE(5896),
    [sym_abstract_array_declarator] = STATE(5942),
    [sym_type_qualifier] = STATE(2612),
    [sym_alignas_qualifier] = STATE(4266),
    [sym_parameter_list] = STATE(3166),
    [sym_decltype] = STATE(8512),
    [sym_reference_declarator] = STATE(5896),
    [sym_abstract_reference_declarator] = STATE(5942),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym__function_declarator_seq] = STATE(5919),
    [sym_template_type] = STATE(8512),
    [sym_template_function] = STATE(5896),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5765),
    [sym_qualified_identifier] = STATE(5896),
    [sym_operator_name] = STATE(5896),
    [aux_sym__type_definition_type_repeat1] = STATE(2612),
    [aux_sym_pointer_declarator_repeat1] = STATE(3851),
    [sym_identifier] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5698),
    [anon_sym_LPAREN2] = ACTIONS(4157),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(5807),
    [anon_sym_AMP_AMP] = ACTIONS(5809),
    [anon_sym_AMP] = ACTIONS(5811),
    [anon_sym___extension__] = ACTIONS(3270),
    [anon_sym___attribute__] = ACTIONS(5706),
    [anon_sym___attribute] = ACTIONS(5706),
    [anon_sym_COLON_COLON] = ACTIONS(5708),
    [anon_sym___based] = ACTIONS(51),
    [sym_ms_restrict_modifier] = ACTIONS(3266),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(3266),
    [sym_ms_signed_ptr_modifier] = ACTIONS(3266),
    [anon_sym__unaligned] = ACTIONS(3268),
    [anon_sym___unaligned] = ACTIONS(3268),
    [anon_sym_LBRACK] = ACTIONS(5710),
    [anon_sym_const] = ACTIONS(3270),
    [anon_sym_constexpr] = ACTIONS(3270),
    [anon_sym_volatile] = ACTIONS(3270),
    [anon_sym_restrict] = ACTIONS(3270),
    [anon_sym___restrict__] = ACTIONS(3270),
    [anon_sym__Atomic] = ACTIONS(3270),
    [anon_sym__Noreturn] = ACTIONS(3270),
    [anon_sym_noreturn] = ACTIONS(3270),
    [anon_sym__Nonnull] = ACTIONS(3270),
    [anon_sym_mutable] = ACTIONS(3270),
    [anon_sym_constinit] = ACTIONS(3270),
    [anon_sym_consteval] = ACTIONS(3270),
    [anon_sym_alignas] = ACTIONS(3272),
    [anon_sym__Alignas] = ACTIONS(3272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_GT2] = ACTIONS(5698),
    [anon_sym_operator] = ACTIONS(1823),
  },
  [1956] = {
    [sym_string_literal] = STATE(1956),
    [sym_raw_string_literal] = STATE(1956),
    [aux_sym_concatenated_string_repeat1] = STATE(1956),
    [sym_identifier] = ACTIONS(5825),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5258),
    [anon_sym_COMMA] = ACTIONS(5258),
    [anon_sym_LPAREN2] = ACTIONS(5258),
    [anon_sym_DASH] = ACTIONS(5260),
    [anon_sym_PLUS] = ACTIONS(5260),
    [anon_sym_STAR] = ACTIONS(5260),
    [anon_sym_SLASH] = ACTIONS(5260),
    [anon_sym_PERCENT] = ACTIONS(5260),
    [anon_sym_PIPE_PIPE] = ACTIONS(5258),
    [anon_sym_AMP_AMP] = ACTIONS(5258),
    [anon_sym_PIPE] = ACTIONS(5260),
    [anon_sym_CARET] = ACTIONS(5260),
    [anon_sym_AMP] = ACTIONS(5260),
    [anon_sym_EQ_EQ] = ACTIONS(5258),
    [anon_sym_BANG_EQ] = ACTIONS(5258),
    [anon_sym_GT] = ACTIONS(5260),
    [anon_sym_GT_EQ] = ACTIONS(5258),
    [anon_sym_LT_EQ] = ACTIONS(5260),
    [anon_sym_LT] = ACTIONS(5260),
    [anon_sym_LT_LT] = ACTIONS(5260),
    [anon_sym_GT_GT] = ACTIONS(5260),
    [anon_sym_SEMI] = ACTIONS(5258),
    [anon_sym___attribute__] = ACTIONS(5260),
    [anon_sym___attribute] = ACTIONS(5260),
    [anon_sym_LBRACK] = ACTIONS(5258),
    [anon_sym_EQ] = ACTIONS(5260),
    [anon_sym_QMARK] = ACTIONS(5258),
    [anon_sym_STAR_EQ] = ACTIONS(5258),
    [anon_sym_SLASH_EQ] = ACTIONS(5258),
    [anon_sym_PERCENT_EQ] = ACTIONS(5258),
    [anon_sym_PLUS_EQ] = ACTIONS(5258),
    [anon_sym_DASH_EQ] = ACTIONS(5258),
    [anon_sym_LT_LT_EQ] = ACTIONS(5258),
    [anon_sym_GT_GT_EQ] = ACTIONS(5258),
    [anon_sym_AMP_EQ] = ACTIONS(5258),
    [anon_sym_CARET_EQ] = ACTIONS(5258),
    [anon_sym_PIPE_EQ] = ACTIONS(5258),
    [anon_sym_and_eq] = ACTIONS(5260),
    [anon_sym_or_eq] = ACTIONS(5260),
    [anon_sym_xor_eq] = ACTIONS(5260),
    [anon_sym_LT_EQ_GT] = ACTIONS(5258),
    [anon_sym_or] = ACTIONS(5260),
    [anon_sym_and] = ACTIONS(5260),
    [anon_sym_bitor] = ACTIONS(5260),
    [anon_sym_xor] = ACTIONS(5260),
    [anon_sym_bitand] = ACTIONS(5260),
    [anon_sym_not_eq] = ACTIONS(5260),
    [anon_sym_DASH_DASH] = ACTIONS(5258),
    [anon_sym_PLUS_PLUS] = ACTIONS(5258),
    [anon_sym_DOT] = ACTIONS(5260),
    [anon_sym_DOT_STAR] = ACTIONS(5258),
    [anon_sym_DASH_GT] = ACTIONS(5258),
    [anon_sym_L_DQUOTE] = ACTIONS(5828),
    [anon_sym_u_DQUOTE] = ACTIONS(5828),
    [anon_sym_U_DQUOTE] = ACTIONS(5828),
    [anon_sym_u8_DQUOTE] = ACTIONS(5828),
    [anon_sym_DQUOTE] = ACTIONS(5828),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5831),
    [anon_sym_LR_DQUOTE] = ACTIONS(5831),
    [anon_sym_uR_DQUOTE] = ACTIONS(5831),
    [anon_sym_UR_DQUOTE] = ACTIONS(5831),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5831),
    [sym_literal_suffix] = ACTIONS(5260),
  },
  [1957] = {
    [sym_identifier] = ACTIONS(2645),
    [aux_sym_preproc_def_token1] = ACTIONS(2645),
    [aux_sym_preproc_if_token1] = ACTIONS(2645),
    [aux_sym_preproc_if_token2] = ACTIONS(2645),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2645),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2645),
    [sym_preproc_directive] = ACTIONS(2645),
    [anon_sym_LPAREN2] = ACTIONS(2647),
    [anon_sym_TILDE] = ACTIONS(2647),
    [anon_sym_STAR] = ACTIONS(2647),
    [anon_sym_AMP_AMP] = ACTIONS(2647),
    [anon_sym_AMP] = ACTIONS(2645),
    [anon_sym_SEMI] = ACTIONS(2647),
    [anon_sym___extension__] = ACTIONS(2645),
    [anon_sym_typedef] = ACTIONS(2645),
    [anon_sym_virtual] = ACTIONS(2645),
    [anon_sym_extern] = ACTIONS(2645),
    [anon_sym___attribute__] = ACTIONS(2645),
    [anon_sym___attribute] = ACTIONS(2645),
    [anon_sym_COLON_COLON] = ACTIONS(2647),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2647),
    [anon_sym___declspec] = ACTIONS(2645),
    [anon_sym___based] = ACTIONS(2645),
    [anon_sym_signed] = ACTIONS(2645),
    [anon_sym_unsigned] = ACTIONS(2645),
    [anon_sym_long] = ACTIONS(2645),
    [anon_sym_short] = ACTIONS(2645),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_static] = ACTIONS(2645),
    [anon_sym_register] = ACTIONS(2645),
    [anon_sym_inline] = ACTIONS(2645),
    [anon_sym___inline] = ACTIONS(2645),
    [anon_sym___inline__] = ACTIONS(2645),
    [anon_sym___forceinline] = ACTIONS(2645),
    [anon_sym_thread_local] = ACTIONS(2645),
    [anon_sym___thread] = ACTIONS(2645),
    [anon_sym_const] = ACTIONS(2645),
    [anon_sym_constexpr] = ACTIONS(2645),
    [anon_sym_volatile] = ACTIONS(2645),
    [anon_sym_restrict] = ACTIONS(2645),
    [anon_sym___restrict__] = ACTIONS(2645),
    [anon_sym__Atomic] = ACTIONS(2645),
    [anon_sym__Noreturn] = ACTIONS(2645),
    [anon_sym_noreturn] = ACTIONS(2645),
    [anon_sym__Nonnull] = ACTIONS(2645),
    [anon_sym_mutable] = ACTIONS(2645),
    [anon_sym_constinit] = ACTIONS(2645),
    [anon_sym_consteval] = ACTIONS(2645),
    [anon_sym_alignas] = ACTIONS(2645),
    [anon_sym__Alignas] = ACTIONS(2645),
    [sym_primitive_type] = ACTIONS(2645),
    [anon_sym_enum] = ACTIONS(2645),
    [anon_sym_class] = ACTIONS(2645),
    [anon_sym_struct] = ACTIONS(2645),
    [anon_sym_union] = ACTIONS(2645),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2645),
    [anon_sym_decltype] = ACTIONS(2645),
    [anon_sym_explicit] = ACTIONS(2645),
    [anon_sym_typename] = ACTIONS(2645),
    [anon_sym_template] = ACTIONS(2645),
    [anon_sym_operator] = ACTIONS(2645),
    [anon_sym_friend] = ACTIONS(2645),
    [anon_sym_public] = ACTIONS(2645),
    [anon_sym_private] = ACTIONS(2645),
    [anon_sym_protected] = ACTIONS(2645),
    [anon_sym_using] = ACTIONS(2645),
    [anon_sym_static_assert] = ACTIONS(2645),
  },
  [1958] = {
    [sym_identifier] = ACTIONS(2649),
    [aux_sym_preproc_def_token1] = ACTIONS(2649),
    [aux_sym_preproc_if_token1] = ACTIONS(2649),
    [aux_sym_preproc_if_token2] = ACTIONS(2649),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2649),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2649),
    [sym_preproc_directive] = ACTIONS(2649),
    [anon_sym_LPAREN2] = ACTIONS(2651),
    [anon_sym_TILDE] = ACTIONS(2651),
    [anon_sym_STAR] = ACTIONS(2651),
    [anon_sym_AMP_AMP] = ACTIONS(2651),
    [anon_sym_AMP] = ACTIONS(2649),
    [anon_sym_SEMI] = ACTIONS(2651),
    [anon_sym___extension__] = ACTIONS(2649),
    [anon_sym_typedef] = ACTIONS(2649),
    [anon_sym_virtual] = ACTIONS(2649),
    [anon_sym_extern] = ACTIONS(2649),
    [anon_sym___attribute__] = ACTIONS(2649),
    [anon_sym___attribute] = ACTIONS(2649),
    [anon_sym_COLON_COLON] = ACTIONS(2651),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2651),
    [anon_sym___declspec] = ACTIONS(2649),
    [anon_sym___based] = ACTIONS(2649),
    [anon_sym_signed] = ACTIONS(2649),
    [anon_sym_unsigned] = ACTIONS(2649),
    [anon_sym_long] = ACTIONS(2649),
    [anon_sym_short] = ACTIONS(2649),
    [anon_sym_LBRACK] = ACTIONS(2649),
    [anon_sym_static] = ACTIONS(2649),
    [anon_sym_register] = ACTIONS(2649),
    [anon_sym_inline] = ACTIONS(2649),
    [anon_sym___inline] = ACTIONS(2649),
    [anon_sym___inline__] = ACTIONS(2649),
    [anon_sym___forceinline] = ACTIONS(2649),
    [anon_sym_thread_local] = ACTIONS(2649),
    [anon_sym___thread] = ACTIONS(2649),
    [anon_sym_const] = ACTIONS(2649),
    [anon_sym_constexpr] = ACTIONS(2649),
    [anon_sym_volatile] = ACTIONS(2649),
    [anon_sym_restrict] = ACTIONS(2649),
    [anon_sym___restrict__] = ACTIONS(2649),
    [anon_sym__Atomic] = ACTIONS(2649),
    [anon_sym__Noreturn] = ACTIONS(2649),
    [anon_sym_noreturn] = ACTIONS(2649),
    [anon_sym__Nonnull] = ACTIONS(2649),
    [anon_sym_mutable] = ACTIONS(2649),
    [anon_sym_constinit] = ACTIONS(2649),
    [anon_sym_consteval] = ACTIONS(2649),
    [anon_sym_alignas] = ACTIONS(2649),
    [anon_sym__Alignas] = ACTIONS(2649),
    [sym_primitive_type] = ACTIONS(2649),
    [anon_sym_enum] = ACTIONS(2649),
    [anon_sym_class] = ACTIONS(2649),
    [anon_sym_struct] = ACTIONS(2649),
    [anon_sym_union] = ACTIONS(2649),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2649),
    [anon_sym_decltype] = ACTIONS(2649),
    [anon_sym_explicit] = ACTIONS(2649),
    [anon_sym_typename] = ACTIONS(2649),
    [anon_sym_template] = ACTIONS(2649),
    [anon_sym_operator] = ACTIONS(2649),
    [anon_sym_friend] = ACTIONS(2649),
    [anon_sym_public] = ACTIONS(2649),
    [anon_sym_private] = ACTIONS(2649),
    [anon_sym_protected] = ACTIONS(2649),
    [anon_sym_using] = ACTIONS(2649),
    [anon_sym_static_assert] = ACTIONS(2649),
  },
  [1959] = {
    [sym_identifier] = ACTIONS(2731),
    [aux_sym_preproc_def_token1] = ACTIONS(2731),
    [aux_sym_preproc_if_token1] = ACTIONS(2731),
    [aux_sym_preproc_if_token2] = ACTIONS(2731),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2731),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2731),
    [sym_preproc_directive] = ACTIONS(2731),
    [anon_sym_LPAREN2] = ACTIONS(2733),
    [anon_sym_TILDE] = ACTIONS(2733),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_AMP_AMP] = ACTIONS(2733),
    [anon_sym_AMP] = ACTIONS(2731),
    [anon_sym_SEMI] = ACTIONS(2733),
    [anon_sym___extension__] = ACTIONS(2731),
    [anon_sym_typedef] = ACTIONS(2731),
    [anon_sym_virtual] = ACTIONS(2731),
    [anon_sym_extern] = ACTIONS(2731),
    [anon_sym___attribute__] = ACTIONS(2731),
    [anon_sym___attribute] = ACTIONS(2731),
    [anon_sym_COLON_COLON] = ACTIONS(2733),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2733),
    [anon_sym___declspec] = ACTIONS(2731),
    [anon_sym___based] = ACTIONS(2731),
    [anon_sym_signed] = ACTIONS(2731),
    [anon_sym_unsigned] = ACTIONS(2731),
    [anon_sym_long] = ACTIONS(2731),
    [anon_sym_short] = ACTIONS(2731),
    [anon_sym_LBRACK] = ACTIONS(2731),
    [anon_sym_static] = ACTIONS(2731),
    [anon_sym_register] = ACTIONS(2731),
    [anon_sym_inline] = ACTIONS(2731),
    [anon_sym___inline] = ACTIONS(2731),
    [anon_sym___inline__] = ACTIONS(2731),
    [anon_sym___forceinline] = ACTIONS(2731),
    [anon_sym_thread_local] = ACTIONS(2731),
    [anon_sym___thread] = ACTIONS(2731),
    [anon_sym_const] = ACTIONS(2731),
    [anon_sym_constexpr] = ACTIONS(2731),
    [anon_sym_volatile] = ACTIONS(2731),
    [anon_sym_restrict] = ACTIONS(2731),
    [anon_sym___restrict__] = ACTIONS(2731),
    [anon_sym__Atomic] = ACTIONS(2731),
    [anon_sym__Noreturn] = ACTIONS(2731),
    [anon_sym_noreturn] = ACTIONS(2731),
    [anon_sym__Nonnull] = ACTIONS(2731),
    [anon_sym_mutable] = ACTIONS(2731),
    [anon_sym_constinit] = ACTIONS(2731),
    [anon_sym_consteval] = ACTIONS(2731),
    [anon_sym_alignas] = ACTIONS(2731),
    [anon_sym__Alignas] = ACTIONS(2731),
    [sym_primitive_type] = ACTIONS(2731),
    [anon_sym_enum] = ACTIONS(2731),
    [anon_sym_class] = ACTIONS(2731),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2731),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2731),
    [anon_sym_decltype] = ACTIONS(2731),
    [anon_sym_explicit] = ACTIONS(2731),
    [anon_sym_typename] = ACTIONS(2731),
    [anon_sym_template] = ACTIONS(2731),
    [anon_sym_operator] = ACTIONS(2731),
    [anon_sym_friend] = ACTIONS(2731),
    [anon_sym_public] = ACTIONS(2731),
    [anon_sym_private] = ACTIONS(2731),
    [anon_sym_protected] = ACTIONS(2731),
    [anon_sym_using] = ACTIONS(2731),
    [anon_sym_static_assert] = ACTIONS(2731),
  },
  [1960] = {
    [sym_identifier] = ACTIONS(2689),
    [aux_sym_preproc_def_token1] = ACTIONS(2689),
    [aux_sym_preproc_if_token1] = ACTIONS(2689),
    [aux_sym_preproc_if_token2] = ACTIONS(2689),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2689),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2689),
    [sym_preproc_directive] = ACTIONS(2689),
    [anon_sym_LPAREN2] = ACTIONS(2691),
    [anon_sym_TILDE] = ACTIONS(2691),
    [anon_sym_STAR] = ACTIONS(2691),
    [anon_sym_AMP_AMP] = ACTIONS(2691),
    [anon_sym_AMP] = ACTIONS(2689),
    [anon_sym_SEMI] = ACTIONS(2691),
    [anon_sym___extension__] = ACTIONS(2689),
    [anon_sym_typedef] = ACTIONS(2689),
    [anon_sym_virtual] = ACTIONS(2689),
    [anon_sym_extern] = ACTIONS(2689),
    [anon_sym___attribute__] = ACTIONS(2689),
    [anon_sym___attribute] = ACTIONS(2689),
    [anon_sym_COLON_COLON] = ACTIONS(2691),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2691),
    [anon_sym___declspec] = ACTIONS(2689),
    [anon_sym___based] = ACTIONS(2689),
    [anon_sym_signed] = ACTIONS(2689),
    [anon_sym_unsigned] = ACTIONS(2689),
    [anon_sym_long] = ACTIONS(2689),
    [anon_sym_short] = ACTIONS(2689),
    [anon_sym_LBRACK] = ACTIONS(2689),
    [anon_sym_static] = ACTIONS(2689),
    [anon_sym_register] = ACTIONS(2689),
    [anon_sym_inline] = ACTIONS(2689),
    [anon_sym___inline] = ACTIONS(2689),
    [anon_sym___inline__] = ACTIONS(2689),
    [anon_sym___forceinline] = ACTIONS(2689),
    [anon_sym_thread_local] = ACTIONS(2689),
    [anon_sym___thread] = ACTIONS(2689),
    [anon_sym_const] = ACTIONS(2689),
    [anon_sym_constexpr] = ACTIONS(2689),
    [anon_sym_volatile] = ACTIONS(2689),
    [anon_sym_restrict] = ACTIONS(2689),
    [anon_sym___restrict__] = ACTIONS(2689),
    [anon_sym__Atomic] = ACTIONS(2689),
    [anon_sym__Noreturn] = ACTIONS(2689),
    [anon_sym_noreturn] = ACTIONS(2689),
    [anon_sym__Nonnull] = ACTIONS(2689),
    [anon_sym_mutable] = ACTIONS(2689),
    [anon_sym_constinit] = ACTIONS(2689),
    [anon_sym_consteval] = ACTIONS(2689),
    [anon_sym_alignas] = ACTIONS(2689),
    [anon_sym__Alignas] = ACTIONS(2689),
    [sym_primitive_type] = ACTIONS(2689),
    [anon_sym_enum] = ACTIONS(2689),
    [anon_sym_class] = ACTIONS(2689),
    [anon_sym_struct] = ACTIONS(2689),
    [anon_sym_union] = ACTIONS(2689),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2689),
    [anon_sym_decltype] = ACTIONS(2689),
    [anon_sym_explicit] = ACTIONS(2689),
    [anon_sym_typename] = ACTIONS(2689),
    [anon_sym_template] = ACTIONS(2689),
    [anon_sym_operator] = ACTIONS(2689),
    [anon_sym_friend] = ACTIONS(2689),
    [anon_sym_public] = ACTIONS(2689),
    [anon_sym_private] = ACTIONS(2689),
    [anon_sym_protected] = ACTIONS(2689),
    [anon_sym_using] = ACTIONS(2689),
    [anon_sym_static_assert] = ACTIONS(2689),
  },
  [1961] = {
    [sym_identifier] = ACTIONS(2763),
    [aux_sym_preproc_def_token1] = ACTIONS(2763),
    [aux_sym_preproc_if_token1] = ACTIONS(2763),
    [aux_sym_preproc_if_token2] = ACTIONS(2763),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2763),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2763),
    [sym_preproc_directive] = ACTIONS(2763),
    [anon_sym_LPAREN2] = ACTIONS(2765),
    [anon_sym_TILDE] = ACTIONS(2765),
    [anon_sym_STAR] = ACTIONS(2765),
    [anon_sym_AMP_AMP] = ACTIONS(2765),
    [anon_sym_AMP] = ACTIONS(2763),
    [anon_sym_SEMI] = ACTIONS(2765),
    [anon_sym___extension__] = ACTIONS(2763),
    [anon_sym_typedef] = ACTIONS(2763),
    [anon_sym_virtual] = ACTIONS(2763),
    [anon_sym_extern] = ACTIONS(2763),
    [anon_sym___attribute__] = ACTIONS(2763),
    [anon_sym___attribute] = ACTIONS(2763),
    [anon_sym_COLON_COLON] = ACTIONS(2765),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2765),
    [anon_sym___declspec] = ACTIONS(2763),
    [anon_sym___based] = ACTIONS(2763),
    [anon_sym_signed] = ACTIONS(2763),
    [anon_sym_unsigned] = ACTIONS(2763),
    [anon_sym_long] = ACTIONS(2763),
    [anon_sym_short] = ACTIONS(2763),
    [anon_sym_LBRACK] = ACTIONS(2763),
    [anon_sym_static] = ACTIONS(2763),
    [anon_sym_register] = ACTIONS(2763),
    [anon_sym_inline] = ACTIONS(2763),
    [anon_sym___inline] = ACTIONS(2763),
    [anon_sym___inline__] = ACTIONS(2763),
    [anon_sym___forceinline] = ACTIONS(2763),
    [anon_sym_thread_local] = ACTIONS(2763),
    [anon_sym___thread] = ACTIONS(2763),
    [anon_sym_const] = ACTIONS(2763),
    [anon_sym_constexpr] = ACTIONS(2763),
    [anon_sym_volatile] = ACTIONS(2763),
    [anon_sym_restrict] = ACTIONS(2763),
    [anon_sym___restrict__] = ACTIONS(2763),
    [anon_sym__Atomic] = ACTIONS(2763),
    [anon_sym__Noreturn] = ACTIONS(2763),
    [anon_sym_noreturn] = ACTIONS(2763),
    [anon_sym__Nonnull] = ACTIONS(2763),
    [anon_sym_mutable] = ACTIONS(2763),
    [anon_sym_constinit] = ACTIONS(2763),
    [anon_sym_consteval] = ACTIONS(2763),
    [anon_sym_alignas] = ACTIONS(2763),
    [anon_sym__Alignas] = ACTIONS(2763),
    [sym_primitive_type] = ACTIONS(2763),
    [anon_sym_enum] = ACTIONS(2763),
    [anon_sym_class] = ACTIONS(2763),
    [anon_sym_struct] = ACTIONS(2763),
    [anon_sym_union] = ACTIONS(2763),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2763),
    [anon_sym_decltype] = ACTIONS(2763),
    [anon_sym_explicit] = ACTIONS(2763),
    [anon_sym_typename] = ACTIONS(2763),
    [anon_sym_template] = ACTIONS(2763),
    [anon_sym_operator] = ACTIONS(2763),
    [anon_sym_friend] = ACTIONS(2763),
    [anon_sym_public] = ACTIONS(2763),
    [anon_sym_private] = ACTIONS(2763),
    [anon_sym_protected] = ACTIONS(2763),
    [anon_sym_using] = ACTIONS(2763),
    [anon_sym_static_assert] = ACTIONS(2763),
  },
  [1962] = {
    [sym_attribute_specifier] = STATE(2231),
    [sym_enumerator_list] = STATE(2148),
    [sym_identifier] = ACTIONS(5834),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5836),
    [anon_sym_COMMA] = ACTIONS(5836),
    [anon_sym_RPAREN] = ACTIONS(5836),
    [aux_sym_preproc_if_token2] = ACTIONS(5836),
    [aux_sym_preproc_else_token1] = ACTIONS(5836),
    [aux_sym_preproc_elif_token1] = ACTIONS(5834),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5836),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5836),
    [anon_sym_LPAREN2] = ACTIONS(5836),
    [anon_sym_DASH] = ACTIONS(5834),
    [anon_sym_PLUS] = ACTIONS(5834),
    [anon_sym_STAR] = ACTIONS(5834),
    [anon_sym_SLASH] = ACTIONS(5834),
    [anon_sym_PERCENT] = ACTIONS(5834),
    [anon_sym_PIPE_PIPE] = ACTIONS(5836),
    [anon_sym_AMP_AMP] = ACTIONS(5836),
    [anon_sym_PIPE] = ACTIONS(5834),
    [anon_sym_CARET] = ACTIONS(5834),
    [anon_sym_AMP] = ACTIONS(5834),
    [anon_sym_EQ_EQ] = ACTIONS(5836),
    [anon_sym_BANG_EQ] = ACTIONS(5836),
    [anon_sym_GT] = ACTIONS(5834),
    [anon_sym_GT_EQ] = ACTIONS(5836),
    [anon_sym_LT_EQ] = ACTIONS(5834),
    [anon_sym_LT] = ACTIONS(5834),
    [anon_sym_LT_LT] = ACTIONS(5834),
    [anon_sym_GT_GT] = ACTIONS(5834),
    [anon_sym_SEMI] = ACTIONS(5836),
    [anon_sym___attribute__] = ACTIONS(5379),
    [anon_sym___attribute] = ACTIONS(5379),
    [anon_sym_LBRACE] = ACTIONS(5838),
    [anon_sym_RBRACE] = ACTIONS(5836),
    [anon_sym_LBRACK] = ACTIONS(5836),
    [anon_sym_RBRACK] = ACTIONS(5836),
    [anon_sym_EQ] = ACTIONS(5834),
    [anon_sym_COLON] = ACTIONS(5836),
    [anon_sym_QMARK] = ACTIONS(5836),
    [anon_sym_STAR_EQ] = ACTIONS(5836),
    [anon_sym_SLASH_EQ] = ACTIONS(5836),
    [anon_sym_PERCENT_EQ] = ACTIONS(5836),
    [anon_sym_PLUS_EQ] = ACTIONS(5836),
    [anon_sym_DASH_EQ] = ACTIONS(5836),
    [anon_sym_LT_LT_EQ] = ACTIONS(5836),
    [anon_sym_GT_GT_EQ] = ACTIONS(5836),
    [anon_sym_AMP_EQ] = ACTIONS(5836),
    [anon_sym_CARET_EQ] = ACTIONS(5836),
    [anon_sym_PIPE_EQ] = ACTIONS(5836),
    [anon_sym_and_eq] = ACTIONS(5834),
    [anon_sym_or_eq] = ACTIONS(5834),
    [anon_sym_xor_eq] = ACTIONS(5834),
    [anon_sym_LT_EQ_GT] = ACTIONS(5836),
    [anon_sym_or] = ACTIONS(5834),
    [anon_sym_and] = ACTIONS(5834),
    [anon_sym_bitor] = ACTIONS(5834),
    [anon_sym_xor] = ACTIONS(5834),
    [anon_sym_bitand] = ACTIONS(5834),
    [anon_sym_not_eq] = ACTIONS(5834),
    [anon_sym_DASH_DASH] = ACTIONS(5836),
    [anon_sym_PLUS_PLUS] = ACTIONS(5836),
    [anon_sym_DOT] = ACTIONS(5834),
    [anon_sym_DOT_STAR] = ACTIONS(5836),
    [anon_sym_DASH_GT] = ACTIONS(5836),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5834),
    [anon_sym_decltype] = ACTIONS(5834),
  },
  [1963] = {
    [sym_identifier] = ACTIONS(3142),
    [aux_sym_preproc_def_token1] = ACTIONS(3142),
    [aux_sym_preproc_if_token1] = ACTIONS(3142),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3142),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3142),
    [sym_preproc_directive] = ACTIONS(3142),
    [anon_sym_LPAREN2] = ACTIONS(3144),
    [anon_sym_TILDE] = ACTIONS(3144),
    [anon_sym_STAR] = ACTIONS(3144),
    [anon_sym_AMP_AMP] = ACTIONS(3144),
    [anon_sym_AMP] = ACTIONS(3142),
    [anon_sym_SEMI] = ACTIONS(3144),
    [anon_sym___extension__] = ACTIONS(3142),
    [anon_sym_typedef] = ACTIONS(3142),
    [anon_sym_virtual] = ACTIONS(3142),
    [anon_sym_extern] = ACTIONS(3142),
    [anon_sym___attribute__] = ACTIONS(3142),
    [anon_sym___attribute] = ACTIONS(3142),
    [anon_sym_COLON_COLON] = ACTIONS(3144),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3144),
    [anon_sym___declspec] = ACTIONS(3142),
    [anon_sym___based] = ACTIONS(3142),
    [anon_sym_RBRACE] = ACTIONS(3144),
    [anon_sym_signed] = ACTIONS(3142),
    [anon_sym_unsigned] = ACTIONS(3142),
    [anon_sym_long] = ACTIONS(3142),
    [anon_sym_short] = ACTIONS(3142),
    [anon_sym_LBRACK] = ACTIONS(3142),
    [anon_sym_static] = ACTIONS(3142),
    [anon_sym_register] = ACTIONS(3142),
    [anon_sym_inline] = ACTIONS(3142),
    [anon_sym___inline] = ACTIONS(3142),
    [anon_sym___inline__] = ACTIONS(3142),
    [anon_sym___forceinline] = ACTIONS(3142),
    [anon_sym_thread_local] = ACTIONS(3142),
    [anon_sym___thread] = ACTIONS(3142),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_constexpr] = ACTIONS(3142),
    [anon_sym_volatile] = ACTIONS(3142),
    [anon_sym_restrict] = ACTIONS(3142),
    [anon_sym___restrict__] = ACTIONS(3142),
    [anon_sym__Atomic] = ACTIONS(3142),
    [anon_sym__Noreturn] = ACTIONS(3142),
    [anon_sym_noreturn] = ACTIONS(3142),
    [anon_sym__Nonnull] = ACTIONS(3142),
    [anon_sym_mutable] = ACTIONS(3142),
    [anon_sym_constinit] = ACTIONS(3142),
    [anon_sym_consteval] = ACTIONS(3142),
    [anon_sym_alignas] = ACTIONS(3142),
    [anon_sym__Alignas] = ACTIONS(3142),
    [sym_primitive_type] = ACTIONS(3142),
    [anon_sym_enum] = ACTIONS(3142),
    [anon_sym_class] = ACTIONS(3142),
    [anon_sym_struct] = ACTIONS(3142),
    [anon_sym_union] = ACTIONS(3142),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3142),
    [anon_sym_decltype] = ACTIONS(3142),
    [anon_sym_explicit] = ACTIONS(3142),
    [anon_sym_typename] = ACTIONS(3142),
    [anon_sym_template] = ACTIONS(3142),
    [anon_sym_operator] = ACTIONS(3142),
    [anon_sym_friend] = ACTIONS(3142),
    [anon_sym_public] = ACTIONS(3142),
    [anon_sym_private] = ACTIONS(3142),
    [anon_sym_protected] = ACTIONS(3142),
    [anon_sym_using] = ACTIONS(3142),
    [anon_sym_static_assert] = ACTIONS(3142),
  },
  [1964] = {
    [sym_string_literal] = STATE(2570),
    [sym_template_argument_list] = STATE(3643),
    [sym_raw_string_literal] = STATE(2570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4035),
    [anon_sym_COMMA] = ACTIONS(4035),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_DASH] = ACTIONS(4043),
    [anon_sym_PLUS] = ACTIONS(4043),
    [anon_sym_STAR] = ACTIONS(4043),
    [anon_sym_SLASH] = ACTIONS(4043),
    [anon_sym_PERCENT] = ACTIONS(4043),
    [anon_sym_PIPE_PIPE] = ACTIONS(4035),
    [anon_sym_AMP_AMP] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4043),
    [anon_sym_CARET] = ACTIONS(4043),
    [anon_sym_AMP] = ACTIONS(4043),
    [anon_sym_EQ_EQ] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4043),
    [anon_sym_GT_EQ] = ACTIONS(4035),
    [anon_sym_LT_EQ] = ACTIONS(4043),
    [anon_sym_LT] = ACTIONS(4929),
    [anon_sym_LT_LT] = ACTIONS(4043),
    [anon_sym_GT_GT] = ACTIONS(4043),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACE] = ACTIONS(4059),
    [anon_sym_RBRACE] = ACTIONS(4035),
    [anon_sym_LBRACK] = ACTIONS(4035),
    [anon_sym_EQ] = ACTIONS(4067),
    [anon_sym_COLON] = ACTIONS(5840),
    [anon_sym_QMARK] = ACTIONS(4035),
    [anon_sym_STAR_EQ] = ACTIONS(4071),
    [anon_sym_SLASH_EQ] = ACTIONS(4071),
    [anon_sym_PERCENT_EQ] = ACTIONS(4071),
    [anon_sym_PLUS_EQ] = ACTIONS(4071),
    [anon_sym_DASH_EQ] = ACTIONS(4071),
    [anon_sym_LT_LT_EQ] = ACTIONS(4071),
    [anon_sym_GT_GT_EQ] = ACTIONS(4071),
    [anon_sym_AMP_EQ] = ACTIONS(4071),
    [anon_sym_CARET_EQ] = ACTIONS(4071),
    [anon_sym_PIPE_EQ] = ACTIONS(4071),
    [anon_sym_and_eq] = ACTIONS(4071),
    [anon_sym_or_eq] = ACTIONS(4071),
    [anon_sym_xor_eq] = ACTIONS(4071),
    [anon_sym_LT_EQ_GT] = ACTIONS(4035),
    [anon_sym_or] = ACTIONS(4043),
    [anon_sym_and] = ACTIONS(4043),
    [anon_sym_bitor] = ACTIONS(4035),
    [anon_sym_xor] = ACTIONS(4043),
    [anon_sym_bitand] = ACTIONS(4035),
    [anon_sym_not_eq] = ACTIONS(4035),
    [anon_sym_DASH_DASH] = ACTIONS(4035),
    [anon_sym_PLUS_PLUS] = ACTIONS(4035),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_DOT_STAR] = ACTIONS(4035),
    [anon_sym_DASH_GT] = ACTIONS(4035),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
  },
  [1965] = {
    [sym_template_argument_list] = STATE(1570),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(5842),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5844),
    [anon_sym_COMMA] = ACTIONS(5844),
    [aux_sym_preproc_if_token2] = ACTIONS(5844),
    [aux_sym_preproc_else_token1] = ACTIONS(5844),
    [aux_sym_preproc_elif_token1] = ACTIONS(5842),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5844),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5844),
    [anon_sym_LPAREN2] = ACTIONS(5844),
    [anon_sym_DASH] = ACTIONS(5842),
    [anon_sym_PLUS] = ACTIONS(5842),
    [anon_sym_STAR] = ACTIONS(5842),
    [anon_sym_SLASH] = ACTIONS(5842),
    [anon_sym_PERCENT] = ACTIONS(5842),
    [anon_sym_PIPE_PIPE] = ACTIONS(5844),
    [anon_sym_AMP_AMP] = ACTIONS(5844),
    [anon_sym_PIPE] = ACTIONS(5842),
    [anon_sym_CARET] = ACTIONS(5842),
    [anon_sym_AMP] = ACTIONS(5842),
    [anon_sym_EQ_EQ] = ACTIONS(5844),
    [anon_sym_BANG_EQ] = ACTIONS(5844),
    [anon_sym_GT] = ACTIONS(5842),
    [anon_sym_GT_EQ] = ACTIONS(5844),
    [anon_sym_LT_EQ] = ACTIONS(5842),
    [anon_sym_LT] = ACTIONS(5842),
    [anon_sym_LT_LT] = ACTIONS(5842),
    [anon_sym_GT_GT] = ACTIONS(5842),
    [anon_sym___attribute__] = ACTIONS(5842),
    [anon_sym___attribute] = ACTIONS(5842),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACE] = ACTIONS(5844),
    [anon_sym_signed] = ACTIONS(5846),
    [anon_sym_unsigned] = ACTIONS(5846),
    [anon_sym_long] = ACTIONS(5846),
    [anon_sym_short] = ACTIONS(5846),
    [anon_sym_LBRACK] = ACTIONS(5844),
    [anon_sym_EQ] = ACTIONS(5842),
    [anon_sym_QMARK] = ACTIONS(5844),
    [anon_sym_STAR_EQ] = ACTIONS(5844),
    [anon_sym_SLASH_EQ] = ACTIONS(5844),
    [anon_sym_PERCENT_EQ] = ACTIONS(5844),
    [anon_sym_PLUS_EQ] = ACTIONS(5844),
    [anon_sym_DASH_EQ] = ACTIONS(5844),
    [anon_sym_LT_LT_EQ] = ACTIONS(5844),
    [anon_sym_GT_GT_EQ] = ACTIONS(5844),
    [anon_sym_AMP_EQ] = ACTIONS(5844),
    [anon_sym_CARET_EQ] = ACTIONS(5844),
    [anon_sym_PIPE_EQ] = ACTIONS(5844),
    [anon_sym_and_eq] = ACTIONS(5842),
    [anon_sym_or_eq] = ACTIONS(5842),
    [anon_sym_xor_eq] = ACTIONS(5842),
    [anon_sym_LT_EQ_GT] = ACTIONS(5844),
    [anon_sym_or] = ACTIONS(5842),
    [anon_sym_and] = ACTIONS(5842),
    [anon_sym_bitor] = ACTIONS(5842),
    [anon_sym_xor] = ACTIONS(5842),
    [anon_sym_bitand] = ACTIONS(5842),
    [anon_sym_not_eq] = ACTIONS(5842),
    [anon_sym_DASH_DASH] = ACTIONS(5844),
    [anon_sym_PLUS_PLUS] = ACTIONS(5844),
    [anon_sym_DOT] = ACTIONS(5842),
    [anon_sym_DOT_STAR] = ACTIONS(5844),
    [anon_sym_DASH_GT] = ACTIONS(5844),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5842),
    [anon_sym_decltype] = ACTIONS(5842),
  },
  [1966] = {
    [sym_identifier] = ACTIONS(2751),
    [aux_sym_preproc_def_token1] = ACTIONS(2751),
    [aux_sym_preproc_if_token1] = ACTIONS(2751),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2751),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2751),
    [sym_preproc_directive] = ACTIONS(2751),
    [anon_sym_LPAREN2] = ACTIONS(2753),
    [anon_sym_TILDE] = ACTIONS(2753),
    [anon_sym_STAR] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2751),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym___extension__] = ACTIONS(2751),
    [anon_sym_typedef] = ACTIONS(2751),
    [anon_sym_virtual] = ACTIONS(2751),
    [anon_sym_extern] = ACTIONS(2751),
    [anon_sym___attribute__] = ACTIONS(2751),
    [anon_sym___attribute] = ACTIONS(2751),
    [anon_sym_COLON_COLON] = ACTIONS(2753),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2753),
    [anon_sym___declspec] = ACTIONS(2751),
    [anon_sym___based] = ACTIONS(2751),
    [anon_sym_RBRACE] = ACTIONS(2753),
    [anon_sym_signed] = ACTIONS(2751),
    [anon_sym_unsigned] = ACTIONS(2751),
    [anon_sym_long] = ACTIONS(2751),
    [anon_sym_short] = ACTIONS(2751),
    [anon_sym_LBRACK] = ACTIONS(2751),
    [anon_sym_static] = ACTIONS(2751),
    [anon_sym_register] = ACTIONS(2751),
    [anon_sym_inline] = ACTIONS(2751),
    [anon_sym___inline] = ACTIONS(2751),
    [anon_sym___inline__] = ACTIONS(2751),
    [anon_sym___forceinline] = ACTIONS(2751),
    [anon_sym_thread_local] = ACTIONS(2751),
    [anon_sym___thread] = ACTIONS(2751),
    [anon_sym_const] = ACTIONS(2751),
    [anon_sym_constexpr] = ACTIONS(2751),
    [anon_sym_volatile] = ACTIONS(2751),
    [anon_sym_restrict] = ACTIONS(2751),
    [anon_sym___restrict__] = ACTIONS(2751),
    [anon_sym__Atomic] = ACTIONS(2751),
    [anon_sym__Noreturn] = ACTIONS(2751),
    [anon_sym_noreturn] = ACTIONS(2751),
    [anon_sym__Nonnull] = ACTIONS(2751),
    [anon_sym_mutable] = ACTIONS(2751),
    [anon_sym_constinit] = ACTIONS(2751),
    [anon_sym_consteval] = ACTIONS(2751),
    [anon_sym_alignas] = ACTIONS(2751),
    [anon_sym__Alignas] = ACTIONS(2751),
    [sym_primitive_type] = ACTIONS(2751),
    [anon_sym_enum] = ACTIONS(2751),
    [anon_sym_class] = ACTIONS(2751),
    [anon_sym_struct] = ACTIONS(2751),
    [anon_sym_union] = ACTIONS(2751),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2751),
    [anon_sym_decltype] = ACTIONS(2751),
    [anon_sym_explicit] = ACTIONS(2751),
    [anon_sym_typename] = ACTIONS(2751),
    [anon_sym_template] = ACTIONS(2751),
    [anon_sym_operator] = ACTIONS(2751),
    [anon_sym_friend] = ACTIONS(2751),
    [anon_sym_public] = ACTIONS(2751),
    [anon_sym_private] = ACTIONS(2751),
    [anon_sym_protected] = ACTIONS(2751),
    [anon_sym_using] = ACTIONS(2751),
    [anon_sym_static_assert] = ACTIONS(2751),
  },
  [1967] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1628),
    [sym_identifier] = ACTIONS(4984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4981),
    [anon_sym_COMMA] = ACTIONS(4981),
    [aux_sym_preproc_if_token2] = ACTIONS(4981),
    [aux_sym_preproc_else_token1] = ACTIONS(4981),
    [aux_sym_preproc_elif_token1] = ACTIONS(4984),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4981),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4981),
    [anon_sym_LPAREN2] = ACTIONS(4981),
    [anon_sym_DASH] = ACTIONS(4984),
    [anon_sym_PLUS] = ACTIONS(4984),
    [anon_sym_STAR] = ACTIONS(4981),
    [anon_sym_SLASH] = ACTIONS(4984),
    [anon_sym_PERCENT] = ACTIONS(4981),
    [anon_sym_PIPE_PIPE] = ACTIONS(4981),
    [anon_sym_AMP_AMP] = ACTIONS(4981),
    [anon_sym_PIPE] = ACTIONS(4984),
    [anon_sym_CARET] = ACTIONS(4981),
    [anon_sym_AMP] = ACTIONS(4984),
    [anon_sym_EQ_EQ] = ACTIONS(4981),
    [anon_sym_BANG_EQ] = ACTIONS(4981),
    [anon_sym_GT] = ACTIONS(4984),
    [anon_sym_GT_EQ] = ACTIONS(4981),
    [anon_sym_LT_EQ] = ACTIONS(4984),
    [anon_sym_LT] = ACTIONS(4984),
    [anon_sym_LT_LT] = ACTIONS(4981),
    [anon_sym_GT_GT] = ACTIONS(4981),
    [anon_sym___extension__] = ACTIONS(4932),
    [anon_sym___attribute__] = ACTIONS(4984),
    [anon_sym___attribute] = ACTIONS(4984),
    [anon_sym_LBRACE] = ACTIONS(4981),
    [anon_sym_signed] = ACTIONS(5231),
    [anon_sym_unsigned] = ACTIONS(5231),
    [anon_sym_long] = ACTIONS(5231),
    [anon_sym_short] = ACTIONS(5231),
    [anon_sym_LBRACK] = ACTIONS(4981),
    [anon_sym_const] = ACTIONS(4932),
    [anon_sym_constexpr] = ACTIONS(4932),
    [anon_sym_volatile] = ACTIONS(4932),
    [anon_sym_restrict] = ACTIONS(4932),
    [anon_sym___restrict__] = ACTIONS(4932),
    [anon_sym__Atomic] = ACTIONS(4932),
    [anon_sym__Noreturn] = ACTIONS(4932),
    [anon_sym_noreturn] = ACTIONS(4932),
    [anon_sym__Nonnull] = ACTIONS(4932),
    [anon_sym_mutable] = ACTIONS(4932),
    [anon_sym_constinit] = ACTIONS(4932),
    [anon_sym_consteval] = ACTIONS(4932),
    [anon_sym_alignas] = ACTIONS(4932),
    [anon_sym__Alignas] = ACTIONS(4932),
    [sym_primitive_type] = ACTIONS(4932),
    [anon_sym_QMARK] = ACTIONS(4981),
    [anon_sym_LT_EQ_GT] = ACTIONS(4981),
    [anon_sym_or] = ACTIONS(4984),
    [anon_sym_and] = ACTIONS(4984),
    [anon_sym_bitor] = ACTIONS(4984),
    [anon_sym_xor] = ACTIONS(4984),
    [anon_sym_bitand] = ACTIONS(4984),
    [anon_sym_not_eq] = ACTIONS(4984),
    [anon_sym_DASH_DASH] = ACTIONS(4981),
    [anon_sym_PLUS_PLUS] = ACTIONS(4981),
    [anon_sym_DOT] = ACTIONS(4984),
    [anon_sym_DOT_STAR] = ACTIONS(4981),
    [anon_sym_DASH_GT] = ACTIONS(4981),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4984),
    [anon_sym_decltype] = ACTIONS(4984),
  },
  [1968] = {
    [sym_identifier] = ACTIONS(2834),
    [aux_sym_preproc_def_token1] = ACTIONS(2834),
    [aux_sym_preproc_if_token1] = ACTIONS(2834),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2834),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2834),
    [sym_preproc_directive] = ACTIONS(2834),
    [anon_sym_LPAREN2] = ACTIONS(2836),
    [anon_sym_TILDE] = ACTIONS(2836),
    [anon_sym_STAR] = ACTIONS(2836),
    [anon_sym_AMP_AMP] = ACTIONS(2836),
    [anon_sym_AMP] = ACTIONS(2834),
    [anon_sym_SEMI] = ACTIONS(2836),
    [anon_sym___extension__] = ACTIONS(2834),
    [anon_sym_typedef] = ACTIONS(2834),
    [anon_sym_virtual] = ACTIONS(2834),
    [anon_sym_extern] = ACTIONS(2834),
    [anon_sym___attribute__] = ACTIONS(2834),
    [anon_sym___attribute] = ACTIONS(2834),
    [anon_sym_COLON_COLON] = ACTIONS(2836),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2836),
    [anon_sym___declspec] = ACTIONS(2834),
    [anon_sym___based] = ACTIONS(2834),
    [anon_sym_RBRACE] = ACTIONS(2836),
    [anon_sym_signed] = ACTIONS(2834),
    [anon_sym_unsigned] = ACTIONS(2834),
    [anon_sym_long] = ACTIONS(2834),
    [anon_sym_short] = ACTIONS(2834),
    [anon_sym_LBRACK] = ACTIONS(2834),
    [anon_sym_static] = ACTIONS(2834),
    [anon_sym_register] = ACTIONS(2834),
    [anon_sym_inline] = ACTIONS(2834),
    [anon_sym___inline] = ACTIONS(2834),
    [anon_sym___inline__] = ACTIONS(2834),
    [anon_sym___forceinline] = ACTIONS(2834),
    [anon_sym_thread_local] = ACTIONS(2834),
    [anon_sym___thread] = ACTIONS(2834),
    [anon_sym_const] = ACTIONS(2834),
    [anon_sym_constexpr] = ACTIONS(2834),
    [anon_sym_volatile] = ACTIONS(2834),
    [anon_sym_restrict] = ACTIONS(2834),
    [anon_sym___restrict__] = ACTIONS(2834),
    [anon_sym__Atomic] = ACTIONS(2834),
    [anon_sym__Noreturn] = ACTIONS(2834),
    [anon_sym_noreturn] = ACTIONS(2834),
    [anon_sym__Nonnull] = ACTIONS(2834),
    [anon_sym_mutable] = ACTIONS(2834),
    [anon_sym_constinit] = ACTIONS(2834),
    [anon_sym_consteval] = ACTIONS(2834),
    [anon_sym_alignas] = ACTIONS(2834),
    [anon_sym__Alignas] = ACTIONS(2834),
    [sym_primitive_type] = ACTIONS(2834),
    [anon_sym_enum] = ACTIONS(2834),
    [anon_sym_class] = ACTIONS(2834),
    [anon_sym_struct] = ACTIONS(2834),
    [anon_sym_union] = ACTIONS(2834),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2834),
    [anon_sym_decltype] = ACTIONS(2834),
    [anon_sym_explicit] = ACTIONS(2834),
    [anon_sym_typename] = ACTIONS(2834),
    [anon_sym_template] = ACTIONS(2834),
    [anon_sym_operator] = ACTIONS(2834),
    [anon_sym_friend] = ACTIONS(2834),
    [anon_sym_public] = ACTIONS(2834),
    [anon_sym_private] = ACTIONS(2834),
    [anon_sym_protected] = ACTIONS(2834),
    [anon_sym_using] = ACTIONS(2834),
    [anon_sym_static_assert] = ACTIONS(2834),
  },
  [1969] = {
    [sym_identifier] = ACTIONS(2838),
    [aux_sym_preproc_def_token1] = ACTIONS(2838),
    [aux_sym_preproc_if_token1] = ACTIONS(2838),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2838),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2838),
    [sym_preproc_directive] = ACTIONS(2838),
    [anon_sym_LPAREN2] = ACTIONS(2840),
    [anon_sym_TILDE] = ACTIONS(2840),
    [anon_sym_STAR] = ACTIONS(2840),
    [anon_sym_AMP_AMP] = ACTIONS(2840),
    [anon_sym_AMP] = ACTIONS(2838),
    [anon_sym_SEMI] = ACTIONS(2840),
    [anon_sym___extension__] = ACTIONS(2838),
    [anon_sym_typedef] = ACTIONS(2838),
    [anon_sym_virtual] = ACTIONS(2838),
    [anon_sym_extern] = ACTIONS(2838),
    [anon_sym___attribute__] = ACTIONS(2838),
    [anon_sym___attribute] = ACTIONS(2838),
    [anon_sym_COLON_COLON] = ACTIONS(2840),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2840),
    [anon_sym___declspec] = ACTIONS(2838),
    [anon_sym___based] = ACTIONS(2838),
    [anon_sym_RBRACE] = ACTIONS(2840),
    [anon_sym_signed] = ACTIONS(2838),
    [anon_sym_unsigned] = ACTIONS(2838),
    [anon_sym_long] = ACTIONS(2838),
    [anon_sym_short] = ACTIONS(2838),
    [anon_sym_LBRACK] = ACTIONS(2838),
    [anon_sym_static] = ACTIONS(2838),
    [anon_sym_register] = ACTIONS(2838),
    [anon_sym_inline] = ACTIONS(2838),
    [anon_sym___inline] = ACTIONS(2838),
    [anon_sym___inline__] = ACTIONS(2838),
    [anon_sym___forceinline] = ACTIONS(2838),
    [anon_sym_thread_local] = ACTIONS(2838),
    [anon_sym___thread] = ACTIONS(2838),
    [anon_sym_const] = ACTIONS(2838),
    [anon_sym_constexpr] = ACTIONS(2838),
    [anon_sym_volatile] = ACTIONS(2838),
    [anon_sym_restrict] = ACTIONS(2838),
    [anon_sym___restrict__] = ACTIONS(2838),
    [anon_sym__Atomic] = ACTIONS(2838),
    [anon_sym__Noreturn] = ACTIONS(2838),
    [anon_sym_noreturn] = ACTIONS(2838),
    [anon_sym__Nonnull] = ACTIONS(2838),
    [anon_sym_mutable] = ACTIONS(2838),
    [anon_sym_constinit] = ACTIONS(2838),
    [anon_sym_consteval] = ACTIONS(2838),
    [anon_sym_alignas] = ACTIONS(2838),
    [anon_sym__Alignas] = ACTIONS(2838),
    [sym_primitive_type] = ACTIONS(2838),
    [anon_sym_enum] = ACTIONS(2838),
    [anon_sym_class] = ACTIONS(2838),
    [anon_sym_struct] = ACTIONS(2838),
    [anon_sym_union] = ACTIONS(2838),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2838),
    [anon_sym_decltype] = ACTIONS(2838),
    [anon_sym_explicit] = ACTIONS(2838),
    [anon_sym_typename] = ACTIONS(2838),
    [anon_sym_template] = ACTIONS(2838),
    [anon_sym_operator] = ACTIONS(2838),
    [anon_sym_friend] = ACTIONS(2838),
    [anon_sym_public] = ACTIONS(2838),
    [anon_sym_private] = ACTIONS(2838),
    [anon_sym_protected] = ACTIONS(2838),
    [anon_sym_using] = ACTIONS(2838),
    [anon_sym_static_assert] = ACTIONS(2838),
  },
  [1970] = {
    [sym_identifier] = ACTIONS(2842),
    [aux_sym_preproc_def_token1] = ACTIONS(2842),
    [aux_sym_preproc_if_token1] = ACTIONS(2842),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2842),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2842),
    [sym_preproc_directive] = ACTIONS(2842),
    [anon_sym_LPAREN2] = ACTIONS(2844),
    [anon_sym_TILDE] = ACTIONS(2844),
    [anon_sym_STAR] = ACTIONS(2844),
    [anon_sym_AMP_AMP] = ACTIONS(2844),
    [anon_sym_AMP] = ACTIONS(2842),
    [anon_sym_SEMI] = ACTIONS(2844),
    [anon_sym___extension__] = ACTIONS(2842),
    [anon_sym_typedef] = ACTIONS(2842),
    [anon_sym_virtual] = ACTIONS(2842),
    [anon_sym_extern] = ACTIONS(2842),
    [anon_sym___attribute__] = ACTIONS(2842),
    [anon_sym___attribute] = ACTIONS(2842),
    [anon_sym_COLON_COLON] = ACTIONS(2844),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2844),
    [anon_sym___declspec] = ACTIONS(2842),
    [anon_sym___based] = ACTIONS(2842),
    [anon_sym_RBRACE] = ACTIONS(2844),
    [anon_sym_signed] = ACTIONS(2842),
    [anon_sym_unsigned] = ACTIONS(2842),
    [anon_sym_long] = ACTIONS(2842),
    [anon_sym_short] = ACTIONS(2842),
    [anon_sym_LBRACK] = ACTIONS(2842),
    [anon_sym_static] = ACTIONS(2842),
    [anon_sym_register] = ACTIONS(2842),
    [anon_sym_inline] = ACTIONS(2842),
    [anon_sym___inline] = ACTIONS(2842),
    [anon_sym___inline__] = ACTIONS(2842),
    [anon_sym___forceinline] = ACTIONS(2842),
    [anon_sym_thread_local] = ACTIONS(2842),
    [anon_sym___thread] = ACTIONS(2842),
    [anon_sym_const] = ACTIONS(2842),
    [anon_sym_constexpr] = ACTIONS(2842),
    [anon_sym_volatile] = ACTIONS(2842),
    [anon_sym_restrict] = ACTIONS(2842),
    [anon_sym___restrict__] = ACTIONS(2842),
    [anon_sym__Atomic] = ACTIONS(2842),
    [anon_sym__Noreturn] = ACTIONS(2842),
    [anon_sym_noreturn] = ACTIONS(2842),
    [anon_sym__Nonnull] = ACTIONS(2842),
    [anon_sym_mutable] = ACTIONS(2842),
    [anon_sym_constinit] = ACTIONS(2842),
    [anon_sym_consteval] = ACTIONS(2842),
    [anon_sym_alignas] = ACTIONS(2842),
    [anon_sym__Alignas] = ACTIONS(2842),
    [sym_primitive_type] = ACTIONS(2842),
    [anon_sym_enum] = ACTIONS(2842),
    [anon_sym_class] = ACTIONS(2842),
    [anon_sym_struct] = ACTIONS(2842),
    [anon_sym_union] = ACTIONS(2842),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2842),
    [anon_sym_decltype] = ACTIONS(2842),
    [anon_sym_explicit] = ACTIONS(2842),
    [anon_sym_typename] = ACTIONS(2842),
    [anon_sym_template] = ACTIONS(2842),
    [anon_sym_operator] = ACTIONS(2842),
    [anon_sym_friend] = ACTIONS(2842),
    [anon_sym_public] = ACTIONS(2842),
    [anon_sym_private] = ACTIONS(2842),
    [anon_sym_protected] = ACTIONS(2842),
    [anon_sym_using] = ACTIONS(2842),
    [anon_sym_static_assert] = ACTIONS(2842),
  },
  [1971] = {
    [sym_identifier] = ACTIONS(2846),
    [aux_sym_preproc_def_token1] = ACTIONS(2846),
    [aux_sym_preproc_if_token1] = ACTIONS(2846),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2846),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2846),
    [sym_preproc_directive] = ACTIONS(2846),
    [anon_sym_LPAREN2] = ACTIONS(2848),
    [anon_sym_TILDE] = ACTIONS(2848),
    [anon_sym_STAR] = ACTIONS(2848),
    [anon_sym_AMP_AMP] = ACTIONS(2848),
    [anon_sym_AMP] = ACTIONS(2846),
    [anon_sym_SEMI] = ACTIONS(2848),
    [anon_sym___extension__] = ACTIONS(2846),
    [anon_sym_typedef] = ACTIONS(2846),
    [anon_sym_virtual] = ACTIONS(2846),
    [anon_sym_extern] = ACTIONS(2846),
    [anon_sym___attribute__] = ACTIONS(2846),
    [anon_sym___attribute] = ACTIONS(2846),
    [anon_sym_COLON_COLON] = ACTIONS(2848),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2848),
    [anon_sym___declspec] = ACTIONS(2846),
    [anon_sym___based] = ACTIONS(2846),
    [anon_sym_RBRACE] = ACTIONS(2848),
    [anon_sym_signed] = ACTIONS(2846),
    [anon_sym_unsigned] = ACTIONS(2846),
    [anon_sym_long] = ACTIONS(2846),
    [anon_sym_short] = ACTIONS(2846),
    [anon_sym_LBRACK] = ACTIONS(2846),
    [anon_sym_static] = ACTIONS(2846),
    [anon_sym_register] = ACTIONS(2846),
    [anon_sym_inline] = ACTIONS(2846),
    [anon_sym___inline] = ACTIONS(2846),
    [anon_sym___inline__] = ACTIONS(2846),
    [anon_sym___forceinline] = ACTIONS(2846),
    [anon_sym_thread_local] = ACTIONS(2846),
    [anon_sym___thread] = ACTIONS(2846),
    [anon_sym_const] = ACTIONS(2846),
    [anon_sym_constexpr] = ACTIONS(2846),
    [anon_sym_volatile] = ACTIONS(2846),
    [anon_sym_restrict] = ACTIONS(2846),
    [anon_sym___restrict__] = ACTIONS(2846),
    [anon_sym__Atomic] = ACTIONS(2846),
    [anon_sym__Noreturn] = ACTIONS(2846),
    [anon_sym_noreturn] = ACTIONS(2846),
    [anon_sym__Nonnull] = ACTIONS(2846),
    [anon_sym_mutable] = ACTIONS(2846),
    [anon_sym_constinit] = ACTIONS(2846),
    [anon_sym_consteval] = ACTIONS(2846),
    [anon_sym_alignas] = ACTIONS(2846),
    [anon_sym__Alignas] = ACTIONS(2846),
    [sym_primitive_type] = ACTIONS(2846),
    [anon_sym_enum] = ACTIONS(2846),
    [anon_sym_class] = ACTIONS(2846),
    [anon_sym_struct] = ACTIONS(2846),
    [anon_sym_union] = ACTIONS(2846),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2846),
    [anon_sym_decltype] = ACTIONS(2846),
    [anon_sym_explicit] = ACTIONS(2846),
    [anon_sym_typename] = ACTIONS(2846),
    [anon_sym_template] = ACTIONS(2846),
    [anon_sym_operator] = ACTIONS(2846),
    [anon_sym_friend] = ACTIONS(2846),
    [anon_sym_public] = ACTIONS(2846),
    [anon_sym_private] = ACTIONS(2846),
    [anon_sym_protected] = ACTIONS(2846),
    [anon_sym_using] = ACTIONS(2846),
    [anon_sym_static_assert] = ACTIONS(2846),
  },
  [1972] = {
    [sym_identifier] = ACTIONS(2850),
    [aux_sym_preproc_def_token1] = ACTIONS(2850),
    [aux_sym_preproc_if_token1] = ACTIONS(2850),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2850),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2850),
    [sym_preproc_directive] = ACTIONS(2850),
    [anon_sym_LPAREN2] = ACTIONS(2852),
    [anon_sym_TILDE] = ACTIONS(2852),
    [anon_sym_STAR] = ACTIONS(2852),
    [anon_sym_AMP_AMP] = ACTIONS(2852),
    [anon_sym_AMP] = ACTIONS(2850),
    [anon_sym_SEMI] = ACTIONS(2852),
    [anon_sym___extension__] = ACTIONS(2850),
    [anon_sym_typedef] = ACTIONS(2850),
    [anon_sym_virtual] = ACTIONS(2850),
    [anon_sym_extern] = ACTIONS(2850),
    [anon_sym___attribute__] = ACTIONS(2850),
    [anon_sym___attribute] = ACTIONS(2850),
    [anon_sym_COLON_COLON] = ACTIONS(2852),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2852),
    [anon_sym___declspec] = ACTIONS(2850),
    [anon_sym___based] = ACTIONS(2850),
    [anon_sym_RBRACE] = ACTIONS(2852),
    [anon_sym_signed] = ACTIONS(2850),
    [anon_sym_unsigned] = ACTIONS(2850),
    [anon_sym_long] = ACTIONS(2850),
    [anon_sym_short] = ACTIONS(2850),
    [anon_sym_LBRACK] = ACTIONS(2850),
    [anon_sym_static] = ACTIONS(2850),
    [anon_sym_register] = ACTIONS(2850),
    [anon_sym_inline] = ACTIONS(2850),
    [anon_sym___inline] = ACTIONS(2850),
    [anon_sym___inline__] = ACTIONS(2850),
    [anon_sym___forceinline] = ACTIONS(2850),
    [anon_sym_thread_local] = ACTIONS(2850),
    [anon_sym___thread] = ACTIONS(2850),
    [anon_sym_const] = ACTIONS(2850),
    [anon_sym_constexpr] = ACTIONS(2850),
    [anon_sym_volatile] = ACTIONS(2850),
    [anon_sym_restrict] = ACTIONS(2850),
    [anon_sym___restrict__] = ACTIONS(2850),
    [anon_sym__Atomic] = ACTIONS(2850),
    [anon_sym__Noreturn] = ACTIONS(2850),
    [anon_sym_noreturn] = ACTIONS(2850),
    [anon_sym__Nonnull] = ACTIONS(2850),
    [anon_sym_mutable] = ACTIONS(2850),
    [anon_sym_constinit] = ACTIONS(2850),
    [anon_sym_consteval] = ACTIONS(2850),
    [anon_sym_alignas] = ACTIONS(2850),
    [anon_sym__Alignas] = ACTIONS(2850),
    [sym_primitive_type] = ACTIONS(2850),
    [anon_sym_enum] = ACTIONS(2850),
    [anon_sym_class] = ACTIONS(2850),
    [anon_sym_struct] = ACTIONS(2850),
    [anon_sym_union] = ACTIONS(2850),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2850),
    [anon_sym_decltype] = ACTIONS(2850),
    [anon_sym_explicit] = ACTIONS(2850),
    [anon_sym_typename] = ACTIONS(2850),
    [anon_sym_template] = ACTIONS(2850),
    [anon_sym_operator] = ACTIONS(2850),
    [anon_sym_friend] = ACTIONS(2850),
    [anon_sym_public] = ACTIONS(2850),
    [anon_sym_private] = ACTIONS(2850),
    [anon_sym_protected] = ACTIONS(2850),
    [anon_sym_using] = ACTIONS(2850),
    [anon_sym_static_assert] = ACTIONS(2850),
  },
  [1973] = {
    [sym_identifier] = ACTIONS(2920),
    [aux_sym_preproc_def_token1] = ACTIONS(2920),
    [aux_sym_preproc_if_token1] = ACTIONS(2920),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2920),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2920),
    [sym_preproc_directive] = ACTIONS(2920),
    [anon_sym_LPAREN2] = ACTIONS(2922),
    [anon_sym_TILDE] = ACTIONS(2922),
    [anon_sym_STAR] = ACTIONS(2922),
    [anon_sym_AMP_AMP] = ACTIONS(2922),
    [anon_sym_AMP] = ACTIONS(2920),
    [anon_sym_SEMI] = ACTIONS(2922),
    [anon_sym___extension__] = ACTIONS(2920),
    [anon_sym_typedef] = ACTIONS(2920),
    [anon_sym_virtual] = ACTIONS(2920),
    [anon_sym_extern] = ACTIONS(2920),
    [anon_sym___attribute__] = ACTIONS(2920),
    [anon_sym___attribute] = ACTIONS(2920),
    [anon_sym_COLON_COLON] = ACTIONS(2922),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2922),
    [anon_sym___declspec] = ACTIONS(2920),
    [anon_sym___based] = ACTIONS(2920),
    [anon_sym_RBRACE] = ACTIONS(2922),
    [anon_sym_signed] = ACTIONS(2920),
    [anon_sym_unsigned] = ACTIONS(2920),
    [anon_sym_long] = ACTIONS(2920),
    [anon_sym_short] = ACTIONS(2920),
    [anon_sym_LBRACK] = ACTIONS(2920),
    [anon_sym_static] = ACTIONS(2920),
    [anon_sym_register] = ACTIONS(2920),
    [anon_sym_inline] = ACTIONS(2920),
    [anon_sym___inline] = ACTIONS(2920),
    [anon_sym___inline__] = ACTIONS(2920),
    [anon_sym___forceinline] = ACTIONS(2920),
    [anon_sym_thread_local] = ACTIONS(2920),
    [anon_sym___thread] = ACTIONS(2920),
    [anon_sym_const] = ACTIONS(2920),
    [anon_sym_constexpr] = ACTIONS(2920),
    [anon_sym_volatile] = ACTIONS(2920),
    [anon_sym_restrict] = ACTIONS(2920),
    [anon_sym___restrict__] = ACTIONS(2920),
    [anon_sym__Atomic] = ACTIONS(2920),
    [anon_sym__Noreturn] = ACTIONS(2920),
    [anon_sym_noreturn] = ACTIONS(2920),
    [anon_sym__Nonnull] = ACTIONS(2920),
    [anon_sym_mutable] = ACTIONS(2920),
    [anon_sym_constinit] = ACTIONS(2920),
    [anon_sym_consteval] = ACTIONS(2920),
    [anon_sym_alignas] = ACTIONS(2920),
    [anon_sym__Alignas] = ACTIONS(2920),
    [sym_primitive_type] = ACTIONS(2920),
    [anon_sym_enum] = ACTIONS(2920),
    [anon_sym_class] = ACTIONS(2920),
    [anon_sym_struct] = ACTIONS(2920),
    [anon_sym_union] = ACTIONS(2920),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2920),
    [anon_sym_decltype] = ACTIONS(2920),
    [anon_sym_explicit] = ACTIONS(2920),
    [anon_sym_typename] = ACTIONS(2920),
    [anon_sym_template] = ACTIONS(2920),
    [anon_sym_operator] = ACTIONS(2920),
    [anon_sym_friend] = ACTIONS(2920),
    [anon_sym_public] = ACTIONS(2920),
    [anon_sym_private] = ACTIONS(2920),
    [anon_sym_protected] = ACTIONS(2920),
    [anon_sym_using] = ACTIONS(2920),
    [anon_sym_static_assert] = ACTIONS(2920),
  },
  [1974] = {
    [sym_identifier] = ACTIONS(2924),
    [aux_sym_preproc_def_token1] = ACTIONS(2924),
    [aux_sym_preproc_if_token1] = ACTIONS(2924),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2924),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2924),
    [sym_preproc_directive] = ACTIONS(2924),
    [anon_sym_LPAREN2] = ACTIONS(2926),
    [anon_sym_TILDE] = ACTIONS(2926),
    [anon_sym_STAR] = ACTIONS(2926),
    [anon_sym_AMP_AMP] = ACTIONS(2926),
    [anon_sym_AMP] = ACTIONS(2924),
    [anon_sym_SEMI] = ACTIONS(2926),
    [anon_sym___extension__] = ACTIONS(2924),
    [anon_sym_typedef] = ACTIONS(2924),
    [anon_sym_virtual] = ACTIONS(2924),
    [anon_sym_extern] = ACTIONS(2924),
    [anon_sym___attribute__] = ACTIONS(2924),
    [anon_sym___attribute] = ACTIONS(2924),
    [anon_sym_COLON_COLON] = ACTIONS(2926),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2926),
    [anon_sym___declspec] = ACTIONS(2924),
    [anon_sym___based] = ACTIONS(2924),
    [anon_sym_RBRACE] = ACTIONS(2926),
    [anon_sym_signed] = ACTIONS(2924),
    [anon_sym_unsigned] = ACTIONS(2924),
    [anon_sym_long] = ACTIONS(2924),
    [anon_sym_short] = ACTIONS(2924),
    [anon_sym_LBRACK] = ACTIONS(2924),
    [anon_sym_static] = ACTIONS(2924),
    [anon_sym_register] = ACTIONS(2924),
    [anon_sym_inline] = ACTIONS(2924),
    [anon_sym___inline] = ACTIONS(2924),
    [anon_sym___inline__] = ACTIONS(2924),
    [anon_sym___forceinline] = ACTIONS(2924),
    [anon_sym_thread_local] = ACTIONS(2924),
    [anon_sym___thread] = ACTIONS(2924),
    [anon_sym_const] = ACTIONS(2924),
    [anon_sym_constexpr] = ACTIONS(2924),
    [anon_sym_volatile] = ACTIONS(2924),
    [anon_sym_restrict] = ACTIONS(2924),
    [anon_sym___restrict__] = ACTIONS(2924),
    [anon_sym__Atomic] = ACTIONS(2924),
    [anon_sym__Noreturn] = ACTIONS(2924),
    [anon_sym_noreturn] = ACTIONS(2924),
    [anon_sym__Nonnull] = ACTIONS(2924),
    [anon_sym_mutable] = ACTIONS(2924),
    [anon_sym_constinit] = ACTIONS(2924),
    [anon_sym_consteval] = ACTIONS(2924),
    [anon_sym_alignas] = ACTIONS(2924),
    [anon_sym__Alignas] = ACTIONS(2924),
    [sym_primitive_type] = ACTIONS(2924),
    [anon_sym_enum] = ACTIONS(2924),
    [anon_sym_class] = ACTIONS(2924),
    [anon_sym_struct] = ACTIONS(2924),
    [anon_sym_union] = ACTIONS(2924),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2924),
    [anon_sym_decltype] = ACTIONS(2924),
    [anon_sym_explicit] = ACTIONS(2924),
    [anon_sym_typename] = ACTIONS(2924),
    [anon_sym_template] = ACTIONS(2924),
    [anon_sym_operator] = ACTIONS(2924),
    [anon_sym_friend] = ACTIONS(2924),
    [anon_sym_public] = ACTIONS(2924),
    [anon_sym_private] = ACTIONS(2924),
    [anon_sym_protected] = ACTIONS(2924),
    [anon_sym_using] = ACTIONS(2924),
    [anon_sym_static_assert] = ACTIONS(2924),
  },
  [1975] = {
    [sym_identifier] = ACTIONS(2613),
    [aux_sym_preproc_def_token1] = ACTIONS(2613),
    [aux_sym_preproc_if_token1] = ACTIONS(2613),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2613),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2613),
    [sym_preproc_directive] = ACTIONS(2613),
    [anon_sym_LPAREN2] = ACTIONS(2615),
    [anon_sym_TILDE] = ACTIONS(2615),
    [anon_sym_STAR] = ACTIONS(2615),
    [anon_sym_AMP_AMP] = ACTIONS(2615),
    [anon_sym_AMP] = ACTIONS(2613),
    [anon_sym_SEMI] = ACTIONS(2615),
    [anon_sym___extension__] = ACTIONS(2613),
    [anon_sym_typedef] = ACTIONS(2613),
    [anon_sym_virtual] = ACTIONS(2613),
    [anon_sym_extern] = ACTIONS(2613),
    [anon_sym___attribute__] = ACTIONS(2613),
    [anon_sym___attribute] = ACTIONS(2613),
    [anon_sym_COLON_COLON] = ACTIONS(2615),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2615),
    [anon_sym___declspec] = ACTIONS(2613),
    [anon_sym___based] = ACTIONS(2613),
    [anon_sym_RBRACE] = ACTIONS(2615),
    [anon_sym_signed] = ACTIONS(2613),
    [anon_sym_unsigned] = ACTIONS(2613),
    [anon_sym_long] = ACTIONS(2613),
    [anon_sym_short] = ACTIONS(2613),
    [anon_sym_LBRACK] = ACTIONS(2613),
    [anon_sym_static] = ACTIONS(2613),
    [anon_sym_register] = ACTIONS(2613),
    [anon_sym_inline] = ACTIONS(2613),
    [anon_sym___inline] = ACTIONS(2613),
    [anon_sym___inline__] = ACTIONS(2613),
    [anon_sym___forceinline] = ACTIONS(2613),
    [anon_sym_thread_local] = ACTIONS(2613),
    [anon_sym___thread] = ACTIONS(2613),
    [anon_sym_const] = ACTIONS(2613),
    [anon_sym_constexpr] = ACTIONS(2613),
    [anon_sym_volatile] = ACTIONS(2613),
    [anon_sym_restrict] = ACTIONS(2613),
    [anon_sym___restrict__] = ACTIONS(2613),
    [anon_sym__Atomic] = ACTIONS(2613),
    [anon_sym__Noreturn] = ACTIONS(2613),
    [anon_sym_noreturn] = ACTIONS(2613),
    [anon_sym__Nonnull] = ACTIONS(2613),
    [anon_sym_mutable] = ACTIONS(2613),
    [anon_sym_constinit] = ACTIONS(2613),
    [anon_sym_consteval] = ACTIONS(2613),
    [anon_sym_alignas] = ACTIONS(2613),
    [anon_sym__Alignas] = ACTIONS(2613),
    [sym_primitive_type] = ACTIONS(2613),
    [anon_sym_enum] = ACTIONS(2613),
    [anon_sym_class] = ACTIONS(2613),
    [anon_sym_struct] = ACTIONS(2613),
    [anon_sym_union] = ACTIONS(2613),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2613),
    [anon_sym_decltype] = ACTIONS(2613),
    [anon_sym_explicit] = ACTIONS(2613),
    [anon_sym_typename] = ACTIONS(2613),
    [anon_sym_template] = ACTIONS(2613),
    [anon_sym_operator] = ACTIONS(2613),
    [anon_sym_friend] = ACTIONS(2613),
    [anon_sym_public] = ACTIONS(2613),
    [anon_sym_private] = ACTIONS(2613),
    [anon_sym_protected] = ACTIONS(2613),
    [anon_sym_using] = ACTIONS(2613),
    [anon_sym_static_assert] = ACTIONS(2613),
  },
  [1976] = {
    [sym_attribute_specifier] = STATE(2265),
    [sym_enumerator_list] = STATE(2139),
    [sym_identifier] = ACTIONS(5848),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5850),
    [anon_sym_COMMA] = ACTIONS(5850),
    [anon_sym_RPAREN] = ACTIONS(5850),
    [aux_sym_preproc_if_token2] = ACTIONS(5850),
    [aux_sym_preproc_else_token1] = ACTIONS(5850),
    [aux_sym_preproc_elif_token1] = ACTIONS(5848),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5850),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5850),
    [anon_sym_LPAREN2] = ACTIONS(5850),
    [anon_sym_DASH] = ACTIONS(5848),
    [anon_sym_PLUS] = ACTIONS(5848),
    [anon_sym_STAR] = ACTIONS(5848),
    [anon_sym_SLASH] = ACTIONS(5848),
    [anon_sym_PERCENT] = ACTIONS(5848),
    [anon_sym_PIPE_PIPE] = ACTIONS(5850),
    [anon_sym_AMP_AMP] = ACTIONS(5850),
    [anon_sym_PIPE] = ACTIONS(5848),
    [anon_sym_CARET] = ACTIONS(5848),
    [anon_sym_AMP] = ACTIONS(5848),
    [anon_sym_EQ_EQ] = ACTIONS(5850),
    [anon_sym_BANG_EQ] = ACTIONS(5850),
    [anon_sym_GT] = ACTIONS(5848),
    [anon_sym_GT_EQ] = ACTIONS(5850),
    [anon_sym_LT_EQ] = ACTIONS(5848),
    [anon_sym_LT] = ACTIONS(5848),
    [anon_sym_LT_LT] = ACTIONS(5848),
    [anon_sym_GT_GT] = ACTIONS(5848),
    [anon_sym_SEMI] = ACTIONS(5850),
    [anon_sym___attribute__] = ACTIONS(5379),
    [anon_sym___attribute] = ACTIONS(5379),
    [anon_sym_LBRACE] = ACTIONS(5838),
    [anon_sym_RBRACE] = ACTIONS(5850),
    [anon_sym_LBRACK] = ACTIONS(5850),
    [anon_sym_RBRACK] = ACTIONS(5850),
    [anon_sym_EQ] = ACTIONS(5848),
    [anon_sym_COLON] = ACTIONS(5850),
    [anon_sym_QMARK] = ACTIONS(5850),
    [anon_sym_STAR_EQ] = ACTIONS(5850),
    [anon_sym_SLASH_EQ] = ACTIONS(5850),
    [anon_sym_PERCENT_EQ] = ACTIONS(5850),
    [anon_sym_PLUS_EQ] = ACTIONS(5850),
    [anon_sym_DASH_EQ] = ACTIONS(5850),
    [anon_sym_LT_LT_EQ] = ACTIONS(5850),
    [anon_sym_GT_GT_EQ] = ACTIONS(5850),
    [anon_sym_AMP_EQ] = ACTIONS(5850),
    [anon_sym_CARET_EQ] = ACTIONS(5850),
    [anon_sym_PIPE_EQ] = ACTIONS(5850),
    [anon_sym_and_eq] = ACTIONS(5848),
    [anon_sym_or_eq] = ACTIONS(5848),
    [anon_sym_xor_eq] = ACTIONS(5848),
    [anon_sym_LT_EQ_GT] = ACTIONS(5850),
    [anon_sym_or] = ACTIONS(5848),
    [anon_sym_and] = ACTIONS(5848),
    [anon_sym_bitor] = ACTIONS(5848),
    [anon_sym_xor] = ACTIONS(5848),
    [anon_sym_bitand] = ACTIONS(5848),
    [anon_sym_not_eq] = ACTIONS(5848),
    [anon_sym_DASH_DASH] = ACTIONS(5850),
    [anon_sym_PLUS_PLUS] = ACTIONS(5850),
    [anon_sym_DOT] = ACTIONS(5848),
    [anon_sym_DOT_STAR] = ACTIONS(5850),
    [anon_sym_DASH_GT] = ACTIONS(5850),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5848),
    [anon_sym_decltype] = ACTIONS(5848),
  },
  [1977] = {
    [sym_identifier] = ACTIONS(5478),
    [aux_sym_preproc_def_token1] = ACTIONS(5478),
    [aux_sym_preproc_if_token1] = ACTIONS(5478),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5478),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5478),
    [sym_preproc_directive] = ACTIONS(5478),
    [anon_sym_LPAREN2] = ACTIONS(5480),
    [anon_sym_TILDE] = ACTIONS(5480),
    [anon_sym_STAR] = ACTIONS(5480),
    [anon_sym_AMP_AMP] = ACTIONS(5480),
    [anon_sym_AMP] = ACTIONS(5478),
    [anon_sym_SEMI] = ACTIONS(5480),
    [anon_sym___extension__] = ACTIONS(5478),
    [anon_sym_typedef] = ACTIONS(5478),
    [anon_sym_virtual] = ACTIONS(5478),
    [anon_sym_extern] = ACTIONS(5478),
    [anon_sym___attribute__] = ACTIONS(5478),
    [anon_sym___attribute] = ACTIONS(5478),
    [anon_sym_COLON_COLON] = ACTIONS(5480),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5480),
    [anon_sym___declspec] = ACTIONS(5478),
    [anon_sym___based] = ACTIONS(5478),
    [anon_sym_RBRACE] = ACTIONS(5480),
    [anon_sym_signed] = ACTIONS(5478),
    [anon_sym_unsigned] = ACTIONS(5478),
    [anon_sym_long] = ACTIONS(5478),
    [anon_sym_short] = ACTIONS(5478),
    [anon_sym_LBRACK] = ACTIONS(5478),
    [anon_sym_static] = ACTIONS(5478),
    [anon_sym_register] = ACTIONS(5478),
    [anon_sym_inline] = ACTIONS(5478),
    [anon_sym___inline] = ACTIONS(5478),
    [anon_sym___inline__] = ACTIONS(5478),
    [anon_sym___forceinline] = ACTIONS(5478),
    [anon_sym_thread_local] = ACTIONS(5478),
    [anon_sym___thread] = ACTIONS(5478),
    [anon_sym_const] = ACTIONS(5478),
    [anon_sym_constexpr] = ACTIONS(5478),
    [anon_sym_volatile] = ACTIONS(5478),
    [anon_sym_restrict] = ACTIONS(5478),
    [anon_sym___restrict__] = ACTIONS(5478),
    [anon_sym__Atomic] = ACTIONS(5478),
    [anon_sym__Noreturn] = ACTIONS(5478),
    [anon_sym_noreturn] = ACTIONS(5478),
    [anon_sym__Nonnull] = ACTIONS(5478),
    [anon_sym_mutable] = ACTIONS(5478),
    [anon_sym_constinit] = ACTIONS(5478),
    [anon_sym_consteval] = ACTIONS(5478),
    [anon_sym_alignas] = ACTIONS(5478),
    [anon_sym__Alignas] = ACTIONS(5478),
    [sym_primitive_type] = ACTIONS(5478),
    [anon_sym_enum] = ACTIONS(5478),
    [anon_sym_class] = ACTIONS(5478),
    [anon_sym_struct] = ACTIONS(5478),
    [anon_sym_union] = ACTIONS(5478),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5478),
    [anon_sym_decltype] = ACTIONS(5478),
    [anon_sym_explicit] = ACTIONS(5478),
    [anon_sym_typename] = ACTIONS(5478),
    [anon_sym_template] = ACTIONS(5478),
    [anon_sym_operator] = ACTIONS(5478),
    [anon_sym_friend] = ACTIONS(5478),
    [anon_sym_public] = ACTIONS(5478),
    [anon_sym_private] = ACTIONS(5478),
    [anon_sym_protected] = ACTIONS(5478),
    [anon_sym_using] = ACTIONS(5478),
    [anon_sym_static_assert] = ACTIONS(5478),
  },
  [1978] = {
    [sym__declaration_modifiers] = STATE(3242),
    [sym_attribute_specifier] = STATE(3242),
    [sym_attribute_declaration] = STATE(3242),
    [sym_ms_declspec_modifier] = STATE(3242),
    [sym_storage_class_specifier] = STATE(3242),
    [sym_type_qualifier] = STATE(3242),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(3972),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2336),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(6476),
    [sym_qualified_type_identifier] = STATE(2788),
    [aux_sym__declaration_specifiers_repeat1] = STATE(3242),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2667),
    [sym_identifier] = ACTIONS(3758),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(5852),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(3766),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(3768),
    [anon_sym_unsigned] = ACTIONS(3768),
    [anon_sym_long] = ACTIONS(3768),
    [anon_sym_short] = ACTIONS(3768),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3770),
    [anon_sym_enum] = ACTIONS(3772),
    [anon_sym_class] = ACTIONS(3774),
    [anon_sym_struct] = ACTIONS(3776),
    [anon_sym_union] = ACTIONS(3778),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(3780),
    [anon_sym_template] = ACTIONS(1235),
  },
  [1979] = {
    [sym_string_literal] = STATE(3161),
    [sym_template_argument_list] = STATE(3643),
    [sym_raw_string_literal] = STATE(3161),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4035),
    [anon_sym_COMMA] = ACTIONS(4035),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_DASH] = ACTIONS(4043),
    [anon_sym_PLUS] = ACTIONS(4043),
    [anon_sym_STAR] = ACTIONS(4043),
    [anon_sym_SLASH] = ACTIONS(4043),
    [anon_sym_PERCENT] = ACTIONS(4043),
    [anon_sym_PIPE_PIPE] = ACTIONS(4035),
    [anon_sym_AMP_AMP] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4043),
    [anon_sym_CARET] = ACTIONS(4043),
    [anon_sym_AMP] = ACTIONS(4043),
    [anon_sym_EQ_EQ] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4043),
    [anon_sym_GT_EQ] = ACTIONS(4035),
    [anon_sym_LT_EQ] = ACTIONS(4043),
    [anon_sym_LT] = ACTIONS(4929),
    [anon_sym_LT_LT] = ACTIONS(4043),
    [anon_sym_GT_GT] = ACTIONS(4043),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym___attribute__] = ACTIONS(4035),
    [anon_sym___attribute] = ACTIONS(4043),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACE] = ACTIONS(4059),
    [anon_sym_LBRACK] = ACTIONS(4035),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_QMARK] = ACTIONS(4035),
    [anon_sym_STAR_EQ] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_PERCENT_EQ] = ACTIONS(5856),
    [anon_sym_PLUS_EQ] = ACTIONS(5856),
    [anon_sym_DASH_EQ] = ACTIONS(5856),
    [anon_sym_LT_LT_EQ] = ACTIONS(5856),
    [anon_sym_GT_GT_EQ] = ACTIONS(5856),
    [anon_sym_AMP_EQ] = ACTIONS(5856),
    [anon_sym_CARET_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_and_eq] = ACTIONS(5856),
    [anon_sym_or_eq] = ACTIONS(5856),
    [anon_sym_xor_eq] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(4035),
    [anon_sym_or] = ACTIONS(4043),
    [anon_sym_and] = ACTIONS(4043),
    [anon_sym_bitor] = ACTIONS(4035),
    [anon_sym_xor] = ACTIONS(4043),
    [anon_sym_bitand] = ACTIONS(4035),
    [anon_sym_not_eq] = ACTIONS(4035),
    [anon_sym_DASH_DASH] = ACTIONS(4035),
    [anon_sym_PLUS_PLUS] = ACTIONS(4035),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_DOT_STAR] = ACTIONS(4035),
    [anon_sym_DASH_GT] = ACTIONS(4035),
    [anon_sym_L_DQUOTE] = ACTIONS(5858),
    [anon_sym_u_DQUOTE] = ACTIONS(5858),
    [anon_sym_U_DQUOTE] = ACTIONS(5858),
    [anon_sym_u8_DQUOTE] = ACTIONS(5858),
    [anon_sym_DQUOTE] = ACTIONS(5858),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5860),
    [anon_sym_LR_DQUOTE] = ACTIONS(5860),
    [anon_sym_uR_DQUOTE] = ACTIONS(5860),
    [anon_sym_UR_DQUOTE] = ACTIONS(5860),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5860),
  },
  [1980] = {
    [sym_identifier] = ACTIONS(5482),
    [aux_sym_preproc_def_token1] = ACTIONS(5482),
    [aux_sym_preproc_if_token1] = ACTIONS(5482),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5482),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5482),
    [sym_preproc_directive] = ACTIONS(5482),
    [anon_sym_LPAREN2] = ACTIONS(5484),
    [anon_sym_TILDE] = ACTIONS(5484),
    [anon_sym_STAR] = ACTIONS(5484),
    [anon_sym_AMP_AMP] = ACTIONS(5484),
    [anon_sym_AMP] = ACTIONS(5482),
    [anon_sym_SEMI] = ACTIONS(5484),
    [anon_sym___extension__] = ACTIONS(5482),
    [anon_sym_typedef] = ACTIONS(5482),
    [anon_sym_virtual] = ACTIONS(5482),
    [anon_sym_extern] = ACTIONS(5482),
    [anon_sym___attribute__] = ACTIONS(5482),
    [anon_sym___attribute] = ACTIONS(5482),
    [anon_sym_COLON_COLON] = ACTIONS(5484),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5484),
    [anon_sym___declspec] = ACTIONS(5482),
    [anon_sym___based] = ACTIONS(5482),
    [anon_sym_RBRACE] = ACTIONS(5484),
    [anon_sym_signed] = ACTIONS(5482),
    [anon_sym_unsigned] = ACTIONS(5482),
    [anon_sym_long] = ACTIONS(5482),
    [anon_sym_short] = ACTIONS(5482),
    [anon_sym_LBRACK] = ACTIONS(5482),
    [anon_sym_static] = ACTIONS(5482),
    [anon_sym_register] = ACTIONS(5482),
    [anon_sym_inline] = ACTIONS(5482),
    [anon_sym___inline] = ACTIONS(5482),
    [anon_sym___inline__] = ACTIONS(5482),
    [anon_sym___forceinline] = ACTIONS(5482),
    [anon_sym_thread_local] = ACTIONS(5482),
    [anon_sym___thread] = ACTIONS(5482),
    [anon_sym_const] = ACTIONS(5482),
    [anon_sym_constexpr] = ACTIONS(5482),
    [anon_sym_volatile] = ACTIONS(5482),
    [anon_sym_restrict] = ACTIONS(5482),
    [anon_sym___restrict__] = ACTIONS(5482),
    [anon_sym__Atomic] = ACTIONS(5482),
    [anon_sym__Noreturn] = ACTIONS(5482),
    [anon_sym_noreturn] = ACTIONS(5482),
    [anon_sym__Nonnull] = ACTIONS(5482),
    [anon_sym_mutable] = ACTIONS(5482),
    [anon_sym_constinit] = ACTIONS(5482),
    [anon_sym_consteval] = ACTIONS(5482),
    [anon_sym_alignas] = ACTIONS(5482),
    [anon_sym__Alignas] = ACTIONS(5482),
    [sym_primitive_type] = ACTIONS(5482),
    [anon_sym_enum] = ACTIONS(5482),
    [anon_sym_class] = ACTIONS(5482),
    [anon_sym_struct] = ACTIONS(5482),
    [anon_sym_union] = ACTIONS(5482),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5482),
    [anon_sym_decltype] = ACTIONS(5482),
    [anon_sym_explicit] = ACTIONS(5482),
    [anon_sym_typename] = ACTIONS(5482),
    [anon_sym_template] = ACTIONS(5482),
    [anon_sym_operator] = ACTIONS(5482),
    [anon_sym_friend] = ACTIONS(5482),
    [anon_sym_public] = ACTIONS(5482),
    [anon_sym_private] = ACTIONS(5482),
    [anon_sym_protected] = ACTIONS(5482),
    [anon_sym_using] = ACTIONS(5482),
    [anon_sym_static_assert] = ACTIONS(5482),
  },
  [1981] = {
    [sym_identifier] = ACTIONS(5486),
    [aux_sym_preproc_def_token1] = ACTIONS(5486),
    [aux_sym_preproc_if_token1] = ACTIONS(5486),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5486),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5486),
    [sym_preproc_directive] = ACTIONS(5486),
    [anon_sym_LPAREN2] = ACTIONS(5488),
    [anon_sym_TILDE] = ACTIONS(5488),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP_AMP] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5486),
    [anon_sym_SEMI] = ACTIONS(5488),
    [anon_sym___extension__] = ACTIONS(5486),
    [anon_sym_typedef] = ACTIONS(5486),
    [anon_sym_virtual] = ACTIONS(5486),
    [anon_sym_extern] = ACTIONS(5486),
    [anon_sym___attribute__] = ACTIONS(5486),
    [anon_sym___attribute] = ACTIONS(5486),
    [anon_sym_COLON_COLON] = ACTIONS(5488),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5488),
    [anon_sym___declspec] = ACTIONS(5486),
    [anon_sym___based] = ACTIONS(5486),
    [anon_sym_RBRACE] = ACTIONS(5488),
    [anon_sym_signed] = ACTIONS(5486),
    [anon_sym_unsigned] = ACTIONS(5486),
    [anon_sym_long] = ACTIONS(5486),
    [anon_sym_short] = ACTIONS(5486),
    [anon_sym_LBRACK] = ACTIONS(5486),
    [anon_sym_static] = ACTIONS(5486),
    [anon_sym_register] = ACTIONS(5486),
    [anon_sym_inline] = ACTIONS(5486),
    [anon_sym___inline] = ACTIONS(5486),
    [anon_sym___inline__] = ACTIONS(5486),
    [anon_sym___forceinline] = ACTIONS(5486),
    [anon_sym_thread_local] = ACTIONS(5486),
    [anon_sym___thread] = ACTIONS(5486),
    [anon_sym_const] = ACTIONS(5486),
    [anon_sym_constexpr] = ACTIONS(5486),
    [anon_sym_volatile] = ACTIONS(5486),
    [anon_sym_restrict] = ACTIONS(5486),
    [anon_sym___restrict__] = ACTIONS(5486),
    [anon_sym__Atomic] = ACTIONS(5486),
    [anon_sym__Noreturn] = ACTIONS(5486),
    [anon_sym_noreturn] = ACTIONS(5486),
    [anon_sym__Nonnull] = ACTIONS(5486),
    [anon_sym_mutable] = ACTIONS(5486),
    [anon_sym_constinit] = ACTIONS(5486),
    [anon_sym_consteval] = ACTIONS(5486),
    [anon_sym_alignas] = ACTIONS(5486),
    [anon_sym__Alignas] = ACTIONS(5486),
    [sym_primitive_type] = ACTIONS(5486),
    [anon_sym_enum] = ACTIONS(5486),
    [anon_sym_class] = ACTIONS(5486),
    [anon_sym_struct] = ACTIONS(5486),
    [anon_sym_union] = ACTIONS(5486),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5486),
    [anon_sym_decltype] = ACTIONS(5486),
    [anon_sym_explicit] = ACTIONS(5486),
    [anon_sym_typename] = ACTIONS(5486),
    [anon_sym_template] = ACTIONS(5486),
    [anon_sym_operator] = ACTIONS(5486),
    [anon_sym_friend] = ACTIONS(5486),
    [anon_sym_public] = ACTIONS(5486),
    [anon_sym_private] = ACTIONS(5486),
    [anon_sym_protected] = ACTIONS(5486),
    [anon_sym_using] = ACTIONS(5486),
    [anon_sym_static_assert] = ACTIONS(5486),
  },
  [1982] = {
    [sym_identifier] = ACTIONS(2826),
    [aux_sym_preproc_def_token1] = ACTIONS(2826),
    [aux_sym_preproc_if_token1] = ACTIONS(2826),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2826),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2826),
    [sym_preproc_directive] = ACTIONS(2826),
    [anon_sym_LPAREN2] = ACTIONS(2828),
    [anon_sym_TILDE] = ACTIONS(2828),
    [anon_sym_STAR] = ACTIONS(2828),
    [anon_sym_AMP_AMP] = ACTIONS(2828),
    [anon_sym_AMP] = ACTIONS(2826),
    [anon_sym_SEMI] = ACTIONS(2828),
    [anon_sym___extension__] = ACTIONS(2826),
    [anon_sym_typedef] = ACTIONS(2826),
    [anon_sym_virtual] = ACTIONS(2826),
    [anon_sym_extern] = ACTIONS(2826),
    [anon_sym___attribute__] = ACTIONS(2826),
    [anon_sym___attribute] = ACTIONS(2826),
    [anon_sym_COLON_COLON] = ACTIONS(2828),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2828),
    [anon_sym___declspec] = ACTIONS(2826),
    [anon_sym___based] = ACTIONS(2826),
    [anon_sym_RBRACE] = ACTIONS(2828),
    [anon_sym_signed] = ACTIONS(2826),
    [anon_sym_unsigned] = ACTIONS(2826),
    [anon_sym_long] = ACTIONS(2826),
    [anon_sym_short] = ACTIONS(2826),
    [anon_sym_LBRACK] = ACTIONS(2826),
    [anon_sym_static] = ACTIONS(2826),
    [anon_sym_register] = ACTIONS(2826),
    [anon_sym_inline] = ACTIONS(2826),
    [anon_sym___inline] = ACTIONS(2826),
    [anon_sym___inline__] = ACTIONS(2826),
    [anon_sym___forceinline] = ACTIONS(2826),
    [anon_sym_thread_local] = ACTIONS(2826),
    [anon_sym___thread] = ACTIONS(2826),
    [anon_sym_const] = ACTIONS(2826),
    [anon_sym_constexpr] = ACTIONS(2826),
    [anon_sym_volatile] = ACTIONS(2826),
    [anon_sym_restrict] = ACTIONS(2826),
    [anon_sym___restrict__] = ACTIONS(2826),
    [anon_sym__Atomic] = ACTIONS(2826),
    [anon_sym__Noreturn] = ACTIONS(2826),
    [anon_sym_noreturn] = ACTIONS(2826),
    [anon_sym__Nonnull] = ACTIONS(2826),
    [anon_sym_mutable] = ACTIONS(2826),
    [anon_sym_constinit] = ACTIONS(2826),
    [anon_sym_consteval] = ACTIONS(2826),
    [anon_sym_alignas] = ACTIONS(2826),
    [anon_sym__Alignas] = ACTIONS(2826),
    [sym_primitive_type] = ACTIONS(2826),
    [anon_sym_enum] = ACTIONS(2826),
    [anon_sym_class] = ACTIONS(2826),
    [anon_sym_struct] = ACTIONS(2826),
    [anon_sym_union] = ACTIONS(2826),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2826),
    [anon_sym_decltype] = ACTIONS(2826),
    [anon_sym_explicit] = ACTIONS(2826),
    [anon_sym_typename] = ACTIONS(2826),
    [anon_sym_template] = ACTIONS(2826),
    [anon_sym_operator] = ACTIONS(2826),
    [anon_sym_friend] = ACTIONS(2826),
    [anon_sym_public] = ACTIONS(2826),
    [anon_sym_private] = ACTIONS(2826),
    [anon_sym_protected] = ACTIONS(2826),
    [anon_sym_using] = ACTIONS(2826),
    [anon_sym_static_assert] = ACTIONS(2826),
  },
  [1983] = {
    [sym_identifier] = ACTIONS(3013),
    [aux_sym_preproc_def_token1] = ACTIONS(3013),
    [aux_sym_preproc_if_token1] = ACTIONS(3013),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3013),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3013),
    [sym_preproc_directive] = ACTIONS(3013),
    [anon_sym_LPAREN2] = ACTIONS(3015),
    [anon_sym_TILDE] = ACTIONS(3015),
    [anon_sym_STAR] = ACTIONS(3015),
    [anon_sym_AMP_AMP] = ACTIONS(3015),
    [anon_sym_AMP] = ACTIONS(3013),
    [anon_sym_SEMI] = ACTIONS(3015),
    [anon_sym___extension__] = ACTIONS(3013),
    [anon_sym_typedef] = ACTIONS(3013),
    [anon_sym_virtual] = ACTIONS(3013),
    [anon_sym_extern] = ACTIONS(3013),
    [anon_sym___attribute__] = ACTIONS(3013),
    [anon_sym___attribute] = ACTIONS(3013),
    [anon_sym_COLON_COLON] = ACTIONS(3015),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3015),
    [anon_sym___declspec] = ACTIONS(3013),
    [anon_sym___based] = ACTIONS(3013),
    [anon_sym_RBRACE] = ACTIONS(3015),
    [anon_sym_signed] = ACTIONS(3013),
    [anon_sym_unsigned] = ACTIONS(3013),
    [anon_sym_long] = ACTIONS(3013),
    [anon_sym_short] = ACTIONS(3013),
    [anon_sym_LBRACK] = ACTIONS(3013),
    [anon_sym_static] = ACTIONS(3013),
    [anon_sym_register] = ACTIONS(3013),
    [anon_sym_inline] = ACTIONS(3013),
    [anon_sym___inline] = ACTIONS(3013),
    [anon_sym___inline__] = ACTIONS(3013),
    [anon_sym___forceinline] = ACTIONS(3013),
    [anon_sym_thread_local] = ACTIONS(3013),
    [anon_sym___thread] = ACTIONS(3013),
    [anon_sym_const] = ACTIONS(3013),
    [anon_sym_constexpr] = ACTIONS(3013),
    [anon_sym_volatile] = ACTIONS(3013),
    [anon_sym_restrict] = ACTIONS(3013),
    [anon_sym___restrict__] = ACTIONS(3013),
    [anon_sym__Atomic] = ACTIONS(3013),
    [anon_sym__Noreturn] = ACTIONS(3013),
    [anon_sym_noreturn] = ACTIONS(3013),
    [anon_sym__Nonnull] = ACTIONS(3013),
    [anon_sym_mutable] = ACTIONS(3013),
    [anon_sym_constinit] = ACTIONS(3013),
    [anon_sym_consteval] = ACTIONS(3013),
    [anon_sym_alignas] = ACTIONS(3013),
    [anon_sym__Alignas] = ACTIONS(3013),
    [sym_primitive_type] = ACTIONS(3013),
    [anon_sym_enum] = ACTIONS(3013),
    [anon_sym_class] = ACTIONS(3013),
    [anon_sym_struct] = ACTIONS(3013),
    [anon_sym_union] = ACTIONS(3013),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3013),
    [anon_sym_decltype] = ACTIONS(3013),
    [anon_sym_explicit] = ACTIONS(3013),
    [anon_sym_typename] = ACTIONS(3013),
    [anon_sym_template] = ACTIONS(3013),
    [anon_sym_operator] = ACTIONS(3013),
    [anon_sym_friend] = ACTIONS(3013),
    [anon_sym_public] = ACTIONS(3013),
    [anon_sym_private] = ACTIONS(3013),
    [anon_sym_protected] = ACTIONS(3013),
    [anon_sym_using] = ACTIONS(3013),
    [anon_sym_static_assert] = ACTIONS(3013),
  },
  [1984] = {
    [sym_identifier] = ACTIONS(3026),
    [aux_sym_preproc_def_token1] = ACTIONS(3026),
    [aux_sym_preproc_if_token1] = ACTIONS(3026),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3026),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3026),
    [sym_preproc_directive] = ACTIONS(3026),
    [anon_sym_LPAREN2] = ACTIONS(3028),
    [anon_sym_TILDE] = ACTIONS(3028),
    [anon_sym_STAR] = ACTIONS(3028),
    [anon_sym_AMP_AMP] = ACTIONS(3028),
    [anon_sym_AMP] = ACTIONS(3026),
    [anon_sym_SEMI] = ACTIONS(3028),
    [anon_sym___extension__] = ACTIONS(3026),
    [anon_sym_typedef] = ACTIONS(3026),
    [anon_sym_virtual] = ACTIONS(3026),
    [anon_sym_extern] = ACTIONS(3026),
    [anon_sym___attribute__] = ACTIONS(3026),
    [anon_sym___attribute] = ACTIONS(3026),
    [anon_sym_COLON_COLON] = ACTIONS(3028),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3028),
    [anon_sym___declspec] = ACTIONS(3026),
    [anon_sym___based] = ACTIONS(3026),
    [anon_sym_RBRACE] = ACTIONS(3028),
    [anon_sym_signed] = ACTIONS(3026),
    [anon_sym_unsigned] = ACTIONS(3026),
    [anon_sym_long] = ACTIONS(3026),
    [anon_sym_short] = ACTIONS(3026),
    [anon_sym_LBRACK] = ACTIONS(3026),
    [anon_sym_static] = ACTIONS(3026),
    [anon_sym_register] = ACTIONS(3026),
    [anon_sym_inline] = ACTIONS(3026),
    [anon_sym___inline] = ACTIONS(3026),
    [anon_sym___inline__] = ACTIONS(3026),
    [anon_sym___forceinline] = ACTIONS(3026),
    [anon_sym_thread_local] = ACTIONS(3026),
    [anon_sym___thread] = ACTIONS(3026),
    [anon_sym_const] = ACTIONS(3026),
    [anon_sym_constexpr] = ACTIONS(3026),
    [anon_sym_volatile] = ACTIONS(3026),
    [anon_sym_restrict] = ACTIONS(3026),
    [anon_sym___restrict__] = ACTIONS(3026),
    [anon_sym__Atomic] = ACTIONS(3026),
    [anon_sym__Noreturn] = ACTIONS(3026),
    [anon_sym_noreturn] = ACTIONS(3026),
    [anon_sym__Nonnull] = ACTIONS(3026),
    [anon_sym_mutable] = ACTIONS(3026),
    [anon_sym_constinit] = ACTIONS(3026),
    [anon_sym_consteval] = ACTIONS(3026),
    [anon_sym_alignas] = ACTIONS(3026),
    [anon_sym__Alignas] = ACTIONS(3026),
    [sym_primitive_type] = ACTIONS(3026),
    [anon_sym_enum] = ACTIONS(3026),
    [anon_sym_class] = ACTIONS(3026),
    [anon_sym_struct] = ACTIONS(3026),
    [anon_sym_union] = ACTIONS(3026),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3026),
    [anon_sym_decltype] = ACTIONS(3026),
    [anon_sym_explicit] = ACTIONS(3026),
    [anon_sym_typename] = ACTIONS(3026),
    [anon_sym_template] = ACTIONS(3026),
    [anon_sym_operator] = ACTIONS(3026),
    [anon_sym_friend] = ACTIONS(3026),
    [anon_sym_public] = ACTIONS(3026),
    [anon_sym_private] = ACTIONS(3026),
    [anon_sym_protected] = ACTIONS(3026),
    [anon_sym_using] = ACTIONS(3026),
    [anon_sym_static_assert] = ACTIONS(3026),
  },
  [1985] = {
    [sym_identifier] = ACTIONS(5435),
    [aux_sym_preproc_def_token1] = ACTIONS(5435),
    [aux_sym_preproc_if_token1] = ACTIONS(5435),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5435),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5435),
    [sym_preproc_directive] = ACTIONS(5435),
    [anon_sym_LPAREN2] = ACTIONS(5437),
    [anon_sym_TILDE] = ACTIONS(5437),
    [anon_sym_STAR] = ACTIONS(5437),
    [anon_sym_AMP_AMP] = ACTIONS(5437),
    [anon_sym_AMP] = ACTIONS(5435),
    [anon_sym_SEMI] = ACTIONS(5437),
    [anon_sym___extension__] = ACTIONS(5435),
    [anon_sym_typedef] = ACTIONS(5435),
    [anon_sym_virtual] = ACTIONS(5435),
    [anon_sym_extern] = ACTIONS(5435),
    [anon_sym___attribute__] = ACTIONS(5435),
    [anon_sym___attribute] = ACTIONS(5435),
    [anon_sym_COLON_COLON] = ACTIONS(5437),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5437),
    [anon_sym___declspec] = ACTIONS(5435),
    [anon_sym___based] = ACTIONS(5435),
    [anon_sym_RBRACE] = ACTIONS(5437),
    [anon_sym_signed] = ACTIONS(5435),
    [anon_sym_unsigned] = ACTIONS(5435),
    [anon_sym_long] = ACTIONS(5435),
    [anon_sym_short] = ACTIONS(5435),
    [anon_sym_LBRACK] = ACTIONS(5435),
    [anon_sym_static] = ACTIONS(5435),
    [anon_sym_register] = ACTIONS(5435),
    [anon_sym_inline] = ACTIONS(5435),
    [anon_sym___inline] = ACTIONS(5435),
    [anon_sym___inline__] = ACTIONS(5435),
    [anon_sym___forceinline] = ACTIONS(5435),
    [anon_sym_thread_local] = ACTIONS(5435),
    [anon_sym___thread] = ACTIONS(5435),
    [anon_sym_const] = ACTIONS(5435),
    [anon_sym_constexpr] = ACTIONS(5435),
    [anon_sym_volatile] = ACTIONS(5435),
    [anon_sym_restrict] = ACTIONS(5435),
    [anon_sym___restrict__] = ACTIONS(5435),
    [anon_sym__Atomic] = ACTIONS(5435),
    [anon_sym__Noreturn] = ACTIONS(5435),
    [anon_sym_noreturn] = ACTIONS(5435),
    [anon_sym__Nonnull] = ACTIONS(5435),
    [anon_sym_mutable] = ACTIONS(5435),
    [anon_sym_constinit] = ACTIONS(5435),
    [anon_sym_consteval] = ACTIONS(5435),
    [anon_sym_alignas] = ACTIONS(5435),
    [anon_sym__Alignas] = ACTIONS(5435),
    [sym_primitive_type] = ACTIONS(5435),
    [anon_sym_enum] = ACTIONS(5435),
    [anon_sym_class] = ACTIONS(5435),
    [anon_sym_struct] = ACTIONS(5435),
    [anon_sym_union] = ACTIONS(5435),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5435),
    [anon_sym_decltype] = ACTIONS(5435),
    [anon_sym_explicit] = ACTIONS(5435),
    [anon_sym_typename] = ACTIONS(5435),
    [anon_sym_template] = ACTIONS(5435),
    [anon_sym_operator] = ACTIONS(5435),
    [anon_sym_friend] = ACTIONS(5435),
    [anon_sym_public] = ACTIONS(5435),
    [anon_sym_private] = ACTIONS(5435),
    [anon_sym_protected] = ACTIONS(5435),
    [anon_sym_using] = ACTIONS(5435),
    [anon_sym_static_assert] = ACTIONS(5435),
  },
  [1986] = {
    [sym_identifier] = ACTIONS(5435),
    [aux_sym_preproc_def_token1] = ACTIONS(5435),
    [aux_sym_preproc_if_token1] = ACTIONS(5435),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5435),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5435),
    [sym_preproc_directive] = ACTIONS(5435),
    [anon_sym_LPAREN2] = ACTIONS(5437),
    [anon_sym_TILDE] = ACTIONS(5437),
    [anon_sym_STAR] = ACTIONS(5437),
    [anon_sym_AMP_AMP] = ACTIONS(5437),
    [anon_sym_AMP] = ACTIONS(5435),
    [anon_sym_SEMI] = ACTIONS(5437),
    [anon_sym___extension__] = ACTIONS(5435),
    [anon_sym_typedef] = ACTIONS(5435),
    [anon_sym_virtual] = ACTIONS(5435),
    [anon_sym_extern] = ACTIONS(5435),
    [anon_sym___attribute__] = ACTIONS(5435),
    [anon_sym___attribute] = ACTIONS(5435),
    [anon_sym_COLON_COLON] = ACTIONS(5437),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5437),
    [anon_sym___declspec] = ACTIONS(5435),
    [anon_sym___based] = ACTIONS(5435),
    [anon_sym_RBRACE] = ACTIONS(5437),
    [anon_sym_signed] = ACTIONS(5435),
    [anon_sym_unsigned] = ACTIONS(5435),
    [anon_sym_long] = ACTIONS(5435),
    [anon_sym_short] = ACTIONS(5435),
    [anon_sym_LBRACK] = ACTIONS(5435),
    [anon_sym_static] = ACTIONS(5435),
    [anon_sym_register] = ACTIONS(5435),
    [anon_sym_inline] = ACTIONS(5435),
    [anon_sym___inline] = ACTIONS(5435),
    [anon_sym___inline__] = ACTIONS(5435),
    [anon_sym___forceinline] = ACTIONS(5435),
    [anon_sym_thread_local] = ACTIONS(5435),
    [anon_sym___thread] = ACTIONS(5435),
    [anon_sym_const] = ACTIONS(5435),
    [anon_sym_constexpr] = ACTIONS(5435),
    [anon_sym_volatile] = ACTIONS(5435),
    [anon_sym_restrict] = ACTIONS(5435),
    [anon_sym___restrict__] = ACTIONS(5435),
    [anon_sym__Atomic] = ACTIONS(5435),
    [anon_sym__Noreturn] = ACTIONS(5435),
    [anon_sym_noreturn] = ACTIONS(5435),
    [anon_sym__Nonnull] = ACTIONS(5435),
    [anon_sym_mutable] = ACTIONS(5435),
    [anon_sym_constinit] = ACTIONS(5435),
    [anon_sym_consteval] = ACTIONS(5435),
    [anon_sym_alignas] = ACTIONS(5435),
    [anon_sym__Alignas] = ACTIONS(5435),
    [sym_primitive_type] = ACTIONS(5435),
    [anon_sym_enum] = ACTIONS(5435),
    [anon_sym_class] = ACTIONS(5435),
    [anon_sym_struct] = ACTIONS(5435),
    [anon_sym_union] = ACTIONS(5435),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5435),
    [anon_sym_decltype] = ACTIONS(5435),
    [anon_sym_explicit] = ACTIONS(5435),
    [anon_sym_typename] = ACTIONS(5435),
    [anon_sym_template] = ACTIONS(5435),
    [anon_sym_operator] = ACTIONS(5435),
    [anon_sym_friend] = ACTIONS(5435),
    [anon_sym_public] = ACTIONS(5435),
    [anon_sym_private] = ACTIONS(5435),
    [anon_sym_protected] = ACTIONS(5435),
    [anon_sym_using] = ACTIONS(5435),
    [anon_sym_static_assert] = ACTIONS(5435),
  },
  [1987] = {
    [sym_identifier] = ACTIONS(5357),
    [aux_sym_preproc_def_token1] = ACTIONS(5357),
    [aux_sym_preproc_if_token1] = ACTIONS(5357),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5357),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5357),
    [sym_preproc_directive] = ACTIONS(5357),
    [anon_sym_LPAREN2] = ACTIONS(5359),
    [anon_sym_TILDE] = ACTIONS(5359),
    [anon_sym_STAR] = ACTIONS(5359),
    [anon_sym_AMP_AMP] = ACTIONS(5359),
    [anon_sym_AMP] = ACTIONS(5357),
    [anon_sym_SEMI] = ACTIONS(5359),
    [anon_sym___extension__] = ACTIONS(5357),
    [anon_sym_typedef] = ACTIONS(5357),
    [anon_sym_virtual] = ACTIONS(5357),
    [anon_sym_extern] = ACTIONS(5357),
    [anon_sym___attribute__] = ACTIONS(5357),
    [anon_sym___attribute] = ACTIONS(5357),
    [anon_sym_COLON_COLON] = ACTIONS(5359),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5359),
    [anon_sym___declspec] = ACTIONS(5357),
    [anon_sym___based] = ACTIONS(5357),
    [anon_sym_RBRACE] = ACTIONS(5359),
    [anon_sym_signed] = ACTIONS(5357),
    [anon_sym_unsigned] = ACTIONS(5357),
    [anon_sym_long] = ACTIONS(5357),
    [anon_sym_short] = ACTIONS(5357),
    [anon_sym_LBRACK] = ACTIONS(5357),
    [anon_sym_static] = ACTIONS(5357),
    [anon_sym_register] = ACTIONS(5357),
    [anon_sym_inline] = ACTIONS(5357),
    [anon_sym___inline] = ACTIONS(5357),
    [anon_sym___inline__] = ACTIONS(5357),
    [anon_sym___forceinline] = ACTIONS(5357),
    [anon_sym_thread_local] = ACTIONS(5357),
    [anon_sym___thread] = ACTIONS(5357),
    [anon_sym_const] = ACTIONS(5357),
    [anon_sym_constexpr] = ACTIONS(5357),
    [anon_sym_volatile] = ACTIONS(5357),
    [anon_sym_restrict] = ACTIONS(5357),
    [anon_sym___restrict__] = ACTIONS(5357),
    [anon_sym__Atomic] = ACTIONS(5357),
    [anon_sym__Noreturn] = ACTIONS(5357),
    [anon_sym_noreturn] = ACTIONS(5357),
    [anon_sym__Nonnull] = ACTIONS(5357),
    [anon_sym_mutable] = ACTIONS(5357),
    [anon_sym_constinit] = ACTIONS(5357),
    [anon_sym_consteval] = ACTIONS(5357),
    [anon_sym_alignas] = ACTIONS(5357),
    [anon_sym__Alignas] = ACTIONS(5357),
    [sym_primitive_type] = ACTIONS(5357),
    [anon_sym_enum] = ACTIONS(5357),
    [anon_sym_class] = ACTIONS(5357),
    [anon_sym_struct] = ACTIONS(5357),
    [anon_sym_union] = ACTIONS(5357),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5357),
    [anon_sym_decltype] = ACTIONS(5357),
    [anon_sym_explicit] = ACTIONS(5357),
    [anon_sym_typename] = ACTIONS(5357),
    [anon_sym_template] = ACTIONS(5357),
    [anon_sym_operator] = ACTIONS(5357),
    [anon_sym_friend] = ACTIONS(5357),
    [anon_sym_public] = ACTIONS(5357),
    [anon_sym_private] = ACTIONS(5357),
    [anon_sym_protected] = ACTIONS(5357),
    [anon_sym_using] = ACTIONS(5357),
    [anon_sym_static_assert] = ACTIONS(5357),
  },
  [1988] = {
    [sym_identifier] = ACTIONS(5403),
    [aux_sym_preproc_def_token1] = ACTIONS(5403),
    [aux_sym_preproc_if_token1] = ACTIONS(5403),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5403),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5403),
    [sym_preproc_directive] = ACTIONS(5403),
    [anon_sym_LPAREN2] = ACTIONS(5405),
    [anon_sym_TILDE] = ACTIONS(5405),
    [anon_sym_STAR] = ACTIONS(5405),
    [anon_sym_AMP_AMP] = ACTIONS(5405),
    [anon_sym_AMP] = ACTIONS(5403),
    [anon_sym_SEMI] = ACTIONS(5405),
    [anon_sym___extension__] = ACTIONS(5403),
    [anon_sym_typedef] = ACTIONS(5403),
    [anon_sym_virtual] = ACTIONS(5403),
    [anon_sym_extern] = ACTIONS(5403),
    [anon_sym___attribute__] = ACTIONS(5403),
    [anon_sym___attribute] = ACTIONS(5403),
    [anon_sym_COLON_COLON] = ACTIONS(5405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5405),
    [anon_sym___declspec] = ACTIONS(5403),
    [anon_sym___based] = ACTIONS(5403),
    [anon_sym_RBRACE] = ACTIONS(5405),
    [anon_sym_signed] = ACTIONS(5403),
    [anon_sym_unsigned] = ACTIONS(5403),
    [anon_sym_long] = ACTIONS(5403),
    [anon_sym_short] = ACTIONS(5403),
    [anon_sym_LBRACK] = ACTIONS(5403),
    [anon_sym_static] = ACTIONS(5403),
    [anon_sym_register] = ACTIONS(5403),
    [anon_sym_inline] = ACTIONS(5403),
    [anon_sym___inline] = ACTIONS(5403),
    [anon_sym___inline__] = ACTIONS(5403),
    [anon_sym___forceinline] = ACTIONS(5403),
    [anon_sym_thread_local] = ACTIONS(5403),
    [anon_sym___thread] = ACTIONS(5403),
    [anon_sym_const] = ACTIONS(5403),
    [anon_sym_constexpr] = ACTIONS(5403),
    [anon_sym_volatile] = ACTIONS(5403),
    [anon_sym_restrict] = ACTIONS(5403),
    [anon_sym___restrict__] = ACTIONS(5403),
    [anon_sym__Atomic] = ACTIONS(5403),
    [anon_sym__Noreturn] = ACTIONS(5403),
    [anon_sym_noreturn] = ACTIONS(5403),
    [anon_sym__Nonnull] = ACTIONS(5403),
    [anon_sym_mutable] = ACTIONS(5403),
    [anon_sym_constinit] = ACTIONS(5403),
    [anon_sym_consteval] = ACTIONS(5403),
    [anon_sym_alignas] = ACTIONS(5403),
    [anon_sym__Alignas] = ACTIONS(5403),
    [sym_primitive_type] = ACTIONS(5403),
    [anon_sym_enum] = ACTIONS(5403),
    [anon_sym_class] = ACTIONS(5403),
    [anon_sym_struct] = ACTIONS(5403),
    [anon_sym_union] = ACTIONS(5403),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5403),
    [anon_sym_decltype] = ACTIONS(5403),
    [anon_sym_explicit] = ACTIONS(5403),
    [anon_sym_typename] = ACTIONS(5403),
    [anon_sym_template] = ACTIONS(5403),
    [anon_sym_operator] = ACTIONS(5403),
    [anon_sym_friend] = ACTIONS(5403),
    [anon_sym_public] = ACTIONS(5403),
    [anon_sym_private] = ACTIONS(5403),
    [anon_sym_protected] = ACTIONS(5403),
    [anon_sym_using] = ACTIONS(5403),
    [anon_sym_static_assert] = ACTIONS(5403),
  },
  [1989] = {
    [sym_identifier] = ACTIONS(3046),
    [aux_sym_preproc_def_token1] = ACTIONS(3046),
    [aux_sym_preproc_if_token1] = ACTIONS(3046),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3046),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3046),
    [sym_preproc_directive] = ACTIONS(3046),
    [anon_sym_LPAREN2] = ACTIONS(3048),
    [anon_sym_TILDE] = ACTIONS(3048),
    [anon_sym_STAR] = ACTIONS(3048),
    [anon_sym_AMP_AMP] = ACTIONS(3048),
    [anon_sym_AMP] = ACTIONS(3046),
    [anon_sym_SEMI] = ACTIONS(3048),
    [anon_sym___extension__] = ACTIONS(3046),
    [anon_sym_typedef] = ACTIONS(3046),
    [anon_sym_virtual] = ACTIONS(3046),
    [anon_sym_extern] = ACTIONS(3046),
    [anon_sym___attribute__] = ACTIONS(3046),
    [anon_sym___attribute] = ACTIONS(3046),
    [anon_sym_COLON_COLON] = ACTIONS(3048),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3048),
    [anon_sym___declspec] = ACTIONS(3046),
    [anon_sym___based] = ACTIONS(3046),
    [anon_sym_RBRACE] = ACTIONS(3048),
    [anon_sym_signed] = ACTIONS(3046),
    [anon_sym_unsigned] = ACTIONS(3046),
    [anon_sym_long] = ACTIONS(3046),
    [anon_sym_short] = ACTIONS(3046),
    [anon_sym_LBRACK] = ACTIONS(3046),
    [anon_sym_static] = ACTIONS(3046),
    [anon_sym_register] = ACTIONS(3046),
    [anon_sym_inline] = ACTIONS(3046),
    [anon_sym___inline] = ACTIONS(3046),
    [anon_sym___inline__] = ACTIONS(3046),
    [anon_sym___forceinline] = ACTIONS(3046),
    [anon_sym_thread_local] = ACTIONS(3046),
    [anon_sym___thread] = ACTIONS(3046),
    [anon_sym_const] = ACTIONS(3046),
    [anon_sym_constexpr] = ACTIONS(3046),
    [anon_sym_volatile] = ACTIONS(3046),
    [anon_sym_restrict] = ACTIONS(3046),
    [anon_sym___restrict__] = ACTIONS(3046),
    [anon_sym__Atomic] = ACTIONS(3046),
    [anon_sym__Noreturn] = ACTIONS(3046),
    [anon_sym_noreturn] = ACTIONS(3046),
    [anon_sym__Nonnull] = ACTIONS(3046),
    [anon_sym_mutable] = ACTIONS(3046),
    [anon_sym_constinit] = ACTIONS(3046),
    [anon_sym_consteval] = ACTIONS(3046),
    [anon_sym_alignas] = ACTIONS(3046),
    [anon_sym__Alignas] = ACTIONS(3046),
    [sym_primitive_type] = ACTIONS(3046),
    [anon_sym_enum] = ACTIONS(3046),
    [anon_sym_class] = ACTIONS(3046),
    [anon_sym_struct] = ACTIONS(3046),
    [anon_sym_union] = ACTIONS(3046),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3046),
    [anon_sym_decltype] = ACTIONS(3046),
    [anon_sym_explicit] = ACTIONS(3046),
    [anon_sym_typename] = ACTIONS(3046),
    [anon_sym_template] = ACTIONS(3046),
    [anon_sym_operator] = ACTIONS(3046),
    [anon_sym_friend] = ACTIONS(3046),
    [anon_sym_public] = ACTIONS(3046),
    [anon_sym_private] = ACTIONS(3046),
    [anon_sym_protected] = ACTIONS(3046),
    [anon_sym_using] = ACTIONS(3046),
    [anon_sym_static_assert] = ACTIONS(3046),
  },
  [1990] = {
    [sym_identifier] = ACTIONS(3050),
    [aux_sym_preproc_def_token1] = ACTIONS(3050),
    [aux_sym_preproc_if_token1] = ACTIONS(3050),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3050),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3050),
    [sym_preproc_directive] = ACTIONS(3050),
    [anon_sym_LPAREN2] = ACTIONS(3052),
    [anon_sym_TILDE] = ACTIONS(3052),
    [anon_sym_STAR] = ACTIONS(3052),
    [anon_sym_AMP_AMP] = ACTIONS(3052),
    [anon_sym_AMP] = ACTIONS(3050),
    [anon_sym_SEMI] = ACTIONS(3052),
    [anon_sym___extension__] = ACTIONS(3050),
    [anon_sym_typedef] = ACTIONS(3050),
    [anon_sym_virtual] = ACTIONS(3050),
    [anon_sym_extern] = ACTIONS(3050),
    [anon_sym___attribute__] = ACTIONS(3050),
    [anon_sym___attribute] = ACTIONS(3050),
    [anon_sym_COLON_COLON] = ACTIONS(3052),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3052),
    [anon_sym___declspec] = ACTIONS(3050),
    [anon_sym___based] = ACTIONS(3050),
    [anon_sym_RBRACE] = ACTIONS(3052),
    [anon_sym_signed] = ACTIONS(3050),
    [anon_sym_unsigned] = ACTIONS(3050),
    [anon_sym_long] = ACTIONS(3050),
    [anon_sym_short] = ACTIONS(3050),
    [anon_sym_LBRACK] = ACTIONS(3050),
    [anon_sym_static] = ACTIONS(3050),
    [anon_sym_register] = ACTIONS(3050),
    [anon_sym_inline] = ACTIONS(3050),
    [anon_sym___inline] = ACTIONS(3050),
    [anon_sym___inline__] = ACTIONS(3050),
    [anon_sym___forceinline] = ACTIONS(3050),
    [anon_sym_thread_local] = ACTIONS(3050),
    [anon_sym___thread] = ACTIONS(3050),
    [anon_sym_const] = ACTIONS(3050),
    [anon_sym_constexpr] = ACTIONS(3050),
    [anon_sym_volatile] = ACTIONS(3050),
    [anon_sym_restrict] = ACTIONS(3050),
    [anon_sym___restrict__] = ACTIONS(3050),
    [anon_sym__Atomic] = ACTIONS(3050),
    [anon_sym__Noreturn] = ACTIONS(3050),
    [anon_sym_noreturn] = ACTIONS(3050),
    [anon_sym__Nonnull] = ACTIONS(3050),
    [anon_sym_mutable] = ACTIONS(3050),
    [anon_sym_constinit] = ACTIONS(3050),
    [anon_sym_consteval] = ACTIONS(3050),
    [anon_sym_alignas] = ACTIONS(3050),
    [anon_sym__Alignas] = ACTIONS(3050),
    [sym_primitive_type] = ACTIONS(3050),
    [anon_sym_enum] = ACTIONS(3050),
    [anon_sym_class] = ACTIONS(3050),
    [anon_sym_struct] = ACTIONS(3050),
    [anon_sym_union] = ACTIONS(3050),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3050),
    [anon_sym_decltype] = ACTIONS(3050),
    [anon_sym_explicit] = ACTIONS(3050),
    [anon_sym_typename] = ACTIONS(3050),
    [anon_sym_template] = ACTIONS(3050),
    [anon_sym_operator] = ACTIONS(3050),
    [anon_sym_friend] = ACTIONS(3050),
    [anon_sym_public] = ACTIONS(3050),
    [anon_sym_private] = ACTIONS(3050),
    [anon_sym_protected] = ACTIONS(3050),
    [anon_sym_using] = ACTIONS(3050),
    [anon_sym_static_assert] = ACTIONS(3050),
  },
  [1991] = {
    [sym_identifier] = ACTIONS(3056),
    [aux_sym_preproc_def_token1] = ACTIONS(3056),
    [aux_sym_preproc_if_token1] = ACTIONS(3056),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3056),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3056),
    [sym_preproc_directive] = ACTIONS(3056),
    [anon_sym_LPAREN2] = ACTIONS(3058),
    [anon_sym_TILDE] = ACTIONS(3058),
    [anon_sym_STAR] = ACTIONS(3058),
    [anon_sym_AMP_AMP] = ACTIONS(3058),
    [anon_sym_AMP] = ACTIONS(3056),
    [anon_sym_SEMI] = ACTIONS(3058),
    [anon_sym___extension__] = ACTIONS(3056),
    [anon_sym_typedef] = ACTIONS(3056),
    [anon_sym_virtual] = ACTIONS(3056),
    [anon_sym_extern] = ACTIONS(3056),
    [anon_sym___attribute__] = ACTIONS(3056),
    [anon_sym___attribute] = ACTIONS(3056),
    [anon_sym_COLON_COLON] = ACTIONS(3058),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3058),
    [anon_sym___declspec] = ACTIONS(3056),
    [anon_sym___based] = ACTIONS(3056),
    [anon_sym_RBRACE] = ACTIONS(3058),
    [anon_sym_signed] = ACTIONS(3056),
    [anon_sym_unsigned] = ACTIONS(3056),
    [anon_sym_long] = ACTIONS(3056),
    [anon_sym_short] = ACTIONS(3056),
    [anon_sym_LBRACK] = ACTIONS(3056),
    [anon_sym_static] = ACTIONS(3056),
    [anon_sym_register] = ACTIONS(3056),
    [anon_sym_inline] = ACTIONS(3056),
    [anon_sym___inline] = ACTIONS(3056),
    [anon_sym___inline__] = ACTIONS(3056),
    [anon_sym___forceinline] = ACTIONS(3056),
    [anon_sym_thread_local] = ACTIONS(3056),
    [anon_sym___thread] = ACTIONS(3056),
    [anon_sym_const] = ACTIONS(3056),
    [anon_sym_constexpr] = ACTIONS(3056),
    [anon_sym_volatile] = ACTIONS(3056),
    [anon_sym_restrict] = ACTIONS(3056),
    [anon_sym___restrict__] = ACTIONS(3056),
    [anon_sym__Atomic] = ACTIONS(3056),
    [anon_sym__Noreturn] = ACTIONS(3056),
    [anon_sym_noreturn] = ACTIONS(3056),
    [anon_sym__Nonnull] = ACTIONS(3056),
    [anon_sym_mutable] = ACTIONS(3056),
    [anon_sym_constinit] = ACTIONS(3056),
    [anon_sym_consteval] = ACTIONS(3056),
    [anon_sym_alignas] = ACTIONS(3056),
    [anon_sym__Alignas] = ACTIONS(3056),
    [sym_primitive_type] = ACTIONS(3056),
    [anon_sym_enum] = ACTIONS(3056),
    [anon_sym_class] = ACTIONS(3056),
    [anon_sym_struct] = ACTIONS(3056),
    [anon_sym_union] = ACTIONS(3056),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3056),
    [anon_sym_decltype] = ACTIONS(3056),
    [anon_sym_explicit] = ACTIONS(3056),
    [anon_sym_typename] = ACTIONS(3056),
    [anon_sym_template] = ACTIONS(3056),
    [anon_sym_operator] = ACTIONS(3056),
    [anon_sym_friend] = ACTIONS(3056),
    [anon_sym_public] = ACTIONS(3056),
    [anon_sym_private] = ACTIONS(3056),
    [anon_sym_protected] = ACTIONS(3056),
    [anon_sym_using] = ACTIONS(3056),
    [anon_sym_static_assert] = ACTIONS(3056),
  },
  [1992] = {
    [sym_identifier] = ACTIONS(3060),
    [aux_sym_preproc_def_token1] = ACTIONS(3060),
    [aux_sym_preproc_if_token1] = ACTIONS(3060),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3060),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3060),
    [sym_preproc_directive] = ACTIONS(3060),
    [anon_sym_LPAREN2] = ACTIONS(3062),
    [anon_sym_TILDE] = ACTIONS(3062),
    [anon_sym_STAR] = ACTIONS(3062),
    [anon_sym_AMP_AMP] = ACTIONS(3062),
    [anon_sym_AMP] = ACTIONS(3060),
    [anon_sym_SEMI] = ACTIONS(3062),
    [anon_sym___extension__] = ACTIONS(3060),
    [anon_sym_typedef] = ACTIONS(3060),
    [anon_sym_virtual] = ACTIONS(3060),
    [anon_sym_extern] = ACTIONS(3060),
    [anon_sym___attribute__] = ACTIONS(3060),
    [anon_sym___attribute] = ACTIONS(3060),
    [anon_sym_COLON_COLON] = ACTIONS(3062),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3062),
    [anon_sym___declspec] = ACTIONS(3060),
    [anon_sym___based] = ACTIONS(3060),
    [anon_sym_RBRACE] = ACTIONS(3062),
    [anon_sym_signed] = ACTIONS(3060),
    [anon_sym_unsigned] = ACTIONS(3060),
    [anon_sym_long] = ACTIONS(3060),
    [anon_sym_short] = ACTIONS(3060),
    [anon_sym_LBRACK] = ACTIONS(3060),
    [anon_sym_static] = ACTIONS(3060),
    [anon_sym_register] = ACTIONS(3060),
    [anon_sym_inline] = ACTIONS(3060),
    [anon_sym___inline] = ACTIONS(3060),
    [anon_sym___inline__] = ACTIONS(3060),
    [anon_sym___forceinline] = ACTIONS(3060),
    [anon_sym_thread_local] = ACTIONS(3060),
    [anon_sym___thread] = ACTIONS(3060),
    [anon_sym_const] = ACTIONS(3060),
    [anon_sym_constexpr] = ACTIONS(3060),
    [anon_sym_volatile] = ACTIONS(3060),
    [anon_sym_restrict] = ACTIONS(3060),
    [anon_sym___restrict__] = ACTIONS(3060),
    [anon_sym__Atomic] = ACTIONS(3060),
    [anon_sym__Noreturn] = ACTIONS(3060),
    [anon_sym_noreturn] = ACTIONS(3060),
    [anon_sym__Nonnull] = ACTIONS(3060),
    [anon_sym_mutable] = ACTIONS(3060),
    [anon_sym_constinit] = ACTIONS(3060),
    [anon_sym_consteval] = ACTIONS(3060),
    [anon_sym_alignas] = ACTIONS(3060),
    [anon_sym__Alignas] = ACTIONS(3060),
    [sym_primitive_type] = ACTIONS(3060),
    [anon_sym_enum] = ACTIONS(3060),
    [anon_sym_class] = ACTIONS(3060),
    [anon_sym_struct] = ACTIONS(3060),
    [anon_sym_union] = ACTIONS(3060),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3060),
    [anon_sym_decltype] = ACTIONS(3060),
    [anon_sym_explicit] = ACTIONS(3060),
    [anon_sym_typename] = ACTIONS(3060),
    [anon_sym_template] = ACTIONS(3060),
    [anon_sym_operator] = ACTIONS(3060),
    [anon_sym_friend] = ACTIONS(3060),
    [anon_sym_public] = ACTIONS(3060),
    [anon_sym_private] = ACTIONS(3060),
    [anon_sym_protected] = ACTIONS(3060),
    [anon_sym_using] = ACTIONS(3060),
    [anon_sym_static_assert] = ACTIONS(3060),
  },
  [1993] = {
    [sym_identifier] = ACTIONS(3064),
    [aux_sym_preproc_def_token1] = ACTIONS(3064),
    [aux_sym_preproc_if_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3064),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3064),
    [sym_preproc_directive] = ACTIONS(3064),
    [anon_sym_LPAREN2] = ACTIONS(3066),
    [anon_sym_TILDE] = ACTIONS(3066),
    [anon_sym_STAR] = ACTIONS(3066),
    [anon_sym_AMP_AMP] = ACTIONS(3066),
    [anon_sym_AMP] = ACTIONS(3064),
    [anon_sym_SEMI] = ACTIONS(3066),
    [anon_sym___extension__] = ACTIONS(3064),
    [anon_sym_typedef] = ACTIONS(3064),
    [anon_sym_virtual] = ACTIONS(3064),
    [anon_sym_extern] = ACTIONS(3064),
    [anon_sym___attribute__] = ACTIONS(3064),
    [anon_sym___attribute] = ACTIONS(3064),
    [anon_sym_COLON_COLON] = ACTIONS(3066),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3066),
    [anon_sym___declspec] = ACTIONS(3064),
    [anon_sym___based] = ACTIONS(3064),
    [anon_sym_RBRACE] = ACTIONS(3066),
    [anon_sym_signed] = ACTIONS(3064),
    [anon_sym_unsigned] = ACTIONS(3064),
    [anon_sym_long] = ACTIONS(3064),
    [anon_sym_short] = ACTIONS(3064),
    [anon_sym_LBRACK] = ACTIONS(3064),
    [anon_sym_static] = ACTIONS(3064),
    [anon_sym_register] = ACTIONS(3064),
    [anon_sym_inline] = ACTIONS(3064),
    [anon_sym___inline] = ACTIONS(3064),
    [anon_sym___inline__] = ACTIONS(3064),
    [anon_sym___forceinline] = ACTIONS(3064),
    [anon_sym_thread_local] = ACTIONS(3064),
    [anon_sym___thread] = ACTIONS(3064),
    [anon_sym_const] = ACTIONS(3064),
    [anon_sym_constexpr] = ACTIONS(3064),
    [anon_sym_volatile] = ACTIONS(3064),
    [anon_sym_restrict] = ACTIONS(3064),
    [anon_sym___restrict__] = ACTIONS(3064),
    [anon_sym__Atomic] = ACTIONS(3064),
    [anon_sym__Noreturn] = ACTIONS(3064),
    [anon_sym_noreturn] = ACTIONS(3064),
    [anon_sym__Nonnull] = ACTIONS(3064),
    [anon_sym_mutable] = ACTIONS(3064),
    [anon_sym_constinit] = ACTIONS(3064),
    [anon_sym_consteval] = ACTIONS(3064),
    [anon_sym_alignas] = ACTIONS(3064),
    [anon_sym__Alignas] = ACTIONS(3064),
    [sym_primitive_type] = ACTIONS(3064),
    [anon_sym_enum] = ACTIONS(3064),
    [anon_sym_class] = ACTIONS(3064),
    [anon_sym_struct] = ACTIONS(3064),
    [anon_sym_union] = ACTIONS(3064),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3064),
    [anon_sym_decltype] = ACTIONS(3064),
    [anon_sym_explicit] = ACTIONS(3064),
    [anon_sym_typename] = ACTIONS(3064),
    [anon_sym_template] = ACTIONS(3064),
    [anon_sym_operator] = ACTIONS(3064),
    [anon_sym_friend] = ACTIONS(3064),
    [anon_sym_public] = ACTIONS(3064),
    [anon_sym_private] = ACTIONS(3064),
    [anon_sym_protected] = ACTIONS(3064),
    [anon_sym_using] = ACTIONS(3064),
    [anon_sym_static_assert] = ACTIONS(3064),
  },
  [1994] = {
    [sym_identifier] = ACTIONS(3068),
    [aux_sym_preproc_def_token1] = ACTIONS(3068),
    [aux_sym_preproc_if_token1] = ACTIONS(3068),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3068),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3068),
    [sym_preproc_directive] = ACTIONS(3068),
    [anon_sym_LPAREN2] = ACTIONS(3070),
    [anon_sym_TILDE] = ACTIONS(3070),
    [anon_sym_STAR] = ACTIONS(3070),
    [anon_sym_AMP_AMP] = ACTIONS(3070),
    [anon_sym_AMP] = ACTIONS(3068),
    [anon_sym_SEMI] = ACTIONS(3070),
    [anon_sym___extension__] = ACTIONS(3068),
    [anon_sym_typedef] = ACTIONS(3068),
    [anon_sym_virtual] = ACTIONS(3068),
    [anon_sym_extern] = ACTIONS(3068),
    [anon_sym___attribute__] = ACTIONS(3068),
    [anon_sym___attribute] = ACTIONS(3068),
    [anon_sym_COLON_COLON] = ACTIONS(3070),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3070),
    [anon_sym___declspec] = ACTIONS(3068),
    [anon_sym___based] = ACTIONS(3068),
    [anon_sym_RBRACE] = ACTIONS(3070),
    [anon_sym_signed] = ACTIONS(3068),
    [anon_sym_unsigned] = ACTIONS(3068),
    [anon_sym_long] = ACTIONS(3068),
    [anon_sym_short] = ACTIONS(3068),
    [anon_sym_LBRACK] = ACTIONS(3068),
    [anon_sym_static] = ACTIONS(3068),
    [anon_sym_register] = ACTIONS(3068),
    [anon_sym_inline] = ACTIONS(3068),
    [anon_sym___inline] = ACTIONS(3068),
    [anon_sym___inline__] = ACTIONS(3068),
    [anon_sym___forceinline] = ACTIONS(3068),
    [anon_sym_thread_local] = ACTIONS(3068),
    [anon_sym___thread] = ACTIONS(3068),
    [anon_sym_const] = ACTIONS(3068),
    [anon_sym_constexpr] = ACTIONS(3068),
    [anon_sym_volatile] = ACTIONS(3068),
    [anon_sym_restrict] = ACTIONS(3068),
    [anon_sym___restrict__] = ACTIONS(3068),
    [anon_sym__Atomic] = ACTIONS(3068),
    [anon_sym__Noreturn] = ACTIONS(3068),
    [anon_sym_noreturn] = ACTIONS(3068),
    [anon_sym__Nonnull] = ACTIONS(3068),
    [anon_sym_mutable] = ACTIONS(3068),
    [anon_sym_constinit] = ACTIONS(3068),
    [anon_sym_consteval] = ACTIONS(3068),
    [anon_sym_alignas] = ACTIONS(3068),
    [anon_sym__Alignas] = ACTIONS(3068),
    [sym_primitive_type] = ACTIONS(3068),
    [anon_sym_enum] = ACTIONS(3068),
    [anon_sym_class] = ACTIONS(3068),
    [anon_sym_struct] = ACTIONS(3068),
    [anon_sym_union] = ACTIONS(3068),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3068),
    [anon_sym_decltype] = ACTIONS(3068),
    [anon_sym_explicit] = ACTIONS(3068),
    [anon_sym_typename] = ACTIONS(3068),
    [anon_sym_template] = ACTIONS(3068),
    [anon_sym_operator] = ACTIONS(3068),
    [anon_sym_friend] = ACTIONS(3068),
    [anon_sym_public] = ACTIONS(3068),
    [anon_sym_private] = ACTIONS(3068),
    [anon_sym_protected] = ACTIONS(3068),
    [anon_sym_using] = ACTIONS(3068),
    [anon_sym_static_assert] = ACTIONS(3068),
  },
  [1995] = {
    [sym_identifier] = ACTIONS(2645),
    [aux_sym_preproc_def_token1] = ACTIONS(2645),
    [aux_sym_preproc_if_token1] = ACTIONS(2645),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2645),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2645),
    [sym_preproc_directive] = ACTIONS(2645),
    [anon_sym_LPAREN2] = ACTIONS(2647),
    [anon_sym_TILDE] = ACTIONS(2647),
    [anon_sym_STAR] = ACTIONS(2647),
    [anon_sym_AMP_AMP] = ACTIONS(2647),
    [anon_sym_AMP] = ACTIONS(2645),
    [anon_sym_SEMI] = ACTIONS(2647),
    [anon_sym___extension__] = ACTIONS(2645),
    [anon_sym_typedef] = ACTIONS(2645),
    [anon_sym_virtual] = ACTIONS(2645),
    [anon_sym_extern] = ACTIONS(2645),
    [anon_sym___attribute__] = ACTIONS(2645),
    [anon_sym___attribute] = ACTIONS(2645),
    [anon_sym_COLON_COLON] = ACTIONS(2647),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2647),
    [anon_sym___declspec] = ACTIONS(2645),
    [anon_sym___based] = ACTIONS(2645),
    [anon_sym_RBRACE] = ACTIONS(2647),
    [anon_sym_signed] = ACTIONS(2645),
    [anon_sym_unsigned] = ACTIONS(2645),
    [anon_sym_long] = ACTIONS(2645),
    [anon_sym_short] = ACTIONS(2645),
    [anon_sym_LBRACK] = ACTIONS(2645),
    [anon_sym_static] = ACTIONS(2645),
    [anon_sym_register] = ACTIONS(2645),
    [anon_sym_inline] = ACTIONS(2645),
    [anon_sym___inline] = ACTIONS(2645),
    [anon_sym___inline__] = ACTIONS(2645),
    [anon_sym___forceinline] = ACTIONS(2645),
    [anon_sym_thread_local] = ACTIONS(2645),
    [anon_sym___thread] = ACTIONS(2645),
    [anon_sym_const] = ACTIONS(2645),
    [anon_sym_constexpr] = ACTIONS(2645),
    [anon_sym_volatile] = ACTIONS(2645),
    [anon_sym_restrict] = ACTIONS(2645),
    [anon_sym___restrict__] = ACTIONS(2645),
    [anon_sym__Atomic] = ACTIONS(2645),
    [anon_sym__Noreturn] = ACTIONS(2645),
    [anon_sym_noreturn] = ACTIONS(2645),
    [anon_sym__Nonnull] = ACTIONS(2645),
    [anon_sym_mutable] = ACTIONS(2645),
    [anon_sym_constinit] = ACTIONS(2645),
    [anon_sym_consteval] = ACTIONS(2645),
    [anon_sym_alignas] = ACTIONS(2645),
    [anon_sym__Alignas] = ACTIONS(2645),
    [sym_primitive_type] = ACTIONS(2645),
    [anon_sym_enum] = ACTIONS(2645),
    [anon_sym_class] = ACTIONS(2645),
    [anon_sym_struct] = ACTIONS(2645),
    [anon_sym_union] = ACTIONS(2645),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2645),
    [anon_sym_decltype] = ACTIONS(2645),
    [anon_sym_explicit] = ACTIONS(2645),
    [anon_sym_typename] = ACTIONS(2645),
    [anon_sym_template] = ACTIONS(2645),
    [anon_sym_operator] = ACTIONS(2645),
    [anon_sym_friend] = ACTIONS(2645),
    [anon_sym_public] = ACTIONS(2645),
    [anon_sym_private] = ACTIONS(2645),
    [anon_sym_protected] = ACTIONS(2645),
    [anon_sym_using] = ACTIONS(2645),
    [anon_sym_static_assert] = ACTIONS(2645),
  },
  [1996] = {
    [sym_identifier] = ACTIONS(2649),
    [aux_sym_preproc_def_token1] = ACTIONS(2649),
    [aux_sym_preproc_if_token1] = ACTIONS(2649),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2649),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2649),
    [sym_preproc_directive] = ACTIONS(2649),
    [anon_sym_LPAREN2] = ACTIONS(2651),
    [anon_sym_TILDE] = ACTIONS(2651),
    [anon_sym_STAR] = ACTIONS(2651),
    [anon_sym_AMP_AMP] = ACTIONS(2651),
    [anon_sym_AMP] = ACTIONS(2649),
    [anon_sym_SEMI] = ACTIONS(2651),
    [anon_sym___extension__] = ACTIONS(2649),
    [anon_sym_typedef] = ACTIONS(2649),
    [anon_sym_virtual] = ACTIONS(2649),
    [anon_sym_extern] = ACTIONS(2649),
    [anon_sym___attribute__] = ACTIONS(2649),
    [anon_sym___attribute] = ACTIONS(2649),
    [anon_sym_COLON_COLON] = ACTIONS(2651),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2651),
    [anon_sym___declspec] = ACTIONS(2649),
    [anon_sym___based] = ACTIONS(2649),
    [anon_sym_RBRACE] = ACTIONS(2651),
    [anon_sym_signed] = ACTIONS(2649),
    [anon_sym_unsigned] = ACTIONS(2649),
    [anon_sym_long] = ACTIONS(2649),
    [anon_sym_short] = ACTIONS(2649),
    [anon_sym_LBRACK] = ACTIONS(2649),
    [anon_sym_static] = ACTIONS(2649),
    [anon_sym_register] = ACTIONS(2649),
    [anon_sym_inline] = ACTIONS(2649),
    [anon_sym___inline] = ACTIONS(2649),
    [anon_sym___inline__] = ACTIONS(2649),
    [anon_sym___forceinline] = ACTIONS(2649),
    [anon_sym_thread_local] = ACTIONS(2649),
    [anon_sym___thread] = ACTIONS(2649),
    [anon_sym_const] = ACTIONS(2649),
    [anon_sym_constexpr] = ACTIONS(2649),
    [anon_sym_volatile] = ACTIONS(2649),
    [anon_sym_restrict] = ACTIONS(2649),
    [anon_sym___restrict__] = ACTIONS(2649),
    [anon_sym__Atomic] = ACTIONS(2649),
    [anon_sym__Noreturn] = ACTIONS(2649),
    [anon_sym_noreturn] = ACTIONS(2649),
    [anon_sym__Nonnull] = ACTIONS(2649),
    [anon_sym_mutable] = ACTIONS(2649),
    [anon_sym_constinit] = ACTIONS(2649),
    [anon_sym_consteval] = ACTIONS(2649),
    [anon_sym_alignas] = ACTIONS(2649),
    [anon_sym__Alignas] = ACTIONS(2649),
    [sym_primitive_type] = ACTIONS(2649),
    [anon_sym_enum] = ACTIONS(2649),
    [anon_sym_class] = ACTIONS(2649),
    [anon_sym_struct] = ACTIONS(2649),
    [anon_sym_union] = ACTIONS(2649),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2649),
    [anon_sym_decltype] = ACTIONS(2649),
    [anon_sym_explicit] = ACTIONS(2649),
    [anon_sym_typename] = ACTIONS(2649),
    [anon_sym_template] = ACTIONS(2649),
    [anon_sym_operator] = ACTIONS(2649),
    [anon_sym_friend] = ACTIONS(2649),
    [anon_sym_public] = ACTIONS(2649),
    [anon_sym_private] = ACTIONS(2649),
    [anon_sym_protected] = ACTIONS(2649),
    [anon_sym_using] = ACTIONS(2649),
    [anon_sym_static_assert] = ACTIONS(2649),
  },
  [1997] = {
    [sym_ms_based_modifier] = STATE(7915),
    [sym_ms_unaligned_ptr_modifier] = STATE(3998),
    [sym_ms_pointer_modifier] = STATE(1998),
    [sym__declarator] = STATE(6269),
    [sym__abstract_declarator] = STATE(6570),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_abstract_parenthesized_declarator] = STATE(5942),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_abstract_pointer_declarator] = STATE(5942),
    [sym_function_declarator] = STATE(5896),
    [sym_abstract_function_declarator] = STATE(5942),
    [sym_array_declarator] = STATE(5896),
    [sym_abstract_array_declarator] = STATE(5942),
    [sym_type_qualifier] = STATE(2664),
    [sym_alignas_qualifier] = STATE(4266),
    [sym_parameter_list] = STATE(3233),
    [sym_decltype] = STATE(8512),
    [sym_reference_declarator] = STATE(5896),
    [sym_abstract_reference_declarator] = STATE(5942),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym__function_declarator_seq] = STATE(5919),
    [sym_template_type] = STATE(8512),
    [sym_template_function] = STATE(5896),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5765),
    [sym_qualified_identifier] = STATE(5896),
    [sym_operator_name] = STATE(5896),
    [aux_sym__type_definition_type_repeat1] = STATE(2664),
    [aux_sym_pointer_declarator_repeat1] = STATE(1998),
    [sym_identifier] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5730),
    [anon_sym_RPAREN] = ACTIONS(5730),
    [anon_sym_LPAREN2] = ACTIONS(4157),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5864),
    [anon_sym_AMP] = ACTIONS(5866),
    [anon_sym___extension__] = ACTIONS(3270),
    [anon_sym___attribute__] = ACTIONS(5732),
    [anon_sym___attribute] = ACTIONS(5732),
    [anon_sym_COLON_COLON] = ACTIONS(5708),
    [anon_sym___based] = ACTIONS(51),
    [sym_ms_restrict_modifier] = ACTIONS(3266),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(3266),
    [sym_ms_signed_ptr_modifier] = ACTIONS(3266),
    [anon_sym__unaligned] = ACTIONS(3268),
    [anon_sym___unaligned] = ACTIONS(3268),
    [anon_sym_LBRACK] = ACTIONS(5710),
    [anon_sym_const] = ACTIONS(3270),
    [anon_sym_constexpr] = ACTIONS(3270),
    [anon_sym_volatile] = ACTIONS(3270),
    [anon_sym_restrict] = ACTIONS(3270),
    [anon_sym___restrict__] = ACTIONS(3270),
    [anon_sym__Atomic] = ACTIONS(3270),
    [anon_sym__Noreturn] = ACTIONS(3270),
    [anon_sym_noreturn] = ACTIONS(3270),
    [anon_sym__Nonnull] = ACTIONS(3270),
    [anon_sym_mutable] = ACTIONS(3270),
    [anon_sym_constinit] = ACTIONS(3270),
    [anon_sym_consteval] = ACTIONS(3270),
    [anon_sym_alignas] = ACTIONS(3272),
    [anon_sym__Alignas] = ACTIONS(3272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_operator] = ACTIONS(1823),
  },
  [1998] = {
    [sym_ms_based_modifier] = STATE(7915),
    [sym_ms_unaligned_ptr_modifier] = STATE(3998),
    [sym_ms_pointer_modifier] = STATE(3851),
    [sym__declarator] = STATE(6275),
    [sym__abstract_declarator] = STATE(6587),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_abstract_parenthesized_declarator] = STATE(5942),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_abstract_pointer_declarator] = STATE(5942),
    [sym_function_declarator] = STATE(5896),
    [sym_abstract_function_declarator] = STATE(5942),
    [sym_array_declarator] = STATE(5896),
    [sym_abstract_array_declarator] = STATE(5942),
    [sym_type_qualifier] = STATE(2640),
    [sym_alignas_qualifier] = STATE(4266),
    [sym_parameter_list] = STATE(3233),
    [sym_decltype] = STATE(8512),
    [sym_reference_declarator] = STATE(5896),
    [sym_abstract_reference_declarator] = STATE(5942),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym__function_declarator_seq] = STATE(5919),
    [sym_template_type] = STATE(8512),
    [sym_template_function] = STATE(5896),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5765),
    [sym_qualified_identifier] = STATE(5896),
    [sym_operator_name] = STATE(5896),
    [aux_sym__type_definition_type_repeat1] = STATE(2640),
    [aux_sym_pointer_declarator_repeat1] = STATE(3851),
    [sym_identifier] = ACTIONS(5696),
    [anon_sym_COMMA] = ACTIONS(5698),
    [anon_sym_RPAREN] = ACTIONS(5698),
    [anon_sym_LPAREN2] = ACTIONS(4157),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5864),
    [anon_sym_AMP] = ACTIONS(5866),
    [anon_sym___extension__] = ACTIONS(3270),
    [anon_sym___attribute__] = ACTIONS(5706),
    [anon_sym___attribute] = ACTIONS(5706),
    [anon_sym_COLON_COLON] = ACTIONS(5708),
    [anon_sym___based] = ACTIONS(51),
    [sym_ms_restrict_modifier] = ACTIONS(3266),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(3266),
    [sym_ms_signed_ptr_modifier] = ACTIONS(3266),
    [anon_sym__unaligned] = ACTIONS(3268),
    [anon_sym___unaligned] = ACTIONS(3268),
    [anon_sym_LBRACK] = ACTIONS(5710),
    [anon_sym_const] = ACTIONS(3270),
    [anon_sym_constexpr] = ACTIONS(3270),
    [anon_sym_volatile] = ACTIONS(3270),
    [anon_sym_restrict] = ACTIONS(3270),
    [anon_sym___restrict__] = ACTIONS(3270),
    [anon_sym__Atomic] = ACTIONS(3270),
    [anon_sym__Noreturn] = ACTIONS(3270),
    [anon_sym_noreturn] = ACTIONS(3270),
    [anon_sym__Nonnull] = ACTIONS(3270),
    [anon_sym_mutable] = ACTIONS(3270),
    [anon_sym_constinit] = ACTIONS(3270),
    [anon_sym_consteval] = ACTIONS(3270),
    [anon_sym_alignas] = ACTIONS(3272),
    [anon_sym__Alignas] = ACTIONS(3272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_operator] = ACTIONS(1823),
  },
  [1999] = {
    [sym_identifier] = ACTIONS(2731),
    [aux_sym_preproc_def_token1] = ACTIONS(2731),
    [aux_sym_preproc_if_token1] = ACTIONS(2731),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2731),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2731),
    [sym_preproc_directive] = ACTIONS(2731),
    [anon_sym_LPAREN2] = ACTIONS(2733),
    [anon_sym_TILDE] = ACTIONS(2733),
    [anon_sym_STAR] = ACTIONS(2733),
    [anon_sym_AMP_AMP] = ACTIONS(2733),
    [anon_sym_AMP] = ACTIONS(2731),
    [anon_sym_SEMI] = ACTIONS(2733),
    [anon_sym___extension__] = ACTIONS(2731),
    [anon_sym_typedef] = ACTIONS(2731),
    [anon_sym_virtual] = ACTIONS(2731),
    [anon_sym_extern] = ACTIONS(2731),
    [anon_sym___attribute__] = ACTIONS(2731),
    [anon_sym___attribute] = ACTIONS(2731),
    [anon_sym_COLON_COLON] = ACTIONS(2733),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2733),
    [anon_sym___declspec] = ACTIONS(2731),
    [anon_sym___based] = ACTIONS(2731),
    [anon_sym_RBRACE] = ACTIONS(2733),
    [anon_sym_signed] = ACTIONS(2731),
    [anon_sym_unsigned] = ACTIONS(2731),
    [anon_sym_long] = ACTIONS(2731),
    [anon_sym_short] = ACTIONS(2731),
    [anon_sym_LBRACK] = ACTIONS(2731),
    [anon_sym_static] = ACTIONS(2731),
    [anon_sym_register] = ACTIONS(2731),
    [anon_sym_inline] = ACTIONS(2731),
    [anon_sym___inline] = ACTIONS(2731),
    [anon_sym___inline__] = ACTIONS(2731),
    [anon_sym___forceinline] = ACTIONS(2731),
    [anon_sym_thread_local] = ACTIONS(2731),
    [anon_sym___thread] = ACTIONS(2731),
    [anon_sym_const] = ACTIONS(2731),
    [anon_sym_constexpr] = ACTIONS(2731),
    [anon_sym_volatile] = ACTIONS(2731),
    [anon_sym_restrict] = ACTIONS(2731),
    [anon_sym___restrict__] = ACTIONS(2731),
    [anon_sym__Atomic] = ACTIONS(2731),
    [anon_sym__Noreturn] = ACTIONS(2731),
    [anon_sym_noreturn] = ACTIONS(2731),
    [anon_sym__Nonnull] = ACTIONS(2731),
    [anon_sym_mutable] = ACTIONS(2731),
    [anon_sym_constinit] = ACTIONS(2731),
    [anon_sym_consteval] = ACTIONS(2731),
    [anon_sym_alignas] = ACTIONS(2731),
    [anon_sym__Alignas] = ACTIONS(2731),
    [sym_primitive_type] = ACTIONS(2731),
    [anon_sym_enum] = ACTIONS(2731),
    [anon_sym_class] = ACTIONS(2731),
    [anon_sym_struct] = ACTIONS(2731),
    [anon_sym_union] = ACTIONS(2731),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2731),
    [anon_sym_decltype] = ACTIONS(2731),
    [anon_sym_explicit] = ACTIONS(2731),
    [anon_sym_typename] = ACTIONS(2731),
    [anon_sym_template] = ACTIONS(2731),
    [anon_sym_operator] = ACTIONS(2731),
    [anon_sym_friend] = ACTIONS(2731),
    [anon_sym_public] = ACTIONS(2731),
    [anon_sym_private] = ACTIONS(2731),
    [anon_sym_protected] = ACTIONS(2731),
    [anon_sym_using] = ACTIONS(2731),
    [anon_sym_static_assert] = ACTIONS(2731),
  },
  [2000] = {
    [sym_string_literal] = STATE(1952),
    [sym_template_argument_list] = STATE(2300),
    [sym_raw_string_literal] = STATE(1952),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4035),
    [anon_sym_COMMA] = ACTIONS(4035),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_DASH] = ACTIONS(4043),
    [anon_sym_PLUS] = ACTIONS(4043),
    [anon_sym_STAR] = ACTIONS(4043),
    [anon_sym_SLASH] = ACTIONS(4043),
    [anon_sym_PERCENT] = ACTIONS(4043),
    [anon_sym_PIPE_PIPE] = ACTIONS(4035),
    [anon_sym_AMP_AMP] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4043),
    [anon_sym_CARET] = ACTIONS(4043),
    [anon_sym_AMP] = ACTIONS(4043),
    [anon_sym_EQ_EQ] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4043),
    [anon_sym_GT_EQ] = ACTIONS(4035),
    [anon_sym_LT_EQ] = ACTIONS(4043),
    [anon_sym_LT] = ACTIONS(5237),
    [anon_sym_LT_LT] = ACTIONS(4043),
    [anon_sym_GT_GT] = ACTIONS(4043),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym___attribute__] = ACTIONS(4035),
    [anon_sym___attribute] = ACTIONS(4043),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACE] = ACTIONS(4059),
    [anon_sym_LBRACK] = ACTIONS(4035),
    [anon_sym_EQ] = ACTIONS(4043),
    [anon_sym_QMARK] = ACTIONS(4035),
    [anon_sym_STAR_EQ] = ACTIONS(4035),
    [anon_sym_SLASH_EQ] = ACTIONS(4035),
    [anon_sym_PERCENT_EQ] = ACTIONS(4035),
    [anon_sym_PLUS_EQ] = ACTIONS(4035),
    [anon_sym_DASH_EQ] = ACTIONS(4035),
    [anon_sym_LT_LT_EQ] = ACTIONS(4035),
    [anon_sym_GT_GT_EQ] = ACTIONS(4035),
    [anon_sym_AMP_EQ] = ACTIONS(4035),
    [anon_sym_CARET_EQ] = ACTIONS(4035),
    [anon_sym_PIPE_EQ] = ACTIONS(4035),
    [anon_sym_and_eq] = ACTIONS(4035),
    [anon_sym_or_eq] = ACTIONS(4035),
    [anon_sym_xor_eq] = ACTIONS(4035),
    [anon_sym_LT_EQ_GT] = ACTIONS(4035),
    [anon_sym_or] = ACTIONS(4043),
    [anon_sym_and] = ACTIONS(4043),
    [anon_sym_bitor] = ACTIONS(4035),
    [anon_sym_xor] = ACTIONS(4043),
    [anon_sym_bitand] = ACTIONS(4035),
    [anon_sym_not_eq] = ACTIONS(4035),
    [anon_sym_DASH_DASH] = ACTIONS(4035),
    [anon_sym_PLUS_PLUS] = ACTIONS(4035),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_DOT_STAR] = ACTIONS(4035),
    [anon_sym_DASH_GT] = ACTIONS(4035),
    [anon_sym_L_DQUOTE] = ACTIONS(5819),
    [anon_sym_u_DQUOTE] = ACTIONS(5819),
    [anon_sym_U_DQUOTE] = ACTIONS(5819),
    [anon_sym_u8_DQUOTE] = ACTIONS(5819),
    [anon_sym_DQUOTE] = ACTIONS(5819),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5821),
    [anon_sym_LR_DQUOTE] = ACTIONS(5821),
    [anon_sym_uR_DQUOTE] = ACTIONS(5821),
    [anon_sym_UR_DQUOTE] = ACTIONS(5821),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5821),
  },
  [2001] = {
    [sym_identifier] = ACTIONS(2735),
    [aux_sym_preproc_def_token1] = ACTIONS(2735),
    [aux_sym_preproc_if_token1] = ACTIONS(2735),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2735),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2735),
    [sym_preproc_directive] = ACTIONS(2735),
    [anon_sym_LPAREN2] = ACTIONS(2737),
    [anon_sym_TILDE] = ACTIONS(2737),
    [anon_sym_STAR] = ACTIONS(2737),
    [anon_sym_AMP_AMP] = ACTIONS(2737),
    [anon_sym_AMP] = ACTIONS(2735),
    [anon_sym_SEMI] = ACTIONS(2737),
    [anon_sym___extension__] = ACTIONS(2735),
    [anon_sym_typedef] = ACTIONS(2735),
    [anon_sym_virtual] = ACTIONS(2735),
    [anon_sym_extern] = ACTIONS(2735),
    [anon_sym___attribute__] = ACTIONS(2735),
    [anon_sym___attribute] = ACTIONS(2735),
    [anon_sym_COLON_COLON] = ACTIONS(2737),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2737),
    [anon_sym___declspec] = ACTIONS(2735),
    [anon_sym___based] = ACTIONS(2735),
    [anon_sym_RBRACE] = ACTIONS(2737),
    [anon_sym_signed] = ACTIONS(2735),
    [anon_sym_unsigned] = ACTIONS(2735),
    [anon_sym_long] = ACTIONS(2735),
    [anon_sym_short] = ACTIONS(2735),
    [anon_sym_LBRACK] = ACTIONS(2735),
    [anon_sym_static] = ACTIONS(2735),
    [anon_sym_register] = ACTIONS(2735),
    [anon_sym_inline] = ACTIONS(2735),
    [anon_sym___inline] = ACTIONS(2735),
    [anon_sym___inline__] = ACTIONS(2735),
    [anon_sym___forceinline] = ACTIONS(2735),
    [anon_sym_thread_local] = ACTIONS(2735),
    [anon_sym___thread] = ACTIONS(2735),
    [anon_sym_const] = ACTIONS(2735),
    [anon_sym_constexpr] = ACTIONS(2735),
    [anon_sym_volatile] = ACTIONS(2735),
    [anon_sym_restrict] = ACTIONS(2735),
    [anon_sym___restrict__] = ACTIONS(2735),
    [anon_sym__Atomic] = ACTIONS(2735),
    [anon_sym__Noreturn] = ACTIONS(2735),
    [anon_sym_noreturn] = ACTIONS(2735),
    [anon_sym__Nonnull] = ACTIONS(2735),
    [anon_sym_mutable] = ACTIONS(2735),
    [anon_sym_constinit] = ACTIONS(2735),
    [anon_sym_consteval] = ACTIONS(2735),
    [anon_sym_alignas] = ACTIONS(2735),
    [anon_sym__Alignas] = ACTIONS(2735),
    [sym_primitive_type] = ACTIONS(2735),
    [anon_sym_enum] = ACTIONS(2735),
    [anon_sym_class] = ACTIONS(2735),
    [anon_sym_struct] = ACTIONS(2735),
    [anon_sym_union] = ACTIONS(2735),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2735),
    [anon_sym_decltype] = ACTIONS(2735),
    [anon_sym_explicit] = ACTIONS(2735),
    [anon_sym_typename] = ACTIONS(2735),
    [anon_sym_template] = ACTIONS(2735),
    [anon_sym_operator] = ACTIONS(2735),
    [anon_sym_friend] = ACTIONS(2735),
    [anon_sym_public] = ACTIONS(2735),
    [anon_sym_private] = ACTIONS(2735),
    [anon_sym_protected] = ACTIONS(2735),
    [anon_sym_using] = ACTIONS(2735),
    [anon_sym_static_assert] = ACTIONS(2735),
  },
  [2002] = {
    [sym_identifier] = ACTIONS(5462),
    [aux_sym_preproc_def_token1] = ACTIONS(5462),
    [aux_sym_preproc_if_token1] = ACTIONS(5462),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5462),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5462),
    [sym_preproc_directive] = ACTIONS(5462),
    [anon_sym_LPAREN2] = ACTIONS(5464),
    [anon_sym_TILDE] = ACTIONS(5464),
    [anon_sym_STAR] = ACTIONS(5464),
    [anon_sym_AMP_AMP] = ACTIONS(5464),
    [anon_sym_AMP] = ACTIONS(5462),
    [anon_sym_SEMI] = ACTIONS(5464),
    [anon_sym___extension__] = ACTIONS(5462),
    [anon_sym_typedef] = ACTIONS(5462),
    [anon_sym_virtual] = ACTIONS(5462),
    [anon_sym_extern] = ACTIONS(5462),
    [anon_sym___attribute__] = ACTIONS(5462),
    [anon_sym___attribute] = ACTIONS(5462),
    [anon_sym_COLON_COLON] = ACTIONS(5464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5464),
    [anon_sym___declspec] = ACTIONS(5462),
    [anon_sym___based] = ACTIONS(5462),
    [anon_sym_RBRACE] = ACTIONS(5464),
    [anon_sym_signed] = ACTIONS(5462),
    [anon_sym_unsigned] = ACTIONS(5462),
    [anon_sym_long] = ACTIONS(5462),
    [anon_sym_short] = ACTIONS(5462),
    [anon_sym_LBRACK] = ACTIONS(5462),
    [anon_sym_static] = ACTIONS(5462),
    [anon_sym_register] = ACTIONS(5462),
    [anon_sym_inline] = ACTIONS(5462),
    [anon_sym___inline] = ACTIONS(5462),
    [anon_sym___inline__] = ACTIONS(5462),
    [anon_sym___forceinline] = ACTIONS(5462),
    [anon_sym_thread_local] = ACTIONS(5462),
    [anon_sym___thread] = ACTIONS(5462),
    [anon_sym_const] = ACTIONS(5462),
    [anon_sym_constexpr] = ACTIONS(5462),
    [anon_sym_volatile] = ACTIONS(5462),
    [anon_sym_restrict] = ACTIONS(5462),
    [anon_sym___restrict__] = ACTIONS(5462),
    [anon_sym__Atomic] = ACTIONS(5462),
    [anon_sym__Noreturn] = ACTIONS(5462),
    [anon_sym_noreturn] = ACTIONS(5462),
    [anon_sym__Nonnull] = ACTIONS(5462),
    [anon_sym_mutable] = ACTIONS(5462),
    [anon_sym_constinit] = ACTIONS(5462),
    [anon_sym_consteval] = ACTIONS(5462),
    [anon_sym_alignas] = ACTIONS(5462),
    [anon_sym__Alignas] = ACTIONS(5462),
    [sym_primitive_type] = ACTIONS(5462),
    [anon_sym_enum] = ACTIONS(5462),
    [anon_sym_class] = ACTIONS(5462),
    [anon_sym_struct] = ACTIONS(5462),
    [anon_sym_union] = ACTIONS(5462),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5462),
    [anon_sym_decltype] = ACTIONS(5462),
    [anon_sym_explicit] = ACTIONS(5462),
    [anon_sym_typename] = ACTIONS(5462),
    [anon_sym_template] = ACTIONS(5462),
    [anon_sym_operator] = ACTIONS(5462),
    [anon_sym_friend] = ACTIONS(5462),
    [anon_sym_public] = ACTIONS(5462),
    [anon_sym_private] = ACTIONS(5462),
    [anon_sym_protected] = ACTIONS(5462),
    [anon_sym_using] = ACTIONS(5462),
    [anon_sym_static_assert] = ACTIONS(5462),
  },
  [2003] = {
    [sym_identifier] = ACTIONS(3170),
    [aux_sym_preproc_def_token1] = ACTIONS(3170),
    [aux_sym_preproc_if_token1] = ACTIONS(3170),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3170),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3170),
    [sym_preproc_directive] = ACTIONS(3170),
    [anon_sym_LPAREN2] = ACTIONS(3172),
    [anon_sym_TILDE] = ACTIONS(3172),
    [anon_sym_STAR] = ACTIONS(3172),
    [anon_sym_AMP_AMP] = ACTIONS(3172),
    [anon_sym_AMP] = ACTIONS(3170),
    [anon_sym_SEMI] = ACTIONS(3172),
    [anon_sym___extension__] = ACTIONS(3170),
    [anon_sym_typedef] = ACTIONS(3170),
    [anon_sym_virtual] = ACTIONS(3170),
    [anon_sym_extern] = ACTIONS(3170),
    [anon_sym___attribute__] = ACTIONS(3170),
    [anon_sym___attribute] = ACTIONS(3170),
    [anon_sym_COLON_COLON] = ACTIONS(3172),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3172),
    [anon_sym___declspec] = ACTIONS(3170),
    [anon_sym___based] = ACTIONS(3170),
    [anon_sym_RBRACE] = ACTIONS(3172),
    [anon_sym_signed] = ACTIONS(3170),
    [anon_sym_unsigned] = ACTIONS(3170),
    [anon_sym_long] = ACTIONS(3170),
    [anon_sym_short] = ACTIONS(3170),
    [anon_sym_LBRACK] = ACTIONS(3170),
    [anon_sym_static] = ACTIONS(3170),
    [anon_sym_register] = ACTIONS(3170),
    [anon_sym_inline] = ACTIONS(3170),
    [anon_sym___inline] = ACTIONS(3170),
    [anon_sym___inline__] = ACTIONS(3170),
    [anon_sym___forceinline] = ACTIONS(3170),
    [anon_sym_thread_local] = ACTIONS(3170),
    [anon_sym___thread] = ACTIONS(3170),
    [anon_sym_const] = ACTIONS(3170),
    [anon_sym_constexpr] = ACTIONS(3170),
    [anon_sym_volatile] = ACTIONS(3170),
    [anon_sym_restrict] = ACTIONS(3170),
    [anon_sym___restrict__] = ACTIONS(3170),
    [anon_sym__Atomic] = ACTIONS(3170),
    [anon_sym__Noreturn] = ACTIONS(3170),
    [anon_sym_noreturn] = ACTIONS(3170),
    [anon_sym__Nonnull] = ACTIONS(3170),
    [anon_sym_mutable] = ACTIONS(3170),
    [anon_sym_constinit] = ACTIONS(3170),
    [anon_sym_consteval] = ACTIONS(3170),
    [anon_sym_alignas] = ACTIONS(3170),
    [anon_sym__Alignas] = ACTIONS(3170),
    [sym_primitive_type] = ACTIONS(3170),
    [anon_sym_enum] = ACTIONS(3170),
    [anon_sym_class] = ACTIONS(3170),
    [anon_sym_struct] = ACTIONS(3170),
    [anon_sym_union] = ACTIONS(3170),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3170),
    [anon_sym_decltype] = ACTIONS(3170),
    [anon_sym_explicit] = ACTIONS(3170),
    [anon_sym_typename] = ACTIONS(3170),
    [anon_sym_template] = ACTIONS(3170),
    [anon_sym_operator] = ACTIONS(3170),
    [anon_sym_friend] = ACTIONS(3170),
    [anon_sym_public] = ACTIONS(3170),
    [anon_sym_private] = ACTIONS(3170),
    [anon_sym_protected] = ACTIONS(3170),
    [anon_sym_using] = ACTIONS(3170),
    [anon_sym_static_assert] = ACTIONS(3170),
  },
  [2004] = {
    [sym_identifier] = ACTIONS(5490),
    [aux_sym_preproc_def_token1] = ACTIONS(5490),
    [aux_sym_preproc_if_token1] = ACTIONS(5490),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5490),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5490),
    [sym_preproc_directive] = ACTIONS(5490),
    [anon_sym_LPAREN2] = ACTIONS(5492),
    [anon_sym_TILDE] = ACTIONS(5492),
    [anon_sym_STAR] = ACTIONS(5492),
    [anon_sym_AMP_AMP] = ACTIONS(5492),
    [anon_sym_AMP] = ACTIONS(5490),
    [anon_sym_SEMI] = ACTIONS(5492),
    [anon_sym___extension__] = ACTIONS(5490),
    [anon_sym_typedef] = ACTIONS(5490),
    [anon_sym_virtual] = ACTIONS(5490),
    [anon_sym_extern] = ACTIONS(5490),
    [anon_sym___attribute__] = ACTIONS(5490),
    [anon_sym___attribute] = ACTIONS(5490),
    [anon_sym_COLON_COLON] = ACTIONS(5492),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5492),
    [anon_sym___declspec] = ACTIONS(5490),
    [anon_sym___based] = ACTIONS(5490),
    [anon_sym_RBRACE] = ACTIONS(5492),
    [anon_sym_signed] = ACTIONS(5490),
    [anon_sym_unsigned] = ACTIONS(5490),
    [anon_sym_long] = ACTIONS(5490),
    [anon_sym_short] = ACTIONS(5490),
    [anon_sym_LBRACK] = ACTIONS(5490),
    [anon_sym_static] = ACTIONS(5490),
    [anon_sym_register] = ACTIONS(5490),
    [anon_sym_inline] = ACTIONS(5490),
    [anon_sym___inline] = ACTIONS(5490),
    [anon_sym___inline__] = ACTIONS(5490),
    [anon_sym___forceinline] = ACTIONS(5490),
    [anon_sym_thread_local] = ACTIONS(5490),
    [anon_sym___thread] = ACTIONS(5490),
    [anon_sym_const] = ACTIONS(5490),
    [anon_sym_constexpr] = ACTIONS(5490),
    [anon_sym_volatile] = ACTIONS(5490),
    [anon_sym_restrict] = ACTIONS(5490),
    [anon_sym___restrict__] = ACTIONS(5490),
    [anon_sym__Atomic] = ACTIONS(5490),
    [anon_sym__Noreturn] = ACTIONS(5490),
    [anon_sym_noreturn] = ACTIONS(5490),
    [anon_sym__Nonnull] = ACTIONS(5490),
    [anon_sym_mutable] = ACTIONS(5490),
    [anon_sym_constinit] = ACTIONS(5490),
    [anon_sym_consteval] = ACTIONS(5490),
    [anon_sym_alignas] = ACTIONS(5490),
    [anon_sym__Alignas] = ACTIONS(5490),
    [sym_primitive_type] = ACTIONS(5490),
    [anon_sym_enum] = ACTIONS(5490),
    [anon_sym_class] = ACTIONS(5490),
    [anon_sym_struct] = ACTIONS(5490),
    [anon_sym_union] = ACTIONS(5490),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5490),
    [anon_sym_decltype] = ACTIONS(5490),
    [anon_sym_explicit] = ACTIONS(5490),
    [anon_sym_typename] = ACTIONS(5490),
    [anon_sym_template] = ACTIONS(5490),
    [anon_sym_operator] = ACTIONS(5490),
    [anon_sym_friend] = ACTIONS(5490),
    [anon_sym_public] = ACTIONS(5490),
    [anon_sym_private] = ACTIONS(5490),
    [anon_sym_protected] = ACTIONS(5490),
    [anon_sym_using] = ACTIONS(5490),
    [anon_sym_static_assert] = ACTIONS(5490),
  },
  [2005] = {
    [sym_identifier] = ACTIONS(2689),
    [aux_sym_preproc_def_token1] = ACTIONS(2689),
    [aux_sym_preproc_if_token1] = ACTIONS(2689),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2689),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2689),
    [sym_preproc_directive] = ACTIONS(2689),
    [anon_sym_LPAREN2] = ACTIONS(2691),
    [anon_sym_TILDE] = ACTIONS(2691),
    [anon_sym_STAR] = ACTIONS(2691),
    [anon_sym_AMP_AMP] = ACTIONS(2691),
    [anon_sym_AMP] = ACTIONS(2689),
    [anon_sym_SEMI] = ACTIONS(2691),
    [anon_sym___extension__] = ACTIONS(2689),
    [anon_sym_typedef] = ACTIONS(2689),
    [anon_sym_virtual] = ACTIONS(2689),
    [anon_sym_extern] = ACTIONS(2689),
    [anon_sym___attribute__] = ACTIONS(2689),
    [anon_sym___attribute] = ACTIONS(2689),
    [anon_sym_COLON_COLON] = ACTIONS(2691),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2691),
    [anon_sym___declspec] = ACTIONS(2689),
    [anon_sym___based] = ACTIONS(2689),
    [anon_sym_RBRACE] = ACTIONS(2691),
    [anon_sym_signed] = ACTIONS(2689),
    [anon_sym_unsigned] = ACTIONS(2689),
    [anon_sym_long] = ACTIONS(2689),
    [anon_sym_short] = ACTIONS(2689),
    [anon_sym_LBRACK] = ACTIONS(2689),
    [anon_sym_static] = ACTIONS(2689),
    [anon_sym_register] = ACTIONS(2689),
    [anon_sym_inline] = ACTIONS(2689),
    [anon_sym___inline] = ACTIONS(2689),
    [anon_sym___inline__] = ACTIONS(2689),
    [anon_sym___forceinline] = ACTIONS(2689),
    [anon_sym_thread_local] = ACTIONS(2689),
    [anon_sym___thread] = ACTIONS(2689),
    [anon_sym_const] = ACTIONS(2689),
    [anon_sym_constexpr] = ACTIONS(2689),
    [anon_sym_volatile] = ACTIONS(2689),
    [anon_sym_restrict] = ACTIONS(2689),
    [anon_sym___restrict__] = ACTIONS(2689),
    [anon_sym__Atomic] = ACTIONS(2689),
    [anon_sym__Noreturn] = ACTIONS(2689),
    [anon_sym_noreturn] = ACTIONS(2689),
    [anon_sym__Nonnull] = ACTIONS(2689),
    [anon_sym_mutable] = ACTIONS(2689),
    [anon_sym_constinit] = ACTIONS(2689),
    [anon_sym_consteval] = ACTIONS(2689),
    [anon_sym_alignas] = ACTIONS(2689),
    [anon_sym__Alignas] = ACTIONS(2689),
    [sym_primitive_type] = ACTIONS(2689),
    [anon_sym_enum] = ACTIONS(2689),
    [anon_sym_class] = ACTIONS(2689),
    [anon_sym_struct] = ACTIONS(2689),
    [anon_sym_union] = ACTIONS(2689),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2689),
    [anon_sym_decltype] = ACTIONS(2689),
    [anon_sym_explicit] = ACTIONS(2689),
    [anon_sym_typename] = ACTIONS(2689),
    [anon_sym_template] = ACTIONS(2689),
    [anon_sym_operator] = ACTIONS(2689),
    [anon_sym_friend] = ACTIONS(2689),
    [anon_sym_public] = ACTIONS(2689),
    [anon_sym_private] = ACTIONS(2689),
    [anon_sym_protected] = ACTIONS(2689),
    [anon_sym_using] = ACTIONS(2689),
    [anon_sym_static_assert] = ACTIONS(2689),
  },
  [2006] = {
    [sym_identifier] = ACTIONS(3818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3820),
    [anon_sym_COMMA] = ACTIONS(3820),
    [anon_sym_RPAREN] = ACTIONS(3820),
    [anon_sym_LPAREN2] = ACTIONS(3820),
    [anon_sym_TILDE] = ACTIONS(3820),
    [anon_sym_STAR] = ACTIONS(3820),
    [anon_sym_AMP_AMP] = ACTIONS(3820),
    [anon_sym_AMP] = ACTIONS(3818),
    [anon_sym_SEMI] = ACTIONS(3820),
    [anon_sym___extension__] = ACTIONS(3818),
    [anon_sym_virtual] = ACTIONS(3818),
    [anon_sym_extern] = ACTIONS(3818),
    [anon_sym___attribute__] = ACTIONS(3818),
    [anon_sym___attribute] = ACTIONS(3818),
    [anon_sym_COLON_COLON] = ACTIONS(3820),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3820),
    [anon_sym___declspec] = ACTIONS(3818),
    [anon_sym___based] = ACTIONS(3818),
    [anon_sym___cdecl] = ACTIONS(3818),
    [anon_sym___clrcall] = ACTIONS(3818),
    [anon_sym___stdcall] = ACTIONS(3818),
    [anon_sym___fastcall] = ACTIONS(3818),
    [anon_sym___thiscall] = ACTIONS(3818),
    [anon_sym___vectorcall] = ACTIONS(3818),
    [anon_sym_LBRACE] = ACTIONS(3820),
    [anon_sym_LBRACK] = ACTIONS(3818),
    [anon_sym_static] = ACTIONS(3818),
    [anon_sym_EQ] = ACTIONS(3820),
    [anon_sym_register] = ACTIONS(3818),
    [anon_sym_inline] = ACTIONS(3818),
    [anon_sym___inline] = ACTIONS(3818),
    [anon_sym___inline__] = ACTIONS(3818),
    [anon_sym___forceinline] = ACTIONS(3818),
    [anon_sym_thread_local] = ACTIONS(3818),
    [anon_sym___thread] = ACTIONS(3818),
    [anon_sym_const] = ACTIONS(3818),
    [anon_sym_constexpr] = ACTIONS(3818),
    [anon_sym_volatile] = ACTIONS(3818),
    [anon_sym_restrict] = ACTIONS(3818),
    [anon_sym___restrict__] = ACTIONS(3818),
    [anon_sym__Atomic] = ACTIONS(3818),
    [anon_sym__Noreturn] = ACTIONS(3818),
    [anon_sym_noreturn] = ACTIONS(3818),
    [anon_sym__Nonnull] = ACTIONS(3818),
    [anon_sym_mutable] = ACTIONS(3818),
    [anon_sym_constinit] = ACTIONS(3818),
    [anon_sym_consteval] = ACTIONS(3818),
    [anon_sym_alignas] = ACTIONS(3818),
    [anon_sym__Alignas] = ACTIONS(3818),
    [anon_sym_COLON] = ACTIONS(3818),
    [anon_sym_asm] = ACTIONS(3818),
    [anon_sym___asm__] = ACTIONS(3818),
    [anon_sym___asm] = ACTIONS(3818),
    [anon_sym_DASH_GT] = ACTIONS(3820),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3818),
    [anon_sym_final] = ACTIONS(3818),
    [anon_sym_override] = ACTIONS(3818),
    [anon_sym_explicit] = ACTIONS(3818),
    [anon_sym_template] = ACTIONS(3818),
    [anon_sym_GT2] = ACTIONS(3820),
    [anon_sym_operator] = ACTIONS(3818),
    [anon_sym_try] = ACTIONS(3818),
    [anon_sym_public] = ACTIONS(3818),
    [anon_sym_private] = ACTIONS(3818),
    [anon_sym_protected] = ACTIONS(3818),
    [anon_sym_requires] = ACTIONS(3818),
  },
  [2007] = {
    [sym_identifier] = ACTIONS(2830),
    [aux_sym_preproc_def_token1] = ACTIONS(2830),
    [aux_sym_preproc_if_token1] = ACTIONS(2830),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2830),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2830),
    [sym_preproc_directive] = ACTIONS(2830),
    [anon_sym_LPAREN2] = ACTIONS(2832),
    [anon_sym_TILDE] = ACTIONS(2832),
    [anon_sym_STAR] = ACTIONS(2832),
    [anon_sym_AMP_AMP] = ACTIONS(2832),
    [anon_sym_AMP] = ACTIONS(2830),
    [anon_sym_SEMI] = ACTIONS(2832),
    [anon_sym___extension__] = ACTIONS(2830),
    [anon_sym_typedef] = ACTIONS(2830),
    [anon_sym_virtual] = ACTIONS(2830),
    [anon_sym_extern] = ACTIONS(2830),
    [anon_sym___attribute__] = ACTIONS(2830),
    [anon_sym___attribute] = ACTIONS(2830),
    [anon_sym_COLON_COLON] = ACTIONS(2832),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2832),
    [anon_sym___declspec] = ACTIONS(2830),
    [anon_sym___based] = ACTIONS(2830),
    [anon_sym_RBRACE] = ACTIONS(2832),
    [anon_sym_signed] = ACTIONS(2830),
    [anon_sym_unsigned] = ACTIONS(2830),
    [anon_sym_long] = ACTIONS(2830),
    [anon_sym_short] = ACTIONS(2830),
    [anon_sym_LBRACK] = ACTIONS(2830),
    [anon_sym_static] = ACTIONS(2830),
    [anon_sym_register] = ACTIONS(2830),
    [anon_sym_inline] = ACTIONS(2830),
    [anon_sym___inline] = ACTIONS(2830),
    [anon_sym___inline__] = ACTIONS(2830),
    [anon_sym___forceinline] = ACTIONS(2830),
    [anon_sym_thread_local] = ACTIONS(2830),
    [anon_sym___thread] = ACTIONS(2830),
    [anon_sym_const] = ACTIONS(2830),
    [anon_sym_constexpr] = ACTIONS(2830),
    [anon_sym_volatile] = ACTIONS(2830),
    [anon_sym_restrict] = ACTIONS(2830),
    [anon_sym___restrict__] = ACTIONS(2830),
    [anon_sym__Atomic] = ACTIONS(2830),
    [anon_sym__Noreturn] = ACTIONS(2830),
    [anon_sym_noreturn] = ACTIONS(2830),
    [anon_sym__Nonnull] = ACTIONS(2830),
    [anon_sym_mutable] = ACTIONS(2830),
    [anon_sym_constinit] = ACTIONS(2830),
    [anon_sym_consteval] = ACTIONS(2830),
    [anon_sym_alignas] = ACTIONS(2830),
    [anon_sym__Alignas] = ACTIONS(2830),
    [sym_primitive_type] = ACTIONS(2830),
    [anon_sym_enum] = ACTIONS(2830),
    [anon_sym_class] = ACTIONS(2830),
    [anon_sym_struct] = ACTIONS(2830),
    [anon_sym_union] = ACTIONS(2830),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2830),
    [anon_sym_decltype] = ACTIONS(2830),
    [anon_sym_explicit] = ACTIONS(2830),
    [anon_sym_typename] = ACTIONS(2830),
    [anon_sym_template] = ACTIONS(2830),
    [anon_sym_operator] = ACTIONS(2830),
    [anon_sym_friend] = ACTIONS(2830),
    [anon_sym_public] = ACTIONS(2830),
    [anon_sym_private] = ACTIONS(2830),
    [anon_sym_protected] = ACTIONS(2830),
    [anon_sym_using] = ACTIONS(2830),
    [anon_sym_static_assert] = ACTIONS(2830),
  },
  [2008] = {
    [sym__declaration_modifiers] = STATE(3242),
    [sym_attribute_specifier] = STATE(3242),
    [sym_attribute_declaration] = STATE(3242),
    [sym_ms_declspec_modifier] = STATE(3242),
    [sym_storage_class_specifier] = STATE(3242),
    [sym_type_qualifier] = STATE(3242),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2364),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2336),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(6493),
    [sym_qualified_type_identifier] = STATE(2978),
    [aux_sym__declaration_specifiers_repeat1] = STATE(3242),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(5025),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(5852),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5027),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3216),
    [anon_sym_struct] = ACTIONS(3218),
    [anon_sym_union] = ACTIONS(3220),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(3222),
    [anon_sym_template] = ACTIONS(1235),
  },
  [2009] = {
    [sym_identifier] = ACTIONS(2763),
    [aux_sym_preproc_def_token1] = ACTIONS(2763),
    [aux_sym_preproc_if_token1] = ACTIONS(2763),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2763),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2763),
    [sym_preproc_directive] = ACTIONS(2763),
    [anon_sym_LPAREN2] = ACTIONS(2765),
    [anon_sym_TILDE] = ACTIONS(2765),
    [anon_sym_STAR] = ACTIONS(2765),
    [anon_sym_AMP_AMP] = ACTIONS(2765),
    [anon_sym_AMP] = ACTIONS(2763),
    [anon_sym_SEMI] = ACTIONS(2765),
    [anon_sym___extension__] = ACTIONS(2763),
    [anon_sym_typedef] = ACTIONS(2763),
    [anon_sym_virtual] = ACTIONS(2763),
    [anon_sym_extern] = ACTIONS(2763),
    [anon_sym___attribute__] = ACTIONS(2763),
    [anon_sym___attribute] = ACTIONS(2763),
    [anon_sym_COLON_COLON] = ACTIONS(2765),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2765),
    [anon_sym___declspec] = ACTIONS(2763),
    [anon_sym___based] = ACTIONS(2763),
    [anon_sym_RBRACE] = ACTIONS(2765),
    [anon_sym_signed] = ACTIONS(2763),
    [anon_sym_unsigned] = ACTIONS(2763),
    [anon_sym_long] = ACTIONS(2763),
    [anon_sym_short] = ACTIONS(2763),
    [anon_sym_LBRACK] = ACTIONS(2763),
    [anon_sym_static] = ACTIONS(2763),
    [anon_sym_register] = ACTIONS(2763),
    [anon_sym_inline] = ACTIONS(2763),
    [anon_sym___inline] = ACTIONS(2763),
    [anon_sym___inline__] = ACTIONS(2763),
    [anon_sym___forceinline] = ACTIONS(2763),
    [anon_sym_thread_local] = ACTIONS(2763),
    [anon_sym___thread] = ACTIONS(2763),
    [anon_sym_const] = ACTIONS(2763),
    [anon_sym_constexpr] = ACTIONS(2763),
    [anon_sym_volatile] = ACTIONS(2763),
    [anon_sym_restrict] = ACTIONS(2763),
    [anon_sym___restrict__] = ACTIONS(2763),
    [anon_sym__Atomic] = ACTIONS(2763),
    [anon_sym__Noreturn] = ACTIONS(2763),
    [anon_sym_noreturn] = ACTIONS(2763),
    [anon_sym__Nonnull] = ACTIONS(2763),
    [anon_sym_mutable] = ACTIONS(2763),
    [anon_sym_constinit] = ACTIONS(2763),
    [anon_sym_consteval] = ACTIONS(2763),
    [anon_sym_alignas] = ACTIONS(2763),
    [anon_sym__Alignas] = ACTIONS(2763),
    [sym_primitive_type] = ACTIONS(2763),
    [anon_sym_enum] = ACTIONS(2763),
    [anon_sym_class] = ACTIONS(2763),
    [anon_sym_struct] = ACTIONS(2763),
    [anon_sym_union] = ACTIONS(2763),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2763),
    [anon_sym_decltype] = ACTIONS(2763),
    [anon_sym_explicit] = ACTIONS(2763),
    [anon_sym_typename] = ACTIONS(2763),
    [anon_sym_template] = ACTIONS(2763),
    [anon_sym_operator] = ACTIONS(2763),
    [anon_sym_friend] = ACTIONS(2763),
    [anon_sym_public] = ACTIONS(2763),
    [anon_sym_private] = ACTIONS(2763),
    [anon_sym_protected] = ACTIONS(2763),
    [anon_sym_using] = ACTIONS(2763),
    [anon_sym_static_assert] = ACTIONS(2763),
  },
  [2010] = {
    [sym_identifier] = ACTIONS(2767),
    [aux_sym_preproc_def_token1] = ACTIONS(2767),
    [aux_sym_preproc_if_token1] = ACTIONS(2767),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2767),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2767),
    [sym_preproc_directive] = ACTIONS(2767),
    [anon_sym_LPAREN2] = ACTIONS(2769),
    [anon_sym_TILDE] = ACTIONS(2769),
    [anon_sym_STAR] = ACTIONS(2769),
    [anon_sym_AMP_AMP] = ACTIONS(2769),
    [anon_sym_AMP] = ACTIONS(2767),
    [anon_sym_SEMI] = ACTIONS(2769),
    [anon_sym___extension__] = ACTIONS(2767),
    [anon_sym_typedef] = ACTIONS(2767),
    [anon_sym_virtual] = ACTIONS(2767),
    [anon_sym_extern] = ACTIONS(2767),
    [anon_sym___attribute__] = ACTIONS(2767),
    [anon_sym___attribute] = ACTIONS(2767),
    [anon_sym_COLON_COLON] = ACTIONS(2769),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2769),
    [anon_sym___declspec] = ACTIONS(2767),
    [anon_sym___based] = ACTIONS(2767),
    [anon_sym_RBRACE] = ACTIONS(2769),
    [anon_sym_signed] = ACTIONS(2767),
    [anon_sym_unsigned] = ACTIONS(2767),
    [anon_sym_long] = ACTIONS(2767),
    [anon_sym_short] = ACTIONS(2767),
    [anon_sym_LBRACK] = ACTIONS(2767),
    [anon_sym_static] = ACTIONS(2767),
    [anon_sym_register] = ACTIONS(2767),
    [anon_sym_inline] = ACTIONS(2767),
    [anon_sym___inline] = ACTIONS(2767),
    [anon_sym___inline__] = ACTIONS(2767),
    [anon_sym___forceinline] = ACTIONS(2767),
    [anon_sym_thread_local] = ACTIONS(2767),
    [anon_sym___thread] = ACTIONS(2767),
    [anon_sym_const] = ACTIONS(2767),
    [anon_sym_constexpr] = ACTIONS(2767),
    [anon_sym_volatile] = ACTIONS(2767),
    [anon_sym_restrict] = ACTIONS(2767),
    [anon_sym___restrict__] = ACTIONS(2767),
    [anon_sym__Atomic] = ACTIONS(2767),
    [anon_sym__Noreturn] = ACTIONS(2767),
    [anon_sym_noreturn] = ACTIONS(2767),
    [anon_sym__Nonnull] = ACTIONS(2767),
    [anon_sym_mutable] = ACTIONS(2767),
    [anon_sym_constinit] = ACTIONS(2767),
    [anon_sym_consteval] = ACTIONS(2767),
    [anon_sym_alignas] = ACTIONS(2767),
    [anon_sym__Alignas] = ACTIONS(2767),
    [sym_primitive_type] = ACTIONS(2767),
    [anon_sym_enum] = ACTIONS(2767),
    [anon_sym_class] = ACTIONS(2767),
    [anon_sym_struct] = ACTIONS(2767),
    [anon_sym_union] = ACTIONS(2767),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2767),
    [anon_sym_decltype] = ACTIONS(2767),
    [anon_sym_explicit] = ACTIONS(2767),
    [anon_sym_typename] = ACTIONS(2767),
    [anon_sym_template] = ACTIONS(2767),
    [anon_sym_operator] = ACTIONS(2767),
    [anon_sym_friend] = ACTIONS(2767),
    [anon_sym_public] = ACTIONS(2767),
    [anon_sym_private] = ACTIONS(2767),
    [anon_sym_protected] = ACTIONS(2767),
    [anon_sym_using] = ACTIONS(2767),
    [anon_sym_static_assert] = ACTIONS(2767),
  },
  [2011] = {
    [sym_identifier] = ACTIONS(5439),
    [aux_sym_preproc_def_token1] = ACTIONS(5439),
    [aux_sym_preproc_if_token1] = ACTIONS(5439),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5439),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5439),
    [sym_preproc_directive] = ACTIONS(5439),
    [anon_sym_LPAREN2] = ACTIONS(5441),
    [anon_sym_TILDE] = ACTIONS(5441),
    [anon_sym_STAR] = ACTIONS(5441),
    [anon_sym_AMP_AMP] = ACTIONS(5441),
    [anon_sym_AMP] = ACTIONS(5439),
    [anon_sym_SEMI] = ACTIONS(5441),
    [anon_sym___extension__] = ACTIONS(5439),
    [anon_sym_typedef] = ACTIONS(5439),
    [anon_sym_virtual] = ACTIONS(5439),
    [anon_sym_extern] = ACTIONS(5439),
    [anon_sym___attribute__] = ACTIONS(5439),
    [anon_sym___attribute] = ACTIONS(5439),
    [anon_sym_COLON_COLON] = ACTIONS(5441),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5441),
    [anon_sym___declspec] = ACTIONS(5439),
    [anon_sym___based] = ACTIONS(5439),
    [anon_sym_RBRACE] = ACTIONS(5441),
    [anon_sym_signed] = ACTIONS(5439),
    [anon_sym_unsigned] = ACTIONS(5439),
    [anon_sym_long] = ACTIONS(5439),
    [anon_sym_short] = ACTIONS(5439),
    [anon_sym_LBRACK] = ACTIONS(5439),
    [anon_sym_static] = ACTIONS(5439),
    [anon_sym_register] = ACTIONS(5439),
    [anon_sym_inline] = ACTIONS(5439),
    [anon_sym___inline] = ACTIONS(5439),
    [anon_sym___inline__] = ACTIONS(5439),
    [anon_sym___forceinline] = ACTIONS(5439),
    [anon_sym_thread_local] = ACTIONS(5439),
    [anon_sym___thread] = ACTIONS(5439),
    [anon_sym_const] = ACTIONS(5439),
    [anon_sym_constexpr] = ACTIONS(5439),
    [anon_sym_volatile] = ACTIONS(5439),
    [anon_sym_restrict] = ACTIONS(5439),
    [anon_sym___restrict__] = ACTIONS(5439),
    [anon_sym__Atomic] = ACTIONS(5439),
    [anon_sym__Noreturn] = ACTIONS(5439),
    [anon_sym_noreturn] = ACTIONS(5439),
    [anon_sym__Nonnull] = ACTIONS(5439),
    [anon_sym_mutable] = ACTIONS(5439),
    [anon_sym_constinit] = ACTIONS(5439),
    [anon_sym_consteval] = ACTIONS(5439),
    [anon_sym_alignas] = ACTIONS(5439),
    [anon_sym__Alignas] = ACTIONS(5439),
    [sym_primitive_type] = ACTIONS(5439),
    [anon_sym_enum] = ACTIONS(5439),
    [anon_sym_class] = ACTIONS(5439),
    [anon_sym_struct] = ACTIONS(5439),
    [anon_sym_union] = ACTIONS(5439),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5439),
    [anon_sym_decltype] = ACTIONS(5439),
    [anon_sym_explicit] = ACTIONS(5439),
    [anon_sym_typename] = ACTIONS(5439),
    [anon_sym_template] = ACTIONS(5439),
    [anon_sym_operator] = ACTIONS(5439),
    [anon_sym_friend] = ACTIONS(5439),
    [anon_sym_public] = ACTIONS(5439),
    [anon_sym_private] = ACTIONS(5439),
    [anon_sym_protected] = ACTIONS(5439),
    [anon_sym_using] = ACTIONS(5439),
    [anon_sym_static_assert] = ACTIONS(5439),
  },
  [2012] = {
    [sym_identifier] = ACTIONS(5439),
    [aux_sym_preproc_def_token1] = ACTIONS(5439),
    [aux_sym_preproc_if_token1] = ACTIONS(5439),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5439),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5439),
    [sym_preproc_directive] = ACTIONS(5439),
    [anon_sym_LPAREN2] = ACTIONS(5441),
    [anon_sym_TILDE] = ACTIONS(5441),
    [anon_sym_STAR] = ACTIONS(5441),
    [anon_sym_AMP_AMP] = ACTIONS(5441),
    [anon_sym_AMP] = ACTIONS(5439),
    [anon_sym_SEMI] = ACTIONS(5441),
    [anon_sym___extension__] = ACTIONS(5439),
    [anon_sym_typedef] = ACTIONS(5439),
    [anon_sym_virtual] = ACTIONS(5439),
    [anon_sym_extern] = ACTIONS(5439),
    [anon_sym___attribute__] = ACTIONS(5439),
    [anon_sym___attribute] = ACTIONS(5439),
    [anon_sym_COLON_COLON] = ACTIONS(5441),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5441),
    [anon_sym___declspec] = ACTIONS(5439),
    [anon_sym___based] = ACTIONS(5439),
    [anon_sym_RBRACE] = ACTIONS(5441),
    [anon_sym_signed] = ACTIONS(5439),
    [anon_sym_unsigned] = ACTIONS(5439),
    [anon_sym_long] = ACTIONS(5439),
    [anon_sym_short] = ACTIONS(5439),
    [anon_sym_LBRACK] = ACTIONS(5439),
    [anon_sym_static] = ACTIONS(5439),
    [anon_sym_register] = ACTIONS(5439),
    [anon_sym_inline] = ACTIONS(5439),
    [anon_sym___inline] = ACTIONS(5439),
    [anon_sym___inline__] = ACTIONS(5439),
    [anon_sym___forceinline] = ACTIONS(5439),
    [anon_sym_thread_local] = ACTIONS(5439),
    [anon_sym___thread] = ACTIONS(5439),
    [anon_sym_const] = ACTIONS(5439),
    [anon_sym_constexpr] = ACTIONS(5439),
    [anon_sym_volatile] = ACTIONS(5439),
    [anon_sym_restrict] = ACTIONS(5439),
    [anon_sym___restrict__] = ACTIONS(5439),
    [anon_sym__Atomic] = ACTIONS(5439),
    [anon_sym__Noreturn] = ACTIONS(5439),
    [anon_sym_noreturn] = ACTIONS(5439),
    [anon_sym__Nonnull] = ACTIONS(5439),
    [anon_sym_mutable] = ACTIONS(5439),
    [anon_sym_constinit] = ACTIONS(5439),
    [anon_sym_consteval] = ACTIONS(5439),
    [anon_sym_alignas] = ACTIONS(5439),
    [anon_sym__Alignas] = ACTIONS(5439),
    [sym_primitive_type] = ACTIONS(5439),
    [anon_sym_enum] = ACTIONS(5439),
    [anon_sym_class] = ACTIONS(5439),
    [anon_sym_struct] = ACTIONS(5439),
    [anon_sym_union] = ACTIONS(5439),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5439),
    [anon_sym_decltype] = ACTIONS(5439),
    [anon_sym_explicit] = ACTIONS(5439),
    [anon_sym_typename] = ACTIONS(5439),
    [anon_sym_template] = ACTIONS(5439),
    [anon_sym_operator] = ACTIONS(5439),
    [anon_sym_friend] = ACTIONS(5439),
    [anon_sym_public] = ACTIONS(5439),
    [anon_sym_private] = ACTIONS(5439),
    [anon_sym_protected] = ACTIONS(5439),
    [anon_sym_using] = ACTIONS(5439),
    [anon_sym_static_assert] = ACTIONS(5439),
  },
  [2013] = {
    [sym_identifier] = ACTIONS(5458),
    [aux_sym_preproc_def_token1] = ACTIONS(5458),
    [aux_sym_preproc_if_token1] = ACTIONS(5458),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5458),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5458),
    [sym_preproc_directive] = ACTIONS(5458),
    [anon_sym_LPAREN2] = ACTIONS(5460),
    [anon_sym_TILDE] = ACTIONS(5460),
    [anon_sym_STAR] = ACTIONS(5460),
    [anon_sym_AMP_AMP] = ACTIONS(5460),
    [anon_sym_AMP] = ACTIONS(5458),
    [anon_sym_SEMI] = ACTIONS(5460),
    [anon_sym___extension__] = ACTIONS(5458),
    [anon_sym_typedef] = ACTIONS(5458),
    [anon_sym_virtual] = ACTIONS(5458),
    [anon_sym_extern] = ACTIONS(5458),
    [anon_sym___attribute__] = ACTIONS(5458),
    [anon_sym___attribute] = ACTIONS(5458),
    [anon_sym_COLON_COLON] = ACTIONS(5460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5460),
    [anon_sym___declspec] = ACTIONS(5458),
    [anon_sym___based] = ACTIONS(5458),
    [anon_sym_RBRACE] = ACTIONS(5460),
    [anon_sym_signed] = ACTIONS(5458),
    [anon_sym_unsigned] = ACTIONS(5458),
    [anon_sym_long] = ACTIONS(5458),
    [anon_sym_short] = ACTIONS(5458),
    [anon_sym_LBRACK] = ACTIONS(5458),
    [anon_sym_static] = ACTIONS(5458),
    [anon_sym_register] = ACTIONS(5458),
    [anon_sym_inline] = ACTIONS(5458),
    [anon_sym___inline] = ACTIONS(5458),
    [anon_sym___inline__] = ACTIONS(5458),
    [anon_sym___forceinline] = ACTIONS(5458),
    [anon_sym_thread_local] = ACTIONS(5458),
    [anon_sym___thread] = ACTIONS(5458),
    [anon_sym_const] = ACTIONS(5458),
    [anon_sym_constexpr] = ACTIONS(5458),
    [anon_sym_volatile] = ACTIONS(5458),
    [anon_sym_restrict] = ACTIONS(5458),
    [anon_sym___restrict__] = ACTIONS(5458),
    [anon_sym__Atomic] = ACTIONS(5458),
    [anon_sym__Noreturn] = ACTIONS(5458),
    [anon_sym_noreturn] = ACTIONS(5458),
    [anon_sym__Nonnull] = ACTIONS(5458),
    [anon_sym_mutable] = ACTIONS(5458),
    [anon_sym_constinit] = ACTIONS(5458),
    [anon_sym_consteval] = ACTIONS(5458),
    [anon_sym_alignas] = ACTIONS(5458),
    [anon_sym__Alignas] = ACTIONS(5458),
    [sym_primitive_type] = ACTIONS(5458),
    [anon_sym_enum] = ACTIONS(5458),
    [anon_sym_class] = ACTIONS(5458),
    [anon_sym_struct] = ACTIONS(5458),
    [anon_sym_union] = ACTIONS(5458),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5458),
    [anon_sym_decltype] = ACTIONS(5458),
    [anon_sym_explicit] = ACTIONS(5458),
    [anon_sym_typename] = ACTIONS(5458),
    [anon_sym_template] = ACTIONS(5458),
    [anon_sym_operator] = ACTIONS(5458),
    [anon_sym_friend] = ACTIONS(5458),
    [anon_sym_public] = ACTIONS(5458),
    [anon_sym_private] = ACTIONS(5458),
    [anon_sym_protected] = ACTIONS(5458),
    [anon_sym_using] = ACTIONS(5458),
    [anon_sym_static_assert] = ACTIONS(5458),
  },
  [2014] = {
    [sym_identifier] = ACTIONS(5466),
    [aux_sym_preproc_def_token1] = ACTIONS(5466),
    [aux_sym_preproc_if_token1] = ACTIONS(5466),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5466),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5466),
    [sym_preproc_directive] = ACTIONS(5466),
    [anon_sym_LPAREN2] = ACTIONS(5468),
    [anon_sym_TILDE] = ACTIONS(5468),
    [anon_sym_STAR] = ACTIONS(5468),
    [anon_sym_AMP_AMP] = ACTIONS(5468),
    [anon_sym_AMP] = ACTIONS(5466),
    [anon_sym_SEMI] = ACTIONS(5468),
    [anon_sym___extension__] = ACTIONS(5466),
    [anon_sym_typedef] = ACTIONS(5466),
    [anon_sym_virtual] = ACTIONS(5466),
    [anon_sym_extern] = ACTIONS(5466),
    [anon_sym___attribute__] = ACTIONS(5466),
    [anon_sym___attribute] = ACTIONS(5466),
    [anon_sym_COLON_COLON] = ACTIONS(5468),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5468),
    [anon_sym___declspec] = ACTIONS(5466),
    [anon_sym___based] = ACTIONS(5466),
    [anon_sym_RBRACE] = ACTIONS(5468),
    [anon_sym_signed] = ACTIONS(5466),
    [anon_sym_unsigned] = ACTIONS(5466),
    [anon_sym_long] = ACTIONS(5466),
    [anon_sym_short] = ACTIONS(5466),
    [anon_sym_LBRACK] = ACTIONS(5466),
    [anon_sym_static] = ACTIONS(5466),
    [anon_sym_register] = ACTIONS(5466),
    [anon_sym_inline] = ACTIONS(5466),
    [anon_sym___inline] = ACTIONS(5466),
    [anon_sym___inline__] = ACTIONS(5466),
    [anon_sym___forceinline] = ACTIONS(5466),
    [anon_sym_thread_local] = ACTIONS(5466),
    [anon_sym___thread] = ACTIONS(5466),
    [anon_sym_const] = ACTIONS(5466),
    [anon_sym_constexpr] = ACTIONS(5466),
    [anon_sym_volatile] = ACTIONS(5466),
    [anon_sym_restrict] = ACTIONS(5466),
    [anon_sym___restrict__] = ACTIONS(5466),
    [anon_sym__Atomic] = ACTIONS(5466),
    [anon_sym__Noreturn] = ACTIONS(5466),
    [anon_sym_noreturn] = ACTIONS(5466),
    [anon_sym__Nonnull] = ACTIONS(5466),
    [anon_sym_mutable] = ACTIONS(5466),
    [anon_sym_constinit] = ACTIONS(5466),
    [anon_sym_consteval] = ACTIONS(5466),
    [anon_sym_alignas] = ACTIONS(5466),
    [anon_sym__Alignas] = ACTIONS(5466),
    [sym_primitive_type] = ACTIONS(5466),
    [anon_sym_enum] = ACTIONS(5466),
    [anon_sym_class] = ACTIONS(5466),
    [anon_sym_struct] = ACTIONS(5466),
    [anon_sym_union] = ACTIONS(5466),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5466),
    [anon_sym_decltype] = ACTIONS(5466),
    [anon_sym_explicit] = ACTIONS(5466),
    [anon_sym_typename] = ACTIONS(5466),
    [anon_sym_template] = ACTIONS(5466),
    [anon_sym_operator] = ACTIONS(5466),
    [anon_sym_friend] = ACTIONS(5466),
    [anon_sym_public] = ACTIONS(5466),
    [anon_sym_private] = ACTIONS(5466),
    [anon_sym_protected] = ACTIONS(5466),
    [anon_sym_using] = ACTIONS(5466),
    [anon_sym_static_assert] = ACTIONS(5466),
  },
  [2015] = {
    [sym_identifier] = ACTIONS(5474),
    [aux_sym_preproc_def_token1] = ACTIONS(5474),
    [aux_sym_preproc_if_token1] = ACTIONS(5474),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5474),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5474),
    [sym_preproc_directive] = ACTIONS(5474),
    [anon_sym_LPAREN2] = ACTIONS(5476),
    [anon_sym_TILDE] = ACTIONS(5476),
    [anon_sym_STAR] = ACTIONS(5476),
    [anon_sym_AMP_AMP] = ACTIONS(5476),
    [anon_sym_AMP] = ACTIONS(5474),
    [anon_sym_SEMI] = ACTIONS(5476),
    [anon_sym___extension__] = ACTIONS(5474),
    [anon_sym_typedef] = ACTIONS(5474),
    [anon_sym_virtual] = ACTIONS(5474),
    [anon_sym_extern] = ACTIONS(5474),
    [anon_sym___attribute__] = ACTIONS(5474),
    [anon_sym___attribute] = ACTIONS(5474),
    [anon_sym_COLON_COLON] = ACTIONS(5476),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5476),
    [anon_sym___declspec] = ACTIONS(5474),
    [anon_sym___based] = ACTIONS(5474),
    [anon_sym_RBRACE] = ACTIONS(5476),
    [anon_sym_signed] = ACTIONS(5474),
    [anon_sym_unsigned] = ACTIONS(5474),
    [anon_sym_long] = ACTIONS(5474),
    [anon_sym_short] = ACTIONS(5474),
    [anon_sym_LBRACK] = ACTIONS(5474),
    [anon_sym_static] = ACTIONS(5474),
    [anon_sym_register] = ACTIONS(5474),
    [anon_sym_inline] = ACTIONS(5474),
    [anon_sym___inline] = ACTIONS(5474),
    [anon_sym___inline__] = ACTIONS(5474),
    [anon_sym___forceinline] = ACTIONS(5474),
    [anon_sym_thread_local] = ACTIONS(5474),
    [anon_sym___thread] = ACTIONS(5474),
    [anon_sym_const] = ACTIONS(5474),
    [anon_sym_constexpr] = ACTIONS(5474),
    [anon_sym_volatile] = ACTIONS(5474),
    [anon_sym_restrict] = ACTIONS(5474),
    [anon_sym___restrict__] = ACTIONS(5474),
    [anon_sym__Atomic] = ACTIONS(5474),
    [anon_sym__Noreturn] = ACTIONS(5474),
    [anon_sym_noreturn] = ACTIONS(5474),
    [anon_sym__Nonnull] = ACTIONS(5474),
    [anon_sym_mutable] = ACTIONS(5474),
    [anon_sym_constinit] = ACTIONS(5474),
    [anon_sym_consteval] = ACTIONS(5474),
    [anon_sym_alignas] = ACTIONS(5474),
    [anon_sym__Alignas] = ACTIONS(5474),
    [sym_primitive_type] = ACTIONS(5474),
    [anon_sym_enum] = ACTIONS(5474),
    [anon_sym_class] = ACTIONS(5474),
    [anon_sym_struct] = ACTIONS(5474),
    [anon_sym_union] = ACTIONS(5474),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5474),
    [anon_sym_decltype] = ACTIONS(5474),
    [anon_sym_explicit] = ACTIONS(5474),
    [anon_sym_typename] = ACTIONS(5474),
    [anon_sym_template] = ACTIONS(5474),
    [anon_sym_operator] = ACTIONS(5474),
    [anon_sym_friend] = ACTIONS(5474),
    [anon_sym_public] = ACTIONS(5474),
    [anon_sym_private] = ACTIONS(5474),
    [anon_sym_protected] = ACTIONS(5474),
    [anon_sym_using] = ACTIONS(5474),
    [anon_sym_static_assert] = ACTIONS(5474),
  },
  [2016] = {
    [sym_identifier] = ACTIONS(5311),
    [aux_sym_preproc_def_token1] = ACTIONS(5311),
    [aux_sym_preproc_if_token1] = ACTIONS(5311),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5311),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5311),
    [sym_preproc_directive] = ACTIONS(5311),
    [anon_sym_LPAREN2] = ACTIONS(5313),
    [anon_sym_TILDE] = ACTIONS(5313),
    [anon_sym_STAR] = ACTIONS(5313),
    [anon_sym_AMP_AMP] = ACTIONS(5313),
    [anon_sym_AMP] = ACTIONS(5311),
    [anon_sym_SEMI] = ACTIONS(5313),
    [anon_sym___extension__] = ACTIONS(5311),
    [anon_sym_typedef] = ACTIONS(5311),
    [anon_sym_virtual] = ACTIONS(5311),
    [anon_sym_extern] = ACTIONS(5311),
    [anon_sym___attribute__] = ACTIONS(5311),
    [anon_sym___attribute] = ACTIONS(5311),
    [anon_sym_COLON_COLON] = ACTIONS(5313),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5313),
    [anon_sym___declspec] = ACTIONS(5311),
    [anon_sym___based] = ACTIONS(5311),
    [anon_sym_RBRACE] = ACTIONS(5313),
    [anon_sym_signed] = ACTIONS(5311),
    [anon_sym_unsigned] = ACTIONS(5311),
    [anon_sym_long] = ACTIONS(5311),
    [anon_sym_short] = ACTIONS(5311),
    [anon_sym_LBRACK] = ACTIONS(5311),
    [anon_sym_static] = ACTIONS(5311),
    [anon_sym_register] = ACTIONS(5311),
    [anon_sym_inline] = ACTIONS(5311),
    [anon_sym___inline] = ACTIONS(5311),
    [anon_sym___inline__] = ACTIONS(5311),
    [anon_sym___forceinline] = ACTIONS(5311),
    [anon_sym_thread_local] = ACTIONS(5311),
    [anon_sym___thread] = ACTIONS(5311),
    [anon_sym_const] = ACTIONS(5311),
    [anon_sym_constexpr] = ACTIONS(5311),
    [anon_sym_volatile] = ACTIONS(5311),
    [anon_sym_restrict] = ACTIONS(5311),
    [anon_sym___restrict__] = ACTIONS(5311),
    [anon_sym__Atomic] = ACTIONS(5311),
    [anon_sym__Noreturn] = ACTIONS(5311),
    [anon_sym_noreturn] = ACTIONS(5311),
    [anon_sym__Nonnull] = ACTIONS(5311),
    [anon_sym_mutable] = ACTIONS(5311),
    [anon_sym_constinit] = ACTIONS(5311),
    [anon_sym_consteval] = ACTIONS(5311),
    [anon_sym_alignas] = ACTIONS(5311),
    [anon_sym__Alignas] = ACTIONS(5311),
    [sym_primitive_type] = ACTIONS(5311),
    [anon_sym_enum] = ACTIONS(5311),
    [anon_sym_class] = ACTIONS(5311),
    [anon_sym_struct] = ACTIONS(5311),
    [anon_sym_union] = ACTIONS(5311),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5311),
    [anon_sym_decltype] = ACTIONS(5311),
    [anon_sym_explicit] = ACTIONS(5311),
    [anon_sym_typename] = ACTIONS(5311),
    [anon_sym_template] = ACTIONS(5311),
    [anon_sym_operator] = ACTIONS(5311),
    [anon_sym_friend] = ACTIONS(5311),
    [anon_sym_public] = ACTIONS(5311),
    [anon_sym_private] = ACTIONS(5311),
    [anon_sym_protected] = ACTIONS(5311),
    [anon_sym_using] = ACTIONS(5311),
    [anon_sym_static_assert] = ACTIONS(5311),
  },
  [2017] = {
    [sym_identifier] = ACTIONS(5494),
    [aux_sym_preproc_def_token1] = ACTIONS(5494),
    [aux_sym_preproc_if_token1] = ACTIONS(5494),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5494),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5494),
    [sym_preproc_directive] = ACTIONS(5494),
    [anon_sym_LPAREN2] = ACTIONS(5496),
    [anon_sym_TILDE] = ACTIONS(5496),
    [anon_sym_STAR] = ACTIONS(5496),
    [anon_sym_AMP_AMP] = ACTIONS(5496),
    [anon_sym_AMP] = ACTIONS(5494),
    [anon_sym_SEMI] = ACTIONS(5496),
    [anon_sym___extension__] = ACTIONS(5494),
    [anon_sym_typedef] = ACTIONS(5494),
    [anon_sym_virtual] = ACTIONS(5494),
    [anon_sym_extern] = ACTIONS(5494),
    [anon_sym___attribute__] = ACTIONS(5494),
    [anon_sym___attribute] = ACTIONS(5494),
    [anon_sym_COLON_COLON] = ACTIONS(5496),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5496),
    [anon_sym___declspec] = ACTIONS(5494),
    [anon_sym___based] = ACTIONS(5494),
    [anon_sym_RBRACE] = ACTIONS(5496),
    [anon_sym_signed] = ACTIONS(5494),
    [anon_sym_unsigned] = ACTIONS(5494),
    [anon_sym_long] = ACTIONS(5494),
    [anon_sym_short] = ACTIONS(5494),
    [anon_sym_LBRACK] = ACTIONS(5494),
    [anon_sym_static] = ACTIONS(5494),
    [anon_sym_register] = ACTIONS(5494),
    [anon_sym_inline] = ACTIONS(5494),
    [anon_sym___inline] = ACTIONS(5494),
    [anon_sym___inline__] = ACTIONS(5494),
    [anon_sym___forceinline] = ACTIONS(5494),
    [anon_sym_thread_local] = ACTIONS(5494),
    [anon_sym___thread] = ACTIONS(5494),
    [anon_sym_const] = ACTIONS(5494),
    [anon_sym_constexpr] = ACTIONS(5494),
    [anon_sym_volatile] = ACTIONS(5494),
    [anon_sym_restrict] = ACTIONS(5494),
    [anon_sym___restrict__] = ACTIONS(5494),
    [anon_sym__Atomic] = ACTIONS(5494),
    [anon_sym__Noreturn] = ACTIONS(5494),
    [anon_sym_noreturn] = ACTIONS(5494),
    [anon_sym__Nonnull] = ACTIONS(5494),
    [anon_sym_mutable] = ACTIONS(5494),
    [anon_sym_constinit] = ACTIONS(5494),
    [anon_sym_consteval] = ACTIONS(5494),
    [anon_sym_alignas] = ACTIONS(5494),
    [anon_sym__Alignas] = ACTIONS(5494),
    [sym_primitive_type] = ACTIONS(5494),
    [anon_sym_enum] = ACTIONS(5494),
    [anon_sym_class] = ACTIONS(5494),
    [anon_sym_struct] = ACTIONS(5494),
    [anon_sym_union] = ACTIONS(5494),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5494),
    [anon_sym_decltype] = ACTIONS(5494),
    [anon_sym_explicit] = ACTIONS(5494),
    [anon_sym_typename] = ACTIONS(5494),
    [anon_sym_template] = ACTIONS(5494),
    [anon_sym_operator] = ACTIONS(5494),
    [anon_sym_friend] = ACTIONS(5494),
    [anon_sym_public] = ACTIONS(5494),
    [anon_sym_private] = ACTIONS(5494),
    [anon_sym_protected] = ACTIONS(5494),
    [anon_sym_using] = ACTIONS(5494),
    [anon_sym_static_assert] = ACTIONS(5494),
  },
  [2018] = {
    [sym_identifier] = ACTIONS(3104),
    [aux_sym_preproc_def_token1] = ACTIONS(3104),
    [aux_sym_preproc_if_token1] = ACTIONS(3104),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3104),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3104),
    [sym_preproc_directive] = ACTIONS(3104),
    [anon_sym_LPAREN2] = ACTIONS(3106),
    [anon_sym_TILDE] = ACTIONS(3106),
    [anon_sym_STAR] = ACTIONS(3106),
    [anon_sym_AMP_AMP] = ACTIONS(3106),
    [anon_sym_AMP] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(3106),
    [anon_sym___extension__] = ACTIONS(3104),
    [anon_sym_typedef] = ACTIONS(3104),
    [anon_sym_virtual] = ACTIONS(3104),
    [anon_sym_extern] = ACTIONS(3104),
    [anon_sym___attribute__] = ACTIONS(3104),
    [anon_sym___attribute] = ACTIONS(3104),
    [anon_sym_COLON_COLON] = ACTIONS(3106),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3106),
    [anon_sym___declspec] = ACTIONS(3104),
    [anon_sym___based] = ACTIONS(3104),
    [anon_sym_RBRACE] = ACTIONS(3106),
    [anon_sym_signed] = ACTIONS(3104),
    [anon_sym_unsigned] = ACTIONS(3104),
    [anon_sym_long] = ACTIONS(3104),
    [anon_sym_short] = ACTIONS(3104),
    [anon_sym_LBRACK] = ACTIONS(3104),
    [anon_sym_static] = ACTIONS(3104),
    [anon_sym_register] = ACTIONS(3104),
    [anon_sym_inline] = ACTIONS(3104),
    [anon_sym___inline] = ACTIONS(3104),
    [anon_sym___inline__] = ACTIONS(3104),
    [anon_sym___forceinline] = ACTIONS(3104),
    [anon_sym_thread_local] = ACTIONS(3104),
    [anon_sym___thread] = ACTIONS(3104),
    [anon_sym_const] = ACTIONS(3104),
    [anon_sym_constexpr] = ACTIONS(3104),
    [anon_sym_volatile] = ACTIONS(3104),
    [anon_sym_restrict] = ACTIONS(3104),
    [anon_sym___restrict__] = ACTIONS(3104),
    [anon_sym__Atomic] = ACTIONS(3104),
    [anon_sym__Noreturn] = ACTIONS(3104),
    [anon_sym_noreturn] = ACTIONS(3104),
    [anon_sym__Nonnull] = ACTIONS(3104),
    [anon_sym_mutable] = ACTIONS(3104),
    [anon_sym_constinit] = ACTIONS(3104),
    [anon_sym_consteval] = ACTIONS(3104),
    [anon_sym_alignas] = ACTIONS(3104),
    [anon_sym__Alignas] = ACTIONS(3104),
    [sym_primitive_type] = ACTIONS(3104),
    [anon_sym_enum] = ACTIONS(3104),
    [anon_sym_class] = ACTIONS(3104),
    [anon_sym_struct] = ACTIONS(3104),
    [anon_sym_union] = ACTIONS(3104),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3104),
    [anon_sym_decltype] = ACTIONS(3104),
    [anon_sym_explicit] = ACTIONS(3104),
    [anon_sym_typename] = ACTIONS(3104),
    [anon_sym_template] = ACTIONS(3104),
    [anon_sym_operator] = ACTIONS(3104),
    [anon_sym_friend] = ACTIONS(3104),
    [anon_sym_public] = ACTIONS(3104),
    [anon_sym_private] = ACTIONS(3104),
    [anon_sym_protected] = ACTIONS(3104),
    [anon_sym_using] = ACTIONS(3104),
    [anon_sym_static_assert] = ACTIONS(3104),
  },
  [2019] = {
    [sym_identifier] = ACTIONS(5315),
    [aux_sym_preproc_def_token1] = ACTIONS(5315),
    [aux_sym_preproc_if_token1] = ACTIONS(5315),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5315),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5315),
    [sym_preproc_directive] = ACTIONS(5315),
    [anon_sym_LPAREN2] = ACTIONS(5317),
    [anon_sym_TILDE] = ACTIONS(5317),
    [anon_sym_STAR] = ACTIONS(5317),
    [anon_sym_AMP_AMP] = ACTIONS(5317),
    [anon_sym_AMP] = ACTIONS(5315),
    [anon_sym_SEMI] = ACTIONS(5317),
    [anon_sym___extension__] = ACTIONS(5315),
    [anon_sym_typedef] = ACTIONS(5315),
    [anon_sym_virtual] = ACTIONS(5315),
    [anon_sym_extern] = ACTIONS(5315),
    [anon_sym___attribute__] = ACTIONS(5315),
    [anon_sym___attribute] = ACTIONS(5315),
    [anon_sym_COLON_COLON] = ACTIONS(5317),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5317),
    [anon_sym___declspec] = ACTIONS(5315),
    [anon_sym___based] = ACTIONS(5315),
    [anon_sym_RBRACE] = ACTIONS(5317),
    [anon_sym_signed] = ACTIONS(5315),
    [anon_sym_unsigned] = ACTIONS(5315),
    [anon_sym_long] = ACTIONS(5315),
    [anon_sym_short] = ACTIONS(5315),
    [anon_sym_LBRACK] = ACTIONS(5315),
    [anon_sym_static] = ACTIONS(5315),
    [anon_sym_register] = ACTIONS(5315),
    [anon_sym_inline] = ACTIONS(5315),
    [anon_sym___inline] = ACTIONS(5315),
    [anon_sym___inline__] = ACTIONS(5315),
    [anon_sym___forceinline] = ACTIONS(5315),
    [anon_sym_thread_local] = ACTIONS(5315),
    [anon_sym___thread] = ACTIONS(5315),
    [anon_sym_const] = ACTIONS(5315),
    [anon_sym_constexpr] = ACTIONS(5315),
    [anon_sym_volatile] = ACTIONS(5315),
    [anon_sym_restrict] = ACTIONS(5315),
    [anon_sym___restrict__] = ACTIONS(5315),
    [anon_sym__Atomic] = ACTIONS(5315),
    [anon_sym__Noreturn] = ACTIONS(5315),
    [anon_sym_noreturn] = ACTIONS(5315),
    [anon_sym__Nonnull] = ACTIONS(5315),
    [anon_sym_mutable] = ACTIONS(5315),
    [anon_sym_constinit] = ACTIONS(5315),
    [anon_sym_consteval] = ACTIONS(5315),
    [anon_sym_alignas] = ACTIONS(5315),
    [anon_sym__Alignas] = ACTIONS(5315),
    [sym_primitive_type] = ACTIONS(5315),
    [anon_sym_enum] = ACTIONS(5315),
    [anon_sym_class] = ACTIONS(5315),
    [anon_sym_struct] = ACTIONS(5315),
    [anon_sym_union] = ACTIONS(5315),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5315),
    [anon_sym_decltype] = ACTIONS(5315),
    [anon_sym_explicit] = ACTIONS(5315),
    [anon_sym_typename] = ACTIONS(5315),
    [anon_sym_template] = ACTIONS(5315),
    [anon_sym_operator] = ACTIONS(5315),
    [anon_sym_friend] = ACTIONS(5315),
    [anon_sym_public] = ACTIONS(5315),
    [anon_sym_private] = ACTIONS(5315),
    [anon_sym_protected] = ACTIONS(5315),
    [anon_sym_using] = ACTIONS(5315),
    [anon_sym_static_assert] = ACTIONS(5315),
  },
  [2020] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1628),
    [sym_identifier] = ACTIONS(4932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4981),
    [anon_sym_COMMA] = ACTIONS(4981),
    [anon_sym_RPAREN] = ACTIONS(4981),
    [anon_sym_LPAREN2] = ACTIONS(4981),
    [anon_sym_DASH] = ACTIONS(4984),
    [anon_sym_PLUS] = ACTIONS(4984),
    [anon_sym_STAR] = ACTIONS(4981),
    [anon_sym_SLASH] = ACTIONS(4984),
    [anon_sym_PERCENT] = ACTIONS(4981),
    [anon_sym_PIPE_PIPE] = ACTIONS(4981),
    [anon_sym_AMP_AMP] = ACTIONS(4981),
    [anon_sym_PIPE] = ACTIONS(4984),
    [anon_sym_CARET] = ACTIONS(4981),
    [anon_sym_AMP] = ACTIONS(4984),
    [anon_sym_EQ_EQ] = ACTIONS(4981),
    [anon_sym_BANG_EQ] = ACTIONS(4981),
    [anon_sym_GT] = ACTIONS(4984),
    [anon_sym_GT_EQ] = ACTIONS(4981),
    [anon_sym_LT_EQ] = ACTIONS(4984),
    [anon_sym_LT] = ACTIONS(4984),
    [anon_sym_LT_LT] = ACTIONS(4981),
    [anon_sym_GT_GT] = ACTIONS(4981),
    [anon_sym_SEMI] = ACTIONS(4981),
    [anon_sym___extension__] = ACTIONS(4932),
    [anon_sym___attribute__] = ACTIONS(4984),
    [anon_sym___attribute] = ACTIONS(4984),
    [anon_sym_LBRACE] = ACTIONS(4981),
    [anon_sym_RBRACE] = ACTIONS(4981),
    [anon_sym_signed] = ACTIONS(5231),
    [anon_sym_unsigned] = ACTIONS(5231),
    [anon_sym_long] = ACTIONS(5231),
    [anon_sym_short] = ACTIONS(5231),
    [anon_sym_LBRACK] = ACTIONS(4981),
    [anon_sym_RBRACK] = ACTIONS(4981),
    [anon_sym_const] = ACTIONS(4932),
    [anon_sym_constexpr] = ACTIONS(4932),
    [anon_sym_volatile] = ACTIONS(4932),
    [anon_sym_restrict] = ACTIONS(4932),
    [anon_sym___restrict__] = ACTIONS(4932),
    [anon_sym__Atomic] = ACTIONS(4932),
    [anon_sym__Noreturn] = ACTIONS(4932),
    [anon_sym_noreturn] = ACTIONS(4932),
    [anon_sym__Nonnull] = ACTIONS(4932),
    [anon_sym_mutable] = ACTIONS(4932),
    [anon_sym_constinit] = ACTIONS(4932),
    [anon_sym_consteval] = ACTIONS(4932),
    [anon_sym_alignas] = ACTIONS(4932),
    [anon_sym__Alignas] = ACTIONS(4932),
    [sym_primitive_type] = ACTIONS(4932),
    [anon_sym_COLON] = ACTIONS(4981),
    [anon_sym_QMARK] = ACTIONS(4981),
    [anon_sym_LT_EQ_GT] = ACTIONS(4981),
    [anon_sym_or] = ACTIONS(4984),
    [anon_sym_and] = ACTIONS(4984),
    [anon_sym_bitor] = ACTIONS(4984),
    [anon_sym_xor] = ACTIONS(4984),
    [anon_sym_bitand] = ACTIONS(4984),
    [anon_sym_not_eq] = ACTIONS(4984),
    [anon_sym_DASH_DASH] = ACTIONS(4981),
    [anon_sym_PLUS_PLUS] = ACTIONS(4981),
    [anon_sym_DOT] = ACTIONS(4984),
    [anon_sym_DOT_STAR] = ACTIONS(4981),
    [anon_sym_DASH_GT] = ACTIONS(4981),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4984),
    [anon_sym_decltype] = ACTIONS(4984),
  },
  [2021] = {
    [sym_identifier] = ACTIONS(5319),
    [aux_sym_preproc_def_token1] = ACTIONS(5319),
    [aux_sym_preproc_if_token1] = ACTIONS(5319),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5319),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5319),
    [sym_preproc_directive] = ACTIONS(5319),
    [anon_sym_LPAREN2] = ACTIONS(5321),
    [anon_sym_TILDE] = ACTIONS(5321),
    [anon_sym_STAR] = ACTIONS(5321),
    [anon_sym_AMP_AMP] = ACTIONS(5321),
    [anon_sym_AMP] = ACTIONS(5319),
    [anon_sym_SEMI] = ACTIONS(5321),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_typedef] = ACTIONS(5319),
    [anon_sym_virtual] = ACTIONS(5319),
    [anon_sym_extern] = ACTIONS(5319),
    [anon_sym___attribute__] = ACTIONS(5319),
    [anon_sym___attribute] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(5321),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5321),
    [anon_sym___declspec] = ACTIONS(5319),
    [anon_sym___based] = ACTIONS(5319),
    [anon_sym_RBRACE] = ACTIONS(5321),
    [anon_sym_signed] = ACTIONS(5319),
    [anon_sym_unsigned] = ACTIONS(5319),
    [anon_sym_long] = ACTIONS(5319),
    [anon_sym_short] = ACTIONS(5319),
    [anon_sym_LBRACK] = ACTIONS(5319),
    [anon_sym_static] = ACTIONS(5319),
    [anon_sym_register] = ACTIONS(5319),
    [anon_sym_inline] = ACTIONS(5319),
    [anon_sym___inline] = ACTIONS(5319),
    [anon_sym___inline__] = ACTIONS(5319),
    [anon_sym___forceinline] = ACTIONS(5319),
    [anon_sym_thread_local] = ACTIONS(5319),
    [anon_sym___thread] = ACTIONS(5319),
    [anon_sym_const] = ACTIONS(5319),
    [anon_sym_constexpr] = ACTIONS(5319),
    [anon_sym_volatile] = ACTIONS(5319),
    [anon_sym_restrict] = ACTIONS(5319),
    [anon_sym___restrict__] = ACTIONS(5319),
    [anon_sym__Atomic] = ACTIONS(5319),
    [anon_sym__Noreturn] = ACTIONS(5319),
    [anon_sym_noreturn] = ACTIONS(5319),
    [anon_sym__Nonnull] = ACTIONS(5319),
    [anon_sym_mutable] = ACTIONS(5319),
    [anon_sym_constinit] = ACTIONS(5319),
    [anon_sym_consteval] = ACTIONS(5319),
    [anon_sym_alignas] = ACTIONS(5319),
    [anon_sym__Alignas] = ACTIONS(5319),
    [sym_primitive_type] = ACTIONS(5319),
    [anon_sym_enum] = ACTIONS(5319),
    [anon_sym_class] = ACTIONS(5319),
    [anon_sym_struct] = ACTIONS(5319),
    [anon_sym_union] = ACTIONS(5319),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5319),
    [anon_sym_decltype] = ACTIONS(5319),
    [anon_sym_explicit] = ACTIONS(5319),
    [anon_sym_typename] = ACTIONS(5319),
    [anon_sym_template] = ACTIONS(5319),
    [anon_sym_operator] = ACTIONS(5319),
    [anon_sym_friend] = ACTIONS(5319),
    [anon_sym_public] = ACTIONS(5319),
    [anon_sym_private] = ACTIONS(5319),
    [anon_sym_protected] = ACTIONS(5319),
    [anon_sym_using] = ACTIONS(5319),
    [anon_sym_static_assert] = ACTIONS(5319),
  },
  [2022] = {
    [sym_identifier] = ACTIONS(5323),
    [aux_sym_preproc_def_token1] = ACTIONS(5323),
    [aux_sym_preproc_if_token1] = ACTIONS(5323),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5323),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5323),
    [sym_preproc_directive] = ACTIONS(5323),
    [anon_sym_LPAREN2] = ACTIONS(5325),
    [anon_sym_TILDE] = ACTIONS(5325),
    [anon_sym_STAR] = ACTIONS(5325),
    [anon_sym_AMP_AMP] = ACTIONS(5325),
    [anon_sym_AMP] = ACTIONS(5323),
    [anon_sym_SEMI] = ACTIONS(5325),
    [anon_sym___extension__] = ACTIONS(5323),
    [anon_sym_typedef] = ACTIONS(5323),
    [anon_sym_virtual] = ACTIONS(5323),
    [anon_sym_extern] = ACTIONS(5323),
    [anon_sym___attribute__] = ACTIONS(5323),
    [anon_sym___attribute] = ACTIONS(5323),
    [anon_sym_COLON_COLON] = ACTIONS(5325),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5325),
    [anon_sym___declspec] = ACTIONS(5323),
    [anon_sym___based] = ACTIONS(5323),
    [anon_sym_RBRACE] = ACTIONS(5325),
    [anon_sym_signed] = ACTIONS(5323),
    [anon_sym_unsigned] = ACTIONS(5323),
    [anon_sym_long] = ACTIONS(5323),
    [anon_sym_short] = ACTIONS(5323),
    [anon_sym_LBRACK] = ACTIONS(5323),
    [anon_sym_static] = ACTIONS(5323),
    [anon_sym_register] = ACTIONS(5323),
    [anon_sym_inline] = ACTIONS(5323),
    [anon_sym___inline] = ACTIONS(5323),
    [anon_sym___inline__] = ACTIONS(5323),
    [anon_sym___forceinline] = ACTIONS(5323),
    [anon_sym_thread_local] = ACTIONS(5323),
    [anon_sym___thread] = ACTIONS(5323),
    [anon_sym_const] = ACTIONS(5323),
    [anon_sym_constexpr] = ACTIONS(5323),
    [anon_sym_volatile] = ACTIONS(5323),
    [anon_sym_restrict] = ACTIONS(5323),
    [anon_sym___restrict__] = ACTIONS(5323),
    [anon_sym__Atomic] = ACTIONS(5323),
    [anon_sym__Noreturn] = ACTIONS(5323),
    [anon_sym_noreturn] = ACTIONS(5323),
    [anon_sym__Nonnull] = ACTIONS(5323),
    [anon_sym_mutable] = ACTIONS(5323),
    [anon_sym_constinit] = ACTIONS(5323),
    [anon_sym_consteval] = ACTIONS(5323),
    [anon_sym_alignas] = ACTIONS(5323),
    [anon_sym__Alignas] = ACTIONS(5323),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_enum] = ACTIONS(5323),
    [anon_sym_class] = ACTIONS(5323),
    [anon_sym_struct] = ACTIONS(5323),
    [anon_sym_union] = ACTIONS(5323),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5323),
    [anon_sym_decltype] = ACTIONS(5323),
    [anon_sym_explicit] = ACTIONS(5323),
    [anon_sym_typename] = ACTIONS(5323),
    [anon_sym_template] = ACTIONS(5323),
    [anon_sym_operator] = ACTIONS(5323),
    [anon_sym_friend] = ACTIONS(5323),
    [anon_sym_public] = ACTIONS(5323),
    [anon_sym_private] = ACTIONS(5323),
    [anon_sym_protected] = ACTIONS(5323),
    [anon_sym_using] = ACTIONS(5323),
    [anon_sym_static_assert] = ACTIONS(5323),
  },
  [2023] = {
    [sym_identifier] = ACTIONS(5319),
    [aux_sym_preproc_def_token1] = ACTIONS(5319),
    [aux_sym_preproc_if_token1] = ACTIONS(5319),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5319),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5319),
    [sym_preproc_directive] = ACTIONS(5319),
    [anon_sym_LPAREN2] = ACTIONS(5321),
    [anon_sym_TILDE] = ACTIONS(5321),
    [anon_sym_STAR] = ACTIONS(5321),
    [anon_sym_AMP_AMP] = ACTIONS(5321),
    [anon_sym_AMP] = ACTIONS(5319),
    [anon_sym_SEMI] = ACTIONS(5321),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_typedef] = ACTIONS(5319),
    [anon_sym_virtual] = ACTIONS(5319),
    [anon_sym_extern] = ACTIONS(5319),
    [anon_sym___attribute__] = ACTIONS(5319),
    [anon_sym___attribute] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(5321),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5321),
    [anon_sym___declspec] = ACTIONS(5319),
    [anon_sym___based] = ACTIONS(5319),
    [anon_sym_RBRACE] = ACTIONS(5321),
    [anon_sym_signed] = ACTIONS(5319),
    [anon_sym_unsigned] = ACTIONS(5319),
    [anon_sym_long] = ACTIONS(5319),
    [anon_sym_short] = ACTIONS(5319),
    [anon_sym_LBRACK] = ACTIONS(5319),
    [anon_sym_static] = ACTIONS(5319),
    [anon_sym_register] = ACTIONS(5319),
    [anon_sym_inline] = ACTIONS(5319),
    [anon_sym___inline] = ACTIONS(5319),
    [anon_sym___inline__] = ACTIONS(5319),
    [anon_sym___forceinline] = ACTIONS(5319),
    [anon_sym_thread_local] = ACTIONS(5319),
    [anon_sym___thread] = ACTIONS(5319),
    [anon_sym_const] = ACTIONS(5319),
    [anon_sym_constexpr] = ACTIONS(5319),
    [anon_sym_volatile] = ACTIONS(5319),
    [anon_sym_restrict] = ACTIONS(5319),
    [anon_sym___restrict__] = ACTIONS(5319),
    [anon_sym__Atomic] = ACTIONS(5319),
    [anon_sym__Noreturn] = ACTIONS(5319),
    [anon_sym_noreturn] = ACTIONS(5319),
    [anon_sym__Nonnull] = ACTIONS(5319),
    [anon_sym_mutable] = ACTIONS(5319),
    [anon_sym_constinit] = ACTIONS(5319),
    [anon_sym_consteval] = ACTIONS(5319),
    [anon_sym_alignas] = ACTIONS(5319),
    [anon_sym__Alignas] = ACTIONS(5319),
    [sym_primitive_type] = ACTIONS(5319),
    [anon_sym_enum] = ACTIONS(5319),
    [anon_sym_class] = ACTIONS(5319),
    [anon_sym_struct] = ACTIONS(5319),
    [anon_sym_union] = ACTIONS(5319),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5319),
    [anon_sym_decltype] = ACTIONS(5319),
    [anon_sym_explicit] = ACTIONS(5319),
    [anon_sym_typename] = ACTIONS(5319),
    [anon_sym_template] = ACTIONS(5319),
    [anon_sym_operator] = ACTIONS(5319),
    [anon_sym_friend] = ACTIONS(5319),
    [anon_sym_public] = ACTIONS(5319),
    [anon_sym_private] = ACTIONS(5319),
    [anon_sym_protected] = ACTIONS(5319),
    [anon_sym_using] = ACTIONS(5319),
    [anon_sym_static_assert] = ACTIONS(5319),
  },
  [2024] = {
    [sym_identifier] = ACTIONS(5349),
    [aux_sym_preproc_def_token1] = ACTIONS(5349),
    [aux_sym_preproc_if_token1] = ACTIONS(5349),
    [aux_sym_preproc_if_token2] = ACTIONS(5349),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5349),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5349),
    [sym_preproc_directive] = ACTIONS(5349),
    [anon_sym_LPAREN2] = ACTIONS(5351),
    [anon_sym_TILDE] = ACTIONS(5351),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_AMP_AMP] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5349),
    [anon_sym_SEMI] = ACTIONS(5351),
    [anon_sym___extension__] = ACTIONS(5349),
    [anon_sym_typedef] = ACTIONS(5349),
    [anon_sym_virtual] = ACTIONS(5349),
    [anon_sym_extern] = ACTIONS(5349),
    [anon_sym___attribute__] = ACTIONS(5349),
    [anon_sym___attribute] = ACTIONS(5349),
    [anon_sym_COLON_COLON] = ACTIONS(5351),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5351),
    [anon_sym___declspec] = ACTIONS(5349),
    [anon_sym___based] = ACTIONS(5349),
    [anon_sym_signed] = ACTIONS(5349),
    [anon_sym_unsigned] = ACTIONS(5349),
    [anon_sym_long] = ACTIONS(5349),
    [anon_sym_short] = ACTIONS(5349),
    [anon_sym_LBRACK] = ACTIONS(5349),
    [anon_sym_static] = ACTIONS(5349),
    [anon_sym_register] = ACTIONS(5349),
    [anon_sym_inline] = ACTIONS(5349),
    [anon_sym___inline] = ACTIONS(5349),
    [anon_sym___inline__] = ACTIONS(5349),
    [anon_sym___forceinline] = ACTIONS(5349),
    [anon_sym_thread_local] = ACTIONS(5349),
    [anon_sym___thread] = ACTIONS(5349),
    [anon_sym_const] = ACTIONS(5349),
    [anon_sym_constexpr] = ACTIONS(5349),
    [anon_sym_volatile] = ACTIONS(5349),
    [anon_sym_restrict] = ACTIONS(5349),
    [anon_sym___restrict__] = ACTIONS(5349),
    [anon_sym__Atomic] = ACTIONS(5349),
    [anon_sym__Noreturn] = ACTIONS(5349),
    [anon_sym_noreturn] = ACTIONS(5349),
    [anon_sym__Nonnull] = ACTIONS(5349),
    [anon_sym_mutable] = ACTIONS(5349),
    [anon_sym_constinit] = ACTIONS(5349),
    [anon_sym_consteval] = ACTIONS(5349),
    [anon_sym_alignas] = ACTIONS(5349),
    [anon_sym__Alignas] = ACTIONS(5349),
    [sym_primitive_type] = ACTIONS(5349),
    [anon_sym_enum] = ACTIONS(5349),
    [anon_sym_class] = ACTIONS(5349),
    [anon_sym_struct] = ACTIONS(5349),
    [anon_sym_union] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5349),
    [anon_sym_decltype] = ACTIONS(5349),
    [anon_sym_explicit] = ACTIONS(5349),
    [anon_sym_typename] = ACTIONS(5349),
    [anon_sym_template] = ACTIONS(5349),
    [anon_sym_operator] = ACTIONS(5349),
    [anon_sym_friend] = ACTIONS(5349),
    [anon_sym_public] = ACTIONS(5349),
    [anon_sym_private] = ACTIONS(5349),
    [anon_sym_protected] = ACTIONS(5349),
    [anon_sym_using] = ACTIONS(5349),
    [anon_sym_static_assert] = ACTIONS(5349),
  },
  [2025] = {
    [sym_identifier] = ACTIONS(5323),
    [aux_sym_preproc_def_token1] = ACTIONS(5323),
    [aux_sym_preproc_if_token1] = ACTIONS(5323),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5323),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5323),
    [sym_preproc_directive] = ACTIONS(5323),
    [anon_sym_LPAREN2] = ACTIONS(5325),
    [anon_sym_TILDE] = ACTIONS(5325),
    [anon_sym_STAR] = ACTIONS(5325),
    [anon_sym_AMP_AMP] = ACTIONS(5325),
    [anon_sym_AMP] = ACTIONS(5323),
    [anon_sym_SEMI] = ACTIONS(5325),
    [anon_sym___extension__] = ACTIONS(5323),
    [anon_sym_typedef] = ACTIONS(5323),
    [anon_sym_virtual] = ACTIONS(5323),
    [anon_sym_extern] = ACTIONS(5323),
    [anon_sym___attribute__] = ACTIONS(5323),
    [anon_sym___attribute] = ACTIONS(5323),
    [anon_sym_COLON_COLON] = ACTIONS(5325),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5325),
    [anon_sym___declspec] = ACTIONS(5323),
    [anon_sym___based] = ACTIONS(5323),
    [anon_sym_RBRACE] = ACTIONS(5325),
    [anon_sym_signed] = ACTIONS(5323),
    [anon_sym_unsigned] = ACTIONS(5323),
    [anon_sym_long] = ACTIONS(5323),
    [anon_sym_short] = ACTIONS(5323),
    [anon_sym_LBRACK] = ACTIONS(5323),
    [anon_sym_static] = ACTIONS(5323),
    [anon_sym_register] = ACTIONS(5323),
    [anon_sym_inline] = ACTIONS(5323),
    [anon_sym___inline] = ACTIONS(5323),
    [anon_sym___inline__] = ACTIONS(5323),
    [anon_sym___forceinline] = ACTIONS(5323),
    [anon_sym_thread_local] = ACTIONS(5323),
    [anon_sym___thread] = ACTIONS(5323),
    [anon_sym_const] = ACTIONS(5323),
    [anon_sym_constexpr] = ACTIONS(5323),
    [anon_sym_volatile] = ACTIONS(5323),
    [anon_sym_restrict] = ACTIONS(5323),
    [anon_sym___restrict__] = ACTIONS(5323),
    [anon_sym__Atomic] = ACTIONS(5323),
    [anon_sym__Noreturn] = ACTIONS(5323),
    [anon_sym_noreturn] = ACTIONS(5323),
    [anon_sym__Nonnull] = ACTIONS(5323),
    [anon_sym_mutable] = ACTIONS(5323),
    [anon_sym_constinit] = ACTIONS(5323),
    [anon_sym_consteval] = ACTIONS(5323),
    [anon_sym_alignas] = ACTIONS(5323),
    [anon_sym__Alignas] = ACTIONS(5323),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_enum] = ACTIONS(5323),
    [anon_sym_class] = ACTIONS(5323),
    [anon_sym_struct] = ACTIONS(5323),
    [anon_sym_union] = ACTIONS(5323),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5323),
    [anon_sym_decltype] = ACTIONS(5323),
    [anon_sym_explicit] = ACTIONS(5323),
    [anon_sym_typename] = ACTIONS(5323),
    [anon_sym_template] = ACTIONS(5323),
    [anon_sym_operator] = ACTIONS(5323),
    [anon_sym_friend] = ACTIONS(5323),
    [anon_sym_public] = ACTIONS(5323),
    [anon_sym_private] = ACTIONS(5323),
    [anon_sym_protected] = ACTIONS(5323),
    [anon_sym_using] = ACTIONS(5323),
    [anon_sym_static_assert] = ACTIONS(5323),
  },
  [2026] = {
    [sym_identifier] = ACTIONS(5345),
    [aux_sym_preproc_def_token1] = ACTIONS(5345),
    [aux_sym_preproc_if_token1] = ACTIONS(5345),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5345),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5345),
    [sym_preproc_directive] = ACTIONS(5345),
    [anon_sym_LPAREN2] = ACTIONS(5347),
    [anon_sym_TILDE] = ACTIONS(5347),
    [anon_sym_STAR] = ACTIONS(5347),
    [anon_sym_AMP_AMP] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5345),
    [anon_sym_SEMI] = ACTIONS(5347),
    [anon_sym___extension__] = ACTIONS(5345),
    [anon_sym_typedef] = ACTIONS(5345),
    [anon_sym_virtual] = ACTIONS(5345),
    [anon_sym_extern] = ACTIONS(5345),
    [anon_sym___attribute__] = ACTIONS(5345),
    [anon_sym___attribute] = ACTIONS(5345),
    [anon_sym_COLON_COLON] = ACTIONS(5347),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5347),
    [anon_sym___declspec] = ACTIONS(5345),
    [anon_sym___based] = ACTIONS(5345),
    [anon_sym_RBRACE] = ACTIONS(5347),
    [anon_sym_signed] = ACTIONS(5345),
    [anon_sym_unsigned] = ACTIONS(5345),
    [anon_sym_long] = ACTIONS(5345),
    [anon_sym_short] = ACTIONS(5345),
    [anon_sym_LBRACK] = ACTIONS(5345),
    [anon_sym_static] = ACTIONS(5345),
    [anon_sym_register] = ACTIONS(5345),
    [anon_sym_inline] = ACTIONS(5345),
    [anon_sym___inline] = ACTIONS(5345),
    [anon_sym___inline__] = ACTIONS(5345),
    [anon_sym___forceinline] = ACTIONS(5345),
    [anon_sym_thread_local] = ACTIONS(5345),
    [anon_sym___thread] = ACTIONS(5345),
    [anon_sym_const] = ACTIONS(5345),
    [anon_sym_constexpr] = ACTIONS(5345),
    [anon_sym_volatile] = ACTIONS(5345),
    [anon_sym_restrict] = ACTIONS(5345),
    [anon_sym___restrict__] = ACTIONS(5345),
    [anon_sym__Atomic] = ACTIONS(5345),
    [anon_sym__Noreturn] = ACTIONS(5345),
    [anon_sym_noreturn] = ACTIONS(5345),
    [anon_sym__Nonnull] = ACTIONS(5345),
    [anon_sym_mutable] = ACTIONS(5345),
    [anon_sym_constinit] = ACTIONS(5345),
    [anon_sym_consteval] = ACTIONS(5345),
    [anon_sym_alignas] = ACTIONS(5345),
    [anon_sym__Alignas] = ACTIONS(5345),
    [sym_primitive_type] = ACTIONS(5345),
    [anon_sym_enum] = ACTIONS(5345),
    [anon_sym_class] = ACTIONS(5345),
    [anon_sym_struct] = ACTIONS(5345),
    [anon_sym_union] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5345),
    [anon_sym_decltype] = ACTIONS(5345),
    [anon_sym_explicit] = ACTIONS(5345),
    [anon_sym_typename] = ACTIONS(5345),
    [anon_sym_template] = ACTIONS(5345),
    [anon_sym_operator] = ACTIONS(5345),
    [anon_sym_friend] = ACTIONS(5345),
    [anon_sym_public] = ACTIONS(5345),
    [anon_sym_private] = ACTIONS(5345),
    [anon_sym_protected] = ACTIONS(5345),
    [anon_sym_using] = ACTIONS(5345),
    [anon_sym_static_assert] = ACTIONS(5345),
  },
  [2027] = {
    [sym_identifier] = ACTIONS(5307),
    [aux_sym_preproc_def_token1] = ACTIONS(5307),
    [aux_sym_preproc_if_token1] = ACTIONS(5307),
    [aux_sym_preproc_if_token2] = ACTIONS(5307),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5307),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5307),
    [sym_preproc_directive] = ACTIONS(5307),
    [anon_sym_LPAREN2] = ACTIONS(5309),
    [anon_sym_TILDE] = ACTIONS(5309),
    [anon_sym_STAR] = ACTIONS(5309),
    [anon_sym_AMP_AMP] = ACTIONS(5309),
    [anon_sym_AMP] = ACTIONS(5307),
    [anon_sym_SEMI] = ACTIONS(5309),
    [anon_sym___extension__] = ACTIONS(5307),
    [anon_sym_typedef] = ACTIONS(5307),
    [anon_sym_virtual] = ACTIONS(5307),
    [anon_sym_extern] = ACTIONS(5307),
    [anon_sym___attribute__] = ACTIONS(5307),
    [anon_sym___attribute] = ACTIONS(5307),
    [anon_sym_COLON_COLON] = ACTIONS(5309),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5309),
    [anon_sym___declspec] = ACTIONS(5307),
    [anon_sym___based] = ACTIONS(5307),
    [anon_sym_signed] = ACTIONS(5307),
    [anon_sym_unsigned] = ACTIONS(5307),
    [anon_sym_long] = ACTIONS(5307),
    [anon_sym_short] = ACTIONS(5307),
    [anon_sym_LBRACK] = ACTIONS(5307),
    [anon_sym_static] = ACTIONS(5307),
    [anon_sym_register] = ACTIONS(5307),
    [anon_sym_inline] = ACTIONS(5307),
    [anon_sym___inline] = ACTIONS(5307),
    [anon_sym___inline__] = ACTIONS(5307),
    [anon_sym___forceinline] = ACTIONS(5307),
    [anon_sym_thread_local] = ACTIONS(5307),
    [anon_sym___thread] = ACTIONS(5307),
    [anon_sym_const] = ACTIONS(5307),
    [anon_sym_constexpr] = ACTIONS(5307),
    [anon_sym_volatile] = ACTIONS(5307),
    [anon_sym_restrict] = ACTIONS(5307),
    [anon_sym___restrict__] = ACTIONS(5307),
    [anon_sym__Atomic] = ACTIONS(5307),
    [anon_sym__Noreturn] = ACTIONS(5307),
    [anon_sym_noreturn] = ACTIONS(5307),
    [anon_sym__Nonnull] = ACTIONS(5307),
    [anon_sym_mutable] = ACTIONS(5307),
    [anon_sym_constinit] = ACTIONS(5307),
    [anon_sym_consteval] = ACTIONS(5307),
    [anon_sym_alignas] = ACTIONS(5307),
    [anon_sym__Alignas] = ACTIONS(5307),
    [sym_primitive_type] = ACTIONS(5307),
    [anon_sym_enum] = ACTIONS(5307),
    [anon_sym_class] = ACTIONS(5307),
    [anon_sym_struct] = ACTIONS(5307),
    [anon_sym_union] = ACTIONS(5307),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5307),
    [anon_sym_decltype] = ACTIONS(5307),
    [anon_sym_explicit] = ACTIONS(5307),
    [anon_sym_typename] = ACTIONS(5307),
    [anon_sym_template] = ACTIONS(5307),
    [anon_sym_operator] = ACTIONS(5307),
    [anon_sym_friend] = ACTIONS(5307),
    [anon_sym_public] = ACTIONS(5307),
    [anon_sym_private] = ACTIONS(5307),
    [anon_sym_protected] = ACTIONS(5307),
    [anon_sym_using] = ACTIONS(5307),
    [anon_sym_static_assert] = ACTIONS(5307),
  },
  [2028] = {
    [sym_identifier] = ACTIONS(5353),
    [aux_sym_preproc_def_token1] = ACTIONS(5353),
    [aux_sym_preproc_if_token1] = ACTIONS(5353),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5353),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5353),
    [sym_preproc_directive] = ACTIONS(5353),
    [anon_sym_LPAREN2] = ACTIONS(5355),
    [anon_sym_TILDE] = ACTIONS(5355),
    [anon_sym_STAR] = ACTIONS(5355),
    [anon_sym_AMP_AMP] = ACTIONS(5355),
    [anon_sym_AMP] = ACTIONS(5353),
    [anon_sym_SEMI] = ACTIONS(5355),
    [anon_sym___extension__] = ACTIONS(5353),
    [anon_sym_typedef] = ACTIONS(5353),
    [anon_sym_virtual] = ACTIONS(5353),
    [anon_sym_extern] = ACTIONS(5353),
    [anon_sym___attribute__] = ACTIONS(5353),
    [anon_sym___attribute] = ACTIONS(5353),
    [anon_sym_COLON_COLON] = ACTIONS(5355),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5355),
    [anon_sym___declspec] = ACTIONS(5353),
    [anon_sym___based] = ACTIONS(5353),
    [anon_sym_RBRACE] = ACTIONS(5355),
    [anon_sym_signed] = ACTIONS(5353),
    [anon_sym_unsigned] = ACTIONS(5353),
    [anon_sym_long] = ACTIONS(5353),
    [anon_sym_short] = ACTIONS(5353),
    [anon_sym_LBRACK] = ACTIONS(5353),
    [anon_sym_static] = ACTIONS(5353),
    [anon_sym_register] = ACTIONS(5353),
    [anon_sym_inline] = ACTIONS(5353),
    [anon_sym___inline] = ACTIONS(5353),
    [anon_sym___inline__] = ACTIONS(5353),
    [anon_sym___forceinline] = ACTIONS(5353),
    [anon_sym_thread_local] = ACTIONS(5353),
    [anon_sym___thread] = ACTIONS(5353),
    [anon_sym_const] = ACTIONS(5353),
    [anon_sym_constexpr] = ACTIONS(5353),
    [anon_sym_volatile] = ACTIONS(5353),
    [anon_sym_restrict] = ACTIONS(5353),
    [anon_sym___restrict__] = ACTIONS(5353),
    [anon_sym__Atomic] = ACTIONS(5353),
    [anon_sym__Noreturn] = ACTIONS(5353),
    [anon_sym_noreturn] = ACTIONS(5353),
    [anon_sym__Nonnull] = ACTIONS(5353),
    [anon_sym_mutable] = ACTIONS(5353),
    [anon_sym_constinit] = ACTIONS(5353),
    [anon_sym_consteval] = ACTIONS(5353),
    [anon_sym_alignas] = ACTIONS(5353),
    [anon_sym__Alignas] = ACTIONS(5353),
    [sym_primitive_type] = ACTIONS(5353),
    [anon_sym_enum] = ACTIONS(5353),
    [anon_sym_class] = ACTIONS(5353),
    [anon_sym_struct] = ACTIONS(5353),
    [anon_sym_union] = ACTIONS(5353),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5353),
    [anon_sym_decltype] = ACTIONS(5353),
    [anon_sym_explicit] = ACTIONS(5353),
    [anon_sym_typename] = ACTIONS(5353),
    [anon_sym_template] = ACTIONS(5353),
    [anon_sym_operator] = ACTIONS(5353),
    [anon_sym_friend] = ACTIONS(5353),
    [anon_sym_public] = ACTIONS(5353),
    [anon_sym_private] = ACTIONS(5353),
    [anon_sym_protected] = ACTIONS(5353),
    [anon_sym_using] = ACTIONS(5353),
    [anon_sym_static_assert] = ACTIONS(5353),
  },
  [2029] = {
    [sym_identifier] = ACTIONS(5367),
    [aux_sym_preproc_def_token1] = ACTIONS(5367),
    [aux_sym_preproc_if_token1] = ACTIONS(5367),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5367),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5367),
    [sym_preproc_directive] = ACTIONS(5367),
    [anon_sym_LPAREN2] = ACTIONS(5369),
    [anon_sym_TILDE] = ACTIONS(5369),
    [anon_sym_STAR] = ACTIONS(5369),
    [anon_sym_AMP_AMP] = ACTIONS(5369),
    [anon_sym_AMP] = ACTIONS(5367),
    [anon_sym_SEMI] = ACTIONS(5369),
    [anon_sym___extension__] = ACTIONS(5367),
    [anon_sym_typedef] = ACTIONS(5367),
    [anon_sym_virtual] = ACTIONS(5367),
    [anon_sym_extern] = ACTIONS(5367),
    [anon_sym___attribute__] = ACTIONS(5367),
    [anon_sym___attribute] = ACTIONS(5367),
    [anon_sym_COLON_COLON] = ACTIONS(5369),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5369),
    [anon_sym___declspec] = ACTIONS(5367),
    [anon_sym___based] = ACTIONS(5367),
    [anon_sym_RBRACE] = ACTIONS(5369),
    [anon_sym_signed] = ACTIONS(5367),
    [anon_sym_unsigned] = ACTIONS(5367),
    [anon_sym_long] = ACTIONS(5367),
    [anon_sym_short] = ACTIONS(5367),
    [anon_sym_LBRACK] = ACTIONS(5367),
    [anon_sym_static] = ACTIONS(5367),
    [anon_sym_register] = ACTIONS(5367),
    [anon_sym_inline] = ACTIONS(5367),
    [anon_sym___inline] = ACTIONS(5367),
    [anon_sym___inline__] = ACTIONS(5367),
    [anon_sym___forceinline] = ACTIONS(5367),
    [anon_sym_thread_local] = ACTIONS(5367),
    [anon_sym___thread] = ACTIONS(5367),
    [anon_sym_const] = ACTIONS(5367),
    [anon_sym_constexpr] = ACTIONS(5367),
    [anon_sym_volatile] = ACTIONS(5367),
    [anon_sym_restrict] = ACTIONS(5367),
    [anon_sym___restrict__] = ACTIONS(5367),
    [anon_sym__Atomic] = ACTIONS(5367),
    [anon_sym__Noreturn] = ACTIONS(5367),
    [anon_sym_noreturn] = ACTIONS(5367),
    [anon_sym__Nonnull] = ACTIONS(5367),
    [anon_sym_mutable] = ACTIONS(5367),
    [anon_sym_constinit] = ACTIONS(5367),
    [anon_sym_consteval] = ACTIONS(5367),
    [anon_sym_alignas] = ACTIONS(5367),
    [anon_sym__Alignas] = ACTIONS(5367),
    [sym_primitive_type] = ACTIONS(5367),
    [anon_sym_enum] = ACTIONS(5367),
    [anon_sym_class] = ACTIONS(5367),
    [anon_sym_struct] = ACTIONS(5367),
    [anon_sym_union] = ACTIONS(5367),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5367),
    [anon_sym_decltype] = ACTIONS(5367),
    [anon_sym_explicit] = ACTIONS(5367),
    [anon_sym_typename] = ACTIONS(5367),
    [anon_sym_template] = ACTIONS(5367),
    [anon_sym_operator] = ACTIONS(5367),
    [anon_sym_friend] = ACTIONS(5367),
    [anon_sym_public] = ACTIONS(5367),
    [anon_sym_private] = ACTIONS(5367),
    [anon_sym_protected] = ACTIONS(5367),
    [anon_sym_using] = ACTIONS(5367),
    [anon_sym_static_assert] = ACTIONS(5367),
  },
  [2030] = {
    [sym_identifier] = ACTIONS(5367),
    [aux_sym_preproc_def_token1] = ACTIONS(5367),
    [aux_sym_preproc_if_token1] = ACTIONS(5367),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5367),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5367),
    [sym_preproc_directive] = ACTIONS(5367),
    [anon_sym_LPAREN2] = ACTIONS(5369),
    [anon_sym_TILDE] = ACTIONS(5369),
    [anon_sym_STAR] = ACTIONS(5369),
    [anon_sym_AMP_AMP] = ACTIONS(5369),
    [anon_sym_AMP] = ACTIONS(5367),
    [anon_sym_SEMI] = ACTIONS(5369),
    [anon_sym___extension__] = ACTIONS(5367),
    [anon_sym_typedef] = ACTIONS(5367),
    [anon_sym_virtual] = ACTIONS(5367),
    [anon_sym_extern] = ACTIONS(5367),
    [anon_sym___attribute__] = ACTIONS(5367),
    [anon_sym___attribute] = ACTIONS(5367),
    [anon_sym_COLON_COLON] = ACTIONS(5369),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5369),
    [anon_sym___declspec] = ACTIONS(5367),
    [anon_sym___based] = ACTIONS(5367),
    [anon_sym_RBRACE] = ACTIONS(5369),
    [anon_sym_signed] = ACTIONS(5367),
    [anon_sym_unsigned] = ACTIONS(5367),
    [anon_sym_long] = ACTIONS(5367),
    [anon_sym_short] = ACTIONS(5367),
    [anon_sym_LBRACK] = ACTIONS(5367),
    [anon_sym_static] = ACTIONS(5367),
    [anon_sym_register] = ACTIONS(5367),
    [anon_sym_inline] = ACTIONS(5367),
    [anon_sym___inline] = ACTIONS(5367),
    [anon_sym___inline__] = ACTIONS(5367),
    [anon_sym___forceinline] = ACTIONS(5367),
    [anon_sym_thread_local] = ACTIONS(5367),
    [anon_sym___thread] = ACTIONS(5367),
    [anon_sym_const] = ACTIONS(5367),
    [anon_sym_constexpr] = ACTIONS(5367),
    [anon_sym_volatile] = ACTIONS(5367),
    [anon_sym_restrict] = ACTIONS(5367),
    [anon_sym___restrict__] = ACTIONS(5367),
    [anon_sym__Atomic] = ACTIONS(5367),
    [anon_sym__Noreturn] = ACTIONS(5367),
    [anon_sym_noreturn] = ACTIONS(5367),
    [anon_sym__Nonnull] = ACTIONS(5367),
    [anon_sym_mutable] = ACTIONS(5367),
    [anon_sym_constinit] = ACTIONS(5367),
    [anon_sym_consteval] = ACTIONS(5367),
    [anon_sym_alignas] = ACTIONS(5367),
    [anon_sym__Alignas] = ACTIONS(5367),
    [sym_primitive_type] = ACTIONS(5367),
    [anon_sym_enum] = ACTIONS(5367),
    [anon_sym_class] = ACTIONS(5367),
    [anon_sym_struct] = ACTIONS(5367),
    [anon_sym_union] = ACTIONS(5367),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5367),
    [anon_sym_decltype] = ACTIONS(5367),
    [anon_sym_explicit] = ACTIONS(5367),
    [anon_sym_typename] = ACTIONS(5367),
    [anon_sym_template] = ACTIONS(5367),
    [anon_sym_operator] = ACTIONS(5367),
    [anon_sym_friend] = ACTIONS(5367),
    [anon_sym_public] = ACTIONS(5367),
    [anon_sym_private] = ACTIONS(5367),
    [anon_sym_protected] = ACTIONS(5367),
    [anon_sym_using] = ACTIONS(5367),
    [anon_sym_static_assert] = ACTIONS(5367),
  },
  [2031] = {
    [sym_identifier] = ACTIONS(2799),
    [aux_sym_preproc_def_token1] = ACTIONS(2799),
    [aux_sym_preproc_if_token1] = ACTIONS(2799),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2799),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2799),
    [sym_preproc_directive] = ACTIONS(2799),
    [anon_sym_LPAREN2] = ACTIONS(2801),
    [anon_sym_TILDE] = ACTIONS(2801),
    [anon_sym_STAR] = ACTIONS(2801),
    [anon_sym_AMP_AMP] = ACTIONS(2801),
    [anon_sym_AMP] = ACTIONS(2799),
    [anon_sym_SEMI] = ACTIONS(2801),
    [anon_sym___extension__] = ACTIONS(2799),
    [anon_sym_typedef] = ACTIONS(2799),
    [anon_sym_virtual] = ACTIONS(2799),
    [anon_sym_extern] = ACTIONS(2799),
    [anon_sym___attribute__] = ACTIONS(2799),
    [anon_sym___attribute] = ACTIONS(2799),
    [anon_sym_COLON_COLON] = ACTIONS(2801),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2801),
    [anon_sym___declspec] = ACTIONS(2799),
    [anon_sym___based] = ACTIONS(2799),
    [anon_sym_RBRACE] = ACTIONS(2801),
    [anon_sym_signed] = ACTIONS(2799),
    [anon_sym_unsigned] = ACTIONS(2799),
    [anon_sym_long] = ACTIONS(2799),
    [anon_sym_short] = ACTIONS(2799),
    [anon_sym_LBRACK] = ACTIONS(2799),
    [anon_sym_static] = ACTIONS(2799),
    [anon_sym_register] = ACTIONS(2799),
    [anon_sym_inline] = ACTIONS(2799),
    [anon_sym___inline] = ACTIONS(2799),
    [anon_sym___inline__] = ACTIONS(2799),
    [anon_sym___forceinline] = ACTIONS(2799),
    [anon_sym_thread_local] = ACTIONS(2799),
    [anon_sym___thread] = ACTIONS(2799),
    [anon_sym_const] = ACTIONS(2799),
    [anon_sym_constexpr] = ACTIONS(2799),
    [anon_sym_volatile] = ACTIONS(2799),
    [anon_sym_restrict] = ACTIONS(2799),
    [anon_sym___restrict__] = ACTIONS(2799),
    [anon_sym__Atomic] = ACTIONS(2799),
    [anon_sym__Noreturn] = ACTIONS(2799),
    [anon_sym_noreturn] = ACTIONS(2799),
    [anon_sym__Nonnull] = ACTIONS(2799),
    [anon_sym_mutable] = ACTIONS(2799),
    [anon_sym_constinit] = ACTIONS(2799),
    [anon_sym_consteval] = ACTIONS(2799),
    [anon_sym_alignas] = ACTIONS(2799),
    [anon_sym__Alignas] = ACTIONS(2799),
    [sym_primitive_type] = ACTIONS(2799),
    [anon_sym_enum] = ACTIONS(2799),
    [anon_sym_class] = ACTIONS(2799),
    [anon_sym_struct] = ACTIONS(2799),
    [anon_sym_union] = ACTIONS(2799),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2799),
    [anon_sym_decltype] = ACTIONS(2799),
    [anon_sym_explicit] = ACTIONS(2799),
    [anon_sym_typename] = ACTIONS(2799),
    [anon_sym_template] = ACTIONS(2799),
    [anon_sym_operator] = ACTIONS(2799),
    [anon_sym_friend] = ACTIONS(2799),
    [anon_sym_public] = ACTIONS(2799),
    [anon_sym_private] = ACTIONS(2799),
    [anon_sym_protected] = ACTIONS(2799),
    [anon_sym_using] = ACTIONS(2799),
    [anon_sym_static_assert] = ACTIONS(2799),
  },
  [2032] = {
    [sym_identifier] = ACTIONS(2799),
    [aux_sym_preproc_def_token1] = ACTIONS(2799),
    [aux_sym_preproc_if_token1] = ACTIONS(2799),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2799),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2799),
    [sym_preproc_directive] = ACTIONS(2799),
    [anon_sym_LPAREN2] = ACTIONS(2801),
    [anon_sym_TILDE] = ACTIONS(2801),
    [anon_sym_STAR] = ACTIONS(2801),
    [anon_sym_AMP_AMP] = ACTIONS(2801),
    [anon_sym_AMP] = ACTIONS(2799),
    [anon_sym_SEMI] = ACTIONS(2801),
    [anon_sym___extension__] = ACTIONS(2799),
    [anon_sym_typedef] = ACTIONS(2799),
    [anon_sym_virtual] = ACTIONS(2799),
    [anon_sym_extern] = ACTIONS(2799),
    [anon_sym___attribute__] = ACTIONS(2799),
    [anon_sym___attribute] = ACTIONS(2799),
    [anon_sym_COLON_COLON] = ACTIONS(2801),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2801),
    [anon_sym___declspec] = ACTIONS(2799),
    [anon_sym___based] = ACTIONS(2799),
    [anon_sym_RBRACE] = ACTIONS(2801),
    [anon_sym_signed] = ACTIONS(2799),
    [anon_sym_unsigned] = ACTIONS(2799),
    [anon_sym_long] = ACTIONS(2799),
    [anon_sym_short] = ACTIONS(2799),
    [anon_sym_LBRACK] = ACTIONS(2799),
    [anon_sym_static] = ACTIONS(2799),
    [anon_sym_register] = ACTIONS(2799),
    [anon_sym_inline] = ACTIONS(2799),
    [anon_sym___inline] = ACTIONS(2799),
    [anon_sym___inline__] = ACTIONS(2799),
    [anon_sym___forceinline] = ACTIONS(2799),
    [anon_sym_thread_local] = ACTIONS(2799),
    [anon_sym___thread] = ACTIONS(2799),
    [anon_sym_const] = ACTIONS(2799),
    [anon_sym_constexpr] = ACTIONS(2799),
    [anon_sym_volatile] = ACTIONS(2799),
    [anon_sym_restrict] = ACTIONS(2799),
    [anon_sym___restrict__] = ACTIONS(2799),
    [anon_sym__Atomic] = ACTIONS(2799),
    [anon_sym__Noreturn] = ACTIONS(2799),
    [anon_sym_noreturn] = ACTIONS(2799),
    [anon_sym__Nonnull] = ACTIONS(2799),
    [anon_sym_mutable] = ACTIONS(2799),
    [anon_sym_constinit] = ACTIONS(2799),
    [anon_sym_consteval] = ACTIONS(2799),
    [anon_sym_alignas] = ACTIONS(2799),
    [anon_sym__Alignas] = ACTIONS(2799),
    [sym_primitive_type] = ACTIONS(2799),
    [anon_sym_enum] = ACTIONS(2799),
    [anon_sym_class] = ACTIONS(2799),
    [anon_sym_struct] = ACTIONS(2799),
    [anon_sym_union] = ACTIONS(2799),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2799),
    [anon_sym_decltype] = ACTIONS(2799),
    [anon_sym_explicit] = ACTIONS(2799),
    [anon_sym_typename] = ACTIONS(2799),
    [anon_sym_template] = ACTIONS(2799),
    [anon_sym_operator] = ACTIONS(2799),
    [anon_sym_friend] = ACTIONS(2799),
    [anon_sym_public] = ACTIONS(2799),
    [anon_sym_private] = ACTIONS(2799),
    [anon_sym_protected] = ACTIONS(2799),
    [anon_sym_using] = ACTIONS(2799),
    [anon_sym_static_assert] = ACTIONS(2799),
  },
  [2033] = {
    [sym__declaration_modifiers] = STATE(3242),
    [sym_attribute_specifier] = STATE(3242),
    [sym_attribute_declaration] = STATE(3242),
    [sym_ms_declspec_modifier] = STATE(3242),
    [sym_storage_class_specifier] = STATE(3242),
    [sym_type_qualifier] = STATE(3242),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2364),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2336),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(6493),
    [sym_qualified_type_identifier] = STATE(2978),
    [aux_sym__declaration_specifiers_repeat1] = STATE(3242),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(5025),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(5852),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(5027),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(71),
    [anon_sym_class] = ACTIONS(73),
    [anon_sym_struct] = ACTIONS(75),
    [anon_sym_union] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(129),
    [anon_sym_template] = ACTIONS(1235),
  },
  [2034] = {
    [sym_identifier] = ACTIONS(3822),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3824),
    [anon_sym_COMMA] = ACTIONS(3824),
    [anon_sym_RPAREN] = ACTIONS(3824),
    [anon_sym_LPAREN2] = ACTIONS(3824),
    [anon_sym_TILDE] = ACTIONS(3824),
    [anon_sym_STAR] = ACTIONS(3824),
    [anon_sym_AMP_AMP] = ACTIONS(3824),
    [anon_sym_AMP] = ACTIONS(3822),
    [anon_sym_SEMI] = ACTIONS(3824),
    [anon_sym___extension__] = ACTIONS(3822),
    [anon_sym_virtual] = ACTIONS(3822),
    [anon_sym_extern] = ACTIONS(3822),
    [anon_sym___attribute__] = ACTIONS(3822),
    [anon_sym___attribute] = ACTIONS(3822),
    [anon_sym_COLON_COLON] = ACTIONS(3824),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3824),
    [anon_sym___declspec] = ACTIONS(3822),
    [anon_sym___based] = ACTIONS(3822),
    [anon_sym___cdecl] = ACTIONS(3822),
    [anon_sym___clrcall] = ACTIONS(3822),
    [anon_sym___stdcall] = ACTIONS(3822),
    [anon_sym___fastcall] = ACTIONS(3822),
    [anon_sym___thiscall] = ACTIONS(3822),
    [anon_sym___vectorcall] = ACTIONS(3822),
    [anon_sym_LBRACE] = ACTIONS(3824),
    [anon_sym_LBRACK] = ACTIONS(3822),
    [anon_sym_static] = ACTIONS(3822),
    [anon_sym_EQ] = ACTIONS(3824),
    [anon_sym_register] = ACTIONS(3822),
    [anon_sym_inline] = ACTIONS(3822),
    [anon_sym___inline] = ACTIONS(3822),
    [anon_sym___inline__] = ACTIONS(3822),
    [anon_sym___forceinline] = ACTIONS(3822),
    [anon_sym_thread_local] = ACTIONS(3822),
    [anon_sym___thread] = ACTIONS(3822),
    [anon_sym_const] = ACTIONS(3822),
    [anon_sym_constexpr] = ACTIONS(3822),
    [anon_sym_volatile] = ACTIONS(3822),
    [anon_sym_restrict] = ACTIONS(3822),
    [anon_sym___restrict__] = ACTIONS(3822),
    [anon_sym__Atomic] = ACTIONS(3822),
    [anon_sym__Noreturn] = ACTIONS(3822),
    [anon_sym_noreturn] = ACTIONS(3822),
    [anon_sym__Nonnull] = ACTIONS(3822),
    [anon_sym_mutable] = ACTIONS(3822),
    [anon_sym_constinit] = ACTIONS(3822),
    [anon_sym_consteval] = ACTIONS(3822),
    [anon_sym_alignas] = ACTIONS(3822),
    [anon_sym__Alignas] = ACTIONS(3822),
    [anon_sym_COLON] = ACTIONS(3822),
    [anon_sym_asm] = ACTIONS(3822),
    [anon_sym___asm__] = ACTIONS(3822),
    [anon_sym___asm] = ACTIONS(3822),
    [anon_sym_DASH_GT] = ACTIONS(3824),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(3822),
    [anon_sym_final] = ACTIONS(3822),
    [anon_sym_override] = ACTIONS(3822),
    [anon_sym_explicit] = ACTIONS(3822),
    [anon_sym_template] = ACTIONS(3822),
    [anon_sym_GT2] = ACTIONS(3824),
    [anon_sym_operator] = ACTIONS(3822),
    [anon_sym_try] = ACTIONS(3822),
    [anon_sym_public] = ACTIONS(3822),
    [anon_sym_private] = ACTIONS(3822),
    [anon_sym_protected] = ACTIONS(3822),
    [anon_sym_requires] = ACTIONS(3822),
  },
  [2035] = {
    [sym_identifier] = ACTIONS(3030),
    [aux_sym_preproc_def_token1] = ACTIONS(3030),
    [aux_sym_preproc_if_token1] = ACTIONS(3030),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3030),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3030),
    [sym_preproc_directive] = ACTIONS(3030),
    [anon_sym_LPAREN2] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3032),
    [anon_sym_STAR] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_AMP] = ACTIONS(3030),
    [anon_sym_SEMI] = ACTIONS(3032),
    [anon_sym___extension__] = ACTIONS(3030),
    [anon_sym_typedef] = ACTIONS(3030),
    [anon_sym_virtual] = ACTIONS(3030),
    [anon_sym_extern] = ACTIONS(3030),
    [anon_sym___attribute__] = ACTIONS(3030),
    [anon_sym___attribute] = ACTIONS(3030),
    [anon_sym_COLON_COLON] = ACTIONS(3032),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3032),
    [anon_sym___declspec] = ACTIONS(3030),
    [anon_sym___based] = ACTIONS(3030),
    [anon_sym_RBRACE] = ACTIONS(3032),
    [anon_sym_signed] = ACTIONS(3030),
    [anon_sym_unsigned] = ACTIONS(3030),
    [anon_sym_long] = ACTIONS(3030),
    [anon_sym_short] = ACTIONS(3030),
    [anon_sym_LBRACK] = ACTIONS(3030),
    [anon_sym_static] = ACTIONS(3030),
    [anon_sym_register] = ACTIONS(3030),
    [anon_sym_inline] = ACTIONS(3030),
    [anon_sym___inline] = ACTIONS(3030),
    [anon_sym___inline__] = ACTIONS(3030),
    [anon_sym___forceinline] = ACTIONS(3030),
    [anon_sym_thread_local] = ACTIONS(3030),
    [anon_sym___thread] = ACTIONS(3030),
    [anon_sym_const] = ACTIONS(3030),
    [anon_sym_constexpr] = ACTIONS(3030),
    [anon_sym_volatile] = ACTIONS(3030),
    [anon_sym_restrict] = ACTIONS(3030),
    [anon_sym___restrict__] = ACTIONS(3030),
    [anon_sym__Atomic] = ACTIONS(3030),
    [anon_sym__Noreturn] = ACTIONS(3030),
    [anon_sym_noreturn] = ACTIONS(3030),
    [anon_sym__Nonnull] = ACTIONS(3030),
    [anon_sym_mutable] = ACTIONS(3030),
    [anon_sym_constinit] = ACTIONS(3030),
    [anon_sym_consteval] = ACTIONS(3030),
    [anon_sym_alignas] = ACTIONS(3030),
    [anon_sym__Alignas] = ACTIONS(3030),
    [sym_primitive_type] = ACTIONS(3030),
    [anon_sym_enum] = ACTIONS(3030),
    [anon_sym_class] = ACTIONS(3030),
    [anon_sym_struct] = ACTIONS(3030),
    [anon_sym_union] = ACTIONS(3030),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3030),
    [anon_sym_decltype] = ACTIONS(3030),
    [anon_sym_explicit] = ACTIONS(3030),
    [anon_sym_typename] = ACTIONS(3030),
    [anon_sym_template] = ACTIONS(3030),
    [anon_sym_operator] = ACTIONS(3030),
    [anon_sym_friend] = ACTIONS(3030),
    [anon_sym_public] = ACTIONS(3030),
    [anon_sym_private] = ACTIONS(3030),
    [anon_sym_protected] = ACTIONS(3030),
    [anon_sym_using] = ACTIONS(3030),
    [anon_sym_static_assert] = ACTIONS(3030),
  },
  [2036] = {
    [sym_identifier] = ACTIONS(3030),
    [aux_sym_preproc_def_token1] = ACTIONS(3030),
    [aux_sym_preproc_if_token1] = ACTIONS(3030),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3030),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3030),
    [sym_preproc_directive] = ACTIONS(3030),
    [anon_sym_LPAREN2] = ACTIONS(3032),
    [anon_sym_TILDE] = ACTIONS(3032),
    [anon_sym_STAR] = ACTIONS(3032),
    [anon_sym_AMP_AMP] = ACTIONS(3032),
    [anon_sym_AMP] = ACTIONS(3030),
    [anon_sym_SEMI] = ACTIONS(3032),
    [anon_sym___extension__] = ACTIONS(3030),
    [anon_sym_typedef] = ACTIONS(3030),
    [anon_sym_virtual] = ACTIONS(3030),
    [anon_sym_extern] = ACTIONS(3030),
    [anon_sym___attribute__] = ACTIONS(3030),
    [anon_sym___attribute] = ACTIONS(3030),
    [anon_sym_COLON_COLON] = ACTIONS(3032),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3032),
    [anon_sym___declspec] = ACTIONS(3030),
    [anon_sym___based] = ACTIONS(3030),
    [anon_sym_RBRACE] = ACTIONS(3032),
    [anon_sym_signed] = ACTIONS(3030),
    [anon_sym_unsigned] = ACTIONS(3030),
    [anon_sym_long] = ACTIONS(3030),
    [anon_sym_short] = ACTIONS(3030),
    [anon_sym_LBRACK] = ACTIONS(3030),
    [anon_sym_static] = ACTIONS(3030),
    [anon_sym_register] = ACTIONS(3030),
    [anon_sym_inline] = ACTIONS(3030),
    [anon_sym___inline] = ACTIONS(3030),
    [anon_sym___inline__] = ACTIONS(3030),
    [anon_sym___forceinline] = ACTIONS(3030),
    [anon_sym_thread_local] = ACTIONS(3030),
    [anon_sym___thread] = ACTIONS(3030),
    [anon_sym_const] = ACTIONS(3030),
    [anon_sym_constexpr] = ACTIONS(3030),
    [anon_sym_volatile] = ACTIONS(3030),
    [anon_sym_restrict] = ACTIONS(3030),
    [anon_sym___restrict__] = ACTIONS(3030),
    [anon_sym__Atomic] = ACTIONS(3030),
    [anon_sym__Noreturn] = ACTIONS(3030),
    [anon_sym_noreturn] = ACTIONS(3030),
    [anon_sym__Nonnull] = ACTIONS(3030),
    [anon_sym_mutable] = ACTIONS(3030),
    [anon_sym_constinit] = ACTIONS(3030),
    [anon_sym_consteval] = ACTIONS(3030),
    [anon_sym_alignas] = ACTIONS(3030),
    [anon_sym__Alignas] = ACTIONS(3030),
    [sym_primitive_type] = ACTIONS(3030),
    [anon_sym_enum] = ACTIONS(3030),
    [anon_sym_class] = ACTIONS(3030),
    [anon_sym_struct] = ACTIONS(3030),
    [anon_sym_union] = ACTIONS(3030),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3030),
    [anon_sym_decltype] = ACTIONS(3030),
    [anon_sym_explicit] = ACTIONS(3030),
    [anon_sym_typename] = ACTIONS(3030),
    [anon_sym_template] = ACTIONS(3030),
    [anon_sym_operator] = ACTIONS(3030),
    [anon_sym_friend] = ACTIONS(3030),
    [anon_sym_public] = ACTIONS(3030),
    [anon_sym_private] = ACTIONS(3030),
    [anon_sym_protected] = ACTIONS(3030),
    [anon_sym_using] = ACTIONS(3030),
    [anon_sym_static_assert] = ACTIONS(3030),
  },
  [2037] = {
    [sym_identifier] = ACTIONS(3042),
    [aux_sym_preproc_def_token1] = ACTIONS(3042),
    [aux_sym_preproc_if_token1] = ACTIONS(3042),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3042),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3042),
    [sym_preproc_directive] = ACTIONS(3042),
    [anon_sym_LPAREN2] = ACTIONS(3044),
    [anon_sym_TILDE] = ACTIONS(3044),
    [anon_sym_STAR] = ACTIONS(3044),
    [anon_sym_AMP_AMP] = ACTIONS(3044),
    [anon_sym_AMP] = ACTIONS(3042),
    [anon_sym_SEMI] = ACTIONS(3044),
    [anon_sym___extension__] = ACTIONS(3042),
    [anon_sym_typedef] = ACTIONS(3042),
    [anon_sym_virtual] = ACTIONS(3042),
    [anon_sym_extern] = ACTIONS(3042),
    [anon_sym___attribute__] = ACTIONS(3042),
    [anon_sym___attribute] = ACTIONS(3042),
    [anon_sym_COLON_COLON] = ACTIONS(3044),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3044),
    [anon_sym___declspec] = ACTIONS(3042),
    [anon_sym___based] = ACTIONS(3042),
    [anon_sym_RBRACE] = ACTIONS(3044),
    [anon_sym_signed] = ACTIONS(3042),
    [anon_sym_unsigned] = ACTIONS(3042),
    [anon_sym_long] = ACTIONS(3042),
    [anon_sym_short] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3042),
    [anon_sym_static] = ACTIONS(3042),
    [anon_sym_register] = ACTIONS(3042),
    [anon_sym_inline] = ACTIONS(3042),
    [anon_sym___inline] = ACTIONS(3042),
    [anon_sym___inline__] = ACTIONS(3042),
    [anon_sym___forceinline] = ACTIONS(3042),
    [anon_sym_thread_local] = ACTIONS(3042),
    [anon_sym___thread] = ACTIONS(3042),
    [anon_sym_const] = ACTIONS(3042),
    [anon_sym_constexpr] = ACTIONS(3042),
    [anon_sym_volatile] = ACTIONS(3042),
    [anon_sym_restrict] = ACTIONS(3042),
    [anon_sym___restrict__] = ACTIONS(3042),
    [anon_sym__Atomic] = ACTIONS(3042),
    [anon_sym__Noreturn] = ACTIONS(3042),
    [anon_sym_noreturn] = ACTIONS(3042),
    [anon_sym__Nonnull] = ACTIONS(3042),
    [anon_sym_mutable] = ACTIONS(3042),
    [anon_sym_constinit] = ACTIONS(3042),
    [anon_sym_consteval] = ACTIONS(3042),
    [anon_sym_alignas] = ACTIONS(3042),
    [anon_sym__Alignas] = ACTIONS(3042),
    [sym_primitive_type] = ACTIONS(3042),
    [anon_sym_enum] = ACTIONS(3042),
    [anon_sym_class] = ACTIONS(3042),
    [anon_sym_struct] = ACTIONS(3042),
    [anon_sym_union] = ACTIONS(3042),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3042),
    [anon_sym_decltype] = ACTIONS(3042),
    [anon_sym_explicit] = ACTIONS(3042),
    [anon_sym_typename] = ACTIONS(3042),
    [anon_sym_template] = ACTIONS(3042),
    [anon_sym_operator] = ACTIONS(3042),
    [anon_sym_friend] = ACTIONS(3042),
    [anon_sym_public] = ACTIONS(3042),
    [anon_sym_private] = ACTIONS(3042),
    [anon_sym_protected] = ACTIONS(3042),
    [anon_sym_using] = ACTIONS(3042),
    [anon_sym_static_assert] = ACTIONS(3042),
  },
  [2038] = {
    [sym_identifier] = ACTIONS(3042),
    [aux_sym_preproc_def_token1] = ACTIONS(3042),
    [aux_sym_preproc_if_token1] = ACTIONS(3042),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3042),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3042),
    [sym_preproc_directive] = ACTIONS(3042),
    [anon_sym_LPAREN2] = ACTIONS(3044),
    [anon_sym_TILDE] = ACTIONS(3044),
    [anon_sym_STAR] = ACTIONS(3044),
    [anon_sym_AMP_AMP] = ACTIONS(3044),
    [anon_sym_AMP] = ACTIONS(3042),
    [anon_sym_SEMI] = ACTIONS(3044),
    [anon_sym___extension__] = ACTIONS(3042),
    [anon_sym_typedef] = ACTIONS(3042),
    [anon_sym_virtual] = ACTIONS(3042),
    [anon_sym_extern] = ACTIONS(3042),
    [anon_sym___attribute__] = ACTIONS(3042),
    [anon_sym___attribute] = ACTIONS(3042),
    [anon_sym_COLON_COLON] = ACTIONS(3044),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3044),
    [anon_sym___declspec] = ACTIONS(3042),
    [anon_sym___based] = ACTIONS(3042),
    [anon_sym_RBRACE] = ACTIONS(3044),
    [anon_sym_signed] = ACTIONS(3042),
    [anon_sym_unsigned] = ACTIONS(3042),
    [anon_sym_long] = ACTIONS(3042),
    [anon_sym_short] = ACTIONS(3042),
    [anon_sym_LBRACK] = ACTIONS(3042),
    [anon_sym_static] = ACTIONS(3042),
    [anon_sym_register] = ACTIONS(3042),
    [anon_sym_inline] = ACTIONS(3042),
    [anon_sym___inline] = ACTIONS(3042),
    [anon_sym___inline__] = ACTIONS(3042),
    [anon_sym___forceinline] = ACTIONS(3042),
    [anon_sym_thread_local] = ACTIONS(3042),
    [anon_sym___thread] = ACTIONS(3042),
    [anon_sym_const] = ACTIONS(3042),
    [anon_sym_constexpr] = ACTIONS(3042),
    [anon_sym_volatile] = ACTIONS(3042),
    [anon_sym_restrict] = ACTIONS(3042),
    [anon_sym___restrict__] = ACTIONS(3042),
    [anon_sym__Atomic] = ACTIONS(3042),
    [anon_sym__Noreturn] = ACTIONS(3042),
    [anon_sym_noreturn] = ACTIONS(3042),
    [anon_sym__Nonnull] = ACTIONS(3042),
    [anon_sym_mutable] = ACTIONS(3042),
    [anon_sym_constinit] = ACTIONS(3042),
    [anon_sym_consteval] = ACTIONS(3042),
    [anon_sym_alignas] = ACTIONS(3042),
    [anon_sym__Alignas] = ACTIONS(3042),
    [sym_primitive_type] = ACTIONS(3042),
    [anon_sym_enum] = ACTIONS(3042),
    [anon_sym_class] = ACTIONS(3042),
    [anon_sym_struct] = ACTIONS(3042),
    [anon_sym_union] = ACTIONS(3042),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3042),
    [anon_sym_decltype] = ACTIONS(3042),
    [anon_sym_explicit] = ACTIONS(3042),
    [anon_sym_typename] = ACTIONS(3042),
    [anon_sym_template] = ACTIONS(3042),
    [anon_sym_operator] = ACTIONS(3042),
    [anon_sym_friend] = ACTIONS(3042),
    [anon_sym_public] = ACTIONS(3042),
    [anon_sym_private] = ACTIONS(3042),
    [anon_sym_protected] = ACTIONS(3042),
    [anon_sym_using] = ACTIONS(3042),
    [anon_sym_static_assert] = ACTIONS(3042),
  },
  [2039] = {
    [sym_string_literal] = STATE(2149),
    [sym_template_argument_list] = STATE(3162),
    [sym_raw_string_literal] = STATE(2149),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4035),
    [anon_sym_COMMA] = ACTIONS(4035),
    [anon_sym_RPAREN] = ACTIONS(5813),
    [anon_sym_LPAREN2] = ACTIONS(5813),
    [anon_sym_DASH] = ACTIONS(4043),
    [anon_sym_PLUS] = ACTIONS(4043),
    [anon_sym_STAR] = ACTIONS(4043),
    [anon_sym_SLASH] = ACTIONS(4043),
    [anon_sym_PERCENT] = ACTIONS(4043),
    [anon_sym_PIPE_PIPE] = ACTIONS(4035),
    [anon_sym_AMP_AMP] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4043),
    [anon_sym_CARET] = ACTIONS(4043),
    [anon_sym_AMP] = ACTIONS(4043),
    [anon_sym_EQ_EQ] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4043),
    [anon_sym_GT_EQ] = ACTIONS(4035),
    [anon_sym_LT_EQ] = ACTIONS(4043),
    [anon_sym_LT] = ACTIONS(4903),
    [anon_sym_LT_LT] = ACTIONS(4043),
    [anon_sym_GT_GT] = ACTIONS(4043),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5813),
    [anon_sym_LBRACE] = ACTIONS(4059),
    [anon_sym_LBRACK] = ACTIONS(5815),
    [anon_sym_EQ] = ACTIONS(4043),
    [anon_sym_QMARK] = ACTIONS(4035),
    [anon_sym_STAR_EQ] = ACTIONS(4035),
    [anon_sym_SLASH_EQ] = ACTIONS(4035),
    [anon_sym_PERCENT_EQ] = ACTIONS(4035),
    [anon_sym_PLUS_EQ] = ACTIONS(4035),
    [anon_sym_DASH_EQ] = ACTIONS(4035),
    [anon_sym_LT_LT_EQ] = ACTIONS(4035),
    [anon_sym_GT_GT_EQ] = ACTIONS(4035),
    [anon_sym_AMP_EQ] = ACTIONS(4035),
    [anon_sym_CARET_EQ] = ACTIONS(4035),
    [anon_sym_PIPE_EQ] = ACTIONS(4035),
    [anon_sym_and_eq] = ACTIONS(4035),
    [anon_sym_or_eq] = ACTIONS(4035),
    [anon_sym_xor_eq] = ACTIONS(4035),
    [anon_sym_LT_EQ_GT] = ACTIONS(4035),
    [anon_sym_or] = ACTIONS(4043),
    [anon_sym_and] = ACTIONS(4043),
    [anon_sym_bitor] = ACTIONS(4035),
    [anon_sym_xor] = ACTIONS(4043),
    [anon_sym_bitand] = ACTIONS(4035),
    [anon_sym_not_eq] = ACTIONS(4035),
    [anon_sym_DASH_DASH] = ACTIONS(4035),
    [anon_sym_PLUS_PLUS] = ACTIONS(4035),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_DOT_STAR] = ACTIONS(4035),
    [anon_sym_DASH_GT] = ACTIONS(4043),
    [anon_sym_L_DQUOTE] = ACTIONS(4899),
    [anon_sym_u_DQUOTE] = ACTIONS(4899),
    [anon_sym_U_DQUOTE] = ACTIONS(4899),
    [anon_sym_u8_DQUOTE] = ACTIONS(4899),
    [anon_sym_DQUOTE] = ACTIONS(4899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4901),
    [anon_sym_LR_DQUOTE] = ACTIONS(4901),
    [anon_sym_uR_DQUOTE] = ACTIONS(4901),
    [anon_sym_UR_DQUOTE] = ACTIONS(4901),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4901),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4035),
  },
  [2040] = {
    [sym_string_literal] = STATE(2149),
    [sym_template_argument_list] = STATE(3044),
    [sym_raw_string_literal] = STATE(2149),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4035),
    [anon_sym_COMMA] = ACTIONS(4035),
    [anon_sym_RPAREN] = ACTIONS(5868),
    [anon_sym_LPAREN2] = ACTIONS(5868),
    [anon_sym_DASH] = ACTIONS(4043),
    [anon_sym_PLUS] = ACTIONS(4043),
    [anon_sym_STAR] = ACTIONS(4043),
    [anon_sym_SLASH] = ACTIONS(4043),
    [anon_sym_PERCENT] = ACTIONS(4043),
    [anon_sym_PIPE_PIPE] = ACTIONS(4035),
    [anon_sym_AMP_AMP] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4043),
    [anon_sym_CARET] = ACTIONS(4043),
    [anon_sym_AMP] = ACTIONS(4043),
    [anon_sym_EQ_EQ] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4043),
    [anon_sym_GT_EQ] = ACTIONS(4035),
    [anon_sym_LT_EQ] = ACTIONS(4043),
    [anon_sym_LT] = ACTIONS(4892),
    [anon_sym_LT_LT] = ACTIONS(4043),
    [anon_sym_GT_GT] = ACTIONS(4043),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4895),
    [anon_sym_LBRACE] = ACTIONS(4059),
    [anon_sym_LBRACK] = ACTIONS(5871),
    [anon_sym_EQ] = ACTIONS(4043),
    [anon_sym_QMARK] = ACTIONS(4035),
    [anon_sym_STAR_EQ] = ACTIONS(4035),
    [anon_sym_SLASH_EQ] = ACTIONS(4035),
    [anon_sym_PERCENT_EQ] = ACTIONS(4035),
    [anon_sym_PLUS_EQ] = ACTIONS(4035),
    [anon_sym_DASH_EQ] = ACTIONS(4035),
    [anon_sym_LT_LT_EQ] = ACTIONS(4035),
    [anon_sym_GT_GT_EQ] = ACTIONS(4035),
    [anon_sym_AMP_EQ] = ACTIONS(4035),
    [anon_sym_CARET_EQ] = ACTIONS(4035),
    [anon_sym_PIPE_EQ] = ACTIONS(4035),
    [anon_sym_and_eq] = ACTIONS(4035),
    [anon_sym_or_eq] = ACTIONS(4035),
    [anon_sym_xor_eq] = ACTIONS(4035),
    [anon_sym_LT_EQ_GT] = ACTIONS(4035),
    [anon_sym_or] = ACTIONS(4043),
    [anon_sym_and] = ACTIONS(4043),
    [anon_sym_bitor] = ACTIONS(4035),
    [anon_sym_xor] = ACTIONS(4043),
    [anon_sym_bitand] = ACTIONS(4035),
    [anon_sym_not_eq] = ACTIONS(4035),
    [anon_sym_DASH_DASH] = ACTIONS(4035),
    [anon_sym_PLUS_PLUS] = ACTIONS(4035),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_DOT_STAR] = ACTIONS(4035),
    [anon_sym_DASH_GT] = ACTIONS(4043),
    [anon_sym_L_DQUOTE] = ACTIONS(4899),
    [anon_sym_u_DQUOTE] = ACTIONS(4899),
    [anon_sym_U_DQUOTE] = ACTIONS(4899),
    [anon_sym_u8_DQUOTE] = ACTIONS(4899),
    [anon_sym_DQUOTE] = ACTIONS(4899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4901),
    [anon_sym_LR_DQUOTE] = ACTIONS(4901),
    [anon_sym_uR_DQUOTE] = ACTIONS(4901),
    [anon_sym_UR_DQUOTE] = ACTIONS(4901),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4901),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4035),
  },
  [2041] = {
    [sym_identifier] = ACTIONS(2739),
    [aux_sym_preproc_def_token1] = ACTIONS(2739),
    [aux_sym_preproc_if_token1] = ACTIONS(2739),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2739),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2739),
    [sym_preproc_directive] = ACTIONS(2739),
    [anon_sym_LPAREN2] = ACTIONS(2741),
    [anon_sym_TILDE] = ACTIONS(2741),
    [anon_sym_STAR] = ACTIONS(2741),
    [anon_sym_AMP_AMP] = ACTIONS(2741),
    [anon_sym_AMP] = ACTIONS(2739),
    [anon_sym_SEMI] = ACTIONS(2741),
    [anon_sym___extension__] = ACTIONS(2739),
    [anon_sym_typedef] = ACTIONS(2739),
    [anon_sym_virtual] = ACTIONS(2739),
    [anon_sym_extern] = ACTIONS(2739),
    [anon_sym___attribute__] = ACTIONS(2739),
    [anon_sym___attribute] = ACTIONS(2739),
    [anon_sym_COLON_COLON] = ACTIONS(2741),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2741),
    [anon_sym___declspec] = ACTIONS(2739),
    [anon_sym___based] = ACTIONS(2739),
    [anon_sym_RBRACE] = ACTIONS(2741),
    [anon_sym_signed] = ACTIONS(2739),
    [anon_sym_unsigned] = ACTIONS(2739),
    [anon_sym_long] = ACTIONS(2739),
    [anon_sym_short] = ACTIONS(2739),
    [anon_sym_LBRACK] = ACTIONS(2739),
    [anon_sym_static] = ACTIONS(2739),
    [anon_sym_register] = ACTIONS(2739),
    [anon_sym_inline] = ACTIONS(2739),
    [anon_sym___inline] = ACTIONS(2739),
    [anon_sym___inline__] = ACTIONS(2739),
    [anon_sym___forceinline] = ACTIONS(2739),
    [anon_sym_thread_local] = ACTIONS(2739),
    [anon_sym___thread] = ACTIONS(2739),
    [anon_sym_const] = ACTIONS(2739),
    [anon_sym_constexpr] = ACTIONS(2739),
    [anon_sym_volatile] = ACTIONS(2739),
    [anon_sym_restrict] = ACTIONS(2739),
    [anon_sym___restrict__] = ACTIONS(2739),
    [anon_sym__Atomic] = ACTIONS(2739),
    [anon_sym__Noreturn] = ACTIONS(2739),
    [anon_sym_noreturn] = ACTIONS(2739),
    [anon_sym__Nonnull] = ACTIONS(2739),
    [anon_sym_mutable] = ACTIONS(2739),
    [anon_sym_constinit] = ACTIONS(2739),
    [anon_sym_consteval] = ACTIONS(2739),
    [anon_sym_alignas] = ACTIONS(2739),
    [anon_sym__Alignas] = ACTIONS(2739),
    [sym_primitive_type] = ACTIONS(2739),
    [anon_sym_enum] = ACTIONS(2739),
    [anon_sym_class] = ACTIONS(2739),
    [anon_sym_struct] = ACTIONS(2739),
    [anon_sym_union] = ACTIONS(2739),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2739),
    [anon_sym_decltype] = ACTIONS(2739),
    [anon_sym_explicit] = ACTIONS(2739),
    [anon_sym_typename] = ACTIONS(2739),
    [anon_sym_template] = ACTIONS(2739),
    [anon_sym_operator] = ACTIONS(2739),
    [anon_sym_friend] = ACTIONS(2739),
    [anon_sym_public] = ACTIONS(2739),
    [anon_sym_private] = ACTIONS(2739),
    [anon_sym_protected] = ACTIONS(2739),
    [anon_sym_using] = ACTIONS(2739),
    [anon_sym_static_assert] = ACTIONS(2739),
  },
  [2042] = {
    [sym_identifier] = ACTIONS(2747),
    [aux_sym_preproc_def_token1] = ACTIONS(2747),
    [aux_sym_preproc_if_token1] = ACTIONS(2747),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2747),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2747),
    [sym_preproc_directive] = ACTIONS(2747),
    [anon_sym_LPAREN2] = ACTIONS(2749),
    [anon_sym_TILDE] = ACTIONS(2749),
    [anon_sym_STAR] = ACTIONS(2749),
    [anon_sym_AMP_AMP] = ACTIONS(2749),
    [anon_sym_AMP] = ACTIONS(2747),
    [anon_sym_SEMI] = ACTIONS(2749),
    [anon_sym___extension__] = ACTIONS(2747),
    [anon_sym_typedef] = ACTIONS(2747),
    [anon_sym_virtual] = ACTIONS(2747),
    [anon_sym_extern] = ACTIONS(2747),
    [anon_sym___attribute__] = ACTIONS(2747),
    [anon_sym___attribute] = ACTIONS(2747),
    [anon_sym_COLON_COLON] = ACTIONS(2749),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2749),
    [anon_sym___declspec] = ACTIONS(2747),
    [anon_sym___based] = ACTIONS(2747),
    [anon_sym_RBRACE] = ACTIONS(2749),
    [anon_sym_signed] = ACTIONS(2747),
    [anon_sym_unsigned] = ACTIONS(2747),
    [anon_sym_long] = ACTIONS(2747),
    [anon_sym_short] = ACTIONS(2747),
    [anon_sym_LBRACK] = ACTIONS(2747),
    [anon_sym_static] = ACTIONS(2747),
    [anon_sym_register] = ACTIONS(2747),
    [anon_sym_inline] = ACTIONS(2747),
    [anon_sym___inline] = ACTIONS(2747),
    [anon_sym___inline__] = ACTIONS(2747),
    [anon_sym___forceinline] = ACTIONS(2747),
    [anon_sym_thread_local] = ACTIONS(2747),
    [anon_sym___thread] = ACTIONS(2747),
    [anon_sym_const] = ACTIONS(2747),
    [anon_sym_constexpr] = ACTIONS(2747),
    [anon_sym_volatile] = ACTIONS(2747),
    [anon_sym_restrict] = ACTIONS(2747),
    [anon_sym___restrict__] = ACTIONS(2747),
    [anon_sym__Atomic] = ACTIONS(2747),
    [anon_sym__Noreturn] = ACTIONS(2747),
    [anon_sym_noreturn] = ACTIONS(2747),
    [anon_sym__Nonnull] = ACTIONS(2747),
    [anon_sym_mutable] = ACTIONS(2747),
    [anon_sym_constinit] = ACTIONS(2747),
    [anon_sym_consteval] = ACTIONS(2747),
    [anon_sym_alignas] = ACTIONS(2747),
    [anon_sym__Alignas] = ACTIONS(2747),
    [sym_primitive_type] = ACTIONS(2747),
    [anon_sym_enum] = ACTIONS(2747),
    [anon_sym_class] = ACTIONS(2747),
    [anon_sym_struct] = ACTIONS(2747),
    [anon_sym_union] = ACTIONS(2747),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2747),
    [anon_sym_decltype] = ACTIONS(2747),
    [anon_sym_explicit] = ACTIONS(2747),
    [anon_sym_typename] = ACTIONS(2747),
    [anon_sym_template] = ACTIONS(2747),
    [anon_sym_operator] = ACTIONS(2747),
    [anon_sym_friend] = ACTIONS(2747),
    [anon_sym_public] = ACTIONS(2747),
    [anon_sym_private] = ACTIONS(2747),
    [anon_sym_protected] = ACTIONS(2747),
    [anon_sym_using] = ACTIONS(2747),
    [anon_sym_static_assert] = ACTIONS(2747),
  },
  [2043] = {
    [sym_identifier] = ACTIONS(2747),
    [aux_sym_preproc_def_token1] = ACTIONS(2747),
    [aux_sym_preproc_if_token1] = ACTIONS(2747),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2747),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2747),
    [sym_preproc_directive] = ACTIONS(2747),
    [anon_sym_LPAREN2] = ACTIONS(2749),
    [anon_sym_TILDE] = ACTIONS(2749),
    [anon_sym_STAR] = ACTIONS(2749),
    [anon_sym_AMP_AMP] = ACTIONS(2749),
    [anon_sym_AMP] = ACTIONS(2747),
    [anon_sym_SEMI] = ACTIONS(2749),
    [anon_sym___extension__] = ACTIONS(2747),
    [anon_sym_typedef] = ACTIONS(2747),
    [anon_sym_virtual] = ACTIONS(2747),
    [anon_sym_extern] = ACTIONS(2747),
    [anon_sym___attribute__] = ACTIONS(2747),
    [anon_sym___attribute] = ACTIONS(2747),
    [anon_sym_COLON_COLON] = ACTIONS(2749),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2749),
    [anon_sym___declspec] = ACTIONS(2747),
    [anon_sym___based] = ACTIONS(2747),
    [anon_sym_RBRACE] = ACTIONS(2749),
    [anon_sym_signed] = ACTIONS(2747),
    [anon_sym_unsigned] = ACTIONS(2747),
    [anon_sym_long] = ACTIONS(2747),
    [anon_sym_short] = ACTIONS(2747),
    [anon_sym_LBRACK] = ACTIONS(2747),
    [anon_sym_static] = ACTIONS(2747),
    [anon_sym_register] = ACTIONS(2747),
    [anon_sym_inline] = ACTIONS(2747),
    [anon_sym___inline] = ACTIONS(2747),
    [anon_sym___inline__] = ACTIONS(2747),
    [anon_sym___forceinline] = ACTIONS(2747),
    [anon_sym_thread_local] = ACTIONS(2747),
    [anon_sym___thread] = ACTIONS(2747),
    [anon_sym_const] = ACTIONS(2747),
    [anon_sym_constexpr] = ACTIONS(2747),
    [anon_sym_volatile] = ACTIONS(2747),
    [anon_sym_restrict] = ACTIONS(2747),
    [anon_sym___restrict__] = ACTIONS(2747),
    [anon_sym__Atomic] = ACTIONS(2747),
    [anon_sym__Noreturn] = ACTIONS(2747),
    [anon_sym_noreturn] = ACTIONS(2747),
    [anon_sym__Nonnull] = ACTIONS(2747),
    [anon_sym_mutable] = ACTIONS(2747),
    [anon_sym_constinit] = ACTIONS(2747),
    [anon_sym_consteval] = ACTIONS(2747),
    [anon_sym_alignas] = ACTIONS(2747),
    [anon_sym__Alignas] = ACTIONS(2747),
    [sym_primitive_type] = ACTIONS(2747),
    [anon_sym_enum] = ACTIONS(2747),
    [anon_sym_class] = ACTIONS(2747),
    [anon_sym_struct] = ACTIONS(2747),
    [anon_sym_union] = ACTIONS(2747),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2747),
    [anon_sym_decltype] = ACTIONS(2747),
    [anon_sym_explicit] = ACTIONS(2747),
    [anon_sym_typename] = ACTIONS(2747),
    [anon_sym_template] = ACTIONS(2747),
    [anon_sym_operator] = ACTIONS(2747),
    [anon_sym_friend] = ACTIONS(2747),
    [anon_sym_public] = ACTIONS(2747),
    [anon_sym_private] = ACTIONS(2747),
    [anon_sym_protected] = ACTIONS(2747),
    [anon_sym_using] = ACTIONS(2747),
    [anon_sym_static_assert] = ACTIONS(2747),
  },
  [2044] = {
    [sym_attribute_specifier] = STATE(1800),
    [sym_field_declaration_list] = STATE(2311),
    [sym_virtual_specifier] = STATE(6916),
    [sym_base_class_clause] = STATE(7464),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5377),
    [anon_sym_COMMA] = ACTIONS(5377),
    [anon_sym_RPAREN] = ACTIONS(5377),
    [anon_sym_LPAREN2] = ACTIONS(5377),
    [anon_sym_DASH] = ACTIONS(5375),
    [anon_sym_PLUS] = ACTIONS(5375),
    [anon_sym_STAR] = ACTIONS(5377),
    [anon_sym_SLASH] = ACTIONS(5375),
    [anon_sym_PERCENT] = ACTIONS(5377),
    [anon_sym_PIPE_PIPE] = ACTIONS(5377),
    [anon_sym_AMP_AMP] = ACTIONS(5377),
    [anon_sym_PIPE] = ACTIONS(5375),
    [anon_sym_CARET] = ACTIONS(5377),
    [anon_sym_AMP] = ACTIONS(5375),
    [anon_sym_EQ_EQ] = ACTIONS(5377),
    [anon_sym_BANG_EQ] = ACTIONS(5377),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5377),
    [anon_sym_LT_EQ] = ACTIONS(5375),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_LT] = ACTIONS(5377),
    [anon_sym_GT_GT] = ACTIONS(5377),
    [anon_sym_SEMI] = ACTIONS(5377),
    [anon_sym___extension__] = ACTIONS(5377),
    [anon_sym___attribute__] = ACTIONS(5874),
    [anon_sym___attribute] = ACTIONS(5876),
    [anon_sym_LBRACE] = ACTIONS(5878),
    [anon_sym_RBRACE] = ACTIONS(5377),
    [anon_sym_LBRACK] = ACTIONS(5377),
    [anon_sym_RBRACK] = ACTIONS(5377),
    [anon_sym_const] = ACTIONS(5375),
    [anon_sym_constexpr] = ACTIONS(5377),
    [anon_sym_volatile] = ACTIONS(5377),
    [anon_sym_restrict] = ACTIONS(5377),
    [anon_sym___restrict__] = ACTIONS(5377),
    [anon_sym__Atomic] = ACTIONS(5377),
    [anon_sym__Noreturn] = ACTIONS(5377),
    [anon_sym_noreturn] = ACTIONS(5377),
    [anon_sym__Nonnull] = ACTIONS(5377),
    [anon_sym_mutable] = ACTIONS(5377),
    [anon_sym_constinit] = ACTIONS(5377),
    [anon_sym_consteval] = ACTIONS(5377),
    [anon_sym_alignas] = ACTIONS(5377),
    [anon_sym__Alignas] = ACTIONS(5377),
    [anon_sym_COLON] = ACTIONS(5383),
    [anon_sym_QMARK] = ACTIONS(5377),
    [anon_sym_LT_EQ_GT] = ACTIONS(5377),
    [anon_sym_or] = ACTIONS(5377),
    [anon_sym_and] = ACTIONS(5377),
    [anon_sym_bitor] = ACTIONS(5377),
    [anon_sym_xor] = ACTIONS(5377),
    [anon_sym_bitand] = ACTIONS(5377),
    [anon_sym_not_eq] = ACTIONS(5377),
    [anon_sym_DASH_DASH] = ACTIONS(5377),
    [anon_sym_PLUS_PLUS] = ACTIONS(5377),
    [anon_sym_DOT] = ACTIONS(5375),
    [anon_sym_DOT_STAR] = ACTIONS(5377),
    [anon_sym_DASH_GT] = ACTIONS(5377),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5377),
    [anon_sym_decltype] = ACTIONS(5377),
    [anon_sym_final] = ACTIONS(5880),
    [anon_sym_override] = ACTIONS(5880),
    [anon_sym_requires] = ACTIONS(5377),
  },
  [2045] = {
    [sym__declaration_modifiers] = STATE(3242),
    [sym_attribute_specifier] = STATE(3242),
    [sym_attribute_declaration] = STATE(3242),
    [sym_ms_declspec_modifier] = STATE(3242),
    [sym_storage_class_specifier] = STATE(3242),
    [sym_type_qualifier] = STATE(3242),
    [sym_alignas_qualifier] = STATE(1619),
    [sym_type_specifier] = STATE(2364),
    [sym_sized_type_specifier] = STATE(2383),
    [sym_enum_specifier] = STATE(2383),
    [sym_struct_specifier] = STATE(2383),
    [sym_union_specifier] = STATE(2383),
    [sym_placeholder_type_specifier] = STATE(2383),
    [sym_decltype_auto] = STATE(2423),
    [sym_decltype] = STATE(2336),
    [sym_class_specifier] = STATE(2383),
    [sym_dependent_type] = STATE(2383),
    [sym_template_type] = STATE(2336),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(6511),
    [sym_qualified_type_identifier] = STATE(2978),
    [aux_sym__declaration_specifiers_repeat1] = STATE(3242),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2269),
    [sym_identifier] = ACTIONS(4869),
    [anon_sym___extension__] = ACTIONS(65),
    [anon_sym_virtual] = ACTIONS(5852),
    [anon_sym_extern] = ACTIONS(61),
    [anon_sym___attribute__] = ACTIONS(43),
    [anon_sym___attribute] = ACTIONS(43),
    [anon_sym_COLON_COLON] = ACTIONS(4879),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1755),
    [anon_sym___declspec] = ACTIONS(49),
    [anon_sym_signed] = ACTIONS(57),
    [anon_sym_unsigned] = ACTIONS(57),
    [anon_sym_long] = ACTIONS(57),
    [anon_sym_short] = ACTIONS(57),
    [anon_sym_static] = ACTIONS(61),
    [anon_sym_register] = ACTIONS(61),
    [anon_sym_inline] = ACTIONS(61),
    [anon_sym___inline] = ACTIONS(61),
    [anon_sym___inline__] = ACTIONS(61),
    [anon_sym___forceinline] = ACTIONS(61),
    [anon_sym_thread_local] = ACTIONS(61),
    [anon_sym___thread] = ACTIONS(61),
    [anon_sym_const] = ACTIONS(65),
    [anon_sym_constexpr] = ACTIONS(65),
    [anon_sym_volatile] = ACTIONS(65),
    [anon_sym_restrict] = ACTIONS(65),
    [anon_sym___restrict__] = ACTIONS(65),
    [anon_sym__Atomic] = ACTIONS(65),
    [anon_sym__Noreturn] = ACTIONS(65),
    [anon_sym_noreturn] = ACTIONS(65),
    [anon_sym__Nonnull] = ACTIONS(65),
    [anon_sym_mutable] = ACTIONS(65),
    [anon_sym_constinit] = ACTIONS(65),
    [anon_sym_consteval] = ACTIONS(65),
    [anon_sym_alignas] = ACTIONS(67),
    [anon_sym__Alignas] = ACTIONS(67),
    [sym_primitive_type] = ACTIONS(3212),
    [anon_sym_enum] = ACTIONS(1857),
    [anon_sym_class] = ACTIONS(1859),
    [anon_sym_struct] = ACTIONS(1861),
    [anon_sym_union] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(123),
    [anon_sym_decltype] = ACTIONS(125),
    [anon_sym_typename] = ACTIONS(1887),
    [anon_sym_template] = ACTIONS(1235),
  },
  [2046] = {
    [sym_identifier] = ACTIONS(5407),
    [aux_sym_preproc_def_token1] = ACTIONS(5407),
    [aux_sym_preproc_if_token1] = ACTIONS(5407),
    [aux_sym_preproc_if_token2] = ACTIONS(5407),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5407),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5407),
    [sym_preproc_directive] = ACTIONS(5407),
    [anon_sym_LPAREN2] = ACTIONS(5409),
    [anon_sym_TILDE] = ACTIONS(5409),
    [anon_sym_STAR] = ACTIONS(5409),
    [anon_sym_AMP_AMP] = ACTIONS(5409),
    [anon_sym_AMP] = ACTIONS(5407),
    [anon_sym_SEMI] = ACTIONS(5409),
    [anon_sym___extension__] = ACTIONS(5407),
    [anon_sym_typedef] = ACTIONS(5407),
    [anon_sym_virtual] = ACTIONS(5407),
    [anon_sym_extern] = ACTIONS(5407),
    [anon_sym___attribute__] = ACTIONS(5407),
    [anon_sym___attribute] = ACTIONS(5407),
    [anon_sym_COLON_COLON] = ACTIONS(5409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5409),
    [anon_sym___declspec] = ACTIONS(5407),
    [anon_sym___based] = ACTIONS(5407),
    [anon_sym_signed] = ACTIONS(5407),
    [anon_sym_unsigned] = ACTIONS(5407),
    [anon_sym_long] = ACTIONS(5407),
    [anon_sym_short] = ACTIONS(5407),
    [anon_sym_LBRACK] = ACTIONS(5407),
    [anon_sym_static] = ACTIONS(5407),
    [anon_sym_register] = ACTIONS(5407),
    [anon_sym_inline] = ACTIONS(5407),
    [anon_sym___inline] = ACTIONS(5407),
    [anon_sym___inline__] = ACTIONS(5407),
    [anon_sym___forceinline] = ACTIONS(5407),
    [anon_sym_thread_local] = ACTIONS(5407),
    [anon_sym___thread] = ACTIONS(5407),
    [anon_sym_const] = ACTIONS(5407),
    [anon_sym_constexpr] = ACTIONS(5407),
    [anon_sym_volatile] = ACTIONS(5407),
    [anon_sym_restrict] = ACTIONS(5407),
    [anon_sym___restrict__] = ACTIONS(5407),
    [anon_sym__Atomic] = ACTIONS(5407),
    [anon_sym__Noreturn] = ACTIONS(5407),
    [anon_sym_noreturn] = ACTIONS(5407),
    [anon_sym__Nonnull] = ACTIONS(5407),
    [anon_sym_mutable] = ACTIONS(5407),
    [anon_sym_constinit] = ACTIONS(5407),
    [anon_sym_consteval] = ACTIONS(5407),
    [anon_sym_alignas] = ACTIONS(5407),
    [anon_sym__Alignas] = ACTIONS(5407),
    [sym_primitive_type] = ACTIONS(5407),
    [anon_sym_enum] = ACTIONS(5407),
    [anon_sym_class] = ACTIONS(5407),
    [anon_sym_struct] = ACTIONS(5407),
    [anon_sym_union] = ACTIONS(5407),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5407),
    [anon_sym_decltype] = ACTIONS(5407),
    [anon_sym_explicit] = ACTIONS(5407),
    [anon_sym_typename] = ACTIONS(5407),
    [anon_sym_template] = ACTIONS(5407),
    [anon_sym_operator] = ACTIONS(5407),
    [anon_sym_friend] = ACTIONS(5407),
    [anon_sym_public] = ACTIONS(5407),
    [anon_sym_private] = ACTIONS(5407),
    [anon_sym_protected] = ACTIONS(5407),
    [anon_sym_using] = ACTIONS(5407),
    [anon_sym_static_assert] = ACTIONS(5407),
  },
  [2047] = {
    [sym_identifier] = ACTIONS(5411),
    [aux_sym_preproc_def_token1] = ACTIONS(5411),
    [aux_sym_preproc_if_token1] = ACTIONS(5411),
    [aux_sym_preproc_if_token2] = ACTIONS(5411),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5411),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5411),
    [sym_preproc_directive] = ACTIONS(5411),
    [anon_sym_LPAREN2] = ACTIONS(5413),
    [anon_sym_TILDE] = ACTIONS(5413),
    [anon_sym_STAR] = ACTIONS(5413),
    [anon_sym_AMP_AMP] = ACTIONS(5413),
    [anon_sym_AMP] = ACTIONS(5411),
    [anon_sym_SEMI] = ACTIONS(5413),
    [anon_sym___extension__] = ACTIONS(5411),
    [anon_sym_typedef] = ACTIONS(5411),
    [anon_sym_virtual] = ACTIONS(5411),
    [anon_sym_extern] = ACTIONS(5411),
    [anon_sym___attribute__] = ACTIONS(5411),
    [anon_sym___attribute] = ACTIONS(5411),
    [anon_sym_COLON_COLON] = ACTIONS(5413),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5413),
    [anon_sym___declspec] = ACTIONS(5411),
    [anon_sym___based] = ACTIONS(5411),
    [anon_sym_signed] = ACTIONS(5411),
    [anon_sym_unsigned] = ACTIONS(5411),
    [anon_sym_long] = ACTIONS(5411),
    [anon_sym_short] = ACTIONS(5411),
    [anon_sym_LBRACK] = ACTIONS(5411),
    [anon_sym_static] = ACTIONS(5411),
    [anon_sym_register] = ACTIONS(5411),
    [anon_sym_inline] = ACTIONS(5411),
    [anon_sym___inline] = ACTIONS(5411),
    [anon_sym___inline__] = ACTIONS(5411),
    [anon_sym___forceinline] = ACTIONS(5411),
    [anon_sym_thread_local] = ACTIONS(5411),
    [anon_sym___thread] = ACTIONS(5411),
    [anon_sym_const] = ACTIONS(5411),
    [anon_sym_constexpr] = ACTIONS(5411),
    [anon_sym_volatile] = ACTIONS(5411),
    [anon_sym_restrict] = ACTIONS(5411),
    [anon_sym___restrict__] = ACTIONS(5411),
    [anon_sym__Atomic] = ACTIONS(5411),
    [anon_sym__Noreturn] = ACTIONS(5411),
    [anon_sym_noreturn] = ACTIONS(5411),
    [anon_sym__Nonnull] = ACTIONS(5411),
    [anon_sym_mutable] = ACTIONS(5411),
    [anon_sym_constinit] = ACTIONS(5411),
    [anon_sym_consteval] = ACTIONS(5411),
    [anon_sym_alignas] = ACTIONS(5411),
    [anon_sym__Alignas] = ACTIONS(5411),
    [sym_primitive_type] = ACTIONS(5411),
    [anon_sym_enum] = ACTIONS(5411),
    [anon_sym_class] = ACTIONS(5411),
    [anon_sym_struct] = ACTIONS(5411),
    [anon_sym_union] = ACTIONS(5411),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5411),
    [anon_sym_decltype] = ACTIONS(5411),
    [anon_sym_explicit] = ACTIONS(5411),
    [anon_sym_typename] = ACTIONS(5411),
    [anon_sym_template] = ACTIONS(5411),
    [anon_sym_operator] = ACTIONS(5411),
    [anon_sym_friend] = ACTIONS(5411),
    [anon_sym_public] = ACTIONS(5411),
    [anon_sym_private] = ACTIONS(5411),
    [anon_sym_protected] = ACTIONS(5411),
    [anon_sym_using] = ACTIONS(5411),
    [anon_sym_static_assert] = ACTIONS(5411),
  },
  [2048] = {
    [sym_identifier] = ACTIONS(5415),
    [aux_sym_preproc_def_token1] = ACTIONS(5415),
    [aux_sym_preproc_if_token1] = ACTIONS(5415),
    [aux_sym_preproc_if_token2] = ACTIONS(5415),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5415),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5415),
    [sym_preproc_directive] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(5417),
    [anon_sym_TILDE] = ACTIONS(5417),
    [anon_sym_STAR] = ACTIONS(5417),
    [anon_sym_AMP_AMP] = ACTIONS(5417),
    [anon_sym_AMP] = ACTIONS(5415),
    [anon_sym_SEMI] = ACTIONS(5417),
    [anon_sym___extension__] = ACTIONS(5415),
    [anon_sym_typedef] = ACTIONS(5415),
    [anon_sym_virtual] = ACTIONS(5415),
    [anon_sym_extern] = ACTIONS(5415),
    [anon_sym___attribute__] = ACTIONS(5415),
    [anon_sym___attribute] = ACTIONS(5415),
    [anon_sym_COLON_COLON] = ACTIONS(5417),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5417),
    [anon_sym___declspec] = ACTIONS(5415),
    [anon_sym___based] = ACTIONS(5415),
    [anon_sym_signed] = ACTIONS(5415),
    [anon_sym_unsigned] = ACTIONS(5415),
    [anon_sym_long] = ACTIONS(5415),
    [anon_sym_short] = ACTIONS(5415),
    [anon_sym_LBRACK] = ACTIONS(5415),
    [anon_sym_static] = ACTIONS(5415),
    [anon_sym_register] = ACTIONS(5415),
    [anon_sym_inline] = ACTIONS(5415),
    [anon_sym___inline] = ACTIONS(5415),
    [anon_sym___inline__] = ACTIONS(5415),
    [anon_sym___forceinline] = ACTIONS(5415),
    [anon_sym_thread_local] = ACTIONS(5415),
    [anon_sym___thread] = ACTIONS(5415),
    [anon_sym_const] = ACTIONS(5415),
    [anon_sym_constexpr] = ACTIONS(5415),
    [anon_sym_volatile] = ACTIONS(5415),
    [anon_sym_restrict] = ACTIONS(5415),
    [anon_sym___restrict__] = ACTIONS(5415),
    [anon_sym__Atomic] = ACTIONS(5415),
    [anon_sym__Noreturn] = ACTIONS(5415),
    [anon_sym_noreturn] = ACTIONS(5415),
    [anon_sym__Nonnull] = ACTIONS(5415),
    [anon_sym_mutable] = ACTIONS(5415),
    [anon_sym_constinit] = ACTIONS(5415),
    [anon_sym_consteval] = ACTIONS(5415),
    [anon_sym_alignas] = ACTIONS(5415),
    [anon_sym__Alignas] = ACTIONS(5415),
    [sym_primitive_type] = ACTIONS(5415),
    [anon_sym_enum] = ACTIONS(5415),
    [anon_sym_class] = ACTIONS(5415),
    [anon_sym_struct] = ACTIONS(5415),
    [anon_sym_union] = ACTIONS(5415),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5415),
    [anon_sym_decltype] = ACTIONS(5415),
    [anon_sym_explicit] = ACTIONS(5415),
    [anon_sym_typename] = ACTIONS(5415),
    [anon_sym_template] = ACTIONS(5415),
    [anon_sym_operator] = ACTIONS(5415),
    [anon_sym_friend] = ACTIONS(5415),
    [anon_sym_public] = ACTIONS(5415),
    [anon_sym_private] = ACTIONS(5415),
    [anon_sym_protected] = ACTIONS(5415),
    [anon_sym_using] = ACTIONS(5415),
    [anon_sym_static_assert] = ACTIONS(5415),
  },
  [2049] = {
    [sym_identifier] = ACTIONS(5419),
    [aux_sym_preproc_def_token1] = ACTIONS(5419),
    [aux_sym_preproc_if_token1] = ACTIONS(5419),
    [aux_sym_preproc_if_token2] = ACTIONS(5419),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5419),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5419),
    [sym_preproc_directive] = ACTIONS(5419),
    [anon_sym_LPAREN2] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5421),
    [anon_sym_STAR] = ACTIONS(5421),
    [anon_sym_AMP_AMP] = ACTIONS(5421),
    [anon_sym_AMP] = ACTIONS(5419),
    [anon_sym_SEMI] = ACTIONS(5421),
    [anon_sym___extension__] = ACTIONS(5419),
    [anon_sym_typedef] = ACTIONS(5419),
    [anon_sym_virtual] = ACTIONS(5419),
    [anon_sym_extern] = ACTIONS(5419),
    [anon_sym___attribute__] = ACTIONS(5419),
    [anon_sym___attribute] = ACTIONS(5419),
    [anon_sym_COLON_COLON] = ACTIONS(5421),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5421),
    [anon_sym___declspec] = ACTIONS(5419),
    [anon_sym___based] = ACTIONS(5419),
    [anon_sym_signed] = ACTIONS(5419),
    [anon_sym_unsigned] = ACTIONS(5419),
    [anon_sym_long] = ACTIONS(5419),
    [anon_sym_short] = ACTIONS(5419),
    [anon_sym_LBRACK] = ACTIONS(5419),
    [anon_sym_static] = ACTIONS(5419),
    [anon_sym_register] = ACTIONS(5419),
    [anon_sym_inline] = ACTIONS(5419),
    [anon_sym___inline] = ACTIONS(5419),
    [anon_sym___inline__] = ACTIONS(5419),
    [anon_sym___forceinline] = ACTIONS(5419),
    [anon_sym_thread_local] = ACTIONS(5419),
    [anon_sym___thread] = ACTIONS(5419),
    [anon_sym_const] = ACTIONS(5419),
    [anon_sym_constexpr] = ACTIONS(5419),
    [anon_sym_volatile] = ACTIONS(5419),
    [anon_sym_restrict] = ACTIONS(5419),
    [anon_sym___restrict__] = ACTIONS(5419),
    [anon_sym__Atomic] = ACTIONS(5419),
    [anon_sym__Noreturn] = ACTIONS(5419),
    [anon_sym_noreturn] = ACTIONS(5419),
    [anon_sym__Nonnull] = ACTIONS(5419),
    [anon_sym_mutable] = ACTIONS(5419),
    [anon_sym_constinit] = ACTIONS(5419),
    [anon_sym_consteval] = ACTIONS(5419),
    [anon_sym_alignas] = ACTIONS(5419),
    [anon_sym__Alignas] = ACTIONS(5419),
    [sym_primitive_type] = ACTIONS(5419),
    [anon_sym_enum] = ACTIONS(5419),
    [anon_sym_class] = ACTIONS(5419),
    [anon_sym_struct] = ACTIONS(5419),
    [anon_sym_union] = ACTIONS(5419),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5419),
    [anon_sym_decltype] = ACTIONS(5419),
    [anon_sym_explicit] = ACTIONS(5419),
    [anon_sym_typename] = ACTIONS(5419),
    [anon_sym_template] = ACTIONS(5419),
    [anon_sym_operator] = ACTIONS(5419),
    [anon_sym_friend] = ACTIONS(5419),
    [anon_sym_public] = ACTIONS(5419),
    [anon_sym_private] = ACTIONS(5419),
    [anon_sym_protected] = ACTIONS(5419),
    [anon_sym_using] = ACTIONS(5419),
    [anon_sym_static_assert] = ACTIONS(5419),
  },
  [2050] = {
    [sym_identifier] = ACTIONS(5427),
    [aux_sym_preproc_def_token1] = ACTIONS(5427),
    [aux_sym_preproc_if_token1] = ACTIONS(5427),
    [aux_sym_preproc_if_token2] = ACTIONS(5427),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5427),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5427),
    [sym_preproc_directive] = ACTIONS(5427),
    [anon_sym_LPAREN2] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(5429),
    [anon_sym_STAR] = ACTIONS(5429),
    [anon_sym_AMP_AMP] = ACTIONS(5429),
    [anon_sym_AMP] = ACTIONS(5427),
    [anon_sym_SEMI] = ACTIONS(5429),
    [anon_sym___extension__] = ACTIONS(5427),
    [anon_sym_typedef] = ACTIONS(5427),
    [anon_sym_virtual] = ACTIONS(5427),
    [anon_sym_extern] = ACTIONS(5427),
    [anon_sym___attribute__] = ACTIONS(5427),
    [anon_sym___attribute] = ACTIONS(5427),
    [anon_sym_COLON_COLON] = ACTIONS(5429),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5429),
    [anon_sym___declspec] = ACTIONS(5427),
    [anon_sym___based] = ACTIONS(5427),
    [anon_sym_signed] = ACTIONS(5427),
    [anon_sym_unsigned] = ACTIONS(5427),
    [anon_sym_long] = ACTIONS(5427),
    [anon_sym_short] = ACTIONS(5427),
    [anon_sym_LBRACK] = ACTIONS(5427),
    [anon_sym_static] = ACTIONS(5427),
    [anon_sym_register] = ACTIONS(5427),
    [anon_sym_inline] = ACTIONS(5427),
    [anon_sym___inline] = ACTIONS(5427),
    [anon_sym___inline__] = ACTIONS(5427),
    [anon_sym___forceinline] = ACTIONS(5427),
    [anon_sym_thread_local] = ACTIONS(5427),
    [anon_sym___thread] = ACTIONS(5427),
    [anon_sym_const] = ACTIONS(5427),
    [anon_sym_constexpr] = ACTIONS(5427),
    [anon_sym_volatile] = ACTIONS(5427),
    [anon_sym_restrict] = ACTIONS(5427),
    [anon_sym___restrict__] = ACTIONS(5427),
    [anon_sym__Atomic] = ACTIONS(5427),
    [anon_sym__Noreturn] = ACTIONS(5427),
    [anon_sym_noreturn] = ACTIONS(5427),
    [anon_sym__Nonnull] = ACTIONS(5427),
    [anon_sym_mutable] = ACTIONS(5427),
    [anon_sym_constinit] = ACTIONS(5427),
    [anon_sym_consteval] = ACTIONS(5427),
    [anon_sym_alignas] = ACTIONS(5427),
    [anon_sym__Alignas] = ACTIONS(5427),
    [sym_primitive_type] = ACTIONS(5427),
    [anon_sym_enum] = ACTIONS(5427),
    [anon_sym_class] = ACTIONS(5427),
    [anon_sym_struct] = ACTIONS(5427),
    [anon_sym_union] = ACTIONS(5427),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5427),
    [anon_sym_decltype] = ACTIONS(5427),
    [anon_sym_explicit] = ACTIONS(5427),
    [anon_sym_typename] = ACTIONS(5427),
    [anon_sym_template] = ACTIONS(5427),
    [anon_sym_operator] = ACTIONS(5427),
    [anon_sym_friend] = ACTIONS(5427),
    [anon_sym_public] = ACTIONS(5427),
    [anon_sym_private] = ACTIONS(5427),
    [anon_sym_protected] = ACTIONS(5427),
    [anon_sym_using] = ACTIONS(5427),
    [anon_sym_static_assert] = ACTIONS(5427),
  },
  [2051] = {
    [sym_identifier] = ACTIONS(5427),
    [aux_sym_preproc_def_token1] = ACTIONS(5427),
    [aux_sym_preproc_if_token1] = ACTIONS(5427),
    [aux_sym_preproc_if_token2] = ACTIONS(5427),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5427),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5427),
    [sym_preproc_directive] = ACTIONS(5427),
    [anon_sym_LPAREN2] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(5429),
    [anon_sym_STAR] = ACTIONS(5429),
    [anon_sym_AMP_AMP] = ACTIONS(5429),
    [anon_sym_AMP] = ACTIONS(5427),
    [anon_sym_SEMI] = ACTIONS(5429),
    [anon_sym___extension__] = ACTIONS(5427),
    [anon_sym_typedef] = ACTIONS(5427),
    [anon_sym_virtual] = ACTIONS(5427),
    [anon_sym_extern] = ACTIONS(5427),
    [anon_sym___attribute__] = ACTIONS(5427),
    [anon_sym___attribute] = ACTIONS(5427),
    [anon_sym_COLON_COLON] = ACTIONS(5429),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5429),
    [anon_sym___declspec] = ACTIONS(5427),
    [anon_sym___based] = ACTIONS(5427),
    [anon_sym_signed] = ACTIONS(5427),
    [anon_sym_unsigned] = ACTIONS(5427),
    [anon_sym_long] = ACTIONS(5427),
    [anon_sym_short] = ACTIONS(5427),
    [anon_sym_LBRACK] = ACTIONS(5427),
    [anon_sym_static] = ACTIONS(5427),
    [anon_sym_register] = ACTIONS(5427),
    [anon_sym_inline] = ACTIONS(5427),
    [anon_sym___inline] = ACTIONS(5427),
    [anon_sym___inline__] = ACTIONS(5427),
    [anon_sym___forceinline] = ACTIONS(5427),
    [anon_sym_thread_local] = ACTIONS(5427),
    [anon_sym___thread] = ACTIONS(5427),
    [anon_sym_const] = ACTIONS(5427),
    [anon_sym_constexpr] = ACTIONS(5427),
    [anon_sym_volatile] = ACTIONS(5427),
    [anon_sym_restrict] = ACTIONS(5427),
    [anon_sym___restrict__] = ACTIONS(5427),
    [anon_sym__Atomic] = ACTIONS(5427),
    [anon_sym__Noreturn] = ACTIONS(5427),
    [anon_sym_noreturn] = ACTIONS(5427),
    [anon_sym__Nonnull] = ACTIONS(5427),
    [anon_sym_mutable] = ACTIONS(5427),
    [anon_sym_constinit] = ACTIONS(5427),
    [anon_sym_consteval] = ACTIONS(5427),
    [anon_sym_alignas] = ACTIONS(5427),
    [anon_sym__Alignas] = ACTIONS(5427),
    [sym_primitive_type] = ACTIONS(5427),
    [anon_sym_enum] = ACTIONS(5427),
    [anon_sym_class] = ACTIONS(5427),
    [anon_sym_struct] = ACTIONS(5427),
    [anon_sym_union] = ACTIONS(5427),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5427),
    [anon_sym_decltype] = ACTIONS(5427),
    [anon_sym_explicit] = ACTIONS(5427),
    [anon_sym_typename] = ACTIONS(5427),
    [anon_sym_template] = ACTIONS(5427),
    [anon_sym_operator] = ACTIONS(5427),
    [anon_sym_friend] = ACTIONS(5427),
    [anon_sym_public] = ACTIONS(5427),
    [anon_sym_private] = ACTIONS(5427),
    [anon_sym_protected] = ACTIONS(5427),
    [anon_sym_using] = ACTIONS(5427),
    [anon_sym_static_assert] = ACTIONS(5427),
  },
  [2052] = {
    [sym_identifier] = ACTIONS(5427),
    [aux_sym_preproc_def_token1] = ACTIONS(5427),
    [aux_sym_preproc_if_token1] = ACTIONS(5427),
    [aux_sym_preproc_if_token2] = ACTIONS(5427),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5427),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5427),
    [sym_preproc_directive] = ACTIONS(5427),
    [anon_sym_LPAREN2] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(5429),
    [anon_sym_STAR] = ACTIONS(5429),
    [anon_sym_AMP_AMP] = ACTIONS(5429),
    [anon_sym_AMP] = ACTIONS(5427),
    [anon_sym_SEMI] = ACTIONS(5429),
    [anon_sym___extension__] = ACTIONS(5427),
    [anon_sym_typedef] = ACTIONS(5427),
    [anon_sym_virtual] = ACTIONS(5427),
    [anon_sym_extern] = ACTIONS(5427),
    [anon_sym___attribute__] = ACTIONS(5427),
    [anon_sym___attribute] = ACTIONS(5427),
    [anon_sym_COLON_COLON] = ACTIONS(5429),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5429),
    [anon_sym___declspec] = ACTIONS(5427),
    [anon_sym___based] = ACTIONS(5427),
    [anon_sym_signed] = ACTIONS(5427),
    [anon_sym_unsigned] = ACTIONS(5427),
    [anon_sym_long] = ACTIONS(5427),
    [anon_sym_short] = ACTIONS(5427),
    [anon_sym_LBRACK] = ACTIONS(5427),
    [anon_sym_static] = ACTIONS(5427),
    [anon_sym_register] = ACTIONS(5427),
    [anon_sym_inline] = ACTIONS(5427),
    [anon_sym___inline] = ACTIONS(5427),
    [anon_sym___inline__] = ACTIONS(5427),
    [anon_sym___forceinline] = ACTIONS(5427),
    [anon_sym_thread_local] = ACTIONS(5427),
    [anon_sym___thread] = ACTIONS(5427),
    [anon_sym_const] = ACTIONS(5427),
    [anon_sym_constexpr] = ACTIONS(5427),
    [anon_sym_volatile] = ACTIONS(5427),
    [anon_sym_restrict] = ACTIONS(5427),
    [anon_sym___restrict__] = ACTIONS(5427),
    [anon_sym__Atomic] = ACTIONS(5427),
    [anon_sym__Noreturn] = ACTIONS(5427),
    [anon_sym_noreturn] = ACTIONS(5427),
    [anon_sym__Nonnull] = ACTIONS(5427),
    [anon_sym_mutable] = ACTIONS(5427),
    [anon_sym_constinit] = ACTIONS(5427),
    [anon_sym_consteval] = ACTIONS(5427),
    [anon_sym_alignas] = ACTIONS(5427),
    [anon_sym__Alignas] = ACTIONS(5427),
    [sym_primitive_type] = ACTIONS(5427),
    [anon_sym_enum] = ACTIONS(5427),
    [anon_sym_class] = ACTIONS(5427),
    [anon_sym_struct] = ACTIONS(5427),
    [anon_sym_union] = ACTIONS(5427),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5427),
    [anon_sym_decltype] = ACTIONS(5427),
    [anon_sym_explicit] = ACTIONS(5427),
    [anon_sym_typename] = ACTIONS(5427),
    [anon_sym_template] = ACTIONS(5427),
    [anon_sym_operator] = ACTIONS(5427),
    [anon_sym_friend] = ACTIONS(5427),
    [anon_sym_public] = ACTIONS(5427),
    [anon_sym_private] = ACTIONS(5427),
    [anon_sym_protected] = ACTIONS(5427),
    [anon_sym_using] = ACTIONS(5427),
    [anon_sym_static_assert] = ACTIONS(5427),
  },
  [2053] = {
    [sym_identifier] = ACTIONS(5419),
    [aux_sym_preproc_def_token1] = ACTIONS(5419),
    [aux_sym_preproc_if_token1] = ACTIONS(5419),
    [aux_sym_preproc_if_token2] = ACTIONS(5419),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5419),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5419),
    [sym_preproc_directive] = ACTIONS(5419),
    [anon_sym_LPAREN2] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5421),
    [anon_sym_STAR] = ACTIONS(5421),
    [anon_sym_AMP_AMP] = ACTIONS(5421),
    [anon_sym_AMP] = ACTIONS(5419),
    [anon_sym_SEMI] = ACTIONS(5421),
    [anon_sym___extension__] = ACTIONS(5419),
    [anon_sym_typedef] = ACTIONS(5419),
    [anon_sym_virtual] = ACTIONS(5419),
    [anon_sym_extern] = ACTIONS(5419),
    [anon_sym___attribute__] = ACTIONS(5419),
    [anon_sym___attribute] = ACTIONS(5419),
    [anon_sym_COLON_COLON] = ACTIONS(5421),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5421),
    [anon_sym___declspec] = ACTIONS(5419),
    [anon_sym___based] = ACTIONS(5419),
    [anon_sym_signed] = ACTIONS(5419),
    [anon_sym_unsigned] = ACTIONS(5419),
    [anon_sym_long] = ACTIONS(5419),
    [anon_sym_short] = ACTIONS(5419),
    [anon_sym_LBRACK] = ACTIONS(5419),
    [anon_sym_static] = ACTIONS(5419),
    [anon_sym_register] = ACTIONS(5419),
    [anon_sym_inline] = ACTIONS(5419),
    [anon_sym___inline] = ACTIONS(5419),
    [anon_sym___inline__] = ACTIONS(5419),
    [anon_sym___forceinline] = ACTIONS(5419),
    [anon_sym_thread_local] = ACTIONS(5419),
    [anon_sym___thread] = ACTIONS(5419),
    [anon_sym_const] = ACTIONS(5419),
    [anon_sym_constexpr] = ACTIONS(5419),
    [anon_sym_volatile] = ACTIONS(5419),
    [anon_sym_restrict] = ACTIONS(5419),
    [anon_sym___restrict__] = ACTIONS(5419),
    [anon_sym__Atomic] = ACTIONS(5419),
    [anon_sym__Noreturn] = ACTIONS(5419),
    [anon_sym_noreturn] = ACTIONS(5419),
    [anon_sym__Nonnull] = ACTIONS(5419),
    [anon_sym_mutable] = ACTIONS(5419),
    [anon_sym_constinit] = ACTIONS(5419),
    [anon_sym_consteval] = ACTIONS(5419),
    [anon_sym_alignas] = ACTIONS(5419),
    [anon_sym__Alignas] = ACTIONS(5419),
    [sym_primitive_type] = ACTIONS(5419),
    [anon_sym_enum] = ACTIONS(5419),
    [anon_sym_class] = ACTIONS(5419),
    [anon_sym_struct] = ACTIONS(5419),
    [anon_sym_union] = ACTIONS(5419),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5419),
    [anon_sym_decltype] = ACTIONS(5419),
    [anon_sym_explicit] = ACTIONS(5419),
    [anon_sym_typename] = ACTIONS(5419),
    [anon_sym_template] = ACTIONS(5419),
    [anon_sym_operator] = ACTIONS(5419),
    [anon_sym_friend] = ACTIONS(5419),
    [anon_sym_public] = ACTIONS(5419),
    [anon_sym_private] = ACTIONS(5419),
    [anon_sym_protected] = ACTIONS(5419),
    [anon_sym_using] = ACTIONS(5419),
    [anon_sym_static_assert] = ACTIONS(5419),
  },
  [2054] = {
    [sym_identifier] = ACTIONS(5407),
    [aux_sym_preproc_def_token1] = ACTIONS(5407),
    [aux_sym_preproc_if_token1] = ACTIONS(5407),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5407),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5407),
    [sym_preproc_directive] = ACTIONS(5407),
    [anon_sym_LPAREN2] = ACTIONS(5409),
    [anon_sym_TILDE] = ACTIONS(5409),
    [anon_sym_STAR] = ACTIONS(5409),
    [anon_sym_AMP_AMP] = ACTIONS(5409),
    [anon_sym_AMP] = ACTIONS(5407),
    [anon_sym_SEMI] = ACTIONS(5409),
    [anon_sym___extension__] = ACTIONS(5407),
    [anon_sym_typedef] = ACTIONS(5407),
    [anon_sym_virtual] = ACTIONS(5407),
    [anon_sym_extern] = ACTIONS(5407),
    [anon_sym___attribute__] = ACTIONS(5407),
    [anon_sym___attribute] = ACTIONS(5407),
    [anon_sym_COLON_COLON] = ACTIONS(5409),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5409),
    [anon_sym___declspec] = ACTIONS(5407),
    [anon_sym___based] = ACTIONS(5407),
    [anon_sym_RBRACE] = ACTIONS(5409),
    [anon_sym_signed] = ACTIONS(5407),
    [anon_sym_unsigned] = ACTIONS(5407),
    [anon_sym_long] = ACTIONS(5407),
    [anon_sym_short] = ACTIONS(5407),
    [anon_sym_LBRACK] = ACTIONS(5407),
    [anon_sym_static] = ACTIONS(5407),
    [anon_sym_register] = ACTIONS(5407),
    [anon_sym_inline] = ACTIONS(5407),
    [anon_sym___inline] = ACTIONS(5407),
    [anon_sym___inline__] = ACTIONS(5407),
    [anon_sym___forceinline] = ACTIONS(5407),
    [anon_sym_thread_local] = ACTIONS(5407),
    [anon_sym___thread] = ACTIONS(5407),
    [anon_sym_const] = ACTIONS(5407),
    [anon_sym_constexpr] = ACTIONS(5407),
    [anon_sym_volatile] = ACTIONS(5407),
    [anon_sym_restrict] = ACTIONS(5407),
    [anon_sym___restrict__] = ACTIONS(5407),
    [anon_sym__Atomic] = ACTIONS(5407),
    [anon_sym__Noreturn] = ACTIONS(5407),
    [anon_sym_noreturn] = ACTIONS(5407),
    [anon_sym__Nonnull] = ACTIONS(5407),
    [anon_sym_mutable] = ACTIONS(5407),
    [anon_sym_constinit] = ACTIONS(5407),
    [anon_sym_consteval] = ACTIONS(5407),
    [anon_sym_alignas] = ACTIONS(5407),
    [anon_sym__Alignas] = ACTIONS(5407),
    [sym_primitive_type] = ACTIONS(5407),
    [anon_sym_enum] = ACTIONS(5407),
    [anon_sym_class] = ACTIONS(5407),
    [anon_sym_struct] = ACTIONS(5407),
    [anon_sym_union] = ACTIONS(5407),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5407),
    [anon_sym_decltype] = ACTIONS(5407),
    [anon_sym_explicit] = ACTIONS(5407),
    [anon_sym_typename] = ACTIONS(5407),
    [anon_sym_template] = ACTIONS(5407),
    [anon_sym_operator] = ACTIONS(5407),
    [anon_sym_friend] = ACTIONS(5407),
    [anon_sym_public] = ACTIONS(5407),
    [anon_sym_private] = ACTIONS(5407),
    [anon_sym_protected] = ACTIONS(5407),
    [anon_sym_using] = ACTIONS(5407),
    [anon_sym_static_assert] = ACTIONS(5407),
  },
  [2055] = {
    [sym_template_argument_list] = STATE(1570),
    [sym_identifier] = ACTIONS(4838),
    [anon_sym_LPAREN2] = ACTIONS(4845),
    [anon_sym_TILDE] = ACTIONS(4845),
    [anon_sym_STAR] = ACTIONS(4845),
    [anon_sym_PIPE_PIPE] = ACTIONS(4845),
    [anon_sym_AMP_AMP] = ACTIONS(4845),
    [anon_sym_AMP] = ACTIONS(4838),
    [anon_sym_LT] = ACTIONS(5882),
    [anon_sym___extension__] = ACTIONS(4838),
    [anon_sym_virtual] = ACTIONS(4838),
    [anon_sym_extern] = ACTIONS(4838),
    [anon_sym___attribute__] = ACTIONS(4838),
    [anon_sym___attribute] = ACTIONS(4838),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4845),
    [anon_sym___declspec] = ACTIONS(4838),
    [anon_sym___based] = ACTIONS(4838),
    [anon_sym___cdecl] = ACTIONS(4838),
    [anon_sym___clrcall] = ACTIONS(4838),
    [anon_sym___stdcall] = ACTIONS(4838),
    [anon_sym___fastcall] = ACTIONS(4838),
    [anon_sym___thiscall] = ACTIONS(4838),
    [anon_sym___vectorcall] = ACTIONS(4838),
    [anon_sym_signed] = ACTIONS(4838),
    [anon_sym_unsigned] = ACTIONS(4838),
    [anon_sym_long] = ACTIONS(4838),
    [anon_sym_short] = ACTIONS(4838),
    [anon_sym_LBRACK] = ACTIONS(4838),
    [anon_sym_static] = ACTIONS(4838),
    [anon_sym_register] = ACTIONS(4838),
    [anon_sym_inline] = ACTIONS(4838),
    [anon_sym___inline] = ACTIONS(4838),
    [anon_sym___inline__] = ACTIONS(4838),
    [anon_sym___forceinline] = ACTIONS(4838),
    [anon_sym_thread_local] = ACTIONS(4838),
    [anon_sym___thread] = ACTIONS(4838),
    [anon_sym_const] = ACTIONS(4838),
    [anon_sym_constexpr] = ACTIONS(4838),
    [anon_sym_volatile] = ACTIONS(4838),
    [anon_sym_restrict] = ACTIONS(4838),
    [anon_sym___restrict__] = ACTIONS(4838),
    [anon_sym__Atomic] = ACTIONS(4838),
    [anon_sym__Noreturn] = ACTIONS(4838),
    [anon_sym_noreturn] = ACTIONS(4838),
    [anon_sym__Nonnull] = ACTIONS(4838),
    [anon_sym_mutable] = ACTIONS(4838),
    [anon_sym_constinit] = ACTIONS(4838),
    [anon_sym_consteval] = ACTIONS(4838),
    [anon_sym_alignas] = ACTIONS(4838),
    [anon_sym__Alignas] = ACTIONS(4838),
    [sym_primitive_type] = ACTIONS(4838),
    [anon_sym_enum] = ACTIONS(4838),
    [anon_sym_class] = ACTIONS(4838),
    [anon_sym_struct] = ACTIONS(4838),
    [anon_sym_union] = ACTIONS(4838),
    [anon_sym_or] = ACTIONS(4838),
    [anon_sym_and] = ACTIONS(4838),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4838),
    [anon_sym_decltype] = ACTIONS(4838),
    [anon_sym_explicit] = ACTIONS(4838),
    [anon_sym_typename] = ACTIONS(4838),
    [anon_sym_template] = ACTIONS(4838),
    [anon_sym_operator] = ACTIONS(4838),
    [anon_sym_friend] = ACTIONS(4838),
    [anon_sym_using] = ACTIONS(4838),
    [anon_sym_concept] = ACTIONS(4838),
  },
  [2056] = {
    [sym_string_literal] = STATE(2570),
    [sym_template_argument_list] = STATE(3643),
    [sym_raw_string_literal] = STATE(2570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4035),
    [anon_sym_COMMA] = ACTIONS(4035),
    [anon_sym_RPAREN] = ACTIONS(4035),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_DASH] = ACTIONS(4043),
    [anon_sym_PLUS] = ACTIONS(4043),
    [anon_sym_STAR] = ACTIONS(4043),
    [anon_sym_SLASH] = ACTIONS(4043),
    [anon_sym_PERCENT] = ACTIONS(4043),
    [anon_sym_PIPE_PIPE] = ACTIONS(4035),
    [anon_sym_AMP_AMP] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4043),
    [anon_sym_CARET] = ACTIONS(4043),
    [anon_sym_AMP] = ACTIONS(4043),
    [anon_sym_EQ_EQ] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4043),
    [anon_sym_GT_EQ] = ACTIONS(4035),
    [anon_sym_LT_EQ] = ACTIONS(4043),
    [anon_sym_LT] = ACTIONS(4929),
    [anon_sym_LT_LT] = ACTIONS(4043),
    [anon_sym_GT_GT] = ACTIONS(4043),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACE] = ACTIONS(4059),
    [anon_sym_RBRACE] = ACTIONS(4035),
    [anon_sym_LBRACK] = ACTIONS(4035),
    [anon_sym_EQ] = ACTIONS(4067),
    [anon_sym_QMARK] = ACTIONS(4035),
    [anon_sym_STAR_EQ] = ACTIONS(4071),
    [anon_sym_SLASH_EQ] = ACTIONS(4071),
    [anon_sym_PERCENT_EQ] = ACTIONS(4071),
    [anon_sym_PLUS_EQ] = ACTIONS(4071),
    [anon_sym_DASH_EQ] = ACTIONS(4071),
    [anon_sym_LT_LT_EQ] = ACTIONS(4071),
    [anon_sym_GT_GT_EQ] = ACTIONS(4071),
    [anon_sym_AMP_EQ] = ACTIONS(4071),
    [anon_sym_CARET_EQ] = ACTIONS(4071),
    [anon_sym_PIPE_EQ] = ACTIONS(4071),
    [anon_sym_and_eq] = ACTIONS(4071),
    [anon_sym_or_eq] = ACTIONS(4071),
    [anon_sym_xor_eq] = ACTIONS(4071),
    [anon_sym_LT_EQ_GT] = ACTIONS(4035),
    [anon_sym_or] = ACTIONS(4043),
    [anon_sym_and] = ACTIONS(4043),
    [anon_sym_bitor] = ACTIONS(4035),
    [anon_sym_xor] = ACTIONS(4043),
    [anon_sym_bitand] = ACTIONS(4035),
    [anon_sym_not_eq] = ACTIONS(4035),
    [anon_sym_DASH_DASH] = ACTIONS(4035),
    [anon_sym_PLUS_PLUS] = ACTIONS(4035),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_DOT_STAR] = ACTIONS(4035),
    [anon_sym_DASH_GT] = ACTIONS(4035),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
  },
  [2057] = {
    [sym_identifier] = ACTIONS(2818),
    [aux_sym_preproc_def_token1] = ACTIONS(2818),
    [aux_sym_preproc_if_token1] = ACTIONS(2818),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2818),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2818),
    [sym_preproc_directive] = ACTIONS(2818),
    [anon_sym_LPAREN2] = ACTIONS(2820),
    [anon_sym_TILDE] = ACTIONS(2820),
    [anon_sym_STAR] = ACTIONS(2820),
    [anon_sym_AMP_AMP] = ACTIONS(2820),
    [anon_sym_AMP] = ACTIONS(2818),
    [anon_sym_SEMI] = ACTIONS(2820),
    [anon_sym___extension__] = ACTIONS(2818),
    [anon_sym_typedef] = ACTIONS(2818),
    [anon_sym_virtual] = ACTIONS(2818),
    [anon_sym_extern] = ACTIONS(2818),
    [anon_sym___attribute__] = ACTIONS(2818),
    [anon_sym___attribute] = ACTIONS(2818),
    [anon_sym_COLON_COLON] = ACTIONS(2820),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2820),
    [anon_sym___declspec] = ACTIONS(2818),
    [anon_sym___based] = ACTIONS(2818),
    [anon_sym_RBRACE] = ACTIONS(2820),
    [anon_sym_signed] = ACTIONS(2818),
    [anon_sym_unsigned] = ACTIONS(2818),
    [anon_sym_long] = ACTIONS(2818),
    [anon_sym_short] = ACTIONS(2818),
    [anon_sym_LBRACK] = ACTIONS(2818),
    [anon_sym_static] = ACTIONS(2818),
    [anon_sym_register] = ACTIONS(2818),
    [anon_sym_inline] = ACTIONS(2818),
    [anon_sym___inline] = ACTIONS(2818),
    [anon_sym___inline__] = ACTIONS(2818),
    [anon_sym___forceinline] = ACTIONS(2818),
    [anon_sym_thread_local] = ACTIONS(2818),
    [anon_sym___thread] = ACTIONS(2818),
    [anon_sym_const] = ACTIONS(2818),
    [anon_sym_constexpr] = ACTIONS(2818),
    [anon_sym_volatile] = ACTIONS(2818),
    [anon_sym_restrict] = ACTIONS(2818),
    [anon_sym___restrict__] = ACTIONS(2818),
    [anon_sym__Atomic] = ACTIONS(2818),
    [anon_sym__Noreturn] = ACTIONS(2818),
    [anon_sym_noreturn] = ACTIONS(2818),
    [anon_sym__Nonnull] = ACTIONS(2818),
    [anon_sym_mutable] = ACTIONS(2818),
    [anon_sym_constinit] = ACTIONS(2818),
    [anon_sym_consteval] = ACTIONS(2818),
    [anon_sym_alignas] = ACTIONS(2818),
    [anon_sym__Alignas] = ACTIONS(2818),
    [sym_primitive_type] = ACTIONS(2818),
    [anon_sym_enum] = ACTIONS(2818),
    [anon_sym_class] = ACTIONS(2818),
    [anon_sym_struct] = ACTIONS(2818),
    [anon_sym_union] = ACTIONS(2818),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2818),
    [anon_sym_decltype] = ACTIONS(2818),
    [anon_sym_explicit] = ACTIONS(2818),
    [anon_sym_typename] = ACTIONS(2818),
    [anon_sym_template] = ACTIONS(2818),
    [anon_sym_operator] = ACTIONS(2818),
    [anon_sym_friend] = ACTIONS(2818),
    [anon_sym_public] = ACTIONS(2818),
    [anon_sym_private] = ACTIONS(2818),
    [anon_sym_protected] = ACTIONS(2818),
    [anon_sym_using] = ACTIONS(2818),
    [anon_sym_static_assert] = ACTIONS(2818),
  },
  [2058] = {
    [sym_identifier] = ACTIONS(2805),
    [aux_sym_preproc_def_token1] = ACTIONS(2805),
    [aux_sym_preproc_if_token1] = ACTIONS(2805),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2805),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2805),
    [sym_preproc_directive] = ACTIONS(2805),
    [anon_sym_LPAREN2] = ACTIONS(2807),
    [anon_sym_TILDE] = ACTIONS(2807),
    [anon_sym_STAR] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2805),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym___extension__] = ACTIONS(2805),
    [anon_sym_typedef] = ACTIONS(2805),
    [anon_sym_virtual] = ACTIONS(2805),
    [anon_sym_extern] = ACTIONS(2805),
    [anon_sym___attribute__] = ACTIONS(2805),
    [anon_sym___attribute] = ACTIONS(2805),
    [anon_sym_COLON_COLON] = ACTIONS(2807),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2807),
    [anon_sym___declspec] = ACTIONS(2805),
    [anon_sym___based] = ACTIONS(2805),
    [anon_sym_RBRACE] = ACTIONS(2807),
    [anon_sym_signed] = ACTIONS(2805),
    [anon_sym_unsigned] = ACTIONS(2805),
    [anon_sym_long] = ACTIONS(2805),
    [anon_sym_short] = ACTIONS(2805),
    [anon_sym_LBRACK] = ACTIONS(2805),
    [anon_sym_static] = ACTIONS(2805),
    [anon_sym_register] = ACTIONS(2805),
    [anon_sym_inline] = ACTIONS(2805),
    [anon_sym___inline] = ACTIONS(2805),
    [anon_sym___inline__] = ACTIONS(2805),
    [anon_sym___forceinline] = ACTIONS(2805),
    [anon_sym_thread_local] = ACTIONS(2805),
    [anon_sym___thread] = ACTIONS(2805),
    [anon_sym_const] = ACTIONS(2805),
    [anon_sym_constexpr] = ACTIONS(2805),
    [anon_sym_volatile] = ACTIONS(2805),
    [anon_sym_restrict] = ACTIONS(2805),
    [anon_sym___restrict__] = ACTIONS(2805),
    [anon_sym__Atomic] = ACTIONS(2805),
    [anon_sym__Noreturn] = ACTIONS(2805),
    [anon_sym_noreturn] = ACTIONS(2805),
    [anon_sym__Nonnull] = ACTIONS(2805),
    [anon_sym_mutable] = ACTIONS(2805),
    [anon_sym_constinit] = ACTIONS(2805),
    [anon_sym_consteval] = ACTIONS(2805),
    [anon_sym_alignas] = ACTIONS(2805),
    [anon_sym__Alignas] = ACTIONS(2805),
    [sym_primitive_type] = ACTIONS(2805),
    [anon_sym_enum] = ACTIONS(2805),
    [anon_sym_class] = ACTIONS(2805),
    [anon_sym_struct] = ACTIONS(2805),
    [anon_sym_union] = ACTIONS(2805),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2805),
    [anon_sym_decltype] = ACTIONS(2805),
    [anon_sym_explicit] = ACTIONS(2805),
    [anon_sym_typename] = ACTIONS(2805),
    [anon_sym_template] = ACTIONS(2805),
    [anon_sym_operator] = ACTIONS(2805),
    [anon_sym_friend] = ACTIONS(2805),
    [anon_sym_public] = ACTIONS(2805),
    [anon_sym_private] = ACTIONS(2805),
    [anon_sym_protected] = ACTIONS(2805),
    [anon_sym_using] = ACTIONS(2805),
    [anon_sym_static_assert] = ACTIONS(2805),
  },
  [2059] = {
    [sym_identifier] = ACTIONS(5349),
    [aux_sym_preproc_def_token1] = ACTIONS(5349),
    [aux_sym_preproc_if_token1] = ACTIONS(5349),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5349),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5349),
    [sym_preproc_directive] = ACTIONS(5349),
    [anon_sym_LPAREN2] = ACTIONS(5351),
    [anon_sym_TILDE] = ACTIONS(5351),
    [anon_sym_STAR] = ACTIONS(5351),
    [anon_sym_AMP_AMP] = ACTIONS(5351),
    [anon_sym_AMP] = ACTIONS(5349),
    [anon_sym_SEMI] = ACTIONS(5351),
    [anon_sym___extension__] = ACTIONS(5349),
    [anon_sym_typedef] = ACTIONS(5349),
    [anon_sym_virtual] = ACTIONS(5349),
    [anon_sym_extern] = ACTIONS(5349),
    [anon_sym___attribute__] = ACTIONS(5349),
    [anon_sym___attribute] = ACTIONS(5349),
    [anon_sym_COLON_COLON] = ACTIONS(5351),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5351),
    [anon_sym___declspec] = ACTIONS(5349),
    [anon_sym___based] = ACTIONS(5349),
    [anon_sym_RBRACE] = ACTIONS(5351),
    [anon_sym_signed] = ACTIONS(5349),
    [anon_sym_unsigned] = ACTIONS(5349),
    [anon_sym_long] = ACTIONS(5349),
    [anon_sym_short] = ACTIONS(5349),
    [anon_sym_LBRACK] = ACTIONS(5349),
    [anon_sym_static] = ACTIONS(5349),
    [anon_sym_register] = ACTIONS(5349),
    [anon_sym_inline] = ACTIONS(5349),
    [anon_sym___inline] = ACTIONS(5349),
    [anon_sym___inline__] = ACTIONS(5349),
    [anon_sym___forceinline] = ACTIONS(5349),
    [anon_sym_thread_local] = ACTIONS(5349),
    [anon_sym___thread] = ACTIONS(5349),
    [anon_sym_const] = ACTIONS(5349),
    [anon_sym_constexpr] = ACTIONS(5349),
    [anon_sym_volatile] = ACTIONS(5349),
    [anon_sym_restrict] = ACTIONS(5349),
    [anon_sym___restrict__] = ACTIONS(5349),
    [anon_sym__Atomic] = ACTIONS(5349),
    [anon_sym__Noreturn] = ACTIONS(5349),
    [anon_sym_noreturn] = ACTIONS(5349),
    [anon_sym__Nonnull] = ACTIONS(5349),
    [anon_sym_mutable] = ACTIONS(5349),
    [anon_sym_constinit] = ACTIONS(5349),
    [anon_sym_consteval] = ACTIONS(5349),
    [anon_sym_alignas] = ACTIONS(5349),
    [anon_sym__Alignas] = ACTIONS(5349),
    [sym_primitive_type] = ACTIONS(5349),
    [anon_sym_enum] = ACTIONS(5349),
    [anon_sym_class] = ACTIONS(5349),
    [anon_sym_struct] = ACTIONS(5349),
    [anon_sym_union] = ACTIONS(5349),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5349),
    [anon_sym_decltype] = ACTIONS(5349),
    [anon_sym_explicit] = ACTIONS(5349),
    [anon_sym_typename] = ACTIONS(5349),
    [anon_sym_template] = ACTIONS(5349),
    [anon_sym_operator] = ACTIONS(5349),
    [anon_sym_friend] = ACTIONS(5349),
    [anon_sym_public] = ACTIONS(5349),
    [anon_sym_private] = ACTIONS(5349),
    [anon_sym_protected] = ACTIONS(5349),
    [anon_sym_using] = ACTIONS(5349),
    [anon_sym_static_assert] = ACTIONS(5349),
  },
  [2060] = {
    [sym_identifier] = ACTIONS(5411),
    [aux_sym_preproc_def_token1] = ACTIONS(5411),
    [aux_sym_preproc_if_token1] = ACTIONS(5411),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5411),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5411),
    [sym_preproc_directive] = ACTIONS(5411),
    [anon_sym_LPAREN2] = ACTIONS(5413),
    [anon_sym_TILDE] = ACTIONS(5413),
    [anon_sym_STAR] = ACTIONS(5413),
    [anon_sym_AMP_AMP] = ACTIONS(5413),
    [anon_sym_AMP] = ACTIONS(5411),
    [anon_sym_SEMI] = ACTIONS(5413),
    [anon_sym___extension__] = ACTIONS(5411),
    [anon_sym_typedef] = ACTIONS(5411),
    [anon_sym_virtual] = ACTIONS(5411),
    [anon_sym_extern] = ACTIONS(5411),
    [anon_sym___attribute__] = ACTIONS(5411),
    [anon_sym___attribute] = ACTIONS(5411),
    [anon_sym_COLON_COLON] = ACTIONS(5413),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5413),
    [anon_sym___declspec] = ACTIONS(5411),
    [anon_sym___based] = ACTIONS(5411),
    [anon_sym_RBRACE] = ACTIONS(5413),
    [anon_sym_signed] = ACTIONS(5411),
    [anon_sym_unsigned] = ACTIONS(5411),
    [anon_sym_long] = ACTIONS(5411),
    [anon_sym_short] = ACTIONS(5411),
    [anon_sym_LBRACK] = ACTIONS(5411),
    [anon_sym_static] = ACTIONS(5411),
    [anon_sym_register] = ACTIONS(5411),
    [anon_sym_inline] = ACTIONS(5411),
    [anon_sym___inline] = ACTIONS(5411),
    [anon_sym___inline__] = ACTIONS(5411),
    [anon_sym___forceinline] = ACTIONS(5411),
    [anon_sym_thread_local] = ACTIONS(5411),
    [anon_sym___thread] = ACTIONS(5411),
    [anon_sym_const] = ACTIONS(5411),
    [anon_sym_constexpr] = ACTIONS(5411),
    [anon_sym_volatile] = ACTIONS(5411),
    [anon_sym_restrict] = ACTIONS(5411),
    [anon_sym___restrict__] = ACTIONS(5411),
    [anon_sym__Atomic] = ACTIONS(5411),
    [anon_sym__Noreturn] = ACTIONS(5411),
    [anon_sym_noreturn] = ACTIONS(5411),
    [anon_sym__Nonnull] = ACTIONS(5411),
    [anon_sym_mutable] = ACTIONS(5411),
    [anon_sym_constinit] = ACTIONS(5411),
    [anon_sym_consteval] = ACTIONS(5411),
    [anon_sym_alignas] = ACTIONS(5411),
    [anon_sym__Alignas] = ACTIONS(5411),
    [sym_primitive_type] = ACTIONS(5411),
    [anon_sym_enum] = ACTIONS(5411),
    [anon_sym_class] = ACTIONS(5411),
    [anon_sym_struct] = ACTIONS(5411),
    [anon_sym_union] = ACTIONS(5411),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5411),
    [anon_sym_decltype] = ACTIONS(5411),
    [anon_sym_explicit] = ACTIONS(5411),
    [anon_sym_typename] = ACTIONS(5411),
    [anon_sym_template] = ACTIONS(5411),
    [anon_sym_operator] = ACTIONS(5411),
    [anon_sym_friend] = ACTIONS(5411),
    [anon_sym_public] = ACTIONS(5411),
    [anon_sym_private] = ACTIONS(5411),
    [anon_sym_protected] = ACTIONS(5411),
    [anon_sym_using] = ACTIONS(5411),
    [anon_sym_static_assert] = ACTIONS(5411),
  },
  [2061] = {
    [sym_identifier] = ACTIONS(2609),
    [aux_sym_preproc_def_token1] = ACTIONS(2609),
    [aux_sym_preproc_if_token1] = ACTIONS(2609),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2609),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2609),
    [sym_preproc_directive] = ACTIONS(2609),
    [anon_sym_LPAREN2] = ACTIONS(2611),
    [anon_sym_TILDE] = ACTIONS(2611),
    [anon_sym_STAR] = ACTIONS(2611),
    [anon_sym_AMP_AMP] = ACTIONS(2611),
    [anon_sym_AMP] = ACTIONS(2609),
    [anon_sym_SEMI] = ACTIONS(2611),
    [anon_sym___extension__] = ACTIONS(2609),
    [anon_sym_typedef] = ACTIONS(2609),
    [anon_sym_virtual] = ACTIONS(2609),
    [anon_sym_extern] = ACTIONS(2609),
    [anon_sym___attribute__] = ACTIONS(2609),
    [anon_sym___attribute] = ACTIONS(2609),
    [anon_sym_COLON_COLON] = ACTIONS(2611),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2611),
    [anon_sym___declspec] = ACTIONS(2609),
    [anon_sym___based] = ACTIONS(2609),
    [anon_sym_RBRACE] = ACTIONS(2611),
    [anon_sym_signed] = ACTIONS(2609),
    [anon_sym_unsigned] = ACTIONS(2609),
    [anon_sym_long] = ACTIONS(2609),
    [anon_sym_short] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(2609),
    [anon_sym_static] = ACTIONS(2609),
    [anon_sym_register] = ACTIONS(2609),
    [anon_sym_inline] = ACTIONS(2609),
    [anon_sym___inline] = ACTIONS(2609),
    [anon_sym___inline__] = ACTIONS(2609),
    [anon_sym___forceinline] = ACTIONS(2609),
    [anon_sym_thread_local] = ACTIONS(2609),
    [anon_sym___thread] = ACTIONS(2609),
    [anon_sym_const] = ACTIONS(2609),
    [anon_sym_constexpr] = ACTIONS(2609),
    [anon_sym_volatile] = ACTIONS(2609),
    [anon_sym_restrict] = ACTIONS(2609),
    [anon_sym___restrict__] = ACTIONS(2609),
    [anon_sym__Atomic] = ACTIONS(2609),
    [anon_sym__Noreturn] = ACTIONS(2609),
    [anon_sym_noreturn] = ACTIONS(2609),
    [anon_sym__Nonnull] = ACTIONS(2609),
    [anon_sym_mutable] = ACTIONS(2609),
    [anon_sym_constinit] = ACTIONS(2609),
    [anon_sym_consteval] = ACTIONS(2609),
    [anon_sym_alignas] = ACTIONS(2609),
    [anon_sym__Alignas] = ACTIONS(2609),
    [sym_primitive_type] = ACTIONS(2609),
    [anon_sym_enum] = ACTIONS(2609),
    [anon_sym_class] = ACTIONS(2609),
    [anon_sym_struct] = ACTIONS(2609),
    [anon_sym_union] = ACTIONS(2609),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2609),
    [anon_sym_decltype] = ACTIONS(2609),
    [anon_sym_explicit] = ACTIONS(2609),
    [anon_sym_typename] = ACTIONS(2609),
    [anon_sym_template] = ACTIONS(2609),
    [anon_sym_operator] = ACTIONS(2609),
    [anon_sym_friend] = ACTIONS(2609),
    [anon_sym_public] = ACTIONS(2609),
    [anon_sym_private] = ACTIONS(2609),
    [anon_sym_protected] = ACTIONS(2609),
    [anon_sym_using] = ACTIONS(2609),
    [anon_sym_static_assert] = ACTIONS(2609),
  },
  [2062] = {
    [sym_identifier] = ACTIONS(5415),
    [aux_sym_preproc_def_token1] = ACTIONS(5415),
    [aux_sym_preproc_if_token1] = ACTIONS(5415),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5415),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5415),
    [sym_preproc_directive] = ACTIONS(5415),
    [anon_sym_LPAREN2] = ACTIONS(5417),
    [anon_sym_TILDE] = ACTIONS(5417),
    [anon_sym_STAR] = ACTIONS(5417),
    [anon_sym_AMP_AMP] = ACTIONS(5417),
    [anon_sym_AMP] = ACTIONS(5415),
    [anon_sym_SEMI] = ACTIONS(5417),
    [anon_sym___extension__] = ACTIONS(5415),
    [anon_sym_typedef] = ACTIONS(5415),
    [anon_sym_virtual] = ACTIONS(5415),
    [anon_sym_extern] = ACTIONS(5415),
    [anon_sym___attribute__] = ACTIONS(5415),
    [anon_sym___attribute] = ACTIONS(5415),
    [anon_sym_COLON_COLON] = ACTIONS(5417),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5417),
    [anon_sym___declspec] = ACTIONS(5415),
    [anon_sym___based] = ACTIONS(5415),
    [anon_sym_RBRACE] = ACTIONS(5417),
    [anon_sym_signed] = ACTIONS(5415),
    [anon_sym_unsigned] = ACTIONS(5415),
    [anon_sym_long] = ACTIONS(5415),
    [anon_sym_short] = ACTIONS(5415),
    [anon_sym_LBRACK] = ACTIONS(5415),
    [anon_sym_static] = ACTIONS(5415),
    [anon_sym_register] = ACTIONS(5415),
    [anon_sym_inline] = ACTIONS(5415),
    [anon_sym___inline] = ACTIONS(5415),
    [anon_sym___inline__] = ACTIONS(5415),
    [anon_sym___forceinline] = ACTIONS(5415),
    [anon_sym_thread_local] = ACTIONS(5415),
    [anon_sym___thread] = ACTIONS(5415),
    [anon_sym_const] = ACTIONS(5415),
    [anon_sym_constexpr] = ACTIONS(5415),
    [anon_sym_volatile] = ACTIONS(5415),
    [anon_sym_restrict] = ACTIONS(5415),
    [anon_sym___restrict__] = ACTIONS(5415),
    [anon_sym__Atomic] = ACTIONS(5415),
    [anon_sym__Noreturn] = ACTIONS(5415),
    [anon_sym_noreturn] = ACTIONS(5415),
    [anon_sym__Nonnull] = ACTIONS(5415),
    [anon_sym_mutable] = ACTIONS(5415),
    [anon_sym_constinit] = ACTIONS(5415),
    [anon_sym_consteval] = ACTIONS(5415),
    [anon_sym_alignas] = ACTIONS(5415),
    [anon_sym__Alignas] = ACTIONS(5415),
    [sym_primitive_type] = ACTIONS(5415),
    [anon_sym_enum] = ACTIONS(5415),
    [anon_sym_class] = ACTIONS(5415),
    [anon_sym_struct] = ACTIONS(5415),
    [anon_sym_union] = ACTIONS(5415),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5415),
    [anon_sym_decltype] = ACTIONS(5415),
    [anon_sym_explicit] = ACTIONS(5415),
    [anon_sym_typename] = ACTIONS(5415),
    [anon_sym_template] = ACTIONS(5415),
    [anon_sym_operator] = ACTIONS(5415),
    [anon_sym_friend] = ACTIONS(5415),
    [anon_sym_public] = ACTIONS(5415),
    [anon_sym_private] = ACTIONS(5415),
    [anon_sym_protected] = ACTIONS(5415),
    [anon_sym_using] = ACTIONS(5415),
    [anon_sym_static_assert] = ACTIONS(5415),
  },
  [2063] = {
    [sym_identifier] = ACTIONS(2609),
    [aux_sym_preproc_def_token1] = ACTIONS(2609),
    [aux_sym_preproc_if_token1] = ACTIONS(2609),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2609),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2609),
    [sym_preproc_directive] = ACTIONS(2609),
    [anon_sym_LPAREN2] = ACTIONS(2611),
    [anon_sym_TILDE] = ACTIONS(2611),
    [anon_sym_STAR] = ACTIONS(2611),
    [anon_sym_AMP_AMP] = ACTIONS(2611),
    [anon_sym_AMP] = ACTIONS(2609),
    [anon_sym_SEMI] = ACTIONS(2611),
    [anon_sym___extension__] = ACTIONS(2609),
    [anon_sym_typedef] = ACTIONS(2609),
    [anon_sym_virtual] = ACTIONS(2609),
    [anon_sym_extern] = ACTIONS(2609),
    [anon_sym___attribute__] = ACTIONS(2609),
    [anon_sym___attribute] = ACTIONS(2609),
    [anon_sym_COLON_COLON] = ACTIONS(2611),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2611),
    [anon_sym___declspec] = ACTIONS(2609),
    [anon_sym___based] = ACTIONS(2609),
    [anon_sym_RBRACE] = ACTIONS(2611),
    [anon_sym_signed] = ACTIONS(2609),
    [anon_sym_unsigned] = ACTIONS(2609),
    [anon_sym_long] = ACTIONS(2609),
    [anon_sym_short] = ACTIONS(2609),
    [anon_sym_LBRACK] = ACTIONS(2609),
    [anon_sym_static] = ACTIONS(2609),
    [anon_sym_register] = ACTIONS(2609),
    [anon_sym_inline] = ACTIONS(2609),
    [anon_sym___inline] = ACTIONS(2609),
    [anon_sym___inline__] = ACTIONS(2609),
    [anon_sym___forceinline] = ACTIONS(2609),
    [anon_sym_thread_local] = ACTIONS(2609),
    [anon_sym___thread] = ACTIONS(2609),
    [anon_sym_const] = ACTIONS(2609),
    [anon_sym_constexpr] = ACTIONS(2609),
    [anon_sym_volatile] = ACTIONS(2609),
    [anon_sym_restrict] = ACTIONS(2609),
    [anon_sym___restrict__] = ACTIONS(2609),
    [anon_sym__Atomic] = ACTIONS(2609),
    [anon_sym__Noreturn] = ACTIONS(2609),
    [anon_sym_noreturn] = ACTIONS(2609),
    [anon_sym__Nonnull] = ACTIONS(2609),
    [anon_sym_mutable] = ACTIONS(2609),
    [anon_sym_constinit] = ACTIONS(2609),
    [anon_sym_consteval] = ACTIONS(2609),
    [anon_sym_alignas] = ACTIONS(2609),
    [anon_sym__Alignas] = ACTIONS(2609),
    [sym_primitive_type] = ACTIONS(2609),
    [anon_sym_enum] = ACTIONS(2609),
    [anon_sym_class] = ACTIONS(2609),
    [anon_sym_struct] = ACTIONS(2609),
    [anon_sym_union] = ACTIONS(2609),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2609),
    [anon_sym_decltype] = ACTIONS(2609),
    [anon_sym_explicit] = ACTIONS(2609),
    [anon_sym_typename] = ACTIONS(2609),
    [anon_sym_template] = ACTIONS(2609),
    [anon_sym_operator] = ACTIONS(2609),
    [anon_sym_friend] = ACTIONS(2609),
    [anon_sym_public] = ACTIONS(2609),
    [anon_sym_private] = ACTIONS(2609),
    [anon_sym_protected] = ACTIONS(2609),
    [anon_sym_using] = ACTIONS(2609),
    [anon_sym_static_assert] = ACTIONS(2609),
  },
  [2064] = {
    [sym_identifier] = ACTIONS(2809),
    [aux_sym_preproc_def_token1] = ACTIONS(2809),
    [aux_sym_preproc_if_token1] = ACTIONS(2809),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2809),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2809),
    [sym_preproc_directive] = ACTIONS(2809),
    [anon_sym_LPAREN2] = ACTIONS(2811),
    [anon_sym_TILDE] = ACTIONS(2811),
    [anon_sym_STAR] = ACTIONS(2811),
    [anon_sym_AMP_AMP] = ACTIONS(2811),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2811),
    [anon_sym___extension__] = ACTIONS(2809),
    [anon_sym_typedef] = ACTIONS(2809),
    [anon_sym_virtual] = ACTIONS(2809),
    [anon_sym_extern] = ACTIONS(2809),
    [anon_sym___attribute__] = ACTIONS(2809),
    [anon_sym___attribute] = ACTIONS(2809),
    [anon_sym_COLON_COLON] = ACTIONS(2811),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2811),
    [anon_sym___declspec] = ACTIONS(2809),
    [anon_sym___based] = ACTIONS(2809),
    [anon_sym_RBRACE] = ACTIONS(2811),
    [anon_sym_signed] = ACTIONS(2809),
    [anon_sym_unsigned] = ACTIONS(2809),
    [anon_sym_long] = ACTIONS(2809),
    [anon_sym_short] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2809),
    [anon_sym_static] = ACTIONS(2809),
    [anon_sym_register] = ACTIONS(2809),
    [anon_sym_inline] = ACTIONS(2809),
    [anon_sym___inline] = ACTIONS(2809),
    [anon_sym___inline__] = ACTIONS(2809),
    [anon_sym___forceinline] = ACTIONS(2809),
    [anon_sym_thread_local] = ACTIONS(2809),
    [anon_sym___thread] = ACTIONS(2809),
    [anon_sym_const] = ACTIONS(2809),
    [anon_sym_constexpr] = ACTIONS(2809),
    [anon_sym_volatile] = ACTIONS(2809),
    [anon_sym_restrict] = ACTIONS(2809),
    [anon_sym___restrict__] = ACTIONS(2809),
    [anon_sym__Atomic] = ACTIONS(2809),
    [anon_sym__Noreturn] = ACTIONS(2809),
    [anon_sym_noreturn] = ACTIONS(2809),
    [anon_sym__Nonnull] = ACTIONS(2809),
    [anon_sym_mutable] = ACTIONS(2809),
    [anon_sym_constinit] = ACTIONS(2809),
    [anon_sym_consteval] = ACTIONS(2809),
    [anon_sym_alignas] = ACTIONS(2809),
    [anon_sym__Alignas] = ACTIONS(2809),
    [sym_primitive_type] = ACTIONS(2809),
    [anon_sym_enum] = ACTIONS(2809),
    [anon_sym_class] = ACTIONS(2809),
    [anon_sym_struct] = ACTIONS(2809),
    [anon_sym_union] = ACTIONS(2809),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2809),
    [anon_sym_decltype] = ACTIONS(2809),
    [anon_sym_explicit] = ACTIONS(2809),
    [anon_sym_typename] = ACTIONS(2809),
    [anon_sym_template] = ACTIONS(2809),
    [anon_sym_operator] = ACTIONS(2809),
    [anon_sym_friend] = ACTIONS(2809),
    [anon_sym_public] = ACTIONS(2809),
    [anon_sym_private] = ACTIONS(2809),
    [anon_sym_protected] = ACTIONS(2809),
    [anon_sym_using] = ACTIONS(2809),
    [anon_sym_static_assert] = ACTIONS(2809),
  },
  [2065] = {
    [sym_identifier] = ACTIONS(5419),
    [aux_sym_preproc_def_token1] = ACTIONS(5419),
    [aux_sym_preproc_if_token1] = ACTIONS(5419),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5419),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5419),
    [sym_preproc_directive] = ACTIONS(5419),
    [anon_sym_LPAREN2] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5421),
    [anon_sym_STAR] = ACTIONS(5421),
    [anon_sym_AMP_AMP] = ACTIONS(5421),
    [anon_sym_AMP] = ACTIONS(5419),
    [anon_sym_SEMI] = ACTIONS(5421),
    [anon_sym___extension__] = ACTIONS(5419),
    [anon_sym_typedef] = ACTIONS(5419),
    [anon_sym_virtual] = ACTIONS(5419),
    [anon_sym_extern] = ACTIONS(5419),
    [anon_sym___attribute__] = ACTIONS(5419),
    [anon_sym___attribute] = ACTIONS(5419),
    [anon_sym_COLON_COLON] = ACTIONS(5421),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5421),
    [anon_sym___declspec] = ACTIONS(5419),
    [anon_sym___based] = ACTIONS(5419),
    [anon_sym_RBRACE] = ACTIONS(5421),
    [anon_sym_signed] = ACTIONS(5419),
    [anon_sym_unsigned] = ACTIONS(5419),
    [anon_sym_long] = ACTIONS(5419),
    [anon_sym_short] = ACTIONS(5419),
    [anon_sym_LBRACK] = ACTIONS(5419),
    [anon_sym_static] = ACTIONS(5419),
    [anon_sym_register] = ACTIONS(5419),
    [anon_sym_inline] = ACTIONS(5419),
    [anon_sym___inline] = ACTIONS(5419),
    [anon_sym___inline__] = ACTIONS(5419),
    [anon_sym___forceinline] = ACTIONS(5419),
    [anon_sym_thread_local] = ACTIONS(5419),
    [anon_sym___thread] = ACTIONS(5419),
    [anon_sym_const] = ACTIONS(5419),
    [anon_sym_constexpr] = ACTIONS(5419),
    [anon_sym_volatile] = ACTIONS(5419),
    [anon_sym_restrict] = ACTIONS(5419),
    [anon_sym___restrict__] = ACTIONS(5419),
    [anon_sym__Atomic] = ACTIONS(5419),
    [anon_sym__Noreturn] = ACTIONS(5419),
    [anon_sym_noreturn] = ACTIONS(5419),
    [anon_sym__Nonnull] = ACTIONS(5419),
    [anon_sym_mutable] = ACTIONS(5419),
    [anon_sym_constinit] = ACTIONS(5419),
    [anon_sym_consteval] = ACTIONS(5419),
    [anon_sym_alignas] = ACTIONS(5419),
    [anon_sym__Alignas] = ACTIONS(5419),
    [sym_primitive_type] = ACTIONS(5419),
    [anon_sym_enum] = ACTIONS(5419),
    [anon_sym_class] = ACTIONS(5419),
    [anon_sym_struct] = ACTIONS(5419),
    [anon_sym_union] = ACTIONS(5419),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5419),
    [anon_sym_decltype] = ACTIONS(5419),
    [anon_sym_explicit] = ACTIONS(5419),
    [anon_sym_typename] = ACTIONS(5419),
    [anon_sym_template] = ACTIONS(5419),
    [anon_sym_operator] = ACTIONS(5419),
    [anon_sym_friend] = ACTIONS(5419),
    [anon_sym_public] = ACTIONS(5419),
    [anon_sym_private] = ACTIONS(5419),
    [anon_sym_protected] = ACTIONS(5419),
    [anon_sym_using] = ACTIONS(5419),
    [anon_sym_static_assert] = ACTIONS(5419),
  },
  [2066] = {
    [sym_identifier] = ACTIONS(5427),
    [aux_sym_preproc_def_token1] = ACTIONS(5427),
    [aux_sym_preproc_if_token1] = ACTIONS(5427),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5427),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5427),
    [sym_preproc_directive] = ACTIONS(5427),
    [anon_sym_LPAREN2] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(5429),
    [anon_sym_STAR] = ACTIONS(5429),
    [anon_sym_AMP_AMP] = ACTIONS(5429),
    [anon_sym_AMP] = ACTIONS(5427),
    [anon_sym_SEMI] = ACTIONS(5429),
    [anon_sym___extension__] = ACTIONS(5427),
    [anon_sym_typedef] = ACTIONS(5427),
    [anon_sym_virtual] = ACTIONS(5427),
    [anon_sym_extern] = ACTIONS(5427),
    [anon_sym___attribute__] = ACTIONS(5427),
    [anon_sym___attribute] = ACTIONS(5427),
    [anon_sym_COLON_COLON] = ACTIONS(5429),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5429),
    [anon_sym___declspec] = ACTIONS(5427),
    [anon_sym___based] = ACTIONS(5427),
    [anon_sym_RBRACE] = ACTIONS(5429),
    [anon_sym_signed] = ACTIONS(5427),
    [anon_sym_unsigned] = ACTIONS(5427),
    [anon_sym_long] = ACTIONS(5427),
    [anon_sym_short] = ACTIONS(5427),
    [anon_sym_LBRACK] = ACTIONS(5427),
    [anon_sym_static] = ACTIONS(5427),
    [anon_sym_register] = ACTIONS(5427),
    [anon_sym_inline] = ACTIONS(5427),
    [anon_sym___inline] = ACTIONS(5427),
    [anon_sym___inline__] = ACTIONS(5427),
    [anon_sym___forceinline] = ACTIONS(5427),
    [anon_sym_thread_local] = ACTIONS(5427),
    [anon_sym___thread] = ACTIONS(5427),
    [anon_sym_const] = ACTIONS(5427),
    [anon_sym_constexpr] = ACTIONS(5427),
    [anon_sym_volatile] = ACTIONS(5427),
    [anon_sym_restrict] = ACTIONS(5427),
    [anon_sym___restrict__] = ACTIONS(5427),
    [anon_sym__Atomic] = ACTIONS(5427),
    [anon_sym__Noreturn] = ACTIONS(5427),
    [anon_sym_noreturn] = ACTIONS(5427),
    [anon_sym__Nonnull] = ACTIONS(5427),
    [anon_sym_mutable] = ACTIONS(5427),
    [anon_sym_constinit] = ACTIONS(5427),
    [anon_sym_consteval] = ACTIONS(5427),
    [anon_sym_alignas] = ACTIONS(5427),
    [anon_sym__Alignas] = ACTIONS(5427),
    [sym_primitive_type] = ACTIONS(5427),
    [anon_sym_enum] = ACTIONS(5427),
    [anon_sym_class] = ACTIONS(5427),
    [anon_sym_struct] = ACTIONS(5427),
    [anon_sym_union] = ACTIONS(5427),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5427),
    [anon_sym_decltype] = ACTIONS(5427),
    [anon_sym_explicit] = ACTIONS(5427),
    [anon_sym_typename] = ACTIONS(5427),
    [anon_sym_template] = ACTIONS(5427),
    [anon_sym_operator] = ACTIONS(5427),
    [anon_sym_friend] = ACTIONS(5427),
    [anon_sym_public] = ACTIONS(5427),
    [anon_sym_private] = ACTIONS(5427),
    [anon_sym_protected] = ACTIONS(5427),
    [anon_sym_using] = ACTIONS(5427),
    [anon_sym_static_assert] = ACTIONS(5427),
  },
  [2067] = {
    [sym_identifier] = ACTIONS(5427),
    [aux_sym_preproc_def_token1] = ACTIONS(5427),
    [aux_sym_preproc_if_token1] = ACTIONS(5427),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5427),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5427),
    [sym_preproc_directive] = ACTIONS(5427),
    [anon_sym_LPAREN2] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(5429),
    [anon_sym_STAR] = ACTIONS(5429),
    [anon_sym_AMP_AMP] = ACTIONS(5429),
    [anon_sym_AMP] = ACTIONS(5427),
    [anon_sym_SEMI] = ACTIONS(5429),
    [anon_sym___extension__] = ACTIONS(5427),
    [anon_sym_typedef] = ACTIONS(5427),
    [anon_sym_virtual] = ACTIONS(5427),
    [anon_sym_extern] = ACTIONS(5427),
    [anon_sym___attribute__] = ACTIONS(5427),
    [anon_sym___attribute] = ACTIONS(5427),
    [anon_sym_COLON_COLON] = ACTIONS(5429),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5429),
    [anon_sym___declspec] = ACTIONS(5427),
    [anon_sym___based] = ACTIONS(5427),
    [anon_sym_RBRACE] = ACTIONS(5429),
    [anon_sym_signed] = ACTIONS(5427),
    [anon_sym_unsigned] = ACTIONS(5427),
    [anon_sym_long] = ACTIONS(5427),
    [anon_sym_short] = ACTIONS(5427),
    [anon_sym_LBRACK] = ACTIONS(5427),
    [anon_sym_static] = ACTIONS(5427),
    [anon_sym_register] = ACTIONS(5427),
    [anon_sym_inline] = ACTIONS(5427),
    [anon_sym___inline] = ACTIONS(5427),
    [anon_sym___inline__] = ACTIONS(5427),
    [anon_sym___forceinline] = ACTIONS(5427),
    [anon_sym_thread_local] = ACTIONS(5427),
    [anon_sym___thread] = ACTIONS(5427),
    [anon_sym_const] = ACTIONS(5427),
    [anon_sym_constexpr] = ACTIONS(5427),
    [anon_sym_volatile] = ACTIONS(5427),
    [anon_sym_restrict] = ACTIONS(5427),
    [anon_sym___restrict__] = ACTIONS(5427),
    [anon_sym__Atomic] = ACTIONS(5427),
    [anon_sym__Noreturn] = ACTIONS(5427),
    [anon_sym_noreturn] = ACTIONS(5427),
    [anon_sym__Nonnull] = ACTIONS(5427),
    [anon_sym_mutable] = ACTIONS(5427),
    [anon_sym_constinit] = ACTIONS(5427),
    [anon_sym_consteval] = ACTIONS(5427),
    [anon_sym_alignas] = ACTIONS(5427),
    [anon_sym__Alignas] = ACTIONS(5427),
    [sym_primitive_type] = ACTIONS(5427),
    [anon_sym_enum] = ACTIONS(5427),
    [anon_sym_class] = ACTIONS(5427),
    [anon_sym_struct] = ACTIONS(5427),
    [anon_sym_union] = ACTIONS(5427),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5427),
    [anon_sym_decltype] = ACTIONS(5427),
    [anon_sym_explicit] = ACTIONS(5427),
    [anon_sym_typename] = ACTIONS(5427),
    [anon_sym_template] = ACTIONS(5427),
    [anon_sym_operator] = ACTIONS(5427),
    [anon_sym_friend] = ACTIONS(5427),
    [anon_sym_public] = ACTIONS(5427),
    [anon_sym_private] = ACTIONS(5427),
    [anon_sym_protected] = ACTIONS(5427),
    [anon_sym_using] = ACTIONS(5427),
    [anon_sym_static_assert] = ACTIONS(5427),
  },
  [2068] = {
    [sym_identifier] = ACTIONS(5427),
    [aux_sym_preproc_def_token1] = ACTIONS(5427),
    [aux_sym_preproc_if_token1] = ACTIONS(5427),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5427),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5427),
    [sym_preproc_directive] = ACTIONS(5427),
    [anon_sym_LPAREN2] = ACTIONS(5429),
    [anon_sym_TILDE] = ACTIONS(5429),
    [anon_sym_STAR] = ACTIONS(5429),
    [anon_sym_AMP_AMP] = ACTIONS(5429),
    [anon_sym_AMP] = ACTIONS(5427),
    [anon_sym_SEMI] = ACTIONS(5429),
    [anon_sym___extension__] = ACTIONS(5427),
    [anon_sym_typedef] = ACTIONS(5427),
    [anon_sym_virtual] = ACTIONS(5427),
    [anon_sym_extern] = ACTIONS(5427),
    [anon_sym___attribute__] = ACTIONS(5427),
    [anon_sym___attribute] = ACTIONS(5427),
    [anon_sym_COLON_COLON] = ACTIONS(5429),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5429),
    [anon_sym___declspec] = ACTIONS(5427),
    [anon_sym___based] = ACTIONS(5427),
    [anon_sym_RBRACE] = ACTIONS(5429),
    [anon_sym_signed] = ACTIONS(5427),
    [anon_sym_unsigned] = ACTIONS(5427),
    [anon_sym_long] = ACTIONS(5427),
    [anon_sym_short] = ACTIONS(5427),
    [anon_sym_LBRACK] = ACTIONS(5427),
    [anon_sym_static] = ACTIONS(5427),
    [anon_sym_register] = ACTIONS(5427),
    [anon_sym_inline] = ACTIONS(5427),
    [anon_sym___inline] = ACTIONS(5427),
    [anon_sym___inline__] = ACTIONS(5427),
    [anon_sym___forceinline] = ACTIONS(5427),
    [anon_sym_thread_local] = ACTIONS(5427),
    [anon_sym___thread] = ACTIONS(5427),
    [anon_sym_const] = ACTIONS(5427),
    [anon_sym_constexpr] = ACTIONS(5427),
    [anon_sym_volatile] = ACTIONS(5427),
    [anon_sym_restrict] = ACTIONS(5427),
    [anon_sym___restrict__] = ACTIONS(5427),
    [anon_sym__Atomic] = ACTIONS(5427),
    [anon_sym__Noreturn] = ACTIONS(5427),
    [anon_sym_noreturn] = ACTIONS(5427),
    [anon_sym__Nonnull] = ACTIONS(5427),
    [anon_sym_mutable] = ACTIONS(5427),
    [anon_sym_constinit] = ACTIONS(5427),
    [anon_sym_consteval] = ACTIONS(5427),
    [anon_sym_alignas] = ACTIONS(5427),
    [anon_sym__Alignas] = ACTIONS(5427),
    [sym_primitive_type] = ACTIONS(5427),
    [anon_sym_enum] = ACTIONS(5427),
    [anon_sym_class] = ACTIONS(5427),
    [anon_sym_struct] = ACTIONS(5427),
    [anon_sym_union] = ACTIONS(5427),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5427),
    [anon_sym_decltype] = ACTIONS(5427),
    [anon_sym_explicit] = ACTIONS(5427),
    [anon_sym_typename] = ACTIONS(5427),
    [anon_sym_template] = ACTIONS(5427),
    [anon_sym_operator] = ACTIONS(5427),
    [anon_sym_friend] = ACTIONS(5427),
    [anon_sym_public] = ACTIONS(5427),
    [anon_sym_private] = ACTIONS(5427),
    [anon_sym_protected] = ACTIONS(5427),
    [anon_sym_using] = ACTIONS(5427),
    [anon_sym_static_assert] = ACTIONS(5427),
  },
  [2069] = {
    [sym_identifier] = ACTIONS(5419),
    [aux_sym_preproc_def_token1] = ACTIONS(5419),
    [aux_sym_preproc_if_token1] = ACTIONS(5419),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5419),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5419),
    [sym_preproc_directive] = ACTIONS(5419),
    [anon_sym_LPAREN2] = ACTIONS(5421),
    [anon_sym_TILDE] = ACTIONS(5421),
    [anon_sym_STAR] = ACTIONS(5421),
    [anon_sym_AMP_AMP] = ACTIONS(5421),
    [anon_sym_AMP] = ACTIONS(5419),
    [anon_sym_SEMI] = ACTIONS(5421),
    [anon_sym___extension__] = ACTIONS(5419),
    [anon_sym_typedef] = ACTIONS(5419),
    [anon_sym_virtual] = ACTIONS(5419),
    [anon_sym_extern] = ACTIONS(5419),
    [anon_sym___attribute__] = ACTIONS(5419),
    [anon_sym___attribute] = ACTIONS(5419),
    [anon_sym_COLON_COLON] = ACTIONS(5421),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5421),
    [anon_sym___declspec] = ACTIONS(5419),
    [anon_sym___based] = ACTIONS(5419),
    [anon_sym_RBRACE] = ACTIONS(5421),
    [anon_sym_signed] = ACTIONS(5419),
    [anon_sym_unsigned] = ACTIONS(5419),
    [anon_sym_long] = ACTIONS(5419),
    [anon_sym_short] = ACTIONS(5419),
    [anon_sym_LBRACK] = ACTIONS(5419),
    [anon_sym_static] = ACTIONS(5419),
    [anon_sym_register] = ACTIONS(5419),
    [anon_sym_inline] = ACTIONS(5419),
    [anon_sym___inline] = ACTIONS(5419),
    [anon_sym___inline__] = ACTIONS(5419),
    [anon_sym___forceinline] = ACTIONS(5419),
    [anon_sym_thread_local] = ACTIONS(5419),
    [anon_sym___thread] = ACTIONS(5419),
    [anon_sym_const] = ACTIONS(5419),
    [anon_sym_constexpr] = ACTIONS(5419),
    [anon_sym_volatile] = ACTIONS(5419),
    [anon_sym_restrict] = ACTIONS(5419),
    [anon_sym___restrict__] = ACTIONS(5419),
    [anon_sym__Atomic] = ACTIONS(5419),
    [anon_sym__Noreturn] = ACTIONS(5419),
    [anon_sym_noreturn] = ACTIONS(5419),
    [anon_sym__Nonnull] = ACTIONS(5419),
    [anon_sym_mutable] = ACTIONS(5419),
    [anon_sym_constinit] = ACTIONS(5419),
    [anon_sym_consteval] = ACTIONS(5419),
    [anon_sym_alignas] = ACTIONS(5419),
    [anon_sym__Alignas] = ACTIONS(5419),
    [sym_primitive_type] = ACTIONS(5419),
    [anon_sym_enum] = ACTIONS(5419),
    [anon_sym_class] = ACTIONS(5419),
    [anon_sym_struct] = ACTIONS(5419),
    [anon_sym_union] = ACTIONS(5419),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5419),
    [anon_sym_decltype] = ACTIONS(5419),
    [anon_sym_explicit] = ACTIONS(5419),
    [anon_sym_typename] = ACTIONS(5419),
    [anon_sym_template] = ACTIONS(5419),
    [anon_sym_operator] = ACTIONS(5419),
    [anon_sym_friend] = ACTIONS(5419),
    [anon_sym_public] = ACTIONS(5419),
    [anon_sym_private] = ACTIONS(5419),
    [anon_sym_protected] = ACTIONS(5419),
    [anon_sym_using] = ACTIONS(5419),
    [anon_sym_static_assert] = ACTIONS(5419),
  },
  [2070] = {
    [sym_identifier] = ACTIONS(2822),
    [aux_sym_preproc_def_token1] = ACTIONS(2822),
    [aux_sym_preproc_if_token1] = ACTIONS(2822),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2822),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2822),
    [sym_preproc_directive] = ACTIONS(2822),
    [anon_sym_LPAREN2] = ACTIONS(2824),
    [anon_sym_TILDE] = ACTIONS(2824),
    [anon_sym_STAR] = ACTIONS(2824),
    [anon_sym_AMP_AMP] = ACTIONS(2824),
    [anon_sym_AMP] = ACTIONS(2822),
    [anon_sym_SEMI] = ACTIONS(2824),
    [anon_sym___extension__] = ACTIONS(2822),
    [anon_sym_typedef] = ACTIONS(2822),
    [anon_sym_virtual] = ACTIONS(2822),
    [anon_sym_extern] = ACTIONS(2822),
    [anon_sym___attribute__] = ACTIONS(2822),
    [anon_sym___attribute] = ACTIONS(2822),
    [anon_sym_COLON_COLON] = ACTIONS(2824),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2824),
    [anon_sym___declspec] = ACTIONS(2822),
    [anon_sym___based] = ACTIONS(2822),
    [anon_sym_RBRACE] = ACTIONS(2824),
    [anon_sym_signed] = ACTIONS(2822),
    [anon_sym_unsigned] = ACTIONS(2822),
    [anon_sym_long] = ACTIONS(2822),
    [anon_sym_short] = ACTIONS(2822),
    [anon_sym_LBRACK] = ACTIONS(2822),
    [anon_sym_static] = ACTIONS(2822),
    [anon_sym_register] = ACTIONS(2822),
    [anon_sym_inline] = ACTIONS(2822),
    [anon_sym___inline] = ACTIONS(2822),
    [anon_sym___inline__] = ACTIONS(2822),
    [anon_sym___forceinline] = ACTIONS(2822),
    [anon_sym_thread_local] = ACTIONS(2822),
    [anon_sym___thread] = ACTIONS(2822),
    [anon_sym_const] = ACTIONS(2822),
    [anon_sym_constexpr] = ACTIONS(2822),
    [anon_sym_volatile] = ACTIONS(2822),
    [anon_sym_restrict] = ACTIONS(2822),
    [anon_sym___restrict__] = ACTIONS(2822),
    [anon_sym__Atomic] = ACTIONS(2822),
    [anon_sym__Noreturn] = ACTIONS(2822),
    [anon_sym_noreturn] = ACTIONS(2822),
    [anon_sym__Nonnull] = ACTIONS(2822),
    [anon_sym_mutable] = ACTIONS(2822),
    [anon_sym_constinit] = ACTIONS(2822),
    [anon_sym_consteval] = ACTIONS(2822),
    [anon_sym_alignas] = ACTIONS(2822),
    [anon_sym__Alignas] = ACTIONS(2822),
    [sym_primitive_type] = ACTIONS(2822),
    [anon_sym_enum] = ACTIONS(2822),
    [anon_sym_class] = ACTIONS(2822),
    [anon_sym_struct] = ACTIONS(2822),
    [anon_sym_union] = ACTIONS(2822),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2822),
    [anon_sym_decltype] = ACTIONS(2822),
    [anon_sym_explicit] = ACTIONS(2822),
    [anon_sym_typename] = ACTIONS(2822),
    [anon_sym_template] = ACTIONS(2822),
    [anon_sym_operator] = ACTIONS(2822),
    [anon_sym_friend] = ACTIONS(2822),
    [anon_sym_public] = ACTIONS(2822),
    [anon_sym_private] = ACTIONS(2822),
    [anon_sym_protected] = ACTIONS(2822),
    [anon_sym_using] = ACTIONS(2822),
    [anon_sym_static_assert] = ACTIONS(2822),
  },
  [2071] = {
    [sym_identifier] = ACTIONS(5478),
    [aux_sym_preproc_def_token1] = ACTIONS(5478),
    [aux_sym_preproc_if_token1] = ACTIONS(5478),
    [aux_sym_preproc_if_token2] = ACTIONS(5478),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5478),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5478),
    [sym_preproc_directive] = ACTIONS(5478),
    [anon_sym_LPAREN2] = ACTIONS(5480),
    [anon_sym_TILDE] = ACTIONS(5480),
    [anon_sym_STAR] = ACTIONS(5480),
    [anon_sym_AMP_AMP] = ACTIONS(5480),
    [anon_sym_AMP] = ACTIONS(5478),
    [anon_sym_SEMI] = ACTIONS(5480),
    [anon_sym___extension__] = ACTIONS(5478),
    [anon_sym_typedef] = ACTIONS(5478),
    [anon_sym_virtual] = ACTIONS(5478),
    [anon_sym_extern] = ACTIONS(5478),
    [anon_sym___attribute__] = ACTIONS(5478),
    [anon_sym___attribute] = ACTIONS(5478),
    [anon_sym_COLON_COLON] = ACTIONS(5480),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5480),
    [anon_sym___declspec] = ACTIONS(5478),
    [anon_sym___based] = ACTIONS(5478),
    [anon_sym_signed] = ACTIONS(5478),
    [anon_sym_unsigned] = ACTIONS(5478),
    [anon_sym_long] = ACTIONS(5478),
    [anon_sym_short] = ACTIONS(5478),
    [anon_sym_LBRACK] = ACTIONS(5478),
    [anon_sym_static] = ACTIONS(5478),
    [anon_sym_register] = ACTIONS(5478),
    [anon_sym_inline] = ACTIONS(5478),
    [anon_sym___inline] = ACTIONS(5478),
    [anon_sym___inline__] = ACTIONS(5478),
    [anon_sym___forceinline] = ACTIONS(5478),
    [anon_sym_thread_local] = ACTIONS(5478),
    [anon_sym___thread] = ACTIONS(5478),
    [anon_sym_const] = ACTIONS(5478),
    [anon_sym_constexpr] = ACTIONS(5478),
    [anon_sym_volatile] = ACTIONS(5478),
    [anon_sym_restrict] = ACTIONS(5478),
    [anon_sym___restrict__] = ACTIONS(5478),
    [anon_sym__Atomic] = ACTIONS(5478),
    [anon_sym__Noreturn] = ACTIONS(5478),
    [anon_sym_noreturn] = ACTIONS(5478),
    [anon_sym__Nonnull] = ACTIONS(5478),
    [anon_sym_mutable] = ACTIONS(5478),
    [anon_sym_constinit] = ACTIONS(5478),
    [anon_sym_consteval] = ACTIONS(5478),
    [anon_sym_alignas] = ACTIONS(5478),
    [anon_sym__Alignas] = ACTIONS(5478),
    [sym_primitive_type] = ACTIONS(5478),
    [anon_sym_enum] = ACTIONS(5478),
    [anon_sym_class] = ACTIONS(5478),
    [anon_sym_struct] = ACTIONS(5478),
    [anon_sym_union] = ACTIONS(5478),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5478),
    [anon_sym_decltype] = ACTIONS(5478),
    [anon_sym_explicit] = ACTIONS(5478),
    [anon_sym_typename] = ACTIONS(5478),
    [anon_sym_template] = ACTIONS(5478),
    [anon_sym_operator] = ACTIONS(5478),
    [anon_sym_friend] = ACTIONS(5478),
    [anon_sym_public] = ACTIONS(5478),
    [anon_sym_private] = ACTIONS(5478),
    [anon_sym_protected] = ACTIONS(5478),
    [anon_sym_using] = ACTIONS(5478),
    [anon_sym_static_assert] = ACTIONS(5478),
  },
  [2072] = {
    [sym_identifier] = ACTIONS(5482),
    [aux_sym_preproc_def_token1] = ACTIONS(5482),
    [aux_sym_preproc_if_token1] = ACTIONS(5482),
    [aux_sym_preproc_if_token2] = ACTIONS(5482),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5482),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5482),
    [sym_preproc_directive] = ACTIONS(5482),
    [anon_sym_LPAREN2] = ACTIONS(5484),
    [anon_sym_TILDE] = ACTIONS(5484),
    [anon_sym_STAR] = ACTIONS(5484),
    [anon_sym_AMP_AMP] = ACTIONS(5484),
    [anon_sym_AMP] = ACTIONS(5482),
    [anon_sym_SEMI] = ACTIONS(5484),
    [anon_sym___extension__] = ACTIONS(5482),
    [anon_sym_typedef] = ACTIONS(5482),
    [anon_sym_virtual] = ACTIONS(5482),
    [anon_sym_extern] = ACTIONS(5482),
    [anon_sym___attribute__] = ACTIONS(5482),
    [anon_sym___attribute] = ACTIONS(5482),
    [anon_sym_COLON_COLON] = ACTIONS(5484),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5484),
    [anon_sym___declspec] = ACTIONS(5482),
    [anon_sym___based] = ACTIONS(5482),
    [anon_sym_signed] = ACTIONS(5482),
    [anon_sym_unsigned] = ACTIONS(5482),
    [anon_sym_long] = ACTIONS(5482),
    [anon_sym_short] = ACTIONS(5482),
    [anon_sym_LBRACK] = ACTIONS(5482),
    [anon_sym_static] = ACTIONS(5482),
    [anon_sym_register] = ACTIONS(5482),
    [anon_sym_inline] = ACTIONS(5482),
    [anon_sym___inline] = ACTIONS(5482),
    [anon_sym___inline__] = ACTIONS(5482),
    [anon_sym___forceinline] = ACTIONS(5482),
    [anon_sym_thread_local] = ACTIONS(5482),
    [anon_sym___thread] = ACTIONS(5482),
    [anon_sym_const] = ACTIONS(5482),
    [anon_sym_constexpr] = ACTIONS(5482),
    [anon_sym_volatile] = ACTIONS(5482),
    [anon_sym_restrict] = ACTIONS(5482),
    [anon_sym___restrict__] = ACTIONS(5482),
    [anon_sym__Atomic] = ACTIONS(5482),
    [anon_sym__Noreturn] = ACTIONS(5482),
    [anon_sym_noreturn] = ACTIONS(5482),
    [anon_sym__Nonnull] = ACTIONS(5482),
    [anon_sym_mutable] = ACTIONS(5482),
    [anon_sym_constinit] = ACTIONS(5482),
    [anon_sym_consteval] = ACTIONS(5482),
    [anon_sym_alignas] = ACTIONS(5482),
    [anon_sym__Alignas] = ACTIONS(5482),
    [sym_primitive_type] = ACTIONS(5482),
    [anon_sym_enum] = ACTIONS(5482),
    [anon_sym_class] = ACTIONS(5482),
    [anon_sym_struct] = ACTIONS(5482),
    [anon_sym_union] = ACTIONS(5482),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5482),
    [anon_sym_decltype] = ACTIONS(5482),
    [anon_sym_explicit] = ACTIONS(5482),
    [anon_sym_typename] = ACTIONS(5482),
    [anon_sym_template] = ACTIONS(5482),
    [anon_sym_operator] = ACTIONS(5482),
    [anon_sym_friend] = ACTIONS(5482),
    [anon_sym_public] = ACTIONS(5482),
    [anon_sym_private] = ACTIONS(5482),
    [anon_sym_protected] = ACTIONS(5482),
    [anon_sym_using] = ACTIONS(5482),
    [anon_sym_static_assert] = ACTIONS(5482),
  },
  [2073] = {
    [sym_identifier] = ACTIONS(5486),
    [aux_sym_preproc_def_token1] = ACTIONS(5486),
    [aux_sym_preproc_if_token1] = ACTIONS(5486),
    [aux_sym_preproc_if_token2] = ACTIONS(5486),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5486),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5486),
    [sym_preproc_directive] = ACTIONS(5486),
    [anon_sym_LPAREN2] = ACTIONS(5488),
    [anon_sym_TILDE] = ACTIONS(5488),
    [anon_sym_STAR] = ACTIONS(5488),
    [anon_sym_AMP_AMP] = ACTIONS(5488),
    [anon_sym_AMP] = ACTIONS(5486),
    [anon_sym_SEMI] = ACTIONS(5488),
    [anon_sym___extension__] = ACTIONS(5486),
    [anon_sym_typedef] = ACTIONS(5486),
    [anon_sym_virtual] = ACTIONS(5486),
    [anon_sym_extern] = ACTIONS(5486),
    [anon_sym___attribute__] = ACTIONS(5486),
    [anon_sym___attribute] = ACTIONS(5486),
    [anon_sym_COLON_COLON] = ACTIONS(5488),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5488),
    [anon_sym___declspec] = ACTIONS(5486),
    [anon_sym___based] = ACTIONS(5486),
    [anon_sym_signed] = ACTIONS(5486),
    [anon_sym_unsigned] = ACTIONS(5486),
    [anon_sym_long] = ACTIONS(5486),
    [anon_sym_short] = ACTIONS(5486),
    [anon_sym_LBRACK] = ACTIONS(5486),
    [anon_sym_static] = ACTIONS(5486),
    [anon_sym_register] = ACTIONS(5486),
    [anon_sym_inline] = ACTIONS(5486),
    [anon_sym___inline] = ACTIONS(5486),
    [anon_sym___inline__] = ACTIONS(5486),
    [anon_sym___forceinline] = ACTIONS(5486),
    [anon_sym_thread_local] = ACTIONS(5486),
    [anon_sym___thread] = ACTIONS(5486),
    [anon_sym_const] = ACTIONS(5486),
    [anon_sym_constexpr] = ACTIONS(5486),
    [anon_sym_volatile] = ACTIONS(5486),
    [anon_sym_restrict] = ACTIONS(5486),
    [anon_sym___restrict__] = ACTIONS(5486),
    [anon_sym__Atomic] = ACTIONS(5486),
    [anon_sym__Noreturn] = ACTIONS(5486),
    [anon_sym_noreturn] = ACTIONS(5486),
    [anon_sym__Nonnull] = ACTIONS(5486),
    [anon_sym_mutable] = ACTIONS(5486),
    [anon_sym_constinit] = ACTIONS(5486),
    [anon_sym_consteval] = ACTIONS(5486),
    [anon_sym_alignas] = ACTIONS(5486),
    [anon_sym__Alignas] = ACTIONS(5486),
    [sym_primitive_type] = ACTIONS(5486),
    [anon_sym_enum] = ACTIONS(5486),
    [anon_sym_class] = ACTIONS(5486),
    [anon_sym_struct] = ACTIONS(5486),
    [anon_sym_union] = ACTIONS(5486),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5486),
    [anon_sym_decltype] = ACTIONS(5486),
    [anon_sym_explicit] = ACTIONS(5486),
    [anon_sym_typename] = ACTIONS(5486),
    [anon_sym_template] = ACTIONS(5486),
    [anon_sym_operator] = ACTIONS(5486),
    [anon_sym_friend] = ACTIONS(5486),
    [anon_sym_public] = ACTIONS(5486),
    [anon_sym_private] = ACTIONS(5486),
    [anon_sym_protected] = ACTIONS(5486),
    [anon_sym_using] = ACTIONS(5486),
    [anon_sym_static_assert] = ACTIONS(5486),
  },
  [2074] = {
    [sym_identifier] = ACTIONS(2633),
    [aux_sym_preproc_def_token1] = ACTIONS(2633),
    [aux_sym_preproc_if_token1] = ACTIONS(2633),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2633),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2633),
    [sym_preproc_directive] = ACTIONS(2633),
    [anon_sym_LPAREN2] = ACTIONS(2635),
    [anon_sym_TILDE] = ACTIONS(2635),
    [anon_sym_STAR] = ACTIONS(2635),
    [anon_sym_AMP_AMP] = ACTIONS(2635),
    [anon_sym_AMP] = ACTIONS(2633),
    [anon_sym_SEMI] = ACTIONS(2635),
    [anon_sym___extension__] = ACTIONS(2633),
    [anon_sym_typedef] = ACTIONS(2633),
    [anon_sym_virtual] = ACTIONS(2633),
    [anon_sym_extern] = ACTIONS(2633),
    [anon_sym___attribute__] = ACTIONS(2633),
    [anon_sym___attribute] = ACTIONS(2633),
    [anon_sym_COLON_COLON] = ACTIONS(2635),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2635),
    [anon_sym___declspec] = ACTIONS(2633),
    [anon_sym___based] = ACTIONS(2633),
    [anon_sym_RBRACE] = ACTIONS(2635),
    [anon_sym_signed] = ACTIONS(2633),
    [anon_sym_unsigned] = ACTIONS(2633),
    [anon_sym_long] = ACTIONS(2633),
    [anon_sym_short] = ACTIONS(2633),
    [anon_sym_LBRACK] = ACTIONS(2633),
    [anon_sym_static] = ACTIONS(2633),
    [anon_sym_register] = ACTIONS(2633),
    [anon_sym_inline] = ACTIONS(2633),
    [anon_sym___inline] = ACTIONS(2633),
    [anon_sym___inline__] = ACTIONS(2633),
    [anon_sym___forceinline] = ACTIONS(2633),
    [anon_sym_thread_local] = ACTIONS(2633),
    [anon_sym___thread] = ACTIONS(2633),
    [anon_sym_const] = ACTIONS(2633),
    [anon_sym_constexpr] = ACTIONS(2633),
    [anon_sym_volatile] = ACTIONS(2633),
    [anon_sym_restrict] = ACTIONS(2633),
    [anon_sym___restrict__] = ACTIONS(2633),
    [anon_sym__Atomic] = ACTIONS(2633),
    [anon_sym__Noreturn] = ACTIONS(2633),
    [anon_sym_noreturn] = ACTIONS(2633),
    [anon_sym__Nonnull] = ACTIONS(2633),
    [anon_sym_mutable] = ACTIONS(2633),
    [anon_sym_constinit] = ACTIONS(2633),
    [anon_sym_consteval] = ACTIONS(2633),
    [anon_sym_alignas] = ACTIONS(2633),
    [anon_sym__Alignas] = ACTIONS(2633),
    [sym_primitive_type] = ACTIONS(2633),
    [anon_sym_enum] = ACTIONS(2633),
    [anon_sym_class] = ACTIONS(2633),
    [anon_sym_struct] = ACTIONS(2633),
    [anon_sym_union] = ACTIONS(2633),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2633),
    [anon_sym_decltype] = ACTIONS(2633),
    [anon_sym_explicit] = ACTIONS(2633),
    [anon_sym_typename] = ACTIONS(2633),
    [anon_sym_template] = ACTIONS(2633),
    [anon_sym_operator] = ACTIONS(2633),
    [anon_sym_friend] = ACTIONS(2633),
    [anon_sym_public] = ACTIONS(2633),
    [anon_sym_private] = ACTIONS(2633),
    [anon_sym_protected] = ACTIONS(2633),
    [anon_sym_using] = ACTIONS(2633),
    [anon_sym_static_assert] = ACTIONS(2633),
  },
  [2075] = {
    [sym_identifier] = ACTIONS(2637),
    [aux_sym_preproc_def_token1] = ACTIONS(2637),
    [aux_sym_preproc_if_token1] = ACTIONS(2637),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2637),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2637),
    [sym_preproc_directive] = ACTIONS(2637),
    [anon_sym_LPAREN2] = ACTIONS(2639),
    [anon_sym_TILDE] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(2639),
    [anon_sym_AMP_AMP] = ACTIONS(2639),
    [anon_sym_AMP] = ACTIONS(2637),
    [anon_sym_SEMI] = ACTIONS(2639),
    [anon_sym___extension__] = ACTIONS(2637),
    [anon_sym_typedef] = ACTIONS(2637),
    [anon_sym_virtual] = ACTIONS(2637),
    [anon_sym_extern] = ACTIONS(2637),
    [anon_sym___attribute__] = ACTIONS(2637),
    [anon_sym___attribute] = ACTIONS(2637),
    [anon_sym_COLON_COLON] = ACTIONS(2639),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2639),
    [anon_sym___declspec] = ACTIONS(2637),
    [anon_sym___based] = ACTIONS(2637),
    [anon_sym_RBRACE] = ACTIONS(2639),
    [anon_sym_signed] = ACTIONS(2637),
    [anon_sym_unsigned] = ACTIONS(2637),
    [anon_sym_long] = ACTIONS(2637),
    [anon_sym_short] = ACTIONS(2637),
    [anon_sym_LBRACK] = ACTIONS(2637),
    [anon_sym_static] = ACTIONS(2637),
    [anon_sym_register] = ACTIONS(2637),
    [anon_sym_inline] = ACTIONS(2637),
    [anon_sym___inline] = ACTIONS(2637),
    [anon_sym___inline__] = ACTIONS(2637),
    [anon_sym___forceinline] = ACTIONS(2637),
    [anon_sym_thread_local] = ACTIONS(2637),
    [anon_sym___thread] = ACTIONS(2637),
    [anon_sym_const] = ACTIONS(2637),
    [anon_sym_constexpr] = ACTIONS(2637),
    [anon_sym_volatile] = ACTIONS(2637),
    [anon_sym_restrict] = ACTIONS(2637),
    [anon_sym___restrict__] = ACTIONS(2637),
    [anon_sym__Atomic] = ACTIONS(2637),
    [anon_sym__Noreturn] = ACTIONS(2637),
    [anon_sym_noreturn] = ACTIONS(2637),
    [anon_sym__Nonnull] = ACTIONS(2637),
    [anon_sym_mutable] = ACTIONS(2637),
    [anon_sym_constinit] = ACTIONS(2637),
    [anon_sym_consteval] = ACTIONS(2637),
    [anon_sym_alignas] = ACTIONS(2637),
    [anon_sym__Alignas] = ACTIONS(2637),
    [sym_primitive_type] = ACTIONS(2637),
    [anon_sym_enum] = ACTIONS(2637),
    [anon_sym_class] = ACTIONS(2637),
    [anon_sym_struct] = ACTIONS(2637),
    [anon_sym_union] = ACTIONS(2637),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2637),
    [anon_sym_decltype] = ACTIONS(2637),
    [anon_sym_explicit] = ACTIONS(2637),
    [anon_sym_typename] = ACTIONS(2637),
    [anon_sym_template] = ACTIONS(2637),
    [anon_sym_operator] = ACTIONS(2637),
    [anon_sym_friend] = ACTIONS(2637),
    [anon_sym_public] = ACTIONS(2637),
    [anon_sym_private] = ACTIONS(2637),
    [anon_sym_protected] = ACTIONS(2637),
    [anon_sym_using] = ACTIONS(2637),
    [anon_sym_static_assert] = ACTIONS(2637),
  },
  [2076] = {
    [sym_identifier] = ACTIONS(2637),
    [aux_sym_preproc_def_token1] = ACTIONS(2637),
    [aux_sym_preproc_if_token1] = ACTIONS(2637),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2637),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2637),
    [sym_preproc_directive] = ACTIONS(2637),
    [anon_sym_LPAREN2] = ACTIONS(2639),
    [anon_sym_TILDE] = ACTIONS(2639),
    [anon_sym_STAR] = ACTIONS(2639),
    [anon_sym_AMP_AMP] = ACTIONS(2639),
    [anon_sym_AMP] = ACTIONS(2637),
    [anon_sym_SEMI] = ACTIONS(2639),
    [anon_sym___extension__] = ACTIONS(2637),
    [anon_sym_typedef] = ACTIONS(2637),
    [anon_sym_virtual] = ACTIONS(2637),
    [anon_sym_extern] = ACTIONS(2637),
    [anon_sym___attribute__] = ACTIONS(2637),
    [anon_sym___attribute] = ACTIONS(2637),
    [anon_sym_COLON_COLON] = ACTIONS(2639),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2639),
    [anon_sym___declspec] = ACTIONS(2637),
    [anon_sym___based] = ACTIONS(2637),
    [anon_sym_RBRACE] = ACTIONS(2639),
    [anon_sym_signed] = ACTIONS(2637),
    [anon_sym_unsigned] = ACTIONS(2637),
    [anon_sym_long] = ACTIONS(2637),
    [anon_sym_short] = ACTIONS(2637),
    [anon_sym_LBRACK] = ACTIONS(2637),
    [anon_sym_static] = ACTIONS(2637),
    [anon_sym_register] = ACTIONS(2637),
    [anon_sym_inline] = ACTIONS(2637),
    [anon_sym___inline] = ACTIONS(2637),
    [anon_sym___inline__] = ACTIONS(2637),
    [anon_sym___forceinline] = ACTIONS(2637),
    [anon_sym_thread_local] = ACTIONS(2637),
    [anon_sym___thread] = ACTIONS(2637),
    [anon_sym_const] = ACTIONS(2637),
    [anon_sym_constexpr] = ACTIONS(2637),
    [anon_sym_volatile] = ACTIONS(2637),
    [anon_sym_restrict] = ACTIONS(2637),
    [anon_sym___restrict__] = ACTIONS(2637),
    [anon_sym__Atomic] = ACTIONS(2637),
    [anon_sym__Noreturn] = ACTIONS(2637),
    [anon_sym_noreturn] = ACTIONS(2637),
    [anon_sym__Nonnull] = ACTIONS(2637),
    [anon_sym_mutable] = ACTIONS(2637),
    [anon_sym_constinit] = ACTIONS(2637),
    [anon_sym_consteval] = ACTIONS(2637),
    [anon_sym_alignas] = ACTIONS(2637),
    [anon_sym__Alignas] = ACTIONS(2637),
    [sym_primitive_type] = ACTIONS(2637),
    [anon_sym_enum] = ACTIONS(2637),
    [anon_sym_class] = ACTIONS(2637),
    [anon_sym_struct] = ACTIONS(2637),
    [anon_sym_union] = ACTIONS(2637),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2637),
    [anon_sym_decltype] = ACTIONS(2637),
    [anon_sym_explicit] = ACTIONS(2637),
    [anon_sym_typename] = ACTIONS(2637),
    [anon_sym_template] = ACTIONS(2637),
    [anon_sym_operator] = ACTIONS(2637),
    [anon_sym_friend] = ACTIONS(2637),
    [anon_sym_public] = ACTIONS(2637),
    [anon_sym_private] = ACTIONS(2637),
    [anon_sym_protected] = ACTIONS(2637),
    [anon_sym_using] = ACTIONS(2637),
    [anon_sym_static_assert] = ACTIONS(2637),
  },
  [2077] = {
    [sym_identifier] = ACTIONS(5435),
    [aux_sym_preproc_def_token1] = ACTIONS(5435),
    [aux_sym_preproc_if_token1] = ACTIONS(5435),
    [aux_sym_preproc_if_token2] = ACTIONS(5435),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5435),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5435),
    [sym_preproc_directive] = ACTIONS(5435),
    [anon_sym_LPAREN2] = ACTIONS(5437),
    [anon_sym_TILDE] = ACTIONS(5437),
    [anon_sym_STAR] = ACTIONS(5437),
    [anon_sym_AMP_AMP] = ACTIONS(5437),
    [anon_sym_AMP] = ACTIONS(5435),
    [anon_sym_SEMI] = ACTIONS(5437),
    [anon_sym___extension__] = ACTIONS(5435),
    [anon_sym_typedef] = ACTIONS(5435),
    [anon_sym_virtual] = ACTIONS(5435),
    [anon_sym_extern] = ACTIONS(5435),
    [anon_sym___attribute__] = ACTIONS(5435),
    [anon_sym___attribute] = ACTIONS(5435),
    [anon_sym_COLON_COLON] = ACTIONS(5437),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5437),
    [anon_sym___declspec] = ACTIONS(5435),
    [anon_sym___based] = ACTIONS(5435),
    [anon_sym_signed] = ACTIONS(5435),
    [anon_sym_unsigned] = ACTIONS(5435),
    [anon_sym_long] = ACTIONS(5435),
    [anon_sym_short] = ACTIONS(5435),
    [anon_sym_LBRACK] = ACTIONS(5435),
    [anon_sym_static] = ACTIONS(5435),
    [anon_sym_register] = ACTIONS(5435),
    [anon_sym_inline] = ACTIONS(5435),
    [anon_sym___inline] = ACTIONS(5435),
    [anon_sym___inline__] = ACTIONS(5435),
    [anon_sym___forceinline] = ACTIONS(5435),
    [anon_sym_thread_local] = ACTIONS(5435),
    [anon_sym___thread] = ACTIONS(5435),
    [anon_sym_const] = ACTIONS(5435),
    [anon_sym_constexpr] = ACTIONS(5435),
    [anon_sym_volatile] = ACTIONS(5435),
    [anon_sym_restrict] = ACTIONS(5435),
    [anon_sym___restrict__] = ACTIONS(5435),
    [anon_sym__Atomic] = ACTIONS(5435),
    [anon_sym__Noreturn] = ACTIONS(5435),
    [anon_sym_noreturn] = ACTIONS(5435),
    [anon_sym__Nonnull] = ACTIONS(5435),
    [anon_sym_mutable] = ACTIONS(5435),
    [anon_sym_constinit] = ACTIONS(5435),
    [anon_sym_consteval] = ACTIONS(5435),
    [anon_sym_alignas] = ACTIONS(5435),
    [anon_sym__Alignas] = ACTIONS(5435),
    [sym_primitive_type] = ACTIONS(5435),
    [anon_sym_enum] = ACTIONS(5435),
    [anon_sym_class] = ACTIONS(5435),
    [anon_sym_struct] = ACTIONS(5435),
    [anon_sym_union] = ACTIONS(5435),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5435),
    [anon_sym_decltype] = ACTIONS(5435),
    [anon_sym_explicit] = ACTIONS(5435),
    [anon_sym_typename] = ACTIONS(5435),
    [anon_sym_template] = ACTIONS(5435),
    [anon_sym_operator] = ACTIONS(5435),
    [anon_sym_friend] = ACTIONS(5435),
    [anon_sym_public] = ACTIONS(5435),
    [anon_sym_private] = ACTIONS(5435),
    [anon_sym_protected] = ACTIONS(5435),
    [anon_sym_using] = ACTIONS(5435),
    [anon_sym_static_assert] = ACTIONS(5435),
  },
  [2078] = {
    [sym_identifier] = ACTIONS(5435),
    [aux_sym_preproc_def_token1] = ACTIONS(5435),
    [aux_sym_preproc_if_token1] = ACTIONS(5435),
    [aux_sym_preproc_if_token2] = ACTIONS(5435),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5435),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5435),
    [sym_preproc_directive] = ACTIONS(5435),
    [anon_sym_LPAREN2] = ACTIONS(5437),
    [anon_sym_TILDE] = ACTIONS(5437),
    [anon_sym_STAR] = ACTIONS(5437),
    [anon_sym_AMP_AMP] = ACTIONS(5437),
    [anon_sym_AMP] = ACTIONS(5435),
    [anon_sym_SEMI] = ACTIONS(5437),
    [anon_sym___extension__] = ACTIONS(5435),
    [anon_sym_typedef] = ACTIONS(5435),
    [anon_sym_virtual] = ACTIONS(5435),
    [anon_sym_extern] = ACTIONS(5435),
    [anon_sym___attribute__] = ACTIONS(5435),
    [anon_sym___attribute] = ACTIONS(5435),
    [anon_sym_COLON_COLON] = ACTIONS(5437),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5437),
    [anon_sym___declspec] = ACTIONS(5435),
    [anon_sym___based] = ACTIONS(5435),
    [anon_sym_signed] = ACTIONS(5435),
    [anon_sym_unsigned] = ACTIONS(5435),
    [anon_sym_long] = ACTIONS(5435),
    [anon_sym_short] = ACTIONS(5435),
    [anon_sym_LBRACK] = ACTIONS(5435),
    [anon_sym_static] = ACTIONS(5435),
    [anon_sym_register] = ACTIONS(5435),
    [anon_sym_inline] = ACTIONS(5435),
    [anon_sym___inline] = ACTIONS(5435),
    [anon_sym___inline__] = ACTIONS(5435),
    [anon_sym___forceinline] = ACTIONS(5435),
    [anon_sym_thread_local] = ACTIONS(5435),
    [anon_sym___thread] = ACTIONS(5435),
    [anon_sym_const] = ACTIONS(5435),
    [anon_sym_constexpr] = ACTIONS(5435),
    [anon_sym_volatile] = ACTIONS(5435),
    [anon_sym_restrict] = ACTIONS(5435),
    [anon_sym___restrict__] = ACTIONS(5435),
    [anon_sym__Atomic] = ACTIONS(5435),
    [anon_sym__Noreturn] = ACTIONS(5435),
    [anon_sym_noreturn] = ACTIONS(5435),
    [anon_sym__Nonnull] = ACTIONS(5435),
    [anon_sym_mutable] = ACTIONS(5435),
    [anon_sym_constinit] = ACTIONS(5435),
    [anon_sym_consteval] = ACTIONS(5435),
    [anon_sym_alignas] = ACTIONS(5435),
    [anon_sym__Alignas] = ACTIONS(5435),
    [sym_primitive_type] = ACTIONS(5435),
    [anon_sym_enum] = ACTIONS(5435),
    [anon_sym_class] = ACTIONS(5435),
    [anon_sym_struct] = ACTIONS(5435),
    [anon_sym_union] = ACTIONS(5435),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5435),
    [anon_sym_decltype] = ACTIONS(5435),
    [anon_sym_explicit] = ACTIONS(5435),
    [anon_sym_typename] = ACTIONS(5435),
    [anon_sym_template] = ACTIONS(5435),
    [anon_sym_operator] = ACTIONS(5435),
    [anon_sym_friend] = ACTIONS(5435),
    [anon_sym_public] = ACTIONS(5435),
    [anon_sym_private] = ACTIONS(5435),
    [anon_sym_protected] = ACTIONS(5435),
    [anon_sym_using] = ACTIONS(5435),
    [anon_sym_static_assert] = ACTIONS(5435),
  },
  [2079] = {
    [sym_identifier] = ACTIONS(5357),
    [aux_sym_preproc_def_token1] = ACTIONS(5357),
    [aux_sym_preproc_if_token1] = ACTIONS(5357),
    [aux_sym_preproc_if_token2] = ACTIONS(5357),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5357),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5357),
    [sym_preproc_directive] = ACTIONS(5357),
    [anon_sym_LPAREN2] = ACTIONS(5359),
    [anon_sym_TILDE] = ACTIONS(5359),
    [anon_sym_STAR] = ACTIONS(5359),
    [anon_sym_AMP_AMP] = ACTIONS(5359),
    [anon_sym_AMP] = ACTIONS(5357),
    [anon_sym_SEMI] = ACTIONS(5359),
    [anon_sym___extension__] = ACTIONS(5357),
    [anon_sym_typedef] = ACTIONS(5357),
    [anon_sym_virtual] = ACTIONS(5357),
    [anon_sym_extern] = ACTIONS(5357),
    [anon_sym___attribute__] = ACTIONS(5357),
    [anon_sym___attribute] = ACTIONS(5357),
    [anon_sym_COLON_COLON] = ACTIONS(5359),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5359),
    [anon_sym___declspec] = ACTIONS(5357),
    [anon_sym___based] = ACTIONS(5357),
    [anon_sym_signed] = ACTIONS(5357),
    [anon_sym_unsigned] = ACTIONS(5357),
    [anon_sym_long] = ACTIONS(5357),
    [anon_sym_short] = ACTIONS(5357),
    [anon_sym_LBRACK] = ACTIONS(5357),
    [anon_sym_static] = ACTIONS(5357),
    [anon_sym_register] = ACTIONS(5357),
    [anon_sym_inline] = ACTIONS(5357),
    [anon_sym___inline] = ACTIONS(5357),
    [anon_sym___inline__] = ACTIONS(5357),
    [anon_sym___forceinline] = ACTIONS(5357),
    [anon_sym_thread_local] = ACTIONS(5357),
    [anon_sym___thread] = ACTIONS(5357),
    [anon_sym_const] = ACTIONS(5357),
    [anon_sym_constexpr] = ACTIONS(5357),
    [anon_sym_volatile] = ACTIONS(5357),
    [anon_sym_restrict] = ACTIONS(5357),
    [anon_sym___restrict__] = ACTIONS(5357),
    [anon_sym__Atomic] = ACTIONS(5357),
    [anon_sym__Noreturn] = ACTIONS(5357),
    [anon_sym_noreturn] = ACTIONS(5357),
    [anon_sym__Nonnull] = ACTIONS(5357),
    [anon_sym_mutable] = ACTIONS(5357),
    [anon_sym_constinit] = ACTIONS(5357),
    [anon_sym_consteval] = ACTIONS(5357),
    [anon_sym_alignas] = ACTIONS(5357),
    [anon_sym__Alignas] = ACTIONS(5357),
    [sym_primitive_type] = ACTIONS(5357),
    [anon_sym_enum] = ACTIONS(5357),
    [anon_sym_class] = ACTIONS(5357),
    [anon_sym_struct] = ACTIONS(5357),
    [anon_sym_union] = ACTIONS(5357),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5357),
    [anon_sym_decltype] = ACTIONS(5357),
    [anon_sym_explicit] = ACTIONS(5357),
    [anon_sym_typename] = ACTIONS(5357),
    [anon_sym_template] = ACTIONS(5357),
    [anon_sym_operator] = ACTIONS(5357),
    [anon_sym_friend] = ACTIONS(5357),
    [anon_sym_public] = ACTIONS(5357),
    [anon_sym_private] = ACTIONS(5357),
    [anon_sym_protected] = ACTIONS(5357),
    [anon_sym_using] = ACTIONS(5357),
    [anon_sym_static_assert] = ACTIONS(5357),
  },
  [2080] = {
    [sym_identifier] = ACTIONS(5307),
    [aux_sym_preproc_def_token1] = ACTIONS(5307),
    [aux_sym_preproc_if_token1] = ACTIONS(5307),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5307),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5307),
    [sym_preproc_directive] = ACTIONS(5307),
    [anon_sym_LPAREN2] = ACTIONS(5309),
    [anon_sym_TILDE] = ACTIONS(5309),
    [anon_sym_STAR] = ACTIONS(5309),
    [anon_sym_AMP_AMP] = ACTIONS(5309),
    [anon_sym_AMP] = ACTIONS(5307),
    [anon_sym_SEMI] = ACTIONS(5309),
    [anon_sym___extension__] = ACTIONS(5307),
    [anon_sym_typedef] = ACTIONS(5307),
    [anon_sym_virtual] = ACTIONS(5307),
    [anon_sym_extern] = ACTIONS(5307),
    [anon_sym___attribute__] = ACTIONS(5307),
    [anon_sym___attribute] = ACTIONS(5307),
    [anon_sym_COLON_COLON] = ACTIONS(5309),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5309),
    [anon_sym___declspec] = ACTIONS(5307),
    [anon_sym___based] = ACTIONS(5307),
    [anon_sym_RBRACE] = ACTIONS(5309),
    [anon_sym_signed] = ACTIONS(5307),
    [anon_sym_unsigned] = ACTIONS(5307),
    [anon_sym_long] = ACTIONS(5307),
    [anon_sym_short] = ACTIONS(5307),
    [anon_sym_LBRACK] = ACTIONS(5307),
    [anon_sym_static] = ACTIONS(5307),
    [anon_sym_register] = ACTIONS(5307),
    [anon_sym_inline] = ACTIONS(5307),
    [anon_sym___inline] = ACTIONS(5307),
    [anon_sym___inline__] = ACTIONS(5307),
    [anon_sym___forceinline] = ACTIONS(5307),
    [anon_sym_thread_local] = ACTIONS(5307),
    [anon_sym___thread] = ACTIONS(5307),
    [anon_sym_const] = ACTIONS(5307),
    [anon_sym_constexpr] = ACTIONS(5307),
    [anon_sym_volatile] = ACTIONS(5307),
    [anon_sym_restrict] = ACTIONS(5307),
    [anon_sym___restrict__] = ACTIONS(5307),
    [anon_sym__Atomic] = ACTIONS(5307),
    [anon_sym__Noreturn] = ACTIONS(5307),
    [anon_sym_noreturn] = ACTIONS(5307),
    [anon_sym__Nonnull] = ACTIONS(5307),
    [anon_sym_mutable] = ACTIONS(5307),
    [anon_sym_constinit] = ACTIONS(5307),
    [anon_sym_consteval] = ACTIONS(5307),
    [anon_sym_alignas] = ACTIONS(5307),
    [anon_sym__Alignas] = ACTIONS(5307),
    [sym_primitive_type] = ACTIONS(5307),
    [anon_sym_enum] = ACTIONS(5307),
    [anon_sym_class] = ACTIONS(5307),
    [anon_sym_struct] = ACTIONS(5307),
    [anon_sym_union] = ACTIONS(5307),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5307),
    [anon_sym_decltype] = ACTIONS(5307),
    [anon_sym_explicit] = ACTIONS(5307),
    [anon_sym_typename] = ACTIONS(5307),
    [anon_sym_template] = ACTIONS(5307),
    [anon_sym_operator] = ACTIONS(5307),
    [anon_sym_friend] = ACTIONS(5307),
    [anon_sym_public] = ACTIONS(5307),
    [anon_sym_private] = ACTIONS(5307),
    [anon_sym_protected] = ACTIONS(5307),
    [anon_sym_using] = ACTIONS(5307),
    [anon_sym_static_assert] = ACTIONS(5307),
  },
  [2081] = {
    [sym_identifier] = ACTIONS(5403),
    [aux_sym_preproc_def_token1] = ACTIONS(5403),
    [aux_sym_preproc_if_token1] = ACTIONS(5403),
    [aux_sym_preproc_if_token2] = ACTIONS(5403),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5403),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5403),
    [sym_preproc_directive] = ACTIONS(5403),
    [anon_sym_LPAREN2] = ACTIONS(5405),
    [anon_sym_TILDE] = ACTIONS(5405),
    [anon_sym_STAR] = ACTIONS(5405),
    [anon_sym_AMP_AMP] = ACTIONS(5405),
    [anon_sym_AMP] = ACTIONS(5403),
    [anon_sym_SEMI] = ACTIONS(5405),
    [anon_sym___extension__] = ACTIONS(5403),
    [anon_sym_typedef] = ACTIONS(5403),
    [anon_sym_virtual] = ACTIONS(5403),
    [anon_sym_extern] = ACTIONS(5403),
    [anon_sym___attribute__] = ACTIONS(5403),
    [anon_sym___attribute] = ACTIONS(5403),
    [anon_sym_COLON_COLON] = ACTIONS(5405),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5405),
    [anon_sym___declspec] = ACTIONS(5403),
    [anon_sym___based] = ACTIONS(5403),
    [anon_sym_signed] = ACTIONS(5403),
    [anon_sym_unsigned] = ACTIONS(5403),
    [anon_sym_long] = ACTIONS(5403),
    [anon_sym_short] = ACTIONS(5403),
    [anon_sym_LBRACK] = ACTIONS(5403),
    [anon_sym_static] = ACTIONS(5403),
    [anon_sym_register] = ACTIONS(5403),
    [anon_sym_inline] = ACTIONS(5403),
    [anon_sym___inline] = ACTIONS(5403),
    [anon_sym___inline__] = ACTIONS(5403),
    [anon_sym___forceinline] = ACTIONS(5403),
    [anon_sym_thread_local] = ACTIONS(5403),
    [anon_sym___thread] = ACTIONS(5403),
    [anon_sym_const] = ACTIONS(5403),
    [anon_sym_constexpr] = ACTIONS(5403),
    [anon_sym_volatile] = ACTIONS(5403),
    [anon_sym_restrict] = ACTIONS(5403),
    [anon_sym___restrict__] = ACTIONS(5403),
    [anon_sym__Atomic] = ACTIONS(5403),
    [anon_sym__Noreturn] = ACTIONS(5403),
    [anon_sym_noreturn] = ACTIONS(5403),
    [anon_sym__Nonnull] = ACTIONS(5403),
    [anon_sym_mutable] = ACTIONS(5403),
    [anon_sym_constinit] = ACTIONS(5403),
    [anon_sym_consteval] = ACTIONS(5403),
    [anon_sym_alignas] = ACTIONS(5403),
    [anon_sym__Alignas] = ACTIONS(5403),
    [sym_primitive_type] = ACTIONS(5403),
    [anon_sym_enum] = ACTIONS(5403),
    [anon_sym_class] = ACTIONS(5403),
    [anon_sym_struct] = ACTIONS(5403),
    [anon_sym_union] = ACTIONS(5403),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5403),
    [anon_sym_decltype] = ACTIONS(5403),
    [anon_sym_explicit] = ACTIONS(5403),
    [anon_sym_typename] = ACTIONS(5403),
    [anon_sym_template] = ACTIONS(5403),
    [anon_sym_operator] = ACTIONS(5403),
    [anon_sym_friend] = ACTIONS(5403),
    [anon_sym_public] = ACTIONS(5403),
    [anon_sym_private] = ACTIONS(5403),
    [anon_sym_protected] = ACTIONS(5403),
    [anon_sym_using] = ACTIONS(5403),
    [anon_sym_static_assert] = ACTIONS(5403),
  },
  [2082] = {
    [sym_identifier] = ACTIONS(5423),
    [aux_sym_preproc_def_token1] = ACTIONS(5423),
    [aux_sym_preproc_if_token1] = ACTIONS(5423),
    [aux_sym_preproc_if_token2] = ACTIONS(5423),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5423),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5423),
    [sym_preproc_directive] = ACTIONS(5423),
    [anon_sym_LPAREN2] = ACTIONS(5425),
    [anon_sym_TILDE] = ACTIONS(5425),
    [anon_sym_STAR] = ACTIONS(5425),
    [anon_sym_AMP_AMP] = ACTIONS(5425),
    [anon_sym_AMP] = ACTIONS(5423),
    [anon_sym_SEMI] = ACTIONS(5425),
    [anon_sym___extension__] = ACTIONS(5423),
    [anon_sym_typedef] = ACTIONS(5423),
    [anon_sym_virtual] = ACTIONS(5423),
    [anon_sym_extern] = ACTIONS(5423),
    [anon_sym___attribute__] = ACTIONS(5423),
    [anon_sym___attribute] = ACTIONS(5423),
    [anon_sym_COLON_COLON] = ACTIONS(5425),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5425),
    [anon_sym___declspec] = ACTIONS(5423),
    [anon_sym___based] = ACTIONS(5423),
    [anon_sym_signed] = ACTIONS(5423),
    [anon_sym_unsigned] = ACTIONS(5423),
    [anon_sym_long] = ACTIONS(5423),
    [anon_sym_short] = ACTIONS(5423),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_static] = ACTIONS(5423),
    [anon_sym_register] = ACTIONS(5423),
    [anon_sym_inline] = ACTIONS(5423),
    [anon_sym___inline] = ACTIONS(5423),
    [anon_sym___inline__] = ACTIONS(5423),
    [anon_sym___forceinline] = ACTIONS(5423),
    [anon_sym_thread_local] = ACTIONS(5423),
    [anon_sym___thread] = ACTIONS(5423),
    [anon_sym_const] = ACTIONS(5423),
    [anon_sym_constexpr] = ACTIONS(5423),
    [anon_sym_volatile] = ACTIONS(5423),
    [anon_sym_restrict] = ACTIONS(5423),
    [anon_sym___restrict__] = ACTIONS(5423),
    [anon_sym__Atomic] = ACTIONS(5423),
    [anon_sym__Noreturn] = ACTIONS(5423),
    [anon_sym_noreturn] = ACTIONS(5423),
    [anon_sym__Nonnull] = ACTIONS(5423),
    [anon_sym_mutable] = ACTIONS(5423),
    [anon_sym_constinit] = ACTIONS(5423),
    [anon_sym_consteval] = ACTIONS(5423),
    [anon_sym_alignas] = ACTIONS(5423),
    [anon_sym__Alignas] = ACTIONS(5423),
    [sym_primitive_type] = ACTIONS(5423),
    [anon_sym_enum] = ACTIONS(5423),
    [anon_sym_class] = ACTIONS(5423),
    [anon_sym_struct] = ACTIONS(5423),
    [anon_sym_union] = ACTIONS(5423),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5423),
    [anon_sym_decltype] = ACTIONS(5423),
    [anon_sym_explicit] = ACTIONS(5423),
    [anon_sym_typename] = ACTIONS(5423),
    [anon_sym_template] = ACTIONS(5423),
    [anon_sym_operator] = ACTIONS(5423),
    [anon_sym_friend] = ACTIONS(5423),
    [anon_sym_public] = ACTIONS(5423),
    [anon_sym_private] = ACTIONS(5423),
    [anon_sym_protected] = ACTIONS(5423),
    [anon_sym_using] = ACTIONS(5423),
    [anon_sym_static_assert] = ACTIONS(5423),
  },
  [2083] = {
    [sym_identifier] = ACTIONS(5462),
    [aux_sym_preproc_def_token1] = ACTIONS(5462),
    [aux_sym_preproc_if_token1] = ACTIONS(5462),
    [aux_sym_preproc_if_token2] = ACTIONS(5462),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5462),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5462),
    [sym_preproc_directive] = ACTIONS(5462),
    [anon_sym_LPAREN2] = ACTIONS(5464),
    [anon_sym_TILDE] = ACTIONS(5464),
    [anon_sym_STAR] = ACTIONS(5464),
    [anon_sym_AMP_AMP] = ACTIONS(5464),
    [anon_sym_AMP] = ACTIONS(5462),
    [anon_sym_SEMI] = ACTIONS(5464),
    [anon_sym___extension__] = ACTIONS(5462),
    [anon_sym_typedef] = ACTIONS(5462),
    [anon_sym_virtual] = ACTIONS(5462),
    [anon_sym_extern] = ACTIONS(5462),
    [anon_sym___attribute__] = ACTIONS(5462),
    [anon_sym___attribute] = ACTIONS(5462),
    [anon_sym_COLON_COLON] = ACTIONS(5464),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5464),
    [anon_sym___declspec] = ACTIONS(5462),
    [anon_sym___based] = ACTIONS(5462),
    [anon_sym_signed] = ACTIONS(5462),
    [anon_sym_unsigned] = ACTIONS(5462),
    [anon_sym_long] = ACTIONS(5462),
    [anon_sym_short] = ACTIONS(5462),
    [anon_sym_LBRACK] = ACTIONS(5462),
    [anon_sym_static] = ACTIONS(5462),
    [anon_sym_register] = ACTIONS(5462),
    [anon_sym_inline] = ACTIONS(5462),
    [anon_sym___inline] = ACTIONS(5462),
    [anon_sym___inline__] = ACTIONS(5462),
    [anon_sym___forceinline] = ACTIONS(5462),
    [anon_sym_thread_local] = ACTIONS(5462),
    [anon_sym___thread] = ACTIONS(5462),
    [anon_sym_const] = ACTIONS(5462),
    [anon_sym_constexpr] = ACTIONS(5462),
    [anon_sym_volatile] = ACTIONS(5462),
    [anon_sym_restrict] = ACTIONS(5462),
    [anon_sym___restrict__] = ACTIONS(5462),
    [anon_sym__Atomic] = ACTIONS(5462),
    [anon_sym__Noreturn] = ACTIONS(5462),
    [anon_sym_noreturn] = ACTIONS(5462),
    [anon_sym__Nonnull] = ACTIONS(5462),
    [anon_sym_mutable] = ACTIONS(5462),
    [anon_sym_constinit] = ACTIONS(5462),
    [anon_sym_consteval] = ACTIONS(5462),
    [anon_sym_alignas] = ACTIONS(5462),
    [anon_sym__Alignas] = ACTIONS(5462),
    [sym_primitive_type] = ACTIONS(5462),
    [anon_sym_enum] = ACTIONS(5462),
    [anon_sym_class] = ACTIONS(5462),
    [anon_sym_struct] = ACTIONS(5462),
    [anon_sym_union] = ACTIONS(5462),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5462),
    [anon_sym_decltype] = ACTIONS(5462),
    [anon_sym_explicit] = ACTIONS(5462),
    [anon_sym_typename] = ACTIONS(5462),
    [anon_sym_template] = ACTIONS(5462),
    [anon_sym_operator] = ACTIONS(5462),
    [anon_sym_friend] = ACTIONS(5462),
    [anon_sym_public] = ACTIONS(5462),
    [anon_sym_private] = ACTIONS(5462),
    [anon_sym_protected] = ACTIONS(5462),
    [anon_sym_using] = ACTIONS(5462),
    [anon_sym_static_assert] = ACTIONS(5462),
  },
  [2084] = {
    [sym_identifier] = ACTIONS(5490),
    [aux_sym_preproc_def_token1] = ACTIONS(5490),
    [aux_sym_preproc_if_token1] = ACTIONS(5490),
    [aux_sym_preproc_if_token2] = ACTIONS(5490),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5490),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5490),
    [sym_preproc_directive] = ACTIONS(5490),
    [anon_sym_LPAREN2] = ACTIONS(5492),
    [anon_sym_TILDE] = ACTIONS(5492),
    [anon_sym_STAR] = ACTIONS(5492),
    [anon_sym_AMP_AMP] = ACTIONS(5492),
    [anon_sym_AMP] = ACTIONS(5490),
    [anon_sym_SEMI] = ACTIONS(5492),
    [anon_sym___extension__] = ACTIONS(5490),
    [anon_sym_typedef] = ACTIONS(5490),
    [anon_sym_virtual] = ACTIONS(5490),
    [anon_sym_extern] = ACTIONS(5490),
    [anon_sym___attribute__] = ACTIONS(5490),
    [anon_sym___attribute] = ACTIONS(5490),
    [anon_sym_COLON_COLON] = ACTIONS(5492),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5492),
    [anon_sym___declspec] = ACTIONS(5490),
    [anon_sym___based] = ACTIONS(5490),
    [anon_sym_signed] = ACTIONS(5490),
    [anon_sym_unsigned] = ACTIONS(5490),
    [anon_sym_long] = ACTIONS(5490),
    [anon_sym_short] = ACTIONS(5490),
    [anon_sym_LBRACK] = ACTIONS(5490),
    [anon_sym_static] = ACTIONS(5490),
    [anon_sym_register] = ACTIONS(5490),
    [anon_sym_inline] = ACTIONS(5490),
    [anon_sym___inline] = ACTIONS(5490),
    [anon_sym___inline__] = ACTIONS(5490),
    [anon_sym___forceinline] = ACTIONS(5490),
    [anon_sym_thread_local] = ACTIONS(5490),
    [anon_sym___thread] = ACTIONS(5490),
    [anon_sym_const] = ACTIONS(5490),
    [anon_sym_constexpr] = ACTIONS(5490),
    [anon_sym_volatile] = ACTIONS(5490),
    [anon_sym_restrict] = ACTIONS(5490),
    [anon_sym___restrict__] = ACTIONS(5490),
    [anon_sym__Atomic] = ACTIONS(5490),
    [anon_sym__Noreturn] = ACTIONS(5490),
    [anon_sym_noreturn] = ACTIONS(5490),
    [anon_sym__Nonnull] = ACTIONS(5490),
    [anon_sym_mutable] = ACTIONS(5490),
    [anon_sym_constinit] = ACTIONS(5490),
    [anon_sym_consteval] = ACTIONS(5490),
    [anon_sym_alignas] = ACTIONS(5490),
    [anon_sym__Alignas] = ACTIONS(5490),
    [sym_primitive_type] = ACTIONS(5490),
    [anon_sym_enum] = ACTIONS(5490),
    [anon_sym_class] = ACTIONS(5490),
    [anon_sym_struct] = ACTIONS(5490),
    [anon_sym_union] = ACTIONS(5490),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5490),
    [anon_sym_decltype] = ACTIONS(5490),
    [anon_sym_explicit] = ACTIONS(5490),
    [anon_sym_typename] = ACTIONS(5490),
    [anon_sym_template] = ACTIONS(5490),
    [anon_sym_operator] = ACTIONS(5490),
    [anon_sym_friend] = ACTIONS(5490),
    [anon_sym_public] = ACTIONS(5490),
    [anon_sym_private] = ACTIONS(5490),
    [anon_sym_protected] = ACTIONS(5490),
    [anon_sym_using] = ACTIONS(5490),
    [anon_sym_static_assert] = ACTIONS(5490),
  },
  [2085] = {
    [sym_identifier] = ACTIONS(5439),
    [aux_sym_preproc_def_token1] = ACTIONS(5439),
    [aux_sym_preproc_if_token1] = ACTIONS(5439),
    [aux_sym_preproc_if_token2] = ACTIONS(5439),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5439),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5439),
    [sym_preproc_directive] = ACTIONS(5439),
    [anon_sym_LPAREN2] = ACTIONS(5441),
    [anon_sym_TILDE] = ACTIONS(5441),
    [anon_sym_STAR] = ACTIONS(5441),
    [anon_sym_AMP_AMP] = ACTIONS(5441),
    [anon_sym_AMP] = ACTIONS(5439),
    [anon_sym_SEMI] = ACTIONS(5441),
    [anon_sym___extension__] = ACTIONS(5439),
    [anon_sym_typedef] = ACTIONS(5439),
    [anon_sym_virtual] = ACTIONS(5439),
    [anon_sym_extern] = ACTIONS(5439),
    [anon_sym___attribute__] = ACTIONS(5439),
    [anon_sym___attribute] = ACTIONS(5439),
    [anon_sym_COLON_COLON] = ACTIONS(5441),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5441),
    [anon_sym___declspec] = ACTIONS(5439),
    [anon_sym___based] = ACTIONS(5439),
    [anon_sym_signed] = ACTIONS(5439),
    [anon_sym_unsigned] = ACTIONS(5439),
    [anon_sym_long] = ACTIONS(5439),
    [anon_sym_short] = ACTIONS(5439),
    [anon_sym_LBRACK] = ACTIONS(5439),
    [anon_sym_static] = ACTIONS(5439),
    [anon_sym_register] = ACTIONS(5439),
    [anon_sym_inline] = ACTIONS(5439),
    [anon_sym___inline] = ACTIONS(5439),
    [anon_sym___inline__] = ACTIONS(5439),
    [anon_sym___forceinline] = ACTIONS(5439),
    [anon_sym_thread_local] = ACTIONS(5439),
    [anon_sym___thread] = ACTIONS(5439),
    [anon_sym_const] = ACTIONS(5439),
    [anon_sym_constexpr] = ACTIONS(5439),
    [anon_sym_volatile] = ACTIONS(5439),
    [anon_sym_restrict] = ACTIONS(5439),
    [anon_sym___restrict__] = ACTIONS(5439),
    [anon_sym__Atomic] = ACTIONS(5439),
    [anon_sym__Noreturn] = ACTIONS(5439),
    [anon_sym_noreturn] = ACTIONS(5439),
    [anon_sym__Nonnull] = ACTIONS(5439),
    [anon_sym_mutable] = ACTIONS(5439),
    [anon_sym_constinit] = ACTIONS(5439),
    [anon_sym_consteval] = ACTIONS(5439),
    [anon_sym_alignas] = ACTIONS(5439),
    [anon_sym__Alignas] = ACTIONS(5439),
    [sym_primitive_type] = ACTIONS(5439),
    [anon_sym_enum] = ACTIONS(5439),
    [anon_sym_class] = ACTIONS(5439),
    [anon_sym_struct] = ACTIONS(5439),
    [anon_sym_union] = ACTIONS(5439),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5439),
    [anon_sym_decltype] = ACTIONS(5439),
    [anon_sym_explicit] = ACTIONS(5439),
    [anon_sym_typename] = ACTIONS(5439),
    [anon_sym_template] = ACTIONS(5439),
    [anon_sym_operator] = ACTIONS(5439),
    [anon_sym_friend] = ACTIONS(5439),
    [anon_sym_public] = ACTIONS(5439),
    [anon_sym_private] = ACTIONS(5439),
    [anon_sym_protected] = ACTIONS(5439),
    [anon_sym_using] = ACTIONS(5439),
    [anon_sym_static_assert] = ACTIONS(5439),
  },
  [2086] = {
    [sym_identifier] = ACTIONS(5439),
    [aux_sym_preproc_def_token1] = ACTIONS(5439),
    [aux_sym_preproc_if_token1] = ACTIONS(5439),
    [aux_sym_preproc_if_token2] = ACTIONS(5439),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5439),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5439),
    [sym_preproc_directive] = ACTIONS(5439),
    [anon_sym_LPAREN2] = ACTIONS(5441),
    [anon_sym_TILDE] = ACTIONS(5441),
    [anon_sym_STAR] = ACTIONS(5441),
    [anon_sym_AMP_AMP] = ACTIONS(5441),
    [anon_sym_AMP] = ACTIONS(5439),
    [anon_sym_SEMI] = ACTIONS(5441),
    [anon_sym___extension__] = ACTIONS(5439),
    [anon_sym_typedef] = ACTIONS(5439),
    [anon_sym_virtual] = ACTIONS(5439),
    [anon_sym_extern] = ACTIONS(5439),
    [anon_sym___attribute__] = ACTIONS(5439),
    [anon_sym___attribute] = ACTIONS(5439),
    [anon_sym_COLON_COLON] = ACTIONS(5441),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5441),
    [anon_sym___declspec] = ACTIONS(5439),
    [anon_sym___based] = ACTIONS(5439),
    [anon_sym_signed] = ACTIONS(5439),
    [anon_sym_unsigned] = ACTIONS(5439),
    [anon_sym_long] = ACTIONS(5439),
    [anon_sym_short] = ACTIONS(5439),
    [anon_sym_LBRACK] = ACTIONS(5439),
    [anon_sym_static] = ACTIONS(5439),
    [anon_sym_register] = ACTIONS(5439),
    [anon_sym_inline] = ACTIONS(5439),
    [anon_sym___inline] = ACTIONS(5439),
    [anon_sym___inline__] = ACTIONS(5439),
    [anon_sym___forceinline] = ACTIONS(5439),
    [anon_sym_thread_local] = ACTIONS(5439),
    [anon_sym___thread] = ACTIONS(5439),
    [anon_sym_const] = ACTIONS(5439),
    [anon_sym_constexpr] = ACTIONS(5439),
    [anon_sym_volatile] = ACTIONS(5439),
    [anon_sym_restrict] = ACTIONS(5439),
    [anon_sym___restrict__] = ACTIONS(5439),
    [anon_sym__Atomic] = ACTIONS(5439),
    [anon_sym__Noreturn] = ACTIONS(5439),
    [anon_sym_noreturn] = ACTIONS(5439),
    [anon_sym__Nonnull] = ACTIONS(5439),
    [anon_sym_mutable] = ACTIONS(5439),
    [anon_sym_constinit] = ACTIONS(5439),
    [anon_sym_consteval] = ACTIONS(5439),
    [anon_sym_alignas] = ACTIONS(5439),
    [anon_sym__Alignas] = ACTIONS(5439),
    [sym_primitive_type] = ACTIONS(5439),
    [anon_sym_enum] = ACTIONS(5439),
    [anon_sym_class] = ACTIONS(5439),
    [anon_sym_struct] = ACTIONS(5439),
    [anon_sym_union] = ACTIONS(5439),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5439),
    [anon_sym_decltype] = ACTIONS(5439),
    [anon_sym_explicit] = ACTIONS(5439),
    [anon_sym_typename] = ACTIONS(5439),
    [anon_sym_template] = ACTIONS(5439),
    [anon_sym_operator] = ACTIONS(5439),
    [anon_sym_friend] = ACTIONS(5439),
    [anon_sym_public] = ACTIONS(5439),
    [anon_sym_private] = ACTIONS(5439),
    [anon_sym_protected] = ACTIONS(5439),
    [anon_sym_using] = ACTIONS(5439),
    [anon_sym_static_assert] = ACTIONS(5439),
  },
  [2087] = {
    [sym_identifier] = ACTIONS(5458),
    [aux_sym_preproc_def_token1] = ACTIONS(5458),
    [aux_sym_preproc_if_token1] = ACTIONS(5458),
    [aux_sym_preproc_if_token2] = ACTIONS(5458),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5458),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5458),
    [sym_preproc_directive] = ACTIONS(5458),
    [anon_sym_LPAREN2] = ACTIONS(5460),
    [anon_sym_TILDE] = ACTIONS(5460),
    [anon_sym_STAR] = ACTIONS(5460),
    [anon_sym_AMP_AMP] = ACTIONS(5460),
    [anon_sym_AMP] = ACTIONS(5458),
    [anon_sym_SEMI] = ACTIONS(5460),
    [anon_sym___extension__] = ACTIONS(5458),
    [anon_sym_typedef] = ACTIONS(5458),
    [anon_sym_virtual] = ACTIONS(5458),
    [anon_sym_extern] = ACTIONS(5458),
    [anon_sym___attribute__] = ACTIONS(5458),
    [anon_sym___attribute] = ACTIONS(5458),
    [anon_sym_COLON_COLON] = ACTIONS(5460),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5460),
    [anon_sym___declspec] = ACTIONS(5458),
    [anon_sym___based] = ACTIONS(5458),
    [anon_sym_signed] = ACTIONS(5458),
    [anon_sym_unsigned] = ACTIONS(5458),
    [anon_sym_long] = ACTIONS(5458),
    [anon_sym_short] = ACTIONS(5458),
    [anon_sym_LBRACK] = ACTIONS(5458),
    [anon_sym_static] = ACTIONS(5458),
    [anon_sym_register] = ACTIONS(5458),
    [anon_sym_inline] = ACTIONS(5458),
    [anon_sym___inline] = ACTIONS(5458),
    [anon_sym___inline__] = ACTIONS(5458),
    [anon_sym___forceinline] = ACTIONS(5458),
    [anon_sym_thread_local] = ACTIONS(5458),
    [anon_sym___thread] = ACTIONS(5458),
    [anon_sym_const] = ACTIONS(5458),
    [anon_sym_constexpr] = ACTIONS(5458),
    [anon_sym_volatile] = ACTIONS(5458),
    [anon_sym_restrict] = ACTIONS(5458),
    [anon_sym___restrict__] = ACTIONS(5458),
    [anon_sym__Atomic] = ACTIONS(5458),
    [anon_sym__Noreturn] = ACTIONS(5458),
    [anon_sym_noreturn] = ACTIONS(5458),
    [anon_sym__Nonnull] = ACTIONS(5458),
    [anon_sym_mutable] = ACTIONS(5458),
    [anon_sym_constinit] = ACTIONS(5458),
    [anon_sym_consteval] = ACTIONS(5458),
    [anon_sym_alignas] = ACTIONS(5458),
    [anon_sym__Alignas] = ACTIONS(5458),
    [sym_primitive_type] = ACTIONS(5458),
    [anon_sym_enum] = ACTIONS(5458),
    [anon_sym_class] = ACTIONS(5458),
    [anon_sym_struct] = ACTIONS(5458),
    [anon_sym_union] = ACTIONS(5458),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5458),
    [anon_sym_decltype] = ACTIONS(5458),
    [anon_sym_explicit] = ACTIONS(5458),
    [anon_sym_typename] = ACTIONS(5458),
    [anon_sym_template] = ACTIONS(5458),
    [anon_sym_operator] = ACTIONS(5458),
    [anon_sym_friend] = ACTIONS(5458),
    [anon_sym_public] = ACTIONS(5458),
    [anon_sym_private] = ACTIONS(5458),
    [anon_sym_protected] = ACTIONS(5458),
    [anon_sym_using] = ACTIONS(5458),
    [anon_sym_static_assert] = ACTIONS(5458),
  },
  [2088] = {
    [sym_identifier] = ACTIONS(5466),
    [aux_sym_preproc_def_token1] = ACTIONS(5466),
    [aux_sym_preproc_if_token1] = ACTIONS(5466),
    [aux_sym_preproc_if_token2] = ACTIONS(5466),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5466),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5466),
    [sym_preproc_directive] = ACTIONS(5466),
    [anon_sym_LPAREN2] = ACTIONS(5468),
    [anon_sym_TILDE] = ACTIONS(5468),
    [anon_sym_STAR] = ACTIONS(5468),
    [anon_sym_AMP_AMP] = ACTIONS(5468),
    [anon_sym_AMP] = ACTIONS(5466),
    [anon_sym_SEMI] = ACTIONS(5468),
    [anon_sym___extension__] = ACTIONS(5466),
    [anon_sym_typedef] = ACTIONS(5466),
    [anon_sym_virtual] = ACTIONS(5466),
    [anon_sym_extern] = ACTIONS(5466),
    [anon_sym___attribute__] = ACTIONS(5466),
    [anon_sym___attribute] = ACTIONS(5466),
    [anon_sym_COLON_COLON] = ACTIONS(5468),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5468),
    [anon_sym___declspec] = ACTIONS(5466),
    [anon_sym___based] = ACTIONS(5466),
    [anon_sym_signed] = ACTIONS(5466),
    [anon_sym_unsigned] = ACTIONS(5466),
    [anon_sym_long] = ACTIONS(5466),
    [anon_sym_short] = ACTIONS(5466),
    [anon_sym_LBRACK] = ACTIONS(5466),
    [anon_sym_static] = ACTIONS(5466),
    [anon_sym_register] = ACTIONS(5466),
    [anon_sym_inline] = ACTIONS(5466),
    [anon_sym___inline] = ACTIONS(5466),
    [anon_sym___inline__] = ACTIONS(5466),
    [anon_sym___forceinline] = ACTIONS(5466),
    [anon_sym_thread_local] = ACTIONS(5466),
    [anon_sym___thread] = ACTIONS(5466),
    [anon_sym_const] = ACTIONS(5466),
    [anon_sym_constexpr] = ACTIONS(5466),
    [anon_sym_volatile] = ACTIONS(5466),
    [anon_sym_restrict] = ACTIONS(5466),
    [anon_sym___restrict__] = ACTIONS(5466),
    [anon_sym__Atomic] = ACTIONS(5466),
    [anon_sym__Noreturn] = ACTIONS(5466),
    [anon_sym_noreturn] = ACTIONS(5466),
    [anon_sym__Nonnull] = ACTIONS(5466),
    [anon_sym_mutable] = ACTIONS(5466),
    [anon_sym_constinit] = ACTIONS(5466),
    [anon_sym_consteval] = ACTIONS(5466),
    [anon_sym_alignas] = ACTIONS(5466),
    [anon_sym__Alignas] = ACTIONS(5466),
    [sym_primitive_type] = ACTIONS(5466),
    [anon_sym_enum] = ACTIONS(5466),
    [anon_sym_class] = ACTIONS(5466),
    [anon_sym_struct] = ACTIONS(5466),
    [anon_sym_union] = ACTIONS(5466),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5466),
    [anon_sym_decltype] = ACTIONS(5466),
    [anon_sym_explicit] = ACTIONS(5466),
    [anon_sym_typename] = ACTIONS(5466),
    [anon_sym_template] = ACTIONS(5466),
    [anon_sym_operator] = ACTIONS(5466),
    [anon_sym_friend] = ACTIONS(5466),
    [anon_sym_public] = ACTIONS(5466),
    [anon_sym_private] = ACTIONS(5466),
    [anon_sym_protected] = ACTIONS(5466),
    [anon_sym_using] = ACTIONS(5466),
    [anon_sym_static_assert] = ACTIONS(5466),
  },
  [2089] = {
    [sym_identifier] = ACTIONS(2681),
    [aux_sym_preproc_def_token1] = ACTIONS(2681),
    [aux_sym_preproc_if_token1] = ACTIONS(2681),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2681),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2681),
    [sym_preproc_directive] = ACTIONS(2681),
    [anon_sym_LPAREN2] = ACTIONS(2683),
    [anon_sym_TILDE] = ACTIONS(2683),
    [anon_sym_STAR] = ACTIONS(2683),
    [anon_sym_AMP_AMP] = ACTIONS(2683),
    [anon_sym_AMP] = ACTIONS(2681),
    [anon_sym_SEMI] = ACTIONS(2683),
    [anon_sym___extension__] = ACTIONS(2681),
    [anon_sym_typedef] = ACTIONS(2681),
    [anon_sym_virtual] = ACTIONS(2681),
    [anon_sym_extern] = ACTIONS(2681),
    [anon_sym___attribute__] = ACTIONS(2681),
    [anon_sym___attribute] = ACTIONS(2681),
    [anon_sym_COLON_COLON] = ACTIONS(2683),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2683),
    [anon_sym___declspec] = ACTIONS(2681),
    [anon_sym___based] = ACTIONS(2681),
    [anon_sym_RBRACE] = ACTIONS(2683),
    [anon_sym_signed] = ACTIONS(2681),
    [anon_sym_unsigned] = ACTIONS(2681),
    [anon_sym_long] = ACTIONS(2681),
    [anon_sym_short] = ACTIONS(2681),
    [anon_sym_LBRACK] = ACTIONS(2681),
    [anon_sym_static] = ACTIONS(2681),
    [anon_sym_register] = ACTIONS(2681),
    [anon_sym_inline] = ACTIONS(2681),
    [anon_sym___inline] = ACTIONS(2681),
    [anon_sym___inline__] = ACTIONS(2681),
    [anon_sym___forceinline] = ACTIONS(2681),
    [anon_sym_thread_local] = ACTIONS(2681),
    [anon_sym___thread] = ACTIONS(2681),
    [anon_sym_const] = ACTIONS(2681),
    [anon_sym_constexpr] = ACTIONS(2681),
    [anon_sym_volatile] = ACTIONS(2681),
    [anon_sym_restrict] = ACTIONS(2681),
    [anon_sym___restrict__] = ACTIONS(2681),
    [anon_sym__Atomic] = ACTIONS(2681),
    [anon_sym__Noreturn] = ACTIONS(2681),
    [anon_sym_noreturn] = ACTIONS(2681),
    [anon_sym__Nonnull] = ACTIONS(2681),
    [anon_sym_mutable] = ACTIONS(2681),
    [anon_sym_constinit] = ACTIONS(2681),
    [anon_sym_consteval] = ACTIONS(2681),
    [anon_sym_alignas] = ACTIONS(2681),
    [anon_sym__Alignas] = ACTIONS(2681),
    [sym_primitive_type] = ACTIONS(2681),
    [anon_sym_enum] = ACTIONS(2681),
    [anon_sym_class] = ACTIONS(2681),
    [anon_sym_struct] = ACTIONS(2681),
    [anon_sym_union] = ACTIONS(2681),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2681),
    [anon_sym_decltype] = ACTIONS(2681),
    [anon_sym_explicit] = ACTIONS(2681),
    [anon_sym_typename] = ACTIONS(2681),
    [anon_sym_template] = ACTIONS(2681),
    [anon_sym_operator] = ACTIONS(2681),
    [anon_sym_friend] = ACTIONS(2681),
    [anon_sym_public] = ACTIONS(2681),
    [anon_sym_private] = ACTIONS(2681),
    [anon_sym_protected] = ACTIONS(2681),
    [anon_sym_using] = ACTIONS(2681),
    [anon_sym_static_assert] = ACTIONS(2681),
  },
  [2090] = {
    [sym_identifier] = ACTIONS(5474),
    [aux_sym_preproc_def_token1] = ACTIONS(5474),
    [aux_sym_preproc_if_token1] = ACTIONS(5474),
    [aux_sym_preproc_if_token2] = ACTIONS(5474),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5474),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5474),
    [sym_preproc_directive] = ACTIONS(5474),
    [anon_sym_LPAREN2] = ACTIONS(5476),
    [anon_sym_TILDE] = ACTIONS(5476),
    [anon_sym_STAR] = ACTIONS(5476),
    [anon_sym_AMP_AMP] = ACTIONS(5476),
    [anon_sym_AMP] = ACTIONS(5474),
    [anon_sym_SEMI] = ACTIONS(5476),
    [anon_sym___extension__] = ACTIONS(5474),
    [anon_sym_typedef] = ACTIONS(5474),
    [anon_sym_virtual] = ACTIONS(5474),
    [anon_sym_extern] = ACTIONS(5474),
    [anon_sym___attribute__] = ACTIONS(5474),
    [anon_sym___attribute] = ACTIONS(5474),
    [anon_sym_COLON_COLON] = ACTIONS(5476),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5476),
    [anon_sym___declspec] = ACTIONS(5474),
    [anon_sym___based] = ACTIONS(5474),
    [anon_sym_signed] = ACTIONS(5474),
    [anon_sym_unsigned] = ACTIONS(5474),
    [anon_sym_long] = ACTIONS(5474),
    [anon_sym_short] = ACTIONS(5474),
    [anon_sym_LBRACK] = ACTIONS(5474),
    [anon_sym_static] = ACTIONS(5474),
    [anon_sym_register] = ACTIONS(5474),
    [anon_sym_inline] = ACTIONS(5474),
    [anon_sym___inline] = ACTIONS(5474),
    [anon_sym___inline__] = ACTIONS(5474),
    [anon_sym___forceinline] = ACTIONS(5474),
    [anon_sym_thread_local] = ACTIONS(5474),
    [anon_sym___thread] = ACTIONS(5474),
    [anon_sym_const] = ACTIONS(5474),
    [anon_sym_constexpr] = ACTIONS(5474),
    [anon_sym_volatile] = ACTIONS(5474),
    [anon_sym_restrict] = ACTIONS(5474),
    [anon_sym___restrict__] = ACTIONS(5474),
    [anon_sym__Atomic] = ACTIONS(5474),
    [anon_sym__Noreturn] = ACTIONS(5474),
    [anon_sym_noreturn] = ACTIONS(5474),
    [anon_sym__Nonnull] = ACTIONS(5474),
    [anon_sym_mutable] = ACTIONS(5474),
    [anon_sym_constinit] = ACTIONS(5474),
    [anon_sym_consteval] = ACTIONS(5474),
    [anon_sym_alignas] = ACTIONS(5474),
    [anon_sym__Alignas] = ACTIONS(5474),
    [sym_primitive_type] = ACTIONS(5474),
    [anon_sym_enum] = ACTIONS(5474),
    [anon_sym_class] = ACTIONS(5474),
    [anon_sym_struct] = ACTIONS(5474),
    [anon_sym_union] = ACTIONS(5474),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5474),
    [anon_sym_decltype] = ACTIONS(5474),
    [anon_sym_explicit] = ACTIONS(5474),
    [anon_sym_typename] = ACTIONS(5474),
    [anon_sym_template] = ACTIONS(5474),
    [anon_sym_operator] = ACTIONS(5474),
    [anon_sym_friend] = ACTIONS(5474),
    [anon_sym_public] = ACTIONS(5474),
    [anon_sym_private] = ACTIONS(5474),
    [anon_sym_protected] = ACTIONS(5474),
    [anon_sym_using] = ACTIONS(5474),
    [anon_sym_static_assert] = ACTIONS(5474),
  },
  [2091] = {
    [sym_identifier] = ACTIONS(5311),
    [aux_sym_preproc_def_token1] = ACTIONS(5311),
    [aux_sym_preproc_if_token1] = ACTIONS(5311),
    [aux_sym_preproc_if_token2] = ACTIONS(5311),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5311),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5311),
    [sym_preproc_directive] = ACTIONS(5311),
    [anon_sym_LPAREN2] = ACTIONS(5313),
    [anon_sym_TILDE] = ACTIONS(5313),
    [anon_sym_STAR] = ACTIONS(5313),
    [anon_sym_AMP_AMP] = ACTIONS(5313),
    [anon_sym_AMP] = ACTIONS(5311),
    [anon_sym_SEMI] = ACTIONS(5313),
    [anon_sym___extension__] = ACTIONS(5311),
    [anon_sym_typedef] = ACTIONS(5311),
    [anon_sym_virtual] = ACTIONS(5311),
    [anon_sym_extern] = ACTIONS(5311),
    [anon_sym___attribute__] = ACTIONS(5311),
    [anon_sym___attribute] = ACTIONS(5311),
    [anon_sym_COLON_COLON] = ACTIONS(5313),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5313),
    [anon_sym___declspec] = ACTIONS(5311),
    [anon_sym___based] = ACTIONS(5311),
    [anon_sym_signed] = ACTIONS(5311),
    [anon_sym_unsigned] = ACTIONS(5311),
    [anon_sym_long] = ACTIONS(5311),
    [anon_sym_short] = ACTIONS(5311),
    [anon_sym_LBRACK] = ACTIONS(5311),
    [anon_sym_static] = ACTIONS(5311),
    [anon_sym_register] = ACTIONS(5311),
    [anon_sym_inline] = ACTIONS(5311),
    [anon_sym___inline] = ACTIONS(5311),
    [anon_sym___inline__] = ACTIONS(5311),
    [anon_sym___forceinline] = ACTIONS(5311),
    [anon_sym_thread_local] = ACTIONS(5311),
    [anon_sym___thread] = ACTIONS(5311),
    [anon_sym_const] = ACTIONS(5311),
    [anon_sym_constexpr] = ACTIONS(5311),
    [anon_sym_volatile] = ACTIONS(5311),
    [anon_sym_restrict] = ACTIONS(5311),
    [anon_sym___restrict__] = ACTIONS(5311),
    [anon_sym__Atomic] = ACTIONS(5311),
    [anon_sym__Noreturn] = ACTIONS(5311),
    [anon_sym_noreturn] = ACTIONS(5311),
    [anon_sym__Nonnull] = ACTIONS(5311),
    [anon_sym_mutable] = ACTIONS(5311),
    [anon_sym_constinit] = ACTIONS(5311),
    [anon_sym_consteval] = ACTIONS(5311),
    [anon_sym_alignas] = ACTIONS(5311),
    [anon_sym__Alignas] = ACTIONS(5311),
    [sym_primitive_type] = ACTIONS(5311),
    [anon_sym_enum] = ACTIONS(5311),
    [anon_sym_class] = ACTIONS(5311),
    [anon_sym_struct] = ACTIONS(5311),
    [anon_sym_union] = ACTIONS(5311),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5311),
    [anon_sym_decltype] = ACTIONS(5311),
    [anon_sym_explicit] = ACTIONS(5311),
    [anon_sym_typename] = ACTIONS(5311),
    [anon_sym_template] = ACTIONS(5311),
    [anon_sym_operator] = ACTIONS(5311),
    [anon_sym_friend] = ACTIONS(5311),
    [anon_sym_public] = ACTIONS(5311),
    [anon_sym_private] = ACTIONS(5311),
    [anon_sym_protected] = ACTIONS(5311),
    [anon_sym_using] = ACTIONS(5311),
    [anon_sym_static_assert] = ACTIONS(5311),
  },
  [2092] = {
    [sym_identifier] = ACTIONS(5494),
    [aux_sym_preproc_def_token1] = ACTIONS(5494),
    [aux_sym_preproc_if_token1] = ACTIONS(5494),
    [aux_sym_preproc_if_token2] = ACTIONS(5494),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5494),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5494),
    [sym_preproc_directive] = ACTIONS(5494),
    [anon_sym_LPAREN2] = ACTIONS(5496),
    [anon_sym_TILDE] = ACTIONS(5496),
    [anon_sym_STAR] = ACTIONS(5496),
    [anon_sym_AMP_AMP] = ACTIONS(5496),
    [anon_sym_AMP] = ACTIONS(5494),
    [anon_sym_SEMI] = ACTIONS(5496),
    [anon_sym___extension__] = ACTIONS(5494),
    [anon_sym_typedef] = ACTIONS(5494),
    [anon_sym_virtual] = ACTIONS(5494),
    [anon_sym_extern] = ACTIONS(5494),
    [anon_sym___attribute__] = ACTIONS(5494),
    [anon_sym___attribute] = ACTIONS(5494),
    [anon_sym_COLON_COLON] = ACTIONS(5496),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5496),
    [anon_sym___declspec] = ACTIONS(5494),
    [anon_sym___based] = ACTIONS(5494),
    [anon_sym_signed] = ACTIONS(5494),
    [anon_sym_unsigned] = ACTIONS(5494),
    [anon_sym_long] = ACTIONS(5494),
    [anon_sym_short] = ACTIONS(5494),
    [anon_sym_LBRACK] = ACTIONS(5494),
    [anon_sym_static] = ACTIONS(5494),
    [anon_sym_register] = ACTIONS(5494),
    [anon_sym_inline] = ACTIONS(5494),
    [anon_sym___inline] = ACTIONS(5494),
    [anon_sym___inline__] = ACTIONS(5494),
    [anon_sym___forceinline] = ACTIONS(5494),
    [anon_sym_thread_local] = ACTIONS(5494),
    [anon_sym___thread] = ACTIONS(5494),
    [anon_sym_const] = ACTIONS(5494),
    [anon_sym_constexpr] = ACTIONS(5494),
    [anon_sym_volatile] = ACTIONS(5494),
    [anon_sym_restrict] = ACTIONS(5494),
    [anon_sym___restrict__] = ACTIONS(5494),
    [anon_sym__Atomic] = ACTIONS(5494),
    [anon_sym__Noreturn] = ACTIONS(5494),
    [anon_sym_noreturn] = ACTIONS(5494),
    [anon_sym__Nonnull] = ACTIONS(5494),
    [anon_sym_mutable] = ACTIONS(5494),
    [anon_sym_constinit] = ACTIONS(5494),
    [anon_sym_consteval] = ACTIONS(5494),
    [anon_sym_alignas] = ACTIONS(5494),
    [anon_sym__Alignas] = ACTIONS(5494),
    [sym_primitive_type] = ACTIONS(5494),
    [anon_sym_enum] = ACTIONS(5494),
    [anon_sym_class] = ACTIONS(5494),
    [anon_sym_struct] = ACTIONS(5494),
    [anon_sym_union] = ACTIONS(5494),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5494),
    [anon_sym_decltype] = ACTIONS(5494),
    [anon_sym_explicit] = ACTIONS(5494),
    [anon_sym_typename] = ACTIONS(5494),
    [anon_sym_template] = ACTIONS(5494),
    [anon_sym_operator] = ACTIONS(5494),
    [anon_sym_friend] = ACTIONS(5494),
    [anon_sym_public] = ACTIONS(5494),
    [anon_sym_private] = ACTIONS(5494),
    [anon_sym_protected] = ACTIONS(5494),
    [anon_sym_using] = ACTIONS(5494),
    [anon_sym_static_assert] = ACTIONS(5494),
  },
  [2093] = {
    [sym_identifier] = ACTIONS(5315),
    [aux_sym_preproc_def_token1] = ACTIONS(5315),
    [aux_sym_preproc_if_token1] = ACTIONS(5315),
    [aux_sym_preproc_if_token2] = ACTIONS(5315),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5315),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5315),
    [sym_preproc_directive] = ACTIONS(5315),
    [anon_sym_LPAREN2] = ACTIONS(5317),
    [anon_sym_TILDE] = ACTIONS(5317),
    [anon_sym_STAR] = ACTIONS(5317),
    [anon_sym_AMP_AMP] = ACTIONS(5317),
    [anon_sym_AMP] = ACTIONS(5315),
    [anon_sym_SEMI] = ACTIONS(5317),
    [anon_sym___extension__] = ACTIONS(5315),
    [anon_sym_typedef] = ACTIONS(5315),
    [anon_sym_virtual] = ACTIONS(5315),
    [anon_sym_extern] = ACTIONS(5315),
    [anon_sym___attribute__] = ACTIONS(5315),
    [anon_sym___attribute] = ACTIONS(5315),
    [anon_sym_COLON_COLON] = ACTIONS(5317),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5317),
    [anon_sym___declspec] = ACTIONS(5315),
    [anon_sym___based] = ACTIONS(5315),
    [anon_sym_signed] = ACTIONS(5315),
    [anon_sym_unsigned] = ACTIONS(5315),
    [anon_sym_long] = ACTIONS(5315),
    [anon_sym_short] = ACTIONS(5315),
    [anon_sym_LBRACK] = ACTIONS(5315),
    [anon_sym_static] = ACTIONS(5315),
    [anon_sym_register] = ACTIONS(5315),
    [anon_sym_inline] = ACTIONS(5315),
    [anon_sym___inline] = ACTIONS(5315),
    [anon_sym___inline__] = ACTIONS(5315),
    [anon_sym___forceinline] = ACTIONS(5315),
    [anon_sym_thread_local] = ACTIONS(5315),
    [anon_sym___thread] = ACTIONS(5315),
    [anon_sym_const] = ACTIONS(5315),
    [anon_sym_constexpr] = ACTIONS(5315),
    [anon_sym_volatile] = ACTIONS(5315),
    [anon_sym_restrict] = ACTIONS(5315),
    [anon_sym___restrict__] = ACTIONS(5315),
    [anon_sym__Atomic] = ACTIONS(5315),
    [anon_sym__Noreturn] = ACTIONS(5315),
    [anon_sym_noreturn] = ACTIONS(5315),
    [anon_sym__Nonnull] = ACTIONS(5315),
    [anon_sym_mutable] = ACTIONS(5315),
    [anon_sym_constinit] = ACTIONS(5315),
    [anon_sym_consteval] = ACTIONS(5315),
    [anon_sym_alignas] = ACTIONS(5315),
    [anon_sym__Alignas] = ACTIONS(5315),
    [sym_primitive_type] = ACTIONS(5315),
    [anon_sym_enum] = ACTIONS(5315),
    [anon_sym_class] = ACTIONS(5315),
    [anon_sym_struct] = ACTIONS(5315),
    [anon_sym_union] = ACTIONS(5315),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5315),
    [anon_sym_decltype] = ACTIONS(5315),
    [anon_sym_explicit] = ACTIONS(5315),
    [anon_sym_typename] = ACTIONS(5315),
    [anon_sym_template] = ACTIONS(5315),
    [anon_sym_operator] = ACTIONS(5315),
    [anon_sym_friend] = ACTIONS(5315),
    [anon_sym_public] = ACTIONS(5315),
    [anon_sym_private] = ACTIONS(5315),
    [anon_sym_protected] = ACTIONS(5315),
    [anon_sym_using] = ACTIONS(5315),
    [anon_sym_static_assert] = ACTIONS(5315),
  },
  [2094] = {
    [sym_identifier] = ACTIONS(5319),
    [aux_sym_preproc_def_token1] = ACTIONS(5319),
    [aux_sym_preproc_if_token1] = ACTIONS(5319),
    [aux_sym_preproc_if_token2] = ACTIONS(5319),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5319),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5319),
    [sym_preproc_directive] = ACTIONS(5319),
    [anon_sym_LPAREN2] = ACTIONS(5321),
    [anon_sym_TILDE] = ACTIONS(5321),
    [anon_sym_STAR] = ACTIONS(5321),
    [anon_sym_AMP_AMP] = ACTIONS(5321),
    [anon_sym_AMP] = ACTIONS(5319),
    [anon_sym_SEMI] = ACTIONS(5321),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_typedef] = ACTIONS(5319),
    [anon_sym_virtual] = ACTIONS(5319),
    [anon_sym_extern] = ACTIONS(5319),
    [anon_sym___attribute__] = ACTIONS(5319),
    [anon_sym___attribute] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(5321),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5321),
    [anon_sym___declspec] = ACTIONS(5319),
    [anon_sym___based] = ACTIONS(5319),
    [anon_sym_signed] = ACTIONS(5319),
    [anon_sym_unsigned] = ACTIONS(5319),
    [anon_sym_long] = ACTIONS(5319),
    [anon_sym_short] = ACTIONS(5319),
    [anon_sym_LBRACK] = ACTIONS(5319),
    [anon_sym_static] = ACTIONS(5319),
    [anon_sym_register] = ACTIONS(5319),
    [anon_sym_inline] = ACTIONS(5319),
    [anon_sym___inline] = ACTIONS(5319),
    [anon_sym___inline__] = ACTIONS(5319),
    [anon_sym___forceinline] = ACTIONS(5319),
    [anon_sym_thread_local] = ACTIONS(5319),
    [anon_sym___thread] = ACTIONS(5319),
    [anon_sym_const] = ACTIONS(5319),
    [anon_sym_constexpr] = ACTIONS(5319),
    [anon_sym_volatile] = ACTIONS(5319),
    [anon_sym_restrict] = ACTIONS(5319),
    [anon_sym___restrict__] = ACTIONS(5319),
    [anon_sym__Atomic] = ACTIONS(5319),
    [anon_sym__Noreturn] = ACTIONS(5319),
    [anon_sym_noreturn] = ACTIONS(5319),
    [anon_sym__Nonnull] = ACTIONS(5319),
    [anon_sym_mutable] = ACTIONS(5319),
    [anon_sym_constinit] = ACTIONS(5319),
    [anon_sym_consteval] = ACTIONS(5319),
    [anon_sym_alignas] = ACTIONS(5319),
    [anon_sym__Alignas] = ACTIONS(5319),
    [sym_primitive_type] = ACTIONS(5319),
    [anon_sym_enum] = ACTIONS(5319),
    [anon_sym_class] = ACTIONS(5319),
    [anon_sym_struct] = ACTIONS(5319),
    [anon_sym_union] = ACTIONS(5319),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5319),
    [anon_sym_decltype] = ACTIONS(5319),
    [anon_sym_explicit] = ACTIONS(5319),
    [anon_sym_typename] = ACTIONS(5319),
    [anon_sym_template] = ACTIONS(5319),
    [anon_sym_operator] = ACTIONS(5319),
    [anon_sym_friend] = ACTIONS(5319),
    [anon_sym_public] = ACTIONS(5319),
    [anon_sym_private] = ACTIONS(5319),
    [anon_sym_protected] = ACTIONS(5319),
    [anon_sym_using] = ACTIONS(5319),
    [anon_sym_static_assert] = ACTIONS(5319),
  },
  [2095] = {
    [sym_identifier] = ACTIONS(2980),
    [aux_sym_preproc_def_token1] = ACTIONS(2980),
    [aux_sym_preproc_if_token1] = ACTIONS(2980),
    [aux_sym_preproc_if_token2] = ACTIONS(2980),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2980),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2980),
    [sym_preproc_directive] = ACTIONS(2980),
    [anon_sym_LPAREN2] = ACTIONS(2982),
    [anon_sym_TILDE] = ACTIONS(2982),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP_AMP] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2980),
    [anon_sym_SEMI] = ACTIONS(2982),
    [anon_sym___extension__] = ACTIONS(2980),
    [anon_sym_typedef] = ACTIONS(2980),
    [anon_sym_virtual] = ACTIONS(2980),
    [anon_sym_extern] = ACTIONS(2980),
    [anon_sym___attribute__] = ACTIONS(2980),
    [anon_sym___attribute] = ACTIONS(2980),
    [anon_sym_COLON_COLON] = ACTIONS(2982),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2982),
    [anon_sym___declspec] = ACTIONS(2980),
    [anon_sym___based] = ACTIONS(2980),
    [anon_sym_signed] = ACTIONS(2980),
    [anon_sym_unsigned] = ACTIONS(2980),
    [anon_sym_long] = ACTIONS(2980),
    [anon_sym_short] = ACTIONS(2980),
    [anon_sym_LBRACK] = ACTIONS(2980),
    [anon_sym_static] = ACTIONS(2980),
    [anon_sym_register] = ACTIONS(2980),
    [anon_sym_inline] = ACTIONS(2980),
    [anon_sym___inline] = ACTIONS(2980),
    [anon_sym___inline__] = ACTIONS(2980),
    [anon_sym___forceinline] = ACTIONS(2980),
    [anon_sym_thread_local] = ACTIONS(2980),
    [anon_sym___thread] = ACTIONS(2980),
    [anon_sym_const] = ACTIONS(2980),
    [anon_sym_constexpr] = ACTIONS(2980),
    [anon_sym_volatile] = ACTIONS(2980),
    [anon_sym_restrict] = ACTIONS(2980),
    [anon_sym___restrict__] = ACTIONS(2980),
    [anon_sym__Atomic] = ACTIONS(2980),
    [anon_sym__Noreturn] = ACTIONS(2980),
    [anon_sym_noreturn] = ACTIONS(2980),
    [anon_sym__Nonnull] = ACTIONS(2980),
    [anon_sym_mutable] = ACTIONS(2980),
    [anon_sym_constinit] = ACTIONS(2980),
    [anon_sym_consteval] = ACTIONS(2980),
    [anon_sym_alignas] = ACTIONS(2980),
    [anon_sym__Alignas] = ACTIONS(2980),
    [sym_primitive_type] = ACTIONS(2980),
    [anon_sym_enum] = ACTIONS(2980),
    [anon_sym_class] = ACTIONS(2980),
    [anon_sym_struct] = ACTIONS(2980),
    [anon_sym_union] = ACTIONS(2980),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2980),
    [anon_sym_decltype] = ACTIONS(2980),
    [anon_sym_explicit] = ACTIONS(2980),
    [anon_sym_typename] = ACTIONS(2980),
    [anon_sym_template] = ACTIONS(2980),
    [anon_sym_operator] = ACTIONS(2980),
    [anon_sym_friend] = ACTIONS(2980),
    [anon_sym_public] = ACTIONS(2980),
    [anon_sym_private] = ACTIONS(2980),
    [anon_sym_protected] = ACTIONS(2980),
    [anon_sym_using] = ACTIONS(2980),
    [anon_sym_static_assert] = ACTIONS(2980),
  },
  [2096] = {
    [sym_identifier] = ACTIONS(5323),
    [aux_sym_preproc_def_token1] = ACTIONS(5323),
    [aux_sym_preproc_if_token1] = ACTIONS(5323),
    [aux_sym_preproc_if_token2] = ACTIONS(5323),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5323),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5323),
    [sym_preproc_directive] = ACTIONS(5323),
    [anon_sym_LPAREN2] = ACTIONS(5325),
    [anon_sym_TILDE] = ACTIONS(5325),
    [anon_sym_STAR] = ACTIONS(5325),
    [anon_sym_AMP_AMP] = ACTIONS(5325),
    [anon_sym_AMP] = ACTIONS(5323),
    [anon_sym_SEMI] = ACTIONS(5325),
    [anon_sym___extension__] = ACTIONS(5323),
    [anon_sym_typedef] = ACTIONS(5323),
    [anon_sym_virtual] = ACTIONS(5323),
    [anon_sym_extern] = ACTIONS(5323),
    [anon_sym___attribute__] = ACTIONS(5323),
    [anon_sym___attribute] = ACTIONS(5323),
    [anon_sym_COLON_COLON] = ACTIONS(5325),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5325),
    [anon_sym___declspec] = ACTIONS(5323),
    [anon_sym___based] = ACTIONS(5323),
    [anon_sym_signed] = ACTIONS(5323),
    [anon_sym_unsigned] = ACTIONS(5323),
    [anon_sym_long] = ACTIONS(5323),
    [anon_sym_short] = ACTIONS(5323),
    [anon_sym_LBRACK] = ACTIONS(5323),
    [anon_sym_static] = ACTIONS(5323),
    [anon_sym_register] = ACTIONS(5323),
    [anon_sym_inline] = ACTIONS(5323),
    [anon_sym___inline] = ACTIONS(5323),
    [anon_sym___inline__] = ACTIONS(5323),
    [anon_sym___forceinline] = ACTIONS(5323),
    [anon_sym_thread_local] = ACTIONS(5323),
    [anon_sym___thread] = ACTIONS(5323),
    [anon_sym_const] = ACTIONS(5323),
    [anon_sym_constexpr] = ACTIONS(5323),
    [anon_sym_volatile] = ACTIONS(5323),
    [anon_sym_restrict] = ACTIONS(5323),
    [anon_sym___restrict__] = ACTIONS(5323),
    [anon_sym__Atomic] = ACTIONS(5323),
    [anon_sym__Noreturn] = ACTIONS(5323),
    [anon_sym_noreturn] = ACTIONS(5323),
    [anon_sym__Nonnull] = ACTIONS(5323),
    [anon_sym_mutable] = ACTIONS(5323),
    [anon_sym_constinit] = ACTIONS(5323),
    [anon_sym_consteval] = ACTIONS(5323),
    [anon_sym_alignas] = ACTIONS(5323),
    [anon_sym__Alignas] = ACTIONS(5323),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_enum] = ACTIONS(5323),
    [anon_sym_class] = ACTIONS(5323),
    [anon_sym_struct] = ACTIONS(5323),
    [anon_sym_union] = ACTIONS(5323),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5323),
    [anon_sym_decltype] = ACTIONS(5323),
    [anon_sym_explicit] = ACTIONS(5323),
    [anon_sym_typename] = ACTIONS(5323),
    [anon_sym_template] = ACTIONS(5323),
    [anon_sym_operator] = ACTIONS(5323),
    [anon_sym_friend] = ACTIONS(5323),
    [anon_sym_public] = ACTIONS(5323),
    [anon_sym_private] = ACTIONS(5323),
    [anon_sym_protected] = ACTIONS(5323),
    [anon_sym_using] = ACTIONS(5323),
    [anon_sym_static_assert] = ACTIONS(5323),
  },
  [2097] = {
    [sym_identifier] = ACTIONS(5319),
    [aux_sym_preproc_def_token1] = ACTIONS(5319),
    [aux_sym_preproc_if_token1] = ACTIONS(5319),
    [aux_sym_preproc_if_token2] = ACTIONS(5319),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5319),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5319),
    [sym_preproc_directive] = ACTIONS(5319),
    [anon_sym_LPAREN2] = ACTIONS(5321),
    [anon_sym_TILDE] = ACTIONS(5321),
    [anon_sym_STAR] = ACTIONS(5321),
    [anon_sym_AMP_AMP] = ACTIONS(5321),
    [anon_sym_AMP] = ACTIONS(5319),
    [anon_sym_SEMI] = ACTIONS(5321),
    [anon_sym___extension__] = ACTIONS(5319),
    [anon_sym_typedef] = ACTIONS(5319),
    [anon_sym_virtual] = ACTIONS(5319),
    [anon_sym_extern] = ACTIONS(5319),
    [anon_sym___attribute__] = ACTIONS(5319),
    [anon_sym___attribute] = ACTIONS(5319),
    [anon_sym_COLON_COLON] = ACTIONS(5321),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5321),
    [anon_sym___declspec] = ACTIONS(5319),
    [anon_sym___based] = ACTIONS(5319),
    [anon_sym_signed] = ACTIONS(5319),
    [anon_sym_unsigned] = ACTIONS(5319),
    [anon_sym_long] = ACTIONS(5319),
    [anon_sym_short] = ACTIONS(5319),
    [anon_sym_LBRACK] = ACTIONS(5319),
    [anon_sym_static] = ACTIONS(5319),
    [anon_sym_register] = ACTIONS(5319),
    [anon_sym_inline] = ACTIONS(5319),
    [anon_sym___inline] = ACTIONS(5319),
    [anon_sym___inline__] = ACTIONS(5319),
    [anon_sym___forceinline] = ACTIONS(5319),
    [anon_sym_thread_local] = ACTIONS(5319),
    [anon_sym___thread] = ACTIONS(5319),
    [anon_sym_const] = ACTIONS(5319),
    [anon_sym_constexpr] = ACTIONS(5319),
    [anon_sym_volatile] = ACTIONS(5319),
    [anon_sym_restrict] = ACTIONS(5319),
    [anon_sym___restrict__] = ACTIONS(5319),
    [anon_sym__Atomic] = ACTIONS(5319),
    [anon_sym__Noreturn] = ACTIONS(5319),
    [anon_sym_noreturn] = ACTIONS(5319),
    [anon_sym__Nonnull] = ACTIONS(5319),
    [anon_sym_mutable] = ACTIONS(5319),
    [anon_sym_constinit] = ACTIONS(5319),
    [anon_sym_consteval] = ACTIONS(5319),
    [anon_sym_alignas] = ACTIONS(5319),
    [anon_sym__Alignas] = ACTIONS(5319),
    [sym_primitive_type] = ACTIONS(5319),
    [anon_sym_enum] = ACTIONS(5319),
    [anon_sym_class] = ACTIONS(5319),
    [anon_sym_struct] = ACTIONS(5319),
    [anon_sym_union] = ACTIONS(5319),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5319),
    [anon_sym_decltype] = ACTIONS(5319),
    [anon_sym_explicit] = ACTIONS(5319),
    [anon_sym_typename] = ACTIONS(5319),
    [anon_sym_template] = ACTIONS(5319),
    [anon_sym_operator] = ACTIONS(5319),
    [anon_sym_friend] = ACTIONS(5319),
    [anon_sym_public] = ACTIONS(5319),
    [anon_sym_private] = ACTIONS(5319),
    [anon_sym_protected] = ACTIONS(5319),
    [anon_sym_using] = ACTIONS(5319),
    [anon_sym_static_assert] = ACTIONS(5319),
  },
  [2098] = {
    [sym_identifier] = ACTIONS(2980),
    [aux_sym_preproc_def_token1] = ACTIONS(2980),
    [aux_sym_preproc_if_token1] = ACTIONS(2980),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2980),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2980),
    [sym_preproc_directive] = ACTIONS(2980),
    [anon_sym_LPAREN2] = ACTIONS(2982),
    [anon_sym_TILDE] = ACTIONS(2982),
    [anon_sym_STAR] = ACTIONS(2982),
    [anon_sym_AMP_AMP] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2980),
    [anon_sym_SEMI] = ACTIONS(2982),
    [anon_sym___extension__] = ACTIONS(2980),
    [anon_sym_typedef] = ACTIONS(2980),
    [anon_sym_virtual] = ACTIONS(2980),
    [anon_sym_extern] = ACTIONS(2980),
    [anon_sym___attribute__] = ACTIONS(2980),
    [anon_sym___attribute] = ACTIONS(2980),
    [anon_sym_COLON_COLON] = ACTIONS(2982),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2982),
    [anon_sym___declspec] = ACTIONS(2980),
    [anon_sym___based] = ACTIONS(2980),
    [anon_sym_RBRACE] = ACTIONS(2982),
    [anon_sym_signed] = ACTIONS(2980),
    [anon_sym_unsigned] = ACTIONS(2980),
    [anon_sym_long] = ACTIONS(2980),
    [anon_sym_short] = ACTIONS(2980),
    [anon_sym_LBRACK] = ACTIONS(2980),
    [anon_sym_static] = ACTIONS(2980),
    [anon_sym_register] = ACTIONS(2980),
    [anon_sym_inline] = ACTIONS(2980),
    [anon_sym___inline] = ACTIONS(2980),
    [anon_sym___inline__] = ACTIONS(2980),
    [anon_sym___forceinline] = ACTIONS(2980),
    [anon_sym_thread_local] = ACTIONS(2980),
    [anon_sym___thread] = ACTIONS(2980),
    [anon_sym_const] = ACTIONS(2980),
    [anon_sym_constexpr] = ACTIONS(2980),
    [anon_sym_volatile] = ACTIONS(2980),
    [anon_sym_restrict] = ACTIONS(2980),
    [anon_sym___restrict__] = ACTIONS(2980),
    [anon_sym__Atomic] = ACTIONS(2980),
    [anon_sym__Noreturn] = ACTIONS(2980),
    [anon_sym_noreturn] = ACTIONS(2980),
    [anon_sym__Nonnull] = ACTIONS(2980),
    [anon_sym_mutable] = ACTIONS(2980),
    [anon_sym_constinit] = ACTIONS(2980),
    [anon_sym_consteval] = ACTIONS(2980),
    [anon_sym_alignas] = ACTIONS(2980),
    [anon_sym__Alignas] = ACTIONS(2980),
    [sym_primitive_type] = ACTIONS(2980),
    [anon_sym_enum] = ACTIONS(2980),
    [anon_sym_class] = ACTIONS(2980),
    [anon_sym_struct] = ACTIONS(2980),
    [anon_sym_union] = ACTIONS(2980),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2980),
    [anon_sym_decltype] = ACTIONS(2980),
    [anon_sym_explicit] = ACTIONS(2980),
    [anon_sym_typename] = ACTIONS(2980),
    [anon_sym_template] = ACTIONS(2980),
    [anon_sym_operator] = ACTIONS(2980),
    [anon_sym_friend] = ACTIONS(2980),
    [anon_sym_public] = ACTIONS(2980),
    [anon_sym_private] = ACTIONS(2980),
    [anon_sym_protected] = ACTIONS(2980),
    [anon_sym_using] = ACTIONS(2980),
    [anon_sym_static_assert] = ACTIONS(2980),
  },
  [2099] = {
    [sym_template_argument_list] = STATE(1570),
    [sym_identifier] = ACTIONS(5720),
    [anon_sym_LPAREN2] = ACTIONS(4059),
    [anon_sym_TILDE] = ACTIONS(4059),
    [anon_sym_STAR] = ACTIONS(4059),
    [anon_sym_PIPE_PIPE] = ACTIONS(4059),
    [anon_sym_AMP_AMP] = ACTIONS(4059),
    [anon_sym_AMP] = ACTIONS(5720),
    [anon_sym_LT] = ACTIONS(5882),
    [anon_sym___extension__] = ACTIONS(5720),
    [anon_sym_virtual] = ACTIONS(5720),
    [anon_sym_extern] = ACTIONS(5720),
    [anon_sym___attribute__] = ACTIONS(5720),
    [anon_sym___attribute] = ACTIONS(5720),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4059),
    [anon_sym___declspec] = ACTIONS(5720),
    [anon_sym___based] = ACTIONS(5720),
    [anon_sym___cdecl] = ACTIONS(5720),
    [anon_sym___clrcall] = ACTIONS(5720),
    [anon_sym___stdcall] = ACTIONS(5720),
    [anon_sym___fastcall] = ACTIONS(5720),
    [anon_sym___thiscall] = ACTIONS(5720),
    [anon_sym___vectorcall] = ACTIONS(5720),
    [anon_sym_signed] = ACTIONS(5720),
    [anon_sym_unsigned] = ACTIONS(5720),
    [anon_sym_long] = ACTIONS(5720),
    [anon_sym_short] = ACTIONS(5720),
    [anon_sym_LBRACK] = ACTIONS(5720),
    [anon_sym_static] = ACTIONS(5720),
    [anon_sym_register] = ACTIONS(5720),
    [anon_sym_inline] = ACTIONS(5720),
    [anon_sym___inline] = ACTIONS(5720),
    [anon_sym___inline__] = ACTIONS(5720),
    [anon_sym___forceinline] = ACTIONS(5720),
    [anon_sym_thread_local] = ACTIONS(5720),
    [anon_sym___thread] = ACTIONS(5720),
    [anon_sym_const] = ACTIONS(5720),
    [anon_sym_constexpr] = ACTIONS(5720),
    [anon_sym_volatile] = ACTIONS(5720),
    [anon_sym_restrict] = ACTIONS(5720),
    [anon_sym___restrict__] = ACTIONS(5720),
    [anon_sym__Atomic] = ACTIONS(5720),
    [anon_sym__Noreturn] = ACTIONS(5720),
    [anon_sym_noreturn] = ACTIONS(5720),
    [anon_sym__Nonnull] = ACTIONS(5720),
    [anon_sym_mutable] = ACTIONS(5720),
    [anon_sym_constinit] = ACTIONS(5720),
    [anon_sym_consteval] = ACTIONS(5720),
    [anon_sym_alignas] = ACTIONS(5720),
    [anon_sym__Alignas] = ACTIONS(5720),
    [sym_primitive_type] = ACTIONS(5720),
    [anon_sym_enum] = ACTIONS(5720),
    [anon_sym_class] = ACTIONS(5720),
    [anon_sym_struct] = ACTIONS(5720),
    [anon_sym_union] = ACTIONS(5720),
    [anon_sym_or] = ACTIONS(5720),
    [anon_sym_and] = ACTIONS(5720),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5720),
    [anon_sym_decltype] = ACTIONS(5720),
    [anon_sym_explicit] = ACTIONS(5720),
    [anon_sym_typename] = ACTIONS(5720),
    [anon_sym_template] = ACTIONS(5720),
    [anon_sym_operator] = ACTIONS(5720),
    [anon_sym_friend] = ACTIONS(5720),
    [anon_sym_using] = ACTIONS(5720),
    [anon_sym_concept] = ACTIONS(5720),
  },
  [2100] = {
    [sym_identifier] = ACTIONS(5323),
    [aux_sym_preproc_def_token1] = ACTIONS(5323),
    [aux_sym_preproc_if_token1] = ACTIONS(5323),
    [aux_sym_preproc_if_token2] = ACTIONS(5323),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5323),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5323),
    [sym_preproc_directive] = ACTIONS(5323),
    [anon_sym_LPAREN2] = ACTIONS(5325),
    [anon_sym_TILDE] = ACTIONS(5325),
    [anon_sym_STAR] = ACTIONS(5325),
    [anon_sym_AMP_AMP] = ACTIONS(5325),
    [anon_sym_AMP] = ACTIONS(5323),
    [anon_sym_SEMI] = ACTIONS(5325),
    [anon_sym___extension__] = ACTIONS(5323),
    [anon_sym_typedef] = ACTIONS(5323),
    [anon_sym_virtual] = ACTIONS(5323),
    [anon_sym_extern] = ACTIONS(5323),
    [anon_sym___attribute__] = ACTIONS(5323),
    [anon_sym___attribute] = ACTIONS(5323),
    [anon_sym_COLON_COLON] = ACTIONS(5325),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5325),
    [anon_sym___declspec] = ACTIONS(5323),
    [anon_sym___based] = ACTIONS(5323),
    [anon_sym_signed] = ACTIONS(5323),
    [anon_sym_unsigned] = ACTIONS(5323),
    [anon_sym_long] = ACTIONS(5323),
    [anon_sym_short] = ACTIONS(5323),
    [anon_sym_LBRACK] = ACTIONS(5323),
    [anon_sym_static] = ACTIONS(5323),
    [anon_sym_register] = ACTIONS(5323),
    [anon_sym_inline] = ACTIONS(5323),
    [anon_sym___inline] = ACTIONS(5323),
    [anon_sym___inline__] = ACTIONS(5323),
    [anon_sym___forceinline] = ACTIONS(5323),
    [anon_sym_thread_local] = ACTIONS(5323),
    [anon_sym___thread] = ACTIONS(5323),
    [anon_sym_const] = ACTIONS(5323),
    [anon_sym_constexpr] = ACTIONS(5323),
    [anon_sym_volatile] = ACTIONS(5323),
    [anon_sym_restrict] = ACTIONS(5323),
    [anon_sym___restrict__] = ACTIONS(5323),
    [anon_sym__Atomic] = ACTIONS(5323),
    [anon_sym__Noreturn] = ACTIONS(5323),
    [anon_sym_noreturn] = ACTIONS(5323),
    [anon_sym__Nonnull] = ACTIONS(5323),
    [anon_sym_mutable] = ACTIONS(5323),
    [anon_sym_constinit] = ACTIONS(5323),
    [anon_sym_consteval] = ACTIONS(5323),
    [anon_sym_alignas] = ACTIONS(5323),
    [anon_sym__Alignas] = ACTIONS(5323),
    [sym_primitive_type] = ACTIONS(5323),
    [anon_sym_enum] = ACTIONS(5323),
    [anon_sym_class] = ACTIONS(5323),
    [anon_sym_struct] = ACTIONS(5323),
    [anon_sym_union] = ACTIONS(5323),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5323),
    [anon_sym_decltype] = ACTIONS(5323),
    [anon_sym_explicit] = ACTIONS(5323),
    [anon_sym_typename] = ACTIONS(5323),
    [anon_sym_template] = ACTIONS(5323),
    [anon_sym_operator] = ACTIONS(5323),
    [anon_sym_friend] = ACTIONS(5323),
    [anon_sym_public] = ACTIONS(5323),
    [anon_sym_private] = ACTIONS(5323),
    [anon_sym_protected] = ACTIONS(5323),
    [anon_sym_using] = ACTIONS(5323),
    [anon_sym_static_assert] = ACTIONS(5323),
  },
  [2101] = {
    [sym_identifier] = ACTIONS(5345),
    [aux_sym_preproc_def_token1] = ACTIONS(5345),
    [aux_sym_preproc_if_token1] = ACTIONS(5345),
    [aux_sym_preproc_if_token2] = ACTIONS(5345),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5345),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5345),
    [sym_preproc_directive] = ACTIONS(5345),
    [anon_sym_LPAREN2] = ACTIONS(5347),
    [anon_sym_TILDE] = ACTIONS(5347),
    [anon_sym_STAR] = ACTIONS(5347),
    [anon_sym_AMP_AMP] = ACTIONS(5347),
    [anon_sym_AMP] = ACTIONS(5345),
    [anon_sym_SEMI] = ACTIONS(5347),
    [anon_sym___extension__] = ACTIONS(5345),
    [anon_sym_typedef] = ACTIONS(5345),
    [anon_sym_virtual] = ACTIONS(5345),
    [anon_sym_extern] = ACTIONS(5345),
    [anon_sym___attribute__] = ACTIONS(5345),
    [anon_sym___attribute] = ACTIONS(5345),
    [anon_sym_COLON_COLON] = ACTIONS(5347),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5347),
    [anon_sym___declspec] = ACTIONS(5345),
    [anon_sym___based] = ACTIONS(5345),
    [anon_sym_signed] = ACTIONS(5345),
    [anon_sym_unsigned] = ACTIONS(5345),
    [anon_sym_long] = ACTIONS(5345),
    [anon_sym_short] = ACTIONS(5345),
    [anon_sym_LBRACK] = ACTIONS(5345),
    [anon_sym_static] = ACTIONS(5345),
    [anon_sym_register] = ACTIONS(5345),
    [anon_sym_inline] = ACTIONS(5345),
    [anon_sym___inline] = ACTIONS(5345),
    [anon_sym___inline__] = ACTIONS(5345),
    [anon_sym___forceinline] = ACTIONS(5345),
    [anon_sym_thread_local] = ACTIONS(5345),
    [anon_sym___thread] = ACTIONS(5345),
    [anon_sym_const] = ACTIONS(5345),
    [anon_sym_constexpr] = ACTIONS(5345),
    [anon_sym_volatile] = ACTIONS(5345),
    [anon_sym_restrict] = ACTIONS(5345),
    [anon_sym___restrict__] = ACTIONS(5345),
    [anon_sym__Atomic] = ACTIONS(5345),
    [anon_sym__Noreturn] = ACTIONS(5345),
    [anon_sym_noreturn] = ACTIONS(5345),
    [anon_sym__Nonnull] = ACTIONS(5345),
    [anon_sym_mutable] = ACTIONS(5345),
    [anon_sym_constinit] = ACTIONS(5345),
    [anon_sym_consteval] = ACTIONS(5345),
    [anon_sym_alignas] = ACTIONS(5345),
    [anon_sym__Alignas] = ACTIONS(5345),
    [sym_primitive_type] = ACTIONS(5345),
    [anon_sym_enum] = ACTIONS(5345),
    [anon_sym_class] = ACTIONS(5345),
    [anon_sym_struct] = ACTIONS(5345),
    [anon_sym_union] = ACTIONS(5345),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5345),
    [anon_sym_decltype] = ACTIONS(5345),
    [anon_sym_explicit] = ACTIONS(5345),
    [anon_sym_typename] = ACTIONS(5345),
    [anon_sym_template] = ACTIONS(5345),
    [anon_sym_operator] = ACTIONS(5345),
    [anon_sym_friend] = ACTIONS(5345),
    [anon_sym_public] = ACTIONS(5345),
    [anon_sym_private] = ACTIONS(5345),
    [anon_sym_protected] = ACTIONS(5345),
    [anon_sym_using] = ACTIONS(5345),
    [anon_sym_static_assert] = ACTIONS(5345),
  },
  [2102] = {
    [sym_identifier] = ACTIONS(3094),
    [aux_sym_preproc_def_token1] = ACTIONS(3094),
    [aux_sym_preproc_if_token1] = ACTIONS(3094),
    [aux_sym_preproc_if_token2] = ACTIONS(3094),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3094),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3094),
    [sym_preproc_directive] = ACTIONS(3094),
    [anon_sym_LPAREN2] = ACTIONS(3096),
    [anon_sym_TILDE] = ACTIONS(3096),
    [anon_sym_STAR] = ACTIONS(3096),
    [anon_sym_AMP_AMP] = ACTIONS(3096),
    [anon_sym_AMP] = ACTIONS(3094),
    [anon_sym_SEMI] = ACTIONS(3096),
    [anon_sym___extension__] = ACTIONS(3094),
    [anon_sym_typedef] = ACTIONS(3094),
    [anon_sym_virtual] = ACTIONS(3094),
    [anon_sym_extern] = ACTIONS(3094),
    [anon_sym___attribute__] = ACTIONS(3094),
    [anon_sym___attribute] = ACTIONS(3094),
    [anon_sym_COLON_COLON] = ACTIONS(3096),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3096),
    [anon_sym___declspec] = ACTIONS(3094),
    [anon_sym___based] = ACTIONS(3094),
    [anon_sym_signed] = ACTIONS(3094),
    [anon_sym_unsigned] = ACTIONS(3094),
    [anon_sym_long] = ACTIONS(3094),
    [anon_sym_short] = ACTIONS(3094),
    [anon_sym_LBRACK] = ACTIONS(3094),
    [anon_sym_static] = ACTIONS(3094),
    [anon_sym_register] = ACTIONS(3094),
    [anon_sym_inline] = ACTIONS(3094),
    [anon_sym___inline] = ACTIONS(3094),
    [anon_sym___inline__] = ACTIONS(3094),
    [anon_sym___forceinline] = ACTIONS(3094),
    [anon_sym_thread_local] = ACTIONS(3094),
    [anon_sym___thread] = ACTIONS(3094),
    [anon_sym_const] = ACTIONS(3094),
    [anon_sym_constexpr] = ACTIONS(3094),
    [anon_sym_volatile] = ACTIONS(3094),
    [anon_sym_restrict] = ACTIONS(3094),
    [anon_sym___restrict__] = ACTIONS(3094),
    [anon_sym__Atomic] = ACTIONS(3094),
    [anon_sym__Noreturn] = ACTIONS(3094),
    [anon_sym_noreturn] = ACTIONS(3094),
    [anon_sym__Nonnull] = ACTIONS(3094),
    [anon_sym_mutable] = ACTIONS(3094),
    [anon_sym_constinit] = ACTIONS(3094),
    [anon_sym_consteval] = ACTIONS(3094),
    [anon_sym_alignas] = ACTIONS(3094),
    [anon_sym__Alignas] = ACTIONS(3094),
    [sym_primitive_type] = ACTIONS(3094),
    [anon_sym_enum] = ACTIONS(3094),
    [anon_sym_class] = ACTIONS(3094),
    [anon_sym_struct] = ACTIONS(3094),
    [anon_sym_union] = ACTIONS(3094),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3094),
    [anon_sym_decltype] = ACTIONS(3094),
    [anon_sym_explicit] = ACTIONS(3094),
    [anon_sym_typename] = ACTIONS(3094),
    [anon_sym_template] = ACTIONS(3094),
    [anon_sym_operator] = ACTIONS(3094),
    [anon_sym_friend] = ACTIONS(3094),
    [anon_sym_public] = ACTIONS(3094),
    [anon_sym_private] = ACTIONS(3094),
    [anon_sym_protected] = ACTIONS(3094),
    [anon_sym_using] = ACTIONS(3094),
    [anon_sym_static_assert] = ACTIONS(3094),
  },
  [2103] = {
    [sym_identifier] = ACTIONS(3098),
    [aux_sym_preproc_def_token1] = ACTIONS(3098),
    [aux_sym_preproc_if_token1] = ACTIONS(3098),
    [aux_sym_preproc_if_token2] = ACTIONS(3098),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3098),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3098),
    [sym_preproc_directive] = ACTIONS(3098),
    [anon_sym_LPAREN2] = ACTIONS(3100),
    [anon_sym_TILDE] = ACTIONS(3100),
    [anon_sym_STAR] = ACTIONS(3100),
    [anon_sym_AMP_AMP] = ACTIONS(3100),
    [anon_sym_AMP] = ACTIONS(3098),
    [anon_sym_SEMI] = ACTIONS(3100),
    [anon_sym___extension__] = ACTIONS(3098),
    [anon_sym_typedef] = ACTIONS(3098),
    [anon_sym_virtual] = ACTIONS(3098),
    [anon_sym_extern] = ACTIONS(3098),
    [anon_sym___attribute__] = ACTIONS(3098),
    [anon_sym___attribute] = ACTIONS(3098),
    [anon_sym_COLON_COLON] = ACTIONS(3100),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3100),
    [anon_sym___declspec] = ACTIONS(3098),
    [anon_sym___based] = ACTIONS(3098),
    [anon_sym_signed] = ACTIONS(3098),
    [anon_sym_unsigned] = ACTIONS(3098),
    [anon_sym_long] = ACTIONS(3098),
    [anon_sym_short] = ACTIONS(3098),
    [anon_sym_LBRACK] = ACTIONS(3098),
    [anon_sym_static] = ACTIONS(3098),
    [anon_sym_register] = ACTIONS(3098),
    [anon_sym_inline] = ACTIONS(3098),
    [anon_sym___inline] = ACTIONS(3098),
    [anon_sym___inline__] = ACTIONS(3098),
    [anon_sym___forceinline] = ACTIONS(3098),
    [anon_sym_thread_local] = ACTIONS(3098),
    [anon_sym___thread] = ACTIONS(3098),
    [anon_sym_const] = ACTIONS(3098),
    [anon_sym_constexpr] = ACTIONS(3098),
    [anon_sym_volatile] = ACTIONS(3098),
    [anon_sym_restrict] = ACTIONS(3098),
    [anon_sym___restrict__] = ACTIONS(3098),
    [anon_sym__Atomic] = ACTIONS(3098),
    [anon_sym__Noreturn] = ACTIONS(3098),
    [anon_sym_noreturn] = ACTIONS(3098),
    [anon_sym__Nonnull] = ACTIONS(3098),
    [anon_sym_mutable] = ACTIONS(3098),
    [anon_sym_constinit] = ACTIONS(3098),
    [anon_sym_consteval] = ACTIONS(3098),
    [anon_sym_alignas] = ACTIONS(3098),
    [anon_sym__Alignas] = ACTIONS(3098),
    [sym_primitive_type] = ACTIONS(3098),
    [anon_sym_enum] = ACTIONS(3098),
    [anon_sym_class] = ACTIONS(3098),
    [anon_sym_struct] = ACTIONS(3098),
    [anon_sym_union] = ACTIONS(3098),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3098),
    [anon_sym_decltype] = ACTIONS(3098),
    [anon_sym_explicit] = ACTIONS(3098),
    [anon_sym_typename] = ACTIONS(3098),
    [anon_sym_template] = ACTIONS(3098),
    [anon_sym_operator] = ACTIONS(3098),
    [anon_sym_friend] = ACTIONS(3098),
    [anon_sym_public] = ACTIONS(3098),
    [anon_sym_private] = ACTIONS(3098),
    [anon_sym_protected] = ACTIONS(3098),
    [anon_sym_using] = ACTIONS(3098),
    [anon_sym_static_assert] = ACTIONS(3098),
  },
  [2104] = {
    [sym_identifier] = ACTIONS(3104),
    [aux_sym_preproc_def_token1] = ACTIONS(3104),
    [aux_sym_preproc_if_token1] = ACTIONS(3104),
    [aux_sym_preproc_if_token2] = ACTIONS(3104),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3104),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3104),
    [sym_preproc_directive] = ACTIONS(3104),
    [anon_sym_LPAREN2] = ACTIONS(3106),
    [anon_sym_TILDE] = ACTIONS(3106),
    [anon_sym_STAR] = ACTIONS(3106),
    [anon_sym_AMP_AMP] = ACTIONS(3106),
    [anon_sym_AMP] = ACTIONS(3104),
    [anon_sym_SEMI] = ACTIONS(3106),
    [anon_sym___extension__] = ACTIONS(3104),
    [anon_sym_typedef] = ACTIONS(3104),
    [anon_sym_virtual] = ACTIONS(3104),
    [anon_sym_extern] = ACTIONS(3104),
    [anon_sym___attribute__] = ACTIONS(3104),
    [anon_sym___attribute] = ACTIONS(3104),
    [anon_sym_COLON_COLON] = ACTIONS(3106),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3106),
    [anon_sym___declspec] = ACTIONS(3104),
    [anon_sym___based] = ACTIONS(3104),
    [anon_sym_signed] = ACTIONS(3104),
    [anon_sym_unsigned] = ACTIONS(3104),
    [anon_sym_long] = ACTIONS(3104),
    [anon_sym_short] = ACTIONS(3104),
    [anon_sym_LBRACK] = ACTIONS(3104),
    [anon_sym_static] = ACTIONS(3104),
    [anon_sym_register] = ACTIONS(3104),
    [anon_sym_inline] = ACTIONS(3104),
    [anon_sym___inline] = ACTIONS(3104),
    [anon_sym___inline__] = ACTIONS(3104),
    [anon_sym___forceinline] = ACTIONS(3104),
    [anon_sym_thread_local] = ACTIONS(3104),
    [anon_sym___thread] = ACTIONS(3104),
    [anon_sym_const] = ACTIONS(3104),
    [anon_sym_constexpr] = ACTIONS(3104),
    [anon_sym_volatile] = ACTIONS(3104),
    [anon_sym_restrict] = ACTIONS(3104),
    [anon_sym___restrict__] = ACTIONS(3104),
    [anon_sym__Atomic] = ACTIONS(3104),
    [anon_sym__Noreturn] = ACTIONS(3104),
    [anon_sym_noreturn] = ACTIONS(3104),
    [anon_sym__Nonnull] = ACTIONS(3104),
    [anon_sym_mutable] = ACTIONS(3104),
    [anon_sym_constinit] = ACTIONS(3104),
    [anon_sym_consteval] = ACTIONS(3104),
    [anon_sym_alignas] = ACTIONS(3104),
    [anon_sym__Alignas] = ACTIONS(3104),
    [sym_primitive_type] = ACTIONS(3104),
    [anon_sym_enum] = ACTIONS(3104),
    [anon_sym_class] = ACTIONS(3104),
    [anon_sym_struct] = ACTIONS(3104),
    [anon_sym_union] = ACTIONS(3104),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3104),
    [anon_sym_decltype] = ACTIONS(3104),
    [anon_sym_explicit] = ACTIONS(3104),
    [anon_sym_typename] = ACTIONS(3104),
    [anon_sym_template] = ACTIONS(3104),
    [anon_sym_operator] = ACTIONS(3104),
    [anon_sym_friend] = ACTIONS(3104),
    [anon_sym_public] = ACTIONS(3104),
    [anon_sym_private] = ACTIONS(3104),
    [anon_sym_protected] = ACTIONS(3104),
    [anon_sym_using] = ACTIONS(3104),
    [anon_sym_static_assert] = ACTIONS(3104),
  },
  [2105] = {
    [sym_identifier] = ACTIONS(5353),
    [aux_sym_preproc_def_token1] = ACTIONS(5353),
    [aux_sym_preproc_if_token1] = ACTIONS(5353),
    [aux_sym_preproc_if_token2] = ACTIONS(5353),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5353),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5353),
    [sym_preproc_directive] = ACTIONS(5353),
    [anon_sym_LPAREN2] = ACTIONS(5355),
    [anon_sym_TILDE] = ACTIONS(5355),
    [anon_sym_STAR] = ACTIONS(5355),
    [anon_sym_AMP_AMP] = ACTIONS(5355),
    [anon_sym_AMP] = ACTIONS(5353),
    [anon_sym_SEMI] = ACTIONS(5355),
    [anon_sym___extension__] = ACTIONS(5353),
    [anon_sym_typedef] = ACTIONS(5353),
    [anon_sym_virtual] = ACTIONS(5353),
    [anon_sym_extern] = ACTIONS(5353),
    [anon_sym___attribute__] = ACTIONS(5353),
    [anon_sym___attribute] = ACTIONS(5353),
    [anon_sym_COLON_COLON] = ACTIONS(5355),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5355),
    [anon_sym___declspec] = ACTIONS(5353),
    [anon_sym___based] = ACTIONS(5353),
    [anon_sym_signed] = ACTIONS(5353),
    [anon_sym_unsigned] = ACTIONS(5353),
    [anon_sym_long] = ACTIONS(5353),
    [anon_sym_short] = ACTIONS(5353),
    [anon_sym_LBRACK] = ACTIONS(5353),
    [anon_sym_static] = ACTIONS(5353),
    [anon_sym_register] = ACTIONS(5353),
    [anon_sym_inline] = ACTIONS(5353),
    [anon_sym___inline] = ACTIONS(5353),
    [anon_sym___inline__] = ACTIONS(5353),
    [anon_sym___forceinline] = ACTIONS(5353),
    [anon_sym_thread_local] = ACTIONS(5353),
    [anon_sym___thread] = ACTIONS(5353),
    [anon_sym_const] = ACTIONS(5353),
    [anon_sym_constexpr] = ACTIONS(5353),
    [anon_sym_volatile] = ACTIONS(5353),
    [anon_sym_restrict] = ACTIONS(5353),
    [anon_sym___restrict__] = ACTIONS(5353),
    [anon_sym__Atomic] = ACTIONS(5353),
    [anon_sym__Noreturn] = ACTIONS(5353),
    [anon_sym_noreturn] = ACTIONS(5353),
    [anon_sym__Nonnull] = ACTIONS(5353),
    [anon_sym_mutable] = ACTIONS(5353),
    [anon_sym_constinit] = ACTIONS(5353),
    [anon_sym_consteval] = ACTIONS(5353),
    [anon_sym_alignas] = ACTIONS(5353),
    [anon_sym__Alignas] = ACTIONS(5353),
    [sym_primitive_type] = ACTIONS(5353),
    [anon_sym_enum] = ACTIONS(5353),
    [anon_sym_class] = ACTIONS(5353),
    [anon_sym_struct] = ACTIONS(5353),
    [anon_sym_union] = ACTIONS(5353),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5353),
    [anon_sym_decltype] = ACTIONS(5353),
    [anon_sym_explicit] = ACTIONS(5353),
    [anon_sym_typename] = ACTIONS(5353),
    [anon_sym_template] = ACTIONS(5353),
    [anon_sym_operator] = ACTIONS(5353),
    [anon_sym_friend] = ACTIONS(5353),
    [anon_sym_public] = ACTIONS(5353),
    [anon_sym_private] = ACTIONS(5353),
    [anon_sym_protected] = ACTIONS(5353),
    [anon_sym_using] = ACTIONS(5353),
    [anon_sym_static_assert] = ACTIONS(5353),
  },
  [2106] = {
    [sym_identifier] = ACTIONS(3146),
    [aux_sym_preproc_def_token1] = ACTIONS(3146),
    [aux_sym_preproc_if_token1] = ACTIONS(3146),
    [aux_sym_preproc_if_token2] = ACTIONS(3146),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3146),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3146),
    [sym_preproc_directive] = ACTIONS(3146),
    [anon_sym_LPAREN2] = ACTIONS(3148),
    [anon_sym_TILDE] = ACTIONS(3148),
    [anon_sym_STAR] = ACTIONS(3148),
    [anon_sym_AMP_AMP] = ACTIONS(3148),
    [anon_sym_AMP] = ACTIONS(3146),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym___extension__] = ACTIONS(3146),
    [anon_sym_typedef] = ACTIONS(3146),
    [anon_sym_virtual] = ACTIONS(3146),
    [anon_sym_extern] = ACTIONS(3146),
    [anon_sym___attribute__] = ACTIONS(3146),
    [anon_sym___attribute] = ACTIONS(3146),
    [anon_sym_COLON_COLON] = ACTIONS(3148),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3148),
    [anon_sym___declspec] = ACTIONS(3146),
    [anon_sym___based] = ACTIONS(3146),
    [anon_sym_signed] = ACTIONS(3146),
    [anon_sym_unsigned] = ACTIONS(3146),
    [anon_sym_long] = ACTIONS(3146),
    [anon_sym_short] = ACTIONS(3146),
    [anon_sym_LBRACK] = ACTIONS(3146),
    [anon_sym_static] = ACTIONS(3146),
    [anon_sym_register] = ACTIONS(3146),
    [anon_sym_inline] = ACTIONS(3146),
    [anon_sym___inline] = ACTIONS(3146),
    [anon_sym___inline__] = ACTIONS(3146),
    [anon_sym___forceinline] = ACTIONS(3146),
    [anon_sym_thread_local] = ACTIONS(3146),
    [anon_sym___thread] = ACTIONS(3146),
    [anon_sym_const] = ACTIONS(3146),
    [anon_sym_constexpr] = ACTIONS(3146),
    [anon_sym_volatile] = ACTIONS(3146),
    [anon_sym_restrict] = ACTIONS(3146),
    [anon_sym___restrict__] = ACTIONS(3146),
    [anon_sym__Atomic] = ACTIONS(3146),
    [anon_sym__Noreturn] = ACTIONS(3146),
    [anon_sym_noreturn] = ACTIONS(3146),
    [anon_sym__Nonnull] = ACTIONS(3146),
    [anon_sym_mutable] = ACTIONS(3146),
    [anon_sym_constinit] = ACTIONS(3146),
    [anon_sym_consteval] = ACTIONS(3146),
    [anon_sym_alignas] = ACTIONS(3146),
    [anon_sym__Alignas] = ACTIONS(3146),
    [sym_primitive_type] = ACTIONS(3146),
    [anon_sym_enum] = ACTIONS(3146),
    [anon_sym_class] = ACTIONS(3146),
    [anon_sym_struct] = ACTIONS(3146),
    [anon_sym_union] = ACTIONS(3146),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3146),
    [anon_sym_decltype] = ACTIONS(3146),
    [anon_sym_explicit] = ACTIONS(3146),
    [anon_sym_typename] = ACTIONS(3146),
    [anon_sym_template] = ACTIONS(3146),
    [anon_sym_operator] = ACTIONS(3146),
    [anon_sym_friend] = ACTIONS(3146),
    [anon_sym_public] = ACTIONS(3146),
    [anon_sym_private] = ACTIONS(3146),
    [anon_sym_protected] = ACTIONS(3146),
    [anon_sym_using] = ACTIONS(3146),
    [anon_sym_static_assert] = ACTIONS(3146),
  },
  [2107] = {
    [sym_identifier] = ACTIONS(3150),
    [aux_sym_preproc_def_token1] = ACTIONS(3150),
    [aux_sym_preproc_if_token1] = ACTIONS(3150),
    [aux_sym_preproc_if_token2] = ACTIONS(3150),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3150),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3150),
    [sym_preproc_directive] = ACTIONS(3150),
    [anon_sym_LPAREN2] = ACTIONS(3152),
    [anon_sym_TILDE] = ACTIONS(3152),
    [anon_sym_STAR] = ACTIONS(3152),
    [anon_sym_AMP_AMP] = ACTIONS(3152),
    [anon_sym_AMP] = ACTIONS(3150),
    [anon_sym_SEMI] = ACTIONS(3152),
    [anon_sym___extension__] = ACTIONS(3150),
    [anon_sym_typedef] = ACTIONS(3150),
    [anon_sym_virtual] = ACTIONS(3150),
    [anon_sym_extern] = ACTIONS(3150),
    [anon_sym___attribute__] = ACTIONS(3150),
    [anon_sym___attribute] = ACTIONS(3150),
    [anon_sym_COLON_COLON] = ACTIONS(3152),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3152),
    [anon_sym___declspec] = ACTIONS(3150),
    [anon_sym___based] = ACTIONS(3150),
    [anon_sym_signed] = ACTIONS(3150),
    [anon_sym_unsigned] = ACTIONS(3150),
    [anon_sym_long] = ACTIONS(3150),
    [anon_sym_short] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(3150),
    [anon_sym_static] = ACTIONS(3150),
    [anon_sym_register] = ACTIONS(3150),
    [anon_sym_inline] = ACTIONS(3150),
    [anon_sym___inline] = ACTIONS(3150),
    [anon_sym___inline__] = ACTIONS(3150),
    [anon_sym___forceinline] = ACTIONS(3150),
    [anon_sym_thread_local] = ACTIONS(3150),
    [anon_sym___thread] = ACTIONS(3150),
    [anon_sym_const] = ACTIONS(3150),
    [anon_sym_constexpr] = ACTIONS(3150),
    [anon_sym_volatile] = ACTIONS(3150),
    [anon_sym_restrict] = ACTIONS(3150),
    [anon_sym___restrict__] = ACTIONS(3150),
    [anon_sym__Atomic] = ACTIONS(3150),
    [anon_sym__Noreturn] = ACTIONS(3150),
    [anon_sym_noreturn] = ACTIONS(3150),
    [anon_sym__Nonnull] = ACTIONS(3150),
    [anon_sym_mutable] = ACTIONS(3150),
    [anon_sym_constinit] = ACTIONS(3150),
    [anon_sym_consteval] = ACTIONS(3150),
    [anon_sym_alignas] = ACTIONS(3150),
    [anon_sym__Alignas] = ACTIONS(3150),
    [sym_primitive_type] = ACTIONS(3150),
    [anon_sym_enum] = ACTIONS(3150),
    [anon_sym_class] = ACTIONS(3150),
    [anon_sym_struct] = ACTIONS(3150),
    [anon_sym_union] = ACTIONS(3150),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3150),
    [anon_sym_decltype] = ACTIONS(3150),
    [anon_sym_explicit] = ACTIONS(3150),
    [anon_sym_typename] = ACTIONS(3150),
    [anon_sym_template] = ACTIONS(3150),
    [anon_sym_operator] = ACTIONS(3150),
    [anon_sym_friend] = ACTIONS(3150),
    [anon_sym_public] = ACTIONS(3150),
    [anon_sym_private] = ACTIONS(3150),
    [anon_sym_protected] = ACTIONS(3150),
    [anon_sym_using] = ACTIONS(3150),
    [anon_sym_static_assert] = ACTIONS(3150),
  },
  [2108] = {
    [sym_identifier] = ACTIONS(2771),
    [aux_sym_preproc_def_token1] = ACTIONS(2771),
    [aux_sym_preproc_if_token1] = ACTIONS(2771),
    [aux_sym_preproc_if_token2] = ACTIONS(2771),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2771),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2771),
    [sym_preproc_directive] = ACTIONS(2771),
    [anon_sym_LPAREN2] = ACTIONS(2773),
    [anon_sym_TILDE] = ACTIONS(2773),
    [anon_sym_STAR] = ACTIONS(2773),
    [anon_sym_AMP_AMP] = ACTIONS(2773),
    [anon_sym_AMP] = ACTIONS(2771),
    [anon_sym_SEMI] = ACTIONS(2773),
    [anon_sym___extension__] = ACTIONS(2771),
    [anon_sym_typedef] = ACTIONS(2771),
    [anon_sym_virtual] = ACTIONS(2771),
    [anon_sym_extern] = ACTIONS(2771),
    [anon_sym___attribute__] = ACTIONS(2771),
    [anon_sym___attribute] = ACTIONS(2771),
    [anon_sym_COLON_COLON] = ACTIONS(2773),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2773),
    [anon_sym___declspec] = ACTIONS(2771),
    [anon_sym___based] = ACTIONS(2771),
    [anon_sym_signed] = ACTIONS(2771),
    [anon_sym_unsigned] = ACTIONS(2771),
    [anon_sym_long] = ACTIONS(2771),
    [anon_sym_short] = ACTIONS(2771),
    [anon_sym_LBRACK] = ACTIONS(2771),
    [anon_sym_static] = ACTIONS(2771),
    [anon_sym_register] = ACTIONS(2771),
    [anon_sym_inline] = ACTIONS(2771),
    [anon_sym___inline] = ACTIONS(2771),
    [anon_sym___inline__] = ACTIONS(2771),
    [anon_sym___forceinline] = ACTIONS(2771),
    [anon_sym_thread_local] = ACTIONS(2771),
    [anon_sym___thread] = ACTIONS(2771),
    [anon_sym_const] = ACTIONS(2771),
    [anon_sym_constexpr] = ACTIONS(2771),
    [anon_sym_volatile] = ACTIONS(2771),
    [anon_sym_restrict] = ACTIONS(2771),
    [anon_sym___restrict__] = ACTIONS(2771),
    [anon_sym__Atomic] = ACTIONS(2771),
    [anon_sym__Noreturn] = ACTIONS(2771),
    [anon_sym_noreturn] = ACTIONS(2771),
    [anon_sym__Nonnull] = ACTIONS(2771),
    [anon_sym_mutable] = ACTIONS(2771),
    [anon_sym_constinit] = ACTIONS(2771),
    [anon_sym_consteval] = ACTIONS(2771),
    [anon_sym_alignas] = ACTIONS(2771),
    [anon_sym__Alignas] = ACTIONS(2771),
    [sym_primitive_type] = ACTIONS(2771),
    [anon_sym_enum] = ACTIONS(2771),
    [anon_sym_class] = ACTIONS(2771),
    [anon_sym_struct] = ACTIONS(2771),
    [anon_sym_union] = ACTIONS(2771),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2771),
    [anon_sym_decltype] = ACTIONS(2771),
    [anon_sym_explicit] = ACTIONS(2771),
    [anon_sym_typename] = ACTIONS(2771),
    [anon_sym_template] = ACTIONS(2771),
    [anon_sym_operator] = ACTIONS(2771),
    [anon_sym_friend] = ACTIONS(2771),
    [anon_sym_public] = ACTIONS(2771),
    [anon_sym_private] = ACTIONS(2771),
    [anon_sym_protected] = ACTIONS(2771),
    [anon_sym_using] = ACTIONS(2771),
    [anon_sym_static_assert] = ACTIONS(2771),
  },
  [2109] = {
    [sym_identifier] = ACTIONS(2960),
    [aux_sym_preproc_def_token1] = ACTIONS(2960),
    [aux_sym_preproc_if_token1] = ACTIONS(2960),
    [aux_sym_preproc_if_token2] = ACTIONS(2960),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2960),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2960),
    [sym_preproc_directive] = ACTIONS(2960),
    [anon_sym_LPAREN2] = ACTIONS(2962),
    [anon_sym_TILDE] = ACTIONS(2962),
    [anon_sym_STAR] = ACTIONS(2962),
    [anon_sym_AMP_AMP] = ACTIONS(2962),
    [anon_sym_AMP] = ACTIONS(2960),
    [anon_sym_SEMI] = ACTIONS(2962),
    [anon_sym___extension__] = ACTIONS(2960),
    [anon_sym_typedef] = ACTIONS(2960),
    [anon_sym_virtual] = ACTIONS(2960),
    [anon_sym_extern] = ACTIONS(2960),
    [anon_sym___attribute__] = ACTIONS(2960),
    [anon_sym___attribute] = ACTIONS(2960),
    [anon_sym_COLON_COLON] = ACTIONS(2962),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2962),
    [anon_sym___declspec] = ACTIONS(2960),
    [anon_sym___based] = ACTIONS(2960),
    [anon_sym_signed] = ACTIONS(2960),
    [anon_sym_unsigned] = ACTIONS(2960),
    [anon_sym_long] = ACTIONS(2960),
    [anon_sym_short] = ACTIONS(2960),
    [anon_sym_LBRACK] = ACTIONS(2960),
    [anon_sym_static] = ACTIONS(2960),
    [anon_sym_register] = ACTIONS(2960),
    [anon_sym_inline] = ACTIONS(2960),
    [anon_sym___inline] = ACTIONS(2960),
    [anon_sym___inline__] = ACTIONS(2960),
    [anon_sym___forceinline] = ACTIONS(2960),
    [anon_sym_thread_local] = ACTIONS(2960),
    [anon_sym___thread] = ACTIONS(2960),
    [anon_sym_const] = ACTIONS(2960),
    [anon_sym_constexpr] = ACTIONS(2960),
    [anon_sym_volatile] = ACTIONS(2960),
    [anon_sym_restrict] = ACTIONS(2960),
    [anon_sym___restrict__] = ACTIONS(2960),
    [anon_sym__Atomic] = ACTIONS(2960),
    [anon_sym__Noreturn] = ACTIONS(2960),
    [anon_sym_noreturn] = ACTIONS(2960),
    [anon_sym__Nonnull] = ACTIONS(2960),
    [anon_sym_mutable] = ACTIONS(2960),
    [anon_sym_constinit] = ACTIONS(2960),
    [anon_sym_consteval] = ACTIONS(2960),
    [anon_sym_alignas] = ACTIONS(2960),
    [anon_sym__Alignas] = ACTIONS(2960),
    [sym_primitive_type] = ACTIONS(2960),
    [anon_sym_enum] = ACTIONS(2960),
    [anon_sym_class] = ACTIONS(2960),
    [anon_sym_struct] = ACTIONS(2960),
    [anon_sym_union] = ACTIONS(2960),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2960),
    [anon_sym_decltype] = ACTIONS(2960),
    [anon_sym_explicit] = ACTIONS(2960),
    [anon_sym_typename] = ACTIONS(2960),
    [anon_sym_template] = ACTIONS(2960),
    [anon_sym_operator] = ACTIONS(2960),
    [anon_sym_friend] = ACTIONS(2960),
    [anon_sym_public] = ACTIONS(2960),
    [anon_sym_private] = ACTIONS(2960),
    [anon_sym_protected] = ACTIONS(2960),
    [anon_sym_using] = ACTIONS(2960),
    [anon_sym_static_assert] = ACTIONS(2960),
  },
  [2110] = {
    [sym_identifier] = ACTIONS(5367),
    [aux_sym_preproc_def_token1] = ACTIONS(5367),
    [aux_sym_preproc_if_token1] = ACTIONS(5367),
    [aux_sym_preproc_if_token2] = ACTIONS(5367),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5367),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5367),
    [sym_preproc_directive] = ACTIONS(5367),
    [anon_sym_LPAREN2] = ACTIONS(5369),
    [anon_sym_TILDE] = ACTIONS(5369),
    [anon_sym_STAR] = ACTIONS(5369),
    [anon_sym_AMP_AMP] = ACTIONS(5369),
    [anon_sym_AMP] = ACTIONS(5367),
    [anon_sym_SEMI] = ACTIONS(5369),
    [anon_sym___extension__] = ACTIONS(5367),
    [anon_sym_typedef] = ACTIONS(5367),
    [anon_sym_virtual] = ACTIONS(5367),
    [anon_sym_extern] = ACTIONS(5367),
    [anon_sym___attribute__] = ACTIONS(5367),
    [anon_sym___attribute] = ACTIONS(5367),
    [anon_sym_COLON_COLON] = ACTIONS(5369),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5369),
    [anon_sym___declspec] = ACTIONS(5367),
    [anon_sym___based] = ACTIONS(5367),
    [anon_sym_signed] = ACTIONS(5367),
    [anon_sym_unsigned] = ACTIONS(5367),
    [anon_sym_long] = ACTIONS(5367),
    [anon_sym_short] = ACTIONS(5367),
    [anon_sym_LBRACK] = ACTIONS(5367),
    [anon_sym_static] = ACTIONS(5367),
    [anon_sym_register] = ACTIONS(5367),
    [anon_sym_inline] = ACTIONS(5367),
    [anon_sym___inline] = ACTIONS(5367),
    [anon_sym___inline__] = ACTIONS(5367),
    [anon_sym___forceinline] = ACTIONS(5367),
    [anon_sym_thread_local] = ACTIONS(5367),
    [anon_sym___thread] = ACTIONS(5367),
    [anon_sym_const] = ACTIONS(5367),
    [anon_sym_constexpr] = ACTIONS(5367),
    [anon_sym_volatile] = ACTIONS(5367),
    [anon_sym_restrict] = ACTIONS(5367),
    [anon_sym___restrict__] = ACTIONS(5367),
    [anon_sym__Atomic] = ACTIONS(5367),
    [anon_sym__Noreturn] = ACTIONS(5367),
    [anon_sym_noreturn] = ACTIONS(5367),
    [anon_sym__Nonnull] = ACTIONS(5367),
    [anon_sym_mutable] = ACTIONS(5367),
    [anon_sym_constinit] = ACTIONS(5367),
    [anon_sym_consteval] = ACTIONS(5367),
    [anon_sym_alignas] = ACTIONS(5367),
    [anon_sym__Alignas] = ACTIONS(5367),
    [sym_primitive_type] = ACTIONS(5367),
    [anon_sym_enum] = ACTIONS(5367),
    [anon_sym_class] = ACTIONS(5367),
    [anon_sym_struct] = ACTIONS(5367),
    [anon_sym_union] = ACTIONS(5367),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5367),
    [anon_sym_decltype] = ACTIONS(5367),
    [anon_sym_explicit] = ACTIONS(5367),
    [anon_sym_typename] = ACTIONS(5367),
    [anon_sym_template] = ACTIONS(5367),
    [anon_sym_operator] = ACTIONS(5367),
    [anon_sym_friend] = ACTIONS(5367),
    [anon_sym_public] = ACTIONS(5367),
    [anon_sym_private] = ACTIONS(5367),
    [anon_sym_protected] = ACTIONS(5367),
    [anon_sym_using] = ACTIONS(5367),
    [anon_sym_static_assert] = ACTIONS(5367),
  },
  [2111] = {
    [sym_identifier] = ACTIONS(5367),
    [aux_sym_preproc_def_token1] = ACTIONS(5367),
    [aux_sym_preproc_if_token1] = ACTIONS(5367),
    [aux_sym_preproc_if_token2] = ACTIONS(5367),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5367),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5367),
    [sym_preproc_directive] = ACTIONS(5367),
    [anon_sym_LPAREN2] = ACTIONS(5369),
    [anon_sym_TILDE] = ACTIONS(5369),
    [anon_sym_STAR] = ACTIONS(5369),
    [anon_sym_AMP_AMP] = ACTIONS(5369),
    [anon_sym_AMP] = ACTIONS(5367),
    [anon_sym_SEMI] = ACTIONS(5369),
    [anon_sym___extension__] = ACTIONS(5367),
    [anon_sym_typedef] = ACTIONS(5367),
    [anon_sym_virtual] = ACTIONS(5367),
    [anon_sym_extern] = ACTIONS(5367),
    [anon_sym___attribute__] = ACTIONS(5367),
    [anon_sym___attribute] = ACTIONS(5367),
    [anon_sym_COLON_COLON] = ACTIONS(5369),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5369),
    [anon_sym___declspec] = ACTIONS(5367),
    [anon_sym___based] = ACTIONS(5367),
    [anon_sym_signed] = ACTIONS(5367),
    [anon_sym_unsigned] = ACTIONS(5367),
    [anon_sym_long] = ACTIONS(5367),
    [anon_sym_short] = ACTIONS(5367),
    [anon_sym_LBRACK] = ACTIONS(5367),
    [anon_sym_static] = ACTIONS(5367),
    [anon_sym_register] = ACTIONS(5367),
    [anon_sym_inline] = ACTIONS(5367),
    [anon_sym___inline] = ACTIONS(5367),
    [anon_sym___inline__] = ACTIONS(5367),
    [anon_sym___forceinline] = ACTIONS(5367),
    [anon_sym_thread_local] = ACTIONS(5367),
    [anon_sym___thread] = ACTIONS(5367),
    [anon_sym_const] = ACTIONS(5367),
    [anon_sym_constexpr] = ACTIONS(5367),
    [anon_sym_volatile] = ACTIONS(5367),
    [anon_sym_restrict] = ACTIONS(5367),
    [anon_sym___restrict__] = ACTIONS(5367),
    [anon_sym__Atomic] = ACTIONS(5367),
    [anon_sym__Noreturn] = ACTIONS(5367),
    [anon_sym_noreturn] = ACTIONS(5367),
    [anon_sym__Nonnull] = ACTIONS(5367),
    [anon_sym_mutable] = ACTIONS(5367),
    [anon_sym_constinit] = ACTIONS(5367),
    [anon_sym_consteval] = ACTIONS(5367),
    [anon_sym_alignas] = ACTIONS(5367),
    [anon_sym__Alignas] = ACTIONS(5367),
    [sym_primitive_type] = ACTIONS(5367),
    [anon_sym_enum] = ACTIONS(5367),
    [anon_sym_class] = ACTIONS(5367),
    [anon_sym_struct] = ACTIONS(5367),
    [anon_sym_union] = ACTIONS(5367),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5367),
    [anon_sym_decltype] = ACTIONS(5367),
    [anon_sym_explicit] = ACTIONS(5367),
    [anon_sym_typename] = ACTIONS(5367),
    [anon_sym_template] = ACTIONS(5367),
    [anon_sym_operator] = ACTIONS(5367),
    [anon_sym_friend] = ACTIONS(5367),
    [anon_sym_public] = ACTIONS(5367),
    [anon_sym_private] = ACTIONS(5367),
    [anon_sym_protected] = ACTIONS(5367),
    [anon_sym_using] = ACTIONS(5367),
    [anon_sym_static_assert] = ACTIONS(5367),
  },
  [2112] = {
    [sym_string_literal] = STATE(2570),
    [sym_template_argument_list] = STATE(3643),
    [sym_raw_string_literal] = STATE(2570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4035),
    [anon_sym_COMMA] = ACTIONS(4035),
    [anon_sym_LPAREN2] = ACTIONS(5813),
    [anon_sym_DASH] = ACTIONS(4043),
    [anon_sym_PLUS] = ACTIONS(4043),
    [anon_sym_STAR] = ACTIONS(4043),
    [anon_sym_SLASH] = ACTIONS(4043),
    [anon_sym_PERCENT] = ACTIONS(4043),
    [anon_sym_PIPE_PIPE] = ACTIONS(4035),
    [anon_sym_AMP_AMP] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4043),
    [anon_sym_CARET] = ACTIONS(4043),
    [anon_sym_AMP] = ACTIONS(4043),
    [anon_sym_EQ_EQ] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4043),
    [anon_sym_GT_EQ] = ACTIONS(4035),
    [anon_sym_LT_EQ] = ACTIONS(4043),
    [anon_sym_LT] = ACTIONS(4929),
    [anon_sym_LT_LT] = ACTIONS(4043),
    [anon_sym_GT_GT] = ACTIONS(4043),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5813),
    [anon_sym_LBRACE] = ACTIONS(4059),
    [anon_sym_RBRACE] = ACTIONS(4035),
    [anon_sym_LBRACK] = ACTIONS(5815),
    [anon_sym_EQ] = ACTIONS(4067),
    [anon_sym_QMARK] = ACTIONS(4035),
    [anon_sym_STAR_EQ] = ACTIONS(4071),
    [anon_sym_SLASH_EQ] = ACTIONS(4071),
    [anon_sym_PERCENT_EQ] = ACTIONS(4071),
    [anon_sym_PLUS_EQ] = ACTIONS(4071),
    [anon_sym_DASH_EQ] = ACTIONS(4071),
    [anon_sym_LT_LT_EQ] = ACTIONS(4071),
    [anon_sym_GT_GT_EQ] = ACTIONS(4071),
    [anon_sym_AMP_EQ] = ACTIONS(4071),
    [anon_sym_CARET_EQ] = ACTIONS(4071),
    [anon_sym_PIPE_EQ] = ACTIONS(4071),
    [anon_sym_and_eq] = ACTIONS(4071),
    [anon_sym_or_eq] = ACTIONS(4071),
    [anon_sym_xor_eq] = ACTIONS(4071),
    [anon_sym_LT_EQ_GT] = ACTIONS(4035),
    [anon_sym_or] = ACTIONS(4043),
    [anon_sym_and] = ACTIONS(4043),
    [anon_sym_bitor] = ACTIONS(4035),
    [anon_sym_xor] = ACTIONS(4043),
    [anon_sym_bitand] = ACTIONS(4035),
    [anon_sym_not_eq] = ACTIONS(4035),
    [anon_sym_DASH_DASH] = ACTIONS(4035),
    [anon_sym_PLUS_PLUS] = ACTIONS(4035),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_DOT_STAR] = ACTIONS(4035),
    [anon_sym_DASH_GT] = ACTIONS(4035),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
  },
  [2113] = {
    [sym_identifier] = ACTIONS(3142),
    [aux_sym_preproc_def_token1] = ACTIONS(3142),
    [aux_sym_preproc_if_token1] = ACTIONS(3142),
    [aux_sym_preproc_if_token2] = ACTIONS(3142),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(3142),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(3142),
    [sym_preproc_directive] = ACTIONS(3142),
    [anon_sym_LPAREN2] = ACTIONS(3144),
    [anon_sym_TILDE] = ACTIONS(3144),
    [anon_sym_STAR] = ACTIONS(3144),
    [anon_sym_AMP_AMP] = ACTIONS(3144),
    [anon_sym_AMP] = ACTIONS(3142),
    [anon_sym_SEMI] = ACTIONS(3144),
    [anon_sym___extension__] = ACTIONS(3142),
    [anon_sym_typedef] = ACTIONS(3142),
    [anon_sym_virtual] = ACTIONS(3142),
    [anon_sym_extern] = ACTIONS(3142),
    [anon_sym___attribute__] = ACTIONS(3142),
    [anon_sym___attribute] = ACTIONS(3142),
    [anon_sym_COLON_COLON] = ACTIONS(3144),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(3144),
    [anon_sym___declspec] = ACTIONS(3142),
    [anon_sym___based] = ACTIONS(3142),
    [anon_sym_signed] = ACTIONS(3142),
    [anon_sym_unsigned] = ACTIONS(3142),
    [anon_sym_long] = ACTIONS(3142),
    [anon_sym_short] = ACTIONS(3142),
    [anon_sym_LBRACK] = ACTIONS(3142),
    [anon_sym_static] = ACTIONS(3142),
    [anon_sym_register] = ACTIONS(3142),
    [anon_sym_inline] = ACTIONS(3142),
    [anon_sym___inline] = ACTIONS(3142),
    [anon_sym___inline__] = ACTIONS(3142),
    [anon_sym___forceinline] = ACTIONS(3142),
    [anon_sym_thread_local] = ACTIONS(3142),
    [anon_sym___thread] = ACTIONS(3142),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_constexpr] = ACTIONS(3142),
    [anon_sym_volatile] = ACTIONS(3142),
    [anon_sym_restrict] = ACTIONS(3142),
    [anon_sym___restrict__] = ACTIONS(3142),
    [anon_sym__Atomic] = ACTIONS(3142),
    [anon_sym__Noreturn] = ACTIONS(3142),
    [anon_sym_noreturn] = ACTIONS(3142),
    [anon_sym__Nonnull] = ACTIONS(3142),
    [anon_sym_mutable] = ACTIONS(3142),
    [anon_sym_constinit] = ACTIONS(3142),
    [anon_sym_consteval] = ACTIONS(3142),
    [anon_sym_alignas] = ACTIONS(3142),
    [anon_sym__Alignas] = ACTIONS(3142),
    [sym_primitive_type] = ACTIONS(3142),
    [anon_sym_enum] = ACTIONS(3142),
    [anon_sym_class] = ACTIONS(3142),
    [anon_sym_struct] = ACTIONS(3142),
    [anon_sym_union] = ACTIONS(3142),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(3142),
    [anon_sym_decltype] = ACTIONS(3142),
    [anon_sym_explicit] = ACTIONS(3142),
    [anon_sym_typename] = ACTIONS(3142),
    [anon_sym_template] = ACTIONS(3142),
    [anon_sym_operator] = ACTIONS(3142),
    [anon_sym_friend] = ACTIONS(3142),
    [anon_sym_public] = ACTIONS(3142),
    [anon_sym_private] = ACTIONS(3142),
    [anon_sym_protected] = ACTIONS(3142),
    [anon_sym_using] = ACTIONS(3142),
    [anon_sym_static_assert] = ACTIONS(3142),
  },
  [2114] = {
    [sym_string_literal] = STATE(1656),
    [sym_template_argument_list] = STATE(2832),
    [sym_raw_string_literal] = STATE(1656),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4035),
    [anon_sym_COMMA] = ACTIONS(4035),
    [anon_sym_LPAREN2] = ACTIONS(5868),
    [anon_sym_DASH] = ACTIONS(4043),
    [anon_sym_PLUS] = ACTIONS(4043),
    [anon_sym_STAR] = ACTIONS(4043),
    [anon_sym_SLASH] = ACTIONS(4043),
    [anon_sym_PERCENT] = ACTIONS(4043),
    [anon_sym_PIPE_PIPE] = ACTIONS(4035),
    [anon_sym_AMP_AMP] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4043),
    [anon_sym_CARET] = ACTIONS(4043),
    [anon_sym_AMP] = ACTIONS(4043),
    [anon_sym_EQ_EQ] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4043),
    [anon_sym_GT_EQ] = ACTIONS(4035),
    [anon_sym_LT_EQ] = ACTIONS(4043),
    [anon_sym_LT] = ACTIONS(5884),
    [anon_sym_LT_LT] = ACTIONS(4043),
    [anon_sym_GT_GT] = ACTIONS(4043),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4895),
    [anon_sym_LBRACE] = ACTIONS(4059),
    [anon_sym_RBRACE] = ACTIONS(4035),
    [anon_sym_LBRACK] = ACTIONS(5871),
    [anon_sym_EQ] = ACTIONS(4043),
    [anon_sym_QMARK] = ACTIONS(4035),
    [anon_sym_STAR_EQ] = ACTIONS(4035),
    [anon_sym_SLASH_EQ] = ACTIONS(4035),
    [anon_sym_PERCENT_EQ] = ACTIONS(4035),
    [anon_sym_PLUS_EQ] = ACTIONS(4035),
    [anon_sym_DASH_EQ] = ACTIONS(4035),
    [anon_sym_LT_LT_EQ] = ACTIONS(4035),
    [anon_sym_GT_GT_EQ] = ACTIONS(4035),
    [anon_sym_AMP_EQ] = ACTIONS(4035),
    [anon_sym_CARET_EQ] = ACTIONS(4035),
    [anon_sym_PIPE_EQ] = ACTIONS(4035),
    [anon_sym_and_eq] = ACTIONS(4035),
    [anon_sym_or_eq] = ACTIONS(4035),
    [anon_sym_xor_eq] = ACTIONS(4035),
    [anon_sym_LT_EQ_GT] = ACTIONS(4035),
    [anon_sym_or] = ACTIONS(4043),
    [anon_sym_and] = ACTIONS(4043),
    [anon_sym_bitor] = ACTIONS(4035),
    [anon_sym_xor] = ACTIONS(4043),
    [anon_sym_bitand] = ACTIONS(4035),
    [anon_sym_not_eq] = ACTIONS(4035),
    [anon_sym_DASH_DASH] = ACTIONS(4035),
    [anon_sym_PLUS_PLUS] = ACTIONS(4035),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_DOT_STAR] = ACTIONS(4035),
    [anon_sym_DASH_GT] = ACTIONS(4035),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(1955),
    [anon_sym_LR_DQUOTE] = ACTIONS(1955),
    [anon_sym_uR_DQUOTE] = ACTIONS(1955),
    [anon_sym_UR_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1955),
  },
  [2115] = {
    [sym_identifier] = ACTIONS(2751),
    [aux_sym_preproc_def_token1] = ACTIONS(2751),
    [aux_sym_preproc_if_token1] = ACTIONS(2751),
    [aux_sym_preproc_if_token2] = ACTIONS(2751),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2751),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2751),
    [sym_preproc_directive] = ACTIONS(2751),
    [anon_sym_LPAREN2] = ACTIONS(2753),
    [anon_sym_TILDE] = ACTIONS(2753),
    [anon_sym_STAR] = ACTIONS(2753),
    [anon_sym_AMP_AMP] = ACTIONS(2753),
    [anon_sym_AMP] = ACTIONS(2751),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym___extension__] = ACTIONS(2751),
    [anon_sym_typedef] = ACTIONS(2751),
    [anon_sym_virtual] = ACTIONS(2751),
    [anon_sym_extern] = ACTIONS(2751),
    [anon_sym___attribute__] = ACTIONS(2751),
    [anon_sym___attribute] = ACTIONS(2751),
    [anon_sym_COLON_COLON] = ACTIONS(2753),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2753),
    [anon_sym___declspec] = ACTIONS(2751),
    [anon_sym___based] = ACTIONS(2751),
    [anon_sym_signed] = ACTIONS(2751),
    [anon_sym_unsigned] = ACTIONS(2751),
    [anon_sym_long] = ACTIONS(2751),
    [anon_sym_short] = ACTIONS(2751),
    [anon_sym_LBRACK] = ACTIONS(2751),
    [anon_sym_static] = ACTIONS(2751),
    [anon_sym_register] = ACTIONS(2751),
    [anon_sym_inline] = ACTIONS(2751),
    [anon_sym___inline] = ACTIONS(2751),
    [anon_sym___inline__] = ACTIONS(2751),
    [anon_sym___forceinline] = ACTIONS(2751),
    [anon_sym_thread_local] = ACTIONS(2751),
    [anon_sym___thread] = ACTIONS(2751),
    [anon_sym_const] = ACTIONS(2751),
    [anon_sym_constexpr] = ACTIONS(2751),
    [anon_sym_volatile] = ACTIONS(2751),
    [anon_sym_restrict] = ACTIONS(2751),
    [anon_sym___restrict__] = ACTIONS(2751),
    [anon_sym__Atomic] = ACTIONS(2751),
    [anon_sym__Noreturn] = ACTIONS(2751),
    [anon_sym_noreturn] = ACTIONS(2751),
    [anon_sym__Nonnull] = ACTIONS(2751),
    [anon_sym_mutable] = ACTIONS(2751),
    [anon_sym_constinit] = ACTIONS(2751),
    [anon_sym_consteval] = ACTIONS(2751),
    [anon_sym_alignas] = ACTIONS(2751),
    [anon_sym__Alignas] = ACTIONS(2751),
    [sym_primitive_type] = ACTIONS(2751),
    [anon_sym_enum] = ACTIONS(2751),
    [anon_sym_class] = ACTIONS(2751),
    [anon_sym_struct] = ACTIONS(2751),
    [anon_sym_union] = ACTIONS(2751),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2751),
    [anon_sym_decltype] = ACTIONS(2751),
    [anon_sym_explicit] = ACTIONS(2751),
    [anon_sym_typename] = ACTIONS(2751),
    [anon_sym_template] = ACTIONS(2751),
    [anon_sym_operator] = ACTIONS(2751),
    [anon_sym_friend] = ACTIONS(2751),
    [anon_sym_public] = ACTIONS(2751),
    [anon_sym_private] = ACTIONS(2751),
    [anon_sym_protected] = ACTIONS(2751),
    [anon_sym_using] = ACTIONS(2751),
    [anon_sym_static_assert] = ACTIONS(2751),
  },
  [2116] = {
    [sym_identifier] = ACTIONS(2799),
    [aux_sym_preproc_def_token1] = ACTIONS(2799),
    [aux_sym_preproc_if_token1] = ACTIONS(2799),
    [aux_sym_preproc_if_token2] = ACTIONS(2799),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2799),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2799),
    [sym_preproc_directive] = ACTIONS(2799),
    [anon_sym_LPAREN2] = ACTIONS(2801),
    [anon_sym_TILDE] = ACTIONS(2801),
    [anon_sym_STAR] = ACTIONS(2801),
    [anon_sym_AMP_AMP] = ACTIONS(2801),
    [anon_sym_AMP] = ACTIONS(2799),
    [anon_sym_SEMI] = ACTIONS(2801),
    [anon_sym___extension__] = ACTIONS(2799),
    [anon_sym_typedef] = ACTIONS(2799),
    [anon_sym_virtual] = ACTIONS(2799),
    [anon_sym_extern] = ACTIONS(2799),
    [anon_sym___attribute__] = ACTIONS(2799),
    [anon_sym___attribute] = ACTIONS(2799),
    [anon_sym_COLON_COLON] = ACTIONS(2801),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2801),
    [anon_sym___declspec] = ACTIONS(2799),
    [anon_sym___based] = ACTIONS(2799),
    [anon_sym_signed] = ACTIONS(2799),
    [anon_sym_unsigned] = ACTIONS(2799),
    [anon_sym_long] = ACTIONS(2799),
    [anon_sym_short] = ACTIONS(2799),
    [anon_sym_LBRACK] = ACTIONS(2799),
    [anon_sym_static] = ACTIONS(2799),
    [anon_sym_register] = ACTIONS(2799),
    [anon_sym_inline] = ACTIONS(2799),
    [anon_sym___inline] = ACTIONS(2799),
    [anon_sym___inline__] = ACTIONS(2799),
    [anon_sym___forceinline] = ACTIONS(2799),
    [anon_sym_thread_local] = ACTIONS(2799),
    [anon_sym___thread] = ACTIONS(2799),
    [anon_sym_const] = ACTIONS(2799),
    [anon_sym_constexpr] = ACTIONS(2799),
    [anon_sym_volatile] = ACTIONS(2799),
    [anon_sym_restrict] = ACTIONS(2799),
    [anon_sym___restrict__] = ACTIONS(2799),
    [anon_sym__Atomic] = ACTIONS(2799),
    [anon_sym__Noreturn] = ACTIONS(2799),
    [anon_sym_noreturn] = ACTIONS(2799),
    [anon_sym__Nonnull] = ACTIONS(2799),
    [anon_sym_mutable] = ACTIONS(2799),
    [anon_sym_constinit] = ACTIONS(2799),
    [anon_sym_consteval] = ACTIONS(2799),
    [anon_sym_alignas] = ACTIONS(2799),
    [anon_sym__Alignas] = ACTIONS(2799),
    [sym_primitive_type] = ACTIONS(2799),
    [anon_sym_enum] = ACTIONS(2799),
    [anon_sym_class] = ACTIONS(2799),
    [anon_sym_struct] = ACTIONS(2799),
    [anon_sym_union] = ACTIONS(2799),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2799),
    [anon_sym_decltype] = ACTIONS(2799),
    [anon_sym_explicit] = ACTIONS(2799),
    [anon_sym_typename] = ACTIONS(2799),
    [anon_sym_template] = ACTIONS(2799),
    [anon_sym_operator] = ACTIONS(2799),
    [anon_sym_friend] = ACTIONS(2799),
    [anon_sym_public] = ACTIONS(2799),
    [anon_sym_private] = ACTIONS(2799),
    [anon_sym_protected] = ACTIONS(2799),
    [anon_sym_using] = ACTIONS(2799),
    [anon_sym_static_assert] = ACTIONS(2799),
  },
  [2117] = {
    [sym_identifier] = ACTIONS(2799),
    [aux_sym_preproc_def_token1] = ACTIONS(2799),
    [aux_sym_preproc_if_token1] = ACTIONS(2799),
    [aux_sym_preproc_if_token2] = ACTIONS(2799),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(2799),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(2799),
    [sym_preproc_directive] = ACTIONS(2799),
    [anon_sym_LPAREN2] = ACTIONS(2801),
    [anon_sym_TILDE] = ACTIONS(2801),
    [anon_sym_STAR] = ACTIONS(2801),
    [anon_sym_AMP_AMP] = ACTIONS(2801),
    [anon_sym_AMP] = ACTIONS(2799),
    [anon_sym_SEMI] = ACTIONS(2801),
    [anon_sym___extension__] = ACTIONS(2799),
    [anon_sym_typedef] = ACTIONS(2799),
    [anon_sym_virtual] = ACTIONS(2799),
    [anon_sym_extern] = ACTIONS(2799),
    [anon_sym___attribute__] = ACTIONS(2799),
    [anon_sym___attribute] = ACTIONS(2799),
    [anon_sym_COLON_COLON] = ACTIONS(2801),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(2801),
    [anon_sym___declspec] = ACTIONS(2799),
    [anon_sym___based] = ACTIONS(2799),
    [anon_sym_signed] = ACTIONS(2799),
    [anon_sym_unsigned] = ACTIONS(2799),
    [anon_sym_long] = ACTIONS(2799),
    [anon_sym_short] = ACTIONS(2799),
    [anon_sym_LBRACK] = ACTIONS(2799),
    [anon_sym_static] = ACTIONS(2799),
    [anon_sym_register] = ACTIONS(2799),
    [anon_sym_inline] = ACTIONS(2799),
    [anon_sym___inline] = ACTIONS(2799),
    [anon_sym___inline__] = ACTIONS(2799),
    [anon_sym___forceinline] = ACTIONS(2799),
    [anon_sym_thread_local] = ACTIONS(2799),
    [anon_sym___thread] = ACTIONS(2799),
    [anon_sym_const] = ACTIONS(2799),
    [anon_sym_constexpr] = ACTIONS(2799),
    [anon_sym_volatile] = ACTIONS(2799),
    [anon_sym_restrict] = ACTIONS(2799),
    [anon_sym___restrict__] = ACTIONS(2799),
    [anon_sym__Atomic] = ACTIONS(2799),
    [anon_sym__Noreturn] = ACTIONS(2799),
    [anon_sym_noreturn] = ACTIONS(2799),
    [anon_sym__Nonnull] = ACTIONS(2799),
    [anon_sym_mutable] = ACTIONS(2799),
    [anon_sym_constinit] = ACTIONS(2799),
    [anon_sym_consteval] = ACTIONS(2799),
    [anon_sym_alignas] = ACTIONS(2799),
    [anon_sym__Alignas] = ACTIONS(2799),
    [sym_primitive_type] = ACTIONS(2799),
    [anon_sym_enum] = ACTIONS(2799),
    [anon_sym_class] = ACTIONS(2799),
    [anon_sym_struct] = ACTIONS(2799),
    [anon_sym_union] = ACTIONS(2799),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2799),
    [anon_sym_decltype] = ACTIONS(2799),
    [anon_sym_explicit] = ACTIONS(2799),
    [anon_sym_typename] = ACTIONS(2799),
    [anon_sym_template] = ACTIONS(2799),
    [anon_sym_operator] = ACTIONS(2799),
    [anon_sym_friend] = ACTIONS(2799),
    [anon_sym_public] = ACTIONS(2799),
    [anon_sym_private] = ACTIONS(2799),
    [anon_sym_protected] = ACTIONS(2799),
    [anon_sym_using] = ACTIONS(2799),
    [anon_sym_static_assert] = ACTIONS(2799),
  },
  [2118] = {
    [sym_identifier] = ACTIONS(5423),
    [aux_sym_preproc_def_token1] = ACTIONS(5423),
    [aux_sym_preproc_if_token1] = ACTIONS(5423),
    [aux_sym_preproc_ifdef_token1] = ACTIONS(5423),
    [aux_sym_preproc_ifdef_token2] = ACTIONS(5423),
    [sym_preproc_directive] = ACTIONS(5423),
    [anon_sym_LPAREN2] = ACTIONS(5425),
    [anon_sym_TILDE] = ACTIONS(5425),
    [anon_sym_STAR] = ACTIONS(5425),
    [anon_sym_AMP_AMP] = ACTIONS(5425),
    [anon_sym_AMP] = ACTIONS(5423),
    [anon_sym_SEMI] = ACTIONS(5425),
    [anon_sym___extension__] = ACTIONS(5423),
    [anon_sym_typedef] = ACTIONS(5423),
    [anon_sym_virtual] = ACTIONS(5423),
    [anon_sym_extern] = ACTIONS(5423),
    [anon_sym___attribute__] = ACTIONS(5423),
    [anon_sym___attribute] = ACTIONS(5423),
    [anon_sym_COLON_COLON] = ACTIONS(5425),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5425),
    [anon_sym___declspec] = ACTIONS(5423),
    [anon_sym___based] = ACTIONS(5423),
    [anon_sym_RBRACE] = ACTIONS(5425),
    [anon_sym_signed] = ACTIONS(5423),
    [anon_sym_unsigned] = ACTIONS(5423),
    [anon_sym_long] = ACTIONS(5423),
    [anon_sym_short] = ACTIONS(5423),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_static] = ACTIONS(5423),
    [anon_sym_register] = ACTIONS(5423),
    [anon_sym_inline] = ACTIONS(5423),
    [anon_sym___inline] = ACTIONS(5423),
    [anon_sym___inline__] = ACTIONS(5423),
    [anon_sym___forceinline] = ACTIONS(5423),
    [anon_sym_thread_local] = ACTIONS(5423),
    [anon_sym___thread] = ACTIONS(5423),
    [anon_sym_const] = ACTIONS(5423),
    [anon_sym_constexpr] = ACTIONS(5423),
    [anon_sym_volatile] = ACTIONS(5423),
    [anon_sym_restrict] = ACTIONS(5423),
    [anon_sym___restrict__] = ACTIONS(5423),
    [anon_sym__Atomic] = ACTIONS(5423),
    [anon_sym__Noreturn] = ACTIONS(5423),
    [anon_sym_noreturn] = ACTIONS(5423),
    [anon_sym__Nonnull] = ACTIONS(5423),
    [anon_sym_mutable] = ACTIONS(5423),
    [anon_sym_constinit] = ACTIONS(5423),
    [anon_sym_consteval] = ACTIONS(5423),
    [anon_sym_alignas] = ACTIONS(5423),
    [anon_sym__Alignas] = ACTIONS(5423),
    [sym_primitive_type] = ACTIONS(5423),
    [anon_sym_enum] = ACTIONS(5423),
    [anon_sym_class] = ACTIONS(5423),
    [anon_sym_struct] = ACTIONS(5423),
    [anon_sym_union] = ACTIONS(5423),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5423),
    [anon_sym_decltype] = ACTIONS(5423),
    [anon_sym_explicit] = ACTIONS(5423),
    [anon_sym_typename] = ACTIONS(5423),
    [anon_sym_template] = ACTIONS(5423),
    [anon_sym_operator] = ACTIONS(5423),
    [anon_sym_friend] = ACTIONS(5423),
    [anon_sym_public] = ACTIONS(5423),
    [anon_sym_private] = ACTIONS(5423),
    [anon_sym_protected] = ACTIONS(5423),
    [anon_sym_using] = ACTIONS(5423),
    [anon_sym_static_assert] = ACTIONS(5423),
  },
  [2119] = {
    [sym_identifier] = ACTIONS(5361),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5363),
    [anon_sym_COMMA] = ACTIONS(5363),
    [anon_sym_RPAREN] = ACTIONS(5363),
    [anon_sym_LPAREN2] = ACTIONS(5363),
    [anon_sym_TILDE] = ACTIONS(5363),
    [anon_sym_STAR] = ACTIONS(5363),
    [anon_sym_PIPE_PIPE] = ACTIONS(5363),
    [anon_sym_AMP_AMP] = ACTIONS(5363),
    [anon_sym_AMP] = ACTIONS(5361),
    [anon_sym_SEMI] = ACTIONS(5363),
    [anon_sym___extension__] = ACTIONS(5361),
    [anon_sym_virtual] = ACTIONS(5361),
    [anon_sym_extern] = ACTIONS(5361),
    [anon_sym___attribute__] = ACTIONS(5361),
    [anon_sym___attribute] = ACTIONS(5361),
    [anon_sym_COLON_COLON] = ACTIONS(5365),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5363),
    [anon_sym___declspec] = ACTIONS(5361),
    [anon_sym___based] = ACTIONS(5361),
    [anon_sym___cdecl] = ACTIONS(5361),
    [anon_sym___clrcall] = ACTIONS(5361),
    [anon_sym___stdcall] = ACTIONS(5361),
    [anon_sym___fastcall] = ACTIONS(5361),
    [anon_sym___thiscall] = ACTIONS(5361),
    [anon_sym___vectorcall] = ACTIONS(5361),
    [anon_sym_LBRACE] = ACTIONS(5363),
    [anon_sym_LBRACK] = ACTIONS(5361),
    [anon_sym_static] = ACTIONS(5361),
    [anon_sym_EQ] = ACTIONS(5363),
    [anon_sym_register] = ACTIONS(5361),
    [anon_sym_inline] = ACTIONS(5361),
    [anon_sym___inline] = ACTIONS(5361),
    [anon_sym___inline__] = ACTIONS(5361),
    [anon_sym___forceinline] = ACTIONS(5361),
    [anon_sym_thread_local] = ACTIONS(5361),
    [anon_sym___thread] = ACTIONS(5361),
    [anon_sym_const] = ACTIONS(5361),
    [anon_sym_constexpr] = ACTIONS(5361),
    [anon_sym_volatile] = ACTIONS(5361),
    [anon_sym_restrict] = ACTIONS(5361),
    [anon_sym___restrict__] = ACTIONS(5361),
    [anon_sym__Atomic] = ACTIONS(5361),
    [anon_sym__Noreturn] = ACTIONS(5361),
    [anon_sym_noreturn] = ACTIONS(5361),
    [anon_sym__Nonnull] = ACTIONS(5361),
    [anon_sym_mutable] = ACTIONS(5361),
    [anon_sym_constinit] = ACTIONS(5361),
    [anon_sym_consteval] = ACTIONS(5361),
    [anon_sym_alignas] = ACTIONS(5361),
    [anon_sym__Alignas] = ACTIONS(5361),
    [anon_sym_COLON] = ACTIONS(5361),
    [anon_sym_or] = ACTIONS(5361),
    [anon_sym_and] = ACTIONS(5361),
    [anon_sym_asm] = ACTIONS(5361),
    [anon_sym___asm__] = ACTIONS(5361),
    [anon_sym___asm] = ACTIONS(5361),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5361),
    [anon_sym_decltype] = ACTIONS(5361),
    [anon_sym_final] = ACTIONS(5361),
    [anon_sym_override] = ACTIONS(5361),
    [anon_sym_template] = ACTIONS(5361),
    [anon_sym_GT2] = ACTIONS(5363),
    [anon_sym_operator] = ACTIONS(5361),
    [anon_sym_try] = ACTIONS(5361),
    [anon_sym_requires] = ACTIONS(5361),
  },
  [2120] = {
    [sym_attribute_specifier] = STATE(2206),
    [sym_identifier] = ACTIONS(5887),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5889),
    [anon_sym_COMMA] = ACTIONS(5889),
    [anon_sym_RPAREN] = ACTIONS(5889),
    [aux_sym_preproc_if_token2] = ACTIONS(5889),
    [aux_sym_preproc_else_token1] = ACTIONS(5889),
    [aux_sym_preproc_elif_token1] = ACTIONS(5887),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5889),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5889),
    [anon_sym_LPAREN2] = ACTIONS(5889),
    [anon_sym_DASH] = ACTIONS(5887),
    [anon_sym_PLUS] = ACTIONS(5887),
    [anon_sym_STAR] = ACTIONS(5887),
    [anon_sym_SLASH] = ACTIONS(5887),
    [anon_sym_PERCENT] = ACTIONS(5887),
    [anon_sym_PIPE_PIPE] = ACTIONS(5889),
    [anon_sym_AMP_AMP] = ACTIONS(5889),
    [anon_sym_PIPE] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5887),
    [anon_sym_AMP] = ACTIONS(5887),
    [anon_sym_EQ_EQ] = ACTIONS(5889),
    [anon_sym_BANG_EQ] = ACTIONS(5889),
    [anon_sym_GT] = ACTIONS(5887),
    [anon_sym_GT_EQ] = ACTIONS(5889),
    [anon_sym_LT_EQ] = ACTIONS(5887),
    [anon_sym_LT] = ACTIONS(5887),
    [anon_sym_LT_LT] = ACTIONS(5887),
    [anon_sym_GT_GT] = ACTIONS(5887),
    [anon_sym_SEMI] = ACTIONS(5889),
    [anon_sym___attribute__] = ACTIONS(5379),
    [anon_sym___attribute] = ACTIONS(5379),
    [anon_sym_LBRACE] = ACTIONS(5889),
    [anon_sym_RBRACE] = ACTIONS(5889),
    [anon_sym_LBRACK] = ACTIONS(5889),
    [anon_sym_RBRACK] = ACTIONS(5889),
    [anon_sym_EQ] = ACTIONS(5887),
    [anon_sym_COLON] = ACTIONS(5889),
    [anon_sym_QMARK] = ACTIONS(5889),
    [anon_sym_STAR_EQ] = ACTIONS(5889),
    [anon_sym_SLASH_EQ] = ACTIONS(5889),
    [anon_sym_PERCENT_EQ] = ACTIONS(5889),
    [anon_sym_PLUS_EQ] = ACTIONS(5889),
    [anon_sym_DASH_EQ] = ACTIONS(5889),
    [anon_sym_LT_LT_EQ] = ACTIONS(5889),
    [anon_sym_GT_GT_EQ] = ACTIONS(5889),
    [anon_sym_AMP_EQ] = ACTIONS(5889),
    [anon_sym_CARET_EQ] = ACTIONS(5889),
    [anon_sym_PIPE_EQ] = ACTIONS(5889),
    [anon_sym_and_eq] = ACTIONS(5887),
    [anon_sym_or_eq] = ACTIONS(5887),
    [anon_sym_xor_eq] = ACTIONS(5887),
    [anon_sym_LT_EQ_GT] = ACTIONS(5889),
    [anon_sym_or] = ACTIONS(5887),
    [anon_sym_and] = ACTIONS(5887),
    [anon_sym_bitor] = ACTIONS(5887),
    [anon_sym_xor] = ACTIONS(5887),
    [anon_sym_bitand] = ACTIONS(5887),
    [anon_sym_not_eq] = ACTIONS(5887),
    [anon_sym_DASH_DASH] = ACTIONS(5889),
    [anon_sym_PLUS_PLUS] = ACTIONS(5889),
    [anon_sym_DOT] = ACTIONS(5887),
    [anon_sym_DOT_STAR] = ACTIONS(5889),
    [anon_sym_DASH_GT] = ACTIONS(5889),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5887),
    [anon_sym_decltype] = ACTIONS(5887),
  },
  [2121] = {
    [sym_attribute_declaration] = STATE(2255),
    [sym_parameter_list] = STATE(2187),
    [aux_sym_attributed_declarator_repeat1] = STATE(2255),
    [sym_identifier] = ACTIONS(5891),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5893),
    [anon_sym_COMMA] = ACTIONS(5893),
    [anon_sym_RPAREN] = ACTIONS(5893),
    [aux_sym_preproc_if_token2] = ACTIONS(5893),
    [aux_sym_preproc_else_token1] = ACTIONS(5893),
    [aux_sym_preproc_elif_token1] = ACTIONS(5891),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5893),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5893),
    [anon_sym_LPAREN2] = ACTIONS(5895),
    [anon_sym_DASH] = ACTIONS(5891),
    [anon_sym_PLUS] = ACTIONS(5891),
    [anon_sym_STAR] = ACTIONS(5891),
    [anon_sym_SLASH] = ACTIONS(5891),
    [anon_sym_PERCENT] = ACTIONS(5891),
    [anon_sym_PIPE_PIPE] = ACTIONS(5893),
    [anon_sym_AMP_AMP] = ACTIONS(5893),
    [anon_sym_PIPE] = ACTIONS(5891),
    [anon_sym_CARET] = ACTIONS(5891),
    [anon_sym_AMP] = ACTIONS(5891),
    [anon_sym_EQ_EQ] = ACTIONS(5893),
    [anon_sym_BANG_EQ] = ACTIONS(5893),
    [anon_sym_GT] = ACTIONS(5891),
    [anon_sym_GT_EQ] = ACTIONS(5893),
    [anon_sym_LT_EQ] = ACTIONS(5891),
    [anon_sym_LT] = ACTIONS(5891),
    [anon_sym_LT_LT] = ACTIONS(5891),
    [anon_sym_GT_GT] = ACTIONS(5891),
    [anon_sym_SEMI] = ACTIONS(5893),
    [anon_sym___attribute__] = ACTIONS(5891),
    [anon_sym___attribute] = ACTIONS(5891),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5897),
    [anon_sym_RBRACE] = ACTIONS(5893),
    [anon_sym_LBRACK] = ACTIONS(5899),
    [anon_sym_RBRACK] = ACTIONS(5893),
    [anon_sym_EQ] = ACTIONS(5891),
    [anon_sym_COLON] = ACTIONS(5893),
    [anon_sym_QMARK] = ACTIONS(5893),
    [anon_sym_STAR_EQ] = ACTIONS(5893),
    [anon_sym_SLASH_EQ] = ACTIONS(5893),
    [anon_sym_PERCENT_EQ] = ACTIONS(5893),
    [anon_sym_PLUS_EQ] = ACTIONS(5893),
    [anon_sym_DASH_EQ] = ACTIONS(5893),
    [anon_sym_LT_LT_EQ] = ACTIONS(5893),
    [anon_sym_GT_GT_EQ] = ACTIONS(5893),
    [anon_sym_AMP_EQ] = ACTIONS(5893),
    [anon_sym_CARET_EQ] = ACTIONS(5893),
    [anon_sym_PIPE_EQ] = ACTIONS(5893),
    [anon_sym_and_eq] = ACTIONS(5891),
    [anon_sym_or_eq] = ACTIONS(5891),
    [anon_sym_xor_eq] = ACTIONS(5891),
    [anon_sym_LT_EQ_GT] = ACTIONS(5893),
    [anon_sym_or] = ACTIONS(5891),
    [anon_sym_and] = ACTIONS(5891),
    [anon_sym_bitor] = ACTIONS(5891),
    [anon_sym_xor] = ACTIONS(5891),
    [anon_sym_bitand] = ACTIONS(5891),
    [anon_sym_not_eq] = ACTIONS(5891),
    [anon_sym_DASH_DASH] = ACTIONS(5893),
    [anon_sym_PLUS_PLUS] = ACTIONS(5893),
    [anon_sym_DOT] = ACTIONS(5891),
    [anon_sym_DOT_STAR] = ACTIONS(5893),
    [anon_sym_DASH_GT] = ACTIONS(5893),
    [sym_comment] = ACTIONS(3),
  },
  [2122] = {
    [sym_attribute_specifier] = STATE(2188),
    [sym_identifier] = ACTIONS(5901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5903),
    [anon_sym_COMMA] = ACTIONS(5903),
    [anon_sym_RPAREN] = ACTIONS(5903),
    [aux_sym_preproc_if_token2] = ACTIONS(5903),
    [aux_sym_preproc_else_token1] = ACTIONS(5903),
    [aux_sym_preproc_elif_token1] = ACTIONS(5901),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5903),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5903),
    [anon_sym_LPAREN2] = ACTIONS(5903),
    [anon_sym_DASH] = ACTIONS(5901),
    [anon_sym_PLUS] = ACTIONS(5901),
    [anon_sym_STAR] = ACTIONS(5901),
    [anon_sym_SLASH] = ACTIONS(5901),
    [anon_sym_PERCENT] = ACTIONS(5901),
    [anon_sym_PIPE_PIPE] = ACTIONS(5903),
    [anon_sym_AMP_AMP] = ACTIONS(5903),
    [anon_sym_PIPE] = ACTIONS(5901),
    [anon_sym_CARET] = ACTIONS(5901),
    [anon_sym_AMP] = ACTIONS(5901),
    [anon_sym_EQ_EQ] = ACTIONS(5903),
    [anon_sym_BANG_EQ] = ACTIONS(5903),
    [anon_sym_GT] = ACTIONS(5901),
    [anon_sym_GT_EQ] = ACTIONS(5903),
    [anon_sym_LT_EQ] = ACTIONS(5901),
    [anon_sym_LT] = ACTIONS(5901),
    [anon_sym_LT_LT] = ACTIONS(5901),
    [anon_sym_GT_GT] = ACTIONS(5901),
    [anon_sym_SEMI] = ACTIONS(5903),
    [anon_sym___attribute__] = ACTIONS(5379),
    [anon_sym___attribute] = ACTIONS(5379),
    [anon_sym_LBRACE] = ACTIONS(5903),
    [anon_sym_RBRACE] = ACTIONS(5903),
    [anon_sym_LBRACK] = ACTIONS(5903),
    [anon_sym_RBRACK] = ACTIONS(5903),
    [anon_sym_EQ] = ACTIONS(5901),
    [anon_sym_COLON] = ACTIONS(5903),
    [anon_sym_QMARK] = ACTIONS(5903),
    [anon_sym_STAR_EQ] = ACTIONS(5903),
    [anon_sym_SLASH_EQ] = ACTIONS(5903),
    [anon_sym_PERCENT_EQ] = ACTIONS(5903),
    [anon_sym_PLUS_EQ] = ACTIONS(5903),
    [anon_sym_DASH_EQ] = ACTIONS(5903),
    [anon_sym_LT_LT_EQ] = ACTIONS(5903),
    [anon_sym_GT_GT_EQ] = ACTIONS(5903),
    [anon_sym_AMP_EQ] = ACTIONS(5903),
    [anon_sym_CARET_EQ] = ACTIONS(5903),
    [anon_sym_PIPE_EQ] = ACTIONS(5903),
    [anon_sym_and_eq] = ACTIONS(5901),
    [anon_sym_or_eq] = ACTIONS(5901),
    [anon_sym_xor_eq] = ACTIONS(5901),
    [anon_sym_LT_EQ_GT] = ACTIONS(5903),
    [anon_sym_or] = ACTIONS(5901),
    [anon_sym_and] = ACTIONS(5901),
    [anon_sym_bitor] = ACTIONS(5901),
    [anon_sym_xor] = ACTIONS(5901),
    [anon_sym_bitand] = ACTIONS(5901),
    [anon_sym_not_eq] = ACTIONS(5901),
    [anon_sym_DASH_DASH] = ACTIONS(5903),
    [anon_sym_PLUS_PLUS] = ACTIONS(5903),
    [anon_sym_DOT] = ACTIONS(5901),
    [anon_sym_DOT_STAR] = ACTIONS(5903),
    [anon_sym_DASH_GT] = ACTIONS(5903),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5901),
    [anon_sym_decltype] = ACTIONS(5901),
  },
  [2123] = {
    [sym_attribute_specifier] = STATE(2230),
    [sym_identifier] = ACTIONS(5905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5907),
    [anon_sym_COMMA] = ACTIONS(5907),
    [anon_sym_RPAREN] = ACTIONS(5907),
    [aux_sym_preproc_if_token2] = ACTIONS(5907),
    [aux_sym_preproc_else_token1] = ACTIONS(5907),
    [aux_sym_preproc_elif_token1] = ACTIONS(5905),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5907),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5907),
    [anon_sym_LPAREN2] = ACTIONS(5907),
    [anon_sym_DASH] = ACTIONS(5905),
    [anon_sym_PLUS] = ACTIONS(5905),
    [anon_sym_STAR] = ACTIONS(5905),
    [anon_sym_SLASH] = ACTIONS(5905),
    [anon_sym_PERCENT] = ACTIONS(5905),
    [anon_sym_PIPE_PIPE] = ACTIONS(5907),
    [anon_sym_AMP_AMP] = ACTIONS(5907),
    [anon_sym_PIPE] = ACTIONS(5905),
    [anon_sym_CARET] = ACTIONS(5905),
    [anon_sym_AMP] = ACTIONS(5905),
    [anon_sym_EQ_EQ] = ACTIONS(5907),
    [anon_sym_BANG_EQ] = ACTIONS(5907),
    [anon_sym_GT] = ACTIONS(5905),
    [anon_sym_GT_EQ] = ACTIONS(5907),
    [anon_sym_LT_EQ] = ACTIONS(5905),
    [anon_sym_LT] = ACTIONS(5905),
    [anon_sym_LT_LT] = ACTIONS(5905),
    [anon_sym_GT_GT] = ACTIONS(5905),
    [anon_sym_SEMI] = ACTIONS(5907),
    [anon_sym___attribute__] = ACTIONS(5379),
    [anon_sym___attribute] = ACTIONS(5379),
    [anon_sym_LBRACE] = ACTIONS(5907),
    [anon_sym_RBRACE] = ACTIONS(5907),
    [anon_sym_LBRACK] = ACTIONS(5907),
    [anon_sym_RBRACK] = ACTIONS(5907),
    [anon_sym_EQ] = ACTIONS(5905),
    [anon_sym_COLON] = ACTIONS(5907),
    [anon_sym_QMARK] = ACTIONS(5907),
    [anon_sym_STAR_EQ] = ACTIONS(5907),
    [anon_sym_SLASH_EQ] = ACTIONS(5907),
    [anon_sym_PERCENT_EQ] = ACTIONS(5907),
    [anon_sym_PLUS_EQ] = ACTIONS(5907),
    [anon_sym_DASH_EQ] = ACTIONS(5907),
    [anon_sym_LT_LT_EQ] = ACTIONS(5907),
    [anon_sym_GT_GT_EQ] = ACTIONS(5907),
    [anon_sym_AMP_EQ] = ACTIONS(5907),
    [anon_sym_CARET_EQ] = ACTIONS(5907),
    [anon_sym_PIPE_EQ] = ACTIONS(5907),
    [anon_sym_and_eq] = ACTIONS(5905),
    [anon_sym_or_eq] = ACTIONS(5905),
    [anon_sym_xor_eq] = ACTIONS(5905),
    [anon_sym_LT_EQ_GT] = ACTIONS(5907),
    [anon_sym_or] = ACTIONS(5905),
    [anon_sym_and] = ACTIONS(5905),
    [anon_sym_bitor] = ACTIONS(5905),
    [anon_sym_xor] = ACTIONS(5905),
    [anon_sym_bitand] = ACTIONS(5905),
    [anon_sym_not_eq] = ACTIONS(5905),
    [anon_sym_DASH_DASH] = ACTIONS(5907),
    [anon_sym_PLUS_PLUS] = ACTIONS(5907),
    [anon_sym_DOT] = ACTIONS(5905),
    [anon_sym_DOT_STAR] = ACTIONS(5907),
    [anon_sym_DASH_GT] = ACTIONS(5907),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5905),
    [anon_sym_decltype] = ACTIONS(5905),
  },
  [2124] = {
    [sym_string_literal] = STATE(2570),
    [sym_template_argument_list] = STATE(3643),
    [sym_raw_string_literal] = STATE(2570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4035),
    [anon_sym_COMMA] = ACTIONS(4035),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_DASH] = ACTIONS(4043),
    [anon_sym_PLUS] = ACTIONS(4043),
    [anon_sym_STAR] = ACTIONS(4043),
    [anon_sym_SLASH] = ACTIONS(4043),
    [anon_sym_PERCENT] = ACTIONS(4043),
    [anon_sym_PIPE_PIPE] = ACTIONS(4035),
    [anon_sym_AMP_AMP] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4043),
    [anon_sym_CARET] = ACTIONS(4043),
    [anon_sym_AMP] = ACTIONS(4043),
    [anon_sym_EQ_EQ] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4043),
    [anon_sym_GT_EQ] = ACTIONS(4035),
    [anon_sym_LT_EQ] = ACTIONS(4043),
    [anon_sym_LT] = ACTIONS(4929),
    [anon_sym_LT_LT] = ACTIONS(4043),
    [anon_sym_GT_GT] = ACTIONS(4043),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACE] = ACTIONS(4059),
    [anon_sym_LBRACK] = ACTIONS(4035),
    [anon_sym_EQ] = ACTIONS(4067),
    [anon_sym_COLON] = ACTIONS(4075),
    [anon_sym_QMARK] = ACTIONS(4035),
    [anon_sym_STAR_EQ] = ACTIONS(4071),
    [anon_sym_SLASH_EQ] = ACTIONS(4071),
    [anon_sym_PERCENT_EQ] = ACTIONS(4071),
    [anon_sym_PLUS_EQ] = ACTIONS(4071),
    [anon_sym_DASH_EQ] = ACTIONS(4071),
    [anon_sym_LT_LT_EQ] = ACTIONS(4071),
    [anon_sym_GT_GT_EQ] = ACTIONS(4071),
    [anon_sym_AMP_EQ] = ACTIONS(4071),
    [anon_sym_CARET_EQ] = ACTIONS(4071),
    [anon_sym_PIPE_EQ] = ACTIONS(4071),
    [anon_sym_and_eq] = ACTIONS(4071),
    [anon_sym_or_eq] = ACTIONS(4071),
    [anon_sym_xor_eq] = ACTIONS(4071),
    [anon_sym_LT_EQ_GT] = ACTIONS(4035),
    [anon_sym_or] = ACTIONS(4043),
    [anon_sym_and] = ACTIONS(4043),
    [anon_sym_bitor] = ACTIONS(4035),
    [anon_sym_xor] = ACTIONS(4043),
    [anon_sym_bitand] = ACTIONS(4035),
    [anon_sym_not_eq] = ACTIONS(4035),
    [anon_sym_DASH_DASH] = ACTIONS(4035),
    [anon_sym_PLUS_PLUS] = ACTIONS(4035),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_DOT_STAR] = ACTIONS(4035),
    [anon_sym_DASH_GT] = ACTIONS(4035),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
  },
  [2125] = {
    [sym_attribute_declaration] = STATE(2255),
    [sym_parameter_list] = STATE(2187),
    [aux_sym_attributed_declarator_repeat1] = STATE(2255),
    [sym_identifier] = ACTIONS(5909),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5911),
    [anon_sym_COMMA] = ACTIONS(5911),
    [anon_sym_RPAREN] = ACTIONS(5911),
    [aux_sym_preproc_if_token2] = ACTIONS(5911),
    [aux_sym_preproc_else_token1] = ACTIONS(5911),
    [aux_sym_preproc_elif_token1] = ACTIONS(5909),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5911),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5911),
    [anon_sym_LPAREN2] = ACTIONS(5895),
    [anon_sym_DASH] = ACTIONS(5909),
    [anon_sym_PLUS] = ACTIONS(5909),
    [anon_sym_STAR] = ACTIONS(5909),
    [anon_sym_SLASH] = ACTIONS(5909),
    [anon_sym_PERCENT] = ACTIONS(5909),
    [anon_sym_PIPE_PIPE] = ACTIONS(5911),
    [anon_sym_AMP_AMP] = ACTIONS(5911),
    [anon_sym_PIPE] = ACTIONS(5909),
    [anon_sym_CARET] = ACTIONS(5909),
    [anon_sym_AMP] = ACTIONS(5909),
    [anon_sym_EQ_EQ] = ACTIONS(5911),
    [anon_sym_BANG_EQ] = ACTIONS(5911),
    [anon_sym_GT] = ACTIONS(5909),
    [anon_sym_GT_EQ] = ACTIONS(5911),
    [anon_sym_LT_EQ] = ACTIONS(5909),
    [anon_sym_LT] = ACTIONS(5909),
    [anon_sym_LT_LT] = ACTIONS(5909),
    [anon_sym_GT_GT] = ACTIONS(5909),
    [anon_sym_SEMI] = ACTIONS(5911),
    [anon_sym___attribute__] = ACTIONS(5909),
    [anon_sym___attribute] = ACTIONS(5909),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5897),
    [anon_sym_RBRACE] = ACTIONS(5911),
    [anon_sym_LBRACK] = ACTIONS(5899),
    [anon_sym_RBRACK] = ACTIONS(5911),
    [anon_sym_EQ] = ACTIONS(5909),
    [anon_sym_COLON] = ACTIONS(5911),
    [anon_sym_QMARK] = ACTIONS(5911),
    [anon_sym_STAR_EQ] = ACTIONS(5911),
    [anon_sym_SLASH_EQ] = ACTIONS(5911),
    [anon_sym_PERCENT_EQ] = ACTIONS(5911),
    [anon_sym_PLUS_EQ] = ACTIONS(5911),
    [anon_sym_DASH_EQ] = ACTIONS(5911),
    [anon_sym_LT_LT_EQ] = ACTIONS(5911),
    [anon_sym_GT_GT_EQ] = ACTIONS(5911),
    [anon_sym_AMP_EQ] = ACTIONS(5911),
    [anon_sym_CARET_EQ] = ACTIONS(5911),
    [anon_sym_PIPE_EQ] = ACTIONS(5911),
    [anon_sym_and_eq] = ACTIONS(5909),
    [anon_sym_or_eq] = ACTIONS(5909),
    [anon_sym_xor_eq] = ACTIONS(5909),
    [anon_sym_LT_EQ_GT] = ACTIONS(5911),
    [anon_sym_or] = ACTIONS(5909),
    [anon_sym_and] = ACTIONS(5909),
    [anon_sym_bitor] = ACTIONS(5909),
    [anon_sym_xor] = ACTIONS(5909),
    [anon_sym_bitand] = ACTIONS(5909),
    [anon_sym_not_eq] = ACTIONS(5909),
    [anon_sym_DASH_DASH] = ACTIONS(5911),
    [anon_sym_PLUS_PLUS] = ACTIONS(5911),
    [anon_sym_DOT] = ACTIONS(5909),
    [anon_sym_DOT_STAR] = ACTIONS(5911),
    [anon_sym_DASH_GT] = ACTIONS(5911),
    [sym_comment] = ACTIONS(3),
  },
  [2126] = {
    [sym_attribute_specifier] = STATE(2236),
    [sym_identifier] = ACTIONS(5913),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5915),
    [anon_sym_COMMA] = ACTIONS(5915),
    [anon_sym_RPAREN] = ACTIONS(5915),
    [aux_sym_preproc_if_token2] = ACTIONS(5915),
    [aux_sym_preproc_else_token1] = ACTIONS(5915),
    [aux_sym_preproc_elif_token1] = ACTIONS(5913),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5915),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5915),
    [anon_sym_LPAREN2] = ACTIONS(5915),
    [anon_sym_DASH] = ACTIONS(5913),
    [anon_sym_PLUS] = ACTIONS(5913),
    [anon_sym_STAR] = ACTIONS(5913),
    [anon_sym_SLASH] = ACTIONS(5913),
    [anon_sym_PERCENT] = ACTIONS(5913),
    [anon_sym_PIPE_PIPE] = ACTIONS(5915),
    [anon_sym_AMP_AMP] = ACTIONS(5915),
    [anon_sym_PIPE] = ACTIONS(5913),
    [anon_sym_CARET] = ACTIONS(5913),
    [anon_sym_AMP] = ACTIONS(5913),
    [anon_sym_EQ_EQ] = ACTIONS(5915),
    [anon_sym_BANG_EQ] = ACTIONS(5915),
    [anon_sym_GT] = ACTIONS(5913),
    [anon_sym_GT_EQ] = ACTIONS(5915),
    [anon_sym_LT_EQ] = ACTIONS(5913),
    [anon_sym_LT] = ACTIONS(5913),
    [anon_sym_LT_LT] = ACTIONS(5913),
    [anon_sym_GT_GT] = ACTIONS(5913),
    [anon_sym_SEMI] = ACTIONS(5915),
    [anon_sym___attribute__] = ACTIONS(5379),
    [anon_sym___attribute] = ACTIONS(5379),
    [anon_sym_LBRACE] = ACTIONS(5915),
    [anon_sym_RBRACE] = ACTIONS(5915),
    [anon_sym_LBRACK] = ACTIONS(5915),
    [anon_sym_RBRACK] = ACTIONS(5915),
    [anon_sym_EQ] = ACTIONS(5913),
    [anon_sym_COLON] = ACTIONS(5915),
    [anon_sym_QMARK] = ACTIONS(5915),
    [anon_sym_STAR_EQ] = ACTIONS(5915),
    [anon_sym_SLASH_EQ] = ACTIONS(5915),
    [anon_sym_PERCENT_EQ] = ACTIONS(5915),
    [anon_sym_PLUS_EQ] = ACTIONS(5915),
    [anon_sym_DASH_EQ] = ACTIONS(5915),
    [anon_sym_LT_LT_EQ] = ACTIONS(5915),
    [anon_sym_GT_GT_EQ] = ACTIONS(5915),
    [anon_sym_AMP_EQ] = ACTIONS(5915),
    [anon_sym_CARET_EQ] = ACTIONS(5915),
    [anon_sym_PIPE_EQ] = ACTIONS(5915),
    [anon_sym_and_eq] = ACTIONS(5913),
    [anon_sym_or_eq] = ACTIONS(5913),
    [anon_sym_xor_eq] = ACTIONS(5913),
    [anon_sym_LT_EQ_GT] = ACTIONS(5915),
    [anon_sym_or] = ACTIONS(5913),
    [anon_sym_and] = ACTIONS(5913),
    [anon_sym_bitor] = ACTIONS(5913),
    [anon_sym_xor] = ACTIONS(5913),
    [anon_sym_bitand] = ACTIONS(5913),
    [anon_sym_not_eq] = ACTIONS(5913),
    [anon_sym_DASH_DASH] = ACTIONS(5915),
    [anon_sym_PLUS_PLUS] = ACTIONS(5915),
    [anon_sym_DOT] = ACTIONS(5913),
    [anon_sym_DOT_STAR] = ACTIONS(5915),
    [anon_sym_DASH_GT] = ACTIONS(5915),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5913),
    [anon_sym_decltype] = ACTIONS(5913),
  },
  [2127] = {
    [sym_attribute_specifier] = STATE(2239),
    [sym_identifier] = ACTIONS(5917),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5919),
    [anon_sym_COMMA] = ACTIONS(5919),
    [anon_sym_RPAREN] = ACTIONS(5919),
    [aux_sym_preproc_if_token2] = ACTIONS(5919),
    [aux_sym_preproc_else_token1] = ACTIONS(5919),
    [aux_sym_preproc_elif_token1] = ACTIONS(5917),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5919),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5919),
    [anon_sym_LPAREN2] = ACTIONS(5919),
    [anon_sym_DASH] = ACTIONS(5917),
    [anon_sym_PLUS] = ACTIONS(5917),
    [anon_sym_STAR] = ACTIONS(5917),
    [anon_sym_SLASH] = ACTIONS(5917),
    [anon_sym_PERCENT] = ACTIONS(5917),
    [anon_sym_PIPE_PIPE] = ACTIONS(5919),
    [anon_sym_AMP_AMP] = ACTIONS(5919),
    [anon_sym_PIPE] = ACTIONS(5917),
    [anon_sym_CARET] = ACTIONS(5917),
    [anon_sym_AMP] = ACTIONS(5917),
    [anon_sym_EQ_EQ] = ACTIONS(5919),
    [anon_sym_BANG_EQ] = ACTIONS(5919),
    [anon_sym_GT] = ACTIONS(5917),
    [anon_sym_GT_EQ] = ACTIONS(5919),
    [anon_sym_LT_EQ] = ACTIONS(5917),
    [anon_sym_LT] = ACTIONS(5917),
    [anon_sym_LT_LT] = ACTIONS(5917),
    [anon_sym_GT_GT] = ACTIONS(5917),
    [anon_sym_SEMI] = ACTIONS(5919),
    [anon_sym___attribute__] = ACTIONS(5379),
    [anon_sym___attribute] = ACTIONS(5379),
    [anon_sym_LBRACE] = ACTIONS(5919),
    [anon_sym_RBRACE] = ACTIONS(5919),
    [anon_sym_LBRACK] = ACTIONS(5919),
    [anon_sym_RBRACK] = ACTIONS(5919),
    [anon_sym_EQ] = ACTIONS(5917),
    [anon_sym_COLON] = ACTIONS(5919),
    [anon_sym_QMARK] = ACTIONS(5919),
    [anon_sym_STAR_EQ] = ACTIONS(5919),
    [anon_sym_SLASH_EQ] = ACTIONS(5919),
    [anon_sym_PERCENT_EQ] = ACTIONS(5919),
    [anon_sym_PLUS_EQ] = ACTIONS(5919),
    [anon_sym_DASH_EQ] = ACTIONS(5919),
    [anon_sym_LT_LT_EQ] = ACTIONS(5919),
    [anon_sym_GT_GT_EQ] = ACTIONS(5919),
    [anon_sym_AMP_EQ] = ACTIONS(5919),
    [anon_sym_CARET_EQ] = ACTIONS(5919),
    [anon_sym_PIPE_EQ] = ACTIONS(5919),
    [anon_sym_and_eq] = ACTIONS(5917),
    [anon_sym_or_eq] = ACTIONS(5917),
    [anon_sym_xor_eq] = ACTIONS(5917),
    [anon_sym_LT_EQ_GT] = ACTIONS(5919),
    [anon_sym_or] = ACTIONS(5917),
    [anon_sym_and] = ACTIONS(5917),
    [anon_sym_bitor] = ACTIONS(5917),
    [anon_sym_xor] = ACTIONS(5917),
    [anon_sym_bitand] = ACTIONS(5917),
    [anon_sym_not_eq] = ACTIONS(5917),
    [anon_sym_DASH_DASH] = ACTIONS(5919),
    [anon_sym_PLUS_PLUS] = ACTIONS(5919),
    [anon_sym_DOT] = ACTIONS(5917),
    [anon_sym_DOT_STAR] = ACTIONS(5919),
    [anon_sym_DASH_GT] = ACTIONS(5919),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5917),
    [anon_sym_decltype] = ACTIONS(5917),
  },
  [2128] = {
    [sym_attribute_declaration] = STATE(2255),
    [sym_parameter_list] = STATE(2187),
    [aux_sym_attributed_declarator_repeat1] = STATE(2255),
    [sym_identifier] = ACTIONS(5921),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5923),
    [anon_sym_COMMA] = ACTIONS(5923),
    [anon_sym_RPAREN] = ACTIONS(5923),
    [aux_sym_preproc_if_token2] = ACTIONS(5923),
    [aux_sym_preproc_else_token1] = ACTIONS(5923),
    [aux_sym_preproc_elif_token1] = ACTIONS(5921),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5923),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5923),
    [anon_sym_LPAREN2] = ACTIONS(5895),
    [anon_sym_DASH] = ACTIONS(5921),
    [anon_sym_PLUS] = ACTIONS(5921),
    [anon_sym_STAR] = ACTIONS(5921),
    [anon_sym_SLASH] = ACTIONS(5921),
    [anon_sym_PERCENT] = ACTIONS(5921),
    [anon_sym_PIPE_PIPE] = ACTIONS(5923),
    [anon_sym_AMP_AMP] = ACTIONS(5923),
    [anon_sym_PIPE] = ACTIONS(5921),
    [anon_sym_CARET] = ACTIONS(5921),
    [anon_sym_AMP] = ACTIONS(5921),
    [anon_sym_EQ_EQ] = ACTIONS(5923),
    [anon_sym_BANG_EQ] = ACTIONS(5923),
    [anon_sym_GT] = ACTIONS(5921),
    [anon_sym_GT_EQ] = ACTIONS(5923),
    [anon_sym_LT_EQ] = ACTIONS(5921),
    [anon_sym_LT] = ACTIONS(5921),
    [anon_sym_LT_LT] = ACTIONS(5921),
    [anon_sym_GT_GT] = ACTIONS(5921),
    [anon_sym_SEMI] = ACTIONS(5923),
    [anon_sym___attribute__] = ACTIONS(5921),
    [anon_sym___attribute] = ACTIONS(5921),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5897),
    [anon_sym_RBRACE] = ACTIONS(5923),
    [anon_sym_LBRACK] = ACTIONS(5899),
    [anon_sym_RBRACK] = ACTIONS(5923),
    [anon_sym_EQ] = ACTIONS(5921),
    [anon_sym_COLON] = ACTIONS(5923),
    [anon_sym_QMARK] = ACTIONS(5923),
    [anon_sym_STAR_EQ] = ACTIONS(5923),
    [anon_sym_SLASH_EQ] = ACTIONS(5923),
    [anon_sym_PERCENT_EQ] = ACTIONS(5923),
    [anon_sym_PLUS_EQ] = ACTIONS(5923),
    [anon_sym_DASH_EQ] = ACTIONS(5923),
    [anon_sym_LT_LT_EQ] = ACTIONS(5923),
    [anon_sym_GT_GT_EQ] = ACTIONS(5923),
    [anon_sym_AMP_EQ] = ACTIONS(5923),
    [anon_sym_CARET_EQ] = ACTIONS(5923),
    [anon_sym_PIPE_EQ] = ACTIONS(5923),
    [anon_sym_and_eq] = ACTIONS(5921),
    [anon_sym_or_eq] = ACTIONS(5921),
    [anon_sym_xor_eq] = ACTIONS(5921),
    [anon_sym_LT_EQ_GT] = ACTIONS(5923),
    [anon_sym_or] = ACTIONS(5921),
    [anon_sym_and] = ACTIONS(5921),
    [anon_sym_bitor] = ACTIONS(5921),
    [anon_sym_xor] = ACTIONS(5921),
    [anon_sym_bitand] = ACTIONS(5921),
    [anon_sym_not_eq] = ACTIONS(5921),
    [anon_sym_DASH_DASH] = ACTIONS(5923),
    [anon_sym_PLUS_PLUS] = ACTIONS(5923),
    [anon_sym_DOT] = ACTIONS(5921),
    [anon_sym_DOT_STAR] = ACTIONS(5923),
    [anon_sym_DASH_GT] = ACTIONS(5923),
    [sym_comment] = ACTIONS(3),
  },
  [2129] = {
    [sym_string_literal] = STATE(2140),
    [sym_raw_string_literal] = STATE(2140),
    [aux_sym_concatenated_string_repeat1] = STATE(2140),
    [sym_identifier] = ACTIONS(5925),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5251),
    [anon_sym_COMMA] = ACTIONS(5251),
    [anon_sym_RPAREN] = ACTIONS(5251),
    [anon_sym_LPAREN2] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5253),
    [anon_sym_PLUS] = ACTIONS(5253),
    [anon_sym_STAR] = ACTIONS(5253),
    [anon_sym_SLASH] = ACTIONS(5253),
    [anon_sym_PERCENT] = ACTIONS(5253),
    [anon_sym_PIPE_PIPE] = ACTIONS(5251),
    [anon_sym_AMP_AMP] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5253),
    [anon_sym_CARET] = ACTIONS(5253),
    [anon_sym_AMP] = ACTIONS(5253),
    [anon_sym_EQ_EQ] = ACTIONS(5251),
    [anon_sym_BANG_EQ] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5253),
    [anon_sym_GT_EQ] = ACTIONS(5251),
    [anon_sym_LT_EQ] = ACTIONS(5253),
    [anon_sym_LT] = ACTIONS(5253),
    [anon_sym_LT_LT] = ACTIONS(5253),
    [anon_sym_GT_GT] = ACTIONS(5253),
    [anon_sym_LBRACK] = ACTIONS(5251),
    [anon_sym_EQ] = ACTIONS(5253),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_STAR_EQ] = ACTIONS(5251),
    [anon_sym_SLASH_EQ] = ACTIONS(5251),
    [anon_sym_PERCENT_EQ] = ACTIONS(5251),
    [anon_sym_PLUS_EQ] = ACTIONS(5251),
    [anon_sym_DASH_EQ] = ACTIONS(5251),
    [anon_sym_LT_LT_EQ] = ACTIONS(5251),
    [anon_sym_GT_GT_EQ] = ACTIONS(5251),
    [anon_sym_AMP_EQ] = ACTIONS(5251),
    [anon_sym_CARET_EQ] = ACTIONS(5251),
    [anon_sym_PIPE_EQ] = ACTIONS(5251),
    [anon_sym_and_eq] = ACTIONS(5253),
    [anon_sym_or_eq] = ACTIONS(5253),
    [anon_sym_xor_eq] = ACTIONS(5253),
    [anon_sym_LT_EQ_GT] = ACTIONS(5251),
    [anon_sym_or] = ACTIONS(5253),
    [anon_sym_and] = ACTIONS(5253),
    [anon_sym_bitor] = ACTIONS(5253),
    [anon_sym_xor] = ACTIONS(5253),
    [anon_sym_bitand] = ACTIONS(5253),
    [anon_sym_not_eq] = ACTIONS(5253),
    [anon_sym_DASH_DASH] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5251),
    [anon_sym_DOT] = ACTIONS(5253),
    [anon_sym_DOT_STAR] = ACTIONS(5251),
    [anon_sym_DASH_GT] = ACTIONS(5253),
    [anon_sym_L_DQUOTE] = ACTIONS(4899),
    [anon_sym_u_DQUOTE] = ACTIONS(4899),
    [anon_sym_U_DQUOTE] = ACTIONS(4899),
    [anon_sym_u8_DQUOTE] = ACTIONS(4899),
    [anon_sym_DQUOTE] = ACTIONS(4899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4901),
    [anon_sym_LR_DQUOTE] = ACTIONS(4901),
    [anon_sym_uR_DQUOTE] = ACTIONS(4901),
    [anon_sym_UR_DQUOTE] = ACTIONS(4901),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4901),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5251),
    [sym_literal_suffix] = ACTIONS(5253),
  },
  [2130] = {
    [sym_string_literal] = STATE(2570),
    [sym_template_argument_list] = STATE(3643),
    [sym_raw_string_literal] = STATE(2570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4035),
    [anon_sym_COMMA] = ACTIONS(4035),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_DASH] = ACTIONS(4043),
    [anon_sym_PLUS] = ACTIONS(4043),
    [anon_sym_STAR] = ACTIONS(4043),
    [anon_sym_SLASH] = ACTIONS(4043),
    [anon_sym_PERCENT] = ACTIONS(4043),
    [anon_sym_PIPE_PIPE] = ACTIONS(4035),
    [anon_sym_AMP_AMP] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4043),
    [anon_sym_CARET] = ACTIONS(4043),
    [anon_sym_AMP] = ACTIONS(4043),
    [anon_sym_EQ_EQ] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4043),
    [anon_sym_GT_EQ] = ACTIONS(4035),
    [anon_sym_LT_EQ] = ACTIONS(4043),
    [anon_sym_LT] = ACTIONS(4929),
    [anon_sym_LT_LT] = ACTIONS(4043),
    [anon_sym_GT_GT] = ACTIONS(4043),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACE] = ACTIONS(4059),
    [anon_sym_LBRACK] = ACTIONS(4035),
    [anon_sym_EQ] = ACTIONS(4067),
    [anon_sym_COLON] = ACTIONS(4077),
    [anon_sym_QMARK] = ACTIONS(4035),
    [anon_sym_STAR_EQ] = ACTIONS(4071),
    [anon_sym_SLASH_EQ] = ACTIONS(4071),
    [anon_sym_PERCENT_EQ] = ACTIONS(4071),
    [anon_sym_PLUS_EQ] = ACTIONS(4071),
    [anon_sym_DASH_EQ] = ACTIONS(4071),
    [anon_sym_LT_LT_EQ] = ACTIONS(4071),
    [anon_sym_GT_GT_EQ] = ACTIONS(4071),
    [anon_sym_AMP_EQ] = ACTIONS(4071),
    [anon_sym_CARET_EQ] = ACTIONS(4071),
    [anon_sym_PIPE_EQ] = ACTIONS(4071),
    [anon_sym_and_eq] = ACTIONS(4071),
    [anon_sym_or_eq] = ACTIONS(4071),
    [anon_sym_xor_eq] = ACTIONS(4071),
    [anon_sym_LT_EQ_GT] = ACTIONS(4035),
    [anon_sym_or] = ACTIONS(4043),
    [anon_sym_and] = ACTIONS(4043),
    [anon_sym_bitor] = ACTIONS(4035),
    [anon_sym_xor] = ACTIONS(4043),
    [anon_sym_bitand] = ACTIONS(4035),
    [anon_sym_not_eq] = ACTIONS(4035),
    [anon_sym_DASH_DASH] = ACTIONS(4035),
    [anon_sym_PLUS_PLUS] = ACTIONS(4035),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_DOT_STAR] = ACTIONS(4035),
    [anon_sym_DASH_GT] = ACTIONS(4035),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
  },
  [2131] = {
    [sym_template_argument_list] = STATE(1570),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2305),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5844),
    [anon_sym_COMMA] = ACTIONS(5844),
    [anon_sym_RPAREN] = ACTIONS(5844),
    [anon_sym_LPAREN2] = ACTIONS(5844),
    [anon_sym_DASH] = ACTIONS(5842),
    [anon_sym_PLUS] = ACTIONS(5842),
    [anon_sym_STAR] = ACTIONS(5842),
    [anon_sym_SLASH] = ACTIONS(5842),
    [anon_sym_PERCENT] = ACTIONS(5842),
    [anon_sym_PIPE_PIPE] = ACTIONS(5844),
    [anon_sym_AMP_AMP] = ACTIONS(5844),
    [anon_sym_PIPE] = ACTIONS(5842),
    [anon_sym_CARET] = ACTIONS(5842),
    [anon_sym_AMP] = ACTIONS(5842),
    [anon_sym_EQ_EQ] = ACTIONS(5844),
    [anon_sym_BANG_EQ] = ACTIONS(5844),
    [anon_sym_GT] = ACTIONS(5842),
    [anon_sym_GT_EQ] = ACTIONS(5844),
    [anon_sym_LT_EQ] = ACTIONS(5842),
    [anon_sym_LT] = ACTIONS(5842),
    [anon_sym_LT_LT] = ACTIONS(5842),
    [anon_sym_GT_GT] = ACTIONS(5842),
    [anon_sym_SEMI] = ACTIONS(5844),
    [anon_sym___attribute__] = ACTIONS(5844),
    [anon_sym___attribute] = ACTIONS(5842),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACE] = ACTIONS(5844),
    [anon_sym_RBRACE] = ACTIONS(5844),
    [anon_sym_signed] = ACTIONS(5927),
    [anon_sym_unsigned] = ACTIONS(5927),
    [anon_sym_long] = ACTIONS(5927),
    [anon_sym_short] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(5844),
    [anon_sym_RBRACK] = ACTIONS(5844),
    [anon_sym_EQ] = ACTIONS(5842),
    [anon_sym_COLON] = ACTIONS(5842),
    [anon_sym_QMARK] = ACTIONS(5844),
    [anon_sym_STAR_EQ] = ACTIONS(5844),
    [anon_sym_SLASH_EQ] = ACTIONS(5844),
    [anon_sym_PERCENT_EQ] = ACTIONS(5844),
    [anon_sym_PLUS_EQ] = ACTIONS(5844),
    [anon_sym_DASH_EQ] = ACTIONS(5844),
    [anon_sym_LT_LT_EQ] = ACTIONS(5844),
    [anon_sym_GT_GT_EQ] = ACTIONS(5844),
    [anon_sym_AMP_EQ] = ACTIONS(5844),
    [anon_sym_CARET_EQ] = ACTIONS(5844),
    [anon_sym_PIPE_EQ] = ACTIONS(5844),
    [anon_sym_and_eq] = ACTIONS(5844),
    [anon_sym_or_eq] = ACTIONS(5844),
    [anon_sym_xor_eq] = ACTIONS(5844),
    [anon_sym_LT_EQ_GT] = ACTIONS(5844),
    [anon_sym_or] = ACTIONS(5842),
    [anon_sym_and] = ACTIONS(5842),
    [anon_sym_bitor] = ACTIONS(5844),
    [anon_sym_xor] = ACTIONS(5842),
    [anon_sym_bitand] = ACTIONS(5844),
    [anon_sym_not_eq] = ACTIONS(5844),
    [anon_sym_DASH_DASH] = ACTIONS(5844),
    [anon_sym_PLUS_PLUS] = ACTIONS(5844),
    [anon_sym_DOT] = ACTIONS(5842),
    [anon_sym_DOT_STAR] = ACTIONS(5844),
    [anon_sym_DASH_GT] = ACTIONS(5844),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5844),
    [anon_sym_decltype] = ACTIONS(5844),
  },
  [2132] = {
    [sym_string_literal] = STATE(2570),
    [sym_template_argument_list] = STATE(3643),
    [sym_raw_string_literal] = STATE(2570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4035),
    [anon_sym_COMMA] = ACTIONS(4035),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_DASH] = ACTIONS(4043),
    [anon_sym_PLUS] = ACTIONS(4043),
    [anon_sym_STAR] = ACTIONS(4043),
    [anon_sym_SLASH] = ACTIONS(4043),
    [anon_sym_PERCENT] = ACTIONS(4043),
    [anon_sym_PIPE_PIPE] = ACTIONS(4035),
    [anon_sym_AMP_AMP] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4043),
    [anon_sym_CARET] = ACTIONS(4043),
    [anon_sym_AMP] = ACTIONS(4043),
    [anon_sym_EQ_EQ] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4043),
    [anon_sym_GT_EQ] = ACTIONS(4035),
    [anon_sym_LT_EQ] = ACTIONS(4043),
    [anon_sym_LT] = ACTIONS(4929),
    [anon_sym_LT_LT] = ACTIONS(4043),
    [anon_sym_GT_GT] = ACTIONS(4043),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACE] = ACTIONS(4059),
    [anon_sym_LBRACK] = ACTIONS(4035),
    [anon_sym_EQ] = ACTIONS(4067),
    [anon_sym_COLON] = ACTIONS(4191),
    [anon_sym_QMARK] = ACTIONS(4035),
    [anon_sym_STAR_EQ] = ACTIONS(4071),
    [anon_sym_SLASH_EQ] = ACTIONS(4071),
    [anon_sym_PERCENT_EQ] = ACTIONS(4071),
    [anon_sym_PLUS_EQ] = ACTIONS(4071),
    [anon_sym_DASH_EQ] = ACTIONS(4071),
    [anon_sym_LT_LT_EQ] = ACTIONS(4071),
    [anon_sym_GT_GT_EQ] = ACTIONS(4071),
    [anon_sym_AMP_EQ] = ACTIONS(4071),
    [anon_sym_CARET_EQ] = ACTIONS(4071),
    [anon_sym_PIPE_EQ] = ACTIONS(4071),
    [anon_sym_and_eq] = ACTIONS(4071),
    [anon_sym_or_eq] = ACTIONS(4071),
    [anon_sym_xor_eq] = ACTIONS(4071),
    [anon_sym_LT_EQ_GT] = ACTIONS(4035),
    [anon_sym_or] = ACTIONS(4043),
    [anon_sym_and] = ACTIONS(4043),
    [anon_sym_bitor] = ACTIONS(4035),
    [anon_sym_xor] = ACTIONS(4043),
    [anon_sym_bitand] = ACTIONS(4035),
    [anon_sym_not_eq] = ACTIONS(4035),
    [anon_sym_DASH_DASH] = ACTIONS(4035),
    [anon_sym_PLUS_PLUS] = ACTIONS(4035),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_DOT_STAR] = ACTIONS(4035),
    [anon_sym_DASH_GT] = ACTIONS(4035),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
  },
  [2133] = {
    [sym_string_literal] = STATE(2570),
    [sym_template_argument_list] = STATE(3643),
    [sym_raw_string_literal] = STATE(2570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4035),
    [anon_sym_COMMA] = ACTIONS(4035),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_DASH] = ACTIONS(4043),
    [anon_sym_PLUS] = ACTIONS(4043),
    [anon_sym_STAR] = ACTIONS(4043),
    [anon_sym_SLASH] = ACTIONS(4043),
    [anon_sym_PERCENT] = ACTIONS(4043),
    [anon_sym_PIPE_PIPE] = ACTIONS(4035),
    [anon_sym_AMP_AMP] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4043),
    [anon_sym_CARET] = ACTIONS(4043),
    [anon_sym_AMP] = ACTIONS(4043),
    [anon_sym_EQ_EQ] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4043),
    [anon_sym_GT_EQ] = ACTIONS(4035),
    [anon_sym_LT_EQ] = ACTIONS(4043),
    [anon_sym_LT] = ACTIONS(4929),
    [anon_sym_LT_LT] = ACTIONS(4043),
    [anon_sym_GT_GT] = ACTIONS(4043),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACE] = ACTIONS(4059),
    [anon_sym_LBRACK] = ACTIONS(4035),
    [anon_sym_EQ] = ACTIONS(4067),
    [anon_sym_COLON] = ACTIONS(4342),
    [anon_sym_QMARK] = ACTIONS(4035),
    [anon_sym_STAR_EQ] = ACTIONS(4071),
    [anon_sym_SLASH_EQ] = ACTIONS(4071),
    [anon_sym_PERCENT_EQ] = ACTIONS(4071),
    [anon_sym_PLUS_EQ] = ACTIONS(4071),
    [anon_sym_DASH_EQ] = ACTIONS(4071),
    [anon_sym_LT_LT_EQ] = ACTIONS(4071),
    [anon_sym_GT_GT_EQ] = ACTIONS(4071),
    [anon_sym_AMP_EQ] = ACTIONS(4071),
    [anon_sym_CARET_EQ] = ACTIONS(4071),
    [anon_sym_PIPE_EQ] = ACTIONS(4071),
    [anon_sym_and_eq] = ACTIONS(4071),
    [anon_sym_or_eq] = ACTIONS(4071),
    [anon_sym_xor_eq] = ACTIONS(4071),
    [anon_sym_LT_EQ_GT] = ACTIONS(4035),
    [anon_sym_or] = ACTIONS(4043),
    [anon_sym_and] = ACTIONS(4043),
    [anon_sym_bitor] = ACTIONS(4035),
    [anon_sym_xor] = ACTIONS(4043),
    [anon_sym_bitand] = ACTIONS(4035),
    [anon_sym_not_eq] = ACTIONS(4035),
    [anon_sym_DASH_DASH] = ACTIONS(4035),
    [anon_sym_PLUS_PLUS] = ACTIONS(4035),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_DOT_STAR] = ACTIONS(4035),
    [anon_sym_DASH_GT] = ACTIONS(4035),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
  },
  [2134] = {
    [sym_string_literal] = STATE(2149),
    [sym_template_argument_list] = STATE(3162),
    [sym_raw_string_literal] = STATE(2149),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4035),
    [anon_sym_COMMA] = ACTIONS(4035),
    [anon_sym_RPAREN] = ACTIONS(4035),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_DASH] = ACTIONS(4043),
    [anon_sym_PLUS] = ACTIONS(4043),
    [anon_sym_STAR] = ACTIONS(4043),
    [anon_sym_SLASH] = ACTIONS(4043),
    [anon_sym_PERCENT] = ACTIONS(4043),
    [anon_sym_PIPE_PIPE] = ACTIONS(4035),
    [anon_sym_AMP_AMP] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4043),
    [anon_sym_CARET] = ACTIONS(4043),
    [anon_sym_AMP] = ACTIONS(4043),
    [anon_sym_EQ_EQ] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4043),
    [anon_sym_GT_EQ] = ACTIONS(4035),
    [anon_sym_LT_EQ] = ACTIONS(4043),
    [anon_sym_LT] = ACTIONS(4903),
    [anon_sym_LT_LT] = ACTIONS(4043),
    [anon_sym_GT_GT] = ACTIONS(4043),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACE] = ACTIONS(4059),
    [anon_sym_LBRACK] = ACTIONS(4035),
    [anon_sym_EQ] = ACTIONS(4043),
    [anon_sym_QMARK] = ACTIONS(4035),
    [anon_sym_STAR_EQ] = ACTIONS(4035),
    [anon_sym_SLASH_EQ] = ACTIONS(4035),
    [anon_sym_PERCENT_EQ] = ACTIONS(4035),
    [anon_sym_PLUS_EQ] = ACTIONS(4035),
    [anon_sym_DASH_EQ] = ACTIONS(4035),
    [anon_sym_LT_LT_EQ] = ACTIONS(4035),
    [anon_sym_GT_GT_EQ] = ACTIONS(4035),
    [anon_sym_AMP_EQ] = ACTIONS(4035),
    [anon_sym_CARET_EQ] = ACTIONS(4035),
    [anon_sym_PIPE_EQ] = ACTIONS(4035),
    [anon_sym_and_eq] = ACTIONS(4035),
    [anon_sym_or_eq] = ACTIONS(4035),
    [anon_sym_xor_eq] = ACTIONS(4035),
    [anon_sym_LT_EQ_GT] = ACTIONS(4035),
    [anon_sym_or] = ACTIONS(4043),
    [anon_sym_and] = ACTIONS(4043),
    [anon_sym_bitor] = ACTIONS(4035),
    [anon_sym_xor] = ACTIONS(4043),
    [anon_sym_bitand] = ACTIONS(4035),
    [anon_sym_not_eq] = ACTIONS(4035),
    [anon_sym_DASH_DASH] = ACTIONS(4035),
    [anon_sym_PLUS_PLUS] = ACTIONS(4035),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_DOT_STAR] = ACTIONS(4035),
    [anon_sym_DASH_GT] = ACTIONS(4043),
    [anon_sym_L_DQUOTE] = ACTIONS(4899),
    [anon_sym_u_DQUOTE] = ACTIONS(4899),
    [anon_sym_U_DQUOTE] = ACTIONS(4899),
    [anon_sym_u8_DQUOTE] = ACTIONS(4899),
    [anon_sym_DQUOTE] = ACTIONS(4899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4901),
    [anon_sym_LR_DQUOTE] = ACTIONS(4901),
    [anon_sym_uR_DQUOTE] = ACTIONS(4901),
    [anon_sym_UR_DQUOTE] = ACTIONS(4901),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4901),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4035),
  },
  [2135] = {
    [sym_string_literal] = STATE(2570),
    [sym_template_argument_list] = STATE(3643),
    [sym_raw_string_literal] = STATE(2570),
    [aux_sym_structured_binding_declarator_repeat1] = STATE(7394),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5929),
    [anon_sym_COMMA] = ACTIONS(5932),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_DASH] = ACTIONS(4043),
    [anon_sym_PLUS] = ACTIONS(4043),
    [anon_sym_STAR] = ACTIONS(4043),
    [anon_sym_SLASH] = ACTIONS(4043),
    [anon_sym_PERCENT] = ACTIONS(4043),
    [anon_sym_PIPE_PIPE] = ACTIONS(4035),
    [anon_sym_AMP_AMP] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4043),
    [anon_sym_CARET] = ACTIONS(4043),
    [anon_sym_AMP] = ACTIONS(4043),
    [anon_sym_EQ_EQ] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4043),
    [anon_sym_GT_EQ] = ACTIONS(4035),
    [anon_sym_LT_EQ] = ACTIONS(4043),
    [anon_sym_LT] = ACTIONS(4929),
    [anon_sym_LT_LT] = ACTIONS(4043),
    [anon_sym_GT_GT] = ACTIONS(4043),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACE] = ACTIONS(4059),
    [anon_sym_LBRACK] = ACTIONS(4035),
    [anon_sym_RBRACK] = ACTIONS(5935),
    [anon_sym_EQ] = ACTIONS(5939),
    [anon_sym_QMARK] = ACTIONS(4035),
    [anon_sym_STAR_EQ] = ACTIONS(5941),
    [anon_sym_SLASH_EQ] = ACTIONS(5941),
    [anon_sym_PERCENT_EQ] = ACTIONS(5941),
    [anon_sym_PLUS_EQ] = ACTIONS(5941),
    [anon_sym_DASH_EQ] = ACTIONS(5941),
    [anon_sym_LT_LT_EQ] = ACTIONS(5941),
    [anon_sym_GT_GT_EQ] = ACTIONS(5941),
    [anon_sym_AMP_EQ] = ACTIONS(5941),
    [anon_sym_CARET_EQ] = ACTIONS(5941),
    [anon_sym_PIPE_EQ] = ACTIONS(5941),
    [anon_sym_and_eq] = ACTIONS(5941),
    [anon_sym_or_eq] = ACTIONS(5941),
    [anon_sym_xor_eq] = ACTIONS(5941),
    [anon_sym_LT_EQ_GT] = ACTIONS(4035),
    [anon_sym_or] = ACTIONS(4043),
    [anon_sym_and] = ACTIONS(4043),
    [anon_sym_bitor] = ACTIONS(4035),
    [anon_sym_xor] = ACTIONS(4043),
    [anon_sym_bitand] = ACTIONS(4035),
    [anon_sym_not_eq] = ACTIONS(4035),
    [anon_sym_DASH_DASH] = ACTIONS(4035),
    [anon_sym_PLUS_PLUS] = ACTIONS(4035),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_DOT_STAR] = ACTIONS(4035),
    [anon_sym_DASH_GT] = ACTIONS(4035),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
  },
  [2136] = {
    [sym_attribute_declaration] = STATE(2255),
    [sym_parameter_list] = STATE(2187),
    [aux_sym_attributed_declarator_repeat1] = STATE(2255),
    [sym_identifier] = ACTIONS(5943),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5945),
    [anon_sym_COMMA] = ACTIONS(5945),
    [anon_sym_RPAREN] = ACTIONS(5945),
    [aux_sym_preproc_if_token2] = ACTIONS(5945),
    [aux_sym_preproc_else_token1] = ACTIONS(5945),
    [aux_sym_preproc_elif_token1] = ACTIONS(5943),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5945),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5945),
    [anon_sym_LPAREN2] = ACTIONS(5895),
    [anon_sym_DASH] = ACTIONS(5943),
    [anon_sym_PLUS] = ACTIONS(5943),
    [anon_sym_STAR] = ACTIONS(5943),
    [anon_sym_SLASH] = ACTIONS(5943),
    [anon_sym_PERCENT] = ACTIONS(5943),
    [anon_sym_PIPE_PIPE] = ACTIONS(5945),
    [anon_sym_AMP_AMP] = ACTIONS(5945),
    [anon_sym_PIPE] = ACTIONS(5943),
    [anon_sym_CARET] = ACTIONS(5943),
    [anon_sym_AMP] = ACTIONS(5943),
    [anon_sym_EQ_EQ] = ACTIONS(5945),
    [anon_sym_BANG_EQ] = ACTIONS(5945),
    [anon_sym_GT] = ACTIONS(5943),
    [anon_sym_GT_EQ] = ACTIONS(5945),
    [anon_sym_LT_EQ] = ACTIONS(5943),
    [anon_sym_LT] = ACTIONS(5943),
    [anon_sym_LT_LT] = ACTIONS(5943),
    [anon_sym_GT_GT] = ACTIONS(5943),
    [anon_sym_SEMI] = ACTIONS(5945),
    [anon_sym___attribute__] = ACTIONS(5943),
    [anon_sym___attribute] = ACTIONS(5943),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5897),
    [anon_sym_RBRACE] = ACTIONS(5945),
    [anon_sym_LBRACK] = ACTIONS(5899),
    [anon_sym_RBRACK] = ACTIONS(5945),
    [anon_sym_EQ] = ACTIONS(5943),
    [anon_sym_COLON] = ACTIONS(5945),
    [anon_sym_QMARK] = ACTIONS(5945),
    [anon_sym_STAR_EQ] = ACTIONS(5945),
    [anon_sym_SLASH_EQ] = ACTIONS(5945),
    [anon_sym_PERCENT_EQ] = ACTIONS(5945),
    [anon_sym_PLUS_EQ] = ACTIONS(5945),
    [anon_sym_DASH_EQ] = ACTIONS(5945),
    [anon_sym_LT_LT_EQ] = ACTIONS(5945),
    [anon_sym_GT_GT_EQ] = ACTIONS(5945),
    [anon_sym_AMP_EQ] = ACTIONS(5945),
    [anon_sym_CARET_EQ] = ACTIONS(5945),
    [anon_sym_PIPE_EQ] = ACTIONS(5945),
    [anon_sym_and_eq] = ACTIONS(5943),
    [anon_sym_or_eq] = ACTIONS(5943),
    [anon_sym_xor_eq] = ACTIONS(5943),
    [anon_sym_LT_EQ_GT] = ACTIONS(5945),
    [anon_sym_or] = ACTIONS(5943),
    [anon_sym_and] = ACTIONS(5943),
    [anon_sym_bitor] = ACTIONS(5943),
    [anon_sym_xor] = ACTIONS(5943),
    [anon_sym_bitand] = ACTIONS(5943),
    [anon_sym_not_eq] = ACTIONS(5943),
    [anon_sym_DASH_DASH] = ACTIONS(5945),
    [anon_sym_PLUS_PLUS] = ACTIONS(5945),
    [anon_sym_DOT] = ACTIONS(5943),
    [anon_sym_DOT_STAR] = ACTIONS(5945),
    [anon_sym_DASH_GT] = ACTIONS(5945),
    [sym_comment] = ACTIONS(3),
  },
  [2137] = {
    [sym_identifier] = ACTIONS(5361),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5363),
    [anon_sym_COMMA] = ACTIONS(5363),
    [anon_sym_RPAREN] = ACTIONS(5363),
    [anon_sym_LPAREN2] = ACTIONS(5363),
    [anon_sym_TILDE] = ACTIONS(5363),
    [anon_sym_STAR] = ACTIONS(5363),
    [anon_sym_PIPE_PIPE] = ACTIONS(5363),
    [anon_sym_AMP_AMP] = ACTIONS(5363),
    [anon_sym_AMP] = ACTIONS(5361),
    [anon_sym_SEMI] = ACTIONS(5363),
    [anon_sym___extension__] = ACTIONS(5361),
    [anon_sym_virtual] = ACTIONS(5361),
    [anon_sym_extern] = ACTIONS(5361),
    [anon_sym___attribute__] = ACTIONS(5361),
    [anon_sym___attribute] = ACTIONS(5361),
    [anon_sym_COLON_COLON] = ACTIONS(5365),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5363),
    [anon_sym___declspec] = ACTIONS(5361),
    [anon_sym___based] = ACTIONS(5361),
    [anon_sym___cdecl] = ACTIONS(5361),
    [anon_sym___clrcall] = ACTIONS(5361),
    [anon_sym___stdcall] = ACTIONS(5361),
    [anon_sym___fastcall] = ACTIONS(5361),
    [anon_sym___thiscall] = ACTIONS(5361),
    [anon_sym___vectorcall] = ACTIONS(5361),
    [anon_sym_LBRACE] = ACTIONS(5363),
    [anon_sym_LBRACK] = ACTIONS(5361),
    [anon_sym_static] = ACTIONS(5361),
    [anon_sym_EQ] = ACTIONS(5363),
    [anon_sym_register] = ACTIONS(5361),
    [anon_sym_inline] = ACTIONS(5361),
    [anon_sym___inline] = ACTIONS(5361),
    [anon_sym___inline__] = ACTIONS(5361),
    [anon_sym___forceinline] = ACTIONS(5361),
    [anon_sym_thread_local] = ACTIONS(5361),
    [anon_sym___thread] = ACTIONS(5361),
    [anon_sym_const] = ACTIONS(5361),
    [anon_sym_constexpr] = ACTIONS(5361),
    [anon_sym_volatile] = ACTIONS(5361),
    [anon_sym_restrict] = ACTIONS(5361),
    [anon_sym___restrict__] = ACTIONS(5361),
    [anon_sym__Atomic] = ACTIONS(5361),
    [anon_sym__Noreturn] = ACTIONS(5361),
    [anon_sym_noreturn] = ACTIONS(5361),
    [anon_sym__Nonnull] = ACTIONS(5361),
    [anon_sym_mutable] = ACTIONS(5361),
    [anon_sym_constinit] = ACTIONS(5361),
    [anon_sym_consteval] = ACTIONS(5361),
    [anon_sym_alignas] = ACTIONS(5361),
    [anon_sym__Alignas] = ACTIONS(5361),
    [anon_sym_COLON] = ACTIONS(5361),
    [anon_sym_or] = ACTIONS(5361),
    [anon_sym_and] = ACTIONS(5361),
    [anon_sym_asm] = ACTIONS(5361),
    [anon_sym___asm__] = ACTIONS(5361),
    [anon_sym___asm] = ACTIONS(5361),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5361),
    [anon_sym_decltype] = ACTIONS(5361),
    [anon_sym_final] = ACTIONS(5361),
    [anon_sym_override] = ACTIONS(5361),
    [anon_sym_template] = ACTIONS(5361),
    [anon_sym_GT2] = ACTIONS(5363),
    [anon_sym_operator] = ACTIONS(5361),
    [anon_sym_try] = ACTIONS(5361),
    [anon_sym_requires] = ACTIONS(5361),
  },
  [2138] = {
    [sym_attribute_specifier] = STATE(2227),
    [sym_identifier] = ACTIONS(5947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5949),
    [anon_sym_COMMA] = ACTIONS(5949),
    [anon_sym_RPAREN] = ACTIONS(5949),
    [aux_sym_preproc_if_token2] = ACTIONS(5949),
    [aux_sym_preproc_else_token1] = ACTIONS(5949),
    [aux_sym_preproc_elif_token1] = ACTIONS(5947),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5949),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5949),
    [anon_sym_LPAREN2] = ACTIONS(5949),
    [anon_sym_DASH] = ACTIONS(5947),
    [anon_sym_PLUS] = ACTIONS(5947),
    [anon_sym_STAR] = ACTIONS(5947),
    [anon_sym_SLASH] = ACTIONS(5947),
    [anon_sym_PERCENT] = ACTIONS(5947),
    [anon_sym_PIPE_PIPE] = ACTIONS(5949),
    [anon_sym_AMP_AMP] = ACTIONS(5949),
    [anon_sym_PIPE] = ACTIONS(5947),
    [anon_sym_CARET] = ACTIONS(5947),
    [anon_sym_AMP] = ACTIONS(5947),
    [anon_sym_EQ_EQ] = ACTIONS(5949),
    [anon_sym_BANG_EQ] = ACTIONS(5949),
    [anon_sym_GT] = ACTIONS(5947),
    [anon_sym_GT_EQ] = ACTIONS(5949),
    [anon_sym_LT_EQ] = ACTIONS(5947),
    [anon_sym_LT] = ACTIONS(5947),
    [anon_sym_LT_LT] = ACTIONS(5947),
    [anon_sym_GT_GT] = ACTIONS(5947),
    [anon_sym_SEMI] = ACTIONS(5949),
    [anon_sym___attribute__] = ACTIONS(5379),
    [anon_sym___attribute] = ACTIONS(5379),
    [anon_sym_LBRACE] = ACTIONS(5949),
    [anon_sym_RBRACE] = ACTIONS(5949),
    [anon_sym_LBRACK] = ACTIONS(5949),
    [anon_sym_RBRACK] = ACTIONS(5949),
    [anon_sym_EQ] = ACTIONS(5947),
    [anon_sym_COLON] = ACTIONS(5949),
    [anon_sym_QMARK] = ACTIONS(5949),
    [anon_sym_STAR_EQ] = ACTIONS(5949),
    [anon_sym_SLASH_EQ] = ACTIONS(5949),
    [anon_sym_PERCENT_EQ] = ACTIONS(5949),
    [anon_sym_PLUS_EQ] = ACTIONS(5949),
    [anon_sym_DASH_EQ] = ACTIONS(5949),
    [anon_sym_LT_LT_EQ] = ACTIONS(5949),
    [anon_sym_GT_GT_EQ] = ACTIONS(5949),
    [anon_sym_AMP_EQ] = ACTIONS(5949),
    [anon_sym_CARET_EQ] = ACTIONS(5949),
    [anon_sym_PIPE_EQ] = ACTIONS(5949),
    [anon_sym_and_eq] = ACTIONS(5947),
    [anon_sym_or_eq] = ACTIONS(5947),
    [anon_sym_xor_eq] = ACTIONS(5947),
    [anon_sym_LT_EQ_GT] = ACTIONS(5949),
    [anon_sym_or] = ACTIONS(5947),
    [anon_sym_and] = ACTIONS(5947),
    [anon_sym_bitor] = ACTIONS(5947),
    [anon_sym_xor] = ACTIONS(5947),
    [anon_sym_bitand] = ACTIONS(5947),
    [anon_sym_not_eq] = ACTIONS(5947),
    [anon_sym_DASH_DASH] = ACTIONS(5949),
    [anon_sym_PLUS_PLUS] = ACTIONS(5949),
    [anon_sym_DOT] = ACTIONS(5947),
    [anon_sym_DOT_STAR] = ACTIONS(5949),
    [anon_sym_DASH_GT] = ACTIONS(5949),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5947),
    [anon_sym_decltype] = ACTIONS(5947),
  },
  [2139] = {
    [sym_attribute_specifier] = STATE(2203),
    [sym_identifier] = ACTIONS(5951),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5953),
    [anon_sym_COMMA] = ACTIONS(5953),
    [anon_sym_RPAREN] = ACTIONS(5953),
    [aux_sym_preproc_if_token2] = ACTIONS(5953),
    [aux_sym_preproc_else_token1] = ACTIONS(5953),
    [aux_sym_preproc_elif_token1] = ACTIONS(5951),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5953),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5953),
    [anon_sym_LPAREN2] = ACTIONS(5953),
    [anon_sym_DASH] = ACTIONS(5951),
    [anon_sym_PLUS] = ACTIONS(5951),
    [anon_sym_STAR] = ACTIONS(5951),
    [anon_sym_SLASH] = ACTIONS(5951),
    [anon_sym_PERCENT] = ACTIONS(5951),
    [anon_sym_PIPE_PIPE] = ACTIONS(5953),
    [anon_sym_AMP_AMP] = ACTIONS(5953),
    [anon_sym_PIPE] = ACTIONS(5951),
    [anon_sym_CARET] = ACTIONS(5951),
    [anon_sym_AMP] = ACTIONS(5951),
    [anon_sym_EQ_EQ] = ACTIONS(5953),
    [anon_sym_BANG_EQ] = ACTIONS(5953),
    [anon_sym_GT] = ACTIONS(5951),
    [anon_sym_GT_EQ] = ACTIONS(5953),
    [anon_sym_LT_EQ] = ACTIONS(5951),
    [anon_sym_LT] = ACTIONS(5951),
    [anon_sym_LT_LT] = ACTIONS(5951),
    [anon_sym_GT_GT] = ACTIONS(5951),
    [anon_sym_SEMI] = ACTIONS(5953),
    [anon_sym___attribute__] = ACTIONS(5379),
    [anon_sym___attribute] = ACTIONS(5379),
    [anon_sym_LBRACE] = ACTIONS(5953),
    [anon_sym_RBRACE] = ACTIONS(5953),
    [anon_sym_LBRACK] = ACTIONS(5953),
    [anon_sym_RBRACK] = ACTIONS(5953),
    [anon_sym_EQ] = ACTIONS(5951),
    [anon_sym_COLON] = ACTIONS(5953),
    [anon_sym_QMARK] = ACTIONS(5953),
    [anon_sym_STAR_EQ] = ACTIONS(5953),
    [anon_sym_SLASH_EQ] = ACTIONS(5953),
    [anon_sym_PERCENT_EQ] = ACTIONS(5953),
    [anon_sym_PLUS_EQ] = ACTIONS(5953),
    [anon_sym_DASH_EQ] = ACTIONS(5953),
    [anon_sym_LT_LT_EQ] = ACTIONS(5953),
    [anon_sym_GT_GT_EQ] = ACTIONS(5953),
    [anon_sym_AMP_EQ] = ACTIONS(5953),
    [anon_sym_CARET_EQ] = ACTIONS(5953),
    [anon_sym_PIPE_EQ] = ACTIONS(5953),
    [anon_sym_and_eq] = ACTIONS(5951),
    [anon_sym_or_eq] = ACTIONS(5951),
    [anon_sym_xor_eq] = ACTIONS(5951),
    [anon_sym_LT_EQ_GT] = ACTIONS(5953),
    [anon_sym_or] = ACTIONS(5951),
    [anon_sym_and] = ACTIONS(5951),
    [anon_sym_bitor] = ACTIONS(5951),
    [anon_sym_xor] = ACTIONS(5951),
    [anon_sym_bitand] = ACTIONS(5951),
    [anon_sym_not_eq] = ACTIONS(5951),
    [anon_sym_DASH_DASH] = ACTIONS(5953),
    [anon_sym_PLUS_PLUS] = ACTIONS(5953),
    [anon_sym_DOT] = ACTIONS(5951),
    [anon_sym_DOT_STAR] = ACTIONS(5953),
    [anon_sym_DASH_GT] = ACTIONS(5953),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5951),
    [anon_sym_decltype] = ACTIONS(5951),
  },
  [2140] = {
    [sym_string_literal] = STATE(2140),
    [sym_raw_string_literal] = STATE(2140),
    [aux_sym_concatenated_string_repeat1] = STATE(2140),
    [sym_identifier] = ACTIONS(5955),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5258),
    [anon_sym_COMMA] = ACTIONS(5258),
    [anon_sym_RPAREN] = ACTIONS(5258),
    [anon_sym_LPAREN2] = ACTIONS(5258),
    [anon_sym_DASH] = ACTIONS(5260),
    [anon_sym_PLUS] = ACTIONS(5260),
    [anon_sym_STAR] = ACTIONS(5260),
    [anon_sym_SLASH] = ACTIONS(5260),
    [anon_sym_PERCENT] = ACTIONS(5260),
    [anon_sym_PIPE_PIPE] = ACTIONS(5258),
    [anon_sym_AMP_AMP] = ACTIONS(5258),
    [anon_sym_PIPE] = ACTIONS(5260),
    [anon_sym_CARET] = ACTIONS(5260),
    [anon_sym_AMP] = ACTIONS(5260),
    [anon_sym_EQ_EQ] = ACTIONS(5258),
    [anon_sym_BANG_EQ] = ACTIONS(5258),
    [anon_sym_GT] = ACTIONS(5260),
    [anon_sym_GT_EQ] = ACTIONS(5258),
    [anon_sym_LT_EQ] = ACTIONS(5260),
    [anon_sym_LT] = ACTIONS(5260),
    [anon_sym_LT_LT] = ACTIONS(5260),
    [anon_sym_GT_GT] = ACTIONS(5260),
    [anon_sym_LBRACK] = ACTIONS(5258),
    [anon_sym_EQ] = ACTIONS(5260),
    [anon_sym_QMARK] = ACTIONS(5258),
    [anon_sym_STAR_EQ] = ACTIONS(5258),
    [anon_sym_SLASH_EQ] = ACTIONS(5258),
    [anon_sym_PERCENT_EQ] = ACTIONS(5258),
    [anon_sym_PLUS_EQ] = ACTIONS(5258),
    [anon_sym_DASH_EQ] = ACTIONS(5258),
    [anon_sym_LT_LT_EQ] = ACTIONS(5258),
    [anon_sym_GT_GT_EQ] = ACTIONS(5258),
    [anon_sym_AMP_EQ] = ACTIONS(5258),
    [anon_sym_CARET_EQ] = ACTIONS(5258),
    [anon_sym_PIPE_EQ] = ACTIONS(5258),
    [anon_sym_and_eq] = ACTIONS(5260),
    [anon_sym_or_eq] = ACTIONS(5260),
    [anon_sym_xor_eq] = ACTIONS(5260),
    [anon_sym_LT_EQ_GT] = ACTIONS(5258),
    [anon_sym_or] = ACTIONS(5260),
    [anon_sym_and] = ACTIONS(5260),
    [anon_sym_bitor] = ACTIONS(5260),
    [anon_sym_xor] = ACTIONS(5260),
    [anon_sym_bitand] = ACTIONS(5260),
    [anon_sym_not_eq] = ACTIONS(5260),
    [anon_sym_DASH_DASH] = ACTIONS(5258),
    [anon_sym_PLUS_PLUS] = ACTIONS(5258),
    [anon_sym_DOT] = ACTIONS(5260),
    [anon_sym_DOT_STAR] = ACTIONS(5258),
    [anon_sym_DASH_GT] = ACTIONS(5260),
    [anon_sym_L_DQUOTE] = ACTIONS(5958),
    [anon_sym_u_DQUOTE] = ACTIONS(5958),
    [anon_sym_U_DQUOTE] = ACTIONS(5958),
    [anon_sym_u8_DQUOTE] = ACTIONS(5958),
    [anon_sym_DQUOTE] = ACTIONS(5958),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5961),
    [anon_sym_LR_DQUOTE] = ACTIONS(5961),
    [anon_sym_uR_DQUOTE] = ACTIONS(5961),
    [anon_sym_UR_DQUOTE] = ACTIONS(5961),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5961),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5258),
    [sym_literal_suffix] = ACTIONS(5260),
  },
  [2141] = {
    [sym_string_literal] = STATE(2326),
    [sym_template_argument_list] = STATE(3543),
    [sym_raw_string_literal] = STATE(2326),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4035),
    [anon_sym_COMMA] = ACTIONS(4035),
    [anon_sym_RPAREN] = ACTIONS(4035),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_DASH] = ACTIONS(4043),
    [anon_sym_PLUS] = ACTIONS(4043),
    [anon_sym_STAR] = ACTIONS(4043),
    [anon_sym_SLASH] = ACTIONS(4043),
    [anon_sym_PERCENT] = ACTIONS(4043),
    [anon_sym_PIPE_PIPE] = ACTIONS(4035),
    [anon_sym_AMP_AMP] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4043),
    [anon_sym_CARET] = ACTIONS(4043),
    [anon_sym_AMP] = ACTIONS(4043),
    [anon_sym_EQ_EQ] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4043),
    [anon_sym_GT_EQ] = ACTIONS(4035),
    [anon_sym_LT_EQ] = ACTIONS(4043),
    [anon_sym_LT] = ACTIONS(5964),
    [anon_sym_LT_LT] = ACTIONS(4043),
    [anon_sym_GT_GT] = ACTIONS(4043),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACE] = ACTIONS(4059),
    [anon_sym_LBRACK] = ACTIONS(4035),
    [anon_sym_EQ] = ACTIONS(4043),
    [anon_sym_QMARK] = ACTIONS(4035),
    [anon_sym_STAR_EQ] = ACTIONS(4035),
    [anon_sym_SLASH_EQ] = ACTIONS(4035),
    [anon_sym_PERCENT_EQ] = ACTIONS(4035),
    [anon_sym_PLUS_EQ] = ACTIONS(4035),
    [anon_sym_DASH_EQ] = ACTIONS(4035),
    [anon_sym_LT_LT_EQ] = ACTIONS(4035),
    [anon_sym_GT_GT_EQ] = ACTIONS(4035),
    [anon_sym_AMP_EQ] = ACTIONS(4035),
    [anon_sym_CARET_EQ] = ACTIONS(4035),
    [anon_sym_PIPE_EQ] = ACTIONS(4035),
    [anon_sym_and_eq] = ACTIONS(5967),
    [anon_sym_or_eq] = ACTIONS(5967),
    [anon_sym_xor_eq] = ACTIONS(5967),
    [anon_sym_LT_EQ_GT] = ACTIONS(4035),
    [anon_sym_or] = ACTIONS(4043),
    [anon_sym_and] = ACTIONS(4043),
    [anon_sym_bitor] = ACTIONS(4035),
    [anon_sym_xor] = ACTIONS(4043),
    [anon_sym_bitand] = ACTIONS(4035),
    [anon_sym_not_eq] = ACTIONS(4035),
    [anon_sym_DASH_DASH] = ACTIONS(4035),
    [anon_sym_PLUS_PLUS] = ACTIONS(4035),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_DOT_STAR] = ACTIONS(4035),
    [anon_sym_DASH_GT] = ACTIONS(4043),
    [anon_sym_L_DQUOTE] = ACTIONS(4220),
    [anon_sym_u_DQUOTE] = ACTIONS(4220),
    [anon_sym_U_DQUOTE] = ACTIONS(4220),
    [anon_sym_u8_DQUOTE] = ACTIONS(4220),
    [anon_sym_DQUOTE] = ACTIONS(4220),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4222),
    [anon_sym_LR_DQUOTE] = ACTIONS(4222),
    [anon_sym_uR_DQUOTE] = ACTIONS(4222),
    [anon_sym_UR_DQUOTE] = ACTIONS(4222),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4222),
    [anon_sym_DASH_GT_STAR] = ACTIONS(4035),
  },
  [2142] = {
    [sym_template_argument_list] = STATE(1874),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2305),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4041),
    [anon_sym_COMMA] = ACTIONS(4041),
    [anon_sym_RPAREN] = ACTIONS(4041),
    [anon_sym_LPAREN2] = ACTIONS(4041),
    [anon_sym_DASH] = ACTIONS(4033),
    [anon_sym_PLUS] = ACTIONS(4033),
    [anon_sym_STAR] = ACTIONS(4033),
    [anon_sym_SLASH] = ACTIONS(4033),
    [anon_sym_PERCENT] = ACTIONS(4033),
    [anon_sym_PIPE_PIPE] = ACTIONS(4041),
    [anon_sym_AMP_AMP] = ACTIONS(4041),
    [anon_sym_PIPE] = ACTIONS(4033),
    [anon_sym_CARET] = ACTIONS(4033),
    [anon_sym_AMP] = ACTIONS(4033),
    [anon_sym_EQ_EQ] = ACTIONS(4041),
    [anon_sym_BANG_EQ] = ACTIONS(4041),
    [anon_sym_GT] = ACTIONS(4033),
    [anon_sym_GT_EQ] = ACTIONS(4041),
    [anon_sym_LT_EQ] = ACTIONS(4033),
    [anon_sym_LT] = ACTIONS(5722),
    [anon_sym_LT_LT] = ACTIONS(4033),
    [anon_sym_GT_GT] = ACTIONS(4033),
    [anon_sym_SEMI] = ACTIONS(4041),
    [anon_sym___attribute__] = ACTIONS(4041),
    [anon_sym___attribute] = ACTIONS(4033),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACE] = ACTIONS(4041),
    [anon_sym_RBRACE] = ACTIONS(4041),
    [anon_sym_signed] = ACTIONS(5927),
    [anon_sym_unsigned] = ACTIONS(5927),
    [anon_sym_long] = ACTIONS(5927),
    [anon_sym_short] = ACTIONS(5927),
    [anon_sym_LBRACK] = ACTIONS(4041),
    [anon_sym_RBRACK] = ACTIONS(4041),
    [anon_sym_EQ] = ACTIONS(4033),
    [anon_sym_COLON] = ACTIONS(4033),
    [anon_sym_QMARK] = ACTIONS(4041),
    [anon_sym_STAR_EQ] = ACTIONS(4041),
    [anon_sym_SLASH_EQ] = ACTIONS(4041),
    [anon_sym_PERCENT_EQ] = ACTIONS(4041),
    [anon_sym_PLUS_EQ] = ACTIONS(4041),
    [anon_sym_DASH_EQ] = ACTIONS(4041),
    [anon_sym_LT_LT_EQ] = ACTIONS(4041),
    [anon_sym_GT_GT_EQ] = ACTIONS(4041),
    [anon_sym_AMP_EQ] = ACTIONS(4041),
    [anon_sym_CARET_EQ] = ACTIONS(4041),
    [anon_sym_PIPE_EQ] = ACTIONS(4041),
    [anon_sym_and_eq] = ACTIONS(4041),
    [anon_sym_or_eq] = ACTIONS(4041),
    [anon_sym_xor_eq] = ACTIONS(4041),
    [anon_sym_LT_EQ_GT] = ACTIONS(4041),
    [anon_sym_or] = ACTIONS(4033),
    [anon_sym_and] = ACTIONS(4033),
    [anon_sym_bitor] = ACTIONS(4041),
    [anon_sym_xor] = ACTIONS(4033),
    [anon_sym_bitand] = ACTIONS(4041),
    [anon_sym_not_eq] = ACTIONS(4041),
    [anon_sym_DASH_DASH] = ACTIONS(4041),
    [anon_sym_PLUS_PLUS] = ACTIONS(4041),
    [anon_sym_DOT] = ACTIONS(4033),
    [anon_sym_DOT_STAR] = ACTIONS(4041),
    [anon_sym_DASH_GT] = ACTIONS(4041),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4041),
    [anon_sym_decltype] = ACTIONS(4041),
  },
  [2143] = {
    [sym_attribute_specifier] = STATE(2202),
    [sym_identifier] = ACTIONS(5969),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5971),
    [anon_sym_COMMA] = ACTIONS(5971),
    [anon_sym_RPAREN] = ACTIONS(5971),
    [aux_sym_preproc_if_token2] = ACTIONS(5971),
    [aux_sym_preproc_else_token1] = ACTIONS(5971),
    [aux_sym_preproc_elif_token1] = ACTIONS(5969),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5971),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5971),
    [anon_sym_LPAREN2] = ACTIONS(5971),
    [anon_sym_DASH] = ACTIONS(5969),
    [anon_sym_PLUS] = ACTIONS(5969),
    [anon_sym_STAR] = ACTIONS(5969),
    [anon_sym_SLASH] = ACTIONS(5969),
    [anon_sym_PERCENT] = ACTIONS(5969),
    [anon_sym_PIPE_PIPE] = ACTIONS(5971),
    [anon_sym_AMP_AMP] = ACTIONS(5971),
    [anon_sym_PIPE] = ACTIONS(5969),
    [anon_sym_CARET] = ACTIONS(5969),
    [anon_sym_AMP] = ACTIONS(5969),
    [anon_sym_EQ_EQ] = ACTIONS(5971),
    [anon_sym_BANG_EQ] = ACTIONS(5971),
    [anon_sym_GT] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_LT_EQ] = ACTIONS(5969),
    [anon_sym_LT] = ACTIONS(5969),
    [anon_sym_LT_LT] = ACTIONS(5969),
    [anon_sym_GT_GT] = ACTIONS(5969),
    [anon_sym_SEMI] = ACTIONS(5971),
    [anon_sym___attribute__] = ACTIONS(5379),
    [anon_sym___attribute] = ACTIONS(5379),
    [anon_sym_LBRACE] = ACTIONS(5971),
    [anon_sym_RBRACE] = ACTIONS(5971),
    [anon_sym_LBRACK] = ACTIONS(5971),
    [anon_sym_RBRACK] = ACTIONS(5971),
    [anon_sym_EQ] = ACTIONS(5969),
    [anon_sym_COLON] = ACTIONS(5971),
    [anon_sym_QMARK] = ACTIONS(5971),
    [anon_sym_STAR_EQ] = ACTIONS(5971),
    [anon_sym_SLASH_EQ] = ACTIONS(5971),
    [anon_sym_PERCENT_EQ] = ACTIONS(5971),
    [anon_sym_PLUS_EQ] = ACTIONS(5971),
    [anon_sym_DASH_EQ] = ACTIONS(5971),
    [anon_sym_LT_LT_EQ] = ACTIONS(5971),
    [anon_sym_GT_GT_EQ] = ACTIONS(5971),
    [anon_sym_AMP_EQ] = ACTIONS(5971),
    [anon_sym_CARET_EQ] = ACTIONS(5971),
    [anon_sym_PIPE_EQ] = ACTIONS(5971),
    [anon_sym_and_eq] = ACTIONS(5969),
    [anon_sym_or_eq] = ACTIONS(5969),
    [anon_sym_xor_eq] = ACTIONS(5969),
    [anon_sym_LT_EQ_GT] = ACTIONS(5971),
    [anon_sym_or] = ACTIONS(5969),
    [anon_sym_and] = ACTIONS(5969),
    [anon_sym_bitor] = ACTIONS(5969),
    [anon_sym_xor] = ACTIONS(5969),
    [anon_sym_bitand] = ACTIONS(5969),
    [anon_sym_not_eq] = ACTIONS(5969),
    [anon_sym_DASH_DASH] = ACTIONS(5971),
    [anon_sym_PLUS_PLUS] = ACTIONS(5971),
    [anon_sym_DOT] = ACTIONS(5969),
    [anon_sym_DOT_STAR] = ACTIONS(5971),
    [anon_sym_DASH_GT] = ACTIONS(5971),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5969),
    [anon_sym_decltype] = ACTIONS(5969),
  },
  [2144] = {
    [sym_string_literal] = STATE(2570),
    [sym_template_argument_list] = STATE(3643),
    [sym_raw_string_literal] = STATE(2570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4035),
    [anon_sym_COMMA] = ACTIONS(4035),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_DASH] = ACTIONS(4043),
    [anon_sym_PLUS] = ACTIONS(4043),
    [anon_sym_STAR] = ACTIONS(4043),
    [anon_sym_SLASH] = ACTIONS(4043),
    [anon_sym_PERCENT] = ACTIONS(4043),
    [anon_sym_PIPE_PIPE] = ACTIONS(4035),
    [anon_sym_AMP_AMP] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4043),
    [anon_sym_CARET] = ACTIONS(4043),
    [anon_sym_AMP] = ACTIONS(4043),
    [anon_sym_EQ_EQ] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4043),
    [anon_sym_GT_EQ] = ACTIONS(4035),
    [anon_sym_LT_EQ] = ACTIONS(4043),
    [anon_sym_LT] = ACTIONS(4929),
    [anon_sym_LT_LT] = ACTIONS(4043),
    [anon_sym_GT_GT] = ACTIONS(4043),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACE] = ACTIONS(4059),
    [anon_sym_LBRACK] = ACTIONS(4035),
    [anon_sym_EQ] = ACTIONS(4067),
    [anon_sym_COLON] = ACTIONS(4145),
    [anon_sym_QMARK] = ACTIONS(4035),
    [anon_sym_STAR_EQ] = ACTIONS(4071),
    [anon_sym_SLASH_EQ] = ACTIONS(4071),
    [anon_sym_PERCENT_EQ] = ACTIONS(4071),
    [anon_sym_PLUS_EQ] = ACTIONS(4071),
    [anon_sym_DASH_EQ] = ACTIONS(4071),
    [anon_sym_LT_LT_EQ] = ACTIONS(4071),
    [anon_sym_GT_GT_EQ] = ACTIONS(4071),
    [anon_sym_AMP_EQ] = ACTIONS(4071),
    [anon_sym_CARET_EQ] = ACTIONS(4071),
    [anon_sym_PIPE_EQ] = ACTIONS(4071),
    [anon_sym_and_eq] = ACTIONS(4071),
    [anon_sym_or_eq] = ACTIONS(4071),
    [anon_sym_xor_eq] = ACTIONS(4071),
    [anon_sym_LT_EQ_GT] = ACTIONS(4035),
    [anon_sym_or] = ACTIONS(4043),
    [anon_sym_and] = ACTIONS(4043),
    [anon_sym_bitor] = ACTIONS(4035),
    [anon_sym_xor] = ACTIONS(4043),
    [anon_sym_bitand] = ACTIONS(4035),
    [anon_sym_not_eq] = ACTIONS(4035),
    [anon_sym_DASH_DASH] = ACTIONS(4035),
    [anon_sym_PLUS_PLUS] = ACTIONS(4035),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_DOT_STAR] = ACTIONS(4035),
    [anon_sym_DASH_GT] = ACTIONS(4035),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
  },
  [2145] = {
    [sym_identifier] = ACTIONS(5470),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5472),
    [anon_sym_COMMA] = ACTIONS(5472),
    [anon_sym_RPAREN] = ACTIONS(5472),
    [anon_sym_LPAREN2] = ACTIONS(5472),
    [anon_sym_TILDE] = ACTIONS(5472),
    [anon_sym_STAR] = ACTIONS(5472),
    [anon_sym_PIPE_PIPE] = ACTIONS(5472),
    [anon_sym_AMP_AMP] = ACTIONS(5472),
    [anon_sym_AMP] = ACTIONS(5470),
    [anon_sym_SEMI] = ACTIONS(5472),
    [anon_sym___extension__] = ACTIONS(5470),
    [anon_sym_virtual] = ACTIONS(5470),
    [anon_sym_extern] = ACTIONS(5470),
    [anon_sym___attribute__] = ACTIONS(5470),
    [anon_sym___attribute] = ACTIONS(5470),
    [anon_sym_COLON_COLON] = ACTIONS(5472),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5472),
    [anon_sym___declspec] = ACTIONS(5470),
    [anon_sym___based] = ACTIONS(5470),
    [anon_sym___cdecl] = ACTIONS(5470),
    [anon_sym___clrcall] = ACTIONS(5470),
    [anon_sym___stdcall] = ACTIONS(5470),
    [anon_sym___fastcall] = ACTIONS(5470),
    [anon_sym___thiscall] = ACTIONS(5470),
    [anon_sym___vectorcall] = ACTIONS(5470),
    [anon_sym_LBRACE] = ACTIONS(5472),
    [anon_sym_LBRACK] = ACTIONS(5470),
    [anon_sym_static] = ACTIONS(5470),
    [anon_sym_EQ] = ACTIONS(5472),
    [anon_sym_register] = ACTIONS(5470),
    [anon_sym_inline] = ACTIONS(5470),
    [anon_sym___inline] = ACTIONS(5470),
    [anon_sym___inline__] = ACTIONS(5470),
    [anon_sym___forceinline] = ACTIONS(5470),
    [anon_sym_thread_local] = ACTIONS(5470),
    [anon_sym___thread] = ACTIONS(5470),
    [anon_sym_const] = ACTIONS(5470),
    [anon_sym_constexpr] = ACTIONS(5470),
    [anon_sym_volatile] = ACTIONS(5470),
    [anon_sym_restrict] = ACTIONS(5470),
    [anon_sym___restrict__] = ACTIONS(5470),
    [anon_sym__Atomic] = ACTIONS(5470),
    [anon_sym__Noreturn] = ACTIONS(5470),
    [anon_sym_noreturn] = ACTIONS(5470),
    [anon_sym__Nonnull] = ACTIONS(5470),
    [anon_sym_mutable] = ACTIONS(5470),
    [anon_sym_constinit] = ACTIONS(5470),
    [anon_sym_consteval] = ACTIONS(5470),
    [anon_sym_alignas] = ACTIONS(5470),
    [anon_sym__Alignas] = ACTIONS(5470),
    [anon_sym_COLON] = ACTIONS(5470),
    [anon_sym_or] = ACTIONS(5470),
    [anon_sym_and] = ACTIONS(5470),
    [anon_sym_asm] = ACTIONS(5470),
    [anon_sym___asm__] = ACTIONS(5470),
    [anon_sym___asm] = ACTIONS(5470),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5470),
    [anon_sym_decltype] = ACTIONS(5470),
    [anon_sym_final] = ACTIONS(5470),
    [anon_sym_override] = ACTIONS(5470),
    [anon_sym_template] = ACTIONS(5470),
    [anon_sym_GT2] = ACTIONS(5472),
    [anon_sym_operator] = ACTIONS(5470),
    [anon_sym_try] = ACTIONS(5470),
    [anon_sym_requires] = ACTIONS(5470),
  },
  [2146] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2146),
    [sym_identifier] = ACTIONS(4932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4934),
    [anon_sym_COMMA] = ACTIONS(4934),
    [anon_sym_LPAREN2] = ACTIONS(4934),
    [anon_sym_DASH] = ACTIONS(4932),
    [anon_sym_PLUS] = ACTIONS(4932),
    [anon_sym_STAR] = ACTIONS(4934),
    [anon_sym_SLASH] = ACTIONS(4932),
    [anon_sym_PERCENT] = ACTIONS(4934),
    [anon_sym_PIPE_PIPE] = ACTIONS(4934),
    [anon_sym_AMP_AMP] = ACTIONS(4934),
    [anon_sym_PIPE] = ACTIONS(4932),
    [anon_sym_CARET] = ACTIONS(4934),
    [anon_sym_AMP] = ACTIONS(4932),
    [anon_sym_EQ_EQ] = ACTIONS(4934),
    [anon_sym_BANG_EQ] = ACTIONS(4934),
    [anon_sym_GT] = ACTIONS(4932),
    [anon_sym_GT_EQ] = ACTIONS(4932),
    [anon_sym_LT_EQ] = ACTIONS(4932),
    [anon_sym_LT] = ACTIONS(4932),
    [anon_sym_LT_LT] = ACTIONS(4934),
    [anon_sym_GT_GT] = ACTIONS(4932),
    [anon_sym___extension__] = ACTIONS(4932),
    [anon_sym___attribute__] = ACTIONS(4932),
    [anon_sym___attribute] = ACTIONS(4932),
    [anon_sym_LBRACE] = ACTIONS(4934),
    [anon_sym_signed] = ACTIONS(5973),
    [anon_sym_unsigned] = ACTIONS(5973),
    [anon_sym_long] = ACTIONS(5973),
    [anon_sym_short] = ACTIONS(5973),
    [anon_sym_LBRACK] = ACTIONS(4934),
    [anon_sym_const] = ACTIONS(4932),
    [anon_sym_constexpr] = ACTIONS(4932),
    [anon_sym_volatile] = ACTIONS(4932),
    [anon_sym_restrict] = ACTIONS(4932),
    [anon_sym___restrict__] = ACTIONS(4932),
    [anon_sym__Atomic] = ACTIONS(4932),
    [anon_sym__Noreturn] = ACTIONS(4932),
    [anon_sym_noreturn] = ACTIONS(4932),
    [anon_sym__Nonnull] = ACTIONS(4932),
    [anon_sym_mutable] = ACTIONS(4932),
    [anon_sym_constinit] = ACTIONS(4932),
    [anon_sym_consteval] = ACTIONS(4932),
    [anon_sym_alignas] = ACTIONS(4932),
    [anon_sym__Alignas] = ACTIONS(4932),
    [sym_primitive_type] = ACTIONS(4932),
    [anon_sym_QMARK] = ACTIONS(4934),
    [anon_sym_LT_EQ_GT] = ACTIONS(4934),
    [anon_sym_or] = ACTIONS(4932),
    [anon_sym_and] = ACTIONS(4932),
    [anon_sym_bitor] = ACTIONS(4932),
    [anon_sym_xor] = ACTIONS(4932),
    [anon_sym_bitand] = ACTIONS(4932),
    [anon_sym_not_eq] = ACTIONS(4932),
    [anon_sym_DASH_DASH] = ACTIONS(4934),
    [anon_sym_PLUS_PLUS] = ACTIONS(4934),
    [anon_sym_DOT] = ACTIONS(4932),
    [anon_sym_DOT_STAR] = ACTIONS(4934),
    [anon_sym_DASH_GT] = ACTIONS(4934),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4932),
    [anon_sym_decltype] = ACTIONS(4932),
    [anon_sym_final] = ACTIONS(4932),
    [anon_sym_override] = ACTIONS(4932),
    [anon_sym_GT2] = ACTIONS(4934),
    [anon_sym_requires] = ACTIONS(4932),
  },
  [2147] = {
    [sym_attribute_specifier] = STATE(2264),
    [sym_identifier] = ACTIONS(5976),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5978),
    [anon_sym_COMMA] = ACTIONS(5978),
    [anon_sym_RPAREN] = ACTIONS(5978),
    [aux_sym_preproc_if_token2] = ACTIONS(5978),
    [aux_sym_preproc_else_token1] = ACTIONS(5978),
    [aux_sym_preproc_elif_token1] = ACTIONS(5976),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5978),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5978),
    [anon_sym_LPAREN2] = ACTIONS(5978),
    [anon_sym_DASH] = ACTIONS(5976),
    [anon_sym_PLUS] = ACTIONS(5976),
    [anon_sym_STAR] = ACTIONS(5976),
    [anon_sym_SLASH] = ACTIONS(5976),
    [anon_sym_PERCENT] = ACTIONS(5976),
    [anon_sym_PIPE_PIPE] = ACTIONS(5978),
    [anon_sym_AMP_AMP] = ACTIONS(5978),
    [anon_sym_PIPE] = ACTIONS(5976),
    [anon_sym_CARET] = ACTIONS(5976),
    [anon_sym_AMP] = ACTIONS(5976),
    [anon_sym_EQ_EQ] = ACTIONS(5978),
    [anon_sym_BANG_EQ] = ACTIONS(5978),
    [anon_sym_GT] = ACTIONS(5976),
    [anon_sym_GT_EQ] = ACTIONS(5978),
    [anon_sym_LT_EQ] = ACTIONS(5976),
    [anon_sym_LT] = ACTIONS(5976),
    [anon_sym_LT_LT] = ACTIONS(5976),
    [anon_sym_GT_GT] = ACTIONS(5976),
    [anon_sym_SEMI] = ACTIONS(5978),
    [anon_sym___attribute__] = ACTIONS(5379),
    [anon_sym___attribute] = ACTIONS(5379),
    [anon_sym_LBRACE] = ACTIONS(5978),
    [anon_sym_RBRACE] = ACTIONS(5978),
    [anon_sym_LBRACK] = ACTIONS(5978),
    [anon_sym_RBRACK] = ACTIONS(5978),
    [anon_sym_EQ] = ACTIONS(5976),
    [anon_sym_COLON] = ACTIONS(5978),
    [anon_sym_QMARK] = ACTIONS(5978),
    [anon_sym_STAR_EQ] = ACTIONS(5978),
    [anon_sym_SLASH_EQ] = ACTIONS(5978),
    [anon_sym_PERCENT_EQ] = ACTIONS(5978),
    [anon_sym_PLUS_EQ] = ACTIONS(5978),
    [anon_sym_DASH_EQ] = ACTIONS(5978),
    [anon_sym_LT_LT_EQ] = ACTIONS(5978),
    [anon_sym_GT_GT_EQ] = ACTIONS(5978),
    [anon_sym_AMP_EQ] = ACTIONS(5978),
    [anon_sym_CARET_EQ] = ACTIONS(5978),
    [anon_sym_PIPE_EQ] = ACTIONS(5978),
    [anon_sym_and_eq] = ACTIONS(5976),
    [anon_sym_or_eq] = ACTIONS(5976),
    [anon_sym_xor_eq] = ACTIONS(5976),
    [anon_sym_LT_EQ_GT] = ACTIONS(5978),
    [anon_sym_or] = ACTIONS(5976),
    [anon_sym_and] = ACTIONS(5976),
    [anon_sym_bitor] = ACTIONS(5976),
    [anon_sym_xor] = ACTIONS(5976),
    [anon_sym_bitand] = ACTIONS(5976),
    [anon_sym_not_eq] = ACTIONS(5976),
    [anon_sym_DASH_DASH] = ACTIONS(5978),
    [anon_sym_PLUS_PLUS] = ACTIONS(5978),
    [anon_sym_DOT] = ACTIONS(5976),
    [anon_sym_DOT_STAR] = ACTIONS(5978),
    [anon_sym_DASH_GT] = ACTIONS(5978),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5976),
    [anon_sym_decltype] = ACTIONS(5976),
  },
  [2148] = {
    [sym_attribute_specifier] = STATE(2179),
    [sym_identifier] = ACTIONS(5980),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5982),
    [anon_sym_COMMA] = ACTIONS(5982),
    [anon_sym_RPAREN] = ACTIONS(5982),
    [aux_sym_preproc_if_token2] = ACTIONS(5982),
    [aux_sym_preproc_else_token1] = ACTIONS(5982),
    [aux_sym_preproc_elif_token1] = ACTIONS(5980),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5982),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5982),
    [anon_sym_LPAREN2] = ACTIONS(5982),
    [anon_sym_DASH] = ACTIONS(5980),
    [anon_sym_PLUS] = ACTIONS(5980),
    [anon_sym_STAR] = ACTIONS(5980),
    [anon_sym_SLASH] = ACTIONS(5980),
    [anon_sym_PERCENT] = ACTIONS(5980),
    [anon_sym_PIPE_PIPE] = ACTIONS(5982),
    [anon_sym_AMP_AMP] = ACTIONS(5982),
    [anon_sym_PIPE] = ACTIONS(5980),
    [anon_sym_CARET] = ACTIONS(5980),
    [anon_sym_AMP] = ACTIONS(5980),
    [anon_sym_EQ_EQ] = ACTIONS(5982),
    [anon_sym_BANG_EQ] = ACTIONS(5982),
    [anon_sym_GT] = ACTIONS(5980),
    [anon_sym_GT_EQ] = ACTIONS(5982),
    [anon_sym_LT_EQ] = ACTIONS(5980),
    [anon_sym_LT] = ACTIONS(5980),
    [anon_sym_LT_LT] = ACTIONS(5980),
    [anon_sym_GT_GT] = ACTIONS(5980),
    [anon_sym_SEMI] = ACTIONS(5982),
    [anon_sym___attribute__] = ACTIONS(5379),
    [anon_sym___attribute] = ACTIONS(5379),
    [anon_sym_LBRACE] = ACTIONS(5982),
    [anon_sym_RBRACE] = ACTIONS(5982),
    [anon_sym_LBRACK] = ACTIONS(5982),
    [anon_sym_RBRACK] = ACTIONS(5982),
    [anon_sym_EQ] = ACTIONS(5980),
    [anon_sym_COLON] = ACTIONS(5982),
    [anon_sym_QMARK] = ACTIONS(5982),
    [anon_sym_STAR_EQ] = ACTIONS(5982),
    [anon_sym_SLASH_EQ] = ACTIONS(5982),
    [anon_sym_PERCENT_EQ] = ACTIONS(5982),
    [anon_sym_PLUS_EQ] = ACTIONS(5982),
    [anon_sym_DASH_EQ] = ACTIONS(5982),
    [anon_sym_LT_LT_EQ] = ACTIONS(5982),
    [anon_sym_GT_GT_EQ] = ACTIONS(5982),
    [anon_sym_AMP_EQ] = ACTIONS(5982),
    [anon_sym_CARET_EQ] = ACTIONS(5982),
    [anon_sym_PIPE_EQ] = ACTIONS(5982),
    [anon_sym_and_eq] = ACTIONS(5980),
    [anon_sym_or_eq] = ACTIONS(5980),
    [anon_sym_xor_eq] = ACTIONS(5980),
    [anon_sym_LT_EQ_GT] = ACTIONS(5982),
    [anon_sym_or] = ACTIONS(5980),
    [anon_sym_and] = ACTIONS(5980),
    [anon_sym_bitor] = ACTIONS(5980),
    [anon_sym_xor] = ACTIONS(5980),
    [anon_sym_bitand] = ACTIONS(5980),
    [anon_sym_not_eq] = ACTIONS(5980),
    [anon_sym_DASH_DASH] = ACTIONS(5982),
    [anon_sym_PLUS_PLUS] = ACTIONS(5982),
    [anon_sym_DOT] = ACTIONS(5980),
    [anon_sym_DOT_STAR] = ACTIONS(5982),
    [anon_sym_DASH_GT] = ACTIONS(5982),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5980),
    [anon_sym_decltype] = ACTIONS(5980),
  },
  [2149] = {
    [sym_string_literal] = STATE(2129),
    [sym_raw_string_literal] = STATE(2129),
    [aux_sym_concatenated_string_repeat1] = STATE(2129),
    [sym_identifier] = ACTIONS(5984),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5274),
    [anon_sym_COMMA] = ACTIONS(5274),
    [anon_sym_RPAREN] = ACTIONS(5274),
    [anon_sym_LPAREN2] = ACTIONS(5274),
    [anon_sym_DASH] = ACTIONS(5276),
    [anon_sym_PLUS] = ACTIONS(5276),
    [anon_sym_STAR] = ACTIONS(5276),
    [anon_sym_SLASH] = ACTIONS(5276),
    [anon_sym_PERCENT] = ACTIONS(5276),
    [anon_sym_PIPE_PIPE] = ACTIONS(5274),
    [anon_sym_AMP_AMP] = ACTIONS(5274),
    [anon_sym_PIPE] = ACTIONS(5276),
    [anon_sym_CARET] = ACTIONS(5276),
    [anon_sym_AMP] = ACTIONS(5276),
    [anon_sym_EQ_EQ] = ACTIONS(5274),
    [anon_sym_BANG_EQ] = ACTIONS(5274),
    [anon_sym_GT] = ACTIONS(5276),
    [anon_sym_GT_EQ] = ACTIONS(5274),
    [anon_sym_LT_EQ] = ACTIONS(5276),
    [anon_sym_LT] = ACTIONS(5276),
    [anon_sym_LT_LT] = ACTIONS(5276),
    [anon_sym_GT_GT] = ACTIONS(5276),
    [anon_sym_LBRACK] = ACTIONS(5274),
    [anon_sym_EQ] = ACTIONS(5276),
    [anon_sym_QMARK] = ACTIONS(5274),
    [anon_sym_STAR_EQ] = ACTIONS(5274),
    [anon_sym_SLASH_EQ] = ACTIONS(5274),
    [anon_sym_PERCENT_EQ] = ACTIONS(5274),
    [anon_sym_PLUS_EQ] = ACTIONS(5274),
    [anon_sym_DASH_EQ] = ACTIONS(5274),
    [anon_sym_LT_LT_EQ] = ACTIONS(5274),
    [anon_sym_GT_GT_EQ] = ACTIONS(5274),
    [anon_sym_AMP_EQ] = ACTIONS(5274),
    [anon_sym_CARET_EQ] = ACTIONS(5274),
    [anon_sym_PIPE_EQ] = ACTIONS(5274),
    [anon_sym_and_eq] = ACTIONS(5276),
    [anon_sym_or_eq] = ACTIONS(5276),
    [anon_sym_xor_eq] = ACTIONS(5276),
    [anon_sym_LT_EQ_GT] = ACTIONS(5274),
    [anon_sym_or] = ACTIONS(5276),
    [anon_sym_and] = ACTIONS(5276),
    [anon_sym_bitor] = ACTIONS(5276),
    [anon_sym_xor] = ACTIONS(5276),
    [anon_sym_bitand] = ACTIONS(5276),
    [anon_sym_not_eq] = ACTIONS(5276),
    [anon_sym_DASH_DASH] = ACTIONS(5274),
    [anon_sym_PLUS_PLUS] = ACTIONS(5274),
    [anon_sym_DOT] = ACTIONS(5276),
    [anon_sym_DOT_STAR] = ACTIONS(5274),
    [anon_sym_DASH_GT] = ACTIONS(5276),
    [anon_sym_L_DQUOTE] = ACTIONS(4899),
    [anon_sym_u_DQUOTE] = ACTIONS(4899),
    [anon_sym_U_DQUOTE] = ACTIONS(4899),
    [anon_sym_u8_DQUOTE] = ACTIONS(4899),
    [anon_sym_DQUOTE] = ACTIONS(4899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4901),
    [anon_sym_LR_DQUOTE] = ACTIONS(4901),
    [anon_sym_uR_DQUOTE] = ACTIONS(4901),
    [anon_sym_UR_DQUOTE] = ACTIONS(4901),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4901),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5274),
    [sym_literal_suffix] = ACTIONS(5276),
  },
  [2150] = {
    [sym_attribute_specifier] = STATE(2251),
    [sym_identifier] = ACTIONS(5986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5988),
    [anon_sym_COMMA] = ACTIONS(5988),
    [anon_sym_RPAREN] = ACTIONS(5988),
    [aux_sym_preproc_if_token2] = ACTIONS(5988),
    [aux_sym_preproc_else_token1] = ACTIONS(5988),
    [aux_sym_preproc_elif_token1] = ACTIONS(5986),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5988),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5988),
    [anon_sym_LPAREN2] = ACTIONS(5988),
    [anon_sym_DASH] = ACTIONS(5986),
    [anon_sym_PLUS] = ACTIONS(5986),
    [anon_sym_STAR] = ACTIONS(5986),
    [anon_sym_SLASH] = ACTIONS(5986),
    [anon_sym_PERCENT] = ACTIONS(5986),
    [anon_sym_PIPE_PIPE] = ACTIONS(5988),
    [anon_sym_AMP_AMP] = ACTIONS(5988),
    [anon_sym_PIPE] = ACTIONS(5986),
    [anon_sym_CARET] = ACTIONS(5986),
    [anon_sym_AMP] = ACTIONS(5986),
    [anon_sym_EQ_EQ] = ACTIONS(5988),
    [anon_sym_BANG_EQ] = ACTIONS(5988),
    [anon_sym_GT] = ACTIONS(5986),
    [anon_sym_GT_EQ] = ACTIONS(5988),
    [anon_sym_LT_EQ] = ACTIONS(5986),
    [anon_sym_LT] = ACTIONS(5986),
    [anon_sym_LT_LT] = ACTIONS(5986),
    [anon_sym_GT_GT] = ACTIONS(5986),
    [anon_sym_SEMI] = ACTIONS(5988),
    [anon_sym___attribute__] = ACTIONS(5379),
    [anon_sym___attribute] = ACTIONS(5379),
    [anon_sym_LBRACE] = ACTIONS(5988),
    [anon_sym_RBRACE] = ACTIONS(5988),
    [anon_sym_LBRACK] = ACTIONS(5988),
    [anon_sym_RBRACK] = ACTIONS(5988),
    [anon_sym_EQ] = ACTIONS(5986),
    [anon_sym_COLON] = ACTIONS(5988),
    [anon_sym_QMARK] = ACTIONS(5988),
    [anon_sym_STAR_EQ] = ACTIONS(5988),
    [anon_sym_SLASH_EQ] = ACTIONS(5988),
    [anon_sym_PERCENT_EQ] = ACTIONS(5988),
    [anon_sym_PLUS_EQ] = ACTIONS(5988),
    [anon_sym_DASH_EQ] = ACTIONS(5988),
    [anon_sym_LT_LT_EQ] = ACTIONS(5988),
    [anon_sym_GT_GT_EQ] = ACTIONS(5988),
    [anon_sym_AMP_EQ] = ACTIONS(5988),
    [anon_sym_CARET_EQ] = ACTIONS(5988),
    [anon_sym_PIPE_EQ] = ACTIONS(5988),
    [anon_sym_and_eq] = ACTIONS(5986),
    [anon_sym_or_eq] = ACTIONS(5986),
    [anon_sym_xor_eq] = ACTIONS(5986),
    [anon_sym_LT_EQ_GT] = ACTIONS(5988),
    [anon_sym_or] = ACTIONS(5986),
    [anon_sym_and] = ACTIONS(5986),
    [anon_sym_bitor] = ACTIONS(5986),
    [anon_sym_xor] = ACTIONS(5986),
    [anon_sym_bitand] = ACTIONS(5986),
    [anon_sym_not_eq] = ACTIONS(5986),
    [anon_sym_DASH_DASH] = ACTIONS(5988),
    [anon_sym_PLUS_PLUS] = ACTIONS(5988),
    [anon_sym_DOT] = ACTIONS(5986),
    [anon_sym_DOT_STAR] = ACTIONS(5988),
    [anon_sym_DASH_GT] = ACTIONS(5988),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5986),
    [anon_sym_decltype] = ACTIONS(5986),
  },
  [2151] = {
    [sym_attribute_specifier] = STATE(2195),
    [sym_identifier] = ACTIONS(5990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5992),
    [anon_sym_COMMA] = ACTIONS(5992),
    [anon_sym_RPAREN] = ACTIONS(5992),
    [aux_sym_preproc_if_token2] = ACTIONS(5992),
    [aux_sym_preproc_else_token1] = ACTIONS(5992),
    [aux_sym_preproc_elif_token1] = ACTIONS(5990),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5992),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5992),
    [anon_sym_LPAREN2] = ACTIONS(5992),
    [anon_sym_DASH] = ACTIONS(5990),
    [anon_sym_PLUS] = ACTIONS(5990),
    [anon_sym_STAR] = ACTIONS(5990),
    [anon_sym_SLASH] = ACTIONS(5990),
    [anon_sym_PERCENT] = ACTIONS(5990),
    [anon_sym_PIPE_PIPE] = ACTIONS(5992),
    [anon_sym_AMP_AMP] = ACTIONS(5992),
    [anon_sym_PIPE] = ACTIONS(5990),
    [anon_sym_CARET] = ACTIONS(5990),
    [anon_sym_AMP] = ACTIONS(5990),
    [anon_sym_EQ_EQ] = ACTIONS(5992),
    [anon_sym_BANG_EQ] = ACTIONS(5992),
    [anon_sym_GT] = ACTIONS(5990),
    [anon_sym_GT_EQ] = ACTIONS(5992),
    [anon_sym_LT_EQ] = ACTIONS(5990),
    [anon_sym_LT] = ACTIONS(5990),
    [anon_sym_LT_LT] = ACTIONS(5990),
    [anon_sym_GT_GT] = ACTIONS(5990),
    [anon_sym_SEMI] = ACTIONS(5992),
    [anon_sym___attribute__] = ACTIONS(5379),
    [anon_sym___attribute] = ACTIONS(5379),
    [anon_sym_LBRACE] = ACTIONS(5992),
    [anon_sym_RBRACE] = ACTIONS(5992),
    [anon_sym_LBRACK] = ACTIONS(5992),
    [anon_sym_RBRACK] = ACTIONS(5992),
    [anon_sym_EQ] = ACTIONS(5990),
    [anon_sym_COLON] = ACTIONS(5992),
    [anon_sym_QMARK] = ACTIONS(5992),
    [anon_sym_STAR_EQ] = ACTIONS(5992),
    [anon_sym_SLASH_EQ] = ACTIONS(5992),
    [anon_sym_PERCENT_EQ] = ACTIONS(5992),
    [anon_sym_PLUS_EQ] = ACTIONS(5992),
    [anon_sym_DASH_EQ] = ACTIONS(5992),
    [anon_sym_LT_LT_EQ] = ACTIONS(5992),
    [anon_sym_GT_GT_EQ] = ACTIONS(5992),
    [anon_sym_AMP_EQ] = ACTIONS(5992),
    [anon_sym_CARET_EQ] = ACTIONS(5992),
    [anon_sym_PIPE_EQ] = ACTIONS(5992),
    [anon_sym_and_eq] = ACTIONS(5990),
    [anon_sym_or_eq] = ACTIONS(5990),
    [anon_sym_xor_eq] = ACTIONS(5990),
    [anon_sym_LT_EQ_GT] = ACTIONS(5992),
    [anon_sym_or] = ACTIONS(5990),
    [anon_sym_and] = ACTIONS(5990),
    [anon_sym_bitor] = ACTIONS(5990),
    [anon_sym_xor] = ACTIONS(5990),
    [anon_sym_bitand] = ACTIONS(5990),
    [anon_sym_not_eq] = ACTIONS(5990),
    [anon_sym_DASH_DASH] = ACTIONS(5992),
    [anon_sym_PLUS_PLUS] = ACTIONS(5992),
    [anon_sym_DOT] = ACTIONS(5990),
    [anon_sym_DOT_STAR] = ACTIONS(5992),
    [anon_sym_DASH_GT] = ACTIONS(5992),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5990),
    [anon_sym_decltype] = ACTIONS(5990),
  },
  [2152] = {
    [sym_string_literal] = STATE(2570),
    [sym_template_argument_list] = STATE(3643),
    [sym_raw_string_literal] = STATE(2570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4035),
    [anon_sym_COMMA] = ACTIONS(4035),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_DASH] = ACTIONS(4043),
    [anon_sym_PLUS] = ACTIONS(4043),
    [anon_sym_STAR] = ACTIONS(4043),
    [anon_sym_SLASH] = ACTIONS(4043),
    [anon_sym_PERCENT] = ACTIONS(4043),
    [anon_sym_PIPE_PIPE] = ACTIONS(4035),
    [anon_sym_AMP_AMP] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4043),
    [anon_sym_CARET] = ACTIONS(4043),
    [anon_sym_AMP] = ACTIONS(4043),
    [anon_sym_EQ_EQ] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4043),
    [anon_sym_GT_EQ] = ACTIONS(4035),
    [anon_sym_LT_EQ] = ACTIONS(4043),
    [anon_sym_LT] = ACTIONS(4929),
    [anon_sym_LT_LT] = ACTIONS(4043),
    [anon_sym_GT_GT] = ACTIONS(4043),
    [anon_sym_SEMI] = ACTIONS(4035),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACE] = ACTIONS(4059),
    [anon_sym_LBRACK] = ACTIONS(4035),
    [anon_sym_EQ] = ACTIONS(4067),
    [anon_sym_COLON] = ACTIONS(4149),
    [anon_sym_QMARK] = ACTIONS(4035),
    [anon_sym_STAR_EQ] = ACTIONS(4071),
    [anon_sym_SLASH_EQ] = ACTIONS(4071),
    [anon_sym_PERCENT_EQ] = ACTIONS(4071),
    [anon_sym_PLUS_EQ] = ACTIONS(4071),
    [anon_sym_DASH_EQ] = ACTIONS(4071),
    [anon_sym_LT_LT_EQ] = ACTIONS(4071),
    [anon_sym_GT_GT_EQ] = ACTIONS(4071),
    [anon_sym_AMP_EQ] = ACTIONS(4071),
    [anon_sym_CARET_EQ] = ACTIONS(4071),
    [anon_sym_PIPE_EQ] = ACTIONS(4071),
    [anon_sym_and_eq] = ACTIONS(4071),
    [anon_sym_or_eq] = ACTIONS(4071),
    [anon_sym_xor_eq] = ACTIONS(4071),
    [anon_sym_LT_EQ_GT] = ACTIONS(4035),
    [anon_sym_or] = ACTIONS(4043),
    [anon_sym_and] = ACTIONS(4043),
    [anon_sym_bitor] = ACTIONS(4035),
    [anon_sym_xor] = ACTIONS(4043),
    [anon_sym_bitand] = ACTIONS(4035),
    [anon_sym_not_eq] = ACTIONS(4035),
    [anon_sym_DASH_DASH] = ACTIONS(4035),
    [anon_sym_PLUS_PLUS] = ACTIONS(4035),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_DOT_STAR] = ACTIONS(4035),
    [anon_sym_DASH_GT] = ACTIONS(4035),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
  },
  [2153] = {
    [sym_identifier] = ACTIONS(5371),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5373),
    [anon_sym_COMMA] = ACTIONS(5373),
    [anon_sym_RPAREN] = ACTIONS(5373),
    [aux_sym_preproc_if_token2] = ACTIONS(5373),
    [aux_sym_preproc_else_token1] = ACTIONS(5373),
    [aux_sym_preproc_elif_token1] = ACTIONS(5371),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5373),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5373),
    [anon_sym_LPAREN2] = ACTIONS(5373),
    [anon_sym_DASH] = ACTIONS(5371),
    [anon_sym_PLUS] = ACTIONS(5371),
    [anon_sym_STAR] = ACTIONS(5371),
    [anon_sym_SLASH] = ACTIONS(5371),
    [anon_sym_PERCENT] = ACTIONS(5371),
    [anon_sym_PIPE_PIPE] = ACTIONS(5373),
    [anon_sym_AMP_AMP] = ACTIONS(5373),
    [anon_sym_PIPE] = ACTIONS(5371),
    [anon_sym_CARET] = ACTIONS(5371),
    [anon_sym_AMP] = ACTIONS(5371),
    [anon_sym_EQ_EQ] = ACTIONS(5373),
    [anon_sym_BANG_EQ] = ACTIONS(5373),
    [anon_sym_GT] = ACTIONS(5371),
    [anon_sym_GT_EQ] = ACTIONS(5373),
    [anon_sym_LT_EQ] = ACTIONS(5371),
    [anon_sym_LT] = ACTIONS(5371),
    [anon_sym_LT_LT] = ACTIONS(5371),
    [anon_sym_GT_GT] = ACTIONS(5371),
    [anon_sym_SEMI] = ACTIONS(5373),
    [anon_sym___attribute__] = ACTIONS(5371),
    [anon_sym___attribute] = ACTIONS(5371),
    [anon_sym_COLON_COLON] = ACTIONS(5373),
    [anon_sym_LBRACE] = ACTIONS(5373),
    [anon_sym_RBRACE] = ACTIONS(5373),
    [anon_sym_LBRACK] = ACTIONS(5373),
    [anon_sym_RBRACK] = ACTIONS(5373),
    [anon_sym_EQ] = ACTIONS(5371),
    [anon_sym_COLON] = ACTIONS(5371),
    [anon_sym_QMARK] = ACTIONS(5373),
    [anon_sym_STAR_EQ] = ACTIONS(5373),
    [anon_sym_SLASH_EQ] = ACTIONS(5373),
    [anon_sym_PERCENT_EQ] = ACTIONS(5373),
    [anon_sym_PLUS_EQ] = ACTIONS(5373),
    [anon_sym_DASH_EQ] = ACTIONS(5373),
    [anon_sym_LT_LT_EQ] = ACTIONS(5373),
    [anon_sym_GT_GT_EQ] = ACTIONS(5373),
    [anon_sym_AMP_EQ] = ACTIONS(5373),
    [anon_sym_CARET_EQ] = ACTIONS(5373),
    [anon_sym_PIPE_EQ] = ACTIONS(5373),
    [anon_sym_and_eq] = ACTIONS(5371),
    [anon_sym_or_eq] = ACTIONS(5371),
    [anon_sym_xor_eq] = ACTIONS(5371),
    [anon_sym_LT_EQ_GT] = ACTIONS(5373),
    [anon_sym_or] = ACTIONS(5371),
    [anon_sym_and] = ACTIONS(5371),
    [anon_sym_bitor] = ACTIONS(5371),
    [anon_sym_xor] = ACTIONS(5371),
    [anon_sym_bitand] = ACTIONS(5371),
    [anon_sym_not_eq] = ACTIONS(5371),
    [anon_sym_DASH_DASH] = ACTIONS(5373),
    [anon_sym_PLUS_PLUS] = ACTIONS(5373),
    [anon_sym_DOT] = ACTIONS(5371),
    [anon_sym_DOT_STAR] = ACTIONS(5373),
    [anon_sym_DASH_GT] = ACTIONS(5373),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5371),
    [anon_sym_decltype] = ACTIONS(5371),
  },
  [2154] = {
    [sym_type_qualifier] = STATE(2155),
    [sym_alignas_qualifier] = STATE(2209),
    [aux_sym__type_definition_type_repeat1] = STATE(2155),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2339),
    [sym_identifier] = ACTIONS(5994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4946),
    [anon_sym_COMMA] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(4946),
    [anon_sym_DASH] = ACTIONS(4948),
    [anon_sym_PLUS] = ACTIONS(4948),
    [anon_sym_STAR] = ACTIONS(4946),
    [anon_sym_SLASH] = ACTIONS(4948),
    [anon_sym_PERCENT] = ACTIONS(4946),
    [anon_sym_PIPE_PIPE] = ACTIONS(4946),
    [anon_sym_AMP_AMP] = ACTIONS(4946),
    [anon_sym_PIPE] = ACTIONS(4948),
    [anon_sym_CARET] = ACTIONS(4946),
    [anon_sym_AMP] = ACTIONS(4948),
    [anon_sym_EQ_EQ] = ACTIONS(4946),
    [anon_sym_BANG_EQ] = ACTIONS(4946),
    [anon_sym_GT] = ACTIONS(4948),
    [anon_sym_GT_EQ] = ACTIONS(4948),
    [anon_sym_LT_EQ] = ACTIONS(4948),
    [anon_sym_LT] = ACTIONS(4948),
    [anon_sym_LT_LT] = ACTIONS(4946),
    [anon_sym_GT_GT] = ACTIONS(4948),
    [anon_sym___extension__] = ACTIONS(5996),
    [anon_sym___attribute__] = ACTIONS(4948),
    [anon_sym___attribute] = ACTIONS(4948),
    [anon_sym_LBRACE] = ACTIONS(4946),
    [anon_sym_signed] = ACTIONS(5998),
    [anon_sym_unsigned] = ACTIONS(5998),
    [anon_sym_long] = ACTIONS(5998),
    [anon_sym_short] = ACTIONS(5998),
    [anon_sym_LBRACK] = ACTIONS(4946),
    [anon_sym_const] = ACTIONS(5996),
    [anon_sym_constexpr] = ACTIONS(5996),
    [anon_sym_volatile] = ACTIONS(5996),
    [anon_sym_restrict] = ACTIONS(5996),
    [anon_sym___restrict__] = ACTIONS(5996),
    [anon_sym__Atomic] = ACTIONS(5996),
    [anon_sym__Noreturn] = ACTIONS(5996),
    [anon_sym_noreturn] = ACTIONS(5996),
    [anon_sym__Nonnull] = ACTIONS(5996),
    [anon_sym_mutable] = ACTIONS(5996),
    [anon_sym_constinit] = ACTIONS(5996),
    [anon_sym_consteval] = ACTIONS(5996),
    [anon_sym_alignas] = ACTIONS(6000),
    [anon_sym__Alignas] = ACTIONS(6000),
    [sym_primitive_type] = ACTIONS(6002),
    [anon_sym_QMARK] = ACTIONS(4946),
    [anon_sym_LT_EQ_GT] = ACTIONS(4946),
    [anon_sym_or] = ACTIONS(4948),
    [anon_sym_and] = ACTIONS(4948),
    [anon_sym_bitor] = ACTIONS(4948),
    [anon_sym_xor] = ACTIONS(4948),
    [anon_sym_bitand] = ACTIONS(4948),
    [anon_sym_not_eq] = ACTIONS(4948),
    [anon_sym_DASH_DASH] = ACTIONS(4946),
    [anon_sym_PLUS_PLUS] = ACTIONS(4946),
    [anon_sym_DOT] = ACTIONS(4948),
    [anon_sym_DOT_STAR] = ACTIONS(4946),
    [anon_sym_DASH_GT] = ACTIONS(4946),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4948),
    [anon_sym_decltype] = ACTIONS(4948),
    [anon_sym_GT2] = ACTIONS(4946),
  },
  [2155] = {
    [sym_type_qualifier] = STATE(1882),
    [sym_alignas_qualifier] = STATE(2209),
    [aux_sym__type_definition_type_repeat1] = STATE(1882),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2301),
    [sym_identifier] = ACTIONS(6004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4961),
    [anon_sym_COMMA] = ACTIONS(4961),
    [anon_sym_LPAREN2] = ACTIONS(4961),
    [anon_sym_DASH] = ACTIONS(4963),
    [anon_sym_PLUS] = ACTIONS(4963),
    [anon_sym_STAR] = ACTIONS(4961),
    [anon_sym_SLASH] = ACTIONS(4963),
    [anon_sym_PERCENT] = ACTIONS(4961),
    [anon_sym_PIPE_PIPE] = ACTIONS(4961),
    [anon_sym_AMP_AMP] = ACTIONS(4961),
    [anon_sym_PIPE] = ACTIONS(4963),
    [anon_sym_CARET] = ACTIONS(4961),
    [anon_sym_AMP] = ACTIONS(4963),
    [anon_sym_EQ_EQ] = ACTIONS(4961),
    [anon_sym_BANG_EQ] = ACTIONS(4961),
    [anon_sym_GT] = ACTIONS(4963),
    [anon_sym_GT_EQ] = ACTIONS(4963),
    [anon_sym_LT_EQ] = ACTIONS(4963),
    [anon_sym_LT] = ACTIONS(4963),
    [anon_sym_LT_LT] = ACTIONS(4961),
    [anon_sym_GT_GT] = ACTIONS(4963),
    [anon_sym___extension__] = ACTIONS(5996),
    [anon_sym___attribute__] = ACTIONS(4963),
    [anon_sym___attribute] = ACTIONS(4963),
    [anon_sym_LBRACE] = ACTIONS(4961),
    [anon_sym_signed] = ACTIONS(6006),
    [anon_sym_unsigned] = ACTIONS(6006),
    [anon_sym_long] = ACTIONS(6006),
    [anon_sym_short] = ACTIONS(6006),
    [anon_sym_LBRACK] = ACTIONS(4961),
    [anon_sym_const] = ACTIONS(5996),
    [anon_sym_constexpr] = ACTIONS(5996),
    [anon_sym_volatile] = ACTIONS(5996),
    [anon_sym_restrict] = ACTIONS(5996),
    [anon_sym___restrict__] = ACTIONS(5996),
    [anon_sym__Atomic] = ACTIONS(5996),
    [anon_sym__Noreturn] = ACTIONS(5996),
    [anon_sym_noreturn] = ACTIONS(5996),
    [anon_sym__Nonnull] = ACTIONS(5996),
    [anon_sym_mutable] = ACTIONS(5996),
    [anon_sym_constinit] = ACTIONS(5996),
    [anon_sym_consteval] = ACTIONS(5996),
    [anon_sym_alignas] = ACTIONS(6000),
    [anon_sym__Alignas] = ACTIONS(6000),
    [sym_primitive_type] = ACTIONS(6008),
    [anon_sym_QMARK] = ACTIONS(4961),
    [anon_sym_LT_EQ_GT] = ACTIONS(4961),
    [anon_sym_or] = ACTIONS(4963),
    [anon_sym_and] = ACTIONS(4963),
    [anon_sym_bitor] = ACTIONS(4963),
    [anon_sym_xor] = ACTIONS(4963),
    [anon_sym_bitand] = ACTIONS(4963),
    [anon_sym_not_eq] = ACTIONS(4963),
    [anon_sym_DASH_DASH] = ACTIONS(4961),
    [anon_sym_PLUS_PLUS] = ACTIONS(4961),
    [anon_sym_DOT] = ACTIONS(4963),
    [anon_sym_DOT_STAR] = ACTIONS(4961),
    [anon_sym_DASH_GT] = ACTIONS(4961),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4963),
    [anon_sym_decltype] = ACTIONS(4963),
    [anon_sym_GT2] = ACTIONS(4961),
  },
  [2156] = {
    [sym_decltype_auto] = STATE(2183),
    [sym_identifier] = ACTIONS(5391),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5393),
    [anon_sym_COMMA] = ACTIONS(5393),
    [anon_sym_RPAREN] = ACTIONS(5393),
    [aux_sym_preproc_if_token2] = ACTIONS(5393),
    [aux_sym_preproc_else_token1] = ACTIONS(5393),
    [aux_sym_preproc_elif_token1] = ACTIONS(5391),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5393),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5393),
    [anon_sym_LPAREN2] = ACTIONS(5393),
    [anon_sym_DASH] = ACTIONS(5391),
    [anon_sym_PLUS] = ACTIONS(5391),
    [anon_sym_STAR] = ACTIONS(5391),
    [anon_sym_SLASH] = ACTIONS(5391),
    [anon_sym_PERCENT] = ACTIONS(5391),
    [anon_sym_PIPE_PIPE] = ACTIONS(5393),
    [anon_sym_AMP_AMP] = ACTIONS(5393),
    [anon_sym_PIPE] = ACTIONS(5391),
    [anon_sym_CARET] = ACTIONS(5391),
    [anon_sym_AMP] = ACTIONS(5391),
    [anon_sym_EQ_EQ] = ACTIONS(5393),
    [anon_sym_BANG_EQ] = ACTIONS(5393),
    [anon_sym_GT] = ACTIONS(5391),
    [anon_sym_GT_EQ] = ACTIONS(5393),
    [anon_sym_LT_EQ] = ACTIONS(5391),
    [anon_sym_LT] = ACTIONS(5391),
    [anon_sym_LT_LT] = ACTIONS(5391),
    [anon_sym_GT_GT] = ACTIONS(5391),
    [anon_sym_SEMI] = ACTIONS(5393),
    [anon_sym___attribute__] = ACTIONS(5391),
    [anon_sym___attribute] = ACTIONS(5391),
    [anon_sym_LBRACE] = ACTIONS(5393),
    [anon_sym_RBRACE] = ACTIONS(5393),
    [anon_sym_LBRACK] = ACTIONS(5393),
    [anon_sym_RBRACK] = ACTIONS(5393),
    [anon_sym_EQ] = ACTIONS(5391),
    [anon_sym_COLON] = ACTIONS(5393),
    [anon_sym_QMARK] = ACTIONS(5393),
    [anon_sym_STAR_EQ] = ACTIONS(5393),
    [anon_sym_SLASH_EQ] = ACTIONS(5393),
    [anon_sym_PERCENT_EQ] = ACTIONS(5393),
    [anon_sym_PLUS_EQ] = ACTIONS(5393),
    [anon_sym_DASH_EQ] = ACTIONS(5393),
    [anon_sym_LT_LT_EQ] = ACTIONS(5393),
    [anon_sym_GT_GT_EQ] = ACTIONS(5393),
    [anon_sym_AMP_EQ] = ACTIONS(5393),
    [anon_sym_CARET_EQ] = ACTIONS(5393),
    [anon_sym_PIPE_EQ] = ACTIONS(5393),
    [anon_sym_and_eq] = ACTIONS(5391),
    [anon_sym_or_eq] = ACTIONS(5391),
    [anon_sym_xor_eq] = ACTIONS(5391),
    [anon_sym_LT_EQ_GT] = ACTIONS(5393),
    [anon_sym_or] = ACTIONS(5391),
    [anon_sym_and] = ACTIONS(5391),
    [anon_sym_bitor] = ACTIONS(5391),
    [anon_sym_xor] = ACTIONS(5391),
    [anon_sym_bitand] = ACTIONS(5391),
    [anon_sym_not_eq] = ACTIONS(5391),
    [anon_sym_DASH_DASH] = ACTIONS(5393),
    [anon_sym_PLUS_PLUS] = ACTIONS(5393),
    [anon_sym_DOT] = ACTIONS(5391),
    [anon_sym_DOT_STAR] = ACTIONS(5393),
    [anon_sym_DASH_GT] = ACTIONS(5393),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5692),
    [anon_sym_decltype] = ACTIONS(5694),
  },
  [2157] = {
    [sym_string_literal] = STATE(2570),
    [sym_template_argument_list] = STATE(3643),
    [sym_raw_string_literal] = STATE(2570),
    [aux_sym_structured_binding_declarator_repeat1] = STATE(7394),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4035),
    [anon_sym_COMMA] = ACTIONS(6010),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_DASH] = ACTIONS(4043),
    [anon_sym_PLUS] = ACTIONS(4043),
    [anon_sym_STAR] = ACTIONS(4043),
    [anon_sym_SLASH] = ACTIONS(4043),
    [anon_sym_PERCENT] = ACTIONS(4043),
    [anon_sym_PIPE_PIPE] = ACTIONS(4035),
    [anon_sym_AMP_AMP] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4043),
    [anon_sym_CARET] = ACTIONS(4043),
    [anon_sym_AMP] = ACTIONS(4043),
    [anon_sym_EQ_EQ] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4043),
    [anon_sym_GT_EQ] = ACTIONS(4035),
    [anon_sym_LT_EQ] = ACTIONS(4043),
    [anon_sym_LT] = ACTIONS(4929),
    [anon_sym_LT_LT] = ACTIONS(4043),
    [anon_sym_GT_GT] = ACTIONS(4043),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACE] = ACTIONS(4059),
    [anon_sym_LBRACK] = ACTIONS(4035),
    [anon_sym_RBRACK] = ACTIONS(6012),
    [anon_sym_EQ] = ACTIONS(6015),
    [anon_sym_QMARK] = ACTIONS(4035),
    [anon_sym_STAR_EQ] = ACTIONS(5941),
    [anon_sym_SLASH_EQ] = ACTIONS(5941),
    [anon_sym_PERCENT_EQ] = ACTIONS(5941),
    [anon_sym_PLUS_EQ] = ACTIONS(5941),
    [anon_sym_DASH_EQ] = ACTIONS(5941),
    [anon_sym_LT_LT_EQ] = ACTIONS(5941),
    [anon_sym_GT_GT_EQ] = ACTIONS(5941),
    [anon_sym_AMP_EQ] = ACTIONS(5941),
    [anon_sym_CARET_EQ] = ACTIONS(5941),
    [anon_sym_PIPE_EQ] = ACTIONS(5941),
    [anon_sym_and_eq] = ACTIONS(5941),
    [anon_sym_or_eq] = ACTIONS(5941),
    [anon_sym_xor_eq] = ACTIONS(5941),
    [anon_sym_LT_EQ_GT] = ACTIONS(4035),
    [anon_sym_or] = ACTIONS(4043),
    [anon_sym_and] = ACTIONS(4043),
    [anon_sym_bitor] = ACTIONS(4035),
    [anon_sym_xor] = ACTIONS(4043),
    [anon_sym_bitand] = ACTIONS(4035),
    [anon_sym_not_eq] = ACTIONS(4035),
    [anon_sym_DASH_DASH] = ACTIONS(4035),
    [anon_sym_PLUS_PLUS] = ACTIONS(4035),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_DOT_STAR] = ACTIONS(4035),
    [anon_sym_DASH_GT] = ACTIONS(4035),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
  },
  [2158] = {
    [sym_identifier] = ACTIONS(5443),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5445),
    [anon_sym_COMMA] = ACTIONS(5445),
    [anon_sym_RPAREN] = ACTIONS(5445),
    [anon_sym_LPAREN2] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_STAR] = ACTIONS(5445),
    [anon_sym_PIPE_PIPE] = ACTIONS(5445),
    [anon_sym_AMP_AMP] = ACTIONS(5445),
    [anon_sym_AMP] = ACTIONS(5443),
    [anon_sym_SEMI] = ACTIONS(5445),
    [anon_sym___extension__] = ACTIONS(5443),
    [anon_sym_virtual] = ACTIONS(5443),
    [anon_sym_extern] = ACTIONS(5443),
    [anon_sym___attribute__] = ACTIONS(5443),
    [anon_sym___attribute] = ACTIONS(5443),
    [anon_sym_COLON_COLON] = ACTIONS(5365),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5445),
    [anon_sym___declspec] = ACTIONS(5443),
    [anon_sym___based] = ACTIONS(5443),
    [anon_sym___cdecl] = ACTIONS(5443),
    [anon_sym___clrcall] = ACTIONS(5443),
    [anon_sym___stdcall] = ACTIONS(5443),
    [anon_sym___fastcall] = ACTIONS(5443),
    [anon_sym___thiscall] = ACTIONS(5443),
    [anon_sym___vectorcall] = ACTIONS(5443),
    [anon_sym_LBRACE] = ACTIONS(5445),
    [anon_sym_LBRACK] = ACTIONS(5443),
    [anon_sym_static] = ACTIONS(5443),
    [anon_sym_EQ] = ACTIONS(5445),
    [anon_sym_register] = ACTIONS(5443),
    [anon_sym_inline] = ACTIONS(5443),
    [anon_sym___inline] = ACTIONS(5443),
    [anon_sym___inline__] = ACTIONS(5443),
    [anon_sym___forceinline] = ACTIONS(5443),
    [anon_sym_thread_local] = ACTIONS(5443),
    [anon_sym___thread] = ACTIONS(5443),
    [anon_sym_const] = ACTIONS(5443),
    [anon_sym_constexpr] = ACTIONS(5443),
    [anon_sym_volatile] = ACTIONS(5443),
    [anon_sym_restrict] = ACTIONS(5443),
    [anon_sym___restrict__] = ACTIONS(5443),
    [anon_sym__Atomic] = ACTIONS(5443),
    [anon_sym__Noreturn] = ACTIONS(5443),
    [anon_sym_noreturn] = ACTIONS(5443),
    [anon_sym__Nonnull] = ACTIONS(5443),
    [anon_sym_mutable] = ACTIONS(5443),
    [anon_sym_constinit] = ACTIONS(5443),
    [anon_sym_consteval] = ACTIONS(5443),
    [anon_sym_alignas] = ACTIONS(5443),
    [anon_sym__Alignas] = ACTIONS(5443),
    [anon_sym_COLON] = ACTIONS(5443),
    [anon_sym_or] = ACTIONS(5443),
    [anon_sym_and] = ACTIONS(5443),
    [anon_sym_asm] = ACTIONS(5443),
    [anon_sym___asm__] = ACTIONS(5443),
    [anon_sym___asm] = ACTIONS(5443),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5443),
    [anon_sym_decltype] = ACTIONS(5443),
    [anon_sym_final] = ACTIONS(5443),
    [anon_sym_override] = ACTIONS(5443),
    [anon_sym_template] = ACTIONS(5443),
    [anon_sym_GT2] = ACTIONS(5445),
    [anon_sym_operator] = ACTIONS(5443),
    [anon_sym_try] = ACTIONS(5443),
    [anon_sym_requires] = ACTIONS(5443),
  },
  [2159] = {
    [sym_attribute_declaration] = STATE(2255),
    [sym_parameter_list] = STATE(2187),
    [aux_sym_attributed_declarator_repeat1] = STATE(2255),
    [sym_identifier] = ACTIONS(6017),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6019),
    [anon_sym_COMMA] = ACTIONS(6019),
    [anon_sym_RPAREN] = ACTIONS(6019),
    [aux_sym_preproc_if_token2] = ACTIONS(6019),
    [aux_sym_preproc_else_token1] = ACTIONS(6019),
    [aux_sym_preproc_elif_token1] = ACTIONS(6017),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6019),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6019),
    [anon_sym_LPAREN2] = ACTIONS(5895),
    [anon_sym_DASH] = ACTIONS(6017),
    [anon_sym_PLUS] = ACTIONS(6017),
    [anon_sym_STAR] = ACTIONS(6017),
    [anon_sym_SLASH] = ACTIONS(6017),
    [anon_sym_PERCENT] = ACTIONS(6017),
    [anon_sym_PIPE_PIPE] = ACTIONS(6019),
    [anon_sym_AMP_AMP] = ACTIONS(6019),
    [anon_sym_PIPE] = ACTIONS(6017),
    [anon_sym_CARET] = ACTIONS(6017),
    [anon_sym_AMP] = ACTIONS(6017),
    [anon_sym_EQ_EQ] = ACTIONS(6019),
    [anon_sym_BANG_EQ] = ACTIONS(6019),
    [anon_sym_GT] = ACTIONS(6017),
    [anon_sym_GT_EQ] = ACTIONS(6019),
    [anon_sym_LT_EQ] = ACTIONS(6017),
    [anon_sym_LT] = ACTIONS(6017),
    [anon_sym_LT_LT] = ACTIONS(6017),
    [anon_sym_GT_GT] = ACTIONS(6017),
    [anon_sym_SEMI] = ACTIONS(6019),
    [anon_sym___attribute__] = ACTIONS(6017),
    [anon_sym___attribute] = ACTIONS(6017),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5897),
    [anon_sym_RBRACE] = ACTIONS(6019),
    [anon_sym_LBRACK] = ACTIONS(5899),
    [anon_sym_RBRACK] = ACTIONS(6019),
    [anon_sym_EQ] = ACTIONS(6017),
    [anon_sym_COLON] = ACTIONS(6019),
    [anon_sym_QMARK] = ACTIONS(6019),
    [anon_sym_STAR_EQ] = ACTIONS(6019),
    [anon_sym_SLASH_EQ] = ACTIONS(6019),
    [anon_sym_PERCENT_EQ] = ACTIONS(6019),
    [anon_sym_PLUS_EQ] = ACTIONS(6019),
    [anon_sym_DASH_EQ] = ACTIONS(6019),
    [anon_sym_LT_LT_EQ] = ACTIONS(6019),
    [anon_sym_GT_GT_EQ] = ACTIONS(6019),
    [anon_sym_AMP_EQ] = ACTIONS(6019),
    [anon_sym_CARET_EQ] = ACTIONS(6019),
    [anon_sym_PIPE_EQ] = ACTIONS(6019),
    [anon_sym_and_eq] = ACTIONS(6017),
    [anon_sym_or_eq] = ACTIONS(6017),
    [anon_sym_xor_eq] = ACTIONS(6017),
    [anon_sym_LT_EQ_GT] = ACTIONS(6019),
    [anon_sym_or] = ACTIONS(6017),
    [anon_sym_and] = ACTIONS(6017),
    [anon_sym_bitor] = ACTIONS(6017),
    [anon_sym_xor] = ACTIONS(6017),
    [anon_sym_bitand] = ACTIONS(6017),
    [anon_sym_not_eq] = ACTIONS(6017),
    [anon_sym_DASH_DASH] = ACTIONS(6019),
    [anon_sym_PLUS_PLUS] = ACTIONS(6019),
    [anon_sym_DOT] = ACTIONS(6017),
    [anon_sym_DOT_STAR] = ACTIONS(6019),
    [anon_sym_DASH_GT] = ACTIONS(6019),
    [sym_comment] = ACTIONS(3),
  },
  [2160] = {
    [sym_identifier] = ACTIONS(5431),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5433),
    [anon_sym_COMMA] = ACTIONS(5433),
    [anon_sym_RPAREN] = ACTIONS(5433),
    [aux_sym_preproc_if_token2] = ACTIONS(5433),
    [aux_sym_preproc_else_token1] = ACTIONS(5433),
    [aux_sym_preproc_elif_token1] = ACTIONS(5431),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5433),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5433),
    [anon_sym_LPAREN2] = ACTIONS(5433),
    [anon_sym_DASH] = ACTIONS(5431),
    [anon_sym_PLUS] = ACTIONS(5431),
    [anon_sym_STAR] = ACTIONS(5431),
    [anon_sym_SLASH] = ACTIONS(5431),
    [anon_sym_PERCENT] = ACTIONS(5431),
    [anon_sym_PIPE_PIPE] = ACTIONS(5433),
    [anon_sym_AMP_AMP] = ACTIONS(5433),
    [anon_sym_PIPE] = ACTIONS(5431),
    [anon_sym_CARET] = ACTIONS(5431),
    [anon_sym_AMP] = ACTIONS(5431),
    [anon_sym_EQ_EQ] = ACTIONS(5433),
    [anon_sym_BANG_EQ] = ACTIONS(5433),
    [anon_sym_GT] = ACTIONS(5431),
    [anon_sym_GT_EQ] = ACTIONS(5433),
    [anon_sym_LT_EQ] = ACTIONS(5431),
    [anon_sym_LT] = ACTIONS(5431),
    [anon_sym_LT_LT] = ACTIONS(5431),
    [anon_sym_GT_GT] = ACTIONS(5431),
    [anon_sym_SEMI] = ACTIONS(5433),
    [anon_sym___attribute__] = ACTIONS(5431),
    [anon_sym___attribute] = ACTIONS(5431),
    [anon_sym_COLON_COLON] = ACTIONS(5365),
    [anon_sym_LBRACE] = ACTIONS(5433),
    [anon_sym_RBRACE] = ACTIONS(5433),
    [anon_sym_LBRACK] = ACTIONS(5433),
    [anon_sym_RBRACK] = ACTIONS(5433),
    [anon_sym_EQ] = ACTIONS(5431),
    [anon_sym_COLON] = ACTIONS(5431),
    [anon_sym_QMARK] = ACTIONS(5433),
    [anon_sym_STAR_EQ] = ACTIONS(5433),
    [anon_sym_SLASH_EQ] = ACTIONS(5433),
    [anon_sym_PERCENT_EQ] = ACTIONS(5433),
    [anon_sym_PLUS_EQ] = ACTIONS(5433),
    [anon_sym_DASH_EQ] = ACTIONS(5433),
    [anon_sym_LT_LT_EQ] = ACTIONS(5433),
    [anon_sym_GT_GT_EQ] = ACTIONS(5433),
    [anon_sym_AMP_EQ] = ACTIONS(5433),
    [anon_sym_CARET_EQ] = ACTIONS(5433),
    [anon_sym_PIPE_EQ] = ACTIONS(5433),
    [anon_sym_and_eq] = ACTIONS(5431),
    [anon_sym_or_eq] = ACTIONS(5431),
    [anon_sym_xor_eq] = ACTIONS(5431),
    [anon_sym_LT_EQ_GT] = ACTIONS(5433),
    [anon_sym_or] = ACTIONS(5431),
    [anon_sym_and] = ACTIONS(5431),
    [anon_sym_bitor] = ACTIONS(5431),
    [anon_sym_xor] = ACTIONS(5431),
    [anon_sym_bitand] = ACTIONS(5431),
    [anon_sym_not_eq] = ACTIONS(5431),
    [anon_sym_DASH_DASH] = ACTIONS(5433),
    [anon_sym_PLUS_PLUS] = ACTIONS(5433),
    [anon_sym_DOT] = ACTIONS(5431),
    [anon_sym_DOT_STAR] = ACTIONS(5433),
    [anon_sym_DASH_GT] = ACTIONS(5433),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5431),
    [anon_sym_decltype] = ACTIONS(5431),
  },
  [2161] = {
    [sym_identifier] = ACTIONS(5361),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5363),
    [anon_sym_COMMA] = ACTIONS(5363),
    [anon_sym_RPAREN] = ACTIONS(5363),
    [anon_sym_LPAREN2] = ACTIONS(5363),
    [anon_sym_TILDE] = ACTIONS(5363),
    [anon_sym_STAR] = ACTIONS(5363),
    [anon_sym_PIPE_PIPE] = ACTIONS(5363),
    [anon_sym_AMP_AMP] = ACTIONS(5363),
    [anon_sym_AMP] = ACTIONS(5361),
    [anon_sym_SEMI] = ACTIONS(5363),
    [anon_sym___extension__] = ACTIONS(5361),
    [anon_sym_virtual] = ACTIONS(5361),
    [anon_sym_extern] = ACTIONS(5361),
    [anon_sym___attribute__] = ACTIONS(5361),
    [anon_sym___attribute] = ACTIONS(5361),
    [anon_sym_COLON_COLON] = ACTIONS(5363),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5363),
    [anon_sym___declspec] = ACTIONS(5361),
    [anon_sym___based] = ACTIONS(5361),
    [anon_sym___cdecl] = ACTIONS(5361),
    [anon_sym___clrcall] = ACTIONS(5361),
    [anon_sym___stdcall] = ACTIONS(5361),
    [anon_sym___fastcall] = ACTIONS(5361),
    [anon_sym___thiscall] = ACTIONS(5361),
    [anon_sym___vectorcall] = ACTIONS(5361),
    [anon_sym_LBRACE] = ACTIONS(5363),
    [anon_sym_LBRACK] = ACTIONS(5361),
    [anon_sym_static] = ACTIONS(5361),
    [anon_sym_EQ] = ACTIONS(5363),
    [anon_sym_register] = ACTIONS(5361),
    [anon_sym_inline] = ACTIONS(5361),
    [anon_sym___inline] = ACTIONS(5361),
    [anon_sym___inline__] = ACTIONS(5361),
    [anon_sym___forceinline] = ACTIONS(5361),
    [anon_sym_thread_local] = ACTIONS(5361),
    [anon_sym___thread] = ACTIONS(5361),
    [anon_sym_const] = ACTIONS(5361),
    [anon_sym_constexpr] = ACTIONS(5361),
    [anon_sym_volatile] = ACTIONS(5361),
    [anon_sym_restrict] = ACTIONS(5361),
    [anon_sym___restrict__] = ACTIONS(5361),
    [anon_sym__Atomic] = ACTIONS(5361),
    [anon_sym__Noreturn] = ACTIONS(5361),
    [anon_sym_noreturn] = ACTIONS(5361),
    [anon_sym__Nonnull] = ACTIONS(5361),
    [anon_sym_mutable] = ACTIONS(5361),
    [anon_sym_constinit] = ACTIONS(5361),
    [anon_sym_consteval] = ACTIONS(5361),
    [anon_sym_alignas] = ACTIONS(5361),
    [anon_sym__Alignas] = ACTIONS(5361),
    [anon_sym_COLON] = ACTIONS(5361),
    [anon_sym_or] = ACTIONS(5361),
    [anon_sym_and] = ACTIONS(5361),
    [anon_sym_asm] = ACTIONS(5361),
    [anon_sym___asm__] = ACTIONS(5361),
    [anon_sym___asm] = ACTIONS(5361),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5361),
    [anon_sym_decltype] = ACTIONS(5361),
    [anon_sym_final] = ACTIONS(5361),
    [anon_sym_override] = ACTIONS(5361),
    [anon_sym_template] = ACTIONS(5361),
    [anon_sym_GT2] = ACTIONS(5363),
    [anon_sym_operator] = ACTIONS(5361),
    [anon_sym_try] = ACTIONS(5361),
    [anon_sym_requires] = ACTIONS(5361),
  },
  [2162] = {
    [sym_identifier] = ACTIONS(5361),
    [anon_sym_LPAREN2] = ACTIONS(5363),
    [anon_sym_TILDE] = ACTIONS(5363),
    [anon_sym_STAR] = ACTIONS(5363),
    [anon_sym_PIPE_PIPE] = ACTIONS(5363),
    [anon_sym_AMP_AMP] = ACTIONS(5363),
    [anon_sym_AMP] = ACTIONS(5361),
    [anon_sym___extension__] = ACTIONS(5361),
    [anon_sym_virtual] = ACTIONS(5361),
    [anon_sym_extern] = ACTIONS(5361),
    [anon_sym___attribute__] = ACTIONS(5361),
    [anon_sym___attribute] = ACTIONS(5361),
    [anon_sym_COLON_COLON] = ACTIONS(5363),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5363),
    [anon_sym___declspec] = ACTIONS(5361),
    [anon_sym___based] = ACTIONS(5361),
    [anon_sym___cdecl] = ACTIONS(5361),
    [anon_sym___clrcall] = ACTIONS(5361),
    [anon_sym___stdcall] = ACTIONS(5361),
    [anon_sym___fastcall] = ACTIONS(5361),
    [anon_sym___thiscall] = ACTIONS(5361),
    [anon_sym___vectorcall] = ACTIONS(5361),
    [anon_sym_signed] = ACTIONS(5361),
    [anon_sym_unsigned] = ACTIONS(5361),
    [anon_sym_long] = ACTIONS(5361),
    [anon_sym_short] = ACTIONS(5361),
    [anon_sym_LBRACK] = ACTIONS(5361),
    [anon_sym_static] = ACTIONS(5361),
    [anon_sym_register] = ACTIONS(5361),
    [anon_sym_inline] = ACTIONS(5361),
    [anon_sym___inline] = ACTIONS(5361),
    [anon_sym___inline__] = ACTIONS(5361),
    [anon_sym___forceinline] = ACTIONS(5361),
    [anon_sym_thread_local] = ACTIONS(5361),
    [anon_sym___thread] = ACTIONS(5361),
    [anon_sym_const] = ACTIONS(5361),
    [anon_sym_constexpr] = ACTIONS(5361),
    [anon_sym_volatile] = ACTIONS(5361),
    [anon_sym_restrict] = ACTIONS(5361),
    [anon_sym___restrict__] = ACTIONS(5361),
    [anon_sym__Atomic] = ACTIONS(5361),
    [anon_sym__Noreturn] = ACTIONS(5361),
    [anon_sym_noreturn] = ACTIONS(5361),
    [anon_sym__Nonnull] = ACTIONS(5361),
    [anon_sym_mutable] = ACTIONS(5361),
    [anon_sym_constinit] = ACTIONS(5361),
    [anon_sym_consteval] = ACTIONS(5361),
    [anon_sym_alignas] = ACTIONS(5361),
    [anon_sym__Alignas] = ACTIONS(5361),
    [sym_primitive_type] = ACTIONS(5361),
    [anon_sym_enum] = ACTIONS(5361),
    [anon_sym_class] = ACTIONS(5361),
    [anon_sym_struct] = ACTIONS(5361),
    [anon_sym_union] = ACTIONS(5361),
    [anon_sym_or] = ACTIONS(5361),
    [anon_sym_and] = ACTIONS(5361),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5361),
    [anon_sym_decltype] = ACTIONS(5361),
    [anon_sym_explicit] = ACTIONS(5361),
    [anon_sym_typename] = ACTIONS(5361),
    [anon_sym_template] = ACTIONS(5361),
    [anon_sym_operator] = ACTIONS(5361),
    [anon_sym_friend] = ACTIONS(5361),
    [anon_sym_using] = ACTIONS(5361),
    [anon_sym_concept] = ACTIONS(5361),
  },
  [2163] = {
    [sym_identifier] = ACTIONS(6021),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6023),
    [anon_sym_COMMA] = ACTIONS(6023),
    [anon_sym_RPAREN] = ACTIONS(6023),
    [aux_sym_preproc_if_token2] = ACTIONS(6023),
    [aux_sym_preproc_else_token1] = ACTIONS(6023),
    [aux_sym_preproc_elif_token1] = ACTIONS(6021),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6023),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6023),
    [anon_sym_LPAREN2] = ACTIONS(6023),
    [anon_sym_DASH] = ACTIONS(6021),
    [anon_sym_PLUS] = ACTIONS(6021),
    [anon_sym_STAR] = ACTIONS(6021),
    [anon_sym_SLASH] = ACTIONS(6021),
    [anon_sym_PERCENT] = ACTIONS(6021),
    [anon_sym_PIPE_PIPE] = ACTIONS(6023),
    [anon_sym_AMP_AMP] = ACTIONS(6023),
    [anon_sym_PIPE] = ACTIONS(6021),
    [anon_sym_CARET] = ACTIONS(6021),
    [anon_sym_AMP] = ACTIONS(6021),
    [anon_sym_EQ_EQ] = ACTIONS(6023),
    [anon_sym_BANG_EQ] = ACTIONS(6023),
    [anon_sym_GT] = ACTIONS(6021),
    [anon_sym_GT_EQ] = ACTIONS(6023),
    [anon_sym_LT_EQ] = ACTIONS(6021),
    [anon_sym_LT] = ACTIONS(6021),
    [anon_sym_LT_LT] = ACTIONS(6021),
    [anon_sym_GT_GT] = ACTIONS(6021),
    [anon_sym_SEMI] = ACTIONS(6023),
    [anon_sym___attribute__] = ACTIONS(6021),
    [anon_sym___attribute] = ACTIONS(6021),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6023),
    [anon_sym_LBRACE] = ACTIONS(6023),
    [anon_sym_RBRACE] = ACTIONS(6023),
    [anon_sym_LBRACK] = ACTIONS(6021),
    [anon_sym_RBRACK] = ACTIONS(6023),
    [anon_sym_EQ] = ACTIONS(6021),
    [anon_sym_COLON] = ACTIONS(6023),
    [anon_sym_QMARK] = ACTIONS(6023),
    [anon_sym_STAR_EQ] = ACTIONS(6023),
    [anon_sym_SLASH_EQ] = ACTIONS(6023),
    [anon_sym_PERCENT_EQ] = ACTIONS(6023),
    [anon_sym_PLUS_EQ] = ACTIONS(6023),
    [anon_sym_DASH_EQ] = ACTIONS(6023),
    [anon_sym_LT_LT_EQ] = ACTIONS(6023),
    [anon_sym_GT_GT_EQ] = ACTIONS(6023),
    [anon_sym_AMP_EQ] = ACTIONS(6023),
    [anon_sym_CARET_EQ] = ACTIONS(6023),
    [anon_sym_PIPE_EQ] = ACTIONS(6023),
    [anon_sym_and_eq] = ACTIONS(6021),
    [anon_sym_or_eq] = ACTIONS(6021),
    [anon_sym_xor_eq] = ACTIONS(6021),
    [anon_sym_LT_EQ_GT] = ACTIONS(6023),
    [anon_sym_or] = ACTIONS(6021),
    [anon_sym_and] = ACTIONS(6021),
    [anon_sym_bitor] = ACTIONS(6021),
    [anon_sym_xor] = ACTIONS(6021),
    [anon_sym_bitand] = ACTIONS(6021),
    [anon_sym_not_eq] = ACTIONS(6021),
    [anon_sym_DASH_DASH] = ACTIONS(6023),
    [anon_sym_PLUS_PLUS] = ACTIONS(6023),
    [anon_sym_DOT] = ACTIONS(6021),
    [anon_sym_DOT_STAR] = ACTIONS(6023),
    [anon_sym_DASH_GT] = ACTIONS(6023),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6021),
  },
  [2164] = {
    [sym_template_argument_list] = STATE(1874),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(4033),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4041),
    [anon_sym_COMMA] = ACTIONS(4041),
    [aux_sym_preproc_if_token2] = ACTIONS(4041),
    [aux_sym_preproc_else_token1] = ACTIONS(4041),
    [aux_sym_preproc_elif_token1] = ACTIONS(4033),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4041),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4041),
    [anon_sym_LPAREN2] = ACTIONS(4041),
    [anon_sym_DASH] = ACTIONS(4033),
    [anon_sym_PLUS] = ACTIONS(4033),
    [anon_sym_STAR] = ACTIONS(4033),
    [anon_sym_SLASH] = ACTIONS(4033),
    [anon_sym_PERCENT] = ACTIONS(4033),
    [anon_sym_PIPE_PIPE] = ACTIONS(4041),
    [anon_sym_AMP_AMP] = ACTIONS(4041),
    [anon_sym_PIPE] = ACTIONS(4033),
    [anon_sym_CARET] = ACTIONS(4033),
    [anon_sym_AMP] = ACTIONS(4033),
    [anon_sym_EQ_EQ] = ACTIONS(4041),
    [anon_sym_BANG_EQ] = ACTIONS(4041),
    [anon_sym_GT] = ACTIONS(4033),
    [anon_sym_GT_EQ] = ACTIONS(4041),
    [anon_sym_LT_EQ] = ACTIONS(4033),
    [anon_sym_LT] = ACTIONS(5722),
    [anon_sym_LT_LT] = ACTIONS(4033),
    [anon_sym_GT_GT] = ACTIONS(4033),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACE] = ACTIONS(4041),
    [anon_sym_signed] = ACTIONS(5846),
    [anon_sym_unsigned] = ACTIONS(5846),
    [anon_sym_long] = ACTIONS(5846),
    [anon_sym_short] = ACTIONS(5846),
    [anon_sym_LBRACK] = ACTIONS(4041),
    [anon_sym_EQ] = ACTIONS(4033),
    [anon_sym_QMARK] = ACTIONS(4041),
    [anon_sym_STAR_EQ] = ACTIONS(4041),
    [anon_sym_SLASH_EQ] = ACTIONS(4041),
    [anon_sym_PERCENT_EQ] = ACTIONS(4041),
    [anon_sym_PLUS_EQ] = ACTIONS(4041),
    [anon_sym_DASH_EQ] = ACTIONS(4041),
    [anon_sym_LT_LT_EQ] = ACTIONS(4041),
    [anon_sym_GT_GT_EQ] = ACTIONS(4041),
    [anon_sym_AMP_EQ] = ACTIONS(4041),
    [anon_sym_CARET_EQ] = ACTIONS(4041),
    [anon_sym_PIPE_EQ] = ACTIONS(4041),
    [anon_sym_and_eq] = ACTIONS(4033),
    [anon_sym_or_eq] = ACTIONS(4033),
    [anon_sym_xor_eq] = ACTIONS(4033),
    [anon_sym_LT_EQ_GT] = ACTIONS(4041),
    [anon_sym_or] = ACTIONS(4033),
    [anon_sym_and] = ACTIONS(4033),
    [anon_sym_bitor] = ACTIONS(4033),
    [anon_sym_xor] = ACTIONS(4033),
    [anon_sym_bitand] = ACTIONS(4033),
    [anon_sym_not_eq] = ACTIONS(4033),
    [anon_sym_DASH_DASH] = ACTIONS(4041),
    [anon_sym_PLUS_PLUS] = ACTIONS(4041),
    [anon_sym_DOT] = ACTIONS(4033),
    [anon_sym_DOT_STAR] = ACTIONS(4041),
    [anon_sym_DASH_GT] = ACTIONS(4041),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4033),
    [anon_sym_decltype] = ACTIONS(4033),
  },
  [2165] = {
    [sym_string_literal] = STATE(3454),
    [sym_template_argument_list] = STATE(4370),
    [sym_raw_string_literal] = STATE(3454),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4035),
    [anon_sym_COMMA] = ACTIONS(4035),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_DASH] = ACTIONS(4043),
    [anon_sym_PLUS] = ACTIONS(4043),
    [anon_sym_STAR] = ACTIONS(4043),
    [anon_sym_SLASH] = ACTIONS(4043),
    [anon_sym_PERCENT] = ACTIONS(4043),
    [anon_sym_PIPE_PIPE] = ACTIONS(4035),
    [anon_sym_AMP_AMP] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4043),
    [anon_sym_CARET] = ACTIONS(4043),
    [anon_sym_AMP] = ACTIONS(4043),
    [anon_sym_EQ_EQ] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4043),
    [anon_sym_GT_EQ] = ACTIONS(4043),
    [anon_sym_LT_EQ] = ACTIONS(4043),
    [anon_sym_LT] = ACTIONS(4916),
    [anon_sym_LT_LT] = ACTIONS(4043),
    [anon_sym_GT_GT] = ACTIONS(4043),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACE] = ACTIONS(4059),
    [anon_sym_LBRACK] = ACTIONS(4035),
    [anon_sym_EQ] = ACTIONS(4921),
    [anon_sym_QMARK] = ACTIONS(4035),
    [anon_sym_STAR_EQ] = ACTIONS(4923),
    [anon_sym_SLASH_EQ] = ACTIONS(4923),
    [anon_sym_PERCENT_EQ] = ACTIONS(4923),
    [anon_sym_PLUS_EQ] = ACTIONS(4923),
    [anon_sym_DASH_EQ] = ACTIONS(4923),
    [anon_sym_LT_LT_EQ] = ACTIONS(4923),
    [anon_sym_GT_GT_EQ] = ACTIONS(4921),
    [anon_sym_AMP_EQ] = ACTIONS(4923),
    [anon_sym_CARET_EQ] = ACTIONS(4923),
    [anon_sym_PIPE_EQ] = ACTIONS(4923),
    [anon_sym_and_eq] = ACTIONS(4923),
    [anon_sym_or_eq] = ACTIONS(4923),
    [anon_sym_xor_eq] = ACTIONS(4923),
    [anon_sym_LT_EQ_GT] = ACTIONS(4035),
    [anon_sym_or] = ACTIONS(4043),
    [anon_sym_and] = ACTIONS(4043),
    [anon_sym_bitor] = ACTIONS(4035),
    [anon_sym_xor] = ACTIONS(4043),
    [anon_sym_bitand] = ACTIONS(4035),
    [anon_sym_not_eq] = ACTIONS(4035),
    [anon_sym_DASH_DASH] = ACTIONS(4035),
    [anon_sym_PLUS_PLUS] = ACTIONS(4035),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_DOT_STAR] = ACTIONS(4035),
    [anon_sym_DASH_GT] = ACTIONS(4035),
    [anon_sym_L_DQUOTE] = ACTIONS(4925),
    [anon_sym_u_DQUOTE] = ACTIONS(4925),
    [anon_sym_U_DQUOTE] = ACTIONS(4925),
    [anon_sym_u8_DQUOTE] = ACTIONS(4925),
    [anon_sym_DQUOTE] = ACTIONS(4925),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(4035),
    [anon_sym_R_DQUOTE] = ACTIONS(4927),
    [anon_sym_LR_DQUOTE] = ACTIONS(4927),
    [anon_sym_uR_DQUOTE] = ACTIONS(4927),
    [anon_sym_UR_DQUOTE] = ACTIONS(4927),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4927),
  },
  [2166] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2249),
    [sym_identifier] = ACTIONS(5768),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5766),
    [anon_sym_COMMA] = ACTIONS(5766),
    [aux_sym_preproc_if_token2] = ACTIONS(5766),
    [aux_sym_preproc_else_token1] = ACTIONS(5766),
    [aux_sym_preproc_elif_token1] = ACTIONS(5768),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5766),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5766),
    [anon_sym_LPAREN2] = ACTIONS(5766),
    [anon_sym_DASH] = ACTIONS(5768),
    [anon_sym_PLUS] = ACTIONS(5768),
    [anon_sym_STAR] = ACTIONS(5768),
    [anon_sym_SLASH] = ACTIONS(5768),
    [anon_sym_PERCENT] = ACTIONS(5768),
    [anon_sym_PIPE_PIPE] = ACTIONS(5766),
    [anon_sym_AMP_AMP] = ACTIONS(5766),
    [anon_sym_PIPE] = ACTIONS(5768),
    [anon_sym_CARET] = ACTIONS(5768),
    [anon_sym_AMP] = ACTIONS(5768),
    [anon_sym_EQ_EQ] = ACTIONS(5766),
    [anon_sym_BANG_EQ] = ACTIONS(5766),
    [anon_sym_GT] = ACTIONS(5768),
    [anon_sym_GT_EQ] = ACTIONS(5766),
    [anon_sym_LT_EQ] = ACTIONS(5768),
    [anon_sym_LT] = ACTIONS(5768),
    [anon_sym_LT_LT] = ACTIONS(5768),
    [anon_sym_GT_GT] = ACTIONS(5768),
    [anon_sym___attribute__] = ACTIONS(5768),
    [anon_sym___attribute] = ACTIONS(5768),
    [anon_sym_LBRACE] = ACTIONS(5766),
    [anon_sym_signed] = ACTIONS(6025),
    [anon_sym_unsigned] = ACTIONS(6025),
    [anon_sym_long] = ACTIONS(6025),
    [anon_sym_short] = ACTIONS(6025),
    [anon_sym_LBRACK] = ACTIONS(5766),
    [anon_sym_EQ] = ACTIONS(5768),
    [anon_sym_QMARK] = ACTIONS(5766),
    [anon_sym_STAR_EQ] = ACTIONS(5766),
    [anon_sym_SLASH_EQ] = ACTIONS(5766),
    [anon_sym_PERCENT_EQ] = ACTIONS(5766),
    [anon_sym_PLUS_EQ] = ACTIONS(5766),
    [anon_sym_DASH_EQ] = ACTIONS(5766),
    [anon_sym_LT_LT_EQ] = ACTIONS(5766),
    [anon_sym_GT_GT_EQ] = ACTIONS(5766),
    [anon_sym_AMP_EQ] = ACTIONS(5766),
    [anon_sym_CARET_EQ] = ACTIONS(5766),
    [anon_sym_PIPE_EQ] = ACTIONS(5766),
    [anon_sym_and_eq] = ACTIONS(5768),
    [anon_sym_or_eq] = ACTIONS(5768),
    [anon_sym_xor_eq] = ACTIONS(5768),
    [anon_sym_LT_EQ_GT] = ACTIONS(5766),
    [anon_sym_or] = ACTIONS(5768),
    [anon_sym_and] = ACTIONS(5768),
    [anon_sym_bitor] = ACTIONS(5768),
    [anon_sym_xor] = ACTIONS(5768),
    [anon_sym_bitand] = ACTIONS(5768),
    [anon_sym_not_eq] = ACTIONS(5768),
    [anon_sym_DASH_DASH] = ACTIONS(5766),
    [anon_sym_PLUS_PLUS] = ACTIONS(5766),
    [anon_sym_DOT] = ACTIONS(5768),
    [anon_sym_DOT_STAR] = ACTIONS(5766),
    [anon_sym_DASH_GT] = ACTIONS(5766),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5768),
    [anon_sym_decltype] = ACTIONS(5768),
  },
  [2167] = {
    [sym_identifier] = ACTIONS(5361),
    [anon_sym_LPAREN2] = ACTIONS(5363),
    [anon_sym_TILDE] = ACTIONS(5363),
    [anon_sym_STAR] = ACTIONS(5363),
    [anon_sym_PIPE_PIPE] = ACTIONS(5363),
    [anon_sym_AMP_AMP] = ACTIONS(5363),
    [anon_sym_AMP] = ACTIONS(5361),
    [anon_sym___extension__] = ACTIONS(5361),
    [anon_sym_virtual] = ACTIONS(5361),
    [anon_sym_extern] = ACTIONS(5361),
    [anon_sym___attribute__] = ACTIONS(5361),
    [anon_sym___attribute] = ACTIONS(5361),
    [anon_sym_COLON_COLON] = ACTIONS(5365),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5363),
    [anon_sym___declspec] = ACTIONS(5361),
    [anon_sym___based] = ACTIONS(5361),
    [anon_sym___cdecl] = ACTIONS(5361),
    [anon_sym___clrcall] = ACTIONS(5361),
    [anon_sym___stdcall] = ACTIONS(5361),
    [anon_sym___fastcall] = ACTIONS(5361),
    [anon_sym___thiscall] = ACTIONS(5361),
    [anon_sym___vectorcall] = ACTIONS(5361),
    [anon_sym_signed] = ACTIONS(5361),
    [anon_sym_unsigned] = ACTIONS(5361),
    [anon_sym_long] = ACTIONS(5361),
    [anon_sym_short] = ACTIONS(5361),
    [anon_sym_LBRACK] = ACTIONS(5361),
    [anon_sym_static] = ACTIONS(5361),
    [anon_sym_register] = ACTIONS(5361),
    [anon_sym_inline] = ACTIONS(5361),
    [anon_sym___inline] = ACTIONS(5361),
    [anon_sym___inline__] = ACTIONS(5361),
    [anon_sym___forceinline] = ACTIONS(5361),
    [anon_sym_thread_local] = ACTIONS(5361),
    [anon_sym___thread] = ACTIONS(5361),
    [anon_sym_const] = ACTIONS(5361),
    [anon_sym_constexpr] = ACTIONS(5361),
    [anon_sym_volatile] = ACTIONS(5361),
    [anon_sym_restrict] = ACTIONS(5361),
    [anon_sym___restrict__] = ACTIONS(5361),
    [anon_sym__Atomic] = ACTIONS(5361),
    [anon_sym__Noreturn] = ACTIONS(5361),
    [anon_sym_noreturn] = ACTIONS(5361),
    [anon_sym__Nonnull] = ACTIONS(5361),
    [anon_sym_mutable] = ACTIONS(5361),
    [anon_sym_constinit] = ACTIONS(5361),
    [anon_sym_consteval] = ACTIONS(5361),
    [anon_sym_alignas] = ACTIONS(5361),
    [anon_sym__Alignas] = ACTIONS(5361),
    [sym_primitive_type] = ACTIONS(5361),
    [anon_sym_enum] = ACTIONS(5361),
    [anon_sym_class] = ACTIONS(5361),
    [anon_sym_struct] = ACTIONS(5361),
    [anon_sym_union] = ACTIONS(5361),
    [anon_sym_or] = ACTIONS(5361),
    [anon_sym_and] = ACTIONS(5361),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5361),
    [anon_sym_decltype] = ACTIONS(5361),
    [anon_sym_explicit] = ACTIONS(5361),
    [anon_sym_typename] = ACTIONS(5361),
    [anon_sym_template] = ACTIONS(5361),
    [anon_sym_operator] = ACTIONS(5361),
    [anon_sym_friend] = ACTIONS(5361),
    [anon_sym_using] = ACTIONS(5361),
    [anon_sym_concept] = ACTIONS(5361),
  },
  [2168] = {
    [sym_identifier] = ACTIONS(5361),
    [anon_sym_LPAREN2] = ACTIONS(5363),
    [anon_sym_TILDE] = ACTIONS(5363),
    [anon_sym_STAR] = ACTIONS(5363),
    [anon_sym_PIPE_PIPE] = ACTIONS(5363),
    [anon_sym_AMP_AMP] = ACTIONS(5363),
    [anon_sym_AMP] = ACTIONS(5361),
    [anon_sym___extension__] = ACTIONS(5361),
    [anon_sym_virtual] = ACTIONS(5361),
    [anon_sym_extern] = ACTIONS(5361),
    [anon_sym___attribute__] = ACTIONS(5361),
    [anon_sym___attribute] = ACTIONS(5361),
    [anon_sym_COLON_COLON] = ACTIONS(5365),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5363),
    [anon_sym___declspec] = ACTIONS(5361),
    [anon_sym___based] = ACTIONS(5361),
    [anon_sym___cdecl] = ACTIONS(5361),
    [anon_sym___clrcall] = ACTIONS(5361),
    [anon_sym___stdcall] = ACTIONS(5361),
    [anon_sym___fastcall] = ACTIONS(5361),
    [anon_sym___thiscall] = ACTIONS(5361),
    [anon_sym___vectorcall] = ACTIONS(5361),
    [anon_sym_signed] = ACTIONS(5361),
    [anon_sym_unsigned] = ACTIONS(5361),
    [anon_sym_long] = ACTIONS(5361),
    [anon_sym_short] = ACTIONS(5361),
    [anon_sym_LBRACK] = ACTIONS(5361),
    [anon_sym_static] = ACTIONS(5361),
    [anon_sym_register] = ACTIONS(5361),
    [anon_sym_inline] = ACTIONS(5361),
    [anon_sym___inline] = ACTIONS(5361),
    [anon_sym___inline__] = ACTIONS(5361),
    [anon_sym___forceinline] = ACTIONS(5361),
    [anon_sym_thread_local] = ACTIONS(5361),
    [anon_sym___thread] = ACTIONS(5361),
    [anon_sym_const] = ACTIONS(5361),
    [anon_sym_constexpr] = ACTIONS(5361),
    [anon_sym_volatile] = ACTIONS(5361),
    [anon_sym_restrict] = ACTIONS(5361),
    [anon_sym___restrict__] = ACTIONS(5361),
    [anon_sym__Atomic] = ACTIONS(5361),
    [anon_sym__Noreturn] = ACTIONS(5361),
    [anon_sym_noreturn] = ACTIONS(5361),
    [anon_sym__Nonnull] = ACTIONS(5361),
    [anon_sym_mutable] = ACTIONS(5361),
    [anon_sym_constinit] = ACTIONS(5361),
    [anon_sym_consteval] = ACTIONS(5361),
    [anon_sym_alignas] = ACTIONS(5361),
    [anon_sym__Alignas] = ACTIONS(5361),
    [sym_primitive_type] = ACTIONS(5361),
    [anon_sym_enum] = ACTIONS(5361),
    [anon_sym_class] = ACTIONS(5361),
    [anon_sym_struct] = ACTIONS(5361),
    [anon_sym_union] = ACTIONS(5361),
    [anon_sym_or] = ACTIONS(5361),
    [anon_sym_and] = ACTIONS(5361),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5361),
    [anon_sym_decltype] = ACTIONS(5361),
    [anon_sym_explicit] = ACTIONS(5361),
    [anon_sym_typename] = ACTIONS(5361),
    [anon_sym_template] = ACTIONS(5361),
    [anon_sym_operator] = ACTIONS(5361),
    [anon_sym_friend] = ACTIONS(5361),
    [anon_sym_using] = ACTIONS(5361),
    [anon_sym_concept] = ACTIONS(5361),
  },
  [2169] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2249),
    [sym_identifier] = ACTIONS(5791),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5789),
    [anon_sym_COMMA] = ACTIONS(5789),
    [aux_sym_preproc_if_token2] = ACTIONS(5789),
    [aux_sym_preproc_else_token1] = ACTIONS(5789),
    [aux_sym_preproc_elif_token1] = ACTIONS(5791),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5789),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5789),
    [anon_sym_LPAREN2] = ACTIONS(5789),
    [anon_sym_DASH] = ACTIONS(5791),
    [anon_sym_PLUS] = ACTIONS(5791),
    [anon_sym_STAR] = ACTIONS(5791),
    [anon_sym_SLASH] = ACTIONS(5791),
    [anon_sym_PERCENT] = ACTIONS(5791),
    [anon_sym_PIPE_PIPE] = ACTIONS(5789),
    [anon_sym_AMP_AMP] = ACTIONS(5789),
    [anon_sym_PIPE] = ACTIONS(5791),
    [anon_sym_CARET] = ACTIONS(5791),
    [anon_sym_AMP] = ACTIONS(5791),
    [anon_sym_EQ_EQ] = ACTIONS(5789),
    [anon_sym_BANG_EQ] = ACTIONS(5789),
    [anon_sym_GT] = ACTIONS(5791),
    [anon_sym_GT_EQ] = ACTIONS(5789),
    [anon_sym_LT_EQ] = ACTIONS(5791),
    [anon_sym_LT] = ACTIONS(5791),
    [anon_sym_LT_LT] = ACTIONS(5791),
    [anon_sym_GT_GT] = ACTIONS(5791),
    [anon_sym___attribute__] = ACTIONS(5791),
    [anon_sym___attribute] = ACTIONS(5791),
    [anon_sym_LBRACE] = ACTIONS(5789),
    [anon_sym_signed] = ACTIONS(6025),
    [anon_sym_unsigned] = ACTIONS(6025),
    [anon_sym_long] = ACTIONS(6025),
    [anon_sym_short] = ACTIONS(6025),
    [anon_sym_LBRACK] = ACTIONS(5789),
    [anon_sym_EQ] = ACTIONS(5791),
    [anon_sym_QMARK] = ACTIONS(5789),
    [anon_sym_STAR_EQ] = ACTIONS(5789),
    [anon_sym_SLASH_EQ] = ACTIONS(5789),
    [anon_sym_PERCENT_EQ] = ACTIONS(5789),
    [anon_sym_PLUS_EQ] = ACTIONS(5789),
    [anon_sym_DASH_EQ] = ACTIONS(5789),
    [anon_sym_LT_LT_EQ] = ACTIONS(5789),
    [anon_sym_GT_GT_EQ] = ACTIONS(5789),
    [anon_sym_AMP_EQ] = ACTIONS(5789),
    [anon_sym_CARET_EQ] = ACTIONS(5789),
    [anon_sym_PIPE_EQ] = ACTIONS(5789),
    [anon_sym_and_eq] = ACTIONS(5791),
    [anon_sym_or_eq] = ACTIONS(5791),
    [anon_sym_xor_eq] = ACTIONS(5791),
    [anon_sym_LT_EQ_GT] = ACTIONS(5789),
    [anon_sym_or] = ACTIONS(5791),
    [anon_sym_and] = ACTIONS(5791),
    [anon_sym_bitor] = ACTIONS(5791),
    [anon_sym_xor] = ACTIONS(5791),
    [anon_sym_bitand] = ACTIONS(5791),
    [anon_sym_not_eq] = ACTIONS(5791),
    [anon_sym_DASH_DASH] = ACTIONS(5789),
    [anon_sym_PLUS_PLUS] = ACTIONS(5789),
    [anon_sym_DOT] = ACTIONS(5791),
    [anon_sym_DOT_STAR] = ACTIONS(5789),
    [anon_sym_DASH_GT] = ACTIONS(5789),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5791),
    [anon_sym_decltype] = ACTIONS(5791),
  },
  [2170] = {
    [sym_identifier] = ACTIONS(5502),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5504),
    [anon_sym_COMMA] = ACTIONS(5504),
    [anon_sym_RPAREN] = ACTIONS(5504),
    [aux_sym_preproc_if_token2] = ACTIONS(5504),
    [aux_sym_preproc_else_token1] = ACTIONS(5504),
    [aux_sym_preproc_elif_token1] = ACTIONS(5502),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5504),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5504),
    [anon_sym_LPAREN2] = ACTIONS(5504),
    [anon_sym_DASH] = ACTIONS(5502),
    [anon_sym_PLUS] = ACTIONS(5502),
    [anon_sym_STAR] = ACTIONS(5502),
    [anon_sym_SLASH] = ACTIONS(5502),
    [anon_sym_PERCENT] = ACTIONS(5502),
    [anon_sym_PIPE_PIPE] = ACTIONS(5504),
    [anon_sym_AMP_AMP] = ACTIONS(5504),
    [anon_sym_PIPE] = ACTIONS(5502),
    [anon_sym_CARET] = ACTIONS(5502),
    [anon_sym_AMP] = ACTIONS(5502),
    [anon_sym_EQ_EQ] = ACTIONS(5504),
    [anon_sym_BANG_EQ] = ACTIONS(5504),
    [anon_sym_GT] = ACTIONS(5502),
    [anon_sym_GT_EQ] = ACTIONS(5504),
    [anon_sym_LT_EQ] = ACTIONS(5502),
    [anon_sym_LT] = ACTIONS(5502),
    [anon_sym_LT_LT] = ACTIONS(5502),
    [anon_sym_GT_GT] = ACTIONS(5502),
    [anon_sym_SEMI] = ACTIONS(5504),
    [anon_sym___attribute__] = ACTIONS(5502),
    [anon_sym___attribute] = ACTIONS(5502),
    [anon_sym_LBRACE] = ACTIONS(5504),
    [anon_sym_RBRACE] = ACTIONS(5504),
    [anon_sym_LBRACK] = ACTIONS(5504),
    [anon_sym_RBRACK] = ACTIONS(5504),
    [anon_sym_EQ] = ACTIONS(5502),
    [anon_sym_COLON] = ACTIONS(5504),
    [anon_sym_QMARK] = ACTIONS(5504),
    [anon_sym_STAR_EQ] = ACTIONS(5504),
    [anon_sym_SLASH_EQ] = ACTIONS(5504),
    [anon_sym_PERCENT_EQ] = ACTIONS(5504),
    [anon_sym_PLUS_EQ] = ACTIONS(5504),
    [anon_sym_DASH_EQ] = ACTIONS(5504),
    [anon_sym_LT_LT_EQ] = ACTIONS(5504),
    [anon_sym_GT_GT_EQ] = ACTIONS(5504),
    [anon_sym_AMP_EQ] = ACTIONS(5504),
    [anon_sym_CARET_EQ] = ACTIONS(5504),
    [anon_sym_PIPE_EQ] = ACTIONS(5504),
    [anon_sym_and_eq] = ACTIONS(5502),
    [anon_sym_or_eq] = ACTIONS(5502),
    [anon_sym_xor_eq] = ACTIONS(5502),
    [anon_sym_LT_EQ_GT] = ACTIONS(5504),
    [anon_sym_or] = ACTIONS(5502),
    [anon_sym_and] = ACTIONS(5502),
    [anon_sym_bitor] = ACTIONS(5502),
    [anon_sym_xor] = ACTIONS(5502),
    [anon_sym_bitand] = ACTIONS(5502),
    [anon_sym_not_eq] = ACTIONS(5502),
    [anon_sym_DASH_DASH] = ACTIONS(5504),
    [anon_sym_PLUS_PLUS] = ACTIONS(5504),
    [anon_sym_DOT] = ACTIONS(5502),
    [anon_sym_DOT_STAR] = ACTIONS(5504),
    [anon_sym_DASH_GT] = ACTIONS(5504),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5502),
    [anon_sym_decltype] = ACTIONS(5502),
  },
  [2171] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2174),
    [sym_identifier] = ACTIONS(5803),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5801),
    [anon_sym_COMMA] = ACTIONS(5801),
    [aux_sym_preproc_if_token2] = ACTIONS(5801),
    [aux_sym_preproc_else_token1] = ACTIONS(5801),
    [aux_sym_preproc_elif_token1] = ACTIONS(5803),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5801),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5801),
    [anon_sym_LPAREN2] = ACTIONS(5801),
    [anon_sym_DASH] = ACTIONS(5803),
    [anon_sym_PLUS] = ACTIONS(5803),
    [anon_sym_STAR] = ACTIONS(5803),
    [anon_sym_SLASH] = ACTIONS(5803),
    [anon_sym_PERCENT] = ACTIONS(5803),
    [anon_sym_PIPE_PIPE] = ACTIONS(5801),
    [anon_sym_AMP_AMP] = ACTIONS(5801),
    [anon_sym_PIPE] = ACTIONS(5803),
    [anon_sym_CARET] = ACTIONS(5803),
    [anon_sym_AMP] = ACTIONS(5803),
    [anon_sym_EQ_EQ] = ACTIONS(5801),
    [anon_sym_BANG_EQ] = ACTIONS(5801),
    [anon_sym_GT] = ACTIONS(5803),
    [anon_sym_GT_EQ] = ACTIONS(5801),
    [anon_sym_LT_EQ] = ACTIONS(5803),
    [anon_sym_LT] = ACTIONS(5803),
    [anon_sym_LT_LT] = ACTIONS(5803),
    [anon_sym_GT_GT] = ACTIONS(5803),
    [anon_sym___attribute__] = ACTIONS(5803),
    [anon_sym___attribute] = ACTIONS(5803),
    [anon_sym_LBRACE] = ACTIONS(5801),
    [anon_sym_signed] = ACTIONS(6027),
    [anon_sym_unsigned] = ACTIONS(6027),
    [anon_sym_long] = ACTIONS(6027),
    [anon_sym_short] = ACTIONS(6027),
    [anon_sym_LBRACK] = ACTIONS(5801),
    [anon_sym_EQ] = ACTIONS(5803),
    [anon_sym_QMARK] = ACTIONS(5801),
    [anon_sym_STAR_EQ] = ACTIONS(5801),
    [anon_sym_SLASH_EQ] = ACTIONS(5801),
    [anon_sym_PERCENT_EQ] = ACTIONS(5801),
    [anon_sym_PLUS_EQ] = ACTIONS(5801),
    [anon_sym_DASH_EQ] = ACTIONS(5801),
    [anon_sym_LT_LT_EQ] = ACTIONS(5801),
    [anon_sym_GT_GT_EQ] = ACTIONS(5801),
    [anon_sym_AMP_EQ] = ACTIONS(5801),
    [anon_sym_CARET_EQ] = ACTIONS(5801),
    [anon_sym_PIPE_EQ] = ACTIONS(5801),
    [anon_sym_and_eq] = ACTIONS(5803),
    [anon_sym_or_eq] = ACTIONS(5803),
    [anon_sym_xor_eq] = ACTIONS(5803),
    [anon_sym_LT_EQ_GT] = ACTIONS(5801),
    [anon_sym_or] = ACTIONS(5803),
    [anon_sym_and] = ACTIONS(5803),
    [anon_sym_bitor] = ACTIONS(5803),
    [anon_sym_xor] = ACTIONS(5803),
    [anon_sym_bitand] = ACTIONS(5803),
    [anon_sym_not_eq] = ACTIONS(5803),
    [anon_sym_DASH_DASH] = ACTIONS(5801),
    [anon_sym_PLUS_PLUS] = ACTIONS(5801),
    [anon_sym_DOT] = ACTIONS(5803),
    [anon_sym_DOT_STAR] = ACTIONS(5801),
    [anon_sym_DASH_GT] = ACTIONS(5801),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5803),
    [anon_sym_decltype] = ACTIONS(5803),
  },
  [2172] = {
    [sym_identifier] = ACTIONS(5470),
    [anon_sym_LPAREN2] = ACTIONS(5472),
    [anon_sym_TILDE] = ACTIONS(5472),
    [anon_sym_STAR] = ACTIONS(5472),
    [anon_sym_PIPE_PIPE] = ACTIONS(5472),
    [anon_sym_AMP_AMP] = ACTIONS(5472),
    [anon_sym_AMP] = ACTIONS(5470),
    [anon_sym___extension__] = ACTIONS(5470),
    [anon_sym_virtual] = ACTIONS(5470),
    [anon_sym_extern] = ACTIONS(5470),
    [anon_sym___attribute__] = ACTIONS(5470),
    [anon_sym___attribute] = ACTIONS(5470),
    [anon_sym_COLON_COLON] = ACTIONS(5472),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5472),
    [anon_sym___declspec] = ACTIONS(5470),
    [anon_sym___based] = ACTIONS(5470),
    [anon_sym___cdecl] = ACTIONS(5470),
    [anon_sym___clrcall] = ACTIONS(5470),
    [anon_sym___stdcall] = ACTIONS(5470),
    [anon_sym___fastcall] = ACTIONS(5470),
    [anon_sym___thiscall] = ACTIONS(5470),
    [anon_sym___vectorcall] = ACTIONS(5470),
    [anon_sym_signed] = ACTIONS(5470),
    [anon_sym_unsigned] = ACTIONS(5470),
    [anon_sym_long] = ACTIONS(5470),
    [anon_sym_short] = ACTIONS(5470),
    [anon_sym_LBRACK] = ACTIONS(5470),
    [anon_sym_static] = ACTIONS(5470),
    [anon_sym_register] = ACTIONS(5470),
    [anon_sym_inline] = ACTIONS(5470),
    [anon_sym___inline] = ACTIONS(5470),
    [anon_sym___inline__] = ACTIONS(5470),
    [anon_sym___forceinline] = ACTIONS(5470),
    [anon_sym_thread_local] = ACTIONS(5470),
    [anon_sym___thread] = ACTIONS(5470),
    [anon_sym_const] = ACTIONS(5470),
    [anon_sym_constexpr] = ACTIONS(5470),
    [anon_sym_volatile] = ACTIONS(5470),
    [anon_sym_restrict] = ACTIONS(5470),
    [anon_sym___restrict__] = ACTIONS(5470),
    [anon_sym__Atomic] = ACTIONS(5470),
    [anon_sym__Noreturn] = ACTIONS(5470),
    [anon_sym_noreturn] = ACTIONS(5470),
    [anon_sym__Nonnull] = ACTIONS(5470),
    [anon_sym_mutable] = ACTIONS(5470),
    [anon_sym_constinit] = ACTIONS(5470),
    [anon_sym_consteval] = ACTIONS(5470),
    [anon_sym_alignas] = ACTIONS(5470),
    [anon_sym__Alignas] = ACTIONS(5470),
    [sym_primitive_type] = ACTIONS(5470),
    [anon_sym_enum] = ACTIONS(5470),
    [anon_sym_class] = ACTIONS(5470),
    [anon_sym_struct] = ACTIONS(5470),
    [anon_sym_union] = ACTIONS(5470),
    [anon_sym_or] = ACTIONS(5470),
    [anon_sym_and] = ACTIONS(5470),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5470),
    [anon_sym_decltype] = ACTIONS(5470),
    [anon_sym_explicit] = ACTIONS(5470),
    [anon_sym_typename] = ACTIONS(5470),
    [anon_sym_template] = ACTIONS(5470),
    [anon_sym_operator] = ACTIONS(5470),
    [anon_sym_friend] = ACTIONS(5470),
    [anon_sym_using] = ACTIONS(5470),
    [anon_sym_concept] = ACTIONS(5470),
  },
  [2173] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2175),
    [sym_identifier] = ACTIONS(5746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5744),
    [anon_sym_COMMA] = ACTIONS(5744),
    [aux_sym_preproc_if_token2] = ACTIONS(5744),
    [aux_sym_preproc_else_token1] = ACTIONS(5744),
    [aux_sym_preproc_elif_token1] = ACTIONS(5746),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5744),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5744),
    [anon_sym_LPAREN2] = ACTIONS(5744),
    [anon_sym_DASH] = ACTIONS(5746),
    [anon_sym_PLUS] = ACTIONS(5746),
    [anon_sym_STAR] = ACTIONS(5746),
    [anon_sym_SLASH] = ACTIONS(5746),
    [anon_sym_PERCENT] = ACTIONS(5746),
    [anon_sym_PIPE_PIPE] = ACTIONS(5744),
    [anon_sym_AMP_AMP] = ACTIONS(5744),
    [anon_sym_PIPE] = ACTIONS(5746),
    [anon_sym_CARET] = ACTIONS(5746),
    [anon_sym_AMP] = ACTIONS(5746),
    [anon_sym_EQ_EQ] = ACTIONS(5744),
    [anon_sym_BANG_EQ] = ACTIONS(5744),
    [anon_sym_GT] = ACTIONS(5746),
    [anon_sym_GT_EQ] = ACTIONS(5744),
    [anon_sym_LT_EQ] = ACTIONS(5746),
    [anon_sym_LT] = ACTIONS(5746),
    [anon_sym_LT_LT] = ACTIONS(5746),
    [anon_sym_GT_GT] = ACTIONS(5746),
    [anon_sym___attribute__] = ACTIONS(5746),
    [anon_sym___attribute] = ACTIONS(5746),
    [anon_sym_LBRACE] = ACTIONS(5744),
    [anon_sym_signed] = ACTIONS(6029),
    [anon_sym_unsigned] = ACTIONS(6029),
    [anon_sym_long] = ACTIONS(6029),
    [anon_sym_short] = ACTIONS(6029),
    [anon_sym_LBRACK] = ACTIONS(5744),
    [anon_sym_EQ] = ACTIONS(5746),
    [anon_sym_QMARK] = ACTIONS(5744),
    [anon_sym_STAR_EQ] = ACTIONS(5744),
    [anon_sym_SLASH_EQ] = ACTIONS(5744),
    [anon_sym_PERCENT_EQ] = ACTIONS(5744),
    [anon_sym_PLUS_EQ] = ACTIONS(5744),
    [anon_sym_DASH_EQ] = ACTIONS(5744),
    [anon_sym_LT_LT_EQ] = ACTIONS(5744),
    [anon_sym_GT_GT_EQ] = ACTIONS(5744),
    [anon_sym_AMP_EQ] = ACTIONS(5744),
    [anon_sym_CARET_EQ] = ACTIONS(5744),
    [anon_sym_PIPE_EQ] = ACTIONS(5744),
    [anon_sym_and_eq] = ACTIONS(5746),
    [anon_sym_or_eq] = ACTIONS(5746),
    [anon_sym_xor_eq] = ACTIONS(5746),
    [anon_sym_LT_EQ_GT] = ACTIONS(5744),
    [anon_sym_or] = ACTIONS(5746),
    [anon_sym_and] = ACTIONS(5746),
    [anon_sym_bitor] = ACTIONS(5746),
    [anon_sym_xor] = ACTIONS(5746),
    [anon_sym_bitand] = ACTIONS(5746),
    [anon_sym_not_eq] = ACTIONS(5746),
    [anon_sym_DASH_DASH] = ACTIONS(5744),
    [anon_sym_PLUS_PLUS] = ACTIONS(5744),
    [anon_sym_DOT] = ACTIONS(5746),
    [anon_sym_DOT_STAR] = ACTIONS(5744),
    [anon_sym_DASH_GT] = ACTIONS(5744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5746),
    [anon_sym_decltype] = ACTIONS(5746),
  },
  [2174] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2249),
    [sym_identifier] = ACTIONS(5795),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5793),
    [anon_sym_COMMA] = ACTIONS(5793),
    [aux_sym_preproc_if_token2] = ACTIONS(5793),
    [aux_sym_preproc_else_token1] = ACTIONS(5793),
    [aux_sym_preproc_elif_token1] = ACTIONS(5795),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5793),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5793),
    [anon_sym_LPAREN2] = ACTIONS(5793),
    [anon_sym_DASH] = ACTIONS(5795),
    [anon_sym_PLUS] = ACTIONS(5795),
    [anon_sym_STAR] = ACTIONS(5795),
    [anon_sym_SLASH] = ACTIONS(5795),
    [anon_sym_PERCENT] = ACTIONS(5795),
    [anon_sym_PIPE_PIPE] = ACTIONS(5793),
    [anon_sym_AMP_AMP] = ACTIONS(5793),
    [anon_sym_PIPE] = ACTIONS(5795),
    [anon_sym_CARET] = ACTIONS(5795),
    [anon_sym_AMP] = ACTIONS(5795),
    [anon_sym_EQ_EQ] = ACTIONS(5793),
    [anon_sym_BANG_EQ] = ACTIONS(5793),
    [anon_sym_GT] = ACTIONS(5795),
    [anon_sym_GT_EQ] = ACTIONS(5793),
    [anon_sym_LT_EQ] = ACTIONS(5795),
    [anon_sym_LT] = ACTIONS(5795),
    [anon_sym_LT_LT] = ACTIONS(5795),
    [anon_sym_GT_GT] = ACTIONS(5795),
    [anon_sym___attribute__] = ACTIONS(5795),
    [anon_sym___attribute] = ACTIONS(5795),
    [anon_sym_LBRACE] = ACTIONS(5793),
    [anon_sym_signed] = ACTIONS(6025),
    [anon_sym_unsigned] = ACTIONS(6025),
    [anon_sym_long] = ACTIONS(6025),
    [anon_sym_short] = ACTIONS(6025),
    [anon_sym_LBRACK] = ACTIONS(5793),
    [anon_sym_EQ] = ACTIONS(5795),
    [anon_sym_QMARK] = ACTIONS(5793),
    [anon_sym_STAR_EQ] = ACTIONS(5793),
    [anon_sym_SLASH_EQ] = ACTIONS(5793),
    [anon_sym_PERCENT_EQ] = ACTIONS(5793),
    [anon_sym_PLUS_EQ] = ACTIONS(5793),
    [anon_sym_DASH_EQ] = ACTIONS(5793),
    [anon_sym_LT_LT_EQ] = ACTIONS(5793),
    [anon_sym_GT_GT_EQ] = ACTIONS(5793),
    [anon_sym_AMP_EQ] = ACTIONS(5793),
    [anon_sym_CARET_EQ] = ACTIONS(5793),
    [anon_sym_PIPE_EQ] = ACTIONS(5793),
    [anon_sym_and_eq] = ACTIONS(5795),
    [anon_sym_or_eq] = ACTIONS(5795),
    [anon_sym_xor_eq] = ACTIONS(5795),
    [anon_sym_LT_EQ_GT] = ACTIONS(5793),
    [anon_sym_or] = ACTIONS(5795),
    [anon_sym_and] = ACTIONS(5795),
    [anon_sym_bitor] = ACTIONS(5795),
    [anon_sym_xor] = ACTIONS(5795),
    [anon_sym_bitand] = ACTIONS(5795),
    [anon_sym_not_eq] = ACTIONS(5795),
    [anon_sym_DASH_DASH] = ACTIONS(5793),
    [anon_sym_PLUS_PLUS] = ACTIONS(5793),
    [anon_sym_DOT] = ACTIONS(5795),
    [anon_sym_DOT_STAR] = ACTIONS(5793),
    [anon_sym_DASH_GT] = ACTIONS(5793),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5795),
    [anon_sym_decltype] = ACTIONS(5795),
  },
  [2175] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2249),
    [sym_identifier] = ACTIONS(5782),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5780),
    [anon_sym_COMMA] = ACTIONS(5780),
    [aux_sym_preproc_if_token2] = ACTIONS(5780),
    [aux_sym_preproc_else_token1] = ACTIONS(5780),
    [aux_sym_preproc_elif_token1] = ACTIONS(5782),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5780),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5780),
    [anon_sym_LPAREN2] = ACTIONS(5780),
    [anon_sym_DASH] = ACTIONS(5782),
    [anon_sym_PLUS] = ACTIONS(5782),
    [anon_sym_STAR] = ACTIONS(5782),
    [anon_sym_SLASH] = ACTIONS(5782),
    [anon_sym_PERCENT] = ACTIONS(5782),
    [anon_sym_PIPE_PIPE] = ACTIONS(5780),
    [anon_sym_AMP_AMP] = ACTIONS(5780),
    [anon_sym_PIPE] = ACTIONS(5782),
    [anon_sym_CARET] = ACTIONS(5782),
    [anon_sym_AMP] = ACTIONS(5782),
    [anon_sym_EQ_EQ] = ACTIONS(5780),
    [anon_sym_BANG_EQ] = ACTIONS(5780),
    [anon_sym_GT] = ACTIONS(5782),
    [anon_sym_GT_EQ] = ACTIONS(5780),
    [anon_sym_LT_EQ] = ACTIONS(5782),
    [anon_sym_LT] = ACTIONS(5782),
    [anon_sym_LT_LT] = ACTIONS(5782),
    [anon_sym_GT_GT] = ACTIONS(5782),
    [anon_sym___attribute__] = ACTIONS(5782),
    [anon_sym___attribute] = ACTIONS(5782),
    [anon_sym_LBRACE] = ACTIONS(5780),
    [anon_sym_signed] = ACTIONS(6025),
    [anon_sym_unsigned] = ACTIONS(6025),
    [anon_sym_long] = ACTIONS(6025),
    [anon_sym_short] = ACTIONS(6025),
    [anon_sym_LBRACK] = ACTIONS(5780),
    [anon_sym_EQ] = ACTIONS(5782),
    [anon_sym_QMARK] = ACTIONS(5780),
    [anon_sym_STAR_EQ] = ACTIONS(5780),
    [anon_sym_SLASH_EQ] = ACTIONS(5780),
    [anon_sym_PERCENT_EQ] = ACTIONS(5780),
    [anon_sym_PLUS_EQ] = ACTIONS(5780),
    [anon_sym_DASH_EQ] = ACTIONS(5780),
    [anon_sym_LT_LT_EQ] = ACTIONS(5780),
    [anon_sym_GT_GT_EQ] = ACTIONS(5780),
    [anon_sym_AMP_EQ] = ACTIONS(5780),
    [anon_sym_CARET_EQ] = ACTIONS(5780),
    [anon_sym_PIPE_EQ] = ACTIONS(5780),
    [anon_sym_and_eq] = ACTIONS(5782),
    [anon_sym_or_eq] = ACTIONS(5782),
    [anon_sym_xor_eq] = ACTIONS(5782),
    [anon_sym_LT_EQ_GT] = ACTIONS(5780),
    [anon_sym_or] = ACTIONS(5782),
    [anon_sym_and] = ACTIONS(5782),
    [anon_sym_bitor] = ACTIONS(5782),
    [anon_sym_xor] = ACTIONS(5782),
    [anon_sym_bitand] = ACTIONS(5782),
    [anon_sym_not_eq] = ACTIONS(5782),
    [anon_sym_DASH_DASH] = ACTIONS(5780),
    [anon_sym_PLUS_PLUS] = ACTIONS(5780),
    [anon_sym_DOT] = ACTIONS(5782),
    [anon_sym_DOT_STAR] = ACTIONS(5780),
    [anon_sym_DASH_GT] = ACTIONS(5780),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5782),
    [anon_sym_decltype] = ACTIONS(5782),
  },
  [2176] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2184),
    [sym_identifier] = ACTIONS(5740),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5738),
    [anon_sym_COMMA] = ACTIONS(5738),
    [aux_sym_preproc_if_token2] = ACTIONS(5738),
    [aux_sym_preproc_else_token1] = ACTIONS(5738),
    [aux_sym_preproc_elif_token1] = ACTIONS(5740),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5738),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5738),
    [anon_sym_LPAREN2] = ACTIONS(5738),
    [anon_sym_DASH] = ACTIONS(5740),
    [anon_sym_PLUS] = ACTIONS(5740),
    [anon_sym_STAR] = ACTIONS(5740),
    [anon_sym_SLASH] = ACTIONS(5740),
    [anon_sym_PERCENT] = ACTIONS(5740),
    [anon_sym_PIPE_PIPE] = ACTIONS(5738),
    [anon_sym_AMP_AMP] = ACTIONS(5738),
    [anon_sym_PIPE] = ACTIONS(5740),
    [anon_sym_CARET] = ACTIONS(5740),
    [anon_sym_AMP] = ACTIONS(5740),
    [anon_sym_EQ_EQ] = ACTIONS(5738),
    [anon_sym_BANG_EQ] = ACTIONS(5738),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5738),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_LT_LT] = ACTIONS(5740),
    [anon_sym_GT_GT] = ACTIONS(5740),
    [anon_sym___attribute__] = ACTIONS(5740),
    [anon_sym___attribute] = ACTIONS(5740),
    [anon_sym_LBRACE] = ACTIONS(5738),
    [anon_sym_signed] = ACTIONS(6031),
    [anon_sym_unsigned] = ACTIONS(6031),
    [anon_sym_long] = ACTIONS(6031),
    [anon_sym_short] = ACTIONS(6031),
    [anon_sym_LBRACK] = ACTIONS(5738),
    [anon_sym_EQ] = ACTIONS(5740),
    [anon_sym_QMARK] = ACTIONS(5738),
    [anon_sym_STAR_EQ] = ACTIONS(5738),
    [anon_sym_SLASH_EQ] = ACTIONS(5738),
    [anon_sym_PERCENT_EQ] = ACTIONS(5738),
    [anon_sym_PLUS_EQ] = ACTIONS(5738),
    [anon_sym_DASH_EQ] = ACTIONS(5738),
    [anon_sym_LT_LT_EQ] = ACTIONS(5738),
    [anon_sym_GT_GT_EQ] = ACTIONS(5738),
    [anon_sym_AMP_EQ] = ACTIONS(5738),
    [anon_sym_CARET_EQ] = ACTIONS(5738),
    [anon_sym_PIPE_EQ] = ACTIONS(5738),
    [anon_sym_and_eq] = ACTIONS(5740),
    [anon_sym_or_eq] = ACTIONS(5740),
    [anon_sym_xor_eq] = ACTIONS(5740),
    [anon_sym_LT_EQ_GT] = ACTIONS(5738),
    [anon_sym_or] = ACTIONS(5740),
    [anon_sym_and] = ACTIONS(5740),
    [anon_sym_bitor] = ACTIONS(5740),
    [anon_sym_xor] = ACTIONS(5740),
    [anon_sym_bitand] = ACTIONS(5740),
    [anon_sym_not_eq] = ACTIONS(5740),
    [anon_sym_DASH_DASH] = ACTIONS(5738),
    [anon_sym_PLUS_PLUS] = ACTIONS(5738),
    [anon_sym_DOT] = ACTIONS(5740),
    [anon_sym_DOT_STAR] = ACTIONS(5738),
    [anon_sym_DASH_GT] = ACTIONS(5738),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5740),
    [anon_sym_decltype] = ACTIONS(5740),
  },
  [2177] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2185),
    [sym_identifier] = ACTIONS(5762),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5760),
    [anon_sym_COMMA] = ACTIONS(5760),
    [aux_sym_preproc_if_token2] = ACTIONS(5760),
    [aux_sym_preproc_else_token1] = ACTIONS(5760),
    [aux_sym_preproc_elif_token1] = ACTIONS(5762),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5760),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5760),
    [anon_sym_LPAREN2] = ACTIONS(5760),
    [anon_sym_DASH] = ACTIONS(5762),
    [anon_sym_PLUS] = ACTIONS(5762),
    [anon_sym_STAR] = ACTIONS(5762),
    [anon_sym_SLASH] = ACTIONS(5762),
    [anon_sym_PERCENT] = ACTIONS(5762),
    [anon_sym_PIPE_PIPE] = ACTIONS(5760),
    [anon_sym_AMP_AMP] = ACTIONS(5760),
    [anon_sym_PIPE] = ACTIONS(5762),
    [anon_sym_CARET] = ACTIONS(5762),
    [anon_sym_AMP] = ACTIONS(5762),
    [anon_sym_EQ_EQ] = ACTIONS(5760),
    [anon_sym_BANG_EQ] = ACTIONS(5760),
    [anon_sym_GT] = ACTIONS(5762),
    [anon_sym_GT_EQ] = ACTIONS(5760),
    [anon_sym_LT_EQ] = ACTIONS(5762),
    [anon_sym_LT] = ACTIONS(5762),
    [anon_sym_LT_LT] = ACTIONS(5762),
    [anon_sym_GT_GT] = ACTIONS(5762),
    [anon_sym___attribute__] = ACTIONS(5762),
    [anon_sym___attribute] = ACTIONS(5762),
    [anon_sym_LBRACE] = ACTIONS(5760),
    [anon_sym_signed] = ACTIONS(6033),
    [anon_sym_unsigned] = ACTIONS(6033),
    [anon_sym_long] = ACTIONS(6033),
    [anon_sym_short] = ACTIONS(6033),
    [anon_sym_LBRACK] = ACTIONS(5760),
    [anon_sym_EQ] = ACTIONS(5762),
    [anon_sym_QMARK] = ACTIONS(5760),
    [anon_sym_STAR_EQ] = ACTIONS(5760),
    [anon_sym_SLASH_EQ] = ACTIONS(5760),
    [anon_sym_PERCENT_EQ] = ACTIONS(5760),
    [anon_sym_PLUS_EQ] = ACTIONS(5760),
    [anon_sym_DASH_EQ] = ACTIONS(5760),
    [anon_sym_LT_LT_EQ] = ACTIONS(5760),
    [anon_sym_GT_GT_EQ] = ACTIONS(5760),
    [anon_sym_AMP_EQ] = ACTIONS(5760),
    [anon_sym_CARET_EQ] = ACTIONS(5760),
    [anon_sym_PIPE_EQ] = ACTIONS(5760),
    [anon_sym_and_eq] = ACTIONS(5762),
    [anon_sym_or_eq] = ACTIONS(5762),
    [anon_sym_xor_eq] = ACTIONS(5762),
    [anon_sym_LT_EQ_GT] = ACTIONS(5760),
    [anon_sym_or] = ACTIONS(5762),
    [anon_sym_and] = ACTIONS(5762),
    [anon_sym_bitor] = ACTIONS(5762),
    [anon_sym_xor] = ACTIONS(5762),
    [anon_sym_bitand] = ACTIONS(5762),
    [anon_sym_not_eq] = ACTIONS(5762),
    [anon_sym_DASH_DASH] = ACTIONS(5760),
    [anon_sym_PLUS_PLUS] = ACTIONS(5760),
    [anon_sym_DOT] = ACTIONS(5762),
    [anon_sym_DOT_STAR] = ACTIONS(5760),
    [anon_sym_DASH_GT] = ACTIONS(5760),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5762),
    [anon_sym_decltype] = ACTIONS(5762),
  },
  [2178] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2249),
    [sym_identifier] = ACTIONS(5778),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5776),
    [anon_sym_COMMA] = ACTIONS(5776),
    [aux_sym_preproc_if_token2] = ACTIONS(5776),
    [aux_sym_preproc_else_token1] = ACTIONS(5776),
    [aux_sym_preproc_elif_token1] = ACTIONS(5778),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5776),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5776),
    [anon_sym_LPAREN2] = ACTIONS(5776),
    [anon_sym_DASH] = ACTIONS(5778),
    [anon_sym_PLUS] = ACTIONS(5778),
    [anon_sym_STAR] = ACTIONS(5778),
    [anon_sym_SLASH] = ACTIONS(5778),
    [anon_sym_PERCENT] = ACTIONS(5778),
    [anon_sym_PIPE_PIPE] = ACTIONS(5776),
    [anon_sym_AMP_AMP] = ACTIONS(5776),
    [anon_sym_PIPE] = ACTIONS(5778),
    [anon_sym_CARET] = ACTIONS(5778),
    [anon_sym_AMP] = ACTIONS(5778),
    [anon_sym_EQ_EQ] = ACTIONS(5776),
    [anon_sym_BANG_EQ] = ACTIONS(5776),
    [anon_sym_GT] = ACTIONS(5778),
    [anon_sym_GT_EQ] = ACTIONS(5776),
    [anon_sym_LT_EQ] = ACTIONS(5778),
    [anon_sym_LT] = ACTIONS(5778),
    [anon_sym_LT_LT] = ACTIONS(5778),
    [anon_sym_GT_GT] = ACTIONS(5778),
    [anon_sym___attribute__] = ACTIONS(5778),
    [anon_sym___attribute] = ACTIONS(5778),
    [anon_sym_LBRACE] = ACTIONS(5776),
    [anon_sym_signed] = ACTIONS(6025),
    [anon_sym_unsigned] = ACTIONS(6025),
    [anon_sym_long] = ACTIONS(6025),
    [anon_sym_short] = ACTIONS(6025),
    [anon_sym_LBRACK] = ACTIONS(5776),
    [anon_sym_EQ] = ACTIONS(5778),
    [anon_sym_QMARK] = ACTIONS(5776),
    [anon_sym_STAR_EQ] = ACTIONS(5776),
    [anon_sym_SLASH_EQ] = ACTIONS(5776),
    [anon_sym_PERCENT_EQ] = ACTIONS(5776),
    [anon_sym_PLUS_EQ] = ACTIONS(5776),
    [anon_sym_DASH_EQ] = ACTIONS(5776),
    [anon_sym_LT_LT_EQ] = ACTIONS(5776),
    [anon_sym_GT_GT_EQ] = ACTIONS(5776),
    [anon_sym_AMP_EQ] = ACTIONS(5776),
    [anon_sym_CARET_EQ] = ACTIONS(5776),
    [anon_sym_PIPE_EQ] = ACTIONS(5776),
    [anon_sym_and_eq] = ACTIONS(5778),
    [anon_sym_or_eq] = ACTIONS(5778),
    [anon_sym_xor_eq] = ACTIONS(5778),
    [anon_sym_LT_EQ_GT] = ACTIONS(5776),
    [anon_sym_or] = ACTIONS(5778),
    [anon_sym_and] = ACTIONS(5778),
    [anon_sym_bitor] = ACTIONS(5778),
    [anon_sym_xor] = ACTIONS(5778),
    [anon_sym_bitand] = ACTIONS(5778),
    [anon_sym_not_eq] = ACTIONS(5778),
    [anon_sym_DASH_DASH] = ACTIONS(5776),
    [anon_sym_PLUS_PLUS] = ACTIONS(5776),
    [anon_sym_DOT] = ACTIONS(5778),
    [anon_sym_DOT_STAR] = ACTIONS(5776),
    [anon_sym_DASH_GT] = ACTIONS(5776),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5778),
    [anon_sym_decltype] = ACTIONS(5778),
  },
  [2179] = {
    [sym_identifier] = ACTIONS(5672),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5674),
    [anon_sym_COMMA] = ACTIONS(5674),
    [anon_sym_RPAREN] = ACTIONS(5674),
    [aux_sym_preproc_if_token2] = ACTIONS(5674),
    [aux_sym_preproc_else_token1] = ACTIONS(5674),
    [aux_sym_preproc_elif_token1] = ACTIONS(5672),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5674),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5674),
    [anon_sym_LPAREN2] = ACTIONS(5674),
    [anon_sym_DASH] = ACTIONS(5672),
    [anon_sym_PLUS] = ACTIONS(5672),
    [anon_sym_STAR] = ACTIONS(5672),
    [anon_sym_SLASH] = ACTIONS(5672),
    [anon_sym_PERCENT] = ACTIONS(5672),
    [anon_sym_PIPE_PIPE] = ACTIONS(5674),
    [anon_sym_AMP_AMP] = ACTIONS(5674),
    [anon_sym_PIPE] = ACTIONS(5672),
    [anon_sym_CARET] = ACTIONS(5672),
    [anon_sym_AMP] = ACTIONS(5672),
    [anon_sym_EQ_EQ] = ACTIONS(5674),
    [anon_sym_BANG_EQ] = ACTIONS(5674),
    [anon_sym_GT] = ACTIONS(5672),
    [anon_sym_GT_EQ] = ACTIONS(5674),
    [anon_sym_LT_EQ] = ACTIONS(5672),
    [anon_sym_LT] = ACTIONS(5672),
    [anon_sym_LT_LT] = ACTIONS(5672),
    [anon_sym_GT_GT] = ACTIONS(5672),
    [anon_sym_SEMI] = ACTIONS(5674),
    [anon_sym___attribute__] = ACTIONS(5672),
    [anon_sym___attribute] = ACTIONS(5672),
    [anon_sym_LBRACE] = ACTIONS(5674),
    [anon_sym_RBRACE] = ACTIONS(5674),
    [anon_sym_LBRACK] = ACTIONS(5674),
    [anon_sym_RBRACK] = ACTIONS(5674),
    [anon_sym_EQ] = ACTIONS(5672),
    [anon_sym_COLON] = ACTIONS(5674),
    [anon_sym_QMARK] = ACTIONS(5674),
    [anon_sym_STAR_EQ] = ACTIONS(5674),
    [anon_sym_SLASH_EQ] = ACTIONS(5674),
    [anon_sym_PERCENT_EQ] = ACTIONS(5674),
    [anon_sym_PLUS_EQ] = ACTIONS(5674),
    [anon_sym_DASH_EQ] = ACTIONS(5674),
    [anon_sym_LT_LT_EQ] = ACTIONS(5674),
    [anon_sym_GT_GT_EQ] = ACTIONS(5674),
    [anon_sym_AMP_EQ] = ACTIONS(5674),
    [anon_sym_CARET_EQ] = ACTIONS(5674),
    [anon_sym_PIPE_EQ] = ACTIONS(5674),
    [anon_sym_and_eq] = ACTIONS(5672),
    [anon_sym_or_eq] = ACTIONS(5672),
    [anon_sym_xor_eq] = ACTIONS(5672),
    [anon_sym_LT_EQ_GT] = ACTIONS(5674),
    [anon_sym_or] = ACTIONS(5672),
    [anon_sym_and] = ACTIONS(5672),
    [anon_sym_bitor] = ACTIONS(5672),
    [anon_sym_xor] = ACTIONS(5672),
    [anon_sym_bitand] = ACTIONS(5672),
    [anon_sym_not_eq] = ACTIONS(5672),
    [anon_sym_DASH_DASH] = ACTIONS(5674),
    [anon_sym_PLUS_PLUS] = ACTIONS(5674),
    [anon_sym_DOT] = ACTIONS(5672),
    [anon_sym_DOT_STAR] = ACTIONS(5674),
    [anon_sym_DASH_GT] = ACTIONS(5674),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5672),
    [anon_sym_decltype] = ACTIONS(5672),
  },
  [2180] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2166),
    [sym_identifier] = ACTIONS(5545),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5547),
    [anon_sym_COMMA] = ACTIONS(5547),
    [aux_sym_preproc_if_token2] = ACTIONS(5547),
    [aux_sym_preproc_else_token1] = ACTIONS(5547),
    [aux_sym_preproc_elif_token1] = ACTIONS(5545),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5547),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5547),
    [anon_sym_LPAREN2] = ACTIONS(5547),
    [anon_sym_DASH] = ACTIONS(5545),
    [anon_sym_PLUS] = ACTIONS(5545),
    [anon_sym_STAR] = ACTIONS(5545),
    [anon_sym_SLASH] = ACTIONS(5545),
    [anon_sym_PERCENT] = ACTIONS(5545),
    [anon_sym_PIPE_PIPE] = ACTIONS(5547),
    [anon_sym_AMP_AMP] = ACTIONS(5547),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_CARET] = ACTIONS(5545),
    [anon_sym_AMP] = ACTIONS(5545),
    [anon_sym_EQ_EQ] = ACTIONS(5547),
    [anon_sym_BANG_EQ] = ACTIONS(5547),
    [anon_sym_GT] = ACTIONS(5545),
    [anon_sym_GT_EQ] = ACTIONS(5547),
    [anon_sym_LT_EQ] = ACTIONS(5545),
    [anon_sym_LT] = ACTIONS(5545),
    [anon_sym_LT_LT] = ACTIONS(5545),
    [anon_sym_GT_GT] = ACTIONS(5545),
    [anon_sym___attribute__] = ACTIONS(5545),
    [anon_sym___attribute] = ACTIONS(5545),
    [anon_sym_LBRACE] = ACTIONS(5547),
    [anon_sym_signed] = ACTIONS(6035),
    [anon_sym_unsigned] = ACTIONS(6035),
    [anon_sym_long] = ACTIONS(6035),
    [anon_sym_short] = ACTIONS(6035),
    [anon_sym_LBRACK] = ACTIONS(5547),
    [anon_sym_EQ] = ACTIONS(5545),
    [anon_sym_QMARK] = ACTIONS(5547),
    [anon_sym_STAR_EQ] = ACTIONS(5547),
    [anon_sym_SLASH_EQ] = ACTIONS(5547),
    [anon_sym_PERCENT_EQ] = ACTIONS(5547),
    [anon_sym_PLUS_EQ] = ACTIONS(5547),
    [anon_sym_DASH_EQ] = ACTIONS(5547),
    [anon_sym_LT_LT_EQ] = ACTIONS(5547),
    [anon_sym_GT_GT_EQ] = ACTIONS(5547),
    [anon_sym_AMP_EQ] = ACTIONS(5547),
    [anon_sym_CARET_EQ] = ACTIONS(5547),
    [anon_sym_PIPE_EQ] = ACTIONS(5547),
    [anon_sym_and_eq] = ACTIONS(5545),
    [anon_sym_or_eq] = ACTIONS(5545),
    [anon_sym_xor_eq] = ACTIONS(5545),
    [anon_sym_LT_EQ_GT] = ACTIONS(5547),
    [anon_sym_or] = ACTIONS(5545),
    [anon_sym_and] = ACTIONS(5545),
    [anon_sym_bitor] = ACTIONS(5545),
    [anon_sym_xor] = ACTIONS(5545),
    [anon_sym_bitand] = ACTIONS(5545),
    [anon_sym_not_eq] = ACTIONS(5545),
    [anon_sym_DASH_DASH] = ACTIONS(5547),
    [anon_sym_PLUS_PLUS] = ACTIONS(5547),
    [anon_sym_DOT] = ACTIONS(5545),
    [anon_sym_DOT_STAR] = ACTIONS(5547),
    [anon_sym_DASH_GT] = ACTIONS(5547),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5545),
    [anon_sym_decltype] = ACTIONS(5545),
  },
  [2181] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5456),
    [anon_sym_COMMA] = ACTIONS(5456),
    [anon_sym_RPAREN] = ACTIONS(5456),
    [anon_sym_LPAREN2] = ACTIONS(5456),
    [anon_sym_DASH] = ACTIONS(5454),
    [anon_sym_PLUS] = ACTIONS(5454),
    [anon_sym_STAR] = ACTIONS(5454),
    [anon_sym_SLASH] = ACTIONS(5454),
    [anon_sym_PERCENT] = ACTIONS(5454),
    [anon_sym_PIPE_PIPE] = ACTIONS(5456),
    [anon_sym_AMP_AMP] = ACTIONS(5456),
    [anon_sym_PIPE] = ACTIONS(5454),
    [anon_sym_CARET] = ACTIONS(5454),
    [anon_sym_AMP] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5456),
    [anon_sym_BANG_EQ] = ACTIONS(5456),
    [anon_sym_GT] = ACTIONS(5454),
    [anon_sym_GT_EQ] = ACTIONS(5456),
    [anon_sym_LT_EQ] = ACTIONS(5454),
    [anon_sym_LT] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5454),
    [anon_sym_SEMI] = ACTIONS(5456),
    [anon_sym_RBRACE] = ACTIONS(5456),
    [anon_sym_LBRACK] = ACTIONS(5456),
    [anon_sym_RBRACK] = ACTIONS(5456),
    [anon_sym_EQ] = ACTIONS(5454),
    [anon_sym_COLON] = ACTIONS(5456),
    [anon_sym_QMARK] = ACTIONS(5456),
    [anon_sym_STAR_EQ] = ACTIONS(5456),
    [anon_sym_SLASH_EQ] = ACTIONS(5456),
    [anon_sym_PERCENT_EQ] = ACTIONS(5456),
    [anon_sym_PLUS_EQ] = ACTIONS(5456),
    [anon_sym_DASH_EQ] = ACTIONS(5456),
    [anon_sym_LT_LT_EQ] = ACTIONS(5456),
    [anon_sym_GT_GT_EQ] = ACTIONS(5456),
    [anon_sym_AMP_EQ] = ACTIONS(5456),
    [anon_sym_CARET_EQ] = ACTIONS(5456),
    [anon_sym_PIPE_EQ] = ACTIONS(5456),
    [anon_sym_and_eq] = ACTIONS(5454),
    [anon_sym_or_eq] = ACTIONS(5454),
    [anon_sym_xor_eq] = ACTIONS(5454),
    [anon_sym_LT_EQ_GT] = ACTIONS(5456),
    [anon_sym_or] = ACTIONS(5454),
    [anon_sym_and] = ACTIONS(5454),
    [anon_sym_bitor] = ACTIONS(5454),
    [anon_sym_xor] = ACTIONS(5454),
    [anon_sym_bitand] = ACTIONS(5454),
    [anon_sym_not_eq] = ACTIONS(5454),
    [anon_sym_DASH_DASH] = ACTIONS(5456),
    [anon_sym_PLUS_PLUS] = ACTIONS(5456),
    [anon_sym_DOT] = ACTIONS(5454),
    [anon_sym_DOT_STAR] = ACTIONS(5456),
    [anon_sym_DASH_GT] = ACTIONS(5456),
    [anon_sym_L_DQUOTE] = ACTIONS(5456),
    [anon_sym_u_DQUOTE] = ACTIONS(5456),
    [anon_sym_U_DQUOTE] = ACTIONS(5456),
    [anon_sym_u8_DQUOTE] = ACTIONS(5456),
    [anon_sym_DQUOTE] = ACTIONS(5456),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5456),
    [anon_sym_LR_DQUOTE] = ACTIONS(5456),
    [anon_sym_uR_DQUOTE] = ACTIONS(5456),
    [anon_sym_UR_DQUOTE] = ACTIONS(5456),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5456),
    [sym_literal_suffix] = ACTIONS(5454),
  },
  [2182] = {
    [sym_identifier] = ACTIONS(6037),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6039),
    [anon_sym_COMMA] = ACTIONS(6039),
    [anon_sym_RPAREN] = ACTIONS(6039),
    [aux_sym_preproc_if_token2] = ACTIONS(6039),
    [aux_sym_preproc_else_token1] = ACTIONS(6039),
    [aux_sym_preproc_elif_token1] = ACTIONS(6037),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6039),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6039),
    [anon_sym_LPAREN2] = ACTIONS(6039),
    [anon_sym_DASH] = ACTIONS(6037),
    [anon_sym_PLUS] = ACTIONS(6037),
    [anon_sym_STAR] = ACTIONS(6037),
    [anon_sym_SLASH] = ACTIONS(6037),
    [anon_sym_PERCENT] = ACTIONS(6037),
    [anon_sym_PIPE_PIPE] = ACTIONS(6039),
    [anon_sym_AMP_AMP] = ACTIONS(6039),
    [anon_sym_PIPE] = ACTIONS(6037),
    [anon_sym_CARET] = ACTIONS(6037),
    [anon_sym_AMP] = ACTIONS(6037),
    [anon_sym_EQ_EQ] = ACTIONS(6039),
    [anon_sym_BANG_EQ] = ACTIONS(6039),
    [anon_sym_GT] = ACTIONS(6037),
    [anon_sym_GT_EQ] = ACTIONS(6039),
    [anon_sym_LT_EQ] = ACTIONS(6037),
    [anon_sym_LT] = ACTIONS(6037),
    [anon_sym_LT_LT] = ACTIONS(6037),
    [anon_sym_GT_GT] = ACTIONS(6037),
    [anon_sym_SEMI] = ACTIONS(6039),
    [anon_sym___attribute__] = ACTIONS(6037),
    [anon_sym___attribute] = ACTIONS(6037),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6039),
    [anon_sym_LBRACE] = ACTIONS(6039),
    [anon_sym_RBRACE] = ACTIONS(6039),
    [anon_sym_LBRACK] = ACTIONS(6037),
    [anon_sym_RBRACK] = ACTIONS(6039),
    [anon_sym_EQ] = ACTIONS(6037),
    [anon_sym_COLON] = ACTIONS(6039),
    [anon_sym_QMARK] = ACTIONS(6039),
    [anon_sym_STAR_EQ] = ACTIONS(6039),
    [anon_sym_SLASH_EQ] = ACTIONS(6039),
    [anon_sym_PERCENT_EQ] = ACTIONS(6039),
    [anon_sym_PLUS_EQ] = ACTIONS(6039),
    [anon_sym_DASH_EQ] = ACTIONS(6039),
    [anon_sym_LT_LT_EQ] = ACTIONS(6039),
    [anon_sym_GT_GT_EQ] = ACTIONS(6039),
    [anon_sym_AMP_EQ] = ACTIONS(6039),
    [anon_sym_CARET_EQ] = ACTIONS(6039),
    [anon_sym_PIPE_EQ] = ACTIONS(6039),
    [anon_sym_and_eq] = ACTIONS(6037),
    [anon_sym_or_eq] = ACTIONS(6037),
    [anon_sym_xor_eq] = ACTIONS(6037),
    [anon_sym_LT_EQ_GT] = ACTIONS(6039),
    [anon_sym_or] = ACTIONS(6037),
    [anon_sym_and] = ACTIONS(6037),
    [anon_sym_bitor] = ACTIONS(6037),
    [anon_sym_xor] = ACTIONS(6037),
    [anon_sym_bitand] = ACTIONS(6037),
    [anon_sym_not_eq] = ACTIONS(6037),
    [anon_sym_DASH_DASH] = ACTIONS(6039),
    [anon_sym_PLUS_PLUS] = ACTIONS(6039),
    [anon_sym_DOT] = ACTIONS(6037),
    [anon_sym_DOT_STAR] = ACTIONS(6039),
    [anon_sym_DASH_GT] = ACTIONS(6039),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6037),
  },
  [2183] = {
    [sym_identifier] = ACTIONS(5626),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5628),
    [anon_sym_COMMA] = ACTIONS(5628),
    [anon_sym_RPAREN] = ACTIONS(5628),
    [aux_sym_preproc_if_token2] = ACTIONS(5628),
    [aux_sym_preproc_else_token1] = ACTIONS(5628),
    [aux_sym_preproc_elif_token1] = ACTIONS(5626),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5628),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5628),
    [anon_sym_LPAREN2] = ACTIONS(5628),
    [anon_sym_DASH] = ACTIONS(5626),
    [anon_sym_PLUS] = ACTIONS(5626),
    [anon_sym_STAR] = ACTIONS(5626),
    [anon_sym_SLASH] = ACTIONS(5626),
    [anon_sym_PERCENT] = ACTIONS(5626),
    [anon_sym_PIPE_PIPE] = ACTIONS(5628),
    [anon_sym_AMP_AMP] = ACTIONS(5628),
    [anon_sym_PIPE] = ACTIONS(5626),
    [anon_sym_CARET] = ACTIONS(5626),
    [anon_sym_AMP] = ACTIONS(5626),
    [anon_sym_EQ_EQ] = ACTIONS(5628),
    [anon_sym_BANG_EQ] = ACTIONS(5628),
    [anon_sym_GT] = ACTIONS(5626),
    [anon_sym_GT_EQ] = ACTIONS(5628),
    [anon_sym_LT_EQ] = ACTIONS(5626),
    [anon_sym_LT] = ACTIONS(5626),
    [anon_sym_LT_LT] = ACTIONS(5626),
    [anon_sym_GT_GT] = ACTIONS(5626),
    [anon_sym_SEMI] = ACTIONS(5628),
    [anon_sym___attribute__] = ACTIONS(5626),
    [anon_sym___attribute] = ACTIONS(5626),
    [anon_sym_LBRACE] = ACTIONS(5628),
    [anon_sym_RBRACE] = ACTIONS(5628),
    [anon_sym_LBRACK] = ACTIONS(5628),
    [anon_sym_RBRACK] = ACTIONS(5628),
    [anon_sym_EQ] = ACTIONS(5626),
    [anon_sym_COLON] = ACTIONS(5628),
    [anon_sym_QMARK] = ACTIONS(5628),
    [anon_sym_STAR_EQ] = ACTIONS(5628),
    [anon_sym_SLASH_EQ] = ACTIONS(5628),
    [anon_sym_PERCENT_EQ] = ACTIONS(5628),
    [anon_sym_PLUS_EQ] = ACTIONS(5628),
    [anon_sym_DASH_EQ] = ACTIONS(5628),
    [anon_sym_LT_LT_EQ] = ACTIONS(5628),
    [anon_sym_GT_GT_EQ] = ACTIONS(5628),
    [anon_sym_AMP_EQ] = ACTIONS(5628),
    [anon_sym_CARET_EQ] = ACTIONS(5628),
    [anon_sym_PIPE_EQ] = ACTIONS(5628),
    [anon_sym_and_eq] = ACTIONS(5626),
    [anon_sym_or_eq] = ACTIONS(5626),
    [anon_sym_xor_eq] = ACTIONS(5626),
    [anon_sym_LT_EQ_GT] = ACTIONS(5628),
    [anon_sym_or] = ACTIONS(5626),
    [anon_sym_and] = ACTIONS(5626),
    [anon_sym_bitor] = ACTIONS(5626),
    [anon_sym_xor] = ACTIONS(5626),
    [anon_sym_bitand] = ACTIONS(5626),
    [anon_sym_not_eq] = ACTIONS(5626),
    [anon_sym_DASH_DASH] = ACTIONS(5628),
    [anon_sym_PLUS_PLUS] = ACTIONS(5628),
    [anon_sym_DOT] = ACTIONS(5626),
    [anon_sym_DOT_STAR] = ACTIONS(5628),
    [anon_sym_DASH_GT] = ACTIONS(5628),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5626),
    [anon_sym_decltype] = ACTIONS(5626),
  },
  [2184] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2249),
    [sym_identifier] = ACTIONS(5752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5750),
    [anon_sym_COMMA] = ACTIONS(5750),
    [aux_sym_preproc_if_token2] = ACTIONS(5750),
    [aux_sym_preproc_else_token1] = ACTIONS(5750),
    [aux_sym_preproc_elif_token1] = ACTIONS(5752),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5750),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5750),
    [anon_sym_LPAREN2] = ACTIONS(5750),
    [anon_sym_DASH] = ACTIONS(5752),
    [anon_sym_PLUS] = ACTIONS(5752),
    [anon_sym_STAR] = ACTIONS(5752),
    [anon_sym_SLASH] = ACTIONS(5752),
    [anon_sym_PERCENT] = ACTIONS(5752),
    [anon_sym_PIPE_PIPE] = ACTIONS(5750),
    [anon_sym_AMP_AMP] = ACTIONS(5750),
    [anon_sym_PIPE] = ACTIONS(5752),
    [anon_sym_CARET] = ACTIONS(5752),
    [anon_sym_AMP] = ACTIONS(5752),
    [anon_sym_EQ_EQ] = ACTIONS(5750),
    [anon_sym_BANG_EQ] = ACTIONS(5750),
    [anon_sym_GT] = ACTIONS(5752),
    [anon_sym_GT_EQ] = ACTIONS(5750),
    [anon_sym_LT_EQ] = ACTIONS(5752),
    [anon_sym_LT] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5752),
    [anon_sym_GT_GT] = ACTIONS(5752),
    [anon_sym___attribute__] = ACTIONS(5752),
    [anon_sym___attribute] = ACTIONS(5752),
    [anon_sym_LBRACE] = ACTIONS(5750),
    [anon_sym_signed] = ACTIONS(6025),
    [anon_sym_unsigned] = ACTIONS(6025),
    [anon_sym_long] = ACTIONS(6025),
    [anon_sym_short] = ACTIONS(6025),
    [anon_sym_LBRACK] = ACTIONS(5750),
    [anon_sym_EQ] = ACTIONS(5752),
    [anon_sym_QMARK] = ACTIONS(5750),
    [anon_sym_STAR_EQ] = ACTIONS(5750),
    [anon_sym_SLASH_EQ] = ACTIONS(5750),
    [anon_sym_PERCENT_EQ] = ACTIONS(5750),
    [anon_sym_PLUS_EQ] = ACTIONS(5750),
    [anon_sym_DASH_EQ] = ACTIONS(5750),
    [anon_sym_LT_LT_EQ] = ACTIONS(5750),
    [anon_sym_GT_GT_EQ] = ACTIONS(5750),
    [anon_sym_AMP_EQ] = ACTIONS(5750),
    [anon_sym_CARET_EQ] = ACTIONS(5750),
    [anon_sym_PIPE_EQ] = ACTIONS(5750),
    [anon_sym_and_eq] = ACTIONS(5752),
    [anon_sym_or_eq] = ACTIONS(5752),
    [anon_sym_xor_eq] = ACTIONS(5752),
    [anon_sym_LT_EQ_GT] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5752),
    [anon_sym_and] = ACTIONS(5752),
    [anon_sym_bitor] = ACTIONS(5752),
    [anon_sym_xor] = ACTIONS(5752),
    [anon_sym_bitand] = ACTIONS(5752),
    [anon_sym_not_eq] = ACTIONS(5752),
    [anon_sym_DASH_DASH] = ACTIONS(5750),
    [anon_sym_PLUS_PLUS] = ACTIONS(5750),
    [anon_sym_DOT] = ACTIONS(5752),
    [anon_sym_DOT_STAR] = ACTIONS(5750),
    [anon_sym_DASH_GT] = ACTIONS(5750),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5752),
    [anon_sym_decltype] = ACTIONS(5752),
  },
  [2185] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2249),
    [sym_identifier] = ACTIONS(5758),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5756),
    [anon_sym_COMMA] = ACTIONS(5756),
    [aux_sym_preproc_if_token2] = ACTIONS(5756),
    [aux_sym_preproc_else_token1] = ACTIONS(5756),
    [aux_sym_preproc_elif_token1] = ACTIONS(5758),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5756),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5756),
    [anon_sym_LPAREN2] = ACTIONS(5756),
    [anon_sym_DASH] = ACTIONS(5758),
    [anon_sym_PLUS] = ACTIONS(5758),
    [anon_sym_STAR] = ACTIONS(5758),
    [anon_sym_SLASH] = ACTIONS(5758),
    [anon_sym_PERCENT] = ACTIONS(5758),
    [anon_sym_PIPE_PIPE] = ACTIONS(5756),
    [anon_sym_AMP_AMP] = ACTIONS(5756),
    [anon_sym_PIPE] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5758),
    [anon_sym_AMP] = ACTIONS(5758),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5756),
    [anon_sym_GT] = ACTIONS(5758),
    [anon_sym_GT_EQ] = ACTIONS(5756),
    [anon_sym_LT_EQ] = ACTIONS(5758),
    [anon_sym_LT] = ACTIONS(5758),
    [anon_sym_LT_LT] = ACTIONS(5758),
    [anon_sym_GT_GT] = ACTIONS(5758),
    [anon_sym___attribute__] = ACTIONS(5758),
    [anon_sym___attribute] = ACTIONS(5758),
    [anon_sym_LBRACE] = ACTIONS(5756),
    [anon_sym_signed] = ACTIONS(6025),
    [anon_sym_unsigned] = ACTIONS(6025),
    [anon_sym_long] = ACTIONS(6025),
    [anon_sym_short] = ACTIONS(6025),
    [anon_sym_LBRACK] = ACTIONS(5756),
    [anon_sym_EQ] = ACTIONS(5758),
    [anon_sym_QMARK] = ACTIONS(5756),
    [anon_sym_STAR_EQ] = ACTIONS(5756),
    [anon_sym_SLASH_EQ] = ACTIONS(5756),
    [anon_sym_PERCENT_EQ] = ACTIONS(5756),
    [anon_sym_PLUS_EQ] = ACTIONS(5756),
    [anon_sym_DASH_EQ] = ACTIONS(5756),
    [anon_sym_LT_LT_EQ] = ACTIONS(5756),
    [anon_sym_GT_GT_EQ] = ACTIONS(5756),
    [anon_sym_AMP_EQ] = ACTIONS(5756),
    [anon_sym_CARET_EQ] = ACTIONS(5756),
    [anon_sym_PIPE_EQ] = ACTIONS(5756),
    [anon_sym_and_eq] = ACTIONS(5758),
    [anon_sym_or_eq] = ACTIONS(5758),
    [anon_sym_xor_eq] = ACTIONS(5758),
    [anon_sym_LT_EQ_GT] = ACTIONS(5756),
    [anon_sym_or] = ACTIONS(5758),
    [anon_sym_and] = ACTIONS(5758),
    [anon_sym_bitor] = ACTIONS(5758),
    [anon_sym_xor] = ACTIONS(5758),
    [anon_sym_bitand] = ACTIONS(5758),
    [anon_sym_not_eq] = ACTIONS(5758),
    [anon_sym_DASH_DASH] = ACTIONS(5756),
    [anon_sym_PLUS_PLUS] = ACTIONS(5756),
    [anon_sym_DOT] = ACTIONS(5758),
    [anon_sym_DOT_STAR] = ACTIONS(5756),
    [anon_sym_DASH_GT] = ACTIONS(5756),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5758),
    [anon_sym_decltype] = ACTIONS(5758),
  },
  [2186] = {
    [sym_identifier] = ACTIONS(6041),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6043),
    [anon_sym_COMMA] = ACTIONS(6043),
    [anon_sym_RPAREN] = ACTIONS(6043),
    [aux_sym_preproc_if_token2] = ACTIONS(6043),
    [aux_sym_preproc_else_token1] = ACTIONS(6043),
    [aux_sym_preproc_elif_token1] = ACTIONS(6041),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6043),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6043),
    [anon_sym_LPAREN2] = ACTIONS(6043),
    [anon_sym_DASH] = ACTIONS(6041),
    [anon_sym_PLUS] = ACTIONS(6041),
    [anon_sym_STAR] = ACTIONS(6041),
    [anon_sym_SLASH] = ACTIONS(6041),
    [anon_sym_PERCENT] = ACTIONS(6041),
    [anon_sym_PIPE_PIPE] = ACTIONS(6043),
    [anon_sym_AMP_AMP] = ACTIONS(6043),
    [anon_sym_PIPE] = ACTIONS(6041),
    [anon_sym_CARET] = ACTIONS(6041),
    [anon_sym_AMP] = ACTIONS(6041),
    [anon_sym_EQ_EQ] = ACTIONS(6043),
    [anon_sym_BANG_EQ] = ACTIONS(6043),
    [anon_sym_GT] = ACTIONS(6041),
    [anon_sym_GT_EQ] = ACTIONS(6043),
    [anon_sym_LT_EQ] = ACTIONS(6041),
    [anon_sym_LT] = ACTIONS(6041),
    [anon_sym_LT_LT] = ACTIONS(6041),
    [anon_sym_GT_GT] = ACTIONS(6041),
    [anon_sym_SEMI] = ACTIONS(6043),
    [anon_sym___attribute__] = ACTIONS(6041),
    [anon_sym___attribute] = ACTIONS(6041),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6043),
    [anon_sym_LBRACE] = ACTIONS(6043),
    [anon_sym_RBRACE] = ACTIONS(6043),
    [anon_sym_LBRACK] = ACTIONS(6041),
    [anon_sym_RBRACK] = ACTIONS(6043),
    [anon_sym_EQ] = ACTIONS(6041),
    [anon_sym_COLON] = ACTIONS(6043),
    [anon_sym_QMARK] = ACTIONS(6043),
    [anon_sym_STAR_EQ] = ACTIONS(6043),
    [anon_sym_SLASH_EQ] = ACTIONS(6043),
    [anon_sym_PERCENT_EQ] = ACTIONS(6043),
    [anon_sym_PLUS_EQ] = ACTIONS(6043),
    [anon_sym_DASH_EQ] = ACTIONS(6043),
    [anon_sym_LT_LT_EQ] = ACTIONS(6043),
    [anon_sym_GT_GT_EQ] = ACTIONS(6043),
    [anon_sym_AMP_EQ] = ACTIONS(6043),
    [anon_sym_CARET_EQ] = ACTIONS(6043),
    [anon_sym_PIPE_EQ] = ACTIONS(6043),
    [anon_sym_and_eq] = ACTIONS(6041),
    [anon_sym_or_eq] = ACTIONS(6041),
    [anon_sym_xor_eq] = ACTIONS(6041),
    [anon_sym_LT_EQ_GT] = ACTIONS(6043),
    [anon_sym_or] = ACTIONS(6041),
    [anon_sym_and] = ACTIONS(6041),
    [anon_sym_bitor] = ACTIONS(6041),
    [anon_sym_xor] = ACTIONS(6041),
    [anon_sym_bitand] = ACTIONS(6041),
    [anon_sym_not_eq] = ACTIONS(6041),
    [anon_sym_DASH_DASH] = ACTIONS(6043),
    [anon_sym_PLUS_PLUS] = ACTIONS(6043),
    [anon_sym_DOT] = ACTIONS(6041),
    [anon_sym_DOT_STAR] = ACTIONS(6043),
    [anon_sym_DASH_GT] = ACTIONS(6043),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6041),
  },
  [2187] = {
    [sym_identifier] = ACTIONS(6045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6047),
    [anon_sym_COMMA] = ACTIONS(6047),
    [anon_sym_RPAREN] = ACTIONS(6047),
    [aux_sym_preproc_if_token2] = ACTIONS(6047),
    [aux_sym_preproc_else_token1] = ACTIONS(6047),
    [aux_sym_preproc_elif_token1] = ACTIONS(6045),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6047),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6047),
    [anon_sym_LPAREN2] = ACTIONS(6047),
    [anon_sym_DASH] = ACTIONS(6045),
    [anon_sym_PLUS] = ACTIONS(6045),
    [anon_sym_STAR] = ACTIONS(6045),
    [anon_sym_SLASH] = ACTIONS(6045),
    [anon_sym_PERCENT] = ACTIONS(6045),
    [anon_sym_PIPE_PIPE] = ACTIONS(6047),
    [anon_sym_AMP_AMP] = ACTIONS(6047),
    [anon_sym_PIPE] = ACTIONS(6045),
    [anon_sym_CARET] = ACTIONS(6045),
    [anon_sym_AMP] = ACTIONS(6045),
    [anon_sym_EQ_EQ] = ACTIONS(6047),
    [anon_sym_BANG_EQ] = ACTIONS(6047),
    [anon_sym_GT] = ACTIONS(6045),
    [anon_sym_GT_EQ] = ACTIONS(6047),
    [anon_sym_LT_EQ] = ACTIONS(6045),
    [anon_sym_LT] = ACTIONS(6045),
    [anon_sym_LT_LT] = ACTIONS(6045),
    [anon_sym_GT_GT] = ACTIONS(6045),
    [anon_sym_SEMI] = ACTIONS(6047),
    [anon_sym___attribute__] = ACTIONS(6045),
    [anon_sym___attribute] = ACTIONS(6045),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6047),
    [anon_sym_LBRACE] = ACTIONS(6047),
    [anon_sym_RBRACE] = ACTIONS(6047),
    [anon_sym_LBRACK] = ACTIONS(6045),
    [anon_sym_RBRACK] = ACTIONS(6047),
    [anon_sym_EQ] = ACTIONS(6045),
    [anon_sym_COLON] = ACTIONS(6047),
    [anon_sym_QMARK] = ACTIONS(6047),
    [anon_sym_STAR_EQ] = ACTIONS(6047),
    [anon_sym_SLASH_EQ] = ACTIONS(6047),
    [anon_sym_PERCENT_EQ] = ACTIONS(6047),
    [anon_sym_PLUS_EQ] = ACTIONS(6047),
    [anon_sym_DASH_EQ] = ACTIONS(6047),
    [anon_sym_LT_LT_EQ] = ACTIONS(6047),
    [anon_sym_GT_GT_EQ] = ACTIONS(6047),
    [anon_sym_AMP_EQ] = ACTIONS(6047),
    [anon_sym_CARET_EQ] = ACTIONS(6047),
    [anon_sym_PIPE_EQ] = ACTIONS(6047),
    [anon_sym_and_eq] = ACTIONS(6045),
    [anon_sym_or_eq] = ACTIONS(6045),
    [anon_sym_xor_eq] = ACTIONS(6045),
    [anon_sym_LT_EQ_GT] = ACTIONS(6047),
    [anon_sym_or] = ACTIONS(6045),
    [anon_sym_and] = ACTIONS(6045),
    [anon_sym_bitor] = ACTIONS(6045),
    [anon_sym_xor] = ACTIONS(6045),
    [anon_sym_bitand] = ACTIONS(6045),
    [anon_sym_not_eq] = ACTIONS(6045),
    [anon_sym_DASH_DASH] = ACTIONS(6047),
    [anon_sym_PLUS_PLUS] = ACTIONS(6047),
    [anon_sym_DOT] = ACTIONS(6045),
    [anon_sym_DOT_STAR] = ACTIONS(6047),
    [anon_sym_DASH_GT] = ACTIONS(6047),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6045),
  },
  [2188] = {
    [sym_identifier] = ACTIONS(5668),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5670),
    [anon_sym_COMMA] = ACTIONS(5670),
    [anon_sym_RPAREN] = ACTIONS(5670),
    [aux_sym_preproc_if_token2] = ACTIONS(5670),
    [aux_sym_preproc_else_token1] = ACTIONS(5670),
    [aux_sym_preproc_elif_token1] = ACTIONS(5668),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5670),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5670),
    [anon_sym_LPAREN2] = ACTIONS(5670),
    [anon_sym_DASH] = ACTIONS(5668),
    [anon_sym_PLUS] = ACTIONS(5668),
    [anon_sym_STAR] = ACTIONS(5668),
    [anon_sym_SLASH] = ACTIONS(5668),
    [anon_sym_PERCENT] = ACTIONS(5668),
    [anon_sym_PIPE_PIPE] = ACTIONS(5670),
    [anon_sym_AMP_AMP] = ACTIONS(5670),
    [anon_sym_PIPE] = ACTIONS(5668),
    [anon_sym_CARET] = ACTIONS(5668),
    [anon_sym_AMP] = ACTIONS(5668),
    [anon_sym_EQ_EQ] = ACTIONS(5670),
    [anon_sym_BANG_EQ] = ACTIONS(5670),
    [anon_sym_GT] = ACTIONS(5668),
    [anon_sym_GT_EQ] = ACTIONS(5670),
    [anon_sym_LT_EQ] = ACTIONS(5668),
    [anon_sym_LT] = ACTIONS(5668),
    [anon_sym_LT_LT] = ACTIONS(5668),
    [anon_sym_GT_GT] = ACTIONS(5668),
    [anon_sym_SEMI] = ACTIONS(5670),
    [anon_sym___attribute__] = ACTIONS(5668),
    [anon_sym___attribute] = ACTIONS(5668),
    [anon_sym_LBRACE] = ACTIONS(5670),
    [anon_sym_RBRACE] = ACTIONS(5670),
    [anon_sym_LBRACK] = ACTIONS(5670),
    [anon_sym_RBRACK] = ACTIONS(5670),
    [anon_sym_EQ] = ACTIONS(5668),
    [anon_sym_COLON] = ACTIONS(5670),
    [anon_sym_QMARK] = ACTIONS(5670),
    [anon_sym_STAR_EQ] = ACTIONS(5670),
    [anon_sym_SLASH_EQ] = ACTIONS(5670),
    [anon_sym_PERCENT_EQ] = ACTIONS(5670),
    [anon_sym_PLUS_EQ] = ACTIONS(5670),
    [anon_sym_DASH_EQ] = ACTIONS(5670),
    [anon_sym_LT_LT_EQ] = ACTIONS(5670),
    [anon_sym_GT_GT_EQ] = ACTIONS(5670),
    [anon_sym_AMP_EQ] = ACTIONS(5670),
    [anon_sym_CARET_EQ] = ACTIONS(5670),
    [anon_sym_PIPE_EQ] = ACTIONS(5670),
    [anon_sym_and_eq] = ACTIONS(5668),
    [anon_sym_or_eq] = ACTIONS(5668),
    [anon_sym_xor_eq] = ACTIONS(5668),
    [anon_sym_LT_EQ_GT] = ACTIONS(5670),
    [anon_sym_or] = ACTIONS(5668),
    [anon_sym_and] = ACTIONS(5668),
    [anon_sym_bitor] = ACTIONS(5668),
    [anon_sym_xor] = ACTIONS(5668),
    [anon_sym_bitand] = ACTIONS(5668),
    [anon_sym_not_eq] = ACTIONS(5668),
    [anon_sym_DASH_DASH] = ACTIONS(5670),
    [anon_sym_PLUS_PLUS] = ACTIONS(5670),
    [anon_sym_DOT] = ACTIONS(5668),
    [anon_sym_DOT_STAR] = ACTIONS(5670),
    [anon_sym_DASH_GT] = ACTIONS(5670),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5668),
    [anon_sym_decltype] = ACTIONS(5668),
  },
  [2189] = {
    [sym_identifier] = ACTIONS(6049),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6051),
    [anon_sym_COMMA] = ACTIONS(6051),
    [anon_sym_RPAREN] = ACTIONS(6051),
    [aux_sym_preproc_if_token2] = ACTIONS(6051),
    [aux_sym_preproc_else_token1] = ACTIONS(6051),
    [aux_sym_preproc_elif_token1] = ACTIONS(6049),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6051),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6051),
    [anon_sym_LPAREN2] = ACTIONS(6051),
    [anon_sym_DASH] = ACTIONS(6049),
    [anon_sym_PLUS] = ACTIONS(6049),
    [anon_sym_STAR] = ACTIONS(6049),
    [anon_sym_SLASH] = ACTIONS(6049),
    [anon_sym_PERCENT] = ACTIONS(6049),
    [anon_sym_PIPE_PIPE] = ACTIONS(6051),
    [anon_sym_AMP_AMP] = ACTIONS(6051),
    [anon_sym_PIPE] = ACTIONS(6049),
    [anon_sym_CARET] = ACTIONS(6049),
    [anon_sym_AMP] = ACTIONS(6049),
    [anon_sym_EQ_EQ] = ACTIONS(6051),
    [anon_sym_BANG_EQ] = ACTIONS(6051),
    [anon_sym_GT] = ACTIONS(6049),
    [anon_sym_GT_EQ] = ACTIONS(6051),
    [anon_sym_LT_EQ] = ACTIONS(6049),
    [anon_sym_LT] = ACTIONS(6049),
    [anon_sym_LT_LT] = ACTIONS(6049),
    [anon_sym_GT_GT] = ACTIONS(6049),
    [anon_sym_SEMI] = ACTIONS(6051),
    [anon_sym___attribute__] = ACTIONS(6049),
    [anon_sym___attribute] = ACTIONS(6049),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6051),
    [anon_sym_LBRACE] = ACTIONS(6051),
    [anon_sym_RBRACE] = ACTIONS(6051),
    [anon_sym_LBRACK] = ACTIONS(6049),
    [anon_sym_RBRACK] = ACTIONS(6051),
    [anon_sym_EQ] = ACTIONS(6049),
    [anon_sym_COLON] = ACTIONS(6051),
    [anon_sym_QMARK] = ACTIONS(6051),
    [anon_sym_STAR_EQ] = ACTIONS(6051),
    [anon_sym_SLASH_EQ] = ACTIONS(6051),
    [anon_sym_PERCENT_EQ] = ACTIONS(6051),
    [anon_sym_PLUS_EQ] = ACTIONS(6051),
    [anon_sym_DASH_EQ] = ACTIONS(6051),
    [anon_sym_LT_LT_EQ] = ACTIONS(6051),
    [anon_sym_GT_GT_EQ] = ACTIONS(6051),
    [anon_sym_AMP_EQ] = ACTIONS(6051),
    [anon_sym_CARET_EQ] = ACTIONS(6051),
    [anon_sym_PIPE_EQ] = ACTIONS(6051),
    [anon_sym_and_eq] = ACTIONS(6049),
    [anon_sym_or_eq] = ACTIONS(6049),
    [anon_sym_xor_eq] = ACTIONS(6049),
    [anon_sym_LT_EQ_GT] = ACTIONS(6051),
    [anon_sym_or] = ACTIONS(6049),
    [anon_sym_and] = ACTIONS(6049),
    [anon_sym_bitor] = ACTIONS(6049),
    [anon_sym_xor] = ACTIONS(6049),
    [anon_sym_bitand] = ACTIONS(6049),
    [anon_sym_not_eq] = ACTIONS(6049),
    [anon_sym_DASH_DASH] = ACTIONS(6051),
    [anon_sym_PLUS_PLUS] = ACTIONS(6051),
    [anon_sym_DOT] = ACTIONS(6049),
    [anon_sym_DOT_STAR] = ACTIONS(6051),
    [anon_sym_DASH_GT] = ACTIONS(6051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6049),
  },
  [2190] = {
    [sym_argument_list] = STATE(2443),
    [sym_initializer_list] = STATE(2443),
    [sym_identifier] = ACTIONS(6053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6055),
    [anon_sym_COMMA] = ACTIONS(6055),
    [anon_sym_RPAREN] = ACTIONS(6055),
    [aux_sym_preproc_if_token2] = ACTIONS(6055),
    [aux_sym_preproc_else_token1] = ACTIONS(6055),
    [aux_sym_preproc_elif_token1] = ACTIONS(6053),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6055),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6055),
    [anon_sym_LPAREN2] = ACTIONS(5688),
    [anon_sym_DASH] = ACTIONS(6053),
    [anon_sym_PLUS] = ACTIONS(6053),
    [anon_sym_STAR] = ACTIONS(6053),
    [anon_sym_SLASH] = ACTIONS(6053),
    [anon_sym_PERCENT] = ACTIONS(6053),
    [anon_sym_PIPE_PIPE] = ACTIONS(6055),
    [anon_sym_AMP_AMP] = ACTIONS(6055),
    [anon_sym_PIPE] = ACTIONS(6053),
    [anon_sym_CARET] = ACTIONS(6053),
    [anon_sym_AMP] = ACTIONS(6053),
    [anon_sym_EQ_EQ] = ACTIONS(6055),
    [anon_sym_BANG_EQ] = ACTIONS(6055),
    [anon_sym_GT] = ACTIONS(6053),
    [anon_sym_GT_EQ] = ACTIONS(6055),
    [anon_sym_LT_EQ] = ACTIONS(6053),
    [anon_sym_LT] = ACTIONS(6053),
    [anon_sym_LT_LT] = ACTIONS(6053),
    [anon_sym_GT_GT] = ACTIONS(6053),
    [anon_sym_SEMI] = ACTIONS(6055),
    [anon_sym___attribute__] = ACTIONS(6053),
    [anon_sym___attribute] = ACTIONS(6053),
    [anon_sym_LBRACE] = ACTIONS(1927),
    [anon_sym_RBRACE] = ACTIONS(6055),
    [anon_sym_LBRACK] = ACTIONS(6055),
    [anon_sym_RBRACK] = ACTIONS(6055),
    [anon_sym_EQ] = ACTIONS(6053),
    [anon_sym_COLON] = ACTIONS(6055),
    [anon_sym_QMARK] = ACTIONS(6055),
    [anon_sym_STAR_EQ] = ACTIONS(6055),
    [anon_sym_SLASH_EQ] = ACTIONS(6055),
    [anon_sym_PERCENT_EQ] = ACTIONS(6055),
    [anon_sym_PLUS_EQ] = ACTIONS(6055),
    [anon_sym_DASH_EQ] = ACTIONS(6055),
    [anon_sym_LT_LT_EQ] = ACTIONS(6055),
    [anon_sym_GT_GT_EQ] = ACTIONS(6055),
    [anon_sym_AMP_EQ] = ACTIONS(6055),
    [anon_sym_CARET_EQ] = ACTIONS(6055),
    [anon_sym_PIPE_EQ] = ACTIONS(6055),
    [anon_sym_and_eq] = ACTIONS(6053),
    [anon_sym_or_eq] = ACTIONS(6053),
    [anon_sym_xor_eq] = ACTIONS(6053),
    [anon_sym_LT_EQ_GT] = ACTIONS(6055),
    [anon_sym_or] = ACTIONS(6053),
    [anon_sym_and] = ACTIONS(6053),
    [anon_sym_bitor] = ACTIONS(6053),
    [anon_sym_xor] = ACTIONS(6053),
    [anon_sym_bitand] = ACTIONS(6053),
    [anon_sym_not_eq] = ACTIONS(6053),
    [anon_sym_DASH_DASH] = ACTIONS(6055),
    [anon_sym_PLUS_PLUS] = ACTIONS(6055),
    [anon_sym_DOT] = ACTIONS(6053),
    [anon_sym_DOT_STAR] = ACTIONS(6055),
    [anon_sym_DASH_GT] = ACTIONS(6055),
    [sym_comment] = ACTIONS(3),
  },
  [2191] = {
    [sym_identifier] = ACTIONS(6057),
    [anon_sym_LPAREN2] = ACTIONS(6059),
    [anon_sym_TILDE] = ACTIONS(6059),
    [anon_sym_STAR] = ACTIONS(6059),
    [anon_sym_PIPE_PIPE] = ACTIONS(6059),
    [anon_sym_AMP_AMP] = ACTIONS(6061),
    [anon_sym_AMP] = ACTIONS(6057),
    [anon_sym___extension__] = ACTIONS(6057),
    [anon_sym_virtual] = ACTIONS(6057),
    [anon_sym_extern] = ACTIONS(6057),
    [anon_sym___attribute__] = ACTIONS(6057),
    [anon_sym___attribute] = ACTIONS(6057),
    [anon_sym_COLON_COLON] = ACTIONS(6059),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6059),
    [anon_sym___declspec] = ACTIONS(6057),
    [anon_sym___based] = ACTIONS(6057),
    [anon_sym___cdecl] = ACTIONS(6057),
    [anon_sym___clrcall] = ACTIONS(6057),
    [anon_sym___stdcall] = ACTIONS(6057),
    [anon_sym___fastcall] = ACTIONS(6057),
    [anon_sym___thiscall] = ACTIONS(6057),
    [anon_sym___vectorcall] = ACTIONS(6057),
    [anon_sym_signed] = ACTIONS(6057),
    [anon_sym_unsigned] = ACTIONS(6057),
    [anon_sym_long] = ACTIONS(6057),
    [anon_sym_short] = ACTIONS(6057),
    [anon_sym_LBRACK] = ACTIONS(6057),
    [anon_sym_static] = ACTIONS(6057),
    [anon_sym_register] = ACTIONS(6057),
    [anon_sym_inline] = ACTIONS(6057),
    [anon_sym___inline] = ACTIONS(6057),
    [anon_sym___inline__] = ACTIONS(6057),
    [anon_sym___forceinline] = ACTIONS(6057),
    [anon_sym_thread_local] = ACTIONS(6057),
    [anon_sym___thread] = ACTIONS(6057),
    [anon_sym_const] = ACTIONS(6057),
    [anon_sym_constexpr] = ACTIONS(6057),
    [anon_sym_volatile] = ACTIONS(6057),
    [anon_sym_restrict] = ACTIONS(6057),
    [anon_sym___restrict__] = ACTIONS(6057),
    [anon_sym__Atomic] = ACTIONS(6057),
    [anon_sym__Noreturn] = ACTIONS(6057),
    [anon_sym_noreturn] = ACTIONS(6057),
    [anon_sym__Nonnull] = ACTIONS(6057),
    [anon_sym_mutable] = ACTIONS(6057),
    [anon_sym_constinit] = ACTIONS(6057),
    [anon_sym_consteval] = ACTIONS(6057),
    [anon_sym_alignas] = ACTIONS(6057),
    [anon_sym__Alignas] = ACTIONS(6057),
    [sym_primitive_type] = ACTIONS(6057),
    [anon_sym_enum] = ACTIONS(6057),
    [anon_sym_class] = ACTIONS(6057),
    [anon_sym_struct] = ACTIONS(6057),
    [anon_sym_union] = ACTIONS(6057),
    [anon_sym_or] = ACTIONS(6057),
    [anon_sym_and] = ACTIONS(6063),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6057),
    [anon_sym_decltype] = ACTIONS(6057),
    [anon_sym_explicit] = ACTIONS(6057),
    [anon_sym_typename] = ACTIONS(6057),
    [anon_sym_template] = ACTIONS(6057),
    [anon_sym_operator] = ACTIONS(6057),
    [anon_sym_friend] = ACTIONS(6057),
    [anon_sym_using] = ACTIONS(6057),
    [anon_sym_concept] = ACTIONS(6057),
  },
  [2192] = {
    [sym_identifier] = ACTIONS(1913),
    [anon_sym_LPAREN2] = ACTIONS(1911),
    [anon_sym_TILDE] = ACTIONS(1911),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_PIPE_PIPE] = ACTIONS(1911),
    [anon_sym_AMP_AMP] = ACTIONS(1911),
    [anon_sym_AMP] = ACTIONS(1913),
    [anon_sym___extension__] = ACTIONS(1913),
    [anon_sym_virtual] = ACTIONS(1913),
    [anon_sym_extern] = ACTIONS(1913),
    [anon_sym___attribute__] = ACTIONS(1913),
    [anon_sym___attribute] = ACTIONS(1913),
    [anon_sym_COLON_COLON] = ACTIONS(1911),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1911),
    [anon_sym___declspec] = ACTIONS(1913),
    [anon_sym___based] = ACTIONS(1913),
    [anon_sym___cdecl] = ACTIONS(1913),
    [anon_sym___clrcall] = ACTIONS(1913),
    [anon_sym___stdcall] = ACTIONS(1913),
    [anon_sym___fastcall] = ACTIONS(1913),
    [anon_sym___thiscall] = ACTIONS(1913),
    [anon_sym___vectorcall] = ACTIONS(1913),
    [anon_sym_signed] = ACTIONS(1913),
    [anon_sym_unsigned] = ACTIONS(1913),
    [anon_sym_long] = ACTIONS(1913),
    [anon_sym_short] = ACTIONS(1913),
    [anon_sym_LBRACK] = ACTIONS(1913),
    [anon_sym_static] = ACTIONS(1913),
    [anon_sym_register] = ACTIONS(1913),
    [anon_sym_inline] = ACTIONS(1913),
    [anon_sym___inline] = ACTIONS(1913),
    [anon_sym___inline__] = ACTIONS(1913),
    [anon_sym___forceinline] = ACTIONS(1913),
    [anon_sym_thread_local] = ACTIONS(1913),
    [anon_sym___thread] = ACTIONS(1913),
    [anon_sym_const] = ACTIONS(1913),
    [anon_sym_constexpr] = ACTIONS(1913),
    [anon_sym_volatile] = ACTIONS(1913),
    [anon_sym_restrict] = ACTIONS(1913),
    [anon_sym___restrict__] = ACTIONS(1913),
    [anon_sym__Atomic] = ACTIONS(1913),
    [anon_sym__Noreturn] = ACTIONS(1913),
    [anon_sym_noreturn] = ACTIONS(1913),
    [anon_sym__Nonnull] = ACTIONS(1913),
    [anon_sym_mutable] = ACTIONS(1913),
    [anon_sym_constinit] = ACTIONS(1913),
    [anon_sym_consteval] = ACTIONS(1913),
    [anon_sym_alignas] = ACTIONS(1913),
    [anon_sym__Alignas] = ACTIONS(1913),
    [sym_primitive_type] = ACTIONS(1913),
    [anon_sym_enum] = ACTIONS(1913),
    [anon_sym_class] = ACTIONS(1913),
    [anon_sym_struct] = ACTIONS(1913),
    [anon_sym_union] = ACTIONS(1913),
    [anon_sym_or] = ACTIONS(1913),
    [anon_sym_and] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1913),
    [anon_sym_decltype] = ACTIONS(1913),
    [anon_sym_explicit] = ACTIONS(1913),
    [anon_sym_typename] = ACTIONS(1913),
    [anon_sym_template] = ACTIONS(1913),
    [anon_sym_operator] = ACTIONS(1913),
    [anon_sym_friend] = ACTIONS(1913),
    [anon_sym_using] = ACTIONS(1913),
    [anon_sym_concept] = ACTIONS(1913),
  },
  [2193] = {
    [sym_identifier] = ACTIONS(1909),
    [anon_sym_LPAREN2] = ACTIONS(1907),
    [anon_sym_TILDE] = ACTIONS(1907),
    [anon_sym_STAR] = ACTIONS(1907),
    [anon_sym_PIPE_PIPE] = ACTIONS(1907),
    [anon_sym_AMP_AMP] = ACTIONS(1907),
    [anon_sym_AMP] = ACTIONS(1909),
    [anon_sym___extension__] = ACTIONS(1909),
    [anon_sym_virtual] = ACTIONS(1909),
    [anon_sym_extern] = ACTIONS(1909),
    [anon_sym___attribute__] = ACTIONS(1909),
    [anon_sym___attribute] = ACTIONS(1909),
    [anon_sym_COLON_COLON] = ACTIONS(1907),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1907),
    [anon_sym___declspec] = ACTIONS(1909),
    [anon_sym___based] = ACTIONS(1909),
    [anon_sym___cdecl] = ACTIONS(1909),
    [anon_sym___clrcall] = ACTIONS(1909),
    [anon_sym___stdcall] = ACTIONS(1909),
    [anon_sym___fastcall] = ACTIONS(1909),
    [anon_sym___thiscall] = ACTIONS(1909),
    [anon_sym___vectorcall] = ACTIONS(1909),
    [anon_sym_signed] = ACTIONS(1909),
    [anon_sym_unsigned] = ACTIONS(1909),
    [anon_sym_long] = ACTIONS(1909),
    [anon_sym_short] = ACTIONS(1909),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_static] = ACTIONS(1909),
    [anon_sym_register] = ACTIONS(1909),
    [anon_sym_inline] = ACTIONS(1909),
    [anon_sym___inline] = ACTIONS(1909),
    [anon_sym___inline__] = ACTIONS(1909),
    [anon_sym___forceinline] = ACTIONS(1909),
    [anon_sym_thread_local] = ACTIONS(1909),
    [anon_sym___thread] = ACTIONS(1909),
    [anon_sym_const] = ACTIONS(1909),
    [anon_sym_constexpr] = ACTIONS(1909),
    [anon_sym_volatile] = ACTIONS(1909),
    [anon_sym_restrict] = ACTIONS(1909),
    [anon_sym___restrict__] = ACTIONS(1909),
    [anon_sym__Atomic] = ACTIONS(1909),
    [anon_sym__Noreturn] = ACTIONS(1909),
    [anon_sym_noreturn] = ACTIONS(1909),
    [anon_sym__Nonnull] = ACTIONS(1909),
    [anon_sym_mutable] = ACTIONS(1909),
    [anon_sym_constinit] = ACTIONS(1909),
    [anon_sym_consteval] = ACTIONS(1909),
    [anon_sym_alignas] = ACTIONS(1909),
    [anon_sym__Alignas] = ACTIONS(1909),
    [sym_primitive_type] = ACTIONS(1909),
    [anon_sym_enum] = ACTIONS(1909),
    [anon_sym_class] = ACTIONS(1909),
    [anon_sym_struct] = ACTIONS(1909),
    [anon_sym_union] = ACTIONS(1909),
    [anon_sym_or] = ACTIONS(1909),
    [anon_sym_and] = ACTIONS(1909),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(1909),
    [anon_sym_decltype] = ACTIONS(1909),
    [anon_sym_explicit] = ACTIONS(1909),
    [anon_sym_typename] = ACTIONS(1909),
    [anon_sym_template] = ACTIONS(1909),
    [anon_sym_operator] = ACTIONS(1909),
    [anon_sym_friend] = ACTIONS(1909),
    [anon_sym_using] = ACTIONS(1909),
    [anon_sym_concept] = ACTIONS(1909),
  },
  [2194] = {
    [sym_identifier] = ACTIONS(5676),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5678),
    [anon_sym_COMMA] = ACTIONS(5678),
    [anon_sym_RPAREN] = ACTIONS(5678),
    [aux_sym_preproc_if_token2] = ACTIONS(5678),
    [aux_sym_preproc_else_token1] = ACTIONS(5678),
    [aux_sym_preproc_elif_token1] = ACTIONS(5676),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5678),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5678),
    [anon_sym_LPAREN2] = ACTIONS(5678),
    [anon_sym_DASH] = ACTIONS(5676),
    [anon_sym_PLUS] = ACTIONS(5676),
    [anon_sym_STAR] = ACTIONS(5676),
    [anon_sym_SLASH] = ACTIONS(5676),
    [anon_sym_PERCENT] = ACTIONS(5676),
    [anon_sym_PIPE_PIPE] = ACTIONS(5678),
    [anon_sym_AMP_AMP] = ACTIONS(5678),
    [anon_sym_PIPE] = ACTIONS(5676),
    [anon_sym_CARET] = ACTIONS(5676),
    [anon_sym_AMP] = ACTIONS(5676),
    [anon_sym_EQ_EQ] = ACTIONS(5678),
    [anon_sym_BANG_EQ] = ACTIONS(5678),
    [anon_sym_GT] = ACTIONS(5676),
    [anon_sym_GT_EQ] = ACTIONS(5678),
    [anon_sym_LT_EQ] = ACTIONS(5676),
    [anon_sym_LT] = ACTIONS(5676),
    [anon_sym_LT_LT] = ACTIONS(5676),
    [anon_sym_GT_GT] = ACTIONS(5676),
    [anon_sym_SEMI] = ACTIONS(5678),
    [anon_sym___attribute__] = ACTIONS(5676),
    [anon_sym___attribute] = ACTIONS(5676),
    [anon_sym_LBRACE] = ACTIONS(5678),
    [anon_sym_RBRACE] = ACTIONS(5678),
    [anon_sym_LBRACK] = ACTIONS(5678),
    [anon_sym_RBRACK] = ACTIONS(5678),
    [anon_sym_EQ] = ACTIONS(5676),
    [anon_sym_COLON] = ACTIONS(5678),
    [anon_sym_QMARK] = ACTIONS(5678),
    [anon_sym_STAR_EQ] = ACTIONS(5678),
    [anon_sym_SLASH_EQ] = ACTIONS(5678),
    [anon_sym_PERCENT_EQ] = ACTIONS(5678),
    [anon_sym_PLUS_EQ] = ACTIONS(5678),
    [anon_sym_DASH_EQ] = ACTIONS(5678),
    [anon_sym_LT_LT_EQ] = ACTIONS(5678),
    [anon_sym_GT_GT_EQ] = ACTIONS(5678),
    [anon_sym_AMP_EQ] = ACTIONS(5678),
    [anon_sym_CARET_EQ] = ACTIONS(5678),
    [anon_sym_PIPE_EQ] = ACTIONS(5678),
    [anon_sym_and_eq] = ACTIONS(5676),
    [anon_sym_or_eq] = ACTIONS(5676),
    [anon_sym_xor_eq] = ACTIONS(5676),
    [anon_sym_LT_EQ_GT] = ACTIONS(5678),
    [anon_sym_or] = ACTIONS(5676),
    [anon_sym_and] = ACTIONS(5676),
    [anon_sym_bitor] = ACTIONS(5676),
    [anon_sym_xor] = ACTIONS(5676),
    [anon_sym_bitand] = ACTIONS(5676),
    [anon_sym_not_eq] = ACTIONS(5676),
    [anon_sym_DASH_DASH] = ACTIONS(5678),
    [anon_sym_PLUS_PLUS] = ACTIONS(5678),
    [anon_sym_DOT] = ACTIONS(5676),
    [anon_sym_DOT_STAR] = ACTIONS(5678),
    [anon_sym_DASH_GT] = ACTIONS(5678),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5676),
    [anon_sym_decltype] = ACTIONS(5676),
  },
  [2195] = {
    [sym_identifier] = ACTIONS(5568),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5570),
    [anon_sym_COMMA] = ACTIONS(5570),
    [anon_sym_RPAREN] = ACTIONS(5570),
    [aux_sym_preproc_if_token2] = ACTIONS(5570),
    [aux_sym_preproc_else_token1] = ACTIONS(5570),
    [aux_sym_preproc_elif_token1] = ACTIONS(5568),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5570),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5570),
    [anon_sym_LPAREN2] = ACTIONS(5570),
    [anon_sym_DASH] = ACTIONS(5568),
    [anon_sym_PLUS] = ACTIONS(5568),
    [anon_sym_STAR] = ACTIONS(5568),
    [anon_sym_SLASH] = ACTIONS(5568),
    [anon_sym_PERCENT] = ACTIONS(5568),
    [anon_sym_PIPE_PIPE] = ACTIONS(5570),
    [anon_sym_AMP_AMP] = ACTIONS(5570),
    [anon_sym_PIPE] = ACTIONS(5568),
    [anon_sym_CARET] = ACTIONS(5568),
    [anon_sym_AMP] = ACTIONS(5568),
    [anon_sym_EQ_EQ] = ACTIONS(5570),
    [anon_sym_BANG_EQ] = ACTIONS(5570),
    [anon_sym_GT] = ACTIONS(5568),
    [anon_sym_GT_EQ] = ACTIONS(5570),
    [anon_sym_LT_EQ] = ACTIONS(5568),
    [anon_sym_LT] = ACTIONS(5568),
    [anon_sym_LT_LT] = ACTIONS(5568),
    [anon_sym_GT_GT] = ACTIONS(5568),
    [anon_sym_SEMI] = ACTIONS(5570),
    [anon_sym___attribute__] = ACTIONS(5568),
    [anon_sym___attribute] = ACTIONS(5568),
    [anon_sym_LBRACE] = ACTIONS(5570),
    [anon_sym_RBRACE] = ACTIONS(5570),
    [anon_sym_LBRACK] = ACTIONS(5570),
    [anon_sym_RBRACK] = ACTIONS(5570),
    [anon_sym_EQ] = ACTIONS(5568),
    [anon_sym_COLON] = ACTIONS(5570),
    [anon_sym_QMARK] = ACTIONS(5570),
    [anon_sym_STAR_EQ] = ACTIONS(5570),
    [anon_sym_SLASH_EQ] = ACTIONS(5570),
    [anon_sym_PERCENT_EQ] = ACTIONS(5570),
    [anon_sym_PLUS_EQ] = ACTIONS(5570),
    [anon_sym_DASH_EQ] = ACTIONS(5570),
    [anon_sym_LT_LT_EQ] = ACTIONS(5570),
    [anon_sym_GT_GT_EQ] = ACTIONS(5570),
    [anon_sym_AMP_EQ] = ACTIONS(5570),
    [anon_sym_CARET_EQ] = ACTIONS(5570),
    [anon_sym_PIPE_EQ] = ACTIONS(5570),
    [anon_sym_and_eq] = ACTIONS(5568),
    [anon_sym_or_eq] = ACTIONS(5568),
    [anon_sym_xor_eq] = ACTIONS(5568),
    [anon_sym_LT_EQ_GT] = ACTIONS(5570),
    [anon_sym_or] = ACTIONS(5568),
    [anon_sym_and] = ACTIONS(5568),
    [anon_sym_bitor] = ACTIONS(5568),
    [anon_sym_xor] = ACTIONS(5568),
    [anon_sym_bitand] = ACTIONS(5568),
    [anon_sym_not_eq] = ACTIONS(5568),
    [anon_sym_DASH_DASH] = ACTIONS(5570),
    [anon_sym_PLUS_PLUS] = ACTIONS(5570),
    [anon_sym_DOT] = ACTIONS(5568),
    [anon_sym_DOT_STAR] = ACTIONS(5570),
    [anon_sym_DASH_GT] = ACTIONS(5570),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5568),
    [anon_sym_decltype] = ACTIONS(5568),
  },
  [2196] = {
    [sym_attribute_specifier] = STATE(1847),
    [sym_enumerator_list] = STATE(2273),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5850),
    [anon_sym_COMMA] = ACTIONS(5850),
    [anon_sym_RPAREN] = ACTIONS(5850),
    [anon_sym_LPAREN2] = ACTIONS(5850),
    [anon_sym_DASH] = ACTIONS(5848),
    [anon_sym_PLUS] = ACTIONS(5848),
    [anon_sym_STAR] = ACTIONS(5850),
    [anon_sym_SLASH] = ACTIONS(5848),
    [anon_sym_PERCENT] = ACTIONS(5850),
    [anon_sym_PIPE_PIPE] = ACTIONS(5850),
    [anon_sym_AMP_AMP] = ACTIONS(5850),
    [anon_sym_PIPE] = ACTIONS(5848),
    [anon_sym_CARET] = ACTIONS(5850),
    [anon_sym_AMP] = ACTIONS(5848),
    [anon_sym_EQ_EQ] = ACTIONS(5850),
    [anon_sym_BANG_EQ] = ACTIONS(5850),
    [anon_sym_GT] = ACTIONS(5848),
    [anon_sym_GT_EQ] = ACTIONS(5850),
    [anon_sym_LT_EQ] = ACTIONS(5848),
    [anon_sym_LT] = ACTIONS(5848),
    [anon_sym_LT_LT] = ACTIONS(5850),
    [anon_sym_GT_GT] = ACTIONS(5850),
    [anon_sym_SEMI] = ACTIONS(5850),
    [anon_sym___extension__] = ACTIONS(5850),
    [anon_sym___attribute__] = ACTIONS(5874),
    [anon_sym___attribute] = ACTIONS(5876),
    [anon_sym_LBRACE] = ACTIONS(6065),
    [anon_sym_RBRACE] = ACTIONS(5850),
    [anon_sym_LBRACK] = ACTIONS(5850),
    [anon_sym_RBRACK] = ACTIONS(5850),
    [anon_sym_const] = ACTIONS(5848),
    [anon_sym_constexpr] = ACTIONS(5850),
    [anon_sym_volatile] = ACTIONS(5850),
    [anon_sym_restrict] = ACTIONS(5850),
    [anon_sym___restrict__] = ACTIONS(5850),
    [anon_sym__Atomic] = ACTIONS(5850),
    [anon_sym__Noreturn] = ACTIONS(5850),
    [anon_sym_noreturn] = ACTIONS(5850),
    [anon_sym__Nonnull] = ACTIONS(5850),
    [anon_sym_mutable] = ACTIONS(5850),
    [anon_sym_constinit] = ACTIONS(5850),
    [anon_sym_consteval] = ACTIONS(5850),
    [anon_sym_alignas] = ACTIONS(5850),
    [anon_sym__Alignas] = ACTIONS(5850),
    [anon_sym_COLON] = ACTIONS(5850),
    [anon_sym_QMARK] = ACTIONS(5850),
    [anon_sym_LT_EQ_GT] = ACTIONS(5850),
    [anon_sym_or] = ACTIONS(5850),
    [anon_sym_and] = ACTIONS(5850),
    [anon_sym_bitor] = ACTIONS(5850),
    [anon_sym_xor] = ACTIONS(5850),
    [anon_sym_bitand] = ACTIONS(5850),
    [anon_sym_not_eq] = ACTIONS(5850),
    [anon_sym_DASH_DASH] = ACTIONS(5850),
    [anon_sym_PLUS_PLUS] = ACTIONS(5850),
    [anon_sym_DOT] = ACTIONS(5848),
    [anon_sym_DOT_STAR] = ACTIONS(5850),
    [anon_sym_DASH_GT] = ACTIONS(5850),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5850),
    [anon_sym_decltype] = ACTIONS(5850),
    [anon_sym_final] = ACTIONS(5850),
    [anon_sym_override] = ACTIONS(5850),
    [anon_sym_requires] = ACTIONS(5850),
  },
  [2197] = {
    [sym_attribute_declaration] = STATE(2197),
    [aux_sym_attributed_declarator_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(6067),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6069),
    [anon_sym_COMMA] = ACTIONS(6069),
    [anon_sym_RPAREN] = ACTIONS(6069),
    [aux_sym_preproc_if_token2] = ACTIONS(6069),
    [aux_sym_preproc_else_token1] = ACTIONS(6069),
    [aux_sym_preproc_elif_token1] = ACTIONS(6067),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6069),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6069),
    [anon_sym_LPAREN2] = ACTIONS(6069),
    [anon_sym_DASH] = ACTIONS(6067),
    [anon_sym_PLUS] = ACTIONS(6067),
    [anon_sym_STAR] = ACTIONS(6067),
    [anon_sym_SLASH] = ACTIONS(6067),
    [anon_sym_PERCENT] = ACTIONS(6067),
    [anon_sym_PIPE_PIPE] = ACTIONS(6069),
    [anon_sym_AMP_AMP] = ACTIONS(6069),
    [anon_sym_PIPE] = ACTIONS(6067),
    [anon_sym_CARET] = ACTIONS(6067),
    [anon_sym_AMP] = ACTIONS(6067),
    [anon_sym_EQ_EQ] = ACTIONS(6069),
    [anon_sym_BANG_EQ] = ACTIONS(6069),
    [anon_sym_GT] = ACTIONS(6067),
    [anon_sym_GT_EQ] = ACTIONS(6069),
    [anon_sym_LT_EQ] = ACTIONS(6067),
    [anon_sym_LT] = ACTIONS(6067),
    [anon_sym_LT_LT] = ACTIONS(6067),
    [anon_sym_GT_GT] = ACTIONS(6067),
    [anon_sym_SEMI] = ACTIONS(6069),
    [anon_sym___attribute__] = ACTIONS(6067),
    [anon_sym___attribute] = ACTIONS(6067),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6071),
    [anon_sym_RBRACE] = ACTIONS(6069),
    [anon_sym_LBRACK] = ACTIONS(6067),
    [anon_sym_RBRACK] = ACTIONS(6069),
    [anon_sym_EQ] = ACTIONS(6067),
    [anon_sym_COLON] = ACTIONS(6069),
    [anon_sym_QMARK] = ACTIONS(6069),
    [anon_sym_STAR_EQ] = ACTIONS(6069),
    [anon_sym_SLASH_EQ] = ACTIONS(6069),
    [anon_sym_PERCENT_EQ] = ACTIONS(6069),
    [anon_sym_PLUS_EQ] = ACTIONS(6069),
    [anon_sym_DASH_EQ] = ACTIONS(6069),
    [anon_sym_LT_LT_EQ] = ACTIONS(6069),
    [anon_sym_GT_GT_EQ] = ACTIONS(6069),
    [anon_sym_AMP_EQ] = ACTIONS(6069),
    [anon_sym_CARET_EQ] = ACTIONS(6069),
    [anon_sym_PIPE_EQ] = ACTIONS(6069),
    [anon_sym_and_eq] = ACTIONS(6067),
    [anon_sym_or_eq] = ACTIONS(6067),
    [anon_sym_xor_eq] = ACTIONS(6067),
    [anon_sym_LT_EQ_GT] = ACTIONS(6069),
    [anon_sym_or] = ACTIONS(6067),
    [anon_sym_and] = ACTIONS(6067),
    [anon_sym_bitor] = ACTIONS(6067),
    [anon_sym_xor] = ACTIONS(6067),
    [anon_sym_bitand] = ACTIONS(6067),
    [anon_sym_not_eq] = ACTIONS(6067),
    [anon_sym_DASH_DASH] = ACTIONS(6069),
    [anon_sym_PLUS_PLUS] = ACTIONS(6069),
    [anon_sym_DOT] = ACTIONS(6067),
    [anon_sym_DOT_STAR] = ACTIONS(6069),
    [anon_sym_DASH_GT] = ACTIONS(6069),
    [sym_comment] = ACTIONS(3),
  },
  [2198] = {
    [sym_template_argument_list] = STATE(2300),
    [sym_identifier] = ACTIONS(4847),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4840),
    [anon_sym_COMMA] = ACTIONS(4840),
    [anon_sym_RPAREN] = ACTIONS(4840),
    [aux_sym_preproc_if_token2] = ACTIONS(4840),
    [aux_sym_preproc_else_token1] = ACTIONS(4840),
    [aux_sym_preproc_elif_token1] = ACTIONS(4847),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4840),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4840),
    [anon_sym_LPAREN2] = ACTIONS(4840),
    [anon_sym_DASH] = ACTIONS(4847),
    [anon_sym_PLUS] = ACTIONS(4847),
    [anon_sym_STAR] = ACTIONS(4847),
    [anon_sym_SLASH] = ACTIONS(4847),
    [anon_sym_PERCENT] = ACTIONS(4847),
    [anon_sym_PIPE_PIPE] = ACTIONS(4840),
    [anon_sym_AMP_AMP] = ACTIONS(4840),
    [anon_sym_PIPE] = ACTIONS(4847),
    [anon_sym_CARET] = ACTIONS(4847),
    [anon_sym_AMP] = ACTIONS(4847),
    [anon_sym_EQ_EQ] = ACTIONS(4840),
    [anon_sym_BANG_EQ] = ACTIONS(4840),
    [anon_sym_GT] = ACTIONS(4847),
    [anon_sym_GT_EQ] = ACTIONS(4840),
    [anon_sym_LT_EQ] = ACTIONS(4847),
    [anon_sym_LT] = ACTIONS(5727),
    [anon_sym_LT_LT] = ACTIONS(4847),
    [anon_sym_GT_GT] = ACTIONS(4847),
    [anon_sym_SEMI] = ACTIONS(4840),
    [anon_sym___attribute__] = ACTIONS(4847),
    [anon_sym___attribute] = ACTIONS(4847),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACE] = ACTIONS(4845),
    [anon_sym_RBRACE] = ACTIONS(4840),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_RBRACK] = ACTIONS(4840),
    [anon_sym_EQ] = ACTIONS(4847),
    [anon_sym_COLON] = ACTIONS(4847),
    [anon_sym_QMARK] = ACTIONS(4840),
    [anon_sym_STAR_EQ] = ACTIONS(4840),
    [anon_sym_SLASH_EQ] = ACTIONS(4840),
    [anon_sym_PERCENT_EQ] = ACTIONS(4840),
    [anon_sym_PLUS_EQ] = ACTIONS(4840),
    [anon_sym_DASH_EQ] = ACTIONS(4840),
    [anon_sym_LT_LT_EQ] = ACTIONS(4840),
    [anon_sym_GT_GT_EQ] = ACTIONS(4840),
    [anon_sym_AMP_EQ] = ACTIONS(4840),
    [anon_sym_CARET_EQ] = ACTIONS(4840),
    [anon_sym_PIPE_EQ] = ACTIONS(4840),
    [anon_sym_and_eq] = ACTIONS(4847),
    [anon_sym_or_eq] = ACTIONS(4847),
    [anon_sym_xor_eq] = ACTIONS(4847),
    [anon_sym_LT_EQ_GT] = ACTIONS(4840),
    [anon_sym_or] = ACTIONS(4847),
    [anon_sym_and] = ACTIONS(4847),
    [anon_sym_bitor] = ACTIONS(4847),
    [anon_sym_xor] = ACTIONS(4847),
    [anon_sym_bitand] = ACTIONS(4847),
    [anon_sym_not_eq] = ACTIONS(4847),
    [anon_sym_DASH_DASH] = ACTIONS(4840),
    [anon_sym_PLUS_PLUS] = ACTIONS(4840),
    [anon_sym_DOT] = ACTIONS(4847),
    [anon_sym_DOT_STAR] = ACTIONS(4840),
    [anon_sym_DASH_GT] = ACTIONS(4840),
    [sym_comment] = ACTIONS(3),
  },
  [2199] = {
    [sym_identifier] = ACTIONS(5592),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5594),
    [anon_sym_COMMA] = ACTIONS(5594),
    [anon_sym_RPAREN] = ACTIONS(5594),
    [aux_sym_preproc_if_token2] = ACTIONS(5594),
    [aux_sym_preproc_else_token1] = ACTIONS(5594),
    [aux_sym_preproc_elif_token1] = ACTIONS(5592),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5594),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5594),
    [anon_sym_LPAREN2] = ACTIONS(5594),
    [anon_sym_DASH] = ACTIONS(5592),
    [anon_sym_PLUS] = ACTIONS(5592),
    [anon_sym_STAR] = ACTIONS(5592),
    [anon_sym_SLASH] = ACTIONS(5592),
    [anon_sym_PERCENT] = ACTIONS(5592),
    [anon_sym_PIPE_PIPE] = ACTIONS(5594),
    [anon_sym_AMP_AMP] = ACTIONS(5594),
    [anon_sym_PIPE] = ACTIONS(5592),
    [anon_sym_CARET] = ACTIONS(5592),
    [anon_sym_AMP] = ACTIONS(5592),
    [anon_sym_EQ_EQ] = ACTIONS(5594),
    [anon_sym_BANG_EQ] = ACTIONS(5594),
    [anon_sym_GT] = ACTIONS(5592),
    [anon_sym_GT_EQ] = ACTIONS(5594),
    [anon_sym_LT_EQ] = ACTIONS(5592),
    [anon_sym_LT] = ACTIONS(5592),
    [anon_sym_LT_LT] = ACTIONS(5592),
    [anon_sym_GT_GT] = ACTIONS(5592),
    [anon_sym_SEMI] = ACTIONS(5594),
    [anon_sym___attribute__] = ACTIONS(5592),
    [anon_sym___attribute] = ACTIONS(5592),
    [anon_sym_LBRACE] = ACTIONS(5594),
    [anon_sym_RBRACE] = ACTIONS(5594),
    [anon_sym_LBRACK] = ACTIONS(5594),
    [anon_sym_RBRACK] = ACTIONS(5594),
    [anon_sym_EQ] = ACTIONS(5592),
    [anon_sym_COLON] = ACTIONS(5594),
    [anon_sym_QMARK] = ACTIONS(5594),
    [anon_sym_STAR_EQ] = ACTIONS(5594),
    [anon_sym_SLASH_EQ] = ACTIONS(5594),
    [anon_sym_PERCENT_EQ] = ACTIONS(5594),
    [anon_sym_PLUS_EQ] = ACTIONS(5594),
    [anon_sym_DASH_EQ] = ACTIONS(5594),
    [anon_sym_LT_LT_EQ] = ACTIONS(5594),
    [anon_sym_GT_GT_EQ] = ACTIONS(5594),
    [anon_sym_AMP_EQ] = ACTIONS(5594),
    [anon_sym_CARET_EQ] = ACTIONS(5594),
    [anon_sym_PIPE_EQ] = ACTIONS(5594),
    [anon_sym_and_eq] = ACTIONS(5592),
    [anon_sym_or_eq] = ACTIONS(5592),
    [anon_sym_xor_eq] = ACTIONS(5592),
    [anon_sym_LT_EQ_GT] = ACTIONS(5594),
    [anon_sym_or] = ACTIONS(5592),
    [anon_sym_and] = ACTIONS(5592),
    [anon_sym_bitor] = ACTIONS(5592),
    [anon_sym_xor] = ACTIONS(5592),
    [anon_sym_bitand] = ACTIONS(5592),
    [anon_sym_not_eq] = ACTIONS(5592),
    [anon_sym_DASH_DASH] = ACTIONS(5594),
    [anon_sym_PLUS_PLUS] = ACTIONS(5594),
    [anon_sym_DOT] = ACTIONS(5592),
    [anon_sym_DOT_STAR] = ACTIONS(5594),
    [anon_sym_DASH_GT] = ACTIONS(5594),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5592),
    [anon_sym_decltype] = ACTIONS(5592),
  },
  [2200] = {
    [sym_string_literal] = STATE(1656),
    [sym_template_argument_list] = STATE(2300),
    [sym_raw_string_literal] = STATE(1656),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5929),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_DASH] = ACTIONS(4043),
    [anon_sym_PLUS] = ACTIONS(4043),
    [anon_sym_STAR] = ACTIONS(4043),
    [anon_sym_SLASH] = ACTIONS(4043),
    [anon_sym_PERCENT] = ACTIONS(4043),
    [anon_sym_PIPE_PIPE] = ACTIONS(4035),
    [anon_sym_AMP_AMP] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4043),
    [anon_sym_CARET] = ACTIONS(4043),
    [anon_sym_AMP] = ACTIONS(4043),
    [anon_sym_EQ_EQ] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4043),
    [anon_sym_GT_EQ] = ACTIONS(4035),
    [anon_sym_LT_EQ] = ACTIONS(4043),
    [anon_sym_LT] = ACTIONS(5237),
    [anon_sym_LT_LT] = ACTIONS(4043),
    [anon_sym_GT_GT] = ACTIONS(4043),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACE] = ACTIONS(4059),
    [anon_sym_LBRACK] = ACTIONS(4035),
    [anon_sym_RBRACK] = ACTIONS(6076),
    [anon_sym_EQ] = ACTIONS(4043),
    [anon_sym_QMARK] = ACTIONS(4035),
    [anon_sym_STAR_EQ] = ACTIONS(4035),
    [anon_sym_SLASH_EQ] = ACTIONS(4035),
    [anon_sym_PERCENT_EQ] = ACTIONS(4035),
    [anon_sym_PLUS_EQ] = ACTIONS(4035),
    [anon_sym_DASH_EQ] = ACTIONS(4035),
    [anon_sym_LT_LT_EQ] = ACTIONS(4035),
    [anon_sym_GT_GT_EQ] = ACTIONS(4035),
    [anon_sym_AMP_EQ] = ACTIONS(4035),
    [anon_sym_CARET_EQ] = ACTIONS(4035),
    [anon_sym_PIPE_EQ] = ACTIONS(4035),
    [anon_sym_and_eq] = ACTIONS(4035),
    [anon_sym_or_eq] = ACTIONS(4035),
    [anon_sym_xor_eq] = ACTIONS(4035),
    [anon_sym_LT_EQ_GT] = ACTIONS(4035),
    [anon_sym_or] = ACTIONS(4043),
    [anon_sym_and] = ACTIONS(4043),
    [anon_sym_bitor] = ACTIONS(4035),
    [anon_sym_xor] = ACTIONS(4043),
    [anon_sym_bitand] = ACTIONS(4035),
    [anon_sym_not_eq] = ACTIONS(4035),
    [anon_sym_DASH_DASH] = ACTIONS(4035),
    [anon_sym_PLUS_PLUS] = ACTIONS(4035),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_DOT_STAR] = ACTIONS(4035),
    [anon_sym_DASH_GT] = ACTIONS(4035),
    [anon_sym_L_DQUOTE] = ACTIONS(1945),
    [anon_sym_u_DQUOTE] = ACTIONS(1945),
    [anon_sym_U_DQUOTE] = ACTIONS(1945),
    [anon_sym_u8_DQUOTE] = ACTIONS(1945),
    [anon_sym_DQUOTE] = ACTIONS(1945),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(1955),
    [anon_sym_LR_DQUOTE] = ACTIONS(1955),
    [anon_sym_uR_DQUOTE] = ACTIONS(1955),
    [anon_sym_UR_DQUOTE] = ACTIONS(1955),
    [anon_sym_u8R_DQUOTE] = ACTIONS(1955),
  },
  [2201] = {
    [sym_identifier] = ACTIONS(5502),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5504),
    [anon_sym_COMMA] = ACTIONS(5504),
    [anon_sym_RPAREN] = ACTIONS(5504),
    [aux_sym_preproc_if_token2] = ACTIONS(5504),
    [aux_sym_preproc_else_token1] = ACTIONS(5504),
    [aux_sym_preproc_elif_token1] = ACTIONS(5502),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5504),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5504),
    [anon_sym_LPAREN2] = ACTIONS(5504),
    [anon_sym_DASH] = ACTIONS(5502),
    [anon_sym_PLUS] = ACTIONS(5502),
    [anon_sym_STAR] = ACTIONS(5502),
    [anon_sym_SLASH] = ACTIONS(5502),
    [anon_sym_PERCENT] = ACTIONS(5502),
    [anon_sym_PIPE_PIPE] = ACTIONS(5504),
    [anon_sym_AMP_AMP] = ACTIONS(5504),
    [anon_sym_PIPE] = ACTIONS(5502),
    [anon_sym_CARET] = ACTIONS(5502),
    [anon_sym_AMP] = ACTIONS(5502),
    [anon_sym_EQ_EQ] = ACTIONS(5504),
    [anon_sym_BANG_EQ] = ACTIONS(5504),
    [anon_sym_GT] = ACTIONS(5502),
    [anon_sym_GT_EQ] = ACTIONS(5504),
    [anon_sym_LT_EQ] = ACTIONS(5502),
    [anon_sym_LT] = ACTIONS(5502),
    [anon_sym_LT_LT] = ACTIONS(5502),
    [anon_sym_GT_GT] = ACTIONS(5502),
    [anon_sym_SEMI] = ACTIONS(5504),
    [anon_sym___attribute__] = ACTIONS(5502),
    [anon_sym___attribute] = ACTIONS(5502),
    [anon_sym_LBRACE] = ACTIONS(5504),
    [anon_sym_RBRACE] = ACTIONS(5504),
    [anon_sym_LBRACK] = ACTIONS(5504),
    [anon_sym_RBRACK] = ACTIONS(5504),
    [anon_sym_EQ] = ACTIONS(5502),
    [anon_sym_COLON] = ACTIONS(5504),
    [anon_sym_QMARK] = ACTIONS(5504),
    [anon_sym_STAR_EQ] = ACTIONS(5504),
    [anon_sym_SLASH_EQ] = ACTIONS(5504),
    [anon_sym_PERCENT_EQ] = ACTIONS(5504),
    [anon_sym_PLUS_EQ] = ACTIONS(5504),
    [anon_sym_DASH_EQ] = ACTIONS(5504),
    [anon_sym_LT_LT_EQ] = ACTIONS(5504),
    [anon_sym_GT_GT_EQ] = ACTIONS(5504),
    [anon_sym_AMP_EQ] = ACTIONS(5504),
    [anon_sym_CARET_EQ] = ACTIONS(5504),
    [anon_sym_PIPE_EQ] = ACTIONS(5504),
    [anon_sym_and_eq] = ACTIONS(5502),
    [anon_sym_or_eq] = ACTIONS(5502),
    [anon_sym_xor_eq] = ACTIONS(5502),
    [anon_sym_LT_EQ_GT] = ACTIONS(5504),
    [anon_sym_or] = ACTIONS(5502),
    [anon_sym_and] = ACTIONS(5502),
    [anon_sym_bitor] = ACTIONS(5502),
    [anon_sym_xor] = ACTIONS(5502),
    [anon_sym_bitand] = ACTIONS(5502),
    [anon_sym_not_eq] = ACTIONS(5502),
    [anon_sym_DASH_DASH] = ACTIONS(5504),
    [anon_sym_PLUS_PLUS] = ACTIONS(5504),
    [anon_sym_DOT] = ACTIONS(5502),
    [anon_sym_DOT_STAR] = ACTIONS(5504),
    [anon_sym_DASH_GT] = ACTIONS(5504),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5502),
    [anon_sym_decltype] = ACTIONS(5502),
  },
  [2202] = {
    [sym_identifier] = ACTIONS(5510),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5512),
    [anon_sym_COMMA] = ACTIONS(5512),
    [anon_sym_RPAREN] = ACTIONS(5512),
    [aux_sym_preproc_if_token2] = ACTIONS(5512),
    [aux_sym_preproc_else_token1] = ACTIONS(5512),
    [aux_sym_preproc_elif_token1] = ACTIONS(5510),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5512),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5512),
    [anon_sym_LPAREN2] = ACTIONS(5512),
    [anon_sym_DASH] = ACTIONS(5510),
    [anon_sym_PLUS] = ACTIONS(5510),
    [anon_sym_STAR] = ACTIONS(5510),
    [anon_sym_SLASH] = ACTIONS(5510),
    [anon_sym_PERCENT] = ACTIONS(5510),
    [anon_sym_PIPE_PIPE] = ACTIONS(5512),
    [anon_sym_AMP_AMP] = ACTIONS(5512),
    [anon_sym_PIPE] = ACTIONS(5510),
    [anon_sym_CARET] = ACTIONS(5510),
    [anon_sym_AMP] = ACTIONS(5510),
    [anon_sym_EQ_EQ] = ACTIONS(5512),
    [anon_sym_BANG_EQ] = ACTIONS(5512),
    [anon_sym_GT] = ACTIONS(5510),
    [anon_sym_GT_EQ] = ACTIONS(5512),
    [anon_sym_LT_EQ] = ACTIONS(5510),
    [anon_sym_LT] = ACTIONS(5510),
    [anon_sym_LT_LT] = ACTIONS(5510),
    [anon_sym_GT_GT] = ACTIONS(5510),
    [anon_sym_SEMI] = ACTIONS(5512),
    [anon_sym___attribute__] = ACTIONS(5510),
    [anon_sym___attribute] = ACTIONS(5510),
    [anon_sym_LBRACE] = ACTIONS(5512),
    [anon_sym_RBRACE] = ACTIONS(5512),
    [anon_sym_LBRACK] = ACTIONS(5512),
    [anon_sym_RBRACK] = ACTIONS(5512),
    [anon_sym_EQ] = ACTIONS(5510),
    [anon_sym_COLON] = ACTIONS(5512),
    [anon_sym_QMARK] = ACTIONS(5512),
    [anon_sym_STAR_EQ] = ACTIONS(5512),
    [anon_sym_SLASH_EQ] = ACTIONS(5512),
    [anon_sym_PERCENT_EQ] = ACTIONS(5512),
    [anon_sym_PLUS_EQ] = ACTIONS(5512),
    [anon_sym_DASH_EQ] = ACTIONS(5512),
    [anon_sym_LT_LT_EQ] = ACTIONS(5512),
    [anon_sym_GT_GT_EQ] = ACTIONS(5512),
    [anon_sym_AMP_EQ] = ACTIONS(5512),
    [anon_sym_CARET_EQ] = ACTIONS(5512),
    [anon_sym_PIPE_EQ] = ACTIONS(5512),
    [anon_sym_and_eq] = ACTIONS(5510),
    [anon_sym_or_eq] = ACTIONS(5510),
    [anon_sym_xor_eq] = ACTIONS(5510),
    [anon_sym_LT_EQ_GT] = ACTIONS(5512),
    [anon_sym_or] = ACTIONS(5510),
    [anon_sym_and] = ACTIONS(5510),
    [anon_sym_bitor] = ACTIONS(5510),
    [anon_sym_xor] = ACTIONS(5510),
    [anon_sym_bitand] = ACTIONS(5510),
    [anon_sym_not_eq] = ACTIONS(5510),
    [anon_sym_DASH_DASH] = ACTIONS(5512),
    [anon_sym_PLUS_PLUS] = ACTIONS(5512),
    [anon_sym_DOT] = ACTIONS(5510),
    [anon_sym_DOT_STAR] = ACTIONS(5512),
    [anon_sym_DASH_GT] = ACTIONS(5512),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5510),
    [anon_sym_decltype] = ACTIONS(5510),
  },
  [2203] = {
    [sym_identifier] = ACTIONS(5652),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5654),
    [anon_sym_COMMA] = ACTIONS(5654),
    [anon_sym_RPAREN] = ACTIONS(5654),
    [aux_sym_preproc_if_token2] = ACTIONS(5654),
    [aux_sym_preproc_else_token1] = ACTIONS(5654),
    [aux_sym_preproc_elif_token1] = ACTIONS(5652),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5654),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5654),
    [anon_sym_LPAREN2] = ACTIONS(5654),
    [anon_sym_DASH] = ACTIONS(5652),
    [anon_sym_PLUS] = ACTIONS(5652),
    [anon_sym_STAR] = ACTIONS(5652),
    [anon_sym_SLASH] = ACTIONS(5652),
    [anon_sym_PERCENT] = ACTIONS(5652),
    [anon_sym_PIPE_PIPE] = ACTIONS(5654),
    [anon_sym_AMP_AMP] = ACTIONS(5654),
    [anon_sym_PIPE] = ACTIONS(5652),
    [anon_sym_CARET] = ACTIONS(5652),
    [anon_sym_AMP] = ACTIONS(5652),
    [anon_sym_EQ_EQ] = ACTIONS(5654),
    [anon_sym_BANG_EQ] = ACTIONS(5654),
    [anon_sym_GT] = ACTIONS(5652),
    [anon_sym_GT_EQ] = ACTIONS(5654),
    [anon_sym_LT_EQ] = ACTIONS(5652),
    [anon_sym_LT] = ACTIONS(5652),
    [anon_sym_LT_LT] = ACTIONS(5652),
    [anon_sym_GT_GT] = ACTIONS(5652),
    [anon_sym_SEMI] = ACTIONS(5654),
    [anon_sym___attribute__] = ACTIONS(5652),
    [anon_sym___attribute] = ACTIONS(5652),
    [anon_sym_LBRACE] = ACTIONS(5654),
    [anon_sym_RBRACE] = ACTIONS(5654),
    [anon_sym_LBRACK] = ACTIONS(5654),
    [anon_sym_RBRACK] = ACTIONS(5654),
    [anon_sym_EQ] = ACTIONS(5652),
    [anon_sym_COLON] = ACTIONS(5654),
    [anon_sym_QMARK] = ACTIONS(5654),
    [anon_sym_STAR_EQ] = ACTIONS(5654),
    [anon_sym_SLASH_EQ] = ACTIONS(5654),
    [anon_sym_PERCENT_EQ] = ACTIONS(5654),
    [anon_sym_PLUS_EQ] = ACTIONS(5654),
    [anon_sym_DASH_EQ] = ACTIONS(5654),
    [anon_sym_LT_LT_EQ] = ACTIONS(5654),
    [anon_sym_GT_GT_EQ] = ACTIONS(5654),
    [anon_sym_AMP_EQ] = ACTIONS(5654),
    [anon_sym_CARET_EQ] = ACTIONS(5654),
    [anon_sym_PIPE_EQ] = ACTIONS(5654),
    [anon_sym_and_eq] = ACTIONS(5652),
    [anon_sym_or_eq] = ACTIONS(5652),
    [anon_sym_xor_eq] = ACTIONS(5652),
    [anon_sym_LT_EQ_GT] = ACTIONS(5654),
    [anon_sym_or] = ACTIONS(5652),
    [anon_sym_and] = ACTIONS(5652),
    [anon_sym_bitor] = ACTIONS(5652),
    [anon_sym_xor] = ACTIONS(5652),
    [anon_sym_bitand] = ACTIONS(5652),
    [anon_sym_not_eq] = ACTIONS(5652),
    [anon_sym_DASH_DASH] = ACTIONS(5654),
    [anon_sym_PLUS_PLUS] = ACTIONS(5654),
    [anon_sym_DOT] = ACTIONS(5652),
    [anon_sym_DOT_STAR] = ACTIONS(5654),
    [anon_sym_DASH_GT] = ACTIONS(5654),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5652),
    [anon_sym_decltype] = ACTIONS(5652),
  },
  [2204] = {
    [sym_argument_list] = STATE(2450),
    [sym_initializer_list] = STATE(2450),
    [sym_identifier] = ACTIONS(6079),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6081),
    [anon_sym_COMMA] = ACTIONS(6081),
    [anon_sym_RPAREN] = ACTIONS(6081),
    [aux_sym_preproc_if_token2] = ACTIONS(6081),
    [aux_sym_preproc_else_token1] = ACTIONS(6081),
    [aux_sym_preproc_elif_token1] = ACTIONS(6079),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6081),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6081),
    [anon_sym_LPAREN2] = ACTIONS(5688),
    [anon_sym_DASH] = ACTIONS(6079),
    [anon_sym_PLUS] = ACTIONS(6079),
    [anon_sym_STAR] = ACTIONS(6079),
    [anon_sym_SLASH] = ACTIONS(6079),
    [anon_sym_PERCENT] = ACTIONS(6079),
    [anon_sym_PIPE_PIPE] = ACTIONS(6081),
    [anon_sym_AMP_AMP] = ACTIONS(6081),
    [anon_sym_PIPE] = ACTIONS(6079),
    [anon_sym_CARET] = ACTIONS(6079),
    [anon_sym_AMP] = ACTIONS(6079),
    [anon_sym_EQ_EQ] = ACTIONS(6081),
    [anon_sym_BANG_EQ] = ACTIONS(6081),
    [anon_sym_GT] = ACTIONS(6079),
    [anon_sym_GT_EQ] = ACTIONS(6081),
    [anon_sym_LT_EQ] = ACTIONS(6079),
    [anon_sym_LT] = ACTIONS(6079),
    [anon_sym_LT_LT] = ACTIONS(6079),
    [anon_sym_GT_GT] = ACTIONS(6079),
    [anon_sym_SEMI] = ACTIONS(6081),
    [anon_sym___attribute__] = ACTIONS(6079),
    [anon_sym___attribute] = ACTIONS(6079),
    [anon_sym_LBRACE] = ACTIONS(1927),
    [anon_sym_RBRACE] = ACTIONS(6081),
    [anon_sym_LBRACK] = ACTIONS(6081),
    [anon_sym_RBRACK] = ACTIONS(6081),
    [anon_sym_EQ] = ACTIONS(6079),
    [anon_sym_COLON] = ACTIONS(6081),
    [anon_sym_QMARK] = ACTIONS(6081),
    [anon_sym_STAR_EQ] = ACTIONS(6081),
    [anon_sym_SLASH_EQ] = ACTIONS(6081),
    [anon_sym_PERCENT_EQ] = ACTIONS(6081),
    [anon_sym_PLUS_EQ] = ACTIONS(6081),
    [anon_sym_DASH_EQ] = ACTIONS(6081),
    [anon_sym_LT_LT_EQ] = ACTIONS(6081),
    [anon_sym_GT_GT_EQ] = ACTIONS(6081),
    [anon_sym_AMP_EQ] = ACTIONS(6081),
    [anon_sym_CARET_EQ] = ACTIONS(6081),
    [anon_sym_PIPE_EQ] = ACTIONS(6081),
    [anon_sym_and_eq] = ACTIONS(6079),
    [anon_sym_or_eq] = ACTIONS(6079),
    [anon_sym_xor_eq] = ACTIONS(6079),
    [anon_sym_LT_EQ_GT] = ACTIONS(6081),
    [anon_sym_or] = ACTIONS(6079),
    [anon_sym_and] = ACTIONS(6079),
    [anon_sym_bitor] = ACTIONS(6079),
    [anon_sym_xor] = ACTIONS(6079),
    [anon_sym_bitand] = ACTIONS(6079),
    [anon_sym_not_eq] = ACTIONS(6079),
    [anon_sym_DASH_DASH] = ACTIONS(6081),
    [anon_sym_PLUS_PLUS] = ACTIONS(6081),
    [anon_sym_DOT] = ACTIONS(6079),
    [anon_sym_DOT_STAR] = ACTIONS(6081),
    [anon_sym_DASH_GT] = ACTIONS(6081),
    [sym_comment] = ACTIONS(3),
  },
  [2205] = {
    [sym_string_literal] = STATE(2570),
    [sym_template_argument_list] = STATE(3643),
    [sym_raw_string_literal] = STATE(2570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5929),
    [anon_sym_COMMA] = ACTIONS(6083),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_DASH] = ACTIONS(4043),
    [anon_sym_PLUS] = ACTIONS(4043),
    [anon_sym_STAR] = ACTIONS(4043),
    [anon_sym_SLASH] = ACTIONS(4043),
    [anon_sym_PERCENT] = ACTIONS(4043),
    [anon_sym_PIPE_PIPE] = ACTIONS(4035),
    [anon_sym_AMP_AMP] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4043),
    [anon_sym_CARET] = ACTIONS(4043),
    [anon_sym_AMP] = ACTIONS(4043),
    [anon_sym_EQ_EQ] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4043),
    [anon_sym_GT_EQ] = ACTIONS(4035),
    [anon_sym_LT_EQ] = ACTIONS(4043),
    [anon_sym_LT] = ACTIONS(4929),
    [anon_sym_LT_LT] = ACTIONS(4043),
    [anon_sym_GT_GT] = ACTIONS(4043),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACE] = ACTIONS(4059),
    [anon_sym_LBRACK] = ACTIONS(4035),
    [anon_sym_RBRACK] = ACTIONS(6085),
    [anon_sym_EQ] = ACTIONS(5939),
    [anon_sym_QMARK] = ACTIONS(4035),
    [anon_sym_STAR_EQ] = ACTIONS(5941),
    [anon_sym_SLASH_EQ] = ACTIONS(5941),
    [anon_sym_PERCENT_EQ] = ACTIONS(5941),
    [anon_sym_PLUS_EQ] = ACTIONS(5941),
    [anon_sym_DASH_EQ] = ACTIONS(5941),
    [anon_sym_LT_LT_EQ] = ACTIONS(5941),
    [anon_sym_GT_GT_EQ] = ACTIONS(5941),
    [anon_sym_AMP_EQ] = ACTIONS(5941),
    [anon_sym_CARET_EQ] = ACTIONS(5941),
    [anon_sym_PIPE_EQ] = ACTIONS(5941),
    [anon_sym_and_eq] = ACTIONS(5941),
    [anon_sym_or_eq] = ACTIONS(5941),
    [anon_sym_xor_eq] = ACTIONS(5941),
    [anon_sym_LT_EQ_GT] = ACTIONS(4035),
    [anon_sym_or] = ACTIONS(4043),
    [anon_sym_and] = ACTIONS(4043),
    [anon_sym_bitor] = ACTIONS(4035),
    [anon_sym_xor] = ACTIONS(4043),
    [anon_sym_bitand] = ACTIONS(4035),
    [anon_sym_not_eq] = ACTIONS(4035),
    [anon_sym_DASH_DASH] = ACTIONS(4035),
    [anon_sym_PLUS_PLUS] = ACTIONS(4035),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_DOT_STAR] = ACTIONS(4035),
    [anon_sym_DASH_GT] = ACTIONS(4035),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
  },
  [2206] = {
    [sym_identifier] = ACTIONS(5533),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5535),
    [anon_sym_COMMA] = ACTIONS(5535),
    [anon_sym_RPAREN] = ACTIONS(5535),
    [aux_sym_preproc_if_token2] = ACTIONS(5535),
    [aux_sym_preproc_else_token1] = ACTIONS(5535),
    [aux_sym_preproc_elif_token1] = ACTIONS(5533),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5535),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5535),
    [anon_sym_LPAREN2] = ACTIONS(5535),
    [anon_sym_DASH] = ACTIONS(5533),
    [anon_sym_PLUS] = ACTIONS(5533),
    [anon_sym_STAR] = ACTIONS(5533),
    [anon_sym_SLASH] = ACTIONS(5533),
    [anon_sym_PERCENT] = ACTIONS(5533),
    [anon_sym_PIPE_PIPE] = ACTIONS(5535),
    [anon_sym_AMP_AMP] = ACTIONS(5535),
    [anon_sym_PIPE] = ACTIONS(5533),
    [anon_sym_CARET] = ACTIONS(5533),
    [anon_sym_AMP] = ACTIONS(5533),
    [anon_sym_EQ_EQ] = ACTIONS(5535),
    [anon_sym_BANG_EQ] = ACTIONS(5535),
    [anon_sym_GT] = ACTIONS(5533),
    [anon_sym_GT_EQ] = ACTIONS(5535),
    [anon_sym_LT_EQ] = ACTIONS(5533),
    [anon_sym_LT] = ACTIONS(5533),
    [anon_sym_LT_LT] = ACTIONS(5533),
    [anon_sym_GT_GT] = ACTIONS(5533),
    [anon_sym_SEMI] = ACTIONS(5535),
    [anon_sym___attribute__] = ACTIONS(5533),
    [anon_sym___attribute] = ACTIONS(5533),
    [anon_sym_LBRACE] = ACTIONS(5535),
    [anon_sym_RBRACE] = ACTIONS(5535),
    [anon_sym_LBRACK] = ACTIONS(5535),
    [anon_sym_RBRACK] = ACTIONS(5535),
    [anon_sym_EQ] = ACTIONS(5533),
    [anon_sym_COLON] = ACTIONS(5535),
    [anon_sym_QMARK] = ACTIONS(5535),
    [anon_sym_STAR_EQ] = ACTIONS(5535),
    [anon_sym_SLASH_EQ] = ACTIONS(5535),
    [anon_sym_PERCENT_EQ] = ACTIONS(5535),
    [anon_sym_PLUS_EQ] = ACTIONS(5535),
    [anon_sym_DASH_EQ] = ACTIONS(5535),
    [anon_sym_LT_LT_EQ] = ACTIONS(5535),
    [anon_sym_GT_GT_EQ] = ACTIONS(5535),
    [anon_sym_AMP_EQ] = ACTIONS(5535),
    [anon_sym_CARET_EQ] = ACTIONS(5535),
    [anon_sym_PIPE_EQ] = ACTIONS(5535),
    [anon_sym_and_eq] = ACTIONS(5533),
    [anon_sym_or_eq] = ACTIONS(5533),
    [anon_sym_xor_eq] = ACTIONS(5533),
    [anon_sym_LT_EQ_GT] = ACTIONS(5535),
    [anon_sym_or] = ACTIONS(5533),
    [anon_sym_and] = ACTIONS(5533),
    [anon_sym_bitor] = ACTIONS(5533),
    [anon_sym_xor] = ACTIONS(5533),
    [anon_sym_bitand] = ACTIONS(5533),
    [anon_sym_not_eq] = ACTIONS(5533),
    [anon_sym_DASH_DASH] = ACTIONS(5535),
    [anon_sym_PLUS_PLUS] = ACTIONS(5535),
    [anon_sym_DOT] = ACTIONS(5533),
    [anon_sym_DOT_STAR] = ACTIONS(5535),
    [anon_sym_DASH_GT] = ACTIONS(5535),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5533),
    [anon_sym_decltype] = ACTIONS(5533),
  },
  [2207] = {
    [sym_identifier] = ACTIONS(5443),
    [anon_sym_LPAREN2] = ACTIONS(5445),
    [anon_sym_TILDE] = ACTIONS(5445),
    [anon_sym_STAR] = ACTIONS(5445),
    [anon_sym_PIPE_PIPE] = ACTIONS(5445),
    [anon_sym_AMP_AMP] = ACTIONS(5445),
    [anon_sym_AMP] = ACTIONS(5443),
    [anon_sym___extension__] = ACTIONS(5443),
    [anon_sym_virtual] = ACTIONS(5443),
    [anon_sym_extern] = ACTIONS(5443),
    [anon_sym___attribute__] = ACTIONS(5443),
    [anon_sym___attribute] = ACTIONS(5443),
    [anon_sym_COLON_COLON] = ACTIONS(5365),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5445),
    [anon_sym___declspec] = ACTIONS(5443),
    [anon_sym___based] = ACTIONS(5443),
    [anon_sym___cdecl] = ACTIONS(5443),
    [anon_sym___clrcall] = ACTIONS(5443),
    [anon_sym___stdcall] = ACTIONS(5443),
    [anon_sym___fastcall] = ACTIONS(5443),
    [anon_sym___thiscall] = ACTIONS(5443),
    [anon_sym___vectorcall] = ACTIONS(5443),
    [anon_sym_signed] = ACTIONS(5443),
    [anon_sym_unsigned] = ACTIONS(5443),
    [anon_sym_long] = ACTIONS(5443),
    [anon_sym_short] = ACTIONS(5443),
    [anon_sym_LBRACK] = ACTIONS(5443),
    [anon_sym_static] = ACTIONS(5443),
    [anon_sym_register] = ACTIONS(5443),
    [anon_sym_inline] = ACTIONS(5443),
    [anon_sym___inline] = ACTIONS(5443),
    [anon_sym___inline__] = ACTIONS(5443),
    [anon_sym___forceinline] = ACTIONS(5443),
    [anon_sym_thread_local] = ACTIONS(5443),
    [anon_sym___thread] = ACTIONS(5443),
    [anon_sym_const] = ACTIONS(5443),
    [anon_sym_constexpr] = ACTIONS(5443),
    [anon_sym_volatile] = ACTIONS(5443),
    [anon_sym_restrict] = ACTIONS(5443),
    [anon_sym___restrict__] = ACTIONS(5443),
    [anon_sym__Atomic] = ACTIONS(5443),
    [anon_sym__Noreturn] = ACTIONS(5443),
    [anon_sym_noreturn] = ACTIONS(5443),
    [anon_sym__Nonnull] = ACTIONS(5443),
    [anon_sym_mutable] = ACTIONS(5443),
    [anon_sym_constinit] = ACTIONS(5443),
    [anon_sym_consteval] = ACTIONS(5443),
    [anon_sym_alignas] = ACTIONS(5443),
    [anon_sym__Alignas] = ACTIONS(5443),
    [sym_primitive_type] = ACTIONS(5443),
    [anon_sym_enum] = ACTIONS(5443),
    [anon_sym_class] = ACTIONS(5443),
    [anon_sym_struct] = ACTIONS(5443),
    [anon_sym_union] = ACTIONS(5443),
    [anon_sym_or] = ACTIONS(5443),
    [anon_sym_and] = ACTIONS(5443),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5443),
    [anon_sym_decltype] = ACTIONS(5443),
    [anon_sym_explicit] = ACTIONS(5443),
    [anon_sym_typename] = ACTIONS(5443),
    [anon_sym_template] = ACTIONS(5443),
    [anon_sym_operator] = ACTIONS(5443),
    [anon_sym_friend] = ACTIONS(5443),
    [anon_sym_using] = ACTIONS(5443),
    [anon_sym_concept] = ACTIONS(5443),
  },
  [2208] = {
    [sym_identifier] = ACTIONS(5514),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5516),
    [anon_sym_COMMA] = ACTIONS(5516),
    [anon_sym_RPAREN] = ACTIONS(5516),
    [aux_sym_preproc_if_token2] = ACTIONS(5516),
    [aux_sym_preproc_else_token1] = ACTIONS(5516),
    [aux_sym_preproc_elif_token1] = ACTIONS(5514),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5516),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5516),
    [anon_sym_LPAREN2] = ACTIONS(5516),
    [anon_sym_DASH] = ACTIONS(5514),
    [anon_sym_PLUS] = ACTIONS(5514),
    [anon_sym_STAR] = ACTIONS(5514),
    [anon_sym_SLASH] = ACTIONS(5514),
    [anon_sym_PERCENT] = ACTIONS(5514),
    [anon_sym_PIPE_PIPE] = ACTIONS(5516),
    [anon_sym_AMP_AMP] = ACTIONS(5516),
    [anon_sym_PIPE] = ACTIONS(5514),
    [anon_sym_CARET] = ACTIONS(5514),
    [anon_sym_AMP] = ACTIONS(5514),
    [anon_sym_EQ_EQ] = ACTIONS(5516),
    [anon_sym_BANG_EQ] = ACTIONS(5516),
    [anon_sym_GT] = ACTIONS(5514),
    [anon_sym_GT_EQ] = ACTIONS(5516),
    [anon_sym_LT_EQ] = ACTIONS(5514),
    [anon_sym_LT] = ACTIONS(5514),
    [anon_sym_LT_LT] = ACTIONS(5514),
    [anon_sym_GT_GT] = ACTIONS(5514),
    [anon_sym_SEMI] = ACTIONS(5516),
    [anon_sym___attribute__] = ACTIONS(5514),
    [anon_sym___attribute] = ACTIONS(5514),
    [anon_sym_LBRACE] = ACTIONS(5516),
    [anon_sym_RBRACE] = ACTIONS(5516),
    [anon_sym_LBRACK] = ACTIONS(5516),
    [anon_sym_RBRACK] = ACTIONS(5516),
    [anon_sym_EQ] = ACTIONS(5514),
    [anon_sym_COLON] = ACTIONS(5516),
    [anon_sym_QMARK] = ACTIONS(5516),
    [anon_sym_STAR_EQ] = ACTIONS(5516),
    [anon_sym_SLASH_EQ] = ACTIONS(5516),
    [anon_sym_PERCENT_EQ] = ACTIONS(5516),
    [anon_sym_PLUS_EQ] = ACTIONS(5516),
    [anon_sym_DASH_EQ] = ACTIONS(5516),
    [anon_sym_LT_LT_EQ] = ACTIONS(5516),
    [anon_sym_GT_GT_EQ] = ACTIONS(5516),
    [anon_sym_AMP_EQ] = ACTIONS(5516),
    [anon_sym_CARET_EQ] = ACTIONS(5516),
    [anon_sym_PIPE_EQ] = ACTIONS(5516),
    [anon_sym_and_eq] = ACTIONS(5514),
    [anon_sym_or_eq] = ACTIONS(5514),
    [anon_sym_xor_eq] = ACTIONS(5514),
    [anon_sym_LT_EQ_GT] = ACTIONS(5516),
    [anon_sym_or] = ACTIONS(5514),
    [anon_sym_and] = ACTIONS(5514),
    [anon_sym_bitor] = ACTIONS(5514),
    [anon_sym_xor] = ACTIONS(5514),
    [anon_sym_bitand] = ACTIONS(5514),
    [anon_sym_not_eq] = ACTIONS(5514),
    [anon_sym_DASH_DASH] = ACTIONS(5516),
    [anon_sym_PLUS_PLUS] = ACTIONS(5516),
    [anon_sym_DOT] = ACTIONS(5514),
    [anon_sym_DOT_STAR] = ACTIONS(5516),
    [anon_sym_DASH_GT] = ACTIONS(5516),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5514),
    [anon_sym_decltype] = ACTIONS(5514),
  },
  [2209] = {
    [sym_identifier] = ACTIONS(2536),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2526),
    [anon_sym_COMMA] = ACTIONS(2526),
    [anon_sym_LPAREN2] = ACTIONS(2526),
    [anon_sym_DASH] = ACTIONS(2536),
    [anon_sym_PLUS] = ACTIONS(2536),
    [anon_sym_STAR] = ACTIONS(2526),
    [anon_sym_SLASH] = ACTIONS(2536),
    [anon_sym_PERCENT] = ACTIONS(2526),
    [anon_sym_PIPE_PIPE] = ACTIONS(2526),
    [anon_sym_AMP_AMP] = ACTIONS(2526),
    [anon_sym_PIPE] = ACTIONS(2536),
    [anon_sym_CARET] = ACTIONS(2526),
    [anon_sym_AMP] = ACTIONS(2536),
    [anon_sym_EQ_EQ] = ACTIONS(2526),
    [anon_sym_BANG_EQ] = ACTIONS(2526),
    [anon_sym_GT] = ACTIONS(2536),
    [anon_sym_GT_EQ] = ACTIONS(2536),
    [anon_sym_LT_EQ] = ACTIONS(2536),
    [anon_sym_LT] = ACTIONS(2536),
    [anon_sym_LT_LT] = ACTIONS(2526),
    [anon_sym_GT_GT] = ACTIONS(2536),
    [anon_sym___extension__] = ACTIONS(2536),
    [anon_sym___attribute__] = ACTIONS(2536),
    [anon_sym___attribute] = ACTIONS(2536),
    [anon_sym_LBRACE] = ACTIONS(2526),
    [anon_sym_signed] = ACTIONS(2536),
    [anon_sym_unsigned] = ACTIONS(2536),
    [anon_sym_long] = ACTIONS(2536),
    [anon_sym_short] = ACTIONS(2536),
    [anon_sym_LBRACK] = ACTIONS(2526),
    [anon_sym_const] = ACTIONS(2536),
    [anon_sym_constexpr] = ACTIONS(2536),
    [anon_sym_volatile] = ACTIONS(2536),
    [anon_sym_restrict] = ACTIONS(2536),
    [anon_sym___restrict__] = ACTIONS(2536),
    [anon_sym__Atomic] = ACTIONS(2536),
    [anon_sym__Noreturn] = ACTIONS(2536),
    [anon_sym_noreturn] = ACTIONS(2536),
    [anon_sym__Nonnull] = ACTIONS(2536),
    [anon_sym_mutable] = ACTIONS(2536),
    [anon_sym_constinit] = ACTIONS(2536),
    [anon_sym_consteval] = ACTIONS(2536),
    [anon_sym_alignas] = ACTIONS(2536),
    [anon_sym__Alignas] = ACTIONS(2536),
    [sym_primitive_type] = ACTIONS(2536),
    [anon_sym_QMARK] = ACTIONS(2526),
    [anon_sym_LT_EQ_GT] = ACTIONS(2526),
    [anon_sym_or] = ACTIONS(2536),
    [anon_sym_and] = ACTIONS(2536),
    [anon_sym_bitor] = ACTIONS(2536),
    [anon_sym_xor] = ACTIONS(2536),
    [anon_sym_bitand] = ACTIONS(2536),
    [anon_sym_not_eq] = ACTIONS(2536),
    [anon_sym_DASH_DASH] = ACTIONS(2526),
    [anon_sym_PLUS_PLUS] = ACTIONS(2526),
    [anon_sym_DOT] = ACTIONS(2536),
    [anon_sym_DOT_STAR] = ACTIONS(2526),
    [anon_sym_DASH_GT] = ACTIONS(2526),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(2536),
    [anon_sym_decltype] = ACTIONS(2536),
    [anon_sym_final] = ACTIONS(2536),
    [anon_sym_override] = ACTIONS(2536),
    [anon_sym_GT2] = ACTIONS(2526),
    [anon_sym_requires] = ACTIONS(2536),
  },
  [2210] = {
    [sym_identifier] = ACTIONS(5630),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5632),
    [anon_sym_COMMA] = ACTIONS(5632),
    [anon_sym_RPAREN] = ACTIONS(5632),
    [aux_sym_preproc_if_token2] = ACTIONS(5632),
    [aux_sym_preproc_else_token1] = ACTIONS(5632),
    [aux_sym_preproc_elif_token1] = ACTIONS(5630),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5632),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5632),
    [anon_sym_LPAREN2] = ACTIONS(5632),
    [anon_sym_DASH] = ACTIONS(5630),
    [anon_sym_PLUS] = ACTIONS(5630),
    [anon_sym_STAR] = ACTIONS(5630),
    [anon_sym_SLASH] = ACTIONS(5630),
    [anon_sym_PERCENT] = ACTIONS(5630),
    [anon_sym_PIPE_PIPE] = ACTIONS(5632),
    [anon_sym_AMP_AMP] = ACTIONS(5632),
    [anon_sym_PIPE] = ACTIONS(5630),
    [anon_sym_CARET] = ACTIONS(5630),
    [anon_sym_AMP] = ACTIONS(5630),
    [anon_sym_EQ_EQ] = ACTIONS(5632),
    [anon_sym_BANG_EQ] = ACTIONS(5632),
    [anon_sym_GT] = ACTIONS(5630),
    [anon_sym_GT_EQ] = ACTIONS(5632),
    [anon_sym_LT_EQ] = ACTIONS(5630),
    [anon_sym_LT] = ACTIONS(5630),
    [anon_sym_LT_LT] = ACTIONS(5630),
    [anon_sym_GT_GT] = ACTIONS(5630),
    [anon_sym_SEMI] = ACTIONS(5632),
    [anon_sym___attribute__] = ACTIONS(5630),
    [anon_sym___attribute] = ACTIONS(5630),
    [anon_sym_LBRACE] = ACTIONS(5632),
    [anon_sym_RBRACE] = ACTIONS(5632),
    [anon_sym_LBRACK] = ACTIONS(5632),
    [anon_sym_RBRACK] = ACTIONS(5632),
    [anon_sym_EQ] = ACTIONS(5630),
    [anon_sym_COLON] = ACTIONS(5632),
    [anon_sym_QMARK] = ACTIONS(5632),
    [anon_sym_STAR_EQ] = ACTIONS(5632),
    [anon_sym_SLASH_EQ] = ACTIONS(5632),
    [anon_sym_PERCENT_EQ] = ACTIONS(5632),
    [anon_sym_PLUS_EQ] = ACTIONS(5632),
    [anon_sym_DASH_EQ] = ACTIONS(5632),
    [anon_sym_LT_LT_EQ] = ACTIONS(5632),
    [anon_sym_GT_GT_EQ] = ACTIONS(5632),
    [anon_sym_AMP_EQ] = ACTIONS(5632),
    [anon_sym_CARET_EQ] = ACTIONS(5632),
    [anon_sym_PIPE_EQ] = ACTIONS(5632),
    [anon_sym_and_eq] = ACTIONS(5630),
    [anon_sym_or_eq] = ACTIONS(5630),
    [anon_sym_xor_eq] = ACTIONS(5630),
    [anon_sym_LT_EQ_GT] = ACTIONS(5632),
    [anon_sym_or] = ACTIONS(5630),
    [anon_sym_and] = ACTIONS(5630),
    [anon_sym_bitor] = ACTIONS(5630),
    [anon_sym_xor] = ACTIONS(5630),
    [anon_sym_bitand] = ACTIONS(5630),
    [anon_sym_not_eq] = ACTIONS(5630),
    [anon_sym_DASH_DASH] = ACTIONS(5632),
    [anon_sym_PLUS_PLUS] = ACTIONS(5632),
    [anon_sym_DOT] = ACTIONS(5630),
    [anon_sym_DOT_STAR] = ACTIONS(5632),
    [anon_sym_DASH_GT] = ACTIONS(5632),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5630),
    [anon_sym_decltype] = ACTIONS(5630),
  },
  [2211] = {
    [sym_identifier] = ACTIONS(5431),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5433),
    [anon_sym_COMMA] = ACTIONS(5433),
    [anon_sym_RPAREN] = ACTIONS(5433),
    [aux_sym_preproc_if_token2] = ACTIONS(5433),
    [aux_sym_preproc_else_token1] = ACTIONS(5433),
    [aux_sym_preproc_elif_token1] = ACTIONS(5431),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5433),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5433),
    [anon_sym_LPAREN2] = ACTIONS(5433),
    [anon_sym_DASH] = ACTIONS(5431),
    [anon_sym_PLUS] = ACTIONS(5431),
    [anon_sym_STAR] = ACTIONS(5431),
    [anon_sym_SLASH] = ACTIONS(5431),
    [anon_sym_PERCENT] = ACTIONS(5431),
    [anon_sym_PIPE_PIPE] = ACTIONS(5433),
    [anon_sym_AMP_AMP] = ACTIONS(5433),
    [anon_sym_PIPE] = ACTIONS(5431),
    [anon_sym_CARET] = ACTIONS(5431),
    [anon_sym_AMP] = ACTIONS(5431),
    [anon_sym_EQ_EQ] = ACTIONS(5433),
    [anon_sym_BANG_EQ] = ACTIONS(5433),
    [anon_sym_GT] = ACTIONS(5431),
    [anon_sym_GT_EQ] = ACTIONS(5433),
    [anon_sym_LT_EQ] = ACTIONS(5431),
    [anon_sym_LT] = ACTIONS(5431),
    [anon_sym_LT_LT] = ACTIONS(5431),
    [anon_sym_GT_GT] = ACTIONS(5431),
    [anon_sym_SEMI] = ACTIONS(5433),
    [anon_sym___attribute__] = ACTIONS(5431),
    [anon_sym___attribute] = ACTIONS(5431),
    [anon_sym_LBRACE] = ACTIONS(5433),
    [anon_sym_RBRACE] = ACTIONS(5433),
    [anon_sym_LBRACK] = ACTIONS(5433),
    [anon_sym_RBRACK] = ACTIONS(5433),
    [anon_sym_EQ] = ACTIONS(5431),
    [anon_sym_COLON] = ACTIONS(5433),
    [anon_sym_QMARK] = ACTIONS(5433),
    [anon_sym_STAR_EQ] = ACTIONS(5433),
    [anon_sym_SLASH_EQ] = ACTIONS(5433),
    [anon_sym_PERCENT_EQ] = ACTIONS(5433),
    [anon_sym_PLUS_EQ] = ACTIONS(5433),
    [anon_sym_DASH_EQ] = ACTIONS(5433),
    [anon_sym_LT_LT_EQ] = ACTIONS(5433),
    [anon_sym_GT_GT_EQ] = ACTIONS(5433),
    [anon_sym_AMP_EQ] = ACTIONS(5433),
    [anon_sym_CARET_EQ] = ACTIONS(5433),
    [anon_sym_PIPE_EQ] = ACTIONS(5433),
    [anon_sym_and_eq] = ACTIONS(5431),
    [anon_sym_or_eq] = ACTIONS(5431),
    [anon_sym_xor_eq] = ACTIONS(5431),
    [anon_sym_LT_EQ_GT] = ACTIONS(5433),
    [anon_sym_or] = ACTIONS(5431),
    [anon_sym_and] = ACTIONS(5431),
    [anon_sym_bitor] = ACTIONS(5431),
    [anon_sym_xor] = ACTIONS(5431),
    [anon_sym_bitand] = ACTIONS(5431),
    [anon_sym_not_eq] = ACTIONS(5431),
    [anon_sym_DASH_DASH] = ACTIONS(5433),
    [anon_sym_PLUS_PLUS] = ACTIONS(5433),
    [anon_sym_DOT] = ACTIONS(5431),
    [anon_sym_DOT_STAR] = ACTIONS(5433),
    [anon_sym_DASH_GT] = ACTIONS(5433),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5431),
    [anon_sym_decltype] = ACTIONS(5431),
  },
  [2212] = {
    [sym_identifier] = ACTIONS(5640),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5642),
    [anon_sym_COMMA] = ACTIONS(5642),
    [anon_sym_RPAREN] = ACTIONS(5642),
    [aux_sym_preproc_if_token2] = ACTIONS(5642),
    [aux_sym_preproc_else_token1] = ACTIONS(5642),
    [aux_sym_preproc_elif_token1] = ACTIONS(5640),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5642),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5642),
    [anon_sym_LPAREN2] = ACTIONS(5642),
    [anon_sym_DASH] = ACTIONS(5640),
    [anon_sym_PLUS] = ACTIONS(5640),
    [anon_sym_STAR] = ACTIONS(5640),
    [anon_sym_SLASH] = ACTIONS(5640),
    [anon_sym_PERCENT] = ACTIONS(5640),
    [anon_sym_PIPE_PIPE] = ACTIONS(5642),
    [anon_sym_AMP_AMP] = ACTIONS(5642),
    [anon_sym_PIPE] = ACTIONS(5640),
    [anon_sym_CARET] = ACTIONS(5640),
    [anon_sym_AMP] = ACTIONS(5640),
    [anon_sym_EQ_EQ] = ACTIONS(5642),
    [anon_sym_BANG_EQ] = ACTIONS(5642),
    [anon_sym_GT] = ACTIONS(5640),
    [anon_sym_GT_EQ] = ACTIONS(5642),
    [anon_sym_LT_EQ] = ACTIONS(5640),
    [anon_sym_LT] = ACTIONS(5640),
    [anon_sym_LT_LT] = ACTIONS(5640),
    [anon_sym_GT_GT] = ACTIONS(5640),
    [anon_sym_SEMI] = ACTIONS(5642),
    [anon_sym___attribute__] = ACTIONS(5640),
    [anon_sym___attribute] = ACTIONS(5640),
    [anon_sym_LBRACE] = ACTIONS(5642),
    [anon_sym_RBRACE] = ACTIONS(5642),
    [anon_sym_LBRACK] = ACTIONS(5642),
    [anon_sym_RBRACK] = ACTIONS(5642),
    [anon_sym_EQ] = ACTIONS(5640),
    [anon_sym_COLON] = ACTIONS(5642),
    [anon_sym_QMARK] = ACTIONS(5642),
    [anon_sym_STAR_EQ] = ACTIONS(5642),
    [anon_sym_SLASH_EQ] = ACTIONS(5642),
    [anon_sym_PERCENT_EQ] = ACTIONS(5642),
    [anon_sym_PLUS_EQ] = ACTIONS(5642),
    [anon_sym_DASH_EQ] = ACTIONS(5642),
    [anon_sym_LT_LT_EQ] = ACTIONS(5642),
    [anon_sym_GT_GT_EQ] = ACTIONS(5642),
    [anon_sym_AMP_EQ] = ACTIONS(5642),
    [anon_sym_CARET_EQ] = ACTIONS(5642),
    [anon_sym_PIPE_EQ] = ACTIONS(5642),
    [anon_sym_and_eq] = ACTIONS(5640),
    [anon_sym_or_eq] = ACTIONS(5640),
    [anon_sym_xor_eq] = ACTIONS(5640),
    [anon_sym_LT_EQ_GT] = ACTIONS(5642),
    [anon_sym_or] = ACTIONS(5640),
    [anon_sym_and] = ACTIONS(5640),
    [anon_sym_bitor] = ACTIONS(5640),
    [anon_sym_xor] = ACTIONS(5640),
    [anon_sym_bitand] = ACTIONS(5640),
    [anon_sym_not_eq] = ACTIONS(5640),
    [anon_sym_DASH_DASH] = ACTIONS(5642),
    [anon_sym_PLUS_PLUS] = ACTIONS(5642),
    [anon_sym_DOT] = ACTIONS(5640),
    [anon_sym_DOT_STAR] = ACTIONS(5642),
    [anon_sym_DASH_GT] = ACTIONS(5642),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5640),
    [anon_sym_decltype] = ACTIONS(5640),
  },
  [2213] = {
    [sym_argument_list] = STATE(2413),
    [sym_initializer_list] = STATE(2413),
    [sym_identifier] = ACTIONS(6088),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6090),
    [anon_sym_COMMA] = ACTIONS(6090),
    [anon_sym_RPAREN] = ACTIONS(6090),
    [aux_sym_preproc_if_token2] = ACTIONS(6090),
    [aux_sym_preproc_else_token1] = ACTIONS(6090),
    [aux_sym_preproc_elif_token1] = ACTIONS(6088),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6090),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6090),
    [anon_sym_LPAREN2] = ACTIONS(5688),
    [anon_sym_DASH] = ACTIONS(6088),
    [anon_sym_PLUS] = ACTIONS(6088),
    [anon_sym_STAR] = ACTIONS(6088),
    [anon_sym_SLASH] = ACTIONS(6088),
    [anon_sym_PERCENT] = ACTIONS(6088),
    [anon_sym_PIPE_PIPE] = ACTIONS(6090),
    [anon_sym_AMP_AMP] = ACTIONS(6090),
    [anon_sym_PIPE] = ACTIONS(6088),
    [anon_sym_CARET] = ACTIONS(6088),
    [anon_sym_AMP] = ACTIONS(6088),
    [anon_sym_EQ_EQ] = ACTIONS(6090),
    [anon_sym_BANG_EQ] = ACTIONS(6090),
    [anon_sym_GT] = ACTIONS(6088),
    [anon_sym_GT_EQ] = ACTIONS(6090),
    [anon_sym_LT_EQ] = ACTIONS(6088),
    [anon_sym_LT] = ACTIONS(6088),
    [anon_sym_LT_LT] = ACTIONS(6088),
    [anon_sym_GT_GT] = ACTIONS(6088),
    [anon_sym_SEMI] = ACTIONS(6090),
    [anon_sym___attribute__] = ACTIONS(6088),
    [anon_sym___attribute] = ACTIONS(6088),
    [anon_sym_LBRACE] = ACTIONS(1927),
    [anon_sym_RBRACE] = ACTIONS(6090),
    [anon_sym_LBRACK] = ACTIONS(6090),
    [anon_sym_RBRACK] = ACTIONS(6090),
    [anon_sym_EQ] = ACTIONS(6088),
    [anon_sym_COLON] = ACTIONS(6090),
    [anon_sym_QMARK] = ACTIONS(6090),
    [anon_sym_STAR_EQ] = ACTIONS(6090),
    [anon_sym_SLASH_EQ] = ACTIONS(6090),
    [anon_sym_PERCENT_EQ] = ACTIONS(6090),
    [anon_sym_PLUS_EQ] = ACTIONS(6090),
    [anon_sym_DASH_EQ] = ACTIONS(6090),
    [anon_sym_LT_LT_EQ] = ACTIONS(6090),
    [anon_sym_GT_GT_EQ] = ACTIONS(6090),
    [anon_sym_AMP_EQ] = ACTIONS(6090),
    [anon_sym_CARET_EQ] = ACTIONS(6090),
    [anon_sym_PIPE_EQ] = ACTIONS(6090),
    [anon_sym_and_eq] = ACTIONS(6088),
    [anon_sym_or_eq] = ACTIONS(6088),
    [anon_sym_xor_eq] = ACTIONS(6088),
    [anon_sym_LT_EQ_GT] = ACTIONS(6090),
    [anon_sym_or] = ACTIONS(6088),
    [anon_sym_and] = ACTIONS(6088),
    [anon_sym_bitor] = ACTIONS(6088),
    [anon_sym_xor] = ACTIONS(6088),
    [anon_sym_bitand] = ACTIONS(6088),
    [anon_sym_not_eq] = ACTIONS(6088),
    [anon_sym_DASH_DASH] = ACTIONS(6090),
    [anon_sym_PLUS_PLUS] = ACTIONS(6090),
    [anon_sym_DOT] = ACTIONS(6088),
    [anon_sym_DOT_STAR] = ACTIONS(6090),
    [anon_sym_DASH_GT] = ACTIONS(6090),
    [sym_comment] = ACTIONS(3),
  },
  [2214] = {
    [sym_identifier] = ACTIONS(4810),
    [anon_sym_LPAREN2] = ACTIONS(4812),
    [anon_sym_TILDE] = ACTIONS(4812),
    [anon_sym_STAR] = ACTIONS(4812),
    [anon_sym_PIPE_PIPE] = ACTIONS(4812),
    [anon_sym_AMP_AMP] = ACTIONS(4812),
    [anon_sym_AMP] = ACTIONS(4810),
    [anon_sym___extension__] = ACTIONS(4810),
    [anon_sym_virtual] = ACTIONS(4810),
    [anon_sym_extern] = ACTIONS(4810),
    [anon_sym___attribute__] = ACTIONS(4810),
    [anon_sym___attribute] = ACTIONS(4810),
    [anon_sym_COLON_COLON] = ACTIONS(4812),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4812),
    [anon_sym___declspec] = ACTIONS(4810),
    [anon_sym___based] = ACTIONS(4810),
    [anon_sym___cdecl] = ACTIONS(4810),
    [anon_sym___clrcall] = ACTIONS(4810),
    [anon_sym___stdcall] = ACTIONS(4810),
    [anon_sym___fastcall] = ACTIONS(4810),
    [anon_sym___thiscall] = ACTIONS(4810),
    [anon_sym___vectorcall] = ACTIONS(4810),
    [anon_sym_signed] = ACTIONS(4810),
    [anon_sym_unsigned] = ACTIONS(4810),
    [anon_sym_long] = ACTIONS(4810),
    [anon_sym_short] = ACTIONS(4810),
    [anon_sym_LBRACK] = ACTIONS(4810),
    [anon_sym_static] = ACTIONS(4810),
    [anon_sym_register] = ACTIONS(4810),
    [anon_sym_inline] = ACTIONS(4810),
    [anon_sym___inline] = ACTIONS(4810),
    [anon_sym___inline__] = ACTIONS(4810),
    [anon_sym___forceinline] = ACTIONS(4810),
    [anon_sym_thread_local] = ACTIONS(4810),
    [anon_sym___thread] = ACTIONS(4810),
    [anon_sym_const] = ACTIONS(4810),
    [anon_sym_constexpr] = ACTIONS(4810),
    [anon_sym_volatile] = ACTIONS(4810),
    [anon_sym_restrict] = ACTIONS(4810),
    [anon_sym___restrict__] = ACTIONS(4810),
    [anon_sym__Atomic] = ACTIONS(4810),
    [anon_sym__Noreturn] = ACTIONS(4810),
    [anon_sym_noreturn] = ACTIONS(4810),
    [anon_sym__Nonnull] = ACTIONS(4810),
    [anon_sym_mutable] = ACTIONS(4810),
    [anon_sym_constinit] = ACTIONS(4810),
    [anon_sym_consteval] = ACTIONS(4810),
    [anon_sym_alignas] = ACTIONS(4810),
    [anon_sym__Alignas] = ACTIONS(4810),
    [sym_primitive_type] = ACTIONS(4810),
    [anon_sym_enum] = ACTIONS(4810),
    [anon_sym_class] = ACTIONS(4810),
    [anon_sym_struct] = ACTIONS(4810),
    [anon_sym_union] = ACTIONS(4810),
    [anon_sym_or] = ACTIONS(4810),
    [anon_sym_and] = ACTIONS(4810),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4810),
    [anon_sym_decltype] = ACTIONS(4810),
    [anon_sym_explicit] = ACTIONS(4810),
    [anon_sym_typename] = ACTIONS(4810),
    [anon_sym_template] = ACTIONS(4810),
    [anon_sym_operator] = ACTIONS(4810),
    [anon_sym_friend] = ACTIONS(4810),
    [anon_sym_using] = ACTIONS(4810),
    [anon_sym_concept] = ACTIONS(4810),
  },
  [2215] = {
    [sym_identifier] = ACTIONS(4826),
    [anon_sym_LPAREN2] = ACTIONS(4828),
    [anon_sym_TILDE] = ACTIONS(4828),
    [anon_sym_STAR] = ACTIONS(4828),
    [anon_sym_PIPE_PIPE] = ACTIONS(4828),
    [anon_sym_AMP_AMP] = ACTIONS(4828),
    [anon_sym_AMP] = ACTIONS(4826),
    [anon_sym___extension__] = ACTIONS(4826),
    [anon_sym_virtual] = ACTIONS(4826),
    [anon_sym_extern] = ACTIONS(4826),
    [anon_sym___attribute__] = ACTIONS(4826),
    [anon_sym___attribute] = ACTIONS(4826),
    [anon_sym_COLON_COLON] = ACTIONS(4828),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4828),
    [anon_sym___declspec] = ACTIONS(4826),
    [anon_sym___based] = ACTIONS(4826),
    [anon_sym___cdecl] = ACTIONS(4826),
    [anon_sym___clrcall] = ACTIONS(4826),
    [anon_sym___stdcall] = ACTIONS(4826),
    [anon_sym___fastcall] = ACTIONS(4826),
    [anon_sym___thiscall] = ACTIONS(4826),
    [anon_sym___vectorcall] = ACTIONS(4826),
    [anon_sym_signed] = ACTIONS(4826),
    [anon_sym_unsigned] = ACTIONS(4826),
    [anon_sym_long] = ACTIONS(4826),
    [anon_sym_short] = ACTIONS(4826),
    [anon_sym_LBRACK] = ACTIONS(4826),
    [anon_sym_static] = ACTIONS(4826),
    [anon_sym_register] = ACTIONS(4826),
    [anon_sym_inline] = ACTIONS(4826),
    [anon_sym___inline] = ACTIONS(4826),
    [anon_sym___inline__] = ACTIONS(4826),
    [anon_sym___forceinline] = ACTIONS(4826),
    [anon_sym_thread_local] = ACTIONS(4826),
    [anon_sym___thread] = ACTIONS(4826),
    [anon_sym_const] = ACTIONS(4826),
    [anon_sym_constexpr] = ACTIONS(4826),
    [anon_sym_volatile] = ACTIONS(4826),
    [anon_sym_restrict] = ACTIONS(4826),
    [anon_sym___restrict__] = ACTIONS(4826),
    [anon_sym__Atomic] = ACTIONS(4826),
    [anon_sym__Noreturn] = ACTIONS(4826),
    [anon_sym_noreturn] = ACTIONS(4826),
    [anon_sym__Nonnull] = ACTIONS(4826),
    [anon_sym_mutable] = ACTIONS(4826),
    [anon_sym_constinit] = ACTIONS(4826),
    [anon_sym_consteval] = ACTIONS(4826),
    [anon_sym_alignas] = ACTIONS(4826),
    [anon_sym__Alignas] = ACTIONS(4826),
    [sym_primitive_type] = ACTIONS(4826),
    [anon_sym_enum] = ACTIONS(4826),
    [anon_sym_class] = ACTIONS(4826),
    [anon_sym_struct] = ACTIONS(4826),
    [anon_sym_union] = ACTIONS(4826),
    [anon_sym_or] = ACTIONS(4826),
    [anon_sym_and] = ACTIONS(4826),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4826),
    [anon_sym_decltype] = ACTIONS(4826),
    [anon_sym_explicit] = ACTIONS(4826),
    [anon_sym_typename] = ACTIONS(4826),
    [anon_sym_template] = ACTIONS(4826),
    [anon_sym_operator] = ACTIONS(4826),
    [anon_sym_friend] = ACTIONS(4826),
    [anon_sym_using] = ACTIONS(4826),
    [anon_sym_concept] = ACTIONS(4826),
  },
  [2216] = {
    [sym_identifier] = ACTIONS(4818),
    [anon_sym_LPAREN2] = ACTIONS(4820),
    [anon_sym_TILDE] = ACTIONS(4820),
    [anon_sym_STAR] = ACTIONS(4820),
    [anon_sym_PIPE_PIPE] = ACTIONS(4820),
    [anon_sym_AMP_AMP] = ACTIONS(4820),
    [anon_sym_AMP] = ACTIONS(4818),
    [anon_sym___extension__] = ACTIONS(4818),
    [anon_sym_virtual] = ACTIONS(4818),
    [anon_sym_extern] = ACTIONS(4818),
    [anon_sym___attribute__] = ACTIONS(4818),
    [anon_sym___attribute] = ACTIONS(4818),
    [anon_sym_COLON_COLON] = ACTIONS(4820),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4820),
    [anon_sym___declspec] = ACTIONS(4818),
    [anon_sym___based] = ACTIONS(4818),
    [anon_sym___cdecl] = ACTIONS(4818),
    [anon_sym___clrcall] = ACTIONS(4818),
    [anon_sym___stdcall] = ACTIONS(4818),
    [anon_sym___fastcall] = ACTIONS(4818),
    [anon_sym___thiscall] = ACTIONS(4818),
    [anon_sym___vectorcall] = ACTIONS(4818),
    [anon_sym_signed] = ACTIONS(4818),
    [anon_sym_unsigned] = ACTIONS(4818),
    [anon_sym_long] = ACTIONS(4818),
    [anon_sym_short] = ACTIONS(4818),
    [anon_sym_LBRACK] = ACTIONS(4818),
    [anon_sym_static] = ACTIONS(4818),
    [anon_sym_register] = ACTIONS(4818),
    [anon_sym_inline] = ACTIONS(4818),
    [anon_sym___inline] = ACTIONS(4818),
    [anon_sym___inline__] = ACTIONS(4818),
    [anon_sym___forceinline] = ACTIONS(4818),
    [anon_sym_thread_local] = ACTIONS(4818),
    [anon_sym___thread] = ACTIONS(4818),
    [anon_sym_const] = ACTIONS(4818),
    [anon_sym_constexpr] = ACTIONS(4818),
    [anon_sym_volatile] = ACTIONS(4818),
    [anon_sym_restrict] = ACTIONS(4818),
    [anon_sym___restrict__] = ACTIONS(4818),
    [anon_sym__Atomic] = ACTIONS(4818),
    [anon_sym__Noreturn] = ACTIONS(4818),
    [anon_sym_noreturn] = ACTIONS(4818),
    [anon_sym__Nonnull] = ACTIONS(4818),
    [anon_sym_mutable] = ACTIONS(4818),
    [anon_sym_constinit] = ACTIONS(4818),
    [anon_sym_consteval] = ACTIONS(4818),
    [anon_sym_alignas] = ACTIONS(4818),
    [anon_sym__Alignas] = ACTIONS(4818),
    [sym_primitive_type] = ACTIONS(4818),
    [anon_sym_enum] = ACTIONS(4818),
    [anon_sym_class] = ACTIONS(4818),
    [anon_sym_struct] = ACTIONS(4818),
    [anon_sym_union] = ACTIONS(4818),
    [anon_sym_or] = ACTIONS(4818),
    [anon_sym_and] = ACTIONS(4818),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4818),
    [anon_sym_decltype] = ACTIONS(4818),
    [anon_sym_explicit] = ACTIONS(4818),
    [anon_sym_typename] = ACTIONS(4818),
    [anon_sym_template] = ACTIONS(4818),
    [anon_sym_operator] = ACTIONS(4818),
    [anon_sym_friend] = ACTIONS(4818),
    [anon_sym_using] = ACTIONS(4818),
    [anon_sym_concept] = ACTIONS(4818),
  },
  [2217] = {
    [sym_identifier] = ACTIONS(4822),
    [anon_sym_LPAREN2] = ACTIONS(4824),
    [anon_sym_TILDE] = ACTIONS(4824),
    [anon_sym_STAR] = ACTIONS(4824),
    [anon_sym_PIPE_PIPE] = ACTIONS(4824),
    [anon_sym_AMP_AMP] = ACTIONS(4824),
    [anon_sym_AMP] = ACTIONS(4822),
    [anon_sym___extension__] = ACTIONS(4822),
    [anon_sym_virtual] = ACTIONS(4822),
    [anon_sym_extern] = ACTIONS(4822),
    [anon_sym___attribute__] = ACTIONS(4822),
    [anon_sym___attribute] = ACTIONS(4822),
    [anon_sym_COLON_COLON] = ACTIONS(4824),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4824),
    [anon_sym___declspec] = ACTIONS(4822),
    [anon_sym___based] = ACTIONS(4822),
    [anon_sym___cdecl] = ACTIONS(4822),
    [anon_sym___clrcall] = ACTIONS(4822),
    [anon_sym___stdcall] = ACTIONS(4822),
    [anon_sym___fastcall] = ACTIONS(4822),
    [anon_sym___thiscall] = ACTIONS(4822),
    [anon_sym___vectorcall] = ACTIONS(4822),
    [anon_sym_signed] = ACTIONS(4822),
    [anon_sym_unsigned] = ACTIONS(4822),
    [anon_sym_long] = ACTIONS(4822),
    [anon_sym_short] = ACTIONS(4822),
    [anon_sym_LBRACK] = ACTIONS(4822),
    [anon_sym_static] = ACTIONS(4822),
    [anon_sym_register] = ACTIONS(4822),
    [anon_sym_inline] = ACTIONS(4822),
    [anon_sym___inline] = ACTIONS(4822),
    [anon_sym___inline__] = ACTIONS(4822),
    [anon_sym___forceinline] = ACTIONS(4822),
    [anon_sym_thread_local] = ACTIONS(4822),
    [anon_sym___thread] = ACTIONS(4822),
    [anon_sym_const] = ACTIONS(4822),
    [anon_sym_constexpr] = ACTIONS(4822),
    [anon_sym_volatile] = ACTIONS(4822),
    [anon_sym_restrict] = ACTIONS(4822),
    [anon_sym___restrict__] = ACTIONS(4822),
    [anon_sym__Atomic] = ACTIONS(4822),
    [anon_sym__Noreturn] = ACTIONS(4822),
    [anon_sym_noreturn] = ACTIONS(4822),
    [anon_sym__Nonnull] = ACTIONS(4822),
    [anon_sym_mutable] = ACTIONS(4822),
    [anon_sym_constinit] = ACTIONS(4822),
    [anon_sym_consteval] = ACTIONS(4822),
    [anon_sym_alignas] = ACTIONS(4822),
    [anon_sym__Alignas] = ACTIONS(4822),
    [sym_primitive_type] = ACTIONS(4822),
    [anon_sym_enum] = ACTIONS(4822),
    [anon_sym_class] = ACTIONS(4822),
    [anon_sym_struct] = ACTIONS(4822),
    [anon_sym_union] = ACTIONS(4822),
    [anon_sym_or] = ACTIONS(4822),
    [anon_sym_and] = ACTIONS(4822),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4822),
    [anon_sym_decltype] = ACTIONS(4822),
    [anon_sym_explicit] = ACTIONS(4822),
    [anon_sym_typename] = ACTIONS(4822),
    [anon_sym_template] = ACTIONS(4822),
    [anon_sym_operator] = ACTIONS(4822),
    [anon_sym_friend] = ACTIONS(4822),
    [anon_sym_using] = ACTIONS(4822),
    [anon_sym_concept] = ACTIONS(4822),
  },
  [2218] = {
    [sym_identifier] = ACTIONS(6092),
    [anon_sym_LPAREN2] = ACTIONS(6094),
    [anon_sym_TILDE] = ACTIONS(6094),
    [anon_sym_STAR] = ACTIONS(6094),
    [anon_sym_PIPE_PIPE] = ACTIONS(6096),
    [anon_sym_AMP_AMP] = ACTIONS(6061),
    [anon_sym_AMP] = ACTIONS(6092),
    [anon_sym___extension__] = ACTIONS(6092),
    [anon_sym_virtual] = ACTIONS(6092),
    [anon_sym_extern] = ACTIONS(6092),
    [anon_sym___attribute__] = ACTIONS(6092),
    [anon_sym___attribute] = ACTIONS(6092),
    [anon_sym_COLON_COLON] = ACTIONS(6094),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6094),
    [anon_sym___declspec] = ACTIONS(6092),
    [anon_sym___based] = ACTIONS(6092),
    [anon_sym___cdecl] = ACTIONS(6092),
    [anon_sym___clrcall] = ACTIONS(6092),
    [anon_sym___stdcall] = ACTIONS(6092),
    [anon_sym___fastcall] = ACTIONS(6092),
    [anon_sym___thiscall] = ACTIONS(6092),
    [anon_sym___vectorcall] = ACTIONS(6092),
    [anon_sym_signed] = ACTIONS(6092),
    [anon_sym_unsigned] = ACTIONS(6092),
    [anon_sym_long] = ACTIONS(6092),
    [anon_sym_short] = ACTIONS(6092),
    [anon_sym_LBRACK] = ACTIONS(6092),
    [anon_sym_static] = ACTIONS(6092),
    [anon_sym_register] = ACTIONS(6092),
    [anon_sym_inline] = ACTIONS(6092),
    [anon_sym___inline] = ACTIONS(6092),
    [anon_sym___inline__] = ACTIONS(6092),
    [anon_sym___forceinline] = ACTIONS(6092),
    [anon_sym_thread_local] = ACTIONS(6092),
    [anon_sym___thread] = ACTIONS(6092),
    [anon_sym_const] = ACTIONS(6092),
    [anon_sym_constexpr] = ACTIONS(6092),
    [anon_sym_volatile] = ACTIONS(6092),
    [anon_sym_restrict] = ACTIONS(6092),
    [anon_sym___restrict__] = ACTIONS(6092),
    [anon_sym__Atomic] = ACTIONS(6092),
    [anon_sym__Noreturn] = ACTIONS(6092),
    [anon_sym_noreturn] = ACTIONS(6092),
    [anon_sym__Nonnull] = ACTIONS(6092),
    [anon_sym_mutable] = ACTIONS(6092),
    [anon_sym_constinit] = ACTIONS(6092),
    [anon_sym_consteval] = ACTIONS(6092),
    [anon_sym_alignas] = ACTIONS(6092),
    [anon_sym__Alignas] = ACTIONS(6092),
    [sym_primitive_type] = ACTIONS(6092),
    [anon_sym_enum] = ACTIONS(6092),
    [anon_sym_class] = ACTIONS(6092),
    [anon_sym_struct] = ACTIONS(6092),
    [anon_sym_union] = ACTIONS(6092),
    [anon_sym_or] = ACTIONS(6098),
    [anon_sym_and] = ACTIONS(6063),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6092),
    [anon_sym_decltype] = ACTIONS(6092),
    [anon_sym_explicit] = ACTIONS(6092),
    [anon_sym_typename] = ACTIONS(6092),
    [anon_sym_template] = ACTIONS(6092),
    [anon_sym_operator] = ACTIONS(6092),
    [anon_sym_friend] = ACTIONS(6092),
    [anon_sym_using] = ACTIONS(6092),
    [anon_sym_concept] = ACTIONS(6092),
  },
  [2219] = {
    [sym_identifier] = ACTIONS(4830),
    [anon_sym_LPAREN2] = ACTIONS(4832),
    [anon_sym_TILDE] = ACTIONS(4832),
    [anon_sym_STAR] = ACTIONS(4832),
    [anon_sym_PIPE_PIPE] = ACTIONS(4832),
    [anon_sym_AMP_AMP] = ACTIONS(4832),
    [anon_sym_AMP] = ACTIONS(4830),
    [anon_sym___extension__] = ACTIONS(4830),
    [anon_sym_virtual] = ACTIONS(4830),
    [anon_sym_extern] = ACTIONS(4830),
    [anon_sym___attribute__] = ACTIONS(4830),
    [anon_sym___attribute] = ACTIONS(4830),
    [anon_sym_COLON_COLON] = ACTIONS(4832),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4832),
    [anon_sym___declspec] = ACTIONS(4830),
    [anon_sym___based] = ACTIONS(4830),
    [anon_sym___cdecl] = ACTIONS(4830),
    [anon_sym___clrcall] = ACTIONS(4830),
    [anon_sym___stdcall] = ACTIONS(4830),
    [anon_sym___fastcall] = ACTIONS(4830),
    [anon_sym___thiscall] = ACTIONS(4830),
    [anon_sym___vectorcall] = ACTIONS(4830),
    [anon_sym_signed] = ACTIONS(4830),
    [anon_sym_unsigned] = ACTIONS(4830),
    [anon_sym_long] = ACTIONS(4830),
    [anon_sym_short] = ACTIONS(4830),
    [anon_sym_LBRACK] = ACTIONS(4830),
    [anon_sym_static] = ACTIONS(4830),
    [anon_sym_register] = ACTIONS(4830),
    [anon_sym_inline] = ACTIONS(4830),
    [anon_sym___inline] = ACTIONS(4830),
    [anon_sym___inline__] = ACTIONS(4830),
    [anon_sym___forceinline] = ACTIONS(4830),
    [anon_sym_thread_local] = ACTIONS(4830),
    [anon_sym___thread] = ACTIONS(4830),
    [anon_sym_const] = ACTIONS(4830),
    [anon_sym_constexpr] = ACTIONS(4830),
    [anon_sym_volatile] = ACTIONS(4830),
    [anon_sym_restrict] = ACTIONS(4830),
    [anon_sym___restrict__] = ACTIONS(4830),
    [anon_sym__Atomic] = ACTIONS(4830),
    [anon_sym__Noreturn] = ACTIONS(4830),
    [anon_sym_noreturn] = ACTIONS(4830),
    [anon_sym__Nonnull] = ACTIONS(4830),
    [anon_sym_mutable] = ACTIONS(4830),
    [anon_sym_constinit] = ACTIONS(4830),
    [anon_sym_consteval] = ACTIONS(4830),
    [anon_sym_alignas] = ACTIONS(4830),
    [anon_sym__Alignas] = ACTIONS(4830),
    [sym_primitive_type] = ACTIONS(4830),
    [anon_sym_enum] = ACTIONS(4830),
    [anon_sym_class] = ACTIONS(4830),
    [anon_sym_struct] = ACTIONS(4830),
    [anon_sym_union] = ACTIONS(4830),
    [anon_sym_or] = ACTIONS(4830),
    [anon_sym_and] = ACTIONS(4830),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4830),
    [anon_sym_decltype] = ACTIONS(4830),
    [anon_sym_explicit] = ACTIONS(4830),
    [anon_sym_typename] = ACTIONS(4830),
    [anon_sym_template] = ACTIONS(4830),
    [anon_sym_operator] = ACTIONS(4830),
    [anon_sym_friend] = ACTIONS(4830),
    [anon_sym_using] = ACTIONS(4830),
    [anon_sym_concept] = ACTIONS(4830),
  },
  [2220] = {
    [sym_identifier] = ACTIONS(4834),
    [anon_sym_LPAREN2] = ACTIONS(4836),
    [anon_sym_TILDE] = ACTIONS(4836),
    [anon_sym_STAR] = ACTIONS(4836),
    [anon_sym_PIPE_PIPE] = ACTIONS(4836),
    [anon_sym_AMP_AMP] = ACTIONS(4836),
    [anon_sym_AMP] = ACTIONS(4834),
    [anon_sym___extension__] = ACTIONS(4834),
    [anon_sym_virtual] = ACTIONS(4834),
    [anon_sym_extern] = ACTIONS(4834),
    [anon_sym___attribute__] = ACTIONS(4834),
    [anon_sym___attribute] = ACTIONS(4834),
    [anon_sym_COLON_COLON] = ACTIONS(4836),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4836),
    [anon_sym___declspec] = ACTIONS(4834),
    [anon_sym___based] = ACTIONS(4834),
    [anon_sym___cdecl] = ACTIONS(4834),
    [anon_sym___clrcall] = ACTIONS(4834),
    [anon_sym___stdcall] = ACTIONS(4834),
    [anon_sym___fastcall] = ACTIONS(4834),
    [anon_sym___thiscall] = ACTIONS(4834),
    [anon_sym___vectorcall] = ACTIONS(4834),
    [anon_sym_signed] = ACTIONS(4834),
    [anon_sym_unsigned] = ACTIONS(4834),
    [anon_sym_long] = ACTIONS(4834),
    [anon_sym_short] = ACTIONS(4834),
    [anon_sym_LBRACK] = ACTIONS(4834),
    [anon_sym_static] = ACTIONS(4834),
    [anon_sym_register] = ACTIONS(4834),
    [anon_sym_inline] = ACTIONS(4834),
    [anon_sym___inline] = ACTIONS(4834),
    [anon_sym___inline__] = ACTIONS(4834),
    [anon_sym___forceinline] = ACTIONS(4834),
    [anon_sym_thread_local] = ACTIONS(4834),
    [anon_sym___thread] = ACTIONS(4834),
    [anon_sym_const] = ACTIONS(4834),
    [anon_sym_constexpr] = ACTIONS(4834),
    [anon_sym_volatile] = ACTIONS(4834),
    [anon_sym_restrict] = ACTIONS(4834),
    [anon_sym___restrict__] = ACTIONS(4834),
    [anon_sym__Atomic] = ACTIONS(4834),
    [anon_sym__Noreturn] = ACTIONS(4834),
    [anon_sym_noreturn] = ACTIONS(4834),
    [anon_sym__Nonnull] = ACTIONS(4834),
    [anon_sym_mutable] = ACTIONS(4834),
    [anon_sym_constinit] = ACTIONS(4834),
    [anon_sym_consteval] = ACTIONS(4834),
    [anon_sym_alignas] = ACTIONS(4834),
    [anon_sym__Alignas] = ACTIONS(4834),
    [sym_primitive_type] = ACTIONS(4834),
    [anon_sym_enum] = ACTIONS(4834),
    [anon_sym_class] = ACTIONS(4834),
    [anon_sym_struct] = ACTIONS(4834),
    [anon_sym_union] = ACTIONS(4834),
    [anon_sym_or] = ACTIONS(4834),
    [anon_sym_and] = ACTIONS(4834),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4834),
    [anon_sym_decltype] = ACTIONS(4834),
    [anon_sym_explicit] = ACTIONS(4834),
    [anon_sym_typename] = ACTIONS(4834),
    [anon_sym_template] = ACTIONS(4834),
    [anon_sym_operator] = ACTIONS(4834),
    [anon_sym_friend] = ACTIONS(4834),
    [anon_sym_using] = ACTIONS(4834),
    [anon_sym_concept] = ACTIONS(4834),
  },
  [2221] = {
    [sym_identifier] = ACTIONS(6100),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6102),
    [anon_sym_COMMA] = ACTIONS(6102),
    [anon_sym_RPAREN] = ACTIONS(6102),
    [aux_sym_preproc_if_token2] = ACTIONS(6102),
    [aux_sym_preproc_else_token1] = ACTIONS(6102),
    [aux_sym_preproc_elif_token1] = ACTIONS(6100),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6102),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6102),
    [anon_sym_LPAREN2] = ACTIONS(6102),
    [anon_sym_DASH] = ACTIONS(6100),
    [anon_sym_PLUS] = ACTIONS(6100),
    [anon_sym_STAR] = ACTIONS(6100),
    [anon_sym_SLASH] = ACTIONS(6100),
    [anon_sym_PERCENT] = ACTIONS(6100),
    [anon_sym_PIPE_PIPE] = ACTIONS(6102),
    [anon_sym_AMP_AMP] = ACTIONS(6102),
    [anon_sym_PIPE] = ACTIONS(6100),
    [anon_sym_CARET] = ACTIONS(6100),
    [anon_sym_AMP] = ACTIONS(6100),
    [anon_sym_EQ_EQ] = ACTIONS(6102),
    [anon_sym_BANG_EQ] = ACTIONS(6102),
    [anon_sym_GT] = ACTIONS(6100),
    [anon_sym_GT_EQ] = ACTIONS(6102),
    [anon_sym_LT_EQ] = ACTIONS(6100),
    [anon_sym_LT] = ACTIONS(6100),
    [anon_sym_LT_LT] = ACTIONS(6100),
    [anon_sym_GT_GT] = ACTIONS(6100),
    [anon_sym_SEMI] = ACTIONS(6102),
    [anon_sym___attribute__] = ACTIONS(6100),
    [anon_sym___attribute] = ACTIONS(6100),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6102),
    [anon_sym_LBRACE] = ACTIONS(6102),
    [anon_sym_RBRACE] = ACTIONS(6102),
    [anon_sym_LBRACK] = ACTIONS(6100),
    [anon_sym_RBRACK] = ACTIONS(6102),
    [anon_sym_EQ] = ACTIONS(6100),
    [anon_sym_COLON] = ACTIONS(6102),
    [anon_sym_QMARK] = ACTIONS(6102),
    [anon_sym_STAR_EQ] = ACTIONS(6102),
    [anon_sym_SLASH_EQ] = ACTIONS(6102),
    [anon_sym_PERCENT_EQ] = ACTIONS(6102),
    [anon_sym_PLUS_EQ] = ACTIONS(6102),
    [anon_sym_DASH_EQ] = ACTIONS(6102),
    [anon_sym_LT_LT_EQ] = ACTIONS(6102),
    [anon_sym_GT_GT_EQ] = ACTIONS(6102),
    [anon_sym_AMP_EQ] = ACTIONS(6102),
    [anon_sym_CARET_EQ] = ACTIONS(6102),
    [anon_sym_PIPE_EQ] = ACTIONS(6102),
    [anon_sym_and_eq] = ACTIONS(6100),
    [anon_sym_or_eq] = ACTIONS(6100),
    [anon_sym_xor_eq] = ACTIONS(6100),
    [anon_sym_LT_EQ_GT] = ACTIONS(6102),
    [anon_sym_or] = ACTIONS(6100),
    [anon_sym_and] = ACTIONS(6100),
    [anon_sym_bitor] = ACTIONS(6100),
    [anon_sym_xor] = ACTIONS(6100),
    [anon_sym_bitand] = ACTIONS(6100),
    [anon_sym_not_eq] = ACTIONS(6100),
    [anon_sym_DASH_DASH] = ACTIONS(6102),
    [anon_sym_PLUS_PLUS] = ACTIONS(6102),
    [anon_sym_DOT] = ACTIONS(6100),
    [anon_sym_DOT_STAR] = ACTIONS(6102),
    [anon_sym_DASH_GT] = ACTIONS(6102),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6100),
  },
  [2222] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5389),
    [anon_sym_COMMA] = ACTIONS(5389),
    [anon_sym_RPAREN] = ACTIONS(5389),
    [anon_sym_LPAREN2] = ACTIONS(5389),
    [anon_sym_DASH] = ACTIONS(5387),
    [anon_sym_PLUS] = ACTIONS(5387),
    [anon_sym_STAR] = ACTIONS(5387),
    [anon_sym_SLASH] = ACTIONS(5387),
    [anon_sym_PERCENT] = ACTIONS(5387),
    [anon_sym_PIPE_PIPE] = ACTIONS(5389),
    [anon_sym_AMP_AMP] = ACTIONS(5389),
    [anon_sym_PIPE] = ACTIONS(5387),
    [anon_sym_CARET] = ACTIONS(5387),
    [anon_sym_AMP] = ACTIONS(5387),
    [anon_sym_EQ_EQ] = ACTIONS(5389),
    [anon_sym_BANG_EQ] = ACTIONS(5389),
    [anon_sym_GT] = ACTIONS(5387),
    [anon_sym_GT_EQ] = ACTIONS(5389),
    [anon_sym_LT_EQ] = ACTIONS(5387),
    [anon_sym_LT] = ACTIONS(5387),
    [anon_sym_LT_LT] = ACTIONS(5387),
    [anon_sym_GT_GT] = ACTIONS(5387),
    [anon_sym_SEMI] = ACTIONS(5389),
    [anon_sym_RBRACE] = ACTIONS(5389),
    [anon_sym_LBRACK] = ACTIONS(5389),
    [anon_sym_RBRACK] = ACTIONS(5389),
    [anon_sym_EQ] = ACTIONS(5387),
    [anon_sym_COLON] = ACTIONS(5389),
    [anon_sym_QMARK] = ACTIONS(5389),
    [anon_sym_STAR_EQ] = ACTIONS(5389),
    [anon_sym_SLASH_EQ] = ACTIONS(5389),
    [anon_sym_PERCENT_EQ] = ACTIONS(5389),
    [anon_sym_PLUS_EQ] = ACTIONS(5389),
    [anon_sym_DASH_EQ] = ACTIONS(5389),
    [anon_sym_LT_LT_EQ] = ACTIONS(5389),
    [anon_sym_GT_GT_EQ] = ACTIONS(5389),
    [anon_sym_AMP_EQ] = ACTIONS(5389),
    [anon_sym_CARET_EQ] = ACTIONS(5389),
    [anon_sym_PIPE_EQ] = ACTIONS(5389),
    [anon_sym_and_eq] = ACTIONS(5387),
    [anon_sym_or_eq] = ACTIONS(5387),
    [anon_sym_xor_eq] = ACTIONS(5387),
    [anon_sym_LT_EQ_GT] = ACTIONS(5389),
    [anon_sym_or] = ACTIONS(5387),
    [anon_sym_and] = ACTIONS(5387),
    [anon_sym_bitor] = ACTIONS(5387),
    [anon_sym_xor] = ACTIONS(5387),
    [anon_sym_bitand] = ACTIONS(5387),
    [anon_sym_not_eq] = ACTIONS(5387),
    [anon_sym_DASH_DASH] = ACTIONS(5389),
    [anon_sym_PLUS_PLUS] = ACTIONS(5389),
    [anon_sym_DOT] = ACTIONS(5387),
    [anon_sym_DOT_STAR] = ACTIONS(5389),
    [anon_sym_DASH_GT] = ACTIONS(5389),
    [anon_sym_L_DQUOTE] = ACTIONS(5389),
    [anon_sym_u_DQUOTE] = ACTIONS(5389),
    [anon_sym_U_DQUOTE] = ACTIONS(5389),
    [anon_sym_u8_DQUOTE] = ACTIONS(5389),
    [anon_sym_DQUOTE] = ACTIONS(5389),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5389),
    [anon_sym_LR_DQUOTE] = ACTIONS(5389),
    [anon_sym_uR_DQUOTE] = ACTIONS(5389),
    [anon_sym_UR_DQUOTE] = ACTIONS(5389),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5389),
    [sym_literal_suffix] = ACTIONS(5387),
  },
  [2223] = {
    [sym_identifier] = ACTIONS(6104),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6106),
    [anon_sym_COMMA] = ACTIONS(6106),
    [anon_sym_RPAREN] = ACTIONS(6106),
    [aux_sym_preproc_if_token2] = ACTIONS(6106),
    [aux_sym_preproc_else_token1] = ACTIONS(6106),
    [aux_sym_preproc_elif_token1] = ACTIONS(6104),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6106),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6106),
    [anon_sym_LPAREN2] = ACTIONS(6106),
    [anon_sym_DASH] = ACTIONS(6104),
    [anon_sym_PLUS] = ACTIONS(6104),
    [anon_sym_STAR] = ACTIONS(6104),
    [anon_sym_SLASH] = ACTIONS(6104),
    [anon_sym_PERCENT] = ACTIONS(6104),
    [anon_sym_PIPE_PIPE] = ACTIONS(6106),
    [anon_sym_AMP_AMP] = ACTIONS(6106),
    [anon_sym_PIPE] = ACTIONS(6104),
    [anon_sym_CARET] = ACTIONS(6104),
    [anon_sym_AMP] = ACTIONS(6104),
    [anon_sym_EQ_EQ] = ACTIONS(6106),
    [anon_sym_BANG_EQ] = ACTIONS(6106),
    [anon_sym_GT] = ACTIONS(6104),
    [anon_sym_GT_EQ] = ACTIONS(6106),
    [anon_sym_LT_EQ] = ACTIONS(6104),
    [anon_sym_LT] = ACTIONS(6104),
    [anon_sym_LT_LT] = ACTIONS(6104),
    [anon_sym_GT_GT] = ACTIONS(6104),
    [anon_sym_SEMI] = ACTIONS(6106),
    [anon_sym___attribute__] = ACTIONS(6104),
    [anon_sym___attribute] = ACTIONS(6104),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6106),
    [anon_sym_LBRACE] = ACTIONS(6106),
    [anon_sym_RBRACE] = ACTIONS(6106),
    [anon_sym_LBRACK] = ACTIONS(6104),
    [anon_sym_RBRACK] = ACTIONS(6106),
    [anon_sym_EQ] = ACTIONS(6104),
    [anon_sym_COLON] = ACTIONS(6106),
    [anon_sym_QMARK] = ACTIONS(6106),
    [anon_sym_STAR_EQ] = ACTIONS(6106),
    [anon_sym_SLASH_EQ] = ACTIONS(6106),
    [anon_sym_PERCENT_EQ] = ACTIONS(6106),
    [anon_sym_PLUS_EQ] = ACTIONS(6106),
    [anon_sym_DASH_EQ] = ACTIONS(6106),
    [anon_sym_LT_LT_EQ] = ACTIONS(6106),
    [anon_sym_GT_GT_EQ] = ACTIONS(6106),
    [anon_sym_AMP_EQ] = ACTIONS(6106),
    [anon_sym_CARET_EQ] = ACTIONS(6106),
    [anon_sym_PIPE_EQ] = ACTIONS(6106),
    [anon_sym_and_eq] = ACTIONS(6104),
    [anon_sym_or_eq] = ACTIONS(6104),
    [anon_sym_xor_eq] = ACTIONS(6104),
    [anon_sym_LT_EQ_GT] = ACTIONS(6106),
    [anon_sym_or] = ACTIONS(6104),
    [anon_sym_and] = ACTIONS(6104),
    [anon_sym_bitor] = ACTIONS(6104),
    [anon_sym_xor] = ACTIONS(6104),
    [anon_sym_bitand] = ACTIONS(6104),
    [anon_sym_not_eq] = ACTIONS(6104),
    [anon_sym_DASH_DASH] = ACTIONS(6106),
    [anon_sym_PLUS_PLUS] = ACTIONS(6106),
    [anon_sym_DOT] = ACTIONS(6104),
    [anon_sym_DOT_STAR] = ACTIONS(6106),
    [anon_sym_DASH_GT] = ACTIONS(6106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6104),
  },
  [2224] = {
    [sym_identifier] = ACTIONS(6108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6110),
    [anon_sym_COMMA] = ACTIONS(6110),
    [anon_sym_RPAREN] = ACTIONS(6110),
    [aux_sym_preproc_if_token2] = ACTIONS(6110),
    [aux_sym_preproc_else_token1] = ACTIONS(6110),
    [aux_sym_preproc_elif_token1] = ACTIONS(6108),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6110),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6110),
    [anon_sym_LPAREN2] = ACTIONS(6110),
    [anon_sym_DASH] = ACTIONS(6108),
    [anon_sym_PLUS] = ACTIONS(6108),
    [anon_sym_STAR] = ACTIONS(6108),
    [anon_sym_SLASH] = ACTIONS(6108),
    [anon_sym_PERCENT] = ACTIONS(6108),
    [anon_sym_PIPE_PIPE] = ACTIONS(6110),
    [anon_sym_AMP_AMP] = ACTIONS(6110),
    [anon_sym_PIPE] = ACTIONS(6108),
    [anon_sym_CARET] = ACTIONS(6108),
    [anon_sym_AMP] = ACTIONS(6108),
    [anon_sym_EQ_EQ] = ACTIONS(6110),
    [anon_sym_BANG_EQ] = ACTIONS(6110),
    [anon_sym_GT] = ACTIONS(6108),
    [anon_sym_GT_EQ] = ACTIONS(6110),
    [anon_sym_LT_EQ] = ACTIONS(6108),
    [anon_sym_LT] = ACTIONS(6108),
    [anon_sym_LT_LT] = ACTIONS(6108),
    [anon_sym_GT_GT] = ACTIONS(6108),
    [anon_sym_SEMI] = ACTIONS(6110),
    [anon_sym___attribute__] = ACTIONS(6108),
    [anon_sym___attribute] = ACTIONS(6108),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6110),
    [anon_sym_LBRACE] = ACTIONS(6110),
    [anon_sym_RBRACE] = ACTIONS(6110),
    [anon_sym_LBRACK] = ACTIONS(6108),
    [anon_sym_RBRACK] = ACTIONS(6110),
    [anon_sym_EQ] = ACTIONS(6108),
    [anon_sym_COLON] = ACTIONS(6110),
    [anon_sym_QMARK] = ACTIONS(6110),
    [anon_sym_STAR_EQ] = ACTIONS(6110),
    [anon_sym_SLASH_EQ] = ACTIONS(6110),
    [anon_sym_PERCENT_EQ] = ACTIONS(6110),
    [anon_sym_PLUS_EQ] = ACTIONS(6110),
    [anon_sym_DASH_EQ] = ACTIONS(6110),
    [anon_sym_LT_LT_EQ] = ACTIONS(6110),
    [anon_sym_GT_GT_EQ] = ACTIONS(6110),
    [anon_sym_AMP_EQ] = ACTIONS(6110),
    [anon_sym_CARET_EQ] = ACTIONS(6110),
    [anon_sym_PIPE_EQ] = ACTIONS(6110),
    [anon_sym_and_eq] = ACTIONS(6108),
    [anon_sym_or_eq] = ACTIONS(6108),
    [anon_sym_xor_eq] = ACTIONS(6108),
    [anon_sym_LT_EQ_GT] = ACTIONS(6110),
    [anon_sym_or] = ACTIONS(6108),
    [anon_sym_and] = ACTIONS(6108),
    [anon_sym_bitor] = ACTIONS(6108),
    [anon_sym_xor] = ACTIONS(6108),
    [anon_sym_bitand] = ACTIONS(6108),
    [anon_sym_not_eq] = ACTIONS(6108),
    [anon_sym_DASH_DASH] = ACTIONS(6110),
    [anon_sym_PLUS_PLUS] = ACTIONS(6110),
    [anon_sym_DOT] = ACTIONS(6108),
    [anon_sym_DOT_STAR] = ACTIONS(6110),
    [anon_sym_DASH_GT] = ACTIONS(6110),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6108),
  },
  [2225] = {
    [sym_identifier] = ACTIONS(5618),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5620),
    [anon_sym_COMMA] = ACTIONS(5620),
    [anon_sym_RPAREN] = ACTIONS(5620),
    [aux_sym_preproc_if_token2] = ACTIONS(5620),
    [aux_sym_preproc_else_token1] = ACTIONS(5620),
    [aux_sym_preproc_elif_token1] = ACTIONS(5618),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5620),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5620),
    [anon_sym_LPAREN2] = ACTIONS(5620),
    [anon_sym_DASH] = ACTIONS(5618),
    [anon_sym_PLUS] = ACTIONS(5618),
    [anon_sym_STAR] = ACTIONS(5618),
    [anon_sym_SLASH] = ACTIONS(5618),
    [anon_sym_PERCENT] = ACTIONS(5618),
    [anon_sym_PIPE_PIPE] = ACTIONS(5620),
    [anon_sym_AMP_AMP] = ACTIONS(5620),
    [anon_sym_PIPE] = ACTIONS(5618),
    [anon_sym_CARET] = ACTIONS(5618),
    [anon_sym_AMP] = ACTIONS(5618),
    [anon_sym_EQ_EQ] = ACTIONS(5620),
    [anon_sym_BANG_EQ] = ACTIONS(5620),
    [anon_sym_GT] = ACTIONS(5618),
    [anon_sym_GT_EQ] = ACTIONS(5620),
    [anon_sym_LT_EQ] = ACTIONS(5618),
    [anon_sym_LT] = ACTIONS(5618),
    [anon_sym_LT_LT] = ACTIONS(5618),
    [anon_sym_GT_GT] = ACTIONS(5618),
    [anon_sym_SEMI] = ACTIONS(5620),
    [anon_sym___attribute__] = ACTIONS(5618),
    [anon_sym___attribute] = ACTIONS(5618),
    [anon_sym_LBRACE] = ACTIONS(5620),
    [anon_sym_RBRACE] = ACTIONS(5620),
    [anon_sym_LBRACK] = ACTIONS(5620),
    [anon_sym_RBRACK] = ACTIONS(5620),
    [anon_sym_EQ] = ACTIONS(5618),
    [anon_sym_COLON] = ACTIONS(5620),
    [anon_sym_QMARK] = ACTIONS(5620),
    [anon_sym_STAR_EQ] = ACTIONS(5620),
    [anon_sym_SLASH_EQ] = ACTIONS(5620),
    [anon_sym_PERCENT_EQ] = ACTIONS(5620),
    [anon_sym_PLUS_EQ] = ACTIONS(5620),
    [anon_sym_DASH_EQ] = ACTIONS(5620),
    [anon_sym_LT_LT_EQ] = ACTIONS(5620),
    [anon_sym_GT_GT_EQ] = ACTIONS(5620),
    [anon_sym_AMP_EQ] = ACTIONS(5620),
    [anon_sym_CARET_EQ] = ACTIONS(5620),
    [anon_sym_PIPE_EQ] = ACTIONS(5620),
    [anon_sym_and_eq] = ACTIONS(5618),
    [anon_sym_or_eq] = ACTIONS(5618),
    [anon_sym_xor_eq] = ACTIONS(5618),
    [anon_sym_LT_EQ_GT] = ACTIONS(5620),
    [anon_sym_or] = ACTIONS(5618),
    [anon_sym_and] = ACTIONS(5618),
    [anon_sym_bitor] = ACTIONS(5618),
    [anon_sym_xor] = ACTIONS(5618),
    [anon_sym_bitand] = ACTIONS(5618),
    [anon_sym_not_eq] = ACTIONS(5618),
    [anon_sym_DASH_DASH] = ACTIONS(5620),
    [anon_sym_PLUS_PLUS] = ACTIONS(5620),
    [anon_sym_DOT] = ACTIONS(5618),
    [anon_sym_DOT_STAR] = ACTIONS(5620),
    [anon_sym_DASH_GT] = ACTIONS(5620),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5618),
    [anon_sym_decltype] = ACTIONS(5618),
  },
  [2226] = {
    [sym_identifier] = ACTIONS(5506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5508),
    [anon_sym_COMMA] = ACTIONS(5508),
    [anon_sym_RPAREN] = ACTIONS(5508),
    [aux_sym_preproc_if_token2] = ACTIONS(5508),
    [aux_sym_preproc_else_token1] = ACTIONS(5508),
    [aux_sym_preproc_elif_token1] = ACTIONS(5506),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5508),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5508),
    [anon_sym_LPAREN2] = ACTIONS(5508),
    [anon_sym_DASH] = ACTIONS(5506),
    [anon_sym_PLUS] = ACTIONS(5506),
    [anon_sym_STAR] = ACTIONS(5506),
    [anon_sym_SLASH] = ACTIONS(5506),
    [anon_sym_PERCENT] = ACTIONS(5506),
    [anon_sym_PIPE_PIPE] = ACTIONS(5508),
    [anon_sym_AMP_AMP] = ACTIONS(5508),
    [anon_sym_PIPE] = ACTIONS(5506),
    [anon_sym_CARET] = ACTIONS(5506),
    [anon_sym_AMP] = ACTIONS(5506),
    [anon_sym_EQ_EQ] = ACTIONS(5508),
    [anon_sym_BANG_EQ] = ACTIONS(5508),
    [anon_sym_GT] = ACTIONS(5506),
    [anon_sym_GT_EQ] = ACTIONS(5508),
    [anon_sym_LT_EQ] = ACTIONS(5506),
    [anon_sym_LT] = ACTIONS(5506),
    [anon_sym_LT_LT] = ACTIONS(5506),
    [anon_sym_GT_GT] = ACTIONS(5506),
    [anon_sym_SEMI] = ACTIONS(5508),
    [anon_sym___attribute__] = ACTIONS(5506),
    [anon_sym___attribute] = ACTIONS(5506),
    [anon_sym_LBRACE] = ACTIONS(5508),
    [anon_sym_RBRACE] = ACTIONS(5508),
    [anon_sym_LBRACK] = ACTIONS(5508),
    [anon_sym_RBRACK] = ACTIONS(5508),
    [anon_sym_EQ] = ACTIONS(5506),
    [anon_sym_COLON] = ACTIONS(5508),
    [anon_sym_QMARK] = ACTIONS(5508),
    [anon_sym_STAR_EQ] = ACTIONS(5508),
    [anon_sym_SLASH_EQ] = ACTIONS(5508),
    [anon_sym_PERCENT_EQ] = ACTIONS(5508),
    [anon_sym_PLUS_EQ] = ACTIONS(5508),
    [anon_sym_DASH_EQ] = ACTIONS(5508),
    [anon_sym_LT_LT_EQ] = ACTIONS(5508),
    [anon_sym_GT_GT_EQ] = ACTIONS(5508),
    [anon_sym_AMP_EQ] = ACTIONS(5508),
    [anon_sym_CARET_EQ] = ACTIONS(5508),
    [anon_sym_PIPE_EQ] = ACTIONS(5508),
    [anon_sym_and_eq] = ACTIONS(5506),
    [anon_sym_or_eq] = ACTIONS(5506),
    [anon_sym_xor_eq] = ACTIONS(5506),
    [anon_sym_LT_EQ_GT] = ACTIONS(5508),
    [anon_sym_or] = ACTIONS(5506),
    [anon_sym_and] = ACTIONS(5506),
    [anon_sym_bitor] = ACTIONS(5506),
    [anon_sym_xor] = ACTIONS(5506),
    [anon_sym_bitand] = ACTIONS(5506),
    [anon_sym_not_eq] = ACTIONS(5506),
    [anon_sym_DASH_DASH] = ACTIONS(5508),
    [anon_sym_PLUS_PLUS] = ACTIONS(5508),
    [anon_sym_DOT] = ACTIONS(5506),
    [anon_sym_DOT_STAR] = ACTIONS(5508),
    [anon_sym_DASH_GT] = ACTIONS(5508),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5506),
    [anon_sym_decltype] = ACTIONS(5506),
  },
  [2227] = {
    [sym_identifier] = ACTIONS(5529),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5531),
    [anon_sym_COMMA] = ACTIONS(5531),
    [anon_sym_RPAREN] = ACTIONS(5531),
    [aux_sym_preproc_if_token2] = ACTIONS(5531),
    [aux_sym_preproc_else_token1] = ACTIONS(5531),
    [aux_sym_preproc_elif_token1] = ACTIONS(5529),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5531),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5531),
    [anon_sym_LPAREN2] = ACTIONS(5531),
    [anon_sym_DASH] = ACTIONS(5529),
    [anon_sym_PLUS] = ACTIONS(5529),
    [anon_sym_STAR] = ACTIONS(5529),
    [anon_sym_SLASH] = ACTIONS(5529),
    [anon_sym_PERCENT] = ACTIONS(5529),
    [anon_sym_PIPE_PIPE] = ACTIONS(5531),
    [anon_sym_AMP_AMP] = ACTIONS(5531),
    [anon_sym_PIPE] = ACTIONS(5529),
    [anon_sym_CARET] = ACTIONS(5529),
    [anon_sym_AMP] = ACTIONS(5529),
    [anon_sym_EQ_EQ] = ACTIONS(5531),
    [anon_sym_BANG_EQ] = ACTIONS(5531),
    [anon_sym_GT] = ACTIONS(5529),
    [anon_sym_GT_EQ] = ACTIONS(5531),
    [anon_sym_LT_EQ] = ACTIONS(5529),
    [anon_sym_LT] = ACTIONS(5529),
    [anon_sym_LT_LT] = ACTIONS(5529),
    [anon_sym_GT_GT] = ACTIONS(5529),
    [anon_sym_SEMI] = ACTIONS(5531),
    [anon_sym___attribute__] = ACTIONS(5529),
    [anon_sym___attribute] = ACTIONS(5529),
    [anon_sym_LBRACE] = ACTIONS(5531),
    [anon_sym_RBRACE] = ACTIONS(5531),
    [anon_sym_LBRACK] = ACTIONS(5531),
    [anon_sym_RBRACK] = ACTIONS(5531),
    [anon_sym_EQ] = ACTIONS(5529),
    [anon_sym_COLON] = ACTIONS(5531),
    [anon_sym_QMARK] = ACTIONS(5531),
    [anon_sym_STAR_EQ] = ACTIONS(5531),
    [anon_sym_SLASH_EQ] = ACTIONS(5531),
    [anon_sym_PERCENT_EQ] = ACTIONS(5531),
    [anon_sym_PLUS_EQ] = ACTIONS(5531),
    [anon_sym_DASH_EQ] = ACTIONS(5531),
    [anon_sym_LT_LT_EQ] = ACTIONS(5531),
    [anon_sym_GT_GT_EQ] = ACTIONS(5531),
    [anon_sym_AMP_EQ] = ACTIONS(5531),
    [anon_sym_CARET_EQ] = ACTIONS(5531),
    [anon_sym_PIPE_EQ] = ACTIONS(5531),
    [anon_sym_and_eq] = ACTIONS(5529),
    [anon_sym_or_eq] = ACTIONS(5529),
    [anon_sym_xor_eq] = ACTIONS(5529),
    [anon_sym_LT_EQ_GT] = ACTIONS(5531),
    [anon_sym_or] = ACTIONS(5529),
    [anon_sym_and] = ACTIONS(5529),
    [anon_sym_bitor] = ACTIONS(5529),
    [anon_sym_xor] = ACTIONS(5529),
    [anon_sym_bitand] = ACTIONS(5529),
    [anon_sym_not_eq] = ACTIONS(5529),
    [anon_sym_DASH_DASH] = ACTIONS(5531),
    [anon_sym_PLUS_PLUS] = ACTIONS(5531),
    [anon_sym_DOT] = ACTIONS(5529),
    [anon_sym_DOT_STAR] = ACTIONS(5531),
    [anon_sym_DASH_GT] = ACTIONS(5531),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5529),
    [anon_sym_decltype] = ACTIONS(5529),
  },
  [2228] = {
    [sym_identifier] = ACTIONS(5541),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5543),
    [anon_sym_COMMA] = ACTIONS(5543),
    [anon_sym_RPAREN] = ACTIONS(5543),
    [aux_sym_preproc_if_token2] = ACTIONS(5543),
    [aux_sym_preproc_else_token1] = ACTIONS(5543),
    [aux_sym_preproc_elif_token1] = ACTIONS(5541),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5543),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5543),
    [anon_sym_LPAREN2] = ACTIONS(5543),
    [anon_sym_DASH] = ACTIONS(5541),
    [anon_sym_PLUS] = ACTIONS(5541),
    [anon_sym_STAR] = ACTIONS(5541),
    [anon_sym_SLASH] = ACTIONS(5541),
    [anon_sym_PERCENT] = ACTIONS(5541),
    [anon_sym_PIPE_PIPE] = ACTIONS(5543),
    [anon_sym_AMP_AMP] = ACTIONS(5543),
    [anon_sym_PIPE] = ACTIONS(5541),
    [anon_sym_CARET] = ACTIONS(5541),
    [anon_sym_AMP] = ACTIONS(5541),
    [anon_sym_EQ_EQ] = ACTIONS(5543),
    [anon_sym_BANG_EQ] = ACTIONS(5543),
    [anon_sym_GT] = ACTIONS(5541),
    [anon_sym_GT_EQ] = ACTIONS(5543),
    [anon_sym_LT_EQ] = ACTIONS(5541),
    [anon_sym_LT] = ACTIONS(5541),
    [anon_sym_LT_LT] = ACTIONS(5541),
    [anon_sym_GT_GT] = ACTIONS(5541),
    [anon_sym_SEMI] = ACTIONS(5543),
    [anon_sym___attribute__] = ACTIONS(5541),
    [anon_sym___attribute] = ACTIONS(5541),
    [anon_sym_LBRACE] = ACTIONS(5543),
    [anon_sym_RBRACE] = ACTIONS(5543),
    [anon_sym_LBRACK] = ACTIONS(5543),
    [anon_sym_RBRACK] = ACTIONS(5543),
    [anon_sym_EQ] = ACTIONS(5541),
    [anon_sym_COLON] = ACTIONS(5543),
    [anon_sym_QMARK] = ACTIONS(5543),
    [anon_sym_STAR_EQ] = ACTIONS(5543),
    [anon_sym_SLASH_EQ] = ACTIONS(5543),
    [anon_sym_PERCENT_EQ] = ACTIONS(5543),
    [anon_sym_PLUS_EQ] = ACTIONS(5543),
    [anon_sym_DASH_EQ] = ACTIONS(5543),
    [anon_sym_LT_LT_EQ] = ACTIONS(5543),
    [anon_sym_GT_GT_EQ] = ACTIONS(5543),
    [anon_sym_AMP_EQ] = ACTIONS(5543),
    [anon_sym_CARET_EQ] = ACTIONS(5543),
    [anon_sym_PIPE_EQ] = ACTIONS(5543),
    [anon_sym_and_eq] = ACTIONS(5541),
    [anon_sym_or_eq] = ACTIONS(5541),
    [anon_sym_xor_eq] = ACTIONS(5541),
    [anon_sym_LT_EQ_GT] = ACTIONS(5543),
    [anon_sym_or] = ACTIONS(5541),
    [anon_sym_and] = ACTIONS(5541),
    [anon_sym_bitor] = ACTIONS(5541),
    [anon_sym_xor] = ACTIONS(5541),
    [anon_sym_bitand] = ACTIONS(5541),
    [anon_sym_not_eq] = ACTIONS(5541),
    [anon_sym_DASH_DASH] = ACTIONS(5543),
    [anon_sym_PLUS_PLUS] = ACTIONS(5543),
    [anon_sym_DOT] = ACTIONS(5541),
    [anon_sym_DOT_STAR] = ACTIONS(5543),
    [anon_sym_DASH_GT] = ACTIONS(5543),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5541),
    [anon_sym_decltype] = ACTIONS(5541),
  },
  [2229] = {
    [sym_identifier] = ACTIONS(5545),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5547),
    [anon_sym_COMMA] = ACTIONS(5547),
    [anon_sym_RPAREN] = ACTIONS(5547),
    [aux_sym_preproc_if_token2] = ACTIONS(5547),
    [aux_sym_preproc_else_token1] = ACTIONS(5547),
    [aux_sym_preproc_elif_token1] = ACTIONS(5545),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5547),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5547),
    [anon_sym_LPAREN2] = ACTIONS(5547),
    [anon_sym_DASH] = ACTIONS(5545),
    [anon_sym_PLUS] = ACTIONS(5545),
    [anon_sym_STAR] = ACTIONS(5545),
    [anon_sym_SLASH] = ACTIONS(5545),
    [anon_sym_PERCENT] = ACTIONS(5545),
    [anon_sym_PIPE_PIPE] = ACTIONS(5547),
    [anon_sym_AMP_AMP] = ACTIONS(5547),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_CARET] = ACTIONS(5545),
    [anon_sym_AMP] = ACTIONS(5545),
    [anon_sym_EQ_EQ] = ACTIONS(5547),
    [anon_sym_BANG_EQ] = ACTIONS(5547),
    [anon_sym_GT] = ACTIONS(5545),
    [anon_sym_GT_EQ] = ACTIONS(5547),
    [anon_sym_LT_EQ] = ACTIONS(5545),
    [anon_sym_LT] = ACTIONS(5545),
    [anon_sym_LT_LT] = ACTIONS(5545),
    [anon_sym_GT_GT] = ACTIONS(5545),
    [anon_sym_SEMI] = ACTIONS(5547),
    [anon_sym___attribute__] = ACTIONS(5545),
    [anon_sym___attribute] = ACTIONS(5545),
    [anon_sym_LBRACE] = ACTIONS(5547),
    [anon_sym_RBRACE] = ACTIONS(5547),
    [anon_sym_LBRACK] = ACTIONS(5547),
    [anon_sym_RBRACK] = ACTIONS(5547),
    [anon_sym_EQ] = ACTIONS(5545),
    [anon_sym_COLON] = ACTIONS(5547),
    [anon_sym_QMARK] = ACTIONS(5547),
    [anon_sym_STAR_EQ] = ACTIONS(5547),
    [anon_sym_SLASH_EQ] = ACTIONS(5547),
    [anon_sym_PERCENT_EQ] = ACTIONS(5547),
    [anon_sym_PLUS_EQ] = ACTIONS(5547),
    [anon_sym_DASH_EQ] = ACTIONS(5547),
    [anon_sym_LT_LT_EQ] = ACTIONS(5547),
    [anon_sym_GT_GT_EQ] = ACTIONS(5547),
    [anon_sym_AMP_EQ] = ACTIONS(5547),
    [anon_sym_CARET_EQ] = ACTIONS(5547),
    [anon_sym_PIPE_EQ] = ACTIONS(5547),
    [anon_sym_and_eq] = ACTIONS(5545),
    [anon_sym_or_eq] = ACTIONS(5545),
    [anon_sym_xor_eq] = ACTIONS(5545),
    [anon_sym_LT_EQ_GT] = ACTIONS(5547),
    [anon_sym_or] = ACTIONS(5545),
    [anon_sym_and] = ACTIONS(5545),
    [anon_sym_bitor] = ACTIONS(5545),
    [anon_sym_xor] = ACTIONS(5545),
    [anon_sym_bitand] = ACTIONS(5545),
    [anon_sym_not_eq] = ACTIONS(5545),
    [anon_sym_DASH_DASH] = ACTIONS(5547),
    [anon_sym_PLUS_PLUS] = ACTIONS(5547),
    [anon_sym_DOT] = ACTIONS(5545),
    [anon_sym_DOT_STAR] = ACTIONS(5547),
    [anon_sym_DASH_GT] = ACTIONS(5547),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5545),
    [anon_sym_decltype] = ACTIONS(5545),
  },
  [2230] = {
    [sym_identifier] = ACTIONS(5549),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5551),
    [anon_sym_COMMA] = ACTIONS(5551),
    [anon_sym_RPAREN] = ACTIONS(5551),
    [aux_sym_preproc_if_token2] = ACTIONS(5551),
    [aux_sym_preproc_else_token1] = ACTIONS(5551),
    [aux_sym_preproc_elif_token1] = ACTIONS(5549),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5551),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5551),
    [anon_sym_LPAREN2] = ACTIONS(5551),
    [anon_sym_DASH] = ACTIONS(5549),
    [anon_sym_PLUS] = ACTIONS(5549),
    [anon_sym_STAR] = ACTIONS(5549),
    [anon_sym_SLASH] = ACTIONS(5549),
    [anon_sym_PERCENT] = ACTIONS(5549),
    [anon_sym_PIPE_PIPE] = ACTIONS(5551),
    [anon_sym_AMP_AMP] = ACTIONS(5551),
    [anon_sym_PIPE] = ACTIONS(5549),
    [anon_sym_CARET] = ACTIONS(5549),
    [anon_sym_AMP] = ACTIONS(5549),
    [anon_sym_EQ_EQ] = ACTIONS(5551),
    [anon_sym_BANG_EQ] = ACTIONS(5551),
    [anon_sym_GT] = ACTIONS(5549),
    [anon_sym_GT_EQ] = ACTIONS(5551),
    [anon_sym_LT_EQ] = ACTIONS(5549),
    [anon_sym_LT] = ACTIONS(5549),
    [anon_sym_LT_LT] = ACTIONS(5549),
    [anon_sym_GT_GT] = ACTIONS(5549),
    [anon_sym_SEMI] = ACTIONS(5551),
    [anon_sym___attribute__] = ACTIONS(5549),
    [anon_sym___attribute] = ACTIONS(5549),
    [anon_sym_LBRACE] = ACTIONS(5551),
    [anon_sym_RBRACE] = ACTIONS(5551),
    [anon_sym_LBRACK] = ACTIONS(5551),
    [anon_sym_RBRACK] = ACTIONS(5551),
    [anon_sym_EQ] = ACTIONS(5549),
    [anon_sym_COLON] = ACTIONS(5551),
    [anon_sym_QMARK] = ACTIONS(5551),
    [anon_sym_STAR_EQ] = ACTIONS(5551),
    [anon_sym_SLASH_EQ] = ACTIONS(5551),
    [anon_sym_PERCENT_EQ] = ACTIONS(5551),
    [anon_sym_PLUS_EQ] = ACTIONS(5551),
    [anon_sym_DASH_EQ] = ACTIONS(5551),
    [anon_sym_LT_LT_EQ] = ACTIONS(5551),
    [anon_sym_GT_GT_EQ] = ACTIONS(5551),
    [anon_sym_AMP_EQ] = ACTIONS(5551),
    [anon_sym_CARET_EQ] = ACTIONS(5551),
    [anon_sym_PIPE_EQ] = ACTIONS(5551),
    [anon_sym_and_eq] = ACTIONS(5549),
    [anon_sym_or_eq] = ACTIONS(5549),
    [anon_sym_xor_eq] = ACTIONS(5549),
    [anon_sym_LT_EQ_GT] = ACTIONS(5551),
    [anon_sym_or] = ACTIONS(5549),
    [anon_sym_and] = ACTIONS(5549),
    [anon_sym_bitor] = ACTIONS(5549),
    [anon_sym_xor] = ACTIONS(5549),
    [anon_sym_bitand] = ACTIONS(5549),
    [anon_sym_not_eq] = ACTIONS(5549),
    [anon_sym_DASH_DASH] = ACTIONS(5551),
    [anon_sym_PLUS_PLUS] = ACTIONS(5551),
    [anon_sym_DOT] = ACTIONS(5549),
    [anon_sym_DOT_STAR] = ACTIONS(5551),
    [anon_sym_DASH_GT] = ACTIONS(5551),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5549),
    [anon_sym_decltype] = ACTIONS(5549),
  },
  [2231] = {
    [sym_identifier] = ACTIONS(5553),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5555),
    [anon_sym_COMMA] = ACTIONS(5555),
    [anon_sym_RPAREN] = ACTIONS(5555),
    [aux_sym_preproc_if_token2] = ACTIONS(5555),
    [aux_sym_preproc_else_token1] = ACTIONS(5555),
    [aux_sym_preproc_elif_token1] = ACTIONS(5553),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5555),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5555),
    [anon_sym_LPAREN2] = ACTIONS(5555),
    [anon_sym_DASH] = ACTIONS(5553),
    [anon_sym_PLUS] = ACTIONS(5553),
    [anon_sym_STAR] = ACTIONS(5553),
    [anon_sym_SLASH] = ACTIONS(5553),
    [anon_sym_PERCENT] = ACTIONS(5553),
    [anon_sym_PIPE_PIPE] = ACTIONS(5555),
    [anon_sym_AMP_AMP] = ACTIONS(5555),
    [anon_sym_PIPE] = ACTIONS(5553),
    [anon_sym_CARET] = ACTIONS(5553),
    [anon_sym_AMP] = ACTIONS(5553),
    [anon_sym_EQ_EQ] = ACTIONS(5555),
    [anon_sym_BANG_EQ] = ACTIONS(5555),
    [anon_sym_GT] = ACTIONS(5553),
    [anon_sym_GT_EQ] = ACTIONS(5555),
    [anon_sym_LT_EQ] = ACTIONS(5553),
    [anon_sym_LT] = ACTIONS(5553),
    [anon_sym_LT_LT] = ACTIONS(5553),
    [anon_sym_GT_GT] = ACTIONS(5553),
    [anon_sym_SEMI] = ACTIONS(5555),
    [anon_sym___attribute__] = ACTIONS(5553),
    [anon_sym___attribute] = ACTIONS(5553),
    [anon_sym_LBRACE] = ACTIONS(5555),
    [anon_sym_RBRACE] = ACTIONS(5555),
    [anon_sym_LBRACK] = ACTIONS(5555),
    [anon_sym_RBRACK] = ACTIONS(5555),
    [anon_sym_EQ] = ACTIONS(5553),
    [anon_sym_COLON] = ACTIONS(5555),
    [anon_sym_QMARK] = ACTIONS(5555),
    [anon_sym_STAR_EQ] = ACTIONS(5555),
    [anon_sym_SLASH_EQ] = ACTIONS(5555),
    [anon_sym_PERCENT_EQ] = ACTIONS(5555),
    [anon_sym_PLUS_EQ] = ACTIONS(5555),
    [anon_sym_DASH_EQ] = ACTIONS(5555),
    [anon_sym_LT_LT_EQ] = ACTIONS(5555),
    [anon_sym_GT_GT_EQ] = ACTIONS(5555),
    [anon_sym_AMP_EQ] = ACTIONS(5555),
    [anon_sym_CARET_EQ] = ACTIONS(5555),
    [anon_sym_PIPE_EQ] = ACTIONS(5555),
    [anon_sym_and_eq] = ACTIONS(5553),
    [anon_sym_or_eq] = ACTIONS(5553),
    [anon_sym_xor_eq] = ACTIONS(5553),
    [anon_sym_LT_EQ_GT] = ACTIONS(5555),
    [anon_sym_or] = ACTIONS(5553),
    [anon_sym_and] = ACTIONS(5553),
    [anon_sym_bitor] = ACTIONS(5553),
    [anon_sym_xor] = ACTIONS(5553),
    [anon_sym_bitand] = ACTIONS(5553),
    [anon_sym_not_eq] = ACTIONS(5553),
    [anon_sym_DASH_DASH] = ACTIONS(5555),
    [anon_sym_PLUS_PLUS] = ACTIONS(5555),
    [anon_sym_DOT] = ACTIONS(5553),
    [anon_sym_DOT_STAR] = ACTIONS(5555),
    [anon_sym_DASH_GT] = ACTIONS(5555),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5553),
    [anon_sym_decltype] = ACTIONS(5553),
  },
  [2232] = {
    [sym_identifier] = ACTIONS(5572),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5574),
    [anon_sym_COMMA] = ACTIONS(5574),
    [anon_sym_RPAREN] = ACTIONS(5574),
    [aux_sym_preproc_if_token2] = ACTIONS(5574),
    [aux_sym_preproc_else_token1] = ACTIONS(5574),
    [aux_sym_preproc_elif_token1] = ACTIONS(5572),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5574),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5574),
    [anon_sym_LPAREN2] = ACTIONS(5574),
    [anon_sym_DASH] = ACTIONS(5572),
    [anon_sym_PLUS] = ACTIONS(5572),
    [anon_sym_STAR] = ACTIONS(5572),
    [anon_sym_SLASH] = ACTIONS(5572),
    [anon_sym_PERCENT] = ACTIONS(5572),
    [anon_sym_PIPE_PIPE] = ACTIONS(5574),
    [anon_sym_AMP_AMP] = ACTIONS(5574),
    [anon_sym_PIPE] = ACTIONS(5572),
    [anon_sym_CARET] = ACTIONS(5572),
    [anon_sym_AMP] = ACTIONS(5572),
    [anon_sym_EQ_EQ] = ACTIONS(5574),
    [anon_sym_BANG_EQ] = ACTIONS(5574),
    [anon_sym_GT] = ACTIONS(5572),
    [anon_sym_GT_EQ] = ACTIONS(5574),
    [anon_sym_LT_EQ] = ACTIONS(5572),
    [anon_sym_LT] = ACTIONS(5572),
    [anon_sym_LT_LT] = ACTIONS(5572),
    [anon_sym_GT_GT] = ACTIONS(5572),
    [anon_sym_SEMI] = ACTIONS(5574),
    [anon_sym___attribute__] = ACTIONS(5572),
    [anon_sym___attribute] = ACTIONS(5572),
    [anon_sym_LBRACE] = ACTIONS(5574),
    [anon_sym_RBRACE] = ACTIONS(5574),
    [anon_sym_LBRACK] = ACTIONS(5574),
    [anon_sym_RBRACK] = ACTIONS(5574),
    [anon_sym_EQ] = ACTIONS(5572),
    [anon_sym_COLON] = ACTIONS(5574),
    [anon_sym_QMARK] = ACTIONS(5574),
    [anon_sym_STAR_EQ] = ACTIONS(5574),
    [anon_sym_SLASH_EQ] = ACTIONS(5574),
    [anon_sym_PERCENT_EQ] = ACTIONS(5574),
    [anon_sym_PLUS_EQ] = ACTIONS(5574),
    [anon_sym_DASH_EQ] = ACTIONS(5574),
    [anon_sym_LT_LT_EQ] = ACTIONS(5574),
    [anon_sym_GT_GT_EQ] = ACTIONS(5574),
    [anon_sym_AMP_EQ] = ACTIONS(5574),
    [anon_sym_CARET_EQ] = ACTIONS(5574),
    [anon_sym_PIPE_EQ] = ACTIONS(5574),
    [anon_sym_and_eq] = ACTIONS(5572),
    [anon_sym_or_eq] = ACTIONS(5572),
    [anon_sym_xor_eq] = ACTIONS(5572),
    [anon_sym_LT_EQ_GT] = ACTIONS(5574),
    [anon_sym_or] = ACTIONS(5572),
    [anon_sym_and] = ACTIONS(5572),
    [anon_sym_bitor] = ACTIONS(5572),
    [anon_sym_xor] = ACTIONS(5572),
    [anon_sym_bitand] = ACTIONS(5572),
    [anon_sym_not_eq] = ACTIONS(5572),
    [anon_sym_DASH_DASH] = ACTIONS(5574),
    [anon_sym_PLUS_PLUS] = ACTIONS(5574),
    [anon_sym_DOT] = ACTIONS(5572),
    [anon_sym_DOT_STAR] = ACTIONS(5574),
    [anon_sym_DASH_GT] = ACTIONS(5574),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5572),
    [anon_sym_decltype] = ACTIONS(5572),
  },
  [2233] = {
    [sym_identifier] = ACTIONS(5622),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5624),
    [anon_sym_COMMA] = ACTIONS(5624),
    [anon_sym_RPAREN] = ACTIONS(5624),
    [aux_sym_preproc_if_token2] = ACTIONS(5624),
    [aux_sym_preproc_else_token1] = ACTIONS(5624),
    [aux_sym_preproc_elif_token1] = ACTIONS(5622),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5624),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5624),
    [anon_sym_LPAREN2] = ACTIONS(5624),
    [anon_sym_DASH] = ACTIONS(5622),
    [anon_sym_PLUS] = ACTIONS(5622),
    [anon_sym_STAR] = ACTIONS(5622),
    [anon_sym_SLASH] = ACTIONS(5622),
    [anon_sym_PERCENT] = ACTIONS(5622),
    [anon_sym_PIPE_PIPE] = ACTIONS(5624),
    [anon_sym_AMP_AMP] = ACTIONS(5624),
    [anon_sym_PIPE] = ACTIONS(5622),
    [anon_sym_CARET] = ACTIONS(5622),
    [anon_sym_AMP] = ACTIONS(5622),
    [anon_sym_EQ_EQ] = ACTIONS(5624),
    [anon_sym_BANG_EQ] = ACTIONS(5624),
    [anon_sym_GT] = ACTIONS(5622),
    [anon_sym_GT_EQ] = ACTIONS(5624),
    [anon_sym_LT_EQ] = ACTIONS(5622),
    [anon_sym_LT] = ACTIONS(5622),
    [anon_sym_LT_LT] = ACTIONS(5622),
    [anon_sym_GT_GT] = ACTIONS(5622),
    [anon_sym_SEMI] = ACTIONS(5624),
    [anon_sym___attribute__] = ACTIONS(5622),
    [anon_sym___attribute] = ACTIONS(5622),
    [anon_sym_LBRACE] = ACTIONS(5624),
    [anon_sym_RBRACE] = ACTIONS(5624),
    [anon_sym_LBRACK] = ACTIONS(5624),
    [anon_sym_RBRACK] = ACTIONS(5624),
    [anon_sym_EQ] = ACTIONS(5622),
    [anon_sym_COLON] = ACTIONS(5624),
    [anon_sym_QMARK] = ACTIONS(5624),
    [anon_sym_STAR_EQ] = ACTIONS(5624),
    [anon_sym_SLASH_EQ] = ACTIONS(5624),
    [anon_sym_PERCENT_EQ] = ACTIONS(5624),
    [anon_sym_PLUS_EQ] = ACTIONS(5624),
    [anon_sym_DASH_EQ] = ACTIONS(5624),
    [anon_sym_LT_LT_EQ] = ACTIONS(5624),
    [anon_sym_GT_GT_EQ] = ACTIONS(5624),
    [anon_sym_AMP_EQ] = ACTIONS(5624),
    [anon_sym_CARET_EQ] = ACTIONS(5624),
    [anon_sym_PIPE_EQ] = ACTIONS(5624),
    [anon_sym_and_eq] = ACTIONS(5622),
    [anon_sym_or_eq] = ACTIONS(5622),
    [anon_sym_xor_eq] = ACTIONS(5622),
    [anon_sym_LT_EQ_GT] = ACTIONS(5624),
    [anon_sym_or] = ACTIONS(5622),
    [anon_sym_and] = ACTIONS(5622),
    [anon_sym_bitor] = ACTIONS(5622),
    [anon_sym_xor] = ACTIONS(5622),
    [anon_sym_bitand] = ACTIONS(5622),
    [anon_sym_not_eq] = ACTIONS(5622),
    [anon_sym_DASH_DASH] = ACTIONS(5624),
    [anon_sym_PLUS_PLUS] = ACTIONS(5624),
    [anon_sym_DOT] = ACTIONS(5622),
    [anon_sym_DOT_STAR] = ACTIONS(5624),
    [anon_sym_DASH_GT] = ACTIONS(5624),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5622),
    [anon_sym_decltype] = ACTIONS(5622),
  },
  [2234] = {
    [sym_identifier] = ACTIONS(5578),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5580),
    [anon_sym_COMMA] = ACTIONS(5580),
    [anon_sym_RPAREN] = ACTIONS(5580),
    [aux_sym_preproc_if_token2] = ACTIONS(5580),
    [aux_sym_preproc_else_token1] = ACTIONS(5580),
    [aux_sym_preproc_elif_token1] = ACTIONS(5578),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5580),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5580),
    [anon_sym_LPAREN2] = ACTIONS(5580),
    [anon_sym_DASH] = ACTIONS(5578),
    [anon_sym_PLUS] = ACTIONS(5578),
    [anon_sym_STAR] = ACTIONS(5578),
    [anon_sym_SLASH] = ACTIONS(5578),
    [anon_sym_PERCENT] = ACTIONS(5578),
    [anon_sym_PIPE_PIPE] = ACTIONS(5580),
    [anon_sym_AMP_AMP] = ACTIONS(5580),
    [anon_sym_PIPE] = ACTIONS(5578),
    [anon_sym_CARET] = ACTIONS(5578),
    [anon_sym_AMP] = ACTIONS(5578),
    [anon_sym_EQ_EQ] = ACTIONS(5580),
    [anon_sym_BANG_EQ] = ACTIONS(5580),
    [anon_sym_GT] = ACTIONS(5578),
    [anon_sym_GT_EQ] = ACTIONS(5580),
    [anon_sym_LT_EQ] = ACTIONS(5578),
    [anon_sym_LT] = ACTIONS(5578),
    [anon_sym_LT_LT] = ACTIONS(5578),
    [anon_sym_GT_GT] = ACTIONS(5578),
    [anon_sym_SEMI] = ACTIONS(5580),
    [anon_sym___attribute__] = ACTIONS(5578),
    [anon_sym___attribute] = ACTIONS(5578),
    [anon_sym_LBRACE] = ACTIONS(5580),
    [anon_sym_RBRACE] = ACTIONS(5580),
    [anon_sym_LBRACK] = ACTIONS(5580),
    [anon_sym_RBRACK] = ACTIONS(5580),
    [anon_sym_EQ] = ACTIONS(5578),
    [anon_sym_COLON] = ACTIONS(5580),
    [anon_sym_QMARK] = ACTIONS(5580),
    [anon_sym_STAR_EQ] = ACTIONS(5580),
    [anon_sym_SLASH_EQ] = ACTIONS(5580),
    [anon_sym_PERCENT_EQ] = ACTIONS(5580),
    [anon_sym_PLUS_EQ] = ACTIONS(5580),
    [anon_sym_DASH_EQ] = ACTIONS(5580),
    [anon_sym_LT_LT_EQ] = ACTIONS(5580),
    [anon_sym_GT_GT_EQ] = ACTIONS(5580),
    [anon_sym_AMP_EQ] = ACTIONS(5580),
    [anon_sym_CARET_EQ] = ACTIONS(5580),
    [anon_sym_PIPE_EQ] = ACTIONS(5580),
    [anon_sym_and_eq] = ACTIONS(5578),
    [anon_sym_or_eq] = ACTIONS(5578),
    [anon_sym_xor_eq] = ACTIONS(5578),
    [anon_sym_LT_EQ_GT] = ACTIONS(5580),
    [anon_sym_or] = ACTIONS(5578),
    [anon_sym_and] = ACTIONS(5578),
    [anon_sym_bitor] = ACTIONS(5578),
    [anon_sym_xor] = ACTIONS(5578),
    [anon_sym_bitand] = ACTIONS(5578),
    [anon_sym_not_eq] = ACTIONS(5578),
    [anon_sym_DASH_DASH] = ACTIONS(5580),
    [anon_sym_PLUS_PLUS] = ACTIONS(5580),
    [anon_sym_DOT] = ACTIONS(5578),
    [anon_sym_DOT_STAR] = ACTIONS(5580),
    [anon_sym_DASH_GT] = ACTIONS(5580),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5578),
    [anon_sym_decltype] = ACTIONS(5578),
  },
  [2235] = {
    [sym_identifier] = ACTIONS(5498),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5500),
    [anon_sym_COMMA] = ACTIONS(5500),
    [anon_sym_RPAREN] = ACTIONS(5500),
    [aux_sym_preproc_if_token2] = ACTIONS(5500),
    [aux_sym_preproc_else_token1] = ACTIONS(5500),
    [aux_sym_preproc_elif_token1] = ACTIONS(5498),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5500),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5500),
    [anon_sym_LPAREN2] = ACTIONS(5500),
    [anon_sym_DASH] = ACTIONS(5498),
    [anon_sym_PLUS] = ACTIONS(5498),
    [anon_sym_STAR] = ACTIONS(5498),
    [anon_sym_SLASH] = ACTIONS(5498),
    [anon_sym_PERCENT] = ACTIONS(5498),
    [anon_sym_PIPE_PIPE] = ACTIONS(5500),
    [anon_sym_AMP_AMP] = ACTIONS(5500),
    [anon_sym_PIPE] = ACTIONS(5498),
    [anon_sym_CARET] = ACTIONS(5498),
    [anon_sym_AMP] = ACTIONS(5498),
    [anon_sym_EQ_EQ] = ACTIONS(5500),
    [anon_sym_BANG_EQ] = ACTIONS(5500),
    [anon_sym_GT] = ACTIONS(5498),
    [anon_sym_GT_EQ] = ACTIONS(5500),
    [anon_sym_LT_EQ] = ACTIONS(5498),
    [anon_sym_LT] = ACTIONS(5498),
    [anon_sym_LT_LT] = ACTIONS(5498),
    [anon_sym_GT_GT] = ACTIONS(5498),
    [anon_sym_SEMI] = ACTIONS(5500),
    [anon_sym___attribute__] = ACTIONS(5498),
    [anon_sym___attribute] = ACTIONS(5498),
    [anon_sym_LBRACE] = ACTIONS(5500),
    [anon_sym_RBRACE] = ACTIONS(5500),
    [anon_sym_LBRACK] = ACTIONS(5500),
    [anon_sym_RBRACK] = ACTIONS(5500),
    [anon_sym_EQ] = ACTIONS(5498),
    [anon_sym_COLON] = ACTIONS(5500),
    [anon_sym_QMARK] = ACTIONS(5500),
    [anon_sym_STAR_EQ] = ACTIONS(5500),
    [anon_sym_SLASH_EQ] = ACTIONS(5500),
    [anon_sym_PERCENT_EQ] = ACTIONS(5500),
    [anon_sym_PLUS_EQ] = ACTIONS(5500),
    [anon_sym_DASH_EQ] = ACTIONS(5500),
    [anon_sym_LT_LT_EQ] = ACTIONS(5500),
    [anon_sym_GT_GT_EQ] = ACTIONS(5500),
    [anon_sym_AMP_EQ] = ACTIONS(5500),
    [anon_sym_CARET_EQ] = ACTIONS(5500),
    [anon_sym_PIPE_EQ] = ACTIONS(5500),
    [anon_sym_and_eq] = ACTIONS(5498),
    [anon_sym_or_eq] = ACTIONS(5498),
    [anon_sym_xor_eq] = ACTIONS(5498),
    [anon_sym_LT_EQ_GT] = ACTIONS(5500),
    [anon_sym_or] = ACTIONS(5498),
    [anon_sym_and] = ACTIONS(5498),
    [anon_sym_bitor] = ACTIONS(5498),
    [anon_sym_xor] = ACTIONS(5498),
    [anon_sym_bitand] = ACTIONS(5498),
    [anon_sym_not_eq] = ACTIONS(5498),
    [anon_sym_DASH_DASH] = ACTIONS(5500),
    [anon_sym_PLUS_PLUS] = ACTIONS(5500),
    [anon_sym_DOT] = ACTIONS(5498),
    [anon_sym_DOT_STAR] = ACTIONS(5500),
    [anon_sym_DASH_GT] = ACTIONS(5500),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5498),
    [anon_sym_decltype] = ACTIONS(5498),
  },
  [2236] = {
    [sym_identifier] = ACTIONS(5596),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5598),
    [anon_sym_COMMA] = ACTIONS(5598),
    [anon_sym_RPAREN] = ACTIONS(5598),
    [aux_sym_preproc_if_token2] = ACTIONS(5598),
    [aux_sym_preproc_else_token1] = ACTIONS(5598),
    [aux_sym_preproc_elif_token1] = ACTIONS(5596),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5598),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5598),
    [anon_sym_LPAREN2] = ACTIONS(5598),
    [anon_sym_DASH] = ACTIONS(5596),
    [anon_sym_PLUS] = ACTIONS(5596),
    [anon_sym_STAR] = ACTIONS(5596),
    [anon_sym_SLASH] = ACTIONS(5596),
    [anon_sym_PERCENT] = ACTIONS(5596),
    [anon_sym_PIPE_PIPE] = ACTIONS(5598),
    [anon_sym_AMP_AMP] = ACTIONS(5598),
    [anon_sym_PIPE] = ACTIONS(5596),
    [anon_sym_CARET] = ACTIONS(5596),
    [anon_sym_AMP] = ACTIONS(5596),
    [anon_sym_EQ_EQ] = ACTIONS(5598),
    [anon_sym_BANG_EQ] = ACTIONS(5598),
    [anon_sym_GT] = ACTIONS(5596),
    [anon_sym_GT_EQ] = ACTIONS(5598),
    [anon_sym_LT_EQ] = ACTIONS(5596),
    [anon_sym_LT] = ACTIONS(5596),
    [anon_sym_LT_LT] = ACTIONS(5596),
    [anon_sym_GT_GT] = ACTIONS(5596),
    [anon_sym_SEMI] = ACTIONS(5598),
    [anon_sym___attribute__] = ACTIONS(5596),
    [anon_sym___attribute] = ACTIONS(5596),
    [anon_sym_LBRACE] = ACTIONS(5598),
    [anon_sym_RBRACE] = ACTIONS(5598),
    [anon_sym_LBRACK] = ACTIONS(5598),
    [anon_sym_RBRACK] = ACTIONS(5598),
    [anon_sym_EQ] = ACTIONS(5596),
    [anon_sym_COLON] = ACTIONS(5598),
    [anon_sym_QMARK] = ACTIONS(5598),
    [anon_sym_STAR_EQ] = ACTIONS(5598),
    [anon_sym_SLASH_EQ] = ACTIONS(5598),
    [anon_sym_PERCENT_EQ] = ACTIONS(5598),
    [anon_sym_PLUS_EQ] = ACTIONS(5598),
    [anon_sym_DASH_EQ] = ACTIONS(5598),
    [anon_sym_LT_LT_EQ] = ACTIONS(5598),
    [anon_sym_GT_GT_EQ] = ACTIONS(5598),
    [anon_sym_AMP_EQ] = ACTIONS(5598),
    [anon_sym_CARET_EQ] = ACTIONS(5598),
    [anon_sym_PIPE_EQ] = ACTIONS(5598),
    [anon_sym_and_eq] = ACTIONS(5596),
    [anon_sym_or_eq] = ACTIONS(5596),
    [anon_sym_xor_eq] = ACTIONS(5596),
    [anon_sym_LT_EQ_GT] = ACTIONS(5598),
    [anon_sym_or] = ACTIONS(5596),
    [anon_sym_and] = ACTIONS(5596),
    [anon_sym_bitor] = ACTIONS(5596),
    [anon_sym_xor] = ACTIONS(5596),
    [anon_sym_bitand] = ACTIONS(5596),
    [anon_sym_not_eq] = ACTIONS(5596),
    [anon_sym_DASH_DASH] = ACTIONS(5598),
    [anon_sym_PLUS_PLUS] = ACTIONS(5598),
    [anon_sym_DOT] = ACTIONS(5596),
    [anon_sym_DOT_STAR] = ACTIONS(5598),
    [anon_sym_DASH_GT] = ACTIONS(5598),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5596),
    [anon_sym_decltype] = ACTIONS(5596),
  },
  [2237] = {
    [sym_string_literal] = STATE(2570),
    [sym_template_argument_list] = STATE(3643),
    [sym_raw_string_literal] = STATE(2570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4035),
    [anon_sym_COMMA] = ACTIONS(4035),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_DASH] = ACTIONS(4043),
    [anon_sym_PLUS] = ACTIONS(4043),
    [anon_sym_STAR] = ACTIONS(4043),
    [anon_sym_SLASH] = ACTIONS(4043),
    [anon_sym_PERCENT] = ACTIONS(4043),
    [anon_sym_PIPE_PIPE] = ACTIONS(4035),
    [anon_sym_AMP_AMP] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4043),
    [anon_sym_CARET] = ACTIONS(4043),
    [anon_sym_AMP] = ACTIONS(4043),
    [anon_sym_EQ_EQ] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4043),
    [anon_sym_GT_EQ] = ACTIONS(4035),
    [anon_sym_LT_EQ] = ACTIONS(4043),
    [anon_sym_LT] = ACTIONS(4929),
    [anon_sym_LT_LT] = ACTIONS(4043),
    [anon_sym_GT_GT] = ACTIONS(4043),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACE] = ACTIONS(4059),
    [anon_sym_LBRACK] = ACTIONS(4035),
    [anon_sym_EQ] = ACTIONS(6112),
    [anon_sym_COLON] = ACTIONS(4043),
    [anon_sym_QMARK] = ACTIONS(4035),
    [anon_sym_STAR_EQ] = ACTIONS(6114),
    [anon_sym_SLASH_EQ] = ACTIONS(6114),
    [anon_sym_PERCENT_EQ] = ACTIONS(6114),
    [anon_sym_PLUS_EQ] = ACTIONS(6114),
    [anon_sym_DASH_EQ] = ACTIONS(6114),
    [anon_sym_LT_LT_EQ] = ACTIONS(6114),
    [anon_sym_GT_GT_EQ] = ACTIONS(6114),
    [anon_sym_AMP_EQ] = ACTIONS(6114),
    [anon_sym_CARET_EQ] = ACTIONS(6114),
    [anon_sym_PIPE_EQ] = ACTIONS(6114),
    [anon_sym_and_eq] = ACTIONS(6114),
    [anon_sym_or_eq] = ACTIONS(6114),
    [anon_sym_xor_eq] = ACTIONS(6114),
    [anon_sym_LT_EQ_GT] = ACTIONS(4035),
    [anon_sym_or] = ACTIONS(4043),
    [anon_sym_and] = ACTIONS(4043),
    [anon_sym_bitor] = ACTIONS(4035),
    [anon_sym_xor] = ACTIONS(4043),
    [anon_sym_bitand] = ACTIONS(4035),
    [anon_sym_not_eq] = ACTIONS(4035),
    [anon_sym_DASH_DASH] = ACTIONS(4035),
    [anon_sym_PLUS_PLUS] = ACTIONS(4035),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_DOT_STAR] = ACTIONS(4035),
    [anon_sym_DASH_GT] = ACTIONS(4035),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
  },
  [2238] = {
    [sym_identifier] = ACTIONS(6116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6118),
    [anon_sym_COMMA] = ACTIONS(6118),
    [anon_sym_RPAREN] = ACTIONS(6118),
    [aux_sym_preproc_if_token2] = ACTIONS(6118),
    [aux_sym_preproc_else_token1] = ACTIONS(6118),
    [aux_sym_preproc_elif_token1] = ACTIONS(6116),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6118),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6118),
    [anon_sym_LPAREN2] = ACTIONS(6118),
    [anon_sym_DASH] = ACTIONS(6116),
    [anon_sym_PLUS] = ACTIONS(6116),
    [anon_sym_STAR] = ACTIONS(6116),
    [anon_sym_SLASH] = ACTIONS(6116),
    [anon_sym_PERCENT] = ACTIONS(6116),
    [anon_sym_PIPE_PIPE] = ACTIONS(6118),
    [anon_sym_AMP_AMP] = ACTIONS(6118),
    [anon_sym_PIPE] = ACTIONS(6116),
    [anon_sym_CARET] = ACTIONS(6116),
    [anon_sym_AMP] = ACTIONS(6116),
    [anon_sym_EQ_EQ] = ACTIONS(6118),
    [anon_sym_BANG_EQ] = ACTIONS(6118),
    [anon_sym_GT] = ACTIONS(6116),
    [anon_sym_GT_EQ] = ACTIONS(6118),
    [anon_sym_LT_EQ] = ACTIONS(6116),
    [anon_sym_LT] = ACTIONS(6116),
    [anon_sym_LT_LT] = ACTIONS(6116),
    [anon_sym_GT_GT] = ACTIONS(6116),
    [anon_sym_SEMI] = ACTIONS(6118),
    [anon_sym___attribute__] = ACTIONS(6116),
    [anon_sym___attribute] = ACTIONS(6116),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6118),
    [anon_sym_LBRACE] = ACTIONS(6118),
    [anon_sym_RBRACE] = ACTIONS(6118),
    [anon_sym_LBRACK] = ACTIONS(6116),
    [anon_sym_RBRACK] = ACTIONS(6118),
    [anon_sym_EQ] = ACTIONS(6116),
    [anon_sym_COLON] = ACTIONS(6118),
    [anon_sym_QMARK] = ACTIONS(6118),
    [anon_sym_STAR_EQ] = ACTIONS(6118),
    [anon_sym_SLASH_EQ] = ACTIONS(6118),
    [anon_sym_PERCENT_EQ] = ACTIONS(6118),
    [anon_sym_PLUS_EQ] = ACTIONS(6118),
    [anon_sym_DASH_EQ] = ACTIONS(6118),
    [anon_sym_LT_LT_EQ] = ACTIONS(6118),
    [anon_sym_GT_GT_EQ] = ACTIONS(6118),
    [anon_sym_AMP_EQ] = ACTIONS(6118),
    [anon_sym_CARET_EQ] = ACTIONS(6118),
    [anon_sym_PIPE_EQ] = ACTIONS(6118),
    [anon_sym_and_eq] = ACTIONS(6116),
    [anon_sym_or_eq] = ACTIONS(6116),
    [anon_sym_xor_eq] = ACTIONS(6116),
    [anon_sym_LT_EQ_GT] = ACTIONS(6118),
    [anon_sym_or] = ACTIONS(6116),
    [anon_sym_and] = ACTIONS(6116),
    [anon_sym_bitor] = ACTIONS(6116),
    [anon_sym_xor] = ACTIONS(6116),
    [anon_sym_bitand] = ACTIONS(6116),
    [anon_sym_not_eq] = ACTIONS(6116),
    [anon_sym_DASH_DASH] = ACTIONS(6118),
    [anon_sym_PLUS_PLUS] = ACTIONS(6118),
    [anon_sym_DOT] = ACTIONS(6116),
    [anon_sym_DOT_STAR] = ACTIONS(6118),
    [anon_sym_DASH_GT] = ACTIONS(6118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6116),
  },
  [2239] = {
    [sym_identifier] = ACTIONS(5680),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5682),
    [anon_sym_COMMA] = ACTIONS(5682),
    [anon_sym_RPAREN] = ACTIONS(5682),
    [aux_sym_preproc_if_token2] = ACTIONS(5682),
    [aux_sym_preproc_else_token1] = ACTIONS(5682),
    [aux_sym_preproc_elif_token1] = ACTIONS(5680),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5682),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5682),
    [anon_sym_LPAREN2] = ACTIONS(5682),
    [anon_sym_DASH] = ACTIONS(5680),
    [anon_sym_PLUS] = ACTIONS(5680),
    [anon_sym_STAR] = ACTIONS(5680),
    [anon_sym_SLASH] = ACTIONS(5680),
    [anon_sym_PERCENT] = ACTIONS(5680),
    [anon_sym_PIPE_PIPE] = ACTIONS(5682),
    [anon_sym_AMP_AMP] = ACTIONS(5682),
    [anon_sym_PIPE] = ACTIONS(5680),
    [anon_sym_CARET] = ACTIONS(5680),
    [anon_sym_AMP] = ACTIONS(5680),
    [anon_sym_EQ_EQ] = ACTIONS(5682),
    [anon_sym_BANG_EQ] = ACTIONS(5682),
    [anon_sym_GT] = ACTIONS(5680),
    [anon_sym_GT_EQ] = ACTIONS(5682),
    [anon_sym_LT_EQ] = ACTIONS(5680),
    [anon_sym_LT] = ACTIONS(5680),
    [anon_sym_LT_LT] = ACTIONS(5680),
    [anon_sym_GT_GT] = ACTIONS(5680),
    [anon_sym_SEMI] = ACTIONS(5682),
    [anon_sym___attribute__] = ACTIONS(5680),
    [anon_sym___attribute] = ACTIONS(5680),
    [anon_sym_LBRACE] = ACTIONS(5682),
    [anon_sym_RBRACE] = ACTIONS(5682),
    [anon_sym_LBRACK] = ACTIONS(5682),
    [anon_sym_RBRACK] = ACTIONS(5682),
    [anon_sym_EQ] = ACTIONS(5680),
    [anon_sym_COLON] = ACTIONS(5682),
    [anon_sym_QMARK] = ACTIONS(5682),
    [anon_sym_STAR_EQ] = ACTIONS(5682),
    [anon_sym_SLASH_EQ] = ACTIONS(5682),
    [anon_sym_PERCENT_EQ] = ACTIONS(5682),
    [anon_sym_PLUS_EQ] = ACTIONS(5682),
    [anon_sym_DASH_EQ] = ACTIONS(5682),
    [anon_sym_LT_LT_EQ] = ACTIONS(5682),
    [anon_sym_GT_GT_EQ] = ACTIONS(5682),
    [anon_sym_AMP_EQ] = ACTIONS(5682),
    [anon_sym_CARET_EQ] = ACTIONS(5682),
    [anon_sym_PIPE_EQ] = ACTIONS(5682),
    [anon_sym_and_eq] = ACTIONS(5680),
    [anon_sym_or_eq] = ACTIONS(5680),
    [anon_sym_xor_eq] = ACTIONS(5680),
    [anon_sym_LT_EQ_GT] = ACTIONS(5682),
    [anon_sym_or] = ACTIONS(5680),
    [anon_sym_and] = ACTIONS(5680),
    [anon_sym_bitor] = ACTIONS(5680),
    [anon_sym_xor] = ACTIONS(5680),
    [anon_sym_bitand] = ACTIONS(5680),
    [anon_sym_not_eq] = ACTIONS(5680),
    [anon_sym_DASH_DASH] = ACTIONS(5682),
    [anon_sym_PLUS_PLUS] = ACTIONS(5682),
    [anon_sym_DOT] = ACTIONS(5680),
    [anon_sym_DOT_STAR] = ACTIONS(5682),
    [anon_sym_DASH_GT] = ACTIONS(5682),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5680),
    [anon_sym_decltype] = ACTIONS(5680),
  },
  [2240] = {
    [sym_string_literal] = STATE(2240),
    [sym_raw_string_literal] = STATE(2240),
    [aux_sym_concatenated_string_repeat1] = STATE(2240),
    [sym_identifier] = ACTIONS(6120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5258),
    [anon_sym_COMMA] = ACTIONS(5258),
    [anon_sym_LPAREN2] = ACTIONS(5258),
    [anon_sym_DASH] = ACTIONS(5260),
    [anon_sym_PLUS] = ACTIONS(5260),
    [anon_sym_STAR] = ACTIONS(5260),
    [anon_sym_SLASH] = ACTIONS(5260),
    [anon_sym_PERCENT] = ACTIONS(5260),
    [anon_sym_PIPE_PIPE] = ACTIONS(5258),
    [anon_sym_AMP_AMP] = ACTIONS(5258),
    [anon_sym_PIPE] = ACTIONS(5260),
    [anon_sym_CARET] = ACTIONS(5260),
    [anon_sym_AMP] = ACTIONS(5260),
    [anon_sym_EQ_EQ] = ACTIONS(5258),
    [anon_sym_BANG_EQ] = ACTIONS(5258),
    [anon_sym_GT] = ACTIONS(5260),
    [anon_sym_GT_EQ] = ACTIONS(5260),
    [anon_sym_LT_EQ] = ACTIONS(5260),
    [anon_sym_LT] = ACTIONS(5260),
    [anon_sym_LT_LT] = ACTIONS(5260),
    [anon_sym_GT_GT] = ACTIONS(5260),
    [anon_sym_LBRACK] = ACTIONS(5258),
    [anon_sym_EQ] = ACTIONS(5260),
    [anon_sym_QMARK] = ACTIONS(5258),
    [anon_sym_STAR_EQ] = ACTIONS(5258),
    [anon_sym_SLASH_EQ] = ACTIONS(5258),
    [anon_sym_PERCENT_EQ] = ACTIONS(5258),
    [anon_sym_PLUS_EQ] = ACTIONS(5258),
    [anon_sym_DASH_EQ] = ACTIONS(5258),
    [anon_sym_LT_LT_EQ] = ACTIONS(5258),
    [anon_sym_GT_GT_EQ] = ACTIONS(5260),
    [anon_sym_AMP_EQ] = ACTIONS(5258),
    [anon_sym_CARET_EQ] = ACTIONS(5258),
    [anon_sym_PIPE_EQ] = ACTIONS(5258),
    [anon_sym_and_eq] = ACTIONS(5260),
    [anon_sym_or_eq] = ACTIONS(5260),
    [anon_sym_xor_eq] = ACTIONS(5260),
    [anon_sym_LT_EQ_GT] = ACTIONS(5258),
    [anon_sym_or] = ACTIONS(5260),
    [anon_sym_and] = ACTIONS(5260),
    [anon_sym_bitor] = ACTIONS(5260),
    [anon_sym_xor] = ACTIONS(5260),
    [anon_sym_bitand] = ACTIONS(5260),
    [anon_sym_not_eq] = ACTIONS(5260),
    [anon_sym_DASH_DASH] = ACTIONS(5258),
    [anon_sym_PLUS_PLUS] = ACTIONS(5258),
    [anon_sym_DOT] = ACTIONS(5260),
    [anon_sym_DOT_STAR] = ACTIONS(5258),
    [anon_sym_DASH_GT] = ACTIONS(5258),
    [anon_sym_L_DQUOTE] = ACTIONS(6123),
    [anon_sym_u_DQUOTE] = ACTIONS(6123),
    [anon_sym_U_DQUOTE] = ACTIONS(6123),
    [anon_sym_u8_DQUOTE] = ACTIONS(6123),
    [anon_sym_DQUOTE] = ACTIONS(6123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(5258),
    [anon_sym_R_DQUOTE] = ACTIONS(6126),
    [anon_sym_LR_DQUOTE] = ACTIONS(6126),
    [anon_sym_uR_DQUOTE] = ACTIONS(6126),
    [anon_sym_UR_DQUOTE] = ACTIONS(6126),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6126),
    [sym_literal_suffix] = ACTIONS(5260),
  },
  [2241] = {
    [sym_attribute_specifier] = STATE(1809),
    [sym_enumerator_list] = STATE(2309),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5836),
    [anon_sym_COMMA] = ACTIONS(5836),
    [anon_sym_RPAREN] = ACTIONS(5836),
    [anon_sym_LPAREN2] = ACTIONS(5836),
    [anon_sym_DASH] = ACTIONS(5834),
    [anon_sym_PLUS] = ACTIONS(5834),
    [anon_sym_STAR] = ACTIONS(5836),
    [anon_sym_SLASH] = ACTIONS(5834),
    [anon_sym_PERCENT] = ACTIONS(5836),
    [anon_sym_PIPE_PIPE] = ACTIONS(5836),
    [anon_sym_AMP_AMP] = ACTIONS(5836),
    [anon_sym_PIPE] = ACTIONS(5834),
    [anon_sym_CARET] = ACTIONS(5836),
    [anon_sym_AMP] = ACTIONS(5834),
    [anon_sym_EQ_EQ] = ACTIONS(5836),
    [anon_sym_BANG_EQ] = ACTIONS(5836),
    [anon_sym_GT] = ACTIONS(5834),
    [anon_sym_GT_EQ] = ACTIONS(5836),
    [anon_sym_LT_EQ] = ACTIONS(5834),
    [anon_sym_LT] = ACTIONS(5834),
    [anon_sym_LT_LT] = ACTIONS(5836),
    [anon_sym_GT_GT] = ACTIONS(5836),
    [anon_sym_SEMI] = ACTIONS(5836),
    [anon_sym___extension__] = ACTIONS(5836),
    [anon_sym___attribute__] = ACTIONS(5874),
    [anon_sym___attribute] = ACTIONS(5876),
    [anon_sym_LBRACE] = ACTIONS(6065),
    [anon_sym_RBRACE] = ACTIONS(5836),
    [anon_sym_LBRACK] = ACTIONS(5836),
    [anon_sym_RBRACK] = ACTIONS(5836),
    [anon_sym_const] = ACTIONS(5834),
    [anon_sym_constexpr] = ACTIONS(5836),
    [anon_sym_volatile] = ACTIONS(5836),
    [anon_sym_restrict] = ACTIONS(5836),
    [anon_sym___restrict__] = ACTIONS(5836),
    [anon_sym__Atomic] = ACTIONS(5836),
    [anon_sym__Noreturn] = ACTIONS(5836),
    [anon_sym_noreturn] = ACTIONS(5836),
    [anon_sym__Nonnull] = ACTIONS(5836),
    [anon_sym_mutable] = ACTIONS(5836),
    [anon_sym_constinit] = ACTIONS(5836),
    [anon_sym_consteval] = ACTIONS(5836),
    [anon_sym_alignas] = ACTIONS(5836),
    [anon_sym__Alignas] = ACTIONS(5836),
    [anon_sym_COLON] = ACTIONS(5836),
    [anon_sym_QMARK] = ACTIONS(5836),
    [anon_sym_LT_EQ_GT] = ACTIONS(5836),
    [anon_sym_or] = ACTIONS(5836),
    [anon_sym_and] = ACTIONS(5836),
    [anon_sym_bitor] = ACTIONS(5836),
    [anon_sym_xor] = ACTIONS(5836),
    [anon_sym_bitand] = ACTIONS(5836),
    [anon_sym_not_eq] = ACTIONS(5836),
    [anon_sym_DASH_DASH] = ACTIONS(5836),
    [anon_sym_PLUS_PLUS] = ACTIONS(5836),
    [anon_sym_DOT] = ACTIONS(5834),
    [anon_sym_DOT_STAR] = ACTIONS(5836),
    [anon_sym_DASH_GT] = ACTIONS(5836),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5836),
    [anon_sym_decltype] = ACTIONS(5836),
    [anon_sym_final] = ACTIONS(5836),
    [anon_sym_override] = ACTIONS(5836),
    [anon_sym_requires] = ACTIONS(5836),
  },
  [2242] = {
    [sym_identifier] = ACTIONS(5498),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5500),
    [anon_sym_COMMA] = ACTIONS(5500),
    [anon_sym_RPAREN] = ACTIONS(5500),
    [aux_sym_preproc_if_token2] = ACTIONS(5500),
    [aux_sym_preproc_else_token1] = ACTIONS(5500),
    [aux_sym_preproc_elif_token1] = ACTIONS(5498),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5500),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5500),
    [anon_sym_LPAREN2] = ACTIONS(5500),
    [anon_sym_DASH] = ACTIONS(5498),
    [anon_sym_PLUS] = ACTIONS(5498),
    [anon_sym_STAR] = ACTIONS(5498),
    [anon_sym_SLASH] = ACTIONS(5498),
    [anon_sym_PERCENT] = ACTIONS(5498),
    [anon_sym_PIPE_PIPE] = ACTIONS(5500),
    [anon_sym_AMP_AMP] = ACTIONS(5500),
    [anon_sym_PIPE] = ACTIONS(5498),
    [anon_sym_CARET] = ACTIONS(5498),
    [anon_sym_AMP] = ACTIONS(5498),
    [anon_sym_EQ_EQ] = ACTIONS(5500),
    [anon_sym_BANG_EQ] = ACTIONS(5500),
    [anon_sym_GT] = ACTIONS(5498),
    [anon_sym_GT_EQ] = ACTIONS(5500),
    [anon_sym_LT_EQ] = ACTIONS(5498),
    [anon_sym_LT] = ACTIONS(5498),
    [anon_sym_LT_LT] = ACTIONS(5498),
    [anon_sym_GT_GT] = ACTIONS(5498),
    [anon_sym_SEMI] = ACTIONS(5500),
    [anon_sym___attribute__] = ACTIONS(5498),
    [anon_sym___attribute] = ACTIONS(5498),
    [anon_sym_LBRACE] = ACTIONS(5500),
    [anon_sym_RBRACE] = ACTIONS(5500),
    [anon_sym_LBRACK] = ACTIONS(5500),
    [anon_sym_RBRACK] = ACTIONS(5500),
    [anon_sym_EQ] = ACTIONS(5498),
    [anon_sym_COLON] = ACTIONS(5500),
    [anon_sym_QMARK] = ACTIONS(5500),
    [anon_sym_STAR_EQ] = ACTIONS(5500),
    [anon_sym_SLASH_EQ] = ACTIONS(5500),
    [anon_sym_PERCENT_EQ] = ACTIONS(5500),
    [anon_sym_PLUS_EQ] = ACTIONS(5500),
    [anon_sym_DASH_EQ] = ACTIONS(5500),
    [anon_sym_LT_LT_EQ] = ACTIONS(5500),
    [anon_sym_GT_GT_EQ] = ACTIONS(5500),
    [anon_sym_AMP_EQ] = ACTIONS(5500),
    [anon_sym_CARET_EQ] = ACTIONS(5500),
    [anon_sym_PIPE_EQ] = ACTIONS(5500),
    [anon_sym_and_eq] = ACTIONS(5498),
    [anon_sym_or_eq] = ACTIONS(5498),
    [anon_sym_xor_eq] = ACTIONS(5498),
    [anon_sym_LT_EQ_GT] = ACTIONS(5500),
    [anon_sym_or] = ACTIONS(5498),
    [anon_sym_and] = ACTIONS(5498),
    [anon_sym_bitor] = ACTIONS(5498),
    [anon_sym_xor] = ACTIONS(5498),
    [anon_sym_bitand] = ACTIONS(5498),
    [anon_sym_not_eq] = ACTIONS(5498),
    [anon_sym_DASH_DASH] = ACTIONS(5500),
    [anon_sym_PLUS_PLUS] = ACTIONS(5500),
    [anon_sym_DOT] = ACTIONS(5498),
    [anon_sym_DOT_STAR] = ACTIONS(5500),
    [anon_sym_DASH_GT] = ACTIONS(5500),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5498),
    [anon_sym_decltype] = ACTIONS(5498),
  },
  [2243] = {
    [sym_string_literal] = STATE(1952),
    [sym_raw_string_literal] = STATE(1952),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5799),
    [anon_sym_COMMA] = ACTIONS(5799),
    [anon_sym_LPAREN2] = ACTIONS(5799),
    [anon_sym_DASH] = ACTIONS(5797),
    [anon_sym_PLUS] = ACTIONS(5797),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_SLASH] = ACTIONS(5797),
    [anon_sym_PERCENT] = ACTIONS(5797),
    [anon_sym_PIPE_PIPE] = ACTIONS(5799),
    [anon_sym_AMP_AMP] = ACTIONS(5799),
    [anon_sym_PIPE] = ACTIONS(5797),
    [anon_sym_CARET] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5797),
    [anon_sym_EQ_EQ] = ACTIONS(5799),
    [anon_sym_BANG_EQ] = ACTIONS(5799),
    [anon_sym_GT] = ACTIONS(5797),
    [anon_sym_GT_EQ] = ACTIONS(5799),
    [anon_sym_LT_EQ] = ACTIONS(5797),
    [anon_sym_LT] = ACTIONS(5797),
    [anon_sym_LT_LT] = ACTIONS(5797),
    [anon_sym_GT_GT] = ACTIONS(5797),
    [anon_sym_SEMI] = ACTIONS(5799),
    [anon_sym___attribute__] = ACTIONS(5797),
    [anon_sym___attribute] = ACTIONS(5797),
    [anon_sym_LBRACK] = ACTIONS(5799),
    [anon_sym_EQ] = ACTIONS(5797),
    [anon_sym_QMARK] = ACTIONS(5799),
    [anon_sym_STAR_EQ] = ACTIONS(5799),
    [anon_sym_SLASH_EQ] = ACTIONS(5799),
    [anon_sym_PERCENT_EQ] = ACTIONS(5799),
    [anon_sym_PLUS_EQ] = ACTIONS(5799),
    [anon_sym_DASH_EQ] = ACTIONS(5799),
    [anon_sym_LT_LT_EQ] = ACTIONS(5799),
    [anon_sym_GT_GT_EQ] = ACTIONS(5799),
    [anon_sym_AMP_EQ] = ACTIONS(5799),
    [anon_sym_CARET_EQ] = ACTIONS(5799),
    [anon_sym_PIPE_EQ] = ACTIONS(5799),
    [anon_sym_and_eq] = ACTIONS(5797),
    [anon_sym_or_eq] = ACTIONS(5797),
    [anon_sym_xor_eq] = ACTIONS(5797),
    [anon_sym_LT_EQ_GT] = ACTIONS(5799),
    [anon_sym_or] = ACTIONS(5797),
    [anon_sym_and] = ACTIONS(5797),
    [anon_sym_bitor] = ACTIONS(5797),
    [anon_sym_xor] = ACTIONS(5797),
    [anon_sym_bitand] = ACTIONS(5797),
    [anon_sym_not_eq] = ACTIONS(5797),
    [anon_sym_DASH_DASH] = ACTIONS(5799),
    [anon_sym_PLUS_PLUS] = ACTIONS(5799),
    [anon_sym_DOT] = ACTIONS(5797),
    [anon_sym_DOT_STAR] = ACTIONS(5799),
    [anon_sym_DASH_GT] = ACTIONS(5799),
    [anon_sym_L_DQUOTE] = ACTIONS(5819),
    [anon_sym_u_DQUOTE] = ACTIONS(5819),
    [anon_sym_U_DQUOTE] = ACTIONS(5819),
    [anon_sym_u8_DQUOTE] = ACTIONS(5819),
    [anon_sym_DQUOTE] = ACTIONS(5819),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5821),
    [anon_sym_LR_DQUOTE] = ACTIONS(5821),
    [anon_sym_uR_DQUOTE] = ACTIONS(5821),
    [anon_sym_UR_DQUOTE] = ACTIONS(5821),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5821),
    [sym_literal_suffix] = ACTIONS(5797),
  },
  [2244] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5401),
    [anon_sym_COMMA] = ACTIONS(5401),
    [anon_sym_RPAREN] = ACTIONS(5401),
    [anon_sym_LPAREN2] = ACTIONS(5401),
    [anon_sym_DASH] = ACTIONS(5399),
    [anon_sym_PLUS] = ACTIONS(5399),
    [anon_sym_STAR] = ACTIONS(5399),
    [anon_sym_SLASH] = ACTIONS(5399),
    [anon_sym_PERCENT] = ACTIONS(5399),
    [anon_sym_PIPE_PIPE] = ACTIONS(5401),
    [anon_sym_AMP_AMP] = ACTIONS(5401),
    [anon_sym_PIPE] = ACTIONS(5399),
    [anon_sym_CARET] = ACTIONS(5399),
    [anon_sym_AMP] = ACTIONS(5399),
    [anon_sym_EQ_EQ] = ACTIONS(5401),
    [anon_sym_BANG_EQ] = ACTIONS(5401),
    [anon_sym_GT] = ACTIONS(5399),
    [anon_sym_GT_EQ] = ACTIONS(5401),
    [anon_sym_LT_EQ] = ACTIONS(5399),
    [anon_sym_LT] = ACTIONS(5399),
    [anon_sym_LT_LT] = ACTIONS(5399),
    [anon_sym_GT_GT] = ACTIONS(5399),
    [anon_sym_SEMI] = ACTIONS(5401),
    [anon_sym_RBRACE] = ACTIONS(5401),
    [anon_sym_LBRACK] = ACTIONS(5401),
    [anon_sym_RBRACK] = ACTIONS(5401),
    [anon_sym_EQ] = ACTIONS(5399),
    [anon_sym_COLON] = ACTIONS(5401),
    [anon_sym_QMARK] = ACTIONS(5401),
    [anon_sym_STAR_EQ] = ACTIONS(5401),
    [anon_sym_SLASH_EQ] = ACTIONS(5401),
    [anon_sym_PERCENT_EQ] = ACTIONS(5401),
    [anon_sym_PLUS_EQ] = ACTIONS(5401),
    [anon_sym_DASH_EQ] = ACTIONS(5401),
    [anon_sym_LT_LT_EQ] = ACTIONS(5401),
    [anon_sym_GT_GT_EQ] = ACTIONS(5401),
    [anon_sym_AMP_EQ] = ACTIONS(5401),
    [anon_sym_CARET_EQ] = ACTIONS(5401),
    [anon_sym_PIPE_EQ] = ACTIONS(5401),
    [anon_sym_and_eq] = ACTIONS(5399),
    [anon_sym_or_eq] = ACTIONS(5399),
    [anon_sym_xor_eq] = ACTIONS(5399),
    [anon_sym_LT_EQ_GT] = ACTIONS(5401),
    [anon_sym_or] = ACTIONS(5399),
    [anon_sym_and] = ACTIONS(5399),
    [anon_sym_bitor] = ACTIONS(5399),
    [anon_sym_xor] = ACTIONS(5399),
    [anon_sym_bitand] = ACTIONS(5399),
    [anon_sym_not_eq] = ACTIONS(5399),
    [anon_sym_DASH_DASH] = ACTIONS(5401),
    [anon_sym_PLUS_PLUS] = ACTIONS(5401),
    [anon_sym_DOT] = ACTIONS(5399),
    [anon_sym_DOT_STAR] = ACTIONS(5401),
    [anon_sym_DASH_GT] = ACTIONS(5401),
    [anon_sym_L_DQUOTE] = ACTIONS(5401),
    [anon_sym_u_DQUOTE] = ACTIONS(5401),
    [anon_sym_U_DQUOTE] = ACTIONS(5401),
    [anon_sym_u8_DQUOTE] = ACTIONS(5401),
    [anon_sym_DQUOTE] = ACTIONS(5401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5401),
    [anon_sym_LR_DQUOTE] = ACTIONS(5401),
    [anon_sym_uR_DQUOTE] = ACTIONS(5401),
    [anon_sym_UR_DQUOTE] = ACTIONS(5401),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5401),
    [sym_literal_suffix] = ACTIONS(5399),
  },
  [2245] = {
    [sym_identifier] = ACTIONS(5648),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5650),
    [anon_sym_COMMA] = ACTIONS(5650),
    [anon_sym_RPAREN] = ACTIONS(5650),
    [aux_sym_preproc_if_token2] = ACTIONS(5650),
    [aux_sym_preproc_else_token1] = ACTIONS(5650),
    [aux_sym_preproc_elif_token1] = ACTIONS(5648),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5650),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5650),
    [anon_sym_LPAREN2] = ACTIONS(5650),
    [anon_sym_DASH] = ACTIONS(5648),
    [anon_sym_PLUS] = ACTIONS(5648),
    [anon_sym_STAR] = ACTIONS(5648),
    [anon_sym_SLASH] = ACTIONS(5648),
    [anon_sym_PERCENT] = ACTIONS(5648),
    [anon_sym_PIPE_PIPE] = ACTIONS(5650),
    [anon_sym_AMP_AMP] = ACTIONS(5650),
    [anon_sym_PIPE] = ACTIONS(5648),
    [anon_sym_CARET] = ACTIONS(5648),
    [anon_sym_AMP] = ACTIONS(5648),
    [anon_sym_EQ_EQ] = ACTIONS(5650),
    [anon_sym_BANG_EQ] = ACTIONS(5650),
    [anon_sym_GT] = ACTIONS(5648),
    [anon_sym_GT_EQ] = ACTIONS(5650),
    [anon_sym_LT_EQ] = ACTIONS(5648),
    [anon_sym_LT] = ACTIONS(5648),
    [anon_sym_LT_LT] = ACTIONS(5648),
    [anon_sym_GT_GT] = ACTIONS(5648),
    [anon_sym_SEMI] = ACTIONS(5650),
    [anon_sym___attribute__] = ACTIONS(5648),
    [anon_sym___attribute] = ACTIONS(5648),
    [anon_sym_LBRACE] = ACTIONS(5650),
    [anon_sym_RBRACE] = ACTIONS(5650),
    [anon_sym_LBRACK] = ACTIONS(5650),
    [anon_sym_RBRACK] = ACTIONS(5650),
    [anon_sym_EQ] = ACTIONS(5648),
    [anon_sym_COLON] = ACTIONS(5650),
    [anon_sym_QMARK] = ACTIONS(5650),
    [anon_sym_STAR_EQ] = ACTIONS(5650),
    [anon_sym_SLASH_EQ] = ACTIONS(5650),
    [anon_sym_PERCENT_EQ] = ACTIONS(5650),
    [anon_sym_PLUS_EQ] = ACTIONS(5650),
    [anon_sym_DASH_EQ] = ACTIONS(5650),
    [anon_sym_LT_LT_EQ] = ACTIONS(5650),
    [anon_sym_GT_GT_EQ] = ACTIONS(5650),
    [anon_sym_AMP_EQ] = ACTIONS(5650),
    [anon_sym_CARET_EQ] = ACTIONS(5650),
    [anon_sym_PIPE_EQ] = ACTIONS(5650),
    [anon_sym_and_eq] = ACTIONS(5648),
    [anon_sym_or_eq] = ACTIONS(5648),
    [anon_sym_xor_eq] = ACTIONS(5648),
    [anon_sym_LT_EQ_GT] = ACTIONS(5650),
    [anon_sym_or] = ACTIONS(5648),
    [anon_sym_and] = ACTIONS(5648),
    [anon_sym_bitor] = ACTIONS(5648),
    [anon_sym_xor] = ACTIONS(5648),
    [anon_sym_bitand] = ACTIONS(5648),
    [anon_sym_not_eq] = ACTIONS(5648),
    [anon_sym_DASH_DASH] = ACTIONS(5650),
    [anon_sym_PLUS_PLUS] = ACTIONS(5650),
    [anon_sym_DOT] = ACTIONS(5648),
    [anon_sym_DOT_STAR] = ACTIONS(5650),
    [anon_sym_DASH_GT] = ACTIONS(5650),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5648),
    [anon_sym_decltype] = ACTIONS(5648),
  },
  [2246] = {
    [sym_string_literal] = STATE(2248),
    [sym_template_argument_list] = STATE(3296),
    [sym_raw_string_literal] = STATE(2248),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4035),
    [anon_sym_COMMA] = ACTIONS(4035),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_DASH] = ACTIONS(4043),
    [anon_sym_PLUS] = ACTIONS(4043),
    [anon_sym_STAR] = ACTIONS(4043),
    [anon_sym_SLASH] = ACTIONS(4043),
    [anon_sym_PERCENT] = ACTIONS(4043),
    [anon_sym_PIPE_PIPE] = ACTIONS(4035),
    [anon_sym_AMP_AMP] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4043),
    [anon_sym_CARET] = ACTIONS(4043),
    [anon_sym_AMP] = ACTIONS(4043),
    [anon_sym_EQ_EQ] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4043),
    [anon_sym_GT_EQ] = ACTIONS(4043),
    [anon_sym_LT_EQ] = ACTIONS(4043),
    [anon_sym_LT] = ACTIONS(6129),
    [anon_sym_LT_LT] = ACTIONS(4043),
    [anon_sym_GT_GT] = ACTIONS(4043),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACE] = ACTIONS(4059),
    [anon_sym_LBRACK] = ACTIONS(4035),
    [anon_sym_EQ] = ACTIONS(4043),
    [anon_sym_QMARK] = ACTIONS(4035),
    [anon_sym_STAR_EQ] = ACTIONS(4035),
    [anon_sym_SLASH_EQ] = ACTIONS(4035),
    [anon_sym_PERCENT_EQ] = ACTIONS(4035),
    [anon_sym_PLUS_EQ] = ACTIONS(4035),
    [anon_sym_DASH_EQ] = ACTIONS(4035),
    [anon_sym_LT_LT_EQ] = ACTIONS(4035),
    [anon_sym_GT_GT_EQ] = ACTIONS(4043),
    [anon_sym_AMP_EQ] = ACTIONS(4035),
    [anon_sym_CARET_EQ] = ACTIONS(4035),
    [anon_sym_PIPE_EQ] = ACTIONS(4035),
    [anon_sym_and_eq] = ACTIONS(4035),
    [anon_sym_or_eq] = ACTIONS(4035),
    [anon_sym_xor_eq] = ACTIONS(4035),
    [anon_sym_LT_EQ_GT] = ACTIONS(4035),
    [anon_sym_or] = ACTIONS(4043),
    [anon_sym_and] = ACTIONS(4043),
    [anon_sym_bitor] = ACTIONS(4035),
    [anon_sym_xor] = ACTIONS(4043),
    [anon_sym_bitand] = ACTIONS(4035),
    [anon_sym_not_eq] = ACTIONS(4035),
    [anon_sym_DASH_DASH] = ACTIONS(4035),
    [anon_sym_PLUS_PLUS] = ACTIONS(4035),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_DOT_STAR] = ACTIONS(4035),
    [anon_sym_DASH_GT] = ACTIONS(4035),
    [anon_sym_L_DQUOTE] = ACTIONS(6132),
    [anon_sym_u_DQUOTE] = ACTIONS(6132),
    [anon_sym_U_DQUOTE] = ACTIONS(6132),
    [anon_sym_u8_DQUOTE] = ACTIONS(6132),
    [anon_sym_DQUOTE] = ACTIONS(6132),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(4035),
    [anon_sym_R_DQUOTE] = ACTIONS(6134),
    [anon_sym_LR_DQUOTE] = ACTIONS(6134),
    [anon_sym_uR_DQUOTE] = ACTIONS(6134),
    [anon_sym_UR_DQUOTE] = ACTIONS(6134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6134),
  },
  [2247] = {
    [sym_identifier] = ACTIONS(5600),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5602),
    [anon_sym_COMMA] = ACTIONS(5602),
    [anon_sym_RPAREN] = ACTIONS(5602),
    [aux_sym_preproc_if_token2] = ACTIONS(5602),
    [aux_sym_preproc_else_token1] = ACTIONS(5602),
    [aux_sym_preproc_elif_token1] = ACTIONS(5600),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5602),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5602),
    [anon_sym_LPAREN2] = ACTIONS(5602),
    [anon_sym_DASH] = ACTIONS(5600),
    [anon_sym_PLUS] = ACTIONS(5600),
    [anon_sym_STAR] = ACTIONS(5600),
    [anon_sym_SLASH] = ACTIONS(5600),
    [anon_sym_PERCENT] = ACTIONS(5600),
    [anon_sym_PIPE_PIPE] = ACTIONS(5602),
    [anon_sym_AMP_AMP] = ACTIONS(5602),
    [anon_sym_PIPE] = ACTIONS(5600),
    [anon_sym_CARET] = ACTIONS(5600),
    [anon_sym_AMP] = ACTIONS(5600),
    [anon_sym_EQ_EQ] = ACTIONS(5602),
    [anon_sym_BANG_EQ] = ACTIONS(5602),
    [anon_sym_GT] = ACTIONS(5600),
    [anon_sym_GT_EQ] = ACTIONS(5602),
    [anon_sym_LT_EQ] = ACTIONS(5600),
    [anon_sym_LT] = ACTIONS(5600),
    [anon_sym_LT_LT] = ACTIONS(5600),
    [anon_sym_GT_GT] = ACTIONS(5600),
    [anon_sym_SEMI] = ACTIONS(5602),
    [anon_sym___attribute__] = ACTIONS(5600),
    [anon_sym___attribute] = ACTIONS(5600),
    [anon_sym_LBRACE] = ACTIONS(5602),
    [anon_sym_RBRACE] = ACTIONS(5602),
    [anon_sym_LBRACK] = ACTIONS(5602),
    [anon_sym_RBRACK] = ACTIONS(5602),
    [anon_sym_EQ] = ACTIONS(5600),
    [anon_sym_COLON] = ACTIONS(5602),
    [anon_sym_QMARK] = ACTIONS(5602),
    [anon_sym_STAR_EQ] = ACTIONS(5602),
    [anon_sym_SLASH_EQ] = ACTIONS(5602),
    [anon_sym_PERCENT_EQ] = ACTIONS(5602),
    [anon_sym_PLUS_EQ] = ACTIONS(5602),
    [anon_sym_DASH_EQ] = ACTIONS(5602),
    [anon_sym_LT_LT_EQ] = ACTIONS(5602),
    [anon_sym_GT_GT_EQ] = ACTIONS(5602),
    [anon_sym_AMP_EQ] = ACTIONS(5602),
    [anon_sym_CARET_EQ] = ACTIONS(5602),
    [anon_sym_PIPE_EQ] = ACTIONS(5602),
    [anon_sym_and_eq] = ACTIONS(5600),
    [anon_sym_or_eq] = ACTIONS(5600),
    [anon_sym_xor_eq] = ACTIONS(5600),
    [anon_sym_LT_EQ_GT] = ACTIONS(5602),
    [anon_sym_or] = ACTIONS(5600),
    [anon_sym_and] = ACTIONS(5600),
    [anon_sym_bitor] = ACTIONS(5600),
    [anon_sym_xor] = ACTIONS(5600),
    [anon_sym_bitand] = ACTIONS(5600),
    [anon_sym_not_eq] = ACTIONS(5600),
    [anon_sym_DASH_DASH] = ACTIONS(5602),
    [anon_sym_PLUS_PLUS] = ACTIONS(5602),
    [anon_sym_DOT] = ACTIONS(5600),
    [anon_sym_DOT_STAR] = ACTIONS(5602),
    [anon_sym_DASH_GT] = ACTIONS(5602),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5600),
    [anon_sym_decltype] = ACTIONS(5600),
  },
  [2248] = {
    [sym_string_literal] = STATE(2257),
    [sym_raw_string_literal] = STATE(2257),
    [aux_sym_concatenated_string_repeat1] = STATE(2257),
    [sym_identifier] = ACTIONS(6136),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5274),
    [anon_sym_COMMA] = ACTIONS(5274),
    [anon_sym_LPAREN2] = ACTIONS(5274),
    [anon_sym_DASH] = ACTIONS(5276),
    [anon_sym_PLUS] = ACTIONS(5276),
    [anon_sym_STAR] = ACTIONS(5276),
    [anon_sym_SLASH] = ACTIONS(5276),
    [anon_sym_PERCENT] = ACTIONS(5276),
    [anon_sym_PIPE_PIPE] = ACTIONS(5274),
    [anon_sym_AMP_AMP] = ACTIONS(5274),
    [anon_sym_PIPE] = ACTIONS(5276),
    [anon_sym_CARET] = ACTIONS(5276),
    [anon_sym_AMP] = ACTIONS(5276),
    [anon_sym_EQ_EQ] = ACTIONS(5274),
    [anon_sym_BANG_EQ] = ACTIONS(5274),
    [anon_sym_GT] = ACTIONS(5276),
    [anon_sym_GT_EQ] = ACTIONS(5276),
    [anon_sym_LT_EQ] = ACTIONS(5276),
    [anon_sym_LT] = ACTIONS(5276),
    [anon_sym_LT_LT] = ACTIONS(5276),
    [anon_sym_GT_GT] = ACTIONS(5276),
    [anon_sym_LBRACK] = ACTIONS(5274),
    [anon_sym_EQ] = ACTIONS(5276),
    [anon_sym_QMARK] = ACTIONS(5274),
    [anon_sym_STAR_EQ] = ACTIONS(5274),
    [anon_sym_SLASH_EQ] = ACTIONS(5274),
    [anon_sym_PERCENT_EQ] = ACTIONS(5274),
    [anon_sym_PLUS_EQ] = ACTIONS(5274),
    [anon_sym_DASH_EQ] = ACTIONS(5274),
    [anon_sym_LT_LT_EQ] = ACTIONS(5274),
    [anon_sym_GT_GT_EQ] = ACTIONS(5276),
    [anon_sym_AMP_EQ] = ACTIONS(5274),
    [anon_sym_CARET_EQ] = ACTIONS(5274),
    [anon_sym_PIPE_EQ] = ACTIONS(5274),
    [anon_sym_and_eq] = ACTIONS(5276),
    [anon_sym_or_eq] = ACTIONS(5276),
    [anon_sym_xor_eq] = ACTIONS(5276),
    [anon_sym_LT_EQ_GT] = ACTIONS(5274),
    [anon_sym_or] = ACTIONS(5276),
    [anon_sym_and] = ACTIONS(5276),
    [anon_sym_bitor] = ACTIONS(5276),
    [anon_sym_xor] = ACTIONS(5276),
    [anon_sym_bitand] = ACTIONS(5276),
    [anon_sym_not_eq] = ACTIONS(5276),
    [anon_sym_DASH_DASH] = ACTIONS(5274),
    [anon_sym_PLUS_PLUS] = ACTIONS(5274),
    [anon_sym_DOT] = ACTIONS(5276),
    [anon_sym_DOT_STAR] = ACTIONS(5274),
    [anon_sym_DASH_GT] = ACTIONS(5274),
    [anon_sym_L_DQUOTE] = ACTIONS(6132),
    [anon_sym_u_DQUOTE] = ACTIONS(6132),
    [anon_sym_U_DQUOTE] = ACTIONS(6132),
    [anon_sym_u8_DQUOTE] = ACTIONS(6132),
    [anon_sym_DQUOTE] = ACTIONS(6132),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(5274),
    [anon_sym_R_DQUOTE] = ACTIONS(6134),
    [anon_sym_LR_DQUOTE] = ACTIONS(6134),
    [anon_sym_uR_DQUOTE] = ACTIONS(6134),
    [anon_sym_UR_DQUOTE] = ACTIONS(6134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6134),
    [sym_literal_suffix] = ACTIONS(5276),
  },
  [2249] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2249),
    [sym_identifier] = ACTIONS(4932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4934),
    [anon_sym_COMMA] = ACTIONS(4934),
    [aux_sym_preproc_if_token2] = ACTIONS(4934),
    [aux_sym_preproc_else_token1] = ACTIONS(4934),
    [aux_sym_preproc_elif_token1] = ACTIONS(4932),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4934),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4934),
    [anon_sym_LPAREN2] = ACTIONS(4934),
    [anon_sym_DASH] = ACTIONS(4932),
    [anon_sym_PLUS] = ACTIONS(4932),
    [anon_sym_STAR] = ACTIONS(4932),
    [anon_sym_SLASH] = ACTIONS(4932),
    [anon_sym_PERCENT] = ACTIONS(4932),
    [anon_sym_PIPE_PIPE] = ACTIONS(4934),
    [anon_sym_AMP_AMP] = ACTIONS(4934),
    [anon_sym_PIPE] = ACTIONS(4932),
    [anon_sym_CARET] = ACTIONS(4932),
    [anon_sym_AMP] = ACTIONS(4932),
    [anon_sym_EQ_EQ] = ACTIONS(4934),
    [anon_sym_BANG_EQ] = ACTIONS(4934),
    [anon_sym_GT] = ACTIONS(4932),
    [anon_sym_GT_EQ] = ACTIONS(4934),
    [anon_sym_LT_EQ] = ACTIONS(4932),
    [anon_sym_LT] = ACTIONS(4932),
    [anon_sym_LT_LT] = ACTIONS(4932),
    [anon_sym_GT_GT] = ACTIONS(4932),
    [anon_sym___attribute__] = ACTIONS(4932),
    [anon_sym___attribute] = ACTIONS(4932),
    [anon_sym_LBRACE] = ACTIONS(4934),
    [anon_sym_signed] = ACTIONS(6138),
    [anon_sym_unsigned] = ACTIONS(6138),
    [anon_sym_long] = ACTIONS(6138),
    [anon_sym_short] = ACTIONS(6138),
    [anon_sym_LBRACK] = ACTIONS(4934),
    [anon_sym_EQ] = ACTIONS(4932),
    [anon_sym_QMARK] = ACTIONS(4934),
    [anon_sym_STAR_EQ] = ACTIONS(4934),
    [anon_sym_SLASH_EQ] = ACTIONS(4934),
    [anon_sym_PERCENT_EQ] = ACTIONS(4934),
    [anon_sym_PLUS_EQ] = ACTIONS(4934),
    [anon_sym_DASH_EQ] = ACTIONS(4934),
    [anon_sym_LT_LT_EQ] = ACTIONS(4934),
    [anon_sym_GT_GT_EQ] = ACTIONS(4934),
    [anon_sym_AMP_EQ] = ACTIONS(4934),
    [anon_sym_CARET_EQ] = ACTIONS(4934),
    [anon_sym_PIPE_EQ] = ACTIONS(4934),
    [anon_sym_and_eq] = ACTIONS(4932),
    [anon_sym_or_eq] = ACTIONS(4932),
    [anon_sym_xor_eq] = ACTIONS(4932),
    [anon_sym_LT_EQ_GT] = ACTIONS(4934),
    [anon_sym_or] = ACTIONS(4932),
    [anon_sym_and] = ACTIONS(4932),
    [anon_sym_bitor] = ACTIONS(4932),
    [anon_sym_xor] = ACTIONS(4932),
    [anon_sym_bitand] = ACTIONS(4932),
    [anon_sym_not_eq] = ACTIONS(4932),
    [anon_sym_DASH_DASH] = ACTIONS(4934),
    [anon_sym_PLUS_PLUS] = ACTIONS(4934),
    [anon_sym_DOT] = ACTIONS(4932),
    [anon_sym_DOT_STAR] = ACTIONS(4934),
    [anon_sym_DASH_GT] = ACTIONS(4934),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4932),
    [anon_sym_decltype] = ACTIONS(4932),
  },
  [2250] = {
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5449),
    [anon_sym_COMMA] = ACTIONS(5449),
    [anon_sym_RPAREN] = ACTIONS(5449),
    [anon_sym_LPAREN2] = ACTIONS(5449),
    [anon_sym_DASH] = ACTIONS(5447),
    [anon_sym_PLUS] = ACTIONS(5447),
    [anon_sym_STAR] = ACTIONS(5447),
    [anon_sym_SLASH] = ACTIONS(5447),
    [anon_sym_PERCENT] = ACTIONS(5447),
    [anon_sym_PIPE_PIPE] = ACTIONS(5449),
    [anon_sym_AMP_AMP] = ACTIONS(5449),
    [anon_sym_PIPE] = ACTIONS(5447),
    [anon_sym_CARET] = ACTIONS(5447),
    [anon_sym_AMP] = ACTIONS(5447),
    [anon_sym_EQ_EQ] = ACTIONS(5449),
    [anon_sym_BANG_EQ] = ACTIONS(5449),
    [anon_sym_GT] = ACTIONS(5447),
    [anon_sym_GT_EQ] = ACTIONS(5449),
    [anon_sym_LT_EQ] = ACTIONS(5447),
    [anon_sym_LT] = ACTIONS(5447),
    [anon_sym_LT_LT] = ACTIONS(5447),
    [anon_sym_GT_GT] = ACTIONS(5447),
    [anon_sym_SEMI] = ACTIONS(5449),
    [anon_sym_RBRACE] = ACTIONS(5449),
    [anon_sym_LBRACK] = ACTIONS(5449),
    [anon_sym_RBRACK] = ACTIONS(5449),
    [anon_sym_EQ] = ACTIONS(5447),
    [anon_sym_COLON] = ACTIONS(5449),
    [anon_sym_QMARK] = ACTIONS(5449),
    [anon_sym_STAR_EQ] = ACTIONS(5449),
    [anon_sym_SLASH_EQ] = ACTIONS(5449),
    [anon_sym_PERCENT_EQ] = ACTIONS(5449),
    [anon_sym_PLUS_EQ] = ACTIONS(5449),
    [anon_sym_DASH_EQ] = ACTIONS(5449),
    [anon_sym_LT_LT_EQ] = ACTIONS(5449),
    [anon_sym_GT_GT_EQ] = ACTIONS(5449),
    [anon_sym_AMP_EQ] = ACTIONS(5449),
    [anon_sym_CARET_EQ] = ACTIONS(5449),
    [anon_sym_PIPE_EQ] = ACTIONS(5449),
    [anon_sym_and_eq] = ACTIONS(5447),
    [anon_sym_or_eq] = ACTIONS(5447),
    [anon_sym_xor_eq] = ACTIONS(5447),
    [anon_sym_LT_EQ_GT] = ACTIONS(5449),
    [anon_sym_or] = ACTIONS(5447),
    [anon_sym_and] = ACTIONS(5447),
    [anon_sym_bitor] = ACTIONS(5447),
    [anon_sym_xor] = ACTIONS(5447),
    [anon_sym_bitand] = ACTIONS(5447),
    [anon_sym_not_eq] = ACTIONS(5447),
    [anon_sym_DASH_DASH] = ACTIONS(5449),
    [anon_sym_PLUS_PLUS] = ACTIONS(5449),
    [anon_sym_DOT] = ACTIONS(5447),
    [anon_sym_DOT_STAR] = ACTIONS(5449),
    [anon_sym_DASH_GT] = ACTIONS(5449),
    [anon_sym_L_DQUOTE] = ACTIONS(5449),
    [anon_sym_u_DQUOTE] = ACTIONS(5449),
    [anon_sym_U_DQUOTE] = ACTIONS(5449),
    [anon_sym_u8_DQUOTE] = ACTIONS(5449),
    [anon_sym_DQUOTE] = ACTIONS(5449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5449),
    [anon_sym_LR_DQUOTE] = ACTIONS(5449),
    [anon_sym_uR_DQUOTE] = ACTIONS(5449),
    [anon_sym_UR_DQUOTE] = ACTIONS(5449),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5449),
    [sym_literal_suffix] = ACTIONS(5447),
  },
  [2251] = {
    [sym_identifier] = ACTIONS(5564),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5566),
    [anon_sym_COMMA] = ACTIONS(5566),
    [anon_sym_RPAREN] = ACTIONS(5566),
    [aux_sym_preproc_if_token2] = ACTIONS(5566),
    [aux_sym_preproc_else_token1] = ACTIONS(5566),
    [aux_sym_preproc_elif_token1] = ACTIONS(5564),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5566),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5566),
    [anon_sym_LPAREN2] = ACTIONS(5566),
    [anon_sym_DASH] = ACTIONS(5564),
    [anon_sym_PLUS] = ACTIONS(5564),
    [anon_sym_STAR] = ACTIONS(5564),
    [anon_sym_SLASH] = ACTIONS(5564),
    [anon_sym_PERCENT] = ACTIONS(5564),
    [anon_sym_PIPE_PIPE] = ACTIONS(5566),
    [anon_sym_AMP_AMP] = ACTIONS(5566),
    [anon_sym_PIPE] = ACTIONS(5564),
    [anon_sym_CARET] = ACTIONS(5564),
    [anon_sym_AMP] = ACTIONS(5564),
    [anon_sym_EQ_EQ] = ACTIONS(5566),
    [anon_sym_BANG_EQ] = ACTIONS(5566),
    [anon_sym_GT] = ACTIONS(5564),
    [anon_sym_GT_EQ] = ACTIONS(5566),
    [anon_sym_LT_EQ] = ACTIONS(5564),
    [anon_sym_LT] = ACTIONS(5564),
    [anon_sym_LT_LT] = ACTIONS(5564),
    [anon_sym_GT_GT] = ACTIONS(5564),
    [anon_sym_SEMI] = ACTIONS(5566),
    [anon_sym___attribute__] = ACTIONS(5564),
    [anon_sym___attribute] = ACTIONS(5564),
    [anon_sym_LBRACE] = ACTIONS(5566),
    [anon_sym_RBRACE] = ACTIONS(5566),
    [anon_sym_LBRACK] = ACTIONS(5566),
    [anon_sym_RBRACK] = ACTIONS(5566),
    [anon_sym_EQ] = ACTIONS(5564),
    [anon_sym_COLON] = ACTIONS(5566),
    [anon_sym_QMARK] = ACTIONS(5566),
    [anon_sym_STAR_EQ] = ACTIONS(5566),
    [anon_sym_SLASH_EQ] = ACTIONS(5566),
    [anon_sym_PERCENT_EQ] = ACTIONS(5566),
    [anon_sym_PLUS_EQ] = ACTIONS(5566),
    [anon_sym_DASH_EQ] = ACTIONS(5566),
    [anon_sym_LT_LT_EQ] = ACTIONS(5566),
    [anon_sym_GT_GT_EQ] = ACTIONS(5566),
    [anon_sym_AMP_EQ] = ACTIONS(5566),
    [anon_sym_CARET_EQ] = ACTIONS(5566),
    [anon_sym_PIPE_EQ] = ACTIONS(5566),
    [anon_sym_and_eq] = ACTIONS(5564),
    [anon_sym_or_eq] = ACTIONS(5564),
    [anon_sym_xor_eq] = ACTIONS(5564),
    [anon_sym_LT_EQ_GT] = ACTIONS(5566),
    [anon_sym_or] = ACTIONS(5564),
    [anon_sym_and] = ACTIONS(5564),
    [anon_sym_bitor] = ACTIONS(5564),
    [anon_sym_xor] = ACTIONS(5564),
    [anon_sym_bitand] = ACTIONS(5564),
    [anon_sym_not_eq] = ACTIONS(5564),
    [anon_sym_DASH_DASH] = ACTIONS(5566),
    [anon_sym_PLUS_PLUS] = ACTIONS(5566),
    [anon_sym_DOT] = ACTIONS(5564),
    [anon_sym_DOT_STAR] = ACTIONS(5566),
    [anon_sym_DASH_GT] = ACTIONS(5566),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5564),
    [anon_sym_decltype] = ACTIONS(5564),
  },
  [2252] = {
    [sym_identifier] = ACTIONS(6141),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6143),
    [anon_sym_COMMA] = ACTIONS(6143),
    [anon_sym_RPAREN] = ACTIONS(6143),
    [aux_sym_preproc_if_token2] = ACTIONS(6143),
    [aux_sym_preproc_else_token1] = ACTIONS(6143),
    [aux_sym_preproc_elif_token1] = ACTIONS(6141),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6143),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6143),
    [anon_sym_LPAREN2] = ACTIONS(6143),
    [anon_sym_DASH] = ACTIONS(6141),
    [anon_sym_PLUS] = ACTIONS(6141),
    [anon_sym_STAR] = ACTIONS(6141),
    [anon_sym_SLASH] = ACTIONS(6141),
    [anon_sym_PERCENT] = ACTIONS(6141),
    [anon_sym_PIPE_PIPE] = ACTIONS(6143),
    [anon_sym_AMP_AMP] = ACTIONS(6143),
    [anon_sym_PIPE] = ACTIONS(6141),
    [anon_sym_CARET] = ACTIONS(6141),
    [anon_sym_AMP] = ACTIONS(6141),
    [anon_sym_EQ_EQ] = ACTIONS(6143),
    [anon_sym_BANG_EQ] = ACTIONS(6143),
    [anon_sym_GT] = ACTIONS(6141),
    [anon_sym_GT_EQ] = ACTIONS(6143),
    [anon_sym_LT_EQ] = ACTIONS(6141),
    [anon_sym_LT] = ACTIONS(6141),
    [anon_sym_LT_LT] = ACTIONS(6141),
    [anon_sym_GT_GT] = ACTIONS(6141),
    [anon_sym_SEMI] = ACTIONS(6143),
    [anon_sym___attribute__] = ACTIONS(6141),
    [anon_sym___attribute] = ACTIONS(6141),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6143),
    [anon_sym_LBRACE] = ACTIONS(6143),
    [anon_sym_RBRACE] = ACTIONS(6143),
    [anon_sym_LBRACK] = ACTIONS(6141),
    [anon_sym_RBRACK] = ACTIONS(6143),
    [anon_sym_EQ] = ACTIONS(6141),
    [anon_sym_COLON] = ACTIONS(6143),
    [anon_sym_QMARK] = ACTIONS(6143),
    [anon_sym_STAR_EQ] = ACTIONS(6143),
    [anon_sym_SLASH_EQ] = ACTIONS(6143),
    [anon_sym_PERCENT_EQ] = ACTIONS(6143),
    [anon_sym_PLUS_EQ] = ACTIONS(6143),
    [anon_sym_DASH_EQ] = ACTIONS(6143),
    [anon_sym_LT_LT_EQ] = ACTIONS(6143),
    [anon_sym_GT_GT_EQ] = ACTIONS(6143),
    [anon_sym_AMP_EQ] = ACTIONS(6143),
    [anon_sym_CARET_EQ] = ACTIONS(6143),
    [anon_sym_PIPE_EQ] = ACTIONS(6143),
    [anon_sym_and_eq] = ACTIONS(6141),
    [anon_sym_or_eq] = ACTIONS(6141),
    [anon_sym_xor_eq] = ACTIONS(6141),
    [anon_sym_LT_EQ_GT] = ACTIONS(6143),
    [anon_sym_or] = ACTIONS(6141),
    [anon_sym_and] = ACTIONS(6141),
    [anon_sym_bitor] = ACTIONS(6141),
    [anon_sym_xor] = ACTIONS(6141),
    [anon_sym_bitand] = ACTIONS(6141),
    [anon_sym_not_eq] = ACTIONS(6141),
    [anon_sym_DASH_DASH] = ACTIONS(6143),
    [anon_sym_PLUS_PLUS] = ACTIONS(6143),
    [anon_sym_DOT] = ACTIONS(6141),
    [anon_sym_DOT_STAR] = ACTIONS(6143),
    [anon_sym_DASH_GT] = ACTIONS(6143),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6141),
  },
  [2253] = {
    [sym_argument_list] = STATE(2392),
    [sym_initializer_list] = STATE(2392),
    [sym_identifier] = ACTIONS(6145),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6147),
    [anon_sym_COMMA] = ACTIONS(6147),
    [anon_sym_RPAREN] = ACTIONS(6147),
    [aux_sym_preproc_if_token2] = ACTIONS(6147),
    [aux_sym_preproc_else_token1] = ACTIONS(6147),
    [aux_sym_preproc_elif_token1] = ACTIONS(6145),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6147),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6147),
    [anon_sym_LPAREN2] = ACTIONS(5688),
    [anon_sym_DASH] = ACTIONS(6145),
    [anon_sym_PLUS] = ACTIONS(6145),
    [anon_sym_STAR] = ACTIONS(6145),
    [anon_sym_SLASH] = ACTIONS(6145),
    [anon_sym_PERCENT] = ACTIONS(6145),
    [anon_sym_PIPE_PIPE] = ACTIONS(6147),
    [anon_sym_AMP_AMP] = ACTIONS(6147),
    [anon_sym_PIPE] = ACTIONS(6145),
    [anon_sym_CARET] = ACTIONS(6145),
    [anon_sym_AMP] = ACTIONS(6145),
    [anon_sym_EQ_EQ] = ACTIONS(6147),
    [anon_sym_BANG_EQ] = ACTIONS(6147),
    [anon_sym_GT] = ACTIONS(6145),
    [anon_sym_GT_EQ] = ACTIONS(6147),
    [anon_sym_LT_EQ] = ACTIONS(6145),
    [anon_sym_LT] = ACTIONS(6145),
    [anon_sym_LT_LT] = ACTIONS(6145),
    [anon_sym_GT_GT] = ACTIONS(6145),
    [anon_sym_SEMI] = ACTIONS(6147),
    [anon_sym___attribute__] = ACTIONS(6145),
    [anon_sym___attribute] = ACTIONS(6145),
    [anon_sym_LBRACE] = ACTIONS(1927),
    [anon_sym_RBRACE] = ACTIONS(6147),
    [anon_sym_LBRACK] = ACTIONS(6147),
    [anon_sym_RBRACK] = ACTIONS(6147),
    [anon_sym_EQ] = ACTIONS(6145),
    [anon_sym_COLON] = ACTIONS(6147),
    [anon_sym_QMARK] = ACTIONS(6147),
    [anon_sym_STAR_EQ] = ACTIONS(6147),
    [anon_sym_SLASH_EQ] = ACTIONS(6147),
    [anon_sym_PERCENT_EQ] = ACTIONS(6147),
    [anon_sym_PLUS_EQ] = ACTIONS(6147),
    [anon_sym_DASH_EQ] = ACTIONS(6147),
    [anon_sym_LT_LT_EQ] = ACTIONS(6147),
    [anon_sym_GT_GT_EQ] = ACTIONS(6147),
    [anon_sym_AMP_EQ] = ACTIONS(6147),
    [anon_sym_CARET_EQ] = ACTIONS(6147),
    [anon_sym_PIPE_EQ] = ACTIONS(6147),
    [anon_sym_and_eq] = ACTIONS(6145),
    [anon_sym_or_eq] = ACTIONS(6145),
    [anon_sym_xor_eq] = ACTIONS(6145),
    [anon_sym_LT_EQ_GT] = ACTIONS(6147),
    [anon_sym_or] = ACTIONS(6145),
    [anon_sym_and] = ACTIONS(6145),
    [anon_sym_bitor] = ACTIONS(6145),
    [anon_sym_xor] = ACTIONS(6145),
    [anon_sym_bitand] = ACTIONS(6145),
    [anon_sym_not_eq] = ACTIONS(6145),
    [anon_sym_DASH_DASH] = ACTIONS(6147),
    [anon_sym_PLUS_PLUS] = ACTIONS(6147),
    [anon_sym_DOT] = ACTIONS(6145),
    [anon_sym_DOT_STAR] = ACTIONS(6147),
    [anon_sym_DASH_GT] = ACTIONS(6147),
    [sym_comment] = ACTIONS(3),
  },
  [2254] = {
    [sym_identifier] = ACTIONS(4939),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4941),
    [anon_sym_COMMA] = ACTIONS(4941),
    [anon_sym_LPAREN2] = ACTIONS(4941),
    [anon_sym_DASH] = ACTIONS(4939),
    [anon_sym_PLUS] = ACTIONS(4939),
    [anon_sym_STAR] = ACTIONS(4941),
    [anon_sym_SLASH] = ACTIONS(4939),
    [anon_sym_PERCENT] = ACTIONS(4941),
    [anon_sym_PIPE_PIPE] = ACTIONS(4941),
    [anon_sym_AMP_AMP] = ACTIONS(4941),
    [anon_sym_PIPE] = ACTIONS(4939),
    [anon_sym_CARET] = ACTIONS(4941),
    [anon_sym_AMP] = ACTIONS(4939),
    [anon_sym_EQ_EQ] = ACTIONS(4941),
    [anon_sym_BANG_EQ] = ACTIONS(4941),
    [anon_sym_GT] = ACTIONS(4939),
    [anon_sym_GT_EQ] = ACTIONS(4939),
    [anon_sym_LT_EQ] = ACTIONS(4939),
    [anon_sym_LT] = ACTIONS(4939),
    [anon_sym_LT_LT] = ACTIONS(4941),
    [anon_sym_GT_GT] = ACTIONS(4939),
    [anon_sym___extension__] = ACTIONS(4939),
    [anon_sym___attribute__] = ACTIONS(4939),
    [anon_sym___attribute] = ACTIONS(4939),
    [anon_sym_LBRACE] = ACTIONS(4941),
    [anon_sym_signed] = ACTIONS(4939),
    [anon_sym_unsigned] = ACTIONS(4939),
    [anon_sym_long] = ACTIONS(4939),
    [anon_sym_short] = ACTIONS(4939),
    [anon_sym_LBRACK] = ACTIONS(4941),
    [anon_sym_const] = ACTIONS(4939),
    [anon_sym_constexpr] = ACTIONS(4939),
    [anon_sym_volatile] = ACTIONS(4939),
    [anon_sym_restrict] = ACTIONS(4939),
    [anon_sym___restrict__] = ACTIONS(4939),
    [anon_sym__Atomic] = ACTIONS(4939),
    [anon_sym__Noreturn] = ACTIONS(4939),
    [anon_sym_noreturn] = ACTIONS(4939),
    [anon_sym__Nonnull] = ACTIONS(4939),
    [anon_sym_mutable] = ACTIONS(4939),
    [anon_sym_constinit] = ACTIONS(4939),
    [anon_sym_consteval] = ACTIONS(4939),
    [anon_sym_alignas] = ACTIONS(4939),
    [anon_sym__Alignas] = ACTIONS(4939),
    [sym_primitive_type] = ACTIONS(4939),
    [anon_sym_QMARK] = ACTIONS(4941),
    [anon_sym_LT_EQ_GT] = ACTIONS(4941),
    [anon_sym_or] = ACTIONS(4939),
    [anon_sym_and] = ACTIONS(4939),
    [anon_sym_bitor] = ACTIONS(4939),
    [anon_sym_xor] = ACTIONS(4939),
    [anon_sym_bitand] = ACTIONS(4939),
    [anon_sym_not_eq] = ACTIONS(4939),
    [anon_sym_DASH_DASH] = ACTIONS(4941),
    [anon_sym_PLUS_PLUS] = ACTIONS(4941),
    [anon_sym_DOT] = ACTIONS(4939),
    [anon_sym_DOT_STAR] = ACTIONS(4941),
    [anon_sym_DASH_GT] = ACTIONS(4941),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4939),
    [anon_sym_decltype] = ACTIONS(4939),
    [anon_sym_final] = ACTIONS(4939),
    [anon_sym_override] = ACTIONS(4939),
    [anon_sym_GT2] = ACTIONS(4941),
    [anon_sym_requires] = ACTIONS(4939),
  },
  [2255] = {
    [sym_attribute_declaration] = STATE(2197),
    [aux_sym_attributed_declarator_repeat1] = STATE(2197),
    [sym_identifier] = ACTIONS(6149),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6151),
    [anon_sym_COMMA] = ACTIONS(6151),
    [anon_sym_RPAREN] = ACTIONS(6151),
    [aux_sym_preproc_if_token2] = ACTIONS(6151),
    [aux_sym_preproc_else_token1] = ACTIONS(6151),
    [aux_sym_preproc_elif_token1] = ACTIONS(6149),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6151),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6151),
    [anon_sym_LPAREN2] = ACTIONS(6151),
    [anon_sym_DASH] = ACTIONS(6149),
    [anon_sym_PLUS] = ACTIONS(6149),
    [anon_sym_STAR] = ACTIONS(6149),
    [anon_sym_SLASH] = ACTIONS(6149),
    [anon_sym_PERCENT] = ACTIONS(6149),
    [anon_sym_PIPE_PIPE] = ACTIONS(6151),
    [anon_sym_AMP_AMP] = ACTIONS(6151),
    [anon_sym_PIPE] = ACTIONS(6149),
    [anon_sym_CARET] = ACTIONS(6149),
    [anon_sym_AMP] = ACTIONS(6149),
    [anon_sym_EQ_EQ] = ACTIONS(6151),
    [anon_sym_BANG_EQ] = ACTIONS(6151),
    [anon_sym_GT] = ACTIONS(6149),
    [anon_sym_GT_EQ] = ACTIONS(6151),
    [anon_sym_LT_EQ] = ACTIONS(6149),
    [anon_sym_LT] = ACTIONS(6149),
    [anon_sym_LT_LT] = ACTIONS(6149),
    [anon_sym_GT_GT] = ACTIONS(6149),
    [anon_sym_SEMI] = ACTIONS(6151),
    [anon_sym___attribute__] = ACTIONS(6149),
    [anon_sym___attribute] = ACTIONS(6149),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(5897),
    [anon_sym_RBRACE] = ACTIONS(6151),
    [anon_sym_LBRACK] = ACTIONS(6149),
    [anon_sym_RBRACK] = ACTIONS(6151),
    [anon_sym_EQ] = ACTIONS(6149),
    [anon_sym_COLON] = ACTIONS(6151),
    [anon_sym_QMARK] = ACTIONS(6151),
    [anon_sym_STAR_EQ] = ACTIONS(6151),
    [anon_sym_SLASH_EQ] = ACTIONS(6151),
    [anon_sym_PERCENT_EQ] = ACTIONS(6151),
    [anon_sym_PLUS_EQ] = ACTIONS(6151),
    [anon_sym_DASH_EQ] = ACTIONS(6151),
    [anon_sym_LT_LT_EQ] = ACTIONS(6151),
    [anon_sym_GT_GT_EQ] = ACTIONS(6151),
    [anon_sym_AMP_EQ] = ACTIONS(6151),
    [anon_sym_CARET_EQ] = ACTIONS(6151),
    [anon_sym_PIPE_EQ] = ACTIONS(6151),
    [anon_sym_and_eq] = ACTIONS(6149),
    [anon_sym_or_eq] = ACTIONS(6149),
    [anon_sym_xor_eq] = ACTIONS(6149),
    [anon_sym_LT_EQ_GT] = ACTIONS(6151),
    [anon_sym_or] = ACTIONS(6149),
    [anon_sym_and] = ACTIONS(6149),
    [anon_sym_bitor] = ACTIONS(6149),
    [anon_sym_xor] = ACTIONS(6149),
    [anon_sym_bitand] = ACTIONS(6149),
    [anon_sym_not_eq] = ACTIONS(6149),
    [anon_sym_DASH_DASH] = ACTIONS(6151),
    [anon_sym_PLUS_PLUS] = ACTIONS(6151),
    [anon_sym_DOT] = ACTIONS(6149),
    [anon_sym_DOT_STAR] = ACTIONS(6151),
    [anon_sym_DASH_GT] = ACTIONS(6151),
    [sym_comment] = ACTIONS(3),
  },
  [2256] = {
    [sym_identifier] = ACTIONS(5537),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5539),
    [anon_sym_COMMA] = ACTIONS(5539),
    [anon_sym_RPAREN] = ACTIONS(5539),
    [aux_sym_preproc_if_token2] = ACTIONS(5539),
    [aux_sym_preproc_else_token1] = ACTIONS(5539),
    [aux_sym_preproc_elif_token1] = ACTIONS(5537),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5539),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5539),
    [anon_sym_LPAREN2] = ACTIONS(5539),
    [anon_sym_DASH] = ACTIONS(5537),
    [anon_sym_PLUS] = ACTIONS(5537),
    [anon_sym_STAR] = ACTIONS(5537),
    [anon_sym_SLASH] = ACTIONS(5537),
    [anon_sym_PERCENT] = ACTIONS(5537),
    [anon_sym_PIPE_PIPE] = ACTIONS(5539),
    [anon_sym_AMP_AMP] = ACTIONS(5539),
    [anon_sym_PIPE] = ACTIONS(5537),
    [anon_sym_CARET] = ACTIONS(5537),
    [anon_sym_AMP] = ACTIONS(5537),
    [anon_sym_EQ_EQ] = ACTIONS(5539),
    [anon_sym_BANG_EQ] = ACTIONS(5539),
    [anon_sym_GT] = ACTIONS(5537),
    [anon_sym_GT_EQ] = ACTIONS(5539),
    [anon_sym_LT_EQ] = ACTIONS(5537),
    [anon_sym_LT] = ACTIONS(5537),
    [anon_sym_LT_LT] = ACTIONS(5537),
    [anon_sym_GT_GT] = ACTIONS(5537),
    [anon_sym_SEMI] = ACTIONS(5539),
    [anon_sym___attribute__] = ACTIONS(5537),
    [anon_sym___attribute] = ACTIONS(5537),
    [anon_sym_LBRACE] = ACTIONS(5539),
    [anon_sym_RBRACE] = ACTIONS(5539),
    [anon_sym_LBRACK] = ACTIONS(5539),
    [anon_sym_RBRACK] = ACTIONS(5539),
    [anon_sym_EQ] = ACTIONS(5537),
    [anon_sym_COLON] = ACTIONS(5539),
    [anon_sym_QMARK] = ACTIONS(5539),
    [anon_sym_STAR_EQ] = ACTIONS(5539),
    [anon_sym_SLASH_EQ] = ACTIONS(5539),
    [anon_sym_PERCENT_EQ] = ACTIONS(5539),
    [anon_sym_PLUS_EQ] = ACTIONS(5539),
    [anon_sym_DASH_EQ] = ACTIONS(5539),
    [anon_sym_LT_LT_EQ] = ACTIONS(5539),
    [anon_sym_GT_GT_EQ] = ACTIONS(5539),
    [anon_sym_AMP_EQ] = ACTIONS(5539),
    [anon_sym_CARET_EQ] = ACTIONS(5539),
    [anon_sym_PIPE_EQ] = ACTIONS(5539),
    [anon_sym_and_eq] = ACTIONS(5537),
    [anon_sym_or_eq] = ACTIONS(5537),
    [anon_sym_xor_eq] = ACTIONS(5537),
    [anon_sym_LT_EQ_GT] = ACTIONS(5539),
    [anon_sym_or] = ACTIONS(5537),
    [anon_sym_and] = ACTIONS(5537),
    [anon_sym_bitor] = ACTIONS(5537),
    [anon_sym_xor] = ACTIONS(5537),
    [anon_sym_bitand] = ACTIONS(5537),
    [anon_sym_not_eq] = ACTIONS(5537),
    [anon_sym_DASH_DASH] = ACTIONS(5539),
    [anon_sym_PLUS_PLUS] = ACTIONS(5539),
    [anon_sym_DOT] = ACTIONS(5537),
    [anon_sym_DOT_STAR] = ACTIONS(5539),
    [anon_sym_DASH_GT] = ACTIONS(5539),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5537),
    [anon_sym_decltype] = ACTIONS(5537),
  },
  [2257] = {
    [sym_string_literal] = STATE(2240),
    [sym_raw_string_literal] = STATE(2240),
    [aux_sym_concatenated_string_repeat1] = STATE(2240),
    [sym_identifier] = ACTIONS(6153),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5251),
    [anon_sym_COMMA] = ACTIONS(5251),
    [anon_sym_LPAREN2] = ACTIONS(5251),
    [anon_sym_DASH] = ACTIONS(5253),
    [anon_sym_PLUS] = ACTIONS(5253),
    [anon_sym_STAR] = ACTIONS(5253),
    [anon_sym_SLASH] = ACTIONS(5253),
    [anon_sym_PERCENT] = ACTIONS(5253),
    [anon_sym_PIPE_PIPE] = ACTIONS(5251),
    [anon_sym_AMP_AMP] = ACTIONS(5251),
    [anon_sym_PIPE] = ACTIONS(5253),
    [anon_sym_CARET] = ACTIONS(5253),
    [anon_sym_AMP] = ACTIONS(5253),
    [anon_sym_EQ_EQ] = ACTIONS(5251),
    [anon_sym_BANG_EQ] = ACTIONS(5251),
    [anon_sym_GT] = ACTIONS(5253),
    [anon_sym_GT_EQ] = ACTIONS(5253),
    [anon_sym_LT_EQ] = ACTIONS(5253),
    [anon_sym_LT] = ACTIONS(5253),
    [anon_sym_LT_LT] = ACTIONS(5253),
    [anon_sym_GT_GT] = ACTIONS(5253),
    [anon_sym_LBRACK] = ACTIONS(5251),
    [anon_sym_EQ] = ACTIONS(5253),
    [anon_sym_QMARK] = ACTIONS(5251),
    [anon_sym_STAR_EQ] = ACTIONS(5251),
    [anon_sym_SLASH_EQ] = ACTIONS(5251),
    [anon_sym_PERCENT_EQ] = ACTIONS(5251),
    [anon_sym_PLUS_EQ] = ACTIONS(5251),
    [anon_sym_DASH_EQ] = ACTIONS(5251),
    [anon_sym_LT_LT_EQ] = ACTIONS(5251),
    [anon_sym_GT_GT_EQ] = ACTIONS(5253),
    [anon_sym_AMP_EQ] = ACTIONS(5251),
    [anon_sym_CARET_EQ] = ACTIONS(5251),
    [anon_sym_PIPE_EQ] = ACTIONS(5251),
    [anon_sym_and_eq] = ACTIONS(5253),
    [anon_sym_or_eq] = ACTIONS(5253),
    [anon_sym_xor_eq] = ACTIONS(5253),
    [anon_sym_LT_EQ_GT] = ACTIONS(5251),
    [anon_sym_or] = ACTIONS(5253),
    [anon_sym_and] = ACTIONS(5253),
    [anon_sym_bitor] = ACTIONS(5253),
    [anon_sym_xor] = ACTIONS(5253),
    [anon_sym_bitand] = ACTIONS(5253),
    [anon_sym_not_eq] = ACTIONS(5253),
    [anon_sym_DASH_DASH] = ACTIONS(5251),
    [anon_sym_PLUS_PLUS] = ACTIONS(5251),
    [anon_sym_DOT] = ACTIONS(5253),
    [anon_sym_DOT_STAR] = ACTIONS(5251),
    [anon_sym_DASH_GT] = ACTIONS(5251),
    [anon_sym_L_DQUOTE] = ACTIONS(6132),
    [anon_sym_u_DQUOTE] = ACTIONS(6132),
    [anon_sym_U_DQUOTE] = ACTIONS(6132),
    [anon_sym_u8_DQUOTE] = ACTIONS(6132),
    [anon_sym_DQUOTE] = ACTIONS(6132),
    [sym_comment] = ACTIONS(3),
    [anon_sym_GT2] = ACTIONS(5251),
    [anon_sym_R_DQUOTE] = ACTIONS(6134),
    [anon_sym_LR_DQUOTE] = ACTIONS(6134),
    [anon_sym_uR_DQUOTE] = ACTIONS(6134),
    [anon_sym_UR_DQUOTE] = ACTIONS(6134),
    [anon_sym_u8R_DQUOTE] = ACTIONS(6134),
    [sym_literal_suffix] = ACTIONS(5253),
  },
  [2258] = {
    [sym_identifier] = ACTIONS(6155),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6157),
    [anon_sym_COMMA] = ACTIONS(6157),
    [anon_sym_RPAREN] = ACTIONS(6157),
    [aux_sym_preproc_if_token2] = ACTIONS(6157),
    [aux_sym_preproc_else_token1] = ACTIONS(6157),
    [aux_sym_preproc_elif_token1] = ACTIONS(6155),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6157),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6157),
    [anon_sym_LPAREN2] = ACTIONS(6157),
    [anon_sym_DASH] = ACTIONS(6155),
    [anon_sym_PLUS] = ACTIONS(6155),
    [anon_sym_STAR] = ACTIONS(6155),
    [anon_sym_SLASH] = ACTIONS(6155),
    [anon_sym_PERCENT] = ACTIONS(6155),
    [anon_sym_PIPE_PIPE] = ACTIONS(6157),
    [anon_sym_AMP_AMP] = ACTIONS(6157),
    [anon_sym_PIPE] = ACTIONS(6155),
    [anon_sym_CARET] = ACTIONS(6155),
    [anon_sym_AMP] = ACTIONS(6155),
    [anon_sym_EQ_EQ] = ACTIONS(6157),
    [anon_sym_BANG_EQ] = ACTIONS(6157),
    [anon_sym_GT] = ACTIONS(6155),
    [anon_sym_GT_EQ] = ACTIONS(6157),
    [anon_sym_LT_EQ] = ACTIONS(6155),
    [anon_sym_LT] = ACTIONS(6155),
    [anon_sym_LT_LT] = ACTIONS(6155),
    [anon_sym_GT_GT] = ACTIONS(6155),
    [anon_sym_SEMI] = ACTIONS(6157),
    [anon_sym___attribute__] = ACTIONS(6155),
    [anon_sym___attribute] = ACTIONS(6155),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(6157),
    [anon_sym_LBRACE] = ACTIONS(6157),
    [anon_sym_RBRACE] = ACTIONS(6157),
    [anon_sym_LBRACK] = ACTIONS(6155),
    [anon_sym_RBRACK] = ACTIONS(6157),
    [anon_sym_EQ] = ACTIONS(6155),
    [anon_sym_COLON] = ACTIONS(6157),
    [anon_sym_QMARK] = ACTIONS(6157),
    [anon_sym_STAR_EQ] = ACTIONS(6157),
    [anon_sym_SLASH_EQ] = ACTIONS(6157),
    [anon_sym_PERCENT_EQ] = ACTIONS(6157),
    [anon_sym_PLUS_EQ] = ACTIONS(6157),
    [anon_sym_DASH_EQ] = ACTIONS(6157),
    [anon_sym_LT_LT_EQ] = ACTIONS(6157),
    [anon_sym_GT_GT_EQ] = ACTIONS(6157),
    [anon_sym_AMP_EQ] = ACTIONS(6157),
    [anon_sym_CARET_EQ] = ACTIONS(6157),
    [anon_sym_PIPE_EQ] = ACTIONS(6157),
    [anon_sym_and_eq] = ACTIONS(6155),
    [anon_sym_or_eq] = ACTIONS(6155),
    [anon_sym_xor_eq] = ACTIONS(6155),
    [anon_sym_LT_EQ_GT] = ACTIONS(6157),
    [anon_sym_or] = ACTIONS(6155),
    [anon_sym_and] = ACTIONS(6155),
    [anon_sym_bitor] = ACTIONS(6155),
    [anon_sym_xor] = ACTIONS(6155),
    [anon_sym_bitand] = ACTIONS(6155),
    [anon_sym_not_eq] = ACTIONS(6155),
    [anon_sym_DASH_DASH] = ACTIONS(6157),
    [anon_sym_PLUS_PLUS] = ACTIONS(6157),
    [anon_sym_DOT] = ACTIONS(6155),
    [anon_sym_DOT_STAR] = ACTIONS(6157),
    [anon_sym_DASH_GT] = ACTIONS(6157),
    [sym_comment] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(6155),
  },
  [2259] = {
    [sym_string_literal] = STATE(2570),
    [sym_template_argument_list] = STATE(3643),
    [sym_raw_string_literal] = STATE(2570),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4035),
    [anon_sym_COMMA] = ACTIONS(4035),
    [anon_sym_LPAREN2] = ACTIONS(4035),
    [anon_sym_DASH] = ACTIONS(4043),
    [anon_sym_PLUS] = ACTIONS(4043),
    [anon_sym_STAR] = ACTIONS(4043),
    [anon_sym_SLASH] = ACTIONS(4043),
    [anon_sym_PERCENT] = ACTIONS(4043),
    [anon_sym_PIPE_PIPE] = ACTIONS(4035),
    [anon_sym_AMP_AMP] = ACTIONS(4035),
    [anon_sym_PIPE] = ACTIONS(4043),
    [anon_sym_CARET] = ACTIONS(4043),
    [anon_sym_AMP] = ACTIONS(4043),
    [anon_sym_EQ_EQ] = ACTIONS(4035),
    [anon_sym_BANG_EQ] = ACTIONS(4035),
    [anon_sym_GT] = ACTIONS(4043),
    [anon_sym_GT_EQ] = ACTIONS(4035),
    [anon_sym_LT_EQ] = ACTIONS(4043),
    [anon_sym_LT] = ACTIONS(4929),
    [anon_sym_LT_LT] = ACTIONS(4043),
    [anon_sym_GT_GT] = ACTIONS(4043),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_LBRACE] = ACTIONS(4059),
    [anon_sym_LBRACK] = ACTIONS(4035),
    [anon_sym_RBRACK] = ACTIONS(4035),
    [anon_sym_EQ] = ACTIONS(6015),
    [anon_sym_QMARK] = ACTIONS(4035),
    [anon_sym_STAR_EQ] = ACTIONS(5941),
    [anon_sym_SLASH_EQ] = ACTIONS(5941),
    [anon_sym_PERCENT_EQ] = ACTIONS(5941),
    [anon_sym_PLUS_EQ] = ACTIONS(5941),
    [anon_sym_DASH_EQ] = ACTIONS(5941),
    [anon_sym_LT_LT_EQ] = ACTIONS(5941),
    [anon_sym_GT_GT_EQ] = ACTIONS(5941),
    [anon_sym_AMP_EQ] = ACTIONS(5941),
    [anon_sym_CARET_EQ] = ACTIONS(5941),
    [anon_sym_PIPE_EQ] = ACTIONS(5941),
    [anon_sym_and_eq] = ACTIONS(5941),
    [anon_sym_or_eq] = ACTIONS(5941),
    [anon_sym_xor_eq] = ACTIONS(5941),
    [anon_sym_LT_EQ_GT] = ACTIONS(4035),
    [anon_sym_or] = ACTIONS(4043),
    [anon_sym_and] = ACTIONS(4043),
    [anon_sym_bitor] = ACTIONS(4035),
    [anon_sym_xor] = ACTIONS(4043),
    [anon_sym_bitand] = ACTIONS(4035),
    [anon_sym_not_eq] = ACTIONS(4035),
    [anon_sym_DASH_DASH] = ACTIONS(4035),
    [anon_sym_PLUS_PLUS] = ACTIONS(4035),
    [anon_sym_DOT] = ACTIONS(4043),
    [anon_sym_DOT_STAR] = ACTIONS(4035),
    [anon_sym_DASH_GT] = ACTIONS(4035),
    [anon_sym_L_DQUOTE] = ACTIONS(3474),
    [anon_sym_u_DQUOTE] = ACTIONS(3474),
    [anon_sym_U_DQUOTE] = ACTIONS(3474),
    [anon_sym_u8_DQUOTE] = ACTIONS(3474),
    [anon_sym_DQUOTE] = ACTIONS(3474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(3478),
    [anon_sym_LR_DQUOTE] = ACTIONS(3478),
    [anon_sym_uR_DQUOTE] = ACTIONS(3478),
    [anon_sym_UR_DQUOTE] = ACTIONS(3478),
    [anon_sym_u8R_DQUOTE] = ACTIONS(3478),
  },
  [2260] = {
    [sym_identifier] = ACTIONS(5656),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5658),
    [anon_sym_COMMA] = ACTIONS(5658),
    [anon_sym_RPAREN] = ACTIONS(5658),
    [aux_sym_preproc_if_token2] = ACTIONS(5658),
    [aux_sym_preproc_else_token1] = ACTIONS(5658),
    [aux_sym_preproc_elif_token1] = ACTIONS(5656),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5658),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5658),
    [anon_sym_LPAREN2] = ACTIONS(5658),
    [anon_sym_DASH] = ACTIONS(5656),
    [anon_sym_PLUS] = ACTIONS(5656),
    [anon_sym_STAR] = ACTIONS(5656),
    [anon_sym_SLASH] = ACTIONS(5656),
    [anon_sym_PERCENT] = ACTIONS(5656),
    [anon_sym_PIPE_PIPE] = ACTIONS(5658),
    [anon_sym_AMP_AMP] = ACTIONS(5658),
    [anon_sym_PIPE] = ACTIONS(5656),
    [anon_sym_CARET] = ACTIONS(5656),
    [anon_sym_AMP] = ACTIONS(5656),
    [anon_sym_EQ_EQ] = ACTIONS(5658),
    [anon_sym_BANG_EQ] = ACTIONS(5658),
    [anon_sym_GT] = ACTIONS(5656),
    [anon_sym_GT_EQ] = ACTIONS(5658),
    [anon_sym_LT_EQ] = ACTIONS(5656),
    [anon_sym_LT] = ACTIONS(5656),
    [anon_sym_LT_LT] = ACTIONS(5656),
    [anon_sym_GT_GT] = ACTIONS(5656),
    [anon_sym_SEMI] = ACTIONS(5658),
    [anon_sym___attribute__] = ACTIONS(5656),
    [anon_sym___attribute] = ACTIONS(5656),
    [anon_sym_LBRACE] = ACTIONS(5658),
    [anon_sym_RBRACE] = ACTIONS(5658),
    [anon_sym_LBRACK] = ACTIONS(5658),
    [anon_sym_RBRACK] = ACTIONS(5658),
    [anon_sym_EQ] = ACTIONS(5656),
    [anon_sym_COLON] = ACTIONS(5658),
    [anon_sym_QMARK] = ACTIONS(5658),
    [anon_sym_STAR_EQ] = ACTIONS(5658),
    [anon_sym_SLASH_EQ] = ACTIONS(5658),
    [anon_sym_PERCENT_EQ] = ACTIONS(5658),
    [anon_sym_PLUS_EQ] = ACTIONS(5658),
    [anon_sym_DASH_EQ] = ACTIONS(5658),
    [anon_sym_LT_LT_EQ] = ACTIONS(5658),
    [anon_sym_GT_GT_EQ] = ACTIONS(5658),
    [anon_sym_AMP_EQ] = ACTIONS(5658),
    [anon_sym_CARET_EQ] = ACTIONS(5658),
    [anon_sym_PIPE_EQ] = ACTIONS(5658),
    [anon_sym_and_eq] = ACTIONS(5656),
    [anon_sym_or_eq] = ACTIONS(5656),
    [anon_sym_xor_eq] = ACTIONS(5656),
    [anon_sym_LT_EQ_GT] = ACTIONS(5658),
    [anon_sym_or] = ACTIONS(5656),
    [anon_sym_and] = ACTIONS(5656),
    [anon_sym_bitor] = ACTIONS(5656),
    [anon_sym_xor] = ACTIONS(5656),
    [anon_sym_bitand] = ACTIONS(5656),
    [anon_sym_not_eq] = ACTIONS(5656),
    [anon_sym_DASH_DASH] = ACTIONS(5658),
    [anon_sym_PLUS_PLUS] = ACTIONS(5658),
    [anon_sym_DOT] = ACTIONS(5656),
    [anon_sym_DOT_STAR] = ACTIONS(5658),
    [anon_sym_DASH_GT] = ACTIONS(5658),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5656),
    [anon_sym_decltype] = ACTIONS(5656),
  },
  [2261] = {
    [sym_identifier] = ACTIONS(5431),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5433),
    [anon_sym_COMMA] = ACTIONS(5433),
    [anon_sym_RPAREN] = ACTIONS(5433),
    [aux_sym_preproc_if_token2] = ACTIONS(5433),
    [aux_sym_preproc_else_token1] = ACTIONS(5433),
    [aux_sym_preproc_elif_token1] = ACTIONS(5431),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5433),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5433),
    [anon_sym_LPAREN2] = ACTIONS(5433),
    [anon_sym_DASH] = ACTIONS(5431),
    [anon_sym_PLUS] = ACTIONS(5431),
    [anon_sym_STAR] = ACTIONS(5431),
    [anon_sym_SLASH] = ACTIONS(5431),
    [anon_sym_PERCENT] = ACTIONS(5431),
    [anon_sym_PIPE_PIPE] = ACTIONS(5433),
    [anon_sym_AMP_AMP] = ACTIONS(5433),
    [anon_sym_PIPE] = ACTIONS(5431),
    [anon_sym_CARET] = ACTIONS(5431),
    [anon_sym_AMP] = ACTIONS(5431),
    [anon_sym_EQ_EQ] = ACTIONS(5433),
    [anon_sym_BANG_EQ] = ACTIONS(5433),
    [anon_sym_GT] = ACTIONS(5431),
    [anon_sym_GT_EQ] = ACTIONS(5433),
    [anon_sym_LT_EQ] = ACTIONS(5431),
    [anon_sym_LT] = ACTIONS(5431),
    [anon_sym_LT_LT] = ACTIONS(5431),
    [anon_sym_GT_GT] = ACTIONS(5431),
    [anon_sym_SEMI] = ACTIONS(5433),
    [anon_sym___attribute__] = ACTIONS(5431),
    [anon_sym___attribute] = ACTIONS(5431),
    [anon_sym_LBRACE] = ACTIONS(5433),
    [anon_sym_RBRACE] = ACTIONS(5433),
    [anon_sym_LBRACK] = ACTIONS(5433),
    [anon_sym_RBRACK] = ACTIONS(5433),
    [anon_sym_EQ] = ACTIONS(5431),
    [anon_sym_COLON] = ACTIONS(5433),
    [anon_sym_QMARK] = ACTIONS(5433),
    [anon_sym_STAR_EQ] = ACTIONS(5433),
    [anon_sym_SLASH_EQ] = ACTIONS(5433),
    [anon_sym_PERCENT_EQ] = ACTIONS(5433),
    [anon_sym_PLUS_EQ] = ACTIONS(5433),
    [anon_sym_DASH_EQ] = ACTIONS(5433),
    [anon_sym_LT_LT_EQ] = ACTIONS(5433),
    [anon_sym_GT_GT_EQ] = ACTIONS(5433),
    [anon_sym_AMP_EQ] = ACTIONS(5433),
    [anon_sym_CARET_EQ] = ACTIONS(5433),
    [anon_sym_PIPE_EQ] = ACTIONS(5433),
    [anon_sym_and_eq] = ACTIONS(5431),
    [anon_sym_or_eq] = ACTIONS(5431),
    [anon_sym_xor_eq] = ACTIONS(5431),
    [anon_sym_LT_EQ_GT] = ACTIONS(5433),
    [anon_sym_or] = ACTIONS(5431),
    [anon_sym_and] = ACTIONS(5431),
    [anon_sym_bitor] = ACTIONS(5431),
    [anon_sym_xor] = ACTIONS(5431),
    [anon_sym_bitand] = ACTIONS(5431),
    [anon_sym_not_eq] = ACTIONS(5431),
    [anon_sym_DASH_DASH] = ACTIONS(5433),
    [anon_sym_PLUS_PLUS] = ACTIONS(5433),
    [anon_sym_DOT] = ACTIONS(5431),
    [anon_sym_DOT_STAR] = ACTIONS(5433),
    [anon_sym_DASH_GT] = ACTIONS(5433),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5431),
    [anon_sym_decltype] = ACTIONS(5431),
  },
  [2262] = {
    [sym_identifier] = ACTIONS(5502),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5504),
    [anon_sym_COMMA] = ACTIONS(5504),
    [anon_sym_RPAREN] = ACTIONS(5504),
    [aux_sym_preproc_if_token2] = ACTIONS(5504),
    [aux_sym_preproc_else_token1] = ACTIONS(5504),
    [aux_sym_preproc_elif_token1] = ACTIONS(5502),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5504),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5504),
    [anon_sym_LPAREN2] = ACTIONS(5504),
    [anon_sym_DASH] = ACTIONS(5502),
    [anon_sym_PLUS] = ACTIONS(5502),
    [anon_sym_STAR] = ACTIONS(5502),
    [anon_sym_SLASH] = ACTIONS(5502),
    [anon_sym_PERCENT] = ACTIONS(5502),
    [anon_sym_PIPE_PIPE] = ACTIONS(5504),
    [anon_sym_AMP_AMP] = ACTIONS(5504),
    [anon_sym_PIPE] = ACTIONS(5502),
    [anon_sym_CARET] = ACTIONS(5502),
    [anon_sym_AMP] = ACTIONS(5502),
    [anon_sym_EQ_EQ] = ACTIONS(5504),
    [anon_sym_BANG_EQ] = ACTIONS(5504),
    [anon_sym_GT] = ACTIONS(5502),
    [anon_sym_GT_EQ] = ACTIONS(5504),
    [anon_sym_LT_EQ] = ACTIONS(5502),
    [anon_sym_LT] = ACTIONS(5502),
    [anon_sym_LT_LT] = ACTIONS(5502),
    [anon_sym_GT_GT] = ACTIONS(5502),
    [anon_sym_SEMI] = ACTIONS(5504),
    [anon_sym___attribute__] = ACTIONS(5502),
    [anon_sym___attribute] = ACTIONS(5502),
    [anon_sym_LBRACE] = ACTIONS(5504),
    [anon_sym_RBRACE] = ACTIONS(5504),
    [anon_sym_LBRACK] = ACTIONS(5504),
    [anon_sym_RBRACK] = ACTIONS(5504),
    [anon_sym_EQ] = ACTIONS(5502),
    [anon_sym_COLON] = ACTIONS(5504),
    [anon_sym_QMARK] = ACTIONS(5504),
    [anon_sym_STAR_EQ] = ACTIONS(5504),
    [anon_sym_SLASH_EQ] = ACTIONS(5504),
    [anon_sym_PERCENT_EQ] = ACTIONS(5504),
    [anon_sym_PLUS_EQ] = ACTIONS(5504),
    [anon_sym_DASH_EQ] = ACTIONS(5504),
    [anon_sym_LT_LT_EQ] = ACTIONS(5504),
    [anon_sym_GT_GT_EQ] = ACTIONS(5504),
    [anon_sym_AMP_EQ] = ACTIONS(5504),
    [anon_sym_CARET_EQ] = ACTIONS(5504),
    [anon_sym_PIPE_EQ] = ACTIONS(5504),
    [anon_sym_and_eq] = ACTIONS(5502),
    [anon_sym_or_eq] = ACTIONS(5502),
    [anon_sym_xor_eq] = ACTIONS(5502),
    [anon_sym_LT_EQ_GT] = ACTIONS(5504),
    [anon_sym_or] = ACTIONS(5502),
    [anon_sym_and] = ACTIONS(5502),
    [anon_sym_bitor] = ACTIONS(5502),
    [anon_sym_xor] = ACTIONS(5502),
    [anon_sym_bitand] = ACTIONS(5502),
    [anon_sym_not_eq] = ACTIONS(5502),
    [anon_sym_DASH_DASH] = ACTIONS(5504),
    [anon_sym_PLUS_PLUS] = ACTIONS(5504),
    [anon_sym_DOT] = ACTIONS(5502),
    [anon_sym_DOT_STAR] = ACTIONS(5504),
    [anon_sym_DASH_GT] = ACTIONS(5504),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5502),
    [anon_sym_decltype] = ACTIONS(5502),
  },
  [2263] = {
    [sym_identifier] = ACTIONS(5644),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5646),
    [anon_sym_COMMA] = ACTIONS(5646),
    [anon_sym_RPAREN] = ACTIONS(5646),
    [aux_sym_preproc_if_token2] = ACTIONS(5646),
    [aux_sym_preproc_else_token1] = ACTIONS(5646),
    [aux_sym_preproc_elif_token1] = ACTIONS(5644),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5646),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5646),
    [anon_sym_LPAREN2] = ACTIONS(5646),
    [anon_sym_DASH] = ACTIONS(5644),
    [anon_sym_PLUS] = ACTIONS(5644),
    [anon_sym_STAR] = ACTIONS(5644),
    [anon_sym_SLASH] = ACTIONS(5644),
    [anon_sym_PERCENT] = ACTIONS(5644),
    [anon_sym_PIPE_PIPE] = ACTIONS(5646),
    [anon_sym_AMP_AMP] = ACTIONS(5646),
    [anon_sym_PIPE] = ACTIONS(5644),
    [anon_sym_CARET] = ACTIONS(5644),
    [anon_sym_AMP] = ACTIONS(5644),
    [anon_sym_EQ_EQ] = ACTIONS(5646),
    [anon_sym_BANG_EQ] = ACTIONS(5646),
    [anon_sym_GT] = ACTIONS(5644),
    [anon_sym_GT_EQ] = ACTIONS(5646),
    [anon_sym_LT_EQ] = ACTIONS(5644),
    [anon_sym_LT] = ACTIONS(5644),
    [anon_sym_LT_LT] = ACTIONS(5644),
    [anon_sym_GT_GT] = ACTIONS(5644),
    [anon_sym_SEMI] = ACTIONS(5646),
    [anon_sym___attribute__] = ACTIONS(5644),
    [anon_sym___attribute] = ACTIONS(5644),
    [anon_sym_LBRACE] = ACTIONS(5646),
    [anon_sym_RBRACE] = ACTIONS(5646),
    [anon_sym_LBRACK] = ACTIONS(5646),
    [anon_sym_RBRACK] = ACTIONS(5646),
    [anon_sym_EQ] = ACTIONS(5644),
    [anon_sym_COLON] = ACTIONS(5646),
    [anon_sym_QMARK] = ACTIONS(5646),
    [anon_sym_STAR_EQ] = ACTIONS(5646),
    [anon_sym_SLASH_EQ] = ACTIONS(5646),
    [anon_sym_PERCENT_EQ] = ACTIONS(5646),
    [anon_sym_PLUS_EQ] = ACTIONS(5646),
    [anon_sym_DASH_EQ] = ACTIONS(5646),
    [anon_sym_LT_LT_EQ] = ACTIONS(5646),
    [anon_sym_GT_GT_EQ] = ACTIONS(5646),
    [anon_sym_AMP_EQ] = ACTIONS(5646),
    [anon_sym_CARET_EQ] = ACTIONS(5646),
    [anon_sym_PIPE_EQ] = ACTIONS(5646),
    [anon_sym_and_eq] = ACTIONS(5644),
    [anon_sym_or_eq] = ACTIONS(5644),
    [anon_sym_xor_eq] = ACTIONS(5644),
    [anon_sym_LT_EQ_GT] = ACTIONS(5646),
    [anon_sym_or] = ACTIONS(5644),
    [anon_sym_and] = ACTIONS(5644),
    [anon_sym_bitor] = ACTIONS(5644),
    [anon_sym_xor] = ACTIONS(5644),
    [anon_sym_bitand] = ACTIONS(5644),
    [anon_sym_not_eq] = ACTIONS(5644),
    [anon_sym_DASH_DASH] = ACTIONS(5646),
    [anon_sym_PLUS_PLUS] = ACTIONS(5646),
    [anon_sym_DOT] = ACTIONS(5644),
    [anon_sym_DOT_STAR] = ACTIONS(5646),
    [anon_sym_DASH_GT] = ACTIONS(5646),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5644),
    [anon_sym_decltype] = ACTIONS(5644),
  },
  [2264] = {
    [sym_identifier] = ACTIONS(5660),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5662),
    [anon_sym_COMMA] = ACTIONS(5662),
    [anon_sym_RPAREN] = ACTIONS(5662),
    [aux_sym_preproc_if_token2] = ACTIONS(5662),
    [aux_sym_preproc_else_token1] = ACTIONS(5662),
    [aux_sym_preproc_elif_token1] = ACTIONS(5660),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5662),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5662),
    [anon_sym_LPAREN2] = ACTIONS(5662),
    [anon_sym_DASH] = ACTIONS(5660),
    [anon_sym_PLUS] = ACTIONS(5660),
    [anon_sym_STAR] = ACTIONS(5660),
    [anon_sym_SLASH] = ACTIONS(5660),
    [anon_sym_PERCENT] = ACTIONS(5660),
    [anon_sym_PIPE_PIPE] = ACTIONS(5662),
    [anon_sym_AMP_AMP] = ACTIONS(5662),
    [anon_sym_PIPE] = ACTIONS(5660),
    [anon_sym_CARET] = ACTIONS(5660),
    [anon_sym_AMP] = ACTIONS(5660),
    [anon_sym_EQ_EQ] = ACTIONS(5662),
    [anon_sym_BANG_EQ] = ACTIONS(5662),
    [anon_sym_GT] = ACTIONS(5660),
    [anon_sym_GT_EQ] = ACTIONS(5662),
    [anon_sym_LT_EQ] = ACTIONS(5660),
    [anon_sym_LT] = ACTIONS(5660),
    [anon_sym_LT_LT] = ACTIONS(5660),
    [anon_sym_GT_GT] = ACTIONS(5660),
    [anon_sym_SEMI] = ACTIONS(5662),
    [anon_sym___attribute__] = ACTIONS(5660),
    [anon_sym___attribute] = ACTIONS(5660),
    [anon_sym_LBRACE] = ACTIONS(5662),
    [anon_sym_RBRACE] = ACTIONS(5662),
    [anon_sym_LBRACK] = ACTIONS(5662),
    [anon_sym_RBRACK] = ACTIONS(5662),
    [anon_sym_EQ] = ACTIONS(5660),
    [anon_sym_COLON] = ACTIONS(5662),
    [anon_sym_QMARK] = ACTIONS(5662),
    [anon_sym_STAR_EQ] = ACTIONS(5662),
    [anon_sym_SLASH_EQ] = ACTIONS(5662),
    [anon_sym_PERCENT_EQ] = ACTIONS(5662),
    [anon_sym_PLUS_EQ] = ACTIONS(5662),
    [anon_sym_DASH_EQ] = ACTIONS(5662),
    [anon_sym_LT_LT_EQ] = ACTIONS(5662),
    [anon_sym_GT_GT_EQ] = ACTIONS(5662),
    [anon_sym_AMP_EQ] = ACTIONS(5662),
    [anon_sym_CARET_EQ] = ACTIONS(5662),
    [anon_sym_PIPE_EQ] = ACTIONS(5662),
    [anon_sym_and_eq] = ACTIONS(5660),
    [anon_sym_or_eq] = ACTIONS(5660),
    [anon_sym_xor_eq] = ACTIONS(5660),
    [anon_sym_LT_EQ_GT] = ACTIONS(5662),
    [anon_sym_or] = ACTIONS(5660),
    [anon_sym_and] = ACTIONS(5660),
    [anon_sym_bitor] = ACTIONS(5660),
    [anon_sym_xor] = ACTIONS(5660),
    [anon_sym_bitand] = ACTIONS(5660),
    [anon_sym_not_eq] = ACTIONS(5660),
    [anon_sym_DASH_DASH] = ACTIONS(5662),
    [anon_sym_PLUS_PLUS] = ACTIONS(5662),
    [anon_sym_DOT] = ACTIONS(5660),
    [anon_sym_DOT_STAR] = ACTIONS(5662),
    [anon_sym_DASH_GT] = ACTIONS(5662),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5660),
    [anon_sym_decltype] = ACTIONS(5660),
  },
  [2265] = {
    [sym_identifier] = ACTIONS(5664),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5666),
    [anon_sym_COMMA] = ACTIONS(5666),
    [anon_sym_RPAREN] = ACTIONS(5666),
    [aux_sym_preproc_if_token2] = ACTIONS(5666),
    [aux_sym_preproc_else_token1] = ACTIONS(5666),
    [aux_sym_preproc_elif_token1] = ACTIONS(5664),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(5666),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(5666),
    [anon_sym_LPAREN2] = ACTIONS(5666),
    [anon_sym_DASH] = ACTIONS(5664),
    [anon_sym_PLUS] = ACTIONS(5664),
    [anon_sym_STAR] = ACTIONS(5664),
    [anon_sym_SLASH] = ACTIONS(5664),
    [anon_sym_PERCENT] = ACTIONS(5664),
    [anon_sym_PIPE_PIPE] = ACTIONS(5666),
    [anon_sym_AMP_AMP] = ACTIONS(5666),
    [anon_sym_PIPE] = ACTIONS(5664),
    [anon_sym_CARET] = ACTIONS(5664),
    [anon_sym_AMP] = ACTIONS(5664),
    [anon_sym_EQ_EQ] = ACTIONS(5666),
    [anon_sym_BANG_EQ] = ACTIONS(5666),
    [anon_sym_GT] = ACTIONS(5664),
    [anon_sym_GT_EQ] = ACTIONS(5666),
    [anon_sym_LT_EQ] = ACTIONS(5664),
    [anon_sym_LT] = ACTIONS(5664),
    [anon_sym_LT_LT] = ACTIONS(5664),
    [anon_sym_GT_GT] = ACTIONS(5664),
    [anon_sym_SEMI] = ACTIONS(5666),
    [anon_sym___attribute__] = ACTIONS(5664),
    [anon_sym___attribute] = ACTIONS(5664),
    [anon_sym_LBRACE] = ACTIONS(5666),
    [anon_sym_RBRACE] = ACTIONS(5666),
    [anon_sym_LBRACK] = ACTIONS(5666),
    [anon_sym_RBRACK] = ACTIONS(5666),
    [anon_sym_EQ] = ACTIONS(5664),
    [anon_sym_COLON] = ACTIONS(5666),
    [anon_sym_QMARK] = ACTIONS(5666),
    [anon_sym_STAR_EQ] = ACTIONS(5666),
    [anon_sym_SLASH_EQ] = ACTIONS(5666),
    [anon_sym_PERCENT_EQ] = ACTIONS(5666),
    [anon_sym_PLUS_EQ] = ACTIONS(5666),
    [anon_sym_DASH_EQ] = ACTIONS(5666),
    [anon_sym_LT_LT_EQ] = ACTIONS(5666),
    [anon_sym_GT_GT_EQ] = ACTIONS(5666),
    [anon_sym_AMP_EQ] = ACTIONS(5666),
    [anon_sym_CARET_EQ] = ACTIONS(5666),
    [anon_sym_PIPE_EQ] = ACTIONS(5666),
    [anon_sym_and_eq] = ACTIONS(5664),
    [anon_sym_or_eq] = ACTIONS(5664),
    [anon_sym_xor_eq] = ACTIONS(5664),
    [anon_sym_LT_EQ_GT] = ACTIONS(5666),
    [anon_sym_or] = ACTIONS(5664),
    [anon_sym_and] = ACTIONS(5664),
    [anon_sym_bitor] = ACTIONS(5664),
    [anon_sym_xor] = ACTIONS(5664),
    [anon_sym_bitand] = ACTIONS(5664),
    [anon_sym_not_eq] = ACTIONS(5664),
    [anon_sym_DASH_DASH] = ACTIONS(5666),
    [anon_sym_PLUS_PLUS] = ACTIONS(5666),
    [anon_sym_DOT] = ACTIONS(5664),
    [anon_sym_DOT_STAR] = ACTIONS(5666),
    [anon_sym_DASH_GT] = ACTIONS(5666),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5664),
    [anon_sym_decltype] = ACTIONS(5664),
  },
  [2266] = {
    [sym_identifier] = ACTIONS(4814),
    [anon_sym_LPAREN2] = ACTIONS(4816),
    [anon_sym_TILDE] = ACTIONS(4816),
    [anon_sym_STAR] = ACTIONS(4816),
    [anon_sym_PIPE_PIPE] = ACTIONS(4816),
    [anon_sym_AMP_AMP] = ACTIONS(4816),
    [anon_sym_AMP] = ACTIONS(4814),
    [anon_sym___extension__] = ACTIONS(4814),
    [anon_sym_virtual] = ACTIONS(4814),
    [anon_sym_extern] = ACTIONS(4814),
    [anon_sym___attribute__] = ACTIONS(4814),
    [anon_sym___attribute] = ACTIONS(4814),
    [anon_sym_COLON_COLON] = ACTIONS(4816),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4816),
    [anon_sym___declspec] = ACTIONS(4814),
    [anon_sym___based] = ACTIONS(4814),
    [anon_sym___cdecl] = ACTIONS(4814),
    [anon_sym___clrcall] = ACTIONS(4814),
    [anon_sym___stdcall] = ACTIONS(4814),
    [anon_sym___fastcall] = ACTIONS(4814),
    [anon_sym___thiscall] = ACTIONS(4814),
    [anon_sym___vectorcall] = ACTIONS(4814),
    [anon_sym_signed] = ACTIONS(4814),
    [anon_sym_unsigned] = ACTIONS(4814),
    [anon_sym_long] = ACTIONS(4814),
    [anon_sym_short] = ACTIONS(4814),
    [anon_sym_LBRACK] = ACTIONS(4814),
    [anon_sym_static] = ACTIONS(4814),
    [anon_sym_register] = ACTIONS(4814),
    [anon_sym_inline] = ACTIONS(4814),
    [anon_sym___inline] = ACTIONS(4814),
    [anon_sym___inline__] = ACTIONS(4814),
    [anon_sym___forceinline] = ACTIONS(4814),
    [anon_sym_thread_local] = ACTIONS(4814),
    [anon_sym___thread] = ACTIONS(4814),
    [anon_sym_const] = ACTIONS(4814),
    [anon_sym_constexpr] = ACTIONS(4814),
    [anon_sym_volatile] = ACTIONS(4814),
    [anon_sym_restrict] = ACTIONS(4814),
    [anon_sym___restrict__] = ACTIONS(4814),
    [anon_sym__Atomic] = ACTIONS(4814),
    [anon_sym__Noreturn] = ACTIONS(4814),
    [anon_sym_noreturn] = ACTIONS(4814),
    [anon_sym__Nonnull] = ACTIONS(4814),
    [anon_sym_mutable] = ACTIONS(4814),
    [anon_sym_constinit] = ACTIONS(4814),
    [anon_sym_consteval] = ACTIONS(4814),
    [anon_sym_alignas] = ACTIONS(4814),
    [anon_sym__Alignas] = ACTIONS(4814),
    [sym_primitive_type] = ACTIONS(4814),
    [anon_sym_enum] = ACTIONS(4814),
    [anon_sym_class] = ACTIONS(4814),
    [anon_sym_struct] = ACTIONS(4814),
    [anon_sym_union] = ACTIONS(4814),
    [anon_sym_or] = ACTIONS(4814),
    [anon_sym_and] = ACTIONS(4814),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4814),
    [anon_sym_decltype] = ACTIONS(4814),
    [anon_sym_explicit] = ACTIONS(4814),
    [anon_sym_typename] = ACTIONS(4814),
    [anon_sym_template] = ACTIONS(4814),
    [anon_sym_operator] = ACTIONS(4814),
    [anon_sym_friend] = ACTIONS(4814),
    [anon_sym_using] = ACTIONS(4814),
    [anon_sym_concept] = ACTIONS(4814),
  },
  [2267] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5789),
    [anon_sym_COMMA] = ACTIONS(5789),
    [anon_sym_LPAREN2] = ACTIONS(5789),
    [anon_sym_DASH] = ACTIONS(5791),
    [anon_sym_PLUS] = ACTIONS(5791),
    [anon_sym_STAR] = ACTIONS(5789),
    [anon_sym_SLASH] = ACTIONS(5791),
    [anon_sym_PERCENT] = ACTIONS(5789),
    [anon_sym_PIPE_PIPE] = ACTIONS(5789),
    [anon_sym_AMP_AMP] = ACTIONS(5789),
    [anon_sym_PIPE] = ACTIONS(5791),
    [anon_sym_CARET] = ACTIONS(5789),
    [anon_sym_AMP] = ACTIONS(5791),
    [anon_sym_EQ_EQ] = ACTIONS(5789),
    [anon_sym_BANG_EQ] = ACTIONS(5789),
    [anon_sym_GT] = ACTIONS(5791),
    [anon_sym_GT_EQ] = ACTIONS(5791),
    [anon_sym_LT_EQ] = ACTIONS(5791),
    [anon_sym_LT] = ACTIONS(5791),
    [anon_sym_LT_LT] = ACTIONS(5789),
    [anon_sym_GT_GT] = ACTIONS(5791),
    [anon_sym___extension__] = ACTIONS(5789),
    [anon_sym___attribute__] = ACTIONS(5789),
    [anon_sym___attribute] = ACTIONS(5791),
    [anon_sym_LBRACE] = ACTIONS(5789),
    [anon_sym_signed] = ACTIONS(6159),
    [anon_sym_unsigned] = ACTIONS(6159),
    [anon_sym_long] = ACTIONS(6159),
    [anon_sym_short] = ACTIONS(6159),
    [anon_sym_LBRACK] = ACTIONS(5789),
    [anon_sym_const] = ACTIONS(5791),
    [anon_sym_constexpr] = ACTIONS(5789),
    [anon_sym_volatile] = ACTIONS(5789),
    [anon_sym_restrict] = ACTIONS(5789),
    [anon_sym___restrict__] = ACTIONS(5789),
    [anon_sym__Atomic] = ACTIONS(5789),
    [anon_sym__Noreturn] = ACTIONS(5789),
    [anon_sym_noreturn] = ACTIONS(5789),
    [anon_sym__Nonnull] = ACTIONS(5789),
    [anon_sym_mutable] = ACTIONS(5789),
    [anon_sym_constinit] = ACTIONS(5789),
    [anon_sym_consteval] = ACTIONS(5789),
    [anon_sym_alignas] = ACTIONS(5789),
    [anon_sym__Alignas] = ACTIONS(5789),
    [anon_sym_QMARK] = ACTIONS(5789),
    [anon_sym_LT_EQ_GT] = ACTIONS(5789),
    [anon_sym_or] = ACTIONS(5789),
    [anon_sym_and] = ACTIONS(5789),
    [anon_sym_bitor] = ACTIONS(5789),
    [anon_sym_xor] = ACTIONS(5789),
    [anon_sym_bitand] = ACTIONS(5789),
    [anon_sym_not_eq] = ACTIONS(5789),
    [anon_sym_DASH_DASH] = ACTIONS(5789),
    [anon_sym_PLUS_PLUS] = ACTIONS(5789),
    [anon_sym_DOT] = ACTIONS(5791),
    [anon_sym_DOT_STAR] = ACTIONS(5789),
    [anon_sym_DASH_GT] = ACTIONS(5789),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5789),
    [anon_sym_decltype] = ACTIONS(5789),
    [anon_sym_final] = ACTIONS(5789),
    [anon_sym_override] = ACTIONS(5789),
    [anon_sym_GT2] = ACTIONS(5789),
    [anon_sym_requires] = ACTIONS(5789),
  },
  [2268] = {
    [sym_attribute_specifier] = STATE(2228),
    [sym_enumerator_list] = STATE(2147),
    [sym__enum_base_clause] = STATE(1976),
    [sym_identifier] = ACTIONS(6161),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6163),
    [anon_sym_COMMA] = ACTIONS(6163),
    [aux_sym_preproc_if_token2] = ACTIONS(6163),
    [aux_sym_preproc_else_token1] = ACTIONS(6163),
    [aux_sym_preproc_elif_token1] = ACTIONS(6161),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6163),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6163),
    [anon_sym_LPAREN2] = ACTIONS(6163),
    [anon_sym_DASH] = ACTIONS(6161),
    [anon_sym_PLUS] = ACTIONS(6161),
    [anon_sym_STAR] = ACTIONS(6161),
    [anon_sym_SLASH] = ACTIONS(6161),
    [anon_sym_PERCENT] = ACTIONS(6161),
    [anon_sym_PIPE_PIPE] = ACTIONS(6163),
    [anon_sym_AMP_AMP] = ACTIONS(6163),
    [anon_sym_PIPE] = ACTIONS(6161),
    [anon_sym_CARET] = ACTIONS(6161),
    [anon_sym_AMP] = ACTIONS(6161),
    [anon_sym_EQ_EQ] = ACTIONS(6163),
    [anon_sym_BANG_EQ] = ACTIONS(6163),
    [anon_sym_GT] = ACTIONS(6161),
    [anon_sym_GT_EQ] = ACTIONS(6163),
    [anon_sym_LT_EQ] = ACTIONS(6161),
    [anon_sym_LT] = ACTIONS(6161),
    [anon_sym_LT_LT] = ACTIONS(6161),
    [anon_sym_GT_GT] = ACTIONS(6161),
    [anon_sym___attribute__] = ACTIONS(5379),
    [anon_sym___attribute] = ACTIONS(5379),
    [anon_sym_LBRACE] = ACTIONS(5838),
    [anon_sym_LBRACK] = ACTIONS(6163),
    [anon_sym_EQ] = ACTIONS(6161),
    [anon_sym_COLON] = ACTIONS(6165),
    [anon_sym_QMARK] = ACTIONS(6163),
    [anon_sym_STAR_EQ] = ACTIONS(6163),
    [anon_sym_SLASH_EQ] = ACTIONS(6163),
    [anon_sym_PERCENT_EQ] = ACTIONS(6163),
    [anon_sym_PLUS_EQ] = ACTIONS(6163),
    [anon_sym_DASH_EQ] = ACTIONS(6163),
    [anon_sym_LT_LT_EQ] = ACTIONS(6163),
    [anon_sym_GT_GT_EQ] = ACTIONS(6163),
    [anon_sym_AMP_EQ] = ACTIONS(6163),
    [anon_sym_CARET_EQ] = ACTIONS(6163),
    [anon_sym_PIPE_EQ] = ACTIONS(6163),
    [anon_sym_and_eq] = ACTIONS(6161),
    [anon_sym_or_eq] = ACTIONS(6161),
    [anon_sym_xor_eq] = ACTIONS(6161),
    [anon_sym_LT_EQ_GT] = ACTIONS(6163),
    [anon_sym_or] = ACTIONS(6161),
    [anon_sym_and] = ACTIONS(6161),
    [anon_sym_bitor] = ACTIONS(6161),
    [anon_sym_xor] = ACTIONS(6161),
    [anon_sym_bitand] = ACTIONS(6161),
    [anon_sym_not_eq] = ACTIONS(6161),
    [anon_sym_DASH_DASH] = ACTIONS(6163),
    [anon_sym_PLUS_PLUS] = ACTIONS(6163),
    [anon_sym_DOT] = ACTIONS(6161),
    [anon_sym_DOT_STAR] = ACTIONS(6163),
    [anon_sym_DASH_GT] = ACTIONS(6163),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6161),
    [anon_sym_decltype] = ACTIONS(6161),
  },
  [2269] = {
    [sym_type_qualifier] = STATE(2308),
    [sym_alignas_qualifier] = STATE(1619),
    [aux_sym__type_definition_type_repeat1] = STATE(2308),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2526),
    [sym_identifier] = ACTIONS(6167),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4946),
    [anon_sym_COMMA] = ACTIONS(4946),
    [anon_sym_RPAREN] = ACTIONS(4946),
    [anon_sym_LPAREN2] = ACTIONS(4946),
    [anon_sym_TILDE] = ACTIONS(4946),
    [anon_sym_STAR] = ACTIONS(4946),
    [anon_sym_AMP_AMP] = ACTIONS(4946),
    [anon_sym_AMP] = ACTIONS(4948),
    [anon_sym_SEMI] = ACTIONS(4946),
    [anon_sym___extension__] = ACTIONS(6170),
    [anon_sym_virtual] = ACTIONS(4948),
    [anon_sym_extern] = ACTIONS(4948),
    [anon_sym___attribute__] = ACTIONS(4948),
    [anon_sym___attribute] = ACTIONS(4948),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4946),
    [anon_sym___declspec] = ACTIONS(4948),
    [anon_sym___based] = ACTIONS(4948),
    [anon_sym___cdecl] = ACTIONS(4948),
    [anon_sym___clrcall] = ACTIONS(4948),
    [anon_sym___stdcall] = ACTIONS(4948),
    [anon_sym___fastcall] = ACTIONS(4948),
    [anon_sym___thiscall] = ACTIONS(4948),
    [anon_sym___vectorcall] = ACTIONS(4948),
    [anon_sym_LBRACE] = ACTIONS(4946),
    [anon_sym_signed] = ACTIONS(6173),
    [anon_sym_unsigned] = ACTIONS(6173),
    [anon_sym_long] = ACTIONS(6173),
    [anon_sym_short] = ACTIONS(6173),
    [anon_sym_LBRACK] = ACTIONS(4948),
    [anon_sym_static] = ACTIONS(4948),
    [anon_sym_EQ] = ACTIONS(4946),
    [anon_sym_register] = ACTIONS(4948),
    [anon_sym_inline] = ACTIONS(4948),
    [anon_sym___inline] = ACTIONS(4948),
    [anon_sym___inline__] = ACTIONS(4948),
    [anon_sym___forceinline] = ACTIONS(4948),
    [anon_sym_thread_local] = ACTIONS(4948),
    [anon_sym___thread] = ACTIONS(4948),
    [anon_sym_const] = ACTIONS(6170),
    [anon_sym_constexpr] = ACTIONS(6170),
    [anon_sym_volatile] = ACTIONS(6170),
    [anon_sym_restrict] = ACTIONS(6170),
    [anon_sym___restrict__] = ACTIONS(6170),
    [anon_sym__Atomic] = ACTIONS(6170),
    [anon_sym__Noreturn] = ACTIONS(6170),
    [anon_sym_noreturn] = ACTIONS(6170),
    [anon_sym__Nonnull] = ACTIONS(6170),
    [anon_sym_mutable] = ACTIONS(6170),
    [anon_sym_constinit] = ACTIONS(6170),
    [anon_sym_consteval] = ACTIONS(6170),
    [anon_sym_alignas] = ACTIONS(6175),
    [anon_sym__Alignas] = ACTIONS(6175),
    [sym_primitive_type] = ACTIONS(6178),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4948),
    [anon_sym_decltype] = ACTIONS(4948),
    [anon_sym_template] = ACTIONS(4948),
    [anon_sym_GT2] = ACTIONS(4946),
    [anon_sym_operator] = ACTIONS(4948),
  },
  [2270] = {
    [sym_identifier] = ACTIONS(5387),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5389),
    [anon_sym_COMMA] = ACTIONS(5389),
    [anon_sym_LPAREN2] = ACTIONS(5389),
    [anon_sym_DASH] = ACTIONS(5387),
    [anon_sym_PLUS] = ACTIONS(5387),
    [anon_sym_STAR] = ACTIONS(5387),
    [anon_sym_SLASH] = ACTIONS(5387),
    [anon_sym_PERCENT] = ACTIONS(5387),
    [anon_sym_PIPE_PIPE] = ACTIONS(5389),
    [anon_sym_AMP_AMP] = ACTIONS(5389),
    [anon_sym_PIPE] = ACTIONS(5387),
    [anon_sym_CARET] = ACTIONS(5387),
    [anon_sym_AMP] = ACTIONS(5387),
    [anon_sym_EQ_EQ] = ACTIONS(5389),
    [anon_sym_BANG_EQ] = ACTIONS(5389),
    [anon_sym_GT] = ACTIONS(5387),
    [anon_sym_GT_EQ] = ACTIONS(5389),
    [anon_sym_LT_EQ] = ACTIONS(5387),
    [anon_sym_LT] = ACTIONS(5387),
    [anon_sym_LT_LT] = ACTIONS(5387),
    [anon_sym_GT_GT] = ACTIONS(5387),
    [anon_sym_SEMI] = ACTIONS(5389),
    [anon_sym___attribute__] = ACTIONS(5387),
    [anon_sym___attribute] = ACTIONS(5387),
    [anon_sym_LBRACK] = ACTIONS(5389),
    [anon_sym_EQ] = ACTIONS(5387),
    [anon_sym_QMARK] = ACTIONS(5389),
    [anon_sym_STAR_EQ] = ACTIONS(5389),
    [anon_sym_SLASH_EQ] = ACTIONS(5389),
    [anon_sym_PERCENT_EQ] = ACTIONS(5389),
    [anon_sym_PLUS_EQ] = ACTIONS(5389),
    [anon_sym_DASH_EQ] = ACTIONS(5389),
    [anon_sym_LT_LT_EQ] = ACTIONS(5389),
    [anon_sym_GT_GT_EQ] = ACTIONS(5389),
    [anon_sym_AMP_EQ] = ACTIONS(5389),
    [anon_sym_CARET_EQ] = ACTIONS(5389),
    [anon_sym_PIPE_EQ] = ACTIONS(5389),
    [anon_sym_and_eq] = ACTIONS(5387),
    [anon_sym_or_eq] = ACTIONS(5387),
    [anon_sym_xor_eq] = ACTIONS(5387),
    [anon_sym_LT_EQ_GT] = ACTIONS(5389),
    [anon_sym_or] = ACTIONS(5387),
    [anon_sym_and] = ACTIONS(5387),
    [anon_sym_bitor] = ACTIONS(5387),
    [anon_sym_xor] = ACTIONS(5387),
    [anon_sym_bitand] = ACTIONS(5387),
    [anon_sym_not_eq] = ACTIONS(5387),
    [anon_sym_DASH_DASH] = ACTIONS(5389),
    [anon_sym_PLUS_PLUS] = ACTIONS(5389),
    [anon_sym_DOT] = ACTIONS(5387),
    [anon_sym_DOT_STAR] = ACTIONS(5389),
    [anon_sym_DASH_GT] = ACTIONS(5389),
    [anon_sym_L_DQUOTE] = ACTIONS(5389),
    [anon_sym_u_DQUOTE] = ACTIONS(5389),
    [anon_sym_U_DQUOTE] = ACTIONS(5389),
    [anon_sym_u8_DQUOTE] = ACTIONS(5389),
    [anon_sym_DQUOTE] = ACTIONS(5389),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5389),
    [anon_sym_LR_DQUOTE] = ACTIONS(5389),
    [anon_sym_uR_DQUOTE] = ACTIONS(5389),
    [anon_sym_UR_DQUOTE] = ACTIONS(5389),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5389),
    [sym_literal_suffix] = ACTIONS(5387),
  },
  [2271] = {
    [sym_identifier] = ACTIONS(5447),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5449),
    [anon_sym_COMMA] = ACTIONS(5449),
    [anon_sym_LPAREN2] = ACTIONS(5449),
    [anon_sym_DASH] = ACTIONS(5447),
    [anon_sym_PLUS] = ACTIONS(5447),
    [anon_sym_STAR] = ACTIONS(5447),
    [anon_sym_SLASH] = ACTIONS(5447),
    [anon_sym_PERCENT] = ACTIONS(5447),
    [anon_sym_PIPE_PIPE] = ACTIONS(5449),
    [anon_sym_AMP_AMP] = ACTIONS(5449),
    [anon_sym_PIPE] = ACTIONS(5447),
    [anon_sym_CARET] = ACTIONS(5447),
    [anon_sym_AMP] = ACTIONS(5447),
    [anon_sym_EQ_EQ] = ACTIONS(5449),
    [anon_sym_BANG_EQ] = ACTIONS(5449),
    [anon_sym_GT] = ACTIONS(5447),
    [anon_sym_GT_EQ] = ACTIONS(5449),
    [anon_sym_LT_EQ] = ACTIONS(5447),
    [anon_sym_LT] = ACTIONS(5447),
    [anon_sym_LT_LT] = ACTIONS(5447),
    [anon_sym_GT_GT] = ACTIONS(5447),
    [anon_sym_SEMI] = ACTIONS(5449),
    [anon_sym___attribute__] = ACTIONS(5447),
    [anon_sym___attribute] = ACTIONS(5447),
    [anon_sym_LBRACK] = ACTIONS(5449),
    [anon_sym_EQ] = ACTIONS(5447),
    [anon_sym_QMARK] = ACTIONS(5449),
    [anon_sym_STAR_EQ] = ACTIONS(5449),
    [anon_sym_SLASH_EQ] = ACTIONS(5449),
    [anon_sym_PERCENT_EQ] = ACTIONS(5449),
    [anon_sym_PLUS_EQ] = ACTIONS(5449),
    [anon_sym_DASH_EQ] = ACTIONS(5449),
    [anon_sym_LT_LT_EQ] = ACTIONS(5449),
    [anon_sym_GT_GT_EQ] = ACTIONS(5449),
    [anon_sym_AMP_EQ] = ACTIONS(5449),
    [anon_sym_CARET_EQ] = ACTIONS(5449),
    [anon_sym_PIPE_EQ] = ACTIONS(5449),
    [anon_sym_and_eq] = ACTIONS(5447),
    [anon_sym_or_eq] = ACTIONS(5447),
    [anon_sym_xor_eq] = ACTIONS(5447),
    [anon_sym_LT_EQ_GT] = ACTIONS(5449),
    [anon_sym_or] = ACTIONS(5447),
    [anon_sym_and] = ACTIONS(5447),
    [anon_sym_bitor] = ACTIONS(5447),
    [anon_sym_xor] = ACTIONS(5447),
    [anon_sym_bitand] = ACTIONS(5447),
    [anon_sym_not_eq] = ACTIONS(5447),
    [anon_sym_DASH_DASH] = ACTIONS(5449),
    [anon_sym_PLUS_PLUS] = ACTIONS(5449),
    [anon_sym_DOT] = ACTIONS(5447),
    [anon_sym_DOT_STAR] = ACTIONS(5449),
    [anon_sym_DASH_GT] = ACTIONS(5449),
    [anon_sym_L_DQUOTE] = ACTIONS(5449),
    [anon_sym_u_DQUOTE] = ACTIONS(5449),
    [anon_sym_U_DQUOTE] = ACTIONS(5449),
    [anon_sym_u8_DQUOTE] = ACTIONS(5449),
    [anon_sym_DQUOTE] = ACTIONS(5449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5449),
    [anon_sym_LR_DQUOTE] = ACTIONS(5449),
    [anon_sym_uR_DQUOTE] = ACTIONS(5449),
    [anon_sym_UR_DQUOTE] = ACTIONS(5449),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5449),
    [sym_literal_suffix] = ACTIONS(5447),
  },
  [2272] = {
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_unaligned_ptr_modifier] = STATE(3998),
    [sym_ms_pointer_modifier] = STATE(2286),
    [sym__declarator] = STATE(6341),
    [sym__abstract_declarator] = STATE(6609),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_abstract_parenthesized_declarator] = STATE(5942),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_abstract_pointer_declarator] = STATE(5942),
    [sym_function_declarator] = STATE(5896),
    [sym_abstract_function_declarator] = STATE(5942),
    [sym_array_declarator] = STATE(5896),
    [sym_abstract_array_declarator] = STATE(5942),
    [sym_type_qualifier] = STATE(2827),
    [sym_alignas_qualifier] = STATE(4266),
    [sym_parameter_list] = STATE(3055),
    [sym_decltype] = STATE(8512),
    [sym_reference_declarator] = STATE(5896),
    [sym_abstract_reference_declarator] = STATE(5942),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym__function_declarator_seq] = STATE(5919),
    [sym_template_type] = STATE(8512),
    [sym_template_function] = STATE(5896),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(5896),
    [sym_operator_name] = STATE(5896),
    [aux_sym__type_definition_type_repeat1] = STATE(2827),
    [aux_sym_pointer_declarator_repeat1] = STATE(2286),
    [sym_identifier] = ACTIONS(5327),
    [anon_sym_RPAREN] = ACTIONS(5730),
    [anon_sym_LPAREN2] = ACTIONS(4157),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(4159),
    [anon_sym_AMP_AMP] = ACTIONS(4161),
    [anon_sym_AMP] = ACTIONS(4163),
    [anon_sym___extension__] = ACTIONS(3270),
    [anon_sym_COLON_COLON] = ACTIONS(6180),
    [anon_sym___based] = ACTIONS(51),
    [sym_ms_restrict_modifier] = ACTIONS(3266),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(3266),
    [sym_ms_signed_ptr_modifier] = ACTIONS(3266),
    [anon_sym__unaligned] = ACTIONS(3268),
    [anon_sym___unaligned] = ACTIONS(3268),
    [anon_sym_LBRACK] = ACTIONS(5710),
    [anon_sym_const] = ACTIONS(3270),
    [anon_sym_constexpr] = ACTIONS(3270),
    [anon_sym_volatile] = ACTIONS(3270),
    [anon_sym_restrict] = ACTIONS(3270),
    [anon_sym___restrict__] = ACTIONS(3270),
    [anon_sym__Atomic] = ACTIONS(3270),
    [anon_sym__Noreturn] = ACTIONS(3270),
    [anon_sym_noreturn] = ACTIONS(3270),
    [anon_sym__Nonnull] = ACTIONS(3270),
    [anon_sym_mutable] = ACTIONS(3270),
    [anon_sym_constinit] = ACTIONS(3270),
    [anon_sym_consteval] = ACTIONS(3270),
    [anon_sym_alignas] = ACTIONS(3272),
    [anon_sym__Alignas] = ACTIONS(3272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_operator] = ACTIONS(1823),
  },
  [2273] = {
    [sym_attribute_specifier] = STATE(1844),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5953),
    [anon_sym_COMMA] = ACTIONS(5953),
    [anon_sym_RPAREN] = ACTIONS(5953),
    [anon_sym_LPAREN2] = ACTIONS(5953),
    [anon_sym_DASH] = ACTIONS(5951),
    [anon_sym_PLUS] = ACTIONS(5951),
    [anon_sym_STAR] = ACTIONS(5953),
    [anon_sym_SLASH] = ACTIONS(5951),
    [anon_sym_PERCENT] = ACTIONS(5953),
    [anon_sym_PIPE_PIPE] = ACTIONS(5953),
    [anon_sym_AMP_AMP] = ACTIONS(5953),
    [anon_sym_PIPE] = ACTIONS(5951),
    [anon_sym_CARET] = ACTIONS(5953),
    [anon_sym_AMP] = ACTIONS(5951),
    [anon_sym_EQ_EQ] = ACTIONS(5953),
    [anon_sym_BANG_EQ] = ACTIONS(5953),
    [anon_sym_GT] = ACTIONS(5951),
    [anon_sym_GT_EQ] = ACTIONS(5953),
    [anon_sym_LT_EQ] = ACTIONS(5951),
    [anon_sym_LT] = ACTIONS(5951),
    [anon_sym_LT_LT] = ACTIONS(5953),
    [anon_sym_GT_GT] = ACTIONS(5953),
    [anon_sym_SEMI] = ACTIONS(5953),
    [anon_sym___extension__] = ACTIONS(5953),
    [anon_sym___attribute__] = ACTIONS(5874),
    [anon_sym___attribute] = ACTIONS(5876),
    [anon_sym_LBRACE] = ACTIONS(5953),
    [anon_sym_RBRACE] = ACTIONS(5953),
    [anon_sym_LBRACK] = ACTIONS(5953),
    [anon_sym_RBRACK] = ACTIONS(5953),
    [anon_sym_const] = ACTIONS(5951),
    [anon_sym_constexpr] = ACTIONS(5953),
    [anon_sym_volatile] = ACTIONS(5953),
    [anon_sym_restrict] = ACTIONS(5953),
    [anon_sym___restrict__] = ACTIONS(5953),
    [anon_sym__Atomic] = ACTIONS(5953),
    [anon_sym__Noreturn] = ACTIONS(5953),
    [anon_sym_noreturn] = ACTIONS(5953),
    [anon_sym__Nonnull] = ACTIONS(5953),
    [anon_sym_mutable] = ACTIONS(5953),
    [anon_sym_constinit] = ACTIONS(5953),
    [anon_sym_consteval] = ACTIONS(5953),
    [anon_sym_alignas] = ACTIONS(5953),
    [anon_sym__Alignas] = ACTIONS(5953),
    [anon_sym_COLON] = ACTIONS(5953),
    [anon_sym_QMARK] = ACTIONS(5953),
    [anon_sym_LT_EQ_GT] = ACTIONS(5953),
    [anon_sym_or] = ACTIONS(5953),
    [anon_sym_and] = ACTIONS(5953),
    [anon_sym_bitor] = ACTIONS(5953),
    [anon_sym_xor] = ACTIONS(5953),
    [anon_sym_bitand] = ACTIONS(5953),
    [anon_sym_not_eq] = ACTIONS(5953),
    [anon_sym_DASH_DASH] = ACTIONS(5953),
    [anon_sym_PLUS_PLUS] = ACTIONS(5953),
    [anon_sym_DOT] = ACTIONS(5951),
    [anon_sym_DOT_STAR] = ACTIONS(5953),
    [anon_sym_DASH_GT] = ACTIONS(5953),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5953),
    [anon_sym_decltype] = ACTIONS(5953),
    [anon_sym_final] = ACTIONS(5953),
    [anon_sym_override] = ACTIONS(5953),
    [anon_sym_requires] = ACTIONS(5953),
  },
  [2274] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1544),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5793),
    [anon_sym_COMMA] = ACTIONS(5793),
    [anon_sym_RPAREN] = ACTIONS(5793),
    [anon_sym_LPAREN2] = ACTIONS(5793),
    [anon_sym_DASH] = ACTIONS(5795),
    [anon_sym_PLUS] = ACTIONS(5795),
    [anon_sym_STAR] = ACTIONS(5795),
    [anon_sym_SLASH] = ACTIONS(5795),
    [anon_sym_PERCENT] = ACTIONS(5795),
    [anon_sym_PIPE_PIPE] = ACTIONS(5793),
    [anon_sym_AMP_AMP] = ACTIONS(5793),
    [anon_sym_PIPE] = ACTIONS(5795),
    [anon_sym_CARET] = ACTIONS(5795),
    [anon_sym_AMP] = ACTIONS(5795),
    [anon_sym_EQ_EQ] = ACTIONS(5793),
    [anon_sym_BANG_EQ] = ACTIONS(5793),
    [anon_sym_GT] = ACTIONS(5795),
    [anon_sym_GT_EQ] = ACTIONS(5793),
    [anon_sym_LT_EQ] = ACTIONS(5795),
    [anon_sym_LT] = ACTIONS(5795),
    [anon_sym_LT_LT] = ACTIONS(5795),
    [anon_sym_GT_GT] = ACTIONS(5795),
    [anon_sym_SEMI] = ACTIONS(5793),
    [anon_sym___attribute__] = ACTIONS(5793),
    [anon_sym___attribute] = ACTIONS(5795),
    [anon_sym_LBRACE] = ACTIONS(5793),
    [anon_sym_RBRACE] = ACTIONS(5793),
    [anon_sym_signed] = ACTIONS(6182),
    [anon_sym_unsigned] = ACTIONS(6182),
    [anon_sym_long] = ACTIONS(6182),
    [anon_sym_short] = ACTIONS(6182),
    [anon_sym_LBRACK] = ACTIONS(5793),
    [anon_sym_RBRACK] = ACTIONS(5793),
    [anon_sym_EQ] = ACTIONS(5795),
    [anon_sym_COLON] = ACTIONS(5793),
    [anon_sym_QMARK] = ACTIONS(5793),
    [anon_sym_STAR_EQ] = ACTIONS(5793),
    [anon_sym_SLASH_EQ] = ACTIONS(5793),
    [anon_sym_PERCENT_EQ] = ACTIONS(5793),
    [anon_sym_PLUS_EQ] = ACTIONS(5793),
    [anon_sym_DASH_EQ] = ACTIONS(5793),
    [anon_sym_LT_LT_EQ] = ACTIONS(5793),
    [anon_sym_GT_GT_EQ] = ACTIONS(5793),
    [anon_sym_AMP_EQ] = ACTIONS(5793),
    [anon_sym_CARET_EQ] = ACTIONS(5793),
    [anon_sym_PIPE_EQ] = ACTIONS(5793),
    [anon_sym_and_eq] = ACTIONS(5793),
    [anon_sym_or_eq] = ACTIONS(5793),
    [anon_sym_xor_eq] = ACTIONS(5793),
    [anon_sym_LT_EQ_GT] = ACTIONS(5793),
    [anon_sym_or] = ACTIONS(5795),
    [anon_sym_and] = ACTIONS(5795),
    [anon_sym_bitor] = ACTIONS(5793),
    [anon_sym_xor] = ACTIONS(5795),
    [anon_sym_bitand] = ACTIONS(5793),
    [anon_sym_not_eq] = ACTIONS(5793),
    [anon_sym_DASH_DASH] = ACTIONS(5793),
    [anon_sym_PLUS_PLUS] = ACTIONS(5793),
    [anon_sym_DOT] = ACTIONS(5795),
    [anon_sym_DOT_STAR] = ACTIONS(5793),
    [anon_sym_DASH_GT] = ACTIONS(5793),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5793),
    [anon_sym_decltype] = ACTIONS(5793),
  },
  [2275] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1544),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5780),
    [anon_sym_COMMA] = ACTIONS(5780),
    [anon_sym_RPAREN] = ACTIONS(5780),
    [anon_sym_LPAREN2] = ACTIONS(5780),
    [anon_sym_DASH] = ACTIONS(5782),
    [anon_sym_PLUS] = ACTIONS(5782),
    [anon_sym_STAR] = ACTIONS(5782),
    [anon_sym_SLASH] = ACTIONS(5782),
    [anon_sym_PERCENT] = ACTIONS(5782),
    [anon_sym_PIPE_PIPE] = ACTIONS(5780),
    [anon_sym_AMP_AMP] = ACTIONS(5780),
    [anon_sym_PIPE] = ACTIONS(5782),
    [anon_sym_CARET] = ACTIONS(5782),
    [anon_sym_AMP] = ACTIONS(5782),
    [anon_sym_EQ_EQ] = ACTIONS(5780),
    [anon_sym_BANG_EQ] = ACTIONS(5780),
    [anon_sym_GT] = ACTIONS(5782),
    [anon_sym_GT_EQ] = ACTIONS(5780),
    [anon_sym_LT_EQ] = ACTIONS(5782),
    [anon_sym_LT] = ACTIONS(5782),
    [anon_sym_LT_LT] = ACTIONS(5782),
    [anon_sym_GT_GT] = ACTIONS(5782),
    [anon_sym_SEMI] = ACTIONS(5780),
    [anon_sym___attribute__] = ACTIONS(5780),
    [anon_sym___attribute] = ACTIONS(5782),
    [anon_sym_LBRACE] = ACTIONS(5780),
    [anon_sym_RBRACE] = ACTIONS(5780),
    [anon_sym_signed] = ACTIONS(6182),
    [anon_sym_unsigned] = ACTIONS(6182),
    [anon_sym_long] = ACTIONS(6182),
    [anon_sym_short] = ACTIONS(6182),
    [anon_sym_LBRACK] = ACTIONS(5780),
    [anon_sym_RBRACK] = ACTIONS(5780),
    [anon_sym_EQ] = ACTIONS(5782),
    [anon_sym_COLON] = ACTIONS(5780),
    [anon_sym_QMARK] = ACTIONS(5780),
    [anon_sym_STAR_EQ] = ACTIONS(5780),
    [anon_sym_SLASH_EQ] = ACTIONS(5780),
    [anon_sym_PERCENT_EQ] = ACTIONS(5780),
    [anon_sym_PLUS_EQ] = ACTIONS(5780),
    [anon_sym_DASH_EQ] = ACTIONS(5780),
    [anon_sym_LT_LT_EQ] = ACTIONS(5780),
    [anon_sym_GT_GT_EQ] = ACTIONS(5780),
    [anon_sym_AMP_EQ] = ACTIONS(5780),
    [anon_sym_CARET_EQ] = ACTIONS(5780),
    [anon_sym_PIPE_EQ] = ACTIONS(5780),
    [anon_sym_and_eq] = ACTIONS(5780),
    [anon_sym_or_eq] = ACTIONS(5780),
    [anon_sym_xor_eq] = ACTIONS(5780),
    [anon_sym_LT_EQ_GT] = ACTIONS(5780),
    [anon_sym_or] = ACTIONS(5782),
    [anon_sym_and] = ACTIONS(5782),
    [anon_sym_bitor] = ACTIONS(5780),
    [anon_sym_xor] = ACTIONS(5782),
    [anon_sym_bitand] = ACTIONS(5780),
    [anon_sym_not_eq] = ACTIONS(5780),
    [anon_sym_DASH_DASH] = ACTIONS(5780),
    [anon_sym_PLUS_PLUS] = ACTIONS(5780),
    [anon_sym_DOT] = ACTIONS(5782),
    [anon_sym_DOT_STAR] = ACTIONS(5780),
    [anon_sym_DASH_GT] = ACTIONS(5780),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5780),
    [anon_sym_decltype] = ACTIONS(5780),
  },
  [2276] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2291),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5738),
    [anon_sym_COMMA] = ACTIONS(5738),
    [anon_sym_RPAREN] = ACTIONS(5738),
    [anon_sym_LPAREN2] = ACTIONS(5738),
    [anon_sym_DASH] = ACTIONS(5740),
    [anon_sym_PLUS] = ACTIONS(5740),
    [anon_sym_STAR] = ACTIONS(5740),
    [anon_sym_SLASH] = ACTIONS(5740),
    [anon_sym_PERCENT] = ACTIONS(5740),
    [anon_sym_PIPE_PIPE] = ACTIONS(5738),
    [anon_sym_AMP_AMP] = ACTIONS(5738),
    [anon_sym_PIPE] = ACTIONS(5740),
    [anon_sym_CARET] = ACTIONS(5740),
    [anon_sym_AMP] = ACTIONS(5740),
    [anon_sym_EQ_EQ] = ACTIONS(5738),
    [anon_sym_BANG_EQ] = ACTIONS(5738),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5738),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_LT_LT] = ACTIONS(5740),
    [anon_sym_GT_GT] = ACTIONS(5740),
    [anon_sym_SEMI] = ACTIONS(5738),
    [anon_sym___attribute__] = ACTIONS(5738),
    [anon_sym___attribute] = ACTIONS(5740),
    [anon_sym_LBRACE] = ACTIONS(5738),
    [anon_sym_RBRACE] = ACTIONS(5738),
    [anon_sym_signed] = ACTIONS(6184),
    [anon_sym_unsigned] = ACTIONS(6184),
    [anon_sym_long] = ACTIONS(6184),
    [anon_sym_short] = ACTIONS(6184),
    [anon_sym_LBRACK] = ACTIONS(5738),
    [anon_sym_RBRACK] = ACTIONS(5738),
    [anon_sym_EQ] = ACTIONS(5740),
    [anon_sym_COLON] = ACTIONS(5738),
    [anon_sym_QMARK] = ACTIONS(5738),
    [anon_sym_STAR_EQ] = ACTIONS(5738),
    [anon_sym_SLASH_EQ] = ACTIONS(5738),
    [anon_sym_PERCENT_EQ] = ACTIONS(5738),
    [anon_sym_PLUS_EQ] = ACTIONS(5738),
    [anon_sym_DASH_EQ] = ACTIONS(5738),
    [anon_sym_LT_LT_EQ] = ACTIONS(5738),
    [anon_sym_GT_GT_EQ] = ACTIONS(5738),
    [anon_sym_AMP_EQ] = ACTIONS(5738),
    [anon_sym_CARET_EQ] = ACTIONS(5738),
    [anon_sym_PIPE_EQ] = ACTIONS(5738),
    [anon_sym_and_eq] = ACTIONS(5738),
    [anon_sym_or_eq] = ACTIONS(5738),
    [anon_sym_xor_eq] = ACTIONS(5738),
    [anon_sym_LT_EQ_GT] = ACTIONS(5738),
    [anon_sym_or] = ACTIONS(5740),
    [anon_sym_and] = ACTIONS(5740),
    [anon_sym_bitor] = ACTIONS(5738),
    [anon_sym_xor] = ACTIONS(5740),
    [anon_sym_bitand] = ACTIONS(5738),
    [anon_sym_not_eq] = ACTIONS(5738),
    [anon_sym_DASH_DASH] = ACTIONS(5738),
    [anon_sym_PLUS_PLUS] = ACTIONS(5738),
    [anon_sym_DOT] = ACTIONS(5740),
    [anon_sym_DOT_STAR] = ACTIONS(5738),
    [anon_sym_DASH_GT] = ACTIONS(5738),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5738),
    [anon_sym_decltype] = ACTIONS(5738),
  },
  [2277] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5760),
    [anon_sym_COMMA] = ACTIONS(5760),
    [anon_sym_RPAREN] = ACTIONS(5760),
    [anon_sym_LPAREN2] = ACTIONS(5760),
    [anon_sym_DASH] = ACTIONS(5762),
    [anon_sym_PLUS] = ACTIONS(5762),
    [anon_sym_STAR] = ACTIONS(5762),
    [anon_sym_SLASH] = ACTIONS(5762),
    [anon_sym_PERCENT] = ACTIONS(5762),
    [anon_sym_PIPE_PIPE] = ACTIONS(5760),
    [anon_sym_AMP_AMP] = ACTIONS(5760),
    [anon_sym_PIPE] = ACTIONS(5762),
    [anon_sym_CARET] = ACTIONS(5762),
    [anon_sym_AMP] = ACTIONS(5762),
    [anon_sym_EQ_EQ] = ACTIONS(5760),
    [anon_sym_BANG_EQ] = ACTIONS(5760),
    [anon_sym_GT] = ACTIONS(5762),
    [anon_sym_GT_EQ] = ACTIONS(5760),
    [anon_sym_LT_EQ] = ACTIONS(5762),
    [anon_sym_LT] = ACTIONS(5762),
    [anon_sym_LT_LT] = ACTIONS(5762),
    [anon_sym_GT_GT] = ACTIONS(5762),
    [anon_sym_SEMI] = ACTIONS(5760),
    [anon_sym___attribute__] = ACTIONS(5760),
    [anon_sym___attribute] = ACTIONS(5762),
    [anon_sym_LBRACE] = ACTIONS(5760),
    [anon_sym_RBRACE] = ACTIONS(5760),
    [anon_sym_signed] = ACTIONS(6186),
    [anon_sym_unsigned] = ACTIONS(6186),
    [anon_sym_long] = ACTIONS(6186),
    [anon_sym_short] = ACTIONS(6186),
    [anon_sym_LBRACK] = ACTIONS(5760),
    [anon_sym_RBRACK] = ACTIONS(5760),
    [anon_sym_EQ] = ACTIONS(5762),
    [anon_sym_COLON] = ACTIONS(5760),
    [anon_sym_QMARK] = ACTIONS(5760),
    [anon_sym_STAR_EQ] = ACTIONS(5760),
    [anon_sym_SLASH_EQ] = ACTIONS(5760),
    [anon_sym_PERCENT_EQ] = ACTIONS(5760),
    [anon_sym_PLUS_EQ] = ACTIONS(5760),
    [anon_sym_DASH_EQ] = ACTIONS(5760),
    [anon_sym_LT_LT_EQ] = ACTIONS(5760),
    [anon_sym_GT_GT_EQ] = ACTIONS(5760),
    [anon_sym_AMP_EQ] = ACTIONS(5760),
    [anon_sym_CARET_EQ] = ACTIONS(5760),
    [anon_sym_PIPE_EQ] = ACTIONS(5760),
    [anon_sym_and_eq] = ACTIONS(5760),
    [anon_sym_or_eq] = ACTIONS(5760),
    [anon_sym_xor_eq] = ACTIONS(5760),
    [anon_sym_LT_EQ_GT] = ACTIONS(5760),
    [anon_sym_or] = ACTIONS(5762),
    [anon_sym_and] = ACTIONS(5762),
    [anon_sym_bitor] = ACTIONS(5760),
    [anon_sym_xor] = ACTIONS(5762),
    [anon_sym_bitand] = ACTIONS(5760),
    [anon_sym_not_eq] = ACTIONS(5760),
    [anon_sym_DASH_DASH] = ACTIONS(5760),
    [anon_sym_PLUS_PLUS] = ACTIONS(5760),
    [anon_sym_DOT] = ACTIONS(5762),
    [anon_sym_DOT_STAR] = ACTIONS(5760),
    [anon_sym_DASH_GT] = ACTIONS(5760),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5760),
    [anon_sym_decltype] = ACTIONS(5760),
  },
  [2278] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1544),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5776),
    [anon_sym_COMMA] = ACTIONS(5776),
    [anon_sym_RPAREN] = ACTIONS(5776),
    [anon_sym_LPAREN2] = ACTIONS(5776),
    [anon_sym_DASH] = ACTIONS(5778),
    [anon_sym_PLUS] = ACTIONS(5778),
    [anon_sym_STAR] = ACTIONS(5778),
    [anon_sym_SLASH] = ACTIONS(5778),
    [anon_sym_PERCENT] = ACTIONS(5778),
    [anon_sym_PIPE_PIPE] = ACTIONS(5776),
    [anon_sym_AMP_AMP] = ACTIONS(5776),
    [anon_sym_PIPE] = ACTIONS(5778),
    [anon_sym_CARET] = ACTIONS(5778),
    [anon_sym_AMP] = ACTIONS(5778),
    [anon_sym_EQ_EQ] = ACTIONS(5776),
    [anon_sym_BANG_EQ] = ACTIONS(5776),
    [anon_sym_GT] = ACTIONS(5778),
    [anon_sym_GT_EQ] = ACTIONS(5776),
    [anon_sym_LT_EQ] = ACTIONS(5778),
    [anon_sym_LT] = ACTIONS(5778),
    [anon_sym_LT_LT] = ACTIONS(5778),
    [anon_sym_GT_GT] = ACTIONS(5778),
    [anon_sym_SEMI] = ACTIONS(5776),
    [anon_sym___attribute__] = ACTIONS(5776),
    [anon_sym___attribute] = ACTIONS(5778),
    [anon_sym_LBRACE] = ACTIONS(5776),
    [anon_sym_RBRACE] = ACTIONS(5776),
    [anon_sym_signed] = ACTIONS(6182),
    [anon_sym_unsigned] = ACTIONS(6182),
    [anon_sym_long] = ACTIONS(6182),
    [anon_sym_short] = ACTIONS(6182),
    [anon_sym_LBRACK] = ACTIONS(5776),
    [anon_sym_RBRACK] = ACTIONS(5776),
    [anon_sym_EQ] = ACTIONS(5778),
    [anon_sym_COLON] = ACTIONS(5776),
    [anon_sym_QMARK] = ACTIONS(5776),
    [anon_sym_STAR_EQ] = ACTIONS(5776),
    [anon_sym_SLASH_EQ] = ACTIONS(5776),
    [anon_sym_PERCENT_EQ] = ACTIONS(5776),
    [anon_sym_PLUS_EQ] = ACTIONS(5776),
    [anon_sym_DASH_EQ] = ACTIONS(5776),
    [anon_sym_LT_LT_EQ] = ACTIONS(5776),
    [anon_sym_GT_GT_EQ] = ACTIONS(5776),
    [anon_sym_AMP_EQ] = ACTIONS(5776),
    [anon_sym_CARET_EQ] = ACTIONS(5776),
    [anon_sym_PIPE_EQ] = ACTIONS(5776),
    [anon_sym_and_eq] = ACTIONS(5776),
    [anon_sym_or_eq] = ACTIONS(5776),
    [anon_sym_xor_eq] = ACTIONS(5776),
    [anon_sym_LT_EQ_GT] = ACTIONS(5776),
    [anon_sym_or] = ACTIONS(5778),
    [anon_sym_and] = ACTIONS(5778),
    [anon_sym_bitor] = ACTIONS(5776),
    [anon_sym_xor] = ACTIONS(5778),
    [anon_sym_bitand] = ACTIONS(5776),
    [anon_sym_not_eq] = ACTIONS(5776),
    [anon_sym_DASH_DASH] = ACTIONS(5776),
    [anon_sym_PLUS_PLUS] = ACTIONS(5776),
    [anon_sym_DOT] = ACTIONS(5778),
    [anon_sym_DOT_STAR] = ACTIONS(5776),
    [anon_sym_DASH_GT] = ACTIONS(5776),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5776),
    [anon_sym_decltype] = ACTIONS(5776),
  },
  [2279] = {
    [sym_identifier] = ACTIONS(6188),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6190),
    [anon_sym_COMMA] = ACTIONS(6190),
    [anon_sym_RPAREN] = ACTIONS(6190),
    [aux_sym_preproc_if_token2] = ACTIONS(6190),
    [aux_sym_preproc_else_token1] = ACTIONS(6190),
    [aux_sym_preproc_elif_token1] = ACTIONS(6188),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6190),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6190),
    [anon_sym_LPAREN2] = ACTIONS(6190),
    [anon_sym_DASH] = ACTIONS(6188),
    [anon_sym_PLUS] = ACTIONS(6188),
    [anon_sym_STAR] = ACTIONS(6188),
    [anon_sym_SLASH] = ACTIONS(6188),
    [anon_sym_PERCENT] = ACTIONS(6188),
    [anon_sym_PIPE_PIPE] = ACTIONS(6190),
    [anon_sym_AMP_AMP] = ACTIONS(6190),
    [anon_sym_PIPE] = ACTIONS(6188),
    [anon_sym_CARET] = ACTIONS(6188),
    [anon_sym_AMP] = ACTIONS(6188),
    [anon_sym_EQ_EQ] = ACTIONS(6190),
    [anon_sym_BANG_EQ] = ACTIONS(6190),
    [anon_sym_GT] = ACTIONS(6188),
    [anon_sym_GT_EQ] = ACTIONS(6190),
    [anon_sym_LT_EQ] = ACTIONS(6188),
    [anon_sym_LT] = ACTIONS(6188),
    [anon_sym_LT_LT] = ACTIONS(6188),
    [anon_sym_GT_GT] = ACTIONS(6188),
    [anon_sym_SEMI] = ACTIONS(6190),
    [anon_sym___attribute__] = ACTIONS(6188),
    [anon_sym___attribute] = ACTIONS(6188),
    [anon_sym_COLON_COLON] = ACTIONS(4862),
    [anon_sym_LBRACE] = ACTIONS(6190),
    [anon_sym_RBRACE] = ACTIONS(6190),
    [anon_sym_LBRACK] = ACTIONS(6190),
    [anon_sym_RBRACK] = ACTIONS(6190),
    [anon_sym_EQ] = ACTIONS(6188),
    [anon_sym_COLON] = ACTIONS(6188),
    [anon_sym_QMARK] = ACTIONS(6190),
    [anon_sym_STAR_EQ] = ACTIONS(6190),
    [anon_sym_SLASH_EQ] = ACTIONS(6190),
    [anon_sym_PERCENT_EQ] = ACTIONS(6190),
    [anon_sym_PLUS_EQ] = ACTIONS(6190),
    [anon_sym_DASH_EQ] = ACTIONS(6190),
    [anon_sym_LT_LT_EQ] = ACTIONS(6190),
    [anon_sym_GT_GT_EQ] = ACTIONS(6190),
    [anon_sym_AMP_EQ] = ACTIONS(6190),
    [anon_sym_CARET_EQ] = ACTIONS(6190),
    [anon_sym_PIPE_EQ] = ACTIONS(6190),
    [anon_sym_and_eq] = ACTIONS(6188),
    [anon_sym_or_eq] = ACTIONS(6188),
    [anon_sym_xor_eq] = ACTIONS(6188),
    [anon_sym_LT_EQ_GT] = ACTIONS(6190),
    [anon_sym_or] = ACTIONS(6188),
    [anon_sym_and] = ACTIONS(6188),
    [anon_sym_bitor] = ACTIONS(6188),
    [anon_sym_xor] = ACTIONS(6188),
    [anon_sym_bitand] = ACTIONS(6188),
    [anon_sym_not_eq] = ACTIONS(6188),
    [anon_sym_DASH_DASH] = ACTIONS(6190),
    [anon_sym_PLUS_PLUS] = ACTIONS(6190),
    [anon_sym_DOT] = ACTIONS(6188),
    [anon_sym_DOT_STAR] = ACTIONS(6190),
    [anon_sym_DASH_GT] = ACTIONS(6190),
    [sym_comment] = ACTIONS(3),
  },
  [2280] = {
    [sym_new_declarator] = STATE(2333),
    [sym_identifier] = ACTIONS(6192),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6194),
    [anon_sym_COMMA] = ACTIONS(6194),
    [anon_sym_RPAREN] = ACTIONS(6194),
    [aux_sym_preproc_if_token2] = ACTIONS(6194),
    [aux_sym_preproc_else_token1] = ACTIONS(6194),
    [aux_sym_preproc_elif_token1] = ACTIONS(6192),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6194),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6194),
    [anon_sym_LPAREN2] = ACTIONS(6194),
    [anon_sym_DASH] = ACTIONS(6192),
    [anon_sym_PLUS] = ACTIONS(6192),
    [anon_sym_STAR] = ACTIONS(6192),
    [anon_sym_SLASH] = ACTIONS(6192),
    [anon_sym_PERCENT] = ACTIONS(6192),
    [anon_sym_PIPE_PIPE] = ACTIONS(6194),
    [anon_sym_AMP_AMP] = ACTIONS(6194),
    [anon_sym_PIPE] = ACTIONS(6192),
    [anon_sym_CARET] = ACTIONS(6192),
    [anon_sym_AMP] = ACTIONS(6192),
    [anon_sym_EQ_EQ] = ACTIONS(6194),
    [anon_sym_BANG_EQ] = ACTIONS(6194),
    [anon_sym_GT] = ACTIONS(6192),
    [anon_sym_GT_EQ] = ACTIONS(6194),
    [anon_sym_LT_EQ] = ACTIONS(6192),
    [anon_sym_LT] = ACTIONS(6192),
    [anon_sym_LT_LT] = ACTIONS(6192),
    [anon_sym_GT_GT] = ACTIONS(6192),
    [anon_sym_SEMI] = ACTIONS(6194),
    [anon_sym___attribute__] = ACTIONS(6192),
    [anon_sym___attribute] = ACTIONS(6192),
    [anon_sym_LBRACE] = ACTIONS(6194),
    [anon_sym_RBRACE] = ACTIONS(6194),
    [anon_sym_LBRACK] = ACTIONS(5690),
    [anon_sym_RBRACK] = ACTIONS(6194),
    [anon_sym_EQ] = ACTIONS(6192),
    [anon_sym_COLON] = ACTIONS(6194),
    [anon_sym_QMARK] = ACTIONS(6194),
    [anon_sym_STAR_EQ] = ACTIONS(6194),
    [anon_sym_SLASH_EQ] = ACTIONS(6194),
    [anon_sym_PERCENT_EQ] = ACTIONS(6194),
    [anon_sym_PLUS_EQ] = ACTIONS(6194),
    [anon_sym_DASH_EQ] = ACTIONS(6194),
    [anon_sym_LT_LT_EQ] = ACTIONS(6194),
    [anon_sym_GT_GT_EQ] = ACTIONS(6194),
    [anon_sym_AMP_EQ] = ACTIONS(6194),
    [anon_sym_CARET_EQ] = ACTIONS(6194),
    [anon_sym_PIPE_EQ] = ACTIONS(6194),
    [anon_sym_and_eq] = ACTIONS(6192),
    [anon_sym_or_eq] = ACTIONS(6192),
    [anon_sym_xor_eq] = ACTIONS(6192),
    [anon_sym_LT_EQ_GT] = ACTIONS(6194),
    [anon_sym_or] = ACTIONS(6192),
    [anon_sym_and] = ACTIONS(6192),
    [anon_sym_bitor] = ACTIONS(6192),
    [anon_sym_xor] = ACTIONS(6192),
    [anon_sym_bitand] = ACTIONS(6192),
    [anon_sym_not_eq] = ACTIONS(6192),
    [anon_sym_DASH_DASH] = ACTIONS(6194),
    [anon_sym_PLUS_PLUS] = ACTIONS(6194),
    [anon_sym_DOT] = ACTIONS(6192),
    [anon_sym_DOT_STAR] = ACTIONS(6194),
    [anon_sym_DASH_GT] = ACTIONS(6194),
    [sym_comment] = ACTIONS(3),
  },
  [2281] = {
    [sym_identifier] = ACTIONS(5454),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5456),
    [anon_sym_COMMA] = ACTIONS(5456),
    [anon_sym_LPAREN2] = ACTIONS(5456),
    [anon_sym_DASH] = ACTIONS(5454),
    [anon_sym_PLUS] = ACTIONS(5454),
    [anon_sym_STAR] = ACTIONS(5454),
    [anon_sym_SLASH] = ACTIONS(5454),
    [anon_sym_PERCENT] = ACTIONS(5454),
    [anon_sym_PIPE_PIPE] = ACTIONS(5456),
    [anon_sym_AMP_AMP] = ACTIONS(5456),
    [anon_sym_PIPE] = ACTIONS(5454),
    [anon_sym_CARET] = ACTIONS(5454),
    [anon_sym_AMP] = ACTIONS(5454),
    [anon_sym_EQ_EQ] = ACTIONS(5456),
    [anon_sym_BANG_EQ] = ACTIONS(5456),
    [anon_sym_GT] = ACTIONS(5454),
    [anon_sym_GT_EQ] = ACTIONS(5456),
    [anon_sym_LT_EQ] = ACTIONS(5454),
    [anon_sym_LT] = ACTIONS(5454),
    [anon_sym_LT_LT] = ACTIONS(5454),
    [anon_sym_GT_GT] = ACTIONS(5454),
    [anon_sym_SEMI] = ACTIONS(5456),
    [anon_sym___attribute__] = ACTIONS(5454),
    [anon_sym___attribute] = ACTIONS(5454),
    [anon_sym_LBRACK] = ACTIONS(5456),
    [anon_sym_EQ] = ACTIONS(5454),
    [anon_sym_QMARK] = ACTIONS(5456),
    [anon_sym_STAR_EQ] = ACTIONS(5456),
    [anon_sym_SLASH_EQ] = ACTIONS(5456),
    [anon_sym_PERCENT_EQ] = ACTIONS(5456),
    [anon_sym_PLUS_EQ] = ACTIONS(5456),
    [anon_sym_DASH_EQ] = ACTIONS(5456),
    [anon_sym_LT_LT_EQ] = ACTIONS(5456),
    [anon_sym_GT_GT_EQ] = ACTIONS(5456),
    [anon_sym_AMP_EQ] = ACTIONS(5456),
    [anon_sym_CARET_EQ] = ACTIONS(5456),
    [anon_sym_PIPE_EQ] = ACTIONS(5456),
    [anon_sym_and_eq] = ACTIONS(5454),
    [anon_sym_or_eq] = ACTIONS(5454),
    [anon_sym_xor_eq] = ACTIONS(5454),
    [anon_sym_LT_EQ_GT] = ACTIONS(5456),
    [anon_sym_or] = ACTIONS(5454),
    [anon_sym_and] = ACTIONS(5454),
    [anon_sym_bitor] = ACTIONS(5454),
    [anon_sym_xor] = ACTIONS(5454),
    [anon_sym_bitand] = ACTIONS(5454),
    [anon_sym_not_eq] = ACTIONS(5454),
    [anon_sym_DASH_DASH] = ACTIONS(5456),
    [anon_sym_PLUS_PLUS] = ACTIONS(5456),
    [anon_sym_DOT] = ACTIONS(5454),
    [anon_sym_DOT_STAR] = ACTIONS(5456),
    [anon_sym_DASH_GT] = ACTIONS(5456),
    [anon_sym_L_DQUOTE] = ACTIONS(5456),
    [anon_sym_u_DQUOTE] = ACTIONS(5456),
    [anon_sym_U_DQUOTE] = ACTIONS(5456),
    [anon_sym_u8_DQUOTE] = ACTIONS(5456),
    [anon_sym_DQUOTE] = ACTIONS(5456),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5456),
    [anon_sym_LR_DQUOTE] = ACTIONS(5456),
    [anon_sym_uR_DQUOTE] = ACTIONS(5456),
    [anon_sym_UR_DQUOTE] = ACTIONS(5456),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5456),
    [sym_literal_suffix] = ACTIONS(5454),
  },
  [2282] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5750),
    [anon_sym_COMMA] = ACTIONS(5750),
    [anon_sym_LPAREN2] = ACTIONS(5750),
    [anon_sym_DASH] = ACTIONS(5752),
    [anon_sym_PLUS] = ACTIONS(5752),
    [anon_sym_STAR] = ACTIONS(5750),
    [anon_sym_SLASH] = ACTIONS(5752),
    [anon_sym_PERCENT] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5750),
    [anon_sym_AMP_AMP] = ACTIONS(5750),
    [anon_sym_PIPE] = ACTIONS(5752),
    [anon_sym_CARET] = ACTIONS(5750),
    [anon_sym_AMP] = ACTIONS(5752),
    [anon_sym_EQ_EQ] = ACTIONS(5750),
    [anon_sym_BANG_EQ] = ACTIONS(5750),
    [anon_sym_GT] = ACTIONS(5752),
    [anon_sym_GT_EQ] = ACTIONS(5752),
    [anon_sym_LT_EQ] = ACTIONS(5752),
    [anon_sym_LT] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5750),
    [anon_sym_GT_GT] = ACTIONS(5752),
    [anon_sym___extension__] = ACTIONS(5750),
    [anon_sym___attribute__] = ACTIONS(5750),
    [anon_sym___attribute] = ACTIONS(5752),
    [anon_sym_LBRACE] = ACTIONS(5750),
    [anon_sym_signed] = ACTIONS(6159),
    [anon_sym_unsigned] = ACTIONS(6159),
    [anon_sym_long] = ACTIONS(6159),
    [anon_sym_short] = ACTIONS(6159),
    [anon_sym_LBRACK] = ACTIONS(5750),
    [anon_sym_const] = ACTIONS(5752),
    [anon_sym_constexpr] = ACTIONS(5750),
    [anon_sym_volatile] = ACTIONS(5750),
    [anon_sym_restrict] = ACTIONS(5750),
    [anon_sym___restrict__] = ACTIONS(5750),
    [anon_sym__Atomic] = ACTIONS(5750),
    [anon_sym__Noreturn] = ACTIONS(5750),
    [anon_sym_noreturn] = ACTIONS(5750),
    [anon_sym__Nonnull] = ACTIONS(5750),
    [anon_sym_mutable] = ACTIONS(5750),
    [anon_sym_constinit] = ACTIONS(5750),
    [anon_sym_consteval] = ACTIONS(5750),
    [anon_sym_alignas] = ACTIONS(5750),
    [anon_sym__Alignas] = ACTIONS(5750),
    [anon_sym_QMARK] = ACTIONS(5750),
    [anon_sym_LT_EQ_GT] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_bitor] = ACTIONS(5750),
    [anon_sym_xor] = ACTIONS(5750),
    [anon_sym_bitand] = ACTIONS(5750),
    [anon_sym_not_eq] = ACTIONS(5750),
    [anon_sym_DASH_DASH] = ACTIONS(5750),
    [anon_sym_PLUS_PLUS] = ACTIONS(5750),
    [anon_sym_DOT] = ACTIONS(5752),
    [anon_sym_DOT_STAR] = ACTIONS(5750),
    [anon_sym_DASH_GT] = ACTIONS(5750),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5750),
    [anon_sym_decltype] = ACTIONS(5750),
    [anon_sym_final] = ACTIONS(5750),
    [anon_sym_override] = ACTIONS(5750),
    [anon_sym_GT2] = ACTIONS(5750),
    [anon_sym_requires] = ACTIONS(5750),
  },
  [2283] = {
    [sym_attribute_specifier] = STATE(1848),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5903),
    [anon_sym_COMMA] = ACTIONS(5903),
    [anon_sym_RPAREN] = ACTIONS(5903),
    [anon_sym_LPAREN2] = ACTIONS(5903),
    [anon_sym_DASH] = ACTIONS(5901),
    [anon_sym_PLUS] = ACTIONS(5901),
    [anon_sym_STAR] = ACTIONS(5903),
    [anon_sym_SLASH] = ACTIONS(5901),
    [anon_sym_PERCENT] = ACTIONS(5903),
    [anon_sym_PIPE_PIPE] = ACTIONS(5903),
    [anon_sym_AMP_AMP] = ACTIONS(5903),
    [anon_sym_PIPE] = ACTIONS(5901),
    [anon_sym_CARET] = ACTIONS(5903),
    [anon_sym_AMP] = ACTIONS(5901),
    [anon_sym_EQ_EQ] = ACTIONS(5903),
    [anon_sym_BANG_EQ] = ACTIONS(5903),
    [anon_sym_GT] = ACTIONS(5901),
    [anon_sym_GT_EQ] = ACTIONS(5903),
    [anon_sym_LT_EQ] = ACTIONS(5901),
    [anon_sym_LT] = ACTIONS(5901),
    [anon_sym_LT_LT] = ACTIONS(5903),
    [anon_sym_GT_GT] = ACTIONS(5903),
    [anon_sym_SEMI] = ACTIONS(5903),
    [anon_sym___extension__] = ACTIONS(5903),
    [anon_sym___attribute__] = ACTIONS(5874),
    [anon_sym___attribute] = ACTIONS(5876),
    [anon_sym_LBRACE] = ACTIONS(5903),
    [anon_sym_RBRACE] = ACTIONS(5903),
    [anon_sym_LBRACK] = ACTIONS(5903),
    [anon_sym_RBRACK] = ACTIONS(5903),
    [anon_sym_const] = ACTIONS(5901),
    [anon_sym_constexpr] = ACTIONS(5903),
    [anon_sym_volatile] = ACTIONS(5903),
    [anon_sym_restrict] = ACTIONS(5903),
    [anon_sym___restrict__] = ACTIONS(5903),
    [anon_sym__Atomic] = ACTIONS(5903),
    [anon_sym__Noreturn] = ACTIONS(5903),
    [anon_sym_noreturn] = ACTIONS(5903),
    [anon_sym__Nonnull] = ACTIONS(5903),
    [anon_sym_mutable] = ACTIONS(5903),
    [anon_sym_constinit] = ACTIONS(5903),
    [anon_sym_consteval] = ACTIONS(5903),
    [anon_sym_alignas] = ACTIONS(5903),
    [anon_sym__Alignas] = ACTIONS(5903),
    [anon_sym_COLON] = ACTIONS(5903),
    [anon_sym_QMARK] = ACTIONS(5903),
    [anon_sym_LT_EQ_GT] = ACTIONS(5903),
    [anon_sym_or] = ACTIONS(5903),
    [anon_sym_and] = ACTIONS(5903),
    [anon_sym_bitor] = ACTIONS(5903),
    [anon_sym_xor] = ACTIONS(5903),
    [anon_sym_bitand] = ACTIONS(5903),
    [anon_sym_not_eq] = ACTIONS(5903),
    [anon_sym_DASH_DASH] = ACTIONS(5903),
    [anon_sym_PLUS_PLUS] = ACTIONS(5903),
    [anon_sym_DOT] = ACTIONS(5901),
    [anon_sym_DOT_STAR] = ACTIONS(5903),
    [anon_sym_DASH_GT] = ACTIONS(5903),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5903),
    [anon_sym_decltype] = ACTIONS(5903),
    [anon_sym_final] = ACTIONS(5903),
    [anon_sym_override] = ACTIONS(5903),
    [anon_sym_requires] = ACTIONS(5903),
  },
  [2284] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2303),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5547),
    [anon_sym_COMMA] = ACTIONS(5547),
    [anon_sym_RPAREN] = ACTIONS(5547),
    [anon_sym_LPAREN2] = ACTIONS(5547),
    [anon_sym_DASH] = ACTIONS(5545),
    [anon_sym_PLUS] = ACTIONS(5545),
    [anon_sym_STAR] = ACTIONS(5545),
    [anon_sym_SLASH] = ACTIONS(5545),
    [anon_sym_PERCENT] = ACTIONS(5545),
    [anon_sym_PIPE_PIPE] = ACTIONS(5547),
    [anon_sym_AMP_AMP] = ACTIONS(5547),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_CARET] = ACTIONS(5545),
    [anon_sym_AMP] = ACTIONS(5545),
    [anon_sym_EQ_EQ] = ACTIONS(5547),
    [anon_sym_BANG_EQ] = ACTIONS(5547),
    [anon_sym_GT] = ACTIONS(5545),
    [anon_sym_GT_EQ] = ACTIONS(5547),
    [anon_sym_LT_EQ] = ACTIONS(5545),
    [anon_sym_LT] = ACTIONS(5545),
    [anon_sym_LT_LT] = ACTIONS(5545),
    [anon_sym_GT_GT] = ACTIONS(5545),
    [anon_sym_SEMI] = ACTIONS(5547),
    [anon_sym___attribute__] = ACTIONS(5547),
    [anon_sym___attribute] = ACTIONS(5545),
    [anon_sym_LBRACE] = ACTIONS(5547),
    [anon_sym_RBRACE] = ACTIONS(5547),
    [anon_sym_signed] = ACTIONS(6196),
    [anon_sym_unsigned] = ACTIONS(6196),
    [anon_sym_long] = ACTIONS(6196),
    [anon_sym_short] = ACTIONS(6196),
    [anon_sym_LBRACK] = ACTIONS(5547),
    [anon_sym_RBRACK] = ACTIONS(5547),
    [anon_sym_EQ] = ACTIONS(5545),
    [anon_sym_COLON] = ACTIONS(5547),
    [anon_sym_QMARK] = ACTIONS(5547),
    [anon_sym_STAR_EQ] = ACTIONS(5547),
    [anon_sym_SLASH_EQ] = ACTIONS(5547),
    [anon_sym_PERCENT_EQ] = ACTIONS(5547),
    [anon_sym_PLUS_EQ] = ACTIONS(5547),
    [anon_sym_DASH_EQ] = ACTIONS(5547),
    [anon_sym_LT_LT_EQ] = ACTIONS(5547),
    [anon_sym_GT_GT_EQ] = ACTIONS(5547),
    [anon_sym_AMP_EQ] = ACTIONS(5547),
    [anon_sym_CARET_EQ] = ACTIONS(5547),
    [anon_sym_PIPE_EQ] = ACTIONS(5547),
    [anon_sym_and_eq] = ACTIONS(5547),
    [anon_sym_or_eq] = ACTIONS(5547),
    [anon_sym_xor_eq] = ACTIONS(5547),
    [anon_sym_LT_EQ_GT] = ACTIONS(5547),
    [anon_sym_or] = ACTIONS(5545),
    [anon_sym_and] = ACTIONS(5545),
    [anon_sym_bitor] = ACTIONS(5547),
    [anon_sym_xor] = ACTIONS(5545),
    [anon_sym_bitand] = ACTIONS(5547),
    [anon_sym_not_eq] = ACTIONS(5547),
    [anon_sym_DASH_DASH] = ACTIONS(5547),
    [anon_sym_PLUS_PLUS] = ACTIONS(5547),
    [anon_sym_DOT] = ACTIONS(5545),
    [anon_sym_DOT_STAR] = ACTIONS(5547),
    [anon_sym_DASH_GT] = ACTIONS(5547),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5547),
    [anon_sym_decltype] = ACTIONS(5547),
  },
  [2285] = {
    [sym_attribute_specifier] = STATE(1799),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5971),
    [anon_sym_COMMA] = ACTIONS(5971),
    [anon_sym_RPAREN] = ACTIONS(5971),
    [anon_sym_LPAREN2] = ACTIONS(5971),
    [anon_sym_DASH] = ACTIONS(5969),
    [anon_sym_PLUS] = ACTIONS(5969),
    [anon_sym_STAR] = ACTIONS(5971),
    [anon_sym_SLASH] = ACTIONS(5969),
    [anon_sym_PERCENT] = ACTIONS(5971),
    [anon_sym_PIPE_PIPE] = ACTIONS(5971),
    [anon_sym_AMP_AMP] = ACTIONS(5971),
    [anon_sym_PIPE] = ACTIONS(5969),
    [anon_sym_CARET] = ACTIONS(5971),
    [anon_sym_AMP] = ACTIONS(5969),
    [anon_sym_EQ_EQ] = ACTIONS(5971),
    [anon_sym_BANG_EQ] = ACTIONS(5971),
    [anon_sym_GT] = ACTIONS(5969),
    [anon_sym_GT_EQ] = ACTIONS(5971),
    [anon_sym_LT_EQ] = ACTIONS(5969),
    [anon_sym_LT] = ACTIONS(5969),
    [anon_sym_LT_LT] = ACTIONS(5971),
    [anon_sym_GT_GT] = ACTIONS(5971),
    [anon_sym_SEMI] = ACTIONS(5971),
    [anon_sym___extension__] = ACTIONS(5971),
    [anon_sym___attribute__] = ACTIONS(5874),
    [anon_sym___attribute] = ACTIONS(5876),
    [anon_sym_LBRACE] = ACTIONS(5971),
    [anon_sym_RBRACE] = ACTIONS(5971),
    [anon_sym_LBRACK] = ACTIONS(5971),
    [anon_sym_RBRACK] = ACTIONS(5971),
    [anon_sym_const] = ACTIONS(5969),
    [anon_sym_constexpr] = ACTIONS(5971),
    [anon_sym_volatile] = ACTIONS(5971),
    [anon_sym_restrict] = ACTIONS(5971),
    [anon_sym___restrict__] = ACTIONS(5971),
    [anon_sym__Atomic] = ACTIONS(5971),
    [anon_sym__Noreturn] = ACTIONS(5971),
    [anon_sym_noreturn] = ACTIONS(5971),
    [anon_sym__Nonnull] = ACTIONS(5971),
    [anon_sym_mutable] = ACTIONS(5971),
    [anon_sym_constinit] = ACTIONS(5971),
    [anon_sym_consteval] = ACTIONS(5971),
    [anon_sym_alignas] = ACTIONS(5971),
    [anon_sym__Alignas] = ACTIONS(5971),
    [anon_sym_COLON] = ACTIONS(5971),
    [anon_sym_QMARK] = ACTIONS(5971),
    [anon_sym_LT_EQ_GT] = ACTIONS(5971),
    [anon_sym_or] = ACTIONS(5971),
    [anon_sym_and] = ACTIONS(5971),
    [anon_sym_bitor] = ACTIONS(5971),
    [anon_sym_xor] = ACTIONS(5971),
    [anon_sym_bitand] = ACTIONS(5971),
    [anon_sym_not_eq] = ACTIONS(5971),
    [anon_sym_DASH_DASH] = ACTIONS(5971),
    [anon_sym_PLUS_PLUS] = ACTIONS(5971),
    [anon_sym_DOT] = ACTIONS(5969),
    [anon_sym_DOT_STAR] = ACTIONS(5971),
    [anon_sym_DASH_GT] = ACTIONS(5971),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5971),
    [anon_sym_decltype] = ACTIONS(5971),
    [anon_sym_final] = ACTIONS(5971),
    [anon_sym_override] = ACTIONS(5971),
    [anon_sym_requires] = ACTIONS(5971),
  },
  [2286] = {
    [sym_ms_based_modifier] = STATE(7870),
    [sym_ms_unaligned_ptr_modifier] = STATE(3998),
    [sym_ms_pointer_modifier] = STATE(3851),
    [sym__declarator] = STATE(6337),
    [sym__abstract_declarator] = STATE(6616),
    [sym_parenthesized_declarator] = STATE(5896),
    [sym_abstract_parenthesized_declarator] = STATE(5942),
    [sym_attributed_declarator] = STATE(5896),
    [sym_pointer_declarator] = STATE(5896),
    [sym_abstract_pointer_declarator] = STATE(5942),
    [sym_function_declarator] = STATE(5896),
    [sym_abstract_function_declarator] = STATE(5942),
    [sym_array_declarator] = STATE(5896),
    [sym_abstract_array_declarator] = STATE(5942),
    [sym_type_qualifier] = STATE(2806),
    [sym_alignas_qualifier] = STATE(4266),
    [sym_parameter_list] = STATE(3055),
    [sym_decltype] = STATE(8512),
    [sym_reference_declarator] = STATE(5896),
    [sym_abstract_reference_declarator] = STATE(5942),
    [sym_structured_binding_declarator] = STATE(5896),
    [sym__function_declarator_seq] = STATE(5919),
    [sym_template_type] = STATE(8512),
    [sym_template_function] = STATE(5896),
    [sym_destructor_name] = STATE(5896),
    [sym_dependent_type_identifier] = STATE(8512),
    [sym__scope_resolution] = STATE(5712),
    [sym_qualified_identifier] = STATE(5896),
    [sym_operator_name] = STATE(5896),
    [aux_sym__type_definition_type_repeat1] = STATE(2806),
    [aux_sym_pointer_declarator_repeat1] = STATE(3851),
    [sym_identifier] = ACTIONS(5327),
    [anon_sym_RPAREN] = ACTIONS(5698),
    [anon_sym_LPAREN2] = ACTIONS(4157),
    [anon_sym_TILDE] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(4159),
    [anon_sym_AMP_AMP] = ACTIONS(4161),
    [anon_sym_AMP] = ACTIONS(4163),
    [anon_sym___extension__] = ACTIONS(3270),
    [anon_sym_COLON_COLON] = ACTIONS(6180),
    [anon_sym___based] = ACTIONS(51),
    [sym_ms_restrict_modifier] = ACTIONS(3266),
    [sym_ms_unsigned_ptr_modifier] = ACTIONS(3266),
    [sym_ms_signed_ptr_modifier] = ACTIONS(3266),
    [anon_sym__unaligned] = ACTIONS(3268),
    [anon_sym___unaligned] = ACTIONS(3268),
    [anon_sym_LBRACK] = ACTIONS(5710),
    [anon_sym_const] = ACTIONS(3270),
    [anon_sym_constexpr] = ACTIONS(3270),
    [anon_sym_volatile] = ACTIONS(3270),
    [anon_sym_restrict] = ACTIONS(3270),
    [anon_sym___restrict__] = ACTIONS(3270),
    [anon_sym__Atomic] = ACTIONS(3270),
    [anon_sym__Noreturn] = ACTIONS(3270),
    [anon_sym_noreturn] = ACTIONS(3270),
    [anon_sym__Nonnull] = ACTIONS(3270),
    [anon_sym_mutable] = ACTIONS(3270),
    [anon_sym_constinit] = ACTIONS(3270),
    [anon_sym_consteval] = ACTIONS(3270),
    [anon_sym_alignas] = ACTIONS(3272),
    [anon_sym__Alignas] = ACTIONS(3272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_decltype] = ACTIONS(1951),
    [anon_sym_template] = ACTIONS(1235),
    [anon_sym_operator] = ACTIONS(1823),
  },
  [2287] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2282),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5738),
    [anon_sym_COMMA] = ACTIONS(5738),
    [anon_sym_LPAREN2] = ACTIONS(5738),
    [anon_sym_DASH] = ACTIONS(5740),
    [anon_sym_PLUS] = ACTIONS(5740),
    [anon_sym_STAR] = ACTIONS(5738),
    [anon_sym_SLASH] = ACTIONS(5740),
    [anon_sym_PERCENT] = ACTIONS(5738),
    [anon_sym_PIPE_PIPE] = ACTIONS(5738),
    [anon_sym_AMP_AMP] = ACTIONS(5738),
    [anon_sym_PIPE] = ACTIONS(5740),
    [anon_sym_CARET] = ACTIONS(5738),
    [anon_sym_AMP] = ACTIONS(5740),
    [anon_sym_EQ_EQ] = ACTIONS(5738),
    [anon_sym_BANG_EQ] = ACTIONS(5738),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5740),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_LT_LT] = ACTIONS(5738),
    [anon_sym_GT_GT] = ACTIONS(5740),
    [anon_sym___extension__] = ACTIONS(5738),
    [anon_sym___attribute__] = ACTIONS(5738),
    [anon_sym___attribute] = ACTIONS(5740),
    [anon_sym_LBRACE] = ACTIONS(5738),
    [anon_sym_signed] = ACTIONS(6198),
    [anon_sym_unsigned] = ACTIONS(6198),
    [anon_sym_long] = ACTIONS(6198),
    [anon_sym_short] = ACTIONS(6198),
    [anon_sym_LBRACK] = ACTIONS(5738),
    [anon_sym_const] = ACTIONS(5740),
    [anon_sym_constexpr] = ACTIONS(5738),
    [anon_sym_volatile] = ACTIONS(5738),
    [anon_sym_restrict] = ACTIONS(5738),
    [anon_sym___restrict__] = ACTIONS(5738),
    [anon_sym__Atomic] = ACTIONS(5738),
    [anon_sym__Noreturn] = ACTIONS(5738),
    [anon_sym_noreturn] = ACTIONS(5738),
    [anon_sym__Nonnull] = ACTIONS(5738),
    [anon_sym_mutable] = ACTIONS(5738),
    [anon_sym_constinit] = ACTIONS(5738),
    [anon_sym_consteval] = ACTIONS(5738),
    [anon_sym_alignas] = ACTIONS(5738),
    [anon_sym__Alignas] = ACTIONS(5738),
    [anon_sym_QMARK] = ACTIONS(5738),
    [anon_sym_LT_EQ_GT] = ACTIONS(5738),
    [anon_sym_or] = ACTIONS(5738),
    [anon_sym_and] = ACTIONS(5738),
    [anon_sym_bitor] = ACTIONS(5738),
    [anon_sym_xor] = ACTIONS(5738),
    [anon_sym_bitand] = ACTIONS(5738),
    [anon_sym_not_eq] = ACTIONS(5738),
    [anon_sym_DASH_DASH] = ACTIONS(5738),
    [anon_sym_PLUS_PLUS] = ACTIONS(5738),
    [anon_sym_DOT] = ACTIONS(5740),
    [anon_sym_DOT_STAR] = ACTIONS(5738),
    [anon_sym_DASH_GT] = ACTIONS(5738),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5738),
    [anon_sym_decltype] = ACTIONS(5738),
    [anon_sym_final] = ACTIONS(5738),
    [anon_sym_override] = ACTIONS(5738),
    [anon_sym_GT2] = ACTIONS(5738),
    [anon_sym_requires] = ACTIONS(5738),
  },
  [2288] = {
    [sym_attribute_specifier] = STATE(1802),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5949),
    [anon_sym_COMMA] = ACTIONS(5949),
    [anon_sym_RPAREN] = ACTIONS(5949),
    [anon_sym_LPAREN2] = ACTIONS(5949),
    [anon_sym_DASH] = ACTIONS(5947),
    [anon_sym_PLUS] = ACTIONS(5947),
    [anon_sym_STAR] = ACTIONS(5949),
    [anon_sym_SLASH] = ACTIONS(5947),
    [anon_sym_PERCENT] = ACTIONS(5949),
    [anon_sym_PIPE_PIPE] = ACTIONS(5949),
    [anon_sym_AMP_AMP] = ACTIONS(5949),
    [anon_sym_PIPE] = ACTIONS(5947),
    [anon_sym_CARET] = ACTIONS(5949),
    [anon_sym_AMP] = ACTIONS(5947),
    [anon_sym_EQ_EQ] = ACTIONS(5949),
    [anon_sym_BANG_EQ] = ACTIONS(5949),
    [anon_sym_GT] = ACTIONS(5947),
    [anon_sym_GT_EQ] = ACTIONS(5949),
    [anon_sym_LT_EQ] = ACTIONS(5947),
    [anon_sym_LT] = ACTIONS(5947),
    [anon_sym_LT_LT] = ACTIONS(5949),
    [anon_sym_GT_GT] = ACTIONS(5949),
    [anon_sym_SEMI] = ACTIONS(5949),
    [anon_sym___extension__] = ACTIONS(5949),
    [anon_sym___attribute__] = ACTIONS(5874),
    [anon_sym___attribute] = ACTIONS(5876),
    [anon_sym_LBRACE] = ACTIONS(5949),
    [anon_sym_RBRACE] = ACTIONS(5949),
    [anon_sym_LBRACK] = ACTIONS(5949),
    [anon_sym_RBRACK] = ACTIONS(5949),
    [anon_sym_const] = ACTIONS(5947),
    [anon_sym_constexpr] = ACTIONS(5949),
    [anon_sym_volatile] = ACTIONS(5949),
    [anon_sym_restrict] = ACTIONS(5949),
    [anon_sym___restrict__] = ACTIONS(5949),
    [anon_sym__Atomic] = ACTIONS(5949),
    [anon_sym__Noreturn] = ACTIONS(5949),
    [anon_sym_noreturn] = ACTIONS(5949),
    [anon_sym__Nonnull] = ACTIONS(5949),
    [anon_sym_mutable] = ACTIONS(5949),
    [anon_sym_constinit] = ACTIONS(5949),
    [anon_sym_consteval] = ACTIONS(5949),
    [anon_sym_alignas] = ACTIONS(5949),
    [anon_sym__Alignas] = ACTIONS(5949),
    [anon_sym_COLON] = ACTIONS(5949),
    [anon_sym_QMARK] = ACTIONS(5949),
    [anon_sym_LT_EQ_GT] = ACTIONS(5949),
    [anon_sym_or] = ACTIONS(5949),
    [anon_sym_and] = ACTIONS(5949),
    [anon_sym_bitor] = ACTIONS(5949),
    [anon_sym_xor] = ACTIONS(5949),
    [anon_sym_bitand] = ACTIONS(5949),
    [anon_sym_not_eq] = ACTIONS(5949),
    [anon_sym_DASH_DASH] = ACTIONS(5949),
    [anon_sym_PLUS_PLUS] = ACTIONS(5949),
    [anon_sym_DOT] = ACTIONS(5947),
    [anon_sym_DOT_STAR] = ACTIONS(5949),
    [anon_sym_DASH_GT] = ACTIONS(5949),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5949),
    [anon_sym_decltype] = ACTIONS(5949),
    [anon_sym_final] = ACTIONS(5949),
    [anon_sym_override] = ACTIONS(5949),
    [anon_sym_requires] = ACTIONS(5949),
  },
  [2289] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5756),
    [anon_sym_COMMA] = ACTIONS(5756),
    [anon_sym_LPAREN2] = ACTIONS(5756),
    [anon_sym_DASH] = ACTIONS(5758),
    [anon_sym_PLUS] = ACTIONS(5758),
    [anon_sym_STAR] = ACTIONS(5756),
    [anon_sym_SLASH] = ACTIONS(5758),
    [anon_sym_PERCENT] = ACTIONS(5756),
    [anon_sym_PIPE_PIPE] = ACTIONS(5756),
    [anon_sym_AMP_AMP] = ACTIONS(5756),
    [anon_sym_PIPE] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5756),
    [anon_sym_AMP] = ACTIONS(5758),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5756),
    [anon_sym_GT] = ACTIONS(5758),
    [anon_sym_GT_EQ] = ACTIONS(5758),
    [anon_sym_LT_EQ] = ACTIONS(5758),
    [anon_sym_LT] = ACTIONS(5758),
    [anon_sym_LT_LT] = ACTIONS(5756),
    [anon_sym_GT_GT] = ACTIONS(5758),
    [anon_sym___extension__] = ACTIONS(5756),
    [anon_sym___attribute__] = ACTIONS(5756),
    [anon_sym___attribute] = ACTIONS(5758),
    [anon_sym_LBRACE] = ACTIONS(5756),
    [anon_sym_signed] = ACTIONS(6159),
    [anon_sym_unsigned] = ACTIONS(6159),
    [anon_sym_long] = ACTIONS(6159),
    [anon_sym_short] = ACTIONS(6159),
    [anon_sym_LBRACK] = ACTIONS(5756),
    [anon_sym_const] = ACTIONS(5758),
    [anon_sym_constexpr] = ACTIONS(5756),
    [anon_sym_volatile] = ACTIONS(5756),
    [anon_sym_restrict] = ACTIONS(5756),
    [anon_sym___restrict__] = ACTIONS(5756),
    [anon_sym__Atomic] = ACTIONS(5756),
    [anon_sym__Noreturn] = ACTIONS(5756),
    [anon_sym_noreturn] = ACTIONS(5756),
    [anon_sym__Nonnull] = ACTIONS(5756),
    [anon_sym_mutable] = ACTIONS(5756),
    [anon_sym_constinit] = ACTIONS(5756),
    [anon_sym_consteval] = ACTIONS(5756),
    [anon_sym_alignas] = ACTIONS(5756),
    [anon_sym__Alignas] = ACTIONS(5756),
    [anon_sym_QMARK] = ACTIONS(5756),
    [anon_sym_LT_EQ_GT] = ACTIONS(5756),
    [anon_sym_or] = ACTIONS(5756),
    [anon_sym_and] = ACTIONS(5756),
    [anon_sym_bitor] = ACTIONS(5756),
    [anon_sym_xor] = ACTIONS(5756),
    [anon_sym_bitand] = ACTIONS(5756),
    [anon_sym_not_eq] = ACTIONS(5756),
    [anon_sym_DASH_DASH] = ACTIONS(5756),
    [anon_sym_PLUS_PLUS] = ACTIONS(5756),
    [anon_sym_DOT] = ACTIONS(5758),
    [anon_sym_DOT_STAR] = ACTIONS(5756),
    [anon_sym_DASH_GT] = ACTIONS(5756),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5756),
    [anon_sym_decltype] = ACTIONS(5756),
    [anon_sym_final] = ACTIONS(5756),
    [anon_sym_override] = ACTIONS(5756),
    [anon_sym_GT2] = ACTIONS(5756),
    [anon_sym_requires] = ACTIONS(5756),
  },
  [2290] = {
    [sym_attribute_specifier] = STATE(1803),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5889),
    [anon_sym_COMMA] = ACTIONS(5889),
    [anon_sym_RPAREN] = ACTIONS(5889),
    [anon_sym_LPAREN2] = ACTIONS(5889),
    [anon_sym_DASH] = ACTIONS(5887),
    [anon_sym_PLUS] = ACTIONS(5887),
    [anon_sym_STAR] = ACTIONS(5889),
    [anon_sym_SLASH] = ACTIONS(5887),
    [anon_sym_PERCENT] = ACTIONS(5889),
    [anon_sym_PIPE_PIPE] = ACTIONS(5889),
    [anon_sym_AMP_AMP] = ACTIONS(5889),
    [anon_sym_PIPE] = ACTIONS(5887),
    [anon_sym_CARET] = ACTIONS(5889),
    [anon_sym_AMP] = ACTIONS(5887),
    [anon_sym_EQ_EQ] = ACTIONS(5889),
    [anon_sym_BANG_EQ] = ACTIONS(5889),
    [anon_sym_GT] = ACTIONS(5887),
    [anon_sym_GT_EQ] = ACTIONS(5889),
    [anon_sym_LT_EQ] = ACTIONS(5887),
    [anon_sym_LT] = ACTIONS(5887),
    [anon_sym_LT_LT] = ACTIONS(5889),
    [anon_sym_GT_GT] = ACTIONS(5889),
    [anon_sym_SEMI] = ACTIONS(5889),
    [anon_sym___extension__] = ACTIONS(5889),
    [anon_sym___attribute__] = ACTIONS(5874),
    [anon_sym___attribute] = ACTIONS(5876),
    [anon_sym_LBRACE] = ACTIONS(5889),
    [anon_sym_RBRACE] = ACTIONS(5889),
    [anon_sym_LBRACK] = ACTIONS(5889),
    [anon_sym_RBRACK] = ACTIONS(5889),
    [anon_sym_const] = ACTIONS(5887),
    [anon_sym_constexpr] = ACTIONS(5889),
    [anon_sym_volatile] = ACTIONS(5889),
    [anon_sym_restrict] = ACTIONS(5889),
    [anon_sym___restrict__] = ACTIONS(5889),
    [anon_sym__Atomic] = ACTIONS(5889),
    [anon_sym__Noreturn] = ACTIONS(5889),
    [anon_sym_noreturn] = ACTIONS(5889),
    [anon_sym__Nonnull] = ACTIONS(5889),
    [anon_sym_mutable] = ACTIONS(5889),
    [anon_sym_constinit] = ACTIONS(5889),
    [anon_sym_consteval] = ACTIONS(5889),
    [anon_sym_alignas] = ACTIONS(5889),
    [anon_sym__Alignas] = ACTIONS(5889),
    [anon_sym_COLON] = ACTIONS(5889),
    [anon_sym_QMARK] = ACTIONS(5889),
    [anon_sym_LT_EQ_GT] = ACTIONS(5889),
    [anon_sym_or] = ACTIONS(5889),
    [anon_sym_and] = ACTIONS(5889),
    [anon_sym_bitor] = ACTIONS(5889),
    [anon_sym_xor] = ACTIONS(5889),
    [anon_sym_bitand] = ACTIONS(5889),
    [anon_sym_not_eq] = ACTIONS(5889),
    [anon_sym_DASH_DASH] = ACTIONS(5889),
    [anon_sym_PLUS_PLUS] = ACTIONS(5889),
    [anon_sym_DOT] = ACTIONS(5887),
    [anon_sym_DOT_STAR] = ACTIONS(5889),
    [anon_sym_DASH_GT] = ACTIONS(5889),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5889),
    [anon_sym_decltype] = ACTIONS(5889),
    [anon_sym_final] = ACTIONS(5889),
    [anon_sym_override] = ACTIONS(5889),
    [anon_sym_requires] = ACTIONS(5889),
  },
  [2291] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1544),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5750),
    [anon_sym_COMMA] = ACTIONS(5750),
    [anon_sym_RPAREN] = ACTIONS(5750),
    [anon_sym_LPAREN2] = ACTIONS(5750),
    [anon_sym_DASH] = ACTIONS(5752),
    [anon_sym_PLUS] = ACTIONS(5752),
    [anon_sym_STAR] = ACTIONS(5752),
    [anon_sym_SLASH] = ACTIONS(5752),
    [anon_sym_PERCENT] = ACTIONS(5752),
    [anon_sym_PIPE_PIPE] = ACTIONS(5750),
    [anon_sym_AMP_AMP] = ACTIONS(5750),
    [anon_sym_PIPE] = ACTIONS(5752),
    [anon_sym_CARET] = ACTIONS(5752),
    [anon_sym_AMP] = ACTIONS(5752),
    [anon_sym_EQ_EQ] = ACTIONS(5750),
    [anon_sym_BANG_EQ] = ACTIONS(5750),
    [anon_sym_GT] = ACTIONS(5752),
    [anon_sym_GT_EQ] = ACTIONS(5750),
    [anon_sym_LT_EQ] = ACTIONS(5752),
    [anon_sym_LT] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5752),
    [anon_sym_GT_GT] = ACTIONS(5752),
    [anon_sym_SEMI] = ACTIONS(5750),
    [anon_sym___attribute__] = ACTIONS(5750),
    [anon_sym___attribute] = ACTIONS(5752),
    [anon_sym_LBRACE] = ACTIONS(5750),
    [anon_sym_RBRACE] = ACTIONS(5750),
    [anon_sym_signed] = ACTIONS(6182),
    [anon_sym_unsigned] = ACTIONS(6182),
    [anon_sym_long] = ACTIONS(6182),
    [anon_sym_short] = ACTIONS(6182),
    [anon_sym_LBRACK] = ACTIONS(5750),
    [anon_sym_RBRACK] = ACTIONS(5750),
    [anon_sym_EQ] = ACTIONS(5752),
    [anon_sym_COLON] = ACTIONS(5750),
    [anon_sym_QMARK] = ACTIONS(5750),
    [anon_sym_STAR_EQ] = ACTIONS(5750),
    [anon_sym_SLASH_EQ] = ACTIONS(5750),
    [anon_sym_PERCENT_EQ] = ACTIONS(5750),
    [anon_sym_PLUS_EQ] = ACTIONS(5750),
    [anon_sym_DASH_EQ] = ACTIONS(5750),
    [anon_sym_LT_LT_EQ] = ACTIONS(5750),
    [anon_sym_GT_GT_EQ] = ACTIONS(5750),
    [anon_sym_AMP_EQ] = ACTIONS(5750),
    [anon_sym_CARET_EQ] = ACTIONS(5750),
    [anon_sym_PIPE_EQ] = ACTIONS(5750),
    [anon_sym_and_eq] = ACTIONS(5750),
    [anon_sym_or_eq] = ACTIONS(5750),
    [anon_sym_xor_eq] = ACTIONS(5750),
    [anon_sym_LT_EQ_GT] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5752),
    [anon_sym_and] = ACTIONS(5752),
    [anon_sym_bitor] = ACTIONS(5750),
    [anon_sym_xor] = ACTIONS(5752),
    [anon_sym_bitand] = ACTIONS(5750),
    [anon_sym_not_eq] = ACTIONS(5750),
    [anon_sym_DASH_DASH] = ACTIONS(5750),
    [anon_sym_PLUS_PLUS] = ACTIONS(5750),
    [anon_sym_DOT] = ACTIONS(5752),
    [anon_sym_DOT_STAR] = ACTIONS(5750),
    [anon_sym_DASH_GT] = ACTIONS(5750),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5750),
    [anon_sym_decltype] = ACTIONS(5750),
  },
  [2292] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1544),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5756),
    [anon_sym_COMMA] = ACTIONS(5756),
    [anon_sym_RPAREN] = ACTIONS(5756),
    [anon_sym_LPAREN2] = ACTIONS(5756),
    [anon_sym_DASH] = ACTIONS(5758),
    [anon_sym_PLUS] = ACTIONS(5758),
    [anon_sym_STAR] = ACTIONS(5758),
    [anon_sym_SLASH] = ACTIONS(5758),
    [anon_sym_PERCENT] = ACTIONS(5758),
    [anon_sym_PIPE_PIPE] = ACTIONS(5756),
    [anon_sym_AMP_AMP] = ACTIONS(5756),
    [anon_sym_PIPE] = ACTIONS(5758),
    [anon_sym_CARET] = ACTIONS(5758),
    [anon_sym_AMP] = ACTIONS(5758),
    [anon_sym_EQ_EQ] = ACTIONS(5756),
    [anon_sym_BANG_EQ] = ACTIONS(5756),
    [anon_sym_GT] = ACTIONS(5758),
    [anon_sym_GT_EQ] = ACTIONS(5756),
    [anon_sym_LT_EQ] = ACTIONS(5758),
    [anon_sym_LT] = ACTIONS(5758),
    [anon_sym_LT_LT] = ACTIONS(5758),
    [anon_sym_GT_GT] = ACTIONS(5758),
    [anon_sym_SEMI] = ACTIONS(5756),
    [anon_sym___attribute__] = ACTIONS(5756),
    [anon_sym___attribute] = ACTIONS(5758),
    [anon_sym_LBRACE] = ACTIONS(5756),
    [anon_sym_RBRACE] = ACTIONS(5756),
    [anon_sym_signed] = ACTIONS(6182),
    [anon_sym_unsigned] = ACTIONS(6182),
    [anon_sym_long] = ACTIONS(6182),
    [anon_sym_short] = ACTIONS(6182),
    [anon_sym_LBRACK] = ACTIONS(5756),
    [anon_sym_RBRACK] = ACTIONS(5756),
    [anon_sym_EQ] = ACTIONS(5758),
    [anon_sym_COLON] = ACTIONS(5756),
    [anon_sym_QMARK] = ACTIONS(5756),
    [anon_sym_STAR_EQ] = ACTIONS(5756),
    [anon_sym_SLASH_EQ] = ACTIONS(5756),
    [anon_sym_PERCENT_EQ] = ACTIONS(5756),
    [anon_sym_PLUS_EQ] = ACTIONS(5756),
    [anon_sym_DASH_EQ] = ACTIONS(5756),
    [anon_sym_LT_LT_EQ] = ACTIONS(5756),
    [anon_sym_GT_GT_EQ] = ACTIONS(5756),
    [anon_sym_AMP_EQ] = ACTIONS(5756),
    [anon_sym_CARET_EQ] = ACTIONS(5756),
    [anon_sym_PIPE_EQ] = ACTIONS(5756),
    [anon_sym_and_eq] = ACTIONS(5756),
    [anon_sym_or_eq] = ACTIONS(5756),
    [anon_sym_xor_eq] = ACTIONS(5756),
    [anon_sym_LT_EQ_GT] = ACTIONS(5756),
    [anon_sym_or] = ACTIONS(5758),
    [anon_sym_and] = ACTIONS(5758),
    [anon_sym_bitor] = ACTIONS(5756),
    [anon_sym_xor] = ACTIONS(5758),
    [anon_sym_bitand] = ACTIONS(5756),
    [anon_sym_not_eq] = ACTIONS(5756),
    [anon_sym_DASH_DASH] = ACTIONS(5756),
    [anon_sym_PLUS_PLUS] = ACTIONS(5756),
    [anon_sym_DOT] = ACTIONS(5758),
    [anon_sym_DOT_STAR] = ACTIONS(5756),
    [anon_sym_DASH_GT] = ACTIONS(5756),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5756),
    [anon_sym_decltype] = ACTIONS(5756),
  },
  [2293] = {
    [sym_template_argument_list] = STATE(2279),
    [sym_identifier] = ACTIONS(6200),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6202),
    [anon_sym_COMMA] = ACTIONS(6202),
    [anon_sym_RPAREN] = ACTIONS(6202),
    [aux_sym_preproc_if_token2] = ACTIONS(6202),
    [aux_sym_preproc_else_token1] = ACTIONS(6202),
    [aux_sym_preproc_elif_token1] = ACTIONS(6200),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6202),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6202),
    [anon_sym_LPAREN2] = ACTIONS(6202),
    [anon_sym_DASH] = ACTIONS(6200),
    [anon_sym_PLUS] = ACTIONS(6200),
    [anon_sym_STAR] = ACTIONS(6200),
    [anon_sym_SLASH] = ACTIONS(6200),
    [anon_sym_PERCENT] = ACTIONS(6200),
    [anon_sym_PIPE_PIPE] = ACTIONS(6202),
    [anon_sym_AMP_AMP] = ACTIONS(6202),
    [anon_sym_PIPE] = ACTIONS(6200),
    [anon_sym_CARET] = ACTIONS(6200),
    [anon_sym_AMP] = ACTIONS(6200),
    [anon_sym_EQ_EQ] = ACTIONS(6202),
    [anon_sym_BANG_EQ] = ACTIONS(6202),
    [anon_sym_GT] = ACTIONS(6200),
    [anon_sym_GT_EQ] = ACTIONS(6202),
    [anon_sym_LT_EQ] = ACTIONS(6200),
    [anon_sym_LT] = ACTIONS(6204),
    [anon_sym_LT_LT] = ACTIONS(6200),
    [anon_sym_GT_GT] = ACTIONS(6200),
    [anon_sym_SEMI] = ACTIONS(6202),
    [anon_sym___attribute__] = ACTIONS(6200),
    [anon_sym___attribute] = ACTIONS(6200),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_RBRACE] = ACTIONS(6202),
    [anon_sym_LBRACK] = ACTIONS(6202),
    [anon_sym_RBRACK] = ACTIONS(6202),
    [anon_sym_EQ] = ACTIONS(6200),
    [anon_sym_COLON] = ACTIONS(6200),
    [anon_sym_QMARK] = ACTIONS(6202),
    [anon_sym_STAR_EQ] = ACTIONS(6202),
    [anon_sym_SLASH_EQ] = ACTIONS(6202),
    [anon_sym_PERCENT_EQ] = ACTIONS(6202),
    [anon_sym_PLUS_EQ] = ACTIONS(6202),
    [anon_sym_DASH_EQ] = ACTIONS(6202),
    [anon_sym_LT_LT_EQ] = ACTIONS(6202),
    [anon_sym_GT_GT_EQ] = ACTIONS(6202),
    [anon_sym_AMP_EQ] = ACTIONS(6202),
    [anon_sym_CARET_EQ] = ACTIONS(6202),
    [anon_sym_PIPE_EQ] = ACTIONS(6202),
    [anon_sym_and_eq] = ACTIONS(6200),
    [anon_sym_or_eq] = ACTIONS(6200),
    [anon_sym_xor_eq] = ACTIONS(6200),
    [anon_sym_LT_EQ_GT] = ACTIONS(6202),
    [anon_sym_or] = ACTIONS(6200),
    [anon_sym_and] = ACTIONS(6200),
    [anon_sym_bitor] = ACTIONS(6200),
    [anon_sym_xor] = ACTIONS(6200),
    [anon_sym_bitand] = ACTIONS(6200),
    [anon_sym_not_eq] = ACTIONS(6200),
    [anon_sym_DASH_DASH] = ACTIONS(6202),
    [anon_sym_PLUS_PLUS] = ACTIONS(6202),
    [anon_sym_DOT] = ACTIONS(6200),
    [anon_sym_DOT_STAR] = ACTIONS(6202),
    [anon_sym_DASH_GT] = ACTIONS(6202),
    [sym_comment] = ACTIONS(3),
  },
  [2294] = {
    [sym_attribute_specifier] = STATE(1807),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5907),
    [anon_sym_COMMA] = ACTIONS(5907),
    [anon_sym_RPAREN] = ACTIONS(5907),
    [anon_sym_LPAREN2] = ACTIONS(5907),
    [anon_sym_DASH] = ACTIONS(5905),
    [anon_sym_PLUS] = ACTIONS(5905),
    [anon_sym_STAR] = ACTIONS(5907),
    [anon_sym_SLASH] = ACTIONS(5905),
    [anon_sym_PERCENT] = ACTIONS(5907),
    [anon_sym_PIPE_PIPE] = ACTIONS(5907),
    [anon_sym_AMP_AMP] = ACTIONS(5907),
    [anon_sym_PIPE] = ACTIONS(5905),
    [anon_sym_CARET] = ACTIONS(5907),
    [anon_sym_AMP] = ACTIONS(5905),
    [anon_sym_EQ_EQ] = ACTIONS(5907),
    [anon_sym_BANG_EQ] = ACTIONS(5907),
    [anon_sym_GT] = ACTIONS(5905),
    [anon_sym_GT_EQ] = ACTIONS(5907),
    [anon_sym_LT_EQ] = ACTIONS(5905),
    [anon_sym_LT] = ACTIONS(5905),
    [anon_sym_LT_LT] = ACTIONS(5907),
    [anon_sym_GT_GT] = ACTIONS(5907),
    [anon_sym_SEMI] = ACTIONS(5907),
    [anon_sym___extension__] = ACTIONS(5907),
    [anon_sym___attribute__] = ACTIONS(5874),
    [anon_sym___attribute] = ACTIONS(5876),
    [anon_sym_LBRACE] = ACTIONS(5907),
    [anon_sym_RBRACE] = ACTIONS(5907),
    [anon_sym_LBRACK] = ACTIONS(5907),
    [anon_sym_RBRACK] = ACTIONS(5907),
    [anon_sym_const] = ACTIONS(5905),
    [anon_sym_constexpr] = ACTIONS(5907),
    [anon_sym_volatile] = ACTIONS(5907),
    [anon_sym_restrict] = ACTIONS(5907),
    [anon_sym___restrict__] = ACTIONS(5907),
    [anon_sym__Atomic] = ACTIONS(5907),
    [anon_sym__Noreturn] = ACTIONS(5907),
    [anon_sym_noreturn] = ACTIONS(5907),
    [anon_sym__Nonnull] = ACTIONS(5907),
    [anon_sym_mutable] = ACTIONS(5907),
    [anon_sym_constinit] = ACTIONS(5907),
    [anon_sym_consteval] = ACTIONS(5907),
    [anon_sym_alignas] = ACTIONS(5907),
    [anon_sym__Alignas] = ACTIONS(5907),
    [anon_sym_COLON] = ACTIONS(5907),
    [anon_sym_QMARK] = ACTIONS(5907),
    [anon_sym_LT_EQ_GT] = ACTIONS(5907),
    [anon_sym_or] = ACTIONS(5907),
    [anon_sym_and] = ACTIONS(5907),
    [anon_sym_bitor] = ACTIONS(5907),
    [anon_sym_xor] = ACTIONS(5907),
    [anon_sym_bitand] = ACTIONS(5907),
    [anon_sym_not_eq] = ACTIONS(5907),
    [anon_sym_DASH_DASH] = ACTIONS(5907),
    [anon_sym_PLUS_PLUS] = ACTIONS(5907),
    [anon_sym_DOT] = ACTIONS(5905),
    [anon_sym_DOT_STAR] = ACTIONS(5907),
    [anon_sym_DASH_GT] = ACTIONS(5907),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5907),
    [anon_sym_decltype] = ACTIONS(5907),
    [anon_sym_final] = ACTIONS(5907),
    [anon_sym_override] = ACTIONS(5907),
    [anon_sym_requires] = ACTIONS(5907),
  },
  [2295] = {
    [sym_attribute_specifier] = STATE(1846),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5978),
    [anon_sym_COMMA] = ACTIONS(5978),
    [anon_sym_RPAREN] = ACTIONS(5978),
    [anon_sym_LPAREN2] = ACTIONS(5978),
    [anon_sym_DASH] = ACTIONS(5976),
    [anon_sym_PLUS] = ACTIONS(5976),
    [anon_sym_STAR] = ACTIONS(5978),
    [anon_sym_SLASH] = ACTIONS(5976),
    [anon_sym_PERCENT] = ACTIONS(5978),
    [anon_sym_PIPE_PIPE] = ACTIONS(5978),
    [anon_sym_AMP_AMP] = ACTIONS(5978),
    [anon_sym_PIPE] = ACTIONS(5976),
    [anon_sym_CARET] = ACTIONS(5978),
    [anon_sym_AMP] = ACTIONS(5976),
    [anon_sym_EQ_EQ] = ACTIONS(5978),
    [anon_sym_BANG_EQ] = ACTIONS(5978),
    [anon_sym_GT] = ACTIONS(5976),
    [anon_sym_GT_EQ] = ACTIONS(5978),
    [anon_sym_LT_EQ] = ACTIONS(5976),
    [anon_sym_LT] = ACTIONS(5976),
    [anon_sym_LT_LT] = ACTIONS(5978),
    [anon_sym_GT_GT] = ACTIONS(5978),
    [anon_sym_SEMI] = ACTIONS(5978),
    [anon_sym___extension__] = ACTIONS(5978),
    [anon_sym___attribute__] = ACTIONS(5874),
    [anon_sym___attribute] = ACTIONS(5876),
    [anon_sym_LBRACE] = ACTIONS(5978),
    [anon_sym_RBRACE] = ACTIONS(5978),
    [anon_sym_LBRACK] = ACTIONS(5978),
    [anon_sym_RBRACK] = ACTIONS(5978),
    [anon_sym_const] = ACTIONS(5976),
    [anon_sym_constexpr] = ACTIONS(5978),
    [anon_sym_volatile] = ACTIONS(5978),
    [anon_sym_restrict] = ACTIONS(5978),
    [anon_sym___restrict__] = ACTIONS(5978),
    [anon_sym__Atomic] = ACTIONS(5978),
    [anon_sym__Noreturn] = ACTIONS(5978),
    [anon_sym_noreturn] = ACTIONS(5978),
    [anon_sym__Nonnull] = ACTIONS(5978),
    [anon_sym_mutable] = ACTIONS(5978),
    [anon_sym_constinit] = ACTIONS(5978),
    [anon_sym_consteval] = ACTIONS(5978),
    [anon_sym_alignas] = ACTIONS(5978),
    [anon_sym__Alignas] = ACTIONS(5978),
    [anon_sym_COLON] = ACTIONS(5978),
    [anon_sym_QMARK] = ACTIONS(5978),
    [anon_sym_LT_EQ_GT] = ACTIONS(5978),
    [anon_sym_or] = ACTIONS(5978),
    [anon_sym_and] = ACTIONS(5978),
    [anon_sym_bitor] = ACTIONS(5978),
    [anon_sym_xor] = ACTIONS(5978),
    [anon_sym_bitand] = ACTIONS(5978),
    [anon_sym_not_eq] = ACTIONS(5978),
    [anon_sym_DASH_DASH] = ACTIONS(5978),
    [anon_sym_PLUS_PLUS] = ACTIONS(5978),
    [anon_sym_DOT] = ACTIONS(5976),
    [anon_sym_DOT_STAR] = ACTIONS(5978),
    [anon_sym_DASH_GT] = ACTIONS(5978),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5978),
    [anon_sym_decltype] = ACTIONS(5978),
    [anon_sym_final] = ACTIONS(5978),
    [anon_sym_override] = ACTIONS(5978),
    [anon_sym_requires] = ACTIONS(5978),
  },
  [2296] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2303),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5433),
    [anon_sym_COMMA] = ACTIONS(5433),
    [anon_sym_RPAREN] = ACTIONS(5433),
    [anon_sym_LPAREN2] = ACTIONS(5433),
    [anon_sym_DASH] = ACTIONS(5431),
    [anon_sym_PLUS] = ACTIONS(5431),
    [anon_sym_STAR] = ACTIONS(5431),
    [anon_sym_SLASH] = ACTIONS(5431),
    [anon_sym_PERCENT] = ACTIONS(5431),
    [anon_sym_PIPE_PIPE] = ACTIONS(5433),
    [anon_sym_AMP_AMP] = ACTIONS(5433),
    [anon_sym_PIPE] = ACTIONS(5431),
    [anon_sym_CARET] = ACTIONS(5431),
    [anon_sym_AMP] = ACTIONS(5431),
    [anon_sym_EQ_EQ] = ACTIONS(5433),
    [anon_sym_BANG_EQ] = ACTIONS(5433),
    [anon_sym_GT] = ACTIONS(5431),
    [anon_sym_GT_EQ] = ACTIONS(5433),
    [anon_sym_LT_EQ] = ACTIONS(5431),
    [anon_sym_LT] = ACTIONS(5431),
    [anon_sym_LT_LT] = ACTIONS(5431),
    [anon_sym_GT_GT] = ACTIONS(5431),
    [anon_sym_SEMI] = ACTIONS(5433),
    [anon_sym___attribute__] = ACTIONS(5433),
    [anon_sym___attribute] = ACTIONS(5431),
    [anon_sym_LBRACE] = ACTIONS(5433),
    [anon_sym_RBRACE] = ACTIONS(5433),
    [anon_sym_signed] = ACTIONS(6196),
    [anon_sym_unsigned] = ACTIONS(6196),
    [anon_sym_long] = ACTIONS(6196),
    [anon_sym_short] = ACTIONS(6196),
    [anon_sym_LBRACK] = ACTIONS(5433),
    [anon_sym_RBRACK] = ACTIONS(5433),
    [anon_sym_EQ] = ACTIONS(5431),
    [anon_sym_COLON] = ACTIONS(5433),
    [anon_sym_QMARK] = ACTIONS(5433),
    [anon_sym_STAR_EQ] = ACTIONS(5433),
    [anon_sym_SLASH_EQ] = ACTIONS(5433),
    [anon_sym_PERCENT_EQ] = ACTIONS(5433),
    [anon_sym_PLUS_EQ] = ACTIONS(5433),
    [anon_sym_DASH_EQ] = ACTIONS(5433),
    [anon_sym_LT_LT_EQ] = ACTIONS(5433),
    [anon_sym_GT_GT_EQ] = ACTIONS(5433),
    [anon_sym_AMP_EQ] = ACTIONS(5433),
    [anon_sym_CARET_EQ] = ACTIONS(5433),
    [anon_sym_PIPE_EQ] = ACTIONS(5433),
    [anon_sym_and_eq] = ACTIONS(5433),
    [anon_sym_or_eq] = ACTIONS(5433),
    [anon_sym_xor_eq] = ACTIONS(5433),
    [anon_sym_LT_EQ_GT] = ACTIONS(5433),
    [anon_sym_or] = ACTIONS(5431),
    [anon_sym_and] = ACTIONS(5431),
    [anon_sym_bitor] = ACTIONS(5433),
    [anon_sym_xor] = ACTIONS(5431),
    [anon_sym_bitand] = ACTIONS(5433),
    [anon_sym_not_eq] = ACTIONS(5433),
    [anon_sym_DASH_DASH] = ACTIONS(5433),
    [anon_sym_PLUS_PLUS] = ACTIONS(5433),
    [anon_sym_DOT] = ACTIONS(5431),
    [anon_sym_DOT_STAR] = ACTIONS(5433),
    [anon_sym_DASH_GT] = ACTIONS(5433),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5433),
    [anon_sym_decltype] = ACTIONS(5433),
  },
  [2297] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2289),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5760),
    [anon_sym_COMMA] = ACTIONS(5760),
    [anon_sym_LPAREN2] = ACTIONS(5760),
    [anon_sym_DASH] = ACTIONS(5762),
    [anon_sym_PLUS] = ACTIONS(5762),
    [anon_sym_STAR] = ACTIONS(5760),
    [anon_sym_SLASH] = ACTIONS(5762),
    [anon_sym_PERCENT] = ACTIONS(5760),
    [anon_sym_PIPE_PIPE] = ACTIONS(5760),
    [anon_sym_AMP_AMP] = ACTIONS(5760),
    [anon_sym_PIPE] = ACTIONS(5762),
    [anon_sym_CARET] = ACTIONS(5760),
    [anon_sym_AMP] = ACTIONS(5762),
    [anon_sym_EQ_EQ] = ACTIONS(5760),
    [anon_sym_BANG_EQ] = ACTIONS(5760),
    [anon_sym_GT] = ACTIONS(5762),
    [anon_sym_GT_EQ] = ACTIONS(5762),
    [anon_sym_LT_EQ] = ACTIONS(5762),
    [anon_sym_LT] = ACTIONS(5762),
    [anon_sym_LT_LT] = ACTIONS(5760),
    [anon_sym_GT_GT] = ACTIONS(5762),
    [anon_sym___extension__] = ACTIONS(5760),
    [anon_sym___attribute__] = ACTIONS(5760),
    [anon_sym___attribute] = ACTIONS(5762),
    [anon_sym_LBRACE] = ACTIONS(5760),
    [anon_sym_signed] = ACTIONS(6207),
    [anon_sym_unsigned] = ACTIONS(6207),
    [anon_sym_long] = ACTIONS(6207),
    [anon_sym_short] = ACTIONS(6207),
    [anon_sym_LBRACK] = ACTIONS(5760),
    [anon_sym_const] = ACTIONS(5762),
    [anon_sym_constexpr] = ACTIONS(5760),
    [anon_sym_volatile] = ACTIONS(5760),
    [anon_sym_restrict] = ACTIONS(5760),
    [anon_sym___restrict__] = ACTIONS(5760),
    [anon_sym__Atomic] = ACTIONS(5760),
    [anon_sym__Noreturn] = ACTIONS(5760),
    [anon_sym_noreturn] = ACTIONS(5760),
    [anon_sym__Nonnull] = ACTIONS(5760),
    [anon_sym_mutable] = ACTIONS(5760),
    [anon_sym_constinit] = ACTIONS(5760),
    [anon_sym_consteval] = ACTIONS(5760),
    [anon_sym_alignas] = ACTIONS(5760),
    [anon_sym__Alignas] = ACTIONS(5760),
    [anon_sym_QMARK] = ACTIONS(5760),
    [anon_sym_LT_EQ_GT] = ACTIONS(5760),
    [anon_sym_or] = ACTIONS(5760),
    [anon_sym_and] = ACTIONS(5760),
    [anon_sym_bitor] = ACTIONS(5760),
    [anon_sym_xor] = ACTIONS(5760),
    [anon_sym_bitand] = ACTIONS(5760),
    [anon_sym_not_eq] = ACTIONS(5760),
    [anon_sym_DASH_DASH] = ACTIONS(5760),
    [anon_sym_PLUS_PLUS] = ACTIONS(5760),
    [anon_sym_DOT] = ACTIONS(5762),
    [anon_sym_DOT_STAR] = ACTIONS(5760),
    [anon_sym_DASH_GT] = ACTIONS(5760),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5760),
    [anon_sym_decltype] = ACTIONS(5760),
    [anon_sym_final] = ACTIONS(5760),
    [anon_sym_override] = ACTIONS(5760),
    [anon_sym_GT2] = ACTIONS(5760),
    [anon_sym_requires] = ACTIONS(5760),
  },
  [2298] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5780),
    [anon_sym_COMMA] = ACTIONS(5780),
    [anon_sym_LPAREN2] = ACTIONS(5780),
    [anon_sym_DASH] = ACTIONS(5782),
    [anon_sym_PLUS] = ACTIONS(5782),
    [anon_sym_STAR] = ACTIONS(5780),
    [anon_sym_SLASH] = ACTIONS(5782),
    [anon_sym_PERCENT] = ACTIONS(5780),
    [anon_sym_PIPE_PIPE] = ACTIONS(5780),
    [anon_sym_AMP_AMP] = ACTIONS(5780),
    [anon_sym_PIPE] = ACTIONS(5782),
    [anon_sym_CARET] = ACTIONS(5780),
    [anon_sym_AMP] = ACTIONS(5782),
    [anon_sym_EQ_EQ] = ACTIONS(5780),
    [anon_sym_BANG_EQ] = ACTIONS(5780),
    [anon_sym_GT] = ACTIONS(5782),
    [anon_sym_GT_EQ] = ACTIONS(5782),
    [anon_sym_LT_EQ] = ACTIONS(5782),
    [anon_sym_LT] = ACTIONS(5782),
    [anon_sym_LT_LT] = ACTIONS(5780),
    [anon_sym_GT_GT] = ACTIONS(5782),
    [anon_sym___extension__] = ACTIONS(5780),
    [anon_sym___attribute__] = ACTIONS(5780),
    [anon_sym___attribute] = ACTIONS(5782),
    [anon_sym_LBRACE] = ACTIONS(5780),
    [anon_sym_signed] = ACTIONS(6159),
    [anon_sym_unsigned] = ACTIONS(6159),
    [anon_sym_long] = ACTIONS(6159),
    [anon_sym_short] = ACTIONS(6159),
    [anon_sym_LBRACK] = ACTIONS(5780),
    [anon_sym_const] = ACTIONS(5782),
    [anon_sym_constexpr] = ACTIONS(5780),
    [anon_sym_volatile] = ACTIONS(5780),
    [anon_sym_restrict] = ACTIONS(5780),
    [anon_sym___restrict__] = ACTIONS(5780),
    [anon_sym__Atomic] = ACTIONS(5780),
    [anon_sym__Noreturn] = ACTIONS(5780),
    [anon_sym_noreturn] = ACTIONS(5780),
    [anon_sym__Nonnull] = ACTIONS(5780),
    [anon_sym_mutable] = ACTIONS(5780),
    [anon_sym_constinit] = ACTIONS(5780),
    [anon_sym_consteval] = ACTIONS(5780),
    [anon_sym_alignas] = ACTIONS(5780),
    [anon_sym__Alignas] = ACTIONS(5780),
    [anon_sym_QMARK] = ACTIONS(5780),
    [anon_sym_LT_EQ_GT] = ACTIONS(5780),
    [anon_sym_or] = ACTIONS(5780),
    [anon_sym_and] = ACTIONS(5780),
    [anon_sym_bitor] = ACTIONS(5780),
    [anon_sym_xor] = ACTIONS(5780),
    [anon_sym_bitand] = ACTIONS(5780),
    [anon_sym_not_eq] = ACTIONS(5780),
    [anon_sym_DASH_DASH] = ACTIONS(5780),
    [anon_sym_PLUS_PLUS] = ACTIONS(5780),
    [anon_sym_DOT] = ACTIONS(5782),
    [anon_sym_DOT_STAR] = ACTIONS(5780),
    [anon_sym_DASH_GT] = ACTIONS(5780),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5780),
    [anon_sym_decltype] = ACTIONS(5780),
    [anon_sym_final] = ACTIONS(5780),
    [anon_sym_override] = ACTIONS(5780),
    [anon_sym_GT2] = ACTIONS(5780),
    [anon_sym_requires] = ACTIONS(5780),
  },
  [2299] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5547),
    [anon_sym_COMMA] = ACTIONS(5547),
    [anon_sym_LPAREN2] = ACTIONS(5547),
    [anon_sym_DASH] = ACTIONS(5545),
    [anon_sym_PLUS] = ACTIONS(5545),
    [anon_sym_STAR] = ACTIONS(5547),
    [anon_sym_SLASH] = ACTIONS(5545),
    [anon_sym_PERCENT] = ACTIONS(5547),
    [anon_sym_PIPE_PIPE] = ACTIONS(5547),
    [anon_sym_AMP_AMP] = ACTIONS(5547),
    [anon_sym_PIPE] = ACTIONS(5545),
    [anon_sym_CARET] = ACTIONS(5547),
    [anon_sym_AMP] = ACTIONS(5545),
    [anon_sym_EQ_EQ] = ACTIONS(5547),
    [anon_sym_BANG_EQ] = ACTIONS(5547),
    [anon_sym_GT] = ACTIONS(5545),
    [anon_sym_GT_EQ] = ACTIONS(5545),
    [anon_sym_LT_EQ] = ACTIONS(5545),
    [anon_sym_LT] = ACTIONS(5545),
    [anon_sym_LT_LT] = ACTIONS(5547),
    [anon_sym_GT_GT] = ACTIONS(5545),
    [anon_sym___extension__] = ACTIONS(5547),
    [anon_sym___attribute__] = ACTIONS(5547),
    [anon_sym___attribute] = ACTIONS(5545),
    [anon_sym_LBRACE] = ACTIONS(5547),
    [anon_sym_signed] = ACTIONS(6209),
    [anon_sym_unsigned] = ACTIONS(6209),
    [anon_sym_long] = ACTIONS(6209),
    [anon_sym_short] = ACTIONS(6209),
    [anon_sym_LBRACK] = ACTIONS(5547),
    [anon_sym_const] = ACTIONS(5545),
    [anon_sym_constexpr] = ACTIONS(5547),
    [anon_sym_volatile] = ACTIONS(5547),
    [anon_sym_restrict] = ACTIONS(5547),
    [anon_sym___restrict__] = ACTIONS(5547),
    [anon_sym__Atomic] = ACTIONS(5547),
    [anon_sym__Noreturn] = ACTIONS(5547),
    [anon_sym_noreturn] = ACTIONS(5547),
    [anon_sym__Nonnull] = ACTIONS(5547),
    [anon_sym_mutable] = ACTIONS(5547),
    [anon_sym_constinit] = ACTIONS(5547),
    [anon_sym_consteval] = ACTIONS(5547),
    [anon_sym_alignas] = ACTIONS(5547),
    [anon_sym__Alignas] = ACTIONS(5547),
    [anon_sym_QMARK] = ACTIONS(5547),
    [anon_sym_LT_EQ_GT] = ACTIONS(5547),
    [anon_sym_or] = ACTIONS(5547),
    [anon_sym_and] = ACTIONS(5547),
    [anon_sym_bitor] = ACTIONS(5547),
    [anon_sym_xor] = ACTIONS(5547),
    [anon_sym_bitand] = ACTIONS(5547),
    [anon_sym_not_eq] = ACTIONS(5547),
    [anon_sym_DASH_DASH] = ACTIONS(5547),
    [anon_sym_PLUS_PLUS] = ACTIONS(5547),
    [anon_sym_DOT] = ACTIONS(5545),
    [anon_sym_DOT_STAR] = ACTIONS(5547),
    [anon_sym_DASH_GT] = ACTIONS(5547),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5547),
    [anon_sym_decltype] = ACTIONS(5547),
    [anon_sym_final] = ACTIONS(5547),
    [anon_sym_override] = ACTIONS(5547),
    [anon_sym_GT2] = ACTIONS(5547),
    [anon_sym_requires] = ACTIONS(5547),
  },
  [2300] = {
    [sym_identifier] = ACTIONS(4864),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4857),
    [anon_sym_COMMA] = ACTIONS(4857),
    [anon_sym_RPAREN] = ACTIONS(4857),
    [aux_sym_preproc_if_token2] = ACTIONS(4857),
    [aux_sym_preproc_else_token1] = ACTIONS(4857),
    [aux_sym_preproc_elif_token1] = ACTIONS(4864),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(4857),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(4857),
    [anon_sym_LPAREN2] = ACTIONS(4857),
    [anon_sym_DASH] = ACTIONS(4864),
    [anon_sym_PLUS] = ACTIONS(4864),
    [anon_sym_STAR] = ACTIONS(4864),
    [anon_sym_SLASH] = ACTIONS(4864),
    [anon_sym_PERCENT] = ACTIONS(4864),
    [anon_sym_PIPE_PIPE] = ACTIONS(4857),
    [anon_sym_AMP_AMP] = ACTIONS(4857),
    [anon_sym_PIPE] = ACTIONS(4864),
    [anon_sym_CARET] = ACTIONS(4864),
    [anon_sym_AMP] = ACTIONS(4864),
    [anon_sym_EQ_EQ] = ACTIONS(4857),
    [anon_sym_BANG_EQ] = ACTIONS(4857),
    [anon_sym_GT] = ACTIONS(4864),
    [anon_sym_GT_EQ] = ACTIONS(4857),
    [anon_sym_LT_EQ] = ACTIONS(4864),
    [anon_sym_LT] = ACTIONS(4864),
    [anon_sym_LT_LT] = ACTIONS(4864),
    [anon_sym_GT_GT] = ACTIONS(4864),
    [anon_sym_SEMI] = ACTIONS(4857),
    [anon_sym___attribute__] = ACTIONS(4864),
    [anon_sym___attribute] = ACTIONS(4864),
    [anon_sym_COLON_COLON] = ACTIONS(4862),
    [anon_sym_LBRACE] = ACTIONS(4862),
    [anon_sym_RBRACE] = ACTIONS(4857),
    [anon_sym_LBRACK] = ACTIONS(4857),
    [anon_sym_RBRACK] = ACTIONS(4857),
    [anon_sym_EQ] = ACTIONS(4864),
    [anon_sym_COLON] = ACTIONS(4864),
    [anon_sym_QMARK] = ACTIONS(4857),
    [anon_sym_STAR_EQ] = ACTIONS(4857),
    [anon_sym_SLASH_EQ] = ACTIONS(4857),
    [anon_sym_PERCENT_EQ] = ACTIONS(4857),
    [anon_sym_PLUS_EQ] = ACTIONS(4857),
    [anon_sym_DASH_EQ] = ACTIONS(4857),
    [anon_sym_LT_LT_EQ] = ACTIONS(4857),
    [anon_sym_GT_GT_EQ] = ACTIONS(4857),
    [anon_sym_AMP_EQ] = ACTIONS(4857),
    [anon_sym_CARET_EQ] = ACTIONS(4857),
    [anon_sym_PIPE_EQ] = ACTIONS(4857),
    [anon_sym_and_eq] = ACTIONS(4864),
    [anon_sym_or_eq] = ACTIONS(4864),
    [anon_sym_xor_eq] = ACTIONS(4864),
    [anon_sym_LT_EQ_GT] = ACTIONS(4857),
    [anon_sym_or] = ACTIONS(4864),
    [anon_sym_and] = ACTIONS(4864),
    [anon_sym_bitor] = ACTIONS(4864),
    [anon_sym_xor] = ACTIONS(4864),
    [anon_sym_bitand] = ACTIONS(4864),
    [anon_sym_not_eq] = ACTIONS(4864),
    [anon_sym_DASH_DASH] = ACTIONS(4857),
    [anon_sym_PLUS_PLUS] = ACTIONS(4857),
    [anon_sym_DOT] = ACTIONS(4864),
    [anon_sym_DOT_STAR] = ACTIONS(4857),
    [anon_sym_DASH_GT] = ACTIONS(4857),
    [sym_comment] = ACTIONS(3),
  },
  [2301] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5776),
    [anon_sym_COMMA] = ACTIONS(5776),
    [anon_sym_LPAREN2] = ACTIONS(5776),
    [anon_sym_DASH] = ACTIONS(5778),
    [anon_sym_PLUS] = ACTIONS(5778),
    [anon_sym_STAR] = ACTIONS(5776),
    [anon_sym_SLASH] = ACTIONS(5778),
    [anon_sym_PERCENT] = ACTIONS(5776),
    [anon_sym_PIPE_PIPE] = ACTIONS(5776),
    [anon_sym_AMP_AMP] = ACTIONS(5776),
    [anon_sym_PIPE] = ACTIONS(5778),
    [anon_sym_CARET] = ACTIONS(5776),
    [anon_sym_AMP] = ACTIONS(5778),
    [anon_sym_EQ_EQ] = ACTIONS(5776),
    [anon_sym_BANG_EQ] = ACTIONS(5776),
    [anon_sym_GT] = ACTIONS(5778),
    [anon_sym_GT_EQ] = ACTIONS(5778),
    [anon_sym_LT_EQ] = ACTIONS(5778),
    [anon_sym_LT] = ACTIONS(5778),
    [anon_sym_LT_LT] = ACTIONS(5776),
    [anon_sym_GT_GT] = ACTIONS(5778),
    [anon_sym___extension__] = ACTIONS(5776),
    [anon_sym___attribute__] = ACTIONS(5776),
    [anon_sym___attribute] = ACTIONS(5778),
    [anon_sym_LBRACE] = ACTIONS(5776),
    [anon_sym_signed] = ACTIONS(6159),
    [anon_sym_unsigned] = ACTIONS(6159),
    [anon_sym_long] = ACTIONS(6159),
    [anon_sym_short] = ACTIONS(6159),
    [anon_sym_LBRACK] = ACTIONS(5776),
    [anon_sym_const] = ACTIONS(5778),
    [anon_sym_constexpr] = ACTIONS(5776),
    [anon_sym_volatile] = ACTIONS(5776),
    [anon_sym_restrict] = ACTIONS(5776),
    [anon_sym___restrict__] = ACTIONS(5776),
    [anon_sym__Atomic] = ACTIONS(5776),
    [anon_sym__Noreturn] = ACTIONS(5776),
    [anon_sym_noreturn] = ACTIONS(5776),
    [anon_sym__Nonnull] = ACTIONS(5776),
    [anon_sym_mutable] = ACTIONS(5776),
    [anon_sym_constinit] = ACTIONS(5776),
    [anon_sym_consteval] = ACTIONS(5776),
    [anon_sym_alignas] = ACTIONS(5776),
    [anon_sym__Alignas] = ACTIONS(5776),
    [anon_sym_QMARK] = ACTIONS(5776),
    [anon_sym_LT_EQ_GT] = ACTIONS(5776),
    [anon_sym_or] = ACTIONS(5776),
    [anon_sym_and] = ACTIONS(5776),
    [anon_sym_bitor] = ACTIONS(5776),
    [anon_sym_xor] = ACTIONS(5776),
    [anon_sym_bitand] = ACTIONS(5776),
    [anon_sym_not_eq] = ACTIONS(5776),
    [anon_sym_DASH_DASH] = ACTIONS(5776),
    [anon_sym_PLUS_PLUS] = ACTIONS(5776),
    [anon_sym_DOT] = ACTIONS(5778),
    [anon_sym_DOT_STAR] = ACTIONS(5776),
    [anon_sym_DASH_GT] = ACTIONS(5776),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5776),
    [anon_sym_decltype] = ACTIONS(5776),
    [anon_sym_final] = ACTIONS(5776),
    [anon_sym_override] = ACTIONS(5776),
    [anon_sym_GT2] = ACTIONS(5776),
    [anon_sym_requires] = ACTIONS(5776),
  },
  [2302] = {
    [sym_template_argument_list] = STATE(2279),
    [sym_identifier] = ACTIONS(6211),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6213),
    [anon_sym_COMMA] = ACTIONS(6213),
    [anon_sym_RPAREN] = ACTIONS(6213),
    [aux_sym_preproc_if_token2] = ACTIONS(6213),
    [aux_sym_preproc_else_token1] = ACTIONS(6213),
    [aux_sym_preproc_elif_token1] = ACTIONS(6211),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6213),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6213),
    [anon_sym_LPAREN2] = ACTIONS(6213),
    [anon_sym_DASH] = ACTIONS(6211),
    [anon_sym_PLUS] = ACTIONS(6211),
    [anon_sym_STAR] = ACTIONS(6211),
    [anon_sym_SLASH] = ACTIONS(6211),
    [anon_sym_PERCENT] = ACTIONS(6211),
    [anon_sym_PIPE_PIPE] = ACTIONS(6213),
    [anon_sym_AMP_AMP] = ACTIONS(6213),
    [anon_sym_PIPE] = ACTIONS(6211),
    [anon_sym_CARET] = ACTIONS(6211),
    [anon_sym_AMP] = ACTIONS(6211),
    [anon_sym_EQ_EQ] = ACTIONS(6213),
    [anon_sym_BANG_EQ] = ACTIONS(6213),
    [anon_sym_GT] = ACTIONS(6211),
    [anon_sym_GT_EQ] = ACTIONS(6213),
    [anon_sym_LT_EQ] = ACTIONS(6211),
    [anon_sym_LT] = ACTIONS(6215),
    [anon_sym_LT_LT] = ACTIONS(6211),
    [anon_sym_GT_GT] = ACTIONS(6211),
    [anon_sym_SEMI] = ACTIONS(6213),
    [anon_sym___attribute__] = ACTIONS(6211),
    [anon_sym___attribute] = ACTIONS(6211),
    [anon_sym_COLON_COLON] = ACTIONS(4054),
    [anon_sym_RBRACE] = ACTIONS(6213),
    [anon_sym_LBRACK] = ACTIONS(6213),
    [anon_sym_RBRACK] = ACTIONS(6213),
    [anon_sym_EQ] = ACTIONS(6211),
    [anon_sym_COLON] = ACTIONS(6211),
    [anon_sym_QMARK] = ACTIONS(6213),
    [anon_sym_STAR_EQ] = ACTIONS(6213),
    [anon_sym_SLASH_EQ] = ACTIONS(6213),
    [anon_sym_PERCENT_EQ] = ACTIONS(6213),
    [anon_sym_PLUS_EQ] = ACTIONS(6213),
    [anon_sym_DASH_EQ] = ACTIONS(6213),
    [anon_sym_LT_LT_EQ] = ACTIONS(6213),
    [anon_sym_GT_GT_EQ] = ACTIONS(6213),
    [anon_sym_AMP_EQ] = ACTIONS(6213),
    [anon_sym_CARET_EQ] = ACTIONS(6213),
    [anon_sym_PIPE_EQ] = ACTIONS(6213),
    [anon_sym_and_eq] = ACTIONS(6211),
    [anon_sym_or_eq] = ACTIONS(6211),
    [anon_sym_xor_eq] = ACTIONS(6211),
    [anon_sym_LT_EQ_GT] = ACTIONS(6213),
    [anon_sym_or] = ACTIONS(6211),
    [anon_sym_and] = ACTIONS(6211),
    [anon_sym_bitor] = ACTIONS(6211),
    [anon_sym_xor] = ACTIONS(6211),
    [anon_sym_bitand] = ACTIONS(6211),
    [anon_sym_not_eq] = ACTIONS(6211),
    [anon_sym_DASH_DASH] = ACTIONS(6213),
    [anon_sym_PLUS_PLUS] = ACTIONS(6213),
    [anon_sym_DOT] = ACTIONS(6211),
    [anon_sym_DOT_STAR] = ACTIONS(6213),
    [anon_sym_DASH_GT] = ACTIONS(6213),
    [sym_comment] = ACTIONS(3),
  },
  [2303] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1544),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5766),
    [anon_sym_COMMA] = ACTIONS(5766),
    [anon_sym_RPAREN] = ACTIONS(5766),
    [anon_sym_LPAREN2] = ACTIONS(5766),
    [anon_sym_DASH] = ACTIONS(5768),
    [anon_sym_PLUS] = ACTIONS(5768),
    [anon_sym_STAR] = ACTIONS(5768),
    [anon_sym_SLASH] = ACTIONS(5768),
    [anon_sym_PERCENT] = ACTIONS(5768),
    [anon_sym_PIPE_PIPE] = ACTIONS(5766),
    [anon_sym_AMP_AMP] = ACTIONS(5766),
    [anon_sym_PIPE] = ACTIONS(5768),
    [anon_sym_CARET] = ACTIONS(5768),
    [anon_sym_AMP] = ACTIONS(5768),
    [anon_sym_EQ_EQ] = ACTIONS(5766),
    [anon_sym_BANG_EQ] = ACTIONS(5766),
    [anon_sym_GT] = ACTIONS(5768),
    [anon_sym_GT_EQ] = ACTIONS(5766),
    [anon_sym_LT_EQ] = ACTIONS(5768),
    [anon_sym_LT] = ACTIONS(5768),
    [anon_sym_LT_LT] = ACTIONS(5768),
    [anon_sym_GT_GT] = ACTIONS(5768),
    [anon_sym_SEMI] = ACTIONS(5766),
    [anon_sym___attribute__] = ACTIONS(5766),
    [anon_sym___attribute] = ACTIONS(5768),
    [anon_sym_LBRACE] = ACTIONS(5766),
    [anon_sym_RBRACE] = ACTIONS(5766),
    [anon_sym_signed] = ACTIONS(6182),
    [anon_sym_unsigned] = ACTIONS(6182),
    [anon_sym_long] = ACTIONS(6182),
    [anon_sym_short] = ACTIONS(6182),
    [anon_sym_LBRACK] = ACTIONS(5766),
    [anon_sym_RBRACK] = ACTIONS(5766),
    [anon_sym_EQ] = ACTIONS(5768),
    [anon_sym_COLON] = ACTIONS(5766),
    [anon_sym_QMARK] = ACTIONS(5766),
    [anon_sym_STAR_EQ] = ACTIONS(5766),
    [anon_sym_SLASH_EQ] = ACTIONS(5766),
    [anon_sym_PERCENT_EQ] = ACTIONS(5766),
    [anon_sym_PLUS_EQ] = ACTIONS(5766),
    [anon_sym_DASH_EQ] = ACTIONS(5766),
    [anon_sym_LT_LT_EQ] = ACTIONS(5766),
    [anon_sym_GT_GT_EQ] = ACTIONS(5766),
    [anon_sym_AMP_EQ] = ACTIONS(5766),
    [anon_sym_CARET_EQ] = ACTIONS(5766),
    [anon_sym_PIPE_EQ] = ACTIONS(5766),
    [anon_sym_and_eq] = ACTIONS(5766),
    [anon_sym_or_eq] = ACTIONS(5766),
    [anon_sym_xor_eq] = ACTIONS(5766),
    [anon_sym_LT_EQ_GT] = ACTIONS(5766),
    [anon_sym_or] = ACTIONS(5768),
    [anon_sym_and] = ACTIONS(5768),
    [anon_sym_bitor] = ACTIONS(5766),
    [anon_sym_xor] = ACTIONS(5768),
    [anon_sym_bitand] = ACTIONS(5766),
    [anon_sym_not_eq] = ACTIONS(5766),
    [anon_sym_DASH_DASH] = ACTIONS(5766),
    [anon_sym_PLUS_PLUS] = ACTIONS(5766),
    [anon_sym_DOT] = ACTIONS(5768),
    [anon_sym_DOT_STAR] = ACTIONS(5766),
    [anon_sym_DASH_GT] = ACTIONS(5766),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5766),
    [anon_sym_decltype] = ACTIONS(5766),
  },
  [2304] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5433),
    [anon_sym_COMMA] = ACTIONS(5433),
    [anon_sym_LPAREN2] = ACTIONS(5433),
    [anon_sym_DASH] = ACTIONS(5431),
    [anon_sym_PLUS] = ACTIONS(5431),
    [anon_sym_STAR] = ACTIONS(5433),
    [anon_sym_SLASH] = ACTIONS(5431),
    [anon_sym_PERCENT] = ACTIONS(5433),
    [anon_sym_PIPE_PIPE] = ACTIONS(5433),
    [anon_sym_AMP_AMP] = ACTIONS(5433),
    [anon_sym_PIPE] = ACTIONS(5431),
    [anon_sym_CARET] = ACTIONS(5433),
    [anon_sym_AMP] = ACTIONS(5431),
    [anon_sym_EQ_EQ] = ACTIONS(5433),
    [anon_sym_BANG_EQ] = ACTIONS(5433),
    [anon_sym_GT] = ACTIONS(5431),
    [anon_sym_GT_EQ] = ACTIONS(5431),
    [anon_sym_LT_EQ] = ACTIONS(5431),
    [anon_sym_LT] = ACTIONS(5431),
    [anon_sym_LT_LT] = ACTIONS(5433),
    [anon_sym_GT_GT] = ACTIONS(5431),
    [anon_sym___extension__] = ACTIONS(5433),
    [anon_sym___attribute__] = ACTIONS(5433),
    [anon_sym___attribute] = ACTIONS(5431),
    [anon_sym_LBRACE] = ACTIONS(5433),
    [anon_sym_signed] = ACTIONS(6209),
    [anon_sym_unsigned] = ACTIONS(6209),
    [anon_sym_long] = ACTIONS(6209),
    [anon_sym_short] = ACTIONS(6209),
    [anon_sym_LBRACK] = ACTIONS(5433),
    [anon_sym_const] = ACTIONS(5431),
    [anon_sym_constexpr] = ACTIONS(5433),
    [anon_sym_volatile] = ACTIONS(5433),
    [anon_sym_restrict] = ACTIONS(5433),
    [anon_sym___restrict__] = ACTIONS(5433),
    [anon_sym__Atomic] = ACTIONS(5433),
    [anon_sym__Noreturn] = ACTIONS(5433),
    [anon_sym_noreturn] = ACTIONS(5433),
    [anon_sym__Nonnull] = ACTIONS(5433),
    [anon_sym_mutable] = ACTIONS(5433),
    [anon_sym_constinit] = ACTIONS(5433),
    [anon_sym_consteval] = ACTIONS(5433),
    [anon_sym_alignas] = ACTIONS(5433),
    [anon_sym__Alignas] = ACTIONS(5433),
    [anon_sym_QMARK] = ACTIONS(5433),
    [anon_sym_LT_EQ_GT] = ACTIONS(5433),
    [anon_sym_or] = ACTIONS(5433),
    [anon_sym_and] = ACTIONS(5433),
    [anon_sym_bitor] = ACTIONS(5433),
    [anon_sym_xor] = ACTIONS(5433),
    [anon_sym_bitand] = ACTIONS(5433),
    [anon_sym_not_eq] = ACTIONS(5433),
    [anon_sym_DASH_DASH] = ACTIONS(5433),
    [anon_sym_PLUS_PLUS] = ACTIONS(5433),
    [anon_sym_DOT] = ACTIONS(5431),
    [anon_sym_DOT_STAR] = ACTIONS(5433),
    [anon_sym_DASH_GT] = ACTIONS(5433),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5433),
    [anon_sym_decltype] = ACTIONS(5433),
    [anon_sym_final] = ACTIONS(5433),
    [anon_sym_override] = ACTIONS(5433),
    [anon_sym_GT2] = ACTIONS(5433),
    [anon_sym_requires] = ACTIONS(5433),
  },
  [2305] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(1544),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5789),
    [anon_sym_COMMA] = ACTIONS(5789),
    [anon_sym_RPAREN] = ACTIONS(5789),
    [anon_sym_LPAREN2] = ACTIONS(5789),
    [anon_sym_DASH] = ACTIONS(5791),
    [anon_sym_PLUS] = ACTIONS(5791),
    [anon_sym_STAR] = ACTIONS(5791),
    [anon_sym_SLASH] = ACTIONS(5791),
    [anon_sym_PERCENT] = ACTIONS(5791),
    [anon_sym_PIPE_PIPE] = ACTIONS(5789),
    [anon_sym_AMP_AMP] = ACTIONS(5789),
    [anon_sym_PIPE] = ACTIONS(5791),
    [anon_sym_CARET] = ACTIONS(5791),
    [anon_sym_AMP] = ACTIONS(5791),
    [anon_sym_EQ_EQ] = ACTIONS(5789),
    [anon_sym_BANG_EQ] = ACTIONS(5789),
    [anon_sym_GT] = ACTIONS(5791),
    [anon_sym_GT_EQ] = ACTIONS(5789),
    [anon_sym_LT_EQ] = ACTIONS(5791),
    [anon_sym_LT] = ACTIONS(5791),
    [anon_sym_LT_LT] = ACTIONS(5791),
    [anon_sym_GT_GT] = ACTIONS(5791),
    [anon_sym_SEMI] = ACTIONS(5789),
    [anon_sym___attribute__] = ACTIONS(5789),
    [anon_sym___attribute] = ACTIONS(5791),
    [anon_sym_LBRACE] = ACTIONS(5789),
    [anon_sym_RBRACE] = ACTIONS(5789),
    [anon_sym_signed] = ACTIONS(6182),
    [anon_sym_unsigned] = ACTIONS(6182),
    [anon_sym_long] = ACTIONS(6182),
    [anon_sym_short] = ACTIONS(6182),
    [anon_sym_LBRACK] = ACTIONS(5789),
    [anon_sym_RBRACK] = ACTIONS(5789),
    [anon_sym_EQ] = ACTIONS(5791),
    [anon_sym_COLON] = ACTIONS(5789),
    [anon_sym_QMARK] = ACTIONS(5789),
    [anon_sym_STAR_EQ] = ACTIONS(5789),
    [anon_sym_SLASH_EQ] = ACTIONS(5789),
    [anon_sym_PERCENT_EQ] = ACTIONS(5789),
    [anon_sym_PLUS_EQ] = ACTIONS(5789),
    [anon_sym_DASH_EQ] = ACTIONS(5789),
    [anon_sym_LT_LT_EQ] = ACTIONS(5789),
    [anon_sym_GT_GT_EQ] = ACTIONS(5789),
    [anon_sym_AMP_EQ] = ACTIONS(5789),
    [anon_sym_CARET_EQ] = ACTIONS(5789),
    [anon_sym_PIPE_EQ] = ACTIONS(5789),
    [anon_sym_and_eq] = ACTIONS(5789),
    [anon_sym_or_eq] = ACTIONS(5789),
    [anon_sym_xor_eq] = ACTIONS(5789),
    [anon_sym_LT_EQ_GT] = ACTIONS(5789),
    [anon_sym_or] = ACTIONS(5791),
    [anon_sym_and] = ACTIONS(5791),
    [anon_sym_bitor] = ACTIONS(5789),
    [anon_sym_xor] = ACTIONS(5791),
    [anon_sym_bitand] = ACTIONS(5789),
    [anon_sym_not_eq] = ACTIONS(5789),
    [anon_sym_DASH_DASH] = ACTIONS(5789),
    [anon_sym_PLUS_PLUS] = ACTIONS(5789),
    [anon_sym_DOT] = ACTIONS(5791),
    [anon_sym_DOT_STAR] = ACTIONS(5789),
    [anon_sym_DASH_GT] = ACTIONS(5789),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5789),
    [anon_sym_decltype] = ACTIONS(5789),
  },
  [2306] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5766),
    [anon_sym_COMMA] = ACTIONS(5766),
    [anon_sym_LPAREN2] = ACTIONS(5766),
    [anon_sym_DASH] = ACTIONS(5768),
    [anon_sym_PLUS] = ACTIONS(5768),
    [anon_sym_STAR] = ACTIONS(5766),
    [anon_sym_SLASH] = ACTIONS(5768),
    [anon_sym_PERCENT] = ACTIONS(5766),
    [anon_sym_PIPE_PIPE] = ACTIONS(5766),
    [anon_sym_AMP_AMP] = ACTIONS(5766),
    [anon_sym_PIPE] = ACTIONS(5768),
    [anon_sym_CARET] = ACTIONS(5766),
    [anon_sym_AMP] = ACTIONS(5768),
    [anon_sym_EQ_EQ] = ACTIONS(5766),
    [anon_sym_BANG_EQ] = ACTIONS(5766),
    [anon_sym_GT] = ACTIONS(5768),
    [anon_sym_GT_EQ] = ACTIONS(5768),
    [anon_sym_LT_EQ] = ACTIONS(5768),
    [anon_sym_LT] = ACTIONS(5768),
    [anon_sym_LT_LT] = ACTIONS(5766),
    [anon_sym_GT_GT] = ACTIONS(5768),
    [anon_sym___extension__] = ACTIONS(5766),
    [anon_sym___attribute__] = ACTIONS(5766),
    [anon_sym___attribute] = ACTIONS(5768),
    [anon_sym_LBRACE] = ACTIONS(5766),
    [anon_sym_signed] = ACTIONS(6159),
    [anon_sym_unsigned] = ACTIONS(6159),
    [anon_sym_long] = ACTIONS(6159),
    [anon_sym_short] = ACTIONS(6159),
    [anon_sym_LBRACK] = ACTIONS(5766),
    [anon_sym_const] = ACTIONS(5768),
    [anon_sym_constexpr] = ACTIONS(5766),
    [anon_sym_volatile] = ACTIONS(5766),
    [anon_sym_restrict] = ACTIONS(5766),
    [anon_sym___restrict__] = ACTIONS(5766),
    [anon_sym__Atomic] = ACTIONS(5766),
    [anon_sym__Noreturn] = ACTIONS(5766),
    [anon_sym_noreturn] = ACTIONS(5766),
    [anon_sym__Nonnull] = ACTIONS(5766),
    [anon_sym_mutable] = ACTIONS(5766),
    [anon_sym_constinit] = ACTIONS(5766),
    [anon_sym_consteval] = ACTIONS(5766),
    [anon_sym_alignas] = ACTIONS(5766),
    [anon_sym__Alignas] = ACTIONS(5766),
    [anon_sym_QMARK] = ACTIONS(5766),
    [anon_sym_LT_EQ_GT] = ACTIONS(5766),
    [anon_sym_or] = ACTIONS(5766),
    [anon_sym_and] = ACTIONS(5766),
    [anon_sym_bitor] = ACTIONS(5766),
    [anon_sym_xor] = ACTIONS(5766),
    [anon_sym_bitand] = ACTIONS(5766),
    [anon_sym_not_eq] = ACTIONS(5766),
    [anon_sym_DASH_DASH] = ACTIONS(5766),
    [anon_sym_PLUS_PLUS] = ACTIONS(5766),
    [anon_sym_DOT] = ACTIONS(5768),
    [anon_sym_DOT_STAR] = ACTIONS(5766),
    [anon_sym_DASH_GT] = ACTIONS(5766),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5766),
    [anon_sym_decltype] = ACTIONS(5766),
    [anon_sym_final] = ACTIONS(5766),
    [anon_sym_override] = ACTIONS(5766),
    [anon_sym_GT2] = ACTIONS(5766),
    [anon_sym_requires] = ACTIONS(5766),
  },
  [2307] = {
    [sym_attribute_specifier] = STATE(2616),
    [sym_field_declaration_list] = STATE(2572),
    [sym_virtual_specifier] = STATE(6941),
    [sym_base_class_clause] = STATE(7533),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5377),
    [anon_sym_COMMA] = ACTIONS(5377),
    [anon_sym_LPAREN2] = ACTIONS(5377),
    [anon_sym_DASH] = ACTIONS(5375),
    [anon_sym_PLUS] = ACTIONS(5375),
    [anon_sym_STAR] = ACTIONS(5377),
    [anon_sym_SLASH] = ACTIONS(5375),
    [anon_sym_PERCENT] = ACTIONS(5377),
    [anon_sym_PIPE_PIPE] = ACTIONS(5377),
    [anon_sym_AMP_AMP] = ACTIONS(5377),
    [anon_sym_PIPE] = ACTIONS(5375),
    [anon_sym_CARET] = ACTIONS(5377),
    [anon_sym_AMP] = ACTIONS(5375),
    [anon_sym_EQ_EQ] = ACTIONS(5377),
    [anon_sym_BANG_EQ] = ACTIONS(5377),
    [anon_sym_GT] = ACTIONS(5375),
    [anon_sym_GT_EQ] = ACTIONS(5375),
    [anon_sym_LT_EQ] = ACTIONS(5375),
    [anon_sym_LT] = ACTIONS(5375),
    [anon_sym_LT_LT] = ACTIONS(5377),
    [anon_sym_GT_GT] = ACTIONS(5375),
    [anon_sym___extension__] = ACTIONS(5377),
    [anon_sym___attribute__] = ACTIONS(6218),
    [anon_sym___attribute] = ACTIONS(6220),
    [anon_sym_LBRACE] = ACTIONS(6222),
    [anon_sym_LBRACK] = ACTIONS(5377),
    [anon_sym_const] = ACTIONS(5375),
    [anon_sym_constexpr] = ACTIONS(5377),
    [anon_sym_volatile] = ACTIONS(5377),
    [anon_sym_restrict] = ACTIONS(5377),
    [anon_sym___restrict__] = ACTIONS(5377),
    [anon_sym__Atomic] = ACTIONS(5377),
    [anon_sym__Noreturn] = ACTIONS(5377),
    [anon_sym_noreturn] = ACTIONS(5377),
    [anon_sym__Nonnull] = ACTIONS(5377),
    [anon_sym_mutable] = ACTIONS(5377),
    [anon_sym_constinit] = ACTIONS(5377),
    [anon_sym_consteval] = ACTIONS(5377),
    [anon_sym_alignas] = ACTIONS(5377),
    [anon_sym__Alignas] = ACTIONS(5377),
    [anon_sym_COLON] = ACTIONS(5383),
    [anon_sym_QMARK] = ACTIONS(5377),
    [anon_sym_LT_EQ_GT] = ACTIONS(5377),
    [anon_sym_or] = ACTIONS(5377),
    [anon_sym_and] = ACTIONS(5377),
    [anon_sym_bitor] = ACTIONS(5377),
    [anon_sym_xor] = ACTIONS(5377),
    [anon_sym_bitand] = ACTIONS(5377),
    [anon_sym_not_eq] = ACTIONS(5377),
    [anon_sym_DASH_DASH] = ACTIONS(5377),
    [anon_sym_PLUS_PLUS] = ACTIONS(5377),
    [anon_sym_DOT] = ACTIONS(5375),
    [anon_sym_DOT_STAR] = ACTIONS(5377),
    [anon_sym_DASH_GT] = ACTIONS(5377),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5377),
    [anon_sym_decltype] = ACTIONS(5377),
    [anon_sym_final] = ACTIONS(5880),
    [anon_sym_override] = ACTIONS(5880),
    [anon_sym_GT2] = ACTIONS(5377),
    [anon_sym_requires] = ACTIONS(5377),
  },
  [2308] = {
    [sym_type_qualifier] = STATE(1580),
    [sym_alignas_qualifier] = STATE(1619),
    [aux_sym__type_definition_type_repeat1] = STATE(1580),
    [aux_sym_sized_type_specifier_repeat1] = STATE(2561),
    [sym_identifier] = ACTIONS(6224),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4961),
    [anon_sym_COMMA] = ACTIONS(4961),
    [anon_sym_RPAREN] = ACTIONS(4961),
    [anon_sym_LPAREN2] = ACTIONS(4961),
    [anon_sym_TILDE] = ACTIONS(4961),
    [anon_sym_STAR] = ACTIONS(4961),
    [anon_sym_AMP_AMP] = ACTIONS(4961),
    [anon_sym_AMP] = ACTIONS(4963),
    [anon_sym_SEMI] = ACTIONS(4961),
    [anon_sym___extension__] = ACTIONS(6227),
    [anon_sym_virtual] = ACTIONS(4963),
    [anon_sym_extern] = ACTIONS(4963),
    [anon_sym___attribute__] = ACTIONS(4963),
    [anon_sym___attribute] = ACTIONS(4963),
    [anon_sym_COLON_COLON] = ACTIONS(4961),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(4961),
    [anon_sym___declspec] = ACTIONS(4963),
    [anon_sym___based] = ACTIONS(4963),
    [anon_sym___cdecl] = ACTIONS(4963),
    [anon_sym___clrcall] = ACTIONS(4963),
    [anon_sym___stdcall] = ACTIONS(4963),
    [anon_sym___fastcall] = ACTIONS(4963),
    [anon_sym___thiscall] = ACTIONS(4963),
    [anon_sym___vectorcall] = ACTIONS(4963),
    [anon_sym_LBRACE] = ACTIONS(4961),
    [anon_sym_signed] = ACTIONS(6230),
    [anon_sym_unsigned] = ACTIONS(6230),
    [anon_sym_long] = ACTIONS(6230),
    [anon_sym_short] = ACTIONS(6230),
    [anon_sym_LBRACK] = ACTIONS(4963),
    [anon_sym_static] = ACTIONS(4963),
    [anon_sym_EQ] = ACTIONS(4961),
    [anon_sym_register] = ACTIONS(4963),
    [anon_sym_inline] = ACTIONS(4963),
    [anon_sym___inline] = ACTIONS(4963),
    [anon_sym___inline__] = ACTIONS(4963),
    [anon_sym___forceinline] = ACTIONS(4963),
    [anon_sym_thread_local] = ACTIONS(4963),
    [anon_sym___thread] = ACTIONS(4963),
    [anon_sym_const] = ACTIONS(6227),
    [anon_sym_constexpr] = ACTIONS(6227),
    [anon_sym_volatile] = ACTIONS(6227),
    [anon_sym_restrict] = ACTIONS(6227),
    [anon_sym___restrict__] = ACTIONS(6227),
    [anon_sym__Atomic] = ACTIONS(6227),
    [anon_sym__Noreturn] = ACTIONS(6227),
    [anon_sym_noreturn] = ACTIONS(6227),
    [anon_sym__Nonnull] = ACTIONS(6227),
    [anon_sym_mutable] = ACTIONS(6227),
    [anon_sym_constinit] = ACTIONS(6227),
    [anon_sym_consteval] = ACTIONS(6227),
    [anon_sym_alignas] = ACTIONS(6232),
    [anon_sym__Alignas] = ACTIONS(6232),
    [sym_primitive_type] = ACTIONS(6235),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(4963),
    [anon_sym_decltype] = ACTIONS(4963),
    [anon_sym_template] = ACTIONS(4963),
    [anon_sym_GT2] = ACTIONS(4961),
    [anon_sym_operator] = ACTIONS(4963),
  },
  [2309] = {
    [sym_attribute_specifier] = STATE(1849),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5982),
    [anon_sym_COMMA] = ACTIONS(5982),
    [anon_sym_RPAREN] = ACTIONS(5982),
    [anon_sym_LPAREN2] = ACTIONS(5982),
    [anon_sym_DASH] = ACTIONS(5980),
    [anon_sym_PLUS] = ACTIONS(5980),
    [anon_sym_STAR] = ACTIONS(5982),
    [anon_sym_SLASH] = ACTIONS(5980),
    [anon_sym_PERCENT] = ACTIONS(5982),
    [anon_sym_PIPE_PIPE] = ACTIONS(5982),
    [anon_sym_AMP_AMP] = ACTIONS(5982),
    [anon_sym_PIPE] = ACTIONS(5980),
    [anon_sym_CARET] = ACTIONS(5982),
    [anon_sym_AMP] = ACTIONS(5980),
    [anon_sym_EQ_EQ] = ACTIONS(5982),
    [anon_sym_BANG_EQ] = ACTIONS(5982),
    [anon_sym_GT] = ACTIONS(5980),
    [anon_sym_GT_EQ] = ACTIONS(5982),
    [anon_sym_LT_EQ] = ACTIONS(5980),
    [anon_sym_LT] = ACTIONS(5980),
    [anon_sym_LT_LT] = ACTIONS(5982),
    [anon_sym_GT_GT] = ACTIONS(5982),
    [anon_sym_SEMI] = ACTIONS(5982),
    [anon_sym___extension__] = ACTIONS(5982),
    [anon_sym___attribute__] = ACTIONS(5874),
    [anon_sym___attribute] = ACTIONS(5876),
    [anon_sym_LBRACE] = ACTIONS(5982),
    [anon_sym_RBRACE] = ACTIONS(5982),
    [anon_sym_LBRACK] = ACTIONS(5982),
    [anon_sym_RBRACK] = ACTIONS(5982),
    [anon_sym_const] = ACTIONS(5980),
    [anon_sym_constexpr] = ACTIONS(5982),
    [anon_sym_volatile] = ACTIONS(5982),
    [anon_sym_restrict] = ACTIONS(5982),
    [anon_sym___restrict__] = ACTIONS(5982),
    [anon_sym__Atomic] = ACTIONS(5982),
    [anon_sym__Noreturn] = ACTIONS(5982),
    [anon_sym_noreturn] = ACTIONS(5982),
    [anon_sym__Nonnull] = ACTIONS(5982),
    [anon_sym_mutable] = ACTIONS(5982),
    [anon_sym_constinit] = ACTIONS(5982),
    [anon_sym_consteval] = ACTIONS(5982),
    [anon_sym_alignas] = ACTIONS(5982),
    [anon_sym__Alignas] = ACTIONS(5982),
    [anon_sym_COLON] = ACTIONS(5982),
    [anon_sym_QMARK] = ACTIONS(5982),
    [anon_sym_LT_EQ_GT] = ACTIONS(5982),
    [anon_sym_or] = ACTIONS(5982),
    [anon_sym_and] = ACTIONS(5982),
    [anon_sym_bitor] = ACTIONS(5982),
    [anon_sym_xor] = ACTIONS(5982),
    [anon_sym_bitand] = ACTIONS(5982),
    [anon_sym_not_eq] = ACTIONS(5982),
    [anon_sym_DASH_DASH] = ACTIONS(5982),
    [anon_sym_PLUS_PLUS] = ACTIONS(5982),
    [anon_sym_DOT] = ACTIONS(5980),
    [anon_sym_DOT_STAR] = ACTIONS(5982),
    [anon_sym_DASH_GT] = ACTIONS(5982),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5982),
    [anon_sym_decltype] = ACTIONS(5982),
    [anon_sym_final] = ACTIONS(5982),
    [anon_sym_override] = ACTIONS(5982),
    [anon_sym_requires] = ACTIONS(5982),
  },
  [2310] = {
    [sym_string_literal] = STATE(2149),
    [sym_raw_string_literal] = STATE(2149),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5799),
    [anon_sym_COMMA] = ACTIONS(5799),
    [anon_sym_RPAREN] = ACTIONS(5799),
    [anon_sym_LPAREN2] = ACTIONS(5799),
    [anon_sym_DASH] = ACTIONS(5797),
    [anon_sym_PLUS] = ACTIONS(5797),
    [anon_sym_STAR] = ACTIONS(5797),
    [anon_sym_SLASH] = ACTIONS(5797),
    [anon_sym_PERCENT] = ACTIONS(5797),
    [anon_sym_PIPE_PIPE] = ACTIONS(5799),
    [anon_sym_AMP_AMP] = ACTIONS(5799),
    [anon_sym_PIPE] = ACTIONS(5797),
    [anon_sym_CARET] = ACTIONS(5797),
    [anon_sym_AMP] = ACTIONS(5797),
    [anon_sym_EQ_EQ] = ACTIONS(5799),
    [anon_sym_BANG_EQ] = ACTIONS(5799),
    [anon_sym_GT] = ACTIONS(5797),
    [anon_sym_GT_EQ] = ACTIONS(5799),
    [anon_sym_LT_EQ] = ACTIONS(5797),
    [anon_sym_LT] = ACTIONS(5797),
    [anon_sym_LT_LT] = ACTIONS(5797),
    [anon_sym_GT_GT] = ACTIONS(5797),
    [anon_sym_LBRACK] = ACTIONS(5799),
    [anon_sym_EQ] = ACTIONS(5797),
    [anon_sym_QMARK] = ACTIONS(5799),
    [anon_sym_STAR_EQ] = ACTIONS(5799),
    [anon_sym_SLASH_EQ] = ACTIONS(5799),
    [anon_sym_PERCENT_EQ] = ACTIONS(5799),
    [anon_sym_PLUS_EQ] = ACTIONS(5799),
    [anon_sym_DASH_EQ] = ACTIONS(5799),
    [anon_sym_LT_LT_EQ] = ACTIONS(5799),
    [anon_sym_GT_GT_EQ] = ACTIONS(5799),
    [anon_sym_AMP_EQ] = ACTIONS(5799),
    [anon_sym_CARET_EQ] = ACTIONS(5799),
    [anon_sym_PIPE_EQ] = ACTIONS(5799),
    [anon_sym_and_eq] = ACTIONS(5797),
    [anon_sym_or_eq] = ACTIONS(5797),
    [anon_sym_xor_eq] = ACTIONS(5797),
    [anon_sym_LT_EQ_GT] = ACTIONS(5799),
    [anon_sym_or] = ACTIONS(5797),
    [anon_sym_and] = ACTIONS(5797),
    [anon_sym_bitor] = ACTIONS(5797),
    [anon_sym_xor] = ACTIONS(5797),
    [anon_sym_bitand] = ACTIONS(5797),
    [anon_sym_not_eq] = ACTIONS(5797),
    [anon_sym_DASH_DASH] = ACTIONS(5799),
    [anon_sym_PLUS_PLUS] = ACTIONS(5799),
    [anon_sym_DOT] = ACTIONS(5797),
    [anon_sym_DOT_STAR] = ACTIONS(5799),
    [anon_sym_DASH_GT] = ACTIONS(5797),
    [anon_sym_L_DQUOTE] = ACTIONS(4899),
    [anon_sym_u_DQUOTE] = ACTIONS(4899),
    [anon_sym_U_DQUOTE] = ACTIONS(4899),
    [anon_sym_u8_DQUOTE] = ACTIONS(4899),
    [anon_sym_DQUOTE] = ACTIONS(4899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(4901),
    [anon_sym_LR_DQUOTE] = ACTIONS(4901),
    [anon_sym_uR_DQUOTE] = ACTIONS(4901),
    [anon_sym_UR_DQUOTE] = ACTIONS(4901),
    [anon_sym_u8R_DQUOTE] = ACTIONS(4901),
    [anon_sym_DASH_GT_STAR] = ACTIONS(5799),
    [sym_literal_suffix] = ACTIONS(5797),
  },
  [2311] = {
    [sym_attribute_specifier] = STATE(1823),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5915),
    [anon_sym_COMMA] = ACTIONS(5915),
    [anon_sym_RPAREN] = ACTIONS(5915),
    [anon_sym_LPAREN2] = ACTIONS(5915),
    [anon_sym_DASH] = ACTIONS(5913),
    [anon_sym_PLUS] = ACTIONS(5913),
    [anon_sym_STAR] = ACTIONS(5915),
    [anon_sym_SLASH] = ACTIONS(5913),
    [anon_sym_PERCENT] = ACTIONS(5915),
    [anon_sym_PIPE_PIPE] = ACTIONS(5915),
    [anon_sym_AMP_AMP] = ACTIONS(5915),
    [anon_sym_PIPE] = ACTIONS(5913),
    [anon_sym_CARET] = ACTIONS(5915),
    [anon_sym_AMP] = ACTIONS(5913),
    [anon_sym_EQ_EQ] = ACTIONS(5915),
    [anon_sym_BANG_EQ] = ACTIONS(5915),
    [anon_sym_GT] = ACTIONS(5913),
    [anon_sym_GT_EQ] = ACTIONS(5915),
    [anon_sym_LT_EQ] = ACTIONS(5913),
    [anon_sym_LT] = ACTIONS(5913),
    [anon_sym_LT_LT] = ACTIONS(5915),
    [anon_sym_GT_GT] = ACTIONS(5915),
    [anon_sym_SEMI] = ACTIONS(5915),
    [anon_sym___extension__] = ACTIONS(5915),
    [anon_sym___attribute__] = ACTIONS(5874),
    [anon_sym___attribute] = ACTIONS(5876),
    [anon_sym_LBRACE] = ACTIONS(5915),
    [anon_sym_RBRACE] = ACTIONS(5915),
    [anon_sym_LBRACK] = ACTIONS(5915),
    [anon_sym_RBRACK] = ACTIONS(5915),
    [anon_sym_const] = ACTIONS(5913),
    [anon_sym_constexpr] = ACTIONS(5915),
    [anon_sym_volatile] = ACTIONS(5915),
    [anon_sym_restrict] = ACTIONS(5915),
    [anon_sym___restrict__] = ACTIONS(5915),
    [anon_sym__Atomic] = ACTIONS(5915),
    [anon_sym__Noreturn] = ACTIONS(5915),
    [anon_sym_noreturn] = ACTIONS(5915),
    [anon_sym__Nonnull] = ACTIONS(5915),
    [anon_sym_mutable] = ACTIONS(5915),
    [anon_sym_constinit] = ACTIONS(5915),
    [anon_sym_consteval] = ACTIONS(5915),
    [anon_sym_alignas] = ACTIONS(5915),
    [anon_sym__Alignas] = ACTIONS(5915),
    [anon_sym_COLON] = ACTIONS(5915),
    [anon_sym_QMARK] = ACTIONS(5915),
    [anon_sym_LT_EQ_GT] = ACTIONS(5915),
    [anon_sym_or] = ACTIONS(5915),
    [anon_sym_and] = ACTIONS(5915),
    [anon_sym_bitor] = ACTIONS(5915),
    [anon_sym_xor] = ACTIONS(5915),
    [anon_sym_bitand] = ACTIONS(5915),
    [anon_sym_not_eq] = ACTIONS(5915),
    [anon_sym_DASH_DASH] = ACTIONS(5915),
    [anon_sym_PLUS_PLUS] = ACTIONS(5915),
    [anon_sym_DOT] = ACTIONS(5913),
    [anon_sym_DOT_STAR] = ACTIONS(5915),
    [anon_sym_DASH_GT] = ACTIONS(5915),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5915),
    [anon_sym_decltype] = ACTIONS(5915),
    [anon_sym_final] = ACTIONS(5915),
    [anon_sym_override] = ACTIONS(5915),
    [anon_sym_requires] = ACTIONS(5915),
  },
  [2312] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2315),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5801),
    [anon_sym_COMMA] = ACTIONS(5801),
    [anon_sym_LPAREN2] = ACTIONS(5801),
    [anon_sym_DASH] = ACTIONS(5803),
    [anon_sym_PLUS] = ACTIONS(5803),
    [anon_sym_STAR] = ACTIONS(5801),
    [anon_sym_SLASH] = ACTIONS(5803),
    [anon_sym_PERCENT] = ACTIONS(5801),
    [anon_sym_PIPE_PIPE] = ACTIONS(5801),
    [anon_sym_AMP_AMP] = ACTIONS(5801),
    [anon_sym_PIPE] = ACTIONS(5803),
    [anon_sym_CARET] = ACTIONS(5801),
    [anon_sym_AMP] = ACTIONS(5803),
    [anon_sym_EQ_EQ] = ACTIONS(5801),
    [anon_sym_BANG_EQ] = ACTIONS(5801),
    [anon_sym_GT] = ACTIONS(5803),
    [anon_sym_GT_EQ] = ACTIONS(5803),
    [anon_sym_LT_EQ] = ACTIONS(5803),
    [anon_sym_LT] = ACTIONS(5803),
    [anon_sym_LT_LT] = ACTIONS(5801),
    [anon_sym_GT_GT] = ACTIONS(5803),
    [anon_sym___extension__] = ACTIONS(5801),
    [anon_sym___attribute__] = ACTIONS(5801),
    [anon_sym___attribute] = ACTIONS(5803),
    [anon_sym_LBRACE] = ACTIONS(5801),
    [anon_sym_signed] = ACTIONS(6237),
    [anon_sym_unsigned] = ACTIONS(6237),
    [anon_sym_long] = ACTIONS(6237),
    [anon_sym_short] = ACTIONS(6237),
    [anon_sym_LBRACK] = ACTIONS(5801),
    [anon_sym_const] = ACTIONS(5803),
    [anon_sym_constexpr] = ACTIONS(5801),
    [anon_sym_volatile] = ACTIONS(5801),
    [anon_sym_restrict] = ACTIONS(5801),
    [anon_sym___restrict__] = ACTIONS(5801),
    [anon_sym__Atomic] = ACTIONS(5801),
    [anon_sym__Noreturn] = ACTIONS(5801),
    [anon_sym_noreturn] = ACTIONS(5801),
    [anon_sym__Nonnull] = ACTIONS(5801),
    [anon_sym_mutable] = ACTIONS(5801),
    [anon_sym_constinit] = ACTIONS(5801),
    [anon_sym_consteval] = ACTIONS(5801),
    [anon_sym_alignas] = ACTIONS(5801),
    [anon_sym__Alignas] = ACTIONS(5801),
    [anon_sym_QMARK] = ACTIONS(5801),
    [anon_sym_LT_EQ_GT] = ACTIONS(5801),
    [anon_sym_or] = ACTIONS(5801),
    [anon_sym_and] = ACTIONS(5801),
    [anon_sym_bitor] = ACTIONS(5801),
    [anon_sym_xor] = ACTIONS(5801),
    [anon_sym_bitand] = ACTIONS(5801),
    [anon_sym_not_eq] = ACTIONS(5801),
    [anon_sym_DASH_DASH] = ACTIONS(5801),
    [anon_sym_PLUS_PLUS] = ACTIONS(5801),
    [anon_sym_DOT] = ACTIONS(5803),
    [anon_sym_DOT_STAR] = ACTIONS(5801),
    [anon_sym_DASH_GT] = ACTIONS(5801),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5801),
    [anon_sym_decltype] = ACTIONS(5801),
    [anon_sym_final] = ACTIONS(5801),
    [anon_sym_override] = ACTIONS(5801),
    [anon_sym_GT2] = ACTIONS(5801),
    [anon_sym_requires] = ACTIONS(5801),
  },
  [2313] = {
    [sym_attribute_specifier] = STATE(1852),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5919),
    [anon_sym_COMMA] = ACTIONS(5919),
    [anon_sym_RPAREN] = ACTIONS(5919),
    [anon_sym_LPAREN2] = ACTIONS(5919),
    [anon_sym_DASH] = ACTIONS(5917),
    [anon_sym_PLUS] = ACTIONS(5917),
    [anon_sym_STAR] = ACTIONS(5919),
    [anon_sym_SLASH] = ACTIONS(5917),
    [anon_sym_PERCENT] = ACTIONS(5919),
    [anon_sym_PIPE_PIPE] = ACTIONS(5919),
    [anon_sym_AMP_AMP] = ACTIONS(5919),
    [anon_sym_PIPE] = ACTIONS(5917),
    [anon_sym_CARET] = ACTIONS(5919),
    [anon_sym_AMP] = ACTIONS(5917),
    [anon_sym_EQ_EQ] = ACTIONS(5919),
    [anon_sym_BANG_EQ] = ACTIONS(5919),
    [anon_sym_GT] = ACTIONS(5917),
    [anon_sym_GT_EQ] = ACTIONS(5919),
    [anon_sym_LT_EQ] = ACTIONS(5917),
    [anon_sym_LT] = ACTIONS(5917),
    [anon_sym_LT_LT] = ACTIONS(5919),
    [anon_sym_GT_GT] = ACTIONS(5919),
    [anon_sym_SEMI] = ACTIONS(5919),
    [anon_sym___extension__] = ACTIONS(5919),
    [anon_sym___attribute__] = ACTIONS(5874),
    [anon_sym___attribute] = ACTIONS(5876),
    [anon_sym_LBRACE] = ACTIONS(5919),
    [anon_sym_RBRACE] = ACTIONS(5919),
    [anon_sym_LBRACK] = ACTIONS(5919),
    [anon_sym_RBRACK] = ACTIONS(5919),
    [anon_sym_const] = ACTIONS(5917),
    [anon_sym_constexpr] = ACTIONS(5919),
    [anon_sym_volatile] = ACTIONS(5919),
    [anon_sym_restrict] = ACTIONS(5919),
    [anon_sym___restrict__] = ACTIONS(5919),
    [anon_sym__Atomic] = ACTIONS(5919),
    [anon_sym__Noreturn] = ACTIONS(5919),
    [anon_sym_noreturn] = ACTIONS(5919),
    [anon_sym__Nonnull] = ACTIONS(5919),
    [anon_sym_mutable] = ACTIONS(5919),
    [anon_sym_constinit] = ACTIONS(5919),
    [anon_sym_consteval] = ACTIONS(5919),
    [anon_sym_alignas] = ACTIONS(5919),
    [anon_sym__Alignas] = ACTIONS(5919),
    [anon_sym_COLON] = ACTIONS(5919),
    [anon_sym_QMARK] = ACTIONS(5919),
    [anon_sym_LT_EQ_GT] = ACTIONS(5919),
    [anon_sym_or] = ACTIONS(5919),
    [anon_sym_and] = ACTIONS(5919),
    [anon_sym_bitor] = ACTIONS(5919),
    [anon_sym_xor] = ACTIONS(5919),
    [anon_sym_bitand] = ACTIONS(5919),
    [anon_sym_not_eq] = ACTIONS(5919),
    [anon_sym_DASH_DASH] = ACTIONS(5919),
    [anon_sym_PLUS_PLUS] = ACTIONS(5919),
    [anon_sym_DOT] = ACTIONS(5917),
    [anon_sym_DOT_STAR] = ACTIONS(5919),
    [anon_sym_DASH_GT] = ACTIONS(5919),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5919),
    [anon_sym_decltype] = ACTIONS(5919),
    [anon_sym_final] = ACTIONS(5919),
    [anon_sym_override] = ACTIONS(5919),
    [anon_sym_requires] = ACTIONS(5919),
  },
  [2314] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2298),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5744),
    [anon_sym_COMMA] = ACTIONS(5744),
    [anon_sym_LPAREN2] = ACTIONS(5744),
    [anon_sym_DASH] = ACTIONS(5746),
    [anon_sym_PLUS] = ACTIONS(5746),
    [anon_sym_STAR] = ACTIONS(5744),
    [anon_sym_SLASH] = ACTIONS(5746),
    [anon_sym_PERCENT] = ACTIONS(5744),
    [anon_sym_PIPE_PIPE] = ACTIONS(5744),
    [anon_sym_AMP_AMP] = ACTIONS(5744),
    [anon_sym_PIPE] = ACTIONS(5746),
    [anon_sym_CARET] = ACTIONS(5744),
    [anon_sym_AMP] = ACTIONS(5746),
    [anon_sym_EQ_EQ] = ACTIONS(5744),
    [anon_sym_BANG_EQ] = ACTIONS(5744),
    [anon_sym_GT] = ACTIONS(5746),
    [anon_sym_GT_EQ] = ACTIONS(5746),
    [anon_sym_LT_EQ] = ACTIONS(5746),
    [anon_sym_LT] = ACTIONS(5746),
    [anon_sym_LT_LT] = ACTIONS(5744),
    [anon_sym_GT_GT] = ACTIONS(5746),
    [anon_sym___extension__] = ACTIONS(5744),
    [anon_sym___attribute__] = ACTIONS(5744),
    [anon_sym___attribute] = ACTIONS(5746),
    [anon_sym_LBRACE] = ACTIONS(5744),
    [anon_sym_signed] = ACTIONS(6239),
    [anon_sym_unsigned] = ACTIONS(6239),
    [anon_sym_long] = ACTIONS(6239),
    [anon_sym_short] = ACTIONS(6239),
    [anon_sym_LBRACK] = ACTIONS(5744),
    [anon_sym_const] = ACTIONS(5746),
    [anon_sym_constexpr] = ACTIONS(5744),
    [anon_sym_volatile] = ACTIONS(5744),
    [anon_sym_restrict] = ACTIONS(5744),
    [anon_sym___restrict__] = ACTIONS(5744),
    [anon_sym__Atomic] = ACTIONS(5744),
    [anon_sym__Noreturn] = ACTIONS(5744),
    [anon_sym_noreturn] = ACTIONS(5744),
    [anon_sym__Nonnull] = ACTIONS(5744),
    [anon_sym_mutable] = ACTIONS(5744),
    [anon_sym_constinit] = ACTIONS(5744),
    [anon_sym_consteval] = ACTIONS(5744),
    [anon_sym_alignas] = ACTIONS(5744),
    [anon_sym__Alignas] = ACTIONS(5744),
    [anon_sym_QMARK] = ACTIONS(5744),
    [anon_sym_LT_EQ_GT] = ACTIONS(5744),
    [anon_sym_or] = ACTIONS(5744),
    [anon_sym_and] = ACTIONS(5744),
    [anon_sym_bitor] = ACTIONS(5744),
    [anon_sym_xor] = ACTIONS(5744),
    [anon_sym_bitand] = ACTIONS(5744),
    [anon_sym_not_eq] = ACTIONS(5744),
    [anon_sym_DASH_DASH] = ACTIONS(5744),
    [anon_sym_PLUS_PLUS] = ACTIONS(5744),
    [anon_sym_DOT] = ACTIONS(5746),
    [anon_sym_DOT_STAR] = ACTIONS(5744),
    [anon_sym_DASH_GT] = ACTIONS(5744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5744),
    [anon_sym_decltype] = ACTIONS(5744),
    [anon_sym_final] = ACTIONS(5744),
    [anon_sym_override] = ACTIONS(5744),
    [anon_sym_GT2] = ACTIONS(5744),
    [anon_sym_requires] = ACTIONS(5744),
  },
  [2315] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2146),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5793),
    [anon_sym_COMMA] = ACTIONS(5793),
    [anon_sym_LPAREN2] = ACTIONS(5793),
    [anon_sym_DASH] = ACTIONS(5795),
    [anon_sym_PLUS] = ACTIONS(5795),
    [anon_sym_STAR] = ACTIONS(5793),
    [anon_sym_SLASH] = ACTIONS(5795),
    [anon_sym_PERCENT] = ACTIONS(5793),
    [anon_sym_PIPE_PIPE] = ACTIONS(5793),
    [anon_sym_AMP_AMP] = ACTIONS(5793),
    [anon_sym_PIPE] = ACTIONS(5795),
    [anon_sym_CARET] = ACTIONS(5793),
    [anon_sym_AMP] = ACTIONS(5795),
    [anon_sym_EQ_EQ] = ACTIONS(5793),
    [anon_sym_BANG_EQ] = ACTIONS(5793),
    [anon_sym_GT] = ACTIONS(5795),
    [anon_sym_GT_EQ] = ACTIONS(5795),
    [anon_sym_LT_EQ] = ACTIONS(5795),
    [anon_sym_LT] = ACTIONS(5795),
    [anon_sym_LT_LT] = ACTIONS(5793),
    [anon_sym_GT_GT] = ACTIONS(5795),
    [anon_sym___extension__] = ACTIONS(5793),
    [anon_sym___attribute__] = ACTIONS(5793),
    [anon_sym___attribute] = ACTIONS(5795),
    [anon_sym_LBRACE] = ACTIONS(5793),
    [anon_sym_signed] = ACTIONS(6159),
    [anon_sym_unsigned] = ACTIONS(6159),
    [anon_sym_long] = ACTIONS(6159),
    [anon_sym_short] = ACTIONS(6159),
    [anon_sym_LBRACK] = ACTIONS(5793),
    [anon_sym_const] = ACTIONS(5795),
    [anon_sym_constexpr] = ACTIONS(5793),
    [anon_sym_volatile] = ACTIONS(5793),
    [anon_sym_restrict] = ACTIONS(5793),
    [anon_sym___restrict__] = ACTIONS(5793),
    [anon_sym__Atomic] = ACTIONS(5793),
    [anon_sym__Noreturn] = ACTIONS(5793),
    [anon_sym_noreturn] = ACTIONS(5793),
    [anon_sym__Nonnull] = ACTIONS(5793),
    [anon_sym_mutable] = ACTIONS(5793),
    [anon_sym_constinit] = ACTIONS(5793),
    [anon_sym_consteval] = ACTIONS(5793),
    [anon_sym_alignas] = ACTIONS(5793),
    [anon_sym__Alignas] = ACTIONS(5793),
    [anon_sym_QMARK] = ACTIONS(5793),
    [anon_sym_LT_EQ_GT] = ACTIONS(5793),
    [anon_sym_or] = ACTIONS(5793),
    [anon_sym_and] = ACTIONS(5793),
    [anon_sym_bitor] = ACTIONS(5793),
    [anon_sym_xor] = ACTIONS(5793),
    [anon_sym_bitand] = ACTIONS(5793),
    [anon_sym_not_eq] = ACTIONS(5793),
    [anon_sym_DASH_DASH] = ACTIONS(5793),
    [anon_sym_PLUS_PLUS] = ACTIONS(5793),
    [anon_sym_DOT] = ACTIONS(5795),
    [anon_sym_DOT_STAR] = ACTIONS(5793),
    [anon_sym_DASH_GT] = ACTIONS(5793),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5793),
    [anon_sym_decltype] = ACTIONS(5793),
    [anon_sym_final] = ACTIONS(5793),
    [anon_sym_override] = ACTIONS(5793),
    [anon_sym_GT2] = ACTIONS(5793),
    [anon_sym_requires] = ACTIONS(5793),
  },
  [2316] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2274),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5801),
    [anon_sym_COMMA] = ACTIONS(5801),
    [anon_sym_RPAREN] = ACTIONS(5801),
    [anon_sym_LPAREN2] = ACTIONS(5801),
    [anon_sym_DASH] = ACTIONS(5803),
    [anon_sym_PLUS] = ACTIONS(5803),
    [anon_sym_STAR] = ACTIONS(5803),
    [anon_sym_SLASH] = ACTIONS(5803),
    [anon_sym_PERCENT] = ACTIONS(5803),
    [anon_sym_PIPE_PIPE] = ACTIONS(5801),
    [anon_sym_AMP_AMP] = ACTIONS(5801),
    [anon_sym_PIPE] = ACTIONS(5803),
    [anon_sym_CARET] = ACTIONS(5803),
    [anon_sym_AMP] = ACTIONS(5803),
    [anon_sym_EQ_EQ] = ACTIONS(5801),
    [anon_sym_BANG_EQ] = ACTIONS(5801),
    [anon_sym_GT] = ACTIONS(5803),
    [anon_sym_GT_EQ] = ACTIONS(5801),
    [anon_sym_LT_EQ] = ACTIONS(5803),
    [anon_sym_LT] = ACTIONS(5803),
    [anon_sym_LT_LT] = ACTIONS(5803),
    [anon_sym_GT_GT] = ACTIONS(5803),
    [anon_sym_SEMI] = ACTIONS(5801),
    [anon_sym___attribute__] = ACTIONS(5801),
    [anon_sym___attribute] = ACTIONS(5803),
    [anon_sym_LBRACE] = ACTIONS(5801),
    [anon_sym_RBRACE] = ACTIONS(5801),
    [anon_sym_signed] = ACTIONS(6241),
    [anon_sym_unsigned] = ACTIONS(6241),
    [anon_sym_long] = ACTIONS(6241),
    [anon_sym_short] = ACTIONS(6241),
    [anon_sym_LBRACK] = ACTIONS(5801),
    [anon_sym_RBRACK] = ACTIONS(5801),
    [anon_sym_EQ] = ACTIONS(5803),
    [anon_sym_COLON] = ACTIONS(5801),
    [anon_sym_QMARK] = ACTIONS(5801),
    [anon_sym_STAR_EQ] = ACTIONS(5801),
    [anon_sym_SLASH_EQ] = ACTIONS(5801),
    [anon_sym_PERCENT_EQ] = ACTIONS(5801),
    [anon_sym_PLUS_EQ] = ACTIONS(5801),
    [anon_sym_DASH_EQ] = ACTIONS(5801),
    [anon_sym_LT_LT_EQ] = ACTIONS(5801),
    [anon_sym_GT_GT_EQ] = ACTIONS(5801),
    [anon_sym_AMP_EQ] = ACTIONS(5801),
    [anon_sym_CARET_EQ] = ACTIONS(5801),
    [anon_sym_PIPE_EQ] = ACTIONS(5801),
    [anon_sym_and_eq] = ACTIONS(5801),
    [anon_sym_or_eq] = ACTIONS(5801),
    [anon_sym_xor_eq] = ACTIONS(5801),
    [anon_sym_LT_EQ_GT] = ACTIONS(5801),
    [anon_sym_or] = ACTIONS(5803),
    [anon_sym_and] = ACTIONS(5803),
    [anon_sym_bitor] = ACTIONS(5801),
    [anon_sym_xor] = ACTIONS(5803),
    [anon_sym_bitand] = ACTIONS(5801),
    [anon_sym_not_eq] = ACTIONS(5801),
    [anon_sym_DASH_DASH] = ACTIONS(5801),
    [anon_sym_PLUS_PLUS] = ACTIONS(5801),
    [anon_sym_DOT] = ACTIONS(5803),
    [anon_sym_DOT_STAR] = ACTIONS(5801),
    [anon_sym_DASH_GT] = ACTIONS(5801),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5801),
    [anon_sym_decltype] = ACTIONS(5801),
  },
  [2317] = {
    [aux_sym_sized_type_specifier_repeat1] = STATE(2275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5744),
    [anon_sym_COMMA] = ACTIONS(5744),
    [anon_sym_RPAREN] = ACTIONS(5744),
    [anon_sym_LPAREN2] = ACTIONS(5744),
    [anon_sym_DASH] = ACTIONS(5746),
    [anon_sym_PLUS] = ACTIONS(5746),
    [anon_sym_STAR] = ACTIONS(5746),
    [anon_sym_SLASH] = ACTIONS(5746),
    [anon_sym_PERCENT] = ACTIONS(5746),
    [anon_sym_PIPE_PIPE] = ACTIONS(5744),
    [anon_sym_AMP_AMP] = ACTIONS(5744),
    [anon_sym_PIPE] = ACTIONS(5746),
    [anon_sym_CARET] = ACTIONS(5746),
    [anon_sym_AMP] = ACTIONS(5746),
    [anon_sym_EQ_EQ] = ACTIONS(5744),
    [anon_sym_BANG_EQ] = ACTIONS(5744),
    [anon_sym_GT] = ACTIONS(5746),
    [anon_sym_GT_EQ] = ACTIONS(5744),
    [anon_sym_LT_EQ] = ACTIONS(5746),
    [anon_sym_LT] = ACTIONS(5746),
    [anon_sym_LT_LT] = ACTIONS(5746),
    [anon_sym_GT_GT] = ACTIONS(5746),
    [anon_sym_SEMI] = ACTIONS(5744),
    [anon_sym___attribute__] = ACTIONS(5744),
    [anon_sym___attribute] = ACTIONS(5746),
    [anon_sym_LBRACE] = ACTIONS(5744),
    [anon_sym_RBRACE] = ACTIONS(5744),
    [anon_sym_signed] = ACTIONS(6243),
    [anon_sym_unsigned] = ACTIONS(6243),
    [anon_sym_long] = ACTIONS(6243),
    [anon_sym_short] = ACTIONS(6243),
    [anon_sym_LBRACK] = ACTIONS(5744),
    [anon_sym_RBRACK] = ACTIONS(5744),
    [anon_sym_EQ] = ACTIONS(5746),
    [anon_sym_COLON] = ACTIONS(5744),
    [anon_sym_QMARK] = ACTIONS(5744),
    [anon_sym_STAR_EQ] = ACTIONS(5744),
    [anon_sym_SLASH_EQ] = ACTIONS(5744),
    [anon_sym_PERCENT_EQ] = ACTIONS(5744),
    [anon_sym_PLUS_EQ] = ACTIONS(5744),
    [anon_sym_DASH_EQ] = ACTIONS(5744),
    [anon_sym_LT_LT_EQ] = ACTIONS(5744),
    [anon_sym_GT_GT_EQ] = ACTIONS(5744),
    [anon_sym_AMP_EQ] = ACTIONS(5744),
    [anon_sym_CARET_EQ] = ACTIONS(5744),
    [anon_sym_PIPE_EQ] = ACTIONS(5744),
    [anon_sym_and_eq] = ACTIONS(5744),
    [anon_sym_or_eq] = ACTIONS(5744),
    [anon_sym_xor_eq] = ACTIONS(5744),
    [anon_sym_LT_EQ_GT] = ACTIONS(5744),
    [anon_sym_or] = ACTIONS(5746),
    [anon_sym_and] = ACTIONS(5746),
    [anon_sym_bitor] = ACTIONS(5744),
    [anon_sym_xor] = ACTIONS(5746),
    [anon_sym_bitand] = ACTIONS(5744),
    [anon_sym_not_eq] = ACTIONS(5744),
    [anon_sym_DASH_DASH] = ACTIONS(5744),
    [anon_sym_PLUS_PLUS] = ACTIONS(5744),
    [anon_sym_DOT] = ACTIONS(5746),
    [anon_sym_DOT_STAR] = ACTIONS(5744),
    [anon_sym_DASH_GT] = ACTIONS(5744),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5744),
    [anon_sym_decltype] = ACTIONS(5744),
  },
  [2318] = {
    [sym_attribute_specifier] = STATE(1812),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5988),
    [anon_sym_COMMA] = ACTIONS(5988),
    [anon_sym_RPAREN] = ACTIONS(5988),
    [anon_sym_LPAREN2] = ACTIONS(5988),
    [anon_sym_DASH] = ACTIONS(5986),
    [anon_sym_PLUS] = ACTIONS(5986),
    [anon_sym_STAR] = ACTIONS(5988),
    [anon_sym_SLASH] = ACTIONS(5986),
    [anon_sym_PERCENT] = ACTIONS(5988),
    [anon_sym_PIPE_PIPE] = ACTIONS(5988),
    [anon_sym_AMP_AMP] = ACTIONS(5988),
    [anon_sym_PIPE] = ACTIONS(5986),
    [anon_sym_CARET] = ACTIONS(5988),
    [anon_sym_AMP] = ACTIONS(5986),
    [anon_sym_EQ_EQ] = ACTIONS(5988),
    [anon_sym_BANG_EQ] = ACTIONS(5988),
    [anon_sym_GT] = ACTIONS(5986),
    [anon_sym_GT_EQ] = ACTIONS(5988),
    [anon_sym_LT_EQ] = ACTIONS(5986),
    [anon_sym_LT] = ACTIONS(5986),
    [anon_sym_LT_LT] = ACTIONS(5988),
    [anon_sym_GT_GT] = ACTIONS(5988),
    [anon_sym_SEMI] = ACTIONS(5988),
    [anon_sym___extension__] = ACTIONS(5988),
    [anon_sym___attribute__] = ACTIONS(5874),
    [anon_sym___attribute] = ACTIONS(5876),
    [anon_sym_LBRACE] = ACTIONS(5988),
    [anon_sym_RBRACE] = ACTIONS(5988),
    [anon_sym_LBRACK] = ACTIONS(5988),
    [anon_sym_RBRACK] = ACTIONS(5988),
    [anon_sym_const] = ACTIONS(5986),
    [anon_sym_constexpr] = ACTIONS(5988),
    [anon_sym_volatile] = ACTIONS(5988),
    [anon_sym_restrict] = ACTIONS(5988),
    [anon_sym___restrict__] = ACTIONS(5988),
    [anon_sym__Atomic] = ACTIONS(5988),
    [anon_sym__Noreturn] = ACTIONS(5988),
    [anon_sym_noreturn] = ACTIONS(5988),
    [anon_sym__Nonnull] = ACTIONS(5988),
    [anon_sym_mutable] = ACTIONS(5988),
    [anon_sym_constinit] = ACTIONS(5988),
    [anon_sym_consteval] = ACTIONS(5988),
    [anon_sym_alignas] = ACTIONS(5988),
    [anon_sym__Alignas] = ACTIONS(5988),
    [anon_sym_COLON] = ACTIONS(5988),
    [anon_sym_QMARK] = ACTIONS(5988),
    [anon_sym_LT_EQ_GT] = ACTIONS(5988),
    [anon_sym_or] = ACTIONS(5988),
    [anon_sym_and] = ACTIONS(5988),
    [anon_sym_bitor] = ACTIONS(5988),
    [anon_sym_xor] = ACTIONS(5988),
    [anon_sym_bitand] = ACTIONS(5988),
    [anon_sym_not_eq] = ACTIONS(5988),
    [anon_sym_DASH_DASH] = ACTIONS(5988),
    [anon_sym_PLUS_PLUS] = ACTIONS(5988),
    [anon_sym_DOT] = ACTIONS(5986),
    [anon_sym_DOT_STAR] = ACTIONS(5988),
    [anon_sym_DASH_GT] = ACTIONS(5988),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5988),
    [anon_sym_decltype] = ACTIONS(5988),
    [anon_sym_final] = ACTIONS(5988),
    [anon_sym_override] = ACTIONS(5988),
    [anon_sym_requires] = ACTIONS(5988),
  },
  [2319] = {
    [sym_attribute_specifier] = STATE(1816),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5992),
    [anon_sym_COMMA] = ACTIONS(5992),
    [anon_sym_RPAREN] = ACTIONS(5992),
    [anon_sym_LPAREN2] = ACTIONS(5992),
    [anon_sym_DASH] = ACTIONS(5990),
    [anon_sym_PLUS] = ACTIONS(5990),
    [anon_sym_STAR] = ACTIONS(5992),
    [anon_sym_SLASH] = ACTIONS(5990),
    [anon_sym_PERCENT] = ACTIONS(5992),
    [anon_sym_PIPE_PIPE] = ACTIONS(5992),
    [anon_sym_AMP_AMP] = ACTIONS(5992),
    [anon_sym_PIPE] = ACTIONS(5990),
    [anon_sym_CARET] = ACTIONS(5992),
    [anon_sym_AMP] = ACTIONS(5990),
    [anon_sym_EQ_EQ] = ACTIONS(5992),
    [anon_sym_BANG_EQ] = ACTIONS(5992),
    [anon_sym_GT] = ACTIONS(5990),
    [anon_sym_GT_EQ] = ACTIONS(5992),
    [anon_sym_LT_EQ] = ACTIONS(5990),
    [anon_sym_LT] = ACTIONS(5990),
    [anon_sym_LT_LT] = ACTIONS(5992),
    [anon_sym_GT_GT] = ACTIONS(5992),
    [anon_sym_SEMI] = ACTIONS(5992),
    [anon_sym___extension__] = ACTIONS(5992),
    [anon_sym___attribute__] = ACTIONS(5874),
    [anon_sym___attribute] = ACTIONS(5876),
    [anon_sym_LBRACE] = ACTIONS(5992),
    [anon_sym_RBRACE] = ACTIONS(5992),
    [anon_sym_LBRACK] = ACTIONS(5992),
    [anon_sym_RBRACK] = ACTIONS(5992),
    [anon_sym_const] = ACTIONS(5990),
    [anon_sym_constexpr] = ACTIONS(5992),
    [anon_sym_volatile] = ACTIONS(5992),
    [anon_sym_restrict] = ACTIONS(5992),
    [anon_sym___restrict__] = ACTIONS(5992),
    [anon_sym__Atomic] = ACTIONS(5992),
    [anon_sym__Noreturn] = ACTIONS(5992),
    [anon_sym_noreturn] = ACTIONS(5992),
    [anon_sym__Nonnull] = ACTIONS(5992),
    [anon_sym_mutable] = ACTIONS(5992),
    [anon_sym_constinit] = ACTIONS(5992),
    [anon_sym_consteval] = ACTIONS(5992),
    [anon_sym_alignas] = ACTIONS(5992),
    [anon_sym__Alignas] = ACTIONS(5992),
    [anon_sym_COLON] = ACTIONS(5992),
    [anon_sym_QMARK] = ACTIONS(5992),
    [anon_sym_LT_EQ_GT] = ACTIONS(5992),
    [anon_sym_or] = ACTIONS(5992),
    [anon_sym_and] = ACTIONS(5992),
    [anon_sym_bitor] = ACTIONS(5992),
    [anon_sym_xor] = ACTIONS(5992),
    [anon_sym_bitand] = ACTIONS(5992),
    [anon_sym_not_eq] = ACTIONS(5992),
    [anon_sym_DASH_DASH] = ACTIONS(5992),
    [anon_sym_PLUS_PLUS] = ACTIONS(5992),
    [anon_sym_DOT] = ACTIONS(5990),
    [anon_sym_DOT_STAR] = ACTIONS(5992),
    [anon_sym_DASH_GT] = ACTIONS(5992),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(5992),
    [anon_sym_decltype] = ACTIONS(5992),
    [anon_sym_final] = ACTIONS(5992),
    [anon_sym_override] = ACTIONS(5992),
    [anon_sym_requires] = ACTIONS(5992),
  },
  [2320] = {
    [sym_attribute_specifier] = STATE(2194),
    [sym_enumerator_list] = STATE(2123),
    [sym__enum_base_clause] = STATE(1962),
    [sym_identifier] = ACTIONS(6245),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6247),
    [anon_sym_COMMA] = ACTIONS(6247),
    [aux_sym_preproc_if_token2] = ACTIONS(6247),
    [aux_sym_preproc_else_token1] = ACTIONS(6247),
    [aux_sym_preproc_elif_token1] = ACTIONS(6245),
    [aux_sym_preproc_elifdef_token1] = ACTIONS(6247),
    [aux_sym_preproc_elifdef_token2] = ACTIONS(6247),
    [anon_sym_LPAREN2] = ACTIONS(6247),
    [anon_sym_DASH] = ACTIONS(6245),
    [anon_sym_PLUS] = ACTIONS(6245),
    [anon_sym_STAR] = ACTIONS(6245),
    [anon_sym_SLASH] = ACTIONS(6245),
    [anon_sym_PERCENT] = ACTIONS(6245),
    [anon_sym_PIPE_PIPE] = ACTIONS(6247),
    [anon_sym_AMP_AMP] = ACTIONS(6247),
    [anon_sym_PIPE] = ACTIONS(6245),
    [anon_sym_CARET] = ACTIONS(6245),
    [anon_sym_AMP] = ACTIONS(6245),
    [anon_sym_EQ_EQ] = ACTIONS(6247),
    [anon_sym_BANG_EQ] = ACTIONS(6247),
    [anon_sym_GT] = ACTIONS(6245),
    [anon_sym_GT_EQ] = ACTIONS(6247),
    [anon_sym_LT_EQ] = ACTIONS(6245),
    [anon_sym_LT] = ACTIONS(6245),
    [anon_sym_LT_LT] = ACTIONS(6245),
    [anon_sym_GT_GT] = ACTIONS(6245),
    [anon_sym___attribute__] = ACTIONS(5379),
    [anon_sym___attribute] = ACTIONS(5379),
    [anon_sym_LBRACE] = ACTIONS(5838),
    [anon_sym_LBRACK] = ACTIONS(6247),
    [anon_sym_EQ] = ACTIONS(6245),
    [anon_sym_COLON] = ACTIONS(6165),
    [anon_sym_QMARK] = ACTIONS(6247),
    [anon_sym_STAR_EQ] = ACTIONS(6247),
    [anon_sym_SLASH_EQ] = ACTIONS(6247),
    [anon_sym_PERCENT_EQ] = ACTIONS(6247),
    [anon_sym_PLUS_EQ] = ACTIONS(6247),
    [anon_sym_DASH_EQ] = ACTIONS(6247),
    [anon_sym_LT_LT_EQ] = ACTIONS(6247),
    [anon_sym_GT_GT_EQ] = ACTIONS(6247),
    [anon_sym_AMP_EQ] = ACTIONS(6247),
    [anon_sym_CARET_EQ] = ACTIONS(6247),
    [anon_sym_PIPE_EQ] = ACTIONS(6247),
    [anon_sym_and_eq] = ACTIONS(6245),
    [anon_sym_or_eq] = ACTIONS(6245),
    [anon_sym_xor_eq] = ACTIONS(6245),
    [anon_sym_LT_EQ_GT] = ACTIONS(6247),
    [anon_sym_or] = ACTIONS(6245),
    [anon_sym_and] = ACTIONS(6245),
    [anon_sym_bitor] = ACTIONS(6245),
    [anon_sym_xor] = ACTIONS(6245),
    [anon_sym_bitand] = ACTIONS(6245),
    [anon_sym_not_eq] = ACTIONS(6245),
    [anon_sym_DASH_DASH] = ACTIONS(6247),
    [anon_sym_PLUS_PLUS] = ACTIONS(6247),
    [anon_sym_DOT] = ACTIONS(6245),
    [anon_sym_DOT_STAR] = ACTIONS(6247),
    [anon_sym_DASH_GT] = ACTIONS(6247),
    [sym_comment] = ACTIONS(3),
    [sym_auto] = ACTIONS(6245),
    [anon_sym_decltype] = ACTIONS(6245),
  },
  [2321] = {
    [sym_identifier] = ACTIONS(5399),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5401),
    [anon_sym_COMMA] = ACTIONS(5401),
    [anon_sym_LPAREN2] = ACTIONS(5401),
    [anon_sym_DASH] = ACTIONS(5399),
    [anon_sym_PLUS] = ACTIONS(5399),
    [anon_sym_STAR] = ACTIONS(5399),
    [anon_sym_SLASH] = ACTIONS(5399),
    [anon_sym_PERCENT] = ACTIONS(5399),
    [anon_sym_PIPE_PIPE] = ACTIONS(5401),
    [anon_sym_AMP_AMP] = ACTIONS(5401),
    [anon_sym_PIPE] = ACTIONS(5399),
    [anon_sym_CARET] = ACTIONS(5399),
    [anon_sym_AMP] = ACTIONS(5399),
    [anon_sym_EQ_EQ] = ACTIONS(5401),
    [anon_sym_BANG_EQ] = ACTIONS(5401),
    [anon_sym_GT] = ACTIONS(5399),
    [anon_sym_GT_EQ] = ACTIONS(5401),
    [anon_sym_LT_EQ] = ACTIONS(5399),
    [anon_sym_LT] = ACTIONS(5399),
    [anon_sym_LT_LT] = ACTIONS(5399),
    [anon_sym_GT_GT] = ACTIONS(5399),
    [anon_sym_SEMI] = ACTIONS(5401),
    [anon_sym___attribute__] = ACTIONS(5399),
    [anon_sym___attribute] = ACTIONS(5399),
    [anon_sym_LBRACK] = ACTIONS(5401),
    [anon_sym_EQ] = ACTIONS(5399),
    [anon_sym_QMARK] = ACTIONS(5401),
    [anon_sym_STAR_EQ] = ACTIONS(5401),
    [anon_sym_SLASH_EQ] = ACTIONS(5401),
    [anon_sym_PERCENT_EQ] = ACTIONS(5401),
    [anon_sym_PLUS_EQ] = ACTIONS(5401),
    [anon_sym_DASH_EQ] = ACTIONS(5401),
    [anon_sym_LT_LT_EQ] = ACTIONS(5401),
    [anon_sym_GT_GT_EQ] = ACTIONS(5401),
    [anon_sym_AMP_EQ] = ACTIONS(5401),
    [anon_sym_CARET_EQ] = ACTIONS(5401),
    [anon_sym_PIPE_EQ] = ACTIONS(5401),
    [anon_sym_and_eq] = ACTIONS(5399),
    [anon_sym_or_eq] = ACTIONS(5399),
    [anon_sym_xor_eq] = ACTIONS(5399),
    [anon_sym_LT_EQ_GT] = ACTIONS(5401),
    [anon_sym_or] = ACTIONS(5399),
    [anon_sym_and] = ACTIONS(5399),
    [anon_sym_bitor] = ACTIONS(5399),
    [anon_sym_xor] = ACTIONS(5399),
    [anon_sym_bitand] = ACTIONS(5399),
    [anon_sym_not_eq] = ACTIONS(5399),
    [anon_sym_DASH_DASH] = ACTIONS(5401),
    [anon_sym_PLUS_PLUS] = ACTIONS(5401),
    [anon_sym_DOT] = ACTIONS(5399),
    [anon_sym_DOT_STAR] = ACTIONS(5401),
    [anon_sym_DASH_GT] = ACTIONS(5401),
    [anon_sym_L_DQUOTE] = ACTIONS(5401),
    [anon_sym_u_DQUOTE] = ACTIONS(5401),
    [anon_sym_U_DQUOTE] = ACTIONS(5401),
    [anon_sym_u8_DQUOTE] = ACTIONS(5401),
    [anon_sym_DQUOTE] = ACTIONS(5401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_R_DQUOTE] = ACTIONS(5401),
    [anon_sym_LR_DQUOTE] = ACTIONS(5401),
    [anon_sym_uR_DQUOTE] = ACTIONS(5401),
    [anon_sym_UR_DQUOTE] = ACTIONS(5401),
    [anon_sym_u8R_DQUOTE] = ACTIONS(5401),
    [sym_literal_suffix] = ACTIONS(5399),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5383), 1,
      anon_sym_COLON,
    ACTIONS(6249), 1,
      anon_sym___attribute__,
    ACTIONS(6251), 1,
      anon_sym___attribute,
    ACTIONS(6253), 1,
      anon_sym_LBRACE,
    STATE(2727), 1,
      sym_field_declaration_list,
    STATE(2956), 1,
      sym_attribute_specifier,
    STATE(6979), 1,
      sym_virtual_specifier,
    STATE(7640), 1,
      sym_base_class_clause,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5375), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5377), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [89] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6255), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6257), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [160] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6259), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6261), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [231] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6263), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6265), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
  [316] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6275), 1,
      sym_identifier,
    STATE(2366), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(4220), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(4222), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5276), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(5274), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [395] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6277), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6279), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [478] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6281), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6283), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
  [563] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    STATE(1570), 1,
      sym_template_argument_list,
    STATE(2527), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6285), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5842), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5844), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [642] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6289), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6287), 57,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_friend,
      anon_sym_using,
      anon_sym_concept,
      anon_sym_requires,
  [713] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6291), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6293), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [784] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6291), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6293), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [855] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6295), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6297), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [926] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5447), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5449), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [997] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6299), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6301), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [1068] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5365), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5433), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5431), 50,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [1141] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2166), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6035), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5431), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5433), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [1216] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5447), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5449), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [1287] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2146), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5973), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4932), 17,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(4981), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(4984), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_auto,
      anon_sym_decltype,
  [1364] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6303), 1,
      sym_identifier,
    STATE(2340), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(6306), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(6309), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5260), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(5258), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [1443] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6312), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6314), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [1514] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6316), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6318), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
  [1599] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5399), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5401), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [1670] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6324), 1,
      anon_sym_LT,
    STATE(2300), 1,
      sym_template_argument_list,
    ACTIONS(6320), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6322), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [1745] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6327), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6329), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [1816] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5387), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5389), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [1887] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6331), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6333), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
  [1972] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6335), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6337), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [2043] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6341), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6339), 57,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_friend,
      anon_sym_using,
      anon_sym_concept,
      anon_sym_requires,
  [2114] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3822), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(3824), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [2185] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6347), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(6343), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6345), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [2258] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6349), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6351), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
  [2343] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5387), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5389), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [2414] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5399), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5401), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [2485] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5454), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5456), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [2556] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6353), 1,
      sym_auto,
    ACTIONS(6355), 1,
      anon_sym_decltype,
    STATE(2454), 1,
      sym_decltype_auto,
    ACTIONS(5393), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5391), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [2633] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6353), 1,
      sym_auto,
    ACTIONS(6355), 1,
      anon_sym_decltype,
    ACTIONS(6361), 1,
      anon_sym_virtual,
    STATE(2454), 1,
      sym_decltype_auto,
    STATE(3049), 1,
      sym_alignas_qualifier,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2534), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(5333), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(6359), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6357), 12,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(5329), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [2728] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6363), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6365), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [2811] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6291), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6293), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [2882] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6369), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6367), 57,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_friend,
      anon_sym_using,
      anon_sym_concept,
      anon_sym_requires,
  [2953] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6371), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6373), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3024] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3818), 29,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(3820), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3095] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2248), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(6132), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(6134), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5799), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(5797), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
  [3172] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6353), 1,
      sym_auto,
    ACTIONS(6355), 1,
      anon_sym_decltype,
    ACTIONS(6379), 1,
      anon_sym_virtual,
    STATE(2454), 1,
      sym_decltype_auto,
    STATE(3049), 1,
      sym_alignas_qualifier,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2501), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(5333), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(6377), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6375), 12,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(5329), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [3267] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5373), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5371), 50,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [3338] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6381), 1,
      sym_identifier,
    STATE(2340), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(4220), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(4222), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5253), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(5251), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [3417] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5454), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5456), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [3488] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6343), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6345), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3558] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6383), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6385), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3628] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6387), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6389), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3698] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6391), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6393), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3768] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6395), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6397), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3838] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6399), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6401), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3908] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5126), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5128), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [3978] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5624), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5622), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [4048] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5399), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(5401), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [4118] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5130), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5132), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4188] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5602), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5600), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [4258] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5379), 1,
      anon_sym___attribute,
    ACTIONS(5838), 1,
      anon_sym_LBRACE,
    ACTIONS(6403), 1,
      anon_sym___attribute__,
    ACTIONS(6405), 1,
      anon_sym_COLON,
    STATE(1976), 1,
      sym__enum_base_clause,
    STATE(2147), 1,
      sym_enumerator_list,
    STATE(2228), 1,
      sym_attribute_specifier,
    ACTIONS(6161), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6163), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
  [4342] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6407), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6409), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4412] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6411), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6413), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4482] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6415), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6417), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4552] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5433), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5431), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [4622] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5387), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5389), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [4692] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5399), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5401), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [4762] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6419), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6421), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4832] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6423), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6425), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4902] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6427), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6429), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [4972] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5447), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(5449), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [5042] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5658), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5656), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [5112] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5118), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5120), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [5182] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6431), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6433), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [5252] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6435), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6437), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [5322] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5170), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5172), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [5392] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5142), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5144), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [5462] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6439), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6441), 1,
      anon_sym_and,
    ACTIONS(6057), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6059), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [5536] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5174), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5176), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [5606] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6443), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6445), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [5676] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5670), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5668), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [5746] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5447), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5449), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [5816] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5678), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5676), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [5886] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5454), 28,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5456), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [5956] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4840), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [6026] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4043), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4035), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [6096] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5146), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5148), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [6166] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5114), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5116), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [6236] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5150), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5152), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [6306] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6447), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6449), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [6376] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6407), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6409), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [6446] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4840), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [6516] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5646), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5644), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [6586] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5662), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5660), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [6656] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6451), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6453), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [6726] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6455), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6457), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [6796] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5666), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5664), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [6866] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5674), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5672), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [6936] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6459), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6461), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [7006] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5508), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5506), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [7076] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5531), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5529), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [7146] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5543), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5541), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [7216] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5654), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5652), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [7286] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6463), 1,
      anon_sym_LT,
    STATE(1570), 1,
      sym_template_argument_list,
    STATE(2551), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4061), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5844), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5842), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [7366] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5539), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5537), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [7436] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6439), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6441), 1,
      anon_sym_and,
    ACTIONS(6465), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6467), 1,
      anon_sym_or,
    ACTIONS(6092), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6094), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [7514] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4840), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [7584] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1913), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(1911), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [7654] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5547), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5545), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [7724] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5551), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5549), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [7794] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5594), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5592), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [7864] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5555), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5553), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [7934] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4840), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [8004] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5379), 1,
      anon_sym___attribute,
    ACTIONS(5838), 1,
      anon_sym_LBRACE,
    ACTIONS(6403), 1,
      anon_sym___attribute__,
    ACTIONS(6405), 1,
      anon_sym_COLON,
    STATE(1962), 1,
      sym__enum_base_clause,
    STATE(2123), 1,
      sym_enumerator_list,
    STATE(2194), 1,
      sym_attribute_specifier,
    ACTIONS(6245), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6247), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
  [8088] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6469), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6471), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [8158] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6473), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6475), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [8228] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6477), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6479), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [8298] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6481), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6483), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [8368] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1909), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(1907), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [8438] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4840), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [8508] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5134), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5136), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [8578] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5504), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5502), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [8648] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4840), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [8718] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5535), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5533), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [8788] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6485), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6487), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [8858] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5140), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [8928] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5166), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5168), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [8998] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6489), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6491), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [9068] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5512), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5510), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [9138] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5516), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5514), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [9208] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5566), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5564), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [9278] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6493), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6495), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [9348] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6497), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6499), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [9418] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5454), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(5456), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [9488] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6501), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6503), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [9558] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5628), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5626), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [9628] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5570), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5568), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [9698] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5650), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5648), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [9768] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6505), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6507), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [9838] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6509), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6511), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [9908] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6513), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6515), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [9978] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5580), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5578), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [10048] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5500), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5498), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [10118] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5598), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5596), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [10188] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5574), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5572), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [10258] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5632), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5630), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [10328] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5815), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5813), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [10398] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5682), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5680), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [10468] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6517), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6519), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [10538] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5500), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5498), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [10608] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6521), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6523), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [10678] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4043), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4035), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [10748] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5387), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(5389), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [10818] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5504), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5502), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [10888] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6525), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6527), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [10958] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5383), 1,
      anon_sym_COLON,
    ACTIONS(6529), 1,
      anon_sym___attribute__,
    ACTIONS(6531), 1,
      anon_sym___attribute,
    ACTIONS(6533), 1,
      anon_sym_LBRACE,
    STATE(2809), 1,
      sym_field_declaration_list,
    STATE(3094), 1,
      sym_attribute_specifier,
    STATE(6816), 1,
      sym_virtual_specifier,
    STATE(7483), 1,
      sym_base_class_clause,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5375), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5377), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [11046] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6535), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6537), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [11116] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6539), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6541), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [11186] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5504), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5502), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [11256] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6543), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6545), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [11326] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6547), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6549), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [11396] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6551), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6553), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [11466] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6555), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6557), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [11536] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6559), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6561), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [11606] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5305), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2721), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [11676] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    STATE(2448), 1,
      sym_attribute_specifier,
    STATE(2879), 1,
      sym_field_declaration_list,
    STATE(6974), 1,
      sym_virtual_specifier,
    STATE(7628), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5377), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5375), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [11762] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6567), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6569), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [11832] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6571), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6573), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [11902] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5122), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5124), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [11972] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3754), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(3750), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [12042] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5122), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5124), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [12112] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5122), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5124), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [12182] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    STATE(1570), 1,
      sym_template_argument_list,
    STATE(2603), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6575), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5842), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5844), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [12260] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5642), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5640), 49,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [12330] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6577), 28,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6579), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [12400] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2326), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(4220), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(4222), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5797), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(5799), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [12475] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4855), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(4862), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [12544] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4830), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(4832), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [12613] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6218), 1,
      anon_sym___attribute__,
    ACTIONS(6220), 1,
      anon_sym___attribute,
    ACTIONS(6581), 1,
      anon_sym_LBRACE,
    STATE(2540), 1,
      sym_enumerator_list,
    STATE(2605), 1,
      sym_attribute_specifier,
    ACTIONS(5834), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5836), 44,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [12692] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4834), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(4836), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [12761] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6583), 1,
      anon_sym_LT,
    STATE(2600), 1,
      sym_template_argument_list,
    ACTIONS(4838), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4845), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [12836] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4810), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(4812), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [12905] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6590), 1,
      anon_sym_virtual,
    STATE(3049), 1,
      sym_alignas_qualifier,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2511), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(5333), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(6588), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5329), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(6586), 13,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [12992] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6218), 1,
      anon_sym___attribute__,
    ACTIONS(6220), 1,
      anon_sym___attribute,
    ACTIONS(6581), 1,
      anon_sym_LBRACE,
    STATE(2555), 1,
      sym_enumerator_list,
    STATE(2622), 1,
      sym_attribute_specifier,
    ACTIONS(5848), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5850), 44,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [13071] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5447), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5449), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [13140] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6592), 1,
      anon_sym_LT,
    STATE(2600), 1,
      sym_template_argument_list,
    ACTIONS(5720), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4059), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [13215] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5454), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5456), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [13284] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1608), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6594), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5795), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5793), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [13357] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1608), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6594), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5782), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5780), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [13430] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2528), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6596), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5740), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5738), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [13503] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2531), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6598), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5762), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5760), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [13576] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1608), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6594), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5778), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5776), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [13649] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6607), 1,
      anon_sym_virtual,
    ACTIONS(6616), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6619), 1,
      anon_sym___declspec,
    STATE(3049), 1,
      sym_alignas_qualifier,
    ACTIONS(6613), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6622), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2511), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(6610), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(6602), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6600), 13,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(6604), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [13736] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_LBRACE,
    ACTIONS(6625), 1,
      anon_sym_LPAREN2,
    STATE(2409), 1,
      sym_argument_list,
    STATE(2545), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3793), 1,
      sym_initializer_list,
    ACTIONS(6628), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5433), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
    ACTIONS(5431), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [13817] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2514), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6630), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5545), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5547), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [13890] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1608), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6594), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5768), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5766), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [13963] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4814), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(4816), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [14032] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4826), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(4828), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [14101] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5365), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5361), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(5363), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [14172] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(4157), 1,
      anon_sym_LPAREN2,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(5700), 1,
      anon_sym_STAR,
    ACTIONS(5702), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5704), 1,
      anon_sym_AMP,
    ACTIONS(5708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5710), 1,
      anon_sym_LBRACK,
    STATE(3005), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5765), 1,
      sym__scope_resolution,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6275), 1,
      sym__declarator,
    STATE(6473), 1,
      sym__abstract_declarator,
    STATE(7915), 1,
      sym_ms_based_modifier,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5706), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(5698), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_GT2,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [14291] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(4157), 1,
      anon_sym_LPAREN2,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(5700), 1,
      anon_sym_STAR,
    ACTIONS(5702), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5704), 1,
      anon_sym_AMP,
    ACTIONS(5708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5710), 1,
      anon_sym_LBRACK,
    STATE(3005), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5765), 1,
      sym__scope_resolution,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6209), 1,
      sym__declarator,
    STATE(6474), 1,
      sym__abstract_declarator,
    STATE(7915), 1,
      sym_ms_based_modifier,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6634), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(6632), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_GT2,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [14410] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2506), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6636), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5803), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5801), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [14483] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5365), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5361), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(5363), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [14554] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2507), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6638), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5746), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5744), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [14627] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4818), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(4820), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [14696] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4822), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(4824), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [14765] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(5472), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [14834] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4932), 1,
      sym_primitive_type,
    STATE(1894), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5786), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4981), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4984), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [14909] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1608), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6594), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5791), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5789), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [14982] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1608), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6594), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5752), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5750), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [15055] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5387), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5389), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [15124] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5399), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5401), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [15193] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1608), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6594), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5758), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5756), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [15266] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5365), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5443), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(5445), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [15337] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6592), 1,
      anon_sym_LT,
    STATE(2527), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2600), 1,
      sym_template_argument_list,
    ACTIONS(6285), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4033), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4041), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [15416] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6590), 1,
      anon_sym_virtual,
    STATE(3049), 1,
      sym_alignas_qualifier,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2511), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(5333), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(6642), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5329), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(6640), 13,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [15503] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4820), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4818), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [15571] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6218), 1,
      anon_sym___attribute__,
    ACTIONS(6220), 1,
      anon_sym___attribute,
    STATE(2634), 1,
      sym_attribute_specifier,
    ACTIONS(5901), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5903), 45,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [15645] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4836), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4834), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [15713] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5383), 1,
      anon_sym_COLON,
    ACTIONS(6644), 1,
      anon_sym___attribute__,
    ACTIONS(6646), 1,
      anon_sym___attribute,
    ACTIONS(6648), 1,
      anon_sym_LBRACE,
    STATE(3022), 1,
      sym_field_declaration_list,
    STATE(3405), 1,
      sym_attribute_specifier,
    STATE(6982), 1,
      sym_virtual_specifier,
    STATE(7650), 1,
      sym_base_class_clause,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5375), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5377), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [15799] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6218), 1,
      anon_sym___attribute__,
    ACTIONS(6220), 1,
      anon_sym___attribute,
    STATE(2620), 1,
      sym_attribute_specifier,
    ACTIONS(5976), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5978), 45,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [15873] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6218), 1,
      anon_sym___attribute__,
    ACTIONS(6220), 1,
      anon_sym___attribute,
    STATE(2630), 1,
      sym_attribute_specifier,
    ACTIONS(5980), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5982), 45,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [15947] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6218), 1,
      anon_sym___attribute__,
    ACTIONS(6220), 1,
      anon_sym___attribute,
    STATE(2631), 1,
      sym_attribute_specifier,
    ACTIONS(5986), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5988), 45,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [16021] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6218), 1,
      anon_sym___attribute__,
    ACTIONS(6220), 1,
      anon_sym___attribute,
    STATE(2618), 1,
      sym_attribute_specifier,
    ACTIONS(5947), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5949), 45,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [16095] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6218), 1,
      anon_sym___attribute__,
    ACTIONS(6220), 1,
      anon_sym___attribute,
    STATE(2635), 1,
      sym_attribute_specifier,
    ACTIONS(5990), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5992), 45,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [16169] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5365), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5361), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5363), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [16239] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2574), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6650), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5766), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5768), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [16311] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6218), 1,
      anon_sym___attribute__,
    ACTIONS(6220), 1,
      anon_sym___attribute,
    STATE(2663), 1,
      sym_attribute_specifier,
    ACTIONS(5905), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5907), 45,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [16385] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6652), 1,
      sym_identifier,
    STATE(2547), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(6655), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(6658), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5260), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5258), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [16461] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2574), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6650), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5793), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5795), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [16533] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6249), 1,
      anon_sym___attribute__,
    ACTIONS(6251), 1,
      anon_sym___attribute,
    ACTIONS(6661), 1,
      anon_sym_LBRACE,
    ACTIONS(6663), 1,
      anon_sym_COLON,
    STATE(2672), 1,
      sym__enum_base_clause,
    STATE(2725), 1,
      sym_enumerator_list,
    STATE(3020), 1,
      sym_attribute_specifier,
    ACTIONS(6245), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6247), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [16615] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2574), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6650), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5780), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5782), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [16687] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2574), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6650), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5789), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5791), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [16759] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5447), 24,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5449), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [16827] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5472), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [16895] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2595), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6665), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5738), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5740), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [16967] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6218), 1,
      anon_sym___attribute__,
    ACTIONS(6220), 1,
      anon_sym___attribute,
    STATE(2652), 1,
      sym_attribute_specifier,
    ACTIONS(5951), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5953), 45,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [17041] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2599), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6667), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5760), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5762), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [17113] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6218), 1,
      anon_sym___attribute__,
    ACTIONS(6220), 1,
      anon_sym___attribute,
    STATE(2615), 1,
      sym_attribute_specifier,
    ACTIONS(5969), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5971), 45,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [17187] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6218), 1,
      anon_sym___attribute__,
    ACTIONS(6220), 1,
      anon_sym___attribute,
    STATE(2661), 1,
      sym_attribute_specifier,
    ACTIONS(5887), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5889), 45,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [17261] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6249), 1,
      anon_sym___attribute__,
    ACTIONS(6251), 1,
      anon_sym___attribute,
    ACTIONS(6661), 1,
      anon_sym_LBRACE,
    ACTIONS(6663), 1,
      anon_sym_COLON,
    STATE(2709), 1,
      sym__enum_base_clause,
    STATE(2793), 1,
      sym_enumerator_list,
    STATE(2981), 1,
      sym_attribute_specifier,
    ACTIONS(6161), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6163), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [17343] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5454), 24,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5456), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [17411] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2574), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6650), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5776), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5778), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [17483] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5365), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5443), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5445), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [17553] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5365), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5431), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5433), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [17623] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4828), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4826), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [17691] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4824), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4822), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [17759] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4832), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4830), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [17827] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6669), 1,
      anon_sym_LT,
    STATE(2603), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2604), 1,
      sym_template_argument_list,
    ACTIONS(6575), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4033), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4041), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [17905] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1618), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6671), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5768), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5766), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [17977] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6669), 1,
      anon_sym_LT,
    STATE(2604), 1,
      sym_template_argument_list,
    ACTIONS(5720), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4059), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [18051] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6673), 1,
      sym_identifier,
    STATE(2598), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(3474), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(3478), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5276), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5274), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [18127] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6675), 1,
      anon_sym_LT,
    STATE(2679), 1,
      sym_template_argument_list,
    ACTIONS(4059), 27,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5720), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [18201] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6218), 1,
      anon_sym___attribute__,
    ACTIONS(6220), 1,
      anon_sym___attribute,
    STATE(2617), 1,
      sym_attribute_specifier,
    ACTIONS(5913), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5915), 45,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [18275] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2579), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6677), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5803), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5801), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [18347] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2574), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6679), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4934), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4932), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [18419] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2548), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6682), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5801), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5803), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [18491] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2550), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6684), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5744), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5746), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [18563] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2580), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6686), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5746), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5744), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [18635] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6218), 1,
      anon_sym___attribute__,
    ACTIONS(6220), 1,
      anon_sym___attribute,
    STATE(2628), 1,
      sym_attribute_specifier,
    ACTIONS(5917), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5919), 45,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [18709] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1618), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6671), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5795), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5793), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [18781] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1618), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6671), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5782), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5780), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [18853] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2589), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6688), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5740), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5738), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [18925] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5387), 24,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5389), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [18993] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2545), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6628), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5547), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5545), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [19065] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2590), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6690), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5762), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5760), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [19137] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1618), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6671), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5778), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5776), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [19209] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5371), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5373), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [19277] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2568), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6692), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5545), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5547), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [19349] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    STATE(1570), 1,
      sym_template_argument_list,
    STATE(2721), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6694), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5842), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5844), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [19425] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1618), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6671), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5752), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5750), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [19497] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1618), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6671), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5758), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5756), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [19569] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4812), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4810), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [19637] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6696), 1,
      sym_auto,
    ACTIONS(6698), 1,
      anon_sym_decltype,
    STATE(2653), 1,
      sym_decltype_auto,
    ACTIONS(5391), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5393), 44,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [19711] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5361), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5363), 47,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [19779] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5365), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5361), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5363), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [19849] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2574), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6650), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5750), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5752), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [19921] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6700), 1,
      anon_sym_LT,
    STATE(2604), 1,
      sym_template_argument_list,
    ACTIONS(4838), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4845), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [19995] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6675), 1,
      anon_sym_LT,
    STATE(2679), 1,
      sym_template_argument_list,
    ACTIONS(4845), 27,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(4838), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [20069] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6703), 1,
      sym_identifier,
    STATE(2547), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(3474), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(3478), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5253), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5251), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [20145] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2574), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6650), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5756), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5758), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [20217] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4855), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4862), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [20285] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5399), 24,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5401), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [20353] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4816), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4814), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [20421] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1618), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6671), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5791), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5789), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [20493] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4855), 22,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4862), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [20560] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5553), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5555), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [20627] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5365), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5361), 22,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5363), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [20696] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6529), 1,
      anon_sym___attribute__,
    ACTIONS(6531), 1,
      anon_sym___attribute,
    ACTIONS(6705), 1,
      anon_sym_LBRACE,
    ACTIONS(6707), 1,
      anon_sym_COLON,
    STATE(2791), 1,
      sym__enum_base_clause,
    STATE(2807), 1,
      sym_enumerator_list,
    STATE(3089), 1,
      sym_attribute_specifier,
    ACTIONS(6245), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6247), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [20777] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5656), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5658), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [20844] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5648), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5650), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [20911] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5361), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5363), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [20978] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5447), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(5449), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [21045] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(4157), 1,
      anon_sym_LPAREN2,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(5708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5710), 1,
      anon_sym_LBRACK,
    ACTIONS(5807), 1,
      anon_sym_STAR,
    ACTIONS(5809), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5811), 1,
      anon_sym_AMP,
    STATE(3166), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5765), 1,
      sym__scope_resolution,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6209), 1,
      sym__declarator,
    STATE(6548), 1,
      sym__abstract_declarator,
    STATE(7915), 1,
      sym_ms_based_modifier,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6632), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(6634), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [21162] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5578), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5580), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [21229] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5498), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5500), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [21296] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5510), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5512), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [21363] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5514), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5516), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [21430] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5596), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5598), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [21497] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5529), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5531), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [21564] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5646), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [21631] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5660), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5662), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [21698] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1577), 1,
      sym_string_literal,
    ACTIONS(6713), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(6711), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6709), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [21769] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5664), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5666), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [21836] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5640), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5642), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [21903] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1576), 1,
      sym_string_literal,
    ACTIONS(6713), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(6711), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6709), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [21974] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(4157), 1,
      anon_sym_LPAREN2,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(5708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5710), 1,
      anon_sym_LBRACK,
    ACTIONS(5807), 1,
      anon_sym_STAR,
    ACTIONS(5809), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5811), 1,
      anon_sym_AMP,
    STATE(3166), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5765), 1,
      sym__scope_resolution,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6275), 1,
      sym__declarator,
    STATE(6578), 1,
      sym__abstract_declarator,
    STATE(7915), 1,
      sym_ms_based_modifier,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5698), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(5706), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [22091] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5399), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(5401), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [22158] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5454), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(5456), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [22225] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5680), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5682), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [22292] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5541), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5543), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [22359] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5672), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5674), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [22426] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5564), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5566), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [22493] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5365), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5443), 22,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5445), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [22562] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6529), 1,
      anon_sym___attribute__,
    ACTIONS(6531), 1,
      anon_sym___attribute,
    ACTIONS(6705), 1,
      anon_sym_LBRACE,
    ACTIONS(6707), 1,
      anon_sym_COLON,
    STATE(2799), 1,
      sym__enum_base_clause,
    STATE(2822), 1,
      sym_enumerator_list,
    STATE(3116), 1,
      sym_attribute_specifier,
    ACTIONS(6161), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6163), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [22643] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5668), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5670), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [22710] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5568), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5570), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [22777] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5622), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5624), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [22844] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5537), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5539), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [22911] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5600), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5602), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [22978] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5572), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5574), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [23045] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(4157), 1,
      anon_sym_LPAREN2,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(5708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5710), 1,
      anon_sym_LBRACK,
    ACTIONS(5862), 1,
      anon_sym_STAR,
    ACTIONS(5864), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5866), 1,
      anon_sym_AMP,
    STATE(3233), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5765), 1,
      sym__scope_resolution,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6209), 1,
      sym__declarator,
    STATE(6561), 1,
      sym__abstract_declarator,
    STATE(7915), 1,
      sym_ms_based_modifier,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6632), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(6634), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [23162] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5632), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [23229] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5502), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5504), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [23296] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5676), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5678), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [23363] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5498), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5500), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [23430] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5387), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(5389), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
      anon_sym_DASH_GT_STAR,
  [23497] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1574), 1,
      sym_string_literal,
    ACTIONS(6713), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(6711), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6709), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [23568] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5502), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5504), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [23635] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5620), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5618), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_explicit,
      anon_sym_template,
      anon_sym_operator,
  [23702] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5431), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5433), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [23769] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2545), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6628), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5433), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5431), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [23840] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5431), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5433), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [23907] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5652), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5654), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [23974] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5626), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5628), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [24041] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4855), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4862), 41,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
      anon_sym_DASH_GT_STAR,
  [24108] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5618), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5620), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [24175] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5592), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5594), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [24242] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5365), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5361), 22,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5363), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [24311] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5506), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5508), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [24378] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6715), 1,
      sym_identifier,
    ACTIONS(6719), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2987), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6232), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6717), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4961), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6227), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(4963), 24,
      anon_sym_AMP,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [24461] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2514), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6630), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5431), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5433), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [24532] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5533), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5535), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [24599] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5545), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5547), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [24666] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5549), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5551), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [24733] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(4157), 1,
      anon_sym_LPAREN2,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(5708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5710), 1,
      anon_sym_LBRACK,
    ACTIONS(5862), 1,
      anon_sym_STAR,
    ACTIONS(5864), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5866), 1,
      anon_sym_AMP,
    STATE(3233), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5765), 1,
      sym__scope_resolution,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6275), 1,
      sym__declarator,
    STATE(6587), 1,
      sym__abstract_declarator,
    STATE(7915), 1,
      sym_ms_based_modifier,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5698), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(5706), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [24850] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5502), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_DOT,
    ACTIONS(5504), 46,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [24917] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1578), 1,
      sym_string_literal,
    ACTIONS(6713), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(6711), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6709), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [24988] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6721), 1,
      sym_identifier,
    ACTIONS(6725), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2811), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6175), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2659), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6723), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4946), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6170), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(4948), 24,
      anon_sym_AMP,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [25071] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 22,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5472), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [25138] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2568), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6692), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5431), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5433), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [25208] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6727), 1,
      anon_sym_LT,
    STATE(2654), 1,
      sym_template_argument_list,
    STATE(2721), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6694), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4033), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4041), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [25284] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4824), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(4822), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [25350] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6249), 1,
      anon_sym___attribute__,
    ACTIONS(6251), 1,
      anon_sym___attribute,
    ACTIONS(6661), 1,
      anon_sym_LBRACE,
    STATE(2795), 1,
      sym_enumerator_list,
    STATE(2997), 1,
      sym_attribute_specifier,
    ACTIONS(5834), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5836), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [25426] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2694), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6729), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5746), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5744), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [25496] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6733), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6731), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [25562] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6353), 1,
      sym_auto,
    ACTIONS(6355), 1,
      anon_sym_decltype,
    ACTIONS(6361), 1,
      anon_sym_virtual,
    ACTIONS(6735), 1,
      anon_sym_SEMI,
    STATE(2454), 1,
      sym_decltype_auto,
    STATE(3049), 1,
      sym_alignas_qualifier,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6359), 5,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
    STATE(2534), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(5333), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(6357), 12,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(5329), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [25654] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4812), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(4810), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [25720] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1638), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6737), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5795), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5793), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [25790] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1638), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6737), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5778), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5776), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [25860] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4862), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(4855), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [25926] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4828), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(4826), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [25992] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6741), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6739), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [26058] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6745), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6743), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [26124] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2677), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6747), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5803), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5801), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [26194] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2031), 1,
      anon_sym_LBRACE,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(6751), 1,
      anon_sym_LBRACK,
    ACTIONS(6753), 1,
      sym_auto,
    ACTIONS(6755), 1,
      anon_sym_decltype,
    STATE(2939), 1,
      sym_decltype_auto,
    STATE(3010), 1,
      sym_new_declarator,
    STATE(3436), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5712), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5714), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [26276] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5365), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5363), 27,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5361), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [26344] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5365), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5363), 27,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5361), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [26412] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2031), 1,
      anon_sym_LBRACE,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(6751), 1,
      anon_sym_LBRACK,
    ACTIONS(6753), 1,
      sym_auto,
    ACTIONS(6755), 1,
      anon_sym_decltype,
    STATE(2939), 1,
      sym_decltype_auto,
    STATE(2971), 1,
      sym_new_declarator,
    STATE(3393), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5734), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5736), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [26494] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6759), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6757), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [26560] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4820), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(4818), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [26626] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4816), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(4814), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [26692] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2643), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2641), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [26758] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4862), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4855), 45,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
  [26824] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5365), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5445), 27,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5443), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [26892] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1638), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6737), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5782), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5780), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [26962] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5472), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5470), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [27028] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6763), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6761), 45,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_explicit,
      anon_sym_template,
      anon_sym_operator,
  [27094] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1638), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6737), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5768), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5766), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [27164] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4832), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(4830), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [27230] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4836), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(4834), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [27296] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6767), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(6765), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [27362] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6353), 1,
      sym_auto,
    ACTIONS(6355), 1,
      anon_sym_decltype,
    ACTIONS(6361), 1,
      anon_sym_virtual,
    ACTIONS(6769), 1,
      anon_sym_SEMI,
    STATE(2454), 1,
      sym_decltype_auto,
    STATE(3049), 1,
      sym_alignas_qualifier,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6359), 5,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
    STATE(2534), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(5333), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(6357), 12,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(5329), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [27454] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6771), 1,
      anon_sym_LT,
    STATE(2654), 1,
      sym_template_argument_list,
    ACTIONS(4838), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4845), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [27526] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2031), 1,
      anon_sym_LBRACE,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(6751), 1,
      anon_sym_LBRACK,
    ACTIONS(6753), 1,
      sym_auto,
    ACTIONS(6755), 1,
      anon_sym_decltype,
    STATE(2939), 1,
      sym_decltype_auto,
    STATE(2985), 1,
      sym_new_declarator,
    STATE(3350), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5716), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5718), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [27608] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6353), 1,
      sym_auto,
    ACTIONS(6355), 1,
      anon_sym_decltype,
    ACTIONS(6361), 1,
      anon_sym_virtual,
    ACTIONS(6774), 1,
      anon_sym_SEMI,
    STATE(2454), 1,
      sym_decltype_auto,
    STATE(3049), 1,
      sym_alignas_qualifier,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6359), 5,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
    STATE(2534), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(5333), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(6357), 12,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(5329), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [27700] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1638), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6737), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5752), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5750), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [27770] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1638), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6737), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5758), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5756), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [27840] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5361), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5363), 37,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [27906] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6353), 1,
      sym_auto,
    ACTIONS(6355), 1,
      anon_sym_decltype,
    ACTIONS(6361), 1,
      anon_sym_virtual,
    ACTIONS(6776), 1,
      anon_sym_SEMI,
    STATE(2454), 1,
      sym_decltype_auto,
    STATE(3049), 1,
      sym_alignas_qualifier,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6359), 5,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
    STATE(2534), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(5333), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(6357), 12,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(5329), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [27998] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6249), 1,
      anon_sym___attribute__,
    ACTIONS(6251), 1,
      anon_sym___attribute,
    ACTIONS(6661), 1,
      anon_sym_LBRACE,
    STATE(2722), 1,
      sym_enumerator_list,
    STATE(2947), 1,
      sym_attribute_specifier,
    ACTIONS(5848), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5850), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [28074] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2705), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6778), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5740), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5738), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [28144] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6353), 1,
      sym_auto,
    ACTIONS(6355), 1,
      anon_sym_decltype,
    ACTIONS(6361), 1,
      anon_sym_virtual,
    ACTIONS(6780), 1,
      anon_sym_SEMI,
    STATE(2454), 1,
      sym_decltype_auto,
    STATE(3049), 1,
      sym_alignas_qualifier,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6359), 5,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
    STATE(2534), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(5333), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(6357), 12,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(5329), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [28236] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6353), 1,
      sym_auto,
    ACTIONS(6355), 1,
      anon_sym_decltype,
    ACTIONS(6361), 1,
      anon_sym_virtual,
    ACTIONS(6782), 1,
      anon_sym_SEMI,
    STATE(2454), 1,
      sym_decltype_auto,
    STATE(3049), 1,
      sym_alignas_qualifier,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6359), 5,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
    STATE(2534), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(5333), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(6357), 12,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(5329), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [28328] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4941), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4939), 45,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_explicit,
      anon_sym_template,
      anon_sym_operator,
  [28394] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6353), 1,
      sym_auto,
    ACTIONS(6355), 1,
      anon_sym_decltype,
    ACTIONS(6361), 1,
      anon_sym_virtual,
    ACTIONS(6784), 1,
      anon_sym_SEMI,
    STATE(2454), 1,
      sym_decltype_auto,
    STATE(3049), 1,
      sym_alignas_qualifier,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6359), 5,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
    STATE(2534), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(5333), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(6357), 12,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(5329), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [28486] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2631), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(2629), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [28552] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6727), 1,
      anon_sym_LT,
    STATE(2654), 1,
      sym_template_argument_list,
    ACTIONS(5720), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4059), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [28624] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2697), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6786), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5545), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5547), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [28694] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2706), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6788), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5762), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5760), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [28764] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2031), 1,
      anon_sym_LBRACE,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(6751), 1,
      anon_sym_LBRACK,
    ACTIONS(6753), 1,
      sym_auto,
    ACTIONS(6755), 1,
      anon_sym_decltype,
    STATE(2939), 1,
      sym_decltype_auto,
    STATE(3040), 1,
      sym_new_declarator,
    STATE(3369), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5684), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5686), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [28846] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5363), 28,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5361), 30,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [28912] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1638), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6737), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5791), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5789), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [28982] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6249), 1,
      anon_sym___attribute__,
    ACTIONS(6251), 1,
      anon_sym___attribute,
    STATE(2961), 1,
      sym_attribute_specifier,
    ACTIONS(5951), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5953), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [29053] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6537), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_RBRACK_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6535), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
  [29118] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6249), 1,
      anon_sym___attribute__,
    ACTIONS(6251), 1,
      anon_sym___attribute,
    STATE(2980), 1,
      sym_attribute_specifier,
    ACTIONS(5947), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5949), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [29189] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6249), 1,
      anon_sym___attribute__,
    ACTIONS(6251), 1,
      anon_sym___attribute,
    STATE(2989), 1,
      sym_attribute_specifier,
    ACTIONS(5905), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5907), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [29260] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6483), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_RBRACK_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6481), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
  [29325] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6249), 1,
      anon_sym___attribute__,
    ACTIONS(6251), 1,
      anon_sym___attribute,
    STATE(3024), 1,
      sym_attribute_specifier,
    ACTIONS(5913), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5915), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [29396] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6249), 1,
      anon_sym___attribute__,
    ACTIONS(6251), 1,
      anon_sym___attribute,
    STATE(3029), 1,
      sym_attribute_specifier,
    ACTIONS(5917), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5919), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [29467] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4810), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4812), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [29532] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4826), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4828), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [29597] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4818), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4820), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [29662] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4822), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4824), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [29727] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4814), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4816), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [29792] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4830), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4832), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [29857] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4834), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4836), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [29922] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5447), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5449), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [29987] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2456), 1,
      anon_sym_LBRACE,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6794), 1,
      sym_auto,
    ACTIONS(6796), 1,
      anon_sym_decltype,
    STATE(3068), 1,
      sym_new_declarator,
    STATE(3081), 1,
      sym_decltype_auto,
    STATE(3614), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5716), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5718), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [30068] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5365), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5361), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5363), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [30135] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5365), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5361), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5363), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [30202] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6249), 1,
      anon_sym___attribute__,
    ACTIONS(6251), 1,
      anon_sym___attribute,
    STATE(3004), 1,
      sym_attribute_specifier,
    ACTIONS(5887), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5889), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [30273] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5472), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [30338] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2456), 1,
      anon_sym_LBRACE,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6794), 1,
      sym_auto,
    ACTIONS(6796), 1,
      anon_sym_decltype,
    STATE(3081), 1,
      sym_decltype_auto,
    STATE(3097), 1,
      sym_new_declarator,
    STATE(3506), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5684), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5686), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [30419] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(6798), 1,
      anon_sym_SEMI,
    STATE(2448), 1,
      sym_attribute_specifier,
    STATE(2879), 1,
      sym_field_declaration_list,
    STATE(6974), 1,
      sym_virtual_specifier,
    STATE(7628), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5377), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5375), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [30502] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(6800), 1,
      anon_sym_SEMI,
    STATE(2448), 1,
      sym_attribute_specifier,
    STATE(2879), 1,
      sym_field_declaration_list,
    STATE(6974), 1,
      sym_virtual_specifier,
    STATE(7628), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5377), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5375), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [30585] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6802), 1,
      anon_sym_LBRACE,
    STATE(2430), 1,
      sym_attribute_specifier,
    STATE(2902), 1,
      sym_enumerator_list,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5836), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5834), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [30658] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5454), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5456), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [30723] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2456), 1,
      anon_sym_LBRACE,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6794), 1,
      sym_auto,
    ACTIONS(6796), 1,
      anon_sym_decltype,
    STATE(3081), 1,
      sym_decltype_auto,
    STATE(3105), 1,
      sym_new_declarator,
    STATE(3563), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5734), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5736), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [30804] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(6804), 1,
      anon_sym_SEMI,
    STATE(2448), 1,
      sym_attribute_specifier,
    STATE(2879), 1,
      sym_field_declaration_list,
    STATE(6974), 1,
      sym_virtual_specifier,
    STATE(7628), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5377), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5375), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [30887] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(6814), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6816), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6828), 1,
      anon_sym_GT_EQ,
    ACTIONS(6832), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6834), 1,
      anon_sym_or,
    ACTIONS(6836), 1,
      anon_sym_and,
    ACTIONS(6838), 1,
      anon_sym_not_eq,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6810), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6818), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(6820), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6822), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6824), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6830), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6812), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6826), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6806), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(6808), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [30996] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(6814), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6816), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6828), 1,
      anon_sym_GT_EQ,
    ACTIONS(6832), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6834), 1,
      anon_sym_or,
    ACTIONS(6836), 1,
      anon_sym_and,
    ACTIONS(6838), 1,
      anon_sym_not_eq,
    ACTIONS(6840), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6842), 1,
      anon_sym_QMARK,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6810), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6818), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(6820), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6822), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6824), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6830), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6812), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6826), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6543), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(6545), 15,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [31109] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(6816), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6828), 1,
      anon_sym_GT_EQ,
    ACTIONS(6832), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6836), 1,
      anon_sym_and,
    ACTIONS(6838), 1,
      anon_sym_not_eq,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6810), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6818), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(6820), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6822), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6824), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6830), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6812), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6826), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6263), 7,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      sym_identifier,
    ACTIONS(6265), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [31214] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(6828), 1,
      anon_sym_GT_EQ,
    ACTIONS(6832), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6838), 1,
      anon_sym_not_eq,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6810), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6818), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(6820), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6822), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6824), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6830), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6812), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6826), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6263), 8,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
    ACTIONS(6265), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [31315] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(6828), 1,
      anon_sym_GT_EQ,
    ACTIONS(6832), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6838), 1,
      anon_sym_not_eq,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6810), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6820), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6822), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6824), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6830), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6812), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6826), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6263), 10,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      sym_identifier,
    ACTIONS(6265), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [31414] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(6828), 1,
      anon_sym_GT_EQ,
    ACTIONS(6832), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6838), 1,
      anon_sym_not_eq,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6810), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6822), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6824), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6830), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6812), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6826), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6263), 12,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      sym_identifier,
    ACTIONS(6265), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [31511] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(6828), 1,
      anon_sym_GT_EQ,
    ACTIONS(6832), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6838), 1,
      anon_sym_not_eq,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6810), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6824), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6830), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6812), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6826), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6263), 14,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      sym_identifier,
    ACTIONS(6265), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [31606] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(6828), 1,
      anon_sym_GT_EQ,
    ACTIONS(6832), 1,
      anon_sym_LT_EQ_GT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6810), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6830), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6812), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6826), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6263), 15,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6265), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [31697] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(6832), 1,
      anon_sym_LT_EQ_GT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6810), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6830), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6812), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6263), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6265), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [31784] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(6814), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6816), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6828), 1,
      anon_sym_GT_EQ,
    ACTIONS(6832), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6834), 1,
      anon_sym_or,
    ACTIONS(6836), 1,
      anon_sym_and,
    ACTIONS(6838), 1,
      anon_sym_not_eq,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6810), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6818), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(6820), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6822), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6824), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6830), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6812), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6826), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6844), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(6846), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [31893] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(6814), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6816), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6828), 1,
      anon_sym_GT_EQ,
    ACTIONS(6832), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6834), 1,
      anon_sym_or,
    ACTIONS(6836), 1,
      anon_sym_and,
    ACTIONS(6838), 1,
      anon_sym_not_eq,
    ACTIONS(6840), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6842), 1,
      anon_sym_QMARK,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6810), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6818), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(6820), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6822), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6824), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6830), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6812), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6826), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6848), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(6850), 15,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [32006] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(6814), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6816), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6828), 1,
      anon_sym_GT_EQ,
    ACTIONS(6832), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6834), 1,
      anon_sym_or,
    ACTIONS(6836), 1,
      anon_sym_and,
    ACTIONS(6838), 1,
      anon_sym_not_eq,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6810), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6818), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(6820), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6822), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6824), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6830), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6812), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6826), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6852), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(6854), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [32115] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(6814), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6816), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6828), 1,
      anon_sym_GT_EQ,
    ACTIONS(6832), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6834), 1,
      anon_sym_or,
    ACTIONS(6836), 1,
      anon_sym_and,
    ACTIONS(6838), 1,
      anon_sym_not_eq,
    ACTIONS(6840), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6842), 1,
      anon_sym_QMARK,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6810), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6818), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(6820), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6822), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6824), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6830), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6812), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6826), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6856), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(6858), 15,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [32228] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6463), 1,
      anon_sym_LT,
    STATE(1570), 1,
      sym_template_argument_list,
    STATE(3060), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6860), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5842), 6,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5844), 43,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [32303] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2456), 1,
      anon_sym_LBRACE,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6794), 1,
      sym_auto,
    ACTIONS(6796), 1,
      anon_sym_decltype,
    STATE(3081), 1,
      sym_decltype_auto,
    STATE(3128), 1,
      sym_new_declarator,
    STATE(3644), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5712), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5714), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [32384] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(6862), 1,
      anon_sym_SEMI,
    STATE(2448), 1,
      sym_attribute_specifier,
    STATE(2879), 1,
      sym_field_declaration_list,
    STATE(6974), 1,
      sym_virtual_specifier,
    STATE(7628), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5377), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5375), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [32467] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6489), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6491), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
  [32532] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(6864), 1,
      anon_sym_SEMI,
    STATE(2448), 1,
      sym_attribute_specifier,
    STATE(2879), 1,
      sym_field_declaration_list,
    STATE(6974), 1,
      sym_virtual_specifier,
    STATE(7628), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5377), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5375), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [32615] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(6866), 1,
      anon_sym_SEMI,
    STATE(2448), 1,
      sym_attribute_specifier,
    STATE(2879), 1,
      sym_field_declaration_list,
    STATE(6974), 1,
      sym_virtual_specifier,
    STATE(7628), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5377), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5375), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [32698] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(6814), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6816), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6828), 1,
      anon_sym_GT_EQ,
    ACTIONS(6832), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6834), 1,
      anon_sym_or,
    ACTIONS(6836), 1,
      anon_sym_and,
    ACTIONS(6838), 1,
      anon_sym_not_eq,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6810), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6818), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(6820), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6822), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6824), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6830), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6812), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6826), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6868), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(6870), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [32807] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(6814), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6816), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6828), 1,
      anon_sym_GT_EQ,
    ACTIONS(6832), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6834), 1,
      anon_sym_or,
    ACTIONS(6836), 1,
      anon_sym_and,
    ACTIONS(6838), 1,
      anon_sym_not_eq,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6810), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6818), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(6820), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6822), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(6824), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6830), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6812), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6826), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6872), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      sym_identifier,
    ACTIONS(6874), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [32916] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(6876), 1,
      anon_sym_SEMI,
    STATE(2448), 1,
      sym_attribute_specifier,
    STATE(2879), 1,
      sym_field_declaration_list,
    STATE(6974), 1,
      sym_virtual_specifier,
    STATE(7628), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5377), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5375), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [32999] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(6878), 1,
      anon_sym_SEMI,
    STATE(2448), 1,
      sym_attribute_specifier,
    STATE(2879), 1,
      sym_field_declaration_list,
    STATE(6974), 1,
      sym_virtual_specifier,
    STATE(7628), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5377), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5375), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [33082] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(6880), 1,
      anon_sym_SEMI,
    STATE(2448), 1,
      sym_attribute_specifier,
    STATE(2879), 1,
      sym_field_declaration_list,
    STATE(6974), 1,
      sym_virtual_specifier,
    STATE(7628), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5377), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5375), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [33165] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5365), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5443), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5445), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [33232] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6249), 1,
      anon_sym___attribute__,
    ACTIONS(6251), 1,
      anon_sym___attribute,
    STATE(3017), 1,
      sym_attribute_specifier,
    ACTIONS(5901), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5903), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [33303] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6249), 1,
      anon_sym___attribute__,
    ACTIONS(6251), 1,
      anon_sym___attribute,
    STATE(2955), 1,
      sym_attribute_specifier,
    ACTIONS(5969), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5971), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [33374] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6644), 1,
      anon_sym___attribute__,
    ACTIONS(6646), 1,
      anon_sym___attribute,
    ACTIONS(6882), 1,
      anon_sym_LBRACE,
    ACTIONS(6884), 1,
      anon_sym_COLON,
    STATE(2914), 1,
      sym__enum_base_clause,
    STATE(3008), 1,
      sym_enumerator_list,
    STATE(3382), 1,
      sym_attribute_specifier,
    ACTIONS(6245), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6247), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [33453] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4840), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
  [33518] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(6886), 1,
      anon_sym_SEMI,
    STATE(2448), 1,
      sym_attribute_specifier,
    STATE(2879), 1,
      sym_field_declaration_list,
    STATE(6974), 1,
      sym_virtual_specifier,
    STATE(7628), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5377), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5375), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [33601] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(6888), 1,
      anon_sym_SEMI,
    STATE(2448), 1,
      sym_attribute_specifier,
    STATE(2879), 1,
      sym_field_declaration_list,
    STATE(6974), 1,
      sym_virtual_specifier,
    STATE(7628), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5377), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5375), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [33684] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4840), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
  [33749] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4840), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
  [33814] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6445), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_RBRACK_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6443), 31,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
  [33879] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5387), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5389), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [33944] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4840), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
  [34009] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(6890), 1,
      anon_sym_SEMI,
    STATE(2448), 1,
      sym_attribute_specifier,
    STATE(2879), 1,
      sym_field_declaration_list,
    STATE(6974), 1,
      sym_virtual_specifier,
    STATE(7628), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5377), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5375), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [34092] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(6892), 1,
      anon_sym_SEMI,
    STATE(2448), 1,
      sym_attribute_specifier,
    STATE(2879), 1,
      sym_field_declaration_list,
    STATE(6974), 1,
      sym_virtual_specifier,
    STATE(7628), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5377), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5375), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [34175] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4840), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
  [34240] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5433), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT2,
    ACTIONS(5431), 46,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [34305] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6644), 1,
      anon_sym___attribute__,
    ACTIONS(6646), 1,
      anon_sym___attribute,
    ACTIONS(6882), 1,
      anon_sym_LBRACE,
    ACTIONS(6884), 1,
      anon_sym_COLON,
    STATE(2883), 1,
      sym__enum_base_clause,
    STATE(3063), 1,
      sym_enumerator_list,
    STATE(3401), 1,
      sym_attribute_specifier,
    ACTIONS(6161), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6163), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [34384] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4840), 38,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_try,
  [34449] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6529), 1,
      anon_sym___attribute__,
    ACTIONS(6531), 1,
      anon_sym___attribute,
    ACTIONS(6705), 1,
      anon_sym_LBRACE,
    STATE(2824), 1,
      sym_enumerator_list,
    STATE(3121), 1,
      sym_attribute_specifier,
    ACTIONS(5834), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5836), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [34524] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6802), 1,
      anon_sym_LBRACE,
    STATE(2415), 1,
      sym_attribute_specifier,
    STATE(2875), 1,
      sym_enumerator_list,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5850), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5848), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [34597] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6249), 1,
      anon_sym___attribute__,
    ACTIONS(6251), 1,
      anon_sym___attribute,
    STATE(2944), 1,
      sym_attribute_specifier,
    ACTIONS(5976), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5978), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [34668] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5399), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5401), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [34733] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6249), 1,
      anon_sym___attribute__,
    ACTIONS(6251), 1,
      anon_sym___attribute,
    STATE(2960), 1,
      sym_attribute_specifier,
    ACTIONS(5980), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5982), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [34804] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6812), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6263), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6265), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
  [34885] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6810), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6812), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6263), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6265), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
  [34968] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6810), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6830), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6812), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6263), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6265), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
  [35053] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6529), 1,
      anon_sym___attribute__,
    ACTIONS(6531), 1,
      anon_sym___attribute,
    ACTIONS(6705), 1,
      anon_sym_LBRACE,
    STATE(2829), 1,
      sym_enumerator_list,
    STATE(3147), 1,
      sym_attribute_specifier,
    ACTIONS(5848), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5850), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [35128] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6249), 1,
      anon_sym___attribute__,
    ACTIONS(6251), 1,
      anon_sym___attribute,
    STATE(3011), 1,
      sym_attribute_specifier,
    ACTIONS(5986), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5988), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [35199] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6249), 1,
      anon_sym___attribute__,
    ACTIONS(6251), 1,
      anon_sym___attribute,
    STATE(3047), 1,
      sym_attribute_specifier,
    ACTIONS(5990), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5992), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [35270] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(6894), 1,
      anon_sym_SEMI,
    STATE(2448), 1,
      sym_attribute_specifier,
    STATE(2879), 1,
      sym_field_declaration_list,
    STATE(6974), 1,
      sym_virtual_specifier,
    STATE(7628), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5377), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5375), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [35353] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6463), 1,
      anon_sym_LT,
    ACTIONS(6896), 1,
      anon_sym_LBRACK,
    STATE(2551), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3656), 1,
      sym_template_argument_list,
    ACTIONS(4056), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4041), 4,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
    ACTIONS(4061), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4033), 41,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [35431] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6529), 1,
      anon_sym___attribute__,
    ACTIONS(6531), 1,
      anon_sym___attribute,
    STATE(3111), 1,
      sym_attribute_specifier,
    ACTIONS(5947), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5949), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [35501] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6529), 1,
      anon_sym___attribute__,
    ACTIONS(6531), 1,
      anon_sym___attribute,
    STATE(3093), 1,
      sym_attribute_specifier,
    ACTIONS(5969), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5971), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [35571] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(4157), 1,
      anon_sym_LPAREN2,
    ACTIONS(4159), 1,
      anon_sym_STAR,
    ACTIONS(4161), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4163), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      sym_identifier,
    ACTIONS(5710), 1,
      anon_sym_LBRACK,
    ACTIONS(6180), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6632), 1,
      anon_sym_RPAREN,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5712), 1,
      sym__scope_resolution,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6376), 1,
      sym__declarator,
    STATE(6665), 1,
      sym__abstract_declarator,
    STATE(7870), 1,
      sym_ms_based_modifier,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [35683] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6529), 1,
      anon_sym___attribute__,
    ACTIONS(6531), 1,
      anon_sym___attribute,
    STATE(3119), 1,
      sym_attribute_specifier,
    ACTIONS(5905), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5907), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [35753] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6899), 1,
      sym_literal_suffix,
    ACTIONS(4043), 26,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4035), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [35819] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6529), 1,
      anon_sym___attribute__,
    ACTIONS(6531), 1,
      anon_sym___attribute,
    STATE(3123), 1,
      sym_attribute_specifier,
    ACTIONS(5913), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5915), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [35889] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6529), 1,
      anon_sym___attribute__,
    ACTIONS(6531), 1,
      anon_sym___attribute,
    STATE(3124), 1,
      sym_attribute_specifier,
    ACTIONS(5917), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5919), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [35959] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1894), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4932), 2,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(5786), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4981), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4984), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [36029] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5506), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5508), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [36093] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5656), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5658), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [36157] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5545), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5547), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [36221] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5361), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5363), 39,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_DASH_GT_STAR,
  [36285] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6463), 1,
      anon_sym_LT,
    STATE(2551), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2692), 1,
      sym_template_argument_list,
    ACTIONS(4061), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4041), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4033), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [36359] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4059), 1,
      anon_sym_SEMI,
    ACTIONS(6463), 1,
      anon_sym_LT,
    STATE(2551), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2692), 1,
      sym_template_argument_list,
    ACTIONS(4061), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4041), 5,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4033), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [36435] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5578), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5580), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [36499] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5363), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT2,
    ACTIONS(5361), 44,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [36563] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6901), 27,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6903), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [36627] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5592), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5594), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [36691] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6529), 1,
      anon_sym___attribute__,
    ACTIONS(6531), 1,
      anon_sym___attribute,
    STATE(3146), 1,
      sym_attribute_specifier,
    ACTIONS(5976), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5978), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [36761] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5646), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [36825] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6529), 1,
      anon_sym___attribute__,
    ACTIONS(6531), 1,
      anon_sym___attribute,
    STATE(3148), 1,
      sym_attribute_specifier,
    ACTIONS(5980), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5982), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [36895] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6529), 1,
      anon_sym___attribute__,
    ACTIONS(6531), 1,
      anon_sym___attribute,
    STATE(3149), 1,
      sym_attribute_specifier,
    ACTIONS(5986), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5988), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [36965] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6529), 1,
      anon_sym___attribute__,
    ACTIONS(6531), 1,
      anon_sym___attribute,
    STATE(3151), 1,
      sym_attribute_specifier,
    ACTIONS(5990), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5992), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [37035] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(4157), 1,
      anon_sym_LPAREN2,
    ACTIONS(4159), 1,
      anon_sym_STAR,
    ACTIONS(4161), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4163), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      sym_identifier,
    ACTIONS(5698), 1,
      anon_sym_RPAREN,
    ACTIONS(5710), 1,
      anon_sym_LBRACK,
    ACTIONS(6180), 1,
      anon_sym_COLON_COLON,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5712), 1,
      sym__scope_resolution,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6337), 1,
      sym__declarator,
    STATE(6616), 1,
      sym__abstract_declarator,
    STATE(7870), 1,
      sym_ms_based_modifier,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [37147] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6529), 1,
      anon_sym___attribute__,
    ACTIONS(6531), 1,
      anon_sym___attribute,
    STATE(3088), 1,
      sym_attribute_specifier,
    ACTIONS(5901), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5903), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [37217] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6529), 1,
      anon_sym___attribute__,
    ACTIONS(6531), 1,
      anon_sym___attribute,
    STATE(3155), 1,
      sym_attribute_specifier,
    ACTIONS(5951), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5953), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [37287] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6529), 1,
      anon_sym___attribute__,
    ACTIONS(6531), 1,
      anon_sym___attribute,
    STATE(3156), 1,
      sym_attribute_specifier,
    ACTIONS(5887), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5889), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [37357] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6913), 1,
      anon_sym___attribute__,
    ACTIONS(6916), 1,
      anon_sym___attribute,
    ACTIONS(6919), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6922), 1,
      anon_sym_LBRACK,
    ACTIONS(6924), 1,
      anon_sym_const,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6932), 1,
      anon_sym_DASH_GT,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(6941), 1,
      anon_sym_requires,
    STATE(3934), 1,
      sym_alignas_qualifier,
    STATE(4699), 1,
      sym__function_attributes_start,
    STATE(4855), 1,
      sym_ref_qualifier,
    STATE(5483), 1,
      sym_trailing_return_type,
    STATE(5666), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(6926), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6934), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4048), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4217), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5755), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5197), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6905), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
    ACTIONS(6911), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [37475] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4862), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(4864), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4857), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [37541] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2697), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6786), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5431), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5433), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [37609] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6913), 1,
      anon_sym___attribute__,
    ACTIONS(6916), 1,
      anon_sym___attribute,
    ACTIONS(6919), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6922), 1,
      anon_sym_LBRACK,
    ACTIONS(6924), 1,
      anon_sym_const,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6932), 1,
      anon_sym_DASH_GT,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(6944), 1,
      anon_sym_requires,
    STATE(3934), 1,
      sym_alignas_qualifier,
    STATE(4636), 1,
      sym__function_attributes_start,
    STATE(4881), 1,
      sym_ref_qualifier,
    STATE(5490), 1,
      sym_trailing_return_type,
    STATE(5572), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6926), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(4048), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4217), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5755), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5182), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6905), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
    ACTIONS(6911), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [37727] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2399), 1,
      sym_attribute_specifier,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5903), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5901), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [37794] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(6840), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6848), 1,
      anon_sym_EQ,
    ACTIONS(6950), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6952), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6954), 1,
      anon_sym_PIPE,
    ACTIONS(6958), 1,
      anon_sym_AMP,
    ACTIONS(6964), 1,
      anon_sym_GT_EQ,
    ACTIONS(6968), 1,
      anon_sym_QMARK,
    ACTIONS(6970), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6972), 1,
      anon_sym_or,
    ACTIONS(6974), 1,
      anon_sym_and,
    ACTIONS(6976), 1,
      anon_sym_bitor,
    ACTIONS(6978), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6946), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6956), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6966), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6948), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6960), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6962), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6850), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [37907] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5371), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5373), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [37970] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6919), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6922), 1,
      anon_sym_LBRACK,
    ACTIONS(6924), 1,
      anon_sym_const,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(6941), 1,
      anon_sym_requires,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(6984), 1,
      anon_sym_DASH_GT,
    STATE(3934), 1,
      sym_alignas_qualifier,
    STATE(4790), 1,
      sym__function_attributes_start,
    STATE(4913), 1,
      sym_ref_qualifier,
    STATE(5483), 1,
      sym_trailing_return_type,
    STATE(5881), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(6926), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6934), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4048), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4217), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5755), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5243), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6905), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
    ACTIONS(6911), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [38087] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6463), 1,
      anon_sym_LT,
    STATE(2692), 1,
      sym_template_argument_list,
    ACTIONS(4845), 7,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(4838), 45,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
  [38156] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2581), 1,
      anon_sym_LBRACE,
    ACTIONS(6986), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6990), 1,
      sym_auto,
    ACTIONS(6992), 1,
      anon_sym_decltype,
    STATE(3386), 1,
      sym_new_declarator,
    STATE(3469), 1,
      sym_decltype_auto,
    STATE(3838), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5684), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5686), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [38235] = 52,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(6994), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6996), 1,
      anon_sym_COMMA,
    ACTIONS(6998), 1,
      anon_sym_RPAREN,
    ACTIONS(7000), 1,
      anon_sym_DASH,
    ACTIONS(7002), 1,
      anon_sym_PLUS,
    ACTIONS(7004), 1,
      anon_sym_STAR,
    ACTIONS(7006), 1,
      anon_sym_SLASH,
    ACTIONS(7008), 1,
      anon_sym_PERCENT,
    ACTIONS(7010), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7014), 1,
      anon_sym_PIPE,
    ACTIONS(7016), 1,
      anon_sym_CARET,
    ACTIONS(7018), 1,
      anon_sym_AMP,
    ACTIONS(7020), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7022), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7024), 1,
      anon_sym_GT,
    ACTIONS(7026), 1,
      anon_sym_GT_EQ,
    ACTIONS(7028), 1,
      anon_sym_LT_EQ,
    ACTIONS(7030), 1,
      anon_sym_LT,
    ACTIONS(7032), 1,
      anon_sym_LT_LT,
    ACTIONS(7034), 1,
      anon_sym_GT_GT,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7038), 1,
      anon_sym_EQ,
    ACTIONS(7040), 1,
      anon_sym_QMARK,
    ACTIONS(7042), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7044), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7046), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7048), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7050), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7052), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7054), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7056), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7058), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7060), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7064), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7066), 1,
      anon_sym_or,
    ACTIONS(7068), 1,
      anon_sym_and,
    ACTIONS(7070), 1,
      anon_sym_bitor,
    ACTIONS(7072), 1,
      anon_sym_xor,
    ACTIONS(7074), 1,
      anon_sym_bitand,
    ACTIONS(7076), 1,
      anon_sym_not_eq,
    ACTIONS(7082), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7084), 1,
      anon_sym_DASH_GT_STAR,
    STATE(1189), 1,
      sym__binary_fold_operator,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    STATE(8288), 1,
      sym__fold_operator,
    ACTIONS(7078), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7062), 3,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [38396] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(7086), 1,
      anon_sym_STAR,
    ACTIONS(7088), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7090), 1,
      anon_sym_AMP,
    ACTIONS(7092), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5732), 1,
      sym__scope_resolution,
    STATE(6029), 1,
      sym__declarator,
    STATE(7827), 1,
      sym_ms_based_modifier,
    ACTIONS(3268), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2913), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3885), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3266), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [38505] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(6868), 1,
      anon_sym_EQ,
    ACTIONS(6950), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6952), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6954), 1,
      anon_sym_PIPE,
    ACTIONS(6958), 1,
      anon_sym_AMP,
    ACTIONS(6964), 1,
      anon_sym_GT_EQ,
    ACTIONS(6970), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6972), 1,
      anon_sym_or,
    ACTIONS(6974), 1,
      anon_sym_and,
    ACTIONS(6976), 1,
      anon_sym_bitor,
    ACTIONS(6978), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6946), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6956), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6966), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6948), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6960), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6962), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6870), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [38614] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7096), 1,
      sym_identifier,
    ACTIONS(7098), 1,
      anon_sym_STAR,
    ACTIONS(7100), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7102), 1,
      anon_sym_AMP,
    ACTIONS(7104), 1,
      anon_sym_COLON_COLON,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5750), 1,
      sym__scope_resolution,
    STATE(6337), 1,
      sym__declarator,
    STATE(8303), 1,
      sym_ms_based_modifier,
    ACTIONS(3268), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2846), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3916), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3266), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [38723] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6753), 1,
      sym_auto,
    ACTIONS(6755), 1,
      anon_sym_decltype,
    STATE(2939), 1,
      sym_decltype_auto,
    ACTIONS(5391), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5393), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [38792] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7096), 1,
      sym_identifier,
    ACTIONS(7098), 1,
      anon_sym_STAR,
    ACTIONS(7100), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7102), 1,
      anon_sym_AMP,
    ACTIONS(7104), 1,
      anon_sym_COLON_COLON,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5750), 1,
      sym__scope_resolution,
    STATE(6376), 1,
      sym__declarator,
    STATE(8303), 1,
      sym_ms_based_modifier,
    ACTIONS(3268), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3851), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3931), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3266), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [38901] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(6840), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6856), 1,
      anon_sym_EQ,
    ACTIONS(6950), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6952), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6954), 1,
      anon_sym_PIPE,
    ACTIONS(6958), 1,
      anon_sym_AMP,
    ACTIONS(6964), 1,
      anon_sym_GT_EQ,
    ACTIONS(6968), 1,
      anon_sym_QMARK,
    ACTIONS(6970), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6972), 1,
      anon_sym_or,
    ACTIONS(6974), 1,
      anon_sym_and,
    ACTIONS(6976), 1,
      anon_sym_bitor,
    ACTIONS(6978), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6946), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6956), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6966), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6948), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6960), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6962), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6858), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [39014] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6948), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6263), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6265), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [39093] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(6852), 1,
      anon_sym_EQ,
    ACTIONS(6950), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6952), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6954), 1,
      anon_sym_PIPE,
    ACTIONS(6958), 1,
      anon_sym_AMP,
    ACTIONS(6964), 1,
      anon_sym_GT_EQ,
    ACTIONS(6970), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6972), 1,
      anon_sym_or,
    ACTIONS(6974), 1,
      anon_sym_and,
    ACTIONS(6976), 1,
      anon_sym_bitor,
    ACTIONS(6978), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6946), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6956), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6966), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6948), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6960), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6962), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6854), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [39202] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(6952), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6954), 1,
      anon_sym_PIPE,
    ACTIONS(6958), 1,
      anon_sym_AMP,
    ACTIONS(6964), 1,
      anon_sym_GT_EQ,
    ACTIONS(6970), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6974), 1,
      anon_sym_and,
    ACTIONS(6976), 1,
      anon_sym_bitor,
    ACTIONS(6978), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6263), 2,
      anon_sym_EQ,
      anon_sym_or,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6946), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6956), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6966), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6948), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6960), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6962), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [39307] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(6954), 1,
      anon_sym_PIPE,
    ACTIONS(6958), 1,
      anon_sym_AMP,
    ACTIONS(6964), 1,
      anon_sym_GT_EQ,
    ACTIONS(6970), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6976), 1,
      anon_sym_bitor,
    ACTIONS(6978), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6946), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6956), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6966), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6263), 3,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(6948), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6960), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6962), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [39408] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5365), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5431), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5433), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [39473] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5560), 4,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(5562), 10,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(4035), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(4043), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
  [39540] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2442), 1,
      sym_attribute_specifier,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5889), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5887), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [39607] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(6958), 1,
      anon_sym_AMP,
    ACTIONS(6964), 1,
      anon_sym_GT_EQ,
    ACTIONS(6970), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6978), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6946), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6956), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6966), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6948), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6960), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6962), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6263), 4,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(6265), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
  [39704] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(6958), 1,
      anon_sym_AMP,
    ACTIONS(6964), 1,
      anon_sym_GT_EQ,
    ACTIONS(6970), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6978), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6946), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6966), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6948), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6960), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6962), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6263), 6,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6265), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
  [39799] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(6964), 1,
      anon_sym_GT_EQ,
    ACTIONS(6970), 1,
      anon_sym_LT_EQ_GT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6946), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6966), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6948), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6960), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6962), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6263), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6265), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
  [39890] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(6964), 1,
      anon_sym_GT_EQ,
    ACTIONS(6970), 1,
      anon_sym_LT_EQ_GT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6946), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6966), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6948), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6962), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6263), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6265), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [39979] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(6970), 1,
      anon_sym_LT_EQ_GT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6946), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6966), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6948), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6263), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6265), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [40064] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6946), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6948), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6263), 12,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6265), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [40145] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4845), 1,
      anon_sym_LBRACE,
    ACTIONS(4852), 1,
      anon_sym_LT,
    STATE(2832), 1,
      sym_template_argument_list,
    ACTIONS(4847), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4840), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [40216] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5327), 1,
      sym_identifier,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7106), 1,
      anon_sym_STAR,
    ACTIONS(7108), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7110), 1,
      anon_sym_AMP,
    ACTIONS(7112), 1,
      anon_sym_COLON_COLON,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5764), 1,
      sym__scope_resolution,
    STATE(6539), 1,
      sym__declarator,
    STATE(8019), 1,
      sym_ms_based_modifier,
    ACTIONS(3268), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2917), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3900), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3266), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [40325] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(7086), 1,
      anon_sym_STAR,
    ACTIONS(7088), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7090), 1,
      anon_sym_AMP,
    ACTIONS(7092), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5732), 1,
      sym__scope_resolution,
    STATE(6066), 1,
      sym__declarator,
    STATE(7827), 1,
      sym_ms_based_modifier,
    ACTIONS(3268), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2865), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3887), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3266), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [40434] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6946), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6966), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6948), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6263), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6265), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [40517] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(7086), 1,
      anon_sym_STAR,
    ACTIONS(7088), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7090), 1,
      anon_sym_AMP,
    ACTIONS(7092), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5732), 1,
      sym__scope_resolution,
    STATE(6087), 1,
      sym__declarator,
    STATE(7827), 1,
      sym_ms_based_modifier,
    ACTIONS(3268), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3851), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3890), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3266), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [40626] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7114), 1,
      anon_sym_LPAREN2,
    ACTIONS(7116), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7118), 1,
      anon_sym_LBRACK,
    STATE(3295), 1,
      sym_parameter_list,
    STATE(3034), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5921), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5923), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [40699] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(5708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7120), 1,
      anon_sym_STAR,
    ACTIONS(7122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7124), 1,
      anon_sym_AMP,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5765), 1,
      sym__scope_resolution,
    STATE(6269), 1,
      sym__declarator,
    STATE(7915), 1,
      sym_ms_based_modifier,
    ACTIONS(3268), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2918), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3923), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3266), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [40808] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7114), 1,
      anon_sym_LPAREN2,
    ACTIONS(7116), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7118), 1,
      anon_sym_LBRACK,
    STATE(3295), 1,
      sym_parameter_list,
    STATE(3034), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6017), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6019), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [40881] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(5708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7120), 1,
      anon_sym_STAR,
    ACTIONS(7122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7124), 1,
      anon_sym_AMP,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5765), 1,
      sym__scope_resolution,
    STATE(6275), 1,
      sym__declarator,
    STATE(7915), 1,
      sym_ms_based_modifier,
    ACTIONS(3268), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2870), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3929), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3266), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [40990] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(5708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7120), 1,
      anon_sym_STAR,
    ACTIONS(7122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7124), 1,
      anon_sym_AMP,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5765), 1,
      sym__scope_resolution,
    STATE(6209), 1,
      sym__declarator,
    STATE(7915), 1,
      sym_ms_based_modifier,
    ACTIONS(3268), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3851), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3891), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3266), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [41099] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2581), 1,
      anon_sym_LBRACE,
    ACTIONS(6986), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6990), 1,
      sym_auto,
    ACTIONS(6992), 1,
      anon_sym_decltype,
    STATE(3457), 1,
      sym_new_declarator,
    STATE(3469), 1,
      sym_decltype_auto,
    STATE(3796), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5734), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5736), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [41178] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6919), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6922), 1,
      anon_sym_LBRACK,
    ACTIONS(6924), 1,
      anon_sym_const,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(6944), 1,
      anon_sym_requires,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(7129), 1,
      anon_sym___asm,
    ACTIONS(7132), 1,
      anon_sym_DASH_GT,
    STATE(3934), 1,
      sym_alignas_qualifier,
    STATE(4764), 1,
      sym__function_attributes_start,
    STATE(4915), 1,
      sym_ref_qualifier,
    STATE(5490), 1,
      sym_trailing_return_type,
    STATE(5645), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6926), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7126), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(4048), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4217), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5755), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5229), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6905), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(6911), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [41295] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6463), 1,
      anon_sym_LT,
    STATE(2692), 1,
      sym_template_argument_list,
    ACTIONS(4059), 7,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(5720), 45,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
  [41364] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6901), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6903), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [41427] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2421), 1,
      sym_attribute_specifier,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5953), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5951), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [41494] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4855), 1,
      anon_sym_const,
    ACTIONS(4866), 1,
      anon_sym_AMP,
    ACTIONS(4859), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
      anon_sym_GT2,
    ACTIONS(4864), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4857), 18,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(4862), 18,
      anon_sym___extension__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
  [41565] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2447), 1,
      sym_attribute_specifier,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5971), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5969), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [41632] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(5708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7134), 1,
      anon_sym_STAR,
    ACTIONS(7136), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7138), 1,
      anon_sym_AMP,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5765), 1,
      sym__scope_resolution,
    STATE(6532), 1,
      sym__declarator,
    STATE(7968), 1,
      sym_ms_based_modifier,
    ACTIONS(3268), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2881), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3914), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3266), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [41741] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2462), 1,
      sym_attribute_specifier,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5915), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5913), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [41808] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6922), 1,
      anon_sym_LBRACK,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7129), 1,
      anon_sym___asm,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7144), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7149), 1,
      anon_sym_DASH_GT,
    ACTIONS(7151), 1,
      anon_sym_requires,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(4787), 1,
      sym__function_attributes_start,
    STATE(4910), 1,
      sym_ref_qualifier,
    STATE(5379), 1,
      sym_trailing_return_type,
    STATE(5552), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6934), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7126), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3947), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4149), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5755), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5241), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6905), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [41925] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(5708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7134), 1,
      anon_sym_STAR,
    ACTIONS(7136), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7138), 1,
      anon_sym_AMP,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5765), 1,
      sym__scope_resolution,
    STATE(6521), 1,
      sym__declarator,
    STATE(7968), 1,
      sym_ms_based_modifier,
    ACTIONS(3268), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3851), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3888), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3266), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [42034] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4845), 1,
      anon_sym_LBRACE,
    ACTIONS(4889), 1,
      anon_sym_LT,
    STATE(3044), 1,
      sym_template_argument_list,
    ACTIONS(4847), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4840), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [42105] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6644), 1,
      anon_sym___attribute__,
    ACTIONS(6646), 1,
      anon_sym___attribute,
    ACTIONS(6882), 1,
      anon_sym_LBRACE,
    STATE(3059), 1,
      sym_enumerator_list,
    STATE(3336), 1,
      sym_attribute_specifier,
    ACTIONS(5848), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5850), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [42178] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5327), 1,
      sym_identifier,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7106), 1,
      anon_sym_STAR,
    ACTIONS(7108), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7110), 1,
      anon_sym_AMP,
    ACTIONS(7112), 1,
      anon_sym_COLON_COLON,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5764), 1,
      sym__scope_resolution,
    STATE(6584), 1,
      sym__declarator,
    STATE(8019), 1,
      sym_ms_based_modifier,
    ACTIONS(3268), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2889), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3910), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3266), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [42287] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2419), 1,
      sym_attribute_specifier,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5949), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5947), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [42354] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6919), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6922), 1,
      anon_sym_LBRACK,
    ACTIONS(6924), 1,
      anon_sym_const,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(6941), 1,
      anon_sym_requires,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(7129), 1,
      anon_sym___asm,
    ACTIONS(7132), 1,
      anon_sym_DASH_GT,
    STATE(3934), 1,
      sym_alignas_qualifier,
    STATE(4755), 1,
      sym__function_attributes_start,
    STATE(4917), 1,
      sym_ref_qualifier,
    STATE(5483), 1,
      sym_trailing_return_type,
    STATE(5670), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(6926), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6934), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7126), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(4048), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4217), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5755), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5242), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6905), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(6911), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [42471] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(3196), 1,
      anon_sym_STAR,
    ACTIONS(3198), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      sym_identifier,
    ACTIONS(6180), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5712), 1,
      sym__scope_resolution,
    STATE(6341), 1,
      sym__declarator,
    STATE(7870), 1,
      sym_ms_based_modifier,
    ACTIONS(3268), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2929), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3884), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3266), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [42580] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2466), 1,
      sym_attribute_specifier,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5919), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5917), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [42647] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5327), 1,
      sym_identifier,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7106), 1,
      anon_sym_STAR,
    ACTIONS(7108), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7110), 1,
      anon_sym_AMP,
    ACTIONS(7112), 1,
      anon_sym_COLON_COLON,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5764), 1,
      sym__scope_resolution,
    STATE(6544), 1,
      sym__declarator,
    STATE(8019), 1,
      sym_ms_based_modifier,
    ACTIONS(3268), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3851), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3927), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3266), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [42756] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6899), 1,
      sym_literal_suffix,
    ACTIONS(4043), 24,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(4035), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [42821] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5656), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5658), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [42884] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5592), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5594), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [42947] = 52,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(6994), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6996), 1,
      anon_sym_COMMA,
    ACTIONS(7000), 1,
      anon_sym_DASH,
    ACTIONS(7002), 1,
      anon_sym_PLUS,
    ACTIONS(7004), 1,
      anon_sym_STAR,
    ACTIONS(7006), 1,
      anon_sym_SLASH,
    ACTIONS(7008), 1,
      anon_sym_PERCENT,
    ACTIONS(7010), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7014), 1,
      anon_sym_PIPE,
    ACTIONS(7016), 1,
      anon_sym_CARET,
    ACTIONS(7018), 1,
      anon_sym_AMP,
    ACTIONS(7020), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7022), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7024), 1,
      anon_sym_GT,
    ACTIONS(7026), 1,
      anon_sym_GT_EQ,
    ACTIONS(7028), 1,
      anon_sym_LT_EQ,
    ACTIONS(7030), 1,
      anon_sym_LT,
    ACTIONS(7032), 1,
      anon_sym_LT_LT,
    ACTIONS(7034), 1,
      anon_sym_GT_GT,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7038), 1,
      anon_sym_EQ,
    ACTIONS(7040), 1,
      anon_sym_QMARK,
    ACTIONS(7042), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7044), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7046), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7048), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7050), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7052), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7054), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7056), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7058), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7060), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7064), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7066), 1,
      anon_sym_or,
    ACTIONS(7068), 1,
      anon_sym_and,
    ACTIONS(7070), 1,
      anon_sym_bitor,
    ACTIONS(7072), 1,
      anon_sym_xor,
    ACTIONS(7074), 1,
      anon_sym_bitand,
    ACTIONS(7076), 1,
      anon_sym_not_eq,
    ACTIONS(7082), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7084), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7154), 1,
      anon_sym_RPAREN,
    STATE(1189), 1,
      sym__binary_fold_operator,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    STATE(8288), 1,
      sym__fold_operator,
    ACTIONS(7078), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7062), 3,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [43108] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2412), 1,
      sym_attribute_specifier,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5978), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5976), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [43175] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(5708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7156), 1,
      anon_sym_STAR,
    ACTIONS(7158), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7160), 1,
      anon_sym_AMP,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5765), 1,
      sym__scope_resolution,
    STATE(6030), 1,
      sym__declarator,
    STATE(8182), 1,
      sym_ms_based_modifier,
    ACTIONS(3268), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2898), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3898), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3266), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [43284] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(6844), 1,
      anon_sym_EQ,
    ACTIONS(6950), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6952), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6954), 1,
      anon_sym_PIPE,
    ACTIONS(6958), 1,
      anon_sym_AMP,
    ACTIONS(6964), 1,
      anon_sym_GT_EQ,
    ACTIONS(6970), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6972), 1,
      anon_sym_or,
    ACTIONS(6974), 1,
      anon_sym_and,
    ACTIONS(6976), 1,
      anon_sym_bitor,
    ACTIONS(6978), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6946), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6956), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6966), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6948), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6960), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6962), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6846), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [43393] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7114), 1,
      anon_sym_LPAREN2,
    ACTIONS(7116), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7118), 1,
      anon_sym_LBRACK,
    STATE(3295), 1,
      sym_parameter_list,
    STATE(3034), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5909), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5911), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [43466] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(5708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7156), 1,
      anon_sym_STAR,
    ACTIONS(7158), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7160), 1,
      anon_sym_AMP,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5765), 1,
      sym__scope_resolution,
    STATE(6048), 1,
      sym__declarator,
    STATE(8182), 1,
      sym_ms_based_modifier,
    ACTIONS(3268), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3851), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3912), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3266), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [43575] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7096), 1,
      sym_identifier,
    ACTIONS(7098), 1,
      anon_sym_STAR,
    ACTIONS(7100), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7102), 1,
      anon_sym_AMP,
    ACTIONS(7104), 1,
      anon_sym_COLON_COLON,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5750), 1,
      sym__scope_resolution,
    STATE(6341), 1,
      sym__declarator,
    STATE(8303), 1,
      sym_ms_based_modifier,
    ACTIONS(3268), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2908), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3897), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3266), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [43684] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(5708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7156), 1,
      anon_sym_STAR,
    ACTIONS(7158), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7160), 1,
      anon_sym_AMP,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5765), 1,
      sym__scope_resolution,
    STATE(6048), 1,
      sym__declarator,
    STATE(8182), 1,
      sym_ms_based_modifier,
    ACTIONS(3268), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2912), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3912), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3266), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [43793] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(6543), 1,
      anon_sym_EQ,
    ACTIONS(6840), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6950), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6952), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6954), 1,
      anon_sym_PIPE,
    ACTIONS(6958), 1,
      anon_sym_AMP,
    ACTIONS(6964), 1,
      anon_sym_GT_EQ,
    ACTIONS(6968), 1,
      anon_sym_QMARK,
    ACTIONS(6970), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6972), 1,
      anon_sym_or,
    ACTIONS(6974), 1,
      anon_sym_and,
    ACTIONS(6976), 1,
      anon_sym_bitor,
    ACTIONS(6978), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6946), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6956), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6966), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6948), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6960), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6962), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6545), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [43906] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2416), 1,
      sym_attribute_specifier,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5982), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5980), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [43973] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5506), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5508), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [44036] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(6872), 1,
      anon_sym_EQ,
    ACTIONS(6950), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6952), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6954), 1,
      anon_sym_PIPE,
    ACTIONS(6958), 1,
      anon_sym_AMP,
    ACTIONS(6964), 1,
      anon_sym_GT_EQ,
    ACTIONS(6970), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6972), 1,
      anon_sym_or,
    ACTIONS(6974), 1,
      anon_sym_and,
    ACTIONS(6976), 1,
      anon_sym_bitor,
    ACTIONS(6978), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6946), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6956), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6966), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6948), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6960), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6962), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6874), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [44145] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(3196), 1,
      anon_sym_STAR,
    ACTIONS(3198), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      sym_identifier,
    ACTIONS(6180), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5712), 1,
      sym__scope_resolution,
    STATE(6337), 1,
      sym__declarator,
    STATE(7870), 1,
      sym_ms_based_modifier,
    ACTIONS(3268), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2928), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3899), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3266), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [44254] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2428), 1,
      sym_attribute_specifier,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5907), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5905), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [44321] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5545), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5547), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [44384] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7096), 1,
      sym_identifier,
    ACTIONS(7098), 1,
      anon_sym_STAR,
    ACTIONS(7100), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7102), 1,
      anon_sym_AMP,
    ACTIONS(7104), 1,
      anon_sym_COLON_COLON,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5750), 1,
      sym__scope_resolution,
    STATE(6337), 1,
      sym__declarator,
    STATE(8303), 1,
      sym_ms_based_modifier,
    ACTIONS(3268), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3851), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3916), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3266), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [44493] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(5708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7134), 1,
      anon_sym_STAR,
    ACTIONS(7136), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7138), 1,
      anon_sym_AMP,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5765), 1,
      sym__scope_resolution,
    STATE(6495), 1,
      sym__declarator,
    STATE(7968), 1,
      sym_ms_based_modifier,
    ACTIONS(3268), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2915), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3926), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3266), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [44602] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5578), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5580), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [44665] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6919), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6922), 1,
      anon_sym_LBRACK,
    ACTIONS(6924), 1,
      anon_sym_const,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(6944), 1,
      anon_sym_requires,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(6984), 1,
      anon_sym_DASH_GT,
    STATE(3934), 1,
      sym_alignas_qualifier,
    STATE(4754), 1,
      sym__function_attributes_start,
    STATE(4905), 1,
      sym_ref_qualifier,
    STATE(5490), 1,
      sym_trailing_return_type,
    STATE(5849), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6926), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(4048), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4217), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5755), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5236), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6905), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
    ACTIONS(6911), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [44782] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(5708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7156), 1,
      anon_sym_STAR,
    ACTIONS(7158), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7160), 1,
      anon_sym_AMP,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5765), 1,
      sym__scope_resolution,
    STATE(6041), 1,
      sym__declarator,
    STATE(8182), 1,
      sym_ms_based_modifier,
    ACTIONS(3268), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3851), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3893), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3266), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [44891] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(7086), 1,
      anon_sym_STAR,
    ACTIONS(7088), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7090), 1,
      anon_sym_AMP,
    ACTIONS(7092), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5732), 1,
      sym__scope_resolution,
    STATE(6066), 1,
      sym__declarator,
    STATE(7827), 1,
      sym_ms_based_modifier,
    ACTIONS(3268), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3851), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3887), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3266), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [45000] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6644), 1,
      anon_sym___attribute__,
    ACTIONS(6646), 1,
      anon_sym___attribute,
    ACTIONS(6882), 1,
      anon_sym_LBRACE,
    STATE(2950), 1,
      sym_enumerator_list,
    STATE(3419), 1,
      sym_attribute_specifier,
    ACTIONS(5834), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5836), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [45073] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(5708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7134), 1,
      anon_sym_STAR,
    ACTIONS(7136), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7138), 1,
      anon_sym_AMP,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5765), 1,
      sym__scope_resolution,
    STATE(6532), 1,
      sym__declarator,
    STATE(7968), 1,
      sym_ms_based_modifier,
    ACTIONS(3268), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3851), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3914), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3266), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [45182] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7114), 1,
      anon_sym_LPAREN2,
    ACTIONS(7116), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7118), 1,
      anon_sym_LBRACK,
    STATE(3295), 1,
      sym_parameter_list,
    STATE(3034), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5891), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5893), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [45255] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5327), 1,
      sym_identifier,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7106), 1,
      anon_sym_STAR,
    ACTIONS(7108), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7110), 1,
      anon_sym_AMP,
    ACTIONS(7112), 1,
      anon_sym_COLON_COLON,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5764), 1,
      sym__scope_resolution,
    STATE(6584), 1,
      sym__declarator,
    STATE(8019), 1,
      sym_ms_based_modifier,
    ACTIONS(3268), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3851), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3910), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3266), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [45364] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(5708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7120), 1,
      anon_sym_STAR,
    ACTIONS(7122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7124), 1,
      anon_sym_AMP,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5765), 1,
      sym__scope_resolution,
    STATE(6275), 1,
      sym__declarator,
    STATE(7915), 1,
      sym_ms_based_modifier,
    ACTIONS(3268), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3851), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3929), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3266), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [45473] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5646), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [45536] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2449), 1,
      sym_attribute_specifier,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5988), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5986), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [45603] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2581), 1,
      anon_sym_LBRACE,
    ACTIONS(6986), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6990), 1,
      sym_auto,
    ACTIONS(6992), 1,
      anon_sym_decltype,
    STATE(3342), 1,
      sym_new_declarator,
    STATE(3469), 1,
      sym_decltype_auto,
    STATE(3833), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5716), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5718), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [45682] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6922), 1,
      anon_sym_LBRACK,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7129), 1,
      anon_sym___asm,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7144), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7149), 1,
      anon_sym_DASH_GT,
    ACTIONS(7162), 1,
      anon_sym_requires,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(4767), 1,
      sym__function_attributes_start,
    STATE(4909), 1,
      sym_ref_qualifier,
    STATE(5400), 1,
      sym_trailing_return_type,
    STATE(5625), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7126), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3947), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4149), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5755), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5232), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6905), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [45799] = 52,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(6994), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6996), 1,
      anon_sym_COMMA,
    ACTIONS(7000), 1,
      anon_sym_DASH,
    ACTIONS(7002), 1,
      anon_sym_PLUS,
    ACTIONS(7004), 1,
      anon_sym_STAR,
    ACTIONS(7006), 1,
      anon_sym_SLASH,
    ACTIONS(7008), 1,
      anon_sym_PERCENT,
    ACTIONS(7010), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7014), 1,
      anon_sym_PIPE,
    ACTIONS(7016), 1,
      anon_sym_CARET,
    ACTIONS(7018), 1,
      anon_sym_AMP,
    ACTIONS(7020), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7022), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7024), 1,
      anon_sym_GT,
    ACTIONS(7026), 1,
      anon_sym_GT_EQ,
    ACTIONS(7028), 1,
      anon_sym_LT_EQ,
    ACTIONS(7030), 1,
      anon_sym_LT,
    ACTIONS(7032), 1,
      anon_sym_LT_LT,
    ACTIONS(7034), 1,
      anon_sym_GT_GT,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7038), 1,
      anon_sym_EQ,
    ACTIONS(7040), 1,
      anon_sym_QMARK,
    ACTIONS(7042), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7044), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7046), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7048), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7050), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7052), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7054), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7056), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7058), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7060), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7064), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7066), 1,
      anon_sym_or,
    ACTIONS(7068), 1,
      anon_sym_and,
    ACTIONS(7070), 1,
      anon_sym_bitor,
    ACTIONS(7072), 1,
      anon_sym_xor,
    ACTIONS(7074), 1,
      anon_sym_bitand,
    ACTIONS(7076), 1,
      anon_sym_not_eq,
    ACTIONS(7082), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7084), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7164), 1,
      anon_sym_RPAREN,
    STATE(1189), 1,
      sym__binary_fold_operator,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    STATE(8288), 1,
      sym__fold_operator,
    ACTIONS(7078), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7062), 3,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [45960] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(6806), 1,
      anon_sym_EQ,
    ACTIONS(6950), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6952), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6954), 1,
      anon_sym_PIPE,
    ACTIONS(6958), 1,
      anon_sym_AMP,
    ACTIONS(6964), 1,
      anon_sym_GT_EQ,
    ACTIONS(6970), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6972), 1,
      anon_sym_or,
    ACTIONS(6974), 1,
      anon_sym_and,
    ACTIONS(6976), 1,
      anon_sym_bitor,
    ACTIONS(6978), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6946), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6956), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6966), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6948), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6960), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6962), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6808), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [46069] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2455), 1,
      sym_attribute_specifier,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5992), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5990), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [46136] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2581), 1,
      anon_sym_LBRACE,
    ACTIONS(6986), 1,
      anon_sym_LPAREN2,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    ACTIONS(6990), 1,
      sym_auto,
    ACTIONS(6992), 1,
      anon_sym_decltype,
    STATE(3333), 1,
      sym_new_declarator,
    STATE(3469), 1,
      sym_decltype_auto,
    STATE(3859), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5712), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5714), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [46215] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7114), 1,
      anon_sym_LPAREN2,
    ACTIONS(7116), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7118), 1,
      anon_sym_LBRACK,
    STATE(3295), 1,
      sym_parameter_list,
    STATE(3034), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5943), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5945), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [46288] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(3196), 1,
      anon_sym_STAR,
    ACTIONS(3198), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      sym_identifier,
    ACTIONS(6180), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5712), 1,
      sym__scope_resolution,
    STATE(6376), 1,
      sym__declarator,
    STATE(7870), 1,
      sym_ms_based_modifier,
    ACTIONS(3268), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3851), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3886), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3266), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [46397] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(3196), 1,
      anon_sym_STAR,
    ACTIONS(3198), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      sym_identifier,
    ACTIONS(6180), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5712), 1,
      sym__scope_resolution,
    STATE(6337), 1,
      sym__declarator,
    STATE(7870), 1,
      sym_ms_based_modifier,
    ACTIONS(3268), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3851), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(3899), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3266), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [46506] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6922), 1,
      anon_sym_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7144), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7151), 1,
      anon_sym_requires,
    ACTIONS(7166), 1,
      anon_sym___attribute__,
    ACTIONS(7169), 1,
      anon_sym___attribute,
    ACTIONS(7172), 1,
      anon_sym_DASH_GT,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(4828), 1,
      sym__function_attributes_start,
    STATE(4977), 1,
      sym_ref_qualifier,
    STATE(5379), 1,
      sym_trailing_return_type,
    STATE(5792), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6934), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3947), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4149), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5755), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5262), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6905), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [46622] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6922), 1,
      anon_sym_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7174), 1,
      anon_sym_DASH_GT,
    ACTIONS(7179), 1,
      anon_sym_requires,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(4805), 1,
      sym__function_attributes_start,
    STATE(4954), 1,
      sym_ref_qualifier,
    STATE(5841), 1,
      sym_trailing_return_type,
    STATE(6047), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7176), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3947), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4149), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5975), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5260), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6905), 5,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [46738] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7188), 1,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(7186), 2,
      anon_sym_delete,
      anon_sym_new,
    ACTIONS(7184), 20,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_not,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(7182), 31,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_compl,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_co_await,
      anon_sym_DASH_GT_STAR,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LBRACK_RBRACK,
  [46804] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6802), 1,
      anon_sym_LBRACE,
    ACTIONS(7190), 1,
      anon_sym_COLON,
    STATE(2401), 1,
      sym_attribute_specifier,
    STATE(2745), 1,
      sym__enum_base_clause,
    STATE(2906), 1,
      sym_enumerator_list,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6247), 7,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6245), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [46878] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7192), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7196), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7194), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6263), 11,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6265), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [46960] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6794), 1,
      sym_auto,
    ACTIONS(6796), 1,
      anon_sym_decltype,
    STATE(3081), 1,
      sym_decltype_auto,
    ACTIONS(5391), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5393), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [47028] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7198), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(2936), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6067), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6069), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [47094] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5640), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5642), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [47156] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5383), 1,
      anon_sym_COLON,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    STATE(2448), 1,
      sym_attribute_specifier,
    STATE(3616), 1,
      sym_field_declaration_list,
    STATE(7015), 1,
      sym_virtual_specifier,
    STATE(7715), 1,
      sym_base_class_clause,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5375), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5377), 39,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [47236] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5626), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5628), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [47298] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6922), 1,
      anon_sym_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7144), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7162), 1,
      anon_sym_requires,
    ACTIONS(7166), 1,
      anon_sym___attribute__,
    ACTIONS(7169), 1,
      anon_sym___attribute,
    ACTIONS(7172), 1,
      anon_sym_DASH_GT,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(4826), 1,
      sym__function_attributes_start,
    STATE(4936), 1,
      sym_ref_qualifier,
    STATE(5400), 1,
      sym_trailing_return_type,
    STATE(5788), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3947), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4149), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5755), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5271), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6905), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [47414] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6644), 1,
      anon_sym___attribute__,
    ACTIONS(6646), 1,
      anon_sym___attribute,
    STATE(3362), 1,
      sym_attribute_specifier,
    ACTIONS(5887), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5889), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [47482] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5622), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5624), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [47544] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2967), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7201), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5803), 6,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5801), 43,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [47610] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5660), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5662), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [47672] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5445), 1,
      anon_sym_LBRACE,
    ACTIONS(5433), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
    ACTIONS(5431), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [47736] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5600), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5602), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [47798] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5664), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5666), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [47860] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5365), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5431), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5433), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [47924] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5537), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5539), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [47986] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6644), 1,
      anon_sym___attribute__,
    ACTIONS(6646), 1,
      anon_sym___attribute,
    STATE(3337), 1,
      sym_attribute_specifier,
    ACTIONS(5980), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5982), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [48054] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5502), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5504), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [48116] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5365), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5445), 1,
      anon_sym_LBRACE,
    ACTIONS(5433), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
    ACTIONS(5431), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [48182] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2968), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7203), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5746), 6,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5744), 43,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [48248] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6802), 1,
      anon_sym_LBRACE,
    ACTIONS(7190), 1,
      anon_sym_COLON,
    STATE(2420), 1,
      sym_attribute_specifier,
    STATE(2792), 1,
      sym__enum_base_clause,
    STATE(2894), 1,
      sym_enumerator_list,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6163), 7,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6161), 40,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [48322] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5510), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5512), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [48384] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5514), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5516), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [48446] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6644), 1,
      anon_sym___attribute__,
    ACTIONS(6646), 1,
      anon_sym___attribute,
    STATE(3427), 1,
      sym_attribute_specifier,
    ACTIONS(5917), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5919), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [48514] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7205), 1,
      anon_sym_LT,
    STATE(2551), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2692), 1,
      sym_template_argument_list,
    ACTIONS(4061), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4041), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4033), 36,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [48586] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5648), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5650), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [48648] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5672), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5674), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [48710] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5652), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5654), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [48772] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2581), 1,
      anon_sym_LBRACE,
    ACTIONS(7207), 1,
      anon_sym_LPAREN2,
    STATE(2545), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3343), 1,
      sym_argument_list,
    STATE(3775), 1,
      sym_initializer_list,
    ACTIONS(6628), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5433), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
    ACTIONS(5431), 36,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [48846] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7210), 1,
      anon_sym_LPAREN2,
    ACTIONS(7212), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7214), 1,
      anon_sym_LBRACK,
    STATE(3437), 1,
      sym_parameter_list,
    STATE(3118), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5943), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5945), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [48918] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(7216), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7218), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7220), 1,
      anon_sym_PIPE,
    ACTIONS(7224), 1,
      anon_sym_AMP,
    ACTIONS(7230), 1,
      anon_sym_GT_EQ,
    ACTIONS(7232), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7234), 1,
      anon_sym_or,
    ACTIONS(7236), 1,
      anon_sym_and,
    ACTIONS(7238), 1,
      anon_sym_bitor,
    ACTIONS(7240), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6806), 2,
      anon_sym___attribute,
      anon_sym_EQ,
    ACTIONS(7192), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7196), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7222), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7194), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7226), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7228), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6808), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [49026] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6644), 1,
      anon_sym___attribute__,
    ACTIONS(6646), 1,
      anon_sym___attribute,
    STATE(3338), 1,
      sym_attribute_specifier,
    ACTIONS(5986), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5988), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [49094] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7210), 1,
      anon_sym_LPAREN2,
    ACTIONS(7212), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7214), 1,
      anon_sym_LBRACK,
    STATE(3437), 1,
      sym_parameter_list,
    STATE(3118), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5921), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5923), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [49166] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1894), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7242), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5795), 6,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5793), 43,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [49232] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1894), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7242), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5782), 6,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5780), 43,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [49298] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6644), 1,
      anon_sym___attribute__,
    ACTIONS(6646), 1,
      anon_sym___attribute,
    STATE(3400), 1,
      sym_attribute_specifier,
    ACTIONS(5947), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5949), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [49366] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7250), 1,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(7248), 2,
      anon_sym_delete,
      anon_sym_new,
    ACTIONS(7246), 20,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_not,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(7244), 31,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_compl,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_co_await,
      anon_sym_DASH_GT_STAR,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LBRACK_RBRACK,
  [49432] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2031), 1,
      anon_sym_LBRACE,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    STATE(3474), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6053), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6055), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [49500] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5502), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5504), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [49562] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7252), 1,
      anon_sym_typedef,
    ACTIONS(2526), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2536), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [49626] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3015), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7254), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5740), 6,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5738), 43,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [49692] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7256), 1,
      anon_sym_namespace,
    ACTIONS(6711), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6709), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [49756] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3016), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7258), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5762), 6,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5760), 43,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [49822] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(6840), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7216), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7218), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7220), 1,
      anon_sym_PIPE,
    ACTIONS(7224), 1,
      anon_sym_AMP,
    ACTIONS(7230), 1,
      anon_sym_GT_EQ,
    ACTIONS(7232), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7234), 1,
      anon_sym_or,
    ACTIONS(7236), 1,
      anon_sym_and,
    ACTIONS(7238), 1,
      anon_sym_bitor,
    ACTIONS(7240), 1,
      anon_sym_bitand,
    ACTIONS(7260), 1,
      anon_sym_QMARK,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6543), 2,
      anon_sym___attribute,
      anon_sym_EQ,
    ACTIONS(7192), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7196), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7222), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7194), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7226), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7228), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6545), 16,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [49934] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5433), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5431), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [49996] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7262), 1,
      anon_sym_namespace,
    ACTIONS(6711), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6709), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [50060] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5529), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5531), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [50122] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5541), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5543), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [50184] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6922), 1,
      anon_sym_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7144), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7264), 1,
      anon_sym_DASH_GT,
    ACTIONS(7266), 1,
      anon_sym_requires,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(4844), 1,
      sym__function_attributes_start,
    STATE(4980), 1,
      sym_ref_qualifier,
    STATE(5970), 1,
      sym__function_attributes_end,
    STATE(6119), 1,
      sym_trailing_return_type,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6934), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3947), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4149), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5755), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5254), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6905), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [50300] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7210), 1,
      anon_sym_LPAREN2,
    ACTIONS(7212), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7214), 1,
      anon_sym_LBRACK,
    STATE(3437), 1,
      sym_parameter_list,
    STATE(3118), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5891), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5893), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [50372] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3025), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7269), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5545), 6,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5547), 43,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [50438] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2031), 1,
      anon_sym_LBRACE,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    STATE(3391), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6145), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6147), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [50506] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3784), 1,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(7271), 2,
      anon_sym_delete,
      anon_sym_new,
    ACTIONS(3762), 20,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_not,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(3760), 31,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_compl,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_co_await,
      anon_sym_DASH_GT_STAR,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LBRACK_RBRACK,
  [50572] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1894), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7242), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5778), 6,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5776), 43,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [50638] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4855), 1,
      anon_sym_const,
    ACTIONS(4866), 1,
      anon_sym_AMP,
    ACTIONS(4859), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK,
    ACTIONS(4864), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(4862), 18,
      anon_sym___extension__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(4857), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [50708] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5549), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5551), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [50770] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(7218), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7220), 1,
      anon_sym_PIPE,
    ACTIONS(7224), 1,
      anon_sym_AMP,
    ACTIONS(7230), 1,
      anon_sym_GT_EQ,
    ACTIONS(7232), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7236), 1,
      anon_sym_and,
    ACTIONS(7238), 1,
      anon_sym_bitor,
    ACTIONS(7240), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7192), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7196), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7222), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6263), 3,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
    ACTIONS(7194), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7226), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7228), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [50874] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(7220), 1,
      anon_sym_PIPE,
    ACTIONS(7224), 1,
      anon_sym_AMP,
    ACTIONS(7230), 1,
      anon_sym_GT_EQ,
    ACTIONS(7232), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7238), 1,
      anon_sym_bitor,
    ACTIONS(7240), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7192), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7196), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7222), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7194), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7226), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7228), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6263), 4,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(6265), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [50974] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(7224), 1,
      anon_sym_AMP,
    ACTIONS(7230), 1,
      anon_sym_GT_EQ,
    ACTIONS(7232), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7240), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7192), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7196), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7222), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7194), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7226), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7228), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6263), 5,
      anon_sym_PIPE,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(6265), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
  [51070] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(7224), 1,
      anon_sym_AMP,
    ACTIONS(7230), 1,
      anon_sym_GT_EQ,
    ACTIONS(7232), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7240), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7192), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7196), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7194), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7226), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7228), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6263), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6265), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
  [51164] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(7230), 1,
      anon_sym_GT_EQ,
    ACTIONS(7232), 1,
      anon_sym_LT_EQ_GT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7192), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7196), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7194), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7226), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7228), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6263), 8,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6265), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
  [51254] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(7230), 1,
      anon_sym_GT_EQ,
    ACTIONS(7232), 1,
      anon_sym_LT_EQ_GT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7192), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7196), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7194), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7228), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6263), 8,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6265), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [51342] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(7232), 1,
      anon_sym_LT_EQ_GT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7192), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7196), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7194), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6263), 11,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6265), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [51426] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5553), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5555), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [51488] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6922), 1,
      anon_sym_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7273), 1,
      anon_sym_DASH_GT,
    ACTIONS(7275), 1,
      anon_sym_requires,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(4800), 1,
      sym__function_attributes_start,
    STATE(4986), 1,
      sym_ref_qualifier,
    STATE(5930), 1,
      sym_trailing_return_type,
    STATE(6049), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7176), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3947), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4149), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5975), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5255), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6905), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [51604] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5431), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5433), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [51666] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5502), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5504), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [51728] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7278), 1,
      anon_sym_friend,
    ACTIONS(2526), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2536), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [51792] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7192), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7194), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6263), 13,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6265), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [51872] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4845), 1,
      anon_sym_LBRACE,
    ACTIONS(5451), 1,
      anon_sym_LT,
    STATE(3162), 1,
      sym_template_argument_list,
    ACTIONS(4847), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4840), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [51942] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5533), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5535), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [52004] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6922), 1,
      anon_sym_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7166), 1,
      anon_sym___attribute__,
    ACTIONS(7169), 1,
      anon_sym___attribute,
    ACTIONS(7280), 1,
      anon_sym_DASH_GT,
    ACTIONS(7284), 1,
      anon_sym_requires,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(4802), 1,
      sym__function_attributes_start,
    STATE(4929), 1,
      sym_ref_qualifier,
    STATE(5832), 1,
      sym_trailing_return_type,
    STATE(5863), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3947), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4149), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5975), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5249), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6905), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [52120] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6922), 1,
      anon_sym_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7166), 1,
      anon_sym___attribute__,
    ACTIONS(7169), 1,
      anon_sym___attribute,
    ACTIONS(7179), 1,
      anon_sym_requires,
    ACTIONS(7280), 1,
      anon_sym_DASH_GT,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(4803), 1,
      sym__function_attributes_start,
    STATE(4970), 1,
      sym_ref_qualifier,
    STATE(5841), 1,
      sym_trailing_return_type,
    STATE(5867), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7176), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3947), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4149), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5975), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5278), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6905), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [52236] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7210), 1,
      anon_sym_LPAREN2,
    ACTIONS(7212), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7214), 1,
      anon_sym_LBRACK,
    STATE(3437), 1,
      sym_parameter_list,
    STATE(3118), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5909), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5911), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [52308] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6644), 1,
      anon_sym___attribute__,
    ACTIONS(6646), 1,
      anon_sym___attribute,
    STATE(3413), 1,
      sym_attribute_specifier,
    ACTIONS(5905), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5907), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [52376] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7292), 1,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(7290), 2,
      anon_sym_delete,
      anon_sym_new,
    ACTIONS(7288), 20,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_not,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(7286), 31,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_compl,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_co_await,
      anon_sym_DASH_GT_STAR,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LBRACK_RBRACK,
  [52442] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2031), 1,
      anon_sym_LBRACE,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    STATE(3491), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6079), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6081), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [52510] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5564), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5566), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [52572] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7294), 1,
      anon_sym_namespace,
    ACTIONS(6711), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6709), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [52636] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6644), 1,
      anon_sym___attribute__,
    ACTIONS(6646), 1,
      anon_sym___attribute,
    STATE(3340), 1,
      sym_attribute_specifier,
    ACTIONS(5990), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5992), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [52704] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5498), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5500), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [52766] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1894), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7242), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5752), 6,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5750), 43,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [52832] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1894), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7242), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5758), 6,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5756), 43,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [52898] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5668), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5670), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [52960] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7210), 1,
      anon_sym_LPAREN2,
    ACTIONS(7212), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7214), 1,
      anon_sym_LBRACK,
    STATE(3437), 1,
      sym_parameter_list,
    STATE(3118), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6017), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6019), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [53032] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7296), 1,
      anon_sym_friend,
    ACTIONS(2526), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2536), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [53096] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5676), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5678), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [53158] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7304), 1,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(7302), 2,
      anon_sym_delete,
      anon_sym_new,
    ACTIONS(7300), 20,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_not,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(7298), 31,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_compl,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_co_await,
      anon_sym_DASH_GT_STAR,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LBRACK_RBRACK,
  [53224] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6644), 1,
      anon_sym___attribute__,
    ACTIONS(6646), 1,
      anon_sym___attribute,
    STATE(3424), 1,
      sym_attribute_specifier,
    ACTIONS(5913), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5915), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [53292] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7306), 1,
      anon_sym_namespace,
    ACTIONS(6711), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6709), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [53356] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5596), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5598), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [53418] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1894), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7242), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5768), 6,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5766), 43,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [53484] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7308), 1,
      anon_sym_typedef,
    ACTIONS(2526), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2536), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [53548] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7310), 1,
      anon_sym_friend,
    ACTIONS(2526), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2536), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [53612] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(7216), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7218), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7220), 1,
      anon_sym_PIPE,
    ACTIONS(7224), 1,
      anon_sym_AMP,
    ACTIONS(7230), 1,
      anon_sym_GT_EQ,
    ACTIONS(7232), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7234), 1,
      anon_sym_or,
    ACTIONS(7236), 1,
      anon_sym_and,
    ACTIONS(7238), 1,
      anon_sym_bitor,
    ACTIONS(7240), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6868), 2,
      anon_sym___attribute,
      anon_sym_EQ,
    ACTIONS(7192), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7196), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7222), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7194), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7226), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7228), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6870), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [53720] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5680), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5682), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [53782] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(7216), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7218), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7220), 1,
      anon_sym_PIPE,
    ACTIONS(7224), 1,
      anon_sym_AMP,
    ACTIONS(7230), 1,
      anon_sym_GT_EQ,
    ACTIONS(7232), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7234), 1,
      anon_sym_or,
    ACTIONS(7236), 1,
      anon_sym_and,
    ACTIONS(7238), 1,
      anon_sym_bitor,
    ACTIONS(7240), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6844), 2,
      anon_sym___attribute,
      anon_sym_EQ,
    ACTIONS(7192), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7196), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7222), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7194), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7226), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7228), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6846), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [53890] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6644), 1,
      anon_sym___attribute__,
    ACTIONS(6646), 1,
      anon_sym___attribute,
    STATE(3376), 1,
      sym_attribute_specifier,
    ACTIONS(5901), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5903), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [53958] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3792), 1,
      anon_sym_DQUOTE_DQUOTE,
    ACTIONS(7312), 2,
      anon_sym_delete,
      anon_sym_new,
    ACTIONS(3788), 20,
      anon_sym_BANG,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_not,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DASH_GT,
    ACTIONS(3786), 31,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_compl,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_co_await,
      anon_sym_DASH_GT_STAR,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LBRACK_RBRACK,
  [54024] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6644), 1,
      anon_sym___attribute__,
    ACTIONS(6646), 1,
      anon_sym___attribute,
    STATE(3403), 1,
      sym_attribute_specifier,
    ACTIONS(5969), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5971), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [54092] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7116), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(2936), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6149), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6151), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [54158] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5498), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5500), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [54220] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7314), 1,
      anon_sym_friend,
    ACTIONS(2526), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2536), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [54284] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7318), 25,
      anon_sym_LPAREN2,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      sym_number_literal,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(7316), 29,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym___extension__,
      sym_primitive_type,
      anon_sym_not,
      anon_sym_compl,
      anon_sym_sizeof,
      anon_sym___alignof__,
      anon_sym___alignof,
      anon_sym__alignof,
      anon_sym_alignof,
      anon_sym__Alignof,
      anon_sym_offsetof,
      anon_sym__Generic,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_true,
      sym_false,
      anon_sym_NULL,
      anon_sym_nullptr,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_delete,
      anon_sym_co_await,
      anon_sym_new,
      anon_sym_requires,
      sym_this,
  [54346] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3025), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7269), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5431), 6,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5433), 43,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [54412] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(6840), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7216), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7218), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7220), 1,
      anon_sym_PIPE,
    ACTIONS(7224), 1,
      anon_sym_AMP,
    ACTIONS(7230), 1,
      anon_sym_GT_EQ,
    ACTIONS(7232), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7234), 1,
      anon_sym_or,
    ACTIONS(7236), 1,
      anon_sym_and,
    ACTIONS(7238), 1,
      anon_sym_bitor,
    ACTIONS(7240), 1,
      anon_sym_bitand,
    ACTIONS(7260), 1,
      anon_sym_QMARK,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6848), 2,
      anon_sym___attribute,
      anon_sym_EQ,
    ACTIONS(7192), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7196), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7222), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7194), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7226), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7228), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6850), 16,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [54524] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2031), 1,
      anon_sym_LBRACE,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    STATE(3435), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6088), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6090), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [54592] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7320), 1,
      anon_sym_friend,
    ACTIONS(2526), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2536), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [54656] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(7216), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7218), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7220), 1,
      anon_sym_PIPE,
    ACTIONS(7224), 1,
      anon_sym_AMP,
    ACTIONS(7230), 1,
      anon_sym_GT_EQ,
    ACTIONS(7232), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7234), 1,
      anon_sym_or,
    ACTIONS(7236), 1,
      anon_sym_and,
    ACTIONS(7238), 1,
      anon_sym_bitor,
    ACTIONS(7240), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6872), 2,
      anon_sym___attribute,
      anon_sym_EQ,
    ACTIONS(7192), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7196), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7222), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7194), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7226), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7228), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6874), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [54764] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(7216), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7218), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7220), 1,
      anon_sym_PIPE,
    ACTIONS(7224), 1,
      anon_sym_AMP,
    ACTIONS(7230), 1,
      anon_sym_GT_EQ,
    ACTIONS(7232), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7234), 1,
      anon_sym_or,
    ACTIONS(7236), 1,
      anon_sym_and,
    ACTIONS(7238), 1,
      anon_sym_bitor,
    ACTIONS(7240), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6852), 2,
      anon_sym___attribute,
      anon_sym_EQ,
    ACTIONS(7192), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7196), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7222), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7194), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7226), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7228), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6854), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [54872] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4862), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(4864), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4857), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [54936] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7322), 1,
      anon_sym_friend,
    ACTIONS(2526), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2536), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [55000] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5618), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5620), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [55062] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5568), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5570), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [55124] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5431), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5433), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [55186] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2526), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2536), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_template,
      anon_sym_operator,
  [55248] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7194), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6263), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6265), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [55326] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7324), 1,
      anon_sym_friend,
    ACTIONS(2526), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2536), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [55390] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(6840), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7216), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7218), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7220), 1,
      anon_sym_PIPE,
    ACTIONS(7224), 1,
      anon_sym_AMP,
    ACTIONS(7230), 1,
      anon_sym_GT_EQ,
    ACTIONS(7232), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7234), 1,
      anon_sym_or,
    ACTIONS(7236), 1,
      anon_sym_and,
    ACTIONS(7238), 1,
      anon_sym_bitor,
    ACTIONS(7240), 1,
      anon_sym_bitand,
    ACTIONS(7260), 1,
      anon_sym_QMARK,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6856), 2,
      anon_sym___attribute,
      anon_sym_EQ,
    ACTIONS(7192), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7196), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7222), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7194), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7226), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7228), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6858), 16,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [55502] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6922), 1,
      anon_sym_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7174), 1,
      anon_sym_DASH_GT,
    ACTIONS(7284), 1,
      anon_sym_requires,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(4806), 1,
      sym__function_attributes_start,
    STATE(4930), 1,
      sym_ref_qualifier,
    STATE(5832), 1,
      sym_trailing_return_type,
    STATE(6097), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3947), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4149), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5975), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5269), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6905), 5,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [55618] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6711), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6709), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_template,
      anon_sym_operator,
  [55680] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6922), 1,
      anon_sym_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7273), 1,
      anon_sym_DASH_GT,
    ACTIONS(7326), 1,
      anon_sym_requires,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(4804), 1,
      sym__function_attributes_start,
    STATE(4982), 1,
      sym_ref_qualifier,
    STATE(5976), 1,
      sym_trailing_return_type,
    STATE(6067), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3947), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4149), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5975), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5274), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6905), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [55796] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5572), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5574), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [55858] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7328), 1,
      anon_sym_typedef,
    ACTIONS(2526), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2536), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [55922] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2570), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(3474), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(3478), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5797), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5799), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [55990] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6644), 1,
      anon_sym___attribute__,
    ACTIONS(6646), 1,
      anon_sym___attribute,
    STATE(3361), 1,
      sym_attribute_specifier,
    ACTIONS(5951), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5953), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [56058] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1894), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7242), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5791), 6,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5789), 43,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [56124] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5632), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [56186] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5371), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5373), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [56248] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6644), 1,
      anon_sym___attribute__,
    ACTIONS(6646), 1,
      anon_sym___attribute,
    STATE(3335), 1,
      sym_attribute_specifier,
    ACTIONS(5976), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5978), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [56316] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6922), 1,
      anon_sym_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7144), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7264), 1,
      anon_sym_DASH_GT,
    ACTIONS(7330), 1,
      anon_sym_requires,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(4839), 1,
      sym__function_attributes_start,
    STATE(4953), 1,
      sym_ref_qualifier,
    STATE(5979), 1,
      sym__function_attributes_end,
    STATE(6105), 1,
      sym_trailing_return_type,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3947), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4149), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5755), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5273), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6905), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [56432] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7332), 1,
      anon_sym_DOT_STAR,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    ACTIONS(7078), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6281), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6283), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [56507] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5431), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5433), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [56568] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7205), 1,
      anon_sym_LT,
    STATE(2692), 1,
      sym_template_argument_list,
    ACTIONS(4845), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4838), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
  [56635] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2456), 1,
      anon_sym_LBRACE,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    STATE(3562), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6145), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6147), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [56702] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7334), 1,
      anon_sym_LT,
    STATE(3044), 1,
      sym_template_argument_list,
    ACTIONS(6320), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6322), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [56767] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7337), 1,
      sym_identifier,
    STATE(3070), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(7340), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(7343), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5260), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5258), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [56836] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6899), 1,
      sym_literal_suffix,
    ACTIONS(4035), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(4043), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
  [56899] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5632), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [56960] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5640), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5642), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [57021] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5622), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5624), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [57082] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6763), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6761), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [57143] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5600), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5602), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [57204] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7353), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7349), 4,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(7351), 5,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_explicit,
      anon_sym_operator,
    ACTIONS(7356), 11,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_auto,
      anon_sym_typename,
    ACTIONS(7346), 31,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
  [57271] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5431), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5433), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [57332] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5646), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [57393] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5545), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5547), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [57454] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5626), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5628), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [57515] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7358), 1,
      anon_sym_LT,
    STATE(3252), 1,
      sym_template_argument_list,
    ACTIONS(6200), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6202), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [57582] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5578), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5580), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [57643] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    STATE(1570), 1,
      sym_template_argument_list,
    STATE(3485), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5842), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5844), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [57712] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7363), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(6343), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6345), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [57775] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_EQ,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7064), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7332), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7369), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7371), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7373), 1,
      anon_sym_PIPE,
    ACTIONS(7377), 1,
      anon_sym_AMP,
    ACTIONS(7383), 1,
      anon_sym_GT_EQ,
    ACTIONS(7387), 1,
      anon_sym_or,
    ACTIONS(7389), 1,
      anon_sym_and,
    ACTIONS(7391), 1,
      anon_sym_bitor,
    ACTIONS(7393), 1,
      anon_sym_bitand,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    ACTIONS(7078), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7365), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7375), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7385), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7367), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7379), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7381), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6808), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [57882] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(6872), 1,
      anon_sym_EQ,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7064), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7332), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7369), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7371), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7373), 1,
      anon_sym_PIPE,
    ACTIONS(7377), 1,
      anon_sym_AMP,
    ACTIONS(7383), 1,
      anon_sym_GT_EQ,
    ACTIONS(7387), 1,
      anon_sym_or,
    ACTIONS(7389), 1,
      anon_sym_and,
    ACTIONS(7391), 1,
      anon_sym_bitor,
    ACTIONS(7393), 1,
      anon_sym_bitand,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    ACTIONS(7078), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7365), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7375), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7385), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7367), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7379), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7381), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6874), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [57989] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5668), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5670), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [58050] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5676), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5678), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [58111] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(6844), 1,
      anon_sym_EQ,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7064), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7332), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7369), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7371), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7373), 1,
      anon_sym_PIPE,
    ACTIONS(7377), 1,
      anon_sym_AMP,
    ACTIONS(7383), 1,
      anon_sym_GT_EQ,
    ACTIONS(7387), 1,
      anon_sym_or,
    ACTIONS(7389), 1,
      anon_sym_and,
    ACTIONS(7391), 1,
      anon_sym_bitor,
    ACTIONS(7393), 1,
      anon_sym_bitand,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    ACTIONS(7078), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7365), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7375), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7385), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7367), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7379), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7381), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6846), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [58218] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6896), 1,
      anon_sym_LBRACK,
    ACTIONS(7205), 1,
      anon_sym_LT,
    STATE(2551), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3913), 1,
      sym_template_argument_list,
    ACTIONS(4056), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4061), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4041), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_EQ,
    ACTIONS(4033), 35,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [58293] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5502), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5504), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [58354] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5510), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5512), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [58415] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5514), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5516), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [58476] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5502), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5504), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [58537] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5502), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5504), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [58598] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2456), 1,
      anon_sym_LBRACE,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    STATE(3641), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6088), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6090), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [58665] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(6848), 1,
      anon_sym_EQ,
    ACTIONS(6994), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7040), 1,
      anon_sym_QMARK,
    ACTIONS(7064), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7332), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7369), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7371), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7373), 1,
      anon_sym_PIPE,
    ACTIONS(7377), 1,
      anon_sym_AMP,
    ACTIONS(7383), 1,
      anon_sym_GT_EQ,
    ACTIONS(7387), 1,
      anon_sym_or,
    ACTIONS(7389), 1,
      anon_sym_and,
    ACTIONS(7391), 1,
      anon_sym_bitor,
    ACTIONS(7393), 1,
      anon_sym_bitand,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    ACTIONS(7078), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7365), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7375), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7385), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7367), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7379), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7381), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6850), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [58776] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7332), 1,
      anon_sym_DOT_STAR,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    ACTIONS(7078), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6349), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6351), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [58851] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7332), 1,
      anon_sym_DOT_STAR,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    ACTIONS(7078), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6331), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6333), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [58926] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7205), 1,
      anon_sym_LT,
    STATE(2692), 1,
      sym_template_argument_list,
    ACTIONS(4059), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(5720), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
  [58993] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7395), 1,
      anon_sym_LT,
    STATE(1508), 1,
      sym_template_argument_list,
    ACTIONS(6320), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6322), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [59058] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6543), 1,
      anon_sym_EQ,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(6994), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7040), 1,
      anon_sym_QMARK,
    ACTIONS(7064), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7332), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7369), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7371), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7373), 1,
      anon_sym_PIPE,
    ACTIONS(7377), 1,
      anon_sym_AMP,
    ACTIONS(7383), 1,
      anon_sym_GT_EQ,
    ACTIONS(7387), 1,
      anon_sym_or,
    ACTIONS(7389), 1,
      anon_sym_and,
    ACTIONS(7391), 1,
      anon_sym_bitor,
    ACTIONS(7393), 1,
      anon_sym_bitand,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    ACTIONS(7078), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7365), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7375), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7385), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7367), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7379), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7381), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6545), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [59169] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3820), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3818), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [59230] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2456), 1,
      anon_sym_LBRACE,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    STATE(3508), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6053), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6055), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [59297] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6711), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6709), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [59358] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5592), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5594), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [59419] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(6852), 1,
      anon_sym_EQ,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7064), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7332), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7369), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7371), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7373), 1,
      anon_sym_PIPE,
    ACTIONS(7377), 1,
      anon_sym_AMP,
    ACTIONS(7383), 1,
      anon_sym_GT_EQ,
    ACTIONS(7387), 1,
      anon_sym_or,
    ACTIONS(7389), 1,
      anon_sym_and,
    ACTIONS(7391), 1,
      anon_sym_bitor,
    ACTIONS(7393), 1,
      anon_sym_bitand,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    ACTIONS(7078), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7365), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7375), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7385), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7367), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7379), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7381), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6854), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [59526] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6922), 1,
      anon_sym_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7398), 1,
      anon_sym_DASH_GT,
    ACTIONS(7400), 1,
      anon_sym_requires,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(4852), 1,
      sym__function_attributes_start,
    STATE(5051), 1,
      sym_ref_qualifier,
    STATE(6147), 1,
      sym__function_attributes_end,
    STATE(6184), 1,
      sym_trailing_return_type,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3947), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4149), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5975), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5284), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6905), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [59641] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2570), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(3474), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(3478), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5797), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5799), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [59708] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5529), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5531), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [59769] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7332), 1,
      anon_sym_DOT_STAR,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6363), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6365), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT_STAR,
  [59842] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6922), 1,
      anon_sym_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7398), 1,
      anon_sym_DASH_GT,
    ACTIONS(7402), 1,
      anon_sym_requires,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(4871), 1,
      sym__function_attributes_start,
    STATE(5053), 1,
      sym_ref_qualifier,
    STATE(6102), 1,
      sym_trailing_return_type,
    STATE(6131), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7176), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3947), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4149), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5975), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5280), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6905), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [59957] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5656), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5658), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [60018] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4845), 1,
      anon_sym_LBRACE,
    ACTIONS(5612), 1,
      anon_sym_LT,
    STATE(3296), 1,
      sym_template_argument_list,
    ACTIONS(4847), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4840), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [60087] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5541), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5543), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [60148] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7395), 1,
      anon_sym_LT,
    STATE(2832), 1,
      sym_template_argument_list,
    ACTIONS(6320), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6322), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [60213] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7212), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(3157), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6149), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6151), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [60278] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5549), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5551), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [60339] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7395), 1,
      anon_sym_LT,
    STATE(1519), 1,
      sym_template_argument_list,
    ACTIONS(6320), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6322), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [60404] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5553), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5555), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [60465] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5498), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5500), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [60526] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5596), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5598), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [60587] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5680), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5682), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [60648] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7332), 1,
      anon_sym_DOT_STAR,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    ACTIONS(7078), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6316), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6318), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [60723] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5498), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5500), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [60784] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7332), 1,
      anon_sym_DOT_STAR,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6277), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6279), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT_STAR,
  [60857] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2456), 1,
      anon_sym_LBRACE,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    STATE(3511), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6079), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6081), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [60924] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7332), 1,
      anon_sym_DOT_STAR,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    ACTIONS(7078), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7367), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6263), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6265), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [61001] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7332), 1,
      anon_sym_DOT_STAR,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    ACTIONS(7078), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6263), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6265), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [61076] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5648), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5650), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [61137] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7064), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7332), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7371), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7373), 1,
      anon_sym_PIPE,
    ACTIONS(7377), 1,
      anon_sym_AMP,
    ACTIONS(7383), 1,
      anon_sym_GT_EQ,
    ACTIONS(7389), 1,
      anon_sym_and,
    ACTIONS(7391), 1,
      anon_sym_bitor,
    ACTIONS(7393), 1,
      anon_sym_bitand,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    ACTIONS(6263), 2,
      anon_sym_EQ,
      anon_sym_or,
    ACTIONS(7078), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7365), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7375), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7385), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7367), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7379), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7381), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [61240] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7064), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7332), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7373), 1,
      anon_sym_PIPE,
    ACTIONS(7377), 1,
      anon_sym_AMP,
    ACTIONS(7383), 1,
      anon_sym_GT_EQ,
    ACTIONS(7391), 1,
      anon_sym_bitor,
    ACTIONS(7393), 1,
      anon_sym_bitand,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    ACTIONS(7078), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7365), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7375), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7385), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6263), 3,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(7367), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7379), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7381), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [61339] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7064), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7332), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7377), 1,
      anon_sym_AMP,
    ACTIONS(7383), 1,
      anon_sym_GT_EQ,
    ACTIONS(7393), 1,
      anon_sym_bitand,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    ACTIONS(7078), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7365), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7375), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7385), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7367), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7379), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7381), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6263), 4,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(6265), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_DASH_GT_STAR,
  [61434] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7064), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7332), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7377), 1,
      anon_sym_AMP,
    ACTIONS(7383), 1,
      anon_sym_GT_EQ,
    ACTIONS(7393), 1,
      anon_sym_bitand,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    ACTIONS(7078), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7365), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7385), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7367), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7379), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7381), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6263), 6,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6265), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_DASH_GT_STAR,
  [61527] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7064), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7332), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7383), 1,
      anon_sym_GT_EQ,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    ACTIONS(7078), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7365), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7385), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7367), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7379), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7381), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6263), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6265), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_DASH_GT_STAR,
  [61616] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5618), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5620), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [61677] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7064), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7332), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7383), 1,
      anon_sym_GT_EQ,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    ACTIONS(7078), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7365), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7385), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7367), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7381), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6263), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6265), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [61764] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7064), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7332), 1,
      anon_sym_DOT_STAR,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    ACTIONS(7078), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7365), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7385), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7367), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6263), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6265), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [61847] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7332), 1,
      anon_sym_DOT_STAR,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    ACTIONS(7078), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7365), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7367), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6263), 12,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6265), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [61926] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7332), 1,
      anon_sym_DOT_STAR,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    ACTIONS(7078), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7365), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7385), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7367), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6263), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6265), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [62007] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7405), 1,
      anon_sym_LT,
    STATE(3252), 1,
      sym_template_argument_list,
    ACTIONS(6211), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6213), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [62074] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7408), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(6343), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6345), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [62137] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3824), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3822), 47,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_typename,
      anon_sym_template,
      anon_sym_operator,
  [62198] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7334), 1,
      anon_sym_LT,
    STATE(1668), 1,
      sym_template_argument_list,
    ACTIONS(6320), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6322), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [62263] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5660), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5662), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [62324] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5664), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5666), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [62385] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5672), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5674), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [62446] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5564), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5566), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [62507] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6903), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6901), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
  [62568] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5568), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5570), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [62629] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5572), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5574), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [62690] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(6868), 1,
      anon_sym_EQ,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7064), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7332), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7369), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7371), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7373), 1,
      anon_sym_PIPE,
    ACTIONS(7377), 1,
      anon_sym_AMP,
    ACTIONS(7383), 1,
      anon_sym_GT_EQ,
    ACTIONS(7387), 1,
      anon_sym_or,
    ACTIONS(7389), 1,
      anon_sym_and,
    ACTIONS(7391), 1,
      anon_sym_bitor,
    ACTIONS(7393), 1,
      anon_sym_bitand,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    ACTIONS(7078), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7365), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7375), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7385), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7367), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7379), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7381), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6870), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [62797] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7205), 1,
      anon_sym_LT,
    ACTIONS(7412), 1,
      anon_sym_EQ,
    STATE(2551), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2692), 1,
      sym_template_argument_list,
    ACTIONS(7410), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(4061), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4041), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4033), 36,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [62872] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5652), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5654), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [62933] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5533), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5535), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [62994] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7414), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(3157), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6067), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6069), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [63059] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6751), 1,
      anon_sym_LBRACK,
    STATE(3202), 1,
      sym_new_declarator,
    ACTIONS(6192), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6194), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [63124] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5506), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5508), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [63185] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5383), 1,
      anon_sym_COLON,
    ACTIONS(7417), 1,
      anon_sym_LBRACE,
    STATE(3930), 1,
      sym_field_declaration_list,
    STATE(4059), 1,
      sym_attribute_specifier,
    STATE(6845), 1,
      sym_virtual_specifier,
    STATE(7460), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5876), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5375), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5377), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [63262] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7419), 1,
      sym_identifier,
    STATE(3165), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(5858), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(5860), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5276), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5274), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [63331] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4862), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(4864), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4857), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [63394] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(6856), 1,
      anon_sym_EQ,
    ACTIONS(6994), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7040), 1,
      anon_sym_QMARK,
    ACTIONS(7064), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7332), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7369), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7371), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7373), 1,
      anon_sym_PIPE,
    ACTIONS(7377), 1,
      anon_sym_AMP,
    ACTIONS(7383), 1,
      anon_sym_GT_EQ,
    ACTIONS(7387), 1,
      anon_sym_or,
    ACTIONS(7389), 1,
      anon_sym_and,
    ACTIONS(7391), 1,
      anon_sym_bitor,
    ACTIONS(7393), 1,
      anon_sym_bitand,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    ACTIONS(7078), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7365), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7375), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7385), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7367), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7379), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7381), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6858), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_DASH_GT_STAR,
  [63505] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5537), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5539), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [63566] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7421), 1,
      sym_identifier,
    STATE(3070), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(5858), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(5860), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5253), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5251), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [63635] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6922), 1,
      anon_sym_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7166), 1,
      anon_sym___attribute__,
    ACTIONS(7169), 1,
      anon_sym___attribute,
    ACTIONS(7400), 1,
      anon_sym_requires,
    ACTIONS(7423), 1,
      anon_sym_DASH_GT,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(4914), 1,
      sym__function_attributes_start,
    STATE(5133), 1,
      sym_ref_qualifier,
    STATE(6069), 1,
      sym__function_attributes_end,
    STATE(6184), 1,
      sym_trailing_return_type,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3947), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4149), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5975), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(6905), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
    STATE(5296), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [63749] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5815), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5813), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [63809] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7429), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7431), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7433), 1,
      anon_sym_PIPE,
    ACTIONS(7437), 1,
      anon_sym_AMP,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7449), 1,
      anon_sym_or,
    ACTIONS(7451), 1,
      anon_sym_and,
    ACTIONS(7453), 1,
      anon_sym_bitor,
    ACTIONS(7455), 1,
      anon_sym_bitand,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(6844), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(7425), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7435), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7443), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7457), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7427), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7439), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7441), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6846), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [63913] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7429), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7431), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7433), 1,
      anon_sym_PIPE,
    ACTIONS(7437), 1,
      anon_sym_AMP,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7449), 1,
      anon_sym_or,
    ACTIONS(7451), 1,
      anon_sym_and,
    ACTIONS(7453), 1,
      anon_sym_bitor,
    ACTIONS(7455), 1,
      anon_sym_bitand,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(6868), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(7425), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7435), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7443), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7457), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7427), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7439), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7441), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6870), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [64017] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5142), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5144), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [64077] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6343), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6345), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [64137] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5371), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5373), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [64197] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7463), 1,
      sym_literal_suffix,
    ACTIONS(4043), 25,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4035), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [64259] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1909), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(1907), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [64319] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5114), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5116), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [64379] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5365), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5431), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5433), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [64441] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6463), 1,
      anon_sym_LT,
    STATE(1570), 1,
      sym_template_argument_list,
    ACTIONS(4838), 6,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(4845), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [64507] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5170), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5172), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [64567] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7465), 1,
      anon_sym_LT,
    STATE(3162), 1,
      sym_template_argument_list,
    ACTIONS(6320), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6322), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [64631] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3822), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3824), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [64691] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6037), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6039), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [64751] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4895), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5871), 1,
      anon_sym_LBRACK,
    ACTIONS(5868), 2,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    ACTIONS(4043), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4035), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [64817] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6049), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6051), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [64877] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7465), 1,
      anon_sym_LT,
    STATE(1850), 1,
      sym_template_argument_list,
    ACTIONS(6320), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6322), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [64941] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(6543), 1,
      anon_sym_EQ,
    ACTIONS(6840), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6950), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6952), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6954), 1,
      anon_sym_PIPE,
    ACTIONS(6958), 1,
      anon_sym_AMP,
    ACTIONS(6964), 1,
      anon_sym_GT_EQ,
    ACTIONS(6968), 1,
      anon_sym_QMARK,
    ACTIONS(6970), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6972), 1,
      anon_sym_or,
    ACTIONS(6974), 1,
      anon_sym_and,
    ACTIONS(6976), 1,
      anon_sym_bitor,
    ACTIONS(6978), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6946), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6956), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6966), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7468), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(6948), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6960), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6962), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6545), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [65053] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6922), 1,
      anon_sym_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7144), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7162), 1,
      anon_sym_requires,
    ACTIONS(7470), 1,
      anon_sym_DASH_GT,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(4918), 1,
      sym__function_attributes_start,
    STATE(5140), 1,
      sym_ref_qualifier,
    STATE(5400), 1,
      sym_trailing_return_type,
    STATE(6164), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3947), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4149), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5755), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(6905), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(5316), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [65167] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7429), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7431), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7433), 1,
      anon_sym_PIPE,
    ACTIONS(7437), 1,
      anon_sym_AMP,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7449), 1,
      anon_sym_or,
    ACTIONS(7451), 1,
      anon_sym_and,
    ACTIONS(7453), 1,
      anon_sym_bitor,
    ACTIONS(7455), 1,
      anon_sym_bitand,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(6872), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(7425), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7435), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7443), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7457), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7427), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7439), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7441), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6874), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [65271] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6463), 1,
      anon_sym_LT,
    STATE(1570), 1,
      sym_template_argument_list,
    ACTIONS(5720), 6,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(4059), 43,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [65337] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(7457), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7427), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6263), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6265), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [65413] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(7457), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6263), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6265), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [65487] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6922), 1,
      anon_sym_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7144), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7151), 1,
      anon_sym_requires,
    ACTIONS(7470), 1,
      anon_sym_DASH_GT,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(4902), 1,
      sym__function_attributes_start,
    STATE(5144), 1,
      sym_ref_qualifier,
    STATE(5379), 1,
      sym_trailing_return_type,
    STATE(6193), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6934), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3947), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4149), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5755), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(6905), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(5295), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [65601] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6021), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6023), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [65661] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7082), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7084), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7472), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7474), 1,
      anon_sym_COMMA,
    ACTIONS(7476), 1,
      anon_sym_RPAREN,
    ACTIONS(7478), 1,
      anon_sym_DASH,
    ACTIONS(7480), 1,
      anon_sym_PLUS,
    ACTIONS(7482), 1,
      anon_sym_STAR,
    ACTIONS(7484), 1,
      anon_sym_SLASH,
    ACTIONS(7486), 1,
      anon_sym_PERCENT,
    ACTIONS(7488), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7490), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7492), 1,
      anon_sym_PIPE,
    ACTIONS(7494), 1,
      anon_sym_CARET,
    ACTIONS(7496), 1,
      anon_sym_AMP,
    ACTIONS(7498), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7500), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7502), 1,
      anon_sym_GT,
    ACTIONS(7504), 1,
      anon_sym_GT_EQ,
    ACTIONS(7506), 1,
      anon_sym_LT_EQ,
    ACTIONS(7508), 1,
      anon_sym_LT,
    ACTIONS(7510), 1,
      anon_sym_LT_LT,
    ACTIONS(7512), 1,
      anon_sym_GT_GT,
    ACTIONS(7514), 1,
      anon_sym_EQ,
    ACTIONS(7516), 1,
      anon_sym_QMARK,
    ACTIONS(7518), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7520), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7522), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7524), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7526), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7528), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7530), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7532), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7534), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7536), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7540), 1,
      anon_sym_or,
    ACTIONS(7542), 1,
      anon_sym_and,
    ACTIONS(7544), 1,
      anon_sym_bitor,
    ACTIONS(7546), 1,
      anon_sym_xor,
    ACTIONS(7548), 1,
      anon_sym_bitand,
    ACTIONS(7550), 1,
      anon_sym_not_eq,
    STATE(1189), 1,
      sym__binary_fold_operator,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    STATE(8288), 1,
      sym__fold_operator,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7552), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [65817] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6255), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6257), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [65877] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7431), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7433), 1,
      anon_sym_PIPE,
    ACTIONS(7437), 1,
      anon_sym_AMP,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7451), 1,
      anon_sym_and,
    ACTIONS(7453), 1,
      anon_sym_bitor,
    ACTIONS(7455), 1,
      anon_sym_bitand,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(7425), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7435), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7443), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7457), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6263), 3,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
    ACTIONS(7427), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7439), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7441), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [65977] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7433), 1,
      anon_sym_PIPE,
    ACTIONS(7437), 1,
      anon_sym_AMP,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7453), 1,
      anon_sym_bitor,
    ACTIONS(7455), 1,
      anon_sym_bitand,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(7425), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7435), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7443), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7457), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7427), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7439), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6263), 4,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(7441), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [66073] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7429), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7431), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7433), 1,
      anon_sym_PIPE,
    ACTIONS(7437), 1,
      anon_sym_AMP,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7449), 1,
      anon_sym_or,
    ACTIONS(7451), 1,
      anon_sym_and,
    ACTIONS(7453), 1,
      anon_sym_bitor,
    ACTIONS(7455), 1,
      anon_sym_bitand,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    ACTIONS(7554), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7556), 1,
      anon_sym_QMARK,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(6848), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(7425), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7435), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7443), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7457), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7427), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7439), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7441), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6850), 14,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [66181] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7082), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7084), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7472), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7474), 1,
      anon_sym_COMMA,
    ACTIONS(7478), 1,
      anon_sym_DASH,
    ACTIONS(7480), 1,
      anon_sym_PLUS,
    ACTIONS(7482), 1,
      anon_sym_STAR,
    ACTIONS(7484), 1,
      anon_sym_SLASH,
    ACTIONS(7486), 1,
      anon_sym_PERCENT,
    ACTIONS(7488), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7490), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7492), 1,
      anon_sym_PIPE,
    ACTIONS(7494), 1,
      anon_sym_CARET,
    ACTIONS(7496), 1,
      anon_sym_AMP,
    ACTIONS(7498), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7500), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7502), 1,
      anon_sym_GT,
    ACTIONS(7504), 1,
      anon_sym_GT_EQ,
    ACTIONS(7506), 1,
      anon_sym_LT_EQ,
    ACTIONS(7508), 1,
      anon_sym_LT,
    ACTIONS(7510), 1,
      anon_sym_LT_LT,
    ACTIONS(7512), 1,
      anon_sym_GT_GT,
    ACTIONS(7514), 1,
      anon_sym_EQ,
    ACTIONS(7516), 1,
      anon_sym_QMARK,
    ACTIONS(7518), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7520), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7522), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7524), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7526), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7528), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7530), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7532), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7534), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7536), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7540), 1,
      anon_sym_or,
    ACTIONS(7542), 1,
      anon_sym_and,
    ACTIONS(7544), 1,
      anon_sym_bitor,
    ACTIONS(7546), 1,
      anon_sym_xor,
    ACTIONS(7548), 1,
      anon_sym_bitand,
    ACTIONS(7550), 1,
      anon_sym_not_eq,
    ACTIONS(7558), 1,
      anon_sym_RPAREN,
    STATE(1189), 1,
      sym__binary_fold_operator,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    STATE(8288), 1,
      sym__fold_operator,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7552), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [66337] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5122), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5124), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [66397] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7437), 1,
      anon_sym_AMP,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7455), 1,
      anon_sym_bitand,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(7425), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7435), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7443), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7457), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7427), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7439), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7441), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6263), 5,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(6265), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_GT2,
  [66489] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5122), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5124), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [66549] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6295), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6297), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [66609] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7437), 1,
      anon_sym_AMP,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7455), 1,
      anon_sym_bitand,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(7425), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7443), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7457), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7427), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7439), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7441), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6263), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6265), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_GT2,
  [66699] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7082), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7084), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7472), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7474), 1,
      anon_sym_COMMA,
    ACTIONS(7478), 1,
      anon_sym_DASH,
    ACTIONS(7480), 1,
      anon_sym_PLUS,
    ACTIONS(7482), 1,
      anon_sym_STAR,
    ACTIONS(7484), 1,
      anon_sym_SLASH,
    ACTIONS(7486), 1,
      anon_sym_PERCENT,
    ACTIONS(7488), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7490), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7492), 1,
      anon_sym_PIPE,
    ACTIONS(7494), 1,
      anon_sym_CARET,
    ACTIONS(7496), 1,
      anon_sym_AMP,
    ACTIONS(7498), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7500), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7502), 1,
      anon_sym_GT,
    ACTIONS(7504), 1,
      anon_sym_GT_EQ,
    ACTIONS(7506), 1,
      anon_sym_LT_EQ,
    ACTIONS(7508), 1,
      anon_sym_LT,
    ACTIONS(7510), 1,
      anon_sym_LT_LT,
    ACTIONS(7512), 1,
      anon_sym_GT_GT,
    ACTIONS(7514), 1,
      anon_sym_EQ,
    ACTIONS(7516), 1,
      anon_sym_QMARK,
    ACTIONS(7518), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7520), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7522), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7524), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7526), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7528), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7530), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7532), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7534), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7536), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7540), 1,
      anon_sym_or,
    ACTIONS(7542), 1,
      anon_sym_and,
    ACTIONS(7544), 1,
      anon_sym_bitor,
    ACTIONS(7546), 1,
      anon_sym_xor,
    ACTIONS(7548), 1,
      anon_sym_bitand,
    ACTIONS(7550), 1,
      anon_sym_not_eq,
    ACTIONS(7560), 1,
      anon_sym_RPAREN,
    STATE(1189), 1,
      sym__binary_fold_operator,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    STATE(8288), 1,
      sym__fold_operator,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7552), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [66855] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(7425), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7443), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7457), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7427), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7439), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7441), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6263), 8,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6265), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_GT2,
  [66941] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(7425), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7443), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7457), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7427), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7441), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6263), 8,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6265), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [67025] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7334), 1,
      anon_sym_LT,
    STATE(1524), 1,
      sym_template_argument_list,
    ACTIONS(6320), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6322), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [67089] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(7425), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7443), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7457), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7427), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6263), 12,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6265), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [67171] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7562), 1,
      anon_sym_LT,
    STATE(3421), 1,
      sym_template_argument_list,
    ACTIONS(6200), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6202), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [67237] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5126), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5128), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [67297] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(6840), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6950), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6952), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6954), 1,
      anon_sym_PIPE,
    ACTIONS(6958), 1,
      anon_sym_AMP,
    ACTIONS(6964), 1,
      anon_sym_GT_EQ,
    ACTIONS(6968), 1,
      anon_sym_QMARK,
    ACTIONS(6970), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(6972), 1,
      anon_sym_or,
    ACTIONS(6974), 1,
      anon_sym_and,
    ACTIONS(6976), 1,
      anon_sym_bitor,
    ACTIONS(6978), 1,
      anon_sym_bitand,
    ACTIONS(7164), 1,
      anon_sym_RPAREN,
    ACTIONS(7565), 1,
      anon_sym_COMMA,
    ACTIONS(7567), 1,
      anon_sym_EQ,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6946), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(6956), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(6966), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6948), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6960), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6962), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(7062), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [67411] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7429), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7431), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7433), 1,
      anon_sym_PIPE,
    ACTIONS(7437), 1,
      anon_sym_AMP,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7449), 1,
      anon_sym_or,
    ACTIONS(7451), 1,
      anon_sym_and,
    ACTIONS(7453), 1,
      anon_sym_bitor,
    ACTIONS(7455), 1,
      anon_sym_bitand,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(6852), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(7425), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7435), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7443), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7457), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7427), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7439), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7441), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6854), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [67515] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(7425), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7457), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7427), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6263), 14,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6265), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [67593] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6277), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6279), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_GT2,
  [67665] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4895), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5871), 1,
      anon_sym_LBRACK,
    ACTIONS(5868), 2,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    ACTIONS(4043), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4035), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [67731] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4840), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [67791] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3818), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3820), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [67851] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3720), 1,
      sym_ms_unaligned_ptr_modifier,
    ACTIONS(7576), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3218), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(7573), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7571), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT2,
    ACTIONS(7569), 33,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [67919] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7082), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7084), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7472), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7474), 1,
      anon_sym_COMMA,
    ACTIONS(7478), 1,
      anon_sym_DASH,
    ACTIONS(7480), 1,
      anon_sym_PLUS,
    ACTIONS(7482), 1,
      anon_sym_STAR,
    ACTIONS(7484), 1,
      anon_sym_SLASH,
    ACTIONS(7486), 1,
      anon_sym_PERCENT,
    ACTIONS(7488), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7490), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7492), 1,
      anon_sym_PIPE,
    ACTIONS(7494), 1,
      anon_sym_CARET,
    ACTIONS(7496), 1,
      anon_sym_AMP,
    ACTIONS(7498), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7500), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7502), 1,
      anon_sym_GT,
    ACTIONS(7504), 1,
      anon_sym_GT_EQ,
    ACTIONS(7506), 1,
      anon_sym_LT_EQ,
    ACTIONS(7508), 1,
      anon_sym_LT,
    ACTIONS(7510), 1,
      anon_sym_LT_LT,
    ACTIONS(7512), 1,
      anon_sym_GT_GT,
    ACTIONS(7514), 1,
      anon_sym_EQ,
    ACTIONS(7516), 1,
      anon_sym_QMARK,
    ACTIONS(7518), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7520), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7522), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7524), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7526), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7528), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7530), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7532), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7534), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7536), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7540), 1,
      anon_sym_or,
    ACTIONS(7542), 1,
      anon_sym_and,
    ACTIONS(7544), 1,
      anon_sym_bitor,
    ACTIONS(7546), 1,
      anon_sym_xor,
    ACTIONS(7548), 1,
      anon_sym_bitand,
    ACTIONS(7550), 1,
      anon_sym_not_eq,
    ACTIONS(7579), 1,
      anon_sym_RPAREN,
    STATE(1189), 1,
      sym__binary_fold_operator,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    STATE(8288), 1,
      sym__fold_operator,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7552), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [68075] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4067), 1,
      anon_sym_EQ,
    ACTIONS(4071), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(4043), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4035), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [68139] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6922), 1,
      anon_sym_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7166), 1,
      anon_sym___attribute__,
    ACTIONS(7169), 1,
      anon_sym___attribute,
    ACTIONS(7402), 1,
      anon_sym_requires,
    ACTIONS(7423), 1,
      anon_sym_DASH_GT,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(4919), 1,
      sym__function_attributes_start,
    STATE(5146), 1,
      sym_ref_qualifier,
    STATE(6084), 1,
      sym__function_attributes_end,
    STATE(6102), 1,
      sym_trailing_return_type,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7176), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3947), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4149), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5975), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(6905), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
    STATE(5306), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [68253] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(7425), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7443), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7457), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7427), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6263), 12,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6265), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [68333] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4840), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [68393] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6141), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6143), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [68453] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6116), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6118), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [68513] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(7457), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6316), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6318), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [68587] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6041), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6043), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [68647] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4840), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [68707] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7082), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7084), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7472), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7474), 1,
      anon_sym_COMMA,
    ACTIONS(7478), 1,
      anon_sym_DASH,
    ACTIONS(7480), 1,
      anon_sym_PLUS,
    ACTIONS(7482), 1,
      anon_sym_STAR,
    ACTIONS(7484), 1,
      anon_sym_SLASH,
    ACTIONS(7486), 1,
      anon_sym_PERCENT,
    ACTIONS(7488), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7490), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7492), 1,
      anon_sym_PIPE,
    ACTIONS(7494), 1,
      anon_sym_CARET,
    ACTIONS(7496), 1,
      anon_sym_AMP,
    ACTIONS(7498), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7500), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7502), 1,
      anon_sym_GT,
    ACTIONS(7504), 1,
      anon_sym_GT_EQ,
    ACTIONS(7506), 1,
      anon_sym_LT_EQ,
    ACTIONS(7508), 1,
      anon_sym_LT,
    ACTIONS(7510), 1,
      anon_sym_LT_LT,
    ACTIONS(7512), 1,
      anon_sym_GT_GT,
    ACTIONS(7514), 1,
      anon_sym_EQ,
    ACTIONS(7516), 1,
      anon_sym_QMARK,
    ACTIONS(7518), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7520), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7522), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7524), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7526), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7528), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7530), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7532), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7534), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7536), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7540), 1,
      anon_sym_or,
    ACTIONS(7542), 1,
      anon_sym_and,
    ACTIONS(7544), 1,
      anon_sym_bitor,
    ACTIONS(7546), 1,
      anon_sym_xor,
    ACTIONS(7548), 1,
      anon_sym_bitand,
    ACTIONS(7550), 1,
      anon_sym_not_eq,
    ACTIONS(7581), 1,
      anon_sym_RPAREN,
    STATE(1189), 1,
      sym__binary_fold_operator,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    STATE(8288), 1,
      sym__fold_operator,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7552), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [68863] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4840), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [68923] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5130), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5132), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [68983] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(7457), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6281), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6283), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [69057] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6922), 1,
      anon_sym_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7166), 1,
      anon_sym___attribute__,
    ACTIONS(7169), 1,
      anon_sym___attribute,
    ACTIONS(7326), 1,
      anon_sym_requires,
    ACTIONS(7583), 1,
      anon_sym_DASH_GT,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(4911), 1,
      sym__function_attributes_start,
    STATE(5173), 1,
      sym_ref_qualifier,
    STATE(5976), 1,
      sym_trailing_return_type,
    STATE(6050), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3947), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4149), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5975), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(6905), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    STATE(5298), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [69171] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6155), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6157), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [69231] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5815), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5813), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [69291] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7429), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7431), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7433), 1,
      anon_sym_PIPE,
    ACTIONS(7437), 1,
      anon_sym_AMP,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7449), 1,
      anon_sym_or,
    ACTIONS(7451), 1,
      anon_sym_and,
    ACTIONS(7453), 1,
      anon_sym_bitor,
    ACTIONS(7455), 1,
      anon_sym_bitand,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(6806), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(7425), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7435), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7443), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7457), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7427), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7439), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7441), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6808), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [69395] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7585), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(6343), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6345), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [69457] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7082), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7084), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7472), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7474), 1,
      anon_sym_COMMA,
    ACTIONS(7478), 1,
      anon_sym_DASH,
    ACTIONS(7480), 1,
      anon_sym_PLUS,
    ACTIONS(7482), 1,
      anon_sym_STAR,
    ACTIONS(7484), 1,
      anon_sym_SLASH,
    ACTIONS(7486), 1,
      anon_sym_PERCENT,
    ACTIONS(7488), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7490), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7492), 1,
      anon_sym_PIPE,
    ACTIONS(7494), 1,
      anon_sym_CARET,
    ACTIONS(7496), 1,
      anon_sym_AMP,
    ACTIONS(7498), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7500), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7502), 1,
      anon_sym_GT,
    ACTIONS(7504), 1,
      anon_sym_GT_EQ,
    ACTIONS(7506), 1,
      anon_sym_LT_EQ,
    ACTIONS(7508), 1,
      anon_sym_LT,
    ACTIONS(7510), 1,
      anon_sym_LT_LT,
    ACTIONS(7512), 1,
      anon_sym_GT_GT,
    ACTIONS(7514), 1,
      anon_sym_EQ,
    ACTIONS(7516), 1,
      anon_sym_QMARK,
    ACTIONS(7518), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7520), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7522), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7524), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7526), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7528), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7530), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7532), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7534), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7536), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7540), 1,
      anon_sym_or,
    ACTIONS(7542), 1,
      anon_sym_and,
    ACTIONS(7544), 1,
      anon_sym_bitor,
    ACTIONS(7546), 1,
      anon_sym_xor,
    ACTIONS(7548), 1,
      anon_sym_bitand,
    ACTIONS(7550), 1,
      anon_sym_not_eq,
    ACTIONS(7587), 1,
      anon_sym_RPAREN,
    STATE(1189), 1,
      sym__binary_fold_operator,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    STATE(8288), 1,
      sym__fold_operator,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7552), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [69613] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7082), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7084), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7472), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7474), 1,
      anon_sym_COMMA,
    ACTIONS(7478), 1,
      anon_sym_DASH,
    ACTIONS(7480), 1,
      anon_sym_PLUS,
    ACTIONS(7482), 1,
      anon_sym_STAR,
    ACTIONS(7484), 1,
      anon_sym_SLASH,
    ACTIONS(7486), 1,
      anon_sym_PERCENT,
    ACTIONS(7488), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7490), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7492), 1,
      anon_sym_PIPE,
    ACTIONS(7494), 1,
      anon_sym_CARET,
    ACTIONS(7496), 1,
      anon_sym_AMP,
    ACTIONS(7498), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7500), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7502), 1,
      anon_sym_GT,
    ACTIONS(7504), 1,
      anon_sym_GT_EQ,
    ACTIONS(7506), 1,
      anon_sym_LT_EQ,
    ACTIONS(7508), 1,
      anon_sym_LT,
    ACTIONS(7510), 1,
      anon_sym_LT_LT,
    ACTIONS(7512), 1,
      anon_sym_GT_GT,
    ACTIONS(7514), 1,
      anon_sym_EQ,
    ACTIONS(7516), 1,
      anon_sym_QMARK,
    ACTIONS(7518), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7520), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7522), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7524), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7526), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7528), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7530), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7532), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7534), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7536), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7540), 1,
      anon_sym_or,
    ACTIONS(7542), 1,
      anon_sym_and,
    ACTIONS(7544), 1,
      anon_sym_bitor,
    ACTIONS(7546), 1,
      anon_sym_xor,
    ACTIONS(7548), 1,
      anon_sym_bitand,
    ACTIONS(7550), 1,
      anon_sym_not_eq,
    ACTIONS(7589), 1,
      anon_sym_RPAREN,
    STATE(1189), 1,
      sym__binary_fold_operator,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    STATE(8288), 1,
      sym__fold_operator,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7552), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [69769] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6990), 1,
      sym_auto,
    ACTIONS(6992), 1,
      anon_sym_decltype,
    STATE(3469), 1,
      sym_decltype_auto,
    ACTIONS(5391), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5393), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [69835] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6343), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6345), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [69895] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6602), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7594), 1,
      anon_sym_virtual,
    ACTIONS(7603), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7606), 1,
      anon_sym___declspec,
    STATE(1619), 1,
      sym_alignas_qualifier,
    ACTIONS(7600), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(7609), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3242), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(7597), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(7591), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(6600), 14,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
  [69973] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5166), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5168), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [70033] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7612), 1,
      anon_sym_LT,
    STATE(1829), 1,
      sym_template_argument_list,
    STATE(1896), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4897), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4033), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(4041), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
  [70103] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4067), 1,
      anon_sym_EQ,
    ACTIONS(4895), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5868), 1,
      anon_sym_LPAREN2,
    ACTIONS(5871), 1,
      anon_sym_LBRACK,
    ACTIONS(4071), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(4043), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4035), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [70173] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4895), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5868), 1,
      anon_sym_LPAREN2,
    ACTIONS(5871), 1,
      anon_sym_LBRACK,
    ACTIONS(4043), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4035), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [70239] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(7457), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6349), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6351), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [70313] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(7457), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6331), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6333), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [70387] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6922), 1,
      anon_sym_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7166), 1,
      anon_sym___attribute__,
    ACTIONS(7169), 1,
      anon_sym___attribute,
    ACTIONS(7275), 1,
      anon_sym_requires,
    ACTIONS(7583), 1,
      anon_sym_DASH_GT,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(4921), 1,
      sym__function_attributes_start,
    STATE(5156), 1,
      sym_ref_qualifier,
    STATE(5930), 1,
      sym_trailing_return_type,
    STATE(6012), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7176), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3947), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4149), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5975), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(6905), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    STATE(5290), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [70501] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    STATE(1570), 1,
      sym_template_argument_list,
    STATE(1896), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4897), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5842), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(5844), 34,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
  [70569] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4840), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [70629] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4862), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6188), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6190), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [70691] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5122), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5124), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [70751] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6901), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(6903), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [70811] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5174), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5176), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [70871] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7614), 1,
      anon_sym_LT,
    STATE(3421), 1,
      sym_template_argument_list,
    ACTIONS(6211), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6213), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [70937] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6802), 1,
      anon_sym_LBRACE,
    ACTIONS(7617), 1,
      anon_sym_COLON,
    STATE(2401), 1,
      sym_attribute_specifier,
    STATE(2745), 1,
      sym__enum_base_clause,
    STATE(2906), 1,
      sym_enumerator_list,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6247), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6245), 34,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [71009] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6363), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6365), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_GT2,
  [71081] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6802), 1,
      anon_sym_LBRACE,
    ACTIONS(7617), 1,
      anon_sym_COLON,
    STATE(2420), 1,
      sym_attribute_specifier,
    STATE(2792), 1,
      sym__enum_base_clause,
    STATE(2894), 1,
      sym_enumerator_list,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6163), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(6161), 34,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [71153] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    STATE(3366), 1,
      sym_new_declarator,
    ACTIONS(6192), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6194), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [71217] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6363), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6365), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [71289] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6868), 1,
      anon_sym_EQ,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    ACTIONS(7627), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7629), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7631), 1,
      anon_sym_PIPE,
    ACTIONS(7635), 1,
      anon_sym_AMP,
    ACTIONS(7641), 1,
      anon_sym_GT_EQ,
    ACTIONS(7645), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7647), 1,
      anon_sym_or,
    ACTIONS(7649), 1,
      anon_sym_and,
    ACTIONS(7651), 1,
      anon_sym_bitor,
    ACTIONS(7653), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7623), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7633), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7643), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7625), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7637), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7639), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6870), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [71395] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6349), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6351), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [71469] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6331), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6333), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [71543] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6872), 1,
      anon_sym_EQ,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    ACTIONS(7627), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7629), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7631), 1,
      anon_sym_PIPE,
    ACTIONS(7635), 1,
      anon_sym_AMP,
    ACTIONS(7641), 1,
      anon_sym_GT_EQ,
    ACTIONS(7645), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7647), 1,
      anon_sym_or,
    ACTIONS(7649), 1,
      anon_sym_and,
    ACTIONS(7651), 1,
      anon_sym_bitor,
    ACTIONS(7653), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7623), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7633), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7643), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7625), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7637), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7639), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6874), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [71649] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6277), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6279), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [71721] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6806), 1,
      anon_sym_EQ,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    ACTIONS(7627), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7629), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7631), 1,
      anon_sym_PIPE,
    ACTIONS(7635), 1,
      anon_sym_AMP,
    ACTIONS(7641), 1,
      anon_sym_GT_EQ,
    ACTIONS(7645), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7647), 1,
      anon_sym_or,
    ACTIONS(7649), 1,
      anon_sym_and,
    ACTIONS(7651), 1,
      anon_sym_bitor,
    ACTIONS(7653), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7623), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7633), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7643), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7625), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7637), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7639), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6808), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [71827] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6543), 1,
      anon_sym_EQ,
    ACTIONS(6840), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    ACTIONS(7627), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7629), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7631), 1,
      anon_sym_PIPE,
    ACTIONS(7635), 1,
      anon_sym_AMP,
    ACTIONS(7641), 1,
      anon_sym_GT_EQ,
    ACTIONS(7645), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7647), 1,
      anon_sym_or,
    ACTIONS(7649), 1,
      anon_sym_and,
    ACTIONS(7651), 1,
      anon_sym_bitor,
    ACTIONS(7653), 1,
      anon_sym_bitand,
    ACTIONS(7655), 1,
      anon_sym_QMARK,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7623), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7633), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7643), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7625), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7637), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7639), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6545), 15,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [71937] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7625), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6263), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6265), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [72013] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6263), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6265), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [72087] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    ACTIONS(7629), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7631), 1,
      anon_sym_PIPE,
    ACTIONS(7635), 1,
      anon_sym_AMP,
    ACTIONS(7641), 1,
      anon_sym_GT_EQ,
    ACTIONS(7645), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7649), 1,
      anon_sym_and,
    ACTIONS(7651), 1,
      anon_sym_bitor,
    ACTIONS(7653), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6263), 2,
      anon_sym_EQ,
      anon_sym_or,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7623), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7633), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7643), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7625), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7637), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7639), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [72189] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    ACTIONS(7631), 1,
      anon_sym_PIPE,
    ACTIONS(7635), 1,
      anon_sym_AMP,
    ACTIONS(7641), 1,
      anon_sym_GT_EQ,
    ACTIONS(7645), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7651), 1,
      anon_sym_bitor,
    ACTIONS(7653), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7623), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7633), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7643), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6263), 3,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(7625), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7637), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7639), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [72287] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    ACTIONS(7635), 1,
      anon_sym_AMP,
    ACTIONS(7641), 1,
      anon_sym_GT_EQ,
    ACTIONS(7645), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7653), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7623), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7633), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7643), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7625), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7637), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7639), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6263), 4,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
    ACTIONS(6265), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
  [72381] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    ACTIONS(7635), 1,
      anon_sym_AMP,
    ACTIONS(7641), 1,
      anon_sym_GT_EQ,
    ACTIONS(7645), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7653), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7623), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7643), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7625), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7637), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7639), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6263), 6,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6265), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
  [72473] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    ACTIONS(7641), 1,
      anon_sym_GT_EQ,
    ACTIONS(7645), 1,
      anon_sym_LT_EQ_GT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7623), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7643), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7625), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7637), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7639), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6263), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6265), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
  [72561] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    ACTIONS(7641), 1,
      anon_sym_GT_EQ,
    ACTIONS(7645), 1,
      anon_sym_LT_EQ_GT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7623), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7643), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7625), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7639), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6263), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6265), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [72647] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    ACTIONS(7645), 1,
      anon_sym_LT_EQ_GT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7623), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7643), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7625), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6263), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6265), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [72729] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7623), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7625), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6263), 12,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6265), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [72807] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7623), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7643), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7625), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6263), 10,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6265), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [72887] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6281), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6283), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [72961] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7429), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7431), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7433), 1,
      anon_sym_PIPE,
    ACTIONS(7437), 1,
      anon_sym_AMP,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7449), 1,
      anon_sym_or,
    ACTIONS(7451), 1,
      anon_sym_and,
    ACTIONS(7453), 1,
      anon_sym_bitor,
    ACTIONS(7455), 1,
      anon_sym_bitand,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    ACTIONS(7554), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7556), 1,
      anon_sym_QMARK,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(6856), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(7425), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7435), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7443), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7457), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7427), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7439), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7441), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6858), 14,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [73069] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6844), 1,
      anon_sym_EQ,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    ACTIONS(7627), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7629), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7631), 1,
      anon_sym_PIPE,
    ACTIONS(7635), 1,
      anon_sym_AMP,
    ACTIONS(7641), 1,
      anon_sym_GT_EQ,
    ACTIONS(7645), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7647), 1,
      anon_sym_or,
    ACTIONS(7649), 1,
      anon_sym_and,
    ACTIONS(7651), 1,
      anon_sym_bitor,
    ACTIONS(7653), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7623), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7633), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7643), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7625), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7637), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7639), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6846), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [73175] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6840), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6848), 1,
      anon_sym_EQ,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    ACTIONS(7627), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7629), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7631), 1,
      anon_sym_PIPE,
    ACTIONS(7635), 1,
      anon_sym_AMP,
    ACTIONS(7641), 1,
      anon_sym_GT_EQ,
    ACTIONS(7645), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7647), 1,
      anon_sym_or,
    ACTIONS(7649), 1,
      anon_sym_and,
    ACTIONS(7651), 1,
      anon_sym_bitor,
    ACTIONS(7653), 1,
      anon_sym_bitand,
    ACTIONS(7655), 1,
      anon_sym_QMARK,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7623), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7633), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7643), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7625), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7637), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7639), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6850), 15,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [73285] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6852), 1,
      anon_sym_EQ,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    ACTIONS(7627), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7629), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7631), 1,
      anon_sym_PIPE,
    ACTIONS(7635), 1,
      anon_sym_AMP,
    ACTIONS(7641), 1,
      anon_sym_GT_EQ,
    ACTIONS(7645), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7647), 1,
      anon_sym_or,
    ACTIONS(7649), 1,
      anon_sym_and,
    ACTIONS(7651), 1,
      anon_sym_bitor,
    ACTIONS(7653), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7623), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7633), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7643), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7625), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7637), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7639), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6854), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [73391] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6840), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6856), 1,
      anon_sym_EQ,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    ACTIONS(7627), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7629), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7631), 1,
      anon_sym_PIPE,
    ACTIONS(7635), 1,
      anon_sym_AMP,
    ACTIONS(7641), 1,
      anon_sym_GT_EQ,
    ACTIONS(7645), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7647), 1,
      anon_sym_or,
    ACTIONS(7649), 1,
      anon_sym_and,
    ACTIONS(7651), 1,
      anon_sym_bitor,
    ACTIONS(7653), 1,
      anon_sym_bitand,
    ACTIONS(7655), 1,
      anon_sym_QMARK,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7623), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7633), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7643), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7625), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7637), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7639), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6858), 15,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
  [73501] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5854), 1,
      anon_sym_EQ,
    ACTIONS(5856), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(4043), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4035), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [73565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6395), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6397), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [73625] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5118), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5120), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [73685] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1913), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(1911), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [73745] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4840), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [73805] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6327), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6329), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [73865] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7205), 1,
      anon_sym_LT,
    ACTIONS(7412), 1,
      anon_sym_EQ,
    STATE(2692), 1,
      sym_template_argument_list,
    ACTIONS(7410), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(4059), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(5720), 39,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
  [73935] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6269), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6316), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
    ACTIONS(6318), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [74009] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7429), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7431), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7433), 1,
      anon_sym_PIPE,
    ACTIONS(7437), 1,
      anon_sym_AMP,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7447), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7449), 1,
      anon_sym_or,
    ACTIONS(7451), 1,
      anon_sym_and,
    ACTIONS(7453), 1,
      anon_sym_bitor,
    ACTIONS(7455), 1,
      anon_sym_bitand,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    ACTIONS(7554), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7556), 1,
      anon_sym_QMARK,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(6543), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(7425), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7435), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(7443), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7457), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7427), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7439), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7441), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6545), 14,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_GT2,
  [74117] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6045), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6047), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [74177] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4862), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(4864), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4857), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [74239] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6335), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6337), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [74299] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4895), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5868), 1,
      anon_sym_LPAREN2,
    ACTIONS(5871), 1,
      anon_sym_LBRACK,
    ACTIONS(4043), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4035), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [74365] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7664), 1,
      anon_sym_virtual,
    ACTIONS(7673), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7676), 1,
      anon_sym___declspec,
    ACTIONS(7682), 1,
      anon_sym_explicit,
    STATE(3049), 1,
      sym_alignas_qualifier,
    ACTIONS(7670), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(7679), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7659), 5,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
    ACTIONS(7657), 7,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym_LBRACK,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(7667), 9,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    STATE(3299), 9,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      sym_explicit_function_specifier,
      sym__constructor_specifiers,
      aux_sym_operator_cast_definition_repeat1,
    ACTIONS(7661), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [74445] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5134), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5136), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [74505] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5140), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [74565] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7082), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7084), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7472), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7474), 1,
      anon_sym_COMMA,
    ACTIONS(7478), 1,
      anon_sym_DASH,
    ACTIONS(7480), 1,
      anon_sym_PLUS,
    ACTIONS(7482), 1,
      anon_sym_STAR,
    ACTIONS(7484), 1,
      anon_sym_SLASH,
    ACTIONS(7486), 1,
      anon_sym_PERCENT,
    ACTIONS(7488), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7490), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7492), 1,
      anon_sym_PIPE,
    ACTIONS(7494), 1,
      anon_sym_CARET,
    ACTIONS(7496), 1,
      anon_sym_AMP,
    ACTIONS(7498), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7500), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7502), 1,
      anon_sym_GT,
    ACTIONS(7504), 1,
      anon_sym_GT_EQ,
    ACTIONS(7506), 1,
      anon_sym_LT_EQ,
    ACTIONS(7508), 1,
      anon_sym_LT,
    ACTIONS(7510), 1,
      anon_sym_LT_LT,
    ACTIONS(7512), 1,
      anon_sym_GT_GT,
    ACTIONS(7514), 1,
      anon_sym_EQ,
    ACTIONS(7516), 1,
      anon_sym_QMARK,
    ACTIONS(7518), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7520), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7522), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7524), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7526), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7528), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7530), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7532), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7534), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7536), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7540), 1,
      anon_sym_or,
    ACTIONS(7542), 1,
      anon_sym_and,
    ACTIONS(7544), 1,
      anon_sym_bitor,
    ACTIONS(7546), 1,
      anon_sym_xor,
    ACTIONS(7548), 1,
      anon_sym_bitand,
    ACTIONS(7550), 1,
      anon_sym_not_eq,
    ACTIONS(7685), 1,
      anon_sym_RPAREN,
    STATE(1189), 1,
      sym__binary_fold_operator,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    STATE(8288), 1,
      sym__fold_operator,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7552), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [74721] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5146), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5148), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [74781] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6395), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6397), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [74841] = 51,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7082), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7084), 1,
      anon_sym_DASH_GT_STAR,
    ACTIONS(7472), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7474), 1,
      anon_sym_COMMA,
    ACTIONS(7478), 1,
      anon_sym_DASH,
    ACTIONS(7480), 1,
      anon_sym_PLUS,
    ACTIONS(7482), 1,
      anon_sym_STAR,
    ACTIONS(7484), 1,
      anon_sym_SLASH,
    ACTIONS(7486), 1,
      anon_sym_PERCENT,
    ACTIONS(7488), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7490), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7492), 1,
      anon_sym_PIPE,
    ACTIONS(7494), 1,
      anon_sym_CARET,
    ACTIONS(7496), 1,
      anon_sym_AMP,
    ACTIONS(7498), 1,
      anon_sym_EQ_EQ,
    ACTIONS(7500), 1,
      anon_sym_BANG_EQ,
    ACTIONS(7502), 1,
      anon_sym_GT,
    ACTIONS(7504), 1,
      anon_sym_GT_EQ,
    ACTIONS(7506), 1,
      anon_sym_LT_EQ,
    ACTIONS(7508), 1,
      anon_sym_LT,
    ACTIONS(7510), 1,
      anon_sym_LT_LT,
    ACTIONS(7512), 1,
      anon_sym_GT_GT,
    ACTIONS(7514), 1,
      anon_sym_EQ,
    ACTIONS(7516), 1,
      anon_sym_QMARK,
    ACTIONS(7518), 1,
      anon_sym_STAR_EQ,
    ACTIONS(7520), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(7522), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(7524), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(7526), 1,
      anon_sym_DASH_EQ,
    ACTIONS(7528), 1,
      anon_sym_LT_LT_EQ,
    ACTIONS(7530), 1,
      anon_sym_GT_GT_EQ,
    ACTIONS(7532), 1,
      anon_sym_AMP_EQ,
    ACTIONS(7534), 1,
      anon_sym_CARET_EQ,
    ACTIONS(7536), 1,
      anon_sym_PIPE_EQ,
    ACTIONS(7538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7540), 1,
      anon_sym_or,
    ACTIONS(7542), 1,
      anon_sym_and,
    ACTIONS(7544), 1,
      anon_sym_bitor,
    ACTIONS(7546), 1,
      anon_sym_xor,
    ACTIONS(7548), 1,
      anon_sym_bitand,
    ACTIONS(7550), 1,
      anon_sym_not_eq,
    ACTIONS(7687), 1,
      anon_sym_RPAREN,
    STATE(1189), 1,
      sym__binary_fold_operator,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    STATE(8288), 1,
      sym__fold_operator,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7552), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [74997] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5150), 22,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(5152), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [75057] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6100), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6102), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [75117] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6104), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6106), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [75177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6108), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6110), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [75237] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6489), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6491), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [75297] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6383), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6385), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [75356] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5456), 3,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(5454), 48,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
  [75415] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6903), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(6901), 27,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
  [75474] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3460), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7689), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5795), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5793), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [75537] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3460), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7689), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5782), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5780), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [75600] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3321), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7691), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5740), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5738), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [75663] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3322), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7693), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5762), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5760), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [75726] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3460), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7689), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5778), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5776), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [75789] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6343), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6345), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [75848] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3484), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7695), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5545), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5547), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [75911] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3460), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7689), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5752), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5750), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [75974] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3460), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7689), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5758), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5756), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [76037] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7697), 1,
      anon_sym_LT,
    STATE(1862), 1,
      sym_template_argument_list,
    ACTIONS(6320), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6322), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [76100] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6513), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6515), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [76159] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5305), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2721), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [76218] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6551), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6553), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [76277] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6555), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6557), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [76336] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6559), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6561), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [76395] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1909), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1907), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [76454] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7700), 1,
      sym_identifier,
    STATE(3440), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(4925), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(4927), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5253), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5251), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [76521] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6517), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6519), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [76580] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6521), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6523), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [76639] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2581), 1,
      anon_sym_LBRACE,
    ACTIONS(6986), 1,
      anon_sym_LPAREN2,
    STATE(3832), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6079), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6081), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [76704] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6399), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6401), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [76763] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5660), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5662), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [76822] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5664), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5666), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [76881] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5672), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5674), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [76940] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5564), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5566), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [76999] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6543), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6545), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [77058] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5568), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5570), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [77117] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5572), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5574), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [77176] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2581), 1,
      anon_sym_LBRACE,
    ACTIONS(6986), 1,
      anon_sym_LPAREN2,
    STATE(3795), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6145), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6147), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [77241] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6407), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6409), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [77300] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4849), 1,
      anon_sym_LBRACK,
    ACTIONS(6463), 1,
      anon_sym_LT,
    STATE(3656), 1,
      sym_template_argument_list,
    ACTIONS(4842), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4845), 4,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
    ACTIONS(4838), 41,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [77369] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5447), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5449), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [77428] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6255), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6257), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [77487] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5732), 1,
      anon_sym___asm,
    ACTIONS(6924), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7704), 1,
      anon_sym_STAR,
    ACTIONS(7706), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7708), 1,
      anon_sym_AMP,
    ACTIONS(7710), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    STATE(2886), 1,
      sym_parameter_list,
    STATE(3720), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(3934), 1,
      sym_alignas_qualifier,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(5901), 1,
      sym__abstract_declarator,
    ACTIONS(6926), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7712), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7714), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3348), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4123), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5730), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(6911), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [77584] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5706), 1,
      anon_sym___asm,
    ACTIONS(6924), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7704), 1,
      anon_sym_STAR,
    ACTIONS(7706), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7708), 1,
      anon_sym_AMP,
    ACTIONS(7710), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    STATE(2886), 1,
      sym_parameter_list,
    STATE(3720), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(3934), 1,
      sym_alignas_qualifier,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(5909), 1,
      sym__abstract_declarator,
    ACTIONS(6926), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7712), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7714), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3218), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4098), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5698), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(6911), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [77681] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5387), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5389), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [77740] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6477), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6479), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [77799] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5126), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5128), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [77858] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5130), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5132), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [77917] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6391), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6393), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [77976] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6481), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6483), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [78035] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6567), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6569), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [78094] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6922), 1,
      anon_sym_LBRACK,
    ACTIONS(6924), 1,
      anon_sym_const,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(7326), 1,
      anon_sym_requires,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7720), 1,
      anon_sym_DASH_GT,
    STATE(3934), 1,
      sym_alignas_qualifier,
    STATE(4933), 1,
      sym__function_attributes_start,
    STATE(5227), 1,
      sym_ref_qualifier,
    STATE(5976), 1,
      sym_trailing_return_type,
    STATE(6302), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(6905), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(6926), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4048), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4217), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5975), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5318), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6911), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [78207] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6447), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6449), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [78266] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6539), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6541), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [78325] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5134), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5136), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [78384] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5140), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [78443] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5652), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5654), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [78502] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5533), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5535), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [78561] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6571), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6573), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [78620] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7395), 1,
      anon_sym_LT,
    STATE(1538), 1,
      sym_template_argument_list,
    ACTIONS(6320), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6322), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [78683] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6037), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6039), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [78742] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6295), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6297), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [78801] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6049), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6051), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [78860] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6525), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6527), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [78919] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6547), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6549), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [78978] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3161), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(5858), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(5860), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5797), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5799), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [79043] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6387), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6389), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [79102] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6489), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6491), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [79161] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6922), 1,
      anon_sym_LBRACK,
    ACTIONS(6924), 1,
      anon_sym_const,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(7275), 1,
      anon_sym_requires,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7720), 1,
      anon_sym_DASH_GT,
    STATE(3934), 1,
      sym_alignas_qualifier,
    STATE(4950), 1,
      sym__function_attributes_start,
    STATE(5191), 1,
      sym_ref_qualifier,
    STATE(5930), 1,
      sym_trailing_return_type,
    STATE(6310), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(6905), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(6926), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7176), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4048), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4217), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5975), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5319), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6911), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [79274] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7722), 1,
      sym_literal_suffix,
    ACTIONS(4035), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(4043), 26,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
  [79335] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6335), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6337), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [79394] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5668), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5670), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [79453] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6443), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6445), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [79512] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4043), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4035), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [79571] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6427), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6429), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [79630] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6327), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6329), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [79689] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6407), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6409), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [79748] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5676), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5678), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [79807] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6419), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6421), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [79866] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6423), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6425), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [79925] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3822), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3824), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [79984] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2581), 1,
      anon_sym_LBRACE,
    ACTIONS(6986), 1,
      anon_sym_LPAREN2,
    STATE(3815), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6088), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6090), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [80049] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6463), 1,
      anon_sym_LT,
    STATE(1570), 1,
      sym_template_argument_list,
    STATE(3060), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6860), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4033), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(4041), 38,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [80118] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6116), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6118), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [80177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6411), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6413), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [80236] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5118), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5120), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [80295] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6431), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6433), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [80354] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6041), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6043), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [80413] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6435), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6437), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [80472] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6141), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6143), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [80531] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5170), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5172), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [80590] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5142), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5144), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [80649] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7724), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7726), 1,
      anon_sym_and,
    ACTIONS(6057), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6059), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [80712] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5174), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5176), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [80771] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3754), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3750), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [80830] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5529), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5531), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [80889] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5541), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5543), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [80948] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5502), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5504), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [81007] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5510), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5512), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [81066] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6155), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6157), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [81125] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5514), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5516), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [81184] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6100), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6102), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [81243] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6509), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6511), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [81302] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6291), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6293), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [81361] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6291), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6293), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [81420] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6259), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6261), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [81479] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6104), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6106), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [81538] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6501), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6503), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [81597] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5549), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5551), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [81656] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6299), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6301), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [81715] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6108), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6110), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [81774] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5146), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5148), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [81833] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5150), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5152), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [81892] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6505), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6507), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [81951] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5553), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5555), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [82010] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6021), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6023), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [82069] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4862), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6188), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6190), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [82130] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5498), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5500), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [82189] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5537), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5539), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [82248] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5596), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5598), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [82307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5431), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5433), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [82366] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6395), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6397), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [82425] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5680), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5682), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [82484] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5967), 3,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(4043), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4035), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [82545] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5618), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5620), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [82604] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6312), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6314), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [82663] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5498), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5500), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [82722] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7728), 1,
      anon_sym_LT,
    STATE(1829), 1,
      sym_template_argument_list,
    ACTIONS(5720), 23,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4059), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [82787] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7730), 1,
      anon_sym_LT,
    STATE(1829), 1,
      sym_template_argument_list,
    ACTIONS(4838), 23,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4845), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [82852] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6919), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6922), 1,
      anon_sym_LBRACK,
    ACTIONS(6924), 1,
      anon_sym_const,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(7733), 1,
      anon_sym_DASH_GT,
    ACTIONS(7735), 1,
      anon_sym_requires,
    STATE(3934), 1,
      sym_alignas_qualifier,
    STATE(4940), 1,
      sym__function_attributes_start,
    STATE(5196), 1,
      sym_ref_qualifier,
    STATE(6245), 1,
      sym__function_attributes_end,
    STATE(6387), 1,
      sym_trailing_return_type,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(6905), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(6926), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(6934), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4048), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4217), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5755), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5326), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6911), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [82965] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6451), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6453), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [83024] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6455), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6457), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [83083] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6045), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6047), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [83142] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6459), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6461), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [83201] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5431), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5433), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [83260] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7738), 1,
      sym_identifier,
    STATE(3440), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(7741), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(7744), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5260), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5258), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [83327] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5648), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5650), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [83386] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5502), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5504), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [83445] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4043), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4035), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [83504] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1913), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1911), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [83563] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5632), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [83622] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5640), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5642), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [83681] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5622), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5624), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [83740] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5600), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5602), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [83799] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5122), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5124), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [83858] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5815), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5813), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [83917] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5122), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5124), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [83976] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5122), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5124), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [84035] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5449), 3,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    ACTIONS(5447), 48,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
  [84094] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7747), 1,
      sym_identifier,
    STATE(3330), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(4925), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(4927), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5276), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5274), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [84161] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5114), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5116), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [84220] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6371), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6373), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [84279] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2581), 1,
      anon_sym_LBRACE,
    ACTIONS(6986), 1,
      anon_sym_LPAREN2,
    STATE(3834), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6053), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6055), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [84344] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6577), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6579), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [84403] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6469), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6471), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [84462] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3460), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7749), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4932), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(4934), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [84525] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6473), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6475), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [84584] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5454), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5456), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [84643] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7724), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7726), 1,
      anon_sym_and,
    ACTIONS(7752), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7754), 1,
      anon_sym_or,
    ACTIONS(6092), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6094), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [84710] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6919), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6922), 1,
      anon_sym_LBRACK,
    ACTIONS(6924), 1,
      anon_sym_const,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(7733), 1,
      anon_sym_DASH_GT,
    ACTIONS(7756), 1,
      anon_sym_requires,
    STATE(3934), 1,
      sym_alignas_qualifier,
    STATE(4973), 1,
      sym__function_attributes_start,
    STATE(5222), 1,
      sym_ref_qualifier,
    STATE(6273), 1,
      sym__function_attributes_end,
    STATE(6363), 1,
      sym_trailing_return_type,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6905), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(6926), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(4048), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(4217), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5755), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5322), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(6911), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [84823] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5732), 1,
      anon_sym___attribute,
    ACTIONS(6924), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7710), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(7758), 1,
      anon_sym_STAR,
    ACTIONS(7760), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7762), 1,
      anon_sym_AMP,
    STATE(2831), 1,
      sym_parameter_list,
    STATE(3720), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(3934), 1,
      sym_alignas_qualifier,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(5948), 1,
      sym__abstract_declarator,
    ACTIONS(6926), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7712), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7714), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3471), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4091), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5730), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6911), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [84920] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6802), 1,
      anon_sym_LBRACE,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    STATE(2430), 1,
      sym_attribute_specifier,
    STATE(3619), 1,
      sym_enumerator_list,
    ACTIONS(5834), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5836), 41,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [84989] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6802), 1,
      anon_sym_LBRACE,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    STATE(2415), 1,
      sym_attribute_specifier,
    STATE(3622), 1,
      sym_enumerator_list,
    ACTIONS(5848), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5850), 41,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [85058] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5399), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5401), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [85117] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5626), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5628), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [85176] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5502), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5504), 35,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      sym_auto,
      anon_sym_decltype,
      anon_sym_DASH_GT_STAR,
  [85235] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5706), 1,
      anon_sym___attribute,
    ACTIONS(6924), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7710), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(7758), 1,
      anon_sym_STAR,
    ACTIONS(7760), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7762), 1,
      anon_sym_AMP,
    STATE(2831), 1,
      sym_parameter_list,
    STATE(3720), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(3934), 1,
      sym_alignas_qualifier,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(5958), 1,
      sym__abstract_declarator,
    ACTIONS(6926), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7712), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7714), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3218), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4110), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5698), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6911), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [85332] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(5732), 1,
      anon_sym___asm,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7710), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(7764), 1,
      anon_sym_STAR,
    ACTIONS(7766), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7768), 1,
      anon_sym_AMP,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2880), 1,
      sym_parameter_list,
    STATE(3720), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(6010), 1,
      sym__abstract_declarator,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7712), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7714), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3473), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4108), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5730), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [85429] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(5706), 1,
      anon_sym___asm,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7710), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(7764), 1,
      anon_sym_STAR,
    ACTIONS(7766), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7768), 1,
      anon_sym_AMP,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2880), 1,
      sym_parameter_list,
    STATE(3720), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(5963), 1,
      sym__abstract_declarator,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7712), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7714), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3218), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4095), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5698), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [85526] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6485), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6487), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [85585] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4840), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [85644] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7697), 1,
      anon_sym_LT,
    STATE(3296), 1,
      sym_template_argument_list,
    ACTIONS(6320), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6322), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [85707] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4840), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [85766] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4840), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [85825] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4840), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [85884] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7728), 1,
      anon_sym_LT,
    STATE(1829), 1,
      sym_template_argument_list,
    STATE(3485), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4033), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(4041), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [85953] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4840), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [86012] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6415), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6417), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [86071] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5166), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5168), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [86130] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3460), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7689), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5768), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5766), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [86193] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3460), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7689), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5791), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5789), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [86256] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4840), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [86315] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7770), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(6343), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6345), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [86376] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3818), 21,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3820), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [86435] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6535), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6537), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [86494] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3314), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7772), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5803), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5801), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [86557] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6493), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6495), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [86616] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3315), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7774), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5746), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5744), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [86679] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6497), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6499), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [86738] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6291), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6293), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [86797] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4810), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4812), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [86855] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7776), 1,
      anon_sym_LBRACK,
    STATE(3716), 1,
      sym_new_declarator,
    ACTIONS(6192), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6194), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [86917] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6525), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6527), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [86975] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(6856), 1,
      anon_sym_EQ,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7332), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7472), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7516), 1,
      anon_sym_QMARK,
    ACTIONS(7538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7786), 1,
      anon_sym_PIPE,
    ACTIONS(7788), 1,
      anon_sym_CARET,
    ACTIONS(7790), 1,
      anon_sym_AMP,
    ACTIONS(7796), 1,
      anon_sym_GT_EQ,
    ACTIONS(7800), 1,
      anon_sym_bitor,
    ACTIONS(7802), 1,
      anon_sym_xor,
    ACTIONS(7804), 1,
      anon_sym_bitand,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7552), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7782), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7784), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7798), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7780), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7792), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7794), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6858), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [87081] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6395), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6397), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [87139] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4067), 1,
      anon_sym_EQ,
    ACTIONS(4147), 1,
      anon_sym_SEMI,
    ACTIONS(4895), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5868), 1,
      anon_sym_LPAREN2,
    ACTIONS(5871), 1,
      anon_sym_LBRACK,
    ACTIONS(4071), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(4035), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(4043), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
  [87209] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4818), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4820), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [87267] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(6852), 1,
      anon_sym_EQ,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7332), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7786), 1,
      anon_sym_PIPE,
    ACTIONS(7788), 1,
      anon_sym_CARET,
    ACTIONS(7790), 1,
      anon_sym_AMP,
    ACTIONS(7796), 1,
      anon_sym_GT_EQ,
    ACTIONS(7800), 1,
      anon_sym_bitor,
    ACTIONS(7802), 1,
      anon_sym_xor,
    ACTIONS(7804), 1,
      anon_sym_bitand,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7552), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7782), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7784), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7798), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7780), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7792), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7794), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6854), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [87369] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7332), 1,
      anon_sym_DOT_STAR,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7552), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7780), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6263), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(6265), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [87443] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7332), 1,
      anon_sym_DOT_STAR,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7552), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6263), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(6265), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [87515] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1913), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(1911), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [87573] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6547), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6549), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [87631] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6988), 1,
      anon_sym_LBRACK,
    STATE(3659), 1,
      sym_new_declarator,
    ACTIONS(6192), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6194), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [87693] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6485), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6487), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [87751] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6383), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6385), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [87809] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5166), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5168), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [87867] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6493), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6495), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [87925] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6497), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6499), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [87983] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4822), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4824), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [88041] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6505), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6507), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [88099] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6263), 1,
      anon_sym_EQ,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7332), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7786), 1,
      anon_sym_PIPE,
    ACTIONS(7788), 1,
      anon_sym_CARET,
    ACTIONS(7790), 1,
      anon_sym_AMP,
    ACTIONS(7796), 1,
      anon_sym_GT_EQ,
    ACTIONS(7800), 1,
      anon_sym_bitor,
    ACTIONS(7802), 1,
      anon_sym_xor,
    ACTIONS(7804), 1,
      anon_sym_bitand,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7552), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7784), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7798), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7780), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7792), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7794), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_DASH_GT_STAR,
  [88199] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6407), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6409), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [88257] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6263), 1,
      anon_sym_EQ,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7332), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7786), 1,
      anon_sym_PIPE,
    ACTIONS(7788), 1,
      anon_sym_CARET,
    ACTIONS(7790), 1,
      anon_sym_AMP,
    ACTIONS(7796), 1,
      anon_sym_GT_EQ,
    ACTIONS(7800), 1,
      anon_sym_bitor,
    ACTIONS(7802), 1,
      anon_sym_xor,
    ACTIONS(7804), 1,
      anon_sym_bitand,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7552), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7798), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7780), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7792), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7794), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH_GT_STAR,
  [88355] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6551), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6553), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [88413] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6567), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6569), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [88471] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4810), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4812), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [88529] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4826), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4828), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [88587] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4818), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4820), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [88645] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6481), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6483), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [88703] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4822), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4824), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [88761] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6387), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6389), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [88819] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4814), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4816), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [88877] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4830), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4832), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [88935] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4834), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(4836), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [88993] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5387), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5389), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [89051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5399), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5401), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [89109] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7332), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7788), 1,
      anon_sym_CARET,
    ACTIONS(7790), 1,
      anon_sym_AMP,
    ACTIONS(7796), 1,
      anon_sym_GT_EQ,
    ACTIONS(7802), 1,
      anon_sym_xor,
    ACTIONS(7804), 1,
      anon_sym_bitand,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    ACTIONS(6263), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7552), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7798), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7780), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7792), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7794), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_DASH_GT_STAR,
  [89203] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7332), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7790), 1,
      anon_sym_AMP,
    ACTIONS(7796), 1,
      anon_sym_GT_EQ,
    ACTIONS(7804), 1,
      anon_sym_bitand,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7552), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7798), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6263), 3,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_EQ,
    ACTIONS(7780), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7792), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7794), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_DASH_GT_STAR,
  [89293] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7332), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7796), 1,
      anon_sym_GT_EQ,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7552), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7798), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7780), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7792), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7794), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6263), 4,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
    ACTIONS(6265), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_DASH_GT_STAR,
  [89379] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6447), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6449), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [89437] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7332), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7796), 1,
      anon_sym_GT_EQ,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7552), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7798), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7780), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7794), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6263), 4,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ,
    ACTIONS(6265), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [89521] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4043), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4035), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [89579] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5447), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5449), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [89637] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7332), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7538), 1,
      anon_sym_LT_EQ_GT,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7552), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7798), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7780), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6263), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
    ACTIONS(6265), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [89717] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5454), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5456), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [89775] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7332), 1,
      anon_sym_DOT_STAR,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7552), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7780), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6263), 9,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(6265), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [89851] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7332), 1,
      anon_sym_DOT_STAR,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7552), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7798), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7780), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6263), 7,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_EQ,
    ACTIONS(6265), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [89929] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(6806), 1,
      anon_sym_EQ,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7332), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7786), 1,
      anon_sym_PIPE,
    ACTIONS(7788), 1,
      anon_sym_CARET,
    ACTIONS(7790), 1,
      anon_sym_AMP,
    ACTIONS(7796), 1,
      anon_sym_GT_EQ,
    ACTIONS(7800), 1,
      anon_sym_bitor,
    ACTIONS(7802), 1,
      anon_sym_xor,
    ACTIONS(7804), 1,
      anon_sym_bitand,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7552), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7782), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7784), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7798), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7780), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7792), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7794), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6808), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [90031] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4862), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(4864), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4857), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [90091] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4043), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4035), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [90149] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5170), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5172), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [90207] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6419), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6421), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [90265] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6391), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6393), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [90323] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5174), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5176), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [90381] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7332), 1,
      anon_sym_DOT_STAR,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7552), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6281), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(6283), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [90453] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5815), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5813), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [90511] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4814), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4816), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [90569] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6312), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6314), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [90627] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1909), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(1907), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [90685] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6415), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6417), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [90743] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6015), 1,
      anon_sym_EQ,
    ACTIONS(6083), 1,
      anon_sym_COMMA,
    ACTIONS(6085), 1,
      anon_sym_RBRACK,
    ACTIONS(5941), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(4035), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(4043), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
  [90809] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5134), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5136), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [90867] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5114), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5116), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [90925] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5140), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [90983] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7806), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7808), 1,
      anon_sym_and,
    ACTIONS(6057), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6059), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [91045] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4830), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4832), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [91103] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6407), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6409), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [91161] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6431), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6433), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [91219] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6435), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6437), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [91277] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3754), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(3750), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [91335] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6427), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6429), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [91393] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5118), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5120), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [91451] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4840), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [91509] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4840), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [91567] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4840), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [91625] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4840), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [91683] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4840), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [91741] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5142), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5144), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [91799] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4921), 2,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
    ACTIONS(4923), 12,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(4035), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(4043), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
  [91861] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4840), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [91919] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6399), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6401), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [91977] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6411), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6413), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [92035] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6371), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6373), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [92093] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7332), 1,
      anon_sym_DOT_STAR,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6363), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(6365), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT_STAR,
  [92163] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6577), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6579), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [92221] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(6868), 1,
      anon_sym_EQ,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7332), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7786), 1,
      anon_sym_PIPE,
    ACTIONS(7788), 1,
      anon_sym_CARET,
    ACTIONS(7790), 1,
      anon_sym_AMP,
    ACTIONS(7796), 1,
      anon_sym_GT_EQ,
    ACTIONS(7800), 1,
      anon_sym_bitor,
    ACTIONS(7802), 1,
      anon_sym_xor,
    ACTIONS(7804), 1,
      anon_sym_bitand,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7552), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7782), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7784), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7798), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7780), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7792), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7794), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6870), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [92323] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6112), 1,
      anon_sym_EQ,
    ACTIONS(6114), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(4043), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4035), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [92385] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4895), 1,
      anon_sym_SEMI,
    ACTIONS(6463), 1,
      anon_sym_LT,
    ACTIONS(6896), 1,
      anon_sym_LBRACK,
    STATE(2551), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3913), 1,
      sym_template_argument_list,
    ACTIONS(4056), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4041), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(4061), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4033), 35,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [92459] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1787), 1,
      anon_sym_enum,
    ACTIONS(1789), 1,
      anon_sym_class,
    ACTIONS(1791), 1,
      anon_sym_struct,
    ACTIONS(1793), 1,
      anon_sym_union,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(1821), 1,
      anon_sym_typename,
    ACTIONS(7810), 1,
      sym_identifier,
    ACTIONS(7812), 1,
      anon_sym_RPAREN,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7816), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4142), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4605), 1,
      sym_type_specifier,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(7406), 1,
      sym_type_descriptor,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3854), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1781), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [92565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5122), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5124), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [92623] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5122), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5124), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [92681] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5365), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5443), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5445), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [92741] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5122), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5124), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [92799] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6535), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6537), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [92857] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6291), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6293), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [92915] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6423), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6425), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [92973] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6291), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6293), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [93031] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(6844), 1,
      anon_sym_EQ,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7332), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7786), 1,
      anon_sym_PIPE,
    ACTIONS(7788), 1,
      anon_sym_CARET,
    ACTIONS(7790), 1,
      anon_sym_AMP,
    ACTIONS(7796), 1,
      anon_sym_GT_EQ,
    ACTIONS(7800), 1,
      anon_sym_bitor,
    ACTIONS(7802), 1,
      anon_sym_xor,
    ACTIONS(7804), 1,
      anon_sym_bitand,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7552), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7782), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7784), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7798), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7780), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7792), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7794), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6846), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [93133] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6443), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6445), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [93191] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6543), 1,
      anon_sym_EQ,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7332), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7472), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7516), 1,
      anon_sym_QMARK,
    ACTIONS(7538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7786), 1,
      anon_sym_PIPE,
    ACTIONS(7788), 1,
      anon_sym_CARET,
    ACTIONS(7790), 1,
      anon_sym_AMP,
    ACTIONS(7796), 1,
      anon_sym_GT_EQ,
    ACTIONS(7800), 1,
      anon_sym_bitor,
    ACTIONS(7802), 1,
      anon_sym_xor,
    ACTIONS(7804), 1,
      anon_sym_bitand,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7552), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7782), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7784), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7798), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7780), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7792), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7794), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6545), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [93297] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5305), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(2721), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [93355] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5146), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5148), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [93413] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5150), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5152), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [93471] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6291), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6293), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [93529] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7332), 1,
      anon_sym_DOT_STAR,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7552), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6349), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(6351), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [93601] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7332), 1,
      anon_sym_DOT_STAR,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7552), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6331), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(6333), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_GT_STAR,
  [93673] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7818), 1,
      anon_sym_LBRACE,
    ACTIONS(7820), 1,
      anon_sym_COLON,
    STATE(3875), 1,
      sym__enum_base_clause,
    STATE(3925), 1,
      sym_enumerator_list,
    STATE(4049), 1,
      sym_attribute_specifier,
    ACTIONS(5876), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6245), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6247), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [93743] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7822), 1,
      anon_sym_COMMA,
    ACTIONS(7824), 1,
      anon_sym_RBRACK,
    ACTIONS(4043), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4035), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [93805] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(6872), 1,
      anon_sym_EQ,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7332), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7786), 1,
      anon_sym_PIPE,
    ACTIONS(7788), 1,
      anon_sym_CARET,
    ACTIONS(7790), 1,
      anon_sym_AMP,
    ACTIONS(7796), 1,
      anon_sym_GT_EQ,
    ACTIONS(7800), 1,
      anon_sym_bitor,
    ACTIONS(7802), 1,
      anon_sym_xor,
    ACTIONS(7804), 1,
      anon_sym_bitand,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7552), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7782), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7784), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7798), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7780), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7792), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7794), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6874), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [93907] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6543), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6545), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [93965] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6539), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6541), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [94023] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6469), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6471), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [94081] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6473), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6475), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [94139] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7332), 1,
      anon_sym_DOT_STAR,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6277), 14,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(6279), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_GT_STAR,
  [94209] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    STATE(2399), 1,
      sym_attribute_specifier,
    ACTIONS(5901), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5903), 42,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [94273] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6501), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6503), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [94331] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    STATE(2447), 1,
      sym_attribute_specifier,
    ACTIONS(5969), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5971), 42,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [94395] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5365), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5361), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5363), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [94455] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    STATE(2419), 1,
      sym_attribute_specifier,
    ACTIONS(5947), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5949), 42,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [94519] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6477), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6479), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [94577] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    STATE(2428), 1,
      sym_attribute_specifier,
    ACTIONS(5905), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5907), 42,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [94641] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    STATE(2462), 1,
      sym_attribute_specifier,
    ACTIONS(5913), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5915), 42,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [94705] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    STATE(2466), 1,
      sym_attribute_specifier,
    ACTIONS(5917), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5919), 42,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [94769] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    STATE(2412), 1,
      sym_attribute_specifier,
    ACTIONS(5976), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5978), 42,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [94833] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    STATE(2416), 1,
      sym_attribute_specifier,
    ACTIONS(5980), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5982), 42,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [94897] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    STATE(2449), 1,
      sym_attribute_specifier,
    ACTIONS(5986), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5988), 42,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [94961] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    STATE(2455), 1,
      sym_attribute_specifier,
    ACTIONS(5990), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5992), 42,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [95025] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    STATE(2421), 1,
      sym_attribute_specifier,
    ACTIONS(5951), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5953), 42,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [95089] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    STATE(2442), 1,
      sym_attribute_specifier,
    ACTIONS(5887), 5,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5889), 42,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_LBRACE,
      anon_sym_static,
      anon_sym_EQ,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [95153] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5365), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5361), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5363), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [95213] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7818), 1,
      anon_sym_LBRACE,
    ACTIONS(7820), 1,
      anon_sym_COLON,
    STATE(3799), 1,
      sym__enum_base_clause,
    STATE(3917), 1,
      sym_enumerator_list,
    STATE(4029), 1,
      sym_attribute_specifier,
    ACTIONS(5876), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6161), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6163), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [95283] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6299), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6301), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [95341] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5126), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5128), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [95399] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5130), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(5132), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [95457] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6074), 1,
      anon_sym_COMMA,
    ACTIONS(6076), 1,
      anon_sym_RBRACK,
    ACTIONS(4043), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4035), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [95519] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4826), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4828), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [95577] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    ACTIONS(6848), 1,
      anon_sym_EQ,
    ACTIONS(7036), 1,
      anon_sym_LBRACK,
    ACTIONS(7332), 1,
      anon_sym_DOT_STAR,
    ACTIONS(7472), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7516), 1,
      anon_sym_QMARK,
    ACTIONS(7538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(7786), 1,
      anon_sym_PIPE,
    ACTIONS(7788), 1,
      anon_sym_CARET,
    ACTIONS(7790), 1,
      anon_sym_AMP,
    ACTIONS(7796), 1,
      anon_sym_GT_EQ,
    ACTIONS(7800), 1,
      anon_sym_bitor,
    ACTIONS(7802), 1,
      anon_sym_xor,
    ACTIONS(7804), 1,
      anon_sym_bitand,
    STATE(3381), 1,
      sym_argument_list,
    STATE(3389), 1,
      sym_subscript_argument_list,
    ACTIONS(7080), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(7552), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(7778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(7782), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7784), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(7798), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7780), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(7792), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(7794), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6850), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_GT_STAR,
  [95683] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6324), 1,
      anon_sym_LT,
    STATE(1879), 1,
      sym_template_argument_list,
    ACTIONS(6320), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6322), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [95745] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6509), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6511), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [95803] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6513), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6515), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [95861] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6517), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6519), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [95919] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6521), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6523), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [95977] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6555), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6557), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [96035] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6559), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6561), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [96093] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6571), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6573), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [96151] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 24,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5472), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [96209] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6451), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6453), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [96267] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4834), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4836), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [96325] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4862), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(4864), 20,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4857), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [96385] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6455), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6457), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [96443] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7806), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7808), 1,
      anon_sym_and,
    ACTIONS(7827), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7829), 1,
      anon_sym_or,
    ACTIONS(6092), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6094), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [96509] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6343), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6345), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [96567] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6459), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6461), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [96625] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6259), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6261), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [96683] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6015), 1,
      anon_sym_EQ,
    ACTIONS(5941), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(4043), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(4035), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [96745] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6489), 20,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
    ACTIONS(6491), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [96803] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5445), 1,
      anon_sym_SEMI,
    ACTIONS(5433), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5431), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [96862] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(7831), 1,
      sym_identifier,
    ACTIONS(7833), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7837), 1,
      sym_primitive_type,
    ACTIONS(7839), 1,
      anon_sym_enum,
    ACTIONS(7841), 1,
      anon_sym_class,
    ACTIONS(7843), 1,
      anon_sym_struct,
    ACTIONS(7845), 1,
      anon_sym_union,
    ACTIONS(7847), 1,
      anon_sym_typename,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(2788), 1,
      sym_qualified_type_identifier,
    STATE(4831), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4924), 1,
      sym_type_specifier,
    STATE(5585), 1,
      sym__type_definition_type,
    STATE(6513), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3831), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7835), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [96965] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6277), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6279), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [97034] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6387), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6389), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [97091] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6281), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6283), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
  [97162] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4866), 1,
      anon_sym_LBRACK,
    ACTIONS(4859), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4862), 5,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
    ACTIONS(4855), 41,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [97223] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(7851), 1,
      sym_identifier,
    ACTIONS(7853), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7857), 1,
      sym_primitive_type,
    ACTIONS(7859), 1,
      anon_sym_enum,
    ACTIONS(7861), 1,
      anon_sym_class,
    ACTIONS(7863), 1,
      anon_sym_struct,
    ACTIONS(7865), 1,
      anon_sym_union,
    ACTIONS(7867), 1,
      sym_auto,
    ACTIONS(7869), 1,
      anon_sym_decltype,
    ACTIONS(7871), 1,
      anon_sym_typename,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(4027), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4193), 1,
      sym_type_specifier,
    STATE(4894), 1,
      sym_decltype_auto,
    STATE(4895), 1,
      sym_qualified_type_identifier,
    STATE(5946), 1,
      sym_type_descriptor,
    STATE(6508), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3766), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4829), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(7855), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [97326] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6901), 23,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
      sym_literal_suffix,
    ACTIONS(6903), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [97383] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6295), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6297), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [97440] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(2872), 1,
      anon_sym_enum,
    ACTIONS(2874), 1,
      anon_sym_class,
    ACTIONS(2876), 1,
      anon_sym_struct,
    ACTIONS(2878), 1,
      anon_sym_union,
    ACTIONS(2902), 1,
      sym_auto,
    ACTIONS(2904), 1,
      anon_sym_decltype,
    ACTIONS(2906), 1,
      anon_sym_typename,
    ACTIONS(7873), 1,
      sym_identifier,
    ACTIONS(7875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7877), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2637), 1,
      sym_decltype_auto,
    STATE(2649), 1,
      sym_qualified_type_identifier,
    STATE(4167), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4239), 1,
      sym_type_specifier,
    STATE(5946), 1,
      sym_type_descriptor,
    STATE(6528), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2563), 2,
      sym_decltype,
      sym_template_type,
    STATE(3862), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2868), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2651), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [97543] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5454), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5456), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [97600] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3454), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(4925), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(4927), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
    ACTIONS(5797), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5799), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [97663] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1787), 1,
      anon_sym_enum,
    ACTIONS(1789), 1,
      anon_sym_class,
    ACTIONS(1791), 1,
      anon_sym_struct,
    ACTIONS(1793), 1,
      anon_sym_union,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(1821), 1,
      anon_sym_typename,
    ACTIONS(7810), 1,
      sym_identifier,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7816), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4142), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4605), 1,
      sym_type_specifier,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(7911), 1,
      sym_type_descriptor,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3854), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1781), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [97766] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7463), 1,
      sym_literal_suffix,
    ACTIONS(4043), 22,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4035), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [97825] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1787), 1,
      anon_sym_enum,
    ACTIONS(1789), 1,
      anon_sym_class,
    ACTIONS(1791), 1,
      anon_sym_struct,
    ACTIONS(1793), 1,
      anon_sym_union,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(1821), 1,
      anon_sym_typename,
    ACTIONS(7810), 1,
      sym_identifier,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7816), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4142), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4605), 1,
      sym_type_specifier,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(8307), 1,
      sym_type_descriptor,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3854), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1781), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [97928] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7881), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7885), 1,
      sym_primitive_type,
    ACTIONS(7887), 1,
      anon_sym_enum,
    ACTIONS(7889), 1,
      anon_sym_class,
    ACTIONS(7891), 1,
      anon_sym_struct,
    ACTIONS(7893), 1,
      anon_sym_union,
    ACTIONS(7895), 1,
      sym_auto,
    ACTIONS(7897), 1,
      anon_sym_decltype,
    ACTIONS(7899), 1,
      anon_sym_typename,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2788), 1,
      sym_qualified_type_identifier,
    STATE(3909), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3940), 1,
      sym_type_specifier,
    STATE(4584), 1,
      sym_decltype_auto,
    STATE(5746), 1,
      sym_type_descriptor,
    STATE(6504), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2336), 2,
      sym_decltype,
      sym_template_type,
    STATE(3809), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7883), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4586), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [98031] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1787), 1,
      anon_sym_enum,
    ACTIONS(1789), 1,
      anon_sym_class,
    ACTIONS(1791), 1,
      anon_sym_struct,
    ACTIONS(1793), 1,
      anon_sym_union,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(1821), 1,
      anon_sym_typename,
    ACTIONS(7810), 1,
      sym_identifier,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7816), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4142), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4605), 1,
      sym_type_specifier,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(8205), 1,
      sym_type_descriptor,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3854), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1781), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [98134] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1787), 1,
      anon_sym_enum,
    ACTIONS(1789), 1,
      anon_sym_class,
    ACTIONS(1791), 1,
      anon_sym_struct,
    ACTIONS(1793), 1,
      anon_sym_union,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(1821), 1,
      anon_sym_typename,
    ACTIONS(7810), 1,
      sym_identifier,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7816), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4142), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4605), 1,
      sym_type_specifier,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(8485), 1,
      sym_type_descriptor,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3854), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1781), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [98237] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1787), 1,
      anon_sym_enum,
    ACTIONS(1789), 1,
      anon_sym_class,
    ACTIONS(1791), 1,
      anon_sym_struct,
    ACTIONS(1793), 1,
      anon_sym_union,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(1821), 1,
      anon_sym_typename,
    ACTIONS(7810), 1,
      sym_identifier,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7816), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4142), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4605), 1,
      sym_type_specifier,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(8474), 1,
      sym_type_descriptor,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3854), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1781), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [98340] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5365), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5445), 1,
      anon_sym_SEMI,
    ACTIONS(5433), 5,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5431), 42,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [98401] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1787), 1,
      anon_sym_enum,
    ACTIONS(1789), 1,
      anon_sym_class,
    ACTIONS(1791), 1,
      anon_sym_struct,
    ACTIONS(1793), 1,
      anon_sym_union,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(1821), 1,
      anon_sym_typename,
    ACTIONS(7810), 1,
      sym_identifier,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7816), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4142), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4605), 1,
      sym_type_specifier,
    STATE(5746), 1,
      sym_type_descriptor,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3854), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1781), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [98504] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      sym_auto,
    ACTIONS(125), 1,
      anon_sym_decltype,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(3770), 1,
      sym_primitive_type,
    ACTIONS(7901), 1,
      sym_identifier,
    ACTIONS(7903), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7905), 1,
      anon_sym_enum,
    ACTIONS(7907), 1,
      anon_sym_class,
    ACTIONS(7909), 1,
      anon_sym_struct,
    ACTIONS(7911), 1,
      anon_sym_union,
    ACTIONS(7913), 1,
      anon_sym_typename,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2423), 1,
      sym_decltype_auto,
    STATE(2667), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2788), 1,
      sym_qualified_type_identifier,
    STATE(3957), 1,
      sym_type_specifier,
    STATE(5746), 1,
      sym_type_descriptor,
    STATE(6498), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2336), 2,
      sym_decltype,
      sym_template_type,
    STATE(3845), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3768), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2383), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [98607] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1787), 1,
      anon_sym_enum,
    ACTIONS(1789), 1,
      anon_sym_class,
    ACTIONS(1791), 1,
      anon_sym_struct,
    ACTIONS(1793), 1,
      anon_sym_union,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(1821), 1,
      anon_sym_typename,
    ACTIONS(7810), 1,
      sym_identifier,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7816), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4142), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4181), 1,
      sym_type_specifier,
    STATE(5946), 1,
      sym_type_descriptor,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3803), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1781), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [98710] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6459), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6461), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [98767] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6263), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6265), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
  [98838] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1787), 1,
      anon_sym_enum,
    ACTIONS(1789), 1,
      anon_sym_class,
    ACTIONS(1791), 1,
      anon_sym_struct,
    ACTIONS(1793), 1,
      anon_sym_union,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(1821), 1,
      anon_sym_typename,
    ACTIONS(7810), 1,
      sym_identifier,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7816), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4142), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4200), 1,
      sym_type_specifier,
    STATE(5946), 1,
      sym_type_descriptor,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3758), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1781), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [98941] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(7851), 1,
      sym_identifier,
    ACTIONS(7853), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7857), 1,
      sym_primitive_type,
    ACTIONS(7859), 1,
      anon_sym_enum,
    ACTIONS(7861), 1,
      anon_sym_class,
    ACTIONS(7863), 1,
      anon_sym_struct,
    ACTIONS(7865), 1,
      anon_sym_union,
    ACTIONS(7867), 1,
      sym_auto,
    ACTIONS(7869), 1,
      anon_sym_decltype,
    ACTIONS(7871), 1,
      anon_sym_typename,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(4027), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4085), 1,
      sym_type_specifier,
    STATE(4894), 1,
      sym_decltype_auto,
    STATE(4895), 1,
      sym_qualified_type_identifier,
    STATE(5946), 1,
      sym_type_descriptor,
    STATE(6508), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3811), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4829), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(7855), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [99044] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(2872), 1,
      anon_sym_enum,
    ACTIONS(2874), 1,
      anon_sym_class,
    ACTIONS(2876), 1,
      anon_sym_struct,
    ACTIONS(2878), 1,
      anon_sym_union,
    ACTIONS(2902), 1,
      sym_auto,
    ACTIONS(2904), 1,
      anon_sym_decltype,
    ACTIONS(2906), 1,
      anon_sym_typename,
    ACTIONS(7873), 1,
      sym_identifier,
    ACTIONS(7875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7877), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2637), 1,
      sym_decltype_auto,
    STATE(2649), 1,
      sym_qualified_type_identifier,
    STATE(4167), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4198), 1,
      sym_type_specifier,
    STATE(5946), 1,
      sym_type_descriptor,
    STATE(6528), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2563), 2,
      sym_decltype,
      sym_template_type,
    STATE(3770), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(2868), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2651), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [99147] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5305), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(2721), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [99204] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1787), 1,
      anon_sym_enum,
    ACTIONS(1789), 1,
      anon_sym_class,
    ACTIONS(1791), 1,
      anon_sym_struct,
    ACTIONS(1793), 1,
      anon_sym_union,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(1821), 1,
      anon_sym_typename,
    ACTIONS(7810), 1,
      sym_identifier,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7816), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4142), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4605), 1,
      sym_type_specifier,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(8146), 1,
      sym_type_descriptor,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3854), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1781), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [99307] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1787), 1,
      anon_sym_enum,
    ACTIONS(1789), 1,
      anon_sym_class,
    ACTIONS(1791), 1,
      anon_sym_struct,
    ACTIONS(1793), 1,
      anon_sym_union,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(1821), 1,
      anon_sym_typename,
    ACTIONS(7810), 1,
      sym_identifier,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7816), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4142), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4605), 1,
      sym_type_specifier,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(8611), 1,
      sym_type_descriptor,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3854), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1781), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [99410] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7881), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7885), 1,
      sym_primitive_type,
    ACTIONS(7887), 1,
      anon_sym_enum,
    ACTIONS(7889), 1,
      anon_sym_class,
    ACTIONS(7891), 1,
      anon_sym_struct,
    ACTIONS(7893), 1,
      anon_sym_union,
    ACTIONS(7895), 1,
      sym_auto,
    ACTIONS(7897), 1,
      anon_sym_decltype,
    ACTIONS(7899), 1,
      anon_sym_typename,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2788), 1,
      sym_qualified_type_identifier,
    STATE(3909), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3958), 1,
      sym_type_specifier,
    STATE(4584), 1,
      sym_decltype_auto,
    STATE(5746), 1,
      sym_type_descriptor,
    STATE(6504), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2336), 2,
      sym_decltype,
      sym_template_type,
    STATE(3852), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7883), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4586), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [99513] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1787), 1,
      anon_sym_enum,
    ACTIONS(1789), 1,
      anon_sym_class,
    ACTIONS(1791), 1,
      anon_sym_struct,
    ACTIONS(1793), 1,
      anon_sym_union,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(1821), 1,
      anon_sym_typename,
    ACTIONS(7810), 1,
      sym_identifier,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7816), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4142), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4605), 1,
      sym_type_specifier,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(8270), 1,
      sym_type_descriptor,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3854), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1781), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [99616] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      sym_auto,
    ACTIONS(125), 1,
      anon_sym_decltype,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(3770), 1,
      sym_primitive_type,
    ACTIONS(7901), 1,
      sym_identifier,
    ACTIONS(7903), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7905), 1,
      anon_sym_enum,
    ACTIONS(7907), 1,
      anon_sym_class,
    ACTIONS(7909), 1,
      anon_sym_struct,
    ACTIONS(7911), 1,
      anon_sym_union,
    ACTIONS(7913), 1,
      anon_sym_typename,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2423), 1,
      sym_decltype_auto,
    STATE(2667), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2788), 1,
      sym_qualified_type_identifier,
    STATE(4052), 1,
      sym_type_specifier,
    STATE(5746), 1,
      sym_type_descriptor,
    STATE(6498), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2336), 2,
      sym_decltype,
      sym_template_type,
    STATE(3768), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3768), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2383), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [99719] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1787), 1,
      anon_sym_enum,
    ACTIONS(1789), 1,
      anon_sym_class,
    ACTIONS(1791), 1,
      anon_sym_struct,
    ACTIONS(1793), 1,
      anon_sym_union,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(1821), 1,
      anon_sym_typename,
    ACTIONS(7810), 1,
      sym_identifier,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7816), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4142), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4605), 1,
      sym_type_specifier,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(8524), 1,
      sym_type_descriptor,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3854), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1781), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [99822] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1787), 1,
      anon_sym_enum,
    ACTIONS(1789), 1,
      anon_sym_class,
    ACTIONS(1791), 1,
      anon_sym_struct,
    ACTIONS(1793), 1,
      anon_sym_union,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(1821), 1,
      anon_sym_typename,
    ACTIONS(7810), 1,
      sym_identifier,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7816), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4142), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4605), 1,
      sym_type_specifier,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(8166), 1,
      sym_type_descriptor,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3854), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1781), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [99925] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(7885), 1,
      sym_primitive_type,
    ACTIONS(7895), 1,
      sym_auto,
    ACTIONS(7897), 1,
      anon_sym_decltype,
    ACTIONS(7915), 1,
      sym_identifier,
    ACTIONS(7917), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7919), 1,
      anon_sym_enum,
    ACTIONS(7921), 1,
      anon_sym_class,
    ACTIONS(7923), 1,
      anon_sym_struct,
    ACTIONS(7925), 1,
      anon_sym_union,
    ACTIONS(7927), 1,
      anon_sym_typename,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2788), 1,
      sym_qualified_type_identifier,
    STATE(3909), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4351), 1,
      sym_type_specifier,
    STATE(4584), 1,
      sym_decltype_auto,
    STATE(5746), 1,
      sym_type_descriptor,
    STATE(6486), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2336), 2,
      sym_decltype,
      sym_template_type,
    STATE(3876), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7883), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4586), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [100028] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1787), 1,
      anon_sym_enum,
    ACTIONS(1789), 1,
      anon_sym_class,
    ACTIONS(1791), 1,
      anon_sym_struct,
    ACTIONS(1793), 1,
      anon_sym_union,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(1821), 1,
      anon_sym_typename,
    ACTIONS(7810), 1,
      sym_identifier,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7816), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4142), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4605), 1,
      sym_type_specifier,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(8570), 1,
      sym_type_descriptor,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3854), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1781), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [100131] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      sym_auto,
    ACTIONS(125), 1,
      anon_sym_decltype,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(3770), 1,
      sym_primitive_type,
    ACTIONS(7901), 1,
      sym_identifier,
    ACTIONS(7903), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7905), 1,
      anon_sym_enum,
    ACTIONS(7907), 1,
      anon_sym_class,
    ACTIONS(7909), 1,
      anon_sym_struct,
    ACTIONS(7911), 1,
      anon_sym_union,
    ACTIONS(7913), 1,
      anon_sym_typename,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2423), 1,
      sym_decltype_auto,
    STATE(2667), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2788), 1,
      sym_qualified_type_identifier,
    STATE(4268), 1,
      sym_type_specifier,
    STATE(5746), 1,
      sym_type_descriptor,
    STATE(6498), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2336), 2,
      sym_decltype,
      sym_template_type,
    STATE(3781), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3768), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2383), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [100234] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7881), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7885), 1,
      sym_primitive_type,
    ACTIONS(7887), 1,
      anon_sym_enum,
    ACTIONS(7889), 1,
      anon_sym_class,
    ACTIONS(7891), 1,
      anon_sym_struct,
    ACTIONS(7893), 1,
      anon_sym_union,
    ACTIONS(7895), 1,
      sym_auto,
    ACTIONS(7897), 1,
      anon_sym_decltype,
    ACTIONS(7899), 1,
      anon_sym_typename,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2788), 1,
      sym_qualified_type_identifier,
    STATE(3909), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4114), 1,
      sym_type_specifier,
    STATE(4584), 1,
      sym_decltype_auto,
    STATE(5746), 1,
      sym_type_descriptor,
    STATE(6504), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2336), 2,
      sym_decltype,
      sym_template_type,
    STATE(3856), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7883), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4586), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [100337] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1787), 1,
      anon_sym_enum,
    ACTIONS(1789), 1,
      anon_sym_class,
    ACTIONS(1791), 1,
      anon_sym_struct,
    ACTIONS(1793), 1,
      anon_sym_union,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(1821), 1,
      anon_sym_typename,
    ACTIONS(7810), 1,
      sym_identifier,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7816), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4142), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4605), 1,
      sym_type_specifier,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(7763), 1,
      sym_type_descriptor,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3854), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1781), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [100440] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1787), 1,
      anon_sym_enum,
    ACTIONS(1789), 1,
      anon_sym_class,
    ACTIONS(1791), 1,
      anon_sym_struct,
    ACTIONS(1793), 1,
      anon_sym_union,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(1821), 1,
      anon_sym_typename,
    ACTIONS(7810), 1,
      sym_identifier,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7816), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4142), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4605), 1,
      sym_type_specifier,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(8466), 1,
      sym_type_descriptor,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3854), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1781), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [100543] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1787), 1,
      anon_sym_enum,
    ACTIONS(1789), 1,
      anon_sym_class,
    ACTIONS(1791), 1,
      anon_sym_struct,
    ACTIONS(1793), 1,
      anon_sym_union,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(1821), 1,
      anon_sym_typename,
    ACTIONS(7810), 1,
      sym_identifier,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7816), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4142), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4605), 1,
      sym_type_specifier,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(7850), 1,
      sym_type_descriptor,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3854), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1781), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [100646] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1787), 1,
      anon_sym_enum,
    ACTIONS(1789), 1,
      anon_sym_class,
    ACTIONS(1791), 1,
      anon_sym_struct,
    ACTIONS(1793), 1,
      anon_sym_union,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(1821), 1,
      anon_sym_typename,
    ACTIONS(7810), 1,
      sym_identifier,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7816), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4142), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4605), 1,
      sym_type_specifier,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(7888), 1,
      sym_type_descriptor,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3854), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1781), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [100749] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1787), 1,
      anon_sym_enum,
    ACTIONS(1789), 1,
      anon_sym_class,
    ACTIONS(1791), 1,
      anon_sym_struct,
    ACTIONS(1793), 1,
      anon_sym_union,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(1821), 1,
      anon_sym_typename,
    ACTIONS(7810), 1,
      sym_identifier,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7816), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4142), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4605), 1,
      sym_type_specifier,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(8169), 1,
      sym_type_descriptor,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3854), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1781), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [100852] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7929), 1,
      anon_sym_LT,
    STATE(1829), 1,
      sym_template_argument_list,
    ACTIONS(4838), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(4845), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
  [100915] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5361), 23,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5363), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [100972] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1787), 1,
      anon_sym_enum,
    ACTIONS(1789), 1,
      anon_sym_class,
    ACTIONS(1791), 1,
      anon_sym_struct,
    ACTIONS(1793), 1,
      anon_sym_union,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(1821), 1,
      anon_sym_typename,
    ACTIONS(7810), 1,
      sym_identifier,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7816), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4142), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4605), 1,
      sym_type_specifier,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(8237), 1,
      sym_type_descriptor,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3854), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1781), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [101075] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6349), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6351), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
  [101146] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1787), 1,
      anon_sym_enum,
    ACTIONS(1789), 1,
      anon_sym_class,
    ACTIONS(1791), 1,
      anon_sym_struct,
    ACTIONS(1793), 1,
      anon_sym_union,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(1821), 1,
      anon_sym_typename,
    ACTIONS(7810), 1,
      sym_identifier,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7816), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4142), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4605), 1,
      sym_type_specifier,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(8272), 1,
      sym_type_descriptor,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3854), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1781), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [101249] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1787), 1,
      anon_sym_enum,
    ACTIONS(1789), 1,
      anon_sym_class,
    ACTIONS(1791), 1,
      anon_sym_struct,
    ACTIONS(1793), 1,
      anon_sym_union,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(1821), 1,
      anon_sym_typename,
    ACTIONS(7810), 1,
      sym_identifier,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7816), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4142), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4605), 1,
      sym_type_specifier,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(7775), 1,
      sym_type_descriptor,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3854), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1781), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [101352] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6497), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6499), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [101409] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1787), 1,
      anon_sym_enum,
    ACTIONS(1789), 1,
      anon_sym_class,
    ACTIONS(1791), 1,
      anon_sym_struct,
    ACTIONS(1793), 1,
      anon_sym_union,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(1821), 1,
      anon_sym_typename,
    ACTIONS(7810), 1,
      sym_identifier,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7816), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4142), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4605), 1,
      sym_type_specifier,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(7824), 1,
      sym_type_descriptor,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3854), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1781), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [101512] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1787), 1,
      anon_sym_enum,
    ACTIONS(1789), 1,
      anon_sym_class,
    ACTIONS(1791), 1,
      anon_sym_struct,
    ACTIONS(1793), 1,
      anon_sym_union,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(1821), 1,
      anon_sym_typename,
    ACTIONS(7810), 1,
      sym_identifier,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7816), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4142), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4605), 1,
      sym_type_specifier,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(7797), 1,
      sym_type_descriptor,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3854), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1781), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [101615] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1787), 1,
      anon_sym_enum,
    ACTIONS(1789), 1,
      anon_sym_class,
    ACTIONS(1791), 1,
      anon_sym_struct,
    ACTIONS(1793), 1,
      anon_sym_union,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(1821), 1,
      anon_sym_typename,
    ACTIONS(7810), 1,
      sym_identifier,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7816), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4142), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4605), 1,
      sym_type_specifier,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(7840), 1,
      sym_type_descriptor,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3854), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1781), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [101718] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6363), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6365), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [101787] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1787), 1,
      anon_sym_enum,
    ACTIONS(1789), 1,
      anon_sym_class,
    ACTIONS(1791), 1,
      anon_sym_struct,
    ACTIONS(1793), 1,
      anon_sym_union,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(1821), 1,
      anon_sym_typename,
    ACTIONS(7810), 1,
      sym_identifier,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7816), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4142), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4817), 1,
      sym_type_specifier,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(8396), 1,
      sym_type_descriptor,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3855), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1781), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [101890] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1787), 1,
      anon_sym_enum,
    ACTIONS(1789), 1,
      anon_sym_class,
    ACTIONS(1791), 1,
      anon_sym_struct,
    ACTIONS(1793), 1,
      anon_sym_union,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(1821), 1,
      anon_sym_typename,
    ACTIONS(7810), 1,
      sym_identifier,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7816), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4142), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4605), 1,
      sym_type_specifier,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(8535), 1,
      sym_type_descriptor,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3854), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1781), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [101993] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(7831), 1,
      sym_identifier,
    ACTIONS(7833), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7837), 1,
      sym_primitive_type,
    ACTIONS(7839), 1,
      anon_sym_enum,
    ACTIONS(7841), 1,
      anon_sym_class,
    ACTIONS(7843), 1,
      anon_sym_struct,
    ACTIONS(7845), 1,
      anon_sym_union,
    ACTIONS(7847), 1,
      anon_sym_typename,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(2788), 1,
      sym_qualified_type_identifier,
    STATE(4831), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4924), 1,
      sym_type_specifier,
    STATE(5591), 1,
      sym__type_definition_type,
    STATE(6513), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3831), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7835), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [102096] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(7831), 1,
      sym_identifier,
    ACTIONS(7833), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7837), 1,
      sym_primitive_type,
    ACTIONS(7839), 1,
      anon_sym_enum,
    ACTIONS(7841), 1,
      anon_sym_class,
    ACTIONS(7843), 1,
      anon_sym_struct,
    ACTIONS(7845), 1,
      anon_sym_union,
    ACTIONS(7847), 1,
      anon_sym_typename,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(2788), 1,
      sym_qualified_type_identifier,
    STATE(4831), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4924), 1,
      sym_type_specifier,
    STATE(5654), 1,
      sym__type_definition_type,
    STATE(6513), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3831), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7835), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [102199] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5387), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5389), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [102256] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(5732), 1,
      anon_sym___attribute,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7710), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(7932), 1,
      anon_sym_STAR,
    ACTIONS(7934), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7936), 1,
      anon_sym_AMP,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2930), 1,
      sym_parameter_list,
    STATE(3720), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(6108), 1,
      sym__abstract_declarator,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7712), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7714), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3715), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4186), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5730), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [102351] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5447), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5449), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [102408] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5399), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5401), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [102465] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(5706), 1,
      anon_sym___attribute,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7710), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(7932), 1,
      anon_sym_STAR,
    ACTIONS(7934), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7936), 1,
      anon_sym_AMP,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2930), 1,
      sym_parameter_list,
    STATE(3720), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(6175), 1,
      sym__abstract_declarator,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7712), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7714), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3218), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4188), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5698), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [102560] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6295), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6297), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [102617] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4067), 1,
      anon_sym_EQ,
    ACTIONS(4147), 1,
      anon_sym_SEMI,
    ACTIONS(4071), 13,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_and_eq,
      anon_sym_or_eq,
      anon_sym_xor_eq,
    ACTIONS(4035), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(4043), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_xor,
      anon_sym_DOT,
  [102680] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1787), 1,
      anon_sym_enum,
    ACTIONS(1789), 1,
      anon_sym_class,
    ACTIONS(1791), 1,
      anon_sym_struct,
    ACTIONS(1793), 1,
      anon_sym_union,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(1821), 1,
      anon_sym_typename,
    ACTIONS(7810), 1,
      sym_identifier,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7816), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4142), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4817), 1,
      sym_type_specifier,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(8305), 1,
      sym_type_descriptor,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3855), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1781), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [102783] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1787), 1,
      anon_sym_enum,
    ACTIONS(1789), 1,
      anon_sym_class,
    ACTIONS(1791), 1,
      anon_sym_struct,
    ACTIONS(1793), 1,
      anon_sym_union,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(1821), 1,
      anon_sym_typename,
    ACTIONS(7810), 1,
      sym_identifier,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7816), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4142), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4436), 1,
      sym_type_specifier,
    STATE(5946), 1,
      sym_type_descriptor,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3867), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1781), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [102886] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7940), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT2,
    ACTIONS(7938), 38,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [102943] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7944), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT2,
    ACTIONS(7942), 38,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [103000] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(7831), 1,
      sym_identifier,
    ACTIONS(7833), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7837), 1,
      sym_primitive_type,
    ACTIONS(7839), 1,
      anon_sym_enum,
    ACTIONS(7841), 1,
      anon_sym_class,
    ACTIONS(7843), 1,
      anon_sym_struct,
    ACTIONS(7845), 1,
      anon_sym_union,
    ACTIONS(7847), 1,
      anon_sym_typename,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(2788), 1,
      sym_qualified_type_identifier,
    STATE(4831), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4924), 1,
      sym_type_specifier,
    STATE(5628), 1,
      sym__type_definition_type,
    STATE(6513), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3831), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7835), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [103103] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(7831), 1,
      sym_identifier,
    ACTIONS(7833), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7837), 1,
      sym_primitive_type,
    ACTIONS(7839), 1,
      anon_sym_enum,
    ACTIONS(7841), 1,
      anon_sym_class,
    ACTIONS(7843), 1,
      anon_sym_struct,
    ACTIONS(7845), 1,
      anon_sym_union,
    ACTIONS(7847), 1,
      anon_sym_typename,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(2788), 1,
      sym_qualified_type_identifier,
    STATE(4831), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4924), 1,
      sym_type_specifier,
    STATE(5639), 1,
      sym__type_definition_type,
    STATE(6513), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3831), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7835), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [103206] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1787), 1,
      anon_sym_enum,
    ACTIONS(1789), 1,
      anon_sym_class,
    ACTIONS(1791), 1,
      anon_sym_struct,
    ACTIONS(1793), 1,
      anon_sym_union,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(1821), 1,
      anon_sym_typename,
    ACTIONS(7810), 1,
      sym_identifier,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7816), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4142), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4605), 1,
      sym_type_specifier,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(7705), 1,
      sym_type_descriptor,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3854), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1781), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [103309] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(7831), 1,
      sym_identifier,
    ACTIONS(7833), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7837), 1,
      sym_primitive_type,
    ACTIONS(7839), 1,
      anon_sym_enum,
    ACTIONS(7841), 1,
      anon_sym_class,
    ACTIONS(7843), 1,
      anon_sym_struct,
    ACTIONS(7845), 1,
      anon_sym_union,
    ACTIONS(7847), 1,
      anon_sym_typename,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(2788), 1,
      sym_qualified_type_identifier,
    STATE(4831), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4924), 1,
      sym_type_specifier,
    STATE(5589), 1,
      sym__type_definition_type,
    STATE(6513), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3831), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7835), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [103412] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(7831), 1,
      sym_identifier,
    ACTIONS(7833), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7837), 1,
      sym_primitive_type,
    ACTIONS(7839), 1,
      anon_sym_enum,
    ACTIONS(7841), 1,
      anon_sym_class,
    ACTIONS(7843), 1,
      anon_sym_struct,
    ACTIONS(7845), 1,
      anon_sym_union,
    ACTIONS(7847), 1,
      anon_sym_typename,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(2788), 1,
      sym_qualified_type_identifier,
    STATE(4831), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4924), 1,
      sym_type_specifier,
    STATE(5684), 1,
      sym__type_definition_type,
    STATE(6513), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3831), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7835), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [103515] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6331), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6333), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
  [103586] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(7831), 1,
      sym_identifier,
    ACTIONS(7833), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7837), 1,
      sym_primitive_type,
    ACTIONS(7839), 1,
      anon_sym_enum,
    ACTIONS(7841), 1,
      anon_sym_class,
    ACTIONS(7843), 1,
      anon_sym_struct,
    ACTIONS(7845), 1,
      anon_sym_union,
    ACTIONS(7847), 1,
      anon_sym_typename,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(2788), 1,
      sym_qualified_type_identifier,
    STATE(4831), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4924), 1,
      sym_type_specifier,
    STATE(5690), 1,
      sym__type_definition_type,
    STATE(6513), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3831), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7835), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [103689] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(7831), 1,
      sym_identifier,
    ACTIONS(7833), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7837), 1,
      sym_primitive_type,
    ACTIONS(7839), 1,
      anon_sym_enum,
    ACTIONS(7841), 1,
      anon_sym_class,
    ACTIONS(7843), 1,
      anon_sym_struct,
    ACTIONS(7845), 1,
      anon_sym_union,
    ACTIONS(7847), 1,
      anon_sym_typename,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(2788), 1,
      sym_qualified_type_identifier,
    STATE(4831), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4924), 1,
      sym_type_specifier,
    STATE(5554), 1,
      sym__type_definition_type,
    STATE(6513), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3831), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7835), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [103792] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(7831), 1,
      sym_identifier,
    ACTIONS(7833), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7837), 1,
      sym_primitive_type,
    ACTIONS(7839), 1,
      anon_sym_enum,
    ACTIONS(7841), 1,
      anon_sym_class,
    ACTIONS(7843), 1,
      anon_sym_struct,
    ACTIONS(7845), 1,
      anon_sym_union,
    ACTIONS(7847), 1,
      anon_sym_typename,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(2788), 1,
      sym_qualified_type_identifier,
    STATE(4831), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4924), 1,
      sym_type_specifier,
    STATE(5558), 1,
      sym__type_definition_type,
    STATE(6513), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3831), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7835), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [103895] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(7831), 1,
      sym_identifier,
    ACTIONS(7833), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7837), 1,
      sym_primitive_type,
    ACTIONS(7839), 1,
      anon_sym_enum,
    ACTIONS(7841), 1,
      anon_sym_class,
    ACTIONS(7843), 1,
      anon_sym_struct,
    ACTIONS(7845), 1,
      anon_sym_union,
    ACTIONS(7847), 1,
      anon_sym_typename,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(2788), 1,
      sym_qualified_type_identifier,
    STATE(4831), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4924), 1,
      sym_type_specifier,
    STATE(5568), 1,
      sym__type_definition_type,
    STATE(6513), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3831), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7835), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [103998] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(7831), 1,
      sym_identifier,
    ACTIONS(7833), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7837), 1,
      sym_primitive_type,
    ACTIONS(7839), 1,
      anon_sym_enum,
    ACTIONS(7841), 1,
      anon_sym_class,
    ACTIONS(7843), 1,
      anon_sym_struct,
    ACTIONS(7845), 1,
      anon_sym_union,
    ACTIONS(7847), 1,
      anon_sym_typename,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(2788), 1,
      sym_qualified_type_identifier,
    STATE(4831), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4924), 1,
      sym_type_specifier,
    STATE(5570), 1,
      sym__type_definition_type,
    STATE(6513), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3831), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7835), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [104101] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(7831), 1,
      sym_identifier,
    ACTIONS(7833), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7837), 1,
      sym_primitive_type,
    ACTIONS(7839), 1,
      anon_sym_enum,
    ACTIONS(7841), 1,
      anon_sym_class,
    ACTIONS(7843), 1,
      anon_sym_struct,
    ACTIONS(7845), 1,
      anon_sym_union,
    ACTIONS(7847), 1,
      anon_sym_typename,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(2788), 1,
      sym_qualified_type_identifier,
    STATE(4831), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4924), 1,
      sym_type_specifier,
    STATE(5584), 1,
      sym__type_definition_type,
    STATE(6513), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3831), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7835), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [104204] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(7831), 1,
      sym_identifier,
    ACTIONS(7833), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7837), 1,
      sym_primitive_type,
    ACTIONS(7839), 1,
      anon_sym_enum,
    ACTIONS(7841), 1,
      anon_sym_class,
    ACTIONS(7843), 1,
      anon_sym_struct,
    ACTIONS(7845), 1,
      anon_sym_union,
    ACTIONS(7847), 1,
      anon_sym_typename,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(2788), 1,
      sym_qualified_type_identifier,
    STATE(4831), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4924), 1,
      sym_type_specifier,
    STATE(5587), 1,
      sym__type_definition_type,
    STATE(6513), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3831), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7835), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [104307] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(7831), 1,
      sym_identifier,
    ACTIONS(7833), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7837), 1,
      sym_primitive_type,
    ACTIONS(7839), 1,
      anon_sym_enum,
    ACTIONS(7841), 1,
      anon_sym_class,
    ACTIONS(7843), 1,
      anon_sym_struct,
    ACTIONS(7845), 1,
      anon_sym_union,
    ACTIONS(7847), 1,
      anon_sym_typename,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(2788), 1,
      sym_qualified_type_identifier,
    STATE(4831), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4924), 1,
      sym_type_specifier,
    STATE(5595), 1,
      sym__type_definition_type,
    STATE(6513), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3831), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7835), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [104410] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(7831), 1,
      sym_identifier,
    ACTIONS(7833), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7837), 1,
      sym_primitive_type,
    ACTIONS(7839), 1,
      anon_sym_enum,
    ACTIONS(7841), 1,
      anon_sym_class,
    ACTIONS(7843), 1,
      anon_sym_struct,
    ACTIONS(7845), 1,
      anon_sym_union,
    ACTIONS(7847), 1,
      anon_sym_typename,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(2788), 1,
      sym_qualified_type_identifier,
    STATE(4831), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4924), 1,
      sym_type_specifier,
    STATE(5596), 1,
      sym__type_definition_type,
    STATE(6513), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3831), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7835), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [104513] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(7831), 1,
      sym_identifier,
    ACTIONS(7833), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7837), 1,
      sym_primitive_type,
    ACTIONS(7839), 1,
      anon_sym_enum,
    ACTIONS(7841), 1,
      anon_sym_class,
    ACTIONS(7843), 1,
      anon_sym_struct,
    ACTIONS(7845), 1,
      anon_sym_union,
    ACTIONS(7847), 1,
      anon_sym_typename,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(2788), 1,
      sym_qualified_type_identifier,
    STATE(4831), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4924), 1,
      sym_type_specifier,
    STATE(5598), 1,
      sym__type_definition_type,
    STATE(6513), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3831), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7835), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [104616] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(7831), 1,
      sym_identifier,
    ACTIONS(7833), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7837), 1,
      sym_primitive_type,
    ACTIONS(7839), 1,
      anon_sym_enum,
    ACTIONS(7841), 1,
      anon_sym_class,
    ACTIONS(7843), 1,
      anon_sym_struct,
    ACTIONS(7845), 1,
      anon_sym_union,
    ACTIONS(7847), 1,
      anon_sym_typename,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(2788), 1,
      sym_qualified_type_identifier,
    STATE(4831), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4924), 1,
      sym_type_specifier,
    STATE(5600), 1,
      sym__type_definition_type,
    STATE(6513), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3831), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7835), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [104719] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1787), 1,
      anon_sym_enum,
    ACTIONS(1789), 1,
      anon_sym_class,
    ACTIONS(1791), 1,
      anon_sym_struct,
    ACTIONS(1793), 1,
      anon_sym_union,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(1821), 1,
      anon_sym_typename,
    ACTIONS(7810), 1,
      sym_identifier,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7816), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4142), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4605), 1,
      sym_type_specifier,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(8159), 1,
      sym_type_descriptor,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3854), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1781), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [104822] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1787), 1,
      anon_sym_enum,
    ACTIONS(1789), 1,
      anon_sym_class,
    ACTIONS(1791), 1,
      anon_sym_struct,
    ACTIONS(1793), 1,
      anon_sym_union,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(1821), 1,
      anon_sym_typename,
    ACTIONS(7810), 1,
      sym_identifier,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7816), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4142), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4817), 1,
      sym_type_specifier,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(8181), 1,
      sym_type_descriptor,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3855), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1781), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [104925] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1787), 1,
      anon_sym_enum,
    ACTIONS(1789), 1,
      anon_sym_class,
    ACTIONS(1791), 1,
      anon_sym_struct,
    ACTIONS(1793), 1,
      anon_sym_union,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(1821), 1,
      anon_sym_typename,
    ACTIONS(7810), 1,
      sym_identifier,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7816), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4142), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4817), 1,
      sym_type_specifier,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(8242), 1,
      sym_type_descriptor,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3855), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1781), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [105028] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3484), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(7695), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5431), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5433), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [105089] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7948), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7946), 44,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
  [105146] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3934), 1,
      sym_alignas_qualifier,
    ACTIONS(7953), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3744), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4908), 10,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DASH_GT,
    ACTIONS(7950), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(4906), 21,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      sym_primitive_type,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [105211] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1787), 1,
      anon_sym_enum,
    ACTIONS(1789), 1,
      anon_sym_class,
    ACTIONS(1791), 1,
      anon_sym_struct,
    ACTIONS(1793), 1,
      anon_sym_union,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(1821), 1,
      anon_sym_typename,
    ACTIONS(7810), 1,
      sym_identifier,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7816), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4142), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4605), 1,
      sym_type_specifier,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(8464), 1,
      sym_type_descriptor,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3854), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1781), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [105314] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7612), 1,
      anon_sym_LT,
    STATE(1829), 1,
      sym_template_argument_list,
    ACTIONS(5720), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(4059), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
  [105377] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      sym_auto,
    ACTIONS(125), 1,
      anon_sym_decltype,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(3758), 1,
      sym_identifier,
    ACTIONS(3766), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3770), 1,
      sym_primitive_type,
    ACTIONS(3772), 1,
      anon_sym_enum,
    ACTIONS(3774), 1,
      anon_sym_class,
    ACTIONS(3776), 1,
      anon_sym_struct,
    ACTIONS(3778), 1,
      anon_sym_union,
    ACTIONS(3780), 1,
      anon_sym_typename,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2423), 1,
      sym_decltype_auto,
    STATE(2667), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2788), 1,
      sym_qualified_type_identifier,
    STATE(4157), 1,
      sym_type_specifier,
    STATE(5746), 1,
      sym_type_descriptor,
    STATE(6476), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(2336), 2,
      sym_decltype,
      sym_template_type,
    STATE(3860), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3768), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2383), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [105480] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1787), 1,
      anon_sym_enum,
    ACTIONS(1789), 1,
      anon_sym_class,
    ACTIONS(1791), 1,
      anon_sym_struct,
    ACTIONS(1793), 1,
      anon_sym_union,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(1821), 1,
      anon_sym_typename,
    ACTIONS(7810), 1,
      sym_identifier,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7816), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4142), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4605), 1,
      sym_type_specifier,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(8330), 1,
      sym_type_descriptor,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3854), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1781), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [105583] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1787), 1,
      anon_sym_enum,
    ACTIONS(1789), 1,
      anon_sym_class,
    ACTIONS(1791), 1,
      anon_sym_struct,
    ACTIONS(1793), 1,
      anon_sym_union,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(1821), 1,
      anon_sym_typename,
    ACTIONS(7810), 1,
      sym_identifier,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7816), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4142), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4817), 1,
      sym_type_specifier,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(8335), 1,
      sym_type_descriptor,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3855), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1781), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [105686] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1787), 1,
      anon_sym_enum,
    ACTIONS(1789), 1,
      anon_sym_class,
    ACTIONS(1791), 1,
      anon_sym_struct,
    ACTIONS(1793), 1,
      anon_sym_union,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(1821), 1,
      anon_sym_typename,
    ACTIONS(7810), 1,
      sym_identifier,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7816), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4142), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4605), 1,
      sym_type_specifier,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(8352), 1,
      sym_type_descriptor,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3854), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1781), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [105789] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1787), 1,
      anon_sym_enum,
    ACTIONS(1789), 1,
      anon_sym_class,
    ACTIONS(1791), 1,
      anon_sym_struct,
    ACTIONS(1793), 1,
      anon_sym_union,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(1821), 1,
      anon_sym_typename,
    ACTIONS(7810), 1,
      sym_identifier,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7816), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4142), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4817), 1,
      sym_type_specifier,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(8357), 1,
      sym_type_descriptor,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3855), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1781), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [105892] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1787), 1,
      anon_sym_enum,
    ACTIONS(1789), 1,
      anon_sym_class,
    ACTIONS(1791), 1,
      anon_sym_struct,
    ACTIONS(1793), 1,
      anon_sym_union,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(1821), 1,
      anon_sym_typename,
    ACTIONS(7810), 1,
      sym_identifier,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7816), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4142), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4605), 1,
      sym_type_specifier,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(8372), 1,
      sym_type_descriptor,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3854), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1781), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [105995] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1787), 1,
      anon_sym_enum,
    ACTIONS(1789), 1,
      anon_sym_class,
    ACTIONS(1791), 1,
      anon_sym_struct,
    ACTIONS(1793), 1,
      anon_sym_union,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(1821), 1,
      anon_sym_typename,
    ACTIONS(7810), 1,
      sym_identifier,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7816), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4142), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4817), 1,
      sym_type_specifier,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(8377), 1,
      sym_type_descriptor,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3855), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1781), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [106098] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1787), 1,
      anon_sym_enum,
    ACTIONS(1789), 1,
      anon_sym_class,
    ACTIONS(1791), 1,
      anon_sym_struct,
    ACTIONS(1793), 1,
      anon_sym_union,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(1821), 1,
      anon_sym_typename,
    ACTIONS(7810), 1,
      sym_identifier,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7816), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4142), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4605), 1,
      sym_type_specifier,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(8391), 1,
      sym_type_descriptor,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3854), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1781), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [106201] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1787), 1,
      anon_sym_enum,
    ACTIONS(1789), 1,
      anon_sym_class,
    ACTIONS(1791), 1,
      anon_sym_struct,
    ACTIONS(1793), 1,
      anon_sym_union,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(1821), 1,
      anon_sym_typename,
    ACTIONS(7810), 1,
      sym_identifier,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7816), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4142), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4605), 1,
      sym_type_specifier,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(8457), 1,
      sym_type_descriptor,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    STATE(3854), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(1781), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [106304] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6451), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6453), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [106360] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6423), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6425), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [106416] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1787), 1,
      anon_sym_enum,
    ACTIONS(1789), 1,
      anon_sym_class,
    ACTIONS(1791), 1,
      anon_sym_struct,
    ACTIONS(1793), 1,
      anon_sym_union,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(1821), 1,
      anon_sym_typename,
    ACTIONS(7810), 1,
      sym_identifier,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7816), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4142), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4199), 1,
      sym_type_specifier,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(1781), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [106516] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6505), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6507), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [106572] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6525), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6527), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [106628] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6481), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6483), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [106684] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6469), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6471), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [106740] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6517), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6519), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [106796] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6473), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6475), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [106852] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_LBRACE,
    ACTIONS(7776), 1,
      anon_sym_LBRACK,
    ACTIONS(7956), 1,
      anon_sym_LPAREN2,
    ACTIONS(7958), 1,
      sym_auto,
    ACTIONS(7960), 1,
      anon_sym_decltype,
    STATE(3955), 1,
      sym_new_declarator,
    STATE(4062), 1,
      sym_decltype_auto,
    STATE(3865), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5734), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5736), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [106924] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(7851), 1,
      sym_identifier,
    ACTIONS(7853), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7857), 1,
      sym_primitive_type,
    ACTIONS(7859), 1,
      anon_sym_enum,
    ACTIONS(7861), 1,
      anon_sym_class,
    ACTIONS(7863), 1,
      anon_sym_struct,
    ACTIONS(7865), 1,
      anon_sym_union,
    ACTIONS(7867), 1,
      sym_auto,
    ACTIONS(7869), 1,
      anon_sym_decltype,
    ACTIONS(7871), 1,
      anon_sym_typename,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(4027), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4189), 1,
      sym_type_specifier,
    STATE(4894), 1,
      sym_decltype_auto,
    STATE(4895), 1,
      sym_qualified_type_identifier,
    STATE(6508), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4829), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(7855), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [107024] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6571), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6573), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [107080] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      sym_auto,
    ACTIONS(125), 1,
      anon_sym_decltype,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(3770), 1,
      sym_primitive_type,
    ACTIONS(7901), 1,
      sym_identifier,
    ACTIONS(7903), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7905), 1,
      anon_sym_enum,
    ACTIONS(7907), 1,
      anon_sym_class,
    ACTIONS(7909), 1,
      anon_sym_struct,
    ACTIONS(7911), 1,
      anon_sym_union,
    ACTIONS(7913), 1,
      anon_sym_typename,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2423), 1,
      sym_decltype_auto,
    STATE(2667), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2788), 1,
      sym_qualified_type_identifier,
    STATE(4042), 1,
      sym_type_specifier,
    STATE(6498), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(2336), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(3768), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2383), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [107180] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6387), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6389), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [107236] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(2872), 1,
      anon_sym_enum,
    ACTIONS(2874), 1,
      anon_sym_class,
    ACTIONS(2876), 1,
      anon_sym_struct,
    ACTIONS(2878), 1,
      anon_sym_union,
    ACTIONS(2902), 1,
      sym_auto,
    ACTIONS(2904), 1,
      anon_sym_decltype,
    ACTIONS(2906), 1,
      anon_sym_typename,
    ACTIONS(7873), 1,
      sym_identifier,
    ACTIONS(7875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7877), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2637), 1,
      sym_decltype_auto,
    STATE(2649), 1,
      sym_qualified_type_identifier,
    STATE(4167), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4196), 1,
      sym_type_specifier,
    STATE(6528), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(2563), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2868), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2651), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [107336] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6521), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6523), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [107392] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3754), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(3750), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [107448] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6505), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6507), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [107504] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5447), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5449), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [107560] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6391), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6393), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [107616] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6525), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6527), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [107672] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6497), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6499), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [107728] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6493), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6495), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [107784] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5122), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5124), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [107840] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6509), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6511), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [107896] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      sym_auto,
    ACTIONS(125), 1,
      anon_sym_decltype,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(3770), 1,
      sym_primitive_type,
    ACTIONS(7901), 1,
      sym_identifier,
    ACTIONS(7903), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7905), 1,
      anon_sym_enum,
    ACTIONS(7907), 1,
      anon_sym_class,
    ACTIONS(7909), 1,
      anon_sym_struct,
    ACTIONS(7911), 1,
      anon_sym_union,
    ACTIONS(7913), 1,
      anon_sym_typename,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2423), 1,
      sym_decltype_auto,
    STATE(2667), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2788), 1,
      sym_qualified_type_identifier,
    STATE(4269), 1,
      sym_type_specifier,
    STATE(6498), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(2336), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(3768), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2383), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [107996] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7962), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(7964), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6092), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6094), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [108056] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6513), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6515), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [108112] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6551), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6553), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [108168] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6485), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6487), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [108224] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5454), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5456), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [108280] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6555), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6557), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [108336] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6559), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6561), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [108392] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6567), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6569), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [108448] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6571), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6573), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [108504] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5126), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5128), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [108560] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    STATE(1570), 1,
      sym_template_argument_list,
    STATE(2267), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4919), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5842), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5844), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [108624] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6391), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6393), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [108680] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_LBRACE,
    ACTIONS(7776), 1,
      anon_sym_LBRACK,
    ACTIONS(7956), 1,
      anon_sym_LPAREN2,
    ACTIONS(7958), 1,
      sym_auto,
    ACTIONS(7960), 1,
      anon_sym_decltype,
    STATE(3951), 1,
      sym_new_declarator,
    STATE(4062), 1,
      sym_decltype_auto,
    STATE(3821), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5712), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5714), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [108752] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6431), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6433), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [108808] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6435), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6437), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [108864] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6547), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6549), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [108920] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(2872), 1,
      anon_sym_enum,
    ACTIONS(2874), 1,
      anon_sym_class,
    ACTIONS(2876), 1,
      anon_sym_struct,
    ACTIONS(2878), 1,
      anon_sym_union,
    ACTIONS(2902), 1,
      sym_auto,
    ACTIONS(2904), 1,
      anon_sym_decltype,
    ACTIONS(2906), 1,
      anon_sym_typename,
    ACTIONS(7873), 1,
      sym_identifier,
    ACTIONS(7875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7877), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2637), 1,
      sym_decltype_auto,
    STATE(2649), 1,
      sym_qualified_type_identifier,
    STATE(4167), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4619), 1,
      sym_type_specifier,
    STATE(6528), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(2563), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2868), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2651), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [109020] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7818), 1,
      anon_sym_LBRACE,
    STATE(3911), 1,
      sym_enumerator_list,
    STATE(4057), 1,
      sym_attribute_specifier,
    ACTIONS(5876), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5848), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5850), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [109084] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1909), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1907), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [109140] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6517), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6519), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [109196] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5170), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5172), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [109252] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1787), 1,
      anon_sym_enum,
    ACTIONS(1789), 1,
      anon_sym_class,
    ACTIONS(1791), 1,
      anon_sym_struct,
    ACTIONS(1793), 1,
      anon_sym_union,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(1821), 1,
      anon_sym_typename,
    ACTIONS(7810), 1,
      sym_identifier,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7816), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4142), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4182), 1,
      sym_type_specifier,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(1781), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [109352] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6509), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6511), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [109408] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5166), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5168), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [109464] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_LBRACE,
    ACTIONS(7776), 1,
      anon_sym_LBRACK,
    ACTIONS(7956), 1,
      anon_sym_LPAREN2,
    ACTIONS(7958), 1,
      sym_auto,
    ACTIONS(7960), 1,
      anon_sym_decltype,
    STATE(3954), 1,
      sym_new_declarator,
    STATE(4062), 1,
      sym_decltype_auto,
    STATE(3797), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5684), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5686), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [109536] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5142), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5144), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [109592] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6423), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6425), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [109648] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7881), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7885), 1,
      sym_primitive_type,
    ACTIONS(7887), 1,
      anon_sym_enum,
    ACTIONS(7889), 1,
      anon_sym_class,
    ACTIONS(7891), 1,
      anon_sym_struct,
    ACTIONS(7893), 1,
      anon_sym_union,
    ACTIONS(7895), 1,
      sym_auto,
    ACTIONS(7897), 1,
      anon_sym_decltype,
    ACTIONS(7899), 1,
      anon_sym_typename,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2788), 1,
      sym_qualified_type_identifier,
    STATE(3909), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3945), 1,
      sym_type_specifier,
    STATE(4584), 1,
      sym_decltype_auto,
    STATE(6504), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(2336), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(7883), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4586), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [109748] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6521), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6523), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [109804] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(7851), 1,
      sym_identifier,
    ACTIONS(7853), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7857), 1,
      sym_primitive_type,
    ACTIONS(7859), 1,
      anon_sym_enum,
    ACTIONS(7861), 1,
      anon_sym_class,
    ACTIONS(7863), 1,
      anon_sym_struct,
    ACTIONS(7865), 1,
      anon_sym_union,
    ACTIONS(7867), 1,
      sym_auto,
    ACTIONS(7869), 1,
      anon_sym_decltype,
    ACTIONS(7871), 1,
      anon_sym_typename,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(4027), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4077), 1,
      sym_type_specifier,
    STATE(4894), 1,
      sym_decltype_auto,
    STATE(4895), 1,
      sym_qualified_type_identifier,
    STATE(6508), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4829), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(7855), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [109904] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5114), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5116), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [109960] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5130), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5132), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [110016] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6513), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6515), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [110072] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6451), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6453), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [110128] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5305), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2721), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [110184] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5134), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5136), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [110240] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5140), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [110296] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5122), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5124), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [110352] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3266), 1,
      sym_ms_restrict_modifier,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(5706), 1,
      anon_sym___attribute,
    ACTIONS(7966), 1,
      anon_sym_STAR,
    ACTIONS(7968), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7970), 1,
      anon_sym_AMP,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    STATE(3006), 1,
      sym_parameter_list,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6258), 1,
      sym__abstract_declarator,
    ACTIONS(7974), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7976), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3851), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4260), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5698), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [110446] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6455), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6457), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [110502] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6447), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6449), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [110558] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7964), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6057), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6059), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [110616] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5174), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5176), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [110672] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6551), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6553), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [110728] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6567), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6569), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [110784] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4043), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(4035), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [110840] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3754), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(3750), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [110896] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6555), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6557), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [110952] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6427), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6429), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [111008] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(7831), 1,
      sym_identifier,
    ACTIONS(7833), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7837), 1,
      sym_primitive_type,
    ACTIONS(7839), 1,
      anon_sym_enum,
    ACTIONS(7841), 1,
      anon_sym_class,
    ACTIONS(7843), 1,
      anon_sym_struct,
    ACTIONS(7845), 1,
      anon_sym_union,
    ACTIONS(7847), 1,
      anon_sym_typename,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(2788), 1,
      sym_qualified_type_identifier,
    STATE(4831), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4957), 1,
      sym_type_specifier,
    STATE(6513), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(7835), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [111108] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6493), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6495), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [111164] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6477), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6479), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [111220] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6485), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6487), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [111276] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6459), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6461), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [111332] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6473), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6475), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [111388] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6419), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6421), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [111444] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6547), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6549), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [111500] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6447), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6449), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [111556] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4043), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4035), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [111612] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6535), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6537), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [111668] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6543), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6545), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [111724] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5118), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5120), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [111780] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6463), 1,
      anon_sym_LT,
    ACTIONS(7982), 1,
      anon_sym_LBRACK,
    STATE(2551), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4207), 1,
      sym_template_argument_list,
    ACTIONS(4056), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4041), 3,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
    ACTIONS(4061), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4033), 34,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_operator,
  [111850] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      sym_auto,
    ACTIONS(125), 1,
      anon_sym_decltype,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(3770), 1,
      sym_primitive_type,
    ACTIONS(7901), 1,
      sym_identifier,
    ACTIONS(7903), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7905), 1,
      anon_sym_enum,
    ACTIONS(7907), 1,
      anon_sym_class,
    ACTIONS(7909), 1,
      anon_sym_struct,
    ACTIONS(7911), 1,
      anon_sym_union,
    ACTIONS(7913), 1,
      anon_sym_typename,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2423), 1,
      sym_decltype_auto,
    STATE(2667), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2788), 1,
      sym_qualified_type_identifier,
    STATE(3932), 1,
      sym_type_specifier,
    STATE(6498), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(2336), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(3768), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2383), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [111950] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5874), 1,
      anon_sym___attribute__,
    ACTIONS(5876), 1,
      anon_sym___attribute,
    ACTIONS(6065), 1,
      anon_sym_LBRACE,
    ACTIONS(7984), 1,
      anon_sym_COLON,
    STATE(1851), 1,
      sym_attribute_specifier,
    STATE(2241), 1,
      sym__enum_base_clause,
    STATE(2294), 1,
      sym_enumerator_list,
    ACTIONS(6245), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(6247), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
  [112020] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5874), 1,
      anon_sym___attribute__,
    ACTIONS(5876), 1,
      anon_sym___attribute,
    ACTIONS(6065), 1,
      anon_sym_LBRACE,
    ACTIONS(7984), 1,
      anon_sym_COLON,
    STATE(1805), 1,
      sym_attribute_specifier,
    STATE(2196), 1,
      sym__enum_base_clause,
    STATE(2295), 1,
      sym_enumerator_list,
    ACTIONS(6161), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(6163), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
  [112090] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5122), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5124), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [112146] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4849), 1,
      anon_sym_LBRACK,
    ACTIONS(7205), 1,
      anon_sym_LT,
    STATE(3913), 1,
      sym_template_argument_list,
    ACTIONS(4842), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4845), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_EQ,
    ACTIONS(4838), 35,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [112212] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6559), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6561), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [112268] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    ACTIONS(7989), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3851), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(7986), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7571), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(7569), 27,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [112332] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7881), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7885), 1,
      sym_primitive_type,
    ACTIONS(7887), 1,
      anon_sym_enum,
    ACTIONS(7889), 1,
      anon_sym_class,
    ACTIONS(7891), 1,
      anon_sym_struct,
    ACTIONS(7893), 1,
      anon_sym_union,
    ACTIONS(7895), 1,
      sym_auto,
    ACTIONS(7897), 1,
      anon_sym_decltype,
    ACTIONS(7899), 1,
      anon_sym_typename,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2788), 1,
      sym_qualified_type_identifier,
    STATE(3909), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3953), 1,
      sym_type_specifier,
    STATE(4584), 1,
      sym_decltype_auto,
    STATE(6504), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(2336), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(7883), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4586), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [112432] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5387), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5389), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [112488] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1787), 1,
      anon_sym_enum,
    ACTIONS(1789), 1,
      anon_sym_class,
    ACTIONS(1791), 1,
      anon_sym_struct,
    ACTIONS(1793), 1,
      anon_sym_union,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(1821), 1,
      anon_sym_typename,
    ACTIONS(7810), 1,
      sym_identifier,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7816), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4142), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4562), 1,
      sym_type_specifier,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(1781), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [112588] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1787), 1,
      anon_sym_enum,
    ACTIONS(1789), 1,
      anon_sym_class,
    ACTIONS(1791), 1,
      anon_sym_struct,
    ACTIONS(1793), 1,
      anon_sym_union,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(1821), 1,
      anon_sym_typename,
    ACTIONS(7810), 1,
      sym_identifier,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7816), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4142), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4843), 1,
      sym_type_specifier,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(1781), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [112688] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7881), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7885), 1,
      sym_primitive_type,
    ACTIONS(7887), 1,
      anon_sym_enum,
    ACTIONS(7889), 1,
      anon_sym_class,
    ACTIONS(7891), 1,
      anon_sym_struct,
    ACTIONS(7893), 1,
      anon_sym_union,
    ACTIONS(7895), 1,
      sym_auto,
    ACTIONS(7897), 1,
      anon_sym_decltype,
    ACTIONS(7899), 1,
      anon_sym_typename,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2788), 1,
      sym_qualified_type_identifier,
    STATE(3909), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4068), 1,
      sym_type_specifier,
    STATE(4584), 1,
      sym_decltype_auto,
    STATE(6504), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(2336), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(7883), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4586), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [112788] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1913), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(1911), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [112844] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5399), 19,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(5401), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [112900] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6455), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6457), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [112956] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      sym_auto,
    ACTIONS(125), 1,
      anon_sym_decltype,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(3758), 1,
      sym_identifier,
    ACTIONS(3766), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3770), 1,
      sym_primitive_type,
    ACTIONS(3772), 1,
      anon_sym_enum,
    ACTIONS(3774), 1,
      anon_sym_class,
    ACTIONS(3776), 1,
      anon_sym_struct,
    ACTIONS(3778), 1,
      anon_sym_union,
    ACTIONS(3780), 1,
      anon_sym_typename,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2423), 1,
      sym_decltype_auto,
    STATE(2667), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2788), 1,
      sym_qualified_type_identifier,
    STATE(4163), 1,
      sym_type_specifier,
    STATE(6476), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(2336), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(3768), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2383), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [113056] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6427), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6429), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [113112] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(2872), 1,
      anon_sym_enum,
    ACTIONS(2874), 1,
      anon_sym_class,
    ACTIONS(2876), 1,
      anon_sym_struct,
    ACTIONS(2878), 1,
      anon_sym_union,
    ACTIONS(2902), 1,
      sym_auto,
    ACTIONS(2904), 1,
      anon_sym_decltype,
    ACTIONS(2906), 1,
      anon_sym_typename,
    ACTIONS(7873), 1,
      sym_identifier,
    ACTIONS(7875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7877), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2637), 1,
      sym_decltype_auto,
    STATE(2649), 1,
      sym_qualified_type_identifier,
    STATE(4167), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4237), 1,
      sym_type_specifier,
    STATE(6528), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(2563), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2868), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2651), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [113212] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6577), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6579), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [113268] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6469), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6471), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [113324] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6435), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6437), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [113380] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6924), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7710), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(7992), 1,
      anon_sym_STAR,
    ACTIONS(7994), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7996), 1,
      anon_sym_AMP,
    STATE(2838), 1,
      sym_parameter_list,
    STATE(3720), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(3934), 1,
      sym_alignas_qualifier,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(6232), 1,
      sym__abstract_declarator,
    ACTIONS(6926), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7712), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7714), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3218), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4236), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5698), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6911), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [113472] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1787), 1,
      anon_sym_enum,
    ACTIONS(1789), 1,
      anon_sym_class,
    ACTIONS(1791), 1,
      anon_sym_struct,
    ACTIONS(1793), 1,
      anon_sym_union,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(1821), 1,
      anon_sym_typename,
    ACTIONS(7810), 1,
      sym_identifier,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7816), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4142), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4384), 1,
      sym_type_specifier,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(1781), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [113572] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5146), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5148), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [113628] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5150), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(5152), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [113684] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6543), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6545), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [113740] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6577), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6579), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [113796] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_LBRACE,
    ACTIONS(7776), 1,
      anon_sym_LBRACK,
    ACTIONS(7956), 1,
      anon_sym_LPAREN2,
    ACTIONS(7958), 1,
      sym_auto,
    ACTIONS(7960), 1,
      anon_sym_decltype,
    STATE(3944), 1,
      sym_new_declarator,
    STATE(4062), 1,
      sym_decltype_auto,
    STATE(3873), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5716), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5718), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [113868] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6477), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6479), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [113924] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6419), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6421), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [113980] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7818), 1,
      anon_sym_LBRACE,
    STATE(3889), 1,
      sym_enumerator_list,
    STATE(4032), 1,
      sym_attribute_specifier,
    ACTIONS(5876), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5834), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5836), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [114044] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(7885), 1,
      sym_primitive_type,
    ACTIONS(7895), 1,
      sym_auto,
    ACTIONS(7897), 1,
      anon_sym_decltype,
    ACTIONS(7915), 1,
      sym_identifier,
    ACTIONS(7917), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7919), 1,
      anon_sym_enum,
    ACTIONS(7921), 1,
      anon_sym_class,
    ACTIONS(7923), 1,
      anon_sym_struct,
    ACTIONS(7925), 1,
      anon_sym_union,
    ACTIONS(7927), 1,
      anon_sym_typename,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2788), 1,
      sym_qualified_type_identifier,
    STATE(3909), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4352), 1,
      sym_type_specifier,
    STATE(4584), 1,
      sym_decltype_auto,
    STATE(6486), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(2336), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(7883), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4586), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [114144] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6924), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7710), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(7992), 1,
      anon_sym_STAR,
    ACTIONS(7994), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7996), 1,
      anon_sym_AMP,
    STATE(2838), 1,
      sym_parameter_list,
    STATE(3720), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(3934), 1,
      sym_alignas_qualifier,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(6208), 1,
      sym__abstract_declarator,
    ACTIONS(6926), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7712), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7714), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3866), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4218), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5730), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6911), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [114236] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6443), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(6445), 32,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [114292] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3266), 1,
      sym_ms_restrict_modifier,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(5732), 1,
      anon_sym___attribute,
    ACTIONS(7966), 1,
      anon_sym_STAR,
    ACTIONS(7968), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7970), 1,
      anon_sym_AMP,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    STATE(3006), 1,
      sym_parameter_list,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6213), 1,
      sym__abstract_declarator,
    ACTIONS(7974), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7976), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3820), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4258), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5730), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [114386] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6431), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6433), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [114442] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7710), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_STAR,
    ACTIONS(8000), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8002), 1,
      anon_sym_AMP,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2982), 1,
      sym_parameter_list,
    STATE(3720), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(6322), 1,
      sym__abstract_declarator,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7712), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7714), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3903), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4357), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5730), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [114533] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4036), 1,
      sym_attribute_specifier,
    ACTIONS(5876), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5917), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5919), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [114592] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6802), 1,
      anon_sym_LBRACE,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(8004), 1,
      anon_sym_COLON,
    STATE(2420), 1,
      sym_attribute_specifier,
    STATE(3467), 1,
      sym__enum_base_clause,
    STATE(3618), 1,
      sym_enumerator_list,
    ACTIONS(6161), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(6163), 36,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [114661] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(3196), 1,
      anon_sym_STAR,
    ACTIONS(3198), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      sym_identifier,
    ACTIONS(6180), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5712), 1,
      sym__scope_resolution,
    STATE(6337), 1,
      sym__declarator,
    STATE(7870), 1,
      sym_ms_based_modifier,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [114754] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(7086), 1,
      anon_sym_STAR,
    ACTIONS(7088), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7090), 1,
      anon_sym_AMP,
    ACTIONS(7092), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5732), 1,
      sym__scope_resolution,
    STATE(6066), 1,
      sym__declarator,
    STATE(7827), 1,
      sym_ms_based_modifier,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [114847] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(3196), 1,
      anon_sym_STAR,
    ACTIONS(3198), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      sym_identifier,
    ACTIONS(6180), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5712), 1,
      sym__scope_resolution,
    STATE(6417), 1,
      sym__declarator,
    STATE(7870), 1,
      sym_ms_based_modifier,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [114940] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(7086), 1,
      anon_sym_STAR,
    ACTIONS(7088), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7090), 1,
      anon_sym_AMP,
    ACTIONS(7092), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5732), 1,
      sym__scope_resolution,
    STATE(6087), 1,
      sym__declarator,
    STATE(7827), 1,
      sym_ms_based_modifier,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [115033] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(5708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7134), 1,
      anon_sym_STAR,
    ACTIONS(7136), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7138), 1,
      anon_sym_AMP,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5765), 1,
      sym__scope_resolution,
    STATE(6503), 1,
      sym__declarator,
    STATE(7968), 1,
      sym_ms_based_modifier,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [115126] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4026), 1,
      sym_attribute_specifier,
    ACTIONS(5876), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5980), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5982), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [115185] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(7086), 1,
      anon_sym_STAR,
    ACTIONS(7088), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7090), 1,
      anon_sym_AMP,
    ACTIONS(7092), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5732), 1,
      sym__scope_resolution,
    STATE(6035), 1,
      sym__declarator,
    STATE(7827), 1,
      sym_ms_based_modifier,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [115278] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(5708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7120), 1,
      anon_sym_STAR,
    ACTIONS(7122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7124), 1,
      anon_sym_AMP,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5765), 1,
      sym__scope_resolution,
    STATE(6215), 1,
      sym__declarator,
    STATE(7915), 1,
      sym_ms_based_modifier,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [115371] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(4157), 1,
      anon_sym_LPAREN2,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(5708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5710), 1,
      anon_sym_LBRACK,
    ACTIONS(5807), 1,
      anon_sym_STAR,
    ACTIONS(8006), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8010), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8012), 1,
      anon_sym_AMP,
    ACTIONS(8014), 1,
      anon_sym_EQ,
    STATE(3166), 1,
      sym_parameter_list,
    STATE(5765), 1,
      sym__scope_resolution,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6197), 1,
      sym__declarator,
    STATE(6432), 1,
      sym__abstract_declarator,
    STATE(6603), 1,
      sym_abstract_reference_declarator,
    STATE(7105), 1,
      sym_variadic_declarator,
    STATE(7106), 1,
      sym_variadic_reference_declarator,
    STATE(7915), 1,
      sym_ms_based_modifier,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(8008), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6608), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5942), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [115480] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(5708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7156), 1,
      anon_sym_STAR,
    ACTIONS(7158), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7160), 1,
      anon_sym_AMP,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5765), 1,
      sym__scope_resolution,
    STATE(6057), 1,
      sym__declarator,
    STATE(8182), 1,
      sym_ms_based_modifier,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [115573] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5454), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5456), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [115628] = 30,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(4157), 1,
      anon_sym_LPAREN2,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(5708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5710), 1,
      anon_sym_LBRACK,
    ACTIONS(5862), 1,
      anon_sym_STAR,
    ACTIONS(8006), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8010), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8012), 1,
      anon_sym_AMP,
    ACTIONS(8016), 1,
      anon_sym_EQ,
    STATE(3233), 1,
      sym_parameter_list,
    STATE(5765), 1,
      sym__scope_resolution,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6196), 1,
      sym__declarator,
    STATE(6449), 1,
      sym__abstract_declarator,
    STATE(6613), 1,
      sym_abstract_reference_declarator,
    STATE(7105), 1,
      sym_variadic_declarator,
    STATE(7106), 1,
      sym_variadic_reference_declarator,
    STATE(7915), 1,
      sym_ms_based_modifier,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(8008), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(6608), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5942), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [115737] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5399), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5401), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [115792] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7096), 1,
      sym_identifier,
    ACTIONS(7098), 1,
      anon_sym_STAR,
    ACTIONS(7100), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7102), 1,
      anon_sym_AMP,
    ACTIONS(7104), 1,
      anon_sym_COLON_COLON,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5750), 1,
      sym__scope_resolution,
    STATE(6337), 1,
      sym__declarator,
    STATE(8303), 1,
      sym_ms_based_modifier,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [115885] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(5708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7156), 1,
      anon_sym_STAR,
    ACTIONS(7158), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7160), 1,
      anon_sym_AMP,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5765), 1,
      sym__scope_resolution,
    STATE(6048), 1,
      sym__declarator,
    STATE(8182), 1,
      sym_ms_based_modifier,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [115978] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(3196), 1,
      anon_sym_STAR,
    ACTIONS(3198), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      sym_identifier,
    ACTIONS(6180), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5712), 1,
      sym__scope_resolution,
    STATE(6376), 1,
      sym__declarator,
    STATE(7870), 1,
      sym_ms_based_modifier,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [116071] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5327), 1,
      sym_identifier,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7106), 1,
      anon_sym_STAR,
    ACTIONS(7108), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7110), 1,
      anon_sym_AMP,
    ACTIONS(7112), 1,
      anon_sym_COLON_COLON,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5764), 1,
      sym__scope_resolution,
    STATE(6584), 1,
      sym__declarator,
    STATE(8019), 1,
      sym_ms_based_modifier,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [116164] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_LBRACE,
    ACTIONS(7776), 1,
      anon_sym_LBRACK,
    ACTIONS(8018), 1,
      anon_sym_LPAREN2,
    ACTIONS(8020), 1,
      sym_auto,
    ACTIONS(8022), 1,
      anon_sym_decltype,
    STATE(1837), 1,
      sym_decltype_auto,
    STATE(4096), 1,
      sym_new_declarator,
    STATE(3821), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5712), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5714), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [116235] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5447), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5449), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [116290] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7710), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_STAR,
    ACTIONS(8000), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8002), 1,
      anon_sym_AMP,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2982), 1,
      sym_parameter_list,
    STATE(3720), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(6278), 1,
      sym__abstract_declarator,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7712), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7714), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3218), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4313), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5698), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [116381] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8024), 1,
      sym_identifier,
    ACTIONS(8034), 1,
      sym_primitive_type,
    STATE(3934), 1,
      sym_alignas_qualifier,
    STATE(4137), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8031), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3744), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8029), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4961), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(4963), 13,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(8026), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [116452] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_LBRACE,
    ACTIONS(7776), 1,
      anon_sym_LBRACK,
    ACTIONS(8018), 1,
      anon_sym_LPAREN2,
    ACTIONS(8020), 1,
      sym_auto,
    ACTIONS(8022), 1,
      anon_sym_decltype,
    STATE(1837), 1,
      sym_decltype_auto,
    STATE(4103), 1,
      sym_new_declarator,
    STATE(3797), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5684), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5686), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [116523] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4054), 1,
      sym_attribute_specifier,
    ACTIONS(5876), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5887), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5889), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [116582] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4045), 1,
      sym_attribute_specifier,
    ACTIONS(5876), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5901), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5903), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [116641] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4058), 1,
      sym_attribute_specifier,
    ACTIONS(5876), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5969), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5971), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [116700] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8036), 1,
      sym_identifier,
    ACTIONS(8046), 1,
      sym_primitive_type,
    STATE(3934), 1,
      sym_alignas_qualifier,
    STATE(4012), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8043), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3904), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8041), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4946), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(4948), 13,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(8038), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [116771] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5327), 1,
      sym_identifier,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7106), 1,
      anon_sym_STAR,
    ACTIONS(7108), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7110), 1,
      anon_sym_AMP,
    ACTIONS(7112), 1,
      anon_sym_COLON_COLON,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5764), 1,
      sym__scope_resolution,
    STATE(6544), 1,
      sym__declarator,
    STATE(8019), 1,
      sym_ms_based_modifier,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [116864] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4051), 1,
      sym_attribute_specifier,
    ACTIONS(5876), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5951), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5953), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [116923] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(5708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7156), 1,
      anon_sym_STAR,
    ACTIONS(7158), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7160), 1,
      anon_sym_AMP,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5765), 1,
      sym__scope_resolution,
    STATE(6041), 1,
      sym__declarator,
    STATE(8182), 1,
      sym_ms_based_modifier,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [117016] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4857), 1,
      anon_sym_SEMI,
    ACTIONS(4866), 1,
      anon_sym_LBRACK,
    ACTIONS(4859), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4862), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
    ACTIONS(4855), 35,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [117077] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(5708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7134), 1,
      anon_sym_STAR,
    ACTIONS(7136), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7138), 1,
      anon_sym_AMP,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5765), 1,
      sym__scope_resolution,
    STATE(6521), 1,
      sym__declarator,
    STATE(7968), 1,
      sym_ms_based_modifier,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [117170] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5387), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(5389), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_GT2,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [117225] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7096), 1,
      sym_identifier,
    ACTIONS(7098), 1,
      anon_sym_STAR,
    ACTIONS(7100), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7102), 1,
      anon_sym_AMP,
    ACTIONS(7104), 1,
      anon_sym_COLON_COLON,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5750), 1,
      sym__scope_resolution,
    STATE(6376), 1,
      sym__declarator,
    STATE(8303), 1,
      sym_ms_based_modifier,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [117318] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4037), 1,
      sym_attribute_specifier,
    ACTIONS(5876), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5976), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5978), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [117377] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_LBRACE,
    ACTIONS(7776), 1,
      anon_sym_LBRACK,
    ACTIONS(8018), 1,
      anon_sym_LPAREN2,
    ACTIONS(8020), 1,
      sym_auto,
    ACTIONS(8022), 1,
      anon_sym_decltype,
    STATE(1837), 1,
      sym_decltype_auto,
    STATE(4069), 1,
      sym_new_declarator,
    STATE(3865), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5734), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5736), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [117448] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4040), 1,
      sym_attribute_specifier,
    ACTIONS(5876), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5990), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5992), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [117507] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4046), 1,
      sym_attribute_specifier,
    ACTIONS(5876), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5947), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5949), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [117566] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5383), 1,
      anon_sym_COLON,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    STATE(2448), 1,
      sym_attribute_specifier,
    STATE(2879), 1,
      sym_field_declaration_list,
    STATE(6974), 1,
      sym_virtual_specifier,
    STATE(7628), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5377), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5375), 32,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_operator,
  [117637] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_LBRACE,
    ACTIONS(7776), 1,
      anon_sym_LBRACK,
    ACTIONS(8018), 1,
      anon_sym_LPAREN2,
    ACTIONS(8020), 1,
      sym_auto,
    ACTIONS(8022), 1,
      anon_sym_decltype,
    STATE(1837), 1,
      sym_decltype_auto,
    STATE(4093), 1,
      sym_new_declarator,
    STATE(3873), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5716), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5718), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [117708] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(5708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7120), 1,
      anon_sym_STAR,
    ACTIONS(7122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7124), 1,
      anon_sym_AMP,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5765), 1,
      sym__scope_resolution,
    STATE(6275), 1,
      sym__declarator,
    STATE(7915), 1,
      sym_ms_based_modifier,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [117801] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4050), 1,
      sym_attribute_specifier,
    ACTIONS(5876), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5986), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5988), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [117860] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4020), 1,
      sym_attribute_specifier,
    ACTIONS(5876), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5905), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5907), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [117919] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(5708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7134), 1,
      anon_sym_STAR,
    ACTIONS(7136), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7138), 1,
      anon_sym_AMP,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5765), 1,
      sym__scope_resolution,
    STATE(6532), 1,
      sym__declarator,
    STATE(7968), 1,
      sym_ms_based_modifier,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [118012] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5327), 1,
      sym_identifier,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7106), 1,
      anon_sym_STAR,
    ACTIONS(7108), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7110), 1,
      anon_sym_AMP,
    ACTIONS(7112), 1,
      anon_sym_COLON_COLON,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5764), 1,
      sym__scope_resolution,
    STATE(6558), 1,
      sym__declarator,
    STATE(8019), 1,
      sym_ms_based_modifier,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [118105] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6802), 1,
      anon_sym_LBRACE,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(8004), 1,
      anon_sym_COLON,
    STATE(2401), 1,
      sym_attribute_specifier,
    STATE(3466), 1,
      sym__enum_base_clause,
    STATE(3615), 1,
      sym_enumerator_list,
    ACTIONS(6245), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym___inline,
      anon_sym_const,
    ACTIONS(6247), 36,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym_LBRACK_LBRACK,
      anon_sym___declspec,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [118174] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(5708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7120), 1,
      anon_sym_STAR,
    ACTIONS(7122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7124), 1,
      anon_sym_AMP,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5765), 1,
      sym__scope_resolution,
    STATE(6209), 1,
      sym__declarator,
    STATE(7915), 1,
      sym_ms_based_modifier,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [118267] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4010), 1,
      sym_attribute_specifier,
    ACTIONS(5876), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5913), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5915), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [118326] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7096), 1,
      sym_identifier,
    ACTIONS(7098), 1,
      anon_sym_STAR,
    ACTIONS(7100), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7102), 1,
      anon_sym_AMP,
    ACTIONS(7104), 1,
      anon_sym_COLON_COLON,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5750), 1,
      sym__scope_resolution,
    STATE(6417), 1,
      sym__declarator,
    STATE(8303), 1,
      sym_ms_based_modifier,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [118419] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(7764), 1,
      anon_sym_STAR,
    ACTIONS(7766), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7768), 1,
      anon_sym_AMP,
    ACTIONS(8050), 1,
      anon_sym___asm,
    ACTIONS(8052), 1,
      sym_auto,
    ACTIONS(8054), 1,
      anon_sym_decltype,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2454), 1,
      sym_decltype_auto,
    STATE(2880), 1,
      sym_parameter_list,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(5933), 1,
      sym__abstract_declarator,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4074), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8048), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [118507] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3266), 1,
      sym_ms_restrict_modifier,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(5706), 1,
      anon_sym___attribute,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8056), 1,
      anon_sym_STAR,
    ACTIONS(8058), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8060), 1,
      anon_sym_AMP,
    STATE(3221), 1,
      sym_parameter_list,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6395), 1,
      sym__abstract_declarator,
    ACTIONS(7974), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7976), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3851), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4419), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5698), 6,
      anon_sym_COMMA,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [118599] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2526), 10,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DASH_GT,
    ACTIONS(2536), 36,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [118653] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3266), 1,
      sym_ms_restrict_modifier,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(5732), 1,
      anon_sym___attribute,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8062), 1,
      anon_sym_STAR,
    ACTIONS(8064), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8066), 1,
      anon_sym_AMP,
    STATE(3249), 1,
      sym_parameter_list,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6411), 1,
      sym__abstract_declarator,
    ACTIONS(7974), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7976), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3948), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4425), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5730), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [118745] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3266), 1,
      sym_ms_restrict_modifier,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8068), 1,
      anon_sym_STAR,
    ACTIONS(8070), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8072), 1,
      anon_sym_AMP,
    STATE(2931), 1,
      sym_parameter_list,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6351), 1,
      sym__abstract_declarator,
    ACTIONS(7974), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7976), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3851), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4409), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5698), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [118835] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3266), 1,
      sym_ms_restrict_modifier,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8074), 1,
      anon_sym_STAR,
    ACTIONS(8076), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8078), 1,
      anon_sym_AMP,
    STATE(2998), 1,
      sym_parameter_list,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6431), 1,
      sym__abstract_declarator,
    ACTIONS(7974), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7976), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3851), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4393), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5698), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [118925] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5506), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5508), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [118979] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8080), 1,
      anon_sym_LT,
    STATE(2495), 1,
      sym_template_argument_list,
    ACTIONS(4838), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(4845), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [119039] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6924), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(7758), 1,
      anon_sym_STAR,
    ACTIONS(7760), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7762), 1,
      anon_sym_AMP,
    ACTIONS(8085), 1,
      anon_sym___attribute,
    ACTIONS(8087), 1,
      sym_auto,
    ACTIONS(8089), 1,
      anon_sym_decltype,
    STATE(2831), 1,
      sym_parameter_list,
    STATE(3934), 1,
      sym_alignas_qualifier,
    STATE(4610), 1,
      sym_decltype_auto,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(5947), 1,
      sym__abstract_declarator,
    ACTIONS(6926), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4109), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8083), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6911), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [119127] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8091), 1,
      anon_sym_LT,
    STATE(2267), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2495), 1,
      sym_template_argument_list,
    ACTIONS(4919), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4033), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4041), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [119191] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5545), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5547), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [119245] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5656), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5658), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [119299] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_LBRACE,
    ACTIONS(7956), 1,
      anon_sym_LPAREN2,
    STATE(3880), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6145), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6147), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [119359] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6924), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(7758), 1,
      anon_sym_STAR,
    ACTIONS(7760), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7762), 1,
      anon_sym_AMP,
    ACTIONS(8050), 1,
      anon_sym___attribute,
    ACTIONS(8087), 1,
      sym_auto,
    ACTIONS(8089), 1,
      anon_sym_decltype,
    STATE(2831), 1,
      sym_parameter_list,
    STATE(3934), 1,
      sym_alignas_qualifier,
    STATE(4610), 1,
      sym_decltype_auto,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(5956), 1,
      sym__abstract_declarator,
    ACTIONS(6926), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4124), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8048), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6911), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [119447] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4941), 10,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DASH_GT,
    ACTIONS(4939), 36,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [119501] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(65), 1,
      anon_sym_const,
    STATE(1619), 1,
      sym_alignas_qualifier,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4153), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4208), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5372), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(8095), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(8093), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [119569] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3266), 1,
      sym_ms_restrict_modifier,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(5706), 1,
      anon_sym___attribute,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8062), 1,
      anon_sym_STAR,
    ACTIONS(8064), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8066), 1,
      anon_sym_AMP,
    STATE(3249), 1,
      sym_parameter_list,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6413), 1,
      sym__abstract_declarator,
    ACTIONS(7974), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7976), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3851), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4428), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5698), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [119661] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7205), 1,
      anon_sym_LT,
    STATE(1570), 1,
      sym_template_argument_list,
    STATE(3060), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6860), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4033), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(4041), 33,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [119725] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5578), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5580), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [119779] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_LBRACE,
    ACTIONS(7956), 1,
      anon_sym_LPAREN2,
    STATE(3778), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6079), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6081), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [119839] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8091), 1,
      anon_sym_LT,
    STATE(2495), 1,
      sym_template_argument_list,
    ACTIONS(5720), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_COLON,
      anon_sym_DOT,
    ACTIONS(4059), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
  [119899] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6924), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7704), 1,
      anon_sym_STAR,
    ACTIONS(7706), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7708), 1,
      anon_sym_AMP,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(8050), 1,
      anon_sym___asm,
    ACTIONS(8087), 1,
      sym_auto,
    ACTIONS(8089), 1,
      anon_sym_decltype,
    STATE(2886), 1,
      sym_parameter_list,
    STATE(3934), 1,
      sym_alignas_qualifier,
    STATE(4610), 1,
      sym_decltype_auto,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(5906), 1,
      sym__abstract_declarator,
    ACTIONS(6926), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4097), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8048), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(6911), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [119987] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_LBRACE,
    ACTIONS(7956), 1,
      anon_sym_LPAREN2,
    STATE(3756), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6088), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6090), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [120047] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_LBRACE,
    ACTIONS(7956), 1,
      anon_sym_LPAREN2,
    STATE(3785), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6053), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6055), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [120107] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5592), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5594), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [120161] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(7764), 1,
      anon_sym_STAR,
    ACTIONS(7766), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7768), 1,
      anon_sym_AMP,
    ACTIONS(8052), 1,
      sym_auto,
    ACTIONS(8054), 1,
      anon_sym_decltype,
    ACTIONS(8085), 1,
      anon_sym___asm,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2454), 1,
      sym_decltype_auto,
    STATE(2880), 1,
      sym_parameter_list,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(5980), 1,
      sym__abstract_declarator,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4075), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8083), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [120249] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6924), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7704), 1,
      anon_sym_STAR,
    ACTIONS(7706), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7708), 1,
      anon_sym_AMP,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(8085), 1,
      anon_sym___asm,
    ACTIONS(8087), 1,
      sym_auto,
    ACTIONS(8089), 1,
      anon_sym_decltype,
    STATE(2886), 1,
      sym_parameter_list,
    STATE(3934), 1,
      sym_alignas_qualifier,
    STATE(4610), 1,
      sym_decltype_auto,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(5995), 1,
      sym__abstract_declarator,
    ACTIONS(6926), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4092), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8083), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(6911), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [120337] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3266), 1,
      sym_ms_restrict_modifier,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(5732), 1,
      anon_sym___attribute,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8056), 1,
      anon_sym_STAR,
    ACTIONS(8058), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8060), 1,
      anon_sym_AMP,
    STATE(3221), 1,
      sym_parameter_list,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6389), 1,
      sym__abstract_declarator,
    ACTIONS(7974), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7976), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3933), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4417), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5730), 6,
      anon_sym_COMMA,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [120429] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 21,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5646), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [120483] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3266), 1,
      sym_ms_restrict_modifier,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8068), 1,
      anon_sym_STAR,
    ACTIONS(8070), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8072), 1,
      anon_sym_AMP,
    STATE(2931), 1,
      sym_parameter_list,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6344), 1,
      sym__abstract_declarator,
    ACTIONS(7974), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7976), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3936), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4406), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5730), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [120573] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3266), 1,
      sym_ms_restrict_modifier,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8074), 1,
      anon_sym_STAR,
    ACTIONS(8076), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8078), 1,
      anon_sym_AMP,
    STATE(2998), 1,
      sym_parameter_list,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6361), 1,
      sym__abstract_declarator,
    ACTIONS(7974), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7976), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3937), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4391), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5730), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [120663] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8097), 1,
      sym_identifier,
    ACTIONS(8099), 1,
      anon_sym_LPAREN2,
    ACTIONS(8101), 1,
      anon_sym_STAR,
    ACTIONS(8103), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8105), 1,
      anon_sym_AMP,
    ACTIONS(8111), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2136), 1,
      sym__type_declarator,
    STATE(2258), 1,
      sym_pointer_type_declarator,
    STATE(3720), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8208), 1,
      sym_ms_based_modifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8107), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3218), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4706), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7710), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8109), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2186), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [120752] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8097), 1,
      sym_identifier,
    ACTIONS(8099), 1,
      anon_sym_LPAREN2,
    ACTIONS(8111), 1,
      sym_primitive_type,
    ACTIONS(8113), 1,
      anon_sym_STAR,
    ACTIONS(8115), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8117), 1,
      anon_sym_AMP,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2258), 1,
      sym_pointer_type_declarator,
    STATE(3720), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6643), 1,
      sym__type_declarator,
    STATE(8327), 1,
      sym_ms_based_modifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8107), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3218), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4686), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7710), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8109), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2186), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [120841] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(61), 1,
      anon_sym___inline,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(8052), 1,
      sym_auto,
    ACTIONS(8054), 1,
      anon_sym_decltype,
    ACTIONS(8119), 1,
      anon_sym_virtual,
    ACTIONS(8123), 1,
      anon_sym___declspec,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2454), 1,
      sym_decltype_auto,
    ACTIONS(6357), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6359), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    STATE(4144), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(8121), 8,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [120924] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8097), 1,
      sym_identifier,
    ACTIONS(8099), 1,
      anon_sym_LPAREN2,
    ACTIONS(8111), 1,
      sym_primitive_type,
    ACTIONS(8125), 1,
      anon_sym_STAR,
    ACTIONS(8127), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8129), 1,
      anon_sym_AMP,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2258), 1,
      sym_pointer_type_declarator,
    STATE(3720), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6202), 1,
      sym__type_declarator,
    STATE(8147), 1,
      sym_ms_based_modifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8107), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3218), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4656), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7710), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8109), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2186), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [121013] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8097), 1,
      sym_identifier,
    ACTIONS(8099), 1,
      anon_sym_LPAREN2,
    ACTIONS(8101), 1,
      anon_sym_STAR,
    ACTIONS(8103), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8105), 1,
      anon_sym_AMP,
    ACTIONS(8111), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2125), 1,
      sym__type_declarator,
    STATE(2258), 1,
      sym_pointer_type_declarator,
    STATE(3720), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8208), 1,
      sym_ms_based_modifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8107), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3218), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4642), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7710), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8109), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2186), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [121102] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8131), 1,
      sym_identifier,
    ACTIONS(8133), 1,
      anon_sym_LPAREN2,
    ACTIONS(8135), 1,
      anon_sym_STAR,
    ACTIONS(8137), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8139), 1,
      anon_sym_AMP,
    ACTIONS(8143), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(3720), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5786), 1,
      sym__type_declarator,
    STATE(5952), 1,
      sym_pointer_type_declarator,
    STATE(7940), 1,
      sym_ms_based_modifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8107), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3218), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4608), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7710), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8141), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5950), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [121191] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7710), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(8145), 1,
      anon_sym_STAR,
    ACTIONS(8147), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8149), 1,
      anon_sym_AMP,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(3191), 1,
      sym_parameter_list,
    STATE(3720), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(6462), 1,
      sym__abstract_declarator,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7712), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7714), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3973), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4708), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5730), 6,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [121280] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5371), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5373), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [121333] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8131), 1,
      sym_identifier,
    ACTIONS(8133), 1,
      anon_sym_LPAREN2,
    ACTIONS(8135), 1,
      anon_sym_STAR,
    ACTIONS(8137), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8139), 1,
      anon_sym_AMP,
    ACTIONS(8143), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(3720), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5784), 1,
      sym__type_declarator,
    STATE(5952), 1,
      sym_pointer_type_declarator,
    STATE(7940), 1,
      sym_ms_based_modifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8107), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3218), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4669), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7710), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8141), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5950), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [121422] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(61), 1,
      anon_sym___inline,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(8052), 1,
      sym_auto,
    ACTIONS(8054), 1,
      anon_sym_decltype,
    ACTIONS(8123), 1,
      anon_sym___declspec,
    ACTIONS(8151), 1,
      anon_sym_virtual,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2454), 1,
      sym_decltype_auto,
    ACTIONS(6375), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6377), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    STATE(4150), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(8121), 8,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [121505] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7710), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(8145), 1,
      anon_sym_STAR,
    ACTIONS(8147), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8149), 1,
      anon_sym_AMP,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(3191), 1,
      sym_parameter_list,
    STATE(3720), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(6466), 1,
      sym__abstract_declarator,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7712), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7714), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3218), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4710), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5698), 6,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [121594] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8131), 1,
      sym_identifier,
    ACTIONS(8133), 1,
      anon_sym_LPAREN2,
    ACTIONS(8135), 1,
      anon_sym_STAR,
    ACTIONS(8137), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8139), 1,
      anon_sym_AMP,
    ACTIONS(8143), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(3720), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5786), 1,
      sym__type_declarator,
    STATE(5952), 1,
      sym_pointer_type_declarator,
    STATE(7940), 1,
      sym_ms_based_modifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8107), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3971), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4608), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7710), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8141), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5950), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [121683] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8153), 1,
      sym_identifier,
    ACTIONS(8155), 1,
      anon_sym_LPAREN2,
    ACTIONS(8157), 1,
      anon_sym_STAR,
    ACTIONS(8159), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8161), 1,
      anon_sym_AMP,
    ACTIONS(8165), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2927), 1,
      sym__type_declarator,
    STATE(3234), 1,
      sym_pointer_type_declarator,
    STATE(3720), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8392), 1,
      sym_ms_based_modifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8107), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3218), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4617), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7710), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8163), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3227), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [121772] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8131), 1,
      sym_identifier,
    ACTIONS(8133), 1,
      anon_sym_LPAREN2,
    ACTIONS(8143), 1,
      sym_primitive_type,
    ACTIONS(8167), 1,
      anon_sym_STAR,
    ACTIONS(8169), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8171), 1,
      anon_sym_AMP,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(3720), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5952), 1,
      sym_pointer_type_declarator,
    STATE(6179), 1,
      sym__type_declarator,
    STATE(8076), 1,
      sym_ms_based_modifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8107), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3218), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4663), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7710), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8141), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5950), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [121861] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8131), 1,
      sym_identifier,
    ACTIONS(8133), 1,
      anon_sym_LPAREN2,
    ACTIONS(8143), 1,
      sym_primitive_type,
    ACTIONS(8167), 1,
      anon_sym_STAR,
    ACTIONS(8169), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8171), 1,
      anon_sym_AMP,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(3720), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5952), 1,
      sym_pointer_type_declarator,
    STATE(6179), 1,
      sym__type_declarator,
    STATE(8076), 1,
      sym_ms_based_modifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8107), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3978), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4663), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7710), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8141), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5950), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [121950] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8131), 1,
      sym_identifier,
    ACTIONS(8133), 1,
      anon_sym_LPAREN2,
    ACTIONS(8143), 1,
      sym_primitive_type,
    ACTIONS(8167), 1,
      anon_sym_STAR,
    ACTIONS(8169), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8171), 1,
      anon_sym_AMP,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(3720), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5952), 1,
      sym_pointer_type_declarator,
    STATE(6177), 1,
      sym__type_declarator,
    STATE(8076), 1,
      sym_ms_based_modifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8107), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3218), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4665), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7710), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8141), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5950), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [122039] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8153), 1,
      sym_identifier,
    ACTIONS(8155), 1,
      anon_sym_LPAREN2,
    ACTIONS(8157), 1,
      anon_sym_STAR,
    ACTIONS(8159), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8161), 1,
      anon_sym_AMP,
    ACTIONS(8165), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2897), 1,
      sym__type_declarator,
    STATE(3234), 1,
      sym_pointer_type_declarator,
    STATE(3720), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8392), 1,
      sym_ms_based_modifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8107), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3218), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4576), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7710), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8163), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3227), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [122128] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7205), 1,
      anon_sym_LT,
    STATE(1570), 1,
      sym_template_argument_list,
    ACTIONS(5720), 6,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_COLON,
      anon_sym___asm,
    ACTIONS(4059), 36,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [122187] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6218), 1,
      anon_sym___attribute__,
    ACTIONS(6220), 1,
      anon_sym___attribute,
    ACTIONS(6581), 1,
      anon_sym_LBRACE,
    ACTIONS(8173), 1,
      anon_sym_COLON,
    STATE(2497), 1,
      sym__enum_base_clause,
    STATE(2546), 1,
      sym_enumerator_list,
    STATE(2643), 1,
      sym_attribute_specifier,
    ACTIONS(6245), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6247), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [122254] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6218), 1,
      anon_sym___attribute__,
    ACTIONS(6220), 1,
      anon_sym___attribute,
    ACTIONS(6581), 1,
      anon_sym_LBRACE,
    ACTIONS(8173), 1,
      anon_sym_COLON,
    STATE(2502), 1,
      sym__enum_base_clause,
    STATE(2539), 1,
      sym_enumerator_list,
    STATE(2629), 1,
      sym_attribute_specifier,
    ACTIONS(6161), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6163), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [122321] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8097), 1,
      sym_identifier,
    ACTIONS(8099), 1,
      anon_sym_LPAREN2,
    ACTIONS(8111), 1,
      sym_primitive_type,
    ACTIONS(8125), 1,
      anon_sym_STAR,
    ACTIONS(8127), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8129), 1,
      anon_sym_AMP,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2258), 1,
      sym_pointer_type_declarator,
    STATE(3720), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6112), 1,
      sym__type_declarator,
    STATE(8147), 1,
      sym_ms_based_modifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8107), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3966), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4652), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7710), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8109), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2186), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [122410] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8153), 1,
      sym_identifier,
    ACTIONS(8155), 1,
      anon_sym_LPAREN2,
    ACTIONS(8157), 1,
      anon_sym_STAR,
    ACTIONS(8159), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8161), 1,
      anon_sym_AMP,
    ACTIONS(8165), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2866), 1,
      sym__type_declarator,
    STATE(3234), 1,
      sym_pointer_type_declarator,
    STATE(3720), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8392), 1,
      sym_ms_based_modifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8107), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3979), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4542), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7710), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8163), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3227), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [122499] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8131), 1,
      sym_identifier,
    ACTIONS(8133), 1,
      anon_sym_LPAREN2,
    ACTIONS(8135), 1,
      anon_sym_STAR,
    ACTIONS(8137), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8139), 1,
      anon_sym_AMP,
    ACTIONS(8143), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(3720), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5781), 1,
      sym__type_declarator,
    STATE(5952), 1,
      sym_pointer_type_declarator,
    STATE(7940), 1,
      sym_ms_based_modifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8107), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3968), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4718), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7710), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8141), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5950), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [122588] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8131), 1,
      sym_identifier,
    ACTIONS(8133), 1,
      anon_sym_LPAREN2,
    ACTIONS(8143), 1,
      sym_primitive_type,
    ACTIONS(8167), 1,
      anon_sym_STAR,
    ACTIONS(8169), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8171), 1,
      anon_sym_AMP,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(3720), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5952), 1,
      sym_pointer_type_declarator,
    STATE(6101), 1,
      sym__type_declarator,
    STATE(8076), 1,
      sym_ms_based_modifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8107), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3976), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4661), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7710), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8141), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5950), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [122677] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3266), 1,
      sym_ms_restrict_modifier,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8175), 1,
      anon_sym_STAR,
    ACTIONS(8177), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8179), 1,
      anon_sym_AMP,
    STATE(3113), 1,
      sym_parameter_list,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6447), 1,
      sym__abstract_declarator,
    ACTIONS(7974), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7976), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3989), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4672), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5730), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [122766] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4840), 1,
      anon_sym_SEMI,
    ACTIONS(4849), 1,
      anon_sym_LBRACK,
    ACTIONS(6463), 1,
      anon_sym_LT,
    STATE(3913), 1,
      sym_template_argument_list,
    ACTIONS(4842), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4845), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(4838), 35,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [122831] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3266), 1,
      sym_ms_restrict_modifier,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8175), 1,
      anon_sym_STAR,
    ACTIONS(8177), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8179), 1,
      anon_sym_AMP,
    STATE(3113), 1,
      sym_parameter_list,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6455), 1,
      sym__abstract_declarator,
    ACTIONS(7974), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7976), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3851), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4674), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5698), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [122920] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5365), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5431), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5433), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [122975] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7958), 1,
      sym_auto,
    ACTIONS(7960), 1,
      anon_sym_decltype,
    STATE(4062), 1,
      sym_decltype_auto,
    ACTIONS(5391), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(5393), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [123034] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8097), 1,
      sym_identifier,
    ACTIONS(8099), 1,
      anon_sym_LPAREN2,
    ACTIONS(8101), 1,
      anon_sym_STAR,
    ACTIONS(8103), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8105), 1,
      anon_sym_AMP,
    ACTIONS(8111), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2128), 1,
      sym__type_declarator,
    STATE(2258), 1,
      sym_pointer_type_declarator,
    STATE(3720), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8208), 1,
      sym_ms_based_modifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8107), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3967), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4567), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7710), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8109), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2186), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [123123] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8097), 1,
      sym_identifier,
    ACTIONS(8099), 1,
      anon_sym_LPAREN2,
    ACTIONS(8111), 1,
      sym_primitive_type,
    ACTIONS(8125), 1,
      anon_sym_STAR,
    ACTIONS(8127), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8129), 1,
      anon_sym_AMP,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2258), 1,
      sym_pointer_type_declarator,
    STATE(3720), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6174), 1,
      sym__type_declarator,
    STATE(8147), 1,
      sym_ms_based_modifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8107), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4005), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4648), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7710), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8109), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2186), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [123212] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8181), 1,
      sym_identifier,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8185), 1,
      anon_sym_STAR,
    ACTIONS(8187), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8189), 1,
      anon_sym_AMP,
    ACTIONS(8193), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(3007), 1,
      sym__type_declarator,
    STATE(3404), 1,
      sym_pointer_type_declarator,
    STATE(3720), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8244), 1,
      sym_ms_based_modifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8107), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3218), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4611), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7710), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8191), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3392), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [123301] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8181), 1,
      sym_identifier,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8185), 1,
      anon_sym_STAR,
    ACTIONS(8187), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8189), 1,
      anon_sym_AMP,
    ACTIONS(8193), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(3007), 1,
      sym__type_declarator,
    STATE(3404), 1,
      sym_pointer_type_declarator,
    STATE(3720), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8244), 1,
      sym_ms_based_modifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8107), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4009), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4611), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7710), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8191), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3392), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [123390] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6463), 1,
      anon_sym_LT,
    STATE(1570), 1,
      sym_template_argument_list,
    STATE(4130), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8195), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5842), 6,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_COLON,
      anon_sym___asm,
    ACTIONS(5844), 31,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [123453] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8181), 1,
      sym_identifier,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8185), 1,
      anon_sym_STAR,
    ACTIONS(8187), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8189), 1,
      anon_sym_AMP,
    ACTIONS(8193), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2966), 1,
      sym__type_declarator,
    STATE(3404), 1,
      sym_pointer_type_declarator,
    STATE(3720), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8244), 1,
      sym_ms_based_modifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8107), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3994), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4588), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7710), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8191), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3392), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [123542] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7940), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(7938), 32,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [123595] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8097), 1,
      sym_identifier,
    ACTIONS(8099), 1,
      anon_sym_LPAREN2,
    ACTIONS(8101), 1,
      anon_sym_STAR,
    ACTIONS(8103), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8105), 1,
      anon_sym_AMP,
    ACTIONS(8111), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2125), 1,
      sym__type_declarator,
    STATE(2258), 1,
      sym_pointer_type_declarator,
    STATE(3720), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8208), 1,
      sym_ms_based_modifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8107), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3963), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4642), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7710), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8109), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2186), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [123684] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7944), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(7942), 32,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [123737] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8153), 1,
      sym_identifier,
    ACTIONS(8155), 1,
      anon_sym_LPAREN2,
    ACTIONS(8157), 1,
      anon_sym_STAR,
    ACTIONS(8159), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8161), 1,
      anon_sym_AMP,
    ACTIONS(8165), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2897), 1,
      sym__type_declarator,
    STATE(3234), 1,
      sym_pointer_type_declarator,
    STATE(3720), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8392), 1,
      sym_ms_based_modifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8107), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3975), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4576), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7710), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8163), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3227), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [123826] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8097), 1,
      sym_identifier,
    ACTIONS(8099), 1,
      anon_sym_LPAREN2,
    ACTIONS(8111), 1,
      sym_primitive_type,
    ACTIONS(8113), 1,
      anon_sym_STAR,
    ACTIONS(8115), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8117), 1,
      anon_sym_AMP,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2258), 1,
      sym_pointer_type_declarator,
    STATE(3720), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6664), 1,
      sym__type_declarator,
    STATE(8327), 1,
      sym_ms_based_modifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8107), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4007), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4680), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7710), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8109), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2186), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [123915] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7205), 1,
      anon_sym_LT,
    STATE(1570), 1,
      sym_template_argument_list,
    ACTIONS(4838), 6,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_COLON,
      anon_sym___asm,
    ACTIONS(4845), 36,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [123974] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(4157), 1,
      anon_sym_LPAREN2,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(5700), 1,
      anon_sym_STAR,
    ACTIONS(5702), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5704), 1,
      anon_sym_AMP,
    ACTIONS(5708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5710), 1,
      anon_sym_LBRACK,
    ACTIONS(8006), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(3005), 1,
      sym_parameter_list,
    STATE(5765), 1,
      sym__scope_resolution,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6254), 1,
      sym__declarator,
    STATE(6438), 1,
      sym__abstract_declarator,
    STATE(7367), 1,
      sym_variadic_declarator,
    STATE(7915), 1,
      sym_ms_based_modifier,
    ACTIONS(8199), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(8197), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_GT2,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [124073] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8097), 1,
      sym_identifier,
    ACTIONS(8099), 1,
      anon_sym_LPAREN2,
    ACTIONS(8111), 1,
      sym_primitive_type,
    ACTIONS(8125), 1,
      anon_sym_STAR,
    ACTIONS(8127), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8129), 1,
      anon_sym_AMP,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2258), 1,
      sym_pointer_type_declarator,
    STATE(3720), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6112), 1,
      sym__type_declarator,
    STATE(8147), 1,
      sym_ms_based_modifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8107), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3218), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4652), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7710), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8109), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2186), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [124162] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7205), 1,
      anon_sym_LT,
    STATE(1570), 1,
      sym_template_argument_list,
    STATE(4130), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8195), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4033), 6,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_COLON,
      anon_sym___asm,
    ACTIONS(4041), 31,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [124225] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8097), 1,
      sym_identifier,
    ACTIONS(8099), 1,
      anon_sym_LPAREN2,
    ACTIONS(8111), 1,
      sym_primitive_type,
    ACTIONS(8113), 1,
      anon_sym_STAR,
    ACTIONS(8115), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8117), 1,
      anon_sym_AMP,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2258), 1,
      sym_pointer_type_declarator,
    STATE(3720), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6624), 1,
      sym__type_declarator,
    STATE(8327), 1,
      sym_ms_based_modifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8107), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3218), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4683), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7710), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8109), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2186), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [124314] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8097), 1,
      sym_identifier,
    ACTIONS(8099), 1,
      anon_sym_LPAREN2,
    ACTIONS(8111), 1,
      sym_primitive_type,
    ACTIONS(8113), 1,
      anon_sym_STAR,
    ACTIONS(8115), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8117), 1,
      anon_sym_AMP,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2258), 1,
      sym_pointer_type_declarator,
    STATE(3720), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(6624), 1,
      sym__type_declarator,
    STATE(8327), 1,
      sym_ms_based_modifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8107), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3964), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4683), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7710), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8109), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2186), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [124403] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8181), 1,
      sym_identifier,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8185), 1,
      anon_sym_STAR,
    ACTIONS(8187), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8189), 1,
      anon_sym_AMP,
    ACTIONS(8193), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2963), 1,
      sym__type_declarator,
    STATE(3404), 1,
      sym_pointer_type_declarator,
    STATE(3720), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(8244), 1,
      sym_ms_based_modifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(8107), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3218), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4697), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(7710), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8191), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3392), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [124492] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5596), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5598), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [124544] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5431), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5433), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [124596] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4043), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4932), 2,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(8201), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4981), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(4984), 28,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [124654] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_LBRACE,
    ACTIONS(7776), 1,
      anon_sym_LBRACK,
    ACTIONS(7956), 1,
      anon_sym_LPAREN2,
    ACTIONS(8020), 1,
      sym_auto,
    ACTIONS(8022), 1,
      anon_sym_decltype,
    STATE(1837), 1,
      sym_decltype_auto,
    STATE(3944), 1,
      sym_new_declarator,
    STATE(3873), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5716), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(5718), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [124722] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_LBRACE,
    ACTIONS(7776), 1,
      anon_sym_LBRACK,
    ACTIONS(7956), 1,
      anon_sym_LPAREN2,
    ACTIONS(8020), 1,
      sym_auto,
    ACTIONS(8022), 1,
      anon_sym_decltype,
    STATE(1837), 1,
      sym_decltype_auto,
    STATE(3954), 1,
      sym_new_declarator,
    STATE(3797), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5684), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(5686), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [124790] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6924), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7710), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(8204), 1,
      anon_sym_STAR,
    ACTIONS(8206), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8208), 1,
      anon_sym_AMP,
    STATE(3434), 1,
      sym_parameter_list,
    STATE(3720), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(3934), 1,
      sym_alignas_qualifier,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(6527), 1,
      sym__abstract_declarator,
    ACTIONS(6926), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7712), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7714), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4017), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4782), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5730), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6911), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [124878] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5648), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5650), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [124930] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6924), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7710), 1,
      sym_ms_restrict_modifier,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(8204), 1,
      anon_sym_STAR,
    ACTIONS(8206), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8208), 1,
      anon_sym_AMP,
    STATE(3434), 1,
      sym_parameter_list,
    STATE(3720), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(3934), 1,
      sym_alignas_qualifier,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(6489), 1,
      sym__abstract_declarator,
    ACTIONS(6926), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(7712), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7714), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(3218), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4784), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5698), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6911), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [125018] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2788), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2783), 42,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
  [125070] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6802), 1,
      anon_sym_LBRACE,
    ACTIONS(8210), 1,
      anon_sym_COLON,
    STATE(2420), 1,
      sym_attribute_specifier,
    STATE(2792), 1,
      sym__enum_base_clause,
    STATE(2894), 1,
      sym_enumerator_list,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6163), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6161), 32,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_operator,
  [125134] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5549), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5551), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [125186] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5498), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5500), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [125238] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5632), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [125290] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5640), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5642), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [125342] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5622), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5624), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [125394] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5600), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5602), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [125446] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5672), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5674), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [125498] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8212), 1,
      sym_identifier,
    ACTIONS(8222), 1,
      sym_primitive_type,
    STATE(4179), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4254), 1,
      sym_alignas_qualifier,
    ACTIONS(8219), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4041), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8217), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4948), 9,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(4946), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(8214), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [125566] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_LBRACE,
    ACTIONS(7776), 1,
      anon_sym_LBRACK,
    ACTIONS(7956), 1,
      anon_sym_LPAREN2,
    ACTIONS(8020), 1,
      sym_auto,
    ACTIONS(8022), 1,
      anon_sym_decltype,
    STATE(1837), 1,
      sym_decltype_auto,
    STATE(3951), 1,
      sym_new_declarator,
    STATE(3821), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5712), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(5714), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [125634] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5541), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5543), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [125686] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_LBRACE,
    ACTIONS(7776), 1,
      anon_sym_LBRACK,
    ACTIONS(7956), 1,
      anon_sym_LPAREN2,
    ACTIONS(8020), 1,
      sym_auto,
    ACTIONS(8022), 1,
      anon_sym_decltype,
    STATE(1837), 1,
      sym_decltype_auto,
    STATE(3955), 1,
      sym_new_declarator,
    STATE(3865), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5734), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(5736), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [125754] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2615), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2613), 42,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
  [125806] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5553), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5555), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [125858] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6802), 1,
      anon_sym_LBRACE,
    ACTIONS(8210), 1,
      anon_sym_COLON,
    STATE(2401), 1,
      sym_attribute_specifier,
    STATE(2745), 1,
      sym__enum_base_clause,
    STATE(2906), 1,
      sym_enumerator_list,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6247), 5,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6245), 32,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_operator,
  [125922] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5537), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5539), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [125974] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2651), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2649), 42,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
  [126026] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5680), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5682), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [126078] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5660), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5662), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [126130] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2733), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2731), 42,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
  [126182] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5498), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5500), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [126234] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5568), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5570), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [126286] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8224), 1,
      sym_identifier,
    ACTIONS(8234), 1,
      sym_primitive_type,
    STATE(4254), 1,
      sym_alignas_qualifier,
    STATE(4353), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8231), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4094), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8229), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4963), 9,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(4961), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(8226), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [126354] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(7932), 1,
      anon_sym_STAR,
    ACTIONS(7934), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7936), 1,
      anon_sym_AMP,
    ACTIONS(8050), 1,
      anon_sym___attribute,
    ACTIONS(8052), 1,
      sym_auto,
    ACTIONS(8054), 1,
      anon_sym_decltype,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2454), 1,
      sym_decltype_auto,
    STATE(2930), 1,
      sym_parameter_list,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(6155), 1,
      sym__abstract_declarator,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4187), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8048), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [126440] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4043), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8201), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4934), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
    ACTIONS(4932), 30,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [126496] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2647), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2645), 42,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
  [126548] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5668), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5670), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [126600] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5529), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5531), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [126652] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5502), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5504), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [126704] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6924), 1,
      anon_sym_const,
    STATE(3934), 1,
      sym_alignas_qualifier,
    ACTIONS(6926), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4246), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4311), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5623), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(8095), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(6911), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(8093), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [126770] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5676), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5678), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [126822] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5564), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5566), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [126874] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5652), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5654), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [126926] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(7932), 1,
      anon_sym_STAR,
    ACTIONS(7934), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7936), 1,
      anon_sym_AMP,
    ACTIONS(8052), 1,
      sym_auto,
    ACTIONS(8054), 1,
      anon_sym_decltype,
    ACTIONS(8085), 1,
      anon_sym___attribute,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2454), 1,
      sym_decltype_auto,
    STATE(2930), 1,
      sym_parameter_list,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(6191), 1,
      sym__abstract_declarator,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4211), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8083), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [127012] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5572), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5574), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [127064] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5533), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5535), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [127116] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2691), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2689), 42,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
  [127168] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5502), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5504), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [127220] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5664), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5666), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [127272] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5510), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5512), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [127324] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5514), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5516), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [127376] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2765), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(2763), 42,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_enum,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_union,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_typename,
      anon_sym_template,
  [127428] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5502), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5504), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [127480] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5626), 19,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5628), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [127532] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8240), 1,
      anon_sym_SLASH,
    ACTIONS(8244), 1,
      anon_sym_CARET,
    ACTIONS(8252), 1,
      anon_sym_GT_EQ,
    ACTIONS(8256), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8258), 1,
      anon_sym_xor,
    ACTIONS(8260), 1,
      anon_sym_not_eq,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8236), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8238), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8242), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8246), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8248), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8254), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8250), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6263), 4,
      aux_sym_preproc_elif_token1,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
    ACTIONS(6265), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
  [127623] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8240), 1,
      anon_sym_SLASH,
    ACTIONS(8256), 1,
      anon_sym_LT_EQ_GT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8236), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8238), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8254), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6263), 13,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6265), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
  [127698] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(8262), 1,
      sym_identifier,
    ACTIONS(8264), 1,
      anon_sym_LPAREN2,
    ACTIONS(8266), 1,
      anon_sym_STAR,
    ACTIONS(8268), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8270), 1,
      anon_sym_AMP,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(6089), 1,
      sym__field_declarator,
    STATE(6266), 1,
      sym_operator_name,
    STATE(7897), 1,
      sym_ms_based_modifier,
    ACTIONS(3268), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3851), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4830), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3266), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(6285), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [127783] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(8264), 1,
      anon_sym_LPAREN2,
    ACTIONS(8272), 1,
      sym_identifier,
    ACTIONS(8274), 1,
      anon_sym_STAR,
    ACTIONS(8276), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8278), 1,
      anon_sym_AMP,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(6546), 1,
      sym__field_declarator,
    STATE(6701), 1,
      sym_operator_name,
    STATE(7946), 1,
      sym_ms_based_modifier,
    ACTIONS(3268), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4078), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4815), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3266), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(6285), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [127868] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3730), 1,
      anon_sym_LBRACE,
    ACTIONS(6696), 1,
      sym_auto,
    ACTIONS(6698), 1,
      anon_sym_decltype,
    ACTIONS(8280), 1,
      anon_sym_LPAREN2,
    ACTIONS(8282), 1,
      anon_sym_LBRACK,
    STATE(2653), 1,
      sym_decltype_auto,
    STATE(4283), 1,
      sym_new_declarator,
    STATE(4743), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5712), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5714), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [127935] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6924), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(7992), 1,
      anon_sym_STAR,
    ACTIONS(7994), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7996), 1,
      anon_sym_AMP,
    ACTIONS(8087), 1,
      sym_auto,
    ACTIONS(8089), 1,
      anon_sym_decltype,
    STATE(2838), 1,
      sym_parameter_list,
    STATE(3934), 1,
      sym_alignas_qualifier,
    STATE(4610), 1,
      sym_decltype_auto,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(6234), 1,
      sym__abstract_declarator,
    ACTIONS(6926), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4222), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8048), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6911), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [128018] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_LBRACE,
    ACTIONS(8018), 1,
      anon_sym_LPAREN2,
    STATE(3785), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6053), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(6055), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [128075] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4847), 1,
      anon_sym_LBRACK,
    ACTIONS(6463), 1,
      anon_sym_LT,
    STATE(4207), 1,
      sym_template_argument_list,
    ACTIONS(4842), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4845), 3,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
    ACTIONS(4838), 34,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_operator,
  [128136] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3266), 1,
      sym_ms_restrict_modifier,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8284), 1,
      anon_sym_STAR,
    ACTIONS(8286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8288), 1,
      anon_sym_AMP,
    STATE(3053), 1,
      sym_parameter_list,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6593), 1,
      sym__abstract_declarator,
    ACTIONS(7974), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7976), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3851), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4808), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5698), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [128223] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4266), 1,
      sym_alignas_qualifier,
    ACTIONS(8293), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4906), 12,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(4908), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(8290), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [128282] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6443), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6445), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [128333] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(7764), 1,
      anon_sym_STAR,
    ACTIONS(7766), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7768), 1,
      anon_sym_AMP,
    ACTIONS(8298), 1,
      anon_sym___asm,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2880), 1,
      sym_parameter_list,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(5983), 1,
      sym__abstract_declarator,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8296), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [128412] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(7764), 1,
      anon_sym_STAR,
    ACTIONS(7766), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7768), 1,
      anon_sym_AMP,
    ACTIONS(8302), 1,
      anon_sym___asm,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2880), 1,
      sym_parameter_list,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(5928), 1,
      sym__abstract_declarator,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8300), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [128491] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8240), 1,
      anon_sym_SLASH,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8236), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8238), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6263), 13,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6265), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
  [128562] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7966), 1,
      anon_sym_STAR,
    ACTIONS(7968), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7970), 1,
      anon_sym_AMP,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8050), 1,
      anon_sym___attribute,
    ACTIONS(8304), 1,
      sym_auto,
    ACTIONS(8306), 1,
      anon_sym_decltype,
    STATE(3006), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(4865), 1,
      sym_decltype_auto,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6228), 1,
      sym__abstract_declarator,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4259), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8048), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [128647] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(8264), 1,
      anon_sym_LPAREN2,
    ACTIONS(8272), 1,
      sym_identifier,
    ACTIONS(8274), 1,
      anon_sym_STAR,
    ACTIONS(8276), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8278), 1,
      anon_sym_AMP,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(6574), 1,
      sym__field_declarator,
    STATE(6701), 1,
      sym_operator_name,
    STATE(7946), 1,
      sym_ms_based_modifier,
    ACTIONS(3268), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3851), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4820), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3266), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(6285), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [128732] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(8264), 1,
      anon_sym_LPAREN2,
    ACTIONS(8272), 1,
      sym_identifier,
    ACTIONS(8274), 1,
      anon_sym_STAR,
    ACTIONS(8276), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8278), 1,
      anon_sym_AMP,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(6577), 1,
      sym__field_declarator,
    STATE(6701), 1,
      sym_operator_name,
    STATE(7946), 1,
      sym_ms_based_modifier,
    ACTIONS(3268), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3851), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4821), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3266), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(6285), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [128817] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(8264), 1,
      anon_sym_LPAREN2,
    ACTIONS(8272), 1,
      sym_identifier,
    ACTIONS(8274), 1,
      anon_sym_STAR,
    ACTIONS(8276), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8278), 1,
      anon_sym_AMP,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(6574), 1,
      sym__field_declarator,
    STATE(6701), 1,
      sym_operator_name,
    STATE(7946), 1,
      sym_ms_based_modifier,
    ACTIONS(3268), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4079), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4820), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3266), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(6285), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [128902] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6481), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6483), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [128953] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8240), 1,
      anon_sym_SLASH,
    ACTIONS(8244), 1,
      anon_sym_CARET,
    ACTIONS(8252), 1,
      anon_sym_GT_EQ,
    ACTIONS(8256), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8258), 1,
      anon_sym_xor,
    ACTIONS(8260), 1,
      anon_sym_not_eq,
    ACTIONS(8308), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8310), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8312), 1,
      anon_sym_or,
    ACTIONS(8314), 1,
      anon_sym_and,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6852), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8236), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8238), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8242), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8246), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8248), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8254), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8250), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6854), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
  [129052] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8240), 1,
      anon_sym_SLASH,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8236), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8238), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8254), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6263), 13,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6265), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
  [129125] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(4157), 1,
      anon_sym_LPAREN2,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(5700), 1,
      anon_sym_STAR,
    ACTIONS(5702), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5704), 1,
      anon_sym_AMP,
    ACTIONS(5708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5710), 1,
      anon_sym_LBRACK,
    STATE(3005), 1,
      sym_parameter_list,
    STATE(5765), 1,
      sym__scope_resolution,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6254), 1,
      sym__declarator,
    STATE(6438), 1,
      sym__abstract_declarator,
    STATE(7915), 1,
      sym_ms_based_modifier,
    ACTIONS(8199), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(8197), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_GT2,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [129218] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7966), 1,
      anon_sym_STAR,
    ACTIONS(7968), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7970), 1,
      anon_sym_AMP,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8085), 1,
      anon_sym___attribute,
    ACTIONS(8304), 1,
      sym_auto,
    ACTIONS(8306), 1,
      anon_sym_decltype,
    STATE(3006), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(4865), 1,
      sym_decltype_auto,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6217), 1,
      sym__abstract_declarator,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4257), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8083), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [129303] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8240), 1,
      anon_sym_SLASH,
    ACTIONS(8244), 1,
      anon_sym_CARET,
    ACTIONS(8252), 1,
      anon_sym_GT_EQ,
    ACTIONS(8256), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8258), 1,
      anon_sym_xor,
    ACTIONS(8260), 1,
      anon_sym_not_eq,
    ACTIONS(8308), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8310), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8312), 1,
      anon_sym_or,
    ACTIONS(8314), 1,
      anon_sym_and,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6806), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8236), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8238), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8242), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8246), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8248), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8254), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8250), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6808), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
  [129402] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8240), 1,
      anon_sym_SLASH,
    ACTIONS(8244), 1,
      anon_sym_CARET,
    ACTIONS(8252), 1,
      anon_sym_GT_EQ,
    ACTIONS(8256), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8258), 1,
      anon_sym_xor,
    ACTIONS(8260), 1,
      anon_sym_not_eq,
    ACTIONS(8308), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8310), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8312), 1,
      anon_sym_or,
    ACTIONS(8314), 1,
      anon_sym_and,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6868), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8236), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8238), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8242), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8246), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8248), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8254), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8250), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6870), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
  [129501] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3730), 1,
      anon_sym_LBRACE,
    ACTIONS(6696), 1,
      sym_auto,
    ACTIONS(6698), 1,
      anon_sym_decltype,
    ACTIONS(8280), 1,
      anon_sym_LPAREN2,
    ACTIONS(8282), 1,
      anon_sym_LBRACK,
    STATE(2653), 1,
      sym_decltype_auto,
    STATE(4361), 1,
      sym_new_declarator,
    STATE(4745), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5716), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5718), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [129568] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(8262), 1,
      sym_identifier,
    ACTIONS(8264), 1,
      anon_sym_LPAREN2,
    ACTIONS(8266), 1,
      anon_sym_STAR,
    ACTIONS(8268), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8270), 1,
      anon_sym_AMP,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(6025), 1,
      sym__field_declarator,
    STATE(6266), 1,
      sym_operator_name,
    STATE(7897), 1,
      sym_ms_based_modifier,
    ACTIONS(3268), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4065), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4795), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3266), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(6285), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [129653] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8240), 1,
      anon_sym_SLASH,
    ACTIONS(8244), 1,
      anon_sym_CARET,
    ACTIONS(8252), 1,
      anon_sym_GT_EQ,
    ACTIONS(8256), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8258), 1,
      anon_sym_xor,
    ACTIONS(8260), 1,
      anon_sym_not_eq,
    ACTIONS(8308), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8310), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8312), 1,
      anon_sym_or,
    ACTIONS(8314), 1,
      anon_sym_and,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8318), 1,
      anon_sym_QMARK,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6848), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8236), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8238), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8242), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8246), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8248), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8254), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8250), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6850), 5,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [129756] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5706), 1,
      anon_sym___attribute,
    ACTIONS(6924), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(7758), 1,
      anon_sym_STAR,
    ACTIONS(7760), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7762), 1,
      anon_sym_AMP,
    STATE(2831), 1,
      sym_parameter_list,
    STATE(3934), 1,
      sym_alignas_qualifier,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(5958), 1,
      sym__abstract_declarator,
    ACTIONS(6926), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3744), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5698), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6911), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [129835] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6924), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7704), 1,
      anon_sym_STAR,
    ACTIONS(7706), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7708), 1,
      anon_sym_AMP,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(8302), 1,
      anon_sym___asm,
    STATE(2886), 1,
      sym_parameter_list,
    STATE(3934), 1,
      sym_alignas_qualifier,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(5905), 1,
      sym__abstract_declarator,
    ACTIONS(6926), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3744), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8300), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(6911), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [129914] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_LBRACE,
    ACTIONS(8018), 1,
      anon_sym_LPAREN2,
    STATE(3880), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6145), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(6147), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [129971] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4254), 1,
      sym_alignas_qualifier,
    ACTIONS(8323), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4094), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4908), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(8320), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(4906), 15,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [130030] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(6634), 1,
      anon_sym___asm,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(7764), 1,
      anon_sym_STAR,
    ACTIONS(7766), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7768), 1,
      anon_sym_AMP,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2880), 1,
      sym_parameter_list,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(5985), 1,
      sym__abstract_declarator,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6632), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [130109] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_LBRACE,
    ACTIONS(8018), 1,
      anon_sym_LPAREN2,
    STATE(3778), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6079), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(6081), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [130166] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6924), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7704), 1,
      anon_sym_STAR,
    ACTIONS(7706), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7708), 1,
      anon_sym_AMP,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(8298), 1,
      anon_sym___asm,
    STATE(2886), 1,
      sym_parameter_list,
    STATE(3934), 1,
      sym_alignas_qualifier,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(5910), 1,
      sym__abstract_declarator,
    ACTIONS(6926), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3744), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8296), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(6911), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [130245] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6634), 1,
      anon_sym___asm,
    ACTIONS(6924), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7704), 1,
      anon_sym_STAR,
    ACTIONS(7706), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7708), 1,
      anon_sym_AMP,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    STATE(2886), 1,
      sym_parameter_list,
    STATE(3934), 1,
      sym_alignas_qualifier,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(5911), 1,
      sym__abstract_declarator,
    ACTIONS(6926), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3744), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6632), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(6911), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [130324] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8240), 1,
      anon_sym_SLASH,
    ACTIONS(8244), 1,
      anon_sym_CARET,
    ACTIONS(8252), 1,
      anon_sym_GT_EQ,
    ACTIONS(8256), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8258), 1,
      anon_sym_xor,
    ACTIONS(8260), 1,
      anon_sym_not_eq,
    ACTIONS(8308), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8310), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8312), 1,
      anon_sym_or,
    ACTIONS(8314), 1,
      anon_sym_and,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8318), 1,
      anon_sym_QMARK,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6856), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8236), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8238), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8242), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8246), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8248), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8254), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8250), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6858), 5,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [130427] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(8262), 1,
      sym_identifier,
    ACTIONS(8264), 1,
      anon_sym_LPAREN2,
    ACTIONS(8266), 1,
      anon_sym_STAR,
    ACTIONS(8268), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8270), 1,
      anon_sym_AMP,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(6089), 1,
      sym__field_declarator,
    STATE(6266), 1,
      sym_operator_name,
    STATE(7897), 1,
      sym_ms_based_modifier,
    ACTIONS(3268), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4113), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4830), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3266), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(6285), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [130512] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8240), 1,
      anon_sym_SLASH,
    ACTIONS(8244), 1,
      anon_sym_CARET,
    ACTIONS(8252), 1,
      anon_sym_GT_EQ,
    ACTIONS(8256), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8258), 1,
      anon_sym_xor,
    ACTIONS(8260), 1,
      anon_sym_not_eq,
    ACTIONS(8310), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8314), 1,
      anon_sym_and,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8236), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8238), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8242), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8246), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8248), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8254), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6263), 3,
      aux_sym_preproc_elif_token1,
      anon_sym_or,
      sym_identifier,
    ACTIONS(8250), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
  [130607] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8240), 1,
      anon_sym_SLASH,
    ACTIONS(8244), 1,
      anon_sym_CARET,
    ACTIONS(8252), 1,
      anon_sym_GT_EQ,
    ACTIONS(8256), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8258), 1,
      anon_sym_xor,
    ACTIONS(8260), 1,
      anon_sym_not_eq,
    ACTIONS(8308), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8310), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8312), 1,
      anon_sym_or,
    ACTIONS(8314), 1,
      anon_sym_and,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6872), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8236), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8238), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8242), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8246), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8248), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8254), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8250), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6874), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
  [130706] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_LBRACE,
    ACTIONS(8018), 1,
      anon_sym_LPAREN2,
    STATE(3756), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6088), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(6090), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [130763] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(5521), 1,
      anon_sym_const,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8326), 1,
      anon_sym_STAR,
    ACTIONS(8328), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8330), 1,
      anon_sym_AMP,
    ACTIONS(8334), 1,
      sym_ms_restrict_modifier,
    STATE(1651), 1,
      sym_alignas_qualifier,
    STATE(3373), 1,
      sym_parameter_list,
    STATE(5211), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6589), 1,
      sym__abstract_declarator,
    ACTIONS(8336), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8338), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8340), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4107), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4834), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5730), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8332), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [130850] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8240), 1,
      anon_sym_SLASH,
    ACTIONS(8244), 1,
      anon_sym_CARET,
    ACTIONS(8252), 1,
      anon_sym_GT_EQ,
    ACTIONS(8256), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8258), 1,
      anon_sym_xor,
    ACTIONS(8260), 1,
      anon_sym_not_eq,
    ACTIONS(8308), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8310), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8312), 1,
      anon_sym_or,
    ACTIONS(8314), 1,
      anon_sym_and,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6844), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8236), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8238), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8242), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8246), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8248), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8254), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8250), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6846), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_QMARK,
  [130949] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8240), 1,
      anon_sym_SLASH,
    ACTIONS(8252), 1,
      anon_sym_GT_EQ,
    ACTIONS(8256), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8260), 1,
      anon_sym_not_eq,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8236), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8238), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8246), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8248), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8254), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8250), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6263), 7,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      sym_identifier,
    ACTIONS(6265), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_QMARK,
  [131034] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(5521), 1,
      anon_sym_const,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8326), 1,
      anon_sym_STAR,
    ACTIONS(8328), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8330), 1,
      anon_sym_AMP,
    ACTIONS(8334), 1,
      sym_ms_restrict_modifier,
    STATE(1651), 1,
      sym_alignas_qualifier,
    STATE(3373), 1,
      sym_parameter_list,
    STATE(5211), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6535), 1,
      sym__abstract_declarator,
    ACTIONS(8336), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8338), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8340), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4836), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(4923), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(5698), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8332), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [131121] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(5706), 1,
      anon_sym___asm,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(7764), 1,
      anon_sym_STAR,
    ACTIONS(7766), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7768), 1,
      anon_sym_AMP,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2880), 1,
      sym_parameter_list,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(5963), 1,
      sym__abstract_declarator,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5698), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [131200] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6924), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(7758), 1,
      anon_sym_STAR,
    ACTIONS(7760), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7762), 1,
      anon_sym_AMP,
    ACTIONS(8302), 1,
      anon_sym___attribute,
    STATE(2831), 1,
      sym_parameter_list,
    STATE(3934), 1,
      sym_alignas_qualifier,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(5955), 1,
      sym__abstract_declarator,
    ACTIONS(6926), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3744), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8300), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6911), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [131279] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6634), 1,
      anon_sym___attribute,
    ACTIONS(6924), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(7758), 1,
      anon_sym_STAR,
    ACTIONS(7760), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7762), 1,
      anon_sym_AMP,
    STATE(2831), 1,
      sym_parameter_list,
    STATE(3934), 1,
      sym_alignas_qualifier,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(5961), 1,
      sym__abstract_declarator,
    ACTIONS(6926), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3744), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6632), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6911), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [131358] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8240), 1,
      anon_sym_SLASH,
    ACTIONS(8244), 1,
      anon_sym_CARET,
    ACTIONS(8252), 1,
      anon_sym_GT_EQ,
    ACTIONS(8256), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8258), 1,
      anon_sym_xor,
    ACTIONS(8260), 1,
      anon_sym_not_eq,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8236), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8238), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8246), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8248), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8254), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8250), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6263), 6,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      sym_identifier,
    ACTIONS(6265), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
  [131447] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8240), 1,
      anon_sym_SLASH,
    ACTIONS(8244), 1,
      anon_sym_CARET,
    ACTIONS(8252), 1,
      anon_sym_GT_EQ,
    ACTIONS(8256), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8258), 1,
      anon_sym_xor,
    ACTIONS(8260), 1,
      anon_sym_not_eq,
    ACTIONS(8308), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8310), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8312), 1,
      anon_sym_or,
    ACTIONS(8314), 1,
      anon_sym_and,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8318), 1,
      anon_sym_QMARK,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8236), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8238), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8242), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8246), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8248), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8254), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8342), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(8250), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8344), 5,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [131550] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(8262), 1,
      sym_identifier,
    ACTIONS(8264), 1,
      anon_sym_LPAREN2,
    ACTIONS(8266), 1,
      anon_sym_STAR,
    ACTIONS(8268), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8270), 1,
      anon_sym_AMP,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(6065), 1,
      sym__field_declarator,
    STATE(6266), 1,
      sym_operator_name,
    STATE(7897), 1,
      sym_ms_based_modifier,
    ACTIONS(3268), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3851), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4819), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(3266), 3,
      sym_ms_restrict_modifier,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    STATE(6285), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [131635] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6924), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(7992), 1,
      anon_sym_STAR,
    ACTIONS(7994), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7996), 1,
      anon_sym_AMP,
    ACTIONS(8087), 1,
      sym_auto,
    ACTIONS(8089), 1,
      anon_sym_decltype,
    STATE(2838), 1,
      sym_parameter_list,
    STATE(3934), 1,
      sym_alignas_qualifier,
    STATE(4610), 1,
      sym_decltype_auto,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(6223), 1,
      sym__abstract_declarator,
    ACTIONS(6926), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4267), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8083), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6911), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [131718] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8240), 1,
      anon_sym_SLASH,
    ACTIONS(8252), 1,
      anon_sym_GT_EQ,
    ACTIONS(8256), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8260), 1,
      anon_sym_not_eq,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8236), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8238), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8248), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8254), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8250), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6263), 9,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      sym_identifier,
    ACTIONS(6265), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_QMARK,
  [131801] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6535), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6537), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [131852] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8240), 1,
      anon_sym_SLASH,
    ACTIONS(8244), 1,
      anon_sym_CARET,
    ACTIONS(8252), 1,
      anon_sym_GT_EQ,
    ACTIONS(8256), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8258), 1,
      anon_sym_xor,
    ACTIONS(8260), 1,
      anon_sym_not_eq,
    ACTIONS(8308), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8310), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8312), 1,
      anon_sym_or,
    ACTIONS(8314), 1,
      anon_sym_and,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8318), 1,
      anon_sym_QMARK,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6543), 2,
      aux_sym_preproc_elif_token1,
      sym_identifier,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8236), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8238), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8242), 2,
      anon_sym_PIPE,
      anon_sym_bitor,
    ACTIONS(8246), 2,
      anon_sym_AMP,
      anon_sym_bitand,
    ACTIONS(8248), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8254), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8250), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6545), 5,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [131955] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3266), 1,
      sym_ms_restrict_modifier,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8284), 1,
      anon_sym_STAR,
    ACTIONS(8286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8288), 1,
      anon_sym_AMP,
    STATE(3053), 1,
      sym_parameter_list,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6571), 1,
      sym__abstract_declarator,
    ACTIONS(7974), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7976), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4071), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4832), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5730), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [132042] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8240), 1,
      anon_sym_SLASH,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8238), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6263), 15,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6265), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
  [132111] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8240), 1,
      anon_sym_SLASH,
    ACTIONS(8252), 1,
      anon_sym_GT_EQ,
    ACTIONS(8256), 1,
      anon_sym_LT_EQ_GT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8236), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8238), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8254), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8250), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6263), 10,
      aux_sym_preproc_elif_token1,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      sym_identifier,
    ACTIONS(6265), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
  [132190] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3730), 1,
      anon_sym_LBRACE,
    ACTIONS(6696), 1,
      sym_auto,
    ACTIONS(6698), 1,
      anon_sym_decltype,
    ACTIONS(8280), 1,
      anon_sym_LPAREN2,
    ACTIONS(8282), 1,
      anon_sym_LBRACK,
    STATE(2653), 1,
      sym_decltype_auto,
    STATE(4346), 1,
      sym_new_declarator,
    STATE(4737), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5734), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5736), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [132257] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3730), 1,
      anon_sym_LBRACE,
    ACTIONS(6696), 1,
      sym_auto,
    ACTIONS(6698), 1,
      anon_sym_decltype,
    ACTIONS(8280), 1,
      anon_sym_LPAREN2,
    ACTIONS(8282), 1,
      anon_sym_LBRACK,
    STATE(2653), 1,
      sym_decltype_auto,
    STATE(4328), 1,
      sym_new_declarator,
    STATE(4759), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(5684), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(5686), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [132324] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5706), 1,
      anon_sym___asm,
    ACTIONS(6924), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7704), 1,
      anon_sym_STAR,
    ACTIONS(7706), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7708), 1,
      anon_sym_AMP,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    STATE(2886), 1,
      sym_parameter_list,
    STATE(3934), 1,
      sym_alignas_qualifier,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(5909), 1,
      sym__abstract_declarator,
    ACTIONS(6926), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3744), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5698), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(6911), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [132403] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6924), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(7758), 1,
      anon_sym_STAR,
    ACTIONS(7760), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7762), 1,
      anon_sym_AMP,
    ACTIONS(8298), 1,
      anon_sym___attribute,
    STATE(2831), 1,
      sym_parameter_list,
    STATE(3934), 1,
      sym_alignas_qualifier,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(5959), 1,
      sym__abstract_declarator,
    ACTIONS(6926), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3744), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8296), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6911), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [132482] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4043), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8346), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5758), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5756), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [132536] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8348), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8350), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6092), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(6094), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [132590] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6899), 1,
      sym_literal_suffix,
    ACTIONS(4043), 17,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(4035), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [132642] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8352), 1,
      anon_sym_COMMA,
    ACTIONS(8358), 1,
      anon_sym_SLASH,
    ACTIONS(8364), 1,
      anon_sym_PIPE,
    ACTIONS(8368), 1,
      anon_sym_AMP,
    ACTIONS(8374), 1,
      anon_sym_GT_EQ,
    ACTIONS(8378), 1,
      anon_sym_SEMI,
    ACTIONS(8380), 1,
      anon_sym_QMARK,
    ACTIONS(8382), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8384), 1,
      anon_sym_bitor,
    ACTIONS(8386), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    STATE(6716), 1,
      aux_sym_field_declaration_repeat1,
    STATE(7806), 1,
      sym_attribute_specifier,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8354), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8356), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8360), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8362), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8366), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8376), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8370), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8372), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [132748] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4043), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8346), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5768), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5766), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [132802] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4043), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8346), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5791), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5789), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [132856] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4133), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8388), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5803), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5801), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [132910] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4134), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8390), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5746), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5744), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [132964] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4043), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8346), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5795), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5793), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [133018] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4043), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8346), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5782), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5780), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [133072] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4139), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8392), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5740), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5738), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [133126] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4125), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8394), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5762), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5760), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [133180] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4043), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8346), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5778), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5776), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [133234] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4129), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8396), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5545), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5547), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [133288] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4043), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8346), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5752), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5750), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [133342] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6901), 18,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
      sym_literal_suffix,
    ACTIONS(6903), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [133392] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3266), 1,
      sym_ms_restrict_modifier,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(4873), 1,
      anon_sym_STAR,
    ACTIONS(4875), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4877), 1,
      anon_sym_AMP,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6609), 1,
      sym__abstract_declarator,
    ACTIONS(7974), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7976), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4143), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4849), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5730), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [133478] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5634), 1,
      sym_identifier,
    ACTIONS(5638), 1,
      sym_primitive_type,
    STATE(1651), 1,
      sym_alignas_qualifier,
    STATE(4307), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8403), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4145), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8401), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4948), 8,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(4946), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(8398), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [133544] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3266), 1,
      sym_ms_restrict_modifier,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(4873), 1,
      anon_sym_STAR,
    ACTIONS(4875), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4877), 1,
      anon_sym_AMP,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6616), 1,
      sym__abstract_declarator,
    ACTIONS(7974), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7976), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3851), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4890), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5698), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [133630] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(61), 1,
      anon_sym___inline,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(8123), 1,
      anon_sym___declspec,
    ACTIONS(8406), 1,
      anon_sym_virtual,
    STATE(1619), 1,
      sym_alignas_qualifier,
    ACTIONS(6640), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6642), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    STATE(4155), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(8121), 8,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [133704] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5604), 1,
      sym_identifier,
    ACTIONS(5608), 1,
      sym_primitive_type,
    STATE(1651), 1,
      sym_alignas_qualifier,
    STATE(1884), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8411), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1617), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5606), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4963), 8,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(4961), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(8408), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [133770] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8352), 1,
      anon_sym_COMMA,
    ACTIONS(8358), 1,
      anon_sym_SLASH,
    ACTIONS(8364), 1,
      anon_sym_PIPE,
    ACTIONS(8368), 1,
      anon_sym_AMP,
    ACTIONS(8374), 1,
      anon_sym_GT_EQ,
    ACTIONS(8380), 1,
      anon_sym_QMARK,
    ACTIONS(8382), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8384), 1,
      anon_sym_bitor,
    ACTIONS(8386), 1,
      anon_sym_bitand,
    ACTIONS(8414), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    STATE(6684), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8573), 1,
      sym_attribute_specifier,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8354), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8356), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8360), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8362), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8366), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8376), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8370), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8372), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [133876] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8416), 1,
      anon_sym_LT,
    STATE(4306), 1,
      sym_template_argument_list,
    STATE(4335), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4033), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(8418), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4041), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [133936] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6463), 1,
      anon_sym_LT,
    STATE(1570), 1,
      sym_template_argument_list,
    STATE(4335), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5842), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(8418), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5844), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [133996] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(65), 1,
      anon_sym_const,
    STATE(1619), 1,
      sym_alignas_qualifier,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8095), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(8093), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [134056] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(61), 1,
      anon_sym___inline,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(8123), 1,
      anon_sym___declspec,
    ACTIONS(8406), 1,
      anon_sym_virtual,
    STATE(1619), 1,
      sym_alignas_qualifier,
    ACTIONS(6586), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6588), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    STATE(4155), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(8121), 8,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [134130] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8352), 1,
      anon_sym_COMMA,
    ACTIONS(8358), 1,
      anon_sym_SLASH,
    ACTIONS(8364), 1,
      anon_sym_PIPE,
    ACTIONS(8368), 1,
      anon_sym_AMP,
    ACTIONS(8374), 1,
      anon_sym_GT_EQ,
    ACTIONS(8380), 1,
      anon_sym_QMARK,
    ACTIONS(8382), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8384), 1,
      anon_sym_bitor,
    ACTIONS(8386), 1,
      anon_sym_bitand,
    ACTIONS(8420), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    STATE(6724), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8534), 1,
      sym_attribute_specifier,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8354), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8356), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8360), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8362), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8366), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8376), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8370), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8372), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [134236] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8424), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8422), 36,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_template,
      anon_sym_operator,
  [134286] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(65), 1,
      anon_sym_const,
    STATE(1619), 1,
      sym_alignas_qualifier,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8428), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(8426), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [134346] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8350), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6057), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(6059), 30,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [134398] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7591), 1,
      anon_sym_const,
    ACTIONS(7597), 1,
      anon_sym___inline,
    ACTIONS(7600), 1,
      anon_sym___attribute,
    ACTIONS(8433), 1,
      anon_sym_virtual,
    ACTIONS(8439), 1,
      anon_sym___attribute__,
    ACTIONS(8442), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8445), 1,
      anon_sym___declspec,
    STATE(1619), 1,
      sym_alignas_qualifier,
    ACTIONS(6600), 2,
      anon_sym_AMP,
      anon_sym_LBRACK,
    ACTIONS(8448), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(6602), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    STATE(4155), 7,
      sym__declaration_modifiers,
      sym_attribute_specifier,
      sym_attribute_declaration,
      sym_ms_declspec_modifier,
      sym_storage_class_specifier,
      sym_type_qualifier,
      aux_sym__declaration_specifiers_repeat1,
    ACTIONS(8436), 8,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
    ACTIONS(8430), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [134472] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5365), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5433), 5,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5431), 36,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [134524] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_STAR,
    ACTIONS(8000), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8002), 1,
      anon_sym_AMP,
    ACTIONS(8052), 1,
      sym_auto,
    ACTIONS(8054), 1,
      anon_sym_decltype,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2454), 1,
      sym_decltype_auto,
    STATE(2982), 1,
      sym_parameter_list,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(6318), 1,
      sym__abstract_declarator,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4347), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8083), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [134606] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3266), 1,
      sym_ms_restrict_modifier,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8451), 1,
      anon_sym_STAR,
    ACTIONS(8453), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8455), 1,
      anon_sym_AMP,
    STATE(3109), 1,
      sym_parameter_list,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6655), 1,
      sym__abstract_declarator,
    ACTIONS(7974), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7976), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4159), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4878), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5730), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [134692] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3266), 1,
      sym_ms_restrict_modifier,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8451), 1,
      anon_sym_STAR,
    ACTIONS(8453), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8455), 1,
      anon_sym_AMP,
    STATE(3109), 1,
      sym_parameter_list,
    STATE(3998), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6658), 1,
      sym__abstract_declarator,
    ACTIONS(7974), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(7976), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3851), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4880), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5698), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [134778] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6802), 1,
      anon_sym_LBRACE,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(8457), 1,
      anon_sym_COLON,
    STATE(2401), 1,
      sym_attribute_specifier,
    STATE(3466), 1,
      sym__enum_base_clause,
    STATE(3615), 1,
      sym_enumerator_list,
    ACTIONS(6245), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(6247), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [134842] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6802), 1,
      anon_sym_LBRACE,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(8457), 1,
      anon_sym_COLON,
    STATE(2420), 1,
      sym_attribute_specifier,
    STATE(3467), 1,
      sym__enum_base_clause,
    STATE(3618), 1,
      sym_enumerator_list,
    ACTIONS(6161), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(6163), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [134906] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8461), 1,
      anon_sym_LPAREN2,
    ACTIONS(8463), 5,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8459), 36,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_LBRACK,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_explicit,
      anon_sym_template,
      anon_sym_operator,
  [134958] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_STAR,
    ACTIONS(8000), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8002), 1,
      anon_sym_AMP,
    ACTIONS(8052), 1,
      sym_auto,
    ACTIONS(8054), 1,
      anon_sym_decltype,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2454), 1,
      sym_decltype_auto,
    STATE(2982), 1,
      sym_parameter_list,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(6282), 1,
      sym__abstract_declarator,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4360), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8048), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [135040] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4129), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8396), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5431), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5433), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [135094] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5140), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [135143] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5134), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5136), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [135192] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5994), 1,
      sym_identifier,
    ACTIONS(6002), 1,
      sym_primitive_type,
    STATE(2209), 1,
      sym_alignas_qualifier,
    STATE(4410), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8470), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4176), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8468), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4946), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_GT2,
    ACTIONS(4948), 8,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(8465), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [135257] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6899), 1,
      sym_literal_suffix,
    ACTIONS(4043), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(4035), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [135308] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5170), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5172), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [135357] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5142), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5144), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [135406] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5174), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5176), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [135455] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5146), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5148), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [135504] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5150), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5152), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [135553] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5166), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5168), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [135602] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(4157), 1,
      anon_sym_LPAREN2,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(5708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5710), 1,
      anon_sym_LBRACK,
    ACTIONS(5807), 1,
      anon_sym_STAR,
    ACTIONS(5809), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5811), 1,
      anon_sym_AMP,
    STATE(3166), 1,
      sym_parameter_list,
    STATE(5765), 1,
      sym__scope_resolution,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6254), 1,
      sym__declarator,
    STATE(6591), 1,
      sym__abstract_declarator,
    STATE(7915), 1,
      sym_ms_based_modifier,
    ACTIONS(8197), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(8199), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [135693] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6004), 1,
      sym_identifier,
    ACTIONS(6008), 1,
      sym_primitive_type,
    STATE(2209), 1,
      sym_alignas_qualifier,
    STATE(2301), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8476), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1882), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6006), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4961), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_GT2,
    ACTIONS(4963), 8,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(8473), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [135758] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5383), 1,
      anon_sym_COLON,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(8479), 1,
      anon_sym_LBRACE,
    STATE(4439), 1,
      sym_field_declaration_list,
    STATE(4632), 1,
      sym_attribute_specifier,
    STATE(7020), 1,
      sym_virtual_specifier,
    STATE(7734), 1,
      sym_base_class_clause,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5375), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5377), 27,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_try,
      anon_sym_requires,
  [135825] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1913), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(1911), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [135874] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4204), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4932), 2,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(8481), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4981), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4984), 24,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [135929] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5114), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5116), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [135978] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8020), 1,
      sym_auto,
    ACTIONS(8022), 1,
      anon_sym_decltype,
    ACTIONS(8074), 1,
      anon_sym_STAR,
    ACTIONS(8076), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8078), 1,
      anon_sym_AMP,
    STATE(1837), 1,
      sym_decltype_auto,
    STATE(2998), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6326), 1,
      sym__abstract_declarator,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4389), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8083), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [136059] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8020), 1,
      sym_auto,
    ACTIONS(8022), 1,
      anon_sym_decltype,
    ACTIONS(8074), 1,
      anon_sym_STAR,
    ACTIONS(8076), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8078), 1,
      anon_sym_AMP,
    STATE(1837), 1,
      sym_decltype_auto,
    STATE(2998), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6349), 1,
      sym__abstract_declarator,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4392), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8048), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [136140] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1909), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(1907), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [136189] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(4157), 1,
      anon_sym_LPAREN2,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(5708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5710), 1,
      anon_sym_LBRACK,
    ACTIONS(5862), 1,
      anon_sym_STAR,
    ACTIONS(5864), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5866), 1,
      anon_sym_AMP,
    STATE(3233), 1,
      sym_parameter_list,
    STATE(5765), 1,
      sym__scope_resolution,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6254), 1,
      sym__declarator,
    STATE(6572), 1,
      sym__abstract_declarator,
    STATE(7915), 1,
      sym_ms_based_modifier,
    ACTIONS(8197), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(8199), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [136280] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6327), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(6329), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [136329] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(5706), 1,
      anon_sym___attribute,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(7932), 1,
      anon_sym_STAR,
    ACTIONS(7934), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7936), 1,
      anon_sym_AMP,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2930), 1,
      sym_parameter_list,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(6175), 1,
      sym__abstract_declarator,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5698), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [136406] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(7932), 1,
      anon_sym_STAR,
    ACTIONS(7934), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7936), 1,
      anon_sym_AMP,
    ACTIONS(8298), 1,
      anon_sym___attribute,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2930), 1,
      sym_parameter_list,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(6200), 1,
      sym__abstract_declarator,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8296), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [136483] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(6634), 1,
      anon_sym___attribute,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(7932), 1,
      anon_sym_STAR,
    ACTIONS(7934), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7936), 1,
      anon_sym_AMP,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2930), 1,
      sym_parameter_list,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(6111), 1,
      sym__abstract_declarator,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6632), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [136560] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8068), 1,
      anon_sym_STAR,
    ACTIONS(8070), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8072), 1,
      anon_sym_AMP,
    ACTIONS(8304), 1,
      sym_auto,
    ACTIONS(8306), 1,
      anon_sym_decltype,
    STATE(2931), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(4865), 1,
      sym_decltype_auto,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6371), 1,
      sym__abstract_declarator,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4407), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8048), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [136641] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5118), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5120), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [136690] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8484), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8486), 1,
      anon_sym_and,
    ACTIONS(6057), 16,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6059), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [136743] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8416), 1,
      anon_sym_LT,
    STATE(4306), 1,
      sym_template_argument_list,
    ACTIONS(4838), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(4845), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [136798] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8068), 1,
      anon_sym_STAR,
    ACTIONS(8070), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8072), 1,
      anon_sym_AMP,
    ACTIONS(8304), 1,
      sym_auto,
    ACTIONS(8306), 1,
      anon_sym_decltype,
    STATE(2931), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(4865), 1,
      sym_decltype_auto,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6331), 1,
      sym__abstract_declarator,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4403), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8083), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [136879] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8416), 1,
      anon_sym_LT,
    STATE(4306), 1,
      sym_template_argument_list,
    ACTIONS(5720), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(4059), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [136934] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5122), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5124), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [136983] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(6696), 1,
      sym_auto,
    ACTIONS(6698), 1,
      anon_sym_decltype,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8050), 1,
      anon_sym___attribute,
    ACTIONS(8056), 1,
      anon_sym_STAR,
    ACTIONS(8058), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8060), 1,
      anon_sym_AMP,
    STATE(2653), 1,
      sym_decltype_auto,
    STATE(3221), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6366), 1,
      sym__abstract_declarator,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4418), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8048), 6,
      anon_sym_COMMA,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [137066] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6255), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(6257), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [137115] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(6696), 1,
      sym_auto,
    ACTIONS(6698), 1,
      anon_sym_decltype,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8056), 1,
      anon_sym_STAR,
    ACTIONS(8058), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8060), 1,
      anon_sym_AMP,
    ACTIONS(8085), 1,
      anon_sym___attribute,
    STATE(2653), 1,
      sym_decltype_auto,
    STATE(3221), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6380), 1,
      sym__abstract_declarator,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4414), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8083), 6,
      anon_sym_COMMA,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [137198] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8020), 1,
      sym_auto,
    ACTIONS(8022), 1,
      anon_sym_decltype,
    ACTIONS(8050), 1,
      anon_sym___attribute,
    ACTIONS(8062), 1,
      anon_sym_STAR,
    ACTIONS(8064), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8066), 1,
      anon_sym_AMP,
    STATE(1837), 1,
      sym_decltype_auto,
    STATE(3249), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6347), 1,
      sym__abstract_declarator,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4426), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8048), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [137281] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8020), 1,
      sym_auto,
    ACTIONS(8022), 1,
      anon_sym_decltype,
    ACTIONS(8062), 1,
      anon_sym_STAR,
    ACTIONS(8064), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8066), 1,
      anon_sym_AMP,
    ACTIONS(8085), 1,
      anon_sym___attribute,
    STATE(1837), 1,
      sym_decltype_auto,
    STATE(3249), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6328), 1,
      sym__abstract_declarator,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4422), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8083), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [137364] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5122), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5124), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [137413] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5122), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5124), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [137462] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6335), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(6337), 36,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [137511] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4204), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(8481), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4934), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4932), 26,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [137564] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5130), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5132), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [137613] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8484), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8486), 1,
      anon_sym_and,
    ACTIONS(8488), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8490), 1,
      anon_sym_or,
    ACTIONS(6092), 15,
      aux_sym_preproc_elif_token1,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_identifier,
    ACTIONS(6094), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [137670] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4864), 1,
      anon_sym_LBRACK,
    ACTIONS(4859), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4862), 4,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
    ACTIONS(4855), 34,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym_virtual,
      anon_sym_extern,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___declspec,
      anon_sym___based,
      anon_sym_static,
      anon_sym_register,
      anon_sym_inline,
      anon_sym___inline,
      anon_sym___inline__,
      anon_sym___forceinline,
      anon_sym_thread_local,
      anon_sym___thread,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_operator,
  [137723] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8496), 1,
      anon_sym___attribute__,
    ACTIONS(8499), 1,
      anon_sym___attribute,
    STATE(4208), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(8494), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(8492), 33,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [137778] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5126), 12,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym___attribute,
      anon_sym_DOT,
    ACTIONS(5128), 29,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [137827] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6901), 16,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6903), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [137876] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(7932), 1,
      anon_sym_STAR,
    ACTIONS(7934), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7936), 1,
      anon_sym_AMP,
    ACTIONS(8302), 1,
      anon_sym___attribute,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2930), 1,
      sym_parameter_list,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(6150), 1,
      sym__abstract_declarator,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8300), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [137953] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(8502), 1,
      anon_sym_LBRACE,
    ACTIONS(8504), 1,
      anon_sym_COLON,
    STATE(4319), 1,
      sym__enum_base_clause,
    STATE(4438), 1,
      sym_enumerator_list,
    STATE(4625), 1,
      sym_attribute_specifier,
    ACTIONS(6245), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(6247), 29,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [138015] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6263), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [138085] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8514), 1,
      anon_sym_COMMA,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8532), 1,
      anon_sym_SEMI,
    ACTIONS(8534), 1,
      anon_sym_RBRACE,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    STATE(7226), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [138185] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6858), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [138279] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8358), 1,
      anon_sym_SLASH,
    ACTIONS(8364), 1,
      anon_sym_PIPE,
    ACTIONS(8368), 1,
      anon_sym_AMP,
    ACTIONS(8374), 1,
      anon_sym_GT_EQ,
    ACTIONS(8380), 1,
      anon_sym_QMARK,
    ACTIONS(8382), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8384), 1,
      anon_sym_bitor,
    ACTIONS(8386), 1,
      anon_sym_bitand,
    ACTIONS(8546), 1,
      anon_sym___attribute,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8354), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8356), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8360), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8362), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8366), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8376), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8370), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8372), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8544), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [138375] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6924), 1,
      anon_sym_const,
    STATE(3934), 1,
      sym_alignas_qualifier,
    ACTIONS(6926), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3744), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8095), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(6911), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(8093), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [138433] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6924), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(7992), 1,
      anon_sym_STAR,
    ACTIONS(7994), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7996), 1,
      anon_sym_AMP,
    STATE(2838), 1,
      sym_parameter_list,
    STATE(3934), 1,
      sym_alignas_qualifier,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(6232), 1,
      sym__abstract_declarator,
    ACTIONS(6926), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3744), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5698), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6911), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [138507] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(8502), 1,
      anon_sym_LBRACE,
    ACTIONS(8504), 1,
      anon_sym_COLON,
    STATE(4332), 1,
      sym__enum_base_clause,
    STATE(4464), 1,
      sym_enumerator_list,
    STATE(4655), 1,
      sym_attribute_specifier,
    ACTIONS(6161), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(6163), 29,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [138569] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6263), 7,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [138635] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(5521), 1,
      anon_sym_const,
    ACTIONS(5730), 1,
      anon_sym_COLON,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8334), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8548), 1,
      anon_sym_STAR,
    ACTIONS(8550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8552), 1,
      anon_sym_AMP,
    STATE(1651), 1,
      sym_alignas_qualifier,
    STATE(3356), 1,
      sym_parameter_list,
    STATE(5211), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6780), 1,
      sym__abstract_declarator,
    ACTIONS(8336), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8338), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8340), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4240), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4938), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8332), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [138719] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6924), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(7992), 1,
      anon_sym_STAR,
    ACTIONS(7994), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7996), 1,
      anon_sym_AMP,
    STATE(2838), 1,
      sym_parameter_list,
    STATE(3934), 1,
      sym_alignas_qualifier,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(6231), 1,
      sym__abstract_declarator,
    ACTIONS(6926), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3744), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8296), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6911), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [138793] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8554), 1,
      anon_sym_LT,
    STATE(1829), 1,
      sym_template_argument_list,
    STATE(1896), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4033), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(4897), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4041), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [138851] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
  [138939] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
  [139025] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(6806), 1,
      anon_sym___attribute,
    ACTIONS(8358), 1,
      anon_sym_SLASH,
    ACTIONS(8364), 1,
      anon_sym_PIPE,
    ACTIONS(8368), 1,
      anon_sym_AMP,
    ACTIONS(8374), 1,
      anon_sym_GT_EQ,
    ACTIONS(8382), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8384), 1,
      anon_sym_bitor,
    ACTIONS(8386), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8354), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8356), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8360), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8362), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8366), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8376), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8370), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8372), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6808), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
  [139117] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4941), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4939), 27,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [139165] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6463), 1,
      anon_sym_LT,
    STATE(1570), 1,
      sym_template_argument_list,
    STATE(1896), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4897), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5842), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(5844), 28,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [139223] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(6543), 1,
      anon_sym___attribute,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8358), 1,
      anon_sym_SLASH,
    ACTIONS(8364), 1,
      anon_sym_PIPE,
    ACTIONS(8368), 1,
      anon_sym_AMP,
    ACTIONS(8374), 1,
      anon_sym_GT_EQ,
    ACTIONS(8380), 1,
      anon_sym_QMARK,
    ACTIONS(8382), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8384), 1,
      anon_sym_bitor,
    ACTIONS(8386), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8354), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8356), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8360), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8362), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8366), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8376), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6545), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
    ACTIONS(8370), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8372), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [139319] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8358), 1,
      anon_sym_SLASH,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8356), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6263), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
    ACTIONS(6265), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [139385] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6263), 1,
      anon_sym___attribute,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8358), 1,
      anon_sym_SLASH,
    ACTIONS(8364), 1,
      anon_sym_PIPE,
    ACTIONS(8368), 1,
      anon_sym_AMP,
    ACTIONS(8374), 1,
      anon_sym_GT_EQ,
    ACTIONS(8382), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8384), 1,
      anon_sym_bitor,
    ACTIONS(8386), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8354), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8356), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8362), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8366), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8376), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8370), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8372), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
  [139475] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6263), 1,
      anon_sym___attribute,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8358), 1,
      anon_sym_SLASH,
    ACTIONS(8364), 1,
      anon_sym_PIPE,
    ACTIONS(8368), 1,
      anon_sym_AMP,
    ACTIONS(8374), 1,
      anon_sym_GT_EQ,
    ACTIONS(8382), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8384), 1,
      anon_sym_bitor,
    ACTIONS(8386), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8354), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8356), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8366), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8376), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8370), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8372), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
  [139563] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8358), 1,
      anon_sym_SLASH,
    ACTIONS(8364), 1,
      anon_sym_PIPE,
    ACTIONS(8368), 1,
      anon_sym_AMP,
    ACTIONS(8374), 1,
      anon_sym_GT_EQ,
    ACTIONS(8380), 1,
      anon_sym_QMARK,
    ACTIONS(8382), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8384), 1,
      anon_sym_bitor,
    ACTIONS(8386), 1,
      anon_sym_bitand,
    ACTIONS(8558), 1,
      anon_sym___attribute,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8354), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8356), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8360), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8362), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8366), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8376), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8370), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8372), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(8556), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [139659] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8358), 1,
      anon_sym_SLASH,
    ACTIONS(8368), 1,
      anon_sym_AMP,
    ACTIONS(8374), 1,
      anon_sym_GT_EQ,
    ACTIONS(8382), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8386), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6263), 2,
      anon_sym_PIPE,
      anon_sym___attribute,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8354), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8356), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8366), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8376), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8370), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8372), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
  [139743] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6846), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
  [139833] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6924), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(7992), 1,
      anon_sym_STAR,
    ACTIONS(7994), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7996), 1,
      anon_sym_AMP,
    STATE(2838), 1,
      sym_parameter_list,
    STATE(3934), 1,
      sym_alignas_qualifier,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(6214), 1,
      sym__abstract_declarator,
    ACTIONS(6926), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3744), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6632), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6911), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [139907] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(6696), 1,
      sym_auto,
    ACTIONS(6698), 1,
      anon_sym_decltype,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8175), 1,
      anon_sym_STAR,
    ACTIONS(8177), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8179), 1,
      anon_sym_AMP,
    STATE(2653), 1,
      sym_decltype_auto,
    STATE(3113), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6444), 1,
      sym__abstract_declarator,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4673), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8048), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [139987] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8358), 1,
      anon_sym_SLASH,
    ACTIONS(8368), 1,
      anon_sym_AMP,
    ACTIONS(8374), 1,
      anon_sym_GT_EQ,
    ACTIONS(8382), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8386), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6263), 2,
      anon_sym_PIPE,
      anon_sym___attribute,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8354), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8356), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8376), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8370), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8372), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
  [140069] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(6696), 1,
      sym_auto,
    ACTIONS(6698), 1,
      anon_sym_decltype,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8175), 1,
      anon_sym_STAR,
    ACTIONS(8177), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8179), 1,
      anon_sym_AMP,
    STATE(2653), 1,
      sym_decltype_auto,
    STATE(3113), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6451), 1,
      sym__abstract_declarator,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4671), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8083), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [140149] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(5521), 1,
      anon_sym_const,
    ACTIONS(5698), 1,
      anon_sym_COLON,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8334), 1,
      sym_ms_restrict_modifier,
    ACTIONS(8548), 1,
      anon_sym_STAR,
    ACTIONS(8550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8552), 1,
      anon_sym_AMP,
    STATE(1651), 1,
      sym_alignas_qualifier,
    STATE(3356), 1,
      sym_parameter_list,
    STATE(5211), 1,
      sym_ms_unaligned_ptr_modifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6779), 1,
      sym__abstract_declarator,
    ACTIONS(8336), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(8338), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    ACTIONS(8340), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4923), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    STATE(4935), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8332), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [140233] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8358), 1,
      anon_sym_SLASH,
    ACTIONS(8374), 1,
      anon_sym_GT_EQ,
    ACTIONS(8382), 1,
      anon_sym_LT_EQ_GT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8354), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8356), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8376), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6263), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym___attribute,
    ACTIONS(8372), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [140309] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6808), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
  [140399] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8358), 1,
      anon_sym_SLASH,
    ACTIONS(8382), 1,
      anon_sym_LT_EQ_GT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8354), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8356), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8376), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6263), 6,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
    ACTIONS(6265), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [140471] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8358), 1,
      anon_sym_SLASH,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8354), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8356), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6263), 6,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
    ACTIONS(6265), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [140539] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8358), 1,
      anon_sym_SLASH,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8354), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8356), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8376), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6263), 6,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute,
    ACTIONS(6265), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [140609] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6924), 1,
      anon_sym_const,
    STATE(3934), 1,
      sym_alignas_qualifier,
    ACTIONS(6926), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3744), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8428), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(6911), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
    ACTIONS(8426), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [140667] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6870), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
  [140757] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6850), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [140851] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(6868), 1,
      anon_sym___attribute,
    ACTIONS(8358), 1,
      anon_sym_SLASH,
    ACTIONS(8364), 1,
      anon_sym_PIPE,
    ACTIONS(8368), 1,
      anon_sym_AMP,
    ACTIONS(8374), 1,
      anon_sym_GT_EQ,
    ACTIONS(8382), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8384), 1,
      anon_sym_bitor,
    ACTIONS(8386), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8354), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8356), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8360), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8362), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8366), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8376), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8370), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8372), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6870), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
  [140943] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(6872), 1,
      anon_sym___attribute,
    ACTIONS(8358), 1,
      anon_sym_SLASH,
    ACTIONS(8364), 1,
      anon_sym_PIPE,
    ACTIONS(8368), 1,
      anon_sym_AMP,
    ACTIONS(8374), 1,
      anon_sym_GT_EQ,
    ACTIONS(8382), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8384), 1,
      anon_sym_bitor,
    ACTIONS(8386), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8354), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8356), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8360), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8362), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8366), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8376), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8370), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8372), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6874), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
  [141035] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(6844), 1,
      anon_sym___attribute,
    ACTIONS(8358), 1,
      anon_sym_SLASH,
    ACTIONS(8364), 1,
      anon_sym_PIPE,
    ACTIONS(8368), 1,
      anon_sym_AMP,
    ACTIONS(8374), 1,
      anon_sym_GT_EQ,
    ACTIONS(8382), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8384), 1,
      anon_sym_bitor,
    ACTIONS(8386), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8354), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8356), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8360), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8362), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8366), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8376), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8370), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8372), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6846), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
  [141127] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(6848), 1,
      anon_sym___attribute,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8358), 1,
      anon_sym_SLASH,
    ACTIONS(8364), 1,
      anon_sym_PIPE,
    ACTIONS(8368), 1,
      anon_sym_AMP,
    ACTIONS(8374), 1,
      anon_sym_GT_EQ,
    ACTIONS(8380), 1,
      anon_sym_QMARK,
    ACTIONS(8382), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8384), 1,
      anon_sym_bitor,
    ACTIONS(8386), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8354), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8356), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8360), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8362), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8366), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8376), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6850), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
    ACTIONS(8370), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8372), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [141223] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6854), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
  [141313] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2526), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2536), 30,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [141361] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(6852), 1,
      anon_sym___attribute,
    ACTIONS(8358), 1,
      anon_sym_SLASH,
    ACTIONS(8364), 1,
      anon_sym_PIPE,
    ACTIONS(8368), 1,
      anon_sym_AMP,
    ACTIONS(8374), 1,
      anon_sym_GT_EQ,
    ACTIONS(8382), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8384), 1,
      anon_sym_bitor,
    ACTIONS(8386), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8354), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8356), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8360), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8362), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8366), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8376), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8370), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8372), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6854), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
  [141453] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6263), 1,
      anon_sym_PIPE,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
  [141537] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7966), 1,
      anon_sym_STAR,
    ACTIONS(7968), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7970), 1,
      anon_sym_AMP,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8302), 1,
      anon_sym___attribute,
    STATE(3006), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6218), 1,
      sym__abstract_declarator,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8300), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [141613] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(5706), 1,
      anon_sym___attribute,
    ACTIONS(7966), 1,
      anon_sym_STAR,
    ACTIONS(7968), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7970), 1,
      anon_sym_AMP,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    STATE(3006), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6258), 1,
      sym__abstract_declarator,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5698), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [141689] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7966), 1,
      anon_sym_STAR,
    ACTIONS(7968), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7970), 1,
      anon_sym_AMP,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8298), 1,
      anon_sym___attribute,
    STATE(3006), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6261), 1,
      sym__abstract_declarator,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8296), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [141765] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(6634), 1,
      anon_sym___attribute,
    ACTIONS(7966), 1,
      anon_sym_STAR,
    ACTIONS(7968), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7970), 1,
      anon_sym_AMP,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    STATE(3006), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6219), 1,
      sym__abstract_declarator,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6632), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [141841] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6874), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
  [141931] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4941), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(4939), 30,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [141979] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6263), 1,
      anon_sym_PIPE,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
  [142061] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(6856), 1,
      anon_sym___attribute,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8358), 1,
      anon_sym_SLASH,
    ACTIONS(8364), 1,
      anon_sym_PIPE,
    ACTIONS(8368), 1,
      anon_sym_AMP,
    ACTIONS(8374), 1,
      anon_sym_GT_EQ,
    ACTIONS(8380), 1,
      anon_sym_QMARK,
    ACTIONS(8382), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8384), 1,
      anon_sym_bitor,
    ACTIONS(8386), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8354), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8356), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8360), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8362), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8366), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8376), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6858), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
    ACTIONS(8370), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8372), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [142157] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6263), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 14,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
  [142235] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2526), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
    ACTIONS(2536), 27,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_operator,
      anon_sym_try,
      anon_sym_requires,
  [142283] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6924), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(7992), 1,
      anon_sym_STAR,
    ACTIONS(7994), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7996), 1,
      anon_sym_AMP,
    STATE(2838), 1,
      sym_parameter_list,
    STATE(3934), 1,
      sym_alignas_qualifier,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(6212), 1,
      sym__abstract_declarator,
    ACTIONS(6926), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3744), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8300), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(6911), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [142357] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(8052), 1,
      sym_auto,
    ACTIONS(8054), 1,
      anon_sym_decltype,
    ACTIONS(8145), 1,
      anon_sym_STAR,
    ACTIONS(8147), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8149), 1,
      anon_sym_AMP,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2454), 1,
      sym_decltype_auto,
    STATE(3191), 1,
      sym_parameter_list,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(6460), 1,
      sym__abstract_declarator,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4707), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8083), 6,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [142437] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(8052), 1,
      sym_auto,
    ACTIONS(8054), 1,
      anon_sym_decltype,
    ACTIONS(8145), 1,
      anon_sym_STAR,
    ACTIONS(8147), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8149), 1,
      anon_sym_AMP,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2454), 1,
      sym_decltype_auto,
    STATE(3191), 1,
      sym_parameter_list,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(6465), 1,
      sym__abstract_declarator,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4709), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8048), 6,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [142517] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6545), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [142611] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6263), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [142687] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6263), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [142759] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6263), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [142827] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5618), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5620), 35,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [142875] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8358), 1,
      anon_sym_SLASH,
    ACTIONS(8374), 1,
      anon_sym_GT_EQ,
    ACTIONS(8382), 1,
      anon_sym_LT_EQ_GT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8354), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8356), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8376), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6263), 3,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym___attribute,
    ACTIONS(8370), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8372), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
  [142953] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8560), 1,
      anon_sym_COMMA,
    ACTIONS(8562), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    STATE(7075), 1,
      aux_sym_generic_expression_repeat1,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [143050] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8564), 1,
      anon_sym_COMMA,
    ACTIONS(8566), 1,
      anon_sym_RBRACE,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    STATE(7285), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [143147] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    ACTIONS(8568), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(8576), 1,
      anon_sym_SLASH,
    ACTIONS(8582), 1,
      anon_sym_PIPE,
    ACTIONS(8586), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_LT_LT,
    ACTIONS(8594), 1,
      anon_sym_GT_GT,
    ACTIONS(8596), 1,
      anon_sym_QMARK,
    ACTIONS(8598), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8600), 1,
      anon_sym_bitor,
    ACTIONS(8602), 1,
      anon_sym_bitand,
    ACTIONS(8606), 1,
      anon_sym_GT2,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    STATE(7350), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8578), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8580), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8584), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8604), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8588), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8590), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [143244] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6901), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6903), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [143291] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8608), 1,
      anon_sym_COMMA,
    ACTIONS(8610), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    STATE(7069), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [143388] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8612), 1,
      anon_sym_COMMA,
    ACTIONS(8614), 1,
      anon_sym_RBRACE,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    STATE(7072), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [143485] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    ACTIONS(8568), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(8576), 1,
      anon_sym_SLASH,
    ACTIONS(8582), 1,
      anon_sym_PIPE,
    ACTIONS(8586), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_LT_LT,
    ACTIONS(8594), 1,
      anon_sym_GT_GT,
    ACTIONS(8596), 1,
      anon_sym_QMARK,
    ACTIONS(8598), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8600), 1,
      anon_sym_bitor,
    ACTIONS(8602), 1,
      anon_sym_bitand,
    ACTIONS(8616), 1,
      anon_sym_GT2,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    STATE(7080), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8578), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8580), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8584), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8604), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8588), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8590), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [143582] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3730), 1,
      anon_sym_LBRACE,
    ACTIONS(8280), 1,
      anon_sym_LPAREN2,
    STATE(4771), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6079), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6081), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [143635] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5470), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(5472), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [143682] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1167), 1,
      sym__fold_operator,
    ACTIONS(8620), 13,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ,
    ACTIONS(8618), 25,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT_STAR,
  [143731] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8560), 1,
      anon_sym_COMMA,
    ACTIONS(8622), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    STATE(7100), 1,
      aux_sym_generic_expression_repeat1,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [143828] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4810), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(4812), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [143875] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4826), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(4828), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [143922] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4818), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(4820), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [143969] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4822), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(4824), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [144016] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4814), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(4816), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [144063] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4830), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(4832), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [144110] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8608), 1,
      anon_sym_COMMA,
    ACTIONS(8624), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    STATE(7197), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [144207] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8626), 1,
      anon_sym_COMMA,
    ACTIONS(8628), 1,
      anon_sym_RBRACE,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    STATE(7198), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [144304] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    ACTIONS(8568), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(8576), 1,
      anon_sym_SLASH,
    ACTIONS(8582), 1,
      anon_sym_PIPE,
    ACTIONS(8586), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_LT_LT,
    ACTIONS(8594), 1,
      anon_sym_GT_GT,
    ACTIONS(8596), 1,
      anon_sym_QMARK,
    ACTIONS(8598), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8600), 1,
      anon_sym_bitor,
    ACTIONS(8602), 1,
      anon_sym_bitand,
    ACTIONS(8630), 1,
      anon_sym_GT2,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    STATE(7207), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8578), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8580), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8584), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8604), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8588), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8590), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [144401] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8560), 1,
      anon_sym_COMMA,
    ACTIONS(8632), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    STATE(7228), 1,
      aux_sym_generic_expression_repeat1,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [144498] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4834), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(4836), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [144545] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5383), 1,
      anon_sym_COLON,
    ACTIONS(8634), 1,
      anon_sym___attribute__,
    ACTIONS(8636), 1,
      anon_sym___attribute,
    ACTIONS(8638), 1,
      anon_sym_LBRACE,
    STATE(4822), 1,
      sym_field_declaration_list,
    STATE(4869), 1,
      sym_attribute_specifier,
    STATE(6833), 1,
      sym_virtual_specifier,
    STATE(7663), 1,
      sym_base_class_clause,
    ACTIONS(5375), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5377), 27,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [144610] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8640), 1,
      anon_sym_COMMA,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    ACTIONS(8652), 1,
      anon_sym_PIPE,
    ACTIONS(8656), 1,
      anon_sym_AMP,
    ACTIONS(8662), 1,
      anon_sym_GT_EQ,
    ACTIONS(8666), 1,
      anon_sym_RBRACK,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8672), 1,
      anon_sym_bitor,
    ACTIONS(8674), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    STATE(7379), 1,
      aux_sym_subscript_argument_list_repeat1,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8648), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8650), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8654), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8658), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8660), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [144707] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8676), 1,
      anon_sym_COMMA,
    ACTIONS(8679), 1,
      anon_sym_SEMI,
    ACTIONS(8681), 1,
      anon_sym_RBRACE,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [144804] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8608), 1,
      anon_sym_COMMA,
    ACTIONS(8683), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    STATE(7322), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [144901] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8685), 1,
      anon_sym_COMMA,
    ACTIONS(8687), 1,
      anon_sym_RBRACE,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    STATE(7323), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [144998] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(7565), 1,
      anon_sym_COMMA,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8679), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [145093] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    ACTIONS(8568), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(8576), 1,
      anon_sym_SLASH,
    ACTIONS(8582), 1,
      anon_sym_PIPE,
    ACTIONS(8586), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_LT_LT,
    ACTIONS(8594), 1,
      anon_sym_GT_GT,
    ACTIONS(8596), 1,
      anon_sym_QMARK,
    ACTIONS(8598), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8600), 1,
      anon_sym_bitor,
    ACTIONS(8602), 1,
      anon_sym_bitand,
    ACTIONS(8689), 1,
      anon_sym_GT2,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    STATE(7326), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8578), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8580), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8584), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8604), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8588), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8590), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [145190] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8560), 1,
      anon_sym_COMMA,
    ACTIONS(8691), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    STATE(7349), 1,
      aux_sym_generic_expression_repeat1,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [145287] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4855), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(4862), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [145334] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1628), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4932), 2,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(5231), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4981), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(4984), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [145387] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6463), 1,
      anon_sym_LT,
    STATE(1570), 1,
      sym_template_argument_list,
    STATE(2267), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5842), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(4919), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5844), 28,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [145444] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8608), 1,
      anon_sym_COMMA,
    ACTIONS(8693), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    STATE(7299), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [145541] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    ACTIONS(8568), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(8576), 1,
      anon_sym_SLASH,
    ACTIONS(8582), 1,
      anon_sym_PIPE,
    ACTIONS(8586), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_LT_LT,
    ACTIONS(8594), 1,
      anon_sym_GT_GT,
    ACTIONS(8596), 1,
      anon_sym_QMARK,
    ACTIONS(8598), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8600), 1,
      anon_sym_bitor,
    ACTIONS(8602), 1,
      anon_sym_bitand,
    ACTIONS(8695), 1,
      anon_sym_GT2,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    STATE(7053), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8578), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8580), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8584), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8604), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8588), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8590), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [145638] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8697), 1,
      anon_sym___attribute__,
    ACTIONS(8700), 1,
      anon_sym___attribute,
    STATE(4311), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(8494), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(8492), 31,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [145691] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8705), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8703), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [145786] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_STAR,
    ACTIONS(8000), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8002), 1,
      anon_sym_AMP,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2982), 1,
      sym_parameter_list,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(6295), 1,
      sym__abstract_declarator,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6632), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [145859] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8608), 1,
      anon_sym_COMMA,
    ACTIONS(8707), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    STATE(7128), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [145956] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    ACTIONS(8568), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(8576), 1,
      anon_sym_SLASH,
    ACTIONS(8582), 1,
      anon_sym_PIPE,
    ACTIONS(8586), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_LT_LT,
    ACTIONS(8594), 1,
      anon_sym_GT_GT,
    ACTIONS(8596), 1,
      anon_sym_QMARK,
    ACTIONS(8598), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8600), 1,
      anon_sym_bitor,
    ACTIONS(8602), 1,
      anon_sym_bitand,
    ACTIONS(8709), 1,
      anon_sym_GT2,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    STATE(7181), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8578), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8580), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8584), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8604), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8588), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8590), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [146053] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    ACTIONS(8568), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(8576), 1,
      anon_sym_SLASH,
    ACTIONS(8582), 1,
      anon_sym_PIPE,
    ACTIONS(8586), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_LT_LT,
    ACTIONS(8594), 1,
      anon_sym_GT_GT,
    ACTIONS(8596), 1,
      anon_sym_QMARK,
    ACTIONS(8598), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8600), 1,
      anon_sym_bitor,
    ACTIONS(8602), 1,
      anon_sym_bitand,
    ACTIONS(8711), 1,
      anon_sym_GT2,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    STATE(7398), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8578), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8580), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8584), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8604), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8588), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8590), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [146150] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8560), 1,
      anon_sym_COMMA,
    ACTIONS(8713), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    STATE(7059), 1,
      aux_sym_generic_expression_repeat1,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [146247] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    ACTIONS(8568), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(8576), 1,
      anon_sym_SLASH,
    ACTIONS(8582), 1,
      anon_sym_PIPE,
    ACTIONS(8586), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_LT_LT,
    ACTIONS(8594), 1,
      anon_sym_GT_GT,
    ACTIONS(8596), 1,
      anon_sym_QMARK,
    ACTIONS(8598), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8600), 1,
      anon_sym_bitor,
    ACTIONS(8602), 1,
      anon_sym_bitand,
    ACTIONS(8715), 1,
      anon_sym_GT2,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    STATE(7101), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8578), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8580), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8584), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8604), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8588), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8590), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [146344] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(8502), 1,
      anon_sym_LBRACE,
    STATE(4465), 1,
      sym_enumerator_list,
    STATE(4660), 1,
      sym_attribute_specifier,
    ACTIONS(5834), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5836), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [146401] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8532), 1,
      anon_sym_SEMI,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8717), 1,
      anon_sym_COMMA,
    ACTIONS(8720), 1,
      anon_sym_RBRACE,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [146498] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    ACTIONS(8568), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(8576), 1,
      anon_sym_SLASH,
    ACTIONS(8582), 1,
      anon_sym_PIPE,
    ACTIONS(8586), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_LT_LT,
    ACTIONS(8594), 1,
      anon_sym_GT_GT,
    ACTIONS(8596), 1,
      anon_sym_QMARK,
    ACTIONS(8598), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8600), 1,
      anon_sym_bitor,
    ACTIONS(8602), 1,
      anon_sym_bitand,
    ACTIONS(8722), 1,
      anon_sym_GT2,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    STATE(7168), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8578), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8580), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8584), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8604), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8588), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8590), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [146595] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    ACTIONS(8568), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(8576), 1,
      anon_sym_SLASH,
    ACTIONS(8582), 1,
      anon_sym_PIPE,
    ACTIONS(8586), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_LT_LT,
    ACTIONS(8594), 1,
      anon_sym_GT_GT,
    ACTIONS(8596), 1,
      anon_sym_QMARK,
    ACTIONS(8598), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8600), 1,
      anon_sym_bitor,
    ACTIONS(8602), 1,
      anon_sym_bitand,
    ACTIONS(8724), 1,
      anon_sym_GT2,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    STATE(7211), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8578), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8580), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8584), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8604), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8588), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8590), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [146692] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    ACTIONS(8568), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(8576), 1,
      anon_sym_SLASH,
    ACTIONS(8582), 1,
      anon_sym_PIPE,
    ACTIONS(8586), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_LT_LT,
    ACTIONS(8594), 1,
      anon_sym_GT_GT,
    ACTIONS(8596), 1,
      anon_sym_QMARK,
    ACTIONS(8598), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8600), 1,
      anon_sym_bitor,
    ACTIONS(8602), 1,
      anon_sym_bitand,
    ACTIONS(8726), 1,
      anon_sym_GT2,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    STATE(7245), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8578), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8580), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8584), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8604), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8588), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8590), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [146789] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    ACTIONS(8568), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(8576), 1,
      anon_sym_SLASH,
    ACTIONS(8582), 1,
      anon_sym_PIPE,
    ACTIONS(8586), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_LT_LT,
    ACTIONS(8594), 1,
      anon_sym_GT_GT,
    ACTIONS(8596), 1,
      anon_sym_QMARK,
    ACTIONS(8598), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8600), 1,
      anon_sym_bitor,
    ACTIONS(8602), 1,
      anon_sym_bitand,
    ACTIONS(8728), 1,
      anon_sym_GT2,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    STATE(7269), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8578), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8580), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8584), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8604), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8588), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8590), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [146886] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    ACTIONS(8568), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(8576), 1,
      anon_sym_SLASH,
    ACTIONS(8582), 1,
      anon_sym_PIPE,
    ACTIONS(8586), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_LT_LT,
    ACTIONS(8594), 1,
      anon_sym_GT_GT,
    ACTIONS(8596), 1,
      anon_sym_QMARK,
    ACTIONS(8598), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8600), 1,
      anon_sym_bitor,
    ACTIONS(8602), 1,
      anon_sym_bitand,
    ACTIONS(8730), 1,
      anon_sym_GT2,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    STATE(7307), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8578), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8580), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8584), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8604), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8588), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8590), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [146983] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    ACTIONS(8568), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(8576), 1,
      anon_sym_SLASH,
    ACTIONS(8582), 1,
      anon_sym_PIPE,
    ACTIONS(8586), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_LT_LT,
    ACTIONS(8594), 1,
      anon_sym_GT_GT,
    ACTIONS(8596), 1,
      anon_sym_QMARK,
    ACTIONS(8598), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8600), 1,
      anon_sym_bitor,
    ACTIONS(8602), 1,
      anon_sym_bitand,
    ACTIONS(8732), 1,
      anon_sym_GT2,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    STATE(7356), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8578), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8580), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8584), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8604), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8588), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8590), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [147080] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5365), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5443), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(5445), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [147129] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3730), 1,
      anon_sym_LBRACE,
    ACTIONS(8280), 1,
      anon_sym_LPAREN2,
    STATE(4738), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6088), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6090), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [147182] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4333), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5431), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(8734), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5433), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [147233] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    ACTIONS(8568), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(8576), 1,
      anon_sym_SLASH,
    ACTIONS(8582), 1,
      anon_sym_PIPE,
    ACTIONS(8586), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_LT_LT,
    ACTIONS(8594), 1,
      anon_sym_GT_GT,
    ACTIONS(8596), 1,
      anon_sym_QMARK,
    ACTIONS(8598), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8600), 1,
      anon_sym_bitor,
    ACTIONS(8602), 1,
      anon_sym_bitand,
    ACTIONS(8736), 1,
      anon_sym_GT2,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    STATE(7040), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8578), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8580), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8584), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8604), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8588), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8590), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [147330] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8534), 1,
      anon_sym_RBRACE,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8738), 1,
      anon_sym_COMMA,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    STATE(7226), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [147427] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(8502), 1,
      anon_sym_LBRACE,
    STATE(4479), 1,
      sym_enumerator_list,
    STATE(4684), 1,
      sym_attribute_specifier,
    ACTIONS(5848), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5850), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [147484] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4204), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5768), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(8740), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5766), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [147535] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5365), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5361), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(5363), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [147584] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4204), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5791), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(8740), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5789), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [147635] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4338), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5803), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(8742), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5801), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [147686] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4340), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5746), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(8744), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5744), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [147737] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4204), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5795), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(8740), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5793), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [147788] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8640), 1,
      anon_sym_COMMA,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    ACTIONS(8652), 1,
      anon_sym_PIPE,
    ACTIONS(8656), 1,
      anon_sym_AMP,
    ACTIONS(8662), 1,
      anon_sym_GT_EQ,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8672), 1,
      anon_sym_bitor,
    ACTIONS(8674), 1,
      anon_sym_bitand,
    ACTIONS(8746), 1,
      anon_sym_RBRACK,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    STATE(7044), 1,
      aux_sym_subscript_argument_list_repeat1,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8648), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8650), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8654), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8658), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8660), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [147885] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4204), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5782), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(8740), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5780), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [147936] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8608), 1,
      anon_sym_COMMA,
    ACTIONS(8748), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    STATE(7383), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [148033] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8750), 1,
      anon_sym_COMMA,
    ACTIONS(8752), 1,
      anon_sym_RBRACE,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    STATE(7395), 1,
      aux_sym_initializer_list_repeat1,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [148130] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4356), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5740), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(8754), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5738), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [148181] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    ACTIONS(8568), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(8576), 1,
      anon_sym_SLASH,
    ACTIONS(8582), 1,
      anon_sym_PIPE,
    ACTIONS(8586), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_LT_LT,
    ACTIONS(8594), 1,
      anon_sym_GT_GT,
    ACTIONS(8596), 1,
      anon_sym_QMARK,
    ACTIONS(8598), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8600), 1,
      anon_sym_bitor,
    ACTIONS(8602), 1,
      anon_sym_bitand,
    ACTIONS(8756), 1,
      anon_sym_GT2,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    STATE(7410), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8578), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8580), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8584), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8604), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8588), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8590), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [148278] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6899), 1,
      sym_literal_suffix,
    ACTIONS(4043), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(4035), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [148327] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3730), 1,
      anon_sym_LBRACE,
    ACTIONS(8280), 1,
      anon_sym_LPAREN2,
    STATE(4758), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6053), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6055), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [148380] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_STAR,
    ACTIONS(8000), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8002), 1,
      anon_sym_AMP,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2982), 1,
      sym_parameter_list,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(6301), 1,
      sym__abstract_declarator,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8300), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [148453] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8640), 1,
      anon_sym_COMMA,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    ACTIONS(8652), 1,
      anon_sym_PIPE,
    ACTIONS(8656), 1,
      anon_sym_AMP,
    ACTIONS(8662), 1,
      anon_sym_GT_EQ,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8672), 1,
      anon_sym_bitor,
    ACTIONS(8674), 1,
      anon_sym_bitand,
    ACTIONS(8758), 1,
      anon_sym_RBRACK,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    STATE(7316), 1,
      aux_sym_subscript_argument_list_repeat1,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8648), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8650), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8654), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8658), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8660), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [148550] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(7565), 1,
      anon_sym_COMMA,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8760), 1,
      anon_sym_RPAREN,
    ACTIONS(8762), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [148647] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4358), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5762), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(8764), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5760), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [148698] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6924), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(8087), 1,
      sym_auto,
    ACTIONS(8089), 1,
      anon_sym_decltype,
    ACTIONS(8204), 1,
      anon_sym_STAR,
    ACTIONS(8206), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8208), 1,
      anon_sym_AMP,
    STATE(3434), 1,
      sym_parameter_list,
    STATE(3934), 1,
      sym_alignas_qualifier,
    STATE(4610), 1,
      sym_decltype_auto,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(6512), 1,
      sym__abstract_declarator,
    ACTIONS(6926), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4781), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8083), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6911), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [148777] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6924), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(8087), 1,
      sym_auto,
    ACTIONS(8089), 1,
      anon_sym_decltype,
    ACTIONS(8204), 1,
      anon_sym_STAR,
    ACTIONS(8206), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8208), 1,
      anon_sym_AMP,
    STATE(3434), 1,
      sym_parameter_list,
    STATE(3934), 1,
      sym_alignas_qualifier,
    STATE(4610), 1,
      sym_decltype_auto,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(6481), 1,
      sym__abstract_declarator,
    ACTIONS(6926), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4783), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8048), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6911), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [148856] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4204), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5778), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(8740), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5776), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [148907] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4333), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5545), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(8734), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5547), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [148958] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8560), 1,
      anon_sym_COMMA,
    ACTIONS(8766), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    STATE(7231), 1,
      aux_sym_generic_expression_repeat1,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [149055] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4204), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5752), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(8740), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5750), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [149106] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_STAR,
    ACTIONS(8000), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8002), 1,
      anon_sym_AMP,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2982), 1,
      sym_parameter_list,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(6278), 1,
      sym__abstract_declarator,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5698), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [149179] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4204), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5758), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(8740), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5756), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [149230] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5365), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5361), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(5363), 34,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [149279] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_STAR,
    ACTIONS(8000), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8002), 1,
      anon_sym_AMP,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2982), 1,
      sym_parameter_list,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(6319), 1,
      sym__abstract_declarator,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8296), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [149352] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3730), 1,
      anon_sym_LBRACE,
    ACTIONS(8280), 1,
      anon_sym_LPAREN2,
    STATE(4734), 2,
      sym_argument_list,
      sym_initializer_list,
    ACTIONS(6145), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6147), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [149405] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8608), 1,
      anon_sym_COMMA,
    ACTIONS(8768), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    STATE(7276), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [149502] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    ACTIONS(8568), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(8576), 1,
      anon_sym_SLASH,
    ACTIONS(8582), 1,
      anon_sym_PIPE,
    ACTIONS(8586), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_LT_LT,
    ACTIONS(8594), 1,
      anon_sym_GT_GT,
    ACTIONS(8596), 1,
      anon_sym_QMARK,
    ACTIONS(8598), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8600), 1,
      anon_sym_bitor,
    ACTIONS(8602), 1,
      anon_sym_bitand,
    ACTIONS(8770), 1,
      anon_sym_GT2,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    STATE(7139), 1,
      aux_sym_template_argument_list_repeat1,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8578), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8580), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8584), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8604), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8588), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8590), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [149599] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    ACTIONS(8652), 1,
      anon_sym_PIPE,
    ACTIONS(8656), 1,
      anon_sym_AMP,
    ACTIONS(8662), 1,
      anon_sym_GT_EQ,
    ACTIONS(8670), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8672), 1,
      anon_sym_bitor,
    ACTIONS(8674), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8648), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8650), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8654), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8658), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8660), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6808), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [149687] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    ACTIONS(8576), 1,
      anon_sym_SLASH,
    ACTIONS(8582), 1,
      anon_sym_PIPE,
    ACTIONS(8586), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_LT_LT,
    ACTIONS(8594), 1,
      anon_sym_GT_GT,
    ACTIONS(8598), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8600), 1,
      anon_sym_bitor,
    ACTIONS(8602), 1,
      anon_sym_bitand,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8578), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8580), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8584), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8604), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8588), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6874), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_GT2,
    ACTIONS(8590), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [149775] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8604), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6281), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(6283), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [149835] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6277), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(6279), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_GT2,
  [149893] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(7565), 1,
      anon_sym_COMMA,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8772), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [149987] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(7565), 1,
      anon_sym_COMMA,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8774), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [150081] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4862), 2,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
    ACTIONS(4864), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4857), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [150129] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8776), 1,
      anon_sym_COMMA,
    ACTIONS(8782), 1,
      anon_sym_SLASH,
    ACTIONS(8788), 1,
      anon_sym_PIPE,
    ACTIONS(8792), 1,
      anon_sym_AMP,
    ACTIONS(8798), 1,
      anon_sym_GT_EQ,
    ACTIONS(8802), 1,
      anon_sym_COLON,
    ACTIONS(8804), 1,
      anon_sym_QMARK,
    ACTIONS(8806), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8808), 1,
      anon_sym_bitor,
    ACTIONS(8810), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8780), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8784), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8786), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8790), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8800), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8794), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8796), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [150223] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    ACTIONS(8576), 1,
      anon_sym_SLASH,
    ACTIONS(8582), 1,
      anon_sym_PIPE,
    ACTIONS(8586), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_LT_LT,
    ACTIONS(8594), 1,
      anon_sym_GT_GT,
    ACTIONS(8598), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8600), 1,
      anon_sym_bitor,
    ACTIONS(8602), 1,
      anon_sym_bitand,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8578), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8580), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8584), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8604), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8588), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6846), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_GT2,
    ACTIONS(8590), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [150311] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(7565), 1,
      anon_sym_COMMA,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8812), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [150405] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(7565), 1,
      anon_sym_COMMA,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8814), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [150499] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8554), 1,
      anon_sym_LT,
    STATE(1829), 1,
      sym_template_argument_list,
    ACTIONS(4838), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(4845), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [150551] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(7565), 1,
      anon_sym_COMMA,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8532), 1,
      anon_sym_SEMI,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [150645] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    ACTIONS(8568), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8576), 1,
      anon_sym_SLASH,
    ACTIONS(8582), 1,
      anon_sym_PIPE,
    ACTIONS(8586), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_LT_LT,
    ACTIONS(8594), 1,
      anon_sym_GT_GT,
    ACTIONS(8596), 1,
      anon_sym_QMARK,
    ACTIONS(8598), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8600), 1,
      anon_sym_bitor,
    ACTIONS(8602), 1,
      anon_sym_bitand,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(6850), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8578), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8580), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8584), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8604), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8588), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8590), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [150737] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(7565), 1,
      anon_sym_COMMA,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8816), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [150831] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    ACTIONS(8576), 1,
      anon_sym_SLASH,
    ACTIONS(8582), 1,
      anon_sym_PIPE,
    ACTIONS(8586), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_LT_LT,
    ACTIONS(8594), 1,
      anon_sym_GT_GT,
    ACTIONS(8598), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8600), 1,
      anon_sym_bitor,
    ACTIONS(8602), 1,
      anon_sym_bitand,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8578), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8580), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8584), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8604), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8588), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6854), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_GT2,
    ACTIONS(8590), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [150919] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8776), 1,
      anon_sym_COMMA,
    ACTIONS(8782), 1,
      anon_sym_SLASH,
    ACTIONS(8788), 1,
      anon_sym_PIPE,
    ACTIONS(8792), 1,
      anon_sym_AMP,
    ACTIONS(8798), 1,
      anon_sym_GT_EQ,
    ACTIONS(8804), 1,
      anon_sym_QMARK,
    ACTIONS(8806), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8808), 1,
      anon_sym_bitor,
    ACTIONS(8810), 1,
      anon_sym_bitand,
    ACTIONS(8818), 1,
      anon_sym_COLON,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8780), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8784), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8786), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8790), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8800), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8794), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8796), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [151013] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8282), 1,
      anon_sym_LBRACK,
    STATE(4705), 1,
      sym_new_declarator,
    ACTIONS(6192), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6194), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [151063] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    ACTIONS(8568), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8576), 1,
      anon_sym_SLASH,
    ACTIONS(8582), 1,
      anon_sym_PIPE,
    ACTIONS(8586), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_LT_LT,
    ACTIONS(8594), 1,
      anon_sym_GT_GT,
    ACTIONS(8596), 1,
      anon_sym_QMARK,
    ACTIONS(8598), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8600), 1,
      anon_sym_bitor,
    ACTIONS(8602), 1,
      anon_sym_bitand,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(6858), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8578), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8580), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8584), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8604), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8588), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8590), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [151155] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    ACTIONS(8568), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8576), 1,
      anon_sym_SLASH,
    ACTIONS(8582), 1,
      anon_sym_PIPE,
    ACTIONS(8586), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_LT_LT,
    ACTIONS(8594), 1,
      anon_sym_GT_GT,
    ACTIONS(8596), 1,
      anon_sym_QMARK,
    ACTIONS(8598), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8600), 1,
      anon_sym_bitor,
    ACTIONS(8602), 1,
      anon_sym_bitand,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8578), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8580), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8584), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8604), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8820), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(8588), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8590), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [151247] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(5521), 1,
      anon_sym_const,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8020), 1,
      sym_auto,
    ACTIONS(8022), 1,
      anon_sym_decltype,
    ACTIONS(8326), 1,
      anon_sym_STAR,
    ACTIONS(8328), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8330), 1,
      anon_sym_AMP,
    STATE(1651), 1,
      sym_alignas_qualifier,
    STATE(1837), 1,
      sym_decltype_auto,
    STATE(3373), 1,
      sym_parameter_list,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6566), 1,
      sym__abstract_declarator,
    ACTIONS(8340), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4835), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8048), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8332), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [151325] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8822), 1,
      anon_sym_LT,
    STATE(2495), 1,
      sym_template_argument_list,
    ACTIONS(4838), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(4845), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [151377] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    ACTIONS(8652), 1,
      anon_sym_PIPE,
    ACTIONS(8656), 1,
      anon_sym_AMP,
    ACTIONS(8662), 1,
      anon_sym_GT_EQ,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8672), 1,
      anon_sym_bitor,
    ACTIONS(8674), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8648), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8650), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8654), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8824), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(8658), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8660), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [151469] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(7565), 1,
      anon_sym_COMMA,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8826), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [151563] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(7565), 1,
      anon_sym_COMMA,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8828), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [151657] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8074), 1,
      anon_sym_STAR,
    ACTIONS(8076), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8078), 1,
      anon_sym_AMP,
    STATE(2998), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6348), 1,
      sym__abstract_declarator,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8300), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [151729] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8776), 1,
      anon_sym_COMMA,
    ACTIONS(8782), 1,
      anon_sym_SLASH,
    ACTIONS(8788), 1,
      anon_sym_PIPE,
    ACTIONS(8792), 1,
      anon_sym_AMP,
    ACTIONS(8798), 1,
      anon_sym_GT_EQ,
    ACTIONS(8804), 1,
      anon_sym_QMARK,
    ACTIONS(8806), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8808), 1,
      anon_sym_bitor,
    ACTIONS(8810), 1,
      anon_sym_bitand,
    ACTIONS(8830), 1,
      anon_sym_COLON,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8780), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8784), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8786), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8790), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8800), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8794), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8796), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [151823] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8074), 1,
      anon_sym_STAR,
    ACTIONS(8076), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8078), 1,
      anon_sym_AMP,
    STATE(2998), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6431), 1,
      sym__abstract_declarator,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5698), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [151895] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8074), 1,
      anon_sym_STAR,
    ACTIONS(8076), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8078), 1,
      anon_sym_AMP,
    STATE(2998), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6399), 1,
      sym__abstract_declarator,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8296), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [151967] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8074), 1,
      anon_sym_STAR,
    ACTIONS(8076), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8078), 1,
      anon_sym_AMP,
    STATE(2998), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6385), 1,
      sym__abstract_declarator,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6632), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [152039] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8822), 1,
      anon_sym_LT,
    STATE(2495), 1,
      sym_template_argument_list,
    ACTIONS(5720), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(4059), 31,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [152091] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    ACTIONS(8568), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8576), 1,
      anon_sym_SLASH,
    ACTIONS(8582), 1,
      anon_sym_PIPE,
    ACTIONS(8586), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_LT_LT,
    ACTIONS(8594), 1,
      anon_sym_GT_GT,
    ACTIONS(8596), 1,
      anon_sym_QMARK,
    ACTIONS(8598), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8600), 1,
      anon_sym_bitor,
    ACTIONS(8602), 1,
      anon_sym_bitand,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8578), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8580), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8584), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8604), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8820), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(8588), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8590), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [152183] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8634), 1,
      anon_sym___attribute__,
    ACTIONS(8636), 1,
      anon_sym___attribute,
    ACTIONS(8832), 1,
      anon_sym_LBRACE,
    ACTIONS(8834), 1,
      anon_sym_COLON,
    STATE(4732), 1,
      sym__enum_base_clause,
    STATE(4799), 1,
      sym_enumerator_list,
    STATE(4856), 1,
      sym_attribute_specifier,
    ACTIONS(6245), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6247), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [152243] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(7565), 1,
      anon_sym_COMMA,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8836), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [152337] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(7565), 1,
      anon_sym_COMMA,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8838), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [152431] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(7565), 1,
      anon_sym_COMMA,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8840), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [152525] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(7565), 1,
      anon_sym_COMMA,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8842), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [152619] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(7565), 1,
      anon_sym_COMMA,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8844), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [152713] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(7565), 1,
      anon_sym_COMMA,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8846), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [152807] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8068), 1,
      anon_sym_STAR,
    ACTIONS(8070), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8072), 1,
      anon_sym_AMP,
    STATE(2931), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6370), 1,
      sym__abstract_declarator,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8300), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [152879] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8848), 1,
      anon_sym_COMMA,
    ACTIONS(8850), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [152973] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8776), 1,
      anon_sym_COMMA,
    ACTIONS(8782), 1,
      anon_sym_SLASH,
    ACTIONS(8788), 1,
      anon_sym_PIPE,
    ACTIONS(8792), 1,
      anon_sym_AMP,
    ACTIONS(8798), 1,
      anon_sym_GT_EQ,
    ACTIONS(8804), 1,
      anon_sym_QMARK,
    ACTIONS(8806), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8808), 1,
      anon_sym_bitor,
    ACTIONS(8810), 1,
      anon_sym_bitand,
    ACTIONS(8852), 1,
      anon_sym_COLON,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8780), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8784), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8786), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8790), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8800), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8794), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8796), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [153067] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8068), 1,
      anon_sym_STAR,
    ACTIONS(8070), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8072), 1,
      anon_sym_AMP,
    STATE(2931), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6351), 1,
      sym__abstract_declarator,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5698), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [153139] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8068), 1,
      anon_sym_STAR,
    ACTIONS(8070), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8072), 1,
      anon_sym_AMP,
    STATE(2931), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6383), 1,
      sym__abstract_declarator,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8296), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [153211] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8634), 1,
      anon_sym___attribute__,
    ACTIONS(8636), 1,
      anon_sym___attribute,
    ACTIONS(8832), 1,
      anon_sym_LBRACE,
    ACTIONS(8834), 1,
      anon_sym_COLON,
    STATE(4762), 1,
      sym__enum_base_clause,
    STATE(4813), 1,
      sym_enumerator_list,
    STATE(4847), 1,
      sym_attribute_specifier,
    ACTIONS(6161), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6163), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [153271] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8068), 1,
      anon_sym_STAR,
    ACTIONS(8070), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8072), 1,
      anon_sym_AMP,
    STATE(2931), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6354), 1,
      sym__abstract_declarator,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6632), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [153343] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(2146), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4932), 2,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(5973), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4981), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_GT2,
    ACTIONS(4984), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [153395] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(7565), 1,
      anon_sym_COMMA,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8854), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [153489] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(7565), 1,
      anon_sym_COMMA,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8856), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [153583] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    ACTIONS(8576), 1,
      anon_sym_SLASH,
    ACTIONS(8582), 1,
      anon_sym_PIPE,
    ACTIONS(8586), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_LT_LT,
    ACTIONS(8594), 1,
      anon_sym_GT_GT,
    ACTIONS(8598), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8600), 1,
      anon_sym_bitor,
    ACTIONS(8602), 1,
      anon_sym_bitand,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8578), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8580), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8584), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8604), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8588), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6808), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_GT2,
    ACTIONS(8590), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [153671] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8056), 1,
      anon_sym_STAR,
    ACTIONS(8058), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8060), 1,
      anon_sym_AMP,
    ACTIONS(8302), 1,
      anon_sym___attribute,
    STATE(3221), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6365), 1,
      sym__abstract_declarator,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8300), 6,
      anon_sym_COMMA,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [153745] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5361), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5363), 35,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [153791] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8776), 1,
      anon_sym_COMMA,
    ACTIONS(8782), 1,
      anon_sym_SLASH,
    ACTIONS(8788), 1,
      anon_sym_PIPE,
    ACTIONS(8792), 1,
      anon_sym_AMP,
    ACTIONS(8798), 1,
      anon_sym_GT_EQ,
    ACTIONS(8804), 1,
      anon_sym_QMARK,
    ACTIONS(8806), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8808), 1,
      anon_sym_bitor,
    ACTIONS(8810), 1,
      anon_sym_bitand,
    ACTIONS(8858), 1,
      anon_sym_COLON,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8780), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8784), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8786), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8790), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8800), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8794), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8796), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [153885] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(5706), 1,
      anon_sym___attribute,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8056), 1,
      anon_sym_STAR,
    ACTIONS(8058), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8060), 1,
      anon_sym_AMP,
    STATE(3221), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6395), 1,
      sym__abstract_declarator,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5698), 6,
      anon_sym_COMMA,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [153959] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8056), 1,
      anon_sym_STAR,
    ACTIONS(8058), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8060), 1,
      anon_sym_AMP,
    ACTIONS(8298), 1,
      anon_sym___attribute,
    STATE(3221), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6400), 1,
      sym__abstract_declarator,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8296), 6,
      anon_sym_COMMA,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [154033] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(6634), 1,
      anon_sym___attribute,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8056), 1,
      anon_sym_STAR,
    ACTIONS(8058), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8060), 1,
      anon_sym_AMP,
    STATE(3221), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6397), 1,
      sym__abstract_declarator,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6632), 6,
      anon_sym_COMMA,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [154107] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    ACTIONS(8652), 1,
      anon_sym_PIPE,
    ACTIONS(8656), 1,
      anon_sym_AMP,
    ACTIONS(8662), 1,
      anon_sym_GT_EQ,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8672), 1,
      anon_sym_bitor,
    ACTIONS(8674), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8648), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8650), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8654), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8860), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(8658), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8660), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [154199] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(7565), 1,
      anon_sym_COMMA,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8762), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [154293] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8062), 1,
      anon_sym_STAR,
    ACTIONS(8064), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8066), 1,
      anon_sym_AMP,
    ACTIONS(8302), 1,
      anon_sym___attribute,
    STATE(3249), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6346), 1,
      sym__abstract_declarator,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8300), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [154367] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8703), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [154459] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8776), 1,
      anon_sym_COMMA,
    ACTIONS(8782), 1,
      anon_sym_SLASH,
    ACTIONS(8788), 1,
      anon_sym_PIPE,
    ACTIONS(8792), 1,
      anon_sym_AMP,
    ACTIONS(8798), 1,
      anon_sym_GT_EQ,
    ACTIONS(8804), 1,
      anon_sym_QMARK,
    ACTIONS(8806), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8808), 1,
      anon_sym_bitor,
    ACTIONS(8810), 1,
      anon_sym_bitand,
    ACTIONS(8862), 1,
      anon_sym_COLON,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8780), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8784), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8786), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8790), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8800), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8794), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8796), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [154553] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(5706), 1,
      anon_sym___attribute,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8062), 1,
      anon_sym_STAR,
    ACTIONS(8064), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8066), 1,
      anon_sym_AMP,
    STATE(3249), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6413), 1,
      sym__abstract_declarator,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5698), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [154627] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8062), 1,
      anon_sym_STAR,
    ACTIONS(8064), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8066), 1,
      anon_sym_AMP,
    ACTIONS(8298), 1,
      anon_sym___attribute,
    STATE(3249), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6352), 1,
      sym__abstract_declarator,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8296), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [154701] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    STATE(4624), 1,
      sym_attribute_specifier,
    ACTIONS(5901), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5903), 31,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [154753] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(6634), 1,
      anon_sym___attribute,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8062), 1,
      anon_sym_STAR,
    ACTIONS(8064), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8066), 1,
      anon_sym_AMP,
    STATE(3249), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6415), 1,
      sym__abstract_declarator,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6632), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [154827] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    STATE(4630), 1,
      sym_attribute_specifier,
    ACTIONS(5969), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5971), 31,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [154879] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    ACTIONS(8568), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8576), 1,
      anon_sym_SLASH,
    ACTIONS(8582), 1,
      anon_sym_PIPE,
    ACTIONS(8586), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_LT_LT,
    ACTIONS(8594), 1,
      anon_sym_GT_GT,
    ACTIONS(8596), 1,
      anon_sym_QMARK,
    ACTIONS(8598), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8600), 1,
      anon_sym_bitor,
    ACTIONS(8602), 1,
      anon_sym_bitand,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(6545), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8578), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8580), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8584), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8604), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8588), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8590), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [154971] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8087), 1,
      sym_auto,
    ACTIONS(8089), 1,
      anon_sym_decltype,
    STATE(4610), 1,
      sym_decltype_auto,
    ACTIONS(5391), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5393), 30,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [155023] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8864), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [155115] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8776), 1,
      anon_sym_COMMA,
    ACTIONS(8782), 1,
      anon_sym_SLASH,
    ACTIONS(8788), 1,
      anon_sym_PIPE,
    ACTIONS(8792), 1,
      anon_sym_AMP,
    ACTIONS(8798), 1,
      anon_sym_GT_EQ,
    ACTIONS(8804), 1,
      anon_sym_QMARK,
    ACTIONS(8806), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8808), 1,
      anon_sym_bitor,
    ACTIONS(8810), 1,
      anon_sym_bitand,
    ACTIONS(8866), 1,
      anon_sym_COLON,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8780), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8784), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8786), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8790), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8800), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8794), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8796), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [155209] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8776), 1,
      anon_sym_COMMA,
    ACTIONS(8782), 1,
      anon_sym_SLASH,
    ACTIONS(8788), 1,
      anon_sym_PIPE,
    ACTIONS(8792), 1,
      anon_sym_AMP,
    ACTIONS(8798), 1,
      anon_sym_GT_EQ,
    ACTIONS(8804), 1,
      anon_sym_QMARK,
    ACTIONS(8806), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8808), 1,
      anon_sym_bitor,
    ACTIONS(8810), 1,
      anon_sym_bitand,
    ACTIONS(8868), 1,
      anon_sym_COLON,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8780), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8784), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8786), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8790), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8800), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8794), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8796), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [155303] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8870), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [155395] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(5521), 1,
      anon_sym_const,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8020), 1,
      sym_auto,
    ACTIONS(8022), 1,
      anon_sym_decltype,
    ACTIONS(8326), 1,
      anon_sym_STAR,
    ACTIONS(8328), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8330), 1,
      anon_sym_AMP,
    STATE(1651), 1,
      sym_alignas_qualifier,
    STATE(1837), 1,
      sym_decltype_auto,
    STATE(3373), 1,
      sym_parameter_list,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6554), 1,
      sym__abstract_declarator,
    ACTIONS(8340), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4833), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8083), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8332), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [155473] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    STATE(4653), 1,
      sym_attribute_specifier,
    ACTIONS(5947), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5949), 31,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [155525] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    STATE(4659), 1,
      sym_attribute_specifier,
    ACTIONS(5905), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5907), 31,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [155577] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    STATE(4666), 1,
      sym_attribute_specifier,
    ACTIONS(5913), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5915), 31,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [155629] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    STATE(4667), 1,
      sym_attribute_specifier,
    ACTIONS(5917), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5919), 31,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [155681] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8820), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [155773] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8820), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [155865] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6363), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(6365), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_GT2,
  [155923] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    ACTIONS(8576), 1,
      anon_sym_SLASH,
    ACTIONS(8582), 1,
      anon_sym_PIPE,
    ACTIONS(8586), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_LT_LT,
    ACTIONS(8594), 1,
      anon_sym_GT_GT,
    ACTIONS(8598), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8600), 1,
      anon_sym_bitor,
    ACTIONS(8602), 1,
      anon_sym_bitand,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8578), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8580), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8584), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8604), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8588), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(6870), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_GT2,
    ACTIONS(8590), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [156011] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    ACTIONS(8782), 1,
      anon_sym_SLASH,
    ACTIONS(8788), 1,
      anon_sym_PIPE,
    ACTIONS(8792), 1,
      anon_sym_AMP,
    ACTIONS(8798), 1,
      anon_sym_GT_EQ,
    ACTIONS(8806), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8808), 1,
      anon_sym_bitor,
    ACTIONS(8810), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8780), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8784), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8786), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8790), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8800), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8794), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8796), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6808), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [156099] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8782), 1,
      anon_sym_SLASH,
    ACTIONS(8788), 1,
      anon_sym_PIPE,
    ACTIONS(8792), 1,
      anon_sym_AMP,
    ACTIONS(8798), 1,
      anon_sym_GT_EQ,
    ACTIONS(8804), 1,
      anon_sym_QMARK,
    ACTIONS(8806), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8808), 1,
      anon_sym_bitor,
    ACTIONS(8810), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6545), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8780), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8784), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8786), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8790), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8800), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8794), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8796), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [156191] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8872), 1,
      anon_sym_COMMA,
    ACTIONS(8874), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [156285] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    ACTIONS(8782), 1,
      anon_sym_SLASH,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8780), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6263), 7,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [156349] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    ACTIONS(8782), 1,
      anon_sym_SLASH,
    ACTIONS(8788), 1,
      anon_sym_PIPE,
    ACTIONS(8792), 1,
      anon_sym_AMP,
    ACTIONS(8798), 1,
      anon_sym_GT_EQ,
    ACTIONS(8806), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8808), 1,
      anon_sym_bitor,
    ACTIONS(8810), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8780), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8786), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8790), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8800), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8794), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8796), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
  [156435] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    ACTIONS(8782), 1,
      anon_sym_SLASH,
    ACTIONS(8788), 1,
      anon_sym_PIPE,
    ACTIONS(8792), 1,
      anon_sym_AMP,
    ACTIONS(8798), 1,
      anon_sym_GT_EQ,
    ACTIONS(8806), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8808), 1,
      anon_sym_bitor,
    ACTIONS(8810), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8780), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8790), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8800), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8794), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8796), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
  [156519] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6263), 1,
      anon_sym_PIPE,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    ACTIONS(8782), 1,
      anon_sym_SLASH,
    ACTIONS(8792), 1,
      anon_sym_AMP,
    ACTIONS(8798), 1,
      anon_sym_GT_EQ,
    ACTIONS(8806), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8810), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8780), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8790), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8800), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8794), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8796), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
  [156601] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6263), 1,
      anon_sym_PIPE,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    ACTIONS(8782), 1,
      anon_sym_SLASH,
    ACTIONS(8792), 1,
      anon_sym_AMP,
    ACTIONS(8798), 1,
      anon_sym_GT_EQ,
    ACTIONS(8806), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8810), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8780), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8800), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8794), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8796), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
  [156681] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    ACTIONS(8782), 1,
      anon_sym_SLASH,
    ACTIONS(8798), 1,
      anon_sym_GT_EQ,
    ACTIONS(8806), 1,
      anon_sym_LT_EQ_GT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6263), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8780), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8800), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8794), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8796), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
  [156757] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    ACTIONS(8782), 1,
      anon_sym_SLASH,
    ACTIONS(8798), 1,
      anon_sym_GT_EQ,
    ACTIONS(8806), 1,
      anon_sym_LT_EQ_GT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6263), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8780), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8800), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8796), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [156831] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    ACTIONS(8782), 1,
      anon_sym_SLASH,
    ACTIONS(8806), 1,
      anon_sym_LT_EQ_GT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8780), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8800), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6263), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [156901] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8604), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6331), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(6333), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [156961] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8776), 1,
      anon_sym_COMMA,
    ACTIONS(8782), 1,
      anon_sym_SLASH,
    ACTIONS(8788), 1,
      anon_sym_PIPE,
    ACTIONS(8792), 1,
      anon_sym_AMP,
    ACTIONS(8798), 1,
      anon_sym_GT_EQ,
    ACTIONS(8804), 1,
      anon_sym_QMARK,
    ACTIONS(8806), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8808), 1,
      anon_sym_bitor,
    ACTIONS(8810), 1,
      anon_sym_bitand,
    ACTIONS(8876), 1,
      anon_sym_COLON,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8780), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8784), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8786), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8790), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8800), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8794), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8796), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [157055] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    ACTIONS(8782), 1,
      anon_sym_SLASH,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8780), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8800), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6263), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [157123] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8679), 1,
      anon_sym_COLON,
    ACTIONS(8776), 1,
      anon_sym_COMMA,
    ACTIONS(8782), 1,
      anon_sym_SLASH,
    ACTIONS(8788), 1,
      anon_sym_PIPE,
    ACTIONS(8792), 1,
      anon_sym_AMP,
    ACTIONS(8798), 1,
      anon_sym_GT_EQ,
    ACTIONS(8804), 1,
      anon_sym_QMARK,
    ACTIONS(8806), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8808), 1,
      anon_sym_bitor,
    ACTIONS(8810), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8780), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8784), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8786), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8790), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8800), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8794), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8796), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [157217] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    ACTIONS(8782), 1,
      anon_sym_SLASH,
    ACTIONS(8788), 1,
      anon_sym_PIPE,
    ACTIONS(8792), 1,
      anon_sym_AMP,
    ACTIONS(8798), 1,
      anon_sym_GT_EQ,
    ACTIONS(8806), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8808), 1,
      anon_sym_bitor,
    ACTIONS(8810), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8780), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8784), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8786), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8790), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8800), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8794), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8796), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6846), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [157305] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8782), 1,
      anon_sym_SLASH,
    ACTIONS(8788), 1,
      anon_sym_PIPE,
    ACTIONS(8792), 1,
      anon_sym_AMP,
    ACTIONS(8798), 1,
      anon_sym_GT_EQ,
    ACTIONS(8804), 1,
      anon_sym_QMARK,
    ACTIONS(8806), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8808), 1,
      anon_sym_bitor,
    ACTIONS(8810), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6850), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8780), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8784), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8786), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8790), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8800), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8794), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8796), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [157397] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    ACTIONS(8782), 1,
      anon_sym_SLASH,
    ACTIONS(8788), 1,
      anon_sym_PIPE,
    ACTIONS(8792), 1,
      anon_sym_AMP,
    ACTIONS(8798), 1,
      anon_sym_GT_EQ,
    ACTIONS(8806), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8808), 1,
      anon_sym_bitor,
    ACTIONS(8810), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8780), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8784), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8786), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8790), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8800), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8794), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8796), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6854), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [157485] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8782), 1,
      anon_sym_SLASH,
    ACTIONS(8788), 1,
      anon_sym_PIPE,
    ACTIONS(8792), 1,
      anon_sym_AMP,
    ACTIONS(8798), 1,
      anon_sym_GT_EQ,
    ACTIONS(8804), 1,
      anon_sym_QMARK,
    ACTIONS(8806), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8808), 1,
      anon_sym_bitor,
    ACTIONS(8810), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6858), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8780), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8784), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8786), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8790), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8800), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8794), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8796), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [157577] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    STATE(4682), 1,
      sym_attribute_specifier,
    ACTIONS(5976), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5978), 31,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [157629] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    STATE(4687), 1,
      sym_attribute_specifier,
    ACTIONS(5980), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5982), 31,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [157681] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    ACTIONS(8652), 1,
      anon_sym_PIPE,
    ACTIONS(8656), 1,
      anon_sym_AMP,
    ACTIONS(8662), 1,
      anon_sym_GT_EQ,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8672), 1,
      anon_sym_bitor,
    ACTIONS(8674), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8648), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8650), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8654), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8824), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(8658), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8660), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [157773] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    STATE(4688), 1,
      sym_attribute_specifier,
    ACTIONS(5986), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5988), 31,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [157825] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    STATE(4691), 1,
      sym_attribute_specifier,
    ACTIONS(5990), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5992), 31,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [157877] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4895), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5868), 1,
      anon_sym_LPAREN2,
    ACTIONS(5871), 1,
      anon_sym_LBRACK,
    ACTIONS(4043), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(4035), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [157929] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8878), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [158021] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    ACTIONS(8652), 1,
      anon_sym_PIPE,
    ACTIONS(8656), 1,
      anon_sym_AMP,
    ACTIONS(8662), 1,
      anon_sym_GT_EQ,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8672), 1,
      anon_sym_bitor,
    ACTIONS(8674), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7468), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8648), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8650), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8654), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8658), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8660), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [158113] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    ACTIONS(8576), 1,
      anon_sym_SLASH,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8604), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6263), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(6265), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [158177] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8554), 1,
      anon_sym_LT,
    STATE(1829), 1,
      sym_template_argument_list,
    ACTIONS(5720), 4,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(4059), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_or,
      anon_sym_and,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [158229] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8720), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [158321] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8681), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [158413] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8880), 1,
      anon_sym_COMMA,
    ACTIONS(8882), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [158507] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8884), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [158599] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8776), 1,
      anon_sym_COMMA,
    ACTIONS(8782), 1,
      anon_sym_SLASH,
    ACTIONS(8788), 1,
      anon_sym_PIPE,
    ACTIONS(8792), 1,
      anon_sym_AMP,
    ACTIONS(8798), 1,
      anon_sym_GT_EQ,
    ACTIONS(8804), 1,
      anon_sym_QMARK,
    ACTIONS(8806), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8808), 1,
      anon_sym_bitor,
    ACTIONS(8810), 1,
      anon_sym_bitand,
    ACTIONS(8886), 1,
      anon_sym_COLON,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8780), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8784), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8786), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8790), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8800), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8794), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8796), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [158693] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    STATE(4695), 1,
      sym_attribute_specifier,
    ACTIONS(5951), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5953), 31,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [158745] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8604), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6263), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(6265), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [158805] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    ACTIONS(8576), 1,
      anon_sym_SLASH,
    ACTIONS(8582), 1,
      anon_sym_PIPE,
    ACTIONS(8586), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_LT_LT,
    ACTIONS(8594), 1,
      anon_sym_GT_GT,
    ACTIONS(8598), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8600), 1,
      anon_sym_bitor,
    ACTIONS(8602), 1,
      anon_sym_bitand,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8580), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8584), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8604), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8588), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8590), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_GT2,
  [158891] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    STATE(4696), 1,
      sym_attribute_specifier,
    ACTIONS(5887), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5889), 31,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [158943] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8344), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [159035] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    ACTIONS(8576), 1,
      anon_sym_SLASH,
    ACTIONS(8582), 1,
      anon_sym_PIPE,
    ACTIONS(8586), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_LT_LT,
    ACTIONS(8594), 1,
      anon_sym_GT_GT,
    ACTIONS(8598), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8600), 1,
      anon_sym_bitor,
    ACTIONS(8602), 1,
      anon_sym_bitand,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8584), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8604), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8588), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8590), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_GT2,
  [159119] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8888), 1,
      anon_sym_COMMA,
    ACTIONS(8890), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [159213] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8892), 1,
      anon_sym_COMMA,
    ACTIONS(8894), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [159307] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8896), 1,
      anon_sym_COMMA,
    ACTIONS(8898), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [159401] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6263), 1,
      anon_sym_PIPE,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    ACTIONS(8576), 1,
      anon_sym_SLASH,
    ACTIONS(8586), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_LT_LT,
    ACTIONS(8594), 1,
      anon_sym_GT_GT,
    ACTIONS(8598), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8602), 1,
      anon_sym_bitand,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8584), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8604), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8588), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8590), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_GT2,
  [159483] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8822), 1,
      anon_sym_LT,
    STATE(2267), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2495), 1,
      sym_template_argument_list,
    ACTIONS(4033), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(4919), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4041), 27,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [159539] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8900), 1,
      anon_sym_COMMA,
    ACTIONS(8902), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [159633] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6263), 1,
      anon_sym_PIPE,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    ACTIONS(8576), 1,
      anon_sym_SLASH,
    ACTIONS(8586), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_LT_LT,
    ACTIONS(8594), 1,
      anon_sym_GT_GT,
    ACTIONS(8598), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8602), 1,
      anon_sym_bitand,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8604), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8588), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8590), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_GT2,
  [159713] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    ACTIONS(8576), 1,
      anon_sym_SLASH,
    ACTIONS(8592), 1,
      anon_sym_LT_LT,
    ACTIONS(8594), 1,
      anon_sym_GT_GT,
    ACTIONS(8598), 1,
      anon_sym_LT_EQ_GT,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(6263), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8604), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8588), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8590), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_GT2,
  [159789] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    ACTIONS(8576), 1,
      anon_sym_SLASH,
    ACTIONS(8592), 1,
      anon_sym_LT_LT,
    ACTIONS(8594), 1,
      anon_sym_GT_GT,
    ACTIONS(8598), 1,
      anon_sym_LT_EQ_GT,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(6263), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8604), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8590), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [159863] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    ACTIONS(8782), 1,
      anon_sym_SLASH,
    ACTIONS(8788), 1,
      anon_sym_PIPE,
    ACTIONS(8792), 1,
      anon_sym_AMP,
    ACTIONS(8798), 1,
      anon_sym_GT_EQ,
    ACTIONS(8806), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8808), 1,
      anon_sym_bitor,
    ACTIONS(8810), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8780), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8784), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8786), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8790), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8800), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8794), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8796), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6870), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [159951] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    ACTIONS(8782), 1,
      anon_sym_SLASH,
    ACTIONS(8788), 1,
      anon_sym_PIPE,
    ACTIONS(8792), 1,
      anon_sym_AMP,
    ACTIONS(8798), 1,
      anon_sym_GT_EQ,
    ACTIONS(8806), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8808), 1,
      anon_sym_bitor,
    ACTIONS(8810), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8780), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8784), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8786), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8790), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8800), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8794), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8796), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6874), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_QMARK,
  [160039] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6263), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [160099] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8776), 1,
      anon_sym_COMMA,
    ACTIONS(8782), 1,
      anon_sym_SLASH,
    ACTIONS(8788), 1,
      anon_sym_PIPE,
    ACTIONS(8792), 1,
      anon_sym_AMP,
    ACTIONS(8798), 1,
      anon_sym_GT_EQ,
    ACTIONS(8804), 1,
      anon_sym_QMARK,
    ACTIONS(8806), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8808), 1,
      anon_sym_bitor,
    ACTIONS(8810), 1,
      anon_sym_bitand,
    ACTIONS(8904), 1,
      anon_sym_COLON,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8780), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8784), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8786), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8790), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8800), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8794), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8796), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [160193] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6281), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6283), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [160253] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    ACTIONS(8576), 1,
      anon_sym_SLASH,
    ACTIONS(8592), 1,
      anon_sym_LT_LT,
    ACTIONS(8594), 1,
      anon_sym_GT_GT,
    ACTIONS(8598), 1,
      anon_sym_LT_EQ_GT,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8604), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6263), 6,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [160325] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    ACTIONS(8576), 1,
      anon_sym_SLASH,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8604), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6263), 7,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(6265), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [160391] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(7565), 1,
      anon_sym_COMMA,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8906), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [160485] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    ACTIONS(8576), 1,
      anon_sym_SLASH,
    ACTIONS(8592), 1,
      anon_sym_LT_LT,
    ACTIONS(8594), 1,
      anon_sym_GT_GT,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8604), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6263), 6,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [160555] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5383), 1,
      anon_sym_COLON,
    ACTIONS(5878), 1,
      anon_sym_LBRACE,
    STATE(1800), 1,
      sym_attribute_specifier,
    STATE(5093), 1,
      sym_field_declaration_list,
    STATE(6993), 1,
      sym_virtual_specifier,
    STATE(7682), 1,
      sym_base_class_clause,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(5377), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(5375), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [160617] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(7565), 1,
      anon_sym_COMMA,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8908), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [160711] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(7565), 1,
      anon_sym_COMMA,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8910), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [160805] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    ACTIONS(8568), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8576), 1,
      anon_sym_SLASH,
    ACTIONS(8582), 1,
      anon_sym_PIPE,
    ACTIONS(8586), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_LT_LT,
    ACTIONS(8594), 1,
      anon_sym_GT_GT,
    ACTIONS(8596), 1,
      anon_sym_QMARK,
    ACTIONS(8598), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8600), 1,
      anon_sym_bitor,
    ACTIONS(8602), 1,
      anon_sym_bitand,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8578), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8580), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8584), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8604), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8912), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(8588), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8590), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [160897] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    ACTIONS(8652), 1,
      anon_sym_PIPE,
    ACTIONS(8656), 1,
      anon_sym_AMP,
    ACTIONS(8662), 1,
      anon_sym_GT_EQ,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8672), 1,
      anon_sym_bitor,
    ACTIONS(8674), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6545), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8648), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8650), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8654), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8658), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8660), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [160989] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6263), 7,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [161053] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    ACTIONS(8652), 1,
      anon_sym_PIPE,
    ACTIONS(8656), 1,
      anon_sym_AMP,
    ACTIONS(8662), 1,
      anon_sym_GT_EQ,
    ACTIONS(8670), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8672), 1,
      anon_sym_bitor,
    ACTIONS(8674), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8650), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8654), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8658), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8660), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
  [161139] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    ACTIONS(8652), 1,
      anon_sym_PIPE,
    ACTIONS(8656), 1,
      anon_sym_AMP,
    ACTIONS(8662), 1,
      anon_sym_GT_EQ,
    ACTIONS(8670), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8672), 1,
      anon_sym_bitor,
    ACTIONS(8674), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8654), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8658), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8660), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
  [161223] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6263), 1,
      anon_sym_PIPE,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    ACTIONS(8656), 1,
      anon_sym_AMP,
    ACTIONS(8662), 1,
      anon_sym_GT_EQ,
    ACTIONS(8670), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8674), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8654), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8658), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8660), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
  [161305] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6263), 1,
      anon_sym_PIPE,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    ACTIONS(8656), 1,
      anon_sym_AMP,
    ACTIONS(8662), 1,
      anon_sym_GT_EQ,
    ACTIONS(8670), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8674), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8658), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8660), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
  [161385] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    ACTIONS(8662), 1,
      anon_sym_GT_EQ,
    ACTIONS(8670), 1,
      anon_sym_LT_EQ_GT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6263), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8658), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8660), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 12,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
  [161461] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    ACTIONS(8662), 1,
      anon_sym_GT_EQ,
    ACTIONS(8670), 1,
      anon_sym_LT_EQ_GT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6263), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8660), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [161535] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    ACTIONS(8670), 1,
      anon_sym_LT_EQ_GT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6263), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [161605] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6263), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [161671] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6263), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [161739] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    ACTIONS(8652), 1,
      anon_sym_PIPE,
    ACTIONS(8656), 1,
      anon_sym_AMP,
    ACTIONS(8662), 1,
      anon_sym_GT_EQ,
    ACTIONS(8670), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8672), 1,
      anon_sym_bitor,
    ACTIONS(8674), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8648), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8650), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8654), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8658), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8660), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6846), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [161827] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    ACTIONS(8652), 1,
      anon_sym_PIPE,
    ACTIONS(8656), 1,
      anon_sym_AMP,
    ACTIONS(8662), 1,
      anon_sym_GT_EQ,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8672), 1,
      anon_sym_bitor,
    ACTIONS(8674), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6850), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8648), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8650), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8654), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8658), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8660), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [161919] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    ACTIONS(8652), 1,
      anon_sym_PIPE,
    ACTIONS(8656), 1,
      anon_sym_AMP,
    ACTIONS(8662), 1,
      anon_sym_GT_EQ,
    ACTIONS(8670), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8672), 1,
      anon_sym_bitor,
    ACTIONS(8674), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8648), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8650), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8654), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8658), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8660), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6854), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [162007] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    ACTIONS(8652), 1,
      anon_sym_PIPE,
    ACTIONS(8656), 1,
      anon_sym_AMP,
    ACTIONS(8662), 1,
      anon_sym_GT_EQ,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8672), 1,
      anon_sym_bitor,
    ACTIONS(8674), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6858), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8648), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8650), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8654), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8658), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8660), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [162099] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    ACTIONS(8652), 1,
      anon_sym_PIPE,
    ACTIONS(8656), 1,
      anon_sym_AMP,
    ACTIONS(8662), 1,
      anon_sym_GT_EQ,
    ACTIONS(8670), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8672), 1,
      anon_sym_bitor,
    ACTIONS(8674), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8648), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8650), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8654), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8658), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8660), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6870), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [162187] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    ACTIONS(8652), 1,
      anon_sym_PIPE,
    ACTIONS(8656), 1,
      anon_sym_AMP,
    ACTIONS(8662), 1,
      anon_sym_GT_EQ,
    ACTIONS(8670), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8672), 1,
      anon_sym_bitor,
    ACTIONS(8674), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8648), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8650), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8654), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8658), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8660), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6874), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_QMARK,
  [162275] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(4157), 1,
      anon_sym_LPAREN2,
    ACTIONS(4159), 1,
      anon_sym_STAR,
    ACTIONS(4161), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4163), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      sym_identifier,
    ACTIONS(5710), 1,
      anon_sym_LBRACK,
    ACTIONS(6180), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8197), 1,
      anon_sym_RPAREN,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(5712), 1,
      sym__scope_resolution,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6367), 1,
      sym__declarator,
    STATE(6619), 1,
      sym__abstract_declarator,
    STATE(7870), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [162361] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(7565), 1,
      anon_sym_COMMA,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8914), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [162455] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    ACTIONS(8568), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8576), 1,
      anon_sym_SLASH,
    ACTIONS(8582), 1,
      anon_sym_PIPE,
    ACTIONS(8586), 1,
      anon_sym_AMP,
    ACTIONS(8592), 1,
      anon_sym_LT_LT,
    ACTIONS(8594), 1,
      anon_sym_GT_GT,
    ACTIONS(8596), 1,
      anon_sym_QMARK,
    ACTIONS(8598), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8600), 1,
      anon_sym_bitor,
    ACTIONS(8602), 1,
      anon_sym_bitand,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8572), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8574), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8578), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8580), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8584), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8604), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8864), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    ACTIONS(8588), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8590), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [162547] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6363), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6365), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [162605] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6349), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6351), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [162665] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6331), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6333), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [162725] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(6277), 8,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6279), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
  [162783] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(7565), 1,
      anon_sym_COMMA,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8916), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [162877] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8776), 1,
      anon_sym_COMMA,
    ACTIONS(8782), 1,
      anon_sym_SLASH,
    ACTIONS(8788), 1,
      anon_sym_PIPE,
    ACTIONS(8792), 1,
      anon_sym_AMP,
    ACTIONS(8798), 1,
      anon_sym_GT_EQ,
    ACTIONS(8804), 1,
      anon_sym_QMARK,
    ACTIONS(8806), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8808), 1,
      anon_sym_bitor,
    ACTIONS(8810), 1,
      anon_sym_bitand,
    ACTIONS(8918), 1,
      anon_sym_COLON,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8780), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8784), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8786), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8790), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8800), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8794), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8796), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [162971] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    ACTIONS(7445), 1,
      anon_sym_LBRACK,
    ACTIONS(7459), 1,
      anon_sym_DOT,
    STATE(3561), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym_subscript_argument_list,
    ACTIONS(7461), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(8604), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(6349), 10,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
    ACTIONS(6351), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_GT2,
  [163031] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8776), 1,
      anon_sym_COMMA,
    ACTIONS(8782), 1,
      anon_sym_SLASH,
    ACTIONS(8788), 1,
      anon_sym_PIPE,
    ACTIONS(8792), 1,
      anon_sym_AMP,
    ACTIONS(8798), 1,
      anon_sym_GT_EQ,
    ACTIONS(8804), 1,
      anon_sym_QMARK,
    ACTIONS(8806), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8808), 1,
      anon_sym_bitor,
    ACTIONS(8810), 1,
      anon_sym_bitand,
    ACTIONS(8920), 1,
      anon_sym_COLON,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8780), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8784), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8786), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8790), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8800), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8794), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8796), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [163125] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    ACTIONS(8652), 1,
      anon_sym_PIPE,
    ACTIONS(8656), 1,
      anon_sym_AMP,
    ACTIONS(8662), 1,
      anon_sym_GT_EQ,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8672), 1,
      anon_sym_bitor,
    ACTIONS(8674), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8648), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8650), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8654), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8922), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(8658), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8660), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [163217] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    ACTIONS(8782), 1,
      anon_sym_SLASH,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8780), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(6263), 5,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(6265), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
  [163283] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    ACTIONS(8652), 1,
      anon_sym_PIPE,
    ACTIONS(8656), 1,
      anon_sym_AMP,
    ACTIONS(8662), 1,
      anon_sym_GT_EQ,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8672), 1,
      anon_sym_bitor,
    ACTIONS(8674), 1,
      anon_sym_bitand,
    ACTIONS(8924), 1,
      anon_sym_RBRACK,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8648), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8650), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8654), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8658), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8660), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [163374] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    ACTIONS(8652), 1,
      anon_sym_PIPE,
    ACTIONS(8656), 1,
      anon_sym_AMP,
    ACTIONS(8662), 1,
      anon_sym_GT_EQ,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8672), 1,
      anon_sym_bitor,
    ACTIONS(8674), 1,
      anon_sym_bitand,
    ACTIONS(8926), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8928), 1,
      anon_sym_RBRACK,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8648), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8650), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8654), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8658), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8660), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [163465] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8930), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [163556] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8932), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [163647] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8934), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [163738] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8153), 1,
      sym_identifier,
    ACTIONS(8155), 1,
      anon_sym_LPAREN2,
    ACTIONS(8157), 1,
      anon_sym_STAR,
    ACTIONS(8159), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8161), 1,
      anon_sym_AMP,
    ACTIONS(8165), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2897), 1,
      sym__type_declarator,
    STATE(3234), 1,
      sym_pointer_type_declarator,
    STATE(8392), 1,
      sym_ms_based_modifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8163), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3227), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [163811] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8936), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [163902] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    ACTIONS(8652), 1,
      anon_sym_PIPE,
    ACTIONS(8656), 1,
      anon_sym_AMP,
    ACTIONS(8662), 1,
      anon_sym_GT_EQ,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8672), 1,
      anon_sym_bitor,
    ACTIONS(8674), 1,
      anon_sym_bitand,
    ACTIONS(8938), 1,
      anon_sym_RBRACK,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8648), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8650), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8654), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8658), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8660), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [163993] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8940), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [164084] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4672), 1,
      anon_sym_RBRACK,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    ACTIONS(8652), 1,
      anon_sym_PIPE,
    ACTIONS(8656), 1,
      anon_sym_AMP,
    ACTIONS(8662), 1,
      anon_sym_GT_EQ,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8672), 1,
      anon_sym_bitor,
    ACTIONS(8674), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8648), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8650), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8654), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8658), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8660), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [164175] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4707), 1,
      anon_sym_RBRACK,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    ACTIONS(8652), 1,
      anon_sym_PIPE,
    ACTIONS(8656), 1,
      anon_sym_AMP,
    ACTIONS(8662), 1,
      anon_sym_GT_EQ,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8672), 1,
      anon_sym_bitor,
    ACTIONS(8674), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8648), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8650), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8654), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8658), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8660), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [164266] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8782), 1,
      anon_sym_SLASH,
    ACTIONS(8788), 1,
      anon_sym_PIPE,
    ACTIONS(8792), 1,
      anon_sym_AMP,
    ACTIONS(8798), 1,
      anon_sym_GT_EQ,
    ACTIONS(8804), 1,
      anon_sym_QMARK,
    ACTIONS(8806), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8808), 1,
      anon_sym_bitor,
    ACTIONS(8810), 1,
      anon_sym_bitand,
    ACTIONS(8942), 1,
      anon_sym_COLON,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8780), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8784), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8786), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8790), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8800), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8794), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8796), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [164357] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8944), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [164448] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8782), 1,
      anon_sym_SLASH,
    ACTIONS(8788), 1,
      anon_sym_PIPE,
    ACTIONS(8792), 1,
      anon_sym_AMP,
    ACTIONS(8798), 1,
      anon_sym_GT_EQ,
    ACTIONS(8804), 1,
      anon_sym_QMARK,
    ACTIONS(8806), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8808), 1,
      anon_sym_bitor,
    ACTIONS(8810), 1,
      anon_sym_bitand,
    ACTIONS(8946), 1,
      anon_sym_COLON,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8780), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8784), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8786), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8790), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8800), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8794), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8796), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [164539] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8948), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [164630] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8950), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [164721] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8952), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [164812] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8954), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [164903] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8956), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [164994] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8958), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [165085] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4696), 1,
      anon_sym_RBRACK,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    ACTIONS(8652), 1,
      anon_sym_PIPE,
    ACTIONS(8656), 1,
      anon_sym_AMP,
    ACTIONS(8662), 1,
      anon_sym_GT_EQ,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8672), 1,
      anon_sym_bitor,
    ACTIONS(8674), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8648), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8650), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8654), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8658), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8660), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [165176] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8960), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [165267] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(6696), 1,
      sym_auto,
    ACTIONS(6698), 1,
      anon_sym_decltype,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8451), 1,
      anon_sym_STAR,
    ACTIONS(8453), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8455), 1,
      anon_sym_AMP,
    STATE(2653), 1,
      sym_decltype_auto,
    STATE(3109), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6650), 1,
      sym__abstract_declarator,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4892), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8083), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [165344] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8962), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [165435] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    ACTIONS(8652), 1,
      anon_sym_PIPE,
    ACTIONS(8656), 1,
      anon_sym_AMP,
    ACTIONS(8662), 1,
      anon_sym_GT_EQ,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8672), 1,
      anon_sym_bitor,
    ACTIONS(8674), 1,
      anon_sym_bitand,
    ACTIONS(8964), 1,
      anon_sym_RBRACK,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8648), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8650), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8654), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8658), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8660), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [165526] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(4873), 1,
      anon_sym_STAR,
    ACTIONS(4875), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4877), 1,
      anon_sym_AMP,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8020), 1,
      sym_auto,
    ACTIONS(8022), 1,
      anon_sym_decltype,
    STATE(1837), 1,
      sym_decltype_auto,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6625), 1,
      sym__abstract_declarator,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4886), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8048), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [165603] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8966), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [165694] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4580), 1,
      anon_sym_RBRACK,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    ACTIONS(8652), 1,
      anon_sym_PIPE,
    ACTIONS(8656), 1,
      anon_sym_AMP,
    ACTIONS(8662), 1,
      anon_sym_GT_EQ,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8672), 1,
      anon_sym_bitor,
    ACTIONS(8674), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8648), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8650), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8654), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8658), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8660), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [165785] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4615), 1,
      anon_sym_RBRACK,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    ACTIONS(8652), 1,
      anon_sym_PIPE,
    ACTIONS(8656), 1,
      anon_sym_AMP,
    ACTIONS(8662), 1,
      anon_sym_GT_EQ,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8672), 1,
      anon_sym_bitor,
    ACTIONS(8674), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8648), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8650), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8654), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8658), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8660), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [165876] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8968), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [165967] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8097), 1,
      sym_identifier,
    ACTIONS(8099), 1,
      anon_sym_LPAREN2,
    ACTIONS(8101), 1,
      anon_sym_STAR,
    ACTIONS(8103), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8105), 1,
      anon_sym_AMP,
    ACTIONS(8111), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2125), 1,
      sym__type_declarator,
    STATE(2258), 1,
      sym_pointer_type_declarator,
    STATE(8208), 1,
      sym_ms_based_modifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8109), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2186), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [166040] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8782), 1,
      anon_sym_SLASH,
    ACTIONS(8788), 1,
      anon_sym_PIPE,
    ACTIONS(8792), 1,
      anon_sym_AMP,
    ACTIONS(8798), 1,
      anon_sym_GT_EQ,
    ACTIONS(8804), 1,
      anon_sym_QMARK,
    ACTIONS(8806), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8808), 1,
      anon_sym_bitor,
    ACTIONS(8810), 1,
      anon_sym_bitand,
    ACTIONS(8970), 1,
      anon_sym_COLON,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8780), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8784), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8786), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8790), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8800), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8794), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8796), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [166131] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8972), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [166222] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8974), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [166313] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8976), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [166404] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8978), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [166495] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8980), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [166586] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8982), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [166677] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8984), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [166768] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8153), 1,
      sym_identifier,
    ACTIONS(8155), 1,
      anon_sym_LPAREN2,
    ACTIONS(8157), 1,
      anon_sym_STAR,
    ACTIONS(8159), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8161), 1,
      anon_sym_AMP,
    ACTIONS(8165), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2927), 1,
      sym__type_declarator,
    STATE(3234), 1,
      sym_pointer_type_declarator,
    STATE(8392), 1,
      sym_ms_based_modifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8163), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3227), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [166841] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8986), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [166932] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8782), 1,
      anon_sym_SLASH,
    ACTIONS(8788), 1,
      anon_sym_PIPE,
    ACTIONS(8792), 1,
      anon_sym_AMP,
    ACTIONS(8798), 1,
      anon_sym_GT_EQ,
    ACTIONS(8804), 1,
      anon_sym_QMARK,
    ACTIONS(8806), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8808), 1,
      anon_sym_bitor,
    ACTIONS(8810), 1,
      anon_sym_bitand,
    ACTIONS(8988), 1,
      anon_sym_COLON,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8780), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8784), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8786), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8790), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8800), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8794), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8796), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [167023] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    ACTIONS(8652), 1,
      anon_sym_PIPE,
    ACTIONS(8656), 1,
      anon_sym_AMP,
    ACTIONS(8662), 1,
      anon_sym_GT_EQ,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8672), 1,
      anon_sym_bitor,
    ACTIONS(8674), 1,
      anon_sym_bitand,
    ACTIONS(8990), 1,
      anon_sym_RBRACK,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8648), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8650), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8654), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8658), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8660), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [167114] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8992), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [167205] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    ACTIONS(8652), 1,
      anon_sym_PIPE,
    ACTIONS(8656), 1,
      anon_sym_AMP,
    ACTIONS(8662), 1,
      anon_sym_GT_EQ,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8672), 1,
      anon_sym_bitor,
    ACTIONS(8674), 1,
      anon_sym_bitand,
    ACTIONS(8994), 1,
      anon_sym_RBRACK,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8648), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8650), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8654), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8658), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8660), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [167296] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8996), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [167387] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8998), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [167478] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5537), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5539), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [167523] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(9000), 1,
      anon_sym_RBRACE,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [167614] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5431), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5433), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [167659] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8554), 1,
      anon_sym_LT,
    STATE(1570), 1,
      sym_template_argument_list,
    ACTIONS(4845), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(4838), 30,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_COLON,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
  [167710] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8181), 1,
      sym_identifier,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8185), 1,
      anon_sym_STAR,
    ACTIONS(8187), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8189), 1,
      anon_sym_AMP,
    ACTIONS(8193), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(3007), 1,
      sym__type_declarator,
    STATE(3404), 1,
      sym_pointer_type_declarator,
    STATE(8244), 1,
      sym_ms_based_modifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8191), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3392), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [167783] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4670), 1,
      anon_sym_RBRACK,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    ACTIONS(8652), 1,
      anon_sym_PIPE,
    ACTIONS(8656), 1,
      anon_sym_AMP,
    ACTIONS(8662), 1,
      anon_sym_GT_EQ,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8672), 1,
      anon_sym_bitor,
    ACTIONS(8674), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8648), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8650), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8654), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8658), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8660), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [167874] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9002), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(6335), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(6337), 30,
      anon_sym_LPAREN2,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [167921] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(9005), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [168012] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(5708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7156), 1,
      anon_sym_STAR,
    ACTIONS(7158), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7160), 1,
      anon_sym_AMP,
    STATE(5225), 1,
      sym_ms_call_modifier,
    STATE(5539), 1,
      sym__declarator,
    STATE(5765), 1,
      sym__scope_resolution,
    STATE(7421), 1,
      sym_init_declarator,
    STATE(8182), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1779), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [168093] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(9007), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [168184] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(9009), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [168275] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(9011), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [168366] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(9013), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [168457] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(9015), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [168548] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(9017), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [168639] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(9019), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [168730] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5632), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [168775] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5640), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5642), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [168820] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5622), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5624), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [168865] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5600), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5602), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [168910] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4748), 1,
      anon_sym_RBRACK,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    ACTIONS(8652), 1,
      anon_sym_PIPE,
    ACTIONS(8656), 1,
      anon_sym_AMP,
    ACTIONS(8662), 1,
      anon_sym_GT_EQ,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8672), 1,
      anon_sym_bitor,
    ACTIONS(8674), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8648), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8650), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8654), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8658), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8660), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [169001] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(4873), 1,
      anon_sym_STAR,
    ACTIONS(4875), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4877), 1,
      anon_sym_AMP,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8020), 1,
      sym_auto,
    ACTIONS(8022), 1,
      anon_sym_decltype,
    STATE(1837), 1,
      sym_decltype_auto,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6651), 1,
      sym__abstract_declarator,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4870), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8083), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [169078] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(9021), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [169169] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(9023), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [169260] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8131), 1,
      sym_identifier,
    ACTIONS(8133), 1,
      anon_sym_LPAREN2,
    ACTIONS(8135), 1,
      anon_sym_STAR,
    ACTIONS(8137), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8139), 1,
      anon_sym_AMP,
    ACTIONS(8143), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(5784), 1,
      sym__type_declarator,
    STATE(5952), 1,
      sym_pointer_type_declarator,
    STATE(7940), 1,
      sym_ms_based_modifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8141), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5950), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [169333] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(9025), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [169424] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5626), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5628), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [169469] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8181), 1,
      sym_identifier,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8185), 1,
      anon_sym_STAR,
    ACTIONS(8187), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8189), 1,
      anon_sym_AMP,
    ACTIONS(8193), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2963), 1,
      sym__type_declarator,
    STATE(3404), 1,
      sym_pointer_type_declarator,
    STATE(8244), 1,
      sym_ms_based_modifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8191), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3392), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [169542] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(9027), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [169633] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(9029), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [169724] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(9031), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [169815] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(9033), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [169906] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(9035), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [169997] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8153), 1,
      sym_identifier,
    ACTIONS(8155), 1,
      anon_sym_LPAREN2,
    ACTIONS(8157), 1,
      anon_sym_STAR,
    ACTIONS(8159), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8161), 1,
      anon_sym_AMP,
    ACTIONS(8165), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2916), 1,
      sym__type_declarator,
    STATE(3234), 1,
      sym_pointer_type_declarator,
    STATE(8392), 1,
      sym_ms_based_modifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8163), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3227), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [170070] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(9037), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [170161] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(6696), 1,
      sym_auto,
    ACTIONS(6698), 1,
      anon_sym_decltype,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8451), 1,
      anon_sym_STAR,
    ACTIONS(8453), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8455), 1,
      anon_sym_AMP,
    STATE(2653), 1,
      sym_decltype_auto,
    STATE(3109), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6668), 1,
      sym__abstract_declarator,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4851), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8048), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [170238] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(9039), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [170329] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(9041), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [170420] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5656), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5658), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [170465] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(9043), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [170556] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5668), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5670), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [170601] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5676), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5678), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [170646] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(9045), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [170737] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(9047), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [170828] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5592), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5594), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [170873] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5502), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5504), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [170918] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5510), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5512), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [170963] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(9049), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [171054] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5514), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5516), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [171099] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5502), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5504), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [171144] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5502), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5504), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [171189] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6901), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
      sym_literal_suffix,
    ACTIONS(6903), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [171234] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6932), 1,
      anon_sym_DASH_GT,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(6944), 1,
      anon_sym_requires,
    ACTIONS(9053), 1,
      anon_sym___attribute__,
    ACTIONS(9056), 1,
      anon_sym___attribute,
    ACTIONS(9059), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    STATE(4874), 1,
      sym_ref_qualifier,
    STATE(5497), 1,
      sym_trailing_return_type,
    STATE(5583), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5208), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9051), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [171321] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7722), 1,
      sym_literal_suffix,
    ACTIONS(4043), 17,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(4035), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [171368] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4586), 1,
      anon_sym_RBRACK,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    ACTIONS(8652), 1,
      anon_sym_PIPE,
    ACTIONS(8656), 1,
      anon_sym_AMP,
    ACTIONS(8662), 1,
      anon_sym_GT_EQ,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8672), 1,
      anon_sym_bitor,
    ACTIONS(8674), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8648), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8650), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8654), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8658), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8660), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [171459] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4730), 1,
      anon_sym_RBRACK,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    ACTIONS(8652), 1,
      anon_sym_PIPE,
    ACTIONS(8656), 1,
      anon_sym_AMP,
    ACTIONS(8662), 1,
      anon_sym_GT_EQ,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8672), 1,
      anon_sym_bitor,
    ACTIONS(8674), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8648), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8650), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8654), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8658), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8660), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [171550] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(5708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7156), 1,
      anon_sym_STAR,
    ACTIONS(7158), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7160), 1,
      anon_sym_AMP,
    STATE(5207), 1,
      sym_ms_call_modifier,
    STATE(5406), 1,
      sym__declarator,
    STATE(5765), 1,
      sym__scope_resolution,
    STATE(7253), 1,
      sym_init_declarator,
    STATE(8182), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1779), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [171631] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4746), 1,
      anon_sym_RBRACK,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    ACTIONS(8652), 1,
      anon_sym_PIPE,
    ACTIONS(8656), 1,
      anon_sym_AMP,
    ACTIONS(8662), 1,
      anon_sym_GT_EQ,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8672), 1,
      anon_sym_bitor,
    ACTIONS(8674), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8648), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8650), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8654), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8658), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8660), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [171722] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8097), 1,
      sym_identifier,
    ACTIONS(8099), 1,
      anon_sym_LPAREN2,
    ACTIONS(8101), 1,
      anon_sym_STAR,
    ACTIONS(8103), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8105), 1,
      anon_sym_AMP,
    ACTIONS(8111), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2136), 1,
      sym__type_declarator,
    STATE(2258), 1,
      sym_pointer_type_declarator,
    STATE(8208), 1,
      sym_ms_based_modifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8109), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2186), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [171795] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(9064), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [171886] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(9066), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [171977] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4725), 1,
      anon_sym_RBRACK,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    ACTIONS(8652), 1,
      anon_sym_PIPE,
    ACTIONS(8656), 1,
      anon_sym_AMP,
    ACTIONS(8662), 1,
      anon_sym_GT_EQ,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8672), 1,
      anon_sym_bitor,
    ACTIONS(8674), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8648), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8650), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8654), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8658), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8660), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [172068] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(9068), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [172159] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4595), 1,
      anon_sym_RBRACK,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    ACTIONS(8652), 1,
      anon_sym_PIPE,
    ACTIONS(8656), 1,
      anon_sym_AMP,
    ACTIONS(8662), 1,
      anon_sym_GT_EQ,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8672), 1,
      anon_sym_bitor,
    ACTIONS(8674), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8648), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8650), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8654), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8658), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8660), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [172250] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8097), 1,
      sym_identifier,
    ACTIONS(8099), 1,
      anon_sym_LPAREN2,
    ACTIONS(8111), 1,
      sym_primitive_type,
    ACTIONS(8125), 1,
      anon_sym_STAR,
    ACTIONS(8127), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8129), 1,
      anon_sym_AMP,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2258), 1,
      sym_pointer_type_declarator,
    STATE(6112), 1,
      sym__type_declarator,
    STATE(8147), 1,
      sym_ms_based_modifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8109), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2186), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [172323] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4565), 1,
      anon_sym_RBRACK,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    ACTIONS(8652), 1,
      anon_sym_PIPE,
    ACTIONS(8656), 1,
      anon_sym_AMP,
    ACTIONS(8662), 1,
      anon_sym_GT_EQ,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8672), 1,
      anon_sym_bitor,
    ACTIONS(8674), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8648), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8650), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8654), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8658), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8660), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [172414] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(9070), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [172505] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5506), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5508), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [172550] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8097), 1,
      sym_identifier,
    ACTIONS(8099), 1,
      anon_sym_LPAREN2,
    ACTIONS(8111), 1,
      sym_primitive_type,
    ACTIONS(8125), 1,
      anon_sym_STAR,
    ACTIONS(8127), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8129), 1,
      anon_sym_AMP,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2258), 1,
      sym_pointer_type_declarator,
    STATE(6202), 1,
      sym__type_declarator,
    STATE(8147), 1,
      sym_ms_based_modifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8109), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2186), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [172623] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5529), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5531), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [172668] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4555), 1,
      anon_sym_RBRACK,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    ACTIONS(8652), 1,
      anon_sym_PIPE,
    ACTIONS(8656), 1,
      anon_sym_AMP,
    ACTIONS(8662), 1,
      anon_sym_GT_EQ,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8672), 1,
      anon_sym_bitor,
    ACTIONS(8674), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8648), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8650), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8654), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8658), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8660), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [172759] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5541), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5543), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [172804] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8097), 1,
      sym_identifier,
    ACTIONS(8099), 1,
      anon_sym_LPAREN2,
    ACTIONS(8111), 1,
      sym_primitive_type,
    ACTIONS(8125), 1,
      anon_sym_STAR,
    ACTIONS(8127), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8129), 1,
      anon_sym_AMP,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2258), 1,
      sym_pointer_type_declarator,
    STATE(6158), 1,
      sym__type_declarator,
    STATE(8147), 1,
      sym_ms_based_modifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8109), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2186), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [172877] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(9072), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [172968] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5545), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5547), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [173013] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5549), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5551), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [173058] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5553), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5555), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [173103] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8131), 1,
      sym_identifier,
    ACTIONS(8133), 1,
      anon_sym_LPAREN2,
    ACTIONS(8143), 1,
      sym_primitive_type,
    ACTIONS(8167), 1,
      anon_sym_STAR,
    ACTIONS(8169), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8171), 1,
      anon_sym_AMP,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(5952), 1,
      sym_pointer_type_declarator,
    STATE(6179), 1,
      sym__type_declarator,
    STATE(8076), 1,
      sym_ms_based_modifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8141), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5950), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [173176] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5578), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5580), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [173221] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8131), 1,
      sym_identifier,
    ACTIONS(8133), 1,
      anon_sym_LPAREN2,
    ACTIONS(8143), 1,
      sym_primitive_type,
    ACTIONS(8167), 1,
      anon_sym_STAR,
    ACTIONS(8169), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8171), 1,
      anon_sym_AMP,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(5952), 1,
      sym_pointer_type_declarator,
    STATE(6177), 1,
      sym__type_declarator,
    STATE(8076), 1,
      sym_ms_based_modifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8141), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5950), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [173294] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5498), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5500), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [173339] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8131), 1,
      sym_identifier,
    ACTIONS(8133), 1,
      anon_sym_LPAREN2,
    ACTIONS(8143), 1,
      sym_primitive_type,
    ACTIONS(8167), 1,
      anon_sym_STAR,
    ACTIONS(8169), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8171), 1,
      anon_sym_AMP,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(5952), 1,
      sym_pointer_type_declarator,
    STATE(6189), 1,
      sym__type_declarator,
    STATE(8076), 1,
      sym_ms_based_modifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8141), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5950), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [173412] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5596), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5598), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [173457] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5680), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5682), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [173502] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5498), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5500), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [173547] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8131), 1,
      sym_identifier,
    ACTIONS(8133), 1,
      anon_sym_LPAREN2,
    ACTIONS(8135), 1,
      anon_sym_STAR,
    ACTIONS(8137), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8139), 1,
      anon_sym_AMP,
    ACTIONS(8143), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(5830), 1,
      sym__type_declarator,
    STATE(5952), 1,
      sym_pointer_type_declarator,
    STATE(7940), 1,
      sym_ms_based_modifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8141), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5950), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [173620] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5648), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5650), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [173665] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8175), 1,
      anon_sym_STAR,
    ACTIONS(8177), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8179), 1,
      anon_sym_AMP,
    STATE(3113), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6443), 1,
      sym__abstract_declarator,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8300), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [173736] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8175), 1,
      anon_sym_STAR,
    ACTIONS(8177), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8179), 1,
      anon_sym_AMP,
    STATE(3113), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6455), 1,
      sym__abstract_declarator,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5698), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [173807] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8175), 1,
      anon_sym_STAR,
    ACTIONS(8177), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8179), 1,
      anon_sym_AMP,
    STATE(3113), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6446), 1,
      sym__abstract_declarator,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8296), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [173878] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8175), 1,
      anon_sym_STAR,
    ACTIONS(8177), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8179), 1,
      anon_sym_AMP,
    STATE(3113), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6459), 1,
      sym__abstract_declarator,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6632), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [173949] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(9074), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [174040] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    ACTIONS(8652), 1,
      anon_sym_PIPE,
    ACTIONS(8656), 1,
      anon_sym_AMP,
    ACTIONS(8662), 1,
      anon_sym_GT_EQ,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8672), 1,
      anon_sym_bitor,
    ACTIONS(8674), 1,
      anon_sym_bitand,
    ACTIONS(9076), 1,
      anon_sym_RBRACK,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8648), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8650), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8654), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8658), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8660), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [174131] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(5708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7156), 1,
      anon_sym_STAR,
    ACTIONS(7158), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7160), 1,
      anon_sym_AMP,
    STATE(5220), 1,
      sym_ms_call_modifier,
    STATE(5508), 1,
      sym__declarator,
    STATE(5765), 1,
      sym__scope_resolution,
    STATE(7213), 1,
      sym_init_declarator,
    STATE(8182), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1779), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [174212] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(9078), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [174303] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4642), 1,
      anon_sym_RBRACK,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    ACTIONS(8652), 1,
      anon_sym_PIPE,
    ACTIONS(8656), 1,
      anon_sym_AMP,
    ACTIONS(8662), 1,
      anon_sym_GT_EQ,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8672), 1,
      anon_sym_bitor,
    ACTIONS(8674), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8648), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8650), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8654), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8658), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8660), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [174394] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8097), 1,
      sym_identifier,
    ACTIONS(8099), 1,
      anon_sym_LPAREN2,
    ACTIONS(8111), 1,
      sym_primitive_type,
    ACTIONS(8113), 1,
      anon_sym_STAR,
    ACTIONS(8115), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8117), 1,
      anon_sym_AMP,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2258), 1,
      sym_pointer_type_declarator,
    STATE(6624), 1,
      sym__type_declarator,
    STATE(8327), 1,
      sym_ms_based_modifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8109), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2186), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [174467] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5646), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [174512] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5660), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5662), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [174557] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8097), 1,
      sym_identifier,
    ACTIONS(8099), 1,
      anon_sym_LPAREN2,
    ACTIONS(8111), 1,
      sym_primitive_type,
    ACTIONS(8113), 1,
      anon_sym_STAR,
    ACTIONS(8115), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8117), 1,
      anon_sym_AMP,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2258), 1,
      sym_pointer_type_declarator,
    STATE(6643), 1,
      sym__type_declarator,
    STATE(8327), 1,
      sym_ms_based_modifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8109), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2186), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [174630] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5664), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5666), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [174675] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4644), 1,
      anon_sym_RBRACK,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    ACTIONS(8652), 1,
      anon_sym_PIPE,
    ACTIONS(8656), 1,
      anon_sym_AMP,
    ACTIONS(8662), 1,
      anon_sym_GT_EQ,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8672), 1,
      anon_sym_bitor,
    ACTIONS(8674), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8648), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8650), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8654), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8658), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8660), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [174766] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8097), 1,
      sym_identifier,
    ACTIONS(8099), 1,
      anon_sym_LPAREN2,
    ACTIONS(8111), 1,
      sym_primitive_type,
    ACTIONS(8113), 1,
      anon_sym_STAR,
    ACTIONS(8115), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8117), 1,
      anon_sym_AMP,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2258), 1,
      sym_pointer_type_declarator,
    STATE(6647), 1,
      sym__type_declarator,
    STATE(8327), 1,
      sym_ms_based_modifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8109), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2186), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [174839] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5672), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5674), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [174884] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5564), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5566), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [174929] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(9080), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [175020] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4676), 1,
      anon_sym_RBRACK,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    ACTIONS(8652), 1,
      anon_sym_PIPE,
    ACTIONS(8656), 1,
      anon_sym_AMP,
    ACTIONS(8662), 1,
      anon_sym_GT_EQ,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8672), 1,
      anon_sym_bitor,
    ACTIONS(8674), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8648), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8650), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8654), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8658), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8660), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [175111] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5568), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5570), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [175156] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5572), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5574), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [175201] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(5708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7156), 1,
      anon_sym_STAR,
    ACTIONS(7158), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7160), 1,
      anon_sym_AMP,
    STATE(5204), 1,
      sym_ms_call_modifier,
    STATE(5498), 1,
      sym__declarator,
    STATE(5765), 1,
      sym__scope_resolution,
    STATE(7151), 1,
      sym_init_declarator,
    STATE(8182), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1779), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [175282] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(5708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7156), 1,
      anon_sym_STAR,
    ACTIONS(7158), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7160), 1,
      anon_sym_AMP,
    STATE(5185), 1,
      sym_ms_call_modifier,
    STATE(5526), 1,
      sym__declarator,
    STATE(5765), 1,
      sym__scope_resolution,
    STATE(7280), 1,
      sym_init_declarator,
    STATE(8182), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1779), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [175363] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5652), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5654), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [175408] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5533), 5,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym___asm,
    ACTIONS(5535), 32,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [175453] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8181), 1,
      sym_identifier,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8185), 1,
      anon_sym_STAR,
    ACTIONS(8187), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8189), 1,
      anon_sym_AMP,
    ACTIONS(8193), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2983), 1,
      sym__type_declarator,
    STATE(3404), 1,
      sym_pointer_type_declarator,
    STATE(8244), 1,
      sym_ms_based_modifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8191), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3392), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [175526] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(5708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7156), 1,
      anon_sym_STAR,
    ACTIONS(7158), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7160), 1,
      anon_sym_AMP,
    STATE(5193), 1,
      sym_ms_call_modifier,
    STATE(5456), 1,
      sym__declarator,
    STATE(5765), 1,
      sym__scope_resolution,
    STATE(7400), 1,
      sym_init_declarator,
    STATE(8182), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1779), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [175607] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6932), 1,
      anon_sym_DASH_GT,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(9053), 1,
      anon_sym___attribute__,
    ACTIONS(9056), 1,
      anon_sym___attribute,
    ACTIONS(9059), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9085), 1,
      anon_sym_requires,
    STATE(4884), 1,
      sym_ref_qualifier,
    STATE(5411), 1,
      sym_trailing_return_type,
    STATE(5668), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9082), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5198), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9051), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [175694] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(5708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7156), 1,
      anon_sym_STAR,
    ACTIONS(7158), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7160), 1,
      anon_sym_AMP,
    STATE(5228), 1,
      sym_ms_call_modifier,
    STATE(5491), 1,
      sym__declarator,
    STATE(5765), 1,
      sym__scope_resolution,
    STATE(7094), 1,
      sym_init_declarator,
    STATE(8182), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1779), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [175775] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4735), 1,
      anon_sym_RBRACK,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    ACTIONS(8652), 1,
      anon_sym_PIPE,
    ACTIONS(8656), 1,
      anon_sym_AMP,
    ACTIONS(8662), 1,
      anon_sym_GT_EQ,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8672), 1,
      anon_sym_bitor,
    ACTIONS(8674), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8648), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8650), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8654), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8658), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8660), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [175866] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4737), 1,
      anon_sym_RBRACK,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    ACTIONS(8652), 1,
      anon_sym_PIPE,
    ACTIONS(8656), 1,
      anon_sym_AMP,
    ACTIONS(8662), 1,
      anon_sym_GT_EQ,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8672), 1,
      anon_sym_bitor,
    ACTIONS(8674), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8648), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8650), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8654), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8658), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8660), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [175957] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(9088), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [176048] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(9090), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [176139] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6295), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6297), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [176184] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8097), 1,
      sym_identifier,
    ACTIONS(8099), 1,
      anon_sym_LPAREN2,
    ACTIONS(8101), 1,
      anon_sym_STAR,
    ACTIONS(8103), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8105), 1,
      anon_sym_AMP,
    ACTIONS(8111), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2121), 1,
      sym__type_declarator,
    STATE(2258), 1,
      sym_pointer_type_declarator,
    STATE(8208), 1,
      sym_ms_based_modifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8109), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2186), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [176257] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(8145), 1,
      anon_sym_STAR,
    ACTIONS(8147), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8149), 1,
      anon_sym_AMP,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(3191), 1,
      sym_parameter_list,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(6464), 1,
      sym__abstract_declarator,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8300), 6,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [176328] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(8145), 1,
      anon_sym_STAR,
    ACTIONS(8147), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8149), 1,
      anon_sym_AMP,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(3191), 1,
      sym_parameter_list,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(6466), 1,
      sym__abstract_declarator,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(5698), 6,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [176399] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(8145), 1,
      anon_sym_STAR,
    ACTIONS(8147), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8149), 1,
      anon_sym_AMP,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(3191), 1,
      sym_parameter_list,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(6467), 1,
      sym__abstract_declarator,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8296), 6,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [176470] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(65), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(8145), 1,
      anon_sym_STAR,
    ACTIONS(8147), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8149), 1,
      anon_sym_AMP,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(3191), 1,
      sym_parameter_list,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(6468), 1,
      sym__abstract_declarator,
    ACTIONS(7147), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6632), 6,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    ACTIONS(7140), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [176541] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(9092), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [176632] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8554), 1,
      anon_sym_LT,
    STATE(1570), 1,
      sym_template_argument_list,
    ACTIONS(4059), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(5720), 30,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      anon_sym_COLON,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
  [176683] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(9094), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [176774] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(4157), 1,
      anon_sym_LPAREN2,
    ACTIONS(4159), 1,
      anon_sym_STAR,
    ACTIONS(4161), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4163), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      sym_identifier,
    ACTIONS(5710), 1,
      anon_sym_LBRACK,
    ACTIONS(6180), 1,
      anon_sym_COLON_COLON,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(5712), 1,
      sym__scope_resolution,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6552), 1,
      sym__declarator,
    STATE(6800), 1,
      sym__abstract_declarator,
    STATE(7870), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [176857] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    ACTIONS(8652), 1,
      anon_sym_PIPE,
    ACTIONS(8656), 1,
      anon_sym_AMP,
    ACTIONS(8662), 1,
      anon_sym_GT_EQ,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8672), 1,
      anon_sym_bitor,
    ACTIONS(8674), 1,
      anon_sym_bitand,
    ACTIONS(9096), 1,
      anon_sym_RBRACK,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8648), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8650), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8654), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8658), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8660), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [176948] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(9098), 1,
      anon_sym_COMMA,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [177039] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(8705), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [177130] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8131), 1,
      sym_identifier,
    ACTIONS(8133), 1,
      anon_sym_LPAREN2,
    ACTIONS(8135), 1,
      anon_sym_STAR,
    ACTIONS(8137), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8139), 1,
      anon_sym_AMP,
    ACTIONS(8143), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(5786), 1,
      sym__type_declarator,
    STATE(5952), 1,
      sym_pointer_type_declarator,
    STATE(7940), 1,
      sym_ms_based_modifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8141), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5950), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [177203] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(7619), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8782), 1,
      anon_sym_SLASH,
    ACTIONS(8788), 1,
      anon_sym_PIPE,
    ACTIONS(8792), 1,
      anon_sym_AMP,
    ACTIONS(8798), 1,
      anon_sym_GT_EQ,
    ACTIONS(8804), 1,
      anon_sym_QMARK,
    ACTIONS(8806), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8808), 1,
      anon_sym_bitor,
    ACTIONS(8810), 1,
      anon_sym_bitand,
    ACTIONS(9100), 1,
      anon_sym_COLON,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(7621), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8778), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8780), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8784), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8786), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8790), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8800), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8794), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8796), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [177294] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(9102), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [177385] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(9104), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [177476] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(9106), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [177567] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(9108), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [177658] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(9110), 1,
      anon_sym_SEMI,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [177749] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4625), 1,
      anon_sym_RBRACK,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8646), 1,
      anon_sym_SLASH,
    ACTIONS(8652), 1,
      anon_sym_PIPE,
    ACTIONS(8656), 1,
      anon_sym_AMP,
    ACTIONS(8662), 1,
      anon_sym_GT_EQ,
    ACTIONS(8668), 1,
      anon_sym_QMARK,
    ACTIONS(8670), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8672), 1,
      anon_sym_bitor,
    ACTIONS(8674), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8642), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8644), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8648), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8650), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8654), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8664), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8658), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8660), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [177840] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(9112), 1,
      anon_sym_COMMA,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [177931] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(9114), 1,
      anon_sym_COMMA,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [178022] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(9116), 1,
      anon_sym_COMMA,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [178113] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(9118), 1,
      anon_sym_COMMA,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [178204] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(9120), 1,
      anon_sym_COMMA,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [178295] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    ACTIONS(9122), 1,
      anon_sym_RPAREN,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [178386] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8634), 1,
      anon_sym___attribute__,
    ACTIONS(8636), 1,
      anon_sym___attribute,
    ACTIONS(8832), 1,
      anon_sym_LBRACE,
    STATE(4825), 1,
      sym_enumerator_list,
    STATE(4868), 1,
      sym_attribute_specifier,
    ACTIONS(5834), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5836), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [178440] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6447), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6449), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [178484] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6431), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6433), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [178528] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4043), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(4035), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [178572] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5305), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(2721), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [178616] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6435), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6437), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [178660] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6451), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6453), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [178704] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9124), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9126), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6092), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6094), 21,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [178752] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7096), 1,
      sym_identifier,
    ACTIONS(7098), 1,
      anon_sym_STAR,
    ACTIONS(7100), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7102), 1,
      anon_sym_AMP,
    ACTIONS(7104), 1,
      anon_sym_COLON_COLON,
    STATE(5216), 1,
      sym_ms_call_modifier,
    STATE(5750), 1,
      sym__scope_resolution,
    STATE(6403), 1,
      sym__declarator,
    STATE(8303), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1779), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [178830] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6387), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6389), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [178874] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3754), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(3750), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [178918] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6455), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6457), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [178962] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6459), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6461), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [179006] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6477), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6479), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [179050] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6427), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6429), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [179094] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(3196), 1,
      anon_sym_STAR,
    ACTIONS(3198), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      sym_identifier,
    ACTIONS(6180), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    STATE(5218), 1,
      sym_ms_call_modifier,
    STATE(5712), 1,
      sym__scope_resolution,
    STATE(6536), 1,
      sym__declarator,
    STATE(7870), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1779), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [179172] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9126), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6057), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6059), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [179218] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6391), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6393), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [179262] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6577), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6579), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [179306] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6469), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6471), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [179350] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4147), 1,
      anon_sym_SEMI,
    ACTIONS(4895), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5868), 1,
      anon_sym_LPAREN2,
    ACTIONS(5871), 1,
      anon_sym_LBRACK,
    ACTIONS(4043), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(4035), 23,
      anon_sym_DOT_DOT_DOT,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [179402] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6473), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6475), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [179446] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(6944), 1,
      anon_sym_requires,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(6984), 1,
      anon_sym_DASH_GT,
    ACTIONS(9059), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    STATE(4907), 1,
      sym_ref_qualifier,
    STATE(5497), 1,
      sym_trailing_return_type,
    STATE(5853), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5231), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9051), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [179532] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(7132), 1,
      anon_sym_DASH_GT,
    ACTIONS(9059), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9085), 1,
      anon_sym_requires,
    ACTIONS(9131), 1,
      anon_sym___asm,
    STATE(4903), 1,
      sym_ref_qualifier,
    STATE(5411), 1,
      sym_trailing_return_type,
    STATE(5674), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(9082), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9128), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5244), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9051), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [179618] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7096), 1,
      sym_identifier,
    ACTIONS(7098), 1,
      anon_sym_STAR,
    ACTIONS(7100), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7102), 1,
      anon_sym_AMP,
    ACTIONS(7104), 1,
      anon_sym_COLON_COLON,
    STATE(5219), 1,
      sym_ms_call_modifier,
    STATE(5750), 1,
      sym__scope_resolution,
    STATE(6406), 1,
      sym__declarator,
    STATE(8303), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1779), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [179696] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7096), 1,
      sym_identifier,
    ACTIONS(7098), 1,
      anon_sym_STAR,
    ACTIONS(7100), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7102), 1,
      anon_sym_AMP,
    ACTIONS(7104), 1,
      anon_sym_COLON_COLON,
    STATE(5221), 1,
      sym_ms_call_modifier,
    STATE(5750), 1,
      sym__scope_resolution,
    STATE(6409), 1,
      sym__declarator,
    STATE(8303), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1779), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [179774] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6485), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6487), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [179818] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6547), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6549), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [179862] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6543), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6545), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [179906] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4147), 1,
      anon_sym_SEMI,
    ACTIONS(6899), 1,
      sym_literal_suffix,
    ACTIONS(4043), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DOT,
    ACTIONS(4035), 19,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [179954] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8634), 1,
      anon_sym___attribute__,
    ACTIONS(8636), 1,
      anon_sym___attribute,
    ACTIONS(8832), 1,
      anon_sym_LBRACE,
    STATE(4801), 1,
      sym_enumerator_list,
    STATE(4850), 1,
      sym_attribute_specifier,
    ACTIONS(5848), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5850), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [180008] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7096), 1,
      sym_identifier,
    ACTIONS(7098), 1,
      anon_sym_STAR,
    ACTIONS(7100), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7102), 1,
      anon_sym_AMP,
    ACTIONS(7104), 1,
      anon_sym_COLON_COLON,
    STATE(5201), 1,
      sym_ms_call_modifier,
    STATE(5750), 1,
      sym__scope_resolution,
    STATE(6382), 1,
      sym__declarator,
    STATE(8303), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1779), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [180086] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(6944), 1,
      anon_sym_requires,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(7132), 1,
      anon_sym_DASH_GT,
    ACTIONS(9059), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9131), 1,
      anon_sym___asm,
    STATE(4908), 1,
      sym_ref_qualifier,
    STATE(5497), 1,
      sym_trailing_return_type,
    STATE(5655), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9128), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5240), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9051), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [180172] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7096), 1,
      sym_identifier,
    ACTIONS(7098), 1,
      anon_sym_STAR,
    ACTIONS(7100), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7102), 1,
      anon_sym_AMP,
    ACTIONS(7104), 1,
      anon_sym_COLON_COLON,
    STATE(5188), 1,
      sym_ms_call_modifier,
    STATE(5750), 1,
      sym__scope_resolution,
    STATE(6358), 1,
      sym__declarator,
    STATE(8303), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1779), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [180250] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6419), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6421), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [180294] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7149), 1,
      anon_sym_DASH_GT,
    ACTIONS(7162), 1,
      anon_sym_requires,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9131), 1,
      anon_sym___asm,
    ACTIONS(9134), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(4900), 1,
      sym_ref_qualifier,
    STATE(5366), 1,
      sym_trailing_return_type,
    STATE(5633), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9128), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5234), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9051), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [180380] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7096), 1,
      sym_identifier,
    ACTIONS(7098), 1,
      anon_sym_STAR,
    ACTIONS(7100), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7102), 1,
      anon_sym_AMP,
    ACTIONS(7104), 1,
      anon_sym_COLON_COLON,
    STATE(5195), 1,
      sym_ms_call_modifier,
    STATE(5750), 1,
      sym__scope_resolution,
    STATE(6333), 1,
      sym__declarator,
    STATE(8303), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1779), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [180458] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7096), 1,
      sym_identifier,
    ACTIONS(7098), 1,
      anon_sym_STAR,
    ACTIONS(7100), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7102), 1,
      anon_sym_AMP,
    ACTIONS(7104), 1,
      anon_sym_COLON_COLON,
    STATE(5202), 1,
      sym_ms_call_modifier,
    STATE(5750), 1,
      sym__scope_resolution,
    STATE(6340), 1,
      sym__declarator,
    STATE(8303), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1779), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [180536] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6423), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6425), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [180580] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6493), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6495), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [180624] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6497), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6499), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [180668] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6505), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6507), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [180712] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6509), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6511), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [180756] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6513), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6515), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [180800] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    ACTIONS(6267), 1,
      anon_sym_LBRACK,
    ACTIONS(6271), 1,
      anon_sym_DOT,
    ACTIONS(8316), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(8510), 1,
      anon_sym_SLASH,
    ACTIONS(8520), 1,
      anon_sym_PIPE,
    ACTIONS(8524), 1,
      anon_sym_AMP,
    ACTIONS(8530), 1,
      anon_sym_GT_EQ,
    ACTIONS(8536), 1,
      anon_sym_QMARK,
    ACTIONS(8538), 1,
      anon_sym_LT_EQ_GT,
    ACTIONS(8540), 1,
      anon_sym_bitor,
    ACTIONS(8542), 1,
      anon_sym_bitand,
    STATE(2380), 1,
      sym_argument_list,
    STATE(2381), 1,
      sym_subscript_argument_list,
    ACTIONS(6273), 2,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
    ACTIONS(7849), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(8506), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(8508), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8512), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(8516), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(8518), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(8522), 2,
      anon_sym_CARET,
      anon_sym_xor,
    ACTIONS(8526), 3,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_not_eq,
    ACTIONS(8528), 3,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [180888] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6535), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6537), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [180932] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6517), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6519), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [180976] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6521), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6523), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [181020] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6551), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6553), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [181064] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6924), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(8204), 1,
      anon_sym_STAR,
    ACTIONS(8206), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8208), 1,
      anon_sym_AMP,
    STATE(3434), 1,
      sym_parameter_list,
    STATE(3934), 1,
      sym_alignas_qualifier,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(6479), 1,
      sym__abstract_declarator,
    ACTIONS(6926), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3744), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8300), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6911), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [181134] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6924), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(8204), 1,
      anon_sym_STAR,
    ACTIONS(8206), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8208), 1,
      anon_sym_AMP,
    STATE(3434), 1,
      sym_parameter_list,
    STATE(3934), 1,
      sym_alignas_qualifier,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(6489), 1,
      sym__abstract_declarator,
    ACTIONS(6926), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3744), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5698), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6911), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [181204] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6924), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(8204), 1,
      anon_sym_STAR,
    ACTIONS(8206), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8208), 1,
      anon_sym_AMP,
    STATE(3434), 1,
      sym_parameter_list,
    STATE(3934), 1,
      sym_alignas_qualifier,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(6491), 1,
      sym__abstract_declarator,
    ACTIONS(6926), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3744), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8296), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6911), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [181274] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6924), 1,
      anon_sym_const,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(8204), 1,
      anon_sym_STAR,
    ACTIONS(8206), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8208), 1,
      anon_sym_AMP,
    STATE(3434), 1,
      sym_parameter_list,
    STATE(3934), 1,
      sym_alignas_qualifier,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(6497), 1,
      sym__abstract_declarator,
    ACTIONS(6926), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(3744), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6632), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(6911), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [181344] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6555), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6557), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [181388] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6559), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6561), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [181432] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7149), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9131), 1,
      anon_sym___asm,
    ACTIONS(9134), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9137), 1,
      anon_sym_requires,
    STATE(4922), 1,
      sym_ref_qualifier,
    STATE(5380), 1,
      sym_trailing_return_type,
    STATE(5559), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(9082), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9128), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5233), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9051), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [181518] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6567), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6569), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [181562] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6571), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6573), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [181606] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(6984), 1,
      anon_sym_DASH_GT,
    ACTIONS(9059), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9085), 1,
      anon_sym_requires,
    STATE(4901), 1,
      sym_ref_qualifier,
    STATE(5411), 1,
      sym_trailing_return_type,
    STATE(5894), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9082), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5246), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9051), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [181692] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6443), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6445), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [181736] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6481), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6483), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [181780] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6525), 11,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT_GT,
      anon_sym_DOT,
    ACTIONS(6527), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
      anon_sym_GT2,
  [181824] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9140), 1,
      anon_sym_COMMA,
    ACTIONS(9142), 1,
      anon_sym_RBRACK,
    ACTIONS(4043), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(4035), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [181872] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(8262), 1,
      sym_identifier,
    ACTIONS(8264), 1,
      anon_sym_LPAREN2,
    ACTIONS(8266), 1,
      anon_sym_STAR,
    ACTIONS(8268), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8270), 1,
      anon_sym_AMP,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(6089), 1,
      sym__field_declarator,
    STATE(6266), 1,
      sym_operator_name,
    STATE(7897), 1,
      sym_ms_based_modifier,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6285), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [181941] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5371), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5373), 32,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [181984] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8304), 1,
      sym_auto,
    ACTIONS(8306), 1,
      anon_sym_decltype,
    STATE(4865), 1,
      sym_decltype_auto,
    ACTIONS(5391), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5393), 29,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [182033] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5874), 1,
      anon_sym___attribute__,
    ACTIONS(5876), 1,
      anon_sym___attribute,
    ACTIONS(6065), 1,
      anon_sym_LBRACE,
    ACTIONS(9145), 1,
      anon_sym_COLON,
    STATE(1851), 1,
      sym_attribute_specifier,
    STATE(2241), 1,
      sym__enum_base_clause,
    STATE(2294), 1,
      sym_enumerator_list,
    ACTIONS(6245), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6247), 26,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [182090] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8634), 1,
      anon_sym___attribute__,
    ACTIONS(8636), 1,
      anon_sym___attribute,
    STATE(4866), 1,
      sym_attribute_specifier,
    ACTIONS(5905), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5907), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [182139] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7273), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9150), 1,
      anon_sym_requires,
    STATE(4927), 1,
      sym_ref_qualifier,
    STATE(5931), 1,
      sym_trailing_return_type,
    STATE(6092), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9147), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5263), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9051), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [182224] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8634), 1,
      anon_sym___attribute__,
    ACTIONS(8636), 1,
      anon_sym___attribute,
    STATE(4877), 1,
      sym_attribute_specifier,
    ACTIONS(5951), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5953), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [182273] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7280), 1,
      anon_sym_DASH_GT,
    ACTIONS(7284), 1,
      anon_sym_requires,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9153), 1,
      anon_sym___attribute__,
    ACTIONS(9156), 1,
      anon_sym___attribute,
    STATE(4932), 1,
      sym_ref_qualifier,
    STATE(5807), 1,
      sym_trailing_return_type,
    STATE(5864), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5250), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9051), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
  [182358] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7280), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9153), 1,
      anon_sym___attribute__,
    ACTIONS(9156), 1,
      anon_sym___attribute,
    ACTIONS(9159), 1,
      anon_sym_requires,
    STATE(4944), 1,
      sym_ref_qualifier,
    STATE(5838), 1,
      sym_trailing_return_type,
    STATE(5868), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9147), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5266), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9051), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
  [182443] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7273), 1,
      anon_sym_DASH_GT,
    ACTIONS(7326), 1,
      anon_sym_requires,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    STATE(4969), 1,
      sym_ref_qualifier,
    STATE(5965), 1,
      sym_trailing_return_type,
    STATE(6055), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5277), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9051), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [182528] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7174), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9159), 1,
      anon_sym_requires,
    STATE(4974), 1,
      sym_ref_qualifier,
    STATE(5838), 1,
      sym_trailing_return_type,
    STATE(6027), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9147), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5272), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9051), 5,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [182613] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7174), 1,
      anon_sym_DASH_GT,
    ACTIONS(7284), 1,
      anon_sym_requires,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    STATE(4985), 1,
      sym_ref_qualifier,
    STATE(5807), 1,
      sym_trailing_return_type,
    STATE(6095), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5256), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9051), 5,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [182698] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6065), 1,
      anon_sym_LBRACE,
    ACTIONS(9162), 1,
      anon_sym_COLON,
    STATE(1851), 1,
      sym_attribute_specifier,
    STATE(4904), 1,
      sym__enum_base_clause,
    STATE(5092), 1,
      sym_enumerator_list,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6247), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(6245), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [182753] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8284), 1,
      anon_sym_STAR,
    ACTIONS(8286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8288), 1,
      anon_sym_AMP,
    STATE(3053), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6562), 1,
      sym__abstract_declarator,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6632), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [182822] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8634), 1,
      anon_sym___attribute__,
    ACTIONS(8636), 1,
      anon_sym___attribute,
    STATE(4896), 1,
      sym_attribute_specifier,
    ACTIONS(5901), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5903), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [182871] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6218), 1,
      anon_sym___attribute__,
    ACTIONS(6220), 1,
      anon_sym___attribute,
    ACTIONS(6581), 1,
      anon_sym_LBRACE,
    ACTIONS(9164), 1,
      anon_sym_COLON,
    STATE(2497), 1,
      sym__enum_base_clause,
    STATE(2546), 1,
      sym_enumerator_list,
    STATE(2643), 1,
      sym_attribute_specifier,
    ACTIONS(6245), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6247), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [182928] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(4879), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9166), 1,
      sym_identifier,
    ACTIONS(9168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9172), 1,
      anon_sym_EQ,
    STATE(2158), 1,
      sym_template_type,
    STATE(2464), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5419), 1,
      sym_ms_declspec_modifier,
    STATE(6511), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9170), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(2484), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5423), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5134), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [183019] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8634), 1,
      anon_sym___attribute__,
    ACTIONS(8636), 1,
      anon_sym___attribute,
    STATE(4875), 1,
      sym_attribute_specifier,
    ACTIONS(5887), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5889), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [183068] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8634), 1,
      anon_sym___attribute__,
    ACTIONS(8636), 1,
      anon_sym___attribute,
    STATE(4853), 1,
      sym_attribute_specifier,
    ACTIONS(5976), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5978), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [183117] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8634), 1,
      anon_sym___attribute__,
    ACTIONS(8636), 1,
      anon_sym___attribute,
    STATE(4846), 1,
      sym_attribute_specifier,
    ACTIONS(5969), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5971), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [183166] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(8264), 1,
      anon_sym_LPAREN2,
    ACTIONS(8272), 1,
      sym_identifier,
    ACTIONS(8274), 1,
      anon_sym_STAR,
    ACTIONS(8276), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8278), 1,
      anon_sym_AMP,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(6574), 1,
      sym__field_declarator,
    STATE(6701), 1,
      sym_operator_name,
    STATE(7946), 1,
      sym_ms_based_modifier,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6285), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [183235] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8634), 1,
      anon_sym___attribute__,
    ACTIONS(8636), 1,
      anon_sym___attribute,
    STATE(4885), 1,
      sym_attribute_specifier,
    ACTIONS(5947), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5949), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [183284] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(5521), 1,
      anon_sym_const,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8020), 1,
      sym_auto,
    ACTIONS(8022), 1,
      anon_sym_decltype,
    ACTIONS(8083), 1,
      anon_sym_COLON,
    ACTIONS(8548), 1,
      anon_sym_STAR,
    ACTIONS(8550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8552), 1,
      anon_sym_AMP,
    STATE(1651), 1,
      sym_alignas_qualifier,
    STATE(1837), 1,
      sym_decltype_auto,
    STATE(3356), 1,
      sym_parameter_list,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6775), 1,
      sym__abstract_declarator,
    ACTIONS(8340), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4947), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8332), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [183359] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6463), 1,
      anon_sym_LT,
    STATE(1570), 1,
      sym_template_argument_list,
    STATE(4961), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5844), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(5842), 27,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [183410] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(8262), 1,
      sym_identifier,
    ACTIONS(8264), 1,
      anon_sym_LPAREN2,
    ACTIONS(8266), 1,
      anon_sym_STAR,
    ACTIONS(8268), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8270), 1,
      anon_sym_AMP,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(6015), 1,
      sym__field_declarator,
    STATE(6266), 1,
      sym_operator_name,
    STATE(7897), 1,
      sym_ms_based_modifier,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6285), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [183479] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(8264), 1,
      anon_sym_LPAREN2,
    ACTIONS(8272), 1,
      sym_identifier,
    ACTIONS(8274), 1,
      anon_sym_STAR,
    ACTIONS(8276), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8278), 1,
      anon_sym_AMP,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(6577), 1,
      sym__field_declarator,
    STATE(6701), 1,
      sym_operator_name,
    STATE(7946), 1,
      sym_ms_based_modifier,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6285), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [183548] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(8264), 1,
      anon_sym_LPAREN2,
    ACTIONS(8272), 1,
      sym_identifier,
    ACTIONS(8274), 1,
      anon_sym_STAR,
    ACTIONS(8276), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8278), 1,
      anon_sym_AMP,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(6579), 1,
      sym__field_declarator,
    STATE(6701), 1,
      sym_operator_name,
    STATE(7946), 1,
      sym_ms_based_modifier,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6285), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [183617] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8634), 1,
      anon_sym___attribute__,
    ACTIONS(8636), 1,
      anon_sym___attribute,
    STATE(4888), 1,
      sym_attribute_specifier,
    ACTIONS(5913), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5915), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [183666] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8634), 1,
      anon_sym___attribute__,
    ACTIONS(8636), 1,
      anon_sym___attribute,
    STATE(4889), 1,
      sym_attribute_specifier,
    ACTIONS(5917), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5919), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [183715] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6065), 1,
      anon_sym_LBRACE,
    ACTIONS(9162), 1,
      anon_sym_COLON,
    STATE(1805), 1,
      sym_attribute_specifier,
    STATE(4906), 1,
      sym__enum_base_clause,
    STATE(5095), 1,
      sym_enumerator_list,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(6163), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(6161), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [183770] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8634), 1,
      anon_sym___attribute__,
    ACTIONS(8636), 1,
      anon_sym___attribute,
    STATE(4899), 1,
      sym_attribute_specifier,
    ACTIONS(5980), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5982), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [183819] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7162), 1,
      anon_sym_requires,
    ACTIONS(7172), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9134), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9153), 1,
      anon_sym___attribute__,
    ACTIONS(9156), 1,
      anon_sym___attribute,
    STATE(4962), 1,
      sym_ref_qualifier,
    STATE(5366), 1,
      sym_trailing_return_type,
    STATE(5789), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5253), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9051), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
  [183904] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4147), 1,
      anon_sym_SEMI,
    ACTIONS(4043), 9,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
    ACTIONS(4035), 25,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_LT_EQ_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_bitor,
      anon_sym_xor,
      anon_sym_bitand,
      anon_sym_not_eq,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_DOT_STAR,
      anon_sym_DASH_GT,
  [183949] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7172), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9134), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9137), 1,
      anon_sym_requires,
    ACTIONS(9153), 1,
      anon_sym___attribute__,
    ACTIONS(9156), 1,
      anon_sym___attribute,
    STATE(4945), 1,
      sym_ref_qualifier,
    STATE(5380), 1,
      sym_trailing_return_type,
    STATE(5793), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9082), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5264), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9051), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
  [184034] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5365), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5431), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5433), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [184079] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(8262), 1,
      sym_identifier,
    ACTIONS(8264), 1,
      anon_sym_LPAREN2,
    ACTIONS(8266), 1,
      anon_sym_STAR,
    ACTIONS(8268), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8270), 1,
      anon_sym_AMP,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(6065), 1,
      sym__field_declarator,
    STATE(6266), 1,
      sym_operator_name,
    STATE(7897), 1,
      sym_ms_based_modifier,
    ACTIONS(3272), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(6285), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
    ACTIONS(3270), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [184148] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9174), 1,
      sym_identifier,
    ACTIONS(9180), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(4960), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6175), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4845), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4946), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(9177), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4948), 6,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6170), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [184207] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8284), 1,
      anon_sym_STAR,
    ACTIONS(8286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8288), 1,
      anon_sym_AMP,
    STATE(3053), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6593), 1,
      sym__abstract_declarator,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5698), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [184276] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(5521), 1,
      anon_sym_const,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8326), 1,
      anon_sym_STAR,
    ACTIONS(8328), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8330), 1,
      anon_sym_AMP,
    STATE(1651), 1,
      sym_alignas_qualifier,
    STATE(3373), 1,
      sym_parameter_list,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6565), 1,
      sym__abstract_declarator,
    ACTIONS(8340), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1617), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8300), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8332), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [184345] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(5521), 1,
      anon_sym_const,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8326), 1,
      anon_sym_STAR,
    ACTIONS(8328), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8330), 1,
      anon_sym_AMP,
    STATE(1651), 1,
      sym_alignas_qualifier,
    STATE(3373), 1,
      sym_parameter_list,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6535), 1,
      sym__abstract_declarator,
    ACTIONS(8340), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1617), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5698), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8332), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [184414] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(5521), 1,
      anon_sym_const,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8326), 1,
      anon_sym_STAR,
    ACTIONS(8328), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8330), 1,
      anon_sym_AMP,
    STATE(1651), 1,
      sym_alignas_qualifier,
    STATE(3373), 1,
      sym_parameter_list,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6568), 1,
      sym__abstract_declarator,
    ACTIONS(8340), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1617), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8296), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8332), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [184483] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(5521), 1,
      anon_sym_const,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8326), 1,
      anon_sym_STAR,
    ACTIONS(8328), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8330), 1,
      anon_sym_AMP,
    STATE(1651), 1,
      sym_alignas_qualifier,
    STATE(3373), 1,
      sym_parameter_list,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6557), 1,
      sym__abstract_declarator,
    ACTIONS(8340), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1617), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6632), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8332), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [184552] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5874), 1,
      anon_sym___attribute__,
    ACTIONS(5876), 1,
      anon_sym___attribute,
    ACTIONS(6065), 1,
      anon_sym_LBRACE,
    ACTIONS(9145), 1,
      anon_sym_COLON,
    STATE(1805), 1,
      sym_attribute_specifier,
    STATE(2196), 1,
      sym__enum_base_clause,
    STATE(2295), 1,
      sym_enumerator_list,
    ACTIONS(6161), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6163), 26,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [184609] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8634), 1,
      anon_sym___attribute__,
    ACTIONS(8636), 1,
      anon_sym___attribute,
    STATE(4897), 1,
      sym_attribute_specifier,
    ACTIONS(5986), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5988), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [184658] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7264), 1,
      anon_sym_DASH_GT,
    ACTIONS(7330), 1,
      anon_sym_requires,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9134), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(4939), 1,
      sym_ref_qualifier,
    STATE(5941), 1,
      sym__function_attributes_end,
    STATE(6183), 1,
      sym_trailing_return_type,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5251), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9051), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [184743] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8634), 1,
      anon_sym___attribute__,
    ACTIONS(8636), 1,
      anon_sym___attribute,
    STATE(4858), 1,
      sym_attribute_specifier,
    ACTIONS(5990), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5992), 30,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [184792] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6463), 1,
      anon_sym_LT,
    STATE(1570), 1,
      sym_template_argument_list,
    STATE(4130), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4033), 4,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
      anon_sym_COLON,
    ACTIONS(8195), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4041), 23,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [184845] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6218), 1,
      anon_sym___attribute__,
    ACTIONS(6220), 1,
      anon_sym___attribute,
    ACTIONS(6581), 1,
      anon_sym_LBRACE,
    ACTIONS(9164), 1,
      anon_sym_COLON,
    STATE(2502), 1,
      sym__enum_base_clause,
    STATE(2539), 1,
      sym_enumerator_list,
    STATE(2629), 1,
      sym_attribute_specifier,
    ACTIONS(6161), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6163), 26,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [184902] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(5521), 1,
      anon_sym_const,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8020), 1,
      sym_auto,
    ACTIONS(8022), 1,
      anon_sym_decltype,
    ACTIONS(8048), 1,
      anon_sym_COLON,
    ACTIONS(8548), 1,
      anon_sym_STAR,
    ACTIONS(8550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8552), 1,
      anon_sym_AMP,
    STATE(1651), 1,
      sym_alignas_qualifier,
    STATE(1837), 1,
      sym_decltype_auto,
    STATE(3356), 1,
      sym_parameter_list,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6755), 1,
      sym__abstract_declarator,
    ACTIONS(8340), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4955), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8332), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [184977] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7264), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9134), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9183), 1,
      anon_sym_requires,
    STATE(4941), 1,
      sym_ref_qualifier,
    STATE(5992), 1,
      sym__function_attributes_end,
    STATE(6110), 1,
      sym_trailing_return_type,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9082), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5270), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9051), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [185062] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9186), 1,
      sym_identifier,
    ACTIONS(9192), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(4968), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(6232), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4961), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(9189), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4963), 6,
      anon_sym_AMP,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6227), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [185121] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5510), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5512), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [185163] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5541), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5543), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [185205] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5640), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5642), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [185247] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(4873), 1,
      anon_sym_STAR,
    ACTIONS(4875), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4877), 1,
      anon_sym_AMP,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6616), 1,
      sym__abstract_declarator,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5698), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [185315] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5664), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5666), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [185357] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8451), 1,
      anon_sym_STAR,
    ACTIONS(8453), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8455), 1,
      anon_sym_AMP,
    STATE(3109), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6618), 1,
      sym__abstract_declarator,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8296), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [185425] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7398), 1,
      anon_sym_DASH_GT,
    ACTIONS(7400), 1,
      anon_sym_requires,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    STATE(5052), 1,
      sym_ref_qualifier,
    STATE(6156), 1,
      sym__function_attributes_end,
    STATE(6190), 1,
      sym_trailing_return_type,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5283), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9051), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [185509] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5660), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5662), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [185551] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5656), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5658), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [185593] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6932), 1,
      anon_sym_DASH_GT,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(9053), 1,
      anon_sym___attribute__,
    ACTIONS(9056), 1,
      anon_sym___attribute,
    ACTIONS(9059), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9085), 1,
      anon_sym_requires,
    STATE(5411), 1,
      sym_trailing_return_type,
    STATE(5668), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9082), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5198), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9051), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [185671] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5676), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5678), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [185713] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5618), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5620), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [185755] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5568), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5570), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [185797] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      sym_auto,
    ACTIONS(125), 1,
      anon_sym_decltype,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1857), 1,
      anon_sym_enum,
    ACTIONS(1859), 1,
      anon_sym_class,
    ACTIONS(1861), 1,
      anon_sym_struct,
    ACTIONS(1863), 1,
      anon_sym_union,
    ACTIONS(1887), 1,
      anon_sym_typename,
    ACTIONS(3212), 1,
      sym_primitive_type,
    ACTIONS(4879), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9172), 1,
      anon_sym_EQ,
    ACTIONS(9195), 1,
      sym_identifier,
    STATE(2269), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2356), 1,
      sym_type_specifier,
    STATE(2423), 1,
      sym_decltype_auto,
    STATE(2978), 1,
      sym_qualified_type_identifier,
    STATE(6511), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    ACTIONS(9170), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(2336), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(57), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2383), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [185881] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5592), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5594), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [185923] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5498), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5500), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [185965] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5545), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5547), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [186007] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5648), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5650), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [186049] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5572), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5574), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [186091] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5626), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5628), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [186133] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5549), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5551), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [186175] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5502), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5504), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [186217] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5553), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5555), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [186259] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5514), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5516), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [186301] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(4873), 1,
      anon_sym_STAR,
    ACTIONS(4875), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4877), 1,
      anon_sym_AMP,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6617), 1,
      sym__abstract_declarator,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8300), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [186369] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7398), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9197), 1,
      anon_sym_requires,
    STATE(5054), 1,
      sym_ref_qualifier,
    STATE(6106), 1,
      sym_trailing_return_type,
    STATE(6136), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9147), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5282), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9051), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [186453] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5502), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5504), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [186495] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5502), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5504), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [186537] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6932), 1,
      anon_sym_DASH_GT,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(6944), 1,
      anon_sym_requires,
    ACTIONS(9202), 1,
      anon_sym___attribute__,
    ACTIONS(9205), 1,
      anon_sym___attribute,
    ACTIONS(9208), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    STATE(5535), 1,
      sym_trailing_return_type,
    STATE(5604), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5189), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9200), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [186615] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5533), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5535), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [186657] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5630), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5632), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [186699] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5652), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5654), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [186741] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8451), 1,
      anon_sym_STAR,
    ACTIONS(8453), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8455), 1,
      anon_sym_AMP,
    STATE(3109), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6658), 1,
      sym__abstract_declarator,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(5698), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [186809] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5431), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5433), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [186851] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8451), 1,
      anon_sym_STAR,
    ACTIONS(8453), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8455), 1,
      anon_sym_AMP,
    STATE(3109), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6659), 1,
      sym__abstract_declarator,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6632), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [186919] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6932), 1,
      anon_sym_DASH_GT,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(6944), 1,
      anon_sym_requires,
    ACTIONS(9053), 1,
      anon_sym___attribute__,
    ACTIONS(9056), 1,
      anon_sym___attribute,
    ACTIONS(9059), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    STATE(5497), 1,
      sym_trailing_return_type,
    STATE(5583), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5208), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9051), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [186997] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5578), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5580), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [187039] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5506), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5508), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [187081] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6932), 1,
      anon_sym_DASH_GT,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(9202), 1,
      anon_sym___attribute__,
    ACTIONS(9205), 1,
      anon_sym___attribute,
    ACTIONS(9208), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(9216), 1,
      anon_sym_requires,
    STATE(5489), 1,
      sym_trailing_return_type,
    STATE(5677), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9213), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5199), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9200), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [187159] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5529), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5531), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [187201] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(4873), 1,
      anon_sym_STAR,
    ACTIONS(4875), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4877), 1,
      anon_sym_AMP,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6633), 1,
      sym__abstract_declarator,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8296), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [187269] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5498), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5500), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [187311] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5596), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5598), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [187353] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5680), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5682), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [187395] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(4873), 1,
      anon_sym_STAR,
    ACTIONS(4875), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4877), 1,
      anon_sym_AMP,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6665), 1,
      sym__abstract_declarator,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(6632), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [187463] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5622), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5624), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [187505] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3270), 1,
      anon_sym_const,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8451), 1,
      anon_sym_STAR,
    ACTIONS(8453), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8455), 1,
      anon_sym_AMP,
    STATE(3109), 1,
      sym_parameter_list,
    STATE(4266), 1,
      sym_alignas_qualifier,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6662), 1,
      sym__abstract_declarator,
    ACTIONS(7980), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4072), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(8300), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(7972), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [187573] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5600), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5602), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [187615] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5537), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5539), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [187657] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5431), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5433), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [187699] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5668), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5670), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [187741] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5564), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5566), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [187783] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5644), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5646), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [187825] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5672), 3,
      anon_sym_AMP,
      anon_sym___attribute,
      anon_sym_const,
    ACTIONS(5674), 31,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [187867] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7149), 1,
      anon_sym_DASH_GT,
    ACTIONS(7162), 1,
      anon_sym_requires,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(9219), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9225), 1,
      anon_sym___asm,
    STATE(5367), 1,
      sym_trailing_return_type,
    STATE(5638), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9222), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5237), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9200), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [187944] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(6984), 1,
      anon_sym_DASH_GT,
    ACTIONS(9208), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(9216), 1,
      anon_sym_requires,
    STATE(5489), 1,
      sym_trailing_return_type,
    STATE(5892), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9213), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5247), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9200), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [188021] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7470), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9134), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9137), 1,
      anon_sym_requires,
    STATE(5145), 1,
      sym_ref_qualifier,
    STATE(5380), 1,
      sym_trailing_return_type,
    STATE(6195), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9082), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(5297), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [188104] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(7132), 1,
      anon_sym_DASH_GT,
    ACTIONS(9208), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(9216), 1,
      anon_sym_requires,
    ACTIONS(9225), 1,
      anon_sym___asm,
    STATE(5489), 1,
      sym_trailing_return_type,
    STATE(5675), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(9213), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9222), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5245), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9200), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [188181] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6065), 1,
      anon_sym_LBRACE,
    STATE(1809), 1,
      sym_attribute_specifier,
    STATE(5096), 1,
      sym_enumerator_list,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5836), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(5834), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [188230] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(6944), 1,
      anon_sym_requires,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(6984), 1,
      anon_sym_DASH_GT,
    ACTIONS(9059), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    STATE(5497), 1,
      sym_trailing_return_type,
    STATE(5853), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5231), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9051), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [188307] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6065), 1,
      anon_sym_LBRACE,
    STATE(1847), 1,
      sym_attribute_specifier,
    STATE(5098), 1,
      sym_enumerator_list,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5850), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(5848), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [188356] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(6944), 1,
      anon_sym_requires,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(6984), 1,
      anon_sym_DASH_GT,
    ACTIONS(9208), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    STATE(5535), 1,
      sym_trailing_return_type,
    STATE(5888), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5230), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9200), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [188433] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(6944), 1,
      anon_sym_requires,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(7132), 1,
      anon_sym_DASH_GT,
    ACTIONS(9208), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(9225), 1,
      anon_sym___asm,
    STATE(5535), 1,
      sym_trailing_return_type,
    STATE(5663), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9222), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5239), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9200), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [188510] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7149), 1,
      anon_sym_DASH_GT,
    ACTIONS(7162), 1,
      anon_sym_requires,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9131), 1,
      anon_sym___asm,
    ACTIONS(9134), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5366), 1,
      sym_trailing_return_type,
    STATE(5633), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9128), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5234), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9051), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [188587] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7149), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9131), 1,
      anon_sym___asm,
    ACTIONS(9134), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9137), 1,
      anon_sym_requires,
    STATE(5380), 1,
      sym_trailing_return_type,
    STATE(5559), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(9082), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9128), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5233), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9051), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [188664] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7326), 1,
      anon_sym_requires,
    ACTIONS(7583), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9153), 1,
      anon_sym___attribute__,
    ACTIONS(9156), 1,
      anon_sym___attribute,
    STATE(5179), 1,
      sym_ref_qualifier,
    STATE(5965), 1,
      sym_trailing_return_type,
    STATE(6051), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    STATE(5312), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [188747] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(8502), 1,
      anon_sym_LBRACE,
    ACTIONS(9228), 1,
      anon_sym_COLON,
    STATE(4319), 1,
      sym__enum_base_clause,
    STATE(4438), 1,
      sym_enumerator_list,
    STATE(4625), 1,
      sym_attribute_specifier,
    ACTIONS(6245), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6247), 23,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [188802] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(6984), 1,
      anon_sym_DASH_GT,
    ACTIONS(9059), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9085), 1,
      anon_sym_requires,
    STATE(5411), 1,
      sym_trailing_return_type,
    STATE(5894), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9082), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5246), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9051), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [188879] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7400), 1,
      anon_sym_requires,
    ACTIONS(7423), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9153), 1,
      anon_sym___attribute__,
    ACTIONS(9156), 1,
      anon_sym___attribute,
    STATE(5149), 1,
      sym_ref_qualifier,
    STATE(6070), 1,
      sym__function_attributes_end,
    STATE(6190), 1,
      sym_trailing_return_type,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
    STATE(5289), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [188962] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(6944), 1,
      anon_sym_requires,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(7132), 1,
      anon_sym_DASH_GT,
    ACTIONS(9059), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9131), 1,
      anon_sym___asm,
    STATE(5497), 1,
      sym_trailing_return_type,
    STATE(5655), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9128), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5240), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9051), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [189039] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3730), 1,
      anon_sym_LBRACE,
    ACTIONS(9230), 1,
      anon_sym_LPAREN2,
    STATE(2306), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3516), 1,
      sym_argument_list,
    STATE(4749), 1,
      sym_initializer_list,
    ACTIONS(5431), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(6209), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5433), 22,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [189092] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(7132), 1,
      anon_sym_DASH_GT,
    ACTIONS(9059), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9085), 1,
      anon_sym_requires,
    ACTIONS(9131), 1,
      anon_sym___asm,
    STATE(5411), 1,
      sym_trailing_return_type,
    STATE(5674), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(9082), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9128), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5244), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9051), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [189169] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7162), 1,
      anon_sym_requires,
    ACTIONS(7470), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9134), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5141), 1,
      sym_ref_qualifier,
    STATE(5366), 1,
      sym_trailing_return_type,
    STATE(6167), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(5291), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [189252] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7423), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9153), 1,
      anon_sym___attribute__,
    ACTIONS(9156), 1,
      anon_sym___attribute,
    ACTIONS(9197), 1,
      anon_sym_requires,
    STATE(5153), 1,
      sym_ref_qualifier,
    STATE(6085), 1,
      sym__function_attributes_end,
    STATE(6106), 1,
      sym_trailing_return_type,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9147), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
    STATE(5314), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [189335] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(8502), 1,
      anon_sym_LBRACE,
    ACTIONS(9228), 1,
      anon_sym_COLON,
    STATE(4332), 1,
      sym__enum_base_clause,
    STATE(4464), 1,
      sym_enumerator_list,
    STATE(4655), 1,
      sym_attribute_specifier,
    ACTIONS(6161), 3,
      anon_sym_AMP,
      anon_sym_LBRACK,
      anon_sym_const,
    ACTIONS(6163), 23,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [189390] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7583), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9150), 1,
      anon_sym_requires,
    ACTIONS(9153), 1,
      anon_sym___attribute__,
    ACTIONS(9156), 1,
      anon_sym___attribute,
    STATE(5158), 1,
      sym_ref_qualifier,
    STATE(5931), 1,
      sym_trailing_return_type,
    STATE(6060), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9147), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    STATE(5293), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [189473] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7149), 1,
      anon_sym_DASH_GT,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(9219), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9225), 1,
      anon_sym___asm,
    ACTIONS(9233), 1,
      anon_sym_requires,
    STATE(5382), 1,
      sym_trailing_return_type,
    STATE(5561), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(9213), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9222), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5235), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9200), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [189550] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9236), 1,
      sym_ms_restrict_modifier,
    STATE(5211), 1,
      sym_ms_unaligned_ptr_modifier,
    ACTIONS(7569), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(9239), 2,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
    ACTIONS(9242), 2,
      anon_sym__unaligned,
      anon_sym___unaligned,
    STATE(4923), 2,
      sym_ms_pointer_modifier,
      aux_sym_pointer_declarator_repeat1,
    ACTIONS(7571), 22,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [189600] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5395), 1,
      sym_auto,
    ACTIONS(5397), 1,
      anon_sym_decltype,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1837), 1,
      sym_decltype_auto,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5209), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9247), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(9245), 8,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [189654] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1894), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5756), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(9249), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5758), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [189698] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(8018), 1,
      anon_sym_LPAREN2,
    ACTIONS(9252), 1,
      sym_identifier,
    ACTIONS(9254), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9258), 1,
      sym_primitive_type,
    ACTIONS(9260), 1,
      anon_sym_enum,
    ACTIONS(9262), 1,
      anon_sym_class,
    ACTIONS(9264), 1,
      anon_sym_struct,
    ACTIONS(9266), 1,
      anon_sym_union,
    ACTIONS(9268), 1,
      sym_auto,
    ACTIONS(9270), 1,
      anon_sym_decltype,
    ACTIONS(9272), 1,
      anon_sym_typename,
    STATE(1554), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1856), 1,
      sym_type_specifier,
    STATE(2211), 1,
      sym_qualified_type_identifier,
    STATE(2256), 1,
      sym_decltype_auto,
    STATE(5114), 1,
      sym_argument_list,
    STATE(6506), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(2160), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9256), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2261), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [189778] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7273), 1,
      anon_sym_DASH_GT,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(9277), 1,
      anon_sym_requires,
    STATE(6008), 1,
      sym_trailing_return_type,
    STATE(6059), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9274), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5935), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5275), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9200), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [189854] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(2902), 1,
      sym_auto,
    ACTIONS(2904), 1,
      anon_sym_decltype,
    ACTIONS(7877), 1,
      sym_primitive_type,
    ACTIONS(8018), 1,
      anon_sym_LPAREN2,
    ACTIONS(9280), 1,
      sym_identifier,
    ACTIONS(9282), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9286), 1,
      anon_sym_enum,
    ACTIONS(9288), 1,
      anon_sym_class,
    ACTIONS(9290), 1,
      anon_sym_struct,
    ACTIONS(9292), 1,
      anon_sym_union,
    ACTIONS(9294), 1,
      anon_sym_typename,
    STATE(2154), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2637), 1,
      sym_decltype_auto,
    STATE(2649), 1,
      sym_qualified_type_identifier,
    STATE(4088), 1,
      sym_type_specifier,
    STATE(5130), 1,
      sym_argument_list,
    STATE(6500), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(2563), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9284), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2651), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [189934] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7280), 1,
      anon_sym_DASH_GT,
    ACTIONS(7284), 1,
      anon_sym_requires,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9153), 1,
      anon_sym___attribute__,
    ACTIONS(9156), 1,
      anon_sym___attribute,
    STATE(5807), 1,
      sym_trailing_return_type,
    STATE(5864), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5250), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9051), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
  [190010] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7174), 1,
      anon_sym_DASH_GT,
    ACTIONS(7284), 1,
      anon_sym_requires,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    STATE(5807), 1,
      sym_trailing_return_type,
    STATE(6095), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5256), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9051), 5,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [190086] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8554), 1,
      anon_sym_LT,
    STATE(1570), 1,
      sym_template_argument_list,
    STATE(4961), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4041), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(9296), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4033), 21,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [190136] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7280), 1,
      anon_sym_DASH_GT,
    ACTIONS(7284), 1,
      anon_sym_requires,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(9298), 1,
      anon_sym___attribute__,
    ACTIONS(9301), 1,
      anon_sym___attribute,
    STATE(5812), 1,
      sym_trailing_return_type,
    STATE(5842), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5935), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5252), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9200), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
  [190212] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(7326), 1,
      anon_sym_requires,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7720), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    STATE(5190), 1,
      sym_ref_qualifier,
    STATE(5965), 1,
      sym_trailing_return_type,
    STATE(6303), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9051), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5325), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [190294] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(8018), 1,
      anon_sym_LPAREN2,
    ACTIONS(9252), 1,
      sym_identifier,
    ACTIONS(9254), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9258), 1,
      sym_primitive_type,
    ACTIONS(9260), 1,
      anon_sym_enum,
    ACTIONS(9262), 1,
      anon_sym_class,
    ACTIONS(9264), 1,
      anon_sym_struct,
    ACTIONS(9266), 1,
      anon_sym_union,
    ACTIONS(9268), 1,
      sym_auto,
    ACTIONS(9270), 1,
      anon_sym_decltype,
    ACTIONS(9272), 1,
      anon_sym_typename,
    STATE(1554), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1853), 1,
      sym_type_specifier,
    STATE(2211), 1,
      sym_qualified_type_identifier,
    STATE(2256), 1,
      sym_decltype_auto,
    STATE(5115), 1,
      sym_argument_list,
    STATE(6506), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(2160), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9256), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2261), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [190374] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(5521), 1,
      anon_sym_const,
    ACTIONS(6632), 1,
      anon_sym_COLON,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8548), 1,
      anon_sym_STAR,
    ACTIONS(8550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8552), 1,
      anon_sym_AMP,
    STATE(1651), 1,
      sym_alignas_qualifier,
    STATE(3356), 1,
      sym_parameter_list,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6760), 1,
      sym__abstract_declarator,
    ACTIONS(8340), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1617), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8332), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [190440] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7162), 1,
      anon_sym_requires,
    ACTIONS(7172), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9134), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9153), 1,
      anon_sym___attribute__,
    ACTIONS(9156), 1,
      anon_sym___attribute,
    STATE(5366), 1,
      sym_trailing_return_type,
    STATE(5789), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5253), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9051), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
  [190516] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(8018), 1,
      anon_sym_LPAREN2,
    ACTIONS(9304), 1,
      sym_identifier,
    ACTIONS(9306), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9310), 1,
      sym_primitive_type,
    ACTIONS(9312), 1,
      anon_sym_enum,
    ACTIONS(9314), 1,
      anon_sym_class,
    ACTIONS(9316), 1,
      anon_sym_struct,
    ACTIONS(9318), 1,
      anon_sym_union,
    ACTIONS(9320), 1,
      sym_auto,
    ACTIONS(9322), 1,
      anon_sym_decltype,
    ACTIONS(9324), 1,
      anon_sym_typename,
    STATE(1573), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2742), 1,
      sym_type_specifier,
    STATE(3078), 1,
      sym_qualified_type_identifier,
    STATE(3164), 1,
      sym_decltype_auto,
    STATE(5169), 1,
      sym_argument_list,
    STATE(6487), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(2948), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9308), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3066), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [190596] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(5521), 1,
      anon_sym_const,
    ACTIONS(5698), 1,
      anon_sym_COLON,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8548), 1,
      anon_sym_STAR,
    ACTIONS(8550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8552), 1,
      anon_sym_AMP,
    STATE(1651), 1,
      sym_alignas_qualifier,
    STATE(3356), 1,
      sym_parameter_list,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6779), 1,
      sym__abstract_declarator,
    ACTIONS(8340), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1617), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8332), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [190662] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7264), 1,
      anon_sym_DASH_GT,
    ACTIONS(7330), 1,
      anon_sym_requires,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(9219), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5968), 1,
      sym__function_attributes_end,
    STATE(6116), 1,
      sym_trailing_return_type,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5248), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9200), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [190738] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(7733), 1,
      anon_sym_DASH_GT,
    ACTIONS(9059), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9326), 1,
      anon_sym_requires,
    STATE(5203), 1,
      sym_ref_qualifier,
    STATE(6246), 1,
      sym__function_attributes_end,
    STATE(6388), 1,
      sym_trailing_return_type,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9051), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9082), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5327), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [190820] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7264), 1,
      anon_sym_DASH_GT,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(9219), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9329), 1,
      anon_sym_requires,
    STATE(5982), 1,
      sym__function_attributes_end,
    STATE(6128), 1,
      sym_trailing_return_type,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9213), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5261), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9200), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [190896] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(8018), 1,
      anon_sym_LPAREN2,
    ACTIONS(9332), 1,
      sym_identifier,
    ACTIONS(9334), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9338), 1,
      sym_primitive_type,
    ACTIONS(9340), 1,
      anon_sym_enum,
    ACTIONS(9342), 1,
      anon_sym_class,
    ACTIONS(9344), 1,
      anon_sym_struct,
    ACTIONS(9346), 1,
      anon_sym_union,
    ACTIONS(9348), 1,
      sym_auto,
    ACTIONS(9350), 1,
      anon_sym_decltype,
    ACTIONS(9352), 1,
      anon_sym_typename,
    STATE(1569), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2703), 1,
      sym_type_specifier,
    STATE(2949), 1,
      sym_decltype_auto,
    STATE(3048), 1,
      sym_qualified_type_identifier,
    STATE(5127), 1,
      sym_argument_list,
    STATE(6507), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(2852), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9336), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2999), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [190976] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(2902), 1,
      sym_auto,
    ACTIONS(2904), 1,
      anon_sym_decltype,
    ACTIONS(7877), 1,
      sym_primitive_type,
    ACTIONS(8018), 1,
      anon_sym_LPAREN2,
    ACTIONS(9280), 1,
      sym_identifier,
    ACTIONS(9282), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9286), 1,
      anon_sym_enum,
    ACTIONS(9288), 1,
      anon_sym_class,
    ACTIONS(9290), 1,
      anon_sym_struct,
    ACTIONS(9292), 1,
      anon_sym_union,
    ACTIONS(9294), 1,
      anon_sym_typename,
    STATE(2154), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2637), 1,
      sym_decltype_auto,
    STATE(2649), 1,
      sym_qualified_type_identifier,
    STATE(4122), 1,
      sym_type_specifier,
    STATE(5131), 1,
      sym_argument_list,
    STATE(6500), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(2563), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9284), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2651), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [191056] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7280), 1,
      anon_sym_DASH_GT,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(9298), 1,
      anon_sym___attribute__,
    ACTIONS(9301), 1,
      anon_sym___attribute,
    ACTIONS(9354), 1,
      anon_sym_requires,
    STATE(5803), 1,
      sym_trailing_return_type,
    STATE(5869), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9274), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5935), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5267), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9200), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
  [191132] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7172), 1,
      anon_sym_DASH_GT,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(9219), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9233), 1,
      anon_sym_requires,
    ACTIONS(9298), 1,
      anon_sym___attribute__,
    ACTIONS(9301), 1,
      anon_sym___attribute,
    STATE(5382), 1,
      sym_trailing_return_type,
    STATE(5794), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9213), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5265), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9200), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
  [191208] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(7816), 1,
      sym_primitive_type,
    ACTIONS(8018), 1,
      anon_sym_LPAREN2,
    ACTIONS(9357), 1,
      sym_identifier,
    ACTIONS(9359), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9363), 1,
      anon_sym_enum,
    ACTIONS(9365), 1,
      anon_sym_class,
    ACTIONS(9367), 1,
      anon_sym_struct,
    ACTIONS(9369), 1,
      anon_sym_union,
    ACTIONS(9371), 1,
      anon_sym_typename,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1839), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(3905), 1,
      sym_type_specifier,
    STATE(5176), 1,
      sym_argument_list,
    STATE(6490), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [191288] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(5521), 1,
      anon_sym_const,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8300), 1,
      anon_sym_COLON,
    ACTIONS(8548), 1,
      anon_sym_STAR,
    ACTIONS(8550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8552), 1,
      anon_sym_AMP,
    STATE(1651), 1,
      sym_alignas_qualifier,
    STATE(3356), 1,
      sym_parameter_list,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6747), 1,
      sym__abstract_declarator,
    ACTIONS(8340), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1617), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8332), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [191354] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(7816), 1,
      sym_primitive_type,
    ACTIONS(8018), 1,
      anon_sym_LPAREN2,
    ACTIONS(9357), 1,
      sym_identifier,
    ACTIONS(9359), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9363), 1,
      anon_sym_enum,
    ACTIONS(9365), 1,
      anon_sym_class,
    ACTIONS(9367), 1,
      anon_sym_struct,
    ACTIONS(9369), 1,
      anon_sym_union,
    ACTIONS(9371), 1,
      anon_sym_typename,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1839), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4014), 1,
      sym_type_specifier,
    STATE(5136), 1,
      sym_argument_list,
    STATE(6490), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [191434] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6715), 1,
      sym_identifier,
    ACTIONS(6719), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(2987), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4961), 3,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_GT2,
    ACTIONS(4963), 4,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(6717), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [191490] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7720), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9150), 1,
      anon_sym_requires,
    STATE(5194), 1,
      sym_ref_qualifier,
    STATE(5931), 1,
      sym_trailing_return_type,
    STATE(6311), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9051), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9147), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5320), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [191572] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4964), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5801), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(9373), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5803), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [191616] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4965), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5744), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(9376), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5746), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [191660] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7264), 1,
      anon_sym_DASH_GT,
    ACTIONS(7330), 1,
      anon_sym_requires,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9134), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5941), 1,
      sym__function_attributes_end,
    STATE(6183), 1,
      sym_trailing_return_type,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5251), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9051), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [191736] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7174), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9159), 1,
      anon_sym_requires,
    STATE(5838), 1,
      sym_trailing_return_type,
    STATE(6027), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9147), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5272), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9051), 5,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [191812] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(5521), 1,
      anon_sym_const,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8296), 1,
      anon_sym_COLON,
    ACTIONS(8548), 1,
      anon_sym_STAR,
    ACTIONS(8550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8552), 1,
      anon_sym_AMP,
    STATE(1651), 1,
      sym_alignas_qualifier,
    STATE(3356), 1,
      sym_parameter_list,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6750), 1,
      sym__abstract_declarator,
    ACTIONS(8340), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1617), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8332), 12,
      anon_sym___extension__,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [191878] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(8018), 1,
      anon_sym_LPAREN2,
    ACTIONS(9254), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9262), 1,
      anon_sym_class,
    ACTIONS(9264), 1,
      anon_sym_struct,
    ACTIONS(9266), 1,
      anon_sym_union,
    ACTIONS(9268), 1,
      sym_auto,
    ACTIONS(9270), 1,
      anon_sym_decltype,
    ACTIONS(9379), 1,
      sym_identifier,
    ACTIONS(9383), 1,
      sym_primitive_type,
    ACTIONS(9385), 1,
      anon_sym_enum,
    ACTIONS(9387), 1,
      anon_sym_typename,
    STATE(1556), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1856), 1,
      sym_type_specifier,
    STATE(2211), 1,
      sym_qualified_type_identifier,
    STATE(2256), 1,
      sym_decltype_auto,
    STATE(5106), 1,
      sym_argument_list,
    STATE(6506), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(2160), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9381), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2261), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [191958] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5395), 1,
      sym_auto,
    ACTIONS(5397), 1,
      anon_sym_decltype,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(1837), 1,
      sym_decltype_auto,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(5215), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9391), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(9389), 8,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [192012] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(7816), 1,
      sym_primitive_type,
    ACTIONS(8018), 1,
      anon_sym_LPAREN2,
    ACTIONS(9357), 1,
      sym_identifier,
    ACTIONS(9359), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9363), 1,
      anon_sym_enum,
    ACTIONS(9365), 1,
      anon_sym_class,
    ACTIONS(9367), 1,
      anon_sym_struct,
    ACTIONS(9369), 1,
      anon_sym_union,
    ACTIONS(9371), 1,
      anon_sym_typename,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1839), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4013), 1,
      sym_type_specifier,
    STATE(5135), 1,
      sym_argument_list,
    STATE(6490), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [192092] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(8018), 1,
      anon_sym_LPAREN2,
    ACTIONS(9393), 1,
      sym_identifier,
    ACTIONS(9395), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9399), 1,
      sym_primitive_type,
    ACTIONS(9401), 1,
      anon_sym_enum,
    ACTIONS(9403), 1,
      anon_sym_class,
    ACTIONS(9405), 1,
      anon_sym_struct,
    ACTIONS(9407), 1,
      anon_sym_union,
    ACTIONS(9409), 1,
      sym_auto,
    ACTIONS(9411), 1,
      anon_sym_decltype,
    ACTIONS(9413), 1,
      anon_sym_typename,
    STATE(1801), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(3806), 1,
      sym_type_specifier,
    STATE(4034), 1,
      sym_decltype_auto,
    STATE(5110), 1,
      sym_argument_list,
    STATE(6510), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(3990), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9397), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4011), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [192172] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1894), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4981), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(9415), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4984), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [192216] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1894), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5789), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(9419), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5791), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [192260] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7162), 1,
      anon_sym_requires,
    ACTIONS(7172), 1,
      anon_sym_DASH_GT,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(9219), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9298), 1,
      anon_sym___attribute__,
    ACTIONS(9301), 1,
      anon_sym___attribute,
    STATE(5367), 1,
      sym_trailing_return_type,
    STATE(5790), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5268), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9200), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
  [192336] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(8018), 1,
      anon_sym_LPAREN2,
    ACTIONS(9393), 1,
      sym_identifier,
    ACTIONS(9395), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9399), 1,
      sym_primitive_type,
    ACTIONS(9401), 1,
      anon_sym_enum,
    ACTIONS(9403), 1,
      anon_sym_class,
    ACTIONS(9405), 1,
      anon_sym_struct,
    ACTIONS(9407), 1,
      anon_sym_union,
    ACTIONS(9409), 1,
      sym_auto,
    ACTIONS(9411), 1,
      anon_sym_decltype,
    ACTIONS(9413), 1,
      anon_sym_typename,
    STATE(1801), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(3872), 1,
      sym_type_specifier,
    STATE(4034), 1,
      sym_decltype_auto,
    STATE(5109), 1,
      sym_argument_list,
    STATE(6510), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(3990), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9397), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4011), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [192416] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1894), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5793), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(9422), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5795), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [192460] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1894), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5780), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(9425), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5782), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [192504] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4978), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5738), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(9428), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5740), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [192548] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4925), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5760), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(9431), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5762), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [192592] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1894), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5776), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(9434), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5778), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [192636] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7273), 1,
      anon_sym_DASH_GT,
    ACTIONS(7326), 1,
      anon_sym_requires,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    STATE(5936), 1,
      sym_trailing_return_type,
    STATE(6020), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5935), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5276), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9200), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [192712] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7280), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9153), 1,
      anon_sym___attribute__,
    ACTIONS(9156), 1,
      anon_sym___attribute,
    ACTIONS(9159), 1,
      anon_sym_requires,
    STATE(5838), 1,
      sym_trailing_return_type,
    STATE(5868), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9147), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5266), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9051), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
  [192788] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(8018), 1,
      anon_sym_LPAREN2,
    ACTIONS(9332), 1,
      sym_identifier,
    ACTIONS(9334), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9338), 1,
      sym_primitive_type,
    ACTIONS(9340), 1,
      anon_sym_enum,
    ACTIONS(9342), 1,
      anon_sym_class,
    ACTIONS(9344), 1,
      anon_sym_struct,
    ACTIONS(9346), 1,
      anon_sym_union,
    ACTIONS(9348), 1,
      sym_auto,
    ACTIONS(9350), 1,
      anon_sym_decltype,
    ACTIONS(9352), 1,
      anon_sym_typename,
    STATE(1569), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2719), 1,
      sym_type_specifier,
    STATE(2949), 1,
      sym_decltype_auto,
    STATE(3048), 1,
      sym_qualified_type_identifier,
    STATE(5138), 1,
      sym_argument_list,
    STATE(6507), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(2852), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9336), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2999), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [192868] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(8018), 1,
      anon_sym_LPAREN2,
    ACTIONS(9437), 1,
      sym_identifier,
    ACTIONS(9439), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9443), 1,
      sym_primitive_type,
    ACTIONS(9445), 1,
      anon_sym_enum,
    ACTIONS(9447), 1,
      anon_sym_class,
    ACTIONS(9449), 1,
      anon_sym_struct,
    ACTIONS(9451), 1,
      anon_sym_union,
    ACTIONS(9453), 1,
      sym_auto,
    ACTIONS(9455), 1,
      anon_sym_decltype,
    ACTIONS(9457), 1,
      anon_sym_typename,
    STATE(1610), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2921), 1,
      sym_type_specifier,
    STATE(3423), 1,
      sym_decltype_auto,
    STATE(3439), 1,
      sym_qualified_type_identifier,
    STATE(5155), 1,
      sym_argument_list,
    STATE(6477), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(3176), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9441), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3425), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [192948] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6907), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6909), 1,
      anon_sym_AMP,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(7733), 1,
      anon_sym_DASH_GT,
    ACTIONS(7756), 1,
      anon_sym_requires,
    ACTIONS(9059), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    STATE(5186), 1,
      sym_ref_qualifier,
    STATE(6221), 1,
      sym__function_attributes_end,
    STATE(6369), 1,
      sym_trailing_return_type,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9051), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5323), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [193030] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7174), 1,
      anon_sym_DASH_GT,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(9354), 1,
      anon_sym_requires,
    STATE(5803), 1,
      sym_trailing_return_type,
    STATE(6023), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9274), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5935), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5259), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9200), 5,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [193106] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6721), 1,
      sym_identifier,
    ACTIONS(6725), 1,
      sym_primitive_type,
    STATE(1619), 1,
      sym_alignas_qualifier,
    STATE(5206), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(4949), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(4946), 3,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_GT2,
    ACTIONS(4948), 4,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(9459), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [193162] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(8018), 1,
      anon_sym_LPAREN2,
    ACTIONS(9304), 1,
      sym_identifier,
    ACTIONS(9306), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9310), 1,
      sym_primitive_type,
    ACTIONS(9312), 1,
      anon_sym_enum,
    ACTIONS(9314), 1,
      anon_sym_class,
    ACTIONS(9316), 1,
      anon_sym_struct,
    ACTIONS(9318), 1,
      anon_sym_union,
    ACTIONS(9320), 1,
      sym_auto,
    ACTIONS(9322), 1,
      anon_sym_decltype,
    ACTIONS(9324), 1,
      anon_sym_typename,
    STATE(1573), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2737), 1,
      sym_type_specifier,
    STATE(3078), 1,
      sym_qualified_type_identifier,
    STATE(3164), 1,
      sym_decltype_auto,
    STATE(5168), 1,
      sym_argument_list,
    STATE(6487), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(2948), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9308), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3066), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [193242] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7172), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9134), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9137), 1,
      anon_sym_requires,
    ACTIONS(9153), 1,
      anon_sym___attribute__,
    ACTIONS(9156), 1,
      anon_sym___attribute,
    STATE(5380), 1,
      sym_trailing_return_type,
    STATE(5793), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9082), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5264), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9051), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
  [193318] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1894), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5750), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(9461), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5752), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [193362] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4984), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5547), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(5545), 27,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [193404] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7264), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9134), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9183), 1,
      anon_sym_requires,
    STATE(5992), 1,
      sym__function_attributes_end,
    STATE(6110), 1,
      sym_trailing_return_type,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9082), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5270), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9051), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [193480] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(8018), 1,
      anon_sym_LPAREN2,
    ACTIONS(9437), 1,
      sym_identifier,
    ACTIONS(9439), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9443), 1,
      sym_primitive_type,
    ACTIONS(9445), 1,
      anon_sym_enum,
    ACTIONS(9447), 1,
      anon_sym_class,
    ACTIONS(9449), 1,
      anon_sym_struct,
    ACTIONS(9451), 1,
      anon_sym_union,
    ACTIONS(9453), 1,
      sym_auto,
    ACTIONS(9455), 1,
      anon_sym_decltype,
    ACTIONS(9457), 1,
      anon_sym_typename,
    STATE(1610), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2840), 1,
      sym_type_specifier,
    STATE(3423), 1,
      sym_decltype_auto,
    STATE(3439), 1,
      sym_qualified_type_identifier,
    STATE(5157), 1,
      sym_argument_list,
    STATE(6477), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(3176), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9441), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3425), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [193560] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7273), 1,
      anon_sym_DASH_GT,
    ACTIONS(7326), 1,
      anon_sym_requires,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    STATE(5965), 1,
      sym_trailing_return_type,
    STATE(6055), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5277), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9051), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [193636] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(7816), 1,
      sym_primitive_type,
    ACTIONS(8018), 1,
      anon_sym_LPAREN2,
    ACTIONS(9357), 1,
      sym_identifier,
    ACTIONS(9359), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9363), 1,
      anon_sym_enum,
    ACTIONS(9365), 1,
      anon_sym_class,
    ACTIONS(9367), 1,
      anon_sym_struct,
    ACTIONS(9369), 1,
      anon_sym_union,
    ACTIONS(9371), 1,
      anon_sym_typename,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1839), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(3922), 1,
      sym_type_specifier,
    STATE(5171), 1,
      sym_argument_list,
    STATE(6490), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [193716] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1894), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5766), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
    ACTIONS(9464), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5768), 23,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [193760] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7174), 1,
      anon_sym_DASH_GT,
    ACTIONS(7284), 1,
      anon_sym_requires,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    STATE(5812), 1,
      sym_trailing_return_type,
    STATE(6045), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5935), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5257), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9200), 5,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [193836] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7273), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9150), 1,
      anon_sym_requires,
    STATE(5931), 1,
      sym_trailing_return_type,
    STATE(6092), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9147), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5263), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9051), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [193912] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(8018), 1,
      anon_sym_LPAREN2,
    ACTIONS(9254), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9262), 1,
      anon_sym_class,
    ACTIONS(9264), 1,
      anon_sym_struct,
    ACTIONS(9266), 1,
      anon_sym_union,
    ACTIONS(9268), 1,
      sym_auto,
    ACTIONS(9270), 1,
      anon_sym_decltype,
    ACTIONS(9379), 1,
      sym_identifier,
    ACTIONS(9383), 1,
      sym_primitive_type,
    ACTIONS(9385), 1,
      anon_sym_enum,
    ACTIONS(9387), 1,
      anon_sym_typename,
    STATE(1556), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1853), 1,
      sym_type_specifier,
    STATE(2211), 1,
      sym_qualified_type_identifier,
    STATE(2256), 1,
      sym_decltype_auto,
    STATE(5112), 1,
      sym_argument_list,
    STATE(6506), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(2160), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9381), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2261), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [193992] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1812), 1,
      sym_attribute_specifier,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5988), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(5986), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [194035] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(5878), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7833), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9467), 1,
      sym_identifier,
    STATE(1766), 1,
      sym_template_type,
    STATE(1838), 1,
      sym__class_declaration,
    STATE(1840), 1,
      sym__class_declaration_item,
    STATE(5090), 1,
      sym_field_declaration_list,
    STATE(5521), 1,
      sym_ms_declspec_modifier,
    STATE(6513), 1,
      sym__scope_resolution,
    STATE(6992), 1,
      sym_virtual_specifier,
    STATE(7680), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4503), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5522), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5178), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [194116] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(5878), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7833), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9467), 1,
      sym_identifier,
    STATE(1766), 1,
      sym_template_type,
    STATE(1836), 1,
      sym__class_declaration,
    STATE(1840), 1,
      sym__class_declaration_item,
    STATE(5090), 1,
      sym_field_declaration_list,
    STATE(5521), 1,
      sym_ms_declspec_modifier,
    STATE(6513), 1,
      sym__scope_resolution,
    STATE(6992), 1,
      sym_virtual_specifier,
    STATE(7680), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4503), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5522), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5178), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [194197] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(5878), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7833), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9467), 1,
      sym_identifier,
    STATE(1766), 1,
      sym_template_type,
    STATE(1824), 1,
      sym__class_declaration,
    STATE(1840), 1,
      sym__class_declaration_item,
    STATE(5090), 1,
      sym_field_declaration_list,
    STATE(5521), 1,
      sym_ms_declspec_modifier,
    STATE(6513), 1,
      sym__scope_resolution,
    STATE(6992), 1,
      sym_virtual_specifier,
    STATE(7680), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4503), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5522), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5178), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [194278] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2031), 1,
      anon_sym_LBRACE,
    ACTIONS(7207), 1,
      anon_sym_LPAREN2,
    STATE(1880), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3343), 1,
      sym_argument_list,
    STATE(3353), 1,
      sym_initializer_list,
    ACTIONS(5431), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5784), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5433), 20,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
  [194329] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2464), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5499), 1,
      sym_ms_declspec_modifier,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2748), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5443), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5123), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [194410] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2375), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5499), 1,
      sym_ms_declspec_modifier,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2748), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5443), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5123), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [194491] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2378), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5499), 1,
      sym_ms_declspec_modifier,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2748), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5443), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5123), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [194572] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7917), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9471), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2464), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(3611), 1,
      sym_field_declaration_list,
    STATE(5479), 1,
      sym_ms_declspec_modifier,
    STATE(6486), 1,
      sym__scope_resolution,
    STATE(7014), 1,
      sym_virtual_specifier,
    STATE(7713), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2938), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5484), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5122), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [194653] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7917), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9471), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2375), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(3611), 1,
      sym_field_declaration_list,
    STATE(5479), 1,
      sym_ms_declspec_modifier,
    STATE(6486), 1,
      sym__scope_resolution,
    STATE(7014), 1,
      sym_virtual_specifier,
    STATE(7713), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2938), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5484), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5122), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [194734] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7917), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9471), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2378), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(3611), 1,
      sym_field_declaration_list,
    STATE(5479), 1,
      sym_ms_declspec_modifier,
    STATE(6486), 1,
      sym__scope_resolution,
    STATE(7014), 1,
      sym_virtual_specifier,
    STATE(7713), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2938), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5484), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5122), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [194815] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(5878), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9359), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9473), 1,
      sym_identifier,
    STATE(1766), 1,
      sym_template_type,
    STATE(1838), 1,
      sym__class_declaration,
    STATE(1840), 1,
      sym__class_declaration_item,
    STATE(2285), 1,
      sym_field_declaration_list,
    STATE(5435), 1,
      sym_ms_declspec_modifier,
    STATE(6490), 1,
      sym__scope_resolution,
    STATE(6822), 1,
      sym_virtual_specifier,
    STATE(7579), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2044), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5436), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5150), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [194896] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(5878), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9359), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9473), 1,
      sym_identifier,
    STATE(1766), 1,
      sym_template_type,
    STATE(1836), 1,
      sym__class_declaration,
    STATE(1840), 1,
      sym__class_declaration_item,
    STATE(2285), 1,
      sym_field_declaration_list,
    STATE(5435), 1,
      sym_ms_declspec_modifier,
    STATE(6490), 1,
      sym__scope_resolution,
    STATE(6822), 1,
      sym_virtual_specifier,
    STATE(7579), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2044), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5436), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5150), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [194977] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(5878), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9359), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9473), 1,
      sym_identifier,
    STATE(1766), 1,
      sym_template_type,
    STATE(1824), 1,
      sym__class_declaration,
    STATE(1840), 1,
      sym__class_declaration_item,
    STATE(2285), 1,
      sym_field_declaration_list,
    STATE(5435), 1,
      sym_ms_declspec_modifier,
    STATE(6490), 1,
      sym__scope_resolution,
    STATE(6822), 1,
      sym_virtual_specifier,
    STATE(7579), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2044), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5436), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5150), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [195058] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6253), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9334), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9475), 1,
      sym_identifier,
    STATE(2562), 1,
      sym_template_type,
    STATE(2775), 1,
      sym_field_declaration_list,
    STATE(2937), 1,
      sym__class_declaration_item,
    STATE(3061), 1,
      sym__class_declaration,
    STATE(5455), 1,
      sym_ms_declspec_modifier,
    STATE(6507), 1,
      sym__scope_resolution,
    STATE(6937), 1,
      sym_virtual_specifier,
    STATE(7520), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2322), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5459), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5124), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [195139] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6253), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9334), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9475), 1,
      sym_identifier,
    STATE(2562), 1,
      sym_template_type,
    STATE(2775), 1,
      sym_field_declaration_list,
    STATE(2937), 1,
      sym__class_declaration_item,
    STATE(2942), 1,
      sym__class_declaration,
    STATE(5455), 1,
      sym_ms_declspec_modifier,
    STATE(6507), 1,
      sym__scope_resolution,
    STATE(6937), 1,
      sym_virtual_specifier,
    STATE(7520), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2322), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5459), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5124), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [195220] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6253), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9334), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9475), 1,
      sym_identifier,
    STATE(2562), 1,
      sym_template_type,
    STATE(2775), 1,
      sym_field_declaration_list,
    STATE(2937), 1,
      sym__class_declaration_item,
    STATE(2946), 1,
      sym__class_declaration,
    STATE(5455), 1,
      sym_ms_declspec_modifier,
    STATE(6507), 1,
      sym__scope_resolution,
    STATE(6937), 1,
      sym_virtual_specifier,
    STATE(7520), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2322), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5459), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5124), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [195301] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2378), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5499), 1,
      sym_ms_declspec_modifier,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2484), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5443), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5123), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [195382] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(5878), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9477), 1,
      sym_identifier,
    STATE(1766), 1,
      sym_template_type,
    STATE(1838), 1,
      sym__class_declaration,
    STATE(1840), 1,
      sym__class_declaration_item,
    STATE(2285), 1,
      sym_field_declaration_list,
    STATE(5464), 1,
      sym_ms_declspec_modifier,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(6822), 1,
      sym_virtual_specifier,
    STATE(7579), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2044), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5480), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5108), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [195463] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(5878), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9477), 1,
      sym_identifier,
    STATE(1766), 1,
      sym_template_type,
    STATE(1836), 1,
      sym__class_declaration,
    STATE(1840), 1,
      sym__class_declaration_item,
    STATE(2285), 1,
      sym_field_declaration_list,
    STATE(5464), 1,
      sym_ms_declspec_modifier,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(6822), 1,
      sym_virtual_specifier,
    STATE(7579), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2044), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5480), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5108), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [195544] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(5878), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9477), 1,
      sym_identifier,
    STATE(1766), 1,
      sym_template_type,
    STATE(1824), 1,
      sym__class_declaration,
    STATE(1840), 1,
      sym__class_declaration_item,
    STATE(2285), 1,
      sym_field_declaration_list,
    STATE(5464), 1,
      sym_ms_declspec_modifier,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(6822), 1,
      sym_virtual_specifier,
    STATE(7579), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2044), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5480), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5108), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [195625] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(5381), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9254), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9479), 1,
      sym_identifier,
    STATE(1883), 1,
      sym_template_type,
    STATE(2143), 1,
      sym_field_declaration_list,
    STATE(2210), 1,
      sym__class_declaration,
    STATE(2212), 1,
      sym__class_declaration_item,
    STATE(5424), 1,
      sym_ms_declspec_modifier,
    STATE(6506), 1,
      sym__scope_resolution,
    STATE(6878), 1,
      sym_virtual_specifier,
    STATE(7580), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(1724), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5431), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5147), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [195706] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(5381), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9254), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9479), 1,
      sym_identifier,
    STATE(1883), 1,
      sym_template_type,
    STATE(2143), 1,
      sym_field_declaration_list,
    STATE(2212), 1,
      sym__class_declaration_item,
    STATE(2233), 1,
      sym__class_declaration,
    STATE(5424), 1,
      sym_ms_declspec_modifier,
    STATE(6506), 1,
      sym__scope_resolution,
    STATE(6878), 1,
      sym_virtual_specifier,
    STATE(7580), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(1724), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5431), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5147), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [195787] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(5381), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9254), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9479), 1,
      sym_identifier,
    STATE(1883), 1,
      sym_template_type,
    STATE(2143), 1,
      sym_field_declaration_list,
    STATE(2212), 1,
      sym__class_declaration_item,
    STATE(2247), 1,
      sym__class_declaration,
    STATE(5424), 1,
      sym_ms_declspec_modifier,
    STATE(6506), 1,
      sym__scope_resolution,
    STATE(6878), 1,
      sym_virtual_specifier,
    STATE(7580), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(1724), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5431), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5147), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [195868] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    ACTIONS(9481), 1,
      anon_sym_COLON_COLON,
    STATE(2158), 1,
      sym_template_type,
    STATE(2464), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5516), 1,
      sym_ms_declspec_modifier,
    STATE(6509), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3921), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5518), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5104), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [195949] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    ACTIONS(9481), 1,
      anon_sym_COLON_COLON,
    STATE(2158), 1,
      sym_template_type,
    STATE(2375), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5516), 1,
      sym_ms_declspec_modifier,
    STATE(6509), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3921), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5518), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5104), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [196030] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    ACTIONS(9481), 1,
      anon_sym_COLON_COLON,
    STATE(2158), 1,
      sym_template_type,
    STATE(2378), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5516), 1,
      sym_ms_declspec_modifier,
    STATE(6509), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3921), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5518), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5104), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [196111] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6222), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9483), 1,
      sym_identifier,
    STATE(2532), 1,
      sym_template_type,
    STATE(2557), 1,
      sym_field_declaration_list,
    STATE(2623), 1,
      sym__class_declaration_item,
    STATE(2641), 1,
      sym__class_declaration,
    STATE(5425), 1,
      sym_ms_declspec_modifier,
    STATE(6528), 1,
      sym__scope_resolution,
    STATE(6927), 1,
      sym_virtual_specifier,
    STATE(7497), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2307), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5427), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5162), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [196192] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6222), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9483), 1,
      sym_identifier,
    STATE(2532), 1,
      sym_template_type,
    STATE(2557), 1,
      sym_field_declaration_list,
    STATE(2623), 1,
      sym__class_declaration_item,
    STATE(2636), 1,
      sym__class_declaration,
    STATE(5425), 1,
      sym_ms_declspec_modifier,
    STATE(6528), 1,
      sym__scope_resolution,
    STATE(6927), 1,
      sym_virtual_specifier,
    STATE(7497), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2307), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5427), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5162), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [196273] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6222), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9483), 1,
      sym_identifier,
    STATE(2532), 1,
      sym_template_type,
    STATE(2557), 1,
      sym_field_declaration_list,
    STATE(2623), 1,
      sym__class_declaration_item,
    STATE(2638), 1,
      sym__class_declaration,
    STATE(5425), 1,
      sym_ms_declspec_modifier,
    STATE(6528), 1,
      sym__scope_resolution,
    STATE(6927), 1,
      sym_virtual_specifier,
    STATE(7497), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2307), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5427), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5162), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [196354] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6222), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9282), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9485), 1,
      sym_identifier,
    STATE(2532), 1,
      sym_template_type,
    STATE(2557), 1,
      sym_field_declaration_list,
    STATE(2623), 1,
      sym__class_declaration_item,
    STATE(2641), 1,
      sym__class_declaration,
    STATE(5470), 1,
      sym_ms_declspec_modifier,
    STATE(6500), 1,
      sym__scope_resolution,
    STATE(6927), 1,
      sym_virtual_specifier,
    STATE(7497), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2307), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5471), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5180), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [196435] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6222), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9282), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9485), 1,
      sym_identifier,
    STATE(2532), 1,
      sym_template_type,
    STATE(2557), 1,
      sym_field_declaration_list,
    STATE(2623), 1,
      sym__class_declaration_item,
    STATE(2636), 1,
      sym__class_declaration,
    STATE(5470), 1,
      sym_ms_declspec_modifier,
    STATE(6500), 1,
      sym__scope_resolution,
    STATE(6927), 1,
      sym_virtual_specifier,
    STATE(7497), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2307), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5471), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5180), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [196516] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6222), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9282), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9485), 1,
      sym_identifier,
    STATE(2532), 1,
      sym_template_type,
    STATE(2557), 1,
      sym_field_declaration_list,
    STATE(2623), 1,
      sym__class_declaration_item,
    STATE(2638), 1,
      sym__class_declaration,
    STATE(5470), 1,
      sym_ms_declspec_modifier,
    STATE(6500), 1,
      sym__scope_resolution,
    STATE(6927), 1,
      sym_virtual_specifier,
    STATE(7497), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2307), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5471), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5180), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [196597] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(6648), 1,
      anon_sym_LBRACE,
    ACTIONS(9439), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9487), 1,
      sym_identifier,
    STATE(2773), 1,
      sym_template_type,
    STATE(3033), 1,
      sym_field_declaration_list,
    STATE(3445), 1,
      sym__class_declaration,
    STATE(3446), 1,
      sym__class_declaration_item,
    STATE(5502), 1,
      sym_ms_declspec_modifier,
    STATE(6477), 1,
      sym__scope_resolution,
    STATE(6971), 1,
      sym_virtual_specifier,
    STATE(7614), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2538), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5503), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5111), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [196678] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(6648), 1,
      anon_sym_LBRACE,
    ACTIONS(9439), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9487), 1,
      sym_identifier,
    STATE(2773), 1,
      sym_template_type,
    STATE(3033), 1,
      sym_field_declaration_list,
    STATE(3446), 1,
      sym__class_declaration_item,
    STATE(3447), 1,
      sym__class_declaration,
    STATE(5502), 1,
      sym_ms_declspec_modifier,
    STATE(6477), 1,
      sym__scope_resolution,
    STATE(6971), 1,
      sym_virtual_specifier,
    STATE(7614), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2538), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5503), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5111), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [196759] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(6648), 1,
      anon_sym_LBRACE,
    ACTIONS(9439), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9487), 1,
      sym_identifier,
    STATE(2773), 1,
      sym_template_type,
    STATE(3033), 1,
      sym_field_declaration_list,
    STATE(3446), 1,
      sym__class_declaration_item,
    STATE(3448), 1,
      sym__class_declaration,
    STATE(5502), 1,
      sym_ms_declspec_modifier,
    STATE(6477), 1,
      sym__scope_resolution,
    STATE(6971), 1,
      sym_virtual_specifier,
    STATE(7614), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2538), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5503), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5111), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [196840] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7881), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8479), 1,
      anon_sym_LBRACE,
    ACTIONS(9489), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(4429), 1,
      sym_field_declaration_list,
    STATE(4600), 1,
      sym__class_declaration,
    STATE(4601), 1,
      sym__class_declaration_item,
    STATE(5407), 1,
      sym_ms_declspec_modifier,
    STATE(6504), 1,
      sym__scope_resolution,
    STATE(7010), 1,
      sym_virtual_specifier,
    STATE(7709), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4177), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5410), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5129), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [196921] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7881), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8479), 1,
      anon_sym_LBRACE,
    ACTIONS(9489), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(4429), 1,
      sym_field_declaration_list,
    STATE(4601), 1,
      sym__class_declaration_item,
    STATE(4602), 1,
      sym__class_declaration,
    STATE(5407), 1,
      sym_ms_declspec_modifier,
    STATE(6504), 1,
      sym__scope_resolution,
    STATE(7010), 1,
      sym_virtual_specifier,
    STATE(7709), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4177), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5410), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5129), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [197002] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7881), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8479), 1,
      anon_sym_LBRACE,
    ACTIONS(9489), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(4429), 1,
      sym_field_declaration_list,
    STATE(4601), 1,
      sym__class_declaration_item,
    STATE(4603), 1,
      sym__class_declaration,
    STATE(5407), 1,
      sym_ms_declspec_modifier,
    STATE(6504), 1,
      sym__scope_resolution,
    STATE(7010), 1,
      sym_virtual_specifier,
    STATE(7709), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4177), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5410), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5129), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [197083] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6533), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9306), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9491), 1,
      sym_identifier,
    STATE(2632), 1,
      sym_template_type,
    STATE(2805), 1,
      sym_field_declaration_list,
    STATE(3072), 1,
      sym__class_declaration,
    STATE(3073), 1,
      sym__class_declaration_item,
    STATE(5537), 1,
      sym_ms_declspec_modifier,
    STATE(6487), 1,
      sym__scope_resolution,
    STATE(6812), 1,
      sym_virtual_specifier,
    STATE(7706), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2474), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5541), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5116), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [197164] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6533), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9306), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9491), 1,
      sym_identifier,
    STATE(2632), 1,
      sym_template_type,
    STATE(2805), 1,
      sym_field_declaration_list,
    STATE(3073), 1,
      sym__class_declaration_item,
    STATE(3074), 1,
      sym__class_declaration,
    STATE(5537), 1,
      sym_ms_declspec_modifier,
    STATE(6487), 1,
      sym__scope_resolution,
    STATE(6812), 1,
      sym_virtual_specifier,
    STATE(7706), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2474), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5541), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5116), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [197245] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6533), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9306), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9491), 1,
      sym_identifier,
    STATE(2632), 1,
      sym_template_type,
    STATE(2805), 1,
      sym_field_declaration_list,
    STATE(3073), 1,
      sym__class_declaration_item,
    STATE(3076), 1,
      sym__class_declaration,
    STATE(5537), 1,
      sym_ms_declspec_modifier,
    STATE(6487), 1,
      sym__scope_resolution,
    STATE(6812), 1,
      sym_virtual_specifier,
    STATE(7706), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2474), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5541), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5116), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [197326] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7881), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9489), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2464), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(3611), 1,
      sym_field_declaration_list,
    STATE(5514), 1,
      sym_ms_declspec_modifier,
    STATE(6504), 1,
      sym__scope_resolution,
    STATE(7014), 1,
      sym_virtual_specifier,
    STATE(7713), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2938), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5154), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [197407] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7881), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9489), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2375), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(3611), 1,
      sym_field_declaration_list,
    STATE(5514), 1,
      sym_ms_declspec_modifier,
    STATE(6504), 1,
      sym__scope_resolution,
    STATE(7014), 1,
      sym_virtual_specifier,
    STATE(7713), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2938), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5154), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [197488] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7881), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9489), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2378), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(3611), 1,
      sym_field_declaration_list,
    STATE(5514), 1,
      sym_ms_declspec_modifier,
    STATE(6504), 1,
      sym__scope_resolution,
    STATE(7014), 1,
      sym_virtual_specifier,
    STATE(7713), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2938), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5520), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5154), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [197569] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7853), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8638), 1,
      anon_sym_LBRACE,
    ACTIONS(9493), 1,
      sym_identifier,
    STATE(4327), 1,
      sym_template_type,
    STATE(4814), 1,
      sym_field_declaration_list,
    STATE(4848), 1,
      sym__class_declaration_item,
    STATE(4876), 1,
      sym__class_declaration,
    STATE(5402), 1,
      sym_ms_declspec_modifier,
    STATE(6508), 1,
      sym__scope_resolution,
    STATE(6825), 1,
      sym_virtual_specifier,
    STATE(7611), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4298), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5414), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5118), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [197650] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7853), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8638), 1,
      anon_sym_LBRACE,
    ACTIONS(9493), 1,
      sym_identifier,
    STATE(4327), 1,
      sym_template_type,
    STATE(4814), 1,
      sym_field_declaration_list,
    STATE(4848), 1,
      sym__class_declaration_item,
    STATE(4891), 1,
      sym__class_declaration,
    STATE(5402), 1,
      sym_ms_declspec_modifier,
    STATE(6508), 1,
      sym__scope_resolution,
    STATE(6825), 1,
      sym_virtual_specifier,
    STATE(7611), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4298), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5414), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5118), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [197731] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7853), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8638), 1,
      anon_sym_LBRACE,
    ACTIONS(9493), 1,
      sym_identifier,
    STATE(4327), 1,
      sym_template_type,
    STATE(4814), 1,
      sym_field_declaration_list,
    STATE(4848), 1,
      sym__class_declaration_item,
    STATE(4893), 1,
      sym__class_declaration,
    STATE(5402), 1,
      sym_ms_declspec_modifier,
    STATE(6508), 1,
      sym__scope_resolution,
    STATE(6825), 1,
      sym_virtual_specifier,
    STATE(7611), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4298), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5414), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5118), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [197812] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7417), 1,
      anon_sym_LBRACE,
    ACTIONS(9395), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9495), 1,
      sym_identifier,
    STATE(3586), 1,
      sym_template_type,
    STATE(3908), 1,
      sym_field_declaration_list,
    STATE(4022), 1,
      sym__class_declaration,
    STATE(4023), 1,
      sym__class_declaration_item,
    STATE(5524), 1,
      sym_ms_declspec_modifier,
    STATE(6510), 1,
      sym__scope_resolution,
    STATE(6841), 1,
      sym_virtual_specifier,
    STATE(7445), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3160), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5528), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5152), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [197893] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7417), 1,
      anon_sym_LBRACE,
    ACTIONS(9395), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9495), 1,
      sym_identifier,
    STATE(3586), 1,
      sym_template_type,
    STATE(3908), 1,
      sym_field_declaration_list,
    STATE(4023), 1,
      sym__class_declaration_item,
    STATE(4024), 1,
      sym__class_declaration,
    STATE(5524), 1,
      sym_ms_declspec_modifier,
    STATE(6510), 1,
      sym__scope_resolution,
    STATE(6841), 1,
      sym_virtual_specifier,
    STATE(7445), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3160), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5528), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5152), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [197974] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7417), 1,
      anon_sym_LBRACE,
    ACTIONS(9395), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9495), 1,
      sym_identifier,
    STATE(3586), 1,
      sym_template_type,
    STATE(3908), 1,
      sym_field_declaration_list,
    STATE(4023), 1,
      sym__class_declaration_item,
    STATE(4025), 1,
      sym__class_declaration,
    STATE(5524), 1,
      sym_ms_declspec_modifier,
    STATE(6510), 1,
      sym__scope_resolution,
    STATE(6841), 1,
      sym_virtual_specifier,
    STATE(7445), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3160), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5528), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5152), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [198055] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7917), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8479), 1,
      anon_sym_LBRACE,
    ACTIONS(9471), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(4429), 1,
      sym_field_declaration_list,
    STATE(4600), 1,
      sym__class_declaration,
    STATE(4601), 1,
      sym__class_declaration_item,
    STATE(5451), 1,
      sym_ms_declspec_modifier,
    STATE(6486), 1,
      sym__scope_resolution,
    STATE(7010), 1,
      sym_virtual_specifier,
    STATE(7709), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4177), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5453), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5167), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [198136] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7917), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8479), 1,
      anon_sym_LBRACE,
    ACTIONS(9471), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(4429), 1,
      sym_field_declaration_list,
    STATE(4601), 1,
      sym__class_declaration_item,
    STATE(4602), 1,
      sym__class_declaration,
    STATE(5451), 1,
      sym_ms_declspec_modifier,
    STATE(6486), 1,
      sym__scope_resolution,
    STATE(7010), 1,
      sym_virtual_specifier,
    STATE(7709), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4177), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5453), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5167), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [198217] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7917), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8479), 1,
      anon_sym_LBRACE,
    ACTIONS(9471), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(4429), 1,
      sym_field_declaration_list,
    STATE(4601), 1,
      sym__class_declaration_item,
    STATE(4603), 1,
      sym__class_declaration,
    STATE(5451), 1,
      sym_ms_declspec_modifier,
    STATE(6486), 1,
      sym__scope_resolution,
    STATE(7010), 1,
      sym_virtual_specifier,
    STATE(7709), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4177), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5453), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5167), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [198298] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(4879), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9497), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2464), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5419), 1,
      sym_ms_declspec_modifier,
    STATE(6511), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2484), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5423), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5134), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [198379] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(4879), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9497), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2375), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5419), 1,
      sym_ms_declspec_modifier,
    STATE(6511), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2484), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5423), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5134), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [198460] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(4879), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9497), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2378), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5419), 1,
      sym_ms_declspec_modifier,
    STATE(6511), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2484), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5423), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5134), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [198541] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2464), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5499), 1,
      sym_ms_declspec_modifier,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2743), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5443), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5123), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [198622] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2375), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5499), 1,
      sym_ms_declspec_modifier,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2743), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5443), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5123), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [198703] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2378), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5499), 1,
      sym_ms_declspec_modifier,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2743), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5443), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5123), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [198784] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2375), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5499), 1,
      sym_ms_declspec_modifier,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2484), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5443), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5123), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [198865] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2375), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5499), 1,
      sym_ms_declspec_modifier,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2744), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5443), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5123), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [198946] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2378), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5499), 1,
      sym_ms_declspec_modifier,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2744), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5443), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5123), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [199027] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7398), 1,
      anon_sym_DASH_GT,
    ACTIONS(7400), 1,
      anon_sym_requires,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    STATE(6156), 1,
      sym__function_attributes_end,
    STATE(6190), 1,
      sym_trailing_return_type,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5283), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9051), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [199102] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7398), 1,
      anon_sym_DASH_GT,
    ACTIONS(7400), 1,
      anon_sym_requires,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    STATE(6133), 1,
      sym_trailing_return_type,
    STATE(6161), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5935), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5286), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9200), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [199177] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7398), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9197), 1,
      anon_sym_requires,
    STATE(6106), 1,
      sym_trailing_return_type,
    STATE(6136), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9147), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5282), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9051), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [199252] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7398), 1,
      anon_sym_DASH_GT,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(9499), 1,
      anon_sym_requires,
    STATE(6107), 1,
      sym_trailing_return_type,
    STATE(6140), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9274), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5935), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5279), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
    ACTIONS(9200), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [199327] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2464), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5499), 1,
      sym_ms_declspec_modifier,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2766), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5443), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5123), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [199408] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2375), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5499), 1,
      sym_ms_declspec_modifier,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2766), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5443), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5123), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [199489] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2378), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5499), 1,
      sym_ms_declspec_modifier,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2766), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5443), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5123), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [199570] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2464), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5499), 1,
      sym_ms_declspec_modifier,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2767), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5443), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5123), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [199651] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2375), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5499), 1,
      sym_ms_declspec_modifier,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2767), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5443), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5123), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [199732] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2378), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5499), 1,
      sym_ms_declspec_modifier,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2767), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5443), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5123), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [199813] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2464), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5499), 1,
      sym_ms_declspec_modifier,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2770), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5443), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5123), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [199894] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2375), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5499), 1,
      sym_ms_declspec_modifier,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2770), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5443), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5123), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [199975] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2378), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5499), 1,
      sym_ms_declspec_modifier,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2770), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5443), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5123), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [200056] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2464), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5499), 1,
      sym_ms_declspec_modifier,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2771), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5443), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5123), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [200137] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2375), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5499), 1,
      sym_ms_declspec_modifier,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2771), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5443), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5123), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [200218] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2378), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5499), 1,
      sym_ms_declspec_modifier,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2771), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5443), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5123), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [200299] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2464), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5499), 1,
      sym_ms_declspec_modifier,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2764), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5443), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5123), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [200380] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2375), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5499), 1,
      sym_ms_declspec_modifier,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2764), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5443), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5123), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [200461] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2378), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5499), 1,
      sym_ms_declspec_modifier,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2764), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5443), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5123), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [200542] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2464), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5499), 1,
      sym_ms_declspec_modifier,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2802), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5443), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5123), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [200623] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2375), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5499), 1,
      sym_ms_declspec_modifier,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2802), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5443), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5123), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [200704] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2378), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5499), 1,
      sym_ms_declspec_modifier,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2802), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5443), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5123), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [200785] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2464), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5499), 1,
      sym_ms_declspec_modifier,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2772), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5443), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5123), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [200866] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2375), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5499), 1,
      sym_ms_declspec_modifier,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2772), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5443), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5123), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [200947] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2378), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5499), 1,
      sym_ms_declspec_modifier,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2772), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5443), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5123), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [201028] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2464), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5499), 1,
      sym_ms_declspec_modifier,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2778), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5443), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5123), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [201109] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2375), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5499), 1,
      sym_ms_declspec_modifier,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2778), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5443), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5123), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [201190] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2378), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5499), 1,
      sym_ms_declspec_modifier,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2778), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5443), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5123), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [201271] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2464), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5499), 1,
      sym_ms_declspec_modifier,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2779), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5443), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5123), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [201352] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2375), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5499), 1,
      sym_ms_declspec_modifier,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2779), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5443), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5123), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [201433] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2378), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5499), 1,
      sym_ms_declspec_modifier,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2779), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5443), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5123), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [201514] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2464), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5499), 1,
      sym_ms_declspec_modifier,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2785), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5443), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5123), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [201595] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2375), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5499), 1,
      sym_ms_declspec_modifier,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2785), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5443), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5123), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [201676] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2378), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5499), 1,
      sym_ms_declspec_modifier,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2785), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5443), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5123), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [201757] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2464), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5499), 1,
      sym_ms_declspec_modifier,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2786), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5443), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5123), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [201838] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2375), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5499), 1,
      sym_ms_declspec_modifier,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2786), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5443), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5123), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [201919] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2378), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5499), 1,
      sym_ms_declspec_modifier,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2786), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5443), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5123), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [202000] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9502), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6069), 10,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_DASH_GT,
      anon_sym_GT2,
    ACTIONS(6067), 18,
      anon_sym_virtual,
      anon_sym___attribute__,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym___asm,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
      anon_sym_try,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_requires,
  [202043] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1848), 1,
      sym_attribute_specifier,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5903), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(5901), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [202086] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1799), 1,
      sym_attribute_specifier,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5971), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(5969), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [202129] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1802), 1,
      sym_attribute_specifier,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5949), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(5947), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [202172] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1807), 1,
      sym_attribute_specifier,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5907), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(5905), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [202215] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1823), 1,
      sym_attribute_specifier,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5915), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(5913), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [202258] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1852), 1,
      sym_attribute_specifier,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5919), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(5917), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [202301] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1846), 1,
      sym_attribute_specifier,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5978), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(5976), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [202344] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1849), 1,
      sym_attribute_specifier,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5982), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(5980), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [202387] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1816), 1,
      sym_attribute_specifier,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5992), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(5990), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [202430] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1844), 1,
      sym_attribute_specifier,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5953), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(5951), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [202473] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1803), 1,
      sym_attribute_specifier,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5889), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(5887), 25,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [202516] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2464), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5499), 1,
      sym_ms_declspec_modifier,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2484), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5443), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5123), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [202597] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_LBRACE,
    ACTIONS(6625), 1,
      anon_sym_LPAREN2,
    STATE(1880), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2409), 1,
      sym_argument_list,
    STATE(3793), 1,
      sym_initializer_list,
    ACTIONS(5431), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5784), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5433), 20,
      anon_sym_RPAREN,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
  [202648] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2464), 1,
      sym__class_declaration,
    STATE(2492), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5499), 1,
      sym_ms_declspec_modifier,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2744), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5443), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5123), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [202729] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(5708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7156), 1,
      anon_sym_STAR,
    ACTIONS(7158), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7160), 1,
      anon_sym_AMP,
    STATE(5765), 1,
      sym__scope_resolution,
    STATE(5835), 1,
      sym__declarator,
    STATE(7253), 1,
      sym_init_declarator,
    STATE(8182), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [202799] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    ACTIONS(9481), 1,
      anon_sym_COLON_COLON,
    STATE(2158), 1,
      sym_template_type,
    STATE(2477), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5466), 1,
      sym_ms_declspec_modifier,
    STATE(6509), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3921), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5465), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5852), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [202877] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(9254), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9262), 1,
      anon_sym_class,
    ACTIONS(9264), 1,
      anon_sym_struct,
    ACTIONS(9266), 1,
      anon_sym_union,
    ACTIONS(9268), 1,
      sym_auto,
    ACTIONS(9270), 1,
      anon_sym_decltype,
    ACTIONS(9379), 1,
      sym_identifier,
    ACTIONS(9383), 1,
      sym_primitive_type,
    ACTIONS(9385), 1,
      anon_sym_enum,
    ACTIONS(9387), 1,
      anon_sym_typename,
    STATE(1556), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2156), 1,
      sym_type_specifier,
    STATE(2211), 1,
      sym_qualified_type_identifier,
    STATE(2256), 1,
      sym_decltype_auto,
    STATE(6506), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(2160), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9381), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2261), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [202951] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(9254), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9262), 1,
      anon_sym_class,
    ACTIONS(9264), 1,
      anon_sym_struct,
    ACTIONS(9266), 1,
      anon_sym_union,
    ACTIONS(9268), 1,
      sym_auto,
    ACTIONS(9270), 1,
      anon_sym_decltype,
    ACTIONS(9379), 1,
      sym_identifier,
    ACTIONS(9383), 1,
      sym_primitive_type,
    ACTIONS(9385), 1,
      anon_sym_enum,
    ACTIONS(9387), 1,
      anon_sym_typename,
    STATE(1556), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1864), 1,
      sym_type_specifier,
    STATE(2211), 1,
      sym_qualified_type_identifier,
    STATE(2256), 1,
      sym_decltype_auto,
    STATE(6506), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(2160), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9381), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2261), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [203025] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      sym_auto,
    ACTIONS(125), 1,
      anon_sym_decltype,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(3758), 1,
      sym_identifier,
    ACTIONS(3766), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3770), 1,
      sym_primitive_type,
    ACTIONS(3772), 1,
      anon_sym_enum,
    ACTIONS(3774), 1,
      anon_sym_class,
    ACTIONS(3776), 1,
      anon_sym_struct,
    ACTIONS(3778), 1,
      anon_sym_union,
    ACTIONS(3780), 1,
      anon_sym_typename,
    STATE(2356), 1,
      sym_type_specifier,
    STATE(2423), 1,
      sym_decltype_auto,
    STATE(2667), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2788), 1,
      sym_qualified_type_identifier,
    STATE(6476), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(2336), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(3768), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2383), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [203099] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(5878), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9477), 1,
      sym_identifier,
    STATE(1766), 1,
      sym_template_type,
    STATE(1815), 1,
      sym__class_declaration_item,
    STATE(2285), 1,
      sym_field_declaration_list,
    STATE(5446), 1,
      sym_ms_declspec_modifier,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(6822), 1,
      sym_virtual_specifier,
    STATE(7579), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2044), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5487), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5852), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [203177] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(9393), 1,
      sym_identifier,
    ACTIONS(9395), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9399), 1,
      sym_primitive_type,
    ACTIONS(9401), 1,
      anon_sym_enum,
    ACTIONS(9403), 1,
      anon_sym_class,
    ACTIONS(9405), 1,
      anon_sym_struct,
    ACTIONS(9407), 1,
      anon_sym_union,
    ACTIONS(9409), 1,
      sym_auto,
    ACTIONS(9411), 1,
      anon_sym_decltype,
    ACTIONS(9413), 1,
      anon_sym_typename,
    STATE(1801), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(3765), 1,
      sym_type_specifier,
    STATE(4034), 1,
      sym_decltype_auto,
    STATE(6510), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(3990), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9397), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4011), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [203251] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(9393), 1,
      sym_identifier,
    ACTIONS(9395), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9399), 1,
      sym_primitive_type,
    ACTIONS(9401), 1,
      anon_sym_enum,
    ACTIONS(9403), 1,
      anon_sym_class,
    ACTIONS(9405), 1,
      anon_sym_struct,
    ACTIONS(9407), 1,
      anon_sym_union,
    ACTIONS(9409), 1,
      sym_auto,
    ACTIONS(9411), 1,
      anon_sym_decltype,
    ACTIONS(9413), 1,
      anon_sym_typename,
    STATE(1801), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(3794), 1,
      sym_type_specifier,
    STATE(4034), 1,
      sym_decltype_auto,
    STATE(6510), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(3990), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9397), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4011), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [203325] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(6648), 1,
      anon_sym_LBRACE,
    ACTIONS(9439), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9487), 1,
      sym_identifier,
    STATE(2773), 1,
      sym_template_type,
    STATE(3033), 1,
      sym_field_declaration_list,
    STATE(3470), 1,
      sym__class_declaration_item,
    STATE(5511), 1,
      sym_ms_declspec_modifier,
    STATE(6477), 1,
      sym__scope_resolution,
    STATE(6971), 1,
      sym_virtual_specifier,
    STATE(7614), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2538), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5510), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5852), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [203403] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(9254), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9262), 1,
      anon_sym_class,
    ACTIONS(9264), 1,
      anon_sym_struct,
    ACTIONS(9266), 1,
      anon_sym_union,
    ACTIONS(9268), 1,
      sym_auto,
    ACTIONS(9270), 1,
      anon_sym_decltype,
    ACTIONS(9379), 1,
      sym_identifier,
    ACTIONS(9383), 1,
      sym_primitive_type,
    ACTIONS(9385), 1,
      anon_sym_enum,
    ACTIONS(9387), 1,
      anon_sym_typename,
    STATE(1556), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1855), 1,
      sym_type_specifier,
    STATE(2211), 1,
      sym_qualified_type_identifier,
    STATE(2256), 1,
      sym_decltype_auto,
    STATE(6506), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(2160), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9381), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2261), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [203477] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(5708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7156), 1,
      anon_sym_STAR,
    ACTIONS(7158), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7160), 1,
      anon_sym_AMP,
    STATE(5765), 1,
      sym__scope_resolution,
    STATE(5826), 1,
      sym__declarator,
    STATE(7391), 1,
      sym_init_declarator,
    STATE(8182), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [203547] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(9252), 1,
      sym_identifier,
    ACTIONS(9254), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9258), 1,
      sym_primitive_type,
    ACTIONS(9260), 1,
      anon_sym_enum,
    ACTIONS(9262), 1,
      anon_sym_class,
    ACTIONS(9264), 1,
      anon_sym_struct,
    ACTIONS(9266), 1,
      anon_sym_union,
    ACTIONS(9268), 1,
      sym_auto,
    ACTIONS(9270), 1,
      anon_sym_decltype,
    ACTIONS(9272), 1,
      anon_sym_typename,
    STATE(1554), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1864), 1,
      sym_type_specifier,
    STATE(2211), 1,
      sym_qualified_type_identifier,
    STATE(2256), 1,
      sym_decltype_auto,
    STATE(6506), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(2160), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9256), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2261), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [203621] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(9252), 1,
      sym_identifier,
    ACTIONS(9254), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9258), 1,
      sym_primitive_type,
    ACTIONS(9260), 1,
      anon_sym_enum,
    ACTIONS(9262), 1,
      anon_sym_class,
    ACTIONS(9264), 1,
      anon_sym_struct,
    ACTIONS(9266), 1,
      anon_sym_union,
    ACTIONS(9268), 1,
      sym_auto,
    ACTIONS(9270), 1,
      anon_sym_decltype,
    ACTIONS(9272), 1,
      anon_sym_typename,
    STATE(1554), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1855), 1,
      sym_type_specifier,
    STATE(2211), 1,
      sym_qualified_type_identifier,
    STATE(2256), 1,
      sym_decltype_auto,
    STATE(6506), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(2160), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9256), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2261), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [203695] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6533), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9306), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9491), 1,
      sym_identifier,
    STATE(2632), 1,
      sym_template_type,
    STATE(2805), 1,
      sym_field_declaration_list,
    STATE(3096), 1,
      sym__class_declaration_item,
    STATE(5525), 1,
      sym_ms_declspec_modifier,
    STATE(6487), 1,
      sym__scope_resolution,
    STATE(6812), 1,
      sym_virtual_specifier,
    STATE(7706), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2474), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5545), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5852), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [203773] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(9252), 1,
      sym_identifier,
    ACTIONS(9254), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9258), 1,
      sym_primitive_type,
    ACTIONS(9260), 1,
      anon_sym_enum,
    ACTIONS(9262), 1,
      anon_sym_class,
    ACTIONS(9264), 1,
      anon_sym_struct,
    ACTIONS(9266), 1,
      anon_sym_union,
    ACTIONS(9268), 1,
      sym_auto,
    ACTIONS(9270), 1,
      anon_sym_decltype,
    ACTIONS(9272), 1,
      anon_sym_typename,
    STATE(1554), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2156), 1,
      sym_type_specifier,
    STATE(2211), 1,
      sym_qualified_type_identifier,
    STATE(2256), 1,
      sym_decltype_auto,
    STATE(6506), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(2160), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9256), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2261), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [203847] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7853), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8638), 1,
      anon_sym_LBRACE,
    ACTIONS(9493), 1,
      sym_identifier,
    STATE(4327), 1,
      sym_template_type,
    STATE(4814), 1,
      sym_field_declaration_list,
    STATE(4873), 1,
      sym__class_declaration_item,
    STATE(5540), 1,
      sym_ms_declspec_modifier,
    STATE(6508), 1,
      sym__scope_resolution,
    STATE(6825), 1,
      sym_virtual_specifier,
    STATE(7611), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4298), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5492), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5852), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [203925] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(7879), 1,
      sym_identifier,
    ACTIONS(7881), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7885), 1,
      sym_primitive_type,
    ACTIONS(7887), 1,
      anon_sym_enum,
    ACTIONS(7889), 1,
      anon_sym_class,
    ACTIONS(7891), 1,
      anon_sym_struct,
    ACTIONS(7893), 1,
      anon_sym_union,
    ACTIONS(7895), 1,
      sym_auto,
    ACTIONS(7897), 1,
      anon_sym_decltype,
    ACTIONS(7899), 1,
      anon_sym_typename,
    STATE(2788), 1,
      sym_qualified_type_identifier,
    STATE(3909), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4431), 1,
      sym_type_specifier,
    STATE(4584), 1,
      sym_decltype_auto,
    STATE(6504), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(2336), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(7883), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4586), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [203999] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(2902), 1,
      sym_auto,
    ACTIONS(2904), 1,
      anon_sym_decltype,
    ACTIONS(7877), 1,
      sym_primitive_type,
    ACTIONS(9280), 1,
      sym_identifier,
    ACTIONS(9282), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9286), 1,
      anon_sym_enum,
    ACTIONS(9288), 1,
      anon_sym_class,
    ACTIONS(9290), 1,
      anon_sym_struct,
    ACTIONS(9292), 1,
      anon_sym_union,
    ACTIONS(9294), 1,
      anon_sym_typename,
    STATE(2154), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2592), 1,
      sym_type_specifier,
    STATE(2637), 1,
      sym_decltype_auto,
    STATE(2649), 1,
      sym_qualified_type_identifier,
    STATE(6500), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(2563), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9284), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2651), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [204073] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1787), 1,
      anon_sym_enum,
    ACTIONS(1789), 1,
      anon_sym_class,
    ACTIONS(1791), 1,
      anon_sym_struct,
    ACTIONS(1793), 1,
      anon_sym_union,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(1821), 1,
      anon_sym_typename,
    ACTIONS(7810), 1,
      sym_identifier,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7816), 1,
      sym_primitive_type,
    STATE(1733), 1,
      sym_type_specifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4142), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(1781), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [204147] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7917), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9471), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2477), 1,
      sym__class_declaration_item,
    STATE(3611), 1,
      sym_field_declaration_list,
    STATE(5506), 1,
      sym_ms_declspec_modifier,
    STATE(6486), 1,
      sym__scope_resolution,
    STATE(7014), 1,
      sym_virtual_specifier,
    STATE(7713), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2938), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5504), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5852), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [204225] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2477), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5488), 1,
      sym_ms_declspec_modifier,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2484), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5477), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5852), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [204303] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6253), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9334), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9475), 1,
      sym_identifier,
    STATE(2562), 1,
      sym_template_type,
    STATE(2775), 1,
      sym_field_declaration_list,
    STATE(3000), 1,
      sym__class_declaration_item,
    STATE(5469), 1,
      sym_ms_declspec_modifier,
    STATE(6507), 1,
      sym__scope_resolution,
    STATE(6937), 1,
      sym_virtual_specifier,
    STATE(7520), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2322), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5467), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5852), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [204381] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(9393), 1,
      sym_identifier,
    ACTIONS(9395), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9399), 1,
      sym_primitive_type,
    ACTIONS(9401), 1,
      anon_sym_enum,
    ACTIONS(9403), 1,
      anon_sym_class,
    ACTIONS(9405), 1,
      anon_sym_struct,
    ACTIONS(9407), 1,
      anon_sym_union,
    ACTIONS(9409), 1,
      sym_auto,
    ACTIONS(9411), 1,
      anon_sym_decltype,
    ACTIONS(9413), 1,
      anon_sym_typename,
    STATE(1801), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(3991), 1,
      sym_type_specifier,
    STATE(4034), 1,
      sym_decltype_auto,
    STATE(6510), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(3990), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9397), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4011), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [204455] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(9304), 1,
      sym_identifier,
    ACTIONS(9306), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9310), 1,
      sym_primitive_type,
    ACTIONS(9312), 1,
      anon_sym_enum,
    ACTIONS(9314), 1,
      anon_sym_class,
    ACTIONS(9316), 1,
      anon_sym_struct,
    ACTIONS(9318), 1,
      anon_sym_union,
    ACTIONS(9320), 1,
      sym_auto,
    ACTIONS(9322), 1,
      anon_sym_decltype,
    ACTIONS(9324), 1,
      anon_sym_typename,
    STATE(1573), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2935), 1,
      sym_type_specifier,
    STATE(3078), 1,
      sym_qualified_type_identifier,
    STATE(3164), 1,
      sym_decltype_auto,
    STATE(6487), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(2948), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9308), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3066), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [204529] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(9332), 1,
      sym_identifier,
    ACTIONS(9334), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9338), 1,
      sym_primitive_type,
    ACTIONS(9340), 1,
      anon_sym_enum,
    ACTIONS(9342), 1,
      anon_sym_class,
    ACTIONS(9344), 1,
      anon_sym_struct,
    ACTIONS(9346), 1,
      anon_sym_union,
    ACTIONS(9348), 1,
      sym_auto,
    ACTIONS(9350), 1,
      anon_sym_decltype,
    ACTIONS(9352), 1,
      anon_sym_typename,
    STATE(1569), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2687), 1,
      sym_type_specifier,
    STATE(2949), 1,
      sym_decltype_auto,
    STATE(3048), 1,
      sym_qualified_type_identifier,
    STATE(6507), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(2852), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9336), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2999), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [204603] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      sym_auto,
    ACTIONS(125), 1,
      anon_sym_decltype,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(3770), 1,
      sym_primitive_type,
    ACTIONS(7901), 1,
      sym_identifier,
    ACTIONS(7903), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7907), 1,
      anon_sym_class,
    ACTIONS(7909), 1,
      anon_sym_struct,
    ACTIONS(7911), 1,
      anon_sym_union,
    ACTIONS(9507), 1,
      anon_sym_enum,
    ACTIONS(9509), 1,
      anon_sym_typename,
    STATE(2356), 1,
      sym_type_specifier,
    STATE(2423), 1,
      sym_decltype_auto,
    STATE(2788), 1,
      sym_qualified_type_identifier,
    STATE(4975), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6498), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(2336), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9505), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2383), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [204677] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7881), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8479), 1,
      anon_sym_LBRACE,
    ACTIONS(9489), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(4429), 1,
      sym_field_declaration_list,
    STATE(4634), 1,
      sym__class_declaration_item,
    STATE(5529), 1,
      sym_ms_declspec_modifier,
    STATE(6504), 1,
      sym__scope_resolution,
    STATE(7010), 1,
      sym_virtual_specifier,
    STATE(7709), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4177), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5519), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5852), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [204755] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(2902), 1,
      sym_auto,
    ACTIONS(2904), 1,
      anon_sym_decltype,
    ACTIONS(7877), 1,
      sym_primitive_type,
    ACTIONS(9280), 1,
      sym_identifier,
    ACTIONS(9282), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9286), 1,
      anon_sym_enum,
    ACTIONS(9288), 1,
      anon_sym_class,
    ACTIONS(9290), 1,
      anon_sym_struct,
    ACTIONS(9292), 1,
      anon_sym_union,
    ACTIONS(9294), 1,
      anon_sym_typename,
    STATE(2154), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2637), 1,
      sym_decltype_auto,
    STATE(2649), 1,
      sym_qualified_type_identifier,
    STATE(4121), 1,
      sym_type_specifier,
    STATE(6500), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(2563), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9284), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2651), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [204829] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(2902), 1,
      sym_auto,
    ACTIONS(2904), 1,
      anon_sym_decltype,
    ACTIONS(7877), 1,
      sym_primitive_type,
    ACTIONS(9280), 1,
      sym_identifier,
    ACTIONS(9282), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9286), 1,
      anon_sym_enum,
    ACTIONS(9288), 1,
      anon_sym_class,
    ACTIONS(9290), 1,
      anon_sym_struct,
    ACTIONS(9292), 1,
      anon_sym_union,
    ACTIONS(9294), 1,
      anon_sym_typename,
    STATE(2154), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2637), 1,
      sym_decltype_auto,
    STATE(2649), 1,
      sym_qualified_type_identifier,
    STATE(4067), 1,
      sym_type_specifier,
    STATE(6500), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(2563), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9284), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2651), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [204903] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      sym_auto,
    ACTIONS(125), 1,
      anon_sym_decltype,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1857), 1,
      anon_sym_enum,
    ACTIONS(1859), 1,
      anon_sym_class,
    ACTIONS(1861), 1,
      anon_sym_struct,
    ACTIONS(1863), 1,
      anon_sym_union,
    ACTIONS(1887), 1,
      anon_sym_typename,
    ACTIONS(3212), 1,
      sym_primitive_type,
    ACTIONS(4869), 1,
      sym_identifier,
    ACTIONS(4879), 1,
      anon_sym_COLON_COLON,
    STATE(2269), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2356), 1,
      sym_type_specifier,
    STATE(2423), 1,
      sym_decltype_auto,
    STATE(2978), 1,
      sym_qualified_type_identifier,
    STATE(6511), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(2336), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(57), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2383), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [204977] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7400), 1,
      anon_sym_requires,
    ACTIONS(7423), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9153), 1,
      anon_sym___attribute__,
    ACTIONS(9156), 1,
      anon_sym___attribute,
    STATE(6070), 1,
      sym__function_attributes_end,
    STATE(6190), 1,
      sym_trailing_return_type,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
    STATE(5289), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [205051] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(4879), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9497), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2477), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(5450), 1,
      sym_ms_declspec_modifier,
    STATE(6511), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2484), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5449), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5852), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [205129] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(7816), 1,
      sym_primitive_type,
    ACTIONS(9357), 1,
      sym_identifier,
    ACTIONS(9359), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9363), 1,
      anon_sym_enum,
    ACTIONS(9365), 1,
      anon_sym_class,
    ACTIONS(9367), 1,
      anon_sym_struct,
    ACTIONS(9369), 1,
      anon_sym_union,
    ACTIONS(9371), 1,
      anon_sym_typename,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1839), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4030), 1,
      sym_type_specifier,
    STATE(6490), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [205203] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(7816), 1,
      sym_primitive_type,
    ACTIONS(9357), 1,
      sym_identifier,
    ACTIONS(9359), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9363), 1,
      anon_sym_enum,
    ACTIONS(9365), 1,
      anon_sym_class,
    ACTIONS(9367), 1,
      anon_sym_struct,
    ACTIONS(9369), 1,
      anon_sym_union,
    ACTIONS(9371), 1,
      anon_sym_typename,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1839), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(4028), 1,
      sym_type_specifier,
    STATE(6490), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [205277] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(7831), 1,
      sym_identifier,
    ACTIONS(7833), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7837), 1,
      sym_primitive_type,
    ACTIONS(7839), 1,
      anon_sym_enum,
    ACTIONS(7841), 1,
      anon_sym_class,
    ACTIONS(7843), 1,
      anon_sym_struct,
    ACTIONS(7845), 1,
      anon_sym_union,
    ACTIONS(7847), 1,
      anon_sym_typename,
    STATE(1733), 1,
      sym_type_specifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(2788), 1,
      sym_qualified_type_identifier,
    STATE(4831), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6513), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(7835), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [205351] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(9332), 1,
      sym_identifier,
    ACTIONS(9334), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9338), 1,
      sym_primitive_type,
    ACTIONS(9340), 1,
      anon_sym_enum,
    ACTIONS(9342), 1,
      anon_sym_class,
    ACTIONS(9344), 1,
      anon_sym_struct,
    ACTIONS(9346), 1,
      anon_sym_union,
    ACTIONS(9348), 1,
      sym_auto,
    ACTIONS(9350), 1,
      anon_sym_decltype,
    ACTIONS(9352), 1,
      anon_sym_typename,
    STATE(1569), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2684), 1,
      sym_type_specifier,
    STATE(2949), 1,
      sym_decltype_auto,
    STATE(3048), 1,
      sym_qualified_type_identifier,
    STATE(6507), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(2852), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9336), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2999), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [205425] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(5708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7156), 1,
      anon_sym_STAR,
    ACTIONS(7158), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7160), 1,
      anon_sym_AMP,
    STATE(5765), 1,
      sym__scope_resolution,
    STATE(5802), 1,
      sym__declarator,
    STATE(7213), 1,
      sym_init_declarator,
    STATE(8182), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [205495] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7162), 1,
      anon_sym_requires,
    ACTIONS(7470), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9134), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5366), 1,
      sym_trailing_return_type,
    STATE(6167), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(5291), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [205569] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7162), 1,
      anon_sym_requires,
    ACTIONS(7470), 1,
      anon_sym_DASH_GT,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(9219), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5367), 1,
      sym_trailing_return_type,
    STATE(6173), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(5303), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [205643] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      sym_auto,
    ACTIONS(125), 1,
      anon_sym_decltype,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(3770), 1,
      sym_primitive_type,
    ACTIONS(7901), 1,
      sym_identifier,
    ACTIONS(7903), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7907), 1,
      anon_sym_class,
    ACTIONS(7909), 1,
      anon_sym_struct,
    ACTIONS(7911), 1,
      anon_sym_union,
    ACTIONS(9507), 1,
      anon_sym_enum,
    ACTIONS(9509), 1,
      anon_sym_typename,
    STATE(2423), 1,
      sym_decltype_auto,
    STATE(2788), 1,
      sym_qualified_type_identifier,
    STATE(4975), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6498), 1,
      sym__scope_resolution,
    STATE(6735), 1,
      sym_type_specifier,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(2336), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9505), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2383), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [205717] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(7885), 1,
      sym_primitive_type,
    ACTIONS(7895), 1,
      sym_auto,
    ACTIONS(7897), 1,
      anon_sym_decltype,
    ACTIONS(7915), 1,
      sym_identifier,
    ACTIONS(7917), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7919), 1,
      anon_sym_enum,
    ACTIONS(7921), 1,
      anon_sym_class,
    ACTIONS(7923), 1,
      anon_sym_struct,
    ACTIONS(7925), 1,
      anon_sym_union,
    ACTIONS(7927), 1,
      anon_sym_typename,
    STATE(2788), 1,
      sym_qualified_type_identifier,
    STATE(3909), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4431), 1,
      sym_type_specifier,
    STATE(4584), 1,
      sym_decltype_auto,
    STATE(6486), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(2336), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(7883), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4586), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [205791] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7470), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9134), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9137), 1,
      anon_sym_requires,
    STATE(5380), 1,
      sym_trailing_return_type,
    STATE(6195), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9082), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(5297), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [205865] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7470), 1,
      anon_sym_DASH_GT,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(9219), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9233), 1,
      anon_sym_requires,
    STATE(5382), 1,
      sym_trailing_return_type,
    STATE(6199), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9213), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(5304), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [205939] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7423), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9153), 1,
      anon_sym___attribute__,
    ACTIONS(9156), 1,
      anon_sym___attribute,
    ACTIONS(9197), 1,
      anon_sym_requires,
    STATE(6085), 1,
      sym__function_attributes_end,
    STATE(6106), 1,
      sym_trailing_return_type,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9147), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
    STATE(5314), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [206013] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(5381), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9254), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9479), 1,
      sym_identifier,
    STATE(1883), 1,
      sym_template_type,
    STATE(2143), 1,
      sym_field_declaration_list,
    STATE(2170), 1,
      sym__class_declaration_item,
    STATE(5447), 1,
      sym_ms_declspec_modifier,
    STATE(6506), 1,
      sym__scope_resolution,
    STATE(6878), 1,
      sym_virtual_specifier,
    STATE(7580), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(1724), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5438), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5852), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [206091] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      sym_auto,
    ACTIONS(125), 1,
      anon_sym_decltype,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(3770), 1,
      sym_primitive_type,
    ACTIONS(7901), 1,
      sym_identifier,
    ACTIONS(7903), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7905), 1,
      anon_sym_enum,
    ACTIONS(7907), 1,
      anon_sym_class,
    ACTIONS(7909), 1,
      anon_sym_struct,
    ACTIONS(7911), 1,
      anon_sym_union,
    ACTIONS(7913), 1,
      anon_sym_typename,
    STATE(2356), 1,
      sym_type_specifier,
    STATE(2423), 1,
      sym_decltype_auto,
    STATE(2667), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2788), 1,
      sym_qualified_type_identifier,
    STATE(6498), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(2336), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(3768), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2383), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [206165] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7400), 1,
      anon_sym_requires,
    ACTIONS(7423), 1,
      anon_sym_DASH_GT,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(9298), 1,
      anon_sym___attribute__,
    ACTIONS(9301), 1,
      anon_sym___attribute,
    STATE(6075), 1,
      sym__function_attributes_end,
    STATE(6133), 1,
      sym_trailing_return_type,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5935), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
    STATE(5315), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [206239] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(5878), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9359), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9473), 1,
      sym_identifier,
    STATE(1766), 1,
      sym_template_type,
    STATE(1815), 1,
      sym__class_declaration_item,
    STATE(2285), 1,
      sym_field_declaration_list,
    STATE(5505), 1,
      sym_ms_declspec_modifier,
    STATE(6490), 1,
      sym__scope_resolution,
    STATE(6822), 1,
      sym_virtual_specifier,
    STATE(7579), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2044), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5500), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5852), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [206317] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(7851), 1,
      sym_identifier,
    ACTIONS(7853), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7857), 1,
      sym_primitive_type,
    ACTIONS(7859), 1,
      anon_sym_enum,
    ACTIONS(7861), 1,
      anon_sym_class,
    ACTIONS(7863), 1,
      anon_sym_struct,
    ACTIONS(7865), 1,
      anon_sym_union,
    ACTIONS(7867), 1,
      sym_auto,
    ACTIONS(7869), 1,
      anon_sym_decltype,
    ACTIONS(7871), 1,
      anon_sym_typename,
    STATE(4027), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(4797), 1,
      sym_type_specifier,
    STATE(4894), 1,
      sym_decltype_auto,
    STATE(4895), 1,
      sym_qualified_type_identifier,
    STATE(6508), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(4829), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(7855), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(4879), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [206391] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7417), 1,
      anon_sym_LBRACE,
    ACTIONS(9395), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9495), 1,
      sym_identifier,
    STATE(3586), 1,
      sym_template_type,
    STATE(3908), 1,
      sym_field_declaration_list,
    STATE(4047), 1,
      sym__class_declaration_item,
    STATE(5507), 1,
      sym_ms_declspec_modifier,
    STATE(6510), 1,
      sym__scope_resolution,
    STATE(6841), 1,
      sym_virtual_specifier,
    STATE(7445), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3160), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5472), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5852), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [206469] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7423), 1,
      anon_sym_DASH_GT,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(9298), 1,
      anon_sym___attribute__,
    ACTIONS(9301), 1,
      anon_sym___attribute,
    ACTIONS(9499), 1,
      anon_sym_requires,
    STATE(6086), 1,
      sym__function_attributes_end,
    STATE(6107), 1,
      sym_trailing_return_type,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9274), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5935), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
    STATE(5308), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [206543] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7881), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9489), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2477), 1,
      sym__class_declaration_item,
    STATE(3611), 1,
      sym_field_declaration_list,
    STATE(5416), 1,
      sym_ms_declspec_modifier,
    STATE(6504), 1,
      sym__scope_resolution,
    STATE(7014), 1,
      sym_virtual_specifier,
    STATE(7713), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2938), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5415), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5852), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [206621] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(9437), 1,
      sym_identifier,
    ACTIONS(9439), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9443), 1,
      sym_primitive_type,
    ACTIONS(9445), 1,
      anon_sym_enum,
    ACTIONS(9447), 1,
      anon_sym_class,
    ACTIONS(9449), 1,
      anon_sym_struct,
    ACTIONS(9451), 1,
      anon_sym_union,
    ACTIONS(9453), 1,
      sym_auto,
    ACTIONS(9455), 1,
      anon_sym_decltype,
    ACTIONS(9457), 1,
      anon_sym_typename,
    STATE(1610), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2871), 1,
      sym_type_specifier,
    STATE(3423), 1,
      sym_decltype_auto,
    STATE(3439), 1,
      sym_qualified_type_identifier,
    STATE(6477), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(3176), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9441), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3425), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [206695] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7583), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9150), 1,
      anon_sym_requires,
    ACTIONS(9153), 1,
      anon_sym___attribute__,
    ACTIONS(9156), 1,
      anon_sym___attribute,
    STATE(5931), 1,
      sym_trailing_return_type,
    STATE(6060), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9147), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    STATE(5293), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [206769] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(9437), 1,
      sym_identifier,
    ACTIONS(9439), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9443), 1,
      sym_primitive_type,
    ACTIONS(9445), 1,
      anon_sym_enum,
    ACTIONS(9447), 1,
      anon_sym_class,
    ACTIONS(9449), 1,
      anon_sym_struct,
    ACTIONS(9451), 1,
      anon_sym_union,
    ACTIONS(9453), 1,
      sym_auto,
    ACTIONS(9455), 1,
      anon_sym_decltype,
    ACTIONS(9457), 1,
      anon_sym_typename,
    STATE(1610), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2926), 1,
      sym_type_specifier,
    STATE(3423), 1,
      sym_decltype_auto,
    STATE(3439), 1,
      sym_qualified_type_identifier,
    STATE(6477), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(3176), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9441), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3425), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [206843] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7583), 1,
      anon_sym_DASH_GT,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(9277), 1,
      anon_sym_requires,
    ACTIONS(9298), 1,
      anon_sym___attribute__,
    ACTIONS(9301), 1,
      anon_sym___attribute,
    STATE(6008), 1,
      sym_trailing_return_type,
    STATE(6061), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9274), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5935), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    STATE(5309), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [206917] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(5708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7156), 1,
      anon_sym_STAR,
    ACTIONS(7158), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7160), 1,
      anon_sym_AMP,
    STATE(5765), 1,
      sym__scope_resolution,
    STATE(5829), 1,
      sym__declarator,
    STATE(7151), 1,
      sym_init_declarator,
    STATE(8182), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [206987] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(9437), 1,
      sym_identifier,
    ACTIONS(9439), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9443), 1,
      sym_primitive_type,
    ACTIONS(9445), 1,
      anon_sym_enum,
    ACTIONS(9447), 1,
      anon_sym_class,
    ACTIONS(9449), 1,
      anon_sym_struct,
    ACTIONS(9451), 1,
      anon_sym_union,
    ACTIONS(9453), 1,
      sym_auto,
    ACTIONS(9455), 1,
      anon_sym_decltype,
    ACTIONS(9457), 1,
      anon_sym_typename,
    STATE(1610), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(3240), 1,
      sym_type_specifier,
    STATE(3423), 1,
      sym_decltype_auto,
    STATE(3439), 1,
      sym_qualified_type_identifier,
    STATE(6477), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(3176), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9441), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3425), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [207061] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(5708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7156), 1,
      anon_sym_STAR,
    ACTIONS(7158), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7160), 1,
      anon_sym_AMP,
    STATE(5765), 1,
      sym__scope_resolution,
    STATE(5871), 1,
      sym__declarator,
    STATE(7635), 1,
      sym_init_declarator,
    STATE(8182), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [207131] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6222), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9483), 1,
      sym_identifier,
    STATE(2532), 1,
      sym_template_type,
    STATE(2557), 1,
      sym_field_declaration_list,
    STATE(2647), 1,
      sym__class_declaration_item,
    STATE(5433), 1,
      sym_ms_declspec_modifier,
    STATE(6528), 1,
      sym__scope_resolution,
    STATE(6927), 1,
      sym_virtual_specifier,
    STATE(7497), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2307), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5432), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5852), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [207209] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      sym_auto,
    ACTIONS(125), 1,
      anon_sym_decltype,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(3212), 1,
      sym_primitive_type,
    ACTIONS(3214), 1,
      anon_sym_enum,
    ACTIONS(3216), 1,
      anon_sym_class,
    ACTIONS(3218), 1,
      anon_sym_struct,
    ACTIONS(3220), 1,
      anon_sym_union,
    ACTIONS(3222), 1,
      anon_sym_typename,
    ACTIONS(5025), 1,
      sym_identifier,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    STATE(2269), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2356), 1,
      sym_type_specifier,
    STATE(2423), 1,
      sym_decltype_auto,
    STATE(2978), 1,
      sym_qualified_type_identifier,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(2336), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(57), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2383), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [207283] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(9332), 1,
      sym_identifier,
    ACTIONS(9334), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9338), 1,
      sym_primitive_type,
    ACTIONS(9340), 1,
      anon_sym_enum,
    ACTIONS(9342), 1,
      anon_sym_class,
    ACTIONS(9344), 1,
      anon_sym_struct,
    ACTIONS(9346), 1,
      anon_sym_union,
    ACTIONS(9348), 1,
      sym_auto,
    ACTIONS(9350), 1,
      anon_sym_decltype,
    ACTIONS(9352), 1,
      anon_sym_typename,
    STATE(1569), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2845), 1,
      sym_type_specifier,
    STATE(2949), 1,
      sym_decltype_auto,
    STATE(3048), 1,
      sym_qualified_type_identifier,
    STATE(6507), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(2852), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9336), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2999), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [207357] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(2872), 1,
      anon_sym_enum,
    ACTIONS(2874), 1,
      anon_sym_class,
    ACTIONS(2876), 1,
      anon_sym_struct,
    ACTIONS(2878), 1,
      anon_sym_union,
    ACTIONS(2902), 1,
      sym_auto,
    ACTIONS(2904), 1,
      anon_sym_decltype,
    ACTIONS(2906), 1,
      anon_sym_typename,
    ACTIONS(7873), 1,
      sym_identifier,
    ACTIONS(7875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7877), 1,
      sym_primitive_type,
    STATE(2592), 1,
      sym_type_specifier,
    STATE(2637), 1,
      sym_decltype_auto,
    STATE(2649), 1,
      sym_qualified_type_identifier,
    STATE(4167), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6528), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(2563), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(2868), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2651), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [207431] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(5708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7156), 1,
      anon_sym_STAR,
    ACTIONS(7158), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7160), 1,
      anon_sym_AMP,
    STATE(5765), 1,
      sym__scope_resolution,
    STATE(5827), 1,
      sym__declarator,
    STATE(7391), 1,
      sym_init_declarator,
    STATE(8182), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [207501] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7917), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8479), 1,
      anon_sym_LBRACE,
    ACTIONS(9471), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(4429), 1,
      sym_field_declaration_list,
    STATE(4634), 1,
      sym__class_declaration_item,
    STATE(5462), 1,
      sym_ms_declspec_modifier,
    STATE(6486), 1,
      sym__scope_resolution,
    STATE(7010), 1,
      sym_virtual_specifier,
    STATE(7709), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4177), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5461), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5852), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [207579] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(9304), 1,
      sym_identifier,
    ACTIONS(9306), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9310), 1,
      sym_primitive_type,
    ACTIONS(9312), 1,
      anon_sym_enum,
    ACTIONS(9314), 1,
      anon_sym_class,
    ACTIONS(9316), 1,
      anon_sym_struct,
    ACTIONS(9318), 1,
      anon_sym_union,
    ACTIONS(9320), 1,
      sym_auto,
    ACTIONS(9322), 1,
      anon_sym_decltype,
    ACTIONS(9324), 1,
      anon_sym_typename,
    STATE(1573), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2747), 1,
      sym_type_specifier,
    STATE(3078), 1,
      sym_qualified_type_identifier,
    STATE(3164), 1,
      sym_decltype_auto,
    STATE(6487), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(2948), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9308), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3066), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [207653] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(9304), 1,
      sym_identifier,
    ACTIONS(9306), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9310), 1,
      sym_primitive_type,
    ACTIONS(9312), 1,
      anon_sym_enum,
    ACTIONS(9314), 1,
      anon_sym_class,
    ACTIONS(9316), 1,
      anon_sym_struct,
    ACTIONS(9318), 1,
      anon_sym_union,
    ACTIONS(9320), 1,
      sym_auto,
    ACTIONS(9322), 1,
      anon_sym_decltype,
    ACTIONS(9324), 1,
      anon_sym_typename,
    STATE(1573), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2763), 1,
      sym_type_specifier,
    STATE(3078), 1,
      sym_qualified_type_identifier,
    STATE(3164), 1,
      sym_decltype_auto,
    STATE(6487), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(2948), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9308), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3066), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [207727] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(71), 1,
      anon_sym_enum,
    ACTIONS(73), 1,
      anon_sym_class,
    ACTIONS(75), 1,
      anon_sym_struct,
    ACTIONS(77), 1,
      anon_sym_union,
    ACTIONS(123), 1,
      sym_auto,
    ACTIONS(125), 1,
      anon_sym_decltype,
    ACTIONS(129), 1,
      anon_sym_typename,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(3212), 1,
      sym_primitive_type,
    ACTIONS(5025), 1,
      sym_identifier,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    STATE(2269), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(2356), 1,
      sym_type_specifier,
    STATE(2423), 1,
      sym_decltype_auto,
    STATE(2978), 1,
      sym_qualified_type_identifier,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(2336), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(57), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2383), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [207801] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(7816), 1,
      sym_primitive_type,
    ACTIONS(9357), 1,
      sym_identifier,
    ACTIONS(9359), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9363), 1,
      anon_sym_enum,
    ACTIONS(9365), 1,
      anon_sym_class,
    ACTIONS(9367), 1,
      anon_sym_struct,
    ACTIONS(9369), 1,
      anon_sym_union,
    ACTIONS(9371), 1,
      anon_sym_typename,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1839), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(3918), 1,
      sym_type_specifier,
    STATE(6490), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [207875] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(5708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7156), 1,
      anon_sym_STAR,
    ACTIONS(7158), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7160), 1,
      anon_sym_AMP,
    STATE(5765), 1,
      sym__scope_resolution,
    STATE(5797), 1,
      sym__declarator,
    STATE(7421), 1,
      sym_init_declarator,
    STATE(8182), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [207945] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7326), 1,
      anon_sym_requires,
    ACTIONS(7583), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9153), 1,
      anon_sym___attribute__,
    ACTIONS(9156), 1,
      anon_sym___attribute,
    STATE(5965), 1,
      sym_trailing_return_type,
    STATE(6051), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    STATE(5312), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [208019] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(7086), 1,
      anon_sym_STAR,
    ACTIONS(7088), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7090), 1,
      anon_sym_AMP,
    ACTIONS(7092), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    STATE(5729), 1,
      sym__declarator,
    STATE(5732), 1,
      sym__scope_resolution,
    STATE(7391), 1,
      sym_init_declarator,
    STATE(7827), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [208089] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      sym_auto,
    ACTIONS(125), 1,
      anon_sym_decltype,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(3770), 1,
      sym_primitive_type,
    ACTIONS(7901), 1,
      sym_identifier,
    ACTIONS(7903), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7907), 1,
      anon_sym_class,
    ACTIONS(7909), 1,
      anon_sym_struct,
    ACTIONS(7911), 1,
      anon_sym_union,
    ACTIONS(9507), 1,
      anon_sym_enum,
    ACTIONS(9509), 1,
      anon_sym_typename,
    STATE(2423), 1,
      sym_decltype_auto,
    STATE(2788), 1,
      sym_qualified_type_identifier,
    STATE(4975), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6498), 1,
      sym__scope_resolution,
    STATE(6787), 1,
      sym_type_specifier,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(2336), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9505), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2383), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [208163] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(7816), 1,
      sym_primitive_type,
    ACTIONS(9357), 1,
      sym_identifier,
    ACTIONS(9359), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9363), 1,
      anon_sym_enum,
    ACTIONS(9365), 1,
      anon_sym_class,
    ACTIONS(9367), 1,
      anon_sym_struct,
    ACTIONS(9369), 1,
      anon_sym_union,
    ACTIONS(9371), 1,
      anon_sym_typename,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1839), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(3901), 1,
      sym_type_specifier,
    STATE(6490), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [208237] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1817), 1,
      sym_auto,
    ACTIONS(1819), 1,
      anon_sym_decltype,
    ACTIONS(7816), 1,
      sym_primitive_type,
    ACTIONS(9357), 1,
      sym_identifier,
    ACTIONS(9359), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9363), 1,
      anon_sym_enum,
    ACTIONS(9365), 1,
      anon_sym_class,
    ACTIONS(9367), 1,
      anon_sym_struct,
    ACTIONS(9369), 1,
      anon_sym_union,
    ACTIONS(9371), 1,
      anon_sym_typename,
    STATE(1733), 1,
      sym_type_specifier,
    STATE(1804), 1,
      sym_decltype_auto,
    STATE(1839), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(1860), 1,
      sym_qualified_type_identifier,
    STATE(6490), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_dependent_type_identifier,
    STATE(1755), 2,
      sym_decltype,
      sym_template_type,
    ACTIONS(9361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(1810), 7,
      sym_sized_type_specifier,
      sym_enum_specifier,
      sym_struct_specifier,
      sym_union_specifier,
      sym_placeholder_type_specifier,
      sym_class_specifier,
      sym_dependent_type,
  [208311] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(5878), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7833), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9467), 1,
      sym_identifier,
    STATE(1766), 1,
      sym_template_type,
    STATE(1815), 1,
      sym__class_declaration_item,
    STATE(5090), 1,
      sym_field_declaration_list,
    STATE(5538), 1,
      sym_ms_declspec_modifier,
    STATE(6513), 1,
      sym__scope_resolution,
    STATE(6992), 1,
      sym_virtual_specifier,
    STATE(7680), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4503), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5536), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5852), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [208389] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(7326), 1,
      anon_sym_requires,
    ACTIONS(7583), 1,
      anon_sym_DASH_GT,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(9298), 1,
      anon_sym___attribute__,
    ACTIONS(9301), 1,
      anon_sym___attribute,
    STATE(5936), 1,
      sym_trailing_return_type,
    STATE(6053), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5935), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    STATE(5310), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [208463] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5341), 1,
      anon_sym___declspec,
    ACTIONS(6222), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9282), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9485), 1,
      sym_identifier,
    STATE(2532), 1,
      sym_template_type,
    STATE(2557), 1,
      sym_field_declaration_list,
    STATE(2647), 1,
      sym__class_declaration_item,
    STATE(5474), 1,
      sym_ms_declspec_modifier,
    STATE(6500), 1,
      sym__scope_resolution,
    STATE(6927), 1,
      sym_virtual_specifier,
    STATE(7497), 1,
      sym_base_class_clause,
    ACTIONS(5335), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(5343), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2307), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5473), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5852), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
  [208541] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(5708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7134), 1,
      anon_sym_STAR,
    ACTIONS(7136), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7138), 1,
      anon_sym_AMP,
    STATE(5765), 1,
      sym__scope_resolution,
    STATE(6471), 1,
      sym__declarator,
    STATE(7968), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [208608] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6932), 1,
      anon_sym_DASH_GT,
    ACTIONS(6944), 1,
      anon_sym_requires,
    ACTIONS(9053), 1,
      anon_sym___attribute__,
    ACTIONS(9056), 1,
      anon_sym___attribute,
    ACTIONS(9059), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    STATE(5497), 1,
      sym_trailing_return_type,
    STATE(5583), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [208675] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(5708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7156), 1,
      anon_sym_STAR,
    ACTIONS(7158), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7160), 1,
      anon_sym_AMP,
    STATE(5765), 1,
      sym__scope_resolution,
    STATE(6037), 1,
      sym__declarator,
    STATE(8182), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [208742] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(5708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7134), 1,
      anon_sym_STAR,
    ACTIONS(7136), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7138), 1,
      anon_sym_AMP,
    STATE(5765), 1,
      sym__scope_resolution,
    STATE(6496), 1,
      sym__declarator,
    STATE(7968), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [208809] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7096), 1,
      sym_identifier,
    ACTIONS(7098), 1,
      anon_sym_STAR,
    ACTIONS(7100), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7102), 1,
      anon_sym_AMP,
    ACTIONS(7104), 1,
      anon_sym_COLON_COLON,
    STATE(5750), 1,
      sym__scope_resolution,
    STATE(6357), 1,
      sym__declarator,
    STATE(8303), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [208876] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(7733), 1,
      anon_sym_DASH_GT,
    ACTIONS(7756), 1,
      anon_sym_requires,
    ACTIONS(9208), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    STATE(6272), 1,
      sym__function_attributes_end,
    STATE(6372), 1,
      sym_trailing_return_type,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9200), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5324), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [208949] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4984), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(5433), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(9511), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(5431), 21,
      anon_sym_AMP,
      anon_sym___extension__,
      anon_sym___based,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
      sym_auto,
      anon_sym_decltype,
  [208990] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7096), 1,
      sym_identifier,
    ACTIONS(7098), 1,
      anon_sym_STAR,
    ACTIONS(7100), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7102), 1,
      anon_sym_AMP,
    ACTIONS(7104), 1,
      anon_sym_COLON_COLON,
    STATE(5750), 1,
      sym__scope_resolution,
    STATE(6325), 1,
      sym__declarator,
    STATE(8303), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [209057] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6932), 1,
      anon_sym_DASH_GT,
    ACTIONS(6944), 1,
      anon_sym_requires,
    ACTIONS(9516), 1,
      anon_sym___attribute__,
    ACTIONS(9519), 1,
      anon_sym___attribute,
    ACTIONS(9522), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9525), 1,
      anon_sym_LBRACK,
    STATE(5482), 1,
      sym_trailing_return_type,
    STATE(5615), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5701), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [209124] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(7326), 1,
      anon_sym_requires,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7720), 1,
      anon_sym_DASH_GT,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    STATE(5936), 1,
      sym_trailing_return_type,
    STATE(6304), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9200), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5935), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5317), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [209197] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7720), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9150), 1,
      anon_sym_requires,
    STATE(5931), 1,
      sym_trailing_return_type,
    STATE(6311), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9051), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9147), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5320), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [209270] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5327), 1,
      sym_identifier,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7106), 1,
      anon_sym_STAR,
    ACTIONS(7108), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7110), 1,
      anon_sym_AMP,
    ACTIONS(7112), 1,
      anon_sym_COLON_COLON,
    STATE(5764), 1,
      sym__scope_resolution,
    STATE(6541), 1,
      sym__declarator,
    STATE(8019), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [209337] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7096), 1,
      sym_identifier,
    ACTIONS(7098), 1,
      anon_sym_STAR,
    ACTIONS(7100), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7102), 1,
      anon_sym_AMP,
    ACTIONS(7104), 1,
      anon_sym_COLON_COLON,
    STATE(5750), 1,
      sym__scope_resolution,
    STATE(6425), 1,
      sym__declarator,
    STATE(8303), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [209404] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7720), 1,
      anon_sym_DASH_GT,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(9277), 1,
      anon_sym_requires,
    STATE(6008), 1,
      sym_trailing_return_type,
    STATE(6313), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9200), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9274), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5935), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5321), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [209477] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7096), 1,
      sym_identifier,
    ACTIONS(7098), 1,
      anon_sym_STAR,
    ACTIONS(7100), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7102), 1,
      anon_sym_AMP,
    ACTIONS(7104), 1,
      anon_sym_COLON_COLON,
    STATE(5750), 1,
      sym__scope_resolution,
    STATE(6392), 1,
      sym__declarator,
    STATE(8303), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [209544] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(7733), 1,
      anon_sym_DASH_GT,
    ACTIONS(9059), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9326), 1,
      anon_sym_requires,
    STATE(6246), 1,
      sym__function_attributes_end,
    STATE(6388), 1,
      sym_trailing_return_type,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9051), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9082), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5327), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [209617] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6932), 1,
      anon_sym_DASH_GT,
    ACTIONS(9053), 1,
      anon_sym___attribute__,
    ACTIONS(9056), 1,
      anon_sym___attribute,
    ACTIONS(9059), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9085), 1,
      anon_sym_requires,
    STATE(5411), 1,
      sym_trailing_return_type,
    STATE(5668), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9082), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [209684] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6932), 1,
      anon_sym_DASH_GT,
    ACTIONS(9202), 1,
      anon_sym___attribute__,
    ACTIONS(9205), 1,
      anon_sym___attribute,
    ACTIONS(9208), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(9216), 1,
      anon_sym_requires,
    STATE(5489), 1,
      sym_trailing_return_type,
    STATE(5677), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9213), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [209751] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6932), 1,
      anon_sym_DASH_GT,
    ACTIONS(9516), 1,
      anon_sym___attribute__,
    ACTIONS(9519), 1,
      anon_sym___attribute,
    ACTIONS(9522), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9525), 1,
      anon_sym_LBRACK,
    ACTIONS(9530), 1,
      anon_sym_requires,
    STATE(5401), 1,
      sym_trailing_return_type,
    STATE(5679), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9527), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5701), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [209818] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(5708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7120), 1,
      anon_sym_STAR,
    ACTIONS(7122), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7124), 1,
      anon_sym_AMP,
    STATE(5765), 1,
      sym__scope_resolution,
    STATE(6254), 1,
      sym__declarator,
    STATE(7915), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [209885] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7096), 1,
      sym_identifier,
    ACTIONS(7098), 1,
      anon_sym_STAR,
    ACTIONS(7100), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7102), 1,
      anon_sym_AMP,
    ACTIONS(7104), 1,
      anon_sym_COLON_COLON,
    STATE(5750), 1,
      sym__scope_resolution,
    STATE(6416), 1,
      sym__declarator,
    STATE(8303), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [209952] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7096), 1,
      sym_identifier,
    ACTIONS(7098), 1,
      anon_sym_STAR,
    ACTIONS(7100), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7102), 1,
      anon_sym_AMP,
    ACTIONS(7104), 1,
      anon_sym_COLON_COLON,
    STATE(5750), 1,
      sym__scope_resolution,
    STATE(6350), 1,
      sym__declarator,
    STATE(8303), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [210019] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(7733), 1,
      anon_sym_DASH_GT,
    ACTIONS(9208), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(9533), 1,
      anon_sym_requires,
    STATE(6251), 1,
      sym__function_attributes_end,
    STATE(6391), 1,
      sym_trailing_return_type,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9200), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9213), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5328), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [210092] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7096), 1,
      sym_identifier,
    ACTIONS(7098), 1,
      anon_sym_STAR,
    ACTIONS(7100), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7102), 1,
      anon_sym_AMP,
    ACTIONS(7104), 1,
      anon_sym_COLON_COLON,
    STATE(5750), 1,
      sym__scope_resolution,
    STATE(6379), 1,
      sym__declarator,
    STATE(8303), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [210159] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(3196), 1,
      anon_sym_STAR,
    ACTIONS(3198), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      sym_identifier,
    ACTIONS(6180), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    STATE(5712), 1,
      sym__scope_resolution,
    STATE(6543), 1,
      sym__declarator,
    STATE(7870), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [210226] = 6,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1894), 1,
      aux_sym_sized_type_specifier_repeat1,
    ACTIONS(4981), 3,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_GT2,
    ACTIONS(4984), 4,
      anon_sym___attribute__,
      anon_sym___attribute,
      sym_auto,
      anon_sym_decltype,
    ACTIONS(5786), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    ACTIONS(4932), 17,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_primitive_type,
      sym_identifier,
  [210269] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7096), 1,
      sym_identifier,
    ACTIONS(7098), 1,
      anon_sym_STAR,
    ACTIONS(7100), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7102), 1,
      anon_sym_AMP,
    ACTIONS(7104), 1,
      anon_sym_COLON_COLON,
    STATE(5750), 1,
      sym__scope_resolution,
    STATE(6398), 1,
      sym__declarator,
    STATE(8303), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [210336] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6932), 1,
      anon_sym_DASH_GT,
    ACTIONS(6944), 1,
      anon_sym_requires,
    ACTIONS(9202), 1,
      anon_sym___attribute__,
    ACTIONS(9205), 1,
      anon_sym___attribute,
    ACTIONS(9208), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    STATE(5535), 1,
      sym_trailing_return_type,
    STATE(5604), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 7,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [210403] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1619), 1,
      sym_alignas_qualifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9538), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(9536), 8,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [210448] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(3196), 1,
      anon_sym_STAR,
    ACTIONS(3198), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      sym_identifier,
    ACTIONS(6180), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    STATE(5712), 1,
      sym__scope_resolution,
    STATE(6583), 1,
      sym__declarator,
    STATE(7870), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [210515] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7938), 3,
      anon_sym_AMP,
      sym_ms_restrict_modifier,
      anon_sym_const,
    ACTIONS(7940), 26,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [210552] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(3196), 1,
      anon_sym_STAR,
    ACTIONS(3198), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      sym_identifier,
    ACTIONS(6180), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    STATE(5712), 1,
      sym__scope_resolution,
    STATE(6367), 1,
      sym__declarator,
    STATE(7870), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [210619] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7942), 3,
      anon_sym_AMP,
      sym_ms_restrict_modifier,
      anon_sym_const,
    ACTIONS(7944), 26,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      sym_ms_unsigned_ptr_modifier,
      sym_ms_signed_ptr_modifier,
      anon_sym__unaligned,
      anon_sym___unaligned,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [210656] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7096), 1,
      sym_identifier,
    ACTIONS(7098), 1,
      anon_sym_STAR,
    ACTIONS(7100), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7102), 1,
      anon_sym_AMP,
    ACTIONS(7104), 1,
      anon_sym_COLON_COLON,
    STATE(5750), 1,
      sym__scope_resolution,
    STATE(6367), 1,
      sym__declarator,
    STATE(8303), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [210723] = 7,
    ACTIONS(3), 1,
      sym_comment,
    STATE(1619), 1,
      sym_alignas_qualifier,
    ACTIONS(67), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    STATE(1580), 2,
      sym_type_qualifier,
      aux_sym__type_definition_type_repeat1,
    ACTIONS(9542), 3,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
    ACTIONS(9540), 8,
      anon_sym_AMP,
      anon_sym___based,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
      sym_primitive_type,
      sym_identifier,
    ACTIONS(65), 13,
      anon_sym___extension__,
      anon_sym_const,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
  [210768] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7096), 1,
      sym_identifier,
    ACTIONS(7098), 1,
      anon_sym_STAR,
    ACTIONS(7100), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7102), 1,
      anon_sym_AMP,
    ACTIONS(7104), 1,
      anon_sym_COLON_COLON,
    STATE(5750), 1,
      sym__scope_resolution,
    STATE(6332), 1,
      sym__declarator,
    STATE(8303), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [210835] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(3196), 1,
      anon_sym_STAR,
    ACTIONS(3198), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      sym_identifier,
    ACTIONS(6180), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    STATE(5712), 1,
      sym__scope_resolution,
    STATE(6559), 1,
      sym__declarator,
    STATE(7870), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [210902] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(3196), 1,
      anon_sym_STAR,
    ACTIONS(3198), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      sym_identifier,
    ACTIONS(6180), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    STATE(5712), 1,
      sym__scope_resolution,
    STATE(6552), 1,
      sym__declarator,
    STATE(7870), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [210969] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7096), 1,
      sym_identifier,
    ACTIONS(7098), 1,
      anon_sym_STAR,
    ACTIONS(7100), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7102), 1,
      anon_sym_AMP,
    ACTIONS(7104), 1,
      anon_sym_COLON_COLON,
    STATE(5750), 1,
      sym__scope_resolution,
    STATE(6353), 1,
      sym__declarator,
    STATE(8303), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [211036] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7096), 1,
      sym_identifier,
    ACTIONS(7098), 1,
      anon_sym_STAR,
    ACTIONS(7100), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7102), 1,
      anon_sym_AMP,
    ACTIONS(7104), 1,
      anon_sym_COLON_COLON,
    STATE(5750), 1,
      sym__scope_resolution,
    STATE(6404), 1,
      sym__declarator,
    STATE(8303), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [211103] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7096), 1,
      sym_identifier,
    ACTIONS(7098), 1,
      anon_sym_STAR,
    ACTIONS(7100), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7102), 1,
      anon_sym_AMP,
    ACTIONS(7104), 1,
      anon_sym_COLON_COLON,
    STATE(5750), 1,
      sym__scope_resolution,
    STATE(6427), 1,
      sym__declarator,
    STATE(8303), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [211170] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(7733), 1,
      anon_sym_DASH_GT,
    ACTIONS(7756), 1,
      anon_sym_requires,
    ACTIONS(9059), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    STATE(6221), 1,
      sym__function_attributes_end,
    STATE(6369), 1,
      sym_trailing_return_type,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9051), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5323), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [211243] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5327), 1,
      sym_identifier,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7106), 1,
      anon_sym_STAR,
    ACTIONS(7108), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7110), 1,
      anon_sym_AMP,
    ACTIONS(7112), 1,
      anon_sym_COLON_COLON,
    STATE(5764), 1,
      sym__scope_resolution,
    STATE(6560), 1,
      sym__declarator,
    STATE(8019), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [211310] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5696), 1,
      sym_identifier,
    ACTIONS(7086), 1,
      anon_sym_STAR,
    ACTIONS(7088), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7090), 1,
      anon_sym_AMP,
    ACTIONS(7092), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    STATE(5732), 1,
      sym__scope_resolution,
    STATE(6039), 1,
      sym__declarator,
    STATE(7827), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [211377] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7096), 1,
      sym_identifier,
    ACTIONS(7098), 1,
      anon_sym_STAR,
    ACTIONS(7100), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7102), 1,
      anon_sym_AMP,
    ACTIONS(7104), 1,
      anon_sym_COLON_COLON,
    STATE(5750), 1,
      sym__scope_resolution,
    STATE(6408), 1,
      sym__declarator,
    STATE(8303), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [211444] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 1,
      anon_sym_AMP_AMP,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(3196), 1,
      anon_sym_STAR,
    ACTIONS(3198), 1,
      anon_sym_AMP,
    ACTIONS(5327), 1,
      sym_identifier,
    ACTIONS(6180), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    STATE(5712), 1,
      sym__scope_resolution,
    STATE(6538), 1,
      sym__declarator,
    STATE(7870), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [211511] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6937), 1,
      anon_sym_noexcept,
    ACTIONS(6939), 1,
      anon_sym_throw,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(7326), 1,
      anon_sym_requires,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7720), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    STATE(5965), 1,
      sym_trailing_return_type,
    STATE(6303), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9051), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    STATE(5325), 3,
      sym__function_exception_specification,
      sym_noexcept,
      sym_throw_specifier,
  [211584] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3192), 1,
      anon_sym_LPAREN2,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(7094), 1,
      anon_sym_LBRACK,
    ACTIONS(7096), 1,
      sym_identifier,
    ACTIONS(7098), 1,
      anon_sym_STAR,
    ACTIONS(7100), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7102), 1,
      anon_sym_AMP,
    ACTIONS(7104), 1,
      anon_sym_COLON_COLON,
    STATE(5750), 1,
      sym__scope_resolution,
    STATE(6339), 1,
      sym__declarator,
    STATE(8303), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(5896), 11,
      sym_parenthesized_declarator,
      sym_attributed_declarator,
      sym_pointer_declarator,
      sym_function_declarator,
      sym_array_declarator,
      sym_reference_declarator,
      sym_structured_binding_declarator,
      sym_template_function,
      sym_destructor_name,
      sym_qualified_identifier,
      sym_operator_name,
  [211651] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6944), 1,
      anon_sym_requires,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(7132), 1,
      anon_sym_DASH_GT,
    ACTIONS(9059), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9131), 1,
      anon_sym___asm,
    STATE(5497), 1,
      sym_trailing_return_type,
    STATE(5655), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9128), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [211717] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6944), 1,
      anon_sym_requires,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(6984), 1,
      anon_sym_DASH_GT,
    ACTIONS(9522), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9525), 1,
      anon_sym_LBRACK,
    STATE(5482), 1,
      sym_trailing_return_type,
    STATE(5851), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5701), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [211783] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6944), 1,
      anon_sym_requires,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(6984), 1,
      anon_sym_DASH_GT,
    ACTIONS(9208), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    STATE(5535), 1,
      sym_trailing_return_type,
    STATE(5888), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [211849] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7149), 1,
      anon_sym_DASH_GT,
    ACTIONS(7162), 1,
      anon_sym_requires,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9131), 1,
      anon_sym___asm,
    ACTIONS(9134), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5366), 1,
      sym_trailing_return_type,
    STATE(5633), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9128), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [211915] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7149), 1,
      anon_sym_DASH_GT,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(9219), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9225), 1,
      anon_sym___asm,
    ACTIONS(9233), 1,
      anon_sym_requires,
    STATE(5382), 1,
      sym_trailing_return_type,
    STATE(5561), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(9213), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9222), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [211981] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7149), 1,
      anon_sym_DASH_GT,
    ACTIONS(7162), 1,
      anon_sym_requires,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(9219), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9225), 1,
      anon_sym___asm,
    STATE(5367), 1,
      sym_trailing_return_type,
    STATE(5638), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9222), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [212047] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7149), 1,
      anon_sym_DASH_GT,
    ACTIONS(9525), 1,
      anon_sym_LBRACK,
    ACTIONS(9544), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9550), 1,
      anon_sym___asm,
    ACTIONS(9553), 1,
      anon_sym_requires,
    STATE(5337), 1,
      sym_trailing_return_type,
    STATE(5562), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(9527), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9547), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5701), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [212113] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6944), 1,
      anon_sym_requires,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(6984), 1,
      anon_sym_DASH_GT,
    ACTIONS(9059), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    STATE(5497), 1,
      sym_trailing_return_type,
    STATE(5853), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [212179] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7149), 1,
      anon_sym_DASH_GT,
    ACTIONS(7162), 1,
      anon_sym_requires,
    ACTIONS(9525), 1,
      anon_sym_LBRACK,
    ACTIONS(9544), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9550), 1,
      anon_sym___asm,
    STATE(5368), 1,
      sym_trailing_return_type,
    STATE(5643), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9547), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5701), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [212245] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5365), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5445), 1,
      anon_sym_LBRACE,
    ACTIONS(5431), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5433), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [212285] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6944), 1,
      anon_sym_requires,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(7132), 1,
      anon_sym_DASH_GT,
    ACTIONS(9522), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9525), 1,
      anon_sym_LBRACK,
    ACTIONS(9550), 1,
      anon_sym___asm,
    STATE(5482), 1,
      sym_trailing_return_type,
    STATE(5667), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9547), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5701), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [212351] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6944), 1,
      anon_sym_requires,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(7132), 1,
      anon_sym_DASH_GT,
    ACTIONS(9208), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(9225), 1,
      anon_sym___asm,
    STATE(5535), 1,
      sym_trailing_return_type,
    STATE(5663), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9222), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [212417] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7149), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9131), 1,
      anon_sym___asm,
    ACTIONS(9134), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9137), 1,
      anon_sym_requires,
    STATE(5380), 1,
      sym_trailing_return_type,
    STATE(5559), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(9082), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9128), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [212483] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(7132), 1,
      anon_sym_DASH_GT,
    ACTIONS(9059), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9085), 1,
      anon_sym_requires,
    ACTIONS(9131), 1,
      anon_sym___asm,
    STATE(5411), 1,
      sym_trailing_return_type,
    STATE(5674), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(9082), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9128), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [212549] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(6984), 1,
      anon_sym_DASH_GT,
    ACTIONS(9059), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9085), 1,
      anon_sym_requires,
    STATE(5411), 1,
      sym_trailing_return_type,
    STATE(5894), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9082), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [212615] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(7132), 1,
      anon_sym_DASH_GT,
    ACTIONS(9208), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(9216), 1,
      anon_sym_requires,
    ACTIONS(9225), 1,
      anon_sym___asm,
    STATE(5489), 1,
      sym_trailing_return_type,
    STATE(5675), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(9213), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9222), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [212681] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(7132), 1,
      anon_sym_DASH_GT,
    ACTIONS(9522), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9525), 1,
      anon_sym_LBRACK,
    ACTIONS(9530), 1,
      anon_sym_requires,
    ACTIONS(9550), 1,
      anon_sym___asm,
    STATE(5401), 1,
      sym_trailing_return_type,
    STATE(5676), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(9527), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9547), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5701), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 6,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
  [212747] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(6984), 1,
      anon_sym_DASH_GT,
    ACTIONS(9208), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(9216), 1,
      anon_sym_requires,
    STATE(5489), 1,
      sym_trailing_return_type,
    STATE(5892), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9213), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [212813] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(6984), 1,
      anon_sym_DASH_GT,
    ACTIONS(9522), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9525), 1,
      anon_sym_LBRACK,
    ACTIONS(9530), 1,
      anon_sym_requires,
    STATE(5401), 1,
      sym_trailing_return_type,
    STATE(5889), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9527), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5701), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [212879] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7264), 1,
      anon_sym_DASH_GT,
    ACTIONS(7330), 1,
      anon_sym_requires,
    ACTIONS(9525), 1,
      anon_sym_LBRACK,
    ACTIONS(9544), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5923), 1,
      sym__function_attributes_end,
    STATE(6123), 1,
      sym_trailing_return_type,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5701), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [212944] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7280), 1,
      anon_sym_DASH_GT,
    ACTIONS(7284), 1,
      anon_sym_requires,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9153), 1,
      anon_sym___attribute__,
    ACTIONS(9156), 1,
      anon_sym___attribute,
    STATE(5807), 1,
      sym_trailing_return_type,
    STATE(5864), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
  [213009] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7280), 1,
      anon_sym_DASH_GT,
    ACTIONS(7284), 1,
      anon_sym_requires,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(9298), 1,
      anon_sym___attribute__,
    ACTIONS(9301), 1,
      anon_sym___attribute,
    STATE(5812), 1,
      sym_trailing_return_type,
    STATE(5842), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5935), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
  [213074] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7264), 1,
      anon_sym_DASH_GT,
    ACTIONS(7330), 1,
      anon_sym_requires,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(9219), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5968), 1,
      sym__function_attributes_end,
    STATE(6116), 1,
      sym_trailing_return_type,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [213139] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7280), 1,
      anon_sym_DASH_GT,
    ACTIONS(7284), 1,
      anon_sym_requires,
    ACTIONS(9525), 1,
      anon_sym_LBRACK,
    ACTIONS(9556), 1,
      anon_sym___attribute__,
    ACTIONS(9559), 1,
      anon_sym___attribute,
    STATE(5822), 1,
      sym_trailing_return_type,
    STATE(5895), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5991), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
  [213204] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7162), 1,
      anon_sym_requires,
    ACTIONS(7172), 1,
      anon_sym_DASH_GT,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(9219), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9298), 1,
      anon_sym___attribute__,
    ACTIONS(9301), 1,
      anon_sym___attribute,
    STATE(5367), 1,
      sym_trailing_return_type,
    STATE(5790), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
  [213269] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7264), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9134), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9183), 1,
      anon_sym_requires,
    STATE(5992), 1,
      sym__function_attributes_end,
    STATE(6110), 1,
      sym_trailing_return_type,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9082), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [213334] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7273), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9150), 1,
      anon_sym_requires,
    STATE(5931), 1,
      sym_trailing_return_type,
    STATE(6092), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9147), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [213399] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7174), 1,
      anon_sym_DASH_GT,
    ACTIONS(7284), 1,
      anon_sym_requires,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    STATE(5812), 1,
      sym_trailing_return_type,
    STATE(6045), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5935), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 5,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [213464] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7174), 1,
      anon_sym_DASH_GT,
    ACTIONS(7284), 1,
      anon_sym_requires,
    ACTIONS(9525), 1,
      anon_sym_LBRACK,
    STATE(5822), 1,
      sym_trailing_return_type,
    STATE(6079), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5991), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 5,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [213529] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5445), 1,
      anon_sym_LBRACE,
    ACTIONS(5431), 2,
      anon_sym_AMP,
      anon_sym_const,
    ACTIONS(5433), 24,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym___extension__,
      anon_sym_LBRACK,
      anon_sym_constexpr,
      anon_sym_volatile,
      anon_sym_restrict,
      anon_sym___restrict__,
      anon_sym__Atomic,
      anon_sym__Noreturn,
      anon_sym_noreturn,
      anon_sym__Nonnull,
      anon_sym_mutable,
      anon_sym_constinit,
      anon_sym_consteval,
      anon_sym_alignas,
      anon_sym__Alignas,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [213566] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7174), 1,
      anon_sym_DASH_GT,
    ACTIONS(9525), 1,
      anon_sym_LBRACK,
    ACTIONS(9565), 1,
      anon_sym_requires,
    STATE(5806), 1,
      sym_trailing_return_type,
    STATE(6064), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9562), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5991), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 5,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [213631] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7174), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9159), 1,
      anon_sym_requires,
    STATE(5838), 1,
      sym_trailing_return_type,
    STATE(6027), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9147), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 5,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [213696] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7264), 1,
      anon_sym_DASH_GT,
    ACTIONS(9525), 1,
      anon_sym_LBRACK,
    ACTIONS(9544), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9568), 1,
      anon_sym_requires,
    STATE(5924), 1,
      sym__function_attributes_end,
    STATE(6138), 1,
      sym_trailing_return_type,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9527), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5701), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [213761] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7172), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9134), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9137), 1,
      anon_sym_requires,
    ACTIONS(9153), 1,
      anon_sym___attribute__,
    ACTIONS(9156), 1,
      anon_sym___attribute,
    STATE(5380), 1,
      sym_trailing_return_type,
    STATE(5793), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9082), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
  [213826] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7273), 1,
      anon_sym_DASH_GT,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(9277), 1,
      anon_sym_requires,
    STATE(6008), 1,
      sym_trailing_return_type,
    STATE(6059), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9274), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5935), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [213891] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7172), 1,
      anon_sym_DASH_GT,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(9219), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9233), 1,
      anon_sym_requires,
    ACTIONS(9298), 1,
      anon_sym___attribute__,
    ACTIONS(9301), 1,
      anon_sym___attribute,
    STATE(5382), 1,
      sym_trailing_return_type,
    STATE(5794), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9213), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
  [213956] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7172), 1,
      anon_sym_DASH_GT,
    ACTIONS(9525), 1,
      anon_sym_LBRACK,
    ACTIONS(9544), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9553), 1,
      anon_sym_requires,
    ACTIONS(9556), 1,
      anon_sym___attribute__,
    ACTIONS(9559), 1,
      anon_sym___attribute,
    STATE(5337), 1,
      sym_trailing_return_type,
    STATE(5795), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9527), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5701), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
  [214021] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7280), 1,
      anon_sym_DASH_GT,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(9298), 1,
      anon_sym___attribute__,
    ACTIONS(9301), 1,
      anon_sym___attribute,
    ACTIONS(9354), 1,
      anon_sym_requires,
    STATE(5803), 1,
      sym_trailing_return_type,
    STATE(5869), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9274), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5935), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
  [214086] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7280), 1,
      anon_sym_DASH_GT,
    ACTIONS(9525), 1,
      anon_sym_LBRACK,
    ACTIONS(9556), 1,
      anon_sym___attribute__,
    ACTIONS(9559), 1,
      anon_sym___attribute,
    ACTIONS(9565), 1,
      anon_sym_requires,
    STATE(5806), 1,
      sym_trailing_return_type,
    STATE(5870), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9562), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5991), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
  [214151] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7162), 1,
      anon_sym_requires,
    ACTIONS(7172), 1,
      anon_sym_DASH_GT,
    ACTIONS(9525), 1,
      anon_sym_LBRACK,
    ACTIONS(9544), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9556), 1,
      anon_sym___attribute__,
    ACTIONS(9559), 1,
      anon_sym___attribute,
    STATE(5368), 1,
      sym_trailing_return_type,
    STATE(5791), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5701), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
  [214216] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7174), 1,
      anon_sym_DASH_GT,
    ACTIONS(7284), 1,
      anon_sym_requires,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    STATE(5807), 1,
      sym_trailing_return_type,
    STATE(6095), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 5,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [214281] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7264), 1,
      anon_sym_DASH_GT,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(9219), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9329), 1,
      anon_sym_requires,
    STATE(5982), 1,
      sym__function_attributes_end,
    STATE(6128), 1,
      sym_trailing_return_type,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9213), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [214346] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7162), 1,
      anon_sym_requires,
    ACTIONS(7172), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9134), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9153), 1,
      anon_sym___attribute__,
    ACTIONS(9156), 1,
      anon_sym___attribute,
    STATE(5366), 1,
      sym_trailing_return_type,
    STATE(5789), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
  [214411] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7174), 1,
      anon_sym_DASH_GT,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(9354), 1,
      anon_sym_requires,
    STATE(5803), 1,
      sym_trailing_return_type,
    STATE(6023), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9274), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5935), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 5,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [214476] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7264), 1,
      anon_sym_DASH_GT,
    ACTIONS(7330), 1,
      anon_sym_requires,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9134), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5941), 1,
      sym__function_attributes_end,
    STATE(6183), 1,
      sym_trailing_return_type,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [214541] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7273), 1,
      anon_sym_DASH_GT,
    ACTIONS(7326), 1,
      anon_sym_requires,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    STATE(5965), 1,
      sym_trailing_return_type,
    STATE(6055), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [214606] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7273), 1,
      anon_sym_DASH_GT,
    ACTIONS(9525), 1,
      anon_sym_LBRACK,
    ACTIONS(9571), 1,
      anon_sym_requires,
    STATE(5967), 1,
      sym_trailing_return_type,
    STATE(6022), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9562), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5991), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [214671] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7273), 1,
      anon_sym_DASH_GT,
    ACTIONS(7326), 1,
      anon_sym_requires,
    ACTIONS(9525), 1,
      anon_sym_LBRACK,
    STATE(5993), 1,
      sym_trailing_return_type,
    STATE(6090), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5991), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [214736] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7273), 1,
      anon_sym_DASH_GT,
    ACTIONS(7326), 1,
      anon_sym_requires,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    STATE(5936), 1,
      sym_trailing_return_type,
    STATE(6020), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5935), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [214801] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7280), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9153), 1,
      anon_sym___attribute__,
    ACTIONS(9156), 1,
      anon_sym___attribute,
    ACTIONS(9159), 1,
      anon_sym_requires,
    STATE(5838), 1,
      sym_trailing_return_type,
    STATE(5868), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9147), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_EQ,
      anon_sym_GT2,
  [214866] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7398), 1,
      anon_sym_DASH_GT,
    ACTIONS(9525), 1,
      anon_sym_LBRACK,
    ACTIONS(9574), 1,
      anon_sym_requires,
    STATE(6109), 1,
      sym_trailing_return_type,
    STATE(6145), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9562), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5991), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [214930] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7398), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9197), 1,
      anon_sym_requires,
    STATE(6106), 1,
      sym_trailing_return_type,
    STATE(6136), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9147), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [214994] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8097), 1,
      sym_identifier,
    ACTIONS(8099), 1,
      anon_sym_LPAREN2,
    ACTIONS(8111), 1,
      sym_primitive_type,
    ACTIONS(8125), 1,
      anon_sym_STAR,
    ACTIONS(8127), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8129), 1,
      anon_sym_AMP,
    STATE(2258), 1,
      sym_pointer_type_declarator,
    STATE(5710), 1,
      sym_ms_call_modifier,
    STATE(6615), 1,
      sym__type_declarator,
    STATE(8147), 1,
      sym_ms_based_modifier,
    ACTIONS(8109), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2186), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(53), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [215052] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7398), 1,
      anon_sym_DASH_GT,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(9499), 1,
      anon_sym_requires,
    STATE(6107), 1,
      sym_trailing_return_type,
    STATE(6140), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9274), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5935), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [215116] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7398), 1,
      anon_sym_DASH_GT,
    ACTIONS(7400), 1,
      anon_sym_requires,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    STATE(6133), 1,
      sym_trailing_return_type,
    STATE(6161), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5935), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [215180] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7398), 1,
      anon_sym_DASH_GT,
    ACTIONS(7400), 1,
      anon_sym_requires,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    STATE(6156), 1,
      sym__function_attributes_end,
    STATE(6190), 1,
      sym_trailing_return_type,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [215244] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8097), 1,
      sym_identifier,
    ACTIONS(8099), 1,
      anon_sym_LPAREN2,
    ACTIONS(8111), 1,
      sym_primitive_type,
    ACTIONS(8125), 1,
      anon_sym_STAR,
    ACTIONS(8127), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8129), 1,
      anon_sym_AMP,
    STATE(2258), 1,
      sym_pointer_type_declarator,
    STATE(5744), 1,
      sym_ms_call_modifier,
    STATE(6611), 1,
      sym__type_declarator,
    STATE(8147), 1,
      sym_ms_based_modifier,
    ACTIONS(8109), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2186), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(53), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [215302] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7398), 1,
      anon_sym_DASH_GT,
    ACTIONS(7400), 1,
      anon_sym_requires,
    ACTIONS(9525), 1,
      anon_sym_LBRACK,
    STATE(6118), 1,
      sym_trailing_return_type,
    STATE(6168), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5991), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 4,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [215366] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8097), 1,
      sym_identifier,
    ACTIONS(8099), 1,
      anon_sym_LPAREN2,
    ACTIONS(8111), 1,
      sym_primitive_type,
    ACTIONS(8125), 1,
      anon_sym_STAR,
    ACTIONS(8127), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8129), 1,
      anon_sym_AMP,
    STATE(2258), 1,
      sym_pointer_type_declarator,
    STATE(5705), 1,
      sym_ms_call_modifier,
    STATE(6600), 1,
      sym__type_declarator,
    STATE(8147), 1,
      sym_ms_based_modifier,
    ACTIONS(8109), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2186), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(53), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [215424] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8097), 1,
      sym_identifier,
    ACTIONS(8099), 1,
      anon_sym_LPAREN2,
    ACTIONS(8111), 1,
      sym_primitive_type,
    ACTIONS(8125), 1,
      anon_sym_STAR,
    ACTIONS(8127), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8129), 1,
      anon_sym_AMP,
    STATE(2258), 1,
      sym_pointer_type_declarator,
    STATE(5752), 1,
      sym_ms_call_modifier,
    STATE(6626), 1,
      sym__type_declarator,
    STATE(8147), 1,
      sym_ms_based_modifier,
    ACTIONS(8109), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2186), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
    ACTIONS(53), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
  [215482] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7400), 1,
      anon_sym_requires,
    ACTIONS(7423), 1,
      anon_sym_DASH_GT,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(9298), 1,
      anon_sym___attribute__,
    ACTIONS(9301), 1,
      anon_sym___attribute,
    STATE(6075), 1,
      sym__function_attributes_end,
    STATE(6133), 1,
      sym_trailing_return_type,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5935), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [215545] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7583), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9150), 1,
      anon_sym_requires,
    ACTIONS(9153), 1,
      anon_sym___attribute__,
    ACTIONS(9156), 1,
      anon_sym___attribute,
    STATE(5931), 1,
      sym_trailing_return_type,
    STATE(6060), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9147), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
  [215608] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7162), 1,
      anon_sym_requires,
    ACTIONS(7470), 1,
      anon_sym_DASH_GT,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(9219), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5367), 1,
      sym_trailing_return_type,
    STATE(6173), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [215671] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(9359), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9473), 1,
      sym_identifier,
    ACTIONS(9577), 1,
      anon_sym_LPAREN2,
    ACTIONS(9579), 1,
      anon_sym_LBRACE,
    ACTIONS(9583), 1,
      anon_sym_requires,
    STATE(1766), 1,
      sym_template_type,
    STATE(3175), 1,
      sym_requirement_seq,
    STATE(5890), 1,
      sym_lambda_capture_specifier,
    STATE(6490), 1,
      sym__scope_resolution,
    STATE(7710), 1,
      sym_requires_parameter_list,
    ACTIONS(9581), 2,
      sym_true,
      sym_false,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4126), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [215732] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7583), 1,
      anon_sym_DASH_GT,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(9277), 1,
      anon_sym_requires,
    ACTIONS(9298), 1,
      anon_sym___attribute__,
    ACTIONS(9301), 1,
      anon_sym___attribute,
    STATE(6008), 1,
      sym_trailing_return_type,
    STATE(6061), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9274), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5935), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
  [215795] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(7764), 1,
      anon_sym_STAR,
    ACTIONS(7766), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7768), 1,
      anon_sym_AMP,
    ACTIONS(8199), 1,
      anon_sym___asm,
    STATE(2880), 1,
      sym_parameter_list,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(5939), 1,
      sym__abstract_declarator,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8197), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [215846] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7470), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9134), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9137), 1,
      anon_sym_requires,
    STATE(5380), 1,
      sym_trailing_return_type,
    STATE(6195), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9082), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [215909] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7400), 1,
      anon_sym_requires,
    ACTIONS(7423), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9153), 1,
      anon_sym___attribute__,
    ACTIONS(9156), 1,
      anon_sym___attribute,
    STATE(6070), 1,
      sym__function_attributes_end,
    STATE(6190), 1,
      sym_trailing_return_type,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [215972] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7470), 1,
      anon_sym_DASH_GT,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(9219), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9233), 1,
      anon_sym_requires,
    STATE(5382), 1,
      sym_trailing_return_type,
    STATE(6199), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9213), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [216035] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7326), 1,
      anon_sym_requires,
    ACTIONS(7583), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9153), 1,
      anon_sym___attribute__,
    ACTIONS(9156), 1,
      anon_sym___attribute,
    STATE(5965), 1,
      sym_trailing_return_type,
    STATE(6051), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
  [216098] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(9254), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9479), 1,
      sym_identifier,
    ACTIONS(9585), 1,
      anon_sym_LPAREN2,
    ACTIONS(9587), 1,
      anon_sym_LBRACE,
    ACTIONS(9591), 1,
      anon_sym_requires,
    STATE(1883), 1,
      sym_template_type,
    STATE(2406), 1,
      sym_requirement_seq,
    STATE(5876), 1,
      sym_lambda_capture_specifier,
    STATE(6506), 1,
      sym__scope_resolution,
    STATE(7557), 1,
      sym_requires_parameter_list,
    ACTIONS(9589), 2,
      sym_true,
      sym_false,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(2424), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [216159] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7704), 1,
      anon_sym_STAR,
    ACTIONS(7706), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7708), 1,
      anon_sym_AMP,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(8199), 1,
      anon_sym___asm,
    STATE(2886), 1,
      sym_parameter_list,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(5903), 1,
      sym__abstract_declarator,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8197), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [216210] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(9306), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9491), 1,
      sym_identifier,
    ACTIONS(9593), 1,
      anon_sym_LPAREN2,
    ACTIONS(9595), 1,
      anon_sym_LBRACE,
    ACTIONS(9599), 1,
      anon_sym_requires,
    STATE(2632), 1,
      sym_template_type,
    STATE(3557), 1,
      sym_requirement_seq,
    STATE(5874), 1,
      sym_lambda_capture_specifier,
    STATE(6487), 1,
      sym__scope_resolution,
    STATE(7625), 1,
      sym_requires_parameter_list,
    ACTIONS(9597), 2,
      sym_true,
      sym_false,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3645), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [216271] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(9334), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9475), 1,
      sym_identifier,
    ACTIONS(9601), 1,
      anon_sym_LPAREN2,
    ACTIONS(9603), 1,
      anon_sym_LBRACE,
    ACTIONS(9607), 1,
      anon_sym_requires,
    STATE(2562), 1,
      sym_template_type,
    STATE(3455), 1,
      sym_requirement_seq,
    STATE(5873), 1,
      sym_lambda_capture_specifier,
    STATE(6507), 1,
      sym__scope_resolution,
    STATE(7547), 1,
      sym_requires_parameter_list,
    ACTIONS(9605), 2,
      sym_true,
      sym_false,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3463), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [216332] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7162), 1,
      anon_sym_requires,
    ACTIONS(7470), 1,
      anon_sym_DASH_GT,
    ACTIONS(9525), 1,
      anon_sym_LBRACK,
    ACTIONS(9544), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5368), 1,
      sym_trailing_return_type,
    STATE(6182), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5701), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [216395] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7470), 1,
      anon_sym_DASH_GT,
    ACTIONS(9525), 1,
      anon_sym_LBRACK,
    ACTIONS(9544), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9553), 1,
      anon_sym_requires,
    STATE(5337), 1,
      sym_trailing_return_type,
    STATE(6151), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9527), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5701), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [216458] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(9395), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9495), 1,
      sym_identifier,
    ACTIONS(9577), 1,
      anon_sym_LPAREN2,
    ACTIONS(9579), 1,
      anon_sym_LBRACE,
    ACTIONS(9583), 1,
      anon_sym_requires,
    STATE(3175), 1,
      sym_requirement_seq,
    STATE(3586), 1,
      sym_template_type,
    STATE(5890), 1,
      sym_lambda_capture_specifier,
    STATE(6510), 1,
      sym__scope_resolution,
    STATE(7710), 1,
      sym_requires_parameter_list,
    ACTIONS(9609), 2,
      sym_true,
      sym_false,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4206), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [216519] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7423), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9153), 1,
      anon_sym___attribute__,
    ACTIONS(9156), 1,
      anon_sym___attribute,
    ACTIONS(9197), 1,
      anon_sym_requires,
    STATE(6085), 1,
      sym__function_attributes_end,
    STATE(6106), 1,
      sym_trailing_return_type,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9147), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [216582] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(9282), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9485), 1,
      sym_identifier,
    ACTIONS(9611), 1,
      anon_sym_LPAREN2,
    ACTIONS(9613), 1,
      anon_sym_LBRACE,
    ACTIONS(9617), 1,
      anon_sym_requires,
    STATE(2532), 1,
      sym_template_type,
    STATE(4180), 1,
      sym_requirement_seq,
    STATE(5854), 1,
      sym_lambda_capture_specifier,
    STATE(6500), 1,
      sym__scope_resolution,
    STATE(7655), 1,
      sym_requires_parameter_list,
    ACTIONS(9615), 2,
      sym_true,
      sym_false,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4739), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [216643] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7423), 1,
      anon_sym_DASH_GT,
    ACTIONS(9525), 1,
      anon_sym_LBRACK,
    ACTIONS(9556), 1,
      anon_sym___attribute__,
    ACTIONS(9559), 1,
      anon_sym___attribute,
    ACTIONS(9574), 1,
      anon_sym_requires,
    STATE(6088), 1,
      sym__function_attributes_end,
    STATE(6109), 1,
      sym_trailing_return_type,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9562), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5991), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [216706] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7583), 1,
      anon_sym_DASH_GT,
    ACTIONS(9525), 1,
      anon_sym_LBRACK,
    ACTIONS(9556), 1,
      anon_sym___attribute__,
    ACTIONS(9559), 1,
      anon_sym___attribute,
    ACTIONS(9571), 1,
      anon_sym_requires,
    STATE(5967), 1,
      sym_trailing_return_type,
    STATE(6062), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9562), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5991), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
  [216769] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7326), 1,
      anon_sym_requires,
    ACTIONS(7583), 1,
      anon_sym_DASH_GT,
    ACTIONS(9525), 1,
      anon_sym_LBRACK,
    ACTIONS(9556), 1,
      anon_sym___attribute__,
    ACTIONS(9559), 1,
      anon_sym___attribute,
    STATE(5993), 1,
      sym_trailing_return_type,
    STATE(6054), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5991), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
  [216832] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(7758), 1,
      anon_sym_STAR,
    ACTIONS(7760), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7762), 1,
      anon_sym_AMP,
    ACTIONS(8199), 1,
      anon_sym___attribute,
    STATE(2831), 1,
      sym_parameter_list,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(5954), 1,
      sym__abstract_declarator,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8197), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [216883] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7326), 1,
      anon_sym_requires,
    ACTIONS(7583), 1,
      anon_sym_DASH_GT,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(9298), 1,
      anon_sym___attribute__,
    ACTIONS(9301), 1,
      anon_sym___attribute,
    STATE(5936), 1,
      sym_trailing_return_type,
    STATE(6053), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5935), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
  [216946] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(9439), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9487), 1,
      sym_identifier,
    ACTIONS(9619), 1,
      anon_sym_LPAREN2,
    ACTIONS(9621), 1,
      anon_sym_LBRACE,
    ACTIONS(9625), 1,
      anon_sym_requires,
    STATE(2773), 1,
      sym_template_type,
    STATE(3812), 1,
      sym_requirement_seq,
    STATE(5872), 1,
      sym_lambda_capture_specifier,
    STATE(6477), 1,
      sym__scope_resolution,
    STATE(7503), 1,
      sym_requires_parameter_list,
    ACTIONS(9623), 2,
      sym_true,
      sym_false,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3782), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [217007] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7423), 1,
      anon_sym_DASH_GT,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(9298), 1,
      anon_sym___attribute__,
    ACTIONS(9301), 1,
      anon_sym___attribute,
    ACTIONS(9499), 1,
      anon_sym_requires,
    STATE(6086), 1,
      sym__function_attributes_end,
    STATE(6107), 1,
      sym_trailing_return_type,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9274), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5935), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [217070] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7400), 1,
      anon_sym_requires,
    ACTIONS(7423), 1,
      anon_sym_DASH_GT,
    ACTIONS(9525), 1,
      anon_sym_LBRACK,
    ACTIONS(9556), 1,
      anon_sym___attribute__,
    ACTIONS(9559), 1,
      anon_sym___attribute,
    STATE(6077), 1,
      sym__function_attributes_end,
    STATE(6118), 1,
      sym_trailing_return_type,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5991), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_GT2,
  [217133] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7162), 1,
      anon_sym_requires,
    ACTIONS(7470), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9134), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5366), 1,
      sym_trailing_return_type,
    STATE(6167), 1,
      sym__function_attributes_end,
    STATE(6630), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5334), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5352), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [217196] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(7326), 1,
      anon_sym_requires,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7720), 1,
      anon_sym_DASH_GT,
    ACTIONS(9525), 1,
      anon_sym_LBRACK,
    STATE(5993), 1,
      sym_trailing_return_type,
    STATE(6305), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9514), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5991), 2,
      sym__function_postfix,
      sym_requires_clause,
  [217258] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(7326), 1,
      anon_sym_requires,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7720), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    STATE(5965), 1,
      sym_trailing_return_type,
    STATE(6303), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9051), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
  [217320] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7720), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9150), 1,
      anon_sym_requires,
    STATE(5931), 1,
      sym_trailing_return_type,
    STATE(6311), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9051), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9147), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
  [217382] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7720), 1,
      anon_sym_DASH_GT,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(9277), 1,
      anon_sym_requires,
    STATE(6008), 1,
      sym_trailing_return_type,
    STATE(6313), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9200), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9274), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5935), 2,
      sym__function_postfix,
      sym_requires_clause,
  [217444] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7720), 1,
      anon_sym_DASH_GT,
    ACTIONS(9525), 1,
      anon_sym_LBRACK,
    ACTIONS(9571), 1,
      anon_sym_requires,
    STATE(5967), 1,
      sym_trailing_return_type,
    STATE(6314), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9514), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9562), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5991), 2,
      sym__function_postfix,
      sym_requires_clause,
  [217506] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(7733), 1,
      anon_sym_DASH_GT,
    ACTIONS(7756), 1,
      anon_sym_requires,
    ACTIONS(9059), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    STATE(6221), 1,
      sym__function_attributes_end,
    STATE(6369), 1,
      sym_trailing_return_type,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9051), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
  [217568] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(7733), 1,
      anon_sym_DASH_GT,
    ACTIONS(7756), 1,
      anon_sym_requires,
    ACTIONS(9208), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    STATE(6272), 1,
      sym__function_attributes_end,
    STATE(6372), 1,
      sym_trailing_return_type,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9200), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
  [217630] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(7733), 1,
      anon_sym_DASH_GT,
    ACTIONS(7756), 1,
      anon_sym_requires,
    ACTIONS(9522), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9525), 1,
      anon_sym_LBRACK,
    STATE(6274), 1,
      sym__function_attributes_end,
    STATE(6373), 1,
      sym_trailing_return_type,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9514), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5701), 2,
      sym__function_postfix,
      sym_requires_clause,
  [217692] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(7326), 1,
      anon_sym_requires,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7720), 1,
      anon_sym_DASH_GT,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    STATE(5936), 1,
      sym_trailing_return_type,
    STATE(6304), 1,
      sym__function_attributes_end,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9200), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5935), 2,
      sym__function_postfix,
      sym_requires_clause,
  [217754] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(7733), 1,
      anon_sym_DASH_GT,
    ACTIONS(9059), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9326), 1,
      anon_sym_requires,
    STATE(6246), 1,
      sym__function_attributes_end,
    STATE(6388), 1,
      sym_trailing_return_type,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9051), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9082), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
  [217816] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(7733), 1,
      anon_sym_DASH_GT,
    ACTIONS(9208), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(9533), 1,
      anon_sym_requires,
    STATE(6251), 1,
      sym__function_attributes_end,
    STATE(6391), 1,
      sym_trailing_return_type,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9200), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9213), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
  [217878] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6930), 1,
      anon_sym___asm,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(7733), 1,
      anon_sym_DASH_GT,
    ACTIONS(9522), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9525), 1,
      anon_sym_LBRACK,
    ACTIONS(9627), 1,
      anon_sym_requires,
    STATE(6256), 1,
      sym__function_attributes_end,
    STATE(6393), 1,
      sym_trailing_return_type,
    STATE(6606), 1,
      sym_gnu_asm_expression,
    ACTIONS(6928), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(9514), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    ACTIONS(9527), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5385), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5575), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(5701), 2,
      sym__function_postfix,
      sym_requires_clause,
  [217940] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8352), 1,
      anon_sym_COMMA,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9632), 1,
      anon_sym_SEMI,
    ACTIONS(9634), 1,
      anon_sym_LBRACE,
    ACTIONS(9636), 1,
      anon_sym_LBRACK,
    ACTIONS(9638), 1,
      anon_sym_EQ,
    ACTIONS(9640), 1,
      anon_sym_COLON,
    ACTIONS(9642), 1,
      anon_sym_try,
    STATE(2049), 1,
      sym_compound_statement,
    STATE(2050), 1,
      sym_default_method_clause,
    STATE(2051), 1,
      sym_delete_method_clause,
    STATE(2052), 1,
      sym_pure_virtual_clause,
    STATE(2053), 1,
      sym_try_statement,
    STATE(2834), 1,
      sym_parameter_list,
    STATE(6324), 1,
      sym__function_declarator_seq,
    STATE(6695), 1,
      sym_bitfield_clause,
    STATE(6714), 1,
      sym_initializer_list,
    STATE(6719), 1,
      aux_sym_field_declaration_repeat1,
    STATE(7921), 1,
      sym_attribute_specifier,
    STATE(6210), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [218014] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(8264), 1,
      anon_sym_LPAREN2,
    ACTIONS(8272), 1,
      sym_identifier,
    ACTIONS(8274), 1,
      anon_sym_STAR,
    ACTIONS(8276), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8278), 1,
      anon_sym_AMP,
    STATE(5861), 1,
      sym_ms_call_modifier,
    STATE(6580), 1,
      sym__field_declarator,
    STATE(6701), 1,
      sym_operator_name,
    STATE(7946), 1,
      sym_ms_based_modifier,
    ACTIONS(1779), 6,
      anon_sym___cdecl,
      anon_sym___clrcall,
      anon_sym___stdcall,
      anon_sym___fastcall,
      anon_sym___thiscall,
      anon_sym___vectorcall,
    STATE(6285), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [218068] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8352), 1,
      anon_sym_COMMA,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9636), 1,
      anon_sym_LBRACK,
    ACTIONS(9640), 1,
      anon_sym_COLON,
    ACTIONS(9644), 1,
      anon_sym_SEMI,
    ACTIONS(9646), 1,
      anon_sym_LBRACE,
    ACTIONS(9648), 1,
      anon_sym_EQ,
    ACTIONS(9650), 1,
      anon_sym_try,
    STATE(2065), 1,
      sym_compound_statement,
    STATE(2066), 1,
      sym_default_method_clause,
    STATE(2067), 1,
      sym_delete_method_clause,
    STATE(2068), 1,
      sym_pure_virtual_clause,
    STATE(2069), 1,
      sym_try_statement,
    STATE(2834), 1,
      sym_parameter_list,
    STATE(6324), 1,
      sym__function_declarator_seq,
    STATE(6682), 1,
      aux_sym_field_declaration_repeat1,
    STATE(6691), 1,
      sym_initializer_list,
    STATE(6723), 1,
      sym_bitfield_clause,
    STATE(8044), 1,
      sym_attribute_specifier,
    STATE(6210), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [218142] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(8352), 1,
      anon_sym_COMMA,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9636), 1,
      anon_sym_LBRACK,
    ACTIONS(9640), 1,
      anon_sym_COLON,
    ACTIONS(9652), 1,
      anon_sym_SEMI,
    ACTIONS(9654), 1,
      anon_sym_LBRACE,
    ACTIONS(9656), 1,
      anon_sym_EQ,
    ACTIONS(9658), 1,
      anon_sym_try,
    STATE(1746), 1,
      sym_compound_statement,
    STATE(1751), 1,
      sym_default_method_clause,
    STATE(1752), 1,
      sym_delete_method_clause,
    STATE(1753), 1,
      sym_pure_virtual_clause,
    STATE(1756), 1,
      sym_try_statement,
    STATE(2834), 1,
      sym_parameter_list,
    STATE(6324), 1,
      sym__function_declarator_seq,
    STATE(6674), 1,
      sym_initializer_list,
    STATE(6683), 1,
      aux_sym_field_declaration_repeat1,
    STATE(6711), 1,
      sym_bitfield_clause,
    STATE(8354), 1,
      sym_attribute_specifier,
    STATE(6210), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [218216] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(9662), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    STATE(4208), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5387), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9660), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [218258] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(9666), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    STATE(4208), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5372), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9664), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [218300] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(7932), 1,
      anon_sym_STAR,
    ACTIONS(7934), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7936), 1,
      anon_sym_AMP,
    ACTIONS(8199), 1,
      anon_sym___attribute,
    STATE(2930), 1,
      sym_parameter_list,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(6139), 1,
      sym__abstract_declarator,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8197), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [218349] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9670), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9668), 20,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_noexcept,
      anon_sym_throw,
      anon_sym_requires,
  [218380] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9679), 1,
      anon_sym_requires,
    ACTIONS(9676), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5714), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9674), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9672), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [218418] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(7917), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9471), 1,
      sym_identifier,
    ACTIONS(9682), 1,
      anon_sym_LPAREN2,
    ACTIONS(9686), 1,
      anon_sym_requires,
    STATE(2158), 1,
      sym_template_type,
    STATE(5857), 1,
      sym_lambda_capture_specifier,
    STATE(6486), 1,
      sym__scope_resolution,
    ACTIONS(9684), 2,
      sym_true,
      sym_false,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6396), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [218470] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(9395), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9495), 1,
      sym_identifier,
    ACTIONS(9583), 1,
      anon_sym_requires,
    ACTIONS(9688), 1,
      anon_sym_LPAREN2,
    STATE(3586), 1,
      sym_template_type,
    STATE(5890), 1,
      sym_lambda_capture_specifier,
    STATE(6510), 1,
      sym__scope_resolution,
    ACTIONS(9690), 2,
      sym_true,
      sym_false,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4191), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [218522] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(7853), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9493), 1,
      sym_identifier,
    ACTIONS(9692), 1,
      anon_sym_LPAREN2,
    ACTIONS(9696), 1,
      anon_sym_requires,
    STATE(4327), 1,
      sym_template_type,
    STATE(5856), 1,
      sym_lambda_capture_specifier,
    STATE(6508), 1,
      sym__scope_resolution,
    ACTIONS(9694), 2,
      sym_true,
      sym_false,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5810), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [218574] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(9282), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9485), 1,
      sym_identifier,
    ACTIONS(9617), 1,
      anon_sym_requires,
    ACTIONS(9698), 1,
      anon_sym_LPAREN2,
    STATE(2532), 1,
      sym_template_type,
    STATE(5854), 1,
      sym_lambda_capture_specifier,
    STATE(6500), 1,
      sym__scope_resolution,
    ACTIONS(9700), 2,
      sym_true,
      sym_false,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4748), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [218626] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(9583), 1,
      anon_sym_requires,
    ACTIONS(9688), 1,
      anon_sym_LPAREN2,
    ACTIONS(9702), 1,
      sym_identifier,
    ACTIONS(9704), 1,
      anon_sym_COLON_COLON,
    STATE(1766), 1,
      sym_template_type,
    STATE(5890), 1,
      sym_lambda_capture_specifier,
    STATE(6522), 1,
      sym__scope_resolution,
    ACTIONS(9706), 2,
      sym_true,
      sym_false,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5937), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [218678] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(9583), 1,
      anon_sym_requires,
    ACTIONS(9688), 1,
      anon_sym_LPAREN2,
    ACTIONS(9702), 1,
      sym_identifier,
    ACTIONS(9704), 1,
      anon_sym_COLON_COLON,
    STATE(1766), 1,
      sym_template_type,
    STATE(5890), 1,
      sym_lambda_capture_specifier,
    STATE(6522), 1,
      sym__scope_resolution,
    ACTIONS(9708), 2,
      sym_true,
      sym_false,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3255), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [218730] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(7992), 1,
      anon_sym_STAR,
    ACTIONS(7994), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7996), 1,
      anon_sym_AMP,
    STATE(2838), 1,
      sym_parameter_list,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(6240), 1,
      sym__abstract_declarator,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8197), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [218776] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(9710), 1,
      sym_identifier,
    ACTIONS(9712), 1,
      anon_sym_LPAREN2,
    ACTIONS(9714), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9718), 1,
      anon_sym_requires,
    STATE(2207), 1,
      sym_template_type,
    STATE(5855), 1,
      sym_lambda_capture_specifier,
    STATE(6483), 1,
      sym__scope_resolution,
    ACTIONS(9716), 2,
      sym_true,
      sym_false,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(2191), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [218828] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(9710), 1,
      sym_identifier,
    ACTIONS(9712), 1,
      anon_sym_LPAREN2,
    ACTIONS(9714), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9718), 1,
      anon_sym_requires,
    STATE(2207), 1,
      sym_template_type,
    STATE(5855), 1,
      sym_lambda_capture_specifier,
    STATE(6483), 1,
      sym__scope_resolution,
    ACTIONS(9720), 2,
      sym_true,
      sym_false,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(1607), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [218880] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(7917), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9471), 1,
      sym_identifier,
    ACTIONS(9682), 1,
      anon_sym_LPAREN2,
    ACTIONS(9686), 1,
      anon_sym_requires,
    STATE(2158), 1,
      sym_template_type,
    STATE(5857), 1,
      sym_lambda_capture_specifier,
    STATE(6486), 1,
      sym__scope_resolution,
    ACTIONS(9722), 2,
      sym_true,
      sym_false,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6407), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [218932] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(7917), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9471), 1,
      sym_identifier,
    ACTIONS(9682), 1,
      anon_sym_LPAREN2,
    ACTIONS(9686), 1,
      anon_sym_requires,
    STATE(2158), 1,
      sym_template_type,
    STATE(5857), 1,
      sym_lambda_capture_specifier,
    STATE(6486), 1,
      sym__scope_resolution,
    ACTIONS(9724), 2,
      sym_true,
      sym_false,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5532), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [218984] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(7903), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9489), 1,
      sym_identifier,
    ACTIONS(9712), 1,
      anon_sym_LPAREN2,
    ACTIONS(9718), 1,
      anon_sym_requires,
    STATE(2158), 1,
      sym_template_type,
    STATE(5846), 1,
      sym_lambda_capture_specifier,
    STATE(6498), 1,
      sym__scope_resolution,
    ACTIONS(9726), 2,
      sym_true,
      sym_false,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5351), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [219036] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(7903), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9489), 1,
      sym_identifier,
    ACTIONS(9712), 1,
      anon_sym_LPAREN2,
    ACTIONS(9718), 1,
      anon_sym_requires,
    STATE(2158), 1,
      sym_template_type,
    STATE(5846), 1,
      sym_lambda_capture_specifier,
    STATE(6498), 1,
      sym__scope_resolution,
    ACTIONS(9720), 2,
      sym_true,
      sym_false,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(1607), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [219088] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9728), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6057), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(6059), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [219120] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9666), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9664), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [219154] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9477), 1,
      sym_identifier,
    ACTIONS(9583), 1,
      anon_sym_requires,
    ACTIONS(9688), 1,
      anon_sym_LPAREN2,
    STATE(1766), 1,
      sym_template_type,
    STATE(5890), 1,
      sym_lambda_capture_specifier,
    STATE(6488), 1,
      sym__scope_resolution,
    ACTIONS(9730), 2,
      sym_true,
      sym_false,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6526), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [219206] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(9395), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9495), 1,
      sym_identifier,
    ACTIONS(9583), 1,
      anon_sym_requires,
    ACTIONS(9688), 1,
      anon_sym_LPAREN2,
    STATE(3586), 1,
      sym_template_type,
    STATE(5890), 1,
      sym_lambda_capture_specifier,
    STATE(6510), 1,
      sym__scope_resolution,
    ACTIONS(9708), 2,
      sym_true,
      sym_false,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3255), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [219258] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(9359), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9473), 1,
      sym_identifier,
    ACTIONS(9583), 1,
      anon_sym_requires,
    ACTIONS(9688), 1,
      anon_sym_LPAREN2,
    STATE(1766), 1,
      sym_template_type,
    STATE(5890), 1,
      sym_lambda_capture_specifier,
    STATE(6490), 1,
      sym__scope_resolution,
    ACTIONS(9708), 2,
      sym_true,
      sym_false,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3255), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [219310] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(9439), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9487), 1,
      sym_identifier,
    ACTIONS(9625), 1,
      anon_sym_requires,
    ACTIONS(9732), 1,
      anon_sym_LPAREN2,
    STATE(2773), 1,
      sym_template_type,
    STATE(5872), 1,
      sym_lambda_capture_specifier,
    STATE(6477), 1,
      sym__scope_resolution,
    ACTIONS(9734), 2,
      sym_true,
      sym_false,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3823), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [219362] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(9439), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9487), 1,
      sym_identifier,
    ACTIONS(9625), 1,
      anon_sym_requires,
    ACTIONS(9732), 1,
      anon_sym_LPAREN2,
    STATE(2773), 1,
      sym_template_type,
    STATE(5872), 1,
      sym_lambda_capture_specifier,
    STATE(6477), 1,
      sym__scope_resolution,
    ACTIONS(9736), 2,
      sym_true,
      sym_false,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3824), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [219414] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(9282), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9485), 1,
      sym_identifier,
    ACTIONS(9617), 1,
      anon_sym_requires,
    ACTIONS(9698), 1,
      anon_sym_LPAREN2,
    STATE(2532), 1,
      sym_template_type,
    STATE(5854), 1,
      sym_lambda_capture_specifier,
    STATE(6500), 1,
      sym__scope_resolution,
    ACTIONS(9738), 2,
      sym_true,
      sym_false,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4171), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [219466] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(9710), 1,
      sym_identifier,
    ACTIONS(9712), 1,
      anon_sym_LPAREN2,
    ACTIONS(9714), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9718), 1,
      anon_sym_requires,
    STATE(2207), 1,
      sym_template_type,
    STATE(5855), 1,
      sym_lambda_capture_specifier,
    STATE(6483), 1,
      sym__scope_resolution,
    ACTIONS(9740), 2,
      sym_true,
      sym_false,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(2218), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [219518] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(133), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(3828), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8125), 1,
      anon_sym_STAR,
    ACTIONS(9742), 1,
      sym_identifier,
    ACTIONS(9744), 1,
      anon_sym_template,
    STATE(2119), 1,
      sym_dependent_type_identifier,
    STATE(2137), 1,
      sym_template_type,
    STATE(2161), 1,
      sym_qualified_type_identifier,
    STATE(2777), 1,
      sym_pointer_type_declarator,
    STATE(2780), 1,
      sym_template_function,
    STATE(2781), 1,
      sym_destructor_name,
    STATE(2784), 1,
      sym_dependent_identifier,
    STATE(2787), 1,
      sym_qualified_identifier,
    STATE(2790), 1,
      sym_operator_name,
    STATE(5360), 1,
      sym__scope_resolution,
    STATE(6819), 1,
      sym_operator_cast,
    STATE(6861), 1,
      sym_qualified_operator_cast_identifier,
    STATE(8147), 1,
      sym_ms_based_modifier,
    STATE(8512), 1,
      sym_decltype,
  [219588] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9728), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(9746), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(6092), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(6094), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [219622] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7966), 1,
      anon_sym_STAR,
    ACTIONS(7968), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7970), 1,
      anon_sym_AMP,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8199), 1,
      anon_sym___attribute,
    STATE(3006), 1,
      sym_parameter_list,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6216), 1,
      sym__abstract_declarator,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8197), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [219670] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(8101), 1,
      anon_sym_STAR,
    ACTIONS(9748), 1,
      sym_identifier,
    ACTIONS(9750), 1,
      anon_sym_TILDE,
    ACTIONS(9752), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9754), 1,
      anon_sym_template,
    ACTIONS(9756), 1,
      anon_sym_operator,
    STATE(2119), 1,
      sym_dependent_type_identifier,
    STATE(2137), 1,
      sym_template_type,
    STATE(2161), 1,
      sym_qualified_type_identifier,
    STATE(2777), 1,
      sym_pointer_type_declarator,
    STATE(2780), 1,
      sym_template_function,
    STATE(2781), 1,
      sym_destructor_name,
    STATE(2784), 1,
      sym_dependent_identifier,
    STATE(2787), 1,
      sym_qualified_identifier,
    STATE(2790), 1,
      sym_operator_name,
    STATE(5363), 1,
      sym__scope_resolution,
    STATE(6819), 1,
      sym_operator_cast,
    STATE(6861), 1,
      sym_qualified_operator_cast_identifier,
    STATE(8208), 1,
      sym_ms_based_modifier,
    STATE(8512), 1,
      sym_decltype,
  [219740] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(3766), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9471), 1,
      sym_identifier,
    ACTIONS(9712), 1,
      anon_sym_LPAREN2,
    ACTIONS(9718), 1,
      anon_sym_requires,
    STATE(2158), 1,
      sym_template_type,
    STATE(5846), 1,
      sym_lambda_capture_specifier,
    STATE(6476), 1,
      sym__scope_resolution,
    ACTIONS(9720), 2,
      sym_true,
      sym_false,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(1607), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [219792] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(7881), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9489), 1,
      sym_identifier,
    ACTIONS(9682), 1,
      anon_sym_LPAREN2,
    ACTIONS(9686), 1,
      anon_sym_requires,
    STATE(2158), 1,
      sym_template_type,
    STATE(5857), 1,
      sym_lambda_capture_specifier,
    STATE(6504), 1,
      sym__scope_resolution,
    ACTIONS(9758), 2,
      sym_true,
      sym_false,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5485), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [219844] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7162), 1,
      anon_sym_requires,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9211), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9200), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [219882] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7162), 1,
      anon_sym_requires,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5701), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9525), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9514), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [219920] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7162), 1,
      anon_sym_requires,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5714), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9674), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9672), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [219958] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7162), 1,
      anon_sym_requires,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5773), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9762), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9760), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [219996] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(7875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9483), 1,
      sym_identifier,
    ACTIONS(9617), 1,
      anon_sym_requires,
    ACTIONS(9698), 1,
      anon_sym_LPAREN2,
    STATE(2532), 1,
      sym_template_type,
    STATE(5854), 1,
      sym_lambda_capture_specifier,
    STATE(6528), 1,
      sym__scope_resolution,
    ACTIONS(9764), 2,
      sym_true,
      sym_false,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6125), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [220048] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9477), 1,
      sym_identifier,
    ACTIONS(9583), 1,
      anon_sym_requires,
    ACTIONS(9688), 1,
      anon_sym_LPAREN2,
    STATE(1766), 1,
      sym_template_type,
    STATE(5890), 1,
      sym_lambda_capture_specifier,
    STATE(6488), 1,
      sym__scope_resolution,
    ACTIONS(9766), 2,
      sym_true,
      sym_false,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6501), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [220100] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9662), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9660), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [220134] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(7903), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9489), 1,
      sym_identifier,
    ACTIONS(9712), 1,
      anon_sym_LPAREN2,
    ACTIONS(9718), 1,
      anon_sym_requires,
    STATE(2158), 1,
      sym_template_type,
    STATE(5846), 1,
      sym_lambda_capture_specifier,
    STATE(6498), 1,
      sym__scope_resolution,
    ACTIONS(9768), 2,
      sym_true,
      sym_false,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5361), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [220186] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9477), 1,
      sym_identifier,
    ACTIONS(9583), 1,
      anon_sym_requires,
    ACTIONS(9688), 1,
      anon_sym_LPAREN2,
    STATE(1766), 1,
      sym_template_type,
    STATE(5890), 1,
      sym_lambda_capture_specifier,
    STATE(6488), 1,
      sym__scope_resolution,
    ACTIONS(9708), 2,
      sym_true,
      sym_false,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3255), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [220238] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(9334), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9475), 1,
      sym_identifier,
    ACTIONS(9607), 1,
      anon_sym_requires,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    STATE(2562), 1,
      sym_template_type,
    STATE(5873), 1,
      sym_lambda_capture_specifier,
    STATE(6507), 1,
      sym__scope_resolution,
    ACTIONS(9772), 2,
      sym_true,
      sym_false,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3397), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [220290] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(3766), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9471), 1,
      sym_identifier,
    ACTIONS(9712), 1,
      anon_sym_LPAREN2,
    ACTIONS(9718), 1,
      anon_sym_requires,
    STATE(2158), 1,
      sym_template_type,
    STATE(5846), 1,
      sym_lambda_capture_specifier,
    STATE(6476), 1,
      sym__scope_resolution,
    ACTIONS(9774), 2,
      sym_true,
      sym_false,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6185), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [220342] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(7875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9483), 1,
      sym_identifier,
    ACTIONS(9617), 1,
      anon_sym_requires,
    ACTIONS(9698), 1,
      anon_sym_LPAREN2,
    STATE(2532), 1,
      sym_template_type,
    STATE(5854), 1,
      sym_lambda_capture_specifier,
    STATE(6528), 1,
      sym__scope_resolution,
    ACTIONS(9776), 2,
      sym_true,
      sym_false,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6143), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [220394] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(7875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9483), 1,
      sym_identifier,
    ACTIONS(9617), 1,
      anon_sym_requires,
    ACTIONS(9698), 1,
      anon_sym_LPAREN2,
    STATE(2532), 1,
      sym_template_type,
    STATE(5854), 1,
      sym_lambda_capture_specifier,
    STATE(6528), 1,
      sym__scope_resolution,
    ACTIONS(9738), 2,
      sym_true,
      sym_false,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4171), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [220446] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9137), 1,
      anon_sym_requires,
    ACTIONS(9082), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9062), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9051), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [220484] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9233), 1,
      anon_sym_requires,
    ACTIONS(9213), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9211), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9200), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [220522] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9662), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    STATE(4311), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5683), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9660), 13,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [220562] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9553), 1,
      anon_sym_requires,
    ACTIONS(9527), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5701), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9525), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9514), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [220600] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(133), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(3206), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8125), 1,
      anon_sym_STAR,
    ACTIONS(9778), 1,
      sym_identifier,
    ACTIONS(9780), 1,
      anon_sym_template,
    STATE(2119), 1,
      sym_dependent_type_identifier,
    STATE(2137), 1,
      sym_template_type,
    STATE(2161), 1,
      sym_qualified_type_identifier,
    STATE(2777), 1,
      sym_pointer_type_declarator,
    STATE(2780), 1,
      sym_template_function,
    STATE(2781), 1,
      sym_destructor_name,
    STATE(2784), 1,
      sym_dependent_identifier,
    STATE(2787), 1,
      sym_qualified_identifier,
    STATE(2790), 1,
      sym_operator_name,
    STATE(5383), 1,
      sym__scope_resolution,
    STATE(6819), 1,
      sym_operator_cast,
    STATE(6861), 1,
      sym_qualified_operator_cast_identifier,
    STATE(8147), 1,
      sym_ms_based_modifier,
    STATE(8512), 1,
      sym_decltype,
  [220670] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(7853), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9493), 1,
      sym_identifier,
    ACTIONS(9692), 1,
      anon_sym_LPAREN2,
    ACTIONS(9696), 1,
      anon_sym_requires,
    STATE(4327), 1,
      sym_template_type,
    STATE(5856), 1,
      sym_lambda_capture_specifier,
    STATE(6508), 1,
      sym__scope_resolution,
    ACTIONS(9782), 2,
      sym_true,
      sym_false,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5782), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [220722] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9666), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    STATE(4311), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5623), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9664), 13,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [220762] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(7853), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9493), 1,
      sym_identifier,
    ACTIONS(9692), 1,
      anon_sym_LPAREN2,
    ACTIONS(9696), 1,
      anon_sym_requires,
    STATE(4327), 1,
      sym_template_type,
    STATE(5856), 1,
      sym_lambda_capture_specifier,
    STATE(6508), 1,
      sym__scope_resolution,
    ACTIONS(9784), 2,
      sym_true,
      sym_false,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5800), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [220814] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9788), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9786), 16,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [220848] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(7881), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9489), 1,
      sym_identifier,
    ACTIONS(9682), 1,
      anon_sym_LPAREN2,
    ACTIONS(9686), 1,
      anon_sym_requires,
    STATE(2158), 1,
      sym_template_type,
    STATE(5857), 1,
      sym_lambda_capture_specifier,
    STATE(6504), 1,
      sym__scope_resolution,
    ACTIONS(9790), 2,
      sym_true,
      sym_false,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5531), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [220900] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(7881), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9489), 1,
      sym_identifier,
    ACTIONS(9682), 1,
      anon_sym_LPAREN2,
    ACTIONS(9686), 1,
      anon_sym_requires,
    STATE(2158), 1,
      sym_template_type,
    STATE(5857), 1,
      sym_lambda_capture_specifier,
    STATE(6504), 1,
      sym__scope_resolution,
    ACTIONS(9724), 2,
      sym_true,
      sym_false,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5532), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [220952] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(9583), 1,
      anon_sym_requires,
    ACTIONS(9688), 1,
      anon_sym_LPAREN2,
    ACTIONS(9702), 1,
      sym_identifier,
    ACTIONS(9704), 1,
      anon_sym_COLON_COLON,
    STATE(1766), 1,
      sym_template_type,
    STATE(5890), 1,
      sym_lambda_capture_specifier,
    STATE(6522), 1,
      sym__scope_resolution,
    ACTIONS(9792), 2,
      sym_true,
      sym_false,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(5984), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [221004] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(9359), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9473), 1,
      sym_identifier,
    ACTIONS(9583), 1,
      anon_sym_requires,
    ACTIONS(9688), 1,
      anon_sym_LPAREN2,
    STATE(1766), 1,
      sym_template_type,
    STATE(5890), 1,
      sym_lambda_capture_specifier,
    STATE(6490), 1,
      sym__scope_resolution,
    ACTIONS(9794), 2,
      sym_true,
      sym_false,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(4154), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [221056] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9799), 1,
      anon_sym_requires,
    ACTIONS(9796), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5773), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9762), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9760), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [221094] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(9254), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9479), 1,
      sym_identifier,
    ACTIONS(9591), 1,
      anon_sym_requires,
    ACTIONS(9802), 1,
      anon_sym_LPAREN2,
    STATE(1883), 1,
      sym_template_type,
    STATE(5876), 1,
      sym_lambda_capture_specifier,
    STATE(6506), 1,
      sym__scope_resolution,
    ACTIONS(9804), 2,
      sym_true,
      sym_false,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(2396), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [221146] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(9254), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9479), 1,
      sym_identifier,
    ACTIONS(9591), 1,
      anon_sym_requires,
    ACTIONS(9802), 1,
      anon_sym_LPAREN2,
    STATE(1883), 1,
      sym_template_type,
    STATE(5876), 1,
      sym_lambda_capture_specifier,
    STATE(6506), 1,
      sym__scope_resolution,
    ACTIONS(9806), 2,
      sym_true,
      sym_false,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(2397), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [221198] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9810), 1,
      anon_sym_LPAREN2,
    STATE(5599), 1,
      sym_preproc_argument_list,
    ACTIONS(9812), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9808), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [221232] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(9306), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9491), 1,
      sym_identifier,
    ACTIONS(9599), 1,
      anon_sym_requires,
    ACTIONS(9814), 1,
      anon_sym_LPAREN2,
    STATE(2632), 1,
      sym_template_type,
    STATE(5874), 1,
      sym_lambda_capture_specifier,
    STATE(6487), 1,
      sym__scope_resolution,
    ACTIONS(9816), 2,
      sym_true,
      sym_false,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3559), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [221284] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(9306), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9491), 1,
      sym_identifier,
    ACTIONS(9599), 1,
      anon_sym_requires,
    ACTIONS(9814), 1,
      anon_sym_LPAREN2,
    STATE(2632), 1,
      sym_template_type,
    STATE(5874), 1,
      sym_lambda_capture_specifier,
    STATE(6487), 1,
      sym__scope_resolution,
    ACTIONS(9818), 2,
      sym_true,
      sym_false,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3548), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [221336] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(3766), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9471), 1,
      sym_identifier,
    ACTIONS(9712), 1,
      anon_sym_LPAREN2,
    ACTIONS(9718), 1,
      anon_sym_requires,
    STATE(2158), 1,
      sym_template_type,
    STATE(5846), 1,
      sym_lambda_capture_specifier,
    STATE(6476), 1,
      sym__scope_resolution,
    ACTIONS(9820), 2,
      sym_true,
      sym_false,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(6160), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [221388] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(2017), 1,
      anon_sym_LBRACK,
    ACTIONS(9334), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9475), 1,
      sym_identifier,
    ACTIONS(9607), 1,
      anon_sym_requires,
    ACTIONS(9770), 1,
      anon_sym_LPAREN2,
    STATE(2562), 1,
      sym_template_type,
    STATE(5873), 1,
      sym_lambda_capture_specifier,
    STATE(6507), 1,
      sym__scope_resolution,
    ACTIONS(9822), 2,
      sym_true,
      sym_false,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    STATE(3398), 8,
      sym__class_name,
      sym_constraint_conjunction,
      sym_constraint_disjunction,
      sym__requirement_clause_constraint,
      sym_requires_expression,
      sym_lambda_expression,
      sym_fold_expression,
      sym_qualified_type_identifier,
  [221440] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7162), 1,
      anon_sym_requires,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9062), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9051), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [221478] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9824), 1,
      anon_sym_requires,
    ACTIONS(9676), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5714), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9674), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9672), 11,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [221515] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7853), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8638), 1,
      anon_sym_LBRACE,
    ACTIONS(9493), 1,
      sym_identifier,
    STATE(4327), 1,
      sym_template_type,
    STATE(4814), 1,
      sym_field_declaration_list,
    STATE(4867), 1,
      sym__class_declaration_item,
    STATE(6508), 1,
      sym__scope_resolution,
    STATE(6825), 1,
      sym_virtual_specifier,
    STATE(7611), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4298), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5492), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [221574] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5130), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(5132), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [221603] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(5140), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [221632] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9827), 1,
      sym_identifier,
    ACTIONS(9829), 1,
      anon_sym_RPAREN,
    ACTIONS(9831), 1,
      anon_sym_LPAREN2,
    ACTIONS(9833), 1,
      anon_sym_defined,
    ACTIONS(9839), 1,
      sym_number_literal,
    ACTIONS(9835), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9837), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9841), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5523), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [221675] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(111), 1,
      anon_sym___asm,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(9845), 1,
      anon_sym_LPAREN2,
    ACTIONS(9847), 1,
      anon_sym_SEMI,
    ACTIONS(9849), 1,
      anon_sym_LBRACE,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(9853), 1,
      anon_sym_EQ,
    ACTIONS(9857), 1,
      anon_sym_try,
    STATE(672), 1,
      sym_compound_statement,
    STATE(674), 1,
      sym_try_statement,
    STATE(2922), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(7146), 1,
      sym_gnu_asm_expression,
    STATE(7149), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(9855), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7535), 2,
      sym_argument_list,
      sym_initializer_list,
  [221736] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7881), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8479), 1,
      anon_sym_LBRACE,
    ACTIONS(9489), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(4429), 1,
      sym_field_declaration_list,
    STATE(4629), 1,
      sym__class_declaration_item,
    STATE(6504), 1,
      sym__scope_resolution,
    STATE(7010), 1,
      sym_virtual_specifier,
    STATE(7709), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4177), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5519), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [221795] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7881), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8479), 1,
      anon_sym_LBRACE,
    ACTIONS(9489), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(4429), 1,
      sym_field_declaration_list,
    STATE(4692), 1,
      sym__class_declaration_item,
    STATE(6504), 1,
      sym__scope_resolution,
    STATE(7010), 1,
      sym_virtual_specifier,
    STATE(7709), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4177), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [221854] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5513), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    ACTIONS(9861), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9859), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [221887] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7881), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8479), 1,
      anon_sym_LBRACE,
    ACTIONS(9489), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(4429), 1,
      sym_field_declaration_list,
    STATE(4633), 1,
      sym__class_declaration_item,
    STATE(6504), 1,
      sym__scope_resolution,
    STATE(7010), 1,
      sym_virtual_specifier,
    STATE(7709), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4177), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [221946] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9216), 1,
      anon_sym_requires,
    ACTIONS(9213), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9211), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9200), 11,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [221983] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5166), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(5168), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [222012] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1913), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(1911), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [222041] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7853), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8638), 1,
      anon_sym_LBRACE,
    ACTIONS(9493), 1,
      sym_identifier,
    STATE(4327), 1,
      sym_template_type,
    STATE(4814), 1,
      sym_field_declaration_list,
    STATE(4872), 1,
      sym__class_declaration_item,
    STATE(6508), 1,
      sym__scope_resolution,
    STATE(6825), 1,
      sym_virtual_specifier,
    STATE(7611), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4298), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [222100] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7881), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9489), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2461), 1,
      sym__class_declaration_item,
    STATE(3611), 1,
      sym_field_declaration_list,
    STATE(6504), 1,
      sym__scope_resolution,
    STATE(7014), 1,
      sym_virtual_specifier,
    STATE(7713), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2938), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [222159] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7881), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9489), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2468), 1,
      sym__class_declaration_item,
    STATE(3611), 1,
      sym_field_declaration_list,
    STATE(6504), 1,
      sym__scope_resolution,
    STATE(7014), 1,
      sym_virtual_specifier,
    STATE(7713), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2938), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5421), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [222218] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5878), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9359), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9473), 1,
      sym_identifier,
    STATE(1766), 1,
      sym_template_type,
    STATE(1817), 1,
      sym__class_declaration_item,
    STATE(2285), 1,
      sym_field_declaration_list,
    STATE(6490), 1,
      sym__scope_resolution,
    STATE(6822), 1,
      sym_virtual_specifier,
    STATE(7579), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2044), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [222277] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    ACTIONS(9481), 1,
      anon_sym_COLON_COLON,
    STATE(2158), 1,
      sym_template_type,
    STATE(2463), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(6509), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3921), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [222336] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(4879), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9497), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2440), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(6511), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2484), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5449), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [222395] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9865), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9863), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [222424] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7881), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9489), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2463), 1,
      sym__class_declaration_item,
    STATE(3611), 1,
      sym_field_declaration_list,
    STATE(6504), 1,
      sym__scope_resolution,
    STATE(7014), 1,
      sym_virtual_specifier,
    STATE(7713), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2938), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [222483] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9869), 1,
      anon_sym_LPAREN2,
    ACTIONS(9871), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9867), 17,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [222514] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(4879), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9497), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2472), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(6511), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2484), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [222573] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5381), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9254), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9479), 1,
      sym_identifier,
    STATE(1883), 1,
      sym_template_type,
    STATE(2143), 1,
      sym_field_declaration_list,
    STATE(2201), 1,
      sym__class_declaration_item,
    STATE(6506), 1,
      sym__scope_resolution,
    STATE(6878), 1,
      sym_virtual_specifier,
    STATE(7580), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(1724), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5438), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [222632] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6222), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9483), 1,
      sym_identifier,
    STATE(2532), 1,
      sym_template_type,
    STATE(2557), 1,
      sym_field_declaration_list,
    STATE(2665), 1,
      sym__class_declaration_item,
    STATE(6528), 1,
      sym__scope_resolution,
    STATE(6927), 1,
      sym_virtual_specifier,
    STATE(7497), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2307), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5432), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [222691] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5122), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(5124), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [222720] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6222), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9483), 1,
      sym_identifier,
    STATE(2532), 1,
      sym_template_type,
    STATE(2557), 1,
      sym_field_declaration_list,
    STATE(2642), 1,
      sym__class_declaration_item,
    STATE(6528), 1,
      sym__scope_resolution,
    STATE(6927), 1,
      sym_virtual_specifier,
    STATE(7497), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2307), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [222779] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1909), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(1907), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [222808] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9875), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9873), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [222837] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5122), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(5124), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [222866] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5381), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9254), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9479), 1,
      sym_identifier,
    STATE(1883), 1,
      sym_template_type,
    STATE(2143), 1,
      sym_field_declaration_list,
    STATE(2262), 1,
      sym__class_declaration_item,
    STATE(6506), 1,
      sym__scope_resolution,
    STATE(6878), 1,
      sym_virtual_specifier,
    STATE(7580), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(1724), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [222925] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6222), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9483), 1,
      sym_identifier,
    STATE(2532), 1,
      sym_template_type,
    STATE(2557), 1,
      sym_field_declaration_list,
    STATE(2614), 1,
      sym__class_declaration_item,
    STATE(6528), 1,
      sym__scope_resolution,
    STATE(6927), 1,
      sym_virtual_specifier,
    STATE(7497), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2307), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [222984] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6222), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9483), 1,
      sym_identifier,
    STATE(2532), 1,
      sym_template_type,
    STATE(2557), 1,
      sym_field_declaration_list,
    STATE(2644), 1,
      sym__class_declaration_item,
    STATE(6528), 1,
      sym__scope_resolution,
    STATE(6927), 1,
      sym_virtual_specifier,
    STATE(7497), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2307), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5434), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [223043] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6222), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9483), 1,
      sym_identifier,
    STATE(2532), 1,
      sym_template_type,
    STATE(2557), 1,
      sym_field_declaration_list,
    STATE(2639), 1,
      sym__class_declaration_item,
    STATE(6528), 1,
      sym__scope_resolution,
    STATE(6927), 1,
      sym_virtual_specifier,
    STATE(7497), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2307), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [223102] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5878), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9359), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9473), 1,
      sym_identifier,
    STATE(1766), 1,
      sym_template_type,
    STATE(1797), 1,
      sym__class_declaration_item,
    STATE(2285), 1,
      sym_field_declaration_list,
    STATE(6490), 1,
      sym__scope_resolution,
    STATE(6822), 1,
      sym_virtual_specifier,
    STATE(7579), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2044), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5500), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [223161] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5878), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9359), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9473), 1,
      sym_identifier,
    STATE(1766), 1,
      sym_template_type,
    STATE(1814), 1,
      sym__class_declaration_item,
    STATE(2285), 1,
      sym_field_declaration_list,
    STATE(6490), 1,
      sym__scope_resolution,
    STATE(6822), 1,
      sym_virtual_specifier,
    STATE(7579), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2044), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [223220] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(8262), 1,
      sym_identifier,
    ACTIONS(8264), 1,
      anon_sym_LPAREN2,
    ACTIONS(8266), 1,
      anon_sym_STAR,
    ACTIONS(8268), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8270), 1,
      anon_sym_AMP,
    ACTIONS(9877), 1,
      anon_sym_SEMI,
    STATE(5329), 1,
      sym__field_declarator,
    STATE(6266), 1,
      sym_operator_name,
    STATE(7897), 1,
      sym_ms_based_modifier,
    STATE(8499), 1,
      sym_attribute_specifier,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(6285), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [223273] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5381), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9254), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9479), 1,
      sym_identifier,
    STATE(1883), 1,
      sym_template_type,
    STATE(2143), 1,
      sym_field_declaration_list,
    STATE(2235), 1,
      sym__class_declaration_item,
    STATE(6506), 1,
      sym__scope_resolution,
    STATE(6878), 1,
      sym_virtual_specifier,
    STATE(7580), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(1724), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [223332] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9879), 1,
      anon_sym_COMMA,
    ACTIONS(9881), 1,
      anon_sym_RPAREN,
    ACTIONS(9887), 1,
      anon_sym_SLASH,
    ACTIONS(9889), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9891), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9893), 1,
      anon_sym_PIPE,
    ACTIONS(9895), 1,
      anon_sym_CARET,
    ACTIONS(9897), 1,
      anon_sym_AMP,
    STATE(7217), 1,
      aux_sym_preproc_argument_list_repeat1,
    ACTIONS(9883), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9885), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9899), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9901), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9903), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9905), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [223387] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5142), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(5144), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [223416] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5126), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(5128), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [223445] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9909), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9907), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [223474] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2472), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2484), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [223533] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(133), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5337), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8125), 1,
      anon_sym_STAR,
    ACTIONS(9911), 1,
      sym_identifier,
    ACTIONS(9913), 1,
      anon_sym_template,
    STATE(2777), 1,
      sym_pointer_type_declarator,
    STATE(2780), 1,
      sym_template_function,
    STATE(2781), 1,
      sym_destructor_name,
    STATE(2784), 1,
      sym_dependent_identifier,
    STATE(2787), 1,
      sym_qualified_identifier,
    STATE(2790), 1,
      sym_operator_name,
    STATE(5444), 1,
      sym__scope_resolution,
    STATE(6819), 1,
      sym_operator_cast,
    STATE(6861), 1,
      sym_qualified_operator_cast_identifier,
    STATE(8147), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [223596] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9879), 1,
      anon_sym_COMMA,
    ACTIONS(9887), 1,
      anon_sym_SLASH,
    ACTIONS(9889), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9891), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9893), 1,
      anon_sym_PIPE,
    ACTIONS(9895), 1,
      anon_sym_CARET,
    ACTIONS(9897), 1,
      anon_sym_AMP,
    ACTIONS(9915), 1,
      anon_sym_RPAREN,
    STATE(7030), 1,
      aux_sym_preproc_argument_list_repeat1,
    ACTIONS(9883), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9885), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9899), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9901), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9903), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9905), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [223651] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5878), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9477), 1,
      sym_identifier,
    STATE(1766), 1,
      sym_template_type,
    STATE(1826), 1,
      sym__class_declaration_item,
    STATE(2285), 1,
      sym_field_declaration_list,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(6822), 1,
      sym_virtual_specifier,
    STATE(7579), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2044), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5494), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [223710] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5381), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9254), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9479), 1,
      sym_identifier,
    STATE(1883), 1,
      sym_template_type,
    STATE(2143), 1,
      sym_field_declaration_list,
    STATE(2242), 1,
      sym__class_declaration_item,
    STATE(6506), 1,
      sym__scope_resolution,
    STATE(6878), 1,
      sym_virtual_specifier,
    STATE(7580), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(1724), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5448), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [223769] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5381), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9254), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9479), 1,
      sym_identifier,
    STATE(1883), 1,
      sym_template_type,
    STATE(2143), 1,
      sym_field_declaration_list,
    STATE(2232), 1,
      sym__class_declaration_item,
    STATE(6506), 1,
      sym__scope_resolution,
    STATE(6878), 1,
      sym_virtual_specifier,
    STATE(7580), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(1724), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [223828] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(4879), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9497), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2461), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(6511), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2484), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [223887] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(4879), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9497), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2468), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(6511), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2484), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5493), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [223946] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7917), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8479), 1,
      anon_sym_LBRACE,
    ACTIONS(9471), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(4429), 1,
      sym_field_declaration_list,
    STATE(4629), 1,
      sym__class_declaration_item,
    STATE(6486), 1,
      sym__scope_resolution,
    STATE(7010), 1,
      sym_virtual_specifier,
    STATE(7709), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4177), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5461), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [224005] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7917), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9471), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2463), 1,
      sym__class_declaration_item,
    STATE(3611), 1,
      sym_field_declaration_list,
    STATE(6486), 1,
      sym__scope_resolution,
    STATE(7014), 1,
      sym_virtual_specifier,
    STATE(7713), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2938), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [224064] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7917), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8479), 1,
      anon_sym_LBRACE,
    ACTIONS(9471), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(4429), 1,
      sym_field_declaration_list,
    STATE(4633), 1,
      sym__class_declaration_item,
    STATE(6486), 1,
      sym__scope_resolution,
    STATE(7010), 1,
      sym_virtual_specifier,
    STATE(7709), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4177), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [224123] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(8262), 1,
      sym_identifier,
    ACTIONS(8264), 1,
      anon_sym_LPAREN2,
    ACTIONS(8266), 1,
      anon_sym_STAR,
    ACTIONS(8268), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8270), 1,
      anon_sym_AMP,
    ACTIONS(9917), 1,
      anon_sym_SEMI,
    STATE(5331), 1,
      sym__field_declarator,
    STATE(6266), 1,
      sym_operator_name,
    STATE(7862), 1,
      sym_attribute_specifier,
    STATE(7897), 1,
      sym_ms_based_modifier,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(6285), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [224176] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6253), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9334), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9475), 1,
      sym_identifier,
    STATE(2562), 1,
      sym_template_type,
    STATE(2775), 1,
      sym_field_declaration_list,
    STATE(2951), 1,
      sym__class_declaration_item,
    STATE(6507), 1,
      sym__scope_resolution,
    STATE(6937), 1,
      sym_virtual_specifier,
    STATE(7520), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2322), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5467), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [224235] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(111), 1,
      anon_sym___asm,
    ACTIONS(9658), 1,
      anon_sym_try,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(9845), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(9853), 1,
      anon_sym_EQ,
    ACTIONS(9919), 1,
      anon_sym_SEMI,
    ACTIONS(9921), 1,
      anon_sym_LBRACE,
    STATE(1691), 1,
      sym_compound_statement,
    STATE(1692), 1,
      sym_try_statement,
    STATE(2922), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(7422), 1,
      sym_gnu_asm_expression,
    STATE(7423), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(9855), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7535), 2,
      sym_argument_list,
      sym_initializer_list,
  [224296] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5114), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(5116), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [224325] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5146), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(5148), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [224354] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6253), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9334), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9475), 1,
      sym_identifier,
    STATE(2562), 1,
      sym_template_type,
    STATE(2775), 1,
      sym_field_declaration_list,
    STATE(2972), 1,
      sym__class_declaration_item,
    STATE(6507), 1,
      sym__scope_resolution,
    STATE(6937), 1,
      sym_virtual_specifier,
    STATE(7520), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2322), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [224413] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5150), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(5152), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [224442] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7917), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8479), 1,
      anon_sym_LBRACE,
    ACTIONS(9471), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(4429), 1,
      sym_field_declaration_list,
    STATE(4664), 1,
      sym__class_declaration_item,
    STATE(6486), 1,
      sym__scope_resolution,
    STATE(7010), 1,
      sym_virtual_specifier,
    STATE(7709), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4177), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [224501] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7917), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8479), 1,
      anon_sym_LBRACE,
    ACTIONS(9471), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(4429), 1,
      sym_field_declaration_list,
    STATE(4668), 1,
      sym__class_declaration_item,
    STATE(6486), 1,
      sym__scope_resolution,
    STATE(7010), 1,
      sym_virtual_specifier,
    STATE(7709), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4177), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5463), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [224560] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7917), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8479), 1,
      anon_sym_LBRACE,
    ACTIONS(9471), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(4429), 1,
      sym_field_declaration_list,
    STATE(4692), 1,
      sym__class_declaration_item,
    STATE(6486), 1,
      sym__scope_resolution,
    STATE(7010), 1,
      sym_virtual_specifier,
    STATE(7709), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4177), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [224619] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5878), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9477), 1,
      sym_identifier,
    STATE(1766), 1,
      sym_template_type,
    STATE(1797), 1,
      sym__class_declaration_item,
    STATE(2285), 1,
      sym_field_declaration_list,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(6822), 1,
      sym_virtual_specifier,
    STATE(7579), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2044), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5487), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [224678] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    ACTIONS(9481), 1,
      anon_sym_COLON_COLON,
    STATE(2158), 1,
      sym_template_type,
    STATE(2461), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(6509), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3921), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [224737] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    ACTIONS(9481), 1,
      anon_sym_COLON_COLON,
    STATE(2158), 1,
      sym_template_type,
    STATE(2468), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(6509), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3921), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5418), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [224796] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6253), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9334), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9475), 1,
      sym_identifier,
    STATE(2562), 1,
      sym_template_type,
    STATE(2775), 1,
      sym_field_declaration_list,
    STATE(3014), 1,
      sym__class_declaration_item,
    STATE(6507), 1,
      sym__scope_resolution,
    STATE(6937), 1,
      sym_virtual_specifier,
    STATE(7520), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2322), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [224855] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(7998), 1,
      anon_sym_STAR,
    ACTIONS(8000), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8002), 1,
      anon_sym_AMP,
    STATE(2982), 1,
      sym_parameter_list,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(6323), 1,
      sym__abstract_declarator,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8197), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [224900] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6253), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9334), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9475), 1,
      sym_identifier,
    STATE(2562), 1,
      sym_template_type,
    STATE(2775), 1,
      sym_field_declaration_list,
    STATE(3035), 1,
      sym__class_declaration_item,
    STATE(6507), 1,
      sym__scope_resolution,
    STATE(6937), 1,
      sym_virtual_specifier,
    STATE(7520), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2322), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5478), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [224959] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6222), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9282), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9485), 1,
      sym_identifier,
    STATE(2532), 1,
      sym_template_type,
    STATE(2557), 1,
      sym_field_declaration_list,
    STATE(2665), 1,
      sym__class_declaration_item,
    STATE(6500), 1,
      sym__scope_resolution,
    STATE(6927), 1,
      sym_virtual_specifier,
    STATE(7497), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2307), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5473), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [225018] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6222), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9282), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9485), 1,
      sym_identifier,
    STATE(2532), 1,
      sym_template_type,
    STATE(2557), 1,
      sym_field_declaration_list,
    STATE(2642), 1,
      sym__class_declaration_item,
    STATE(6500), 1,
      sym__scope_resolution,
    STATE(6927), 1,
      sym_virtual_specifier,
    STATE(7497), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2307), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [225077] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7417), 1,
      anon_sym_LBRACE,
    ACTIONS(9395), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9495), 1,
      sym_identifier,
    STATE(3586), 1,
      sym_template_type,
    STATE(3908), 1,
      sym_field_declaration_list,
    STATE(4021), 1,
      sym__class_declaration_item,
    STATE(6510), 1,
      sym__scope_resolution,
    STATE(6841), 1,
      sym_virtual_specifier,
    STATE(7445), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3160), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [225136] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6222), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9282), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9485), 1,
      sym_identifier,
    STATE(2532), 1,
      sym_template_type,
    STATE(2557), 1,
      sym_field_declaration_list,
    STATE(2614), 1,
      sym__class_declaration_item,
    STATE(6500), 1,
      sym__scope_resolution,
    STATE(6927), 1,
      sym_virtual_specifier,
    STATE(7497), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2307), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [225195] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6222), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9282), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9485), 1,
      sym_identifier,
    STATE(2532), 1,
      sym_template_type,
    STATE(2557), 1,
      sym_field_declaration_list,
    STATE(2644), 1,
      sym__class_declaration_item,
    STATE(6500), 1,
      sym__scope_resolution,
    STATE(6927), 1,
      sym_virtual_specifier,
    STATE(7497), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2307), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5475), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [225254] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6222), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9282), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9485), 1,
      sym_identifier,
    STATE(2532), 1,
      sym_template_type,
    STATE(2557), 1,
      sym_field_declaration_list,
    STATE(2639), 1,
      sym__class_declaration_item,
    STATE(6500), 1,
      sym__scope_resolution,
    STATE(6927), 1,
      sym_virtual_specifier,
    STATE(7497), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2307), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [225313] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9827), 1,
      sym_identifier,
    ACTIONS(9831), 1,
      anon_sym_LPAREN2,
    ACTIONS(9833), 1,
      anon_sym_defined,
    ACTIONS(9923), 1,
      anon_sym_RPAREN,
    ACTIONS(9925), 1,
      sym_number_literal,
    ACTIONS(9835), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9837), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9841), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5439), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [225356] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2461), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2484), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [225415] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6253), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9334), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9475), 1,
      sym_identifier,
    STATE(2562), 1,
      sym_template_type,
    STATE(2775), 1,
      sym_field_declaration_list,
    STATE(3056), 1,
      sym__class_declaration_item,
    STATE(6507), 1,
      sym__scope_resolution,
    STATE(6937), 1,
      sym_virtual_specifier,
    STATE(7520), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2322), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [225474] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7917), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9471), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2440), 1,
      sym__class_declaration_item,
    STATE(3611), 1,
      sym_field_declaration_list,
    STATE(6486), 1,
      sym__scope_resolution,
    STATE(7014), 1,
      sym_virtual_specifier,
    STATE(7713), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2938), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5504), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [225533] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5878), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9477), 1,
      sym_identifier,
    STATE(1766), 1,
      sym_template_type,
    STATE(1814), 1,
      sym__class_declaration_item,
    STATE(2285), 1,
      sym_field_declaration_list,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(6822), 1,
      sym_virtual_specifier,
    STATE(7579), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2044), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [225592] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6533), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9306), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9491), 1,
      sym_identifier,
    STATE(2632), 1,
      sym_template_type,
    STATE(2805), 1,
      sym_field_declaration_list,
    STATE(3152), 1,
      sym__class_declaration_item,
    STATE(6487), 1,
      sym__scope_resolution,
    STATE(6812), 1,
      sym_virtual_specifier,
    STATE(7706), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2474), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [225651] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6944), 1,
      anon_sym_requires,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5714), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9674), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9672), 11,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [225688] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9085), 1,
      anon_sym_requires,
    ACTIONS(9082), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9062), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9051), 11,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [225725] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7917), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9471), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2472), 1,
      sym__class_declaration_item,
    STATE(3611), 1,
      sym_field_declaration_list,
    STATE(6486), 1,
      sym__scope_resolution,
    STATE(7014), 1,
      sym_virtual_specifier,
    STATE(7713), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2938), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [225784] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9927), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(9929), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6092), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(6094), 14,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [225817] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6944), 1,
      anon_sym_requires,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5773), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9762), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9760), 11,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [225854] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5878), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9477), 1,
      sym_identifier,
    STATE(1766), 1,
      sym_template_type,
    STATE(1796), 1,
      sym__class_declaration_item,
    STATE(2285), 1,
      sym_field_declaration_list,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(6822), 1,
      sym_virtual_specifier,
    STATE(7579), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2044), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [225913] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2468), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2484), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5515), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [225972] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9530), 1,
      anon_sym_requires,
    ACTIONS(9527), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5701), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9525), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9514), 11,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [226009] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6944), 1,
      anon_sym_requires,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9062), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9051), 11,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [226046] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(111), 1,
      anon_sym___asm,
    ACTIONS(9642), 1,
      anon_sym_try,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(9845), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(9853), 1,
      anon_sym_EQ,
    ACTIONS(9931), 1,
      anon_sym_SEMI,
    ACTIONS(9933), 1,
      anon_sym_LBRACE,
    STATE(2116), 1,
      sym_compound_statement,
    STATE(2117), 1,
      sym_try_statement,
    STATE(2922), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(7144), 1,
      sym_gnu_asm_expression,
    STATE(7148), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(9855), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7535), 2,
      sym_argument_list,
      sym_initializer_list,
  [226107] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7853), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8638), 1,
      anon_sym_LBRACE,
    ACTIONS(9493), 1,
      sym_identifier,
    STATE(4327), 1,
      sym_template_type,
    STATE(4814), 1,
      sym_field_declaration_list,
    STATE(4887), 1,
      sym__class_declaration_item,
    STATE(6508), 1,
      sym__scope_resolution,
    STATE(6825), 1,
      sym_virtual_specifier,
    STATE(7611), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4298), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [226166] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(4879), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9497), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2463), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(6511), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2484), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [226225] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5878), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9477), 1,
      sym_identifier,
    STATE(1766), 1,
      sym_template_type,
    STATE(1817), 1,
      sym__class_declaration_item,
    STATE(2285), 1,
      sym_field_declaration_list,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(6822), 1,
      sym_virtual_specifier,
    STATE(7579), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2044), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [226284] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5118), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(5120), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [226313] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(8262), 1,
      sym_identifier,
    ACTIONS(8264), 1,
      anon_sym_LPAREN2,
    ACTIONS(8266), 1,
      anon_sym_STAR,
    ACTIONS(8268), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8270), 1,
      anon_sym_AMP,
    ACTIONS(9935), 1,
      anon_sym_SEMI,
    STATE(5332), 1,
      sym__field_declarator,
    STATE(6266), 1,
      sym_operator_name,
    STATE(7897), 1,
      sym_ms_based_modifier,
    STATE(8192), 1,
      sym_attribute_specifier,
    ACTIONS(43), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    STATE(6285), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [226366] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6944), 1,
      anon_sym_requires,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9211), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9200), 11,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [226403] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(111), 1,
      anon_sym___asm,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(9845), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(9853), 1,
      anon_sym_EQ,
    ACTIONS(9937), 1,
      anon_sym_SEMI,
    ACTIONS(9939), 1,
      anon_sym_LBRACE,
    ACTIONS(9941), 1,
      anon_sym_try,
    STATE(628), 1,
      sym_compound_statement,
    STATE(630), 1,
      sym_try_statement,
    STATE(2922), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(7184), 1,
      sym_gnu_asm_expression,
    STATE(7185), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(9855), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7535), 2,
      sym_argument_list,
      sym_initializer_list,
  [226464] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2440), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2484), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5477), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [226523] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5878), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9359), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9473), 1,
      sym_identifier,
    STATE(1766), 1,
      sym_template_type,
    STATE(1796), 1,
      sym__class_declaration_item,
    STATE(2285), 1,
      sym_field_declaration_list,
    STATE(6490), 1,
      sym__scope_resolution,
    STATE(6822), 1,
      sym_virtual_specifier,
    STATE(7579), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2044), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [226582] = 5,
    ACTIONS(9808), 1,
      anon_sym_LF,
    ACTIONS(9943), 1,
      anon_sym_LPAREN2,
    ACTIONS(9945), 1,
      sym_comment,
    STATE(5754), 1,
      sym_preproc_argument_list,
    ACTIONS(9812), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [226615] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(6648), 1,
      anon_sym_LBRACE,
    ACTIONS(9439), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9487), 1,
      sym_identifier,
    STATE(2773), 1,
      sym_template_type,
    STATE(3033), 1,
      sym_field_declaration_list,
    STATE(3402), 1,
      sym__class_declaration_item,
    STATE(6477), 1,
      sym__scope_resolution,
    STATE(6971), 1,
      sym_virtual_specifier,
    STATE(7614), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2538), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5510), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [226674] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(6648), 1,
      anon_sym_LBRACE,
    ACTIONS(9439), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9487), 1,
      sym_identifier,
    STATE(2773), 1,
      sym_template_type,
    STATE(3033), 1,
      sym_field_declaration_list,
    STATE(3442), 1,
      sym__class_declaration_item,
    STATE(6477), 1,
      sym__scope_resolution,
    STATE(6971), 1,
      sym_virtual_specifier,
    STATE(7614), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2538), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [226733] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7917), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9471), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2461), 1,
      sym__class_declaration_item,
    STATE(3611), 1,
      sym_field_declaration_list,
    STATE(6486), 1,
      sym__scope_resolution,
    STATE(7014), 1,
      sym_virtual_specifier,
    STATE(7713), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2938), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [226792] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5878), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9359), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9473), 1,
      sym_identifier,
    STATE(1766), 1,
      sym_template_type,
    STATE(1826), 1,
      sym__class_declaration_item,
    STATE(2285), 1,
      sym_field_declaration_list,
    STATE(6490), 1,
      sym__scope_resolution,
    STATE(6822), 1,
      sym_virtual_specifier,
    STATE(7579), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2044), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5417), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [226851] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7917), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9471), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2468), 1,
      sym__class_declaration_item,
    STATE(3611), 1,
      sym_field_declaration_list,
    STATE(6486), 1,
      sym__scope_resolution,
    STATE(7014), 1,
      sym_virtual_specifier,
    STATE(7713), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2938), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5452), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [226910] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7417), 1,
      anon_sym_LBRACE,
    ACTIONS(9395), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9495), 1,
      sym_identifier,
    STATE(3586), 1,
      sym_template_type,
    STATE(3908), 1,
      sym_field_declaration_list,
    STATE(4039), 1,
      sym__class_declaration_item,
    STATE(6510), 1,
      sym__scope_resolution,
    STATE(6841), 1,
      sym_virtual_specifier,
    STATE(7445), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3160), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5546), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [226969] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(111), 1,
      anon_sym___asm,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(9845), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(9853), 1,
      anon_sym_EQ,
    ACTIONS(9947), 1,
      anon_sym_SEMI,
    ACTIONS(9949), 1,
      anon_sym_LBRACE,
    ACTIONS(9951), 1,
      anon_sym_try,
    STATE(285), 1,
      sym_compound_statement,
    STATE(287), 1,
      sym_try_statement,
    STATE(2922), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(7319), 1,
      sym_gnu_asm_expression,
    STATE(7320), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(9855), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7535), 2,
      sym_argument_list,
      sym_initializer_list,
  [227030] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9827), 1,
      sym_identifier,
    ACTIONS(9831), 1,
      anon_sym_LPAREN2,
    ACTIONS(9833), 1,
      anon_sym_defined,
    ACTIONS(9953), 1,
      anon_sym_RPAREN,
    ACTIONS(9955), 1,
      sym_number_literal,
    ACTIONS(9835), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9837), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9841), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5445), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [227073] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(6648), 1,
      anon_sym_LBRACE,
    ACTIONS(9439), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9487), 1,
      sym_identifier,
    STATE(2773), 1,
      sym_template_type,
    STATE(3033), 1,
      sym_field_declaration_list,
    STATE(3422), 1,
      sym__class_declaration_item,
    STATE(6477), 1,
      sym__scope_resolution,
    STATE(6971), 1,
      sym_virtual_specifier,
    STATE(7614), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2538), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [227132] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(6648), 1,
      anon_sym_LBRACE,
    ACTIONS(9439), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9487), 1,
      sym_identifier,
    STATE(2773), 1,
      sym_template_type,
    STATE(3033), 1,
      sym_field_declaration_list,
    STATE(3431), 1,
      sym__class_declaration_item,
    STATE(6477), 1,
      sym__scope_resolution,
    STATE(6971), 1,
      sym_virtual_specifier,
    STATE(7614), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2538), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5512), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [227191] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(6648), 1,
      anon_sym_LBRACE,
    ACTIONS(9439), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9487), 1,
      sym_identifier,
    STATE(2773), 1,
      sym_template_type,
    STATE(3033), 1,
      sym_field_declaration_list,
    STATE(3341), 1,
      sym__class_declaration_item,
    STATE(6477), 1,
      sym__scope_resolution,
    STATE(6971), 1,
      sym_virtual_specifier,
    STATE(7614), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2538), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [227250] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9961), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5513), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    ACTIONS(9959), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9957), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [227283] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7881), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9489), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2440), 1,
      sym__class_declaration_item,
    STATE(3611), 1,
      sym_field_declaration_list,
    STATE(6504), 1,
      sym__scope_resolution,
    STATE(7014), 1,
      sym_virtual_specifier,
    STATE(7713), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2938), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5415), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [227342] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2463), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2484), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [227401] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    ACTIONS(9481), 1,
      anon_sym_COLON_COLON,
    STATE(2158), 1,
      sym_template_type,
    STATE(2440), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(6509), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3921), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5465), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [227460] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5122), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(5124), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [227489] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9469), 1,
      sym_identifier,
    ACTIONS(9481), 1,
      anon_sym_COLON_COLON,
    STATE(2158), 1,
      sym_template_type,
    STATE(2472), 1,
      sym__class_declaration_item,
    STATE(2877), 1,
      sym_field_declaration_list,
    STATE(6509), 1,
      sym__scope_resolution,
    STATE(6809), 1,
      sym_virtual_specifier,
    STATE(7447), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3921), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [227548] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7881), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8479), 1,
      anon_sym_LBRACE,
    ACTIONS(9489), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(4429), 1,
      sym_field_declaration_list,
    STATE(4664), 1,
      sym__class_declaration_item,
    STATE(6504), 1,
      sym__scope_resolution,
    STATE(7010), 1,
      sym_virtual_specifier,
    STATE(7709), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4177), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [227607] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7881), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9489), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2472), 1,
      sym__class_declaration_item,
    STATE(3611), 1,
      sym_field_declaration_list,
    STATE(6504), 1,
      sym__scope_resolution,
    STATE(7014), 1,
      sym_virtual_specifier,
    STATE(7713), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2938), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [227666] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5878), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7833), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9467), 1,
      sym_identifier,
    STATE(1766), 1,
      sym_template_type,
    STATE(1797), 1,
      sym__class_declaration_item,
    STATE(5090), 1,
      sym_field_declaration_list,
    STATE(6513), 1,
      sym__scope_resolution,
    STATE(6992), 1,
      sym_virtual_specifier,
    STATE(7680), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4503), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5536), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [227725] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5878), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7833), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9467), 1,
      sym_identifier,
    STATE(1766), 1,
      sym_template_type,
    STATE(1814), 1,
      sym__class_declaration_item,
    STATE(5090), 1,
      sym_field_declaration_list,
    STATE(6513), 1,
      sym__scope_resolution,
    STATE(6992), 1,
      sym_virtual_specifier,
    STATE(7680), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4503), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [227784] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9879), 1,
      anon_sym_COMMA,
    ACTIONS(9887), 1,
      anon_sym_SLASH,
    ACTIONS(9889), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9891), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9893), 1,
      anon_sym_PIPE,
    ACTIONS(9895), 1,
      anon_sym_CARET,
    ACTIONS(9897), 1,
      anon_sym_AMP,
    ACTIONS(9964), 1,
      anon_sym_RPAREN,
    STATE(7266), 1,
      aux_sym_preproc_argument_list_repeat1,
    ACTIONS(9883), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9885), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9899), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9901), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9903), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9905), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [227839] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7417), 1,
      anon_sym_LBRACE,
    ACTIONS(9395), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9495), 1,
      sym_identifier,
    STATE(3586), 1,
      sym_template_type,
    STATE(3908), 1,
      sym_field_declaration_list,
    STATE(4056), 1,
      sym__class_declaration_item,
    STATE(6510), 1,
      sym__scope_resolution,
    STATE(6841), 1,
      sym_virtual_specifier,
    STATE(7445), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3160), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5472), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [227898] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6533), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9306), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9491), 1,
      sym_identifier,
    STATE(2632), 1,
      sym_template_type,
    STATE(2805), 1,
      sym_field_declaration_list,
    STATE(3126), 1,
      sym__class_declaration_item,
    STATE(6487), 1,
      sym__scope_resolution,
    STATE(6812), 1,
      sym_virtual_specifier,
    STATE(7706), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2474), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5481), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [227957] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(111), 1,
      anon_sym___asm,
    ACTIONS(9650), 1,
      anon_sym_try,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(9845), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(9853), 1,
      anon_sym_EQ,
    ACTIONS(9966), 1,
      anon_sym_SEMI,
    ACTIONS(9968), 1,
      anon_sym_LBRACE,
    STATE(2031), 1,
      sym_compound_statement,
    STATE(2032), 1,
      sym_try_statement,
    STATE(2922), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(7309), 1,
      sym_gnu_asm_expression,
    STATE(7310), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(9855), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7535), 2,
      sym_argument_list,
      sym_initializer_list,
  [228018] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9970), 1,
      anon_sym_requires,
    ACTIONS(9796), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5773), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9762), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9760), 11,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [228055] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7417), 1,
      anon_sym_LBRACE,
    ACTIONS(9395), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9495), 1,
      sym_identifier,
    STATE(3586), 1,
      sym_template_type,
    STATE(3908), 1,
      sym_field_declaration_list,
    STATE(4061), 1,
      sym__class_declaration_item,
    STATE(6510), 1,
      sym__scope_resolution,
    STATE(6841), 1,
      sym_virtual_specifier,
    STATE(7445), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3160), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [228114] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7881), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8479), 1,
      anon_sym_LBRACE,
    ACTIONS(9489), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(4429), 1,
      sym_field_declaration_list,
    STATE(4668), 1,
      sym__class_declaration_item,
    STATE(6504), 1,
      sym__scope_resolution,
    STATE(7010), 1,
      sym_virtual_specifier,
    STATE(7709), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4177), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5408), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [228173] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5170), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(5172), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [228202] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9929), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6057), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(6059), 16,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [228233] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5174), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(5176), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [228262] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9975), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9973), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [228291] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9979), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9977), 18,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [228320] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6944), 1,
      anon_sym_requires,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5701), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9525), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9514), 11,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [228357] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5878), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7833), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9467), 1,
      sym_identifier,
    STATE(1766), 1,
      sym_template_type,
    STATE(1796), 1,
      sym__class_declaration_item,
    STATE(5090), 1,
      sym_field_declaration_list,
    STATE(6513), 1,
      sym__scope_resolution,
    STATE(6992), 1,
      sym_virtual_specifier,
    STATE(7680), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4503), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [228416] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6533), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9306), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9491), 1,
      sym_identifier,
    STATE(2632), 1,
      sym_template_type,
    STATE(2805), 1,
      sym_field_declaration_list,
    STATE(3092), 1,
      sym__class_declaration_item,
    STATE(6487), 1,
      sym__scope_resolution,
    STATE(6812), 1,
      sym_virtual_specifier,
    STATE(7706), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2474), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5545), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [228475] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5878), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7833), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9467), 1,
      sym_identifier,
    STATE(1766), 1,
      sym_template_type,
    STATE(1826), 1,
      sym__class_declaration_item,
    STATE(5090), 1,
      sym_field_declaration_list,
    STATE(6513), 1,
      sym__scope_resolution,
    STATE(6992), 1,
      sym_virtual_specifier,
    STATE(7680), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4503), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5544), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [228534] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(111), 1,
      anon_sym___asm,
    ACTIONS(1905), 1,
      anon_sym_LBRACE,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(9845), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(9853), 1,
      anon_sym_EQ,
    ACTIONS(9981), 1,
      anon_sym_SEMI,
    ACTIONS(9983), 1,
      anon_sym_try,
    STATE(727), 1,
      sym_compound_statement,
    STATE(728), 1,
      sym_try_statement,
    STATE(2922), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(7048), 1,
      sym_gnu_asm_expression,
    STATE(7389), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(9855), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7535), 2,
      sym_argument_list,
      sym_initializer_list,
  [228595] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7853), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8638), 1,
      anon_sym_LBRACE,
    ACTIONS(9493), 1,
      sym_identifier,
    STATE(4327), 1,
      sym_template_type,
    STATE(4814), 1,
      sym_field_declaration_list,
    STATE(4861), 1,
      sym__class_declaration_item,
    STATE(6508), 1,
      sym__scope_resolution,
    STATE(6825), 1,
      sym_virtual_specifier,
    STATE(7611), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4298), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5543), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [228654] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6533), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9306), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9491), 1,
      sym_identifier,
    STATE(2632), 1,
      sym_template_type,
    STATE(2805), 1,
      sym_field_declaration_list,
    STATE(3095), 1,
      sym__class_declaration_item,
    STATE(6487), 1,
      sym__scope_resolution,
    STATE(6812), 1,
      sym_virtual_specifier,
    STATE(7706), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2474), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [228713] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5134), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(5136), 18,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_and,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [228742] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7853), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8638), 1,
      anon_sym_LBRACE,
    ACTIONS(9493), 1,
      sym_identifier,
    STATE(4327), 1,
      sym_template_type,
    STATE(4814), 1,
      sym_field_declaration_list,
    STATE(4864), 1,
      sym__class_declaration_item,
    STATE(6508), 1,
      sym__scope_resolution,
    STATE(6825), 1,
      sym_virtual_specifier,
    STATE(7611), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4298), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [228801] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5878), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7833), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9467), 1,
      sym_identifier,
    STATE(1766), 1,
      sym_template_type,
    STATE(1817), 1,
      sym__class_declaration_item,
    STATE(5090), 1,
      sym_field_declaration_list,
    STATE(6513), 1,
      sym__scope_resolution,
    STATE(6992), 1,
      sym_virtual_specifier,
    STATE(7680), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(4503), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [228860] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6533), 1,
      anon_sym_LBRACE,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(9306), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9491), 1,
      sym_identifier,
    STATE(2632), 1,
      sym_template_type,
    STATE(2805), 1,
      sym_field_declaration_list,
    STATE(3122), 1,
      sym__class_declaration_item,
    STATE(6487), 1,
      sym__scope_resolution,
    STATE(6812), 1,
      sym_virtual_specifier,
    STATE(7706), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(2474), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [228919] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6565), 1,
      anon_sym_COLON,
    ACTIONS(7417), 1,
      anon_sym_LBRACE,
    ACTIONS(9395), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9495), 1,
      sym_identifier,
    STATE(3586), 1,
      sym_template_type,
    STATE(3908), 1,
      sym_field_declaration_list,
    STATE(4053), 1,
      sym__class_declaration_item,
    STATE(6510), 1,
      sym__scope_resolution,
    STATE(6841), 1,
      sym_virtual_specifier,
    STATE(7445), 1,
      sym_base_class_clause,
    ACTIONS(5385), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(3160), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [228978] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(4368), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4376), 1,
      anon_sym_EQ,
    ACTIONS(9985), 1,
      sym_identifier,
    ACTIONS(9987), 1,
      anon_sym_STAR,
    ACTIONS(9989), 1,
      anon_sym_AMP,
    ACTIONS(9991), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9993), 1,
      anon_sym_RBRACK,
    ACTIONS(9995), 1,
      sym_this,
    STATE(5700), 1,
      sym__scope_resolution,
    STATE(7453), 1,
      sym_lambda_default_capture,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7112), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [229030] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8062), 1,
      anon_sym_STAR,
    ACTIONS(8064), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8066), 1,
      anon_sym_AMP,
    ACTIONS(8199), 1,
      anon_sym___attribute,
    STATE(3249), 1,
      sym_parameter_list,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6412), 1,
      sym__abstract_declarator,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8197), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [229076] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9997), 1,
      sym_identifier,
    ACTIONS(9999), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_defined,
    ACTIONS(10007), 1,
      sym_number_literal,
    ACTIONS(10003), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10005), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10009), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5736), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [229116] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9997), 1,
      sym_identifier,
    ACTIONS(9999), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_defined,
    ACTIONS(10011), 1,
      sym_number_literal,
    ACTIONS(10003), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10005), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10009), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5737), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [229156] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(8157), 1,
      anon_sym_STAR,
    ACTIONS(10013), 1,
      sym_identifier,
    ACTIONS(10015), 1,
      anon_sym_TILDE,
    ACTIONS(10017), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10019), 1,
      anon_sym_template,
    ACTIONS(10021), 1,
      anon_sym_operator,
    STATE(1704), 1,
      sym_template_type,
    STATE(1706), 1,
      sym_dependent_type_identifier,
    STATE(1808), 1,
      sym_qualified_type_identifier,
    STATE(3216), 1,
      sym_pointer_type_declarator,
    STATE(3223), 1,
      sym_template_function,
    STATE(3228), 1,
      sym_destructor_name,
    STATE(3230), 1,
      sym_dependent_identifier,
    STATE(3251), 1,
      sym_qualified_identifier,
    STATE(3290), 1,
      sym_operator_name,
    STATE(5551), 1,
      sym__scope_resolution,
    STATE(8392), 1,
      sym_ms_based_modifier,
    STATE(8512), 1,
      sym_decltype,
  [229220] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7149), 1,
      anon_sym_DASH_GT,
    ACTIONS(9137), 1,
      anon_sym_requires,
    STATE(5380), 1,
      sym_trailing_return_type,
    ACTIONS(9062), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9082), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [229260] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9997), 1,
      sym_identifier,
    ACTIONS(9999), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_defined,
    ACTIONS(10023), 1,
      sym_number_literal,
    ACTIONS(10003), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10005), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10009), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5751), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [229300] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8097), 1,
      sym_identifier,
    ACTIONS(8099), 1,
      anon_sym_LPAREN2,
    ACTIONS(8111), 1,
      sym_primitive_type,
    ACTIONS(8125), 1,
      anon_sym_STAR,
    ACTIONS(8127), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8129), 1,
      anon_sym_AMP,
    STATE(2258), 1,
      sym_pointer_type_declarator,
    STATE(6386), 1,
      sym__type_declarator,
    STATE(6754), 1,
      sym__type_definition_declarators,
    STATE(8147), 1,
      sym_ms_based_modifier,
    ACTIONS(8109), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2186), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [229350] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(4368), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4376), 1,
      anon_sym_EQ,
    ACTIONS(9985), 1,
      sym_identifier,
    ACTIONS(9987), 1,
      anon_sym_STAR,
    ACTIONS(9989), 1,
      anon_sym_AMP,
    ACTIONS(9991), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9995), 1,
      sym_this,
    ACTIONS(10025), 1,
      anon_sym_RBRACK,
    STATE(5700), 1,
      sym__scope_resolution,
    STATE(7453), 1,
      sym_lambda_default_capture,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7112), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [229402] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(8101), 1,
      anon_sym_STAR,
    ACTIONS(9750), 1,
      anon_sym_TILDE,
    ACTIONS(10027), 1,
      sym_identifier,
    ACTIONS(10029), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10031), 1,
      anon_sym_template,
    ACTIONS(10033), 1,
      anon_sym_operator,
    STATE(2119), 1,
      sym_dependent_type_identifier,
    STATE(2137), 1,
      sym_template_type,
    STATE(2161), 1,
      sym_qualified_type_identifier,
    STATE(2777), 1,
      sym_pointer_type_declarator,
    STATE(2780), 1,
      sym_template_function,
    STATE(2781), 1,
      sym_destructor_name,
    STATE(2784), 1,
      sym_dependent_identifier,
    STATE(2787), 1,
      sym_qualified_identifier,
    STATE(2790), 1,
      sym_operator_name,
    STATE(5556), 1,
      sym__scope_resolution,
    STATE(8208), 1,
      sym_ms_based_modifier,
    STATE(8512), 1,
      sym_decltype,
  [229466] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9887), 1,
      anon_sym_SLASH,
    ACTIONS(9895), 1,
      anon_sym_CARET,
    ACTIONS(9897), 1,
      anon_sym_AMP,
    ACTIONS(10037), 1,
      anon_sym_PIPE,
    ACTIONS(9883), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9885), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9899), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9901), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9903), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9905), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10035), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [229512] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8097), 1,
      sym_identifier,
    ACTIONS(8099), 1,
      anon_sym_LPAREN2,
    ACTIONS(8111), 1,
      sym_primitive_type,
    ACTIONS(8125), 1,
      anon_sym_STAR,
    ACTIONS(8127), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8129), 1,
      anon_sym_AMP,
    STATE(2258), 1,
      sym_pointer_type_declarator,
    STATE(6386), 1,
      sym__type_declarator,
    STATE(6793), 1,
      sym__type_definition_declarators,
    STATE(8147), 1,
      sym_ms_based_modifier,
    ACTIONS(8109), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2186), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [229562] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7149), 1,
      anon_sym_DASH_GT,
    ACTIONS(9233), 1,
      anon_sym_requires,
    STATE(5382), 1,
      sym_trailing_return_type,
    ACTIONS(9211), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9213), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [229602] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9887), 1,
      anon_sym_SLASH,
    ACTIONS(9897), 1,
      anon_sym_AMP,
    ACTIONS(10037), 1,
      anon_sym_PIPE,
    ACTIONS(9883), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9885), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9899), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9901), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9903), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9905), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10035), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [229646] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7149), 1,
      anon_sym_DASH_GT,
    ACTIONS(9553), 1,
      anon_sym_requires,
    STATE(5337), 1,
      sym_trailing_return_type,
    ACTIONS(9525), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9527), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5701), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [229686] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7149), 1,
      anon_sym_DASH_GT,
    ACTIONS(9679), 1,
      anon_sym_requires,
    STATE(5392), 1,
      sym_trailing_return_type,
    ACTIONS(9674), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9676), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5714), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9672), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [229726] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9887), 1,
      anon_sym_SLASH,
    ACTIONS(9883), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9885), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9899), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9901), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9903), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9905), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10037), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(10035), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
  [229768] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9887), 1,
      anon_sym_SLASH,
    ACTIONS(9883), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9885), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9901), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9903), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9905), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10037), 2,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(10035), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [229808] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9887), 1,
      anon_sym_SLASH,
    ACTIONS(9883), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9885), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9905), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10037), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10035), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [229844] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9887), 1,
      anon_sym_SLASH,
    ACTIONS(9883), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9885), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10037), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10035), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [229878] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9997), 1,
      sym_identifier,
    ACTIONS(9999), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_defined,
    ACTIONS(10039), 1,
      sym_number_literal,
    ACTIONS(10003), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10005), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10009), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5718), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [229918] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8097), 1,
      sym_identifier,
    ACTIONS(8099), 1,
      anon_sym_LPAREN2,
    ACTIONS(8111), 1,
      sym_primitive_type,
    ACTIONS(8125), 1,
      anon_sym_STAR,
    ACTIONS(8127), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8129), 1,
      anon_sym_AMP,
    STATE(2258), 1,
      sym_pointer_type_declarator,
    STATE(6386), 1,
      sym__type_declarator,
    STATE(6790), 1,
      sym__type_definition_declarators,
    STATE(8147), 1,
      sym_ms_based_modifier,
    ACTIONS(8109), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2186), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [229968] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9997), 1,
      sym_identifier,
    ACTIONS(9999), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_defined,
    ACTIONS(10041), 1,
      sym_number_literal,
    ACTIONS(10003), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10005), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10009), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5753), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [230008] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8097), 1,
      sym_identifier,
    ACTIONS(8099), 1,
      anon_sym_LPAREN2,
    ACTIONS(8111), 1,
      sym_primitive_type,
    ACTIONS(8125), 1,
      anon_sym_STAR,
    ACTIONS(8127), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8129), 1,
      anon_sym_AMP,
    STATE(2258), 1,
      sym_pointer_type_declarator,
    STATE(6386), 1,
      sym__type_declarator,
    STATE(6734), 1,
      sym__type_definition_declarators,
    STATE(8147), 1,
      sym_ms_based_modifier,
    ACTIONS(8109), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2186), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [230058] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(4368), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4376), 1,
      anon_sym_EQ,
    ACTIONS(9985), 1,
      sym_identifier,
    ACTIONS(9987), 1,
      anon_sym_STAR,
    ACTIONS(9989), 1,
      anon_sym_AMP,
    ACTIONS(9991), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9995), 1,
      sym_this,
    ACTIONS(10043), 1,
      anon_sym_RBRACK,
    STATE(5700), 1,
      sym__scope_resolution,
    STATE(7453), 1,
      sym_lambda_default_capture,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7112), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [230110] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6932), 1,
      anon_sym_DASH_GT,
    ACTIONS(6944), 1,
      anon_sym_requires,
    STATE(5497), 1,
      sym_trailing_return_type,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9062), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [230150] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9997), 1,
      sym_identifier,
    ACTIONS(9999), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_defined,
    ACTIONS(10045), 1,
      sym_number_literal,
    ACTIONS(10003), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10005), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10009), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5723), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [230190] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(4368), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4376), 1,
      anon_sym_EQ,
    ACTIONS(9985), 1,
      sym_identifier,
    ACTIONS(9987), 1,
      anon_sym_STAR,
    ACTIONS(9989), 1,
      anon_sym_AMP,
    ACTIONS(9991), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9995), 1,
      sym_this,
    ACTIONS(10047), 1,
      anon_sym_RBRACK,
    STATE(5700), 1,
      sym__scope_resolution,
    STATE(7453), 1,
      sym_lambda_default_capture,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7112), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [230242] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5635), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9666), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9664), 14,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [230274] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8068), 1,
      anon_sym_STAR,
    ACTIONS(8070), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8072), 1,
      anon_sym_AMP,
    STATE(2931), 1,
      sym_parameter_list,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6345), 1,
      sym__abstract_declarator,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8197), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [230318] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6901), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(6903), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [230346] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(8101), 1,
      anon_sym_STAR,
    ACTIONS(10049), 1,
      sym_identifier,
    ACTIONS(10051), 1,
      anon_sym_TILDE,
    ACTIONS(10053), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10055), 1,
      anon_sym_template,
    ACTIONS(10057), 1,
      anon_sym_operator,
    STATE(2119), 1,
      sym_dependent_type_identifier,
    STATE(2137), 1,
      sym_template_type,
    STATE(2161), 1,
      sym_qualified_type_identifier,
    STATE(2403), 1,
      sym_pointer_type_declarator,
    STATE(2410), 1,
      sym_template_function,
    STATE(2425), 1,
      sym_destructor_name,
    STATE(2431), 1,
      sym_dependent_identifier,
    STATE(2438), 1,
      sym_qualified_identifier,
    STATE(2441), 1,
      sym_operator_name,
    STATE(5578), 1,
      sym__scope_resolution,
    STATE(8208), 1,
      sym_ms_based_modifier,
    STATE(8512), 1,
      sym_decltype,
  [230410] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(4368), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4376), 1,
      anon_sym_EQ,
    ACTIONS(9985), 1,
      sym_identifier,
    ACTIONS(9987), 1,
      anon_sym_STAR,
    ACTIONS(9989), 1,
      anon_sym_AMP,
    ACTIONS(9991), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9995), 1,
      sym_this,
    ACTIONS(10059), 1,
      anon_sym_RBRACK,
    STATE(5700), 1,
      sym__scope_resolution,
    STATE(7453), 1,
      sym_lambda_default_capture,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7112), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [230462] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(4368), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4376), 1,
      anon_sym_EQ,
    ACTIONS(9985), 1,
      sym_identifier,
    ACTIONS(9987), 1,
      anon_sym_STAR,
    ACTIONS(9989), 1,
      anon_sym_AMP,
    ACTIONS(9991), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9995), 1,
      sym_this,
    ACTIONS(10061), 1,
      anon_sym_RBRACK,
    STATE(5700), 1,
      sym__scope_resolution,
    STATE(7453), 1,
      sym_lambda_default_capture,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7112), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [230514] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9827), 1,
      sym_identifier,
    ACTIONS(9831), 1,
      anon_sym_LPAREN2,
    ACTIONS(9833), 1,
      anon_sym_defined,
    ACTIONS(10063), 1,
      sym_number_literal,
    ACTIONS(9835), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9837), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9841), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5706), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [230554] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9997), 1,
      sym_identifier,
    ACTIONS(9999), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_defined,
    ACTIONS(10065), 1,
      sym_number_literal,
    ACTIONS(10003), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10005), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10009), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5739), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [230594] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6932), 1,
      anon_sym_DASH_GT,
    ACTIONS(6944), 1,
      anon_sym_requires,
    STATE(5535), 1,
      sym_trailing_return_type,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9211), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [230634] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8097), 1,
      sym_identifier,
    ACTIONS(8099), 1,
      anon_sym_LPAREN2,
    ACTIONS(8111), 1,
      sym_primitive_type,
    ACTIONS(8125), 1,
      anon_sym_STAR,
    ACTIONS(8127), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8129), 1,
      anon_sym_AMP,
    STATE(2258), 1,
      sym_pointer_type_declarator,
    STATE(6386), 1,
      sym__type_declarator,
    STATE(6764), 1,
      sym__type_definition_declarators,
    STATE(8147), 1,
      sym_ms_based_modifier,
    ACTIONS(8109), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2186), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [230684] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8097), 1,
      sym_identifier,
    ACTIONS(8099), 1,
      anon_sym_LPAREN2,
    ACTIONS(8111), 1,
      sym_primitive_type,
    ACTIONS(8125), 1,
      anon_sym_STAR,
    ACTIONS(8127), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8129), 1,
      anon_sym_AMP,
    STATE(2258), 1,
      sym_pointer_type_declarator,
    STATE(6386), 1,
      sym__type_declarator,
    STATE(6746), 1,
      sym__type_definition_declarators,
    STATE(8147), 1,
      sym_ms_based_modifier,
    ACTIONS(8109), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2186), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [230734] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9997), 1,
      sym_identifier,
    ACTIONS(9999), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_defined,
    ACTIONS(10067), 1,
      sym_number_literal,
    ACTIONS(10003), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10005), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10009), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5762), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [230774] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8097), 1,
      sym_identifier,
    ACTIONS(8099), 1,
      anon_sym_LPAREN2,
    ACTIONS(8111), 1,
      sym_primitive_type,
    ACTIONS(8125), 1,
      anon_sym_STAR,
    ACTIONS(8127), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8129), 1,
      anon_sym_AMP,
    STATE(2258), 1,
      sym_pointer_type_declarator,
    STATE(6386), 1,
      sym__type_declarator,
    STATE(6736), 1,
      sym__type_definition_declarators,
    STATE(8147), 1,
      sym_ms_based_modifier,
    ACTIONS(8109), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2186), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [230824] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9997), 1,
      sym_identifier,
    ACTIONS(9999), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_defined,
    ACTIONS(10069), 1,
      sym_number_literal,
    ACTIONS(10003), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10005), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10009), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5725), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [230864] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8097), 1,
      sym_identifier,
    ACTIONS(8099), 1,
      anon_sym_LPAREN2,
    ACTIONS(8111), 1,
      sym_primitive_type,
    ACTIONS(8125), 1,
      anon_sym_STAR,
    ACTIONS(8127), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8129), 1,
      anon_sym_AMP,
    STATE(2258), 1,
      sym_pointer_type_declarator,
    STATE(6386), 1,
      sym__type_declarator,
    STATE(6782), 1,
      sym__type_definition_declarators,
    STATE(8147), 1,
      sym_ms_based_modifier,
    ACTIONS(8109), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2186), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [230914] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9827), 1,
      sym_identifier,
    ACTIONS(9831), 1,
      anon_sym_LPAREN2,
    ACTIONS(9833), 1,
      anon_sym_defined,
    ACTIONS(10071), 1,
      sym_number_literal,
    ACTIONS(9835), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9837), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9841), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5724), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [230954] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8097), 1,
      sym_identifier,
    ACTIONS(8099), 1,
      anon_sym_LPAREN2,
    ACTIONS(8111), 1,
      sym_primitive_type,
    ACTIONS(8125), 1,
      anon_sym_STAR,
    ACTIONS(8127), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8129), 1,
      anon_sym_AMP,
    STATE(2258), 1,
      sym_pointer_type_declarator,
    STATE(6386), 1,
      sym__type_declarator,
    STATE(6770), 1,
      sym__type_definition_declarators,
    STATE(8147), 1,
      sym_ms_based_modifier,
    ACTIONS(8109), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2186), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [231004] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(8157), 1,
      anon_sym_STAR,
    ACTIONS(10073), 1,
      sym_identifier,
    ACTIONS(10075), 1,
      anon_sym_TILDE,
    ACTIONS(10077), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10079), 1,
      anon_sym_template,
    ACTIONS(10081), 1,
      anon_sym_operator,
    STATE(2119), 1,
      sym_dependent_type_identifier,
    STATE(2137), 1,
      sym_template_type,
    STATE(2161), 1,
      sym_qualified_type_identifier,
    STATE(3475), 1,
      sym_pointer_type_declarator,
    STATE(3477), 1,
      sym_template_function,
    STATE(3478), 1,
      sym_destructor_name,
    STATE(3479), 1,
      sym_dependent_identifier,
    STATE(3481), 1,
      sym_qualified_identifier,
    STATE(3486), 1,
      sym_operator_name,
    STATE(5592), 1,
      sym__scope_resolution,
    STATE(8392), 1,
      sym_ms_based_modifier,
    STATE(8512), 1,
      sym_decltype,
  [231068] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9997), 1,
      sym_identifier,
    ACTIONS(9999), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_defined,
    ACTIONS(10083), 1,
      sym_number_literal,
    ACTIONS(10003), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10005), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10009), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5719), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [231108] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(8157), 1,
      anon_sym_STAR,
    ACTIONS(10075), 1,
      anon_sym_TILDE,
    ACTIONS(10081), 1,
      anon_sym_operator,
    ACTIONS(10085), 1,
      sym_identifier,
    ACTIONS(10087), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10089), 1,
      anon_sym_template,
    STATE(1704), 1,
      sym_template_type,
    STATE(1706), 1,
      sym_dependent_type_identifier,
    STATE(1808), 1,
      sym_qualified_type_identifier,
    STATE(3475), 1,
      sym_pointer_type_declarator,
    STATE(3477), 1,
      sym_template_function,
    STATE(3478), 1,
      sym_destructor_name,
    STATE(3479), 1,
      sym_dependent_identifier,
    STATE(3481), 1,
      sym_qualified_identifier,
    STATE(3486), 1,
      sym_operator_name,
    STATE(5594), 1,
      sym__scope_resolution,
    STATE(8392), 1,
      sym_ms_based_modifier,
    STATE(8512), 1,
      sym_decltype,
  [231172] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8097), 1,
      sym_identifier,
    ACTIONS(8099), 1,
      anon_sym_LPAREN2,
    ACTIONS(8111), 1,
      sym_primitive_type,
    ACTIONS(8125), 1,
      anon_sym_STAR,
    ACTIONS(8127), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8129), 1,
      anon_sym_AMP,
    STATE(2258), 1,
      sym_pointer_type_declarator,
    STATE(6386), 1,
      sym__type_declarator,
    STATE(6765), 1,
      sym__type_definition_declarators,
    STATE(8147), 1,
      sym_ms_based_modifier,
    ACTIONS(8109), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2186), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [231222] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8097), 1,
      sym_identifier,
    ACTIONS(8099), 1,
      anon_sym_LPAREN2,
    ACTIONS(8111), 1,
      sym_primitive_type,
    ACTIONS(8125), 1,
      anon_sym_STAR,
    ACTIONS(8127), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8129), 1,
      anon_sym_AMP,
    STATE(2258), 1,
      sym_pointer_type_declarator,
    STATE(6386), 1,
      sym__type_declarator,
    STATE(6773), 1,
      sym__type_definition_declarators,
    STATE(8147), 1,
      sym_ms_based_modifier,
    ACTIONS(8109), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2186), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [231272] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10093), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10091), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [231300] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8097), 1,
      sym_identifier,
    ACTIONS(8099), 1,
      anon_sym_LPAREN2,
    ACTIONS(8111), 1,
      sym_primitive_type,
    ACTIONS(8125), 1,
      anon_sym_STAR,
    ACTIONS(8127), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8129), 1,
      anon_sym_AMP,
    STATE(2258), 1,
      sym_pointer_type_declarator,
    STATE(6386), 1,
      sym__type_declarator,
    STATE(6768), 1,
      sym__type_definition_declarators,
    STATE(8147), 1,
      sym_ms_based_modifier,
    ACTIONS(8109), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2186), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [231350] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10097), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10095), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [231378] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8097), 1,
      sym_identifier,
    ACTIONS(8099), 1,
      anon_sym_LPAREN2,
    ACTIONS(8111), 1,
      sym_primitive_type,
    ACTIONS(8125), 1,
      anon_sym_STAR,
    ACTIONS(8127), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8129), 1,
      anon_sym_AMP,
    STATE(2258), 1,
      sym_pointer_type_declarator,
    STATE(6386), 1,
      sym__type_declarator,
    STATE(6737), 1,
      sym__type_definition_declarators,
    STATE(8147), 1,
      sym_ms_based_modifier,
    ACTIONS(8109), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2186), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [231428] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(8101), 1,
      anon_sym_STAR,
    ACTIONS(10051), 1,
      anon_sym_TILDE,
    ACTIONS(10057), 1,
      anon_sym_operator,
    ACTIONS(10099), 1,
      sym_identifier,
    ACTIONS(10101), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10103), 1,
      anon_sym_template,
    STATE(2119), 1,
      sym_dependent_type_identifier,
    STATE(2137), 1,
      sym_template_type,
    STATE(2161), 1,
      sym_qualified_type_identifier,
    STATE(2403), 1,
      sym_pointer_type_declarator,
    STATE(2410), 1,
      sym_template_function,
    STATE(2425), 1,
      sym_destructor_name,
    STATE(2431), 1,
      sym_dependent_identifier,
    STATE(2438), 1,
      sym_qualified_identifier,
    STATE(2441), 1,
      sym_operator_name,
    STATE(5601), 1,
      sym__scope_resolution,
    STATE(8208), 1,
      sym_ms_based_modifier,
    STATE(8512), 1,
      sym_decltype,
  [231492] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10107), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10105), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [231520] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9997), 1,
      sym_identifier,
    ACTIONS(9999), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_defined,
    ACTIONS(10109), 1,
      sym_number_literal,
    ACTIONS(10003), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10005), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10009), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5742), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [231560] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6932), 1,
      anon_sym_DASH_GT,
    ACTIONS(6944), 1,
      anon_sym_requires,
    STATE(5482), 1,
      sym_trailing_return_type,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9525), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5701), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [231600] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10113), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10111), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [231628] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(4165), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8125), 1,
      anon_sym_STAR,
    ACTIONS(10115), 1,
      sym_identifier,
    ACTIONS(10117), 1,
      anon_sym_template,
    STATE(2119), 1,
      sym_dependent_type_identifier,
    STATE(2137), 1,
      sym_template_type,
    STATE(2161), 1,
      sym_qualified_type_identifier,
    STATE(2777), 1,
      sym_pointer_type_declarator,
    STATE(2780), 1,
      sym_template_function,
    STATE(2781), 1,
      sym_destructor_name,
    STATE(2784), 1,
      sym_dependent_identifier,
    STATE(2787), 1,
      sym_qualified_identifier,
    STATE(2790), 1,
      sym_operator_name,
    STATE(5606), 1,
      sym__scope_resolution,
    STATE(8147), 1,
      sym_ms_based_modifier,
    STATE(8512), 1,
      sym_decltype,
  [231692] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(4368), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4376), 1,
      anon_sym_EQ,
    ACTIONS(9985), 1,
      sym_identifier,
    ACTIONS(9987), 1,
      anon_sym_STAR,
    ACTIONS(9989), 1,
      anon_sym_AMP,
    ACTIONS(9991), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9995), 1,
      sym_this,
    ACTIONS(10119), 1,
      anon_sym_RBRACK,
    STATE(5700), 1,
      sym__scope_resolution,
    STATE(7453), 1,
      sym_lambda_default_capture,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7112), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [231744] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(4368), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4376), 1,
      anon_sym_EQ,
    ACTIONS(9985), 1,
      sym_identifier,
    ACTIONS(9987), 1,
      anon_sym_STAR,
    ACTIONS(9989), 1,
      anon_sym_AMP,
    ACTIONS(9991), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9995), 1,
      sym_this,
    ACTIONS(10121), 1,
      anon_sym_RBRACK,
    STATE(5700), 1,
      sym__scope_resolution,
    STATE(7453), 1,
      sym_lambda_default_capture,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7112), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [231796] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9997), 1,
      sym_identifier,
    ACTIONS(9999), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_defined,
    ACTIONS(10123), 1,
      sym_number_literal,
    ACTIONS(10003), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10005), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10009), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5766), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [231836] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9997), 1,
      sym_identifier,
    ACTIONS(9999), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_defined,
    ACTIONS(10125), 1,
      sym_number_literal,
    ACTIONS(10003), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10005), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10009), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5711), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [231876] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9827), 1,
      sym_identifier,
    ACTIONS(9831), 1,
      anon_sym_LPAREN2,
    ACTIONS(9833), 1,
      anon_sym_defined,
    ACTIONS(10127), 1,
      sym_number_literal,
    ACTIONS(9835), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9837), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9841), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5662), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [231916] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9827), 1,
      sym_identifier,
    ACTIONS(9831), 1,
      anon_sym_LPAREN2,
    ACTIONS(9833), 1,
      anon_sym_defined,
    ACTIONS(10129), 1,
      sym_number_literal,
    ACTIONS(9835), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9837), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9841), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5686), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [231956] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(4368), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4376), 1,
      anon_sym_EQ,
    ACTIONS(9985), 1,
      sym_identifier,
    ACTIONS(9987), 1,
      anon_sym_STAR,
    ACTIONS(9989), 1,
      anon_sym_AMP,
    ACTIONS(9991), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9995), 1,
      sym_this,
    ACTIONS(10131), 1,
      anon_sym_RBRACK,
    STATE(5700), 1,
      sym__scope_resolution,
    STATE(7453), 1,
      sym_lambda_default_capture,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7112), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [232008] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(8157), 1,
      anon_sym_STAR,
    ACTIONS(10075), 1,
      anon_sym_TILDE,
    ACTIONS(10081), 1,
      anon_sym_operator,
    ACTIONS(10133), 1,
      sym_identifier,
    ACTIONS(10135), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10137), 1,
      anon_sym_template,
    STATE(2119), 1,
      sym_dependent_type_identifier,
    STATE(2137), 1,
      sym_template_type,
    STATE(2161), 1,
      sym_qualified_type_identifier,
    STATE(3475), 1,
      sym_pointer_type_declarator,
    STATE(3477), 1,
      sym_template_function,
    STATE(3478), 1,
      sym_destructor_name,
    STATE(3479), 1,
      sym_dependent_identifier,
    STATE(3481), 1,
      sym_qualified_identifier,
    STATE(3486), 1,
      sym_operator_name,
    STATE(5614), 1,
      sym__scope_resolution,
    STATE(8392), 1,
      sym_ms_based_modifier,
    STATE(8512), 1,
      sym_decltype,
  [232072] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6932), 1,
      anon_sym_DASH_GT,
    ACTIONS(6944), 1,
      anon_sym_requires,
    STATE(5486), 1,
      sym_trailing_return_type,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9674), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5714), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9672), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [232112] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9827), 1,
      sym_identifier,
    ACTIONS(9831), 1,
      anon_sym_LPAREN2,
    ACTIONS(9833), 1,
      anon_sym_defined,
    ACTIONS(10139), 1,
      sym_number_literal,
    ACTIONS(9835), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9837), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9841), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5691), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [232152] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10143), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10141), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [232180] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(4368), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4376), 1,
      anon_sym_EQ,
    ACTIONS(9985), 1,
      sym_identifier,
    ACTIONS(9987), 1,
      anon_sym_STAR,
    ACTIONS(9989), 1,
      anon_sym_AMP,
    ACTIONS(9991), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9995), 1,
      sym_this,
    ACTIONS(10145), 1,
      anon_sym_RBRACK,
    STATE(5700), 1,
      sym__scope_resolution,
    STATE(7453), 1,
      sym_lambda_default_capture,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7112), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [232232] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(4368), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4376), 1,
      anon_sym_EQ,
    ACTIONS(9985), 1,
      sym_identifier,
    ACTIONS(9987), 1,
      anon_sym_STAR,
    ACTIONS(9989), 1,
      anon_sym_AMP,
    ACTIONS(9991), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9995), 1,
      sym_this,
    ACTIONS(10147), 1,
      anon_sym_RBRACK,
    STATE(5700), 1,
      sym__scope_resolution,
    STATE(7453), 1,
      sym_lambda_default_capture,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7112), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [232284] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9827), 1,
      sym_identifier,
    ACTIONS(9831), 1,
      anon_sym_LPAREN2,
    ACTIONS(9833), 1,
      anon_sym_defined,
    ACTIONS(10149), 1,
      sym_number_literal,
    ACTIONS(9835), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9837), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9841), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5694), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [232324] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(4368), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4376), 1,
      anon_sym_EQ,
    ACTIONS(9985), 1,
      sym_identifier,
    ACTIONS(9987), 1,
      anon_sym_STAR,
    ACTIONS(9989), 1,
      anon_sym_AMP,
    ACTIONS(9991), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9995), 1,
      sym_this,
    ACTIONS(10151), 1,
      anon_sym_RBRACK,
    STATE(5700), 1,
      sym__scope_resolution,
    STATE(7453), 1,
      sym_lambda_default_capture,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7112), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [232376] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9997), 1,
      sym_identifier,
    ACTIONS(9999), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_defined,
    ACTIONS(10153), 1,
      sym_number_literal,
    ACTIONS(10003), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10005), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10009), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5747), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [232416] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5635), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9662), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9660), 14,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [232448] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(4887), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8125), 1,
      anon_sym_STAR,
    ACTIONS(10155), 1,
      sym_identifier,
    ACTIONS(10157), 1,
      anon_sym_template,
    STATE(2119), 1,
      sym_dependent_type_identifier,
    STATE(2137), 1,
      sym_template_type,
    STATE(2161), 1,
      sym_qualified_type_identifier,
    STATE(2777), 1,
      sym_pointer_type_declarator,
    STATE(2780), 1,
      sym_template_function,
    STATE(2781), 1,
      sym_destructor_name,
    STATE(2784), 1,
      sym_dependent_identifier,
    STATE(2787), 1,
      sym_qualified_identifier,
    STATE(2790), 1,
      sym_operator_name,
    STATE(5624), 1,
      sym__scope_resolution,
    STATE(8147), 1,
      sym_ms_based_modifier,
    STATE(8512), 1,
      sym_decltype,
  [232512] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7149), 1,
      anon_sym_DASH_GT,
    ACTIONS(7162), 1,
      anon_sym_requires,
    STATE(5366), 1,
      sym_trailing_return_type,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9062), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [232552] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(4368), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4374), 1,
      anon_sym_RBRACK,
    ACTIONS(4376), 1,
      anon_sym_EQ,
    ACTIONS(9987), 1,
      anon_sym_STAR,
    ACTIONS(9989), 1,
      anon_sym_AMP,
    ACTIONS(9991), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9995), 1,
      sym_this,
    ACTIONS(10159), 1,
      sym_identifier,
    STATE(5700), 1,
      sym__scope_resolution,
    STATE(7453), 1,
      sym_lambda_default_capture,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7112), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [232604] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(4368), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4376), 1,
      anon_sym_EQ,
    ACTIONS(9985), 1,
      sym_identifier,
    ACTIONS(9987), 1,
      anon_sym_STAR,
    ACTIONS(9989), 1,
      anon_sym_AMP,
    ACTIONS(9991), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9995), 1,
      sym_this,
    ACTIONS(10161), 1,
      anon_sym_RBRACK,
    STATE(5700), 1,
      sym__scope_resolution,
    STATE(7453), 1,
      sym_lambda_default_capture,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7112), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [232656] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8097), 1,
      sym_identifier,
    ACTIONS(8099), 1,
      anon_sym_LPAREN2,
    ACTIONS(8111), 1,
      sym_primitive_type,
    ACTIONS(8125), 1,
      anon_sym_STAR,
    ACTIONS(8127), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8129), 1,
      anon_sym_AMP,
    STATE(2258), 1,
      sym_pointer_type_declarator,
    STATE(6386), 1,
      sym__type_declarator,
    STATE(6766), 1,
      sym__type_definition_declarators,
    STATE(8147), 1,
      sym_ms_based_modifier,
    ACTIONS(8109), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2186), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [232706] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9827), 1,
      sym_identifier,
    ACTIONS(9831), 1,
      anon_sym_LPAREN2,
    ACTIONS(9833), 1,
      anon_sym_defined,
    ACTIONS(10163), 1,
      sym_number_literal,
    ACTIONS(9835), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9837), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9841), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5602), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [232746] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9827), 1,
      sym_identifier,
    ACTIONS(9831), 1,
      anon_sym_LPAREN2,
    ACTIONS(9833), 1,
      anon_sym_defined,
    ACTIONS(10165), 1,
      sym_number_literal,
    ACTIONS(9835), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9837), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9841), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5557), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [232786] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9997), 1,
      sym_identifier,
    ACTIONS(9999), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_defined,
    ACTIONS(10167), 1,
      sym_number_literal,
    ACTIONS(10003), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10005), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10009), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5722), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [232826] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9827), 1,
      sym_identifier,
    ACTIONS(9831), 1,
      anon_sym_LPAREN2,
    ACTIONS(9833), 1,
      anon_sym_defined,
    ACTIONS(10169), 1,
      sym_number_literal,
    ACTIONS(9835), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9837), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9841), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5671), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [232866] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7149), 1,
      anon_sym_DASH_GT,
    ACTIONS(7162), 1,
      anon_sym_requires,
    STATE(5367), 1,
      sym_trailing_return_type,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9211), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [232906] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9827), 1,
      sym_identifier,
    ACTIONS(9831), 1,
      anon_sym_LPAREN2,
    ACTIONS(9833), 1,
      anon_sym_defined,
    ACTIONS(10171), 1,
      sym_number_literal,
    ACTIONS(9835), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9837), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9841), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5560), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [232946] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10173), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5635), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6067), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(6069), 14,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [232978] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(4368), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4376), 1,
      anon_sym_EQ,
    ACTIONS(9985), 1,
      sym_identifier,
    ACTIONS(9987), 1,
      anon_sym_STAR,
    ACTIONS(9989), 1,
      anon_sym_AMP,
    ACTIONS(9991), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9995), 1,
      sym_this,
    ACTIONS(10176), 1,
      anon_sym_RBRACK,
    STATE(5700), 1,
      sym__scope_resolution,
    STATE(7453), 1,
      sym_lambda_default_capture,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7112), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [233030] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9997), 1,
      sym_identifier,
    ACTIONS(9999), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_defined,
    ACTIONS(10178), 1,
      sym_number_literal,
    ACTIONS(10003), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10005), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10009), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5713), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [233070] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7149), 1,
      anon_sym_DASH_GT,
    ACTIONS(7162), 1,
      anon_sym_requires,
    STATE(5368), 1,
      sym_trailing_return_type,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9525), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5701), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [233110] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8097), 1,
      sym_identifier,
    ACTIONS(8099), 1,
      anon_sym_LPAREN2,
    ACTIONS(8111), 1,
      sym_primitive_type,
    ACTIONS(8125), 1,
      anon_sym_STAR,
    ACTIONS(8127), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8129), 1,
      anon_sym_AMP,
    STATE(2258), 1,
      sym_pointer_type_declarator,
    STATE(6386), 1,
      sym__type_declarator,
    STATE(6745), 1,
      sym__type_definition_declarators,
    STATE(8147), 1,
      sym_ms_based_modifier,
    ACTIONS(8109), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2186), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [233160] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9827), 1,
      sym_identifier,
    ACTIONS(9831), 1,
      anon_sym_LPAREN2,
    ACTIONS(9833), 1,
      anon_sym_defined,
    ACTIONS(10180), 1,
      sym_number_literal,
    ACTIONS(9835), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9837), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9841), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5563), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [233200] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(4368), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4376), 1,
      anon_sym_EQ,
    ACTIONS(9985), 1,
      sym_identifier,
    ACTIONS(9987), 1,
      anon_sym_STAR,
    ACTIONS(9989), 1,
      anon_sym_AMP,
    ACTIONS(9991), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9995), 1,
      sym_this,
    ACTIONS(10182), 1,
      anon_sym_RBRACK,
    STATE(5700), 1,
      sym__scope_resolution,
    STATE(7453), 1,
      sym_lambda_default_capture,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7112), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [233252] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(4368), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4376), 1,
      anon_sym_EQ,
    ACTIONS(9985), 1,
      sym_identifier,
    ACTIONS(9987), 1,
      anon_sym_STAR,
    ACTIONS(9989), 1,
      anon_sym_AMP,
    ACTIONS(9991), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9995), 1,
      sym_this,
    ACTIONS(10184), 1,
      anon_sym_RBRACK,
    STATE(5700), 1,
      sym__scope_resolution,
    STATE(7453), 1,
      sym_lambda_default_capture,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7112), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [233304] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7149), 1,
      anon_sym_DASH_GT,
    ACTIONS(7162), 1,
      anon_sym_requires,
    STATE(5369), 1,
      sym_trailing_return_type,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9674), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5714), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9672), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [233344] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9827), 1,
      sym_identifier,
    ACTIONS(9831), 1,
      anon_sym_LPAREN2,
    ACTIONS(9833), 1,
      anon_sym_defined,
    ACTIONS(10186), 1,
      sym_number_literal,
    ACTIONS(9835), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9837), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9841), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5564), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [233384] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6944), 1,
      anon_sym_requires,
    ACTIONS(7132), 1,
      anon_sym_DASH_GT,
    STATE(5497), 1,
      sym_trailing_return_type,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9062), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [233424] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9827), 1,
      sym_identifier,
    ACTIONS(9831), 1,
      anon_sym_LPAREN2,
    ACTIONS(9833), 1,
      anon_sym_defined,
    ACTIONS(10188), 1,
      sym_number_literal,
    ACTIONS(9835), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9837), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9841), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5565), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [233464] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9827), 1,
      sym_identifier,
    ACTIONS(9831), 1,
      anon_sym_LPAREN2,
    ACTIONS(9833), 1,
      anon_sym_defined,
    ACTIONS(10190), 1,
      sym_number_literal,
    ACTIONS(9835), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(9837), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9841), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5566), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [233504] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(4368), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4376), 1,
      anon_sym_EQ,
    ACTIONS(9985), 1,
      sym_identifier,
    ACTIONS(9987), 1,
      anon_sym_STAR,
    ACTIONS(9989), 1,
      anon_sym_AMP,
    ACTIONS(9991), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9995), 1,
      sym_this,
    ACTIONS(10192), 1,
      anon_sym_RBRACK,
    STATE(5700), 1,
      sym__scope_resolution,
    STATE(7453), 1,
      sym_lambda_default_capture,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7112), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [233556] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(8157), 1,
      anon_sym_STAR,
    ACTIONS(10015), 1,
      anon_sym_TILDE,
    ACTIONS(10021), 1,
      anon_sym_operator,
    ACTIONS(10194), 1,
      sym_identifier,
    ACTIONS(10196), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10198), 1,
      anon_sym_template,
    STATE(2119), 1,
      sym_dependent_type_identifier,
    STATE(2137), 1,
      sym_template_type,
    STATE(2161), 1,
      sym_qualified_type_identifier,
    STATE(3216), 1,
      sym_pointer_type_declarator,
    STATE(3223), 1,
      sym_template_function,
    STATE(3228), 1,
      sym_destructor_name,
    STATE(3230), 1,
      sym_dependent_identifier,
    STATE(3251), 1,
      sym_qualified_identifier,
    STATE(3290), 1,
      sym_operator_name,
    STATE(5649), 1,
      sym__scope_resolution,
    STATE(8392), 1,
      sym_ms_based_modifier,
    STATE(8512), 1,
      sym_decltype,
  [233620] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(4368), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4374), 1,
      anon_sym_RBRACK,
    ACTIONS(4376), 1,
      anon_sym_EQ,
    ACTIONS(9985), 1,
      sym_identifier,
    ACTIONS(9987), 1,
      anon_sym_STAR,
    ACTIONS(9989), 1,
      anon_sym_AMP,
    ACTIONS(9991), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9995), 1,
      sym_this,
    STATE(5700), 1,
      sym__scope_resolution,
    STATE(7453), 1,
      sym_lambda_default_capture,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7112), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [233672] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9997), 1,
      sym_identifier,
    ACTIONS(9999), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_defined,
    ACTIONS(10200), 1,
      sym_number_literal,
    ACTIONS(10003), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10005), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10009), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5715), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [233712] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9997), 1,
      sym_identifier,
    ACTIONS(9999), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_defined,
    ACTIONS(10202), 1,
      sym_number_literal,
    ACTIONS(10003), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10005), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10009), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5738), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [233752] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10206), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10204), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [233780] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8097), 1,
      sym_identifier,
    ACTIONS(8099), 1,
      anon_sym_LPAREN2,
    ACTIONS(8111), 1,
      sym_primitive_type,
    ACTIONS(8125), 1,
      anon_sym_STAR,
    ACTIONS(8127), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8129), 1,
      anon_sym_AMP,
    STATE(2258), 1,
      sym_pointer_type_declarator,
    STATE(6386), 1,
      sym__type_declarator,
    STATE(6763), 1,
      sym__type_definition_declarators,
    STATE(8147), 1,
      sym_ms_based_modifier,
    ACTIONS(8109), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2186), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [233830] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6944), 1,
      anon_sym_requires,
    ACTIONS(7132), 1,
      anon_sym_DASH_GT,
    STATE(5535), 1,
      sym_trailing_return_type,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9211), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [233870] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9997), 1,
      sym_identifier,
    ACTIONS(9999), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_defined,
    ACTIONS(10208), 1,
      sym_number_literal,
    ACTIONS(10003), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10005), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10009), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5745), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [233910] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9997), 1,
      sym_identifier,
    ACTIONS(9999), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_defined,
    ACTIONS(10210), 1,
      sym_number_literal,
    ACTIONS(10003), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10005), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10009), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5749), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [233950] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(8101), 1,
      anon_sym_STAR,
    ACTIONS(10051), 1,
      anon_sym_TILDE,
    ACTIONS(10057), 1,
      anon_sym_operator,
    ACTIONS(10212), 1,
      sym_identifier,
    ACTIONS(10214), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10216), 1,
      anon_sym_template,
    STATE(1704), 1,
      sym_template_type,
    STATE(1706), 1,
      sym_dependent_type_identifier,
    STATE(1808), 1,
      sym_qualified_type_identifier,
    STATE(2403), 1,
      sym_pointer_type_declarator,
    STATE(2410), 1,
      sym_template_function,
    STATE(2425), 1,
      sym_destructor_name,
    STATE(2431), 1,
      sym_dependent_identifier,
    STATE(2438), 1,
      sym_qualified_identifier,
    STATE(2441), 1,
      sym_operator_name,
    STATE(5658), 1,
      sym__scope_resolution,
    STATE(8208), 1,
      sym_ms_based_modifier,
    STATE(8512), 1,
      sym_decltype,
  [234014] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8074), 1,
      anon_sym_STAR,
    ACTIONS(8076), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8078), 1,
      anon_sym_AMP,
    STATE(2998), 1,
      sym_parameter_list,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6362), 1,
      sym__abstract_declarator,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8197), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [234058] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8056), 1,
      anon_sym_STAR,
    ACTIONS(8058), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8060), 1,
      anon_sym_AMP,
    ACTIONS(8199), 1,
      anon_sym___attribute,
    STATE(3221), 1,
      sym_parameter_list,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6390), 1,
      sym__abstract_declarator,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8197), 6,
      anon_sym_COMMA,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [234104] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9997), 1,
      sym_identifier,
    ACTIONS(9999), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_defined,
    ACTIONS(10218), 1,
      sym_number_literal,
    ACTIONS(10003), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10005), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10009), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5721), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [234144] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9887), 1,
      anon_sym_SLASH,
    ACTIONS(9885), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(10037), 4,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10035), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [234176] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6944), 1,
      anon_sym_requires,
    ACTIONS(7132), 1,
      anon_sym_DASH_GT,
    STATE(5482), 1,
      sym_trailing_return_type,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9525), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5701), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [234216] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(8101), 1,
      anon_sym_STAR,
    ACTIONS(10051), 1,
      anon_sym_TILDE,
    ACTIONS(10057), 1,
      anon_sym_operator,
    ACTIONS(10220), 1,
      sym_identifier,
    ACTIONS(10222), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10224), 1,
      anon_sym_template,
    STATE(2119), 1,
      sym_dependent_type_identifier,
    STATE(2137), 1,
      sym_template_type,
    STATE(2161), 1,
      sym_qualified_type_identifier,
    STATE(2403), 1,
      sym_pointer_type_declarator,
    STATE(2410), 1,
      sym_template_function,
    STATE(2425), 1,
      sym_destructor_name,
    STATE(2431), 1,
      sym_dependent_identifier,
    STATE(2438), 1,
      sym_qualified_identifier,
    STATE(2441), 1,
      sym_operator_name,
    STATE(5664), 1,
      sym__scope_resolution,
    STATE(8208), 1,
      sym_ms_based_modifier,
    STATE(8512), 1,
      sym_decltype,
  [234280] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(4368), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4376), 1,
      anon_sym_EQ,
    ACTIONS(9985), 1,
      sym_identifier,
    ACTIONS(9987), 1,
      anon_sym_STAR,
    ACTIONS(9989), 1,
      anon_sym_AMP,
    ACTIONS(9991), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9995), 1,
      sym_this,
    ACTIONS(10226), 1,
      anon_sym_RBRACK,
    STATE(5700), 1,
      sym__scope_resolution,
    STATE(7453), 1,
      sym_lambda_default_capture,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7112), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [234332] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6932), 1,
      anon_sym_DASH_GT,
    ACTIONS(9085), 1,
      anon_sym_requires,
    STATE(5411), 1,
      sym_trailing_return_type,
    ACTIONS(9062), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(9082), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [234372] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6944), 1,
      anon_sym_requires,
    ACTIONS(7132), 1,
      anon_sym_DASH_GT,
    STATE(5486), 1,
      sym_trailing_return_type,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9674), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5714), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9672), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [234412] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6932), 1,
      anon_sym_DASH_GT,
    ACTIONS(9216), 1,
      anon_sym_requires,
    STATE(5489), 1,
      sym_trailing_return_type,
    ACTIONS(9211), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(9213), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [234452] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9997), 1,
      sym_identifier,
    ACTIONS(9999), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_defined,
    ACTIONS(10228), 1,
      sym_number_literal,
    ACTIONS(10003), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10005), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10009), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5728), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [234492] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7132), 1,
      anon_sym_DASH_GT,
    ACTIONS(9085), 1,
      anon_sym_requires,
    STATE(5411), 1,
      sym_trailing_return_type,
    ACTIONS(9062), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9082), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [234532] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9887), 1,
      anon_sym_SLASH,
    ACTIONS(9889), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9891), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9893), 1,
      anon_sym_PIPE,
    ACTIONS(9895), 1,
      anon_sym_CARET,
    ACTIONS(9897), 1,
      anon_sym_AMP,
    ACTIONS(9883), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9885), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9899), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9901), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9903), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9905), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10230), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [234582] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(4368), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4376), 1,
      anon_sym_EQ,
    ACTIONS(9985), 1,
      sym_identifier,
    ACTIONS(9987), 1,
      anon_sym_STAR,
    ACTIONS(9989), 1,
      anon_sym_AMP,
    ACTIONS(9991), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9995), 1,
      sym_this,
    ACTIONS(10232), 1,
      anon_sym_RBRACK,
    STATE(5700), 1,
      sym__scope_resolution,
    STATE(7453), 1,
      sym_lambda_default_capture,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7112), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [234634] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(4368), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4376), 1,
      anon_sym_EQ,
    ACTIONS(9985), 1,
      sym_identifier,
    ACTIONS(9987), 1,
      anon_sym_STAR,
    ACTIONS(9989), 1,
      anon_sym_AMP,
    ACTIONS(9991), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9995), 1,
      sym_this,
    ACTIONS(10234), 1,
      anon_sym_RBRACK,
    STATE(5700), 1,
      sym__scope_resolution,
    STATE(7453), 1,
      sym_lambda_default_capture,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7112), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [234686] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7132), 1,
      anon_sym_DASH_GT,
    ACTIONS(9216), 1,
      anon_sym_requires,
    STATE(5489), 1,
      sym_trailing_return_type,
    ACTIONS(9211), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9213), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [234726] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7132), 1,
      anon_sym_DASH_GT,
    ACTIONS(9530), 1,
      anon_sym_requires,
    STATE(5401), 1,
      sym_trailing_return_type,
    ACTIONS(9525), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9527), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5701), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [234766] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7132), 1,
      anon_sym_DASH_GT,
    ACTIONS(9824), 1,
      anon_sym_requires,
    STATE(5527), 1,
      sym_trailing_return_type,
    ACTIONS(9674), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9676), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5714), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9672), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [234806] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6932), 1,
      anon_sym_DASH_GT,
    ACTIONS(9530), 1,
      anon_sym_requires,
    STATE(5401), 1,
      sym_trailing_return_type,
    ACTIONS(9525), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(9527), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5701), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [234846] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10238), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10236), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [234874] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6932), 1,
      anon_sym_DASH_GT,
    ACTIONS(9824), 1,
      anon_sym_requires,
    STATE(5527), 1,
      sym_trailing_return_type,
    ACTIONS(9674), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(9676), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5714), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9672), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [234914] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10242), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10240), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [234942] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(4368), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4376), 1,
      anon_sym_EQ,
    ACTIONS(9985), 1,
      sym_identifier,
    ACTIONS(9987), 1,
      anon_sym_STAR,
    ACTIONS(9989), 1,
      anon_sym_AMP,
    ACTIONS(9991), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9995), 1,
      sym_this,
    ACTIONS(10244), 1,
      anon_sym_RBRACK,
    STATE(5700), 1,
      sym__scope_resolution,
    STATE(7453), 1,
      sym_lambda_default_capture,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7112), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [234994] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9997), 1,
      sym_identifier,
    ACTIONS(9999), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_defined,
    ACTIONS(10246), 1,
      sym_number_literal,
    ACTIONS(10003), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10005), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10009), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5733), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [235034] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5635), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(9788), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9786), 14,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [235066] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8097), 1,
      sym_identifier,
    ACTIONS(8099), 1,
      anon_sym_LPAREN2,
    ACTIONS(8111), 1,
      sym_primitive_type,
    ACTIONS(8125), 1,
      anon_sym_STAR,
    ACTIONS(8127), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8129), 1,
      anon_sym_AMP,
    STATE(2258), 1,
      sym_pointer_type_declarator,
    STATE(6386), 1,
      sym__type_declarator,
    STATE(6774), 1,
      sym__type_definition_declarators,
    STATE(8147), 1,
      sym_ms_based_modifier,
    ACTIONS(8109), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2186), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [235116] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(4368), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4376), 1,
      anon_sym_EQ,
    ACTIONS(9985), 1,
      sym_identifier,
    ACTIONS(9987), 1,
      anon_sym_STAR,
    ACTIONS(9989), 1,
      anon_sym_AMP,
    ACTIONS(9991), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9995), 1,
      sym_this,
    ACTIONS(10248), 1,
      anon_sym_RBRACK,
    STATE(5700), 1,
      sym__scope_resolution,
    STATE(7453), 1,
      sym_lambda_default_capture,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7112), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [235168] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10037), 5,
      anon_sym_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(10035), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_CARET,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [235196] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(4368), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4376), 1,
      anon_sym_EQ,
    ACTIONS(9985), 1,
      sym_identifier,
    ACTIONS(9987), 1,
      anon_sym_STAR,
    ACTIONS(9989), 1,
      anon_sym_AMP,
    ACTIONS(9991), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9995), 1,
      sym_this,
    ACTIONS(10250), 1,
      anon_sym_RBRACK,
    STATE(5700), 1,
      sym__scope_resolution,
    STATE(7453), 1,
      sym_lambda_default_capture,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7112), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [235248] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(4368), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4376), 1,
      anon_sym_EQ,
    ACTIONS(9985), 1,
      sym_identifier,
    ACTIONS(9987), 1,
      anon_sym_STAR,
    ACTIONS(9989), 1,
      anon_sym_AMP,
    ACTIONS(9991), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9995), 1,
      sym_this,
    ACTIONS(10252), 1,
      anon_sym_RBRACK,
    STATE(5700), 1,
      sym__scope_resolution,
    STATE(7453), 1,
      sym_lambda_default_capture,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7112), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [235300] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9997), 1,
      sym_identifier,
    ACTIONS(9999), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_defined,
    ACTIONS(10254), 1,
      sym_number_literal,
    ACTIONS(10003), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10005), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10009), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5699), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [235340] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8097), 1,
      sym_identifier,
    ACTIONS(8099), 1,
      anon_sym_LPAREN2,
    ACTIONS(8111), 1,
      sym_primitive_type,
    ACTIONS(8125), 1,
      anon_sym_STAR,
    ACTIONS(8127), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8129), 1,
      anon_sym_AMP,
    STATE(2258), 1,
      sym_pointer_type_declarator,
    STATE(6386), 1,
      sym__type_declarator,
    STATE(6801), 1,
      sym__type_definition_declarators,
    STATE(8147), 1,
      sym_ms_based_modifier,
    ACTIONS(8109), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2186), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [235390] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9887), 1,
      anon_sym_SLASH,
    ACTIONS(9891), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9893), 1,
      anon_sym_PIPE,
    ACTIONS(9895), 1,
      anon_sym_CARET,
    ACTIONS(9897), 1,
      anon_sym_AMP,
    ACTIONS(9883), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9885), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9899), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9901), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9903), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9905), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10035), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
  [235438] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(4368), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4376), 1,
      anon_sym_EQ,
    ACTIONS(9985), 1,
      sym_identifier,
    ACTIONS(9987), 1,
      anon_sym_STAR,
    ACTIONS(9989), 1,
      anon_sym_AMP,
    ACTIONS(9991), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9995), 1,
      sym_this,
    ACTIONS(10256), 1,
      anon_sym_RBRACK,
    STATE(5700), 1,
      sym__scope_resolution,
    STATE(7453), 1,
      sym_lambda_default_capture,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7112), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [235490] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(8185), 1,
      anon_sym_STAR,
    ACTIONS(10258), 1,
      sym_identifier,
    ACTIONS(10260), 1,
      anon_sym_TILDE,
    ACTIONS(10262), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10264), 1,
      anon_sym_template,
    ACTIONS(10266), 1,
      anon_sym_operator,
    STATE(2517), 1,
      sym_template_type,
    STATE(2521), 1,
      sym_dependent_type_identifier,
    STATE(2593), 1,
      sym_qualified_type_identifier,
    STATE(3567), 1,
      sym_pointer_type_declarator,
    STATE(3568), 1,
      sym_template_function,
    STATE(3569), 1,
      sym_destructor_name,
    STATE(3570), 1,
      sym_dependent_identifier,
    STATE(3571), 1,
      sym_qualified_identifier,
    STATE(3574), 1,
      sym_operator_name,
    STATE(5693), 1,
      sym__scope_resolution,
    STATE(8244), 1,
      sym_ms_based_modifier,
    STATE(8512), 1,
      sym_decltype,
  [235554] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9887), 1,
      anon_sym_SLASH,
    ACTIONS(9893), 1,
      anon_sym_PIPE,
    ACTIONS(9895), 1,
      anon_sym_CARET,
    ACTIONS(9897), 1,
      anon_sym_AMP,
    ACTIONS(9883), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9885), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9899), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9901), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9903), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9905), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10035), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
  [235600] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(4368), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(4376), 1,
      anon_sym_EQ,
    ACTIONS(9985), 1,
      sym_identifier,
    ACTIONS(9987), 1,
      anon_sym_STAR,
    ACTIONS(9989), 1,
      anon_sym_AMP,
    ACTIONS(9991), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9995), 1,
      sym_this,
    ACTIONS(10268), 1,
      anon_sym_RBRACK,
    STATE(5700), 1,
      sym__scope_resolution,
    STATE(7453), 1,
      sym_lambda_default_capture,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7112), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [235652] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(8185), 1,
      anon_sym_STAR,
    ACTIONS(10260), 1,
      anon_sym_TILDE,
    ACTIONS(10266), 1,
      anon_sym_operator,
    ACTIONS(10270), 1,
      sym_identifier,
    ACTIONS(10272), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10274), 1,
      anon_sym_template,
    STATE(2119), 1,
      sym_dependent_type_identifier,
    STATE(2137), 1,
      sym_template_type,
    STATE(2161), 1,
      sym_qualified_type_identifier,
    STATE(3567), 1,
      sym_pointer_type_declarator,
    STATE(3568), 1,
      sym_template_function,
    STATE(3569), 1,
      sym_destructor_name,
    STATE(3570), 1,
      sym_dependent_identifier,
    STATE(3571), 1,
      sym_qualified_identifier,
    STATE(3574), 1,
      sym_operator_name,
    STATE(5696), 1,
      sym__scope_resolution,
    STATE(8244), 1,
      sym_ms_based_modifier,
    STATE(8512), 1,
      sym_decltype,
  [235716] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9997), 1,
      sym_identifier,
    ACTIONS(9999), 1,
      anon_sym_LPAREN2,
    ACTIONS(10001), 1,
      anon_sym_defined,
    ACTIONS(10276), 1,
      sym_number_literal,
    ACTIONS(10003), 2,
      anon_sym_BANG,
      anon_sym_TILDE,
    ACTIONS(10005), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10009), 5,
      anon_sym_L_SQUOTE,
      anon_sym_u_SQUOTE,
      anon_sym_U_SQUOTE,
      anon_sym_u8_SQUOTE,
      anon_sym_SQUOTE,
    STATE(5768), 7,
      sym__preproc_expression,
      sym_preproc_parenthesized_expression,
      sym_preproc_defined,
      sym_preproc_unary_expression,
      sym_preproc_call_expression,
      sym_preproc_binary_expression,
      sym_char_literal,
  [235756] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10280), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10278), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [235783] = 12,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(10282), 1,
      anon_sym_LF,
    ACTIONS(10288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10290), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10292), 1,
      anon_sym_PIPE,
    ACTIONS(10294), 1,
      anon_sym_CARET,
    ACTIONS(10296), 1,
      anon_sym_AMP,
    ACTIONS(10284), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10298), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10302), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10286), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10300), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [235828] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(8125), 1,
      anon_sym_STAR,
    ACTIONS(9991), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10304), 1,
      sym_identifier,
    ACTIONS(10306), 1,
      anon_sym_template,
    STATE(2777), 1,
      sym_pointer_type_declarator,
    STATE(2780), 1,
      sym_template_function,
    STATE(2781), 1,
      sym_destructor_name,
    STATE(2784), 1,
      sym_dependent_identifier,
    STATE(2787), 1,
      sym_qualified_identifier,
    STATE(2790), 1,
      sym_operator_name,
    STATE(5700), 1,
      sym__scope_resolution,
    STATE(8147), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [235885] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9674), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9672), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [235912] = 3,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(10111), 1,
      anon_sym_LF,
    ACTIONS(10113), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [235939] = 3,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(10240), 1,
      anon_sym_LF,
    ACTIONS(10242), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [235966] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8097), 1,
      sym_identifier,
    ACTIONS(8099), 1,
      anon_sym_LPAREN2,
    ACTIONS(8101), 1,
      anon_sym_STAR,
    ACTIONS(8103), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8105), 1,
      anon_sym_AMP,
    ACTIONS(8111), 1,
      sym_primitive_type,
    STATE(2159), 1,
      sym__type_declarator,
    STATE(2258), 1,
      sym_pointer_type_declarator,
    STATE(8208), 1,
      sym_ms_based_modifier,
    ACTIONS(8109), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2186), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [236013] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8097), 1,
      sym_identifier,
    ACTIONS(8099), 1,
      anon_sym_LPAREN2,
    ACTIONS(8111), 1,
      sym_primitive_type,
    ACTIONS(8125), 1,
      anon_sym_STAR,
    ACTIONS(8127), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8129), 1,
      anon_sym_AMP,
    STATE(2258), 1,
      sym_pointer_type_declarator,
    STATE(6660), 1,
      sym__type_declarator,
    STATE(8147), 1,
      sym_ms_based_modifier,
    ACTIONS(8109), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2186), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [236060] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9887), 1,
      anon_sym_SLASH,
    ACTIONS(9889), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9891), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9893), 1,
      anon_sym_PIPE,
    ACTIONS(9895), 1,
      anon_sym_CARET,
    ACTIONS(9897), 1,
      anon_sym_AMP,
    ACTIONS(10308), 1,
      anon_sym_RPAREN,
    ACTIONS(9883), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9885), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9899), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9901), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9903), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9905), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [236109] = 3,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(10204), 1,
      anon_sym_LF,
    ACTIONS(10206), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [236136] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8153), 1,
      sym_identifier,
    ACTIONS(8155), 1,
      anon_sym_LPAREN2,
    ACTIONS(8157), 1,
      anon_sym_STAR,
    ACTIONS(8159), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8161), 1,
      anon_sym_AMP,
    ACTIONS(8165), 1,
      sym_primitive_type,
    STATE(2868), 1,
      sym__type_declarator,
    STATE(3234), 1,
      sym_pointer_type_declarator,
    STATE(8392), 1,
      sym_ms_based_modifier,
    ACTIONS(8163), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3227), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [236183] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10310), 1,
      anon_sym_LBRACK_RBRACK,
    ACTIONS(6343), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(6345), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [236212] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8097), 1,
      sym_identifier,
    ACTIONS(8099), 1,
      anon_sym_LPAREN2,
    ACTIONS(8111), 1,
      sym_primitive_type,
    ACTIONS(8125), 1,
      anon_sym_STAR,
    ACTIONS(8127), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8129), 1,
      anon_sym_AMP,
    STATE(2258), 1,
      sym_pointer_type_declarator,
    STATE(6636), 1,
      sym__type_declarator,
    STATE(8147), 1,
      sym_ms_based_modifier,
    ACTIONS(8109), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2186), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [236259] = 12,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(10288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10290), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10292), 1,
      anon_sym_PIPE,
    ACTIONS(10294), 1,
      anon_sym_CARET,
    ACTIONS(10296), 1,
      anon_sym_AMP,
    ACTIONS(10312), 1,
      anon_sym_LF,
    ACTIONS(10284), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10298), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10302), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10286), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10300), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [236304] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(6180), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8125), 1,
      anon_sym_STAR,
    ACTIONS(9911), 1,
      sym_identifier,
    ACTIONS(9913), 1,
      anon_sym_template,
    STATE(2777), 1,
      sym_pointer_type_declarator,
    STATE(2780), 1,
      sym_template_function,
    STATE(2781), 1,
      sym_destructor_name,
    STATE(2784), 1,
      sym_dependent_identifier,
    STATE(2787), 1,
      sym_qualified_identifier,
    STATE(2790), 1,
      sym_operator_name,
    STATE(5712), 1,
      sym__scope_resolution,
    STATE(8147), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [236361] = 4,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(10035), 1,
      anon_sym_LF,
    ACTIONS(10286), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10037), 15,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [236390] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9762), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9760), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [236417] = 3,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(10035), 1,
      anon_sym_LF,
    ACTIONS(10037), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [236444] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8097), 1,
      sym_identifier,
    ACTIONS(8099), 1,
      anon_sym_LPAREN2,
    ACTIONS(8111), 1,
      sym_primitive_type,
    ACTIONS(8125), 1,
      anon_sym_STAR,
    ACTIONS(8127), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8129), 1,
      anon_sym_AMP,
    STATE(2258), 1,
      sym_pointer_type_declarator,
    STATE(6441), 1,
      sym__type_declarator,
    STATE(8147), 1,
      sym_ms_based_modifier,
    ACTIONS(8109), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2186), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [236491] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8554), 1,
      anon_sym_LT,
    STATE(2654), 1,
      sym_template_argument_list,
    ACTIONS(4838), 2,
      anon_sym___attribute,
      anon_sym_COLON,
    ACTIONS(4845), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [236524] = 12,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(10035), 1,
      anon_sym_LF,
    ACTIONS(10037), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10290), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10292), 1,
      anon_sym_PIPE,
    ACTIONS(10294), 1,
      anon_sym_CARET,
    ACTIONS(10296), 1,
      anon_sym_AMP,
    ACTIONS(10284), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10298), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10302), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10286), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10300), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [236569] = 11,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(10035), 1,
      anon_sym_LF,
    ACTIONS(10292), 1,
      anon_sym_PIPE,
    ACTIONS(10294), 1,
      anon_sym_CARET,
    ACTIONS(10296), 1,
      anon_sym_AMP,
    ACTIONS(10037), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
    ACTIONS(10284), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10298), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10302), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10286), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10300), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [236612] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10316), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10314), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [236639] = 10,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(10035), 1,
      anon_sym_LF,
    ACTIONS(10294), 1,
      anon_sym_CARET,
    ACTIONS(10296), 1,
      anon_sym_AMP,
    ACTIONS(10284), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10298), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10302), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10037), 3,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
    ACTIONS(10286), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10300), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [236680] = 12,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(10288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10290), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10292), 1,
      anon_sym_PIPE,
    ACTIONS(10294), 1,
      anon_sym_CARET,
    ACTIONS(10296), 1,
      anon_sym_AMP,
    ACTIONS(10318), 1,
      anon_sym_LF,
    ACTIONS(10284), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10298), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10302), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10286), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10300), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [236725] = 9,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(10035), 1,
      anon_sym_LF,
    ACTIONS(10296), 1,
      anon_sym_AMP,
    ACTIONS(10284), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10298), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10302), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10286), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10037), 4,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(10300), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [236764] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9887), 1,
      anon_sym_SLASH,
    ACTIONS(9889), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(9891), 1,
      anon_sym_AMP_AMP,
    ACTIONS(9893), 1,
      anon_sym_PIPE,
    ACTIONS(9895), 1,
      anon_sym_CARET,
    ACTIONS(9897), 1,
      anon_sym_AMP,
    ACTIONS(10320), 1,
      anon_sym_RPAREN,
    ACTIONS(9883), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(9885), 2,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(9899), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(9901), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(9903), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(9905), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [236813] = 8,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(10035), 1,
      anon_sym_LF,
    ACTIONS(10284), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10298), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10302), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10286), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10300), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10037), 5,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
  [236850] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10324), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10322), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [236877] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10328), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10326), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [236904] = 12,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(10288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10290), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10292), 1,
      anon_sym_PIPE,
    ACTIONS(10294), 1,
      anon_sym_CARET,
    ACTIONS(10296), 1,
      anon_sym_AMP,
    ACTIONS(10330), 1,
      anon_sym_LF,
    ACTIONS(10284), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10298), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10302), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10286), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10300), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [236949] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 1,
      anon_sym___asm,
    ACTIONS(3466), 1,
      anon_sym_LBRACE,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(9845), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(9853), 1,
      anon_sym_EQ,
    ACTIONS(10332), 1,
      anon_sym_SEMI,
    ACTIONS(10334), 1,
      anon_sym_COLON,
    STATE(2872), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(7050), 1,
      sym_gnu_asm_expression,
    STATE(7051), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(9855), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(6238), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7535), 2,
      sym_argument_list,
      sym_initializer_list,
  [237004] = 3,
    ACTIONS(6903), 1,
      anon_sym_LF,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(6901), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [237031] = 3,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(10091), 1,
      anon_sym_LF,
    ACTIONS(10093), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [237058] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(7092), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8167), 1,
      anon_sym_STAR,
    ACTIONS(10336), 1,
      sym_identifier,
    ACTIONS(10338), 1,
      anon_sym_template,
    STATE(5732), 1,
      sym__scope_resolution,
    STATE(5898), 1,
      sym_destructor_name,
    STATE(5899), 1,
      sym_dependent_identifier,
    STATE(5900), 1,
      sym_qualified_identifier,
    STATE(5912), 1,
      sym_operator_name,
    STATE(5920), 1,
      sym_pointer_type_declarator,
    STATE(6000), 1,
      sym_template_function,
    STATE(8076), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [237115] = 7,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(10035), 1,
      anon_sym_LF,
    ACTIONS(10284), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10302), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10286), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10300), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
    ACTIONS(10037), 7,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [237150] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8175), 1,
      anon_sym_STAR,
    ACTIONS(8177), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8179), 1,
      anon_sym_AMP,
    STATE(3113), 1,
      sym_parameter_list,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6448), 1,
      sym__abstract_declarator,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8197), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [237193] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10342), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10340), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [237220] = 6,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(10035), 1,
      anon_sym_LF,
    ACTIONS(10284), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10302), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10286), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10037), 11,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [237253] = 5,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(10035), 1,
      anon_sym_LF,
    ACTIONS(10284), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10286), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10037), 13,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [237284] = 12,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(10288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10290), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10292), 1,
      anon_sym_PIPE,
    ACTIONS(10294), 1,
      anon_sym_CARET,
    ACTIONS(10296), 1,
      anon_sym_AMP,
    ACTIONS(10344), 1,
      anon_sym_LF,
    ACTIONS(10284), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10298), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10302), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10286), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10300), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [237329] = 12,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(10288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10290), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10292), 1,
      anon_sym_PIPE,
    ACTIONS(10294), 1,
      anon_sym_CARET,
    ACTIONS(10296), 1,
      anon_sym_AMP,
    ACTIONS(10346), 1,
      anon_sym_LF,
    ACTIONS(10284), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10298), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10302), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10286), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10300), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [237374] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(8125), 1,
      anon_sym_STAR,
    ACTIONS(10348), 1,
      sym_identifier,
    ACTIONS(10350), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10352), 1,
      anon_sym_template,
    STATE(2777), 1,
      sym_pointer_type_declarator,
    STATE(2780), 1,
      sym_template_function,
    STATE(2781), 1,
      sym_destructor_name,
    STATE(2784), 1,
      sym_dependent_identifier,
    STATE(2787), 1,
      sym_qualified_identifier,
    STATE(2790), 1,
      sym_operator_name,
    STATE(5740), 1,
      sym__scope_resolution,
    STATE(8147), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [237431] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7205), 1,
      anon_sym_LT,
    STATE(5843), 1,
      sym_template_argument_list,
    ACTIONS(4847), 4,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym___asm,
    ACTIONS(4840), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [237464] = 12,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(10288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10290), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10292), 1,
      anon_sym_PIPE,
    ACTIONS(10294), 1,
      anon_sym_CARET,
    ACTIONS(10296), 1,
      anon_sym_AMP,
    ACTIONS(10354), 1,
      anon_sym_LF,
    ACTIONS(10284), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10298), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10302), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10286), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10300), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [237509] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8097), 1,
      sym_identifier,
    ACTIONS(8099), 1,
      anon_sym_LPAREN2,
    ACTIONS(8111), 1,
      sym_primitive_type,
    ACTIONS(8113), 1,
      anon_sym_STAR,
    ACTIONS(8115), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8117), 1,
      anon_sym_AMP,
    STATE(2258), 1,
      sym_pointer_type_declarator,
    STATE(6612), 1,
      sym__type_declarator,
    STATE(8327), 1,
      sym_ms_based_modifier,
    ACTIONS(8109), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2186), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [237556] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8097), 1,
      sym_identifier,
    ACTIONS(8099), 1,
      anon_sym_LPAREN2,
    ACTIONS(8111), 1,
      sym_primitive_type,
    ACTIONS(8125), 1,
      anon_sym_STAR,
    ACTIONS(8127), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8129), 1,
      anon_sym_AMP,
    STATE(2258), 1,
      sym_pointer_type_declarator,
    STATE(6645), 1,
      sym__type_declarator,
    STATE(8147), 1,
      sym_ms_based_modifier,
    ACTIONS(8109), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2186), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [237603] = 12,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(10288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10290), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10292), 1,
      anon_sym_PIPE,
    ACTIONS(10294), 1,
      anon_sym_CARET,
    ACTIONS(10296), 1,
      anon_sym_AMP,
    ACTIONS(10356), 1,
      anon_sym_LF,
    ACTIONS(10284), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10298), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10302), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10286), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10300), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [237648] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10360), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10358), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [237675] = 12,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(10288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10290), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10292), 1,
      anon_sym_PIPE,
    ACTIONS(10294), 1,
      anon_sym_CARET,
    ACTIONS(10296), 1,
      anon_sym_AMP,
    ACTIONS(10362), 1,
      anon_sym_LF,
    ACTIONS(10284), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10298), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10302), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10286), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10300), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [237720] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9211), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9200), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [237747] = 12,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(10288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10290), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10292), 1,
      anon_sym_PIPE,
    ACTIONS(10294), 1,
      anon_sym_CARET,
    ACTIONS(10296), 1,
      anon_sym_AMP,
    ACTIONS(10364), 1,
      anon_sym_LF,
    ACTIONS(10284), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10298), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10302), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10286), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10300), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [237792] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(7104), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8125), 1,
      anon_sym_STAR,
    ACTIONS(10366), 1,
      sym_identifier,
    ACTIONS(10368), 1,
      anon_sym_template,
    STATE(2777), 1,
      sym_pointer_type_declarator,
    STATE(2780), 1,
      sym_template_function,
    STATE(2781), 1,
      sym_destructor_name,
    STATE(2784), 1,
      sym_dependent_identifier,
    STATE(2787), 1,
      sym_qualified_identifier,
    STATE(2790), 1,
      sym_operator_name,
    STATE(5750), 1,
      sym__scope_resolution,
    STATE(8147), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [237849] = 12,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(10288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10290), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10292), 1,
      anon_sym_PIPE,
    ACTIONS(10294), 1,
      anon_sym_CARET,
    ACTIONS(10296), 1,
      anon_sym_AMP,
    ACTIONS(10370), 1,
      anon_sym_LF,
    ACTIONS(10284), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10298), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10302), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10286), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10300), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [237894] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8097), 1,
      sym_identifier,
    ACTIONS(8099), 1,
      anon_sym_LPAREN2,
    ACTIONS(8111), 1,
      sym_primitive_type,
    ACTIONS(8125), 1,
      anon_sym_STAR,
    ACTIONS(8127), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8129), 1,
      anon_sym_AMP,
    STATE(2258), 1,
      sym_pointer_type_declarator,
    STATE(6654), 1,
      sym__type_declarator,
    STATE(8147), 1,
      sym_ms_based_modifier,
    ACTIONS(8109), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2186), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [237941] = 3,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(10105), 1,
      anon_sym_LF,
    ACTIONS(10107), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [237968] = 3,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(10095), 1,
      anon_sym_LF,
    ACTIONS(10097), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [237995] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9062), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9051), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [238022] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10374), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10372), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [238049] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10378), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10376), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [238076] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10382), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10380), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [238103] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10386), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10384), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [238130] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7205), 1,
      anon_sym_LT,
    STATE(5843), 1,
      sym_template_argument_list,
    ACTIONS(7982), 4,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym___asm,
    ACTIONS(4895), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [238163] = 3,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(10236), 1,
      anon_sym_LF,
    ACTIONS(10238), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [238190] = 12,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(10288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10290), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10292), 1,
      anon_sym_PIPE,
    ACTIONS(10294), 1,
      anon_sym_CARET,
    ACTIONS(10296), 1,
      anon_sym_AMP,
    ACTIONS(10388), 1,
      anon_sym_LF,
    ACTIONS(10284), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10298), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10302), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10286), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10300), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [238235] = 3,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(10141), 1,
      anon_sym_LF,
    ACTIONS(10143), 18,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
  [238262] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(7112), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8113), 1,
      anon_sym_STAR,
    ACTIONS(9911), 1,
      sym_identifier,
    ACTIONS(9913), 1,
      anon_sym_template,
    STATE(2777), 1,
      sym_pointer_type_declarator,
    STATE(2780), 1,
      sym_template_function,
    STATE(2781), 1,
      sym_destructor_name,
    STATE(2784), 1,
      sym_dependent_identifier,
    STATE(2787), 1,
      sym_qualified_identifier,
    STATE(2790), 1,
      sym_operator_name,
    STATE(5764), 1,
      sym__scope_resolution,
    STATE(8327), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [238319] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3194), 1,
      anon_sym_TILDE,
    ACTIONS(5708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8135), 1,
      anon_sym_STAR,
    ACTIONS(10336), 1,
      sym_identifier,
    ACTIONS(10338), 1,
      anon_sym_template,
    STATE(5765), 1,
      sym__scope_resolution,
    STATE(5898), 1,
      sym_destructor_name,
    STATE(5899), 1,
      sym_dependent_identifier,
    STATE(5900), 1,
      sym_qualified_identifier,
    STATE(5912), 1,
      sym_operator_name,
    STATE(5920), 1,
      sym_pointer_type_declarator,
    STATE(6000), 1,
      sym_template_function,
    STATE(7940), 1,
      sym_ms_based_modifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [238376] = 12,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(10288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10290), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10292), 1,
      anon_sym_PIPE,
    ACTIONS(10294), 1,
      anon_sym_CARET,
    ACTIONS(10296), 1,
      anon_sym_AMP,
    ACTIONS(10390), 1,
      anon_sym_LF,
    ACTIONS(10284), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10298), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10302), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10286), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10300), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [238421] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8554), 1,
      anon_sym_LT,
    STATE(2654), 1,
      sym_template_argument_list,
    ACTIONS(5720), 2,
      anon_sym___attribute,
      anon_sym_COLON,
    ACTIONS(4059), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [238454] = 12,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(10288), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(10290), 1,
      anon_sym_AMP_AMP,
    ACTIONS(10292), 1,
      anon_sym_PIPE,
    ACTIONS(10294), 1,
      anon_sym_CARET,
    ACTIONS(10296), 1,
      anon_sym_AMP,
    ACTIONS(10392), 1,
      anon_sym_LF,
    ACTIONS(10284), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(10298), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(10302), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(10286), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(10300), 4,
      anon_sym_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
  [238499] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(8145), 1,
      anon_sym_STAR,
    ACTIONS(8147), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8149), 1,
      anon_sym_AMP,
    STATE(3191), 1,
      sym_parameter_list,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(6463), 1,
      sym__abstract_declarator,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
    ACTIONS(8197), 6,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [238542] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8131), 1,
      sym_identifier,
    ACTIONS(8133), 1,
      anon_sym_LPAREN2,
    ACTIONS(8135), 1,
      anon_sym_STAR,
    ACTIONS(8137), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8139), 1,
      anon_sym_AMP,
    ACTIONS(8143), 1,
      sym_primitive_type,
    STATE(5840), 1,
      sym__type_declarator,
    STATE(5952), 1,
      sym_pointer_type_declarator,
    STATE(7940), 1,
      sym_ms_based_modifier,
    ACTIONS(8141), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5950), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [238589] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8097), 1,
      sym_identifier,
    ACTIONS(8099), 1,
      anon_sym_LPAREN2,
    ACTIONS(8111), 1,
      sym_primitive_type,
    ACTIONS(8125), 1,
      anon_sym_STAR,
    ACTIONS(8127), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8129), 1,
      anon_sym_AMP,
    STATE(2258), 1,
      sym_pointer_type_declarator,
    STATE(6126), 1,
      sym__type_declarator,
    STATE(8147), 1,
      sym_ms_based_modifier,
    ACTIONS(8109), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(2186), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [238636] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10396), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10394), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [238663] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10400), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10398), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [238690] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10404), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10402), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [238717] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10408), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10406), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [238744] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10412), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10410), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [238771] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9525), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(9514), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [238798] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10416), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10414), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [238825] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8131), 1,
      sym_identifier,
    ACTIONS(8133), 1,
      anon_sym_LPAREN2,
    ACTIONS(8143), 1,
      sym_primitive_type,
    ACTIONS(8167), 1,
      anon_sym_STAR,
    ACTIONS(8169), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8171), 1,
      anon_sym_AMP,
    STATE(5952), 1,
      sym_pointer_type_declarator,
    STATE(6192), 1,
      sym__type_declarator,
    STATE(8076), 1,
      sym_ms_based_modifier,
    ACTIONS(8141), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(5950), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [238872] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(8181), 1,
      sym_identifier,
    ACTIONS(8183), 1,
      anon_sym_LPAREN2,
    ACTIONS(8185), 1,
      anon_sym_STAR,
    ACTIONS(8187), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8189), 1,
      anon_sym_AMP,
    ACTIONS(8193), 1,
      sym_primitive_type,
    STATE(3018), 1,
      sym__type_declarator,
    STATE(3404), 1,
      sym_pointer_type_declarator,
    STATE(8244), 1,
      sym_ms_based_modifier,
    ACTIONS(8191), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
    STATE(3392), 5,
      sym_parenthesized_type_declarator,
      sym_attributed_type_declarator,
      sym_function_type_declarator,
      sym_array_type_declarator,
      sym_reference_type_declarator,
  [238919] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10418), 1,
      anon_sym_LBRACK,
    STATE(5998), 1,
      sym_parameter_list,
    ACTIONS(5921), 2,
      anon_sym___attribute,
      anon_sym___asm,
    STATE(5891), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5923), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [238955] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6057), 1,
      anon_sym___attribute,
    ACTIONS(10420), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6059), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [238983] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10422), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5783), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6067), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(6069), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [239013] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10418), 1,
      anon_sym_LBRACK,
    STATE(5998), 1,
      sym_parameter_list,
    ACTIONS(5943), 2,
      anon_sym___attribute,
      anon_sym___asm,
    STATE(5891), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5945), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [239049] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5114), 1,
      anon_sym___attribute,
    ACTIONS(5116), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [239075] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10418), 1,
      anon_sym_LBRACK,
    STATE(5998), 1,
      sym_parameter_list,
    ACTIONS(5909), 2,
      anon_sym___attribute,
      anon_sym___asm,
    STATE(5891), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5911), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [239111] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5170), 1,
      anon_sym___attribute,
    ACTIONS(5172), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [239137] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7162), 1,
      anon_sym_requires,
    ACTIONS(7172), 1,
      anon_sym_DASH_GT,
    STATE(5366), 1,
      sym_trailing_return_type,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9062), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [239175] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7162), 1,
      anon_sym_requires,
    ACTIONS(7172), 1,
      anon_sym_DASH_GT,
    STATE(5367), 1,
      sym_trailing_return_type,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9211), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [239213] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7162), 1,
      anon_sym_requires,
    ACTIONS(7172), 1,
      anon_sym_DASH_GT,
    STATE(5368), 1,
      sym_trailing_return_type,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9525), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5701), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [239251] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7162), 1,
      anon_sym_requires,
    ACTIONS(7172), 1,
      anon_sym_DASH_GT,
    STATE(5369), 1,
      sym_trailing_return_type,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    ACTIONS(9674), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5714), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9672), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [239289] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7172), 1,
      anon_sym_DASH_GT,
    ACTIONS(9137), 1,
      anon_sym_requires,
    STATE(5380), 1,
      sym_trailing_return_type,
    ACTIONS(9062), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(9082), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [239327] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7172), 1,
      anon_sym_DASH_GT,
    ACTIONS(9233), 1,
      anon_sym_requires,
    STATE(5382), 1,
      sym_trailing_return_type,
    ACTIONS(9211), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(9213), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [239365] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7172), 1,
      anon_sym_DASH_GT,
    ACTIONS(9553), 1,
      anon_sym_requires,
    STATE(5337), 1,
      sym_trailing_return_type,
    ACTIONS(9525), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(9527), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5701), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [239403] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7172), 1,
      anon_sym_DASH_GT,
    ACTIONS(9679), 1,
      anon_sym_requires,
    STATE(5392), 1,
      sym_trailing_return_type,
    ACTIONS(9674), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(9676), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5714), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9672), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [239441] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5122), 1,
      anon_sym___attribute,
    ACTIONS(5124), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [239467] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(111), 1,
      anon_sym___asm,
    ACTIONS(3466), 1,
      anon_sym_LBRACE,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(9845), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(9853), 1,
      anon_sym_EQ,
    ACTIONS(9981), 1,
      anon_sym_SEMI,
    STATE(2922), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(7048), 1,
      sym_gnu_asm_expression,
    STATE(7389), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(9855), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7535), 2,
      sym_argument_list,
      sym_initializer_list,
  [239519] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5122), 1,
      anon_sym___attribute,
    ACTIONS(5124), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [239545] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5122), 1,
      anon_sym___attribute,
    ACTIONS(5124), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [239571] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5174), 1,
      anon_sym___attribute,
    ACTIONS(5176), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [239597] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5142), 1,
      anon_sym___attribute,
    ACTIONS(5144), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [239623] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(111), 1,
      anon_sym___asm,
    ACTIONS(3466), 1,
      anon_sym_LBRACE,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(9845), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(9853), 1,
      anon_sym_EQ,
    ACTIONS(9947), 1,
      anon_sym_SEMI,
    STATE(2922), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(7319), 1,
      sym_gnu_asm_expression,
    STATE(7320), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(9855), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7535), 2,
      sym_argument_list,
      sym_initializer_list,
  [239675] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9525), 1,
      anon_sym___attribute,
    ACTIONS(9565), 1,
      anon_sym_requires,
    ACTIONS(9562), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5991), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [239709] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5138), 1,
      anon_sym___attribute,
    ACTIONS(5140), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [239735] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9861), 1,
      anon_sym___attribute,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5828), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    ACTIONS(9859), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [239765] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9674), 1,
      anon_sym___attribute,
    ACTIONS(10428), 1,
      anon_sym_requires,
    ACTIONS(10425), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5897), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9672), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [239799] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7284), 1,
      anon_sym_requires,
    ACTIONS(9211), 1,
      anon_sym___attribute,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5935), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [239833] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9762), 1,
      anon_sym___attribute,
    ACTIONS(10434), 1,
      anon_sym_requires,
    ACTIONS(10431), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5915), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9760), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [239867] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1913), 1,
      anon_sym___attribute,
    ACTIONS(1911), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [239893] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6092), 1,
      anon_sym___attribute,
    ACTIONS(10420), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10437), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(6094), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [239923] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1909), 1,
      anon_sym___attribute,
    ACTIONS(1907), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [239949] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7284), 1,
      anon_sym_requires,
    ACTIONS(9525), 1,
      anon_sym___attribute,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5991), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [239983] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3766), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9471), 1,
      sym_identifier,
    ACTIONS(10439), 1,
      anon_sym_virtual,
    STATE(2158), 1,
      sym_template_type,
    STATE(6384), 1,
      sym_access_specifier,
    STATE(6476), 1,
      sym__scope_resolution,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6828), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(10441), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
  [240031] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6343), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(6345), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [240057] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5118), 1,
      anon_sym___attribute,
    ACTIONS(5120), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [240083] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7205), 1,
      anon_sym_LT,
    STATE(5843), 1,
      sym_template_argument_list,
    ACTIONS(6320), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(6322), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [240113] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7284), 1,
      anon_sym_requires,
    ACTIONS(9762), 1,
      anon_sym___attribute,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5915), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9760), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [240147] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5166), 1,
      anon_sym___attribute,
    ACTIONS(5168), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [240173] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3818), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(3820), 15,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [240199] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6395), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(6397), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LT,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [240225] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3766), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9471), 1,
      sym_identifier,
    ACTIONS(10443), 1,
      anon_sym_virtual,
    STATE(2158), 1,
      sym_template_type,
    STATE(6355), 1,
      sym_access_specifier,
    STATE(6476), 1,
      sym__scope_resolution,
    STATE(5088), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7190), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(10441), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
  [240273] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7284), 1,
      anon_sym_requires,
    ACTIONS(9674), 1,
      anon_sym___attribute,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5897), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9672), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [240307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3822), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(3824), 15,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_DASH_GT,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [240333] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7702), 1,
      anon_sym_LPAREN2,
    ACTIONS(7716), 1,
      anon_sym_LBRACK,
    ACTIONS(8204), 1,
      anon_sym_STAR,
    ACTIONS(8206), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8208), 1,
      anon_sym_AMP,
    STATE(3434), 1,
      sym_parameter_list,
    STATE(5735), 1,
      sym__function_declarator_seq,
    STATE(6478), 1,
      sym__abstract_declarator,
    ACTIONS(8197), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(5727), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [240375] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5146), 1,
      anon_sym___attribute,
    ACTIONS(5148), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [240401] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(111), 1,
      anon_sym___asm,
    ACTIONS(3466), 1,
      anon_sym_LBRACE,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(9845), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(9853), 1,
      anon_sym_EQ,
    ACTIONS(10332), 1,
      anon_sym_SEMI,
    STATE(2922), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(7050), 1,
      sym_gnu_asm_expression,
    STATE(7051), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(9855), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7535), 2,
      sym_argument_list,
      sym_initializer_list,
  [240453] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(111), 1,
      anon_sym___asm,
    ACTIONS(3466), 1,
      anon_sym_LBRACE,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(9845), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(10332), 1,
      anon_sym_SEMI,
    ACTIONS(10445), 1,
      anon_sym_EQ,
    STATE(2922), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(7050), 1,
      sym_gnu_asm_expression,
    STATE(7051), 1,
      aux_sym_declaration_repeat1,
    STATE(7297), 1,
      sym_initializer_list,
    STATE(7535), 1,
      sym_argument_list,
    ACTIONS(9855), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [240507] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9959), 1,
      anon_sym___attribute,
    ACTIONS(10447), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5828), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    ACTIONS(9957), 13,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [240537] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(111), 1,
      anon_sym___asm,
    ACTIONS(3466), 1,
      anon_sym_LBRACE,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(9845), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(9853), 1,
      anon_sym_EQ,
    ACTIONS(9937), 1,
      anon_sym_SEMI,
    STATE(2922), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(7184), 1,
      sym_gnu_asm_expression,
    STATE(7185), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(9855), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7535), 2,
      sym_argument_list,
      sym_initializer_list,
  [240589] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10418), 1,
      anon_sym_LBRACK,
    STATE(5998), 1,
      sym_parameter_list,
    ACTIONS(5891), 2,
      anon_sym___attribute,
      anon_sym___asm,
    STATE(5891), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5893), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [240625] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5134), 1,
      anon_sym___attribute,
    ACTIONS(5136), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [240651] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7284), 1,
      anon_sym_requires,
    ACTIONS(9062), 1,
      anon_sym___attribute,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [240685] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3766), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9471), 1,
      sym_identifier,
    ACTIONS(10450), 1,
      anon_sym_virtual,
    STATE(2158), 1,
      sym_template_type,
    STATE(6359), 1,
      sym_access_specifier,
    STATE(6476), 1,
      sym__scope_resolution,
    STATE(5821), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7291), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(10441), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
  [240733] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5126), 1,
      anon_sym___attribute,
    ACTIONS(5128), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [240759] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(111), 1,
      anon_sym___asm,
    ACTIONS(3466), 1,
      anon_sym_LBRACE,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(9845), 1,
      anon_sym_LPAREN2,
    ACTIONS(9847), 1,
      anon_sym_SEMI,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(9853), 1,
      anon_sym_EQ,
    STATE(2922), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(7146), 1,
      sym_gnu_asm_expression,
    STATE(7149), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(9855), 2,
      anon_sym_asm,
      anon_sym___asm__,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7535), 2,
      sym_argument_list,
      sym_initializer_list,
  [240811] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3766), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9471), 1,
      sym_identifier,
    ACTIONS(10452), 1,
      anon_sym_virtual,
    STATE(2158), 1,
      sym_template_type,
    STATE(6334), 1,
      sym_access_specifier,
    STATE(6476), 1,
      sym__scope_resolution,
    STATE(5813), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6962), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(10441), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
  [240859] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5150), 1,
      anon_sym___attribute,
    ACTIONS(5152), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [240885] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9211), 1,
      anon_sym___attribute,
    ACTIONS(9354), 1,
      anon_sym_requires,
    ACTIONS(9274), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5935), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [240919] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5130), 1,
      anon_sym___attribute,
    ACTIONS(5132), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_AMP_AMP,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_and,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [240945] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10418), 1,
      anon_sym_LBRACK,
    STATE(5998), 1,
      sym_parameter_list,
    ACTIONS(6017), 2,
      anon_sym___attribute,
      anon_sym___asm,
    STATE(5891), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6019), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [240981] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9062), 1,
      anon_sym___attribute,
    ACTIONS(9159), 1,
      anon_sym_requires,
    ACTIONS(9147), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
      anon_sym_try,
  [241015] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7280), 1,
      anon_sym_DASH_GT,
    ACTIONS(7284), 1,
      anon_sym_requires,
    ACTIONS(9525), 1,
      anon_sym___attribute,
    STATE(5822), 1,
      sym_trailing_return_type,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5991), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [241052] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4862), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4864), 4,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym___asm,
    ACTIONS(4857), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [241079] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5815), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(5813), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [241104] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5783), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10456), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10454), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [241133] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(4873), 1,
      anon_sym_STAR,
    ACTIONS(4875), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4877), 1,
      anon_sym_AMP,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(10458), 1,
      anon_sym_LT,
    STATE(1592), 1,
      sym_compound_statement,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(5848), 1,
      sym_template_parameter_list,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6831), 1,
      sym_abstract_function_declarator,
    STATE(6920), 1,
      sym__abstract_declarator,
    STATE(5942), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [241182] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(8264), 1,
      anon_sym_LPAREN2,
    ACTIONS(8272), 1,
      sym_identifier,
    ACTIONS(8274), 1,
      anon_sym_STAR,
    ACTIONS(8276), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8278), 1,
      anon_sym_AMP,
    STATE(6549), 1,
      sym__field_declarator,
    STATE(6701), 1,
      sym_operator_name,
    STATE(7946), 1,
      sym_ms_based_modifier,
    STATE(6285), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [241225] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(4873), 1,
      anon_sym_STAR,
    ACTIONS(4875), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4877), 1,
      anon_sym_AMP,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(10460), 1,
      anon_sym_requires,
    STATE(1599), 1,
      sym_compound_statement,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6044), 1,
      sym_requires_clause,
    STATE(6835), 1,
      sym_abstract_function_declarator,
    STATE(6920), 1,
      sym__abstract_declarator,
    STATE(5942), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [241274] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6944), 1,
      anon_sym_requires,
    ACTIONS(6984), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    STATE(5497), 1,
      sym_trailing_return_type,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 7,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [241311] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(4368), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9985), 1,
      sym_identifier,
    ACTIONS(9987), 1,
      anon_sym_STAR,
    ACTIONS(9991), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10462), 1,
      anon_sym_AMP,
    ACTIONS(10464), 1,
      sym_this,
    STATE(5700), 1,
      sym__scope_resolution,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7160), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [241354] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6944), 1,
      anon_sym_requires,
    ACTIONS(6984), 1,
      anon_sym_DASH_GT,
    ACTIONS(9674), 1,
      anon_sym_LBRACK,
    STATE(5486), 1,
      sym_trailing_return_type,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5714), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9672), 7,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [241391] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10468), 2,
      anon_sym___attribute__,
      anon_sym___attribute,
    ACTIONS(10473), 2,
      anon_sym_alignas,
      anon_sym__Alignas,
    ACTIONS(10471), 3,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
    STATE(5852), 3,
      sym_attribute_specifier,
      sym_alignas_qualifier,
      aux_sym__class_declaration_repeat1,
    ACTIONS(10466), 7,
      anon_sym___declspec,
      anon_sym_COLON,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_final,
      anon_sym_override,
      anon_sym_template,
  [241422] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6944), 1,
      anon_sym_requires,
    ACTIONS(6984), 1,
      anon_sym_DASH_GT,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    STATE(5535), 1,
      sym_trailing_return_type,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 7,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [241459] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(4873), 1,
      anon_sym_STAR,
    ACTIONS(4875), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4877), 1,
      anon_sym_AMP,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(10458), 1,
      anon_sym_LT,
    ACTIONS(10476), 1,
      anon_sym_LBRACE,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(4190), 1,
      sym_compound_statement,
    STATE(5860), 1,
      sym_template_parameter_list,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6893), 1,
      sym_abstract_function_declarator,
    STATE(6920), 1,
      sym__abstract_declarator,
    STATE(5942), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [241508] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(4873), 1,
      anon_sym_STAR,
    ACTIONS(4875), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4877), 1,
      anon_sym_AMP,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(10458), 1,
      anon_sym_LT,
    ACTIONS(10478), 1,
      anon_sym_LBRACE,
    STATE(1592), 1,
      sym_compound_statement,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(5882), 1,
      sym_template_parameter_list,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6920), 1,
      sym__abstract_declarator,
    STATE(7019), 1,
      sym_abstract_function_declarator,
    STATE(5942), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [241557] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(4873), 1,
      anon_sym_STAR,
    ACTIONS(4875), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4877), 1,
      anon_sym_AMP,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(10458), 1,
      anon_sym_LT,
    ACTIONS(10480), 1,
      anon_sym_LBRACE,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(5815), 1,
      sym_compound_statement,
    STATE(5859), 1,
      sym_template_parameter_list,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6844), 1,
      sym_abstract_function_declarator,
    STATE(6920), 1,
      sym__abstract_declarator,
    STATE(5942), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [241606] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(4873), 1,
      anon_sym_STAR,
    ACTIONS(4875), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4877), 1,
      anon_sym_AMP,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(10458), 1,
      anon_sym_LT,
    ACTIONS(10482), 1,
      anon_sym_LBRACE,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(5495), 1,
      sym_compound_statement,
    STATE(5877), 1,
      sym_template_parameter_list,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6802), 1,
      sym_abstract_function_declarator,
    STATE(6920), 1,
      sym__abstract_declarator,
    STATE(5942), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [241655] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10484), 1,
      sym_identifier,
    ACTIONS(10486), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(6082), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(6824), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(117), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [241688] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(4873), 1,
      anon_sym_STAR,
    ACTIONS(4875), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4877), 1,
      anon_sym_AMP,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(10460), 1,
      anon_sym_requires,
    ACTIONS(10480), 1,
      anon_sym_LBRACE,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(5804), 1,
      sym_compound_statement,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6052), 1,
      sym_requires_clause,
    STATE(6847), 1,
      sym_abstract_function_declarator,
    STATE(6920), 1,
      sym__abstract_declarator,
    STATE(5942), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [241737] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(4873), 1,
      anon_sym_STAR,
    ACTIONS(4875), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4877), 1,
      anon_sym_AMP,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(10460), 1,
      anon_sym_requires,
    ACTIONS(10476), 1,
      anon_sym_LBRACE,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(4165), 1,
      sym_compound_statement,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6013), 1,
      sym_requires_clause,
    STATE(6906), 1,
      sym_abstract_function_declarator,
    STATE(6920), 1,
      sym__abstract_declarator,
    STATE(5942), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [241786] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(8264), 1,
      anon_sym_LPAREN2,
    ACTIONS(8272), 1,
      sym_identifier,
    ACTIONS(8274), 1,
      anon_sym_STAR,
    ACTIONS(8276), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8278), 1,
      anon_sym_AMP,
    STATE(6564), 1,
      sym__field_declarator,
    STATE(6701), 1,
      sym_operator_name,
    STATE(7946), 1,
      sym_ms_based_modifier,
    STATE(6285), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [241829] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(4873), 1,
      anon_sym_STAR,
    ACTIONS(4875), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4877), 1,
      anon_sym_AMP,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(10460), 1,
      anon_sym_requires,
    ACTIONS(10488), 1,
      anon_sym_LBRACE,
    STATE(2444), 1,
      sym_compound_statement,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6063), 1,
      sym_requires_clause,
    STATE(6920), 1,
      sym__abstract_declarator,
    STATE(6994), 1,
      sym_abstract_function_declarator,
    STATE(5942), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [241878] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7280), 1,
      anon_sym_DASH_GT,
    ACTIONS(7284), 1,
      anon_sym_requires,
    ACTIONS(9062), 1,
      anon_sym___attribute,
    STATE(5807), 1,
      sym_trailing_return_type,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [241915] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7280), 1,
      anon_sym_DASH_GT,
    ACTIONS(7284), 1,
      anon_sym_requires,
    ACTIONS(9211), 1,
      anon_sym___attribute,
    STATE(5812), 1,
      sym_trailing_return_type,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5935), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [241952] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10490), 1,
      sym_identifier,
    ACTIONS(5251), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(5884), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(10492), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(10494), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [241983] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(4873), 1,
      anon_sym_STAR,
    ACTIONS(4875), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4877), 1,
      anon_sym_AMP,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(10460), 1,
      anon_sym_requires,
    ACTIONS(10496), 1,
      anon_sym_LBRACE,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(3301), 1,
      sym_compound_statement,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6043), 1,
      sym_requires_clause,
    STATE(6808), 1,
      sym_abstract_function_declarator,
    STATE(6920), 1,
      sym__abstract_declarator,
    STATE(5942), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [242032] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7280), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym___attribute,
    ACTIONS(9159), 1,
      anon_sym_requires,
    STATE(5838), 1,
      sym_trailing_return_type,
    ACTIONS(9147), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [242069] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7280), 1,
      anon_sym_DASH_GT,
    ACTIONS(9211), 1,
      anon_sym___attribute,
    ACTIONS(9354), 1,
      anon_sym_requires,
    STATE(5803), 1,
      sym_trailing_return_type,
    ACTIONS(9274), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5935), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [242106] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7280), 1,
      anon_sym_DASH_GT,
    ACTIONS(9525), 1,
      anon_sym___attribute,
    ACTIONS(9565), 1,
      anon_sym_requires,
    STATE(5806), 1,
      sym_trailing_return_type,
    ACTIONS(9562), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5991), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [242143] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7280), 1,
      anon_sym_DASH_GT,
    ACTIONS(9674), 1,
      anon_sym___attribute,
    ACTIONS(10428), 1,
      anon_sym_requires,
    STATE(5808), 1,
      sym_trailing_return_type,
    ACTIONS(10425), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5897), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9672), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [242180] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(111), 1,
      anon_sym___asm,
    ACTIONS(3466), 1,
      anon_sym_LBRACE,
    ACTIONS(9845), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(9853), 1,
      anon_sym_EQ,
    STATE(2922), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(7722), 1,
      sym_gnu_asm_expression,
    ACTIONS(9855), 2,
      anon_sym_asm,
      anon_sym___asm__,
    ACTIONS(10498), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(7535), 2,
      sym_argument_list,
      sym_initializer_list,
  [242227] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(4873), 1,
      anon_sym_STAR,
    ACTIONS(4875), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4877), 1,
      anon_sym_AMP,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(10458), 1,
      anon_sym_LT,
    ACTIONS(10500), 1,
      anon_sym_LBRACE,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(3843), 1,
      sym_compound_statement,
    STATE(5885), 1,
      sym_template_parameter_list,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6920), 1,
      sym__abstract_declarator,
    STATE(6936), 1,
      sym_abstract_function_declarator,
    STATE(5942), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [242276] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(4873), 1,
      anon_sym_STAR,
    ACTIONS(4875), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4877), 1,
      anon_sym_AMP,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(10458), 1,
      anon_sym_LT,
    ACTIONS(10502), 1,
      anon_sym_LBRACE,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(3390), 1,
      sym_compound_statement,
    STATE(5880), 1,
      sym_template_parameter_list,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6894), 1,
      sym_abstract_function_declarator,
    STATE(6920), 1,
      sym__abstract_declarator,
    STATE(5942), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [242325] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(4873), 1,
      anon_sym_STAR,
    ACTIONS(4875), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4877), 1,
      anon_sym_AMP,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(10458), 1,
      anon_sym_LT,
    ACTIONS(10504), 1,
      anon_sym_LBRACE,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(3566), 1,
      sym_compound_statement,
    STATE(5879), 1,
      sym_template_parameter_list,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6920), 1,
      sym__abstract_declarator,
    STATE(6977), 1,
      sym_abstract_function_declarator,
    STATE(5942), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [242374] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(8262), 1,
      sym_identifier,
    ACTIONS(8264), 1,
      anon_sym_LPAREN2,
    ACTIONS(8266), 1,
      anon_sym_STAR,
    ACTIONS(8268), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8270), 1,
      anon_sym_AMP,
    STATE(6028), 1,
      sym__field_declarator,
    STATE(6266), 1,
      sym_operator_name,
    STATE(7897), 1,
      sym_ms_based_modifier,
    STATE(6285), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [242417] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(4873), 1,
      anon_sym_STAR,
    ACTIONS(4875), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4877), 1,
      anon_sym_AMP,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(10458), 1,
      anon_sym_LT,
    ACTIONS(10488), 1,
      anon_sym_LBRACE,
    STATE(2391), 1,
      sym_compound_statement,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(5862), 1,
      sym_template_parameter_list,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6920), 1,
      sym__abstract_declarator,
    STATE(6958), 1,
      sym_abstract_function_declarator,
    STATE(5942), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [242466] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(4873), 1,
      anon_sym_STAR,
    ACTIONS(4875), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4877), 1,
      anon_sym_AMP,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(10460), 1,
      anon_sym_requires,
    ACTIONS(10482), 1,
      anon_sym_LBRACE,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(5404), 1,
      sym_compound_statement,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6033), 1,
      sym_requires_clause,
    STATE(6818), 1,
      sym_abstract_function_declarator,
    STATE(6920), 1,
      sym__abstract_declarator,
    STATE(5942), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [242515] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8326), 1,
      anon_sym_STAR,
    ACTIONS(8328), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8330), 1,
      anon_sym_AMP,
    STATE(3373), 1,
      sym_parameter_list,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6533), 1,
      sym__abstract_declarator,
    ACTIONS(8197), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [242556] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(4873), 1,
      anon_sym_STAR,
    ACTIONS(4875), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4877), 1,
      anon_sym_AMP,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(10460), 1,
      anon_sym_requires,
    ACTIONS(10504), 1,
      anon_sym_LBRACE,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(3558), 1,
      sym_compound_statement,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6074), 1,
      sym_requires_clause,
    STATE(6920), 1,
      sym__abstract_declarator,
    STATE(6988), 1,
      sym_abstract_function_declarator,
    STATE(5942), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [242605] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(4873), 1,
      anon_sym_STAR,
    ACTIONS(4875), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4877), 1,
      anon_sym_AMP,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(10460), 1,
      anon_sym_requires,
    ACTIONS(10502), 1,
      anon_sym_LBRACE,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(3360), 1,
      sym_compound_statement,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6081), 1,
      sym_requires_clause,
    STATE(6920), 1,
      sym__abstract_declarator,
    STATE(6960), 1,
      sym_abstract_function_declarator,
    STATE(5942), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [242654] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6984), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9085), 1,
      anon_sym_requires,
    STATE(5411), 1,
      sym_trailing_return_type,
    ACTIONS(9082), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 7,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [242691] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(4873), 1,
      anon_sym_STAR,
    ACTIONS(4875), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4877), 1,
      anon_sym_AMP,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(10460), 1,
      anon_sym_requires,
    ACTIONS(10478), 1,
      anon_sym_LBRACE,
    STATE(1599), 1,
      sym_compound_statement,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6096), 1,
      sym_requires_clause,
    STATE(6804), 1,
      sym_abstract_function_declarator,
    STATE(6920), 1,
      sym__abstract_declarator,
    STATE(5942), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [242740] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(4368), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9985), 1,
      sym_identifier,
    ACTIONS(9987), 1,
      anon_sym_STAR,
    ACTIONS(9991), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10462), 1,
      anon_sym_AMP,
    ACTIONS(10506), 1,
      sym_this,
    STATE(5700), 1,
      sym__scope_resolution,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(7519), 5,
      sym__lambda_capture_identifier,
      sym_lambda_capture_initializer,
      sym__lambda_capture,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
  [242783] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10508), 1,
      sym_identifier,
    ACTIONS(5258), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(5884), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(10511), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(10514), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [242814] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(4873), 1,
      anon_sym_STAR,
    ACTIONS(4875), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4877), 1,
      anon_sym_AMP,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(10460), 1,
      anon_sym_requires,
    ACTIONS(10500), 1,
      anon_sym_LBRACE,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(3818), 1,
      sym_compound_statement,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6093), 1,
      sym_requires_clause,
    STATE(6920), 1,
      sym__abstract_declarator,
    STATE(6948), 1,
      sym_abstract_function_declarator,
    STATE(5942), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [242863] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym___based,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(8262), 1,
      sym_identifier,
    ACTIONS(8264), 1,
      anon_sym_LPAREN2,
    ACTIONS(8266), 1,
      anon_sym_STAR,
    ACTIONS(8268), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8270), 1,
      anon_sym_AMP,
    STATE(5953), 1,
      sym__field_declarator,
    STATE(6266), 1,
      sym_operator_name,
    STATE(7897), 1,
      sym_ms_based_modifier,
    STATE(6285), 7,
      sym_parenthesized_field_declarator,
      sym_attributed_field_declarator,
      sym_pointer_field_declarator,
      sym_function_field_declarator,
      sym_array_field_declarator,
      sym_reference_field_declarator,
      sym_template_method,
  [242906] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8284), 1,
      anon_sym_STAR,
    ACTIONS(8286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8288), 1,
      anon_sym_AMP,
    STATE(3053), 1,
      sym_parameter_list,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6534), 1,
      sym__abstract_declarator,
    ACTIONS(8197), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [242947] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6944), 1,
      anon_sym_requires,
    ACTIONS(6984), 1,
      anon_sym_DASH_GT,
    ACTIONS(9525), 1,
      anon_sym_LBRACK,
    STATE(5482), 1,
      sym_trailing_return_type,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5701), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 7,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [242984] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6984), 1,
      anon_sym_DASH_GT,
    ACTIONS(9674), 1,
      anon_sym_LBRACK,
    ACTIONS(9824), 1,
      anon_sym_requires,
    STATE(5527), 1,
      sym_trailing_return_type,
    ACTIONS(9676), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5714), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9672), 7,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [243021] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(4873), 1,
      anon_sym_STAR,
    ACTIONS(4875), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4877), 1,
      anon_sym_AMP,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(10458), 1,
      anon_sym_LT,
    ACTIONS(10496), 1,
      anon_sym_LBRACE,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(3288), 1,
      sym_compound_statement,
    STATE(5866), 1,
      sym_template_parameter_list,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6920), 1,
      sym__abstract_declarator,
    STATE(6955), 1,
      sym_abstract_function_declarator,
    STATE(5942), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [243070] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5783), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6149), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(6151), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [243099] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6984), 1,
      anon_sym_DASH_GT,
    ACTIONS(9525), 1,
      anon_sym_LBRACK,
    ACTIONS(9530), 1,
      anon_sym_requires,
    STATE(5401), 1,
      sym_trailing_return_type,
    ACTIONS(9527), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5701), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 7,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [243136] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10517), 1,
      sym_identifier,
    ACTIONS(5274), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    STATE(5865), 3,
      sym_string_literal,
      sym_raw_string_literal,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(10492), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(10494), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [243167] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6984), 1,
      anon_sym_DASH_GT,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(9216), 1,
      anon_sym_requires,
    STATE(5489), 1,
      sym_trailing_return_type,
    ACTIONS(9213), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 7,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [243204] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7280), 1,
      anon_sym_DASH_GT,
    ACTIONS(7284), 1,
      anon_sym_requires,
    ACTIONS(9674), 1,
      anon_sym___attribute,
    STATE(5817), 1,
      sym_trailing_return_type,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5897), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9672), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_GT2,
  [243241] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7982), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(4895), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [243265] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9762), 1,
      anon_sym___attribute,
    ACTIONS(9760), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [243289] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(4840), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [243313] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(4840), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [243337] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(4840), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [243361] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    ACTIONS(10523), 1,
      anon_sym___asm,
    STATE(2886), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10519), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [243393] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7326), 1,
      anon_sym_requires,
    ACTIONS(9762), 1,
      anon_sym___attribute,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5915), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9760), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [243425] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    ACTIONS(10527), 1,
      anon_sym___asm,
    STATE(2886), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10525), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [243457] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10529), 1,
      sym_identifier,
    ACTIONS(10531), 1,
      sym_primitive_type,
    STATE(2269), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(2427), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(57), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [243497] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    ACTIONS(10535), 1,
      anon_sym___asm,
    STATE(2886), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10533), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [243529] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    ACTIONS(10539), 1,
      anon_sym___asm,
    STATE(2886), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10537), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [243561] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(7833), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10541), 1,
      sym_identifier,
    ACTIONS(10543), 1,
      sym_primitive_type,
    STATE(4831), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6513), 1,
      sym__scope_resolution,
    STATE(1806), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(7835), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [243601] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(9306), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10545), 1,
      sym_identifier,
    ACTIONS(10547), 1,
      sym_primitive_type,
    STATE(1573), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6487), 1,
      sym__scope_resolution,
    STATE(2907), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(9308), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [243641] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    ACTIONS(10551), 1,
      anon_sym___asm,
    STATE(2886), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10549), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [243673] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    ACTIONS(10555), 1,
      anon_sym___asm,
    STATE(2886), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10553), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [243705] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    ACTIONS(10559), 1,
      anon_sym___asm,
    STATE(2886), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10557), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [243737] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(4840), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [243761] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10563), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10561), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [243785] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(9439), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10565), 1,
      sym_identifier,
    ACTIONS(10567), 1,
      sym_primitive_type,
    STATE(1610), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6477), 1,
      sym__scope_resolution,
    STATE(3080), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(9441), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [243825] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10400), 1,
      anon_sym___attribute,
    ACTIONS(10398), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [243849] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10571), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10569), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [243873] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10575), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10573), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [243897] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(7903), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10577), 1,
      sym_identifier,
    ACTIONS(10579), 1,
      sym_primitive_type,
    STATE(4975), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6498), 1,
      sym__scope_resolution,
    STATE(2427), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(9505), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [243937] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10342), 1,
      anon_sym___attribute,
    ACTIONS(10340), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [243961] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(4840), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [243985] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10416), 1,
      anon_sym___attribute,
    ACTIONS(10414), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [244009] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6049), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(6051), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [244033] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7264), 1,
      anon_sym_DASH_GT,
    ACTIONS(7330), 1,
      anon_sym_requires,
    ACTIONS(9674), 1,
      anon_sym_LBRACK,
    STATE(6127), 1,
      sym_trailing_return_type,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5714), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9672), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [244069] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7264), 1,
      anon_sym_DASH_GT,
    ACTIONS(9674), 1,
      anon_sym_LBRACK,
    ACTIONS(10581), 1,
      anon_sym_requires,
    STATE(6154), 1,
      sym_trailing_return_type,
    ACTIONS(9676), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5714), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9672), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [244105] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(7903), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10577), 1,
      sym_identifier,
    ACTIONS(10579), 1,
      sym_primitive_type,
    STATE(2667), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6498), 1,
      sym__scope_resolution,
    STATE(2427), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(3768), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [244145] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(4879), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10529), 1,
      sym_identifier,
    ACTIONS(10531), 1,
      sym_primitive_type,
    STATE(2269), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6511), 1,
      sym__scope_resolution,
    STATE(2427), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(57), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [244185] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10280), 1,
      anon_sym___attribute,
    ACTIONS(10278), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [244209] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    ACTIONS(10535), 1,
      anon_sym___asm,
    STATE(2880), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10533), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [244241] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(7875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10584), 1,
      sym_identifier,
    ACTIONS(10586), 1,
      sym_primitive_type,
    STATE(4167), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6528), 1,
      sym__scope_resolution,
    STATE(2662), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(2868), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [244281] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9062), 1,
      anon_sym___attribute,
    ACTIONS(9150), 1,
      anon_sym_requires,
    ACTIONS(9147), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [244313] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9211), 1,
      anon_sym___attribute,
    ACTIONS(9277), 1,
      anon_sym_requires,
    ACTIONS(9274), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5935), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [244345] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(7853), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10588), 1,
      sym_identifier,
    ACTIONS(10590), 1,
      sym_primitive_type,
    STATE(4027), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6508), 1,
      sym__scope_resolution,
    STATE(4862), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(7855), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [244385] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    ACTIONS(10539), 1,
      anon_sym___asm,
    STATE(2880), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10537), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [244417] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(7917), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10592), 1,
      sym_identifier,
    ACTIONS(10594), 1,
      sym_primitive_type,
    STATE(3909), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6486), 1,
      sym__scope_resolution,
    STATE(4658), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(7883), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [244457] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9525), 1,
      anon_sym___attribute,
    ACTIONS(9514), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [244481] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7326), 1,
      anon_sym_requires,
    ACTIONS(9525), 1,
      anon_sym___attribute,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5991), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [244513] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6057), 1,
      anon_sym___attribute,
    ACTIONS(10596), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6059), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [244539] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6037), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(6039), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [244563] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    ACTIONS(10527), 1,
      anon_sym___asm,
    STATE(2880), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10525), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [244595] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6489), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(6491), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [244619] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7264), 1,
      anon_sym_DASH_GT,
    ACTIONS(7330), 1,
      anon_sym_requires,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    STATE(6116), 1,
      sym_trailing_return_type,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [244655] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10328), 1,
      anon_sym___attribute,
    ACTIONS(10326), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [244679] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10324), 1,
      anon_sym___attribute,
    ACTIONS(10322), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [244703] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10600), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10598), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [244727] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(9254), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10602), 1,
      sym_identifier,
    ACTIONS(10604), 1,
      sym_primitive_type,
    STATE(1554), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6506), 1,
      sym__scope_resolution,
    STATE(2229), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(9256), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [244767] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10360), 1,
      anon_sym___attribute,
    ACTIONS(10358), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [244791] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    ACTIONS(10608), 1,
      anon_sym___attribute,
    STATE(2831), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10606), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [244823] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    ACTIONS(10523), 1,
      anon_sym___attribute,
    STATE(2831), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10519), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [244855] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6116), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(6118), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [244879] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6041), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(6043), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [244903] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6141), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(6143), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [244927] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6155), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(6157), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [244951] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_LBRACE,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9636), 1,
      anon_sym_LBRACK,
    ACTIONS(9640), 1,
      anon_sym_COLON,
    ACTIONS(10612), 1,
      anon_sym___attribute,
    ACTIONS(10614), 1,
      anon_sym_EQ,
    STATE(2834), 1,
      sym_parameter_list,
    STATE(6324), 1,
      sym__function_declarator_seq,
    STATE(6933), 1,
      sym_bitfield_clause,
    STATE(6934), 1,
      sym_initializer_list,
    STATE(6210), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10610), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [244997] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    ACTIONS(10527), 1,
      anon_sym___attribute,
    STATE(2831), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10525), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [245029] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    ACTIONS(10535), 1,
      anon_sym___attribute,
    STATE(2831), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10533), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [245061] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    ACTIONS(10539), 1,
      anon_sym___attribute,
    STATE(2831), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10537), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [245093] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(9254), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10616), 1,
      sym_identifier,
    ACTIONS(10618), 1,
      sym_primitive_type,
    STATE(1556), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6506), 1,
      sym__scope_resolution,
    STATE(2229), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(9381), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [245133] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    ACTIONS(10551), 1,
      anon_sym___attribute,
    STATE(2831), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10549), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [245165] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    ACTIONS(10555), 1,
      anon_sym___attribute,
    STATE(2831), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10553), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [245197] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(9334), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10620), 1,
      sym_identifier,
    ACTIONS(10622), 1,
      sym_primitive_type,
    STATE(1569), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6507), 1,
      sym__scope_resolution,
    STATE(2814), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(9336), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [245237] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    ACTIONS(10559), 1,
      anon_sym___attribute,
    STATE(2831), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10557), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [245269] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(9282), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10586), 1,
      sym_primitive_type,
    ACTIONS(10624), 1,
      sym_identifier,
    STATE(2154), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6500), 1,
      sym__scope_resolution,
    STATE(2662), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(9284), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [245309] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    ACTIONS(10551), 1,
      anon_sym___asm,
    STATE(2880), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10549), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [245341] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9211), 1,
      anon_sym___attribute,
    ACTIONS(9200), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [245365] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7326), 1,
      anon_sym_requires,
    ACTIONS(9211), 1,
      anon_sym___attribute,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5935), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [245397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6100), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(6102), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [245421] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9674), 1,
      anon_sym___attribute,
    ACTIONS(10626), 1,
      anon_sym_requires,
    ACTIONS(10425), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5897), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9672), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [245453] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7264), 1,
      anon_sym_DASH_GT,
    ACTIONS(7330), 1,
      anon_sym_requires,
    ACTIONS(9525), 1,
      anon_sym_LBRACK,
    STATE(6123), 1,
      sym_trailing_return_type,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5701), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [245489] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(4873), 1,
      anon_sym_STAR,
    ACTIONS(4875), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4877), 1,
      anon_sym_AMP,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6619), 1,
      sym__abstract_declarator,
    ACTIONS(8197), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [245529] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7264), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9183), 1,
      anon_sym_requires,
    STATE(6110), 1,
      sym_trailing_return_type,
    ACTIONS(9082), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [245565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6104), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(6106), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [245589] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6108), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(6110), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [245613] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6021), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(6023), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [245637] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10631), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10629), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [245661] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9062), 1,
      anon_sym___attribute,
    ACTIONS(9051), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [245685] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7326), 1,
      anon_sym_requires,
    ACTIONS(9062), 1,
      anon_sym___attribute,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [245717] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10316), 1,
      anon_sym___attribute,
    ACTIONS(10314), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [245741] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10396), 1,
      anon_sym___attribute,
    ACTIONS(10394), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [245765] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7264), 1,
      anon_sym_DASH_GT,
    ACTIONS(7330), 1,
      anon_sym_requires,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    STATE(6183), 1,
      sym_trailing_return_type,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [245801] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    ACTIONS(10608), 1,
      anon_sym___asm,
    STATE(2880), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10606), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [245833] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(7881), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10592), 1,
      sym_identifier,
    ACTIONS(10594), 1,
      sym_primitive_type,
    STATE(3909), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6504), 1,
      sym__scope_resolution,
    STATE(4658), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(7883), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [245873] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7264), 1,
      anon_sym_DASH_GT,
    ACTIONS(9525), 1,
      anon_sym_LBRACK,
    ACTIONS(9568), 1,
      anon_sym_requires,
    STATE(6138), 1,
      sym_trailing_return_type,
    ACTIONS(9527), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5701), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [245909] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    ACTIONS(10555), 1,
      anon_sym___asm,
    STATE(2880), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10553), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [245941] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6092), 1,
      anon_sym___attribute,
    ACTIONS(10596), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(10633), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(6094), 11,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [245969] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    ACTIONS(10559), 1,
      anon_sym___asm,
    STATE(2880), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10557), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [246001] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10404), 1,
      anon_sym___attribute,
    ACTIONS(10402), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [246025] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10637), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10635), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [246049] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10641), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10639), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [246073] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(9395), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10643), 1,
      sym_identifier,
    ACTIONS(10645), 1,
      sym_primitive_type,
    STATE(1801), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6510), 1,
      sym__scope_resolution,
    STATE(3942), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(9397), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [246113] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10412), 1,
      anon_sym___attribute,
    ACTIONS(10410), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [246137] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9674), 1,
      anon_sym___attribute,
    ACTIONS(9672), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [246161] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7264), 1,
      anon_sym_DASH_GT,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(9329), 1,
      anon_sym_requires,
    STATE(6128), 1,
      sym_trailing_return_type,
    ACTIONS(9213), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [246197] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7326), 1,
      anon_sym_requires,
    ACTIONS(9674), 1,
      anon_sym___attribute,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5897), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9672), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [246229] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9762), 1,
      anon_sym___attribute,
    ACTIONS(10647), 1,
      anon_sym_requires,
    ACTIONS(10431), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5915), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9760), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [246261] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    ACTIONS(10608), 1,
      anon_sym___asm,
    STATE(2886), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10606), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [246293] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(9359), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10650), 1,
      sym_identifier,
    ACTIONS(10652), 1,
      sym_primitive_type,
    STATE(1839), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6490), 1,
      sym__scope_resolution,
    STATE(1806), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(9361), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [246333] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(10075), 1,
      anon_sym_TILDE,
    ACTIONS(10654), 1,
      sym_identifier,
    ACTIONS(10656), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(10659), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10661), 1,
      anon_sym_template,
    STATE(6257), 1,
      sym__scope_resolution,
    STATE(7677), 1,
      sym_operator_name,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(3311), 4,
      sym_template_method,
      sym_destructor_name,
      sym_dependent_field_identifier,
      sym_qualified_field_identifier,
  [246375] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6045), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(6047), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [246399] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8451), 1,
      anon_sym_STAR,
    ACTIONS(8453), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8455), 1,
      anon_sym_AMP,
    STATE(3109), 1,
      sym_parameter_list,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6657), 1,
      sym__abstract_declarator,
    ACTIONS(8197), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [246439] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4847), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(4840), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [246463] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10408), 1,
      anon_sym___attribute,
    ACTIONS(10406), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [246487] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3766), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10577), 1,
      sym_identifier,
    ACTIONS(10579), 1,
      sym_primitive_type,
    STATE(2667), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6476), 1,
      sym__scope_resolution,
    STATE(2427), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(3768), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [246527] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10665), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10663), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [246551] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10374), 1,
      anon_sym___attribute,
    ACTIONS(10372), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [246575] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10378), 1,
      anon_sym___attribute,
    ACTIONS(10376), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [246599] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10382), 1,
      anon_sym___attribute,
    ACTIONS(10380), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [246623] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10386), 1,
      anon_sym___attribute,
    ACTIONS(10384), 15,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_try,
      anon_sym_requires,
  [246647] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9525), 1,
      anon_sym___attribute,
    ACTIONS(9571), 1,
      anon_sym_requires,
    ACTIONS(9562), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5991), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [246679] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10669), 3,
      anon_sym___attribute,
      anon_sym_LBRACK,
      anon_sym___asm,
    ACTIONS(10667), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_GT2,
      anon_sym_try,
  [246703] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    ACTIONS(10523), 1,
      anon_sym___asm,
    STATE(2880), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10519), 11,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [246735] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10652), 1,
      sym_primitive_type,
    ACTIONS(10671), 1,
      sym_identifier,
    STATE(4142), 1,
      aux_sym_sized_type_specifier_repeat1,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(1806), 2,
      sym_sized_type_specifier,
      sym_qualified_type_identifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    ACTIONS(1781), 4,
      anon_sym_signed,
      anon_sym_unsigned,
      anon_sym_long,
      anon_sym_short,
  [246775] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7583), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym___attribute,
    ACTIONS(9150), 1,
      anon_sym_requires,
    STATE(5931), 1,
      sym_trailing_return_type,
    ACTIONS(9147), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [246810] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(4873), 1,
      anon_sym_STAR,
    ACTIONS(4875), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4877), 1,
      anon_sym_AMP,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(10476), 1,
      anon_sym_LBRACE,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(4173), 1,
      sym_compound_statement,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6909), 1,
      sym_abstract_function_declarator,
    STATE(6920), 1,
      sym__abstract_declarator,
    STATE(5942), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [246853] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10673), 1,
      sym_identifier,
    ACTIONS(10675), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10677), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(10679), 1,
      aux_sym_preproc_elif_token1,
    STATE(6343), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(6381), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(6599), 1,
      sym_enumerator,
    ACTIONS(10681), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(7892), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
    STATE(7929), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [246892] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9636), 1,
      anon_sym_LBRACK,
    ACTIONS(10685), 1,
      anon_sym___attribute,
    STATE(2834), 1,
      sym_parameter_list,
    STATE(6324), 1,
      sym__function_declarator_seq,
    STATE(6210), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10683), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [246927] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10484), 1,
      sym_identifier,
    STATE(6082), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(7176), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(117), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [246956] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10673), 1,
      sym_identifier,
    ACTIONS(10677), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(10679), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(10687), 1,
      aux_sym_preproc_if_token2,
    STATE(6360), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(6428), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(6599), 1,
      sym_enumerator,
    ACTIONS(10681), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(7829), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
    STATE(7877), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [246995] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10484), 1,
      sym_identifier,
    STATE(6082), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(7396), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(117), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [247024] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10484), 1,
      sym_identifier,
    STATE(6082), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(7206), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(117), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [247053] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7273), 1,
      anon_sym_DASH_GT,
    ACTIONS(7326), 1,
      anon_sym_requires,
    STATE(5993), 1,
      sym_trailing_return_type,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5991), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [247086] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10484), 1,
      sym_identifier,
    STATE(6082), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(7296), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(117), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [247115] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7273), 1,
      anon_sym_DASH_GT,
    ACTIONS(10626), 1,
      anon_sym_requires,
    STATE(5994), 1,
      sym_trailing_return_type,
    ACTIONS(10425), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5897), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9672), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [247148] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7174), 1,
      anon_sym_DASH_GT,
    ACTIONS(9565), 1,
      anon_sym_requires,
    STATE(5806), 1,
      sym_trailing_return_type,
    ACTIONS(9562), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5991), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [247181] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10484), 1,
      sym_identifier,
    STATE(6082), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(7302), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(117), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [247210] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9636), 1,
      anon_sym_LBRACK,
    ACTIONS(10691), 1,
      anon_sym___attribute,
    STATE(2834), 1,
      sym_parameter_list,
    STATE(6324), 1,
      sym__function_declarator_seq,
    STATE(6210), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10689), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [247245] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10484), 1,
      sym_identifier,
    STATE(6082), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(7325), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(117), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [247274] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7174), 1,
      anon_sym_DASH_GT,
    ACTIONS(9354), 1,
      anon_sym_requires,
    STATE(5803), 1,
      sym_trailing_return_type,
    ACTIONS(9274), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5935), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [247307] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9636), 1,
      anon_sym_LBRACK,
    ACTIONS(10695), 1,
      anon_sym___attribute,
    STATE(2834), 1,
      sym_parameter_list,
    STATE(6324), 1,
      sym__function_declarator_seq,
    STATE(6210), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10693), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [247342] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(10699), 1,
      anon_sym___asm,
    STATE(2872), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(6238), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10697), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [247377] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(10699), 1,
      anon_sym___asm,
    STATE(2922), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10697), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [247412] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10484), 1,
      sym_identifier,
    STATE(6082), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(7412), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(117), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [247441] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10484), 1,
      sym_identifier,
    STATE(6082), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(7116), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(117), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [247470] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(4873), 1,
      anon_sym_STAR,
    ACTIONS(4875), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4877), 1,
      anon_sym_AMP,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(10482), 1,
      anon_sym_LBRACE,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(5460), 1,
      sym_compound_statement,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6820), 1,
      sym_abstract_function_declarator,
    STATE(6920), 1,
      sym__abstract_declarator,
    STATE(5942), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [247513] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10484), 1,
      sym_identifier,
    STATE(6082), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(7041), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(117), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [247542] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(10703), 1,
      anon_sym___asm,
    STATE(2872), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(6238), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10701), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [247577] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10484), 1,
      sym_identifier,
    STATE(6082), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(7409), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(117), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [247606] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(10707), 1,
      anon_sym___asm,
    STATE(2922), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10705), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [247641] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(10075), 1,
      anon_sym_TILDE,
    ACTIONS(10654), 1,
      sym_identifier,
    ACTIONS(10659), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10661), 1,
      anon_sym_template,
    STATE(6257), 1,
      sym__scope_resolution,
    STATE(7677), 1,
      sym_operator_name,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(3311), 4,
      sym_template_method,
      sym_destructor_name,
      sym_dependent_field_identifier,
      sym_qualified_field_identifier,
  [247680] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(10707), 1,
      anon_sym___asm,
    STATE(2872), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(6238), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10705), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [247715] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10673), 1,
      sym_identifier,
    ACTIONS(10677), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(10679), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(10709), 1,
      aux_sym_preproc_if_token2,
    STATE(6368), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(6430), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(6599), 1,
      sym_enumerator,
    ACTIONS(10681), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(7936), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
    STATE(8273), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [247754] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(10713), 1,
      anon_sym___asm,
    STATE(2922), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10711), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [247789] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(10051), 1,
      anon_sym_TILDE,
    ACTIONS(10715), 1,
      sym_identifier,
    ACTIONS(10717), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10719), 1,
      anon_sym_template,
    STATE(6252), 1,
      sym__scope_resolution,
    STATE(7484), 1,
      sym_operator_name,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(2369), 4,
      sym_template_method,
      sym_destructor_name,
      sym_dependent_field_identifier,
      sym_qualified_field_identifier,
  [247828] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(4873), 1,
      anon_sym_STAR,
    ACTIONS(4875), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4877), 1,
      anon_sym_AMP,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(10496), 1,
      anon_sym_LBRACE,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(3306), 1,
      sym_compound_statement,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6892), 1,
      sym_abstract_function_declarator,
    STATE(6920), 1,
      sym__abstract_declarator,
    STATE(5942), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [247871] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(4873), 1,
      anon_sym_STAR,
    ACTIONS(4875), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4877), 1,
      anon_sym_AMP,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    STATE(1602), 1,
      sym_compound_statement,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6836), 1,
      sym_abstract_function_declarator,
    STATE(6920), 1,
      sym__abstract_declarator,
    STATE(5942), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [247914] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7174), 1,
      anon_sym_DASH_GT,
    ACTIONS(7284), 1,
      anon_sym_requires,
    STATE(5822), 1,
      sym_trailing_return_type,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5991), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [247947] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10484), 1,
      sym_identifier,
    STATE(6082), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(7805), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(117), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [247976] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7174), 1,
      anon_sym_DASH_GT,
    ACTIONS(9159), 1,
      anon_sym_requires,
    STATE(5838), 1,
      sym_trailing_return_type,
    ACTIONS(9147), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [248009] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(10723), 1,
      anon_sym___asm,
    STATE(2922), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10721), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [248044] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7273), 1,
      anon_sym_DASH_GT,
    ACTIONS(9150), 1,
      anon_sym_requires,
    STATE(5931), 1,
      sym_trailing_return_type,
    ACTIONS(9147), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [248077] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7326), 1,
      anon_sym_requires,
    ACTIONS(7583), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym___attribute,
    STATE(5965), 1,
      sym_trailing_return_type,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [248112] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7326), 1,
      anon_sym_requires,
    ACTIONS(7583), 1,
      anon_sym_DASH_GT,
    ACTIONS(9211), 1,
      anon_sym___attribute,
    STATE(5936), 1,
      sym_trailing_return_type,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5935), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [248147] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(4873), 1,
      anon_sym_STAR,
    ACTIONS(4875), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4877), 1,
      anon_sym_AMP,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(10480), 1,
      anon_sym_LBRACE,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(5837), 1,
      sym_compound_statement,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6848), 1,
      sym_abstract_function_declarator,
    STATE(6920), 1,
      sym__abstract_declarator,
    STATE(5942), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [248190] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7326), 1,
      anon_sym_requires,
    ACTIONS(7583), 1,
      anon_sym_DASH_GT,
    ACTIONS(9525), 1,
      anon_sym___attribute,
    STATE(5993), 1,
      sym_trailing_return_type,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5991), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [248225] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7326), 1,
      anon_sym_requires,
    ACTIONS(7583), 1,
      anon_sym_DASH_GT,
    ACTIONS(9674), 1,
      anon_sym___attribute,
    STATE(5902), 1,
      sym_trailing_return_type,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5897), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9672), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [248260] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7273), 1,
      anon_sym_DASH_GT,
    ACTIONS(7326), 1,
      anon_sym_requires,
    STATE(5936), 1,
      sym_trailing_return_type,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5935), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [248293] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10484), 1,
      sym_identifier,
    STATE(6082), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(7346), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(117), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [248322] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(10703), 1,
      anon_sym___asm,
    STATE(2922), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10701), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_asm,
      anon_sym___asm__,
      anon_sym_try,
  [248357] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10673), 1,
      sym_identifier,
    ACTIONS(10677), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(10679), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(10725), 1,
      aux_sym_preproc_if_token2,
    STATE(6402), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(6405), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(6599), 1,
      sym_enumerator,
    ACTIONS(10681), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(7818), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
    STATE(7828), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [248396] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7273), 1,
      anon_sym_DASH_GT,
    ACTIONS(9571), 1,
      anon_sym_requires,
    STATE(5967), 1,
      sym_trailing_return_type,
    ACTIONS(9562), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5991), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [248429] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7583), 1,
      anon_sym_DASH_GT,
    ACTIONS(9211), 1,
      anon_sym___attribute,
    ACTIONS(9277), 1,
      anon_sym_requires,
    STATE(6008), 1,
      sym_trailing_return_type,
    ACTIONS(9274), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5935), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [248464] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7583), 1,
      anon_sym_DASH_GT,
    ACTIONS(9525), 1,
      anon_sym___attribute,
    ACTIONS(9571), 1,
      anon_sym_requires,
    STATE(5967), 1,
      sym_trailing_return_type,
    ACTIONS(9562), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5991), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [248499] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7583), 1,
      anon_sym_DASH_GT,
    ACTIONS(9674), 1,
      anon_sym___attribute,
    ACTIONS(10626), 1,
      anon_sym_requires,
    STATE(5994), 1,
      sym_trailing_return_type,
    ACTIONS(10425), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5897), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9672), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [248534] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(4873), 1,
      anon_sym_STAR,
    ACTIONS(4875), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4877), 1,
      anon_sym_AMP,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(10488), 1,
      anon_sym_LBRACE,
    STATE(2407), 1,
      sym_compound_statement,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6806), 1,
      sym_abstract_function_declarator,
    STATE(6920), 1,
      sym__abstract_declarator,
    STATE(5942), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [248577] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7174), 1,
      anon_sym_DASH_GT,
    ACTIONS(10428), 1,
      anon_sym_requires,
    STATE(5808), 1,
      sym_trailing_return_type,
    ACTIONS(10425), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5897), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9672), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [248610] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9636), 1,
      anon_sym_LBRACK,
    ACTIONS(10729), 1,
      anon_sym___attribute,
    STATE(2834), 1,
      sym_parameter_list,
    STATE(6324), 1,
      sym__function_declarator_seq,
    STATE(6210), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10727), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [248645] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(10723), 1,
      anon_sym___asm,
    STATE(2872), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(6238), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10721), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [248680] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7273), 1,
      anon_sym_DASH_GT,
    ACTIONS(7326), 1,
      anon_sym_requires,
    STATE(5965), 1,
      sym_trailing_return_type,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [248713] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10484), 1,
      sym_identifier,
    STATE(6082), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(7772), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(117), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [248742] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7400), 1,
      anon_sym_requires,
    ACTIONS(7423), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym___attribute,
    STATE(6190), 1,
      sym_trailing_return_type,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [248777] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7400), 1,
      anon_sym_requires,
    ACTIONS(7423), 1,
      anon_sym_DASH_GT,
    ACTIONS(9211), 1,
      anon_sym___attribute,
    STATE(6133), 1,
      sym_trailing_return_type,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5935), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [248812] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10484), 1,
      sym_identifier,
    STATE(6082), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(7885), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(117), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [248841] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10484), 1,
      sym_identifier,
    STATE(6082), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(7958), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(117), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [248870] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10484), 1,
      sym_identifier,
    STATE(6082), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(8009), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(117), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [248899] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(4873), 1,
      anon_sym_STAR,
    ACTIONS(4875), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4877), 1,
      anon_sym_AMP,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(10504), 1,
      anon_sym_LBRACE,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(3597), 1,
      sym_compound_statement,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6920), 1,
      sym__abstract_declarator,
    STATE(6991), 1,
      sym_abstract_function_declarator,
    STATE(5942), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [248942] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7400), 1,
      anon_sym_requires,
    ACTIONS(7423), 1,
      anon_sym_DASH_GT,
    ACTIONS(9525), 1,
      anon_sym___attribute,
    STATE(6118), 1,
      sym_trailing_return_type,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5991), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [248977] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10484), 1,
      sym_identifier,
    STATE(6082), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(8053), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(117), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [249006] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7400), 1,
      anon_sym_requires,
    ACTIONS(7423), 1,
      anon_sym_DASH_GT,
    ACTIONS(9674), 1,
      anon_sym___attribute,
    STATE(6162), 1,
      sym_trailing_return_type,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5897), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9672), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [249041] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10484), 1,
      sym_identifier,
    STATE(6082), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(7182), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(117), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [249070] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7174), 1,
      anon_sym_DASH_GT,
    ACTIONS(7284), 1,
      anon_sym_requires,
    STATE(5817), 1,
      sym_trailing_return_type,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5897), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9672), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [249103] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10484), 1,
      sym_identifier,
    STATE(6082), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(7417), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(117), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [249132] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(4873), 1,
      anon_sym_STAR,
    ACTIONS(4875), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4877), 1,
      anon_sym_AMP,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(10502), 1,
      anon_sym_LBRACE,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(3417), 1,
      sym_compound_statement,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6803), 1,
      sym_abstract_function_declarator,
    STATE(6920), 1,
      sym__abstract_declarator,
    STATE(5942), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [249175] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5893), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(5799), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(10492), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(10494), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [249202] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(10051), 1,
      anon_sym_TILDE,
    ACTIONS(10715), 1,
      sym_identifier,
    ACTIONS(10731), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10733), 1,
      anon_sym_template,
    STATE(6233), 1,
      sym__scope_resolution,
    STATE(7530), 1,
      sym_operator_name,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(2369), 4,
      sym_template_method,
      sym_destructor_name,
      sym_dependent_field_identifier,
      sym_qualified_field_identifier,
  [249241] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7423), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym___attribute,
    ACTIONS(9197), 1,
      anon_sym_requires,
    STATE(6106), 1,
      sym_trailing_return_type,
    ACTIONS(9147), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [249276] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7423), 1,
      anon_sym_DASH_GT,
    ACTIONS(9211), 1,
      anon_sym___attribute,
    ACTIONS(9499), 1,
      anon_sym_requires,
    STATE(6107), 1,
      sym_trailing_return_type,
    ACTIONS(9274), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5935), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [249311] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7423), 1,
      anon_sym_DASH_GT,
    ACTIONS(9525), 1,
      anon_sym___attribute,
    ACTIONS(9574), 1,
      anon_sym_requires,
    STATE(6109), 1,
      sym_trailing_return_type,
    ACTIONS(9562), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5991), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [249346] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(10713), 1,
      anon_sym___asm,
    STATE(2872), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(6238), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10711), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [249381] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7423), 1,
      anon_sym_DASH_GT,
    ACTIONS(9674), 1,
      anon_sym___attribute,
    ACTIONS(10735), 1,
      anon_sym_requires,
    STATE(6114), 1,
      sym_trailing_return_type,
    ACTIONS(10425), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5897), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9672), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [249416] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9636), 1,
      anon_sym_LBRACK,
    ACTIONS(10740), 1,
      anon_sym___attribute,
    STATE(2834), 1,
      sym_parameter_list,
    STATE(6324), 1,
      sym__function_declarator_seq,
    STATE(6210), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10738), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [249451] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7273), 1,
      anon_sym_DASH_GT,
    ACTIONS(7326), 1,
      anon_sym_requires,
    STATE(5902), 1,
      sym_trailing_return_type,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5897), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9672), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [249484] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10484), 1,
      sym_identifier,
    STATE(6082), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(7043), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(117), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [249513] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7273), 1,
      anon_sym_DASH_GT,
    ACTIONS(9277), 1,
      anon_sym_requires,
    STATE(6008), 1,
      sym_trailing_return_type,
    ACTIONS(9274), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5935), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [249546] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(4873), 1,
      anon_sym_STAR,
    ACTIONS(4875), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4877), 1,
      anon_sym_AMP,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(10500), 1,
      anon_sym_LBRACE,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(3869), 1,
      sym_compound_statement,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6920), 1,
      sym__abstract_declarator,
    STATE(6954), 1,
      sym_abstract_function_declarator,
    STATE(5942), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [249589] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10484), 1,
      sym_identifier,
    STATE(6082), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(8473), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(117), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [249618] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7174), 1,
      anon_sym_DASH_GT,
    ACTIONS(7284), 1,
      anon_sym_requires,
    STATE(5812), 1,
      sym_trailing_return_type,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5935), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [249651] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(4873), 1,
      anon_sym_STAR,
    ACTIONS(4875), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4877), 1,
      anon_sym_AMP,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(10478), 1,
      anon_sym_LBRACE,
    STATE(1602), 1,
      sym_compound_statement,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6805), 1,
      sym_abstract_function_declarator,
    STATE(6920), 1,
      sym__abstract_declarator,
    STATE(5942), 4,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [249694] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7174), 1,
      anon_sym_DASH_GT,
    ACTIONS(7284), 1,
      anon_sym_requires,
    STATE(5807), 1,
      sym_trailing_return_type,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 6,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_try,
  [249727] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10484), 1,
      sym_identifier,
    STATE(6082), 2,
      sym_string_literal,
      sym_raw_string_literal,
    STATE(7079), 2,
      sym__string,
      sym_concatenated_string,
    ACTIONS(117), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(153), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [249756] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(10260), 1,
      anon_sym_TILDE,
    ACTIONS(10742), 1,
      sym_identifier,
    ACTIONS(10744), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10746), 1,
      anon_sym_template,
    STATE(6230), 1,
      sym__scope_resolution,
    STATE(7431), 1,
      sym_operator_name,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
    STATE(3509), 4,
      sym_template_method,
      sym_destructor_name,
      sym_dependent_field_identifier,
      sym_qualified_field_identifier,
  [249795] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(6882), 1,
      anon_sym_LBRACE,
    ACTIONS(9439), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9487), 1,
      sym_identifier,
    STATE(2773), 1,
      sym_template_type,
    STATE(3031), 1,
      sym_enumerator_list,
    STATE(6477), 1,
      sym__scope_resolution,
    ACTIONS(10748), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(2776), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [249835] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5921), 1,
      anon_sym___asm,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10418), 1,
      anon_sym_LBRACK,
    STATE(5998), 1,
      sym_parameter_list,
    STATE(6263), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5923), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [249867] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9062), 1,
      anon_sym___attribute,
    ACTIONS(9197), 1,
      anon_sym_requires,
    ACTIONS(9147), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [249897] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5454), 1,
      sym_identifier,
    ACTIONS(5456), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [249919] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(6581), 1,
      anon_sym_LBRACE,
    ACTIONS(7875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9483), 1,
      sym_identifier,
    STATE(2532), 1,
      sym_template_type,
    STATE(2536), 1,
      sym_enumerator_list,
    STATE(6528), 1,
      sym__scope_resolution,
    ACTIONS(10750), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(4810), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [249959] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7330), 1,
      anon_sym_requires,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [249989] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9211), 1,
      anon_sym___attribute,
    ACTIONS(9499), 1,
      anon_sym_requires,
    ACTIONS(9274), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5935), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [250019] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9525), 1,
      anon_sym___attribute,
    ACTIONS(9574), 1,
      anon_sym_requires,
    ACTIONS(9562), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5991), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [250049] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    ACTIONS(10523), 1,
      anon_sym___attribute,
    STATE(2930), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10519), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [250079] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9674), 1,
      anon_sym___attribute,
    ACTIONS(10735), 1,
      anon_sym_requires,
    ACTIONS(10425), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5897), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9672), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [250109] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(9329), 1,
      anon_sym_requires,
    ACTIONS(9213), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [250139] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    ACTIONS(10559), 1,
      anon_sym___attribute,
    STATE(2930), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10557), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [250169] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5899), 1,
      anon_sym_LBRACK,
    ACTIONS(5909), 1,
      anon_sym___attribute,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    STATE(2187), 1,
      sym_parameter_list,
    STATE(6243), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5911), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_try,
  [250201] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3766), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9471), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(6435), 1,
      sym_access_specifier,
    STATE(6476), 1,
      sym__scope_resolution,
    STATE(7190), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(10441), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
  [250239] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9762), 1,
      anon_sym___attribute,
    ACTIONS(10752), 1,
      anon_sym_requires,
    ACTIONS(10431), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5915), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9760), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [250269] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5838), 1,
      anon_sym_LBRACE,
    ACTIONS(9254), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9479), 1,
      sym_identifier,
    STATE(1883), 1,
      sym_template_type,
    STATE(2122), 1,
      sym_enumerator_list,
    STATE(6506), 1,
      sym__scope_resolution,
    ACTIONS(10755), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(2320), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [250309] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7330), 1,
      anon_sym_requires,
    ACTIONS(9525), 1,
      anon_sym_LBRACK,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5701), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [250339] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(6802), 1,
      anon_sym_LBRACE,
    ACTIONS(9469), 1,
      sym_identifier,
    ACTIONS(9481), 1,
      anon_sym_COLON_COLON,
    STATE(2158), 1,
      sym_template_type,
    STATE(2835), 1,
      sym_enumerator_list,
    STATE(6509), 1,
      sym__scope_resolution,
    ACTIONS(10757), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(4033), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [250379] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7400), 1,
      anon_sym_requires,
    ACTIONS(9674), 1,
      anon_sym___attribute,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5897), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9672), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [250409] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9183), 1,
      anon_sym_requires,
    ACTIONS(9082), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [250439] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3766), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9471), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(6458), 1,
      sym_access_specifier,
    STATE(6476), 1,
      sym__scope_resolution,
    STATE(6978), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(10441), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
  [250477] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(6661), 1,
      anon_sym_LBRACE,
    ACTIONS(9334), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9475), 1,
      sym_identifier,
    STATE(2562), 1,
      sym_template_type,
    STATE(2774), 1,
      sym_enumerator_list,
    STATE(6507), 1,
      sym__scope_resolution,
    ACTIONS(10759), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(2549), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [250517] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(616), 1,
      anon_sym_LBRACE,
    ACTIONS(7982), 1,
      anon_sym_LBRACK,
    ACTIONS(10761), 1,
      anon_sym_SEMI,
    ACTIONS(10763), 1,
      anon_sym_EQ,
    ACTIONS(10765), 1,
      anon_sym_COLON,
    ACTIONS(10767), 1,
      anon_sym_try,
    STATE(559), 1,
      sym_compound_statement,
    STATE(7584), 1,
      sym_field_initializer_list,
    ACTIONS(4895), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(601), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [250555] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7330), 1,
      anon_sym_requires,
    ACTIONS(9674), 1,
      anon_sym_LBRACK,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5714), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9672), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [250585] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(6581), 1,
      anon_sym_LBRACE,
    ACTIONS(9282), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9485), 1,
      sym_identifier,
    STATE(2532), 1,
      sym_template_type,
    STATE(2536), 1,
      sym_enumerator_list,
    STATE(6500), 1,
      sym__scope_resolution,
    ACTIONS(10769), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(3981), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [250625] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6092), 1,
      anon_sym___attribute,
    ACTIONS(10771), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10773), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6094), 9,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [250651] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5899), 1,
      anon_sym_LBRACK,
    ACTIONS(6017), 1,
      anon_sym___attribute,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    STATE(2187), 1,
      sym_parameter_list,
    STATE(6243), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6019), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_try,
  [250683] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7330), 1,
      anon_sym_requires,
    ACTIONS(9762), 1,
      anon_sym_LBRACK,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5773), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9760), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [250713] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9525), 1,
      anon_sym_LBRACK,
    ACTIONS(9568), 1,
      anon_sym_requires,
    ACTIONS(9527), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5701), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [250743] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5838), 1,
      anon_sym_LBRACE,
    ACTIONS(9254), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9479), 1,
      sym_identifier,
    STATE(1883), 1,
      sym_template_type,
    STATE(2122), 1,
      sym_enumerator_list,
    STATE(6506), 1,
      sym__scope_resolution,
    ACTIONS(10775), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(2432), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [250783] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(644), 1,
      anon_sym_LBRACE,
    ACTIONS(7982), 1,
      anon_sym_LBRACK,
    ACTIONS(10765), 1,
      anon_sym_COLON,
    ACTIONS(10777), 1,
      anon_sym_SEMI,
    ACTIONS(10779), 1,
      anon_sym_EQ,
    ACTIONS(10781), 1,
      anon_sym_try,
    STATE(567), 1,
      sym_compound_statement,
    STATE(7510), 1,
      sym_field_initializer_list,
    ACTIONS(4895), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(568), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [250821] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7398), 1,
      anon_sym_DASH_GT,
    ACTIONS(9197), 1,
      anon_sym_requires,
    STATE(6106), 1,
      sym_trailing_return_type,
    ACTIONS(9147), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [250853] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3766), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9471), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(6437), 1,
      sym_access_specifier,
    STATE(6476), 1,
      sym__scope_resolution,
    STATE(6828), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(10441), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
  [250891] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7400), 1,
      anon_sym_requires,
    ACTIONS(9525), 1,
      anon_sym___attribute,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5991), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [250921] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(6065), 1,
      anon_sym_LBRACE,
    ACTIONS(9359), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9473), 1,
      sym_identifier,
    STATE(1766), 1,
      sym_template_type,
    STATE(2283), 1,
      sym_enumerator_list,
    STATE(6490), 1,
      sym__scope_resolution,
    ACTIONS(10783), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(3846), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [250961] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6802), 1,
      anon_sym_LBRACE,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2835), 1,
      sym_enumerator_list,
    STATE(6493), 1,
      sym__scope_resolution,
    ACTIONS(10785), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(2933), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [251001] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7398), 1,
      anon_sym_DASH_GT,
    ACTIONS(9499), 1,
      anon_sym_requires,
    STATE(6107), 1,
      sym_trailing_return_type,
    ACTIONS(9274), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5935), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [251033] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7982), 1,
      anon_sym_LBRACK,
    ACTIONS(10765), 1,
      anon_sym_COLON,
    ACTIONS(10787), 1,
      anon_sym_SEMI,
    ACTIONS(10789), 1,
      anon_sym_LBRACE,
    ACTIONS(10791), 1,
      anon_sym_EQ,
    ACTIONS(10793), 1,
      anon_sym_try,
    STATE(1931), 1,
      sym_compound_statement,
    STATE(7660), 1,
      sym_field_initializer_list,
    ACTIONS(4895), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(1934), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [251071] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9674), 1,
      anon_sym_LBRACK,
    ACTIONS(10581), 1,
      anon_sym_requires,
    ACTIONS(9676), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5714), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9672), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [251101] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    ACTIONS(10527), 1,
      anon_sym___attribute,
    STATE(2930), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10525), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [251131] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7398), 1,
      anon_sym_DASH_GT,
    ACTIONS(9574), 1,
      anon_sym_requires,
    STATE(6109), 1,
      sym_trailing_return_type,
    ACTIONS(9562), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5991), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [251163] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(289), 1,
      anon_sym_LBRACE,
    ACTIONS(7982), 1,
      anon_sym_LBRACK,
    ACTIONS(10765), 1,
      anon_sym_COLON,
    ACTIONS(10795), 1,
      anon_sym_SEMI,
    ACTIONS(10797), 1,
      anon_sym_EQ,
    ACTIONS(10799), 1,
      anon_sym_try,
    STATE(297), 1,
      sym_compound_statement,
    STATE(7693), 1,
      sym_field_initializer_list,
    ACTIONS(4895), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(298), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [251201] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5447), 1,
      sym_identifier,
    ACTIONS(5449), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [251223] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6057), 1,
      anon_sym___attribute,
    ACTIONS(10773), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6059), 11,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_or,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [251247] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(7881), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8502), 1,
      anon_sym_LBRACE,
    ACTIONS(9489), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(4427), 1,
      sym_enumerator_list,
    STATE(6504), 1,
      sym__scope_resolution,
    ACTIONS(10801), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(4212), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [251287] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7398), 1,
      anon_sym_DASH_GT,
    ACTIONS(10735), 1,
      anon_sym_requires,
    STATE(6114), 1,
      sym_trailing_return_type,
    ACTIONS(10425), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5897), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9672), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [251319] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5387), 1,
      sym_identifier,
    ACTIONS(5389), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [251341] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7398), 1,
      anon_sym_DASH_GT,
    ACTIONS(7400), 1,
      anon_sym_requires,
    STATE(6190), 1,
      sym_trailing_return_type,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [251373] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(6065), 1,
      anon_sym_LBRACE,
    ACTIONS(7833), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9467), 1,
      sym_identifier,
    STATE(1766), 1,
      sym_template_type,
    STATE(5089), 1,
      sym_enumerator_list,
    STATE(6513), 1,
      sym__scope_resolution,
    ACTIONS(10803), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(4807), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [251413] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(289), 1,
      anon_sym_LBRACE,
    ACTIONS(7982), 1,
      anon_sym_LBRACK,
    ACTIONS(10765), 1,
      anon_sym_COLON,
    ACTIONS(10797), 1,
      anon_sym_EQ,
    ACTIONS(10799), 1,
      anon_sym_try,
    ACTIONS(10805), 1,
      anon_sym_SEMI,
    STATE(342), 1,
      sym_compound_statement,
    STATE(7564), 1,
      sym_field_initializer_list,
    ACTIONS(4895), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(343), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [251451] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    ACTIONS(10535), 1,
      anon_sym___attribute,
    STATE(2930), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10533), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [251481] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7470), 1,
      anon_sym_DASH_GT,
    ACTIONS(9674), 1,
      anon_sym_LBRACK,
    ACTIONS(9679), 1,
      anon_sym_requires,
    STATE(5392), 1,
      sym_trailing_return_type,
    ACTIONS(9676), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5714), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9672), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [251515] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(6802), 1,
      anon_sym_LBRACE,
    ACTIONS(7881), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9489), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(3609), 1,
      sym_enumerator_list,
    STATE(6504), 1,
      sym__scope_resolution,
    ACTIONS(10807), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(4160), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [251555] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5399), 1,
      sym_identifier,
    ACTIONS(5401), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [251577] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9762), 1,
      anon_sym_LBRACK,
    ACTIONS(10809), 1,
      anon_sym_requires,
    ACTIONS(9796), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5773), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9760), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [251607] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    ACTIONS(10539), 1,
      anon_sym___attribute,
    STATE(2930), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10537), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [251637] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7398), 1,
      anon_sym_DASH_GT,
    ACTIONS(7400), 1,
      anon_sym_requires,
    STATE(6133), 1,
      sym_trailing_return_type,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5935), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [251669] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8197), 1,
      anon_sym_COLON,
    ACTIONS(8548), 1,
      anon_sym_STAR,
    ACTIONS(8550), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8552), 1,
      anon_sym_AMP,
    STATE(3356), 1,
      sym_parameter_list,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6742), 1,
      sym__abstract_declarator,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [251707] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5891), 1,
      anon_sym___attribute,
    ACTIONS(5899), 1,
      anon_sym_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    STATE(2187), 1,
      sym_parameter_list,
    STATE(6243), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5893), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_try,
  [251739] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(6705), 1,
      anon_sym_LBRACE,
    ACTIONS(9306), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9491), 1,
      sym_identifier,
    STATE(2632), 1,
      sym_template_type,
    STATE(2828), 1,
      sym_enumerator_list,
    STATE(6487), 1,
      sym__scope_resolution,
    ACTIONS(10812), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(2607), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [251779] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6092), 1,
      anon_sym_LBRACK,
    ACTIONS(10814), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(10816), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6094), 9,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [251805] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7398), 1,
      anon_sym_DASH_GT,
    ACTIONS(7400), 1,
      anon_sym_requires,
    STATE(6118), 1,
      sym_trailing_return_type,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5991), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [251837] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7400), 1,
      anon_sym_requires,
    ACTIONS(9762), 1,
      anon_sym___attribute,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5915), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9760), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [251867] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(6802), 1,
      anon_sym_LBRACE,
    ACTIONS(7881), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9489), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(3609), 1,
      sym_enumerator_list,
    STATE(6504), 1,
      sym__scope_resolution,
    ACTIONS(10818), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(6423), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [251907] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7162), 1,
      anon_sym_requires,
    ACTIONS(7470), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    STATE(5366), 1,
      sym_trailing_return_type,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [251941] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(7982), 1,
      anon_sym_LBRACK,
    ACTIONS(10765), 1,
      anon_sym_COLON,
    ACTIONS(10820), 1,
      anon_sym_SEMI,
    ACTIONS(10822), 1,
      anon_sym_EQ,
    ACTIONS(10824), 1,
      anon_sym_try,
    STATE(716), 1,
      sym_compound_statement,
    STATE(7478), 1,
      sym_field_initializer_list,
    ACTIONS(4895), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(717), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [251979] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7982), 1,
      anon_sym_LBRACK,
    ACTIONS(10765), 1,
      anon_sym_COLON,
    ACTIONS(10789), 1,
      anon_sym_LBRACE,
    ACTIONS(10791), 1,
      anon_sym_EQ,
    ACTIONS(10793), 1,
      anon_sym_try,
    ACTIONS(10826), 1,
      anon_sym_SEMI,
    STATE(1969), 1,
      sym_compound_statement,
    STATE(7436), 1,
      sym_field_initializer_list,
    ACTIONS(4895), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(1970), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [252017] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7162), 1,
      anon_sym_requires,
    ACTIONS(7470), 1,
      anon_sym_DASH_GT,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    STATE(5367), 1,
      sym_trailing_return_type,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [252051] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7398), 1,
      anon_sym_DASH_GT,
    ACTIONS(7400), 1,
      anon_sym_requires,
    STATE(6162), 1,
      sym_trailing_return_type,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5897), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9672), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [252083] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7982), 1,
      anon_sym_LBRACK,
    ACTIONS(10765), 1,
      anon_sym_COLON,
    ACTIONS(10828), 1,
      anon_sym_SEMI,
    ACTIONS(10830), 1,
      anon_sym_LBRACE,
    ACTIONS(10832), 1,
      anon_sym_EQ,
    ACTIONS(10834), 1,
      anon_sym_try,
    STATE(1694), 1,
      sym_compound_statement,
    STATE(7659), 1,
      sym_field_initializer_list,
    ACTIONS(4895), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(1695), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [252121] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(7853), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8832), 1,
      anon_sym_LBRACE,
    ACTIONS(9493), 1,
      sym_identifier,
    STATE(4327), 1,
      sym_template_type,
    STATE(4809), 1,
      sym_enumerator_list,
    STATE(6508), 1,
      sym__scope_resolution,
    ACTIONS(10836), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(4396), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [252161] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(644), 1,
      anon_sym_LBRACE,
    ACTIONS(7982), 1,
      anon_sym_LBRACK,
    ACTIONS(10765), 1,
      anon_sym_COLON,
    ACTIONS(10779), 1,
      anon_sym_EQ,
    ACTIONS(10781), 1,
      anon_sym_try,
    ACTIONS(10838), 1,
      anon_sym_SEMI,
    STATE(610), 1,
      sym_compound_statement,
    STATE(7544), 1,
      sym_field_initializer_list,
    ACTIONS(4895), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(618), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [252199] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7982), 1,
      anon_sym_LBRACK,
    ACTIONS(10765), 1,
      anon_sym_COLON,
    ACTIONS(10840), 1,
      anon_sym_SEMI,
    ACTIONS(10842), 1,
      anon_sym_LBRACE,
    ACTIONS(10844), 1,
      anon_sym_EQ,
    ACTIONS(10846), 1,
      anon_sym_try,
    STATE(2102), 1,
      sym_compound_statement,
    STATE(7726), 1,
      sym_field_initializer_list,
    ACTIONS(4895), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(2103), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [252237] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7162), 1,
      anon_sym_requires,
    ACTIONS(7470), 1,
      anon_sym_DASH_GT,
    ACTIONS(9525), 1,
      anon_sym_LBRACK,
    STATE(5368), 1,
      sym_trailing_return_type,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5701), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [252271] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5899), 1,
      anon_sym_LBRACK,
    ACTIONS(5921), 1,
      anon_sym___attribute,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    STATE(2187), 1,
      sym_parameter_list,
    STATE(6243), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5923), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_try,
  [252303] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    ACTIONS(10551), 1,
      anon_sym___attribute,
    STATE(2930), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10549), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [252333] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(7818), 1,
      anon_sym_LBRACE,
    ACTIONS(9395), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9495), 1,
      sym_identifier,
    STATE(3586), 1,
      sym_template_type,
    STATE(3907), 1,
      sym_enumerator_list,
    STATE(6510), 1,
      sym__scope_resolution,
    ACTIONS(10848), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(3601), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [252373] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5943), 1,
      anon_sym___asm,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10418), 1,
      anon_sym_LBRACK,
    STATE(5998), 1,
      sym_parameter_list,
    STATE(6263), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5945), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [252405] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(6065), 1,
      anon_sym_LBRACE,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9477), 1,
      sym_identifier,
    STATE(1766), 1,
      sym_template_type,
    STATE(2283), 1,
      sym_enumerator_list,
    STATE(6488), 1,
      sym__scope_resolution,
    ACTIONS(10850), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(4798), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [252445] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5909), 1,
      anon_sym___asm,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10418), 1,
      anon_sym_LBRACK,
    STATE(5998), 1,
      sym_parameter_list,
    STATE(6263), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5911), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [252477] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(7917), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8502), 1,
      anon_sym_LBRACE,
    ACTIONS(9471), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(4427), 1,
      sym_enumerator_list,
    STATE(6486), 1,
      sym__scope_resolution,
    ACTIONS(10852), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(4912), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [252517] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7982), 1,
      anon_sym_LBRACK,
    ACTIONS(10765), 1,
      anon_sym_COLON,
    ACTIONS(10830), 1,
      anon_sym_LBRACE,
    ACTIONS(10832), 1,
      anon_sym_EQ,
    ACTIONS(10834), 1,
      anon_sym_try,
    ACTIONS(10854), 1,
      anon_sym_SEMI,
    STATE(1675), 1,
      sym_compound_statement,
    STATE(7633), 1,
      sym_field_initializer_list,
    ACTIONS(4895), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(1676), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [252555] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7162), 1,
      anon_sym_requires,
    ACTIONS(7470), 1,
      anon_sym_DASH_GT,
    ACTIONS(9674), 1,
      anon_sym_LBRACK,
    STATE(5369), 1,
      sym_trailing_return_type,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5714), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9672), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [252589] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7330), 1,
      anon_sym_requires,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 6,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [252619] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7400), 1,
      anon_sym_requires,
    ACTIONS(9062), 1,
      anon_sym___attribute,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [252649] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6057), 1,
      anon_sym_LBRACK,
    ACTIONS(10816), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6059), 11,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_or,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [252673] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(7982), 1,
      anon_sym_LBRACK,
    ACTIONS(10765), 1,
      anon_sym_COLON,
    ACTIONS(10822), 1,
      anon_sym_EQ,
    ACTIONS(10824), 1,
      anon_sym_try,
    ACTIONS(10856), 1,
      anon_sym_SEMI,
    STATE(730), 1,
      sym_compound_statement,
    STATE(7588), 1,
      sym_field_initializer_list,
    ACTIONS(4895), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(731), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [252711] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(6802), 1,
      anon_sym_LBRACE,
    ACTIONS(7917), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9471), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(3609), 1,
      sym_enumerator_list,
    STATE(6486), 1,
      sym__scope_resolution,
    ACTIONS(10858), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(3928), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [252751] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(616), 1,
      anon_sym_LBRACE,
    ACTIONS(7982), 1,
      anon_sym_LBRACK,
    ACTIONS(10763), 1,
      anon_sym_EQ,
    ACTIONS(10765), 1,
      anon_sym_COLON,
    ACTIONS(10767), 1,
      anon_sym_try,
    ACTIONS(10860), 1,
      anon_sym_SEMI,
    STATE(611), 1,
      sym_compound_statement,
    STATE(7578), 1,
      sym_field_initializer_list,
    ACTIONS(4895), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(612), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [252789] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5891), 1,
      anon_sym___asm,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10418), 1,
      anon_sym_LBRACK,
    STATE(5998), 1,
      sym_parameter_list,
    STATE(6263), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5893), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [252821] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7400), 1,
      anon_sym_requires,
    ACTIONS(9211), 1,
      anon_sym___attribute,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5935), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [252851] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    ACTIONS(10608), 1,
      anon_sym___attribute,
    STATE(2930), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10606), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [252881] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6017), 1,
      anon_sym___asm,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10418), 1,
      anon_sym_LBRACK,
    STATE(5998), 1,
      sym_parameter_list,
    STATE(6263), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6019), 7,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [252913] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7470), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9137), 1,
      anon_sym_requires,
    STATE(5380), 1,
      sym_trailing_return_type,
    ACTIONS(9082), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [252947] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(4879), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6802), 1,
      anon_sym_LBRACE,
    ACTIONS(9497), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2835), 1,
      sym_enumerator_list,
    STATE(6511), 1,
      sym__scope_resolution,
    ACTIONS(10862), 2,
      anon_sym_class,
      anon_sym_struct,
    STATE(3257), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [252987] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7470), 1,
      anon_sym_DASH_GT,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(9233), 1,
      anon_sym_requires,
    STATE(5382), 1,
      sym_trailing_return_type,
    ACTIONS(9213), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [253021] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(10866), 1,
      anon_sym_EQ,
    STATE(2940), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    ACTIONS(10864), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6638), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [253061] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(10868), 1,
      anon_sym_EQ,
    STATE(2940), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    ACTIONS(10864), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    STATE(6638), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [253101] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7982), 1,
      anon_sym_LBRACK,
    ACTIONS(10765), 1,
      anon_sym_COLON,
    ACTIONS(10842), 1,
      anon_sym_LBRACE,
    ACTIONS(10844), 1,
      anon_sym_EQ,
    ACTIONS(10846), 1,
      anon_sym_try,
    ACTIONS(10870), 1,
      anon_sym_SEMI,
    STATE(1907), 1,
      sym_compound_statement,
    STATE(7612), 1,
      sym_field_initializer_list,
    ACTIONS(4895), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(1908), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [253139] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7470), 1,
      anon_sym_DASH_GT,
    ACTIONS(9525), 1,
      anon_sym_LBRACK,
    ACTIONS(9553), 1,
      anon_sym_requires,
    STATE(5337), 1,
      sym_trailing_return_type,
    ACTIONS(9527), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5701), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
  [253173] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    ACTIONS(10555), 1,
      anon_sym___attribute,
    STATE(2930), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10553), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [253203] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3766), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9471), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(6440), 1,
      sym_access_specifier,
    STATE(6476), 1,
      sym__scope_resolution,
    STATE(7357), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
    ACTIONS(10441), 3,
      anon_sym_public,
      anon_sym_private,
      anon_sym_protected,
  [253241] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5899), 1,
      anon_sym_LBRACK,
    ACTIONS(5943), 1,
      anon_sym___attribute,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    STATE(2187), 1,
      sym_parameter_list,
    STATE(6243), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(5945), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_try,
  [253273] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10872), 1,
      sym_identifier,
    ACTIONS(10874), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10878), 1,
      anon_sym_RBRACE,
    ACTIONS(10876), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7654), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8185), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6235), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [253306] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(7982), 1,
      anon_sym_LBRACK,
    ACTIONS(10765), 1,
      anon_sym_COLON,
    ACTIONS(10822), 1,
      anon_sym_EQ,
    ACTIONS(10824), 1,
      anon_sym_try,
    STATE(716), 1,
      sym_compound_statement,
    STATE(7478), 1,
      sym_field_initializer_list,
    ACTIONS(4895), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(717), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [253341] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10872), 1,
      sym_identifier,
    ACTIONS(10874), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10880), 1,
      anon_sym_RBRACE,
    ACTIONS(10876), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7528), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8562), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6237), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [253374] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10872), 1,
      sym_identifier,
    ACTIONS(10874), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10882), 1,
      anon_sym_RBRACE,
    ACTIONS(10876), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7444), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(7981), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6377), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [253407] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(4873), 1,
      anon_sym_STAR,
    ACTIONS(4875), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4877), 1,
      anon_sym_AMP,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6800), 1,
      sym__abstract_declarator,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [253442] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(2838), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10519), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [253469] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(10713), 1,
      anon_sym___attribute,
    STATE(2940), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10711), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT2,
  [253502] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10886), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(5635), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10884), 8,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [253527] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10872), 1,
      sym_identifier,
    ACTIONS(10874), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10888), 1,
      anon_sym_RBRACE,
    ACTIONS(10876), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7642), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8129), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6377), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [253560] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(2838), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10533), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [253587] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10523), 1,
      anon_sym___attribute,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3006), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10519), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [253616] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(2838), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10557), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [253643] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(10703), 1,
      anon_sym___attribute,
    STATE(2940), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10701), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT2,
  [253676] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10527), 1,
      anon_sym___attribute,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3006), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10525), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [253705] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10608), 1,
      anon_sym___attribute,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3006), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10606), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [253734] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10535), 1,
      anon_sym___attribute,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3006), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10533), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [253763] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10559), 1,
      anon_sym___attribute,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3006), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10557), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [253792] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(10892), 1,
      sym_identifier,
    ACTIONS(10894), 1,
      anon_sym_COLON_COLON,
    STATE(6222), 1,
      sym__scope_resolution,
    STATE(7071), 1,
      sym_field_initializer,
    STATE(7456), 1,
      sym_operator_name,
    STATE(6908), 2,
      sym_template_method,
      sym_qualified_field_identifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [253829] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7733), 1,
      anon_sym_DASH_GT,
    ACTIONS(7756), 1,
      anon_sym_requires,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    STATE(6372), 1,
      sym_trailing_return_type,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [253862] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(10894), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10896), 1,
      sym_identifier,
    ACTIONS(10898), 1,
      anon_sym_template,
    STATE(2331), 1,
      sym_dependent_field_identifier,
    STATE(2332), 1,
      sym_template_method,
    STATE(2359), 1,
      sym_qualified_field_identifier,
    STATE(6222), 1,
      sym__scope_resolution,
    STATE(7456), 1,
      sym_operator_name,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [253901] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(2838), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10606), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [253928] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10902), 1,
      anon_sym_LT,
    STATE(6298), 1,
      sym_template_argument_list,
    ACTIONS(10904), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(10900), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [253953] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(289), 1,
      anon_sym_LBRACE,
    ACTIONS(7982), 1,
      anon_sym_LBRACK,
    ACTIONS(10765), 1,
      anon_sym_COLON,
    ACTIONS(10797), 1,
      anon_sym_EQ,
    ACTIONS(10799), 1,
      anon_sym_try,
    STATE(342), 1,
      sym_compound_statement,
    STATE(7564), 1,
      sym_field_initializer_list,
    ACTIONS(4895), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(343), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [253988] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10872), 1,
      sym_identifier,
    ACTIONS(10874), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10906), 1,
      anon_sym_RBRACE,
    ACTIONS(10876), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7647), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8150), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6239), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [254021] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(644), 1,
      anon_sym_LBRACE,
    ACTIONS(7982), 1,
      anon_sym_LBRACK,
    ACTIONS(10765), 1,
      anon_sym_COLON,
    ACTIONS(10779), 1,
      anon_sym_EQ,
    ACTIONS(10781), 1,
      anon_sym_try,
    STATE(567), 1,
      sym_compound_statement,
    STATE(7510), 1,
      sym_field_initializer_list,
    ACTIONS(4895), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(568), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [254056] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10539), 1,
      anon_sym___attribute,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3006), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10537), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [254085] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10872), 1,
      sym_identifier,
    ACTIONS(10874), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10908), 1,
      anon_sym_RBRACE,
    ACTIONS(10876), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7536), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(7769), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6377), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [254118] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(10744), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10746), 1,
      anon_sym_template,
    ACTIONS(10910), 1,
      sym_identifier,
    STATE(3589), 1,
      sym_template_method,
    STATE(3591), 1,
      sym_dependent_field_identifier,
    STATE(3598), 1,
      sym_qualified_field_identifier,
    STATE(6230), 1,
      sym__scope_resolution,
    STATE(7431), 1,
      sym_operator_name,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [254157] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(2838), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10553), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [254184] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(2838), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10549), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [254211] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(10731), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10733), 1,
      anon_sym_template,
    ACTIONS(10912), 1,
      sym_identifier,
    STATE(2331), 1,
      sym_dependent_field_identifier,
    STATE(2332), 1,
      sym_template_method,
    STATE(2359), 1,
      sym_qualified_field_identifier,
    STATE(6233), 1,
      sym__scope_resolution,
    STATE(7530), 1,
      sym_operator_name,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [254250] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(2838), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10537), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [254277] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10872), 1,
      sym_identifier,
    ACTIONS(10874), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10914), 1,
      anon_sym_RBRACE,
    ACTIONS(10876), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7699), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8373), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6377), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [254310] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(644), 1,
      anon_sym_LBRACE,
    ACTIONS(7982), 1,
      anon_sym_LBRACK,
    ACTIONS(10765), 1,
      anon_sym_COLON,
    ACTIONS(10779), 1,
      anon_sym_EQ,
    ACTIONS(10781), 1,
      anon_sym_try,
    STATE(610), 1,
      sym_compound_statement,
    STATE(7544), 1,
      sym_field_initializer_list,
    ACTIONS(4895), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(618), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [254345] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10872), 1,
      sym_identifier,
    ACTIONS(10874), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10916), 1,
      anon_sym_RBRACE,
    ACTIONS(10876), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7554), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(7826), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6377), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [254378] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10456), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    STATE(5635), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10454), 8,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [254403] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10872), 1,
      sym_identifier,
    ACTIONS(10874), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10918), 1,
      anon_sym_RBRACE,
    ACTIONS(10876), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7664), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8222), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6377), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [254436] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(2838), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10525), 9,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [254463] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    ACTIONS(8284), 1,
      anon_sym_STAR,
    ACTIONS(8286), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8288), 1,
      anon_sym_AMP,
    STATE(3053), 1,
      sym_parameter_list,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6547), 1,
      sym__abstract_declarator,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [254498] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(10892), 1,
      sym_identifier,
    ACTIONS(10894), 1,
      anon_sym_COLON_COLON,
    STATE(6222), 1,
      sym__scope_resolution,
    STATE(7456), 1,
      sym_operator_name,
    STATE(7738), 1,
      sym_field_initializer,
    STATE(6908), 2,
      sym_template_method,
      sym_qualified_field_identifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [254535] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6149), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    STATE(5783), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6151), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACE,
      anon_sym_RBRACK,
      anon_sym_try,
  [254560] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10872), 1,
      sym_identifier,
    ACTIONS(10874), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10920), 1,
      anon_sym_RBRACE,
    ACTIONS(10876), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7454), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8312), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6260), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [254593] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7733), 1,
      anon_sym_DASH_GT,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9326), 1,
      anon_sym_requires,
    STATE(6388), 1,
      sym_trailing_return_type,
    ACTIONS(9082), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [254626] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7733), 1,
      anon_sym_DASH_GT,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(9533), 1,
      anon_sym_requires,
    STATE(6391), 1,
      sym_trailing_return_type,
    ACTIONS(9213), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [254659] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10872), 1,
      sym_identifier,
    ACTIONS(10874), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10922), 1,
      anon_sym_RBRACE,
    ACTIONS(10876), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7621), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8060), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6264), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [254692] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(616), 1,
      anon_sym_LBRACE,
    ACTIONS(7982), 1,
      anon_sym_LBRACK,
    ACTIONS(10763), 1,
      anon_sym_EQ,
    ACTIONS(10765), 1,
      anon_sym_COLON,
    ACTIONS(10767), 1,
      anon_sym_try,
    STATE(611), 1,
      sym_compound_statement,
    STATE(7578), 1,
      sym_field_initializer_list,
    ACTIONS(4895), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(612), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [254727] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4871), 1,
      anon_sym_LPAREN2,
    ACTIONS(4873), 1,
      anon_sym_STAR,
    ACTIONS(4875), 1,
      anon_sym_AMP_AMP,
    ACTIONS(4877), 1,
      anon_sym_AMP,
    ACTIONS(7978), 1,
      anon_sym_LBRACK,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(5919), 1,
      sym__function_declarator_seq,
    STATE(6789), 1,
      sym__abstract_declarator,
    STATE(5942), 5,
      sym_abstract_parenthesized_declarator,
      sym_abstract_pointer_declarator,
      sym_abstract_function_declarator,
      sym_abstract_array_declarator,
      sym_abstract_reference_declarator,
  [254762] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(4420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9991), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10924), 1,
      sym_identifier,
    STATE(5700), 1,
      sym__scope_resolution,
    ACTIONS(4422), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    STATE(7439), 2,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [254797] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7733), 1,
      anon_sym_DASH_GT,
    ACTIONS(9525), 1,
      anon_sym_LBRACK,
    ACTIONS(9627), 1,
      anon_sym_requires,
    STATE(6393), 1,
      sym_trailing_return_type,
    ACTIONS(9527), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5701), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [254830] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(10717), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10719), 1,
      anon_sym_template,
    ACTIONS(10912), 1,
      sym_identifier,
    STATE(2331), 1,
      sym_dependent_field_identifier,
    STATE(2332), 1,
      sym_template_method,
    STATE(2359), 1,
      sym_qualified_field_identifier,
    STATE(6252), 1,
      sym__scope_resolution,
    STATE(7484), 1,
      sym_operator_name,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [254869] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10872), 1,
      sym_identifier,
    ACTIONS(10874), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10926), 1,
      anon_sym_RBRACE,
    ACTIONS(10876), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7708), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8427), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6206), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [254902] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(10707), 1,
      anon_sym___attribute,
    STATE(2940), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10705), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT2,
  [254935] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(289), 1,
      anon_sym_LBRACE,
    ACTIONS(7982), 1,
      anon_sym_LBRACK,
    ACTIONS(10765), 1,
      anon_sym_COLON,
    ACTIONS(10797), 1,
      anon_sym_EQ,
    ACTIONS(10799), 1,
      anon_sym_try,
    STATE(297), 1,
      sym_compound_statement,
    STATE(7693), 1,
      sym_field_initializer_list,
    ACTIONS(4895), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(298), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [254970] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7733), 1,
      anon_sym_DASH_GT,
    ACTIONS(9674), 1,
      anon_sym_LBRACK,
    ACTIONS(10928), 1,
      anon_sym_requires,
    STATE(6394), 1,
      sym_trailing_return_type,
    ACTIONS(9676), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5714), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9672), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [255003] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(10659), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10661), 1,
      anon_sym_template,
    ACTIONS(10931), 1,
      sym_identifier,
    STATE(3408), 1,
      sym_dependent_field_identifier,
    STATE(3409), 1,
      sym_qualified_field_identifier,
    STATE(3494), 1,
      sym_template_method,
    STATE(6257), 1,
      sym__scope_resolution,
    STATE(7677), 1,
      sym_operator_name,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [255042] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10551), 1,
      anon_sym___attribute,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3006), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10549), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [255071] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10872), 1,
      sym_identifier,
    ACTIONS(10874), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10933), 1,
      anon_sym_RBRACE,
    ACTIONS(10876), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7636), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8282), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6377), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [255104] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10872), 1,
      sym_identifier,
    ACTIONS(10874), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10935), 1,
      anon_sym_RBRACE,
    ACTIONS(10876), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7462), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(7807), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6377), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [255137] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10555), 1,
      anon_sym___attribute,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3006), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10553), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [255166] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10872), 1,
      sym_identifier,
    ACTIONS(10874), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10937), 1,
      anon_sym_RBRACE,
    ACTIONS(10876), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7474), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(7919), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6229), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [255199] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6149), 2,
      anon_sym_LBRACK,
      anon_sym___asm,
    STATE(5635), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(6151), 8,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_asm,
      anon_sym___asm__,
  [255224] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10872), 1,
      sym_identifier,
    ACTIONS(10874), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10939), 1,
      anon_sym_RBRACE,
    ACTIONS(10876), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7719), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8489), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6377), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [255257] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10872), 1,
      sym_identifier,
    ACTIONS(10874), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10941), 1,
      anon_sym_RBRACE,
    ACTIONS(10876), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7457), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8403), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6211), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [255290] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10902), 1,
      anon_sym_LT,
    STATE(6316), 1,
      sym_template_argument_list,
    ACTIONS(10945), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(10943), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [255315] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10872), 1,
      sym_identifier,
    ACTIONS(10874), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10947), 1,
      anon_sym_RBRACE,
    ACTIONS(10876), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7644), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8167), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6377), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [255348] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(616), 1,
      anon_sym_LBRACE,
    ACTIONS(7982), 1,
      anon_sym_LBRACK,
    ACTIONS(10763), 1,
      anon_sym_EQ,
    ACTIONS(10765), 1,
      anon_sym_COLON,
    ACTIONS(10767), 1,
      anon_sym_try,
    STATE(559), 1,
      sym_compound_statement,
    STATE(7584), 1,
      sym_field_initializer_list,
    ACTIONS(4895), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(601), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [255383] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(10699), 1,
      anon_sym___attribute,
    STATE(2940), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10697), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT2,
  [255416] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10872), 1,
      sym_identifier,
    ACTIONS(10874), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10949), 1,
      anon_sym_RBRACE,
    ACTIONS(10876), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7733), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8521), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6259), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [255449] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(7982), 1,
      anon_sym_LBRACK,
    ACTIONS(10765), 1,
      anon_sym_COLON,
    ACTIONS(10822), 1,
      anon_sym_EQ,
    ACTIONS(10824), 1,
      anon_sym_try,
    STATE(730), 1,
      sym_compound_statement,
    STATE(7588), 1,
      sym_field_initializer_list,
    ACTIONS(4895), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
    STATE(731), 4,
      sym_constructor_try_statement,
      sym_default_method_clause,
      sym_delete_method_clause,
      sym_pure_virtual_clause,
  [255484] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7733), 1,
      anon_sym_DASH_GT,
    ACTIONS(7756), 1,
      anon_sym_requires,
    ACTIONS(9525), 1,
      anon_sym_LBRACK,
    STATE(6373), 1,
      sym_trailing_return_type,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5701), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [255517] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7733), 1,
      anon_sym_DASH_GT,
    ACTIONS(7756), 1,
      anon_sym_requires,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    STATE(6369), 1,
      sym_trailing_return_type,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [255550] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7733), 1,
      anon_sym_DASH_GT,
    ACTIONS(7756), 1,
      anon_sym_requires,
    ACTIONS(9674), 1,
      anon_sym_LBRACK,
    STATE(6374), 1,
      sym_trailing_return_type,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5714), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9672), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [255583] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(10723), 1,
      anon_sym___attribute,
    STATE(2940), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10721), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT2,
  [255616] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(17), 1,
      sym_preproc_directive,
    ACTIONS(10872), 1,
      sym_identifier,
    ACTIONS(10874), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(10951), 1,
      anon_sym_RBRACE,
    ACTIONS(10876), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7481), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(8007), 2,
      sym_preproc_if_in_enumerator_list_no_comma,
      sym_preproc_ifdef_in_enumerator_list_no_comma,
    STATE(6267), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [255649] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10955), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(10953), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [255669] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(2982), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10549), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [255695] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(6065), 1,
      anon_sym_LBRACE,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9477), 1,
      sym_identifier,
    STATE(1766), 1,
      sym_template_type,
    STATE(2288), 1,
      sym_enumerator_list,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(4837), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [255731] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5838), 1,
      anon_sym_LBRACE,
    ACTIONS(9254), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9479), 1,
      sym_identifier,
    STATE(1883), 1,
      sym_template_type,
    STATE(2138), 1,
      sym_enumerator_list,
    STATE(6506), 1,
      sym__scope_resolution,
    STATE(2268), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [255767] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(6882), 1,
      anon_sym_LBRACE,
    ACTIONS(9439), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9487), 1,
      sym_identifier,
    STATE(2773), 1,
      sym_template_type,
    STATE(2969), 1,
      sym_enumerator_list,
    STATE(6477), 1,
      sym__scope_resolution,
    STATE(2789), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [255803] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(2982), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10537), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [255829] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(7881), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8502), 1,
      anon_sym_LBRACE,
    ACTIONS(9489), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(4437), 1,
      sym_enumerator_list,
    STATE(6504), 1,
      sym__scope_resolution,
    STATE(4219), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [255865] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(6705), 1,
      anon_sym_LBRACE,
    ACTIONS(9306), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9491), 1,
      sym_identifier,
    STATE(2632), 1,
      sym_template_type,
    STATE(2804), 1,
      sym_enumerator_list,
    STATE(6487), 1,
      sym__scope_resolution,
    STATE(2633), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [255901] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10945), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(10943), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [255921] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6802), 1,
      anon_sym_LBRACE,
    ACTIONS(9469), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2885), 1,
      sym_enumerator_list,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(2954), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [255957] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(6802), 1,
      anon_sym_LBRACE,
    ACTIONS(7881), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9489), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(3613), 1,
      sym_enumerator_list,
    STATE(6504), 1,
      sym__scope_resolution,
    STATE(6424), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [255993] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(7853), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8832), 1,
      anon_sym_LBRACE,
    ACTIONS(9493), 1,
      sym_identifier,
    STATE(4327), 1,
      sym_template_type,
    STATE(4816), 1,
      sym_enumerator_list,
    STATE(6508), 1,
      sym__scope_resolution,
    STATE(4408), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [256029] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(7818), 1,
      anon_sym_LBRACE,
    ACTIONS(9395), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9495), 1,
      sym_identifier,
    STATE(3586), 1,
      sym_template_type,
    STATE(3920), 1,
      sym_enumerator_list,
    STATE(6510), 1,
      sym__scope_resolution,
    STATE(3625), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [256065] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(7917), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8502), 1,
      anon_sym_LBRACE,
    ACTIONS(9471), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(4437), 1,
      sym_enumerator_list,
    STATE(6486), 1,
      sym__scope_resolution,
    STATE(4920), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [256101] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(6802), 1,
      anon_sym_LBRACE,
    ACTIONS(7917), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9471), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(3613), 1,
      sym_enumerator_list,
    STATE(6486), 1,
      sym__scope_resolution,
    STATE(3883), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [256137] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(6065), 1,
      anon_sym_LBRACE,
    ACTIONS(7833), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9467), 1,
      sym_identifier,
    STATE(1766), 1,
      sym_template_type,
    STATE(5091), 1,
      sym_enumerator_list,
    STATE(6513), 1,
      sym__scope_resolution,
    STATE(4824), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [256173] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(4879), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6802), 1,
      anon_sym_LBRACE,
    ACTIONS(9497), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(2885), 1,
      sym_enumerator_list,
    STATE(6511), 1,
      sym__scope_resolution,
    STATE(3259), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [256209] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(6065), 1,
      anon_sym_LBRACE,
    ACTIONS(9359), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9473), 1,
      sym_identifier,
    STATE(1766), 1,
      sym_template_type,
    STATE(2288), 1,
      sym_enumerator_list,
    STATE(6490), 1,
      sym__scope_resolution,
    STATE(3847), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [256245] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(2982), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10557), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [256271] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5838), 1,
      anon_sym_LBRACE,
    ACTIONS(9254), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9479), 1,
      sym_identifier,
    STATE(1883), 1,
      sym_template_type,
    STATE(2138), 1,
      sym_enumerator_list,
    STATE(6506), 1,
      sym__scope_resolution,
    STATE(2379), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [256307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10959), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(10957), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [256327] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6188), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(6190), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [256347] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10963), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(10961), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [256367] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10967), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(10965), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [256387] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(2982), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10533), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [256413] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7326), 1,
      anon_sym_requires,
    ACTIONS(7720), 1,
      anon_sym_DASH_GT,
    STATE(5965), 1,
      sym_trailing_return_type,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [256443] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7326), 1,
      anon_sym_requires,
    ACTIONS(7720), 1,
      anon_sym_DASH_GT,
    STATE(5936), 1,
      sym_trailing_return_type,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5935), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [256473] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7326), 1,
      anon_sym_requires,
    ACTIONS(7720), 1,
      anon_sym_DASH_GT,
    STATE(5993), 1,
      sym_trailing_return_type,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5991), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [256503] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7326), 1,
      anon_sym_requires,
    ACTIONS(7720), 1,
      anon_sym_DASH_GT,
    STATE(5902), 1,
      sym_trailing_return_type,
    ACTIONS(7282), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5897), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9672), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [256533] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10971), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(10969), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [256553] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(6802), 1,
      anon_sym_LBRACE,
    ACTIONS(9469), 1,
      sym_identifier,
    ACTIONS(9481), 1,
      anon_sym_COLON_COLON,
    STATE(2158), 1,
      sym_template_type,
    STATE(2885), 1,
      sym_enumerator_list,
    STATE(6509), 1,
      sym__scope_resolution,
    STATE(4019), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [256589] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7946), 6,
      anon_sym_AMP,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
    ACTIONS(7948), 6,
      anon_sym_LPAREN2,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
  [256609] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10975), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(10973), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [256629] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7720), 1,
      anon_sym_DASH_GT,
    ACTIONS(9150), 1,
      anon_sym_requires,
    STATE(5931), 1,
      sym_trailing_return_type,
    ACTIONS(9147), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5964), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [256659] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7720), 1,
      anon_sym_DASH_GT,
    ACTIONS(9277), 1,
      anon_sym_requires,
    STATE(6008), 1,
      sym_trailing_return_type,
    ACTIONS(9274), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5935), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [256689] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(6802), 1,
      anon_sym_LBRACE,
    ACTIONS(7881), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9489), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(3613), 1,
      sym_enumerator_list,
    STATE(6504), 1,
      sym__scope_resolution,
    STATE(4161), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [256725] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7720), 1,
      anon_sym_DASH_GT,
    ACTIONS(9571), 1,
      anon_sym_requires,
    STATE(5967), 1,
      sym_trailing_return_type,
    ACTIONS(9562), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5991), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [256755] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7720), 1,
      anon_sym_DASH_GT,
    ACTIONS(10626), 1,
      anon_sym_requires,
    STATE(5994), 1,
      sym_trailing_return_type,
    ACTIONS(10425), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5805), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5897), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9672), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
      anon_sym_COLON,
  [256785] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(6581), 1,
      anon_sym_LBRACE,
    ACTIONS(7875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9483), 1,
      sym_identifier,
    STATE(2532), 1,
      sym_template_type,
    STATE(2542), 1,
      sym_enumerator_list,
    STATE(6528), 1,
      sym__scope_resolution,
    STATE(4842), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [256821] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6259), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(6261), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [256841] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(5893), 2,
      sym_string_literal,
      sym_raw_string_literal,
    ACTIONS(10492), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
    ACTIONS(10494), 5,
      anon_sym_R_DQUOTE,
      anon_sym_LR_DQUOTE,
      anon_sym_uR_DQUOTE,
      anon_sym_UR_DQUOTE,
      anon_sym_u8R_DQUOTE,
  [256863] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(2982), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10606), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [256889] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(2982), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10553), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [256915] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(6581), 1,
      anon_sym_LBRACE,
    ACTIONS(9282), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9485), 1,
      sym_identifier,
    STATE(2532), 1,
      sym_template_type,
    STATE(2542), 1,
      sym_enumerator_list,
    STATE(6500), 1,
      sym__scope_resolution,
    STATE(3982), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [256951] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(6661), 1,
      anon_sym_LBRACE,
    ACTIONS(9334), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9475), 1,
      sym_identifier,
    STATE(2562), 1,
      sym_template_type,
    STATE(2724), 1,
      sym_enumerator_list,
    STATE(6507), 1,
      sym__scope_resolution,
    STATE(2559), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [256987] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(2982), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10519), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [257013] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(2982), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10525), 8,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [257039] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10979), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(10977), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [257059] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9650), 1,
      anon_sym_try,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(10789), 1,
      anon_sym_LBRACE,
    STATE(2042), 1,
      sym_compound_statement,
    STATE(2043), 1,
      sym_try_statement,
    STATE(3064), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [257094] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(2998), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10606), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [257119] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4826), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(4828), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [257138] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10608), 1,
      anon_sym___attribute,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3249), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10606), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [257165] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4810), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(4812), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [257184] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(10350), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10981), 1,
      sym_identifier,
    STATE(5740), 1,
      sym__scope_resolution,
    STATE(8061), 1,
      sym_qualified_identifier,
    ACTIONS(10983), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [257215] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(2931), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10606), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [257240] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(616), 1,
      anon_sym_LBRACE,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(9857), 1,
      anon_sym_try,
    STATE(650), 1,
      sym_compound_statement,
    STATE(653), 1,
      sym_try_statement,
    STATE(3064), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [257275] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9658), 1,
      anon_sym_try,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(10830), 1,
      anon_sym_LBRACE,
    STATE(1714), 1,
      sym_compound_statement,
    STATE(1715), 1,
      sym_try_statement,
    STATE(3064), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [257310] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3766), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9471), 1,
      sym_identifier,
    ACTIONS(10985), 1,
      anon_sym_virtual,
    STATE(2158), 1,
      sym_template_type,
    STATE(6476), 1,
      sym__scope_resolution,
    STATE(6828), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [257343] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4818), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(4820), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [257362] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4822), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(4824), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [257381] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    STATE(3064), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10721), 4,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [257410] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(10350), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10987), 1,
      sym_identifier,
    STATE(5740), 1,
      sym__scope_resolution,
    STATE(8479), 1,
      sym_qualified_identifier,
    ACTIONS(10989), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [257441] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9642), 1,
      anon_sym_try,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(10842), 1,
      anon_sym_LBRACE,
    STATE(1918), 1,
      sym_compound_statement,
    STATE(1919), 1,
      sym_try_statement,
    STATE(3064), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [257476] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9642), 1,
      anon_sym_try,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(10842), 1,
      anon_sym_LBRACE,
    STATE(1920), 1,
      sym_compound_statement,
    STATE(1921), 1,
      sym_try_statement,
    STATE(3064), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [257511] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    STATE(3064), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10697), 4,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [257540] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10673), 1,
      sym_identifier,
    ACTIONS(10991), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10993), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(10995), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(10997), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(6360), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(7877), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [257569] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10673), 1,
      sym_identifier,
    ACTIONS(10993), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(10995), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(10999), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10997), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(6563), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(7893), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [257598] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(2931), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10519), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [257623] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(2931), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10525), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [257648] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10535), 1,
      anon_sym___attribute,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3249), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10533), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [257675] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10539), 1,
      anon_sym___attribute,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3249), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10537), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [257702] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(2998), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10533), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [257727] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(2998), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10537), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [257752] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9642), 1,
      anon_sym_try,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(10842), 1,
      anon_sym_LBRACE,
    STATE(1932), 1,
      sym_compound_statement,
    STATE(1933), 1,
      sym_try_statement,
    STATE(3064), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [257787] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(2931), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10549), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [257812] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10555), 1,
      anon_sym___attribute,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3249), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10553), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [257839] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(9983), 1,
      anon_sym_try,
    STATE(705), 1,
      sym_compound_statement,
    STATE(706), 1,
      sym_try_statement,
    STATE(3064), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [257874] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(2931), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10557), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [257899] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3766), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9471), 1,
      sym_identifier,
    ACTIONS(11001), 1,
      anon_sym_virtual,
    STATE(2158), 1,
      sym_template_type,
    STATE(6476), 1,
      sym__scope_resolution,
    STATE(7357), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [257932] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(10350), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11003), 1,
      sym_identifier,
    STATE(5740), 1,
      sym__scope_resolution,
    STATE(8040), 1,
      sym_qualified_identifier,
    ACTIONS(11005), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [257963] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9650), 1,
      anon_sym_try,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(10789), 1,
      anon_sym_LBRACE,
    STATE(2035), 1,
      sym_compound_statement,
    STATE(2036), 1,
      sym_try_statement,
    STATE(3064), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [257998] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9650), 1,
      anon_sym_try,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(10789), 1,
      anon_sym_LBRACE,
    STATE(2037), 1,
      sym_compound_statement,
    STATE(2038), 1,
      sym_try_statement,
    STATE(3064), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [258033] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3766), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9471), 1,
      sym_identifier,
    ACTIONS(11007), 1,
      anon_sym_virtual,
    STATE(2158), 1,
      sym_template_type,
    STATE(6476), 1,
      sym__scope_resolution,
    STATE(7190), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [258066] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10673), 1,
      sym_identifier,
    ACTIONS(10993), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(10995), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11009), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10997), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(6563), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(8023), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [258095] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(2998), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10519), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [258120] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(2998), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10525), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [258145] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7756), 1,
      anon_sym_requires,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [258172] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10675), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10872), 1,
      sym_identifier,
    ACTIONS(11011), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11013), 1,
      aux_sym_preproc_elif_token1,
    STATE(6381), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(7960), 1,
      sym_enumerator,
    ACTIONS(11015), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(7929), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [258203] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10535), 1,
      anon_sym___attribute,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3221), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10533), 6,
      anon_sym_COMMA,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [258230] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10539), 1,
      anon_sym___attribute,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3221), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10537), 6,
      anon_sym_COMMA,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [258257] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    STATE(3064), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10705), 4,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [258286] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10673), 1,
      sym_identifier,
    ACTIONS(10993), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(10995), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11017), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10997), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(6563), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(8280), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [258315] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7756), 1,
      anon_sym_requires,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [258342] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(2931), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10533), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [258367] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(2931), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10537), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [258392] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7756), 1,
      anon_sym_requires,
    ACTIONS(9525), 1,
      anon_sym_LBRACK,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5701), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [258419] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7756), 1,
      anon_sym_requires,
    ACTIONS(9674), 1,
      anon_sym_LBRACK,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5714), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9672), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [258446] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7756), 1,
      anon_sym_requires,
    ACTIONS(9762), 1,
      anon_sym_LBRACK,
    ACTIONS(5880), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5773), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9760), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [258473] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10673), 1,
      sym_identifier,
    ACTIONS(10993), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(10995), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11019), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10997), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(6343), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(7892), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [258502] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    STATE(3064), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10711), 4,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [258531] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11021), 1,
      sym_identifier,
    ACTIONS(11024), 1,
      aux_sym_preproc_if_token1,
    ACTIONS(11030), 1,
      sym_preproc_directive,
    ACTIONS(11033), 1,
      anon_sym_RBRACE,
    ACTIONS(11027), 2,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
    STATE(7855), 2,
      sym_preproc_call,
      sym_enumerator,
    STATE(6377), 3,
      sym_preproc_if_in_enumerator_list,
      sym_preproc_ifdef_in_enumerator_list,
      aux_sym_enumerator_list_repeat1,
  [258560] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10872), 1,
      sym_identifier,
    ACTIONS(11011), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11013), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11035), 1,
      aux_sym_preproc_if_token2,
    STATE(6430), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(7960), 1,
      sym_enumerator,
    ACTIONS(11015), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8273), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [258591] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(644), 1,
      anon_sym_LBRACE,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(9941), 1,
      anon_sym_try,
    STATE(661), 1,
      sym_compound_statement,
    STATE(665), 1,
      sym_try_statement,
    STATE(3064), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [258626] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10608), 1,
      anon_sym___attribute,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3221), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10606), 6,
      anon_sym_COMMA,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [258653] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10872), 1,
      sym_identifier,
    ACTIONS(11011), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11013), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11037), 1,
      aux_sym_preproc_if_token2,
    STATE(6551), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(7960), 1,
      sym_enumerator,
    ACTIONS(11015), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8209), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [258684] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(644), 1,
      anon_sym_LBRACE,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(9941), 1,
      anon_sym_try,
    STATE(666), 1,
      sym_compound_statement,
    STATE(670), 1,
      sym_try_statement,
    STATE(3064), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [258719] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(2931), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10553), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_try,
      anon_sym_requires,
  [258744] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3766), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9471), 1,
      sym_identifier,
    ACTIONS(11039), 1,
      anon_sym_virtual,
    STATE(2158), 1,
      sym_template_type,
    STATE(6476), 1,
      sym__scope_resolution,
    STATE(6978), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [258777] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(2998), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10557), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [258802] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5899), 1,
      anon_sym_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(11041), 1,
      anon_sym_COMMA,
    ACTIONS(11045), 1,
      anon_sym___attribute,
    STATE(2187), 1,
      sym_parameter_list,
    STATE(6792), 1,
      aux_sym__type_definition_declarators_repeat1,
    ACTIONS(11043), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
    STATE(6243), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [258835] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9062), 1,
      anon_sym_LBRACK,
    ACTIONS(9326), 1,
      anon_sym_requires,
    ACTIONS(9082), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5748), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9051), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [258862] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9211), 1,
      anon_sym_LBRACK,
    ACTIONS(9533), 1,
      anon_sym_requires,
    ACTIONS(9213), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5777), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9200), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [258889] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10523), 1,
      anon_sym___attribute,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3221), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10519), 6,
      anon_sym_COMMA,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [258916] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10527), 1,
      anon_sym___attribute,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3221), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10525), 6,
      anon_sym_COMMA,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [258943] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9525), 1,
      anon_sym_LBRACK,
    ACTIONS(9627), 1,
      anon_sym_requires,
    ACTIONS(9527), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5701), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9514), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [258970] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9658), 1,
      anon_sym_try,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(10830), 1,
      anon_sym_LBRACE,
    STATE(1729), 1,
      sym_compound_statement,
    STATE(1730), 1,
      sym_try_statement,
    STATE(3064), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [259005] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9674), 1,
      anon_sym_LBRACK,
    ACTIONS(10928), 1,
      anon_sym_requires,
    ACTIONS(9676), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5714), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9672), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [259032] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9762), 1,
      anon_sym_LBRACK,
    ACTIONS(11047), 1,
      anon_sym_requires,
    ACTIONS(9796), 2,
      anon_sym_final,
      anon_sym_override,
    STATE(5409), 2,
      sym_virtual_specifier,
      aux_sym__function_postfix_repeat1,
    STATE(5773), 2,
      sym__function_postfix,
      sym_requires_clause,
    ACTIONS(9760), 3,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [259059] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10551), 1,
      anon_sym___attribute,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3221), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10549), 6,
      anon_sym_COMMA,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [259086] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6092), 1,
      anon_sym_LBRACK,
    ACTIONS(11050), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(11052), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6094), 6,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [259109] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10559), 1,
      anon_sym___attribute,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3221), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10557), 6,
      anon_sym_COMMA,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [259136] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(616), 1,
      anon_sym_LBRACE,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(9857), 1,
      anon_sym_try,
    STATE(642), 1,
      sym_compound_statement,
    STATE(644), 1,
      sym_try_statement,
    STATE(3064), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [259171] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(2998), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10553), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [259196] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10555), 1,
      anon_sym___attribute,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3221), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10553), 6,
      anon_sym_COMMA,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [259223] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(10350), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11054), 1,
      sym_identifier,
    STATE(5740), 1,
      sym__scope_resolution,
    STATE(8162), 1,
      sym_qualified_identifier,
    ACTIONS(11056), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [259254] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10872), 1,
      sym_identifier,
    ACTIONS(11011), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11013), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11058), 1,
      aux_sym_preproc_if_token2,
    STATE(6551), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(7960), 1,
      sym_enumerator,
    ACTIONS(11015), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(7933), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [259285] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(616), 1,
      anon_sym_LBRACE,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(9857), 1,
      anon_sym_try,
    STATE(654), 1,
      sym_compound_statement,
    STATE(655), 1,
      sym_try_statement,
    STATE(3064), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [259320] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(289), 1,
      anon_sym_LBRACE,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(9951), 1,
      anon_sym_try,
    STATE(323), 1,
      sym_compound_statement,
    STATE(324), 1,
      sym_try_statement,
    STATE(3064), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [259355] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10673), 1,
      sym_identifier,
    ACTIONS(10993), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(10995), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11060), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10997), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(6563), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    STATE(8149), 3,
      sym_preproc_else_in_enumerator_list_no_comma,
      sym_preproc_elif_in_enumerator_list_no_comma,
      sym_preproc_elifdef_in_enumerator_list_no_comma,
  [259384] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(9983), 1,
      anon_sym_try,
    STATE(753), 1,
      sym_compound_statement,
    STATE(756), 1,
      sym_try_statement,
    STATE(3064), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [259419] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6057), 1,
      anon_sym_LBRACK,
    ACTIONS(11052), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6059), 8,
      anon_sym_LPAREN2,
      anon_sym_PIPE_PIPE,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [259440] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(9983), 1,
      anon_sym_try,
    STATE(751), 1,
      sym_compound_statement,
    STATE(752), 1,
      sym_try_statement,
    STATE(3064), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [259475] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(289), 1,
      anon_sym_LBRACE,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(9951), 1,
      anon_sym_try,
    STATE(327), 1,
      sym_compound_statement,
    STATE(328), 1,
      sym_try_statement,
    STATE(3064), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [259510] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(10350), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11062), 1,
      sym_identifier,
    STATE(5740), 1,
      sym__scope_resolution,
    STATE(7802), 1,
      sym_qualified_identifier,
    ACTIONS(11064), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [259541] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10523), 1,
      anon_sym___attribute,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3249), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10519), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [259568] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10527), 1,
      anon_sym___attribute,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3249), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10525), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [259595] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10551), 1,
      anon_sym___attribute,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3249), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10549), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [259622] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(10350), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11066), 1,
      sym_identifier,
    STATE(5740), 1,
      sym__scope_resolution,
    STATE(8225), 1,
      sym_qualified_identifier,
    ACTIONS(11068), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [259653] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10559), 1,
      anon_sym___attribute,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3249), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10557), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [259680] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(644), 1,
      anon_sym_LBRACE,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(9941), 1,
      anon_sym_try,
    STATE(651), 1,
      sym_compound_statement,
    STATE(657), 1,
      sym_try_statement,
    STATE(3064), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [259715] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    STATE(3064), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(10701), 4,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_try,
  [259744] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10872), 1,
      sym_identifier,
    ACTIONS(11011), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11013), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11070), 1,
      aux_sym_preproc_if_token2,
    STATE(6402), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(7960), 1,
      sym_enumerator,
    ACTIONS(11015), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(7818), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [259775] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4814), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(4816), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [259794] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4830), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(4832), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [259813] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4834), 2,
      anon_sym___attribute,
      anon_sym_LBRACK,
    ACTIONS(4836), 9,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_try,
  [259832] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(4420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9991), 1,
      anon_sym_COLON_COLON,
    ACTIONS(10924), 1,
      sym_identifier,
    STATE(5700), 1,
      sym__scope_resolution,
    STATE(7439), 2,
      sym_identifier_parameter_pack_expansion,
      sym_qualified_identifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [259863] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6802), 1,
      anon_sym_LBRACE,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(11072), 1,
      anon_sym_COLON,
    STATE(2401), 1,
      sym_attribute_specifier,
    STATE(3466), 1,
      sym__enum_base_clause,
    STATE(3615), 1,
      sym_enumerator_list,
    ACTIONS(6247), 4,
      anon_sym_COMMA,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [259894] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(6802), 1,
      anon_sym_LBRACE,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(11072), 1,
      anon_sym_COLON,
    STATE(2420), 1,
      sym_attribute_specifier,
    STATE(3467), 1,
      sym__enum_base_clause,
    STATE(3618), 1,
      sym_enumerator_list,
    ACTIONS(6163), 4,
      anon_sym_COMMA,
      sym_auto,
      anon_sym_decltype,
      anon_sym_GT2,
  [259925] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9658), 1,
      anon_sym_try,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(10830), 1,
      anon_sym_LBRACE,
    STATE(1712), 1,
      sym_compound_statement,
    STATE(1713), 1,
      sym_try_statement,
    STATE(3064), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [259960] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10687), 1,
      aux_sym_preproc_if_token2,
    ACTIONS(10872), 1,
      sym_identifier,
    ACTIONS(11011), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11013), 1,
      aux_sym_preproc_elif_token1,
    STATE(6428), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(7960), 1,
      sym_enumerator,
    ACTIONS(11015), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(7829), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [259991] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(289), 1,
      anon_sym_LBRACE,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(9951), 1,
      anon_sym_try,
    STATE(276), 1,
      sym_compound_statement,
    STATE(277), 1,
      sym_try_statement,
    STATE(3064), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [260026] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10872), 1,
      sym_identifier,
    ACTIONS(11011), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11013), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11074), 1,
      aux_sym_preproc_if_token2,
    STATE(6551), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(7960), 1,
      sym_enumerator,
    ACTIONS(11015), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(7972), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [260057] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(10350), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11076), 1,
      sym_identifier,
    STATE(5740), 1,
      sym__scope_resolution,
    STATE(8223), 1,
      sym_qualified_identifier,
    ACTIONS(11078), 2,
      anon_sym_enum,
      anon_sym_namespace,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [260088] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10872), 1,
      sym_identifier,
    ACTIONS(11011), 1,
      aux_sym_preproc_else_token1,
    ACTIONS(11013), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11080), 1,
      aux_sym_preproc_if_token2,
    STATE(6551), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(7960), 1,
      sym_enumerator,
    ACTIONS(11015), 2,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
    STATE(8262), 3,
      sym_preproc_else_in_enumerator_list,
      sym_preproc_elif_in_enumerator_list,
      sym_preproc_elifdef_in_enumerator_list,
  [260119] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(2998), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10549), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [260144] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3166), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10864), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
    STATE(6640), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [260174] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11086), 1,
      anon_sym_delete,
    ACTIONS(11088), 1,
      anon_sym_new,
    ACTIONS(11084), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11082), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [260196] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11090), 1,
      anon_sym_delete,
    ACTIONS(11092), 1,
      anon_sym_new,
    ACTIONS(11084), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11082), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [260218] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3766), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9471), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(6476), 1,
      sym__scope_resolution,
    STATE(7357), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [260248] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(11094), 1,
      sym_identifier,
    ACTIONS(11096), 1,
      anon_sym_COLON_COLON,
    STATE(2693), 1,
      sym_template_type,
    STATE(6494), 1,
      sym__scope_resolution,
    STATE(2674), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [260278] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3766), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9471), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(6476), 1,
      sym__scope_resolution,
    STATE(6978), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [260308] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10527), 1,
      anon_sym___attribute,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3005), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10525), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT2,
  [260334] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11100), 1,
      anon_sym_LBRACK,
    STATE(6837), 1,
      sym_gnu_asm_input_operand,
    STATE(7920), 1,
      sym_string_literal,
    ACTIONS(11098), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(117), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [260358] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3766), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9471), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(6476), 1,
      sym__scope_resolution,
    STATE(7249), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [260388] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5899), 1,
      anon_sym_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(11104), 1,
      anon_sym___attribute,
    STATE(2187), 1,
      sym_parameter_list,
    STATE(6243), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
    ACTIONS(11102), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [260416] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11088), 1,
      anon_sym_new,
    ACTIONS(11106), 1,
      anon_sym_delete,
    ACTIONS(11084), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11082), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [260438] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3113), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10533), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [260462] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3113), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10537), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [260486] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11108), 1,
      anon_sym_delete,
    ACTIONS(11110), 1,
      anon_sym_new,
    ACTIONS(11084), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11082), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [260508] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3113), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10553), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [260532] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3113), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10519), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [260556] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3113), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10525), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [260580] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3233), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10864), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(6640), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [260610] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11112), 1,
      anon_sym_delete,
    ACTIONS(11114), 1,
      anon_sym_new,
    ACTIONS(11084), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11082), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [260632] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3113), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10606), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [260656] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11118), 1,
      anon_sym_LBRACK,
    STATE(6989), 1,
      sym_gnu_asm_output_operand,
    STATE(8245), 1,
      sym_string_literal,
    ACTIONS(11116), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
    ACTIONS(117), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [260680] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11120), 1,
      anon_sym_delete,
    ACTIONS(11122), 1,
      anon_sym_new,
    ACTIONS(11084), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11082), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [260702] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11114), 1,
      anon_sym_new,
    ACTIONS(11124), 1,
      anon_sym_delete,
    ACTIONS(11084), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11082), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [260724] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3113), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10549), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [260748] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11126), 1,
      anon_sym_delete,
    ACTIONS(11128), 1,
      anon_sym_new,
    ACTIONS(11084), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11082), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [260770] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11114), 1,
      anon_sym_new,
    ACTIONS(11130), 1,
      anon_sym_delete,
    ACTIONS(11084), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11082), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [260792] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3766), 1,
      anon_sym_COLON_COLON,
    ACTIONS(9471), 1,
      sym_identifier,
    STATE(2158), 1,
      sym_template_type,
    STATE(6476), 1,
      sym__scope_resolution,
    STATE(6957), 2,
      sym__class_name,
      sym_qualified_type_identifier,
    STATE(8512), 2,
      sym_decltype,
      sym_dependent_type_identifier,
  [260822] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3113), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10557), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_final,
      anon_sym_override,
      anon_sym_GT2,
      anon_sym_requires,
  [260846] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(3191), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10606), 6,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [260870] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11132), 1,
      anon_sym_delete,
    ACTIONS(11134), 1,
      anon_sym_new,
    ACTIONS(11084), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11082), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [260892] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(3191), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10519), 6,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [260916] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(3191), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10525), 6,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [260940] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(3191), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10533), 6,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [260964] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(3191), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10537), 6,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [260988] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(3191), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10549), 6,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [261012] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(3191), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10553), 6,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [261036] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(3191), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10557), 6,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [261060] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11136), 1,
      anon_sym_delete,
    ACTIONS(11138), 1,
      anon_sym_new,
    ACTIONS(11084), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11082), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [261082] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11140), 1,
      anon_sym_delete,
    ACTIONS(11142), 1,
      anon_sym_new,
    ACTIONS(11084), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11082), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [261104] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(3466), 1,
      anon_sym_LBRACE,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(11144), 1,
      anon_sym_EQ,
    STATE(3186), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(8034), 1,
      sym_initializer_list,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [261136] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10523), 1,
      anon_sym___attribute,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3005), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10519), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT2,
  [261162] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10551), 1,
      anon_sym___attribute,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3005), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10549), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT2,
  [261188] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10559), 1,
      anon_sym___attribute,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3005), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10557), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
      anon_sym_EQ,
      anon_sym_GT2,
  [261214] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11134), 1,
      anon_sym_new,
    ACTIONS(11146), 1,
      anon_sym_delete,
    ACTIONS(11084), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11082), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [261236] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(3766), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11148), 1,
      sym_identifier,
    STATE(2119), 1,
      sym_dependent_type_identifier,
    STATE(2137), 1,
      sym_template_type,
    STATE(2161), 1,
      sym_qualified_type_identifier,
    STATE(6476), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_decltype,
  [261267] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(9439), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11150), 1,
      sym_identifier,
    ACTIONS(11152), 1,
      anon_sym_template,
    STATE(2738), 1,
      sym_template_type,
    STATE(2739), 1,
      sym_dependent_type_identifier,
    STATE(2815), 1,
      sym_qualified_type_identifier,
    STATE(6477), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_decltype,
  [261298] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(3434), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10525), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [261321] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(3434), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10533), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [261344] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(10350), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11154), 1,
      sym_identifier,
    STATE(5740), 1,
      sym__scope_resolution,
    STATE(8565), 1,
      sym_qualified_identifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [261371] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(3434), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10537), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [261394] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6463), 1,
      anon_sym_LT,
    STATE(2832), 1,
      sym_template_argument_list,
    ACTIONS(4847), 2,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(4840), 4,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
  [261417] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(9714), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11156), 1,
      sym_identifier,
    ACTIONS(11158), 1,
      anon_sym_template,
    STATE(2162), 1,
      sym_qualified_type_identifier,
    STATE(2167), 1,
      sym_template_type,
    STATE(2168), 1,
      sym_dependent_type_identifier,
    STATE(6483), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_decltype,
  [261448] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11160), 1,
      sym_identifier,
    ACTIONS(11164), 1,
      sym_system_lib_string,
    STATE(7997), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(11162), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [261469] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5037), 1,
      anon_sym_LBRACE,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11166), 1,
      sym_identifier,
    ACTIONS(11168), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11170), 1,
      anon_sym_inline,
    STATE(714), 1,
      sym_declaration_list,
    STATE(6604), 1,
      sym_attribute_declaration,
    STATE(7697), 1,
      sym_nested_namespace_specifier,
    STATE(7917), 1,
      sym__namespace_specifier,
  [261500] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(7917), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11148), 1,
      sym_identifier,
    STATE(2119), 1,
      sym_dependent_type_identifier,
    STATE(2137), 1,
      sym_template_type,
    STATE(2819), 1,
      sym_qualified_type_identifier,
    STATE(6486), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_decltype,
  [261531] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(9306), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11172), 1,
      sym_identifier,
    ACTIONS(11174), 1,
      anon_sym_template,
    STATE(2606), 1,
      sym_template_type,
    STATE(2657), 1,
      sym_dependent_type_identifier,
    STATE(2707), 1,
      sym_qualified_type_identifier,
    STATE(6487), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_decltype,
  [261562] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(7814), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11176), 1,
      sym_identifier,
    ACTIONS(11178), 1,
      anon_sym_template,
    STATE(1704), 1,
      sym_template_type,
    STATE(1706), 1,
      sym_dependent_type_identifier,
    STATE(1808), 1,
      sym_qualified_type_identifier,
    STATE(6488), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_decltype,
  [261593] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(3434), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10549), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [261616] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(9359), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11178), 1,
      anon_sym_template,
    ACTIONS(11180), 1,
      sym_identifier,
    STATE(1704), 1,
      sym_template_type,
    STATE(1706), 1,
      sym_dependent_type_identifier,
    STATE(1808), 1,
      sym_qualified_type_identifier,
    STATE(6490), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_decltype,
  [261647] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(3434), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10553), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [261670] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5037), 1,
      anon_sym_LBRACE,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11168), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11170), 1,
      anon_sym_inline,
    ACTIONS(11182), 1,
      sym_identifier,
    STATE(715), 1,
      sym_declaration_list,
    STATE(6646), 1,
      sym_attribute_declaration,
    STATE(7607), 1,
      sym_nested_namespace_specifier,
    STATE(7917), 1,
      sym__namespace_specifier,
  [261701] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(5027), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11184), 1,
      sym_identifier,
    ACTIONS(11186), 1,
      anon_sym_template,
    STATE(2119), 1,
      sym_dependent_type_identifier,
    STATE(2137), 1,
      sym_template_type,
    STATE(2161), 1,
      sym_qualified_type_identifier,
    STATE(6493), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_decltype,
  [261732] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(11096), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11188), 1,
      sym_identifier,
    ACTIONS(11190), 1,
      anon_sym_template,
    STATE(2685), 1,
      sym_template_type,
    STATE(2686), 1,
      sym_dependent_type_identifier,
    STATE(2720), 1,
      sym_qualified_type_identifier,
    STATE(6494), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_decltype,
  [261763] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    STATE(3186), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    ACTIONS(10697), 2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [261790] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    STATE(3186), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    ACTIONS(10705), 2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [261817] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(3434), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10557), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [261840] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(7903), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11192), 1,
      sym_identifier,
    ACTIONS(11194), 1,
      anon_sym_template,
    STATE(2119), 1,
      sym_dependent_type_identifier,
    STATE(2137), 1,
      sym_template_type,
    STATE(2161), 1,
      sym_qualified_type_identifier,
    STATE(6498), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_decltype,
  [261871] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5039), 1,
      anon_sym_LBRACE,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11168), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11170), 1,
      anon_sym_inline,
    ACTIONS(11196), 1,
      sym_identifier,
    STATE(589), 1,
      sym_declaration_list,
    STATE(6667), 1,
      sym_attribute_declaration,
    STATE(7701), 1,
      sym_nested_namespace_specifier,
    STATE(7917), 1,
      sym__namespace_specifier,
  [261902] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(9282), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11198), 1,
      sym_identifier,
    ACTIONS(11200), 1,
      anon_sym_template,
    STATE(2517), 1,
      sym_template_type,
    STATE(2521), 1,
      sym_dependent_type_identifier,
    STATE(2593), 1,
      sym_qualified_type_identifier,
    STATE(6500), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_decltype,
  [261933] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6057), 1,
      anon_sym_AMP,
    ACTIONS(11202), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(6059), 6,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_PIPE_PIPE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_or,
  [261952] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11204), 1,
      sym_identifier,
    ACTIONS(11206), 1,
      sym_system_lib_string,
    STATE(8598), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(11162), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [261973] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    STATE(3186), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    ACTIONS(10701), 2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [262000] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(7881), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11192), 1,
      sym_identifier,
    ACTIONS(11194), 1,
      anon_sym_template,
    STATE(2119), 1,
      sym_dependent_type_identifier,
    STATE(2137), 1,
      sym_template_type,
    STATE(2819), 1,
      sym_qualified_type_identifier,
    STATE(6504), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_decltype,
  [262031] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(10350), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11208), 1,
      sym_identifier,
    STATE(5740), 1,
      sym__scope_resolution,
    STATE(8125), 1,
      sym_qualified_identifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [262058] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(9254), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11210), 1,
      sym_identifier,
    ACTIONS(11212), 1,
      anon_sym_template,
    STATE(1895), 1,
      sym_dependent_type_identifier,
    STATE(1904), 1,
      sym_template_type,
    STATE(1946), 1,
      sym_qualified_type_identifier,
    STATE(6506), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_decltype,
  [262089] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(9334), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11214), 1,
      sym_identifier,
    ACTIONS(11216), 1,
      anon_sym_template,
    STATE(2544), 1,
      sym_dependent_type_identifier,
    STATE(2594), 1,
      sym_template_type,
    STATE(2610), 1,
      sym_qualified_type_identifier,
    STATE(6507), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_decltype,
  [262120] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(7853), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11218), 1,
      sym_identifier,
    ACTIONS(11220), 1,
      anon_sym_template,
    STATE(4334), 1,
      sym_template_type,
    STATE(4359), 1,
      sym_dependent_type_identifier,
    STATE(4415), 1,
      sym_qualified_type_identifier,
    STATE(6508), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_decltype,
  [262151] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(9481), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11184), 1,
      sym_identifier,
    ACTIONS(11186), 1,
      anon_sym_template,
    STATE(2119), 1,
      sym_dependent_type_identifier,
    STATE(2137), 1,
      sym_template_type,
    STATE(2819), 1,
      sym_qualified_type_identifier,
    STATE(6509), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_decltype,
  [262182] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(9395), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11222), 1,
      sym_identifier,
    ACTIONS(11224), 1,
      anon_sym_template,
    STATE(3612), 1,
      sym_template_type,
    STATE(3624), 1,
      sym_dependent_type_identifier,
    STATE(3697), 1,
      sym_qualified_type_identifier,
    STATE(6510), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_decltype,
  [262213] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(4879), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11226), 1,
      sym_identifier,
    ACTIONS(11228), 1,
      anon_sym_template,
    STATE(2119), 1,
      sym_dependent_type_identifier,
    STATE(2137), 1,
      sym_template_type,
    STATE(2161), 1,
      sym_qualified_type_identifier,
    STATE(6511), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_decltype,
  [262244] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(3434), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10606), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [262267] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(7833), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11230), 1,
      sym_identifier,
    ACTIONS(11232), 1,
      anon_sym_template,
    STATE(1704), 1,
      sym_template_type,
    STATE(1706), 1,
      sym_dependent_type_identifier,
    STATE(1808), 1,
      sym_qualified_type_identifier,
    STATE(6513), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_decltype,
  [262298] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11234), 1,
      sym_identifier,
    ACTIONS(11236), 1,
      sym_system_lib_string,
    STATE(8344), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(11162), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [262319] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(10350), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11238), 1,
      sym_identifier,
    STATE(5740), 1,
      sym__scope_resolution,
    STATE(8183), 1,
      sym_qualified_identifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [262346] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11240), 1,
      sym_identifier,
    ACTIONS(11242), 1,
      sym_system_lib_string,
    STATE(8493), 2,
      sym_preproc_call_expression,
      sym_string_literal,
    ACTIONS(11162), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [262367] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6463), 1,
      anon_sym_LT,
    STATE(2832), 1,
      sym_template_argument_list,
    ACTIONS(7982), 2,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(4895), 4,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
  [262390] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(10350), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11244), 1,
      sym_identifier,
    STATE(5740), 1,
      sym__scope_resolution,
    STATE(8558), 1,
      sym_qualified_identifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [262417] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5041), 1,
      anon_sym_LBRACE,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11168), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11170), 1,
      anon_sym_inline,
    ACTIONS(11246), 1,
      sym_identifier,
    STATE(325), 1,
      sym_declaration_list,
    STATE(6614), 1,
      sym_attribute_declaration,
    STATE(7760), 1,
      sym_nested_namespace_specifier,
    STATE(7917), 1,
      sym__namespace_specifier,
  [262448] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(10350), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11248), 1,
      sym_identifier,
    STATE(5740), 1,
      sym__scope_resolution,
    STATE(7983), 1,
      sym_qualified_identifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [262475] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    STATE(3186), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    ACTIONS(10711), 2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [262502] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(9704), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11250), 1,
      sym_identifier,
    ACTIONS(11252), 1,
      anon_sym_template,
    STATE(1704), 1,
      sym_template_type,
    STATE(1706), 1,
      sym_dependent_type_identifier,
    STATE(1808), 1,
      sym_qualified_type_identifier,
    STATE(6522), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_decltype,
  [262533] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(10350), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11254), 1,
      sym_identifier,
    STATE(5740), 1,
      sym__scope_resolution,
    STATE(7774), 1,
      sym_qualified_identifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [262560] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5029), 1,
      anon_sym_LBRACE,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11168), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11170), 1,
      anon_sym_inline,
    ACTIONS(11256), 1,
      sym_identifier,
    STATE(608), 1,
      sym_declaration_list,
    STATE(6666), 1,
      sym_attribute_declaration,
    STATE(7493), 1,
      sym_nested_namespace_specifier,
    STATE(7917), 1,
      sym__namespace_specifier,
  [262591] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 1,
      anon_sym_template,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(10350), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11258), 1,
      sym_identifier,
    STATE(5740), 1,
      sym__scope_resolution,
    STATE(8203), 1,
      sym_qualified_identifier,
    STATE(8512), 3,
      sym_decltype,
      sym_template_type,
      sym_dependent_type_identifier,
  [262618] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6092), 1,
      anon_sym_AMP,
    ACTIONS(11202), 2,
      anon_sym_AMP_AMP,
      anon_sym_and,
    ACTIONS(11260), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_or,
    ACTIONS(6094), 4,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [262639] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10521), 1,
      anon_sym_LBRACK,
    STATE(3434), 1,
      sym_parameter_list,
    STATE(5726), 1,
      sym__function_declarator_seq,
    ACTIONS(10519), 5,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [262662] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1951), 1,
      anon_sym_decltype,
    ACTIONS(7875), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11200), 1,
      anon_sym_template,
    ACTIONS(11262), 1,
      sym_identifier,
    STATE(2517), 1,
      sym_template_type,
    STATE(2521), 1,
      sym_dependent_type_identifier,
    STATE(2593), 1,
      sym_qualified_type_identifier,
    STATE(6528), 1,
      sym__scope_resolution,
    STATE(8512), 1,
      sym_decltype,
  [262693] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5029), 1,
      anon_sym_LBRACE,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11168), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11170), 1,
      anon_sym_inline,
    ACTIONS(11264), 1,
      sym_identifier,
    STATE(633), 1,
      sym_declaration_list,
    STATE(6597), 1,
      sym_attribute_declaration,
    STATE(7448), 1,
      sym_nested_namespace_specifier,
    STATE(7917), 1,
      sym__namespace_specifier,
  [262724] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5041), 1,
      anon_sym_LBRACE,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11168), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11170), 1,
      anon_sym_inline,
    ACTIONS(11266), 1,
      sym_identifier,
    STATE(326), 1,
      sym_declaration_list,
    STATE(6622), 1,
      sym_attribute_declaration,
    STATE(7543), 1,
      sym_nested_namespace_specifier,
    STATE(7917), 1,
      sym__namespace_specifier,
  [262755] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5039), 1,
      anon_sym_LBRACE,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11168), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11170), 1,
      anon_sym_inline,
    ACTIONS(11268), 1,
      sym_identifier,
    STATE(579), 1,
      sym_declaration_list,
    STATE(6601), 1,
      sym_attribute_declaration,
    STATE(7645), 1,
      sym_nested_namespace_specifier,
    STATE(7917), 1,
      sym__namespace_specifier,
  [262786] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    STATE(3186), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    ACTIONS(10721), 2,
      anon_sym_LBRACE,
      anon_sym_EQ,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [262813] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3373), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10525), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [262835] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3053), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10525), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [262857] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3373), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10549), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [262879] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(11270), 1,
      anon_sym_RPAREN,
    STATE(3064), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [262905] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(11272), 1,
      anon_sym_SEMI,
    STATE(3064), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [262931] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(11274), 1,
      anon_sym_SEMI,
    STATE(3064), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [262957] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(10697), 1,
      anon_sym_COLON,
    STATE(3464), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(6238), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [262983] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(11276), 1,
      anon_sym_SEMI,
    STATE(3064), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [263009] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(10705), 1,
      anon_sym_COLON,
    STATE(3464), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(6238), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [263035] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6463), 1,
      anon_sym_LT,
    ACTIONS(11278), 1,
      anon_sym_SEMI,
    ACTIONS(11280), 1,
      anon_sym_EQ,
    STATE(1570), 1,
      sym_template_argument_list,
    STATE(6980), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [263061] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(11282), 1,
      anon_sym_SEMI,
    STATE(3064), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [263087] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(10711), 1,
      anon_sym_COLON,
    STATE(3464), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(6238), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [263113] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11286), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11284), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [263129] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9636), 1,
      anon_sym_LBRACK,
    ACTIONS(10689), 1,
      anon_sym_RPAREN,
    STATE(3064), 1,
      sym_parameter_list,
    STATE(6324), 1,
      sym__function_declarator_seq,
    STATE(6677), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [263155] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3053), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(11288), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [263177] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10559), 1,
      anon_sym___attribute,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3166), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10557), 3,
      anon_sym_COMMA,
      anon_sym___attribute__,
      anon_sym_GT2,
  [263201] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9636), 1,
      anon_sym_LBRACK,
    ACTIONS(10693), 1,
      anon_sym_RPAREN,
    STATE(3064), 1,
      sym_parameter_list,
    STATE(6324), 1,
      sym__function_declarator_seq,
    STATE(6677), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [263227] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6463), 1,
      anon_sym_LT,
    ACTIONS(11290), 1,
      anon_sym_SEMI,
    ACTIONS(11292), 1,
      anon_sym_EQ,
    STATE(1570), 1,
      sym_template_argument_list,
    STATE(6998), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [263253] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11294), 1,
      sym_identifier,
    ACTIONS(11299), 1,
      aux_sym_preproc_elif_token1,
    STATE(6551), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(7960), 1,
      sym_enumerator,
    ACTIONS(11297), 4,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [263275] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(11301), 1,
      anon_sym_RPAREN,
    STATE(3064), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [263301] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11305), 3,
      anon_sym_TILDE,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
    ACTIONS(11303), 5,
      anon_sym___based,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
      anon_sym_operator,
  [263317] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3373), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10606), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [263339] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11100), 1,
      anon_sym_LBRACK,
    STATE(7077), 1,
      sym_gnu_asm_input_operand,
    STATE(7920), 1,
      sym_string_literal,
    ACTIONS(117), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [263359] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6463), 1,
      anon_sym_LT,
    ACTIONS(11307), 1,
      anon_sym_SEMI,
    ACTIONS(11309), 1,
      anon_sym_EQ,
    STATE(1570), 1,
      sym_template_argument_list,
    STATE(7006), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [263385] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3373), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10557), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [263407] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(10701), 1,
      anon_sym_COLON,
    STATE(3464), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(6238), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [263433] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(11311), 1,
      anon_sym_SEMI,
    STATE(3064), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [263459] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(11313), 1,
      anon_sym_COLON,
    STATE(3464), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(6238), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [263485] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10559), 1,
      anon_sym___attribute,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3233), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10557), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
  [263509] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3053), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10557), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [263531] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11315), 1,
      sym_identifier,
    ACTIONS(11320), 1,
      aux_sym_preproc_elif_token1,
    STATE(6563), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
    ACTIONS(11318), 4,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
  [263551] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9636), 1,
      anon_sym_LBRACK,
    ACTIONS(11322), 1,
      anon_sym_RPAREN,
    STATE(3064), 1,
      sym_parameter_list,
    STATE(6324), 1,
      sym__function_declarator_seq,
    STATE(6677), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [263577] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3373), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10533), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [263599] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3373), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10537), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [263621] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6463), 1,
      anon_sym_LT,
    ACTIONS(11324), 1,
      anon_sym_SEMI,
    ACTIONS(11326), 1,
      anon_sym_EQ,
    STATE(1570), 1,
      sym_template_argument_list,
    STATE(7011), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [263647] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3373), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10553), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [263669] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11330), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11332), 1,
      anon_sym_EQ,
    ACTIONS(11328), 6,
      anon_sym_COMMA,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_identifier,
  [263687] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10523), 1,
      anon_sym___attribute,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3233), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10519), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
  [263711] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3053), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10519), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [263733] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10527), 1,
      anon_sym___attribute,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3233), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10525), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
  [263757] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6463), 1,
      anon_sym_LT,
    ACTIONS(7982), 1,
      anon_sym_LBRACK,
    STATE(5843), 1,
      sym_template_argument_list,
    ACTIONS(4895), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [263779] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9636), 1,
      anon_sym_LBRACK,
    ACTIONS(10738), 1,
      anon_sym_RPAREN,
    STATE(3064), 1,
      sym_parameter_list,
    STATE(6324), 1,
      sym__function_declarator_seq,
    STATE(6677), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [263805] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6463), 1,
      anon_sym_LT,
    ACTIONS(11334), 1,
      anon_sym_SEMI,
    ACTIONS(11336), 1,
      anon_sym_EQ,
    STATE(1570), 1,
      sym_template_argument_list,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [263831] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5932), 1,
      anon_sym_COMMA,
    ACTIONS(6463), 1,
      anon_sym_LT,
    ACTIONS(11338), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11340), 1,
      anon_sym_RBRACK,
    ACTIONS(11343), 1,
      anon_sym_EQ,
    STATE(1570), 1,
      sym_template_argument_list,
    STATE(7394), 1,
      aux_sym_structured_binding_declarator_repeat1,
  [263859] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9636), 1,
      anon_sym_LBRACK,
    ACTIONS(10727), 1,
      anon_sym_RPAREN,
    STATE(3064), 1,
      sym_parameter_list,
    STATE(6324), 1,
      sym__function_declarator_seq,
    STATE(6677), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [263885] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10551), 1,
      anon_sym___attribute,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3166), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10549), 3,
      anon_sym_COMMA,
      anon_sym___attribute__,
      anon_sym_GT2,
  [263909] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9636), 1,
      anon_sym_LBRACK,
    ACTIONS(10683), 1,
      anon_sym_RPAREN,
    STATE(3064), 1,
      sym_parameter_list,
    STATE(6324), 1,
      sym__function_declarator_seq,
    STATE(6677), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [263935] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9636), 1,
      anon_sym_LBRACK,
    ACTIONS(11345), 1,
      anon_sym_RPAREN,
    STATE(3064), 1,
      sym_parameter_list,
    STATE(6324), 1,
      sym__function_declarator_seq,
    STATE(6677), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [263961] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(11347), 1,
      anon_sym_SEMI,
    STATE(3064), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [263987] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11118), 1,
      anon_sym_LBRACK,
    STATE(7366), 1,
      sym_gnu_asm_output_operand,
    STATE(8245), 1,
      sym_string_literal,
    ACTIONS(117), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [264007] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(11349), 1,
      anon_sym_SEMI,
    STATE(3064), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [264033] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(10721), 1,
      anon_sym_COLON,
    STATE(3464), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(6238), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [264059] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10523), 1,
      anon_sym___attribute,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3166), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10519), 3,
      anon_sym_COMMA,
      anon_sym___attribute__,
      anon_sym_GT2,
  [264083] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4847), 1,
      anon_sym_LBRACK,
    ACTIONS(6463), 1,
      anon_sym_LT,
    STATE(5843), 1,
      sym_template_argument_list,
    ACTIONS(4840), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [264105] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10551), 1,
      anon_sym___attribute,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3233), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10549), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym___attribute__,
  [264129] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6320), 1,
      anon_sym_LBRACK,
    ACTIONS(6463), 1,
      anon_sym_LT,
    STATE(2832), 1,
      sym_template_argument_list,
    ACTIONS(6322), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
      anon_sym_COLON,
  [264149] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3373), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10519), 4,
      anon_sym_COLON,
      anon_sym_final,
      anon_sym_override,
      anon_sym_requires,
  [264171] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    ACTIONS(11351), 1,
      anon_sym_SEMI,
    STATE(3064), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [264197] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10527), 1,
      anon_sym___attribute,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3166), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10525), 3,
      anon_sym_COMMA,
      anon_sym___attribute__,
      anon_sym_GT2,
  [264221] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6463), 1,
      anon_sym_LT,
    ACTIONS(11353), 1,
      anon_sym_SEMI,
    ACTIONS(11355), 1,
      anon_sym_EQ,
    STATE(1570), 1,
      sym_template_argument_list,
    STATE(6932), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [264247] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3053), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10549), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [264269] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6463), 1,
      anon_sym_LT,
    ACTIONS(11357), 1,
      anon_sym_SEMI,
    ACTIONS(11359), 1,
      anon_sym_EQ,
    STATE(1570), 1,
      sym_template_argument_list,
    STATE(7008), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [264295] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6320), 1,
      anon_sym_LBRACK,
    ACTIONS(6463), 1,
      anon_sym_LT,
    STATE(5843), 1,
      sym_template_argument_list,
    ACTIONS(6322), 4,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
      anon_sym_LBRACE,
      anon_sym_try,
  [264314] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11363), 1,
      anon_sym_AMP,
    ACTIONS(11361), 6,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [264329] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5029), 1,
      anon_sym_LBRACE,
    ACTIONS(11168), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11170), 1,
      anon_sym_inline,
    ACTIONS(11365), 1,
      sym_identifier,
    STATE(578), 1,
      sym_declaration_list,
    STATE(7630), 1,
      sym_nested_namespace_specifier,
    STATE(7917), 1,
      sym__namespace_specifier,
  [264354] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4443), 1,
      anon_sym_AMP,
    ACTIONS(4441), 6,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [264369] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11369), 1,
      anon_sym_COMMA,
    ACTIONS(11371), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11367), 5,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_identifier,
  [264386] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5899), 1,
      anon_sym_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(11373), 1,
      anon_sym_RPAREN,
    STATE(2187), 1,
      sym_parameter_list,
    STATE(6243), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [264409] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5039), 1,
      anon_sym_LBRACE,
    ACTIONS(11168), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11170), 1,
      anon_sym_inline,
    ACTIONS(11196), 1,
      sym_identifier,
    STATE(589), 1,
      sym_declaration_list,
    STATE(7701), 1,
      sym_nested_namespace_specifier,
    STATE(7917), 1,
      sym__namespace_specifier,
  [264434] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11377), 1,
      anon_sym_AMP,
    ACTIONS(11375), 6,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [264449] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10328), 1,
      anon_sym___attribute,
    ACTIONS(11379), 1,
      anon_sym_EQ,
    ACTIONS(10326), 5,
      anon_sym_COMMA,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
      anon_sym_GT2,
  [264466] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5037), 1,
      anon_sym_LBRACE,
    ACTIONS(11168), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11170), 1,
      anon_sym_inline,
    ACTIONS(11381), 1,
      sym_identifier,
    STATE(745), 1,
      sym_declaration_list,
    STATE(7540), 1,
      sym_nested_namespace_specifier,
    STATE(7917), 1,
      sym__namespace_specifier,
  [264491] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_LBRACE,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6463), 1,
      anon_sym_LT,
    ACTIONS(8018), 1,
      anon_sym_LPAREN2,
    STATE(2279), 1,
      sym_template_argument_list,
    STATE(7143), 2,
      sym_argument_list,
      sym_initializer_list,
  [264514] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6980), 1,
      anon_sym___attribute__,
    ACTIONS(6982), 1,
      anon_sym___attribute,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    STATE(5381), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5623), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [264535] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11385), 1,
      anon_sym_AMP,
    ACTIONS(11383), 6,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [264550] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    STATE(4208), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(11387), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [264569] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10519), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [264590] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11389), 1,
      anon_sym_LPAREN2,
    STATE(6620), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11391), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [264607] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5899), 1,
      anon_sym_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(11393), 1,
      anon_sym_RPAREN,
    STATE(2187), 1,
      sym_parameter_list,
    STATE(6243), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [264630] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5899), 1,
      anon_sym_LBRACK,
    ACTIONS(6019), 1,
      anon_sym_COLON,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    STATE(2187), 1,
      sym_parameter_list,
    STATE(6727), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [264653] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10328), 1,
      anon_sym___attribute,
    ACTIONS(11395), 1,
      anon_sym_EQ,
    ACTIONS(10326), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym___attribute__,
      anon_sym_LBRACK,
  [264670] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5041), 1,
      anon_sym_LBRACE,
    ACTIONS(11168), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11170), 1,
      anon_sym_inline,
    ACTIONS(11397), 1,
      sym_identifier,
    STATE(311), 1,
      sym_declaration_list,
    STATE(7714), 1,
      sym_nested_namespace_specifier,
    STATE(7917), 1,
      sym__namespace_specifier,
  [264695] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5899), 1,
      anon_sym_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(11399), 1,
      anon_sym_RPAREN,
    STATE(2187), 1,
      sym_parameter_list,
    STATE(6243), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [264718] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10549), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [264739] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10533), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [264760] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3109), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10553), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
  [264781] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10525), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [264802] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11401), 1,
      anon_sym_LPAREN2,
    STATE(6648), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11391), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [264819] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6339), 1,
      anon_sym_AMP,
    ACTIONS(6341), 6,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_requires,
  [264834] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5041), 1,
      anon_sym_LBRACE,
    ACTIONS(11168), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11170), 1,
      anon_sym_inline,
    ACTIONS(11246), 1,
      sym_identifier,
    STATE(325), 1,
      sym_declaration_list,
    STATE(7760), 1,
      sym_nested_namespace_specifier,
    STATE(7917), 1,
      sym__namespace_specifier,
  [264859] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6463), 1,
      anon_sym_LT,
    ACTIONS(11338), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11343), 1,
      anon_sym_EQ,
    STATE(1570), 1,
      sym_template_argument_list,
    ACTIONS(6083), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [264882] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5899), 1,
      anon_sym_LBRACK,
    ACTIONS(5911), 1,
      anon_sym_COLON,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    STATE(2187), 1,
      sym_parameter_list,
    STATE(6727), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [264905] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10537), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [264926] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5899), 1,
      anon_sym_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(11403), 1,
      anon_sym_RPAREN,
    STATE(2187), 1,
      sym_parameter_list,
    STATE(6243), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [264949] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11405), 1,
      anon_sym_LPAREN2,
    STATE(6628), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11391), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [264966] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11407), 1,
      anon_sym_LPAREN2,
    STATE(6648), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11391), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [264983] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6287), 1,
      anon_sym_AMP,
    ACTIONS(6289), 6,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_requires,
  [264998] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(5339), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    STATE(5333), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    STATE(5372), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [265019] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11409), 1,
      anon_sym_LPAREN2,
    STATE(6632), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11391), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [265036] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11411), 1,
      anon_sym_LPAREN2,
    STATE(6648), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11391), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [265053] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10553), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [265074] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11413), 1,
      anon_sym_LPAREN2,
    STATE(6669), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11391), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [265091] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11415), 1,
      anon_sym_LBRACK,
    ACTIONS(11417), 1,
      anon_sym_EQ,
    ACTIONS(11419), 1,
      anon_sym_DOT,
    STATE(6652), 4,
      sym_subscript_designator,
      sym_subscript_range_designator,
      sym_field_designator,
      aux_sym_initializer_pair_repeat1,
  [265110] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5899), 1,
      anon_sym_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(11421), 1,
      anon_sym_RPAREN,
    STATE(2187), 1,
      sym_parameter_list,
    STATE(6243), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [265133] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11423), 1,
      anon_sym_LPAREN2,
    STATE(6639), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11391), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [265150] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    STATE(4208), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(11425), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [265169] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11427), 1,
      anon_sym_LPAREN2,
    STATE(6648), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11391), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [265186] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    STATE(4208), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
    ACTIONS(11425), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [265205] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11429), 1,
      anon_sym_LPAREN2,
    STATE(6642), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11391), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [265222] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11431), 1,
      anon_sym_LPAREN2,
    STATE(6648), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11391), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [265239] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5899), 1,
      anon_sym_LBRACK,
    ACTIONS(5945), 1,
      anon_sym_COLON,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    STATE(2187), 1,
      sym_parameter_list,
    STATE(6727), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [265262] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11433), 1,
      anon_sym_LPAREN2,
    STATE(6656), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11391), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [265279] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5899), 1,
      anon_sym_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(11435), 1,
      anon_sym_RPAREN,
    STATE(2187), 1,
      sym_parameter_list,
    STATE(6243), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [265302] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5037), 1,
      anon_sym_LBRACE,
    ACTIONS(11166), 1,
      sym_identifier,
    ACTIONS(11168), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11170), 1,
      anon_sym_inline,
    STATE(714), 1,
      sym_declaration_list,
    STATE(7697), 1,
      sym_nested_namespace_specifier,
    STATE(7917), 1,
      sym__namespace_specifier,
  [265327] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5893), 1,
      anon_sym_COLON,
    ACTIONS(5899), 1,
      anon_sym_LBRACK,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    STATE(2187), 1,
      sym_parameter_list,
    STATE(6727), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [265350] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11437), 1,
      anon_sym_LPAREN2,
    STATE(6648), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11439), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [265367] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6367), 1,
      anon_sym_AMP,
    ACTIONS(6369), 6,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_requires,
  [265382] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3109), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10606), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
  [265403] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10606), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [265424] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11442), 1,
      anon_sym_LBRACK,
    ACTIONS(11445), 1,
      anon_sym_EQ,
    ACTIONS(11447), 1,
      anon_sym_DOT,
    STATE(6652), 4,
      sym_subscript_designator,
      sym_subscript_range_designator,
      sym_field_designator,
      aux_sym_initializer_pair_repeat1,
  [265443] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6463), 1,
      anon_sym_LT,
    ACTIONS(11338), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11450), 1,
      anon_sym_EQ,
    STATE(1570), 1,
      sym_template_argument_list,
    ACTIONS(6074), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [265466] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5899), 1,
      anon_sym_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(11452), 1,
      anon_sym_RPAREN,
    STATE(2187), 1,
      sym_parameter_list,
    STATE(6243), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [265489] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3109), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10519), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
  [265510] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11454), 1,
      anon_sym_LPAREN2,
    STATE(6648), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11391), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [265527] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3109), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10525), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
  [265548] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3109), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10549), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
  [265569] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3109), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10557), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
  [265590] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(5899), 1,
      anon_sym_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(11456), 1,
      anon_sym_RPAREN,
    STATE(2187), 1,
      sym_parameter_list,
    STATE(6243), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [265613] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11460), 1,
      anon_sym_AMP,
    ACTIONS(11458), 6,
      anon_sym_LPAREN2,
      anon_sym_STAR,
      anon_sym_AMP_AMP,
      anon_sym_LT,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
  [265628] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3109), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10533), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
  [265649] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(9851), 1,
      anon_sym_LBRACK,
    STATE(2911), 1,
      sym_parameter_list,
    STATE(6003), 1,
      sym__function_declarator_seq,
    STATE(5845), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [265672] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5899), 1,
      anon_sym_LBRACK,
    ACTIONS(5923), 1,
      anon_sym_COLON,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    STATE(2187), 1,
      sym_parameter_list,
    STATE(6727), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [265695] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10557), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [265716] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5029), 1,
      anon_sym_LBRACE,
    ACTIONS(11168), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11170), 1,
      anon_sym_inline,
    ACTIONS(11264), 1,
      sym_identifier,
    STATE(633), 1,
      sym_declaration_list,
    STATE(7448), 1,
      sym_nested_namespace_specifier,
    STATE(7917), 1,
      sym__namespace_specifier,
  [265741] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5039), 1,
      anon_sym_LBRACE,
    ACTIONS(11168), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11170), 1,
      anon_sym_inline,
    ACTIONS(11462), 1,
      sym_identifier,
    STATE(643), 1,
      sym_declaration_list,
    STATE(7441), 1,
      sym_nested_namespace_specifier,
    STATE(7917), 1,
      sym__namespace_specifier,
  [265766] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3109), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
    ACTIONS(10537), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_COMMA,
      anon_sym_GT2,
  [265787] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11464), 1,
      anon_sym_LPAREN2,
    STATE(6648), 2,
      sym_gnu_asm_qualifier,
      aux_sym_gnu_asm_expression_repeat1,
    ACTIONS(11391), 4,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [265804] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6463), 1,
      anon_sym_LT,
    ACTIONS(10904), 1,
      anon_sym_LBRACK,
    STATE(6298), 1,
      sym_template_argument_list,
    ACTIONS(10900), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [265822] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9650), 1,
      anon_sym_try,
    ACTIONS(10789), 1,
      anon_sym_LBRACE,
    ACTIONS(11466), 1,
      anon_sym_SEMI,
    ACTIONS(11468), 1,
      anon_sym_EQ,
    STATE(1972), 2,
      sym_compound_statement,
      sym_try_statement,
  [265842] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(644), 1,
      anon_sym_LBRACE,
    ACTIONS(9941), 1,
      anon_sym_try,
    ACTIONS(11470), 1,
      anon_sym_SEMI,
    ACTIONS(11472), 1,
      anon_sym_EQ,
    STATE(581), 2,
      sym_compound_statement,
      sym_try_statement,
  [265862] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(8352), 1,
      anon_sym_COMMA,
    ACTIONS(11474), 1,
      anon_sym_SEMI,
    STATE(6731), 1,
      aux_sym_field_declaration_repeat1,
    STATE(7825), 1,
      sym_attribute_specifier,
  [265884] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(8352), 1,
      anon_sym_COMMA,
    ACTIONS(11476), 1,
      anon_sym_SEMI,
    STATE(6680), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8144), 1,
      sym_attribute_specifier,
  [265906] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9642), 1,
      anon_sym_try,
    ACTIONS(10842), 1,
      anon_sym_LBRACE,
    ACTIONS(11478), 1,
      anon_sym_SEMI,
    ACTIONS(11480), 1,
      anon_sym_EQ,
    STATE(1910), 2,
      sym_compound_statement,
      sym_try_statement,
  [265926] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11482), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(11484), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [265940] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(10886), 1,
      anon_sym_LBRACK,
    ACTIONS(10884), 2,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
    STATE(5783), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [265958] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(8352), 1,
      anon_sym_COMMA,
    ACTIONS(11486), 1,
      anon_sym_SEMI,
    STATE(6686), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8298), 1,
      sym_attribute_specifier,
  [265980] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(8352), 1,
      anon_sym_COMMA,
    ACTIONS(11488), 1,
      anon_sym_SEMI,
    STATE(6731), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8265), 1,
      sym_attribute_specifier,
  [266002] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(8352), 1,
      anon_sym_COMMA,
    ACTIONS(11490), 1,
      anon_sym_SEMI,
    STATE(6731), 1,
      aux_sym_field_declaration_repeat1,
    STATE(7908), 1,
      sym_attribute_specifier,
  [266024] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(8352), 1,
      anon_sym_COMMA,
    ACTIONS(11492), 1,
      anon_sym_SEMI,
    STATE(6731), 1,
      aux_sym_field_declaration_repeat1,
    STATE(7832), 1,
      sym_attribute_specifier,
  [266046] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(8352), 1,
      anon_sym_COMMA,
    ACTIONS(11494), 1,
      anon_sym_SEMI,
    STATE(6731), 1,
      aux_sym_field_declaration_repeat1,
    STATE(7957), 1,
      sym_attribute_specifier,
  [266068] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(8352), 1,
      anon_sym_COMMA,
    ACTIONS(11496), 1,
      anon_sym_SEMI,
    STATE(6731), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8261), 1,
      sym_attribute_specifier,
  [266090] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(8352), 1,
      anon_sym_COMMA,
    ACTIONS(11498), 1,
      anon_sym_SEMI,
    STATE(6731), 1,
      aux_sym_field_declaration_repeat1,
    STATE(7927), 1,
      sym_attribute_specifier,
  [266112] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11500), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(11502), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [266126] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(8352), 1,
      anon_sym_COMMA,
    ACTIONS(11504), 1,
      anon_sym_SEMI,
    STATE(6731), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8052), 1,
      sym_attribute_specifier,
  [266148] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9642), 1,
      anon_sym_try,
    ACTIONS(10842), 1,
      anon_sym_LBRACE,
    ACTIONS(11506), 1,
      anon_sym_SEMI,
    ACTIONS(11508), 1,
      anon_sym_EQ,
    STATE(2107), 2,
      sym_compound_statement,
      sym_try_statement,
  [266168] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(9983), 1,
      anon_sym_try,
    ACTIONS(11510), 1,
      anon_sym_SEMI,
    ACTIONS(11512), 1,
      anon_sym_EQ,
    STATE(726), 2,
      sym_compound_statement,
      sym_try_statement,
  [266188] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(616), 1,
      anon_sym_LBRACE,
    ACTIONS(9857), 1,
      anon_sym_try,
    ACTIONS(11514), 1,
      anon_sym_SEMI,
    ACTIONS(11516), 1,
      anon_sym_EQ,
    STATE(621), 2,
      sym_compound_statement,
      sym_try_statement,
  [266208] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(644), 1,
      anon_sym_LBRACE,
    ACTIONS(9941), 1,
      anon_sym_try,
    ACTIONS(11518), 1,
      anon_sym_SEMI,
    ACTIONS(11520), 1,
      anon_sym_EQ,
    STATE(637), 2,
      sym_compound_statement,
      sym_try_statement,
  [266228] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(8352), 1,
      anon_sym_COMMA,
    ACTIONS(11522), 1,
      anon_sym_SEMI,
    STATE(6726), 1,
      aux_sym_field_declaration_repeat1,
    STATE(7923), 1,
      sym_attribute_specifier,
  [266250] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11299), 1,
      aux_sym_preproc_elif_token1,
    ACTIONS(11297), 5,
      aux_sym_preproc_if_token2,
      aux_sym_preproc_else_token1,
      aux_sym_preproc_elifdef_token1,
      aux_sym_preproc_elifdef_token2,
      sym_identifier,
  [266264] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6320), 1,
      anon_sym_LBRACK,
    ACTIONS(6463), 1,
      anon_sym_LT,
    STATE(3913), 1,
      sym_template_argument_list,
    ACTIONS(6322), 3,
      anon_sym_LPAREN2,
      anon_sym_SEMI,
      anon_sym_LBRACK_LBRACK,
  [266282] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(8540), 1,
      sym_string_literal,
    ACTIONS(117), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [266296] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(8352), 1,
      anon_sym_COMMA,
    ACTIONS(11524), 1,
      anon_sym_SEMI,
    STATE(6673), 1,
      aux_sym_field_declaration_repeat1,
    STATE(7796), 1,
      sym_attribute_specifier,
  [266318] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11526), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(11528), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [266332] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11482), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(11484), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [266346] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11033), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(11530), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [266360] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(8352), 1,
      anon_sym_COMMA,
    ACTIONS(11532), 1,
      anon_sym_SEMI,
    STATE(6710), 1,
      aux_sym_field_declaration_repeat1,
    STATE(7931), 1,
      sym_attribute_specifier,
  [266382] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(289), 1,
      anon_sym_LBRACE,
    ACTIONS(9951), 1,
      anon_sym_try,
    ACTIONS(11534), 1,
      anon_sym_SEMI,
    ACTIONS(11536), 1,
      anon_sym_EQ,
    STATE(300), 2,
      sym_compound_statement,
      sym_try_statement,
  [266402] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6463), 1,
      anon_sym_LT,
    ACTIONS(10945), 1,
      anon_sym_LBRACK,
    STATE(6316), 1,
      sym_template_argument_list,
    ACTIONS(10943), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [266420] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9658), 1,
      anon_sym_try,
    ACTIONS(10830), 1,
      anon_sym_LBRACE,
    ACTIONS(11538), 1,
      anon_sym_SEMI,
    ACTIONS(11540), 1,
      anon_sym_EQ,
    STATE(1680), 2,
      sym_compound_statement,
      sym_try_statement,
  [266440] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11542), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(11544), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [266454] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(8077), 1,
      sym_string_literal,
    ACTIONS(117), 5,
      anon_sym_L_DQUOTE,
      anon_sym_u_DQUOTE,
      anon_sym_U_DQUOTE,
      anon_sym_u8_DQUOTE,
      anon_sym_DQUOTE,
  [266468] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(8352), 1,
      anon_sym_COMMA,
    ACTIONS(11546), 1,
      anon_sym_SEMI,
    STATE(6731), 1,
      aux_sym_field_declaration_repeat1,
    STATE(7974), 1,
      sym_attribute_specifier,
  [266490] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6320), 1,
      anon_sym_LBRACK,
    ACTIONS(7205), 1,
      anon_sym_LT,
    STATE(3913), 1,
      sym_template_argument_list,
    ACTIONS(6322), 3,
      anon_sym_RPAREN,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [266508] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(289), 1,
      anon_sym_LBRACE,
    ACTIONS(9951), 1,
      anon_sym_try,
    ACTIONS(11548), 1,
      anon_sym_SEMI,
    ACTIONS(11550), 1,
      anon_sym_EQ,
    STATE(362), 2,
      sym_compound_statement,
      sym_try_statement,
  [266528] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(616), 1,
      anon_sym_LBRACE,
    ACTIONS(9857), 1,
      anon_sym_try,
    ACTIONS(11552), 1,
      anon_sym_SEMI,
    ACTIONS(11554), 1,
      anon_sym_EQ,
    STATE(616), 2,
      sym_compound_statement,
      sym_try_statement,
  [266548] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11556), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(11558), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [266562] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(8352), 1,
      anon_sym_COMMA,
    ACTIONS(11560), 1,
      anon_sym_SEMI,
    STATE(6731), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8204), 1,
      sym_attribute_specifier,
  [266584] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(8352), 1,
      anon_sym_COMMA,
    ACTIONS(11562), 1,
      anon_sym_SEMI,
    STATE(6679), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8063), 1,
      sym_attribute_specifier,
  [266606] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11564), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(11566), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [266620] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(8352), 1,
      anon_sym_COMMA,
    ACTIONS(11568), 1,
      anon_sym_SEMI,
    STATE(6725), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8630), 1,
      sym_attribute_specifier,
  [266642] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(8352), 1,
      anon_sym_COMMA,
    ACTIONS(11570), 1,
      anon_sym_SEMI,
    STATE(6681), 1,
      aux_sym_field_declaration_repeat1,
    STATE(7833), 1,
      sym_attribute_specifier,
  [266664] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11572), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(11574), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [266678] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(8352), 1,
      anon_sym_COMMA,
    ACTIONS(11576), 1,
      anon_sym_SEMI,
    STATE(6731), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8173), 1,
      sym_attribute_specifier,
  [266700] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9650), 1,
      anon_sym_try,
    ACTIONS(10789), 1,
      anon_sym_LBRACE,
    ACTIONS(11578), 1,
      anon_sym_SEMI,
    ACTIONS(11580), 1,
      anon_sym_EQ,
    STATE(1942), 2,
      sym_compound_statement,
      sym_try_statement,
  [266720] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(9983), 1,
      anon_sym_try,
    ACTIONS(11582), 1,
      anon_sym_SEMI,
    ACTIONS(11584), 1,
      anon_sym_EQ,
    STATE(733), 2,
      sym_compound_statement,
      sym_try_statement,
  [266740] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(8352), 1,
      anon_sym_COMMA,
    ACTIONS(11586), 1,
      anon_sym_SEMI,
    STATE(6731), 1,
      aux_sym_field_declaration_repeat1,
    STATE(7934), 1,
      sym_attribute_specifier,
  [266762] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11588), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(11590), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [266776] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9658), 1,
      anon_sym_try,
    ACTIONS(10830), 1,
      anon_sym_LBRACE,
    ACTIONS(11592), 1,
      anon_sym_SEMI,
    ACTIONS(11594), 1,
      anon_sym_EQ,
    STATE(1697), 2,
      sym_compound_statement,
      sym_try_statement,
  [266796] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11542), 2,
      anon_sym_RBRACE,
      sym_identifier,
    ACTIONS(11544), 4,
      aux_sym_preproc_if_token1,
      aux_sym_preproc_ifdef_token1,
      aux_sym_preproc_ifdef_token2,
      sym_preproc_directive,
  [266810] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(8352), 1,
      anon_sym_COMMA,
    ACTIONS(11596), 1,
      anon_sym_SEMI,
    STATE(6705), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8483), 1,
      sym_attribute_specifier,
  [266832] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(8352), 1,
      anon_sym_COMMA,
    ACTIONS(11598), 1,
      anon_sym_SEMI,
    STATE(6731), 1,
      aux_sym_field_declaration_repeat1,
    STATE(7863), 1,
      sym_attribute_specifier,
  [266854] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(8352), 1,
      anon_sym_COMMA,
    ACTIONS(11600), 1,
      anon_sym_SEMI,
    STATE(6731), 1,
      aux_sym_field_declaration_repeat1,
    STATE(7875), 1,
      sym_attribute_specifier,
  [266876] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(8352), 1,
      anon_sym_COMMA,
    ACTIONS(11602), 1,
      anon_sym_SEMI,
    STATE(6731), 1,
      aux_sym_field_declaration_repeat1,
    STATE(8295), 1,
      sym_attribute_specifier,
  [266898] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6149), 1,
      anon_sym_LBRACK,
    ACTIONS(7718), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(6151), 2,
      anon_sym_LPAREN2,
      anon_sym_COLON,
    STATE(5635), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [266916] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(11604), 1,
      anon_sym_SEMI,
    STATE(4208), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [266933] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(11606), 1,
      anon_sym_SEMI,
    STATE(4208), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [266950] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(11608), 1,
      anon_sym_SEMI,
    STATE(4208), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [266967] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11610), 1,
      anon_sym_COMMA,
    ACTIONS(11615), 1,
      anon_sym___attribute,
    STATE(6731), 1,
      aux_sym_field_declaration_repeat1,
    ACTIONS(11613), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [266984] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(11617), 1,
      anon_sym_SEMI,
    STATE(4208), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [267001] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    ACTIONS(11619), 1,
      anon_sym_RPAREN,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
  [267020] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(11621), 1,
      anon_sym_SEMI,
    STATE(6798), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [267037] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8052), 1,
      sym_auto,
    ACTIONS(8054), 1,
      anon_sym_decltype,
    STATE(2454), 1,
      sym_decltype_auto,
    ACTIONS(11623), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [267054] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(11625), 1,
      anon_sym_SEMI,
    STATE(6728), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [267071] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(11627), 1,
      anon_sym_SEMI,
    STATE(6741), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [267088] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(11629), 1,
      anon_sym_SEMI,
    STATE(4208), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [267105] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(11631), 1,
      sym_identifier,
    STATE(2145), 1,
      sym_template_type,
    STATE(2335), 1,
      sym_template_method,
    STATE(7484), 1,
      sym_operator_name,
  [267124] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(11633), 1,
      sym_identifier,
    STATE(2145), 1,
      sym_template_type,
    STATE(3626), 1,
      sym_template_method,
    STATE(7431), 1,
      sym_operator_name,
  [267143] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(11635), 1,
      anon_sym_SEMI,
    STATE(4208), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [267160] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10525), 1,
      anon_sym_COLON,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3356), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
  [267179] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(11637), 1,
      anon_sym_SEMI,
    STATE(4208), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [267196] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9168), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9172), 1,
      anon_sym_EQ,
    ACTIONS(11639), 1,
      sym_identifier,
    ACTIONS(9170), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [267213] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(11641), 1,
      anon_sym_SEMI,
    STATE(6796), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [267230] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(11643), 1,
      anon_sym_SEMI,
    STATE(6729), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [267247] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10533), 1,
      anon_sym_COLON,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3356), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
  [267266] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(11645), 1,
      anon_sym_SEMI,
    STATE(4208), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [267283] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11647), 5,
      anon_sym_LPAREN2,
      anon_sym_inline,
      anon_sym_volatile,
      anon_sym_goto,
      anon_sym___volatile__,
  [267294] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10553), 1,
      anon_sym_COLON,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3356), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
  [267313] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11168), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11170), 1,
      anon_sym_inline,
    ACTIONS(11649), 1,
      sym_identifier,
    STATE(7917), 1,
      sym__namespace_specifier,
    STATE(8306), 1,
      sym_nested_namespace_specifier,
  [267332] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    ACTIONS(11651), 1,
      anon_sym_RPAREN,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
  [267351] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6320), 1,
      anon_sym_LBRACK,
    ACTIONS(6463), 1,
      anon_sym_LT,
    STATE(4207), 1,
      sym_template_argument_list,
    ACTIONS(6322), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [267368] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(11653), 1,
      anon_sym_SEMI,
    STATE(6797), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [267385] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10537), 1,
      anon_sym_COLON,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3356), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
  [267404] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6463), 1,
      anon_sym_LT,
    STATE(2279), 1,
      sym_template_argument_list,
    ACTIONS(6202), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACE,
  [267421] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11168), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11170), 1,
      anon_sym_inline,
    ACTIONS(11655), 1,
      sym_identifier,
    STATE(7917), 1,
      sym__namespace_specifier,
    STATE(8123), 1,
      sym_nested_namespace_specifier,
  [267440] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6463), 1,
      anon_sym_LT,
    STATE(1565), 1,
      sym_template_argument_list,
    ACTIONS(4840), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [267457] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(11657), 1,
      anon_sym_SEMI,
    STATE(4208), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [267474] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10557), 1,
      anon_sym_COLON,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3356), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
  [267493] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11168), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11170), 1,
      anon_sym_inline,
    ACTIONS(11659), 1,
      sym_identifier,
    STATE(7135), 1,
      sym__namespace_specifier,
    STATE(7499), 1,
      sym_nested_namespace_specifier,
  [267512] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10673), 1,
      sym_identifier,
    ACTIONS(11661), 1,
      aux_sym_preproc_if_token2,
    STATE(6599), 1,
      sym_enumerator,
    STATE(6902), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(6914), 1,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
  [267531] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(11663), 1,
      anon_sym_SEMI,
    STATE(6767), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [267548] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(11665), 1,
      anon_sym_SEMI,
    STATE(6783), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [267565] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(11667), 1,
      anon_sym_SEMI,
    STATE(6777), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [267582] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(11669), 1,
      anon_sym_SEMI,
    STATE(6795), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [267599] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(11671), 1,
      anon_sym_SEMI,
    STATE(4208), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [267616] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(11673), 1,
      anon_sym_SEMI,
    STATE(6738), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [267633] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11675), 1,
      anon_sym_COMMA,
    ACTIONS(11680), 1,
      anon_sym___attribute,
    STATE(6769), 1,
      aux_sym__type_definition_declarators_repeat1,
    ACTIONS(11678), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [267650] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(11682), 1,
      anon_sym_SEMI,
    STATE(6748), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [267667] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11684), 2,
      anon_sym_class,
      anon_sym_typename,
    STATE(7694), 3,
      sym_type_parameter_declaration,
      sym_variadic_type_parameter_declaration,
      sym_optional_type_parameter_declaration,
  [267680] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6320), 1,
      anon_sym_LBRACK,
    ACTIONS(6463), 1,
      anon_sym_LT,
    STATE(3656), 1,
      sym_template_argument_list,
    ACTIONS(6322), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK_LBRACK,
  [267697] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(11686), 1,
      anon_sym_SEMI,
    STATE(6784), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [267714] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(11688), 1,
      anon_sym_SEMI,
    STATE(6732), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [267731] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10606), 1,
      anon_sym_COLON,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3356), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
  [267750] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(11631), 1,
      sym_identifier,
    STATE(2145), 1,
      sym_template_type,
    STATE(2335), 1,
      sym_template_method,
    STATE(7530), 1,
      sym_operator_name,
  [267769] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(11690), 1,
      anon_sym_SEMI,
    STATE(4208), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [267786] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(11692), 1,
      anon_sym_SEMI,
    STATE(4208), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [267803] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10549), 1,
      anon_sym_COLON,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3356), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
  [267822] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10519), 1,
      anon_sym_COLON,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3356), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
  [267841] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8018), 1,
      anon_sym_LPAREN2,
    ACTIONS(11696), 1,
      anon_sym_COLON_COLON,
    STATE(7662), 1,
      sym_argument_list,
    ACTIONS(11694), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [267858] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(11698), 1,
      anon_sym_SEMI,
    STATE(6730), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [267875] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(11700), 1,
      anon_sym_SEMI,
    STATE(4208), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [267892] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(11702), 1,
      anon_sym_SEMI,
    STATE(4208), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [267909] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11168), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11170), 1,
      anon_sym_inline,
    ACTIONS(11704), 1,
      sym_identifier,
    STATE(7917), 1,
      sym__namespace_specifier,
    STATE(8608), 1,
      sym_nested_namespace_specifier,
  [267928] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11708), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11706), 4,
      anon_sym_virtual,
      sym_identifier,
      anon_sym_decltype,
      anon_sym_template,
  [267941] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8052), 1,
      sym_auto,
    ACTIONS(8054), 1,
      anon_sym_decltype,
    STATE(2454), 1,
      sym_decltype_auto,
    ACTIONS(11710), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [267958] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11168), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11170), 1,
      anon_sym_inline,
    ACTIONS(11659), 1,
      sym_identifier,
    STATE(7066), 1,
      sym__namespace_specifier,
    STATE(7470), 1,
      sym_nested_namespace_specifier,
  [267977] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    ACTIONS(11712), 1,
      anon_sym_RPAREN,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
  [267996] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(11714), 1,
      anon_sym_SEMI,
    STATE(6743), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [268013] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11168), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11170), 1,
      anon_sym_inline,
    ACTIONS(11716), 1,
      sym_identifier,
    STATE(7917), 1,
      sym__namespace_specifier,
    STATE(8156), 1,
      sym_nested_namespace_specifier,
  [268032] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11041), 1,
      anon_sym_COMMA,
    ACTIONS(11720), 1,
      anon_sym___attribute,
    STATE(6769), 1,
      aux_sym__type_definition_declarators_repeat1,
    ACTIONS(11718), 2,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [268049] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(11722), 1,
      anon_sym_SEMI,
    STATE(6778), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [268066] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(11724), 1,
      sym_identifier,
    STATE(2145), 1,
      sym_template_type,
    STATE(2335), 1,
      sym_template_method,
    STATE(7456), 1,
      sym_operator_name,
  [268085] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(11726), 1,
      anon_sym_SEMI,
    STATE(4208), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [268102] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(11728), 1,
      anon_sym_SEMI,
    STATE(4208), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [268119] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(11730), 1,
      anon_sym_SEMI,
    STATE(4208), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [268136] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(11732), 1,
      anon_sym_SEMI,
    STATE(4208), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [268153] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1823), 1,
      anon_sym_operator,
    ACTIONS(11734), 1,
      sym_identifier,
    STATE(2145), 1,
      sym_template_type,
    STATE(3414), 1,
      sym_template_method,
    STATE(7677), 1,
      sym_operator_name,
  [268172] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    ACTIONS(11736), 1,
      anon_sym_RPAREN,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
  [268191] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(43), 1,
      anon_sym___attribute,
    ACTIONS(7142), 1,
      anon_sym___attribute__,
    ACTIONS(11738), 1,
      anon_sym_SEMI,
    STATE(6759), 2,
      sym_attribute_specifier,
      aux_sym_type_definition_repeat1,
  [268208] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10482), 1,
      anon_sym_LBRACE,
    STATE(5542), 1,
      sym_compound_statement,
    ACTIONS(10326), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [268222] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10502), 1,
      anon_sym_LBRACE,
    STATE(3483), 1,
      sym_compound_statement,
    ACTIONS(10326), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [268236] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10478), 1,
      anon_sym_LBRACE,
    STATE(1601), 1,
      sym_compound_statement,
    ACTIONS(10326), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [268250] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10478), 1,
      anon_sym_LBRACE,
    STATE(1605), 1,
      sym_compound_statement,
    ACTIONS(10326), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [268264] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10488), 1,
      anon_sym_LBRACE,
    STATE(2445), 1,
      sym_compound_statement,
    ACTIONS(10326), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [268278] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1927), 1,
      anon_sym_LBRACE,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    STATE(2371), 1,
      sym_initializer_list,
    STATE(2409), 1,
      sym_argument_list,
  [268294] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10496), 1,
      anon_sym_LBRACE,
    STATE(3303), 1,
      sym_compound_statement,
    ACTIONS(10326), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [268308] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5383), 1,
      anon_sym_COLON,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    STATE(2888), 1,
      sym_field_declaration_list,
    STATE(7631), 1,
      sym_base_class_clause,
  [268324] = 5,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(11740), 1,
      anon_sym_DQUOTE,
    ACTIONS(11742), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11744), 1,
      sym_escape_sequence,
    STATE(6814), 1,
      aux_sym_string_literal_repeat1,
  [268340] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11746), 1,
      anon_sym_COMMA,
    STATE(6811), 1,
      aux_sym_gnu_asm_output_operand_list_repeat1,
    ACTIONS(11749), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [268354] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5383), 1,
      anon_sym_COLON,
    ACTIONS(6533), 1,
      anon_sym_LBRACE,
    STATE(2810), 1,
      sym_field_declaration_list,
    STATE(7486), 1,
      sym_base_class_clause,
  [268370] = 4,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(11751), 1,
      anon_sym_SQUOTE,
    STATE(7018), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11753), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [268384] = 5,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(11755), 1,
      anon_sym_DQUOTE,
    ACTIONS(11757), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11759), 1,
      sym_escape_sequence,
    STATE(7022), 1,
      aux_sym_string_literal_repeat1,
  [268400] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9595), 1,
      anon_sym_LBRACE,
    ACTIONS(11761), 1,
      anon_sym_LPAREN2,
    STATE(3557), 1,
      sym_requirement_seq,
    STATE(7625), 1,
      sym_requires_parameter_list,
  [268416] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5383), 1,
      anon_sym_COLON,
    ACTIONS(6533), 1,
      anon_sym_LBRACE,
    STATE(2825), 1,
      sym_field_declaration_list,
    STATE(7538), 1,
      sym_base_class_clause,
  [268432] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(11763), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11765), 1,
      anon_sym_GT2,
    STATE(7183), 1,
      aux_sym_template_argument_list_repeat1,
  [268448] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10482), 1,
      anon_sym_LBRACE,
    STATE(5458), 1,
      sym_compound_statement,
    ACTIONS(10326), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [268462] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11767), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [268472] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10482), 1,
      anon_sym_LBRACE,
    STATE(5412), 1,
      sym_compound_statement,
    ACTIONS(10326), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [268486] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11769), 1,
      anon_sym_COMMA,
    STATE(6913), 1,
      aux_sym_gnu_asm_input_operand_list_repeat1,
    ACTIONS(11771), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [268500] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5383), 1,
      anon_sym_COLON,
    ACTIONS(5878), 1,
      anon_sym_LBRACE,
    STATE(2313), 1,
      sym_field_declaration_list,
    STATE(7468), 1,
      sym_base_class_clause,
  [268516] = 5,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(11773), 1,
      anon_sym_DQUOTE,
    ACTIONS(11775), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11777), 1,
      sym_escape_sequence,
    STATE(6827), 1,
      aux_sym_string_literal_repeat1,
  [268532] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11779), 1,
      anon_sym_COMMA,
    STATE(6915), 1,
      aux_sym_gnu_asm_clobber_list_repeat1,
    ACTIONS(11781), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [268546] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5383), 1,
      anon_sym_COLON,
    ACTIONS(8638), 1,
      anon_sym_LBRACE,
    STATE(4823), 1,
      sym_field_declaration_list,
    STATE(7428), 1,
      sym_base_class_clause,
  [268562] = 4,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(11783), 1,
      anon_sym_SQUOTE,
    STATE(7018), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11753), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [268576] = 5,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(11757), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11759), 1,
      sym_escape_sequence,
    ACTIONS(11785), 1,
      anon_sym_DQUOTE,
    STATE(7022), 1,
      aux_sym_string_literal_repeat1,
  [268592] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11787), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11789), 1,
      anon_sym_COMMA,
    ACTIONS(11791), 1,
      anon_sym_LBRACE,
    STATE(7288), 1,
      aux_sym_base_class_clause_repeat1,
  [268608] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11793), 1,
      anon_sym_COMMA,
    STATE(6811), 1,
      aux_sym_gnu_asm_output_operand_list_repeat1,
    ACTIONS(11795), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [268622] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11761), 1,
      anon_sym_LPAREN2,
    ACTIONS(11797), 1,
      anon_sym_LBRACE,
    STATE(5785), 1,
      sym_requirement_seq,
    STATE(7618), 1,
      sym_requires_parameter_list,
  [268638] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    STATE(1598), 1,
      sym_compound_statement,
    ACTIONS(10326), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [268652] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6463), 1,
      anon_sym_LT,
    ACTIONS(11799), 1,
      anon_sym_SEMI,
    STATE(1570), 1,
      sym_template_argument_list,
  [268668] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5383), 1,
      anon_sym_COLON,
    ACTIONS(8638), 1,
      anon_sym_LBRACE,
    STATE(4838), 1,
      sym_field_declaration_list,
    STATE(7700), 1,
      sym_base_class_clause,
  [268684] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(11763), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11801), 1,
      anon_sym_GT2,
    STATE(7399), 1,
      aux_sym_template_argument_list_repeat1,
  [268700] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    STATE(1601), 1,
      sym_compound_statement,
    ACTIONS(10326), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [268714] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    STATE(1605), 1,
      sym_compound_statement,
    ACTIONS(10326), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [268728] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11769), 1,
      anon_sym_COMMA,
    STATE(6821), 1,
      aux_sym_gnu_asm_input_operand_list_repeat1,
    ACTIONS(11803), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [268742] = 4,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(11805), 1,
      anon_sym_SQUOTE,
    STATE(7018), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11753), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [268756] = 5,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(11757), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11759), 1,
      sym_escape_sequence,
    ACTIONS(11807), 1,
      anon_sym_DQUOTE,
    STATE(7022), 1,
      aux_sym_string_literal_repeat1,
  [268772] = 5,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(11809), 1,
      anon_sym_DQUOTE,
    ACTIONS(11811), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11813), 1,
      sym_escape_sequence,
    STATE(6843), 1,
      aux_sym_string_literal_repeat1,
  [268788] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5383), 1,
      anon_sym_COLON,
    ACTIONS(7417), 1,
      anon_sym_LBRACE,
    STATE(3882), 1,
      sym_field_declaration_list,
    STATE(7461), 1,
      sym_base_class_clause,
  [268804] = 4,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(11815), 1,
      anon_sym_SQUOTE,
    STATE(7018), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11753), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [268818] = 5,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(11757), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11759), 1,
      sym_escape_sequence,
    ACTIONS(11817), 1,
      anon_sym_DQUOTE,
    STATE(7022), 1,
      aux_sym_string_literal_repeat1,
  [268834] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10480), 1,
      anon_sym_LBRACE,
    STATE(5831), 1,
      sym_compound_statement,
    ACTIONS(10326), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [268848] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5383), 1,
      anon_sym_COLON,
    ACTIONS(7417), 1,
      anon_sym_LBRACE,
    STATE(3924), 1,
      sym_field_declaration_list,
    STATE(7465), 1,
      sym_base_class_clause,
  [268864] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(11763), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11819), 1,
      anon_sym_GT2,
    STATE(7103), 1,
      aux_sym_template_argument_list_repeat1,
  [268880] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10480), 1,
      anon_sym_LBRACE,
    STATE(5825), 1,
      sym_compound_statement,
    ACTIONS(10326), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [268894] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10480), 1,
      anon_sym_LBRACE,
    STATE(5818), 1,
      sym_compound_statement,
    ACTIONS(10326), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [268908] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11821), 1,
      anon_sym_EQ,
    STATE(7001), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [268922] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8558), 1,
      anon_sym___attribute,
    ACTIONS(8556), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [268934] = 5,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(11823), 1,
      anon_sym_DQUOTE,
    ACTIONS(11825), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11827), 1,
      sym_escape_sequence,
    STATE(6854), 1,
      aux_sym_string_literal_repeat1,
  [268950] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5029), 1,
      anon_sym_LBRACE,
    ACTIONS(11829), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11831), 1,
      anon_sym_EQ,
    STATE(662), 1,
      sym_declaration_list,
  [268966] = 4,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(11833), 1,
      anon_sym_SQUOTE,
    STATE(7018), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11753), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [268980] = 5,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(11757), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11759), 1,
      sym_escape_sequence,
    ACTIONS(11835), 1,
      anon_sym_DQUOTE,
    STATE(7022), 1,
      aux_sym_string_literal_repeat1,
  [268996] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(11763), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11837), 1,
      anon_sym_GT2,
    STATE(7140), 1,
      aux_sym_template_argument_list_repeat1,
  [269012] = 5,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(11839), 1,
      anon_sym_DQUOTE,
    ACTIONS(11841), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11843), 1,
      sym_escape_sequence,
    STATE(6888), 1,
      aux_sym_string_literal_repeat1,
  [269028] = 5,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(11845), 1,
      anon_sym_DQUOTE,
    ACTIONS(11847), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11849), 1,
      sym_escape_sequence,
    STATE(6859), 1,
      aux_sym_string_literal_repeat1,
  [269044] = 4,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(11851), 1,
      anon_sym_SQUOTE,
    STATE(7018), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11753), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [269058] = 5,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(11757), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11759), 1,
      sym_escape_sequence,
    ACTIONS(11853), 1,
      anon_sym_DQUOTE,
    STATE(7022), 1,
      aux_sym_string_literal_repeat1,
  [269074] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(11763), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11855), 1,
      anon_sym_GT2,
    STATE(7173), 1,
      aux_sym_template_argument_list_repeat1,
  [269090] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11767), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_try,
  [269100] = 5,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(11857), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(11859), 1,
      anon_sym_LPAREN,
    ACTIONS(11861), 1,
      sym_preproc_arg,
    STATE(7676), 1,
      sym_preproc_params,
  [269116] = 5,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(11863), 1,
      anon_sym_DQUOTE,
    ACTIONS(11865), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11867), 1,
      sym_escape_sequence,
    STATE(6864), 1,
      aux_sym_string_literal_repeat1,
  [269132] = 5,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(11757), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11759), 1,
      sym_escape_sequence,
    ACTIONS(11869), 1,
      anon_sym_DQUOTE,
    STATE(7022), 1,
      aux_sym_string_literal_repeat1,
  [269148] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(11763), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11871), 1,
      anon_sym_GT2,
    STATE(7212), 1,
      aux_sym_template_argument_list_repeat1,
  [269164] = 5,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(11873), 1,
      anon_sym_DQUOTE,
    ACTIONS(11875), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11877), 1,
      sym_escape_sequence,
    STATE(6869), 1,
      aux_sym_string_literal_repeat1,
  [269180] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9603), 1,
      anon_sym_LBRACE,
    ACTIONS(11761), 1,
      anon_sym_LPAREN2,
    STATE(3455), 1,
      sym_requirement_seq,
    STATE(7547), 1,
      sym_requires_parameter_list,
  [269196] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3730), 1,
      anon_sym_LBRACE,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    STATE(3516), 1,
      sym_argument_list,
    STATE(4749), 1,
      sym_initializer_list,
  [269212] = 5,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(11757), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11759), 1,
      sym_escape_sequence,
    ACTIONS(11879), 1,
      anon_sym_DQUOTE,
    STATE(7022), 1,
      aux_sym_string_literal_repeat1,
  [269228] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(11763), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11881), 1,
      anon_sym_GT2,
    STATE(7248), 1,
      aux_sym_template_argument_list_repeat1,
  [269244] = 5,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(11883), 1,
      anon_sym_DQUOTE,
    ACTIONS(11885), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11887), 1,
      sym_escape_sequence,
    STATE(6872), 1,
      aux_sym_string_literal_repeat1,
  [269260] = 5,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(11757), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11759), 1,
      sym_escape_sequence,
    ACTIONS(11889), 1,
      anon_sym_DQUOTE,
    STATE(7022), 1,
      aux_sym_string_literal_repeat1,
  [269276] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(11763), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11891), 1,
      anon_sym_GT2,
    STATE(7270), 1,
      aux_sym_template_argument_list_repeat1,
  [269292] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(10765), 1,
      anon_sym_COLON,
    STATE(7089), 1,
      sym_compound_statement,
    STATE(7463), 1,
      sym_field_initializer_list,
  [269308] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_LBRACE,
    ACTIONS(5688), 1,
      anon_sym_LPAREN2,
    STATE(2409), 1,
      sym_argument_list,
    STATE(3793), 1,
      sym_initializer_list,
  [269324] = 5,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(11859), 1,
      anon_sym_LPAREN,
    ACTIONS(11893), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(11895), 1,
      sym_preproc_arg,
    STATE(7458), 1,
      sym_preproc_params,
  [269340] = 5,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(11897), 1,
      anon_sym_DQUOTE,
    ACTIONS(11899), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11901), 1,
      sym_escape_sequence,
    STATE(6879), 1,
      aux_sym_string_literal_repeat1,
  [269356] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5381), 1,
      anon_sym_LBRACE,
    ACTIONS(5383), 1,
      anon_sym_COLON,
    STATE(2127), 1,
      sym_field_declaration_list,
    STATE(7727), 1,
      sym_base_class_clause,
  [269372] = 5,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(11757), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11759), 1,
      sym_escape_sequence,
    ACTIONS(11903), 1,
      anon_sym_DQUOTE,
    STATE(7022), 1,
      aux_sym_string_literal_repeat1,
  [269388] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(11763), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11905), 1,
      anon_sym_GT2,
    STATE(7313), 1,
      aux_sym_template_argument_list_repeat1,
  [269404] = 5,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(11907), 1,
      anon_sym_DQUOTE,
    ACTIONS(11909), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11911), 1,
      sym_escape_sequence,
    STATE(6882), 1,
      aux_sym_string_literal_repeat1,
  [269420] = 5,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(11757), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11759), 1,
      sym_escape_sequence,
    ACTIONS(11913), 1,
      anon_sym_DQUOTE,
    STATE(7022), 1,
      aux_sym_string_literal_repeat1,
  [269436] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(11763), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11915), 1,
      anon_sym_GT2,
    STATE(7358), 1,
      aux_sym_template_argument_list_repeat1,
  [269452] = 5,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(11917), 1,
      anon_sym_DQUOTE,
    ACTIONS(11919), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11921), 1,
      sym_escape_sequence,
    STATE(6886), 1,
      aux_sym_string_literal_repeat1,
  [269468] = 4,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(11923), 1,
      anon_sym_SQUOTE,
    STATE(7018), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11753), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [269482] = 5,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(11757), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11759), 1,
      sym_escape_sequence,
    ACTIONS(11925), 1,
      anon_sym_DQUOTE,
    STATE(7022), 1,
      aux_sym_string_literal_repeat1,
  [269498] = 5,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(11927), 1,
      anon_sym_DQUOTE,
    ACTIONS(11929), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11931), 1,
      sym_escape_sequence,
    STATE(6889), 1,
      aux_sym_string_literal_repeat1,
  [269514] = 5,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(11757), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11759), 1,
      sym_escape_sequence,
    ACTIONS(11933), 1,
      anon_sym_DQUOTE,
    STATE(7022), 1,
      aux_sym_string_literal_repeat1,
  [269530] = 5,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(11757), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11759), 1,
      sym_escape_sequence,
    ACTIONS(11935), 1,
      anon_sym_DQUOTE,
    STATE(7022), 1,
      aux_sym_string_literal_repeat1,
  [269546] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5039), 1,
      anon_sym_LBRACE,
    ACTIONS(11829), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11937), 1,
      anon_sym_EQ,
    STATE(617), 1,
      sym_declaration_list,
  [269562] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9613), 1,
      anon_sym_LBRACE,
    ACTIONS(11761), 1,
      anon_sym_LPAREN2,
    STATE(4180), 1,
      sym_requirement_seq,
    STATE(7655), 1,
      sym_requires_parameter_list,
  [269578] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10496), 1,
      anon_sym_LBRACE,
    STATE(3243), 1,
      sym_compound_statement,
    ACTIONS(10326), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [269592] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10476), 1,
      anon_sym_LBRACE,
    STATE(4166), 1,
      sym_compound_statement,
    ACTIONS(10326), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [269606] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10502), 1,
      anon_sym_LBRACE,
    STATE(3359), 1,
      sym_compound_statement,
    ACTIONS(10326), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [269620] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(10765), 1,
      anon_sym_COLON,
    STATE(7172), 1,
      sym_compound_statement,
    STATE(7737), 1,
      sym_field_initializer_list,
  [269636] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11939), 1,
      anon_sym___except,
    ACTIONS(11941), 1,
      anon_sym___finally,
    STATE(518), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [269650] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11943), 1,
      anon_sym___except,
    ACTIONS(11945), 1,
      anon_sym___finally,
    STATE(454), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [269664] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4885), 1,
      anon_sym_LT,
    ACTIONS(11947), 1,
      sym_identifier,
    STATE(796), 1,
      sym_template_parameter_list,
    STATE(2145), 1,
      sym_template_type,
  [269680] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5381), 1,
      anon_sym_LBRACE,
    ACTIONS(5383), 1,
      anon_sym_COLON,
    STATE(2150), 1,
      sym_field_declaration_list,
    STATE(7446), 1,
      sym_base_class_clause,
  [269696] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(11763), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11949), 1,
      anon_sym_GT2,
    STATE(7081), 1,
      aux_sym_template_argument_list_repeat1,
  [269712] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6463), 1,
      anon_sym_LT,
    ACTIONS(11951), 1,
      anon_sym_SEMI,
    STATE(1570), 1,
      sym_template_argument_list,
  [269728] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10872), 1,
      sym_identifier,
    ACTIONS(11953), 1,
      aux_sym_preproc_if_token2,
    STATE(6551), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(7960), 1,
      sym_enumerator,
  [269744] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10673), 1,
      sym_identifier,
    ACTIONS(11955), 1,
      aux_sym_preproc_if_token2,
    STATE(6914), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
  [269758] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11355), 1,
      anon_sym_EQ,
    STATE(6932), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [269772] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6463), 1,
      anon_sym_LT,
    STATE(1565), 1,
      sym_template_argument_list,
    ACTIONS(6322), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [269786] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10476), 1,
      anon_sym_LBRACE,
    STATE(4172), 1,
      sym_compound_statement,
    ACTIONS(10326), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [269800] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11957), 1,
      anon_sym___except,
    ACTIONS(11959), 1,
      anon_sym___finally,
    STATE(440), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [269814] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_LBRACE,
    ACTIONS(8018), 1,
      anon_sym_LPAREN2,
    STATE(7272), 2,
      sym_argument_list,
      sym_initializer_list,
  [269828] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10476), 1,
      anon_sym_LBRACE,
    STATE(4174), 1,
      sym_compound_statement,
    ACTIONS(10326), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [269842] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11961), 1,
      sym_identifier,
    ACTIONS(11963), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [269854] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4885), 1,
      anon_sym_LT,
    ACTIONS(11947), 1,
      sym_identifier,
    STATE(798), 1,
      sym_template_parameter_list,
    STATE(2145), 1,
      sym_template_type,
  [269870] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8018), 1,
      anon_sym_LPAREN2,
    STATE(7479), 1,
      sym_argument_list,
    ACTIONS(11965), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [269884] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11967), 1,
      anon_sym_COMMA,
    STATE(6913), 1,
      aux_sym_gnu_asm_input_operand_list_repeat1,
    ACTIONS(11970), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [269898] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10673), 1,
      sym_identifier,
    ACTIONS(11972), 1,
      aux_sym_preproc_if_token2,
    STATE(6563), 2,
      sym_enumerator,
      aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1,
  [269912] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11779), 1,
      anon_sym_COMMA,
    STATE(6946), 1,
      aux_sym_gnu_asm_clobber_list_repeat1,
    ACTIONS(11974), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [269926] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5383), 1,
      anon_sym_COLON,
    ACTIONS(5878), 1,
      anon_sym_LBRACE,
    STATE(2318), 1,
      sym_field_declaration_list,
    STATE(7658), 1,
      sym_base_class_clause,
  [269942] = 4,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(11976), 1,
      anon_sym_SQUOTE,
    STATE(7018), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11753), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [269956] = 5,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(11978), 1,
      anon_sym_DQUOTE,
    ACTIONS(11980), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11982), 1,
      sym_escape_sequence,
    STATE(6943), 1,
      aux_sym_string_literal_repeat1,
  [269972] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(11763), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(11984), 1,
      anon_sym_GT2,
    STATE(7351), 1,
      aux_sym_template_argument_list_repeat1,
  [269988] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    ACTIONS(10890), 1,
      anon_sym_LBRACK,
    STATE(3055), 1,
      sym_parameter_list,
    STATE(5943), 1,
      sym__function_declarator_seq,
  [270004] = 5,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(11986), 1,
      anon_sym_DQUOTE,
    ACTIONS(11988), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11990), 1,
      sym_escape_sequence,
    STATE(6930), 1,
      aux_sym_string_literal_repeat1,
  [270020] = 5,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(11859), 1,
      anon_sym_LPAREN,
    ACTIONS(11992), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(11994), 1,
      sym_preproc_arg,
    STATE(7587), 1,
      sym_preproc_params,
  [270036] = 5,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(11859), 1,
      anon_sym_LPAREN,
    ACTIONS(11996), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(11998), 1,
      sym_preproc_arg,
    STATE(7514), 1,
      sym_preproc_params,
  [270052] = 5,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(11757), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11759), 1,
      sym_escape_sequence,
    ACTIONS(12000), 1,
      anon_sym_DQUOTE,
    STATE(7022), 1,
      aux_sym_string_literal_repeat1,
  [270068] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2456), 1,
      anon_sym_LBRACE,
    ACTIONS(6790), 1,
      anon_sym_LPAREN2,
    STATE(3516), 1,
      sym_argument_list,
    STATE(3547), 1,
      sym_initializer_list,
  [270084] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6463), 1,
      anon_sym_LT,
    ACTIONS(12002), 1,
      anon_sym_SEMI,
    STATE(1570), 1,
      sym_template_argument_list,
  [270100] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5383), 1,
      anon_sym_COLON,
    ACTIONS(6222), 1,
      anon_sym_LBRACE,
    STATE(2578), 1,
      sym_field_declaration_list,
    STATE(7534), 1,
      sym_base_class_clause,
  [270116] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2031), 1,
      anon_sym_LBRACE,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    STATE(3343), 1,
      sym_argument_list,
    STATE(3353), 1,
      sym_initializer_list,
  [270132] = 4,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(12004), 1,
      anon_sym_SQUOTE,
    STATE(7018), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11753), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [270146] = 5,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(11757), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11759), 1,
      sym_escape_sequence,
    ACTIONS(12006), 1,
      anon_sym_DQUOTE,
    STATE(7022), 1,
      aux_sym_string_literal_repeat1,
  [270162] = 5,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(12008), 1,
      anon_sym_DQUOTE,
    ACTIONS(12010), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12012), 1,
      sym_escape_sequence,
    STATE(6924), 1,
      aux_sym_string_literal_repeat1,
  [270178] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12014), 1,
      anon_sym_EQ,
    STATE(5783), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [270192] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12018), 1,
      anon_sym___attribute,
    ACTIONS(12016), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [270204] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12022), 1,
      anon_sym___attribute,
    ACTIONS(12020), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym___attribute__,
  [270216] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11761), 1,
      anon_sym_LPAREN2,
    ACTIONS(12024), 1,
      anon_sym_LBRACE,
    STATE(1591), 1,
      sym_requirement_seq,
    STATE(7723), 1,
      sym_requires_parameter_list,
  [270232] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10500), 1,
      anon_sym_LBRACE,
    STATE(3817), 1,
      sym_compound_statement,
    ACTIONS(10326), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [270246] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5383), 1,
      anon_sym_COLON,
    ACTIONS(6253), 1,
      anon_sym_LBRACE,
    STATE(2728), 1,
      sym_field_declaration_list,
    STATE(7641), 1,
      sym_base_class_clause,
  [270262] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(10765), 1,
      anon_sym_COLON,
    STATE(7338), 1,
      sym_compound_statement,
    STATE(7529), 1,
      sym_field_initializer_list,
  [270278] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12026), 1,
      anon_sym___except,
    ACTIONS(12028), 1,
      anon_sym___finally,
    STATE(864), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [270292] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4885), 1,
      anon_sym_LT,
    ACTIONS(11947), 1,
      sym_identifier,
    STATE(800), 1,
      sym_template_parameter_list,
    STATE(2145), 1,
      sym_template_type,
  [270308] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5383), 1,
      anon_sym_COLON,
    ACTIONS(6222), 1,
      anon_sym_LBRACE,
    STATE(2541), 1,
      sym_field_declaration_list,
    STATE(7556), 1,
      sym_base_class_clause,
  [270324] = 4,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(12030), 1,
      anon_sym_SQUOTE,
    STATE(7018), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11753), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [270338] = 5,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(11757), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11759), 1,
      sym_escape_sequence,
    ACTIONS(12032), 1,
      anon_sym_DQUOTE,
    STATE(7022), 1,
      aux_sym_string_literal_repeat1,
  [270354] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(11763), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12034), 1,
      anon_sym_GT2,
    STATE(7208), 1,
      aux_sym_template_argument_list_repeat1,
  [270370] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6463), 1,
      anon_sym_LT,
    ACTIONS(12036), 1,
      anon_sym_SEMI,
    STATE(1570), 1,
      sym_template_argument_list,
  [270386] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12038), 1,
      anon_sym_COMMA,
    STATE(6946), 1,
      aux_sym_gnu_asm_clobber_list_repeat1,
    ACTIONS(12041), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [270400] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5041), 1,
      anon_sym_LBRACE,
    ACTIONS(11829), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12043), 1,
      anon_sym_EQ,
    STATE(364), 1,
      sym_declaration_list,
  [270416] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10500), 1,
      anon_sym_LBRACE,
    STATE(3868), 1,
      sym_compound_statement,
    ACTIONS(10326), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [270430] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9587), 1,
      anon_sym_LBRACE,
    ACTIONS(11761), 1,
      anon_sym_LPAREN2,
    STATE(2406), 1,
      sym_requirement_seq,
    STATE(7557), 1,
      sym_requires_parameter_list,
  [270446] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5037), 1,
      anon_sym_LBRACE,
    ACTIONS(11829), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12045), 1,
      anon_sym_EQ,
    STATE(723), 1,
      sym_declaration_list,
  [270462] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(10765), 1,
      anon_sym_COLON,
    STATE(7057), 1,
      sym_compound_statement,
    STATE(7565), 1,
      sym_field_initializer_list,
  [270478] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4885), 1,
      anon_sym_LT,
    ACTIONS(11947), 1,
      sym_identifier,
    STATE(797), 1,
      sym_template_parameter_list,
    STATE(2145), 1,
      sym_template_type,
  [270494] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4885), 1,
      anon_sym_LT,
    ACTIONS(11947), 1,
      sym_identifier,
    STATE(801), 1,
      sym_template_parameter_list,
    STATE(2145), 1,
      sym_template_type,
  [270510] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10500), 1,
      anon_sym_LBRACE,
    STATE(3805), 1,
      sym_compound_statement,
    ACTIONS(10326), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [270524] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10496), 1,
      anon_sym_LBRACE,
    STATE(3300), 1,
      sym_compound_statement,
    ACTIONS(10326), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [270538] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4885), 1,
      anon_sym_LT,
    ACTIONS(11947), 1,
      sym_identifier,
    STATE(2145), 1,
      sym_template_type,
    STATE(6771), 1,
      sym_template_parameter_list,
  [270554] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11789), 1,
      anon_sym_COMMA,
    ACTIONS(12047), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12049), 1,
      anon_sym_LBRACE,
    STATE(7354), 1,
      aux_sym_base_class_clause_repeat1,
  [270570] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10488), 1,
      anon_sym_LBRACE,
    STATE(2439), 1,
      sym_compound_statement,
    ACTIONS(10326), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [270584] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(10765), 1,
      anon_sym_COLON,
    STATE(7187), 1,
      sym_compound_statement,
    STATE(7585), 1,
      sym_field_initializer_list,
  [270600] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10502), 1,
      anon_sym_LBRACE,
    STATE(3416), 1,
      sym_compound_statement,
    ACTIONS(10326), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [270614] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4885), 1,
      anon_sym_LT,
    ACTIONS(11947), 1,
      sym_identifier,
    STATE(795), 1,
      sym_template_parameter_list,
    STATE(2145), 1,
      sym_template_type,
  [270630] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11789), 1,
      anon_sym_COMMA,
    ACTIONS(12051), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12053), 1,
      anon_sym_LBRACE,
    STATE(7039), 1,
      aux_sym_base_class_clause_repeat1,
  [270646] = 5,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(12055), 1,
      anon_sym_DQUOTE,
    ACTIONS(12057), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12059), 1,
      sym_escape_sequence,
    STATE(6973), 1,
      aux_sym_string_literal_repeat1,
  [270662] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(10765), 1,
      anon_sym_COLON,
    STATE(7312), 1,
      sym_compound_statement,
    STATE(7600), 1,
      sym_field_initializer_list,
  [270678] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4840), 1,
      anon_sym_SEMI,
    ACTIONS(6463), 1,
      anon_sym_LT,
    STATE(1668), 1,
      sym_template_argument_list,
  [270694] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4885), 1,
      anon_sym_LT,
    ACTIONS(11947), 1,
      sym_identifier,
    STATE(799), 1,
      sym_template_parameter_list,
    STATE(2145), 1,
      sym_template_type,
  [270710] = 5,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(11859), 1,
      anon_sym_LPAREN,
    ACTIONS(12061), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(12063), 1,
      sym_preproc_arg,
    STATE(7638), 1,
      sym_preproc_params,
  [270726] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2581), 1,
      anon_sym_LBRACE,
    ACTIONS(6749), 1,
      anon_sym_LPAREN2,
    STATE(3343), 1,
      sym_argument_list,
    STATE(3775), 1,
      sym_initializer_list,
  [270742] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12065), 1,
      anon_sym___except,
    ACTIONS(12067), 1,
      anon_sym___finally,
    STATE(242), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [270756] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(10765), 1,
      anon_sym_COLON,
    STATE(7426), 1,
      sym_compound_statement,
    STATE(7616), 1,
      sym_field_initializer_list,
  [270772] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5383), 1,
      anon_sym_COLON,
    ACTIONS(6648), 1,
      anon_sym_LBRACE,
    STATE(2957), 1,
      sym_field_declaration_list,
    STATE(7651), 1,
      sym_base_class_clause,
  [270788] = 4,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(12069), 1,
      anon_sym_SQUOTE,
    STATE(7018), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11753), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [270802] = 5,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(11757), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11759), 1,
      sym_escape_sequence,
    ACTIONS(12071), 1,
      anon_sym_DQUOTE,
    STATE(7022), 1,
      aux_sym_string_literal_repeat1,
  [270818] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5383), 1,
      anon_sym_COLON,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    STATE(2920), 1,
      sym_field_declaration_list,
    STATE(7433), 1,
      sym_base_class_clause,
  [270834] = 5,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(12073), 1,
      anon_sym_DQUOTE,
    ACTIONS(12075), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12077), 1,
      sym_escape_sequence,
    STATE(6839), 1,
      aux_sym_string_literal_repeat1,
  [270850] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9621), 1,
      anon_sym_LBRACE,
    ACTIONS(11761), 1,
      anon_sym_LPAREN2,
    STATE(3812), 1,
      sym_requirement_seq,
    STATE(7503), 1,
      sym_requires_parameter_list,
  [270866] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10504), 1,
      anon_sym_LBRACE,
    STATE(3556), 1,
      sym_compound_statement,
    ACTIONS(10326), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [270880] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11789), 1,
      anon_sym_COMMA,
    ACTIONS(12079), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12081), 1,
      anon_sym_LBRACE,
    STATE(7159), 1,
      aux_sym_base_class_clause_repeat1,
  [270896] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5383), 1,
      anon_sym_COLON,
    ACTIONS(6253), 1,
      anon_sym_LBRACE,
    STATE(2800), 1,
      sym_field_declaration_list,
    STATE(7732), 1,
      sym_base_class_clause,
  [270912] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12083), 1,
      anon_sym_EQ,
    STATE(5783), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [270926] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(11763), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12085), 1,
      anon_sym_GT2,
    STATE(7413), 1,
      aux_sym_template_argument_list_repeat1,
  [270942] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5383), 1,
      anon_sym_COLON,
    ACTIONS(6648), 1,
      anon_sym_LBRACE,
    STATE(2965), 1,
      sym_field_declaration_list,
    STATE(7667), 1,
      sym_base_class_clause,
  [270958] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12087), 1,
      anon_sym_EQ,
    STATE(7004), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [270972] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(11763), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12089), 1,
      anon_sym_GT2,
    STATE(7327), 1,
      aux_sym_template_argument_list_repeat1,
  [270988] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6463), 1,
      anon_sym_LT,
    ACTIONS(12091), 1,
      anon_sym_SEMI,
    STATE(1570), 1,
      sym_template_argument_list,
  [271004] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6463), 1,
      anon_sym_LT,
    ACTIONS(12093), 1,
      anon_sym_SEMI,
    STATE(1570), 1,
      sym_template_argument_list,
  [271020] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10872), 1,
      sym_identifier,
    ACTIONS(11661), 1,
      aux_sym_preproc_if_token2,
    STATE(6902), 1,
      aux_sym_preproc_if_in_enumerator_list_repeat1,
    STATE(7960), 1,
      sym_enumerator,
  [271036] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10504), 1,
      anon_sym_LBRACE,
    STATE(3596), 1,
      sym_compound_statement,
    ACTIONS(10326), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [271050] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11793), 1,
      anon_sym_COMMA,
    STATE(6829), 1,
      aux_sym_gnu_asm_output_operand_list_repeat1,
    ACTIONS(12095), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [271064] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9579), 1,
      anon_sym_LBRACE,
    ACTIONS(11761), 1,
      anon_sym_LPAREN2,
    STATE(3175), 1,
      sym_requirement_seq,
    STATE(7710), 1,
      sym_requires_parameter_list,
  [271080] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10504), 1,
      anon_sym_LBRACE,
    STATE(3510), 1,
      sym_compound_statement,
    ACTIONS(10326), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [271094] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5383), 1,
      anon_sym_COLON,
    ACTIONS(5878), 1,
      anon_sym_LBRACE,
    STATE(5094), 1,
      sym_field_declaration_list,
    STATE(7683), 1,
      sym_base_class_clause,
  [271110] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5383), 1,
      anon_sym_COLON,
    ACTIONS(5878), 1,
      anon_sym_LBRACE,
    STATE(4988), 1,
      sym_field_declaration_list,
    STATE(7684), 1,
      sym_base_class_clause,
  [271126] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10488), 1,
      anon_sym_LBRACE,
    STATE(2405), 1,
      sym_compound_statement,
    ACTIONS(10326), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [271140] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12097), 1,
      anon_sym_EQ,
    STATE(5783), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [271154] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11280), 1,
      anon_sym_EQ,
    STATE(6980), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [271168] = 5,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(12099), 1,
      anon_sym_DQUOTE,
    ACTIONS(12101), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12103), 1,
      sym_escape_sequence,
    STATE(7013), 1,
      aux_sym_string_literal_repeat1,
  [271184] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12105), 1,
      anon_sym_EQ,
    STATE(5783), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [271198] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11336), 1,
      anon_sym_EQ,
    STATE(6995), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [271212] = 5,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(11859), 1,
      anon_sym_LPAREN,
    ACTIONS(12107), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(12109), 1,
      sym_preproc_arg,
    STATE(7729), 1,
      sym_preproc_params,
  [271228] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12111), 1,
      anon_sym_EQ,
    STATE(5783), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [271242] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11292), 1,
      anon_sym_EQ,
    STATE(6998), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [271256] = 5,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(11859), 1,
      anon_sym_LPAREN,
    ACTIONS(12113), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(12115), 1,
      sym_preproc_arg,
    STATE(7743), 1,
      sym_preproc_params,
  [271272] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12117), 1,
      anon_sym_EQ,
    STATE(5783), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [271286] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11309), 1,
      anon_sym_EQ,
    STATE(7006), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [271300] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12119), 1,
      anon_sym_EQ,
    STATE(5783), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [271314] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11359), 1,
      anon_sym_EQ,
    STATE(7008), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [271328] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12121), 1,
      anon_sym_EQ,
    STATE(5783), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [271342] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(11326), 1,
      anon_sym_EQ,
    STATE(7011), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [271356] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5383), 1,
      anon_sym_COLON,
    ACTIONS(8479), 1,
      anon_sym_LBRACE,
    STATE(4440), 1,
      sym_field_declaration_list,
    STATE(7735), 1,
      sym_base_class_clause,
  [271372] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK_LBRACK,
    ACTIONS(12123), 1,
      anon_sym_EQ,
    STATE(5783), 2,
      sym_attribute_declaration,
      aux_sym_attributed_declarator_repeat1,
  [271386] = 4,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(12125), 1,
      anon_sym_SQUOTE,
    STATE(7018), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(11753), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [271400] = 5,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(11757), 1,
      aux_sym_string_literal_token1,
    ACTIONS(11759), 1,
      sym_escape_sequence,
    ACTIONS(12127), 1,
      anon_sym_DQUOTE,
    STATE(7022), 1,
      aux_sym_string_literal_repeat1,
  [271416] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5383), 1,
      anon_sym_COLON,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    STATE(3617), 1,
      sym_field_declaration_list,
    STATE(7716), 1,
      sym_base_class_clause,
  [271432] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5383), 1,
      anon_sym_COLON,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    STATE(3620), 1,
      sym_field_declaration_list,
    STATE(7717), 1,
      sym_base_class_clause,
  [271448] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12129), 1,
      anon_sym_SEMI,
    ACTIONS(12131), 1,
      anon_sym_DASH_GT,
    ACTIONS(12133), 1,
      anon_sym_noexcept,
    STATE(7891), 1,
      sym_trailing_return_type,
  [271464] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11761), 1,
      anon_sym_LPAREN2,
    ACTIONS(12135), 1,
      anon_sym_LBRACE,
    STATE(5457), 1,
      sym_requirement_seq,
    STATE(7435), 1,
      sym_requires_parameter_list,
  [271480] = 4,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(12137), 1,
      anon_sym_SQUOTE,
    STATE(7018), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12139), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [271494] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10478), 1,
      anon_sym_LBRACE,
    STATE(1598), 1,
      sym_compound_statement,
    ACTIONS(10326), 2,
      anon_sym_LPAREN2,
      anon_sym_LBRACK,
  [271508] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5383), 1,
      anon_sym_COLON,
    ACTIONS(8479), 1,
      anon_sym_LBRACE,
    STATE(4467), 1,
      sym_field_declaration_list,
    STATE(7429), 1,
      sym_base_class_clause,
  [271524] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(11763), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12142), 1,
      anon_sym_GT2,
    STATE(7058), 1,
      aux_sym_template_argument_list_repeat1,
  [271540] = 5,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(12144), 1,
      anon_sym_DQUOTE,
    ACTIONS(12146), 1,
      aux_sym_string_literal_token1,
    ACTIONS(12149), 1,
      sym_escape_sequence,
    STATE(7022), 1,
      aux_sym_string_literal_repeat1,
  [271556] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6463), 1,
      anon_sym_LT,
    ACTIONS(12152), 1,
      anon_sym_SEMI,
    STATE(1570), 1,
      sym_template_argument_list,
  [271572] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(11763), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12154), 1,
      anon_sym_GT2,
    STATE(7047), 1,
      aux_sym_template_argument_list_repeat1,
  [271588] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12156), 1,
      anon_sym___except,
    ACTIONS(12158), 1,
      anon_sym___finally,
    STATE(454), 2,
      sym_seh_except_clause,
      sym_seh_finally_clause,
  [271602] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12160), 3,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
  [271611] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12162), 1,
      anon_sym_default,
    ACTIONS(12164), 1,
      anon_sym_delete,
    ACTIONS(12166), 1,
      aux_sym_pure_virtual_clause_token1,
  [271624] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8608), 1,
      anon_sym_COMMA,
    ACTIONS(8707), 1,
      anon_sym_RPAREN,
    STATE(7128), 1,
      aux_sym_argument_list_repeat1,
  [271637] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12168), 1,
      anon_sym_COMMA,
    ACTIONS(12170), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7108), 1,
      aux_sym_attribute_declaration_repeat1,
  [271650] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9879), 1,
      anon_sym_COMMA,
    ACTIONS(12172), 1,
      anon_sym_RPAREN,
    STATE(7246), 1,
      aux_sym_preproc_argument_list_repeat1,
  [271663] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12174), 1,
      anon_sym_COMMA,
    ACTIONS(12176), 1,
      anon_sym_RPAREN,
    STATE(7194), 1,
      aux_sym_preproc_params_repeat1,
  [271676] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8608), 1,
      anon_sym_COMMA,
    ACTIONS(8610), 1,
      anon_sym_RPAREN,
    STATE(7069), 1,
      aux_sym_argument_list_repeat1,
  [271689] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12178), 1,
      sym_identifier,
    STATE(1787), 1,
      sym_template_type,
    STATE(3310), 1,
      sym_template_function,
  [271702] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12180), 1,
      sym_identifier,
    STATE(2145), 1,
      sym_template_type,
    STATE(2765), 1,
      sym_template_function,
  [271715] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12182), 1,
      anon_sym_RPAREN,
    ACTIONS(12184), 1,
      anon_sym_COLON,
    STATE(7235), 1,
      sym_gnu_asm_input_operand_list,
  [271728] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5039), 1,
      anon_sym_LBRACE,
    ACTIONS(11829), 1,
      anon_sym_COLON_COLON,
    STATE(640), 1,
      sym_declaration_list,
  [271741] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12168), 1,
      anon_sym_COMMA,
    ACTIONS(12186), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7376), 1,
      aux_sym_attribute_declaration_repeat1,
  [271754] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8612), 1,
      anon_sym_COMMA,
    ACTIONS(8614), 1,
      anon_sym_RBRACE,
    STATE(7072), 1,
      aux_sym_initializer_list_repeat1,
  [271767] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11789), 1,
      anon_sym_COMMA,
    ACTIONS(11791), 1,
      anon_sym_LBRACE,
    STATE(7294), 1,
      aux_sym_base_class_clause_repeat1,
  [271780] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12188), 1,
      anon_sym_GT2,
    STATE(7347), 1,
      aux_sym_template_argument_list_repeat1,
  [271793] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12190), 1,
      anon_sym_RPAREN,
    ACTIONS(12192), 1,
      anon_sym_COLON,
    STATE(7259), 1,
      sym_gnu_asm_output_operand_list,
  [271806] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12194), 1,
      anon_sym_RPAREN,
    ACTIONS(12196), 1,
      anon_sym_COLON,
    STATE(7290), 1,
      sym_gnu_asm_clobber_list,
  [271819] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12192), 1,
      anon_sym_COLON,
    ACTIONS(12198), 1,
      anon_sym_RPAREN,
    STATE(7078), 1,
      sym_gnu_asm_output_operand_list,
  [271832] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8640), 1,
      anon_sym_COMMA,
    ACTIONS(12200), 1,
      anon_sym_RBRACK,
    STATE(7418), 1,
      aux_sym_subscript_argument_list_repeat1,
  [271845] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12202), 1,
      anon_sym_GT2,
    STATE(7082), 1,
      aux_sym_template_argument_list_repeat1,
  [271858] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12204), 1,
      anon_sym_COMMA,
    ACTIONS(12207), 1,
      anon_sym_RPAREN,
    STATE(7046), 1,
      aux_sym_throw_specifier_repeat1,
  [271871] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12209), 1,
      anon_sym_GT2,
    STATE(7347), 1,
      aux_sym_template_argument_list_repeat1,
  [271884] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(12211), 1,
      anon_sym_SEMI,
    STATE(7306), 1,
      aux_sym_declaration_repeat1,
  [271897] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11789), 1,
      anon_sym_COMMA,
    ACTIONS(12213), 1,
      anon_sym_LBRACE,
    STATE(7294), 1,
      aux_sym_base_class_clause_repeat1,
  [271910] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(12215), 1,
      anon_sym_SEMI,
    STATE(7083), 1,
      aux_sym_declaration_repeat1,
  [271923] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(12217), 1,
      anon_sym_SEMI,
    STATE(7308), 1,
      aux_sym_declaration_repeat1,
  [271936] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(12219), 1,
      anon_sym_SEMI,
    STATE(7308), 1,
      aux_sym_declaration_repeat1,
  [271949] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12221), 1,
      anon_sym_GT2,
    STATE(7347), 1,
      aux_sym_template_argument_list_repeat1,
  [271962] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12223), 1,
      anon_sym_COMMA,
    ACTIONS(12225), 1,
      anon_sym_RPAREN,
    STATE(7085), 1,
      aux_sym_parameter_list_repeat1,
  [271975] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8534), 1,
      anon_sym_RBRACE,
    ACTIONS(8738), 1,
      anon_sym_COMMA,
    STATE(7226), 1,
      aux_sym_initializer_list_repeat1,
  [271988] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12227), 1,
      anon_sym_RPAREN,
    ACTIONS(12229), 1,
      anon_sym_COLON,
    STATE(8259), 1,
      sym_gnu_asm_goto_list,
  [272001] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12231), 1,
      anon_sym_catch,
    STATE(1843), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [272012] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12233), 1,
      anon_sym_GT2,
    STATE(7347), 1,
      aux_sym_template_argument_list_repeat1,
  [272025] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8560), 1,
      anon_sym_COMMA,
    ACTIONS(12235), 1,
      anon_sym_RPAREN,
    STATE(7158), 1,
      aux_sym_generic_expression_repeat1,
  [272038] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7412), 1,
      anon_sym_EQ,
    ACTIONS(7410), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [272049] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12237), 1,
      anon_sym_GT2,
    STATE(7062), 1,
      aux_sym_template_argument_list_repeat1,
  [272062] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12239), 1,
      anon_sym_GT2,
    STATE(7347), 1,
      aux_sym_template_argument_list_repeat1,
  [272075] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12241), 1,
      anon_sym_catch,
    STATE(1830), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [272086] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12243), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [272095] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11829), 3,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LBRACE,
  [272104] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12247), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12245), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [272115] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12168), 1,
      anon_sym_COMMA,
    ACTIONS(12249), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7108), 1,
      aux_sym_attribute_declaration_repeat1,
  [272128] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8608), 1,
      anon_sym_COMMA,
    ACTIONS(8768), 1,
      anon_sym_RPAREN,
    STATE(7276), 1,
      aux_sym_argument_list_repeat1,
  [272141] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8608), 1,
      anon_sym_COMMA,
    ACTIONS(12251), 1,
      anon_sym_RPAREN,
    STATE(7132), 1,
      aux_sym_argument_list_repeat1,
  [272154] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5039), 1,
      anon_sym_LBRACE,
    ACTIONS(11829), 1,
      anon_sym_COLON_COLON,
    STATE(679), 1,
      sym_declaration_list,
  [272167] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12253), 1,
      anon_sym_COMMA,
    ACTIONS(12255), 1,
      anon_sym_LBRACE,
    STATE(7257), 1,
      aux_sym_field_initializer_list_repeat1,
  [272180] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4364), 1,
      anon_sym_RBRACE,
    ACTIONS(12257), 1,
      anon_sym_COMMA,
    STATE(7169), 1,
      aux_sym_initializer_list_repeat1,
  [272193] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12168), 1,
      anon_sym_COMMA,
    ACTIONS(12259), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7067), 1,
      aux_sym_attribute_declaration_repeat1,
  [272206] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5029), 1,
      anon_sym_LBRACE,
    ACTIONS(11829), 1,
      anon_sym_COLON_COLON,
    STATE(566), 1,
      sym_declaration_list,
  [272219] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8560), 1,
      anon_sym_COMMA,
    ACTIONS(12261), 1,
      anon_sym_RPAREN,
    STATE(7158), 1,
      aux_sym_generic_expression_repeat1,
  [272232] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12263), 1,
      sym_identifier,
    ACTIONS(12265), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [272243] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12267), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [272252] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12184), 1,
      anon_sym_COLON,
    ACTIONS(12269), 1,
      anon_sym_RPAREN,
    STATE(7091), 1,
      sym_gnu_asm_input_operand_list,
  [272265] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12192), 1,
      anon_sym_COLON,
    ACTIONS(12271), 1,
      anon_sym_RPAREN,
    STATE(7092), 1,
      sym_gnu_asm_output_operand_list,
  [272278] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12273), 1,
      anon_sym_GT2,
    STATE(7347), 1,
      aux_sym_template_argument_list_repeat1,
  [272291] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12275), 1,
      anon_sym_GT2,
    STATE(7347), 1,
      aux_sym_template_argument_list_repeat1,
  [272304] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12277), 1,
      anon_sym_GT2,
    STATE(7347), 1,
      aux_sym_template_argument_list_repeat1,
  [272317] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(12279), 1,
      anon_sym_SEMI,
    STATE(7308), 1,
      aux_sym_declaration_repeat1,
  [272330] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12283), 1,
      anon_sym_RPAREN,
    ACTIONS(12281), 2,
      anon_sym_DOT_DOT_DOT,
      sym_identifier,
  [272341] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12223), 1,
      anon_sym_COMMA,
    ACTIONS(12285), 1,
      anon_sym_RPAREN,
    STATE(7404), 1,
      aux_sym_parameter_list_repeat1,
  [272354] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12231), 1,
      anon_sym_catch,
    STATE(1828), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [272365] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8564), 1,
      anon_sym_COMMA,
    ACTIONS(8566), 1,
      anon_sym_RBRACE,
    STATE(7285), 1,
      aux_sym_initializer_list_repeat1,
  [272378] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12287), 1,
      sym_identifier,
    STATE(2145), 1,
      sym_template_type,
    STATE(3310), 1,
      sym_template_function,
  [272391] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12289), 1,
      anon_sym_catch,
    STATE(466), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [272402] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12291), 1,
      anon_sym_LPAREN2,
    ACTIONS(12293), 1,
      anon_sym_constexpr,
    STATE(191), 1,
      sym_condition_clause,
  [272415] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12196), 1,
      anon_sym_COLON,
    ACTIONS(12295), 1,
      anon_sym_RPAREN,
    STATE(7097), 1,
      sym_gnu_asm_clobber_list,
  [272428] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12184), 1,
      anon_sym_COLON,
    ACTIONS(12297), 1,
      anon_sym_RPAREN,
    STATE(7098), 1,
      sym_gnu_asm_input_operand_list,
  [272441] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12299), 1,
      anon_sym_GT2,
    STATE(7347), 1,
      aux_sym_template_argument_list_repeat1,
  [272454] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(12301), 1,
      anon_sym_SEMI,
    STATE(7155), 1,
      aux_sym_declaration_repeat1,
  [272467] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12303), 1,
      anon_sym_GT2,
    STATE(7104), 1,
      aux_sym_template_argument_list_repeat1,
  [272480] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12305), 1,
      sym_identifier,
    STATE(2145), 1,
      sym_template_type,
    STATE(5940), 1,
      sym_template_function,
  [272493] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12229), 1,
      anon_sym_COLON,
    ACTIONS(12307), 1,
      anon_sym_RPAREN,
    STATE(7777), 1,
      sym_gnu_asm_goto_list,
  [272506] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12196), 1,
      anon_sym_COLON,
    ACTIONS(12309), 1,
      anon_sym_RPAREN,
    STATE(7099), 1,
      sym_gnu_asm_clobber_list,
  [272519] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12229), 1,
      anon_sym_COLON,
    ACTIONS(12311), 1,
      anon_sym_RPAREN,
    STATE(7798), 1,
      sym_gnu_asm_goto_list,
  [272532] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8560), 1,
      anon_sym_COMMA,
    ACTIONS(12313), 1,
      anon_sym_RPAREN,
    STATE(7158), 1,
      aux_sym_generic_expression_repeat1,
  [272545] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12315), 1,
      anon_sym_GT2,
    STATE(7347), 1,
      aux_sym_template_argument_list_repeat1,
  [272558] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12317), 1,
      anon_sym_COMMA,
    ACTIONS(12319), 1,
      anon_sym_RPAREN,
    STATE(7192), 1,
      aux_sym_gnu_asm_goto_list_repeat1,
  [272571] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12321), 1,
      anon_sym_GT2,
    STATE(7347), 1,
      aux_sym_template_argument_list_repeat1,
  [272584] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12323), 1,
      anon_sym_GT2,
    STATE(7347), 1,
      aux_sym_template_argument_list_repeat1,
  [272597] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12325), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [272606] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12325), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [272615] = 3,
    ACTIONS(9945), 1,
      sym_comment,
    STATE(6917), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12327), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [272626] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12329), 1,
      anon_sym_COMMA,
    ACTIONS(12332), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7108), 1,
      aux_sym_attribute_declaration_repeat1,
  [272639] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2569), 1,
      anon_sym_while,
    ACTIONS(12334), 1,
      anon_sym_else,
    STATE(456), 1,
      sym_else_clause,
  [272652] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12223), 1,
      anon_sym_COMMA,
    ACTIONS(12336), 1,
      anon_sym_RPAREN,
    STATE(7363), 1,
      aux_sym_parameter_list_repeat1,
  [272665] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12291), 1,
      anon_sym_LPAREN2,
    ACTIONS(12338), 1,
      anon_sym_constexpr,
    STATE(180), 1,
      sym_condition_clause,
  [272678] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12340), 1,
      anon_sym_COMMA,
    ACTIONS(12342), 1,
      anon_sym_RBRACK,
    STATE(7415), 1,
      aux_sym_lambda_capture_specifier_repeat1,
  [272691] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12196), 1,
      anon_sym_COLON,
    ACTIONS(12344), 1,
      anon_sym_RPAREN,
    STATE(7371), 1,
      sym_gnu_asm_clobber_list,
  [272704] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6423), 1,
      anon_sym___attribute,
    ACTIONS(6425), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [272715] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6322), 1,
      anon_sym_SEMI,
    ACTIONS(6463), 1,
      anon_sym_LT,
    STATE(1668), 1,
      sym_template_argument_list,
  [272728] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12192), 1,
      anon_sym_COLON,
    ACTIONS(12346), 1,
      anon_sym_RPAREN,
    STATE(7343), 1,
      sym_gnu_asm_output_operand_list,
  [272741] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12184), 1,
      anon_sym_COLON,
    ACTIONS(12348), 1,
      anon_sym_RPAREN,
    STATE(7373), 1,
      sym_gnu_asm_input_operand_list,
  [272754] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12350), 1,
      anon_sym_GT2,
    STATE(7352), 1,
      aux_sym_template_argument_list_repeat1,
  [272767] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12352), 1,
      anon_sym_catch,
    STATE(358), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [272778] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12354), 1,
      anon_sym_COMMA,
    ACTIONS(12356), 1,
      anon_sym_GT2,
    STATE(7355), 1,
      aux_sym_template_parameter_list_repeat1,
  [272791] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12168), 1,
      anon_sym_COMMA,
    ACTIONS(12358), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7108), 1,
      aux_sym_attribute_declaration_repeat1,
  [272804] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12360), 1,
      anon_sym_EQ,
    ACTIONS(11328), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [272815] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12354), 1,
      anon_sym_COMMA,
    ACTIONS(12362), 1,
      anon_sym_GT2,
    STATE(7388), 1,
      aux_sym_template_parameter_list_repeat1,
  [272828] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6010), 1,
      anon_sym_COMMA,
    ACTIONS(12364), 1,
      anon_sym_RBRACK,
    STATE(7394), 1,
      aux_sym_structured_binding_declarator_repeat1,
  [272841] = 4,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(12366), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(12368), 1,
      anon_sym_LPAREN2,
    STATE(8226), 1,
      sym_preproc_argument_list,
  [272854] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(12370), 1,
      anon_sym_SEMI,
    STATE(7308), 1,
      aux_sym_declaration_repeat1,
  [272867] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12229), 1,
      anon_sym_COLON,
    ACTIONS(12372), 1,
      anon_sym_RPAREN,
    STATE(7847), 1,
      sym_gnu_asm_goto_list,
  [272880] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8608), 1,
      anon_sym_COMMA,
    ACTIONS(12374), 1,
      anon_sym_RPAREN,
    STATE(7132), 1,
      aux_sym_argument_list_repeat1,
  [272893] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12354), 1,
      anon_sym_COMMA,
    ACTIONS(12376), 1,
      anon_sym_GT2,
    STATE(7123), 1,
      aux_sym_template_parameter_list_repeat1,
  [272906] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12378), 1,
      anon_sym_GT2,
    STATE(7191), 1,
      aux_sym_template_argument_list_repeat1,
  [272919] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12380), 1,
      sym_identifier,
    STATE(1787), 1,
      sym_template_type,
    STATE(3372), 1,
      sym_template_function,
  [272932] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8878), 1,
      anon_sym_RPAREN,
    ACTIONS(12382), 1,
      anon_sym_COMMA,
    STATE(7132), 1,
      aux_sym_argument_list_repeat1,
  [272945] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12168), 1,
      anon_sym_COMMA,
    ACTIONS(12385), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7165), 1,
      aux_sym_attribute_declaration_repeat1,
  [272958] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12289), 1,
      anon_sym_catch,
    STATE(290), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [272969] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12247), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12387), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [272980] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12196), 1,
      anon_sym_COLON,
    ACTIONS(12389), 1,
      anon_sym_RPAREN,
    STATE(7219), 1,
      sym_gnu_asm_clobber_list,
  [272993] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12340), 1,
      anon_sym_COMMA,
    ACTIONS(12391), 1,
      anon_sym_RBRACK,
    STATE(7171), 1,
      aux_sym_lambda_capture_specifier_repeat1,
  [273006] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12393), 1,
      anon_sym_GT2,
    STATE(7141), 1,
      aux_sym_template_argument_list_repeat1,
  [273019] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12395), 1,
      anon_sym_GT2,
    STATE(7347), 1,
      aux_sym_template_argument_list_repeat1,
  [273032] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12397), 1,
      anon_sym_GT2,
    STATE(7347), 1,
      aux_sym_template_argument_list_repeat1,
  [273045] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12399), 1,
      anon_sym_GT2,
    STATE(7347), 1,
      aux_sym_template_argument_list_repeat1,
  [273058] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12231), 1,
      anon_sym_catch,
    STATE(1835), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [273069] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12401), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12403), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [273080] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(12405), 1,
      anon_sym_SEMI,
    STATE(7203), 1,
      aux_sym_declaration_repeat1,
  [273093] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12407), 1,
      anon_sym_default,
    ACTIONS(12409), 1,
      anon_sym_delete,
    ACTIONS(12411), 1,
      aux_sym_pure_virtual_clause_token1,
  [273106] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(12413), 1,
      anon_sym_SEMI,
    STATE(7364), 1,
      aux_sym_declaration_repeat1,
  [273119] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12415), 1,
      anon_sym_COMMA,
    ACTIONS(12418), 1,
      anon_sym_RBRACK,
    STATE(7147), 1,
      aux_sym_structured_binding_declarator_repeat1,
  [273132] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(12420), 1,
      anon_sym_SEMI,
    STATE(7308), 1,
      aux_sym_declaration_repeat1,
  [273145] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(12422), 1,
      anon_sym_SEMI,
    STATE(7308), 1,
      aux_sym_declaration_repeat1,
  [273158] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12291), 1,
      anon_sym_LPAREN2,
    ACTIONS(12424), 1,
      anon_sym_constexpr,
    STATE(188), 1,
      sym_condition_clause,
  [273171] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(12426), 1,
      anon_sym_SEMI,
    STATE(7186), 1,
      aux_sym_declaration_repeat1,
  [273184] = 3,
    ACTIONS(9945), 1,
      sym_comment,
    STATE(6942), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12428), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [273195] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12168), 1,
      anon_sym_COMMA,
    ACTIONS(12430), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7261), 1,
      aux_sym_attribute_declaration_repeat1,
  [273208] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(12432), 1,
      anon_sym_SEMI,
    STATE(7308), 1,
      aux_sym_declaration_repeat1,
  [273221] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(12434), 1,
      anon_sym_SEMI,
    STATE(7308), 1,
      aux_sym_declaration_repeat1,
  [273234] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12436), 1,
      sym_identifier,
    STATE(2145), 1,
      sym_template_type,
    STATE(2765), 1,
      sym_template_function,
  [273247] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12223), 1,
      anon_sym_COMMA,
    ACTIONS(12438), 1,
      anon_sym_RPAREN,
    STATE(7372), 1,
      aux_sym_parameter_list_repeat1,
  [273260] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12440), 1,
      anon_sym_COMMA,
    ACTIONS(12443), 1,
      anon_sym_RPAREN,
    STATE(7158), 1,
      aux_sym_generic_expression_repeat1,
  [273273] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11789), 1,
      anon_sym_COMMA,
    ACTIONS(12049), 1,
      anon_sym_LBRACE,
    STATE(7294), 1,
      aux_sym_base_class_clause_repeat1,
  [273286] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12340), 1,
      anon_sym_COMMA,
    ACTIONS(12445), 1,
      anon_sym_RBRACK,
    STATE(7137), 1,
      aux_sym_lambda_capture_specifier_repeat1,
  [273299] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12447), 3,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
  [273308] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12449), 1,
      sym_identifier,
    STATE(1787), 1,
      sym_template_type,
    STATE(2446), 1,
      sym_template_function,
  [273321] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12451), 1,
      anon_sym_default,
    ACTIONS(12453), 1,
      anon_sym_delete,
    ACTIONS(12455), 1,
      aux_sym_pure_virtual_clause_token1,
  [273334] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12241), 1,
      anon_sym_catch,
    STATE(1825), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [273345] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12168), 1,
      anon_sym_COMMA,
    ACTIONS(12457), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7108), 1,
      aux_sym_attribute_declaration_repeat1,
  [273358] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8608), 1,
      anon_sym_COMMA,
    ACTIONS(8624), 1,
      anon_sym_RPAREN,
    STATE(7197), 1,
      aux_sym_argument_list_repeat1,
  [273371] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12459), 1,
      anon_sym_GT2,
    STATE(7174), 1,
      aux_sym_template_argument_list_repeat1,
  [273384] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12461), 1,
      anon_sym_GT2,
    STATE(7347), 1,
      aux_sym_template_argument_list_repeat1,
  [273397] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8681), 1,
      anon_sym_RBRACE,
    ACTIONS(12463), 1,
      anon_sym_COMMA,
    STATE(7169), 1,
      aux_sym_initializer_list_repeat1,
  [273410] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8626), 1,
      anon_sym_COMMA,
    ACTIONS(8628), 1,
      anon_sym_RBRACE,
    STATE(7198), 1,
      aux_sym_initializer_list_repeat1,
  [273423] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12466), 1,
      anon_sym_COMMA,
    ACTIONS(12469), 1,
      anon_sym_RBRACK,
    STATE(7171), 1,
      aux_sym_lambda_capture_specifier_repeat1,
  [273436] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12352), 1,
      anon_sym_catch,
    STATE(381), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [273447] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12471), 1,
      anon_sym_GT2,
    STATE(7347), 1,
      aux_sym_template_argument_list_repeat1,
  [273460] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12473), 1,
      anon_sym_GT2,
    STATE(7347), 1,
      aux_sym_template_argument_list_repeat1,
  [273473] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(12475), 1,
      anon_sym_SEMI,
    STATE(7308), 1,
      aux_sym_declaration_repeat1,
  [273486] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12192), 1,
      anon_sym_COLON,
    ACTIONS(12477), 1,
      anon_sym_RPAREN,
    STATE(7204), 1,
      sym_gnu_asm_output_operand_list,
  [273499] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12479), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [273508] = 4,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(12368), 1,
      anon_sym_LPAREN2,
    ACTIONS(12481), 1,
      aux_sym_preproc_include_token2,
    STATE(8226), 1,
      sym_preproc_argument_list,
  [273521] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12483), 1,
      anon_sym_GT2,
    STATE(7209), 1,
      aux_sym_template_argument_list_repeat1,
  [273534] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5037), 1,
      anon_sym_LBRACE,
    ACTIONS(11829), 1,
      anon_sym_COLON_COLON,
    STATE(697), 1,
      sym_declaration_list,
  [273547] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12485), 1,
      anon_sym_GT2,
    STATE(7347), 1,
      aux_sym_template_argument_list_repeat1,
  [273560] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12487), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [273569] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12489), 1,
      anon_sym_GT2,
    STATE(7347), 1,
      aux_sym_template_argument_list_repeat1,
  [273582] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(12491), 1,
      anon_sym_SEMI,
    STATE(7215), 1,
      aux_sym_declaration_repeat1,
  [273595] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(12493), 1,
      anon_sym_SEMI,
    STATE(7308), 1,
      aux_sym_declaration_repeat1,
  [273608] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(12495), 1,
      anon_sym_SEMI,
    STATE(7308), 1,
      aux_sym_declaration_repeat1,
  [273621] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12497), 1,
      anon_sym_catch,
    STATE(376), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [273632] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12499), 1,
      anon_sym_catch,
    STATE(219), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [273643] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11789), 1,
      anon_sym_COMMA,
    ACTIONS(12049), 1,
      anon_sym_LBRACE,
    STATE(7354), 1,
      aux_sym_base_class_clause_repeat1,
  [273656] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12501), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12503), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [273667] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12505), 1,
      anon_sym_GT2,
    STATE(7347), 1,
      aux_sym_template_argument_list_repeat1,
  [273680] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12317), 1,
      anon_sym_COMMA,
    ACTIONS(12507), 1,
      anon_sym_RPAREN,
    STATE(7240), 1,
      aux_sym_gnu_asm_goto_list_repeat1,
  [273693] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12509), 1,
      sym_identifier,
    STATE(2145), 1,
      sym_template_type,
    STATE(2765), 1,
      sym_template_function,
  [273706] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12511), 1,
      anon_sym_COMMA,
    ACTIONS(12514), 1,
      anon_sym_RPAREN,
    STATE(7194), 1,
      aux_sym_preproc_params_repeat1,
  [273719] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12131), 1,
      anon_sym_DASH_GT,
    ACTIONS(12516), 1,
      anon_sym_SEMI,
    STATE(8190), 1,
      sym_trailing_return_type,
  [273732] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8640), 1,
      anon_sym_COMMA,
    ACTIONS(8666), 1,
      anon_sym_RBRACK,
    STATE(7379), 1,
      aux_sym_subscript_argument_list_repeat1,
  [273745] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8608), 1,
      anon_sym_COMMA,
    ACTIONS(12518), 1,
      anon_sym_RPAREN,
    STATE(7132), 1,
      aux_sym_argument_list_repeat1,
  [273758] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4344), 1,
      anon_sym_RBRACE,
    ACTIONS(12520), 1,
      anon_sym_COMMA,
    STATE(7169), 1,
      aux_sym_initializer_list_repeat1,
  [273771] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12291), 1,
      anon_sym_LPAREN2,
    ACTIONS(12522), 1,
      anon_sym_constexpr,
    STATE(198), 1,
      sym_condition_clause,
  [273784] = 3,
    ACTIONS(9945), 1,
      sym_comment,
    STATE(6885), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12524), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [273795] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6469), 1,
      anon_sym___attribute,
    ACTIONS(6471), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [273806] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6473), 1,
      anon_sym___attribute,
    ACTIONS(6475), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [273817] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(12526), 1,
      anon_sym_SEMI,
    STATE(7308), 1,
      aux_sym_declaration_repeat1,
  [273830] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12184), 1,
      anon_sym_COLON,
    ACTIONS(12528), 1,
      anon_sym_RPAREN,
    STATE(7221), 1,
      sym_gnu_asm_input_operand_list,
  [273843] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12530), 1,
      anon_sym_GT2,
    STATE(7214), 1,
      aux_sym_template_argument_list_repeat1,
  [273856] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12192), 1,
      anon_sym_COLON,
    ACTIONS(12532), 1,
      anon_sym_RPAREN,
    STATE(7222), 1,
      sym_gnu_asm_output_operand_list,
  [273869] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12534), 1,
      anon_sym_GT2,
    STATE(7347), 1,
      aux_sym_template_argument_list_repeat1,
  [273882] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12536), 1,
      anon_sym_GT2,
    STATE(7347), 1,
      aux_sym_template_argument_list_repeat1,
  [273895] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12538), 1,
      anon_sym_GT2,
    STATE(7347), 1,
      aux_sym_template_argument_list_repeat1,
  [273908] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12540), 1,
      anon_sym_default,
    ACTIONS(12542), 1,
      anon_sym_delete,
    ACTIONS(12544), 1,
      aux_sym_pure_virtual_clause_token1,
  [273921] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12546), 1,
      anon_sym_GT2,
    STATE(7347), 1,
      aux_sym_template_argument_list_repeat1,
  [273934] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12548), 1,
      anon_sym_GT2,
    STATE(7347), 1,
      aux_sym_template_argument_list_repeat1,
  [273947] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(12550), 1,
      anon_sym_SEMI,
    STATE(7321), 1,
      aux_sym_declaration_repeat1,
  [273960] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12552), 1,
      anon_sym_GT2,
    STATE(7347), 1,
      aux_sym_template_argument_list_repeat1,
  [273973] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(12554), 1,
      anon_sym_SEMI,
    STATE(7308), 1,
      aux_sym_declaration_repeat1,
  [273986] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12497), 1,
      anon_sym_catch,
    STATE(377), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [273997] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9879), 1,
      anon_sym_COMMA,
    ACTIONS(12556), 1,
      anon_sym_RPAREN,
    STATE(7246), 1,
      aux_sym_preproc_argument_list_repeat1,
  [274010] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8640), 1,
      anon_sym_COMMA,
    ACTIONS(8746), 1,
      anon_sym_RBRACK,
    STATE(7044), 1,
      aux_sym_subscript_argument_list_repeat1,
  [274023] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12229), 1,
      anon_sym_COLON,
    ACTIONS(12558), 1,
      anon_sym_RPAREN,
    STATE(7887), 1,
      sym_gnu_asm_goto_list,
  [274036] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12560), 3,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
  [274045] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12196), 1,
      anon_sym_COLON,
    ACTIONS(12562), 1,
      anon_sym_RPAREN,
    STATE(7224), 1,
      sym_gnu_asm_clobber_list,
  [274058] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12184), 1,
      anon_sym_COLON,
    ACTIONS(12564), 1,
      anon_sym_RPAREN,
    STATE(7225), 1,
      sym_gnu_asm_input_operand_list,
  [274071] = 4,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(12368), 1,
      anon_sym_LPAREN2,
    ACTIONS(12566), 1,
      aux_sym_preproc_include_token2,
    STATE(8226), 1,
      sym_preproc_argument_list,
  [274084] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12229), 1,
      anon_sym_COLON,
    ACTIONS(12568), 1,
      anon_sym_RPAREN,
    STATE(7898), 1,
      sym_gnu_asm_goto_list,
  [274097] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12196), 1,
      anon_sym_COLON,
    ACTIONS(12570), 1,
      anon_sym_RPAREN,
    STATE(7227), 1,
      sym_gnu_asm_clobber_list,
  [274110] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4201), 1,
      anon_sym_RBRACE,
    ACTIONS(12572), 1,
      anon_sym_COMMA,
    STATE(7169), 1,
      aux_sym_initializer_list_repeat1,
  [274123] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12229), 1,
      anon_sym_COLON,
    ACTIONS(12574), 1,
      anon_sym_RPAREN,
    STATE(7901), 1,
      sym_gnu_asm_goto_list,
  [274136] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8560), 1,
      anon_sym_COMMA,
    ACTIONS(12576), 1,
      anon_sym_RPAREN,
    STATE(7158), 1,
      aux_sym_generic_expression_repeat1,
  [274149] = 3,
    ACTIONS(9945), 1,
      sym_comment,
    STATE(6929), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12578), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [274160] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12580), 1,
      anon_sym_COMMA,
    ACTIONS(12582), 1,
      anon_sym_RPAREN,
    STATE(7397), 1,
      aux_sym_requires_parameter_list_repeat1,
  [274173] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8560), 1,
      anon_sym_COMMA,
    ACTIONS(12584), 1,
      anon_sym_RPAREN,
    STATE(7158), 1,
      aux_sym_generic_expression_repeat1,
  [274186] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12586), 1,
      sym_identifier,
    STATE(2145), 1,
      sym_template_type,
    STATE(2765), 1,
      sym_template_function,
  [274199] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12588), 1,
      anon_sym_default,
    ACTIONS(12590), 1,
      anon_sym_delete,
    ACTIONS(12592), 1,
      aux_sym_pure_virtual_clause_token1,
  [274212] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12594), 1,
      sym_identifier,
    STATE(2145), 1,
      sym_template_type,
    STATE(2446), 1,
      sym_template_function,
  [274225] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12196), 1,
      anon_sym_COLON,
    ACTIONS(12596), 1,
      anon_sym_RPAREN,
    STATE(7277), 1,
      sym_gnu_asm_clobber_list,
  [274238] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6509), 1,
      anon_sym___attribute,
    ACTIONS(6511), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [274249] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12598), 1,
      anon_sym_GT2,
    STATE(7251), 1,
      aux_sym_template_argument_list_repeat1,
  [274262] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6513), 1,
      anon_sym___attribute,
    ACTIONS(6515), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [274273] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12600), 1,
      sym_identifier,
    STATE(2145), 1,
      sym_template_type,
    STATE(2446), 1,
      sym_template_function,
  [274286] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12602), 1,
      anon_sym_COMMA,
    ACTIONS(12605), 1,
      anon_sym_RPAREN,
    STATE(7240), 1,
      aux_sym_gnu_asm_goto_list_repeat1,
  [274299] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12607), 1,
      anon_sym_COMMA,
    ACTIONS(12609), 1,
      anon_sym_RPAREN,
    STATE(7046), 1,
      aux_sym_throw_specifier_repeat1,
  [274312] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6517), 1,
      anon_sym___attribute,
    ACTIONS(6519), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [274323] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6521), 1,
      anon_sym___attribute,
    ACTIONS(6523), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [274334] = 3,
    ACTIONS(9945), 1,
      sym_comment,
    STATE(6972), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12611), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [274345] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12613), 1,
      anon_sym_GT2,
    STATE(7347), 1,
      aux_sym_template_argument_list_repeat1,
  [274358] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10230), 1,
      anon_sym_RPAREN,
    ACTIONS(12615), 1,
      anon_sym_COMMA,
    STATE(7246), 1,
      aux_sym_preproc_argument_list_repeat1,
  [274371] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6555), 1,
      anon_sym___attribute,
    ACTIONS(6557), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [274382] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12618), 1,
      anon_sym_GT2,
    STATE(7347), 1,
      aux_sym_template_argument_list_repeat1,
  [274395] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12620), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12622), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [274406] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12174), 1,
      anon_sym_COMMA,
    ACTIONS(12624), 1,
      anon_sym_RPAREN,
    STATE(7031), 1,
      aux_sym_preproc_params_repeat1,
  [274419] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12626), 1,
      anon_sym_GT2,
    STATE(7347), 1,
      aux_sym_template_argument_list_repeat1,
  [274432] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6559), 1,
      anon_sym___attribute,
    ACTIONS(6561), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [274443] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(12628), 1,
      anon_sym_SEMI,
    STATE(7154), 1,
      aux_sym_declaration_repeat1,
  [274456] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12168), 1,
      anon_sym_COMMA,
    ACTIONS(12630), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7029), 1,
      aux_sym_attribute_declaration_repeat1,
  [274469] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6571), 1,
      anon_sym___attribute,
    ACTIONS(6573), 2,
      anon_sym___attribute__,
      anon_sym_LBRACK_LBRACK,
  [274480] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12291), 1,
      anon_sym_LPAREN2,
    ACTIONS(12632), 1,
      anon_sym_constexpr,
    STATE(208), 1,
      sym_condition_clause,
  [274493] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12253), 1,
      anon_sym_COMMA,
    ACTIONS(12634), 1,
      anon_sym_LBRACE,
    STATE(7414), 1,
      aux_sym_field_initializer_list_repeat1,
  [274506] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12636), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [274515] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12184), 1,
      anon_sym_COLON,
    ACTIONS(12638), 1,
      anon_sym_RPAREN,
    STATE(7284), 1,
      sym_gnu_asm_input_operand_list,
  [274528] = 3,
    ACTIONS(9945), 1,
      sym_comment,
    STATE(7012), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12640), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [274539] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12168), 1,
      anon_sym_COMMA,
    ACTIONS(12642), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7108), 1,
      aux_sym_attribute_declaration_repeat1,
  [274552] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12168), 1,
      anon_sym_COMMA,
    ACTIONS(12644), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7292), 1,
      aux_sym_attribute_declaration_repeat1,
  [274565] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8608), 1,
      anon_sym_COMMA,
    ACTIONS(8748), 1,
      anon_sym_RPAREN,
    STATE(7383), 1,
      aux_sym_argument_list_repeat1,
  [274578] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12646), 1,
      sym_identifier,
    STATE(2525), 1,
      sym_template_type,
    STATE(3650), 1,
      sym_template_function,
  [274591] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12648), 1,
      anon_sym_default,
    ACTIONS(12650), 1,
      anon_sym_delete,
    ACTIONS(12652), 1,
      aux_sym_pure_virtual_clause_token1,
  [274604] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9879), 1,
      anon_sym_COMMA,
    ACTIONS(12654), 1,
      anon_sym_RPAREN,
    STATE(7246), 1,
      aux_sym_preproc_argument_list_repeat1,
  [274617] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5041), 1,
      anon_sym_LBRACE,
    ACTIONS(11829), 1,
      anon_sym_COLON_COLON,
    STATE(310), 1,
      sym_declaration_list,
  [274630] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12656), 1,
      anon_sym_GT2,
    STATE(7271), 1,
      aux_sym_template_argument_list_repeat1,
  [274643] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12658), 1,
      anon_sym_GT2,
    STATE(7347), 1,
      aux_sym_template_argument_list_repeat1,
  [274656] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12660), 1,
      anon_sym_GT2,
    STATE(7347), 1,
      aux_sym_template_argument_list_repeat1,
  [274669] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12662), 1,
      anon_sym_GT2,
    STATE(7347), 1,
      aux_sym_template_argument_list_repeat1,
  [274682] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12664), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12666), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [274693] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8750), 1,
      anon_sym_COMMA,
    ACTIONS(8752), 1,
      anon_sym_RBRACE,
    STATE(7395), 1,
      aux_sym_initializer_list_repeat1,
  [274706] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12668), 1,
      anon_sym_catch,
    STATE(835), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [274717] = 3,
    ACTIONS(9945), 1,
      sym_comment,
    STATE(6813), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12670), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [274728] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8608), 1,
      anon_sym_COMMA,
    ACTIONS(12672), 1,
      anon_sym_RPAREN,
    STATE(7132), 1,
      aux_sym_argument_list_repeat1,
  [274741] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12229), 1,
      anon_sym_COLON,
    ACTIONS(12674), 1,
      anon_sym_RPAREN,
    STATE(8093), 1,
      sym_gnu_asm_goto_list,
  [274754] = 3,
    ACTIONS(9945), 1,
      sym_comment,
    STATE(6826), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12676), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [274765] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5029), 1,
      anon_sym_LBRACE,
    ACTIONS(11829), 1,
      anon_sym_COLON_COLON,
    STATE(553), 1,
      sym_declaration_list,
  [274778] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(12678), 1,
      anon_sym_SEMI,
    STATE(7311), 1,
      aux_sym_declaration_repeat1,
  [274791] = 3,
    ACTIONS(9945), 1,
      sym_comment,
    STATE(6842), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12680), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [274802] = 3,
    ACTIONS(9945), 1,
      sym_comment,
    STATE(6853), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12682), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [274813] = 3,
    ACTIONS(9945), 1,
      sym_comment,
    STATE(6858), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12684), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [274824] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12196), 1,
      anon_sym_COLON,
    ACTIONS(12686), 1,
      anon_sym_RPAREN,
    STATE(7289), 1,
      sym_gnu_asm_clobber_list,
  [274837] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4354), 1,
      anon_sym_RBRACE,
    ACTIONS(12688), 1,
      anon_sym_COMMA,
    STATE(7169), 1,
      aux_sym_initializer_list_repeat1,
  [274850] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12690), 1,
      sym_identifier,
    STATE(2145), 1,
      sym_template_type,
    STATE(2765), 1,
      sym_template_function,
  [274863] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11789), 1,
      anon_sym_COMMA,
    ACTIONS(12081), 1,
      anon_sym_LBRACE,
    STATE(7159), 1,
      aux_sym_base_class_clause_repeat1,
  [274876] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11789), 1,
      anon_sym_COMMA,
    ACTIONS(12081), 1,
      anon_sym_LBRACE,
    STATE(7294), 1,
      aux_sym_base_class_clause_repeat1,
  [274889] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12229), 1,
      anon_sym_COLON,
    ACTIONS(12692), 1,
      anon_sym_RPAREN,
    STATE(8154), 1,
      sym_gnu_asm_goto_list,
  [274902] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12229), 1,
      anon_sym_COLON,
    ACTIONS(12694), 1,
      anon_sym_RPAREN,
    STATE(7945), 1,
      sym_gnu_asm_goto_list,
  [274915] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12696), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12698), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [274926] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12168), 1,
      anon_sym_COMMA,
    ACTIONS(12700), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7108), 1,
      aux_sym_attribute_declaration_repeat1,
  [274939] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8608), 1,
      anon_sym_COMMA,
    ACTIONS(8683), 1,
      anon_sym_RPAREN,
    STATE(7322), 1,
      aux_sym_argument_list_repeat1,
  [274952] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12698), 1,
      anon_sym_LBRACE,
    ACTIONS(12702), 1,
      anon_sym_COMMA,
    STATE(7294), 1,
      aux_sym_base_class_clause_repeat1,
  [274965] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8685), 1,
      anon_sym_COMMA,
    ACTIONS(8687), 1,
      anon_sym_RBRACE,
    STATE(7323), 1,
      aux_sym_initializer_list_repeat1,
  [274978] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12192), 1,
      anon_sym_COLON,
    ACTIONS(12705), 1,
      anon_sym_RPAREN,
    STATE(7408), 1,
      sym_gnu_asm_output_operand_list,
  [274991] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12709), 1,
      anon_sym_RPAREN,
    ACTIONS(12707), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [275002] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12223), 1,
      anon_sym_COMMA,
    ACTIONS(12711), 1,
      anon_sym_RPAREN,
    STATE(7404), 1,
      aux_sym_parameter_list_repeat1,
  [275015] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8608), 1,
      anon_sym_COMMA,
    ACTIONS(12713), 1,
      anon_sym_RPAREN,
    STATE(7132), 1,
      aux_sym_argument_list_repeat1,
  [275028] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12715), 1,
      anon_sym_GT2,
    STATE(7419), 1,
      aux_sym_template_argument_list_repeat1,
  [275041] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12717), 1,
      sym_identifier,
    STATE(2145), 1,
      sym_template_type,
    STATE(2765), 1,
      sym_template_function,
  [275054] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12192), 1,
      anon_sym_COLON,
    ACTIONS(12719), 1,
      anon_sym_RPAREN,
    STATE(7324), 1,
      sym_gnu_asm_output_operand_list,
  [275067] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12499), 1,
      anon_sym_catch,
    STATE(223), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [275078] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12721), 1,
      anon_sym_GT2,
    STATE(7314), 1,
      aux_sym_template_argument_list_repeat1,
  [275091] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12723), 1,
      anon_sym_GT2,
    STATE(7328), 1,
      aux_sym_template_argument_list_repeat1,
  [275104] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(12725), 1,
      anon_sym_SEMI,
    STATE(7308), 1,
      aux_sym_declaration_repeat1,
  [275117] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12727), 1,
      anon_sym_GT2,
    STATE(7347), 1,
      aux_sym_template_argument_list_repeat1,
  [275130] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12729), 1,
      anon_sym_COMMA,
    ACTIONS(12732), 1,
      anon_sym_SEMI,
    STATE(7308), 1,
      aux_sym_declaration_repeat1,
  [275143] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(12734), 1,
      anon_sym_SEMI,
    STATE(7333), 1,
      aux_sym_declaration_repeat1,
  [275156] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(12736), 1,
      anon_sym_SEMI,
    STATE(7308), 1,
      aux_sym_declaration_repeat1,
  [275169] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(12738), 1,
      anon_sym_SEMI,
    STATE(7308), 1,
      aux_sym_declaration_repeat1,
  [275182] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12740), 1,
      anon_sym_catch,
    STATE(1657), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [275193] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12742), 1,
      anon_sym_GT2,
    STATE(7347), 1,
      aux_sym_template_argument_list_repeat1,
  [275206] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12744), 1,
      anon_sym_GT2,
    STATE(7347), 1,
      aux_sym_template_argument_list_repeat1,
  [275219] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12746), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [275228] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8640), 1,
      anon_sym_COMMA,
    ACTIONS(12748), 1,
      anon_sym_RBRACK,
    STATE(7418), 1,
      aux_sym_subscript_argument_list_repeat1,
  [275241] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2575), 1,
      anon_sym_while,
    ACTIONS(12334), 1,
      anon_sym_else,
    STATE(479), 1,
      sym_else_clause,
  [275254] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8679), 3,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
  [275263] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(12750), 1,
      anon_sym_SEMI,
    STATE(7175), 1,
      aux_sym_declaration_repeat1,
  [275276] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(12752), 1,
      anon_sym_SEMI,
    STATE(7308), 1,
      aux_sym_declaration_repeat1,
  [275289] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(12754), 1,
      anon_sym_SEMI,
    STATE(7308), 1,
      aux_sym_declaration_repeat1,
  [275302] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8608), 1,
      anon_sym_COMMA,
    ACTIONS(12756), 1,
      anon_sym_RPAREN,
    STATE(7132), 1,
      aux_sym_argument_list_repeat1,
  [275315] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4350), 1,
      anon_sym_RBRACE,
    ACTIONS(12758), 1,
      anon_sym_COMMA,
    STATE(7169), 1,
      aux_sym_initializer_list_repeat1,
  [275328] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12184), 1,
      anon_sym_COLON,
    ACTIONS(12760), 1,
      anon_sym_RPAREN,
    STATE(7339), 1,
      sym_gnu_asm_input_operand_list,
  [275341] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12192), 1,
      anon_sym_COLON,
    ACTIONS(12762), 1,
      anon_sym_RPAREN,
    STATE(7340), 1,
      sym_gnu_asm_output_operand_list,
  [275354] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12764), 1,
      anon_sym_GT2,
    STATE(7347), 1,
      aux_sym_template_argument_list_repeat1,
  [275367] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12766), 1,
      anon_sym_GT2,
    STATE(7347), 1,
      aux_sym_template_argument_list_repeat1,
  [275380] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12768), 1,
      anon_sym_GT2,
    STATE(7347), 1,
      aux_sym_template_argument_list_repeat1,
  [275393] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12223), 1,
      anon_sym_COMMA,
    ACTIONS(12770), 1,
      anon_sym_RPAREN,
    STATE(7298), 1,
      aux_sym_parameter_list_repeat1,
  [275406] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12580), 1,
      anon_sym_COMMA,
    ACTIONS(12772), 1,
      anon_sym_RPAREN,
    STATE(7230), 1,
      aux_sym_requires_parameter_list_repeat1,
  [275419] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12196), 1,
      anon_sym_COLON,
    ACTIONS(12774), 1,
      anon_sym_RPAREN,
    STATE(7384), 1,
      sym_gnu_asm_clobber_list,
  [275432] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12184), 1,
      anon_sym_COLON,
    ACTIONS(12776), 1,
      anon_sym_RPAREN,
    STATE(7042), 1,
      sym_gnu_asm_input_operand_list,
  [275445] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(12778), 1,
      anon_sym_SEMI,
    STATE(7308), 1,
      aux_sym_declaration_repeat1,
  [275458] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12740), 1,
      anon_sym_catch,
    STATE(1643), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [275469] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11763), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12780), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [275480] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12782), 1,
      sym_identifier,
    STATE(2145), 1,
      sym_template_type,
    STATE(3372), 1,
      sym_template_function,
  [275493] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12784), 1,
      sym_identifier,
    STATE(2145), 1,
      sym_template_type,
    STATE(3372), 1,
      sym_template_function,
  [275506] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12499), 1,
      anon_sym_catch,
    STATE(221), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [275517] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12196), 1,
      anon_sym_COLON,
    ACTIONS(12786), 1,
      anon_sym_RPAREN,
    STATE(7344), 1,
      sym_gnu_asm_clobber_list,
  [275530] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12184), 1,
      anon_sym_COLON,
    ACTIONS(12788), 1,
      anon_sym_RPAREN,
    STATE(7345), 1,
      sym_gnu_asm_input_operand_list,
  [275543] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12196), 1,
      anon_sym_COLON,
    ACTIONS(12790), 1,
      anon_sym_RPAREN,
    STATE(7127), 1,
      sym_gnu_asm_clobber_list,
  [275556] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12792), 1,
      anon_sym_GT2,
    STATE(7359), 1,
      aux_sym_template_argument_list_repeat1,
  [275569] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12184), 1,
      anon_sym_COLON,
    ACTIONS(12794), 1,
      anon_sym_RPAREN,
    STATE(7113), 1,
      sym_gnu_asm_input_operand_list,
  [275582] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12229), 1,
      anon_sym_COLON,
    ACTIONS(12796), 1,
      anon_sym_RPAREN,
    STATE(8287), 1,
      sym_gnu_asm_goto_list,
  [275595] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12196), 1,
      anon_sym_COLON,
    ACTIONS(12798), 1,
      anon_sym_RPAREN,
    STATE(7348), 1,
      sym_gnu_asm_clobber_list,
  [275608] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12192), 1,
      anon_sym_COLON,
    ACTIONS(12800), 1,
      anon_sym_RPAREN,
    STATE(7117), 1,
      sym_gnu_asm_output_operand_list,
  [275621] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12802), 1,
      anon_sym_COMMA,
    ACTIONS(12805), 1,
      anon_sym_GT2,
    STATE(7347), 1,
      aux_sym_template_argument_list_repeat1,
  [275634] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12229), 1,
      anon_sym_COLON,
    ACTIONS(12807), 1,
      anon_sym_RPAREN,
    STATE(8291), 1,
      sym_gnu_asm_goto_list,
  [275647] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8560), 1,
      anon_sym_COMMA,
    ACTIONS(12809), 1,
      anon_sym_RPAREN,
    STATE(7158), 1,
      aux_sym_generic_expression_repeat1,
  [275660] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12811), 1,
      anon_sym_GT2,
    STATE(7347), 1,
      aux_sym_template_argument_list_repeat1,
  [275673] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12813), 1,
      anon_sym_GT2,
    STATE(7347), 1,
      aux_sym_template_argument_list_repeat1,
  [275686] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12815), 1,
      anon_sym_GT2,
    STATE(7347), 1,
      aux_sym_template_argument_list_repeat1,
  [275699] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8640), 1,
      anon_sym_COMMA,
    ACTIONS(8758), 1,
      anon_sym_RBRACK,
    STATE(7316), 1,
      aux_sym_subscript_argument_list_repeat1,
  [275712] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11789), 1,
      anon_sym_COMMA,
    ACTIONS(12817), 1,
      anon_sym_LBRACE,
    STATE(7294), 1,
      aux_sym_base_class_clause_repeat1,
  [275725] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12354), 1,
      anon_sym_COMMA,
    ACTIONS(12819), 1,
      anon_sym_GT2,
    STATE(7388), 1,
      aux_sym_template_parameter_list_repeat1,
  [275738] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12821), 1,
      anon_sym_GT2,
    STATE(7347), 1,
      aux_sym_template_argument_list_repeat1,
  [275751] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12823), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(12825), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [275762] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12827), 1,
      anon_sym_GT2,
    STATE(7347), 1,
      aux_sym_template_argument_list_repeat1,
  [275775] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12829), 1,
      anon_sym_GT2,
    STATE(7347), 1,
      aux_sym_template_argument_list_repeat1,
  [275788] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12831), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [275797] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12289), 1,
      anon_sym_catch,
    STATE(489), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [275808] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11789), 1,
      anon_sym_COMMA,
    ACTIONS(12817), 1,
      anon_sym_LBRACE,
    STATE(7049), 1,
      aux_sym_base_class_clause_repeat1,
  [275821] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12223), 1,
      anon_sym_COMMA,
    ACTIONS(12833), 1,
      anon_sym_RPAREN,
    STATE(7404), 1,
      aux_sym_parameter_list_repeat1,
  [275834] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(12835), 1,
      anon_sym_SEMI,
    STATE(7308), 1,
      aux_sym_declaration_repeat1,
  [275847] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12184), 1,
      anon_sym_COLON,
    ACTIONS(12837), 1,
      anon_sym_RPAREN,
    STATE(7136), 1,
      sym_gnu_asm_input_operand_list,
  [275860] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12839), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [275869] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12841), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_GT2,
  [275878] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12843), 1,
      sym_identifier,
    STATE(2145), 1,
      sym_template_type,
    STATE(2765), 1,
      sym_template_function,
  [275891] = 4,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(12368), 1,
      anon_sym_LPAREN2,
    ACTIONS(12845), 1,
      aux_sym_preproc_include_token2,
    STATE(8226), 1,
      sym_preproc_argument_list,
  [275904] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12847), 1,
      anon_sym_GT2,
    STATE(7425), 1,
      aux_sym_template_argument_list_repeat1,
  [275917] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12229), 1,
      anon_sym_COLON,
    ACTIONS(12849), 1,
      anon_sym_RPAREN,
    STATE(7814), 1,
      sym_gnu_asm_goto_list,
  [275930] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12223), 1,
      anon_sym_COMMA,
    ACTIONS(12851), 1,
      anon_sym_RPAREN,
    STATE(7404), 1,
      aux_sym_parameter_list_repeat1,
  [275943] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12196), 1,
      anon_sym_COLON,
    ACTIONS(12853), 1,
      anon_sym_RPAREN,
    STATE(7056), 1,
      sym_gnu_asm_clobber_list,
  [275956] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12855), 1,
      sym_identifier,
    STATE(2145), 1,
      sym_template_type,
    STATE(3650), 1,
      sym_template_function,
  [275969] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12857), 1,
      sym_identifier,
    STATE(2145), 1,
      sym_template_type,
    STATE(2446), 1,
      sym_template_function,
  [275982] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12168), 1,
      anon_sym_COMMA,
    ACTIONS(12859), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7108), 1,
      aux_sym_attribute_declaration_repeat1,
  [275995] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12168), 1,
      anon_sym_COMMA,
    ACTIONS(12861), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7405), 1,
      aux_sym_attribute_declaration_repeat1,
  [276008] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12352), 1,
      anon_sym_catch,
    STATE(368), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [276019] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8640), 1,
      anon_sym_COMMA,
    ACTIONS(12863), 1,
      anon_sym_RBRACK,
    STATE(7418), 1,
      aux_sym_subscript_argument_list_repeat1,
  [276032] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12865), 1,
      sym_identifier,
    STATE(2145), 1,
      sym_template_type,
    STATE(2765), 1,
      sym_template_function,
  [276045] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12497), 1,
      anon_sym_catch,
    STATE(286), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [276056] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12867), 3,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_DOT,
  [276065] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8608), 1,
      anon_sym_COMMA,
    ACTIONS(12869), 1,
      anon_sym_RPAREN,
    STATE(7132), 1,
      aux_sym_argument_list_repeat1,
  [276078] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12229), 1,
      anon_sym_COLON,
    ACTIONS(12871), 1,
      anon_sym_RPAREN,
    STATE(7854), 1,
      sym_gnu_asm_goto_list,
  [276091] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12168), 1,
      anon_sym_COMMA,
    ACTIONS(12873), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7121), 1,
      aux_sym_attribute_declaration_repeat1,
  [276104] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12291), 1,
      anon_sym_LPAREN2,
    ACTIONS(12875), 1,
      anon_sym_constexpr,
    STATE(170), 1,
      sym_condition_clause,
  [276117] = 3,
    ACTIONS(9945), 1,
      sym_comment,
    STATE(6838), 1,
      aux_sym_char_literal_repeat1,
    ACTIONS(12877), 2,
      aux_sym_char_literal_token1,
      sym_escape_sequence,
  [276128] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12879), 1,
      anon_sym_COMMA,
    ACTIONS(12882), 1,
      anon_sym_GT2,
    STATE(7388), 1,
      aux_sym_template_parameter_list_repeat1,
  [276141] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(12884), 1,
      anon_sym_SEMI,
    STATE(7308), 1,
      aux_sym_declaration_repeat1,
  [276154] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11789), 1,
      anon_sym_COMMA,
    ACTIONS(11791), 1,
      anon_sym_LBRACE,
    STATE(7288), 1,
      aux_sym_base_class_clause_repeat1,
  [276167] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(12886), 1,
      anon_sym_SEMI,
    STATE(7052), 1,
      aux_sym_declaration_repeat1,
  [276180] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5041), 1,
      anon_sym_LBRACE,
    ACTIONS(11829), 1,
      anon_sym_COLON_COLON,
    STATE(349), 1,
      sym_declaration_list,
  [276193] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12740), 1,
      anon_sym_catch,
    STATE(1647), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [276204] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6010), 1,
      anon_sym_COMMA,
    ACTIONS(12888), 1,
      anon_sym_RBRACK,
    STATE(7147), 1,
      aux_sym_structured_binding_declarator_repeat1,
  [276217] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4348), 1,
      anon_sym_RBRACE,
    ACTIONS(12890), 1,
      anon_sym_COMMA,
    STATE(7169), 1,
      aux_sym_initializer_list_repeat1,
  [276230] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12192), 1,
      anon_sym_COLON,
    ACTIONS(12892), 1,
      anon_sym_RPAREN,
    STATE(7411), 1,
      sym_gnu_asm_output_operand_list,
  [276243] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12894), 1,
      anon_sym_COMMA,
    ACTIONS(12897), 1,
      anon_sym_RPAREN,
    STATE(7397), 1,
      aux_sym_requires_parameter_list_repeat1,
  [276256] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12899), 1,
      anon_sym_GT2,
    STATE(7347), 1,
      aux_sym_template_argument_list_repeat1,
  [276269] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12901), 1,
      anon_sym_GT2,
    STATE(7347), 1,
      aux_sym_template_argument_list_repeat1,
  [276282] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(12903), 1,
      anon_sym_SEMI,
    STATE(7424), 1,
      aux_sym_declaration_repeat1,
  [276295] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12905), 1,
      sym_identifier,
    STATE(2145), 1,
      sym_template_type,
    STATE(2765), 1,
      sym_template_function,
  [276308] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(12907), 1,
      anon_sym_SEMI,
    STATE(7308), 1,
      aux_sym_declaration_repeat1,
  [276321] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12909), 1,
      sym_identifier,
    STATE(2145), 1,
      sym_template_type,
    STATE(2765), 1,
      sym_template_function,
  [276334] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12911), 1,
      anon_sym_COMMA,
    ACTIONS(12914), 1,
      anon_sym_RPAREN,
    STATE(7404), 1,
      aux_sym_parameter_list_repeat1,
  [276347] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12168), 1,
      anon_sym_COMMA,
    ACTIONS(12916), 1,
      anon_sym_RBRACK_RBRACK,
    STATE(7108), 1,
      aux_sym_attribute_declaration_repeat1,
  [276360] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12607), 1,
      anon_sym_COMMA,
    ACTIONS(12918), 1,
      anon_sym_RPAREN,
    STATE(7241), 1,
      aux_sym_throw_specifier_repeat1,
  [276373] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8608), 1,
      anon_sym_COMMA,
    ACTIONS(8693), 1,
      anon_sym_RPAREN,
    STATE(7299), 1,
      aux_sym_argument_list_repeat1,
  [276386] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12184), 1,
      anon_sym_COLON,
    ACTIONS(12920), 1,
      anon_sym_RPAREN,
    STATE(7341), 1,
      sym_gnu_asm_input_operand_list,
  [276399] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12192), 1,
      anon_sym_COLON,
    ACTIONS(12922), 1,
      anon_sym_RPAREN,
    STATE(7365), 1,
      sym_gnu_asm_output_operand_list,
  [276412] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12924), 1,
      anon_sym_GT2,
    STATE(7347), 1,
      aux_sym_template_argument_list_repeat1,
  [276425] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12184), 1,
      anon_sym_COLON,
    ACTIONS(12926), 1,
      anon_sym_RPAREN,
    STATE(7331), 1,
      sym_gnu_asm_input_operand_list,
  [276438] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12192), 1,
      anon_sym_COLON,
    ACTIONS(12928), 1,
      anon_sym_RPAREN,
    STATE(7035), 1,
      sym_gnu_asm_output_operand_list,
  [276451] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12930), 1,
      anon_sym_GT2,
    STATE(7347), 1,
      aux_sym_template_argument_list_repeat1,
  [276464] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12932), 1,
      anon_sym_COMMA,
    ACTIONS(12935), 1,
      anon_sym_LBRACE,
    STATE(7414), 1,
      aux_sym_field_initializer_list_repeat1,
  [276477] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12340), 1,
      anon_sym_COMMA,
    ACTIONS(12937), 1,
      anon_sym_RBRACK,
    STATE(7171), 1,
      aux_sym_lambda_capture_specifier_repeat1,
  [276490] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12939), 1,
      anon_sym_GT2,
    STATE(7093), 1,
      aux_sym_template_argument_list_repeat1,
  [276503] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12192), 1,
      anon_sym_COLON,
    ACTIONS(12941), 1,
      anon_sym_RPAREN,
    STATE(7332), 1,
      sym_gnu_asm_output_operand_list,
  [276516] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8922), 1,
      anon_sym_RBRACK,
    ACTIONS(12943), 1,
      anon_sym_COMMA,
    STATE(7418), 1,
      aux_sym_subscript_argument_list_repeat1,
  [276529] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12946), 1,
      anon_sym_GT2,
    STATE(7347), 1,
      aux_sym_template_argument_list_repeat1,
  [276542] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5037), 1,
      anon_sym_LBRACE,
    ACTIONS(11829), 1,
      anon_sym_COLON_COLON,
    STATE(742), 1,
      sym_declaration_list,
  [276555] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(12948), 1,
      anon_sym_SEMI,
    STATE(7402), 1,
      aux_sym_declaration_repeat1,
  [276568] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(12950), 1,
      anon_sym_SEMI,
    STATE(7126), 1,
      aux_sym_declaration_repeat1,
  [276581] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(12952), 1,
      anon_sym_SEMI,
    STATE(7308), 1,
      aux_sym_declaration_repeat1,
  [276594] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9843), 1,
      anon_sym_COMMA,
    ACTIONS(12954), 1,
      anon_sym_SEMI,
    STATE(7308), 1,
      aux_sym_declaration_repeat1,
  [276607] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8570), 1,
      anon_sym_COMMA,
    ACTIONS(12956), 1,
      anon_sym_GT2,
    STATE(7347), 1,
      aux_sym_template_argument_list_repeat1,
  [276620] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12241), 1,
      anon_sym_catch,
    STATE(1818), 2,
      sym_catch_clause,
      aux_sym_constructor_try_statement_repeat1,
  [276631] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12958), 1,
      anon_sym_default,
    ACTIONS(12960), 1,
      anon_sym_delete,
    ACTIONS(12962), 1,
      aux_sym_pure_virtual_clause_token1,
  [276644] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8638), 1,
      anon_sym_LBRACE,
    STATE(4840), 1,
      sym_field_declaration_list,
  [276654] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8479), 1,
      anon_sym_LBRACE,
    STATE(4482), 1,
      sym_field_declaration_list,
  [276664] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12964), 1,
      anon_sym_LPAREN2,
    STATE(7507), 1,
      sym_parenthesized_expression,
  [276674] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12966), 1,
      anon_sym_LT,
    STATE(3648), 1,
      sym_template_argument_list,
  [276684] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12291), 1,
      anon_sym_LPAREN2,
    STATE(168), 1,
      sym_condition_clause,
  [276694] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    STATE(2854), 1,
      sym_field_declaration_list,
  [276704] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12968), 1,
      anon_sym_LT,
    STATE(2279), 1,
      sym_template_argument_list,
  [276714] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12135), 1,
      anon_sym_LBRACE,
    STATE(5403), 1,
      sym_requirement_seq,
  [276724] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10789), 1,
      anon_sym_LBRACE,
    STATE(1993), 1,
      sym_compound_statement,
  [276734] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12970), 1,
      sym_identifier,
    STATE(4284), 1,
      sym_template_type,
  [276744] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8018), 1,
      anon_sym_LPAREN2,
    STATE(8271), 1,
      sym_argument_list,
  [276754] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6074), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [276762] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(289), 1,
      anon_sym_LBRACE,
    STATE(252), 1,
      sym_compound_statement,
  [276772] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5039), 1,
      anon_sym_LBRACE,
    STATE(680), 1,
      sym_declaration_list,
  [276782] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    STATE(461), 1,
      sym_compound_statement,
  [276792] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12972), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [276800] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12974), 1,
      anon_sym_COMMA,
    ACTIONS(12976), 1,
      anon_sym_RBRACE,
  [276810] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7417), 1,
      anon_sym_LBRACE,
    STATE(3882), 1,
      sym_field_declaration_list,
  [276820] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5381), 1,
      anon_sym_LBRACE,
    STATE(2120), 1,
      sym_field_declaration_list,
  [276830] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    STATE(2888), 1,
      sym_field_declaration_list,
  [276840] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5029), 1,
      anon_sym_LBRACE,
    STATE(580), 1,
      sym_declaration_list,
  [276850] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8822), 1,
      anon_sym_LT,
    STATE(2495), 1,
      sym_template_argument_list,
  [276860] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6675), 1,
      anon_sym_LT,
    STATE(2679), 1,
      sym_template_argument_list,
  [276870] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(644), 1,
      anon_sym_LBRACE,
    STATE(417), 1,
      sym_compound_statement,
  [276880] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11829), 1,
      anon_sym_COLON_COLON,
    ACTIONS(12978), 1,
      anon_sym_SEMI,
  [276890] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12342), 1,
      anon_sym_RBRACK,
    ACTIONS(12980), 1,
      anon_sym_COMMA,
  [276900] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10935), 1,
      anon_sym_RBRACE,
    ACTIONS(12974), 1,
      anon_sym_COMMA,
  [276910] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12966), 1,
      anon_sym_LT,
    STATE(3421), 1,
      sym_template_argument_list,
  [276920] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6463), 1,
      anon_sym_LT,
    STATE(2324), 1,
      sym_template_argument_list,
  [276930] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10888), 1,
      anon_sym_RBRACE,
    ACTIONS(12974), 1,
      anon_sym_COMMA,
  [276940] = 3,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(12982), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(12984), 1,
      sym_preproc_arg,
  [276950] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(289), 1,
      anon_sym_LBRACE,
    STATE(233), 1,
      sym_compound_statement,
  [276960] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7417), 1,
      anon_sym_LBRACE,
    STATE(3924), 1,
      sym_field_declaration_list,
  [276970] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7417), 1,
      anon_sym_LBRACE,
    STATE(3919), 1,
      sym_field_declaration_list,
  [276980] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12974), 1,
      anon_sym_COMMA,
    ACTIONS(12986), 1,
      anon_sym_RBRACE,
  [276990] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    STATE(7361), 1,
      sym_compound_statement,
  [277000] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5878), 1,
      anon_sym_LBRACE,
    STATE(2318), 1,
      sym_field_declaration_list,
  [277010] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7417), 1,
      anon_sym_LBRACE,
    STATE(3906), 1,
      sym_field_declaration_list,
  [277020] = 3,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(12988), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(12990), 1,
      sym_preproc_arg,
  [277030] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12332), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [277038] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5878), 1,
      anon_sym_LBRACE,
    STATE(2319), 1,
      sym_field_declaration_list,
  [277048] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8018), 1,
      anon_sym_LPAREN2,
    STATE(8067), 1,
      sym_argument_list,
  [277058] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12245), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [277066] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    STATE(7025), 1,
      sym_compound_statement,
  [277076] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12291), 1,
      anon_sym_LPAREN2,
    STATE(181), 1,
      sym_condition_clause,
  [277086] = 3,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(12992), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(12994), 1,
      sym_preproc_arg,
  [277096] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10908), 1,
      anon_sym_RBRACE,
    ACTIONS(12974), 1,
      anon_sym_COMMA,
  [277106] = 3,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(12996), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(12998), 1,
      sym_preproc_arg,
  [277116] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13000), 1,
      sym_identifier,
    STATE(3640), 1,
      sym_template_type,
  [277126] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1927), 1,
      anon_sym_LBRACE,
    STATE(2371), 1,
      sym_initializer_list,
  [277136] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    STATE(729), 1,
      sym_compound_statement,
  [277146] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13002), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [277154] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13004), 1,
      sym_identifier,
    STATE(1787), 1,
      sym_template_type,
  [277164] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10947), 1,
      anon_sym_RBRACE,
    ACTIONS(12974), 1,
      anon_sym_COMMA,
  [277174] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5882), 1,
      anon_sym_LT,
    STATE(1570), 1,
      sym_template_argument_list,
  [277184] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6533), 1,
      anon_sym_LBRACE,
    STATE(2825), 1,
      sym_field_declaration_list,
  [277194] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13006), 1,
      anon_sym_LT,
    STATE(2324), 1,
      sym_template_argument_list,
  [277204] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2581), 1,
      anon_sym_LBRACE,
    STATE(3775), 1,
      sym_initializer_list,
  [277214] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6533), 1,
      anon_sym_LBRACE,
    STATE(2826), 1,
      sym_field_declaration_list,
  [277224] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13008), 1,
      sym_identifier,
    STATE(2525), 1,
      sym_template_type,
  [277234] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13010), 1,
      sym_identifier,
    STATE(2553), 1,
      sym_template_type,
  [277244] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8554), 1,
      anon_sym_LT,
    STATE(2654), 1,
      sym_template_argument_list,
  [277254] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    STATE(397), 1,
      sym_compound_statement,
  [277264] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8878), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [277272] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12964), 1,
      anon_sym_LPAREN2,
    STATE(7494), 1,
      sym_parenthesized_expression,
  [277282] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5029), 1,
      anon_sym_LBRACE,
    STATE(663), 1,
      sym_declaration_list,
  [277292] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(616), 1,
      anon_sym_LBRACE,
    STATE(492), 1,
      sym_compound_statement,
  [277302] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11829), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13012), 1,
      anon_sym_SEMI,
  [277312] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(616), 1,
      anon_sym_LBRACE,
    STATE(473), 1,
      sym_compound_statement,
  [277322] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6222), 1,
      anon_sym_LBRACE,
    STATE(2578), 1,
      sym_field_declaration_list,
  [277332] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1641), 1,
      anon_sym_LBRACE,
    STATE(869), 1,
      sym_compound_statement,
  [277342] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12387), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [277350] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12418), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [277358] = 3,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(13014), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13016), 1,
      sym_preproc_arg,
  [277368] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13018), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [277376] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9621), 1,
      anon_sym_LBRACE,
    STATE(3813), 1,
      sym_requirement_seq,
  [277386] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13020), 1,
      sym_identifier,
    STATE(7153), 1,
      sym_attribute,
  [277396] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10830), 1,
      anon_sym_LBRACE,
    STATE(1667), 1,
      sym_compound_statement,
  [277406] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12291), 1,
      anon_sym_LPAREN2,
    STATE(7525), 1,
      sym_condition_clause,
  [277416] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    STATE(492), 1,
      sym_compound_statement,
  [277426] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12291), 1,
      anon_sym_LPAREN2,
    STATE(189), 1,
      sym_condition_clause,
  [277436] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    STATE(7188), 1,
      sym_compound_statement,
  [277446] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(644), 1,
      anon_sym_LBRACE,
    STATE(609), 1,
      sym_compound_statement,
  [277456] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12966), 1,
      anon_sym_LT,
    STATE(2604), 1,
      sym_template_argument_list,
  [277466] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13022), 1,
      sym_identifier,
    STATE(2145), 1,
      sym_template_type,
  [277476] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3730), 1,
      anon_sym_LBRACE,
    STATE(4749), 1,
      sym_initializer_list,
  [277486] = 3,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(13024), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13026), 1,
      sym_preproc_arg,
  [277496] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13028), 1,
      anon_sym_LT,
    STATE(2600), 1,
      sym_template_argument_list,
  [277506] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8018), 1,
      anon_sym_LPAREN2,
    STATE(8001), 1,
      sym_argument_list,
  [277516] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    STATE(6969), 1,
      sym_compound_statement,
  [277526] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12291), 1,
      anon_sym_LPAREN2,
    STATE(193), 1,
      sym_condition_clause,
  [277536] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12469), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [277544] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6253), 1,
      anon_sym_LBRACE,
    STATE(2728), 1,
      sym_field_declaration_list,
  [277554] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8720), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [277562] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12291), 1,
      anon_sym_LPAREN2,
    STATE(183), 1,
      sym_condition_clause,
  [277572] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8681), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [277580] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12964), 1,
      anon_sym_LPAREN2,
    STATE(8515), 1,
      sym_parenthesized_expression,
  [277590] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(289), 1,
      anon_sym_LBRACE,
    STATE(243), 1,
      sym_compound_statement,
  [277600] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    STATE(7745), 1,
      sym_parameter_list,
  [277610] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8884), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [277618] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10916), 1,
      anon_sym_RBRACE,
    ACTIONS(12974), 1,
      anon_sym_COMMA,
  [277628] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    STATE(7303), 1,
      sym_compound_statement,
  [277638] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12968), 1,
      anon_sym_LT,
    STATE(2324), 1,
      sym_template_argument_list,
  [277648] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13030), 1,
      sym_identifier,
    STATE(1885), 1,
      sym_template_type,
  [277658] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12964), 1,
      anon_sym_LPAREN2,
    STATE(7539), 1,
      sym_parenthesized_expression,
  [277668] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6222), 1,
      anon_sym_LBRACE,
    STATE(2541), 1,
      sym_field_declaration_list,
  [277678] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6222), 1,
      anon_sym_LBRACE,
    STATE(2543), 1,
      sym_field_declaration_list,
  [277688] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12707), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [277696] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12974), 1,
      anon_sym_COMMA,
    ACTIONS(13032), 1,
      anon_sym_RBRACE,
  [277706] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8416), 1,
      anon_sym_LT,
    STATE(4306), 1,
      sym_template_argument_list,
  [277716] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6533), 1,
      anon_sym_LBRACE,
    STATE(2830), 1,
      sym_field_declaration_list,
  [277726] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    STATE(537), 1,
      sym_compound_statement,
  [277736] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5037), 1,
      anon_sym_LBRACE,
    STATE(698), 1,
      sym_declaration_list,
  [277746] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13034), 1,
      sym_identifier,
    ACTIONS(13036), 1,
      anon_sym_RPAREN,
  [277756] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10842), 1,
      anon_sym_LBRACE,
    STATE(1875), 1,
      sym_compound_statement,
  [277766] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5041), 1,
      anon_sym_LBRACE,
    STATE(275), 1,
      sym_declaration_list,
  [277776] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(644), 1,
      anon_sym_LBRACE,
    STATE(554), 1,
      sym_compound_statement,
  [277786] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13038), 1,
      sym_identifier,
    STATE(1787), 1,
      sym_template_type,
  [277796] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7205), 1,
      anon_sym_LT,
    STATE(1570), 1,
      sym_template_argument_list,
  [277806] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9603), 1,
      anon_sym_LBRACE,
    STATE(3352), 1,
      sym_requirement_seq,
  [277816] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(644), 1,
      anon_sym_LBRACE,
    STATE(535), 1,
      sym_compound_statement,
  [277826] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13020), 1,
      sym_identifier,
    STATE(7254), 1,
      sym_attribute,
  [277836] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12291), 1,
      anon_sym_LPAREN2,
    STATE(7595), 1,
      sym_condition_clause,
  [277846] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12291), 1,
      anon_sym_LPAREN2,
    STATE(199), 1,
      sym_condition_clause,
  [277856] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13040), 1,
      anon_sym_LT,
    STATE(1829), 1,
      sym_template_argument_list,
  [277866] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    STATE(7381), 1,
      sym_compound_statement,
  [277876] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12974), 1,
      anon_sym_COMMA,
    ACTIONS(13042), 1,
      anon_sym_RBRACE,
  [277886] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13044), 1,
      sym_identifier,
    STATE(2145), 1,
      sym_template_type,
  [277896] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6222), 1,
      anon_sym_LBRACE,
    STATE(2558), 1,
      sym_field_declaration_list,
  [277906] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9587), 1,
      anon_sym_LBRACE,
    STATE(2377), 1,
      sym_requirement_seq,
  [277916] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8018), 1,
      anon_sym_LPAREN2,
    STATE(8299), 1,
      sym_argument_list,
  [277926] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    STATE(6896), 1,
      sym_compound_statement,
  [277936] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12291), 1,
      anon_sym_LPAREN2,
    STATE(202), 1,
      sym_condition_clause,
  [277946] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10789), 1,
      anon_sym_LBRACE,
    STATE(1871), 1,
      sym_compound_statement,
  [277956] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12964), 1,
      anon_sym_LPAREN2,
    STATE(8031), 1,
      sym_parenthesized_expression,
  [277966] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    STATE(7451), 1,
      sym_parameter_list,
  [277976] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(289), 1,
      anon_sym_LBRACE,
    STATE(296), 1,
      sym_compound_statement,
  [277986] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    STATE(7086), 1,
      sym_compound_statement,
  [277996] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12503), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [278004] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12964), 1,
      anon_sym_LPAREN2,
    STATE(7459), 1,
      sym_parenthesized_expression,
  [278014] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(644), 1,
      anon_sym_LBRACE,
    STATE(428), 1,
      sym_compound_statement,
  [278024] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12291), 1,
      anon_sym_LPAREN2,
    STATE(201), 1,
      sym_condition_clause,
  [278034] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6463), 1,
      anon_sym_LT,
    STATE(1570), 1,
      sym_template_argument_list,
  [278044] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13020), 1,
      sym_identifier,
    STATE(7133), 1,
      sym_attribute,
  [278054] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12291), 1,
      anon_sym_LPAREN2,
    STATE(7498), 1,
      sym_condition_clause,
  [278064] = 3,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(13046), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13048), 1,
      sym_preproc_arg,
  [278074] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    STATE(7142), 1,
      sym_compound_statement,
  [278084] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8018), 1,
      anon_sym_LPAREN2,
    STATE(8463), 1,
      sym_argument_list,
  [278094] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    STATE(6939), 1,
      sym_compound_statement,
  [278104] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11947), 1,
      sym_identifier,
    STATE(2145), 1,
      sym_template_type,
  [278114] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(616), 1,
      anon_sym_LBRACE,
    STATE(678), 1,
      sym_compound_statement,
  [278124] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5878), 1,
      anon_sym_LBRACE,
    STATE(2313), 1,
      sym_field_declaration_list,
  [278134] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5381), 1,
      anon_sym_LBRACE,
    STATE(2127), 1,
      sym_field_declaration_list,
  [278144] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12964), 1,
      anon_sym_LPAREN2,
    STATE(7837), 1,
      sym_parenthesized_expression,
  [278154] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    STATE(7561), 1,
      sym_parameter_list,
  [278164] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13050), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [278172] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(616), 1,
      anon_sym_LBRACE,
    STATE(684), 1,
      sym_compound_statement,
  [278182] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    STATE(7216), 1,
      sym_compound_statement,
  [278192] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12964), 1,
      anon_sym_LPAREN2,
    STATE(7568), 1,
      sym_parenthesized_expression,
  [278202] = 3,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(13052), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13054), 1,
      sym_preproc_arg,
  [278212] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    STATE(690), 1,
      sym_compound_statement,
  [278222] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13056), 1,
      sym_identifier,
    STATE(2668), 1,
      sym_template_type,
  [278232] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6463), 1,
      anon_sym_LT,
    STATE(2692), 1,
      sym_template_argument_list,
  [278242] = 3,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(13058), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13060), 1,
      sym_preproc_arg,
  [278252] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13020), 1,
      sym_identifier,
    STATE(7262), 1,
      sym_attribute,
  [278262] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    STATE(7274), 1,
      sym_compound_statement,
  [278272] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8018), 1,
      anon_sym_LPAREN2,
    STATE(8131), 1,
      sym_argument_list,
  [278282] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(644), 1,
      anon_sym_LBRACE,
    STATE(496), 1,
      sym_compound_statement,
  [278292] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12291), 1,
      anon_sym_LPAREN2,
    STATE(7442), 1,
      sym_condition_clause,
  [278302] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2456), 1,
      anon_sym_LBRACE,
    STATE(3547), 1,
      sym_initializer_list,
  [278312] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    STATE(7670), 1,
      sym_parameter_list,
  [278322] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12291), 1,
      anon_sym_LPAREN2,
    STATE(212), 1,
      sym_condition_clause,
  [278332] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    STATE(7334), 1,
      sym_compound_statement,
  [278342] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13062), 1,
      sym_identifier,
    STATE(2172), 1,
      sym_template_type,
  [278352] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12964), 1,
      anon_sym_LPAREN2,
    STATE(7678), 1,
      sym_parenthesized_expression,
  [278362] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12291), 1,
      anon_sym_LPAREN2,
    STATE(209), 1,
      sym_condition_clause,
  [278372] = 3,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(13064), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13066), 1,
      sym_preproc_arg,
  [278382] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13020), 1,
      sym_identifier,
    STATE(7377), 1,
      sym_attribute,
  [278392] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    STATE(7393), 1,
      sym_compound_statement,
  [278402] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5037), 1,
      anon_sym_LBRACE,
    STATE(724), 1,
      sym_declaration_list,
  [278412] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8018), 1,
      anon_sym_LPAREN2,
    STATE(8510), 1,
      sym_argument_list,
  [278422] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4422), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [278430] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(616), 1,
      anon_sym_LBRACE,
    STATE(519), 1,
      sym_compound_statement,
  [278440] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8638), 1,
      anon_sym_LBRACE,
    STATE(4823), 1,
      sym_field_declaration_list,
  [278450] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10842), 1,
      anon_sym_LBRACE,
    STATE(1905), 1,
      sym_compound_statement,
  [278460] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    STATE(7505), 1,
      sym_parameter_list,
  [278470] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6648), 1,
      anon_sym_LBRACE,
    STATE(2957), 1,
      sym_field_declaration_list,
  [278480] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    STATE(7490), 1,
      sym_parameter_list,
  [278490] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    STATE(7164), 1,
      sym_compound_statement,
  [278500] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13068), 1,
      sym_identifier,
    STATE(2695), 1,
      sym_template_type,
  [278510] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11797), 1,
      anon_sym_LBRACE,
    STATE(5839), 1,
      sym_requirement_seq,
  [278520] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13020), 1,
      sym_identifier,
    STATE(7385), 1,
      sym_attribute,
  [278530] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    STATE(7063), 1,
      sym_compound_statement,
  [278540] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10939), 1,
      anon_sym_RBRACE,
    ACTIONS(12974), 1,
      anon_sym_COMMA,
  [278550] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8018), 1,
      anon_sym_LPAREN2,
    STATE(8590), 1,
      sym_argument_list,
  [278560] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    STATE(7542), 1,
      sym_parameter_list,
  [278570] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    STATE(473), 1,
      sym_compound_statement,
  [278580] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9595), 1,
      anon_sym_LBRACE,
    STATE(3628), 1,
      sym_requirement_seq,
  [278590] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8018), 1,
      anon_sym_LPAREN2,
    STATE(8121), 1,
      sym_argument_list,
  [278600] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13070), 1,
      sym_identifier,
    ACTIONS(13072), 1,
      anon_sym_LPAREN2,
  [278610] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    STATE(2920), 1,
      sym_field_declaration_list,
  [278620] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13074), 1,
      anon_sym_LT,
    STATE(2654), 1,
      sym_template_argument_list,
  [278630] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5029), 1,
      anon_sym_LBRACE,
    STATE(555), 1,
      sym_declaration_list,
  [278640] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    STATE(2925), 1,
      sym_field_declaration_list,
  [278650] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8018), 1,
      anon_sym_LPAREN2,
    STATE(8120), 1,
      sym_argument_list,
  [278660] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10830), 1,
      anon_sym_LBRACE,
    STATE(1693), 1,
      sym_compound_statement,
  [278670] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13076), 1,
      anon_sym_LPAREN2,
    ACTIONS(13078), 1,
      sym_raw_string_delimiter,
  [278680] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10498), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [278688] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12974), 1,
      anon_sym_COMMA,
    ACTIONS(13080), 1,
      anon_sym_RBRACE,
  [278698] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13020), 1,
      sym_identifier,
    STATE(7073), 1,
      sym_attribute,
  [278708] = 3,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(13082), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13084), 1,
      sym_preproc_arg,
  [278718] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12968), 1,
      anon_sym_LT,
    STATE(1874), 1,
      sym_template_argument_list,
  [278728] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6253), 1,
      anon_sym_LBRACE,
    STATE(2800), 1,
      sym_field_declaration_list,
  [278738] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6253), 1,
      anon_sym_LBRACE,
    STATE(2801), 1,
      sym_field_declaration_list,
  [278748] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12974), 1,
      anon_sym_COMMA,
    ACTIONS(13086), 1,
      anon_sym_RBRACE,
  [278758] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    STATE(6897), 1,
      sym_compound_statement,
  [278768] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12974), 1,
      anon_sym_COMMA,
    ACTIONS(13088), 1,
      anon_sym_RBRACE,
  [278778] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5039), 1,
      anon_sym_LBRACE,
    STATE(540), 1,
      sym_declaration_list,
  [278788] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12291), 1,
      anon_sym_LPAREN2,
    STATE(7610), 1,
      sym_condition_clause,
  [278798] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10918), 1,
      anon_sym_RBRACE,
    ACTIONS(12974), 1,
      anon_sym_COMMA,
  [278808] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8703), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [278816] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12291), 1,
      anon_sym_LPAREN2,
    STATE(171), 1,
      sym_condition_clause,
  [278826] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6648), 1,
      anon_sym_LBRACE,
    STATE(2965), 1,
      sym_field_declaration_list,
  [278836] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6648), 1,
      anon_sym_LBRACE,
    STATE(3013), 1,
      sym_field_declaration_list,
  [278846] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    STATE(7119), 1,
      sym_compound_statement,
  [278856] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8760), 1,
      anon_sym_RPAREN,
    ACTIONS(8762), 1,
      anon_sym_SEMI,
  [278866] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10914), 1,
      anon_sym_RBRACE,
    ACTIONS(12974), 1,
      anon_sym_COMMA,
  [278876] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9613), 1,
      anon_sym_LBRACE,
    STATE(4205), 1,
      sym_requirement_seq,
  [278886] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12514), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [278894] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13090), 1,
      sym_identifier,
    STATE(2145), 1,
      sym_template_type,
  [278904] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5878), 1,
      anon_sym_LBRACE,
    STATE(2290), 1,
      sym_field_declaration_list,
  [278914] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10830), 1,
      anon_sym_LBRACE,
    STATE(1722), 1,
      sym_compound_statement,
  [278924] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10789), 1,
      anon_sym_LBRACE,
    STATE(1968), 1,
      sym_compound_statement,
  [278934] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1641), 1,
      anon_sym_LBRACE,
    STATE(850), 1,
      sym_compound_statement,
  [278944] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13092), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK_RBRACK,
  [278952] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8638), 1,
      anon_sym_LBRACE,
    STATE(4838), 1,
      sym_field_declaration_list,
  [278962] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12974), 1,
      anon_sym_COMMA,
    ACTIONS(13094), 1,
      anon_sym_RBRACE,
  [278972] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13020), 1,
      sym_identifier,
    STATE(7467), 1,
      sym_attribute,
  [278982] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13020), 1,
      sym_identifier,
    STATE(7037), 1,
      sym_attribute,
  [278992] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6648), 1,
      anon_sym_LBRACE,
    STATE(2941), 1,
      sym_field_declaration_list,
  [279002] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8018), 1,
      anon_sym_LPAREN2,
    STATE(8561), 1,
      sym_argument_list,
  [279012] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    STATE(6907), 1,
      sym_compound_statement,
  [279022] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1641), 1,
      anon_sym_LBRACE,
    STATE(843), 1,
      sym_compound_statement,
  [279032] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    STATE(7134), 1,
      sym_compound_statement,
  [279042] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12964), 1,
      anon_sym_LPAREN2,
    STATE(7848), 1,
      sym_parenthesized_expression,
  [279052] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3466), 1,
      anon_sym_LBRACE,
    STATE(3793), 1,
      sym_initializer_list,
  [279062] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12291), 1,
      anon_sym_LPAREN2,
    STATE(175), 1,
      sym_condition_clause,
  [279072] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13096), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [279080] = 3,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(13098), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13100), 1,
      sym_preproc_arg,
  [279090] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13028), 1,
      anon_sym_LT,
    STATE(3410), 1,
      sym_template_argument_list,
  [279100] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1641), 1,
      anon_sym_LBRACE,
    STATE(860), 1,
      sym_compound_statement,
  [279110] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6463), 1,
      anon_sym_LT,
    STATE(2279), 1,
      sym_template_argument_list,
  [279120] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5878), 1,
      anon_sym_LBRACE,
    STATE(5094), 1,
      sym_field_declaration_list,
  [279130] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8554), 1,
      anon_sym_LT,
    STATE(1829), 1,
      sym_template_argument_list,
  [279140] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5878), 1,
      anon_sym_LBRACE,
    STATE(4988), 1,
      sym_field_declaration_list,
  [279150] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5878), 1,
      anon_sym_LBRACE,
    STATE(5097), 1,
      sym_field_declaration_list,
  [279160] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5878), 1,
      anon_sym_LBRACE,
    STATE(5099), 1,
      sym_field_declaration_list,
  [279170] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12622), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [279178] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7822), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [279186] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2031), 1,
      anon_sym_LBRACE,
    STATE(3353), 1,
      sym_initializer_list,
  [279196] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(616), 1,
      anon_sym_LBRACE,
    STATE(420), 1,
      sym_compound_statement,
  [279206] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12825), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [279214] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11829), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13102), 1,
      anon_sym_SEMI,
  [279224] = 3,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(13104), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13106), 1,
      sym_preproc_arg,
  [279234] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13108), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [279242] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(289), 1,
      anon_sym_LBRACE,
    STATE(334), 1,
      sym_compound_statement,
  [279252] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13110), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [279260] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13112), 2,
      anon_sym_DOT_DOT_DOT,
      sym_identifier,
  [279268] = 3,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(13114), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13116), 1,
      sym_preproc_arg,
  [279278] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5037), 1,
      anon_sym_LBRACE,
    STATE(746), 1,
      sym_declaration_list,
  [279288] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13118), 1,
      sym_identifier,
    STATE(2741), 1,
      sym_template_type,
  [279298] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12974), 1,
      anon_sym_COMMA,
    ACTIONS(13120), 1,
      anon_sym_RBRACE,
  [279308] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8638), 1,
      anon_sym_LBRACE,
    STATE(4812), 1,
      sym_field_declaration_list,
  [279318] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5039), 1,
      anon_sym_LBRACE,
    STATE(649), 1,
      sym_declaration_list,
  [279328] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13122), 1,
      sym_identifier,
    ACTIONS(13124), 1,
      anon_sym_LPAREN2,
  [279338] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12882), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [279346] = 3,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(13126), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13128), 1,
      sym_preproc_arg,
  [279356] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12207), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [279364] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6533), 1,
      anon_sym_LBRACE,
    STATE(2810), 1,
      sym_field_declaration_list,
  [279374] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    STATE(469), 1,
      sym_compound_statement,
  [279384] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10882), 1,
      anon_sym_RBRACE,
    ACTIONS(12974), 1,
      anon_sym_COMMA,
  [279394] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8479), 1,
      anon_sym_LBRACE,
    STATE(4440), 1,
      sym_field_declaration_list,
  [279404] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9579), 1,
      anon_sym_LBRACE,
    STATE(3231), 1,
      sym_requirement_seq,
  [279414] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13130), 1,
      anon_sym_LPAREN2,
    ACTIONS(13132), 1,
      sym_raw_string_delimiter,
  [279424] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12964), 1,
      anon_sym_LPAREN2,
    STATE(8213), 1,
      sym_parenthesized_expression,
  [279434] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    STATE(3617), 1,
      sym_field_declaration_list,
  [279444] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5041), 1,
      anon_sym_LBRACE,
    STATE(355), 1,
      sym_declaration_list,
  [279454] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    STATE(3620), 1,
      sym_field_declaration_list,
  [279464] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    STATE(3621), 1,
      sym_field_declaration_list,
  [279474] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6563), 1,
      anon_sym_LBRACE,
    STATE(3623), 1,
      sym_field_declaration_list,
  [279484] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12897), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [279492] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12974), 1,
      anon_sym_COMMA,
    ACTIONS(13134), 1,
      anon_sym_RBRACE,
  [279502] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13136), 2,
      anon_sym_COMMA,
      anon_sym_GT2,
  [279510] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9630), 1,
      anon_sym_LPAREN2,
    STATE(7688), 1,
      sym_parameter_list,
  [279520] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13138), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [279528] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12024), 1,
      anon_sym_LBRACE,
    STATE(1597), 1,
      sym_requirement_seq,
  [279538] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5381), 1,
      anon_sym_LBRACE,
    STATE(2150), 1,
      sym_field_declaration_list,
  [279548] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13028), 1,
      anon_sym_LT,
    STATE(3252), 1,
      sym_template_argument_list,
  [279558] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10842), 1,
      anon_sym_LBRACE,
    STATE(1906), 1,
      sym_compound_statement,
  [279568] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5381), 1,
      anon_sym_LBRACE,
    STATE(2151), 1,
      sym_field_declaration_list,
  [279578] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12914), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [279586] = 3,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(13140), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13142), 1,
      sym_preproc_arg,
  [279596] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7205), 1,
      anon_sym_LT,
    STATE(2692), 1,
      sym_template_argument_list,
  [279606] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13144), 1,
      sym_identifier,
    STATE(1787), 1,
      sym_template_type,
  [279616] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6253), 1,
      anon_sym_LBRACE,
    STATE(2740), 1,
      sym_field_declaration_list,
  [279626] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10933), 1,
      anon_sym_RBRACE,
    ACTIONS(12974), 1,
      anon_sym_COMMA,
  [279636] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8479), 1,
      anon_sym_LBRACE,
    STATE(4467), 1,
      sym_field_declaration_list,
  [279646] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8479), 1,
      anon_sym_LBRACE,
    STATE(4468), 1,
      sym_field_declaration_list,
  [279656] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13146), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [279664] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    STATE(7378), 1,
      sym_compound_statement,
  [279674] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12935), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [279682] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13148), 1,
      anon_sym_LPAREN2,
    ACTIONS(13150), 1,
      sym_raw_string_delimiter,
  [279692] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13152), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [279700] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8922), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [279708] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13154), 1,
      anon_sym_LPAREN2,
    ACTIONS(13156), 1,
      sym_raw_string_delimiter,
  [279718] = 3,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(13158), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(13160), 1,
      sym_preproc_arg,
  [279728] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13162), 1,
      anon_sym_LPAREN2,
    ACTIONS(13164), 1,
      sym_raw_string_delimiter,
  [279738] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(289), 1,
      anon_sym_LBRACE,
    STATE(227), 1,
      sym_compound_statement,
  [279748] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13166), 1,
      anon_sym_LPAREN2,
    ACTIONS(13168), 1,
      sym_raw_string_delimiter,
  [279758] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11829), 1,
      anon_sym_COLON_COLON,
    ACTIONS(13170), 1,
      anon_sym_SEMI,
  [279768] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13172), 1,
      anon_sym_LPAREN2,
    ACTIONS(13174), 1,
      sym_raw_string_delimiter,
  [279778] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13176), 1,
      anon_sym_LPAREN2,
    ACTIONS(13178), 1,
      sym_raw_string_delimiter,
  [279788] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13180), 1,
      anon_sym_LPAREN2,
    ACTIONS(13182), 1,
      sym_raw_string_delimiter,
  [279798] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13184), 1,
      anon_sym_LPAREN2,
    ACTIONS(13186), 1,
      sym_raw_string_delimiter,
  [279808] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13188), 1,
      anon_sym_LPAREN2,
    ACTIONS(13190), 1,
      sym_raw_string_delimiter,
  [279818] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13192), 1,
      anon_sym_LPAREN2,
    ACTIONS(13194), 1,
      sym_raw_string_delimiter,
  [279828] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13196), 1,
      anon_sym_LPAREN2,
    ACTIONS(13198), 1,
      sym_raw_string_delimiter,
  [279838] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13200), 1,
      anon_sym_LPAREN2,
    ACTIONS(13202), 1,
      sym_raw_string_delimiter,
  [279848] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13204), 1,
      anon_sym_LPAREN2,
    ACTIONS(13206), 1,
      sym_raw_string_delimiter,
  [279858] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13208), 1,
      anon_sym_LPAREN2,
    ACTIONS(13210), 1,
      sym_raw_string_delimiter,
  [279868] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13212), 1,
      anon_sym_LPAREN2,
    ACTIONS(13214), 1,
      sym_raw_string_delimiter,
  [279878] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8554), 1,
      anon_sym_LT,
    STATE(1570), 1,
      sym_template_argument_list,
  [279888] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5041), 1,
      anon_sym_LBRACE,
    STATE(312), 1,
      sym_declaration_list,
  [279898] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13216), 1,
      anon_sym_LPAREN2,
  [279905] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13218), 1,
      anon_sym_RPAREN,
  [279912] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13220), 1,
      anon_sym_RPAREN,
  [279919] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13222), 1,
      sym_auto,
  [279926] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13224), 1,
      anon_sym_PIPE,
  [279933] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13226), 1,
      anon_sym_SEMI,
  [279940] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13228), 1,
      anon_sym_RPAREN,
  [279947] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13230), 1,
      anon_sym_RPAREN,
  [279954] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13032), 1,
      anon_sym_RBRACE,
  [279961] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13232), 1,
      anon_sym_SEMI,
  [279968] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13234), 1,
      anon_sym_DQUOTE,
  [279975] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13236), 1,
      anon_sym_RPAREN,
  [279982] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13238), 1,
      sym_raw_string_delimiter,
  [279989] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12036), 1,
      anon_sym_SEMI,
  [279996] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13240), 1,
      anon_sym_SEMI,
  [280003] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13242), 1,
      anon_sym_COLON,
  [280010] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13244), 1,
      anon_sym_RPAREN,
  [280017] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13246), 1,
      anon_sym_SEMI,
  [280024] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13248), 1,
      anon_sym_DQUOTE,
  [280031] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13250), 1,
      anon_sym_DQUOTE,
  [280038] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13252), 1,
      anon_sym_RPAREN,
  [280045] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13254), 1,
      sym_identifier,
  [280052] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7363), 1,
      sym_identifier,
  [280059] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13256), 1,
      anon_sym_DQUOTE,
  [280066] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13258), 1,
      anon_sym_SEMI,
  [280073] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13260), 1,
      anon_sym_SEMI,
  [280080] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13262), 1,
      anon_sym_SEMI,
  [280087] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13264), 1,
      anon_sym_RPAREN,
  [280094] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13266), 1,
      sym_auto,
  [280101] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13268), 1,
      anon_sym_RPAREN,
  [280108] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8858), 1,
      anon_sym_COLON,
  [280115] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13270), 1,
      anon_sym_RPAREN,
  [280122] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13272), 1,
      sym_identifier,
  [280129] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13274), 1,
      sym_identifier,
  [280136] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13276), 1,
      aux_sym_preproc_if_token2,
  [280143] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13278), 1,
      anon_sym_SEMI,
  [280150] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13280), 1,
      anon_sym_SEMI,
  [280157] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13282), 1,
      anon_sym_RPAREN,
  [280164] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13284), 1,
      anon_sym_RBRACE,
  [280171] = 2,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(13286), 1,
      aux_sym_preproc_include_token2,
  [280178] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13288), 1,
      anon_sym_DQUOTE,
  [280185] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11334), 1,
      anon_sym_SEMI,
  [280192] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13290), 1,
      aux_sym_preproc_if_token2,
  [280199] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13292), 1,
      aux_sym_preproc_if_token2,
  [280206] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13294), 1,
      anon_sym_RPAREN,
  [280213] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13296), 1,
      anon_sym_SEMI,
  [280220] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12986), 1,
      anon_sym_RBRACE,
  [280227] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13298), 1,
      anon_sym_RBRACE,
  [280234] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13300), 1,
      anon_sym_RBRACK,
  [280241] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13302), 1,
      sym_identifier,
  [280248] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13304), 1,
      sym_identifier,
  [280255] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13306), 1,
      sym_raw_string_delimiter,
  [280262] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13308), 1,
      anon_sym_COLON,
  [280269] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13310), 1,
      anon_sym_RPAREN,
  [280276] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13312), 1,
      sym_identifier,
  [280283] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13314), 1,
      aux_sym_preproc_if_token2,
  [280290] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13316), 1,
      anon_sym_SEMI,
  [280297] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13318), 1,
      aux_sym_preproc_if_token2,
  [280304] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13320), 1,
      anon_sym_SEMI,
  [280311] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13322), 1,
      sym_identifier,
  [280318] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13324), 1,
      aux_sym_preproc_if_token2,
  [280325] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13224), 1,
      anon_sym_GT,
  [280332] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13326), 1,
      anon_sym_RBRACE,
  [280339] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13328), 1,
      anon_sym_SEMI,
  [280346] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13330), 1,
      anon_sym_SEMI,
  [280353] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13042), 1,
      anon_sym_RBRACE,
  [280360] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13332), 1,
      anon_sym_STAR,
  [280367] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13334), 1,
      aux_sym_preproc_if_token2,
  [280374] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13336), 1,
      aux_sym_preproc_if_token2,
  [280381] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4689), 1,
      anon_sym_SEMI,
  [280388] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13338), 1,
      anon_sym_SEMI,
  [280395] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13340), 1,
      anon_sym_SEMI,
  [280402] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13342), 1,
      anon_sym_SEMI,
  [280409] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13344), 1,
      anon_sym_DQUOTE,
  [280416] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13346), 1,
      anon_sym_RPAREN,
  [280423] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13348), 1,
      aux_sym_preproc_if_token2,
  [280430] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13350), 1,
      anon_sym_SEMI,
  [280437] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9033), 1,
      anon_sym_RPAREN,
  [280444] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13352), 1,
      anon_sym_RPAREN,
  [280451] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13354), 1,
      anon_sym_SEMI,
  [280458] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13356), 1,
      sym_identifier,
  [280465] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13358), 1,
      anon_sym_DQUOTE,
  [280472] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13360), 1,
      anon_sym_DQUOTE,
  [280479] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13362), 1,
      anon_sym_DQUOTE,
  [280486] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13364), 1,
      aux_sym_preproc_if_token2,
  [280493] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13366), 1,
      sym_auto,
  [280500] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13368), 1,
      anon_sym_RPAREN,
  [280507] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13370), 1,
      anon_sym_SEMI,
  [280514] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13372), 1,
      anon_sym_LPAREN2,
  [280521] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13374), 1,
      anon_sym_SEMI,
  [280528] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13376), 1,
      anon_sym_SEMI,
  [280535] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8818), 1,
      anon_sym_COLON,
  [280542] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13378), 1,
      sym_identifier,
  [280549] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13380), 1,
      anon_sym_RPAREN,
  [280556] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12974), 1,
      anon_sym_COMMA,
  [280563] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7408), 1,
      sym_identifier,
  [280570] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13382), 1,
      anon_sym_RPAREN,
  [280577] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13384), 1,
      anon_sym_RPAREN,
  [280584] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13386), 1,
      sym_identifier,
  [280591] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13388), 1,
      anon_sym_DQUOTE,
  [280598] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13390), 1,
      anon_sym_COLON,
  [280605] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13392), 1,
      anon_sym_SEMI,
  [280612] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13394), 1,
      anon_sym_SEMI,
  [280619] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8838), 1,
      anon_sym_SEMI,
  [280626] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13396), 1,
      sym_identifier,
  [280633] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13398), 1,
      anon_sym_RPAREN,
  [280640] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11708), 1,
      anon_sym_COLON,
  [280647] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13400), 1,
      aux_sym_preproc_if_token2,
  [280654] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13402), 1,
      anon_sym_SEMI,
  [280661] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13404), 1,
      anon_sym_STAR,
  [280668] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13406), 1,
      anon_sym_RPAREN,
  [280675] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13408), 1,
      sym_identifier,
  [280682] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13224), 1,
      anon_sym_GT_EQ,
  [280689] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13410), 1,
      anon_sym_SEMI,
  [280696] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13412), 1,
      anon_sym_SEMI,
  [280703] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8840), 1,
      anon_sym_SEMI,
  [280710] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13414), 1,
      aux_sym_preproc_if_token2,
  [280717] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13416), 1,
      sym_identifier,
  [280724] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13418), 1,
      anon_sym_SEMI,
  [280731] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6864), 1,
      anon_sym_SEMI,
  [280738] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6894), 1,
      anon_sym_SEMI,
  [280745] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13420), 1,
      anon_sym_DQUOTE,
  [280752] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13422), 1,
      anon_sym_RPAREN,
  [280759] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13224), 1,
      anon_sym_LT_EQ,
  [280766] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13424), 1,
      anon_sym_RPAREN,
  [280773] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13426), 1,
      sym_raw_string_delimiter,
  [280780] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13428), 1,
      anon_sym_RPAREN,
  [280787] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13430), 1,
      anon_sym_SEMI,
  [280794] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8802), 1,
      anon_sym_COLON,
  [280801] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13432), 1,
      anon_sym_COLON,
  [280808] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12516), 1,
      anon_sym_SEMI,
  [280815] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13434), 1,
      aux_sym_preproc_if_token2,
  [280822] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13436), 1,
      aux_sym_preproc_if_token2,
  [280829] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13438), 1,
      anon_sym_RPAREN,
  [280836] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13440), 1,
      anon_sym_SEMI,
  [280843] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13442), 1,
      anon_sym_DQUOTE,
  [280850] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13444), 1,
      anon_sym_STAR,
  [280857] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13446), 1,
      anon_sym_RPAREN,
  [280864] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13448), 1,
      anon_sym_DQUOTE,
  [280871] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13450), 1,
      anon_sym_DQUOTE,
  [280878] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13452), 1,
      anon_sym_RPAREN,
  [280885] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13454), 1,
      anon_sym_LBRACE,
  [280892] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13456), 1,
      anon_sym_RPAREN,
  [280899] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13458), 1,
      sym_identifier,
  [280906] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13460), 1,
      anon_sym_LPAREN2,
  [280913] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13462), 1,
      anon_sym_SEMI,
  [280920] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13464), 1,
      anon_sym_RPAREN,
  [280927] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13466), 1,
      anon_sym_SEMI,
  [280934] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13468), 1,
      sym_identifier,
  [280941] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13470), 1,
      sym_identifier,
  [280948] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13472), 1,
      anon_sym_RPAREN,
  [280955] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13474), 1,
      anon_sym_RBRACE,
  [280962] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13476), 1,
      sym_identifier,
  [280969] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8842), 1,
      anon_sym_SEMI,
  [280976] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13478), 1,
      anon_sym_STAR,
  [280983] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13480), 1,
      aux_sym_preproc_if_token2,
  [280990] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12247), 1,
      anon_sym_COLON_COLON,
  [280997] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13482), 1,
      anon_sym_LPAREN2,
  [281004] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10908), 1,
      anon_sym_RBRACE,
  [281011] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13484), 1,
      anon_sym_LPAREN2,
  [281018] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13486), 1,
      anon_sym_SEMI,
  [281025] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4533), 1,
      anon_sym_DOT_DOT_DOT,
  [281032] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13488), 1,
      anon_sym_SEMI,
  [281039] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4438), 1,
      anon_sym_DOT_DOT_DOT,
  [281046] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4448), 1,
      anon_sym_DOT_DOT_DOT,
  [281053] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4467), 1,
      anon_sym_DOT_DOT_DOT,
  [281060] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13490), 1,
      anon_sym_SEMI,
  [281067] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13492), 1,
      aux_sym_preproc_if_token2,
  [281074] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13494), 1,
      aux_sym_preproc_if_token2,
  [281081] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13496), 1,
      anon_sym_LPAREN2,
  [281088] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13498), 1,
      anon_sym_SEMI,
  [281095] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13500), 1,
      aux_sym_preproc_if_token2,
  [281102] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13502), 1,
      aux_sym_preproc_if_token2,
  [281109] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13504), 1,
      anon_sym_SEMI,
  [281116] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6798), 1,
      anon_sym_SEMI,
  [281123] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13506), 1,
      aux_sym_preproc_if_token2,
  [281130] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13508), 1,
      sym_identifier,
  [281137] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13510), 1,
      anon_sym_LBRACE,
  [281144] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13512), 1,
      anon_sym_RPAREN,
  [281151] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13514), 1,
      anon_sym_STAR,
  [281158] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13516), 1,
      aux_sym_preproc_if_token2,
  [281165] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13518), 1,
      anon_sym_SEMI,
  [281172] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13520), 1,
      anon_sym_RPAREN,
  [281179] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13522), 1,
      anon_sym_LPAREN2,
  [281186] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13524), 1,
      anon_sym_RPAREN,
  [281193] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13526), 1,
      anon_sym_STAR,
  [281200] = 2,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(13528), 1,
      aux_sym_preproc_include_token2,
  [281207] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13530), 1,
      anon_sym_COLON,
  [281214] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13532), 1,
      anon_sym_SEMI,
  [281221] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13534), 1,
      anon_sym_SEMI,
  [281228] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13536), 1,
      aux_sym_preproc_if_token2,
  [281235] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13538), 1,
      sym_identifier,
  [281242] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6804), 1,
      anon_sym_SEMI,
  [281249] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13540), 1,
      anon_sym_SEMI,
  [281256] = 2,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(13542), 1,
      aux_sym_preproc_include_token2,
  [281263] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13544), 1,
      sym_identifier,
  [281270] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13546), 1,
      anon_sym_SEMI,
  [281277] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13548), 1,
      anon_sym_RPAREN,
  [281284] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13550), 1,
      sym_raw_string_delimiter,
  [281291] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11369), 1,
      anon_sym_COMMA,
  [281298] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13552), 1,
      sym_identifier,
  [281305] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4445), 1,
      anon_sym_DOT_DOT_DOT,
  [281312] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13554), 1,
      anon_sym_SEMI,
  [281319] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13556), 1,
      anon_sym_RPAREN,
  [281326] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13558), 1,
      anon_sym_LPAREN2,
  [281333] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13560), 1,
      anon_sym_RPAREN,
  [281340] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4453), 1,
      anon_sym_DOT_DOT_DOT,
  [281347] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13562), 1,
      anon_sym_STAR,
  [281354] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13564), 1,
      anon_sym_RPAREN,
  [281361] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13566), 1,
      aux_sym_preproc_if_token2,
  [281368] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13568), 1,
      anon_sym_RPAREN,
  [281375] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13570), 1,
      aux_sym_preproc_if_token2,
  [281382] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13572), 1,
      aux_sym_preproc_if_token2,
  [281389] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13574), 1,
      anon_sym_SEMI,
  [281396] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4459), 1,
      anon_sym_DOT_DOT_DOT,
  [281403] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13576), 1,
      anon_sym_DQUOTE,
  [281410] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4488), 1,
      anon_sym_DOT_DOT_DOT,
  [281417] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13578), 1,
      anon_sym_DQUOTE,
  [281424] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13580), 1,
      sym_identifier,
  [281431] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13224), 1,
      anon_sym_LT,
  [281438] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12976), 1,
      anon_sym_RBRACE,
  [281445] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13582), 1,
      anon_sym_LPAREN2,
  [281452] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11799), 1,
      anon_sym_SEMI,
  [281459] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8844), 1,
      anon_sym_SEMI,
  [281466] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4456), 1,
      anon_sym_DOT_DOT_DOT,
  [281473] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13584), 1,
      anon_sym_RBRACK,
  [281480] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13224), 1,
      anon_sym_LT_LT,
  [281487] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13586), 1,
      sym_identifier,
  [281494] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13588), 1,
      anon_sym_COLON,
  [281501] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13590), 1,
      aux_sym_preproc_if_token2,
  [281508] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13592), 1,
      sym_identifier,
  [281515] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13594), 1,
      anon_sym_COLON,
  [281522] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4462), 1,
      anon_sym_DOT_DOT_DOT,
  [281529] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13596), 1,
      anon_sym_RPAREN,
  [281536] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8846), 1,
      anon_sym_SEMI,
  [281543] = 2,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(13598), 1,
      aux_sym_preproc_include_token2,
  [281550] = 2,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(12366), 1,
      aux_sym_preproc_include_token2,
  [281557] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13600), 1,
      anon_sym_SEMI,
  [281564] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13602), 1,
      sym_auto,
  [281571] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4482), 1,
      anon_sym_DOT_DOT_DOT,
  [281578] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13604), 1,
      anon_sym_RPAREN,
  [281585] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13606), 1,
      anon_sym_RPAREN,
  [281592] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13608), 1,
      sym_identifier,
  [281599] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13610), 1,
      anon_sym_RPAREN,
  [281606] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13612), 1,
      anon_sym_RPAREN,
  [281613] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13614), 1,
      anon_sym_RPAREN,
  [281620] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10947), 1,
      anon_sym_RBRACE,
  [281627] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13616), 1,
      sym_identifier,
  [281634] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13618), 1,
      anon_sym_RPAREN,
  [281641] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13620), 1,
      sym_raw_string_delimiter,
  [281648] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13622), 1,
      anon_sym_SEMI,
  [281655] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13624), 1,
      sym_identifier,
  [281662] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13626), 1,
      anon_sym_SEMI,
  [281669] = 2,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(13628), 1,
      aux_sym_preproc_include_token2,
  [281676] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13630), 1,
      anon_sym_SEMI,
  [281683] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8852), 1,
      anon_sym_COLON,
  [281690] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13632), 1,
      sym_identifier,
  [281697] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13634), 1,
      anon_sym_SEMI,
  [281704] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13636), 1,
      anon_sym_STAR,
  [281711] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13638), 1,
      anon_sym_LPAREN2,
  [281718] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8532), 1,
      anon_sym_SEMI,
  [281725] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13224), 1,
      anon_sym_PERCENT,
  [281732] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13640), 1,
      aux_sym_preproc_if_token2,
  [281739] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4485), 1,
      anon_sym_DOT_DOT_DOT,
  [281746] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13642), 1,
      anon_sym_RPAREN,
  [281753] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8762), 1,
      anon_sym_SEMI,
  [281760] = 2,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(13644), 1,
      aux_sym_preproc_include_token2,
  [281767] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13646), 1,
      aux_sym_preproc_if_token2,
  [281774] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13648), 1,
      anon_sym_RPAREN,
  [281781] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13650), 1,
      anon_sym_RPAREN,
  [281788] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13652), 1,
      anon_sym_SEMI,
  [281795] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13654), 1,
      anon_sym_LPAREN2,
  [281802] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13656), 1,
      anon_sym_DQUOTE,
  [281809] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12709), 1,
      anon_sym_RPAREN,
  [281816] = 2,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(13658), 1,
      aux_sym_preproc_include_token2,
  [281823] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13660), 1,
      anon_sym_DQUOTE,
  [281830] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13662), 1,
      aux_sym_preproc_if_token2,
  [281837] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13664), 1,
      anon_sym_RPAREN,
  [281844] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13666), 1,
      anon_sym_RPAREN,
  [281851] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11353), 1,
      anon_sym_SEMI,
  [281858] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13668), 1,
      anon_sym_RPAREN,
  [281865] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8930), 1,
      anon_sym_RPAREN,
  [281872] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13670), 1,
      anon_sym_RPAREN,
  [281879] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13672), 1,
      anon_sym_SEMI,
  [281886] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8752), 1,
      anon_sym_RBRACE,
  [281893] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13674), 1,
      anon_sym_RPAREN,
  [281900] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13676), 1,
      anon_sym_DQUOTE,
  [281907] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13678), 1,
      anon_sym_RPAREN,
  [281914] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13680), 1,
      anon_sym_RPAREN,
  [281921] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13682), 1,
      anon_sym_RPAREN,
  [281928] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7770), 1,
      sym_identifier,
  [281935] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13684), 1,
      anon_sym_SEMI,
  [281942] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13686), 1,
      anon_sym_RPAREN,
  [281949] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13688), 1,
      sym_raw_string_delimiter,
  [281956] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13690), 1,
      anon_sym_RPAREN,
  [281963] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13692), 1,
      anon_sym_RPAREN,
  [281970] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13694), 1,
      anon_sym_SEMI,
  [281977] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13696), 1,
      anon_sym_SEMI,
  [281984] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6998), 1,
      anon_sym_RPAREN,
  [281991] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10939), 1,
      anon_sym_RBRACE,
  [281998] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11357), 1,
      anon_sym_SEMI,
  [282005] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13698), 1,
      anon_sym_LPAREN2,
  [282012] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13700), 1,
      anon_sym_SEMI,
  [282019] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13702), 1,
      sym_identifier,
  [282026] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13704), 1,
      anon_sym_SEMI,
  [282033] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13706), 1,
      anon_sym_RPAREN,
  [282040] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13708), 1,
      anon_sym_RPAREN,
  [282047] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13710), 1,
      anon_sym_SEMI,
  [282054] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13712), 1,
      sym_raw_string_delimiter,
  [282061] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8866), 1,
      anon_sym_COLON,
  [282068] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9047), 1,
      anon_sym_RPAREN,
  [282075] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10310), 1,
      sym_identifier,
  [282082] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13714), 1,
      anon_sym_RPAREN,
  [282089] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13716), 1,
      anon_sym_SEMI,
  [282096] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13718), 1,
      anon_sym_LPAREN2,
  [282103] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13720), 1,
      anon_sym_STAR,
  [282110] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13722), 1,
      anon_sym_LPAREN2,
  [282117] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13724), 1,
      anon_sym_RPAREN,
  [282124] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13726), 1,
      anon_sym_RPAREN,
  [282131] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13728), 1,
      sym_raw_string_delimiter,
  [282138] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13224), 1,
      anon_sym_GT_GT,
  [282145] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13730), 1,
      anon_sym_DQUOTE,
  [282152] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13732), 1,
      anon_sym_RPAREN,
  [282159] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13734), 1,
      anon_sym_EQ,
  [282166] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13736), 1,
      anon_sym_LPAREN2,
  [282173] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13738), 1,
      anon_sym_RPAREN,
  [282180] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13740), 1,
      sym_raw_string_delimiter,
  [282187] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13742), 1,
      sym_identifier,
  [282194] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13744), 1,
      anon_sym_SEMI,
  [282201] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13746), 1,
      anon_sym_RPAREN,
  [282208] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13748), 1,
      sym_raw_string_delimiter,
  [282215] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13750), 1,
      sym_identifier,
  [282222] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13752), 1,
      anon_sym_RPAREN,
  [282229] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13754), 1,
      anon_sym_RPAREN,
  [282236] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13756), 1,
      sym_raw_string_delimiter,
  [282243] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13758), 1,
      anon_sym_RPAREN,
  [282250] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13760), 1,
      sym_raw_string_delimiter,
  [282257] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13762), 1,
      anon_sym_RPAREN,
  [282264] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13764), 1,
      sym_raw_string_delimiter,
  [282271] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13766), 1,
      anon_sym_RPAREN,
  [282278] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13768), 1,
      sym_raw_string_delimiter,
  [282285] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13770), 1,
      anon_sym_RPAREN,
  [282292] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13772), 1,
      sym_raw_string_delimiter,
  [282299] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13774), 1,
      anon_sym_RPAREN,
  [282306] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13776), 1,
      sym_raw_string_delimiter,
  [282313] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13778), 1,
      anon_sym_COLON,
  [282320] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13780), 1,
      anon_sym_LPAREN2,
  [282327] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6347), 1,
      sym_identifier,
  [282334] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13782), 1,
      anon_sym_LPAREN2,
  [282341] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13784), 1,
      anon_sym_RPAREN,
  [282348] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13786), 1,
      anon_sym_LPAREN2,
  [282355] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13788), 1,
      sym_auto,
  [282362] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13790), 1,
      anon_sym_LPAREN2,
  [282369] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13792), 1,
      aux_sym_preproc_if_token2,
  [282376] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13224), 1,
      anon_sym_EQ,
  [282383] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13794), 1,
      anon_sym_LPAREN2,
  [282390] = 2,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(13796), 1,
      aux_sym_preproc_include_token2,
  [282397] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13798), 1,
      anon_sym_LPAREN2,
  [282404] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8854), 1,
      anon_sym_SEMI,
  [282411] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13800), 1,
      anon_sym_RPAREN,
  [282418] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13802), 1,
      anon_sym_RPAREN,
  [282425] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13804), 1,
      anon_sym_RPAREN,
  [282432] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13806), 1,
      anon_sym_SEMI,
  [282439] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13808), 1,
      anon_sym_RPAREN,
  [282446] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12002), 1,
      anon_sym_SEMI,
  [282453] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13810), 1,
      anon_sym_RPAREN,
  [282460] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13812), 1,
      anon_sym_RPAREN,
  [282467] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11450), 1,
      anon_sym_EQ,
  [282474] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13086), 1,
      anon_sym_RBRACE,
  [282481] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13814), 1,
      aux_sym_preproc_if_token2,
  [282488] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13816), 1,
      anon_sym_RPAREN,
  [282495] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13818), 1,
      anon_sym_RPAREN,
  [282502] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8772), 1,
      anon_sym_RPAREN,
  [282509] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13820), 1,
      anon_sym_while,
  [282516] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9092), 1,
      anon_sym_RPAREN,
  [282523] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13822), 1,
      anon_sym_LPAREN2,
  [282530] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13824), 1,
      anon_sym_RPAREN,
  [282537] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13826), 1,
      anon_sym_SEMI,
  [282544] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13828), 1,
      anon_sym_RPAREN,
  [282551] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13830), 1,
      anon_sym_RPAREN,
  [282558] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9007), 1,
      anon_sym_RPAREN,
  [282565] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13832), 1,
      anon_sym_EQ,
  [282572] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13834), 1,
      sym_raw_string_content,
  [282579] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13836), 1,
      anon_sym_SEMI,
  [282586] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8687), 1,
      anon_sym_RBRACE,
  [282593] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13838), 1,
      anon_sym_RPAREN,
  [282600] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13840), 1,
      anon_sym_STAR,
  [282607] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13842), 1,
      aux_sym_preproc_if_token2,
  [282614] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13844), 1,
      aux_sym_preproc_if_token2,
  [282621] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10918), 1,
      anon_sym_RBRACE,
  [282628] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13846), 1,
      anon_sym_RPAREN,
  [282635] = 2,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(10236), 1,
      aux_sym_preproc_include_token2,
  [282642] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13848), 1,
      sym_identifier,
  [282649] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13850), 1,
      anon_sym_RPAREN,
  [282656] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13224), 1,
      anon_sym_COMMA,
  [282663] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13852), 1,
      anon_sym_SEMI,
  [282670] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13854), 1,
      sym_identifier,
  [282677] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13856), 1,
      anon_sym_RPAREN,
  [282684] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13858), 1,
      anon_sym_COMMA,
  [282691] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13860), 1,
      sym_identifier,
  [282698] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9037), 1,
      anon_sym_RPAREN,
  [282705] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11290), 1,
      anon_sym_SEMI,
  [282712] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13862), 1,
      anon_sym_LPAREN2,
  [282719] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8904), 1,
      anon_sym_COLON,
  [282726] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13864), 1,
      anon_sym_EQ,
  [282733] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13866), 1,
      anon_sym_SEMI,
  [282740] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13088), 1,
      anon_sym_RBRACE,
  [282747] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13868), 1,
      anon_sym_RPAREN,
  [282754] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13870), 1,
      anon_sym_RPAREN,
  [282761] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13872), 1,
      anon_sym_DQUOTE,
  [282768] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8856), 1,
      anon_sym_SEMI,
  [282775] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13874), 1,
      anon_sym_RPAREN,
  [282782] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13876), 1,
      anon_sym_SEMI,
  [282789] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8760), 1,
      anon_sym_RPAREN,
  [282796] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13224), 1,
      anon_sym_STAR_EQ,
  [282803] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13878), 1,
      anon_sym_RPAREN,
  [282810] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13880), 1,
      anon_sym_LPAREN2,
  [282817] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13882), 1,
      anon_sym_RPAREN,
  [282824] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13884), 1,
      anon_sym_LPAREN2,
  [282831] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13886), 1,
      anon_sym_SEMI,
  [282838] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13888), 1,
      anon_sym_COLON,
  [282845] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13890), 1,
      anon_sym_STAR,
  [282852] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12091), 1,
      anon_sym_SEMI,
  [282859] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13892), 1,
      anon_sym_SEMI,
  [282866] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10914), 1,
      anon_sym_RBRACE,
  [282873] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8906), 1,
      anon_sym_RPAREN,
  [282880] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8774), 1,
      anon_sym_RPAREN,
  [282887] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13894), 1,
      sym_identifier,
  [282894] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13896), 1,
      anon_sym_LPAREN2,
  [282901] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13898), 1,
      anon_sym_SEMI,
  [282908] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13900), 1,
      aux_sym_preproc_if_token2,
  [282915] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13902), 1,
      anon_sym_SEMI,
  [282922] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13904), 1,
      anon_sym_DQUOTE,
  [282929] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13906), 1,
      sym_identifier,
  [282936] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13908), 1,
      anon_sym_SEMI,
  [282943] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4609), 1,
      anon_sym_SEMI,
  [282950] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13910), 1,
      anon_sym_SEMI,
  [282957] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13224), 1,
      anon_sym_CARET,
  [282964] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13912), 1,
      sym_auto,
  [282971] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8996), 1,
      anon_sym_RPAREN,
  [282978] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8862), 1,
      anon_sym_COLON,
  [282985] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13914), 1,
      anon_sym_RPAREN,
  [282992] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12093), 1,
      anon_sym_SEMI,
  [282999] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13916), 1,
      anon_sym_SEMI,
  [283006] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13918), 1,
      anon_sym_SEMI,
  [283013] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13920), 1,
      anon_sym_LPAREN2,
  [283020] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8908), 1,
      anon_sym_RPAREN,
  [283027] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13922), 1,
      anon_sym_STAR,
  [283034] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13924), 1,
      aux_sym_preproc_if_token2,
  [283041] = 2,
    ACTIONS(5449), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(9945), 1,
      sym_comment,
  [283048] = 2,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(13926), 1,
      aux_sym_preproc_include_token2,
  [283055] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13928), 1,
      sym_identifier,
  [283062] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13930), 1,
      anon_sym_SEMI,
  [283069] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7585), 1,
      sym_identifier,
  [283076] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13224), 1,
      anon_sym_SLASH_EQ,
  [283083] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13932), 1,
      anon_sym_DOT_DOT_DOT,
  [283090] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13224), 1,
      anon_sym_PERCENT_EQ,
  [283097] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13224), 1,
      anon_sym_AMP,
  [283104] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13935), 1,
      sym_identifier,
  [283111] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13937), 1,
      anon_sym_SEMI,
  [283118] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13939), 1,
      aux_sym_preproc_if_token2,
  [283125] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13094), 1,
      anon_sym_RBRACE,
  [283132] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11307), 1,
      anon_sym_SEMI,
  [283139] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13941), 1,
      anon_sym_SEMI,
  [283146] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11278), 1,
      anon_sym_SEMI,
  [283153] = 2,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(10095), 1,
      aux_sym_preproc_include_token2,
  [283160] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13943), 1,
      sym_raw_string_content,
  [283167] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13224), 1,
      anon_sym_DASH,
  [283174] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13945), 1,
      anon_sym_RPAREN,
  [283181] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13947), 1,
      anon_sym_DQUOTE,
  [283188] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13224), 1,
      anon_sym_PLUS_EQ,
  [283195] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13224), 1,
      anon_sym_DASH_EQ,
  [283202] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8910), 1,
      anon_sym_SEMI,
  [283209] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13949), 1,
      sym_identifier,
  [283216] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13951), 1,
      sym_identifier,
  [283223] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13953), 1,
      sym_identifier,
  [283230] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13955), 1,
      anon_sym_SEMI,
  [283237] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13957), 1,
      anon_sym_SEMI,
  [283244] = 2,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(10141), 1,
      aux_sym_preproc_include_token2,
  [283251] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13959), 1,
      sym_identifier,
  [283258] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13961), 1,
      anon_sym_RPAREN,
  [283265] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13963), 1,
      anon_sym_COLON,
  [283272] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13965), 1,
      sym_identifier,
  [283279] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13967), 1,
      anon_sym_STAR,
  [283286] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13969), 1,
      anon_sym_LPAREN2,
  [283293] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8836), 1,
      anon_sym_RPAREN,
  [283300] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13971), 1,
      anon_sym_DQUOTE,
  [283307] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13224), 1,
      anon_sym_LT_LT_EQ,
  [283314] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13224), 1,
      anon_sym_EQ_EQ,
  [283321] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13973), 1,
      anon_sym_RPAREN,
  [283328] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13224), 1,
      anon_sym_BANG_EQ,
  [283335] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13224), 1,
      anon_sym_GT_GT_EQ,
  [283342] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13975), 1,
      sym_identifier,
  [283349] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13977), 1,
      anon_sym_SEMI,
  [283356] = 2,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(13979), 1,
      aux_sym_preproc_include_token2,
  [283363] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9045), 1,
      anon_sym_RPAREN,
  [283370] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8566), 1,
      anon_sym_RBRACE,
  [283377] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13981), 1,
      anon_sym_SEMI,
  [283384] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13983), 1,
      anon_sym_RPAREN,
  [283391] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13224), 1,
      anon_sym_PLUS,
  [283398] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13985), 1,
      anon_sym_SEMI,
  [283405] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13987), 1,
      aux_sym_preproc_if_token2,
  [283412] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13989), 1,
      aux_sym_preproc_if_token2,
  [283419] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13991), 1,
      sym_auto,
  [283426] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13993), 1,
      anon_sym_SEMI,
  [283433] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13995), 1,
      anon_sym_RPAREN,
  [283440] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6886), 1,
      anon_sym_SEMI,
  [283447] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13997), 1,
      anon_sym_SEMI,
  [283454] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13999), 1,
      anon_sym_RPAREN,
  [283461] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14001), 1,
      anon_sym_SEMI,
  [283468] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14003), 1,
      anon_sym_STAR,
  [283475] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14005), 1,
      anon_sym_SEMI,
  [283482] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14007), 1,
      aux_sym_preproc_if_token2,
  [283489] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14009), 1,
      anon_sym_RPAREN,
  [283496] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9043), 1,
      anon_sym_RPAREN,
  [283503] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14011), 1,
      sym_identifier,
  [283510] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14013), 1,
      anon_sym_LPAREN2,
  [283517] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14015), 1,
      anon_sym_RPAREN,
  [283524] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14017), 1,
      ts_builtin_sym_end,
  [283531] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14019), 1,
      aux_sym_preproc_if_token2,
  [283538] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14021), 1,
      sym_auto,
  [283545] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13080), 1,
      anon_sym_RBRACE,
  [283552] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14023), 1,
      anon_sym_SEMI,
  [283559] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14025), 1,
      anon_sym_RPAREN,
  [283566] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14027), 1,
      anon_sym_DQUOTE,
  [283573] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14029), 1,
      anon_sym_SEMI,
  [283580] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14031), 1,
      anon_sym_RPAREN,
  [283587] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14033), 1,
      anon_sym_DOT_DOT_DOT,
  [283594] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13224), 1,
      anon_sym_AMP_EQ,
  [283601] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13224), 1,
      anon_sym_CARET_EQ,
  [283608] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14035), 1,
      anon_sym_RPAREN,
  [283615] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14037), 1,
      sym_identifier,
  [283622] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14039), 1,
      sym_auto,
  [283629] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14041), 1,
      anon_sym_RPAREN,
  [283636] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14043), 1,
      anon_sym_SEMI,
  [283643] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14045), 1,
      sym_raw_string_content,
  [283650] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14047), 1,
      anon_sym_LPAREN2,
  [283657] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14049), 1,
      anon_sym_SEMI,
  [283664] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14051), 1,
      anon_sym_RPAREN,
  [283671] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8830), 1,
      anon_sym_COLON,
  [283678] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13224), 1,
      anon_sym_PIPE_EQ,
  [283685] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13224), 1,
      anon_sym_STAR,
  [283692] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14053), 1,
      anon_sym_STAR,
  [283699] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14055), 1,
      anon_sym_SEMI,
  [283706] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14057), 1,
      anon_sym_COLON,
  [283713] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14059), 1,
      anon_sym_SEMI,
  [283720] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14061), 1,
      anon_sym_SEMI,
  [283727] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14063), 1,
      anon_sym_LPAREN2,
  [283734] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14065), 1,
      anon_sym_LPAREN2,
  [283741] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14067), 1,
      anon_sym_LPAREN2,
  [283748] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14069), 1,
      anon_sym_LPAREN2,
  [283755] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10935), 1,
      anon_sym_RBRACE,
  [283762] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14071), 1,
      anon_sym_LPAREN2,
  [283769] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14073), 1,
      anon_sym_RPAREN,
  [283776] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14075), 1,
      anon_sym_RPAREN,
  [283783] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13224), 1,
      anon_sym_or,
  [283790] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14077), 1,
      anon_sym_SEMI,
  [283797] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14079), 1,
      sym_identifier,
  [283804] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14081), 1,
      anon_sym_while,
  [283811] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14083), 1,
      anon_sym_RPAREN,
  [283818] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14085), 1,
      anon_sym_LPAREN2,
  [283825] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14087), 1,
      anon_sym_DQUOTE,
  [283832] = 2,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(14089), 1,
      aux_sym_preproc_include_token2,
  [283839] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8826), 1,
      anon_sym_SEMI,
  [283846] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14091), 1,
      anon_sym_EQ,
  [283853] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14093), 1,
      sym_raw_string_content,
  [283860] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14095), 1,
      anon_sym_STAR,
  [283867] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14097), 1,
      aux_sym_preproc_if_token2,
  [283874] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14099), 1,
      anon_sym_RPAREN,
  [283881] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14101), 1,
      anon_sym_COMMA,
  [283888] = 2,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(10240), 1,
      aux_sym_preproc_include_token2,
  [283895] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14103), 1,
      anon_sym_RPAREN,
  [283902] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14105), 1,
      sym_identifier,
  [283909] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14107), 1,
      anon_sym_RPAREN,
  [283916] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14109), 1,
      anon_sym_COLON,
  [283923] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14111), 1,
      aux_sym_preproc_if_token2,
  [283930] = 2,
    ACTIONS(5456), 1,
      aux_sym_preproc_include_token2,
    ACTIONS(9945), 1,
      sym_comment,
  [283937] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14113), 1,
      anon_sym_LPAREN2,
  [283944] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14115), 1,
      anon_sym_LPAREN2,
  [283951] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14117), 1,
      anon_sym_LPAREN2,
  [283958] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9049), 1,
      anon_sym_RPAREN,
  [283965] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14119), 1,
      anon_sym_LPAREN2,
  [283972] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14121), 1,
      anon_sym_SEMI,
  [283979] = 2,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(12845), 1,
      aux_sym_preproc_include_token2,
  [283986] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14123), 1,
      anon_sym_while,
  [283993] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14125), 1,
      anon_sym_RPAREN,
  [284000] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14127), 1,
      anon_sym_LPAREN2,
  [284007] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14129), 1,
      anon_sym_RPAREN,
  [284014] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13224), 1,
      anon_sym_and,
  [284021] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14131), 1,
      anon_sym_EQ,
  [284028] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14133), 1,
      sym_raw_string_content,
  [284035] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14135), 1,
      anon_sym_COMMA,
  [284042] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14137), 1,
      anon_sym_SEMI,
  [284049] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14139), 1,
      anon_sym_SEMI,
  [284056] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14141), 1,
      anon_sym_SLASH,
  [284063] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14143), 1,
      anon_sym_RPAREN,
  [284070] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14145), 1,
      anon_sym_COLON,
  [284077] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14147), 1,
      aux_sym_preproc_if_token2,
  [284084] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14149), 1,
      anon_sym_LPAREN2,
  [284091] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14151), 1,
      anon_sym_LPAREN2,
  [284098] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14153), 1,
      anon_sym_LPAREN2,
  [284105] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14155), 1,
      anon_sym_DQUOTE,
  [284112] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14157), 1,
      anon_sym_LPAREN2,
  [284119] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8914), 1,
      anon_sym_SEMI,
  [284126] = 2,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(14159), 1,
      aux_sym_preproc_include_token2,
  [284133] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14161), 1,
      anon_sym_while,
  [284140] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14163), 1,
      anon_sym_LPAREN2,
  [284147] = 2,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(14165), 1,
      aux_sym_preproc_include_token2,
  [284154] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14167), 1,
      anon_sym_RPAREN,
  [284161] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14169), 1,
      anon_sym_EQ,
  [284168] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14171), 1,
      sym_raw_string_content,
  [284175] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14173), 1,
      anon_sym_COMMA,
  [284182] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13120), 1,
      anon_sym_RBRACE,
  [284189] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14175), 1,
      sym_identifier,
  [284196] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14177), 1,
      anon_sym_RPAREN,
  [284203] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14179), 1,
      anon_sym_RPAREN,
  [284210] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14181), 1,
      anon_sym_COLON,
  [284217] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14183), 1,
      anon_sym_RPAREN,
  [284224] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14185), 1,
      anon_sym_LPAREN2,
  [284231] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14187), 1,
      anon_sym_LPAREN2,
  [284238] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14189), 1,
      anon_sym_LPAREN2,
  [284245] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14191), 1,
      anon_sym_RPAREN,
  [284252] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14193), 1,
      anon_sym_LPAREN2,
  [284259] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14195), 1,
      anon_sym_RPAREN,
  [284266] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14197), 1,
      anon_sym_RPAREN,
  [284273] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14199), 1,
      anon_sym_LPAREN2,
  [284280] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9122), 1,
      anon_sym_RPAREN,
  [284287] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14201), 1,
      aux_sym_preproc_if_token2,
  [284294] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14203), 1,
      anon_sym_EQ,
  [284301] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14205), 1,
      sym_raw_string_content,
  [284308] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14207), 1,
      anon_sym_COMMA,
  [284315] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14209), 1,
      anon_sym_STAR,
  [284322] = 2,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(14211), 1,
      aux_sym_preproc_include_token2,
  [284329] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14213), 1,
      aux_sym_preproc_if_token2,
  [284336] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14215), 1,
      anon_sym_RPAREN,
  [284343] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14217), 1,
      anon_sym_COLON,
  [284350] = 2,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(14219), 1,
      aux_sym_preproc_include_token2,
  [284357] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14221), 1,
      anon_sym_LPAREN2,
  [284364] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14223), 1,
      anon_sym_LPAREN2,
  [284371] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14225), 1,
      anon_sym_RPAREN,
  [284378] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14227), 1,
      anon_sym_LPAREN2,
  [284385] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14229), 1,
      aux_sym_preproc_if_token2,
  [284392] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10888), 1,
      anon_sym_RBRACE,
  [284399] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8956), 1,
      anon_sym_RPAREN,
  [284406] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8614), 1,
      anon_sym_RBRACE,
  [284413] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14231), 1,
      anon_sym_EQ,
  [284420] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14233), 1,
      sym_raw_string_content,
  [284427] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14235), 1,
      anon_sym_LPAREN2,
  [284434] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8534), 1,
      anon_sym_RBRACE,
  [284441] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14237), 1,
      sym_identifier,
  [284448] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14239), 1,
      anon_sym_RPAREN,
  [284455] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8812), 1,
      anon_sym_SEMI,
  [284462] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14241), 1,
      anon_sym_LPAREN2,
  [284469] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14243), 1,
      anon_sym_LPAREN2,
  [284476] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14245), 1,
      anon_sym_LPAREN2,
  [284483] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8868), 1,
      anon_sym_COLON,
  [284490] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14247), 1,
      sym_raw_string_content,
  [284497] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14249), 1,
      sym_identifier,
  [284504] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14251), 1,
      anon_sym_SEMI,
  [284511] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14253), 1,
      anon_sym_RPAREN,
  [284518] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14255), 1,
      anon_sym_SEMI,
  [284525] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14257), 1,
      anon_sym_LPAREN2,
  [284532] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14259), 1,
      anon_sym_LPAREN2,
  [284539] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14261), 1,
      anon_sym_LPAREN2,
  [284546] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14263), 1,
      sym_identifier,
  [284553] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14265), 1,
      sym_raw_string_content,
  [284560] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10882), 1,
      anon_sym_RBRACE,
  [284567] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14267), 1,
      anon_sym_RPAREN,
  [284574] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14269), 1,
      anon_sym_LPAREN2,
  [284581] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14271), 1,
      anon_sym_LPAREN2,
  [284588] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14273), 1,
      anon_sym_LPAREN2,
  [284595] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14275), 1,
      sym_raw_string_content,
  [284602] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14277), 1,
      anon_sym_RPAREN,
  [284609] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14279), 1,
      anon_sym_LPAREN2,
  [284616] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14281), 1,
      sym_raw_string_content,
  [284623] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14283), 1,
      anon_sym_RPAREN,
  [284630] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14285), 1,
      anon_sym_LPAREN2,
  [284637] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14287), 1,
      sym_raw_string_content,
  [284644] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14289), 1,
      anon_sym_RPAREN,
  [284651] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14291), 1,
      sym_raw_string_content,
  [284658] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14293), 1,
      anon_sym_RPAREN,
  [284665] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14295), 1,
      sym_raw_string_content,
  [284672] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14297), 1,
      anon_sym_RPAREN,
  [284679] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14299), 1,
      sym_raw_string_content,
  [284686] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14301), 1,
      anon_sym_RPAREN,
  [284693] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14303), 1,
      sym_raw_string_content,
  [284700] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14305), 1,
      anon_sym_RPAREN,
  [284707] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14307), 1,
      sym_raw_string_content,
  [284714] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14309), 1,
      anon_sym_RPAREN,
  [284721] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14311), 1,
      anon_sym_DQUOTE,
  [284728] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13224), 1,
      anon_sym_bitor,
  [284735] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14313), 1,
      anon_sym_LPAREN2,
  [284742] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14315), 1,
      anon_sym_LPAREN2,
  [284749] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14317), 1,
      sym_identifier,
  [284756] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14319), 1,
      anon_sym_DQUOTE,
  [284763] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13224), 1,
      anon_sym_xor,
  [284770] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14321), 1,
      anon_sym_SEMI,
  [284777] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14323), 1,
      sym_identifier,
  [284784] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14325), 1,
      anon_sym_RBRACE,
  [284791] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13224), 1,
      anon_sym_PIPE_PIPE,
  [284798] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14327), 1,
      anon_sym_RPAREN,
  [284805] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14329), 1,
      anon_sym_RPAREN,
  [284812] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14331), 1,
      anon_sym_RPAREN,
  [284819] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14333), 1,
      anon_sym_RPAREN,
  [284826] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14335), 1,
      anon_sym_RPAREN,
  [284833] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14337), 1,
      anon_sym_SEMI,
  [284840] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14339), 1,
      sym_identifier,
  [284847] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14341), 1,
      anon_sym_SEMI,
  [284854] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14343), 1,
      anon_sym_DQUOTE,
  [284861] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14345), 1,
      sym_identifier,
  [284868] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14347), 1,
      sym_raw_string_content,
  [284875] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14349), 1,
      anon_sym_DQUOTE,
  [284882] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14351), 1,
      anon_sym_RPAREN,
  [284889] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14353), 1,
      anon_sym_COMMA,
  [284896] = 2,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(14355), 1,
      aux_sym_preproc_include_token2,
  [284903] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14357), 1,
      sym_raw_string_delimiter,
  [284910] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14359), 1,
      anon_sym_RPAREN,
  [284917] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13224), 1,
      anon_sym_bitand,
  [284924] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11324), 1,
      anon_sym_SEMI,
  [284931] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14361), 1,
      anon_sym_LPAREN2,
  [284938] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14363), 1,
      anon_sym_LBRACE,
  [284945] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14365), 1,
      anon_sym_SEMI,
  [284952] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14367), 1,
      anon_sym_SEMI,
  [284959] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14369), 1,
      anon_sym_RPAREN,
  [284966] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14371), 1,
      anon_sym_SEMI,
  [284973] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14373), 1,
      anon_sym_RPAREN,
  [284980] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13224), 1,
      anon_sym_not_eq,
  [284987] = 2,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(14375), 1,
      aux_sym_preproc_include_token2,
  [284994] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13134), 1,
      anon_sym_RBRACE,
  [285001] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14377), 1,
      anon_sym_DQUOTE,
  [285008] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14379), 1,
      anon_sym_LPAREN2,
  [285015] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14381), 1,
      anon_sym_SEMI,
  [285022] = 2,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(12481), 1,
      aux_sym_preproc_include_token2,
  [285029] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8916), 1,
      anon_sym_RPAREN,
  [285036] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14383), 1,
      sym_identifier,
  [285043] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14385), 1,
      anon_sym_RPAREN,
  [285050] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14387), 1,
      anon_sym_SEMI,
  [285057] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14389), 1,
      sym_identifier,
  [285064] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14391), 1,
      anon_sym_SEMI,
  [285071] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14393), 1,
      aux_sym_preproc_if_token2,
  [285078] = 2,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(14395), 1,
      aux_sym_preproc_include_token2,
  [285085] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14397), 1,
      aux_sym_preproc_if_token2,
  [285092] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8918), 1,
      anon_sym_COLON,
  [285099] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14399), 1,
      sym_identifier,
  [285106] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6876), 1,
      anon_sym_SEMI,
  [285113] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8816), 1,
      anon_sym_RPAREN,
  [285120] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7164), 1,
      anon_sym_RPAREN,
  [285127] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14401), 1,
      anon_sym_RPAREN,
  [285134] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14403), 1,
      anon_sym_RPAREN,
  [285141] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14405), 1,
      anon_sym_RPAREN,
  [285148] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7154), 1,
      anon_sym_RPAREN,
  [285155] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5365), 1,
      anon_sym_COLON_COLON,
  [285162] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13224), 1,
      anon_sym_DOT_STAR,
  [285169] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8814), 1,
      anon_sym_SEMI,
  [285176] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14407), 1,
      anon_sym_SEMI,
  [285183] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13224), 1,
      anon_sym_DASH_GT_STAR,
  [285190] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9104), 1,
      anon_sym_RPAREN,
  [285197] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14409), 1,
      anon_sym_RBRACE,
  [285204] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9023), 1,
      anon_sym_RPAREN,
  [285211] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14411), 1,
      anon_sym_RPAREN,
  [285218] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10933), 1,
      anon_sym_RBRACE,
  [285225] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14413), 1,
      anon_sym_RPAREN,
  [285232] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14415), 1,
      anon_sym_RPAREN,
  [285239] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14417), 1,
      anon_sym_RPAREN,
  [285246] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14419), 1,
      aux_sym_preproc_if_token2,
  [285253] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14421), 1,
      anon_sym_RPAREN,
  [285260] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14423), 1,
      sym_identifier,
  [285267] = 2,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(14425), 1,
      aux_sym_preproc_include_token2,
  [285274] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14427), 1,
      anon_sym_RPAREN,
  [285281] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14429), 1,
      anon_sym_RPAREN,
  [285288] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14431), 1,
      aux_sym_preproc_if_token2,
  [285295] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8978), 1,
      anon_sym_RPAREN,
  [285302] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8920), 1,
      anon_sym_COLON,
  [285309] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14433), 1,
      anon_sym_SEMI,
  [285316] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14435), 1,
      anon_sym_SEMI,
  [285323] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14437), 1,
      anon_sym_LPAREN2,
  [285330] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14439), 1,
      anon_sym_LPAREN2,
  [285337] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14441), 1,
      sym_identifier,
  [285344] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8628), 1,
      anon_sym_RBRACE,
  [285351] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14443), 1,
      anon_sym_LPAREN2,
  [285358] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14445), 1,
      anon_sym_RPAREN,
  [285365] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14447), 1,
      anon_sym_SEMI,
  [285372] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14449), 1,
      sym_identifier,
  [285379] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14451), 1,
      sym_raw_string_content,
  [285386] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14453), 1,
      anon_sym_RPAREN,
  [285393] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14455), 1,
      anon_sym_RPAREN,
  [285400] = 2,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(14457), 1,
      aux_sym_preproc_include_token2,
  [285407] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14459), 1,
      anon_sym_DQUOTE,
  [285414] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14461), 1,
      anon_sym_LPAREN2,
  [285421] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14463), 1,
      anon_sym_LPAREN2,
  [285428] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14465), 1,
      sym_identifier,
  [285435] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14467), 1,
      aux_sym_preproc_if_token2,
  [285442] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14469), 1,
      sym_identifier,
  [285449] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14471), 1,
      sym_identifier,
  [285456] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14473), 1,
      sym_raw_string_content,
  [285463] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14475), 1,
      anon_sym_RPAREN,
  [285470] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6890), 1,
      anon_sym_SEMI,
  [285477] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12152), 1,
      anon_sym_SEMI,
  [285484] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14477), 1,
      anon_sym_LPAREN2,
  [285491] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14479), 1,
      sym_identifier,
  [285498] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14481), 1,
      anon_sym_RPAREN,
  [285505] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10916), 1,
      anon_sym_RBRACE,
  [285512] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14483), 1,
      sym_identifier,
  [285519] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14485), 1,
      sym_raw_string_content,
  [285526] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11951), 1,
      anon_sym_SEMI,
  [285533] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14487), 1,
      anon_sym_RPAREN,
  [285540] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14489), 1,
      anon_sym_LPAREN2,
  [285547] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14491), 1,
      sym_identifier,
  [285554] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14493), 1,
      anon_sym_while,
  [285561] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14495), 1,
      anon_sym_SEMI,
  [285568] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14497), 1,
      sym_identifier,
  [285575] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14499), 1,
      sym_raw_string_content,
  [285582] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14501), 1,
      anon_sym_SEMI,
  [285589] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14503), 1,
      anon_sym_LPAREN2,
  [285596] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14505), 1,
      sym_identifier,
  [285603] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13224), 1,
      anon_sym_AMP_AMP,
  [285610] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14507), 1,
      sym_identifier,
  [285617] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14509), 1,
      sym_raw_string_content,
  [285624] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8886), 1,
      anon_sym_COLON,
  [285631] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14511), 1,
      sym_identifier,
  [285638] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14513), 1,
      sym_raw_string_content,
  [285645] = 2,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(14515), 1,
      aux_sym_preproc_include_token2,
  [285652] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14517), 1,
      sym_raw_string_content,
  [285659] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8828), 1,
      anon_sym_SEMI,
  [285666] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14519), 1,
      sym_raw_string_content,
  [285673] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14521), 1,
      anon_sym_SEMI,
  [285680] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14523), 1,
      sym_raw_string_content,
  [285687] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14525), 1,
      sym_auto,
  [285694] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14527), 1,
      sym_raw_string_content,
  [285701] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14529), 1,
      anon_sym_RPAREN,
  [285708] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14531), 1,
      sym_raw_string_content,
  [285715] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14533), 1,
      anon_sym_DQUOTE,
  [285722] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14535), 1,
      sym_raw_string_content,
  [285729] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14537), 1,
      anon_sym_RPAREN,
  [285736] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14539), 1,
      sym_raw_string_content,
  [285743] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14541), 1,
      sym_identifier,
  [285750] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14543), 1,
      sym_raw_string_content,
  [285757] = 2,
    ACTIONS(9945), 1,
      sym_comment,
    ACTIONS(12566), 1,
      aux_sym_preproc_include_token2,
  [285764] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14545), 1,
      sym_raw_string_content,
  [285771] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14547), 1,
      anon_sym_LPAREN2,
  [285778] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14549), 1,
      anon_sym_LPAREN2,
  [285785] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14551), 1,
      sym_identifier,
  [285792] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14553), 1,
      anon_sym_LPAREN2,
  [285799] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14555), 1,
      anon_sym_LPAREN2,
  [285806] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14557), 1,
      aux_sym_preproc_if_token2,
  [285813] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14559), 1,
      anon_sym_LPAREN2,
  [285820] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14561), 1,
      anon_sym_LPAREN2,
  [285827] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14563), 1,
      anon_sym_SEMI,
  [285834] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14565), 1,
      anon_sym_LPAREN2,
  [285841] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14567), 1,
      anon_sym_LPAREN2,
  [285848] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14569), 1,
      anon_sym_SEMI,
  [285855] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14571), 1,
      anon_sym_LPAREN2,
  [285862] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14573), 1,
      anon_sym_LPAREN2,
  [285869] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14575), 1,
      anon_sym_SEMI,
  [285876] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14577), 1,
      anon_sym_LPAREN2,
  [285883] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14579), 1,
      anon_sym_LPAREN2,
  [285890] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14581), 1,
      anon_sym_LPAREN2,
  [285897] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14583), 1,
      anon_sym_LPAREN2,
  [285904] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14585), 1,
      anon_sym_LPAREN2,
  [285911] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14587), 1,
      anon_sym_LPAREN2,
  [285918] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14589), 1,
      anon_sym_LPAREN2,
  [285925] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14591), 1,
      anon_sym_LPAREN2,
  [285932] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14593), 1,
      anon_sym_LPAREN2,
  [285939] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14595), 1,
      anon_sym_LPAREN2,
  [285946] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14597), 1,
      anon_sym_LPAREN2,
  [285953] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4712), 1,
      anon_sym_SEMI,
  [285960] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14599), 1,
      anon_sym_SEMI,
  [285967] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8876), 1,
      anon_sym_COLON,
  [285974] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14601), 1,
      sym_this,
  [285981] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14603), 1,
      anon_sym_SEMI,
  [285988] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14605), 1,
      anon_sym_LPAREN2,
  [285995] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14607), 1,
      anon_sym_LPAREN2,
  [286002] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14609), 1,
      anon_sym_LPAREN2,
  [286009] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14611), 1,
      anon_sym_LPAREN2,
  [286016] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14613), 1,
      anon_sym_LPAREN2,
  [286023] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14615), 1,
      anon_sym_SEMI,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(2322)] = 0,
  [SMALL_STATE(2323)] = 89,
  [SMALL_STATE(2324)] = 160,
  [SMALL_STATE(2325)] = 231,
  [SMALL_STATE(2326)] = 316,
  [SMALL_STATE(2327)] = 395,
  [SMALL_STATE(2328)] = 478,
  [SMALL_STATE(2329)] = 563,
  [SMALL_STATE(2330)] = 642,
  [SMALL_STATE(2331)] = 713,
  [SMALL_STATE(2332)] = 784,
  [SMALL_STATE(2333)] = 855,
  [SMALL_STATE(2334)] = 926,
  [SMALL_STATE(2335)] = 997,
  [SMALL_STATE(2336)] = 1068,
  [SMALL_STATE(2337)] = 1141,
  [SMALL_STATE(2338)] = 1216,
  [SMALL_STATE(2339)] = 1287,
  [SMALL_STATE(2340)] = 1364,
  [SMALL_STATE(2341)] = 1443,
  [SMALL_STATE(2342)] = 1514,
  [SMALL_STATE(2343)] = 1599,
  [SMALL_STATE(2344)] = 1670,
  [SMALL_STATE(2345)] = 1745,
  [SMALL_STATE(2346)] = 1816,
  [SMALL_STATE(2347)] = 1887,
  [SMALL_STATE(2348)] = 1972,
  [SMALL_STATE(2349)] = 2043,
  [SMALL_STATE(2350)] = 2114,
  [SMALL_STATE(2351)] = 2185,
  [SMALL_STATE(2352)] = 2258,
  [SMALL_STATE(2353)] = 2343,
  [SMALL_STATE(2354)] = 2414,
  [SMALL_STATE(2355)] = 2485,
  [SMALL_STATE(2356)] = 2556,
  [SMALL_STATE(2357)] = 2633,
  [SMALL_STATE(2358)] = 2728,
  [SMALL_STATE(2359)] = 2811,
  [SMALL_STATE(2360)] = 2882,
  [SMALL_STATE(2361)] = 2953,
  [SMALL_STATE(2362)] = 3024,
  [SMALL_STATE(2363)] = 3095,
  [SMALL_STATE(2364)] = 3172,
  [SMALL_STATE(2365)] = 3267,
  [SMALL_STATE(2366)] = 3338,
  [SMALL_STATE(2367)] = 3417,
  [SMALL_STATE(2368)] = 3488,
  [SMALL_STATE(2369)] = 3558,
  [SMALL_STATE(2370)] = 3628,
  [SMALL_STATE(2371)] = 3698,
  [SMALL_STATE(2372)] = 3768,
  [SMALL_STATE(2373)] = 3838,
  [SMALL_STATE(2374)] = 3908,
  [SMALL_STATE(2375)] = 3978,
  [SMALL_STATE(2376)] = 4048,
  [SMALL_STATE(2377)] = 4118,
  [SMALL_STATE(2378)] = 4188,
  [SMALL_STATE(2379)] = 4258,
  [SMALL_STATE(2380)] = 4342,
  [SMALL_STATE(2381)] = 4412,
  [SMALL_STATE(2382)] = 4482,
  [SMALL_STATE(2383)] = 4552,
  [SMALL_STATE(2384)] = 4622,
  [SMALL_STATE(2385)] = 4692,
  [SMALL_STATE(2386)] = 4762,
  [SMALL_STATE(2387)] = 4832,
  [SMALL_STATE(2388)] = 4902,
  [SMALL_STATE(2389)] = 4972,
  [SMALL_STATE(2390)] = 5042,
  [SMALL_STATE(2391)] = 5112,
  [SMALL_STATE(2392)] = 5182,
  [SMALL_STATE(2393)] = 5252,
  [SMALL_STATE(2394)] = 5322,
  [SMALL_STATE(2395)] = 5392,
  [SMALL_STATE(2396)] = 5462,
  [SMALL_STATE(2397)] = 5536,
  [SMALL_STATE(2398)] = 5606,
  [SMALL_STATE(2399)] = 5676,
  [SMALL_STATE(2400)] = 5746,
  [SMALL_STATE(2401)] = 5816,
  [SMALL_STATE(2402)] = 5886,
  [SMALL_STATE(2403)] = 5956,
  [SMALL_STATE(2404)] = 6026,
  [SMALL_STATE(2405)] = 6096,
  [SMALL_STATE(2406)] = 6166,
  [SMALL_STATE(2407)] = 6236,
  [SMALL_STATE(2408)] = 6306,
  [SMALL_STATE(2409)] = 6376,
  [SMALL_STATE(2410)] = 6446,
  [SMALL_STATE(2411)] = 6516,
  [SMALL_STATE(2412)] = 6586,
  [SMALL_STATE(2413)] = 6656,
  [SMALL_STATE(2414)] = 6726,
  [SMALL_STATE(2415)] = 6796,
  [SMALL_STATE(2416)] = 6866,
  [SMALL_STATE(2417)] = 6936,
  [SMALL_STATE(2418)] = 7006,
  [SMALL_STATE(2419)] = 7076,
  [SMALL_STATE(2420)] = 7146,
  [SMALL_STATE(2421)] = 7216,
  [SMALL_STATE(2422)] = 7286,
  [SMALL_STATE(2423)] = 7366,
  [SMALL_STATE(2424)] = 7436,
  [SMALL_STATE(2425)] = 7514,
  [SMALL_STATE(2426)] = 7584,
  [SMALL_STATE(2427)] = 7654,
  [SMALL_STATE(2428)] = 7724,
  [SMALL_STATE(2429)] = 7794,
  [SMALL_STATE(2430)] = 7864,
  [SMALL_STATE(2431)] = 7934,
  [SMALL_STATE(2432)] = 8004,
  [SMALL_STATE(2433)] = 8088,
  [SMALL_STATE(2434)] = 8158,
  [SMALL_STATE(2435)] = 8228,
  [SMALL_STATE(2436)] = 8298,
  [SMALL_STATE(2437)] = 8368,
  [SMALL_STATE(2438)] = 8438,
  [SMALL_STATE(2439)] = 8508,
  [SMALL_STATE(2440)] = 8578,
  [SMALL_STATE(2441)] = 8648,
  [SMALL_STATE(2442)] = 8718,
  [SMALL_STATE(2443)] = 8788,
  [SMALL_STATE(2444)] = 8858,
  [SMALL_STATE(2445)] = 8928,
  [SMALL_STATE(2446)] = 8998,
  [SMALL_STATE(2447)] = 9068,
  [SMALL_STATE(2448)] = 9138,
  [SMALL_STATE(2449)] = 9208,
  [SMALL_STATE(2450)] = 9278,
  [SMALL_STATE(2451)] = 9348,
  [SMALL_STATE(2452)] = 9418,
  [SMALL_STATE(2453)] = 9488,
  [SMALL_STATE(2454)] = 9558,
  [SMALL_STATE(2455)] = 9628,
  [SMALL_STATE(2456)] = 9698,
  [SMALL_STATE(2457)] = 9768,
  [SMALL_STATE(2458)] = 9838,
  [SMALL_STATE(2459)] = 9908,
  [SMALL_STATE(2460)] = 9978,
  [SMALL_STATE(2461)] = 10048,
  [SMALL_STATE(2462)] = 10118,
  [SMALL_STATE(2463)] = 10188,
  [SMALL_STATE(2464)] = 10258,
  [SMALL_STATE(2465)] = 10328,
  [SMALL_STATE(2466)] = 10398,
  [SMALL_STATE(2467)] = 10468,
  [SMALL_STATE(2468)] = 10538,
  [SMALL_STATE(2469)] = 10608,
  [SMALL_STATE(2470)] = 10678,
  [SMALL_STATE(2471)] = 10748,
  [SMALL_STATE(2472)] = 10818,
  [SMALL_STATE(2473)] = 10888,
  [SMALL_STATE(2474)] = 10958,
  [SMALL_STATE(2475)] = 11046,
  [SMALL_STATE(2476)] = 11116,
  [SMALL_STATE(2477)] = 11186,
  [SMALL_STATE(2478)] = 11256,
  [SMALL_STATE(2479)] = 11326,
  [SMALL_STATE(2480)] = 11396,
  [SMALL_STATE(2481)] = 11466,
  [SMALL_STATE(2482)] = 11536,
  [SMALL_STATE(2483)] = 11606,
  [SMALL_STATE(2484)] = 11676,
  [SMALL_STATE(2485)] = 11762,
  [SMALL_STATE(2486)] = 11832,
  [SMALL_STATE(2487)] = 11902,
  [SMALL_STATE(2488)] = 11972,
  [SMALL_STATE(2489)] = 12042,
  [SMALL_STATE(2490)] = 12112,
  [SMALL_STATE(2491)] = 12182,
  [SMALL_STATE(2492)] = 12260,
  [SMALL_STATE(2493)] = 12330,
  [SMALL_STATE(2494)] = 12400,
  [SMALL_STATE(2495)] = 12475,
  [SMALL_STATE(2496)] = 12544,
  [SMALL_STATE(2497)] = 12613,
  [SMALL_STATE(2498)] = 12692,
  [SMALL_STATE(2499)] = 12761,
  [SMALL_STATE(2500)] = 12836,
  [SMALL_STATE(2501)] = 12905,
  [SMALL_STATE(2502)] = 12992,
  [SMALL_STATE(2503)] = 13071,
  [SMALL_STATE(2504)] = 13140,
  [SMALL_STATE(2505)] = 13215,
  [SMALL_STATE(2506)] = 13284,
  [SMALL_STATE(2507)] = 13357,
  [SMALL_STATE(2508)] = 13430,
  [SMALL_STATE(2509)] = 13503,
  [SMALL_STATE(2510)] = 13576,
  [SMALL_STATE(2511)] = 13649,
  [SMALL_STATE(2512)] = 13736,
  [SMALL_STATE(2513)] = 13817,
  [SMALL_STATE(2514)] = 13890,
  [SMALL_STATE(2515)] = 13963,
  [SMALL_STATE(2516)] = 14032,
  [SMALL_STATE(2517)] = 14101,
  [SMALL_STATE(2518)] = 14172,
  [SMALL_STATE(2519)] = 14291,
  [SMALL_STATE(2520)] = 14410,
  [SMALL_STATE(2521)] = 14483,
  [SMALL_STATE(2522)] = 14554,
  [SMALL_STATE(2523)] = 14627,
  [SMALL_STATE(2524)] = 14696,
  [SMALL_STATE(2525)] = 14765,
  [SMALL_STATE(2526)] = 14834,
  [SMALL_STATE(2527)] = 14909,
  [SMALL_STATE(2528)] = 14982,
  [SMALL_STATE(2529)] = 15055,
  [SMALL_STATE(2530)] = 15124,
  [SMALL_STATE(2531)] = 15193,
  [SMALL_STATE(2532)] = 15266,
  [SMALL_STATE(2533)] = 15337,
  [SMALL_STATE(2534)] = 15416,
  [SMALL_STATE(2535)] = 15503,
  [SMALL_STATE(2536)] = 15571,
  [SMALL_STATE(2537)] = 15645,
  [SMALL_STATE(2538)] = 15713,
  [SMALL_STATE(2539)] = 15799,
  [SMALL_STATE(2540)] = 15873,
  [SMALL_STATE(2541)] = 15947,
  [SMALL_STATE(2542)] = 16021,
  [SMALL_STATE(2543)] = 16095,
  [SMALL_STATE(2544)] = 16169,
  [SMALL_STATE(2545)] = 16239,
  [SMALL_STATE(2546)] = 16311,
  [SMALL_STATE(2547)] = 16385,
  [SMALL_STATE(2548)] = 16461,
  [SMALL_STATE(2549)] = 16533,
  [SMALL_STATE(2550)] = 16615,
  [SMALL_STATE(2551)] = 16687,
  [SMALL_STATE(2552)] = 16759,
  [SMALL_STATE(2553)] = 16827,
  [SMALL_STATE(2554)] = 16895,
  [SMALL_STATE(2555)] = 16967,
  [SMALL_STATE(2556)] = 17041,
  [SMALL_STATE(2557)] = 17113,
  [SMALL_STATE(2558)] = 17187,
  [SMALL_STATE(2559)] = 17261,
  [SMALL_STATE(2560)] = 17343,
  [SMALL_STATE(2561)] = 17411,
  [SMALL_STATE(2562)] = 17483,
  [SMALL_STATE(2563)] = 17553,
  [SMALL_STATE(2564)] = 17623,
  [SMALL_STATE(2565)] = 17691,
  [SMALL_STATE(2566)] = 17759,
  [SMALL_STATE(2567)] = 17827,
  [SMALL_STATE(2568)] = 17905,
  [SMALL_STATE(2569)] = 17977,
  [SMALL_STATE(2570)] = 18051,
  [SMALL_STATE(2571)] = 18127,
  [SMALL_STATE(2572)] = 18201,
  [SMALL_STATE(2573)] = 18275,
  [SMALL_STATE(2574)] = 18347,
  [SMALL_STATE(2575)] = 18419,
  [SMALL_STATE(2576)] = 18491,
  [SMALL_STATE(2577)] = 18563,
  [SMALL_STATE(2578)] = 18635,
  [SMALL_STATE(2579)] = 18709,
  [SMALL_STATE(2580)] = 18781,
  [SMALL_STATE(2581)] = 18853,
  [SMALL_STATE(2582)] = 18925,
  [SMALL_STATE(2583)] = 18993,
  [SMALL_STATE(2584)] = 19065,
  [SMALL_STATE(2585)] = 19137,
  [SMALL_STATE(2586)] = 19209,
  [SMALL_STATE(2587)] = 19277,
  [SMALL_STATE(2588)] = 19349,
  [SMALL_STATE(2589)] = 19425,
  [SMALL_STATE(2590)] = 19497,
  [SMALL_STATE(2591)] = 19569,
  [SMALL_STATE(2592)] = 19637,
  [SMALL_STATE(2593)] = 19711,
  [SMALL_STATE(2594)] = 19779,
  [SMALL_STATE(2595)] = 19849,
  [SMALL_STATE(2596)] = 19921,
  [SMALL_STATE(2597)] = 19995,
  [SMALL_STATE(2598)] = 20069,
  [SMALL_STATE(2599)] = 20145,
  [SMALL_STATE(2600)] = 20217,
  [SMALL_STATE(2601)] = 20285,
  [SMALL_STATE(2602)] = 20353,
  [SMALL_STATE(2603)] = 20421,
  [SMALL_STATE(2604)] = 20493,
  [SMALL_STATE(2605)] = 20560,
  [SMALL_STATE(2606)] = 20627,
  [SMALL_STATE(2607)] = 20696,
  [SMALL_STATE(2608)] = 20777,
  [SMALL_STATE(2609)] = 20844,
  [SMALL_STATE(2610)] = 20911,
  [SMALL_STATE(2611)] = 20978,
  [SMALL_STATE(2612)] = 21045,
  [SMALL_STATE(2613)] = 21162,
  [SMALL_STATE(2614)] = 21229,
  [SMALL_STATE(2615)] = 21296,
  [SMALL_STATE(2616)] = 21363,
  [SMALL_STATE(2617)] = 21430,
  [SMALL_STATE(2618)] = 21497,
  [SMALL_STATE(2619)] = 21564,
  [SMALL_STATE(2620)] = 21631,
  [SMALL_STATE(2621)] = 21698,
  [SMALL_STATE(2622)] = 21769,
  [SMALL_STATE(2623)] = 21836,
  [SMALL_STATE(2624)] = 21903,
  [SMALL_STATE(2625)] = 21974,
  [SMALL_STATE(2626)] = 22091,
  [SMALL_STATE(2627)] = 22158,
  [SMALL_STATE(2628)] = 22225,
  [SMALL_STATE(2629)] = 22292,
  [SMALL_STATE(2630)] = 22359,
  [SMALL_STATE(2631)] = 22426,
  [SMALL_STATE(2632)] = 22493,
  [SMALL_STATE(2633)] = 22562,
  [SMALL_STATE(2634)] = 22643,
  [SMALL_STATE(2635)] = 22710,
  [SMALL_STATE(2636)] = 22777,
  [SMALL_STATE(2637)] = 22844,
  [SMALL_STATE(2638)] = 22911,
  [SMALL_STATE(2639)] = 22978,
  [SMALL_STATE(2640)] = 23045,
  [SMALL_STATE(2641)] = 23162,
  [SMALL_STATE(2642)] = 23229,
  [SMALL_STATE(2643)] = 23296,
  [SMALL_STATE(2644)] = 23363,
  [SMALL_STATE(2645)] = 23430,
  [SMALL_STATE(2646)] = 23497,
  [SMALL_STATE(2647)] = 23568,
  [SMALL_STATE(2648)] = 23635,
  [SMALL_STATE(2649)] = 23702,
  [SMALL_STATE(2650)] = 23769,
  [SMALL_STATE(2651)] = 23840,
  [SMALL_STATE(2652)] = 23907,
  [SMALL_STATE(2653)] = 23974,
  [SMALL_STATE(2654)] = 24041,
  [SMALL_STATE(2655)] = 24108,
  [SMALL_STATE(2656)] = 24175,
  [SMALL_STATE(2657)] = 24242,
  [SMALL_STATE(2658)] = 24311,
  [SMALL_STATE(2659)] = 24378,
  [SMALL_STATE(2660)] = 24461,
  [SMALL_STATE(2661)] = 24532,
  [SMALL_STATE(2662)] = 24599,
  [SMALL_STATE(2663)] = 24666,
  [SMALL_STATE(2664)] = 24733,
  [SMALL_STATE(2665)] = 24850,
  [SMALL_STATE(2666)] = 24917,
  [SMALL_STATE(2667)] = 24988,
  [SMALL_STATE(2668)] = 25071,
  [SMALL_STATE(2669)] = 25138,
  [SMALL_STATE(2670)] = 25208,
  [SMALL_STATE(2671)] = 25284,
  [SMALL_STATE(2672)] = 25350,
  [SMALL_STATE(2673)] = 25426,
  [SMALL_STATE(2674)] = 25496,
  [SMALL_STATE(2675)] = 25562,
  [SMALL_STATE(2676)] = 25654,
  [SMALL_STATE(2677)] = 25720,
  [SMALL_STATE(2678)] = 25790,
  [SMALL_STATE(2679)] = 25860,
  [SMALL_STATE(2680)] = 25926,
  [SMALL_STATE(2681)] = 25992,
  [SMALL_STATE(2682)] = 26058,
  [SMALL_STATE(2683)] = 26124,
  [SMALL_STATE(2684)] = 26194,
  [SMALL_STATE(2685)] = 26276,
  [SMALL_STATE(2686)] = 26344,
  [SMALL_STATE(2687)] = 26412,
  [SMALL_STATE(2688)] = 26494,
  [SMALL_STATE(2689)] = 26560,
  [SMALL_STATE(2690)] = 26626,
  [SMALL_STATE(2691)] = 26692,
  [SMALL_STATE(2692)] = 26758,
  [SMALL_STATE(2693)] = 26824,
  [SMALL_STATE(2694)] = 26892,
  [SMALL_STATE(2695)] = 26962,
  [SMALL_STATE(2696)] = 27028,
  [SMALL_STATE(2697)] = 27094,
  [SMALL_STATE(2698)] = 27164,
  [SMALL_STATE(2699)] = 27230,
  [SMALL_STATE(2700)] = 27296,
  [SMALL_STATE(2701)] = 27362,
  [SMALL_STATE(2702)] = 27454,
  [SMALL_STATE(2703)] = 27526,
  [SMALL_STATE(2704)] = 27608,
  [SMALL_STATE(2705)] = 27700,
  [SMALL_STATE(2706)] = 27770,
  [SMALL_STATE(2707)] = 27840,
  [SMALL_STATE(2708)] = 27906,
  [SMALL_STATE(2709)] = 27998,
  [SMALL_STATE(2710)] = 28074,
  [SMALL_STATE(2711)] = 28144,
  [SMALL_STATE(2712)] = 28236,
  [SMALL_STATE(2713)] = 28328,
  [SMALL_STATE(2714)] = 28394,
  [SMALL_STATE(2715)] = 28486,
  [SMALL_STATE(2716)] = 28552,
  [SMALL_STATE(2717)] = 28624,
  [SMALL_STATE(2718)] = 28694,
  [SMALL_STATE(2719)] = 28764,
  [SMALL_STATE(2720)] = 28846,
  [SMALL_STATE(2721)] = 28912,
  [SMALL_STATE(2722)] = 28982,
  [SMALL_STATE(2723)] = 29053,
  [SMALL_STATE(2724)] = 29118,
  [SMALL_STATE(2725)] = 29189,
  [SMALL_STATE(2726)] = 29260,
  [SMALL_STATE(2727)] = 29325,
  [SMALL_STATE(2728)] = 29396,
  [SMALL_STATE(2729)] = 29467,
  [SMALL_STATE(2730)] = 29532,
  [SMALL_STATE(2731)] = 29597,
  [SMALL_STATE(2732)] = 29662,
  [SMALL_STATE(2733)] = 29727,
  [SMALL_STATE(2734)] = 29792,
  [SMALL_STATE(2735)] = 29857,
  [SMALL_STATE(2736)] = 29922,
  [SMALL_STATE(2737)] = 29987,
  [SMALL_STATE(2738)] = 30068,
  [SMALL_STATE(2739)] = 30135,
  [SMALL_STATE(2740)] = 30202,
  [SMALL_STATE(2741)] = 30273,
  [SMALL_STATE(2742)] = 30338,
  [SMALL_STATE(2743)] = 30419,
  [SMALL_STATE(2744)] = 30502,
  [SMALL_STATE(2745)] = 30585,
  [SMALL_STATE(2746)] = 30658,
  [SMALL_STATE(2747)] = 30723,
  [SMALL_STATE(2748)] = 30804,
  [SMALL_STATE(2749)] = 30887,
  [SMALL_STATE(2750)] = 30996,
  [SMALL_STATE(2751)] = 31109,
  [SMALL_STATE(2752)] = 31214,
  [SMALL_STATE(2753)] = 31315,
  [SMALL_STATE(2754)] = 31414,
  [SMALL_STATE(2755)] = 31511,
  [SMALL_STATE(2756)] = 31606,
  [SMALL_STATE(2757)] = 31697,
  [SMALL_STATE(2758)] = 31784,
  [SMALL_STATE(2759)] = 31893,
  [SMALL_STATE(2760)] = 32006,
  [SMALL_STATE(2761)] = 32115,
  [SMALL_STATE(2762)] = 32228,
  [SMALL_STATE(2763)] = 32303,
  [SMALL_STATE(2764)] = 32384,
  [SMALL_STATE(2765)] = 32467,
  [SMALL_STATE(2766)] = 32532,
  [SMALL_STATE(2767)] = 32615,
  [SMALL_STATE(2768)] = 32698,
  [SMALL_STATE(2769)] = 32807,
  [SMALL_STATE(2770)] = 32916,
  [SMALL_STATE(2771)] = 32999,
  [SMALL_STATE(2772)] = 33082,
  [SMALL_STATE(2773)] = 33165,
  [SMALL_STATE(2774)] = 33232,
  [SMALL_STATE(2775)] = 33303,
  [SMALL_STATE(2776)] = 33374,
  [SMALL_STATE(2777)] = 33453,
  [SMALL_STATE(2778)] = 33518,
  [SMALL_STATE(2779)] = 33601,
  [SMALL_STATE(2780)] = 33684,
  [SMALL_STATE(2781)] = 33749,
  [SMALL_STATE(2782)] = 33814,
  [SMALL_STATE(2783)] = 33879,
  [SMALL_STATE(2784)] = 33944,
  [SMALL_STATE(2785)] = 34009,
  [SMALL_STATE(2786)] = 34092,
  [SMALL_STATE(2787)] = 34175,
  [SMALL_STATE(2788)] = 34240,
  [SMALL_STATE(2789)] = 34305,
  [SMALL_STATE(2790)] = 34384,
  [SMALL_STATE(2791)] = 34449,
  [SMALL_STATE(2792)] = 34524,
  [SMALL_STATE(2793)] = 34597,
  [SMALL_STATE(2794)] = 34668,
  [SMALL_STATE(2795)] = 34733,
  [SMALL_STATE(2796)] = 34804,
  [SMALL_STATE(2797)] = 34885,
  [SMALL_STATE(2798)] = 34968,
  [SMALL_STATE(2799)] = 35053,
  [SMALL_STATE(2800)] = 35128,
  [SMALL_STATE(2801)] = 35199,
  [SMALL_STATE(2802)] = 35270,
  [SMALL_STATE(2803)] = 35353,
  [SMALL_STATE(2804)] = 35431,
  [SMALL_STATE(2805)] = 35501,
  [SMALL_STATE(2806)] = 35571,
  [SMALL_STATE(2807)] = 35683,
  [SMALL_STATE(2808)] = 35753,
  [SMALL_STATE(2809)] = 35819,
  [SMALL_STATE(2810)] = 35889,
  [SMALL_STATE(2811)] = 35959,
  [SMALL_STATE(2812)] = 36029,
  [SMALL_STATE(2813)] = 36093,
  [SMALL_STATE(2814)] = 36157,
  [SMALL_STATE(2815)] = 36221,
  [SMALL_STATE(2816)] = 36285,
  [SMALL_STATE(2817)] = 36359,
  [SMALL_STATE(2818)] = 36435,
  [SMALL_STATE(2819)] = 36499,
  [SMALL_STATE(2820)] = 36563,
  [SMALL_STATE(2821)] = 36627,
  [SMALL_STATE(2822)] = 36691,
  [SMALL_STATE(2823)] = 36761,
  [SMALL_STATE(2824)] = 36825,
  [SMALL_STATE(2825)] = 36895,
  [SMALL_STATE(2826)] = 36965,
  [SMALL_STATE(2827)] = 37035,
  [SMALL_STATE(2828)] = 37147,
  [SMALL_STATE(2829)] = 37217,
  [SMALL_STATE(2830)] = 37287,
  [SMALL_STATE(2831)] = 37357,
  [SMALL_STATE(2832)] = 37475,
  [SMALL_STATE(2833)] = 37541,
  [SMALL_STATE(2834)] = 37609,
  [SMALL_STATE(2835)] = 37727,
  [SMALL_STATE(2836)] = 37794,
  [SMALL_STATE(2837)] = 37907,
  [SMALL_STATE(2838)] = 37970,
  [SMALL_STATE(2839)] = 38087,
  [SMALL_STATE(2840)] = 38156,
  [SMALL_STATE(2841)] = 38235,
  [SMALL_STATE(2842)] = 38396,
  [SMALL_STATE(2843)] = 38505,
  [SMALL_STATE(2844)] = 38614,
  [SMALL_STATE(2845)] = 38723,
  [SMALL_STATE(2846)] = 38792,
  [SMALL_STATE(2847)] = 38901,
  [SMALL_STATE(2848)] = 39014,
  [SMALL_STATE(2849)] = 39093,
  [SMALL_STATE(2850)] = 39202,
  [SMALL_STATE(2851)] = 39307,
  [SMALL_STATE(2852)] = 39408,
  [SMALL_STATE(2853)] = 39473,
  [SMALL_STATE(2854)] = 39540,
  [SMALL_STATE(2855)] = 39607,
  [SMALL_STATE(2856)] = 39704,
  [SMALL_STATE(2857)] = 39799,
  [SMALL_STATE(2858)] = 39890,
  [SMALL_STATE(2859)] = 39979,
  [SMALL_STATE(2860)] = 40064,
  [SMALL_STATE(2861)] = 40145,
  [SMALL_STATE(2862)] = 40216,
  [SMALL_STATE(2863)] = 40325,
  [SMALL_STATE(2864)] = 40434,
  [SMALL_STATE(2865)] = 40517,
  [SMALL_STATE(2866)] = 40626,
  [SMALL_STATE(2867)] = 40699,
  [SMALL_STATE(2868)] = 40808,
  [SMALL_STATE(2869)] = 40881,
  [SMALL_STATE(2870)] = 40990,
  [SMALL_STATE(2871)] = 41099,
  [SMALL_STATE(2872)] = 41178,
  [SMALL_STATE(2873)] = 41295,
  [SMALL_STATE(2874)] = 41364,
  [SMALL_STATE(2875)] = 41427,
  [SMALL_STATE(2876)] = 41494,
  [SMALL_STATE(2877)] = 41565,
  [SMALL_STATE(2878)] = 41632,
  [SMALL_STATE(2879)] = 41741,
  [SMALL_STATE(2880)] = 41808,
  [SMALL_STATE(2881)] = 41925,
  [SMALL_STATE(2882)] = 42034,
  [SMALL_STATE(2883)] = 42105,
  [SMALL_STATE(2884)] = 42178,
  [SMALL_STATE(2885)] = 42287,
  [SMALL_STATE(2886)] = 42354,
  [SMALL_STATE(2887)] = 42471,
  [SMALL_STATE(2888)] = 42580,
  [SMALL_STATE(2889)] = 42647,
  [SMALL_STATE(2890)] = 42756,
  [SMALL_STATE(2891)] = 42821,
  [SMALL_STATE(2892)] = 42884,
  [SMALL_STATE(2893)] = 42947,
  [SMALL_STATE(2894)] = 43108,
  [SMALL_STATE(2895)] = 43175,
  [SMALL_STATE(2896)] = 43284,
  [SMALL_STATE(2897)] = 43393,
  [SMALL_STATE(2898)] = 43466,
  [SMALL_STATE(2899)] = 43575,
  [SMALL_STATE(2900)] = 43684,
  [SMALL_STATE(2901)] = 43793,
  [SMALL_STATE(2902)] = 43906,
  [SMALL_STATE(2903)] = 43973,
  [SMALL_STATE(2904)] = 44036,
  [SMALL_STATE(2905)] = 44145,
  [SMALL_STATE(2906)] = 44254,
  [SMALL_STATE(2907)] = 44321,
  [SMALL_STATE(2908)] = 44384,
  [SMALL_STATE(2909)] = 44493,
  [SMALL_STATE(2910)] = 44602,
  [SMALL_STATE(2911)] = 44665,
  [SMALL_STATE(2912)] = 44782,
  [SMALL_STATE(2913)] = 44891,
  [SMALL_STATE(2914)] = 45000,
  [SMALL_STATE(2915)] = 45073,
  [SMALL_STATE(2916)] = 45182,
  [SMALL_STATE(2917)] = 45255,
  [SMALL_STATE(2918)] = 45364,
  [SMALL_STATE(2919)] = 45473,
  [SMALL_STATE(2920)] = 45536,
  [SMALL_STATE(2921)] = 45603,
  [SMALL_STATE(2922)] = 45682,
  [SMALL_STATE(2923)] = 45799,
  [SMALL_STATE(2924)] = 45960,
  [SMALL_STATE(2925)] = 46069,
  [SMALL_STATE(2926)] = 46136,
  [SMALL_STATE(2927)] = 46215,
  [SMALL_STATE(2928)] = 46288,
  [SMALL_STATE(2929)] = 46397,
  [SMALL_STATE(2930)] = 46506,
  [SMALL_STATE(2931)] = 46622,
  [SMALL_STATE(2932)] = 46738,
  [SMALL_STATE(2933)] = 46804,
  [SMALL_STATE(2934)] = 46878,
  [SMALL_STATE(2935)] = 46960,
  [SMALL_STATE(2936)] = 47028,
  [SMALL_STATE(2937)] = 47094,
  [SMALL_STATE(2938)] = 47156,
  [SMALL_STATE(2939)] = 47236,
  [SMALL_STATE(2940)] = 47298,
  [SMALL_STATE(2941)] = 47414,
  [SMALL_STATE(2942)] = 47482,
  [SMALL_STATE(2943)] = 47544,
  [SMALL_STATE(2944)] = 47610,
  [SMALL_STATE(2945)] = 47672,
  [SMALL_STATE(2946)] = 47736,
  [SMALL_STATE(2947)] = 47798,
  [SMALL_STATE(2948)] = 47860,
  [SMALL_STATE(2949)] = 47924,
  [SMALL_STATE(2950)] = 47986,
  [SMALL_STATE(2951)] = 48054,
  [SMALL_STATE(2952)] = 48116,
  [SMALL_STATE(2953)] = 48182,
  [SMALL_STATE(2954)] = 48248,
  [SMALL_STATE(2955)] = 48322,
  [SMALL_STATE(2956)] = 48384,
  [SMALL_STATE(2957)] = 48446,
  [SMALL_STATE(2958)] = 48514,
  [SMALL_STATE(2959)] = 48586,
  [SMALL_STATE(2960)] = 48648,
  [SMALL_STATE(2961)] = 48710,
  [SMALL_STATE(2962)] = 48772,
  [SMALL_STATE(2963)] = 48846,
  [SMALL_STATE(2964)] = 48918,
  [SMALL_STATE(2965)] = 49026,
  [SMALL_STATE(2966)] = 49094,
  [SMALL_STATE(2967)] = 49166,
  [SMALL_STATE(2968)] = 49232,
  [SMALL_STATE(2969)] = 49298,
  [SMALL_STATE(2970)] = 49366,
  [SMALL_STATE(2971)] = 49432,
  [SMALL_STATE(2972)] = 49500,
  [SMALL_STATE(2973)] = 49562,
  [SMALL_STATE(2974)] = 49626,
  [SMALL_STATE(2975)] = 49692,
  [SMALL_STATE(2976)] = 49756,
  [SMALL_STATE(2977)] = 49822,
  [SMALL_STATE(2978)] = 49934,
  [SMALL_STATE(2979)] = 49996,
  [SMALL_STATE(2980)] = 50060,
  [SMALL_STATE(2981)] = 50122,
  [SMALL_STATE(2982)] = 50184,
  [SMALL_STATE(2983)] = 50300,
  [SMALL_STATE(2984)] = 50372,
  [SMALL_STATE(2985)] = 50438,
  [SMALL_STATE(2986)] = 50506,
  [SMALL_STATE(2987)] = 50572,
  [SMALL_STATE(2988)] = 50638,
  [SMALL_STATE(2989)] = 50708,
  [SMALL_STATE(2990)] = 50770,
  [SMALL_STATE(2991)] = 50874,
  [SMALL_STATE(2992)] = 50974,
  [SMALL_STATE(2993)] = 51070,
  [SMALL_STATE(2994)] = 51164,
  [SMALL_STATE(2995)] = 51254,
  [SMALL_STATE(2996)] = 51342,
  [SMALL_STATE(2997)] = 51426,
  [SMALL_STATE(2998)] = 51488,
  [SMALL_STATE(2999)] = 51604,
  [SMALL_STATE(3000)] = 51666,
  [SMALL_STATE(3001)] = 51728,
  [SMALL_STATE(3002)] = 51792,
  [SMALL_STATE(3003)] = 51872,
  [SMALL_STATE(3004)] = 51942,
  [SMALL_STATE(3005)] = 52004,
  [SMALL_STATE(3006)] = 52120,
  [SMALL_STATE(3007)] = 52236,
  [SMALL_STATE(3008)] = 52308,
  [SMALL_STATE(3009)] = 52376,
  [SMALL_STATE(3010)] = 52442,
  [SMALL_STATE(3011)] = 52510,
  [SMALL_STATE(3012)] = 52572,
  [SMALL_STATE(3013)] = 52636,
  [SMALL_STATE(3014)] = 52704,
  [SMALL_STATE(3015)] = 52766,
  [SMALL_STATE(3016)] = 52832,
  [SMALL_STATE(3017)] = 52898,
  [SMALL_STATE(3018)] = 52960,
  [SMALL_STATE(3019)] = 53032,
  [SMALL_STATE(3020)] = 53096,
  [SMALL_STATE(3021)] = 53158,
  [SMALL_STATE(3022)] = 53224,
  [SMALL_STATE(3023)] = 53292,
  [SMALL_STATE(3024)] = 53356,
  [SMALL_STATE(3025)] = 53418,
  [SMALL_STATE(3026)] = 53484,
  [SMALL_STATE(3027)] = 53548,
  [SMALL_STATE(3028)] = 53612,
  [SMALL_STATE(3029)] = 53720,
  [SMALL_STATE(3030)] = 53782,
  [SMALL_STATE(3031)] = 53890,
  [SMALL_STATE(3032)] = 53958,
  [SMALL_STATE(3033)] = 54024,
  [SMALL_STATE(3034)] = 54092,
  [SMALL_STATE(3035)] = 54158,
  [SMALL_STATE(3036)] = 54220,
  [SMALL_STATE(3037)] = 54284,
  [SMALL_STATE(3038)] = 54346,
  [SMALL_STATE(3039)] = 54412,
  [SMALL_STATE(3040)] = 54524,
  [SMALL_STATE(3041)] = 54592,
  [SMALL_STATE(3042)] = 54656,
  [SMALL_STATE(3043)] = 54764,
  [SMALL_STATE(3044)] = 54872,
  [SMALL_STATE(3045)] = 54936,
  [SMALL_STATE(3046)] = 55000,
  [SMALL_STATE(3047)] = 55062,
  [SMALL_STATE(3048)] = 55124,
  [SMALL_STATE(3049)] = 55186,
  [SMALL_STATE(3050)] = 55248,
  [SMALL_STATE(3051)] = 55326,
  [SMALL_STATE(3052)] = 55390,
  [SMALL_STATE(3053)] = 55502,
  [SMALL_STATE(3054)] = 55618,
  [SMALL_STATE(3055)] = 55680,
  [SMALL_STATE(3056)] = 55796,
  [SMALL_STATE(3057)] = 55858,
  [SMALL_STATE(3058)] = 55922,
  [SMALL_STATE(3059)] = 55990,
  [SMALL_STATE(3060)] = 56058,
  [SMALL_STATE(3061)] = 56124,
  [SMALL_STATE(3062)] = 56186,
  [SMALL_STATE(3063)] = 56248,
  [SMALL_STATE(3064)] = 56316,
  [SMALL_STATE(3065)] = 56432,
  [SMALL_STATE(3066)] = 56507,
  [SMALL_STATE(3067)] = 56568,
  [SMALL_STATE(3068)] = 56635,
  [SMALL_STATE(3069)] = 56702,
  [SMALL_STATE(3070)] = 56767,
  [SMALL_STATE(3071)] = 56836,
  [SMALL_STATE(3072)] = 56899,
  [SMALL_STATE(3073)] = 56960,
  [SMALL_STATE(3074)] = 57021,
  [SMALL_STATE(3075)] = 57082,
  [SMALL_STATE(3076)] = 57143,
  [SMALL_STATE(3077)] = 57204,
  [SMALL_STATE(3078)] = 57271,
  [SMALL_STATE(3079)] = 57332,
  [SMALL_STATE(3080)] = 57393,
  [SMALL_STATE(3081)] = 57454,
  [SMALL_STATE(3082)] = 57515,
  [SMALL_STATE(3083)] = 57582,
  [SMALL_STATE(3084)] = 57643,
  [SMALL_STATE(3085)] = 57712,
  [SMALL_STATE(3086)] = 57775,
  [SMALL_STATE(3087)] = 57882,
  [SMALL_STATE(3088)] = 57989,
  [SMALL_STATE(3089)] = 58050,
  [SMALL_STATE(3090)] = 58111,
  [SMALL_STATE(3091)] = 58218,
  [SMALL_STATE(3092)] = 58293,
  [SMALL_STATE(3093)] = 58354,
  [SMALL_STATE(3094)] = 58415,
  [SMALL_STATE(3095)] = 58476,
  [SMALL_STATE(3096)] = 58537,
  [SMALL_STATE(3097)] = 58598,
  [SMALL_STATE(3098)] = 58665,
  [SMALL_STATE(3099)] = 58776,
  [SMALL_STATE(3100)] = 58851,
  [SMALL_STATE(3101)] = 58926,
  [SMALL_STATE(3102)] = 58993,
  [SMALL_STATE(3103)] = 59058,
  [SMALL_STATE(3104)] = 59169,
  [SMALL_STATE(3105)] = 59230,
  [SMALL_STATE(3106)] = 59297,
  [SMALL_STATE(3107)] = 59358,
  [SMALL_STATE(3108)] = 59419,
  [SMALL_STATE(3109)] = 59526,
  [SMALL_STATE(3110)] = 59641,
  [SMALL_STATE(3111)] = 59708,
  [SMALL_STATE(3112)] = 59769,
  [SMALL_STATE(3113)] = 59842,
  [SMALL_STATE(3114)] = 59957,
  [SMALL_STATE(3115)] = 60018,
  [SMALL_STATE(3116)] = 60087,
  [SMALL_STATE(3117)] = 60148,
  [SMALL_STATE(3118)] = 60213,
  [SMALL_STATE(3119)] = 60278,
  [SMALL_STATE(3120)] = 60339,
  [SMALL_STATE(3121)] = 60404,
  [SMALL_STATE(3122)] = 60465,
  [SMALL_STATE(3123)] = 60526,
  [SMALL_STATE(3124)] = 60587,
  [SMALL_STATE(3125)] = 60648,
  [SMALL_STATE(3126)] = 60723,
  [SMALL_STATE(3127)] = 60784,
  [SMALL_STATE(3128)] = 60857,
  [SMALL_STATE(3129)] = 60924,
  [SMALL_STATE(3130)] = 61001,
  [SMALL_STATE(3131)] = 61076,
  [SMALL_STATE(3132)] = 61137,
  [SMALL_STATE(3133)] = 61240,
  [SMALL_STATE(3134)] = 61339,
  [SMALL_STATE(3135)] = 61434,
  [SMALL_STATE(3136)] = 61527,
  [SMALL_STATE(3137)] = 61616,
  [SMALL_STATE(3138)] = 61677,
  [SMALL_STATE(3139)] = 61764,
  [SMALL_STATE(3140)] = 61847,
  [SMALL_STATE(3141)] = 61926,
  [SMALL_STATE(3142)] = 62007,
  [SMALL_STATE(3143)] = 62074,
  [SMALL_STATE(3144)] = 62137,
  [SMALL_STATE(3145)] = 62198,
  [SMALL_STATE(3146)] = 62263,
  [SMALL_STATE(3147)] = 62324,
  [SMALL_STATE(3148)] = 62385,
  [SMALL_STATE(3149)] = 62446,
  [SMALL_STATE(3150)] = 62507,
  [SMALL_STATE(3151)] = 62568,
  [SMALL_STATE(3152)] = 62629,
  [SMALL_STATE(3153)] = 62690,
  [SMALL_STATE(3154)] = 62797,
  [SMALL_STATE(3155)] = 62872,
  [SMALL_STATE(3156)] = 62933,
  [SMALL_STATE(3157)] = 62994,
  [SMALL_STATE(3158)] = 63059,
  [SMALL_STATE(3159)] = 63124,
  [SMALL_STATE(3160)] = 63185,
  [SMALL_STATE(3161)] = 63262,
  [SMALL_STATE(3162)] = 63331,
  [SMALL_STATE(3163)] = 63394,
  [SMALL_STATE(3164)] = 63505,
  [SMALL_STATE(3165)] = 63566,
  [SMALL_STATE(3166)] = 63635,
  [SMALL_STATE(3167)] = 63749,
  [SMALL_STATE(3168)] = 63809,
  [SMALL_STATE(3169)] = 63913,
  [SMALL_STATE(3170)] = 64017,
  [SMALL_STATE(3171)] = 64077,
  [SMALL_STATE(3172)] = 64137,
  [SMALL_STATE(3173)] = 64197,
  [SMALL_STATE(3174)] = 64259,
  [SMALL_STATE(3175)] = 64319,
  [SMALL_STATE(3176)] = 64379,
  [SMALL_STATE(3177)] = 64441,
  [SMALL_STATE(3178)] = 64507,
  [SMALL_STATE(3179)] = 64567,
  [SMALL_STATE(3180)] = 64631,
  [SMALL_STATE(3181)] = 64691,
  [SMALL_STATE(3182)] = 64751,
  [SMALL_STATE(3183)] = 64817,
  [SMALL_STATE(3184)] = 64877,
  [SMALL_STATE(3185)] = 64941,
  [SMALL_STATE(3186)] = 65053,
  [SMALL_STATE(3187)] = 65167,
  [SMALL_STATE(3188)] = 65271,
  [SMALL_STATE(3189)] = 65337,
  [SMALL_STATE(3190)] = 65413,
  [SMALL_STATE(3191)] = 65487,
  [SMALL_STATE(3192)] = 65601,
  [SMALL_STATE(3193)] = 65661,
  [SMALL_STATE(3194)] = 65817,
  [SMALL_STATE(3195)] = 65877,
  [SMALL_STATE(3196)] = 65977,
  [SMALL_STATE(3197)] = 66073,
  [SMALL_STATE(3198)] = 66181,
  [SMALL_STATE(3199)] = 66337,
  [SMALL_STATE(3200)] = 66397,
  [SMALL_STATE(3201)] = 66489,
  [SMALL_STATE(3202)] = 66549,
  [SMALL_STATE(3203)] = 66609,
  [SMALL_STATE(3204)] = 66699,
  [SMALL_STATE(3205)] = 66855,
  [SMALL_STATE(3206)] = 66941,
  [SMALL_STATE(3207)] = 67025,
  [SMALL_STATE(3208)] = 67089,
  [SMALL_STATE(3209)] = 67171,
  [SMALL_STATE(3210)] = 67237,
  [SMALL_STATE(3211)] = 67297,
  [SMALL_STATE(3212)] = 67411,
  [SMALL_STATE(3213)] = 67515,
  [SMALL_STATE(3214)] = 67593,
  [SMALL_STATE(3215)] = 67665,
  [SMALL_STATE(3216)] = 67731,
  [SMALL_STATE(3217)] = 67791,
  [SMALL_STATE(3218)] = 67851,
  [SMALL_STATE(3219)] = 67919,
  [SMALL_STATE(3220)] = 68075,
  [SMALL_STATE(3221)] = 68139,
  [SMALL_STATE(3222)] = 68253,
  [SMALL_STATE(3223)] = 68333,
  [SMALL_STATE(3224)] = 68393,
  [SMALL_STATE(3225)] = 68453,
  [SMALL_STATE(3226)] = 68513,
  [SMALL_STATE(3227)] = 68587,
  [SMALL_STATE(3228)] = 68647,
  [SMALL_STATE(3229)] = 68707,
  [SMALL_STATE(3230)] = 68863,
  [SMALL_STATE(3231)] = 68923,
  [SMALL_STATE(3232)] = 68983,
  [SMALL_STATE(3233)] = 69057,
  [SMALL_STATE(3234)] = 69171,
  [SMALL_STATE(3235)] = 69231,
  [SMALL_STATE(3236)] = 69291,
  [SMALL_STATE(3237)] = 69395,
  [SMALL_STATE(3238)] = 69457,
  [SMALL_STATE(3239)] = 69613,
  [SMALL_STATE(3240)] = 69769,
  [SMALL_STATE(3241)] = 69835,
  [SMALL_STATE(3242)] = 69895,
  [SMALL_STATE(3243)] = 69973,
  [SMALL_STATE(3244)] = 70033,
  [SMALL_STATE(3245)] = 70103,
  [SMALL_STATE(3246)] = 70173,
  [SMALL_STATE(3247)] = 70239,
  [SMALL_STATE(3248)] = 70313,
  [SMALL_STATE(3249)] = 70387,
  [SMALL_STATE(3250)] = 70501,
  [SMALL_STATE(3251)] = 70569,
  [SMALL_STATE(3252)] = 70629,
  [SMALL_STATE(3253)] = 70691,
  [SMALL_STATE(3254)] = 70751,
  [SMALL_STATE(3255)] = 70811,
  [SMALL_STATE(3256)] = 70871,
  [SMALL_STATE(3257)] = 70937,
  [SMALL_STATE(3258)] = 71009,
  [SMALL_STATE(3259)] = 71081,
  [SMALL_STATE(3260)] = 71153,
  [SMALL_STATE(3261)] = 71217,
  [SMALL_STATE(3262)] = 71289,
  [SMALL_STATE(3263)] = 71395,
  [SMALL_STATE(3264)] = 71469,
  [SMALL_STATE(3265)] = 71543,
  [SMALL_STATE(3266)] = 71649,
  [SMALL_STATE(3267)] = 71721,
  [SMALL_STATE(3268)] = 71827,
  [SMALL_STATE(3269)] = 71937,
  [SMALL_STATE(3270)] = 72013,
  [SMALL_STATE(3271)] = 72087,
  [SMALL_STATE(3272)] = 72189,
  [SMALL_STATE(3273)] = 72287,
  [SMALL_STATE(3274)] = 72381,
  [SMALL_STATE(3275)] = 72473,
  [SMALL_STATE(3276)] = 72561,
  [SMALL_STATE(3277)] = 72647,
  [SMALL_STATE(3278)] = 72729,
  [SMALL_STATE(3279)] = 72807,
  [SMALL_STATE(3280)] = 72887,
  [SMALL_STATE(3281)] = 72961,
  [SMALL_STATE(3282)] = 73069,
  [SMALL_STATE(3283)] = 73175,
  [SMALL_STATE(3284)] = 73285,
  [SMALL_STATE(3285)] = 73391,
  [SMALL_STATE(3286)] = 73501,
  [SMALL_STATE(3287)] = 73565,
  [SMALL_STATE(3288)] = 73625,
  [SMALL_STATE(3289)] = 73685,
  [SMALL_STATE(3290)] = 73745,
  [SMALL_STATE(3291)] = 73805,
  [SMALL_STATE(3292)] = 73865,
  [SMALL_STATE(3293)] = 73935,
  [SMALL_STATE(3294)] = 74009,
  [SMALL_STATE(3295)] = 74117,
  [SMALL_STATE(3296)] = 74177,
  [SMALL_STATE(3297)] = 74239,
  [SMALL_STATE(3298)] = 74299,
  [SMALL_STATE(3299)] = 74365,
  [SMALL_STATE(3300)] = 74445,
  [SMALL_STATE(3301)] = 74505,
  [SMALL_STATE(3302)] = 74565,
  [SMALL_STATE(3303)] = 74721,
  [SMALL_STATE(3304)] = 74781,
  [SMALL_STATE(3305)] = 74841,
  [SMALL_STATE(3306)] = 74997,
  [SMALL_STATE(3307)] = 75057,
  [SMALL_STATE(3308)] = 75117,
  [SMALL_STATE(3309)] = 75177,
  [SMALL_STATE(3310)] = 75237,
  [SMALL_STATE(3311)] = 75297,
  [SMALL_STATE(3312)] = 75356,
  [SMALL_STATE(3313)] = 75415,
  [SMALL_STATE(3314)] = 75474,
  [SMALL_STATE(3315)] = 75537,
  [SMALL_STATE(3316)] = 75600,
  [SMALL_STATE(3317)] = 75663,
  [SMALL_STATE(3318)] = 75726,
  [SMALL_STATE(3319)] = 75789,
  [SMALL_STATE(3320)] = 75848,
  [SMALL_STATE(3321)] = 75911,
  [SMALL_STATE(3322)] = 75974,
  [SMALL_STATE(3323)] = 76037,
  [SMALL_STATE(3324)] = 76100,
  [SMALL_STATE(3325)] = 76159,
  [SMALL_STATE(3326)] = 76218,
  [SMALL_STATE(3327)] = 76277,
  [SMALL_STATE(3328)] = 76336,
  [SMALL_STATE(3329)] = 76395,
  [SMALL_STATE(3330)] = 76454,
  [SMALL_STATE(3331)] = 76521,
  [SMALL_STATE(3332)] = 76580,
  [SMALL_STATE(3333)] = 76639,
  [SMALL_STATE(3334)] = 76704,
  [SMALL_STATE(3335)] = 76763,
  [SMALL_STATE(3336)] = 76822,
  [SMALL_STATE(3337)] = 76881,
  [SMALL_STATE(3338)] = 76940,
  [SMALL_STATE(3339)] = 76999,
  [SMALL_STATE(3340)] = 77058,
  [SMALL_STATE(3341)] = 77117,
  [SMALL_STATE(3342)] = 77176,
  [SMALL_STATE(3343)] = 77241,
  [SMALL_STATE(3344)] = 77300,
  [SMALL_STATE(3345)] = 77369,
  [SMALL_STATE(3346)] = 77428,
  [SMALL_STATE(3347)] = 77487,
  [SMALL_STATE(3348)] = 77584,
  [SMALL_STATE(3349)] = 77681,
  [SMALL_STATE(3350)] = 77740,
  [SMALL_STATE(3351)] = 77799,
  [SMALL_STATE(3352)] = 77858,
  [SMALL_STATE(3353)] = 77917,
  [SMALL_STATE(3354)] = 77976,
  [SMALL_STATE(3355)] = 78035,
  [SMALL_STATE(3356)] = 78094,
  [SMALL_STATE(3357)] = 78207,
  [SMALL_STATE(3358)] = 78266,
  [SMALL_STATE(3359)] = 78325,
  [SMALL_STATE(3360)] = 78384,
  [SMALL_STATE(3361)] = 78443,
  [SMALL_STATE(3362)] = 78502,
  [SMALL_STATE(3363)] = 78561,
  [SMALL_STATE(3364)] = 78620,
  [SMALL_STATE(3365)] = 78683,
  [SMALL_STATE(3366)] = 78742,
  [SMALL_STATE(3367)] = 78801,
  [SMALL_STATE(3368)] = 78860,
  [SMALL_STATE(3369)] = 78919,
  [SMALL_STATE(3370)] = 78978,
  [SMALL_STATE(3371)] = 79043,
  [SMALL_STATE(3372)] = 79102,
  [SMALL_STATE(3373)] = 79161,
  [SMALL_STATE(3374)] = 79274,
  [SMALL_STATE(3375)] = 79335,
  [SMALL_STATE(3376)] = 79394,
  [SMALL_STATE(3377)] = 79453,
  [SMALL_STATE(3378)] = 79512,
  [SMALL_STATE(3379)] = 79571,
  [SMALL_STATE(3380)] = 79630,
  [SMALL_STATE(3381)] = 79689,
  [SMALL_STATE(3382)] = 79748,
  [SMALL_STATE(3383)] = 79807,
  [SMALL_STATE(3384)] = 79866,
  [SMALL_STATE(3385)] = 79925,
  [SMALL_STATE(3386)] = 79984,
  [SMALL_STATE(3387)] = 80049,
  [SMALL_STATE(3388)] = 80118,
  [SMALL_STATE(3389)] = 80177,
  [SMALL_STATE(3390)] = 80236,
  [SMALL_STATE(3391)] = 80295,
  [SMALL_STATE(3392)] = 80354,
  [SMALL_STATE(3393)] = 80413,
  [SMALL_STATE(3394)] = 80472,
  [SMALL_STATE(3395)] = 80531,
  [SMALL_STATE(3396)] = 80590,
  [SMALL_STATE(3397)] = 80649,
  [SMALL_STATE(3398)] = 80712,
  [SMALL_STATE(3399)] = 80771,
  [SMALL_STATE(3400)] = 80830,
  [SMALL_STATE(3401)] = 80889,
  [SMALL_STATE(3402)] = 80948,
  [SMALL_STATE(3403)] = 81007,
  [SMALL_STATE(3404)] = 81066,
  [SMALL_STATE(3405)] = 81125,
  [SMALL_STATE(3406)] = 81184,
  [SMALL_STATE(3407)] = 81243,
  [SMALL_STATE(3408)] = 81302,
  [SMALL_STATE(3409)] = 81361,
  [SMALL_STATE(3410)] = 81420,
  [SMALL_STATE(3411)] = 81479,
  [SMALL_STATE(3412)] = 81538,
  [SMALL_STATE(3413)] = 81597,
  [SMALL_STATE(3414)] = 81656,
  [SMALL_STATE(3415)] = 81715,
  [SMALL_STATE(3416)] = 81774,
  [SMALL_STATE(3417)] = 81833,
  [SMALL_STATE(3418)] = 81892,
  [SMALL_STATE(3419)] = 81951,
  [SMALL_STATE(3420)] = 82010,
  [SMALL_STATE(3421)] = 82069,
  [SMALL_STATE(3422)] = 82130,
  [SMALL_STATE(3423)] = 82189,
  [SMALL_STATE(3424)] = 82248,
  [SMALL_STATE(3425)] = 82307,
  [SMALL_STATE(3426)] = 82366,
  [SMALL_STATE(3427)] = 82425,
  [SMALL_STATE(3428)] = 82484,
  [SMALL_STATE(3429)] = 82545,
  [SMALL_STATE(3430)] = 82604,
  [SMALL_STATE(3431)] = 82663,
  [SMALL_STATE(3432)] = 82722,
  [SMALL_STATE(3433)] = 82787,
  [SMALL_STATE(3434)] = 82852,
  [SMALL_STATE(3435)] = 82965,
  [SMALL_STATE(3436)] = 83024,
  [SMALL_STATE(3437)] = 83083,
  [SMALL_STATE(3438)] = 83142,
  [SMALL_STATE(3439)] = 83201,
  [SMALL_STATE(3440)] = 83260,
  [SMALL_STATE(3441)] = 83327,
  [SMALL_STATE(3442)] = 83386,
  [SMALL_STATE(3443)] = 83445,
  [SMALL_STATE(3444)] = 83504,
  [SMALL_STATE(3445)] = 83563,
  [SMALL_STATE(3446)] = 83622,
  [SMALL_STATE(3447)] = 83681,
  [SMALL_STATE(3448)] = 83740,
  [SMALL_STATE(3449)] = 83799,
  [SMALL_STATE(3450)] = 83858,
  [SMALL_STATE(3451)] = 83917,
  [SMALL_STATE(3452)] = 83976,
  [SMALL_STATE(3453)] = 84035,
  [SMALL_STATE(3454)] = 84094,
  [SMALL_STATE(3455)] = 84161,
  [SMALL_STATE(3456)] = 84220,
  [SMALL_STATE(3457)] = 84279,
  [SMALL_STATE(3458)] = 84344,
  [SMALL_STATE(3459)] = 84403,
  [SMALL_STATE(3460)] = 84462,
  [SMALL_STATE(3461)] = 84525,
  [SMALL_STATE(3462)] = 84584,
  [SMALL_STATE(3463)] = 84643,
  [SMALL_STATE(3464)] = 84710,
  [SMALL_STATE(3465)] = 84823,
  [SMALL_STATE(3466)] = 84920,
  [SMALL_STATE(3467)] = 84989,
  [SMALL_STATE(3468)] = 85058,
  [SMALL_STATE(3469)] = 85117,
  [SMALL_STATE(3470)] = 85176,
  [SMALL_STATE(3471)] = 85235,
  [SMALL_STATE(3472)] = 85332,
  [SMALL_STATE(3473)] = 85429,
  [SMALL_STATE(3474)] = 85526,
  [SMALL_STATE(3475)] = 85585,
  [SMALL_STATE(3476)] = 85644,
  [SMALL_STATE(3477)] = 85707,
  [SMALL_STATE(3478)] = 85766,
  [SMALL_STATE(3479)] = 85825,
  [SMALL_STATE(3480)] = 85884,
  [SMALL_STATE(3481)] = 85953,
  [SMALL_STATE(3482)] = 86012,
  [SMALL_STATE(3483)] = 86071,
  [SMALL_STATE(3484)] = 86130,
  [SMALL_STATE(3485)] = 86193,
  [SMALL_STATE(3486)] = 86256,
  [SMALL_STATE(3487)] = 86315,
  [SMALL_STATE(3488)] = 86376,
  [SMALL_STATE(3489)] = 86435,
  [SMALL_STATE(3490)] = 86494,
  [SMALL_STATE(3491)] = 86557,
  [SMALL_STATE(3492)] = 86616,
  [SMALL_STATE(3493)] = 86679,
  [SMALL_STATE(3494)] = 86738,
  [SMALL_STATE(3495)] = 86797,
  [SMALL_STATE(3496)] = 86855,
  [SMALL_STATE(3497)] = 86917,
  [SMALL_STATE(3498)] = 86975,
  [SMALL_STATE(3499)] = 87081,
  [SMALL_STATE(3500)] = 87139,
  [SMALL_STATE(3501)] = 87209,
  [SMALL_STATE(3502)] = 87267,
  [SMALL_STATE(3503)] = 87369,
  [SMALL_STATE(3504)] = 87443,
  [SMALL_STATE(3505)] = 87515,
  [SMALL_STATE(3506)] = 87573,
  [SMALL_STATE(3507)] = 87631,
  [SMALL_STATE(3508)] = 87693,
  [SMALL_STATE(3509)] = 87751,
  [SMALL_STATE(3510)] = 87809,
  [SMALL_STATE(3511)] = 87867,
  [SMALL_STATE(3512)] = 87925,
  [SMALL_STATE(3513)] = 87983,
  [SMALL_STATE(3514)] = 88041,
  [SMALL_STATE(3515)] = 88099,
  [SMALL_STATE(3516)] = 88199,
  [SMALL_STATE(3517)] = 88257,
  [SMALL_STATE(3518)] = 88355,
  [SMALL_STATE(3519)] = 88413,
  [SMALL_STATE(3520)] = 88471,
  [SMALL_STATE(3521)] = 88529,
  [SMALL_STATE(3522)] = 88587,
  [SMALL_STATE(3523)] = 88645,
  [SMALL_STATE(3524)] = 88703,
  [SMALL_STATE(3525)] = 88761,
  [SMALL_STATE(3526)] = 88819,
  [SMALL_STATE(3527)] = 88877,
  [SMALL_STATE(3528)] = 88935,
  [SMALL_STATE(3529)] = 88993,
  [SMALL_STATE(3530)] = 89051,
  [SMALL_STATE(3531)] = 89109,
  [SMALL_STATE(3532)] = 89203,
  [SMALL_STATE(3533)] = 89293,
  [SMALL_STATE(3534)] = 89379,
  [SMALL_STATE(3535)] = 89437,
  [SMALL_STATE(3536)] = 89521,
  [SMALL_STATE(3537)] = 89579,
  [SMALL_STATE(3538)] = 89637,
  [SMALL_STATE(3539)] = 89717,
  [SMALL_STATE(3540)] = 89775,
  [SMALL_STATE(3541)] = 89851,
  [SMALL_STATE(3542)] = 89929,
  [SMALL_STATE(3543)] = 90031,
  [SMALL_STATE(3544)] = 90091,
  [SMALL_STATE(3545)] = 90149,
  [SMALL_STATE(3546)] = 90207,
  [SMALL_STATE(3547)] = 90265,
  [SMALL_STATE(3548)] = 90323,
  [SMALL_STATE(3549)] = 90381,
  [SMALL_STATE(3550)] = 90453,
  [SMALL_STATE(3551)] = 90511,
  [SMALL_STATE(3552)] = 90569,
  [SMALL_STATE(3553)] = 90627,
  [SMALL_STATE(3554)] = 90685,
  [SMALL_STATE(3555)] = 90743,
  [SMALL_STATE(3556)] = 90809,
  [SMALL_STATE(3557)] = 90867,
  [SMALL_STATE(3558)] = 90925,
  [SMALL_STATE(3559)] = 90983,
  [SMALL_STATE(3560)] = 91045,
  [SMALL_STATE(3561)] = 91103,
  [SMALL_STATE(3562)] = 91161,
  [SMALL_STATE(3563)] = 91219,
  [SMALL_STATE(3564)] = 91277,
  [SMALL_STATE(3565)] = 91335,
  [SMALL_STATE(3566)] = 91393,
  [SMALL_STATE(3567)] = 91451,
  [SMALL_STATE(3568)] = 91509,
  [SMALL_STATE(3569)] = 91567,
  [SMALL_STATE(3570)] = 91625,
  [SMALL_STATE(3571)] = 91683,
  [SMALL_STATE(3572)] = 91741,
  [SMALL_STATE(3573)] = 91799,
  [SMALL_STATE(3574)] = 91861,
  [SMALL_STATE(3575)] = 91919,
  [SMALL_STATE(3576)] = 91977,
  [SMALL_STATE(3577)] = 92035,
  [SMALL_STATE(3578)] = 92093,
  [SMALL_STATE(3579)] = 92163,
  [SMALL_STATE(3580)] = 92221,
  [SMALL_STATE(3581)] = 92323,
  [SMALL_STATE(3582)] = 92385,
  [SMALL_STATE(3583)] = 92459,
  [SMALL_STATE(3584)] = 92565,
  [SMALL_STATE(3585)] = 92623,
  [SMALL_STATE(3586)] = 92681,
  [SMALL_STATE(3587)] = 92741,
  [SMALL_STATE(3588)] = 92799,
  [SMALL_STATE(3589)] = 92857,
  [SMALL_STATE(3590)] = 92915,
  [SMALL_STATE(3591)] = 92973,
  [SMALL_STATE(3592)] = 93031,
  [SMALL_STATE(3593)] = 93133,
  [SMALL_STATE(3594)] = 93191,
  [SMALL_STATE(3595)] = 93297,
  [SMALL_STATE(3596)] = 93355,
  [SMALL_STATE(3597)] = 93413,
  [SMALL_STATE(3598)] = 93471,
  [SMALL_STATE(3599)] = 93529,
  [SMALL_STATE(3600)] = 93601,
  [SMALL_STATE(3601)] = 93673,
  [SMALL_STATE(3602)] = 93743,
  [SMALL_STATE(3603)] = 93805,
  [SMALL_STATE(3604)] = 93907,
  [SMALL_STATE(3605)] = 93965,
  [SMALL_STATE(3606)] = 94023,
  [SMALL_STATE(3607)] = 94081,
  [SMALL_STATE(3608)] = 94139,
  [SMALL_STATE(3609)] = 94209,
  [SMALL_STATE(3610)] = 94273,
  [SMALL_STATE(3611)] = 94331,
  [SMALL_STATE(3612)] = 94395,
  [SMALL_STATE(3613)] = 94455,
  [SMALL_STATE(3614)] = 94519,
  [SMALL_STATE(3615)] = 94577,
  [SMALL_STATE(3616)] = 94641,
  [SMALL_STATE(3617)] = 94705,
  [SMALL_STATE(3618)] = 94769,
  [SMALL_STATE(3619)] = 94833,
  [SMALL_STATE(3620)] = 94897,
  [SMALL_STATE(3621)] = 94961,
  [SMALL_STATE(3622)] = 95025,
  [SMALL_STATE(3623)] = 95089,
  [SMALL_STATE(3624)] = 95153,
  [SMALL_STATE(3625)] = 95213,
  [SMALL_STATE(3626)] = 95283,
  [SMALL_STATE(3627)] = 95341,
  [SMALL_STATE(3628)] = 95399,
  [SMALL_STATE(3629)] = 95457,
  [SMALL_STATE(3630)] = 95519,
  [SMALL_STATE(3631)] = 95577,
  [SMALL_STATE(3632)] = 95683,
  [SMALL_STATE(3633)] = 95745,
  [SMALL_STATE(3634)] = 95803,
  [SMALL_STATE(3635)] = 95861,
  [SMALL_STATE(3636)] = 95919,
  [SMALL_STATE(3637)] = 95977,
  [SMALL_STATE(3638)] = 96035,
  [SMALL_STATE(3639)] = 96093,
  [SMALL_STATE(3640)] = 96151,
  [SMALL_STATE(3641)] = 96209,
  [SMALL_STATE(3642)] = 96267,
  [SMALL_STATE(3643)] = 96325,
  [SMALL_STATE(3644)] = 96385,
  [SMALL_STATE(3645)] = 96443,
  [SMALL_STATE(3646)] = 96509,
  [SMALL_STATE(3647)] = 96567,
  [SMALL_STATE(3648)] = 96625,
  [SMALL_STATE(3649)] = 96683,
  [SMALL_STATE(3650)] = 96745,
  [SMALL_STATE(3651)] = 96803,
  [SMALL_STATE(3652)] = 96862,
  [SMALL_STATE(3653)] = 96965,
  [SMALL_STATE(3654)] = 97034,
  [SMALL_STATE(3655)] = 97091,
  [SMALL_STATE(3656)] = 97162,
  [SMALL_STATE(3657)] = 97223,
  [SMALL_STATE(3658)] = 97326,
  [SMALL_STATE(3659)] = 97383,
  [SMALL_STATE(3660)] = 97440,
  [SMALL_STATE(3661)] = 97543,
  [SMALL_STATE(3662)] = 97600,
  [SMALL_STATE(3663)] = 97663,
  [SMALL_STATE(3664)] = 97766,
  [SMALL_STATE(3665)] = 97825,
  [SMALL_STATE(3666)] = 97928,
  [SMALL_STATE(3667)] = 98031,
  [SMALL_STATE(3668)] = 98134,
  [SMALL_STATE(3669)] = 98237,
  [SMALL_STATE(3670)] = 98340,
  [SMALL_STATE(3671)] = 98401,
  [SMALL_STATE(3672)] = 98504,
  [SMALL_STATE(3673)] = 98607,
  [SMALL_STATE(3674)] = 98710,
  [SMALL_STATE(3675)] = 98767,
  [SMALL_STATE(3676)] = 98838,
  [SMALL_STATE(3677)] = 98941,
  [SMALL_STATE(3678)] = 99044,
  [SMALL_STATE(3679)] = 99147,
  [SMALL_STATE(3680)] = 99204,
  [SMALL_STATE(3681)] = 99307,
  [SMALL_STATE(3682)] = 99410,
  [SMALL_STATE(3683)] = 99513,
  [SMALL_STATE(3684)] = 99616,
  [SMALL_STATE(3685)] = 99719,
  [SMALL_STATE(3686)] = 99822,
  [SMALL_STATE(3687)] = 99925,
  [SMALL_STATE(3688)] = 100028,
  [SMALL_STATE(3689)] = 100131,
  [SMALL_STATE(3690)] = 100234,
  [SMALL_STATE(3691)] = 100337,
  [SMALL_STATE(3692)] = 100440,
  [SMALL_STATE(3693)] = 100543,
  [SMALL_STATE(3694)] = 100646,
  [SMALL_STATE(3695)] = 100749,
  [SMALL_STATE(3696)] = 100852,
  [SMALL_STATE(3697)] = 100915,
  [SMALL_STATE(3698)] = 100972,
  [SMALL_STATE(3699)] = 101075,
  [SMALL_STATE(3700)] = 101146,
  [SMALL_STATE(3701)] = 101249,
  [SMALL_STATE(3702)] = 101352,
  [SMALL_STATE(3703)] = 101409,
  [SMALL_STATE(3704)] = 101512,
  [SMALL_STATE(3705)] = 101615,
  [SMALL_STATE(3706)] = 101718,
  [SMALL_STATE(3707)] = 101787,
  [SMALL_STATE(3708)] = 101890,
  [SMALL_STATE(3709)] = 101993,
  [SMALL_STATE(3710)] = 102096,
  [SMALL_STATE(3711)] = 102199,
  [SMALL_STATE(3712)] = 102256,
  [SMALL_STATE(3713)] = 102351,
  [SMALL_STATE(3714)] = 102408,
  [SMALL_STATE(3715)] = 102465,
  [SMALL_STATE(3716)] = 102560,
  [SMALL_STATE(3717)] = 102617,
  [SMALL_STATE(3718)] = 102680,
  [SMALL_STATE(3719)] = 102783,
  [SMALL_STATE(3720)] = 102886,
  [SMALL_STATE(3721)] = 102943,
  [SMALL_STATE(3722)] = 103000,
  [SMALL_STATE(3723)] = 103103,
  [SMALL_STATE(3724)] = 103206,
  [SMALL_STATE(3725)] = 103309,
  [SMALL_STATE(3726)] = 103412,
  [SMALL_STATE(3727)] = 103515,
  [SMALL_STATE(3728)] = 103586,
  [SMALL_STATE(3729)] = 103689,
  [SMALL_STATE(3730)] = 103792,
  [SMALL_STATE(3731)] = 103895,
  [SMALL_STATE(3732)] = 103998,
  [SMALL_STATE(3733)] = 104101,
  [SMALL_STATE(3734)] = 104204,
  [SMALL_STATE(3735)] = 104307,
  [SMALL_STATE(3736)] = 104410,
  [SMALL_STATE(3737)] = 104513,
  [SMALL_STATE(3738)] = 104616,
  [SMALL_STATE(3739)] = 104719,
  [SMALL_STATE(3740)] = 104822,
  [SMALL_STATE(3741)] = 104925,
  [SMALL_STATE(3742)] = 105028,
  [SMALL_STATE(3743)] = 105089,
  [SMALL_STATE(3744)] = 105146,
  [SMALL_STATE(3745)] = 105211,
  [SMALL_STATE(3746)] = 105314,
  [SMALL_STATE(3747)] = 105377,
  [SMALL_STATE(3748)] = 105480,
  [SMALL_STATE(3749)] = 105583,
  [SMALL_STATE(3750)] = 105686,
  [SMALL_STATE(3751)] = 105789,
  [SMALL_STATE(3752)] = 105892,
  [SMALL_STATE(3753)] = 105995,
  [SMALL_STATE(3754)] = 106098,
  [SMALL_STATE(3755)] = 106201,
  [SMALL_STATE(3756)] = 106304,
  [SMALL_STATE(3757)] = 106360,
  [SMALL_STATE(3758)] = 106416,
  [SMALL_STATE(3759)] = 106516,
  [SMALL_STATE(3760)] = 106572,
  [SMALL_STATE(3761)] = 106628,
  [SMALL_STATE(3762)] = 106684,
  [SMALL_STATE(3763)] = 106740,
  [SMALL_STATE(3764)] = 106796,
  [SMALL_STATE(3765)] = 106852,
  [SMALL_STATE(3766)] = 106924,
  [SMALL_STATE(3767)] = 107024,
  [SMALL_STATE(3768)] = 107080,
  [SMALL_STATE(3769)] = 107180,
  [SMALL_STATE(3770)] = 107236,
  [SMALL_STATE(3771)] = 107336,
  [SMALL_STATE(3772)] = 107392,
  [SMALL_STATE(3773)] = 107448,
  [SMALL_STATE(3774)] = 107504,
  [SMALL_STATE(3775)] = 107560,
  [SMALL_STATE(3776)] = 107616,
  [SMALL_STATE(3777)] = 107672,
  [SMALL_STATE(3778)] = 107728,
  [SMALL_STATE(3779)] = 107784,
  [SMALL_STATE(3780)] = 107840,
  [SMALL_STATE(3781)] = 107896,
  [SMALL_STATE(3782)] = 107996,
  [SMALL_STATE(3783)] = 108056,
  [SMALL_STATE(3784)] = 108112,
  [SMALL_STATE(3785)] = 108168,
  [SMALL_STATE(3786)] = 108224,
  [SMALL_STATE(3787)] = 108280,
  [SMALL_STATE(3788)] = 108336,
  [SMALL_STATE(3789)] = 108392,
  [SMALL_STATE(3790)] = 108448,
  [SMALL_STATE(3791)] = 108504,
  [SMALL_STATE(3792)] = 108560,
  [SMALL_STATE(3793)] = 108624,
  [SMALL_STATE(3794)] = 108680,
  [SMALL_STATE(3795)] = 108752,
  [SMALL_STATE(3796)] = 108808,
  [SMALL_STATE(3797)] = 108864,
  [SMALL_STATE(3798)] = 108920,
  [SMALL_STATE(3799)] = 109020,
  [SMALL_STATE(3800)] = 109084,
  [SMALL_STATE(3801)] = 109140,
  [SMALL_STATE(3802)] = 109196,
  [SMALL_STATE(3803)] = 109252,
  [SMALL_STATE(3804)] = 109352,
  [SMALL_STATE(3805)] = 109408,
  [SMALL_STATE(3806)] = 109464,
  [SMALL_STATE(3807)] = 109536,
  [SMALL_STATE(3808)] = 109592,
  [SMALL_STATE(3809)] = 109648,
  [SMALL_STATE(3810)] = 109748,
  [SMALL_STATE(3811)] = 109804,
  [SMALL_STATE(3812)] = 109904,
  [SMALL_STATE(3813)] = 109960,
  [SMALL_STATE(3814)] = 110016,
  [SMALL_STATE(3815)] = 110072,
  [SMALL_STATE(3816)] = 110128,
  [SMALL_STATE(3817)] = 110184,
  [SMALL_STATE(3818)] = 110240,
  [SMALL_STATE(3819)] = 110296,
  [SMALL_STATE(3820)] = 110352,
  [SMALL_STATE(3821)] = 110446,
  [SMALL_STATE(3822)] = 110502,
  [SMALL_STATE(3823)] = 110558,
  [SMALL_STATE(3824)] = 110616,
  [SMALL_STATE(3825)] = 110672,
  [SMALL_STATE(3826)] = 110728,
  [SMALL_STATE(3827)] = 110784,
  [SMALL_STATE(3828)] = 110840,
  [SMALL_STATE(3829)] = 110896,
  [SMALL_STATE(3830)] = 110952,
  [SMALL_STATE(3831)] = 111008,
  [SMALL_STATE(3832)] = 111108,
  [SMALL_STATE(3833)] = 111164,
  [SMALL_STATE(3834)] = 111220,
  [SMALL_STATE(3835)] = 111276,
  [SMALL_STATE(3836)] = 111332,
  [SMALL_STATE(3837)] = 111388,
  [SMALL_STATE(3838)] = 111444,
  [SMALL_STATE(3839)] = 111500,
  [SMALL_STATE(3840)] = 111556,
  [SMALL_STATE(3841)] = 111612,
  [SMALL_STATE(3842)] = 111668,
  [SMALL_STATE(3843)] = 111724,
  [SMALL_STATE(3844)] = 111780,
  [SMALL_STATE(3845)] = 111850,
  [SMALL_STATE(3846)] = 111950,
  [SMALL_STATE(3847)] = 112020,
  [SMALL_STATE(3848)] = 112090,
  [SMALL_STATE(3849)] = 112146,
  [SMALL_STATE(3850)] = 112212,
  [SMALL_STATE(3851)] = 112268,
  [SMALL_STATE(3852)] = 112332,
  [SMALL_STATE(3853)] = 112432,
  [SMALL_STATE(3854)] = 112488,
  [SMALL_STATE(3855)] = 112588,
  [SMALL_STATE(3856)] = 112688,
  [SMALL_STATE(3857)] = 112788,
  [SMALL_STATE(3858)] = 112844,
  [SMALL_STATE(3859)] = 112900,
  [SMALL_STATE(3860)] = 112956,
  [SMALL_STATE(3861)] = 113056,
  [SMALL_STATE(3862)] = 113112,
  [SMALL_STATE(3863)] = 113212,
  [SMALL_STATE(3864)] = 113268,
  [SMALL_STATE(3865)] = 113324,
  [SMALL_STATE(3866)] = 113380,
  [SMALL_STATE(3867)] = 113472,
  [SMALL_STATE(3868)] = 113572,
  [SMALL_STATE(3869)] = 113628,
  [SMALL_STATE(3870)] = 113684,
  [SMALL_STATE(3871)] = 113740,
  [SMALL_STATE(3872)] = 113796,
  [SMALL_STATE(3873)] = 113868,
  [SMALL_STATE(3874)] = 113924,
  [SMALL_STATE(3875)] = 113980,
  [SMALL_STATE(3876)] = 114044,
  [SMALL_STATE(3877)] = 114144,
  [SMALL_STATE(3878)] = 114236,
  [SMALL_STATE(3879)] = 114292,
  [SMALL_STATE(3880)] = 114386,
  [SMALL_STATE(3881)] = 114442,
  [SMALL_STATE(3882)] = 114533,
  [SMALL_STATE(3883)] = 114592,
  [SMALL_STATE(3884)] = 114661,
  [SMALL_STATE(3885)] = 114754,
  [SMALL_STATE(3886)] = 114847,
  [SMALL_STATE(3887)] = 114940,
  [SMALL_STATE(3888)] = 115033,
  [SMALL_STATE(3889)] = 115126,
  [SMALL_STATE(3890)] = 115185,
  [SMALL_STATE(3891)] = 115278,
  [SMALL_STATE(3892)] = 115371,
  [SMALL_STATE(3893)] = 115480,
  [SMALL_STATE(3894)] = 115573,
  [SMALL_STATE(3895)] = 115628,
  [SMALL_STATE(3896)] = 115737,
  [SMALL_STATE(3897)] = 115792,
  [SMALL_STATE(3898)] = 115885,
  [SMALL_STATE(3899)] = 115978,
  [SMALL_STATE(3900)] = 116071,
  [SMALL_STATE(3901)] = 116164,
  [SMALL_STATE(3902)] = 116235,
  [SMALL_STATE(3903)] = 116290,
  [SMALL_STATE(3904)] = 116381,
  [SMALL_STATE(3905)] = 116452,
  [SMALL_STATE(3906)] = 116523,
  [SMALL_STATE(3907)] = 116582,
  [SMALL_STATE(3908)] = 116641,
  [SMALL_STATE(3909)] = 116700,
  [SMALL_STATE(3910)] = 116771,
  [SMALL_STATE(3911)] = 116864,
  [SMALL_STATE(3912)] = 116923,
  [SMALL_STATE(3913)] = 117016,
  [SMALL_STATE(3914)] = 117077,
  [SMALL_STATE(3915)] = 117170,
  [SMALL_STATE(3916)] = 117225,
  [SMALL_STATE(3917)] = 117318,
  [SMALL_STATE(3918)] = 117377,
  [SMALL_STATE(3919)] = 117448,
  [SMALL_STATE(3920)] = 117507,
  [SMALL_STATE(3921)] = 117566,
  [SMALL_STATE(3922)] = 117637,
  [SMALL_STATE(3923)] = 117708,
  [SMALL_STATE(3924)] = 117801,
  [SMALL_STATE(3925)] = 117860,
  [SMALL_STATE(3926)] = 117919,
  [SMALL_STATE(3927)] = 118012,
  [SMALL_STATE(3928)] = 118105,
  [SMALL_STATE(3929)] = 118174,
  [SMALL_STATE(3930)] = 118267,
  [SMALL_STATE(3931)] = 118326,
  [SMALL_STATE(3932)] = 118419,
  [SMALL_STATE(3933)] = 118507,
  [SMALL_STATE(3934)] = 118599,
  [SMALL_STATE(3935)] = 118653,
  [SMALL_STATE(3936)] = 118745,
  [SMALL_STATE(3937)] = 118835,
  [SMALL_STATE(3938)] = 118925,
  [SMALL_STATE(3939)] = 118979,
  [SMALL_STATE(3940)] = 119039,
  [SMALL_STATE(3941)] = 119127,
  [SMALL_STATE(3942)] = 119191,
  [SMALL_STATE(3943)] = 119245,
  [SMALL_STATE(3944)] = 119299,
  [SMALL_STATE(3945)] = 119359,
  [SMALL_STATE(3946)] = 119447,
  [SMALL_STATE(3947)] = 119501,
  [SMALL_STATE(3948)] = 119569,
  [SMALL_STATE(3949)] = 119661,
  [SMALL_STATE(3950)] = 119725,
  [SMALL_STATE(3951)] = 119779,
  [SMALL_STATE(3952)] = 119839,
  [SMALL_STATE(3953)] = 119899,
  [SMALL_STATE(3954)] = 119987,
  [SMALL_STATE(3955)] = 120047,
  [SMALL_STATE(3956)] = 120107,
  [SMALL_STATE(3957)] = 120161,
  [SMALL_STATE(3958)] = 120249,
  [SMALL_STATE(3959)] = 120337,
  [SMALL_STATE(3960)] = 120429,
  [SMALL_STATE(3961)] = 120483,
  [SMALL_STATE(3962)] = 120573,
  [SMALL_STATE(3963)] = 120663,
  [SMALL_STATE(3964)] = 120752,
  [SMALL_STATE(3965)] = 120841,
  [SMALL_STATE(3966)] = 120924,
  [SMALL_STATE(3967)] = 121013,
  [SMALL_STATE(3968)] = 121102,
  [SMALL_STATE(3969)] = 121191,
  [SMALL_STATE(3970)] = 121280,
  [SMALL_STATE(3971)] = 121333,
  [SMALL_STATE(3972)] = 121422,
  [SMALL_STATE(3973)] = 121505,
  [SMALL_STATE(3974)] = 121594,
  [SMALL_STATE(3975)] = 121683,
  [SMALL_STATE(3976)] = 121772,
  [SMALL_STATE(3977)] = 121861,
  [SMALL_STATE(3978)] = 121950,
  [SMALL_STATE(3979)] = 122039,
  [SMALL_STATE(3980)] = 122128,
  [SMALL_STATE(3981)] = 122187,
  [SMALL_STATE(3982)] = 122254,
  [SMALL_STATE(3983)] = 122321,
  [SMALL_STATE(3984)] = 122410,
  [SMALL_STATE(3985)] = 122499,
  [SMALL_STATE(3986)] = 122588,
  [SMALL_STATE(3987)] = 122677,
  [SMALL_STATE(3988)] = 122766,
  [SMALL_STATE(3989)] = 122831,
  [SMALL_STATE(3990)] = 122920,
  [SMALL_STATE(3991)] = 122975,
  [SMALL_STATE(3992)] = 123034,
  [SMALL_STATE(3993)] = 123123,
  [SMALL_STATE(3994)] = 123212,
  [SMALL_STATE(3995)] = 123301,
  [SMALL_STATE(3996)] = 123390,
  [SMALL_STATE(3997)] = 123453,
  [SMALL_STATE(3998)] = 123542,
  [SMALL_STATE(3999)] = 123595,
  [SMALL_STATE(4000)] = 123684,
  [SMALL_STATE(4001)] = 123737,
  [SMALL_STATE(4002)] = 123826,
  [SMALL_STATE(4003)] = 123915,
  [SMALL_STATE(4004)] = 123974,
  [SMALL_STATE(4005)] = 124073,
  [SMALL_STATE(4006)] = 124162,
  [SMALL_STATE(4007)] = 124225,
  [SMALL_STATE(4008)] = 124314,
  [SMALL_STATE(4009)] = 124403,
  [SMALL_STATE(4010)] = 124492,
  [SMALL_STATE(4011)] = 124544,
  [SMALL_STATE(4012)] = 124596,
  [SMALL_STATE(4013)] = 124654,
  [SMALL_STATE(4014)] = 124722,
  [SMALL_STATE(4015)] = 124790,
  [SMALL_STATE(4016)] = 124878,
  [SMALL_STATE(4017)] = 124930,
  [SMALL_STATE(4018)] = 125018,
  [SMALL_STATE(4019)] = 125070,
  [SMALL_STATE(4020)] = 125134,
  [SMALL_STATE(4021)] = 125186,
  [SMALL_STATE(4022)] = 125238,
  [SMALL_STATE(4023)] = 125290,
  [SMALL_STATE(4024)] = 125342,
  [SMALL_STATE(4025)] = 125394,
  [SMALL_STATE(4026)] = 125446,
  [SMALL_STATE(4027)] = 125498,
  [SMALL_STATE(4028)] = 125566,
  [SMALL_STATE(4029)] = 125634,
  [SMALL_STATE(4030)] = 125686,
  [SMALL_STATE(4031)] = 125754,
  [SMALL_STATE(4032)] = 125806,
  [SMALL_STATE(4033)] = 125858,
  [SMALL_STATE(4034)] = 125922,
  [SMALL_STATE(4035)] = 125974,
  [SMALL_STATE(4036)] = 126026,
  [SMALL_STATE(4037)] = 126078,
  [SMALL_STATE(4038)] = 126130,
  [SMALL_STATE(4039)] = 126182,
  [SMALL_STATE(4040)] = 126234,
  [SMALL_STATE(4041)] = 126286,
  [SMALL_STATE(4042)] = 126354,
  [SMALL_STATE(4043)] = 126440,
  [SMALL_STATE(4044)] = 126496,
  [SMALL_STATE(4045)] = 126548,
  [SMALL_STATE(4046)] = 126600,
  [SMALL_STATE(4047)] = 126652,
  [SMALL_STATE(4048)] = 126704,
  [SMALL_STATE(4049)] = 126770,
  [SMALL_STATE(4050)] = 126822,
  [SMALL_STATE(4051)] = 126874,
  [SMALL_STATE(4052)] = 126926,
  [SMALL_STATE(4053)] = 127012,
  [SMALL_STATE(4054)] = 127064,
  [SMALL_STATE(4055)] = 127116,
  [SMALL_STATE(4056)] = 127168,
  [SMALL_STATE(4057)] = 127220,
  [SMALL_STATE(4058)] = 127272,
  [SMALL_STATE(4059)] = 127324,
  [SMALL_STATE(4060)] = 127376,
  [SMALL_STATE(4061)] = 127428,
  [SMALL_STATE(4062)] = 127480,
  [SMALL_STATE(4063)] = 127532,
  [SMALL_STATE(4064)] = 127623,
  [SMALL_STATE(4065)] = 127698,
  [SMALL_STATE(4066)] = 127783,
  [SMALL_STATE(4067)] = 127868,
  [SMALL_STATE(4068)] = 127935,
  [SMALL_STATE(4069)] = 128018,
  [SMALL_STATE(4070)] = 128075,
  [SMALL_STATE(4071)] = 128136,
  [SMALL_STATE(4072)] = 128223,
  [SMALL_STATE(4073)] = 128282,
  [SMALL_STATE(4074)] = 128333,
  [SMALL_STATE(4075)] = 128412,
  [SMALL_STATE(4076)] = 128491,
  [SMALL_STATE(4077)] = 128562,
  [SMALL_STATE(4078)] = 128647,
  [SMALL_STATE(4079)] = 128732,
  [SMALL_STATE(4080)] = 128817,
  [SMALL_STATE(4081)] = 128902,
  [SMALL_STATE(4082)] = 128953,
  [SMALL_STATE(4083)] = 129052,
  [SMALL_STATE(4084)] = 129125,
  [SMALL_STATE(4085)] = 129218,
  [SMALL_STATE(4086)] = 129303,
  [SMALL_STATE(4087)] = 129402,
  [SMALL_STATE(4088)] = 129501,
  [SMALL_STATE(4089)] = 129568,
  [SMALL_STATE(4090)] = 129653,
  [SMALL_STATE(4091)] = 129756,
  [SMALL_STATE(4092)] = 129835,
  [SMALL_STATE(4093)] = 129914,
  [SMALL_STATE(4094)] = 129971,
  [SMALL_STATE(4095)] = 130030,
  [SMALL_STATE(4096)] = 130109,
  [SMALL_STATE(4097)] = 130166,
  [SMALL_STATE(4098)] = 130245,
  [SMALL_STATE(4099)] = 130324,
  [SMALL_STATE(4100)] = 130427,
  [SMALL_STATE(4101)] = 130512,
  [SMALL_STATE(4102)] = 130607,
  [SMALL_STATE(4103)] = 130706,
  [SMALL_STATE(4104)] = 130763,
  [SMALL_STATE(4105)] = 130850,
  [SMALL_STATE(4106)] = 130949,
  [SMALL_STATE(4107)] = 131034,
  [SMALL_STATE(4108)] = 131121,
  [SMALL_STATE(4109)] = 131200,
  [SMALL_STATE(4110)] = 131279,
  [SMALL_STATE(4111)] = 131358,
  [SMALL_STATE(4112)] = 131447,
  [SMALL_STATE(4113)] = 131550,
  [SMALL_STATE(4114)] = 131635,
  [SMALL_STATE(4115)] = 131718,
  [SMALL_STATE(4116)] = 131801,
  [SMALL_STATE(4117)] = 131852,
  [SMALL_STATE(4118)] = 131955,
  [SMALL_STATE(4119)] = 132042,
  [SMALL_STATE(4120)] = 132111,
  [SMALL_STATE(4121)] = 132190,
  [SMALL_STATE(4122)] = 132257,
  [SMALL_STATE(4123)] = 132324,
  [SMALL_STATE(4124)] = 132403,
  [SMALL_STATE(4125)] = 132482,
  [SMALL_STATE(4126)] = 132536,
  [SMALL_STATE(4127)] = 132590,
  [SMALL_STATE(4128)] = 132642,
  [SMALL_STATE(4129)] = 132748,
  [SMALL_STATE(4130)] = 132802,
  [SMALL_STATE(4131)] = 132856,
  [SMALL_STATE(4132)] = 132910,
  [SMALL_STATE(4133)] = 132964,
  [SMALL_STATE(4134)] = 133018,
  [SMALL_STATE(4135)] = 133072,
  [SMALL_STATE(4136)] = 133126,
  [SMALL_STATE(4137)] = 133180,
  [SMALL_STATE(4138)] = 133234,
  [SMALL_STATE(4139)] = 133288,
  [SMALL_STATE(4140)] = 133342,
  [SMALL_STATE(4141)] = 133392,
  [SMALL_STATE(4142)] = 133478,
  [SMALL_STATE(4143)] = 133544,
  [SMALL_STATE(4144)] = 133630,
  [SMALL_STATE(4145)] = 133704,
  [SMALL_STATE(4146)] = 133770,
  [SMALL_STATE(4147)] = 133876,
  [SMALL_STATE(4148)] = 133936,
  [SMALL_STATE(4149)] = 133996,
  [SMALL_STATE(4150)] = 134056,
  [SMALL_STATE(4151)] = 134130,
  [SMALL_STATE(4152)] = 134236,
  [SMALL_STATE(4153)] = 134286,
  [SMALL_STATE(4154)] = 134346,
  [SMALL_STATE(4155)] = 134398,
  [SMALL_STATE(4156)] = 134472,
  [SMALL_STATE(4157)] = 134524,
  [SMALL_STATE(4158)] = 134606,
  [SMALL_STATE(4159)] = 134692,
  [SMALL_STATE(4160)] = 134778,
  [SMALL_STATE(4161)] = 134842,
  [SMALL_STATE(4162)] = 134906,
  [SMALL_STATE(4163)] = 134958,
  [SMALL_STATE(4164)] = 135040,
  [SMALL_STATE(4165)] = 135094,
  [SMALL_STATE(4166)] = 135143,
  [SMALL_STATE(4167)] = 135192,
  [SMALL_STATE(4168)] = 135257,
  [SMALL_STATE(4169)] = 135308,
  [SMALL_STATE(4170)] = 135357,
  [SMALL_STATE(4171)] = 135406,
  [SMALL_STATE(4172)] = 135455,
  [SMALL_STATE(4173)] = 135504,
  [SMALL_STATE(4174)] = 135553,
  [SMALL_STATE(4175)] = 135602,
  [SMALL_STATE(4176)] = 135693,
  [SMALL_STATE(4177)] = 135758,
  [SMALL_STATE(4178)] = 135825,
  [SMALL_STATE(4179)] = 135874,
  [SMALL_STATE(4180)] = 135929,
  [SMALL_STATE(4181)] = 135978,
  [SMALL_STATE(4182)] = 136059,
  [SMALL_STATE(4183)] = 136140,
  [SMALL_STATE(4184)] = 136189,
  [SMALL_STATE(4185)] = 136280,
  [SMALL_STATE(4186)] = 136329,
  [SMALL_STATE(4187)] = 136406,
  [SMALL_STATE(4188)] = 136483,
  [SMALL_STATE(4189)] = 136560,
  [SMALL_STATE(4190)] = 136641,
  [SMALL_STATE(4191)] = 136690,
  [SMALL_STATE(4192)] = 136743,
  [SMALL_STATE(4193)] = 136798,
  [SMALL_STATE(4194)] = 136879,
  [SMALL_STATE(4195)] = 136934,
  [SMALL_STATE(4196)] = 136983,
  [SMALL_STATE(4197)] = 137066,
  [SMALL_STATE(4198)] = 137115,
  [SMALL_STATE(4199)] = 137198,
  [SMALL_STATE(4200)] = 137281,
  [SMALL_STATE(4201)] = 137364,
  [SMALL_STATE(4202)] = 137413,
  [SMALL_STATE(4203)] = 137462,
  [SMALL_STATE(4204)] = 137511,
  [SMALL_STATE(4205)] = 137564,
  [SMALL_STATE(4206)] = 137613,
  [SMALL_STATE(4207)] = 137670,
  [SMALL_STATE(4208)] = 137723,
  [SMALL_STATE(4209)] = 137778,
  [SMALL_STATE(4210)] = 137827,
  [SMALL_STATE(4211)] = 137876,
  [SMALL_STATE(4212)] = 137953,
  [SMALL_STATE(4213)] = 138015,
  [SMALL_STATE(4214)] = 138085,
  [SMALL_STATE(4215)] = 138185,
  [SMALL_STATE(4216)] = 138279,
  [SMALL_STATE(4217)] = 138375,
  [SMALL_STATE(4218)] = 138433,
  [SMALL_STATE(4219)] = 138507,
  [SMALL_STATE(4220)] = 138569,
  [SMALL_STATE(4221)] = 138635,
  [SMALL_STATE(4222)] = 138719,
  [SMALL_STATE(4223)] = 138793,
  [SMALL_STATE(4224)] = 138851,
  [SMALL_STATE(4225)] = 138939,
  [SMALL_STATE(4226)] = 139025,
  [SMALL_STATE(4227)] = 139117,
  [SMALL_STATE(4228)] = 139165,
  [SMALL_STATE(4229)] = 139223,
  [SMALL_STATE(4230)] = 139319,
  [SMALL_STATE(4231)] = 139385,
  [SMALL_STATE(4232)] = 139475,
  [SMALL_STATE(4233)] = 139563,
  [SMALL_STATE(4234)] = 139659,
  [SMALL_STATE(4235)] = 139743,
  [SMALL_STATE(4236)] = 139833,
  [SMALL_STATE(4237)] = 139907,
  [SMALL_STATE(4238)] = 139987,
  [SMALL_STATE(4239)] = 140069,
  [SMALL_STATE(4240)] = 140149,
  [SMALL_STATE(4241)] = 140233,
  [SMALL_STATE(4242)] = 140309,
  [SMALL_STATE(4243)] = 140399,
  [SMALL_STATE(4244)] = 140471,
  [SMALL_STATE(4245)] = 140539,
  [SMALL_STATE(4246)] = 140609,
  [SMALL_STATE(4247)] = 140667,
  [SMALL_STATE(4248)] = 140757,
  [SMALL_STATE(4249)] = 140851,
  [SMALL_STATE(4250)] = 140943,
  [SMALL_STATE(4251)] = 141035,
  [SMALL_STATE(4252)] = 141127,
  [SMALL_STATE(4253)] = 141223,
  [SMALL_STATE(4254)] = 141313,
  [SMALL_STATE(4255)] = 141361,
  [SMALL_STATE(4256)] = 141453,
  [SMALL_STATE(4257)] = 141537,
  [SMALL_STATE(4258)] = 141613,
  [SMALL_STATE(4259)] = 141689,
  [SMALL_STATE(4260)] = 141765,
  [SMALL_STATE(4261)] = 141841,
  [SMALL_STATE(4262)] = 141931,
  [SMALL_STATE(4263)] = 141979,
  [SMALL_STATE(4264)] = 142061,
  [SMALL_STATE(4265)] = 142157,
  [SMALL_STATE(4266)] = 142235,
  [SMALL_STATE(4267)] = 142283,
  [SMALL_STATE(4268)] = 142357,
  [SMALL_STATE(4269)] = 142437,
  [SMALL_STATE(4270)] = 142517,
  [SMALL_STATE(4271)] = 142611,
  [SMALL_STATE(4272)] = 142687,
  [SMALL_STATE(4273)] = 142759,
  [SMALL_STATE(4274)] = 142827,
  [SMALL_STATE(4275)] = 142875,
  [SMALL_STATE(4276)] = 142953,
  [SMALL_STATE(4277)] = 143050,
  [SMALL_STATE(4278)] = 143147,
  [SMALL_STATE(4279)] = 143244,
  [SMALL_STATE(4280)] = 143291,
  [SMALL_STATE(4281)] = 143388,
  [SMALL_STATE(4282)] = 143485,
  [SMALL_STATE(4283)] = 143582,
  [SMALL_STATE(4284)] = 143635,
  [SMALL_STATE(4285)] = 143682,
  [SMALL_STATE(4286)] = 143731,
  [SMALL_STATE(4287)] = 143828,
  [SMALL_STATE(4288)] = 143875,
  [SMALL_STATE(4289)] = 143922,
  [SMALL_STATE(4290)] = 143969,
  [SMALL_STATE(4291)] = 144016,
  [SMALL_STATE(4292)] = 144063,
  [SMALL_STATE(4293)] = 144110,
  [SMALL_STATE(4294)] = 144207,
  [SMALL_STATE(4295)] = 144304,
  [SMALL_STATE(4296)] = 144401,
  [SMALL_STATE(4297)] = 144498,
  [SMALL_STATE(4298)] = 144545,
  [SMALL_STATE(4299)] = 144610,
  [SMALL_STATE(4300)] = 144707,
  [SMALL_STATE(4301)] = 144804,
  [SMALL_STATE(4302)] = 144901,
  [SMALL_STATE(4303)] = 144998,
  [SMALL_STATE(4304)] = 145093,
  [SMALL_STATE(4305)] = 145190,
  [SMALL_STATE(4306)] = 145287,
  [SMALL_STATE(4307)] = 145334,
  [SMALL_STATE(4308)] = 145387,
  [SMALL_STATE(4309)] = 145444,
  [SMALL_STATE(4310)] = 145541,
  [SMALL_STATE(4311)] = 145638,
  [SMALL_STATE(4312)] = 145691,
  [SMALL_STATE(4313)] = 145786,
  [SMALL_STATE(4314)] = 145859,
  [SMALL_STATE(4315)] = 145956,
  [SMALL_STATE(4316)] = 146053,
  [SMALL_STATE(4317)] = 146150,
  [SMALL_STATE(4318)] = 146247,
  [SMALL_STATE(4319)] = 146344,
  [SMALL_STATE(4320)] = 146401,
  [SMALL_STATE(4321)] = 146498,
  [SMALL_STATE(4322)] = 146595,
  [SMALL_STATE(4323)] = 146692,
  [SMALL_STATE(4324)] = 146789,
  [SMALL_STATE(4325)] = 146886,
  [SMALL_STATE(4326)] = 146983,
  [SMALL_STATE(4327)] = 147080,
  [SMALL_STATE(4328)] = 147129,
  [SMALL_STATE(4329)] = 147182,
  [SMALL_STATE(4330)] = 147233,
  [SMALL_STATE(4331)] = 147330,
  [SMALL_STATE(4332)] = 147427,
  [SMALL_STATE(4333)] = 147484,
  [SMALL_STATE(4334)] = 147535,
  [SMALL_STATE(4335)] = 147584,
  [SMALL_STATE(4336)] = 147635,
  [SMALL_STATE(4337)] = 147686,
  [SMALL_STATE(4338)] = 147737,
  [SMALL_STATE(4339)] = 147788,
  [SMALL_STATE(4340)] = 147885,
  [SMALL_STATE(4341)] = 147936,
  [SMALL_STATE(4342)] = 148033,
  [SMALL_STATE(4343)] = 148130,
  [SMALL_STATE(4344)] = 148181,
  [SMALL_STATE(4345)] = 148278,
  [SMALL_STATE(4346)] = 148327,
  [SMALL_STATE(4347)] = 148380,
  [SMALL_STATE(4348)] = 148453,
  [SMALL_STATE(4349)] = 148550,
  [SMALL_STATE(4350)] = 148647,
  [SMALL_STATE(4351)] = 148698,
  [SMALL_STATE(4352)] = 148777,
  [SMALL_STATE(4353)] = 148856,
  [SMALL_STATE(4354)] = 148907,
  [SMALL_STATE(4355)] = 148958,
  [SMALL_STATE(4356)] = 149055,
  [SMALL_STATE(4357)] = 149106,
  [SMALL_STATE(4358)] = 149179,
  [SMALL_STATE(4359)] = 149230,
  [SMALL_STATE(4360)] = 149279,
  [SMALL_STATE(4361)] = 149352,
  [SMALL_STATE(4362)] = 149405,
  [SMALL_STATE(4363)] = 149502,
  [SMALL_STATE(4364)] = 149599,
  [SMALL_STATE(4365)] = 149687,
  [SMALL_STATE(4366)] = 149775,
  [SMALL_STATE(4367)] = 149835,
  [SMALL_STATE(4368)] = 149893,
  [SMALL_STATE(4369)] = 149987,
  [SMALL_STATE(4370)] = 150081,
  [SMALL_STATE(4371)] = 150129,
  [SMALL_STATE(4372)] = 150223,
  [SMALL_STATE(4373)] = 150311,
  [SMALL_STATE(4374)] = 150405,
  [SMALL_STATE(4375)] = 150499,
  [SMALL_STATE(4376)] = 150551,
  [SMALL_STATE(4377)] = 150645,
  [SMALL_STATE(4378)] = 150737,
  [SMALL_STATE(4379)] = 150831,
  [SMALL_STATE(4380)] = 150919,
  [SMALL_STATE(4381)] = 151013,
  [SMALL_STATE(4382)] = 151063,
  [SMALL_STATE(4383)] = 151155,
  [SMALL_STATE(4384)] = 151247,
  [SMALL_STATE(4385)] = 151325,
  [SMALL_STATE(4386)] = 151377,
  [SMALL_STATE(4387)] = 151469,
  [SMALL_STATE(4388)] = 151563,
  [SMALL_STATE(4389)] = 151657,
  [SMALL_STATE(4390)] = 151729,
  [SMALL_STATE(4391)] = 151823,
  [SMALL_STATE(4392)] = 151895,
  [SMALL_STATE(4393)] = 151967,
  [SMALL_STATE(4394)] = 152039,
  [SMALL_STATE(4395)] = 152091,
  [SMALL_STATE(4396)] = 152183,
  [SMALL_STATE(4397)] = 152243,
  [SMALL_STATE(4398)] = 152337,
  [SMALL_STATE(4399)] = 152431,
  [SMALL_STATE(4400)] = 152525,
  [SMALL_STATE(4401)] = 152619,
  [SMALL_STATE(4402)] = 152713,
  [SMALL_STATE(4403)] = 152807,
  [SMALL_STATE(4404)] = 152879,
  [SMALL_STATE(4405)] = 152973,
  [SMALL_STATE(4406)] = 153067,
  [SMALL_STATE(4407)] = 153139,
  [SMALL_STATE(4408)] = 153211,
  [SMALL_STATE(4409)] = 153271,
  [SMALL_STATE(4410)] = 153343,
  [SMALL_STATE(4411)] = 153395,
  [SMALL_STATE(4412)] = 153489,
  [SMALL_STATE(4413)] = 153583,
  [SMALL_STATE(4414)] = 153671,
  [SMALL_STATE(4415)] = 153745,
  [SMALL_STATE(4416)] = 153791,
  [SMALL_STATE(4417)] = 153885,
  [SMALL_STATE(4418)] = 153959,
  [SMALL_STATE(4419)] = 154033,
  [SMALL_STATE(4420)] = 154107,
  [SMALL_STATE(4421)] = 154199,
  [SMALL_STATE(4422)] = 154293,
  [SMALL_STATE(4423)] = 154367,
  [SMALL_STATE(4424)] = 154459,
  [SMALL_STATE(4425)] = 154553,
  [SMALL_STATE(4426)] = 154627,
  [SMALL_STATE(4427)] = 154701,
  [SMALL_STATE(4428)] = 154753,
  [SMALL_STATE(4429)] = 154827,
  [SMALL_STATE(4430)] = 154879,
  [SMALL_STATE(4431)] = 154971,
  [SMALL_STATE(4432)] = 155023,
  [SMALL_STATE(4433)] = 155115,
  [SMALL_STATE(4434)] = 155209,
  [SMALL_STATE(4435)] = 155303,
  [SMALL_STATE(4436)] = 155395,
  [SMALL_STATE(4437)] = 155473,
  [SMALL_STATE(4438)] = 155525,
  [SMALL_STATE(4439)] = 155577,
  [SMALL_STATE(4440)] = 155629,
  [SMALL_STATE(4441)] = 155681,
  [SMALL_STATE(4442)] = 155773,
  [SMALL_STATE(4443)] = 155865,
  [SMALL_STATE(4444)] = 155923,
  [SMALL_STATE(4445)] = 156011,
  [SMALL_STATE(4446)] = 156099,
  [SMALL_STATE(4447)] = 156191,
  [SMALL_STATE(4448)] = 156285,
  [SMALL_STATE(4449)] = 156349,
  [SMALL_STATE(4450)] = 156435,
  [SMALL_STATE(4451)] = 156519,
  [SMALL_STATE(4452)] = 156601,
  [SMALL_STATE(4453)] = 156681,
  [SMALL_STATE(4454)] = 156757,
  [SMALL_STATE(4455)] = 156831,
  [SMALL_STATE(4456)] = 156901,
  [SMALL_STATE(4457)] = 156961,
  [SMALL_STATE(4458)] = 157055,
  [SMALL_STATE(4459)] = 157123,
  [SMALL_STATE(4460)] = 157217,
  [SMALL_STATE(4461)] = 157305,
  [SMALL_STATE(4462)] = 157397,
  [SMALL_STATE(4463)] = 157485,
  [SMALL_STATE(4464)] = 157577,
  [SMALL_STATE(4465)] = 157629,
  [SMALL_STATE(4466)] = 157681,
  [SMALL_STATE(4467)] = 157773,
  [SMALL_STATE(4468)] = 157825,
  [SMALL_STATE(4469)] = 157877,
  [SMALL_STATE(4470)] = 157929,
  [SMALL_STATE(4471)] = 158021,
  [SMALL_STATE(4472)] = 158113,
  [SMALL_STATE(4473)] = 158177,
  [SMALL_STATE(4474)] = 158229,
  [SMALL_STATE(4475)] = 158321,
  [SMALL_STATE(4476)] = 158413,
  [SMALL_STATE(4477)] = 158507,
  [SMALL_STATE(4478)] = 158599,
  [SMALL_STATE(4479)] = 158693,
  [SMALL_STATE(4480)] = 158745,
  [SMALL_STATE(4481)] = 158805,
  [SMALL_STATE(4482)] = 158891,
  [SMALL_STATE(4483)] = 158943,
  [SMALL_STATE(4484)] = 159035,
  [SMALL_STATE(4485)] = 159119,
  [SMALL_STATE(4486)] = 159213,
  [SMALL_STATE(4487)] = 159307,
  [SMALL_STATE(4488)] = 159401,
  [SMALL_STATE(4489)] = 159483,
  [SMALL_STATE(4490)] = 159539,
  [SMALL_STATE(4491)] = 159633,
  [SMALL_STATE(4492)] = 159713,
  [SMALL_STATE(4493)] = 159789,
  [SMALL_STATE(4494)] = 159863,
  [SMALL_STATE(4495)] = 159951,
  [SMALL_STATE(4496)] = 160039,
  [SMALL_STATE(4497)] = 160099,
  [SMALL_STATE(4498)] = 160193,
  [SMALL_STATE(4499)] = 160253,
  [SMALL_STATE(4500)] = 160325,
  [SMALL_STATE(4501)] = 160391,
  [SMALL_STATE(4502)] = 160485,
  [SMALL_STATE(4503)] = 160555,
  [SMALL_STATE(4504)] = 160617,
  [SMALL_STATE(4505)] = 160711,
  [SMALL_STATE(4506)] = 160805,
  [SMALL_STATE(4507)] = 160897,
  [SMALL_STATE(4508)] = 160989,
  [SMALL_STATE(4509)] = 161053,
  [SMALL_STATE(4510)] = 161139,
  [SMALL_STATE(4511)] = 161223,
  [SMALL_STATE(4512)] = 161305,
  [SMALL_STATE(4513)] = 161385,
  [SMALL_STATE(4514)] = 161461,
  [SMALL_STATE(4515)] = 161535,
  [SMALL_STATE(4516)] = 161605,
  [SMALL_STATE(4517)] = 161671,
  [SMALL_STATE(4518)] = 161739,
  [SMALL_STATE(4519)] = 161827,
  [SMALL_STATE(4520)] = 161919,
  [SMALL_STATE(4521)] = 162007,
  [SMALL_STATE(4522)] = 162099,
  [SMALL_STATE(4523)] = 162187,
  [SMALL_STATE(4524)] = 162275,
  [SMALL_STATE(4525)] = 162361,
  [SMALL_STATE(4526)] = 162455,
  [SMALL_STATE(4527)] = 162547,
  [SMALL_STATE(4528)] = 162605,
  [SMALL_STATE(4529)] = 162665,
  [SMALL_STATE(4530)] = 162725,
  [SMALL_STATE(4531)] = 162783,
  [SMALL_STATE(4532)] = 162877,
  [SMALL_STATE(4533)] = 162971,
  [SMALL_STATE(4534)] = 163031,
  [SMALL_STATE(4535)] = 163125,
  [SMALL_STATE(4536)] = 163217,
  [SMALL_STATE(4537)] = 163283,
  [SMALL_STATE(4538)] = 163374,
  [SMALL_STATE(4539)] = 163465,
  [SMALL_STATE(4540)] = 163556,
  [SMALL_STATE(4541)] = 163647,
  [SMALL_STATE(4542)] = 163738,
  [SMALL_STATE(4543)] = 163811,
  [SMALL_STATE(4544)] = 163902,
  [SMALL_STATE(4545)] = 163993,
  [SMALL_STATE(4546)] = 164084,
  [SMALL_STATE(4547)] = 164175,
  [SMALL_STATE(4548)] = 164266,
  [SMALL_STATE(4549)] = 164357,
  [SMALL_STATE(4550)] = 164448,
  [SMALL_STATE(4551)] = 164539,
  [SMALL_STATE(4552)] = 164630,
  [SMALL_STATE(4553)] = 164721,
  [SMALL_STATE(4554)] = 164812,
  [SMALL_STATE(4555)] = 164903,
  [SMALL_STATE(4556)] = 164994,
  [SMALL_STATE(4557)] = 165085,
  [SMALL_STATE(4558)] = 165176,
  [SMALL_STATE(4559)] = 165267,
  [SMALL_STATE(4560)] = 165344,
  [SMALL_STATE(4561)] = 165435,
  [SMALL_STATE(4562)] = 165526,
  [SMALL_STATE(4563)] = 165603,
  [SMALL_STATE(4564)] = 165694,
  [SMALL_STATE(4565)] = 165785,
  [SMALL_STATE(4566)] = 165876,
  [SMALL_STATE(4567)] = 165967,
  [SMALL_STATE(4568)] = 166040,
  [SMALL_STATE(4569)] = 166131,
  [SMALL_STATE(4570)] = 166222,
  [SMALL_STATE(4571)] = 166313,
  [SMALL_STATE(4572)] = 166404,
  [SMALL_STATE(4573)] = 166495,
  [SMALL_STATE(4574)] = 166586,
  [SMALL_STATE(4575)] = 166677,
  [SMALL_STATE(4576)] = 166768,
  [SMALL_STATE(4577)] = 166841,
  [SMALL_STATE(4578)] = 166932,
  [SMALL_STATE(4579)] = 167023,
  [SMALL_STATE(4580)] = 167114,
  [SMALL_STATE(4581)] = 167205,
  [SMALL_STATE(4582)] = 167296,
  [SMALL_STATE(4583)] = 167387,
  [SMALL_STATE(4584)] = 167478,
  [SMALL_STATE(4585)] = 167523,
  [SMALL_STATE(4586)] = 167614,
  [SMALL_STATE(4587)] = 167659,
  [SMALL_STATE(4588)] = 167710,
  [SMALL_STATE(4589)] = 167783,
  [SMALL_STATE(4590)] = 167874,
  [SMALL_STATE(4591)] = 167921,
  [SMALL_STATE(4592)] = 168012,
  [SMALL_STATE(4593)] = 168093,
  [SMALL_STATE(4594)] = 168184,
  [SMALL_STATE(4595)] = 168275,
  [SMALL_STATE(4596)] = 168366,
  [SMALL_STATE(4597)] = 168457,
  [SMALL_STATE(4598)] = 168548,
  [SMALL_STATE(4599)] = 168639,
  [SMALL_STATE(4600)] = 168730,
  [SMALL_STATE(4601)] = 168775,
  [SMALL_STATE(4602)] = 168820,
  [SMALL_STATE(4603)] = 168865,
  [SMALL_STATE(4604)] = 168910,
  [SMALL_STATE(4605)] = 169001,
  [SMALL_STATE(4606)] = 169078,
  [SMALL_STATE(4607)] = 169169,
  [SMALL_STATE(4608)] = 169260,
  [SMALL_STATE(4609)] = 169333,
  [SMALL_STATE(4610)] = 169424,
  [SMALL_STATE(4611)] = 169469,
  [SMALL_STATE(4612)] = 169542,
  [SMALL_STATE(4613)] = 169633,
  [SMALL_STATE(4614)] = 169724,
  [SMALL_STATE(4615)] = 169815,
  [SMALL_STATE(4616)] = 169906,
  [SMALL_STATE(4617)] = 169997,
  [SMALL_STATE(4618)] = 170070,
  [SMALL_STATE(4619)] = 170161,
  [SMALL_STATE(4620)] = 170238,
  [SMALL_STATE(4621)] = 170329,
  [SMALL_STATE(4622)] = 170420,
  [SMALL_STATE(4623)] = 170465,
  [SMALL_STATE(4624)] = 170556,
  [SMALL_STATE(4625)] = 170601,
  [SMALL_STATE(4626)] = 170646,
  [SMALL_STATE(4627)] = 170737,
  [SMALL_STATE(4628)] = 170828,
  [SMALL_STATE(4629)] = 170873,
  [SMALL_STATE(4630)] = 170918,
  [SMALL_STATE(4631)] = 170963,
  [SMALL_STATE(4632)] = 171054,
  [SMALL_STATE(4633)] = 171099,
  [SMALL_STATE(4634)] = 171144,
  [SMALL_STATE(4635)] = 171189,
  [SMALL_STATE(4636)] = 171234,
  [SMALL_STATE(4637)] = 171321,
  [SMALL_STATE(4638)] = 171368,
  [SMALL_STATE(4639)] = 171459,
  [SMALL_STATE(4640)] = 171550,
  [SMALL_STATE(4641)] = 171631,
  [SMALL_STATE(4642)] = 171722,
  [SMALL_STATE(4643)] = 171795,
  [SMALL_STATE(4644)] = 171886,
  [SMALL_STATE(4645)] = 171977,
  [SMALL_STATE(4646)] = 172068,
  [SMALL_STATE(4647)] = 172159,
  [SMALL_STATE(4648)] = 172250,
  [SMALL_STATE(4649)] = 172323,
  [SMALL_STATE(4650)] = 172414,
  [SMALL_STATE(4651)] = 172505,
  [SMALL_STATE(4652)] = 172550,
  [SMALL_STATE(4653)] = 172623,
  [SMALL_STATE(4654)] = 172668,
  [SMALL_STATE(4655)] = 172759,
  [SMALL_STATE(4656)] = 172804,
  [SMALL_STATE(4657)] = 172877,
  [SMALL_STATE(4658)] = 172968,
  [SMALL_STATE(4659)] = 173013,
  [SMALL_STATE(4660)] = 173058,
  [SMALL_STATE(4661)] = 173103,
  [SMALL_STATE(4662)] = 173176,
  [SMALL_STATE(4663)] = 173221,
  [SMALL_STATE(4664)] = 173294,
  [SMALL_STATE(4665)] = 173339,
  [SMALL_STATE(4666)] = 173412,
  [SMALL_STATE(4667)] = 173457,
  [SMALL_STATE(4668)] = 173502,
  [SMALL_STATE(4669)] = 173547,
  [SMALL_STATE(4670)] = 173620,
  [SMALL_STATE(4671)] = 173665,
  [SMALL_STATE(4672)] = 173736,
  [SMALL_STATE(4673)] = 173807,
  [SMALL_STATE(4674)] = 173878,
  [SMALL_STATE(4675)] = 173949,
  [SMALL_STATE(4676)] = 174040,
  [SMALL_STATE(4677)] = 174131,
  [SMALL_STATE(4678)] = 174212,
  [SMALL_STATE(4679)] = 174303,
  [SMALL_STATE(4680)] = 174394,
  [SMALL_STATE(4681)] = 174467,
  [SMALL_STATE(4682)] = 174512,
  [SMALL_STATE(4683)] = 174557,
  [SMALL_STATE(4684)] = 174630,
  [SMALL_STATE(4685)] = 174675,
  [SMALL_STATE(4686)] = 174766,
  [SMALL_STATE(4687)] = 174839,
  [SMALL_STATE(4688)] = 174884,
  [SMALL_STATE(4689)] = 174929,
  [SMALL_STATE(4690)] = 175020,
  [SMALL_STATE(4691)] = 175111,
  [SMALL_STATE(4692)] = 175156,
  [SMALL_STATE(4693)] = 175201,
  [SMALL_STATE(4694)] = 175282,
  [SMALL_STATE(4695)] = 175363,
  [SMALL_STATE(4696)] = 175408,
  [SMALL_STATE(4697)] = 175453,
  [SMALL_STATE(4698)] = 175526,
  [SMALL_STATE(4699)] = 175607,
  [SMALL_STATE(4700)] = 175694,
  [SMALL_STATE(4701)] = 175775,
  [SMALL_STATE(4702)] = 175866,
  [SMALL_STATE(4703)] = 175957,
  [SMALL_STATE(4704)] = 176048,
  [SMALL_STATE(4705)] = 176139,
  [SMALL_STATE(4706)] = 176184,
  [SMALL_STATE(4707)] = 176257,
  [SMALL_STATE(4708)] = 176328,
  [SMALL_STATE(4709)] = 176399,
  [SMALL_STATE(4710)] = 176470,
  [SMALL_STATE(4711)] = 176541,
  [SMALL_STATE(4712)] = 176632,
  [SMALL_STATE(4713)] = 176683,
  [SMALL_STATE(4714)] = 176774,
  [SMALL_STATE(4715)] = 176857,
  [SMALL_STATE(4716)] = 176948,
  [SMALL_STATE(4717)] = 177039,
  [SMALL_STATE(4718)] = 177130,
  [SMALL_STATE(4719)] = 177203,
  [SMALL_STATE(4720)] = 177294,
  [SMALL_STATE(4721)] = 177385,
  [SMALL_STATE(4722)] = 177476,
  [SMALL_STATE(4723)] = 177567,
  [SMALL_STATE(4724)] = 177658,
  [SMALL_STATE(4725)] = 177749,
  [SMALL_STATE(4726)] = 177840,
  [SMALL_STATE(4727)] = 177931,
  [SMALL_STATE(4728)] = 178022,
  [SMALL_STATE(4729)] = 178113,
  [SMALL_STATE(4730)] = 178204,
  [SMALL_STATE(4731)] = 178295,
  [SMALL_STATE(4732)] = 178386,
  [SMALL_STATE(4733)] = 178440,
  [SMALL_STATE(4734)] = 178484,
  [SMALL_STATE(4735)] = 178528,
  [SMALL_STATE(4736)] = 178572,
  [SMALL_STATE(4737)] = 178616,
  [SMALL_STATE(4738)] = 178660,
  [SMALL_STATE(4739)] = 178704,
  [SMALL_STATE(4740)] = 178752,
  [SMALL_STATE(4741)] = 178830,
  [SMALL_STATE(4742)] = 178874,
  [SMALL_STATE(4743)] = 178918,
  [SMALL_STATE(4744)] = 178962,
  [SMALL_STATE(4745)] = 179006,
  [SMALL_STATE(4746)] = 179050,
  [SMALL_STATE(4747)] = 179094,
  [SMALL_STATE(4748)] = 179172,
  [SMALL_STATE(4749)] = 179218,
  [SMALL_STATE(4750)] = 179262,
  [SMALL_STATE(4751)] = 179306,
  [SMALL_STATE(4752)] = 179350,
  [SMALL_STATE(4753)] = 179402,
  [SMALL_STATE(4754)] = 179446,
  [SMALL_STATE(4755)] = 179532,
  [SMALL_STATE(4756)] = 179618,
  [SMALL_STATE(4757)] = 179696,
  [SMALL_STATE(4758)] = 179774,
  [SMALL_STATE(4759)] = 179818,
  [SMALL_STATE(4760)] = 179862,
  [SMALL_STATE(4761)] = 179906,
  [SMALL_STATE(4762)] = 179954,
  [SMALL_STATE(4763)] = 180008,
  [SMALL_STATE(4764)] = 180086,
  [SMALL_STATE(4765)] = 180172,
  [SMALL_STATE(4766)] = 180250,
  [SMALL_STATE(4767)] = 180294,
  [SMALL_STATE(4768)] = 180380,
  [SMALL_STATE(4769)] = 180458,
  [SMALL_STATE(4770)] = 180536,
  [SMALL_STATE(4771)] = 180580,
  [SMALL_STATE(4772)] = 180624,
  [SMALL_STATE(4773)] = 180668,
  [SMALL_STATE(4774)] = 180712,
  [SMALL_STATE(4775)] = 180756,
  [SMALL_STATE(4776)] = 180800,
  [SMALL_STATE(4777)] = 180888,
  [SMALL_STATE(4778)] = 180932,
  [SMALL_STATE(4779)] = 180976,
  [SMALL_STATE(4780)] = 181020,
  [SMALL_STATE(4781)] = 181064,
  [SMALL_STATE(4782)] = 181134,
  [SMALL_STATE(4783)] = 181204,
  [SMALL_STATE(4784)] = 181274,
  [SMALL_STATE(4785)] = 181344,
  [SMALL_STATE(4786)] = 181388,
  [SMALL_STATE(4787)] = 181432,
  [SMALL_STATE(4788)] = 181518,
  [SMALL_STATE(4789)] = 181562,
  [SMALL_STATE(4790)] = 181606,
  [SMALL_STATE(4791)] = 181692,
  [SMALL_STATE(4792)] = 181736,
  [SMALL_STATE(4793)] = 181780,
  [SMALL_STATE(4794)] = 181824,
  [SMALL_STATE(4795)] = 181872,
  [SMALL_STATE(4796)] = 181941,
  [SMALL_STATE(4797)] = 181984,
  [SMALL_STATE(4798)] = 182033,
  [SMALL_STATE(4799)] = 182090,
  [SMALL_STATE(4800)] = 182139,
  [SMALL_STATE(4801)] = 182224,
  [SMALL_STATE(4802)] = 182273,
  [SMALL_STATE(4803)] = 182358,
  [SMALL_STATE(4804)] = 182443,
  [SMALL_STATE(4805)] = 182528,
  [SMALL_STATE(4806)] = 182613,
  [SMALL_STATE(4807)] = 182698,
  [SMALL_STATE(4808)] = 182753,
  [SMALL_STATE(4809)] = 182822,
  [SMALL_STATE(4810)] = 182871,
  [SMALL_STATE(4811)] = 182928,
  [SMALL_STATE(4812)] = 183019,
  [SMALL_STATE(4813)] = 183068,
  [SMALL_STATE(4814)] = 183117,
  [SMALL_STATE(4815)] = 183166,
  [SMALL_STATE(4816)] = 183235,
  [SMALL_STATE(4817)] = 183284,
  [SMALL_STATE(4818)] = 183359,
  [SMALL_STATE(4819)] = 183410,
  [SMALL_STATE(4820)] = 183479,
  [SMALL_STATE(4821)] = 183548,
  [SMALL_STATE(4822)] = 183617,
  [SMALL_STATE(4823)] = 183666,
  [SMALL_STATE(4824)] = 183715,
  [SMALL_STATE(4825)] = 183770,
  [SMALL_STATE(4826)] = 183819,
  [SMALL_STATE(4827)] = 183904,
  [SMALL_STATE(4828)] = 183949,
  [SMALL_STATE(4829)] = 184034,
  [SMALL_STATE(4830)] = 184079,
  [SMALL_STATE(4831)] = 184148,
  [SMALL_STATE(4832)] = 184207,
  [SMALL_STATE(4833)] = 184276,
  [SMALL_STATE(4834)] = 184345,
  [SMALL_STATE(4835)] = 184414,
  [SMALL_STATE(4836)] = 184483,
  [SMALL_STATE(4837)] = 184552,
  [SMALL_STATE(4838)] = 184609,
  [SMALL_STATE(4839)] = 184658,
  [SMALL_STATE(4840)] = 184743,
  [SMALL_STATE(4841)] = 184792,
  [SMALL_STATE(4842)] = 184845,
  [SMALL_STATE(4843)] = 184902,
  [SMALL_STATE(4844)] = 184977,
  [SMALL_STATE(4845)] = 185062,
  [SMALL_STATE(4846)] = 185121,
  [SMALL_STATE(4847)] = 185163,
  [SMALL_STATE(4848)] = 185205,
  [SMALL_STATE(4849)] = 185247,
  [SMALL_STATE(4850)] = 185315,
  [SMALL_STATE(4851)] = 185357,
  [SMALL_STATE(4852)] = 185425,
  [SMALL_STATE(4853)] = 185509,
  [SMALL_STATE(4854)] = 185551,
  [SMALL_STATE(4855)] = 185593,
  [SMALL_STATE(4856)] = 185671,
  [SMALL_STATE(4857)] = 185713,
  [SMALL_STATE(4858)] = 185755,
  [SMALL_STATE(4859)] = 185797,
  [SMALL_STATE(4860)] = 185881,
  [SMALL_STATE(4861)] = 185923,
  [SMALL_STATE(4862)] = 185965,
  [SMALL_STATE(4863)] = 186007,
  [SMALL_STATE(4864)] = 186049,
  [SMALL_STATE(4865)] = 186091,
  [SMALL_STATE(4866)] = 186133,
  [SMALL_STATE(4867)] = 186175,
  [SMALL_STATE(4868)] = 186217,
  [SMALL_STATE(4869)] = 186259,
  [SMALL_STATE(4870)] = 186301,
  [SMALL_STATE(4871)] = 186369,
  [SMALL_STATE(4872)] = 186453,
  [SMALL_STATE(4873)] = 186495,
  [SMALL_STATE(4874)] = 186537,
  [SMALL_STATE(4875)] = 186615,
  [SMALL_STATE(4876)] = 186657,
  [SMALL_STATE(4877)] = 186699,
  [SMALL_STATE(4878)] = 186741,
  [SMALL_STATE(4879)] = 186809,
  [SMALL_STATE(4880)] = 186851,
  [SMALL_STATE(4881)] = 186919,
  [SMALL_STATE(4882)] = 186997,
  [SMALL_STATE(4883)] = 187039,
  [SMALL_STATE(4884)] = 187081,
  [SMALL_STATE(4885)] = 187159,
  [SMALL_STATE(4886)] = 187201,
  [SMALL_STATE(4887)] = 187269,
  [SMALL_STATE(4888)] = 187311,
  [SMALL_STATE(4889)] = 187353,
  [SMALL_STATE(4890)] = 187395,
  [SMALL_STATE(4891)] = 187463,
  [SMALL_STATE(4892)] = 187505,
  [SMALL_STATE(4893)] = 187573,
  [SMALL_STATE(4894)] = 187615,
  [SMALL_STATE(4895)] = 187657,
  [SMALL_STATE(4896)] = 187699,
  [SMALL_STATE(4897)] = 187741,
  [SMALL_STATE(4898)] = 187783,
  [SMALL_STATE(4899)] = 187825,
  [SMALL_STATE(4900)] = 187867,
  [SMALL_STATE(4901)] = 187944,
  [SMALL_STATE(4902)] = 188021,
  [SMALL_STATE(4903)] = 188104,
  [SMALL_STATE(4904)] = 188181,
  [SMALL_STATE(4905)] = 188230,
  [SMALL_STATE(4906)] = 188307,
  [SMALL_STATE(4907)] = 188356,
  [SMALL_STATE(4908)] = 188433,
  [SMALL_STATE(4909)] = 188510,
  [SMALL_STATE(4910)] = 188587,
  [SMALL_STATE(4911)] = 188664,
  [SMALL_STATE(4912)] = 188747,
  [SMALL_STATE(4913)] = 188802,
  [SMALL_STATE(4914)] = 188879,
  [SMALL_STATE(4915)] = 188962,
  [SMALL_STATE(4916)] = 189039,
  [SMALL_STATE(4917)] = 189092,
  [SMALL_STATE(4918)] = 189169,
  [SMALL_STATE(4919)] = 189252,
  [SMALL_STATE(4920)] = 189335,
  [SMALL_STATE(4921)] = 189390,
  [SMALL_STATE(4922)] = 189473,
  [SMALL_STATE(4923)] = 189550,
  [SMALL_STATE(4924)] = 189600,
  [SMALL_STATE(4925)] = 189654,
  [SMALL_STATE(4926)] = 189698,
  [SMALL_STATE(4927)] = 189778,
  [SMALL_STATE(4928)] = 189854,
  [SMALL_STATE(4929)] = 189934,
  [SMALL_STATE(4930)] = 190010,
  [SMALL_STATE(4931)] = 190086,
  [SMALL_STATE(4932)] = 190136,
  [SMALL_STATE(4933)] = 190212,
  [SMALL_STATE(4934)] = 190294,
  [SMALL_STATE(4935)] = 190374,
  [SMALL_STATE(4936)] = 190440,
  [SMALL_STATE(4937)] = 190516,
  [SMALL_STATE(4938)] = 190596,
  [SMALL_STATE(4939)] = 190662,
  [SMALL_STATE(4940)] = 190738,
  [SMALL_STATE(4941)] = 190820,
  [SMALL_STATE(4942)] = 190896,
  [SMALL_STATE(4943)] = 190976,
  [SMALL_STATE(4944)] = 191056,
  [SMALL_STATE(4945)] = 191132,
  [SMALL_STATE(4946)] = 191208,
  [SMALL_STATE(4947)] = 191288,
  [SMALL_STATE(4948)] = 191354,
  [SMALL_STATE(4949)] = 191434,
  [SMALL_STATE(4950)] = 191490,
  [SMALL_STATE(4951)] = 191572,
  [SMALL_STATE(4952)] = 191616,
  [SMALL_STATE(4953)] = 191660,
  [SMALL_STATE(4954)] = 191736,
  [SMALL_STATE(4955)] = 191812,
  [SMALL_STATE(4956)] = 191878,
  [SMALL_STATE(4957)] = 191958,
  [SMALL_STATE(4958)] = 192012,
  [SMALL_STATE(4959)] = 192092,
  [SMALL_STATE(4960)] = 192172,
  [SMALL_STATE(4961)] = 192216,
  [SMALL_STATE(4962)] = 192260,
  [SMALL_STATE(4963)] = 192336,
  [SMALL_STATE(4964)] = 192416,
  [SMALL_STATE(4965)] = 192460,
  [SMALL_STATE(4966)] = 192504,
  [SMALL_STATE(4967)] = 192548,
  [SMALL_STATE(4968)] = 192592,
  [SMALL_STATE(4969)] = 192636,
  [SMALL_STATE(4970)] = 192712,
  [SMALL_STATE(4971)] = 192788,
  [SMALL_STATE(4972)] = 192868,
  [SMALL_STATE(4973)] = 192948,
  [SMALL_STATE(4974)] = 193030,
  [SMALL_STATE(4975)] = 193106,
  [SMALL_STATE(4976)] = 193162,
  [SMALL_STATE(4977)] = 193242,
  [SMALL_STATE(4978)] = 193318,
  [SMALL_STATE(4979)] = 193362,
  [SMALL_STATE(4980)] = 193404,
  [SMALL_STATE(4981)] = 193480,
  [SMALL_STATE(4982)] = 193560,
  [SMALL_STATE(4983)] = 193636,
  [SMALL_STATE(4984)] = 193716,
  [SMALL_STATE(4985)] = 193760,
  [SMALL_STATE(4986)] = 193836,
  [SMALL_STATE(4987)] = 193912,
  [SMALL_STATE(4988)] = 193992,
  [SMALL_STATE(4989)] = 194035,
  [SMALL_STATE(4990)] = 194116,
  [SMALL_STATE(4991)] = 194197,
  [SMALL_STATE(4992)] = 194278,
  [SMALL_STATE(4993)] = 194329,
  [SMALL_STATE(4994)] = 194410,
  [SMALL_STATE(4995)] = 194491,
  [SMALL_STATE(4996)] = 194572,
  [SMALL_STATE(4997)] = 194653,
  [SMALL_STATE(4998)] = 194734,
  [SMALL_STATE(4999)] = 194815,
  [SMALL_STATE(5000)] = 194896,
  [SMALL_STATE(5001)] = 194977,
  [SMALL_STATE(5002)] = 195058,
  [SMALL_STATE(5003)] = 195139,
  [SMALL_STATE(5004)] = 195220,
  [SMALL_STATE(5005)] = 195301,
  [SMALL_STATE(5006)] = 195382,
  [SMALL_STATE(5007)] = 195463,
  [SMALL_STATE(5008)] = 195544,
  [SMALL_STATE(5009)] = 195625,
  [SMALL_STATE(5010)] = 195706,
  [SMALL_STATE(5011)] = 195787,
  [SMALL_STATE(5012)] = 195868,
  [SMALL_STATE(5013)] = 195949,
  [SMALL_STATE(5014)] = 196030,
  [SMALL_STATE(5015)] = 196111,
  [SMALL_STATE(5016)] = 196192,
  [SMALL_STATE(5017)] = 196273,
  [SMALL_STATE(5018)] = 196354,
  [SMALL_STATE(5019)] = 196435,
  [SMALL_STATE(5020)] = 196516,
  [SMALL_STATE(5021)] = 196597,
  [SMALL_STATE(5022)] = 196678,
  [SMALL_STATE(5023)] = 196759,
  [SMALL_STATE(5024)] = 196840,
  [SMALL_STATE(5025)] = 196921,
  [SMALL_STATE(5026)] = 197002,
  [SMALL_STATE(5027)] = 197083,
  [SMALL_STATE(5028)] = 197164,
  [SMALL_STATE(5029)] = 197245,
  [SMALL_STATE(5030)] = 197326,
  [SMALL_STATE(5031)] = 197407,
  [SMALL_STATE(5032)] = 197488,
  [SMALL_STATE(5033)] = 197569,
  [SMALL_STATE(5034)] = 197650,
  [SMALL_STATE(5035)] = 197731,
  [SMALL_STATE(5036)] = 197812,
  [SMALL_STATE(5037)] = 197893,
  [SMALL_STATE(5038)] = 197974,
  [SMALL_STATE(5039)] = 198055,
  [SMALL_STATE(5040)] = 198136,
  [SMALL_STATE(5041)] = 198217,
  [SMALL_STATE(5042)] = 198298,
  [SMALL_STATE(5043)] = 198379,
  [SMALL_STATE(5044)] = 198460,
  [SMALL_STATE(5045)] = 198541,
  [SMALL_STATE(5046)] = 198622,
  [SMALL_STATE(5047)] = 198703,
  [SMALL_STATE(5048)] = 198784,
  [SMALL_STATE(5049)] = 198865,
  [SMALL_STATE(5050)] = 198946,
  [SMALL_STATE(5051)] = 199027,
  [SMALL_STATE(5052)] = 199102,
  [SMALL_STATE(5053)] = 199177,
  [SMALL_STATE(5054)] = 199252,
  [SMALL_STATE(5055)] = 199327,
  [SMALL_STATE(5056)] = 199408,
  [SMALL_STATE(5057)] = 199489,
  [SMALL_STATE(5058)] = 199570,
  [SMALL_STATE(5059)] = 199651,
  [SMALL_STATE(5060)] = 199732,
  [SMALL_STATE(5061)] = 199813,
  [SMALL_STATE(5062)] = 199894,
  [SMALL_STATE(5063)] = 199975,
  [SMALL_STATE(5064)] = 200056,
  [SMALL_STATE(5065)] = 200137,
  [SMALL_STATE(5066)] = 200218,
  [SMALL_STATE(5067)] = 200299,
  [SMALL_STATE(5068)] = 200380,
  [SMALL_STATE(5069)] = 200461,
  [SMALL_STATE(5070)] = 200542,
  [SMALL_STATE(5071)] = 200623,
  [SMALL_STATE(5072)] = 200704,
  [SMALL_STATE(5073)] = 200785,
  [SMALL_STATE(5074)] = 200866,
  [SMALL_STATE(5075)] = 200947,
  [SMALL_STATE(5076)] = 201028,
  [SMALL_STATE(5077)] = 201109,
  [SMALL_STATE(5078)] = 201190,
  [SMALL_STATE(5079)] = 201271,
  [SMALL_STATE(5080)] = 201352,
  [SMALL_STATE(5081)] = 201433,
  [SMALL_STATE(5082)] = 201514,
  [SMALL_STATE(5083)] = 201595,
  [SMALL_STATE(5084)] = 201676,
  [SMALL_STATE(5085)] = 201757,
  [SMALL_STATE(5086)] = 201838,
  [SMALL_STATE(5087)] = 201919,
  [SMALL_STATE(5088)] = 202000,
  [SMALL_STATE(5089)] = 202043,
  [SMALL_STATE(5090)] = 202086,
  [SMALL_STATE(5091)] = 202129,
  [SMALL_STATE(5092)] = 202172,
  [SMALL_STATE(5093)] = 202215,
  [SMALL_STATE(5094)] = 202258,
  [SMALL_STATE(5095)] = 202301,
  [SMALL_STATE(5096)] = 202344,
  [SMALL_STATE(5097)] = 202387,
  [SMALL_STATE(5098)] = 202430,
  [SMALL_STATE(5099)] = 202473,
  [SMALL_STATE(5100)] = 202516,
  [SMALL_STATE(5101)] = 202597,
  [SMALL_STATE(5102)] = 202648,
  [SMALL_STATE(5103)] = 202729,
  [SMALL_STATE(5104)] = 202799,
  [SMALL_STATE(5105)] = 202877,
  [SMALL_STATE(5106)] = 202951,
  [SMALL_STATE(5107)] = 203025,
  [SMALL_STATE(5108)] = 203099,
  [SMALL_STATE(5109)] = 203177,
  [SMALL_STATE(5110)] = 203251,
  [SMALL_STATE(5111)] = 203325,
  [SMALL_STATE(5112)] = 203403,
  [SMALL_STATE(5113)] = 203477,
  [SMALL_STATE(5114)] = 203547,
  [SMALL_STATE(5115)] = 203621,
  [SMALL_STATE(5116)] = 203695,
  [SMALL_STATE(5117)] = 203773,
  [SMALL_STATE(5118)] = 203847,
  [SMALL_STATE(5119)] = 203925,
  [SMALL_STATE(5120)] = 203999,
  [SMALL_STATE(5121)] = 204073,
  [SMALL_STATE(5122)] = 204147,
  [SMALL_STATE(5123)] = 204225,
  [SMALL_STATE(5124)] = 204303,
  [SMALL_STATE(5125)] = 204381,
  [SMALL_STATE(5126)] = 204455,
  [SMALL_STATE(5127)] = 204529,
  [SMALL_STATE(5128)] = 204603,
  [SMALL_STATE(5129)] = 204677,
  [SMALL_STATE(5130)] = 204755,
  [SMALL_STATE(5131)] = 204829,
  [SMALL_STATE(5132)] = 204903,
  [SMALL_STATE(5133)] = 204977,
  [SMALL_STATE(5134)] = 205051,
  [SMALL_STATE(5135)] = 205129,
  [SMALL_STATE(5136)] = 205203,
  [SMALL_STATE(5137)] = 205277,
  [SMALL_STATE(5138)] = 205351,
  [SMALL_STATE(5139)] = 205425,
  [SMALL_STATE(5140)] = 205495,
  [SMALL_STATE(5141)] = 205569,
  [SMALL_STATE(5142)] = 205643,
  [SMALL_STATE(5143)] = 205717,
  [SMALL_STATE(5144)] = 205791,
  [SMALL_STATE(5145)] = 205865,
  [SMALL_STATE(5146)] = 205939,
  [SMALL_STATE(5147)] = 206013,
  [SMALL_STATE(5148)] = 206091,
  [SMALL_STATE(5149)] = 206165,
  [SMALL_STATE(5150)] = 206239,
  [SMALL_STATE(5151)] = 206317,
  [SMALL_STATE(5152)] = 206391,
  [SMALL_STATE(5153)] = 206469,
  [SMALL_STATE(5154)] = 206543,
  [SMALL_STATE(5155)] = 206621,
  [SMALL_STATE(5156)] = 206695,
  [SMALL_STATE(5157)] = 206769,
  [SMALL_STATE(5158)] = 206843,
  [SMALL_STATE(5159)] = 206917,
  [SMALL_STATE(5160)] = 206987,
  [SMALL_STATE(5161)] = 207061,
  [SMALL_STATE(5162)] = 207131,
  [SMALL_STATE(5163)] = 207209,
  [SMALL_STATE(5164)] = 207283,
  [SMALL_STATE(5165)] = 207357,
  [SMALL_STATE(5166)] = 207431,
  [SMALL_STATE(5167)] = 207501,
  [SMALL_STATE(5168)] = 207579,
  [SMALL_STATE(5169)] = 207653,
  [SMALL_STATE(5170)] = 207727,
  [SMALL_STATE(5171)] = 207801,
  [SMALL_STATE(5172)] = 207875,
  [SMALL_STATE(5173)] = 207945,
  [SMALL_STATE(5174)] = 208019,
  [SMALL_STATE(5175)] = 208089,
  [SMALL_STATE(5176)] = 208163,
  [SMALL_STATE(5177)] = 208237,
  [SMALL_STATE(5178)] = 208311,
  [SMALL_STATE(5179)] = 208389,
  [SMALL_STATE(5180)] = 208463,
  [SMALL_STATE(5181)] = 208541,
  [SMALL_STATE(5182)] = 208608,
  [SMALL_STATE(5183)] = 208675,
  [SMALL_STATE(5184)] = 208742,
  [SMALL_STATE(5185)] = 208809,
  [SMALL_STATE(5186)] = 208876,
  [SMALL_STATE(5187)] = 208949,
  [SMALL_STATE(5188)] = 208990,
  [SMALL_STATE(5189)] = 209057,
  [SMALL_STATE(5190)] = 209124,
  [SMALL_STATE(5191)] = 209197,
  [SMALL_STATE(5192)] = 209270,
  [SMALL_STATE(5193)] = 209337,
  [SMALL_STATE(5194)] = 209404,
  [SMALL_STATE(5195)] = 209477,
  [SMALL_STATE(5196)] = 209544,
  [SMALL_STATE(5197)] = 209617,
  [SMALL_STATE(5198)] = 209684,
  [SMALL_STATE(5199)] = 209751,
  [SMALL_STATE(5200)] = 209818,
  [SMALL_STATE(5201)] = 209885,
  [SMALL_STATE(5202)] = 209952,
  [SMALL_STATE(5203)] = 210019,
  [SMALL_STATE(5204)] = 210092,
  [SMALL_STATE(5205)] = 210159,
  [SMALL_STATE(5206)] = 210226,
  [SMALL_STATE(5207)] = 210269,
  [SMALL_STATE(5208)] = 210336,
  [SMALL_STATE(5209)] = 210403,
  [SMALL_STATE(5210)] = 210448,
  [SMALL_STATE(5211)] = 210515,
  [SMALL_STATE(5212)] = 210552,
  [SMALL_STATE(5213)] = 210619,
  [SMALL_STATE(5214)] = 210656,
  [SMALL_STATE(5215)] = 210723,
  [SMALL_STATE(5216)] = 210768,
  [SMALL_STATE(5217)] = 210835,
  [SMALL_STATE(5218)] = 210902,
  [SMALL_STATE(5219)] = 210969,
  [SMALL_STATE(5220)] = 211036,
  [SMALL_STATE(5221)] = 211103,
  [SMALL_STATE(5222)] = 211170,
  [SMALL_STATE(5223)] = 211243,
  [SMALL_STATE(5224)] = 211310,
  [SMALL_STATE(5225)] = 211377,
  [SMALL_STATE(5226)] = 211444,
  [SMALL_STATE(5227)] = 211511,
  [SMALL_STATE(5228)] = 211584,
  [SMALL_STATE(5229)] = 211651,
  [SMALL_STATE(5230)] = 211717,
  [SMALL_STATE(5231)] = 211783,
  [SMALL_STATE(5232)] = 211849,
  [SMALL_STATE(5233)] = 211915,
  [SMALL_STATE(5234)] = 211981,
  [SMALL_STATE(5235)] = 212047,
  [SMALL_STATE(5236)] = 212113,
  [SMALL_STATE(5237)] = 212179,
  [SMALL_STATE(5238)] = 212245,
  [SMALL_STATE(5239)] = 212285,
  [SMALL_STATE(5240)] = 212351,
  [SMALL_STATE(5241)] = 212417,
  [SMALL_STATE(5242)] = 212483,
  [SMALL_STATE(5243)] = 212549,
  [SMALL_STATE(5244)] = 212615,
  [SMALL_STATE(5245)] = 212681,
  [SMALL_STATE(5246)] = 212747,
  [SMALL_STATE(5247)] = 212813,
  [SMALL_STATE(5248)] = 212879,
  [SMALL_STATE(5249)] = 212944,
  [SMALL_STATE(5250)] = 213009,
  [SMALL_STATE(5251)] = 213074,
  [SMALL_STATE(5252)] = 213139,
  [SMALL_STATE(5253)] = 213204,
  [SMALL_STATE(5254)] = 213269,
  [SMALL_STATE(5255)] = 213334,
  [SMALL_STATE(5256)] = 213399,
  [SMALL_STATE(5257)] = 213464,
  [SMALL_STATE(5258)] = 213529,
  [SMALL_STATE(5259)] = 213566,
  [SMALL_STATE(5260)] = 213631,
  [SMALL_STATE(5261)] = 213696,
  [SMALL_STATE(5262)] = 213761,
  [SMALL_STATE(5263)] = 213826,
  [SMALL_STATE(5264)] = 213891,
  [SMALL_STATE(5265)] = 213956,
  [SMALL_STATE(5266)] = 214021,
  [SMALL_STATE(5267)] = 214086,
  [SMALL_STATE(5268)] = 214151,
  [SMALL_STATE(5269)] = 214216,
  [SMALL_STATE(5270)] = 214281,
  [SMALL_STATE(5271)] = 214346,
  [SMALL_STATE(5272)] = 214411,
  [SMALL_STATE(5273)] = 214476,
  [SMALL_STATE(5274)] = 214541,
  [SMALL_STATE(5275)] = 214606,
  [SMALL_STATE(5276)] = 214671,
  [SMALL_STATE(5277)] = 214736,
  [SMALL_STATE(5278)] = 214801,
  [SMALL_STATE(5279)] = 214866,
  [SMALL_STATE(5280)] = 214930,
  [SMALL_STATE(5281)] = 214994,
  [SMALL_STATE(5282)] = 215052,
  [SMALL_STATE(5283)] = 215116,
  [SMALL_STATE(5284)] = 215180,
  [SMALL_STATE(5285)] = 215244,
  [SMALL_STATE(5286)] = 215302,
  [SMALL_STATE(5287)] = 215366,
  [SMALL_STATE(5288)] = 215424,
  [SMALL_STATE(5289)] = 215482,
  [SMALL_STATE(5290)] = 215545,
  [SMALL_STATE(5291)] = 215608,
  [SMALL_STATE(5292)] = 215671,
  [SMALL_STATE(5293)] = 215732,
  [SMALL_STATE(5294)] = 215795,
  [SMALL_STATE(5295)] = 215846,
  [SMALL_STATE(5296)] = 215909,
  [SMALL_STATE(5297)] = 215972,
  [SMALL_STATE(5298)] = 216035,
  [SMALL_STATE(5299)] = 216098,
  [SMALL_STATE(5300)] = 216159,
  [SMALL_STATE(5301)] = 216210,
  [SMALL_STATE(5302)] = 216271,
  [SMALL_STATE(5303)] = 216332,
  [SMALL_STATE(5304)] = 216395,
  [SMALL_STATE(5305)] = 216458,
  [SMALL_STATE(5306)] = 216519,
  [SMALL_STATE(5307)] = 216582,
  [SMALL_STATE(5308)] = 216643,
  [SMALL_STATE(5309)] = 216706,
  [SMALL_STATE(5310)] = 216769,
  [SMALL_STATE(5311)] = 216832,
  [SMALL_STATE(5312)] = 216883,
  [SMALL_STATE(5313)] = 216946,
  [SMALL_STATE(5314)] = 217007,
  [SMALL_STATE(5315)] = 217070,
  [SMALL_STATE(5316)] = 217133,
  [SMALL_STATE(5317)] = 217196,
  [SMALL_STATE(5318)] = 217258,
  [SMALL_STATE(5319)] = 217320,
  [SMALL_STATE(5320)] = 217382,
  [SMALL_STATE(5321)] = 217444,
  [SMALL_STATE(5322)] = 217506,
  [SMALL_STATE(5323)] = 217568,
  [SMALL_STATE(5324)] = 217630,
  [SMALL_STATE(5325)] = 217692,
  [SMALL_STATE(5326)] = 217754,
  [SMALL_STATE(5327)] = 217816,
  [SMALL_STATE(5328)] = 217878,
  [SMALL_STATE(5329)] = 217940,
  [SMALL_STATE(5330)] = 218014,
  [SMALL_STATE(5331)] = 218068,
  [SMALL_STATE(5332)] = 218142,
  [SMALL_STATE(5333)] = 218216,
  [SMALL_STATE(5334)] = 218258,
  [SMALL_STATE(5335)] = 218300,
  [SMALL_STATE(5336)] = 218349,
  [SMALL_STATE(5337)] = 218380,
  [SMALL_STATE(5338)] = 218418,
  [SMALL_STATE(5339)] = 218470,
  [SMALL_STATE(5340)] = 218522,
  [SMALL_STATE(5341)] = 218574,
  [SMALL_STATE(5342)] = 218626,
  [SMALL_STATE(5343)] = 218678,
  [SMALL_STATE(5344)] = 218730,
  [SMALL_STATE(5345)] = 218776,
  [SMALL_STATE(5346)] = 218828,
  [SMALL_STATE(5347)] = 218880,
  [SMALL_STATE(5348)] = 218932,
  [SMALL_STATE(5349)] = 218984,
  [SMALL_STATE(5350)] = 219036,
  [SMALL_STATE(5351)] = 219088,
  [SMALL_STATE(5352)] = 219120,
  [SMALL_STATE(5353)] = 219154,
  [SMALL_STATE(5354)] = 219206,
  [SMALL_STATE(5355)] = 219258,
  [SMALL_STATE(5356)] = 219310,
  [SMALL_STATE(5357)] = 219362,
  [SMALL_STATE(5358)] = 219414,
  [SMALL_STATE(5359)] = 219466,
  [SMALL_STATE(5360)] = 219518,
  [SMALL_STATE(5361)] = 219588,
  [SMALL_STATE(5362)] = 219622,
  [SMALL_STATE(5363)] = 219670,
  [SMALL_STATE(5364)] = 219740,
  [SMALL_STATE(5365)] = 219792,
  [SMALL_STATE(5366)] = 219844,
  [SMALL_STATE(5367)] = 219882,
  [SMALL_STATE(5368)] = 219920,
  [SMALL_STATE(5369)] = 219958,
  [SMALL_STATE(5370)] = 219996,
  [SMALL_STATE(5371)] = 220048,
  [SMALL_STATE(5372)] = 220100,
  [SMALL_STATE(5373)] = 220134,
  [SMALL_STATE(5374)] = 220186,
  [SMALL_STATE(5375)] = 220238,
  [SMALL_STATE(5376)] = 220290,
  [SMALL_STATE(5377)] = 220342,
  [SMALL_STATE(5378)] = 220394,
  [SMALL_STATE(5379)] = 220446,
  [SMALL_STATE(5380)] = 220484,
  [SMALL_STATE(5381)] = 220522,
  [SMALL_STATE(5382)] = 220562,
  [SMALL_STATE(5383)] = 220600,
  [SMALL_STATE(5384)] = 220670,
  [SMALL_STATE(5385)] = 220722,
  [SMALL_STATE(5386)] = 220762,
  [SMALL_STATE(5387)] = 220814,
  [SMALL_STATE(5388)] = 220848,
  [SMALL_STATE(5389)] = 220900,
  [SMALL_STATE(5390)] = 220952,
  [SMALL_STATE(5391)] = 221004,
  [SMALL_STATE(5392)] = 221056,
  [SMALL_STATE(5393)] = 221094,
  [SMALL_STATE(5394)] = 221146,
  [SMALL_STATE(5395)] = 221198,
  [SMALL_STATE(5396)] = 221232,
  [SMALL_STATE(5397)] = 221284,
  [SMALL_STATE(5398)] = 221336,
  [SMALL_STATE(5399)] = 221388,
  [SMALL_STATE(5400)] = 221440,
  [SMALL_STATE(5401)] = 221478,
  [SMALL_STATE(5402)] = 221515,
  [SMALL_STATE(5403)] = 221574,
  [SMALL_STATE(5404)] = 221603,
  [SMALL_STATE(5405)] = 221632,
  [SMALL_STATE(5406)] = 221675,
  [SMALL_STATE(5407)] = 221736,
  [SMALL_STATE(5408)] = 221795,
  [SMALL_STATE(5409)] = 221854,
  [SMALL_STATE(5410)] = 221887,
  [SMALL_STATE(5411)] = 221946,
  [SMALL_STATE(5412)] = 221983,
  [SMALL_STATE(5413)] = 222012,
  [SMALL_STATE(5414)] = 222041,
  [SMALL_STATE(5415)] = 222100,
  [SMALL_STATE(5416)] = 222159,
  [SMALL_STATE(5417)] = 222218,
  [SMALL_STATE(5418)] = 222277,
  [SMALL_STATE(5419)] = 222336,
  [SMALL_STATE(5420)] = 222395,
  [SMALL_STATE(5421)] = 222424,
  [SMALL_STATE(5422)] = 222483,
  [SMALL_STATE(5423)] = 222514,
  [SMALL_STATE(5424)] = 222573,
  [SMALL_STATE(5425)] = 222632,
  [SMALL_STATE(5426)] = 222691,
  [SMALL_STATE(5427)] = 222720,
  [SMALL_STATE(5428)] = 222779,
  [SMALL_STATE(5429)] = 222808,
  [SMALL_STATE(5430)] = 222837,
  [SMALL_STATE(5431)] = 222866,
  [SMALL_STATE(5432)] = 222925,
  [SMALL_STATE(5433)] = 222984,
  [SMALL_STATE(5434)] = 223043,
  [SMALL_STATE(5435)] = 223102,
  [SMALL_STATE(5436)] = 223161,
  [SMALL_STATE(5437)] = 223220,
  [SMALL_STATE(5438)] = 223273,
  [SMALL_STATE(5439)] = 223332,
  [SMALL_STATE(5440)] = 223387,
  [SMALL_STATE(5441)] = 223416,
  [SMALL_STATE(5442)] = 223445,
  [SMALL_STATE(5443)] = 223474,
  [SMALL_STATE(5444)] = 223533,
  [SMALL_STATE(5445)] = 223596,
  [SMALL_STATE(5446)] = 223651,
  [SMALL_STATE(5447)] = 223710,
  [SMALL_STATE(5448)] = 223769,
  [SMALL_STATE(5449)] = 223828,
  [SMALL_STATE(5450)] = 223887,
  [SMALL_STATE(5451)] = 223946,
  [SMALL_STATE(5452)] = 224005,
  [SMALL_STATE(5453)] = 224064,
  [SMALL_STATE(5454)] = 224123,
  [SMALL_STATE(5455)] = 224176,
  [SMALL_STATE(5456)] = 224235,
  [SMALL_STATE(5457)] = 224296,
  [SMALL_STATE(5458)] = 224325,
  [SMALL_STATE(5459)] = 224354,
  [SMALL_STATE(5460)] = 224413,
  [SMALL_STATE(5461)] = 224442,
  [SMALL_STATE(5462)] = 224501,
  [SMALL_STATE(5463)] = 224560,
  [SMALL_STATE(5464)] = 224619,
  [SMALL_STATE(5465)] = 224678,
  [SMALL_STATE(5466)] = 224737,
  [SMALL_STATE(5467)] = 224796,
  [SMALL_STATE(5468)] = 224855,
  [SMALL_STATE(5469)] = 224900,
  [SMALL_STATE(5470)] = 224959,
  [SMALL_STATE(5471)] = 225018,
  [SMALL_STATE(5472)] = 225077,
  [SMALL_STATE(5473)] = 225136,
  [SMALL_STATE(5474)] = 225195,
  [SMALL_STATE(5475)] = 225254,
  [SMALL_STATE(5476)] = 225313,
  [SMALL_STATE(5477)] = 225356,
  [SMALL_STATE(5478)] = 225415,
  [SMALL_STATE(5479)] = 225474,
  [SMALL_STATE(5480)] = 225533,
  [SMALL_STATE(5481)] = 225592,
  [SMALL_STATE(5482)] = 225651,
  [SMALL_STATE(5483)] = 225688,
  [SMALL_STATE(5484)] = 225725,
  [SMALL_STATE(5485)] = 225784,
  [SMALL_STATE(5486)] = 225817,
  [SMALL_STATE(5487)] = 225854,
  [SMALL_STATE(5488)] = 225913,
  [SMALL_STATE(5489)] = 225972,
  [SMALL_STATE(5490)] = 226009,
  [SMALL_STATE(5491)] = 226046,
  [SMALL_STATE(5492)] = 226107,
  [SMALL_STATE(5493)] = 226166,
  [SMALL_STATE(5494)] = 226225,
  [SMALL_STATE(5495)] = 226284,
  [SMALL_STATE(5496)] = 226313,
  [SMALL_STATE(5497)] = 226366,
  [SMALL_STATE(5498)] = 226403,
  [SMALL_STATE(5499)] = 226464,
  [SMALL_STATE(5500)] = 226523,
  [SMALL_STATE(5501)] = 226582,
  [SMALL_STATE(5502)] = 226615,
  [SMALL_STATE(5503)] = 226674,
  [SMALL_STATE(5504)] = 226733,
  [SMALL_STATE(5505)] = 226792,
  [SMALL_STATE(5506)] = 226851,
  [SMALL_STATE(5507)] = 226910,
  [SMALL_STATE(5508)] = 226969,
  [SMALL_STATE(5509)] = 227030,
  [SMALL_STATE(5510)] = 227073,
  [SMALL_STATE(5511)] = 227132,
  [SMALL_STATE(5512)] = 227191,
  [SMALL_STATE(5513)] = 227250,
  [SMALL_STATE(5514)] = 227283,
  [SMALL_STATE(5515)] = 227342,
  [SMALL_STATE(5516)] = 227401,
  [SMALL_STATE(5517)] = 227460,
  [SMALL_STATE(5518)] = 227489,
  [SMALL_STATE(5519)] = 227548,
  [SMALL_STATE(5520)] = 227607,
  [SMALL_STATE(5521)] = 227666,
  [SMALL_STATE(5522)] = 227725,
  [SMALL_STATE(5523)] = 227784,
  [SMALL_STATE(5524)] = 227839,
  [SMALL_STATE(5525)] = 227898,
  [SMALL_STATE(5526)] = 227957,
  [SMALL_STATE(5527)] = 228018,
  [SMALL_STATE(5528)] = 228055,
  [SMALL_STATE(5529)] = 228114,
  [SMALL_STATE(5530)] = 228173,
  [SMALL_STATE(5531)] = 228202,
  [SMALL_STATE(5532)] = 228233,
  [SMALL_STATE(5533)] = 228262,
  [SMALL_STATE(5534)] = 228291,
  [SMALL_STATE(5535)] = 228320,
  [SMALL_STATE(5536)] = 228357,
  [SMALL_STATE(5537)] = 228416,
  [SMALL_STATE(5538)] = 228475,
  [SMALL_STATE(5539)] = 228534,
  [SMALL_STATE(5540)] = 228595,
  [SMALL_STATE(5541)] = 228654,
  [SMALL_STATE(5542)] = 228713,
  [SMALL_STATE(5543)] = 228742,
  [SMALL_STATE(5544)] = 228801,
  [SMALL_STATE(5545)] = 228860,
  [SMALL_STATE(5546)] = 228919,
  [SMALL_STATE(5547)] = 228978,
  [SMALL_STATE(5548)] = 229030,
  [SMALL_STATE(5549)] = 229076,
  [SMALL_STATE(5550)] = 229116,
  [SMALL_STATE(5551)] = 229156,
  [SMALL_STATE(5552)] = 229220,
  [SMALL_STATE(5553)] = 229260,
  [SMALL_STATE(5554)] = 229300,
  [SMALL_STATE(5555)] = 229350,
  [SMALL_STATE(5556)] = 229402,
  [SMALL_STATE(5557)] = 229466,
  [SMALL_STATE(5558)] = 229512,
  [SMALL_STATE(5559)] = 229562,
  [SMALL_STATE(5560)] = 229602,
  [SMALL_STATE(5561)] = 229646,
  [SMALL_STATE(5562)] = 229686,
  [SMALL_STATE(5563)] = 229726,
  [SMALL_STATE(5564)] = 229768,
  [SMALL_STATE(5565)] = 229808,
  [SMALL_STATE(5566)] = 229844,
  [SMALL_STATE(5567)] = 229878,
  [SMALL_STATE(5568)] = 229918,
  [SMALL_STATE(5569)] = 229968,
  [SMALL_STATE(5570)] = 230008,
  [SMALL_STATE(5571)] = 230058,
  [SMALL_STATE(5572)] = 230110,
  [SMALL_STATE(5573)] = 230150,
  [SMALL_STATE(5574)] = 230190,
  [SMALL_STATE(5575)] = 230242,
  [SMALL_STATE(5576)] = 230274,
  [SMALL_STATE(5577)] = 230318,
  [SMALL_STATE(5578)] = 230346,
  [SMALL_STATE(5579)] = 230410,
  [SMALL_STATE(5580)] = 230462,
  [SMALL_STATE(5581)] = 230514,
  [SMALL_STATE(5582)] = 230554,
  [SMALL_STATE(5583)] = 230594,
  [SMALL_STATE(5584)] = 230634,
  [SMALL_STATE(5585)] = 230684,
  [SMALL_STATE(5586)] = 230734,
  [SMALL_STATE(5587)] = 230774,
  [SMALL_STATE(5588)] = 230824,
  [SMALL_STATE(5589)] = 230864,
  [SMALL_STATE(5590)] = 230914,
  [SMALL_STATE(5591)] = 230954,
  [SMALL_STATE(5592)] = 231004,
  [SMALL_STATE(5593)] = 231068,
  [SMALL_STATE(5594)] = 231108,
  [SMALL_STATE(5595)] = 231172,
  [SMALL_STATE(5596)] = 231222,
  [SMALL_STATE(5597)] = 231272,
  [SMALL_STATE(5598)] = 231300,
  [SMALL_STATE(5599)] = 231350,
  [SMALL_STATE(5600)] = 231378,
  [SMALL_STATE(5601)] = 231428,
  [SMALL_STATE(5602)] = 231492,
  [SMALL_STATE(5603)] = 231520,
  [SMALL_STATE(5604)] = 231560,
  [SMALL_STATE(5605)] = 231600,
  [SMALL_STATE(5606)] = 231628,
  [SMALL_STATE(5607)] = 231692,
  [SMALL_STATE(5608)] = 231744,
  [SMALL_STATE(5609)] = 231796,
  [SMALL_STATE(5610)] = 231836,
  [SMALL_STATE(5611)] = 231876,
  [SMALL_STATE(5612)] = 231916,
  [SMALL_STATE(5613)] = 231956,
  [SMALL_STATE(5614)] = 232008,
  [SMALL_STATE(5615)] = 232072,
  [SMALL_STATE(5616)] = 232112,
  [SMALL_STATE(5617)] = 232152,
  [SMALL_STATE(5618)] = 232180,
  [SMALL_STATE(5619)] = 232232,
  [SMALL_STATE(5620)] = 232284,
  [SMALL_STATE(5621)] = 232324,
  [SMALL_STATE(5622)] = 232376,
  [SMALL_STATE(5623)] = 232416,
  [SMALL_STATE(5624)] = 232448,
  [SMALL_STATE(5625)] = 232512,
  [SMALL_STATE(5626)] = 232552,
  [SMALL_STATE(5627)] = 232604,
  [SMALL_STATE(5628)] = 232656,
  [SMALL_STATE(5629)] = 232706,
  [SMALL_STATE(5630)] = 232746,
  [SMALL_STATE(5631)] = 232786,
  [SMALL_STATE(5632)] = 232826,
  [SMALL_STATE(5633)] = 232866,
  [SMALL_STATE(5634)] = 232906,
  [SMALL_STATE(5635)] = 232946,
  [SMALL_STATE(5636)] = 232978,
  [SMALL_STATE(5637)] = 233030,
  [SMALL_STATE(5638)] = 233070,
  [SMALL_STATE(5639)] = 233110,
  [SMALL_STATE(5640)] = 233160,
  [SMALL_STATE(5641)] = 233200,
  [SMALL_STATE(5642)] = 233252,
  [SMALL_STATE(5643)] = 233304,
  [SMALL_STATE(5644)] = 233344,
  [SMALL_STATE(5645)] = 233384,
  [SMALL_STATE(5646)] = 233424,
  [SMALL_STATE(5647)] = 233464,
  [SMALL_STATE(5648)] = 233504,
  [SMALL_STATE(5649)] = 233556,
  [SMALL_STATE(5650)] = 233620,
  [SMALL_STATE(5651)] = 233672,
  [SMALL_STATE(5652)] = 233712,
  [SMALL_STATE(5653)] = 233752,
  [SMALL_STATE(5654)] = 233780,
  [SMALL_STATE(5655)] = 233830,
  [SMALL_STATE(5656)] = 233870,
  [SMALL_STATE(5657)] = 233910,
  [SMALL_STATE(5658)] = 233950,
  [SMALL_STATE(5659)] = 234014,
  [SMALL_STATE(5660)] = 234058,
  [SMALL_STATE(5661)] = 234104,
  [SMALL_STATE(5662)] = 234144,
  [SMALL_STATE(5663)] = 234176,
  [SMALL_STATE(5664)] = 234216,
  [SMALL_STATE(5665)] = 234280,
  [SMALL_STATE(5666)] = 234332,
  [SMALL_STATE(5667)] = 234372,
  [SMALL_STATE(5668)] = 234412,
  [SMALL_STATE(5669)] = 234452,
  [SMALL_STATE(5670)] = 234492,
  [SMALL_STATE(5671)] = 234532,
  [SMALL_STATE(5672)] = 234582,
  [SMALL_STATE(5673)] = 234634,
  [SMALL_STATE(5674)] = 234686,
  [SMALL_STATE(5675)] = 234726,
  [SMALL_STATE(5676)] = 234766,
  [SMALL_STATE(5677)] = 234806,
  [SMALL_STATE(5678)] = 234846,
  [SMALL_STATE(5679)] = 234874,
  [SMALL_STATE(5680)] = 234914,
  [SMALL_STATE(5681)] = 234942,
  [SMALL_STATE(5682)] = 234994,
  [SMALL_STATE(5683)] = 235034,
  [SMALL_STATE(5684)] = 235066,
  [SMALL_STATE(5685)] = 235116,
  [SMALL_STATE(5686)] = 235168,
  [SMALL_STATE(5687)] = 235196,
  [SMALL_STATE(5688)] = 235248,
  [SMALL_STATE(5689)] = 235300,
  [SMALL_STATE(5690)] = 235340,
  [SMALL_STATE(5691)] = 235390,
  [SMALL_STATE(5692)] = 235438,
  [SMALL_STATE(5693)] = 235490,
  [SMALL_STATE(5694)] = 235554,
  [SMALL_STATE(5695)] = 235600,
  [SMALL_STATE(5696)] = 235652,
  [SMALL_STATE(5697)] = 235716,
  [SMALL_STATE(5698)] = 235756,
  [SMALL_STATE(5699)] = 235783,
  [SMALL_STATE(5700)] = 235828,
  [SMALL_STATE(5701)] = 235885,
  [SMALL_STATE(5702)] = 235912,
  [SMALL_STATE(5703)] = 235939,
  [SMALL_STATE(5704)] = 235966,
  [SMALL_STATE(5705)] = 236013,
  [SMALL_STATE(5706)] = 236060,
  [SMALL_STATE(5707)] = 236109,
  [SMALL_STATE(5708)] = 236136,
  [SMALL_STATE(5709)] = 236183,
  [SMALL_STATE(5710)] = 236212,
  [SMALL_STATE(5711)] = 236259,
  [SMALL_STATE(5712)] = 236304,
  [SMALL_STATE(5713)] = 236361,
  [SMALL_STATE(5714)] = 236390,
  [SMALL_STATE(5715)] = 236417,
  [SMALL_STATE(5716)] = 236444,
  [SMALL_STATE(5717)] = 236491,
  [SMALL_STATE(5718)] = 236524,
  [SMALL_STATE(5719)] = 236569,
  [SMALL_STATE(5720)] = 236612,
  [SMALL_STATE(5721)] = 236639,
  [SMALL_STATE(5722)] = 236680,
  [SMALL_STATE(5723)] = 236725,
  [SMALL_STATE(5724)] = 236764,
  [SMALL_STATE(5725)] = 236813,
  [SMALL_STATE(5726)] = 236850,
  [SMALL_STATE(5727)] = 236877,
  [SMALL_STATE(5728)] = 236904,
  [SMALL_STATE(5729)] = 236949,
  [SMALL_STATE(5730)] = 237004,
  [SMALL_STATE(5731)] = 237031,
  [SMALL_STATE(5732)] = 237058,
  [SMALL_STATE(5733)] = 237115,
  [SMALL_STATE(5734)] = 237150,
  [SMALL_STATE(5735)] = 237193,
  [SMALL_STATE(5736)] = 237220,
  [SMALL_STATE(5737)] = 237253,
  [SMALL_STATE(5738)] = 237284,
  [SMALL_STATE(5739)] = 237329,
  [SMALL_STATE(5740)] = 237374,
  [SMALL_STATE(5741)] = 237431,
  [SMALL_STATE(5742)] = 237464,
  [SMALL_STATE(5743)] = 237509,
  [SMALL_STATE(5744)] = 237556,
  [SMALL_STATE(5745)] = 237603,
  [SMALL_STATE(5746)] = 237648,
  [SMALL_STATE(5747)] = 237675,
  [SMALL_STATE(5748)] = 237720,
  [SMALL_STATE(5749)] = 237747,
  [SMALL_STATE(5750)] = 237792,
  [SMALL_STATE(5751)] = 237849,
  [SMALL_STATE(5752)] = 237894,
  [SMALL_STATE(5753)] = 237941,
  [SMALL_STATE(5754)] = 237968,
  [SMALL_STATE(5755)] = 237995,
  [SMALL_STATE(5756)] = 238022,
  [SMALL_STATE(5757)] = 238049,
  [SMALL_STATE(5758)] = 238076,
  [SMALL_STATE(5759)] = 238103,
  [SMALL_STATE(5760)] = 238130,
  [SMALL_STATE(5761)] = 238163,
  [SMALL_STATE(5762)] = 238190,
  [SMALL_STATE(5763)] = 238235,
  [SMALL_STATE(5764)] = 238262,
  [SMALL_STATE(5765)] = 238319,
  [SMALL_STATE(5766)] = 238376,
  [SMALL_STATE(5767)] = 238421,
  [SMALL_STATE(5768)] = 238454,
  [SMALL_STATE(5769)] = 238499,
  [SMALL_STATE(5770)] = 238542,
  [SMALL_STATE(5771)] = 238589,
  [SMALL_STATE(5772)] = 238636,
  [SMALL_STATE(5773)] = 238663,
  [SMALL_STATE(5774)] = 238690,
  [SMALL_STATE(5775)] = 238717,
  [SMALL_STATE(5776)] = 238744,
  [SMALL_STATE(5777)] = 238771,
  [SMALL_STATE(5778)] = 238798,
  [SMALL_STATE(5779)] = 238825,
  [SMALL_STATE(5780)] = 238872,
  [SMALL_STATE(5781)] = 238919,
  [SMALL_STATE(5782)] = 238955,
  [SMALL_STATE(5783)] = 238983,
  [SMALL_STATE(5784)] = 239013,
  [SMALL_STATE(5785)] = 239049,
  [SMALL_STATE(5786)] = 239075,
  [SMALL_STATE(5787)] = 239111,
  [SMALL_STATE(5788)] = 239137,
  [SMALL_STATE(5789)] = 239175,
  [SMALL_STATE(5790)] = 239213,
  [SMALL_STATE(5791)] = 239251,
  [SMALL_STATE(5792)] = 239289,
  [SMALL_STATE(5793)] = 239327,
  [SMALL_STATE(5794)] = 239365,
  [SMALL_STATE(5795)] = 239403,
  [SMALL_STATE(5796)] = 239441,
  [SMALL_STATE(5797)] = 239467,
  [SMALL_STATE(5798)] = 239519,
  [SMALL_STATE(5799)] = 239545,
  [SMALL_STATE(5800)] = 239571,
  [SMALL_STATE(5801)] = 239597,
  [SMALL_STATE(5802)] = 239623,
  [SMALL_STATE(5803)] = 239675,
  [SMALL_STATE(5804)] = 239709,
  [SMALL_STATE(5805)] = 239735,
  [SMALL_STATE(5806)] = 239765,
  [SMALL_STATE(5807)] = 239799,
  [SMALL_STATE(5808)] = 239833,
  [SMALL_STATE(5809)] = 239867,
  [SMALL_STATE(5810)] = 239893,
  [SMALL_STATE(5811)] = 239923,
  [SMALL_STATE(5812)] = 239949,
  [SMALL_STATE(5813)] = 239983,
  [SMALL_STATE(5814)] = 240031,
  [SMALL_STATE(5815)] = 240057,
  [SMALL_STATE(5816)] = 240083,
  [SMALL_STATE(5817)] = 240113,
  [SMALL_STATE(5818)] = 240147,
  [SMALL_STATE(5819)] = 240173,
  [SMALL_STATE(5820)] = 240199,
  [SMALL_STATE(5821)] = 240225,
  [SMALL_STATE(5822)] = 240273,
  [SMALL_STATE(5823)] = 240307,
  [SMALL_STATE(5824)] = 240333,
  [SMALL_STATE(5825)] = 240375,
  [SMALL_STATE(5826)] = 240401,
  [SMALL_STATE(5827)] = 240453,
  [SMALL_STATE(5828)] = 240507,
  [SMALL_STATE(5829)] = 240537,
  [SMALL_STATE(5830)] = 240589,
  [SMALL_STATE(5831)] = 240625,
  [SMALL_STATE(5832)] = 240651,
  [SMALL_STATE(5833)] = 240685,
  [SMALL_STATE(5834)] = 240733,
  [SMALL_STATE(5835)] = 240759,
  [SMALL_STATE(5836)] = 240811,
  [SMALL_STATE(5837)] = 240859,
  [SMALL_STATE(5838)] = 240885,
  [SMALL_STATE(5839)] = 240919,
  [SMALL_STATE(5840)] = 240945,
  [SMALL_STATE(5841)] = 240981,
  [SMALL_STATE(5842)] = 241015,
  [SMALL_STATE(5843)] = 241052,
  [SMALL_STATE(5844)] = 241079,
  [SMALL_STATE(5845)] = 241104,
  [SMALL_STATE(5846)] = 241133,
  [SMALL_STATE(5847)] = 241182,
  [SMALL_STATE(5848)] = 241225,
  [SMALL_STATE(5849)] = 241274,
  [SMALL_STATE(5850)] = 241311,
  [SMALL_STATE(5851)] = 241354,
  [SMALL_STATE(5852)] = 241391,
  [SMALL_STATE(5853)] = 241422,
  [SMALL_STATE(5854)] = 241459,
  [SMALL_STATE(5855)] = 241508,
  [SMALL_STATE(5856)] = 241557,
  [SMALL_STATE(5857)] = 241606,
  [SMALL_STATE(5858)] = 241655,
  [SMALL_STATE(5859)] = 241688,
  [SMALL_STATE(5860)] = 241737,
  [SMALL_STATE(5861)] = 241786,
  [SMALL_STATE(5862)] = 241829,
  [SMALL_STATE(5863)] = 241878,
  [SMALL_STATE(5864)] = 241915,
  [SMALL_STATE(5865)] = 241952,
  [SMALL_STATE(5866)] = 241983,
  [SMALL_STATE(5867)] = 242032,
  [SMALL_STATE(5868)] = 242069,
  [SMALL_STATE(5869)] = 242106,
  [SMALL_STATE(5870)] = 242143,
  [SMALL_STATE(5871)] = 242180,
  [SMALL_STATE(5872)] = 242227,
  [SMALL_STATE(5873)] = 242276,
  [SMALL_STATE(5874)] = 242325,
  [SMALL_STATE(5875)] = 242374,
  [SMALL_STATE(5876)] = 242417,
  [SMALL_STATE(5877)] = 242466,
  [SMALL_STATE(5878)] = 242515,
  [SMALL_STATE(5879)] = 242556,
  [SMALL_STATE(5880)] = 242605,
  [SMALL_STATE(5881)] = 242654,
  [SMALL_STATE(5882)] = 242691,
  [SMALL_STATE(5883)] = 242740,
  [SMALL_STATE(5884)] = 242783,
  [SMALL_STATE(5885)] = 242814,
  [SMALL_STATE(5886)] = 242863,
  [SMALL_STATE(5887)] = 242906,
  [SMALL_STATE(5888)] = 242947,
  [SMALL_STATE(5889)] = 242984,
  [SMALL_STATE(5890)] = 243021,
  [SMALL_STATE(5891)] = 243070,
  [SMALL_STATE(5892)] = 243099,
  [SMALL_STATE(5893)] = 243136,
  [SMALL_STATE(5894)] = 243167,
  [SMALL_STATE(5895)] = 243204,
  [SMALL_STATE(5896)] = 243241,
  [SMALL_STATE(5897)] = 243265,
  [SMALL_STATE(5898)] = 243289,
  [SMALL_STATE(5899)] = 243313,
  [SMALL_STATE(5900)] = 243337,
  [SMALL_STATE(5901)] = 243361,
  [SMALL_STATE(5902)] = 243393,
  [SMALL_STATE(5903)] = 243425,
  [SMALL_STATE(5904)] = 243457,
  [SMALL_STATE(5905)] = 243497,
  [SMALL_STATE(5906)] = 243529,
  [SMALL_STATE(5907)] = 243561,
  [SMALL_STATE(5908)] = 243601,
  [SMALL_STATE(5909)] = 243641,
  [SMALL_STATE(5910)] = 243673,
  [SMALL_STATE(5911)] = 243705,
  [SMALL_STATE(5912)] = 243737,
  [SMALL_STATE(5913)] = 243761,
  [SMALL_STATE(5914)] = 243785,
  [SMALL_STATE(5915)] = 243825,
  [SMALL_STATE(5916)] = 243849,
  [SMALL_STATE(5917)] = 243873,
  [SMALL_STATE(5918)] = 243897,
  [SMALL_STATE(5919)] = 243937,
  [SMALL_STATE(5920)] = 243961,
  [SMALL_STATE(5921)] = 243985,
  [SMALL_STATE(5922)] = 244009,
  [SMALL_STATE(5923)] = 244033,
  [SMALL_STATE(5924)] = 244069,
  [SMALL_STATE(5925)] = 244105,
  [SMALL_STATE(5926)] = 244145,
  [SMALL_STATE(5927)] = 244185,
  [SMALL_STATE(5928)] = 244209,
  [SMALL_STATE(5929)] = 244241,
  [SMALL_STATE(5930)] = 244281,
  [SMALL_STATE(5931)] = 244313,
  [SMALL_STATE(5932)] = 244345,
  [SMALL_STATE(5933)] = 244385,
  [SMALL_STATE(5934)] = 244417,
  [SMALL_STATE(5935)] = 244457,
  [SMALL_STATE(5936)] = 244481,
  [SMALL_STATE(5937)] = 244513,
  [SMALL_STATE(5938)] = 244539,
  [SMALL_STATE(5939)] = 244563,
  [SMALL_STATE(5940)] = 244595,
  [SMALL_STATE(5941)] = 244619,
  [SMALL_STATE(5942)] = 244655,
  [SMALL_STATE(5943)] = 244679,
  [SMALL_STATE(5944)] = 244703,
  [SMALL_STATE(5945)] = 244727,
  [SMALL_STATE(5946)] = 244767,
  [SMALL_STATE(5947)] = 244791,
  [SMALL_STATE(5948)] = 244823,
  [SMALL_STATE(5949)] = 244855,
  [SMALL_STATE(5950)] = 244879,
  [SMALL_STATE(5951)] = 244903,
  [SMALL_STATE(5952)] = 244927,
  [SMALL_STATE(5953)] = 244951,
  [SMALL_STATE(5954)] = 244997,
  [SMALL_STATE(5955)] = 245029,
  [SMALL_STATE(5956)] = 245061,
  [SMALL_STATE(5957)] = 245093,
  [SMALL_STATE(5958)] = 245133,
  [SMALL_STATE(5959)] = 245165,
  [SMALL_STATE(5960)] = 245197,
  [SMALL_STATE(5961)] = 245237,
  [SMALL_STATE(5962)] = 245269,
  [SMALL_STATE(5963)] = 245309,
  [SMALL_STATE(5964)] = 245341,
  [SMALL_STATE(5965)] = 245365,
  [SMALL_STATE(5966)] = 245397,
  [SMALL_STATE(5967)] = 245421,
  [SMALL_STATE(5968)] = 245453,
  [SMALL_STATE(5969)] = 245489,
  [SMALL_STATE(5970)] = 245529,
  [SMALL_STATE(5971)] = 245565,
  [SMALL_STATE(5972)] = 245589,
  [SMALL_STATE(5973)] = 245613,
  [SMALL_STATE(5974)] = 245637,
  [SMALL_STATE(5975)] = 245661,
  [SMALL_STATE(5976)] = 245685,
  [SMALL_STATE(5977)] = 245717,
  [SMALL_STATE(5978)] = 245741,
  [SMALL_STATE(5979)] = 245765,
  [SMALL_STATE(5980)] = 245801,
  [SMALL_STATE(5981)] = 245833,
  [SMALL_STATE(5982)] = 245873,
  [SMALL_STATE(5983)] = 245909,
  [SMALL_STATE(5984)] = 245941,
  [SMALL_STATE(5985)] = 245969,
  [SMALL_STATE(5986)] = 246001,
  [SMALL_STATE(5987)] = 246025,
  [SMALL_STATE(5988)] = 246049,
  [SMALL_STATE(5989)] = 246073,
  [SMALL_STATE(5990)] = 246113,
  [SMALL_STATE(5991)] = 246137,
  [SMALL_STATE(5992)] = 246161,
  [SMALL_STATE(5993)] = 246197,
  [SMALL_STATE(5994)] = 246229,
  [SMALL_STATE(5995)] = 246261,
  [SMALL_STATE(5996)] = 246293,
  [SMALL_STATE(5997)] = 246333,
  [SMALL_STATE(5998)] = 246375,
  [SMALL_STATE(5999)] = 246399,
  [SMALL_STATE(6000)] = 246439,
  [SMALL_STATE(6001)] = 246463,
  [SMALL_STATE(6002)] = 246487,
  [SMALL_STATE(6003)] = 246527,
  [SMALL_STATE(6004)] = 246551,
  [SMALL_STATE(6005)] = 246575,
  [SMALL_STATE(6006)] = 246599,
  [SMALL_STATE(6007)] = 246623,
  [SMALL_STATE(6008)] = 246647,
  [SMALL_STATE(6009)] = 246679,
  [SMALL_STATE(6010)] = 246703,
  [SMALL_STATE(6011)] = 246735,
  [SMALL_STATE(6012)] = 246775,
  [SMALL_STATE(6013)] = 246810,
  [SMALL_STATE(6014)] = 246853,
  [SMALL_STATE(6015)] = 246892,
  [SMALL_STATE(6016)] = 246927,
  [SMALL_STATE(6017)] = 246956,
  [SMALL_STATE(6018)] = 246995,
  [SMALL_STATE(6019)] = 247024,
  [SMALL_STATE(6020)] = 247053,
  [SMALL_STATE(6021)] = 247086,
  [SMALL_STATE(6022)] = 247115,
  [SMALL_STATE(6023)] = 247148,
  [SMALL_STATE(6024)] = 247181,
  [SMALL_STATE(6025)] = 247210,
  [SMALL_STATE(6026)] = 247245,
  [SMALL_STATE(6027)] = 247274,
  [SMALL_STATE(6028)] = 247307,
  [SMALL_STATE(6029)] = 247342,
  [SMALL_STATE(6030)] = 247377,
  [SMALL_STATE(6031)] = 247412,
  [SMALL_STATE(6032)] = 247441,
  [SMALL_STATE(6033)] = 247470,
  [SMALL_STATE(6034)] = 247513,
  [SMALL_STATE(6035)] = 247542,
  [SMALL_STATE(6036)] = 247577,
  [SMALL_STATE(6037)] = 247606,
  [SMALL_STATE(6038)] = 247641,
  [SMALL_STATE(6039)] = 247680,
  [SMALL_STATE(6040)] = 247715,
  [SMALL_STATE(6041)] = 247754,
  [SMALL_STATE(6042)] = 247789,
  [SMALL_STATE(6043)] = 247828,
  [SMALL_STATE(6044)] = 247871,
  [SMALL_STATE(6045)] = 247914,
  [SMALL_STATE(6046)] = 247947,
  [SMALL_STATE(6047)] = 247976,
  [SMALL_STATE(6048)] = 248009,
  [SMALL_STATE(6049)] = 248044,
  [SMALL_STATE(6050)] = 248077,
  [SMALL_STATE(6051)] = 248112,
  [SMALL_STATE(6052)] = 248147,
  [SMALL_STATE(6053)] = 248190,
  [SMALL_STATE(6054)] = 248225,
  [SMALL_STATE(6055)] = 248260,
  [SMALL_STATE(6056)] = 248293,
  [SMALL_STATE(6057)] = 248322,
  [SMALL_STATE(6058)] = 248357,
  [SMALL_STATE(6059)] = 248396,
  [SMALL_STATE(6060)] = 248429,
  [SMALL_STATE(6061)] = 248464,
  [SMALL_STATE(6062)] = 248499,
  [SMALL_STATE(6063)] = 248534,
  [SMALL_STATE(6064)] = 248577,
  [SMALL_STATE(6065)] = 248610,
  [SMALL_STATE(6066)] = 248645,
  [SMALL_STATE(6067)] = 248680,
  [SMALL_STATE(6068)] = 248713,
  [SMALL_STATE(6069)] = 248742,
  [SMALL_STATE(6070)] = 248777,
  [SMALL_STATE(6071)] = 248812,
  [SMALL_STATE(6072)] = 248841,
  [SMALL_STATE(6073)] = 248870,
  [SMALL_STATE(6074)] = 248899,
  [SMALL_STATE(6075)] = 248942,
  [SMALL_STATE(6076)] = 248977,
  [SMALL_STATE(6077)] = 249006,
  [SMALL_STATE(6078)] = 249041,
  [SMALL_STATE(6079)] = 249070,
  [SMALL_STATE(6080)] = 249103,
  [SMALL_STATE(6081)] = 249132,
  [SMALL_STATE(6082)] = 249175,
  [SMALL_STATE(6083)] = 249202,
  [SMALL_STATE(6084)] = 249241,
  [SMALL_STATE(6085)] = 249276,
  [SMALL_STATE(6086)] = 249311,
  [SMALL_STATE(6087)] = 249346,
  [SMALL_STATE(6088)] = 249381,
  [SMALL_STATE(6089)] = 249416,
  [SMALL_STATE(6090)] = 249451,
  [SMALL_STATE(6091)] = 249484,
  [SMALL_STATE(6092)] = 249513,
  [SMALL_STATE(6093)] = 249546,
  [SMALL_STATE(6094)] = 249589,
  [SMALL_STATE(6095)] = 249618,
  [SMALL_STATE(6096)] = 249651,
  [SMALL_STATE(6097)] = 249694,
  [SMALL_STATE(6098)] = 249727,
  [SMALL_STATE(6099)] = 249756,
  [SMALL_STATE(6100)] = 249795,
  [SMALL_STATE(6101)] = 249835,
  [SMALL_STATE(6102)] = 249867,
  [SMALL_STATE(6103)] = 249897,
  [SMALL_STATE(6104)] = 249919,
  [SMALL_STATE(6105)] = 249959,
  [SMALL_STATE(6106)] = 249989,
  [SMALL_STATE(6107)] = 250019,
  [SMALL_STATE(6108)] = 250049,
  [SMALL_STATE(6109)] = 250079,
  [SMALL_STATE(6110)] = 250109,
  [SMALL_STATE(6111)] = 250139,
  [SMALL_STATE(6112)] = 250169,
  [SMALL_STATE(6113)] = 250201,
  [SMALL_STATE(6114)] = 250239,
  [SMALL_STATE(6115)] = 250269,
  [SMALL_STATE(6116)] = 250309,
  [SMALL_STATE(6117)] = 250339,
  [SMALL_STATE(6118)] = 250379,
  [SMALL_STATE(6119)] = 250409,
  [SMALL_STATE(6120)] = 250439,
  [SMALL_STATE(6121)] = 250477,
  [SMALL_STATE(6122)] = 250517,
  [SMALL_STATE(6123)] = 250555,
  [SMALL_STATE(6124)] = 250585,
  [SMALL_STATE(6125)] = 250625,
  [SMALL_STATE(6126)] = 250651,
  [SMALL_STATE(6127)] = 250683,
  [SMALL_STATE(6128)] = 250713,
  [SMALL_STATE(6129)] = 250743,
  [SMALL_STATE(6130)] = 250783,
  [SMALL_STATE(6131)] = 250821,
  [SMALL_STATE(6132)] = 250853,
  [SMALL_STATE(6133)] = 250891,
  [SMALL_STATE(6134)] = 250921,
  [SMALL_STATE(6135)] = 250961,
  [SMALL_STATE(6136)] = 251001,
  [SMALL_STATE(6137)] = 251033,
  [SMALL_STATE(6138)] = 251071,
  [SMALL_STATE(6139)] = 251101,
  [SMALL_STATE(6140)] = 251131,
  [SMALL_STATE(6141)] = 251163,
  [SMALL_STATE(6142)] = 251201,
  [SMALL_STATE(6143)] = 251223,
  [SMALL_STATE(6144)] = 251247,
  [SMALL_STATE(6145)] = 251287,
  [SMALL_STATE(6146)] = 251319,
  [SMALL_STATE(6147)] = 251341,
  [SMALL_STATE(6148)] = 251373,
  [SMALL_STATE(6149)] = 251413,
  [SMALL_STATE(6150)] = 251451,
  [SMALL_STATE(6151)] = 251481,
  [SMALL_STATE(6152)] = 251515,
  [SMALL_STATE(6153)] = 251555,
  [SMALL_STATE(6154)] = 251577,
  [SMALL_STATE(6155)] = 251607,
  [SMALL_STATE(6156)] = 251637,
  [SMALL_STATE(6157)] = 251669,
  [SMALL_STATE(6158)] = 251707,
  [SMALL_STATE(6159)] = 251739,
  [SMALL_STATE(6160)] = 251779,
  [SMALL_STATE(6161)] = 251805,
  [SMALL_STATE(6162)] = 251837,
  [SMALL_STATE(6163)] = 251867,
  [SMALL_STATE(6164)] = 251907,
  [SMALL_STATE(6165)] = 251941,
  [SMALL_STATE(6166)] = 251979,
  [SMALL_STATE(6167)] = 252017,
  [SMALL_STATE(6168)] = 252051,
  [SMALL_STATE(6169)] = 252083,
  [SMALL_STATE(6170)] = 252121,
  [SMALL_STATE(6171)] = 252161,
  [SMALL_STATE(6172)] = 252199,
  [SMALL_STATE(6173)] = 252237,
  [SMALL_STATE(6174)] = 252271,
  [SMALL_STATE(6175)] = 252303,
  [SMALL_STATE(6176)] = 252333,
  [SMALL_STATE(6177)] = 252373,
  [SMALL_STATE(6178)] = 252405,
  [SMALL_STATE(6179)] = 252445,
  [SMALL_STATE(6180)] = 252477,
  [SMALL_STATE(6181)] = 252517,
  [SMALL_STATE(6182)] = 252555,
  [SMALL_STATE(6183)] = 252589,
  [SMALL_STATE(6184)] = 252619,
  [SMALL_STATE(6185)] = 252649,
  [SMALL_STATE(6186)] = 252673,
  [SMALL_STATE(6187)] = 252711,
  [SMALL_STATE(6188)] = 252751,
  [SMALL_STATE(6189)] = 252789,
  [SMALL_STATE(6190)] = 252821,
  [SMALL_STATE(6191)] = 252851,
  [SMALL_STATE(6192)] = 252881,
  [SMALL_STATE(6193)] = 252913,
  [SMALL_STATE(6194)] = 252947,
  [SMALL_STATE(6195)] = 252987,
  [SMALL_STATE(6196)] = 253021,
  [SMALL_STATE(6197)] = 253061,
  [SMALL_STATE(6198)] = 253101,
  [SMALL_STATE(6199)] = 253139,
  [SMALL_STATE(6200)] = 253173,
  [SMALL_STATE(6201)] = 253203,
  [SMALL_STATE(6202)] = 253241,
  [SMALL_STATE(6203)] = 253273,
  [SMALL_STATE(6204)] = 253306,
  [SMALL_STATE(6205)] = 253341,
  [SMALL_STATE(6206)] = 253374,
  [SMALL_STATE(6207)] = 253407,
  [SMALL_STATE(6208)] = 253442,
  [SMALL_STATE(6209)] = 253469,
  [SMALL_STATE(6210)] = 253502,
  [SMALL_STATE(6211)] = 253527,
  [SMALL_STATE(6212)] = 253560,
  [SMALL_STATE(6213)] = 253587,
  [SMALL_STATE(6214)] = 253616,
  [SMALL_STATE(6215)] = 253643,
  [SMALL_STATE(6216)] = 253676,
  [SMALL_STATE(6217)] = 253705,
  [SMALL_STATE(6218)] = 253734,
  [SMALL_STATE(6219)] = 253763,
  [SMALL_STATE(6220)] = 253792,
  [SMALL_STATE(6221)] = 253829,
  [SMALL_STATE(6222)] = 253862,
  [SMALL_STATE(6223)] = 253901,
  [SMALL_STATE(6224)] = 253928,
  [SMALL_STATE(6225)] = 253953,
  [SMALL_STATE(6226)] = 253988,
  [SMALL_STATE(6227)] = 254021,
  [SMALL_STATE(6228)] = 254056,
  [SMALL_STATE(6229)] = 254085,
  [SMALL_STATE(6230)] = 254118,
  [SMALL_STATE(6231)] = 254157,
  [SMALL_STATE(6232)] = 254184,
  [SMALL_STATE(6233)] = 254211,
  [SMALL_STATE(6234)] = 254250,
  [SMALL_STATE(6235)] = 254277,
  [SMALL_STATE(6236)] = 254310,
  [SMALL_STATE(6237)] = 254345,
  [SMALL_STATE(6238)] = 254378,
  [SMALL_STATE(6239)] = 254403,
  [SMALL_STATE(6240)] = 254436,
  [SMALL_STATE(6241)] = 254463,
  [SMALL_STATE(6242)] = 254498,
  [SMALL_STATE(6243)] = 254535,
  [SMALL_STATE(6244)] = 254560,
  [SMALL_STATE(6245)] = 254593,
  [SMALL_STATE(6246)] = 254626,
  [SMALL_STATE(6247)] = 254659,
  [SMALL_STATE(6248)] = 254692,
  [SMALL_STATE(6249)] = 254727,
  [SMALL_STATE(6250)] = 254762,
  [SMALL_STATE(6251)] = 254797,
  [SMALL_STATE(6252)] = 254830,
  [SMALL_STATE(6253)] = 254869,
  [SMALL_STATE(6254)] = 254902,
  [SMALL_STATE(6255)] = 254935,
  [SMALL_STATE(6256)] = 254970,
  [SMALL_STATE(6257)] = 255003,
  [SMALL_STATE(6258)] = 255042,
  [SMALL_STATE(6259)] = 255071,
  [SMALL_STATE(6260)] = 255104,
  [SMALL_STATE(6261)] = 255137,
  [SMALL_STATE(6262)] = 255166,
  [SMALL_STATE(6263)] = 255199,
  [SMALL_STATE(6264)] = 255224,
  [SMALL_STATE(6265)] = 255257,
  [SMALL_STATE(6266)] = 255290,
  [SMALL_STATE(6267)] = 255315,
  [SMALL_STATE(6268)] = 255348,
  [SMALL_STATE(6269)] = 255383,
  [SMALL_STATE(6270)] = 255416,
  [SMALL_STATE(6271)] = 255449,
  [SMALL_STATE(6272)] = 255484,
  [SMALL_STATE(6273)] = 255517,
  [SMALL_STATE(6274)] = 255550,
  [SMALL_STATE(6275)] = 255583,
  [SMALL_STATE(6276)] = 255616,
  [SMALL_STATE(6277)] = 255649,
  [SMALL_STATE(6278)] = 255669,
  [SMALL_STATE(6279)] = 255695,
  [SMALL_STATE(6280)] = 255731,
  [SMALL_STATE(6281)] = 255767,
  [SMALL_STATE(6282)] = 255803,
  [SMALL_STATE(6283)] = 255829,
  [SMALL_STATE(6284)] = 255865,
  [SMALL_STATE(6285)] = 255901,
  [SMALL_STATE(6286)] = 255921,
  [SMALL_STATE(6287)] = 255957,
  [SMALL_STATE(6288)] = 255993,
  [SMALL_STATE(6289)] = 256029,
  [SMALL_STATE(6290)] = 256065,
  [SMALL_STATE(6291)] = 256101,
  [SMALL_STATE(6292)] = 256137,
  [SMALL_STATE(6293)] = 256173,
  [SMALL_STATE(6294)] = 256209,
  [SMALL_STATE(6295)] = 256245,
  [SMALL_STATE(6296)] = 256271,
  [SMALL_STATE(6297)] = 256307,
  [SMALL_STATE(6298)] = 256327,
  [SMALL_STATE(6299)] = 256347,
  [SMALL_STATE(6300)] = 256367,
  [SMALL_STATE(6301)] = 256387,
  [SMALL_STATE(6302)] = 256413,
  [SMALL_STATE(6303)] = 256443,
  [SMALL_STATE(6304)] = 256473,
  [SMALL_STATE(6305)] = 256503,
  [SMALL_STATE(6306)] = 256533,
  [SMALL_STATE(6307)] = 256553,
  [SMALL_STATE(6308)] = 256589,
  [SMALL_STATE(6309)] = 256609,
  [SMALL_STATE(6310)] = 256629,
  [SMALL_STATE(6311)] = 256659,
  [SMALL_STATE(6312)] = 256689,
  [SMALL_STATE(6313)] = 256725,
  [SMALL_STATE(6314)] = 256755,
  [SMALL_STATE(6315)] = 256785,
  [SMALL_STATE(6316)] = 256821,
  [SMALL_STATE(6317)] = 256841,
  [SMALL_STATE(6318)] = 256863,
  [SMALL_STATE(6319)] = 256889,
  [SMALL_STATE(6320)] = 256915,
  [SMALL_STATE(6321)] = 256951,
  [SMALL_STATE(6322)] = 256987,
  [SMALL_STATE(6323)] = 257013,
  [SMALL_STATE(6324)] = 257039,
  [SMALL_STATE(6325)] = 257059,
  [SMALL_STATE(6326)] = 257094,
  [SMALL_STATE(6327)] = 257119,
  [SMALL_STATE(6328)] = 257138,
  [SMALL_STATE(6329)] = 257165,
  [SMALL_STATE(6330)] = 257184,
  [SMALL_STATE(6331)] = 257215,
  [SMALL_STATE(6332)] = 257240,
  [SMALL_STATE(6333)] = 257275,
  [SMALL_STATE(6334)] = 257310,
  [SMALL_STATE(6335)] = 257343,
  [SMALL_STATE(6336)] = 257362,
  [SMALL_STATE(6337)] = 257381,
  [SMALL_STATE(6338)] = 257410,
  [SMALL_STATE(6339)] = 257441,
  [SMALL_STATE(6340)] = 257476,
  [SMALL_STATE(6341)] = 257511,
  [SMALL_STATE(6342)] = 257540,
  [SMALL_STATE(6343)] = 257569,
  [SMALL_STATE(6344)] = 257598,
  [SMALL_STATE(6345)] = 257623,
  [SMALL_STATE(6346)] = 257648,
  [SMALL_STATE(6347)] = 257675,
  [SMALL_STATE(6348)] = 257702,
  [SMALL_STATE(6349)] = 257727,
  [SMALL_STATE(6350)] = 257752,
  [SMALL_STATE(6351)] = 257787,
  [SMALL_STATE(6352)] = 257812,
  [SMALL_STATE(6353)] = 257839,
  [SMALL_STATE(6354)] = 257874,
  [SMALL_STATE(6355)] = 257899,
  [SMALL_STATE(6356)] = 257932,
  [SMALL_STATE(6357)] = 257963,
  [SMALL_STATE(6358)] = 257998,
  [SMALL_STATE(6359)] = 258033,
  [SMALL_STATE(6360)] = 258066,
  [SMALL_STATE(6361)] = 258095,
  [SMALL_STATE(6362)] = 258120,
  [SMALL_STATE(6363)] = 258145,
  [SMALL_STATE(6364)] = 258172,
  [SMALL_STATE(6365)] = 258203,
  [SMALL_STATE(6366)] = 258230,
  [SMALL_STATE(6367)] = 258257,
  [SMALL_STATE(6368)] = 258286,
  [SMALL_STATE(6369)] = 258315,
  [SMALL_STATE(6370)] = 258342,
  [SMALL_STATE(6371)] = 258367,
  [SMALL_STATE(6372)] = 258392,
  [SMALL_STATE(6373)] = 258419,
  [SMALL_STATE(6374)] = 258446,
  [SMALL_STATE(6375)] = 258473,
  [SMALL_STATE(6376)] = 258502,
  [SMALL_STATE(6377)] = 258531,
  [SMALL_STATE(6378)] = 258560,
  [SMALL_STATE(6379)] = 258591,
  [SMALL_STATE(6380)] = 258626,
  [SMALL_STATE(6381)] = 258653,
  [SMALL_STATE(6382)] = 258684,
  [SMALL_STATE(6383)] = 258719,
  [SMALL_STATE(6384)] = 258744,
  [SMALL_STATE(6385)] = 258777,
  [SMALL_STATE(6386)] = 258802,
  [SMALL_STATE(6387)] = 258835,
  [SMALL_STATE(6388)] = 258862,
  [SMALL_STATE(6389)] = 258889,
  [SMALL_STATE(6390)] = 258916,
  [SMALL_STATE(6391)] = 258943,
  [SMALL_STATE(6392)] = 258970,
  [SMALL_STATE(6393)] = 259005,
  [SMALL_STATE(6394)] = 259032,
  [SMALL_STATE(6395)] = 259059,
  [SMALL_STATE(6396)] = 259086,
  [SMALL_STATE(6397)] = 259109,
  [SMALL_STATE(6398)] = 259136,
  [SMALL_STATE(6399)] = 259171,
  [SMALL_STATE(6400)] = 259196,
  [SMALL_STATE(6401)] = 259223,
  [SMALL_STATE(6402)] = 259254,
  [SMALL_STATE(6403)] = 259285,
  [SMALL_STATE(6404)] = 259320,
  [SMALL_STATE(6405)] = 259355,
  [SMALL_STATE(6406)] = 259384,
  [SMALL_STATE(6407)] = 259419,
  [SMALL_STATE(6408)] = 259440,
  [SMALL_STATE(6409)] = 259475,
  [SMALL_STATE(6410)] = 259510,
  [SMALL_STATE(6411)] = 259541,
  [SMALL_STATE(6412)] = 259568,
  [SMALL_STATE(6413)] = 259595,
  [SMALL_STATE(6414)] = 259622,
  [SMALL_STATE(6415)] = 259653,
  [SMALL_STATE(6416)] = 259680,
  [SMALL_STATE(6417)] = 259715,
  [SMALL_STATE(6418)] = 259744,
  [SMALL_STATE(6419)] = 259775,
  [SMALL_STATE(6420)] = 259794,
  [SMALL_STATE(6421)] = 259813,
  [SMALL_STATE(6422)] = 259832,
  [SMALL_STATE(6423)] = 259863,
  [SMALL_STATE(6424)] = 259894,
  [SMALL_STATE(6425)] = 259925,
  [SMALL_STATE(6426)] = 259960,
  [SMALL_STATE(6427)] = 259991,
  [SMALL_STATE(6428)] = 260026,
  [SMALL_STATE(6429)] = 260057,
  [SMALL_STATE(6430)] = 260088,
  [SMALL_STATE(6431)] = 260119,
  [SMALL_STATE(6432)] = 260144,
  [SMALL_STATE(6433)] = 260174,
  [SMALL_STATE(6434)] = 260196,
  [SMALL_STATE(6435)] = 260218,
  [SMALL_STATE(6436)] = 260248,
  [SMALL_STATE(6437)] = 260278,
  [SMALL_STATE(6438)] = 260308,
  [SMALL_STATE(6439)] = 260334,
  [SMALL_STATE(6440)] = 260358,
  [SMALL_STATE(6441)] = 260388,
  [SMALL_STATE(6442)] = 260416,
  [SMALL_STATE(6443)] = 260438,
  [SMALL_STATE(6444)] = 260462,
  [SMALL_STATE(6445)] = 260486,
  [SMALL_STATE(6446)] = 260508,
  [SMALL_STATE(6447)] = 260532,
  [SMALL_STATE(6448)] = 260556,
  [SMALL_STATE(6449)] = 260580,
  [SMALL_STATE(6450)] = 260610,
  [SMALL_STATE(6451)] = 260632,
  [SMALL_STATE(6452)] = 260656,
  [SMALL_STATE(6453)] = 260680,
  [SMALL_STATE(6454)] = 260702,
  [SMALL_STATE(6455)] = 260724,
  [SMALL_STATE(6456)] = 260748,
  [SMALL_STATE(6457)] = 260770,
  [SMALL_STATE(6458)] = 260792,
  [SMALL_STATE(6459)] = 260822,
  [SMALL_STATE(6460)] = 260846,
  [SMALL_STATE(6461)] = 260870,
  [SMALL_STATE(6462)] = 260892,
  [SMALL_STATE(6463)] = 260916,
  [SMALL_STATE(6464)] = 260940,
  [SMALL_STATE(6465)] = 260964,
  [SMALL_STATE(6466)] = 260988,
  [SMALL_STATE(6467)] = 261012,
  [SMALL_STATE(6468)] = 261036,
  [SMALL_STATE(6469)] = 261060,
  [SMALL_STATE(6470)] = 261082,
  [SMALL_STATE(6471)] = 261104,
  [SMALL_STATE(6472)] = 261136,
  [SMALL_STATE(6473)] = 261162,
  [SMALL_STATE(6474)] = 261188,
  [SMALL_STATE(6475)] = 261214,
  [SMALL_STATE(6476)] = 261236,
  [SMALL_STATE(6477)] = 261267,
  [SMALL_STATE(6478)] = 261298,
  [SMALL_STATE(6479)] = 261321,
  [SMALL_STATE(6480)] = 261344,
  [SMALL_STATE(6481)] = 261371,
  [SMALL_STATE(6482)] = 261394,
  [SMALL_STATE(6483)] = 261417,
  [SMALL_STATE(6484)] = 261448,
  [SMALL_STATE(6485)] = 261469,
  [SMALL_STATE(6486)] = 261500,
  [SMALL_STATE(6487)] = 261531,
  [SMALL_STATE(6488)] = 261562,
  [SMALL_STATE(6489)] = 261593,
  [SMALL_STATE(6490)] = 261616,
  [SMALL_STATE(6491)] = 261647,
  [SMALL_STATE(6492)] = 261670,
  [SMALL_STATE(6493)] = 261701,
  [SMALL_STATE(6494)] = 261732,
  [SMALL_STATE(6495)] = 261763,
  [SMALL_STATE(6496)] = 261790,
  [SMALL_STATE(6497)] = 261817,
  [SMALL_STATE(6498)] = 261840,
  [SMALL_STATE(6499)] = 261871,
  [SMALL_STATE(6500)] = 261902,
  [SMALL_STATE(6501)] = 261933,
  [SMALL_STATE(6502)] = 261952,
  [SMALL_STATE(6503)] = 261973,
  [SMALL_STATE(6504)] = 262000,
  [SMALL_STATE(6505)] = 262031,
  [SMALL_STATE(6506)] = 262058,
  [SMALL_STATE(6507)] = 262089,
  [SMALL_STATE(6508)] = 262120,
  [SMALL_STATE(6509)] = 262151,
  [SMALL_STATE(6510)] = 262182,
  [SMALL_STATE(6511)] = 262213,
  [SMALL_STATE(6512)] = 262244,
  [SMALL_STATE(6513)] = 262267,
  [SMALL_STATE(6514)] = 262298,
  [SMALL_STATE(6515)] = 262319,
  [SMALL_STATE(6516)] = 262346,
  [SMALL_STATE(6517)] = 262367,
  [SMALL_STATE(6518)] = 262390,
  [SMALL_STATE(6519)] = 262417,
  [SMALL_STATE(6520)] = 262448,
  [SMALL_STATE(6521)] = 262475,
  [SMALL_STATE(6522)] = 262502,
  [SMALL_STATE(6523)] = 262533,
  [SMALL_STATE(6524)] = 262560,
  [SMALL_STATE(6525)] = 262591,
  [SMALL_STATE(6526)] = 262618,
  [SMALL_STATE(6527)] = 262639,
  [SMALL_STATE(6528)] = 262662,
  [SMALL_STATE(6529)] = 262693,
  [SMALL_STATE(6530)] = 262724,
  [SMALL_STATE(6531)] = 262755,
  [SMALL_STATE(6532)] = 262786,
  [SMALL_STATE(6533)] = 262813,
  [SMALL_STATE(6534)] = 262835,
  [SMALL_STATE(6535)] = 262857,
  [SMALL_STATE(6536)] = 262879,
  [SMALL_STATE(6537)] = 262905,
  [SMALL_STATE(6538)] = 262931,
  [SMALL_STATE(6539)] = 262957,
  [SMALL_STATE(6540)] = 262983,
  [SMALL_STATE(6541)] = 263009,
  [SMALL_STATE(6542)] = 263035,
  [SMALL_STATE(6543)] = 263061,
  [SMALL_STATE(6544)] = 263087,
  [SMALL_STATE(6545)] = 263113,
  [SMALL_STATE(6546)] = 263129,
  [SMALL_STATE(6547)] = 263155,
  [SMALL_STATE(6548)] = 263177,
  [SMALL_STATE(6549)] = 263201,
  [SMALL_STATE(6550)] = 263227,
  [SMALL_STATE(6551)] = 263253,
  [SMALL_STATE(6552)] = 263275,
  [SMALL_STATE(6553)] = 263301,
  [SMALL_STATE(6554)] = 263317,
  [SMALL_STATE(6555)] = 263339,
  [SMALL_STATE(6556)] = 263359,
  [SMALL_STATE(6557)] = 263385,
  [SMALL_STATE(6558)] = 263407,
  [SMALL_STATE(6559)] = 263433,
  [SMALL_STATE(6560)] = 263459,
  [SMALL_STATE(6561)] = 263485,
  [SMALL_STATE(6562)] = 263509,
  [SMALL_STATE(6563)] = 263531,
  [SMALL_STATE(6564)] = 263551,
  [SMALL_STATE(6565)] = 263577,
  [SMALL_STATE(6566)] = 263599,
  [SMALL_STATE(6567)] = 263621,
  [SMALL_STATE(6568)] = 263647,
  [SMALL_STATE(6569)] = 263669,
  [SMALL_STATE(6570)] = 263687,
  [SMALL_STATE(6571)] = 263711,
  [SMALL_STATE(6572)] = 263733,
  [SMALL_STATE(6573)] = 263757,
  [SMALL_STATE(6574)] = 263779,
  [SMALL_STATE(6575)] = 263805,
  [SMALL_STATE(6576)] = 263831,
  [SMALL_STATE(6577)] = 263859,
  [SMALL_STATE(6578)] = 263885,
  [SMALL_STATE(6579)] = 263909,
  [SMALL_STATE(6580)] = 263935,
  [SMALL_STATE(6581)] = 263961,
  [SMALL_STATE(6582)] = 263987,
  [SMALL_STATE(6583)] = 264007,
  [SMALL_STATE(6584)] = 264033,
  [SMALL_STATE(6585)] = 264059,
  [SMALL_STATE(6586)] = 264083,
  [SMALL_STATE(6587)] = 264105,
  [SMALL_STATE(6588)] = 264129,
  [SMALL_STATE(6589)] = 264149,
  [SMALL_STATE(6590)] = 264171,
  [SMALL_STATE(6591)] = 264197,
  [SMALL_STATE(6592)] = 264221,
  [SMALL_STATE(6593)] = 264247,
  [SMALL_STATE(6594)] = 264269,
  [SMALL_STATE(6595)] = 264295,
  [SMALL_STATE(6596)] = 264314,
  [SMALL_STATE(6597)] = 264329,
  [SMALL_STATE(6598)] = 264354,
  [SMALL_STATE(6599)] = 264369,
  [SMALL_STATE(6600)] = 264386,
  [SMALL_STATE(6601)] = 264409,
  [SMALL_STATE(6602)] = 264434,
  [SMALL_STATE(6603)] = 264449,
  [SMALL_STATE(6604)] = 264466,
  [SMALL_STATE(6605)] = 264491,
  [SMALL_STATE(6606)] = 264514,
  [SMALL_STATE(6607)] = 264535,
  [SMALL_STATE(6608)] = 264550,
  [SMALL_STATE(6609)] = 264569,
  [SMALL_STATE(6610)] = 264590,
  [SMALL_STATE(6611)] = 264607,
  [SMALL_STATE(6612)] = 264630,
  [SMALL_STATE(6613)] = 264653,
  [SMALL_STATE(6614)] = 264670,
  [SMALL_STATE(6615)] = 264695,
  [SMALL_STATE(6616)] = 264718,
  [SMALL_STATE(6617)] = 264739,
  [SMALL_STATE(6618)] = 264760,
  [SMALL_STATE(6619)] = 264781,
  [SMALL_STATE(6620)] = 264802,
  [SMALL_STATE(6621)] = 264819,
  [SMALL_STATE(6622)] = 264834,
  [SMALL_STATE(6623)] = 264859,
  [SMALL_STATE(6624)] = 264882,
  [SMALL_STATE(6625)] = 264905,
  [SMALL_STATE(6626)] = 264926,
  [SMALL_STATE(6627)] = 264949,
  [SMALL_STATE(6628)] = 264966,
  [SMALL_STATE(6629)] = 264983,
  [SMALL_STATE(6630)] = 264998,
  [SMALL_STATE(6631)] = 265019,
  [SMALL_STATE(6632)] = 265036,
  [SMALL_STATE(6633)] = 265053,
  [SMALL_STATE(6634)] = 265074,
  [SMALL_STATE(6635)] = 265091,
  [SMALL_STATE(6636)] = 265110,
  [SMALL_STATE(6637)] = 265133,
  [SMALL_STATE(6638)] = 265150,
  [SMALL_STATE(6639)] = 265169,
  [SMALL_STATE(6640)] = 265186,
  [SMALL_STATE(6641)] = 265205,
  [SMALL_STATE(6642)] = 265222,
  [SMALL_STATE(6643)] = 265239,
  [SMALL_STATE(6644)] = 265262,
  [SMALL_STATE(6645)] = 265279,
  [SMALL_STATE(6646)] = 265302,
  [SMALL_STATE(6647)] = 265327,
  [SMALL_STATE(6648)] = 265350,
  [SMALL_STATE(6649)] = 265367,
  [SMALL_STATE(6650)] = 265382,
  [SMALL_STATE(6651)] = 265403,
  [SMALL_STATE(6652)] = 265424,
  [SMALL_STATE(6653)] = 265443,
  [SMALL_STATE(6654)] = 265466,
  [SMALL_STATE(6655)] = 265489,
  [SMALL_STATE(6656)] = 265510,
  [SMALL_STATE(6657)] = 265527,
  [SMALL_STATE(6658)] = 265548,
  [SMALL_STATE(6659)] = 265569,
  [SMALL_STATE(6660)] = 265590,
  [SMALL_STATE(6661)] = 265613,
  [SMALL_STATE(6662)] = 265628,
  [SMALL_STATE(6663)] = 265649,
  [SMALL_STATE(6664)] = 265672,
  [SMALL_STATE(6665)] = 265695,
  [SMALL_STATE(6666)] = 265716,
  [SMALL_STATE(6667)] = 265741,
  [SMALL_STATE(6668)] = 265766,
  [SMALL_STATE(6669)] = 265787,
  [SMALL_STATE(6670)] = 265804,
  [SMALL_STATE(6671)] = 265822,
  [SMALL_STATE(6672)] = 265842,
  [SMALL_STATE(6673)] = 265862,
  [SMALL_STATE(6674)] = 265884,
  [SMALL_STATE(6675)] = 265906,
  [SMALL_STATE(6676)] = 265926,
  [SMALL_STATE(6677)] = 265940,
  [SMALL_STATE(6678)] = 265958,
  [SMALL_STATE(6679)] = 265980,
  [SMALL_STATE(6680)] = 266002,
  [SMALL_STATE(6681)] = 266024,
  [SMALL_STATE(6682)] = 266046,
  [SMALL_STATE(6683)] = 266068,
  [SMALL_STATE(6684)] = 266090,
  [SMALL_STATE(6685)] = 266112,
  [SMALL_STATE(6686)] = 266126,
  [SMALL_STATE(6687)] = 266148,
  [SMALL_STATE(6688)] = 266168,
  [SMALL_STATE(6689)] = 266188,
  [SMALL_STATE(6690)] = 266208,
  [SMALL_STATE(6691)] = 266228,
  [SMALL_STATE(6692)] = 266250,
  [SMALL_STATE(6693)] = 266264,
  [SMALL_STATE(6694)] = 266282,
  [SMALL_STATE(6695)] = 266296,
  [SMALL_STATE(6696)] = 266318,
  [SMALL_STATE(6697)] = 266332,
  [SMALL_STATE(6698)] = 266346,
  [SMALL_STATE(6699)] = 266360,
  [SMALL_STATE(6700)] = 266382,
  [SMALL_STATE(6701)] = 266402,
  [SMALL_STATE(6702)] = 266420,
  [SMALL_STATE(6703)] = 266440,
  [SMALL_STATE(6704)] = 266454,
  [SMALL_STATE(6705)] = 266468,
  [SMALL_STATE(6706)] = 266490,
  [SMALL_STATE(6707)] = 266508,
  [SMALL_STATE(6708)] = 266528,
  [SMALL_STATE(6709)] = 266548,
  [SMALL_STATE(6710)] = 266562,
  [SMALL_STATE(6711)] = 266584,
  [SMALL_STATE(6712)] = 266606,
  [SMALL_STATE(6713)] = 266620,
  [SMALL_STATE(6714)] = 266642,
  [SMALL_STATE(6715)] = 266664,
  [SMALL_STATE(6716)] = 266678,
  [SMALL_STATE(6717)] = 266700,
  [SMALL_STATE(6718)] = 266720,
  [SMALL_STATE(6719)] = 266740,
  [SMALL_STATE(6720)] = 266762,
  [SMALL_STATE(6721)] = 266776,
  [SMALL_STATE(6722)] = 266796,
  [SMALL_STATE(6723)] = 266810,
  [SMALL_STATE(6724)] = 266832,
  [SMALL_STATE(6725)] = 266854,
  [SMALL_STATE(6726)] = 266876,
  [SMALL_STATE(6727)] = 266898,
  [SMALL_STATE(6728)] = 266916,
  [SMALL_STATE(6729)] = 266933,
  [SMALL_STATE(6730)] = 266950,
  [SMALL_STATE(6731)] = 266967,
  [SMALL_STATE(6732)] = 266984,
  [SMALL_STATE(6733)] = 267001,
  [SMALL_STATE(6734)] = 267020,
  [SMALL_STATE(6735)] = 267037,
  [SMALL_STATE(6736)] = 267054,
  [SMALL_STATE(6737)] = 267071,
  [SMALL_STATE(6738)] = 267088,
  [SMALL_STATE(6739)] = 267105,
  [SMALL_STATE(6740)] = 267124,
  [SMALL_STATE(6741)] = 267143,
  [SMALL_STATE(6742)] = 267160,
  [SMALL_STATE(6743)] = 267179,
  [SMALL_STATE(6744)] = 267196,
  [SMALL_STATE(6745)] = 267213,
  [SMALL_STATE(6746)] = 267230,
  [SMALL_STATE(6747)] = 267247,
  [SMALL_STATE(6748)] = 267266,
  [SMALL_STATE(6749)] = 267283,
  [SMALL_STATE(6750)] = 267294,
  [SMALL_STATE(6751)] = 267313,
  [SMALL_STATE(6752)] = 267332,
  [SMALL_STATE(6753)] = 267351,
  [SMALL_STATE(6754)] = 267368,
  [SMALL_STATE(6755)] = 267385,
  [SMALL_STATE(6756)] = 267404,
  [SMALL_STATE(6757)] = 267421,
  [SMALL_STATE(6758)] = 267440,
  [SMALL_STATE(6759)] = 267457,
  [SMALL_STATE(6760)] = 267474,
  [SMALL_STATE(6761)] = 267493,
  [SMALL_STATE(6762)] = 267512,
  [SMALL_STATE(6763)] = 267531,
  [SMALL_STATE(6764)] = 267548,
  [SMALL_STATE(6765)] = 267565,
  [SMALL_STATE(6766)] = 267582,
  [SMALL_STATE(6767)] = 267599,
  [SMALL_STATE(6768)] = 267616,
  [SMALL_STATE(6769)] = 267633,
  [SMALL_STATE(6770)] = 267650,
  [SMALL_STATE(6771)] = 267667,
  [SMALL_STATE(6772)] = 267680,
  [SMALL_STATE(6773)] = 267697,
  [SMALL_STATE(6774)] = 267714,
  [SMALL_STATE(6775)] = 267731,
  [SMALL_STATE(6776)] = 267750,
  [SMALL_STATE(6777)] = 267769,
  [SMALL_STATE(6778)] = 267786,
  [SMALL_STATE(6779)] = 267803,
  [SMALL_STATE(6780)] = 267822,
  [SMALL_STATE(6781)] = 267841,
  [SMALL_STATE(6782)] = 267858,
  [SMALL_STATE(6783)] = 267875,
  [SMALL_STATE(6784)] = 267892,
  [SMALL_STATE(6785)] = 267909,
  [SMALL_STATE(6786)] = 267928,
  [SMALL_STATE(6787)] = 267941,
  [SMALL_STATE(6788)] = 267958,
  [SMALL_STATE(6789)] = 267977,
  [SMALL_STATE(6790)] = 267996,
  [SMALL_STATE(6791)] = 268013,
  [SMALL_STATE(6792)] = 268032,
  [SMALL_STATE(6793)] = 268049,
  [SMALL_STATE(6794)] = 268066,
  [SMALL_STATE(6795)] = 268085,
  [SMALL_STATE(6796)] = 268102,
  [SMALL_STATE(6797)] = 268119,
  [SMALL_STATE(6798)] = 268136,
  [SMALL_STATE(6799)] = 268153,
  [SMALL_STATE(6800)] = 268172,
  [SMALL_STATE(6801)] = 268191,
  [SMALL_STATE(6802)] = 268208,
  [SMALL_STATE(6803)] = 268222,
  [SMALL_STATE(6804)] = 268236,
  [SMALL_STATE(6805)] = 268250,
  [SMALL_STATE(6806)] = 268264,
  [SMALL_STATE(6807)] = 268278,
  [SMALL_STATE(6808)] = 268294,
  [SMALL_STATE(6809)] = 268308,
  [SMALL_STATE(6810)] = 268324,
  [SMALL_STATE(6811)] = 268340,
  [SMALL_STATE(6812)] = 268354,
  [SMALL_STATE(6813)] = 268370,
  [SMALL_STATE(6814)] = 268384,
  [SMALL_STATE(6815)] = 268400,
  [SMALL_STATE(6816)] = 268416,
  [SMALL_STATE(6817)] = 268432,
  [SMALL_STATE(6818)] = 268448,
  [SMALL_STATE(6819)] = 268462,
  [SMALL_STATE(6820)] = 268472,
  [SMALL_STATE(6821)] = 268486,
  [SMALL_STATE(6822)] = 268500,
  [SMALL_STATE(6823)] = 268516,
  [SMALL_STATE(6824)] = 268532,
  [SMALL_STATE(6825)] = 268546,
  [SMALL_STATE(6826)] = 268562,
  [SMALL_STATE(6827)] = 268576,
  [SMALL_STATE(6828)] = 268592,
  [SMALL_STATE(6829)] = 268608,
  [SMALL_STATE(6830)] = 268622,
  [SMALL_STATE(6831)] = 268638,
  [SMALL_STATE(6832)] = 268652,
  [SMALL_STATE(6833)] = 268668,
  [SMALL_STATE(6834)] = 268684,
  [SMALL_STATE(6835)] = 268700,
  [SMALL_STATE(6836)] = 268714,
  [SMALL_STATE(6837)] = 268728,
  [SMALL_STATE(6838)] = 268742,
  [SMALL_STATE(6839)] = 268756,
  [SMALL_STATE(6840)] = 268772,
  [SMALL_STATE(6841)] = 268788,
  [SMALL_STATE(6842)] = 268804,
  [SMALL_STATE(6843)] = 268818,
  [SMALL_STATE(6844)] = 268834,
  [SMALL_STATE(6845)] = 268848,
  [SMALL_STATE(6846)] = 268864,
  [SMALL_STATE(6847)] = 268880,
  [SMALL_STATE(6848)] = 268894,
  [SMALL_STATE(6849)] = 268908,
  [SMALL_STATE(6850)] = 268922,
  [SMALL_STATE(6851)] = 268934,
  [SMALL_STATE(6852)] = 268950,
  [SMALL_STATE(6853)] = 268966,
  [SMALL_STATE(6854)] = 268980,
  [SMALL_STATE(6855)] = 268996,
  [SMALL_STATE(6856)] = 269012,
  [SMALL_STATE(6857)] = 269028,
  [SMALL_STATE(6858)] = 269044,
  [SMALL_STATE(6859)] = 269058,
  [SMALL_STATE(6860)] = 269074,
  [SMALL_STATE(6861)] = 269090,
  [SMALL_STATE(6862)] = 269100,
  [SMALL_STATE(6863)] = 269116,
  [SMALL_STATE(6864)] = 269132,
  [SMALL_STATE(6865)] = 269148,
  [SMALL_STATE(6866)] = 269164,
  [SMALL_STATE(6867)] = 269180,
  [SMALL_STATE(6868)] = 269196,
  [SMALL_STATE(6869)] = 269212,
  [SMALL_STATE(6870)] = 269228,
  [SMALL_STATE(6871)] = 269244,
  [SMALL_STATE(6872)] = 269260,
  [SMALL_STATE(6873)] = 269276,
  [SMALL_STATE(6874)] = 269292,
  [SMALL_STATE(6875)] = 269308,
  [SMALL_STATE(6876)] = 269324,
  [SMALL_STATE(6877)] = 269340,
  [SMALL_STATE(6878)] = 269356,
  [SMALL_STATE(6879)] = 269372,
  [SMALL_STATE(6880)] = 269388,
  [SMALL_STATE(6881)] = 269404,
  [SMALL_STATE(6882)] = 269420,
  [SMALL_STATE(6883)] = 269436,
  [SMALL_STATE(6884)] = 269452,
  [SMALL_STATE(6885)] = 269468,
  [SMALL_STATE(6886)] = 269482,
  [SMALL_STATE(6887)] = 269498,
  [SMALL_STATE(6888)] = 269514,
  [SMALL_STATE(6889)] = 269530,
  [SMALL_STATE(6890)] = 269546,
  [SMALL_STATE(6891)] = 269562,
  [SMALL_STATE(6892)] = 269578,
  [SMALL_STATE(6893)] = 269592,
  [SMALL_STATE(6894)] = 269606,
  [SMALL_STATE(6895)] = 269620,
  [SMALL_STATE(6896)] = 269636,
  [SMALL_STATE(6897)] = 269650,
  [SMALL_STATE(6898)] = 269664,
  [SMALL_STATE(6899)] = 269680,
  [SMALL_STATE(6900)] = 269696,
  [SMALL_STATE(6901)] = 269712,
  [SMALL_STATE(6902)] = 269728,
  [SMALL_STATE(6903)] = 269744,
  [SMALL_STATE(6904)] = 269758,
  [SMALL_STATE(6905)] = 269772,
  [SMALL_STATE(6906)] = 269786,
  [SMALL_STATE(6907)] = 269800,
  [SMALL_STATE(6908)] = 269814,
  [SMALL_STATE(6909)] = 269828,
  [SMALL_STATE(6910)] = 269842,
  [SMALL_STATE(6911)] = 269854,
  [SMALL_STATE(6912)] = 269870,
  [SMALL_STATE(6913)] = 269884,
  [SMALL_STATE(6914)] = 269898,
  [SMALL_STATE(6915)] = 269912,
  [SMALL_STATE(6916)] = 269926,
  [SMALL_STATE(6917)] = 269942,
  [SMALL_STATE(6918)] = 269956,
  [SMALL_STATE(6919)] = 269972,
  [SMALL_STATE(6920)] = 269988,
  [SMALL_STATE(6921)] = 270004,
  [SMALL_STATE(6922)] = 270020,
  [SMALL_STATE(6923)] = 270036,
  [SMALL_STATE(6924)] = 270052,
  [SMALL_STATE(6925)] = 270068,
  [SMALL_STATE(6926)] = 270084,
  [SMALL_STATE(6927)] = 270100,
  [SMALL_STATE(6928)] = 270116,
  [SMALL_STATE(6929)] = 270132,
  [SMALL_STATE(6930)] = 270146,
  [SMALL_STATE(6931)] = 270162,
  [SMALL_STATE(6932)] = 270178,
  [SMALL_STATE(6933)] = 270192,
  [SMALL_STATE(6934)] = 270204,
  [SMALL_STATE(6935)] = 270216,
  [SMALL_STATE(6936)] = 270232,
  [SMALL_STATE(6937)] = 270246,
  [SMALL_STATE(6938)] = 270262,
  [SMALL_STATE(6939)] = 270278,
  [SMALL_STATE(6940)] = 270292,
  [SMALL_STATE(6941)] = 270308,
  [SMALL_STATE(6942)] = 270324,
  [SMALL_STATE(6943)] = 270338,
  [SMALL_STATE(6944)] = 270354,
  [SMALL_STATE(6945)] = 270370,
  [SMALL_STATE(6946)] = 270386,
  [SMALL_STATE(6947)] = 270400,
  [SMALL_STATE(6948)] = 270416,
  [SMALL_STATE(6949)] = 270430,
  [SMALL_STATE(6950)] = 270446,
  [SMALL_STATE(6951)] = 270462,
  [SMALL_STATE(6952)] = 270478,
  [SMALL_STATE(6953)] = 270494,
  [SMALL_STATE(6954)] = 270510,
  [SMALL_STATE(6955)] = 270524,
  [SMALL_STATE(6956)] = 270538,
  [SMALL_STATE(6957)] = 270554,
  [SMALL_STATE(6958)] = 270570,
  [SMALL_STATE(6959)] = 270584,
  [SMALL_STATE(6960)] = 270600,
  [SMALL_STATE(6961)] = 270614,
  [SMALL_STATE(6962)] = 270630,
  [SMALL_STATE(6963)] = 270646,
  [SMALL_STATE(6964)] = 270662,
  [SMALL_STATE(6965)] = 270678,
  [SMALL_STATE(6966)] = 270694,
  [SMALL_STATE(6967)] = 270710,
  [SMALL_STATE(6968)] = 270726,
  [SMALL_STATE(6969)] = 270742,
  [SMALL_STATE(6970)] = 270756,
  [SMALL_STATE(6971)] = 270772,
  [SMALL_STATE(6972)] = 270788,
  [SMALL_STATE(6973)] = 270802,
  [SMALL_STATE(6974)] = 270818,
  [SMALL_STATE(6975)] = 270834,
  [SMALL_STATE(6976)] = 270850,
  [SMALL_STATE(6977)] = 270866,
  [SMALL_STATE(6978)] = 270880,
  [SMALL_STATE(6979)] = 270896,
  [SMALL_STATE(6980)] = 270912,
  [SMALL_STATE(6981)] = 270926,
  [SMALL_STATE(6982)] = 270942,
  [SMALL_STATE(6983)] = 270958,
  [SMALL_STATE(6984)] = 270972,
  [SMALL_STATE(6985)] = 270988,
  [SMALL_STATE(6986)] = 271004,
  [SMALL_STATE(6987)] = 271020,
  [SMALL_STATE(6988)] = 271036,
  [SMALL_STATE(6989)] = 271050,
  [SMALL_STATE(6990)] = 271064,
  [SMALL_STATE(6991)] = 271080,
  [SMALL_STATE(6992)] = 271094,
  [SMALL_STATE(6993)] = 271110,
  [SMALL_STATE(6994)] = 271126,
  [SMALL_STATE(6995)] = 271140,
  [SMALL_STATE(6996)] = 271154,
  [SMALL_STATE(6997)] = 271168,
  [SMALL_STATE(6998)] = 271184,
  [SMALL_STATE(6999)] = 271198,
  [SMALL_STATE(7000)] = 271212,
  [SMALL_STATE(7001)] = 271228,
  [SMALL_STATE(7002)] = 271242,
  [SMALL_STATE(7003)] = 271256,
  [SMALL_STATE(7004)] = 271272,
  [SMALL_STATE(7005)] = 271286,
  [SMALL_STATE(7006)] = 271300,
  [SMALL_STATE(7007)] = 271314,
  [SMALL_STATE(7008)] = 271328,
  [SMALL_STATE(7009)] = 271342,
  [SMALL_STATE(7010)] = 271356,
  [SMALL_STATE(7011)] = 271372,
  [SMALL_STATE(7012)] = 271386,
  [SMALL_STATE(7013)] = 271400,
  [SMALL_STATE(7014)] = 271416,
  [SMALL_STATE(7015)] = 271432,
  [SMALL_STATE(7016)] = 271448,
  [SMALL_STATE(7017)] = 271464,
  [SMALL_STATE(7018)] = 271480,
  [SMALL_STATE(7019)] = 271494,
  [SMALL_STATE(7020)] = 271508,
  [SMALL_STATE(7021)] = 271524,
  [SMALL_STATE(7022)] = 271540,
  [SMALL_STATE(7023)] = 271556,
  [SMALL_STATE(7024)] = 271572,
  [SMALL_STATE(7025)] = 271588,
  [SMALL_STATE(7026)] = 271602,
  [SMALL_STATE(7027)] = 271611,
  [SMALL_STATE(7028)] = 271624,
  [SMALL_STATE(7029)] = 271637,
  [SMALL_STATE(7030)] = 271650,
  [SMALL_STATE(7031)] = 271663,
  [SMALL_STATE(7032)] = 271676,
  [SMALL_STATE(7033)] = 271689,
  [SMALL_STATE(7034)] = 271702,
  [SMALL_STATE(7035)] = 271715,
  [SMALL_STATE(7036)] = 271728,
  [SMALL_STATE(7037)] = 271741,
  [SMALL_STATE(7038)] = 271754,
  [SMALL_STATE(7039)] = 271767,
  [SMALL_STATE(7040)] = 271780,
  [SMALL_STATE(7041)] = 271793,
  [SMALL_STATE(7042)] = 271806,
  [SMALL_STATE(7043)] = 271819,
  [SMALL_STATE(7044)] = 271832,
  [SMALL_STATE(7045)] = 271845,
  [SMALL_STATE(7046)] = 271858,
  [SMALL_STATE(7047)] = 271871,
  [SMALL_STATE(7048)] = 271884,
  [SMALL_STATE(7049)] = 271897,
  [SMALL_STATE(7050)] = 271910,
  [SMALL_STATE(7051)] = 271923,
  [SMALL_STATE(7052)] = 271936,
  [SMALL_STATE(7053)] = 271949,
  [SMALL_STATE(7054)] = 271962,
  [SMALL_STATE(7055)] = 271975,
  [SMALL_STATE(7056)] = 271988,
  [SMALL_STATE(7057)] = 272001,
  [SMALL_STATE(7058)] = 272012,
  [SMALL_STATE(7059)] = 272025,
  [SMALL_STATE(7060)] = 272038,
  [SMALL_STATE(7061)] = 272049,
  [SMALL_STATE(7062)] = 272062,
  [SMALL_STATE(7063)] = 272075,
  [SMALL_STATE(7064)] = 272086,
  [SMALL_STATE(7065)] = 272095,
  [SMALL_STATE(7066)] = 272104,
  [SMALL_STATE(7067)] = 272115,
  [SMALL_STATE(7068)] = 272128,
  [SMALL_STATE(7069)] = 272141,
  [SMALL_STATE(7070)] = 272154,
  [SMALL_STATE(7071)] = 272167,
  [SMALL_STATE(7072)] = 272180,
  [SMALL_STATE(7073)] = 272193,
  [SMALL_STATE(7074)] = 272206,
  [SMALL_STATE(7075)] = 272219,
  [SMALL_STATE(7076)] = 272232,
  [SMALL_STATE(7077)] = 272243,
  [SMALL_STATE(7078)] = 272252,
  [SMALL_STATE(7079)] = 272265,
  [SMALL_STATE(7080)] = 272278,
  [SMALL_STATE(7081)] = 272291,
  [SMALL_STATE(7082)] = 272304,
  [SMALL_STATE(7083)] = 272317,
  [SMALL_STATE(7084)] = 272330,
  [SMALL_STATE(7085)] = 272341,
  [SMALL_STATE(7086)] = 272354,
  [SMALL_STATE(7087)] = 272365,
  [SMALL_STATE(7088)] = 272378,
  [SMALL_STATE(7089)] = 272391,
  [SMALL_STATE(7090)] = 272402,
  [SMALL_STATE(7091)] = 272415,
  [SMALL_STATE(7092)] = 272428,
  [SMALL_STATE(7093)] = 272441,
  [SMALL_STATE(7094)] = 272454,
  [SMALL_STATE(7095)] = 272467,
  [SMALL_STATE(7096)] = 272480,
  [SMALL_STATE(7097)] = 272493,
  [SMALL_STATE(7098)] = 272506,
  [SMALL_STATE(7099)] = 272519,
  [SMALL_STATE(7100)] = 272532,
  [SMALL_STATE(7101)] = 272545,
  [SMALL_STATE(7102)] = 272558,
  [SMALL_STATE(7103)] = 272571,
  [SMALL_STATE(7104)] = 272584,
  [SMALL_STATE(7105)] = 272597,
  [SMALL_STATE(7106)] = 272606,
  [SMALL_STATE(7107)] = 272615,
  [SMALL_STATE(7108)] = 272626,
  [SMALL_STATE(7109)] = 272639,
  [SMALL_STATE(7110)] = 272652,
  [SMALL_STATE(7111)] = 272665,
  [SMALL_STATE(7112)] = 272678,
  [SMALL_STATE(7113)] = 272691,
  [SMALL_STATE(7114)] = 272704,
  [SMALL_STATE(7115)] = 272715,
  [SMALL_STATE(7116)] = 272728,
  [SMALL_STATE(7117)] = 272741,
  [SMALL_STATE(7118)] = 272754,
  [SMALL_STATE(7119)] = 272767,
  [SMALL_STATE(7120)] = 272778,
  [SMALL_STATE(7121)] = 272791,
  [SMALL_STATE(7122)] = 272804,
  [SMALL_STATE(7123)] = 272815,
  [SMALL_STATE(7124)] = 272828,
  [SMALL_STATE(7125)] = 272841,
  [SMALL_STATE(7126)] = 272854,
  [SMALL_STATE(7127)] = 272867,
  [SMALL_STATE(7128)] = 272880,
  [SMALL_STATE(7129)] = 272893,
  [SMALL_STATE(7130)] = 272906,
  [SMALL_STATE(7131)] = 272919,
  [SMALL_STATE(7132)] = 272932,
  [SMALL_STATE(7133)] = 272945,
  [SMALL_STATE(7134)] = 272958,
  [SMALL_STATE(7135)] = 272969,
  [SMALL_STATE(7136)] = 272980,
  [SMALL_STATE(7137)] = 272993,
  [SMALL_STATE(7138)] = 273006,
  [SMALL_STATE(7139)] = 273019,
  [SMALL_STATE(7140)] = 273032,
  [SMALL_STATE(7141)] = 273045,
  [SMALL_STATE(7142)] = 273058,
  [SMALL_STATE(7143)] = 273069,
  [SMALL_STATE(7144)] = 273080,
  [SMALL_STATE(7145)] = 273093,
  [SMALL_STATE(7146)] = 273106,
  [SMALL_STATE(7147)] = 273119,
  [SMALL_STATE(7148)] = 273132,
  [SMALL_STATE(7149)] = 273145,
  [SMALL_STATE(7150)] = 273158,
  [SMALL_STATE(7151)] = 273171,
  [SMALL_STATE(7152)] = 273184,
  [SMALL_STATE(7153)] = 273195,
  [SMALL_STATE(7154)] = 273208,
  [SMALL_STATE(7155)] = 273221,
  [SMALL_STATE(7156)] = 273234,
  [SMALL_STATE(7157)] = 273247,
  [SMALL_STATE(7158)] = 273260,
  [SMALL_STATE(7159)] = 273273,
  [SMALL_STATE(7160)] = 273286,
  [SMALL_STATE(7161)] = 273299,
  [SMALL_STATE(7162)] = 273308,
  [SMALL_STATE(7163)] = 273321,
  [SMALL_STATE(7164)] = 273334,
  [SMALL_STATE(7165)] = 273345,
  [SMALL_STATE(7166)] = 273358,
  [SMALL_STATE(7167)] = 273371,
  [SMALL_STATE(7168)] = 273384,
  [SMALL_STATE(7169)] = 273397,
  [SMALL_STATE(7170)] = 273410,
  [SMALL_STATE(7171)] = 273423,
  [SMALL_STATE(7172)] = 273436,
  [SMALL_STATE(7173)] = 273447,
  [SMALL_STATE(7174)] = 273460,
  [SMALL_STATE(7175)] = 273473,
  [SMALL_STATE(7176)] = 273486,
  [SMALL_STATE(7177)] = 273499,
  [SMALL_STATE(7178)] = 273508,
  [SMALL_STATE(7179)] = 273521,
  [SMALL_STATE(7180)] = 273534,
  [SMALL_STATE(7181)] = 273547,
  [SMALL_STATE(7182)] = 273560,
  [SMALL_STATE(7183)] = 273569,
  [SMALL_STATE(7184)] = 273582,
  [SMALL_STATE(7185)] = 273595,
  [SMALL_STATE(7186)] = 273608,
  [SMALL_STATE(7187)] = 273621,
  [SMALL_STATE(7188)] = 273632,
  [SMALL_STATE(7189)] = 273643,
  [SMALL_STATE(7190)] = 273656,
  [SMALL_STATE(7191)] = 273667,
  [SMALL_STATE(7192)] = 273680,
  [SMALL_STATE(7193)] = 273693,
  [SMALL_STATE(7194)] = 273706,
  [SMALL_STATE(7195)] = 273719,
  [SMALL_STATE(7196)] = 273732,
  [SMALL_STATE(7197)] = 273745,
  [SMALL_STATE(7198)] = 273758,
  [SMALL_STATE(7199)] = 273771,
  [SMALL_STATE(7200)] = 273784,
  [SMALL_STATE(7201)] = 273795,
  [SMALL_STATE(7202)] = 273806,
  [SMALL_STATE(7203)] = 273817,
  [SMALL_STATE(7204)] = 273830,
  [SMALL_STATE(7205)] = 273843,
  [SMALL_STATE(7206)] = 273856,
  [SMALL_STATE(7207)] = 273869,
  [SMALL_STATE(7208)] = 273882,
  [SMALL_STATE(7209)] = 273895,
  [SMALL_STATE(7210)] = 273908,
  [SMALL_STATE(7211)] = 273921,
  [SMALL_STATE(7212)] = 273934,
  [SMALL_STATE(7213)] = 273947,
  [SMALL_STATE(7214)] = 273960,
  [SMALL_STATE(7215)] = 273973,
  [SMALL_STATE(7216)] = 273986,
  [SMALL_STATE(7217)] = 273997,
  [SMALL_STATE(7218)] = 274010,
  [SMALL_STATE(7219)] = 274023,
  [SMALL_STATE(7220)] = 274036,
  [SMALL_STATE(7221)] = 274045,
  [SMALL_STATE(7222)] = 274058,
  [SMALL_STATE(7223)] = 274071,
  [SMALL_STATE(7224)] = 274084,
  [SMALL_STATE(7225)] = 274097,
  [SMALL_STATE(7226)] = 274110,
  [SMALL_STATE(7227)] = 274123,
  [SMALL_STATE(7228)] = 274136,
  [SMALL_STATE(7229)] = 274149,
  [SMALL_STATE(7230)] = 274160,
  [SMALL_STATE(7231)] = 274173,
  [SMALL_STATE(7232)] = 274186,
  [SMALL_STATE(7233)] = 274199,
  [SMALL_STATE(7234)] = 274212,
  [SMALL_STATE(7235)] = 274225,
  [SMALL_STATE(7236)] = 274238,
  [SMALL_STATE(7237)] = 274249,
  [SMALL_STATE(7238)] = 274262,
  [SMALL_STATE(7239)] = 274273,
  [SMALL_STATE(7240)] = 274286,
  [SMALL_STATE(7241)] = 274299,
  [SMALL_STATE(7242)] = 274312,
  [SMALL_STATE(7243)] = 274323,
  [SMALL_STATE(7244)] = 274334,
  [SMALL_STATE(7245)] = 274345,
  [SMALL_STATE(7246)] = 274358,
  [SMALL_STATE(7247)] = 274371,
  [SMALL_STATE(7248)] = 274382,
  [SMALL_STATE(7249)] = 274395,
  [SMALL_STATE(7250)] = 274406,
  [SMALL_STATE(7251)] = 274419,
  [SMALL_STATE(7252)] = 274432,
  [SMALL_STATE(7253)] = 274443,
  [SMALL_STATE(7254)] = 274456,
  [SMALL_STATE(7255)] = 274469,
  [SMALL_STATE(7256)] = 274480,
  [SMALL_STATE(7257)] = 274493,
  [SMALL_STATE(7258)] = 274506,
  [SMALL_STATE(7259)] = 274515,
  [SMALL_STATE(7260)] = 274528,
  [SMALL_STATE(7261)] = 274539,
  [SMALL_STATE(7262)] = 274552,
  [SMALL_STATE(7263)] = 274565,
  [SMALL_STATE(7264)] = 274578,
  [SMALL_STATE(7265)] = 274591,
  [SMALL_STATE(7266)] = 274604,
  [SMALL_STATE(7267)] = 274617,
  [SMALL_STATE(7268)] = 274630,
  [SMALL_STATE(7269)] = 274643,
  [SMALL_STATE(7270)] = 274656,
  [SMALL_STATE(7271)] = 274669,
  [SMALL_STATE(7272)] = 274682,
  [SMALL_STATE(7273)] = 274693,
  [SMALL_STATE(7274)] = 274706,
  [SMALL_STATE(7275)] = 274717,
  [SMALL_STATE(7276)] = 274728,
  [SMALL_STATE(7277)] = 274741,
  [SMALL_STATE(7278)] = 274754,
  [SMALL_STATE(7279)] = 274765,
  [SMALL_STATE(7280)] = 274778,
  [SMALL_STATE(7281)] = 274791,
  [SMALL_STATE(7282)] = 274802,
  [SMALL_STATE(7283)] = 274813,
  [SMALL_STATE(7284)] = 274824,
  [SMALL_STATE(7285)] = 274837,
  [SMALL_STATE(7286)] = 274850,
  [SMALL_STATE(7287)] = 274863,
  [SMALL_STATE(7288)] = 274876,
  [SMALL_STATE(7289)] = 274889,
  [SMALL_STATE(7290)] = 274902,
  [SMALL_STATE(7291)] = 274915,
  [SMALL_STATE(7292)] = 274926,
  [SMALL_STATE(7293)] = 274939,
  [SMALL_STATE(7294)] = 274952,
  [SMALL_STATE(7295)] = 274965,
  [SMALL_STATE(7296)] = 274978,
  [SMALL_STATE(7297)] = 274991,
  [SMALL_STATE(7298)] = 275002,
  [SMALL_STATE(7299)] = 275015,
  [SMALL_STATE(7300)] = 275028,
  [SMALL_STATE(7301)] = 275041,
  [SMALL_STATE(7302)] = 275054,
  [SMALL_STATE(7303)] = 275067,
  [SMALL_STATE(7304)] = 275078,
  [SMALL_STATE(7305)] = 275091,
  [SMALL_STATE(7306)] = 275104,
  [SMALL_STATE(7307)] = 275117,
  [SMALL_STATE(7308)] = 275130,
  [SMALL_STATE(7309)] = 275143,
  [SMALL_STATE(7310)] = 275156,
  [SMALL_STATE(7311)] = 275169,
  [SMALL_STATE(7312)] = 275182,
  [SMALL_STATE(7313)] = 275193,
  [SMALL_STATE(7314)] = 275206,
  [SMALL_STATE(7315)] = 275219,
  [SMALL_STATE(7316)] = 275228,
  [SMALL_STATE(7317)] = 275241,
  [SMALL_STATE(7318)] = 275254,
  [SMALL_STATE(7319)] = 275263,
  [SMALL_STATE(7320)] = 275276,
  [SMALL_STATE(7321)] = 275289,
  [SMALL_STATE(7322)] = 275302,
  [SMALL_STATE(7323)] = 275315,
  [SMALL_STATE(7324)] = 275328,
  [SMALL_STATE(7325)] = 275341,
  [SMALL_STATE(7326)] = 275354,
  [SMALL_STATE(7327)] = 275367,
  [SMALL_STATE(7328)] = 275380,
  [SMALL_STATE(7329)] = 275393,
  [SMALL_STATE(7330)] = 275406,
  [SMALL_STATE(7331)] = 275419,
  [SMALL_STATE(7332)] = 275432,
  [SMALL_STATE(7333)] = 275445,
  [SMALL_STATE(7334)] = 275458,
  [SMALL_STATE(7335)] = 275469,
  [SMALL_STATE(7336)] = 275480,
  [SMALL_STATE(7337)] = 275493,
  [SMALL_STATE(7338)] = 275506,
  [SMALL_STATE(7339)] = 275517,
  [SMALL_STATE(7340)] = 275530,
  [SMALL_STATE(7341)] = 275543,
  [SMALL_STATE(7342)] = 275556,
  [SMALL_STATE(7343)] = 275569,
  [SMALL_STATE(7344)] = 275582,
  [SMALL_STATE(7345)] = 275595,
  [SMALL_STATE(7346)] = 275608,
  [SMALL_STATE(7347)] = 275621,
  [SMALL_STATE(7348)] = 275634,
  [SMALL_STATE(7349)] = 275647,
  [SMALL_STATE(7350)] = 275660,
  [SMALL_STATE(7351)] = 275673,
  [SMALL_STATE(7352)] = 275686,
  [SMALL_STATE(7353)] = 275699,
  [SMALL_STATE(7354)] = 275712,
  [SMALL_STATE(7355)] = 275725,
  [SMALL_STATE(7356)] = 275738,
  [SMALL_STATE(7357)] = 275751,
  [SMALL_STATE(7358)] = 275762,
  [SMALL_STATE(7359)] = 275775,
  [SMALL_STATE(7360)] = 275788,
  [SMALL_STATE(7361)] = 275797,
  [SMALL_STATE(7362)] = 275808,
  [SMALL_STATE(7363)] = 275821,
  [SMALL_STATE(7364)] = 275834,
  [SMALL_STATE(7365)] = 275847,
  [SMALL_STATE(7366)] = 275860,
  [SMALL_STATE(7367)] = 275869,
  [SMALL_STATE(7368)] = 275878,
  [SMALL_STATE(7369)] = 275891,
  [SMALL_STATE(7370)] = 275904,
  [SMALL_STATE(7371)] = 275917,
  [SMALL_STATE(7372)] = 275930,
  [SMALL_STATE(7373)] = 275943,
  [SMALL_STATE(7374)] = 275956,
  [SMALL_STATE(7375)] = 275969,
  [SMALL_STATE(7376)] = 275982,
  [SMALL_STATE(7377)] = 275995,
  [SMALL_STATE(7378)] = 276008,
  [SMALL_STATE(7379)] = 276019,
  [SMALL_STATE(7380)] = 276032,
  [SMALL_STATE(7381)] = 276045,
  [SMALL_STATE(7382)] = 276056,
  [SMALL_STATE(7383)] = 276065,
  [SMALL_STATE(7384)] = 276078,
  [SMALL_STATE(7385)] = 276091,
  [SMALL_STATE(7386)] = 276104,
  [SMALL_STATE(7387)] = 276117,
  [SMALL_STATE(7388)] = 276128,
  [SMALL_STATE(7389)] = 276141,
  [SMALL_STATE(7390)] = 276154,
  [SMALL_STATE(7391)] = 276167,
  [SMALL_STATE(7392)] = 276180,
  [SMALL_STATE(7393)] = 276193,
  [SMALL_STATE(7394)] = 276204,
  [SMALL_STATE(7395)] = 276217,
  [SMALL_STATE(7396)] = 276230,
  [SMALL_STATE(7397)] = 276243,
  [SMALL_STATE(7398)] = 276256,
  [SMALL_STATE(7399)] = 276269,
  [SMALL_STATE(7400)] = 276282,
  [SMALL_STATE(7401)] = 276295,
  [SMALL_STATE(7402)] = 276308,
  [SMALL_STATE(7403)] = 276321,
  [SMALL_STATE(7404)] = 276334,
  [SMALL_STATE(7405)] = 276347,
  [SMALL_STATE(7406)] = 276360,
  [SMALL_STATE(7407)] = 276373,
  [SMALL_STATE(7408)] = 276386,
  [SMALL_STATE(7409)] = 276399,
  [SMALL_STATE(7410)] = 276412,
  [SMALL_STATE(7411)] = 276425,
  [SMALL_STATE(7412)] = 276438,
  [SMALL_STATE(7413)] = 276451,
  [SMALL_STATE(7414)] = 276464,
  [SMALL_STATE(7415)] = 276477,
  [SMALL_STATE(7416)] = 276490,
  [SMALL_STATE(7417)] = 276503,
  [SMALL_STATE(7418)] = 276516,
  [SMALL_STATE(7419)] = 276529,
  [SMALL_STATE(7420)] = 276542,
  [SMALL_STATE(7421)] = 276555,
  [SMALL_STATE(7422)] = 276568,
  [SMALL_STATE(7423)] = 276581,
  [SMALL_STATE(7424)] = 276594,
  [SMALL_STATE(7425)] = 276607,
  [SMALL_STATE(7426)] = 276620,
  [SMALL_STATE(7427)] = 276631,
  [SMALL_STATE(7428)] = 276644,
  [SMALL_STATE(7429)] = 276654,
  [SMALL_STATE(7430)] = 276664,
  [SMALL_STATE(7431)] = 276674,
  [SMALL_STATE(7432)] = 276684,
  [SMALL_STATE(7433)] = 276694,
  [SMALL_STATE(7434)] = 276704,
  [SMALL_STATE(7435)] = 276714,
  [SMALL_STATE(7436)] = 276724,
  [SMALL_STATE(7437)] = 276734,
  [SMALL_STATE(7438)] = 276744,
  [SMALL_STATE(7439)] = 276754,
  [SMALL_STATE(7440)] = 276762,
  [SMALL_STATE(7441)] = 276772,
  [SMALL_STATE(7442)] = 276782,
  [SMALL_STATE(7443)] = 276792,
  [SMALL_STATE(7444)] = 276800,
  [SMALL_STATE(7445)] = 276810,
  [SMALL_STATE(7446)] = 276820,
  [SMALL_STATE(7447)] = 276830,
  [SMALL_STATE(7448)] = 276840,
  [SMALL_STATE(7449)] = 276850,
  [SMALL_STATE(7450)] = 276860,
  [SMALL_STATE(7451)] = 276870,
  [SMALL_STATE(7452)] = 276880,
  [SMALL_STATE(7453)] = 276890,
  [SMALL_STATE(7454)] = 276900,
  [SMALL_STATE(7455)] = 276910,
  [SMALL_STATE(7456)] = 276920,
  [SMALL_STATE(7457)] = 276930,
  [SMALL_STATE(7458)] = 276940,
  [SMALL_STATE(7459)] = 276950,
  [SMALL_STATE(7460)] = 276960,
  [SMALL_STATE(7461)] = 276970,
  [SMALL_STATE(7462)] = 276980,
  [SMALL_STATE(7463)] = 276990,
  [SMALL_STATE(7464)] = 277000,
  [SMALL_STATE(7465)] = 277010,
  [SMALL_STATE(7466)] = 277020,
  [SMALL_STATE(7467)] = 277030,
  [SMALL_STATE(7468)] = 277038,
  [SMALL_STATE(7469)] = 277048,
  [SMALL_STATE(7470)] = 277058,
  [SMALL_STATE(7471)] = 277066,
  [SMALL_STATE(7472)] = 277076,
  [SMALL_STATE(7473)] = 277086,
  [SMALL_STATE(7474)] = 277096,
  [SMALL_STATE(7475)] = 277106,
  [SMALL_STATE(7476)] = 277116,
  [SMALL_STATE(7477)] = 277126,
  [SMALL_STATE(7478)] = 277136,
  [SMALL_STATE(7479)] = 277146,
  [SMALL_STATE(7480)] = 277154,
  [SMALL_STATE(7481)] = 277164,
  [SMALL_STATE(7482)] = 277174,
  [SMALL_STATE(7483)] = 277184,
  [SMALL_STATE(7484)] = 277194,
  [SMALL_STATE(7485)] = 277204,
  [SMALL_STATE(7486)] = 277214,
  [SMALL_STATE(7487)] = 277224,
  [SMALL_STATE(7488)] = 277234,
  [SMALL_STATE(7489)] = 277244,
  [SMALL_STATE(7490)] = 277254,
  [SMALL_STATE(7491)] = 277264,
  [SMALL_STATE(7492)] = 277272,
  [SMALL_STATE(7493)] = 277282,
  [SMALL_STATE(7494)] = 277292,
  [SMALL_STATE(7495)] = 277302,
  [SMALL_STATE(7496)] = 277312,
  [SMALL_STATE(7497)] = 277322,
  [SMALL_STATE(7498)] = 277332,
  [SMALL_STATE(7499)] = 277342,
  [SMALL_STATE(7500)] = 277350,
  [SMALL_STATE(7501)] = 277358,
  [SMALL_STATE(7502)] = 277368,
  [SMALL_STATE(7503)] = 277376,
  [SMALL_STATE(7504)] = 277386,
  [SMALL_STATE(7505)] = 277396,
  [SMALL_STATE(7506)] = 277406,
  [SMALL_STATE(7507)] = 277416,
  [SMALL_STATE(7508)] = 277426,
  [SMALL_STATE(7509)] = 277436,
  [SMALL_STATE(7510)] = 277446,
  [SMALL_STATE(7511)] = 277456,
  [SMALL_STATE(7512)] = 277466,
  [SMALL_STATE(7513)] = 277476,
  [SMALL_STATE(7514)] = 277486,
  [SMALL_STATE(7515)] = 277496,
  [SMALL_STATE(7516)] = 277506,
  [SMALL_STATE(7517)] = 277516,
  [SMALL_STATE(7518)] = 277526,
  [SMALL_STATE(7519)] = 277536,
  [SMALL_STATE(7520)] = 277544,
  [SMALL_STATE(7521)] = 277554,
  [SMALL_STATE(7522)] = 277562,
  [SMALL_STATE(7523)] = 277572,
  [SMALL_STATE(7524)] = 277580,
  [SMALL_STATE(7525)] = 277590,
  [SMALL_STATE(7526)] = 277600,
  [SMALL_STATE(7527)] = 277610,
  [SMALL_STATE(7528)] = 277618,
  [SMALL_STATE(7529)] = 277628,
  [SMALL_STATE(7530)] = 277638,
  [SMALL_STATE(7531)] = 277648,
  [SMALL_STATE(7532)] = 277658,
  [SMALL_STATE(7533)] = 277668,
  [SMALL_STATE(7534)] = 277678,
  [SMALL_STATE(7535)] = 277688,
  [SMALL_STATE(7536)] = 277696,
  [SMALL_STATE(7537)] = 277706,
  [SMALL_STATE(7538)] = 277716,
  [SMALL_STATE(7539)] = 277726,
  [SMALL_STATE(7540)] = 277736,
  [SMALL_STATE(7541)] = 277746,
  [SMALL_STATE(7542)] = 277756,
  [SMALL_STATE(7543)] = 277766,
  [SMALL_STATE(7544)] = 277776,
  [SMALL_STATE(7545)] = 277786,
  [SMALL_STATE(7546)] = 277796,
  [SMALL_STATE(7547)] = 277806,
  [SMALL_STATE(7548)] = 277816,
  [SMALL_STATE(7549)] = 277826,
  [SMALL_STATE(7550)] = 277836,
  [SMALL_STATE(7551)] = 277846,
  [SMALL_STATE(7552)] = 277856,
  [SMALL_STATE(7553)] = 277866,
  [SMALL_STATE(7554)] = 277876,
  [SMALL_STATE(7555)] = 277886,
  [SMALL_STATE(7556)] = 277896,
  [SMALL_STATE(7557)] = 277906,
  [SMALL_STATE(7558)] = 277916,
  [SMALL_STATE(7559)] = 277926,
  [SMALL_STATE(7560)] = 277936,
  [SMALL_STATE(7561)] = 277946,
  [SMALL_STATE(7562)] = 277956,
  [SMALL_STATE(7563)] = 277966,
  [SMALL_STATE(7564)] = 277976,
  [SMALL_STATE(7565)] = 277986,
  [SMALL_STATE(7566)] = 277996,
  [SMALL_STATE(7567)] = 278004,
  [SMALL_STATE(7568)] = 278014,
  [SMALL_STATE(7569)] = 278024,
  [SMALL_STATE(7570)] = 278034,
  [SMALL_STATE(7571)] = 278044,
  [SMALL_STATE(7572)] = 278054,
  [SMALL_STATE(7573)] = 278064,
  [SMALL_STATE(7574)] = 278074,
  [SMALL_STATE(7575)] = 278084,
  [SMALL_STATE(7576)] = 278094,
  [SMALL_STATE(7577)] = 278104,
  [SMALL_STATE(7578)] = 278114,
  [SMALL_STATE(7579)] = 278124,
  [SMALL_STATE(7580)] = 278134,
  [SMALL_STATE(7581)] = 278144,
  [SMALL_STATE(7582)] = 278154,
  [SMALL_STATE(7583)] = 278164,
  [SMALL_STATE(7584)] = 278172,
  [SMALL_STATE(7585)] = 278182,
  [SMALL_STATE(7586)] = 278192,
  [SMALL_STATE(7587)] = 278202,
  [SMALL_STATE(7588)] = 278212,
  [SMALL_STATE(7589)] = 278222,
  [SMALL_STATE(7590)] = 278232,
  [SMALL_STATE(7591)] = 278242,
  [SMALL_STATE(7592)] = 278252,
  [SMALL_STATE(7593)] = 278262,
  [SMALL_STATE(7594)] = 278272,
  [SMALL_STATE(7595)] = 278282,
  [SMALL_STATE(7596)] = 278292,
  [SMALL_STATE(7597)] = 278302,
  [SMALL_STATE(7598)] = 278312,
  [SMALL_STATE(7599)] = 278322,
  [SMALL_STATE(7600)] = 278332,
  [SMALL_STATE(7601)] = 278342,
  [SMALL_STATE(7602)] = 278352,
  [SMALL_STATE(7603)] = 278362,
  [SMALL_STATE(7604)] = 278372,
  [SMALL_STATE(7605)] = 278382,
  [SMALL_STATE(7606)] = 278392,
  [SMALL_STATE(7607)] = 278402,
  [SMALL_STATE(7608)] = 278412,
  [SMALL_STATE(7609)] = 278422,
  [SMALL_STATE(7610)] = 278430,
  [SMALL_STATE(7611)] = 278440,
  [SMALL_STATE(7612)] = 278450,
  [SMALL_STATE(7613)] = 278460,
  [SMALL_STATE(7614)] = 278470,
  [SMALL_STATE(7615)] = 278480,
  [SMALL_STATE(7616)] = 278490,
  [SMALL_STATE(7617)] = 278500,
  [SMALL_STATE(7618)] = 278510,
  [SMALL_STATE(7619)] = 278520,
  [SMALL_STATE(7620)] = 278530,
  [SMALL_STATE(7621)] = 278540,
  [SMALL_STATE(7622)] = 278550,
  [SMALL_STATE(7623)] = 278560,
  [SMALL_STATE(7624)] = 278570,
  [SMALL_STATE(7625)] = 278580,
  [SMALL_STATE(7626)] = 278590,
  [SMALL_STATE(7627)] = 278600,
  [SMALL_STATE(7628)] = 278610,
  [SMALL_STATE(7629)] = 278620,
  [SMALL_STATE(7630)] = 278630,
  [SMALL_STATE(7631)] = 278640,
  [SMALL_STATE(7632)] = 278650,
  [SMALL_STATE(7633)] = 278660,
  [SMALL_STATE(7634)] = 278670,
  [SMALL_STATE(7635)] = 278680,
  [SMALL_STATE(7636)] = 278688,
  [SMALL_STATE(7637)] = 278698,
  [SMALL_STATE(7638)] = 278708,
  [SMALL_STATE(7639)] = 278718,
  [SMALL_STATE(7640)] = 278728,
  [SMALL_STATE(7641)] = 278738,
  [SMALL_STATE(7642)] = 278748,
  [SMALL_STATE(7643)] = 278758,
  [SMALL_STATE(7644)] = 278768,
  [SMALL_STATE(7645)] = 278778,
  [SMALL_STATE(7646)] = 278788,
  [SMALL_STATE(7647)] = 278798,
  [SMALL_STATE(7648)] = 278808,
  [SMALL_STATE(7649)] = 278816,
  [SMALL_STATE(7650)] = 278826,
  [SMALL_STATE(7651)] = 278836,
  [SMALL_STATE(7652)] = 278846,
  [SMALL_STATE(7653)] = 278856,
  [SMALL_STATE(7654)] = 278866,
  [SMALL_STATE(7655)] = 278876,
  [SMALL_STATE(7656)] = 278886,
  [SMALL_STATE(7657)] = 278894,
  [SMALL_STATE(7658)] = 278904,
  [SMALL_STATE(7659)] = 278914,
  [SMALL_STATE(7660)] = 278924,
  [SMALL_STATE(7661)] = 278934,
  [SMALL_STATE(7662)] = 278944,
  [SMALL_STATE(7663)] = 278952,
  [SMALL_STATE(7664)] = 278962,
  [SMALL_STATE(7665)] = 278972,
  [SMALL_STATE(7666)] = 278982,
  [SMALL_STATE(7667)] = 278992,
  [SMALL_STATE(7668)] = 279002,
  [SMALL_STATE(7669)] = 279012,
  [SMALL_STATE(7670)] = 279022,
  [SMALL_STATE(7671)] = 279032,
  [SMALL_STATE(7672)] = 279042,
  [SMALL_STATE(7673)] = 279052,
  [SMALL_STATE(7674)] = 279062,
  [SMALL_STATE(7675)] = 279072,
  [SMALL_STATE(7676)] = 279080,
  [SMALL_STATE(7677)] = 279090,
  [SMALL_STATE(7678)] = 279100,
  [SMALL_STATE(7679)] = 279110,
  [SMALL_STATE(7680)] = 279120,
  [SMALL_STATE(7681)] = 279130,
  [SMALL_STATE(7682)] = 279140,
  [SMALL_STATE(7683)] = 279150,
  [SMALL_STATE(7684)] = 279160,
  [SMALL_STATE(7685)] = 279170,
  [SMALL_STATE(7686)] = 279178,
  [SMALL_STATE(7687)] = 279186,
  [SMALL_STATE(7688)] = 279196,
  [SMALL_STATE(7689)] = 279206,
  [SMALL_STATE(7690)] = 279214,
  [SMALL_STATE(7691)] = 279224,
  [SMALL_STATE(7692)] = 279234,
  [SMALL_STATE(7693)] = 279242,
  [SMALL_STATE(7694)] = 279252,
  [SMALL_STATE(7695)] = 279260,
  [SMALL_STATE(7696)] = 279268,
  [SMALL_STATE(7697)] = 279278,
  [SMALL_STATE(7698)] = 279288,
  [SMALL_STATE(7699)] = 279298,
  [SMALL_STATE(7700)] = 279308,
  [SMALL_STATE(7701)] = 279318,
  [SMALL_STATE(7702)] = 279328,
  [SMALL_STATE(7703)] = 279338,
  [SMALL_STATE(7704)] = 279346,
  [SMALL_STATE(7705)] = 279356,
  [SMALL_STATE(7706)] = 279364,
  [SMALL_STATE(7707)] = 279374,
  [SMALL_STATE(7708)] = 279384,
  [SMALL_STATE(7709)] = 279394,
  [SMALL_STATE(7710)] = 279404,
  [SMALL_STATE(7711)] = 279414,
  [SMALL_STATE(7712)] = 279424,
  [SMALL_STATE(7713)] = 279434,
  [SMALL_STATE(7714)] = 279444,
  [SMALL_STATE(7715)] = 279454,
  [SMALL_STATE(7716)] = 279464,
  [SMALL_STATE(7717)] = 279474,
  [SMALL_STATE(7718)] = 279484,
  [SMALL_STATE(7719)] = 279492,
  [SMALL_STATE(7720)] = 279502,
  [SMALL_STATE(7721)] = 279510,
  [SMALL_STATE(7722)] = 279520,
  [SMALL_STATE(7723)] = 279528,
  [SMALL_STATE(7724)] = 279538,
  [SMALL_STATE(7725)] = 279548,
  [SMALL_STATE(7726)] = 279558,
  [SMALL_STATE(7727)] = 279568,
  [SMALL_STATE(7728)] = 279578,
  [SMALL_STATE(7729)] = 279586,
  [SMALL_STATE(7730)] = 279596,
  [SMALL_STATE(7731)] = 279606,
  [SMALL_STATE(7732)] = 279616,
  [SMALL_STATE(7733)] = 279626,
  [SMALL_STATE(7734)] = 279636,
  [SMALL_STATE(7735)] = 279646,
  [SMALL_STATE(7736)] = 279656,
  [SMALL_STATE(7737)] = 279664,
  [SMALL_STATE(7738)] = 279674,
  [SMALL_STATE(7739)] = 279682,
  [SMALL_STATE(7740)] = 279692,
  [SMALL_STATE(7741)] = 279700,
  [SMALL_STATE(7742)] = 279708,
  [SMALL_STATE(7743)] = 279718,
  [SMALL_STATE(7744)] = 279728,
  [SMALL_STATE(7745)] = 279738,
  [SMALL_STATE(7746)] = 279748,
  [SMALL_STATE(7747)] = 279758,
  [SMALL_STATE(7748)] = 279768,
  [SMALL_STATE(7749)] = 279778,
  [SMALL_STATE(7750)] = 279788,
  [SMALL_STATE(7751)] = 279798,
  [SMALL_STATE(7752)] = 279808,
  [SMALL_STATE(7753)] = 279818,
  [SMALL_STATE(7754)] = 279828,
  [SMALL_STATE(7755)] = 279838,
  [SMALL_STATE(7756)] = 279848,
  [SMALL_STATE(7757)] = 279858,
  [SMALL_STATE(7758)] = 279868,
  [SMALL_STATE(7759)] = 279878,
  [SMALL_STATE(7760)] = 279888,
  [SMALL_STATE(7761)] = 279898,
  [SMALL_STATE(7762)] = 279905,
  [SMALL_STATE(7763)] = 279912,
  [SMALL_STATE(7764)] = 279919,
  [SMALL_STATE(7765)] = 279926,
  [SMALL_STATE(7766)] = 279933,
  [SMALL_STATE(7767)] = 279940,
  [SMALL_STATE(7768)] = 279947,
  [SMALL_STATE(7769)] = 279954,
  [SMALL_STATE(7770)] = 279961,
  [SMALL_STATE(7771)] = 279968,
  [SMALL_STATE(7772)] = 279975,
  [SMALL_STATE(7773)] = 279982,
  [SMALL_STATE(7774)] = 279989,
  [SMALL_STATE(7775)] = 279996,
  [SMALL_STATE(7776)] = 280003,
  [SMALL_STATE(7777)] = 280010,
  [SMALL_STATE(7778)] = 280017,
  [SMALL_STATE(7779)] = 280024,
  [SMALL_STATE(7780)] = 280031,
  [SMALL_STATE(7781)] = 280038,
  [SMALL_STATE(7782)] = 280045,
  [SMALL_STATE(7783)] = 280052,
  [SMALL_STATE(7784)] = 280059,
  [SMALL_STATE(7785)] = 280066,
  [SMALL_STATE(7786)] = 280073,
  [SMALL_STATE(7787)] = 280080,
  [SMALL_STATE(7788)] = 280087,
  [SMALL_STATE(7789)] = 280094,
  [SMALL_STATE(7790)] = 280101,
  [SMALL_STATE(7791)] = 280108,
  [SMALL_STATE(7792)] = 280115,
  [SMALL_STATE(7793)] = 280122,
  [SMALL_STATE(7794)] = 280129,
  [SMALL_STATE(7795)] = 280136,
  [SMALL_STATE(7796)] = 280143,
  [SMALL_STATE(7797)] = 280150,
  [SMALL_STATE(7798)] = 280157,
  [SMALL_STATE(7799)] = 280164,
  [SMALL_STATE(7800)] = 280171,
  [SMALL_STATE(7801)] = 280178,
  [SMALL_STATE(7802)] = 280185,
  [SMALL_STATE(7803)] = 280192,
  [SMALL_STATE(7804)] = 280199,
  [SMALL_STATE(7805)] = 280206,
  [SMALL_STATE(7806)] = 280213,
  [SMALL_STATE(7807)] = 280220,
  [SMALL_STATE(7808)] = 280227,
  [SMALL_STATE(7809)] = 280234,
  [SMALL_STATE(7810)] = 280241,
  [SMALL_STATE(7811)] = 280248,
  [SMALL_STATE(7812)] = 280255,
  [SMALL_STATE(7813)] = 280262,
  [SMALL_STATE(7814)] = 280269,
  [SMALL_STATE(7815)] = 280276,
  [SMALL_STATE(7816)] = 280283,
  [SMALL_STATE(7817)] = 280290,
  [SMALL_STATE(7818)] = 280297,
  [SMALL_STATE(7819)] = 280304,
  [SMALL_STATE(7820)] = 280311,
  [SMALL_STATE(7821)] = 280318,
  [SMALL_STATE(7822)] = 280325,
  [SMALL_STATE(7823)] = 280332,
  [SMALL_STATE(7824)] = 280339,
  [SMALL_STATE(7825)] = 280346,
  [SMALL_STATE(7826)] = 280353,
  [SMALL_STATE(7827)] = 280360,
  [SMALL_STATE(7828)] = 280367,
  [SMALL_STATE(7829)] = 280374,
  [SMALL_STATE(7830)] = 280381,
  [SMALL_STATE(7831)] = 280388,
  [SMALL_STATE(7832)] = 280395,
  [SMALL_STATE(7833)] = 280402,
  [SMALL_STATE(7834)] = 280409,
  [SMALL_STATE(7835)] = 280416,
  [SMALL_STATE(7836)] = 280423,
  [SMALL_STATE(7837)] = 280430,
  [SMALL_STATE(7838)] = 280437,
  [SMALL_STATE(7839)] = 280444,
  [SMALL_STATE(7840)] = 280451,
  [SMALL_STATE(7841)] = 280458,
  [SMALL_STATE(7842)] = 280465,
  [SMALL_STATE(7843)] = 280472,
  [SMALL_STATE(7844)] = 280479,
  [SMALL_STATE(7845)] = 280486,
  [SMALL_STATE(7846)] = 280493,
  [SMALL_STATE(7847)] = 280500,
  [SMALL_STATE(7848)] = 280507,
  [SMALL_STATE(7849)] = 280514,
  [SMALL_STATE(7850)] = 280521,
  [SMALL_STATE(7851)] = 280528,
  [SMALL_STATE(7852)] = 280535,
  [SMALL_STATE(7853)] = 280542,
  [SMALL_STATE(7854)] = 280549,
  [SMALL_STATE(7855)] = 280556,
  [SMALL_STATE(7856)] = 280563,
  [SMALL_STATE(7857)] = 280570,
  [SMALL_STATE(7858)] = 280577,
  [SMALL_STATE(7859)] = 280584,
  [SMALL_STATE(7860)] = 280591,
  [SMALL_STATE(7861)] = 280598,
  [SMALL_STATE(7862)] = 280605,
  [SMALL_STATE(7863)] = 280612,
  [SMALL_STATE(7864)] = 280619,
  [SMALL_STATE(7865)] = 280626,
  [SMALL_STATE(7866)] = 280633,
  [SMALL_STATE(7867)] = 280640,
  [SMALL_STATE(7868)] = 280647,
  [SMALL_STATE(7869)] = 280654,
  [SMALL_STATE(7870)] = 280661,
  [SMALL_STATE(7871)] = 280668,
  [SMALL_STATE(7872)] = 280675,
  [SMALL_STATE(7873)] = 280682,
  [SMALL_STATE(7874)] = 280689,
  [SMALL_STATE(7875)] = 280696,
  [SMALL_STATE(7876)] = 280703,
  [SMALL_STATE(7877)] = 280710,
  [SMALL_STATE(7878)] = 280717,
  [SMALL_STATE(7879)] = 280724,
  [SMALL_STATE(7880)] = 280731,
  [SMALL_STATE(7881)] = 280738,
  [SMALL_STATE(7882)] = 280745,
  [SMALL_STATE(7883)] = 280752,
  [SMALL_STATE(7884)] = 280759,
  [SMALL_STATE(7885)] = 280766,
  [SMALL_STATE(7886)] = 280773,
  [SMALL_STATE(7887)] = 280780,
  [SMALL_STATE(7888)] = 280787,
  [SMALL_STATE(7889)] = 280794,
  [SMALL_STATE(7890)] = 280801,
  [SMALL_STATE(7891)] = 280808,
  [SMALL_STATE(7892)] = 280815,
  [SMALL_STATE(7893)] = 280822,
  [SMALL_STATE(7894)] = 280829,
  [SMALL_STATE(7895)] = 280836,
  [SMALL_STATE(7896)] = 280843,
  [SMALL_STATE(7897)] = 280850,
  [SMALL_STATE(7898)] = 280857,
  [SMALL_STATE(7899)] = 280864,
  [SMALL_STATE(7900)] = 280871,
  [SMALL_STATE(7901)] = 280878,
  [SMALL_STATE(7902)] = 280885,
  [SMALL_STATE(7903)] = 280892,
  [SMALL_STATE(7904)] = 280899,
  [SMALL_STATE(7905)] = 280906,
  [SMALL_STATE(7906)] = 280913,
  [SMALL_STATE(7907)] = 280920,
  [SMALL_STATE(7908)] = 280927,
  [SMALL_STATE(7909)] = 280934,
  [SMALL_STATE(7910)] = 280941,
  [SMALL_STATE(7911)] = 280948,
  [SMALL_STATE(7912)] = 280955,
  [SMALL_STATE(7913)] = 280962,
  [SMALL_STATE(7914)] = 280969,
  [SMALL_STATE(7915)] = 280976,
  [SMALL_STATE(7916)] = 280983,
  [SMALL_STATE(7917)] = 280990,
  [SMALL_STATE(7918)] = 280997,
  [SMALL_STATE(7919)] = 281004,
  [SMALL_STATE(7920)] = 281011,
  [SMALL_STATE(7921)] = 281018,
  [SMALL_STATE(7922)] = 281025,
  [SMALL_STATE(7923)] = 281032,
  [SMALL_STATE(7924)] = 281039,
  [SMALL_STATE(7925)] = 281046,
  [SMALL_STATE(7926)] = 281053,
  [SMALL_STATE(7927)] = 281060,
  [SMALL_STATE(7928)] = 281067,
  [SMALL_STATE(7929)] = 281074,
  [SMALL_STATE(7930)] = 281081,
  [SMALL_STATE(7931)] = 281088,
  [SMALL_STATE(7932)] = 281095,
  [SMALL_STATE(7933)] = 281102,
  [SMALL_STATE(7934)] = 281109,
  [SMALL_STATE(7935)] = 281116,
  [SMALL_STATE(7936)] = 281123,
  [SMALL_STATE(7937)] = 281130,
  [SMALL_STATE(7938)] = 281137,
  [SMALL_STATE(7939)] = 281144,
  [SMALL_STATE(7940)] = 281151,
  [SMALL_STATE(7941)] = 281158,
  [SMALL_STATE(7942)] = 281165,
  [SMALL_STATE(7943)] = 281172,
  [SMALL_STATE(7944)] = 281179,
  [SMALL_STATE(7945)] = 281186,
  [SMALL_STATE(7946)] = 281193,
  [SMALL_STATE(7947)] = 281200,
  [SMALL_STATE(7948)] = 281207,
  [SMALL_STATE(7949)] = 281214,
  [SMALL_STATE(7950)] = 281221,
  [SMALL_STATE(7951)] = 281228,
  [SMALL_STATE(7952)] = 281235,
  [SMALL_STATE(7953)] = 281242,
  [SMALL_STATE(7954)] = 281249,
  [SMALL_STATE(7955)] = 281256,
  [SMALL_STATE(7956)] = 281263,
  [SMALL_STATE(7957)] = 281270,
  [SMALL_STATE(7958)] = 281277,
  [SMALL_STATE(7959)] = 281284,
  [SMALL_STATE(7960)] = 281291,
  [SMALL_STATE(7961)] = 281298,
  [SMALL_STATE(7962)] = 281305,
  [SMALL_STATE(7963)] = 281312,
  [SMALL_STATE(7964)] = 281319,
  [SMALL_STATE(7965)] = 281326,
  [SMALL_STATE(7966)] = 281333,
  [SMALL_STATE(7967)] = 281340,
  [SMALL_STATE(7968)] = 281347,
  [SMALL_STATE(7969)] = 281354,
  [SMALL_STATE(7970)] = 281361,
  [SMALL_STATE(7971)] = 281368,
  [SMALL_STATE(7972)] = 281375,
  [SMALL_STATE(7973)] = 281382,
  [SMALL_STATE(7974)] = 281389,
  [SMALL_STATE(7975)] = 281396,
  [SMALL_STATE(7976)] = 281403,
  [SMALL_STATE(7977)] = 281410,
  [SMALL_STATE(7978)] = 281417,
  [SMALL_STATE(7979)] = 281424,
  [SMALL_STATE(7980)] = 281431,
  [SMALL_STATE(7981)] = 281438,
  [SMALL_STATE(7982)] = 281445,
  [SMALL_STATE(7983)] = 281452,
  [SMALL_STATE(7984)] = 281459,
  [SMALL_STATE(7985)] = 281466,
  [SMALL_STATE(7986)] = 281473,
  [SMALL_STATE(7987)] = 281480,
  [SMALL_STATE(7988)] = 281487,
  [SMALL_STATE(7989)] = 281494,
  [SMALL_STATE(7990)] = 281501,
  [SMALL_STATE(7991)] = 281508,
  [SMALL_STATE(7992)] = 281515,
  [SMALL_STATE(7993)] = 281522,
  [SMALL_STATE(7994)] = 281529,
  [SMALL_STATE(7995)] = 281536,
  [SMALL_STATE(7996)] = 281543,
  [SMALL_STATE(7997)] = 281550,
  [SMALL_STATE(7998)] = 281557,
  [SMALL_STATE(7999)] = 281564,
  [SMALL_STATE(8000)] = 281571,
  [SMALL_STATE(8001)] = 281578,
  [SMALL_STATE(8002)] = 281585,
  [SMALL_STATE(8003)] = 281592,
  [SMALL_STATE(8004)] = 281599,
  [SMALL_STATE(8005)] = 281606,
  [SMALL_STATE(8006)] = 281613,
  [SMALL_STATE(8007)] = 281620,
  [SMALL_STATE(8008)] = 281627,
  [SMALL_STATE(8009)] = 281634,
  [SMALL_STATE(8010)] = 281641,
  [SMALL_STATE(8011)] = 281648,
  [SMALL_STATE(8012)] = 281655,
  [SMALL_STATE(8013)] = 281662,
  [SMALL_STATE(8014)] = 281669,
  [SMALL_STATE(8015)] = 281676,
  [SMALL_STATE(8016)] = 281683,
  [SMALL_STATE(8017)] = 281690,
  [SMALL_STATE(8018)] = 281697,
  [SMALL_STATE(8019)] = 281704,
  [SMALL_STATE(8020)] = 281711,
  [SMALL_STATE(8021)] = 281718,
  [SMALL_STATE(8022)] = 281725,
  [SMALL_STATE(8023)] = 281732,
  [SMALL_STATE(8024)] = 281739,
  [SMALL_STATE(8025)] = 281746,
  [SMALL_STATE(8026)] = 281753,
  [SMALL_STATE(8027)] = 281760,
  [SMALL_STATE(8028)] = 281767,
  [SMALL_STATE(8029)] = 281774,
  [SMALL_STATE(8030)] = 281781,
  [SMALL_STATE(8031)] = 281788,
  [SMALL_STATE(8032)] = 281795,
  [SMALL_STATE(8033)] = 281802,
  [SMALL_STATE(8034)] = 281809,
  [SMALL_STATE(8035)] = 281816,
  [SMALL_STATE(8036)] = 281823,
  [SMALL_STATE(8037)] = 281830,
  [SMALL_STATE(8038)] = 281837,
  [SMALL_STATE(8039)] = 281844,
  [SMALL_STATE(8040)] = 281851,
  [SMALL_STATE(8041)] = 281858,
  [SMALL_STATE(8042)] = 281865,
  [SMALL_STATE(8043)] = 281872,
  [SMALL_STATE(8044)] = 281879,
  [SMALL_STATE(8045)] = 281886,
  [SMALL_STATE(8046)] = 281893,
  [SMALL_STATE(8047)] = 281900,
  [SMALL_STATE(8048)] = 281907,
  [SMALL_STATE(8049)] = 281914,
  [SMALL_STATE(8050)] = 281921,
  [SMALL_STATE(8051)] = 281928,
  [SMALL_STATE(8052)] = 281935,
  [SMALL_STATE(8053)] = 281942,
  [SMALL_STATE(8054)] = 281949,
  [SMALL_STATE(8055)] = 281956,
  [SMALL_STATE(8056)] = 281963,
  [SMALL_STATE(8057)] = 281970,
  [SMALL_STATE(8058)] = 281977,
  [SMALL_STATE(8059)] = 281984,
  [SMALL_STATE(8060)] = 281991,
  [SMALL_STATE(8061)] = 281998,
  [SMALL_STATE(8062)] = 282005,
  [SMALL_STATE(8063)] = 282012,
  [SMALL_STATE(8064)] = 282019,
  [SMALL_STATE(8065)] = 282026,
  [SMALL_STATE(8066)] = 282033,
  [SMALL_STATE(8067)] = 282040,
  [SMALL_STATE(8068)] = 282047,
  [SMALL_STATE(8069)] = 282054,
  [SMALL_STATE(8070)] = 282061,
  [SMALL_STATE(8071)] = 282068,
  [SMALL_STATE(8072)] = 282075,
  [SMALL_STATE(8073)] = 282082,
  [SMALL_STATE(8074)] = 282089,
  [SMALL_STATE(8075)] = 282096,
  [SMALL_STATE(8076)] = 282103,
  [SMALL_STATE(8077)] = 282110,
  [SMALL_STATE(8078)] = 282117,
  [SMALL_STATE(8079)] = 282124,
  [SMALL_STATE(8080)] = 282131,
  [SMALL_STATE(8081)] = 282138,
  [SMALL_STATE(8082)] = 282145,
  [SMALL_STATE(8083)] = 282152,
  [SMALL_STATE(8084)] = 282159,
  [SMALL_STATE(8085)] = 282166,
  [SMALL_STATE(8086)] = 282173,
  [SMALL_STATE(8087)] = 282180,
  [SMALL_STATE(8088)] = 282187,
  [SMALL_STATE(8089)] = 282194,
  [SMALL_STATE(8090)] = 282201,
  [SMALL_STATE(8091)] = 282208,
  [SMALL_STATE(8092)] = 282215,
  [SMALL_STATE(8093)] = 282222,
  [SMALL_STATE(8094)] = 282229,
  [SMALL_STATE(8095)] = 282236,
  [SMALL_STATE(8096)] = 282243,
  [SMALL_STATE(8097)] = 282250,
  [SMALL_STATE(8098)] = 282257,
  [SMALL_STATE(8099)] = 282264,
  [SMALL_STATE(8100)] = 282271,
  [SMALL_STATE(8101)] = 282278,
  [SMALL_STATE(8102)] = 282285,
  [SMALL_STATE(8103)] = 282292,
  [SMALL_STATE(8104)] = 282299,
  [SMALL_STATE(8105)] = 282306,
  [SMALL_STATE(8106)] = 282313,
  [SMALL_STATE(8107)] = 282320,
  [SMALL_STATE(8108)] = 282327,
  [SMALL_STATE(8109)] = 282334,
  [SMALL_STATE(8110)] = 282341,
  [SMALL_STATE(8111)] = 282348,
  [SMALL_STATE(8112)] = 282355,
  [SMALL_STATE(8113)] = 282362,
  [SMALL_STATE(8114)] = 282369,
  [SMALL_STATE(8115)] = 282376,
  [SMALL_STATE(8116)] = 282383,
  [SMALL_STATE(8117)] = 282390,
  [SMALL_STATE(8118)] = 282397,
  [SMALL_STATE(8119)] = 282404,
  [SMALL_STATE(8120)] = 282411,
  [SMALL_STATE(8121)] = 282418,
  [SMALL_STATE(8122)] = 282425,
  [SMALL_STATE(8123)] = 282432,
  [SMALL_STATE(8124)] = 282439,
  [SMALL_STATE(8125)] = 282446,
  [SMALL_STATE(8126)] = 282453,
  [SMALL_STATE(8127)] = 282460,
  [SMALL_STATE(8128)] = 282467,
  [SMALL_STATE(8129)] = 282474,
  [SMALL_STATE(8130)] = 282481,
  [SMALL_STATE(8131)] = 282488,
  [SMALL_STATE(8132)] = 282495,
  [SMALL_STATE(8133)] = 282502,
  [SMALL_STATE(8134)] = 282509,
  [SMALL_STATE(8135)] = 282516,
  [SMALL_STATE(8136)] = 282523,
  [SMALL_STATE(8137)] = 282530,
  [SMALL_STATE(8138)] = 282537,
  [SMALL_STATE(8139)] = 282544,
  [SMALL_STATE(8140)] = 282551,
  [SMALL_STATE(8141)] = 282558,
  [SMALL_STATE(8142)] = 282565,
  [SMALL_STATE(8143)] = 282572,
  [SMALL_STATE(8144)] = 282579,
  [SMALL_STATE(8145)] = 282586,
  [SMALL_STATE(8146)] = 282593,
  [SMALL_STATE(8147)] = 282600,
  [SMALL_STATE(8148)] = 282607,
  [SMALL_STATE(8149)] = 282614,
  [SMALL_STATE(8150)] = 282621,
  [SMALL_STATE(8151)] = 282628,
  [SMALL_STATE(8152)] = 282635,
  [SMALL_STATE(8153)] = 282642,
  [SMALL_STATE(8154)] = 282649,
  [SMALL_STATE(8155)] = 282656,
  [SMALL_STATE(8156)] = 282663,
  [SMALL_STATE(8157)] = 282670,
  [SMALL_STATE(8158)] = 282677,
  [SMALL_STATE(8159)] = 282684,
  [SMALL_STATE(8160)] = 282691,
  [SMALL_STATE(8161)] = 282698,
  [SMALL_STATE(8162)] = 282705,
  [SMALL_STATE(8163)] = 282712,
  [SMALL_STATE(8164)] = 282719,
  [SMALL_STATE(8165)] = 282726,
  [SMALL_STATE(8166)] = 282733,
  [SMALL_STATE(8167)] = 282740,
  [SMALL_STATE(8168)] = 282747,
  [SMALL_STATE(8169)] = 282754,
  [SMALL_STATE(8170)] = 282761,
  [SMALL_STATE(8171)] = 282768,
  [SMALL_STATE(8172)] = 282775,
  [SMALL_STATE(8173)] = 282782,
  [SMALL_STATE(8174)] = 282789,
  [SMALL_STATE(8175)] = 282796,
  [SMALL_STATE(8176)] = 282803,
  [SMALL_STATE(8177)] = 282810,
  [SMALL_STATE(8178)] = 282817,
  [SMALL_STATE(8179)] = 282824,
  [SMALL_STATE(8180)] = 282831,
  [SMALL_STATE(8181)] = 282838,
  [SMALL_STATE(8182)] = 282845,
  [SMALL_STATE(8183)] = 282852,
  [SMALL_STATE(8184)] = 282859,
  [SMALL_STATE(8185)] = 282866,
  [SMALL_STATE(8186)] = 282873,
  [SMALL_STATE(8187)] = 282880,
  [SMALL_STATE(8188)] = 282887,
  [SMALL_STATE(8189)] = 282894,
  [SMALL_STATE(8190)] = 282901,
  [SMALL_STATE(8191)] = 282908,
  [SMALL_STATE(8192)] = 282915,
  [SMALL_STATE(8193)] = 282922,
  [SMALL_STATE(8194)] = 282929,
  [SMALL_STATE(8195)] = 282936,
  [SMALL_STATE(8196)] = 282943,
  [SMALL_STATE(8197)] = 282950,
  [SMALL_STATE(8198)] = 282957,
  [SMALL_STATE(8199)] = 282964,
  [SMALL_STATE(8200)] = 282971,
  [SMALL_STATE(8201)] = 282978,
  [SMALL_STATE(8202)] = 282985,
  [SMALL_STATE(8203)] = 282992,
  [SMALL_STATE(8204)] = 282999,
  [SMALL_STATE(8205)] = 283006,
  [SMALL_STATE(8206)] = 283013,
  [SMALL_STATE(8207)] = 283020,
  [SMALL_STATE(8208)] = 283027,
  [SMALL_STATE(8209)] = 283034,
  [SMALL_STATE(8210)] = 283041,
  [SMALL_STATE(8211)] = 283048,
  [SMALL_STATE(8212)] = 283055,
  [SMALL_STATE(8213)] = 283062,
  [SMALL_STATE(8214)] = 283069,
  [SMALL_STATE(8215)] = 283076,
  [SMALL_STATE(8216)] = 283083,
  [SMALL_STATE(8217)] = 283090,
  [SMALL_STATE(8218)] = 283097,
  [SMALL_STATE(8219)] = 283104,
  [SMALL_STATE(8220)] = 283111,
  [SMALL_STATE(8221)] = 283118,
  [SMALL_STATE(8222)] = 283125,
  [SMALL_STATE(8223)] = 283132,
  [SMALL_STATE(8224)] = 283139,
  [SMALL_STATE(8225)] = 283146,
  [SMALL_STATE(8226)] = 283153,
  [SMALL_STATE(8227)] = 283160,
  [SMALL_STATE(8228)] = 283167,
  [SMALL_STATE(8229)] = 283174,
  [SMALL_STATE(8230)] = 283181,
  [SMALL_STATE(8231)] = 283188,
  [SMALL_STATE(8232)] = 283195,
  [SMALL_STATE(8233)] = 283202,
  [SMALL_STATE(8234)] = 283209,
  [SMALL_STATE(8235)] = 283216,
  [SMALL_STATE(8236)] = 283223,
  [SMALL_STATE(8237)] = 283230,
  [SMALL_STATE(8238)] = 283237,
  [SMALL_STATE(8239)] = 283244,
  [SMALL_STATE(8240)] = 283251,
  [SMALL_STATE(8241)] = 283258,
  [SMALL_STATE(8242)] = 283265,
  [SMALL_STATE(8243)] = 283272,
  [SMALL_STATE(8244)] = 283279,
  [SMALL_STATE(8245)] = 283286,
  [SMALL_STATE(8246)] = 283293,
  [SMALL_STATE(8247)] = 283300,
  [SMALL_STATE(8248)] = 283307,
  [SMALL_STATE(8249)] = 283314,
  [SMALL_STATE(8250)] = 283321,
  [SMALL_STATE(8251)] = 283328,
  [SMALL_STATE(8252)] = 283335,
  [SMALL_STATE(8253)] = 283342,
  [SMALL_STATE(8254)] = 283349,
  [SMALL_STATE(8255)] = 283356,
  [SMALL_STATE(8256)] = 283363,
  [SMALL_STATE(8257)] = 283370,
  [SMALL_STATE(8258)] = 283377,
  [SMALL_STATE(8259)] = 283384,
  [SMALL_STATE(8260)] = 283391,
  [SMALL_STATE(8261)] = 283398,
  [SMALL_STATE(8262)] = 283405,
  [SMALL_STATE(8263)] = 283412,
  [SMALL_STATE(8264)] = 283419,
  [SMALL_STATE(8265)] = 283426,
  [SMALL_STATE(8266)] = 283433,
  [SMALL_STATE(8267)] = 283440,
  [SMALL_STATE(8268)] = 283447,
  [SMALL_STATE(8269)] = 283454,
  [SMALL_STATE(8270)] = 283461,
  [SMALL_STATE(8271)] = 283468,
  [SMALL_STATE(8272)] = 283475,
  [SMALL_STATE(8273)] = 283482,
  [SMALL_STATE(8274)] = 283489,
  [SMALL_STATE(8275)] = 283496,
  [SMALL_STATE(8276)] = 283503,
  [SMALL_STATE(8277)] = 283510,
  [SMALL_STATE(8278)] = 283517,
  [SMALL_STATE(8279)] = 283524,
  [SMALL_STATE(8280)] = 283531,
  [SMALL_STATE(8281)] = 283538,
  [SMALL_STATE(8282)] = 283545,
  [SMALL_STATE(8283)] = 283552,
  [SMALL_STATE(8284)] = 283559,
  [SMALL_STATE(8285)] = 283566,
  [SMALL_STATE(8286)] = 283573,
  [SMALL_STATE(8287)] = 283580,
  [SMALL_STATE(8288)] = 283587,
  [SMALL_STATE(8289)] = 283594,
  [SMALL_STATE(8290)] = 283601,
  [SMALL_STATE(8291)] = 283608,
  [SMALL_STATE(8292)] = 283615,
  [SMALL_STATE(8293)] = 283622,
  [SMALL_STATE(8294)] = 283629,
  [SMALL_STATE(8295)] = 283636,
  [SMALL_STATE(8296)] = 283643,
  [SMALL_STATE(8297)] = 283650,
  [SMALL_STATE(8298)] = 283657,
  [SMALL_STATE(8299)] = 283664,
  [SMALL_STATE(8300)] = 283671,
  [SMALL_STATE(8301)] = 283678,
  [SMALL_STATE(8302)] = 283685,
  [SMALL_STATE(8303)] = 283692,
  [SMALL_STATE(8304)] = 283699,
  [SMALL_STATE(8305)] = 283706,
  [SMALL_STATE(8306)] = 283713,
  [SMALL_STATE(8307)] = 283720,
  [SMALL_STATE(8308)] = 283727,
  [SMALL_STATE(8309)] = 283734,
  [SMALL_STATE(8310)] = 283741,
  [SMALL_STATE(8311)] = 283748,
  [SMALL_STATE(8312)] = 283755,
  [SMALL_STATE(8313)] = 283762,
  [SMALL_STATE(8314)] = 283769,
  [SMALL_STATE(8315)] = 283776,
  [SMALL_STATE(8316)] = 283783,
  [SMALL_STATE(8317)] = 283790,
  [SMALL_STATE(8318)] = 283797,
  [SMALL_STATE(8319)] = 283804,
  [SMALL_STATE(8320)] = 283811,
  [SMALL_STATE(8321)] = 283818,
  [SMALL_STATE(8322)] = 283825,
  [SMALL_STATE(8323)] = 283832,
  [SMALL_STATE(8324)] = 283839,
  [SMALL_STATE(8325)] = 283846,
  [SMALL_STATE(8326)] = 283853,
  [SMALL_STATE(8327)] = 283860,
  [SMALL_STATE(8328)] = 283867,
  [SMALL_STATE(8329)] = 283874,
  [SMALL_STATE(8330)] = 283881,
  [SMALL_STATE(8331)] = 283888,
  [SMALL_STATE(8332)] = 283895,
  [SMALL_STATE(8333)] = 283902,
  [SMALL_STATE(8334)] = 283909,
  [SMALL_STATE(8335)] = 283916,
  [SMALL_STATE(8336)] = 283923,
  [SMALL_STATE(8337)] = 283930,
  [SMALL_STATE(8338)] = 283937,
  [SMALL_STATE(8339)] = 283944,
  [SMALL_STATE(8340)] = 283951,
  [SMALL_STATE(8341)] = 283958,
  [SMALL_STATE(8342)] = 283965,
  [SMALL_STATE(8343)] = 283972,
  [SMALL_STATE(8344)] = 283979,
  [SMALL_STATE(8345)] = 283986,
  [SMALL_STATE(8346)] = 283993,
  [SMALL_STATE(8347)] = 284000,
  [SMALL_STATE(8348)] = 284007,
  [SMALL_STATE(8349)] = 284014,
  [SMALL_STATE(8350)] = 284021,
  [SMALL_STATE(8351)] = 284028,
  [SMALL_STATE(8352)] = 284035,
  [SMALL_STATE(8353)] = 284042,
  [SMALL_STATE(8354)] = 284049,
  [SMALL_STATE(8355)] = 284056,
  [SMALL_STATE(8356)] = 284063,
  [SMALL_STATE(8357)] = 284070,
  [SMALL_STATE(8358)] = 284077,
  [SMALL_STATE(8359)] = 284084,
  [SMALL_STATE(8360)] = 284091,
  [SMALL_STATE(8361)] = 284098,
  [SMALL_STATE(8362)] = 284105,
  [SMALL_STATE(8363)] = 284112,
  [SMALL_STATE(8364)] = 284119,
  [SMALL_STATE(8365)] = 284126,
  [SMALL_STATE(8366)] = 284133,
  [SMALL_STATE(8367)] = 284140,
  [SMALL_STATE(8368)] = 284147,
  [SMALL_STATE(8369)] = 284154,
  [SMALL_STATE(8370)] = 284161,
  [SMALL_STATE(8371)] = 284168,
  [SMALL_STATE(8372)] = 284175,
  [SMALL_STATE(8373)] = 284182,
  [SMALL_STATE(8374)] = 284189,
  [SMALL_STATE(8375)] = 284196,
  [SMALL_STATE(8376)] = 284203,
  [SMALL_STATE(8377)] = 284210,
  [SMALL_STATE(8378)] = 284217,
  [SMALL_STATE(8379)] = 284224,
  [SMALL_STATE(8380)] = 284231,
  [SMALL_STATE(8381)] = 284238,
  [SMALL_STATE(8382)] = 284245,
  [SMALL_STATE(8383)] = 284252,
  [SMALL_STATE(8384)] = 284259,
  [SMALL_STATE(8385)] = 284266,
  [SMALL_STATE(8386)] = 284273,
  [SMALL_STATE(8387)] = 284280,
  [SMALL_STATE(8388)] = 284287,
  [SMALL_STATE(8389)] = 284294,
  [SMALL_STATE(8390)] = 284301,
  [SMALL_STATE(8391)] = 284308,
  [SMALL_STATE(8392)] = 284315,
  [SMALL_STATE(8393)] = 284322,
  [SMALL_STATE(8394)] = 284329,
  [SMALL_STATE(8395)] = 284336,
  [SMALL_STATE(8396)] = 284343,
  [SMALL_STATE(8397)] = 284350,
  [SMALL_STATE(8398)] = 284357,
  [SMALL_STATE(8399)] = 284364,
  [SMALL_STATE(8400)] = 284371,
  [SMALL_STATE(8401)] = 284378,
  [SMALL_STATE(8402)] = 284385,
  [SMALL_STATE(8403)] = 284392,
  [SMALL_STATE(8404)] = 284399,
  [SMALL_STATE(8405)] = 284406,
  [SMALL_STATE(8406)] = 284413,
  [SMALL_STATE(8407)] = 284420,
  [SMALL_STATE(8408)] = 284427,
  [SMALL_STATE(8409)] = 284434,
  [SMALL_STATE(8410)] = 284441,
  [SMALL_STATE(8411)] = 284448,
  [SMALL_STATE(8412)] = 284455,
  [SMALL_STATE(8413)] = 284462,
  [SMALL_STATE(8414)] = 284469,
  [SMALL_STATE(8415)] = 284476,
  [SMALL_STATE(8416)] = 284483,
  [SMALL_STATE(8417)] = 284490,
  [SMALL_STATE(8418)] = 284497,
  [SMALL_STATE(8419)] = 284504,
  [SMALL_STATE(8420)] = 284511,
  [SMALL_STATE(8421)] = 284518,
  [SMALL_STATE(8422)] = 284525,
  [SMALL_STATE(8423)] = 284532,
  [SMALL_STATE(8424)] = 284539,
  [SMALL_STATE(8425)] = 284546,
  [SMALL_STATE(8426)] = 284553,
  [SMALL_STATE(8427)] = 284560,
  [SMALL_STATE(8428)] = 284567,
  [SMALL_STATE(8429)] = 284574,
  [SMALL_STATE(8430)] = 284581,
  [SMALL_STATE(8431)] = 284588,
  [SMALL_STATE(8432)] = 284595,
  [SMALL_STATE(8433)] = 284602,
  [SMALL_STATE(8434)] = 284609,
  [SMALL_STATE(8435)] = 284616,
  [SMALL_STATE(8436)] = 284623,
  [SMALL_STATE(8437)] = 284630,
  [SMALL_STATE(8438)] = 284637,
  [SMALL_STATE(8439)] = 284644,
  [SMALL_STATE(8440)] = 284651,
  [SMALL_STATE(8441)] = 284658,
  [SMALL_STATE(8442)] = 284665,
  [SMALL_STATE(8443)] = 284672,
  [SMALL_STATE(8444)] = 284679,
  [SMALL_STATE(8445)] = 284686,
  [SMALL_STATE(8446)] = 284693,
  [SMALL_STATE(8447)] = 284700,
  [SMALL_STATE(8448)] = 284707,
  [SMALL_STATE(8449)] = 284714,
  [SMALL_STATE(8450)] = 284721,
  [SMALL_STATE(8451)] = 284728,
  [SMALL_STATE(8452)] = 284735,
  [SMALL_STATE(8453)] = 284742,
  [SMALL_STATE(8454)] = 284749,
  [SMALL_STATE(8455)] = 284756,
  [SMALL_STATE(8456)] = 284763,
  [SMALL_STATE(8457)] = 284770,
  [SMALL_STATE(8458)] = 284777,
  [SMALL_STATE(8459)] = 284784,
  [SMALL_STATE(8460)] = 284791,
  [SMALL_STATE(8461)] = 284798,
  [SMALL_STATE(8462)] = 284805,
  [SMALL_STATE(8463)] = 284812,
  [SMALL_STATE(8464)] = 284819,
  [SMALL_STATE(8465)] = 284826,
  [SMALL_STATE(8466)] = 284833,
  [SMALL_STATE(8467)] = 284840,
  [SMALL_STATE(8468)] = 284847,
  [SMALL_STATE(8469)] = 284854,
  [SMALL_STATE(8470)] = 284861,
  [SMALL_STATE(8471)] = 284868,
  [SMALL_STATE(8472)] = 284875,
  [SMALL_STATE(8473)] = 284882,
  [SMALL_STATE(8474)] = 284889,
  [SMALL_STATE(8475)] = 284896,
  [SMALL_STATE(8476)] = 284903,
  [SMALL_STATE(8477)] = 284910,
  [SMALL_STATE(8478)] = 284917,
  [SMALL_STATE(8479)] = 284924,
  [SMALL_STATE(8480)] = 284931,
  [SMALL_STATE(8481)] = 284938,
  [SMALL_STATE(8482)] = 284945,
  [SMALL_STATE(8483)] = 284952,
  [SMALL_STATE(8484)] = 284959,
  [SMALL_STATE(8485)] = 284966,
  [SMALL_STATE(8486)] = 284973,
  [SMALL_STATE(8487)] = 284980,
  [SMALL_STATE(8488)] = 284987,
  [SMALL_STATE(8489)] = 284994,
  [SMALL_STATE(8490)] = 285001,
  [SMALL_STATE(8491)] = 285008,
  [SMALL_STATE(8492)] = 285015,
  [SMALL_STATE(8493)] = 285022,
  [SMALL_STATE(8494)] = 285029,
  [SMALL_STATE(8495)] = 285036,
  [SMALL_STATE(8496)] = 285043,
  [SMALL_STATE(8497)] = 285050,
  [SMALL_STATE(8498)] = 285057,
  [SMALL_STATE(8499)] = 285064,
  [SMALL_STATE(8500)] = 285071,
  [SMALL_STATE(8501)] = 285078,
  [SMALL_STATE(8502)] = 285085,
  [SMALL_STATE(8503)] = 285092,
  [SMALL_STATE(8504)] = 285099,
  [SMALL_STATE(8505)] = 285106,
  [SMALL_STATE(8506)] = 285113,
  [SMALL_STATE(8507)] = 285120,
  [SMALL_STATE(8508)] = 285127,
  [SMALL_STATE(8509)] = 285134,
  [SMALL_STATE(8510)] = 285141,
  [SMALL_STATE(8511)] = 285148,
  [SMALL_STATE(8512)] = 285155,
  [SMALL_STATE(8513)] = 285162,
  [SMALL_STATE(8514)] = 285169,
  [SMALL_STATE(8515)] = 285176,
  [SMALL_STATE(8516)] = 285183,
  [SMALL_STATE(8517)] = 285190,
  [SMALL_STATE(8518)] = 285197,
  [SMALL_STATE(8519)] = 285204,
  [SMALL_STATE(8520)] = 285211,
  [SMALL_STATE(8521)] = 285218,
  [SMALL_STATE(8522)] = 285225,
  [SMALL_STATE(8523)] = 285232,
  [SMALL_STATE(8524)] = 285239,
  [SMALL_STATE(8525)] = 285246,
  [SMALL_STATE(8526)] = 285253,
  [SMALL_STATE(8527)] = 285260,
  [SMALL_STATE(8528)] = 285267,
  [SMALL_STATE(8529)] = 285274,
  [SMALL_STATE(8530)] = 285281,
  [SMALL_STATE(8531)] = 285288,
  [SMALL_STATE(8532)] = 285295,
  [SMALL_STATE(8533)] = 285302,
  [SMALL_STATE(8534)] = 285309,
  [SMALL_STATE(8535)] = 285316,
  [SMALL_STATE(8536)] = 285323,
  [SMALL_STATE(8537)] = 285330,
  [SMALL_STATE(8538)] = 285337,
  [SMALL_STATE(8539)] = 285344,
  [SMALL_STATE(8540)] = 285351,
  [SMALL_STATE(8541)] = 285358,
  [SMALL_STATE(8542)] = 285365,
  [SMALL_STATE(8543)] = 285372,
  [SMALL_STATE(8544)] = 285379,
  [SMALL_STATE(8545)] = 285386,
  [SMALL_STATE(8546)] = 285393,
  [SMALL_STATE(8547)] = 285400,
  [SMALL_STATE(8548)] = 285407,
  [SMALL_STATE(8549)] = 285414,
  [SMALL_STATE(8550)] = 285421,
  [SMALL_STATE(8551)] = 285428,
  [SMALL_STATE(8552)] = 285435,
  [SMALL_STATE(8553)] = 285442,
  [SMALL_STATE(8554)] = 285449,
  [SMALL_STATE(8555)] = 285456,
  [SMALL_STATE(8556)] = 285463,
  [SMALL_STATE(8557)] = 285470,
  [SMALL_STATE(8558)] = 285477,
  [SMALL_STATE(8559)] = 285484,
  [SMALL_STATE(8560)] = 285491,
  [SMALL_STATE(8561)] = 285498,
  [SMALL_STATE(8562)] = 285505,
  [SMALL_STATE(8563)] = 285512,
  [SMALL_STATE(8564)] = 285519,
  [SMALL_STATE(8565)] = 285526,
  [SMALL_STATE(8566)] = 285533,
  [SMALL_STATE(8567)] = 285540,
  [SMALL_STATE(8568)] = 285547,
  [SMALL_STATE(8569)] = 285554,
  [SMALL_STATE(8570)] = 285561,
  [SMALL_STATE(8571)] = 285568,
  [SMALL_STATE(8572)] = 285575,
  [SMALL_STATE(8573)] = 285582,
  [SMALL_STATE(8574)] = 285589,
  [SMALL_STATE(8575)] = 285596,
  [SMALL_STATE(8576)] = 285603,
  [SMALL_STATE(8577)] = 285610,
  [SMALL_STATE(8578)] = 285617,
  [SMALL_STATE(8579)] = 285624,
  [SMALL_STATE(8580)] = 285631,
  [SMALL_STATE(8581)] = 285638,
  [SMALL_STATE(8582)] = 285645,
  [SMALL_STATE(8583)] = 285652,
  [SMALL_STATE(8584)] = 285659,
  [SMALL_STATE(8585)] = 285666,
  [SMALL_STATE(8586)] = 285673,
  [SMALL_STATE(8587)] = 285680,
  [SMALL_STATE(8588)] = 285687,
  [SMALL_STATE(8589)] = 285694,
  [SMALL_STATE(8590)] = 285701,
  [SMALL_STATE(8591)] = 285708,
  [SMALL_STATE(8592)] = 285715,
  [SMALL_STATE(8593)] = 285722,
  [SMALL_STATE(8594)] = 285729,
  [SMALL_STATE(8595)] = 285736,
  [SMALL_STATE(8596)] = 285743,
  [SMALL_STATE(8597)] = 285750,
  [SMALL_STATE(8598)] = 285757,
  [SMALL_STATE(8599)] = 285764,
  [SMALL_STATE(8600)] = 285771,
  [SMALL_STATE(8601)] = 285778,
  [SMALL_STATE(8602)] = 285785,
  [SMALL_STATE(8603)] = 285792,
  [SMALL_STATE(8604)] = 285799,
  [SMALL_STATE(8605)] = 285806,
  [SMALL_STATE(8606)] = 285813,
  [SMALL_STATE(8607)] = 285820,
  [SMALL_STATE(8608)] = 285827,
  [SMALL_STATE(8609)] = 285834,
  [SMALL_STATE(8610)] = 285841,
  [SMALL_STATE(8611)] = 285848,
  [SMALL_STATE(8612)] = 285855,
  [SMALL_STATE(8613)] = 285862,
  [SMALL_STATE(8614)] = 285869,
  [SMALL_STATE(8615)] = 285876,
  [SMALL_STATE(8616)] = 285883,
  [SMALL_STATE(8617)] = 285890,
  [SMALL_STATE(8618)] = 285897,
  [SMALL_STATE(8619)] = 285904,
  [SMALL_STATE(8620)] = 285911,
  [SMALL_STATE(8621)] = 285918,
  [SMALL_STATE(8622)] = 285925,
  [SMALL_STATE(8623)] = 285932,
  [SMALL_STATE(8624)] = 285939,
  [SMALL_STATE(8625)] = 285946,
  [SMALL_STATE(8626)] = 285953,
  [SMALL_STATE(8627)] = 285960,
  [SMALL_STATE(8628)] = 285967,
  [SMALL_STATE(8629)] = 285974,
  [SMALL_STATE(8630)] = 285981,
  [SMALL_STATE(8631)] = 285988,
  [SMALL_STATE(8632)] = 285995,
  [SMALL_STATE(8633)] = 286002,
  [SMALL_STATE(8634)] = 286009,
  [SMALL_STATE(8635)] = 286016,
  [SMALL_STATE(8636)] = 286023,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_translation_unit, 0, 0, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(840),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6502),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8240),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5622),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8596),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7501),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1183),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5212),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(862),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(224),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3725),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3077),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2624),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8107),
  [45] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6433),
  [47] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7666),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7965),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7438),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3743),
  [55] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2269),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5626),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3106),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2975),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1619),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8179),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2512),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6135),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5100),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5048),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5005),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7090),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7596),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1222),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7813),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7569),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(210),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7905),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(947),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8268),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8015),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7956),
  [101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1116),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8020),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8277),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8491),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6644),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4761),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7107),
  [117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6931),
  [119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4827),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3839),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2423),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8206),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4162),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5170),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1514),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(789),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7671),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1184),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1061),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6492),
  [143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6356),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8408),
  [147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7910),
  [149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1068),
  [151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1185),
  [153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7634),
  [155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1186),
  [157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4983),
  [159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5292),
  [161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(834),
  [163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6514),
  [165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8088),
  [167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8409),
  [169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5603),
  [171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8092),
  [173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7573),
  [175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(225),
  [179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3709),
  [181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2646),
  [183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(938),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2979),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7256),
  [193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7646),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1394),
  [197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7992),
  [199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7603),
  [201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(213),
  [203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8113),
  [205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(949),
  [207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8011),
  [209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8018),
  [211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8160),
  [213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7471),
  [215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7949),
  [217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8498),
  [219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4168),
  [221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3840),
  [223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1516),
  [225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7652),
  [227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1133),
  [229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6524),
  [231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6414),
  [233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8453),
  [235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8454),
  [237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1139),
  [239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1395),
  [241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1669),
  [247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1889),
  [251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1898),
  [255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1886),
  [257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1665),
  [259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1866),
  [261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(836),
  [263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6484),
  [265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8235),
  [267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5652),
  [269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(693),
  [271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8236),
  [273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(36),
  [275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5582),
  [277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7865),
  [279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7466),
  [281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(226),
  [285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3722),
  [287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2666),
  [289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3012),
  [293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7386),
  [295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7506),
  [297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1163),
  [299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7989),
  [301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7649),
  [303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(214),
  [305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8452),
  [307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(946),
  [309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7874),
  [311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7879),
  [313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8276),
  [315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7517),
  [317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8304),
  [319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1517),
  [321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7509),
  [323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1078),
  [325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6530),
  [327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6410),
  [329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8537),
  [331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8538),
  [333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1081),
  [335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1417),
  [337] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elifdef, 2, 0, 10),
  [339] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif, 3, 0, 79),
  [341] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elifdef, 3, 0, 10),
  [343] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif, 4, 0, 79),
  [345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(623),
  [347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(736),
  [349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(638),
  [351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(741),
  [353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(563),
  [355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(543),
  [357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(271),
  [359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(306),
  [361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(635),
  [363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(585),
  [365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(673),
  [367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(337),
  [369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(740),
  [371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(631),
  [373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(304),
  [375] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(836),
  [378] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6484),
  [381] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8235),
  [384] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5652),
  [387] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0),
  [389] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8236),
  [392] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7466),
  [395] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(120),
  [398] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1183),
  [401] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1239),
  [404] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1183),
  [407] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(394),
  [410] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5212),
  [413] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(862),
  [416] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(245),
  [419] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(226),
  [422] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(3722),
  [425] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(3077),
  [428] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2666),
  [431] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8107),
  [434] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6433),
  [437] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7666),
  [440] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7965),
  [443] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7438),
  [446] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(3743),
  [449] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(49),
  [452] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2269),
  [455] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5626),
  [458] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(3106),
  [461] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(3012),
  [464] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1619),
  [467] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8179),
  [470] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2512),
  [473] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6135),
  [476] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5100),
  [479] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5048),
  [482] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5005),
  [485] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7386),
  [488] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7506),
  [491] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1163),
  [494] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7989),
  [497] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7649),
  [500] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(214),
  [503] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8452),
  [506] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(946),
  [509] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7874),
  [512] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7879),
  [515] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8276),
  [518] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7517),
  [521] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8304),
  [524] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1247),
  [527] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1116),
  [530] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8020),
  [533] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8277),
  [536] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8491),
  [539] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6644),
  [542] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(4168),
  [545] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7107),
  [548] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6931),
  [551] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(3840),
  [554] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(3839),
  [557] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2423),
  [560] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8206),
  [563] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(4162),
  [566] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5170),
  [569] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1517),
  [572] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(789),
  [575] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7509),
  [578] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1184),
  [581] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1078),
  [584] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6530),
  [587] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6410),
  [590] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8537),
  [593] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8538),
  [596] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1081),
  [599] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1417),
  [602] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7634),
  [605] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1186),
  [608] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(4983),
  [611] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5292),
  [614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(839),
  [616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1903),
  [622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(837),
  [624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6516),
  [626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7904),
  [628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5657),
  [630] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else, 1, 0, 0),
  [632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7811),
  [634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7475),
  [636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(222),
  [640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3733),
  [642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2621),
  [644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3023),
  [648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7150),
  [650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7550),
  [652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1429),
  [654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7948),
  [656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7508),
  [658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(215),
  [660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8536),
  [662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(940),
  [664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8057),
  [666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8058),
  [668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7820),
  [670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7559),
  [672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7869),
  [674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1518),
  [676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7553),
  [678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1141),
  [680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6531),
  [682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6429),
  [684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8559),
  [686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8551),
  [688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1153),
  [690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1423),
  [692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [700] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(839),
  [703] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6514),
  [706] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8088),
  [709] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5603),
  [712] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8092),
  [715] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7573),
  [718] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(472),
  [721] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(225),
  [724] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(3709),
  [727] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2646),
  [730] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(37),
  [733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0),
  [735] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2979),
  [738] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7256),
  [741] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7646),
  [744] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1394),
  [747] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7992),
  [750] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7603),
  [753] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(213),
  [756] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8113),
  [759] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(949),
  [762] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8011),
  [765] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8018),
  [768] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8160),
  [771] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7471),
  [774] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7949),
  [777] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1516),
  [780] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7652),
  [783] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1133),
  [786] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6524),
  [789] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6414),
  [792] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8453),
  [795] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8454),
  [798] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1139),
  [801] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1395),
  [804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3289),
  [808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3174),
  [812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [814] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else, 2, 0, 0),
  [816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [828] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(837),
  [831] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6516),
  [834] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7904),
  [837] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(5657),
  [840] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7811),
  [843] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7475),
  [846] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(441),
  [849] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(222),
  [852] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(3733),
  [855] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(2621),
  [858] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(58),
  [861] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(3023),
  [864] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7150),
  [867] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7550),
  [870] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1429),
  [873] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7948),
  [876] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7508),
  [879] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(215),
  [882] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8536),
  [885] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(940),
  [888] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8057),
  [891] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8058),
  [894] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7820),
  [897] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7559),
  [900] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7869),
  [903] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1518),
  [906] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(7553),
  [909] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1141),
  [912] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6531),
  [915] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(6429),
  [918] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8559),
  [921] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(8551),
  [924] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1153),
  [927] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_repeat1, 2, 0, 0), SHIFT_REPEAT(1423),
  [930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3329),
  [932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2426),
  [934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2437),
  [936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1878),
  [942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1892),
  [944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4178),
  [950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4183),
  [952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3857),
  [954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3800),
  [956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3505),
  [958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3553),
  [960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2192),
  [962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2193),
  [964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5413),
  [966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5428),
  [968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1672),
  [970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1670),
  [972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5809),
  [974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5811),
  [976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1876),
  [978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3444),
  [980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0),
  [982] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(840),
  [985] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6502),
  [988] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8240),
  [991] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5622),
  [994] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8596),
  [997] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7501),
  [1000] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(120),
  [1003] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1183),
  [1006] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1239),
  [1009] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1183),
  [1012] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(394),
  [1015] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5212),
  [1018] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(862),
  [1021] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(713),
  [1024] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(224),
  [1027] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(3725),
  [1030] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(3077),
  [1033] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2624),
  [1036] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8107),
  [1039] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6433),
  [1042] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7666),
  [1045] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7965),
  [1048] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7438),
  [1051] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(3743),
  [1054] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(46),
  [1057] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2269),
  [1060] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5626),
  [1063] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(3106),
  [1066] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2975),
  [1069] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1619),
  [1072] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8179),
  [1075] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2512),
  [1078] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6135),
  [1081] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5100),
  [1084] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5048),
  [1087] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5005),
  [1090] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7090),
  [1093] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7596),
  [1096] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1222),
  [1099] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7813),
  [1102] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7569),
  [1105] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(210),
  [1108] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7905),
  [1111] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(947),
  [1114] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8268),
  [1117] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8015),
  [1120] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7956),
  [1123] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1247),
  [1126] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1116),
  [1129] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8020),
  [1132] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8277),
  [1135] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8491),
  [1138] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6644),
  [1141] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(4761),
  [1144] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7107),
  [1147] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6931),
  [1150] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(4827),
  [1153] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(3839),
  [1156] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(2423),
  [1159] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8206),
  [1162] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(4162),
  [1165] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5170),
  [1168] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1514),
  [1171] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(789),
  [1174] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7671),
  [1177] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1184),
  [1180] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1061),
  [1183] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6492),
  [1186] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(6356),
  [1189] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(8408),
  [1192] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7910),
  [1195] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1068),
  [1198] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1185),
  [1201] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(7634),
  [1204] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(1186),
  [1207] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(4983),
  [1210] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_translation_unit_repeat1, 2, 0, 0), SHIFT_REPEAT(5292),
  [1213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_translation_unit, 1, 0, 0),
  [1215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(922),
  [1217] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 2, 0, 0),
  [1219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [1221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1365),
  [1223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 2, 0, 0),
  [1225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1365),
  [1227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(395),
  [1229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2033),
  [1231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7504),
  [1233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5650),
  [1235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7577),
  [1237] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 3, 0, 14),
  [1239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 3, 0, 14),
  [1241] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 4, 0, 14),
  [1243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 4, 0, 14),
  [1245] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 3, 0, 0),
  [1247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 3, 0, 0),
  [1249] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(922),
  [1252] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0),
  [1254] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(159),
  [1257] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1183),
  [1260] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1183),
  [1263] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1365),
  [1266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0),
  [1268] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1365),
  [1271] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(245),
  [1274] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(395),
  [1277] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(3722),
  [1280] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2033),
  [1283] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(3106),
  [1286] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8107),
  [1289] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(6433),
  [1292] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7504),
  [1295] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7965),
  [1298] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(49),
  [1301] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2269),
  [1304] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(5650),
  [1307] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1619),
  [1310] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8179),
  [1313] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2512),
  [1316] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(6135),
  [1319] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(5100),
  [1322] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(5048),
  [1325] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(5005),
  [1328] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7386),
  [1331] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7506),
  [1334] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7649),
  [1337] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(214),
  [1340] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8452),
  [1343] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(946),
  [1346] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7874),
  [1349] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7879),
  [1352] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8276),
  [1355] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7517),
  [1358] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8304),
  [1361] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1247),
  [1364] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1116),
  [1367] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8020),
  [1370] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8277),
  [1373] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8491),
  [1376] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(6644),
  [1379] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(4168),
  [1382] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7107),
  [1385] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(6931),
  [1388] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(3840),
  [1391] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(3839),
  [1394] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2423),
  [1397] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8206),
  [1400] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(5170),
  [1403] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7577),
  [1406] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7509),
  [1409] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1184),
  [1412] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1078),
  [1415] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1081),
  [1418] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1417),
  [1421] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7634),
  [1424] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1186),
  [1427] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(4983),
  [1430] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(5292),
  [1433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(889),
  [1435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(393),
  [1437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(904),
  [1439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(391),
  [1441] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(908),
  [1444] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(497),
  [1447] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(388),
  [1450] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(3725),
  [1453] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(46),
  [1456] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7090),
  [1459] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7596),
  [1462] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7569),
  [1465] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(210),
  [1468] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7905),
  [1471] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(947),
  [1474] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8268),
  [1477] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8015),
  [1480] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7956),
  [1483] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7669),
  [1486] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8074),
  [1489] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7671),
  [1492] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1061),
  [1495] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1068),
  [1498] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1185),
  [1501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(908),
  [1503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [1505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(388),
  [1507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7669),
  [1509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8074),
  [1511] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(889),
  [1514] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(472),
  [1517] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(393),
  [1520] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(3709),
  [1523] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(37),
  [1526] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7256),
  [1529] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7646),
  [1532] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7603),
  [1535] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(213),
  [1538] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8113),
  [1541] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(949),
  [1544] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8011),
  [1547] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8018),
  [1550] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8160),
  [1553] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7471),
  [1556] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7949),
  [1559] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7652),
  [1562] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1133),
  [1565] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1139),
  [1568] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1395),
  [1571] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(904),
  [1574] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(441),
  [1577] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(391),
  [1580] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(3733),
  [1583] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(58),
  [1586] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7150),
  [1589] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7550),
  [1592] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7508),
  [1595] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(215),
  [1598] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8536),
  [1601] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(940),
  [1604] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8057),
  [1607] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8058),
  [1610] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7820),
  [1613] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7559),
  [1616] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7869),
  [1619] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7553),
  [1622] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1141),
  [1625] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1153),
  [1628] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1423),
  [1631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(412),
  [1633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(921),
  [1635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [1637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(374),
  [1639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3729),
  [1641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [1643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7199),
  [1645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7572),
  [1647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7551),
  [1649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(169),
  [1651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8549),
  [1653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(939),
  [1655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7950),
  [1657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7954),
  [1659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7909),
  [1661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7576),
  [1663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8089),
  [1665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7593),
  [1667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1104),
  [1669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1109),
  [1671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1430),
  [1673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1416),
  [1675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7861),
  [1677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(895),
  [1679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7111),
  [1681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7472),
  [1683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8310),
  [1685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7643),
  [1687] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(921),
  [1690] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(887),
  [1693] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(374),
  [1696] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(3729),
  [1699] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(62),
  [1702] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7199),
  [1705] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7572),
  [1708] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7551),
  [1711] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(169),
  [1714] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8549),
  [1717] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(939),
  [1720] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7950),
  [1723] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7954),
  [1726] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7909),
  [1729] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7576),
  [1732] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(8089),
  [1735] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7593),
  [1738] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1104),
  [1741] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1109),
  [1744] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1430),
  [1747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(890),
  [1749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [1751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(392),
  [1753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3731),
  [1755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7549),
  [1757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8470),
  [1759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1533),
  [1761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4285),
  [1763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [1765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1249),
  [1767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1250),
  [1769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1249),
  [1771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [1773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(885),
  [1775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(792),
  [1777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6434),
  [1779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6308),
  [1781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4142),
  [1783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5626),
  [1785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4992),
  [1787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6178),
  [1789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5006),
  [1791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5007),
  [1793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5008),
  [1795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1255),
  [1797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1106),
  [1799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8116),
  [1801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8600),
  [1803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8631),
  [1805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6610),
  [1807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3173),
  [1809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7152),
  [1811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6918),
  [1813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3378),
  [1815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3357),
  [1817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1804),
  [1819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8118),
  [1821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5121),
  [1823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3032),
  [1825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1228),
  [1827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7711),
  [1829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1229),
  [1831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4942),
  [1833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5302),
  [1835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8153),
  [1837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(907),
  [1839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7938),
  [1841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [1843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [1845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1362),
  [1847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [1849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(422),
  [1851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2045),
  [1853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6470),
  [1855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2962),
  [1857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6194),
  [1859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5042),
  [1861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5043),
  [1863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5044),
  [1865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1363),
  [1867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1093),
  [1869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8361),
  [1871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8609),
  [1873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8634),
  [1875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6634),
  [1877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3664),
  [1879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7260),
  [1881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6840),
  [1883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3827),
  [1885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3822),
  [1887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5132),
  [1889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1218),
  [1891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7749),
  [1893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1219),
  [1895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4972),
  [1897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5313),
  [1899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(934),
  [1901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7110),
  [1903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4590),
  [1905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [1907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_statement, 3, 0, 0),
  [1909] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_statement, 3, 0, 0),
  [1911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_statement, 2, 0, 0),
  [1913] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_statement, 2, 0, 0),
  [1915] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sizeof_expression, 4, 0, 45),
  [1917] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sizeof_expression, 4, 0, 45),
  [1919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1388),
  [1921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1388),
  [1923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1366),
  [1925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6456),
  [1927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [1929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6807),
  [1931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1129),
  [1933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8311),
  [1935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8603),
  [1937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8632),
  [1939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6627),
  [1941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2808),
  [1943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7283),
  [1945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6810),
  [1947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2470),
  [1949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2408),
  [1951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7944),
  [1953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1343),
  [1955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7746),
  [1957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1344),
  [1959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4926),
  [1961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5299),
  [1963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1636),
  [1965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1304),
  [1967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [1969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1232),
  [1971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6450),
  [1973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1076),
  [1975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2890),
  [1977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7200),
  [1979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6856),
  [1981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1165),
  [1983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7739),
  [1985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1166),
  [1987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4956),
  [1989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2000),
  [1991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1384),
  [1993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1384),
  [1995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1351),
  [1997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6454),
  [1999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1090),
  [2001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3071),
  [2003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7282),
  [2005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6881),
  [2007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1298),
  [2009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7756),
  [2011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1299),
  [2013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1539),
  [2015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [2017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5650),
  [2019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2152),
  [2021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1390),
  [2023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6875),
  [2025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2144),
  [2027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2134),
  [2029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1168),
  [2031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [2033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6928),
  [2035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2132),
  [2037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2124),
  [2039] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2124),
  [2042] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(159),
  [2045] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1183),
  [2048] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1183),
  [2051] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1365),
  [2054] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(245),
  [2057] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1390),
  [2060] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(6433),
  [2063] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7504),
  [2066] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(49),
  [2069] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(5650),
  [2072] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(6875),
  [2075] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7386),
  [2078] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7506),
  [2081] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1163),
  [2084] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7989),
  [2087] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7649),
  [2090] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(214),
  [2093] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8452),
  [2096] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(946),
  [2099] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7874),
  [2102] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7879),
  [2105] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8276),
  [2108] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7517),
  [2111] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8304),
  [2114] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1247),
  [2117] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1116),
  [2120] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8020),
  [2123] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8277),
  [2126] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8491),
  [2129] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(6644),
  [2132] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(4168),
  [2135] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7107),
  [2138] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(6931),
  [2141] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(3840),
  [2144] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(3839),
  [2147] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7944),
  [2150] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7577),
  [2153] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7509),
  [2156] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1184),
  [2159] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1078),
  [2162] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1081),
  [2165] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1417),
  [2168] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7634),
  [2171] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1186),
  [2174] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(4983),
  [2177] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(5292),
  [2180] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2132),
  [2183] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(472),
  [2186] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(46),
  [2189] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7111),
  [2192] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7596),
  [2195] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1416),
  [2198] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7861),
  [2201] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7472),
  [2204] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(210),
  [2207] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8310),
  [2210] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(947),
  [2213] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8268),
  [2216] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8015),
  [2219] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7956),
  [2222] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7643),
  [2225] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7949),
  [2228] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7671),
  [2231] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1061),
  [2234] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1068),
  [2237] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1185),
  [2240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2130),
  [2242] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2152),
  [2245] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(497),
  [2248] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7090),
  [2251] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1222),
  [2254] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7813),
  [2257] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7569),
  [2260] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7905),
  [2263] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7669),
  [2266] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8074),
  [2269] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2130),
  [2272] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(441),
  [2275] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(58),
  [2278] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7150),
  [2281] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7550),
  [2284] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1429),
  [2287] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7948),
  [2290] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7508),
  [2293] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(215),
  [2296] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8536),
  [2299] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(940),
  [2302] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8057),
  [2305] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8058),
  [2308] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7820),
  [2311] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7559),
  [2314] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7869),
  [2317] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7553),
  [2320] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1141),
  [2323] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1153),
  [2326] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1423),
  [2329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2133),
  [2331] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2133),
  [2334] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(887),
  [2337] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(62),
  [2340] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7199),
  [2343] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7572),
  [2346] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7551),
  [2349] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(169),
  [2352] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8549),
  [2355] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(939),
  [2358] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7950),
  [2361] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7954),
  [2364] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7909),
  [2367] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7576),
  [2370] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8089),
  [2373] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7593),
  [2376] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1104),
  [2379] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1109),
  [2382] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1430),
  [2385] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(2144),
  [2388] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(37),
  [2391] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7256),
  [2394] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7646),
  [2397] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1394),
  [2400] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7992),
  [2403] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7603),
  [2406] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(213),
  [2409] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8113),
  [2412] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(949),
  [2415] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8011),
  [2418] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8018),
  [2421] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(8160),
  [2424] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7471),
  [2427] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(7652),
  [2430] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1133),
  [2433] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1139),
  [2436] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT(1395),
  [2439] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0),
  [2441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0),
  [2443] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7526),
  [2446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2246),
  [2448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1377),
  [2450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1377),
  [2452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1332),
  [2454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6453),
  [2456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [2458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6925),
  [2460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1103),
  [2462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8381),
  [2464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8612),
  [2466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8635),
  [2468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6641),
  [2470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3374),
  [2472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7275),
  [2474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6857),
  [2476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3536),
  [2478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3534),
  [2480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1235),
  [2482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7751),
  [2484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1236),
  [2486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4976),
  [2488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5301),
  [2490] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, 0, 9),
  [2492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, 0, 9),
  [2494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7526),
  [2496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1451),
  [2498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1451),
  [2500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1460),
  [2502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6457),
  [2504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1132),
  [2506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1471),
  [2508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1472),
  [2510] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_try_statement, 3, 0, 9),
  [2512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_try_statement, 3, 0, 9),
  [2514] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(2056),
  [2517] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(159),
  [2520] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1183),
  [2523] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1365),
  [2526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0),
  [2528] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1365),
  [2531] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1390),
  [2534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3734),
  [2536] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0),
  [2538] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(6433),
  [2541] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(5650),
  [2544] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(6875),
  [2547] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(7944),
  [2550] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(7577),
  [2553] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_try_statement, 4, 0, 46),
  [2555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_try_statement, 4, 0, 46),
  [2557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3652),
  [2559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3710),
  [2561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3723),
  [2563] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 3, 0, 161),
  [2565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 3, 0, 161),
  [2567] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, 0, 51),
  [2569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, 0, 51),
  [2571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(177),
  [2573] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, 0, 104),
  [2575] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, 0, 104),
  [2577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2141),
  [2579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1196),
  [2581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [2583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6968),
  [2585] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_seh_except_clause, 3, 0, 179),
  [2587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_seh_except_clause, 3, 0, 179),
  [2589] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 3, 0, 55),
  [2591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 3, 0, 55),
  [2593] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement, 1, 0, 0),
  [2595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 1, 0, 0),
  [2597] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 3, 0, 0),
  [2599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 3, 0, 0),
  [2601] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_co_return_statement, 3, 0, 0),
  [2603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_co_return_statement, 3, 0, 0),
  [2605] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_co_yield_statement, 3, 0, 0),
  [2607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_co_yield_statement, 3, 0, 0),
  [2609] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 3, 0, 66),
  [2611] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 3, 0, 66),
  [2613] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 4, 0, 86),
  [2615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 4, 0, 86),
  [2617] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_seh_try_statement, 3, 0, 9),
  [2619] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_seh_try_statement, 3, 0, 9),
  [2621] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 3, 0, 52),
  [2623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 3, 0, 52),
  [2625] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, 0, 105),
  [2627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, 0, 105),
  [2629] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 1, 0, 0),
  [2631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 1, 0, 0),
  [2633] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 4, 0, 114),
  [2635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 4, 0, 114),
  [2637] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 4, 0, 115),
  [2639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 4, 0, 115),
  [2641] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0),
  [2643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2, 0, 0),
  [2645] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 5, 0, 132),
  [2647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 5, 0, 132),
  [2649] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 5, 0, 86),
  [2651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 5, 0, 86),
  [2653] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_seh_finally_clause, 2, 0, 9),
  [2655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_seh_finally_clause, 2, 0, 9),
  [2657] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, 0, 147),
  [2659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 147),
  [2661] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 2, 0, 0),
  [2663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 2, 0, 0),
  [2665] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 5, 0, 148),
  [2667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 5, 0, 148),
  [2669] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 5, 0, 152),
  [2671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 5, 0, 152),
  [2673] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_range_loop, 5, 0, 153),
  [2675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_range_loop, 5, 0, 153),
  [2677] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2, 0, 0),
  [2679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2, 0, 0),
  [2681] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 5, 0, 169),
  [2683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 5, 0, 169),
  [2685] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2, 0, 0),
  [2687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2, 0, 0),
  [2689] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 6, 0, 132),
  [2691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 6, 0, 132),
  [2693] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, 0, 52),
  [2695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 3, 0, 52),
  [2697] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 2, 0, 0),
  [2699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 2, 0, 0),
  [2701] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_co_return_statement, 2, 0, 0),
  [2703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_co_return_statement, 2, 0, 0),
  [2705] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3, 0, 0),
  [2707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3, 0, 0),
  [2709] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributed_statement, 2, 0, 0),
  [2711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributed_statement, 2, 0, 0),
  [2713] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_goto_statement, 3, 0, 53),
  [2715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_goto_statement, 3, 0, 53),
  [2717] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_seh_leave_statement, 2, 0, 0),
  [2719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_seh_leave_statement, 2, 0, 0),
  [2721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 2, 0, 0),
  [2723] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2, 0, 0),
  [2725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2, 0, 0),
  [2727] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 3, 0, 10),
  [2729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 3, 0, 10),
  [2731] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alias_declaration, 5, 0, 164),
  [2733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias_declaration, 5, 0, 164),
  [2735] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_assert_declaration, 5, 0, 165),
  [2737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_assert_declaration, 5, 0, 165),
  [2739] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concept_definition, 5, 0, 10),
  [2741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concept_definition, 5, 0, 10),
  [2743] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 3, 0, 48),
  [2745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 3, 0, 48),
  [2747] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 5, 0, 171),
  [2749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 5, 0, 171),
  [2751] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_declaration, 3, 0, 0),
  [2753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_declaration, 3, 0, 0),
  [2755] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 6, 0, 177),
  [2757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 6, 0, 177),
  [2759] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_include, 3, 0, 37),
  [2761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_include, 3, 0, 37),
  [2763] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alias_declaration, 6, 0, 196),
  [2765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias_declaration, 6, 0, 196),
  [2767] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_assert_declaration, 7, 0, 207),
  [2769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_assert_declaration, 7, 0, 207),
  [2771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_def, 3, 0, 10),
  [2773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_def, 3, 0, 10),
  [2775] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_init_statement, 1, 0, 0), SHIFT(2056),
  [2778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [2780] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_init_statement, 1, 0, 0), SHIFT(1390),
  [2783] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_init_statement, 1, 0, 0),
  [2785] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_init_statement, 1, 0, 0), SHIFT(6433),
  [2788] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_init_statement, 1, 0, 0),
  [2790] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_init_statement, 1, 0, 0), SHIFT(6875),
  [2793] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_init_statement, 1, 0, 0), SHIFT(7944),
  [2796] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_init_statement, 1, 0, 0), SHIFT(7577),
  [2799] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 3, 0, 67),
  [2801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 3, 0, 67),
  [2803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7563),
  [2805] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_friend_declaration, 2, 0, 0),
  [2807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_friend_declaration, 2, 0, 0),
  [2809] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_declaration, 2, 0, 26),
  [2811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_declaration, 2, 0, 26),
  [2813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7615),
  [2815] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7563),
  [2818] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_friend_declaration, 3, 0, 0),
  [2820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_friend_declaration, 3, 0, 0),
  [2822] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_declaration, 3, 0, 5),
  [2824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_declaration, 3, 0, 5),
  [2826] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_friend_declaration, 4, 0, 0),
  [2828] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_friend_declaration, 4, 0, 0),
  [2830] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_friend_declaration, 5, 0, 0),
  [2832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_friend_declaration, 5, 0, 0),
  [2834] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 3, 0, 69),
  [2836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 3, 0, 69),
  [2838] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 3, 0, 76),
  [2840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 3, 0, 76),
  [2842] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 3, 0, 5),
  [2844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 3, 0, 5),
  [2846] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_cast_declaration, 3, 0, 5),
  [2848] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast_declaration, 3, 0, 5),
  [2850] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_cast_definition, 3, 0, 76),
  [2852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast_definition, 3, 0, 76),
  [2854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1541),
  [2856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [2858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1345),
  [2860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1345),
  [2862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1264),
  [2864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(790),
  [2866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6469),
  [2868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4167),
  [2870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4916),
  [2872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6104),
  [2874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5015),
  [2876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5016),
  [2878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5017),
  [2880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [2882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1140),
  [2884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8340),
  [2886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8606),
  [2888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8633),
  [2890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6631),
  [2892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4637),
  [2894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7244),
  [2896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6823),
  [2898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4735),
  [2900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4733),
  [2902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2637),
  [2904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8363),
  [2906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5165),
  [2908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1523),
  [2910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1194),
  [2912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7748),
  [2914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1195),
  [2916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4928),
  [2918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5307),
  [2920] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_def, 4, 0, 77),
  [2922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_def, 4, 0, 77),
  [2924] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_function_def, 4, 0, 78),
  [2926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_function_def, 4, 0, 78),
  [2928] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 4, 0, 79),
  [2930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 4, 0, 79),
  [2932] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 4, 0, 80),
  [2934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 4, 0, 80),
  [2936] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 4, 0, 10),
  [2938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 4, 0, 10),
  [2940] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0), SHIFT(2056),
  [2943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1019),
  [2945] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0), SHIFT(1390),
  [2948] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression_statement, 2, 0, 0), SHIFT(6433),
  [2951] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0), SHIFT(6875),
  [2954] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0), SHIFT(7944),
  [2957] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0), SHIFT(7577),
  [2960] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_call, 3, 0, 38),
  [2962] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_call, 3, 0, 38),
  [2964] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_linkage_specification, 3, 0, 44),
  [2966] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_linkage_specification, 3, 0, 44),
  [2968] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 4, 0, 93),
  [2970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 4, 0, 93),
  [2972] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 4, 0, 94),
  [2974] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 4, 0, 94),
  [2976] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 4, 0, 95),
  [2978] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 4, 0, 95),
  [2980] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_call, 2, 0, 3),
  [2982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_call, 2, 0, 3),
  [2984] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7721),
  [2987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [2989] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 1, 0, 0), SHIFT(2056),
  [2992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [2994] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 1, 0, 0), SHIFT(1390),
  [2997] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression_statement, 1, 0, 0), SHIFT(6433),
  [3000] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 1, 0, 0), SHIFT(6875),
  [3003] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 1, 0, 0), SHIFT(7944),
  [3006] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression_statement, 1, 0, 0), SHIFT(7577),
  [3009] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_instantiation, 4, 0, 58),
  [3011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_instantiation, 4, 0, 58),
  [3013] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_declaration, 4, 0, 57),
  [3015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_declaration, 4, 0, 57),
  [3017] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7615),
  [3020] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_list, 3, 0, 0),
  [3022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 3, 0, 0),
  [3024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1707),
  [3026] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_declaration, 4, 0, 0),
  [3028] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_declaration, 4, 0, 0),
  [3030] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 4, 0, 112),
  [3032] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 4, 0, 112),
  [3034] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 3, 0, 46),
  [3036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 3, 0, 46),
  [3038] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 2, 0, 9),
  [3040] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 2, 0, 9),
  [3042] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 4, 0, 117),
  [3044] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 4, 0, 117),
  [3046] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_default_method_clause, 3, 0, 0),
  [3048] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_method_clause, 3, 0, 0),
  [3050] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delete_method_clause, 3, 0, 0),
  [3052] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete_method_clause, 3, 0, 0),
  [3054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1500),
  [3056] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pure_virtual_clause, 3, 0, 0),
  [3058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pure_virtual_clause, 3, 0, 0),
  [3060] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_cast_declaration, 4, 0, 122),
  [3062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast_declaration, 4, 0, 122),
  [3064] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 4, 0, 126),
  [3066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 4, 0, 126),
  [3068] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_function_def, 5, 0, 127),
  [3070] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_function_def, 5, 0, 127),
  [3072] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 5, 0, 128),
  [3074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 5, 0, 128),
  [3076] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if, 5, 0, 79),
  [3078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if, 5, 0, 79),
  [3080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2591),
  [3082] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef, 5, 0, 129),
  [3084] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef, 5, 0, 129),
  [3086] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__block_item, 1, 0, 0), REDUCE(sym_statement, 1, 0, 0),
  [3089] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__block_item, 1, 0, 0), REDUCE(sym_statement, 1, 0, 0),
  [3092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1629),
  [3094] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 2, 0, 25),
  [3096] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 2, 0, 25),
  [3098] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_or_destructor_definition, 2, 0, 26),
  [3100] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_or_destructor_definition, 2, 0, 26),
  [3102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1559),
  [3104] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__empty_declaration, 2, 0, 0),
  [3106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__empty_declaration, 2, 0, 0),
  [3108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2500),
  [3110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1546),
  [3112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6329),
  [3114] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 5, 0, 137),
  [3116] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 5, 0, 137),
  [3118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3495),
  [3120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1639),
  [3122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2214),
  [3124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2729),
  [3126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2676),
  [3128] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 5, 0, 138),
  [3130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 5, 0, 138),
  [3132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4287),
  [3134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3520),
  [3136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7721),
  [3138] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_instantiation, 3, 0, 5),
  [3140] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_instantiation, 3, 0, 5),
  [3142] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_declaration, 3, 0, 57),
  [3144] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_declaration, 3, 0, 57),
  [3146] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_cast_declaration, 2, 0, 26),
  [3148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast_declaration, 2, 0, 26),
  [3150] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_cast_definition, 2, 0, 25),
  [3152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast_definition, 2, 0, 25),
  [3154] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_list, 2, 0, 0),
  [3156] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 2, 0, 0),
  [3158] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_definition, 3, 0, 60),
  [3160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_definition, 3, 0, 60),
  [3162] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_alias_definition, 5, 0, 162),
  [3164] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_alias_definition, 5, 0, 162),
  [3166] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_alias_definition, 5, 0, 163),
  [3168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_alias_definition, 5, 0, 163),
  [3170] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_cast_declaration, 5, 0, 176),
  [3172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast_declaration, 5, 0, 176),
  [3174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3844),
  [3176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7961),
  [3178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5610),
  [3180] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elifdef_in_field_declaration_list, 2, 0, 10),
  [3182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8418),
  [3184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(769),
  [3186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5553),
  [3188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7913),
  [3190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7591),
  [3192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4747),
  [3194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7793),
  [3196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2887),
  [3198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5212),
  [3200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [3202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3057),
  [3204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3735),
  [3206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5383),
  [3208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8188),
  [3210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3036),
  [3212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2650),
  [3214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6117),
  [3216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5012),
  [3218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5013),
  [3220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5014),
  [3222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5163),
  [3224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6952),
  [3226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1582),
  [3228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7867),
  [3230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6330),
  [3232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8567),
  [3234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2054),
  [3236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [3238] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 3, 0, 79),
  [3240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [3242] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elifdef_in_field_declaration_list, 3, 0, 10),
  [3244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [3246] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 4, 0, 79),
  [3248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3730),
  [3250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1742),
  [3252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [3254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1977),
  [3256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [3258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2046),
  [3260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [3262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2040),
  [3264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(833),
  [3266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3998),
  [3268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4000),
  [3270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4266),
  [3272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7761),
  [3274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2071),
  [3276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [3278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2073),
  [3280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2083),
  [3282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1981),
  [3284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1790),
  [3286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [3288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1792),
  [3290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1785),
  [3292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3732),
  [3294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2114),
  [3296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [3298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1305),
  [3300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(831),
  [3302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1306),
  [3304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2002),
  [3306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(194),
  [3308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1542),
  [3310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(791),
  [3312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5101),
  [3314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(164),
  [3316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(172),
  [3318] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(2141),
  [3321] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1196),
  [3324] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(6470),
  [3327] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(6968),
  [3330] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3844),
  [3333] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7961),
  [3336] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5610),
  [3339] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0),
  [3341] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8418),
  [3344] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7591),
  [3347] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4747),
  [3350] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7793),
  [3353] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2887),
  [3356] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5212),
  [3359] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5212),
  [3362] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(598),
  [3365] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3057),
  [3368] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3735),
  [3371] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3077),
  [3374] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3106),
  [3377] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8107),
  [3380] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5383),
  [3383] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7549),
  [3386] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7965),
  [3389] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7438),
  [3392] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2269),
  [3395] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8188),
  [3398] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1619),
  [3401] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3036),
  [3404] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8179),
  [3407] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2650),
  [3410] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6117),
  [3413] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5012),
  [3416] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5013),
  [3419] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5014),
  [3422] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2423),
  [3425] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8206),
  [3428] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4162),
  [3431] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5163),
  [3434] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6952),
  [3437] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(789),
  [3440] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1582),
  [3443] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7867),
  [3446] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6330),
  [3449] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8567),
  [3452] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__top_level_item, 1, 0, 0), REDUCE(sym__top_level_statement, 1, 0, 0),
  [3455] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__top_level_item, 1, 0, 0), REDUCE(sym__top_level_statement, 1, 0, 0),
  [3458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1382),
  [3460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1382),
  [3462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1311),
  [3464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6445),
  [3466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [3468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1070),
  [3470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4127),
  [3472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7281),
  [3474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6963),
  [3476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1307),
  [3478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7742),
  [3480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1308),
  [3482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4963),
  [3484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5305),
  [3486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__top_level_expression_statement, 2, 0, 0),
  [3488] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__top_level_expression_statement, 2, 0, 0),
  [3490] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__top_level_expression_statement, 1, 0, 0),
  [3492] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__top_level_expression_statement, 1, 0, 0),
  [3494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1979),
  [3496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1379),
  [3498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [3500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1265),
  [3502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6442),
  [3504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1064),
  [3506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4345),
  [3508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7278),
  [3510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6877),
  [3512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1258),
  [3514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7755),
  [3516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1261),
  [3518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7810),
  [3520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5631),
  [3522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8410),
  [3524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7473),
  [3526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [3528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2973),
  [3530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3726),
  [3532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1822),
  [3534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3051),
  [3536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6953),
  [3538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1589),
  [3540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6401),
  [3542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8550),
  [3544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8012),
  [3546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5656),
  [3548] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else_in_field_declaration_list, 2, 0, 0),
  [3550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8495),
  [3552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7691),
  [3554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [3556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3026),
  [3558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3737),
  [3560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3045),
  [3562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6966),
  [3564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1587),
  [3566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6338),
  [3568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8574),
  [3570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [3572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1819),
  [3574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2460),
  [3576] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8012),
  [3579] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5656),
  [3582] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8495),
  [3585] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7691),
  [3588] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(763),
  [3591] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3026),
  [3594] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3737),
  [3597] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3045),
  [3600] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6966),
  [3603] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1587),
  [3606] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6338),
  [3609] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8574),
  [3612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2234),
  [3614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [3616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2821),
  [3618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [3620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2429),
  [3622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2818),
  [3624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [3626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2199),
  [3628] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_else_in_field_declaration_list, 1, 0, 0),
  [3630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [3632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [3634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2656),
  [3636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2613),
  [3638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [3640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3107),
  [3642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3950),
  [3644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3083),
  [3646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [3648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4628),
  [3650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4662),
  [3652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [3654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2892),
  [3656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2910),
  [3658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [3660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4860),
  [3662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4882),
  [3664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [3666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3956),
  [3668] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7810),
  [3671] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5631),
  [3674] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8410),
  [3677] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7473),
  [3680] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(782),
  [3683] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2973),
  [3686] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3726),
  [3689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0),
  [3691] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3051),
  [3694] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6953),
  [3697] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1589),
  [3700] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6401),
  [3703] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_field_declaration_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8550),
  [3706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2056),
  [3708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2237),
  [3710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1444),
  [3712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1444),
  [3714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1396),
  [3716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6475),
  [3718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1125),
  [3720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1446),
  [3722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1447),
  [3724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4958),
  [3726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2165),
  [3728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1287),
  [3730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [3732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6868),
  [3734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2259),
  [3736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1491),
  [3738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1491),
  [3740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1477),
  [3742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6461),
  [3744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1151),
  [3746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1493),
  [3748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1494),
  [3750] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_pack_expansion, 2, 0, 28),
  [3752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [3754] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_pack_expansion, 2, 0, 28),
  [3756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1492),
  [3758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3387),
  [3760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3241),
  [3762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3241),
  [3764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1978),
  [3766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6476),
  [3768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2667),
  [3770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3038),
  [3772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6187),
  [3774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4996),
  [3776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4997),
  [3778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4998),
  [3780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5107),
  [3782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3143),
  [3784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7856),
  [3786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5814),
  [3788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5814),
  [3790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5709),
  [3792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8072),
  [3794] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(2165),
  [3797] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1287),
  [3800] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(6469),
  [3803] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(6868),
  [3806] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(2134),
  [3809] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1168),
  [3812] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(6434),
  [3815] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(6928),
  [3818] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_declaration, 3, 0, 0),
  [3820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_declaration, 3, 0, 0),
  [3822] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_declaration, 4, 0, 0),
  [3824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_declaration, 4, 0, 0),
  [3826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2803),
  [3828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5360),
  [3830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3041),
  [3832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6961),
  [3834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1585),
  [3836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8571),
  [3838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5359),
  [3840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3019),
  [3842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6898),
  [3844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1603),
  [3846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8543),
  [3848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8577),
  [3850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8568),
  [3852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3001),
  [3854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6911),
  [3856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1581),
  [3858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8157),
  [3860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8580),
  [3862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8575),
  [3864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3027),
  [3866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6940),
  [3868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1609),
  [3870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8554),
  [3872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8563),
  [3874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8560),
  [3876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1086),
  [3878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(838),
  [3880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1662),
  [3882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3415),
  [3884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1832),
  [3886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8360),
  [3888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1127),
  [3890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(812),
  [3892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5927),
  [3894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1150),
  [3896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3309),
  [3898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1057),
  [3900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(815),
  [3902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5698),
  [3904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [3906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6277),
  [3908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [3910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5916),
  [3912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [3914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(808),
  [3916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6309),
  [3918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1144),
  [3920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6001),
  [3922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1158),
  [3924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(822),
  [3926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5990),
  [3928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [3930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5775),
  [3932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1112),
  [3934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(810),
  [3936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5987),
  [3938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1142),
  [3940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2224),
  [3942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [3944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(829),
  [3946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5776),
  [3948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1062),
  [3950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(818),
  [3952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2189),
  [3954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [3956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(804),
  [3958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3367),
  [3960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1091),
  [3962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6007),
  [3964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1113),
  [3966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(826),
  [3968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5922),
  [3970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1134),
  [3972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5972),
  [3974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2157),
  [3976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [3978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(806),
  [3980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3183),
  [3982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [3984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5759),
  [3986] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__declaration_modifiers, 1, 0, 0), REDUCE(aux_sym_attributed_declarator_repeat1, 1, 0, 0),
  [3989] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declaration_modifiers, 1, 0, 0), REDUCE(aux_sym_attributed_declarator_repeat1, 1, 0, 0),
  [3992] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 1, 0, 0),
  [3994] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 1, 0, 0),
  [3996] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_modifiers, 1, 0, 0),
  [3998] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_modifiers, 1, 0, 0),
  [4000] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1636),
  [4003] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(141),
  [4006] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1304),
  [4009] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1232),
  [4012] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(6450),
  [4015] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(5650),
  [4018] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7598),
  [4021] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(158),
  [4024] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1249),
  [4027] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1231),
  [4030] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1231),
  [4033] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_specifier, 1, 0, 1),
  [4035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0),
  [4037] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__declarator, 1, 0, 0), REDUCE(sym_type_specifier, 1, 0, 1), REDUCE(sym_expression, 1, 0, 0),
  [4041] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 1),
  [4043] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0),
  [4045] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_specifier, 1, 0, 1), REDUCE(sym_expression, 1, 0, 0),
  [4048] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 1), REDUCE(sym_expression, 1, 0, 0),
  [4051] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(315),
  [4054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6545),
  [4056] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declarator, 1, 0, 0), REDUCE(sym_type_specifier, 1, 0, 1),
  [4059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_name, 1, 0, 1),
  [4061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2551),
  [4063] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__declarator, 1, 0, 0), REDUCE(sym_type_specifier, 1, 0, 1), REDUCE(sym_expression, 1, 0, 0),
  [4067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1009),
  [4069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(102),
  [4071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1009),
  [4073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7598),
  [4075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(104),
  [4077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(107),
  [4079] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(2259),
  [4082] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(157),
  [4085] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1491),
  [4088] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1491),
  [4091] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1477),
  [4094] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(6461),
  [4097] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1492),
  [4100] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1151),
  [4103] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(8020),
  [4106] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(8277),
  [4109] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(8491),
  [4112] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(6644),
  [4115] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(4168),
  [4118] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(7107),
  [4121] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(6931),
  [4124] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(3840),
  [4127] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(3839),
  [4130] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1493),
  [4133] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(7634),
  [4136] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(1494),
  [4139] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(4958),
  [4142] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_qualifier, 1, 0, 0), SHIFT(5292),
  [4145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(108),
  [4147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [4149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(111),
  [4151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(203),
  [4153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3091),
  [4155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4203),
  [4157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [4159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2272),
  [4161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4524),
  [4163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4524),
  [4165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5606),
  [4167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(827),
  [4169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2715),
  [4171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [4173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5801),
  [4175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6436),
  [4177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3627),
  [4179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1964),
  [4181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8257),
  [4183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3325),
  [4185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [4187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8539),
  [4189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3816),
  [4191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(106),
  [4193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4209),
  [4195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3807),
  [4197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3572),
  [4199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4170),
  [4201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3674),
  [4203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3396),
  [4205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1596),
  [4207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8405),
  [4209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4736),
  [4211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2395),
  [4213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1600),
  [4215] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(347),
  [4218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1043),
  [4220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6866),
  [4222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7753),
  [4224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3679),
  [4226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8045),
  [4228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2483),
  [4230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3351),
  [4232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5441),
  [4234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3791),
  [4236] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(2056),
  [4239] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(159),
  [4242] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(1183),
  [4245] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(1183),
  [4248] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(1365),
  [4251] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(2715),
  [4254] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(1390),
  [4257] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(6433),
  [4260] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(1280),
  [4263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0),
  [4265] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(5650),
  [4268] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(6875),
  [4271] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(1247),
  [4274] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(1116),
  [4277] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(8020),
  [4280] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(8277),
  [4283] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(8491),
  [4286] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(6644),
  [4289] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(4168),
  [4292] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(7107),
  [4295] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(6931),
  [4298] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(3840),
  [4301] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(3839),
  [4304] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(7944),
  [4307] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(6436),
  [4310] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(7577),
  [4313] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(1184),
  [4316] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(7634),
  [4319] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(1186),
  [4322] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(4983),
  [4325] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_requirement_seq_repeat1, 2, 0, 0), SHIFT_REPEAT(5292),
  [4328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8145),
  [4330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3595),
  [4332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5440),
  [4334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3170),
  [4336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3210),
  [4338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2374),
  [4340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5834),
  [4342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(105),
  [4344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3835),
  [4346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3493),
  [4348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2417),
  [4350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3647),
  [4352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3777),
  [4354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3438),
  [4356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4772),
  [4358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2451),
  [4360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3702),
  [4362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3512),
  [4364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4744),
  [4366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2205),
  [4368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8602),
  [4370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1387),
  [4372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [4374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6598),
  [4376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7609),
  [4378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4794),
  [4380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2135),
  [4382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [4384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [4386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3588),
  [4388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [4390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1310),
  [4392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7819),
  [4394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [4396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1124),
  [4398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7906),
  [4400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4777),
  [4402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3841),
  [4404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [4406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [4408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3489),
  [4410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [4412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2723),
  [4414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4116),
  [4416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2475),
  [4418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2200),
  [4420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8292),
  [4422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_default_capture, 1, 0, 0),
  [4424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [4426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8195),
  [4428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1083),
  [4430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8197),
  [4432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8614),
  [4434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1137),
  [4436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8627),
  [4438] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8115),
  [4441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_capture_specifier, 2, 0, 0),
  [4443] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_capture_specifier, 2, 0, 0),
  [4445] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8217),
  [4448] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8175),
  [4451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2476),
  [4453] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8231),
  [4456] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8252),
  [4459] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8232),
  [4462] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8289),
  [4465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3605),
  [4467] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8215),
  [4470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1811),
  [4472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1383),
  [4474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3358),
  [4476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1445),
  [4478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1378),
  [4480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1386),
  [4482] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8290),
  [4485] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8301),
  [4488] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8248),
  [4491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1389),
  [4493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1452),
  [4495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 4, 1, 189),
  [4497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [4499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1459),
  [4501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1244),
  [4503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [4505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1349),
  [4507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1302),
  [4509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [4511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, 1, 106),
  [4513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1187),
  [4515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1213),
  [4517] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, 1, 79),
  [4519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, 1, 151),
  [4521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [4523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1227),
  [4525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1240),
  [4527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1499),
  [4529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1350),
  [4531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [4533] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8155),
  [4536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1328),
  [4538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 2, 1, 0),
  [4540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 2, 1, 106),
  [4542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1412),
  [4544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1313),
  [4546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [4548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1475),
  [4550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1489),
  [4552] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(7987),
  [4555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5774),
  [4557] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8456),
  [4560] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(7884),
  [4563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [4565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2223),
  [4567] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8487),
  [4570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8177),
  [4572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [4574] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8451),
  [4577] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8478),
  [4580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3411),
  [4582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [4584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [4586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6299),
  [4588] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8228),
  [4591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8321),
  [4593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [4595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6300),
  [4597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [4599] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8260),
  [4602] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(7980),
  [4605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [4607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7939),
  [4609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1717),
  [4611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5619),
  [4613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7894),
  [4615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3420),
  [4617] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(7873),
  [4620] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8349),
  [4623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [4625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5921),
  [4627] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8302),
  [4630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8367),
  [4632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [4634] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8355),
  [4637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8172),
  [4639] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8316),
  [4642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5757),
  [4644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5758),
  [4646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8386),
  [4648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [4650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [4652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8541),
  [4654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8136),
  [4656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [4658] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8022),
  [4661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7768),
  [4663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [4665] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8460),
  [4668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8178),
  [4670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5913),
  [4672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5971),
  [4674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8545),
  [4676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3308),
  [4678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [4680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8132),
  [4682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8274),
  [4684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8594),
  [4686] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8576),
  [4689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1990),
  [4691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [4693] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(7765),
  [4696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5986),
  [4698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [4700] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(7822),
  [4703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [4705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [4707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5973),
  [4709] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8198),
  [4712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1923),
  [4714] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8218),
  [4717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [4719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8347),
  [4721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [4723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [4725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2163),
  [4727] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8081),
  [4730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6005),
  [4732] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8249),
  [4735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5778),
  [4737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3192),
  [4739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [4741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [4743] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8251),
  [4746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6006),
  [4748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5988),
  [4750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5533),
  [4752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5685),
  [4754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5571),
  [4756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5627),
  [4758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5621),
  [4760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5641),
  [4762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5579),
  [4764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5648),
  [4766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5695),
  [4768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5580),
  [4770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5574),
  [4772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5692),
  [4774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5555),
  [4776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2112),
  [4778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5618),
  [4780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2039),
  [4782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5665),
  [4784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5613),
  [4786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5681),
  [4788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1947),
  [4790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5636),
  [4792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5642),
  [4794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5547),
  [4796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3602),
  [4798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5608),
  [4800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5607),
  [4802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5672),
  [4804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5673),
  [4806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5688),
  [4808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5687),
  [4810] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 2, 0, 0),
  [4812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 2, 0, 0),
  [4814] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 4, 1, 0),
  [4816] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 4, 1, 0),
  [4818] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 3, 3, 0),
  [4820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 3, 3, 0),
  [4822] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 3, 2, 0),
  [4824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 3, 2, 0),
  [4826] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 3, 1, 0),
  [4828] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 3, 1, 0),
  [4830] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 4, 3, 0),
  [4832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 4, 3, 0),
  [4834] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_argument_list, 4, 2, 0),
  [4836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument_list, 4, 2, 0),
  [4838] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 35),
  [4840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_identifier, 2, 0, 34),
  [4842] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_qualified_identifier, 2, 0, 34), REDUCE(sym_qualified_type_identifier, 2, 0, 35),
  [4845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_type_identifier, 2, 0, 35),
  [4847] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 34),
  [4849] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 34), REDUCE(sym_qualified_type_identifier, 2, 0, 35),
  [4852] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 34), SHIFT(331),
  [4855] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_type, 2, 0, 16),
  [4857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_function, 2, 0, 17),
  [4859] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_template_type, 2, 0, 16), REDUCE(sym_template_function, 2, 0, 17),
  [4862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_type, 2, 0, 16),
  [4864] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_function, 2, 0, 17),
  [4866] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_template_type, 2, 0, 16), REDUCE(sym_template_function, 2, 0, 17),
  [4869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2958),
  [4871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1510),
  [4873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4141),
  [4875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5969),
  [4877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5969),
  [4879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6511),
  [4881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(805),
  [4883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3582),
  [4885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1622),
  [4887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5624),
  [4889] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 34), SHIFT(301),
  [4892] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(301),
  [4895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declarator, 1, 0, 0),
  [4897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1896),
  [4899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6997),
  [4901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7744),
  [4903] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(341),
  [4906] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0),
  [4908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0),
  [4910] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(1552),
  [4913] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(8414),
  [4916] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(346),
  [4919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2267),
  [4921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1051),
  [4923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [4925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6863),
  [4927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7752),
  [4929] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(321),
  [4932] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0),
  [4934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0),
  [4936] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(1544),
  [4939] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alignas_qualifier, 4, 0, 0),
  [4941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alignas_qualifier, 4, 0, 0),
  [4943] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(2173),
  [4946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 1, 0, 0),
  [4948] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0),
  [4950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1552),
  [4952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1567),
  [4954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8414),
  [4956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2171),
  [4958] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(2177),
  [4961] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, 0, 0),
  [4963] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0),
  [4965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2178),
  [4967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2176),
  [4969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2317),
  [4971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1566),
  [4973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2316),
  [4975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2277),
  [4977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2278),
  [4979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2276),
  [4981] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0),
  [4984] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0),
  [4987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2509),
  [4989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1614),
  [4991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2510),
  [4993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8399),
  [4995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2508),
  [4997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2522),
  [4999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1579),
  [5001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2520),
  [5003] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(1614),
  [5006] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(8399),
  [5009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2584),
  [5011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1624),
  [5013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2585),
  [5015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8434),
  [5017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2581),
  [5019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2577),
  [5021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1615),
  [5023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2573),
  [5025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2816),
  [5027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6493),
  [5029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [5031] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(1624),
  [5034] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(8434),
  [5037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [5039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [5041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [5043] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(1608),
  [5046] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(1619),
  [5049] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(8179),
  [5052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2817),
  [5054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5045),
  [5056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5046),
  [5058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5047),
  [5060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5070),
  [5062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5071),
  [5064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5072),
  [5066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5073),
  [5068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5074),
  [5070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5075),
  [5072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5102),
  [5074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5049),
  [5076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5050),
  [5078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5076),
  [5080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5077),
  [5082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5078),
  [5084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5079),
  [5086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5080),
  [5088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5081),
  [5090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5082),
  [5092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5083),
  [5094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5084),
  [5096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5085),
  [5098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5086),
  [5100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5087),
  [5102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4993),
  [5104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4994),
  [5106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4995),
  [5108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5067),
  [5110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5068),
  [5112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5069),
  [5114] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_requires_expression, 2, 0, 21),
  [5116] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_expression, 2, 0, 21),
  [5118] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 2, 0, 32),
  [5120] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 2, 0, 32),
  [5122] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fold_expression, 3, 0, 40),
  [5124] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fold_expression, 3, 0, 40),
  [5126] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_requirement_seq, 2, 0, 0),
  [5128] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requirement_seq, 2, 0, 0),
  [5130] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_requires_expression, 3, 0, 65),
  [5132] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_expression, 3, 0, 65),
  [5134] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 3, 0, 72),
  [5136] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 3, 0, 72),
  [5138] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 3, 0, 73),
  [5140] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 3, 0, 73),
  [5142] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_requirement_seq, 3, 0, 0),
  [5144] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requirement_seq, 3, 0, 0),
  [5146] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 4, 0, 124),
  [5148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 4, 0, 124),
  [5150] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 4, 0, 125),
  [5152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 4, 0, 125),
  [5154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5055),
  [5156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5056),
  [5158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5057),
  [5160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5058),
  [5162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5059),
  [5164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5060),
  [5166] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 5, 0, 175),
  [5168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 5, 0, 175),
  [5170] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__requirement_clause_constraint, 3, 0, 0),
  [5172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__requirement_clause_constraint, 3, 0, 0),
  [5174] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constraint_conjunction, 3, 0, 54),
  [5176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint_conjunction, 3, 0, 54),
  [5178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5061),
  [5180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5062),
  [5182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5063),
  [5184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2673),
  [5186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1650),
  [5188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1633),
  [5190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8430),
  [5192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2683),
  [5194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2718),
  [5196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2678),
  [5198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2710),
  [5200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5064),
  [5202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5065),
  [5204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5066),
  [5206] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(1618),
  [5209] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(1650),
  [5212] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(8430),
  [5215] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(1651),
  [5218] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(8339),
  [5221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4811),
  [5223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4859),
  [5225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6956),
  [5227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6649),
  [5229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2360),
  [5231] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(1628),
  [5234] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(1638),
  [5237] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(344),
  [5240] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7613),
  [5243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7613),
  [5245] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_condition_clause, 3, 0, 14),
  [5247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition_clause, 3, 0, 14),
  [5249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1648),
  [5251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concatenated_string, 3, 0, 0),
  [5253] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concatenated_string, 3, 0, 0),
  [5255] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(1648),
  [5258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0),
  [5260] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0),
  [5262] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(6810),
  [5265] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7746),
  [5268] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_condition_clause, 4, 0, 146),
  [5270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition_clause, 4, 0, 146),
  [5272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1646),
  [5274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concatenated_string, 2, 0, 0),
  [5276] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concatenated_string, 2, 0, 0),
  [5278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7054),
  [5280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3375),
  [5282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7329),
  [5284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3297),
  [5286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7157),
  [5288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2348),
  [5290] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_array_declarator_repeat1, 2, 0, 0),
  [5292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_declarator_repeat1, 2, 0, 0),
  [5294] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_array_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(1832),
  [5297] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_array_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(1662),
  [5300] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_array_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(8360),
  [5303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7728),
  [5305] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 2, 0, 0),
  [5307] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__field_declaration_list_item, 2, 0, 0),
  [5309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declaration_list_item, 2, 0, 0),
  [5311] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 5, 0, 200),
  [5313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 5, 0, 200),
  [5315] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 6, 0, 177),
  [5317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 6, 0, 177),
  [5319] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 6, 0, 195),
  [5321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 6, 0, 195),
  [5323] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 6, 0, 209),
  [5325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 6, 0, 209),
  [5327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6517),
  [5329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3049),
  [5331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3299),
  [5333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3054),
  [5335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8109),
  [5337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5444),
  [5339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7637),
  [5341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8111),
  [5343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8309),
  [5345] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 6, 0, 199),
  [5347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 6, 0, 199),
  [5349] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 2, 0, 56),
  [5351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 2, 0, 56),
  [5353] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 6, 0, 200),
  [5355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 6, 0, 200),
  [5357] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 4, 0, 181),
  [5359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 4, 0, 181),
  [5361] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 34),
  [5363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_type_identifier, 2, 0, 34),
  [5365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6553),
  [5367] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 7, 0, 209),
  [5369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 7, 0, 209),
  [5371] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decltype, 4, 0, 0),
  [5373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decltype, 4, 0, 0),
  [5375] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 1, 0, 6),
  [5377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 1, 0, 6),
  [5379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8379),
  [5381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [5383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5836),
  [5385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5720),
  [5387] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_raw_string_literal, 5, 0, 0),
  [5389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raw_string_literal, 5, 0, 0),
  [5391] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dependent_type, 2, -1, 0),
  [5393] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dependent_type, 2, -1, 0),
  [5395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1837),
  [5397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8297),
  [5399] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_raw_string_literal, 7, 0, 208),
  [5401] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raw_string_literal, 7, 0, 208),
  [5403] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 4, 0, 182),
  [5405] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 4, 0, 182),
  [5407] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 3, 0, 10),
  [5409] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 3, 0, 10),
  [5411] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, 0, 56),
  [5413] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, 0, 56),
  [5415] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3, 0, 66),
  [5417] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, 0, 66),
  [5419] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_method_definition, 3, 0, 67),
  [5421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_method_definition, 3, 0, 67),
  [5423] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, 0, 128),
  [5425] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, 0, 128),
  [5427] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_method_definition, 3, 0, 66),
  [5429] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_method_definition, 3, 0, 66),
  [5431] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_specifier, 1, 0, 0),
  [5433] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 0),
  [5435] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 4, 0, 66),
  [5437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 4, 0, 66),
  [5439] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 5, 0, 195),
  [5441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 5, 0, 195),
  [5443] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_name, 1, 0, 0),
  [5445] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_name, 1, 0, 0),
  [5447] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 2, 0, 0),
  [5449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 2, 0, 0),
  [5451] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 34), SHIFT(341),
  [5454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 3, 0, 0),
  [5456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 3, 0, 0),
  [5458] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 5, 0, 66),
  [5460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 5, 0, 66),
  [5462] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, 0, 79),
  [5464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 5, 0, 79),
  [5466] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 5, 0, 199),
  [5468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 5, 0, 199),
  [5470] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dependent_type_identifier, 2, 0, 0),
  [5472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dependent_type_identifier, 2, 0, 0),
  [5474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 5, 0, 181),
  [5476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 5, 0, 181),
  [5478] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_field_declaration_list, 4, 0, 79),
  [5480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_field_declaration_list, 4, 0, 79),
  [5482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, 0, 80),
  [5484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, 0, 80),
  [5486] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, 0, 10),
  [5488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 4, 0, 10),
  [5490] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5, 0, 129),
  [5492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_field_declaration_list, 5, 0, 129),
  [5494] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 5, 0, 182),
  [5496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 5, 0, 182),
  [5498] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration, 3, 0, 102),
  [5500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration, 3, 0, 102),
  [5502] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration, 2, 0, 12),
  [5504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration, 2, 0, 12),
  [5506] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_list, 3, 0, 0),
  [5508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_list, 3, 0, 0),
  [5510] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 2, 0, 11),
  [5512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 2, 0, 11),
  [5514] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 2, 0, 6),
  [5516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 2, 0, 6),
  [5518] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(3492),
  [5521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1651),
  [5523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1967),
  [5525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8339),
  [5527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3490),
  [5529] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 46),
  [5531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 46),
  [5533] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 5, 0, 143),
  [5535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 5, 0, 143),
  [5537] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_placeholder_type_specifier, 1, 0, 0),
  [5539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_placeholder_type_specifier, 1, 0, 0),
  [5541] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 47),
  [5543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 47),
  [5545] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__enum_base_clause, 2, 0, 98),
  [5547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__enum_base_clause, 2, 0, 98),
  [5549] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 48),
  [5551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 48),
  [5553] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 49),
  [5555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 49),
  [5557] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(357),
  [5560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1018),
  [5562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1018),
  [5564] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 4, 0, 103),
  [5566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 4, 0, 103),
  [5568] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 4, 0, 46),
  [5570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 4, 0, 46),
  [5572] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration, 4, 0, 144),
  [5574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration, 4, 0, 144),
  [5576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7623),
  [5578] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 3, 0, 0),
  [5580] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 3, 0, 0),
  [5582] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7582),
  [5585] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(3317),
  [5588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3318),
  [5590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3316),
  [5592] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 2, 0, 0),
  [5594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 2, 0, 0),
  [5596] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 3, 0, 50),
  [5598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 3, 0, 50),
  [5600] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_specifier, 2, 0, 12),
  [5602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_specifier, 2, 0, 12),
  [5604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1873),
  [5606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1884),
  [5608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1867),
  [5610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7582),
  [5612] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 34), SHIFT(351),
  [5615] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(7623),
  [5618] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_specifier, 4, 0, 0),
  [5620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_specifier, 4, 0, 0),
  [5622] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_specifier, 2, 0, 12),
  [5624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_specifier, 2, 0, 12),
  [5626] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_placeholder_type_specifier, 2, 0, 27),
  [5628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_placeholder_type_specifier, 2, 0, 27),
  [5630] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_specifier, 2, 0, 12),
  [5632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_specifier, 2, 0, 12),
  [5634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1869),
  [5636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2020),
  [5638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1901),
  [5640] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration, 1, 0, 13),
  [5642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration, 1, 0, 13),
  [5644] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_list, 4, 0, 0),
  [5646] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_list, 4, 0, 0),
  [5648] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decltype_auto, 4, 0, 0),
  [5650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decltype_auto, 4, 0, 0),
  [5652] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 6, 0, 142),
  [5654] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 6, 0, 142),
  [5656] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator_list, 2, 0, 0),
  [5658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator_list, 2, 0, 0),
  [5660] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 5, 0, 95),
  [5662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 5, 0, 95),
  [5664] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 5, 0, 97),
  [5666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 5, 0, 97),
  [5668] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, 0, 9),
  [5670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, 0, 9),
  [5672] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 5, 0, 100),
  [5674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 5, 0, 100),
  [5676] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, 0, 10),
  [5678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, 0, 10),
  [5680] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 3, 0, 9),
  [5682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 3, 0, 9),
  [5684] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, 0, 45),
  [5686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, 0, 45),
  [5688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [5690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1420),
  [5692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2183),
  [5694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7849),
  [5696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5760),
  [5698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 2, 1, 0),
  [5700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1863),
  [5702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4084),
  [5704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4084),
  [5706] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_pointer_declarator, 2, 1, 0),
  [5708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5765),
  [5710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [5712] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, 0, 91),
  [5714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, 0, 91),
  [5716] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 2, 0, 20),
  [5718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 2, 0, 20),
  [5720] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_name, 1, 0, 1),
  [5722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(344),
  [5724] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 35), SHIFT(344),
  [5727] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 2, 0, 34), SHIFT(344),
  [5730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 1, 1, 0),
  [5732] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_pointer_declarator, 1, 1, 0),
  [5734] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, 0, 63),
  [5736] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, 0, 63),
  [5738] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 3, 0, 45),
  [5740] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, 0, 45),
  [5742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1870),
  [5744] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, -1, 36),
  [5746] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, -1, 36),
  [5748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1887),
  [5750] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 4, 0, 45),
  [5752] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 4, 0, 45),
  [5754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1628),
  [5756] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 4, -1, 75),
  [5758] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 4, -1, 75),
  [5760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 3, -1, 75),
  [5762] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, -1, 75),
  [5764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1872),
  [5766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, 0, 2),
  [5768] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 2),
  [5770] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(2209),
  [5773] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(8423),
  [5776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 3, 0, 0),
  [5778] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, 0, 0),
  [5780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 3, -1, 36),
  [5782] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, -1, 36),
  [5784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1880),
  [5786] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(1894),
  [5789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, -1, 18),
  [5791] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, -1, 18),
  [5793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 3, 0, 20),
  [5795] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, 0, 20),
  [5797] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string, 1, 0, 0),
  [5799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string, 1, 0, 0),
  [5801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sized_type_specifier, 2, 0, 20),
  [5803] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 20),
  [5805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1897),
  [5807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1915),
  [5809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4175),
  [5811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4175),
  [5813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_destructor_name, 2, 0, 0),
  [5815] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_destructor_name, 2, 0, 0),
  [5817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1953),
  [5819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6887),
  [5821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7758),
  [5823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1956),
  [5825] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(1956),
  [5828] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(6887),
  [5831] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7758),
  [5834] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, 0, 49),
  [5836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, 0, 49),
  [5838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6253),
  [5840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1055),
  [5842] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__enum_base_clause, 2, 0, 99),
  [5844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__enum_base_clause, 2, 0, 99),
  [5846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2169),
  [5848] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 97),
  [5850] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 97),
  [5852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3242),
  [5854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1039),
  [5856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [5858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6884),
  [5860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7757),
  [5862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1997),
  [5864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4184),
  [5866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4184),
  [5868] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declarator, 1, 0, 0), REDUCE(sym_expression, 1, 0, 0),
  [5871] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__declarator, 1, 0, 0), REDUCE(sym_expression, 1, 0, 0),
  [5874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8338),
  [5876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8338),
  [5878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [5880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5720),
  [5882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [5884] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(331),
  [5887] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 4, 0, 143),
  [5889] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 4, 0, 143),
  [5891] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type_declarator, 5, 1, 170),
  [5893] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 5, 1, 170),
  [5895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1661),
  [5897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7592),
  [5899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(820),
  [5901] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 2, 0, 9),
  [5903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 2, 0, 9),
  [5905] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, 0, 48),
  [5907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, 0, 48),
  [5909] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type_declarator, 3, 1, 41),
  [5911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 3, 1, 41),
  [5913] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 2, 0, 50),
  [5915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 2, 0, 50),
  [5917] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 2, 0, 9),
  [5919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 2, 0, 9),
  [5921] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type_declarator, 2, 1, 5),
  [5923] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 2, 1, 5),
  [5925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2140),
  [5927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2305),
  [5929] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(7443),
  [5932] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__lambda_capture_identifier, 1, 0, 0), SHIFT(7979),
  [5935] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym__lambda_capture_identifier, 1, 0, 0), SHIFT(6009),
  [5939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1046),
  [5941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1053),
  [5943] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type_declarator, 4, 1, 85),
  [5945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type_declarator, 4, 1, 85),
  [5947] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, 0, 46),
  [5949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, 0, 46),
  [5951] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 5, 0, 142),
  [5953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 5, 0, 142),
  [5955] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(2140),
  [5958] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(6997),
  [5961] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7744),
  [5964] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(353),
  [5967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [5969] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 1, 0, 11),
  [5971] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 1, 0, 11),
  [5973] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(2146),
  [5976] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 95),
  [5978] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 95),
  [5980] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 4, 0, 100),
  [5982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 4, 0, 100),
  [5984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2129),
  [5986] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 3, 0, 103),
  [5988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 3, 0, 103),
  [5990] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__class_declaration_item, 3, 0, 46),
  [5992] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_declaration_item, 3, 0, 46),
  [5994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2314),
  [5996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2209),
  [5998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2339),
  [6000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8423),
  [6002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2312),
  [6004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2297),
  [6006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2301),
  [6008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2287),
  [6010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7979),
  [6012] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(6009),
  [6015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1053),
  [6017] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_reference_type_declarator, 2, 1, 0),
  [6019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_type_declarator, 2, 1, 0),
  [6021] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type_declarator, 5, 0, 172),
  [6023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 5, 0, 172),
  [6025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2249),
  [6027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2174),
  [6029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2175),
  [6031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2184),
  [6033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2185),
  [6035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2166),
  [6037] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_type_declarator, 3, -10, 0),
  [6039] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_type_declarator, 3, -10, 0),
  [6041] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_declarator, 1, 0, 0),
  [6043] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_declarator, 1, 0, 0),
  [6045] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type_declarator, 2, 0, 87),
  [6047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type_declarator, 2, 0, 87),
  [6049] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type_declarator, 3, 0, 26),
  [6051] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 3, 0, 26),
  [6053] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, 0, 111),
  [6055] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, 0, 111),
  [6057] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constraint_disjunction, 3, 0, 54),
  [6059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint_disjunction, 3, 0, 54),
  [6061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5346),
  [6063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5346),
  [6065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6265),
  [6067] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0),
  [6069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0),
  [6071] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(7592),
  [6074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__lambda_capture_identifier, 2, 0, 0),
  [6076] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym__lambda_capture_identifier, 2, 0, 0),
  [6079] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 5, 0, 135),
  [6081] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 5, 0, 135),
  [6083] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__lambda_capture_identifier, 1, 0, 0),
  [6085] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym__lambda_capture_identifier, 1, 0, 0),
  [6088] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, 0, 90),
  [6090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, 0, 90),
  [6092] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_requires_clause, 2, 0, 22),
  [6094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_clause, 2, 0, 22),
  [6096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5345),
  [6098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5345),
  [6100] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_type_declarator, 4, -10, 0),
  [6102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_type_declarator, 4, -10, 0),
  [6104] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type_declarator, 4, 0, 118),
  [6106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 4, 0, 118),
  [6108] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type_declarator, 4, 0, 26),
  [6110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type_declarator, 4, 0, 26),
  [6112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1032),
  [6114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [6116] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_declarator, 1, 0, 42),
  [6118] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_declarator, 1, 0, 42),
  [6120] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(2240),
  [6123] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(6871),
  [6126] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7754),
  [6129] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0), SHIFT(351),
  [6132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6871),
  [6134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7754),
  [6136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2257),
  [6138] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(2249),
  [6141] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_declarator, 1, 0, 1),
  [6143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_declarator, 1, 0, 1),
  [6145] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, 0, 62),
  [6147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, 0, 62),
  [6149] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributed_type_declarator, 2, 0, 0),
  [6151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributed_type_declarator, 2, 0, 0),
  [6153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2240),
  [6155] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_declarator, 1, 0, 43),
  [6157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_declarator, 1, 0, 43),
  [6159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2146),
  [6161] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 3, 0, 47),
  [6163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 3, 0, 47),
  [6165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5945),
  [6167] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(2576),
  [6170] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(1619),
  [6173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2526),
  [6175] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(8179),
  [6178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2575),
  [6180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5712),
  [6182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1544),
  [6184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2291),
  [6186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2292),
  [6188] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_method, 2, 0, 119),
  [6190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_method, 2, 0, 119),
  [6192] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_declarator, 3, 0, 166),
  [6194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_declarator, 3, 0, 166),
  [6196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2303),
  [6198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2282),
  [6200] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_field_identifier, 2, 1, 120),
  [6202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_field_identifier, 2, 1, 120),
  [6204] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_field_identifier, 2, 1, 120), SHIFT(344),
  [6207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2289),
  [6209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2306),
  [6211] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_expression, 3, 1, 70),
  [6213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_expression, 3, 1, 70),
  [6215] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_field_expression, 3, 1, 70), SHIFT(344),
  [6218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8398),
  [6220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8398),
  [6222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [6224] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(2556),
  [6227] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(1619),
  [6230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2561),
  [6232] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(8179),
  [6235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2554),
  [6237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2315),
  [6239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2298),
  [6241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2274),
  [6243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2275),
  [6245] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_specifier, 2, 0, 10),
  [6247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_specifier, 2, 0, 10),
  [6249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8359),
  [6251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8359),
  [6253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [6255] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 3, 0, 0),
  [6257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 3, 0, 0),
  [6259] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_method, 2, 0, 17),
  [6261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_method, 2, 0, 17),
  [6263] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 54),
  [6265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 54),
  [6267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [6269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2388),
  [6271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6083),
  [6273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6083),
  [6275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2366),
  [6277] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_co_await_expression, 2, 0, 4),
  [6279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_co_await_expression, 2, 0, 4),
  [6281] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_expression, 4, 0, 84),
  [6283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_expression, 4, 0, 84),
  [6285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2527),
  [6287] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_parameter_list, 3, 0, 0),
  [6289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_parameter_list, 3, 0, 0),
  [6291] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_field_identifier, 2, 0, 34),
  [6293] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_field_identifier, 2, 0, 34),
  [6295] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_declarator, 4, 0, 166),
  [6297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_declarator, 4, 0, 166),
  [6299] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dependent_field_identifier, 2, 0, 0),
  [6301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dependent_field_identifier, 2, 0, 0),
  [6303] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(2340),
  [6306] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(6866),
  [6309] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7753),
  [6312] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [6314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [6316] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_expression, 2, 0, 4),
  [6318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_expression, 2, 0, 4),
  [6320] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, 0, 74),
  [6322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_identifier, 3, 0, 74),
  [6324] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, 0, 74), SHIFT(344),
  [6327] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 4, 0, 0),
  [6329] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 4, 0, 0),
  [6331] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sizeof_expression, 2, 0, 14),
  [6333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sizeof_expression, 2, 0, 14),
  [6335] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_list, 2, 0, 0),
  [6337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 2, 0, 0),
  [6339] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_parameter_list, 4, 0, 0),
  [6341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_parameter_list, 4, 0, 0),
  [6343] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_name, 2, 0, 0),
  [6345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_name, 2, 0, 0),
  [6347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2372),
  [6349] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 4),
  [6351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, 0, 4),
  [6353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2454),
  [6355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8163),
  [6357] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 1, 0, 2),
  [6359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 1, 0, 2),
  [6361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2534),
  [6363] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 4),
  [6365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, 0, 4),
  [6367] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_parameter_list, 2, 0, 0),
  [6369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_parameter_list, 2, 0, 0),
  [6371] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 40),
  [6373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, 0, 40),
  [6375] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 2, 0, 20),
  [6377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 2, 0, 20),
  [6379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2501),
  [6381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2340),
  [6383] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_expression, 3, 0, 71),
  [6385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_expression, 3, 0, 71),
  [6387] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 3, 0, 0),
  [6389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 3, 0, 0),
  [6391] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_literal_expression, 2, 0, 8),
  [6393] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_literal_expression, 2, 0, 8),
  [6395] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_name, 3, 0, 0),
  [6397] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_name, 3, 0, 0),
  [6399] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_user_defined_literal, 2, 0, 0),
  [6401] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_user_defined_literal, 2, 0, 0),
  [6403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8379),
  [6405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5957),
  [6407] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2, 0, 7),
  [6409] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2, 0, 7),
  [6411] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 2, 0, 30),
  [6413] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 2, 0, 30),
  [6415] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_argument_list, 4, 0, 0),
  [6417] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_argument_list, 4, 0, 0),
  [6419] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alignof_expression, 4, 0, 45),
  [6421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alignof_expression, 4, 0, 45),
  [6423] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 4, 0, 107),
  [6425] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 4, 0, 107),
  [6427] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 29),
  [6429] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, 0, 29),
  [6431] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, 0, 109),
  [6433] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, 0, 109),
  [6435] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, 0, 110),
  [6437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, 0, 110),
  [6439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5394),
  [6441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5394),
  [6443] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3, 0, 0),
  [6445] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3, 0, 0),
  [6447] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_null, 1, 0, 0),
  [6449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_null, 1, 0, 0),
  [6451] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 5, 0, 133),
  [6453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 5, 0, 133),
  [6455] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 5, 0, 134),
  [6457] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 5, 0, 134),
  [6459] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 4, 0, 0),
  [6461] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 4, 0, 0),
  [6463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [6465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5393),
  [6467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5393),
  [6469] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 5, 0, 156),
  [6471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 5, 0, 156),
  [6473] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 5, 0, 157),
  [6475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 5, 0, 157),
  [6477] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, 0, 61),
  [6479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, 0, 61),
  [6481] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4, 0, 0),
  [6483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4, 0, 0),
  [6485] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 5, 0, 167),
  [6487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 5, 0, 167),
  [6489] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dependent_identifier, 2, 0, 0),
  [6491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dependent_identifier, 2, 0, 0),
  [6493] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 6, 0, 178),
  [6495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 6, 0, 178),
  [6497] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_list, 5, 0, 0),
  [6499] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_list, 5, 0, 0),
  [6501] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_argument_list, 3, 0, 0),
  [6503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_argument_list, 3, 0, 0),
  [6505] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_offsetof_expression, 6, 0, 190),
  [6507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_offsetof_expression, 6, 0, 190),
  [6509] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 6, 0, 192),
  [6511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 6, 0, 192),
  [6513] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 6, 0, 193),
  [6515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 6, 0, 193),
  [6517] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 7, 0, 205),
  [6519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 7, 0, 205),
  [6521] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 7, 0, 206),
  [6523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 7, 0, 206),
  [6525] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_literal_expression, 4, 0, 84),
  [6527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_literal_expression, 4, 0, 84),
  [6529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8422),
  [6531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8422),
  [6533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [6535] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 2, 0, 0),
  [6537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 2, 0, 0),
  [6539] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_argument_list, 2, 0, 0),
  [6541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_argument_list, 2, 0, 0),
  [6543] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, 0, 54),
  [6545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, 0, 54),
  [6547] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4, 0, 89),
  [6549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4, 0, 89),
  [6551] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_expression, 8, 0, 0),
  [6553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_expression, 8, 0, 0),
  [6555] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 8, 0, 213),
  [6557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 8, 0, 213),
  [6559] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 8, 0, 214),
  [6561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 8, 0, 214),
  [6563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [6565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5836),
  [6567] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_expression, 9, 0, 0),
  [6569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_expression, 9, 0, 0),
  [6571] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gnu_asm_expression, 9, 0, 217),
  [6573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_expression, 9, 0, 217),
  [6575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2603),
  [6577] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sizeof_expression, 5, 0, 154),
  [6579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sizeof_expression, 5, 0, 154),
  [6581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6205),
  [6583] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 35), SHIFT(341),
  [6586] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 3, 0, 20),
  [6588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 3, 0, 20),
  [6590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2511),
  [6592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(341),
  [6594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1608),
  [6596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2528),
  [6598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2531),
  [6600] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0),
  [6602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0),
  [6604] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(3049),
  [6607] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(2511),
  [6610] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(3054),
  [6613] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(8109),
  [6616] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(7637),
  [6619] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(8111),
  [6622] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(8309),
  [6625] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 0), SHIFT(952),
  [6628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2545),
  [6630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2514),
  [6632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 3, 1, 0),
  [6634] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_pointer_declarator, 3, 1, 0),
  [6636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2506),
  [6638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2507),
  [6640] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_specifiers, 2, 0, 2),
  [6642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_specifiers, 2, 0, 2),
  [6644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8413),
  [6646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8413),
  [6648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [6650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2574),
  [6652] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(2547),
  [6655] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(6963),
  [6658] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7742),
  [6661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6247),
  [6663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5960),
  [6665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2595),
  [6667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2599),
  [6669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(351),
  [6671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1618),
  [6673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2598),
  [6675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [6677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2579),
  [6679] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(2574),
  [6682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2548),
  [6684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2550),
  [6686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2580),
  [6688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2589),
  [6690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2590),
  [6692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2568),
  [6694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2721),
  [6696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2653),
  [6698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7930),
  [6700] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 35), SHIFT(351),
  [6703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2547),
  [6705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6262),
  [6707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5908),
  [6709] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_storage_class_specifier, 1, 0, 0),
  [6711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_storage_class_specifier, 1, 0, 0),
  [6713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6921),
  [6715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2976),
  [6717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2987),
  [6719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2974),
  [6721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2953),
  [6723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2811),
  [6725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2943),
  [6727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(353),
  [6729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2694),
  [6731] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_requirement, 2, 0, 0),
  [6733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_requirement, 2, 0, 0),
  [6735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [6737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1638),
  [6739] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__requirement, 1, 0, 64),
  [6741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__requirement, 1, 0, 64),
  [6743] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_requirement, 4, 0, 0),
  [6745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_requirement, 4, 0, 0),
  [6747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2677),
  [6749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [6751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1411),
  [6753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2939),
  [6755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8480),
  [6757] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_requirement, 6, 0, 0),
  [6759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_requirement, 6, 0, 0),
  [6761] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_declspec_modifier, 4, 0, 0),
  [6763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_declspec_modifier, 4, 0, 0),
  [6765] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_requirement, 5, 0, 0),
  [6767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_requirement, 5, 0, 0),
  [6769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1677),
  [6771] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 35), SHIFT(353),
  [6774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [6776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [6778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2705),
  [6780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2018),
  [6782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [6784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2104),
  [6786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2697),
  [6788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2706),
  [6790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [6792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1438),
  [6794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3081),
  [6796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8062),
  [6798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [6800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [6802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6276),
  [6804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1982),
  [6806] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delete_expression, 3, 0, 0),
  [6808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete_expression, 3, 0, 0),
  [6810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1367),
  [6812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1368),
  [6814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1369),
  [6816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1370),
  [6818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1371),
  [6820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1372),
  [6822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1373),
  [6824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1374),
  [6826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1375),
  [6828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1375),
  [6830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1376),
  [6832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1301),
  [6834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1369),
  [6836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1370),
  [6838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1374),
  [6840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2488),
  [6842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [6844] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delete_expression, 4, 0, 0),
  [6846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete_expression, 4, 0, 0),
  [6848] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_expression, 4, 0, 121),
  [6850] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 4, 0, 121),
  [6852] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delete_expression, 5, 0, 0),
  [6854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete_expression, 5, 0, 0),
  [6856] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_expression, 5, 0, 173),
  [6858] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 5, 0, 173),
  [6860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3060),
  [6862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2007),
  [6864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [6866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [6868] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extension_expression, 2, 0, 0),
  [6870] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extension_expression, 2, 0, 0),
  [6872] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delete_expression, 2, 0, 0),
  [6874] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete_expression, 2, 0, 0),
  [6876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [6878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [6880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1784),
  [6882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6226),
  [6884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5914),
  [6886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [6888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [6890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1936),
  [6892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1937),
  [6894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1782),
  [6896] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__declarator, 1, 0, 0), REDUCE(sym_type_specifier, 1, 0, 1),
  [6899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2373),
  [6901] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_char_literal, 3, 0, 0),
  [6903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_char_literal, 3, 0, 0),
  [6905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23),
  [6907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5336),
  [6909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5336),
  [6911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3934),
  [6913] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(8308),
  [6916] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(8308),
  [6919] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(7571),
  [6922] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 1, 0, 23),
  [6924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3934),
  [6926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8380),
  [6928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6637),
  [6930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6637),
  [6932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3666),
  [6934] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(5720),
  [6937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5422),
  [6939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7918),
  [6941] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(5365),
  [6944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5365),
  [6946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1248),
  [6948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1251),
  [6950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1252),
  [6952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [6954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1254),
  [6956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1256),
  [6958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1257),
  [6960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1259),
  [6962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1260),
  [6964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [6966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1262),
  [6968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [6970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [6972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1252),
  [6974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1253),
  [6976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1254),
  [6978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [6980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8308),
  [6982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8308),
  [6984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3690),
  [6986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [6988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1433),
  [6990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3469),
  [6992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7982),
  [6994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3399),
  [6996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [6998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3552),
  [7000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1094),
  [7002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1096),
  [7004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1097),
  [7006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1102),
  [7008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1119),
  [7010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [7012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1123),
  [7014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1126),
  [7016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1136),
  [7018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1145),
  [7020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [7022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [7024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1131),
  [7026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [7028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1060),
  [7030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1080),
  [7032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1075),
  [7034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1143),
  [7036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [7038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(965),
  [7040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [7042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [7044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [7046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [7048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [7050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [7052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [7054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [7056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [7058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [7060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [7062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1017),
  [7064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1263),
  [7066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1099),
  [7068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1147),
  [7070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [7072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1072),
  [7074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1069),
  [7076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1063),
  [7078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3379),
  [7080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6038),
  [7082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5997),
  [7084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8216),
  [7086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2842),
  [7088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5224),
  [7090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5224),
  [7092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5732),
  [7094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8188),
  [7096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6573),
  [7098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2899),
  [7100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5214),
  [7102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5214),
  [7104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5750),
  [7106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2862),
  [7108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5192),
  [7110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5192),
  [7112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5764),
  [7114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1660),
  [7116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7605),
  [7118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(828),
  [7120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2867),
  [7122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5200),
  [7124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5200),
  [7126] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(6637),
  [7129] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(6637),
  [7132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3682),
  [7134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2909),
  [7136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5184),
  [7138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5184),
  [7140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1619),
  [7142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8107),
  [7144] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(7637),
  [7147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8179),
  [7149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3672),
  [7151] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(5373),
  [7154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3430),
  [7156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2895),
  [7158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5183),
  [7160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5183),
  [7162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5373),
  [7164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2341),
  [7166] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(8107),
  [7169] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(8107),
  [7172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3684),
  [7174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3657),
  [7176] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(5977),
  [7179] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(5340),
  [7182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3646),
  [7184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3646),
  [7186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3487),
  [7188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8051),
  [7190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5904),
  [7192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1352),
  [7194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1353),
  [7196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1361),
  [7198] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(7605),
  [7201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2967),
  [7203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2968),
  [7205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [7207] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 0), SHIFT(948),
  [7210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1659),
  [7212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7619),
  [7214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(821),
  [7216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [7218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1355),
  [7220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1356),
  [7222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1357),
  [7224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1358),
  [7226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [7228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1360),
  [7230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1360),
  [7232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [7234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1354),
  [7236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1355),
  [7238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1356),
  [7240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1358),
  [7242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1894),
  [7244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3171),
  [7246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3171),
  [7248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3085),
  [7250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7783),
  [7252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3728),
  [7254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3015),
  [7256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6485),
  [7258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3016),
  [7260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [7262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6529),
  [7264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3747),
  [7266] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(5398),
  [7269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3025),
  [7271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3143),
  [7273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3673),
  [7275] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(5390),
  [7278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1584),
  [7280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3677),
  [7282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5977),
  [7284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5340),
  [7286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2368),
  [7288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2368),
  [7290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2351),
  [7292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8108),
  [7294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6519),
  [7296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1604),
  [7298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3319),
  [7300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3319),
  [7302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3237),
  [7304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8214),
  [7306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6499),
  [7308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3738),
  [7310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1612),
  [7312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5709),
  [7314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1583),
  [7316] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__binary_fold_operator, 3, 0, 130),
  [7318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__binary_fold_operator, 3, 0, 130),
  [7320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1586),
  [7322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1588),
  [7324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1590),
  [7326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5390),
  [7328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3736),
  [7330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5398),
  [7332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6038),
  [7334] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, 0, 74), SHIFT(301),
  [7337] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(3070),
  [7340] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(6884),
  [7343] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7757),
  [7346] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__constructor_specifiers, 1, 0, 0), REDUCE(aux_sym__declaration_specifiers_repeat1, 1, 0, 0),
  [7349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__constructor_specifiers, 1, 0, 0),
  [7351] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__constructor_specifiers, 1, 0, 0),
  [7353] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__constructor_specifiers, 1, 0, 0), REDUCE(aux_sym__declaration_specifiers_repeat1, 1, 0, 0),
  [7356] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 1, 0, 0),
  [7358] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_field_identifier, 2, 1, 120), SHIFT(341),
  [7361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3485),
  [7363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3304),
  [7365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1171),
  [7367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1172),
  [7369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [7371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [7373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1175),
  [7375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1176),
  [7377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1177),
  [7379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [7381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1179),
  [7383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [7385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1180),
  [7387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1173),
  [7389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1174),
  [7391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1175),
  [7393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [7395] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, 0, 74), SHIFT(331),
  [7398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3660),
  [7400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5370),
  [7402] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(5370),
  [7405] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_field_expression, 3, 1, 70), SHIFT(341),
  [7408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3287),
  [7410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_declaration, 2, 0, 108),
  [7412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5175),
  [7414] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(7619),
  [7417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [7419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3165),
  [7421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3070),
  [7423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3678),
  [7425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1333),
  [7427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1334),
  [7429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [7431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [7433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1337),
  [7435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1338),
  [7437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1339),
  [7439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1340),
  [7441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1341),
  [7443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1342),
  [7445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [7447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [7449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1335),
  [7451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1336),
  [7453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [7455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1339),
  [7457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3565),
  [7459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6099),
  [7461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6099),
  [7463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3334),
  [7465] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, 0, 74), SHIFT(341),
  [7468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_capture_initializer, 4, 0, 136),
  [7470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3689),
  [7472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3828),
  [7474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7922),
  [7476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3395),
  [7478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1074),
  [7480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1079),
  [7482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1092),
  [7484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1095),
  [7486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1107),
  [7488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [7490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1128),
  [7492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1130),
  [7494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1135),
  [7496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1138),
  [7498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1155),
  [7500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [7502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1157),
  [7504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [7506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1152),
  [7508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1088),
  [7510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1056),
  [7512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1162),
  [7514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7924),
  [7516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1029),
  [7518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7925),
  [7520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7926),
  [7522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7962),
  [7524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7967),
  [7526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7975),
  [7528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7977),
  [7530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7985),
  [7532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7993),
  [7534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8000),
  [7536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8024),
  [7538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [7540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [7542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [7544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1148),
  [7546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [7548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [7550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1071),
  [7552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3830),
  [7554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3564),
  [7556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1030),
  [7558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5530),
  [7560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3178),
  [7562] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_field_identifier, 2, 1, 120), SHIFT(351),
  [7565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [7567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1017),
  [7569] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0),
  [7571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0),
  [7573] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(3720),
  [7576] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(3721),
  [7579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3545),
  [7581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5787),
  [7583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3676),
  [7585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3426),
  [7587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3802),
  [7589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4169),
  [7591] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(1619),
  [7594] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(3242),
  [7597] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(3106),
  [7600] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(8107),
  [7603] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(7549),
  [7606] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(7965),
  [7609] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(8179),
  [7612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(321),
  [7614] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_field_expression, 3, 1, 70), SHIFT(351),
  [7617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5926),
  [7619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6042),
  [7621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6042),
  [7623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1461),
  [7625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1462),
  [7627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1463),
  [7629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1464),
  [7631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1465),
  [7633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1466),
  [7635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1467),
  [7637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1468),
  [7639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1469),
  [7641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1469),
  [7643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1470),
  [7645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1474),
  [7647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1463),
  [7649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1464),
  [7651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1465),
  [7653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1467),
  [7655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1052),
  [7657] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0),
  [7659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0),
  [7661] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(3049),
  [7664] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(3299),
  [7667] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(3054),
  [7670] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(8109),
  [7673] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(7637),
  [7676] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(8111),
  [7679] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(8309),
  [7682] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_operator_cast_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(4162),
  [7685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2394),
  [7687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1606),
  [7689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3460),
  [7691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3321),
  [7693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3322),
  [7695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3484),
  [7697] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_identifier, 3, 0, 74), SHIFT(351),
  [7700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3440),
  [7702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1509),
  [7704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3347),
  [7706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5300),
  [7708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5300),
  [7710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3720),
  [7712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3720),
  [7714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3721),
  [7716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(807),
  [7718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7571),
  [7720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3719),
  [7722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3575),
  [7724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5399),
  [7726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5399),
  [7728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(357),
  [7730] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 35), SHIFT(357),
  [7733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3687),
  [7735] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 1, 0, 23), SHIFT(5338),
  [7738] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(3440),
  [7741] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(6863),
  [7744] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7752),
  [7747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3330),
  [7749] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(3460),
  [7752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5375),
  [7754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5375),
  [7756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5338),
  [7758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3465),
  [7760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5311),
  [7762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5311),
  [7764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3472),
  [7766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5294),
  [7768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5294),
  [7770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3499),
  [7772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3314),
  [7774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3315),
  [7776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1279),
  [7778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1198),
  [7780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1199),
  [7782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [7784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1201),
  [7786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1202),
  [7788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1203),
  [7790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1204),
  [7792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1205),
  [7794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1206),
  [7796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [7798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1207),
  [7800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1202),
  [7802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1203),
  [7804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1204),
  [7806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5397),
  [7808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5397),
  [7810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4223),
  [7812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5534),
  [7814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6488),
  [7816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1893),
  [7818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6244),
  [7820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5989),
  [7822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__lambda_capture, 2, 0, 0),
  [7824] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym__lambda_capture, 2, 0, 0),
  [7827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5396),
  [7829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5396),
  [7831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4931),
  [7833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6513),
  [7835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4831),
  [7837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5187),
  [7839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6148),
  [7841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4989),
  [7843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4990),
  [7845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4991),
  [7847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5137),
  [7849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3861),
  [7851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4147),
  [7853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6508),
  [7855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4027),
  [7857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4329),
  [7859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6170),
  [7861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5033),
  [7863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5034),
  [7865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5035),
  [7867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4894),
  [7869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8424),
  [7871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5151),
  [7873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4489),
  [7875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6528),
  [7877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2304),
  [7879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4006),
  [7881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6504),
  [7883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3909),
  [7885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4164),
  [7887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6144),
  [7889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5024),
  [7891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5025),
  [7893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5026),
  [7895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4584),
  [7897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8401),
  [7899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5119),
  [7901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3949),
  [7903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6498),
  [7905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6152),
  [7907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5030),
  [7909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5031),
  [7911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5032),
  [7913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5148),
  [7915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4841),
  [7917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6486),
  [7919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6180),
  [7921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5039),
  [7923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5040),
  [7925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5041),
  [7927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5143),
  [7929] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 35), SHIFT(321),
  [7932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3712),
  [7934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5335),
  [7936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5335),
  [7938] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_pointer_modifier, 1, 0, 0),
  [7940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_pointer_modifier, 1, 0, 0),
  [7942] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_unaligned_ptr_modifier, 1, 0, 0),
  [7944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_unaligned_ptr_modifier, 1, 0, 0),
  [7946] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ms_call_modifier, 1, 0, 0),
  [7948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_call_modifier, 1, 0, 0),
  [7950] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(3934),
  [7953] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(8380),
  [7956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [7958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4062),
  [7960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8085),
  [7962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5356),
  [7964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5357),
  [7966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3879),
  [7968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5362),
  [7970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5362),
  [7972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4266),
  [7974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3998),
  [7976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4000),
  [7978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [7980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7761),
  [7982] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declarator, 1, 0, 0),
  [7984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5996),
  [7986] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(3998),
  [7989] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(4000),
  [7992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3877),
  [7994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5344),
  [7996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5344),
  [7998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3881),
  [8000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5468),
  [8002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5468),
  [8004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6002),
  [8006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6910),
  [8008] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 1, 0, 56),
  [8010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4004),
  [8012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4004),
  [8014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [8016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1385),
  [8018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [8020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1837),
  [8022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8297),
  [8024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4136),
  [8026] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(3934),
  [8029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4137),
  [8031] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(8380),
  [8034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4135),
  [8036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4132),
  [8038] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(3934),
  [8041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4012),
  [8043] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(8380),
  [8046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4131),
  [8048] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 2, 0, 20),
  [8050] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_descriptor, 2, 0, 20),
  [8052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2454),
  [8054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8163),
  [8056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3959),
  [8058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5660),
  [8060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5660),
  [8062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3935),
  [8064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5548),
  [8066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5548),
  [8068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3961),
  [8070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5576),
  [8072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5576),
  [8074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3962),
  [8076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5659),
  [8078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5659),
  [8080] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_type_identifier, 2, 0, 35), SHIFT(346),
  [8083] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 1, 0, 2),
  [8085] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_descriptor, 1, 0, 2),
  [8087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4610),
  [8089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8032),
  [8091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(346),
  [8093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_attributes_start, 1, 0, 0),
  [8095] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_attributes_start, 1, 0, 0),
  [8097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2252),
  [8099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5287),
  [8101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3992),
  [8103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5704),
  [8105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5704),
  [8107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3721),
  [8109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2238),
  [8111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2186),
  [8113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4002),
  [8115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5743),
  [8117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5743),
  [8119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4144),
  [8121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3106),
  [8123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7965),
  [8125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3993),
  [8127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5771),
  [8129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5771),
  [8131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5951),
  [8133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5285),
  [8135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3985),
  [8137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5770),
  [8139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5770),
  [8141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5949),
  [8143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5950),
  [8145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3969),
  [8147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5769),
  [8149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5769),
  [8151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4150),
  [8153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3224),
  [8155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5281),
  [8157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3984),
  [8159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5708),
  [8161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5708),
  [8163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3225),
  [8165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3227),
  [8167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3986),
  [8169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5779),
  [8171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5779),
  [8173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5962),
  [8175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3987),
  [8177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5734),
  [8179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5734),
  [8181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3394),
  [8183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5288),
  [8185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3997),
  [8187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5780),
  [8189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5780),
  [8191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3388),
  [8193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3392),
  [8195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4130),
  [8197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_reference_declarator, 1, 0, 0),
  [8199] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_reference_declarator, 1, 0, 0),
  [8201] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(4043),
  [8204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4015),
  [8206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5824),
  [8208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5824),
  [8210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5904),
  [8212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4337),
  [8214] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(4254),
  [8217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4179),
  [8219] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(8437),
  [8222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4336),
  [8224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4350),
  [8226] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(4254),
  [8229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4353),
  [8231] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(8437),
  [8234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4343),
  [8236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1314),
  [8238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1315),
  [8240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1315),
  [8242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1318),
  [8244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1319),
  [8246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1320),
  [8248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [8250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1322),
  [8252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [8254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1323),
  [8256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1324),
  [8258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1319),
  [8260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1321),
  [8262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6224),
  [8264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5330),
  [8266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4089),
  [8268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5875),
  [8270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5875),
  [8272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6670),
  [8274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4066),
  [8276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5847),
  [8278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5847),
  [8280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [8282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1426),
  [8284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4118),
  [8286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5887),
  [8288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5887),
  [8290] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(4266),
  [8293] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(7761),
  [8296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 3, 0, 20),
  [8298] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_descriptor, 3, 0, 20),
  [8300] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 2, 0, 2),
  [8302] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_descriptor, 2, 0, 2),
  [8304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4865),
  [8306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8075),
  [8308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [8310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1317),
  [8312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1316),
  [8314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1317),
  [8316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3772),
  [8318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1041),
  [8320] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(4254),
  [8323] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_definition_type_repeat1, 2, 0, 0), SHIFT_REPEAT(8437),
  [8326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4104),
  [8328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5878),
  [8330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5878),
  [8332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1651),
  [8334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5211),
  [8336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5211),
  [8338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5213),
  [8340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8339),
  [8342] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator, 3, 0, 141),
  [8344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator, 3, 0, 141),
  [8346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4043),
  [8348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5391),
  [8350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5355),
  [8352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5886),
  [8354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1267),
  [8356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1268),
  [8358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1268),
  [8360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1269),
  [8362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [8364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1271),
  [8366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [8368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1273),
  [8370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1274),
  [8372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1275),
  [8374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1275),
  [8376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1276),
  [8378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2011),
  [8380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [8382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1277),
  [8384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [8386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1273),
  [8388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4133),
  [8390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4134),
  [8392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4139),
  [8394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4125),
  [8396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4129),
  [8398] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(1651),
  [8401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4307),
  [8403] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(8339),
  [8406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4155),
  [8408] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(1651),
  [8411] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(8339),
  [8414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1764),
  [8416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [8418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4335),
  [8420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2085),
  [8422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_explicit_function_specifier, 4, 0, 0),
  [8424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_explicit_function_specifier, 4, 0, 0),
  [8426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_attributes_start, 2, 0, 0),
  [8428] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_attributes_start, 2, 0, 0),
  [8430] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(1619),
  [8433] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(4155),
  [8436] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(3106),
  [8439] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(8107),
  [8442] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(7666),
  [8445] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(7965),
  [8448] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_specifiers_repeat1, 2, 0, 0), SHIFT_REPEAT(8179),
  [8451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4158),
  [8453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5999),
  [8455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5999),
  [8457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5925),
  [8459] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_explicit_function_specifier, 1, 0, 0),
  [8461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1230),
  [8463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_explicit_function_specifier, 1, 0, 0),
  [8465] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(2209),
  [8468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4410),
  [8470] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(8423),
  [8473] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(2209),
  [8476] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(8423),
  [8479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [8481] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(4204),
  [8484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5354),
  [8486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5354),
  [8488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5339),
  [8490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5339),
  [8492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0),
  [8494] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0),
  [8496] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(8107),
  [8499] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(8107),
  [8502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6270),
  [8504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5981),
  [8506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1283),
  [8508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1284),
  [8510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1284),
  [8512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1331),
  [8514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [8516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1285),
  [8518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1286),
  [8520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1309),
  [8522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [8524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1326),
  [8526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [8528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1330),
  [8530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1330),
  [8532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [8534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3654),
  [8536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1049),
  [8538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1348),
  [8540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [8542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1326),
  [8544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bitfield_clause, 2, 0, 0),
  [8546] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bitfield_clause, 2, 0, 0),
  [8548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4221),
  [8550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6157),
  [8552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6157),
  [8554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [8556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 4, 0, 176),
  [8558] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_field_declaration_repeat1, 4, 0, 176),
  [8560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3718),
  [8562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3326),
  [8564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [8566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3371),
  [8568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4742),
  [8570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [8572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1288),
  [8574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1289),
  [8576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1289),
  [8578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1290),
  [8580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1291),
  [8582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1292),
  [8584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1293),
  [8586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1294),
  [8588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1295),
  [8590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1296),
  [8592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1297),
  [8594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1297),
  [8596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [8598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1208),
  [8600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1292),
  [8602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1294),
  [8604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4746),
  [8606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1529),
  [8608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [8610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4073),
  [8612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [8614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4741),
  [8616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1504),
  [8618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [8620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1167),
  [8622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4780),
  [8624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3593),
  [8626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [8628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3769),
  [8630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2564),
  [8632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3784),
  [8634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8429),
  [8636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8429),
  [8638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [8640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [8642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1479),
  [8644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1453),
  [8646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1453),
  [8648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1480),
  [8650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1481),
  [8652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1482),
  [8654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1483),
  [8656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1484),
  [8658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1485),
  [8660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1486),
  [8662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1486),
  [8664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1487),
  [8666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3412),
  [8668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [8670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1488),
  [8672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1482),
  [8674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1484),
  [8676] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializer_list_repeat1, 2, 0, 0), SHIFT(1058),
  [8679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comma_expression, 3, 0, 82),
  [8681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_initializer_list_repeat1, 2, 0, 0),
  [8683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4791),
  [8685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [8687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3525),
  [8689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1635),
  [8691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3518),
  [8693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3878),
  [8695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1558),
  [8697] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(8308),
  [8700] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(8308),
  [8703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_init_declarator, 3, 0, 113),
  [8705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition_declaration, 4, 0, 184),
  [8707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2782),
  [8709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2516),
  [8711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1547),
  [8713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3825),
  [8715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6327),
  [8717] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_initializer_pair, 3, 0, 139), SHIFT(1058),
  [8720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_pair, 3, 0, 139),
  [8722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1641),
  [8724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2215),
  [8726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2730),
  [8728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2680),
  [8730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4288),
  [8732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3521),
  [8734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4333),
  [8736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1527),
  [8738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [8740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4204),
  [8742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4338),
  [8744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4340),
  [8746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2453),
  [8748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3377),
  [8750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [8752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2370),
  [8754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4356),
  [8756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1762),
  [8758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3610),
  [8760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1644),
  [8762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [8764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4358),
  [8766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2480),
  [8768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2398),
  [8770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3630),
  [8772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 4, 1, 185),
  [8774] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 4, 1, 186),
  [8776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1085),
  [8778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1398),
  [8780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1399),
  [8782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1399),
  [8784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1400),
  [8786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1401),
  [8788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1402),
  [8790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1403),
  [8792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1404),
  [8794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1405),
  [8796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1406),
  [8798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1406),
  [8800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1407),
  [8802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1188),
  [8804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [8806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1408),
  [8808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1402),
  [8810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1404),
  [8812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [8814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [8816] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 4, 1, 188),
  [8818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1393),
  [8820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter_declaration, 4, 0, 195),
  [8822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [8824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_capture_initializer, 3, 0, 82),
  [8826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [8828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [8830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [8832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6203),
  [8834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5932),
  [8836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1649),
  [8838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [8840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2691),
  [8842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [8844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [8846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [8848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6094),
  [8850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7770),
  [8852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1214),
  [8854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [8856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [8858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1233),
  [8860] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_capture_initializer, 5, 0, 180),
  [8862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [8864] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_parameter_declaration, 3, 0, 160),
  [8866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1245),
  [8868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1303),
  [8870] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_generic_expression_repeat1, 4, 0, 0),
  [8872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6046),
  [8874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8317),
  [8876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1282),
  [8878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0),
  [8880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6068),
  [8882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8065),
  [8884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_pair, 3, 0, 140),
  [8886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [8888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6071),
  [8890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8220),
  [8892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6072),
  [8894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7851),
  [8896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6073),
  [8898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8238),
  [8900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6076),
  [8902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7778),
  [8904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1414),
  [8906] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, 1, 149),
  [8908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 3, 1, 150),
  [8910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [8912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 2, 1, 0),
  [8914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [8916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_statement_body, 5, 1, 201),
  [8918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1476),
  [8920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1490),
  [8922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_subscript_argument_list_repeat1, 2, 0, 0),
  [8924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3260),
  [8926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [8928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7161),
  [8930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2713),
  [8932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2837),
  [8934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [8936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [8938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2280),
  [8940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [8942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [8944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [8946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [8948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [8950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [8952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [8954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2365),
  [8956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1645),
  [8958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2153),
  [8960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1992),
  [8962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [8964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4381),
  [8966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2003),
  [8968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4152),
  [8970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [8972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [8974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [8976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [8978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1813),
  [8980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7177),
  [8982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2586),
  [8984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [8986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [8988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [8990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3496),
  [8992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2041),
  [8994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3507),
  [8996] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_range_loop_body, 4, 0, 187),
  [8998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [9000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7016),
  [9002] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_parameter_list, 2, 0, 0), REDUCE(sym_argument_list, 2, 0, 0),
  [9005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [9007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3946),
  [9009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3172),
  [9011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [9013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1720),
  [9015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [9017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1727),
  [9019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1731),
  [9021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7258),
  [9023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1613),
  [9025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3062),
  [9027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1925),
  [9029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1930),
  [9031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1935),
  [9033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1553),
  [9035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4796),
  [9037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2254),
  [9039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3970),
  [9041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7315),
  [9043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1654),
  [9045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4227),
  [9047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1620),
  [9049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4262),
  [9051] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23),
  [9053] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(8308),
  [9056] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(8308),
  [9059] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(7571),
  [9062] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 2, 0, 23),
  [9064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7064),
  [9066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [9068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1709),
  [9070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [9072] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unary_left_fold, 3, 0, 54),
  [9074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [9076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3158),
  [9078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [9080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [9082] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(5720),
  [9085] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(5365),
  [9088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [9090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [9092] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assignment_expression_lhs, 3, 0, 54),
  [9094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__binary_fold, 3, 0, 83),
  [9096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7382),
  [9098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3741),
  [9100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [9102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5429),
  [9104] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_range_loop_body, 5, 0, 202),
  [9106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [9108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [9110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [9112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3740),
  [9114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3749),
  [9116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3751),
  [9118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3753),
  [9120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3707),
  [9122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1625),
  [9124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5341),
  [9126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5358),
  [9128] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(6637),
  [9131] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(6637),
  [9134] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(7637),
  [9137] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(5373),
  [9140] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__lambda_capture, 1, 0, 0),
  [9142] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0), REDUCE(sym__lambda_capture, 1, 0, 0),
  [9145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6011),
  [9147] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(5977),
  [9150] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(5390),
  [9153] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(8107),
  [9156] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(8107),
  [9159] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(5340),
  [9162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5907),
  [9164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5929),
  [9166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3292),
  [9168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7076),
  [9170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_declaration, 1, 0, 0),
  [9172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5142),
  [9174] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(4952),
  [9177] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(4960),
  [9180] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 1, 0, 0), SHIFT(4951),
  [9183] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(5398),
  [9186] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(4967),
  [9189] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(4968),
  [9192] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), SHIFT(4966),
  [9195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3154),
  [9197] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(5370),
  [9200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23),
  [9202] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(8308),
  [9205] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(8308),
  [9208] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(7571),
  [9211] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 3, 0, 23),
  [9213] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(5720),
  [9216] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(5365),
  [9219] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(7637),
  [9222] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(6637),
  [9225] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(6637),
  [9228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5934),
  [9230] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_specifier, 1, 0, 0), SHIFT(941),
  [9233] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(5373),
  [9236] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(5211),
  [9239] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(5211),
  [9242] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pointer_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(5213),
  [9245] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_type, 1, 0, 2),
  [9247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_type, 1, 0, 2),
  [9249] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 4, -1, 75), SHIFT(1894),
  [9252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2164),
  [9254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6506),
  [9256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1554),
  [9258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2337),
  [9260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6115),
  [9262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5009),
  [9264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5010),
  [9266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5011),
  [9268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2256),
  [9270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8342),
  [9272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5117),
  [9274] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(5977),
  [9277] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(5390),
  [9280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3941),
  [9282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6500),
  [9284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2154),
  [9286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6124),
  [9288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5018),
  [9290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5019),
  [9292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5020),
  [9294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5120),
  [9296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4961),
  [9298] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(8107),
  [9301] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(8107),
  [9304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2567),
  [9306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6487),
  [9308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1573),
  [9310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2669),
  [9312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6159),
  [9314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5027),
  [9316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5028),
  [9318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5029),
  [9320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3164),
  [9322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8415),
  [9324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5126),
  [9326] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 2, 0, 23), SHIFT(5338),
  [9329] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(5398),
  [9332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2533),
  [9334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6507),
  [9336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1569),
  [9338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2660),
  [9340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6121),
  [9342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5002),
  [9344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5003),
  [9346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5004),
  [9348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2949),
  [9350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8313),
  [9352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5164),
  [9354] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(5340),
  [9357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3244),
  [9359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6490),
  [9361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1839),
  [9363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6134),
  [9365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4999),
  [9367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5000),
  [9369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5001),
  [9371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5177),
  [9373] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 20), SHIFT(4964),
  [9376] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, -1, 36), SHIFT(4965),
  [9379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2142),
  [9381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1556),
  [9383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2296),
  [9385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6129),
  [9387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5105),
  [9389] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_type, 2, 0, 20),
  [9391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_type, 2, 0, 20),
  [9393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3480),
  [9395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6510),
  [9397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1801),
  [9399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3742),
  [9401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6176),
  [9403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5036),
  [9405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5037),
  [9407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5038),
  [9409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4034),
  [9411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8431),
  [9413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5125),
  [9415] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 0), REDUCE(aux_sym_sized_type_specifier_repeat1, 2, 0, 0), SHIFT(1894),
  [9419] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, -1, 18), SHIFT(1894),
  [9422] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, 0, 20), SHIFT(1894),
  [9425] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, -1, 36), SHIFT(1894),
  [9428] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, 0, 45), SHIFT(4978),
  [9431] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, -1, 75), SHIFT(4925),
  [9434] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 3, 0, 0), SHIFT(1894),
  [9437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2670),
  [9439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6477),
  [9441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1610),
  [9443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2833),
  [9445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6100),
  [9447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5021),
  [9449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5022),
  [9451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5023),
  [9453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3423),
  [9455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8383),
  [9457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5160),
  [9459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5206),
  [9461] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 4, 0, 45), SHIFT(1894),
  [9464] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_sized_type_specifier, 2, 0, 2), SHIFT(1894),
  [9467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4712),
  [9469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2873),
  [9471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3188),
  [9473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3746),
  [9475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2504),
  [9477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4473),
  [9479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1857),
  [9481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6509),
  [9483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4394),
  [9485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3952),
  [9487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2716),
  [9489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3980),
  [9491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2569),
  [9493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4194),
  [9495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3432),
  [9497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3101),
  [9499] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(5370),
  [9502] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(7637),
  [9505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4975),
  [9507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6163),
  [9509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5128),
  [9511] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_specifier, 1, 0, 0), SHIFT(4984),
  [9514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23),
  [9516] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(8308),
  [9519] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(8308),
  [9522] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(7571),
  [9525] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 4, 0, 23),
  [9527] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(5720),
  [9530] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(5365),
  [9533] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 3, 0, 23), SHIFT(5338),
  [9536] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_type, 2, 0, 2),
  [9538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_type, 2, 0, 2),
  [9540] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_type, 3, 0, 20),
  [9542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_type, 3, 0, 20),
  [9544] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(7637),
  [9547] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(6637),
  [9550] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(6637),
  [9553] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(5373),
  [9556] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(8107),
  [9559] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(8107),
  [9562] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(5977),
  [9565] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(5340),
  [9568] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(5398),
  [9571] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(5390),
  [9574] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(5370),
  [9577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [9579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [9581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4126),
  [9583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6990),
  [9585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [9587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [9589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2424),
  [9591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6949),
  [9593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [9595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [9597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3645),
  [9599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6815),
  [9601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [9603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [9605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3463),
  [9607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6867),
  [9609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4206),
  [9611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [9613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [9615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4739),
  [9617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6891),
  [9619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [9621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [9623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3782),
  [9625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6976),
  [9627] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 4, 0, 23), SHIFT(5338),
  [9630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1663),
  [9632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2048),
  [9634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [9636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(811),
  [9638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(957),
  [9640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1193),
  [9642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7620),
  [9644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2062),
  [9646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [9648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [9650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7574),
  [9652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1745),
  [9654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [9656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [9658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7606),
  [9660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_attributes_end, 2, 0, 0),
  [9662] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_attributes_end, 2, 0, 0),
  [9664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_attributes_end, 1, 0, 0),
  [9666] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_attributes_end, 1, 0, 0),
  [9668] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ref_qualifier, 1, 0, 0),
  [9670] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ref_qualifier, 1, 0, 0),
  [9672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23),
  [9674] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 5, 0, 23),
  [9676] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(5720),
  [9679] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(5373),
  [9682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [9684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6396),
  [9686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7017),
  [9688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [9690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4191),
  [9692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [9694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5810),
  [9696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6830),
  [9698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [9700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4748),
  [9702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5767),
  [9704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6522),
  [9706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5937),
  [9708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3255),
  [9710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2099),
  [9712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [9714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6483),
  [9716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2191),
  [9718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6935),
  [9720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1607),
  [9722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6407),
  [9724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5532),
  [9726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5351),
  [9728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5350),
  [9730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6526),
  [9732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [9734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3823),
  [9736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3824),
  [9738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4171),
  [9740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2218),
  [9742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3344),
  [9744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7301),
  [9746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5349),
  [9748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1507),
  [9750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8553),
  [9752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5363),
  [9754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7232),
  [9756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(788),
  [9758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5485),
  [9760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23),
  [9762] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 6, 0, 23),
  [9764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6125),
  [9766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6501),
  [9768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5361),
  [9770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [9772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3397),
  [9774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6185),
  [9776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6143),
  [9778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4070),
  [9780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7193),
  [9782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5782),
  [9784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5800),
  [9786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_attributes_end, 3, 0, 0),
  [9788] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_attributes_end, 3, 0, 0),
  [9790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5531),
  [9792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5984),
  [9794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4154),
  [9796] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(5720),
  [9799] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(5373),
  [9802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [9804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2396),
  [9806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2397),
  [9808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__preproc_expression, 1, 0, 0),
  [9810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5405),
  [9812] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__preproc_expression, 1, 0, 0),
  [9814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [9816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3559),
  [9818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3548),
  [9820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6160),
  [9822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3398),
  [9824] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(5365),
  [9827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5395),
  [9829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5678),
  [9831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5581),
  [9833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7702),
  [9835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5629),
  [9837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5629),
  [9839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5523),
  [9841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7229),
  [9843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5161),
  [9845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [9847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [9849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [9851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(817),
  [9853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [9855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6644),
  [9857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7652),
  [9859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_postfix, 1, 0, 0),
  [9861] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_postfix, 1, 0, 0),
  [9863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_specifier, 5, 0, 0),
  [9865] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_specifier, 5, 0, 0),
  [9867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_noexcept, 1, 0, 0),
  [9869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1160),
  [9871] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_noexcept, 1, 0, 0),
  [9873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_noexcept, 4, 0, 0),
  [9875] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_noexcept, 4, 0, 0),
  [9877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2024),
  [9879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5632),
  [9881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5703),
  [9883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5611),
  [9885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5612),
  [9887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5612),
  [9889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5616),
  [9891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5620),
  [9893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5630),
  [9895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5634),
  [9897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5640),
  [9899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5644),
  [9901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5646),
  [9903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5646),
  [9905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5647),
  [9907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_specifier, 4, 0, 0),
  [9909] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_specifier, 4, 0, 0),
  [9911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6482),
  [9913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7401),
  [9915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8331),
  [9917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2059),
  [9919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1749),
  [9921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [9923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5761),
  [9925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5439),
  [9927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5388),
  [9929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5389),
  [9931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1939),
  [9933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [9935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1701),
  [9937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [9939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [9941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7553),
  [9943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5476),
  [9945] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [9947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [9949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [9951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7509),
  [9953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8152),
  [9955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5445),
  [9957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__function_postfix_repeat1, 2, 0, 0),
  [9959] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__function_postfix_repeat1, 2, 0, 0),
  [9961] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__function_postfix_repeat1, 2, 0, 0), SHIFT_REPEAT(5720),
  [9964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5680),
  [9966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2061),
  [9968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [9970] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(5365),
  [9973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_noexcept, 3, 0, 0),
  [9975] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_noexcept, 3, 0, 0),
  [9977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_specifier, 3, 0, 0),
  [9979] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_specifier, 3, 0, 0),
  [9981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [9983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7671),
  [9985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6623),
  [9987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8629),
  [9989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6250),
  [9991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5700),
  [9993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(999),
  [9995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7112),
  [9997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5501),
  [9999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5590),
  [10001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7627),
  [10003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5569),
  [10005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5569),
  [10007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5736),
  [10009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7387),
  [10011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5737),
  [10013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1671),
  [10015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8219),
  [10017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5551),
  [10019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7033),
  [10021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2970),
  [10023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5751),
  [10025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(992),
  [10027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2861),
  [10029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5556),
  [10031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7034),
  [10033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2986),
  [10035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_binary_expression, 3, 0, 54),
  [10037] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_binary_expression, 3, 0, 54),
  [10039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5718),
  [10041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5753),
  [10043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1005),
  [10045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5723),
  [10047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [10049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1521),
  [10051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7815),
  [10053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5578),
  [10055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7375),
  [10057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3009),
  [10059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [10061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(996),
  [10063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5706),
  [10065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5739),
  [10067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5762),
  [10069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5725),
  [10071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5724),
  [10073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3003),
  [10075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8064),
  [10077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5592),
  [10079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7336),
  [10081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3021),
  [10083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5719),
  [10085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1770),
  [10087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5594),
  [10089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7131),
  [10091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_defined, 2, 0, 0),
  [10093] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_defined, 2, 0, 0),
  [10095] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_call_expression, 2, 0, 7),
  [10097] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_call_expression, 2, 0, 7),
  [10099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1515),
  [10101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5601),
  [10103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7234),
  [10105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_unary_expression, 2, 0, 4),
  [10107] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_unary_expression, 2, 0, 4),
  [10109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5742),
  [10111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_defined, 4, 0, 0),
  [10113] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_defined, 4, 0, 0),
  [10115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3849),
  [10117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7380),
  [10119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [10121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [10123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5766),
  [10125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5711),
  [10127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5662),
  [10129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5686),
  [10131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [10133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1520),
  [10135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5614),
  [10137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7337),
  [10139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5691),
  [10141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_argument_list, 4, 0, 0),
  [10143] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_argument_list, 4, 0, 0),
  [10145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(994),
  [10147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [10149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5694),
  [10151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(991),
  [10153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5747),
  [10155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3988),
  [10157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7286),
  [10159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6576),
  [10161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [10163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5602),
  [10165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5557),
  [10167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5722),
  [10169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5671),
  [10171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5560),
  [10173] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(7571),
  [10176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [10178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5713),
  [10180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5563),
  [10182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [10184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [10186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5564),
  [10188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5565),
  [10190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5566),
  [10192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(978),
  [10194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2882),
  [10196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5649),
  [10198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7088),
  [10200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5715),
  [10202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5738),
  [10204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_parenthesized_expression, 3, 0, 0),
  [10206] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_parenthesized_expression, 3, 0, 0),
  [10208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5745),
  [10210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5749),
  [10212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1861),
  [10214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5658),
  [10216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7162),
  [10218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5721),
  [10220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2198),
  [10222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5664),
  [10224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7239),
  [10226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [10228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5728),
  [10230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_argument_list_repeat1, 2, 0, 0),
  [10232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1001),
  [10234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [10236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_argument_list, 2, 0, 0),
  [10238] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_argument_list, 2, 0, 0),
  [10240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_argument_list, 3, 0, 0),
  [10242] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_argument_list, 3, 0, 0),
  [10244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [10246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5733),
  [10248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [10250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [10252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1004),
  [10254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5699),
  [10256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [10258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1831),
  [10260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8017),
  [10262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5693),
  [10264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7264),
  [10266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2932),
  [10268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [10270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3115),
  [10272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5696),
  [10274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7374),
  [10276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5768),
  [10278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 2, 0, 0),
  [10280] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 2, 0, 0),
  [10282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6378),
  [10284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5637),
  [10286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5651),
  [10288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5567),
  [10290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5593),
  [10292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5661),
  [10294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5573),
  [10296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5588),
  [10298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5682),
  [10300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5549),
  [10302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5550),
  [10304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6758),
  [10306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7156),
  [10308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5653),
  [10310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5820),
  [10312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [10314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_virtual_specifier, 1, 0, 0),
  [10316] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_virtual_specifier, 1, 0, 0),
  [10318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [10320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5707),
  [10322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_function_declarator, 2, 0, 24),
  [10324] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_function_declarator, 2, 0, 24),
  [10326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__abstract_declarator, 1, 0, 0),
  [10328] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__abstract_declarator, 1, 0, 0),
  [10330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6017),
  [10332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [10334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1013),
  [10336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5741),
  [10338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7096),
  [10340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_function_declarator, 1, 0, 33),
  [10342] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_function_declarator, 1, 0, 33),
  [10344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [10346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [10348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6965),
  [10350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5740),
  [10352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7403),
  [10354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [10356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [10358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trailing_return_type, 2, 0, 0),
  [10360] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trailing_return_type, 2, 0, 0),
  [10362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [10364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [10366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6586),
  [10368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7368),
  [10370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [10372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_parenthesized_declarator, 4, 0, 0),
  [10374] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_parenthesized_declarator, 4, 0, 0),
  [10376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 4, 0, 174),
  [10378] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 4, 0, 174),
  [10380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 4, 0, 118),
  [10382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 4, 0, 118),
  [10384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 4, 0, 26),
  [10386] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 4, 0, 26),
  [10388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6426),
  [10390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6342),
  [10392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6040),
  [10394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_parenthesized_declarator, 3, 0, 0),
  [10396] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_parenthesized_declarator, 3, 0, 0),
  [10398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_declarator_seq, 7, 0, 23),
  [10400] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_declarator_seq, 7, 0, 23),
  [10402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 3, 0, 123),
  [10404] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 3, 0, 123),
  [10406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 3, 0, 0),
  [10408] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 3, 0, 0),
  [10410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 3, 0, 26),
  [10412] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 3, 0, 26),
  [10414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_array_declarator, 5, 0, 172),
  [10416] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_array_declarator, 5, 0, 172),
  [10418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(825),
  [10420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5386),
  [10422] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attributed_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(7666),
  [10425] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(5977),
  [10428] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(5340),
  [10431] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(5977),
  [10434] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(5340),
  [10437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5384),
  [10439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6120),
  [10441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6786),
  [10443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6201),
  [10445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [10447] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__function_postfix_repeat1, 2, 0, 0), SHIFT_REPEAT(5977),
  [10450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6113),
  [10452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6132),
  [10454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributed_declarator, 2, 0, 0),
  [10456] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributed_declarator, 2, 0, 0),
  [10458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1621),
  [10460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5353),
  [10462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6422),
  [10464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7160),
  [10466] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__class_declaration_repeat1, 2, 0, 0),
  [10468] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__class_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(8109),
  [10471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__class_declaration_repeat1, 2, 0, 0),
  [10473] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__class_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(8309),
  [10476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [10478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [10480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [10482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [10484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6317),
  [10486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_clobber_list, 1, 0, 0),
  [10488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [10490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5884),
  [10492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6851),
  [10494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7750),
  [10496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [10498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 2, 0, 5),
  [10500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [10502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [10504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [10506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7519),
  [10508] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(5884),
  [10511] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(6851),
  [10514] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(7750),
  [10517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5865),
  [10519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 2, 1, 5),
  [10521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(819),
  [10523] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_pointer_declarator, 2, 1, 5),
  [10525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_reference_declarator, 2, 0, 0),
  [10527] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_reference_declarator, 2, 0, 0),
  [10529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2422),
  [10531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2583),
  [10533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 3, 0, 81),
  [10535] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_descriptor, 3, 0, 81),
  [10537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 3, 0, 62),
  [10539] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_descriptor, 3, 0, 62),
  [10541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4818),
  [10543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4979),
  [10545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2491),
  [10547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2587),
  [10549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 3, 1, 41),
  [10551] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_pointer_declarator, 3, 1, 41),
  [10553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 4, 0, 131),
  [10555] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_descriptor, 4, 0, 131),
  [10557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_pointer_declarator, 4, 1, 85),
  [10559] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_pointer_declarator, 4, 1, 85),
  [10561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 4, 0, 118),
  [10563] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_declarator, 4, 0, 118),
  [10565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2588),
  [10567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2717),
  [10569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 4, 0, 26),
  [10571] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_declarator, 4, 0, 26),
  [10573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_declarator, 4, -10, 0),
  [10575] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_declarator, 4, -10, 0),
  [10577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2762),
  [10579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2984),
  [10581] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(5398),
  [10584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4308),
  [10586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2299),
  [10588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4148),
  [10590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4354),
  [10592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3996),
  [10594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4138),
  [10596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5343),
  [10598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_declarator, 3, -10, 0),
  [10600] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_declarator, 3, -10, 0),
  [10602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1965),
  [10604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2180),
  [10606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_descriptor, 2, 0, 39),
  [10608] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_descriptor, 2, 0, 39),
  [10610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 2, 0, 5),
  [10612] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_field_declaration_repeat1, 2, 0, 5),
  [10614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [10616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2131),
  [10618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2284),
  [10620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2329),
  [10622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2513),
  [10624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3792),
  [10626] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(5390),
  [10629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_structured_binding_declarator, 4, -1, 0),
  [10631] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_structured_binding_declarator, 4, -1, 0),
  [10633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5342),
  [10635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 3, 0, 26),
  [10637] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_declarator, 3, 0, 26),
  [10639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_declarator, 5, 0, 172),
  [10641] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_declarator, 5, 0, 172),
  [10643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3084),
  [10645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3320),
  [10647] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(5390),
  [10650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3250),
  [10652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1890),
  [10654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3142),
  [10656] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8513),
  [10659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6257),
  [10661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6799),
  [10663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declarator, 2, 1, 24),
  [10665] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declarator, 2, 1, 24),
  [10667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_structured_binding_declarator, 3, -1, 0),
  [10669] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_structured_binding_declarator, 3, -1, 0),
  [10671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4228),
  [10673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6569),
  [10675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list, 2, 0, 10),
  [10677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6762),
  [10679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5669),
  [10681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7782),
  [10683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 5, 1, 170),
  [10685] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_field_declarator, 5, 1, 170),
  [10687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list, 3, 0, 79),
  [10689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 2, 1, 5),
  [10691] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_field_declarator, 2, 1, 5),
  [10693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_field_declarator, 2, 1, 0),
  [10695] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_reference_field_declarator, 2, 1, 0),
  [10697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 2, 1, 5),
  [10699] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_declarator, 2, 1, 5),
  [10701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 5, 1, 170),
  [10703] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_declarator, 5, 1, 170),
  [10705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_declarator, 2, 1, 0),
  [10707] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_reference_declarator, 2, 1, 0),
  [10709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6703),
  [10711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 4, 1, 85),
  [10713] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_declarator, 4, 1, 85),
  [10715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2302),
  [10717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6252),
  [10719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6739),
  [10721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_declarator, 3, 1, 41),
  [10723] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_declarator, 3, 1, 41),
  [10725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6697),
  [10727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 4, 1, 85),
  [10729] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_field_declarator, 4, 1, 85),
  [10731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6233),
  [10733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6776),
  [10735] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(5370),
  [10738] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_field_declarator, 3, 1, 41),
  [10740] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_field_declarator, 3, 1, 41),
  [10742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3256),
  [10744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6230),
  [10746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6740),
  [10748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6281),
  [10750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6315),
  [10752] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(5370),
  [10755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6280),
  [10757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6307),
  [10759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6321),
  [10761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [10763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7027),
  [10765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6220),
  [10767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6895),
  [10769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6320),
  [10771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5377),
  [10773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5378),
  [10775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6296),
  [10777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [10779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7233),
  [10781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6959),
  [10783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6294),
  [10785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6286),
  [10787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2064),
  [10789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [10791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7210),
  [10793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6951),
  [10795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [10797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7163),
  [10799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6938),
  [10801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6283),
  [10803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6292),
  [10805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [10807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6312),
  [10809] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(5398),
  [10812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6284),
  [10814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5376),
  [10816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5364),
  [10818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6287),
  [10820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [10822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7145),
  [10824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6874),
  [10826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2070),
  [10828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1774),
  [10830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [10832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7427),
  [10834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6964),
  [10836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6288),
  [10838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [10840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1914),
  [10842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [10844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7265),
  [10846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6970),
  [10848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6289),
  [10850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6279),
  [10852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6290),
  [10854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1761),
  [10856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [10858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6291),
  [10860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [10862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6293),
  [10864] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 2, 0, 66),
  [10866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1449),
  [10868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [10870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1928),
  [10872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7122),
  [10874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5697),
  [10876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7872),
  [10878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4854),
  [10880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2608),
  [10882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2226),
  [10884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attributed_field_declarator, 2, 0, 0),
  [10886] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attributed_field_declarator, 2, 0, 0),
  [10888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1798),
  [10890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [10892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6605),
  [10894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6222),
  [10896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6756),
  [10898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6794),
  [10900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declarator, 1, 0, 101),
  [10902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [10904] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__field_declarator, 1, 0, 101),
  [10906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3114),
  [10908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2903),
  [10910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3209),
  [10912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2293),
  [10914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4883),
  [10916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2658),
  [10918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3159),
  [10920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3943),
  [10922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2813),
  [10924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6653),
  [10926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2260),
  [10928] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 5, 0, 23), SHIFT(5338),
  [10931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3082),
  [10933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4651),
  [10935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3938),
  [10937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2891),
  [10939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2812),
  [10941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1845),
  [10943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_declarator, 1, 0, 0),
  [10945] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__field_declarator, 1, 0, 0),
  [10947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2418),
  [10949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4622),
  [10951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2390),
  [10953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 4, 0, 26),
  [10955] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_field_declarator, 4, 0, 26),
  [10957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_field_declarator, 3, -10, 0),
  [10959] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_field_declarator, 3, -10, 0),
  [10961] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 5, 0, 172),
  [10963] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_field_declarator, 5, 0, 172),
  [10965] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 4, 0, 118),
  [10967] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_field_declarator, 4, 0, 118),
  [10969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_field_declarator, 4, -10, 0),
  [10971] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_field_declarator, 4, -10, 0),
  [10973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_field_declarator, 3, 0, 26),
  [10975] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_field_declarator, 3, 0, 26),
  [10977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_field_declarator, 2, 1, 24),
  [10979] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_field_declarator, 2, 1, 24),
  [10981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6594),
  [10983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6515),
  [10985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6437),
  [10987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6567),
  [10989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6518),
  [10991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list_no_comma, 3, 0, 79),
  [10993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6903),
  [10995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5609),
  [10997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7991),
  [10999] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list_no_comma, 3, 0, 10),
  [11001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6440),
  [11003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6592),
  [11005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6520),
  [11007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6435),
  [11009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list_no_comma, 4, 0, 79),
  [11011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6987),
  [11013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5586),
  [11015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8333),
  [11017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8459),
  [11019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list_no_comma, 2, 0, 10),
  [11021] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7122),
  [11024] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5689),
  [11027] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7853),
  [11030] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7501),
  [11033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0),
  [11035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6722),
  [11037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list, 3, 0, 10),
  [11039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6458),
  [11041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5716),
  [11043] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_declarators, 1, 0, 26),
  [11045] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_declarators, 1, 0, 26),
  [11047] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_declarator_seq, 6, 0, 23), SHIFT(5338),
  [11050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5347),
  [11052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5348),
  [11054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6550),
  [11056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6480),
  [11058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6715),
  [11060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7823),
  [11062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6575),
  [11064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6525),
  [11066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6542),
  [11068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6505),
  [11070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6676),
  [11072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5918),
  [11074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list, 4, 0, 79),
  [11076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6556),
  [11078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6523),
  [11080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6685),
  [11082] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__scope_resolution, 1, 0, 0),
  [11084] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__scope_resolution, 1, 0, 0),
  [11086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1182),
  [11088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4946),
  [11090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1234),
  [11092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4971),
  [11094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2571),
  [11096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6494),
  [11098] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand_list, 1, 0, 0),
  [11100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8318),
  [11102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_definition_declarators_repeat1, 2, 0, 5),
  [11104] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__type_definition_declarators_repeat1, 2, 0, 5),
  [11106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1266),
  [11108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1312),
  [11110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4959),
  [11112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1169),
  [11114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4987),
  [11116] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand_list, 1, 0, 0),
  [11118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8243),
  [11120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1237),
  [11122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4937),
  [11124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1242),
  [11126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1300),
  [11128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4934),
  [11130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1473),
  [11132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1478),
  [11134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4948),
  [11136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1197),
  [11138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4943),
  [11140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1220),
  [11142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4981),
  [11144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1215),
  [11146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1397),
  [11148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3177),
  [11150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2702),
  [11152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7698),
  [11154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6901),
  [11156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2055),
  [11158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7601),
  [11160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7125),
  [11162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6975),
  [11164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7997),
  [11166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7420),
  [11168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6788),
  [11170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8504),
  [11172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2596),
  [11174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7589),
  [11176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4375),
  [11178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7480),
  [11180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3696),
  [11182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6950),
  [11184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2839),
  [11186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7657),
  [11188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2597),
  [11190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7617),
  [11192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4003),
  [11194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7555),
  [11196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7036),
  [11198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3939),
  [11200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7487),
  [11202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5374),
  [11204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7223),
  [11206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8598),
  [11208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6926),
  [11210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1859),
  [11212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7531),
  [11214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2499),
  [11216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7488),
  [11218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4192),
  [11220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7437),
  [11222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3433),
  [11224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7476),
  [11226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3067),
  [11228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7512),
  [11230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4587),
  [11232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7731),
  [11234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7369),
  [11236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8344),
  [11238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6985),
  [11240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7178),
  [11242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8493),
  [11244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7023),
  [11246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7267),
  [11248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6832),
  [11250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5717),
  [11252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7545),
  [11254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6945),
  [11256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6852),
  [11258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6986),
  [11260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5371),
  [11262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4385),
  [11264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7074),
  [11266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6947),
  [11268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6890),
  [11270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5944),
  [11272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [11274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [11276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [11278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [11280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3665),
  [11282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [11284] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__scope_resolution, 2, 0, 15),
  [11286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__scope_resolution, 2, 0, 15),
  [11288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_cast, 3, 0, 58),
  [11290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1966),
  [11292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3686),
  [11294] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7122),
  [11297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_repeat1, 2, 0, 0),
  [11299] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_repeat1, 2, 0, 0),
  [11301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5917),
  [11303] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__scope_resolution, 2, 0, 31),
  [11305] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__scope_resolution, 2, 0, 31),
  [11307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [11309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3701),
  [11311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [11313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1038),
  [11315] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 2, 0, 0), SHIFT_REPEAT(6569),
  [11318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 2, 0, 0),
  [11320] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 2, 0, 0),
  [11322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6306),
  [11324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2115),
  [11326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3755),
  [11328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enumerator, 1, 0, 6),
  [11330] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enumerator, 1, 0, 6),
  [11332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1281),
  [11334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [11336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3681),
  [11338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7443),
  [11340] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__lambda_capture_identifier, 1, 0, 0), SHIFT(6009),
  [11343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1212),
  [11345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6297),
  [11347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [11349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [11351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [11353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [11355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3667),
  [11357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1690),
  [11359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3704),
  [11361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_capture_specifier, 6, 0, 0),
  [11363] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_capture_specifier, 6, 0, 0),
  [11365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7279),
  [11367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 1, 0, 0),
  [11369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6692),
  [11371] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_preproc_if_in_enumerator_list_no_comma_repeat1, 1, 0, 0),
  [11373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2182),
  [11375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_capture_specifier, 3, 0, 0),
  [11377] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_capture_specifier, 3, 0, 0),
  [11379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1210),
  [11381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7180),
  [11383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_capture_specifier, 4, 0, 0),
  [11385] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_capture_specifier, 4, 0, 0),
  [11387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 2, 0, 56),
  [11389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6032),
  [11391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6749),
  [11393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5938),
  [11395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1450),
  [11397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7392),
  [11399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3181),
  [11401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6056),
  [11403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3365),
  [11405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6021),
  [11407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6036),
  [11409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6091),
  [11411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6098),
  [11413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6016),
  [11415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [11417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1031),
  [11419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8498),
  [11421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3307),
  [11423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6024),
  [11425] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_declaration, 3, 0, 66),
  [11427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6026),
  [11429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6031),
  [11431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6034),
  [11433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6018),
  [11435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5966),
  [11437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_expression_repeat1, 2, 0, 0),
  [11439] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(6749),
  [11442] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializer_pair_repeat1, 2, 0, 0), SHIFT_REPEAT(1391),
  [11445] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_initializer_pair_repeat1, 2, 0, 0),
  [11447] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializer_pair_repeat1, 2, 0, 0), SHIFT_REPEAT(8498),
  [11450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1381),
  [11452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3406),
  [11454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6080),
  [11456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2221),
  [11458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_capture_specifier, 5, 0, 0),
  [11460] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_capture_specifier, 5, 0, 0),
  [11462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7070),
  [11464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6019),
  [11466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1971),
  [11468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1427),
  [11470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [11472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1431),
  [11474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2088),
  [11476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1703),
  [11478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1909),
  [11480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1443),
  [11482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 3, 0, 10),
  [11484] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 3, 0, 10),
  [11486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1775),
  [11488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1786),
  [11490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1678),
  [11492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2091),
  [11494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1988),
  [11496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1737),
  [11498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1685),
  [11500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list, 5, 0, 79),
  [11502] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_enumerator_list, 5, 0, 79),
  [11504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1687),
  [11506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2106),
  [11508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1441),
  [11510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [11512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [11514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [11516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1413),
  [11518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [11520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1434),
  [11522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1987),
  [11524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2078),
  [11526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 4, 0, 80),
  [11528] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 4, 0, 80),
  [11530] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_enumerator_list_repeat1, 2, 0, 0),
  [11532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2012),
  [11534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [11536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1421),
  [11538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1679),
  [11540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [11542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list, 4, 0, 79),
  [11544] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_enumerator_list, 4, 0, 79),
  [11546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2014),
  [11548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [11550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1418),
  [11552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [11554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1409),
  [11556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list, 6, 0, 177),
  [11558] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_enumerator_list, 6, 0, 177),
  [11560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2025),
  [11562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1793),
  [11564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list, 5, 0, 128),
  [11566] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_if_in_enumerator_list, 5, 0, 128),
  [11568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2086),
  [11570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2079),
  [11572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 4, 0, 10),
  [11574] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 4, 0, 10),
  [11576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2022),
  [11578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1941),
  [11580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1424),
  [11582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [11584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1346),
  [11586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2081),
  [11588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 5, 0, 129),
  [11590] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_ifdef_in_enumerator_list, 5, 0, 129),
  [11592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1696),
  [11594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1439),
  [11596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1986),
  [11598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2096),
  [11600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2100),
  [11602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2016),
  [11604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [11606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [11608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [11610] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 2, 0, 183), SHIFT_REPEAT(5886),
  [11613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 2, 0, 183),
  [11615] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_field_declaration_repeat1, 2, 0, 183),
  [11617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1996),
  [11619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5772),
  [11621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4044),
  [11623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_type_parameter_declaration, 3, 0, 159),
  [11625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [11627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1957),
  [11629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1958),
  [11631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7434),
  [11633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7455),
  [11635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1960),
  [11637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4035),
  [11639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7060),
  [11641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [11643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [11645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [11647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_qualifier, 1, 0, 0),
  [11649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7690),
  [11651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5978),
  [11653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [11655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7495),
  [11657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2005),
  [11659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7065),
  [11661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_enumerator_list, 1, 0, 0),
  [11663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [11665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [11667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1773),
  [11669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [11671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [11673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1954),
  [11675] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_definition_declarators_repeat1, 2, 0, 116), SHIFT_REPEAT(5716),
  [11678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_definition_declarators_repeat1, 2, 0, 116),
  [11680] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__type_definition_declarators_repeat1, 2, 0, 116),
  [11682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [11684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6744),
  [11686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1776),
  [11688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1975),
  [11690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1777),
  [11692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [11694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 1, 0, 6),
  [11696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8194),
  [11698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [11700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [11702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1779),
  [11704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7747),
  [11706] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_access_specifier, 1, 0, 0),
  [11708] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_access_specifier, 1, 0, 0),
  [11710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_type_parameter_declaration, 4, 0, 194),
  [11712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5756),
  [11714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4031),
  [11716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7452),
  [11718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_definition_declarators, 2, 0, 88),
  [11720] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_definition_declarators, 2, 0, 88),
  [11722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [11724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7679),
  [11726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [11728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [11730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [11732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4055),
  [11734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7725),
  [11736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6004),
  [11738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1995),
  [11740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1769),
  [11742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6814),
  [11744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6814),
  [11746] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_output_operand_list_repeat1, 2, 0, 203), SHIFT_REPEAT(6582),
  [11749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_output_operand_list_repeat1, 2, 0, 203),
  [11751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3313),
  [11753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7018),
  [11755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1772),
  [11757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7022),
  [11759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7022),
  [11761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1666),
  [11763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7720),
  [11765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2523),
  [11767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_operator_cast_identifier, 2, 0, 34),
  [11769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6555),
  [11771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand_list, 3, 0, 191),
  [11773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3902),
  [11775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6827),
  [11777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6827),
  [11779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6078),
  [11781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_clobber_list, 2, 0, 204),
  [11783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4279),
  [11785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3894),
  [11787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7287),
  [11789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5833),
  [11791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_class_clause, 3, 0, 0),
  [11793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6582),
  [11795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand_list, 3, 0, 191),
  [11797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [11799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [11801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1549),
  [11803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand_list, 2, 0, 155),
  [11805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5730),
  [11807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8337),
  [11809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2611),
  [11811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6843),
  [11813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6843),
  [11815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4140),
  [11817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2627),
  [11819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6335),
  [11821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3693),
  [11823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6142),
  [11825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6854),
  [11827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6854),
  [11829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__namespace_specifier, 1, 0, 19),
  [11831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6751),
  [11833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3150),
  [11835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6103),
  [11837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3501),
  [11839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2250),
  [11841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6888),
  [11843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6888),
  [11845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2503),
  [11847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6859),
  [11849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6859),
  [11851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2820),
  [11853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2505),
  [11855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1642),
  [11857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1950),
  [11859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7084),
  [11861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8255),
  [11863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3774),
  [11865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6864),
  [11867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6864),
  [11869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3786),
  [11871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2216),
  [11873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2552),
  [11875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6869),
  [11877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6869),
  [11879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2560),
  [11881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2731),
  [11883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2400),
  [11885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6872),
  [11887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6872),
  [11889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2402),
  [11891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2689),
  [11893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [11895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8393),
  [11897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3713),
  [11899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6879),
  [11901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6879),
  [11903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3661),
  [11905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4289),
  [11907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2338),
  [11909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6882),
  [11911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6882),
  [11913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2367),
  [11915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3522),
  [11917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3537),
  [11919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6886),
  [11921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6886),
  [11923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2874),
  [11925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3539),
  [11927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2271),
  [11929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6889),
  [11931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6889),
  [11933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2181),
  [11935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2281),
  [11937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6791),
  [11939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7586),
  [11941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7548),
  [11943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7430),
  [11945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7624),
  [11947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7570),
  [11949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1502),
  [11951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1984),
  [11953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_enumerator_list, 2, 0, 0),
  [11955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_enumerator_list_no_comma, 1, 0, 0),
  [11957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7532),
  [11959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7707),
  [11961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7360),
  [11963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_declarator, 1, 0, 0),
  [11965] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 3, 0, 92),
  [11967] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_input_operand_list_repeat1, 2, 0, 203), SHIFT_REPEAT(6555),
  [11970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_input_operand_list_repeat1, 2, 0, 203),
  [11972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_else_in_enumerator_list_no_comma, 2, 0, 0),
  [11974] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_clobber_list, 3, 0, 211),
  [11976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4210),
  [11978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2389),
  [11980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6943),
  [11982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6943),
  [11984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1530),
  [11986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3453),
  [11988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6930),
  [11990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6930),
  [11992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [11994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7947),
  [11996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [11998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8368),
  [12000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3462),
  [12002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [12004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5577),
  [12006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3312),
  [12008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3345),
  [12010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6924),
  [12012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6924),
  [12014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3692),
  [12016] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 3, 0, 5),
  [12018] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_field_declaration_repeat1, 3, 0, 5),
  [12020] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_repeat1, 3, 0, 198),
  [12022] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_field_declaration_repeat1, 3, 0, 198),
  [12024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [12026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7602),
  [12028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7661),
  [12030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3254),
  [12032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2452),
  [12034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2535),
  [12036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [12038] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_clobber_list_repeat1, 2, 0, 215), SHIFT_REPEAT(6078),
  [12041] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_clobber_list_repeat1, 2, 0, 215),
  [12043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6785),
  [12045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6757),
  [12047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7362),
  [12049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_class_clause, 5, 0, 0),
  [12051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7390),
  [12053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_class_clause, 2, 0, 0),
  [12055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2736),
  [12057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6973),
  [12059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6973),
  [12061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1682),
  [12063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8117),
  [12065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7567),
  [12067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7440),
  [12069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4635),
  [12071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2746),
  [12073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8210),
  [12075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6839),
  [12077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6839),
  [12079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7189),
  [12081] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_class_clause, 4, 0, 0),
  [12083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3668),
  [12085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1765),
  [12087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3698),
  [12089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1632),
  [12091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1711),
  [12093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [12095] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand_list, 2, 0, 155),
  [12097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3683),
  [12099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2334),
  [12101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7013),
  [12103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7013),
  [12105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3688),
  [12107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2108),
  [12109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8501),
  [12111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3694),
  [12113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [12115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8547),
  [12117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3700),
  [12119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3703),
  [12121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3705),
  [12123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3708),
  [12125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3658),
  [12127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2355),
  [12129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2682),
  [12131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3671),
  [12133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7195),
  [12135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [12137] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_char_literal_repeat1, 2, 0, 0),
  [12139] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_char_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(7018),
  [12142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1561),
  [12144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0),
  [12146] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(7022),
  [12149] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(7022),
  [12152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1917),
  [12154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1532),
  [12156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7492),
  [12158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7496),
  [12160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__namespace_specifier, 2, 0, 59),
  [12162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8468),
  [12164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8482),
  [12166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8492),
  [12168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7665),
  [12170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3144),
  [12172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8239),
  [12174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7695),
  [12176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7604),
  [12178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3145),
  [12180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3117),
  [12182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3606),
  [12184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6439),
  [12186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [12188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1525),
  [12190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3607),
  [12192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6452),
  [12194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3810),
  [12196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5858),
  [12198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4770),
  [12200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2382),
  [12202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1503),
  [12204] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_throw_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(3724),
  [12207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_throw_specifier_repeat1, 2, 0, 0),
  [12209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1526),
  [12211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [12213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_class_clause, 7, 0, 0),
  [12215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [12217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [12219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [12221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1562),
  [12223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1664),
  [12225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3346),
  [12227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3328),
  [12229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7541),
  [12231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7582),
  [12233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [12235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3826),
  [12237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1537),
  [12239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1522),
  [12241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7623),
  [12243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand, 4, 0, 210),
  [12245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_namespace_specifier, 2, 0, 0),
  [12247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6761),
  [12249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2034),
  [12251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4081),
  [12253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6242),
  [12255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer_list, 2, 0, 0),
  [12257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [12259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2006),
  [12261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3355),
  [12263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7692),
  [12265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_type_parameter_declaration, 2, 0, 0),
  [12267] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_input_operand_list_repeat1, 2, 0, 155),
  [12269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4751),
  [12271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4753),
  [12273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1501),
  [12275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1505),
  [12277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1506),
  [12279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [12281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7250),
  [12283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7704),
  [12285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3380),
  [12287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3069),
  [12289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7615),
  [12291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [12293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7432),
  [12295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4774),
  [12297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4775),
  [12299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1563),
  [12301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1940),
  [12303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6336),
  [12305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5816),
  [12307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4778),
  [12309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4779),
  [12311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4786),
  [12313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4788),
  [12315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6419),
  [12317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7794),
  [12319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_goto_list, 2, 0, 212),
  [12321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6420),
  [12323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6421),
  [12325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter_declaration, 2, 0, 66),
  [12327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6917),
  [12329] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attribute_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(7665),
  [12332] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attribute_declaration_repeat1, 2, 0, 0),
  [12334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [12336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4197),
  [12338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7522),
  [12340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5883),
  [12342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6602),
  [12344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3407),
  [12346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3384),
  [12348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3324),
  [12350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1531),
  [12352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7721),
  [12354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1637),
  [12356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6629),
  [12358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3385),
  [12360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1392),
  [12362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2349),
  [12364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6009),
  [12366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [12368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5509),
  [12370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1767),
  [12372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2467),
  [12374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2726),
  [12376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2330),
  [12378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2524),
  [12380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3184),
  [12382] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(982),
  [12385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5819),
  [12387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_namespace_specifier, 3, 0, 0),
  [12389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2469),
  [12391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6596),
  [12393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3513),
  [12395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3551),
  [12397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3560),
  [12399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3642),
  [12401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7736),
  [12403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 2, 0, 101),
  [12405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1943),
  [12407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8138),
  [12409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8286),
  [12411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7817),
  [12413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [12415] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_structured_binding_declarator_repeat1, 2, 0, 0), SHIFT_REPEAT(7979),
  [12418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_structured_binding_declarator_repeat1, 2, 0, 0),
  [12420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1944),
  [12422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [12424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7518),
  [12426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [12428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6942),
  [12430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [12432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [12434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1945),
  [12436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6905),
  [12438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2323),
  [12440] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_generic_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(3718),
  [12443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_generic_expression_repeat1, 2, 0, 0),
  [12445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6661),
  [12447] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_designator, 3, 0, 0),
  [12449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3632),
  [12451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8636),
  [12453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8254),
  [12455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8258),
  [12457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5823),
  [12459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1652),
  [12461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1653),
  [12463] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_initializer_list_repeat1, 2, 0, 0), SHIFT_REPEAT(937),
  [12466] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_lambda_capture_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(5883),
  [12469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_lambda_capture_specifier_repeat1, 2, 0, 0),
  [12471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1658),
  [12473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1655),
  [12475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [12477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3757),
  [12479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand, 4, 0, 210),
  [12481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [12483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2565),
  [12485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2515),
  [12487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_clobber_list_repeat1, 2, 0, 204),
  [12489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2496),
  [12491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [12493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [12495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [12497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7563),
  [12499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7526),
  [12501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7689),
  [12503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_base_class_clause_repeat1, 3, 0, 0),
  [12505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2498),
  [12507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_goto_list, 3, 0, 216),
  [12509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6753),
  [12511] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_params_repeat1, 2, 0, 0), SHIFT_REPEAT(7695),
  [12514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_preproc_params_repeat1, 2, 0, 0),
  [12516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2700),
  [12518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3523),
  [12520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [12522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7560),
  [12524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6885),
  [12526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1948),
  [12528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3762),
  [12530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2217),
  [12532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3764),
  [12534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2602),
  [12536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2566),
  [12538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2537),
  [12540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7819),
  [12542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7830),
  [12544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7906),
  [12546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2266),
  [12548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2219),
  [12550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [12552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2220),
  [12554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [12556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5763),
  [12558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2482),
  [12560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_designator, 2, 0, 96),
  [12562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3780),
  [12564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3783),
  [12566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [12568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3763),
  [12570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3771),
  [12572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [12574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3788),
  [12576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3789),
  [12578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6929),
  [12580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1674),
  [12582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8481),
  [12584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2485),
  [12586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3102),
  [12588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7785),
  [12590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7786),
  [12592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7787),
  [12594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3120),
  [12596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3633),
  [12598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2732),
  [12600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2344),
  [12602] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_gnu_asm_goto_list_repeat1, 2, 0, 218), SHIFT_REPEAT(7794),
  [12605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_goto_list_repeat1, 2, 0, 218),
  [12607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3724),
  [12609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5420),
  [12611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6972),
  [12613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2733),
  [12615] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_preproc_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5632),
  [12618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2734),
  [12620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7502),
  [12622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_base_class_clause_repeat1, 5, 0, 0),
  [12624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7696),
  [12626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2735),
  [12628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [12630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3104),
  [12632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7599),
  [12634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer_list, 3, 0, 0),
  [12636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_output_operand, 7, 0, 219),
  [12638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3634),
  [12640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7012),
  [12642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [12644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2362),
  [12646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3323),
  [12648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8614),
  [12650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8626),
  [12652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8627),
  [12654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5617),
  [12656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2671),
  [12658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2690),
  [12660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2698),
  [12662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2699),
  [12664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7740),
  [12666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 2, 0, 0),
  [12668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7598),
  [12670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6813),
  [12672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2436),
  [12674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3635),
  [12676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6826),
  [12678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2063),
  [12680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6842),
  [12682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6853),
  [12684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6858),
  [12686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3636),
  [12688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [12690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6693),
  [12692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3638),
  [12694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3850),
  [12696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7566),
  [12698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_base_class_clause_repeat1, 2, 0, 0),
  [12700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2350),
  [12702] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_base_class_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(5833),
  [12705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2387),
  [12707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_init_declarator, 2, 0, 68),
  [12709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition_declaration, 3, 0, 145),
  [12711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3291),
  [12713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3761),
  [12715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1768),
  [12717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6772),
  [12719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7114),
  [12721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4290),
  [12723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1634),
  [12725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [12727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4291),
  [12729] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 2, 0, 116), SHIFT_REPEAT(5161),
  [12732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 2, 0, 116),
  [12734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2074),
  [12736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2075),
  [12738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2076),
  [12740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7613),
  [12742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4292),
  [12744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4297),
  [12746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_input_operand, 7, 0, 219),
  [12748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3554),
  [12750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [12752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [12754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [12756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4792),
  [12758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [12760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7201),
  [12762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7202),
  [12764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1626),
  [12766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1627),
  [12768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1630),
  [12770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3194),
  [12772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7902),
  [12774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3804),
  [12776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3814),
  [12778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2089),
  [12780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 2, 3, 0),
  [12782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3179),
  [12784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3207),
  [12786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7236),
  [12788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7238),
  [12790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2458),
  [12792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3524),
  [12794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3459),
  [12796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7242),
  [12798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7243),
  [12800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3461),
  [12802] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(375),
  [12805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 2, 0, 0),
  [12807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7252),
  [12809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3519),
  [12811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1534),
  [12813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1535),
  [12815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1536),
  [12817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_class_clause, 6, 0, 0),
  [12819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6621),
  [12821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3526),
  [12823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7685),
  [12825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_base_class_clause_repeat1, 4, 0, 0),
  [12827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3527),
  [12829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3528),
  [12831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_declarator, 2, 0, 0),
  [12833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4185),
  [12835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [12837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2459),
  [12839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_output_operand_list_repeat1, 2, 0, 155),
  [12841] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_reference_declarator, 2, 0, 0),
  [12843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6595),
  [12845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [12847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1548),
  [12849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3331),
  [12851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2345),
  [12853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3332),
  [12855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3476),
  [12857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3364),
  [12859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [12861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3217),
  [12863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3482),
  [12865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6706),
  [12867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_range_designator, 5, 0, 197),
  [12869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3354),
  [12871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3801),
  [12873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3488),
  [12875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7674),
  [12877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6838),
  [12879] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_parameter_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1637),
  [12882] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_parameter_list_repeat1, 2, 0, 0),
  [12884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [12886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [12888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5974),
  [12890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [12892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3808),
  [12894] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_requires_parameter_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1674),
  [12897] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_requires_parameter_list_repeat1, 2, 0, 0),
  [12899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1550),
  [12901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1551),
  [12903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1750),
  [12905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6588),
  [12907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [12909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7115),
  [12911] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1664),
  [12914] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2, 0, 0),
  [12916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3180),
  [12918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5442),
  [12920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2433),
  [12922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2434),
  [12924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1719),
  [12926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3864),
  [12928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3590),
  [12930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1736),
  [12932] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_field_initializer_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6242),
  [12935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_initializer_list_repeat1, 2, 0, 0),
  [12937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6607),
  [12939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1560),
  [12941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3836),
  [12943] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subscript_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1028),
  [12946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1740),
  [12948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [12950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1757),
  [12952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1758),
  [12954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1759),
  [12956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1545),
  [12958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8195),
  [12960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8196),
  [12962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8197),
  [12964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [12966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [12968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [12970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7537),
  [12972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_identifier_parameter_pack_expansion, 2, 0, 28),
  [12974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6698),
  [12976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2263),
  [12978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [12980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5850),
  [12982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [12984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8397),
  [12986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3960),
  [12988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [12990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8035),
  [12992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2098),
  [12994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8582),
  [12996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [12998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8027),
  [13000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7552),
  [13002] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 4, 0, 92),
  [13004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7681),
  [13006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [13008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7449),
  [13010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7515),
  [13012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [13014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [13016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8528),
  [13018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_base_class_clause_repeat1, 6, 0, 0),
  [13020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6781),
  [13022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7730),
  [13024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [13026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7800),
  [13028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [13030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7639),
  [13032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2919),
  [13034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7102),
  [13036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gnu_asm_goto_list, 1, 0, 0),
  [13038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7489),
  [13040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [13042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2619),
  [13044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7546),
  [13046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [13048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8475),
  [13050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_gnu_asm_goto_list_repeat1, 2, 0, 212),
  [13052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [13054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8323),
  [13056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7511),
  [13058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1788),
  [13060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7996),
  [13062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7482),
  [13064] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_params, 4, 0, 0),
  [13066] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_params, 4, 0, 0),
  [13068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7450),
  [13070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5731),
  [13072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8425),
  [13074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [13076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8227),
  [13078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8189),
  [13080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4681),
  [13082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1699),
  [13084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8211),
  [13086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1841),
  [13088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2411),
  [13090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7590),
  [13092] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 2, 0, 6),
  [13094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3079),
  [13096] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_argument_list_repeat1, 2, 2, 0),
  [13098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1974),
  [13100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8488),
  [13102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [13104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2095),
  [13106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8365),
  [13108] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_type_parameter_declaration, 3, 0, 158),
  [13110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_template_parameter_declaration, 3, 0, 57),
  [13112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7656),
  [13114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_params, 3, 0, 0),
  [13116] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_params, 3, 0, 0),
  [13118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7629),
  [13120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4898),
  [13122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5597),
  [13124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8374),
  [13126] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_params, 2, 0, 0),
  [13128] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_preproc_params, 2, 0, 0),
  [13130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8143),
  [13132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8601),
  [13134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2823),
  [13136] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_pack_expansion, 2, 0, 28),
  [13138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_repeat1, 3, 0, 168),
  [13140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1912),
  [13142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8014),
  [13144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7759),
  [13146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 3, 0, 101),
  [13148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8326),
  [13150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8604),
  [13152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 3, 0, 0),
  [13154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8351),
  [13156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8607),
  [13158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [13160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7955),
  [13162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8371),
  [13164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8610),
  [13166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8390),
  [13168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8613),
  [13170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [13172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8407),
  [13174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8615),
  [13176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8417),
  [13178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8616),
  [13180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8426),
  [13182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8617),
  [13184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8432),
  [13186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8618),
  [13188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8435),
  [13190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8619),
  [13192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8438),
  [13194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8620),
  [13196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8440),
  [13198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8621),
  [13200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8442),
  [13202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8622),
  [13204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8444),
  [13206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8623),
  [13208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8446),
  [13210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8624),
  [13212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8448),
  [13214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8625),
  [13216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [13218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [13220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3874),
  [13222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8594),
  [13224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3037),
  [13226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2010),
  [13228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1014),
  [13230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2609),
  [13232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [13234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2794),
  [13236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8419),
  [13238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8455),
  [13240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [13242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1673),
  [13244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4785),
  [13246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1929),
  [13248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2384),
  [13250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2385),
  [13252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8476),
  [13254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6014),
  [13256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3349),
  [13258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [13260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [13262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [13264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4195),
  [13266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7768),
  [13268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4201),
  [13270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4202),
  [13272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5844),
  [13274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7583),
  [13276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_field_declaration_list, 4, 0, 129),
  [13278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2087),
  [13280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1778),
  [13282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4789),
  [13284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list_no_comma, 5, 0, 129),
  [13286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [13288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2645),
  [13290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [13292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1791),
  [13294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8343),
  [13296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2021),
  [13298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list_no_comma, 6, 0, 177),
  [13300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6694),
  [13302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6862),
  [13304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [13306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8362),
  [13308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [13310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3327),
  [13312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2465),
  [13314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2072),
  [13316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [13318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6696),
  [13320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1989),
  [13322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8013),
  [13324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [13326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list_no_comma, 4, 0, 10),
  [13328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [13330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2101),
  [13332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2863),
  [13334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7912),
  [13336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list, 4, 0, 128),
  [13338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1771),
  [13340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2105),
  [13342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2090),
  [13344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2529),
  [13346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2696),
  [13348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [13350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [13352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3871),
  [13354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1780),
  [13356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8486),
  [13358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2626),
  [13360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3711),
  [13362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3714),
  [13364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_field_declaration_list, 3, 0, 80),
  [13366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7894),
  [13368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2481),
  [13370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [13372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7999),
  [13374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1512),
  [13376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [13378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6418),
  [13380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3829),
  [13382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [13384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [13386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8055),
  [13388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2353),
  [13390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [13392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2060),
  [13394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2110),
  [13396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [13398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8230),
  [13400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [13402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [13404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2905),
  [13406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [13408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6058),
  [13410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [13412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2111),
  [13414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list_no_comma, 4, 0, 128),
  [13416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8530),
  [13418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [13420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2530),
  [13422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3773),
  [13424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7766),
  [13426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7771),
  [13428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2486),
  [13430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1511),
  [13432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2080),
  [13434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list_no_comma, 3, 0, 80),
  [13436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list_no_comma, 4, 0, 129),
  [13438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2456),
  [13440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [13442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2354),
  [13444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4100),
  [13446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3787),
  [13448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2346),
  [13450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2343),
  [13452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3790),
  [13454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_parameter_list, 3, 0, 0),
  [13456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [13458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6923),
  [13460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [13462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1991),
  [13464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [13466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1702),
  [13468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8180),
  [13470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8084),
  [13472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3383),
  [13474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_ifdef_in_enumerator_list_no_comma, 4, 0, 80),
  [13476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [13478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2869),
  [13480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1980),
  [13482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3583),
  [13484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [13486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2077),
  [13488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2015),
  [13490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1708),
  [13492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1747),
  [13494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list, 3, 0, 80),
  [13496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7789),
  [13498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2023),
  [13500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1794),
  [13502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6720),
  [13504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2092),
  [13506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8518),
  [13508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7839),
  [13510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_parameter_list, 2, 0, 0),
  [13512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1842),
  [13514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3974),
  [13516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef, 4, 0, 129),
  [13518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2057),
  [13520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7860),
  [13522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [13524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3767),
  [13526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4080),
  [13528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [13530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [13532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [13534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [13536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [13538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7883),
  [13540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [13542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [13544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8068),
  [13546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2017),
  [13548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7895),
  [13550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7896),
  [13552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6967),
  [13554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1938),
  [13556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5796),
  [13558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7841),
  [13560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5605),
  [13562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2878),
  [13564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5798),
  [13566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [13568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5799),
  [13570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list, 5, 0, 177),
  [13572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [13574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2026),
  [13576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3529),
  [13578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3530),
  [13580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7500),
  [13582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8199),
  [13584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6704),
  [13586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8229),
  [13588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [13590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2082),
  [13592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6375),
  [13594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [13596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8247),
  [13598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1683),
  [13600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [13602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8541),
  [13604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4274),
  [13606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [13608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8269),
  [13610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3584),
  [13612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3585),
  [13614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3587),
  [13616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8320),
  [13618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8283),
  [13620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8285),
  [13622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [13624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7000),
  [13626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [13628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1926),
  [13630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [13632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3550),
  [13634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [13636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2884),
  [13638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3745),
  [13640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_enumerator_list_no_comma, 5, 0, 177),
  [13642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [13644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [13646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [13648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1022),
  [13650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2457),
  [13652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [13654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8112),
  [13656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2270),
  [13658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [13660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2321),
  [13662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2084),
  [13664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [13666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3779),
  [13668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8047),
  [13670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3848),
  [13672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1985),
  [13674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3819),
  [13676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3915),
  [13678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1012),
  [13680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5426),
  [13682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5430),
  [13684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1725),
  [13686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7963),
  [13688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8082),
  [13690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4750),
  [13692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5517),
  [13694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [13696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [13698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8281),
  [13700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1781),
  [13702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3450),
  [13704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [13706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7801),
  [13708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1834),
  [13710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [13712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7842),
  [13714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [13716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [13718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8293),
  [13720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3977),
  [13722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [13724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8490),
  [13726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2487),
  [13728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8548),
  [13730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3896),
  [13732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2489),
  [13734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1278),
  [13736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7764),
  [13738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7834),
  [13740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7882),
  [13742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7003),
  [13744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [13746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8170),
  [13748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8193),
  [13750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [13752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3637),
  [13754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8469),
  [13756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8472),
  [13758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7779),
  [13760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7780),
  [13762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7843),
  [13764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7844),
  [13766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7899),
  [13768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7900),
  [13770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7976),
  [13772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7978),
  [13774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8033),
  [13776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8036),
  [13778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2027),
  [13780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7469),
  [13782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7668),
  [13784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2490),
  [13786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8234),
  [13788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8545),
  [13790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [13792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif, 5, 0, 177),
  [13794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3663),
  [13796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1698),
  [13798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [13800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4857),
  [13802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3137),
  [13804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1034),
  [13806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [13808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3863),
  [13810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3577),
  [13812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3451),
  [13814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2004),
  [13816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2225),
  [13818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3131),
  [13820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7712),
  [13822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8467),
  [13824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [13826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [13828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [13830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [13832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1410),
  [13834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8508),
  [13836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1789),
  [13838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2386),
  [13840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3983),
  [13842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 5, 0, 177),
  [13844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7799),
  [13846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2361),
  [13848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6849),
  [13850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3639),
  [13852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [13854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6904),
  [13856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [13858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8008),
  [13860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8542),
  [13862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7846),
  [13864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1190),
  [13866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1999),
  [13868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [13870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3546),
  [13872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3853),
  [13874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2959),
  [13876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2029),
  [13878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7812),
  [13880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8458),
  [13882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3441),
  [13884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [13886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [13888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [13890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2900),
  [13892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [13894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7124),
  [13896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8296),
  [13898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2688),
  [13900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif_in_field_declaration_list, 4, 0, 128),
  [13902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1744),
  [13904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3858),
  [13906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6912),
  [13908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1716),
  [13910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1718),
  [13912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8178),
  [13914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [13916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2030),
  [13918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [13920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1084),
  [13922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3999),
  [13924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef_in_enumerator_list, 4, 0, 129),
  [13926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1723),
  [13928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8241),
  [13930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [13932] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__fold_operator, 1, 0, 0), SHIFT(8516),
  [13935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3235),
  [13937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2001),
  [13939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elif, 4, 0, 128),
  [13941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [13943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8400),
  [13945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3579),
  [13947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2783),
  [13949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7835),
  [13951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6922),
  [13953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [13955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4038),
  [13957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1726),
  [13959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6876),
  [13961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3759),
  [13963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [13965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7986),
  [13967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3995),
  [13969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [13971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1728),
  [13973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [13975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8030),
  [13977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [13979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1973),
  [13981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [13983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3363),
  [13985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1795),
  [13987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6709),
  [13989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [13991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8172),
  [13993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1700),
  [13995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3458),
  [13997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [13999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3514),
  [14001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [14003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ms_based_modifier, 2, 0, 0),
  [14005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4060),
  [14007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6712),
  [14009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4863),
  [14011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8586),
  [14013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3669),
  [14015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3253),
  [14017] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [14019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7808),
  [14021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8132),
  [14023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1734),
  [14025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [14027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1735),
  [14029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [14031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7247),
  [14033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8526),
  [14035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7255),
  [14037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8165),
  [14039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8274),
  [14041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3456),
  [14043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2028),
  [14045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7781),
  [14047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8588),
  [14049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1686),
  [14051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1858),
  [14053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2844),
  [14055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [14057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1225),
  [14059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [14061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [14063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7516),
  [14065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [14067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [14069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3680),
  [14071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [14073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1024),
  [14075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [14077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [14079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7809),
  [14081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7524),
  [14083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3418),
  [14085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8527),
  [14087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2471),
  [14089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [14091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1419),
  [14093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8546),
  [14095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4008),
  [14097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [14099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [14101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8253),
  [14103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3452),
  [14105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6364),
  [14107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7773),
  [14109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1422),
  [14111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [14113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7558),
  [14115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [14117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3685),
  [14119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [14121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [14123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7562),
  [14125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [14127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7859),
  [14129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3201),
  [14131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [14133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7866),
  [14135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7878),
  [14137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [14139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1763),
  [14141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3037),
  [14143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7886),
  [14145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [14147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [14149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7575),
  [14151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [14153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3691),
  [14155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2376),
  [14157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [14159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2109),
  [14161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7581),
  [14163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7937),
  [14165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [14167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5702),
  [14169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1432),
  [14171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7943),
  [14173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7952),
  [14175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7966),
  [14177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1037),
  [14179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7959),
  [14181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1435),
  [14183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1593),
  [14185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7594),
  [14187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [14189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3695),
  [14191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1594),
  [14193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [14195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [14197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1595),
  [14199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7988),
  [14201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [14203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1437),
  [14205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7994),
  [14207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8003),
  [14209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4001),
  [14211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [14213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_elifdef, 3, 0, 80),
  [14215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8010),
  [14217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1440),
  [14219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [14221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7608),
  [14223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [14225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7784),
  [14227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [14229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2019),
  [14231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1442),
  [14233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8041),
  [14235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1246),
  [14237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [14239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8054),
  [14241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7622),
  [14243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [14245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1117),
  [14247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8066),
  [14249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [14251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [14253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8069),
  [14255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1927),
  [14257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7626),
  [14259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [14261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1120),
  [14263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8369),
  [14265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8078),
  [14267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8080),
  [14269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7632),
  [14271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [14273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1122),
  [14275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8086),
  [14277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8087),
  [14279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [14281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8090),
  [14283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8091),
  [14285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [14287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8094),
  [14289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8095),
  [14291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8096),
  [14293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8097),
  [14295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8098),
  [14297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8099),
  [14299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8100),
  [14301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8101),
  [14303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8102),
  [14305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8103),
  [14307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8104),
  [14309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8105),
  [14311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3468),
  [14313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [14315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1448),
  [14317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8142),
  [14319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2244),
  [14321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1959),
  [14323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8124),
  [14325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list_no_comma, 5, 0, 79),
  [14327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [14329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [14331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3046),
  [14333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3837),
  [14335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [14337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [14339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8266),
  [14341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [14343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2582),
  [14345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6983),
  [14347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8176),
  [14349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2601),
  [14351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8353),
  [14353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8212),
  [14355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [14357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8450),
  [14359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [14361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8264),
  [14363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_requires_parameter_list, 4, 0, 0),
  [14365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [14367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2013),
  [14369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3199),
  [14371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [14373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3075),
  [14375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1994),
  [14377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6146),
  [14379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1211),
  [14381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [14383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [14385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1050),
  [14387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [14389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7220),
  [14391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2047),
  [14393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [14395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1911),
  [14397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2093),
  [14399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7026),
  [14401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8322),
  [14403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [14405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2655),
  [14407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [14409] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_if_in_enumerator_list_no_comma, 5, 0, 128),
  [14411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [14413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2493),
  [14415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [14417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4766),
  [14419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2118),
  [14421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unary_right_fold, 3, 0, 54),
  [14423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8522),
  [14425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [14427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [14429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4773),
  [14431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1681),
  [14433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2094),
  [14435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1961),
  [14437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [14439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1454),
  [14441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8325),
  [14443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1226),
  [14445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2245),
  [14447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [14449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6996),
  [14451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8334),
  [14453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4670),
  [14455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8592),
  [14457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [14459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6153),
  [14461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [14463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1455),
  [14465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8350),
  [14467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [14469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3167),
  [14471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6999),
  [14473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8356),
  [14475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1035),
  [14477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1456),
  [14479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8370),
  [14481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2648),
  [14483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7002),
  [14485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8376),
  [14487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3449),
  [14489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1457),
  [14491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8389),
  [14493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7672),
  [14495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2009),
  [14497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7005),
  [14499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8395),
  [14501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1684),
  [14503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1458),
  [14505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8406),
  [14507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7007),
  [14509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8411),
  [14511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7009),
  [14513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8420),
  [14515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1951),
  [14517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8428),
  [14519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8433),
  [14521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [14523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8436),
  [14525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7939),
  [14527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8439),
  [14529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3429),
  [14531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8441),
  [14533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2222),
  [14535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8443),
  [14537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4016),
  [14539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8445),
  [14541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [14543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8447),
  [14545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8449),
  [14547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3739),
  [14549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8471),
  [14551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8128),
  [14553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3748),
  [14555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8544),
  [14557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [14559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3750),
  [14561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8555),
  [14563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [14565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3752),
  [14567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8564),
  [14569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [14571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3754),
  [14573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8572),
  [14575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1922),
  [14577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8578),
  [14579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8581),
  [14581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8583),
  [14583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8585),
  [14585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8587),
  [14587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8589),
  [14589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8591),
  [14591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8593),
  [14593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8595),
  [14595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8597),
  [14597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8599),
  [14599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1924),
  [14601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7686),
  [14603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2097),
  [14605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1495),
  [14607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1496),
  [14609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1497),
  [14611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1498),
  [14613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [14615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token_raw_string_delimiter = 0,
  ts_external_token_raw_string_content = 1,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token_raw_string_delimiter] = sym_raw_string_delimiter,
  [ts_external_token_raw_string_content] = sym_raw_string_content,
};

static const bool ts_external_scanner_states[4][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token_raw_string_delimiter] = true,
    [ts_external_token_raw_string_content] = true,
  },
  [2] = {
    [ts_external_token_raw_string_delimiter] = true,
  },
  [3] = {
    [ts_external_token_raw_string_content] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_cpp_external_scanner_create(void);
void tree_sitter_cpp_external_scanner_destroy(void *);
bool tree_sitter_cpp_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_cpp_external_scanner_serialize(void *, char *);
void tree_sitter_cpp_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_cpp(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_cpp_external_scanner_create,
      tree_sitter_cpp_external_scanner_destroy,
      tree_sitter_cpp_external_scanner_scan,
      tree_sitter_cpp_external_scanner_serialize,
      tree_sitter_cpp_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
